var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b2) => {
  for (var prop in b2 || (b2 = {}))
    if (__hasOwnProp.call(b2, prop))
      __defNormalProp(a, prop, b2[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b2)) {
      if (__propIsEnum.call(b2, prop))
        __defNormalProp(a, prop, b2[prop]);
    }
  return a;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import * as React from "react";
import React__default, { useState, useMemo, useRef, useEffect, createContext, useContext } from "react";
var __read$3 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useToggle(defaultValue, reverseValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$3(useState(defaultValue), 2), state = _a2[0], setState = _a2[1];
  var actions2 = useMemo(function() {
    var reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    var toggle = function toggle2() {
      return setState(function(s) {
        return s === defaultValue ? reverseValueOrigin : defaultValue;
      });
    };
    var set2 = function set3(value) {
      return setState(value);
    };
    var setLeft = function setLeft2() {
      return setState(defaultValue);
    };
    var setRight = function setRight2() {
      return setState(reverseValueOrigin);
    };
    return {
      toggle,
      set: set2,
      setLeft,
      setRight
    };
  }, []);
  return [state, actions2];
}
var __read$2 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }
  var _a2 = __read$2(useToggle(defaultValue), 2), state = _a2[0], _b2 = _a2[1], toggle = _b2.toggle, _set = _b2.set;
  var actions2 = useMemo(function() {
    var setTrue = function setTrue2() {
      return _set(true);
    };
    var setFalse = function setFalse2() {
      return _set(false);
    };
    return {
      toggle,
      set: function set2(v4) {
        return _set(!!v4);
      },
      setTrue,
      setFalse
    };
  }, []);
  return [state, actions2];
}
function useLatest(value) {
  var ref = useRef(value);
  ref.current = value;
  return ref;
}
var isBrowser = !!(typeof window !== "undefined" && window.document && window.document.createElement);
var isBrowser$1 = isBrowser;
function getTargetElement(target, defaultElement) {
  if (!isBrowser$1) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  var targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if ("current" in target) {
    targetElement = target.current;
  } else {
    targetElement = target;
  }
  return targetElement;
}
var useUnmount = function useUnmount2(fn) {
  var fnRef = useLatest(fn);
  useEffect(function() {
    return function() {
      fnRef.current();
    };
  }, []);
};
var useUnmount$1 = useUnmount;
function depsAreSame(oldDeps, deps) {
  if (oldDeps === deps)
    return true;
  for (var i = 0; i < oldDeps.length; i++) {
    if (!Object.is(oldDeps[i], deps[i]))
      return false;
  }
  return true;
}
var createEffectWithTarget = function createEffectWithTarget2(useEffectType) {
  var useEffectWithTarget2 = function useEffectWithTarget3(effect, deps, target) {
    var hasInitRef = useRef(false);
    var lastElementRef = useRef([]);
    var lastDepsRef = useRef([]);
    var unLoadRef = useRef();
    useEffectType(function() {
      var _a2;
      var targets = Array.isArray(target) ? target : [target];
      var els = targets.map(function(item) {
        return getTargetElement(item);
      });
      if (!hasInitRef.current) {
        hasInitRef.current = true;
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
        return;
      }
      if (els.length !== lastElementRef.current.length || !depsAreSame(els, lastElementRef.current) || !depsAreSame(deps, lastDepsRef.current)) {
        (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
        lastElementRef.current = els;
        lastDepsRef.current = deps;
        unLoadRef.current = effect();
      }
    });
    useUnmount$1(function() {
      var _a2;
      (_a2 = unLoadRef.current) === null || _a2 === void 0 ? void 0 : _a2.call(unLoadRef);
      hasInitRef.current = false;
    });
  };
  return useEffectWithTarget2;
};
var createEffectWithTarget$1 = createEffectWithTarget;
var useEffectWithTarget = createEffectWithTarget$1(useEffect);
var useEffectWithTarget$1 = useEffectWithTarget;
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x2) {
  return x2 && x2.__esModule && Object.prototype.hasOwnProperty.call(x2, "default") ? x2["default"] : x2;
}
function isObject$7(value) {
  var type4 = typeof value;
  return value != null && (type4 == "object" || type4 == "function");
}
var isObject_1 = isObject$7;
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var _freeGlobal = freeGlobal$1;
var freeGlobal = _freeGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root$2 = freeGlobal || freeSelf || Function("return this")();
var _root = root$2;
var root$1 = _root;
var now$1 = function() {
  return root$1.Date.now();
};
var now_1 = now$1;
var reWhitespace = /\s/;
function trimmedEndIndex$1(string3) {
  var index2 = string3.length;
  while (index2-- && reWhitespace.test(string3.charAt(index2))) {
  }
  return index2;
}
var _trimmedEndIndex = trimmedEndIndex$1;
var trimmedEndIndex = _trimmedEndIndex;
var reTrimStart = /^\s+/;
function baseTrim$1(string3) {
  return string3 ? string3.slice(0, trimmedEndIndex(string3) + 1).replace(reTrimStart, "") : string3;
}
var _baseTrim = baseTrim$1;
var root = _root;
var Symbol$4 = root.Symbol;
var _Symbol = Symbol$4;
var Symbol$3 = _Symbol;
var objectProto$1 = Object.prototype;
var hasOwnProperty$1 = objectProto$1.hasOwnProperty;
var nativeObjectToString$1 = objectProto$1.toString;
var symToStringTag$1 = Symbol$3 ? Symbol$3.toStringTag : void 0;
function getRawTag$1(value) {
  var isOwn = hasOwnProperty$1.call(value, symToStringTag$1), tag = value[symToStringTag$1];
  try {
    value[symToStringTag$1] = void 0;
    var unmasked = true;
  } catch (e2) {
  }
  var result = nativeObjectToString$1.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag$1] = tag;
    } else {
      delete value[symToStringTag$1];
    }
  }
  return result;
}
var _getRawTag = getRawTag$1;
var objectProto = Object.prototype;
var nativeObjectToString = objectProto.toString;
function objectToString$1(value) {
  return nativeObjectToString.call(value);
}
var _objectToString = objectToString$1;
var Symbol$2 = _Symbol, getRawTag = _getRawTag, objectToString = _objectToString;
var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
function baseGetTag$1(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
}
var _baseGetTag = baseGetTag$1;
function isObjectLike$1(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_1 = isObjectLike$1;
var baseGetTag = _baseGetTag, isObjectLike = isObjectLike_1;
var symbolTag = "[object Symbol]";
function isSymbol$1(value) {
  return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
}
var isSymbol_1 = isSymbol$1;
var baseTrim = _baseTrim, isObject$6 = isObject_1, isSymbol = isSymbol_1;
var NAN = 0 / 0;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber$1(value) {
  if (typeof value == "number") {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject$6(value)) {
    var other = typeof value.valueOf == "function" ? value.valueOf() : value;
    value = isObject$6(other) ? other + "" : other;
  }
  if (typeof value != "string") {
    return value === 0 ? value : +value;
  }
  value = baseTrim(value);
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}
var toNumber_1 = toNumber$1;
var isObject$5 = isObject_1, now = now_1, toNumber = toNumber_1;
var FUNC_ERROR_TEXT = "Expected a function";
var nativeMax = Math.max, nativeMin = Math.min;
function debounce(func, wait, options) {
  var lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
  if (typeof func != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject$5(options)) {
    leading = !!options.leading;
    maxing = "maxWait" in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = "trailing" in options ? !!options.trailing : trailing;
  }
  function invokeFunc(time) {
    var args = lastArgs, thisArg = lastThis;
    lastArgs = lastThis = void 0;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }
  function leadingEdge(time) {
    lastInvokeTime = time;
    timerId = setTimeout(timerExpired, wait);
    return leading ? invokeFunc(time) : result;
  }
  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }
  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
    return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }
  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    timerId = setTimeout(timerExpired, remainingWait(time));
  }
  function trailingEdge(time) {
    timerId = void 0;
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = void 0;
    return result;
  }
  function cancel2() {
    if (timerId !== void 0) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = void 0;
  }
  function flush() {
    return timerId === void 0 ? result : trailingEdge(now());
  }
  function debounced() {
    var time = now(), isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;
    if (isInvoking) {
      if (timerId === void 0) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === void 0) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel2;
  debounced.flush = flush;
  return debounced;
}
var debounce_1 = debounce;
var __read$1 = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
var __spread = globalThis && globalThis.__spread || function() {
  for (var ar = [], i = 0; i < arguments.length; i++) {
    ar = ar.concat(__read$1(arguments[i]));
  }
  return ar;
};
function useDebounceFn(fn, options) {
  var _a2;
  var fnRef = useLatest(fn);
  var wait = (_a2 = options === null || options === void 0 ? void 0 : options.wait) !== null && _a2 !== void 0 ? _a2 : 1e3;
  var debounced = useMemo(function() {
    return debounce_1(function() {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      return fnRef.current.apply(fnRef, __spread(args));
    }, wait, options);
  }, []);
  useUnmount$1(function() {
    debounced.cancel();
  });
  return {
    run: debounced,
    cancel: debounced.cancel,
    flush: debounced.flush
  };
}
var createUpdateEffect = function createUpdateEffect2(hook) {
  return function(effect, deps) {
    var isMounted = useRef(false);
    hook(function() {
      return function() {
        isMounted.current = false;
      };
    }, []);
    hook(function() {
      if (!isMounted.current) {
        isMounted.current = true;
      } else {
        return effect();
      }
    }, deps);
  };
};
var useUpdateEffect = createUpdateEffect(useEffect);
var __read = globalThis && globalThis.__read || function(o, n2) {
  var m2 = typeof Symbol === "function" && o[Symbol.iterator];
  if (!m2)
    return o;
  var i = m2.call(o), r2, ar = [], e2;
  try {
    while ((n2 === void 0 || n2-- > 0) && !(r2 = i.next()).done) {
      ar.push(r2.value);
    }
  } catch (error) {
    e2 = {
      error
    };
  } finally {
    try {
      if (r2 && !r2.done && (m2 = i["return"]))
        m2.call(i);
    } finally {
      if (e2)
        throw e2.error;
    }
  }
  return ar;
};
function useDebounceEffect(effect, deps, options) {
  var _a2 = __read(useState({}), 2), flag = _a2[0], setFlag = _a2[1];
  var _b2 = useDebounceFn(function() {
    setFlag({});
  }, options), run = _b2.run, cancel2 = _b2.cancel;
  useEffect(function() {
    return run();
  }, deps);
  useUnmount$1(cancel2);
  useUpdateEffect(effect, [flag]);
}
function useEventListener(eventName, handler, options) {
  if (options === void 0) {
    options = {};
  }
  var handlerRef = useLatest(handler);
  useEffectWithTarget$1(function() {
    var targetElement = getTargetElement(options.target, window);
    if (!(targetElement === null || targetElement === void 0 ? void 0 : targetElement.addEventListener)) {
      return;
    }
    var eventListener = function eventListener2(event) {
      return handlerRef.current(event);
    };
    targetElement.addEventListener(eventName, eventListener, {
      capture: options.capture,
      once: options.once,
      passive: options.passive
    });
    return function() {
      targetElement.removeEventListener(eventName, eventListener, {
        capture: options.capture
      });
    };
  }, [eventName, options.capture, options.once, options.passive], options.target);
}
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
var extendStatics = function(d2, b2) {
  extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d3, b3) {
    d3.__proto__ = b3;
  } || function(d3, b3) {
    for (var p2 in b3)
      if (Object.prototype.hasOwnProperty.call(b3, p2))
        d3[p2] = b3[p2];
  };
  return extendStatics(d2, b2);
};
function __extends(d2, b2) {
  if (typeof b2 !== "function" && b2 !== null)
    throw new TypeError("Class extends value " + String(b2) + " is not a constructor or null");
  extendStatics(d2, b2);
  function __() {
    this.constructor = d2;
  }
  d2.prototype = b2 === null ? Object.create(b2) : (__.prototype = b2.prototype, new __());
}
var Browser = function() {
  function Browser2() {
    this.firefox = false;
    this.ie = false;
    this.edge = false;
    this.newEdge = false;
    this.weChat = false;
  }
  return Browser2;
}();
var Env = function() {
  function Env2() {
    this.browser = new Browser();
    this.node = false;
    this.wxa = false;
    this.worker = false;
    this.svgSupported = false;
    this.touchEventsSupported = false;
    this.pointerEventsSupported = false;
    this.domSupported = false;
    this.transformSupported = false;
    this.transform3dSupported = false;
    this.hasGlobalWindow = typeof window !== "undefined";
  }
  return Env2;
}();
var env = new Env();
if (typeof wx === "object" && typeof wx.getSystemInfoSync === "function") {
  env.wxa = true;
  env.touchEventsSupported = true;
} else if (typeof document === "undefined" && typeof self !== "undefined") {
  env.worker = true;
} else if (typeof navigator === "undefined") {
  env.node = true;
  env.svgSupported = true;
} else {
  detect(navigator.userAgent, env);
}
function detect(ua, env2) {
  var browser = env2.browser;
  var firefox = ua.match(/Firefox\/([\d.]+)/);
  var ie = ua.match(/MSIE\s([\d.]+)/) || ua.match(/Trident\/.+?rv:(([\d.]+))/);
  var edge = ua.match(/Edge?\/([\d.]+)/);
  var weChat = /micromessenger/i.test(ua);
  if (firefox) {
    browser.firefox = true;
    browser.version = firefox[1];
  }
  if (ie) {
    browser.ie = true;
    browser.version = ie[1];
  }
  if (edge) {
    browser.edge = true;
    browser.version = edge[1];
    browser.newEdge = +edge[1].split(".")[0] > 18;
  }
  if (weChat) {
    browser.weChat = true;
  }
  env2.svgSupported = typeof SVGRect !== "undefined";
  env2.touchEventsSupported = "ontouchstart" in window && !browser.ie && !browser.edge;
  env2.pointerEventsSupported = "onpointerdown" in window && (browser.edge || browser.ie && +browser.version >= 11);
  env2.domSupported = typeof document !== "undefined";
  var style = document.documentElement.style;
  env2.transform3dSupported = (browser.ie && "transition" in style || browser.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in style) && !("OTransition" in style);
  env2.transformSupported = env2.transform3dSupported || browser.ie && +browser.version >= 9;
}
var env$1 = env;
var DEFAULT_FONT_SIZE = 12;
var DEFAULT_FONT_FAMILY = "sans-serif";
var DEFAULT_FONT = DEFAULT_FONT_SIZE + "px " + DEFAULT_FONT_FAMILY;
var OFFSET = 20;
var SCALE = 100;
var defaultWidthMapStr = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
function getTextWidthMap(mapStr) {
  var map2 = {};
  if (typeof JSON === "undefined") {
    return map2;
  }
  for (var i = 0; i < mapStr.length; i++) {
    var char = String.fromCharCode(i + 32);
    var size = (mapStr.charCodeAt(i) - OFFSET) / SCALE;
    map2[char] = size;
  }
  return map2;
}
var DEFAULT_TEXT_WIDTH_MAP = getTextWidthMap(defaultWidthMapStr);
var platformApi = {
  createCanvas: function() {
    return typeof document !== "undefined" && document.createElement("canvas");
  },
  measureText: function() {
    var _ctx;
    var _cachedFont;
    return function(text, font) {
      if (!_ctx) {
        var canvas = platformApi.createCanvas();
        _ctx = canvas && canvas.getContext("2d");
      }
      if (_ctx) {
        if (_cachedFont !== font) {
          _cachedFont = _ctx.font = font || DEFAULT_FONT;
        }
        return _ctx.measureText(text);
      } else {
        text = text || "";
        font = font || DEFAULT_FONT;
        var res = /^([0-9]*?)px$/.exec(font);
        var fontSize = +(res && res[1]) || DEFAULT_FONT_SIZE;
        var width = 0;
        if (font.indexOf("mono") >= 0) {
          width = fontSize * text.length;
        } else {
          for (var i = 0; i < text.length; i++) {
            var preCalcWidth = DEFAULT_TEXT_WIDTH_MAP[text[i]];
            width += preCalcWidth == null ? fontSize : preCalcWidth * fontSize;
          }
        }
        return { width };
      }
    };
  }(),
  loadImage: function(src, onload, onerror) {
    var image = new Image();
    image.onload = onload;
    image.onerror = onerror;
    image.src = src;
    return image;
  }
};
var BUILTIN_OBJECT = reduce([
  "Function",
  "RegExp",
  "Date",
  "Error",
  "CanvasGradient",
  "CanvasPattern",
  "Image",
  "Canvas"
], function(obj, val) {
  obj["[object " + val + "]"] = true;
  return obj;
}, {});
var TYPED_ARRAY = reduce([
  "Int8",
  "Uint8",
  "Uint8Clamped",
  "Int16",
  "Uint16",
  "Int32",
  "Uint32",
  "Float32",
  "Float64"
], function(obj, val) {
  obj["[object " + val + "Array]"] = true;
  return obj;
}, {});
var objToString = Object.prototype.toString;
var arrayProto = Array.prototype;
var nativeForEach = arrayProto.forEach;
var nativeFilter = arrayProto.filter;
var nativeSlice = arrayProto.slice;
var nativeMap = arrayProto.map;
var ctorFunction = function() {
}.constructor;
var protoFunction = ctorFunction ? ctorFunction.prototype : null;
var protoKey = "__proto__";
var idStart = 2311;
function guid() {
  return idStart++;
}
function logError() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  if (typeof console !== "undefined") {
    console.error.apply(console, args);
  }
}
function clone$4(source) {
  if (source == null || typeof source !== "object") {
    return source;
  }
  var result = source;
  var typeStr = objToString.call(source);
  if (typeStr === "[object Array]") {
    if (!isPrimitive(source)) {
      result = [];
      for (var i = 0, len2 = source.length; i < len2; i++) {
        result[i] = clone$4(source[i]);
      }
    }
  } else if (TYPED_ARRAY[typeStr]) {
    if (!isPrimitive(source)) {
      var Ctor = source.constructor;
      if (Ctor.from) {
        result = Ctor.from(source);
      } else {
        result = new Ctor(source.length);
        for (var i = 0, len2 = source.length; i < len2; i++) {
          result[i] = source[i];
        }
      }
    }
  } else if (!BUILTIN_OBJECT[typeStr] && !isPrimitive(source) && !isDom(source)) {
    result = {};
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        result[key] = clone$4(source[key]);
      }
    }
  }
  return result;
}
function merge(target, source, overwrite) {
  if (!isObject$4(source) || !isObject$4(target)) {
    return overwrite ? clone$4(source) : target;
  }
  for (var key in source) {
    if (source.hasOwnProperty(key) && key !== protoKey) {
      var targetProp = target[key];
      var sourceProp = source[key];
      if (isObject$4(sourceProp) && isObject$4(targetProp) && !isArray$1(sourceProp) && !isArray$1(targetProp) && !isDom(sourceProp) && !isDom(targetProp) && !isBuiltInObject(sourceProp) && !isBuiltInObject(targetProp) && !isPrimitive(sourceProp) && !isPrimitive(targetProp)) {
        merge(targetProp, sourceProp, overwrite);
      } else if (overwrite || !(key in target)) {
        target[key] = clone$4(source[key]);
      }
    }
  }
  return target;
}
function mergeAll(targetAndSources, overwrite) {
  var result = targetAndSources[0];
  for (var i = 1, len2 = targetAndSources.length; i < len2; i++) {
    result = merge(result, targetAndSources[i], overwrite);
  }
  return result;
}
function extend(target, source) {
  if (Object.assign) {
    Object.assign(target, source);
  } else {
    for (var key in source) {
      if (source.hasOwnProperty(key) && key !== protoKey) {
        target[key] = source[key];
      }
    }
  }
  return target;
}
function defaults(target, source, overlay) {
  var keysArr = keys(source);
  for (var i = 0; i < keysArr.length; i++) {
    var key = keysArr[i];
    if (overlay ? source[key] != null : target[key] == null) {
      target[key] = source[key];
    }
  }
  return target;
}
platformApi.createCanvas;
function indexOf(array4, value) {
  if (array4) {
    if (array4.indexOf) {
      return array4.indexOf(value);
    }
    for (var i = 0, len2 = array4.length; i < len2; i++) {
      if (array4[i] === value) {
        return i;
      }
    }
  }
  return -1;
}
function inherits(clazz, baseClazz) {
  var clazzPrototype = clazz.prototype;
  function F() {
  }
  F.prototype = baseClazz.prototype;
  clazz.prototype = new F();
  for (var prop in clazzPrototype) {
    if (clazzPrototype.hasOwnProperty(prop)) {
      clazz.prototype[prop] = clazzPrototype[prop];
    }
  }
  clazz.prototype.constructor = clazz;
  clazz.superClass = baseClazz;
}
function mixin(target, source, override) {
  target = "prototype" in target ? target.prototype : target;
  source = "prototype" in source ? source.prototype : source;
  if (Object.getOwnPropertyNames) {
    var keyList = Object.getOwnPropertyNames(source);
    for (var i = 0; i < keyList.length; i++) {
      var key = keyList[i];
      if (key !== "constructor") {
        if (override ? source[key] != null : target[key] == null) {
          target[key] = source[key];
        }
      }
    }
  } else {
    defaults(target, source, override);
  }
}
function isArrayLike(data) {
  if (!data) {
    return false;
  }
  if (typeof data === "string") {
    return false;
  }
  return typeof data.length === "number";
}
function each$f(arr, cb, context) {
  if (!(arr && cb)) {
    return;
  }
  if (arr.forEach && arr.forEach === nativeForEach) {
    arr.forEach(cb, context);
  } else if (arr.length === +arr.length) {
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      cb.call(context, arr[i], i, arr);
    }
  } else {
    for (var key in arr) {
      if (arr.hasOwnProperty(key)) {
        cb.call(context, arr[key], key, arr);
      }
    }
  }
}
function map$1(arr, cb, context) {
  if (!arr) {
    return [];
  }
  if (!cb) {
    return slice(arr);
  }
  if (arr.map && arr.map === nativeMap) {
    return arr.map(cb, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      result.push(cb.call(context, arr[i], i, arr));
    }
    return result;
  }
}
function reduce(arr, cb, memo, context) {
  if (!(arr && cb)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    memo = cb.call(context, memo, arr[i], i, arr);
  }
  return memo;
}
function filter(arr, cb, context) {
  if (!arr) {
    return [];
  }
  if (!cb) {
    return slice(arr);
  }
  if (arr.filter && arr.filter === nativeFilter) {
    return arr.filter(cb, context);
  } else {
    var result = [];
    for (var i = 0, len2 = arr.length; i < len2; i++) {
      if (cb.call(context, arr[i], i, arr)) {
        result.push(arr[i]);
      }
    }
    return result;
  }
}
function find(arr, cb, context) {
  if (!(arr && cb)) {
    return;
  }
  for (var i = 0, len2 = arr.length; i < len2; i++) {
    if (cb.call(context, arr[i], i, arr)) {
      return arr[i];
    }
  }
}
function keys(obj) {
  if (!obj) {
    return [];
  }
  if (Object.keys) {
    return Object.keys(obj);
  }
  var keyList = [];
  for (var key in obj) {
    if (obj.hasOwnProperty(key)) {
      keyList.push(key);
    }
  }
  return keyList;
}
function bindPolyfill(func, context) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return function() {
    return func.apply(context, args.concat(nativeSlice.call(arguments)));
  };
}
var bind$1 = protoFunction && isFunction(protoFunction.bind) ? protoFunction.call.bind(protoFunction.bind) : bindPolyfill;
function curry$1(func) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return function() {
    return func.apply(this, args.concat(nativeSlice.call(arguments)));
  };
}
function isArray$1(value) {
  if (Array.isArray) {
    return Array.isArray(value);
  }
  return objToString.call(value) === "[object Array]";
}
function isFunction(value) {
  return typeof value === "function";
}
function isString(value) {
  return typeof value === "string";
}
function isStringSafe(value) {
  return objToString.call(value) === "[object String]";
}
function isNumber(value) {
  return typeof value === "number";
}
function isObject$4(value) {
  var type4 = typeof value;
  return type4 === "function" || !!value && type4 === "object";
}
function isBuiltInObject(value) {
  return !!BUILTIN_OBJECT[objToString.call(value)];
}
function isTypedArray(value) {
  return !!TYPED_ARRAY[objToString.call(value)];
}
function isDom(value) {
  return typeof value === "object" && typeof value.nodeType === "number" && typeof value.ownerDocument === "object";
}
function isGradientObject(value) {
  return value.colorStops != null;
}
function isImagePatternObject(value) {
  return value.image != null;
}
function isRegExp(value) {
  return objToString.call(value) === "[object RegExp]";
}
function eqNaN(value) {
  return value !== value;
}
function retrieve() {
  var args = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    args[_i] = arguments[_i];
  }
  for (var i = 0, len2 = args.length; i < len2; i++) {
    if (args[i] != null) {
      return args[i];
    }
  }
}
function retrieve2(value0, value1) {
  return value0 != null ? value0 : value1;
}
function retrieve3(value0, value1, value2) {
  return value0 != null ? value0 : value1 != null ? value1 : value2;
}
function slice(arr) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  return nativeSlice.apply(arr, args);
}
function normalizeCssArray$1(val) {
  if (typeof val === "number") {
    return [val, val, val, val];
  }
  var len2 = val.length;
  if (len2 === 2) {
    return [val[0], val[1], val[0], val[1]];
  } else if (len2 === 3) {
    return [val[0], val[1], val[2], val[1]];
  }
  return val;
}
function assert(condition, message) {
  if (!condition) {
    throw new Error(message);
  }
}
function trim$1(str) {
  if (str == null) {
    return null;
  } else if (typeof str.trim === "function") {
    return str.trim();
  } else {
    return str.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
}
var primitiveKey = "__ec_primitive__";
function setAsPrimitive(obj) {
  obj[primitiveKey] = true;
}
function isPrimitive(obj) {
  return obj[primitiveKey];
}
var HashMap = function() {
  function HashMap2(obj) {
    this.data = {};
    var isArr = isArray$1(obj);
    this.data = {};
    var thisMap = this;
    obj instanceof HashMap2 ? obj.each(visit) : obj && each$f(obj, visit);
    function visit(value, key) {
      isArr ? thisMap.set(value, key) : thisMap.set(key, value);
    }
  }
  HashMap2.prototype.get = function(key) {
    return this.data.hasOwnProperty(key) ? this.data[key] : null;
  };
  HashMap2.prototype.set = function(key, value) {
    return this.data[key] = value;
  };
  HashMap2.prototype.each = function(cb, context) {
    for (var key in this.data) {
      if (this.data.hasOwnProperty(key)) {
        cb.call(context, this.data[key], key);
      }
    }
  };
  HashMap2.prototype.keys = function() {
    return keys(this.data);
  };
  HashMap2.prototype.removeKey = function(key) {
    delete this.data[key];
  };
  return HashMap2;
}();
function createHashMap(obj) {
  return new HashMap(obj);
}
function concatArray(a, b2) {
  var newArray = new a.constructor(a.length + b2.length);
  for (var i = 0; i < a.length; i++) {
    newArray[i] = a[i];
  }
  var offset = a.length;
  for (var i = 0; i < b2.length; i++) {
    newArray[i + offset] = b2[i];
  }
  return newArray;
}
function createObject(proto2, properties) {
  var obj;
  if (Object.create) {
    obj = Object.create(proto2);
  } else {
    var StyleCtor = function() {
    };
    StyleCtor.prototype = proto2;
    obj = new StyleCtor();
  }
  if (properties) {
    extend(obj, properties);
  }
  return obj;
}
function disableUserSelect(dom) {
  var domStyle = dom.style;
  domStyle.webkitUserSelect = "none";
  domStyle.userSelect = "none";
  domStyle.webkitTapHighlightColor = "rgba(0,0,0,0)";
  domStyle["-webkit-touch-callout"] = "none";
}
function hasOwn(own, prop) {
  return own.hasOwnProperty(prop);
}
function noop() {
}
var RADIAN_TO_DEGREE = 180 / Math.PI;
function create$2(x2, y2) {
  if (x2 == null) {
    x2 = 0;
  }
  if (y2 == null) {
    y2 = 0;
  }
  return [x2, y2];
}
function copy$1(out2, v4) {
  out2[0] = v4[0];
  out2[1] = v4[1];
  return out2;
}
function clone$3(v4) {
  return [v4[0], v4[1]];
}
function set$2(out2, a, b2) {
  out2[0] = a;
  out2[1] = b2;
  return out2;
}
function add(out2, v12, v22) {
  out2[0] = v12[0] + v22[0];
  out2[1] = v12[1] + v22[1];
  return out2;
}
function scaleAndAdd$1(out2, v12, v22, a) {
  out2[0] = v12[0] + v22[0] * a;
  out2[1] = v12[1] + v22[1] * a;
  return out2;
}
function sub(out2, v12, v22) {
  out2[0] = v12[0] - v22[0];
  out2[1] = v12[1] - v22[1];
  return out2;
}
function len(v4) {
  return Math.sqrt(lenSquare(v4));
}
function lenSquare(v4) {
  return v4[0] * v4[0] + v4[1] * v4[1];
}
function scale$2(out2, v4, s) {
  out2[0] = v4[0] * s;
  out2[1] = v4[1] * s;
  return out2;
}
function normalize$4(out2, v4) {
  var d2 = len(v4);
  if (d2 === 0) {
    out2[0] = 0;
    out2[1] = 0;
  } else {
    out2[0] = v4[0] / d2;
    out2[1] = v4[1] / d2;
  }
  return out2;
}
function distance(v12, v22) {
  return Math.sqrt((v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]));
}
var dist$1 = distance;
function distanceSquare(v12, v22) {
  return (v12[0] - v22[0]) * (v12[0] - v22[0]) + (v12[1] - v22[1]) * (v12[1] - v22[1]);
}
var distSquare = distanceSquare;
function lerp$1(out2, v12, v22, t2) {
  out2[0] = v12[0] + t2 * (v22[0] - v12[0]);
  out2[1] = v12[1] + t2 * (v22[1] - v12[1]);
  return out2;
}
function applyTransform$1(out2, v4, m2) {
  var x2 = v4[0];
  var y2 = v4[1];
  out2[0] = m2[0] * x2 + m2[2] * y2 + m2[4];
  out2[1] = m2[1] * x2 + m2[3] * y2 + m2[5];
  return out2;
}
function min$1(out2, v12, v22) {
  out2[0] = Math.min(v12[0], v22[0]);
  out2[1] = Math.min(v12[1], v22[1]);
  return out2;
}
function max$1(out2, v12, v22) {
  out2[0] = Math.max(v12[0], v22[0]);
  out2[1] = Math.max(v12[1], v22[1]);
  return out2;
}
var Param = function() {
  function Param2(target, e2) {
    this.target = target;
    this.topTarget = e2 && e2.topTarget;
  }
  return Param2;
}();
var Draggable = function() {
  function Draggable2(handler) {
    this.handler = handler;
    handler.on("mousedown", this._dragStart, this);
    handler.on("mousemove", this._drag, this);
    handler.on("mouseup", this._dragEnd, this);
  }
  Draggable2.prototype._dragStart = function(e2) {
    var draggingTarget = e2.target;
    while (draggingTarget && !draggingTarget.draggable) {
      draggingTarget = draggingTarget.parent || draggingTarget.__hostTarget;
    }
    if (draggingTarget) {
      this._draggingTarget = draggingTarget;
      draggingTarget.dragging = true;
      this._x = e2.offsetX;
      this._y = e2.offsetY;
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragstart", e2.event);
    }
  };
  Draggable2.prototype._drag = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      var x2 = e2.offsetX;
      var y2 = e2.offsetY;
      var dx = x2 - this._x;
      var dy = y2 - this._y;
      this._x = x2;
      this._y = y2;
      draggingTarget.drift(dx, dy, e2);
      this.handler.dispatchToElement(new Param(draggingTarget, e2), "drag", e2.event);
      var dropTarget = this.handler.findHover(x2, y2, draggingTarget).target;
      var lastDropTarget = this._dropTarget;
      this._dropTarget = dropTarget;
      if (draggingTarget !== dropTarget) {
        if (lastDropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(lastDropTarget, e2), "dragleave", e2.event);
        }
        if (dropTarget && dropTarget !== lastDropTarget) {
          this.handler.dispatchToElement(new Param(dropTarget, e2), "dragenter", e2.event);
        }
      }
    }
  };
  Draggable2.prototype._dragEnd = function(e2) {
    var draggingTarget = this._draggingTarget;
    if (draggingTarget) {
      draggingTarget.dragging = false;
    }
    this.handler.dispatchToElement(new Param(draggingTarget, e2), "dragend", e2.event);
    if (this._dropTarget) {
      this.handler.dispatchToElement(new Param(this._dropTarget, e2), "drop", e2.event);
    }
    this._draggingTarget = null;
    this._dropTarget = null;
  };
  return Draggable2;
}();
var Draggable$1 = Draggable;
var Eventful = function() {
  function Eventful2(eventProcessors) {
    if (eventProcessors) {
      this._$eventProcessor = eventProcessors;
    }
  }
  Eventful2.prototype.on = function(event, query, handler, context) {
    if (!this._$handlers) {
      this._$handlers = {};
    }
    var _h = this._$handlers;
    if (typeof query === "function") {
      context = handler;
      handler = query;
      query = null;
    }
    if (!handler || !event) {
      return this;
    }
    var eventProcessor = this._$eventProcessor;
    if (query != null && eventProcessor && eventProcessor.normalizeQuery) {
      query = eventProcessor.normalizeQuery(query);
    }
    if (!_h[event]) {
      _h[event] = [];
    }
    for (var i = 0; i < _h[event].length; i++) {
      if (_h[event][i].h === handler) {
        return this;
      }
    }
    var wrap = {
      h: handler,
      query,
      ctx: context || this,
      callAtLast: handler.zrEventfulCallAtLast
    };
    var lastIndex = _h[event].length - 1;
    var lastWrap = _h[event][lastIndex];
    lastWrap && lastWrap.callAtLast ? _h[event].splice(lastIndex, 0, wrap) : _h[event].push(wrap);
    return this;
  };
  Eventful2.prototype.isSilent = function(eventName) {
    var _h = this._$handlers;
    return !_h || !_h[eventName] || !_h[eventName].length;
  };
  Eventful2.prototype.off = function(eventType, handler) {
    var _h = this._$handlers;
    if (!_h) {
      return this;
    }
    if (!eventType) {
      this._$handlers = {};
      return this;
    }
    if (handler) {
      if (_h[eventType]) {
        var newList = [];
        for (var i = 0, l2 = _h[eventType].length; i < l2; i++) {
          if (_h[eventType][i].h !== handler) {
            newList.push(_h[eventType][i]);
          }
        }
        _h[eventType] = newList;
      }
      if (_h[eventType] && _h[eventType].length === 0) {
        delete _h[eventType];
      }
    } else {
      delete _h[eventType];
    }
    return this;
  };
  Eventful2.prototype.trigger = function(eventType) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[eventType];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(eventType, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(hItem.ctx);
            break;
          case 1:
            hItem.h.call(hItem.ctx, args[0]);
            break;
          case 2:
            hItem.h.call(hItem.ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(hItem.ctx, args);
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(eventType);
    return this;
  };
  Eventful2.prototype.triggerWithContext = function(type4) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
      args[_i - 1] = arguments[_i];
    }
    if (!this._$handlers) {
      return this;
    }
    var _h = this._$handlers[type4];
    var eventProcessor = this._$eventProcessor;
    if (_h) {
      var argLen = args.length;
      var ctx = args[argLen - 1];
      var len2 = _h.length;
      for (var i = 0; i < len2; i++) {
        var hItem = _h[i];
        if (eventProcessor && eventProcessor.filter && hItem.query != null && !eventProcessor.filter(type4, hItem.query)) {
          continue;
        }
        switch (argLen) {
          case 0:
            hItem.h.call(ctx);
            break;
          case 1:
            hItem.h.call(ctx, args[0]);
            break;
          case 2:
            hItem.h.call(ctx, args[0], args[1]);
            break;
          default:
            hItem.h.apply(ctx, args.slice(1, argLen - 1));
            break;
        }
      }
    }
    eventProcessor && eventProcessor.afterTrigger && eventProcessor.afterTrigger(type4);
    return this;
  };
  return Eventful2;
}();
var Eventful$1 = Eventful;
var LN2 = Math.log(2);
function determinant(rows, rank, rowStart, rowMask, colMask, detCache) {
  var cacheKey = rowMask + "-" + colMask;
  var fullRank = rows.length;
  if (detCache.hasOwnProperty(cacheKey)) {
    return detCache[cacheKey];
  }
  if (rank === 1) {
    var colStart = Math.round(Math.log((1 << fullRank) - 1 & ~colMask) / LN2);
    return rows[rowStart][colStart];
  }
  var subRowMask = rowMask | 1 << rowStart;
  var subRowStart = rowStart + 1;
  while (rowMask & 1 << subRowStart) {
    subRowStart++;
  }
  var sum2 = 0;
  for (var j = 0, colLocalIdx = 0; j < fullRank; j++) {
    var colTag = 1 << j;
    if (!(colTag & colMask)) {
      sum2 += (colLocalIdx % 2 ? -1 : 1) * rows[rowStart][j] * determinant(rows, rank - 1, subRowStart, subRowMask, colMask | colTag, detCache);
      colLocalIdx++;
    }
  }
  detCache[cacheKey] = sum2;
  return sum2;
}
function buildTransformer(src, dest) {
  var mA = [
    [src[0], src[1], 1, 0, 0, 0, -dest[0] * src[0], -dest[0] * src[1]],
    [0, 0, 0, src[0], src[1], 1, -dest[1] * src[0], -dest[1] * src[1]],
    [src[2], src[3], 1, 0, 0, 0, -dest[2] * src[2], -dest[2] * src[3]],
    [0, 0, 0, src[2], src[3], 1, -dest[3] * src[2], -dest[3] * src[3]],
    [src[4], src[5], 1, 0, 0, 0, -dest[4] * src[4], -dest[4] * src[5]],
    [0, 0, 0, src[4], src[5], 1, -dest[5] * src[4], -dest[5] * src[5]],
    [src[6], src[7], 1, 0, 0, 0, -dest[6] * src[6], -dest[6] * src[7]],
    [0, 0, 0, src[6], src[7], 1, -dest[7] * src[6], -dest[7] * src[7]]
  ];
  var detCache = {};
  var det = determinant(mA, 8, 0, 0, 0, detCache);
  if (det === 0) {
    return;
  }
  var vh = [];
  for (var i = 0; i < 8; i++) {
    for (var j = 0; j < 8; j++) {
      vh[j] == null && (vh[j] = 0);
      vh[j] += ((i + j) % 2 ? -1 : 1) * determinant(mA, 7, i === 0 ? 1 : 0, 1 << i, 1 << j, detCache) / det * dest[i];
    }
  }
  return function(out2, srcPointX, srcPointY) {
    var pk = srcPointX * vh[6] + srcPointY * vh[7] + 1;
    out2[0] = (srcPointX * vh[0] + srcPointY * vh[1] + vh[2]) / pk;
    out2[1] = (srcPointX * vh[3] + srcPointY * vh[4] + vh[5]) / pk;
  };
}
var EVENT_SAVED_PROP = "___zrEVENTSAVED";
var _calcOut$1 = [];
function transformLocalCoord(out2, elFrom, elTarget, inX, inY) {
  return transformCoordWithViewport(_calcOut$1, elFrom, inX, inY, true) && transformCoordWithViewport(out2, elTarget, _calcOut$1[0], _calcOut$1[1]);
}
function transformCoordWithViewport(out2, el, inX, inY, inverse) {
  if (el.getBoundingClientRect && env$1.domSupported && !isCanvasEl(el)) {
    var saved = el[EVENT_SAVED_PROP] || (el[EVENT_SAVED_PROP] = {});
    var markers = prepareCoordMarkers(el, saved);
    var transformer = preparePointerTransformer(markers, saved, inverse);
    if (transformer) {
      transformer(out2, inX, inY);
      return true;
    }
  }
  return false;
}
function prepareCoordMarkers(el, saved) {
  var markers = saved.markers;
  if (markers) {
    return markers;
  }
  markers = saved.markers = [];
  var propLR = ["left", "right"];
  var propTB = ["top", "bottom"];
  for (var i = 0; i < 4; i++) {
    var marker = document.createElement("div");
    var stl = marker.style;
    var idxLR = i % 2;
    var idxTB = (i >> 1) % 2;
    stl.cssText = [
      "position: absolute",
      "visibility: hidden",
      "padding: 0",
      "margin: 0",
      "border-width: 0",
      "user-select: none",
      "width:0",
      "height:0",
      propLR[idxLR] + ":0",
      propTB[idxTB] + ":0",
      propLR[1 - idxLR] + ":auto",
      propTB[1 - idxTB] + ":auto",
      ""
    ].join("!important;");
    el.appendChild(marker);
    markers.push(marker);
  }
  return markers;
}
function preparePointerTransformer(markers, saved, inverse) {
  var transformerName = inverse ? "invTrans" : "trans";
  var transformer = saved[transformerName];
  var oldSrcCoords = saved.srcCoords;
  var srcCoords = [];
  var destCoords = [];
  var oldCoordTheSame = true;
  for (var i = 0; i < 4; i++) {
    var rect = markers[i].getBoundingClientRect();
    var ii = 2 * i;
    var x2 = rect.left;
    var y2 = rect.top;
    srcCoords.push(x2, y2);
    oldCoordTheSame = oldCoordTheSame && oldSrcCoords && x2 === oldSrcCoords[ii] && y2 === oldSrcCoords[ii + 1];
    destCoords.push(markers[i].offsetLeft, markers[i].offsetTop);
  }
  return oldCoordTheSame && transformer ? transformer : (saved.srcCoords = srcCoords, saved[transformerName] = inverse ? buildTransformer(destCoords, srcCoords) : buildTransformer(srcCoords, destCoords));
}
function isCanvasEl(el) {
  return el.nodeName.toUpperCase() === "CANVAS";
}
var MOUSE_EVENT_REG = /^(?:mouse|pointer|contextmenu|drag|drop)|click/;
var _calcOut = [];
var firefoxNotSupportOffsetXY = env$1.browser.firefox && +env$1.browser.version.split(".")[0] < 39;
function clientToLocal(el, e2, out2, calculate) {
  out2 = out2 || {};
  if (calculate) {
    calculateZrXY(el, e2, out2);
  } else if (firefoxNotSupportOffsetXY && e2.layerX != null && e2.layerX !== e2.offsetX) {
    out2.zrX = e2.layerX;
    out2.zrY = e2.layerY;
  } else if (e2.offsetX != null) {
    out2.zrX = e2.offsetX;
    out2.zrY = e2.offsetY;
  } else {
    calculateZrXY(el, e2, out2);
  }
  return out2;
}
function calculateZrXY(el, e2, out2) {
  if (env$1.domSupported && el.getBoundingClientRect) {
    var ex = e2.clientX;
    var ey = e2.clientY;
    if (isCanvasEl(el)) {
      var box2 = el.getBoundingClientRect();
      out2.zrX = ex - box2.left;
      out2.zrY = ey - box2.top;
      return;
    } else {
      if (transformCoordWithViewport(_calcOut, el, ex, ey)) {
        out2.zrX = _calcOut[0];
        out2.zrY = _calcOut[1];
        return;
      }
    }
  }
  out2.zrX = out2.zrY = 0;
}
function getNativeEvent(e2) {
  return e2 || window.event;
}
function normalizeEvent(el, e2, calculate) {
  e2 = getNativeEvent(e2);
  if (e2.zrX != null) {
    return e2;
  }
  var eventType = e2.type;
  var isTouch = eventType && eventType.indexOf("touch") >= 0;
  if (!isTouch) {
    clientToLocal(el, e2, e2, calculate);
    var wheelDelta = getWheelDeltaMayPolyfill(e2);
    e2.zrDelta = wheelDelta ? wheelDelta / 120 : -(e2.detail || 0) / 3;
  } else {
    var touch = eventType !== "touchend" ? e2.targetTouches[0] : e2.changedTouches[0];
    touch && clientToLocal(el, touch, e2, calculate);
  }
  var button = e2.button;
  if (e2.which == null && button !== void 0 && MOUSE_EVENT_REG.test(e2.type)) {
    e2.which = button & 1 ? 1 : button & 2 ? 3 : button & 4 ? 2 : 0;
  }
  return e2;
}
function getWheelDeltaMayPolyfill(e2) {
  var rawWheelDelta = e2.wheelDelta;
  if (rawWheelDelta) {
    return rawWheelDelta;
  }
  var deltaX = e2.deltaX;
  var deltaY = e2.deltaY;
  if (deltaX == null || deltaY == null) {
    return rawWheelDelta;
  }
  var delta = deltaY !== 0 ? Math.abs(deltaY) : Math.abs(deltaX);
  var sign = deltaY > 0 ? -1 : deltaY < 0 ? 1 : deltaX > 0 ? -1 : 1;
  return 3 * delta * sign;
}
function addEventListener(el, name, handler, opt) {
  el.addEventListener(name, handler, opt);
}
function removeEventListener(el, name, handler, opt) {
  el.removeEventListener(name, handler, opt);
}
var stop = function(e2) {
  e2.preventDefault();
  e2.stopPropagation();
  e2.cancelBubble = true;
};
function isMiddleOrRightButtonOnMouseUpDown(e2) {
  return e2.which === 2 || e2.which === 3;
}
var GestureMgr = function() {
  function GestureMgr2() {
    this._track = [];
  }
  GestureMgr2.prototype.recognize = function(event, target, root2) {
    this._doTrack(event, target, root2);
    return this._recognize(event);
  };
  GestureMgr2.prototype.clear = function() {
    this._track.length = 0;
    return this;
  };
  GestureMgr2.prototype._doTrack = function(event, target, root2) {
    var touches = event.touches;
    if (!touches) {
      return;
    }
    var trackItem = {
      points: [],
      touches: [],
      target,
      event
    };
    for (var i = 0, len2 = touches.length; i < len2; i++) {
      var touch = touches[i];
      var pos = clientToLocal(root2, touch, {});
      trackItem.points.push([pos.zrX, pos.zrY]);
      trackItem.touches.push(touch);
    }
    this._track.push(trackItem);
  };
  GestureMgr2.prototype._recognize = function(event) {
    for (var eventName in recognizers) {
      if (recognizers.hasOwnProperty(eventName)) {
        var gestureInfo = recognizers[eventName](this._track, event);
        if (gestureInfo) {
          return gestureInfo;
        }
      }
    }
  };
  return GestureMgr2;
}();
function dist(pointPair) {
  var dx = pointPair[1][0] - pointPair[0][0];
  var dy = pointPair[1][1] - pointPair[0][1];
  return Math.sqrt(dx * dx + dy * dy);
}
function center$1(pointPair) {
  return [
    (pointPair[0][0] + pointPair[1][0]) / 2,
    (pointPair[0][1] + pointPair[1][1]) / 2
  ];
}
var recognizers = {
  pinch: function(tracks, event) {
    var trackLen = tracks.length;
    if (!trackLen) {
      return;
    }
    var pinchEnd = (tracks[trackLen - 1] || {}).points;
    var pinchPre = (tracks[trackLen - 2] || {}).points || pinchEnd;
    if (pinchPre && pinchPre.length > 1 && pinchEnd && pinchEnd.length > 1) {
      var pinchScale = dist(pinchEnd) / dist(pinchPre);
      !isFinite(pinchScale) && (pinchScale = 1);
      event.pinchScale = pinchScale;
      var pinchCenter = center$1(pinchEnd);
      event.pinchX = pinchCenter[0];
      event.pinchY = pinchCenter[1];
      return {
        type: "pinch",
        target: tracks[0].target,
        event
      };
    }
  }
};
var SILENT = "silent";
function makeEventPacket(eveType, targetInfo, event) {
  return {
    type: eveType,
    event,
    target: targetInfo.target,
    topTarget: targetInfo.topTarget,
    cancelBubble: false,
    offsetX: event.zrX,
    offsetY: event.zrY,
    gestureEvent: event.gestureEvent,
    pinchX: event.pinchX,
    pinchY: event.pinchY,
    pinchScale: event.pinchScale,
    wheelDelta: event.zrDelta,
    zrByTouch: event.zrByTouch,
    which: event.which,
    stop: stopEvent
  };
}
function stopEvent() {
  stop(this.event);
}
var EmptyProxy = function(_super) {
  __extends(EmptyProxy2, _super);
  function EmptyProxy2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.handler = null;
    return _this;
  }
  EmptyProxy2.prototype.dispose = function() {
  };
  EmptyProxy2.prototype.setCursor = function() {
  };
  return EmptyProxy2;
}(Eventful$1);
var HoveredResult = function() {
  function HoveredResult2(x2, y2) {
    this.x = x2;
    this.y = y2;
  }
  return HoveredResult2;
}();
var handlerNames = [
  "click",
  "dblclick",
  "mousewheel",
  "mouseout",
  "mouseup",
  "mousedown",
  "mousemove",
  "contextmenu"
];
var Handler = function(_super) {
  __extends(Handler2, _super);
  function Handler2(storage2, painter, proxy, painterRoot) {
    var _this = _super.call(this) || this;
    _this._hovered = new HoveredResult(0, 0);
    _this.storage = storage2;
    _this.painter = painter;
    _this.painterRoot = painterRoot;
    proxy = proxy || new EmptyProxy();
    _this.proxy = null;
    _this.setHandlerProxy(proxy);
    _this._draggingMgr = new Draggable$1(_this);
    return _this;
  }
  Handler2.prototype.setHandlerProxy = function(proxy) {
    if (this.proxy) {
      this.proxy.dispose();
    }
    if (proxy) {
      each$f(handlerNames, function(name) {
        proxy.on && proxy.on(name, this[name], this);
      }, this);
      proxy.handler = this;
    }
    this.proxy = proxy;
  };
  Handler2.prototype.mousemove = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var lastHovered = this._hovered;
    var lastHoveredTarget = lastHovered.target;
    if (lastHoveredTarget && !lastHoveredTarget.__zr) {
      lastHovered = this.findHover(lastHovered.x, lastHovered.y);
      lastHoveredTarget = lastHovered.target;
    }
    var hovered = this._hovered = isOutside ? new HoveredResult(x2, y2) : this.findHover(x2, y2);
    var hoveredTarget = hovered.target;
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(hoveredTarget ? hoveredTarget.cursor : "default");
    if (lastHoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(lastHovered, "mouseout", event);
    }
    this.dispatchToElement(hovered, "mousemove", event);
    if (hoveredTarget && hoveredTarget !== lastHoveredTarget) {
      this.dispatchToElement(hovered, "mouseover", event);
    }
  };
  Handler2.prototype.mouseout = function(event) {
    var eventControl = event.zrEventControl;
    if (eventControl !== "only_globalout") {
      this.dispatchToElement(this._hovered, "mouseout", event);
    }
    if (eventControl !== "no_globalout") {
      this.trigger("globalout", { type: "globalout", event });
    }
  };
  Handler2.prototype.resize = function() {
    this._hovered = new HoveredResult(0, 0);
  };
  Handler2.prototype.dispatch = function(eventName, eventArgs) {
    var handler = this[eventName];
    handler && handler.call(this, eventArgs);
  };
  Handler2.prototype.dispose = function() {
    this.proxy.dispose();
    this.storage = null;
    this.proxy = null;
    this.painter = null;
  };
  Handler2.prototype.setCursorStyle = function(cursorStyle) {
    var proxy = this.proxy;
    proxy.setCursor && proxy.setCursor(cursorStyle);
  };
  Handler2.prototype.dispatchToElement = function(targetInfo, eventName, event) {
    targetInfo = targetInfo || {};
    var el = targetInfo.target;
    if (el && el.silent) {
      return;
    }
    var eventKey = "on" + eventName;
    var eventPacket = makeEventPacket(eventName, targetInfo, event);
    while (el) {
      el[eventKey] && (eventPacket.cancelBubble = !!el[eventKey].call(el, eventPacket));
      el.trigger(eventName, eventPacket);
      el = el.__hostTarget ? el.__hostTarget : el.parent;
      if (eventPacket.cancelBubble) {
        break;
      }
    }
    if (!eventPacket.cancelBubble) {
      this.trigger(eventName, eventPacket);
      if (this.painter && this.painter.eachOtherLayer) {
        this.painter.eachOtherLayer(function(layer) {
          if (typeof layer[eventKey] === "function") {
            layer[eventKey].call(layer, eventPacket);
          }
          if (layer.trigger) {
            layer.trigger(eventName, eventPacket);
          }
        });
      }
    }
  };
  Handler2.prototype.findHover = function(x2, y2, exclude) {
    var list = this.storage.getDisplayList();
    var out2 = new HoveredResult(x2, y2);
    for (var i = list.length - 1; i >= 0; i--) {
      var hoverCheckResult = void 0;
      if (list[i] !== exclude && !list[i].ignore && (hoverCheckResult = isHover(list[i], x2, y2))) {
        !out2.topTarget && (out2.topTarget = list[i]);
        if (hoverCheckResult !== SILENT) {
          out2.target = list[i];
          break;
        }
      }
    }
    return out2;
  };
  Handler2.prototype.processGesture = function(event, stage) {
    if (!this._gestureMgr) {
      this._gestureMgr = new GestureMgr();
    }
    var gestureMgr = this._gestureMgr;
    stage === "start" && gestureMgr.clear();
    var gestureInfo = gestureMgr.recognize(event, this.findHover(event.zrX, event.zrY, null).target, this.proxy.dom);
    stage === "end" && gestureMgr.clear();
    if (gestureInfo) {
      var type4 = gestureInfo.type;
      event.gestureEvent = type4;
      var res = new HoveredResult();
      res.target = gestureInfo.target;
      this.dispatchToElement(res, type4, gestureInfo.event);
    }
  };
  return Handler2;
}(Eventful$1);
each$f(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(name) {
  Handler.prototype[name] = function(event) {
    var x2 = event.zrX;
    var y2 = event.zrY;
    var isOutside = isOutsideBoundary(this, x2, y2);
    var hovered;
    var hoveredTarget;
    if (name !== "mouseup" || !isOutside) {
      hovered = this.findHover(x2, y2);
      hoveredTarget = hovered.target;
    }
    if (name === "mousedown") {
      this._downEl = hoveredTarget;
      this._downPoint = [event.zrX, event.zrY];
      this._upEl = hoveredTarget;
    } else if (name === "mouseup") {
      this._upEl = hoveredTarget;
    } else if (name === "click") {
      if (this._downEl !== this._upEl || !this._downPoint || dist$1(this._downPoint, [event.zrX, event.zrY]) > 4) {
        return;
      }
      this._downPoint = null;
    }
    this.dispatchToElement(hovered, name, event);
  };
});
function isHover(displayable, x2, y2) {
  if (displayable[displayable.rectHover ? "rectContain" : "contain"](x2, y2)) {
    var el = displayable;
    var isSilent = void 0;
    var ignoreClip = false;
    while (el) {
      if (el.ignoreClip) {
        ignoreClip = true;
      }
      if (!ignoreClip) {
        var clipPath = el.getClipPath();
        if (clipPath && !clipPath.contain(x2, y2)) {
          return false;
        }
        if (el.silent) {
          isSilent = true;
        }
      }
      var hostEl = el.__hostTarget;
      el = hostEl ? hostEl : el.parent;
    }
    return isSilent ? SILENT : true;
  }
  return false;
}
function isOutsideBoundary(handlerInstance, x2, y2) {
  var painter = handlerInstance.painter;
  return x2 < 0 || x2 > painter.getWidth() || y2 < 0 || y2 > painter.getHeight();
}
var Handler$1 = Handler;
var DEFAULT_MIN_MERGE = 32;
var DEFAULT_MIN_GALLOPING = 7;
function minRunLength(n2) {
  var r2 = 0;
  while (n2 >= DEFAULT_MIN_MERGE) {
    r2 |= n2 & 1;
    n2 >>= 1;
  }
  return n2 + r2;
}
function makeAscendingRun(array4, lo, hi, compare2) {
  var runHi = lo + 1;
  if (runHi === hi) {
    return 1;
  }
  if (compare2(array4[runHi++], array4[lo]) < 0) {
    while (runHi < hi && compare2(array4[runHi], array4[runHi - 1]) < 0) {
      runHi++;
    }
    reverseRun(array4, lo, runHi);
  } else {
    while (runHi < hi && compare2(array4[runHi], array4[runHi - 1]) >= 0) {
      runHi++;
    }
  }
  return runHi - lo;
}
function reverseRun(array4, lo, hi) {
  hi--;
  while (lo < hi) {
    var t2 = array4[lo];
    array4[lo++] = array4[hi];
    array4[hi--] = t2;
  }
}
function binaryInsertionSort(array4, lo, hi, start2, compare2) {
  if (start2 === lo) {
    start2++;
  }
  for (; start2 < hi; start2++) {
    var pivot = array4[start2];
    var left = lo;
    var right = start2;
    var mid;
    while (left < right) {
      mid = left + right >>> 1;
      if (compare2(pivot, array4[mid]) < 0) {
        right = mid;
      } else {
        left = mid + 1;
      }
    }
    var n2 = start2 - left;
    switch (n2) {
      case 3:
        array4[left + 3] = array4[left + 2];
      case 2:
        array4[left + 2] = array4[left + 1];
      case 1:
        array4[left + 1] = array4[left];
        break;
      default:
        while (n2 > 0) {
          array4[left + n2] = array4[left + n2 - 1];
          n2--;
        }
    }
    array4[left] = pivot;
  }
}
function gallopLeft(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset = 1;
  if (compare2(value, array4[start2 + hint]) > 0) {
    maxOffset = length - hint;
    while (offset < maxOffset && compare2(value, array4[start2 + hint + offset]) > 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    lastOffset += hint;
    offset += hint;
  } else {
    maxOffset = hint + 1;
    while (offset < maxOffset && compare2(value, array4[start2 + hint - offset]) <= 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset;
    offset = hint - tmp;
  }
  lastOffset++;
  while (lastOffset < offset) {
    var m2 = lastOffset + (offset - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) > 0) {
      lastOffset = m2 + 1;
    } else {
      offset = m2;
    }
  }
  return offset;
}
function gallopRight(value, array4, start2, length, hint, compare2) {
  var lastOffset = 0;
  var maxOffset = 0;
  var offset = 1;
  if (compare2(value, array4[start2 + hint]) < 0) {
    maxOffset = hint + 1;
    while (offset < maxOffset && compare2(value, array4[start2 + hint - offset]) < 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    var tmp = lastOffset;
    lastOffset = hint - offset;
    offset = hint - tmp;
  } else {
    maxOffset = length - hint;
    while (offset < maxOffset && compare2(value, array4[start2 + hint + offset]) >= 0) {
      lastOffset = offset;
      offset = (offset << 1) + 1;
      if (offset <= 0) {
        offset = maxOffset;
      }
    }
    if (offset > maxOffset) {
      offset = maxOffset;
    }
    lastOffset += hint;
    offset += hint;
  }
  lastOffset++;
  while (lastOffset < offset) {
    var m2 = lastOffset + (offset - lastOffset >>> 1);
    if (compare2(value, array4[start2 + m2]) < 0) {
      offset = m2;
    } else {
      lastOffset = m2 + 1;
    }
  }
  return offset;
}
function TimSort(array4, compare2) {
  var minGallop = DEFAULT_MIN_GALLOPING;
  var runStart;
  var runLength;
  var stackSize = 0;
  var tmp = [];
  runStart = [];
  runLength = [];
  function pushRun(_runStart, _runLength) {
    runStart[stackSize] = _runStart;
    runLength[stackSize] = _runLength;
    stackSize += 1;
  }
  function mergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 >= 1 && runLength[n2 - 1] <= runLength[n2] + runLength[n2 + 1] || n2 >= 2 && runLength[n2 - 2] <= runLength[n2] + runLength[n2 - 1]) {
        if (runLength[n2 - 1] < runLength[n2 + 1]) {
          n2--;
        }
      } else if (runLength[n2] > runLength[n2 + 1]) {
        break;
      }
      mergeAt(n2);
    }
  }
  function forceMergeRuns() {
    while (stackSize > 1) {
      var n2 = stackSize - 2;
      if (n2 > 0 && runLength[n2 - 1] < runLength[n2 + 1]) {
        n2--;
      }
      mergeAt(n2);
    }
  }
  function mergeAt(i) {
    var start1 = runStart[i];
    var length1 = runLength[i];
    var start2 = runStart[i + 1];
    var length2 = runLength[i + 1];
    runLength[i] = length1 + length2;
    if (i === stackSize - 3) {
      runStart[i + 1] = runStart[i + 2];
      runLength[i + 1] = runLength[i + 2];
    }
    stackSize--;
    var k2 = gallopRight(array4[start2], array4, start1, length1, 0, compare2);
    start1 += k2;
    length1 -= k2;
    if (length1 === 0) {
      return;
    }
    length2 = gallopLeft(array4[start1 + length1 - 1], array4, start2, length2, length2 - 1, compare2);
    if (length2 === 0) {
      return;
    }
    if (length1 <= length2) {
      mergeLow(start1, length1, start2, length2);
    } else {
      mergeHigh(start1, length1, start2, length2);
    }
  }
  function mergeLow(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length1; i++) {
      tmp[i] = array4[start1 + i];
    }
    var cursor1 = 0;
    var cursor2 = start2;
    var dest = start1;
    array4[dest++] = array4[cursor2++];
    if (--length2 === 0) {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
      return;
    }
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
      return;
    }
    var _minGallop = minGallop;
    var count1;
    var count2;
    var exit;
    while (1) {
      count1 = 0;
      count2 = 0;
      exit = false;
      do {
        if (compare2(array4[cursor2], tmp[cursor1]) < 0) {
          array4[dest++] = array4[cursor2++];
          count2++;
          count1 = 0;
          if (--length2 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest++] = tmp[cursor1++];
          count1++;
          count2 = 0;
          if (--length1 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = gallopRight(array4[cursor2], tmp, cursor1, length1, 0, compare2);
        if (count1 !== 0) {
          for (i = 0; i < count1; i++) {
            array4[dest + i] = tmp[cursor1 + i];
          }
          dest += count1;
          cursor1 += count1;
          length1 -= count1;
          if (length1 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest++] = array4[cursor2++];
        if (--length2 === 0) {
          exit = true;
          break;
        }
        count2 = gallopLeft(tmp[cursor1], array4, cursor2, length2, 0, compare2);
        if (count2 !== 0) {
          for (i = 0; i < count2; i++) {
            array4[dest + i] = array4[cursor2 + i];
          }
          dest += count2;
          cursor2 += count2;
          length2 -= count2;
          if (length2 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest++] = tmp[cursor1++];
        if (--length1 === 1) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    minGallop < 1 && (minGallop = 1);
    if (length1 === 1) {
      for (i = 0; i < length2; i++) {
        array4[dest + i] = array4[cursor2 + i];
      }
      array4[dest + length2] = tmp[cursor1];
    } else if (length1 === 0) {
      throw new Error();
    } else {
      for (i = 0; i < length1; i++) {
        array4[dest + i] = tmp[cursor1 + i];
      }
    }
  }
  function mergeHigh(start1, length1, start2, length2) {
    var i = 0;
    for (i = 0; i < length2; i++) {
      tmp[i] = array4[start2 + i];
    }
    var cursor1 = start1 + length1 - 1;
    var cursor2 = length2 - 1;
    var dest = start2 + length2 - 1;
    var customCursor = 0;
    var customDest = 0;
    array4[dest--] = array4[cursor1--];
    if (--length1 === 0) {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
      return;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
      return;
    }
    var _minGallop = minGallop;
    while (true) {
      var count1 = 0;
      var count2 = 0;
      var exit = false;
      do {
        if (compare2(tmp[cursor2], array4[cursor1]) < 0) {
          array4[dest--] = array4[cursor1--];
          count1++;
          count2 = 0;
          if (--length1 === 0) {
            exit = true;
            break;
          }
        } else {
          array4[dest--] = tmp[cursor2--];
          count2++;
          count1 = 0;
          if (--length2 === 1) {
            exit = true;
            break;
          }
        }
      } while ((count1 | count2) < _minGallop);
      if (exit) {
        break;
      }
      do {
        count1 = length1 - gallopRight(tmp[cursor2], array4, start1, length1, length1 - 1, compare2);
        if (count1 !== 0) {
          dest -= count1;
          cursor1 -= count1;
          length1 -= count1;
          customDest = dest + 1;
          customCursor = cursor1 + 1;
          for (i = count1 - 1; i >= 0; i--) {
            array4[customDest + i] = array4[customCursor + i];
          }
          if (length1 === 0) {
            exit = true;
            break;
          }
        }
        array4[dest--] = tmp[cursor2--];
        if (--length2 === 1) {
          exit = true;
          break;
        }
        count2 = length2 - gallopLeft(array4[cursor1], tmp, 0, length2, length2 - 1, compare2);
        if (count2 !== 0) {
          dest -= count2;
          cursor2 -= count2;
          length2 -= count2;
          customDest = dest + 1;
          customCursor = cursor2 + 1;
          for (i = 0; i < count2; i++) {
            array4[customDest + i] = tmp[customCursor + i];
          }
          if (length2 <= 1) {
            exit = true;
            break;
          }
        }
        array4[dest--] = array4[cursor1--];
        if (--length1 === 0) {
          exit = true;
          break;
        }
        _minGallop--;
      } while (count1 >= DEFAULT_MIN_GALLOPING || count2 >= DEFAULT_MIN_GALLOPING);
      if (exit) {
        break;
      }
      if (_minGallop < 0) {
        _minGallop = 0;
      }
      _minGallop += 2;
    }
    minGallop = _minGallop;
    if (minGallop < 1) {
      minGallop = 1;
    }
    if (length2 === 1) {
      dest -= length1;
      cursor1 -= length1;
      customDest = dest + 1;
      customCursor = cursor1 + 1;
      for (i = length1 - 1; i >= 0; i--) {
        array4[customDest + i] = array4[customCursor + i];
      }
      array4[dest] = tmp[cursor2];
    } else if (length2 === 0) {
      throw new Error();
    } else {
      customCursor = dest - (length2 - 1);
      for (i = 0; i < length2; i++) {
        array4[customCursor + i] = tmp[i];
      }
    }
  }
  return {
    mergeRuns,
    forceMergeRuns,
    pushRun
  };
}
function sort$2(array4, compare2, lo, hi) {
  if (!lo) {
    lo = 0;
  }
  if (!hi) {
    hi = array4.length;
  }
  var remaining = hi - lo;
  if (remaining < 2) {
    return;
  }
  var runLength = 0;
  if (remaining < DEFAULT_MIN_MERGE) {
    runLength = makeAscendingRun(array4, lo, hi, compare2);
    binaryInsertionSort(array4, lo, hi, lo + runLength, compare2);
    return;
  }
  var ts = TimSort(array4, compare2);
  var minRun = minRunLength(remaining);
  do {
    runLength = makeAscendingRun(array4, lo, hi, compare2);
    if (runLength < minRun) {
      var force = remaining;
      if (force > minRun) {
        force = minRun;
      }
      binaryInsertionSort(array4, lo, lo + force, lo + runLength, compare2);
      runLength = force;
    }
    ts.pushRun(lo, runLength);
    ts.mergeRuns();
    remaining -= runLength;
    lo += runLength;
  } while (remaining !== 0);
  ts.forceMergeRuns();
}
var REDRAW_BIT = 1;
var STYLE_CHANGED_BIT = 2;
var SHAPE_CHANGED_BIT = 4;
var invalidZErrorLogged = false;
function logInvalidZError() {
  if (invalidZErrorLogged) {
    return;
  }
  invalidZErrorLogged = true;
  console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors");
}
function shapeCompareFunc(a, b2) {
  if (a.zlevel === b2.zlevel) {
    if (a.z === b2.z) {
      return a.z2 - b2.z2;
    }
    return a.z - b2.z;
  }
  return a.zlevel - b2.zlevel;
}
var Storage = function() {
  function Storage2() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    this.displayableSortFunc = shapeCompareFunc;
  }
  Storage2.prototype.traverse = function(cb, context) {
    for (var i = 0; i < this._roots.length; i++) {
      this._roots[i].traverse(cb, context);
    }
  };
  Storage2.prototype.getDisplayList = function(update, includeIgnore) {
    includeIgnore = includeIgnore || false;
    var displayList = this._displayList;
    if (update || !displayList.length) {
      this.updateDisplayList(includeIgnore);
    }
    return displayList;
  };
  Storage2.prototype.updateDisplayList = function(includeIgnore) {
    this._displayListLen = 0;
    var roots2 = this._roots;
    var displayList = this._displayList;
    for (var i = 0, len2 = roots2.length; i < len2; i++) {
      this._updateAndAddDisplayable(roots2[i], null, includeIgnore);
    }
    displayList.length = this._displayListLen;
    sort$2(displayList, shapeCompareFunc);
  };
  Storage2.prototype._updateAndAddDisplayable = function(el, clipPaths, includeIgnore) {
    if (el.ignore && !includeIgnore) {
      return;
    }
    el.beforeUpdate();
    el.update();
    el.afterUpdate();
    var userSetClipPath = el.getClipPath();
    if (el.ignoreClip) {
      clipPaths = null;
    } else if (userSetClipPath) {
      if (clipPaths) {
        clipPaths = clipPaths.slice();
      } else {
        clipPaths = [];
      }
      var currentClipPath = userSetClipPath;
      var parentClipPath = el;
      while (currentClipPath) {
        currentClipPath.parent = parentClipPath;
        currentClipPath.updateTransform();
        clipPaths.push(currentClipPath);
        parentClipPath = currentClipPath;
        currentClipPath = currentClipPath.getClipPath();
      }
    }
    if (el.childrenRef) {
      var children = el.childrenRef();
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        if (el.__dirty) {
          child.__dirty |= REDRAW_BIT;
        }
        this._updateAndAddDisplayable(child, clipPaths, includeIgnore);
      }
      el.__dirty = 0;
    } else {
      var disp = el;
      if (clipPaths && clipPaths.length) {
        disp.__clipPaths = clipPaths;
      } else if (disp.__clipPaths && disp.__clipPaths.length > 0) {
        disp.__clipPaths = [];
      }
      if (isNaN(disp.z)) {
        logInvalidZError();
        disp.z = 0;
      }
      if (isNaN(disp.z2)) {
        logInvalidZError();
        disp.z2 = 0;
      }
      if (isNaN(disp.zlevel)) {
        logInvalidZError();
        disp.zlevel = 0;
      }
      this._displayList[this._displayListLen++] = disp;
    }
    var decalEl = el.getDecalElement && el.getDecalElement();
    if (decalEl) {
      this._updateAndAddDisplayable(decalEl, clipPaths, includeIgnore);
    }
    var textGuide = el.getTextGuideLine();
    if (textGuide) {
      this._updateAndAddDisplayable(textGuide, clipPaths, includeIgnore);
    }
    var textEl = el.getTextContent();
    if (textEl) {
      this._updateAndAddDisplayable(textEl, clipPaths, includeIgnore);
    }
  };
  Storage2.prototype.addRoot = function(el) {
    if (el.__zr && el.__zr.storage === this) {
      return;
    }
    this._roots.push(el);
  };
  Storage2.prototype.delRoot = function(el) {
    if (el instanceof Array) {
      for (var i = 0, l2 = el.length; i < l2; i++) {
        this.delRoot(el[i]);
      }
      return;
    }
    var idx = indexOf(this._roots, el);
    if (idx >= 0) {
      this._roots.splice(idx, 1);
    }
  };
  Storage2.prototype.delAllRoots = function() {
    this._roots = [];
    this._displayList = [];
    this._displayListLen = 0;
    return;
  };
  Storage2.prototype.getRoots = function() {
    return this._roots;
  };
  Storage2.prototype.dispose = function() {
    this._displayList = null;
    this._roots = null;
  };
  return Storage2;
}();
var Storage$1 = Storage;
var requestAnimationFrame$1;
requestAnimationFrame$1 = env$1.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(func) {
  return setTimeout(func, 16);
};
var requestAnimationFrame$2 = requestAnimationFrame$1;
var easingFuncs = {
  linear: function(k2) {
    return k2;
  },
  quadraticIn: function(k2) {
    return k2 * k2;
  },
  quadraticOut: function(k2) {
    return k2 * (2 - k2);
  },
  quadraticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2;
    }
    return -0.5 * (--k2 * (k2 - 2) - 1);
  },
  cubicIn: function(k2) {
    return k2 * k2 * k2;
  },
  cubicOut: function(k2) {
    return --k2 * k2 * k2 + 1;
  },
  cubicInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 + 2);
  },
  quarticIn: function(k2) {
    return k2 * k2 * k2 * k2;
  },
  quarticOut: function(k2) {
    return 1 - --k2 * k2 * k2 * k2;
  },
  quarticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2;
    }
    return -0.5 * ((k2 -= 2) * k2 * k2 * k2 - 2);
  },
  quinticIn: function(k2) {
    return k2 * k2 * k2 * k2 * k2;
  },
  quinticOut: function(k2) {
    return --k2 * k2 * k2 * k2 * k2 + 1;
  },
  quinticInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return 0.5 * k2 * k2 * k2 * k2 * k2;
    }
    return 0.5 * ((k2 -= 2) * k2 * k2 * k2 * k2 + 2);
  },
  sinusoidalIn: function(k2) {
    return 1 - Math.cos(k2 * Math.PI / 2);
  },
  sinusoidalOut: function(k2) {
    return Math.sin(k2 * Math.PI / 2);
  },
  sinusoidalInOut: function(k2) {
    return 0.5 * (1 - Math.cos(Math.PI * k2));
  },
  exponentialIn: function(k2) {
    return k2 === 0 ? 0 : Math.pow(1024, k2 - 1);
  },
  exponentialOut: function(k2) {
    return k2 === 1 ? 1 : 1 - Math.pow(2, -10 * k2);
  },
  exponentialInOut: function(k2) {
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if ((k2 *= 2) < 1) {
      return 0.5 * Math.pow(1024, k2 - 1);
    }
    return 0.5 * (-Math.pow(2, -10 * (k2 - 1)) + 2);
  },
  circularIn: function(k2) {
    return 1 - Math.sqrt(1 - k2 * k2);
  },
  circularOut: function(k2) {
    return Math.sqrt(1 - --k2 * k2);
  },
  circularInOut: function(k2) {
    if ((k2 *= 2) < 1) {
      return -0.5 * (Math.sqrt(1 - k2 * k2) - 1);
    }
    return 0.5 * (Math.sqrt(1 - (k2 -= 2) * k2) + 1);
  },
  elasticIn: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return -(a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
  },
  elasticOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    return a * Math.pow(2, -10 * k2) * Math.sin((k2 - s) * (2 * Math.PI) / p2) + 1;
  },
  elasticInOut: function(k2) {
    var s;
    var a = 0.1;
    var p2 = 0.4;
    if (k2 === 0) {
      return 0;
    }
    if (k2 === 1) {
      return 1;
    }
    if (!a || a < 1) {
      a = 1;
      s = p2 / 4;
    } else {
      s = p2 * Math.asin(1 / a) / (2 * Math.PI);
    }
    if ((k2 *= 2) < 1) {
      return -0.5 * (a * Math.pow(2, 10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2));
    }
    return a * Math.pow(2, -10 * (k2 -= 1)) * Math.sin((k2 - s) * (2 * Math.PI) / p2) * 0.5 + 1;
  },
  backIn: function(k2) {
    var s = 1.70158;
    return k2 * k2 * ((s + 1) * k2 - s);
  },
  backOut: function(k2) {
    var s = 1.70158;
    return --k2 * k2 * ((s + 1) * k2 + s) + 1;
  },
  backInOut: function(k2) {
    var s = 1.70158 * 1.525;
    if ((k2 *= 2) < 1) {
      return 0.5 * (k2 * k2 * ((s + 1) * k2 - s));
    }
    return 0.5 * ((k2 -= 2) * k2 * ((s + 1) * k2 + s) + 2);
  },
  bounceIn: function(k2) {
    return 1 - easingFuncs.bounceOut(1 - k2);
  },
  bounceOut: function(k2) {
    if (k2 < 1 / 2.75) {
      return 7.5625 * k2 * k2;
    } else if (k2 < 2 / 2.75) {
      return 7.5625 * (k2 -= 1.5 / 2.75) * k2 + 0.75;
    } else if (k2 < 2.5 / 2.75) {
      return 7.5625 * (k2 -= 2.25 / 2.75) * k2 + 0.9375;
    } else {
      return 7.5625 * (k2 -= 2.625 / 2.75) * k2 + 0.984375;
    }
  },
  bounceInOut: function(k2) {
    if (k2 < 0.5) {
      return easingFuncs.bounceIn(k2 * 2) * 0.5;
    }
    return easingFuncs.bounceOut(k2 * 2 - 1) * 0.5 + 0.5;
  }
};
var easingFuncs$1 = easingFuncs;
var mathPow$2 = Math.pow;
var mathSqrt$3 = Math.sqrt;
var EPSILON$4 = 1e-8;
var EPSILON_NUMERIC = 1e-4;
var THREE_SQRT = mathSqrt$3(3);
var ONE_THIRD = 1 / 3;
var _v0 = create$2();
var _v1 = create$2();
var _v2 = create$2();
function isAroundZero$1(val) {
  return val > -EPSILON$4 && val < EPSILON$4;
}
function isNotAroundZero$1(val) {
  return val > EPSILON$4 || val < -EPSILON$4;
}
function cubicAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return onet * onet * (onet * p0 + 3 * t2 * p1) + t2 * t2 * (t2 * p3 + 3 * onet * p2);
}
function cubicDerivativeAt(p0, p1, p2, p3, t2) {
  var onet = 1 - t2;
  return 3 * (((p1 - p0) * onet + 2 * (p2 - p1) * t2) * onet + (p3 - p2) * t2 * t2);
}
function cubicRootAt(p0, p1, p2, p3, val, roots2) {
  var a = p3 + 3 * (p1 - p2) - p0;
  var b2 = 3 * (p2 - p1 * 2 + p0);
  var c2 = 3 * (p1 - p0);
  var d2 = p0 - val;
  var A2 = b2 * b2 - 3 * a * c2;
  var B = b2 * c2 - 9 * a * d2;
  var C = c2 * c2 - 3 * b2 * d2;
  var n2 = 0;
  if (isAroundZero$1(A2) && isAroundZero$1(B)) {
    if (isAroundZero$1(b2)) {
      roots2[0] = 0;
    } else {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = B * B - 4 * A2 * C;
    if (isAroundZero$1(disc)) {
      var K = B / A2;
      var t1 = -b2 / a + K;
      var t2 = -K / 2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var Y1 = A2 * b2 + 1.5 * a * (-B + discSqrt);
      var Y2 = A2 * b2 + 1.5 * a * (-B - discSqrt);
      if (Y1 < 0) {
        Y1 = -mathPow$2(-Y1, ONE_THIRD);
      } else {
        Y1 = mathPow$2(Y1, ONE_THIRD);
      }
      if (Y2 < 0) {
        Y2 = -mathPow$2(-Y2, ONE_THIRD);
      } else {
        Y2 = mathPow$2(Y2, ONE_THIRD);
      }
      var t1 = (-b2 - (Y1 + Y2)) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else {
      var T = (2 * A2 * b2 - 3 * a * B) / (2 * mathSqrt$3(A2 * A2 * A2));
      var theta = Math.acos(T) / 3;
      var ASqrt = mathSqrt$3(A2);
      var tmp = Math.cos(theta);
      var t1 = (-b2 - 2 * ASqrt * tmp) / (3 * a);
      var t2 = (-b2 + ASqrt * (tmp + THREE_SQRT * Math.sin(theta))) / (3 * a);
      var t3 = (-b2 + ASqrt * (tmp - THREE_SQRT * Math.sin(theta))) / (3 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
      if (t3 >= 0 && t3 <= 1) {
        roots2[n2++] = t3;
      }
    }
  }
  return n2;
}
function cubicExtrema(p0, p1, p2, p3, extrema2) {
  var b2 = 6 * p2 - 12 * p1 + 6 * p0;
  var a = 9 * p1 + 3 * p3 - 3 * p0 - 9 * p2;
  var c2 = 3 * p1 - 3 * p0;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      extrema2[0] = -b2 / (2 * a);
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        extrema2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        extrema2[n2++] = t2;
      }
    }
  }
  return n2;
}
function cubicSubdivide(p0, p1, p2, p3, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p23 = (p3 - p2) * t2 + p2;
  var p012 = (p12 - p01) * t2 + p01;
  var p123 = (p23 - p12) * t2 + p12;
  var p0123 = (p123 - p012) * t2 + p012;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p0123;
  out2[4] = p0123;
  out2[5] = p123;
  out2[6] = p23;
  out2[7] = p3;
}
function cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  var prev;
  var next;
  var d1;
  var d22;
  _v0[0] = x4;
  _v0[1] = y4;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = cubicAt(x0, x1, x2, x3, _t);
    _v1[1] = cubicAt(y0, y1, y2, y3, _t);
    d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    prev = t2 - interval;
    next = t2 + interval;
    _v1[0] = cubicAt(x0, x1, x2, x3, prev);
    _v1[1] = cubicAt(y0, y1, y2, y3, prev);
    d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = cubicAt(x0, x1, x2, x3, next);
      _v2[1] = cubicAt(y0, y1, y2, y3, next);
      d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = cubicAt(x0, x1, x2, x3, t2);
    out2[1] = cubicAt(y0, y1, y2, y3, t2);
  }
  return mathSqrt$3(d2);
}
function cubicLength(x0, y0, x1, y1, x2, y2, x3, y3, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x4 = cubicAt(x0, x1, x2, x3, t2);
    var y4 = cubicAt(y0, y1, y2, y3, t2);
    var dx = x4 - px;
    var dy = y4 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x4;
    py = y4;
  }
  return d2;
}
function quadraticAt$1(p0, p1, p2, t2) {
  var onet = 1 - t2;
  return onet * (onet * p0 + 2 * t2 * p1) + t2 * t2 * p2;
}
function quadraticDerivativeAt(p0, p1, p2, t2) {
  return 2 * ((1 - t2) * (p1 - p0) + t2 * (p2 - p1));
}
function quadraticRootAt(p0, p1, p2, val, roots2) {
  var a = p0 - 2 * p1 + p2;
  var b2 = 2 * (p1 - p0);
  var c2 = p0 - val;
  var n2 = 0;
  if (isAroundZero$1(a)) {
    if (isNotAroundZero$1(b2)) {
      var t1 = -c2 / b2;
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    }
  } else {
    var disc = b2 * b2 - 4 * a * c2;
    if (isAroundZero$1(disc)) {
      var t1 = -b2 / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
    } else if (disc > 0) {
      var discSqrt = mathSqrt$3(disc);
      var t1 = (-b2 + discSqrt) / (2 * a);
      var t2 = (-b2 - discSqrt) / (2 * a);
      if (t1 >= 0 && t1 <= 1) {
        roots2[n2++] = t1;
      }
      if (t2 >= 0 && t2 <= 1) {
        roots2[n2++] = t2;
      }
    }
  }
  return n2;
}
function quadraticExtremum(p0, p1, p2) {
  var divider = p0 + p2 - 2 * p1;
  if (divider === 0) {
    return 0.5;
  } else {
    return (p0 - p1) / divider;
  }
}
function quadraticSubdivide(p0, p1, p2, t2, out2) {
  var p01 = (p1 - p0) * t2 + p0;
  var p12 = (p2 - p1) * t2 + p1;
  var p012 = (p12 - p01) * t2 + p01;
  out2[0] = p0;
  out2[1] = p01;
  out2[2] = p012;
  out2[3] = p012;
  out2[4] = p12;
  out2[5] = p2;
}
function quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, out2) {
  var t2;
  var interval = 5e-3;
  var d2 = Infinity;
  _v0[0] = x3;
  _v0[1] = y3;
  for (var _t = 0; _t < 1; _t += 0.05) {
    _v1[0] = quadraticAt$1(x0, x1, x2, _t);
    _v1[1] = quadraticAt$1(y0, y1, y2, _t);
    var d1 = distSquare(_v0, _v1);
    if (d1 < d2) {
      t2 = _t;
      d2 = d1;
    }
  }
  d2 = Infinity;
  for (var i = 0; i < 32; i++) {
    if (interval < EPSILON_NUMERIC) {
      break;
    }
    var prev = t2 - interval;
    var next = t2 + interval;
    _v1[0] = quadraticAt$1(x0, x1, x2, prev);
    _v1[1] = quadraticAt$1(y0, y1, y2, prev);
    var d1 = distSquare(_v1, _v0);
    if (prev >= 0 && d1 < d2) {
      t2 = prev;
      d2 = d1;
    } else {
      _v2[0] = quadraticAt$1(x0, x1, x2, next);
      _v2[1] = quadraticAt$1(y0, y1, y2, next);
      var d22 = distSquare(_v2, _v0);
      if (next <= 1 && d22 < d2) {
        t2 = next;
        d2 = d22;
      } else {
        interval *= 0.5;
      }
    }
  }
  if (out2) {
    out2[0] = quadraticAt$1(x0, x1, x2, t2);
    out2[1] = quadraticAt$1(y0, y1, y2, t2);
  }
  return mathSqrt$3(d2);
}
function quadraticLength(x0, y0, x1, y1, x2, y2, iteration) {
  var px = x0;
  var py = y0;
  var d2 = 0;
  var step = 1 / iteration;
  for (var i = 1; i <= iteration; i++) {
    var t2 = i * step;
    var x3 = quadraticAt$1(x0, x1, x2, t2);
    var y3 = quadraticAt$1(y0, y1, y2, t2);
    var dx = x3 - px;
    var dy = y3 - py;
    d2 += Math.sqrt(dx * dx + dy * dy);
    px = x3;
    py = y3;
  }
  return d2;
}
var regexp$1 = /cubic-bezier\(([0-9,\.e ]+)\)/;
function createCubicEasingFunc(cubicEasingStr) {
  var cubic = cubicEasingStr && regexp$1.exec(cubicEasingStr);
  if (cubic) {
    var points2 = cubic[1].split(",");
    var a_1 = +trim$1(points2[0]);
    var b_1 = +trim$1(points2[1]);
    var c_1 = +trim$1(points2[2]);
    var d_1 = +trim$1(points2[3]);
    if (isNaN(a_1 + b_1 + c_1 + d_1)) {
      return;
    }
    var roots_1 = [];
    return function(p2) {
      return p2 <= 0 ? 0 : p2 >= 1 ? 1 : cubicRootAt(0, a_1, c_1, 1, p2, roots_1) && cubicAt(0, b_1, d_1, 1, roots_1[0]);
    };
  }
}
var Clip = function() {
  function Clip2(opts) {
    this._inited = false;
    this._startTime = 0;
    this._pausedTime = 0;
    this._paused = false;
    this._life = opts.life || 1e3;
    this._delay = opts.delay || 0;
    this.loop = opts.loop || false;
    this.onframe = opts.onframe || noop;
    this.ondestroy = opts.ondestroy || noop;
    this.onrestart = opts.onrestart || noop;
    opts.easing && this.setEasing(opts.easing);
  }
  Clip2.prototype.step = function(globalTime, deltaTime) {
    if (!this._inited) {
      this._startTime = globalTime + this._delay;
      this._inited = true;
    }
    if (this._paused) {
      this._pausedTime += deltaTime;
      return;
    }
    var life = this._life;
    var elapsedTime = globalTime - this._startTime - this._pausedTime;
    var percent = elapsedTime / life;
    if (percent < 0) {
      percent = 0;
    }
    percent = Math.min(percent, 1);
    var easingFunc = this.easingFunc;
    var schedule = easingFunc ? easingFunc(percent) : percent;
    this.onframe(schedule);
    if (percent === 1) {
      if (this.loop) {
        var remainder = elapsedTime % life;
        this._startTime = globalTime - remainder;
        this._pausedTime = 0;
        this.onrestart();
      } else {
        return true;
      }
    }
    return false;
  };
  Clip2.prototype.pause = function() {
    this._paused = true;
  };
  Clip2.prototype.resume = function() {
    this._paused = false;
  };
  Clip2.prototype.setEasing = function(easing) {
    this.easing = easing;
    this.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
  };
  return Clip2;
}();
var Clip$1 = Clip;
var Entry = function() {
  function Entry2(val) {
    this.value = val;
  }
  return Entry2;
}();
var LinkedList = function() {
  function LinkedList2() {
    this._len = 0;
  }
  LinkedList2.prototype.insert = function(val) {
    var entry = new Entry(val);
    this.insertEntry(entry);
    return entry;
  };
  LinkedList2.prototype.insertEntry = function(entry) {
    if (!this.head) {
      this.head = this.tail = entry;
    } else {
      this.tail.next = entry;
      entry.prev = this.tail;
      entry.next = null;
      this.tail = entry;
    }
    this._len++;
  };
  LinkedList2.prototype.remove = function(entry) {
    var prev = entry.prev;
    var next = entry.next;
    if (prev) {
      prev.next = next;
    } else {
      this.head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this.tail = prev;
    }
    entry.next = entry.prev = null;
    this._len--;
  };
  LinkedList2.prototype.len = function() {
    return this._len;
  };
  LinkedList2.prototype.clear = function() {
    this.head = this.tail = null;
    this._len = 0;
  };
  return LinkedList2;
}();
var LRU = function() {
  function LRU2(maxSize) {
    this._list = new LinkedList();
    this._maxSize = 10;
    this._map = {};
    this._maxSize = maxSize;
  }
  LRU2.prototype.put = function(key, value) {
    var list = this._list;
    var map2 = this._map;
    var removed = null;
    if (map2[key] == null) {
      var len2 = list.len();
      var entry = this._lastRemovedEntry;
      if (len2 >= this._maxSize && len2 > 0) {
        var leastUsedEntry = list.head;
        list.remove(leastUsedEntry);
        delete map2[leastUsedEntry.key];
        removed = leastUsedEntry.value;
        this._lastRemovedEntry = leastUsedEntry;
      }
      if (entry) {
        entry.value = value;
      } else {
        entry = new Entry(value);
      }
      entry.key = key;
      list.insertEntry(entry);
      map2[key] = entry;
    }
    return removed;
  };
  LRU2.prototype.get = function(key) {
    var entry = this._map[key];
    var list = this._list;
    if (entry != null) {
      if (entry !== list.tail) {
        list.remove(entry);
        list.insertEntry(entry);
      }
      return entry.value;
    }
  };
  LRU2.prototype.clear = function() {
    this._list.clear();
    this._map = {};
  };
  LRU2.prototype.len = function() {
    return this._list.len();
  };
  return LRU2;
}();
var LRU$1 = LRU;
var kCSSColorTable = {
  "transparent": [0, 0, 0, 0],
  "aliceblue": [240, 248, 255, 1],
  "antiquewhite": [250, 235, 215, 1],
  "aqua": [0, 255, 255, 1],
  "aquamarine": [127, 255, 212, 1],
  "azure": [240, 255, 255, 1],
  "beige": [245, 245, 220, 1],
  "bisque": [255, 228, 196, 1],
  "black": [0, 0, 0, 1],
  "blanchedalmond": [255, 235, 205, 1],
  "blue": [0, 0, 255, 1],
  "blueviolet": [138, 43, 226, 1],
  "brown": [165, 42, 42, 1],
  "burlywood": [222, 184, 135, 1],
  "cadetblue": [95, 158, 160, 1],
  "chartreuse": [127, 255, 0, 1],
  "chocolate": [210, 105, 30, 1],
  "coral": [255, 127, 80, 1],
  "cornflowerblue": [100, 149, 237, 1],
  "cornsilk": [255, 248, 220, 1],
  "crimson": [220, 20, 60, 1],
  "cyan": [0, 255, 255, 1],
  "darkblue": [0, 0, 139, 1],
  "darkcyan": [0, 139, 139, 1],
  "darkgoldenrod": [184, 134, 11, 1],
  "darkgray": [169, 169, 169, 1],
  "darkgreen": [0, 100, 0, 1],
  "darkgrey": [169, 169, 169, 1],
  "darkkhaki": [189, 183, 107, 1],
  "darkmagenta": [139, 0, 139, 1],
  "darkolivegreen": [85, 107, 47, 1],
  "darkorange": [255, 140, 0, 1],
  "darkorchid": [153, 50, 204, 1],
  "darkred": [139, 0, 0, 1],
  "darksalmon": [233, 150, 122, 1],
  "darkseagreen": [143, 188, 143, 1],
  "darkslateblue": [72, 61, 139, 1],
  "darkslategray": [47, 79, 79, 1],
  "darkslategrey": [47, 79, 79, 1],
  "darkturquoise": [0, 206, 209, 1],
  "darkviolet": [148, 0, 211, 1],
  "deeppink": [255, 20, 147, 1],
  "deepskyblue": [0, 191, 255, 1],
  "dimgray": [105, 105, 105, 1],
  "dimgrey": [105, 105, 105, 1],
  "dodgerblue": [30, 144, 255, 1],
  "firebrick": [178, 34, 34, 1],
  "floralwhite": [255, 250, 240, 1],
  "forestgreen": [34, 139, 34, 1],
  "fuchsia": [255, 0, 255, 1],
  "gainsboro": [220, 220, 220, 1],
  "ghostwhite": [248, 248, 255, 1],
  "gold": [255, 215, 0, 1],
  "goldenrod": [218, 165, 32, 1],
  "gray": [128, 128, 128, 1],
  "green": [0, 128, 0, 1],
  "greenyellow": [173, 255, 47, 1],
  "grey": [128, 128, 128, 1],
  "honeydew": [240, 255, 240, 1],
  "hotpink": [255, 105, 180, 1],
  "indianred": [205, 92, 92, 1],
  "indigo": [75, 0, 130, 1],
  "ivory": [255, 255, 240, 1],
  "khaki": [240, 230, 140, 1],
  "lavender": [230, 230, 250, 1],
  "lavenderblush": [255, 240, 245, 1],
  "lawngreen": [124, 252, 0, 1],
  "lemonchiffon": [255, 250, 205, 1],
  "lightblue": [173, 216, 230, 1],
  "lightcoral": [240, 128, 128, 1],
  "lightcyan": [224, 255, 255, 1],
  "lightgoldenrodyellow": [250, 250, 210, 1],
  "lightgray": [211, 211, 211, 1],
  "lightgreen": [144, 238, 144, 1],
  "lightgrey": [211, 211, 211, 1],
  "lightpink": [255, 182, 193, 1],
  "lightsalmon": [255, 160, 122, 1],
  "lightseagreen": [32, 178, 170, 1],
  "lightskyblue": [135, 206, 250, 1],
  "lightslategray": [119, 136, 153, 1],
  "lightslategrey": [119, 136, 153, 1],
  "lightsteelblue": [176, 196, 222, 1],
  "lightyellow": [255, 255, 224, 1],
  "lime": [0, 255, 0, 1],
  "limegreen": [50, 205, 50, 1],
  "linen": [250, 240, 230, 1],
  "magenta": [255, 0, 255, 1],
  "maroon": [128, 0, 0, 1],
  "mediumaquamarine": [102, 205, 170, 1],
  "mediumblue": [0, 0, 205, 1],
  "mediumorchid": [186, 85, 211, 1],
  "mediumpurple": [147, 112, 219, 1],
  "mediumseagreen": [60, 179, 113, 1],
  "mediumslateblue": [123, 104, 238, 1],
  "mediumspringgreen": [0, 250, 154, 1],
  "mediumturquoise": [72, 209, 204, 1],
  "mediumvioletred": [199, 21, 133, 1],
  "midnightblue": [25, 25, 112, 1],
  "mintcream": [245, 255, 250, 1],
  "mistyrose": [255, 228, 225, 1],
  "moccasin": [255, 228, 181, 1],
  "navajowhite": [255, 222, 173, 1],
  "navy": [0, 0, 128, 1],
  "oldlace": [253, 245, 230, 1],
  "olive": [128, 128, 0, 1],
  "olivedrab": [107, 142, 35, 1],
  "orange": [255, 165, 0, 1],
  "orangered": [255, 69, 0, 1],
  "orchid": [218, 112, 214, 1],
  "palegoldenrod": [238, 232, 170, 1],
  "palegreen": [152, 251, 152, 1],
  "paleturquoise": [175, 238, 238, 1],
  "palevioletred": [219, 112, 147, 1],
  "papayawhip": [255, 239, 213, 1],
  "peachpuff": [255, 218, 185, 1],
  "peru": [205, 133, 63, 1],
  "pink": [255, 192, 203, 1],
  "plum": [221, 160, 221, 1],
  "powderblue": [176, 224, 230, 1],
  "purple": [128, 0, 128, 1],
  "red": [255, 0, 0, 1],
  "rosybrown": [188, 143, 143, 1],
  "royalblue": [65, 105, 225, 1],
  "saddlebrown": [139, 69, 19, 1],
  "salmon": [250, 128, 114, 1],
  "sandybrown": [244, 164, 96, 1],
  "seagreen": [46, 139, 87, 1],
  "seashell": [255, 245, 238, 1],
  "sienna": [160, 82, 45, 1],
  "silver": [192, 192, 192, 1],
  "skyblue": [135, 206, 235, 1],
  "slateblue": [106, 90, 205, 1],
  "slategray": [112, 128, 144, 1],
  "slategrey": [112, 128, 144, 1],
  "snow": [255, 250, 250, 1],
  "springgreen": [0, 255, 127, 1],
  "steelblue": [70, 130, 180, 1],
  "tan": [210, 180, 140, 1],
  "teal": [0, 128, 128, 1],
  "thistle": [216, 191, 216, 1],
  "tomato": [255, 99, 71, 1],
  "turquoise": [64, 224, 208, 1],
  "violet": [238, 130, 238, 1],
  "wheat": [245, 222, 179, 1],
  "white": [255, 255, 255, 1],
  "whitesmoke": [245, 245, 245, 1],
  "yellow": [255, 255, 0, 1],
  "yellowgreen": [154, 205, 50, 1]
};
function clampCssByte(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 255 ? 255 : i;
}
function clampCssAngle(i) {
  i = Math.round(i);
  return i < 0 ? 0 : i > 360 ? 360 : i;
}
function clampCssFloat(f2) {
  return f2 < 0 ? 0 : f2 > 1 ? 1 : f2;
}
function parseCssInt(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssByte(parseFloat(str) / 100 * 255);
  }
  return clampCssByte(parseInt(str, 10));
}
function parseCssFloat(val) {
  var str = val;
  if (str.length && str.charAt(str.length - 1) === "%") {
    return clampCssFloat(parseFloat(str) / 100);
  }
  return clampCssFloat(parseFloat(str));
}
function cssHueToRgb(m1, m2, h) {
  if (h < 0) {
    h += 1;
  } else if (h > 1) {
    h -= 1;
  }
  if (h * 6 < 1) {
    return m1 + (m2 - m1) * h * 6;
  }
  if (h * 2 < 1) {
    return m2;
  }
  if (h * 3 < 2) {
    return m1 + (m2 - m1) * (2 / 3 - h) * 6;
  }
  return m1;
}
function lerpNumber(a, b2, p2) {
  return a + (b2 - a) * p2;
}
function setRgba(out2, r2, g2, b2, a) {
  out2[0] = r2;
  out2[1] = g2;
  out2[2] = b2;
  out2[3] = a;
  return out2;
}
function copyRgba(out2, a) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  return out2;
}
var colorCache = new LRU$1(20);
var lastRemovedArr = null;
function putToCache(colorStr, rgbaArr) {
  if (lastRemovedArr) {
    copyRgba(lastRemovedArr, rgbaArr);
  }
  lastRemovedArr = colorCache.put(colorStr, lastRemovedArr || rgbaArr.slice());
}
function parse(colorStr, rgbaArr) {
  if (!colorStr) {
    return;
  }
  rgbaArr = rgbaArr || [];
  var cached = colorCache.get(colorStr);
  if (cached) {
    return copyRgba(rgbaArr, cached);
  }
  colorStr = colorStr + "";
  var str = colorStr.replace(/ /g, "").toLowerCase();
  if (str in kCSSColorTable) {
    copyRgba(rgbaArr, kCSSColorTable[str]);
    putToCache(colorStr, rgbaArr);
    return rgbaArr;
  }
  var strLen = str.length;
  if (str.charAt(0) === "#") {
    if (strLen === 4 || strLen === 5) {
      var iv = parseInt(str.slice(1, 4), 16);
      if (!(iv >= 0 && iv <= 4095)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 3840) >> 4 | (iv & 3840) >> 8, iv & 240 | (iv & 240) >> 4, iv & 15 | (iv & 15) << 4, strLen === 5 ? parseInt(str.slice(4), 16) / 15 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    } else if (strLen === 7 || strLen === 9) {
      var iv = parseInt(str.slice(1, 7), 16);
      if (!(iv >= 0 && iv <= 16777215)) {
        setRgba(rgbaArr, 0, 0, 0, 1);
        return;
      }
      setRgba(rgbaArr, (iv & 16711680) >> 16, (iv & 65280) >> 8, iv & 255, strLen === 9 ? parseInt(str.slice(7), 16) / 255 : 1);
      putToCache(colorStr, rgbaArr);
      return rgbaArr;
    }
    return;
  }
  var op = str.indexOf("(");
  var ep = str.indexOf(")");
  if (op !== -1 && ep + 1 === strLen) {
    var fname = str.substr(0, op);
    var params = str.substr(op + 1, ep - (op + 1)).split(",");
    var alpha = 1;
    switch (fname) {
      case "rgba":
        if (params.length !== 4) {
          return params.length === 3 ? setRgba(rgbaArr, +params[0], +params[1], +params[2], 1) : setRgba(rgbaArr, 0, 0, 0, 1);
        }
        alpha = parseCssFloat(params.pop());
      case "rgb":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        setRgba(rgbaArr, parseCssInt(params[0]), parseCssInt(params[1]), parseCssInt(params[2]), alpha);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsla":
        if (params.length !== 4) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        params[3] = parseCssFloat(params[3]);
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      case "hsl":
        if (params.length !== 3) {
          setRgba(rgbaArr, 0, 0, 0, 1);
          return;
        }
        hsla2rgba(params, rgbaArr);
        putToCache(colorStr, rgbaArr);
        return rgbaArr;
      default:
        return;
    }
  }
  setRgba(rgbaArr, 0, 0, 0, 1);
  return;
}
function hsla2rgba(hsla, rgba) {
  var h = (parseFloat(hsla[0]) % 360 + 360) % 360 / 360;
  var s = parseCssFloat(hsla[1]);
  var l2 = parseCssFloat(hsla[2]);
  var m2 = l2 <= 0.5 ? l2 * (s + 1) : l2 + s - l2 * s;
  var m1 = l2 * 2 - m2;
  rgba = rgba || [];
  setRgba(rgba, clampCssByte(cssHueToRgb(m1, m2, h + 1 / 3) * 255), clampCssByte(cssHueToRgb(m1, m2, h) * 255), clampCssByte(cssHueToRgb(m1, m2, h - 1 / 3) * 255), 1);
  if (hsla.length === 4) {
    rgba[3] = hsla[3];
  }
  return rgba;
}
function rgba2hsla(rgba) {
  if (!rgba) {
    return;
  }
  var R = rgba[0] / 255;
  var G = rgba[1] / 255;
  var B = rgba[2] / 255;
  var vMin = Math.min(R, G, B);
  var vMax = Math.max(R, G, B);
  var delta = vMax - vMin;
  var L = (vMax + vMin) / 2;
  var H;
  var S;
  if (delta === 0) {
    H = 0;
    S = 0;
  } else {
    if (L < 0.5) {
      S = delta / (vMax + vMin);
    } else {
      S = delta / (2 - vMax - vMin);
    }
    var deltaR = ((vMax - R) / 6 + delta / 2) / delta;
    var deltaG = ((vMax - G) / 6 + delta / 2) / delta;
    var deltaB = ((vMax - B) / 6 + delta / 2) / delta;
    if (R === vMax) {
      H = deltaB - deltaG;
    } else if (G === vMax) {
      H = 1 / 3 + deltaR - deltaB;
    } else if (B === vMax) {
      H = 2 / 3 + deltaG - deltaR;
    }
    if (H < 0) {
      H += 1;
    }
    if (H > 1) {
      H -= 1;
    }
  }
  var hsla = [H * 360, S, L];
  if (rgba[3] != null) {
    hsla.push(rgba[3]);
  }
  return hsla;
}
function lift(color, level) {
  var colorArr = parse(color);
  if (colorArr) {
    for (var i = 0; i < 3; i++) {
      if (level < 0) {
        colorArr[i] = colorArr[i] * (1 - level) | 0;
      } else {
        colorArr[i] = (255 - colorArr[i]) * level + colorArr[i] | 0;
      }
      if (colorArr[i] > 255) {
        colorArr[i] = 255;
      } else if (colorArr[i] < 0) {
        colorArr[i] = 0;
      }
    }
    return stringify(colorArr, colorArr.length === 4 ? "rgba" : "rgb");
  }
}
function fastLerp(normalizedValue, colors, out2) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  out2 = out2 || [];
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = colors[leftIndex];
  var rightColor = colors[rightIndex];
  var dv = value - leftIndex;
  out2[0] = clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv));
  out2[1] = clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv));
  out2[2] = clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv));
  out2[3] = clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv));
  return out2;
}
function lerp(normalizedValue, colors, fullOutput) {
  if (!(colors && colors.length) || !(normalizedValue >= 0 && normalizedValue <= 1)) {
    return;
  }
  var value = normalizedValue * (colors.length - 1);
  var leftIndex = Math.floor(value);
  var rightIndex = Math.ceil(value);
  var leftColor = parse(colors[leftIndex]);
  var rightColor = parse(colors[rightIndex]);
  var dv = value - leftIndex;
  var color = stringify([
    clampCssByte(lerpNumber(leftColor[0], rightColor[0], dv)),
    clampCssByte(lerpNumber(leftColor[1], rightColor[1], dv)),
    clampCssByte(lerpNumber(leftColor[2], rightColor[2], dv)),
    clampCssFloat(lerpNumber(leftColor[3], rightColor[3], dv))
  ], "rgba");
  return fullOutput ? {
    color,
    leftIndex,
    rightIndex,
    value
  } : color;
}
function modifyHSL(color, h, s, l2) {
  var colorArr = parse(color);
  if (color) {
    colorArr = rgba2hsla(colorArr);
    h != null && (colorArr[0] = clampCssAngle(h));
    s != null && (colorArr[1] = parseCssFloat(s));
    l2 != null && (colorArr[2] = parseCssFloat(l2));
    return stringify(hsla2rgba(colorArr), "rgba");
  }
}
function modifyAlpha(color, alpha) {
  var colorArr = parse(color);
  if (colorArr && alpha != null) {
    colorArr[3] = clampCssFloat(alpha);
    return stringify(colorArr, "rgba");
  }
}
function stringify(arrColor, type4) {
  if (!arrColor || !arrColor.length) {
    return;
  }
  var colorStr = arrColor[0] + "," + arrColor[1] + "," + arrColor[2];
  if (type4 === "rgba" || type4 === "hsva" || type4 === "hsla") {
    colorStr += "," + arrColor[3];
  }
  return type4 + "(" + colorStr + ")";
}
function lum(color, backgroundLum) {
  var arr = parse(color);
  return arr ? (0.299 * arr[0] + 0.587 * arr[1] + 0.114 * arr[2]) * arr[3] / 255 + (1 - arr[3]) * backgroundLum : 0;
}
var mathRound$1 = Math.round;
function normalizeColor(color) {
  var opacity;
  if (!color || color === "transparent") {
    color = "none";
  } else if (typeof color === "string" && color.indexOf("rgba") > -1) {
    var arr = parse(color);
    if (arr) {
      color = "rgb(" + arr[0] + "," + arr[1] + "," + arr[2] + ")";
      opacity = arr[3];
    }
  }
  return {
    color,
    opacity: opacity == null ? 1 : opacity
  };
}
var EPSILON$3 = 1e-4;
function isAroundZero(transform2) {
  return transform2 < EPSILON$3 && transform2 > -EPSILON$3;
}
function round3(transform2) {
  return mathRound$1(transform2 * 1e3) / 1e3;
}
function round4(transform2) {
  return mathRound$1(transform2 * 1e4) / 1e4;
}
function getMatrixStr(m2) {
  return "matrix(" + round3(m2[0]) + "," + round3(m2[1]) + "," + round3(m2[2]) + "," + round3(m2[3]) + "," + round4(m2[4]) + "," + round4(m2[5]) + ")";
}
var TEXT_ALIGN_TO_ANCHOR = {
  left: "start",
  right: "end",
  center: "middle",
  middle: "middle"
};
function adjustTextY$1(y2, lineHeight, textBaseline) {
  if (textBaseline === "top") {
    y2 += lineHeight / 2;
  } else if (textBaseline === "bottom") {
    y2 -= lineHeight / 2;
  }
  return y2;
}
function hasShadow(style) {
  return style && (style.shadowBlur || style.shadowOffsetX || style.shadowOffsetY);
}
function getShadowKey(displayable) {
  var style = displayable.style;
  var globalScale = displayable.getGlobalScale();
  return [
    style.shadowColor,
    (style.shadowBlur || 0).toFixed(2),
    (style.shadowOffsetX || 0).toFixed(2),
    (style.shadowOffsetY || 0).toFixed(2),
    globalScale[0],
    globalScale[1]
  ].join(",");
}
function isImagePattern(val) {
  return val && !!val.image;
}
function isSVGPattern(val) {
  return val && !!val.svgElement;
}
function isPattern(val) {
  return isImagePattern(val) || isSVGPattern(val);
}
function isLinearGradient(val) {
  return val.type === "linear";
}
function isRadialGradient(val) {
  return val.type === "radial";
}
function isGradient(val) {
  return val && (val.type === "linear" || val.type === "radial");
}
function getIdURL(id2) {
  return "url(#" + id2 + ")";
}
function getPathPrecision(el) {
  var scale2 = el.getGlobalScale();
  var size = Math.max(scale2[0], scale2[1]);
  return Math.max(Math.ceil(Math.log(size) / Math.log(10)), 1);
}
function getSRTTransformString(transform2) {
  var x2 = transform2.x || 0;
  var y2 = transform2.y || 0;
  var rotation = (transform2.rotation || 0) * RADIAN_TO_DEGREE;
  var scaleX = retrieve2(transform2.scaleX, 1);
  var scaleY = retrieve2(transform2.scaleY, 1);
  var skewX = transform2.skewX || 0;
  var skewY = transform2.skewY || 0;
  var res = [];
  if (x2 || y2) {
    res.push("translate(" + x2 + "px," + y2 + "px)");
  }
  if (rotation) {
    res.push("rotate(" + rotation + ")");
  }
  if (scaleX !== 1 || scaleY !== 1) {
    res.push("scale(" + scaleX + "," + scaleY + ")");
  }
  if (skewX || skewY) {
    res.push("skew(" + mathRound$1(skewX * RADIAN_TO_DEGREE) + "deg, " + mathRound$1(skewY * RADIAN_TO_DEGREE) + "deg)");
  }
  return res.join(" ");
}
var encodeBase64 = function() {
  if (env$1.hasGlobalWindow && isFunction(window.btoa)) {
    return function(str) {
      return window.btoa(unescape(str));
    };
  }
  if (typeof Buffer !== "undefined") {
    return function(str) {
      return Buffer.from(str).toString("base64");
    };
  }
  return function(str) {
    return null;
  };
}();
var arraySlice = Array.prototype.slice;
function interpolateNumber$1(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
function interpolate1DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = interpolateNumber$1(p0[i], p1[i], percent);
  }
  return out2;
}
function interpolate2DArray(out2, p0, p1, percent) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = interpolateNumber$1(p0[i][j], p1[i][j], percent);
    }
  }
  return out2;
}
function add1DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  for (var i = 0; i < len2; i++) {
    out2[i] = p0[i] + p1[i] * sign;
  }
  return out2;
}
function add2DArray(out2, p0, p1, sign) {
  var len2 = p0.length;
  var len22 = len2 && p0[0].length;
  for (var i = 0; i < len2; i++) {
    if (!out2[i]) {
      out2[i] = [];
    }
    for (var j = 0; j < len22; j++) {
      out2[i][j] = p0[i][j] + p1[i][j] * sign;
    }
  }
  return out2;
}
function fillColorStops(val0, val1) {
  var len0 = val0.length;
  var len1 = val1.length;
  var shorterArr = len0 > len1 ? val1 : val0;
  var shorterLen = Math.min(len0, len1);
  var last = shorterArr[shorterLen - 1] || { color: [0, 0, 0, 0], offset: 0 };
  for (var i = shorterLen; i < Math.max(len0, len1); i++) {
    shorterArr.push({
      offset: last.offset,
      color: last.color.slice()
    });
  }
}
function fillArray(val0, val1, arrDim) {
  var arr0 = val0;
  var arr1 = val1;
  if (!arr0.push || !arr1.push) {
    return;
  }
  var arr0Len = arr0.length;
  var arr1Len = arr1.length;
  if (arr0Len !== arr1Len) {
    var isPreviousLarger = arr0Len > arr1Len;
    if (isPreviousLarger) {
      arr0.length = arr1Len;
    } else {
      for (var i = arr0Len; i < arr1Len; i++) {
        arr0.push(arrDim === 1 ? arr1[i] : arraySlice.call(arr1[i]));
      }
    }
  }
  var len2 = arr0[0] && arr0[0].length;
  for (var i = 0; i < arr0.length; i++) {
    if (arrDim === 1) {
      if (isNaN(arr0[i])) {
        arr0[i] = arr1[i];
      }
    } else {
      for (var j = 0; j < len2; j++) {
        if (isNaN(arr0[i][j])) {
          arr0[i][j] = arr1[i][j];
        }
      }
    }
  }
}
function cloneValue(value) {
  if (isArrayLike(value)) {
    var len2 = value.length;
    if (isArrayLike(value[0])) {
      var ret = [];
      for (var i = 0; i < len2; i++) {
        ret.push(arraySlice.call(value[i]));
      }
      return ret;
    }
    return arraySlice.call(value);
  }
  return value;
}
function rgba2String(rgba) {
  rgba[0] = Math.floor(rgba[0]) || 0;
  rgba[1] = Math.floor(rgba[1]) || 0;
  rgba[2] = Math.floor(rgba[2]) || 0;
  rgba[3] = rgba[3] == null ? 1 : rgba[3];
  return "rgba(" + rgba.join(",") + ")";
}
function guessArrayDim(value) {
  return isArrayLike(value && value[0]) ? 2 : 1;
}
var VALUE_TYPE_NUMBER = 0;
var VALUE_TYPE_1D_ARRAY = 1;
var VALUE_TYPE_2D_ARRAY = 2;
var VALUE_TYPE_COLOR = 3;
var VALUE_TYPE_LINEAR_GRADIENT = 4;
var VALUE_TYPE_RADIAL_GRADIENT = 5;
var VALUE_TYPE_UNKOWN = 6;
function isGradientValueType(valType) {
  return valType === VALUE_TYPE_LINEAR_GRADIENT || valType === VALUE_TYPE_RADIAL_GRADIENT;
}
function isArrayValueType(valType) {
  return valType === VALUE_TYPE_1D_ARRAY || valType === VALUE_TYPE_2D_ARRAY;
}
var tmpRgba = [0, 0, 0, 0];
var Track = function() {
  function Track2(propName) {
    this.keyframes = [];
    this.discrete = false;
    this._invalid = false;
    this._needsSort = false;
    this._lastFr = 0;
    this._lastFrP = 0;
    this.propName = propName;
  }
  Track2.prototype.isFinished = function() {
    return this._finished;
  };
  Track2.prototype.setFinished = function() {
    this._finished = true;
    if (this._additiveTrack) {
      this._additiveTrack.setFinished();
    }
  };
  Track2.prototype.needsAnimate = function() {
    return this.keyframes.length >= 1;
  };
  Track2.prototype.getAdditiveTrack = function() {
    return this._additiveTrack;
  };
  Track2.prototype.addKeyframe = function(time, rawValue, easing) {
    this._needsSort = true;
    var keyframes = this.keyframes;
    var len2 = keyframes.length;
    var discrete = false;
    var valType = VALUE_TYPE_UNKOWN;
    var value = rawValue;
    if (isArrayLike(rawValue)) {
      var arrayDim = guessArrayDim(rawValue);
      valType = arrayDim;
      if (arrayDim === 1 && !isNumber(rawValue[0]) || arrayDim === 2 && !isNumber(rawValue[0][0])) {
        discrete = true;
      }
    } else {
      if (isNumber(rawValue) && !eqNaN(rawValue)) {
        valType = VALUE_TYPE_NUMBER;
      } else if (isString(rawValue)) {
        if (!isNaN(+rawValue)) {
          valType = VALUE_TYPE_NUMBER;
        } else {
          var colorArray = parse(rawValue);
          if (colorArray) {
            value = colorArray;
            valType = VALUE_TYPE_COLOR;
          }
        }
      } else if (isGradientObject(rawValue)) {
        var parsedGradient = extend({}, value);
        parsedGradient.colorStops = map$1(rawValue.colorStops, function(colorStop) {
          return {
            offset: colorStop.offset,
            color: parse(colorStop.color)
          };
        });
        if (isLinearGradient(rawValue)) {
          valType = VALUE_TYPE_LINEAR_GRADIENT;
        } else if (isRadialGradient(rawValue)) {
          valType = VALUE_TYPE_RADIAL_GRADIENT;
        }
        value = parsedGradient;
      }
    }
    if (len2 === 0) {
      this.valType = valType;
    } else if (valType !== this.valType || valType === VALUE_TYPE_UNKOWN) {
      discrete = true;
    }
    this.discrete = this.discrete || discrete;
    var kf = {
      time,
      value,
      rawValue,
      percent: 0
    };
    if (easing) {
      kf.easing = easing;
      kf.easingFunc = isFunction(easing) ? easing : easingFuncs$1[easing] || createCubicEasingFunc(easing);
    }
    keyframes.push(kf);
    return kf;
  };
  Track2.prototype.prepare = function(maxTime, additiveTrack) {
    var kfs = this.keyframes;
    if (this._needsSort) {
      kfs.sort(function(a, b2) {
        return a.time - b2.time;
      });
    }
    var valType = this.valType;
    var kfsLen = kfs.length;
    var lastKf = kfs[kfsLen - 1];
    var isDiscrete = this.discrete;
    var isArr = isArrayValueType(valType);
    var isGradient2 = isGradientValueType(valType);
    for (var i = 0; i < kfsLen; i++) {
      var kf = kfs[i];
      var value = kf.value;
      var lastValue = lastKf.value;
      kf.percent = kf.time / maxTime;
      if (!isDiscrete) {
        if (isArr && i !== kfsLen - 1) {
          fillArray(value, lastValue, valType);
        } else if (isGradient2) {
          fillColorStops(value.colorStops, lastValue.colorStops);
        }
      }
    }
    if (!isDiscrete && valType !== VALUE_TYPE_RADIAL_GRADIENT && additiveTrack && this.needsAnimate() && additiveTrack.needsAnimate() && valType === additiveTrack.valType && !additiveTrack._finished) {
      this._additiveTrack = additiveTrack;
      var startValue = kfs[0].value;
      for (var i = 0; i < kfsLen; i++) {
        if (valType === VALUE_TYPE_NUMBER) {
          kfs[i].additiveValue = kfs[i].value - startValue;
        } else if (valType === VALUE_TYPE_COLOR) {
          kfs[i].additiveValue = add1DArray([], kfs[i].value, startValue, -1);
        } else if (isArrayValueType(valType)) {
          kfs[i].additiveValue = valType === VALUE_TYPE_1D_ARRAY ? add1DArray([], kfs[i].value, startValue, -1) : add2DArray([], kfs[i].value, startValue, -1);
        }
      }
    }
  };
  Track2.prototype.step = function(target, percent) {
    if (this._finished) {
      return;
    }
    if (this._additiveTrack && this._additiveTrack._finished) {
      this._additiveTrack = null;
    }
    var isAdditive = this._additiveTrack != null;
    var valueKey = isAdditive ? "additiveValue" : "value";
    var valType = this.valType;
    var keyframes = this.keyframes;
    var kfsNum = keyframes.length;
    var propName = this.propName;
    var isValueColor = valType === VALUE_TYPE_COLOR;
    var frameIdx;
    var lastFrame = this._lastFr;
    var mathMin2 = Math.min;
    var frame;
    var nextFrame;
    if (kfsNum === 1) {
      frame = nextFrame = keyframes[0];
    } else {
      if (percent < 0) {
        frameIdx = 0;
      } else if (percent < this._lastFrP) {
        var start2 = mathMin2(lastFrame + 1, kfsNum - 1);
        for (frameIdx = start2; frameIdx >= 0; frameIdx--) {
          if (keyframes[frameIdx].percent <= percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx, kfsNum - 2);
      } else {
        for (frameIdx = lastFrame; frameIdx < kfsNum; frameIdx++) {
          if (keyframes[frameIdx].percent > percent) {
            break;
          }
        }
        frameIdx = mathMin2(frameIdx - 1, kfsNum - 2);
      }
      nextFrame = keyframes[frameIdx + 1];
      frame = keyframes[frameIdx];
    }
    if (!(frame && nextFrame)) {
      return;
    }
    this._lastFr = frameIdx;
    this._lastFrP = percent;
    var interval = nextFrame.percent - frame.percent;
    var w2 = interval === 0 ? 1 : mathMin2((percent - frame.percent) / interval, 1);
    if (nextFrame.easingFunc) {
      w2 = nextFrame.easingFunc(w2);
    }
    var targetArr = isAdditive ? this._additiveValue : isValueColor ? tmpRgba : target[propName];
    if ((isArrayValueType(valType) || isValueColor) && !targetArr) {
      targetArr = this._additiveValue = [];
    }
    if (this.discrete) {
      target[propName] = w2 < 1 ? frame.rawValue : nextFrame.rawValue;
    } else if (isArrayValueType(valType)) {
      valType === VALUE_TYPE_1D_ARRAY ? interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2) : interpolate2DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
    } else if (isGradientValueType(valType)) {
      var val = frame[valueKey];
      var nextVal_1 = nextFrame[valueKey];
      var isLinearGradient_1 = valType === VALUE_TYPE_LINEAR_GRADIENT;
      target[propName] = {
        type: isLinearGradient_1 ? "linear" : "radial",
        x: interpolateNumber$1(val.x, nextVal_1.x, w2),
        y: interpolateNumber$1(val.y, nextVal_1.y, w2),
        colorStops: map$1(val.colorStops, function(colorStop, idx) {
          var nextColorStop = nextVal_1.colorStops[idx];
          return {
            offset: interpolateNumber$1(colorStop.offset, nextColorStop.offset, w2),
            color: rgba2String(interpolate1DArray([], colorStop.color, nextColorStop.color, w2))
          };
        }),
        global: nextVal_1.global
      };
      if (isLinearGradient_1) {
        target[propName].x2 = interpolateNumber$1(val.x2, nextVal_1.x2, w2);
        target[propName].y2 = interpolateNumber$1(val.y2, nextVal_1.y2, w2);
      } else {
        target[propName].r = interpolateNumber$1(val.r, nextVal_1.r, w2);
      }
    } else if (isValueColor) {
      interpolate1DArray(targetArr, frame[valueKey], nextFrame[valueKey], w2);
      if (!isAdditive) {
        target[propName] = rgba2String(targetArr);
      }
    } else {
      var value = interpolateNumber$1(frame[valueKey], nextFrame[valueKey], w2);
      if (isAdditive) {
        this._additiveValue = value;
      } else {
        target[propName] = value;
      }
    }
    if (isAdditive) {
      this._addToTarget(target);
    }
  };
  Track2.prototype._addToTarget = function(target) {
    var valType = this.valType;
    var propName = this.propName;
    var additiveValue = this._additiveValue;
    if (valType === VALUE_TYPE_NUMBER) {
      target[propName] = target[propName] + additiveValue;
    } else if (valType === VALUE_TYPE_COLOR) {
      parse(target[propName], tmpRgba);
      add1DArray(tmpRgba, tmpRgba, additiveValue, 1);
      target[propName] = rgba2String(tmpRgba);
    } else if (valType === VALUE_TYPE_1D_ARRAY) {
      add1DArray(target[propName], target[propName], additiveValue, 1);
    } else if (valType === VALUE_TYPE_2D_ARRAY) {
      add2DArray(target[propName], target[propName], additiveValue, 1);
    }
  };
  return Track2;
}();
var Animator = function() {
  function Animator2(target, loop, allowDiscreteAnimation, additiveTo) {
    this._tracks = {};
    this._trackKeys = [];
    this._maxTime = 0;
    this._started = 0;
    this._clip = null;
    this._target = target;
    this._loop = loop;
    if (loop && additiveTo) {
      logError("Can' use additive animation on looped animation.");
      return;
    }
    this._additiveAnimators = additiveTo;
    this._allowDiscrete = allowDiscreteAnimation;
  }
  Animator2.prototype.getMaxTime = function() {
    return this._maxTime;
  };
  Animator2.prototype.getDelay = function() {
    return this._delay;
  };
  Animator2.prototype.getLoop = function() {
    return this._loop;
  };
  Animator2.prototype.getTarget = function() {
    return this._target;
  };
  Animator2.prototype.changeTarget = function(target) {
    this._target = target;
  };
  Animator2.prototype.when = function(time, props, easing) {
    return this.whenWithKeys(time, props, keys(props), easing);
  };
  Animator2.prototype.whenWithKeys = function(time, props, propNames, easing) {
    var tracks = this._tracks;
    for (var i = 0; i < propNames.length; i++) {
      var propName = propNames[i];
      var track = tracks[propName];
      if (!track) {
        track = tracks[propName] = new Track(propName);
        var initialValue = void 0;
        var additiveTrack = this._getAdditiveTrack(propName);
        if (additiveTrack) {
          var addtiveTrackKfs = additiveTrack.keyframes;
          var lastFinalKf = addtiveTrackKfs[addtiveTrackKfs.length - 1];
          initialValue = lastFinalKf && lastFinalKf.value;
          if (additiveTrack.valType === VALUE_TYPE_COLOR && initialValue) {
            initialValue = rgba2String(initialValue);
          }
        } else {
          initialValue = this._target[propName];
        }
        if (initialValue == null) {
          continue;
        }
        if (time > 0) {
          track.addKeyframe(0, cloneValue(initialValue), easing);
        }
        this._trackKeys.push(propName);
      }
      track.addKeyframe(time, cloneValue(props[propName]), easing);
    }
    this._maxTime = Math.max(this._maxTime, time);
    return this;
  };
  Animator2.prototype.pause = function() {
    this._clip.pause();
    this._paused = true;
  };
  Animator2.prototype.resume = function() {
    this._clip.resume();
    this._paused = false;
  };
  Animator2.prototype.isPaused = function() {
    return !!this._paused;
  };
  Animator2.prototype.duration = function(duration) {
    this._maxTime = duration;
    this._force = true;
    return this;
  };
  Animator2.prototype._doneCallback = function() {
    this._setTracksFinished();
    this._clip = null;
    var doneList = this._doneCbs;
    if (doneList) {
      var len2 = doneList.length;
      for (var i = 0; i < len2; i++) {
        doneList[i].call(this);
      }
    }
  };
  Animator2.prototype._abortedCallback = function() {
    this._setTracksFinished();
    var animation = this.animation;
    var abortedList = this._abortedCbs;
    if (animation) {
      animation.removeClip(this._clip);
    }
    this._clip = null;
    if (abortedList) {
      for (var i = 0; i < abortedList.length; i++) {
        abortedList[i].call(this);
      }
    }
  };
  Animator2.prototype._setTracksFinished = function() {
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < tracksKeys.length; i++) {
      tracks[tracksKeys[i]].setFinished();
    }
  };
  Animator2.prototype._getAdditiveTrack = function(trackName) {
    var additiveTrack;
    var additiveAnimators = this._additiveAnimators;
    if (additiveAnimators) {
      for (var i = 0; i < additiveAnimators.length; i++) {
        var track = additiveAnimators[i].getTrack(trackName);
        if (track) {
          additiveTrack = track;
        }
      }
    }
    return additiveTrack;
  };
  Animator2.prototype.start = function(easing) {
    if (this._started > 0) {
      return;
    }
    this._started = 1;
    var self2 = this;
    var tracks = [];
    var maxTime = this._maxTime || 0;
    for (var i = 0; i < this._trackKeys.length; i++) {
      var propName = this._trackKeys[i];
      var track = this._tracks[propName];
      var additiveTrack = this._getAdditiveTrack(propName);
      var kfs = track.keyframes;
      var kfsNum = kfs.length;
      track.prepare(maxTime, additiveTrack);
      if (track.needsAnimate()) {
        if (!this._allowDiscrete && track.discrete) {
          var lastKf = kfs[kfsNum - 1];
          if (lastKf) {
            self2._target[track.propName] = lastKf.rawValue;
          }
          track.setFinished();
        } else {
          tracks.push(track);
        }
      }
    }
    if (tracks.length || this._force) {
      var clip2 = new Clip$1({
        life: maxTime,
        loop: this._loop,
        delay: this._delay || 0,
        onframe: function(percent) {
          self2._started = 2;
          var additiveAnimators = self2._additiveAnimators;
          if (additiveAnimators) {
            var stillHasAdditiveAnimator = false;
            for (var i2 = 0; i2 < additiveAnimators.length; i2++) {
              if (additiveAnimators[i2]._clip) {
                stillHasAdditiveAnimator = true;
                break;
              }
            }
            if (!stillHasAdditiveAnimator) {
              self2._additiveAnimators = null;
            }
          }
          for (var i2 = 0; i2 < tracks.length; i2++) {
            tracks[i2].step(self2._target, percent);
          }
          var onframeList = self2._onframeCbs;
          if (onframeList) {
            for (var i2 = 0; i2 < onframeList.length; i2++) {
              onframeList[i2](self2._target, percent);
            }
          }
        },
        ondestroy: function() {
          self2._doneCallback();
        }
      });
      this._clip = clip2;
      if (this.animation) {
        this.animation.addClip(clip2);
      }
      if (easing) {
        clip2.setEasing(easing);
      }
    } else {
      this._doneCallback();
    }
    return this;
  };
  Animator2.prototype.stop = function(forwardToLast) {
    if (!this._clip) {
      return;
    }
    var clip2 = this._clip;
    if (forwardToLast) {
      clip2.onframe(1);
    }
    this._abortedCallback();
  };
  Animator2.prototype.delay = function(time) {
    this._delay = time;
    return this;
  };
  Animator2.prototype.during = function(cb) {
    if (cb) {
      if (!this._onframeCbs) {
        this._onframeCbs = [];
      }
      this._onframeCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.done = function(cb) {
    if (cb) {
      if (!this._doneCbs) {
        this._doneCbs = [];
      }
      this._doneCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.aborted = function(cb) {
    if (cb) {
      if (!this._abortedCbs) {
        this._abortedCbs = [];
      }
      this._abortedCbs.push(cb);
    }
    return this;
  };
  Animator2.prototype.getClip = function() {
    return this._clip;
  };
  Animator2.prototype.getTrack = function(propName) {
    return this._tracks[propName];
  };
  Animator2.prototype.getTracks = function() {
    var _this = this;
    return map$1(this._trackKeys, function(key) {
      return _this._tracks[key];
    });
  };
  Animator2.prototype.stopTracks = function(propNames, forwardToLast) {
    if (!propNames.length || !this._clip) {
      return true;
    }
    var tracks = this._tracks;
    var tracksKeys = this._trackKeys;
    for (var i = 0; i < propNames.length; i++) {
      var track = tracks[propNames[i]];
      if (track && !track.isFinished()) {
        if (forwardToLast) {
          track.step(this._target, 1);
        } else if (this._started === 1) {
          track.step(this._target, 0);
        }
        track.setFinished();
      }
    }
    var allAborted = true;
    for (var i = 0; i < tracksKeys.length; i++) {
      if (!tracks[tracksKeys[i]].isFinished()) {
        allAborted = false;
        break;
      }
    }
    if (allAborted) {
      this._abortedCallback();
    }
    return allAborted;
  };
  Animator2.prototype.saveTo = function(target, trackKeys, firstOrLast) {
    if (!target) {
      return;
    }
    trackKeys = trackKeys || this._trackKeys;
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track || track.isFinished()) {
        continue;
      }
      var kfs = track.keyframes;
      var kf = kfs[firstOrLast ? 0 : kfs.length - 1];
      if (kf) {
        target[propName] = cloneValue(kf.rawValue);
      }
    }
  };
  Animator2.prototype.__changeFinalValue = function(finalProps, trackKeys) {
    trackKeys = trackKeys || keys(finalProps);
    for (var i = 0; i < trackKeys.length; i++) {
      var propName = trackKeys[i];
      var track = this._tracks[propName];
      if (!track) {
        continue;
      }
      var kfs = track.keyframes;
      if (kfs.length > 1) {
        var lastKf = kfs.pop();
        track.addKeyframe(lastKf.time, finalProps[propName]);
        track.prepare(this._maxTime, track.getAdditiveTrack());
      }
    }
  };
  return Animator2;
}();
function getTime() {
  return new Date().getTime();
}
var Animation = function(_super) {
  __extends(Animation2, _super);
  function Animation2(opts) {
    var _this = _super.call(this) || this;
    _this._running = false;
    _this._time = 0;
    _this._pausedTime = 0;
    _this._pauseStart = 0;
    _this._paused = false;
    opts = opts || {};
    _this.stage = opts.stage || {};
    return _this;
  }
  Animation2.prototype.addClip = function(clip2) {
    if (clip2.animation) {
      this.removeClip(clip2);
    }
    if (!this._head) {
      this._head = this._tail = clip2;
    } else {
      this._tail.next = clip2;
      clip2.prev = this._tail;
      clip2.next = null;
      this._tail = clip2;
    }
    clip2.animation = this;
  };
  Animation2.prototype.addAnimator = function(animator) {
    animator.animation = this;
    var clip2 = animator.getClip();
    if (clip2) {
      this.addClip(clip2);
    }
  };
  Animation2.prototype.removeClip = function(clip2) {
    if (!clip2.animation) {
      return;
    }
    var prev = clip2.prev;
    var next = clip2.next;
    if (prev) {
      prev.next = next;
    } else {
      this._head = next;
    }
    if (next) {
      next.prev = prev;
    } else {
      this._tail = prev;
    }
    clip2.next = clip2.prev = clip2.animation = null;
  };
  Animation2.prototype.removeAnimator = function(animator) {
    var clip2 = animator.getClip();
    if (clip2) {
      this.removeClip(clip2);
    }
    animator.animation = null;
  };
  Animation2.prototype.update = function(notTriggerFrameAndStageUpdate) {
    var time = getTime() - this._pausedTime;
    var delta = time - this._time;
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      var finished = clip2.step(time, delta);
      if (finished) {
        clip2.ondestroy();
        this.removeClip(clip2);
        clip2 = nextClip;
      } else {
        clip2 = nextClip;
      }
    }
    this._time = time;
    if (!notTriggerFrameAndStageUpdate) {
      this.trigger("frame", delta);
      this.stage.update && this.stage.update();
    }
  };
  Animation2.prototype._startLoop = function() {
    var self2 = this;
    this._running = true;
    function step() {
      if (self2._running) {
        requestAnimationFrame$2(step);
        !self2._paused && self2.update();
      }
    }
    requestAnimationFrame$2(step);
  };
  Animation2.prototype.start = function() {
    if (this._running) {
      return;
    }
    this._time = getTime();
    this._pausedTime = 0;
    this._startLoop();
  };
  Animation2.prototype.stop = function() {
    this._running = false;
  };
  Animation2.prototype.pause = function() {
    if (!this._paused) {
      this._pauseStart = getTime();
      this._paused = true;
    }
  };
  Animation2.prototype.resume = function() {
    if (this._paused) {
      this._pausedTime += getTime() - this._pauseStart;
      this._paused = false;
    }
  };
  Animation2.prototype.clear = function() {
    var clip2 = this._head;
    while (clip2) {
      var nextClip = clip2.next;
      clip2.prev = clip2.next = clip2.animation = null;
      clip2 = nextClip;
    }
    this._head = this._tail = null;
  };
  Animation2.prototype.isFinished = function() {
    return this._head == null;
  };
  Animation2.prototype.animate = function(target, options) {
    options = options || {};
    this.start();
    var animator = new Animator(target, options.loop);
    this.addAnimator(animator);
    return animator;
  };
  return Animation2;
}(Eventful$1);
var Animation$1 = Animation;
var TOUCH_CLICK_DELAY = 300;
var globalEventSupported = env$1.domSupported;
var localNativeListenerNames = function() {
  var mouseHandlerNames = [
    "click",
    "dblclick",
    "mousewheel",
    "wheel",
    "mouseout",
    "mouseup",
    "mousedown",
    "mousemove",
    "contextmenu"
  ];
  var touchHandlerNames = [
    "touchstart",
    "touchend",
    "touchmove"
  ];
  var pointerEventNameMap = {
    pointerdown: 1,
    pointerup: 1,
    pointermove: 1,
    pointerout: 1
  };
  var pointerHandlerNames = map$1(mouseHandlerNames, function(name) {
    var nm = name.replace("mouse", "pointer");
    return pointerEventNameMap.hasOwnProperty(nm) ? nm : name;
  });
  return {
    mouse: mouseHandlerNames,
    touch: touchHandlerNames,
    pointer: pointerHandlerNames
  };
}();
var globalNativeListenerNames = {
  mouse: ["mousemove", "mouseup"],
  pointer: ["pointermove", "pointerup"]
};
var wheelEventSupported = false;
function isPointerFromTouch(event) {
  var pointerType = event.pointerType;
  return pointerType === "pen" || pointerType === "touch";
}
function setTouchTimer(scope) {
  scope.touching = true;
  if (scope.touchTimer != null) {
    clearTimeout(scope.touchTimer);
    scope.touchTimer = null;
  }
  scope.touchTimer = setTimeout(function() {
    scope.touching = false;
    scope.touchTimer = null;
  }, 700);
}
function markTouch(event) {
  event && (event.zrByTouch = true);
}
function normalizeGlobalEvent(instance, event) {
  return normalizeEvent(instance.dom, new FakeGlobalEvent(instance, event), true);
}
function isLocalEl(instance, el) {
  var elTmp = el;
  var isLocal = false;
  while (elTmp && elTmp.nodeType !== 9 && !(isLocal = elTmp.domBelongToZr || elTmp !== el && elTmp === instance.painterRoot)) {
    elTmp = elTmp.parentNode;
  }
  return isLocal;
}
var FakeGlobalEvent = function() {
  function FakeGlobalEvent2(instance, event) {
    this.stopPropagation = noop;
    this.stopImmediatePropagation = noop;
    this.preventDefault = noop;
    this.type = event.type;
    this.target = this.currentTarget = instance.dom;
    this.pointerType = event.pointerType;
    this.clientX = event.clientX;
    this.clientY = event.clientY;
  }
  return FakeGlobalEvent2;
}();
var localDOMHandlers = {
  mousedown: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__mayPointerCapture = [event.zrX, event.zrY];
    this.trigger("mousedown", event);
  },
  mousemove: function(event) {
    event = normalizeEvent(this.dom, event);
    var downPoint = this.__mayPointerCapture;
    if (downPoint && (event.zrX !== downPoint[0] || event.zrY !== downPoint[1])) {
      this.__togglePointerCapture(true);
    }
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    event = normalizeEvent(this.dom, event);
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
  },
  mouseout: function(event) {
    event = normalizeEvent(this.dom, event);
    var element = event.toElement || event.relatedTarget;
    if (!isLocalEl(this, element)) {
      if (this.__pointerCapturing) {
        event.zrEventControl = "no_globalout";
      }
      this.trigger("mouseout", event);
    }
  },
  wheel: function(event) {
    wheelEventSupported = true;
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  mousewheel: function(event) {
    if (wheelEventSupported) {
      return;
    }
    event = normalizeEvent(this.dom, event);
    this.trigger("mousewheel", event);
  },
  touchstart: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.__lastTouchMoment = new Date();
    this.handler.processGesture(event, "start");
    localDOMHandlers.mousemove.call(this, event);
    localDOMHandlers.mousedown.call(this, event);
  },
  touchmove: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "change");
    localDOMHandlers.mousemove.call(this, event);
  },
  touchend: function(event) {
    event = normalizeEvent(this.dom, event);
    markTouch(event);
    this.handler.processGesture(event, "end");
    localDOMHandlers.mouseup.call(this, event);
    if (+new Date() - +this.__lastTouchMoment < TOUCH_CLICK_DELAY) {
      localDOMHandlers.click.call(this, event);
    }
  },
  pointerdown: function(event) {
    localDOMHandlers.mousedown.call(this, event);
  },
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    localDOMHandlers.mouseup.call(this, event);
  },
  pointerout: function(event) {
    if (!isPointerFromTouch(event)) {
      localDOMHandlers.mouseout.call(this, event);
    }
  }
};
each$f(["click", "dblclick", "contextmenu"], function(name) {
  localDOMHandlers[name] = function(event) {
    event = normalizeEvent(this.dom, event);
    this.trigger(name, event);
  };
});
var globalDOMHandlers = {
  pointermove: function(event) {
    if (!isPointerFromTouch(event)) {
      globalDOMHandlers.mousemove.call(this, event);
    }
  },
  pointerup: function(event) {
    globalDOMHandlers.mouseup.call(this, event);
  },
  mousemove: function(event) {
    this.trigger("mousemove", event);
  },
  mouseup: function(event) {
    var pointerCaptureReleasing = this.__pointerCapturing;
    this.__togglePointerCapture(false);
    this.trigger("mouseup", event);
    if (pointerCaptureReleasing) {
      event.zrEventControl = "only_globalout";
      this.trigger("mouseout", event);
    }
  }
};
function mountLocalDOMEventListeners(instance, scope) {
  var domHandlers = scope.domHandlers;
  if (env$1.pointerEventsSupported) {
    each$f(localNativeListenerNames.pointer, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        domHandlers[nativeEventName].call(instance, event);
      });
    });
  } else {
    if (env$1.touchEventsSupported) {
      each$f(localNativeListenerNames.touch, function(nativeEventName) {
        mountSingleDOMEventListener(scope, nativeEventName, function(event) {
          domHandlers[nativeEventName].call(instance, event);
          setTouchTimer(scope);
        });
      });
    }
    each$f(localNativeListenerNames.mouse, function(nativeEventName) {
      mountSingleDOMEventListener(scope, nativeEventName, function(event) {
        event = getNativeEvent(event);
        if (!scope.touching) {
          domHandlers[nativeEventName].call(instance, event);
        }
      });
    });
  }
}
function mountGlobalDOMEventListeners(instance, scope) {
  if (env$1.pointerEventsSupported) {
    each$f(globalNativeListenerNames.pointer, mount);
  } else if (!env$1.touchEventsSupported) {
    each$f(globalNativeListenerNames.mouse, mount);
  }
  function mount(nativeEventName) {
    function nativeEventListener(event) {
      event = getNativeEvent(event);
      if (!isLocalEl(instance, event.target)) {
        event = normalizeGlobalEvent(instance, event);
        scope.domHandlers[nativeEventName].call(instance, event);
      }
    }
    mountSingleDOMEventListener(scope, nativeEventName, nativeEventListener, { capture: true });
  }
}
function mountSingleDOMEventListener(scope, nativeEventName, listener, opt) {
  scope.mounted[nativeEventName] = listener;
  scope.listenerOpts[nativeEventName] = opt;
  addEventListener(scope.domTarget, nativeEventName, listener, opt);
}
function unmountDOMEventListeners(scope) {
  var mounted = scope.mounted;
  for (var nativeEventName in mounted) {
    if (mounted.hasOwnProperty(nativeEventName)) {
      removeEventListener(scope.domTarget, nativeEventName, mounted[nativeEventName], scope.listenerOpts[nativeEventName]);
    }
  }
  scope.mounted = {};
}
var DOMHandlerScope = function() {
  function DOMHandlerScope2(domTarget, domHandlers) {
    this.mounted = {};
    this.listenerOpts = {};
    this.touching = false;
    this.domTarget = domTarget;
    this.domHandlers = domHandlers;
  }
  return DOMHandlerScope2;
}();
var HandlerDomProxy = function(_super) {
  __extends(HandlerDomProxy2, _super);
  function HandlerDomProxy2(dom, painterRoot) {
    var _this = _super.call(this) || this;
    _this.__pointerCapturing = false;
    _this.dom = dom;
    _this.painterRoot = painterRoot;
    _this._localHandlerScope = new DOMHandlerScope(dom, localDOMHandlers);
    if (globalEventSupported) {
      _this._globalHandlerScope = new DOMHandlerScope(document, globalDOMHandlers);
    }
    mountLocalDOMEventListeners(_this, _this._localHandlerScope);
    return _this;
  }
  HandlerDomProxy2.prototype.dispose = function() {
    unmountDOMEventListeners(this._localHandlerScope);
    if (globalEventSupported) {
      unmountDOMEventListeners(this._globalHandlerScope);
    }
  };
  HandlerDomProxy2.prototype.setCursor = function(cursorStyle) {
    this.dom.style && (this.dom.style.cursor = cursorStyle || "default");
  };
  HandlerDomProxy2.prototype.__togglePointerCapture = function(isPointerCapturing) {
    this.__mayPointerCapture = null;
    if (globalEventSupported && +this.__pointerCapturing ^ +isPointerCapturing) {
      this.__pointerCapturing = isPointerCapturing;
      var globalHandlerScope = this._globalHandlerScope;
      isPointerCapturing ? mountGlobalDOMEventListeners(this, globalHandlerScope) : unmountDOMEventListeners(globalHandlerScope);
    }
  };
  return HandlerDomProxy2;
}(Eventful$1);
var HandlerProxy = HandlerDomProxy;
var dpr = 1;
if (env$1.hasGlobalWindow) {
  dpr = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1);
}
var devicePixelRatio = dpr;
var DARK_MODE_THRESHOLD = 0.4;
var DARK_LABEL_COLOR = "#333";
var LIGHT_LABEL_COLOR = "#ccc";
var LIGHTER_LABEL_COLOR = "#eee";
function create$1() {
  return [1, 0, 0, 1, 0, 0];
}
function identity(out2) {
  out2[0] = 1;
  out2[1] = 0;
  out2[2] = 0;
  out2[3] = 1;
  out2[4] = 0;
  out2[5] = 0;
  return out2;
}
function copy(out2, m2) {
  out2[0] = m2[0];
  out2[1] = m2[1];
  out2[2] = m2[2];
  out2[3] = m2[3];
  out2[4] = m2[4];
  out2[5] = m2[5];
  return out2;
}
function mul(out2, m1, m2) {
  var out0 = m1[0] * m2[0] + m1[2] * m2[1];
  var out1 = m1[1] * m2[0] + m1[3] * m2[1];
  var out22 = m1[0] * m2[2] + m1[2] * m2[3];
  var out3 = m1[1] * m2[2] + m1[3] * m2[3];
  var out4 = m1[0] * m2[4] + m1[2] * m2[5] + m1[4];
  var out5 = m1[1] * m2[4] + m1[3] * m2[5] + m1[5];
  out2[0] = out0;
  out2[1] = out1;
  out2[2] = out22;
  out2[3] = out3;
  out2[4] = out4;
  out2[5] = out5;
  return out2;
}
function translate(out2, a, v4) {
  out2[0] = a[0];
  out2[1] = a[1];
  out2[2] = a[2];
  out2[3] = a[3];
  out2[4] = a[4] + v4[0];
  out2[5] = a[5] + v4[1];
  return out2;
}
function rotate(out2, a, rad) {
  var aa = a[0];
  var ac = a[2];
  var atx = a[4];
  var ab = a[1];
  var ad = a[3];
  var aty = a[5];
  var st = Math.sin(rad);
  var ct = Math.cos(rad);
  out2[0] = aa * ct + ab * st;
  out2[1] = -aa * st + ab * ct;
  out2[2] = ac * ct + ad * st;
  out2[3] = -ac * st + ct * ad;
  out2[4] = ct * atx + st * aty;
  out2[5] = ct * aty - st * atx;
  return out2;
}
function scale$1(out2, a, v4) {
  var vx = v4[0];
  var vy = v4[1];
  out2[0] = a[0] * vx;
  out2[1] = a[1] * vy;
  out2[2] = a[2] * vx;
  out2[3] = a[3] * vy;
  out2[4] = a[4] * vx;
  out2[5] = a[5] * vy;
  return out2;
}
function invert(out2, a) {
  var aa = a[0];
  var ac = a[2];
  var atx = a[4];
  var ab = a[1];
  var ad = a[3];
  var aty = a[5];
  var det = aa * ad - ab * ac;
  if (!det) {
    return null;
  }
  det = 1 / det;
  out2[0] = ad * det;
  out2[1] = -ab * det;
  out2[2] = -ac * det;
  out2[3] = aa * det;
  out2[4] = (ac * aty - ad * atx) * det;
  out2[5] = (ab * atx - aa * aty) * det;
  return out2;
}
function clone$2(a) {
  var b2 = create$1();
  copy(b2, a);
  return b2;
}
var mIdentity = identity;
var EPSILON$2 = 5e-5;
function isNotAroundZero(val) {
  return val > EPSILON$2 || val < -EPSILON$2;
}
var scaleTmp = [];
var tmpTransform = [];
var originTransform = create$1();
var abs = Math.abs;
var Transformable = function() {
  function Transformable2() {
  }
  Transformable2.prototype.getLocalTransform = function(m2) {
    return Transformable2.getLocalTransform(this, m2);
  };
  Transformable2.prototype.setPosition = function(arr) {
    this.x = arr[0];
    this.y = arr[1];
  };
  Transformable2.prototype.setScale = function(arr) {
    this.scaleX = arr[0];
    this.scaleY = arr[1];
  };
  Transformable2.prototype.setSkew = function(arr) {
    this.skewX = arr[0];
    this.skewY = arr[1];
  };
  Transformable2.prototype.setOrigin = function(arr) {
    this.originX = arr[0];
    this.originY = arr[1];
  };
  Transformable2.prototype.needLocalTransform = function() {
    return isNotAroundZero(this.rotation) || isNotAroundZero(this.x) || isNotAroundZero(this.y) || isNotAroundZero(this.scaleX - 1) || isNotAroundZero(this.scaleY - 1) || isNotAroundZero(this.skewX) || isNotAroundZero(this.skewY);
  };
  Transformable2.prototype.updateTransform = function() {
    var parentTransform = this.parent && this.parent.transform;
    var needLocalTransform = this.needLocalTransform();
    var m2 = this.transform;
    if (!(needLocalTransform || parentTransform)) {
      m2 && mIdentity(m2);
      return;
    }
    m2 = m2 || create$1();
    if (needLocalTransform) {
      this.getLocalTransform(m2);
    } else {
      mIdentity(m2);
    }
    if (parentTransform) {
      if (needLocalTransform) {
        mul(m2, parentTransform, m2);
      } else {
        copy(m2, parentTransform);
      }
    }
    this.transform = m2;
    this._resolveGlobalScaleRatio(m2);
  };
  Transformable2.prototype._resolveGlobalScaleRatio = function(m2) {
    var globalScaleRatio = this.globalScaleRatio;
    if (globalScaleRatio != null && globalScaleRatio !== 1) {
      this.getGlobalScale(scaleTmp);
      var relX = scaleTmp[0] < 0 ? -1 : 1;
      var relY = scaleTmp[1] < 0 ? -1 : 1;
      var sx = ((scaleTmp[0] - relX) * globalScaleRatio + relX) / scaleTmp[0] || 0;
      var sy = ((scaleTmp[1] - relY) * globalScaleRatio + relY) / scaleTmp[1] || 0;
      m2[0] *= sx;
      m2[1] *= sx;
      m2[2] *= sy;
      m2[3] *= sy;
    }
    this.invTransform = this.invTransform || create$1();
    invert(this.invTransform, m2);
  };
  Transformable2.prototype.getComputedTransform = function() {
    var transformNode = this;
    var ancestors = [];
    while (transformNode) {
      ancestors.push(transformNode);
      transformNode = transformNode.parent;
    }
    while (transformNode = ancestors.pop()) {
      transformNode.updateTransform();
    }
    return this.transform;
  };
  Transformable2.prototype.setLocalTransform = function(m2) {
    if (!m2) {
      return;
    }
    var sx = m2[0] * m2[0] + m2[1] * m2[1];
    var sy = m2[2] * m2[2] + m2[3] * m2[3];
    var rotation = Math.atan2(m2[1], m2[0]);
    var shearX = Math.PI / 2 + rotation - Math.atan2(m2[3], m2[2]);
    sy = Math.sqrt(sy) * Math.cos(shearX);
    sx = Math.sqrt(sx);
    this.skewX = shearX;
    this.skewY = 0;
    this.rotation = -rotation;
    this.x = +m2[4];
    this.y = +m2[5];
    this.scaleX = sx;
    this.scaleY = sy;
    this.originX = 0;
    this.originY = 0;
  };
  Transformable2.prototype.decomposeTransform = function() {
    if (!this.transform) {
      return;
    }
    var parent = this.parent;
    var m2 = this.transform;
    if (parent && parent.transform) {
      mul(tmpTransform, parent.invTransform, m2);
      m2 = tmpTransform;
    }
    var ox = this.originX;
    var oy = this.originY;
    if (ox || oy) {
      originTransform[4] = ox;
      originTransform[5] = oy;
      mul(tmpTransform, m2, originTransform);
      tmpTransform[4] -= ox;
      tmpTransform[5] -= oy;
      m2 = tmpTransform;
    }
    this.setLocalTransform(m2);
  };
  Transformable2.prototype.getGlobalScale = function(out2) {
    var m2 = this.transform;
    out2 = out2 || [];
    if (!m2) {
      out2[0] = 1;
      out2[1] = 1;
      return out2;
    }
    out2[0] = Math.sqrt(m2[0] * m2[0] + m2[1] * m2[1]);
    out2[1] = Math.sqrt(m2[2] * m2[2] + m2[3] * m2[3]);
    if (m2[0] < 0) {
      out2[0] = -out2[0];
    }
    if (m2[3] < 0) {
      out2[1] = -out2[1];
    }
    return out2;
  };
  Transformable2.prototype.transformCoordToLocal = function(x2, y2) {
    var v22 = [x2, y2];
    var invTransform = this.invTransform;
    if (invTransform) {
      applyTransform$1(v22, v22, invTransform);
    }
    return v22;
  };
  Transformable2.prototype.transformCoordToGlobal = function(x2, y2) {
    var v22 = [x2, y2];
    var transform2 = this.transform;
    if (transform2) {
      applyTransform$1(v22, v22, transform2);
    }
    return v22;
  };
  Transformable2.prototype.getLineScale = function() {
    var m2 = this.transform;
    return m2 && abs(m2[0] - 1) > 1e-10 && abs(m2[3] - 1) > 1e-10 ? Math.sqrt(abs(m2[0] * m2[3] - m2[2] * m2[1])) : 1;
  };
  Transformable2.prototype.copyTransform = function(source) {
    copyTransform(this, source);
  };
  Transformable2.getLocalTransform = function(target, m2) {
    m2 = m2 || [];
    var ox = target.originX || 0;
    var oy = target.originY || 0;
    var sx = target.scaleX;
    var sy = target.scaleY;
    var ax = target.anchorX;
    var ay = target.anchorY;
    var rotation = target.rotation || 0;
    var x2 = target.x;
    var y2 = target.y;
    var skewX = target.skewX ? Math.tan(target.skewX) : 0;
    var skewY = target.skewY ? Math.tan(-target.skewY) : 0;
    if (ox || oy || ax || ay) {
      var dx = ox + ax;
      var dy = oy + ay;
      m2[4] = -dx * sx - skewX * dy * sy;
      m2[5] = -dy * sy - skewY * dx * sx;
    } else {
      m2[4] = m2[5] = 0;
    }
    m2[0] = sx;
    m2[3] = sy;
    m2[1] = skewY * sx;
    m2[2] = skewX * sy;
    rotation && rotate(m2, m2, rotation);
    m2[4] += ox + x2;
    m2[5] += oy + y2;
    return m2;
  };
  Transformable2.initDefaultProps = function() {
    var proto2 = Transformable2.prototype;
    proto2.scaleX = proto2.scaleY = proto2.globalScaleRatio = 1;
    proto2.x = proto2.y = proto2.originX = proto2.originY = proto2.skewX = proto2.skewY = proto2.rotation = proto2.anchorX = proto2.anchorY = 0;
  }();
  return Transformable2;
}();
var TRANSFORMABLE_PROPS = [
  "x",
  "y",
  "originX",
  "originY",
  "anchorX",
  "anchorY",
  "rotation",
  "scaleX",
  "scaleY",
  "skewX",
  "skewY"
];
function copyTransform(target, source) {
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var propName = TRANSFORMABLE_PROPS[i];
    target[propName] = source[propName];
  }
}
var Transformable$1 = Transformable;
var Point = function() {
  function Point2(x2, y2) {
    this.x = x2 || 0;
    this.y = y2 || 0;
  }
  Point2.prototype.copy = function(other) {
    this.x = other.x;
    this.y = other.y;
    return this;
  };
  Point2.prototype.clone = function() {
    return new Point2(this.x, this.y);
  };
  Point2.prototype.set = function(x2, y2) {
    this.x = x2;
    this.y = y2;
    return this;
  };
  Point2.prototype.equal = function(other) {
    return other.x === this.x && other.y === this.y;
  };
  Point2.prototype.add = function(other) {
    this.x += other.x;
    this.y += other.y;
    return this;
  };
  Point2.prototype.scale = function(scalar) {
    this.x *= scalar;
    this.y *= scalar;
  };
  Point2.prototype.scaleAndAdd = function(other, scalar) {
    this.x += other.x * scalar;
    this.y += other.y * scalar;
  };
  Point2.prototype.sub = function(other) {
    this.x -= other.x;
    this.y -= other.y;
    return this;
  };
  Point2.prototype.dot = function(other) {
    return this.x * other.x + this.y * other.y;
  };
  Point2.prototype.len = function() {
    return Math.sqrt(this.x * this.x + this.y * this.y);
  };
  Point2.prototype.lenSquare = function() {
    return this.x * this.x + this.y * this.y;
  };
  Point2.prototype.normalize = function() {
    var len2 = this.len();
    this.x /= len2;
    this.y /= len2;
    return this;
  };
  Point2.prototype.distance = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return Math.sqrt(dx * dx + dy * dy);
  };
  Point2.prototype.distanceSquare = function(other) {
    var dx = this.x - other.x;
    var dy = this.y - other.y;
    return dx * dx + dy * dy;
  };
  Point2.prototype.negate = function() {
    this.x = -this.x;
    this.y = -this.y;
    return this;
  };
  Point2.prototype.transform = function(m2) {
    if (!m2) {
      return;
    }
    var x2 = this.x;
    var y2 = this.y;
    this.x = m2[0] * x2 + m2[2] * y2 + m2[4];
    this.y = m2[1] * x2 + m2[3] * y2 + m2[5];
    return this;
  };
  Point2.prototype.toArray = function(out2) {
    out2[0] = this.x;
    out2[1] = this.y;
    return out2;
  };
  Point2.prototype.fromArray = function(input) {
    this.x = input[0];
    this.y = input[1];
  };
  Point2.set = function(p2, x2, y2) {
    p2.x = x2;
    p2.y = y2;
  };
  Point2.copy = function(p2, p22) {
    p2.x = p22.x;
    p2.y = p22.y;
  };
  Point2.len = function(p2) {
    return Math.sqrt(p2.x * p2.x + p2.y * p2.y);
  };
  Point2.lenSquare = function(p2) {
    return p2.x * p2.x + p2.y * p2.y;
  };
  Point2.dot = function(p0, p1) {
    return p0.x * p1.x + p0.y * p1.y;
  };
  Point2.add = function(out2, p0, p1) {
    out2.x = p0.x + p1.x;
    out2.y = p0.y + p1.y;
  };
  Point2.sub = function(out2, p0, p1) {
    out2.x = p0.x - p1.x;
    out2.y = p0.y - p1.y;
  };
  Point2.scale = function(out2, p0, scalar) {
    out2.x = p0.x * scalar;
    out2.y = p0.y * scalar;
  };
  Point2.scaleAndAdd = function(out2, p0, p1, scalar) {
    out2.x = p0.x + p1.x * scalar;
    out2.y = p0.y + p1.y * scalar;
  };
  Point2.lerp = function(out2, p0, p1, t2) {
    var onet = 1 - t2;
    out2.x = onet * p0.x + t2 * p1.x;
    out2.y = onet * p0.y + t2 * p1.y;
  };
  return Point2;
}();
var Point$1 = Point;
var mathMin$a = Math.min;
var mathMax$a = Math.max;
var lt = new Point$1();
var rb = new Point$1();
var lb = new Point$1();
var rt = new Point$1();
var minTv$1 = new Point$1();
var maxTv$1 = new Point$1();
var BoundingRect = function() {
  function BoundingRect2(x2, y2, width, height) {
    if (width < 0) {
      x2 = x2 + width;
      width = -width;
    }
    if (height < 0) {
      y2 = y2 + height;
      height = -height;
    }
    this.x = x2;
    this.y = y2;
    this.width = width;
    this.height = height;
  }
  BoundingRect2.prototype.union = function(other) {
    var x2 = mathMin$a(other.x, this.x);
    var y2 = mathMin$a(other.y, this.y);
    if (isFinite(this.x) && isFinite(this.width)) {
      this.width = mathMax$a(other.x + other.width, this.x + this.width) - x2;
    } else {
      this.width = other.width;
    }
    if (isFinite(this.y) && isFinite(this.height)) {
      this.height = mathMax$a(other.y + other.height, this.y + this.height) - y2;
    } else {
      this.height = other.height;
    }
    this.x = x2;
    this.y = y2;
  };
  BoundingRect2.prototype.applyTransform = function(m2) {
    BoundingRect2.applyTransform(this, this, m2);
  };
  BoundingRect2.prototype.calculateTransform = function(b2) {
    var a = this;
    var sx = b2.width / a.width;
    var sy = b2.height / a.height;
    var m2 = create$1();
    translate(m2, m2, [-a.x, -a.y]);
    scale$1(m2, m2, [sx, sy]);
    translate(m2, m2, [b2.x, b2.y]);
    return m2;
  };
  BoundingRect2.prototype.intersect = function(b2, mtv) {
    if (!b2) {
      return false;
    }
    if (!(b2 instanceof BoundingRect2)) {
      b2 = BoundingRect2.create(b2);
    }
    var a = this;
    var ax0 = a.x;
    var ax1 = a.x + a.width;
    var ay0 = a.y;
    var ay1 = a.y + a.height;
    var bx0 = b2.x;
    var bx1 = b2.x + b2.width;
    var by0 = b2.y;
    var by1 = b2.y + b2.height;
    var overlap = !(ax1 < bx0 || bx1 < ax0 || ay1 < by0 || by1 < ay0);
    if (mtv) {
      var dMin = Infinity;
      var dMax = 0;
      var d0 = Math.abs(ax1 - bx0);
      var d1 = Math.abs(bx1 - ax0);
      var d2 = Math.abs(ay1 - by0);
      var d3 = Math.abs(by1 - ay0);
      var dx = Math.min(d0, d1);
      var dy = Math.min(d2, d3);
      if (ax1 < bx0 || bx1 < ax0) {
        if (dx > dMax) {
          dMax = dx;
          if (d0 < d1) {
            Point$1.set(maxTv$1, -d0, 0);
          } else {
            Point$1.set(maxTv$1, d1, 0);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d0 < d1) {
            Point$1.set(minTv$1, d0, 0);
          } else {
            Point$1.set(minTv$1, -d1, 0);
          }
        }
      }
      if (ay1 < by0 || by1 < ay0) {
        if (dy > dMax) {
          dMax = dy;
          if (d2 < d3) {
            Point$1.set(maxTv$1, 0, -d2);
          } else {
            Point$1.set(maxTv$1, 0, d3);
          }
        }
      } else {
        if (dx < dMin) {
          dMin = dx;
          if (d2 < d3) {
            Point$1.set(minTv$1, 0, d2);
          } else {
            Point$1.set(minTv$1, 0, -d3);
          }
        }
      }
    }
    if (mtv) {
      Point$1.copy(mtv, overlap ? minTv$1 : maxTv$1);
    }
    return overlap;
  };
  BoundingRect2.prototype.contain = function(x2, y2) {
    var rect = this;
    return x2 >= rect.x && x2 <= rect.x + rect.width && y2 >= rect.y && y2 <= rect.y + rect.height;
  };
  BoundingRect2.prototype.clone = function() {
    return new BoundingRect2(this.x, this.y, this.width, this.height);
  };
  BoundingRect2.prototype.copy = function(other) {
    BoundingRect2.copy(this, other);
  };
  BoundingRect2.prototype.plain = function() {
    return {
      x: this.x,
      y: this.y,
      width: this.width,
      height: this.height
    };
  };
  BoundingRect2.prototype.isFinite = function() {
    return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
  };
  BoundingRect2.prototype.isZero = function() {
    return this.width === 0 || this.height === 0;
  };
  BoundingRect2.create = function(rect) {
    return new BoundingRect2(rect.x, rect.y, rect.width, rect.height);
  };
  BoundingRect2.copy = function(target, source) {
    target.x = source.x;
    target.y = source.y;
    target.width = source.width;
    target.height = source.height;
  };
  BoundingRect2.applyTransform = function(target, source, m2) {
    if (!m2) {
      if (target !== source) {
        BoundingRect2.copy(target, source);
      }
      return;
    }
    if (m2[1] < 1e-5 && m2[1] > -1e-5 && m2[2] < 1e-5 && m2[2] > -1e-5) {
      var sx = m2[0];
      var sy = m2[3];
      var tx = m2[4];
      var ty = m2[5];
      target.x = source.x * sx + tx;
      target.y = source.y * sy + ty;
      target.width = source.width * sx;
      target.height = source.height * sy;
      if (target.width < 0) {
        target.x += target.width;
        target.width = -target.width;
      }
      if (target.height < 0) {
        target.y += target.height;
        target.height = -target.height;
      }
      return;
    }
    lt.x = lb.x = source.x;
    lt.y = rt.y = source.y;
    rb.x = rt.x = source.x + source.width;
    rb.y = lb.y = source.y + source.height;
    lt.transform(m2);
    rt.transform(m2);
    rb.transform(m2);
    lb.transform(m2);
    target.x = mathMin$a(lt.x, rb.x, lb.x, rt.x);
    target.y = mathMin$a(lt.y, rb.y, lb.y, rt.y);
    var maxX = mathMax$a(lt.x, rb.x, lb.x, rt.x);
    var maxY = mathMax$a(lt.y, rb.y, lb.y, rt.y);
    target.width = maxX - target.x;
    target.height = maxY - target.y;
  };
  return BoundingRect2;
}();
var BoundingRect$1 = BoundingRect;
var textWidthCache = {};
function getWidth(text, font) {
  font = font || DEFAULT_FONT;
  var cacheOfFont = textWidthCache[font];
  if (!cacheOfFont) {
    cacheOfFont = textWidthCache[font] = new LRU$1(500);
  }
  var width = cacheOfFont.get(text);
  if (width == null) {
    width = platformApi.measureText(text, font).width;
    cacheOfFont.put(text, width);
  }
  return width;
}
function innerGetBoundingRect(text, font, textAlign, textBaseline) {
  var width = getWidth(text, font);
  var height = getLineHeight(font);
  var x2 = adjustTextX(0, width, textAlign);
  var y2 = adjustTextY(0, height, textBaseline);
  var rect = new BoundingRect$1(x2, y2, width, height);
  return rect;
}
function getBoundingRect(text, font, textAlign, textBaseline) {
  var textLines = ((text || "") + "").split("\n");
  var len2 = textLines.length;
  if (len2 === 1) {
    return innerGetBoundingRect(textLines[0], font, textAlign, textBaseline);
  } else {
    var uniondRect = new BoundingRect$1(0, 0, 0, 0);
    for (var i = 0; i < textLines.length; i++) {
      var rect = innerGetBoundingRect(textLines[i], font, textAlign, textBaseline);
      i === 0 ? uniondRect.copy(rect) : uniondRect.union(rect);
    }
    return uniondRect;
  }
}
function adjustTextX(x2, width, textAlign) {
  if (textAlign === "right") {
    x2 -= width;
  } else if (textAlign === "center") {
    x2 -= width / 2;
  }
  return x2;
}
function adjustTextY(y2, height, verticalAlign) {
  if (verticalAlign === "middle") {
    y2 -= height / 2;
  } else if (verticalAlign === "bottom") {
    y2 -= height;
  }
  return y2;
}
function getLineHeight(font) {
  return getWidth("\u56FD", font);
}
function parsePercent$1(value, maxValue) {
  if (typeof value === "string") {
    if (value.lastIndexOf("%") >= 0) {
      return parseFloat(value) / 100 * maxValue;
    }
    return parseFloat(value);
  }
  return value;
}
function calculateTextPosition(out2, opts, rect) {
  var textPosition = opts.position || "inside";
  var distance2 = opts.distance != null ? opts.distance : 5;
  var height = rect.height;
  var width = rect.width;
  var halfHeight = height / 2;
  var x2 = rect.x;
  var y2 = rect.y;
  var textAlign = "left";
  var textVerticalAlign = "top";
  if (textPosition instanceof Array) {
    x2 += parsePercent$1(textPosition[0], rect.width);
    y2 += parsePercent$1(textPosition[1], rect.height);
    textAlign = null;
    textVerticalAlign = null;
  } else {
    switch (textPosition) {
      case "left":
        x2 -= distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "right":
        x2 += distance2 + width;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "top":
        x2 += width / 2;
        y2 -= distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "bottom":
        x2 += width / 2;
        y2 += height + distance2;
        textAlign = "center";
        break;
      case "inside":
        x2 += width / 2;
        y2 += halfHeight;
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "insideLeft":
        x2 += distance2;
        y2 += halfHeight;
        textVerticalAlign = "middle";
        break;
      case "insideRight":
        x2 += width - distance2;
        y2 += halfHeight;
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideTop":
        x2 += width / 2;
        y2 += distance2;
        textAlign = "center";
        break;
      case "insideBottom":
        x2 += width / 2;
        y2 += height - distance2;
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideTopLeft":
        x2 += distance2;
        y2 += distance2;
        break;
      case "insideTopRight":
        x2 += width - distance2;
        y2 += distance2;
        textAlign = "right";
        break;
      case "insideBottomLeft":
        x2 += distance2;
        y2 += height - distance2;
        textVerticalAlign = "bottom";
        break;
      case "insideBottomRight":
        x2 += width - distance2;
        y2 += height - distance2;
        textAlign = "right";
        textVerticalAlign = "bottom";
        break;
    }
  }
  out2 = out2 || {};
  out2.x = x2;
  out2.y = y2;
  out2.align = textAlign;
  out2.verticalAlign = textVerticalAlign;
  return out2;
}
var PRESERVED_NORMAL_STATE = "__zr_normal__";
var PRIMARY_STATES_KEYS$1 = TRANSFORMABLE_PROPS.concat(["ignore"]);
var DEFAULT_ANIMATABLE_MAP = reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = true;
  return obj;
}, { ignore: false });
var tmpTextPosCalcRes = {};
var tmpBoundingRect = new BoundingRect$1(0, 0, 0, 0);
var Element$1 = function() {
  function Element2(props) {
    this.id = guid();
    this.animators = [];
    this.currentStates = [];
    this.states = {};
    this._init(props);
  }
  Element2.prototype._init = function(props) {
    this.attr(props);
  };
  Element2.prototype.drift = function(dx, dy, e2) {
    switch (this.draggable) {
      case "horizontal":
        dy = 0;
        break;
      case "vertical":
        dx = 0;
        break;
    }
    var m2 = this.transform;
    if (!m2) {
      m2 = this.transform = [1, 0, 0, 1, 0, 0];
    }
    m2[4] += dx;
    m2[5] += dy;
    this.decomposeTransform();
    this.markRedraw();
  };
  Element2.prototype.beforeUpdate = function() {
  };
  Element2.prototype.afterUpdate = function() {
  };
  Element2.prototype.update = function() {
    this.updateTransform();
    if (this.__dirty) {
      this.updateInnerText();
    }
  };
  Element2.prototype.updateInnerText = function(forceUpdate) {
    var textEl = this._textContent;
    if (textEl && (!textEl.ignore || forceUpdate)) {
      if (!this.textConfig) {
        this.textConfig = {};
      }
      var textConfig = this.textConfig;
      var isLocal = textConfig.local;
      var innerTransformable = textEl.innerTransformable;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var textStyleChanged = false;
      innerTransformable.parent = isLocal ? this : null;
      var innerOrigin = false;
      innerTransformable.copyTransform(textEl);
      if (textConfig.position != null) {
        var layoutRect = tmpBoundingRect;
        if (textConfig.layoutRect) {
          layoutRect.copy(textConfig.layoutRect);
        } else {
          layoutRect.copy(this.getBoundingRect());
        }
        if (!isLocal) {
          layoutRect.applyTransform(this.transform);
        }
        if (this.calculateTextPosition) {
          this.calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        } else {
          calculateTextPosition(tmpTextPosCalcRes, textConfig, layoutRect);
        }
        innerTransformable.x = tmpTextPosCalcRes.x;
        innerTransformable.y = tmpTextPosCalcRes.y;
        textAlign = tmpTextPosCalcRes.align;
        textVerticalAlign = tmpTextPosCalcRes.verticalAlign;
        var textOrigin = textConfig.origin;
        if (textOrigin && textConfig.rotation != null) {
          var relOriginX = void 0;
          var relOriginY = void 0;
          if (textOrigin === "center") {
            relOriginX = layoutRect.width * 0.5;
            relOriginY = layoutRect.height * 0.5;
          } else {
            relOriginX = parsePercent$1(textOrigin[0], layoutRect.width);
            relOriginY = parsePercent$1(textOrigin[1], layoutRect.height);
          }
          innerOrigin = true;
          innerTransformable.originX = -innerTransformable.x + relOriginX + (isLocal ? 0 : layoutRect.x);
          innerTransformable.originY = -innerTransformable.y + relOriginY + (isLocal ? 0 : layoutRect.y);
        }
      }
      if (textConfig.rotation != null) {
        innerTransformable.rotation = textConfig.rotation;
      }
      var textOffset = textConfig.offset;
      if (textOffset) {
        innerTransformable.x += textOffset[0];
        innerTransformable.y += textOffset[1];
        if (!innerOrigin) {
          innerTransformable.originX = -textOffset[0];
          innerTransformable.originY = -textOffset[1];
        }
      }
      var isInside = textConfig.inside == null ? typeof textConfig.position === "string" && textConfig.position.indexOf("inside") >= 0 : textConfig.inside;
      var innerTextDefaultStyle = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {});
      var textFill = void 0;
      var textStroke = void 0;
      var autoStroke = void 0;
      if (isInside && this.canBeInsideText()) {
        textFill = textConfig.insideFill;
        textStroke = textConfig.insideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getInsideTextFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getInsideTextStroke(textFill);
          autoStroke = true;
        }
      } else {
        textFill = textConfig.outsideFill;
        textStroke = textConfig.outsideStroke;
        if (textFill == null || textFill === "auto") {
          textFill = this.getOutsideFill();
        }
        if (textStroke == null || textStroke === "auto") {
          textStroke = this.getOutsideStroke(textFill);
          autoStroke = true;
        }
      }
      textFill = textFill || "#000";
      if (textFill !== innerTextDefaultStyle.fill || textStroke !== innerTextDefaultStyle.stroke || autoStroke !== innerTextDefaultStyle.autoStroke || textAlign !== innerTextDefaultStyle.align || textVerticalAlign !== innerTextDefaultStyle.verticalAlign) {
        textStyleChanged = true;
        innerTextDefaultStyle.fill = textFill;
        innerTextDefaultStyle.stroke = textStroke;
        innerTextDefaultStyle.autoStroke = autoStroke;
        innerTextDefaultStyle.align = textAlign;
        innerTextDefaultStyle.verticalAlign = textVerticalAlign;
        textEl.setDefaultTextStyle(innerTextDefaultStyle);
      }
      textEl.__dirty |= REDRAW_BIT;
      if (textStyleChanged) {
        textEl.dirtyStyle(true);
      }
    }
  };
  Element2.prototype.canBeInsideText = function() {
    return true;
  };
  Element2.prototype.getInsideTextFill = function() {
    return "#fff";
  };
  Element2.prototype.getInsideTextStroke = function(textFill) {
    return "#000";
  };
  Element2.prototype.getOutsideFill = function() {
    return this.__zr && this.__zr.isDarkMode() ? LIGHT_LABEL_COLOR : DARK_LABEL_COLOR;
  };
  Element2.prototype.getOutsideStroke = function(textFill) {
    var backgroundColor2 = this.__zr && this.__zr.getBackgroundColor();
    var colorArr = typeof backgroundColor2 === "string" && parse(backgroundColor2);
    if (!colorArr) {
      colorArr = [255, 255, 255, 1];
    }
    var alpha = colorArr[3];
    var isDark = this.__zr.isDarkMode();
    for (var i = 0; i < 3; i++) {
      colorArr[i] = colorArr[i] * alpha + (isDark ? 0 : 255) * (1 - alpha);
    }
    colorArr[3] = 1;
    return stringify(colorArr, "rgba");
  };
  Element2.prototype.traverse = function(cb, context) {
  };
  Element2.prototype.attrKV = function(key, value) {
    if (key === "textConfig") {
      this.setTextConfig(value);
    } else if (key === "textContent") {
      this.setTextContent(value);
    } else if (key === "clipPath") {
      this.setClipPath(value);
    } else if (key === "extra") {
      this.extra = this.extra || {};
      extend(this.extra, value);
    } else {
      this[key] = value;
    }
  };
  Element2.prototype.hide = function() {
    this.ignore = true;
    this.markRedraw();
  };
  Element2.prototype.show = function() {
    this.ignore = false;
    this.markRedraw();
  };
  Element2.prototype.attr = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.attrKV(keyOrObj, value);
    } else if (isObject$4(keyOrObj)) {
      var obj = keyOrObj;
      var keysArr = keys(obj);
      for (var i = 0; i < keysArr.length; i++) {
        var key = keysArr[i];
        this.attrKV(key, keyOrObj[key]);
      }
    }
    this.markRedraw();
    return this;
  };
  Element2.prototype.saveCurrentToNormalState = function(toState) {
    this._innerSaveToNormal(toState);
    var normalState = this._normalState;
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      var fromStateTransition = animator.__fromStateTransition;
      if (animator.getLoop() || fromStateTransition && fromStateTransition !== PRESERVED_NORMAL_STATE) {
        continue;
      }
      var targetName = animator.targetName;
      var target = targetName ? normalState[targetName] : normalState;
      animator.saveTo(target);
    }
  };
  Element2.prototype._innerSaveToNormal = function(toState) {
    var normalState = this._normalState;
    if (!normalState) {
      normalState = this._normalState = {};
    }
    if (toState.textConfig && !normalState.textConfig) {
      normalState.textConfig = this.textConfig;
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS$1);
  };
  Element2.prototype._savePrimaryToNormal = function(toState, normalState, primaryKeys) {
    for (var i = 0; i < primaryKeys.length; i++) {
      var key = primaryKeys[i];
      if (toState[key] != null && !(key in normalState)) {
        normalState[key] = this[key];
      }
    }
  };
  Element2.prototype.hasState = function() {
    return this.currentStates.length > 0;
  };
  Element2.prototype.getState = function(name) {
    return this.states[name];
  };
  Element2.prototype.ensureState = function(name) {
    var states = this.states;
    if (!states[name]) {
      states[name] = {};
    }
    return states[name];
  };
  Element2.prototype.clearStates = function(noAnimation) {
    this.useState(PRESERVED_NORMAL_STATE, false, noAnimation);
  };
  Element2.prototype.useState = function(stateName, keepCurrentStates, noAnimation, forceUseHoverLayer) {
    var toNormalState = stateName === PRESERVED_NORMAL_STATE;
    var hasStates = this.hasState();
    if (!hasStates && toNormalState) {
      return;
    }
    var currentStates = this.currentStates;
    var animationCfg = this.stateTransition;
    if (indexOf(currentStates, stateName) >= 0 && (keepCurrentStates || currentStates.length === 1)) {
      return;
    }
    var state;
    if (this.stateProxy && !toNormalState) {
      state = this.stateProxy(stateName);
    }
    if (!state) {
      state = this.states && this.states[stateName];
    }
    if (!state && !toNormalState) {
      logError("State " + stateName + " not exists.");
      return;
    }
    if (!toNormalState) {
      this.saveCurrentToNormalState(state);
    }
    var useHoverLayer = !!(state && state.hoverLayer || forceUseHoverLayer);
    if (useHoverLayer) {
      this._toggleHoverLayerFlag(true);
    }
    this._applyStateObj(stateName, state, this._normalState, keepCurrentStates, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (textGuide) {
      textGuide.useState(stateName, keepCurrentStates, noAnimation, useHoverLayer);
    }
    if (toNormalState) {
      this.currentStates = [];
      this._normalState = {};
    } else {
      if (!keepCurrentStates) {
        this.currentStates = [stateName];
      } else {
        this.currentStates.push(stateName);
      }
    }
    this._updateAnimationTargets();
    this.markRedraw();
    if (!useHoverLayer && this.__inHover) {
      this._toggleHoverLayerFlag(false);
      this.__dirty &= ~REDRAW_BIT;
    }
    return state;
  };
  Element2.prototype.useStates = function(states, noAnimation, forceUseHoverLayer) {
    if (!states.length) {
      this.clearStates();
    } else {
      var stateObjects = [];
      var currentStates = this.currentStates;
      var len2 = states.length;
      var notChange = len2 === currentStates.length;
      if (notChange) {
        for (var i = 0; i < len2; i++) {
          if (states[i] !== currentStates[i]) {
            notChange = false;
            break;
          }
        }
      }
      if (notChange) {
        return;
      }
      for (var i = 0; i < len2; i++) {
        var stateName = states[i];
        var stateObj = void 0;
        if (this.stateProxy) {
          stateObj = this.stateProxy(stateName, states);
        }
        if (!stateObj) {
          stateObj = this.states[stateName];
        }
        if (stateObj) {
          stateObjects.push(stateObj);
        }
      }
      var lastStateObj = stateObjects[len2 - 1];
      var useHoverLayer = !!(lastStateObj && lastStateObj.hoverLayer || forceUseHoverLayer);
      if (useHoverLayer) {
        this._toggleHoverLayerFlag(true);
      }
      var mergedState = this._mergeStates(stateObjects);
      var animationCfg = this.stateTransition;
      this.saveCurrentToNormalState(mergedState);
      this._applyStateObj(states.join(","), mergedState, this._normalState, false, !noAnimation && !this.__inHover && animationCfg && animationCfg.duration > 0, animationCfg);
      var textContent = this._textContent;
      var textGuide = this._textGuide;
      if (textContent) {
        textContent.useStates(states, noAnimation, useHoverLayer);
      }
      if (textGuide) {
        textGuide.useStates(states, noAnimation, useHoverLayer);
      }
      this._updateAnimationTargets();
      this.currentStates = states.slice();
      this.markRedraw();
      if (!useHoverLayer && this.__inHover) {
        this._toggleHoverLayerFlag(false);
        this.__dirty &= ~REDRAW_BIT;
      }
    }
  };
  Element2.prototype._updateAnimationTargets = function() {
    for (var i = 0; i < this.animators.length; i++) {
      var animator = this.animators[i];
      if (animator.targetName) {
        animator.changeTarget(this[animator.targetName]);
      }
    }
  };
  Element2.prototype.removeState = function(state) {
    var idx = indexOf(this.currentStates, state);
    if (idx >= 0) {
      var currentStates = this.currentStates.slice();
      currentStates.splice(idx, 1);
      this.useStates(currentStates);
    }
  };
  Element2.prototype.replaceState = function(oldState, newState, forceAdd) {
    var currentStates = this.currentStates.slice();
    var idx = indexOf(currentStates, oldState);
    var newStateExists = indexOf(currentStates, newState) >= 0;
    if (idx >= 0) {
      if (!newStateExists) {
        currentStates[idx] = newState;
      } else {
        currentStates.splice(idx, 1);
      }
    } else if (forceAdd && !newStateExists) {
      currentStates.push(newState);
    }
    this.useStates(currentStates);
  };
  Element2.prototype.toggleState = function(state, enable) {
    if (enable) {
      this.useState(state, true);
    } else {
      this.removeState(state);
    }
  };
  Element2.prototype._mergeStates = function(states) {
    var mergedState = {};
    var mergedTextConfig;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      extend(mergedState, state);
      if (state.textConfig) {
        mergedTextConfig = mergedTextConfig || {};
        extend(mergedTextConfig, state.textConfig);
      }
    }
    if (mergedTextConfig) {
      mergedState.textConfig = mergedTextConfig;
    }
    return mergedState;
  };
  Element2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    var needsRestoreToNormal = !(state && keepCurrentStates);
    if (state && state.textConfig) {
      this.textConfig = extend({}, keepCurrentStates ? this.textConfig : normalState.textConfig);
      extend(this.textConfig, state.textConfig);
    } else if (needsRestoreToNormal) {
      if (normalState.textConfig) {
        this.textConfig = normalState.textConfig;
      }
    }
    var transitionTarget = {};
    var hasTransition = false;
    for (var i = 0; i < PRIMARY_STATES_KEYS$1.length; i++) {
      var key = PRIMARY_STATES_KEYS$1[i];
      var propNeedsTransition = transition && DEFAULT_ANIMATABLE_MAP[key];
      if (state && state[key] != null) {
        if (propNeedsTransition) {
          hasTransition = true;
          transitionTarget[key] = state[key];
        } else {
          this[key] = state[key];
        }
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          if (propNeedsTransition) {
            hasTransition = true;
            transitionTarget[key] = normalState[key];
          } else {
            this[key] = normalState[key];
          }
        }
      }
    }
    if (!transition) {
      for (var i = 0; i < this.animators.length; i++) {
        var animator = this.animators[i];
        var targetName = animator.targetName;
        if (!animator.getLoop()) {
          animator.__changeFinalValue(targetName ? (state || normalState)[targetName] : state || normalState);
        }
      }
    }
    if (hasTransition) {
      this._transitionState(stateName, transitionTarget, animationCfg);
    }
  };
  Element2.prototype._attachComponent = function(componentEl) {
    if (componentEl.__zr && !componentEl.__hostTarget) {
      return;
    }
    if (componentEl === this) {
      return;
    }
    var zr = this.__zr;
    if (zr) {
      componentEl.addSelfToZr(zr);
    }
    componentEl.__zr = zr;
    componentEl.__hostTarget = this;
  };
  Element2.prototype._detachComponent = function(componentEl) {
    if (componentEl.__zr) {
      componentEl.removeSelfFromZr(componentEl.__zr);
    }
    componentEl.__zr = null;
    componentEl.__hostTarget = null;
  };
  Element2.prototype.getClipPath = function() {
    return this._clipPath;
  };
  Element2.prototype.setClipPath = function(clipPath) {
    if (this._clipPath && this._clipPath !== clipPath) {
      this.removeClipPath();
    }
    this._attachComponent(clipPath);
    this._clipPath = clipPath;
    this.markRedraw();
  };
  Element2.prototype.removeClipPath = function() {
    var clipPath = this._clipPath;
    if (clipPath) {
      this._detachComponent(clipPath);
      this._clipPath = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextContent = function() {
    return this._textContent;
  };
  Element2.prototype.setTextContent = function(textEl) {
    var previousTextContent = this._textContent;
    if (previousTextContent === textEl) {
      return;
    }
    if (previousTextContent && previousTextContent !== textEl) {
      this.removeTextContent();
    }
    textEl.innerTransformable = new Transformable$1();
    this._attachComponent(textEl);
    this._textContent = textEl;
    this.markRedraw();
  };
  Element2.prototype.setTextConfig = function(cfg) {
    if (!this.textConfig) {
      this.textConfig = {};
    }
    extend(this.textConfig, cfg);
    this.markRedraw();
  };
  Element2.prototype.removeTextConfig = function() {
    this.textConfig = null;
    this.markRedraw();
  };
  Element2.prototype.removeTextContent = function() {
    var textEl = this._textContent;
    if (textEl) {
      textEl.innerTransformable = null;
      this._detachComponent(textEl);
      this._textContent = null;
      this._innerTextDefaultStyle = null;
      this.markRedraw();
    }
  };
  Element2.prototype.getTextGuideLine = function() {
    return this._textGuide;
  };
  Element2.prototype.setTextGuideLine = function(guideLine) {
    if (this._textGuide && this._textGuide !== guideLine) {
      this.removeTextGuideLine();
    }
    this._attachComponent(guideLine);
    this._textGuide = guideLine;
    this.markRedraw();
  };
  Element2.prototype.removeTextGuideLine = function() {
    var textGuide = this._textGuide;
    if (textGuide) {
      this._detachComponent(textGuide);
      this._textGuide = null;
      this.markRedraw();
    }
  };
  Element2.prototype.markRedraw = function() {
    this.__dirty |= REDRAW_BIT;
    var zr = this.__zr;
    if (zr) {
      if (this.__inHover) {
        zr.refreshHover();
      } else {
        zr.refresh();
      }
    }
    if (this.__hostTarget) {
      this.__hostTarget.markRedraw();
    }
  };
  Element2.prototype.dirty = function() {
    this.markRedraw();
  };
  Element2.prototype._toggleHoverLayerFlag = function(inHover) {
    this.__inHover = inHover;
    var textContent = this._textContent;
    var textGuide = this._textGuide;
    if (textContent) {
      textContent.__inHover = inHover;
    }
    if (textGuide) {
      textGuide.__inHover = inHover;
    }
  };
  Element2.prototype.addSelfToZr = function(zr) {
    if (this.__zr === zr) {
      return;
    }
    this.__zr = zr;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.addAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.addSelfToZr(zr);
    }
    if (this._textContent) {
      this._textContent.addSelfToZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.addSelfToZr(zr);
    }
  };
  Element2.prototype.removeSelfFromZr = function(zr) {
    if (!this.__zr) {
      return;
    }
    this.__zr = null;
    var animators = this.animators;
    if (animators) {
      for (var i = 0; i < animators.length; i++) {
        zr.animation.removeAnimator(animators[i]);
      }
    }
    if (this._clipPath) {
      this._clipPath.removeSelfFromZr(zr);
    }
    if (this._textContent) {
      this._textContent.removeSelfFromZr(zr);
    }
    if (this._textGuide) {
      this._textGuide.removeSelfFromZr(zr);
    }
  };
  Element2.prototype.animate = function(key, loop, allowDiscreteAnimation) {
    var target = key ? this[key] : this;
    var animator = new Animator(target, loop, allowDiscreteAnimation);
    key && (animator.targetName = key);
    this.addAnimator(animator, key);
    return animator;
  };
  Element2.prototype.addAnimator = function(animator, key) {
    var zr = this.__zr;
    var el = this;
    animator.during(function() {
      el.updateDuringAnimation(key);
    }).done(function() {
      var animators = el.animators;
      var idx = indexOf(animators, animator);
      if (idx >= 0) {
        animators.splice(idx, 1);
      }
    });
    this.animators.push(animator);
    if (zr) {
      zr.animation.addAnimator(animator);
    }
    zr && zr.wakeUp();
  };
  Element2.prototype.updateDuringAnimation = function(key) {
    this.markRedraw();
  };
  Element2.prototype.stopAnimation = function(scope, forwardToLast) {
    var animators = this.animators;
    var len2 = animators.length;
    var leftAnimators = [];
    for (var i = 0; i < len2; i++) {
      var animator = animators[i];
      if (!scope || scope === animator.scope) {
        animator.stop(forwardToLast);
      } else {
        leftAnimators.push(animator);
      }
    }
    this.animators = leftAnimators;
    return this;
  };
  Element2.prototype.animateTo = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps);
  };
  Element2.prototype.animateFrom = function(target, cfg, animationProps) {
    animateTo(this, target, cfg, animationProps, true);
  };
  Element2.prototype._transitionState = function(stateName, target, cfg, animationProps) {
    var animators = animateTo(this, target, cfg, animationProps);
    for (var i = 0; i < animators.length; i++) {
      animators[i].__fromStateTransition = stateName;
    }
  };
  Element2.prototype.getBoundingRect = function() {
    return null;
  };
  Element2.prototype.getPaintRect = function() {
    return null;
  };
  Element2.initDefaultProps = function() {
    var elProto = Element2.prototype;
    elProto.type = "element";
    elProto.name = "";
    elProto.ignore = elProto.silent = elProto.isGroup = elProto.draggable = elProto.dragging = elProto.ignoreClip = elProto.__inHover = false;
    elProto.__dirty = REDRAW_BIT;
    function createLegacyProperty(key, privateKey, xKey, yKey) {
      Object.defineProperty(elProto, key, {
        get: function() {
          if (!this[privateKey]) {
            var pos = this[privateKey] = [];
            enhanceArray(this, pos);
          }
          return this[privateKey];
        },
        set: function(pos) {
          this[xKey] = pos[0];
          this[yKey] = pos[1];
          this[privateKey] = pos;
          enhanceArray(this, pos);
        }
      });
      function enhanceArray(self2, pos) {
        Object.defineProperty(pos, 0, {
          get: function() {
            return self2[xKey];
          },
          set: function(val) {
            self2[xKey] = val;
          }
        });
        Object.defineProperty(pos, 1, {
          get: function() {
            return self2[yKey];
          },
          set: function(val) {
            self2[yKey] = val;
          }
        });
      }
    }
    if (Object.defineProperty) {
      createLegacyProperty("position", "_legacyPos", "x", "y");
      createLegacyProperty("scale", "_legacyScale", "scaleX", "scaleY");
      createLegacyProperty("origin", "_legacyOrigin", "originX", "originY");
    }
  }();
  return Element2;
}();
mixin(Element$1, Eventful$1);
mixin(Element$1, Transformable$1);
function animateTo(animatable, target, cfg, animationProps, reverse2) {
  cfg = cfg || {};
  var animators = [];
  animateToShallow(animatable, "", animatable, target, cfg, animationProps, animators, reverse2);
  var finishCount = animators.length;
  var doneHappened = false;
  var cfgDone = cfg.done;
  var cfgAborted = cfg.aborted;
  var doneCb = function() {
    doneHappened = true;
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  var abortedCb = function() {
    finishCount--;
    if (finishCount <= 0) {
      doneHappened ? cfgDone && cfgDone() : cfgAborted && cfgAborted();
    }
  };
  if (!finishCount) {
    cfgDone && cfgDone();
  }
  if (animators.length > 0 && cfg.during) {
    animators[0].during(function(target2, percent) {
      cfg.during(percent);
    });
  }
  for (var i = 0; i < animators.length; i++) {
    var animator = animators[i];
    if (doneCb) {
      animator.done(doneCb);
    }
    if (abortedCb) {
      animator.aborted(abortedCb);
    }
    if (cfg.force) {
      animator.duration(cfg.duration);
    }
    animator.start(cfg.easing);
  }
  return animators;
}
function copyArrShallow(source, target, len2) {
  for (var i = 0; i < len2; i++) {
    source[i] = target[i];
  }
}
function is2DArray(value) {
  return isArrayLike(value[0]);
}
function copyValue(target, source, key) {
  if (isArrayLike(source[key])) {
    if (!isArrayLike(target[key])) {
      target[key] = [];
    }
    if (isTypedArray(source[key])) {
      var len2 = source[key].length;
      if (target[key].length !== len2) {
        target[key] = new source[key].constructor(len2);
        copyArrShallow(target[key], source[key], len2);
      }
    } else {
      var sourceArr = source[key];
      var targetArr = target[key];
      var len0 = sourceArr.length;
      if (is2DArray(sourceArr)) {
        var len1 = sourceArr[0].length;
        for (var i = 0; i < len0; i++) {
          if (!targetArr[i]) {
            targetArr[i] = Array.prototype.slice.call(sourceArr[i]);
          } else {
            copyArrShallow(targetArr[i], sourceArr[i], len1);
          }
        }
      } else {
        copyArrShallow(targetArr, sourceArr, len0);
      }
      targetArr.length = sourceArr.length;
    }
  } else {
    target[key] = source[key];
  }
}
function isValueSame(val1, val2) {
  return val1 === val2 || isArrayLike(val1) && isArrayLike(val2) && is1DArraySame(val1, val2);
}
function is1DArraySame(arr0, arr1) {
  var len2 = arr0.length;
  if (len2 !== arr1.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    if (arr0[i] !== arr1[i]) {
      return false;
    }
  }
  return true;
}
function animateToShallow(animatable, topKey, animateObj, target, cfg, animationProps, animators, reverse2) {
  var targetKeys = keys(target);
  var duration = cfg.duration;
  var delay = cfg.delay;
  var additive = cfg.additive;
  var setToFinal = cfg.setToFinal;
  var animateAll = !isObject$4(animationProps);
  var existsAnimators = animatable.animators;
  var animationKeys = [];
  for (var k2 = 0; k2 < targetKeys.length; k2++) {
    var innerKey = targetKeys[k2];
    var targetVal = target[innerKey];
    if (targetVal != null && animateObj[innerKey] != null && (animateAll || animationProps[innerKey])) {
      if (isObject$4(targetVal) && !isArrayLike(targetVal) && !isGradientObject(targetVal)) {
        if (topKey) {
          if (!reverse2) {
            animateObj[innerKey] = targetVal;
            animatable.updateDuringAnimation(topKey);
          }
          continue;
        }
        animateToShallow(animatable, innerKey, animateObj[innerKey], targetVal, cfg, animationProps && animationProps[innerKey], animators, reverse2);
      } else {
        animationKeys.push(innerKey);
      }
    } else if (!reverse2) {
      animateObj[innerKey] = targetVal;
      animatable.updateDuringAnimation(topKey);
      animationKeys.push(innerKey);
    }
  }
  var keyLen = animationKeys.length;
  if (!additive && keyLen) {
    for (var i = 0; i < existsAnimators.length; i++) {
      var animator = existsAnimators[i];
      if (animator.targetName === topKey) {
        var allAborted = animator.stopTracks(animationKeys);
        if (allAborted) {
          var idx = indexOf(existsAnimators, animator);
          existsAnimators.splice(idx, 1);
        }
      }
    }
  }
  if (!cfg.force) {
    animationKeys = filter(animationKeys, function(key) {
      return !isValueSame(target[key], animateObj[key]);
    });
    keyLen = animationKeys.length;
  }
  if (keyLen > 0 || cfg.force && !animators.length) {
    var revertedSource = void 0;
    var reversedTarget = void 0;
    var sourceClone = void 0;
    if (reverse2) {
      reversedTarget = {};
      if (setToFinal) {
        revertedSource = {};
      }
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        reversedTarget[innerKey] = animateObj[innerKey];
        if (setToFinal) {
          revertedSource[innerKey] = target[innerKey];
        } else {
          animateObj[innerKey] = target[innerKey];
        }
      }
    } else if (setToFinal) {
      sourceClone = {};
      for (var i = 0; i < keyLen; i++) {
        var innerKey = animationKeys[i];
        sourceClone[innerKey] = cloneValue(animateObj[innerKey]);
        copyValue(animateObj, target, innerKey);
      }
    }
    var animator = new Animator(animateObj, false, false, additive ? filter(existsAnimators, function(animator2) {
      return animator2.targetName === topKey;
    }) : null);
    animator.targetName = topKey;
    if (cfg.scope) {
      animator.scope = cfg.scope;
    }
    if (setToFinal && revertedSource) {
      animator.whenWithKeys(0, revertedSource, animationKeys);
    }
    if (sourceClone) {
      animator.whenWithKeys(0, sourceClone, animationKeys);
    }
    animator.whenWithKeys(duration == null ? 500 : duration, reverse2 ? reversedTarget : target, animationKeys).delay(delay || 0);
    animatable.addAnimator(animator, topKey);
    animators.push(animator);
  }
}
var Element$2 = Element$1;
var Group$3 = function(_super) {
  __extends(Group2, _super);
  function Group2(opts) {
    var _this = _super.call(this) || this;
    _this.isGroup = true;
    _this._children = [];
    _this.attr(opts);
    return _this;
  }
  Group2.prototype.childrenRef = function() {
    return this._children;
  };
  Group2.prototype.children = function() {
    return this._children.slice();
  };
  Group2.prototype.childAt = function(idx) {
    return this._children[idx];
  };
  Group2.prototype.childOfName = function(name) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].name === name) {
        return children[i];
      }
    }
  };
  Group2.prototype.childCount = function() {
    return this._children.length;
  };
  Group2.prototype.add = function(child) {
    if (child) {
      if (child !== this && child.parent !== this) {
        this._children.push(child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.addBefore = function(child, nextSibling2) {
    if (child && child !== this && child.parent !== this && nextSibling2 && nextSibling2.parent === this) {
      var children = this._children;
      var idx = children.indexOf(nextSibling2);
      if (idx >= 0) {
        children.splice(idx, 0, child);
        this._doAdd(child);
      }
    }
    return this;
  };
  Group2.prototype.replace = function(oldChild, newChild) {
    var idx = indexOf(this._children, oldChild);
    if (idx >= 0) {
      this.replaceAt(newChild, idx);
    }
    return this;
  };
  Group2.prototype.replaceAt = function(child, index2) {
    var children = this._children;
    var old = children[index2];
    if (child && child !== this && child.parent !== this && child !== old) {
      children[index2] = child;
      old.parent = null;
      var zr = this.__zr;
      if (zr) {
        old.removeSelfFromZr(zr);
      }
      this._doAdd(child);
    }
    return this;
  };
  Group2.prototype._doAdd = function(child) {
    if (child.parent) {
      child.parent.remove(child);
    }
    child.parent = this;
    var zr = this.__zr;
    if (zr && zr !== child.__zr) {
      child.addSelfToZr(zr);
    }
    zr && zr.refresh();
  };
  Group2.prototype.remove = function(child) {
    var zr = this.__zr;
    var children = this._children;
    var idx = indexOf(children, child);
    if (idx < 0) {
      return this;
    }
    children.splice(idx, 1);
    child.parent = null;
    if (zr) {
      child.removeSelfFromZr(zr);
    }
    zr && zr.refresh();
    return this;
  };
  Group2.prototype.removeAll = function() {
    var children = this._children;
    var zr = this.__zr;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (zr) {
        child.removeSelfFromZr(zr);
      }
      child.parent = null;
    }
    children.length = 0;
    return this;
  };
  Group2.prototype.eachChild = function(cb, context) {
    var children = this._children;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      cb.call(context, child, i);
    }
    return this;
  };
  Group2.prototype.traverse = function(cb, context) {
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      var stopped = cb.call(context, child);
      if (child.isGroup && !stopped) {
        child.traverse(cb, context);
      }
    }
    return this;
  };
  Group2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.addSelfToZr(zr);
    }
  };
  Group2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.removeSelfFromZr(zr);
    }
  };
  Group2.prototype.getBoundingRect = function(includeChildren) {
    var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
    var children = includeChildren || this._children;
    var tmpMat = [];
    var rect = null;
    for (var i = 0; i < children.length; i++) {
      var child = children[i];
      if (child.ignore || child.invisible) {
        continue;
      }
      var childRect = child.getBoundingRect();
      var transform2 = child.getLocalTransform(tmpMat);
      if (transform2) {
        BoundingRect$1.applyTransform(tmpRect2, childRect, transform2);
        rect = rect || tmpRect2.clone();
        rect.union(tmpRect2);
      } else {
        rect = rect || childRect.clone();
        rect.union(childRect);
      }
    }
    return rect || tmpRect2;
  };
  return Group2;
}(Element$2);
Group$3.prototype.type = "group";
var Group$4 = Group$3;
/*!
* ZRender, a high performance 2d drawing library.
*
* Copyright (c) 2013, Baidu Inc.
* All rights reserved.
*
* LICENSE
* https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
*/
var painterCtors = {};
var instances$1 = {};
function delInstance(id2) {
  delete instances$1[id2];
}
function isDarkMode(backgroundColor2) {
  if (!backgroundColor2) {
    return false;
  }
  if (typeof backgroundColor2 === "string") {
    return lum(backgroundColor2, 1) < DARK_MODE_THRESHOLD;
  } else if (backgroundColor2.colorStops) {
    var colorStops = backgroundColor2.colorStops;
    var totalLum = 0;
    var len2 = colorStops.length;
    for (var i = 0; i < len2; i++) {
      totalLum += lum(colorStops[i].color, 1);
    }
    totalLum /= len2;
    return totalLum < DARK_MODE_THRESHOLD;
  }
  return false;
}
var ZRender = function() {
  function ZRender2(id2, dom, opts) {
    var _this = this;
    this._sleepAfterStill = 10;
    this._stillFrameAccum = 0;
    this._needsRefresh = true;
    this._needsRefreshHover = true;
    this._darkMode = false;
    opts = opts || {};
    this.dom = dom;
    this.id = id2;
    var storage2 = new Storage$1();
    var rendererType = opts.renderer || "canvas";
    if (!painterCtors[rendererType]) {
      rendererType = keys(painterCtors)[0];
    }
    opts.useDirtyRect = opts.useDirtyRect == null ? false : opts.useDirtyRect;
    var painter = new painterCtors[rendererType](dom, storage2, opts, id2);
    var ssrMode = opts.ssr || painter.ssrOnly;
    this.storage = storage2;
    this.painter = painter;
    var handerProxy = !env$1.node && !env$1.worker && !ssrMode ? new HandlerProxy(painter.getViewportRoot(), painter.root) : null;
    this.handler = new Handler$1(storage2, painter, handerProxy, painter.root);
    this.animation = new Animation$1({
      stage: {
        update: ssrMode ? null : function() {
          return _this._flush(true);
        }
      }
    });
    if (!ssrMode) {
      this.animation.start();
    }
  }
  ZRender2.prototype.add = function(el) {
    if (!el) {
      return;
    }
    this.storage.addRoot(el);
    el.addSelfToZr(this);
    this.refresh();
  };
  ZRender2.prototype.remove = function(el) {
    if (!el) {
      return;
    }
    this.storage.delRoot(el);
    el.removeSelfFromZr(this);
    this.refresh();
  };
  ZRender2.prototype.configLayer = function(zLevel, config) {
    if (this.painter.configLayer) {
      this.painter.configLayer(zLevel, config);
    }
    this.refresh();
  };
  ZRender2.prototype.setBackgroundColor = function(backgroundColor2) {
    if (this.painter.setBackgroundColor) {
      this.painter.setBackgroundColor(backgroundColor2);
    }
    this.refresh();
    this._backgroundColor = backgroundColor2;
    this._darkMode = isDarkMode(backgroundColor2);
  };
  ZRender2.prototype.getBackgroundColor = function() {
    return this._backgroundColor;
  };
  ZRender2.prototype.setDarkMode = function(darkMode) {
    this._darkMode = darkMode;
  };
  ZRender2.prototype.isDarkMode = function() {
    return this._darkMode;
  };
  ZRender2.prototype.refreshImmediately = function(fromInside) {
    if (!fromInside) {
      this.animation.update(true);
    }
    this._needsRefresh = false;
    this.painter.refresh();
    this._needsRefresh = false;
  };
  ZRender2.prototype.refresh = function() {
    this._needsRefresh = true;
    this.animation.start();
  };
  ZRender2.prototype.flush = function() {
    this._flush(false);
  };
  ZRender2.prototype._flush = function(fromInside) {
    var triggerRendered;
    var start2 = getTime();
    if (this._needsRefresh) {
      triggerRendered = true;
      this.refreshImmediately(fromInside);
    }
    if (this._needsRefreshHover) {
      triggerRendered = true;
      this.refreshHoverImmediately();
    }
    var end2 = getTime();
    if (triggerRendered) {
      this._stillFrameAccum = 0;
      this.trigger("rendered", {
        elapsedTime: end2 - start2
      });
    } else if (this._sleepAfterStill > 0) {
      this._stillFrameAccum++;
      if (this._stillFrameAccum > this._sleepAfterStill) {
        this.animation.stop();
      }
    }
  };
  ZRender2.prototype.setSleepAfterStill = function(stillFramesCount) {
    this._sleepAfterStill = stillFramesCount;
  };
  ZRender2.prototype.wakeUp = function() {
    this.animation.start();
    this._stillFrameAccum = 0;
  };
  ZRender2.prototype.refreshHover = function() {
    this._needsRefreshHover = true;
  };
  ZRender2.prototype.refreshHoverImmediately = function() {
    this._needsRefreshHover = false;
    if (this.painter.refreshHover && this.painter.getType() === "canvas") {
      this.painter.refreshHover();
    }
  };
  ZRender2.prototype.resize = function(opts) {
    opts = opts || {};
    this.painter.resize(opts.width, opts.height);
    this.handler.resize();
  };
  ZRender2.prototype.clearAnimation = function() {
    this.animation.clear();
  };
  ZRender2.prototype.getWidth = function() {
    return this.painter.getWidth();
  };
  ZRender2.prototype.getHeight = function() {
    return this.painter.getHeight();
  };
  ZRender2.prototype.setCursorStyle = function(cursorStyle) {
    this.handler.setCursorStyle(cursorStyle);
  };
  ZRender2.prototype.findHover = function(x2, y2) {
    return this.handler.findHover(x2, y2);
  };
  ZRender2.prototype.on = function(eventName, eventHandler, context) {
    this.handler.on(eventName, eventHandler, context);
    return this;
  };
  ZRender2.prototype.off = function(eventName, eventHandler) {
    this.handler.off(eventName, eventHandler);
  };
  ZRender2.prototype.trigger = function(eventName, event) {
    this.handler.trigger(eventName, event);
  };
  ZRender2.prototype.clear = function() {
    var roots2 = this.storage.getRoots();
    for (var i = 0; i < roots2.length; i++) {
      if (roots2[i] instanceof Group$4) {
        roots2[i].removeSelfFromZr(this);
      }
    }
    this.storage.delAllRoots();
    this.painter.clear();
  };
  ZRender2.prototype.dispose = function() {
    this.animation.stop();
    this.clear();
    this.storage.dispose();
    this.painter.dispose();
    this.handler.dispose();
    this.animation = this.storage = this.painter = this.handler = null;
    delInstance(this.id);
  };
  return ZRender2;
}();
function init$2(dom, opts) {
  var zr = new ZRender(guid(), dom, opts);
  instances$1[zr.id] = zr;
  return zr;
}
function registerPainter(name, Ctor) {
  painterCtors[name] = Ctor;
}
var RADIAN_EPSILON = 1e-4;
var ROUND_SUPPORTED_PRECISION_MAX = 20;
function _trim(str) {
  return str.replace(/^\s+|\s+$/g, "");
}
function linearMap$2(val, domain, range3, clamp2) {
  var d0 = domain[0];
  var d1 = domain[1];
  var r0 = range3[0];
  var r1 = range3[1];
  var subDomain = d1 - d0;
  var subRange = r1 - r0;
  if (subDomain === 0) {
    return subRange === 0 ? r0 : (r0 + r1) / 2;
  }
  if (clamp2) {
    if (subDomain > 0) {
      if (val <= d0) {
        return r0;
      } else if (val >= d1) {
        return r1;
      }
    } else {
      if (val >= d0) {
        return r0;
      } else if (val <= d1) {
        return r1;
      }
    }
  } else {
    if (val === d0) {
      return r0;
    }
    if (val === d1) {
      return r1;
    }
  }
  return (val - d0) / subDomain * subRange + r0;
}
function parsePercent(percent, all) {
  switch (percent) {
    case "center":
    case "middle":
      percent = "50%";
      break;
    case "left":
    case "top":
      percent = "0%";
      break;
    case "right":
    case "bottom":
      percent = "100%";
      break;
  }
  if (isString(percent)) {
    if (_trim(percent).match(/%$/)) {
      return parseFloat(percent) / 100 * all;
    }
    return parseFloat(percent);
  }
  return percent == null ? NaN : +percent;
}
function round$3(x2, precision, returnStr) {
  if (precision == null) {
    precision = 10;
  }
  precision = Math.min(Math.max(0, precision), ROUND_SUPPORTED_PRECISION_MAX);
  x2 = (+x2).toFixed(precision);
  return returnStr ? x2 : +x2;
}
function asc$2(arr) {
  arr.sort(function(a, b2) {
    return a - b2;
  });
  return arr;
}
function getPrecision(val) {
  val = +val;
  if (isNaN(val)) {
    return 0;
  }
  if (val > 1e-14) {
    var e2 = 1;
    for (var i = 0; i < 15; i++, e2 *= 10) {
      if (Math.round(val * e2) / e2 === val) {
        return i;
      }
    }
  }
  return getPrecisionSafe(val);
}
function getPrecisionSafe(val) {
  var str = val.toString().toLowerCase();
  var eIndex = str.indexOf("e");
  var exp = eIndex > 0 ? +str.slice(eIndex + 1) : 0;
  var significandPartLen = eIndex > 0 ? eIndex : str.length;
  var dotIndex = str.indexOf(".");
  var decimalPartLen = dotIndex < 0 ? 0 : significandPartLen - 1 - dotIndex;
  return Math.max(0, decimalPartLen - exp);
}
function getPixelPrecision(dataExtent, pixelExtent) {
  var log = Math.log;
  var LN10 = Math.LN10;
  var dataQuantity = Math.floor(log(dataExtent[1] - dataExtent[0]) / LN10);
  var sizeQuantity = Math.round(log(Math.abs(pixelExtent[1] - pixelExtent[0])) / LN10);
  var precision = Math.min(Math.max(-dataQuantity + sizeQuantity, 0), 20);
  return !isFinite(precision) ? 20 : precision;
}
function getPercentWithPrecision(valueList, idx, precision) {
  if (!valueList[idx]) {
    return 0;
  }
  var sum2 = reduce(valueList, function(acc, val) {
    return acc + (isNaN(val) ? 0 : val);
  }, 0);
  if (sum2 === 0) {
    return 0;
  }
  var digits = Math.pow(10, precision);
  var votesPerQuota = map$1(valueList, function(val) {
    return (isNaN(val) ? 0 : val) / sum2 * digits * 100;
  });
  var targetSeats = digits * 100;
  var seats = map$1(votesPerQuota, function(votes) {
    return Math.floor(votes);
  });
  var currentSum = reduce(seats, function(acc, val) {
    return acc + val;
  }, 0);
  var remainder = map$1(votesPerQuota, function(votes, idx2) {
    return votes - seats[idx2];
  });
  while (currentSum < targetSeats) {
    var max3 = Number.NEGATIVE_INFINITY;
    var maxId = null;
    for (var i = 0, len2 = remainder.length; i < len2; ++i) {
      if (remainder[i] > max3) {
        max3 = remainder[i];
        maxId = i;
      }
    }
    ++seats[maxId];
    remainder[maxId] = 0;
    ++currentSum;
  }
  return seats[idx] / digits;
}
function addSafe(val0, val1) {
  var maxPrecision = Math.max(getPrecision(val0), getPrecision(val1));
  var sum2 = val0 + val1;
  return maxPrecision > ROUND_SUPPORTED_PRECISION_MAX ? sum2 : round$3(sum2, maxPrecision);
}
var MAX_SAFE_INTEGER = 9007199254740991;
function remRadian(radian) {
  var pi2 = Math.PI * 2;
  return (radian % pi2 + pi2) % pi2;
}
function isRadianAroundZero(val) {
  return val > -RADIAN_EPSILON && val < RADIAN_EPSILON;
}
var TIME_REG = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
function parseDate(value) {
  if (value instanceof Date) {
    return value;
  } else if (isString(value)) {
    var match = TIME_REG.exec(value);
    if (!match) {
      return new Date(NaN);
    }
    if (!match[8]) {
      return new Date(+match[1], +(match[2] || 1) - 1, +match[3] || 1, +match[4] || 0, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0);
    } else {
      var hour = +match[4] || 0;
      if (match[8].toUpperCase() !== "Z") {
        hour -= +match[8].slice(0, 3);
      }
      return new Date(Date.UTC(+match[1], +(match[2] || 1) - 1, +match[3] || 1, hour, +(match[5] || 0), +match[6] || 0, match[7] ? +match[7].substring(0, 3) : 0));
    }
  } else if (value == null) {
    return new Date(NaN);
  }
  return new Date(Math.round(value));
}
function quantity(val) {
  return Math.pow(10, quantityExponent(val));
}
function quantityExponent(val) {
  if (val === 0) {
    return 0;
  }
  var exp = Math.floor(Math.log(val) / Math.LN10);
  if (val / Math.pow(10, exp) >= 10) {
    exp++;
  }
  return exp;
}
function nice(val, round2) {
  var exponent = quantityExponent(val);
  var exp10 = Math.pow(10, exponent);
  var f2 = val / exp10;
  var nf;
  if (round2) {
    if (f2 < 1.5) {
      nf = 1;
    } else if (f2 < 2.5) {
      nf = 2;
    } else if (f2 < 4) {
      nf = 3;
    } else if (f2 < 7) {
      nf = 5;
    } else {
      nf = 10;
    }
  } else {
    if (f2 < 1) {
      nf = 1;
    } else if (f2 < 2) {
      nf = 2;
    } else if (f2 < 3) {
      nf = 3;
    } else if (f2 < 5) {
      nf = 5;
    } else {
      nf = 10;
    }
  }
  val = nf * exp10;
  return exponent >= -20 ? +val.toFixed(exponent < 0 ? -exponent : 0) : val;
}
function quantile(ascArr, p2) {
  var H = (ascArr.length - 1) * p2 + 1;
  var h = Math.floor(H);
  var v4 = +ascArr[h - 1];
  var e2 = H - h;
  return e2 ? v4 + e2 * (ascArr[h] - v4) : v4;
}
function reformIntervals(list) {
  list.sort(function(a, b2) {
    return littleThan2(a, b2, 0) ? -1 : 1;
  });
  var curr = -Infinity;
  var currClose = 1;
  for (var i = 0; i < list.length; ) {
    var interval = list[i].interval;
    var close_1 = list[i].close;
    for (var lg = 0; lg < 2; lg++) {
      if (interval[lg] <= curr) {
        interval[lg] = curr;
        close_1[lg] = !lg ? 1 - currClose : 1;
      }
      curr = interval[lg];
      currClose = close_1[lg];
    }
    if (interval[0] === interval[1] && close_1[0] * close_1[1] !== 1) {
      list.splice(i, 1);
    } else {
      i++;
    }
  }
  return list;
  function littleThan2(a, b2, lg2) {
    return a.interval[lg2] < b2.interval[lg2] || a.interval[lg2] === b2.interval[lg2] && (a.close[lg2] - b2.close[lg2] === (!lg2 ? 1 : -1) || !lg2 && littleThan2(a, b2, 1));
  }
}
function numericToNumber(val) {
  var valFloat = parseFloat(val);
  return valFloat == val && (valFloat !== 0 || !isString(val) || val.indexOf("x") <= 0) ? valFloat : NaN;
}
function isNumeric(val) {
  return !isNaN(numericToNumber(val));
}
function getRandomIdBase() {
  return Math.round(Math.random() * 9);
}
function getGreatestCommonDividor(a, b2) {
  if (b2 === 0) {
    return a;
  }
  return getGreatestCommonDividor(b2, a % b2);
}
function getLeastCommonMultiple(a, b2) {
  if (a == null) {
    return b2;
  }
  if (b2 == null) {
    return a;
  }
  return a * b2 / getGreatestCommonDividor(a, b2);
}
function throwError(msg) {
  throw new Error(msg);
}
function interpolateNumber(p0, p1, percent) {
  return (p1 - p0) * percent + p0;
}
var DUMMY_COMPONENT_NAME_PREFIX = "series\0";
var INTERNAL_COMPONENT_ID_PREFIX = "\0_ec_\0";
function normalizeToArray(value) {
  return value instanceof Array ? value : value == null ? [] : [value];
}
function defaultEmphasis(opt, key, subOpts) {
  if (opt) {
    opt[key] = opt[key] || {};
    opt.emphasis = opt.emphasis || {};
    opt.emphasis[key] = opt.emphasis[key] || {};
    for (var i = 0, len2 = subOpts.length; i < len2; i++) {
      var subOptName = subOpts[i];
      if (!opt.emphasis[key].hasOwnProperty(subOptName) && opt[key].hasOwnProperty(subOptName)) {
        opt.emphasis[key][subOptName] = opt[key][subOptName];
      }
    }
  }
}
var TEXT_STYLE_OPTIONS = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
function getDataItemValue(dataItem) {
  return isObject$4(dataItem) && !isArray$1(dataItem) && !(dataItem instanceof Date) ? dataItem.value : dataItem;
}
function isDataItemOption(dataItem) {
  return isObject$4(dataItem) && !(dataItem instanceof Array);
}
function mappingToExists(existings, newCmptOptions, mode) {
  var isNormalMergeMode = mode === "normalMerge";
  var isReplaceMergeMode = mode === "replaceMerge";
  var isReplaceAllMode = mode === "replaceAll";
  existings = existings || [];
  newCmptOptions = (newCmptOptions || []).slice();
  var existingIdIdxMap = createHashMap();
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!isObject$4(cmptOption)) {
      newCmptOptions[index2] = null;
      return;
    }
  });
  var result = prepareResult(existings, existingIdIdxMap, mode);
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingById(result, existings, existingIdIdxMap, newCmptOptions);
  }
  if (isNormalMergeMode) {
    mappingByName(result, newCmptOptions);
  }
  if (isNormalMergeMode || isReplaceMergeMode) {
    mappingByIndex(result, newCmptOptions, isReplaceMergeMode);
  } else if (isReplaceAllMode) {
    mappingInReplaceAllMode(result, newCmptOptions);
  }
  makeIdAndName(result);
  return result;
}
function prepareResult(existings, existingIdIdxMap, mode) {
  var result = [];
  if (mode === "replaceAll") {
    return result;
  }
  for (var index2 = 0; index2 < existings.length; index2++) {
    var existing = existings[index2];
    if (existing && existing.id != null) {
      existingIdIdxMap.set(existing.id, index2);
    }
    result.push({
      existing: mode === "replaceMerge" || isComponentIdInternal(existing) ? null : existing,
      newOption: null,
      keyInfo: null,
      brandNew: null
    });
  }
  return result;
}
function mappingById(result, existings, existingIdIdxMap, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.id == null) {
      return;
    }
    var optionId = makeComparableKey(cmptOption.id);
    var existingIdx = existingIdIdxMap.get(optionId);
    if (existingIdx != null) {
      var resultItem = result[existingIdx];
      assert(!resultItem.newOption, 'Duplicated option on id "' + optionId + '".');
      resultItem.newOption = cmptOption;
      resultItem.existing = existings[existingIdx];
      newCmptOptions[index2] = null;
    }
  });
}
function mappingByName(result, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption, index2) {
    if (!cmptOption || cmptOption.name == null) {
      return;
    }
    for (var i = 0; i < result.length; i++) {
      var existing = result[i].existing;
      if (!result[i].newOption && existing && (existing.id == null || cmptOption.id == null) && !isComponentIdInternal(cmptOption) && !isComponentIdInternal(existing) && keyExistAndEqual("name", existing, cmptOption)) {
        result[i].newOption = cmptOption;
        newCmptOptions[index2] = null;
        return;
      }
    }
  });
}
function mappingByIndex(result, newCmptOptions, brandNew) {
  each$f(newCmptOptions, function(cmptOption) {
    if (!cmptOption) {
      return;
    }
    var resultItem;
    var nextIdx = 0;
    while ((resultItem = result[nextIdx]) && (resultItem.newOption || isComponentIdInternal(resultItem.existing) || resultItem.existing && cmptOption.id != null && !keyExistAndEqual("id", cmptOption, resultItem.existing))) {
      nextIdx++;
    }
    if (resultItem) {
      resultItem.newOption = cmptOption;
      resultItem.brandNew = brandNew;
    } else {
      result.push({
        newOption: cmptOption,
        brandNew,
        existing: null,
        keyInfo: null
      });
    }
    nextIdx++;
  });
}
function mappingInReplaceAllMode(result, newCmptOptions) {
  each$f(newCmptOptions, function(cmptOption) {
    result.push({
      newOption: cmptOption,
      brandNew: true,
      existing: null,
      keyInfo: null
    });
  });
}
function makeIdAndName(mapResult) {
  var idMap = createHashMap();
  each$f(mapResult, function(item) {
    var existing = item.existing;
    existing && idMap.set(existing.id, item);
  });
  each$f(mapResult, function(item) {
    var opt = item.newOption;
    assert(!opt || opt.id == null || !idMap.get(opt.id) || idMap.get(opt.id) === item, "id duplicates: " + (opt && opt.id));
    opt && opt.id != null && idMap.set(opt.id, item);
    !item.keyInfo && (item.keyInfo = {});
  });
  each$f(mapResult, function(item, index2) {
    var existing = item.existing;
    var opt = item.newOption;
    var keyInfo = item.keyInfo;
    if (!isObject$4(opt)) {
      return;
    }
    keyInfo.name = opt.name != null ? makeComparableKey(opt.name) : existing ? existing.name : DUMMY_COMPONENT_NAME_PREFIX + index2;
    if (existing) {
      keyInfo.id = makeComparableKey(existing.id);
    } else if (opt.id != null) {
      keyInfo.id = makeComparableKey(opt.id);
    } else {
      var idNum = 0;
      do {
        keyInfo.id = "\0" + keyInfo.name + "\0" + idNum++;
      } while (idMap.get(keyInfo.id));
    }
    idMap.set(keyInfo.id, item);
  });
}
function keyExistAndEqual(attr, obj1, obj2) {
  var key1 = convertOptionIdName(obj1[attr], null);
  var key2 = convertOptionIdName(obj2[attr], null);
  return key1 != null && key2 != null && key1 === key2;
}
function makeComparableKey(val) {
  return convertOptionIdName(val, "");
}
function convertOptionIdName(idOrName, defaultValue) {
  if (idOrName == null) {
    return defaultValue;
  }
  return isString(idOrName) ? idOrName : isNumber(idOrName) || isStringSafe(idOrName) ? idOrName + "" : defaultValue;
}
function isNameSpecified(componentModel) {
  var name = componentModel.name;
  return !!(name && name.indexOf(DUMMY_COMPONENT_NAME_PREFIX));
}
function isComponentIdInternal(cmptOption) {
  return cmptOption && cmptOption.id != null && makeComparableKey(cmptOption.id).indexOf(INTERNAL_COMPONENT_ID_PREFIX) === 0;
}
function makeInternalComponentId(idSuffix) {
  return INTERNAL_COMPONENT_ID_PREFIX + idSuffix;
}
function setComponentTypeToKeyInfo(mappingResult, mainType, componentModelCtor) {
  each$f(mappingResult, function(item) {
    var newOption = item.newOption;
    if (isObject$4(newOption)) {
      item.keyInfo.mainType = mainType;
      item.keyInfo.subType = determineSubType(mainType, newOption, item.existing, componentModelCtor);
    }
  });
}
function determineSubType(mainType, newCmptOption, existComponent, componentModelCtor) {
  var subType = newCmptOption.type ? newCmptOption.type : existComponent ? existComponent.subType : componentModelCtor.determineSubType(mainType, newCmptOption);
  return subType;
}
function compressBatches(batchA, batchB) {
  var mapA = {};
  var mapB = {};
  makeMap(batchA || [], mapA);
  makeMap(batchB || [], mapB, mapA);
  return [mapToArray(mapA), mapToArray(mapB)];
  function makeMap(sourceBatch, map2, otherMap) {
    for (var i = 0, len2 = sourceBatch.length; i < len2; i++) {
      var seriesId = convertOptionIdName(sourceBatch[i].seriesId, null);
      if (seriesId == null) {
        return;
      }
      var dataIndices = normalizeToArray(sourceBatch[i].dataIndex);
      var otherDataIndices = otherMap && otherMap[seriesId];
      for (var j = 0, lenj = dataIndices.length; j < lenj; j++) {
        var dataIndex = dataIndices[j];
        if (otherDataIndices && otherDataIndices[dataIndex]) {
          otherDataIndices[dataIndex] = null;
        } else {
          (map2[seriesId] || (map2[seriesId] = {}))[dataIndex] = 1;
        }
      }
    }
  }
  function mapToArray(map2, isData) {
    var result = [];
    for (var i in map2) {
      if (map2.hasOwnProperty(i) && map2[i] != null) {
        if (isData) {
          result.push(+i);
        } else {
          var dataIndices = mapToArray(map2[i], true);
          dataIndices.length && result.push({
            seriesId: i,
            dataIndex: dataIndices
          });
        }
      }
    }
    return result;
  }
}
function queryDataIndex(data, payload) {
  if (payload.dataIndexInside != null) {
    return payload.dataIndexInside;
  } else if (payload.dataIndex != null) {
    return isArray$1(payload.dataIndex) ? map$1(payload.dataIndex, function(value) {
      return data.indexOfRawIndex(value);
    }) : data.indexOfRawIndex(payload.dataIndex);
  } else if (payload.name != null) {
    return isArray$1(payload.name) ? map$1(payload.name, function(value) {
      return data.indexOfName(value);
    }) : data.indexOfName(payload.name);
  }
}
function makeInner() {
  var key = "__ec_inner_" + innerUniqueIndex++;
  return function(hostObj) {
    return hostObj[key] || (hostObj[key] = {});
  };
}
var innerUniqueIndex = getRandomIdBase();
function parseFinder$1(ecModel, finderInput, opt) {
  var _a2 = preParseFinder(finderInput, opt), mainTypeSpecified = _a2.mainTypeSpecified, queryOptionMap = _a2.queryOptionMap, others = _a2.others;
  var result = others;
  var defaultMainType = opt ? opt.defaultMainType : null;
  if (!mainTypeSpecified && defaultMainType) {
    queryOptionMap.set(defaultMainType, {});
  }
  queryOptionMap.each(function(queryOption, mainType) {
    var queryResult = queryReferringComponents(ecModel, mainType, queryOption, {
      useDefault: defaultMainType === mainType,
      enableAll: opt && opt.enableAll != null ? opt.enableAll : true,
      enableNone: opt && opt.enableNone != null ? opt.enableNone : true
    });
    result[mainType + "Models"] = queryResult.models;
    result[mainType + "Model"] = queryResult.models[0];
  });
  return result;
}
function preParseFinder(finderInput, opt) {
  var finder;
  if (isString(finderInput)) {
    var obj = {};
    obj[finderInput + "Index"] = 0;
    finder = obj;
  } else {
    finder = finderInput;
  }
  var queryOptionMap = createHashMap();
  var others = {};
  var mainTypeSpecified = false;
  each$f(finder, function(value, key) {
    if (key === "dataIndex" || key === "dataIndexInside") {
      others[key] = value;
      return;
    }
    var parsedKey = key.match(/^(\w+)(Index|Id|Name)$/) || [];
    var mainType = parsedKey[1];
    var queryType = (parsedKey[2] || "").toLowerCase();
    if (!mainType || !queryType || opt && opt.includeMainTypes && indexOf(opt.includeMainTypes, mainType) < 0) {
      return;
    }
    mainTypeSpecified = mainTypeSpecified || !!mainType;
    var queryOption = queryOptionMap.get(mainType) || queryOptionMap.set(mainType, {});
    queryOption[queryType] = value;
  });
  return {
    mainTypeSpecified,
    queryOptionMap,
    others
  };
}
var SINGLE_REFERRING = {
  useDefault: true,
  enableAll: false,
  enableNone: false
};
var MULTIPLE_REFERRING = {
  useDefault: false,
  enableAll: true,
  enableNone: true
};
function queryReferringComponents(ecModel, mainType, userOption, opt) {
  opt = opt || SINGLE_REFERRING;
  var indexOption = userOption.index;
  var idOption = userOption.id;
  var nameOption = userOption.name;
  var result = {
    models: null,
    specified: indexOption != null || idOption != null || nameOption != null
  };
  if (!result.specified) {
    var firstCmpt = void 0;
    result.models = opt.useDefault && (firstCmpt = ecModel.getComponent(mainType)) ? [firstCmpt] : [];
    return result;
  }
  if (indexOption === "none" || indexOption === false) {
    assert(opt.enableNone, '`"none"` or `false` is not a valid value on index option.');
    result.models = [];
    return result;
  }
  if (indexOption === "all") {
    assert(opt.enableAll, '`"all"` is not a valid value on index option.');
    indexOption = idOption = nameOption = null;
  }
  result.models = ecModel.queryComponents({
    mainType,
    index: indexOption,
    id: idOption,
    name: nameOption
  });
  return result;
}
function setAttribute(dom, key, value) {
  dom.setAttribute ? dom.setAttribute(key, value) : dom[key] = value;
}
function getAttribute(dom, key) {
  return dom.getAttribute ? dom.getAttribute(key) : dom[key];
}
function getTooltipRenderMode(renderModeOption) {
  if (renderModeOption === "auto") {
    return env$1.domSupported ? "html" : "richText";
  } else {
    return renderModeOption || "html";
  }
}
function groupData(array4, getKey2) {
  var buckets = createHashMap();
  var keys2 = [];
  each$f(array4, function(item) {
    var key = getKey2(item);
    (buckets.get(key) || (keys2.push(key), buckets.set(key, []))).push(item);
  });
  return {
    keys: keys2,
    buckets
  };
}
function interpolateRawValues(data, precision, sourceValue, targetValue, percent) {
  var isAutoPrecision = precision == null || precision === "auto";
  if (targetValue == null) {
    return targetValue;
  }
  if (isNumber(targetValue)) {
    var value = interpolateNumber(sourceValue || 0, targetValue, percent);
    return round$3(value, isAutoPrecision ? Math.max(getPrecision(sourceValue || 0), getPrecision(targetValue)) : precision);
  } else if (isString(targetValue)) {
    return percent < 1 ? sourceValue : targetValue;
  } else {
    var interpolated = [];
    var leftArr = sourceValue;
    var rightArr = targetValue;
    var length_1 = Math.max(leftArr ? leftArr.length : 0, rightArr.length);
    for (var i = 0; i < length_1; ++i) {
      var info = data.getDimensionInfo(i);
      if (info && info.type === "ordinal") {
        interpolated[i] = (percent < 1 && leftArr ? leftArr : rightArr)[i];
      } else {
        var leftVal = leftArr && leftArr[i] ? leftArr[i] : 0;
        var rightVal = rightArr[i];
        var value = interpolateNumber(leftVal, rightVal, percent);
        interpolated[i] = round$3(value, isAutoPrecision ? Math.max(getPrecision(leftVal), getPrecision(rightVal)) : precision);
      }
    }
    return interpolated;
  }
}
var TYPE_DELIMITER = ".";
var IS_CONTAINER = "___EC__COMPONENT__CONTAINER___";
var IS_EXTENDED_CLASS = "___EC__EXTENDED_CLASS___";
function parseClassType(componentType) {
  var ret = {
    main: "",
    sub: ""
  };
  if (componentType) {
    var typeArr = componentType.split(TYPE_DELIMITER);
    ret.main = typeArr[0] || "";
    ret.sub = typeArr[1] || "";
  }
  return ret;
}
function checkClassType(componentType) {
  assert(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(componentType), 'componentType "' + componentType + '" illegal');
}
function isExtendedClass(clz) {
  return !!(clz && clz[IS_EXTENDED_CLASS]);
}
function enableClassExtend(rootClz, mandatoryMethods) {
  rootClz.$constructor = rootClz;
  rootClz.extend = function(proto2) {
    var superClass = this;
    var ExtendedClass;
    if (isESClass(superClass)) {
      ExtendedClass = function(_super) {
        __extends(class_1, _super);
        function class_1() {
          return _super.apply(this, arguments) || this;
        }
        return class_1;
      }(superClass);
    } else {
      ExtendedClass = function() {
        (proto2.$constructor || superClass).apply(this, arguments);
      };
      inherits(ExtendedClass, this);
    }
    extend(ExtendedClass.prototype, proto2);
    ExtendedClass[IS_EXTENDED_CLASS] = true;
    ExtendedClass.extend = this.extend;
    ExtendedClass.superCall = superCall;
    ExtendedClass.superApply = superApply;
    ExtendedClass.superClass = superClass;
    return ExtendedClass;
  };
}
function isESClass(fn) {
  return isFunction(fn) && /^class\s/.test(Function.prototype.toString.call(fn));
}
function mountExtend(SubClz, SupperClz) {
  SubClz.extend = SupperClz.extend;
}
var classBase = Math.round(Math.random() * 10);
function enableClassCheck(target) {
  var classAttr = ["__\0is_clz", classBase++].join("_");
  target.prototype[classAttr] = true;
  target.isInstance = function(obj) {
    return !!(obj && obj[classAttr]);
  };
}
function superCall(context, methodName) {
  var args = [];
  for (var _i = 2; _i < arguments.length; _i++) {
    args[_i - 2] = arguments[_i];
  }
  return this.superClass.prototype[methodName].apply(context, args);
}
function superApply(context, methodName, args) {
  return this.superClass.prototype[methodName].apply(context, args);
}
function enableClassManagement(target) {
  var storage2 = {};
  target.registerClass = function(clz) {
    var componentFullType = clz.type || clz.prototype.type;
    if (componentFullType) {
      checkClassType(componentFullType);
      clz.prototype.type = componentFullType;
      var componentTypeInfo = parseClassType(componentFullType);
      if (!componentTypeInfo.sub) {
        storage2[componentTypeInfo.main] = clz;
      } else if (componentTypeInfo.sub !== IS_CONTAINER) {
        var container2 = makeContainer(componentTypeInfo);
        container2[componentTypeInfo.sub] = clz;
      }
    }
    return clz;
  };
  target.getClass = function(mainType, subType, throwWhenNotFound) {
    var clz = storage2[mainType];
    if (clz && clz[IS_CONTAINER]) {
      clz = subType ? clz[subType] : null;
    }
    if (throwWhenNotFound && !clz) {
      throw new Error(!subType ? mainType + ".type should be specified." : "Component " + mainType + "." + (subType || "") + " is used but not imported.");
    }
    return clz;
  };
  target.getClassesByMainType = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var result = [];
    var obj = storage2[componentTypeInfo.main];
    if (obj && obj[IS_CONTAINER]) {
      each$f(obj, function(o, type4) {
        type4 !== IS_CONTAINER && result.push(o);
      });
    } else {
      result.push(obj);
    }
    return result;
  };
  target.hasClass = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    return !!storage2[componentTypeInfo.main];
  };
  target.getAllClassMainTypes = function() {
    var types2 = [];
    each$f(storage2, function(obj, type4) {
      types2.push(type4);
    });
    return types2;
  };
  target.hasSubTypes = function(componentType) {
    var componentTypeInfo = parseClassType(componentType);
    var obj = storage2[componentTypeInfo.main];
    return obj && obj[IS_CONTAINER];
  };
  function makeContainer(componentTypeInfo) {
    var container2 = storage2[componentTypeInfo.main];
    if (!container2 || !container2[IS_CONTAINER]) {
      container2 = storage2[componentTypeInfo.main] = {};
      container2[IS_CONTAINER] = true;
    }
    return container2;
  }
}
function makeStyleMapper(properties, ignoreParent) {
  for (var i = 0; i < properties.length; i++) {
    if (!properties[i][1]) {
      properties[i][1] = properties[i][0];
    }
  }
  ignoreParent = ignoreParent || false;
  return function(model, excludes, includes) {
    var style = {};
    for (var i2 = 0; i2 < properties.length; i2++) {
      var propName = properties[i2][1];
      if (excludes && indexOf(excludes, propName) >= 0 || includes && indexOf(includes, propName) < 0) {
        continue;
      }
      var val = model.getShallow(propName, ignoreParent);
      if (val != null) {
        style[properties[i2][0]] = val;
      }
    }
    return style;
  };
}
var AREA_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["opacity"],
  ["shadowColor"]
];
var getAreaStyle = makeStyleMapper(AREA_STYLE_KEY_MAP);
var AreaStyleMixin = function() {
  function AreaStyleMixin2() {
  }
  AreaStyleMixin2.prototype.getAreaStyle = function(excludes, includes) {
    return getAreaStyle(this, excludes, includes);
  };
  return AreaStyleMixin2;
}();
var globalImageCache = new LRU$1(50);
function findExistImage(newImageOrSrc) {
  if (typeof newImageOrSrc === "string") {
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    return cachedImgObj && cachedImgObj.image;
  } else {
    return newImageOrSrc;
  }
}
function createOrUpdateImage(newImageOrSrc, image, hostEl, onload, cbPayload) {
  if (!newImageOrSrc) {
    return image;
  } else if (typeof newImageOrSrc === "string") {
    if (image && image.__zrImageSrc === newImageOrSrc || !hostEl) {
      return image;
    }
    var cachedImgObj = globalImageCache.get(newImageOrSrc);
    var pendingWrap = { hostEl, cb: onload, cbPayload };
    if (cachedImgObj) {
      image = cachedImgObj.image;
      !isImageReady(image) && cachedImgObj.pending.push(pendingWrap);
    } else {
      var image_1 = platformApi.loadImage(newImageOrSrc, imageOnLoad, imageOnLoad);
      image_1.__zrImageSrc = newImageOrSrc;
      globalImageCache.put(newImageOrSrc, image_1.__cachedImgObj = {
        image: image_1,
        pending: [pendingWrap]
      });
    }
    return image;
  } else {
    return newImageOrSrc;
  }
}
function imageOnLoad() {
  var cachedImgObj = this.__cachedImgObj;
  this.onload = this.onerror = this.__cachedImgObj = null;
  for (var i = 0; i < cachedImgObj.pending.length; i++) {
    var pendingWrap = cachedImgObj.pending[i];
    var cb = pendingWrap.cb;
    cb && cb(this, pendingWrap.cbPayload);
    pendingWrap.hostEl.dirty();
  }
  cachedImgObj.pending.length = 0;
}
function isImageReady(image) {
  return image && image.width && image.height;
}
var STYLE_REG = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
function truncateText(text, containerWidth, font, ellipsis, options) {
  if (!containerWidth) {
    return "";
  }
  var textLines = (text + "").split("\n");
  options = prepareTruncateOptions(containerWidth, font, ellipsis, options);
  for (var i = 0, len2 = textLines.length; i < len2; i++) {
    textLines[i] = truncateSingleLine(textLines[i], options);
  }
  return textLines.join("\n");
}
function prepareTruncateOptions(containerWidth, font, ellipsis, options) {
  options = options || {};
  var preparedOpts = extend({}, options);
  preparedOpts.font = font;
  ellipsis = retrieve2(ellipsis, "...");
  preparedOpts.maxIterations = retrieve2(options.maxIterations, 2);
  var minChar = preparedOpts.minChar = retrieve2(options.minChar, 0);
  preparedOpts.cnCharWidth = getWidth("\u56FD", font);
  var ascCharWidth = preparedOpts.ascCharWidth = getWidth("a", font);
  preparedOpts.placeholder = retrieve2(options.placeholder, "");
  var contentWidth = containerWidth = Math.max(0, containerWidth - 1);
  for (var i = 0; i < minChar && contentWidth >= ascCharWidth; i++) {
    contentWidth -= ascCharWidth;
  }
  var ellipsisWidth = getWidth(ellipsis, font);
  if (ellipsisWidth > contentWidth) {
    ellipsis = "";
    ellipsisWidth = 0;
  }
  contentWidth = containerWidth - ellipsisWidth;
  preparedOpts.ellipsis = ellipsis;
  preparedOpts.ellipsisWidth = ellipsisWidth;
  preparedOpts.contentWidth = contentWidth;
  preparedOpts.containerWidth = containerWidth;
  return preparedOpts;
}
function truncateSingleLine(textLine, options) {
  var containerWidth = options.containerWidth;
  var font = options.font;
  var contentWidth = options.contentWidth;
  if (!containerWidth) {
    return "";
  }
  var lineWidth = getWidth(textLine, font);
  if (lineWidth <= containerWidth) {
    return textLine;
  }
  for (var j = 0; ; j++) {
    if (lineWidth <= contentWidth || j >= options.maxIterations) {
      textLine += options.ellipsis;
      break;
    }
    var subLength = j === 0 ? estimateLength(textLine, contentWidth, options.ascCharWidth, options.cnCharWidth) : lineWidth > 0 ? Math.floor(textLine.length * contentWidth / lineWidth) : 0;
    textLine = textLine.substr(0, subLength);
    lineWidth = getWidth(textLine, font);
  }
  if (textLine === "") {
    textLine = options.placeholder;
  }
  return textLine;
}
function estimateLength(text, contentWidth, ascCharWidth, cnCharWidth) {
  var width = 0;
  var i = 0;
  for (var len2 = text.length; i < len2 && width < contentWidth; i++) {
    var charCode = text.charCodeAt(i);
    width += 0 <= charCode && charCode <= 127 ? ascCharWidth : cnCharWidth;
  }
  return i;
}
function parsePlainText(text, style) {
  text != null && (text += "");
  var overflow = style.overflow;
  var padding = style.padding;
  var font = style.font;
  var truncate = overflow === "truncate";
  var calculatedLineHeight = getLineHeight(font);
  var lineHeight = retrieve2(style.lineHeight, calculatedLineHeight);
  var bgColorDrawn = !!style.backgroundColor;
  var truncateLineOverflow = style.lineOverflow === "truncate";
  var width = style.width;
  var lines;
  if (width != null && (overflow === "break" || overflow === "breakAll")) {
    lines = text ? wrapText(text, style.font, width, overflow === "breakAll", 0).lines : [];
  } else {
    lines = text ? text.split("\n") : [];
  }
  var contentHeight = lines.length * lineHeight;
  var height = retrieve2(style.height, contentHeight);
  if (contentHeight > height && truncateLineOverflow) {
    var lineCount = Math.floor(height / lineHeight);
    lines = lines.slice(0, lineCount);
  }
  if (text && truncate && width != null) {
    var options = prepareTruncateOptions(width, font, style.ellipsis, {
      minChar: style.truncateMinChar,
      placeholder: style.placeholder
    });
    for (var i = 0; i < lines.length; i++) {
      lines[i] = truncateSingleLine(lines[i], options);
    }
  }
  var outerHeight = height;
  var contentWidth = 0;
  for (var i = 0; i < lines.length; i++) {
    contentWidth = Math.max(getWidth(lines[i], font), contentWidth);
  }
  if (width == null) {
    width = contentWidth;
  }
  var outerWidth = contentWidth;
  if (padding) {
    outerHeight += padding[0] + padding[2];
    outerWidth += padding[1] + padding[3];
    width += padding[1] + padding[3];
  }
  if (bgColorDrawn) {
    outerWidth = width;
  }
  return {
    lines,
    height,
    outerWidth,
    outerHeight,
    lineHeight,
    calculatedLineHeight,
    contentWidth,
    contentHeight,
    width
  };
}
var RichTextToken = function() {
  function RichTextToken2() {
  }
  return RichTextToken2;
}();
var RichTextLine = function() {
  function RichTextLine2(tokens) {
    this.tokens = [];
    if (tokens) {
      this.tokens = tokens;
    }
  }
  return RichTextLine2;
}();
var RichTextContentBlock = function() {
  function RichTextContentBlock2() {
    this.width = 0;
    this.height = 0;
    this.contentWidth = 0;
    this.contentHeight = 0;
    this.outerWidth = 0;
    this.outerHeight = 0;
    this.lines = [];
  }
  return RichTextContentBlock2;
}();
function parseRichText(text, style) {
  var contentBlock = new RichTextContentBlock();
  text != null && (text += "");
  if (!text) {
    return contentBlock;
  }
  var topWidth = style.width;
  var topHeight = style.height;
  var overflow = style.overflow;
  var wrapInfo = (overflow === "break" || overflow === "breakAll") && topWidth != null ? { width: topWidth, accumWidth: 0, breakAll: overflow === "breakAll" } : null;
  var lastIndex = STYLE_REG.lastIndex = 0;
  var result;
  while ((result = STYLE_REG.exec(text)) != null) {
    var matchedIndex = result.index;
    if (matchedIndex > lastIndex) {
      pushTokens(contentBlock, text.substring(lastIndex, matchedIndex), style, wrapInfo);
    }
    pushTokens(contentBlock, result[2], style, wrapInfo, result[1]);
    lastIndex = STYLE_REG.lastIndex;
  }
  if (lastIndex < text.length) {
    pushTokens(contentBlock, text.substring(lastIndex, text.length), style, wrapInfo);
  }
  var pendingList = [];
  var calculatedHeight = 0;
  var calculatedWidth = 0;
  var stlPadding = style.padding;
  var truncate = overflow === "truncate";
  var truncateLine = style.lineOverflow === "truncate";
  function finishLine(line2, lineWidth2, lineHeight2) {
    line2.width = lineWidth2;
    line2.lineHeight = lineHeight2;
    calculatedHeight += lineHeight2;
    calculatedWidth = Math.max(calculatedWidth, lineWidth2);
  }
  outer:
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var lineHeight = 0;
      var lineWidth = 0;
      for (var j = 0; j < line.tokens.length; j++) {
        var token = line.tokens[j];
        var tokenStyle = token.styleName && style.rich[token.styleName] || {};
        var textPadding = token.textPadding = tokenStyle.padding;
        var paddingH = textPadding ? textPadding[1] + textPadding[3] : 0;
        var font = token.font = tokenStyle.font || style.font;
        token.contentHeight = getLineHeight(font);
        var tokenHeight = retrieve2(tokenStyle.height, token.contentHeight);
        token.innerHeight = tokenHeight;
        textPadding && (tokenHeight += textPadding[0] + textPadding[2]);
        token.height = tokenHeight;
        token.lineHeight = retrieve3(tokenStyle.lineHeight, style.lineHeight, tokenHeight);
        token.align = tokenStyle && tokenStyle.align || style.align;
        token.verticalAlign = tokenStyle && tokenStyle.verticalAlign || "middle";
        if (truncateLine && topHeight != null && calculatedHeight + token.lineHeight > topHeight) {
          if (j > 0) {
            line.tokens = line.tokens.slice(0, j);
            finishLine(line, lineWidth, lineHeight);
            contentBlock.lines = contentBlock.lines.slice(0, i + 1);
          } else {
            contentBlock.lines = contentBlock.lines.slice(0, i);
          }
          break outer;
        }
        var styleTokenWidth = tokenStyle.width;
        var tokenWidthNotSpecified = styleTokenWidth == null || styleTokenWidth === "auto";
        if (typeof styleTokenWidth === "string" && styleTokenWidth.charAt(styleTokenWidth.length - 1) === "%") {
          token.percentWidth = styleTokenWidth;
          pendingList.push(token);
          token.contentWidth = getWidth(token.text, font);
        } else {
          if (tokenWidthNotSpecified) {
            var textBackgroundColor = tokenStyle.backgroundColor;
            var bgImg = textBackgroundColor && textBackgroundColor.image;
            if (bgImg) {
              bgImg = findExistImage(bgImg);
              if (isImageReady(bgImg)) {
                token.width = Math.max(token.width, bgImg.width * tokenHeight / bgImg.height);
              }
            }
          }
          var remainTruncWidth = truncate && topWidth != null ? topWidth - lineWidth : null;
          if (remainTruncWidth != null && remainTruncWidth < token.width) {
            if (!tokenWidthNotSpecified || remainTruncWidth < paddingH) {
              token.text = "";
              token.width = token.contentWidth = 0;
            } else {
              token.text = truncateText(token.text, remainTruncWidth - paddingH, font, style.ellipsis, { minChar: style.truncateMinChar });
              token.width = token.contentWidth = getWidth(token.text, font);
            }
          } else {
            token.contentWidth = getWidth(token.text, font);
          }
        }
        token.width += paddingH;
        lineWidth += token.width;
        tokenStyle && (lineHeight = Math.max(lineHeight, token.lineHeight));
      }
      finishLine(line, lineWidth, lineHeight);
    }
  contentBlock.outerWidth = contentBlock.width = retrieve2(topWidth, calculatedWidth);
  contentBlock.outerHeight = contentBlock.height = retrieve2(topHeight, calculatedHeight);
  contentBlock.contentHeight = calculatedHeight;
  contentBlock.contentWidth = calculatedWidth;
  if (stlPadding) {
    contentBlock.outerWidth += stlPadding[1] + stlPadding[3];
    contentBlock.outerHeight += stlPadding[0] + stlPadding[2];
  }
  for (var i = 0; i < pendingList.length; i++) {
    var token = pendingList[i];
    var percentWidth = token.percentWidth;
    token.width = parseInt(percentWidth, 10) / 100 * contentBlock.width;
  }
  return contentBlock;
}
function pushTokens(block, str, style, wrapInfo, styleName) {
  var isEmptyStr = str === "";
  var tokenStyle = styleName && style.rich[styleName] || {};
  var lines = block.lines;
  var font = tokenStyle.font || style.font;
  var newLine = false;
  var strLines;
  var linesWidths;
  if (wrapInfo) {
    var tokenPadding = tokenStyle.padding;
    var tokenPaddingH = tokenPadding ? tokenPadding[1] + tokenPadding[3] : 0;
    if (tokenStyle.width != null && tokenStyle.width !== "auto") {
      var outerWidth_1 = parsePercent$1(tokenStyle.width, wrapInfo.width) + tokenPaddingH;
      if (lines.length > 0) {
        if (outerWidth_1 + wrapInfo.accumWidth > wrapInfo.width) {
          strLines = str.split("\n");
          newLine = true;
        }
      }
      wrapInfo.accumWidth = outerWidth_1;
    } else {
      var res = wrapText(str, font, wrapInfo.width, wrapInfo.breakAll, wrapInfo.accumWidth);
      wrapInfo.accumWidth = res.accumWidth + tokenPaddingH;
      linesWidths = res.linesWidths;
      strLines = res.lines;
    }
  } else {
    strLines = str.split("\n");
  }
  for (var i = 0; i < strLines.length; i++) {
    var text = strLines[i];
    var token = new RichTextToken();
    token.styleName = styleName;
    token.text = text;
    token.isLineHolder = !text && !isEmptyStr;
    if (typeof tokenStyle.width === "number") {
      token.width = tokenStyle.width;
    } else {
      token.width = linesWidths ? linesWidths[i] : getWidth(text, font);
    }
    if (!i && !newLine) {
      var tokens = (lines[lines.length - 1] || (lines[0] = new RichTextLine())).tokens;
      var tokensLen = tokens.length;
      tokensLen === 1 && tokens[0].isLineHolder ? tokens[0] = token : (text || !tokensLen || isEmptyStr) && tokens.push(token);
    } else {
      lines.push(new RichTextLine([token]));
    }
  }
}
function isLatin(ch) {
  var code = ch.charCodeAt(0);
  return code >= 33 && code <= 383;
}
var breakCharMap = reduce(",&?/;] ".split(""), function(obj, ch) {
  obj[ch] = true;
  return obj;
}, {});
function isWordBreakChar(ch) {
  if (isLatin(ch)) {
    if (breakCharMap[ch]) {
      return true;
    }
    return false;
  }
  return true;
}
function wrapText(text, font, lineWidth, isBreakAll, lastAccumWidth) {
  var lines = [];
  var linesWidths = [];
  var line = "";
  var currentWord = "";
  var currentWordWidth = 0;
  var accumWidth = 0;
  for (var i = 0; i < text.length; i++) {
    var ch = text.charAt(i);
    if (ch === "\n") {
      if (currentWord) {
        line += currentWord;
        accumWidth += currentWordWidth;
      }
      lines.push(line);
      linesWidths.push(accumWidth);
      line = "";
      currentWord = "";
      currentWordWidth = 0;
      accumWidth = 0;
      continue;
    }
    var chWidth = getWidth(ch, font);
    var inWord = isBreakAll ? false : !isWordBreakChar(ch);
    if (!lines.length ? lastAccumWidth + accumWidth + chWidth > lineWidth : accumWidth + chWidth > lineWidth) {
      if (!accumWidth) {
        if (inWord) {
          lines.push(currentWord);
          linesWidths.push(currentWordWidth);
          currentWord = ch;
          currentWordWidth = chWidth;
        } else {
          lines.push(ch);
          linesWidths.push(chWidth);
        }
      } else if (line || currentWord) {
        if (inWord) {
          if (!line) {
            line = currentWord;
            currentWord = "";
            currentWordWidth = 0;
            accumWidth = currentWordWidth;
          }
          lines.push(line);
          linesWidths.push(accumWidth - currentWordWidth);
          currentWord += ch;
          currentWordWidth += chWidth;
          line = "";
          accumWidth = currentWordWidth;
        } else {
          if (currentWord) {
            line += currentWord;
            currentWord = "";
            currentWordWidth = 0;
          }
          lines.push(line);
          linesWidths.push(accumWidth);
          line = ch;
          accumWidth = chWidth;
        }
      }
      continue;
    }
    accumWidth += chWidth;
    if (inWord) {
      currentWord += ch;
      currentWordWidth += chWidth;
    } else {
      if (currentWord) {
        line += currentWord;
        currentWord = "";
        currentWordWidth = 0;
      }
      line += ch;
    }
  }
  if (!lines.length && !line) {
    line = text;
    currentWord = "";
    currentWordWidth = 0;
  }
  if (currentWord) {
    line += currentWord;
  }
  if (line) {
    lines.push(line);
    linesWidths.push(accumWidth);
  }
  if (lines.length === 1) {
    accumWidth += lastAccumWidth;
  }
  return {
    accumWidth,
    lines,
    linesWidths
  };
}
var STYLE_MAGIC_KEY = "__zr_style_" + Math.round(Math.random() * 10);
var DEFAULT_COMMON_STYLE = {
  shadowBlur: 0,
  shadowOffsetX: 0,
  shadowOffsetY: 0,
  shadowColor: "#000",
  opacity: 1,
  blend: "source-over"
};
var DEFAULT_COMMON_ANIMATION_PROPS = {
  style: {
    shadowBlur: true,
    shadowOffsetX: true,
    shadowOffsetY: true,
    shadowColor: true,
    opacity: true
  }
};
DEFAULT_COMMON_STYLE[STYLE_MAGIC_KEY] = true;
var PRIMARY_STATES_KEYS = ["z", "z2", "invisible"];
var PRIMARY_STATES_KEYS_IN_HOVER_LAYER = ["invisible"];
var Displayable = function(_super) {
  __extends(Displayable2, _super);
  function Displayable2(props) {
    return _super.call(this, props) || this;
  }
  Displayable2.prototype._init = function(props) {
    var keysArr = keys(props);
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      if (key === "style") {
        this.useStyle(props[key]);
      } else {
        _super.prototype.attrKV.call(this, key, props[key]);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Displayable2.prototype.beforeBrush = function() {
  };
  Displayable2.prototype.afterBrush = function() {
  };
  Displayable2.prototype.innerBeforeBrush = function() {
  };
  Displayable2.prototype.innerAfterBrush = function() {
  };
  Displayable2.prototype.shouldBePainted = function(viewWidth, viewHeight, considerClipPath, considerAncestors) {
    var m2 = this.transform;
    if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && isDisplayableCulled(this, viewWidth, viewHeight) || m2 && !m2[0] && !m2[3]) {
      return false;
    }
    if (considerClipPath && this.__clipPaths) {
      for (var i = 0; i < this.__clipPaths.length; ++i) {
        if (this.__clipPaths[i].isZeroArea()) {
          return false;
        }
      }
    }
    if (considerAncestors && this.parent) {
      var parent_1 = this.parent;
      while (parent_1) {
        if (parent_1.ignore) {
          return false;
        }
        parent_1 = parent_1.parent;
      }
    }
    return true;
  };
  Displayable2.prototype.contain = function(x2, y2) {
    return this.rectContain(x2, y2);
  };
  Displayable2.prototype.traverse = function(cb, context) {
    cb.call(context, this);
  };
  Displayable2.prototype.rectContain = function(x2, y2) {
    var coord = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    return rect.contain(coord[0], coord[1]);
  };
  Displayable2.prototype.getPaintRect = function() {
    var rect = this._paintRect;
    if (!this._paintRect || this.__dirty) {
      var transform2 = this.transform;
      var elRect = this.getBoundingRect();
      var style = this.style;
      var shadowSize = style.shadowBlur || 0;
      var shadowOffsetX = style.shadowOffsetX || 0;
      var shadowOffsetY = style.shadowOffsetY || 0;
      rect = this._paintRect || (this._paintRect = new BoundingRect$1(0, 0, 0, 0));
      if (transform2) {
        BoundingRect$1.applyTransform(rect, elRect, transform2);
      } else {
        rect.copy(elRect);
      }
      if (shadowSize || shadowOffsetX || shadowOffsetY) {
        rect.width += shadowSize * 2 + Math.abs(shadowOffsetX);
        rect.height += shadowSize * 2 + Math.abs(shadowOffsetY);
        rect.x = Math.min(rect.x, rect.x + shadowOffsetX - shadowSize);
        rect.y = Math.min(rect.y, rect.y + shadowOffsetY - shadowSize);
      }
      var tolerance = this.dirtyRectTolerance;
      if (!rect.isZero()) {
        rect.x = Math.floor(rect.x - tolerance);
        rect.y = Math.floor(rect.y - tolerance);
        rect.width = Math.ceil(rect.width + 1 + tolerance * 2);
        rect.height = Math.ceil(rect.height + 1 + tolerance * 2);
      }
    }
    return rect;
  };
  Displayable2.prototype.setPrevPaintRect = function(paintRect) {
    if (paintRect) {
      this._prevPaintRect = this._prevPaintRect || new BoundingRect$1(0, 0, 0, 0);
      this._prevPaintRect.copy(paintRect);
    } else {
      this._prevPaintRect = null;
    }
  };
  Displayable2.prototype.getPrevPaintRect = function() {
    return this._prevPaintRect;
  };
  Displayable2.prototype.animateStyle = function(loop) {
    return this.animate("style", loop);
  };
  Displayable2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else {
      this.markRedraw();
    }
  };
  Displayable2.prototype.attrKV = function(key, value) {
    if (key !== "style") {
      _super.prototype.attrKV.call(this, key, value);
    } else {
      if (!this.style) {
        this.useStyle(value);
      } else {
        this.setStyle(value);
      }
    }
  };
  Displayable2.prototype.setStyle = function(keyOrObj, value) {
    if (typeof keyOrObj === "string") {
      this.style[keyOrObj] = value;
    } else {
      extend(this.style, keyOrObj);
    }
    this.dirtyStyle();
    return this;
  };
  Displayable2.prototype.dirtyStyle = function(notRedraw) {
    if (!notRedraw) {
      this.markRedraw();
    }
    this.__dirty |= STYLE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
  };
  Displayable2.prototype.dirty = function() {
    this.dirtyStyle();
  };
  Displayable2.prototype.styleChanged = function() {
    return !!(this.__dirty & STYLE_CHANGED_BIT);
  };
  Displayable2.prototype.styleUpdated = function() {
    this.__dirty &= ~STYLE_CHANGED_BIT;
  };
  Displayable2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_COMMON_STYLE, obj);
  };
  Displayable2.prototype.useStyle = function(obj) {
    if (!obj[STYLE_MAGIC_KEY]) {
      obj = this.createStyle(obj);
    }
    if (this.__inHover) {
      this.__hoverStyle = obj;
    } else {
      this.style = obj;
    }
    this.dirtyStyle();
  };
  Displayable2.prototype.isStyleObject = function(obj) {
    return obj[STYLE_MAGIC_KEY];
  };
  Displayable2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.style && !normalState.style) {
      normalState.style = this._mergeStyle(this.createStyle(), this.style);
    }
    this._savePrimaryToNormal(toState, normalState, PRIMARY_STATES_KEYS);
  };
  Displayable2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetStyle;
    if (state && state.style) {
      if (transition) {
        if (keepCurrentStates) {
          targetStyle = state.style;
        } else {
          targetStyle = this._mergeStyle(this.createStyle(), normalState.style);
          this._mergeStyle(targetStyle, state.style);
        }
      } else {
        targetStyle = this._mergeStyle(this.createStyle(), keepCurrentStates ? this.style : normalState.style);
        this._mergeStyle(targetStyle, state.style);
      }
    } else if (needsRestoreToNormal) {
      targetStyle = normalState.style;
    }
    if (targetStyle) {
      if (transition) {
        var sourceStyle = this.style;
        this.style = this.createStyle(needsRestoreToNormal ? {} : sourceStyle);
        if (needsRestoreToNormal) {
          var changedKeys = keys(sourceStyle);
          for (var i = 0; i < changedKeys.length; i++) {
            var key = changedKeys[i];
            if (key in targetStyle) {
              targetStyle[key] = targetStyle[key];
              this.style[key] = sourceStyle[key];
            }
          }
        }
        var targetKeys = keys(targetStyle);
        for (var i = 0; i < targetKeys.length; i++) {
          var key = targetKeys[i];
          this.style[key] = this.style[key];
        }
        this._transitionState(stateName, {
          style: targetStyle
        }, animationCfg, this.getAnimationStyleProps());
      } else {
        this.useStyle(targetStyle);
      }
    }
    var statesKeys = this.__inHover ? PRIMARY_STATES_KEYS_IN_HOVER_LAYER : PRIMARY_STATES_KEYS;
    for (var i = 0; i < statesKeys.length; i++) {
      var key = statesKeys[i];
      if (state && state[key] != null) {
        this[key] = state[key];
      } else if (needsRestoreToNormal) {
        if (normalState[key] != null) {
          this[key] = normalState[key];
        }
      }
    }
  };
  Displayable2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedStyle;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.style) {
        mergedStyle = mergedStyle || {};
        this._mergeStyle(mergedStyle, state.style);
      }
    }
    if (mergedStyle) {
      mergedState.style = mergedStyle;
    }
    return mergedState;
  };
  Displayable2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    extend(targetStyle, sourceStyle);
    return targetStyle;
  };
  Displayable2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_COMMON_ANIMATION_PROPS;
  };
  Displayable2.initDefaultProps = function() {
    var dispProto = Displayable2.prototype;
    dispProto.type = "displayable";
    dispProto.invisible = false;
    dispProto.z = 0;
    dispProto.z2 = 0;
    dispProto.zlevel = 0;
    dispProto.culling = false;
    dispProto.cursor = "pointer";
    dispProto.rectHover = false;
    dispProto.incremental = false;
    dispProto._rect = null;
    dispProto.dirtyRectTolerance = 0;
    dispProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT;
  }();
  return Displayable2;
}(Element$2);
var tmpRect = new BoundingRect$1(0, 0, 0, 0);
var viewRect = new BoundingRect$1(0, 0, 0, 0);
function isDisplayableCulled(el, width, height) {
  tmpRect.copy(el.getBoundingRect());
  if (el.transform) {
    tmpRect.applyTransform(el.transform);
  }
  viewRect.width = width;
  viewRect.height = height;
  return !tmpRect.intersect(viewRect);
}
var Displayable$1 = Displayable;
var mathMin$9 = Math.min;
var mathMax$9 = Math.max;
var mathSin$4 = Math.sin;
var mathCos$4 = Math.cos;
var PI2$9 = Math.PI * 2;
var start = create$2();
var end = create$2();
var extremity = create$2();
function fromPoints(points2, min3, max3) {
  if (points2.length === 0) {
    return;
  }
  var p2 = points2[0];
  var left = p2[0];
  var right = p2[0];
  var top = p2[1];
  var bottom = p2[1];
  for (var i = 1; i < points2.length; i++) {
    p2 = points2[i];
    left = mathMin$9(left, p2[0]);
    right = mathMax$9(right, p2[0]);
    top = mathMin$9(top, p2[1]);
    bottom = mathMax$9(bottom, p2[1]);
  }
  min3[0] = left;
  min3[1] = top;
  max3[0] = right;
  max3[1] = bottom;
}
function fromLine(x0, y0, x1, y1, min3, max3) {
  min3[0] = mathMin$9(x0, x1);
  min3[1] = mathMin$9(y0, y1);
  max3[0] = mathMax$9(x0, x1);
  max3[1] = mathMax$9(y0, y1);
}
var xDim = [];
var yDim = [];
function fromCubic(x0, y0, x1, y1, x2, y2, x3, y3, min3, max3) {
  var cubicExtrema$1 = cubicExtrema;
  var cubicAt$1 = cubicAt;
  var n2 = cubicExtrema$1(x0, x1, x2, x3, xDim);
  min3[0] = Infinity;
  min3[1] = Infinity;
  max3[0] = -Infinity;
  max3[1] = -Infinity;
  for (var i = 0; i < n2; i++) {
    var x4 = cubicAt$1(x0, x1, x2, x3, xDim[i]);
    min3[0] = mathMin$9(x4, min3[0]);
    max3[0] = mathMax$9(x4, max3[0]);
  }
  n2 = cubicExtrema$1(y0, y1, y2, y3, yDim);
  for (var i = 0; i < n2; i++) {
    var y4 = cubicAt$1(y0, y1, y2, y3, yDim[i]);
    min3[1] = mathMin$9(y4, min3[1]);
    max3[1] = mathMax$9(y4, max3[1]);
  }
  min3[0] = mathMin$9(x0, min3[0]);
  max3[0] = mathMax$9(x0, max3[0]);
  min3[0] = mathMin$9(x3, min3[0]);
  max3[0] = mathMax$9(x3, max3[0]);
  min3[1] = mathMin$9(y0, min3[1]);
  max3[1] = mathMax$9(y0, max3[1]);
  min3[1] = mathMin$9(y3, min3[1]);
  max3[1] = mathMax$9(y3, max3[1]);
}
function fromQuadratic(x0, y0, x1, y1, x2, y2, min3, max3) {
  var quadraticExtremum$1 = quadraticExtremum;
  var quadraticAt2 = quadraticAt$1;
  var tx = mathMax$9(mathMin$9(quadraticExtremum$1(x0, x1, x2), 1), 0);
  var ty = mathMax$9(mathMin$9(quadraticExtremum$1(y0, y1, y2), 1), 0);
  var x3 = quadraticAt2(x0, x1, x2, tx);
  var y3 = quadraticAt2(y0, y1, y2, ty);
  min3[0] = mathMin$9(x0, x2, x3);
  min3[1] = mathMin$9(y0, y2, y3);
  max3[0] = mathMax$9(x0, x2, x3);
  max3[1] = mathMax$9(y0, y2, y3);
}
function fromArc(x2, y2, rx, ry, startAngle, endAngle, anticlockwise, min3, max3) {
  var vec2Min = min$1;
  var vec2Max = max$1;
  var diff = Math.abs(startAngle - endAngle);
  if (diff % PI2$9 < 1e-4 && diff > 1e-4) {
    min3[0] = x2 - rx;
    min3[1] = y2 - ry;
    max3[0] = x2 + rx;
    max3[1] = y2 + ry;
    return;
  }
  start[0] = mathCos$4(startAngle) * rx + x2;
  start[1] = mathSin$4(startAngle) * ry + y2;
  end[0] = mathCos$4(endAngle) * rx + x2;
  end[1] = mathSin$4(endAngle) * ry + y2;
  vec2Min(min3, start, end);
  vec2Max(max3, start, end);
  startAngle = startAngle % PI2$9;
  if (startAngle < 0) {
    startAngle = startAngle + PI2$9;
  }
  endAngle = endAngle % PI2$9;
  if (endAngle < 0) {
    endAngle = endAngle + PI2$9;
  }
  if (startAngle > endAngle && !anticlockwise) {
    endAngle += PI2$9;
  } else if (startAngle < endAngle && anticlockwise) {
    startAngle += PI2$9;
  }
  if (anticlockwise) {
    var tmp = endAngle;
    endAngle = startAngle;
    startAngle = tmp;
  }
  for (var angle = 0; angle < endAngle; angle += Math.PI / 2) {
    if (angle > startAngle) {
      extremity[0] = mathCos$4(angle) * rx + x2;
      extremity[1] = mathSin$4(angle) * ry + y2;
      vec2Min(min3, extremity, min3);
      vec2Max(max3, extremity, max3);
    }
  }
}
var CMD$4 = {
  M: 1,
  L: 2,
  C: 3,
  Q: 4,
  A: 5,
  Z: 6,
  R: 7
};
var tmpOutX = [];
var tmpOutY = [];
var min = [];
var max = [];
var min2 = [];
var max2 = [];
var mathMin$8 = Math.min;
var mathMax$8 = Math.max;
var mathCos$3 = Math.cos;
var mathSin$3 = Math.sin;
var mathAbs$2 = Math.abs;
var PI$8 = Math.PI;
var PI2$8 = PI$8 * 2;
var hasTypedArray = typeof Float32Array !== "undefined";
var tmpAngles = [];
function modPI2(radian) {
  var n2 = Math.round(radian / PI$8 * 1e8) / 1e8;
  return n2 % 2 * PI$8;
}
function normalizeArcAngles(angles, anticlockwise) {
  var newStartAngle = modPI2(angles[0]);
  if (newStartAngle < 0) {
    newStartAngle += PI2$8;
  }
  var delta = newStartAngle - angles[0];
  var newEndAngle = angles[1];
  newEndAngle += delta;
  if (!anticlockwise && newEndAngle - newStartAngle >= PI2$8) {
    newEndAngle = newStartAngle + PI2$8;
  } else if (anticlockwise && newStartAngle - newEndAngle >= PI2$8) {
    newEndAngle = newStartAngle - PI2$8;
  } else if (!anticlockwise && newStartAngle > newEndAngle) {
    newEndAngle = newStartAngle + (PI2$8 - modPI2(newStartAngle - newEndAngle));
  } else if (anticlockwise && newStartAngle < newEndAngle) {
    newEndAngle = newStartAngle - (PI2$8 - modPI2(newEndAngle - newStartAngle));
  }
  angles[0] = newStartAngle;
  angles[1] = newEndAngle;
}
var PathProxy = function() {
  function PathProxy2(notSaveData) {
    this.dpr = 1;
    this._xi = 0;
    this._yi = 0;
    this._x0 = 0;
    this._y0 = 0;
    this._len = 0;
    if (notSaveData) {
      this._saveData = false;
    }
    if (this._saveData) {
      this.data = [];
    }
  }
  PathProxy2.prototype.increaseVersion = function() {
    this._version++;
  };
  PathProxy2.prototype.getVersion = function() {
    return this._version;
  };
  PathProxy2.prototype.setScale = function(sx, sy, segmentIgnoreThreshold) {
    segmentIgnoreThreshold = segmentIgnoreThreshold || 0;
    if (segmentIgnoreThreshold > 0) {
      this._ux = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sx) || 0;
      this._uy = mathAbs$2(segmentIgnoreThreshold / devicePixelRatio / sy) || 0;
    }
  };
  PathProxy2.prototype.setDPR = function(dpr2) {
    this.dpr = dpr2;
  };
  PathProxy2.prototype.setContext = function(ctx) {
    this._ctx = ctx;
  };
  PathProxy2.prototype.getContext = function() {
    return this._ctx;
  };
  PathProxy2.prototype.beginPath = function() {
    this._ctx && this._ctx.beginPath();
    this.reset();
    return this;
  };
  PathProxy2.prototype.reset = function() {
    if (this._saveData) {
      this._len = 0;
    }
    if (this._pathSegLen) {
      this._pathSegLen = null;
      this._pathLen = 0;
    }
    this._version++;
  };
  PathProxy2.prototype.moveTo = function(x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.M, x2, y2);
    this._ctx && this._ctx.moveTo(x2, y2);
    this._x0 = x2;
    this._y0 = y2;
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.lineTo = function(x2, y2) {
    var dx = mathAbs$2(x2 - this._xi);
    var dy = mathAbs$2(y2 - this._yi);
    var exceedUnit = dx > this._ux || dy > this._uy;
    this.addData(CMD$4.L, x2, y2);
    if (this._ctx && exceedUnit) {
      this._ctx.lineTo(x2, y2);
    }
    if (exceedUnit) {
      this._xi = x2;
      this._yi = y2;
      this._pendingPtDist = 0;
    } else {
      var d2 = dx * dx + dy * dy;
      if (d2 > this._pendingPtDist) {
        this._pendingPtX = x2;
        this._pendingPtY = y2;
        this._pendingPtDist = d2;
      }
    }
    return this;
  };
  PathProxy2.prototype.bezierCurveTo = function(x1, y1, x2, y2, x3, y3) {
    this._drawPendingPt();
    this.addData(CMD$4.C, x1, y1, x2, y2, x3, y3);
    if (this._ctx) {
      this._ctx.bezierCurveTo(x1, y1, x2, y2, x3, y3);
    }
    this._xi = x3;
    this._yi = y3;
    return this;
  };
  PathProxy2.prototype.quadraticCurveTo = function(x1, y1, x2, y2) {
    this._drawPendingPt();
    this.addData(CMD$4.Q, x1, y1, x2, y2);
    if (this._ctx) {
      this._ctx.quadraticCurveTo(x1, y1, x2, y2);
    }
    this._xi = x2;
    this._yi = y2;
    return this;
  };
  PathProxy2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this._drawPendingPt();
    tmpAngles[0] = startAngle;
    tmpAngles[1] = endAngle;
    normalizeArcAngles(tmpAngles, anticlockwise);
    startAngle = tmpAngles[0];
    endAngle = tmpAngles[1];
    var delta = endAngle - startAngle;
    this.addData(CMD$4.A, cx, cy, r2, r2, startAngle, delta, 0, anticlockwise ? 0 : 1);
    this._ctx && this._ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
    this._xi = mathCos$3(endAngle) * r2 + cx;
    this._yi = mathSin$3(endAngle) * r2 + cy;
    return this;
  };
  PathProxy2.prototype.arcTo = function(x1, y1, x2, y2, radius) {
    this._drawPendingPt();
    if (this._ctx) {
      this._ctx.arcTo(x1, y1, x2, y2, radius);
    }
    return this;
  };
  PathProxy2.prototype.rect = function(x2, y2, w2, h) {
    this._drawPendingPt();
    this._ctx && this._ctx.rect(x2, y2, w2, h);
    this.addData(CMD$4.R, x2, y2, w2, h);
    return this;
  };
  PathProxy2.prototype.closePath = function() {
    this._drawPendingPt();
    this.addData(CMD$4.Z);
    var ctx = this._ctx;
    var x0 = this._x0;
    var y0 = this._y0;
    if (ctx) {
      ctx.closePath();
    }
    this._xi = x0;
    this._yi = y0;
    return this;
  };
  PathProxy2.prototype.fill = function(ctx) {
    ctx && ctx.fill();
    this.toStatic();
  };
  PathProxy2.prototype.stroke = function(ctx) {
    ctx && ctx.stroke();
    this.toStatic();
  };
  PathProxy2.prototype.len = function() {
    return this._len;
  };
  PathProxy2.prototype.setData = function(data) {
    var len2 = data.length;
    if (!(this.data && this.data.length === len2) && hasTypedArray) {
      this.data = new Float32Array(len2);
    }
    for (var i = 0; i < len2; i++) {
      this.data[i] = data[i];
    }
    this._len = len2;
  };
  PathProxy2.prototype.appendPath = function(path) {
    if (!(path instanceof Array)) {
      path = [path];
    }
    var len2 = path.length;
    var appendSize = 0;
    var offset = this._len;
    for (var i = 0; i < len2; i++) {
      appendSize += path[i].len();
    }
    if (hasTypedArray && this.data instanceof Float32Array) {
      this.data = new Float32Array(offset + appendSize);
    }
    for (var i = 0; i < len2; i++) {
      var appendPathData = path[i].data;
      for (var k2 = 0; k2 < appendPathData.length; k2++) {
        this.data[offset++] = appendPathData[k2];
      }
    }
    this._len = offset;
  };
  PathProxy2.prototype.addData = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    if (!this._saveData) {
      return;
    }
    var data = this.data;
    if (this._len + arguments.length > data.length) {
      this._expandData();
      data = this.data;
    }
    for (var i = 0; i < arguments.length; i++) {
      data[this._len++] = arguments[i];
    }
  };
  PathProxy2.prototype._drawPendingPt = function() {
    if (this._pendingPtDist > 0) {
      this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY);
      this._pendingPtDist = 0;
    }
  };
  PathProxy2.prototype._expandData = function() {
    if (!(this.data instanceof Array)) {
      var newData = [];
      for (var i = 0; i < this._len; i++) {
        newData[i] = this.data[i];
      }
      this.data = newData;
    }
  };
  PathProxy2.prototype.toStatic = function() {
    if (!this._saveData) {
      return;
    }
    this._drawPendingPt();
    var data = this.data;
    if (data instanceof Array) {
      data.length = this._len;
      if (hasTypedArray && this._len > 11) {
        this.data = new Float32Array(data);
      }
    }
  };
  PathProxy2.prototype.getBoundingRect = function() {
    min[0] = min[1] = min2[0] = min2[1] = Number.MAX_VALUE;
    max[0] = max[1] = max2[0] = max2[1] = -Number.MAX_VALUE;
    var data = this.data;
    var xi = 0;
    var yi = 0;
    var x0 = 0;
    var y0 = 0;
    var i;
    for (i = 0; i < this._len; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi = data[i];
        yi = data[i + 1];
        x0 = xi;
        y0 = yi;
      }
      switch (cmd) {
        case CMD$4.M:
          xi = x0 = data[i++];
          yi = y0 = data[i++];
          min2[0] = x0;
          min2[1] = y0;
          max2[0] = x0;
          max2[1] = y0;
          break;
        case CMD$4.L:
          fromLine(xi, yi, data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.C:
          fromCubic(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.Q:
          fromQuadratic(xi, yi, data[i++], data[i++], data[i], data[i + 1], min2, max2);
          xi = data[i++];
          yi = data[i++];
          break;
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var endAngle = data[i++] + startAngle;
          i += 1;
          var anticlockwise = !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          fromArc(cx, cy, rx, ry, startAngle, endAngle, anticlockwise, min2, max2);
          xi = mathCos$3(endAngle) * rx + cx;
          yi = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R:
          x0 = xi = data[i++];
          y0 = yi = data[i++];
          var width = data[i++];
          var height = data[i++];
          fromLine(x0, y0, x0 + width, y0 + height, min2, max2);
          break;
        case CMD$4.Z:
          xi = x0;
          yi = y0;
          break;
      }
      min$1(min, min, min2);
      max$1(max, max, max2);
    }
    if (i === 0) {
      min[0] = min[1] = max[0] = max[1] = 0;
    }
    return new BoundingRect$1(min[0], min[1], max[0] - min[0], max[1] - min[1]);
  };
  PathProxy2.prototype._calculateLength = function() {
    var data = this.data;
    var len2 = this._len;
    var ux = this._ux;
    var uy = this._uy;
    var xi = 0;
    var yi = 0;
    var x0 = 0;
    var y0 = 0;
    if (!this._pathSegLen) {
      this._pathSegLen = [];
    }
    var pathSegLen = this._pathSegLen;
    var pathTotalLen = 0;
    var segCount = 0;
    for (var i = 0; i < len2; ) {
      var cmd = data[i++];
      var isFirst = i === 1;
      if (isFirst) {
        xi = data[i];
        yi = data[i + 1];
        x0 = xi;
        y0 = yi;
      }
      var l2 = -1;
      switch (cmd) {
        case CMD$4.M:
          xi = x0 = data[i++];
          yi = y0 = data[i++];
          break;
        case CMD$4.L: {
          var x2 = data[i++];
          var y2 = data[i++];
          var dx = x2 - xi;
          var dy = y2 - yi;
          if (mathAbs$2(dx) > ux || mathAbs$2(dy) > uy || i === len2 - 1) {
            l2 = Math.sqrt(dx * dx + dy * dy);
            xi = x2;
            yi = y2;
          }
          break;
        }
        case CMD$4.C: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          var x3 = data[i++];
          var y3 = data[i++];
          l2 = cubicLength(xi, yi, x1, y1, x2, y2, x3, y3, 10);
          xi = x3;
          yi = y3;
          break;
        }
        case CMD$4.Q: {
          var x1 = data[i++];
          var y1 = data[i++];
          var x2 = data[i++];
          var y2 = data[i++];
          l2 = quadraticLength(xi, yi, x1, y1, x2, y2, 10);
          xi = x2;
          yi = y2;
          break;
        }
        case CMD$4.A:
          var cx = data[i++];
          var cy = data[i++];
          var rx = data[i++];
          var ry = data[i++];
          var startAngle = data[i++];
          var delta = data[i++];
          var endAngle = delta + startAngle;
          i += 1;
          !data[i++];
          if (isFirst) {
            x0 = mathCos$3(startAngle) * rx + cx;
            y0 = mathSin$3(startAngle) * ry + cy;
          }
          l2 = mathMax$8(rx, ry) * mathMin$8(PI2$8, Math.abs(delta));
          xi = mathCos$3(endAngle) * rx + cx;
          yi = mathSin$3(endAngle) * ry + cy;
          break;
        case CMD$4.R: {
          x0 = xi = data[i++];
          y0 = yi = data[i++];
          var width = data[i++];
          var height = data[i++];
          l2 = width * 2 + height * 2;
          break;
        }
        case CMD$4.Z: {
          var dx = x0 - xi;
          var dy = y0 - yi;
          l2 = Math.sqrt(dx * dx + dy * dy);
          xi = x0;
          yi = y0;
          break;
        }
      }
      if (l2 >= 0) {
        pathSegLen[segCount++] = l2;
        pathTotalLen += l2;
      }
    }
    this._pathLen = pathTotalLen;
    return pathTotalLen;
  };
  PathProxy2.prototype.rebuildPath = function(ctx, percent) {
    var d2 = this.data;
    var ux = this._ux;
    var uy = this._uy;
    var len2 = this._len;
    var x0;
    var y0;
    var xi;
    var yi;
    var x2;
    var y2;
    var drawPart = percent < 1;
    var pathSegLen;
    var pathTotalLen;
    var accumLength = 0;
    var segCount = 0;
    var displayedLength;
    var pendingPtDist = 0;
    var pendingPtX;
    var pendingPtY;
    if (drawPart) {
      if (!this._pathSegLen) {
        this._calculateLength();
      }
      pathSegLen = this._pathSegLen;
      pathTotalLen = this._pathLen;
      displayedLength = percent * pathTotalLen;
      if (!displayedLength) {
        return;
      }
    }
    lo:
      for (var i = 0; i < len2; ) {
        var cmd = d2[i++];
        var isFirst = i === 1;
        if (isFirst) {
          xi = d2[i];
          yi = d2[i + 1];
          x0 = xi;
          y0 = yi;
        }
        if (cmd !== CMD$4.L && pendingPtDist > 0) {
          ctx.lineTo(pendingPtX, pendingPtY);
          pendingPtDist = 0;
        }
        switch (cmd) {
          case CMD$4.M:
            x0 = xi = d2[i++];
            y0 = yi = d2[i++];
            ctx.moveTo(xi, yi);
            break;
          case CMD$4.L: {
            x2 = d2[i++];
            y2 = d2[i++];
            var dx = mathAbs$2(x2 - xi);
            var dy = mathAbs$2(y2 - yi);
            if (dx > ux || dy > uy) {
              if (drawPart) {
                var l2 = pathSegLen[segCount++];
                if (accumLength + l2 > displayedLength) {
                  var t2 = (displayedLength - accumLength) / l2;
                  ctx.lineTo(xi * (1 - t2) + x2 * t2, yi * (1 - t2) + y2 * t2);
                  break lo;
                }
                accumLength += l2;
              }
              ctx.lineTo(x2, y2);
              xi = x2;
              yi = y2;
              pendingPtDist = 0;
            } else {
              var d22 = dx * dx + dy * dy;
              if (d22 > pendingPtDist) {
                pendingPtX = x2;
                pendingPtY = y2;
                pendingPtDist = d22;
              }
            }
            break;
          }
          case CMD$4.C: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            var x3 = d2[i++];
            var y3 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                cubicSubdivide(xi, x1, x22, x3, t2, tmpOutX);
                cubicSubdivide(yi, y1, y22, y3, t2, tmpOutY);
                ctx.bezierCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2], tmpOutX[3], tmpOutY[3]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.bezierCurveTo(x1, y1, x22, y22, x3, y3);
            xi = x3;
            yi = y3;
            break;
          }
          case CMD$4.Q: {
            var x1 = d2[i++];
            var y1 = d2[i++];
            var x22 = d2[i++];
            var y22 = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                quadraticSubdivide(xi, x1, x22, t2, tmpOutX);
                quadraticSubdivide(yi, y1, y22, t2, tmpOutY);
                ctx.quadraticCurveTo(tmpOutX[1], tmpOutY[1], tmpOutX[2], tmpOutY[2]);
                break lo;
              }
              accumLength += l2;
            }
            ctx.quadraticCurveTo(x1, y1, x22, y22);
            xi = x22;
            yi = y22;
            break;
          }
          case CMD$4.A:
            var cx = d2[i++];
            var cy = d2[i++];
            var rx = d2[i++];
            var ry = d2[i++];
            var startAngle = d2[i++];
            var delta = d2[i++];
            var psi = d2[i++];
            var anticlockwise = !d2[i++];
            var r2 = rx > ry ? rx : ry;
            var isEllipse = mathAbs$2(rx - ry) > 1e-3;
            var endAngle = startAngle + delta;
            var breakBuild = false;
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                endAngle = startAngle + delta * (displayedLength - accumLength) / l2;
                breakBuild = true;
              }
              accumLength += l2;
            }
            if (isEllipse && ctx.ellipse) {
              ctx.ellipse(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise);
            } else {
              ctx.arc(cx, cy, r2, startAngle, endAngle, anticlockwise);
            }
            if (breakBuild) {
              break lo;
            }
            if (isFirst) {
              x0 = mathCos$3(startAngle) * rx + cx;
              y0 = mathSin$3(startAngle) * ry + cy;
            }
            xi = mathCos$3(endAngle) * rx + cx;
            yi = mathSin$3(endAngle) * ry + cy;
            break;
          case CMD$4.R:
            x0 = xi = d2[i];
            y0 = yi = d2[i + 1];
            x2 = d2[i++];
            y2 = d2[i++];
            var width = d2[i++];
            var height = d2[i++];
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var d_1 = displayedLength - accumLength;
                ctx.moveTo(x2, y2);
                ctx.lineTo(x2 + mathMin$8(d_1, width), y2);
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + width, y2 + mathMin$8(d_1, height));
                }
                d_1 -= height;
                if (d_1 > 0) {
                  ctx.lineTo(x2 + mathMax$8(width - d_1, 0), y2 + height);
                }
                d_1 -= width;
                if (d_1 > 0) {
                  ctx.lineTo(x2, y2 + mathMax$8(height - d_1, 0));
                }
                break lo;
              }
              accumLength += l2;
            }
            ctx.rect(x2, y2, width, height);
            break;
          case CMD$4.Z:
            if (drawPart) {
              var l2 = pathSegLen[segCount++];
              if (accumLength + l2 > displayedLength) {
                var t2 = (displayedLength - accumLength) / l2;
                ctx.lineTo(xi * (1 - t2) + x0 * t2, yi * (1 - t2) + y0 * t2);
                break lo;
              }
              accumLength += l2;
            }
            ctx.closePath();
            xi = x0;
            yi = y0;
        }
      }
  };
  PathProxy2.prototype.clone = function() {
    var newProxy = new PathProxy2();
    var data = this.data;
    newProxy.data = data.slice ? data.slice() : Array.prototype.slice.call(data);
    newProxy._len = this._len;
    return newProxy;
  };
  PathProxy2.CMD = CMD$4;
  PathProxy2.initDefaultProps = function() {
    var proto2 = PathProxy2.prototype;
    proto2._saveData = true;
    proto2._ux = 0;
    proto2._uy = 0;
    proto2._pendingPtDist = 0;
    proto2._version = 0;
  }();
  return PathProxy2;
}();
var PathProxy$1 = PathProxy;
function containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  var _a2 = 0;
  var _b2 = x0;
  if (y2 > y0 + _l && y2 > y1 + _l || y2 < y0 - _l && y2 < y1 - _l || x2 > x0 + _l && x2 > x1 + _l || x2 < x0 - _l && x2 < x1 - _l) {
    return false;
  }
  if (x0 !== x1) {
    _a2 = (y0 - y1) / (x0 - x1);
    _b2 = (x0 * y1 - x1 * y0) / (x0 - x1);
  } else {
    return Math.abs(x2 - x0) <= _l / 2;
  }
  var tmp = _a2 * x2 - y2 + _b2;
  var _s = tmp * tmp / (_a2 * _a2 + 1);
  return _s <= _l / 2 * _l / 2;
}
function containStroke$3(x0, y0, x1, y1, x2, y2, x3, y3, lineWidth, x4, y4) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y4 > y0 + _l && y4 > y1 + _l && y4 > y2 + _l && y4 > y3 + _l || y4 < y0 - _l && y4 < y1 - _l && y4 < y2 - _l && y4 < y3 - _l || x4 > x0 + _l && x4 > x1 + _l && x4 > x2 + _l && x4 > x3 + _l || x4 < x0 - _l && x4 < x1 - _l && x4 < x2 - _l && x4 < x3 - _l) {
    return false;
  }
  var d2 = cubicProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4, null);
  return d2 <= _l / 2;
}
function containStroke$2(x0, y0, x1, y1, x2, y2, lineWidth, x3, y3) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  if (y3 > y0 + _l && y3 > y1 + _l && y3 > y2 + _l || y3 < y0 - _l && y3 < y1 - _l && y3 < y2 - _l || x3 > x0 + _l && x3 > x1 + _l && x3 > x2 + _l || x3 < x0 - _l && x3 < x1 - _l && x3 < x2 - _l) {
    return false;
  }
  var d2 = quadraticProjectPoint(x0, y0, x1, y1, x2, y2, x3, y3, null);
  return d2 <= _l / 2;
}
var PI2$7 = Math.PI * 2;
function normalizeRadian(angle) {
  angle %= PI2$7;
  if (angle < 0) {
    angle += PI2$7;
  }
  return angle;
}
var PI2$6 = Math.PI * 2;
function containStroke$1(cx, cy, r2, startAngle, endAngle, anticlockwise, lineWidth, x2, y2) {
  if (lineWidth === 0) {
    return false;
  }
  var _l = lineWidth;
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  if (d2 - _l > r2 || d2 + _l < r2) {
    return false;
  }
  if (Math.abs(startAngle - endAngle) % PI2$6 < 1e-4) {
    return true;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$6;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$6;
  }
  return angle >= startAngle && angle <= endAngle || angle + PI2$6 >= startAngle && angle + PI2$6 <= endAngle;
}
function windingLine(x0, y0, x1, y1, x2, y2) {
  if (y2 > y0 && y2 > y1 || y2 < y0 && y2 < y1) {
    return 0;
  }
  if (y1 === y0) {
    return 0;
  }
  var t2 = (y2 - y0) / (y1 - y0);
  var dir3 = y1 < y0 ? 1 : -1;
  if (t2 === 1 || t2 === 0) {
    dir3 = y1 < y0 ? 0.5 : -0.5;
  }
  var x_ = t2 * (x1 - x0) + x0;
  return x_ === x2 ? Infinity : x_ > x2 ? dir3 : 0;
}
var CMD$3 = PathProxy$1.CMD;
var PI2$5 = Math.PI * 2;
var EPSILON$1 = 1e-4;
function isAroundEqual$1(a, b2) {
  return Math.abs(a - b2) < EPSILON$1;
}
var roots = [-1, -1, -1];
var extrema = [-1, -1];
function swapExtrema() {
  var tmp = extrema[0];
  extrema[0] = extrema[1];
  extrema[1] = tmp;
}
function windingCubic(x0, y0, x1, y1, x2, y2, x3, y3, x4, y4) {
  if (y4 > y0 && y4 > y1 && y4 > y2 && y4 > y3 || y4 < y0 && y4 < y1 && y4 < y2 && y4 < y3) {
    return 0;
  }
  var nRoots = cubicRootAt(y0, y1, y2, y3, y4, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var w2 = 0;
    var nExtrema = -1;
    var y0_ = void 0;
    var y1_ = void 0;
    for (var i = 0; i < nRoots; i++) {
      var t2 = roots[i];
      var unit = t2 === 0 || t2 === 1 ? 0.5 : 1;
      var x_ = cubicAt(x0, x1, x2, x3, t2);
      if (x_ < x4) {
        continue;
      }
      if (nExtrema < 0) {
        nExtrema = cubicExtrema(y0, y1, y2, y3, extrema);
        if (extrema[1] < extrema[0] && nExtrema > 1) {
          swapExtrema();
        }
        y0_ = cubicAt(y0, y1, y2, y3, extrema[0]);
        if (nExtrema > 1) {
          y1_ = cubicAt(y0, y1, y2, y3, extrema[1]);
        }
      }
      if (nExtrema === 2) {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else if (t2 < extrema[1]) {
          w2 += y1_ < y0_ ? unit : -unit;
        } else {
          w2 += y3 < y1_ ? unit : -unit;
        }
      } else {
        if (t2 < extrema[0]) {
          w2 += y0_ < y0 ? unit : -unit;
        } else {
          w2 += y3 < y0_ ? unit : -unit;
        }
      }
    }
    return w2;
  }
}
function windingQuadratic(x0, y0, x1, y1, x2, y2, x3, y3) {
  if (y3 > y0 && y3 > y1 && y3 > y2 || y3 < y0 && y3 < y1 && y3 < y2) {
    return 0;
  }
  var nRoots = quadraticRootAt(y0, y1, y2, y3, roots);
  if (nRoots === 0) {
    return 0;
  } else {
    var t2 = quadraticExtremum(y0, y1, y2);
    if (t2 >= 0 && t2 <= 1) {
      var w2 = 0;
      var y_ = quadraticAt$1(y0, y1, y2, t2);
      for (var i = 0; i < nRoots; i++) {
        var unit = roots[i] === 0 || roots[i] === 1 ? 0.5 : 1;
        var x_ = quadraticAt$1(x0, x1, x2, roots[i]);
        if (x_ < x3) {
          continue;
        }
        if (roots[i] < t2) {
          w2 += y_ < y0 ? unit : -unit;
        } else {
          w2 += y2 < y_ ? unit : -unit;
        }
      }
      return w2;
    } else {
      var unit = roots[0] === 0 || roots[0] === 1 ? 0.5 : 1;
      var x_ = quadraticAt$1(x0, x1, x2, roots[0]);
      if (x_ < x3) {
        return 0;
      }
      return y2 < y0 ? unit : -unit;
    }
  }
}
function windingArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2) {
  y2 -= cy;
  if (y2 > r2 || y2 < -r2) {
    return 0;
  }
  var tmp = Math.sqrt(r2 * r2 - y2 * y2);
  roots[0] = -tmp;
  roots[1] = tmp;
  var dTheta = Math.abs(startAngle - endAngle);
  if (dTheta < 1e-4) {
    return 0;
  }
  if (dTheta >= PI2$5 - 1e-4) {
    startAngle = 0;
    endAngle = PI2$5;
    var dir3 = anticlockwise ? 1 : -1;
    if (x2 >= roots[0] + cx && x2 <= roots[1] + cx) {
      return dir3;
    } else {
      return 0;
    }
  }
  if (startAngle > endAngle) {
    var tmp_1 = startAngle;
    startAngle = endAngle;
    endAngle = tmp_1;
  }
  if (startAngle < 0) {
    startAngle += PI2$5;
    endAngle += PI2$5;
  }
  var w2 = 0;
  for (var i = 0; i < 2; i++) {
    var x_ = roots[i];
    if (x_ + cx > x2) {
      var angle = Math.atan2(y2, x_);
      var dir3 = anticlockwise ? 1 : -1;
      if (angle < 0) {
        angle = PI2$5 + angle;
      }
      if (angle >= startAngle && angle <= endAngle || angle + PI2$5 >= startAngle && angle + PI2$5 <= endAngle) {
        if (angle > Math.PI / 2 && angle < Math.PI * 1.5) {
          dir3 = -dir3;
        }
        w2 += dir3;
      }
    }
  }
  return w2;
}
function containPath(path, lineWidth, isStroke, x2, y2) {
  var data = path.data;
  var len2 = path.len();
  var w2 = 0;
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (cmd === CMD$3.M && i > 1) {
      if (!isStroke) {
        w2 += windingLine(xi, yi, x0, y0, x2, y2);
      }
    }
    if (isFirst) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
    }
    switch (cmd) {
      case CMD$3.M:
        x0 = data[i++];
        y0 = data[i++];
        xi = x0;
        yi = y0;
        break;
      case CMD$3.L:
        if (isStroke) {
          if (containStroke$4(xi, yi, data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi, yi, data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.C:
        if (isStroke) {
          if (containStroke$3(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingCubic(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.Q:
        if (isStroke) {
          if (containStroke$2(xi, yi, data[i++], data[i++], data[i], data[i + 1], lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingQuadratic(xi, yi, data[i++], data[i++], data[i], data[i + 1], x2, y2) || 0;
        }
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$3.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (!isFirst) {
          w2 += windingLine(xi, yi, x1, y1, x2, y2);
        } else {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        if (isStroke) {
          if (containStroke$1(cx, cy, ry, theta, theta + dTheta, anticlockwise, lineWidth, _x, y2)) {
            return true;
          }
        } else {
          w2 += windingArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2);
        }
        xi = Math.cos(theta + dTheta) * rx + cx;
        yi = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$3.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        var width = data[i++];
        var height = data[i++];
        x1 = x0 + width;
        y1 = y0 + height;
        if (isStroke) {
          if (containStroke$4(x0, y0, x1, y0, lineWidth, x2, y2) || containStroke$4(x1, y0, x1, y1, lineWidth, x2, y2) || containStroke$4(x1, y1, x0, y1, lineWidth, x2, y2) || containStroke$4(x0, y1, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(x1, y0, x1, y1, x2, y2);
          w2 += windingLine(x0, y1, x0, y0, x2, y2);
        }
        break;
      case CMD$3.Z:
        if (isStroke) {
          if (containStroke$4(xi, yi, x0, y0, lineWidth, x2, y2)) {
            return true;
          }
        } else {
          w2 += windingLine(xi, yi, x0, y0, x2, y2);
        }
        xi = x0;
        yi = y0;
        break;
    }
  }
  if (!isStroke && !isAroundEqual$1(yi, y0)) {
    w2 += windingLine(xi, yi, x0, y0, x2, y2) || 0;
  }
  return w2 !== 0;
}
function contain$2(pathProxy, x2, y2) {
  return containPath(pathProxy, 0, false, x2, y2);
}
function containStroke(pathProxy, lineWidth, x2, y2) {
  return containPath(pathProxy, lineWidth, true, x2, y2);
}
var DEFAULT_PATH_STYLE = defaults({
  fill: "#000",
  stroke: null,
  strokePercent: 1,
  fillOpacity: 1,
  strokeOpacity: 1,
  lineDashOffset: 0,
  lineWidth: 1,
  lineCap: "butt",
  miterLimit: 10,
  strokeNoScale: false,
  strokeFirst: false
}, DEFAULT_COMMON_STYLE);
var DEFAULT_PATH_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    strokePercent: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineDashOffset: true,
    lineWidth: true,
    miterLimit: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var pathCopyParams = TRANSFORMABLE_PROPS.concat([
  "invisible",
  "culling",
  "z",
  "z2",
  "zlevel",
  "parent"
]);
var Path = function(_super) {
  __extends(Path2, _super);
  function Path2(opts) {
    return _super.call(this, opts) || this;
  }
  Path2.prototype.update = function() {
    var _this = this;
    _super.prototype.update.call(this);
    var style = this.style;
    if (style.decal) {
      var decalEl = this._decalEl = this._decalEl || new Path2();
      if (decalEl.buildPath === Path2.prototype.buildPath) {
        decalEl.buildPath = function(ctx) {
          _this.buildPath(ctx, _this.shape);
        };
      }
      decalEl.silent = true;
      var decalElStyle = decalEl.style;
      for (var key in style) {
        if (decalElStyle[key] !== style[key]) {
          decalElStyle[key] = style[key];
        }
      }
      decalElStyle.fill = style.fill ? style.decal : null;
      decalElStyle.decal = null;
      decalElStyle.shadowColor = null;
      style.strokeFirst && (decalElStyle.stroke = null);
      for (var i = 0; i < pathCopyParams.length; ++i) {
        decalEl[pathCopyParams[i]] = this[pathCopyParams[i]];
      }
      decalEl.__dirty |= REDRAW_BIT;
    } else if (this._decalEl) {
      this._decalEl = null;
    }
  };
  Path2.prototype.getDecalElement = function() {
    return this._decalEl;
  };
  Path2.prototype._init = function(props) {
    var keysArr = keys(props);
    this.shape = this.getDefaultShape();
    var defaultStyle = this.getDefaultStyle();
    if (defaultStyle) {
      this.useStyle(defaultStyle);
    }
    for (var i = 0; i < keysArr.length; i++) {
      var key = keysArr[i];
      var value = props[key];
      if (key === "style") {
        if (!this.style) {
          this.useStyle(value);
        } else {
          extend(this.style, value);
        }
      } else if (key === "shape") {
        extend(this.shape, value);
      } else {
        _super.prototype.attrKV.call(this, key, value);
      }
    }
    if (!this.style) {
      this.useStyle({});
    }
  };
  Path2.prototype.getDefaultStyle = function() {
    return null;
  };
  Path2.prototype.getDefaultShape = function() {
    return {};
  };
  Path2.prototype.canBeInsideText = function() {
    return this.hasFill();
  };
  Path2.prototype.getInsideTextFill = function() {
    var pathFill = this.style.fill;
    if (pathFill !== "none") {
      if (isString(pathFill)) {
        var fillLum = lum(pathFill, 0);
        if (fillLum > 0.5) {
          return DARK_LABEL_COLOR;
        } else if (fillLum > 0.2) {
          return LIGHTER_LABEL_COLOR;
        }
        return LIGHT_LABEL_COLOR;
      } else if (pathFill) {
        return LIGHT_LABEL_COLOR;
      }
    }
    return DARK_LABEL_COLOR;
  };
  Path2.prototype.getInsideTextStroke = function(textFill) {
    var pathFill = this.style.fill;
    if (isString(pathFill)) {
      var zr = this.__zr;
      var isDarkMode2 = !!(zr && zr.isDarkMode());
      var isDarkLabel = lum(textFill, 0) < DARK_MODE_THRESHOLD;
      if (isDarkMode2 === isDarkLabel) {
        return pathFill;
      }
    }
  };
  Path2.prototype.buildPath = function(ctx, shapeCfg, inBatch) {
  };
  Path2.prototype.pathUpdated = function() {
    this.__dirty &= ~SHAPE_CHANGED_BIT;
  };
  Path2.prototype.getUpdatedPathProxy = function(inBatch) {
    !this.path && this.createPathProxy();
    this.path.beginPath();
    this.buildPath(this.path, this.shape, inBatch);
    return this.path;
  };
  Path2.prototype.createPathProxy = function() {
    this.path = new PathProxy$1(false);
  };
  Path2.prototype.hasStroke = function() {
    var style = this.style;
    var stroke = style.stroke;
    return !(stroke == null || stroke === "none" || !(style.lineWidth > 0));
  };
  Path2.prototype.hasFill = function() {
    var style = this.style;
    var fill = style.fill;
    return fill != null && fill !== "none";
  };
  Path2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    var style = this.style;
    var needsUpdateRect = !rect;
    if (needsUpdateRect) {
      var firstInvoke = false;
      if (!this.path) {
        firstInvoke = true;
        this.createPathProxy();
      }
      var path = this.path;
      if (firstInvoke || this.__dirty & SHAPE_CHANGED_BIT) {
        path.beginPath();
        this.buildPath(path, this.shape, false);
        this.pathUpdated();
      }
      rect = path.getBoundingRect();
    }
    this._rect = rect;
    if (this.hasStroke() && this.path && this.path.len() > 0) {
      var rectStroke = this._rectStroke || (this._rectStroke = rect.clone());
      if (this.__dirty || needsUpdateRect) {
        rectStroke.copy(rect);
        var lineScale = style.strokeNoScale ? this.getLineScale() : 1;
        var w2 = style.lineWidth;
        if (!this.hasFill()) {
          var strokeContainThreshold = this.strokeContainThreshold;
          w2 = Math.max(w2, strokeContainThreshold == null ? 4 : strokeContainThreshold);
        }
        if (lineScale > 1e-10) {
          rectStroke.width += w2 / lineScale;
          rectStroke.height += w2 / lineScale;
          rectStroke.x -= w2 / lineScale / 2;
          rectStroke.y -= w2 / lineScale / 2;
        }
      }
      return rectStroke;
    }
    return rect;
  };
  Path2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    var style = this.style;
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var pathProxy = this.path;
      if (this.hasStroke()) {
        var lineWidth = style.lineWidth;
        var lineScale = style.strokeNoScale ? this.getLineScale() : 1;
        if (lineScale > 1e-10) {
          if (!this.hasFill()) {
            lineWidth = Math.max(lineWidth, this.strokeContainThreshold);
          }
          if (containStroke(pathProxy, lineWidth / lineScale, x2, y2)) {
            return true;
          }
        }
      }
      if (this.hasFill()) {
        return contain$2(pathProxy, x2, y2);
      }
    }
    return false;
  };
  Path2.prototype.dirtyShape = function() {
    this.__dirty |= SHAPE_CHANGED_BIT;
    if (this._rect) {
      this._rect = null;
    }
    if (this._decalEl) {
      this._decalEl.dirtyShape();
    }
    this.markRedraw();
  };
  Path2.prototype.dirty = function() {
    this.dirtyStyle();
    this.dirtyShape();
  };
  Path2.prototype.animateShape = function(loop) {
    return this.animate("shape", loop);
  };
  Path2.prototype.updateDuringAnimation = function(targetKey) {
    if (targetKey === "style") {
      this.dirtyStyle();
    } else if (targetKey === "shape") {
      this.dirtyShape();
    } else {
      this.markRedraw();
    }
  };
  Path2.prototype.attrKV = function(key, value) {
    if (key === "shape") {
      this.setShape(value);
    } else {
      _super.prototype.attrKV.call(this, key, value);
    }
  };
  Path2.prototype.setShape = function(keyOrObj, value) {
    var shape = this.shape;
    if (!shape) {
      shape = this.shape = {};
    }
    if (typeof keyOrObj === "string") {
      shape[keyOrObj] = value;
    } else {
      extend(shape, keyOrObj);
    }
    this.dirtyShape();
    return this;
  };
  Path2.prototype.shapeChanged = function() {
    return !!(this.__dirty & SHAPE_CHANGED_BIT);
  };
  Path2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_PATH_STYLE, obj);
  };
  Path2.prototype._innerSaveToNormal = function(toState) {
    _super.prototype._innerSaveToNormal.call(this, toState);
    var normalState = this._normalState;
    if (toState.shape && !normalState.shape) {
      normalState.shape = extend({}, this.shape);
    }
  };
  Path2.prototype._applyStateObj = function(stateName, state, normalState, keepCurrentStates, transition, animationCfg) {
    _super.prototype._applyStateObj.call(this, stateName, state, normalState, keepCurrentStates, transition, animationCfg);
    var needsRestoreToNormal = !(state && keepCurrentStates);
    var targetShape;
    if (state && state.shape) {
      if (transition) {
        if (keepCurrentStates) {
          targetShape = state.shape;
        } else {
          targetShape = extend({}, normalState.shape);
          extend(targetShape, state.shape);
        }
      } else {
        targetShape = extend({}, keepCurrentStates ? this.shape : normalState.shape);
        extend(targetShape, state.shape);
      }
    } else if (needsRestoreToNormal) {
      targetShape = normalState.shape;
    }
    if (targetShape) {
      if (transition) {
        this.shape = extend({}, this.shape);
        var targetShapePrimaryProps = {};
        var shapeKeys = keys(targetShape);
        for (var i = 0; i < shapeKeys.length; i++) {
          var key = shapeKeys[i];
          if (typeof targetShape[key] === "object") {
            this.shape[key] = targetShape[key];
          } else {
            targetShapePrimaryProps[key] = targetShape[key];
          }
        }
        this._transitionState(stateName, {
          shape: targetShapePrimaryProps
        }, animationCfg);
      } else {
        this.shape = targetShape;
        this.dirtyShape();
      }
    }
  };
  Path2.prototype._mergeStates = function(states) {
    var mergedState = _super.prototype._mergeStates.call(this, states);
    var mergedShape;
    for (var i = 0; i < states.length; i++) {
      var state = states[i];
      if (state.shape) {
        mergedShape = mergedShape || {};
        this._mergeStyle(mergedShape, state.shape);
      }
    }
    if (mergedShape) {
      mergedState.shape = mergedShape;
    }
    return mergedState;
  };
  Path2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_PATH_ANIMATION_PROPS;
  };
  Path2.prototype.isZeroArea = function() {
    return false;
  };
  Path2.extend = function(defaultProps) {
    var Sub = function(_super2) {
      __extends(Sub2, _super2);
      function Sub2(opts) {
        var _this = _super2.call(this, opts) || this;
        defaultProps.init && defaultProps.init.call(_this, opts);
        return _this;
      }
      Sub2.prototype.getDefaultStyle = function() {
        return clone$4(defaultProps.style);
      };
      Sub2.prototype.getDefaultShape = function() {
        return clone$4(defaultProps.shape);
      };
      return Sub2;
    }(Path2);
    for (var key in defaultProps) {
      if (typeof defaultProps[key] === "function") {
        Sub.prototype[key] = defaultProps[key];
      }
    }
    return Sub;
  };
  Path2.initDefaultProps = function() {
    var pathProto = Path2.prototype;
    pathProto.type = "path";
    pathProto.strokeContainThreshold = 5;
    pathProto.segmentIgnoreThreshold = 0;
    pathProto.subPixelOptimize = false;
    pathProto.autoBatch = false;
    pathProto.__dirty = REDRAW_BIT | STYLE_CHANGED_BIT | SHAPE_CHANGED_BIT;
  }();
  return Path2;
}(Displayable$1);
var Path$1 = Path;
var DEFAULT_TSPAN_STYLE = defaults({
  strokeFirst: true,
  font: DEFAULT_FONT,
  x: 0,
  y: 0,
  textAlign: "left",
  textBaseline: "top",
  miterLimit: 2
}, DEFAULT_PATH_STYLE);
var TSpan = function(_super) {
  __extends(TSpan2, _super);
  function TSpan2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  TSpan2.prototype.hasStroke = function() {
    var style = this.style;
    var stroke = style.stroke;
    return stroke != null && stroke !== "none" && style.lineWidth > 0;
  };
  TSpan2.prototype.hasFill = function() {
    var style = this.style;
    var fill = style.fill;
    return fill != null && fill !== "none";
  };
  TSpan2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_TSPAN_STYLE, obj);
  };
  TSpan2.prototype.setBoundingRect = function(rect) {
    this._rect = rect;
  };
  TSpan2.prototype.getBoundingRect = function() {
    var style = this.style;
    if (!this._rect) {
      var text = style.text;
      text != null ? text += "" : text = "";
      var rect = getBoundingRect(text, style.font, style.textAlign, style.textBaseline);
      rect.x += style.x || 0;
      rect.y += style.y || 0;
      if (this.hasStroke()) {
        var w2 = style.lineWidth;
        rect.x -= w2 / 2;
        rect.y -= w2 / 2;
        rect.width += w2;
        rect.height += w2;
      }
      this._rect = rect;
    }
    return this._rect;
  };
  TSpan2.initDefaultProps = function() {
    var tspanProto = TSpan2.prototype;
    tspanProto.dirtyRectTolerance = 10;
  }();
  return TSpan2;
}(Displayable$1);
TSpan.prototype.type = "tspan";
var TSpan$1 = TSpan;
var DEFAULT_IMAGE_STYLE = defaults({
  x: 0,
  y: 0
}, DEFAULT_COMMON_STYLE);
var DEFAULT_IMAGE_ANIMATION_PROPS = {
  style: defaults({
    x: true,
    y: true,
    width: true,
    height: true,
    sx: true,
    sy: true,
    sWidth: true,
    sHeight: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
function isImageLike$1(source) {
  return !!(source && typeof source !== "string" && source.width && source.height);
}
var ZRImage = function(_super) {
  __extends(ZRImage2, _super);
  function ZRImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ZRImage2.prototype.createStyle = function(obj) {
    return createObject(DEFAULT_IMAGE_STYLE, obj);
  };
  ZRImage2.prototype._getSize = function(dim) {
    var style = this.style;
    var size = style[dim];
    if (size != null) {
      return size;
    }
    var imageSource = isImageLike$1(style.image) ? style.image : this.__image;
    if (!imageSource) {
      return 0;
    }
    var otherDim = dim === "width" ? "height" : "width";
    var otherDimSize = style[otherDim];
    if (otherDimSize == null) {
      return imageSource[dim];
    } else {
      return imageSource[dim] / imageSource[otherDim] * otherDimSize;
    }
  };
  ZRImage2.prototype.getWidth = function() {
    return this._getSize("width");
  };
  ZRImage2.prototype.getHeight = function() {
    return this._getSize("height");
  };
  ZRImage2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_IMAGE_ANIMATION_PROPS;
  };
  ZRImage2.prototype.getBoundingRect = function() {
    var style = this.style;
    if (!this._rect) {
      this._rect = new BoundingRect$1(style.x || 0, style.y || 0, this.getWidth(), this.getHeight());
    }
    return this._rect;
  };
  return ZRImage2;
}(Displayable$1);
ZRImage.prototype.type = "image";
var ZRImage$1 = ZRImage;
function buildPath$2(ctx, shape) {
  var x2 = shape.x;
  var y2 = shape.y;
  var width = shape.width;
  var height = shape.height;
  var r2 = shape.r;
  var r1;
  var r22;
  var r3;
  var r4;
  if (width < 0) {
    x2 = x2 + width;
    width = -width;
  }
  if (height < 0) {
    y2 = y2 + height;
    height = -height;
  }
  if (typeof r2 === "number") {
    r1 = r22 = r3 = r4 = r2;
  } else if (r2 instanceof Array) {
    if (r2.length === 1) {
      r1 = r22 = r3 = r4 = r2[0];
    } else if (r2.length === 2) {
      r1 = r3 = r2[0];
      r22 = r4 = r2[1];
    } else if (r2.length === 3) {
      r1 = r2[0];
      r22 = r4 = r2[1];
      r3 = r2[2];
    } else {
      r1 = r2[0];
      r22 = r2[1];
      r3 = r2[2];
      r4 = r2[3];
    }
  } else {
    r1 = r22 = r3 = r4 = 0;
  }
  var total;
  if (r1 + r22 > width) {
    total = r1 + r22;
    r1 *= width / total;
    r22 *= width / total;
  }
  if (r3 + r4 > width) {
    total = r3 + r4;
    r3 *= width / total;
    r4 *= width / total;
  }
  if (r22 + r3 > height) {
    total = r22 + r3;
    r22 *= height / total;
    r3 *= height / total;
  }
  if (r1 + r4 > height) {
    total = r1 + r4;
    r1 *= height / total;
    r4 *= height / total;
  }
  ctx.moveTo(x2 + r1, y2);
  ctx.lineTo(x2 + width - r22, y2);
  r22 !== 0 && ctx.arc(x2 + width - r22, y2 + r22, r22, -Math.PI / 2, 0);
  ctx.lineTo(x2 + width, y2 + height - r3);
  r3 !== 0 && ctx.arc(x2 + width - r3, y2 + height - r3, r3, 0, Math.PI / 2);
  ctx.lineTo(x2 + r4, y2 + height);
  r4 !== 0 && ctx.arc(x2 + r4, y2 + height - r4, r4, Math.PI / 2, Math.PI);
  ctx.lineTo(x2, y2 + r1);
  r1 !== 0 && ctx.arc(x2 + r1, y2 + r1, r1, Math.PI, Math.PI * 1.5);
}
var round$2 = Math.round;
function subPixelOptimizeLine$1(outputShape, inputShape, style) {
  if (!inputShape) {
    return;
  }
  var x1 = inputShape.x1;
  var x2 = inputShape.x2;
  var y1 = inputShape.y1;
  var y2 = inputShape.y2;
  outputShape.x1 = x1;
  outputShape.x2 = x2;
  outputShape.y1 = y1;
  outputShape.y2 = y2;
  var lineWidth = style && style.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  if (round$2(x1 * 2) === round$2(x2 * 2)) {
    outputShape.x1 = outputShape.x2 = subPixelOptimize$1(x1, lineWidth, true);
  }
  if (round$2(y1 * 2) === round$2(y2 * 2)) {
    outputShape.y1 = outputShape.y2 = subPixelOptimize$1(y1, lineWidth, true);
  }
  return outputShape;
}
function subPixelOptimizeRect$1(outputShape, inputShape, style) {
  if (!inputShape) {
    return;
  }
  var originX = inputShape.x;
  var originY = inputShape.y;
  var originWidth = inputShape.width;
  var originHeight = inputShape.height;
  outputShape.x = originX;
  outputShape.y = originY;
  outputShape.width = originWidth;
  outputShape.height = originHeight;
  var lineWidth = style && style.lineWidth;
  if (!lineWidth) {
    return outputShape;
  }
  outputShape.x = subPixelOptimize$1(originX, lineWidth, true);
  outputShape.y = subPixelOptimize$1(originY, lineWidth, true);
  outputShape.width = Math.max(subPixelOptimize$1(originX + originWidth, lineWidth, false) - outputShape.x, originWidth === 0 ? 0 : 1);
  outputShape.height = Math.max(subPixelOptimize$1(originY + originHeight, lineWidth, false) - outputShape.y, originHeight === 0 ? 0 : 1);
  return outputShape;
}
function subPixelOptimize$1(position2, lineWidth, positiveOrNegative) {
  if (!lineWidth) {
    return position2;
  }
  var doubledPosition = round$2(position2 * 2);
  return (doubledPosition + round$2(lineWidth)) % 2 === 0 ? doubledPosition / 2 : (doubledPosition + (positiveOrNegative ? 1 : -1)) / 2;
}
var RectShape = function() {
  function RectShape2() {
    this.x = 0;
    this.y = 0;
    this.width = 0;
    this.height = 0;
  }
  return RectShape2;
}();
var subPixelOptimizeOutputShape$1 = {};
var Rect$2 = function(_super) {
  __extends(Rect2, _super);
  function Rect2(opts) {
    return _super.call(this, opts) || this;
  }
  Rect2.prototype.getDefaultShape = function() {
    return new RectShape();
  };
  Rect2.prototype.buildPath = function(ctx, shape) {
    var x2;
    var y2;
    var width;
    var height;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeRect$1(subPixelOptimizeOutputShape$1, shape, this.style);
      x2 = optimizedShape.x;
      y2 = optimizedShape.y;
      width = optimizedShape.width;
      height = optimizedShape.height;
      optimizedShape.r = shape.r;
      shape = optimizedShape;
    } else {
      x2 = shape.x;
      y2 = shape.y;
      width = shape.width;
      height = shape.height;
    }
    if (!shape.r) {
      ctx.rect(x2, y2, width, height);
    } else {
      buildPath$2(ctx, shape);
    }
  };
  Rect2.prototype.isZeroArea = function() {
    return !this.shape.width || !this.shape.height;
  };
  return Rect2;
}(Path$1);
Rect$2.prototype.type = "rect";
var Rect$3 = Rect$2;
var DEFAULT_RICH_TEXT_COLOR = {
  fill: "#000"
};
var DEFAULT_STROKE_LINE_WIDTH = 2;
var DEFAULT_TEXT_ANIMATION_PROPS = {
  style: defaults({
    fill: true,
    stroke: true,
    fillOpacity: true,
    strokeOpacity: true,
    lineWidth: true,
    fontSize: true,
    lineHeight: true,
    width: true,
    height: true,
    textShadowColor: true,
    textShadowBlur: true,
    textShadowOffsetX: true,
    textShadowOffsetY: true,
    backgroundColor: true,
    padding: true,
    borderColor: true,
    borderWidth: true,
    borderRadius: true
  }, DEFAULT_COMMON_ANIMATION_PROPS.style)
};
var ZRText = function(_super) {
  __extends(ZRText2, _super);
  function ZRText2(opts) {
    var _this = _super.call(this) || this;
    _this.type = "text";
    _this._children = [];
    _this._defaultStyle = DEFAULT_RICH_TEXT_COLOR;
    _this.attr(opts);
    return _this;
  }
  ZRText2.prototype.childrenRef = function() {
    return this._children;
  };
  ZRText2.prototype.update = function() {
    _super.prototype.update.call(this);
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    for (var i = 0; i < this._children.length; i++) {
      var child = this._children[i];
      child.zlevel = this.zlevel;
      child.z = this.z;
      child.z2 = this.z2;
      child.culling = this.culling;
      child.cursor = this.cursor;
      child.invisible = this.invisible;
    }
  };
  ZRText2.prototype.updateTransform = function() {
    var innerTransformable = this.innerTransformable;
    if (innerTransformable) {
      innerTransformable.updateTransform();
      if (innerTransformable.transform) {
        this.transform = innerTransformable.transform;
      }
    } else {
      _super.prototype.updateTransform.call(this);
    }
  };
  ZRText2.prototype.getLocalTransform = function(m2) {
    var innerTransformable = this.innerTransformable;
    return innerTransformable ? innerTransformable.getLocalTransform(m2) : _super.prototype.getLocalTransform.call(this, m2);
  };
  ZRText2.prototype.getComputedTransform = function() {
    if (this.__hostTarget) {
      this.__hostTarget.getComputedTransform();
      this.__hostTarget.updateInnerText(true);
    }
    return _super.prototype.getComputedTransform.call(this);
  };
  ZRText2.prototype._updateSubTexts = function() {
    this._childCursor = 0;
    normalizeTextStyle(this.style);
    this.style.rich ? this._updateRichTexts() : this._updatePlainTexts();
    this._children.length = this._childCursor;
    this.styleUpdated();
  };
  ZRText2.prototype.addSelfToZr = function(zr) {
    _super.prototype.addSelfToZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = zr;
    }
  };
  ZRText2.prototype.removeSelfFromZr = function(zr) {
    _super.prototype.removeSelfFromZr.call(this, zr);
    for (var i = 0; i < this._children.length; i++) {
      this._children[i].__zr = null;
    }
  };
  ZRText2.prototype.getBoundingRect = function() {
    if (this.styleChanged()) {
      this._updateSubTexts();
    }
    if (!this._rect) {
      var tmpRect2 = new BoundingRect$1(0, 0, 0, 0);
      var children = this._children;
      var tmpMat = [];
      var rect = null;
      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        var childRect = child.getBoundingRect();
        var transform2 = child.getLocalTransform(tmpMat);
        if (transform2) {
          tmpRect2.copy(childRect);
          tmpRect2.applyTransform(transform2);
          rect = rect || tmpRect2.clone();
          rect.union(tmpRect2);
        } else {
          rect = rect || childRect.clone();
          rect.union(childRect);
        }
      }
      this._rect = rect || tmpRect2;
    }
    return this._rect;
  };
  ZRText2.prototype.setDefaultTextStyle = function(defaultTextStyle) {
    this._defaultStyle = defaultTextStyle || DEFAULT_RICH_TEXT_COLOR;
  };
  ZRText2.prototype.setTextContent = function(textContent) {
  };
  ZRText2.prototype._mergeStyle = function(targetStyle, sourceStyle) {
    if (!sourceStyle) {
      return targetStyle;
    }
    var sourceRich = sourceStyle.rich;
    var targetRich = targetStyle.rich || sourceRich && {};
    extend(targetStyle, sourceStyle);
    if (sourceRich && targetRich) {
      this._mergeRich(targetRich, sourceRich);
      targetStyle.rich = targetRich;
    } else if (targetRich) {
      targetStyle.rich = targetRich;
    }
    return targetStyle;
  };
  ZRText2.prototype._mergeRich = function(targetRich, sourceRich) {
    var richNames = keys(sourceRich);
    for (var i = 0; i < richNames.length; i++) {
      var richName = richNames[i];
      targetRich[richName] = targetRich[richName] || {};
      extend(targetRich[richName], sourceRich[richName]);
    }
  };
  ZRText2.prototype.getAnimationStyleProps = function() {
    return DEFAULT_TEXT_ANIMATION_PROPS;
  };
  ZRText2.prototype._getOrCreateChild = function(Ctor) {
    var child = this._children[this._childCursor];
    if (!child || !(child instanceof Ctor)) {
      child = new Ctor();
    }
    this._children[this._childCursor++] = child;
    child.__zr = this.__zr;
    child.parent = this;
    return child;
  };
  ZRText2.prototype._updatePlainTexts = function() {
    var style = this.style;
    var textFont = style.font || DEFAULT_FONT;
    var textPadding = style.padding;
    var text = getStyleText(style);
    var contentBlock = parsePlainText(text, style);
    var needDrawBg = needDrawBackground(style);
    var bgColorDrawn = !!style.backgroundColor;
    var outerHeight = contentBlock.outerHeight;
    var outerWidth = contentBlock.outerWidth;
    var contentWidth = contentBlock.contentWidth;
    var textLines = contentBlock.lines;
    var lineHeight = contentBlock.lineHeight;
    var defaultStyle = this._defaultStyle;
    var baseX = style.x || 0;
    var baseY = style.y || 0;
    var textAlign = style.align || defaultStyle.align || "left";
    var verticalAlign = style.verticalAlign || defaultStyle.verticalAlign || "top";
    var textX = baseX;
    var textY = adjustTextY(baseY, contentBlock.contentHeight, verticalAlign);
    if (needDrawBg || textPadding) {
      var boxX = adjustTextX(baseX, outerWidth, textAlign);
      var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
      needDrawBg && this._renderBackground(style, style, boxX, boxY, outerWidth, outerHeight);
    }
    textY += lineHeight / 2;
    if (textPadding) {
      textX = getTextXForPadding(baseX, textAlign, textPadding);
      if (verticalAlign === "top") {
        textY += textPadding[0];
      } else if (verticalAlign === "bottom") {
        textY -= textPadding[2];
      }
    }
    var defaultLineWidth = 0;
    var useDefaultFill = false;
    var textFill = getFill("fill" in style ? style.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in style ? style.stroke : !bgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = style.textShadowBlur > 0;
    var fixedBoundingRect = style.width != null && (style.overflow === "truncate" || style.overflow === "break" || style.overflow === "breakAll");
    var calculatedLineHeight = contentBlock.calculatedLineHeight;
    for (var i = 0; i < textLines.length; i++) {
      var el = this._getOrCreateChild(TSpan$1);
      var subElStyle = el.createStyle();
      el.useStyle(subElStyle);
      subElStyle.text = textLines[i];
      subElStyle.x = textX;
      subElStyle.y = textY;
      if (textAlign) {
        subElStyle.textAlign = textAlign;
      }
      subElStyle.textBaseline = "middle";
      subElStyle.opacity = style.opacity;
      subElStyle.strokeFirst = true;
      if (hasShadow2) {
        subElStyle.shadowBlur = style.textShadowBlur || 0;
        subElStyle.shadowColor = style.textShadowColor || "transparent";
        subElStyle.shadowOffsetX = style.textShadowOffsetX || 0;
        subElStyle.shadowOffsetY = style.textShadowOffsetY || 0;
      }
      subElStyle.stroke = textStroke;
      subElStyle.fill = textFill;
      if (textStroke) {
        subElStyle.lineWidth = style.lineWidth || defaultLineWidth;
        subElStyle.lineDash = style.lineDash;
        subElStyle.lineDashOffset = style.lineDashOffset || 0;
      }
      subElStyle.font = textFont;
      setSeparateFont(subElStyle, style);
      textY += lineHeight;
      if (fixedBoundingRect) {
        el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, style.width, subElStyle.textAlign), adjustTextY(subElStyle.y, calculatedLineHeight, subElStyle.textBaseline), contentWidth, calculatedLineHeight));
      }
    }
  };
  ZRText2.prototype._updateRichTexts = function() {
    var style = this.style;
    var text = getStyleText(style);
    var contentBlock = parseRichText(text, style);
    var contentWidth = contentBlock.width;
    var outerWidth = contentBlock.outerWidth;
    var outerHeight = contentBlock.outerHeight;
    var textPadding = style.padding;
    var baseX = style.x || 0;
    var baseY = style.y || 0;
    var defaultStyle = this._defaultStyle;
    var textAlign = style.align || defaultStyle.align;
    var verticalAlign = style.verticalAlign || defaultStyle.verticalAlign;
    var boxX = adjustTextX(baseX, outerWidth, textAlign);
    var boxY = adjustTextY(baseY, outerHeight, verticalAlign);
    var xLeft = boxX;
    var lineTop = boxY;
    if (textPadding) {
      xLeft += textPadding[3];
      lineTop += textPadding[0];
    }
    var xRight = xLeft + contentWidth;
    if (needDrawBackground(style)) {
      this._renderBackground(style, style, boxX, boxY, outerWidth, outerHeight);
    }
    var bgColorDrawn = !!style.backgroundColor;
    for (var i = 0; i < contentBlock.lines.length; i++) {
      var line = contentBlock.lines[i];
      var tokens = line.tokens;
      var tokenCount = tokens.length;
      var lineHeight = line.lineHeight;
      var remainedWidth = line.width;
      var leftIndex = 0;
      var lineXLeft = xLeft;
      var lineXRight = xRight;
      var rightIndex = tokenCount - 1;
      var token = void 0;
      while (leftIndex < tokenCount && (token = tokens[leftIndex], !token.align || token.align === "left")) {
        this._placeToken(token, style, lineHeight, lineTop, lineXLeft, "left", bgColorDrawn);
        remainedWidth -= token.width;
        lineXLeft += token.width;
        leftIndex++;
      }
      while (rightIndex >= 0 && (token = tokens[rightIndex], token.align === "right")) {
        this._placeToken(token, style, lineHeight, lineTop, lineXRight, "right", bgColorDrawn);
        remainedWidth -= token.width;
        lineXRight -= token.width;
        rightIndex--;
      }
      lineXLeft += (contentWidth - (lineXLeft - xLeft) - (xRight - lineXRight) - remainedWidth) / 2;
      while (leftIndex <= rightIndex) {
        token = tokens[leftIndex];
        this._placeToken(token, style, lineHeight, lineTop, lineXLeft + token.width / 2, "center", bgColorDrawn);
        lineXLeft += token.width;
        leftIndex++;
      }
      lineTop += lineHeight;
    }
  };
  ZRText2.prototype._placeToken = function(token, style, lineHeight, lineTop, x2, textAlign, parentBgColorDrawn) {
    var tokenStyle = style.rich[token.styleName] || {};
    tokenStyle.text = token.text;
    var verticalAlign = token.verticalAlign;
    var y2 = lineTop + lineHeight / 2;
    if (verticalAlign === "top") {
      y2 = lineTop + token.height / 2;
    } else if (verticalAlign === "bottom") {
      y2 = lineTop + lineHeight - token.height / 2;
    }
    var needDrawBg = !token.isLineHolder && needDrawBackground(tokenStyle);
    needDrawBg && this._renderBackground(tokenStyle, style, textAlign === "right" ? x2 - token.width : textAlign === "center" ? x2 - token.width / 2 : x2, y2 - token.height / 2, token.width, token.height);
    var bgColorDrawn = !!tokenStyle.backgroundColor;
    var textPadding = token.textPadding;
    if (textPadding) {
      x2 = getTextXForPadding(x2, textAlign, textPadding);
      y2 -= token.height / 2 - textPadding[0] - token.innerHeight / 2;
    }
    var el = this._getOrCreateChild(TSpan$1);
    var subElStyle = el.createStyle();
    el.useStyle(subElStyle);
    var defaultStyle = this._defaultStyle;
    var useDefaultFill = false;
    var defaultLineWidth = 0;
    var textFill = getFill("fill" in tokenStyle ? tokenStyle.fill : "fill" in style ? style.fill : (useDefaultFill = true, defaultStyle.fill));
    var textStroke = getStroke("stroke" in tokenStyle ? tokenStyle.stroke : "stroke" in style ? style.stroke : !bgColorDrawn && !parentBgColorDrawn && (!defaultStyle.autoStroke || useDefaultFill) ? (defaultLineWidth = DEFAULT_STROKE_LINE_WIDTH, defaultStyle.stroke) : null);
    var hasShadow2 = tokenStyle.textShadowBlur > 0 || style.textShadowBlur > 0;
    subElStyle.text = token.text;
    subElStyle.x = x2;
    subElStyle.y = y2;
    if (hasShadow2) {
      subElStyle.shadowBlur = tokenStyle.textShadowBlur || style.textShadowBlur || 0;
      subElStyle.shadowColor = tokenStyle.textShadowColor || style.textShadowColor || "transparent";
      subElStyle.shadowOffsetX = tokenStyle.textShadowOffsetX || style.textShadowOffsetX || 0;
      subElStyle.shadowOffsetY = tokenStyle.textShadowOffsetY || style.textShadowOffsetY || 0;
    }
    subElStyle.textAlign = textAlign;
    subElStyle.textBaseline = "middle";
    subElStyle.font = token.font || DEFAULT_FONT;
    subElStyle.opacity = retrieve3(tokenStyle.opacity, style.opacity, 1);
    setSeparateFont(subElStyle, tokenStyle);
    if (textStroke) {
      subElStyle.lineWidth = retrieve3(tokenStyle.lineWidth, style.lineWidth, defaultLineWidth);
      subElStyle.lineDash = retrieve2(tokenStyle.lineDash, style.lineDash);
      subElStyle.lineDashOffset = style.lineDashOffset || 0;
      subElStyle.stroke = textStroke;
    }
    if (textFill) {
      subElStyle.fill = textFill;
    }
    var textWidth = token.contentWidth;
    var textHeight = token.contentHeight;
    el.setBoundingRect(new BoundingRect$1(adjustTextX(subElStyle.x, textWidth, subElStyle.textAlign), adjustTextY(subElStyle.y, textHeight, subElStyle.textBaseline), textWidth, textHeight));
  };
  ZRText2.prototype._renderBackground = function(style, topStyle, x2, y2, width, height) {
    var textBackgroundColor = style.backgroundColor;
    var textBorderWidth = style.borderWidth;
    var textBorderColor = style.borderColor;
    var isImageBg = textBackgroundColor && textBackgroundColor.image;
    var isPlainOrGradientBg = textBackgroundColor && !isImageBg;
    var textBorderRadius = style.borderRadius;
    var self2 = this;
    var rectEl;
    var imgEl;
    if (isPlainOrGradientBg || style.lineHeight || textBorderWidth && textBorderColor) {
      rectEl = this._getOrCreateChild(Rect$3);
      rectEl.useStyle(rectEl.createStyle());
      rectEl.style.fill = null;
      var rectShape = rectEl.shape;
      rectShape.x = x2;
      rectShape.y = y2;
      rectShape.width = width;
      rectShape.height = height;
      rectShape.r = textBorderRadius;
      rectEl.dirtyShape();
    }
    if (isPlainOrGradientBg) {
      var rectStyle = rectEl.style;
      rectStyle.fill = textBackgroundColor || null;
      rectStyle.fillOpacity = retrieve2(style.fillOpacity, 1);
    } else if (isImageBg) {
      imgEl = this._getOrCreateChild(ZRImage$1);
      imgEl.onload = function() {
        self2.dirtyStyle();
      };
      var imgStyle = imgEl.style;
      imgStyle.image = textBackgroundColor.image;
      imgStyle.x = x2;
      imgStyle.y = y2;
      imgStyle.width = width;
      imgStyle.height = height;
    }
    if (textBorderWidth && textBorderColor) {
      var rectStyle = rectEl.style;
      rectStyle.lineWidth = textBorderWidth;
      rectStyle.stroke = textBorderColor;
      rectStyle.strokeOpacity = retrieve2(style.strokeOpacity, 1);
      rectStyle.lineDash = style.borderDash;
      rectStyle.lineDashOffset = style.borderDashOffset || 0;
      rectEl.strokeContainThreshold = 0;
      if (rectEl.hasFill() && rectEl.hasStroke()) {
        rectStyle.strokeFirst = true;
        rectStyle.lineWidth *= 2;
      }
    }
    var commonStyle = (rectEl || imgEl).style;
    commonStyle.shadowBlur = style.shadowBlur || 0;
    commonStyle.shadowColor = style.shadowColor || "transparent";
    commonStyle.shadowOffsetX = style.shadowOffsetX || 0;
    commonStyle.shadowOffsetY = style.shadowOffsetY || 0;
    commonStyle.opacity = retrieve3(style.opacity, topStyle.opacity, 1);
  };
  ZRText2.makeFont = function(style) {
    var font = "";
    if (hasSeparateFont(style)) {
      font = [
        style.fontStyle,
        style.fontWeight,
        parseFontSize(style.fontSize),
        style.fontFamily || "sans-serif"
      ].join(" ");
    }
    return font && trim$1(font) || style.textFont || style.font;
  };
  return ZRText2;
}(Displayable$1);
var VALID_TEXT_ALIGN = { left: true, right: 1, center: 1 };
var VALID_TEXT_VERTICAL_ALIGN = { top: 1, bottom: 1, middle: 1 };
var FONT_PARTS = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
function parseFontSize(fontSize) {
  if (typeof fontSize === "string" && (fontSize.indexOf("px") !== -1 || fontSize.indexOf("rem") !== -1 || fontSize.indexOf("em") !== -1)) {
    return fontSize;
  } else if (!isNaN(+fontSize)) {
    return fontSize + "px";
  } else {
    return DEFAULT_FONT_SIZE + "px";
  }
}
function setSeparateFont(targetStyle, sourceStyle) {
  for (var i = 0; i < FONT_PARTS.length; i++) {
    var fontProp = FONT_PARTS[i];
    var val = sourceStyle[fontProp];
    if (val != null) {
      targetStyle[fontProp] = val;
    }
  }
}
function hasSeparateFont(style) {
  return style.fontSize != null || style.fontFamily || style.fontWeight;
}
function normalizeTextStyle(style) {
  normalizeStyle(style);
  each$f(style.rich, normalizeStyle);
  return style;
}
function normalizeStyle(style) {
  if (style) {
    style.font = ZRText.makeFont(style);
    var textAlign = style.align;
    textAlign === "middle" && (textAlign = "center");
    style.align = textAlign == null || VALID_TEXT_ALIGN[textAlign] ? textAlign : "left";
    var verticalAlign = style.verticalAlign;
    verticalAlign === "center" && (verticalAlign = "middle");
    style.verticalAlign = verticalAlign == null || VALID_TEXT_VERTICAL_ALIGN[verticalAlign] ? verticalAlign : "top";
    var textPadding = style.padding;
    if (textPadding) {
      style.padding = normalizeCssArray$1(style.padding);
    }
  }
}
function getStroke(stroke, lineWidth) {
  return stroke == null || lineWidth <= 0 || stroke === "transparent" || stroke === "none" ? null : stroke.image || stroke.colorStops ? "#000" : stroke;
}
function getFill(fill) {
  return fill == null || fill === "none" ? null : fill.image || fill.colorStops ? "#000" : fill;
}
function getTextXForPadding(x2, textAlign, textPadding) {
  return textAlign === "right" ? x2 - textPadding[1] : textAlign === "center" ? x2 + textPadding[3] / 2 - textPadding[1] / 2 : x2 + textPadding[3];
}
function getStyleText(style) {
  var text = style.text;
  text != null && (text += "");
  return text;
}
function needDrawBackground(style) {
  return !!(style.backgroundColor || style.lineHeight || style.borderWidth && style.borderColor);
}
var ZRText$1 = ZRText;
var getECData = makeInner();
var setCommonECData = function(seriesIndex, dataType, dataIdx, el) {
  if (el) {
    var ecData = getECData(el);
    ecData.dataIndex = dataIdx;
    ecData.dataType = dataType;
    ecData.seriesIndex = seriesIndex;
    if (el.type === "group") {
      el.traverse(function(child) {
        var childECData = getECData(child);
        childECData.seriesIndex = seriesIndex;
        childECData.dataIndex = dataIdx;
        childECData.dataType = dataType;
      });
    }
  }
};
var _highlightNextDigit = 1;
var _highlightKeyMap = {};
var getSavedStates = makeInner();
var getComponentStates = makeInner();
var HOVER_STATE_NORMAL = 0;
var HOVER_STATE_BLUR = 1;
var HOVER_STATE_EMPHASIS = 2;
var SPECIAL_STATES = ["emphasis", "blur", "select"];
var DISPLAY_STATES = ["normal", "emphasis", "blur", "select"];
var Z2_EMPHASIS_LIFT = 10;
var Z2_SELECT_LIFT = 9;
var HIGHLIGHT_ACTION_TYPE = "highlight";
var DOWNPLAY_ACTION_TYPE = "downplay";
var SELECT_ACTION_TYPE = "select";
var UNSELECT_ACTION_TYPE = "unselect";
var TOGGLE_SELECT_ACTION_TYPE = "toggleSelect";
function hasFillOrStroke(fillOrStroke) {
  return fillOrStroke != null && fillOrStroke !== "none";
}
var liftedColorCache = new LRU$1(100);
function liftColor(color) {
  if (isString(color)) {
    var liftedColor = liftedColorCache.get(color);
    if (!liftedColor) {
      liftedColor = lift(color, -0.1);
      liftedColorCache.put(color, liftedColor);
    }
    return liftedColor;
  } else if (isGradientObject(color)) {
    var ret = extend({}, color);
    ret.colorStops = map$1(color.colorStops, function(stop2) {
      return {
        offset: stop2.offset,
        color: lift(stop2.color, -0.1)
      };
    });
    return ret;
  }
  return color;
}
function doChangeHoverState(el, stateName, hoverStateEnum) {
  if (el.onHoverStateChange && (el.hoverState || 0) !== hoverStateEnum) {
    el.onHoverStateChange(stateName);
  }
  el.hoverState = hoverStateEnum;
}
function singleEnterEmphasis(el) {
  doChangeHoverState(el, "emphasis", HOVER_STATE_EMPHASIS);
}
function singleLeaveEmphasis(el) {
  if (el.hoverState === HOVER_STATE_EMPHASIS) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterBlur(el) {
  doChangeHoverState(el, "blur", HOVER_STATE_BLUR);
}
function singleLeaveBlur(el) {
  if (el.hoverState === HOVER_STATE_BLUR) {
    doChangeHoverState(el, "normal", HOVER_STATE_NORMAL);
  }
}
function singleEnterSelect(el) {
  el.selected = true;
}
function singleLeaveSelect(el) {
  el.selected = false;
}
function updateElementState(el, updater, commonParam) {
  updater(el, commonParam);
}
function traverseUpdateState(el, updater, commonParam) {
  updateElementState(el, updater, commonParam);
  el.isGroup && el.traverse(function(child) {
    updateElementState(child, updater, commonParam);
  });
}
function setStatesFlag(el, stateName) {
  switch (stateName) {
    case "emphasis":
      el.hoverState = HOVER_STATE_EMPHASIS;
      break;
    case "normal":
      el.hoverState = HOVER_STATE_NORMAL;
      break;
    case "blur":
      el.hoverState = HOVER_STATE_BLUR;
      break;
    case "select":
      el.selected = true;
  }
}
function getFromStateStyle(el, props, toStateName, defaultValue) {
  var style = el.style;
  var fromState = {};
  for (var i = 0; i < props.length; i++) {
    var propName = props[i];
    var val = style[propName];
    fromState[propName] = val == null ? defaultValue && defaultValue[propName] : val;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.__fromStateTransition && animator.__fromStateTransition.indexOf(toStateName) < 0 && animator.targetName === "style") {
      animator.saveTo(fromState, props);
    }
  }
  return fromState;
}
function createEmphasisDefaultState(el, stateName, targetStates, state) {
  var hasSelect = targetStates && indexOf(targetStates, "select") >= 0;
  var cloned = false;
  if (el instanceof Path$1) {
    var store = getSavedStates(el);
    var fromFill = hasSelect ? store.selectFill || store.normalFill : store.normalFill;
    var fromStroke = hasSelect ? store.selectStroke || store.normalStroke : store.normalStroke;
    if (hasFillOrStroke(fromFill) || hasFillOrStroke(fromStroke)) {
      state = state || {};
      var emphasisStyle = state.style || {};
      if (emphasisStyle.fill === "inherit") {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = fromFill;
      } else if (!hasFillOrStroke(emphasisStyle.fill) && hasFillOrStroke(fromFill)) {
        cloned = true;
        state = extend({}, state);
        emphasisStyle = extend({}, emphasisStyle);
        emphasisStyle.fill = liftColor(fromFill);
      } else if (!hasFillOrStroke(emphasisStyle.stroke) && hasFillOrStroke(fromStroke)) {
        if (!cloned) {
          state = extend({}, state);
          emphasisStyle = extend({}, emphasisStyle);
        }
        emphasisStyle.stroke = liftColor(fromStroke);
      }
      state.style = emphasisStyle;
    }
  }
  if (state) {
    if (state.z2 == null) {
      if (!cloned) {
        state = extend({}, state);
      }
      var z2EmphasisLift = el.z2EmphasisLift;
      state.z2 = el.z2 + (z2EmphasisLift != null ? z2EmphasisLift : Z2_EMPHASIS_LIFT);
    }
  }
  return state;
}
function createSelectDefaultState(el, stateName, state) {
  if (state) {
    if (state.z2 == null) {
      state = extend({}, state);
      var z2SelectLift = el.z2SelectLift;
      state.z2 = el.z2 + (z2SelectLift != null ? z2SelectLift : Z2_SELECT_LIFT);
    }
  }
  return state;
}
function createBlurDefaultState(el, stateName, state) {
  var hasBlur = indexOf(el.currentStates, stateName) >= 0;
  var currentOpacity = el.style.opacity;
  var fromState = !hasBlur ? getFromStateStyle(el, ["opacity"], stateName, {
    opacity: 1
  }) : null;
  state = state || {};
  var blurStyle = state.style || {};
  if (blurStyle.opacity == null) {
    state = extend({}, state);
    blurStyle = extend({
      opacity: hasBlur ? currentOpacity : fromState.opacity * 0.1
    }, blurStyle);
    state.style = blurStyle;
  }
  return state;
}
function elementStateProxy(stateName, targetStates) {
  var state = this.states[stateName];
  if (this.style) {
    if (stateName === "emphasis") {
      return createEmphasisDefaultState(this, stateName, targetStates, state);
    } else if (stateName === "blur") {
      return createBlurDefaultState(this, stateName, state);
    } else if (stateName === "select") {
      return createSelectDefaultState(this, stateName, state);
    }
  }
  return state;
}
function setDefaultStateProxy(el) {
  el.stateProxy = elementStateProxy;
  var textContent = el.getTextContent();
  var textGuide = el.getTextGuideLine();
  if (textContent) {
    textContent.stateProxy = elementStateProxy;
  }
  if (textGuide) {
    textGuide.stateProxy = elementStateProxy;
  }
}
function enterEmphasisWhenMouseOver(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasisWhenMouseOut(el, e2) {
  !shouldSilent(el, e2) && !el.__highByOuter && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterEmphasis(el, highlightDigit) {
  el.__highByOuter |= 1 << (highlightDigit || 0);
  traverseUpdateState(el, singleEnterEmphasis);
}
function leaveEmphasis(el, highlightDigit) {
  !(el.__highByOuter &= ~(1 << (highlightDigit || 0))) && traverseUpdateState(el, singleLeaveEmphasis);
}
function enterBlur(el) {
  traverseUpdateState(el, singleEnterBlur);
}
function leaveBlur(el) {
  traverseUpdateState(el, singleLeaveBlur);
}
function enterSelect(el) {
  traverseUpdateState(el, singleEnterSelect);
}
function leaveSelect(el) {
  traverseUpdateState(el, singleLeaveSelect);
}
function shouldSilent(el, e2) {
  return el.__highDownSilentOnTouch && e2.zrByTouch;
}
function allLeaveBlur(api) {
  var model = api.getModel();
  model.eachComponent(function(componentType, componentModel) {
    var componentStates = getComponentStates(componentModel);
    if (componentStates.isBlured) {
      var view = componentType === "series" ? api.getViewOfSeriesModel(componentModel) : api.getViewOfComponentModel(componentModel);
      view.group.traverse(function(child) {
        singleLeaveBlur(child);
      });
    }
    componentStates.isBlured = false;
  });
}
function blurSeries(targetSeriesIndex, focus, blurScope, api) {
  var ecModel = api.getModel();
  blurScope = blurScope || "coordinateSystem";
  function leaveBlurOfIndices(data, dataIndices) {
    for (var i = 0; i < dataIndices.length; i++) {
      var itemEl = data.getItemGraphicEl(dataIndices[i]);
      itemEl && leaveBlur(itemEl);
    }
  }
  if (targetSeriesIndex == null) {
    return;
  }
  if (!focus || focus === "none") {
    return;
  }
  var targetSeriesModel = ecModel.getSeriesByIndex(targetSeriesIndex);
  var targetCoordSys = targetSeriesModel.coordinateSystem;
  if (targetCoordSys && targetCoordSys.master) {
    targetCoordSys = targetCoordSys.master;
  }
  var blurredSeries = [];
  ecModel.eachSeries(function(seriesModel) {
    var sameSeries = targetSeriesModel === seriesModel;
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.master) {
      coordSys = coordSys.master;
    }
    var sameCoordSys = coordSys && targetCoordSys ? coordSys === targetCoordSys : sameSeries;
    if (!(blurScope === "series" && !sameSeries || blurScope === "coordinateSystem" && !sameCoordSys || focus === "series" && sameSeries)) {
      var view = api.getViewOfSeriesModel(seriesModel);
      view.group.traverse(function(child) {
        singleEnterBlur(child);
      });
      if (isArrayLike(focus)) {
        leaveBlurOfIndices(seriesModel.getData(), focus);
      } else if (isObject$4(focus)) {
        var dataTypes = keys(focus);
        for (var d2 = 0; d2 < dataTypes.length; d2++) {
          leaveBlurOfIndices(seriesModel.getData(dataTypes[d2]), focus[dataTypes[d2]]);
        }
      }
      blurredSeries.push(seriesModel);
      getComponentStates(seriesModel).isBlured = true;
    }
  });
  ecModel.eachComponent(function(componentType, componentModel) {
    if (componentType === "series") {
      return;
    }
    var view = api.getViewOfComponentModel(componentModel);
    if (view && view.blurSeries) {
      view.blurSeries(blurredSeries, ecModel);
    }
  });
}
function blurComponent(componentMainType, componentIndex, api) {
  if (componentMainType == null || componentIndex == null) {
    return;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return;
  }
  getComponentStates(componentModel).isBlured = true;
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.focusBlurEnabled) {
    return;
  }
  view.group.traverse(function(child) {
    singleEnterBlur(child);
  });
}
function blurSeriesFromHighlightPayload(seriesModel, payload, api) {
  var seriesIndex = seriesModel.seriesIndex;
  var data = seriesModel.getData(payload.dataType);
  if (!data) {
    return;
  }
  var dataIndex = queryDataIndex(data, payload);
  dataIndex = (isArray$1(dataIndex) ? dataIndex[0] : dataIndex) || 0;
  var el = data.getItemGraphicEl(dataIndex);
  if (!el) {
    var count2 = data.count();
    var current = 0;
    while (!el && current < count2) {
      el = data.getItemGraphicEl(current++);
    }
  }
  if (el) {
    var ecData = getECData(el);
    blurSeries(seriesIndex, ecData.focus, ecData.blurScope, api);
  } else {
    var focus_1 = seriesModel.get(["emphasis", "focus"]);
    var blurScope = seriesModel.get(["emphasis", "blurScope"]);
    if (focus_1 != null) {
      blurSeries(seriesIndex, focus_1, blurScope, api);
    }
  }
}
function findComponentHighDownDispatchers(componentMainType, componentIndex, name, api) {
  var ret = {
    focusSelf: false,
    dispatchers: null
  };
  if (componentMainType == null || componentMainType === "series" || componentIndex == null || name == null) {
    return ret;
  }
  var componentModel = api.getModel().getComponent(componentMainType, componentIndex);
  if (!componentModel) {
    return ret;
  }
  var view = api.getViewOfComponentModel(componentModel);
  if (!view || !view.findHighDownDispatchers) {
    return ret;
  }
  var dispatchers = view.findHighDownDispatchers(name);
  var focusSelf;
  for (var i = 0; i < dispatchers.length; i++) {
    if (getECData(dispatchers[i]).focus === "self") {
      focusSelf = true;
      break;
    }
  }
  return {
    focusSelf,
    dispatchers
  };
}
function handleGlobalMouseOverForHighDown(dispatcher, e2, api) {
  var ecData = getECData(dispatcher);
  var _a2 = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api), dispatchers = _a2.dispatchers, focusSelf = _a2.focusSelf;
  if (dispatchers) {
    if (focusSelf) {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    each$f(dispatchers, function(dispatcher2) {
      return enterEmphasisWhenMouseOver(dispatcher2, e2);
    });
  } else {
    blurSeries(ecData.seriesIndex, ecData.focus, ecData.blurScope, api);
    if (ecData.focus === "self") {
      blurComponent(ecData.componentMainType, ecData.componentIndex, api);
    }
    enterEmphasisWhenMouseOver(dispatcher, e2);
  }
}
function handleGlobalMouseOutForHighDown(dispatcher, e2, api) {
  allLeaveBlur(api);
  var ecData = getECData(dispatcher);
  var dispatchers = findComponentHighDownDispatchers(ecData.componentMainType, ecData.componentIndex, ecData.componentHighDownName, api).dispatchers;
  if (dispatchers) {
    each$f(dispatchers, function(dispatcher2) {
      return leaveEmphasisWhenMouseOut(dispatcher2, e2);
    });
  } else {
    leaveEmphasisWhenMouseOut(dispatcher, e2);
  }
}
function toggleSelectionFromPayload(seriesModel, payload, api) {
  if (!isSelectChangePayload(payload)) {
    return;
  }
  var dataType = payload.dataType;
  var data = seriesModel.getData(dataType);
  var dataIndex = queryDataIndex(data, payload);
  if (!isArray$1(dataIndex)) {
    dataIndex = [dataIndex];
  }
  seriesModel[payload.type === TOGGLE_SELECT_ACTION_TYPE ? "toggleSelect" : payload.type === SELECT_ACTION_TYPE ? "select" : "unselect"](dataIndex, dataType);
}
function updateSeriesElementSelection(seriesModel) {
  var allData = seriesModel.getAllData();
  each$f(allData, function(_a2) {
    var data = _a2.data, type4 = _a2.type;
    data.eachItemGraphicEl(function(el, idx) {
      seriesModel.isSelected(idx, type4) ? enterSelect(el) : leaveSelect(el);
    });
  });
}
function getAllSelectedIndices(ecModel) {
  var ret = [];
  ecModel.eachSeries(function(seriesModel) {
    var allData = seriesModel.getAllData();
    each$f(allData, function(_a2) {
      _a2.data;
      var type4 = _a2.type;
      var dataIndices = seriesModel.getSelectedDataIndices();
      if (dataIndices.length > 0) {
        var item = {
          dataIndex: dataIndices,
          seriesIndex: seriesModel.seriesIndex
        };
        if (type4 != null) {
          item.dataType = type4;
        }
        ret.push(item);
      }
    });
  });
  return ret;
}
function enableHoverEmphasis(el, focus, blurScope) {
  setAsHighDownDispatcher(el, true);
  traverseUpdateState(el, setDefaultStateProxy);
  enableHoverFocus(el, focus, blurScope);
}
function disableHoverEmphasis(el) {
  setAsHighDownDispatcher(el, false);
}
function toggleHoverEmphasis(el, focus, blurScope, isDisabled) {
  isDisabled ? disableHoverEmphasis(el) : enableHoverEmphasis(el, focus, blurScope);
}
function enableHoverFocus(el, focus, blurScope) {
  var ecData = getECData(el);
  if (focus != null) {
    ecData.focus = focus;
    ecData.blurScope = blurScope;
  } else if (ecData.focus) {
    ecData.focus = null;
  }
}
var OTHER_STATES = ["emphasis", "blur", "select"];
var defaultStyleGetterMap = {
  itemStyle: "getItemStyle",
  lineStyle: "getLineStyle",
  areaStyle: "getAreaStyle"
};
function setStatesStylesFromModel(el, itemModel, styleType, getter) {
  styleType = styleType || "itemStyle";
  for (var i = 0; i < OTHER_STATES.length; i++) {
    var stateName = OTHER_STATES[i];
    var model = itemModel.getModel([stateName, styleType]);
    var state = el.ensureState(stateName);
    state.style = getter ? getter(model) : model[defaultStyleGetterMap[styleType]]();
  }
}
function setAsHighDownDispatcher(el, asDispatcher) {
  var disable = asDispatcher === false;
  var extendedEl = el;
  if (el.highDownSilentOnTouch) {
    extendedEl.__highDownSilentOnTouch = el.highDownSilentOnTouch;
  }
  if (!disable || extendedEl.__highDownDispatcher) {
    extendedEl.__highByOuter = extendedEl.__highByOuter || 0;
    extendedEl.__highDownDispatcher = !disable;
  }
}
function isHighDownDispatcher(el) {
  return !!(el && el.__highDownDispatcher);
}
function enableComponentHighDownFeatures(el, componentModel, componentHighDownName) {
  var ecData = getECData(el);
  ecData.componentMainType = componentModel.mainType;
  ecData.componentIndex = componentModel.componentIndex;
  ecData.componentHighDownName = componentHighDownName;
}
function getHighlightDigit(highlightKey) {
  var highlightDigit = _highlightKeyMap[highlightKey];
  if (highlightDigit == null && _highlightNextDigit <= 32) {
    highlightDigit = _highlightKeyMap[highlightKey] = _highlightNextDigit++;
  }
  return highlightDigit;
}
function isSelectChangePayload(payload) {
  var payloadType = payload.type;
  return payloadType === SELECT_ACTION_TYPE || payloadType === UNSELECT_ACTION_TYPE || payloadType === TOGGLE_SELECT_ACTION_TYPE;
}
function isHighDownPayload(payload) {
  var payloadType = payload.type;
  return payloadType === HIGHLIGHT_ACTION_TYPE || payloadType === DOWNPLAY_ACTION_TYPE;
}
function savePathStates(el) {
  var store = getSavedStates(el);
  store.normalFill = el.style.fill;
  store.normalStroke = el.style.stroke;
  var selectState = el.states.select || {};
  store.selectFill = selectState.style && selectState.style.fill || null;
  store.selectStroke = selectState.style && selectState.style.stroke || null;
}
var CMD$2 = PathProxy$1.CMD;
var points$2 = [[], [], []];
var mathSqrt$2 = Math.sqrt;
var mathAtan2 = Math.atan2;
function transformPath(path, m2) {
  if (!m2) {
    return;
  }
  var data = path.data;
  var len2 = path.len();
  var cmd;
  var nPoint;
  var i;
  var j;
  var k2;
  var p2;
  var M = CMD$2.M;
  var C = CMD$2.C;
  var L = CMD$2.L;
  var R = CMD$2.R;
  var A2 = CMD$2.A;
  var Q = CMD$2.Q;
  for (i = 0, j = 0; i < len2; ) {
    cmd = data[i++];
    j = i;
    nPoint = 0;
    switch (cmd) {
      case M:
        nPoint = 1;
        break;
      case L:
        nPoint = 1;
        break;
      case C:
        nPoint = 3;
        break;
      case Q:
        nPoint = 2;
        break;
      case A2:
        var x2 = m2[4];
        var y2 = m2[5];
        var sx = mathSqrt$2(m2[0] * m2[0] + m2[1] * m2[1]);
        var sy = mathSqrt$2(m2[2] * m2[2] + m2[3] * m2[3]);
        var angle = mathAtan2(-m2[1] / sy, m2[0] / sx);
        data[i] *= sx;
        data[i++] += x2;
        data[i] *= sy;
        data[i++] += y2;
        data[i++] *= sx;
        data[i++] *= sy;
        data[i++] += angle;
        data[i++] += angle;
        i += 2;
        j = i;
        break;
      case R:
        p2[0] = data[i++];
        p2[1] = data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
        p2[0] += data[i++];
        p2[1] += data[i++];
        applyTransform$1(p2, p2, m2);
        data[j++] = p2[0];
        data[j++] = p2[1];
    }
    for (k2 = 0; k2 < nPoint; k2++) {
      var p_1 = points$2[k2];
      p_1[0] = data[i++];
      p_1[1] = data[i++];
      applyTransform$1(p_1, p_1, m2);
      data[j++] = p_1[0];
      data[j++] = p_1[1];
    }
  }
  path.increaseVersion();
}
var mathSqrt$1 = Math.sqrt;
var mathSin$2 = Math.sin;
var mathCos$2 = Math.cos;
var PI$7 = Math.PI;
function vMag(v4) {
  return Math.sqrt(v4[0] * v4[0] + v4[1] * v4[1]);
}
function vRatio(u, v4) {
  return (u[0] * v4[0] + u[1] * v4[1]) / (vMag(u) * vMag(v4));
}
function vAngle(u, v4) {
  return (u[0] * v4[1] < u[1] * v4[0] ? -1 : 1) * Math.acos(vRatio(u, v4));
}
function processArc(x1, y1, x2, y2, fa, fs, rx, ry, psiDeg, cmd, path) {
  var psi = psiDeg * (PI$7 / 180);
  var xp = mathCos$2(psi) * (x1 - x2) / 2 + mathSin$2(psi) * (y1 - y2) / 2;
  var yp = -1 * mathSin$2(psi) * (x1 - x2) / 2 + mathCos$2(psi) * (y1 - y2) / 2;
  var lambda = xp * xp / (rx * rx) + yp * yp / (ry * ry);
  if (lambda > 1) {
    rx *= mathSqrt$1(lambda);
    ry *= mathSqrt$1(lambda);
  }
  var f2 = (fa === fs ? -1 : 1) * mathSqrt$1((rx * rx * (ry * ry) - rx * rx * (yp * yp) - ry * ry * (xp * xp)) / (rx * rx * (yp * yp) + ry * ry * (xp * xp))) || 0;
  var cxp = f2 * rx * yp / ry;
  var cyp = f2 * -ry * xp / rx;
  var cx = (x1 + x2) / 2 + mathCos$2(psi) * cxp - mathSin$2(psi) * cyp;
  var cy = (y1 + y2) / 2 + mathSin$2(psi) * cxp + mathCos$2(psi) * cyp;
  var theta = vAngle([1, 0], [(xp - cxp) / rx, (yp - cyp) / ry]);
  var u = [(xp - cxp) / rx, (yp - cyp) / ry];
  var v4 = [(-1 * xp - cxp) / rx, (-1 * yp - cyp) / ry];
  var dTheta = vAngle(u, v4);
  if (vRatio(u, v4) <= -1) {
    dTheta = PI$7;
  }
  if (vRatio(u, v4) >= 1) {
    dTheta = 0;
  }
  if (dTheta < 0) {
    var n2 = Math.round(dTheta / PI$7 * 1e6) / 1e6;
    dTheta = PI$7 * 2 + n2 % 2 * PI$7;
  }
  path.addData(cmd, cx, cy, rx, ry, theta, dTheta, psi, fs);
}
var commandReg = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig;
var numberReg$1 = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function createPathProxyFromString(data) {
  var path = new PathProxy$1();
  if (!data) {
    return path;
  }
  var cpx = 0;
  var cpy = 0;
  var subpathX = cpx;
  var subpathY = cpy;
  var prevCmd;
  var CMD2 = PathProxy$1.CMD;
  var cmdList = data.match(commandReg);
  if (!cmdList) {
    return path;
  }
  for (var l2 = 0; l2 < cmdList.length; l2++) {
    var cmdText = cmdList[l2];
    var cmdStr = cmdText.charAt(0);
    var cmd = void 0;
    var p2 = cmdText.match(numberReg$1) || [];
    var pLen = p2.length;
    for (var i = 0; i < pLen; i++) {
      p2[i] = parseFloat(p2[i]);
    }
    var off = 0;
    while (off < pLen) {
      var ctlPtx = void 0;
      var ctlPty = void 0;
      var rx = void 0;
      var ry = void 0;
      var psi = void 0;
      var fa = void 0;
      var fs = void 0;
      var x1 = cpx;
      var y1 = cpy;
      var len2 = void 0;
      var pathData = void 0;
      switch (cmdStr) {
        case "l":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "L":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "m":
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "l";
          break;
        case "M":
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.M;
          path.addData(cmd, cpx, cpy);
          subpathX = cpx;
          subpathY = cpy;
          cmdStr = "L";
          break;
        case "h":
          cpx += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "H":
          cpx = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "v":
          cpy += p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "V":
          cpy = p2[off++];
          cmd = CMD2.L;
          path.addData(cmd, cpx, cpy);
          break;
        case "C":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++], p2[off++], p2[off++], p2[off++], p2[off++], p2[off++]);
          cpx = p2[off - 2];
          cpy = p2[off - 1];
          break;
        case "c":
          cmd = CMD2.C;
          path.addData(cmd, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy, p2[off++] + cpx, p2[off++] + cpy);
          cpx += p2[off - 2];
          cpy += p2[off - 1];
          break;
        case "S":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "s":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.C) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cmd = CMD2.C;
          x1 = cpx + p2[off++];
          y1 = cpy + p2[off++];
          cpx += p2[off++];
          cpy += p2[off++];
          path.addData(cmd, ctlPtx, ctlPty, x1, y1, cpx, cpy);
          break;
        case "Q":
          x1 = p2[off++];
          y1 = p2[off++];
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "q":
          x1 = p2[off++] + cpx;
          y1 = p2[off++] + cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, x1, y1, cpx, cpy);
          break;
        case "T":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "t":
          ctlPtx = cpx;
          ctlPty = cpy;
          len2 = path.len();
          pathData = path.data;
          if (prevCmd === CMD2.Q) {
            ctlPtx += cpx - pathData[len2 - 4];
            ctlPty += cpy - pathData[len2 - 3];
          }
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.Q;
          path.addData(cmd, ctlPtx, ctlPty, cpx, cpy);
          break;
        case "A":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx = p2[off++];
          cpy = p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa, fs, rx, ry, psi, cmd, path);
          break;
        case "a":
          rx = p2[off++];
          ry = p2[off++];
          psi = p2[off++];
          fa = p2[off++];
          fs = p2[off++];
          x1 = cpx, y1 = cpy;
          cpx += p2[off++];
          cpy += p2[off++];
          cmd = CMD2.A;
          processArc(x1, y1, cpx, cpy, fa, fs, rx, ry, psi, cmd, path);
          break;
      }
    }
    if (cmdStr === "z" || cmdStr === "Z") {
      cmd = CMD2.Z;
      path.addData(cmd);
      cpx = subpathX;
      cpy = subpathY;
    }
    prevCmd = cmd;
  }
  path.toStatic();
  return path;
}
var SVGPath = function(_super) {
  __extends(SVGPath2, _super);
  function SVGPath2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SVGPath2.prototype.applyTransform = function(m2) {
  };
  return SVGPath2;
}(Path$1);
function isPathProxy(path) {
  return path.setData != null;
}
function createPathOptions(str, opts) {
  var pathProxy = createPathProxyFromString(str);
  var innerOpts = extend({}, opts);
  innerOpts.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.setData(pathProxy.data);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    } else {
      var ctx = path;
      pathProxy.rebuildPath(ctx, 1);
    }
  };
  innerOpts.applyTransform = function(m2) {
    transformPath(pathProxy, m2);
    this.dirtyShape();
  };
  return innerOpts;
}
function createFromString(str, opts) {
  return new SVGPath(createPathOptions(str, opts));
}
function extendFromString(str, defaultOpts) {
  var innerOpts = createPathOptions(str, defaultOpts);
  var Sub = function(_super) {
    __extends(Sub2, _super);
    function Sub2(opts) {
      var _this = _super.call(this, opts) || this;
      _this.applyTransform = innerOpts.applyTransform;
      _this.buildPath = innerOpts.buildPath;
      return _this;
    }
    return Sub2;
  }(SVGPath);
  return Sub;
}
function mergePath$1(pathEls, opts) {
  var pathList = [];
  var len2 = pathEls.length;
  for (var i = 0; i < len2; i++) {
    var pathEl = pathEls[i];
    pathList.push(pathEl.getUpdatedPathProxy(true));
  }
  var pathBundle = new Path$1(opts);
  pathBundle.createPathProxy();
  pathBundle.buildPath = function(path) {
    if (isPathProxy(path)) {
      path.appendPath(pathList);
      var ctx = path.getContext();
      if (ctx) {
        path.rebuildPath(ctx, 1);
      }
    }
  };
  return pathBundle;
}
function clonePath(sourcePath, opts) {
  opts = opts || {};
  var path = new Path$1();
  if (sourcePath.shape) {
    path.setShape(sourcePath.shape);
  }
  path.setStyle(sourcePath.style);
  if (opts.bakeTransform) {
    transformPath(path.path, sourcePath.getComputedTransform());
  } else {
    if (opts.toLocal) {
      path.setLocalTransform(sourcePath.getComputedTransform());
    } else {
      path.copyTransform(sourcePath);
    }
  }
  path.buildPath = sourcePath.buildPath;
  path.applyTransform = path.applyTransform;
  path.z = sourcePath.z;
  path.z2 = sourcePath.z2;
  path.zlevel = sourcePath.zlevel;
  return path;
}
var CircleShape = function() {
  function CircleShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
  }
  return CircleShape2;
}();
var Circle = function(_super) {
  __extends(Circle2, _super);
  function Circle2(opts) {
    return _super.call(this, opts) || this;
  }
  Circle2.prototype.getDefaultShape = function() {
    return new CircleShape();
  };
  Circle2.prototype.buildPath = function(ctx, shape) {
    ctx.moveTo(shape.cx + shape.r, shape.cy);
    ctx.arc(shape.cx, shape.cy, shape.r, 0, Math.PI * 2);
  };
  return Circle2;
}(Path$1);
Circle.prototype.type = "circle";
var Circle$1 = Circle;
var EllipseShape = function() {
  function EllipseShape2() {
    this.cx = 0;
    this.cy = 0;
    this.rx = 0;
    this.ry = 0;
  }
  return EllipseShape2;
}();
var Ellipse = function(_super) {
  __extends(Ellipse2, _super);
  function Ellipse2(opts) {
    return _super.call(this, opts) || this;
  }
  Ellipse2.prototype.getDefaultShape = function() {
    return new EllipseShape();
  };
  Ellipse2.prototype.buildPath = function(ctx, shape) {
    var k2 = 0.5522848;
    var x2 = shape.cx;
    var y2 = shape.cy;
    var a = shape.rx;
    var b2 = shape.ry;
    var ox = a * k2;
    var oy = b2 * k2;
    ctx.moveTo(x2 - a, y2);
    ctx.bezierCurveTo(x2 - a, y2 - oy, x2 - ox, y2 - b2, x2, y2 - b2);
    ctx.bezierCurveTo(x2 + ox, y2 - b2, x2 + a, y2 - oy, x2 + a, y2);
    ctx.bezierCurveTo(x2 + a, y2 + oy, x2 + ox, y2 + b2, x2, y2 + b2);
    ctx.bezierCurveTo(x2 - ox, y2 + b2, x2 - a, y2 + oy, x2 - a, y2);
    ctx.closePath();
  };
  return Ellipse2;
}(Path$1);
Ellipse.prototype.type = "ellipse";
var Ellipse$1 = Ellipse;
var PI$6 = Math.PI;
var PI2$4 = PI$6 * 2;
var mathSin$1 = Math.sin;
var mathCos$1 = Math.cos;
var mathACos = Math.acos;
var mathATan2 = Math.atan2;
var mathAbs$1 = Math.abs;
var mathSqrt = Math.sqrt;
var mathMax$7 = Math.max;
var mathMin$7 = Math.min;
var e$1 = 1e-4;
function intersect(x0, y0, x1, y1, x2, y2, x3, y3) {
  var dx10 = x1 - x0;
  var dy10 = y1 - y0;
  var dx32 = x3 - x2;
  var dy32 = y3 - y2;
  var t2 = dy32 * dx10 - dx32 * dy10;
  if (t2 * t2 < e$1) {
    return;
  }
  t2 = (dx32 * (y0 - y2) - dy32 * (x0 - x2)) / t2;
  return [x0 + t2 * dx10, y0 + t2 * dy10];
}
function computeCornerTangents(x0, y0, x1, y1, radius, cr, clockwise) {
  var x01 = x0 - x1;
  var y01 = y0 - y1;
  var lo = (clockwise ? cr : -cr) / mathSqrt(x01 * x01 + y01 * y01);
  var ox = lo * y01;
  var oy = -lo * x01;
  var x11 = x0 + ox;
  var y11 = y0 + oy;
  var x10 = x1 + ox;
  var y10 = y1 + oy;
  var x00 = (x11 + x10) / 2;
  var y00 = (y11 + y10) / 2;
  var dx = x10 - x11;
  var dy = y10 - y11;
  var d2 = dx * dx + dy * dy;
  var r2 = radius - cr;
  var s = x11 * y10 - x10 * y11;
  var d3 = (dy < 0 ? -1 : 1) * mathSqrt(mathMax$7(0, r2 * r2 * d2 - s * s));
  var cx0 = (s * dy - dx * d3) / d2;
  var cy0 = (-s * dx - dy * d3) / d2;
  var cx1 = (s * dy + dx * d3) / d2;
  var cy1 = (-s * dx + dy * d3) / d2;
  var dx0 = cx0 - x00;
  var dy0 = cy0 - y00;
  var dx1 = cx1 - x00;
  var dy1 = cy1 - y00;
  if (dx0 * dx0 + dy0 * dy0 > dx1 * dx1 + dy1 * dy1) {
    cx0 = cx1;
    cy0 = cy1;
  }
  return {
    cx: cx0,
    cy: cy0,
    x0: -ox,
    y0: -oy,
    x1: cx0 * (radius / r2 - 1),
    y1: cy0 * (radius / r2 - 1)
  };
}
function normalizeCornerRadius(cr) {
  var arr;
  if (isArray$1(cr)) {
    var len2 = cr.length;
    if (!len2) {
      return cr;
    }
    if (len2 === 1) {
      arr = [cr[0], cr[0], 0, 0];
    } else if (len2 === 2) {
      arr = [cr[0], cr[0], cr[1], cr[1]];
    } else if (len2 === 3) {
      arr = cr.concat(cr[2]);
    } else {
      arr = cr;
    }
  } else {
    arr = [cr, cr, cr, cr];
  }
  return arr;
}
function buildPath$1(ctx, shape) {
  var _a2;
  var radius = mathMax$7(shape.r, 0);
  var innerRadius = mathMax$7(shape.r0 || 0, 0);
  var hasRadius = radius > 0;
  var hasInnerRadius = innerRadius > 0;
  if (!hasRadius && !hasInnerRadius) {
    return;
  }
  if (!hasRadius) {
    radius = innerRadius;
    innerRadius = 0;
  }
  if (innerRadius > radius) {
    var tmp = radius;
    radius = innerRadius;
    innerRadius = tmp;
  }
  var startAngle = shape.startAngle, endAngle = shape.endAngle;
  if (isNaN(startAngle) || isNaN(endAngle)) {
    return;
  }
  var cx = shape.cx, cy = shape.cy;
  var clockwise = !!shape.clockwise;
  var arc = mathAbs$1(endAngle - startAngle);
  var mod = arc > PI2$4 && arc % PI2$4;
  mod > e$1 && (arc = mod);
  if (!(radius > e$1)) {
    ctx.moveTo(cx, cy);
  } else if (arc > PI2$4 - e$1) {
    ctx.moveTo(cx + radius * mathCos$1(startAngle), cy + radius * mathSin$1(startAngle));
    ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    if (innerRadius > e$1) {
      ctx.moveTo(cx + innerRadius * mathCos$1(endAngle), cy + innerRadius * mathSin$1(endAngle));
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  } else {
    var icrStart = void 0;
    var icrEnd = void 0;
    var ocrStart = void 0;
    var ocrEnd = void 0;
    var ocrs = void 0;
    var ocre = void 0;
    var icrs = void 0;
    var icre = void 0;
    var ocrMax = void 0;
    var icrMax = void 0;
    var limitedOcrMax = void 0;
    var limitedIcrMax = void 0;
    var xre = void 0;
    var yre = void 0;
    var xirs = void 0;
    var yirs = void 0;
    var xrs = radius * mathCos$1(startAngle);
    var yrs = radius * mathSin$1(startAngle);
    var xire = innerRadius * mathCos$1(endAngle);
    var yire = innerRadius * mathSin$1(endAngle);
    var hasArc = arc > e$1;
    if (hasArc) {
      var cornerRadius = shape.cornerRadius;
      if (cornerRadius) {
        _a2 = normalizeCornerRadius(cornerRadius), icrStart = _a2[0], icrEnd = _a2[1], ocrStart = _a2[2], ocrEnd = _a2[3];
      }
      var halfRd = mathAbs$1(radius - innerRadius) / 2;
      ocrs = mathMin$7(halfRd, ocrStart);
      ocre = mathMin$7(halfRd, ocrEnd);
      icrs = mathMin$7(halfRd, icrStart);
      icre = mathMin$7(halfRd, icrEnd);
      limitedOcrMax = ocrMax = mathMax$7(ocrs, ocre);
      limitedIcrMax = icrMax = mathMax$7(icrs, icre);
      if (ocrMax > e$1 || icrMax > e$1) {
        xre = radius * mathCos$1(endAngle);
        yre = radius * mathSin$1(endAngle);
        xirs = innerRadius * mathCos$1(startAngle);
        yirs = innerRadius * mathSin$1(startAngle);
        if (arc < PI$6) {
          var it_1 = intersect(xrs, yrs, xirs, yirs, xre, yre, xire, yire);
          if (it_1) {
            var x0 = xrs - it_1[0];
            var y0 = yrs - it_1[1];
            var x1 = xre - it_1[0];
            var y1 = yre - it_1[1];
            var a = 1 / mathSin$1(mathACos((x0 * x1 + y0 * y1) / (mathSqrt(x0 * x0 + y0 * y0) * mathSqrt(x1 * x1 + y1 * y1))) / 2);
            var b2 = mathSqrt(it_1[0] * it_1[0] + it_1[1] * it_1[1]);
            limitedOcrMax = mathMin$7(ocrMax, (radius - b2) / (a + 1));
            limitedIcrMax = mathMin$7(icrMax, (innerRadius - b2) / (a - 1));
          }
        }
      }
    }
    if (!hasArc) {
      ctx.moveTo(cx + xrs, cy + yrs);
    } else if (limitedOcrMax > e$1) {
      var crStart = mathMin$7(ocrStart, limitedOcrMax);
      var crEnd = mathMin$7(ocrEnd, limitedOcrMax);
      var ct0 = computeCornerTangents(xirs, yirs, xrs, yrs, radius, crStart, clockwise);
      var ct1 = computeCornerTangents(xre, yre, xire, yire, radius, crEnd, clockwise);
      ctx.moveTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedOcrMax < ocrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedOcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crStart > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crStart, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, radius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), !clockwise);
        crEnd > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crEnd, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.moveTo(cx + xrs, cy + yrs);
      ctx.arc(cx, cy, radius, startAngle, endAngle, !clockwise);
    }
    if (!(innerRadius > e$1) || !hasArc) {
      ctx.lineTo(cx + xire, cy + yire);
    } else if (limitedIcrMax > e$1) {
      var crStart = mathMin$7(icrStart, limitedIcrMax);
      var crEnd = mathMin$7(icrEnd, limitedIcrMax);
      var ct0 = computeCornerTangents(xire, yire, xre, yre, innerRadius, -crEnd, clockwise);
      var ct1 = computeCornerTangents(xrs, yrs, xirs, yirs, innerRadius, -crStart, clockwise);
      ctx.lineTo(cx + ct0.cx + ct0.x0, cy + ct0.cy + ct0.y0);
      if (limitedIcrMax < icrMax && crStart === crEnd) {
        ctx.arc(cx + ct0.cx, cy + ct0.cy, limitedIcrMax, mathATan2(ct0.y0, ct0.x0), mathATan2(ct1.y0, ct1.x0), !clockwise);
      } else {
        crEnd > 0 && ctx.arc(cx + ct0.cx, cy + ct0.cy, crEnd, mathATan2(ct0.y0, ct0.x0), mathATan2(ct0.y1, ct0.x1), !clockwise);
        ctx.arc(cx, cy, innerRadius, mathATan2(ct0.cy + ct0.y1, ct0.cx + ct0.x1), mathATan2(ct1.cy + ct1.y1, ct1.cx + ct1.x1), clockwise);
        crStart > 0 && ctx.arc(cx + ct1.cx, cy + ct1.cy, crStart, mathATan2(ct1.y1, ct1.x1), mathATan2(ct1.y0, ct1.x0), !clockwise);
      }
    } else {
      ctx.lineTo(cx + xire, cy + yire);
      ctx.arc(cx, cy, innerRadius, endAngle, startAngle, clockwise);
    }
  }
  ctx.closePath();
}
var SectorShape = function() {
  function SectorShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
    this.cornerRadius = 0;
  }
  return SectorShape2;
}();
var Sector = function(_super) {
  __extends(Sector2, _super);
  function Sector2(opts) {
    return _super.call(this, opts) || this;
  }
  Sector2.prototype.getDefaultShape = function() {
    return new SectorShape();
  };
  Sector2.prototype.buildPath = function(ctx, shape) {
    buildPath$1(ctx, shape);
  };
  Sector2.prototype.isZeroArea = function() {
    return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
  };
  return Sector2;
}(Path$1);
Sector.prototype.type = "sector";
var Sector$1 = Sector;
var RingShape = function() {
  function RingShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.r0 = 0;
  }
  return RingShape2;
}();
var Ring = function(_super) {
  __extends(Ring2, _super);
  function Ring2(opts) {
    return _super.call(this, opts) || this;
  }
  Ring2.prototype.getDefaultShape = function() {
    return new RingShape();
  };
  Ring2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var PI22 = Math.PI * 2;
    ctx.moveTo(x2 + shape.r, y2);
    ctx.arc(x2, y2, shape.r, 0, PI22, false);
    ctx.moveTo(x2 + shape.r0, y2);
    ctx.arc(x2, y2, shape.r0, 0, PI22, true);
  };
  return Ring2;
}(Path$1);
Ring.prototype.type = "ring";
var Ring$1 = Ring;
function smoothBezier(points2, smooth, isLoop, constraint) {
  var cps = [];
  var v4 = [];
  var v12 = [];
  var v22 = [];
  var prevPoint;
  var nextPoint;
  var min3;
  var max3;
  if (constraint) {
    min3 = [Infinity, Infinity];
    max3 = [-Infinity, -Infinity];
    for (var i = 0, len2 = points2.length; i < len2; i++) {
      min$1(min3, min3, points2[i]);
      max$1(max3, max3, points2[i]);
    }
    min$1(min3, min3, constraint[0]);
    max$1(max3, max3, constraint[1]);
  }
  for (var i = 0, len2 = points2.length; i < len2; i++) {
    var point = points2[i];
    if (isLoop) {
      prevPoint = points2[i ? i - 1 : len2 - 1];
      nextPoint = points2[(i + 1) % len2];
    } else {
      if (i === 0 || i === len2 - 1) {
        cps.push(clone$3(points2[i]));
        continue;
      } else {
        prevPoint = points2[i - 1];
        nextPoint = points2[i + 1];
      }
    }
    sub(v4, nextPoint, prevPoint);
    scale$2(v4, v4, smooth);
    var d0 = distance(point, prevPoint);
    var d1 = distance(point, nextPoint);
    var sum2 = d0 + d1;
    if (sum2 !== 0) {
      d0 /= sum2;
      d1 /= sum2;
    }
    scale$2(v12, v4, -d0);
    scale$2(v22, v4, d1);
    var cp0 = add([], point, v12);
    var cp1 = add([], point, v22);
    if (constraint) {
      max$1(cp0, cp0, min3);
      min$1(cp0, cp0, max3);
      max$1(cp1, cp1, min3);
      min$1(cp1, cp1, max3);
    }
    cps.push(cp0);
    cps.push(cp1);
  }
  if (isLoop) {
    cps.push(cps.shift());
  }
  return cps;
}
function buildPath(ctx, shape, closePath) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (points2 && points2.length >= 2) {
    if (smooth) {
      var controlPoints = smoothBezier(points2, smooth, closePath, shape.smoothConstraint);
      ctx.moveTo(points2[0][0], points2[0][1]);
      var len2 = points2.length;
      for (var i = 0; i < (closePath ? len2 : len2 - 1); i++) {
        var cp1 = controlPoints[i * 2];
        var cp2 = controlPoints[i * 2 + 1];
        var p2 = points2[(i + 1) % len2];
        ctx.bezierCurveTo(cp1[0], cp1[1], cp2[0], cp2[1], p2[0], p2[1]);
      }
    } else {
      ctx.moveTo(points2[0][0], points2[0][1]);
      for (var i = 1, l2 = points2.length; i < l2; i++) {
        ctx.lineTo(points2[i][0], points2[i][1]);
      }
    }
    closePath && ctx.closePath();
  }
}
var PolygonShape = function() {
  function PolygonShape2() {
    this.points = null;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolygonShape2;
}();
var Polygon = function(_super) {
  __extends(Polygon2, _super);
  function Polygon2(opts) {
    return _super.call(this, opts) || this;
  }
  Polygon2.prototype.getDefaultShape = function() {
    return new PolygonShape();
  };
  Polygon2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, true);
  };
  return Polygon2;
}(Path$1);
Polygon.prototype.type = "polygon";
var Polygon$1 = Polygon;
var PolylineShape = function() {
  function PolylineShape2() {
    this.points = null;
    this.percent = 1;
    this.smooth = 0;
    this.smoothConstraint = null;
  }
  return PolylineShape2;
}();
var Polyline$2 = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(opts) {
    return _super.call(this, opts) || this;
  }
  Polyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Polyline2.prototype.getDefaultShape = function() {
    return new PolylineShape();
  };
  Polyline2.prototype.buildPath = function(ctx, shape) {
    buildPath(ctx, shape, false);
  };
  return Polyline2;
}(Path$1);
Polyline$2.prototype.type = "polyline";
var Polyline$3 = Polyline$2;
var subPixelOptimizeOutputShape = {};
var LineShape = function() {
  function LineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return LineShape2;
}();
var Line$2 = function(_super) {
  __extends(Line2, _super);
  function Line2(opts) {
    return _super.call(this, opts) || this;
  }
  Line2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Line2.prototype.getDefaultShape = function() {
    return new LineShape();
  };
  Line2.prototype.buildPath = function(ctx, shape) {
    var x1;
    var y1;
    var x2;
    var y2;
    if (this.subPixelOptimize) {
      var optimizedShape = subPixelOptimizeLine$1(subPixelOptimizeOutputShape, shape, this.style);
      x1 = optimizedShape.x1;
      y1 = optimizedShape.y1;
      x2 = optimizedShape.x2;
      y2 = optimizedShape.y2;
    } else {
      x1 = shape.x1;
      y1 = shape.y1;
      x2 = shape.x2;
      y2 = shape.y2;
    }
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (percent < 1) {
      x2 = x1 * (1 - percent) + x2 * percent;
      y2 = y1 * (1 - percent) + y2 * percent;
    }
    ctx.lineTo(x2, y2);
  };
  Line2.prototype.pointAt = function(p2) {
    var shape = this.shape;
    return [
      shape.x1 * (1 - p2) + shape.x2 * p2,
      shape.y1 * (1 - p2) + shape.y2 * p2
    ];
  };
  return Line2;
}(Path$1);
Line$2.prototype.type = "line";
var Line$3 = Line$2;
var out = [];
var BezierCurveShape = function() {
  function BezierCurveShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.percent = 1;
  }
  return BezierCurveShape2;
}();
function someVectorAt(shape, t2, isTangent) {
  var cpx2 = shape.cpx2;
  var cpy2 = shape.cpy2;
  if (cpx2 != null || cpy2 != null) {
    return [
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.x1, shape.cpx1, shape.cpx2, shape.x2, t2),
      (isTangent ? cubicDerivativeAt : cubicAt)(shape.y1, shape.cpy1, shape.cpy2, shape.y2, t2)
    ];
  } else {
    return [
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.x1, shape.cpx1, shape.x2, t2),
      (isTangent ? quadraticDerivativeAt : quadraticAt$1)(shape.y1, shape.cpy1, shape.y2, t2)
    ];
  }
}
var BezierCurve = function(_super) {
  __extends(BezierCurve2, _super);
  function BezierCurve2(opts) {
    return _super.call(this, opts) || this;
  }
  BezierCurve2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  BezierCurve2.prototype.getDefaultShape = function() {
    return new BezierCurveShape();
  };
  BezierCurve2.prototype.buildPath = function(ctx, shape) {
    var x1 = shape.x1;
    var y1 = shape.y1;
    var x2 = shape.x2;
    var y2 = shape.y2;
    var cpx1 = shape.cpx1;
    var cpy1 = shape.cpy1;
    var cpx2 = shape.cpx2;
    var cpy2 = shape.cpy2;
    var percent = shape.percent;
    if (percent === 0) {
      return;
    }
    ctx.moveTo(x1, y1);
    if (cpx2 == null || cpy2 == null) {
      if (percent < 1) {
        quadraticSubdivide(x1, cpx1, x2, percent, out);
        cpx1 = out[1];
        x2 = out[2];
        quadraticSubdivide(y1, cpy1, y2, percent, out);
        cpy1 = out[1];
        y2 = out[2];
      }
      ctx.quadraticCurveTo(cpx1, cpy1, x2, y2);
    } else {
      if (percent < 1) {
        cubicSubdivide(x1, cpx1, cpx2, x2, percent, out);
        cpx1 = out[1];
        cpx2 = out[2];
        x2 = out[3];
        cubicSubdivide(y1, cpy1, cpy2, y2, percent, out);
        cpy1 = out[1];
        cpy2 = out[2];
        y2 = out[3];
      }
      ctx.bezierCurveTo(cpx1, cpy1, cpx2, cpy2, x2, y2);
    }
  };
  BezierCurve2.prototype.pointAt = function(t2) {
    return someVectorAt(this.shape, t2, false);
  };
  BezierCurve2.prototype.tangentAt = function(t2) {
    var p2 = someVectorAt(this.shape, t2, true);
    return normalize$4(p2, p2);
  };
  return BezierCurve2;
}(Path$1);
BezierCurve.prototype.type = "bezier-curve";
var BezierCurve$1 = BezierCurve;
var ArcShape = function() {
  function ArcShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return ArcShape2;
}();
var Arc = function(_super) {
  __extends(Arc2, _super);
  function Arc2(opts) {
    return _super.call(this, opts) || this;
  }
  Arc2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  Arc2.prototype.getDefaultShape = function() {
    return new ArcShape();
  };
  Arc2.prototype.buildPath = function(ctx, shape) {
    var x2 = shape.cx;
    var y2 = shape.cy;
    var r2 = Math.max(shape.r, 0);
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var unitX = Math.cos(startAngle);
    var unitY = Math.sin(startAngle);
    ctx.moveTo(unitX * r2 + x2, unitY * r2 + y2);
    ctx.arc(x2, y2, r2, startAngle, endAngle, !clockwise);
  };
  return Arc2;
}(Path$1);
Arc.prototype.type = "arc";
var Arc$1 = Arc;
var CompoundPath = function(_super) {
  __extends(CompoundPath2, _super);
  function CompoundPath2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "compound";
    return _this;
  }
  CompoundPath2.prototype._updatePathDirty = function() {
    var paths = this.shape.paths;
    var dirtyPath = this.shapeChanged();
    for (var i = 0; i < paths.length; i++) {
      dirtyPath = dirtyPath || paths[i].shapeChanged();
    }
    if (dirtyPath) {
      this.dirtyShape();
    }
  };
  CompoundPath2.prototype.beforeBrush = function() {
    this._updatePathDirty();
    var paths = this.shape.paths || [];
    var scale2 = this.getGlobalScale();
    for (var i = 0; i < paths.length; i++) {
      if (!paths[i].path) {
        paths[i].createPathProxy();
      }
      paths[i].path.setScale(scale2[0], scale2[1], paths[i].segmentIgnoreThreshold);
    }
  };
  CompoundPath2.prototype.buildPath = function(ctx, shape) {
    var paths = shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].buildPath(ctx, paths[i].shape, true);
    }
  };
  CompoundPath2.prototype.afterBrush = function() {
    var paths = this.shape.paths || [];
    for (var i = 0; i < paths.length; i++) {
      paths[i].pathUpdated();
    }
  };
  CompoundPath2.prototype.getBoundingRect = function() {
    this._updatePathDirty.call(this);
    return Path$1.prototype.getBoundingRect.call(this);
  };
  return CompoundPath2;
}(Path$1);
var CompoundPath$1 = CompoundPath;
var Gradient = function() {
  function Gradient2(colorStops) {
    this.colorStops = colorStops || [];
  }
  Gradient2.prototype.addColorStop = function(offset, color) {
    this.colorStops.push({
      offset,
      color
    });
  };
  return Gradient2;
}();
var Gradient$1 = Gradient;
var LinearGradient = function(_super) {
  __extends(LinearGradient2, _super);
  function LinearGradient2(x2, y2, x22, y22, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0 : x2;
    _this.y = y2 == null ? 0 : y2;
    _this.x2 = x22 == null ? 1 : x22;
    _this.y2 = y22 == null ? 0 : y22;
    _this.type = "linear";
    _this.global = globalCoord || false;
    return _this;
  }
  return LinearGradient2;
}(Gradient$1);
var LinearGradient$1 = LinearGradient;
var RadialGradient = function(_super) {
  __extends(RadialGradient2, _super);
  function RadialGradient2(x2, y2, r2, colorStops, globalCoord) {
    var _this = _super.call(this, colorStops) || this;
    _this.x = x2 == null ? 0.5 : x2;
    _this.y = y2 == null ? 0.5 : y2;
    _this.r = r2 == null ? 0.5 : r2;
    _this.type = "radial";
    _this.global = globalCoord || false;
    return _this;
  }
  return RadialGradient2;
}(Gradient$1);
var RadialGradient$1 = RadialGradient;
var extent = [0, 0];
var extent2 = [0, 0];
var minTv = new Point$1();
var maxTv = new Point$1();
var OrientedBoundingRect = function() {
  function OrientedBoundingRect2(rect, transform2) {
    this._corners = [];
    this._axes = [];
    this._origin = [0, 0];
    for (var i = 0; i < 4; i++) {
      this._corners[i] = new Point$1();
    }
    for (var i = 0; i < 2; i++) {
      this._axes[i] = new Point$1();
    }
    if (rect) {
      this.fromBoundingRect(rect, transform2);
    }
  }
  OrientedBoundingRect2.prototype.fromBoundingRect = function(rect, transform2) {
    var corners = this._corners;
    var axes = this._axes;
    var x2 = rect.x;
    var y2 = rect.y;
    var x22 = x2 + rect.width;
    var y22 = y2 + rect.height;
    corners[0].set(x2, y2);
    corners[1].set(x22, y2);
    corners[2].set(x22, y22);
    corners[3].set(x2, y22);
    if (transform2) {
      for (var i = 0; i < 4; i++) {
        corners[i].transform(transform2);
      }
    }
    Point$1.sub(axes[0], corners[1], corners[0]);
    Point$1.sub(axes[1], corners[3], corners[0]);
    axes[0].normalize();
    axes[1].normalize();
    for (var i = 0; i < 2; i++) {
      this._origin[i] = axes[i].dot(corners[0]);
    }
  };
  OrientedBoundingRect2.prototype.intersect = function(other, mtv) {
    var overlapped = true;
    var noMtv = !mtv;
    minTv.set(Infinity, Infinity);
    maxTv.set(0, 0);
    if (!this._intersectCheckOneSide(this, other, minTv, maxTv, noMtv, 1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!this._intersectCheckOneSide(other, this, minTv, maxTv, noMtv, -1)) {
      overlapped = false;
      if (noMtv) {
        return overlapped;
      }
    }
    if (!noMtv) {
      Point$1.copy(mtv, overlapped ? minTv : maxTv);
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._intersectCheckOneSide = function(self2, other, minTv2, maxTv2, noMtv, inverse) {
    var overlapped = true;
    for (var i = 0; i < 2; i++) {
      var axis = this._axes[i];
      this._getProjMinMaxOnAxis(i, self2._corners, extent);
      this._getProjMinMaxOnAxis(i, other._corners, extent2);
      if (extent[1] < extent2[0] || extent[0] > extent2[1]) {
        overlapped = false;
        if (noMtv) {
          return overlapped;
        }
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) > maxTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(maxTv2, axis, -dist0 * inverse);
          } else {
            Point$1.scale(maxTv2, axis, dist1 * inverse);
          }
        }
      } else if (minTv2) {
        var dist0 = Math.abs(extent2[0] - extent[1]);
        var dist1 = Math.abs(extent[0] - extent2[1]);
        if (Math.min(dist0, dist1) < minTv2.len()) {
          if (dist0 < dist1) {
            Point$1.scale(minTv2, axis, dist0 * inverse);
          } else {
            Point$1.scale(minTv2, axis, -dist1 * inverse);
          }
        }
      }
    }
    return overlapped;
  };
  OrientedBoundingRect2.prototype._getProjMinMaxOnAxis = function(dim, corners, out2) {
    var axis = this._axes[dim];
    var origin = this._origin;
    var proj = corners[0].dot(axis) + origin[dim];
    var min3 = proj;
    var max3 = proj;
    for (var i = 1; i < corners.length; i++) {
      var proj_1 = corners[i].dot(axis) + origin[dim];
      min3 = Math.min(proj_1, min3);
      max3 = Math.max(proj_1, max3);
    }
    out2[0] = min3;
    out2[1] = max3;
  };
  return OrientedBoundingRect2;
}();
var OrientedBoundingRect$1 = OrientedBoundingRect;
var m$2 = [];
var IncrementalDisplayable = function(_super) {
  __extends(IncrementalDisplayable2, _super);
  function IncrementalDisplayable2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.notClear = true;
    _this.incremental = true;
    _this._displayables = [];
    _this._temporaryDisplayables = [];
    _this._cursor = 0;
    return _this;
  }
  IncrementalDisplayable2.prototype.traverse = function(cb, context) {
    cb.call(context, this);
  };
  IncrementalDisplayable2.prototype.useStyle = function() {
    this.style = {};
  };
  IncrementalDisplayable2.prototype.getCursor = function() {
    return this._cursor;
  };
  IncrementalDisplayable2.prototype.innerAfterBrush = function() {
    this._cursor = this._displayables.length;
  };
  IncrementalDisplayable2.prototype.clearDisplaybles = function() {
    this._displayables = [];
    this._temporaryDisplayables = [];
    this._cursor = 0;
    this.markRedraw();
    this.notClear = false;
  };
  IncrementalDisplayable2.prototype.clearTemporalDisplayables = function() {
    this._temporaryDisplayables = [];
  };
  IncrementalDisplayable2.prototype.addDisplayable = function(displayable, notPersistent) {
    if (notPersistent) {
      this._temporaryDisplayables.push(displayable);
    } else {
      this._displayables.push(displayable);
    }
    this.markRedraw();
  };
  IncrementalDisplayable2.prototype.addDisplayables = function(displayables, notPersistent) {
    notPersistent = notPersistent || false;
    for (var i = 0; i < displayables.length; i++) {
      this.addDisplayable(displayables[i], notPersistent);
    }
  };
  IncrementalDisplayable2.prototype.getDisplayables = function() {
    return this._displayables;
  };
  IncrementalDisplayable2.prototype.getTemporalDisplayables = function() {
    return this._temporaryDisplayables;
  };
  IncrementalDisplayable2.prototype.eachPendingDisplayable = function(cb) {
    for (var i = this._cursor; i < this._displayables.length; i++) {
      cb && cb(this._displayables[i]);
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      cb && cb(this._temporaryDisplayables[i]);
    }
  };
  IncrementalDisplayable2.prototype.update = function() {
    this.updateTransform();
    for (var i = this._cursor; i < this._displayables.length; i++) {
      var displayable = this._displayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
    for (var i = 0; i < this._temporaryDisplayables.length; i++) {
      var displayable = this._temporaryDisplayables[i];
      displayable.parent = this;
      displayable.update();
      displayable.parent = null;
    }
  };
  IncrementalDisplayable2.prototype.getBoundingRect = function() {
    if (!this._rect) {
      var rect = new BoundingRect$1(Infinity, Infinity, -Infinity, -Infinity);
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        var childRect = displayable.getBoundingRect().clone();
        if (displayable.needLocalTransform()) {
          childRect.applyTransform(displayable.getLocalTransform(m$2));
        }
        rect.union(childRect);
      }
      this._rect = rect;
    }
    return this._rect;
  };
  IncrementalDisplayable2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    if (rect.contain(localPos[0], localPos[1])) {
      for (var i = 0; i < this._displayables.length; i++) {
        var displayable = this._displayables[i];
        if (displayable.contain(x2, y2)) {
          return true;
        }
      }
    }
    return false;
  };
  return IncrementalDisplayable2;
}(Displayable$1);
var IncrementalDisplayable$1 = IncrementalDisplayable;
var transitionStore = makeInner();
function getAnimationConfig(animationType, animatableModel, dataIndex, extraOpts, extraDelayParams) {
  var animationPayload;
  if (animatableModel && animatableModel.ecModel) {
    var updatePayload = animatableModel.ecModel.getUpdatePayload();
    animationPayload = updatePayload && updatePayload.animation;
  }
  var animationEnabled = animatableModel && animatableModel.isAnimationEnabled();
  var isUpdate = animationType === "update";
  if (animationEnabled) {
    var duration = void 0;
    var easing = void 0;
    var delay = void 0;
    if (extraOpts) {
      duration = retrieve2(extraOpts.duration, 200);
      easing = retrieve2(extraOpts.easing, "cubicOut");
      delay = 0;
    } else {
      duration = animatableModel.getShallow(isUpdate ? "animationDurationUpdate" : "animationDuration");
      easing = animatableModel.getShallow(isUpdate ? "animationEasingUpdate" : "animationEasing");
      delay = animatableModel.getShallow(isUpdate ? "animationDelayUpdate" : "animationDelay");
    }
    if (animationPayload) {
      animationPayload.duration != null && (duration = animationPayload.duration);
      animationPayload.easing != null && (easing = animationPayload.easing);
      animationPayload.delay != null && (delay = animationPayload.delay);
    }
    if (isFunction(delay)) {
      delay = delay(dataIndex, extraDelayParams);
    }
    if (isFunction(duration)) {
      duration = duration(dataIndex);
    }
    var config = {
      duration: duration || 0,
      delay,
      easing
    };
    return config;
  } else {
    return null;
  }
}
function animateOrSetProps(animationType, el, props, animatableModel, dataIndex, cb, during) {
  var isFrom = false;
  var removeOpt;
  if (isFunction(dataIndex)) {
    during = cb;
    cb = dataIndex;
    dataIndex = null;
  } else if (isObject$4(dataIndex)) {
    cb = dataIndex.cb;
    during = dataIndex.during;
    isFrom = dataIndex.isFrom;
    removeOpt = dataIndex.removeOpt;
    dataIndex = dataIndex.dataIndex;
  }
  var isRemove = animationType === "leave";
  if (!isRemove) {
    el.stopAnimation("leave");
  }
  var animationConfig = getAnimationConfig(animationType, animatableModel, dataIndex, isRemove ? removeOpt || {} : null, animatableModel && animatableModel.getAnimationDelayParams ? animatableModel.getAnimationDelayParams(el, dataIndex) : null);
  if (animationConfig && animationConfig.duration > 0) {
    var duration = animationConfig.duration;
    var animationDelay = animationConfig.delay;
    var animationEasing = animationConfig.easing;
    var animateConfig = {
      duration,
      delay: animationDelay || 0,
      easing: animationEasing,
      done: cb,
      force: !!cb || !!during,
      setToFinal: !isRemove,
      scope: animationType,
      during
    };
    isFrom ? el.animateFrom(props, animateConfig) : el.animateTo(props, animateConfig);
  } else {
    el.stopAnimation();
    !isFrom && el.attr(props);
    during && during(1);
    cb && cb();
  }
}
function updateProps$1(el, props, animatableModel, dataIndex, cb, during) {
  animateOrSetProps("update", el, props, animatableModel, dataIndex, cb, during);
}
function initProps(el, props, animatableModel, dataIndex, cb, during) {
  animateOrSetProps("enter", el, props, animatableModel, dataIndex, cb, during);
}
function isElementRemoved(el) {
  if (!el.__zr) {
    return true;
  }
  for (var i = 0; i < el.animators.length; i++) {
    var animator = el.animators[i];
    if (animator.scope === "leave") {
      return true;
    }
  }
  return false;
}
function removeElement(el, props, animatableModel, dataIndex, cb, during) {
  if (isElementRemoved(el)) {
    return;
  }
  animateOrSetProps("leave", el, props, animatableModel, dataIndex, cb, during);
}
function fadeOutDisplayable(el, animatableModel, dataIndex, done) {
  el.removeTextContent();
  el.removeTextGuideLine();
  removeElement(el, {
    style: {
      opacity: 0
    }
  }, animatableModel, dataIndex, done);
}
function removeElementWithFadeOut(el, animatableModel, dataIndex) {
  function doRemove() {
    el.parent && el.parent.remove(el);
  }
  if (!el.isGroup) {
    fadeOutDisplayable(el, animatableModel, dataIndex, doRemove);
  } else {
    el.traverse(function(disp) {
      if (!disp.isGroup) {
        fadeOutDisplayable(disp, animatableModel, dataIndex, doRemove);
      }
    });
  }
}
function saveOldStyle(el) {
  transitionStore(el).oldStyle = el.style;
}
function getOldStyle(el) {
  return transitionStore(el).oldStyle;
}
var mathMax$6 = Math.max;
var mathMin$6 = Math.min;
var _customShapeMap = {};
function extendShape(opts) {
  return Path$1.extend(opts);
}
var extendPathFromString = extendFromString;
function extendPath(pathData, opts) {
  return extendPathFromString(pathData, opts);
}
function registerShape(name, ShapeClass) {
  _customShapeMap[name] = ShapeClass;
}
function getShapeClass(name) {
  if (_customShapeMap.hasOwnProperty(name)) {
    return _customShapeMap[name];
  }
}
function makePath(pathData, opts, rect, layout2) {
  var path = createFromString(pathData, opts);
  if (rect) {
    if (layout2 === "center") {
      rect = centerGraphic(rect, path.getBoundingRect());
    }
    resizePath(path, rect);
  }
  return path;
}
function makeImage(imageUrl, rect, layout2) {
  var zrImg = new ZRImage$1({
    style: {
      image: imageUrl,
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    onload: function(img) {
      if (layout2 === "center") {
        var boundingRect = {
          width: img.width,
          height: img.height
        };
        zrImg.setStyle(centerGraphic(rect, boundingRect));
      }
    }
  });
  return zrImg;
}
function centerGraphic(rect, boundingRect) {
  var aspect = boundingRect.width / boundingRect.height;
  var width = rect.height * aspect;
  var height;
  if (width <= rect.width) {
    height = rect.height;
  } else {
    width = rect.width;
    height = width / aspect;
  }
  var cx = rect.x + rect.width / 2;
  var cy = rect.y + rect.height / 2;
  return {
    x: cx - width / 2,
    y: cy - height / 2,
    width,
    height
  };
}
var mergePath = mergePath$1;
function resizePath(path, rect) {
  if (!path.applyTransform) {
    return;
  }
  var pathRect = path.getBoundingRect();
  var m2 = pathRect.calculateTransform(rect);
  path.applyTransform(m2);
}
function subPixelOptimizeLine(param) {
  subPixelOptimizeLine$1(param.shape, param.shape, param.style);
  return param;
}
function subPixelOptimizeRect(param) {
  subPixelOptimizeRect$1(param.shape, param.shape, param.style);
  return param;
}
var subPixelOptimize = subPixelOptimize$1;
function getTransform$1(target, ancestor) {
  var mat = identity([]);
  while (target && target !== ancestor) {
    mul(mat, target.getLocalTransform(), mat);
    target = target.parent;
  }
  return mat;
}
function applyTransform(target, transform2, invert$1) {
  if (transform2 && !isArrayLike(transform2)) {
    transform2 = Transformable$1.getLocalTransform(transform2);
  }
  if (invert$1) {
    transform2 = invert([], transform2);
  }
  return applyTransform$1([], target, transform2);
}
function transformDirection(direction, transform2, invert2) {
  var hBase = transform2[4] === 0 || transform2[5] === 0 || transform2[0] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[0]);
  var vBase = transform2[4] === 0 || transform2[5] === 0 || transform2[2] === 0 ? 1 : Math.abs(2 * transform2[4] / transform2[2]);
  var vertex = [direction === "left" ? -hBase : direction === "right" ? hBase : 0, direction === "top" ? -vBase : direction === "bottom" ? vBase : 0];
  vertex = applyTransform(vertex, transform2, invert2);
  return Math.abs(vertex[0]) > Math.abs(vertex[1]) ? vertex[0] > 0 ? "right" : "left" : vertex[1] > 0 ? "bottom" : "top";
}
function isNotGroup(el) {
  return !el.isGroup;
}
function isPath$1(el) {
  return el.shape != null;
}
function groupTransition(g1, g2, animatableModel) {
  if (!g1 || !g2) {
    return;
  }
  function getElMap(g3) {
    var elMap = {};
    g3.traverse(function(el) {
      if (isNotGroup(el) && el.anid) {
        elMap[el.anid] = el;
      }
    });
    return elMap;
  }
  function getAnimatableProps(el) {
    var obj = {
      x: el.x,
      y: el.y,
      rotation: el.rotation
    };
    if (isPath$1(el)) {
      obj.shape = extend({}, el.shape);
    }
    return obj;
  }
  var elMap1 = getElMap(g1);
  g2.traverse(function(el) {
    if (isNotGroup(el) && el.anid) {
      var oldEl = elMap1[el.anid];
      if (oldEl) {
        var newProp = getAnimatableProps(el);
        el.attr(getAnimatableProps(oldEl));
        updateProps$1(el, newProp, animatableModel, getECData(el).dataIndex);
      }
    }
  });
}
function clipPointsByRect(points2, rect) {
  return map$1(points2, function(point) {
    var x2 = point[0];
    x2 = mathMax$6(x2, rect.x);
    x2 = mathMin$6(x2, rect.x + rect.width);
    var y2 = point[1];
    y2 = mathMax$6(y2, rect.y);
    y2 = mathMin$6(y2, rect.y + rect.height);
    return [x2, y2];
  });
}
function clipRectByRect(targetRect, rect) {
  var x2 = mathMax$6(targetRect.x, rect.x);
  var x22 = mathMin$6(targetRect.x + targetRect.width, rect.x + rect.width);
  var y2 = mathMax$6(targetRect.y, rect.y);
  var y22 = mathMin$6(targetRect.y + targetRect.height, rect.y + rect.height);
  if (x22 >= x2 && y22 >= y2) {
    return {
      x: x2,
      y: y2,
      width: x22 - x2,
      height: y22 - y2
    };
  }
}
function createIcon(iconStr, opt, rect) {
  var innerOpts = extend({
    rectHover: true
  }, opt);
  var style = innerOpts.style = {
    strokeNoScale: true
  };
  rect = rect || {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  };
  if (iconStr) {
    return iconStr.indexOf("image://") === 0 ? (style.image = iconStr.slice(8), defaults(style, rect), new ZRImage$1(innerOpts)) : makePath(iconStr.replace("path://", ""), innerOpts, rect, "center");
  }
}
function linePolygonIntersect(a1x, a1y, a2x, a2y, points2) {
  for (var i = 0, p2 = points2[points2.length - 1]; i < points2.length; i++) {
    var p3 = points2[i];
    if (lineLineIntersect$1(a1x, a1y, a2x, a2y, p3[0], p3[1], p2[0], p2[1])) {
      return true;
    }
    p2 = p3;
  }
}
function lineLineIntersect$1(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d$1(nx, ny, mx, my);
  if (nearZero(nmCrossProduct)) {
    return false;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var q2 = crossProduct2d$1(b1a1x, b1a1y, mx, my) / nmCrossProduct;
  if (q2 < 0 || q2 > 1) {
    return false;
  }
  var p2 = crossProduct2d$1(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return false;
  }
  return true;
}
function crossProduct2d$1(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function nearZero(val) {
  return val <= 1e-6 && val >= -1e-6;
}
function setTooltipConfig(opt) {
  var itemTooltipOption = opt.itemTooltipOption;
  var componentModel = opt.componentModel;
  var itemName = opt.itemName;
  var itemTooltipOptionObj = isString(itemTooltipOption) ? {
    formatter: itemTooltipOption
  } : itemTooltipOption;
  var mainType = componentModel.mainType;
  var componentIndex = componentModel.componentIndex;
  var formatterParams = {
    componentType: mainType,
    name: itemName,
    $vars: ["name"]
  };
  formatterParams[mainType + "Index"] = componentIndex;
  var formatterParamsExtra = opt.formatterParamsExtra;
  if (formatterParamsExtra) {
    each$f(keys(formatterParamsExtra), function(key) {
      if (!hasOwn(formatterParams, key)) {
        formatterParams[key] = formatterParamsExtra[key];
        formatterParams.$vars.push(key);
      }
    });
  }
  var ecData = getECData(opt.el);
  ecData.componentMainType = mainType;
  ecData.componentIndex = componentIndex;
  ecData.tooltipConfig = {
    name: itemName,
    option: defaults({
      content: itemName,
      formatterParams
    }, itemTooltipOptionObj)
  };
}
function traverseElement(el, cb) {
  var stopped;
  if (el.isGroup) {
    stopped = cb(el);
  }
  if (!stopped) {
    el.traverse(cb);
  }
}
function traverseElements(els, cb) {
  if (els) {
    if (isArray$1(els)) {
      for (var i = 0; i < els.length; i++) {
        traverseElement(els[i], cb);
      }
    } else {
      traverseElement(els, cb);
    }
  }
}
registerShape("circle", Circle$1);
registerShape("ellipse", Ellipse$1);
registerShape("sector", Sector$1);
registerShape("ring", Ring$1);
registerShape("polygon", Polygon$1);
registerShape("polyline", Polyline$3);
registerShape("rect", Rect$3);
registerShape("line", Line$3);
registerShape("bezierCurve", BezierCurve$1);
registerShape("arc", Arc$1);
var graphic = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  updateProps: updateProps$1,
  initProps,
  removeElement,
  removeElementWithFadeOut,
  isElementRemoved,
  extendShape,
  extendPath,
  registerShape,
  getShapeClass,
  makePath,
  makeImage,
  mergePath,
  resizePath,
  subPixelOptimizeLine,
  subPixelOptimizeRect,
  subPixelOptimize,
  getTransform: getTransform$1,
  applyTransform,
  transformDirection,
  groupTransition,
  clipPointsByRect,
  clipRectByRect,
  createIcon,
  linePolygonIntersect,
  lineLineIntersect: lineLineIntersect$1,
  setTooltipConfig,
  traverseElements,
  Group: Group$4,
  Image: ZRImage$1,
  Text: ZRText$1,
  Circle: Circle$1,
  Ellipse: Ellipse$1,
  Sector: Sector$1,
  Ring: Ring$1,
  Polygon: Polygon$1,
  Polyline: Polyline$3,
  Rect: Rect$3,
  Line: Line$3,
  BezierCurve: BezierCurve$1,
  Arc: Arc$1,
  IncrementalDisplayable: IncrementalDisplayable$1,
  CompoundPath: CompoundPath$1,
  LinearGradient: LinearGradient$1,
  RadialGradient: RadialGradient$1,
  BoundingRect: BoundingRect$1,
  OrientedBoundingRect: OrientedBoundingRect$1,
  Point: Point$1,
  Path: Path$1
}, Symbol.toStringTag, { value: "Module" }));
var EMPTY_OBJ = {};
function setLabelText(label, labelTexts) {
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var text = labelTexts[stateName];
    var state = label.ensureState(stateName);
    state.style = state.style || {};
    state.style.text = text;
  }
  var oldStates = label.currentStates.slice();
  label.clearStates(true);
  label.setStyle({
    text: labelTexts.normal
  });
  label.useStates(oldStates, true);
}
function getLabelText(opt, stateModels, interpolatedValue) {
  var labelFetcher = opt.labelFetcher;
  var labelDataIndex = opt.labelDataIndex;
  var labelDimIndex = opt.labelDimIndex;
  var normalModel = stateModels.normal;
  var baseText;
  if (labelFetcher) {
    baseText = labelFetcher.getFormattedLabel(labelDataIndex, "normal", null, labelDimIndex, normalModel && normalModel.get("formatter"), interpolatedValue != null ? {
      interpolatedValue
    } : null);
  }
  if (baseText == null) {
    baseText = isFunction(opt.defaultText) ? opt.defaultText(labelDataIndex, opt, interpolatedValue) : opt.defaultText;
  }
  var statesText = {
    normal: baseText
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    var stateModel = stateModels[stateName];
    statesText[stateName] = retrieve2(labelFetcher ? labelFetcher.getFormattedLabel(labelDataIndex, stateName, null, labelDimIndex, stateModel && stateModel.get("formatter")) : null, baseText);
  }
  return statesText;
}
function setLabelStyle(targetEl, labelStatesModels, opt, stateSpecified) {
  opt = opt || EMPTY_OBJ;
  var isSetOnText = targetEl instanceof ZRText$1;
  var needsCreateText = false;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateModel = labelStatesModels[DISPLAY_STATES[i]];
    if (stateModel && stateModel.getShallow("show")) {
      needsCreateText = true;
      break;
    }
  }
  var textContent = isSetOnText ? targetEl : targetEl.getTextContent();
  if (needsCreateText) {
    if (!isSetOnText) {
      if (!textContent) {
        textContent = new ZRText$1();
        targetEl.setTextContent(textContent);
      }
      if (targetEl.stateProxy) {
        textContent.stateProxy = targetEl.stateProxy;
      }
    }
    var labelStatesTexts = getLabelText(opt, labelStatesModels);
    var normalModel = labelStatesModels.normal;
    var showNormal = !!normalModel.getShallow("show");
    var normalStyle = createTextStyle(normalModel, stateSpecified && stateSpecified.normal, opt, false, !isSetOnText);
    normalStyle.text = labelStatesTexts.normal;
    if (!isSetOnText) {
      targetEl.setTextConfig(createTextConfig(normalModel, opt, false));
    }
    for (var i = 0; i < SPECIAL_STATES.length; i++) {
      var stateName = SPECIAL_STATES[i];
      var stateModel = labelStatesModels[stateName];
      if (stateModel) {
        var stateObj = textContent.ensureState(stateName);
        var stateShow = !!retrieve2(stateModel.getShallow("show"), showNormal);
        if (stateShow !== showNormal) {
          stateObj.ignore = !stateShow;
        }
        stateObj.style = createTextStyle(stateModel, stateSpecified && stateSpecified[stateName], opt, true, !isSetOnText);
        stateObj.style.text = labelStatesTexts[stateName];
        if (!isSetOnText) {
          var targetElEmphasisState = targetEl.ensureState(stateName);
          targetElEmphasisState.textConfig = createTextConfig(stateModel, opt, true);
        }
      }
    }
    textContent.silent = !!normalModel.getShallow("silent");
    if (textContent.style.x != null) {
      normalStyle.x = textContent.style.x;
    }
    if (textContent.style.y != null) {
      normalStyle.y = textContent.style.y;
    }
    textContent.ignore = !showNormal;
    textContent.useStyle(normalStyle);
    textContent.dirty();
    if (opt.enableTextSetter) {
      labelInner(textContent).setLabelText = function(interpolatedValue) {
        var labelStatesTexts2 = getLabelText(opt, labelStatesModels, interpolatedValue);
        setLabelText(textContent, labelStatesTexts2);
      };
    }
  } else if (textContent) {
    textContent.ignore = true;
  }
  targetEl.dirty();
}
function getLabelStatesModels(itemModel, labelName) {
  labelName = labelName || "label";
  var statesModels = {
    normal: itemModel.getModel(labelName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelName]);
  }
  return statesModels;
}
function createTextStyle(textStyleModel, specifiedTextStyle, opt, isNotNormal, isAttached) {
  var textStyle = {};
  setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached);
  specifiedTextStyle && extend(textStyle, specifiedTextStyle);
  return textStyle;
}
function createTextConfig(textStyleModel, opt, isNotNormal) {
  opt = opt || {};
  var textConfig = {};
  var labelPosition;
  var labelRotate = textStyleModel.getShallow("rotate");
  var labelDistance = retrieve2(textStyleModel.getShallow("distance"), isNotNormal ? null : 5);
  var labelOffset = textStyleModel.getShallow("offset");
  labelPosition = textStyleModel.getShallow("position") || (isNotNormal ? null : "inside");
  labelPosition === "outside" && (labelPosition = opt.defaultOutsidePosition || "top");
  if (labelPosition != null) {
    textConfig.position = labelPosition;
  }
  if (labelOffset != null) {
    textConfig.offset = labelOffset;
  }
  if (labelRotate != null) {
    labelRotate *= Math.PI / 180;
    textConfig.rotation = labelRotate;
  }
  if (labelDistance != null) {
    textConfig.distance = labelDistance;
  }
  textConfig.outsideFill = textStyleModel.get("color") === "inherit" ? opt.inheritColor || null : "auto";
  return textConfig;
}
function setTextStyleCommon(textStyle, textStyleModel, opt, isNotNormal, isAttached) {
  opt = opt || EMPTY_OBJ;
  var ecModel = textStyleModel.ecModel;
  var globalTextStyle = ecModel && ecModel.option.textStyle;
  var richItemNames = getRichItemNames(textStyleModel);
  var richResult;
  if (richItemNames) {
    richResult = {};
    for (var name_1 in richItemNames) {
      if (richItemNames.hasOwnProperty(name_1)) {
        var richTextStyle = textStyleModel.getModel(["rich", name_1]);
        setTokenTextStyle(richResult[name_1] = {}, richTextStyle, globalTextStyle, opt, isNotNormal, isAttached, false, true);
      }
    }
  }
  if (richResult) {
    textStyle.rich = richResult;
  }
  var overflow = textStyleModel.get("overflow");
  if (overflow) {
    textStyle.overflow = overflow;
  }
  var margin = textStyleModel.get("minMargin");
  if (margin != null) {
    textStyle.margin = margin;
  }
  setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, true, false);
}
function getRichItemNames(textStyleModel) {
  var richItemNameMap;
  while (textStyleModel && textStyleModel !== textStyleModel.ecModel) {
    var rich = (textStyleModel.option || EMPTY_OBJ).rich;
    if (rich) {
      richItemNameMap = richItemNameMap || {};
      var richKeys = keys(rich);
      for (var i = 0; i < richKeys.length; i++) {
        var richKey = richKeys[i];
        richItemNameMap[richKey] = 1;
      }
    }
    textStyleModel = textStyleModel.parentModel;
  }
  return richItemNameMap;
}
var TEXT_PROPS_WITH_GLOBAL = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"];
var TEXT_PROPS_SELF = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"];
var TEXT_PROPS_BOX = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
function setTokenTextStyle(textStyle, textStyleModel, globalTextStyle, opt, isNotNormal, isAttached, isBlock, inRich) {
  globalTextStyle = !isNotNormal && globalTextStyle || EMPTY_OBJ;
  var inheritColor = opt && opt.inheritColor;
  var fillColor = textStyleModel.getShallow("color");
  var strokeColor = textStyleModel.getShallow("textBorderColor");
  var opacity = retrieve2(textStyleModel.getShallow("opacity"), globalTextStyle.opacity);
  if (fillColor === "inherit" || fillColor === "auto") {
    if (inheritColor) {
      fillColor = inheritColor;
    } else {
      fillColor = null;
    }
  }
  if (strokeColor === "inherit" || strokeColor === "auto") {
    if (inheritColor) {
      strokeColor = inheritColor;
    } else {
      strokeColor = null;
    }
  }
  if (!isAttached) {
    fillColor = fillColor || globalTextStyle.color;
    strokeColor = strokeColor || globalTextStyle.textBorderColor;
  }
  if (fillColor != null) {
    textStyle.fill = fillColor;
  }
  if (strokeColor != null) {
    textStyle.stroke = strokeColor;
  }
  var textBorderWidth = retrieve2(textStyleModel.getShallow("textBorderWidth"), globalTextStyle.textBorderWidth);
  if (textBorderWidth != null) {
    textStyle.lineWidth = textBorderWidth;
  }
  var textBorderType = retrieve2(textStyleModel.getShallow("textBorderType"), globalTextStyle.textBorderType);
  if (textBorderType != null) {
    textStyle.lineDash = textBorderType;
  }
  var textBorderDashOffset = retrieve2(textStyleModel.getShallow("textBorderDashOffset"), globalTextStyle.textBorderDashOffset);
  if (textBorderDashOffset != null) {
    textStyle.lineDashOffset = textBorderDashOffset;
  }
  if (!isNotNormal && opacity == null && !inRich) {
    opacity = opt && opt.defaultOpacity;
  }
  if (opacity != null) {
    textStyle.opacity = opacity;
  }
  if (!isNotNormal && !isAttached) {
    if (textStyle.fill == null && opt.inheritColor) {
      textStyle.fill = opt.inheritColor;
    }
  }
  for (var i = 0; i < TEXT_PROPS_WITH_GLOBAL.length; i++) {
    var key = TEXT_PROPS_WITH_GLOBAL[i];
    var val = retrieve2(textStyleModel.getShallow(key), globalTextStyle[key]);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  for (var i = 0; i < TEXT_PROPS_SELF.length; i++) {
    var key = TEXT_PROPS_SELF[i];
    var val = textStyleModel.getShallow(key);
    if (val != null) {
      textStyle[key] = val;
    }
  }
  if (textStyle.verticalAlign == null) {
    var baseline = textStyleModel.getShallow("baseline");
    if (baseline != null) {
      textStyle.verticalAlign = baseline;
    }
  }
  if (!isBlock || !opt.disableBox) {
    for (var i = 0; i < TEXT_PROPS_BOX.length; i++) {
      var key = TEXT_PROPS_BOX[i];
      var val = textStyleModel.getShallow(key);
      if (val != null) {
        textStyle[key] = val;
      }
    }
    var borderType = textStyleModel.getShallow("borderType");
    if (borderType != null) {
      textStyle.borderDash = borderType;
    }
    if ((textStyle.backgroundColor === "auto" || textStyle.backgroundColor === "inherit") && inheritColor) {
      textStyle.backgroundColor = inheritColor;
    }
    if ((textStyle.borderColor === "auto" || textStyle.borderColor === "inherit") && inheritColor) {
      textStyle.borderColor = inheritColor;
    }
  }
}
function getFont(opt, ecModel) {
  var gTextStyleModel = ecModel && ecModel.getModel("textStyle");
  return trim$1([
    opt.fontStyle || gTextStyleModel && gTextStyleModel.getShallow("fontStyle") || "",
    opt.fontWeight || gTextStyleModel && gTextStyleModel.getShallow("fontWeight") || "",
    (opt.fontSize || gTextStyleModel && gTextStyleModel.getShallow("fontSize") || 12) + "px",
    opt.fontFamily || gTextStyleModel && gTextStyleModel.getShallow("fontFamily") || "sans-serif"
  ].join(" "));
}
var labelInner = makeInner();
function setLabelValueAnimation(label, labelStatesModels, value, getDefaultText) {
  if (!label) {
    return;
  }
  var obj = labelInner(label);
  obj.prevValue = obj.value;
  obj.value = value;
  var normalLabelModel = labelStatesModels.normal;
  obj.valueAnimation = normalLabelModel.get("valueAnimation");
  if (obj.valueAnimation) {
    obj.precision = normalLabelModel.get("precision");
    obj.defaultInterpolatedText = getDefaultText;
    obj.statesModels = labelStatesModels;
  }
}
function animateLabelValue(textEl, dataIndex, data, animatableModel, labelFetcher) {
  var labelInnerStore = labelInner(textEl);
  if (!labelInnerStore.valueAnimation || labelInnerStore.prevValue === labelInnerStore.value) {
    return;
  }
  var defaultInterpolatedText = labelInnerStore.defaultInterpolatedText;
  var currValue = retrieve2(labelInnerStore.interpolatedValue, labelInnerStore.prevValue);
  var targetValue = labelInnerStore.value;
  function during(percent) {
    var interpolated = interpolateRawValues(data, labelInnerStore.precision, currValue, targetValue, percent);
    labelInnerStore.interpolatedValue = percent === 1 ? null : interpolated;
    var labelText = getLabelText({
      labelDataIndex: dataIndex,
      labelFetcher,
      defaultText: defaultInterpolatedText ? defaultInterpolatedText(interpolated) : interpolated + ""
    }, labelInnerStore.statesModels, interpolated);
    setLabelText(textEl, labelText);
  }
  textEl.percent = 0;
  (labelInnerStore.prevValue == null ? initProps : updateProps$1)(textEl, {
    percent: 1
  }, animatableModel, dataIndex, null, during);
}
var PATH_COLOR = ["textStyle", "color"];
var textStyleParams = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"];
var tmpText = new ZRText$1();
var TextStyleMixin = function() {
  function TextStyleMixin2() {
  }
  TextStyleMixin2.prototype.getTextColor = function(isEmphasis) {
    var ecModel = this.ecModel;
    return this.getShallow("color") || (!isEmphasis && ecModel ? ecModel.get(PATH_COLOR) : null);
  };
  TextStyleMixin2.prototype.getFont = function() {
    return getFont({
      fontStyle: this.getShallow("fontStyle"),
      fontWeight: this.getShallow("fontWeight"),
      fontSize: this.getShallow("fontSize"),
      fontFamily: this.getShallow("fontFamily")
    }, this.ecModel);
  };
  TextStyleMixin2.prototype.getTextRect = function(text) {
    var style = {
      text,
      verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline")
    };
    for (var i = 0; i < textStyleParams.length; i++) {
      style[textStyleParams[i]] = this.getShallow(textStyleParams[i]);
    }
    tmpText.useStyle(style);
    tmpText.update();
    return tmpText.getBoundingRect();
  };
  return TextStyleMixin2;
}();
var TextStyleMixin$1 = TextStyleMixin;
var LINE_STYLE_KEY_MAP = [
  ["lineWidth", "width"],
  ["stroke", "color"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "type"],
  ["lineDashOffset", "dashOffset"],
  ["lineCap", "cap"],
  ["lineJoin", "join"],
  ["miterLimit"]
];
var getLineStyle = makeStyleMapper(LINE_STYLE_KEY_MAP);
var LineStyleMixin = function() {
  function LineStyleMixin2() {
  }
  LineStyleMixin2.prototype.getLineStyle = function(excludes) {
    return getLineStyle(this, excludes);
  };
  return LineStyleMixin2;
}();
var ITEM_STYLE_KEY_MAP = [
  ["fill", "color"],
  ["stroke", "borderColor"],
  ["lineWidth", "borderWidth"],
  ["opacity"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"],
  ["lineDash", "borderType"],
  ["lineDashOffset", "borderDashOffset"],
  ["lineCap", "borderCap"],
  ["lineJoin", "borderJoin"],
  ["miterLimit", "borderMiterLimit"]
];
var getItemStyle = makeStyleMapper(ITEM_STYLE_KEY_MAP);
var ItemStyleMixin = function() {
  function ItemStyleMixin2() {
  }
  ItemStyleMixin2.prototype.getItemStyle = function(excludes, includes) {
    return getItemStyle(this, excludes, includes);
  };
  return ItemStyleMixin2;
}();
var Model = function() {
  function Model2(option, parentModel, ecModel) {
    this.parentModel = parentModel;
    this.ecModel = ecModel;
    this.option = option;
  }
  Model2.prototype.init = function(option, parentModel, ecModel) {
    var rest = [];
    for (var _i = 3; _i < arguments.length; _i++) {
      rest[_i - 3] = arguments[_i];
    }
  };
  Model2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
  };
  Model2.prototype.get = function(path, ignoreParent) {
    if (path == null) {
      return this.option;
    }
    return this._doGet(this.parsePath(path), !ignoreParent && this.parentModel);
  };
  Model2.prototype.getShallow = function(key, ignoreParent) {
    var option = this.option;
    var val = option == null ? option : option[key];
    if (val == null && !ignoreParent) {
      var parentModel = this.parentModel;
      if (parentModel) {
        val = parentModel.getShallow(key);
      }
    }
    return val;
  };
  Model2.prototype.getModel = function(path, parentModel) {
    var hasPath = path != null;
    var pathFinal = hasPath ? this.parsePath(path) : null;
    var obj = hasPath ? this._doGet(pathFinal) : this.option;
    parentModel = parentModel || this.parentModel && this.parentModel.getModel(this.resolveParentPath(pathFinal));
    return new Model2(obj, parentModel, this.ecModel);
  };
  Model2.prototype.isEmpty = function() {
    return this.option == null;
  };
  Model2.prototype.restoreData = function() {
  };
  Model2.prototype.clone = function() {
    var Ctor = this.constructor;
    return new Ctor(clone$4(this.option));
  };
  Model2.prototype.parsePath = function(path) {
    if (typeof path === "string") {
      return path.split(".");
    }
    return path;
  };
  Model2.prototype.resolveParentPath = function(path) {
    return path;
  };
  Model2.prototype.isAnimationEnabled = function() {
    if (!env$1.node && this.option) {
      if (this.option.animation != null) {
        return !!this.option.animation;
      } else if (this.parentModel) {
        return this.parentModel.isAnimationEnabled();
      }
    }
  };
  Model2.prototype._doGet = function(pathArr, parentModel) {
    var obj = this.option;
    if (!pathArr) {
      return obj;
    }
    for (var i = 0; i < pathArr.length; i++) {
      if (!pathArr[i]) {
        continue;
      }
      obj = obj && typeof obj === "object" ? obj[pathArr[i]] : null;
      if (obj == null) {
        break;
      }
    }
    if (obj == null && parentModel) {
      obj = parentModel._doGet(this.resolveParentPath(pathArr), parentModel.parentModel);
    }
    return obj;
  };
  return Model2;
}();
enableClassExtend(Model);
enableClassCheck(Model);
mixin(Model, LineStyleMixin);
mixin(Model, ItemStyleMixin);
mixin(Model, AreaStyleMixin);
mixin(Model, TextStyleMixin$1);
var Model$1 = Model;
var base = Math.round(Math.random() * 10);
function getUID(type4) {
  return [type4 || "", base++].join("_");
}
function enableSubTypeDefaulter(target) {
  var subTypeDefaulters = {};
  target.registerSubTypeDefaulter = function(componentType, defaulter) {
    var componentTypeInfo = parseClassType(componentType);
    subTypeDefaulters[componentTypeInfo.main] = defaulter;
  };
  target.determineSubType = function(componentType, option) {
    var type4 = option.type;
    if (!type4) {
      var componentTypeMain = parseClassType(componentType).main;
      if (target.hasSubTypes(componentType) && subTypeDefaulters[componentTypeMain]) {
        type4 = subTypeDefaulters[componentTypeMain](option);
      }
    }
    return type4;
  };
}
function enableTopologicalTravel(entity, dependencyGetter) {
  entity.topologicalTravel = function(targetNameList, fullNameList, callback, context) {
    if (!targetNameList.length) {
      return;
    }
    var result = makeDepndencyGraph(fullNameList);
    var graph = result.graph;
    var noEntryList = result.noEntryList;
    var targetNameSet = {};
    each$f(targetNameList, function(name) {
      targetNameSet[name] = true;
    });
    while (noEntryList.length) {
      var currComponentType = noEntryList.pop();
      var currVertex = graph[currComponentType];
      var isInTargetNameSet = !!targetNameSet[currComponentType];
      if (isInTargetNameSet) {
        callback.call(context, currComponentType, currVertex.originalDeps.slice());
        delete targetNameSet[currComponentType];
      }
      each$f(currVertex.successor, isInTargetNameSet ? removeEdgeAndAdd : removeEdge);
    }
    each$f(targetNameSet, function() {
      var errMsg = "";
      throw new Error(errMsg);
    });
    function removeEdge(succComponentType) {
      graph[succComponentType].entryCount--;
      if (graph[succComponentType].entryCount === 0) {
        noEntryList.push(succComponentType);
      }
    }
    function removeEdgeAndAdd(succComponentType) {
      targetNameSet[succComponentType] = true;
      removeEdge(succComponentType);
    }
  };
  function makeDepndencyGraph(fullNameList) {
    var graph = {};
    var noEntryList = [];
    each$f(fullNameList, function(name) {
      var thisItem = createDependencyGraphItem(graph, name);
      var originalDeps = thisItem.originalDeps = dependencyGetter(name);
      var availableDeps = getAvailableDependencies(originalDeps, fullNameList);
      thisItem.entryCount = availableDeps.length;
      if (thisItem.entryCount === 0) {
        noEntryList.push(name);
      }
      each$f(availableDeps, function(dependentName) {
        if (indexOf(thisItem.predecessor, dependentName) < 0) {
          thisItem.predecessor.push(dependentName);
        }
        var thatItem = createDependencyGraphItem(graph, dependentName);
        if (indexOf(thatItem.successor, dependentName) < 0) {
          thatItem.successor.push(name);
        }
      });
    });
    return {
      graph,
      noEntryList
    };
  }
  function createDependencyGraphItem(graph, name) {
    if (!graph[name]) {
      graph[name] = {
        predecessor: [],
        successor: []
      };
    }
    return graph[name];
  }
  function getAvailableDependencies(originalDeps, fullNameList) {
    var availableDeps = [];
    each$f(originalDeps, function(dep) {
      indexOf(fullNameList, dep) >= 0 && availableDeps.push(dep);
    });
    return availableDeps;
  }
}
function inheritDefaultOption(superOption, subOption) {
  return merge(merge({}, superOption, true), subOption, true);
}
var langEN = {
  time: {
    month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
    dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"]
  },
  legend: {
    selector: {
      all: "All",
      inverse: "Inv"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "Box Select",
        polygon: "Lasso Select",
        lineX: "Horizontally Select",
        lineY: "Vertically Select",
        keep: "Keep Selections",
        clear: "Clear Selections"
      }
    },
    dataView: {
      title: "Data View",
      lang: ["Data View", "Close", "Refresh"]
    },
    dataZoom: {
      title: {
        zoom: "Zoom",
        back: "Zoom Reset"
      }
    },
    magicType: {
      title: {
        line: "Switch to Line Chart",
        bar: "Switch to Bar Chart",
        stack: "Stack",
        tiled: "Tile"
      }
    },
    restore: {
      title: "Restore"
    },
    saveAsImage: {
      title: "Save as Image",
      lang: ["Right Click to Save Image"]
    }
  },
  series: {
    typeNames: {
      pie: "Pie chart",
      bar: "Bar chart",
      line: "Line chart",
      scatter: "Scatter plot",
      effectScatter: "Ripple scatter plot",
      radar: "Radar chart",
      tree: "Tree",
      treemap: "Treemap",
      boxplot: "Boxplot",
      candlestick: "Candlestick",
      k: "K line chart",
      heatmap: "Heat map",
      map: "Map",
      parallel: "Parallel coordinate map",
      lines: "Line graph",
      graph: "Relationship graph",
      sankey: "Sankey diagram",
      funnel: "Funnel chart",
      gauge: "Gauge",
      pictorialBar: "Pictorial bar",
      themeRiver: "Theme River Map",
      sunburst: "Sunburst"
    }
  },
  aria: {
    general: {
      withTitle: 'This is a chart about "{title}"',
      withoutTitle: "This is a chart"
    },
    series: {
      single: {
        prefix: "",
        withName: " with type {seriesType} named {seriesName}.",
        withoutName: " with type {seriesType}."
      },
      multiple: {
        prefix: ". It consists of {seriesCount} series count.",
        withName: " The {seriesId} series is a {seriesType} representing {seriesName}.",
        withoutName: " The {seriesId} series is a {seriesType}.",
        separator: {
          middle: "",
          end: ""
        }
      }
    },
    data: {
      allData: "The data is as follows: ",
      partialData: "The first {displayCnt} items are: ",
      withName: "the data for {name} is {value}",
      withoutName: "{value}",
      separator: {
        middle: ", ",
        end: ". "
      }
    }
  }
};
var langZH = {
  time: {
    month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"],
    monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"],
    dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"],
    dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"]
  },
  legend: {
    selector: {
      all: "\u5168\u9009",
      inverse: "\u53CD\u9009"
    }
  },
  toolbox: {
    brush: {
      title: {
        rect: "\u77E9\u5F62\u9009\u62E9",
        polygon: "\u5708\u9009",
        lineX: "\u6A2A\u5411\u9009\u62E9",
        lineY: "\u7EB5\u5411\u9009\u62E9",
        keep: "\u4FDD\u6301\u9009\u62E9",
        clear: "\u6E05\u9664\u9009\u62E9"
      }
    },
    dataView: {
      title: "\u6570\u636E\u89C6\u56FE",
      lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"]
    },
    dataZoom: {
      title: {
        zoom: "\u533A\u57DF\u7F29\u653E",
        back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F"
      }
    },
    magicType: {
      title: {
        line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE",
        bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE",
        stack: "\u5207\u6362\u4E3A\u5806\u53E0",
        tiled: "\u5207\u6362\u4E3A\u5E73\u94FA"
      }
    },
    restore: {
      title: "\u8FD8\u539F"
    },
    saveAsImage: {
      title: "\u4FDD\u5B58\u4E3A\u56FE\u7247",
      lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"]
    }
  },
  series: {
    typeNames: {
      pie: "\u997C\u56FE",
      bar: "\u67F1\u72B6\u56FE",
      line: "\u6298\u7EBF\u56FE",
      scatter: "\u6563\u70B9\u56FE",
      effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE",
      radar: "\u96F7\u8FBE\u56FE",
      tree: "\u6811\u56FE",
      treemap: "\u77E9\u5F62\u6811\u56FE",
      boxplot: "\u7BB1\u578B\u56FE",
      candlestick: "K\u7EBF\u56FE",
      k: "K\u7EBF\u56FE",
      heatmap: "\u70ED\u529B\u56FE",
      map: "\u5730\u56FE",
      parallel: "\u5E73\u884C\u5750\u6807\u56FE",
      lines: "\u7EBF\u56FE",
      graph: "\u5173\u7CFB\u56FE",
      sankey: "\u6851\u57FA\u56FE",
      funnel: "\u6F0F\u6597\u56FE",
      gauge: "\u4EEA\u8868\u76D8\u56FE",
      pictorialBar: "\u8C61\u5F62\u67F1\u56FE",
      themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE",
      sunburst: "\u65ED\u65E5\u56FE"
    }
  },
  aria: {
    general: {
      withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002",
      withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C"
    },
    series: {
      single: {
        prefix: "",
        withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002",
        withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002"
      },
      multiple: {
        prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002",
        withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C",
        withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C",
        separator: {
          middle: "\uFF1B",
          end: "\u3002"
        }
      }
    },
    data: {
      allData: "\u5176\u6570\u636E\u662F\u2014\u2014",
      partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014",
      withName: "{name}\u7684\u6570\u636E\u662F{value}",
      withoutName: "{value}",
      separator: {
        middle: "\uFF0C",
        end: ""
      }
    }
  }
};
var LOCALE_ZH = "ZH";
var LOCALE_EN = "EN";
var DEFAULT_LOCALE = LOCALE_EN;
var localeStorage = {};
var localeModels = {};
var SYSTEM_LANG = !env$1.domSupported ? DEFAULT_LOCALE : function() {
  var langStr = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
  return langStr.indexOf(LOCALE_ZH) > -1 ? LOCALE_ZH : DEFAULT_LOCALE;
}();
function registerLocale(locale2, localeObj) {
  locale2 = locale2.toUpperCase();
  localeModels[locale2] = new Model$1(localeObj);
  localeStorage[locale2] = localeObj;
}
function createLocaleObject(locale2) {
  if (isString(locale2)) {
    var localeObj = localeStorage[locale2.toUpperCase()] || {};
    if (locale2 === LOCALE_ZH || locale2 === LOCALE_EN) {
      return clone$4(localeObj);
    } else {
      return merge(clone$4(localeObj), clone$4(localeStorage[DEFAULT_LOCALE]), false);
    }
  } else {
    return merge(clone$4(locale2), clone$4(localeStorage[DEFAULT_LOCALE]), false);
  }
}
function getLocaleModel(lang) {
  return localeModels[lang];
}
function getDefaultLocaleModel() {
  return localeModels[DEFAULT_LOCALE];
}
registerLocale(LOCALE_EN, langEN);
registerLocale(LOCALE_ZH, langZH);
var ONE_SECOND = 1e3;
var ONE_MINUTE = ONE_SECOND * 60;
var ONE_HOUR = ONE_MINUTE * 60;
var ONE_DAY = ONE_HOUR * 24;
var ONE_YEAR = ONE_DAY * 365;
var defaultLeveledFormatter = {
  year: "{yyyy}",
  month: "{MMM}",
  day: "{d}",
  hour: "{HH}:{mm}",
  minute: "{HH}:{mm}",
  second: "{HH}:{mm}:{ss}",
  millisecond: "{HH}:{mm}:{ss} {SSS}",
  none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}"
};
var fullDayFormatter = "{yyyy}-{MM}-{dd}";
var fullLeveledFormatter = {
  year: "{yyyy}",
  month: "{yyyy}-{MM}",
  day: fullDayFormatter,
  hour: fullDayFormatter + " " + defaultLeveledFormatter.hour,
  minute: fullDayFormatter + " " + defaultLeveledFormatter.minute,
  second: fullDayFormatter + " " + defaultLeveledFormatter.second,
  millisecond: defaultLeveledFormatter.none
};
var primaryTimeUnits = ["year", "month", "day", "hour", "minute", "second", "millisecond"];
var timeUnits = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
function pad(str, len2) {
  str += "";
  return "0000".substr(0, len2 - str.length) + str;
}
function getPrimaryTimeUnit(timeUnit) {
  switch (timeUnit) {
    case "half-year":
    case "quarter":
      return "month";
    case "week":
    case "half-week":
      return "day";
    case "half-day":
    case "quarter-day":
      return "hour";
    default:
      return timeUnit;
  }
}
function isPrimaryTimeUnit(timeUnit) {
  return timeUnit === getPrimaryTimeUnit(timeUnit);
}
function getDefaultFormatPrecisionOfInterval(timeUnit) {
  switch (timeUnit) {
    case "year":
    case "month":
      return "day";
    case "millisecond":
      return "millisecond";
    default:
      return "second";
  }
}
function format$1(time, template, isUTC, lang) {
  var date4 = parseDate(time);
  var y2 = date4[fullYearGetterName(isUTC)]();
  var M = date4[monthGetterName(isUTC)]() + 1;
  var q2 = Math.floor((M - 1) / 4) + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var e2 = date4["get" + (isUTC ? "UTC" : "") + "Day"]();
  var H = date4[hoursGetterName(isUTC)]();
  var h = (H - 1) % 12 + 1;
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S = date4[millisecondsGetterName(isUTC)]();
  var localeModel = lang instanceof Model$1 ? lang : getLocaleModel(lang || SYSTEM_LANG) || getDefaultLocaleModel();
  var timeModel = localeModel.getModel("time");
  var month = timeModel.get("month");
  var monthAbbr = timeModel.get("monthAbbr");
  var dayOfWeek = timeModel.get("dayOfWeek");
  var dayOfWeekAbbr = timeModel.get("dayOfWeekAbbr");
  return (template || "").replace(/{yyyy}/g, y2 + "").replace(/{yy}/g, y2 % 100 + "").replace(/{Q}/g, q2 + "").replace(/{MMMM}/g, month[M - 1]).replace(/{MMM}/g, monthAbbr[M - 1]).replace(/{MM}/g, pad(M, 2)).replace(/{M}/g, M + "").replace(/{dd}/g, pad(d2, 2)).replace(/{d}/g, d2 + "").replace(/{eeee}/g, dayOfWeek[e2]).replace(/{ee}/g, dayOfWeekAbbr[e2]).replace(/{e}/g, e2 + "").replace(/{HH}/g, pad(H, 2)).replace(/{H}/g, H + "").replace(/{hh}/g, pad(h + "", 2)).replace(/{h}/g, h + "").replace(/{mm}/g, pad(m2, 2)).replace(/{m}/g, m2 + "").replace(/{ss}/g, pad(s, 2)).replace(/{s}/g, s + "").replace(/{SSS}/g, pad(S, 3)).replace(/{S}/g, S + "");
}
function leveledFormat(tick, idx, formatter, lang, isUTC) {
  var template = null;
  if (isString(formatter)) {
    template = formatter;
  } else if (isFunction(formatter)) {
    template = formatter(tick.value, idx, {
      level: tick.level
    });
  } else {
    var defaults$1 = extend({}, defaultLeveledFormatter);
    if (tick.level > 0) {
      for (var i = 0; i < primaryTimeUnits.length; ++i) {
        defaults$1[primaryTimeUnits[i]] = "{primary|" + defaults$1[primaryTimeUnits[i]] + "}";
      }
    }
    var mergedFormatter = formatter ? formatter.inherit === false ? formatter : defaults(formatter, defaults$1) : defaults$1;
    var unit = getUnitFromValue(tick.value, isUTC);
    if (mergedFormatter[unit]) {
      template = mergedFormatter[unit];
    } else if (mergedFormatter.inherit) {
      var targetId = timeUnits.indexOf(unit);
      for (var i = targetId - 1; i >= 0; --i) {
        if (mergedFormatter[unit]) {
          template = mergedFormatter[unit];
          break;
        }
      }
      template = template || defaults$1.none;
    }
    if (isArray$1(template)) {
      var levelId = tick.level == null ? 0 : tick.level >= 0 ? tick.level : template.length + tick.level;
      levelId = Math.min(levelId, template.length - 1);
      template = template[levelId];
    }
  }
  return format$1(new Date(tick.value), template, isUTC, lang);
}
function getUnitFromValue(value, isUTC) {
  var date4 = parseDate(value);
  var M = date4[monthGetterName(isUTC)]() + 1;
  var d2 = date4[dateGetterName(isUTC)]();
  var h = date4[hoursGetterName(isUTC)]();
  var m2 = date4[minutesGetterName(isUTC)]();
  var s = date4[secondsGetterName(isUTC)]();
  var S = date4[millisecondsGetterName(isUTC)]();
  var isSecond = S === 0;
  var isMinute = isSecond && s === 0;
  var isHour = isMinute && m2 === 0;
  var isDay = isHour && h === 0;
  var isMonth = isDay && d2 === 1;
  var isYear = isMonth && M === 1;
  if (isYear) {
    return "year";
  } else if (isMonth) {
    return "month";
  } else if (isDay) {
    return "day";
  } else if (isHour) {
    return "hour";
  } else if (isMinute) {
    return "minute";
  } else if (isSecond) {
    return "second";
  } else {
    return "millisecond";
  }
}
function getUnitValue(value, unit, isUTC) {
  var date4 = isNumber(value) ? parseDate(value) : value;
  unit = unit || getUnitFromValue(value, isUTC);
  switch (unit) {
    case "year":
      return date4[fullYearGetterName(isUTC)]();
    case "half-year":
      return date4[monthGetterName(isUTC)]() >= 6 ? 1 : 0;
    case "quarter":
      return Math.floor((date4[monthGetterName(isUTC)]() + 1) / 4);
    case "month":
      return date4[monthGetterName(isUTC)]();
    case "day":
      return date4[dateGetterName(isUTC)]();
    case "half-day":
      return date4[hoursGetterName(isUTC)]() / 24;
    case "hour":
      return date4[hoursGetterName(isUTC)]();
    case "minute":
      return date4[minutesGetterName(isUTC)]();
    case "second":
      return date4[secondsGetterName(isUTC)]();
    case "millisecond":
      return date4[millisecondsGetterName(isUTC)]();
  }
}
function fullYearGetterName(isUTC) {
  return isUTC ? "getUTCFullYear" : "getFullYear";
}
function monthGetterName(isUTC) {
  return isUTC ? "getUTCMonth" : "getMonth";
}
function dateGetterName(isUTC) {
  return isUTC ? "getUTCDate" : "getDate";
}
function hoursGetterName(isUTC) {
  return isUTC ? "getUTCHours" : "getHours";
}
function minutesGetterName(isUTC) {
  return isUTC ? "getUTCMinutes" : "getMinutes";
}
function secondsGetterName(isUTC) {
  return isUTC ? "getUTCSeconds" : "getSeconds";
}
function millisecondsGetterName(isUTC) {
  return isUTC ? "getUTCMilliseconds" : "getMilliseconds";
}
function fullYearSetterName(isUTC) {
  return isUTC ? "setUTCFullYear" : "setFullYear";
}
function monthSetterName(isUTC) {
  return isUTC ? "setUTCMonth" : "setMonth";
}
function dateSetterName(isUTC) {
  return isUTC ? "setUTCDate" : "setDate";
}
function hoursSetterName(isUTC) {
  return isUTC ? "setUTCHours" : "setHours";
}
function minutesSetterName(isUTC) {
  return isUTC ? "setUTCMinutes" : "setMinutes";
}
function secondsSetterName(isUTC) {
  return isUTC ? "setUTCSeconds" : "setSeconds";
}
function millisecondsSetterName(isUTC) {
  return isUTC ? "setUTCMilliseconds" : "setMilliseconds";
}
function addCommas(x2) {
  if (!isNumeric(x2)) {
    return isString(x2) ? x2 : "-";
  }
  var parts = (x2 + "").split(".");
  return parts[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (parts.length > 1 ? "." + parts[1] : "");
}
function toCamelCase(str, upperCaseFirst) {
  str = (str || "").toLowerCase().replace(/-(.)/g, function(match, group1) {
    return group1.toUpperCase();
  });
  if (upperCaseFirst && str) {
    str = str.charAt(0).toUpperCase() + str.slice(1);
  }
  return str;
}
var normalizeCssArray = normalizeCssArray$1;
var replaceReg = /([&<>"'])/g;
var replaceMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': "&quot;",
  "'": "&#39;"
};
function encodeHTML(source) {
  return source == null ? "" : (source + "").replace(replaceReg, function(str, c2) {
    return replaceMap[c2];
  });
}
function makeValueReadable(value, valueType, useUTC) {
  var USER_READABLE_DEFUALT_TIME_PATTERN = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
  function stringToUserReadable(str) {
    return str && trim$1(str) ? str : "-";
  }
  function isNumberUserReadable(num) {
    return !!(num != null && !isNaN(num) && isFinite(num));
  }
  var isTypeTime = valueType === "time";
  var isValueDate = value instanceof Date;
  if (isTypeTime || isValueDate) {
    var date4 = isTypeTime ? parseDate(value) : value;
    if (!isNaN(+date4)) {
      return format$1(date4, USER_READABLE_DEFUALT_TIME_PATTERN, useUTC);
    } else if (isValueDate) {
      return "-";
    }
  }
  if (valueType === "ordinal") {
    return isStringSafe(value) ? stringToUserReadable(value) : isNumber(value) ? isNumberUserReadable(value) ? value + "" : "-" : "-";
  }
  var numericResult = numericToNumber(value);
  return isNumberUserReadable(numericResult) ? addCommas(numericResult) : isStringSafe(value) ? stringToUserReadable(value) : typeof value === "boolean" ? value + "" : "-";
}
var TPL_VAR_ALIAS = ["a", "b", "c", "d", "e", "f", "g"];
var wrapVar = function(varName, seriesIdx) {
  return "{" + varName + (seriesIdx == null ? "" : seriesIdx) + "}";
};
function formatTpl(tpl, paramsList, encode) {
  if (!isArray$1(paramsList)) {
    paramsList = [paramsList];
  }
  var seriesLen = paramsList.length;
  if (!seriesLen) {
    return "";
  }
  var $vars = paramsList[0].$vars || [];
  for (var i = 0; i < $vars.length; i++) {
    var alias = TPL_VAR_ALIAS[i];
    tpl = tpl.replace(wrapVar(alias), wrapVar(alias, 0));
  }
  for (var seriesIdx = 0; seriesIdx < seriesLen; seriesIdx++) {
    for (var k2 = 0; k2 < $vars.length; k2++) {
      var val = paramsList[seriesIdx][$vars[k2]];
      tpl = tpl.replace(wrapVar(TPL_VAR_ALIAS[k2], seriesIdx), encode ? encodeHTML(val) : val);
    }
  }
  return tpl;
}
function formatTplSimple(tpl, param, encode) {
  each$f(param, function(value, key) {
    tpl = tpl.replace("{" + key + "}", encode ? encodeHTML(value) : value);
  });
  return tpl;
}
function getTooltipMarker(inOpt, extraCssText) {
  var opt = isString(inOpt) ? {
    color: inOpt,
    extraCssText
  } : inOpt || {};
  var color = opt.color;
  var type4 = opt.type;
  extraCssText = opt.extraCssText;
  var renderMode = opt.renderMode || "html";
  if (!color) {
    return "";
  }
  if (renderMode === "html") {
    return type4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + encodeHTML(color) + ";" + (extraCssText || "") + '"></span>';
  } else {
    var markerId = opt.markerId || "markerX";
    return {
      renderMode,
      content: "{" + markerId + "|}  ",
      style: type4 === "subItem" ? {
        width: 4,
        height: 4,
        borderRadius: 2,
        backgroundColor: color
      } : {
        width: 10,
        height: 10,
        borderRadius: 5,
        backgroundColor: color
      }
    };
  }
}
function convertToColorString(color, defaultColor) {
  defaultColor = defaultColor || "transparent";
  return isString(color) ? color : isObject$4(color) ? color.colorStops && (color.colorStops[0] || {}).color || defaultColor : defaultColor;
}
function windowOpen(link, target) {
  if (target === "_blank" || target === "blank") {
    var blank = window.open();
    blank.opener = null;
    blank.location.href = link;
  } else {
    window.open(link, target);
  }
}
var each$e = each$f;
var LOCATION_PARAMS = ["left", "right", "top", "bottom", "width", "height"];
var HV_NAMES = [["width", "left", "right"], ["height", "top", "bottom"]];
function boxLayout(orient, group, gap, maxWidth, maxHeight) {
  var x2 = 0;
  var y2 = 0;
  if (maxWidth == null) {
    maxWidth = Infinity;
  }
  if (maxHeight == null) {
    maxHeight = Infinity;
  }
  var currentLineMaxSize = 0;
  group.eachChild(function(child, idx) {
    var rect = child.getBoundingRect();
    var nextChild = group.childAt(idx + 1);
    var nextChildRect = nextChild && nextChild.getBoundingRect();
    var nextX;
    var nextY;
    if (orient === "horizontal") {
      var moveX = rect.width + (nextChildRect ? -nextChildRect.x + rect.x : 0);
      nextX = x2 + moveX;
      if (nextX > maxWidth || child.newline) {
        x2 = 0;
        nextX = moveX;
        y2 += currentLineMaxSize + gap;
        currentLineMaxSize = rect.height;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.height);
      }
    } else {
      var moveY = rect.height + (nextChildRect ? -nextChildRect.y + rect.y : 0);
      nextY = y2 + moveY;
      if (nextY > maxHeight || child.newline) {
        x2 += currentLineMaxSize + gap;
        y2 = 0;
        nextY = moveY;
        currentLineMaxSize = rect.width;
      } else {
        currentLineMaxSize = Math.max(currentLineMaxSize, rect.width);
      }
    }
    if (child.newline) {
      return;
    }
    child.x = x2;
    child.y = y2;
    child.markRedraw();
    orient === "horizontal" ? x2 = nextX + gap : y2 = nextY + gap;
  });
}
var box = boxLayout;
curry$1(boxLayout, "vertical");
curry$1(boxLayout, "horizontal");
function getAvailableSize(positionInfo, containerRect, margin) {
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var x2 = parsePercent(positionInfo.left, containerWidth);
  var y2 = parsePercent(positionInfo.top, containerHeight);
  var x22 = parsePercent(positionInfo.right, containerWidth);
  var y22 = parsePercent(positionInfo.bottom, containerHeight);
  (isNaN(x2) || isNaN(parseFloat(positionInfo.left))) && (x2 = 0);
  (isNaN(x22) || isNaN(parseFloat(positionInfo.right))) && (x22 = containerWidth);
  (isNaN(y2) || isNaN(parseFloat(positionInfo.top))) && (y2 = 0);
  (isNaN(y22) || isNaN(parseFloat(positionInfo.bottom))) && (y22 = containerHeight);
  margin = normalizeCssArray(margin || 0);
  return {
    width: Math.max(x22 - x2 - margin[1] - margin[3], 0),
    height: Math.max(y22 - y2 - margin[0] - margin[2], 0)
  };
}
function getLayoutRect(positionInfo, containerRect, margin) {
  margin = normalizeCssArray(margin || 0);
  var containerWidth = containerRect.width;
  var containerHeight = containerRect.height;
  var left = parsePercent(positionInfo.left, containerWidth);
  var top = parsePercent(positionInfo.top, containerHeight);
  var right = parsePercent(positionInfo.right, containerWidth);
  var bottom = parsePercent(positionInfo.bottom, containerHeight);
  var width = parsePercent(positionInfo.width, containerWidth);
  var height = parsePercent(positionInfo.height, containerHeight);
  var verticalMargin = margin[2] + margin[0];
  var horizontalMargin = margin[1] + margin[3];
  var aspect = positionInfo.aspect;
  if (isNaN(width)) {
    width = containerWidth - right - horizontalMargin - left;
  }
  if (isNaN(height)) {
    height = containerHeight - bottom - verticalMargin - top;
  }
  if (aspect != null) {
    if (isNaN(width) && isNaN(height)) {
      if (aspect > containerWidth / containerHeight) {
        width = containerWidth * 0.8;
      } else {
        height = containerHeight * 0.8;
      }
    }
    if (isNaN(width)) {
      width = aspect * height;
    }
    if (isNaN(height)) {
      height = width / aspect;
    }
  }
  if (isNaN(left)) {
    left = containerWidth - right - width - horizontalMargin;
  }
  if (isNaN(top)) {
    top = containerHeight - bottom - height - verticalMargin;
  }
  switch (positionInfo.left || positionInfo.right) {
    case "center":
      left = containerWidth / 2 - width / 2 - margin[3];
      break;
    case "right":
      left = containerWidth - width - horizontalMargin;
      break;
  }
  switch (positionInfo.top || positionInfo.bottom) {
    case "middle":
    case "center":
      top = containerHeight / 2 - height / 2 - margin[0];
      break;
    case "bottom":
      top = containerHeight - height - verticalMargin;
      break;
  }
  left = left || 0;
  top = top || 0;
  if (isNaN(width)) {
    width = containerWidth - horizontalMargin - left - (right || 0);
  }
  if (isNaN(height)) {
    height = containerHeight - verticalMargin - top - (bottom || 0);
  }
  var rect = new BoundingRect$1(left + margin[3], top + margin[0], width, height);
  rect.margin = margin;
  return rect;
}
function positionElement(el, positionInfo, containerRect, margin, opt, out2) {
  var h = !opt || !opt.hv || opt.hv[0];
  var v4 = !opt || !opt.hv || opt.hv[1];
  var boundingMode = opt && opt.boundingMode || "all";
  out2 = out2 || el;
  out2.x = el.x;
  out2.y = el.y;
  if (!h && !v4) {
    return false;
  }
  var rect;
  if (boundingMode === "raw") {
    rect = el.type === "group" ? new BoundingRect$1(0, 0, +positionInfo.width || 0, +positionInfo.height || 0) : el.getBoundingRect();
  } else {
    rect = el.getBoundingRect();
    if (el.needLocalTransform()) {
      var transform2 = el.getLocalTransform();
      rect = rect.clone();
      rect.applyTransform(transform2);
    }
  }
  var layoutRect = getLayoutRect(defaults({
    width: rect.width,
    height: rect.height
  }, positionInfo), containerRect, margin);
  var dx = h ? layoutRect.x - rect.x : 0;
  var dy = v4 ? layoutRect.y - rect.y : 0;
  if (boundingMode === "raw") {
    out2.x = dx;
    out2.y = dy;
  } else {
    out2.x += dx;
    out2.y += dy;
  }
  if (out2 === el) {
    el.markRedraw();
  }
  return true;
}
function sizeCalculable(option, hvIdx) {
  return option[HV_NAMES[hvIdx][0]] != null || option[HV_NAMES[hvIdx][1]] != null && option[HV_NAMES[hvIdx][2]] != null;
}
function fetchLayoutMode(ins) {
  var layoutMode = ins.layoutMode || ins.constructor.layoutMode;
  return isObject$4(layoutMode) ? layoutMode : layoutMode ? {
    type: layoutMode
  } : null;
}
function mergeLayoutParam(targetOption, newOption, opt) {
  var ignoreSize = opt && opt.ignoreSize;
  !isArray$1(ignoreSize) && (ignoreSize = [ignoreSize, ignoreSize]);
  var hResult = merge2(HV_NAMES[0], 0);
  var vResult = merge2(HV_NAMES[1], 1);
  copy2(HV_NAMES[0], targetOption, hResult);
  copy2(HV_NAMES[1], targetOption, vResult);
  function merge2(names2, hvIdx) {
    var newParams = {};
    var newValueCount = 0;
    var merged = {};
    var mergedValueCount = 0;
    var enoughParamNumber = 2;
    each$e(names2, function(name) {
      merged[name] = targetOption[name];
    });
    each$e(names2, function(name) {
      hasProp(newOption, name) && (newParams[name] = merged[name] = newOption[name]);
      hasValue(newParams, name) && newValueCount++;
      hasValue(merged, name) && mergedValueCount++;
    });
    if (ignoreSize[hvIdx]) {
      if (hasValue(newOption, names2[1])) {
        merged[names2[2]] = null;
      } else if (hasValue(newOption, names2[2])) {
        merged[names2[1]] = null;
      }
      return merged;
    }
    if (mergedValueCount === enoughParamNumber || !newValueCount) {
      return merged;
    } else if (newValueCount >= enoughParamNumber) {
      return newParams;
    } else {
      for (var i = 0; i < names2.length; i++) {
        var name_1 = names2[i];
        if (!hasProp(newParams, name_1) && hasProp(targetOption, name_1)) {
          newParams[name_1] = targetOption[name_1];
          break;
        }
      }
      return newParams;
    }
  }
  function hasProp(obj, name) {
    return obj.hasOwnProperty(name);
  }
  function hasValue(obj, name) {
    return obj[name] != null && obj[name] !== "auto";
  }
  function copy2(names2, target, source) {
    each$e(names2, function(name) {
      target[name] = source[name];
    });
  }
}
function getLayoutParams(source) {
  return copyLayoutParams({}, source);
}
function copyLayoutParams(target, source) {
  source && target && each$e(LOCATION_PARAMS, function(name) {
    source.hasOwnProperty(name) && (target[name] = source[name]);
  });
  return target;
}
var inner$l = makeInner();
var ComponentModel = function(_super) {
  __extends(ComponentModel2, _super);
  function ComponentModel2(option, parentModel, ecModel) {
    var _this = _super.call(this, option, parentModel, ecModel) || this;
    _this.uid = getUID("ec_cpt_model");
    return _this;
  }
  ComponentModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  ComponentModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeModel = ecModel.getTheme();
    merge(option, themeModel.get(this.mainType));
    merge(option, this.getDefaultOption());
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  ComponentModel2.prototype.mergeOption = function(option, ecModel) {
    merge(this.option, option, true);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, option, layoutMode);
    }
  };
  ComponentModel2.prototype.optionUpdated = function(newCptOption, isInit) {
  };
  ComponentModel2.prototype.getDefaultOption = function() {
    var ctor = this.constructor;
    if (!isExtendedClass(ctor)) {
      return ctor.defaultOption;
    }
    var fields = inner$l(this);
    if (!fields.defaultOption) {
      var optList = [];
      var clz = ctor;
      while (clz) {
        var opt = clz.prototype.defaultOption;
        opt && optList.push(opt);
        clz = clz.superClass;
      }
      var defaultOption2 = {};
      for (var i = optList.length - 1; i >= 0; i--) {
        defaultOption2 = merge(defaultOption2, optList[i], true);
      }
      fields.defaultOption = defaultOption2;
    }
    return fields.defaultOption;
  };
  ComponentModel2.prototype.getReferringComponents = function(mainType, opt) {
    var indexKey = mainType + "Index";
    var idKey = mainType + "Id";
    return queryReferringComponents(this.ecModel, mainType, {
      index: this.get(indexKey, true),
      id: this.get(idKey, true)
    }, opt);
  };
  ComponentModel2.prototype.getBoxLayoutParams = function() {
    var boxLayoutModel = this;
    return {
      left: boxLayoutModel.get("left"),
      top: boxLayoutModel.get("top"),
      right: boxLayoutModel.get("right"),
      bottom: boxLayoutModel.get("bottom"),
      width: boxLayoutModel.get("width"),
      height: boxLayoutModel.get("height")
    };
  };
  ComponentModel2.prototype.getZLevelKey = function() {
    return "";
  };
  ComponentModel2.prototype.setZLevel = function(zlevel) {
    this.option.zlevel = zlevel;
  };
  ComponentModel2.protoInitialize = function() {
    var proto2 = ComponentModel2.prototype;
    proto2.type = "component";
    proto2.id = "";
    proto2.name = "";
    proto2.mainType = "";
    proto2.subType = "";
    proto2.componentIndex = 0;
  }();
  return ComponentModel2;
}(Model$1);
mountExtend(ComponentModel, Model$1);
enableClassManagement(ComponentModel);
enableSubTypeDefaulter(ComponentModel);
enableTopologicalTravel(ComponentModel, getDependencies);
function getDependencies(componentType) {
  var deps = [];
  each$f(ComponentModel.getClassesByMainType(componentType), function(clz) {
    deps = deps.concat(clz.dependencies || clz.prototype.dependencies || []);
  });
  deps = map$1(deps, function(type4) {
    return parseClassType(type4).main;
  });
  if (componentType !== "dataset" && indexOf(deps, "dataset") <= 0) {
    deps.unshift("dataset");
  }
  return deps;
}
var ComponentModel$1 = ComponentModel;
var platform = "";
if (typeof navigator !== "undefined") {
  platform = navigator.platform || "";
}
var decalColor = "rgba(0, 0, 0, 0.2)";
var globalDefault = {
  darkMode: "auto",
  colorBy: "series",
  color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"],
  gradientColor: ["#f6efa6", "#d88273", "#bf444c"],
  aria: {
    decal: {
      decals: [{
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [2, 5],
        symbolSize: 1,
        rotation: Math.PI / 6
      }, {
        color: decalColor,
        symbol: "circle",
        dashArrayX: [[8, 8], [0, 8, 8, 0]],
        dashArrayY: [6, 0],
        symbolSize: 0.8
      }, {
        color: decalColor,
        dashArrayX: [1, 0],
        dashArrayY: [4, 3],
        rotation: -Math.PI / 4
      }, {
        color: decalColor,
        dashArrayX: [[6, 6], [0, 6, 6, 0]],
        dashArrayY: [6, 0]
      }, {
        color: decalColor,
        dashArrayX: [[1, 0], [1, 6]],
        dashArrayY: [1, 0, 6, 0],
        rotation: Math.PI / 4
      }, {
        color: decalColor,
        symbol: "triangle",
        dashArrayX: [[9, 9], [0, 9, 9, 0]],
        dashArrayY: [7, 2],
        symbolSize: 0.75
      }]
    }
  },
  textStyle: {
    fontFamily: platform.match(/^Win/) ? "Microsoft YaHei" : "sans-serif",
    fontSize: 12,
    fontStyle: "normal",
    fontWeight: "normal"
  },
  blendMode: null,
  stateAnimation: {
    duration: 300,
    easing: "cubicOut"
  },
  animation: "auto",
  animationDuration: 1e3,
  animationDurationUpdate: 500,
  animationEasing: "cubicInOut",
  animationEasingUpdate: "cubicInOut",
  animationThreshold: 2e3,
  progressiveThreshold: 3e3,
  progressive: 400,
  hoverLayerThreshold: 3e3,
  useUTC: false
};
var VISUAL_DIMENSIONS = createHashMap(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]);
var SOURCE_FORMAT_ORIGINAL = "original";
var SOURCE_FORMAT_ARRAY_ROWS = "arrayRows";
var SOURCE_FORMAT_OBJECT_ROWS = "objectRows";
var SOURCE_FORMAT_KEYED_COLUMNS = "keyedColumns";
var SOURCE_FORMAT_TYPED_ARRAY = "typedArray";
var SOURCE_FORMAT_UNKNOWN = "unknown";
var SERIES_LAYOUT_BY_COLUMN = "column";
var SERIES_LAYOUT_BY_ROW = "row";
var BE_ORDINAL = {
  Must: 1,
  Might: 2,
  Not: 3
};
var innerGlobalModel = makeInner();
function resetSourceDefaulter(ecModel) {
  innerGlobalModel(ecModel).datasetMap = createHashMap();
}
function makeSeriesEncodeForAxisCoordSys(coordDimensions, seriesModel, source) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel || !coordDimensions) {
    return encode;
  }
  var encodeItemName = [];
  var encodeSeriesName = [];
  var ecModel = seriesModel.ecModel;
  var datasetMap = innerGlobalModel(ecModel).datasetMap;
  var key = datasetModel.uid + "_" + source.seriesLayoutBy;
  var baseCategoryDimIndex;
  var categoryWayValueDimStart;
  coordDimensions = coordDimensions.slice();
  each$f(coordDimensions, function(coordDimInfoLoose, coordDimIdx) {
    var coordDimInfo = isObject$4(coordDimInfoLoose) ? coordDimInfoLoose : coordDimensions[coordDimIdx] = {
      name: coordDimInfoLoose
    };
    if (coordDimInfo.type === "ordinal" && baseCategoryDimIndex == null) {
      baseCategoryDimIndex = coordDimIdx;
      categoryWayValueDimStart = getDataDimCountOnCoordDim(coordDimInfo);
    }
    encode[coordDimInfo.name] = [];
  });
  var datasetRecord = datasetMap.get(key) || datasetMap.set(key, {
    categoryWayDim: categoryWayValueDimStart,
    valueWayDim: 0
  });
  each$f(coordDimensions, function(coordDimInfo, coordDimIdx) {
    var coordDimName = coordDimInfo.name;
    var count2 = getDataDimCountOnCoordDim(coordDimInfo);
    if (baseCategoryDimIndex == null) {
      var start2 = datasetRecord.valueWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.valueWayDim += count2;
    } else if (baseCategoryDimIndex === coordDimIdx) {
      pushDim(encode[coordDimName], 0, count2);
      pushDim(encodeItemName, 0, count2);
    } else {
      var start2 = datasetRecord.categoryWayDim;
      pushDim(encode[coordDimName], start2, count2);
      pushDim(encodeSeriesName, start2, count2);
      datasetRecord.categoryWayDim += count2;
    }
  });
  function pushDim(dimIdxArr, idxFrom, idxCount) {
    for (var i = 0; i < idxCount; i++) {
      dimIdxArr.push(idxFrom + i);
    }
  }
  function getDataDimCountOnCoordDim(coordDimInfo) {
    var dimsDef = coordDimInfo.dimsDef;
    return dimsDef ? dimsDef.length : 1;
  }
  encodeItemName.length && (encode.itemName = encodeItemName);
  encodeSeriesName.length && (encode.seriesName = encodeSeriesName);
  return encode;
}
function makeSeriesEncodeForNameBased(seriesModel, source, dimCount) {
  var encode = {};
  var datasetModel = querySeriesUpstreamDatasetModel(seriesModel);
  if (!datasetModel) {
    return encode;
  }
  var sourceFormat = source.sourceFormat;
  var dimensionsDefine = source.dimensionsDefine;
  var potentialNameDimIndex;
  if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    each$f(dimensionsDefine, function(dim, idx) {
      if ((isObject$4(dim) ? dim.name : dim) === "name") {
        potentialNameDimIndex = idx;
      }
    });
  }
  var idxResult = function() {
    var idxRes0 = {};
    var idxRes1 = {};
    var guessRecords = [];
    for (var i = 0, len2 = Math.min(5, dimCount); i < len2; i++) {
      var guessResult = doGuessOrdinal(source.data, sourceFormat, source.seriesLayoutBy, dimensionsDefine, source.startIndex, i);
      guessRecords.push(guessResult);
      var isPureNumber = guessResult === BE_ORDINAL.Not;
      if (isPureNumber && idxRes0.v == null && i !== potentialNameDimIndex) {
        idxRes0.v = i;
      }
      if (idxRes0.n == null || idxRes0.n === idxRes0.v || !isPureNumber && guessRecords[idxRes0.n] === BE_ORDINAL.Not) {
        idxRes0.n = i;
      }
      if (fulfilled(idxRes0) && guessRecords[idxRes0.n] !== BE_ORDINAL.Not) {
        return idxRes0;
      }
      if (!isPureNumber) {
        if (guessResult === BE_ORDINAL.Might && idxRes1.v == null && i !== potentialNameDimIndex) {
          idxRes1.v = i;
        }
        if (idxRes1.n == null || idxRes1.n === idxRes1.v) {
          idxRes1.n = i;
        }
      }
    }
    function fulfilled(idxResult2) {
      return idxResult2.v != null && idxResult2.n != null;
    }
    return fulfilled(idxRes0) ? idxRes0 : fulfilled(idxRes1) ? idxRes1 : null;
  }();
  if (idxResult) {
    encode.value = [idxResult.v];
    var nameDimIndex = potentialNameDimIndex != null ? potentialNameDimIndex : idxResult.n;
    encode.itemName = [nameDimIndex];
    encode.seriesName = [nameDimIndex];
  }
  return encode;
}
function querySeriesUpstreamDatasetModel(seriesModel) {
  var thisData = seriesModel.get("data", true);
  if (!thisData) {
    return queryReferringComponents(seriesModel.ecModel, "dataset", {
      index: seriesModel.get("datasetIndex", true),
      id: seriesModel.get("datasetId", true)
    }, SINGLE_REFERRING).models[0];
  }
}
function queryDatasetUpstreamDatasetModels(datasetModel) {
  if (!datasetModel.get("transform", true) && !datasetModel.get("fromTransformResult", true)) {
    return [];
  }
  return queryReferringComponents(datasetModel.ecModel, "dataset", {
    index: datasetModel.get("fromDatasetIndex", true),
    id: datasetModel.get("fromDatasetId", true)
  }, SINGLE_REFERRING).models;
}
function guessOrdinal(source, dimIndex) {
  return doGuessOrdinal(source.data, source.sourceFormat, source.seriesLayoutBy, source.dimensionsDefine, source.startIndex, dimIndex);
}
function doGuessOrdinal(data, sourceFormat, seriesLayoutBy, dimensionsDefine, startIndex, dimIndex) {
  var result;
  var maxLoop = 5;
  if (isTypedArray(data)) {
    return BE_ORDINAL.Not;
  }
  var dimName;
  var dimType;
  if (dimensionsDefine) {
    var dimDefItem = dimensionsDefine[dimIndex];
    if (isObject$4(dimDefItem)) {
      dimName = dimDefItem.name;
      dimType = dimDefItem.type;
    } else if (isString(dimDefItem)) {
      dimName = dimDefItem;
    }
  }
  if (dimType != null) {
    return dimType === "ordinal" ? BE_ORDINAL.Must : BE_ORDINAL.Not;
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
      var sample = dataArrayRows[dimIndex];
      for (var i = 0; i < (sample || []).length && i < maxLoop; i++) {
        if ((result = detectValue(sample[startIndex + i])) != null) {
          return result;
        }
      }
    } else {
      for (var i = 0; i < dataArrayRows.length && i < maxLoop; i++) {
        var row = dataArrayRows[startIndex + i];
        if (row && (result = detectValue(row[dimIndex])) != null) {
          return result;
        }
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var dataObjectRows = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < dataObjectRows.length && i < maxLoop; i++) {
      var item = dataObjectRows[i];
      if (item && (result = detectValue(item[dimName])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    var dataKeyedColumns = data;
    if (!dimName) {
      return BE_ORDINAL.Not;
    }
    var sample = dataKeyedColumns[dimName];
    if (!sample || isTypedArray(sample)) {
      return BE_ORDINAL.Not;
    }
    for (var i = 0; i < sample.length && i < maxLoop; i++) {
      if ((result = detectValue(sample[i])) != null) {
        return result;
      }
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var dataOriginal = data;
    for (var i = 0; i < dataOriginal.length && i < maxLoop; i++) {
      var item = dataOriginal[i];
      var val = getDataItemValue(item);
      if (!isArray$1(val)) {
        return BE_ORDINAL.Not;
      }
      if ((result = detectValue(val[dimIndex])) != null) {
        return result;
      }
    }
  }
  function detectValue(val2) {
    var beStr = isString(val2);
    if (val2 != null && isFinite(val2) && val2 !== "") {
      return beStr ? BE_ORDINAL.Might : BE_ORDINAL.Not;
    } else if (beStr && val2 !== "-") {
      return BE_ORDINAL.Must;
    }
  }
  return BE_ORDINAL.Not;
}
var internalOptionCreatorMap = createHashMap();
function registerInternalOptionCreator(mainType, creator) {
  assert(internalOptionCreatorMap.get(mainType) == null && creator);
  internalOptionCreatorMap.set(mainType, creator);
}
function concatInternalOptions(ecModel, mainType, newCmptOptionList) {
  var internalOptionCreator = internalOptionCreatorMap.get(mainType);
  if (!internalOptionCreator) {
    return newCmptOptionList;
  }
  var internalOptions = internalOptionCreator(ecModel);
  if (!internalOptions) {
    return newCmptOptionList;
  }
  return newCmptOptionList.concat(internalOptions);
}
var innerColor = makeInner();
var innerDecal = makeInner();
var PaletteMixin = function() {
  function PaletteMixin2() {
  }
  PaletteMixin2.prototype.getColorFromPalette = function(name, scope, requestNum) {
    var defaultPalette = normalizeToArray(this.get("color", true));
    var layeredPalette = this.get("colorLayer", true);
    return getFromPalette(this, innerColor, defaultPalette, layeredPalette, name, scope, requestNum);
  };
  PaletteMixin2.prototype.clearColorPalette = function() {
    clearPalette(this, innerColor);
  };
  return PaletteMixin2;
}();
function getDecalFromPalette(ecModel, name, scope, requestNum) {
  var defaultDecals = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  return getFromPalette(ecModel, innerDecal, defaultDecals, null, name, scope, requestNum);
}
function getNearestPalette(palettes, requestColorNum) {
  var paletteNum = palettes.length;
  for (var i = 0; i < paletteNum; i++) {
    if (palettes[i].length > requestColorNum) {
      return palettes[i];
    }
  }
  return palettes[paletteNum - 1];
}
function getFromPalette(that, inner2, defaultPalette, layeredPalette, name, scope, requestNum) {
  scope = scope || that;
  var scopeFields = inner2(scope);
  var paletteIdx = scopeFields.paletteIdx || 0;
  var paletteNameMap = scopeFields.paletteNameMap = scopeFields.paletteNameMap || {};
  if (paletteNameMap.hasOwnProperty(name)) {
    return paletteNameMap[name];
  }
  var palette = requestNum == null || !layeredPalette ? defaultPalette : getNearestPalette(layeredPalette, requestNum);
  palette = palette || defaultPalette;
  if (!palette || !palette.length) {
    return;
  }
  var pickedPaletteItem = palette[paletteIdx];
  if (name) {
    paletteNameMap[name] = pickedPaletteItem;
  }
  scopeFields.paletteIdx = (paletteIdx + 1) % palette.length;
  return pickedPaletteItem;
}
function clearPalette(that, inner2) {
  inner2(that).paletteIdx = 0;
  inner2(that).paletteNameMap = {};
}
var reCreateSeriesIndices;
var assertSeriesInitialized;
var initBase;
var OPTION_INNER_KEY = "\0_ec_inner";
var OPTION_INNER_VALUE = 1;
var GlobalModel = function(_super) {
  __extends(GlobalModel2, _super);
  function GlobalModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GlobalModel2.prototype.init = function(option, parentModel, ecModel, theme2, locale2, optionManager) {
    theme2 = theme2 || {};
    this.option = null;
    this._theme = new Model$1(theme2);
    this._locale = new Model$1(locale2);
    this._optionManager = optionManager;
  };
  GlobalModel2.prototype.setOption = function(option, opts, optionPreprocessorFuncs2) {
    var innerOpt = normalizeSetOptionInput(opts);
    this._optionManager.setOption(option, optionPreprocessorFuncs2, innerOpt);
    this._resetOption(null, innerOpt);
  };
  GlobalModel2.prototype.resetOption = function(type4, opt) {
    return this._resetOption(type4, normalizeSetOptionInput(opt));
  };
  GlobalModel2.prototype._resetOption = function(type4, opt) {
    var optionChanged = false;
    var optionManager = this._optionManager;
    if (!type4 || type4 === "recreate") {
      var baseOption = optionManager.mountOption(type4 === "recreate");
      if (!this.option || type4 === "recreate") {
        initBase(this, baseOption);
      } else {
        this.restoreData();
        this._mergeOption(baseOption, opt);
      }
      optionChanged = true;
    }
    if (type4 === "timeline" || type4 === "media") {
      this.restoreData();
    }
    if (!type4 || type4 === "recreate" || type4 === "timeline") {
      var timelineOption = optionManager.getTimelineOption(this);
      if (timelineOption) {
        optionChanged = true;
        this._mergeOption(timelineOption, opt);
      }
    }
    if (!type4 || type4 === "recreate" || type4 === "media") {
      var mediaOptions = optionManager.getMediaOption(this);
      if (mediaOptions.length) {
        each$f(mediaOptions, function(mediaOption) {
          optionChanged = true;
          this._mergeOption(mediaOption, opt);
        }, this);
      }
    }
    return optionChanged;
  };
  GlobalModel2.prototype.mergeOption = function(option) {
    this._mergeOption(option, null);
  };
  GlobalModel2.prototype._mergeOption = function(newOption, opt) {
    var option = this.option;
    var componentsMap = this._componentsMap;
    var componentsCount = this._componentsCount;
    var newCmptTypes = [];
    var newCmptTypeMap = createHashMap();
    var replaceMergeMainTypeMap = opt && opt.replaceMergeMainTypeMap;
    resetSourceDefaulter(this);
    each$f(newOption, function(componentOption, mainType) {
      if (componentOption == null) {
        return;
      }
      if (!ComponentModel$1.hasClass(mainType)) {
        option[mainType] = option[mainType] == null ? clone$4(componentOption) : merge(option[mainType], componentOption, true);
      } else if (mainType) {
        newCmptTypes.push(mainType);
        newCmptTypeMap.set(mainType, true);
      }
    });
    if (replaceMergeMainTypeMap) {
      replaceMergeMainTypeMap.each(function(val, mainTypeInReplaceMerge) {
        if (ComponentModel$1.hasClass(mainTypeInReplaceMerge) && !newCmptTypeMap.get(mainTypeInReplaceMerge)) {
          newCmptTypes.push(mainTypeInReplaceMerge);
          newCmptTypeMap.set(mainTypeInReplaceMerge, true);
        }
      });
    }
    ComponentModel$1.topologicalTravel(newCmptTypes, ComponentModel$1.getAllClassMainTypes(), visitComponent, this);
    function visitComponent(mainType) {
      var newCmptOptionList = concatInternalOptions(this, mainType, normalizeToArray(newOption[mainType]));
      var oldCmptList = componentsMap.get(mainType);
      var mergeMode = !oldCmptList ? "replaceAll" : replaceMergeMainTypeMap && replaceMergeMainTypeMap.get(mainType) ? "replaceMerge" : "normalMerge";
      var mappingResult = mappingToExists(oldCmptList, newCmptOptionList, mergeMode);
      setComponentTypeToKeyInfo(mappingResult, mainType, ComponentModel$1);
      option[mainType] = null;
      componentsMap.set(mainType, null);
      componentsCount.set(mainType, 0);
      var optionsByMainType = [];
      var cmptsByMainType = [];
      var cmptsCountByMainType = 0;
      var tooltipExists;
      each$f(mappingResult, function(resultItem, index2) {
        var componentModel = resultItem.existing;
        var newCmptOption = resultItem.newOption;
        if (!newCmptOption) {
          if (componentModel) {
            componentModel.mergeOption({}, this);
            componentModel.optionUpdated({}, false);
          }
        } else {
          var isSeriesType = mainType === "series";
          var ComponentModelClass = ComponentModel$1.getClass(mainType, resultItem.keyInfo.subType, !isSeriesType);
          if (!ComponentModelClass) {
            return;
          }
          if (mainType === "tooltip") {
            if (tooltipExists) {
              return;
            }
            tooltipExists = true;
          }
          if (componentModel && componentModel.constructor === ComponentModelClass) {
            componentModel.name = resultItem.keyInfo.name;
            componentModel.mergeOption(newCmptOption, this);
            componentModel.optionUpdated(newCmptOption, false);
          } else {
            var extraOpt = extend({
              componentIndex: index2
            }, resultItem.keyInfo);
            componentModel = new ComponentModelClass(newCmptOption, this, this, extraOpt);
            extend(componentModel, extraOpt);
            if (resultItem.brandNew) {
              componentModel.__requireNewView = true;
            }
            componentModel.init(newCmptOption, this, this);
            componentModel.optionUpdated(null, true);
          }
        }
        if (componentModel) {
          optionsByMainType.push(componentModel.option);
          cmptsByMainType.push(componentModel);
          cmptsCountByMainType++;
        } else {
          optionsByMainType.push(void 0);
          cmptsByMainType.push(void 0);
        }
      }, this);
      option[mainType] = optionsByMainType;
      componentsMap.set(mainType, cmptsByMainType);
      componentsCount.set(mainType, cmptsCountByMainType);
      if (mainType === "series") {
        reCreateSeriesIndices(this);
      }
    }
    if (!this._seriesIndices) {
      reCreateSeriesIndices(this);
    }
  };
  GlobalModel2.prototype.getOption = function() {
    var option = clone$4(this.option);
    each$f(option, function(optInMainType, mainType) {
      if (ComponentModel$1.hasClass(mainType)) {
        var opts = normalizeToArray(optInMainType);
        var realLen = opts.length;
        var metNonInner = false;
        for (var i = realLen - 1; i >= 0; i--) {
          if (opts[i] && !isComponentIdInternal(opts[i])) {
            metNonInner = true;
          } else {
            opts[i] = null;
            !metNonInner && realLen--;
          }
        }
        opts.length = realLen;
        option[mainType] = opts;
      }
    });
    delete option[OPTION_INNER_KEY];
    return option;
  };
  GlobalModel2.prototype.getTheme = function() {
    return this._theme;
  };
  GlobalModel2.prototype.getLocaleModel = function() {
    return this._locale;
  };
  GlobalModel2.prototype.setUpdatePayload = function(payload) {
    this._payload = payload;
  };
  GlobalModel2.prototype.getUpdatePayload = function() {
    return this._payload;
  };
  GlobalModel2.prototype.getComponent = function(mainType, idx) {
    var list = this._componentsMap.get(mainType);
    if (list) {
      var cmpt = list[idx || 0];
      if (cmpt) {
        return cmpt;
      } else if (idx == null) {
        for (var i = 0; i < list.length; i++) {
          if (list[i]) {
            return list[i];
          }
        }
      }
    }
  };
  GlobalModel2.prototype.queryComponents = function(condition) {
    var mainType = condition.mainType;
    if (!mainType) {
      return [];
    }
    var index2 = condition.index;
    var id2 = condition.id;
    var name = condition.name;
    var cmpts = this._componentsMap.get(mainType);
    if (!cmpts || !cmpts.length) {
      return [];
    }
    var result;
    if (index2 != null) {
      result = [];
      each$f(normalizeToArray(index2), function(idx) {
        cmpts[idx] && result.push(cmpts[idx]);
      });
    } else if (id2 != null) {
      result = queryByIdOrName("id", id2, cmpts);
    } else if (name != null) {
      result = queryByIdOrName("name", name, cmpts);
    } else {
      result = filter(cmpts, function(cmpt) {
        return !!cmpt;
      });
    }
    return filterBySubType(result, condition);
  };
  GlobalModel2.prototype.findComponents = function(condition) {
    var query = condition.query;
    var mainType = condition.mainType;
    var queryCond = getQueryCond(query);
    var result = queryCond ? this.queryComponents(queryCond) : filter(this._componentsMap.get(mainType), function(cmpt) {
      return !!cmpt;
    });
    return doFilter(filterBySubType(result, condition));
    function getQueryCond(q2) {
      var indexAttr = mainType + "Index";
      var idAttr = mainType + "Id";
      var nameAttr = mainType + "Name";
      return q2 && (q2[indexAttr] != null || q2[idAttr] != null || q2[nameAttr] != null) ? {
        mainType,
        index: q2[indexAttr],
        id: q2[idAttr],
        name: q2[nameAttr]
      } : null;
    }
    function doFilter(res) {
      return condition.filter ? filter(res, condition.filter) : res;
    }
  };
  GlobalModel2.prototype.eachComponent = function(mainType, cb, context) {
    var componentsMap = this._componentsMap;
    if (isFunction(mainType)) {
      var ctxForAll_1 = cb;
      var cbForAll_1 = mainType;
      componentsMap.each(function(cmpts2, componentType) {
        for (var i2 = 0; cmpts2 && i2 < cmpts2.length; i2++) {
          var cmpt2 = cmpts2[i2];
          cmpt2 && cbForAll_1.call(ctxForAll_1, componentType, cmpt2, cmpt2.componentIndex);
        }
      });
    } else {
      var cmpts = isString(mainType) ? componentsMap.get(mainType) : isObject$4(mainType) ? this.findComponents(mainType) : null;
      for (var i = 0; cmpts && i < cmpts.length; i++) {
        var cmpt = cmpts[i];
        cmpt && cb.call(context, cmpt, cmpt.componentIndex);
      }
    }
  };
  GlobalModel2.prototype.getSeriesByName = function(name) {
    var nameStr = convertOptionIdName(name, null);
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && nameStr != null && oneSeries.name === nameStr;
    });
  };
  GlobalModel2.prototype.getSeriesByIndex = function(seriesIndex) {
    return this._componentsMap.get("series")[seriesIndex];
  };
  GlobalModel2.prototype.getSeriesByType = function(subType) {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries && oneSeries.subType === subType;
    });
  };
  GlobalModel2.prototype.getSeries = function() {
    return filter(this._componentsMap.get("series"), function(oneSeries) {
      return !!oneSeries;
    });
  };
  GlobalModel2.prototype.getSeriesCount = function() {
    return this._componentsCount.get("series");
  };
  GlobalModel2.prototype.eachSeries = function(cb, context) {
    assertSeriesInitialized(this);
    each$f(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      cb.call(context, series, rawSeriesIndex);
    }, this);
  };
  GlobalModel2.prototype.eachRawSeries = function(cb, context) {
    each$f(this._componentsMap.get("series"), function(series) {
      series && cb.call(context, series, series.componentIndex);
    });
  };
  GlobalModel2.prototype.eachSeriesByType = function(subType, cb, context) {
    assertSeriesInitialized(this);
    each$f(this._seriesIndices, function(rawSeriesIndex) {
      var series = this._componentsMap.get("series")[rawSeriesIndex];
      if (series.subType === subType) {
        cb.call(context, series, rawSeriesIndex);
      }
    }, this);
  };
  GlobalModel2.prototype.eachRawSeriesByType = function(subType, cb, context) {
    return each$f(this.getSeriesByType(subType), cb, context);
  };
  GlobalModel2.prototype.isSeriesFiltered = function(seriesModel) {
    assertSeriesInitialized(this);
    return this._seriesIndicesMap.get(seriesModel.componentIndex) == null;
  };
  GlobalModel2.prototype.getCurrentSeriesIndices = function() {
    return (this._seriesIndices || []).slice();
  };
  GlobalModel2.prototype.filterSeries = function(cb, context) {
    assertSeriesInitialized(this);
    var newSeriesIndices = [];
    each$f(this._seriesIndices, function(seriesRawIdx) {
      var series = this._componentsMap.get("series")[seriesRawIdx];
      cb.call(context, series, seriesRawIdx) && newSeriesIndices.push(seriesRawIdx);
    }, this);
    this._seriesIndices = newSeriesIndices;
    this._seriesIndicesMap = createHashMap(newSeriesIndices);
  };
  GlobalModel2.prototype.restoreData = function(payload) {
    reCreateSeriesIndices(this);
    var componentsMap = this._componentsMap;
    var componentTypes = [];
    componentsMap.each(function(components, componentType) {
      if (ComponentModel$1.hasClass(componentType)) {
        componentTypes.push(componentType);
      }
    });
    ComponentModel$1.topologicalTravel(componentTypes, ComponentModel$1.getAllClassMainTypes(), function(componentType) {
      each$f(componentsMap.get(componentType), function(component) {
        if (component && (componentType !== "series" || !isNotTargetSeries(component, payload))) {
          component.restoreData();
        }
      });
    });
  };
  GlobalModel2.internalField = function() {
    reCreateSeriesIndices = function(ecModel) {
      var seriesIndices = ecModel._seriesIndices = [];
      each$f(ecModel._componentsMap.get("series"), function(series) {
        series && seriesIndices.push(series.componentIndex);
      });
      ecModel._seriesIndicesMap = createHashMap(seriesIndices);
    };
    assertSeriesInitialized = function(ecModel) {
    };
    initBase = function(ecModel, baseOption) {
      ecModel.option = {};
      ecModel.option[OPTION_INNER_KEY] = OPTION_INNER_VALUE;
      ecModel._componentsMap = createHashMap({
        series: []
      });
      ecModel._componentsCount = createHashMap();
      var airaOption = baseOption.aria;
      if (isObject$4(airaOption) && airaOption.enabled == null) {
        airaOption.enabled = true;
      }
      mergeTheme(baseOption, ecModel._theme.option);
      merge(baseOption, globalDefault, false);
      ecModel._mergeOption(baseOption, null);
    };
  }();
  return GlobalModel2;
}(Model$1);
function isNotTargetSeries(seriesModel, payload) {
  if (payload) {
    var index2 = payload.seriesIndex;
    var id2 = payload.seriesId;
    var name_1 = payload.seriesName;
    return index2 != null && seriesModel.componentIndex !== index2 || id2 != null && seriesModel.id !== id2 || name_1 != null && seriesModel.name !== name_1;
  }
}
function mergeTheme(option, theme2) {
  var notMergeColorLayer = option.color && !option.colorLayer;
  each$f(theme2, function(themeItem, name) {
    if (name === "colorLayer" && notMergeColorLayer) {
      return;
    }
    if (!ComponentModel$1.hasClass(name)) {
      if (typeof themeItem === "object") {
        option[name] = !option[name] ? clone$4(themeItem) : merge(option[name], themeItem, false);
      } else {
        if (option[name] == null) {
          option[name] = themeItem;
        }
      }
    }
  });
}
function queryByIdOrName(attr, idOrName, cmpts) {
  if (isArray$1(idOrName)) {
    var keyMap_1 = createHashMap();
    each$f(idOrName, function(idOrNameItem) {
      if (idOrNameItem != null) {
        var idName = convertOptionIdName(idOrNameItem, null);
        idName != null && keyMap_1.set(idOrNameItem, true);
      }
    });
    return filter(cmpts, function(cmpt) {
      return cmpt && keyMap_1.get(cmpt[attr]);
    });
  } else {
    var idName_1 = convertOptionIdName(idOrName, null);
    return filter(cmpts, function(cmpt) {
      return cmpt && idName_1 != null && cmpt[attr] === idName_1;
    });
  }
}
function filterBySubType(components, condition) {
  return condition.hasOwnProperty("subType") ? filter(components, function(cmpt) {
    return cmpt && cmpt.subType === condition.subType;
  }) : components;
}
function normalizeSetOptionInput(opts) {
  var replaceMergeMainTypeMap = createHashMap();
  opts && each$f(normalizeToArray(opts.replaceMerge), function(mainType) {
    replaceMergeMainTypeMap.set(mainType, true);
  });
  return {
    replaceMergeMainTypeMap
  };
}
mixin(GlobalModel, PaletteMixin);
var GlobalModel$1 = GlobalModel;
var availableMethods = [
  "getDom",
  "getZr",
  "getWidth",
  "getHeight",
  "getDevicePixelRatio",
  "dispatchAction",
  "isSSR",
  "isDisposed",
  "on",
  "off",
  "getDataURL",
  "getConnectedDataURL",
  "getOption",
  "getId",
  "updateLabelLayout"
];
var ExtensionAPI = function() {
  function ExtensionAPI2(ecInstance) {
    each$f(availableMethods, function(methodName) {
      this[methodName] = bind$1(ecInstance[methodName], ecInstance);
    }, this);
  }
  return ExtensionAPI2;
}();
var ExtensionAPI$1 = ExtensionAPI;
var coordinateSystemCreators = {};
var CoordinateSystemManager = function() {
  function CoordinateSystemManager2() {
    this._coordinateSystems = [];
  }
  CoordinateSystemManager2.prototype.create = function(ecModel, api) {
    var coordinateSystems = [];
    each$f(coordinateSystemCreators, function(creater, type4) {
      var list = creater.create(ecModel, api);
      coordinateSystems = coordinateSystems.concat(list || []);
    });
    this._coordinateSystems = coordinateSystems;
  };
  CoordinateSystemManager2.prototype.update = function(ecModel, api) {
    each$f(this._coordinateSystems, function(coordSys) {
      coordSys.update && coordSys.update(ecModel, api);
    });
  };
  CoordinateSystemManager2.prototype.getCoordinateSystems = function() {
    return this._coordinateSystems.slice();
  };
  CoordinateSystemManager2.register = function(type4, creator) {
    coordinateSystemCreators[type4] = creator;
  };
  CoordinateSystemManager2.get = function(type4) {
    return coordinateSystemCreators[type4];
  };
  return CoordinateSystemManager2;
}();
var CoordinateSystem = CoordinateSystemManager;
var QUERY_REG = /^(min|max)?(.+)$/;
var OptionManager = function() {
  function OptionManager2(api) {
    this._timelineOptions = [];
    this._mediaList = [];
    this._currentMediaIndices = [];
    this._api = api;
  }
  OptionManager2.prototype.setOption = function(rawOption, optionPreprocessorFuncs2, opt) {
    if (rawOption) {
      each$f(normalizeToArray(rawOption.series), function(series) {
        series && series.data && isTypedArray(series.data) && setAsPrimitive(series.data);
      });
      each$f(normalizeToArray(rawOption.dataset), function(dataset) {
        dataset && dataset.source && isTypedArray(dataset.source) && setAsPrimitive(dataset.source);
      });
    }
    rawOption = clone$4(rawOption);
    var optionBackup = this._optionBackup;
    var newParsedOption = parseRawOption(rawOption, optionPreprocessorFuncs2, !optionBackup);
    this._newBaseOption = newParsedOption.baseOption;
    if (optionBackup) {
      if (newParsedOption.timelineOptions.length) {
        optionBackup.timelineOptions = newParsedOption.timelineOptions;
      }
      if (newParsedOption.mediaList.length) {
        optionBackup.mediaList = newParsedOption.mediaList;
      }
      if (newParsedOption.mediaDefault) {
        optionBackup.mediaDefault = newParsedOption.mediaDefault;
      }
    } else {
      this._optionBackup = newParsedOption;
    }
  };
  OptionManager2.prototype.mountOption = function(isRecreate) {
    var optionBackup = this._optionBackup;
    this._timelineOptions = optionBackup.timelineOptions;
    this._mediaList = optionBackup.mediaList;
    this._mediaDefault = optionBackup.mediaDefault;
    this._currentMediaIndices = [];
    return clone$4(isRecreate ? optionBackup.baseOption : this._newBaseOption);
  };
  OptionManager2.prototype.getTimelineOption = function(ecModel) {
    var option;
    var timelineOptions = this._timelineOptions;
    if (timelineOptions.length) {
      var timelineModel = ecModel.getComponent("timeline");
      if (timelineModel) {
        option = clone$4(timelineOptions[timelineModel.getCurrentIndex()]);
      }
    }
    return option;
  };
  OptionManager2.prototype.getMediaOption = function(ecModel) {
    var ecWidth = this._api.getWidth();
    var ecHeight = this._api.getHeight();
    var mediaList = this._mediaList;
    var mediaDefault = this._mediaDefault;
    var indices = [];
    var result = [];
    if (!mediaList.length && !mediaDefault) {
      return result;
    }
    for (var i = 0, len2 = mediaList.length; i < len2; i++) {
      if (applyMediaQuery(mediaList[i].query, ecWidth, ecHeight)) {
        indices.push(i);
      }
    }
    if (!indices.length && mediaDefault) {
      indices = [-1];
    }
    if (indices.length && !indicesEquals(indices, this._currentMediaIndices)) {
      result = map$1(indices, function(index2) {
        return clone$4(index2 === -1 ? mediaDefault.option : mediaList[index2].option);
      });
    }
    this._currentMediaIndices = indices;
    return result;
  };
  return OptionManager2;
}();
function parseRawOption(rawOption, optionPreprocessorFuncs2, isNew) {
  var mediaList = [];
  var mediaDefault;
  var baseOption;
  var declaredBaseOption = rawOption.baseOption;
  var timelineOnRoot = rawOption.timeline;
  var timelineOptionsOnRoot = rawOption.options;
  var mediaOnRoot = rawOption.media;
  var hasMedia = !!rawOption.media;
  var hasTimeline = !!(timelineOptionsOnRoot || timelineOnRoot || declaredBaseOption && declaredBaseOption.timeline);
  if (declaredBaseOption) {
    baseOption = declaredBaseOption;
    if (!baseOption.timeline) {
      baseOption.timeline = timelineOnRoot;
    }
  } else {
    if (hasTimeline || hasMedia) {
      rawOption.options = rawOption.media = null;
    }
    baseOption = rawOption;
  }
  if (hasMedia) {
    if (isArray$1(mediaOnRoot)) {
      each$f(mediaOnRoot, function(singleMedia) {
        if (singleMedia && singleMedia.option) {
          if (singleMedia.query) {
            mediaList.push(singleMedia);
          } else if (!mediaDefault) {
            mediaDefault = singleMedia;
          }
        }
      });
    }
  }
  doPreprocess(baseOption);
  each$f(timelineOptionsOnRoot, function(option) {
    return doPreprocess(option);
  });
  each$f(mediaList, function(media) {
    return doPreprocess(media.option);
  });
  function doPreprocess(option) {
    each$f(optionPreprocessorFuncs2, function(preProcess) {
      preProcess(option, isNew);
    });
  }
  return {
    baseOption,
    timelineOptions: timelineOptionsOnRoot || [],
    mediaDefault,
    mediaList
  };
}
function applyMediaQuery(query, ecWidth, ecHeight) {
  var realMap = {
    width: ecWidth,
    height: ecHeight,
    aspectratio: ecWidth / ecHeight
  };
  var applicatable = true;
  each$f(query, function(value, attr) {
    var matched = attr.match(QUERY_REG);
    if (!matched || !matched[1] || !matched[2]) {
      return;
    }
    var operator = matched[1];
    var realAttr = matched[2].toLowerCase();
    if (!compare(realMap[realAttr], value, operator)) {
      applicatable = false;
    }
  });
  return applicatable;
}
function compare(real, expect, operator) {
  if (operator === "min") {
    return real >= expect;
  } else if (operator === "max") {
    return real <= expect;
  } else {
    return real === expect;
  }
}
function indicesEquals(indices1, indices2) {
  return indices1.join(",") === indices2.join(",");
}
var OptionManager$1 = OptionManager;
var each$d = each$f;
var isObject$3 = isObject$4;
var POSSIBLE_STYLES = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
function compatEC2ItemStyle(opt) {
  var itemStyleOpt = opt && opt.itemStyle;
  if (!itemStyleOpt) {
    return;
  }
  for (var i = 0, len2 = POSSIBLE_STYLES.length; i < len2; i++) {
    var styleName = POSSIBLE_STYLES[i];
    var normalItemStyleOpt = itemStyleOpt.normal;
    var emphasisItemStyleOpt = itemStyleOpt.emphasis;
    if (normalItemStyleOpt && normalItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].normal) {
        opt[styleName].normal = normalItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].normal, normalItemStyleOpt[styleName]);
      }
      normalItemStyleOpt[styleName] = null;
    }
    if (emphasisItemStyleOpt && emphasisItemStyleOpt[styleName]) {
      opt[styleName] = opt[styleName] || {};
      if (!opt[styleName].emphasis) {
        opt[styleName].emphasis = emphasisItemStyleOpt[styleName];
      } else {
        merge(opt[styleName].emphasis, emphasisItemStyleOpt[styleName]);
      }
      emphasisItemStyleOpt[styleName] = null;
    }
  }
}
function convertNormalEmphasis(opt, optType, useExtend) {
  if (opt && opt[optType] && (opt[optType].normal || opt[optType].emphasis)) {
    var normalOpt = opt[optType].normal;
    var emphasisOpt = opt[optType].emphasis;
    if (normalOpt) {
      if (useExtend) {
        opt[optType].normal = opt[optType].emphasis = null;
        defaults(opt[optType], normalOpt);
      } else {
        opt[optType] = normalOpt;
      }
    }
    if (emphasisOpt) {
      opt.emphasis = opt.emphasis || {};
      opt.emphasis[optType] = emphasisOpt;
      if (emphasisOpt.focus) {
        opt.emphasis.focus = emphasisOpt.focus;
      }
      if (emphasisOpt.blurScope) {
        opt.emphasis.blurScope = emphasisOpt.blurScope;
      }
    }
  }
}
function removeEC3NormalStatus(opt) {
  convertNormalEmphasis(opt, "itemStyle");
  convertNormalEmphasis(opt, "lineStyle");
  convertNormalEmphasis(opt, "areaStyle");
  convertNormalEmphasis(opt, "label");
  convertNormalEmphasis(opt, "labelLine");
  convertNormalEmphasis(opt, "upperLabel");
  convertNormalEmphasis(opt, "edgeLabel");
}
function compatTextStyle(opt, propName) {
  var labelOptSingle = isObject$3(opt) && opt[propName];
  var textStyle = isObject$3(labelOptSingle) && labelOptSingle.textStyle;
  if (textStyle) {
    for (var i = 0, len2 = TEXT_STYLE_OPTIONS.length; i < len2; i++) {
      var textPropName = TEXT_STYLE_OPTIONS[i];
      if (textStyle.hasOwnProperty(textPropName)) {
        labelOptSingle[textPropName] = textStyle[textPropName];
      }
    }
  }
}
function compatEC3CommonStyles(opt) {
  if (opt) {
    removeEC3NormalStatus(opt);
    compatTextStyle(opt, "label");
    opt.emphasis && compatTextStyle(opt.emphasis, "label");
  }
}
function processSeries(seriesOpt) {
  if (!isObject$3(seriesOpt)) {
    return;
  }
  compatEC2ItemStyle(seriesOpt);
  removeEC3NormalStatus(seriesOpt);
  compatTextStyle(seriesOpt, "label");
  compatTextStyle(seriesOpt, "upperLabel");
  compatTextStyle(seriesOpt, "edgeLabel");
  if (seriesOpt.emphasis) {
    compatTextStyle(seriesOpt.emphasis, "label");
    compatTextStyle(seriesOpt.emphasis, "upperLabel");
    compatTextStyle(seriesOpt.emphasis, "edgeLabel");
  }
  var markPoint = seriesOpt.markPoint;
  if (markPoint) {
    compatEC2ItemStyle(markPoint);
    compatEC3CommonStyles(markPoint);
  }
  var markLine = seriesOpt.markLine;
  if (markLine) {
    compatEC2ItemStyle(markLine);
    compatEC3CommonStyles(markLine);
  }
  var markArea = seriesOpt.markArea;
  if (markArea) {
    compatEC3CommonStyles(markArea);
  }
  var data = seriesOpt.data;
  if (seriesOpt.type === "graph") {
    data = data || seriesOpt.nodes;
    var edgeData = seriesOpt.links || seriesOpt.edges;
    if (edgeData && !isTypedArray(edgeData)) {
      for (var i = 0; i < edgeData.length; i++) {
        compatEC3CommonStyles(edgeData[i]);
      }
    }
    each$f(seriesOpt.categories, function(opt) {
      removeEC3NormalStatus(opt);
    });
  }
  if (data && !isTypedArray(data)) {
    for (var i = 0; i < data.length; i++) {
      compatEC3CommonStyles(data[i]);
    }
  }
  markPoint = seriesOpt.markPoint;
  if (markPoint && markPoint.data) {
    var mpData = markPoint.data;
    for (var i = 0; i < mpData.length; i++) {
      compatEC3CommonStyles(mpData[i]);
    }
  }
  markLine = seriesOpt.markLine;
  if (markLine && markLine.data) {
    var mlData = markLine.data;
    for (var i = 0; i < mlData.length; i++) {
      if (isArray$1(mlData[i])) {
        compatEC3CommonStyles(mlData[i][0]);
        compatEC3CommonStyles(mlData[i][1]);
      } else {
        compatEC3CommonStyles(mlData[i]);
      }
    }
  }
  if (seriesOpt.type === "gauge") {
    compatTextStyle(seriesOpt, "axisLabel");
    compatTextStyle(seriesOpt, "title");
    compatTextStyle(seriesOpt, "detail");
  } else if (seriesOpt.type === "treemap") {
    convertNormalEmphasis(seriesOpt.breadcrumb, "itemStyle");
    each$f(seriesOpt.levels, function(opt) {
      removeEC3NormalStatus(opt);
    });
  } else if (seriesOpt.type === "tree") {
    removeEC3NormalStatus(seriesOpt.leaves);
  }
}
function toArr(o) {
  return isArray$1(o) ? o : o ? [o] : [];
}
function toObj(o) {
  return (isArray$1(o) ? o[0] : o) || {};
}
function globalCompatStyle(option, isTheme) {
  each$d(toArr(option.series), function(seriesOpt) {
    isObject$3(seriesOpt) && processSeries(seriesOpt);
  });
  var axes = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
  isTheme && axes.push("valueAxis", "categoryAxis", "logAxis", "timeAxis");
  each$d(axes, function(axisName) {
    each$d(toArr(option[axisName]), function(axisOpt) {
      if (axisOpt) {
        compatTextStyle(axisOpt, "axisLabel");
        compatTextStyle(axisOpt.axisPointer, "label");
      }
    });
  });
  each$d(toArr(option.parallel), function(parallelOpt) {
    var parallelAxisDefault = parallelOpt && parallelOpt.parallelAxisDefault;
    compatTextStyle(parallelAxisDefault, "axisLabel");
    compatTextStyle(parallelAxisDefault && parallelAxisDefault.axisPointer, "label");
  });
  each$d(toArr(option.calendar), function(calendarOpt) {
    convertNormalEmphasis(calendarOpt, "itemStyle");
    compatTextStyle(calendarOpt, "dayLabel");
    compatTextStyle(calendarOpt, "monthLabel");
    compatTextStyle(calendarOpt, "yearLabel");
  });
  each$d(toArr(option.radar), function(radarOpt) {
    compatTextStyle(radarOpt, "name");
    if (radarOpt.name && radarOpt.axisName == null) {
      radarOpt.axisName = radarOpt.name;
      delete radarOpt.name;
    }
    if (radarOpt.nameGap != null && radarOpt.axisNameGap == null) {
      radarOpt.axisNameGap = radarOpt.nameGap;
      delete radarOpt.nameGap;
    }
  });
  each$d(toArr(option.geo), function(geoOpt) {
    if (isObject$3(geoOpt)) {
      compatEC3CommonStyles(geoOpt);
      each$d(toArr(geoOpt.regions), function(regionObj) {
        compatEC3CommonStyles(regionObj);
      });
    }
  });
  each$d(toArr(option.timeline), function(timelineOpt) {
    compatEC3CommonStyles(timelineOpt);
    convertNormalEmphasis(timelineOpt, "label");
    convertNormalEmphasis(timelineOpt, "itemStyle");
    convertNormalEmphasis(timelineOpt, "controlStyle", true);
    var data = timelineOpt.data;
    isArray$1(data) && each$f(data, function(item) {
      if (isObject$4(item)) {
        convertNormalEmphasis(item, "label");
        convertNormalEmphasis(item, "itemStyle");
      }
    });
  });
  each$d(toArr(option.toolbox), function(toolboxOpt) {
    convertNormalEmphasis(toolboxOpt, "iconStyle");
    each$d(toolboxOpt.feature, function(featureOpt) {
      convertNormalEmphasis(featureOpt, "iconStyle");
    });
  });
  compatTextStyle(toObj(option.axisPointer), "label");
  compatTextStyle(toObj(option.tooltip).axisPointer, "label");
}
function get$1(opt, path) {
  var pathArr = path.split(",");
  var obj = opt;
  for (var i = 0; i < pathArr.length; i++) {
    obj = obj && obj[pathArr[i]];
    if (obj == null) {
      break;
    }
  }
  return obj;
}
function set$1(opt, path, val, overwrite) {
  var pathArr = path.split(",");
  var obj = opt;
  var key;
  var i = 0;
  for (; i < pathArr.length - 1; i++) {
    key = pathArr[i];
    if (obj[key] == null) {
      obj[key] = {};
    }
    obj = obj[key];
  }
  if (overwrite || obj[pathArr[i]] == null) {
    obj[pathArr[i]] = val;
  }
}
function compatLayoutProperties(option) {
  option && each$f(LAYOUT_PROPERTIES, function(prop) {
    if (prop[0] in option && !(prop[1] in option)) {
      option[prop[1]] = option[prop[0]];
    }
  });
}
var LAYOUT_PROPERTIES = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]];
var COMPATITABLE_COMPONENTS = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"];
var BAR_ITEM_STYLE_MAP = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
function compatBarItemStyle(option) {
  var itemStyle = option && option.itemStyle;
  if (itemStyle) {
    for (var i = 0; i < BAR_ITEM_STYLE_MAP.length; i++) {
      var oldName = BAR_ITEM_STYLE_MAP[i][1];
      var newName = BAR_ITEM_STYLE_MAP[i][0];
      if (itemStyle[oldName] != null) {
        itemStyle[newName] = itemStyle[oldName];
      }
    }
  }
}
function compatPieLabel(option) {
  if (!option) {
    return;
  }
  if (option.alignTo === "edge" && option.margin != null && option.edgeDistance == null) {
    option.edgeDistance = option.margin;
  }
}
function compatSunburstState(option) {
  if (!option) {
    return;
  }
  if (option.downplay && !option.blur) {
    option.blur = option.downplay;
  }
}
function compatGraphFocus(option) {
  if (!option) {
    return;
  }
  if (option.focusNodeAdjacency != null) {
    option.emphasis = option.emphasis || {};
    if (option.emphasis.focus == null) {
      option.emphasis.focus = "adjacency";
    }
  }
}
function traverseTree(data, cb) {
  if (data) {
    for (var i = 0; i < data.length; i++) {
      cb(data[i]);
      data[i] && traverseTree(data[i].children, cb);
    }
  }
}
function globalBackwardCompat(option, isTheme) {
  globalCompatStyle(option, isTheme);
  option.series = normalizeToArray(option.series);
  each$f(option.series, function(seriesOpt) {
    if (!isObject$4(seriesOpt)) {
      return;
    }
    var seriesType2 = seriesOpt.type;
    if (seriesType2 === "line") {
      if (seriesOpt.clipOverflow != null) {
        seriesOpt.clip = seriesOpt.clipOverflow;
      }
    } else if (seriesType2 === "pie" || seriesType2 === "gauge") {
      if (seriesOpt.clockWise != null) {
        seriesOpt.clockwise = seriesOpt.clockWise;
      }
      compatPieLabel(seriesOpt.label);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          compatPieLabel(data[i]);
        }
      }
      if (seriesOpt.hoverOffset != null) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (seriesOpt.emphasis.scaleSize = null) {
          seriesOpt.emphasis.scaleSize = seriesOpt.hoverOffset;
        }
      }
    } else if (seriesType2 === "gauge") {
      var pointerColor = get$1(seriesOpt, "pointer.color");
      pointerColor != null && set$1(seriesOpt, "itemStyle.color", pointerColor);
    } else if (seriesType2 === "bar") {
      compatBarItemStyle(seriesOpt);
      compatBarItemStyle(seriesOpt.backgroundStyle);
      compatBarItemStyle(seriesOpt.emphasis);
      var data = seriesOpt.data;
      if (data && !isTypedArray(data)) {
        for (var i = 0; i < data.length; i++) {
          if (typeof data[i] === "object") {
            compatBarItemStyle(data[i]);
            compatBarItemStyle(data[i] && data[i].emphasis);
          }
        }
      }
    } else if (seriesType2 === "sunburst") {
      var highlightPolicy = seriesOpt.highlightPolicy;
      if (highlightPolicy) {
        seriesOpt.emphasis = seriesOpt.emphasis || {};
        if (!seriesOpt.emphasis.focus) {
          seriesOpt.emphasis.focus = highlightPolicy;
        }
      }
      compatSunburstState(seriesOpt);
      traverseTree(seriesOpt.data, compatSunburstState);
    } else if (seriesType2 === "graph" || seriesType2 === "sankey") {
      compatGraphFocus(seriesOpt);
    } else if (seriesType2 === "map") {
      if (seriesOpt.mapType && !seriesOpt.map) {
        seriesOpt.map = seriesOpt.mapType;
      }
      if (seriesOpt.mapLocation) {
        defaults(seriesOpt, seriesOpt.mapLocation);
      }
    }
    if (seriesOpt.hoverAnimation != null) {
      seriesOpt.emphasis = seriesOpt.emphasis || {};
      if (seriesOpt.emphasis && seriesOpt.emphasis.scale == null) {
        seriesOpt.emphasis.scale = seriesOpt.hoverAnimation;
      }
    }
    compatLayoutProperties(seriesOpt);
  });
  if (option.dataRange) {
    option.visualMap = option.dataRange;
  }
  each$f(COMPATITABLE_COMPONENTS, function(componentName) {
    var options = option[componentName];
    if (options) {
      if (!isArray$1(options)) {
        options = [options];
      }
      each$f(options, function(option2) {
        compatLayoutProperties(option2);
      });
    }
  });
}
function dataStack(ecModel) {
  var stackInfoMap = createHashMap();
  ecModel.eachSeries(function(seriesModel) {
    var stack = seriesModel.get("stack");
    if (stack) {
      var stackInfoList = stackInfoMap.get(stack) || stackInfoMap.set(stack, []);
      var data = seriesModel.getData();
      var stackInfo = {
        stackResultDimension: data.getCalculationInfo("stackResultDimension"),
        stackedOverDimension: data.getCalculationInfo("stackedOverDimension"),
        stackedDimension: data.getCalculationInfo("stackedDimension"),
        stackedByDimension: data.getCalculationInfo("stackedByDimension"),
        isStackedByIndex: data.getCalculationInfo("isStackedByIndex"),
        data,
        seriesModel
      };
      if (!stackInfo.stackedDimension || !(stackInfo.isStackedByIndex || stackInfo.stackedByDimension)) {
        return;
      }
      stackInfoList.length && data.setCalculationInfo("stackedOnSeries", stackInfoList[stackInfoList.length - 1].seriesModel);
      stackInfoList.push(stackInfo);
    }
  });
  stackInfoMap.each(calculateStack);
}
function calculateStack(stackInfoList) {
  each$f(stackInfoList, function(targetStackInfo, idxInStack) {
    var resultVal = [];
    var resultNaN = [NaN, NaN];
    var dims = [targetStackInfo.stackResultDimension, targetStackInfo.stackedOverDimension];
    var targetData = targetStackInfo.data;
    var isStackedByIndex = targetStackInfo.isStackedByIndex;
    targetData.modify(dims, function(v0, v12, dataIndex) {
      var sum2 = targetData.get(targetStackInfo.stackedDimension, dataIndex);
      if (isNaN(sum2)) {
        return resultNaN;
      }
      var byValue;
      var stackedDataRawIndex;
      if (isStackedByIndex) {
        stackedDataRawIndex = targetData.getRawIndex(dataIndex);
      } else {
        byValue = targetData.get(targetStackInfo.stackedByDimension, dataIndex);
      }
      var stackedOver = NaN;
      for (var j = idxInStack - 1; j >= 0; j--) {
        var stackInfo = stackInfoList[j];
        if (!isStackedByIndex) {
          stackedDataRawIndex = stackInfo.data.rawIndexOf(stackInfo.stackedByDimension, byValue);
        }
        if (stackedDataRawIndex >= 0) {
          var val = stackInfo.data.getByRawIndex(stackInfo.stackResultDimension, stackedDataRawIndex);
          if (sum2 >= 0 && val > 0 || sum2 <= 0 && val < 0) {
            sum2 = addSafe(sum2, val);
            stackedOver = val;
            break;
          }
        }
      }
      resultVal[0] = sum2;
      resultVal[1] = stackedOver;
      return resultVal;
    });
  });
}
var SourceImpl = function() {
  function SourceImpl2(fields) {
    this.data = fields.data || (fields.sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS ? {} : []);
    this.sourceFormat = fields.sourceFormat || SOURCE_FORMAT_UNKNOWN;
    this.seriesLayoutBy = fields.seriesLayoutBy || SERIES_LAYOUT_BY_COLUMN;
    this.startIndex = fields.startIndex || 0;
    this.dimensionsDetectedCount = fields.dimensionsDetectedCount;
    this.metaRawOption = fields.metaRawOption;
    var dimensionsDefine = this.dimensionsDefine = fields.dimensionsDefine;
    if (dimensionsDefine) {
      for (var i = 0; i < dimensionsDefine.length; i++) {
        var dim = dimensionsDefine[i];
        if (dim.type == null) {
          if (guessOrdinal(this, i) === BE_ORDINAL.Must) {
            dim.type = "ordinal";
          }
        }
      }
    }
  }
  return SourceImpl2;
}();
function isSourceInstance(val) {
  return val instanceof SourceImpl;
}
function createSource(sourceData, thisMetaRawOption, sourceFormat) {
  sourceFormat = sourceFormat || detectSourceFormat(sourceData);
  var seriesLayoutBy = thisMetaRawOption.seriesLayoutBy;
  var determined = determineSourceDimensions(sourceData, sourceFormat, seriesLayoutBy, thisMetaRawOption.sourceHeader, thisMetaRawOption.dimensions);
  var source = new SourceImpl({
    data: sourceData,
    sourceFormat,
    seriesLayoutBy,
    dimensionsDefine: determined.dimensionsDefine,
    startIndex: determined.startIndex,
    dimensionsDetectedCount: determined.dimensionsDetectedCount,
    metaRawOption: clone$4(thisMetaRawOption)
  });
  return source;
}
function createSourceFromSeriesDataOption(data) {
  return new SourceImpl({
    data,
    sourceFormat: isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL
  });
}
function cloneSourceShallow(source) {
  return new SourceImpl({
    data: source.data,
    sourceFormat: source.sourceFormat,
    seriesLayoutBy: source.seriesLayoutBy,
    dimensionsDefine: clone$4(source.dimensionsDefine),
    startIndex: source.startIndex,
    dimensionsDetectedCount: source.dimensionsDetectedCount
  });
}
function detectSourceFormat(data) {
  var sourceFormat = SOURCE_FORMAT_UNKNOWN;
  if (isTypedArray(data)) {
    sourceFormat = SOURCE_FORMAT_TYPED_ARRAY;
  } else if (isArray$1(data)) {
    if (data.length === 0) {
      sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
    }
    for (var i = 0, len2 = data.length; i < len2; i++) {
      var item = data[i];
      if (item == null) {
        continue;
      } else if (isArray$1(item)) {
        sourceFormat = SOURCE_FORMAT_ARRAY_ROWS;
        break;
      } else if (isObject$4(item)) {
        sourceFormat = SOURCE_FORMAT_OBJECT_ROWS;
        break;
      }
    }
  } else if (isObject$4(data)) {
    for (var key in data) {
      if (hasOwn(data, key) && isArrayLike(data[key])) {
        sourceFormat = SOURCE_FORMAT_KEYED_COLUMNS;
        break;
      }
    }
  }
  return sourceFormat;
}
function determineSourceDimensions(data, sourceFormat, seriesLayoutBy, sourceHeader, dimensionsDefine) {
  var dimensionsDetectedCount;
  var startIndex;
  if (!data) {
    return {
      dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
      startIndex,
      dimensionsDetectedCount
    };
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var dataArrayRows = data;
    if (sourceHeader === "auto" || sourceHeader == null) {
      arrayRowsTravelFirst(function(val) {
        if (val != null && val !== "-") {
          if (isString(val)) {
            startIndex == null && (startIndex = 1);
          } else {
            startIndex = 0;
          }
        }
      }, seriesLayoutBy, dataArrayRows, 10);
    } else {
      startIndex = isNumber(sourceHeader) ? sourceHeader : sourceHeader ? 1 : 0;
    }
    if (!dimensionsDefine && startIndex === 1) {
      dimensionsDefine = [];
      arrayRowsTravelFirst(function(val, index2) {
        dimensionsDefine[index2] = val != null ? val + "" : "";
      }, seriesLayoutBy, dataArrayRows, Infinity);
    }
    dimensionsDetectedCount = dimensionsDefine ? dimensionsDefine.length : seriesLayoutBy === SERIES_LAYOUT_BY_ROW ? dataArrayRows.length : dataArrayRows[0] ? dataArrayRows[0].length : null;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    if (!dimensionsDefine) {
      dimensionsDefine = objectRowsCollectDimensions(data);
    }
  } else if (sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS) {
    if (!dimensionsDefine) {
      dimensionsDefine = [];
      each$f(data, function(colArr, key) {
        dimensionsDefine.push(key);
      });
    }
  } else if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var value0 = getDataItemValue(data[0]);
    dimensionsDetectedCount = isArray$1(value0) && value0.length || 1;
  } else
    ;
  return {
    startIndex,
    dimensionsDefine: normalizeDimensionsOption(dimensionsDefine),
    dimensionsDetectedCount
  };
}
function objectRowsCollectDimensions(data) {
  var firstIndex = 0;
  var obj;
  while (firstIndex < data.length && !(obj = data[firstIndex++])) {
  }
  if (obj) {
    var dimensions_1 = [];
    each$f(obj, function(value, key) {
      dimensions_1.push(key);
    });
    return dimensions_1;
  }
}
function normalizeDimensionsOption(dimensionsDefine) {
  if (!dimensionsDefine) {
    return;
  }
  var nameMap = createHashMap();
  return map$1(dimensionsDefine, function(rawItem, index2) {
    rawItem = isObject$4(rawItem) ? rawItem : {
      name: rawItem
    };
    var item = {
      name: rawItem.name,
      displayName: rawItem.displayName,
      type: rawItem.type
    };
    if (item.name == null) {
      return item;
    }
    item.name += "";
    if (item.displayName == null) {
      item.displayName = item.name;
    }
    var exist = nameMap.get(item.name);
    if (!exist) {
      nameMap.set(item.name, {
        count: 1
      });
    } else {
      item.name += "-" + exist.count++;
    }
    return item;
  });
}
function arrayRowsTravelFirst(cb, seriesLayoutBy, data, maxLoop) {
  if (seriesLayoutBy === SERIES_LAYOUT_BY_ROW) {
    for (var i = 0; i < data.length && i < maxLoop; i++) {
      cb(data[i] ? data[i][0] : null, i);
    }
  } else {
    var value0 = data[0] || [];
    for (var i = 0; i < value0.length && i < maxLoop; i++) {
      cb(value0[i], i);
    }
  }
}
function shouldRetrieveDataByName(source) {
  var sourceFormat = source.sourceFormat;
  return sourceFormat === SOURCE_FORMAT_OBJECT_ROWS || sourceFormat === SOURCE_FORMAT_KEYED_COLUMNS;
}
var _a, _b, _c;
var providerMethods;
var mountMethods;
var DefaultDataProvider = function() {
  function DefaultDataProvider2(sourceParam, dimSize) {
    var source = !isSourceInstance(sourceParam) ? createSourceFromSeriesDataOption(sourceParam) : sourceParam;
    this._source = source;
    var data = this._data = source.data;
    if (source.sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
      this._offset = 0;
      this._dimSize = dimSize;
      this._data = data;
    }
    mountMethods(this, data, source);
  }
  DefaultDataProvider2.prototype.getSource = function() {
    return this._source;
  };
  DefaultDataProvider2.prototype.count = function() {
    return 0;
  };
  DefaultDataProvider2.prototype.getItem = function(idx, out2) {
    return;
  };
  DefaultDataProvider2.prototype.appendData = function(newData) {
  };
  DefaultDataProvider2.prototype.clean = function() {
  };
  DefaultDataProvider2.protoInitialize = function() {
    var proto2 = DefaultDataProvider2.prototype;
    proto2.pure = false;
    proto2.persistent = true;
  }();
  DefaultDataProvider2.internalField = function() {
    var _a2;
    mountMethods = function(provider, data, source) {
      var sourceFormat = source.sourceFormat;
      var seriesLayoutBy = source.seriesLayoutBy;
      var startIndex = source.startIndex;
      var dimsDef = source.dimensionsDefine;
      var methods = providerMethods[getMethodMapKey(sourceFormat, seriesLayoutBy)];
      extend(provider, methods);
      if (sourceFormat === SOURCE_FORMAT_TYPED_ARRAY) {
        provider.getItem = getItemForTypedArray;
        provider.count = countForTypedArray;
        provider.fillStorage = fillStorageForTypedArray;
      } else {
        var rawItemGetter = getRawSourceItemGetter(sourceFormat, seriesLayoutBy);
        provider.getItem = bind$1(rawItemGetter, null, data, startIndex, dimsDef);
        var rawCounter = getRawSourceDataCounter(sourceFormat, seriesLayoutBy);
        provider.count = bind$1(rawCounter, null, data, startIndex, dimsDef);
      }
    };
    var getItemForTypedArray = function(idx, out2) {
      idx = idx - this._offset;
      out2 = out2 || [];
      var data = this._data;
      var dimSize = this._dimSize;
      var offset = dimSize * idx;
      for (var i = 0; i < dimSize; i++) {
        out2[i] = data[offset + i];
      }
      return out2;
    };
    var fillStorageForTypedArray = function(start2, end2, storage2, extent3) {
      var data = this._data;
      var dimSize = this._dimSize;
      for (var dim = 0; dim < dimSize; dim++) {
        var dimExtent = extent3[dim];
        var min3 = dimExtent[0] == null ? Infinity : dimExtent[0];
        var max3 = dimExtent[1] == null ? -Infinity : dimExtent[1];
        var count2 = end2 - start2;
        var arr = storage2[dim];
        for (var i = 0; i < count2; i++) {
          var val = data[i * dimSize + dim];
          arr[start2 + i] = val;
          val < min3 && (min3 = val);
          val > max3 && (max3 = val);
        }
        dimExtent[0] = min3;
        dimExtent[1] = max3;
      }
    };
    var countForTypedArray = function() {
      return this._data ? this._data.length / this._dimSize : 0;
    };
    providerMethods = (_a2 = {}, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = {
      pure: true,
      appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      }
    }, _a2[SOURCE_FORMAT_OBJECT_ROWS] = {
      pure: true,
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_KEYED_COLUMNS] = {
      pure: true,
      appendData: function(newData) {
        var data = this._data;
        each$f(newData, function(newCol, key) {
          var oldCol = data[key] || (data[key] = []);
          for (var i = 0; i < (newCol || []).length; i++) {
            oldCol.push(newCol[i]);
          }
        });
      }
    }, _a2[SOURCE_FORMAT_ORIGINAL] = {
      appendData: appendDataSimply
    }, _a2[SOURCE_FORMAT_TYPED_ARRAY] = {
      persistent: false,
      pure: true,
      appendData: function(newData) {
        this._data = newData;
      },
      clean: function() {
        this._offset += this.count();
        this._data = null;
      }
    }, _a2);
    function appendDataSimply(newData) {
      for (var i = 0; i < newData.length; i++) {
        this._data.push(newData[i]);
      }
    }
  }();
  return DefaultDataProvider2;
}();
var getItemSimply = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx];
};
var rawSourceItemGetterMap = (_a = {}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef, idx) {
  return rawData[idx + startIndex];
}, _a[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef, idx, out2) {
  idx += startIndex;
  var item = out2 || [];
  var data = rawData;
  for (var i = 0; i < data.length; i++) {
    var row = data[i];
    item[i] = row ? row[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_OBJECT_ROWS] = getItemSimply, _a[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef, idx, out2) {
  var item = out2 || [];
  for (var i = 0; i < dimsDef.length; i++) {
    var dimName = dimsDef[i].name;
    var col = rawData[dimName];
    item[i] = col ? col[idx] : null;
  }
  return item;
}, _a[SOURCE_FORMAT_ORIGINAL] = getItemSimply, _a);
function getRawSourceItemGetter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceItemGetterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var countSimply = function(rawData, startIndex, dimsDef) {
  return rawData.length;
};
var rawSourceDataCounterMap = (_b = {}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_COLUMN] = function(rawData, startIndex, dimsDef) {
  return Math.max(0, rawData.length - startIndex);
}, _b[SOURCE_FORMAT_ARRAY_ROWS + "_" + SERIES_LAYOUT_BY_ROW] = function(rawData, startIndex, dimsDef) {
  var row = rawData[0];
  return row ? Math.max(0, row.length - startIndex) : 0;
}, _b[SOURCE_FORMAT_OBJECT_ROWS] = countSimply, _b[SOURCE_FORMAT_KEYED_COLUMNS] = function(rawData, startIndex, dimsDef) {
  var dimName = dimsDef[0].name;
  var col = rawData[dimName];
  return col ? col.length : 0;
}, _b[SOURCE_FORMAT_ORIGINAL] = countSimply, _b);
function getRawSourceDataCounter(sourceFormat, seriesLayoutBy) {
  var method4 = rawSourceDataCounterMap[getMethodMapKey(sourceFormat, seriesLayoutBy)];
  return method4;
}
var getRawValueSimply = function(dataItem, dimIndex, property) {
  return dataItem[dimIndex];
};
var rawSourceValueGetterMap = (_c = {}, _c[SOURCE_FORMAT_ARRAY_ROWS] = getRawValueSimply, _c[SOURCE_FORMAT_OBJECT_ROWS] = function(dataItem, dimIndex, property) {
  return dataItem[property];
}, _c[SOURCE_FORMAT_KEYED_COLUMNS] = getRawValueSimply, _c[SOURCE_FORMAT_ORIGINAL] = function(dataItem, dimIndex, property) {
  var value = getDataItemValue(dataItem);
  return !(value instanceof Array) ? value : value[dimIndex];
}, _c[SOURCE_FORMAT_TYPED_ARRAY] = getRawValueSimply, _c);
function getRawSourceValueGetter(sourceFormat) {
  var method4 = rawSourceValueGetterMap[sourceFormat];
  return method4;
}
function getMethodMapKey(sourceFormat, seriesLayoutBy) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS ? sourceFormat + "_" + seriesLayoutBy : sourceFormat;
}
function retrieveRawValue(data, dataIndex, dim) {
  if (!data) {
    return;
  }
  var dataItem = data.getRawDataItem(dataIndex);
  if (dataItem == null) {
    return;
  }
  var store = data.getStore();
  var sourceFormat = store.getSource().sourceFormat;
  if (dim != null) {
    var dimIndex = data.getDimensionIndex(dim);
    var property = store.getDimensionProperty(dimIndex);
    return getRawSourceValueGetter(sourceFormat)(dataItem, dimIndex, property);
  } else {
    var result = dataItem;
    if (sourceFormat === SOURCE_FORMAT_ORIGINAL) {
      result = getDataItemValue(dataItem);
    }
    return result;
  }
}
var DIMENSION_LABEL_REG = /\{@(.+?)\}/g;
var DataFormatMixin = function() {
  function DataFormatMixin2() {
  }
  DataFormatMixin2.prototype.getDataParams = function(dataIndex, dataType) {
    var data = this.getData(dataType);
    var rawValue = this.getRawValue(dataIndex, dataType);
    var rawDataIndex = data.getRawIndex(dataIndex);
    var name = data.getName(dataIndex);
    var itemOpt = data.getRawDataItem(dataIndex);
    var style = data.getItemVisual(dataIndex, "style");
    var color = style && style[data.getItemVisual(dataIndex, "drawType") || "fill"];
    var borderColor = style && style.stroke;
    var mainType = this.mainType;
    var isSeries2 = mainType === "series";
    var userOutput = data.userOutput && data.userOutput.get();
    return {
      componentType: mainType,
      componentSubType: this.subType,
      componentIndex: this.componentIndex,
      seriesType: isSeries2 ? this.subType : null,
      seriesIndex: this.seriesIndex,
      seriesId: isSeries2 ? this.id : null,
      seriesName: isSeries2 ? this.name : null,
      name,
      dataIndex: rawDataIndex,
      data: itemOpt,
      dataType,
      value: rawValue,
      color,
      borderColor,
      dimensionNames: userOutput ? userOutput.fullDimensions : null,
      encode: userOutput ? userOutput.encode : null,
      $vars: ["seriesName", "name", "value"]
    };
  };
  DataFormatMixin2.prototype.getFormattedLabel = function(dataIndex, status, dataType, labelDimIndex, formatter, extendParams) {
    status = status || "normal";
    var data = this.getData(dataType);
    var params = this.getDataParams(dataIndex, dataType);
    if (extendParams) {
      params.value = extendParams.interpolatedValue;
    }
    if (labelDimIndex != null && isArray$1(params.value)) {
      params.value = params.value[labelDimIndex];
    }
    if (!formatter) {
      var itemModel = data.getItemModel(dataIndex);
      formatter = itemModel.get(status === "normal" ? ["label", "formatter"] : [status, "label", "formatter"]);
    }
    if (isFunction(formatter)) {
      params.status = status;
      params.dimensionIndex = labelDimIndex;
      return formatter(params);
    } else if (isString(formatter)) {
      var str = formatTpl(formatter, params);
      return str.replace(DIMENSION_LABEL_REG, function(origin, dimStr) {
        var len2 = dimStr.length;
        var dimLoose = dimStr;
        if (dimLoose.charAt(0) === "[" && dimLoose.charAt(len2 - 1) === "]") {
          dimLoose = +dimLoose.slice(1, len2 - 1);
        }
        var val = retrieveRawValue(data, dataIndex, dimLoose);
        if (extendParams && isArray$1(extendParams.interpolatedValue)) {
          var dimIndex = data.getDimensionIndex(dimLoose);
          if (dimIndex >= 0) {
            val = extendParams.interpolatedValue[dimIndex];
          }
        }
        return val != null ? val + "" : "";
      });
    }
  };
  DataFormatMixin2.prototype.getRawValue = function(idx, dataType) {
    return retrieveRawValue(this.getData(dataType), idx);
  };
  DataFormatMixin2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return;
  };
  return DataFormatMixin2;
}();
function normalizeTooltipFormatResult(result) {
  var markupText;
  var markupFragment;
  if (isObject$4(result)) {
    if (result.type) {
      markupFragment = result;
    }
  } else {
    markupText = result;
  }
  return {
    text: markupText,
    frag: markupFragment
  };
}
function createTask(define) {
  return new Task(define);
}
var Task = function() {
  function Task2(define) {
    define = define || {};
    this._reset = define.reset;
    this._plan = define.plan;
    this._count = define.count;
    this._onDirty = define.onDirty;
    this._dirty = true;
  }
  Task2.prototype.perform = function(performArgs) {
    var upTask = this._upstream;
    var skip = performArgs && performArgs.skip;
    if (this._dirty && upTask) {
      var context = this.context;
      context.data = context.outputData = upTask.context.outputData;
    }
    if (this.__pipeline) {
      this.__pipeline.currentTask = this;
    }
    var planResult;
    if (this._plan && !skip) {
      planResult = this._plan(this.context);
    }
    var lastModBy = normalizeModBy(this._modBy);
    var lastModDataCount = this._modDataCount || 0;
    var modBy = normalizeModBy(performArgs && performArgs.modBy);
    var modDataCount = performArgs && performArgs.modDataCount || 0;
    if (lastModBy !== modBy || lastModDataCount !== modDataCount) {
      planResult = "reset";
    }
    function normalizeModBy(val) {
      !(val >= 1) && (val = 1);
      return val;
    }
    var forceFirstProgress;
    if (this._dirty || planResult === "reset") {
      this._dirty = false;
      forceFirstProgress = this._doReset(skip);
    }
    this._modBy = modBy;
    this._modDataCount = modDataCount;
    var step = performArgs && performArgs.step;
    if (upTask) {
      this._dueEnd = upTask._outputDueEnd;
    } else {
      this._dueEnd = this._count ? this._count(this.context) : Infinity;
    }
    if (this._progress) {
      var start2 = this._dueIndex;
      var end2 = Math.min(step != null ? this._dueIndex + step : Infinity, this._dueEnd);
      if (!skip && (forceFirstProgress || start2 < end2)) {
        var progress = this._progress;
        if (isArray$1(progress)) {
          for (var i = 0; i < progress.length; i++) {
            this._doProgress(progress[i], start2, end2, modBy, modDataCount);
          }
        } else {
          this._doProgress(progress, start2, end2, modBy, modDataCount);
        }
      }
      this._dueIndex = end2;
      var outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : end2;
      this._outputDueEnd = outputDueEnd;
    } else {
      this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
    }
    return this.unfinished();
  };
  Task2.prototype.dirty = function() {
    this._dirty = true;
    this._onDirty && this._onDirty(this.context);
  };
  Task2.prototype._doProgress = function(progress, start2, end2, modBy, modDataCount) {
    iterator.reset(start2, end2, modBy, modDataCount);
    this._callingProgress = progress;
    this._callingProgress({
      start: start2,
      end: end2,
      count: end2 - start2,
      next: iterator.next
    }, this.context);
  };
  Task2.prototype._doReset = function(skip) {
    this._dueIndex = this._outputDueEnd = this._dueEnd = 0;
    this._settedOutputEnd = null;
    var progress;
    var forceFirstProgress;
    if (!skip && this._reset) {
      progress = this._reset(this.context);
      if (progress && progress.progress) {
        forceFirstProgress = progress.forceFirstProgress;
        progress = progress.progress;
      }
      if (isArray$1(progress) && !progress.length) {
        progress = null;
      }
    }
    this._progress = progress;
    this._modBy = this._modDataCount = null;
    var downstream = this._downstream;
    downstream && downstream.dirty();
    return forceFirstProgress;
  };
  Task2.prototype.unfinished = function() {
    return this._progress && this._dueIndex < this._dueEnd;
  };
  Task2.prototype.pipe = function(downTask) {
    if (this._downstream !== downTask || this._dirty) {
      this._downstream = downTask;
      downTask._upstream = this;
      downTask.dirty();
    }
  };
  Task2.prototype.dispose = function() {
    if (this._disposed) {
      return;
    }
    this._upstream && (this._upstream._downstream = null);
    this._downstream && (this._downstream._upstream = null);
    this._dirty = false;
    this._disposed = true;
  };
  Task2.prototype.getUpstream = function() {
    return this._upstream;
  };
  Task2.prototype.getDownstream = function() {
    return this._downstream;
  };
  Task2.prototype.setOutputEnd = function(end2) {
    this._outputDueEnd = this._settedOutputEnd = end2;
  };
  return Task2;
}();
var iterator = function() {
  var end2;
  var current;
  var modBy;
  var modDataCount;
  var winCount;
  var it = {
    reset: function(s, e2, sStep, sCount) {
      current = s;
      end2 = e2;
      modBy = sStep;
      modDataCount = sCount;
      winCount = Math.ceil(modDataCount / modBy);
      it.next = modBy > 1 && modDataCount > 0 ? modNext : sequentialNext;
    }
  };
  return it;
  function sequentialNext() {
    return current < end2 ? current++ : null;
  }
  function modNext() {
    var dataIndex = current % winCount * modBy + Math.ceil(current / winCount);
    var result = current >= end2 ? null : dataIndex < modDataCount ? dataIndex : current;
    current++;
    return result;
  }
}();
function parseDataValue(value, opt) {
  var dimType = opt && opt.type;
  if (dimType === "ordinal") {
    return value;
  }
  if (dimType === "time" && !isNumber(value) && value != null && value !== "-") {
    value = +parseDate(value);
  }
  return value == null || value === "" ? NaN : +value;
}
var valueParserMap = createHashMap({
  "number": function(val) {
    return parseFloat(val);
  },
  "time": function(val) {
    return +parseDate(val);
  },
  "trim": function(val) {
    return isString(val) ? trim$1(val) : val;
  }
});
function getRawValueParser(type4) {
  return valueParserMap.get(type4);
}
var ORDER_COMPARISON_OP_MAP = {
  lt: function(lval, rval) {
    return lval < rval;
  },
  lte: function(lval, rval) {
    return lval <= rval;
  },
  gt: function(lval, rval) {
    return lval > rval;
  },
  gte: function(lval, rval) {
    return lval >= rval;
  }
};
var FilterOrderComparator = function() {
  function FilterOrderComparator2(op, rval) {
    if (!isNumber(rval)) {
      var errMsg = "";
      throwError(errMsg);
    }
    this._opFn = ORDER_COMPARISON_OP_MAP[op];
    this._rvalFloat = numericToNumber(rval);
  }
  FilterOrderComparator2.prototype.evaluate = function(lval) {
    return isNumber(lval) ? this._opFn(lval, this._rvalFloat) : this._opFn(numericToNumber(lval), this._rvalFloat);
  };
  return FilterOrderComparator2;
}();
var SortOrderComparator = function() {
  function SortOrderComparator2(order, incomparable) {
    var isDesc = order === "desc";
    this._resultLT = isDesc ? 1 : -1;
    if (incomparable == null) {
      incomparable = isDesc ? "min" : "max";
    }
    this._incomparable = incomparable === "min" ? -Infinity : Infinity;
  }
  SortOrderComparator2.prototype.evaluate = function(lval, rval) {
    var lvalFloat = isNumber(lval) ? lval : numericToNumber(lval);
    var rvalFloat = isNumber(rval) ? rval : numericToNumber(rval);
    var lvalNotNumeric = isNaN(lvalFloat);
    var rvalNotNumeric = isNaN(rvalFloat);
    if (lvalNotNumeric) {
      lvalFloat = this._incomparable;
    }
    if (rvalNotNumeric) {
      rvalFloat = this._incomparable;
    }
    if (lvalNotNumeric && rvalNotNumeric) {
      var lvalIsStr = isString(lval);
      var rvalIsStr = isString(rval);
      if (lvalIsStr) {
        lvalFloat = rvalIsStr ? lval : 0;
      }
      if (rvalIsStr) {
        rvalFloat = lvalIsStr ? rval : 0;
      }
    }
    return lvalFloat < rvalFloat ? this._resultLT : lvalFloat > rvalFloat ? -this._resultLT : 0;
  };
  return SortOrderComparator2;
}();
var FilterEqualityComparator = function() {
  function FilterEqualityComparator2(isEq, rval) {
    this._rval = rval;
    this._isEQ = isEq;
    this._rvalTypeof = typeof rval;
    this._rvalFloat = numericToNumber(rval);
  }
  FilterEqualityComparator2.prototype.evaluate = function(lval) {
    var eqResult = lval === this._rval;
    if (!eqResult) {
      var lvalTypeof = typeof lval;
      if (lvalTypeof !== this._rvalTypeof && (lvalTypeof === "number" || this._rvalTypeof === "number")) {
        eqResult = numericToNumber(lval) === this._rvalFloat;
      }
    }
    return this._isEQ ? eqResult : !eqResult;
  };
  return FilterEqualityComparator2;
}();
function createFilterComparator(op, rval) {
  return op === "eq" || op === "ne" ? new FilterEqualityComparator(op === "eq", rval) : hasOwn(ORDER_COMPARISON_OP_MAP, op) ? new FilterOrderComparator(op, rval) : null;
}
var ExternalSource = function() {
  function ExternalSource2() {
  }
  ExternalSource2.prototype.getRawData = function() {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.getRawDataItem = function(dataIndex) {
    throw new Error("not supported");
  };
  ExternalSource2.prototype.cloneRawData = function() {
    return;
  };
  ExternalSource2.prototype.getDimensionInfo = function(dim) {
    return;
  };
  ExternalSource2.prototype.cloneAllDimensionInfo = function() {
    return;
  };
  ExternalSource2.prototype.count = function() {
    return;
  };
  ExternalSource2.prototype.retrieveValue = function(dataIndex, dimIndex) {
    return;
  };
  ExternalSource2.prototype.retrieveValueFromItem = function(dataItem, dimIndex) {
    return;
  };
  ExternalSource2.prototype.convertValue = function(rawVal, dimInfo) {
    return parseDataValue(rawVal, dimInfo);
  };
  return ExternalSource2;
}();
function createExternalSource(internalSource, externalTransform) {
  var extSource = new ExternalSource();
  var data = internalSource.data;
  var sourceFormat = extSource.sourceFormat = internalSource.sourceFormat;
  var sourceHeaderCount = internalSource.startIndex;
  var errMsg = "";
  if (internalSource.seriesLayoutBy !== SERIES_LAYOUT_BY_COLUMN) {
    throwError(errMsg);
  }
  var dimensions = [];
  var dimsByName = {};
  var dimsDef = internalSource.dimensionsDefine;
  if (dimsDef) {
    each$f(dimsDef, function(dimDef, idx) {
      var name = dimDef.name;
      var dimDefExt = {
        index: idx,
        name,
        displayName: dimDef.displayName
      };
      dimensions.push(dimDefExt);
      if (name != null) {
        var errMsg_1 = "";
        if (hasOwn(dimsByName, name)) {
          throwError(errMsg_1);
        }
        dimsByName[name] = dimDefExt;
      }
    });
  } else {
    for (var i = 0; i < internalSource.dimensionsDetectedCount || 0; i++) {
      dimensions.push({
        index: i
      });
    }
  }
  var rawItemGetter = getRawSourceItemGetter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  if (externalTransform.__isBuiltIn) {
    extSource.getRawDataItem = function(dataIndex) {
      return rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    };
    extSource.getRawData = bind$1(getRawData, null, internalSource);
  }
  extSource.cloneRawData = bind$1(cloneRawData, null, internalSource);
  var rawCounter = getRawSourceDataCounter(sourceFormat, SERIES_LAYOUT_BY_COLUMN);
  extSource.count = bind$1(rawCounter, null, data, sourceHeaderCount, dimensions);
  var rawValueGetter = getRawSourceValueGetter(sourceFormat);
  extSource.retrieveValue = function(dataIndex, dimIndex) {
    var rawItem = rawItemGetter(data, sourceHeaderCount, dimensions, dataIndex);
    return retrieveValueFromItem(rawItem, dimIndex);
  };
  var retrieveValueFromItem = extSource.retrieveValueFromItem = function(dataItem, dimIndex) {
    if (dataItem == null) {
      return;
    }
    var dimDef = dimensions[dimIndex];
    if (dimDef) {
      return rawValueGetter(dataItem, dimIndex, dimDef.name);
    }
  };
  extSource.getDimensionInfo = bind$1(getDimensionInfo, null, dimensions, dimsByName);
  extSource.cloneAllDimensionInfo = bind$1(cloneAllDimensionInfo, null, dimensions);
  return extSource;
}
function getRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  return upstream.data;
}
function cloneRawData(upstream) {
  var sourceFormat = upstream.sourceFormat;
  var data = upstream.data;
  if (!isSupportedSourceFormat(sourceFormat)) {
    var errMsg = "";
    throwError(errMsg);
  }
  if (sourceFormat === SOURCE_FORMAT_ARRAY_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(data[i].slice());
    }
    return result;
  } else if (sourceFormat === SOURCE_FORMAT_OBJECT_ROWS) {
    var result = [];
    for (var i = 0, len2 = data.length; i < len2; i++) {
      result.push(extend({}, data[i]));
    }
    return result;
  }
}
function getDimensionInfo(dimensions, dimsByName, dim) {
  if (dim == null) {
    return;
  }
  if (isNumber(dim) || !isNaN(dim) && !hasOwn(dimsByName, dim)) {
    return dimensions[dim];
  } else if (hasOwn(dimsByName, dim)) {
    return dimsByName[dim];
  }
}
function cloneAllDimensionInfo(dimensions) {
  return clone$4(dimensions);
}
var externalTransformMap = createHashMap();
function registerExternalTransform(externalTransform) {
  externalTransform = clone$4(externalTransform);
  var type4 = externalTransform.type;
  var errMsg = "";
  if (!type4) {
    throwError(errMsg);
  }
  var typeParsed = type4.split(":");
  if (typeParsed.length !== 2) {
    throwError(errMsg);
  }
  var isBuiltIn = false;
  if (typeParsed[0] === "echarts") {
    type4 = typeParsed[1];
    isBuiltIn = true;
  }
  externalTransform.__isBuiltIn = isBuiltIn;
  externalTransformMap.set(type4, externalTransform);
}
function applyDataTransform(rawTransOption, sourceList, infoForPrint) {
  var pipedTransOption = normalizeToArray(rawTransOption);
  var pipeLen = pipedTransOption.length;
  var errMsg = "";
  if (!pipeLen) {
    throwError(errMsg);
  }
  for (var i = 0, len2 = pipeLen; i < len2; i++) {
    var transOption = pipedTransOption[i];
    sourceList = applySingleDataTransform(transOption, sourceList);
    if (i !== len2 - 1) {
      sourceList.length = Math.max(sourceList.length, 1);
    }
  }
  return sourceList;
}
function applySingleDataTransform(transOption, upSourceList, infoForPrint, pipeIndex) {
  var errMsg = "";
  if (!upSourceList.length) {
    throwError(errMsg);
  }
  if (!isObject$4(transOption)) {
    throwError(errMsg);
  }
  var transType = transOption.type;
  var externalTransform = externalTransformMap.get(transType);
  if (!externalTransform) {
    throwError(errMsg);
  }
  var extUpSourceList = map$1(upSourceList, function(upSource) {
    return createExternalSource(upSource, externalTransform);
  });
  var resultList = normalizeToArray(externalTransform.transform({
    upstream: extUpSourceList[0],
    upstreamList: extUpSourceList,
    config: clone$4(transOption.config)
  }));
  return map$1(resultList, function(result, resultIndex) {
    var errMsg2 = "";
    if (!isObject$4(result)) {
      throwError(errMsg2);
    }
    if (!result.data) {
      throwError(errMsg2);
    }
    var sourceFormat = detectSourceFormat(result.data);
    if (!isSupportedSourceFormat(sourceFormat)) {
      throwError(errMsg2);
    }
    var resultMetaRawOption;
    var firstUpSource = upSourceList[0];
    if (firstUpSource && resultIndex === 0 && !result.dimensions) {
      var startIndex = firstUpSource.startIndex;
      if (startIndex) {
        result.data = firstUpSource.data.slice(0, startIndex).concat(result.data);
      }
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: startIndex,
        dimensions: firstUpSource.metaRawOption.dimensions
      };
    } else {
      resultMetaRawOption = {
        seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN,
        sourceHeader: 0,
        dimensions: result.dimensions
      };
    }
    return createSource(result.data, resultMetaRawOption, null);
  });
}
function isSupportedSourceFormat(sourceFormat) {
  return sourceFormat === SOURCE_FORMAT_ARRAY_ROWS || sourceFormat === SOURCE_FORMAT_OBJECT_ROWS;
}
var UNDEFINED = "undefined";
var CtorUint32Array = typeof Uint32Array === UNDEFINED ? Array : Uint32Array;
var CtorUint16Array = typeof Uint16Array === UNDEFINED ? Array : Uint16Array;
var CtorInt32Array$1 = typeof Int32Array === UNDEFINED ? Array : Int32Array;
var CtorFloat64Array = typeof Float64Array === UNDEFINED ? Array : Float64Array;
var dataCtors = {
  "float": CtorFloat64Array,
  "int": CtorInt32Array$1,
  "ordinal": Array,
  "number": Array,
  "time": CtorFloat64Array
};
var defaultDimValueGetters;
function getIndicesCtor(rawCount) {
  return rawCount > 65535 ? CtorUint32Array : CtorUint16Array;
}
function getInitialExtent() {
  return [Infinity, -Infinity];
}
function cloneChunk(originalChunk) {
  var Ctor = originalChunk.constructor;
  return Ctor === Array ? originalChunk.slice() : new Ctor(originalChunk);
}
function prepareStore(store, dimIdx, dimType, end2, append) {
  var DataCtor = dataCtors[dimType || "float"];
  if (append) {
    var oldStore = store[dimIdx];
    var oldLen = oldStore && oldStore.length;
    if (!(oldLen === end2)) {
      var newStore = new DataCtor(end2);
      for (var j = 0; j < oldLen; j++) {
        newStore[j] = oldStore[j];
      }
      store[dimIdx] = newStore;
    }
  } else {
    store[dimIdx] = new DataCtor(end2);
  }
}
var DataStore = function() {
  function DataStore2() {
    this._chunks = [];
    this._rawExtent = [];
    this._extent = [];
    this._count = 0;
    this._rawCount = 0;
    this._calcDimNameToIdx = createHashMap();
  }
  DataStore2.prototype.initData = function(provider, inputDimensions, dimValueGetter) {
    this._provider = provider;
    this._chunks = [];
    this._indices = null;
    this.getRawIndex = this._getRawIdxIdentity;
    var source = provider.getSource();
    var defaultGetter = this.defaultDimValueGetter = defaultDimValueGetters[source.sourceFormat];
    this._dimValueGetter = dimValueGetter || defaultGetter;
    this._rawExtent = [];
    shouldRetrieveDataByName(source);
    this._dimensions = map$1(inputDimensions, function(dim) {
      return {
        type: dim.type,
        property: dim.property
      };
    });
    this._initDataFromProvider(0, provider.count());
  };
  DataStore2.prototype.getProvider = function() {
    return this._provider;
  };
  DataStore2.prototype.getSource = function() {
    return this._provider.getSource();
  };
  DataStore2.prototype.ensureCalculationDimension = function(dimName, type4) {
    var calcDimNameToIdx = this._calcDimNameToIdx;
    var dimensions = this._dimensions;
    var calcDimIdx = calcDimNameToIdx.get(dimName);
    if (calcDimIdx != null) {
      if (dimensions[calcDimIdx].type === type4) {
        return calcDimIdx;
      }
    } else {
      calcDimIdx = dimensions.length;
    }
    dimensions[calcDimIdx] = {
      type: type4
    };
    calcDimNameToIdx.set(dimName, calcDimIdx);
    this._chunks[calcDimIdx] = new dataCtors[type4 || "float"](this._rawCount);
    this._rawExtent[calcDimIdx] = getInitialExtent();
    return calcDimIdx;
  };
  DataStore2.prototype.collectOrdinalMeta = function(dimIdx, ordinalMeta) {
    var chunk = this._chunks[dimIdx];
    var dim = this._dimensions[dimIdx];
    var rawExtents = this._rawExtent;
    var offset = dim.ordinalOffset || 0;
    var len2 = chunk.length;
    if (offset === 0) {
      rawExtents[dimIdx] = getInitialExtent();
    }
    var dimRawExtent = rawExtents[dimIdx];
    for (var i = offset; i < len2; i++) {
      var val = chunk[i] = ordinalMeta.parseAndCollect(chunk[i]);
      dimRawExtent[0] = Math.min(val, dimRawExtent[0]);
      dimRawExtent[1] = Math.max(val, dimRawExtent[1]);
    }
    dim.ordinalMeta = ordinalMeta;
    dim.ordinalOffset = len2;
    dim.type = "ordinal";
  };
  DataStore2.prototype.getOrdinalMeta = function(dimIdx) {
    var dimInfo = this._dimensions[dimIdx];
    var ordinalMeta = dimInfo.ordinalMeta;
    return ordinalMeta;
  };
  DataStore2.prototype.getDimensionProperty = function(dimIndex) {
    var item = this._dimensions[dimIndex];
    return item && item.property;
  };
  DataStore2.prototype.appendData = function(data) {
    var provider = this._provider;
    var start2 = this.count();
    provider.appendData(data);
    var end2 = provider.count();
    if (!provider.persistent) {
      end2 += start2;
    }
    if (start2 < end2) {
      this._initDataFromProvider(start2, end2, true);
    }
    return [start2, end2];
  };
  DataStore2.prototype.appendValues = function(values, minFillLen) {
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var start2 = this.count();
    var end2 = start2 + Math.max(values.length, minFillLen || 0);
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      prepareStore(chunks, i, dim.type, end2, true);
    }
    var emptyDataItem = [];
    for (var idx = start2; idx < end2; idx++) {
      var sourceIdx = idx - start2;
      for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
        var dim = dimensions[dimIdx];
        var val = defaultDimValueGetters.arrayRows.call(this, values[sourceIdx] || emptyDataItem, dim.property, sourceIdx, dimIdx);
        chunks[dimIdx][idx] = val;
        var dimRawExtent = rawExtent[dimIdx];
        val < dimRawExtent[0] && (dimRawExtent[0] = val);
        val > dimRawExtent[1] && (dimRawExtent[1] = val);
      }
    }
    this._rawCount = this._count = end2;
    return {
      start: start2,
      end: end2
    };
  };
  DataStore2.prototype._initDataFromProvider = function(start2, end2, append) {
    var provider = this._provider;
    var chunks = this._chunks;
    var dimensions = this._dimensions;
    var dimLen = dimensions.length;
    var rawExtent = this._rawExtent;
    var dimNames = map$1(dimensions, function(dim2) {
      return dim2.property;
    });
    for (var i = 0; i < dimLen; i++) {
      var dim = dimensions[i];
      if (!rawExtent[i]) {
        rawExtent[i] = getInitialExtent();
      }
      prepareStore(chunks, i, dim.type, end2, append);
    }
    if (provider.fillStorage) {
      provider.fillStorage(start2, end2, chunks, rawExtent);
    } else {
      var dataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        dataItem = provider.getItem(idx, dataItem);
        for (var dimIdx = 0; dimIdx < dimLen; dimIdx++) {
          var dimStorage = chunks[dimIdx];
          var val = this._dimValueGetter(dataItem, dimNames[dimIdx], idx, dimIdx);
          dimStorage[idx] = val;
          var dimRawExtent = rawExtent[dimIdx];
          val < dimRawExtent[0] && (dimRawExtent[0] = val);
          val > dimRawExtent[1] && (dimRawExtent[1] = val);
        }
      }
    }
    if (!provider.persistent && provider.clean) {
      provider.clean();
    }
    this._rawCount = this._count = end2;
    this._extent = [];
  };
  DataStore2.prototype.count = function() {
    return this._count;
  };
  DataStore2.prototype.get = function(dim, idx) {
    if (!(idx >= 0 && idx < this._count)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[this.getRawIndex(idx)] : NaN;
  };
  DataStore2.prototype.getValues = function(dimensions, idx) {
    var values = [];
    var dimArr = [];
    if (idx == null) {
      idx = dimensions;
      dimensions = [];
      for (var i = 0; i < this._dimensions.length; i++) {
        dimArr.push(i);
      }
    } else {
      dimArr = dimensions;
    }
    for (var i = 0, len2 = dimArr.length; i < len2; i++) {
      values.push(this.get(dimArr[i], idx));
    }
    return values;
  };
  DataStore2.prototype.getByRawIndex = function(dim, rawIdx) {
    if (!(rawIdx >= 0 && rawIdx < this._rawCount)) {
      return NaN;
    }
    var dimStore = this._chunks[dim];
    return dimStore ? dimStore[rawIdx] : NaN;
  };
  DataStore2.prototype.getSum = function(dim) {
    var dimData = this._chunks[dim];
    var sum2 = 0;
    if (dimData) {
      for (var i = 0, len2 = this.count(); i < len2; i++) {
        var value = this.get(dim, i);
        if (!isNaN(value)) {
          sum2 += value;
        }
      }
    }
    return sum2;
  };
  DataStore2.prototype.getMedian = function(dim) {
    var dimDataArray = [];
    this.each([dim], function(val) {
      if (!isNaN(val)) {
        dimDataArray.push(val);
      }
    });
    var sortedDimDataArray = dimDataArray.sort(function(a, b2) {
      return a - b2;
    });
    var len2 = this.count();
    return len2 === 0 ? 0 : len2 % 2 === 1 ? sortedDimDataArray[(len2 - 1) / 2] : (sortedDimDataArray[len2 / 2] + sortedDimDataArray[len2 / 2 - 1]) / 2;
  };
  DataStore2.prototype.indexOfRawIndex = function(rawIndex) {
    if (rawIndex >= this._rawCount || rawIndex < 0) {
      return -1;
    }
    if (!this._indices) {
      return rawIndex;
    }
    var indices = this._indices;
    var rawDataIndex = indices[rawIndex];
    if (rawDataIndex != null && rawDataIndex < this._count && rawDataIndex === rawIndex) {
      return rawIndex;
    }
    var left = 0;
    var right = this._count - 1;
    while (left <= right) {
      var mid = (left + right) / 2 | 0;
      if (indices[mid] < rawIndex) {
        left = mid + 1;
      } else if (indices[mid] > rawIndex) {
        right = mid - 1;
      } else {
        return mid;
      }
    }
    return -1;
  };
  DataStore2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    var chunks = this._chunks;
    var dimData = chunks[dim];
    var nearestIndices = [];
    if (!dimData) {
      return nearestIndices;
    }
    if (maxDistance == null) {
      maxDistance = Infinity;
    }
    var minDist = Infinity;
    var minDiff = -1;
    var nearestIndicesLen = 0;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var dataIndex = this.getRawIndex(i);
      var diff = value - dimData[dataIndex];
      var dist2 = Math.abs(diff);
      if (dist2 <= maxDistance) {
        if (dist2 < minDist || dist2 === minDist && diff >= 0 && minDiff < 0) {
          minDist = dist2;
          minDiff = diff;
          nearestIndicesLen = 0;
        }
        if (diff === minDiff) {
          nearestIndices[nearestIndicesLen++] = i;
        }
      }
    }
    nearestIndices.length = nearestIndicesLen;
    return nearestIndices;
  };
  DataStore2.prototype.getIndices = function() {
    var newIndices;
    var indices = this._indices;
    if (indices) {
      var Ctor = indices.constructor;
      var thisCount = this._count;
      if (Ctor === Array) {
        newIndices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          newIndices[i] = indices[i];
        }
      } else {
        newIndices = new Ctor(indices.buffer, 0, thisCount);
      }
    } else {
      var Ctor = getIndicesCtor(this._rawCount);
      newIndices = new Ctor(this.count());
      for (var i = 0; i < newIndices.length; i++) {
        newIndices[i] = i;
      }
    }
    return newIndices;
  };
  DataStore2.prototype.filter = function(dims, cb) {
    if (!this._count) {
      return this;
    }
    var newStore = this.clone();
    var count2 = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(count2);
    var value = [];
    var dimSize = dims.length;
    var offset = 0;
    var dim0 = dims[0];
    var chunks = newStore._chunks;
    for (var i = 0; i < count2; i++) {
      var keep = void 0;
      var rawIdx = newStore.getRawIndex(i);
      if (dimSize === 0) {
        keep = cb(i);
      } else if (dimSize === 1) {
        var val = chunks[dim0][rawIdx];
        keep = cb(val, i);
      } else {
        var k2 = 0;
        for (; k2 < dimSize; k2++) {
          value[k2] = chunks[dims[k2]][rawIdx];
        }
        value[k2] = i;
        keep = cb.apply(null, value);
      }
      if (keep) {
        newIndices[offset++] = rawIdx;
      }
    }
    if (offset < count2) {
      newStore._indices = newIndices;
    }
    newStore._count = offset;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.selectRange = function(range3) {
    var newStore = this.clone();
    var len2 = newStore._count;
    if (!len2) {
      return this;
    }
    var dims = keys(range3);
    var dimSize = dims.length;
    if (!dimSize) {
      return this;
    }
    var originalCount = newStore.count();
    var Ctor = getIndicesCtor(newStore._rawCount);
    var newIndices = new Ctor(originalCount);
    var offset = 0;
    var dim0 = dims[0];
    var min3 = range3[dim0][0];
    var max3 = range3[dim0][1];
    var storeArr = newStore._chunks;
    var quickFinished = false;
    if (!newStore._indices) {
      var idx = 0;
      if (dimSize === 1) {
        var dimStorage = storeArr[dims[0]];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      } else if (dimSize === 2) {
        var dimStorage = storeArr[dims[0]];
        var dimStorage2 = storeArr[dims[1]];
        var min22 = range3[dims[1]][0];
        var max22 = range3[dims[1]][1];
        for (var i = 0; i < len2; i++) {
          var val = dimStorage[i];
          var val2 = dimStorage2[i];
          if ((val >= min3 && val <= max3 || isNaN(val)) && (val2 >= min22 && val2 <= max22 || isNaN(val2))) {
            newIndices[offset++] = idx;
          }
          idx++;
        }
        quickFinished = true;
      }
    }
    if (!quickFinished) {
      if (dimSize === 1) {
        for (var i = 0; i < originalCount; i++) {
          var rawIndex = newStore.getRawIndex(i);
          var val = storeArr[dims[0]][rawIndex];
          if (val >= min3 && val <= max3 || isNaN(val)) {
            newIndices[offset++] = rawIndex;
          }
        }
      } else {
        for (var i = 0; i < originalCount; i++) {
          var keep = true;
          var rawIndex = newStore.getRawIndex(i);
          for (var k2 = 0; k2 < dimSize; k2++) {
            var dimk = dims[k2];
            var val = storeArr[dimk][rawIndex];
            if (val < range3[dimk][0] || val > range3[dimk][1]) {
              keep = false;
            }
          }
          if (keep) {
            newIndices[offset++] = newStore.getRawIndex(i);
          }
        }
      }
    }
    if (offset < originalCount) {
      newStore._indices = newIndices;
    }
    newStore._count = offset;
    newStore._extent = [];
    newStore._updateGetRawIdx();
    return newStore;
  };
  DataStore2.prototype.map = function(dims, cb) {
    var target = this.clone(dims);
    this._updateDims(target, dims, cb);
    return target;
  };
  DataStore2.prototype.modify = function(dims, cb) {
    this._updateDims(this, dims, cb);
  };
  DataStore2.prototype._updateDims = function(target, dims, cb) {
    var targetChunks = target._chunks;
    var tmpRetValue = [];
    var dimSize = dims.length;
    var dataCount = target.count();
    var values = [];
    var rawExtent = target._rawExtent;
    for (var i = 0; i < dims.length; i++) {
      rawExtent[dims[i]] = getInitialExtent();
    }
    for (var dataIndex = 0; dataIndex < dataCount; dataIndex++) {
      var rawIndex = target.getRawIndex(dataIndex);
      for (var k2 = 0; k2 < dimSize; k2++) {
        values[k2] = targetChunks[dims[k2]][rawIndex];
      }
      values[dimSize] = dataIndex;
      var retValue = cb && cb.apply(null, values);
      if (retValue != null) {
        if (typeof retValue !== "object") {
          tmpRetValue[0] = retValue;
          retValue = tmpRetValue;
        }
        for (var i = 0; i < retValue.length; i++) {
          var dim = dims[i];
          var val = retValue[i];
          var rawExtentOnDim = rawExtent[dim];
          var dimStore = targetChunks[dim];
          if (dimStore) {
            dimStore[rawIndex] = val;
          }
          if (val < rawExtentOnDim[0]) {
            rawExtentOnDim[0] = val;
          }
          if (val > rawExtentOnDim[1]) {
            rawExtentOnDim[1] = val;
          }
        }
      }
    }
  };
  DataStore2.prototype.lttbDownSample = function(valueDimension, rate) {
    var target = this.clone([valueDimension], true);
    var targetStorage = target._chunks;
    var dimStore = targetStorage[valueDimension];
    var len2 = this.count();
    var sampledIndex = 0;
    var frameSize = Math.floor(1 / rate);
    var currentRawIndex = this.getRawIndex(0);
    var maxArea;
    var area;
    var nextRawIndex;
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.min((Math.ceil(len2 / frameSize) + 2) * 2, len2));
    newIndices[sampledIndex++] = currentRawIndex;
    for (var i = 1; i < len2 - 1; i += frameSize) {
      var nextFrameStart = Math.min(i + frameSize, len2 - 1);
      var nextFrameEnd = Math.min(i + frameSize * 2, len2);
      var avgX = (nextFrameEnd + nextFrameStart) / 2;
      var avgY = 0;
      for (var idx = nextFrameStart; idx < nextFrameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          continue;
        }
        avgY += y2;
      }
      avgY /= nextFrameEnd - nextFrameStart;
      var frameStart = i;
      var frameEnd = Math.min(i + frameSize, len2);
      var pointAX = i - 1;
      var pointAY = dimStore[currentRawIndex];
      maxArea = -1;
      nextRawIndex = frameStart;
      var firstNaNIndex = -1;
      var countNaN = 0;
      for (var idx = frameStart; idx < frameEnd; idx++) {
        var rawIndex = this.getRawIndex(idx);
        var y2 = dimStore[rawIndex];
        if (isNaN(y2)) {
          countNaN++;
          if (firstNaNIndex < 0) {
            firstNaNIndex = rawIndex;
          }
          continue;
        }
        area = Math.abs((pointAX - avgX) * (y2 - pointAY) - (pointAX - idx) * (avgY - pointAY));
        if (area > maxArea) {
          maxArea = area;
          nextRawIndex = rawIndex;
        }
      }
      if (countNaN > 0 && countNaN < frameEnd - frameStart) {
        newIndices[sampledIndex++] = Math.min(firstNaNIndex, nextRawIndex);
        nextRawIndex = Math.max(firstNaNIndex, nextRawIndex);
      }
      newIndices[sampledIndex++] = nextRawIndex;
      currentRawIndex = nextRawIndex;
    }
    newIndices[sampledIndex++] = this.getRawIndex(len2 - 1);
    target._count = sampledIndex;
    target._indices = newIndices;
    target.getRawIndex = this._getRawIdx;
    return target;
  };
  DataStore2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var target = this.clone([dimension], true);
    var targetStorage = target._chunks;
    var frameValues = [];
    var frameSize = Math.floor(1 / rate);
    var dimStore = targetStorage[dimension];
    var len2 = this.count();
    var rawExtentOnDim = target._rawExtent[dimension] = getInitialExtent();
    var newIndices = new (getIndicesCtor(this._rawCount))(Math.ceil(len2 / frameSize));
    var offset = 0;
    for (var i = 0; i < len2; i += frameSize) {
      if (frameSize > len2 - i) {
        frameSize = len2 - i;
        frameValues.length = frameSize;
      }
      for (var k2 = 0; k2 < frameSize; k2++) {
        var dataIdx = this.getRawIndex(i + k2);
        frameValues[k2] = dimStore[dataIdx];
      }
      var value = sampleValue(frameValues);
      var sampleFrameIdx = this.getRawIndex(Math.min(i + sampleIndex(frameValues, value) || 0, len2 - 1));
      dimStore[sampleFrameIdx] = value;
      if (value < rawExtentOnDim[0]) {
        rawExtentOnDim[0] = value;
      }
      if (value > rawExtentOnDim[1]) {
        rawExtentOnDim[1] = value;
      }
      newIndices[offset++] = sampleFrameIdx;
    }
    target._count = offset;
    target._indices = newIndices;
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype.each = function(dims, cb) {
    if (!this._count) {
      return;
    }
    var dimSize = dims.length;
    var chunks = this._chunks;
    for (var i = 0, len2 = this.count(); i < len2; i++) {
      var rawIdx = this.getRawIndex(i);
      switch (dimSize) {
        case 0:
          cb(i);
          break;
        case 1:
          cb(chunks[dims[0]][rawIdx], i);
          break;
        case 2:
          cb(chunks[dims[0]][rawIdx], chunks[dims[1]][rawIdx], i);
          break;
        default:
          var k2 = 0;
          var value = [];
          for (; k2 < dimSize; k2++) {
            value[k2] = chunks[dims[k2]][rawIdx];
          }
          value[k2] = i;
          cb.apply(null, value);
      }
    }
  };
  DataStore2.prototype.getDataExtent = function(dim) {
    var dimData = this._chunks[dim];
    var initialExtent = getInitialExtent();
    if (!dimData) {
      return initialExtent;
    }
    var currEnd = this.count();
    var useRaw = !this._indices;
    var dimExtent;
    if (useRaw) {
      return this._rawExtent[dim].slice();
    }
    dimExtent = this._extent[dim];
    if (dimExtent) {
      return dimExtent.slice();
    }
    dimExtent = initialExtent;
    var min3 = dimExtent[0];
    var max3 = dimExtent[1];
    for (var i = 0; i < currEnd; i++) {
      var rawIdx = this.getRawIndex(i);
      var value = dimData[rawIdx];
      value < min3 && (min3 = value);
      value > max3 && (max3 = value);
    }
    dimExtent = [min3, max3];
    this._extent[dim] = dimExtent;
    return dimExtent;
  };
  DataStore2.prototype.getRawDataItem = function(idx) {
    var rawIdx = this.getRawIndex(idx);
    if (!this._provider.persistent) {
      var val = [];
      var chunks = this._chunks;
      for (var i = 0; i < chunks.length; i++) {
        val.push(chunks[i][rawIdx]);
      }
      return val;
    } else {
      return this._provider.getItem(rawIdx);
    }
  };
  DataStore2.prototype.clone = function(clonedDims, ignoreIndices) {
    var target = new DataStore2();
    var chunks = this._chunks;
    var clonedDimsMap = clonedDims && reduce(clonedDims, function(obj, dimIdx) {
      obj[dimIdx] = true;
      return obj;
    }, {});
    if (clonedDimsMap) {
      for (var i = 0; i < chunks.length; i++) {
        target._chunks[i] = !clonedDimsMap[i] ? chunks[i] : cloneChunk(chunks[i]);
      }
    } else {
      target._chunks = chunks;
    }
    this._copyCommonProps(target);
    if (!ignoreIndices) {
      target._indices = this._cloneIndices();
    }
    target._updateGetRawIdx();
    return target;
  };
  DataStore2.prototype._copyCommonProps = function(target) {
    target._count = this._count;
    target._rawCount = this._rawCount;
    target._provider = this._provider;
    target._dimensions = this._dimensions;
    target._extent = clone$4(this._extent);
    target._rawExtent = clone$4(this._rawExtent);
  };
  DataStore2.prototype._cloneIndices = function() {
    if (this._indices) {
      var Ctor = this._indices.constructor;
      var indices = void 0;
      if (Ctor === Array) {
        var thisCount = this._indices.length;
        indices = new Ctor(thisCount);
        for (var i = 0; i < thisCount; i++) {
          indices[i] = this._indices[i];
        }
      } else {
        indices = new Ctor(this._indices);
      }
      return indices;
    }
    return null;
  };
  DataStore2.prototype._getRawIdxIdentity = function(idx) {
    return idx;
  };
  DataStore2.prototype._getRawIdx = function(idx) {
    if (idx < this._count && idx >= 0) {
      return this._indices[idx];
    }
    return -1;
  };
  DataStore2.prototype._updateGetRawIdx = function() {
    this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
  };
  DataStore2.internalField = function() {
    function getDimValueSimply(dataItem, property, dataIndex, dimIndex) {
      return parseDataValue(dataItem[dimIndex], this._dimensions[dimIndex]);
    }
    defaultDimValueGetters = {
      arrayRows: getDimValueSimply,
      objectRows: function(dataItem, property, dataIndex, dimIndex) {
        return parseDataValue(dataItem[property], this._dimensions[dimIndex]);
      },
      keyedColumns: getDimValueSimply,
      original: function(dataItem, property, dataIndex, dimIndex) {
        var value = dataItem && (dataItem.value == null ? dataItem : dataItem.value);
        return parseDataValue(value instanceof Array ? value[dimIndex] : value, this._dimensions[dimIndex]);
      },
      typedArray: function(dataItem, property, dataIndex, dimIndex) {
        return dataItem[dimIndex];
      }
    };
  }();
  return DataStore2;
}();
var SourceManager = function() {
  function SourceManager2(sourceHost) {
    this._sourceList = [];
    this._storeList = [];
    this._upstreamSignList = [];
    this._versionSignBase = 0;
    this._dirty = true;
    this._sourceHost = sourceHost;
  }
  SourceManager2.prototype.dirty = function() {
    this._setLocalSource([], []);
    this._storeList = [];
    this._dirty = true;
  };
  SourceManager2.prototype._setLocalSource = function(sourceList, upstreamSignList) {
    this._sourceList = sourceList;
    this._upstreamSignList = upstreamSignList;
    this._versionSignBase++;
    if (this._versionSignBase > 9e10) {
      this._versionSignBase = 0;
    }
  };
  SourceManager2.prototype._getVersionSign = function() {
    return this._sourceHost.uid + "_" + this._versionSignBase;
  };
  SourceManager2.prototype.prepareSource = function() {
    if (this._isDirty()) {
      this._createSource();
      this._dirty = false;
    }
  };
  SourceManager2.prototype._createSource = function() {
    this._setLocalSource([], []);
    var sourceHost = this._sourceHost;
    var upSourceMgrList = this._getUpstreamSourceManagers();
    var hasUpstream = !!upSourceMgrList.length;
    var resultSourceList;
    var upstreamSignList;
    if (isSeries(sourceHost)) {
      var seriesModel = sourceHost;
      var data = void 0;
      var sourceFormat = void 0;
      var upSource = void 0;
      if (hasUpstream) {
        var upSourceMgr = upSourceMgrList[0];
        upSourceMgr.prepareSource();
        upSource = upSourceMgr.getSource();
        data = upSource.data;
        sourceFormat = upSource.sourceFormat;
        upstreamSignList = [upSourceMgr._getVersionSign()];
      } else {
        data = seriesModel.get("data", true);
        sourceFormat = isTypedArray(data) ? SOURCE_FORMAT_TYPED_ARRAY : SOURCE_FORMAT_ORIGINAL;
        upstreamSignList = [];
      }
      var newMetaRawOption = this._getSourceMetaRawOption() || {};
      var upMetaRawOption = upSource && upSource.metaRawOption || {};
      var seriesLayoutBy = retrieve2(newMetaRawOption.seriesLayoutBy, upMetaRawOption.seriesLayoutBy) || null;
      var sourceHeader = retrieve2(newMetaRawOption.sourceHeader, upMetaRawOption.sourceHeader);
      var dimensions = retrieve2(newMetaRawOption.dimensions, upMetaRawOption.dimensions);
      var needsCreateSource = seriesLayoutBy !== upMetaRawOption.seriesLayoutBy || !!sourceHeader !== !!upMetaRawOption.sourceHeader || dimensions;
      resultSourceList = needsCreateSource ? [createSource(data, {
        seriesLayoutBy,
        sourceHeader,
        dimensions
      }, sourceFormat)] : [];
    } else {
      var datasetModel = sourceHost;
      if (hasUpstream) {
        var result = this._applyTransform(upSourceMgrList);
        resultSourceList = result.sourceList;
        upstreamSignList = result.upstreamSignList;
      } else {
        var sourceData = datasetModel.get("source", true);
        resultSourceList = [createSource(sourceData, this._getSourceMetaRawOption(), null)];
        upstreamSignList = [];
      }
    }
    this._setLocalSource(resultSourceList, upstreamSignList);
  };
  SourceManager2.prototype._applyTransform = function(upMgrList) {
    var datasetModel = this._sourceHost;
    var transformOption = datasetModel.get("transform", true);
    var fromTransformResult = datasetModel.get("fromTransformResult", true);
    if (fromTransformResult != null) {
      var errMsg = "";
      if (upMgrList.length !== 1) {
        doThrow(errMsg);
      }
    }
    var sourceList;
    var upSourceList = [];
    var upstreamSignList = [];
    each$f(upMgrList, function(upMgr) {
      upMgr.prepareSource();
      var upSource = upMgr.getSource(fromTransformResult || 0);
      var errMsg2 = "";
      if (fromTransformResult != null && !upSource) {
        doThrow(errMsg2);
      }
      upSourceList.push(upSource);
      upstreamSignList.push(upMgr._getVersionSign());
    });
    if (transformOption) {
      sourceList = applyDataTransform(transformOption, upSourceList, {
        datasetIndex: datasetModel.componentIndex
      });
    } else if (fromTransformResult != null) {
      sourceList = [cloneSourceShallow(upSourceList[0])];
    }
    return {
      sourceList,
      upstreamSignList
    };
  };
  SourceManager2.prototype._isDirty = function() {
    if (this._dirty) {
      return true;
    }
    var upSourceMgrList = this._getUpstreamSourceManagers();
    for (var i = 0; i < upSourceMgrList.length; i++) {
      var upSrcMgr = upSourceMgrList[i];
      if (upSrcMgr._isDirty() || this._upstreamSignList[i] !== upSrcMgr._getVersionSign()) {
        return true;
      }
    }
  };
  SourceManager2.prototype.getSource = function(sourceIndex) {
    sourceIndex = sourceIndex || 0;
    var source = this._sourceList[sourceIndex];
    if (!source) {
      var upSourceMgrList = this._getUpstreamSourceManagers();
      return upSourceMgrList[0] && upSourceMgrList[0].getSource(sourceIndex);
    }
    return source;
  };
  SourceManager2.prototype.getSharedDataStore = function(seriesDimRequest) {
    var schema = seriesDimRequest.makeStoreSchema();
    return this._innerGetDataStore(schema.dimensions, seriesDimRequest.source, schema.hash);
  };
  SourceManager2.prototype._innerGetDataStore = function(storeDims, seriesSource, sourceReadKey) {
    var sourceIndex = 0;
    var storeList = this._storeList;
    var cachedStoreMap = storeList[sourceIndex];
    if (!cachedStoreMap) {
      cachedStoreMap = storeList[sourceIndex] = {};
    }
    var cachedStore = cachedStoreMap[sourceReadKey];
    if (!cachedStore) {
      var upSourceMgr = this._getUpstreamSourceManagers()[0];
      if (isSeries(this._sourceHost) && upSourceMgr) {
        cachedStore = upSourceMgr._innerGetDataStore(storeDims, seriesSource, sourceReadKey);
      } else {
        cachedStore = new DataStore();
        cachedStore.initData(new DefaultDataProvider(seriesSource, storeDims.length), storeDims);
      }
      cachedStoreMap[sourceReadKey] = cachedStore;
    }
    return cachedStore;
  };
  SourceManager2.prototype._getUpstreamSourceManagers = function() {
    var sourceHost = this._sourceHost;
    if (isSeries(sourceHost)) {
      var datasetModel = querySeriesUpstreamDatasetModel(sourceHost);
      return !datasetModel ? [] : [datasetModel.getSourceManager()];
    } else {
      return map$1(queryDatasetUpstreamDatasetModels(sourceHost), function(datasetModel2) {
        return datasetModel2.getSourceManager();
      });
    }
  };
  SourceManager2.prototype._getSourceMetaRawOption = function() {
    var sourceHost = this._sourceHost;
    var seriesLayoutBy;
    var sourceHeader;
    var dimensions;
    if (isSeries(sourceHost)) {
      seriesLayoutBy = sourceHost.get("seriesLayoutBy", true);
      sourceHeader = sourceHost.get("sourceHeader", true);
      dimensions = sourceHost.get("dimensions", true);
    } else if (!this._getUpstreamSourceManagers().length) {
      var model = sourceHost;
      seriesLayoutBy = model.get("seriesLayoutBy", true);
      sourceHeader = model.get("sourceHeader", true);
      dimensions = model.get("dimensions", true);
    }
    return {
      seriesLayoutBy,
      sourceHeader,
      dimensions
    };
  };
  return SourceManager2;
}();
function disableTransformOptionMerge(datasetModel) {
  var transformOption = datasetModel.option.transform;
  transformOption && setAsPrimitive(datasetModel.option.transform);
}
function isSeries(sourceHost) {
  return sourceHost.mainType === "series";
}
function doThrow(errMsg) {
  throw new Error(errMsg);
}
var TOOLTIP_LINE_HEIGHT_CSS = "line-height:1";
function getTooltipTextStyle(textStyle, renderMode) {
  var nameFontColor = textStyle.color || "#6e7079";
  var nameFontSize = textStyle.fontSize || 12;
  var nameFontWeight = textStyle.fontWeight || "400";
  var valueFontColor = textStyle.color || "#464646";
  var valueFontSize = textStyle.fontSize || 14;
  var valueFontWeight = textStyle.fontWeight || "900";
  if (renderMode === "html") {
    return {
      nameStyle: "font-size:" + encodeHTML(nameFontSize + "") + "px;color:" + encodeHTML(nameFontColor) + ";font-weight:" + encodeHTML(nameFontWeight + ""),
      valueStyle: "font-size:" + encodeHTML(valueFontSize + "") + "px;color:" + encodeHTML(valueFontColor) + ";font-weight:" + encodeHTML(valueFontWeight + "")
    };
  } else {
    return {
      nameStyle: {
        fontSize: nameFontSize,
        fill: nameFontColor,
        fontWeight: nameFontWeight
      },
      valueStyle: {
        fontSize: valueFontSize,
        fill: valueFontColor,
        fontWeight: valueFontWeight
      }
    };
  }
}
var HTML_GAPS = [0, 10, 20, 30];
var RICH_TEXT_GAPS = ["", "\n", "\n\n", "\n\n\n"];
function createTooltipMarkup(type4, option) {
  option.type = type4;
  return option;
}
function isSectionFragment(frag) {
  return frag.type === "section";
}
function getBuilder(frag) {
  return isSectionFragment(frag) ? buildSection : buildNameValue;
}
function getBlockGapLevel(frag) {
  if (isSectionFragment(frag)) {
    var gapLevel_1 = 0;
    var subBlockLen = frag.blocks.length;
    var hasInnerGap_1 = subBlockLen > 1 || subBlockLen > 0 && !frag.noHeader;
    each$f(frag.blocks, function(subBlock) {
      var subGapLevel = getBlockGapLevel(subBlock);
      if (subGapLevel >= gapLevel_1) {
        gapLevel_1 = subGapLevel + +(hasInnerGap_1 && (!subGapLevel || isSectionFragment(subBlock) && !subBlock.noHeader));
      }
    });
    return gapLevel_1;
  }
  return 0;
}
function buildSection(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var noHeader = fragment.noHeader;
  var gaps = getGap(getBlockGapLevel(fragment));
  var subMarkupTextList = [];
  var subBlocks = fragment.blocks || [];
  assert(!subBlocks || isArray$1(subBlocks));
  subBlocks = subBlocks || [];
  var orderMode = ctx.orderMode;
  if (fragment.sortBlocks && orderMode) {
    subBlocks = subBlocks.slice();
    var orderMap = {
      valueAsc: "asc",
      valueDesc: "desc"
    };
    if (hasOwn(orderMap, orderMode)) {
      var comparator_1 = new SortOrderComparator(orderMap[orderMode], null);
      subBlocks.sort(function(a, b2) {
        return comparator_1.evaluate(a.sortParam, b2.sortParam);
      });
    } else if (orderMode === "seriesDesc") {
      subBlocks.reverse();
    }
  }
  each$f(subBlocks, function(subBlock, idx) {
    var valueFormatter = fragment.valueFormatter;
    var subMarkupText2 = getBuilder(subBlock)(valueFormatter ? extend(extend({}, ctx), {
      valueFormatter
    }) : ctx, subBlock, idx > 0 ? gaps.html : 0, toolTipTextStyle);
    subMarkupText2 != null && subMarkupTextList.push(subMarkupText2);
  });
  var subMarkupText = ctx.renderMode === "richText" ? subMarkupTextList.join(gaps.richText) : wrapBlockHTML(subMarkupTextList.join(""), noHeader ? topMarginForOuterGap : gaps.html);
  if (noHeader) {
    return subMarkupText;
  }
  var displayableHeader = makeValueReadable(fragment.header, "ordinal", ctx.useUTC);
  var nameStyle = getTooltipTextStyle(toolTipTextStyle, ctx.renderMode).nameStyle;
  if (ctx.renderMode === "richText") {
    return wrapInlineNameRichText(ctx, displayableHeader, nameStyle) + gaps.richText + subMarkupText;
  } else {
    return wrapBlockHTML('<div style="' + nameStyle + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodeHTML(displayableHeader) + "</div>" + subMarkupText, topMarginForOuterGap);
  }
}
function buildNameValue(ctx, fragment, topMarginForOuterGap, toolTipTextStyle) {
  var renderMode = ctx.renderMode;
  var noName = fragment.noName;
  var noValue = fragment.noValue;
  var noMarker = !fragment.markerType;
  var name = fragment.name;
  var useUTC = ctx.useUTC;
  var valueFormatter = fragment.valueFormatter || ctx.valueFormatter || function(value) {
    value = isArray$1(value) ? value : [value];
    return map$1(value, function(val, idx) {
      return makeValueReadable(val, isArray$1(valueTypeOption) ? valueTypeOption[idx] : valueTypeOption, useUTC);
    });
  };
  if (noName && noValue) {
    return;
  }
  var markerStr = noMarker ? "" : ctx.markupStyleCreator.makeTooltipMarker(fragment.markerType, fragment.markerColor || "#333", renderMode);
  var readableName = noName ? "" : makeValueReadable(name, "ordinal", useUTC);
  var valueTypeOption = fragment.valueType;
  var readableValueList = noValue ? [] : valueFormatter(fragment.value);
  var valueAlignRight = !noMarker || !noName;
  var valueCloseToMarker = !noMarker && noName;
  var _a2 = getTooltipTextStyle(toolTipTextStyle, renderMode), nameStyle = _a2.nameStyle, valueStyle = _a2.valueStyle;
  return renderMode === "richText" ? (noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameRichText(ctx, readableName, nameStyle)) + (noValue ? "" : wrapInlineValueRichText(ctx, readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)) : wrapBlockHTML((noMarker ? "" : markerStr) + (noName ? "" : wrapInlineNameHTML(readableName, !noMarker, nameStyle)) + (noValue ? "" : wrapInlineValueHTML(readableValueList, valueAlignRight, valueCloseToMarker, valueStyle)), topMarginForOuterGap);
}
function buildTooltipMarkup(fragment, markupStyleCreator, renderMode, orderMode, useUTC, toolTipTextStyle) {
  if (!fragment) {
    return;
  }
  var builder = getBuilder(fragment);
  var ctx = {
    useUTC,
    renderMode,
    orderMode,
    markupStyleCreator,
    valueFormatter: fragment.valueFormatter
  };
  return builder(ctx, fragment, 0, toolTipTextStyle);
}
function getGap(gapLevel) {
  return {
    html: HTML_GAPS[gapLevel],
    richText: RICH_TEXT_GAPS[gapLevel]
  };
}
function wrapBlockHTML(encodedContent, topGap) {
  var clearfix = '<div style="clear:both"></div>';
  var marginCSS = "margin: " + topGap + "px 0 0";
  return '<div style="' + marginCSS + ";" + TOOLTIP_LINE_HEIGHT_CSS + ';">' + encodedContent + clearfix + "</div>";
}
function wrapInlineNameHTML(name, leftHasMarker, style) {
  var marginCss = leftHasMarker ? "margin-left:2px" : "";
  return '<span style="' + style + ";" + marginCss + '">' + encodeHTML(name) + "</span>";
}
function wrapInlineValueHTML(valueList, alignRight, valueCloseToMarker, style) {
  var paddingStr = valueCloseToMarker ? "10px" : "20px";
  var alignCSS = alignRight ? "float:right;margin-left:" + paddingStr : "";
  valueList = isArray$1(valueList) ? valueList : [valueList];
  return '<span style="' + alignCSS + ";" + style + '">' + map$1(valueList, function(value) {
    return encodeHTML(value);
  }).join("&nbsp;&nbsp;") + "</span>";
}
function wrapInlineNameRichText(ctx, name, style) {
  return ctx.markupStyleCreator.wrapRichTextStyle(name, style);
}
function wrapInlineValueRichText(ctx, values, alignRight, valueCloseToMarker, style) {
  var styles2 = [style];
  var paddingLeft = valueCloseToMarker ? 10 : 20;
  alignRight && styles2.push({
    padding: [0, 0, 0, paddingLeft],
    align: "right"
  });
  return ctx.markupStyleCreator.wrapRichTextStyle(isArray$1(values) ? values.join("  ") : values, styles2);
}
function retrieveVisualColorForTooltipMarker(series, dataIndex) {
  var style = series.getData().getItemVisual(dataIndex, "style");
  var color = style[series.visualDrawType];
  return convertToColorString(color);
}
function getPaddingFromTooltipModel(model, renderMode) {
  var padding = model.get("padding");
  return padding != null ? padding : renderMode === "richText" ? [8, 10] : 10;
}
var TooltipMarkupStyleCreator = function() {
  function TooltipMarkupStyleCreator2() {
    this.richTextStyles = {};
    this._nextStyleNameId = getRandomIdBase();
  }
  TooltipMarkupStyleCreator2.prototype._generateStyleName = function() {
    return "__EC_aUTo_" + this._nextStyleNameId++;
  };
  TooltipMarkupStyleCreator2.prototype.makeTooltipMarker = function(markerType, colorStr, renderMode) {
    var markerId = renderMode === "richText" ? this._generateStyleName() : null;
    var marker = getTooltipMarker({
      color: colorStr,
      type: markerType,
      renderMode,
      markerId
    });
    if (isString(marker)) {
      return marker;
    } else {
      this.richTextStyles[markerId] = marker.style;
      return marker.content;
    }
  };
  TooltipMarkupStyleCreator2.prototype.wrapRichTextStyle = function(text, styles2) {
    var finalStl = {};
    if (isArray$1(styles2)) {
      each$f(styles2, function(stl) {
        return extend(finalStl, stl);
      });
    } else {
      extend(finalStl, styles2);
    }
    var styleName = this._generateStyleName();
    this.richTextStyles[styleName] = finalStl;
    return "{" + styleName + "|" + text + "}";
  };
  return TooltipMarkupStyleCreator2;
}();
function defaultSeriesFormatTooltip(opt) {
  var series = opt.series;
  var dataIndex = opt.dataIndex;
  var multipleSeries = opt.multipleSeries;
  var data = series.getData();
  var tooltipDims = data.mapDimensionsAll("defaultedTooltip");
  var tooltipDimLen = tooltipDims.length;
  var value = series.getRawValue(dataIndex);
  var isValueArr = isArray$1(value);
  var markerColor = retrieveVisualColorForTooltipMarker(series, dataIndex);
  var inlineValue;
  var inlineValueType;
  var subBlocks;
  var sortParam;
  if (tooltipDimLen > 1 || isValueArr && !tooltipDimLen) {
    var formatArrResult = formatTooltipArrayValue(value, series, dataIndex, tooltipDims, markerColor);
    inlineValue = formatArrResult.inlineValues;
    inlineValueType = formatArrResult.inlineValueTypes;
    subBlocks = formatArrResult.blocks;
    sortParam = formatArrResult.inlineValues[0];
  } else if (tooltipDimLen) {
    var dimInfo = data.getDimensionInfo(tooltipDims[0]);
    sortParam = inlineValue = retrieveRawValue(data, dataIndex, tooltipDims[0]);
    inlineValueType = dimInfo.type;
  } else {
    sortParam = inlineValue = isValueArr ? value[0] : value;
  }
  var seriesNameSpecified = isNameSpecified(series);
  var seriesName = seriesNameSpecified && series.name || "";
  var itemName = data.getName(dataIndex);
  var inlineName = multipleSeries ? seriesName : itemName;
  return createTooltipMarkup("section", {
    header: seriesName,
    noHeader: multipleSeries || !seriesNameSpecified,
    sortParam,
    blocks: [createTooltipMarkup("nameValue", {
      markerType: "item",
      markerColor,
      name: inlineName,
      noName: !trim$1(inlineName),
      value: inlineValue,
      valueType: inlineValueType
    })].concat(subBlocks || [])
  });
}
function formatTooltipArrayValue(value, series, dataIndex, tooltipDims, colorStr) {
  var data = series.getData();
  var isValueMultipleLine = reduce(value, function(isValueMultipleLine2, val, idx) {
    var dimItem = data.getDimensionInfo(idx);
    return isValueMultipleLine2 = isValueMultipleLine2 || dimItem && dimItem.tooltip !== false && dimItem.displayName != null;
  }, false);
  var inlineValues = [];
  var inlineValueTypes = [];
  var blocks = [];
  tooltipDims.length ? each$f(tooltipDims, function(dim) {
    setEachItem(retrieveRawValue(data, dataIndex, dim), dim);
  }) : each$f(value, setEachItem);
  function setEachItem(val, dim) {
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo || dimInfo.otherDims.tooltip === false) {
      return;
    }
    if (isValueMultipleLine) {
      blocks.push(createTooltipMarkup("nameValue", {
        markerType: "subItem",
        markerColor: colorStr,
        name: dimInfo.displayName,
        value: val,
        valueType: dimInfo.type
      }));
    } else {
      inlineValues.push(val);
      inlineValueTypes.push(dimInfo.type);
    }
  }
  return {
    inlineValues,
    inlineValueTypes,
    blocks
  };
}
var inner$k = makeInner();
function getSelectionKey(data, dataIndex) {
  return data.getName(dataIndex) || data.getId(dataIndex);
}
var SERIES_UNIVERSAL_TRANSITION_PROP = "__universalTransitionEnabled";
var SeriesModel = function(_super) {
  __extends(SeriesModel2, _super);
  function SeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._selectedDataIndicesMap = {};
    return _this;
  }
  SeriesModel2.prototype.init = function(option, parentModel, ecModel) {
    this.seriesIndex = this.componentIndex;
    this.dataTask = createTask({
      count: dataTaskCount,
      reset: dataTaskReset
    });
    this.dataTask.context = {
      model: this
    };
    this.mergeDefaultAndTheme(option, ecModel);
    var sourceManager = inner$k(this).sourceManager = new SourceManager(this);
    sourceManager.prepareSource();
    var data = this.getInitialData(option, ecModel);
    wrapData(data, this);
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
    var layoutMode = fetchLayoutMode(this);
    var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
    var themeSubType = this.subType;
    if (ComponentModel$1.hasClass(themeSubType)) {
      themeSubType += "Series";
    }
    merge(option, ecModel.getTheme().get(this.subType));
    merge(option, this.getDefaultOption());
    defaultEmphasis(option, "label", ["show"]);
    this.fillDataTextStyle(option.data);
    if (layoutMode) {
      mergeLayoutParam(option, inputPositionParams, layoutMode);
    }
  };
  SeriesModel2.prototype.mergeOption = function(newSeriesOption, ecModel) {
    newSeriesOption = merge(this.option, newSeriesOption, true);
    this.fillDataTextStyle(newSeriesOption.data);
    var layoutMode = fetchLayoutMode(this);
    if (layoutMode) {
      mergeLayoutParam(this.option, newSeriesOption, layoutMode);
    }
    var sourceManager = inner$k(this).sourceManager;
    sourceManager.dirty();
    sourceManager.prepareSource();
    var data = this.getInitialData(newSeriesOption, ecModel);
    wrapData(data, this);
    this.dataTask.dirty();
    this.dataTask.context.data = data;
    inner$k(this).dataBeforeProcessed = data;
    autoSeriesName(this);
    this._initSelectedMapFromData(data);
  };
  SeriesModel2.prototype.fillDataTextStyle = function(data) {
    if (data && !isTypedArray(data)) {
      var props = ["show"];
      for (var i = 0; i < data.length; i++) {
        if (data[i] && data[i].label) {
          defaultEmphasis(data[i], "label", props);
        }
      }
    }
  };
  SeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return;
  };
  SeriesModel2.prototype.appendData = function(params) {
    var data = this.getRawData();
    data.appendData(params.data);
  };
  SeriesModel2.prototype.getData = function(dataType) {
    var task = getCurrentTask(this);
    if (task) {
      var data = task.context.data;
      return dataType == null ? data : data.getLinkedData(dataType);
    } else {
      return inner$k(this).data;
    }
  };
  SeriesModel2.prototype.getAllData = function() {
    var mainData = this.getData();
    return mainData && mainData.getLinkedDataAll ? mainData.getLinkedDataAll() : [{
      data: mainData
    }];
  };
  SeriesModel2.prototype.setData = function(data) {
    var task = getCurrentTask(this);
    if (task) {
      var context = task.context;
      context.outputData = data;
      if (task !== this.dataTask) {
        context.data = data;
      }
    }
    inner$k(this).data = data;
  };
  SeriesModel2.prototype.getEncode = function() {
    var encode = this.get("encode", true);
    if (encode) {
      return createHashMap(encode);
    }
  };
  SeriesModel2.prototype.getSourceManager = function() {
    return inner$k(this).sourceManager;
  };
  SeriesModel2.prototype.getSource = function() {
    return this.getSourceManager().getSource();
  };
  SeriesModel2.prototype.getRawData = function() {
    return inner$k(this).dataBeforeProcessed;
  };
  SeriesModel2.prototype.getColorBy = function() {
    var colorBy = this.get("colorBy");
    return colorBy || "series";
  };
  SeriesModel2.prototype.isColorBySeries = function() {
    return this.getColorBy() === "series";
  };
  SeriesModel2.prototype.getBaseAxis = function() {
    var coordSys = this.coordinateSystem;
    return coordSys && coordSys.getBaseAxis && coordSys.getBaseAxis();
  };
  SeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    return defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
  };
  SeriesModel2.prototype.isAnimationEnabled = function() {
    var ecModel = this.ecModel;
    if (env$1.node && !(ecModel && ecModel.ssr)) {
      return false;
    }
    var animationEnabled = this.getShallow("animation");
    if (animationEnabled) {
      if (this.getData().count() > this.getShallow("animationThreshold")) {
        animationEnabled = false;
      }
    }
    return !!animationEnabled;
  };
  SeriesModel2.prototype.restoreData = function() {
    this.dataTask.dirty();
  };
  SeriesModel2.prototype.getColorFromPalette = function(name, scope, requestColorNum) {
    var ecModel = this.ecModel;
    var color = PaletteMixin.prototype.getColorFromPalette.call(this, name, scope, requestColorNum);
    if (!color) {
      color = ecModel.getColorFromPalette(name, scope, requestColorNum);
    }
    return color;
  };
  SeriesModel2.prototype.coordDimToDataDim = function(coordDim) {
    return this.getRawData().mapDimensionsAll(coordDim);
  };
  SeriesModel2.prototype.getProgressive = function() {
    return this.get("progressive");
  };
  SeriesModel2.prototype.getProgressiveThreshold = function() {
    return this.get("progressiveThreshold");
  };
  SeriesModel2.prototype.select = function(innerDataIndices, dataType) {
    this._innerSelect(this.getData(dataType), innerDataIndices);
  };
  SeriesModel2.prototype.unselect = function(innerDataIndices, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return;
    }
    var selectedMode = this.option.selectedMode;
    var data = this.getData(dataType);
    if (selectedMode === "series" || selectedMap === "all") {
      this.option.selectedMap = {};
      this._selectedDataIndicesMap = {};
      return;
    }
    for (var i = 0; i < innerDataIndices.length; i++) {
      var dataIndex = innerDataIndices[i];
      var nameOrId = getSelectionKey(data, dataIndex);
      selectedMap[nameOrId] = false;
      this._selectedDataIndicesMap[nameOrId] = -1;
    }
  };
  SeriesModel2.prototype.toggleSelect = function(innerDataIndices, dataType) {
    var tmpArr2 = [];
    for (var i = 0; i < innerDataIndices.length; i++) {
      tmpArr2[0] = innerDataIndices[i];
      this.isSelected(innerDataIndices[i], dataType) ? this.unselect(tmpArr2, dataType) : this.select(tmpArr2, dataType);
    }
  };
  SeriesModel2.prototype.getSelectedDataIndices = function() {
    if (this.option.selectedMap === "all") {
      return [].slice.call(this.getData().getIndices());
    }
    var selectedDataIndicesMap = this._selectedDataIndicesMap;
    var nameOrIds = keys(selectedDataIndicesMap);
    var dataIndices = [];
    for (var i = 0; i < nameOrIds.length; i++) {
      var dataIndex = selectedDataIndicesMap[nameOrIds[i]];
      if (dataIndex >= 0) {
        dataIndices.push(dataIndex);
      }
    }
    return dataIndices;
  };
  SeriesModel2.prototype.isSelected = function(dataIndex, dataType) {
    var selectedMap = this.option.selectedMap;
    if (!selectedMap) {
      return false;
    }
    var data = this.getData(dataType);
    return (selectedMap === "all" || selectedMap[getSelectionKey(data, dataIndex)]) && !data.getItemModel(dataIndex).get(["select", "disabled"]);
  };
  SeriesModel2.prototype.isUniversalTransitionEnabled = function() {
    if (this[SERIES_UNIVERSAL_TRANSITION_PROP]) {
      return true;
    }
    var universalTransitionOpt = this.option.universalTransition;
    if (!universalTransitionOpt) {
      return false;
    }
    if (universalTransitionOpt === true) {
      return true;
    }
    return universalTransitionOpt && universalTransitionOpt.enabled;
  };
  SeriesModel2.prototype._innerSelect = function(data, innerDataIndices) {
    var _a2, _b2;
    var option = this.option;
    var selectedMode = option.selectedMode;
    var len2 = innerDataIndices.length;
    if (!selectedMode || !len2) {
      return;
    }
    if (selectedMode === "series") {
      option.selectedMap = "all";
    } else if (selectedMode === "multiple") {
      if (!isObject$4(option.selectedMap)) {
        option.selectedMap = {};
      }
      var selectedMap = option.selectedMap;
      for (var i = 0; i < len2; i++) {
        var dataIndex = innerDataIndices[i];
        var nameOrId = getSelectionKey(data, dataIndex);
        selectedMap[nameOrId] = true;
        this._selectedDataIndicesMap[nameOrId] = data.getRawIndex(dataIndex);
      }
    } else if (selectedMode === "single" || selectedMode === true) {
      var lastDataIndex = innerDataIndices[len2 - 1];
      var nameOrId = getSelectionKey(data, lastDataIndex);
      option.selectedMap = (_a2 = {}, _a2[nameOrId] = true, _a2);
      this._selectedDataIndicesMap = (_b2 = {}, _b2[nameOrId] = data.getRawIndex(lastDataIndex), _b2);
    }
  };
  SeriesModel2.prototype._initSelectedMapFromData = function(data) {
    if (this.option.selectedMap) {
      return;
    }
    var dataIndices = [];
    if (data.hasItemOption) {
      data.each(function(idx) {
        var rawItem = data.getRawDataItem(idx);
        if (rawItem && rawItem.selected) {
          dataIndices.push(idx);
        }
      });
    }
    if (dataIndices.length > 0) {
      this._innerSelect(data, dataIndices);
    }
  };
  SeriesModel2.registerClass = function(clz) {
    return ComponentModel$1.registerClass(clz);
  };
  SeriesModel2.protoInitialize = function() {
    var proto2 = SeriesModel2.prototype;
    proto2.type = "series.__base__";
    proto2.seriesIndex = 0;
    proto2.ignoreStyleOnData = false;
    proto2.hasSymbolVisual = false;
    proto2.defaultSymbol = "circle";
    proto2.visualStyleAccessPath = "itemStyle";
    proto2.visualDrawType = "fill";
  }();
  return SeriesModel2;
}(ComponentModel$1);
mixin(SeriesModel, DataFormatMixin);
mixin(SeriesModel, PaletteMixin);
mountExtend(SeriesModel, ComponentModel$1);
function autoSeriesName(seriesModel) {
  var name = seriesModel.name;
  if (!isNameSpecified(seriesModel)) {
    seriesModel.name = getSeriesAutoName(seriesModel) || name;
  }
}
function getSeriesAutoName(seriesModel) {
  var data = seriesModel.getRawData();
  var dataDims = data.mapDimensionsAll("seriesName");
  var nameArr = [];
  each$f(dataDims, function(dataDim) {
    var dimInfo = data.getDimensionInfo(dataDim);
    dimInfo.displayName && nameArr.push(dimInfo.displayName);
  });
  return nameArr.join(" ");
}
function dataTaskCount(context) {
  return context.model.getRawData().count();
}
function dataTaskReset(context) {
  var seriesModel = context.model;
  seriesModel.setData(seriesModel.getRawData().cloneShallow());
  return dataTaskProgress;
}
function dataTaskProgress(param, context) {
  if (context.outputData && param.end > context.outputData.count()) {
    context.model.getRawData().cloneShallow(context.outputData);
  }
}
function wrapData(data, seriesModel) {
  each$f(concatArray(data.CHANGABLE_METHODS, data.DOWNSAMPLE_METHODS), function(methodName) {
    data.wrapMethod(methodName, curry$1(onDataChange, seriesModel));
  });
}
function onDataChange(seriesModel, newList) {
  var task = getCurrentTask(seriesModel);
  if (task) {
    task.setOutputEnd((newList || this).count());
  }
  return newList;
}
function getCurrentTask(seriesModel) {
  var scheduler = (seriesModel.ecModel || {}).scheduler;
  var pipeline = scheduler && scheduler.getPipeline(seriesModel.uid);
  if (pipeline) {
    var task = pipeline.currentTask;
    if (task) {
      var agentStubMap = task.agentStubMap;
      if (agentStubMap) {
        task = agentStubMap.get(seriesModel.uid);
      }
    }
    return task;
  }
}
var SeriesModel$1 = SeriesModel;
var ComponentView = function() {
  function ComponentView2() {
    this.group = new Group$4();
    this.uid = getUID("viewComponent");
  }
  ComponentView2.prototype.init = function(ecModel, api) {
  };
  ComponentView2.prototype.render = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.dispose = function(ecModel, api) {
  };
  ComponentView2.prototype.updateView = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateLayout = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.updateVisual = function(model, ecModel, api, payload) {
  };
  ComponentView2.prototype.blurSeries = function(seriesModels, ecModel) {
  };
  ComponentView2.prototype.eachRendered = function(cb) {
    var group = this.group;
    if (group) {
      group.traverse(cb);
    }
  };
  return ComponentView2;
}();
enableClassExtend(ComponentView);
enableClassManagement(ComponentView);
var ComponentView$1 = ComponentView;
function createRenderPlanner() {
  var inner2 = makeInner();
  return function(seriesModel) {
    var fields = inner2(seriesModel);
    var pipelineContext = seriesModel.pipelineContext;
    var originalLarge = !!fields.large;
    var originalProgressive = !!fields.progressiveRender;
    var large = fields.large = !!(pipelineContext && pipelineContext.large);
    var progressive = fields.progressiveRender = !!(pipelineContext && pipelineContext.progressiveRender);
    return !!(originalLarge !== large || originalProgressive !== progressive) && "reset";
  };
}
var inner$j = makeInner();
var renderPlanner = createRenderPlanner();
var ChartView = function() {
  function ChartView2() {
    this.group = new Group$4();
    this.uid = getUID("viewChart");
    this.renderTask = createTask({
      plan: renderTaskPlan,
      reset: renderTaskReset
    });
    this.renderTask.context = {
      view: this
    };
  }
  ChartView2.prototype.init = function(ecModel, api) {
  };
  ChartView2.prototype.render = function(seriesModel, ecModel, api, payload) {
  };
  ChartView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "emphasis");
  };
  ChartView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData(payload && payload.dataType);
    if (!data) {
      return;
    }
    toggleHighlight(data, payload, "normal");
  };
  ChartView2.prototype.remove = function(ecModel, api) {
    this.group.removeAll();
  };
  ChartView2.prototype.dispose = function(ecModel, api) {
  };
  ChartView2.prototype.updateView = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateLayout = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.updateVisual = function(seriesModel, ecModel, api, payload) {
    this.render(seriesModel, ecModel, api, payload);
  };
  ChartView2.prototype.eachRendered = function(cb) {
    traverseElements(this.group, cb);
  };
  ChartView2.markUpdateMethod = function(payload, methodName) {
    inner$j(payload).updateMethod = methodName;
  };
  ChartView2.protoInitialize = function() {
    var proto2 = ChartView2.prototype;
    proto2.type = "chart";
  }();
  return ChartView2;
}();
function elSetState(el, state, highlightDigit) {
  if (el && isHighDownDispatcher(el)) {
    (state === "emphasis" ? enterEmphasis : leaveEmphasis)(el, highlightDigit);
  }
}
function toggleHighlight(data, payload, state) {
  var dataIndex = queryDataIndex(data, payload);
  var highlightDigit = payload && payload.highlightKey != null ? getHighlightDigit(payload.highlightKey) : null;
  if (dataIndex != null) {
    each$f(normalizeToArray(dataIndex), function(dataIdx) {
      elSetState(data.getItemGraphicEl(dataIdx), state, highlightDigit);
    });
  } else {
    data.eachItemGraphicEl(function(el) {
      elSetState(el, state, highlightDigit);
    });
  }
}
enableClassExtend(ChartView);
enableClassManagement(ChartView);
function renderTaskPlan(context) {
  return renderPlanner(context.model);
}
function renderTaskReset(context) {
  var seriesModel = context.model;
  var ecModel = context.ecModel;
  var api = context.api;
  var payload = context.payload;
  var progressiveRender = seriesModel.pipelineContext.progressiveRender;
  var view = context.view;
  var updateMethod = payload && inner$j(payload).updateMethod;
  var methodName = progressiveRender ? "incrementalPrepareRender" : updateMethod && view[updateMethod] ? updateMethod : "render";
  if (methodName !== "render") {
    view[methodName](seriesModel, ecModel, api, payload);
  }
  return progressMethodMap[methodName];
}
var progressMethodMap = {
  incrementalPrepareRender: {
    progress: function(params, context) {
      context.view.incrementalRender(params, context.model, context.ecModel, context.api, context.payload);
    }
  },
  render: {
    forceFirstProgress: true,
    progress: function(params, context) {
      context.view.render(context.model, context.ecModel, context.api, context.payload);
    }
  }
};
var ChartView$1 = ChartView;
var ORIGIN_METHOD = "\0__throttleOriginMethod";
var RATE = "\0__throttleRate";
var THROTTLE_TYPE = "\0__throttleType";
function throttle(fn, delay, debounce2) {
  var currCall;
  var lastCall = 0;
  var lastExec = 0;
  var timer = null;
  var diff;
  var scope;
  var args;
  var debounceNextCall;
  delay = delay || 0;
  function exec() {
    lastExec = new Date().getTime();
    timer = null;
    fn.apply(scope, args || []);
  }
  var cb = function() {
    var cbArgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      cbArgs[_i] = arguments[_i];
    }
    currCall = new Date().getTime();
    scope = this;
    args = cbArgs;
    var thisDelay = debounceNextCall || delay;
    var thisDebounce = debounceNextCall || debounce2;
    debounceNextCall = null;
    diff = currCall - (thisDebounce ? lastCall : lastExec) - thisDelay;
    clearTimeout(timer);
    if (thisDebounce) {
      timer = setTimeout(exec, thisDelay);
    } else {
      if (diff >= 0) {
        exec();
      } else {
        timer = setTimeout(exec, -diff);
      }
    }
    lastCall = currCall;
  };
  cb.clear = function() {
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
  };
  cb.debounceNextCall = function(debounceDelay) {
    debounceNextCall = debounceDelay;
  };
  return cb;
}
function createOrUpdate(obj, fnAttr, rate, throttleType) {
  var fn = obj[fnAttr];
  if (!fn) {
    return;
  }
  var originFn = fn[ORIGIN_METHOD] || fn;
  var lastThrottleType = fn[THROTTLE_TYPE];
  var lastRate = fn[RATE];
  if (lastRate !== rate || lastThrottleType !== throttleType) {
    if (rate == null || !throttleType) {
      return obj[fnAttr] = originFn;
    }
    fn = obj[fnAttr] = throttle(originFn, rate, throttleType === "debounce");
    fn[ORIGIN_METHOD] = originFn;
    fn[THROTTLE_TYPE] = throttleType;
    fn[RATE] = rate;
  }
  return fn;
}
function clear$1(obj, fnAttr) {
  var fn = obj[fnAttr];
  if (fn && fn[ORIGIN_METHOD]) {
    fn.clear && fn.clear();
    obj[fnAttr] = fn[ORIGIN_METHOD];
  }
}
var inner$i = makeInner();
var defaultStyleMappers = {
  itemStyle: makeStyleMapper(ITEM_STYLE_KEY_MAP, true),
  lineStyle: makeStyleMapper(LINE_STYLE_KEY_MAP, true)
};
var defaultColorKey = {
  lineStyle: "stroke",
  itemStyle: "fill"
};
function getStyleMapper(seriesModel, stylePath) {
  var styleMapper = seriesModel.visualStyleMapper || defaultStyleMappers[stylePath];
  if (!styleMapper) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return defaultStyleMappers.itemStyle;
  }
  return styleMapper;
}
function getDefaultColorKey(seriesModel, stylePath) {
  var colorKey = seriesModel.visualDrawType || defaultColorKey[stylePath];
  if (!colorKey) {
    console.warn("Unkown style type '" + stylePath + "'.");
    return "fill";
  }
  return colorKey;
}
var seriesStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var styleModel = seriesModel.getModel(stylePath);
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var globalStyle = getStyle2(styleModel);
    var decalOption = styleModel.getShallow("decal");
    if (decalOption) {
      data.setVisual("decal", decalOption);
      decalOption.dirty = true;
    }
    var colorKey = getDefaultColorKey(seriesModel, stylePath);
    var color = globalStyle[colorKey];
    var colorCallback = isFunction(color) ? color : null;
    var hasAutoColor = globalStyle.fill === "auto" || globalStyle.stroke === "auto";
    if (!globalStyle[colorKey] || colorCallback || hasAutoColor) {
      var colorPalette2 = seriesModel.getColorFromPalette(seriesModel.name, null, ecModel.getSeriesCount());
      if (!globalStyle[colorKey]) {
        globalStyle[colorKey] = colorPalette2;
        data.setVisual("colorFromPalette", true);
      }
      globalStyle.fill = globalStyle.fill === "auto" || isFunction(globalStyle.fill) ? colorPalette2 : globalStyle.fill;
      globalStyle.stroke = globalStyle.stroke === "auto" || isFunction(globalStyle.stroke) ? colorPalette2 : globalStyle.stroke;
    }
    data.setVisual("style", globalStyle);
    data.setVisual("drawType", colorKey);
    if (!ecModel.isSeriesFiltered(seriesModel) && colorCallback) {
      data.setVisual("colorFromPalette", false);
      return {
        dataEach: function(data2, idx) {
          var dataParams = seriesModel.getDataParams(idx);
          var itemStyle = extend({}, globalStyle);
          itemStyle[colorKey] = colorCallback(dataParams);
          data2.setItemVisual(idx, "style", itemStyle);
        }
      };
    }
  }
};
var sharedModel = new Model$1();
var dataStyleTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (seriesModel.ignoreStyleOnData || ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
    var getStyle2 = getStyleMapper(seriesModel, stylePath);
    var colorKey = data.getVisual("drawType");
    return {
      dataEach: data.hasItemOption ? function(data2, idx) {
        var rawItem = data2.getRawDataItem(idx);
        if (rawItem && rawItem[stylePath]) {
          sharedModel.option = rawItem[stylePath];
          var style = getStyle2(sharedModel);
          var existsStyle = data2.ensureUniqueItemVisual(idx, "style");
          extend(existsStyle, style);
          if (sharedModel.option.decal) {
            data2.setItemVisual(idx, "decal", sharedModel.option.decal);
            sharedModel.option.decal.dirty = true;
          }
          if (colorKey in style) {
            data2.setItemVisual(idx, "colorFromPalette", false);
          }
        }
      } : null
    };
  }
};
var dataColorPaletteTask = {
  performRawSeries: true,
  overallReset: function(ecModel) {
    var paletteScopeGroupByType = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var colorBy = seriesModel.getColorBy();
      if (seriesModel.isColorBySeries()) {
        return;
      }
      var key = seriesModel.type + "-" + colorBy;
      var colorScope = paletteScopeGroupByType.get(key);
      if (!colorScope) {
        colorScope = {};
        paletteScopeGroupByType.set(key, colorScope);
      }
      inner$i(seriesModel).scope = colorScope;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.isColorBySeries() || ecModel.isSeriesFiltered(seriesModel)) {
        return;
      }
      var dataAll = seriesModel.getRawData();
      var idxMap = {};
      var data = seriesModel.getData();
      var colorScope = inner$i(seriesModel).scope;
      var stylePath = seriesModel.visualStyleAccessPath || "itemStyle";
      var colorKey = getDefaultColorKey(seriesModel, stylePath);
      data.each(function(idx) {
        var rawIdx = data.getRawIndex(idx);
        idxMap[rawIdx] = idx;
      });
      dataAll.each(function(rawIdx) {
        var idx = idxMap[rawIdx];
        var fromPalette = data.getItemVisual(idx, "colorFromPalette");
        if (fromPalette) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          var name_1 = dataAll.getName(rawIdx) || rawIdx + "";
          var dataCount = dataAll.count();
          itemStyle[colorKey] = seriesModel.getColorFromPalette(name_1, colorScope, dataCount);
        }
      });
    });
  }
};
var PI$5 = Math.PI;
function defaultLoading(api, opts) {
  opts = opts || {};
  defaults(opts, {
    text: "loading",
    textColor: "#000",
    fontSize: 12,
    fontWeight: "normal",
    fontStyle: "normal",
    fontFamily: "sans-serif",
    maskColor: "rgba(255, 255, 255, 0.8)",
    showSpinner: true,
    color: "#5470c6",
    spinnerRadius: 10,
    lineWidth: 5,
    zlevel: 0
  });
  var group = new Group$4();
  var mask = new Rect$3({
    style: {
      fill: opts.maskColor
    },
    zlevel: opts.zlevel,
    z: 1e4
  });
  group.add(mask);
  var textContent = new ZRText$1({
    style: {
      text: opts.text,
      fill: opts.textColor,
      fontSize: opts.fontSize,
      fontWeight: opts.fontWeight,
      fontStyle: opts.fontStyle,
      fontFamily: opts.fontFamily
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  var labelRect = new Rect$3({
    style: {
      fill: "none"
    },
    textContent,
    textConfig: {
      position: "right",
      distance: 10
    },
    zlevel: opts.zlevel,
    z: 10001
  });
  group.add(labelRect);
  var arc;
  if (opts.showSpinner) {
    arc = new Arc$1({
      shape: {
        startAngle: -PI$5 / 2,
        endAngle: -PI$5 / 2 + 0.1,
        r: opts.spinnerRadius
      },
      style: {
        stroke: opts.color,
        lineCap: "round",
        lineWidth: opts.lineWidth
      },
      zlevel: opts.zlevel,
      z: 10001
    });
    arc.animateShape(true).when(1e3, {
      endAngle: PI$5 * 3 / 2
    }).start("circularInOut");
    arc.animateShape(true).when(1e3, {
      startAngle: PI$5 * 3 / 2
    }).delay(300).start("circularInOut");
    group.add(arc);
  }
  group.resize = function() {
    var textWidth = textContent.getBoundingRect().width;
    var r2 = opts.showSpinner ? opts.spinnerRadius : 0;
    var cx = (api.getWidth() - r2 * 2 - (opts.showSpinner && textWidth ? 10 : 0) - textWidth) / 2 - (opts.showSpinner && textWidth ? 0 : 5 + textWidth / 2) + (opts.showSpinner ? 0 : textWidth / 2) + (textWidth ? 0 : r2);
    var cy = api.getHeight() / 2;
    opts.showSpinner && arc.setShape({
      cx,
      cy
    });
    labelRect.setShape({
      x: cx - r2,
      y: cy - r2,
      width: r2 * 2,
      height: r2 * 2
    });
    mask.setShape({
      x: 0,
      y: 0,
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  group.resize();
  return group;
}
var Scheduler = function() {
  function Scheduler2(ecInstance, api, dataProcessorHandlers, visualHandlers) {
    this._stageTaskMap = createHashMap();
    this.ecInstance = ecInstance;
    this.api = api;
    dataProcessorHandlers = this._dataProcessorHandlers = dataProcessorHandlers.slice();
    visualHandlers = this._visualHandlers = visualHandlers.slice();
    this._allHandlers = dataProcessorHandlers.concat(visualHandlers);
  }
  Scheduler2.prototype.restoreData = function(ecModel, payload) {
    ecModel.restoreData(payload);
    this._stageTaskMap.each(function(taskRecord) {
      var overallTask = taskRecord.overallTask;
      overallTask && overallTask.dirty();
    });
  };
  Scheduler2.prototype.getPerformArgs = function(task, isBlock) {
    if (!task.__pipeline) {
      return;
    }
    var pipeline = this._pipelineMap.get(task.__pipeline.id);
    var pCtx = pipeline.context;
    var incremental = !isBlock && pipeline.progressiveEnabled && (!pCtx || pCtx.progressiveRender) && task.__idxInPipeline > pipeline.blockIndex;
    var step = incremental ? pipeline.step : null;
    var modDataCount = pCtx && pCtx.modDataCount;
    var modBy = modDataCount != null ? Math.ceil(modDataCount / step) : null;
    return {
      step,
      modBy,
      modDataCount
    };
  };
  Scheduler2.prototype.getPipeline = function(pipelineId) {
    return this._pipelineMap.get(pipelineId);
  };
  Scheduler2.prototype.updateStreamModes = function(seriesModel, view) {
    var pipeline = this._pipelineMap.get(seriesModel.uid);
    var data = seriesModel.getData();
    var dataLen = data.count();
    var progressiveRender = pipeline.progressiveEnabled && view.incrementalPrepareRender && dataLen >= pipeline.threshold;
    var large = seriesModel.get("large") && dataLen >= seriesModel.get("largeThreshold");
    var modDataCount = seriesModel.get("progressiveChunkMode") === "mod" ? dataLen : null;
    seriesModel.pipelineContext = pipeline.context = {
      progressiveRender,
      modDataCount,
      large
    };
  };
  Scheduler2.prototype.restorePipelines = function(ecModel) {
    var scheduler = this;
    var pipelineMap = scheduler._pipelineMap = createHashMap();
    ecModel.eachSeries(function(seriesModel) {
      var progressive = seriesModel.getProgressive();
      var pipelineId = seriesModel.uid;
      pipelineMap.set(pipelineId, {
        id: pipelineId,
        head: null,
        tail: null,
        threshold: seriesModel.getProgressiveThreshold(),
        progressiveEnabled: progressive && !(seriesModel.preventIncremental && seriesModel.preventIncremental()),
        blockIndex: -1,
        step: Math.round(progressive || 700),
        count: 0
      });
      scheduler._pipe(seriesModel, seriesModel.dataTask);
    });
  };
  Scheduler2.prototype.prepareStageTasks = function() {
    var stageTaskMap = this._stageTaskMap;
    var ecModel = this.api.getModel();
    var api = this.api;
    each$f(this._allHandlers, function(handler) {
      var record = stageTaskMap.get(handler.uid) || stageTaskMap.set(handler.uid, {});
      var errMsg = "";
      assert(!(handler.reset && handler.overallReset), errMsg);
      handler.reset && this._createSeriesStageTask(handler, record, ecModel, api);
      handler.overallReset && this._createOverallStageTask(handler, record, ecModel, api);
    }, this);
  };
  Scheduler2.prototype.prepareView = function(view, model, ecModel, api) {
    var renderTask = view.renderTask;
    var context = renderTask.context;
    context.model = model;
    context.ecModel = ecModel;
    context.api = api;
    renderTask.__block = !view.incrementalPrepareRender;
    this._pipe(model, renderTask);
  };
  Scheduler2.prototype.performDataProcessorTasks = function(ecModel, payload) {
    this._performStageTasks(this._dataProcessorHandlers, ecModel, payload, {
      block: true
    });
  };
  Scheduler2.prototype.performVisualTasks = function(ecModel, payload, opt) {
    this._performStageTasks(this._visualHandlers, ecModel, payload, opt);
  };
  Scheduler2.prototype._performStageTasks = function(stageHandlers, ecModel, payload, opt) {
    opt = opt || {};
    var unfinished = false;
    var scheduler = this;
    each$f(stageHandlers, function(stageHandler, idx) {
      if (opt.visualType && opt.visualType !== stageHandler.visualType) {
        return;
      }
      var stageHandlerRecord = scheduler._stageTaskMap.get(stageHandler.uid);
      var seriesTaskMap = stageHandlerRecord.seriesTaskMap;
      var overallTask = stageHandlerRecord.overallTask;
      if (overallTask) {
        var overallNeedDirty_1;
        var agentStubMap = overallTask.agentStubMap;
        agentStubMap.each(function(stub) {
          if (needSetDirty(opt, stub)) {
            stub.dirty();
            overallNeedDirty_1 = true;
          }
        });
        overallNeedDirty_1 && overallTask.dirty();
        scheduler.updatePayload(overallTask, payload);
        var performArgs_1 = scheduler.getPerformArgs(overallTask, opt.block);
        agentStubMap.each(function(stub) {
          stub.perform(performArgs_1);
        });
        if (overallTask.perform(performArgs_1)) {
          unfinished = true;
        }
      } else if (seriesTaskMap) {
        seriesTaskMap.each(function(task, pipelineId) {
          if (needSetDirty(opt, task)) {
            task.dirty();
          }
          var performArgs = scheduler.getPerformArgs(task, opt.block);
          performArgs.skip = !stageHandler.performRawSeries && ecModel.isSeriesFiltered(task.context.model);
          scheduler.updatePayload(task, payload);
          if (task.perform(performArgs)) {
            unfinished = true;
          }
        });
      }
    });
    function needSetDirty(opt2, task) {
      return opt2.setDirty && (!opt2.dirtyMap || opt2.dirtyMap.get(task.__pipeline.id));
    }
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.performSeriesTasks = function(ecModel) {
    var unfinished;
    ecModel.eachSeries(function(seriesModel) {
      unfinished = seriesModel.dataTask.perform() || unfinished;
    });
    this.unfinished = unfinished || this.unfinished;
  };
  Scheduler2.prototype.plan = function() {
    this._pipelineMap.each(function(pipeline) {
      var task = pipeline.tail;
      do {
        if (task.__block) {
          pipeline.blockIndex = task.__idxInPipeline;
          break;
        }
        task = task.getUpstream();
      } while (task);
    });
  };
  Scheduler2.prototype.updatePayload = function(task, payload) {
    payload !== "remain" && (task.context.payload = payload);
  };
  Scheduler2.prototype._createSeriesStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler = this;
    var oldSeriesTaskMap = stageHandlerRecord.seriesTaskMap;
    var newSeriesTaskMap = stageHandlerRecord.seriesTaskMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    if (stageHandler.createOnAllSeries) {
      ecModel.eachRawSeries(create2);
    } else if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, create2);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(create2);
    }
    function create2(seriesModel) {
      var pipelineId = seriesModel.uid;
      var task = newSeriesTaskMap.set(pipelineId, oldSeriesTaskMap && oldSeriesTaskMap.get(pipelineId) || createTask({
        plan: seriesTaskPlan,
        reset: seriesTaskReset,
        count: seriesTaskCount
      }));
      task.context = {
        model: seriesModel,
        ecModel,
        api,
        useClearVisual: stageHandler.isVisual && !stageHandler.isLayout,
        plan: stageHandler.plan,
        reset: stageHandler.reset,
        scheduler
      };
      scheduler._pipe(seriesModel, task);
    }
  };
  Scheduler2.prototype._createOverallStageTask = function(stageHandler, stageHandlerRecord, ecModel, api) {
    var scheduler = this;
    var overallTask = stageHandlerRecord.overallTask = stageHandlerRecord.overallTask || createTask({
      reset: overallTaskReset
    });
    overallTask.context = {
      ecModel,
      api,
      overallReset: stageHandler.overallReset,
      scheduler
    };
    var oldAgentStubMap = overallTask.agentStubMap;
    var newAgentStubMap = overallTask.agentStubMap = createHashMap();
    var seriesType2 = stageHandler.seriesType;
    var getTargetSeries = stageHandler.getTargetSeries;
    var overallProgress = true;
    var shouldOverallTaskDirty = false;
    var errMsg = "";
    assert(!stageHandler.createOnAllSeries, errMsg);
    if (seriesType2) {
      ecModel.eachRawSeriesByType(seriesType2, createStub);
    } else if (getTargetSeries) {
      getTargetSeries(ecModel, api).each(createStub);
    } else {
      overallProgress = false;
      each$f(ecModel.getSeries(), createStub);
    }
    function createStub(seriesModel) {
      var pipelineId = seriesModel.uid;
      var stub = newAgentStubMap.set(pipelineId, oldAgentStubMap && oldAgentStubMap.get(pipelineId) || (shouldOverallTaskDirty = true, createTask({
        reset: stubReset,
        onDirty: stubOnDirty
      })));
      stub.context = {
        model: seriesModel,
        overallProgress
      };
      stub.agent = overallTask;
      stub.__block = overallProgress;
      scheduler._pipe(seriesModel, stub);
    }
    if (shouldOverallTaskDirty) {
      overallTask.dirty();
    }
  };
  Scheduler2.prototype._pipe = function(seriesModel, task) {
    var pipelineId = seriesModel.uid;
    var pipeline = this._pipelineMap.get(pipelineId);
    !pipeline.head && (pipeline.head = task);
    pipeline.tail && pipeline.tail.pipe(task);
    pipeline.tail = task;
    task.__idxInPipeline = pipeline.count++;
    task.__pipeline = pipeline;
  };
  Scheduler2.wrapStageHandler = function(stageHandler, visualType) {
    if (isFunction(stageHandler)) {
      stageHandler = {
        overallReset: stageHandler,
        seriesType: detectSeriseType(stageHandler)
      };
    }
    stageHandler.uid = getUID("stageHandler");
    visualType && (stageHandler.visualType = visualType);
    return stageHandler;
  };
  return Scheduler2;
}();
function overallTaskReset(context) {
  context.overallReset(context.ecModel, context.api, context.payload);
}
function stubReset(context) {
  return context.overallProgress && stubProgress;
}
function stubProgress() {
  this.agent.dirty();
  this.getDownstream().dirty();
}
function stubOnDirty() {
  this.agent && this.agent.dirty();
}
function seriesTaskPlan(context) {
  return context.plan ? context.plan(context.model, context.ecModel, context.api, context.payload) : null;
}
function seriesTaskReset(context) {
  if (context.useClearVisual) {
    context.data.clearAllVisual();
  }
  var resetDefines = context.resetDefines = normalizeToArray(context.reset(context.model, context.ecModel, context.api, context.payload));
  return resetDefines.length > 1 ? map$1(resetDefines, function(v4, idx) {
    return makeSeriesTaskProgress(idx);
  }) : singleSeriesTaskProgress;
}
var singleSeriesTaskProgress = makeSeriesTaskProgress(0);
function makeSeriesTaskProgress(resetDefineIdx) {
  return function(params, context) {
    var data = context.data;
    var resetDefine = context.resetDefines[resetDefineIdx];
    if (resetDefine && resetDefine.dataEach) {
      for (var i = params.start; i < params.end; i++) {
        resetDefine.dataEach(data, i);
      }
    } else if (resetDefine && resetDefine.progress) {
      resetDefine.progress(params, data);
    }
  };
}
function seriesTaskCount(context) {
  return context.data.count();
}
function detectSeriseType(legacyFunc) {
  seriesType = null;
  try {
    legacyFunc(ecModelMock, apiMock);
  } catch (e2) {
  }
  return seriesType;
}
var ecModelMock = {};
var apiMock = {};
var seriesType;
mockMethods(ecModelMock, GlobalModel$1);
mockMethods(apiMock, ExtensionAPI$1);
ecModelMock.eachSeriesByType = ecModelMock.eachRawSeriesByType = function(type4) {
  seriesType = type4;
};
ecModelMock.eachComponent = function(cond) {
  if (cond.mainType === "series" && cond.subType) {
    seriesType = cond.subType;
  }
};
function mockMethods(target, Clz) {
  for (var name_1 in Clz.prototype) {
    target[name_1] = noop;
  }
}
var Scheduler$1 = Scheduler;
var colorAll = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"];
var lightTheme = {
  color: colorAll,
  colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], colorAll]
};
var contrastColor = "#B9B8CE";
var backgroundColor = "#100C2A";
var axisCommon = function() {
  return {
    axisLine: {
      lineStyle: {
        color: contrastColor
      }
    },
    splitLine: {
      lineStyle: {
        color: "#484753"
      }
    },
    splitArea: {
      areaStyle: {
        color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"]
      }
    },
    minorSplitLine: {
      lineStyle: {
        color: "#20203B"
      }
    }
  };
};
var colorPalette = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"];
var theme = {
  darkMode: true,
  color: colorPalette,
  backgroundColor,
  axisPointer: {
    lineStyle: {
      color: "#817f91"
    },
    crossStyle: {
      color: "#817f91"
    },
    label: {
      color: "#fff"
    }
  },
  legend: {
    textStyle: {
      color: contrastColor
    }
  },
  textStyle: {
    color: contrastColor
  },
  title: {
    textStyle: {
      color: "#EEF1FA"
    },
    subtextStyle: {
      color: "#B9B8CE"
    }
  },
  toolbox: {
    iconStyle: {
      borderColor: contrastColor
    }
  },
  dataZoom: {
    borderColor: "#71708A",
    textStyle: {
      color: contrastColor
    },
    brushStyle: {
      color: "rgba(135,163,206,0.3)"
    },
    handleStyle: {
      color: "#353450",
      borderColor: "#C5CBE3"
    },
    moveHandleStyle: {
      color: "#B0B6C3",
      opacity: 0.3
    },
    fillerColor: "rgba(135,163,206,0.2)",
    emphasis: {
      handleStyle: {
        borderColor: "#91B7F2",
        color: "#4D587D"
      },
      moveHandleStyle: {
        color: "#636D9A",
        opacity: 0.7
      }
    },
    dataBackground: {
      lineStyle: {
        color: "#71708A",
        width: 1
      },
      areaStyle: {
        color: "#71708A"
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#87A3CE"
      },
      areaStyle: {
        color: "#87A3CE"
      }
    }
  },
  visualMap: {
    textStyle: {
      color: contrastColor
    }
  },
  timeline: {
    lineStyle: {
      color: contrastColor
    },
    label: {
      color: contrastColor
    },
    controlStyle: {
      color: contrastColor,
      borderColor: contrastColor
    }
  },
  calendar: {
    itemStyle: {
      color: backgroundColor
    },
    dayLabel: {
      color: contrastColor
    },
    monthLabel: {
      color: contrastColor
    },
    yearLabel: {
      color: contrastColor
    }
  },
  timeAxis: axisCommon(),
  logAxis: axisCommon(),
  valueAxis: axisCommon(),
  categoryAxis: axisCommon(),
  line: {
    symbol: "circle"
  },
  graph: {
    color: colorPalette
  },
  gauge: {
    title: {
      color: contrastColor
    },
    axisLine: {
      lineStyle: {
        color: [[1, "rgba(207,212,219,0.2)"]]
      }
    },
    axisLabel: {
      color: contrastColor
    },
    detail: {
      color: "#EEF1FA"
    }
  },
  candlestick: {
    itemStyle: {
      color: "#f64e56",
      color0: "#54ea92",
      borderColor: "#f64e56",
      borderColor0: "#54ea92"
    }
  }
};
theme.categoryAxis.splitLine.show = false;
var darkTheme = theme;
var ECEventProcessor = function() {
  function ECEventProcessor2() {
  }
  ECEventProcessor2.prototype.normalizeQuery = function(query) {
    var cptQuery = {};
    var dataQuery = {};
    var otherQuery = {};
    if (isString(query)) {
      var condCptType = parseClassType(query);
      cptQuery.mainType = condCptType.main || null;
      cptQuery.subType = condCptType.sub || null;
    } else {
      var suffixes_1 = ["Index", "Name", "Id"];
      var dataKeys_1 = {
        name: 1,
        dataIndex: 1,
        dataType: 1
      };
      each$f(query, function(val, key) {
        var reserved = false;
        for (var i = 0; i < suffixes_1.length; i++) {
          var propSuffix = suffixes_1[i];
          var suffixPos = key.lastIndexOf(propSuffix);
          if (suffixPos > 0 && suffixPos === key.length - propSuffix.length) {
            var mainType = key.slice(0, suffixPos);
            if (mainType !== "data") {
              cptQuery.mainType = mainType;
              cptQuery[propSuffix.toLowerCase()] = val;
              reserved = true;
            }
          }
        }
        if (dataKeys_1.hasOwnProperty(key)) {
          dataQuery[key] = val;
          reserved = true;
        }
        if (!reserved) {
          otherQuery[key] = val;
        }
      });
    }
    return {
      cptQuery,
      dataQuery,
      otherQuery
    };
  };
  ECEventProcessor2.prototype.filter = function(eventType, query) {
    var eventInfo = this.eventInfo;
    if (!eventInfo) {
      return true;
    }
    var targetEl = eventInfo.targetEl;
    var packedEvent = eventInfo.packedEvent;
    var model = eventInfo.model;
    var view = eventInfo.view;
    if (!model || !view) {
      return true;
    }
    var cptQuery = query.cptQuery;
    var dataQuery = query.dataQuery;
    return check(cptQuery, model, "mainType") && check(cptQuery, model, "subType") && check(cptQuery, model, "index", "componentIndex") && check(cptQuery, model, "name") && check(cptQuery, model, "id") && check(dataQuery, packedEvent, "name") && check(dataQuery, packedEvent, "dataIndex") && check(dataQuery, packedEvent, "dataType") && (!view.filterForExposedEvent || view.filterForExposedEvent(eventType, query.otherQuery, targetEl, packedEvent));
    function check(query2, host, prop, propOnHost) {
      return query2[prop] == null || host[propOnHost || prop] === query2[prop];
    }
  };
  ECEventProcessor2.prototype.afterTrigger = function() {
    this.eventInfo = null;
  };
  return ECEventProcessor2;
}();
var SYMBOL_PROPS_WITH_CB = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"];
var SYMBOL_PROPS = SYMBOL_PROPS_WITH_CB.concat(["symbolKeepAspect"]);
var seriesSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    var data = seriesModel.getData();
    if (seriesModel.legendIcon) {
      data.setVisual("legendIcon", seriesModel.legendIcon);
    }
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    var symbolOptions = {};
    var symbolOptionsCb = {};
    var hasCallback = false;
    for (var i = 0; i < SYMBOL_PROPS_WITH_CB.length; i++) {
      var symbolPropName = SYMBOL_PROPS_WITH_CB[i];
      var val = seriesModel.get(symbolPropName);
      if (isFunction(val)) {
        hasCallback = true;
        symbolOptionsCb[symbolPropName] = val;
      } else {
        symbolOptions[symbolPropName] = val;
      }
    }
    symbolOptions.symbol = symbolOptions.symbol || seriesModel.defaultSymbol;
    data.setVisual(extend({
      legendIcon: seriesModel.legendIcon || symbolOptions.symbol,
      symbolKeepAspect: seriesModel.get("symbolKeepAspect")
    }, symbolOptions));
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var symbolPropsCb = keys(symbolOptionsCb);
    function dataEach(data2, idx) {
      var rawValue = seriesModel.getRawValue(idx);
      var params = seriesModel.getDataParams(idx);
      for (var i2 = 0; i2 < symbolPropsCb.length; i2++) {
        var symbolPropName2 = symbolPropsCb[i2];
        data2.setItemVisual(idx, symbolPropName2, symbolOptionsCb[symbolPropName2](rawValue, params));
      }
    }
    return {
      dataEach: hasCallback ? dataEach : null
    };
  }
};
var dataSymbolTask = {
  createOnAllSeries: true,
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    if (!seriesModel.hasSymbolVisual) {
      return;
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      for (var i = 0; i < SYMBOL_PROPS.length; i++) {
        var symbolPropName = SYMBOL_PROPS[i];
        var val = itemModel.getShallow(symbolPropName, true);
        if (val != null) {
          data2.setItemVisual(idx, symbolPropName, val);
        }
      }
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
function getItemVisualFromData(data, dataIndex, key) {
  switch (key) {
    case "color":
      var style = data.getItemVisual(dataIndex, "style");
      return style[data.getVisual("drawType")];
    case "opacity":
      return data.getItemVisual(dataIndex, "style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getItemVisual(dataIndex, key);
  }
}
function getVisualFromData(data, key) {
  switch (key) {
    case "color":
      var style = data.getVisual("style");
      return style[data.getVisual("drawType")];
    case "opacity":
      return data.getVisual("style").opacity;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      return data.getVisual(key);
  }
}
function setItemVisualFromData(data, dataIndex, key, value) {
  switch (key) {
    case "color":
      var style = data.ensureUniqueItemVisual(dataIndex, "style");
      style[data.getVisual("drawType")] = value;
      data.setItemVisual(dataIndex, "colorFromPalette", false);
      break;
    case "opacity":
      data.ensureUniqueItemVisual(dataIndex, "style").opacity = value;
      break;
    case "symbol":
    case "symbolSize":
    case "liftZ":
      data.setItemVisual(dataIndex, key, value);
      break;
  }
}
function createLegacyDataSelectAction(seriesType2, ecRegisterAction) {
  function getSeriesIndices(ecModel, payload) {
    var seriesIndices = [];
    ecModel.eachComponent({
      mainType: "series",
      subType: seriesType2,
      query: payload
    }, function(seriesModel) {
      seriesIndices.push(seriesModel.seriesIndex);
    });
    return seriesIndices;
  }
  each$f([[seriesType2 + "ToggleSelect", "toggleSelect"], [seriesType2 + "Select", "select"], [seriesType2 + "UnSelect", "unselect"]], function(eventsMap) {
    ecRegisterAction(eventsMap[0], function(payload, ecModel, api) {
      payload = extend({}, payload);
      api.dispatchAction(extend(payload, {
        type: eventsMap[1],
        seriesIndex: getSeriesIndices(ecModel, payload)
      }));
    });
  });
}
function handleSeriesLegacySelectEvents(type4, eventPostfix, ecIns, ecModel, payload) {
  var legacyEventName = type4 + eventPostfix;
  if (!ecIns.isSilent(legacyEventName)) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "pie"
    }, function(seriesModel) {
      var seriesIndex = seriesModel.seriesIndex;
      var selectedMap = seriesModel.option.selectedMap;
      var selected = payload.selected;
      for (var i = 0; i < selected.length; i++) {
        if (selected[i].seriesIndex === seriesIndex) {
          var data = seriesModel.getData();
          var dataIndex = queryDataIndex(data, payload.fromActionPayload);
          ecIns.trigger(legacyEventName, {
            type: legacyEventName,
            seriesId: seriesModel.id,
            name: isArray$1(dataIndex) ? data.getName(dataIndex[0]) : data.getName(dataIndex),
            selected: isString(selectedMap) ? selectedMap : extend({}, selectedMap)
          });
        }
      }
    });
  }
}
function handleLegacySelectEvents(messageCenter, ecIns, api) {
  messageCenter.on("selectchanged", function(params) {
    var ecModel = api.getModel();
    if (params.isFromClick) {
      handleSeriesLegacySelectEvents("map", "selectchanged", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selectchanged", ecIns, ecModel, params);
    } else if (params.fromAction === "select") {
      handleSeriesLegacySelectEvents("map", "selected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "selected", ecIns, ecModel, params);
    } else if (params.fromAction === "unselect") {
      handleSeriesLegacySelectEvents("map", "unselected", ecIns, ecModel, params);
      handleSeriesLegacySelectEvents("pie", "unselected", ecIns, ecModel, params);
    }
  });
}
function findEventDispatcher(target, det, returnFirstMatch) {
  var found;
  while (target) {
    if (det(target)) {
      found = target;
      if (returnFirstMatch) {
        break;
      }
    }
    target = target.__hostTarget || target.parent;
  }
  return found;
}
var wmUniqueIndex = Math.round(Math.random() * 9);
var supportDefineProperty = typeof Object.defineProperty === "function";
var WeakMap2 = function() {
  function WeakMap3() {
    this._id = "__ec_inner_" + wmUniqueIndex++;
  }
  WeakMap3.prototype.get = function(key) {
    return this._guard(key)[this._id];
  };
  WeakMap3.prototype.set = function(key, value) {
    var target = this._guard(key);
    if (supportDefineProperty) {
      Object.defineProperty(target, this._id, {
        value,
        enumerable: false,
        configurable: true
      });
    } else {
      target[this._id] = value;
    }
    return this;
  };
  WeakMap3.prototype["delete"] = function(key) {
    if (this.has(key)) {
      delete this._guard(key)[this._id];
      return true;
    }
    return false;
  };
  WeakMap3.prototype.has = function(key) {
    return !!this._guard(key)[this._id];
  };
  WeakMap3.prototype._guard = function(key) {
    if (key !== Object(key)) {
      throw TypeError("Value of WeakMap is not a non-null object.");
    }
    return key;
  };
  return WeakMap3;
}();
var WeakMap$1 = WeakMap2;
var Triangle = Path$1.extend({
  type: "triangle",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy + height);
    path.lineTo(cx - width, cy + height);
    path.closePath();
  }
});
var Diamond = Path$1.extend({
  type: "diamond",
  shape: {
    cx: 0,
    cy: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var width = shape.width / 2;
    var height = shape.height / 2;
    path.moveTo(cx, cy - height);
    path.lineTo(cx + width, cy);
    path.lineTo(cx, cy + height);
    path.lineTo(cx - width, cy);
    path.closePath();
  }
});
var Pin = Path$1.extend({
  type: "pin",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(path, shape) {
    var x2 = shape.x;
    var y2 = shape.y;
    var w2 = shape.width / 5 * 3;
    var h = Math.max(w2, shape.height);
    var r2 = w2 / 2;
    var dy = r2 * r2 / (h - r2);
    var cy = y2 - h + r2 + dy;
    var angle = Math.asin(dy / r2);
    var dx = Math.cos(angle) * r2;
    var tanX = Math.sin(angle);
    var tanY = Math.cos(angle);
    var cpLen = r2 * 0.6;
    var cpLen2 = r2 * 0.7;
    path.moveTo(x2 - dx, cy + dy);
    path.arc(x2, cy, r2, Math.PI - angle, Math.PI * 2 + angle);
    path.bezierCurveTo(x2 + dx - tanX * cpLen, cy + dy + tanY * cpLen, x2, y2 - cpLen2, x2, y2);
    path.bezierCurveTo(x2, y2 - cpLen2, x2 - dx + tanX * cpLen, cy + dy + tanY * cpLen, x2 - dx, cy + dy);
    path.closePath();
  }
});
var Arrow = Path$1.extend({
  type: "arrow",
  shape: {
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  buildPath: function(ctx, shape) {
    var height = shape.height;
    var width = shape.width;
    var x2 = shape.x;
    var y2 = shape.y;
    var dx = width / 3 * 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(x2 + dx, y2 + height);
    ctx.lineTo(x2, y2 + height / 4 * 3);
    ctx.lineTo(x2 - dx, y2 + height);
    ctx.lineTo(x2, y2);
    ctx.closePath();
  }
});
var symbolCtors = {
  line: Line$3,
  rect: Rect$3,
  roundRect: Rect$3,
  square: Rect$3,
  circle: Circle$1,
  diamond: Diamond,
  pin: Pin,
  arrow: Arrow,
  triangle: Triangle
};
var symbolShapeMakers = {
  line: function(x2, y2, w2, h, shape) {
    shape.x1 = x2;
    shape.y1 = y2 + h / 2;
    shape.x2 = x2 + w2;
    shape.y2 = y2 + h / 2;
  },
  rect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
  },
  roundRect: function(x2, y2, w2, h, shape) {
    shape.x = x2;
    shape.y = y2;
    shape.width = w2;
    shape.height = h;
    shape.r = Math.min(w2, h) / 4;
  },
  square: function(x2, y2, w2, h, shape) {
    var size = Math.min(w2, h);
    shape.x = x2;
    shape.y = y2;
    shape.width = size;
    shape.height = size;
  },
  circle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.r = Math.min(w2, h) / 2;
  },
  diamond: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  pin: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  arrow: function(x2, y2, w2, h, shape) {
    shape.x = x2 + w2 / 2;
    shape.y = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  },
  triangle: function(x2, y2, w2, h, shape) {
    shape.cx = x2 + w2 / 2;
    shape.cy = y2 + h / 2;
    shape.width = w2;
    shape.height = h;
  }
};
var symbolBuildProxies = {};
each$f(symbolCtors, function(Ctor, name) {
  symbolBuildProxies[name] = new Ctor();
});
var SymbolClz$1 = Path$1.extend({
  type: "symbol",
  shape: {
    symbolType: "",
    x: 0,
    y: 0,
    width: 0,
    height: 0
  },
  calculateTextPosition: function(out2, config, rect) {
    var res = calculateTextPosition(out2, config, rect);
    var shape = this.shape;
    if (shape && shape.symbolType === "pin" && config.position === "inside") {
      res.y = rect.y + rect.height * 0.4;
    }
    return res;
  },
  buildPath: function(ctx, shape, inBundle) {
    var symbolType = shape.symbolType;
    if (symbolType !== "none") {
      var proxySymbol = symbolBuildProxies[symbolType];
      if (!proxySymbol) {
        symbolType = "rect";
        proxySymbol = symbolBuildProxies[symbolType];
      }
      symbolShapeMakers[symbolType](shape.x, shape.y, shape.width, shape.height, proxySymbol.shape);
      proxySymbol.buildPath(ctx, proxySymbol.shape, inBundle);
    }
  }
});
function symbolPathSetColor(color, innerColor2) {
  if (this.type !== "image") {
    var symbolStyle = this.style;
    if (this.__isEmptyBrush) {
      symbolStyle.stroke = color;
      symbolStyle.fill = innerColor2 || "#fff";
      symbolStyle.lineWidth = 2;
    } else if (this.shape.symbolType === "line") {
      symbolStyle.stroke = color;
    } else {
      symbolStyle.fill = color;
    }
    this.markRedraw();
  }
}
function createSymbol$1(symbolType, x2, y2, w2, h, color, keepAspect) {
  var isEmpty = symbolType.indexOf("empty") === 0;
  if (isEmpty) {
    symbolType = symbolType.substr(5, 1).toLowerCase() + symbolType.substr(6);
  }
  var symbolPath;
  if (symbolType.indexOf("image://") === 0) {
    symbolPath = makeImage(symbolType.slice(8), new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else if (symbolType.indexOf("path://") === 0) {
    symbolPath = makePath(symbolType.slice(7), {}, new BoundingRect$1(x2, y2, w2, h), keepAspect ? "center" : "cover");
  } else {
    symbolPath = new SymbolClz$1({
      shape: {
        symbolType,
        x: x2,
        y: y2,
        width: w2,
        height: h
      }
    });
  }
  symbolPath.__isEmptyBrush = isEmpty;
  symbolPath.setColor = symbolPathSetColor;
  if (color) {
    symbolPath.setColor(color);
  }
  return symbolPath;
}
function normalizeSymbolSize(symbolSize) {
  if (!isArray$1(symbolSize)) {
    symbolSize = [+symbolSize, +symbolSize];
  }
  return [symbolSize[0] || 0, symbolSize[1] || 0];
}
function normalizeSymbolOffset(symbolOffset, symbolSize) {
  if (symbolOffset == null) {
    return;
  }
  if (!isArray$1(symbolOffset)) {
    symbolOffset = [symbolOffset, symbolOffset];
  }
  return [parsePercent(symbolOffset[0], symbolSize[0]) || 0, parsePercent(retrieve2(symbolOffset[1], symbolOffset[0]), symbolSize[1]) || 0];
}
function createLinearGradient(ctx, obj, rect) {
  var x2 = obj.x == null ? 0 : obj.x;
  var x22 = obj.x2 == null ? 1 : obj.x2;
  var y2 = obj.y == null ? 0 : obj.y;
  var y22 = obj.y2 == null ? 0 : obj.y2;
  if (!obj.global) {
    x2 = x2 * rect.width + rect.x;
    x22 = x22 * rect.width + rect.x;
    y2 = y2 * rect.height + rect.y;
    y22 = y22 * rect.height + rect.y;
  }
  x2 = isNaN(x2) ? 0 : x2;
  x22 = isNaN(x22) ? 1 : x22;
  y2 = isNaN(y2) ? 0 : y2;
  y22 = isNaN(y22) ? 0 : y22;
  var canvasGradient = ctx.createLinearGradient(x2, y2, x22, y22);
  return canvasGradient;
}
function createRadialGradient(ctx, obj, rect) {
  var width = rect.width;
  var height = rect.height;
  var min3 = Math.min(width, height);
  var x2 = obj.x == null ? 0.5 : obj.x;
  var y2 = obj.y == null ? 0.5 : obj.y;
  var r2 = obj.r == null ? 0.5 : obj.r;
  if (!obj.global) {
    x2 = x2 * width + rect.x;
    y2 = y2 * height + rect.y;
    r2 = r2 * min3;
  }
  var canvasGradient = ctx.createRadialGradient(x2, y2, 0, x2, y2, r2);
  return canvasGradient;
}
function getCanvasGradient(ctx, obj, rect) {
  var canvasGradient = obj.type === "radial" ? createRadialGradient(ctx, obj, rect) : createLinearGradient(ctx, obj, rect);
  var colorStops = obj.colorStops;
  for (var i = 0; i < colorStops.length; i++) {
    canvasGradient.addColorStop(colorStops[i].offset, colorStops[i].color);
  }
  return canvasGradient;
}
function isClipPathChanged(clipPaths, prevClipPaths) {
  if (clipPaths === prevClipPaths || !clipPaths && !prevClipPaths) {
    return false;
  }
  if (!clipPaths || !prevClipPaths || clipPaths.length !== prevClipPaths.length) {
    return true;
  }
  for (var i = 0; i < clipPaths.length; i++) {
    if (clipPaths[i] !== prevClipPaths[i]) {
      return true;
    }
  }
  return false;
}
function parseInt10(val) {
  return parseInt(val, 10);
}
function getSize$1(root2, whIdx, opts) {
  var wh = ["width", "height"][whIdx];
  var cwh = ["clientWidth", "clientHeight"][whIdx];
  var plt = ["paddingLeft", "paddingTop"][whIdx];
  var prb = ["paddingRight", "paddingBottom"][whIdx];
  if (opts[wh] != null && opts[wh] !== "auto") {
    return parseFloat(opts[wh]);
  }
  var stl = document.defaultView.getComputedStyle(root2);
  return (root2[cwh] || parseInt10(stl[wh]) || parseInt10(root2.style[wh])) - (parseInt10(stl[plt]) || 0) - (parseInt10(stl[prb]) || 0) | 0;
}
function normalizeLineDash(lineType, lineWidth) {
  if (!lineType || lineType === "solid" || !(lineWidth > 0)) {
    return null;
  }
  return lineType === "dashed" ? [4 * lineWidth, 2 * lineWidth] : lineType === "dotted" ? [lineWidth] : isNumber(lineType) ? [lineType] : isArray$1(lineType) ? lineType : null;
}
function getLineDash(el) {
  var style = el.style;
  var lineDash = style.lineDash && style.lineWidth > 0 && normalizeLineDash(style.lineDash, style.lineWidth);
  var lineDashOffset = style.lineDashOffset;
  if (lineDash) {
    var lineScale_1 = style.strokeNoScale && el.getLineScale ? el.getLineScale() : 1;
    if (lineScale_1 && lineScale_1 !== 1) {
      lineDash = map$1(lineDash, function(rawVal) {
        return rawVal / lineScale_1;
      });
      lineDashOffset /= lineScale_1;
    }
  }
  return [lineDash, lineDashOffset];
}
var pathProxyForDraw = new PathProxy$1(true);
function styleHasStroke(style) {
  var stroke = style.stroke;
  return !(stroke == null || stroke === "none" || !(style.lineWidth > 0));
}
function isValidStrokeFillStyle(strokeOrFill) {
  return typeof strokeOrFill === "string" && strokeOrFill !== "none";
}
function styleHasFill(style) {
  var fill = style.fill;
  return fill != null && fill !== "none";
}
function doFillPath(ctx, style) {
  if (style.fillOpacity != null && style.fillOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style.fillOpacity * style.opacity;
    ctx.fill();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.fill();
  }
}
function doStrokePath(ctx, style) {
  if (style.strokeOpacity != null && style.strokeOpacity !== 1) {
    var originalGlobalAlpha = ctx.globalAlpha;
    ctx.globalAlpha = style.strokeOpacity * style.opacity;
    ctx.stroke();
    ctx.globalAlpha = originalGlobalAlpha;
  } else {
    ctx.stroke();
  }
}
function createCanvasPattern(ctx, pattern4, el) {
  var image = createOrUpdateImage(pattern4.image, pattern4.__image, el);
  if (isImageReady(image)) {
    var canvasPattern = ctx.createPattern(image, pattern4.repeat || "repeat");
    if (typeof DOMMatrix === "function" && canvasPattern && canvasPattern.setTransform) {
      var matrix = new DOMMatrix();
      matrix.translateSelf(pattern4.x || 0, pattern4.y || 0);
      matrix.rotateSelf(0, 0, (pattern4.rotation || 0) * RADIAN_TO_DEGREE);
      matrix.scaleSelf(pattern4.scaleX || 1, pattern4.scaleY || 1);
      canvasPattern.setTransform(matrix);
    }
    return canvasPattern;
  }
}
function brushPath(ctx, el, style, inBatch) {
  var _a2;
  var hasStroke = styleHasStroke(style);
  var hasFill = styleHasFill(style);
  var strokePercent = style.strokePercent;
  var strokePart = strokePercent < 1;
  var firstDraw = !el.path;
  if ((!el.silent || strokePart) && firstDraw) {
    el.createPathProxy();
  }
  var path = el.path || pathProxyForDraw;
  var dirtyFlag = el.__dirty;
  if (!inBatch) {
    var fill = style.fill;
    var stroke = style.stroke;
    var hasFillGradient = hasFill && !!fill.colorStops;
    var hasStrokeGradient = hasStroke && !!stroke.colorStops;
    var hasFillPattern = hasFill && !!fill.image;
    var hasStrokePattern = hasStroke && !!stroke.image;
    var fillGradient = void 0;
    var strokeGradient = void 0;
    var fillPattern = void 0;
    var strokePattern = void 0;
    var rect = void 0;
    if (hasFillGradient || hasStrokeGradient) {
      rect = el.getBoundingRect();
    }
    if (hasFillGradient) {
      fillGradient = dirtyFlag ? getCanvasGradient(ctx, fill, rect) : el.__canvasFillGradient;
      el.__canvasFillGradient = fillGradient;
    }
    if (hasStrokeGradient) {
      strokeGradient = dirtyFlag ? getCanvasGradient(ctx, stroke, rect) : el.__canvasStrokeGradient;
      el.__canvasStrokeGradient = strokeGradient;
    }
    if (hasFillPattern) {
      fillPattern = dirtyFlag || !el.__canvasFillPattern ? createCanvasPattern(ctx, fill, el) : el.__canvasFillPattern;
      el.__canvasFillPattern = fillPattern;
    }
    if (hasStrokePattern) {
      strokePattern = dirtyFlag || !el.__canvasStrokePattern ? createCanvasPattern(ctx, stroke, el) : el.__canvasStrokePattern;
      el.__canvasStrokePattern = fillPattern;
    }
    if (hasFillGradient) {
      ctx.fillStyle = fillGradient;
    } else if (hasFillPattern) {
      if (fillPattern) {
        ctx.fillStyle = fillPattern;
      } else {
        hasFill = false;
      }
    }
    if (hasStrokeGradient) {
      ctx.strokeStyle = strokeGradient;
    } else if (hasStrokePattern) {
      if (strokePattern) {
        ctx.strokeStyle = strokePattern;
      } else {
        hasStroke = false;
      }
    }
  }
  var scale2 = el.getGlobalScale();
  path.setScale(scale2[0], scale2[1], el.segmentIgnoreThreshold);
  var lineDash;
  var lineDashOffset;
  if (ctx.setLineDash && style.lineDash) {
    _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
  }
  var needsRebuild = true;
  if (firstDraw || dirtyFlag & SHAPE_CHANGED_BIT) {
    path.setDPR(ctx.dpr);
    if (strokePart) {
      path.setContext(null);
    } else {
      path.setContext(ctx);
      needsRebuild = false;
    }
    path.reset();
    el.buildPath(path, el.shape, inBatch);
    path.toStatic();
    el.pathUpdated();
  }
  if (needsRebuild) {
    path.rebuildPath(ctx, strokePart ? strokePercent : 1);
  }
  if (lineDash) {
    ctx.setLineDash(lineDash);
    ctx.lineDashOffset = lineDashOffset;
  }
  if (!inBatch) {
    if (style.strokeFirst) {
      if (hasStroke) {
        doStrokePath(ctx, style);
      }
      if (hasFill) {
        doFillPath(ctx, style);
      }
    } else {
      if (hasFill) {
        doFillPath(ctx, style);
      }
      if (hasStroke) {
        doStrokePath(ctx, style);
      }
    }
  }
  if (lineDash) {
    ctx.setLineDash([]);
  }
}
function brushImage(ctx, el, style) {
  var image = el.__image = createOrUpdateImage(style.image, el.__image, el, el.onload);
  if (!image || !isImageReady(image)) {
    return;
  }
  var x2 = style.x || 0;
  var y2 = style.y || 0;
  var width = el.getWidth();
  var height = el.getHeight();
  var aspect = image.width / image.height;
  if (width == null && height != null) {
    width = height * aspect;
  } else if (height == null && width != null) {
    height = width / aspect;
  } else if (width == null && height == null) {
    width = image.width;
    height = image.height;
  }
  if (style.sWidth && style.sHeight) {
    var sx = style.sx || 0;
    var sy = style.sy || 0;
    ctx.drawImage(image, sx, sy, style.sWidth, style.sHeight, x2, y2, width, height);
  } else if (style.sx && style.sy) {
    var sx = style.sx;
    var sy = style.sy;
    var sWidth = width - sx;
    var sHeight = height - sy;
    ctx.drawImage(image, sx, sy, sWidth, sHeight, x2, y2, width, height);
  } else {
    ctx.drawImage(image, x2, y2, width, height);
  }
}
function brushText(ctx, el, style) {
  var _a2;
  var text = style.text;
  text != null && (text += "");
  if (text) {
    ctx.font = style.font || DEFAULT_FONT;
    ctx.textAlign = style.textAlign;
    ctx.textBaseline = style.textBaseline;
    var lineDash = void 0;
    var lineDashOffset = void 0;
    if (ctx.setLineDash && style.lineDash) {
      _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
    }
    if (lineDash) {
      ctx.setLineDash(lineDash);
      ctx.lineDashOffset = lineDashOffset;
    }
    if (style.strokeFirst) {
      if (styleHasStroke(style)) {
        ctx.strokeText(text, style.x, style.y);
      }
      if (styleHasFill(style)) {
        ctx.fillText(text, style.x, style.y);
      }
    } else {
      if (styleHasFill(style)) {
        ctx.fillText(text, style.x, style.y);
      }
      if (styleHasStroke(style)) {
        ctx.strokeText(text, style.x, style.y);
      }
    }
    if (lineDash) {
      ctx.setLineDash([]);
    }
  }
}
var SHADOW_NUMBER_PROPS = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"];
var STROKE_PROPS = [
  ["lineCap", "butt"],
  ["lineJoin", "miter"],
  ["miterLimit", 10]
];
function bindCommonProps(ctx, style, prevStyle, forceSetAll, scope) {
  var styleChanged = false;
  if (!forceSetAll) {
    prevStyle = prevStyle || {};
    if (style === prevStyle) {
      return false;
    }
  }
  if (forceSetAll || style.opacity !== prevStyle.opacity) {
    flushPathDrawn(ctx, scope);
    styleChanged = true;
    var opacity = Math.max(Math.min(style.opacity, 1), 0);
    ctx.globalAlpha = isNaN(opacity) ? DEFAULT_COMMON_STYLE.opacity : opacity;
  }
  if (forceSetAll || style.blend !== prevStyle.blend) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalCompositeOperation = style.blend || DEFAULT_COMMON_STYLE.blend;
  }
  for (var i = 0; i < SHADOW_NUMBER_PROPS.length; i++) {
    var propName = SHADOW_NUMBER_PROPS[i];
    if (forceSetAll || style[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = ctx.dpr * (style[propName] || 0);
    }
  }
  if (forceSetAll || style.shadowColor !== prevStyle.shadowColor) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.shadowColor = style.shadowColor || DEFAULT_COMMON_STYLE.shadowColor;
  }
  return styleChanged;
}
function bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetAll, scope) {
  var style = getStyle(el, scope.inHover);
  var prevStyle = forceSetAll ? null : prevEl && getStyle(prevEl, scope.inHover) || {};
  if (style === prevStyle) {
    return false;
  }
  var styleChanged = bindCommonProps(ctx, style, prevStyle, forceSetAll, scope);
  if (forceSetAll || style.fill !== prevStyle.fill) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style.fill) && (ctx.fillStyle = style.fill);
  }
  if (forceSetAll || style.stroke !== prevStyle.stroke) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    isValidStrokeFillStyle(style.stroke) && (ctx.strokeStyle = style.stroke);
  }
  if (forceSetAll || style.opacity !== prevStyle.opacity) {
    if (!styleChanged) {
      flushPathDrawn(ctx, scope);
      styleChanged = true;
    }
    ctx.globalAlpha = style.opacity == null ? 1 : style.opacity;
  }
  if (el.hasStroke()) {
    var lineWidth = style.lineWidth;
    var newLineWidth = lineWidth / (style.strokeNoScale && el.getLineScale ? el.getLineScale() : 1);
    if (ctx.lineWidth !== newLineWidth) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx.lineWidth = newLineWidth;
    }
  }
  for (var i = 0; i < STROKE_PROPS.length; i++) {
    var prop = STROKE_PROPS[i];
    var propName = prop[0];
    if (forceSetAll || style[propName] !== prevStyle[propName]) {
      if (!styleChanged) {
        flushPathDrawn(ctx, scope);
        styleChanged = true;
      }
      ctx[propName] = style[propName] || prop[1];
    }
  }
  return styleChanged;
}
function bindImageStyle(ctx, el, prevEl, forceSetAll, scope) {
  return bindCommonProps(ctx, getStyle(el, scope.inHover), prevEl && getStyle(prevEl, scope.inHover), forceSetAll, scope);
}
function setContextTransform(ctx, el) {
  var m2 = el.transform;
  var dpr2 = ctx.dpr || 1;
  if (m2) {
    ctx.setTransform(dpr2 * m2[0], dpr2 * m2[1], dpr2 * m2[2], dpr2 * m2[3], dpr2 * m2[4], dpr2 * m2[5]);
  } else {
    ctx.setTransform(dpr2, 0, 0, dpr2, 0, 0);
  }
}
function updateClipStatus(clipPaths, ctx, scope) {
  var allClipped = false;
  for (var i = 0; i < clipPaths.length; i++) {
    var clipPath = clipPaths[i];
    allClipped = allClipped || clipPath.isZeroArea();
    setContextTransform(ctx, clipPath);
    ctx.beginPath();
    clipPath.buildPath(ctx, clipPath.shape);
    ctx.clip();
  }
  scope.allClipped = allClipped;
}
function isTransformChanged(m0, m1) {
  if (m0 && m1) {
    return m0[0] !== m1[0] || m0[1] !== m1[1] || m0[2] !== m1[2] || m0[3] !== m1[3] || m0[4] !== m1[4] || m0[5] !== m1[5];
  } else if (!m0 && !m1) {
    return false;
  }
  return true;
}
var DRAW_TYPE_PATH = 1;
var DRAW_TYPE_IMAGE = 2;
var DRAW_TYPE_TEXT = 3;
var DRAW_TYPE_INCREMENTAL = 4;
function canPathBatch(style) {
  var hasFill = styleHasFill(style);
  var hasStroke = styleHasStroke(style);
  return !(style.lineDash || !(+hasFill ^ +hasStroke) || hasFill && typeof style.fill !== "string" || hasStroke && typeof style.stroke !== "string" || style.strokePercent < 1 || style.strokeOpacity < 1 || style.fillOpacity < 1);
}
function flushPathDrawn(ctx, scope) {
  scope.batchFill && ctx.fill();
  scope.batchStroke && ctx.stroke();
  scope.batchFill = "";
  scope.batchStroke = "";
}
function getStyle(el, inHover) {
  return inHover ? el.__hoverStyle || el.style : el.style;
}
function brushSingle(ctx, el) {
  brush$1(ctx, el, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
}
function brush$1(ctx, el, scope, isLast) {
  var m2 = el.transform;
  if (!el.shouldBePainted(scope.viewWidth, scope.viewHeight, false, false)) {
    el.__dirty &= ~REDRAW_BIT;
    el.__isRendered = false;
    return;
  }
  var clipPaths = el.__clipPaths;
  var prevElClipPaths = scope.prevElClipPaths;
  var forceSetTransform = false;
  var forceSetStyle = false;
  if (!prevElClipPaths || isClipPathChanged(clipPaths, prevElClipPaths)) {
    if (prevElClipPaths && prevElClipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.restore();
      forceSetStyle = forceSetTransform = true;
      scope.prevElClipPaths = null;
      scope.allClipped = false;
      scope.prevEl = null;
    }
    if (clipPaths && clipPaths.length) {
      flushPathDrawn(ctx, scope);
      ctx.save();
      updateClipStatus(clipPaths, ctx, scope);
      forceSetTransform = true;
    }
    scope.prevElClipPaths = clipPaths;
  }
  if (scope.allClipped) {
    el.__isRendered = false;
    return;
  }
  el.beforeBrush && el.beforeBrush();
  el.innerBeforeBrush();
  var prevEl = scope.prevEl;
  if (!prevEl) {
    forceSetStyle = forceSetTransform = true;
  }
  var canBatchPath = el instanceof Path$1 && el.autoBatch && canPathBatch(el.style);
  if (forceSetTransform || isTransformChanged(m2, prevEl.transform)) {
    flushPathDrawn(ctx, scope);
    setContextTransform(ctx, el);
  } else if (!canBatchPath) {
    flushPathDrawn(ctx, scope);
  }
  var style = getStyle(el, scope.inHover);
  if (el instanceof Path$1) {
    if (scope.lastDrawType !== DRAW_TYPE_PATH) {
      forceSetStyle = true;
      scope.lastDrawType = DRAW_TYPE_PATH;
    }
    bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
    if (!canBatchPath || !scope.batchFill && !scope.batchStroke) {
      ctx.beginPath();
    }
    brushPath(ctx, el, style, canBatchPath);
    if (canBatchPath) {
      scope.batchFill = style.fill || "";
      scope.batchStroke = style.stroke || "";
    }
  } else {
    if (el instanceof TSpan$1) {
      if (scope.lastDrawType !== DRAW_TYPE_TEXT) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_TEXT;
      }
      bindPathAndTextCommonStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushText(ctx, el, style);
    } else if (el instanceof ZRImage$1) {
      if (scope.lastDrawType !== DRAW_TYPE_IMAGE) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_IMAGE;
      }
      bindImageStyle(ctx, el, prevEl, forceSetStyle, scope);
      brushImage(ctx, el, style);
    } else if (el.getTemporalDisplayables) {
      if (scope.lastDrawType !== DRAW_TYPE_INCREMENTAL) {
        forceSetStyle = true;
        scope.lastDrawType = DRAW_TYPE_INCREMENTAL;
      }
      brushIncremental(ctx, el, scope);
    }
  }
  if (canBatchPath && isLast) {
    flushPathDrawn(ctx, scope);
  }
  el.innerAfterBrush();
  el.afterBrush && el.afterBrush();
  scope.prevEl = el;
  el.__dirty = 0;
  el.__isRendered = true;
}
function brushIncremental(ctx, el, scope) {
  var displayables = el.getDisplayables();
  var temporalDisplayables = el.getTemporalDisplayables();
  ctx.save();
  var innerScope = {
    prevElClipPaths: null,
    prevEl: null,
    allClipped: false,
    viewWidth: scope.viewWidth,
    viewHeight: scope.viewHeight,
    inHover: scope.inHover
  };
  var i;
  var len2;
  for (i = el.getCursor(), len2 = displayables.length; i < len2; i++) {
    var displayable = displayables[i];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i === len2 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  for (var i_1 = 0, len_1 = temporalDisplayables.length; i_1 < len_1; i_1++) {
    var displayable = temporalDisplayables[i_1];
    displayable.beforeBrush && displayable.beforeBrush();
    displayable.innerBeforeBrush();
    brush$1(ctx, displayable, innerScope, i_1 === len_1 - 1);
    displayable.innerAfterBrush();
    displayable.afterBrush && displayable.afterBrush();
    innerScope.prevEl = displayable;
  }
  el.clearTemporalDisplayables();
  el.notClear = true;
  ctx.restore();
}
var decalMap = new WeakMap$1();
var decalCache = new LRU$1(100);
var decalKeys = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
function createOrUpdatePatternFromDecal(decalObject, api) {
  if (decalObject === "none") {
    return null;
  }
  var dpr2 = api.getDevicePixelRatio();
  var zr = api.getZr();
  var isSVG = zr.painter.type === "svg";
  if (decalObject.dirty) {
    decalMap["delete"](decalObject);
  }
  var oldPattern = decalMap.get(decalObject);
  if (oldPattern) {
    return oldPattern;
  }
  var decalOpt = defaults(decalObject, {
    symbol: "rect",
    symbolSize: 1,
    symbolKeepAspect: true,
    color: "rgba(0, 0, 0, 0.2)",
    backgroundColor: null,
    dashArrayX: 5,
    dashArrayY: 5,
    rotation: 0,
    maxTileWidth: 512,
    maxTileHeight: 512
  });
  if (decalOpt.backgroundColor === "none") {
    decalOpt.backgroundColor = null;
  }
  var pattern4 = {
    repeat: "repeat"
  };
  setPatternnSource(pattern4);
  pattern4.rotation = decalOpt.rotation;
  pattern4.scaleX = pattern4.scaleY = isSVG ? 1 : 1 / dpr2;
  decalMap.set(decalObject, pattern4);
  decalObject.dirty = false;
  return pattern4;
  function setPatternnSource(pattern5) {
    var keys2 = [dpr2];
    var isValidKey = true;
    for (var i = 0; i < decalKeys.length; ++i) {
      var value = decalOpt[decalKeys[i]];
      if (value != null && !isArray$1(value) && !isString(value) && !isNumber(value) && typeof value !== "boolean") {
        isValidKey = false;
        break;
      }
      keys2.push(value);
    }
    var cacheKey;
    if (isValidKey) {
      cacheKey = keys2.join(",") + (isSVG ? "-svg" : "");
      var cache = decalCache.get(cacheKey);
      if (cache) {
        isSVG ? pattern5.svgElement = cache : pattern5.image = cache;
      }
    }
    var dashArrayX = normalizeDashArrayX(decalOpt.dashArrayX);
    var dashArrayY = normalizeDashArrayY(decalOpt.dashArrayY);
    var symbolArray = normalizeSymbolArray(decalOpt.symbol);
    var lineBlockLengthsX = getLineBlockLengthX(dashArrayX);
    var lineBlockLengthY = getLineBlockLengthY(dashArrayY);
    var canvas = !isSVG && platformApi.createCanvas();
    var svgRoot = isSVG && {
      tag: "g",
      attrs: {},
      key: "dcl",
      children: []
    };
    var pSize = getPatternSize();
    var ctx;
    if (canvas) {
      canvas.width = pSize.width * dpr2;
      canvas.height = pSize.height * dpr2;
      ctx = canvas.getContext("2d");
    }
    brushDecal();
    if (isValidKey) {
      decalCache.put(cacheKey, canvas || svgRoot);
    }
    pattern5.image = canvas;
    pattern5.svgElement = svgRoot;
    pattern5.svgWidth = pSize.width;
    pattern5.svgHeight = pSize.height;
    function getPatternSize() {
      var width = 1;
      for (var i2 = 0, xlen = lineBlockLengthsX.length; i2 < xlen; ++i2) {
        width = getLeastCommonMultiple(width, lineBlockLengthsX[i2]);
      }
      var symbolRepeats = 1;
      for (var i2 = 0, xlen = symbolArray.length; i2 < xlen; ++i2) {
        symbolRepeats = getLeastCommonMultiple(symbolRepeats, symbolArray[i2].length);
      }
      width *= symbolRepeats;
      var height = lineBlockLengthY * lineBlockLengthsX.length * symbolArray.length;
      return {
        width: Math.max(1, Math.min(width, decalOpt.maxTileWidth)),
        height: Math.max(1, Math.min(height, decalOpt.maxTileHeight))
      };
    }
    function brushDecal() {
      if (ctx) {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        if (decalOpt.backgroundColor) {
          ctx.fillStyle = decalOpt.backgroundColor;
          ctx.fillRect(0, 0, canvas.width, canvas.height);
        }
      }
      var ySum = 0;
      for (var i2 = 0; i2 < dashArrayY.length; ++i2) {
        ySum += dashArrayY[i2];
      }
      if (ySum <= 0) {
        return;
      }
      var y2 = -lineBlockLengthY;
      var yId = 0;
      var yIdTotal = 0;
      var xId0 = 0;
      while (y2 < pSize.height) {
        if (yId % 2 === 0) {
          var symbolYId = yIdTotal / 2 % symbolArray.length;
          var x2 = 0;
          var xId1 = 0;
          var xId1Total = 0;
          while (x2 < pSize.width * 2) {
            var xSum = 0;
            for (var i2 = 0; i2 < dashArrayX[xId0].length; ++i2) {
              xSum += dashArrayX[xId0][i2];
            }
            if (xSum <= 0) {
              break;
            }
            if (xId1 % 2 === 0) {
              var size = (1 - decalOpt.symbolSize) * 0.5;
              var left = x2 + dashArrayX[xId0][xId1] * size;
              var top_1 = y2 + dashArrayY[yId] * size;
              var width = dashArrayX[xId0][xId1] * decalOpt.symbolSize;
              var height = dashArrayY[yId] * decalOpt.symbolSize;
              var symbolXId = xId1Total / 2 % symbolArray[symbolYId].length;
              brushSymbol(left, top_1, width, height, symbolArray[symbolYId][symbolXId]);
            }
            x2 += dashArrayX[xId0][xId1];
            ++xId1Total;
            ++xId1;
            if (xId1 === dashArrayX[xId0].length) {
              xId1 = 0;
            }
          }
          ++xId0;
          if (xId0 === dashArrayX.length) {
            xId0 = 0;
          }
        }
        y2 += dashArrayY[yId];
        ++yIdTotal;
        ++yId;
        if (yId === dashArrayY.length) {
          yId = 0;
        }
      }
      function brushSymbol(x3, y3, width2, height2, symbolType) {
        var scale2 = isSVG ? 1 : dpr2;
        var symbol = createSymbol$1(symbolType, x3 * scale2, y3 * scale2, width2 * scale2, height2 * scale2, decalOpt.color, decalOpt.symbolKeepAspect);
        if (isSVG) {
          var symbolVNode = zr.painter.renderOneToVNode(symbol);
          if (symbolVNode) {
            svgRoot.children.push(symbolVNode);
          }
        } else {
          brushSingle(ctx, symbol);
        }
      }
    }
  }
}
function normalizeSymbolArray(symbol) {
  if (!symbol || symbol.length === 0) {
    return [["rect"]];
  }
  if (isString(symbol)) {
    return [[symbol]];
  }
  var isAllString = true;
  for (var i = 0; i < symbol.length; ++i) {
    if (!isString(symbol[i])) {
      isAllString = false;
      break;
    }
  }
  if (isAllString) {
    return normalizeSymbolArray([symbol]);
  }
  var result = [];
  for (var i = 0; i < symbol.length; ++i) {
    if (isString(symbol[i])) {
      result.push([symbol[i]]);
    } else {
      result.push(symbol[i]);
    }
  }
  return result;
}
function normalizeDashArrayX(dash) {
  if (!dash || dash.length === 0) {
    return [[0, 0]];
  }
  if (isNumber(dash)) {
    var dashValue = Math.ceil(dash);
    return [[dashValue, dashValue]];
  }
  var isAllNumber = true;
  for (var i = 0; i < dash.length; ++i) {
    if (!isNumber(dash[i])) {
      isAllNumber = false;
      break;
    }
  }
  if (isAllNumber) {
    return normalizeDashArrayX([dash]);
  }
  var result = [];
  for (var i = 0; i < dash.length; ++i) {
    if (isNumber(dash[i])) {
      var dashValue = Math.ceil(dash[i]);
      result.push([dashValue, dashValue]);
    } else {
      var dashValue = map$1(dash[i], function(n2) {
        return Math.ceil(n2);
      });
      if (dashValue.length % 2 === 1) {
        result.push(dashValue.concat(dashValue));
      } else {
        result.push(dashValue);
      }
    }
  }
  return result;
}
function normalizeDashArrayY(dash) {
  if (!dash || typeof dash === "object" && dash.length === 0) {
    return [0, 0];
  }
  if (isNumber(dash)) {
    var dashValue_1 = Math.ceil(dash);
    return [dashValue_1, dashValue_1];
  }
  var dashValue = map$1(dash, function(n2) {
    return Math.ceil(n2);
  });
  return dash.length % 2 ? dashValue.concat(dashValue) : dashValue;
}
function getLineBlockLengthX(dash) {
  return map$1(dash, function(line) {
    return getLineBlockLengthY(line);
  });
}
function getLineBlockLengthY(dash) {
  var blockLength = 0;
  for (var i = 0; i < dash.length; ++i) {
    blockLength += dash[i];
  }
  if (dash.length % 2 === 1) {
    return blockLength * 2;
  }
  return blockLength;
}
function decalVisual(ecModel, api) {
  ecModel.eachRawSeries(function(seriesModel) {
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var data = seriesModel.getData();
    if (data.hasItemVisual()) {
      data.each(function(idx) {
        var decal2 = data.getItemVisual(idx, "decal");
        if (decal2) {
          var itemStyle = data.ensureUniqueItemVisual(idx, "style");
          itemStyle.decal = createOrUpdatePatternFromDecal(decal2, api);
        }
      });
    }
    var decal = data.getVisual("decal");
    if (decal) {
      var style = data.getVisual("style");
      style.decal = createOrUpdatePatternFromDecal(decal, api);
    }
  });
}
var lifecycle = new Eventful$1();
var lifecycle$1 = lifecycle;
var implsStore = {};
function registerImpl(name, impl) {
  implsStore[name] = impl;
}
function getImpl(name) {
  return implsStore[name];
}
var hasWindow = typeof window !== "undefined";
var TEST_FRAME_REMAIN_TIME = 1;
var PRIORITY_PROCESSOR_SERIES_FILTER = 800;
var PRIORITY_PROCESSOR_DATASTACK = 900;
var PRIORITY_PROCESSOR_FILTER = 1e3;
var PRIORITY_PROCESSOR_DEFAULT = 2e3;
var PRIORITY_PROCESSOR_STATISTIC = 5e3;
var PRIORITY_VISUAL_LAYOUT = 1e3;
var PRIORITY_VISUAL_PROGRESSIVE_LAYOUT = 1100;
var PRIORITY_VISUAL_GLOBAL = 2e3;
var PRIORITY_VISUAL_CHART = 3e3;
var PRIORITY_VISUAL_COMPONENT = 4e3;
var PRIORITY_VISUAL_CHART_DATA_CUSTOM = 4500;
var PRIORITY_VISUAL_POST_CHART_LAYOUT = 4600;
var PRIORITY_VISUAL_BRUSH = 5e3;
var PRIORITY_VISUAL_ARIA = 6e3;
var PRIORITY_VISUAL_DECAL = 7e3;
var PRIORITY = {
  PROCESSOR: {
    FILTER: PRIORITY_PROCESSOR_FILTER,
    SERIES_FILTER: PRIORITY_PROCESSOR_SERIES_FILTER,
    STATISTIC: PRIORITY_PROCESSOR_STATISTIC
  },
  VISUAL: {
    LAYOUT: PRIORITY_VISUAL_LAYOUT,
    PROGRESSIVE_LAYOUT: PRIORITY_VISUAL_PROGRESSIVE_LAYOUT,
    GLOBAL: PRIORITY_VISUAL_GLOBAL,
    CHART: PRIORITY_VISUAL_CHART,
    POST_CHART_LAYOUT: PRIORITY_VISUAL_POST_CHART_LAYOUT,
    COMPONENT: PRIORITY_VISUAL_COMPONENT,
    BRUSH: PRIORITY_VISUAL_BRUSH,
    CHART_ITEM: PRIORITY_VISUAL_CHART_DATA_CUSTOM,
    ARIA: PRIORITY_VISUAL_ARIA,
    DECAL: PRIORITY_VISUAL_DECAL
  }
};
var IN_MAIN_PROCESS_KEY = "__flagInMainProcess";
var PENDING_UPDATE = "__pendingUpdate";
var STATUS_NEEDS_UPDATE_KEY = "__needsUpdateStatus";
var ACTION_REG = /^[a-zA-Z0-9_]+$/;
var CONNECT_STATUS_KEY = "__connectUpdateStatus";
var CONNECT_STATUS_PENDING = 0;
var CONNECT_STATUS_UPDATING = 1;
var CONNECT_STATUS_UPDATED = 2;
function createRegisterEventWithLowercaseECharts(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    if (this.isDisposed()) {
      disposedWarning(this.id);
      return;
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function createRegisterEventWithLowercaseMessageCenter(method4) {
  return function() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args[_i] = arguments[_i];
    }
    return toLowercaseNameAndCallEventful(this, method4, args);
  };
}
function toLowercaseNameAndCallEventful(host, method4, args) {
  args[0] = args[0] && args[0].toLowerCase();
  return Eventful$1.prototype[method4].apply(host, args);
}
var MessageCenter = function(_super) {
  __extends(MessageCenter2, _super);
  function MessageCenter2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return MessageCenter2;
}(Eventful$1);
var messageCenterProto = MessageCenter.prototype;
messageCenterProto.on = createRegisterEventWithLowercaseMessageCenter("on");
messageCenterProto.off = createRegisterEventWithLowercaseMessageCenter("off");
var prepare;
var prepareView;
var updateDirectly;
var updateMethods;
var doConvertPixel;
var updateStreamModes;
var doDispatchAction;
var flushPendingActions;
var triggerUpdatedEvent;
var bindRenderedEvent;
var bindMouseEvent;
var render;
var renderComponents;
var renderSeries;
var createExtensionAPI;
var enableConnect;
var markStatusToUpdate;
var applyChangedStates;
var ECharts = function(_super) {
  __extends(ECharts2, _super);
  function ECharts2(dom, theme2, opts) {
    var _this = _super.call(this, new ECEventProcessor()) || this;
    _this._chartsViews = [];
    _this._chartsMap = {};
    _this._componentsViews = [];
    _this._componentsMap = {};
    _this._pendingActions = [];
    opts = opts || {};
    if (isString(theme2)) {
      theme2 = themeStorage[theme2];
    }
    _this._dom = dom;
    var defaultRenderer = "canvas";
    var defaultUseDirtyRect = false;
    var zr = _this._zr = init$2(dom, {
      renderer: opts.renderer || defaultRenderer,
      devicePixelRatio: opts.devicePixelRatio,
      width: opts.width,
      height: opts.height,
      ssr: opts.ssr,
      useDirtyRect: opts.useDirtyRect == null ? defaultUseDirtyRect : opts.useDirtyRect
    });
    _this._ssr = opts.ssr;
    _this._throttledZrFlush = throttle(bind$1(zr.flush, zr), 17);
    theme2 = clone$4(theme2);
    theme2 && globalBackwardCompat(theme2, true);
    _this._theme = theme2;
    _this._locale = createLocaleObject(opts.locale || SYSTEM_LANG);
    _this._coordSysMgr = new CoordinateSystem();
    var api = _this._api = createExtensionAPI(_this);
    function prioritySortFunc(a, b2) {
      return a.__prio - b2.__prio;
    }
    sort$2(visualFuncs, prioritySortFunc);
    sort$2(dataProcessorFuncs, prioritySortFunc);
    _this._scheduler = new Scheduler$1(_this, api, dataProcessorFuncs, visualFuncs);
    _this._messageCenter = new MessageCenter();
    _this._initEvents();
    _this.resize = bind$1(_this.resize, _this);
    zr.animation.on("frame", _this._onframe, _this);
    bindRenderedEvent(zr, _this);
    bindMouseEvent(zr, _this);
    setAsPrimitive(_this);
    return _this;
  }
  ECharts2.prototype._onframe = function() {
    if (this._disposed) {
      return;
    }
    applyChangedStates(this);
    var scheduler = this._scheduler;
    if (this[PENDING_UPDATE]) {
      var silent = this[PENDING_UPDATE].silent;
      this[IN_MAIN_PROCESS_KEY] = true;
      try {
        prepare(this);
        updateMethods.update.call(this, null, this[PENDING_UPDATE].updateParams);
      } catch (e2) {
        this[IN_MAIN_PROCESS_KEY] = false;
        this[PENDING_UPDATE] = null;
        throw e2;
      }
      this._zr.flush();
      this[IN_MAIN_PROCESS_KEY] = false;
      this[PENDING_UPDATE] = null;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    } else if (scheduler.unfinished) {
      var remainTime = TEST_FRAME_REMAIN_TIME;
      var ecModel = this._model;
      var api = this._api;
      scheduler.unfinished = false;
      do {
        var startTime = +new Date();
        scheduler.performSeriesTasks(ecModel);
        scheduler.performDataProcessorTasks(ecModel);
        updateStreamModes(this, ecModel);
        scheduler.performVisualTasks(ecModel);
        renderSeries(this, this._model, api, "remain", {});
        remainTime -= +new Date() - startTime;
      } while (remainTime > 0 && scheduler.unfinished);
      if (!scheduler.unfinished) {
        this._zr.flush();
      }
    }
  };
  ECharts2.prototype.getDom = function() {
    return this._dom;
  };
  ECharts2.prototype.getId = function() {
    return this.id;
  };
  ECharts2.prototype.getZr = function() {
    return this._zr;
  };
  ECharts2.prototype.isSSR = function() {
    return this._ssr;
  };
  ECharts2.prototype.setOption = function(option, notMerge, lazyUpdate) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var silent;
    var replaceMerge;
    var transitionOpt;
    if (isObject$4(notMerge)) {
      lazyUpdate = notMerge.lazyUpdate;
      silent = notMerge.silent;
      replaceMerge = notMerge.replaceMerge;
      transitionOpt = notMerge.transition;
      notMerge = notMerge.notMerge;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    if (!this._model || notMerge) {
      var optionManager = new OptionManager$1(this._api);
      var theme2 = this._theme;
      var ecModel = this._model = new GlobalModel$1();
      ecModel.scheduler = this._scheduler;
      ecModel.ssr = this._ssr;
      ecModel.init(null, null, null, theme2, this._locale, optionManager);
    }
    this._model.setOption(option, {
      replaceMerge
    }, optionPreprocessorFuncs);
    var updateParams = {
      seriesTransition: transitionOpt,
      optionChanged: true
    };
    if (lazyUpdate) {
      this[PENDING_UPDATE] = {
        silent,
        updateParams
      };
      this[IN_MAIN_PROCESS_KEY] = false;
      this.getZr().wakeUp();
    } else {
      try {
        prepare(this);
        updateMethods.update.call(this, null, updateParams);
      } catch (e2) {
        this[PENDING_UPDATE] = null;
        this[IN_MAIN_PROCESS_KEY] = false;
        throw e2;
      }
      if (!this._ssr) {
        this._zr.flush();
      }
      this[PENDING_UPDATE] = null;
      this[IN_MAIN_PROCESS_KEY] = false;
      flushPendingActions.call(this, silent);
      triggerUpdatedEvent.call(this, silent);
    }
  };
  ECharts2.prototype.setTheme = function() {
  };
  ECharts2.prototype.getModel = function() {
    return this._model;
  };
  ECharts2.prototype.getOption = function() {
    return this._model && this._model.getOption();
  };
  ECharts2.prototype.getWidth = function() {
    return this._zr.getWidth();
  };
  ECharts2.prototype.getHeight = function() {
    return this._zr.getHeight();
  };
  ECharts2.prototype.getDevicePixelRatio = function() {
    return this._zr.painter.dpr || hasWindow && window.devicePixelRatio || 1;
  };
  ECharts2.prototype.getRenderedCanvas = function(opts) {
    return this.renderToCanvas(opts);
  };
  ECharts2.prototype.renderToCanvas = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.getRenderedCanvas({
      backgroundColor: opts.backgroundColor || this._model.get("backgroundColor"),
      pixelRatio: opts.pixelRatio || this.getDevicePixelRatio()
    });
  };
  ECharts2.prototype.renderToSVGString = function(opts) {
    opts = opts || {};
    var painter = this._zr.painter;
    return painter.renderToString({
      useViewBox: opts.useViewBox
    });
  };
  ECharts2.prototype.getSvgDataURL = function() {
    if (!env$1.svgSupported) {
      return;
    }
    var zr = this._zr;
    var list = zr.storage.getDisplayList();
    each$f(list, function(el) {
      el.stopAnimation(null, true);
    });
    return zr.painter.toDataURL();
  };
  ECharts2.prototype.getDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    opts = opts || {};
    var excludeComponents = opts.excludeComponents;
    var ecModel = this._model;
    var excludesComponentViews = [];
    var self2 = this;
    each$f(excludeComponents, function(componentType) {
      ecModel.eachComponent({
        mainType: componentType
      }, function(component) {
        var view = self2._componentsMap[component.__viewId];
        if (!view.group.ignore) {
          excludesComponentViews.push(view);
          view.group.ignore = true;
        }
      });
    });
    var url2 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(opts).toDataURL("image/" + (opts && opts.type || "png"));
    each$f(excludesComponentViews, function(view) {
      view.group.ignore = false;
    });
    return url2;
  };
  ECharts2.prototype.getConnectedDataURL = function(opts) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var isSvg = opts.type === "svg";
    var groupId = this.group;
    var mathMin2 = Math.min;
    var mathMax2 = Math.max;
    var MAX_NUMBER = Infinity;
    if (connectedGroups[groupId]) {
      var left_1 = MAX_NUMBER;
      var top_1 = MAX_NUMBER;
      var right_1 = -MAX_NUMBER;
      var bottom_1 = -MAX_NUMBER;
      var canvasList_1 = [];
      var dpr_1 = opts && opts.pixelRatio || this.getDevicePixelRatio();
      each$f(instances, function(chart, id2) {
        if (chart.group === groupId) {
          var canvas = isSvg ? chart.getZr().painter.getSvgDom().innerHTML : chart.renderToCanvas(clone$4(opts));
          var boundingRect = chart.getDom().getBoundingClientRect();
          left_1 = mathMin2(boundingRect.left, left_1);
          top_1 = mathMin2(boundingRect.top, top_1);
          right_1 = mathMax2(boundingRect.right, right_1);
          bottom_1 = mathMax2(boundingRect.bottom, bottom_1);
          canvasList_1.push({
            dom: canvas,
            left: boundingRect.left,
            top: boundingRect.top
          });
        }
      });
      left_1 *= dpr_1;
      top_1 *= dpr_1;
      right_1 *= dpr_1;
      bottom_1 *= dpr_1;
      var width = right_1 - left_1;
      var height = bottom_1 - top_1;
      var targetCanvas = platformApi.createCanvas();
      var zr_1 = init$2(targetCanvas, {
        renderer: isSvg ? "svg" : "canvas"
      });
      zr_1.resize({
        width,
        height
      });
      if (isSvg) {
        var content_1 = "";
        each$f(canvasList_1, function(item) {
          var x2 = item.left - left_1;
          var y2 = item.top - top_1;
          content_1 += '<g transform="translate(' + x2 + "," + y2 + ')">' + item.dom + "</g>";
        });
        zr_1.painter.getSvgRoot().innerHTML = content_1;
        if (opts.connectedBackgroundColor) {
          zr_1.painter.setBackgroundColor(opts.connectedBackgroundColor);
        }
        zr_1.refreshImmediately();
        return zr_1.painter.toDataURL();
      } else {
        if (opts.connectedBackgroundColor) {
          zr_1.add(new Rect$3({
            shape: {
              x: 0,
              y: 0,
              width,
              height
            },
            style: {
              fill: opts.connectedBackgroundColor
            }
          }));
        }
        each$f(canvasList_1, function(item) {
          var img = new ZRImage$1({
            style: {
              x: item.left * dpr_1 - left_1,
              y: item.top * dpr_1 - top_1,
              image: item.dom
            }
          });
          zr_1.add(img);
        });
        zr_1.refreshImmediately();
        return targetCanvas.toDataURL("image/" + (opts && opts.type || "png"));
      }
    } else {
      return this.getDataURL(opts);
    }
  };
  ECharts2.prototype.convertToPixel = function(finder, value) {
    return doConvertPixel(this, "convertToPixel", finder, value);
  };
  ECharts2.prototype.convertFromPixel = function(finder, value) {
    return doConvertPixel(this, "convertFromPixel", finder, value);
  };
  ECharts2.prototype.containPixel = function(finder, value) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var ecModel = this._model;
    var result;
    var findResult = parseFinder$1(ecModel, finder);
    each$f(findResult, function(models, key) {
      key.indexOf("Models") >= 0 && each$f(models, function(model) {
        var coordSys = model.coordinateSystem;
        if (coordSys && coordSys.containPoint) {
          result = result || !!coordSys.containPoint(value);
        } else if (key === "seriesModels") {
          var view = this._chartsMap[model.__viewId];
          if (view && view.containPoint) {
            result = result || view.containPoint(value, model);
          }
        } else
          ;
      }, this);
    }, this);
    return !!result;
  };
  ECharts2.prototype.getVisual = function(finder, visualType) {
    var ecModel = this._model;
    var parsedFinder = parseFinder$1(ecModel, finder, {
      defaultMainType: "series"
    });
    var seriesModel = parsedFinder.seriesModel;
    var data = seriesModel.getData();
    var dataIndexInside = parsedFinder.hasOwnProperty("dataIndexInside") ? parsedFinder.dataIndexInside : parsedFinder.hasOwnProperty("dataIndex") ? data.indexOfRawIndex(parsedFinder.dataIndex) : null;
    return dataIndexInside != null ? getItemVisualFromData(data, dataIndexInside, visualType) : getVisualFromData(data, visualType);
  };
  ECharts2.prototype.getViewOfComponentModel = function(componentModel) {
    return this._componentsMap[componentModel.__viewId];
  };
  ECharts2.prototype.getViewOfSeriesModel = function(seriesModel) {
    return this._chartsMap[seriesModel.__viewId];
  };
  ECharts2.prototype._initEvents = function() {
    var _this = this;
    each$f(MOUSE_EVENT_NAMES, function(eveName) {
      var handler = function(e2) {
        var ecModel = _this.getModel();
        var el = e2.target;
        var params;
        var isGlobalOut = eveName === "globalout";
        if (isGlobalOut) {
          params = {};
        } else {
          el && findEventDispatcher(el, function(parent) {
            var ecData = getECData(parent);
            if (ecData && ecData.dataIndex != null) {
              var dataModel = ecData.dataModel || ecModel.getSeriesByIndex(ecData.seriesIndex);
              params = dataModel && dataModel.getDataParams(ecData.dataIndex, ecData.dataType) || {};
              return true;
            } else if (ecData.eventData) {
              params = extend({}, ecData.eventData);
              return true;
            }
          }, true);
        }
        if (params) {
          var componentType = params.componentType;
          var componentIndex = params.componentIndex;
          if (componentType === "markLine" || componentType === "markPoint" || componentType === "markArea") {
            componentType = "series";
            componentIndex = params.seriesIndex;
          }
          var model = componentType && componentIndex != null && ecModel.getComponent(componentType, componentIndex);
          var view = model && _this[model.mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId];
          params.event = e2;
          params.type = eveName;
          _this._$eventProcessor.eventInfo = {
            targetEl: el,
            packedEvent: params,
            model,
            view
          };
          _this.trigger(eveName, params);
        }
      };
      handler.zrEventfulCallAtLast = true;
      _this._zr.on(eveName, handler, _this);
    });
    each$f(eventActionMap, function(actionType, eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    each$f(["selectchanged"], function(eventType) {
      _this._messageCenter.on(eventType, function(event) {
        this.trigger(eventType, event);
      }, _this);
    });
    handleLegacySelectEvents(this._messageCenter, this, this._api);
  };
  ECharts2.prototype.isDisposed = function() {
    return this._disposed;
  };
  ECharts2.prototype.clear = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this.setOption({
      series: []
    }, true);
  };
  ECharts2.prototype.dispose = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._disposed = true;
    var dom = this.getDom();
    if (dom) {
      setAttribute(this.getDom(), DOM_ATTRIBUTE_KEY, "");
    }
    var chart = this;
    var api = chart._api;
    var ecModel = chart._model;
    each$f(chart._componentsViews, function(component) {
      component.dispose(ecModel, api);
    });
    each$f(chart._chartsViews, function(chart2) {
      chart2.dispose(ecModel, api);
    });
    chart._zr.dispose();
    chart._dom = chart._model = chart._chartsMap = chart._componentsMap = chart._chartsViews = chart._componentsViews = chart._scheduler = chart._api = chart._zr = chart._throttledZrFlush = chart._theme = chart._coordSysMgr = chart._messageCenter = null;
    delete instances[chart.id];
  };
  ECharts2.prototype.resize = function(opts) {
    if (this[IN_MAIN_PROCESS_KEY]) {
      return;
    }
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._zr.resize(opts);
    var ecModel = this._model;
    this._loadingFX && this._loadingFX.resize();
    if (!ecModel) {
      return;
    }
    var needPrepare = ecModel.resetOption("media");
    var silent = opts && opts.silent;
    if (this[PENDING_UPDATE]) {
      if (silent == null) {
        silent = this[PENDING_UPDATE].silent;
      }
      needPrepare = true;
      this[PENDING_UPDATE] = null;
    }
    this[IN_MAIN_PROCESS_KEY] = true;
    try {
      needPrepare && prepare(this);
      updateMethods.update.call(this, {
        type: "resize",
        animation: extend({
          duration: 0
        }, opts && opts.animation)
      });
    } catch (e2) {
      this[IN_MAIN_PROCESS_KEY] = false;
      throw e2;
    }
    this[IN_MAIN_PROCESS_KEY] = false;
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.showLoading = function(name, cfg) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (isObject$4(name)) {
      cfg = name;
      name = "";
    }
    name = name || "default";
    this.hideLoading();
    if (!loadingEffects[name]) {
      return;
    }
    var el = loadingEffects[name](this._api, cfg);
    var zr = this._zr;
    this._loadingFX = el;
    zr.add(el);
  };
  ECharts2.prototype.hideLoading = function() {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    this._loadingFX && this._zr.remove(this._loadingFX);
    this._loadingFX = null;
  };
  ECharts2.prototype.makeActionFromEvent = function(eventObj) {
    var payload = extend({}, eventObj);
    payload.type = eventActionMap[eventObj.type];
    return payload;
  };
  ECharts2.prototype.dispatchAction = function(payload, opt) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    if (!isObject$4(opt)) {
      opt = {
        silent: !!opt
      };
    }
    if (!actions[payload.type]) {
      return;
    }
    if (!this._model) {
      return;
    }
    if (this[IN_MAIN_PROCESS_KEY]) {
      this._pendingActions.push(payload);
      return;
    }
    var silent = opt.silent;
    doDispatchAction.call(this, payload, silent);
    var flush = opt.flush;
    if (flush) {
      this._zr.flush();
    } else if (flush !== false && env$1.browser.weChat) {
      this._throttledZrFlush();
    }
    flushPendingActions.call(this, silent);
    triggerUpdatedEvent.call(this, silent);
  };
  ECharts2.prototype.updateLabelLayout = function() {
    lifecycle$1.trigger("series:layoutlabels", this._model, this._api, {
      updatedSeries: []
    });
  };
  ECharts2.prototype.appendData = function(params) {
    if (this._disposed) {
      disposedWarning(this.id);
      return;
    }
    var seriesIndex = params.seriesIndex;
    var ecModel = this.getModel();
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    seriesModel.appendData(params);
    this._scheduler.unfinished = true;
    this.getZr().wakeUp();
  };
  ECharts2.internalField = function() {
    prepare = function(ecIns) {
      var scheduler = ecIns._scheduler;
      scheduler.restorePipelines(ecIns._model);
      scheduler.prepareStageTasks();
      prepareView(ecIns, true);
      prepareView(ecIns, false);
      scheduler.plan();
    };
    prepareView = function(ecIns, isComponent) {
      var ecModel = ecIns._model;
      var scheduler = ecIns._scheduler;
      var viewList = isComponent ? ecIns._componentsViews : ecIns._chartsViews;
      var viewMap = isComponent ? ecIns._componentsMap : ecIns._chartsMap;
      var zr = ecIns._zr;
      var api = ecIns._api;
      for (var i = 0; i < viewList.length; i++) {
        viewList[i].__alive = false;
      }
      isComponent ? ecModel.eachComponent(function(componentType, model) {
        componentType !== "series" && doPrepare(model);
      }) : ecModel.eachSeries(doPrepare);
      function doPrepare(model) {
        var requireNewView = model.__requireNewView;
        model.__requireNewView = false;
        var viewId = "_ec_" + model.id + "_" + model.type;
        var view2 = !requireNewView && viewMap[viewId];
        if (!view2) {
          var classType = parseClassType(model.type);
          var Clazz = isComponent ? ComponentView$1.getClass(classType.main, classType.sub) : ChartView$1.getClass(classType.sub);
          view2 = new Clazz();
          view2.init(ecModel, api);
          viewMap[viewId] = view2;
          viewList.push(view2);
          zr.add(view2.group);
        }
        model.__viewId = view2.__id = viewId;
        view2.__alive = true;
        view2.__model = model;
        view2.group.__ecComponentInfo = {
          mainType: model.mainType,
          index: model.componentIndex
        };
        !isComponent && scheduler.prepareView(view2, model, ecModel, api);
      }
      for (var i = 0; i < viewList.length; ) {
        var view = viewList[i];
        if (!view.__alive) {
          !isComponent && view.renderTask.dispose();
          zr.remove(view.group);
          view.dispose(ecModel, api);
          viewList.splice(i, 1);
          if (viewMap[view.__id] === view) {
            delete viewMap[view.__id];
          }
          view.__id = view.group.__ecComponentInfo = null;
        } else {
          i++;
        }
      }
    };
    updateDirectly = function(ecIns, method4, payload, mainType, subType) {
      var ecModel = ecIns._model;
      ecModel.setUpdatePayload(payload);
      if (!mainType) {
        each$f([].concat(ecIns._componentsViews).concat(ecIns._chartsViews), callView);
        return;
      }
      var query = {};
      query[mainType + "Id"] = payload[mainType + "Id"];
      query[mainType + "Index"] = payload[mainType + "Index"];
      query[mainType + "Name"] = payload[mainType + "Name"];
      var condition = {
        mainType,
        query
      };
      subType && (condition.subType = subType);
      var excludeSeriesId = payload.excludeSeriesId;
      var excludeSeriesIdMap;
      if (excludeSeriesId != null) {
        excludeSeriesIdMap = createHashMap();
        each$f(normalizeToArray(excludeSeriesId), function(id2) {
          var modelId = convertOptionIdName(id2, null);
          if (modelId != null) {
            excludeSeriesIdMap.set(modelId, true);
          }
        });
      }
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        if (isHighDownPayload(payload)) {
          if (model instanceof SeriesModel$1) {
            if (payload.type === HIGHLIGHT_ACTION_TYPE && !payload.notBlur && !model.get(["emphasis", "disabled"])) {
              blurSeriesFromHighlightPayload(model, payload, ecIns._api);
            }
          } else {
            var _a2 = findComponentHighDownDispatchers(model.mainType, model.componentIndex, payload.name, ecIns._api), focusSelf = _a2.focusSelf, dispatchers = _a2.dispatchers;
            if (payload.type === HIGHLIGHT_ACTION_TYPE && focusSelf && !payload.notBlur) {
              blurComponent(model.mainType, model.componentIndex, ecIns._api);
            }
            if (dispatchers) {
              each$f(dispatchers, function(dispatcher) {
                payload.type === HIGHLIGHT_ACTION_TYPE ? enterEmphasis(dispatcher) : leaveEmphasis(dispatcher);
              });
            }
          }
        } else if (isSelectChangePayload(payload)) {
          if (model instanceof SeriesModel$1) {
            toggleSelectionFromPayload(model, payload, ecIns._api);
            updateSeriesElementSelection(model);
            markStatusToUpdate(ecIns);
          }
        }
      }, ecIns);
      ecModel && ecModel.eachComponent(condition, function(model) {
        var isExcluded = excludeSeriesIdMap && excludeSeriesIdMap.get(model.id) !== null;
        if (isExcluded) {
          return;
        }
        callView(ecIns[mainType === "series" ? "_chartsMap" : "_componentsMap"][model.__viewId]);
      }, ecIns);
      function callView(view) {
        view && view.__alive && view[method4] && view[method4](view.__model, ecModel, ecIns._api, payload);
      }
    };
    updateMethods = {
      prepareAndUpdate: function(payload) {
        prepare(this);
        updateMethods.update.call(this, payload, {
          optionChanged: payload.newOption != null
        });
      },
      update: function(payload, updateParams) {
        var ecModel = this._model;
        var api = this._api;
        var zr = this._zr;
        var coordSysMgr = this._coordSysMgr;
        var scheduler = this._scheduler;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        scheduler.restoreData(ecModel, payload);
        scheduler.performSeriesTasks(ecModel);
        coordSysMgr.create(ecModel, api);
        scheduler.performDataProcessorTasks(ecModel, payload);
        updateStreamModes(this, ecModel);
        coordSysMgr.update(ecModel, api);
        clearColorPalette(ecModel);
        scheduler.performVisualTasks(ecModel, payload);
        render(this, ecModel, api, payload, updateParams);
        var backgroundColor2 = ecModel.get("backgroundColor") || "transparent";
        var darkMode = ecModel.get("darkMode");
        zr.setBackgroundColor(backgroundColor2);
        if (darkMode != null && darkMode !== "auto") {
          zr.setDarkMode(darkMode);
        }
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateTransform: function(payload) {
        var _this = this;
        var ecModel = this._model;
        var api = this._api;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        var componentDirtyList = [];
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType === "series") {
            return;
          }
          var componentView = _this.getViewOfComponentModel(componentModel);
          if (componentView && componentView.__alive) {
            if (componentView.updateTransform) {
              var result = componentView.updateTransform(componentModel, ecModel, api, payload);
              result && result.update && componentDirtyList.push(componentView);
            } else {
              componentDirtyList.push(componentView);
            }
          }
        });
        var seriesDirtyMap = createHashMap();
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          if (chartView.updateTransform) {
            var result = chartView.updateTransform(seriesModel, ecModel, api, payload);
            result && result.update && seriesDirtyMap.set(seriesModel.uid, 1);
          } else {
            seriesDirtyMap.set(seriesModel.uid, 1);
          }
        });
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true,
          dirtyMap: seriesDirtyMap
        });
        renderSeries(this, ecModel, api, payload, {}, seriesDirtyMap);
        lifecycle$1.trigger("afterupdate", ecModel, api);
      },
      updateView: function(payload) {
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ChartView$1.markUpdateMethod(payload, "updateView");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          setDirty: true
        });
        render(this, ecModel, this._api, payload, {});
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateVisual: function(payload) {
        var _this = this;
        var ecModel = this._model;
        if (!ecModel) {
          return;
        }
        ecModel.setUpdatePayload(payload);
        ecModel.eachSeries(function(seriesModel) {
          seriesModel.getData().clearAllVisual();
        });
        ChartView$1.markUpdateMethod(payload, "updateVisual");
        clearColorPalette(ecModel);
        this._scheduler.performVisualTasks(ecModel, payload, {
          visualType: "visual",
          setDirty: true
        });
        ecModel.eachComponent(function(componentType, componentModel) {
          if (componentType !== "series") {
            var componentView = _this.getViewOfComponentModel(componentModel);
            componentView && componentView.__alive && componentView.updateVisual(componentModel, ecModel, _this._api, payload);
          }
        });
        ecModel.eachSeries(function(seriesModel) {
          var chartView = _this._chartsMap[seriesModel.__viewId];
          chartView.updateVisual(seriesModel, ecModel, _this._api, payload);
        });
        lifecycle$1.trigger("afterupdate", ecModel, this._api);
      },
      updateLayout: function(payload) {
        updateMethods.update.call(this, payload);
      }
    };
    doConvertPixel = function(ecIns, methodName, finder, value) {
      if (ecIns._disposed) {
        disposedWarning(ecIns.id);
        return;
      }
      var ecModel = ecIns._model;
      var coordSysList = ecIns._coordSysMgr.getCoordinateSystems();
      var result;
      var parsedFinder = parseFinder$1(ecModel, finder);
      for (var i = 0; i < coordSysList.length; i++) {
        var coordSys = coordSysList[i];
        if (coordSys[methodName] && (result = coordSys[methodName](ecModel, parsedFinder, value)) != null) {
          return result;
        }
      }
    };
    updateStreamModes = function(ecIns, ecModel) {
      var chartsMap = ecIns._chartsMap;
      var scheduler = ecIns._scheduler;
      ecModel.eachSeries(function(seriesModel) {
        scheduler.updateStreamModes(seriesModel, chartsMap[seriesModel.__viewId]);
      });
    };
    doDispatchAction = function(payload, silent) {
      var _this = this;
      var ecModel = this.getModel();
      var payloadType = payload.type;
      var escapeConnect = payload.escapeConnect;
      var actionWrap = actions[payloadType];
      var actionInfo2 = actionWrap.actionInfo;
      var cptTypeTmp = (actionInfo2.update || "update").split(":");
      var updateMethod = cptTypeTmp.pop();
      var cptType = cptTypeTmp[0] != null && parseClassType(cptTypeTmp[0]);
      this[IN_MAIN_PROCESS_KEY] = true;
      var payloads = [payload];
      var batched = false;
      if (payload.batch) {
        batched = true;
        payloads = map$1(payload.batch, function(item) {
          item = defaults(extend({}, item), payload);
          item.batch = null;
          return item;
        });
      }
      var eventObjBatch = [];
      var eventObj;
      var isSelectChange = isSelectChangePayload(payload);
      var isHighDown = isHighDownPayload(payload);
      if (isHighDown) {
        allLeaveBlur(this._api);
      }
      each$f(payloads, function(batchItem) {
        eventObj = actionWrap.action(batchItem, _this._model, _this._api);
        eventObj = eventObj || extend({}, batchItem);
        eventObj.type = actionInfo2.event || eventObj.type;
        eventObjBatch.push(eventObj);
        if (isHighDown) {
          var _a2 = preParseFinder(payload), queryOptionMap = _a2.queryOptionMap, mainTypeSpecified = _a2.mainTypeSpecified;
          var componentMainType = mainTypeSpecified ? queryOptionMap.keys()[0] : "series";
          updateDirectly(_this, updateMethod, batchItem, componentMainType);
          markStatusToUpdate(_this);
        } else if (isSelectChange) {
          updateDirectly(_this, updateMethod, batchItem, "series");
          markStatusToUpdate(_this);
        } else if (cptType) {
          updateDirectly(_this, updateMethod, batchItem, cptType.main, cptType.sub);
        }
      });
      if (updateMethod !== "none" && !isHighDown && !isSelectChange && !cptType) {
        try {
          if (this[PENDING_UPDATE]) {
            prepare(this);
            updateMethods.update.call(this, payload);
            this[PENDING_UPDATE] = null;
          } else {
            updateMethods[updateMethod].call(this, payload);
          }
        } catch (e2) {
          this[IN_MAIN_PROCESS_KEY] = false;
          throw e2;
        }
      }
      if (batched) {
        eventObj = {
          type: actionInfo2.event || payloadType,
          escapeConnect,
          batch: eventObjBatch
        };
      } else {
        eventObj = eventObjBatch[0];
      }
      this[IN_MAIN_PROCESS_KEY] = false;
      if (!silent) {
        var messageCenter = this._messageCenter;
        messageCenter.trigger(eventObj.type, eventObj);
        if (isSelectChange) {
          var newObj = {
            type: "selectchanged",
            escapeConnect,
            selected: getAllSelectedIndices(ecModel),
            isFromClick: payload.isFromClick || false,
            fromAction: payload.type,
            fromActionPayload: payload
          };
          messageCenter.trigger(newObj.type, newObj);
        }
      }
    };
    flushPendingActions = function(silent) {
      var pendingActions = this._pendingActions;
      while (pendingActions.length) {
        var payload = pendingActions.shift();
        doDispatchAction.call(this, payload, silent);
      }
    };
    triggerUpdatedEvent = function(silent) {
      !silent && this.trigger("updated");
    };
    bindRenderedEvent = function(zr, ecIns) {
      zr.on("rendered", function(params) {
        ecIns.trigger("rendered", params);
        if (zr.animation.isFinished() && !ecIns[PENDING_UPDATE] && !ecIns._scheduler.unfinished && !ecIns._pendingActions.length) {
          ecIns.trigger("finished");
        }
      });
    };
    bindMouseEvent = function(zr, ecIns) {
      zr.on("mouseover", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOverForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("mouseout", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, isHighDownDispatcher);
        if (dispatcher) {
          handleGlobalMouseOutForHighDown(dispatcher, e2, ecIns._api);
          markStatusToUpdate(ecIns);
        }
      }).on("click", function(e2) {
        var el = e2.target;
        var dispatcher = findEventDispatcher(el, function(target) {
          return getECData(target).dataIndex != null;
        }, true);
        if (dispatcher) {
          var actionType = dispatcher.selected ? "unselect" : "select";
          var ecData = getECData(dispatcher);
          ecIns._api.dispatchAction({
            type: actionType,
            dataType: ecData.dataType,
            dataIndexInside: ecData.dataIndex,
            seriesIndex: ecData.seriesIndex,
            isFromClick: true
          });
        }
      });
    };
    function clearColorPalette(ecModel) {
      ecModel.clearColorPalette();
      ecModel.eachSeries(function(seriesModel) {
        seriesModel.clearColorPalette();
      });
    }
    function allocateZlevels(ecModel) {
      var componentZLevels = [];
      var seriesZLevels = [];
      var hasSeperateZLevel = false;
      ecModel.eachComponent(function(componentType, componentModel) {
        var zlevel = componentModel.get("zlevel") || 0;
        var z2 = componentModel.get("z") || 0;
        var zlevelKey = componentModel.getZLevelKey();
        hasSeperateZLevel = hasSeperateZLevel || !!zlevelKey;
        (componentType === "series" ? seriesZLevels : componentZLevels).push({
          zlevel,
          z: z2,
          idx: componentModel.componentIndex,
          type: componentType,
          key: zlevelKey
        });
      });
      if (hasSeperateZLevel) {
        var zLevels = componentZLevels.concat(seriesZLevels);
        var lastSeriesZLevel_1;
        var lastSeriesKey_1;
        sort$2(zLevels, function(a, b2) {
          if (a.zlevel === b2.zlevel) {
            return a.z - b2.z;
          }
          return a.zlevel - b2.zlevel;
        });
        each$f(zLevels, function(item) {
          var componentModel = ecModel.getComponent(item.type, item.idx);
          var zlevel = item.zlevel;
          var key = item.key;
          if (lastSeriesZLevel_1 != null) {
            zlevel = Math.max(lastSeriesZLevel_1, zlevel);
          }
          if (key) {
            if (zlevel === lastSeriesZLevel_1 && key !== lastSeriesKey_1) {
              zlevel++;
            }
            lastSeriesKey_1 = key;
          } else if (lastSeriesKey_1) {
            if (zlevel === lastSeriesZLevel_1) {
              zlevel++;
            }
            lastSeriesKey_1 = "";
          }
          lastSeriesZLevel_1 = zlevel;
          componentModel.setZLevel(zlevel);
        });
      }
    }
    render = function(ecIns, ecModel, api, payload, updateParams) {
      allocateZlevels(ecModel);
      renderComponents(ecIns, ecModel, api, payload, updateParams);
      each$f(ecIns._chartsViews, function(chart) {
        chart.__alive = false;
      });
      renderSeries(ecIns, ecModel, api, payload, updateParams);
      each$f(ecIns._chartsViews, function(chart) {
        if (!chart.__alive) {
          chart.remove(ecModel, api);
        }
      });
    };
    renderComponents = function(ecIns, ecModel, api, payload, updateParams, dirtyList) {
      each$f(dirtyList || ecIns._componentsViews, function(componentView) {
        var componentModel = componentView.__model;
        clearStates(componentModel, componentView);
        componentView.render(componentModel, ecModel, api, payload);
        updateZ2(componentModel, componentView);
        updateStates(componentModel, componentView);
      });
    };
    renderSeries = function(ecIns, ecModel, api, payload, updateParams, dirtyMap) {
      var scheduler = ecIns._scheduler;
      updateParams = extend(updateParams || {}, {
        updatedSeries: ecModel.getSeries()
      });
      lifecycle$1.trigger("series:beforeupdate", ecModel, api, updateParams);
      var unfinished = false;
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        chartView.__alive = true;
        var renderTask = chartView.renderTask;
        scheduler.updatePayload(renderTask, payload);
        clearStates(seriesModel, chartView);
        if (dirtyMap && dirtyMap.get(seriesModel.uid)) {
          renderTask.dirty();
        }
        if (renderTask.perform(scheduler.getPerformArgs(renderTask))) {
          unfinished = true;
        }
        chartView.group.silent = !!seriesModel.get("silent");
        updateBlend(seriesModel, chartView);
        updateSeriesElementSelection(seriesModel);
      });
      scheduler.unfinished = unfinished || scheduler.unfinished;
      lifecycle$1.trigger("series:layoutlabels", ecModel, api, updateParams);
      lifecycle$1.trigger("series:transition", ecModel, api, updateParams);
      ecModel.eachSeries(function(seriesModel) {
        var chartView = ecIns._chartsMap[seriesModel.__viewId];
        updateZ2(seriesModel, chartView);
        updateStates(seriesModel, chartView);
      });
      updateHoverLayerStatus(ecIns, ecModel);
      lifecycle$1.trigger("series:afterupdate", ecModel, api, updateParams);
    };
    markStatusToUpdate = function(ecIns) {
      ecIns[STATUS_NEEDS_UPDATE_KEY] = true;
      ecIns.getZr().wakeUp();
    };
    applyChangedStates = function(ecIns) {
      if (!ecIns[STATUS_NEEDS_UPDATE_KEY]) {
        return;
      }
      ecIns.getZr().storage.traverse(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        applyElementStates(el);
      });
      ecIns[STATUS_NEEDS_UPDATE_KEY] = false;
    };
    function applyElementStates(el) {
      var newStates = [];
      var oldStates = el.currentStates;
      for (var i = 0; i < oldStates.length; i++) {
        var stateName = oldStates[i];
        if (!(stateName === "emphasis" || stateName === "blur" || stateName === "select")) {
          newStates.push(stateName);
        }
      }
      if (el.selected && el.states.select) {
        newStates.push("select");
      }
      if (el.hoverState === HOVER_STATE_EMPHASIS && el.states.emphasis) {
        newStates.push("emphasis");
      } else if (el.hoverState === HOVER_STATE_BLUR && el.states.blur) {
        newStates.push("blur");
      }
      el.useStates(newStates);
    }
    function updateHoverLayerStatus(ecIns, ecModel) {
      var zr = ecIns._zr;
      var storage2 = zr.storage;
      var elCount = 0;
      storage2.traverse(function(el) {
        if (!el.isGroup) {
          elCount++;
        }
      });
      if (elCount > ecModel.get("hoverLayerThreshold") && !env$1.node && !env$1.worker) {
        ecModel.eachSeries(function(seriesModel) {
          if (seriesModel.preventUsingHoverLayer) {
            return;
          }
          var chartView = ecIns._chartsMap[seriesModel.__viewId];
          if (chartView.__alive) {
            chartView.eachRendered(function(el) {
              if (el.states.emphasis) {
                el.states.emphasis.hoverLayer = true;
              }
            });
          }
        });
      }
    }
    function updateBlend(seriesModel, chartView) {
      var blendMode = seriesModel.get("blendMode") || null;
      chartView.eachRendered(function(el) {
        if (!el.isGroup) {
          el.style.blend = blendMode;
        }
      });
    }
    function updateZ2(model, view) {
      if (model.preventAutoZ) {
        return;
      }
      var z2 = model.get("z") || 0;
      var zlevel = model.get("zlevel") || 0;
      view.eachRendered(function(el) {
        doUpdateZ(el, z2, zlevel, -Infinity);
        return true;
      });
    }
    function doUpdateZ(el, z2, zlevel, maxZ2) {
      var label = el.getTextContent();
      var labelLine = el.getTextGuideLine();
      var isGroup = el.isGroup;
      if (isGroup) {
        var children = el.childrenRef();
        for (var i = 0; i < children.length; i++) {
          maxZ2 = Math.max(doUpdateZ(children[i], z2, zlevel, maxZ2), maxZ2);
        }
      } else {
        el.z = z2;
        el.zlevel = zlevel;
        maxZ2 = Math.max(el.z2, maxZ2);
      }
      if (label) {
        label.z = z2;
        label.zlevel = zlevel;
        isFinite(maxZ2) && (label.z2 = maxZ2 + 2);
      }
      if (labelLine) {
        var textGuideLineConfig = el.textGuideLineConfig;
        labelLine.z = z2;
        labelLine.zlevel = zlevel;
        isFinite(maxZ2) && (labelLine.z2 = maxZ2 + (textGuideLineConfig && textGuideLineConfig.showAbove ? 1 : -1));
      }
      return maxZ2;
    }
    function clearStates(model, view) {
      view.eachRendered(function(el) {
        if (isElementRemoved(el)) {
          return;
        }
        var textContent = el.getTextContent();
        var textGuide = el.getTextGuideLine();
        if (el.stateTransition) {
          el.stateTransition = null;
        }
        if (textContent && textContent.stateTransition) {
          textContent.stateTransition = null;
        }
        if (textGuide && textGuide.stateTransition) {
          textGuide.stateTransition = null;
        }
        if (el.hasState()) {
          el.prevStates = el.currentStates;
          el.clearStates();
        } else if (el.prevStates) {
          el.prevStates = null;
        }
      });
    }
    function updateStates(model, view) {
      var stateAnimationModel = model.getModel("stateAnimation");
      var enableAnimation = model.isAnimationEnabled();
      var duration = stateAnimationModel.get("duration");
      var stateTransition = duration > 0 ? {
        duration,
        delay: stateAnimationModel.get("delay"),
        easing: stateAnimationModel.get("easing")
      } : null;
      view.eachRendered(function(el) {
        if (el.states && el.states.emphasis) {
          if (isElementRemoved(el)) {
            return;
          }
          if (el instanceof Path$1) {
            savePathStates(el);
          }
          if (el.__dirty) {
            var prevStates = el.prevStates;
            if (prevStates) {
              el.useStates(prevStates);
            }
          }
          if (enableAnimation) {
            el.stateTransition = stateTransition;
            var textContent = el.getTextContent();
            var textGuide = el.getTextGuideLine();
            if (textContent) {
              textContent.stateTransition = stateTransition;
            }
            if (textGuide) {
              textGuide.stateTransition = stateTransition;
            }
          }
          if (el.__dirty) {
            applyElementStates(el);
          }
        }
      });
    }
    createExtensionAPI = function(ecIns) {
      return new (function(_super2) {
        __extends(class_1, _super2);
        function class_1() {
          return _super2 !== null && _super2.apply(this, arguments) || this;
        }
        class_1.prototype.getCoordinateSystems = function() {
          return ecIns._coordSysMgr.getCoordinateSystems();
        };
        class_1.prototype.getComponentByElement = function(el) {
          while (el) {
            var modelInfo = el.__ecComponentInfo;
            if (modelInfo != null) {
              return ecIns._model.getComponent(modelInfo.mainType, modelInfo.index);
            }
            el = el.parent;
          }
        };
        class_1.prototype.enterEmphasis = function(el, highlightDigit) {
          enterEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveEmphasis = function(el, highlightDigit) {
          leaveEmphasis(el, highlightDigit);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterBlur = function(el) {
          enterBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveBlur = function(el) {
          leaveBlur(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.enterSelect = function(el) {
          enterSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.leaveSelect = function(el) {
          leaveSelect(el);
          markStatusToUpdate(ecIns);
        };
        class_1.prototype.getModel = function() {
          return ecIns.getModel();
        };
        class_1.prototype.getViewOfComponentModel = function(componentModel) {
          return ecIns.getViewOfComponentModel(componentModel);
        };
        class_1.prototype.getViewOfSeriesModel = function(seriesModel) {
          return ecIns.getViewOfSeriesModel(seriesModel);
        };
        return class_1;
      }(ExtensionAPI$1))(ecIns);
    };
    enableConnect = function(chart) {
      function updateConnectedChartsStatus(charts, status) {
        for (var i = 0; i < charts.length; i++) {
          var otherChart = charts[i];
          otherChart[CONNECT_STATUS_KEY] = status;
        }
      }
      each$f(eventActionMap, function(actionType, eventType) {
        chart._messageCenter.on(eventType, function(event) {
          if (connectedGroups[chart.group] && chart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_PENDING) {
            if (event && event.escapeConnect) {
              return;
            }
            var action_1 = chart.makeActionFromEvent(event);
            var otherCharts_1 = [];
            each$f(instances, function(otherChart) {
              if (otherChart !== chart && otherChart.group === chart.group) {
                otherCharts_1.push(otherChart);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_PENDING);
            each$f(otherCharts_1, function(otherChart) {
              if (otherChart[CONNECT_STATUS_KEY] !== CONNECT_STATUS_UPDATING) {
                otherChart.dispatchAction(action_1);
              }
            });
            updateConnectedChartsStatus(otherCharts_1, CONNECT_STATUS_UPDATED);
          }
        });
      });
    };
  }();
  return ECharts2;
}(Eventful$1);
var echartsProto = ECharts.prototype;
echartsProto.on = createRegisterEventWithLowercaseECharts("on");
echartsProto.off = createRegisterEventWithLowercaseECharts("off");
echartsProto.one = function(eventName, cb, ctx) {
  var self2 = this;
  function wrapped() {
    var args2 = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      args2[_i] = arguments[_i];
    }
    cb && cb.apply && cb.apply(this, args2);
    self2.off(eventName, wrapped);
  }
  this.on.call(this, eventName, wrapped, ctx);
};
var MOUSE_EVENT_NAMES = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
function disposedWarning(id2) {
}
var actions = {};
var eventActionMap = {};
var dataProcessorFuncs = [];
var optionPreprocessorFuncs = [];
var visualFuncs = [];
var themeStorage = {};
var loadingEffects = {};
var instances = {};
var connectedGroups = {};
var idBase = +new Date() - 0;
var DOM_ATTRIBUTE_KEY = "_echarts_instance_";
function init$1(dom, theme2, opts) {
  var isClient = !(opts && opts.ssr);
  if (isClient) {
    var existInstance = getInstanceByDom(dom);
    if (existInstance) {
      return existInstance;
    }
  }
  var chart = new ECharts(dom, theme2, opts);
  chart.id = "ec_" + idBase++;
  instances[chart.id] = chart;
  isClient && setAttribute(dom, DOM_ATTRIBUTE_KEY, chart.id);
  enableConnect(chart);
  lifecycle$1.trigger("afterinit", chart);
  return chart;
}
function getInstanceByDom(dom) {
  return instances[getAttribute(dom, DOM_ATTRIBUTE_KEY)];
}
function registerTheme(name, theme2) {
  themeStorage[name] = theme2;
}
function registerPreprocessor(preprocessorFunc) {
  if (indexOf(optionPreprocessorFuncs, preprocessorFunc) < 0) {
    optionPreprocessorFuncs.push(preprocessorFunc);
  }
}
function registerProcessor(priority, processor) {
  normalizeRegister(dataProcessorFuncs, priority, processor, PRIORITY_PROCESSOR_DEFAULT);
}
function registerPostInit(postInitFunc) {
  registerUpdateLifecycle("afterinit", postInitFunc);
}
function registerPostUpdate(postUpdateFunc) {
  registerUpdateLifecycle("afterupdate", postUpdateFunc);
}
function registerUpdateLifecycle(name, cb) {
  lifecycle$1.on(name, cb);
}
function registerAction(actionInfo2, eventName, action) {
  if (isFunction(eventName)) {
    action = eventName;
    eventName = "";
  }
  var actionType = isObject$4(actionInfo2) ? actionInfo2.type : [actionInfo2, actionInfo2 = {
    event: eventName
  }][0];
  actionInfo2.event = (actionInfo2.event || actionType).toLowerCase();
  eventName = actionInfo2.event;
  if (eventActionMap[eventName]) {
    return;
  }
  assert(ACTION_REG.test(actionType) && ACTION_REG.test(eventName));
  if (!actions[actionType]) {
    actions[actionType] = {
      action,
      actionInfo: actionInfo2
    };
  }
  eventActionMap[eventName] = actionType;
}
function registerCoordinateSystem(type4, coordSysCreator) {
  CoordinateSystem.register(type4, coordSysCreator);
}
function registerLayout(priority, layoutTask) {
  normalizeRegister(visualFuncs, priority, layoutTask, PRIORITY_VISUAL_LAYOUT, "layout");
}
function registerVisual(priority, visualTask) {
  normalizeRegister(visualFuncs, priority, visualTask, PRIORITY_VISUAL_CHART, "visual");
}
var registeredTasks = [];
function normalizeRegister(targetList, priority, fn, defaultPriority, visualType) {
  if (isFunction(priority) || isObject$4(priority)) {
    fn = priority;
    priority = defaultPriority;
  }
  if (indexOf(registeredTasks, fn) >= 0) {
    return;
  }
  registeredTasks.push(fn);
  var stageHandler = Scheduler$1.wrapStageHandler(fn, visualType);
  stageHandler.__prio = priority;
  stageHandler.__raw = fn;
  targetList.push(stageHandler);
}
function registerLoading(name, loadingFx) {
  loadingEffects[name] = loadingFx;
}
function registerMap$1(mapName, geoJson, specialAreas) {
  var registerMap2 = getImpl("registerMap");
  registerMap2 && registerMap2(mapName, geoJson, specialAreas);
}
var registerTransform = registerExternalTransform;
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataStyleTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataColorPaletteTask);
registerVisual(PRIORITY_VISUAL_GLOBAL, seriesSymbolTask);
registerVisual(PRIORITY_VISUAL_CHART_DATA_CUSTOM, dataSymbolTask);
registerVisual(PRIORITY_VISUAL_DECAL, decalVisual);
registerPreprocessor(globalBackwardCompat);
registerProcessor(PRIORITY_PROCESSOR_DATASTACK, dataStack);
registerLoading("default", defaultLoading);
registerAction({
  type: HIGHLIGHT_ACTION_TYPE,
  event: HIGHLIGHT_ACTION_TYPE,
  update: HIGHLIGHT_ACTION_TYPE
}, noop);
registerAction({
  type: DOWNPLAY_ACTION_TYPE,
  event: DOWNPLAY_ACTION_TYPE,
  update: DOWNPLAY_ACTION_TYPE
}, noop);
registerAction({
  type: SELECT_ACTION_TYPE,
  event: SELECT_ACTION_TYPE,
  update: SELECT_ACTION_TYPE
}, noop);
registerAction({
  type: UNSELECT_ACTION_TYPE,
  event: UNSELECT_ACTION_TYPE,
  update: UNSELECT_ACTION_TYPE
}, noop);
registerAction({
  type: TOGGLE_SELECT_ACTION_TYPE,
  event: TOGGLE_SELECT_ACTION_TYPE,
  update: TOGGLE_SELECT_ACTION_TYPE
}, noop);
registerTheme("light", lightTheme);
registerTheme("dark", darkTheme);
var extensions = [];
var extensionRegisters = {
  registerPreprocessor,
  registerProcessor,
  registerPostInit,
  registerPostUpdate,
  registerUpdateLifecycle,
  registerAction,
  registerCoordinateSystem,
  registerLayout,
  registerVisual,
  registerTransform,
  registerLoading,
  registerMap: registerMap$1,
  registerImpl,
  PRIORITY,
  ComponentModel: ComponentModel$1,
  ComponentView: ComponentView$1,
  SeriesModel: SeriesModel$1,
  ChartView: ChartView$1,
  registerComponentModel: function(ComponentModelClass) {
    ComponentModel$1.registerClass(ComponentModelClass);
  },
  registerComponentView: function(ComponentViewClass) {
    ComponentView$1.registerClass(ComponentViewClass);
  },
  registerSeriesModel: function(SeriesModelClass) {
    SeriesModel$1.registerClass(SeriesModelClass);
  },
  registerChartView: function(ChartViewClass) {
    ChartView$1.registerClass(ChartViewClass);
  },
  registerSubTypeDefaulter: function(componentType, defaulter) {
    ComponentModel$1.registerSubTypeDefaulter(componentType, defaulter);
  },
  registerPainter: function(painterType, PainterCtor) {
    registerPainter(painterType, PainterCtor);
  }
};
function use(ext) {
  if (isArray$1(ext)) {
    each$f(ext, function(singleExt) {
      use(singleExt);
    });
    return;
  }
  if (indexOf(extensions, ext) >= 0) {
    return;
  }
  extensions.push(ext);
  if (isFunction(ext)) {
    ext = {
      install: ext
    };
  }
  ext.install(extensionRegisters);
}
function dataIndexMapValueLength(valNumOrArrLengthMoreThan2) {
  return valNumOrArrLengthMoreThan2 == null ? 0 : valNumOrArrLengthMoreThan2.length || 1;
}
function defaultKeyGetter(item) {
  return item;
}
var DataDiffer = function() {
  function DataDiffer2(oldArr, newArr, oldKeyGetter, newKeyGetter, context, diffMode) {
    this._old = oldArr;
    this._new = newArr;
    this._oldKeyGetter = oldKeyGetter || defaultKeyGetter;
    this._newKeyGetter = newKeyGetter || defaultKeyGetter;
    this.context = context;
    this._diffModeMultiple = diffMode === "multiple";
  }
  DataDiffer2.prototype.add = function(func) {
    this._add = func;
    return this;
  };
  DataDiffer2.prototype.update = function(func) {
    this._update = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToOne = function(func) {
    this._updateManyToOne = func;
    return this;
  };
  DataDiffer2.prototype.updateOneToMany = function(func) {
    this._updateOneToMany = func;
    return this;
  };
  DataDiffer2.prototype.updateManyToMany = function(func) {
    this._updateManyToMany = func;
    return this;
  };
  DataDiffer2.prototype.remove = function(func) {
    this._remove = func;
    return this;
  };
  DataDiffer2.prototype.execute = function() {
    this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
  };
  DataDiffer2.prototype._executeOneToOne = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var newDataIndexMap = {};
    var oldDataKeyArr = new Array(oldArr.length);
    var newDataKeyArr = new Array(newArr.length);
    this._initIndexMap(oldArr, null, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (newIdxMapValLen > 1) {
        var newIdx = newIdxMapVal.shift();
        if (newIdxMapVal.length === 1) {
          newDataIndexMap[oldKey] = newIdxMapVal[0];
        }
        this._update && this._update(newIdx, i);
      } else if (newIdxMapValLen === 1) {
        newDataIndexMap[oldKey] = null;
        this._update && this._update(newIdxMapVal, i);
      } else {
        this._remove && this._remove(i);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._executeMultiple = function() {
    var oldArr = this._old;
    var newArr = this._new;
    var oldDataIndexMap = {};
    var newDataIndexMap = {};
    var oldDataKeyArr = [];
    var newDataKeyArr = [];
    this._initIndexMap(oldArr, oldDataIndexMap, oldDataKeyArr, "_oldKeyGetter");
    this._initIndexMap(newArr, newDataIndexMap, newDataKeyArr, "_newKeyGetter");
    for (var i = 0; i < oldDataKeyArr.length; i++) {
      var oldKey = oldDataKeyArr[i];
      var oldIdxMapVal = oldDataIndexMap[oldKey];
      var newIdxMapVal = newDataIndexMap[oldKey];
      var oldIdxMapValLen = dataIndexMapValueLength(oldIdxMapVal);
      var newIdxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (oldIdxMapValLen > 1 && newIdxMapValLen === 1) {
        this._updateManyToOne && this._updateManyToOne(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen > 1) {
        this._updateOneToMany && this._updateOneToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen === 1 && newIdxMapValLen === 1) {
        this._update && this._update(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1 && newIdxMapValLen > 1) {
        this._updateManyToMany && this._updateManyToMany(newIdxMapVal, oldIdxMapVal);
        newDataIndexMap[oldKey] = null;
      } else if (oldIdxMapValLen > 1) {
        for (var i_1 = 0; i_1 < oldIdxMapValLen; i_1++) {
          this._remove && this._remove(oldIdxMapVal[i_1]);
        }
      } else {
        this._remove && this._remove(oldIdxMapVal);
      }
    }
    this._performRestAdd(newDataKeyArr, newDataIndexMap);
  };
  DataDiffer2.prototype._performRestAdd = function(newDataKeyArr, newDataIndexMap) {
    for (var i = 0; i < newDataKeyArr.length; i++) {
      var newKey = newDataKeyArr[i];
      var newIdxMapVal = newDataIndexMap[newKey];
      var idxMapValLen = dataIndexMapValueLength(newIdxMapVal);
      if (idxMapValLen > 1) {
        for (var j = 0; j < idxMapValLen; j++) {
          this._add && this._add(newIdxMapVal[j]);
        }
      } else if (idxMapValLen === 1) {
        this._add && this._add(newIdxMapVal);
      }
      newDataIndexMap[newKey] = null;
    }
  };
  DataDiffer2.prototype._initIndexMap = function(arr, map2, keyArr, keyGetterName) {
    var cbModeMultiple = this._diffModeMultiple;
    for (var i = 0; i < arr.length; i++) {
      var key = "_ec_" + this[keyGetterName](arr[i], i);
      if (!cbModeMultiple) {
        keyArr[i] = key;
      }
      if (!map2) {
        continue;
      }
      var idxMapVal = map2[key];
      var idxMapValLen = dataIndexMapValueLength(idxMapVal);
      if (idxMapValLen === 0) {
        map2[key] = i;
        if (cbModeMultiple) {
          keyArr.push(key);
        }
      } else if (idxMapValLen === 1) {
        map2[key] = [idxMapVal, i];
      } else {
        idxMapVal.push(i);
      }
    }
  };
  return DataDiffer2;
}();
var DataDiffer$1 = DataDiffer;
var DimensionUserOuput = function() {
  function DimensionUserOuput2(encode, dimRequest) {
    this._encode = encode;
    this._schema = dimRequest;
  }
  DimensionUserOuput2.prototype.get = function() {
    return {
      fullDimensions: this._getFullDimensionNames(),
      encode: this._encode
    };
  };
  DimensionUserOuput2.prototype._getFullDimensionNames = function() {
    if (!this._cachedDimNames) {
      this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : [];
    }
    return this._cachedDimNames;
  };
  return DimensionUserOuput2;
}();
function summarizeDimensions(data, schema) {
  var summary = {};
  var encode = summary.encode = {};
  var notExtraCoordDimMap = createHashMap();
  var defaultedLabel = [];
  var defaultedTooltip = [];
  var userOutputEncode = {};
  each$f(data.dimensions, function(dimName) {
    var dimItem = data.getDimensionInfo(dimName);
    var coordDim = dimItem.coordDim;
    if (coordDim) {
      var coordDimIndex = dimItem.coordDimIndex;
      getOrCreateEncodeArr(encode, coordDim)[coordDimIndex] = dimName;
      if (!dimItem.isExtraCoord) {
        notExtraCoordDimMap.set(coordDim, 1);
        if (mayLabelDimType(dimItem.type)) {
          defaultedLabel[0] = dimName;
        }
        getOrCreateEncodeArr(userOutputEncode, coordDim)[coordDimIndex] = data.getDimensionIndex(dimItem.name);
      }
      if (dimItem.defaultTooltip) {
        defaultedTooltip.push(dimName);
      }
    }
    VISUAL_DIMENSIONS.each(function(v4, otherDim) {
      var encodeArr = getOrCreateEncodeArr(encode, otherDim);
      var dimIndex = dimItem.otherDims[otherDim];
      if (dimIndex != null && dimIndex !== false) {
        encodeArr[dimIndex] = dimItem.name;
      }
    });
  });
  var dataDimsOnCoord = [];
  var encodeFirstDimNotExtra = {};
  notExtraCoordDimMap.each(function(v4, coordDim) {
    var dimArr = encode[coordDim];
    encodeFirstDimNotExtra[coordDim] = dimArr[0];
    dataDimsOnCoord = dataDimsOnCoord.concat(dimArr);
  });
  summary.dataDimsOnCoord = dataDimsOnCoord;
  summary.dataDimIndicesOnCoord = map$1(dataDimsOnCoord, function(dimName) {
    return data.getDimensionInfo(dimName).storeDimIndex;
  });
  summary.encodeFirstDimNotExtra = encodeFirstDimNotExtra;
  var encodeLabel = encode.label;
  if (encodeLabel && encodeLabel.length) {
    defaultedLabel = encodeLabel.slice();
  }
  var encodeTooltip = encode.tooltip;
  if (encodeTooltip && encodeTooltip.length) {
    defaultedTooltip = encodeTooltip.slice();
  } else if (!defaultedTooltip.length) {
    defaultedTooltip = defaultedLabel.slice();
  }
  encode.defaultedLabel = defaultedLabel;
  encode.defaultedTooltip = defaultedTooltip;
  summary.userOutput = new DimensionUserOuput(userOutputEncode, schema);
  return summary;
}
function getOrCreateEncodeArr(encode, dim) {
  if (!encode.hasOwnProperty(dim)) {
    encode[dim] = [];
  }
  return encode[dim];
}
function getDimensionTypeByAxis(axisType) {
  return axisType === "category" ? "ordinal" : axisType === "time" ? "time" : "float";
}
function mayLabelDimType(dimType) {
  return !(dimType === "ordinal" || dimType === "time");
}
var SeriesDimensionDefine = function() {
  function SeriesDimensionDefine2(opt) {
    this.otherDims = {};
    if (opt != null) {
      extend(this, opt);
    }
  }
  return SeriesDimensionDefine2;
}();
var SeriesDimensionDefine$1 = SeriesDimensionDefine;
var inner$h = makeInner();
var dimTypeShort = {
  float: "f",
  int: "i",
  ordinal: "o",
  number: "n",
  time: "t"
};
var SeriesDataSchema = function() {
  function SeriesDataSchema2(opt) {
    this.dimensions = opt.dimensions;
    this._dimOmitted = opt.dimensionOmitted;
    this.source = opt.source;
    this._fullDimCount = opt.fullDimensionCount;
    this._updateDimOmitted(opt.dimensionOmitted);
  }
  SeriesDataSchema2.prototype.isDimensionOmitted = function() {
    return this._dimOmitted;
  };
  SeriesDataSchema2.prototype._updateDimOmitted = function(dimensionOmitted) {
    this._dimOmitted = dimensionOmitted;
    if (!dimensionOmitted) {
      return;
    }
    if (!this._dimNameMap) {
      this._dimNameMap = ensureSourceDimNameMap(this.source);
    }
  };
  SeriesDataSchema2.prototype.getSourceDimensionIndex = function(dimName) {
    return retrieve2(this._dimNameMap.get(dimName), -1);
  };
  SeriesDataSchema2.prototype.getSourceDimension = function(dimIndex) {
    var dimensionsDefine = this.source.dimensionsDefine;
    if (dimensionsDefine) {
      return dimensionsDefine[dimIndex];
    }
  };
  SeriesDataSchema2.prototype.makeStoreSchema = function() {
    var dimCount = this._fullDimCount;
    var willRetrieveDataByName = shouldRetrieveDataByName(this.source);
    var makeHashStrict = !shouldOmitUnusedDimensions(dimCount);
    var dimHash = "";
    var dims = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < dimCount; fullDimIdx++) {
      var property = void 0;
      var type4 = void 0;
      var ordinalMeta = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        property = willRetrieveDataByName ? seriesDimDef.name : null;
        type4 = seriesDimDef.type;
        ordinalMeta = seriesDimDef.ordinalMeta;
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          property = willRetrieveDataByName ? sourceDimDef.name : null;
          type4 = sourceDimDef.type;
        }
      }
      dims.push({
        property,
        type: type4,
        ordinalMeta
      });
      if (willRetrieveDataByName && property != null && (!seriesDimDef || !seriesDimDef.isCalculationCoord)) {
        dimHash += makeHashStrict ? property.replace(/\`/g, "`1").replace(/\$/g, "`2") : property;
      }
      dimHash += "$";
      dimHash += dimTypeShort[type4] || "f";
      if (ordinalMeta) {
        dimHash += ordinalMeta.uid;
      }
      dimHash += "$";
    }
    var source = this.source;
    var hash = [source.seriesLayoutBy, source.startIndex, dimHash].join("$$");
    return {
      dimensions: dims,
      hash
    };
  };
  SeriesDataSchema2.prototype.makeOutputDimensionNames = function() {
    var result = [];
    for (var fullDimIdx = 0, seriesDimIdx = 0; fullDimIdx < this._fullDimCount; fullDimIdx++) {
      var name_1 = void 0;
      var seriesDimDef = this.dimensions[seriesDimIdx];
      if (seriesDimDef && seriesDimDef.storeDimIndex === fullDimIdx) {
        if (!seriesDimDef.isCalculationCoord) {
          name_1 = seriesDimDef.name;
        }
        seriesDimIdx++;
      } else {
        var sourceDimDef = this.getSourceDimension(fullDimIdx);
        if (sourceDimDef) {
          name_1 = sourceDimDef.name;
        }
      }
      result.push(name_1);
    }
    return result;
  };
  SeriesDataSchema2.prototype.appendCalculationDimension = function(dimDef) {
    this.dimensions.push(dimDef);
    dimDef.isCalculationCoord = true;
    this._fullDimCount++;
    this._updateDimOmitted(true);
  };
  return SeriesDataSchema2;
}();
function isSeriesDataSchema(schema) {
  return schema instanceof SeriesDataSchema;
}
function createDimNameMap(dimsDef) {
  var dataDimNameMap = createHashMap();
  for (var i = 0; i < (dimsDef || []).length; i++) {
    var dimDefItemRaw = dimsDef[i];
    var userDimName = isObject$4(dimDefItemRaw) ? dimDefItemRaw.name : dimDefItemRaw;
    if (userDimName != null && dataDimNameMap.get(userDimName) == null) {
      dataDimNameMap.set(userDimName, i);
    }
  }
  return dataDimNameMap;
}
function ensureSourceDimNameMap(source) {
  var innerSource = inner$h(source);
  return innerSource.dimNameMap || (innerSource.dimNameMap = createDimNameMap(source.dimensionsDefine));
}
function shouldOmitUnusedDimensions(dimCount) {
  return dimCount > 30;
}
var isObject$2 = isObject$4;
var map = map$1;
var CtorInt32Array = typeof Int32Array === "undefined" ? Array : Int32Array;
var ID_PREFIX = "e\0\0";
var INDEX_NOT_FOUND = -1;
var TRANSFERABLE_PROPERTIES = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"];
var CLONE_PROPERTIES = ["_approximateExtent"];
var prepareInvertedIndex;
var getId;
var getIdNameFromStore;
var normalizeDimensions;
var transferProperties;
var cloneListForMapAndSample;
var makeIdFromName;
var SeriesData = function() {
  function SeriesData2(dimensionsInput, hostModel) {
    this.type = "list";
    this._dimOmitted = false;
    this._nameList = [];
    this._idList = [];
    this._visual = {};
    this._layout = {};
    this._itemVisuals = [];
    this._itemLayouts = [];
    this._graphicEls = [];
    this._approximateExtent = {};
    this._calculationInfo = {};
    this.hasItemOption = false;
    this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"];
    this.CHANGABLE_METHODS = ["filterSelf", "selectRange"];
    this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
    var dimensions;
    var assignStoreDimIdx = false;
    if (isSeriesDataSchema(dimensionsInput)) {
      dimensions = dimensionsInput.dimensions;
      this._dimOmitted = dimensionsInput.isDimensionOmitted();
      this._schema = dimensionsInput;
    } else {
      assignStoreDimIdx = true;
      dimensions = dimensionsInput;
    }
    dimensions = dimensions || ["x", "y"];
    var dimensionInfos = {};
    var dimensionNames = [];
    var invertedIndicesMap = {};
    var needsHasOwn = false;
    var emptyObj = {};
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfoInput = dimensions[i];
      var dimensionInfo = isString(dimInfoInput) ? new SeriesDimensionDefine$1({
        name: dimInfoInput
      }) : !(dimInfoInput instanceof SeriesDimensionDefine$1) ? new SeriesDimensionDefine$1(dimInfoInput) : dimInfoInput;
      var dimensionName = dimensionInfo.name;
      dimensionInfo.type = dimensionInfo.type || "float";
      if (!dimensionInfo.coordDim) {
        dimensionInfo.coordDim = dimensionName;
        dimensionInfo.coordDimIndex = 0;
      }
      var otherDims = dimensionInfo.otherDims = dimensionInfo.otherDims || {};
      dimensionNames.push(dimensionName);
      dimensionInfos[dimensionName] = dimensionInfo;
      if (emptyObj[dimensionName] != null) {
        needsHasOwn = true;
      }
      if (dimensionInfo.createInvertedIndices) {
        invertedIndicesMap[dimensionName] = [];
      }
      if (otherDims.itemName === 0) {
        this._nameDimIdx = i;
      }
      if (otherDims.itemId === 0) {
        this._idDimIdx = i;
      }
      if (assignStoreDimIdx) {
        dimensionInfo.storeDimIndex = i;
      }
    }
    this.dimensions = dimensionNames;
    this._dimInfos = dimensionInfos;
    this._initGetDimensionInfo(needsHasOwn);
    this.hostModel = hostModel;
    this._invertedIndicesMap = invertedIndicesMap;
    if (this._dimOmitted) {
      var dimIdxToName_1 = this._dimIdxToName = createHashMap();
      each$f(dimensionNames, function(dimName) {
        dimIdxToName_1.set(dimensionInfos[dimName].storeDimIndex, dimName);
      });
    }
  }
  SeriesData2.prototype.getDimension = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx == null) {
      return dim;
    }
    dimIdx = dim;
    if (!this._dimOmitted) {
      return this.dimensions[dimIdx];
    }
    var dimName = this._dimIdxToName.get(dimIdx);
    if (dimName != null) {
      return dimName;
    }
    var sourceDimDef = this._schema.getSourceDimension(dimIdx);
    if (sourceDimDef) {
      return sourceDimDef.name;
    }
  };
  SeriesData2.prototype.getDimensionIndex = function(dim) {
    var dimIdx = this._recognizeDimIndex(dim);
    if (dimIdx != null) {
      return dimIdx;
    }
    if (dim == null) {
      return -1;
    }
    var dimInfo = this._getDimInfo(dim);
    return dimInfo ? dimInfo.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(dim) : -1;
  };
  SeriesData2.prototype._recognizeDimIndex = function(dim) {
    if (isNumber(dim) || dim != null && !isNaN(dim) && !this._getDimInfo(dim) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(dim) < 0)) {
      return +dim;
    }
  };
  SeriesData2.prototype._getStoreDimIndex = function(dim) {
    var dimIdx = this.getDimensionIndex(dim);
    return dimIdx;
  };
  SeriesData2.prototype.getDimensionInfo = function(dim) {
    return this._getDimInfo(this.getDimension(dim));
  };
  SeriesData2.prototype._initGetDimensionInfo = function(needsHasOwn) {
    var dimensionInfos = this._dimInfos;
    this._getDimInfo = needsHasOwn ? function(dimName) {
      return dimensionInfos.hasOwnProperty(dimName) ? dimensionInfos[dimName] : void 0;
    } : function(dimName) {
      return dimensionInfos[dimName];
    };
  };
  SeriesData2.prototype.getDimensionsOnCoord = function() {
    return this._dimSummary.dataDimsOnCoord.slice();
  };
  SeriesData2.prototype.mapDimension = function(coordDim, idx) {
    var dimensionsSummary = this._dimSummary;
    if (idx == null) {
      return dimensionsSummary.encodeFirstDimNotExtra[coordDim];
    }
    var dims = dimensionsSummary.encode[coordDim];
    return dims ? dims[idx] : null;
  };
  SeriesData2.prototype.mapDimensionsAll = function(coordDim) {
    var dimensionsSummary = this._dimSummary;
    var dims = dimensionsSummary.encode[coordDim];
    return (dims || []).slice();
  };
  SeriesData2.prototype.getStore = function() {
    return this._store;
  };
  SeriesData2.prototype.initData = function(data, nameList, dimValueGetter) {
    var _this = this;
    var store;
    if (data instanceof DataStore) {
      store = data;
    }
    if (!store) {
      var dimensions = this.dimensions;
      var provider = isSourceInstance(data) || isArrayLike(data) ? new DefaultDataProvider(data, dimensions.length) : data;
      store = new DataStore();
      var dimensionInfos = map(dimensions, function(dimName) {
        return {
          type: _this._dimInfos[dimName].type,
          property: dimName
        };
      });
      store.initData(provider, dimensionInfos, dimValueGetter);
    }
    this._store = store;
    this._nameList = (nameList || []).slice();
    this._idList = [];
    this._nameRepeatCount = {};
    this._doInit(0, store.count());
    this._dimSummary = summarizeDimensions(this, this._schema);
    this.userOutput = this._dimSummary.userOutput;
  };
  SeriesData2.prototype.appendData = function(data) {
    var range3 = this._store.appendData(data);
    this._doInit(range3[0], range3[1]);
  };
  SeriesData2.prototype.appendValues = function(values, names2) {
    var _a2 = this._store.appendValues(values, names2.length), start2 = _a2.start, end2 = _a2.end;
    var shouldMakeIdFromName = this._shouldMakeIdFromName();
    this._updateOrdinalMeta();
    if (names2) {
      for (var idx = start2; idx < end2; idx++) {
        var sourceIdx = idx - start2;
        this._nameList[idx] = names2[sourceIdx];
        if (shouldMakeIdFromName) {
          makeIdFromName(this, idx);
        }
      }
    }
  };
  SeriesData2.prototype._updateOrdinalMeta = function() {
    var store = this._store;
    var dimensions = this.dimensions;
    for (var i = 0; i < dimensions.length; i++) {
      var dimInfo = this._dimInfos[dimensions[i]];
      if (dimInfo.ordinalMeta) {
        store.collectOrdinalMeta(dimInfo.storeDimIndex, dimInfo.ordinalMeta);
      }
    }
  };
  SeriesData2.prototype._shouldMakeIdFromName = function() {
    var provider = this._store.getProvider();
    return this._idDimIdx == null && provider.getSource().sourceFormat !== SOURCE_FORMAT_TYPED_ARRAY && !provider.fillStorage;
  };
  SeriesData2.prototype._doInit = function(start2, end2) {
    if (start2 >= end2) {
      return;
    }
    var store = this._store;
    var provider = store.getProvider();
    this._updateOrdinalMeta();
    var nameList = this._nameList;
    var idList = this._idList;
    var sourceFormat = provider.getSource().sourceFormat;
    var isFormatOriginal = sourceFormat === SOURCE_FORMAT_ORIGINAL;
    if (isFormatOriginal && !provider.pure) {
      var sharedDataItem = [];
      for (var idx = start2; idx < end2; idx++) {
        var dataItem = provider.getItem(idx, sharedDataItem);
        if (!this.hasItemOption && isDataItemOption(dataItem)) {
          this.hasItemOption = true;
        }
        if (dataItem) {
          var itemName = dataItem.name;
          if (nameList[idx] == null && itemName != null) {
            nameList[idx] = convertOptionIdName(itemName, null);
          }
          var itemId = dataItem.id;
          if (idList[idx] == null && itemId != null) {
            idList[idx] = convertOptionIdName(itemId, null);
          }
        }
      }
    }
    if (this._shouldMakeIdFromName()) {
      for (var idx = start2; idx < end2; idx++) {
        makeIdFromName(this, idx);
      }
    }
    prepareInvertedIndex(this);
  };
  SeriesData2.prototype.getApproximateExtent = function(dim) {
    return this._approximateExtent[dim] || this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.setApproximateExtent = function(extent3, dim) {
    dim = this.getDimension(dim);
    this._approximateExtent[dim] = extent3.slice();
  };
  SeriesData2.prototype.getCalculationInfo = function(key) {
    return this._calculationInfo[key];
  };
  SeriesData2.prototype.setCalculationInfo = function(key, value) {
    isObject$2(key) ? extend(this._calculationInfo, key) : this._calculationInfo[key] = value;
  };
  SeriesData2.prototype.getName = function(idx) {
    var rawIndex = this.getRawIndex(idx);
    var name = this._nameList[rawIndex];
    if (name == null && this._nameDimIdx != null) {
      name = getIdNameFromStore(this, this._nameDimIdx, rawIndex);
    }
    if (name == null) {
      name = "";
    }
    return name;
  };
  SeriesData2.prototype._getCategory = function(dimIdx, idx) {
    var ordinal = this._store.get(dimIdx, idx);
    var ordinalMeta = this._store.getOrdinalMeta(dimIdx);
    if (ordinalMeta) {
      return ordinalMeta.categories[ordinal];
    }
    return ordinal;
  };
  SeriesData2.prototype.getId = function(idx) {
    return getId(this, this.getRawIndex(idx));
  };
  SeriesData2.prototype.count = function() {
    return this._store.count();
  };
  SeriesData2.prototype.get = function(dim, idx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.get(dimInfo.storeDimIndex, idx);
    }
  };
  SeriesData2.prototype.getByRawIndex = function(dim, rawIdx) {
    var store = this._store;
    var dimInfo = this._dimInfos[dim];
    if (dimInfo) {
      return store.getByRawIndex(dimInfo.storeDimIndex, rawIdx);
    }
  };
  SeriesData2.prototype.getIndices = function() {
    return this._store.getIndices();
  };
  SeriesData2.prototype.getDataExtent = function(dim) {
    return this._store.getDataExtent(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getSum = function(dim) {
    return this._store.getSum(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getMedian = function(dim) {
    return this._store.getMedian(this._getStoreDimIndex(dim));
  };
  SeriesData2.prototype.getValues = function(dimensions, idx) {
    var _this = this;
    var store = this._store;
    return isArray$1(dimensions) ? store.getValues(map(dimensions, function(dim) {
      return _this._getStoreDimIndex(dim);
    }), idx) : store.getValues(dimensions);
  };
  SeriesData2.prototype.hasValue = function(idx) {
    var dataDimIndicesOnCoord = this._dimSummary.dataDimIndicesOnCoord;
    for (var i = 0, len2 = dataDimIndicesOnCoord.length; i < len2; i++) {
      if (isNaN(this._store.get(dataDimIndicesOnCoord[i], idx))) {
        return false;
      }
    }
    return true;
  };
  SeriesData2.prototype.indexOfName = function(name) {
    for (var i = 0, len2 = this._store.count(); i < len2; i++) {
      if (this.getName(i) === name) {
        return i;
      }
    }
    return -1;
  };
  SeriesData2.prototype.getRawIndex = function(idx) {
    return this._store.getRawIndex(idx);
  };
  SeriesData2.prototype.indexOfRawIndex = function(rawIndex) {
    return this._store.indexOfRawIndex(rawIndex);
  };
  SeriesData2.prototype.rawIndexOf = function(dim, value) {
    var invertedIndices = dim && this._invertedIndicesMap[dim];
    var rawIndex = invertedIndices[value];
    if (rawIndex == null || isNaN(rawIndex)) {
      return INDEX_NOT_FOUND;
    }
    return rawIndex;
  };
  SeriesData2.prototype.indicesOfNearest = function(dim, value, maxDistance) {
    return this._store.indicesOfNearest(this._getStoreDimIndex(dim), value, maxDistance);
  };
  SeriesData2.prototype.each = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.each(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
  };
  SeriesData2.prototype.filterSelf = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    var fCtx = ctx || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store = this._store.filter(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
    return this;
  };
  SeriesData2.prototype.selectRange = function(range3) {
    var _this = this;
    var innerRange = {};
    var dims = keys(range3);
    each$f(dims, function(dim) {
      var dimIdx = _this._getStoreDimIndex(dim);
      innerRange[dimIdx] = range3[dim];
    });
    this._store = this._store.selectRange(innerRange);
    return this;
  };
  SeriesData2.prototype.mapArray = function(dims, cb, ctx) {
    if (isFunction(dims)) {
      ctx = cb;
      cb = dims;
      dims = [];
    }
    ctx = ctx || this;
    var result = [];
    this.each(dims, function() {
      result.push(cb && cb.apply(this, arguments));
    }, ctx);
    return result;
  };
  SeriesData2.prototype.map = function(dims, cb, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    var list = cloneListForMapAndSample(this);
    list._store = this._store.map(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
    return list;
  };
  SeriesData2.prototype.modify = function(dims, cb, ctx, ctxCompat) {
    var fCtx = ctx || ctxCompat || this;
    var dimIndices = map(normalizeDimensions(dims), this._getStoreDimIndex, this);
    this._store.modify(dimIndices, fCtx ? bind$1(cb, fCtx) : cb);
  };
  SeriesData2.prototype.downSample = function(dimension, rate, sampleValue, sampleIndex) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.downSample(this._getStoreDimIndex(dimension), rate, sampleValue, sampleIndex);
    return list;
  };
  SeriesData2.prototype.lttbDownSample = function(valueDimension, rate) {
    var list = cloneListForMapAndSample(this);
    list._store = this._store.lttbDownSample(this._getStoreDimIndex(valueDimension), rate);
    return list;
  };
  SeriesData2.prototype.getRawDataItem = function(idx) {
    return this._store.getRawDataItem(idx);
  };
  SeriesData2.prototype.getItemModel = function(idx) {
    var hostModel = this.hostModel;
    var dataItem = this.getRawDataItem(idx);
    return new Model$1(dataItem, hostModel, hostModel && hostModel.ecModel);
  };
  SeriesData2.prototype.diff = function(otherList) {
    var thisList = this;
    return new DataDiffer$1(otherList ? otherList.getStore().getIndices() : [], this.getStore().getIndices(), function(idx) {
      return getId(otherList, idx);
    }, function(idx) {
      return getId(thisList, idx);
    });
  };
  SeriesData2.prototype.getVisual = function(key) {
    var visual = this._visual;
    return visual && visual[key];
  };
  SeriesData2.prototype.setVisual = function(kvObj, val) {
    this._visual = this._visual || {};
    if (isObject$2(kvObj)) {
      extend(this._visual, kvObj);
    } else {
      this._visual[kvObj] = val;
    }
  };
  SeriesData2.prototype.getItemVisual = function(idx, key) {
    var itemVisual = this._itemVisuals[idx];
    var val = itemVisual && itemVisual[key];
    if (val == null) {
      return this.getVisual(key);
    }
    return val;
  };
  SeriesData2.prototype.hasItemVisual = function() {
    return this._itemVisuals.length > 0;
  };
  SeriesData2.prototype.ensureUniqueItemVisual = function(idx, key) {
    var itemVisuals = this._itemVisuals;
    var itemVisual = itemVisuals[idx];
    if (!itemVisual) {
      itemVisual = itemVisuals[idx] = {};
    }
    var val = itemVisual[key];
    if (val == null) {
      val = this.getVisual(key);
      if (isArray$1(val)) {
        val = val.slice();
      } else if (isObject$2(val)) {
        val = extend({}, val);
      }
      itemVisual[key] = val;
    }
    return val;
  };
  SeriesData2.prototype.setItemVisual = function(idx, key, value) {
    var itemVisual = this._itemVisuals[idx] || {};
    this._itemVisuals[idx] = itemVisual;
    if (isObject$2(key)) {
      extend(itemVisual, key);
    } else {
      itemVisual[key] = value;
    }
  };
  SeriesData2.prototype.clearAllVisual = function() {
    this._visual = {};
    this._itemVisuals = [];
  };
  SeriesData2.prototype.setLayout = function(key, val) {
    isObject$2(key) ? extend(this._layout, key) : this._layout[key] = val;
  };
  SeriesData2.prototype.getLayout = function(key) {
    return this._layout[key];
  };
  SeriesData2.prototype.getItemLayout = function(idx) {
    return this._itemLayouts[idx];
  };
  SeriesData2.prototype.setItemLayout = function(idx, layout2, merge2) {
    this._itemLayouts[idx] = merge2 ? extend(this._itemLayouts[idx] || {}, layout2) : layout2;
  };
  SeriesData2.prototype.clearItemLayouts = function() {
    this._itemLayouts.length = 0;
  };
  SeriesData2.prototype.setItemGraphicEl = function(idx, el) {
    var seriesIndex = this.hostModel && this.hostModel.seriesIndex;
    setCommonECData(seriesIndex, this.dataType, idx, el);
    this._graphicEls[idx] = el;
  };
  SeriesData2.prototype.getItemGraphicEl = function(idx) {
    return this._graphicEls[idx];
  };
  SeriesData2.prototype.eachItemGraphicEl = function(cb, context) {
    each$f(this._graphicEls, function(el, idx) {
      if (el) {
        cb && cb.call(context, el, idx);
      }
    });
  };
  SeriesData2.prototype.cloneShallow = function(list) {
    if (!list) {
      list = new SeriesData2(this._schema ? this._schema : map(this.dimensions, this._getDimInfo, this), this.hostModel);
    }
    transferProperties(list, this);
    list._store = this._store;
    return list;
  };
  SeriesData2.prototype.wrapMethod = function(methodName, injectFunction) {
    var originalMethod = this[methodName];
    if (!isFunction(originalMethod)) {
      return;
    }
    this.__wrappedMethods = this.__wrappedMethods || [];
    this.__wrappedMethods.push(methodName);
    this[methodName] = function() {
      var res = originalMethod.apply(this, arguments);
      return injectFunction.apply(this, [res].concat(slice(arguments)));
    };
  };
  SeriesData2.internalField = function() {
    prepareInvertedIndex = function(data) {
      var invertedIndicesMap = data._invertedIndicesMap;
      each$f(invertedIndicesMap, function(invertedIndices, dim) {
        var dimInfo = data._dimInfos[dim];
        var ordinalMeta = dimInfo.ordinalMeta;
        var store = data._store;
        if (ordinalMeta) {
          invertedIndices = invertedIndicesMap[dim] = new CtorInt32Array(ordinalMeta.categories.length);
          for (var i = 0; i < invertedIndices.length; i++) {
            invertedIndices[i] = INDEX_NOT_FOUND;
          }
          for (var i = 0; i < store.count(); i++) {
            invertedIndices[store.get(dimInfo.storeDimIndex, i)] = i;
          }
        }
      });
    };
    getIdNameFromStore = function(data, dimIdx, idx) {
      return convertOptionIdName(data._getCategory(dimIdx, idx), null);
    };
    getId = function(data, rawIndex) {
      var id2 = data._idList[rawIndex];
      if (id2 == null && data._idDimIdx != null) {
        id2 = getIdNameFromStore(data, data._idDimIdx, rawIndex);
      }
      if (id2 == null) {
        id2 = ID_PREFIX + rawIndex;
      }
      return id2;
    };
    normalizeDimensions = function(dimensions) {
      if (!isArray$1(dimensions)) {
        dimensions = dimensions != null ? [dimensions] : [];
      }
      return dimensions;
    };
    cloneListForMapAndSample = function(original) {
      var list = new SeriesData2(original._schema ? original._schema : map(original.dimensions, original._getDimInfo, original), original.hostModel);
      transferProperties(list, original);
      return list;
    };
    transferProperties = function(target, source) {
      each$f(TRANSFERABLE_PROPERTIES.concat(source.__wrappedMethods || []), function(propName) {
        if (source.hasOwnProperty(propName)) {
          target[propName] = source[propName];
        }
      });
      target.__wrappedMethods = source.__wrappedMethods;
      each$f(CLONE_PROPERTIES, function(propName) {
        target[propName] = clone$4(source[propName]);
      });
      target._calculationInfo = extend({}, source._calculationInfo);
    };
    makeIdFromName = function(data, idx) {
      var nameList = data._nameList;
      var idList = data._idList;
      var nameDimIdx = data._nameDimIdx;
      var idDimIdx = data._idDimIdx;
      var name = nameList[idx];
      var id2 = idList[idx];
      if (name == null && nameDimIdx != null) {
        nameList[idx] = name = getIdNameFromStore(data, nameDimIdx, idx);
      }
      if (id2 == null && idDimIdx != null) {
        idList[idx] = id2 = getIdNameFromStore(data, idDimIdx, idx);
      }
      if (id2 == null && name != null) {
        var nameRepeatCount = data._nameRepeatCount;
        var nmCnt = nameRepeatCount[name] = (nameRepeatCount[name] || 0) + 1;
        id2 = name;
        if (nmCnt > 1) {
          id2 += "__ec__" + nmCnt;
        }
        idList[idx] = id2;
      }
    };
  }();
  return SeriesData2;
}();
var SeriesData$1 = SeriesData;
function prepareSeriesDataSchema(source, opt) {
  if (!isSourceInstance(source)) {
    source = createSourceFromSeriesDataOption(source);
  }
  opt = opt || {};
  var sysDims = opt.coordDimensions || [];
  var dimsDef = opt.dimensionsDefine || source.dimensionsDefine || [];
  var coordDimNameMap = createHashMap();
  var resultList = [];
  var dimCount = getDimCount(source, sysDims, dimsDef, opt.dimensionsCount);
  var omitUnusedDimensions = opt.canOmitUnusedDimensions && shouldOmitUnusedDimensions(dimCount);
  var isUsingSourceDimensionsDef = dimsDef === source.dimensionsDefine;
  var dataDimNameMap = isUsingSourceDimensionsDef ? ensureSourceDimNameMap(source) : createDimNameMap(dimsDef);
  var encodeDef = opt.encodeDefine;
  if (!encodeDef && opt.encodeDefaulter) {
    encodeDef = opt.encodeDefaulter(source, dimCount);
  }
  var encodeDefMap = createHashMap(encodeDef);
  var indicesMap = new CtorInt32Array$1(dimCount);
  for (var i = 0; i < indicesMap.length; i++) {
    indicesMap[i] = -1;
  }
  function getResultItem(dimIdx) {
    var idx = indicesMap[dimIdx];
    if (idx < 0) {
      var dimDefItemRaw = dimsDef[dimIdx];
      var dimDefItem = isObject$4(dimDefItemRaw) ? dimDefItemRaw : {
        name: dimDefItemRaw
      };
      var resultItem2 = new SeriesDimensionDefine$1();
      var userDimName = dimDefItem.name;
      if (userDimName != null && dataDimNameMap.get(userDimName) != null) {
        resultItem2.name = resultItem2.displayName = userDimName;
      }
      dimDefItem.type != null && (resultItem2.type = dimDefItem.type);
      dimDefItem.displayName != null && (resultItem2.displayName = dimDefItem.displayName);
      var newIdx = resultList.length;
      indicesMap[dimIdx] = newIdx;
      resultItem2.storeDimIndex = dimIdx;
      resultList.push(resultItem2);
      return resultItem2;
    }
    return resultList[idx];
  }
  if (!omitUnusedDimensions) {
    for (var i = 0; i < dimCount; i++) {
      getResultItem(i);
    }
  }
  encodeDefMap.each(function(dataDimsRaw, coordDim2) {
    var dataDims = normalizeToArray(dataDimsRaw).slice();
    if (dataDims.length === 1 && !isString(dataDims[0]) && dataDims[0] < 0) {
      encodeDefMap.set(coordDim2, false);
      return;
    }
    var validDataDims = encodeDefMap.set(coordDim2, []);
    each$f(dataDims, function(resultDimIdxOrName, idx) {
      var resultDimIdx2 = isString(resultDimIdxOrName) ? dataDimNameMap.get(resultDimIdxOrName) : resultDimIdxOrName;
      if (resultDimIdx2 != null && resultDimIdx2 < dimCount) {
        validDataDims[idx] = resultDimIdx2;
        applyDim(getResultItem(resultDimIdx2), coordDim2, idx);
      }
    });
  });
  var availDimIdx = 0;
  each$f(sysDims, function(sysDimItemRaw) {
    var coordDim2;
    var sysDimItemDimsDef;
    var sysDimItemOtherDims;
    var sysDimItem;
    if (isString(sysDimItemRaw)) {
      coordDim2 = sysDimItemRaw;
      sysDimItem = {};
    } else {
      sysDimItem = sysDimItemRaw;
      coordDim2 = sysDimItem.name;
      var ordinalMeta = sysDimItem.ordinalMeta;
      sysDimItem.ordinalMeta = null;
      sysDimItem = extend({}, sysDimItem);
      sysDimItem.ordinalMeta = ordinalMeta;
      sysDimItemDimsDef = sysDimItem.dimsDef;
      sysDimItemOtherDims = sysDimItem.otherDims;
      sysDimItem.name = sysDimItem.coordDim = sysDimItem.coordDimIndex = sysDimItem.dimsDef = sysDimItem.otherDims = null;
    }
    var dataDims = encodeDefMap.get(coordDim2);
    if (dataDims === false) {
      return;
    }
    dataDims = normalizeToArray(dataDims);
    if (!dataDims.length) {
      for (var i2 = 0; i2 < (sysDimItemDimsDef && sysDimItemDimsDef.length || 1); i2++) {
        while (availDimIdx < dimCount && getResultItem(availDimIdx).coordDim != null) {
          availDimIdx++;
        }
        availDimIdx < dimCount && dataDims.push(availDimIdx++);
      }
    }
    each$f(dataDims, function(resultDimIdx2, coordDimIndex) {
      var resultItem2 = getResultItem(resultDimIdx2);
      if (isUsingSourceDimensionsDef && sysDimItem.type != null) {
        resultItem2.type = sysDimItem.type;
      }
      applyDim(defaults(resultItem2, sysDimItem), coordDim2, coordDimIndex);
      if (resultItem2.name == null && sysDimItemDimsDef) {
        var sysDimItemDimsDefItem = sysDimItemDimsDef[coordDimIndex];
        !isObject$4(sysDimItemDimsDefItem) && (sysDimItemDimsDefItem = {
          name: sysDimItemDimsDefItem
        });
        resultItem2.name = resultItem2.displayName = sysDimItemDimsDefItem.name;
        resultItem2.defaultTooltip = sysDimItemDimsDefItem.defaultTooltip;
      }
      sysDimItemOtherDims && defaults(resultItem2.otherDims, sysDimItemOtherDims);
    });
  });
  function applyDim(resultItem2, coordDim2, coordDimIndex) {
    if (VISUAL_DIMENSIONS.get(coordDim2) != null) {
      resultItem2.otherDims[coordDim2] = coordDimIndex;
    } else {
      resultItem2.coordDim = coordDim2;
      resultItem2.coordDimIndex = coordDimIndex;
      coordDimNameMap.set(coordDim2, true);
    }
  }
  var generateCoord = opt.generateCoord;
  var generateCoordCount = opt.generateCoordCount;
  var fromZero = generateCoordCount != null;
  generateCoordCount = generateCoord ? generateCoordCount || 1 : 0;
  var extra = generateCoord || "value";
  function ifNoNameFillWithCoordName(resultItem2) {
    if (resultItem2.name == null) {
      resultItem2.name = resultItem2.coordDim;
    }
  }
  if (!omitUnusedDimensions) {
    for (var resultDimIdx = 0; resultDimIdx < dimCount; resultDimIdx++) {
      var resultItem = getResultItem(resultDimIdx);
      var coordDim = resultItem.coordDim;
      if (coordDim == null) {
        resultItem.coordDim = genCoordDimName(extra, coordDimNameMap, fromZero);
        resultItem.coordDimIndex = 0;
        if (!generateCoord || generateCoordCount <= 0) {
          resultItem.isExtraCoord = true;
        }
        generateCoordCount--;
      }
      ifNoNameFillWithCoordName(resultItem);
      if (resultItem.type == null && (guessOrdinal(source, resultDimIdx) === BE_ORDINAL.Must || resultItem.isExtraCoord && (resultItem.otherDims.itemName != null || resultItem.otherDims.seriesName != null))) {
        resultItem.type = "ordinal";
      }
    }
  } else {
    each$f(resultList, function(resultItem2) {
      ifNoNameFillWithCoordName(resultItem2);
    });
    resultList.sort(function(item0, item1) {
      return item0.storeDimIndex - item1.storeDimIndex;
    });
  }
  removeDuplication(resultList);
  return new SeriesDataSchema({
    source,
    dimensions: resultList,
    fullDimensionCount: dimCount,
    dimensionOmitted: omitUnusedDimensions
  });
}
function removeDuplication(result) {
  var duplicationMap = createHashMap();
  for (var i = 0; i < result.length; i++) {
    var dim = result[i];
    var dimOriginalName = dim.name;
    var count2 = duplicationMap.get(dimOriginalName) || 0;
    if (count2 > 0) {
      dim.name = dimOriginalName + (count2 - 1);
    }
    count2++;
    duplicationMap.set(dimOriginalName, count2);
  }
}
function getDimCount(source, sysDims, dimsDef, optDimCount) {
  var dimCount = Math.max(source.dimensionsDetectedCount || 1, sysDims.length, dimsDef.length, optDimCount || 0);
  each$f(sysDims, function(sysDimItem) {
    var sysDimItemDimsDef;
    if (isObject$4(sysDimItem) && (sysDimItemDimsDef = sysDimItem.dimsDef)) {
      dimCount = Math.max(dimCount, sysDimItemDimsDef.length);
    }
  });
  return dimCount;
}
function genCoordDimName(name, map2, fromZero) {
  var mapData = map2.data;
  if (fromZero || mapData.hasOwnProperty(name)) {
    var i = 0;
    while (mapData.hasOwnProperty(name + i)) {
      i++;
    }
    name += i;
  }
  map2.set(name, true);
  return name;
}
var CoordSysInfo = function() {
  function CoordSysInfo2(coordSysName) {
    this.coordSysDims = [];
    this.axisMap = createHashMap();
    this.categoryAxisMap = createHashMap();
    this.coordSysName = coordSysName;
  }
  return CoordSysInfo2;
}();
function getCoordSysInfoBySeries(seriesModel) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var result = new CoordSysInfo(coordSysName);
  var fetch = fetchers[coordSysName];
  if (fetch) {
    fetch(seriesModel, result, result.axisMap, result.categoryAxisMap);
    return result;
  }
}
var fetchers = {
  cartesian2d: function(seriesModel, result, axisMap, categoryAxisMap) {
    var xAxisModel = seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["x", "y"];
    axisMap.set("x", xAxisModel);
    axisMap.set("y", yAxisModel);
    if (isCategory(xAxisModel)) {
      categoryAxisMap.set("x", xAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(yAxisModel)) {
      categoryAxisMap.set("y", yAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  singleAxis: function(seriesModel, result, axisMap, categoryAxisMap) {
    var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    result.coordSysDims = ["single"];
    axisMap.set("single", singleAxisModel);
    if (isCategory(singleAxisModel)) {
      categoryAxisMap.set("single", singleAxisModel);
      result.firstCategoryDimIndex = 0;
    }
  },
  polar: function(seriesModel, result, axisMap, categoryAxisMap) {
    var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
    var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
    var angleAxisModel = polarModel.findAxisModel("angleAxis");
    result.coordSysDims = ["radius", "angle"];
    axisMap.set("radius", radiusAxisModel);
    axisMap.set("angle", angleAxisModel);
    if (isCategory(radiusAxisModel)) {
      categoryAxisMap.set("radius", radiusAxisModel);
      result.firstCategoryDimIndex = 0;
    }
    if (isCategory(angleAxisModel)) {
      categoryAxisMap.set("angle", angleAxisModel);
      result.firstCategoryDimIndex == null && (result.firstCategoryDimIndex = 1);
    }
  },
  geo: function(seriesModel, result, axisMap, categoryAxisMap) {
    result.coordSysDims = ["lng", "lat"];
  },
  parallel: function(seriesModel, result, axisMap, categoryAxisMap) {
    var ecModel = seriesModel.ecModel;
    var parallelModel = ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
    var coordSysDims = result.coordSysDims = parallelModel.dimensions.slice();
    each$f(parallelModel.parallelAxisIndex, function(axisIndex, index2) {
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axisDim = coordSysDims[index2];
      axisMap.set(axisDim, axisModel);
      if (isCategory(axisModel)) {
        categoryAxisMap.set(axisDim, axisModel);
        if (result.firstCategoryDimIndex == null) {
          result.firstCategoryDimIndex = index2;
        }
      }
    });
  }
};
function isCategory(axisModel) {
  return axisModel.get("type") === "category";
}
function enableDataStack(seriesModel, dimensionsInput, opt) {
  opt = opt || {};
  var byIndex = opt.byIndex;
  var stackedCoordDimension = opt.stackedCoordDimension;
  var dimensionDefineList;
  var schema;
  var store;
  if (isLegacyDimensionsInput(dimensionsInput)) {
    dimensionDefineList = dimensionsInput;
  } else {
    schema = dimensionsInput.schema;
    dimensionDefineList = schema.dimensions;
    store = dimensionsInput.store;
  }
  var mayStack = !!(seriesModel && seriesModel.get("stack"));
  var stackedByDimInfo;
  var stackedDimInfo;
  var stackResultDimension;
  var stackedOverDimension;
  each$f(dimensionDefineList, function(dimensionInfo, index2) {
    if (isString(dimensionInfo)) {
      dimensionDefineList[index2] = dimensionInfo = {
        name: dimensionInfo
      };
    }
    if (mayStack && !dimensionInfo.isExtraCoord) {
      if (!byIndex && !stackedByDimInfo && dimensionInfo.ordinalMeta) {
        stackedByDimInfo = dimensionInfo;
      }
      if (!stackedDimInfo && dimensionInfo.type !== "ordinal" && dimensionInfo.type !== "time" && (!stackedCoordDimension || stackedCoordDimension === dimensionInfo.coordDim)) {
        stackedDimInfo = dimensionInfo;
      }
    }
  });
  if (stackedDimInfo && !byIndex && !stackedByDimInfo) {
    byIndex = true;
  }
  if (stackedDimInfo) {
    stackResultDimension = "__\0ecstackresult_" + seriesModel.id;
    stackedOverDimension = "__\0ecstackedover_" + seriesModel.id;
    if (stackedByDimInfo) {
      stackedByDimInfo.createInvertedIndices = true;
    }
    var stackedDimCoordDim_1 = stackedDimInfo.coordDim;
    var stackedDimType = stackedDimInfo.type;
    var stackedDimCoordIndex_1 = 0;
    each$f(dimensionDefineList, function(dimensionInfo) {
      if (dimensionInfo.coordDim === stackedDimCoordDim_1) {
        stackedDimCoordIndex_1++;
      }
    });
    var stackedOverDimensionDefine = {
      name: stackResultDimension,
      coordDim: stackedDimCoordDim_1,
      coordDimIndex: stackedDimCoordIndex_1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length
    };
    var stackResultDimensionDefine = {
      name: stackedOverDimension,
      coordDim: stackedOverDimension,
      coordDimIndex: stackedDimCoordIndex_1 + 1,
      type: stackedDimType,
      isExtraCoord: true,
      isCalculationCoord: true,
      storeDimIndex: dimensionDefineList.length + 1
    };
    if (schema) {
      if (store) {
        stackedOverDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackedOverDimension, stackedDimType);
        stackResultDimensionDefine.storeDimIndex = store.ensureCalculationDimension(stackResultDimension, stackedDimType);
      }
      schema.appendCalculationDimension(stackedOverDimensionDefine);
      schema.appendCalculationDimension(stackResultDimensionDefine);
    } else {
      dimensionDefineList.push(stackedOverDimensionDefine);
      dimensionDefineList.push(stackResultDimensionDefine);
    }
  }
  return {
    stackedDimension: stackedDimInfo && stackedDimInfo.name,
    stackedByDimension: stackedByDimInfo && stackedByDimInfo.name,
    isStackedByIndex: byIndex,
    stackedOverDimension,
    stackResultDimension
  };
}
function isLegacyDimensionsInput(dimensionsInput) {
  return !isSeriesDataSchema(dimensionsInput.schema);
}
function isDimensionStacked(data, stackedDim) {
  return !!stackedDim && stackedDim === data.getCalculationInfo("stackedDimension");
}
function getStackedDimension(data, targetDim) {
  return isDimensionStacked(data, targetDim) ? data.getCalculationInfo("stackResultDimension") : targetDim;
}
function getCoordSysDimDefs(seriesModel, coordSysInfo) {
  var coordSysName = seriesModel.get("coordinateSystem");
  var registeredCoordSys = CoordinateSystem.get(coordSysName);
  var coordSysDimDefs;
  if (coordSysInfo && coordSysInfo.coordSysDims) {
    coordSysDimDefs = map$1(coordSysInfo.coordSysDims, function(dim) {
      var dimInfo = {
        name: dim
      };
      var axisModel = coordSysInfo.axisMap.get(dim);
      if (axisModel) {
        var axisType = axisModel.get("type");
        dimInfo.type = getDimensionTypeByAxis(axisType);
      }
      return dimInfo;
    });
  }
  if (!coordSysDimDefs) {
    coordSysDimDefs = registeredCoordSys && (registeredCoordSys.getDimensionsInfo ? registeredCoordSys.getDimensionsInfo() : registeredCoordSys.dimensions.slice()) || ["x", "y"];
  }
  return coordSysDimDefs;
}
function injectOrdinalMeta(dimInfoList, createInvertedIndices, coordSysInfo) {
  var firstCategoryDimIndex;
  var hasNameEncode;
  coordSysInfo && each$f(dimInfoList, function(dimInfo, dimIndex) {
    var coordDim = dimInfo.coordDim;
    var categoryAxisModel = coordSysInfo.categoryAxisMap.get(coordDim);
    if (categoryAxisModel) {
      if (firstCategoryDimIndex == null) {
        firstCategoryDimIndex = dimIndex;
      }
      dimInfo.ordinalMeta = categoryAxisModel.getOrdinalMeta();
      if (createInvertedIndices) {
        dimInfo.createInvertedIndices = true;
      }
    }
    if (dimInfo.otherDims.itemName != null) {
      hasNameEncode = true;
    }
  });
  if (!hasNameEncode && firstCategoryDimIndex != null) {
    dimInfoList[firstCategoryDimIndex].otherDims.itemName = 0;
  }
  return firstCategoryDimIndex;
}
function createSeriesData(sourceRaw, seriesModel, opt) {
  opt = opt || {};
  var sourceManager = seriesModel.getSourceManager();
  var source;
  var isOriginalSource = false;
  if (sourceRaw) {
    isOriginalSource = true;
    source = createSourceFromSeriesDataOption(sourceRaw);
  } else {
    source = sourceManager.getSource();
    isOriginalSource = source.sourceFormat === SOURCE_FORMAT_ORIGINAL;
  }
  var coordSysInfo = getCoordSysInfoBySeries(seriesModel);
  var coordSysDimDefs = getCoordSysDimDefs(seriesModel, coordSysInfo);
  var useEncodeDefaulter = opt.useEncodeDefaulter;
  var encodeDefaulter = isFunction(useEncodeDefaulter) ? useEncodeDefaulter : useEncodeDefaulter ? curry$1(makeSeriesEncodeForAxisCoordSys, coordSysDimDefs, seriesModel) : null;
  var createDimensionOptions = {
    coordDimensions: coordSysDimDefs,
    generateCoord: opt.generateCoord,
    encodeDefine: seriesModel.getEncode(),
    encodeDefaulter,
    canOmitUnusedDimensions: !isOriginalSource
  };
  var schema = prepareSeriesDataSchema(source, createDimensionOptions);
  var firstCategoryDimIndex = injectOrdinalMeta(schema.dimensions, opt.createInvertedIndices, coordSysInfo);
  var store = !isOriginalSource ? sourceManager.getSharedDataStore(schema) : null;
  var stackCalculationInfo = enableDataStack(seriesModel, {
    schema,
    store
  });
  var data = new SeriesData$1(schema, seriesModel);
  data.setCalculationInfo(stackCalculationInfo);
  var dimValueGetter = firstCategoryDimIndex != null && isNeedCompleteOrdinalData(source) ? function(itemOpt, dimName, dataIndex, dimIndex) {
    return dimIndex === firstCategoryDimIndex ? dataIndex : this.defaultDimValueGetter(itemOpt, dimName, dataIndex, dimIndex);
  } : null;
  data.hasItemOption = false;
  data.initData(isOriginalSource ? source : store, null, dimValueGetter);
  return data;
}
function isNeedCompleteOrdinalData(source) {
  if (source.sourceFormat === SOURCE_FORMAT_ORIGINAL) {
    var sampleItem = firstDataNotNull(source.data || []);
    return !isArray$1(getDataItemValue(sampleItem));
  }
}
function firstDataNotNull(arr) {
  var i = 0;
  while (i < arr.length && arr[i] == null) {
    i++;
  }
  return arr[i];
}
var Scale = function() {
  function Scale2(setting) {
    this._setting = setting || {};
    this._extent = [Infinity, -Infinity];
  }
  Scale2.prototype.getSetting = function(name) {
    return this._setting[name];
  };
  Scale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
  };
  Scale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  Scale2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Scale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = start2;
    }
    if (!isNaN(end2)) {
      thisExtent[1] = end2;
    }
  };
  Scale2.prototype.isInExtentRange = function(value) {
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  Scale2.prototype.isBlank = function() {
    return this._isBlank;
  };
  Scale2.prototype.setBlank = function(isBlank) {
    this._isBlank = isBlank;
  };
  return Scale2;
}();
enableClassManagement(Scale);
var Scale$1 = Scale;
var uidBase = 0;
var OrdinalMeta = function() {
  function OrdinalMeta2(opt) {
    this.categories = opt.categories || [];
    this._needCollect = opt.needCollect;
    this._deduplication = opt.deduplication;
    this.uid = ++uidBase;
  }
  OrdinalMeta2.createByAxisModel = function(axisModel) {
    var option = axisModel.option;
    var data = option.data;
    var categories = data && map$1(data, getName);
    return new OrdinalMeta2({
      categories,
      needCollect: !categories,
      deduplication: option.dedplication !== false
    });
  };
  OrdinalMeta2.prototype.getOrdinal = function(category) {
    return this._getOrCreateMap().get(category);
  };
  OrdinalMeta2.prototype.parseAndCollect = function(category) {
    var index2;
    var needCollect = this._needCollect;
    if (!isString(category) && !needCollect) {
      return category;
    }
    if (needCollect && !this._deduplication) {
      index2 = this.categories.length;
      this.categories[index2] = category;
      return index2;
    }
    var map2 = this._getOrCreateMap();
    index2 = map2.get(category);
    if (index2 == null) {
      if (needCollect) {
        index2 = this.categories.length;
        this.categories[index2] = category;
        map2.set(category, index2);
      } else {
        index2 = NaN;
      }
    }
    return index2;
  };
  OrdinalMeta2.prototype._getOrCreateMap = function() {
    return this._map || (this._map = createHashMap(this.categories));
  };
  return OrdinalMeta2;
}();
function getName(obj) {
  if (isObject$4(obj) && obj.value != null) {
    return obj.value;
  } else {
    return obj + "";
  }
}
var OrdinalMeta$1 = OrdinalMeta;
function isIntervalOrLogScale(scale2) {
  return scale2.type === "interval" || scale2.type === "log";
}
function intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval) {
  var result = {};
  var span = extent3[1] - extent3[0];
  var interval = result.interval = nice(span / splitNumber, true);
  if (minInterval != null && interval < minInterval) {
    interval = result.interval = minInterval;
  }
  if (maxInterval != null && interval > maxInterval) {
    interval = result.interval = maxInterval;
  }
  var precision = result.intervalPrecision = getIntervalPrecision(interval);
  var niceTickExtent = result.niceTickExtent = [round$3(Math.ceil(extent3[0] / interval) * interval, precision), round$3(Math.floor(extent3[1] / interval) * interval, precision)];
  fixExtent(niceTickExtent, extent3);
  return result;
}
function increaseInterval(interval) {
  var exp10 = Math.pow(10, quantityExponent(interval));
  var f2 = interval / exp10;
  if (!f2) {
    f2 = 1;
  } else if (f2 === 2) {
    f2 = 3;
  } else if (f2 === 3) {
    f2 = 5;
  } else {
    f2 *= 2;
  }
  return round$3(f2 * exp10);
}
function getIntervalPrecision(interval) {
  return getPrecision(interval) + 2;
}
function clamp(niceTickExtent, idx, extent3) {
  niceTickExtent[idx] = Math.max(Math.min(niceTickExtent[idx], extent3[1]), extent3[0]);
}
function fixExtent(niceTickExtent, extent3) {
  !isFinite(niceTickExtent[0]) && (niceTickExtent[0] = extent3[0]);
  !isFinite(niceTickExtent[1]) && (niceTickExtent[1] = extent3[1]);
  clamp(niceTickExtent, 0, extent3);
  clamp(niceTickExtent, 1, extent3);
  if (niceTickExtent[0] > niceTickExtent[1]) {
    niceTickExtent[0] = niceTickExtent[1];
  }
}
function contain$1(val, extent3) {
  return val >= extent3[0] && val <= extent3[1];
}
function normalize$3(val, extent3) {
  if (extent3[1] === extent3[0]) {
    return 0.5;
  }
  return (val - extent3[0]) / (extent3[1] - extent3[0]);
}
function scale(val, extent3) {
  return val * (extent3[1] - extent3[0]) + extent3[0];
}
var OrdinalScale = function(_super) {
  __extends(OrdinalScale2, _super);
  function OrdinalScale2(setting) {
    var _this = _super.call(this, setting) || this;
    _this.type = "ordinal";
    var ordinalMeta = _this.getSetting("ordinalMeta");
    if (!ordinalMeta) {
      ordinalMeta = new OrdinalMeta$1({});
    }
    if (isArray$1(ordinalMeta)) {
      ordinalMeta = new OrdinalMeta$1({
        categories: map$1(ordinalMeta, function(item) {
          return isObject$4(item) ? item.value : item;
        })
      });
    }
    _this._ordinalMeta = ordinalMeta;
    _this._extent = _this.getSetting("extent") || [0, ordinalMeta.categories.length - 1];
    return _this;
  }
  OrdinalScale2.prototype.parse = function(val) {
    return isString(val) ? this._ordinalMeta.getOrdinal(val) : Math.round(val);
  };
  OrdinalScale2.prototype.contain = function(rank) {
    rank = this.parse(rank);
    return contain$1(rank, this._extent) && this._ordinalMeta.categories[rank] != null;
  };
  OrdinalScale2.prototype.normalize = function(val) {
    val = this._getTickNumber(this.parse(val));
    return normalize$3(val, this._extent);
  };
  OrdinalScale2.prototype.scale = function(val) {
    val = Math.round(scale(val, this._extent));
    return this.getRawOrdinalNumber(val);
  };
  OrdinalScale2.prototype.getTicks = function() {
    var ticks = [];
    var extent3 = this._extent;
    var rank = extent3[0];
    while (rank <= extent3[1]) {
      ticks.push({
        value: rank
      });
      rank++;
    }
    return ticks;
  };
  OrdinalScale2.prototype.getMinorTicks = function(splitNumber) {
    return;
  };
  OrdinalScale2.prototype.setSortInfo = function(info) {
    if (info == null) {
      this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
      return;
    }
    var infoOrdinalNumbers = info.ordinalNumbers;
    var ordinalsByTick = this._ordinalNumbersByTick = [];
    var ticksByOrdinal = this._ticksByOrdinalNumber = [];
    var tickNum = 0;
    var allCategoryLen = this._ordinalMeta.categories.length;
    for (var len2 = Math.min(allCategoryLen, infoOrdinalNumbers.length); tickNum < len2; ++tickNum) {
      var ordinalNumber = infoOrdinalNumbers[tickNum];
      ordinalsByTick[tickNum] = ordinalNumber;
      ticksByOrdinal[ordinalNumber] = tickNum;
    }
    var unusedOrdinal = 0;
    for (; tickNum < allCategoryLen; ++tickNum) {
      while (ticksByOrdinal[unusedOrdinal] != null) {
        unusedOrdinal++;
      }
      ordinalsByTick.push(unusedOrdinal);
      ticksByOrdinal[unusedOrdinal] = tickNum;
    }
  };
  OrdinalScale2.prototype._getTickNumber = function(ordinal) {
    var ticksByOrdinalNumber = this._ticksByOrdinalNumber;
    return ticksByOrdinalNumber && ordinal >= 0 && ordinal < ticksByOrdinalNumber.length ? ticksByOrdinalNumber[ordinal] : ordinal;
  };
  OrdinalScale2.prototype.getRawOrdinalNumber = function(tickNumber) {
    var ordinalNumbersByTick = this._ordinalNumbersByTick;
    return ordinalNumbersByTick && tickNumber >= 0 && tickNumber < ordinalNumbersByTick.length ? ordinalNumbersByTick[tickNumber] : tickNumber;
  };
  OrdinalScale2.prototype.getLabel = function(tick) {
    if (!this.isBlank()) {
      var ordinalNumber = this.getRawOrdinalNumber(tick.value);
      var cateogry = this._ordinalMeta.categories[ordinalNumber];
      return cateogry == null ? "" : cateogry + "";
    }
  };
  OrdinalScale2.prototype.count = function() {
    return this._extent[1] - this._extent[0] + 1;
  };
  OrdinalScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  OrdinalScale2.prototype.isInExtentRange = function(value) {
    value = this._getTickNumber(value);
    return this._extent[0] <= value && this._extent[1] >= value;
  };
  OrdinalScale2.prototype.getOrdinalMeta = function() {
    return this._ordinalMeta;
  };
  OrdinalScale2.prototype.calcNiceTicks = function() {
  };
  OrdinalScale2.prototype.calcNiceExtent = function() {
  };
  OrdinalScale2.type = "ordinal";
  return OrdinalScale2;
}(Scale$1);
Scale$1.registerClass(OrdinalScale);
var OrdinalScale$1 = OrdinalScale;
var roundNumber = round$3;
var IntervalScale = function(_super) {
  __extends(IntervalScale2, _super);
  function IntervalScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "interval";
    _this._interval = 0;
    _this._intervalPrecision = 2;
    return _this;
  }
  IntervalScale2.prototype.parse = function(val) {
    return val;
  };
  IntervalScale2.prototype.contain = function(val) {
    return contain$1(val, this._extent);
  };
  IntervalScale2.prototype.normalize = function(val) {
    return normalize$3(val, this._extent);
  };
  IntervalScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  IntervalScale2.prototype.setExtent = function(start2, end2) {
    var thisExtent = this._extent;
    if (!isNaN(start2)) {
      thisExtent[0] = parseFloat(start2);
    }
    if (!isNaN(end2)) {
      thisExtent[1] = parseFloat(end2);
    }
  };
  IntervalScale2.prototype.unionExtent = function(other) {
    var extent3 = this._extent;
    other[0] < extent3[0] && (extent3[0] = other[0]);
    other[1] > extent3[1] && (extent3[1] = other[1]);
    this.setExtent(extent3[0], extent3[1]);
  };
  IntervalScale2.prototype.getInterval = function() {
    return this._interval;
  };
  IntervalScale2.prototype.setInterval = function(interval) {
    this._interval = interval;
    this._niceExtent = this._extent.slice();
    this._intervalPrecision = getIntervalPrecision(interval);
  };
  IntervalScale2.prototype.getTicks = function(expandToNicedExtent) {
    var interval = this._interval;
    var extent3 = this._extent;
    var niceTickExtent = this._niceExtent;
    var intervalPrecision = this._intervalPrecision;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    var safeLimit = 1e4;
    if (extent3[0] < niceTickExtent[0]) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(niceTickExtent[0] - interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[0]
        });
      }
    }
    var tick = niceTickExtent[0];
    while (tick <= niceTickExtent[1]) {
      ticks.push({
        value: tick
      });
      tick = roundNumber(tick + interval, intervalPrecision);
      if (tick === ticks[ticks.length - 1].value) {
        break;
      }
      if (ticks.length > safeLimit) {
        return [];
      }
    }
    var lastNiceTick = ticks.length ? ticks[ticks.length - 1].value : niceTickExtent[1];
    if (extent3[1] > lastNiceTick) {
      if (expandToNicedExtent) {
        ticks.push({
          value: roundNumber(lastNiceTick + interval, intervalPrecision)
        });
      } else {
        ticks.push({
          value: extent3[1]
        });
      }
    }
    return ticks;
  };
  IntervalScale2.prototype.getMinorTicks = function(splitNumber) {
    var ticks = this.getTicks(true);
    var minorTicks = [];
    var extent3 = this.getExtent();
    for (var i = 1; i < ticks.length; i++) {
      var nextTick = ticks[i];
      var prevTick = ticks[i - 1];
      var count2 = 0;
      var minorTicksGroup = [];
      var interval = nextTick.value - prevTick.value;
      var minorInterval = interval / splitNumber;
      while (count2 < splitNumber - 1) {
        var minorTick = roundNumber(prevTick.value + (count2 + 1) * minorInterval);
        if (minorTick > extent3[0] && minorTick < extent3[1]) {
          minorTicksGroup.push(minorTick);
        }
        count2++;
      }
      minorTicks.push(minorTicksGroup);
    }
    return minorTicks;
  };
  IntervalScale2.prototype.getLabel = function(data, opt) {
    if (data == null) {
      return "";
    }
    var precision = opt && opt.precision;
    if (precision == null) {
      precision = getPrecision(data.value) || 0;
    } else if (precision === "auto") {
      precision = this._intervalPrecision;
    }
    var dataNum = roundNumber(data.value, precision, true);
    return addCommas(dataNum);
  };
  IntervalScale2.prototype.calcNiceTicks = function(splitNumber, minInterval, maxInterval) {
    splitNumber = splitNumber || 5;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      return;
    }
    if (span < 0) {
      span = -span;
      extent3.reverse();
    }
    var result = intervalScaleNiceTicks(extent3, splitNumber, minInterval, maxInterval);
    this._intervalPrecision = result.intervalPrecision;
    this._interval = result.interval;
    this._niceExtent = result.niceTickExtent;
  };
  IntervalScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      if (extent3[0] !== 0) {
        var expandSize = extent3[0];
        if (!opt.fixMax) {
          extent3[1] += expandSize / 2;
          extent3[0] -= expandSize / 2;
        } else {
          extent3[0] -= expandSize / 2;
        }
      } else {
        extent3[1] = 1;
      }
    }
    var span = extent3[1] - extent3[0];
    if (!isFinite(span)) {
      extent3[0] = 0;
      extent3[1] = 1;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
    var interval = this._interval;
    if (!opt.fixMin) {
      extent3[0] = roundNumber(Math.floor(extent3[0] / interval) * interval);
    }
    if (!opt.fixMax) {
      extent3[1] = roundNumber(Math.ceil(extent3[1] / interval) * interval);
    }
  };
  IntervalScale2.prototype.setNiceExtent = function(min3, max3) {
    this._niceExtent = [min3, max3];
  };
  IntervalScale2.type = "interval";
  return IntervalScale2;
}(Scale$1);
Scale$1.registerClass(IntervalScale);
var IntervalScale$1 = IntervalScale;
var supportFloat32Array = typeof Float32Array !== "undefined";
var Float32ArrayCtor = !supportFloat32Array ? Array : Float32Array;
function createFloat32Array(arg) {
  if (isArray$1(arg)) {
    return supportFloat32Array ? new Float32Array(arg) : arg;
  }
  return new Float32ArrayCtor(arg);
}
var STACK_PREFIX = "__ec_stack_";
function getSeriesStackId$1(seriesModel) {
  return seriesModel.get("stack") || STACK_PREFIX + seriesModel.seriesIndex;
}
function getAxisKey$1(axis) {
  return axis.dim + axis.index;
}
function getLayoutOnAxis(opt) {
  var params = [];
  var baseAxis = opt.axis;
  var axisKey = "axis0";
  if (baseAxis.type !== "category") {
    return;
  }
  var bandWidth = baseAxis.getBandWidth();
  for (var i = 0; i < opt.count || 0; i++) {
    params.push(defaults({
      bandWidth,
      axisKey,
      stackId: STACK_PREFIX + i
    }, opt));
  }
  var widthAndOffsets = doCalBarWidthAndOffset(params);
  var result = [];
  for (var i = 0; i < opt.count; i++) {
    var item = widthAndOffsets[axisKey][STACK_PREFIX + i];
    item.offsetCenter = item.offset + item.width / 2;
    result.push(item);
  }
  return result;
}
function prepareLayoutBarSeries(seriesType2, ecModel) {
  var seriesModels = [];
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (isOnCartesian(seriesModel)) {
      seriesModels.push(seriesModel);
    }
  });
  return seriesModels;
}
function getValueAxesMinGaps(barSeries) {
  var axisValues = {};
  each$f(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    if (baseAxis.type !== "time" && baseAxis.type !== "value") {
      return;
    }
    var data = seriesModel.getData();
    var key2 = baseAxis.dim + "_" + baseAxis.index;
    var dimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
    var store = data.getStore();
    for (var i = 0, cnt = store.count(); i < cnt; ++i) {
      var value = store.get(dimIdx, i);
      if (!axisValues[key2]) {
        axisValues[key2] = [value];
      } else {
        axisValues[key2].push(value);
      }
    }
  });
  var axisMinGaps = {};
  for (var key in axisValues) {
    if (axisValues.hasOwnProperty(key)) {
      var valuesInAxis = axisValues[key];
      if (valuesInAxis) {
        valuesInAxis.sort(function(a, b2) {
          return a - b2;
        });
        var min3 = null;
        for (var j = 1; j < valuesInAxis.length; ++j) {
          var delta = valuesInAxis[j] - valuesInAxis[j - 1];
          if (delta > 0) {
            min3 = min3 === null ? delta : Math.min(min3, delta);
          }
        }
        axisMinGaps[key] = min3;
      }
    }
  }
  return axisMinGaps;
}
function makeColumnLayout(barSeries) {
  var axisMinGaps = getValueAxesMinGaps(barSeries);
  var seriesInfoList = [];
  each$f(barSeries, function(seriesModel) {
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var axisExtent = baseAxis.getExtent();
    var bandWidth;
    if (baseAxis.type === "category") {
      bandWidth = baseAxis.getBandWidth();
    } else if (baseAxis.type === "value" || baseAxis.type === "time") {
      var key = baseAxis.dim + "_" + baseAxis.index;
      var minGap = axisMinGaps[key];
      var extentSpan = Math.abs(axisExtent[1] - axisExtent[0]);
      var scale2 = baseAxis.scale.getExtent();
      var scaleSpan = Math.abs(scale2[1] - scale2[0]);
      bandWidth = minGap ? extentSpan / scaleSpan * minGap : extentSpan;
    } else {
      var data = seriesModel.getData();
      bandWidth = Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    }
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barMinWidth = parsePercent(seriesModel.get("barMinWidth") || (isInLargeMode(seriesModel) ? 0.5 : 1), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    seriesInfoList.push({
      bandWidth,
      barWidth,
      barMaxWidth,
      barMinWidth,
      barGap,
      barCategoryGap,
      axisKey: getAxisKey$1(baseAxis),
      stackId: getSeriesStackId$1(seriesModel)
    });
  });
  return doCalBarWidthAndOffset(seriesInfoList);
}
function doCalBarWidthAndOffset(seriesInfoList) {
  var columnsMap = {};
  each$f(seriesInfoList, function(seriesInfo, idx) {
    var axisKey = seriesInfo.axisKey;
    var bandWidth = seriesInfo.bandWidth;
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: null,
      gap: "20%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = seriesInfo.stackId;
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = seriesInfo.barWidth;
    if (barWidth && !stacks[stackId].width) {
      stacks[stackId].width = barWidth;
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      columnsOnAxis.remainedWidth -= barWidth;
    }
    var barMaxWidth = seriesInfo.barMaxWidth;
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    var barMinWidth = seriesInfo.barMinWidth;
    barMinWidth && (stacks[stackId].minWidth = barMinWidth);
    var barGap = seriesInfo.barGap;
    barGap != null && (columnsOnAxis.gap = barGap);
    var barCategoryGap = seriesInfo.barCategoryGap;
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$f(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGapPercent = columnsOnAxis.categoryGap;
    if (categoryGapPercent == null) {
      var columnCount = keys(stacks).length;
      categoryGapPercent = Math.max(35 - columnCount * 4, 15) + "%";
    }
    var categoryGap = parsePercent(categoryGapPercent, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$f(stacks, function(column) {
      var maxWidth = column.maxWidth;
      var minWidth = column.minWidth;
      if (!column.width) {
        var finalWidth = autoWidth;
        if (maxWidth && maxWidth < finalWidth) {
          finalWidth = Math.min(maxWidth, remainedWidth);
        }
        if (minWidth && minWidth > finalWidth) {
          finalWidth = minWidth;
        }
        if (finalWidth !== autoWidth) {
          column.width = finalWidth;
          remainedWidth -= finalWidth + barGapPercent * finalWidth;
          autoWidthCount--;
        }
      } else {
        var finalWidth = column.width;
        if (maxWidth) {
          finalWidth = Math.min(finalWidth, maxWidth);
        }
        if (minWidth) {
          finalWidth = Math.max(finalWidth, minWidth);
        }
        column.width = finalWidth;
        remainedWidth -= finalWidth + barGapPercent * finalWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$f(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset = -widthSum / 2;
    each$f(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        bandWidth,
        offset,
        width: column.width
      };
      offset += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
function retrieveColumnLayout(barWidthAndOffset, axis, seriesModel) {
  if (barWidthAndOffset && axis) {
    var result = barWidthAndOffset[getAxisKey$1(axis)];
    if (result != null && seriesModel != null) {
      return result[getSeriesStackId$1(seriesModel)];
    }
    return result;
  }
}
function layout$3(seriesType2, ecModel) {
  var seriesModels = prepareLayoutBarSeries(seriesType2, ecModel);
  var barWidthAndOffset = makeColumnLayout(seriesModels);
  each$f(seriesModels, function(seriesModel) {
    var data = seriesModel.getData();
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var stackId = getSeriesStackId$1(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[getAxisKey$1(baseAxis)][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    data.setLayout({
      bandWidth: columnLayoutInfo.bandWidth,
      offset: columnOffset,
      size: columnWidth
    });
  });
}
function createProgressiveLayout(seriesType2) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      if (!isOnCartesian(seriesModel)) {
        return;
      }
      var data = seriesModel.getData();
      var cartesian = seriesModel.coordinateSystem;
      var baseAxis = cartesian.getBaseAxis();
      var valueAxis2 = cartesian.getOtherAxis(baseAxis);
      var valueDimIdx = data.getDimensionIndex(data.mapDimension(valueAxis2.dim));
      var baseDimIdx = data.getDimensionIndex(data.mapDimension(baseAxis.dim));
      var drawBackground = seriesModel.get("showBackground", true);
      var valueDim = data.mapDimension(valueAxis2.dim);
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      var stacked = isDimensionStacked(data, valueDim) && !!data.getCalculationInfo("stackedOnSeries");
      var isValueAxisH = valueAxis2.isHorizontal();
      var valueAxisStart = getValueAxisStart(baseAxis, valueAxis2);
      var isLarge = isInLargeMode(seriesModel);
      var barMinHeight = seriesModel.get("barMinHeight") || 0;
      var stackedDimIdx = stackResultDim && data.getDimensionIndex(stackResultDim);
      var columnWidth = data.getLayout("size");
      var columnOffset = data.getLayout("offset");
      return {
        progress: function(params, data2) {
          var count2 = params.count;
          var largePoints = isLarge && createFloat32Array(count2 * 3);
          var largeBackgroundPoints = isLarge && drawBackground && createFloat32Array(count2 * 3);
          var largeDataIndices = isLarge && createFloat32Array(count2);
          var coordLayout = cartesian.master.getRect();
          var bgSize = isValueAxisH ? coordLayout.width : coordLayout.height;
          var dataIndex;
          var store = data2.getStore();
          var idxOffset = 0;
          while ((dataIndex = params.next()) != null) {
            var value = store.get(stacked ? stackedDimIdx : valueDimIdx, dataIndex);
            var baseValue = store.get(baseDimIdx, dataIndex);
            var baseCoord = valueAxisStart;
            var startValue = void 0;
            if (stacked) {
              startValue = +value - store.get(valueDimIdx, dataIndex);
            }
            var x2 = void 0;
            var y2 = void 0;
            var width = void 0;
            var height = void 0;
            if (isValueAxisH) {
              var coord = cartesian.dataToPoint([value, baseValue]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([startValue, baseValue]);
                baseCoord = startCoord[0];
              }
              x2 = baseCoord;
              y2 = coord[1] + columnOffset;
              width = coord[0] - baseCoord;
              height = columnWidth;
              if (Math.abs(width) < barMinHeight) {
                width = (width < 0 ? -1 : 1) * barMinHeight;
              }
            } else {
              var coord = cartesian.dataToPoint([baseValue, value]);
              if (stacked) {
                var startCoord = cartesian.dataToPoint([baseValue, startValue]);
                baseCoord = startCoord[1];
              }
              x2 = coord[0] + columnOffset;
              y2 = baseCoord;
              width = columnWidth;
              height = coord[1] - baseCoord;
              if (Math.abs(height) < barMinHeight) {
                height = (height <= 0 ? -1 : 1) * barMinHeight;
              }
            }
            if (!isLarge) {
              data2.setItemLayout(dataIndex, {
                x: x2,
                y: y2,
                width,
                height
              });
            } else {
              largePoints[idxOffset] = x2;
              largePoints[idxOffset + 1] = y2;
              largePoints[idxOffset + 2] = isValueAxisH ? width : height;
              if (largeBackgroundPoints) {
                largeBackgroundPoints[idxOffset] = isValueAxisH ? coordLayout.x : x2;
                largeBackgroundPoints[idxOffset + 1] = isValueAxisH ? y2 : coordLayout.y;
                largeBackgroundPoints[idxOffset + 2] = bgSize;
              }
              largeDataIndices[dataIndex] = dataIndex;
            }
            idxOffset += 3;
          }
          if (isLarge) {
            data2.setLayout({
              largePoints,
              largeDataIndices,
              largeBackgroundPoints,
              valueAxisHorizontal: isValueAxisH
            });
          }
        }
      };
    }
  };
}
function isOnCartesian(seriesModel) {
  return seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "cartesian2d";
}
function isInLargeMode(seriesModel) {
  return seriesModel.pipelineContext && seriesModel.pipelineContext.large;
}
function getValueAxisStart(baseAxis, valueAxis2) {
  return valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(valueAxis2.type === "log" ? 1 : 0));
}
var bisect = function(a, x2, lo, hi) {
  while (lo < hi) {
    var mid = lo + hi >>> 1;
    if (a[mid][1] < x2) {
      lo = mid + 1;
    } else {
      hi = mid;
    }
  }
  return lo;
};
var TimeScale = function(_super) {
  __extends(TimeScale2, _super);
  function TimeScale2(settings) {
    var _this = _super.call(this, settings) || this;
    _this.type = "time";
    return _this;
  }
  TimeScale2.prototype.getLabel = function(tick) {
    var useUTC = this.getSetting("useUTC");
    return format$1(tick.value, fullLeveledFormatter[getDefaultFormatPrecisionOfInterval(getPrimaryTimeUnit(this._minLevelUnit))] || fullLeveledFormatter.second, useUTC, this.getSetting("locale"));
  };
  TimeScale2.prototype.getFormattedLabel = function(tick, idx, labelFormatter) {
    var isUTC = this.getSetting("useUTC");
    var lang = this.getSetting("locale");
    return leveledFormat(tick, idx, labelFormatter, lang, isUTC);
  };
  TimeScale2.prototype.getTicks = function() {
    var interval = this._interval;
    var extent3 = this._extent;
    var ticks = [];
    if (!interval) {
      return ticks;
    }
    ticks.push({
      value: extent3[0],
      level: 0
    });
    var useUTC = this.getSetting("useUTC");
    var innerTicks = getIntervalTicks(this._minLevelUnit, this._approxInterval, useUTC, extent3);
    ticks = ticks.concat(innerTicks);
    ticks.push({
      value: extent3[1],
      level: 0
    });
    return ticks;
  };
  TimeScale2.prototype.calcNiceExtent = function(opt) {
    var extent3 = this._extent;
    if (extent3[0] === extent3[1]) {
      extent3[0] -= ONE_DAY;
      extent3[1] += ONE_DAY;
    }
    if (extent3[1] === -Infinity && extent3[0] === Infinity) {
      var d2 = new Date();
      extent3[1] = +new Date(d2.getFullYear(), d2.getMonth(), d2.getDate());
      extent3[0] = extent3[1] - ONE_DAY;
    }
    this.calcNiceTicks(opt.splitNumber, opt.minInterval, opt.maxInterval);
  };
  TimeScale2.prototype.calcNiceTicks = function(approxTickNum, minInterval, maxInterval) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    this._approxInterval = span / approxTickNum;
    if (minInterval != null && this._approxInterval < minInterval) {
      this._approxInterval = minInterval;
    }
    if (maxInterval != null && this._approxInterval > maxInterval) {
      this._approxInterval = maxInterval;
    }
    var scaleIntervalsLen = scaleIntervals.length;
    var idx = Math.min(bisect(scaleIntervals, this._approxInterval, 0, scaleIntervalsLen), scaleIntervalsLen - 1);
    this._interval = scaleIntervals[idx][1];
    this._minLevelUnit = scaleIntervals[Math.max(idx - 1, 0)][0];
  };
  TimeScale2.prototype.parse = function(val) {
    return isNumber(val) ? val : +parseDate(val);
  };
  TimeScale2.prototype.contain = function(val) {
    return contain$1(this.parse(val), this._extent);
  };
  TimeScale2.prototype.normalize = function(val) {
    return normalize$3(this.parse(val), this._extent);
  };
  TimeScale2.prototype.scale = function(val) {
    return scale(val, this._extent);
  };
  TimeScale2.type = "time";
  return TimeScale2;
}(IntervalScale$1);
var scaleIntervals = [
  ["second", ONE_SECOND],
  ["minute", ONE_MINUTE],
  ["hour", ONE_HOUR],
  ["quarter-day", ONE_HOUR * 6],
  ["half-day", ONE_HOUR * 12],
  ["day", ONE_DAY * 1.2],
  ["half-week", ONE_DAY * 3.5],
  ["week", ONE_DAY * 7],
  ["month", ONE_DAY * 31],
  ["quarter", ONE_DAY * 95],
  ["half-year", ONE_YEAR / 2],
  ["year", ONE_YEAR]
];
function isUnitValueSame(unit, valueA, valueB, isUTC) {
  var dateA = parseDate(valueA);
  var dateB = parseDate(valueB);
  var isSame = function(unit2) {
    return getUnitValue(dateA, unit2, isUTC) === getUnitValue(dateB, unit2, isUTC);
  };
  var isSameYear = function() {
    return isSame("year");
  };
  var isSameMonth = function() {
    return isSameYear() && isSame("month");
  };
  var isSameDay = function() {
    return isSameMonth() && isSame("day");
  };
  var isSameHour = function() {
    return isSameDay() && isSame("hour");
  };
  var isSameMinute = function() {
    return isSameHour() && isSame("minute");
  };
  var isSameSecond = function() {
    return isSameMinute() && isSame("second");
  };
  var isSameMilliSecond = function() {
    return isSameSecond() && isSame("millisecond");
  };
  switch (unit) {
    case "year":
      return isSameYear();
    case "month":
      return isSameMonth();
    case "day":
      return isSameDay();
    case "hour":
      return isSameHour();
    case "minute":
      return isSameMinute();
    case "second":
      return isSameSecond();
    case "millisecond":
      return isSameMilliSecond();
  }
}
function getDateInterval(approxInterval, daysInMonth) {
  approxInterval /= ONE_DAY;
  return approxInterval > 16 ? 16 : approxInterval > 7.5 ? 7 : approxInterval > 3.5 ? 4 : approxInterval > 1.5 ? 2 : 1;
}
function getMonthInterval(approxInterval) {
  var APPROX_ONE_MONTH = 30 * ONE_DAY;
  approxInterval /= APPROX_ONE_MONTH;
  return approxInterval > 6 ? 6 : approxInterval > 3 ? 3 : approxInterval > 2 ? 2 : 1;
}
function getHourInterval(approxInterval) {
  approxInterval /= ONE_HOUR;
  return approxInterval > 12 ? 12 : approxInterval > 6 ? 6 : approxInterval > 3.5 ? 4 : approxInterval > 2 ? 2 : 1;
}
function getMinutesAndSecondsInterval(approxInterval, isMinutes) {
  approxInterval /= isMinutes ? ONE_MINUTE : ONE_SECOND;
  return approxInterval > 30 ? 30 : approxInterval > 20 ? 20 : approxInterval > 15 ? 15 : approxInterval > 10 ? 10 : approxInterval > 5 ? 5 : approxInterval > 2 ? 2 : 1;
}
function getMillisecondsInterval(approxInterval) {
  return nice(approxInterval, true);
}
function getFirstTimestampOfUnit(date4, unitName, isUTC) {
  var outDate = new Date(date4);
  switch (getPrimaryTimeUnit(unitName)) {
    case "year":
    case "month":
      outDate[monthSetterName(isUTC)](0);
    case "day":
      outDate[dateSetterName(isUTC)](1);
    case "hour":
      outDate[hoursSetterName(isUTC)](0);
    case "minute":
      outDate[minutesSetterName(isUTC)](0);
    case "second":
      outDate[secondsSetterName(isUTC)](0);
      outDate[millisecondsSetterName(isUTC)](0);
  }
  return outDate.getTime();
}
function getIntervalTicks(bottomUnitName, approxInterval, isUTC, extent3) {
  var safeLimit = 1e4;
  var unitNames = timeUnits;
  var iter = 0;
  function addTicksInSpan(interval, minTimestamp, maxTimestamp, getMethodName, setMethodName, isDate, out2) {
    var date4 = new Date(minTimestamp);
    var dateTime = minTimestamp;
    var d2 = date4[getMethodName]();
    while (dateTime < maxTimestamp && dateTime <= extent3[1]) {
      out2.push({
        value: dateTime
      });
      d2 += interval;
      date4[setMethodName](d2);
      dateTime = date4.getTime();
    }
    out2.push({
      value: dateTime,
      notAdd: true
    });
  }
  function addLevelTicks(unitName, lastLevelTicks, levelTicks2) {
    var newAddedTicks = [];
    var isFirstLevel = !lastLevelTicks.length;
    if (isUnitValueSame(getPrimaryTimeUnit(unitName), extent3[0], extent3[1], isUTC)) {
      return;
    }
    if (isFirstLevel) {
      lastLevelTicks = [{
        value: getFirstTimestampOfUnit(new Date(extent3[0]), unitName, isUTC)
      }, {
        value: extent3[1]
      }];
    }
    for (var i2 = 0; i2 < lastLevelTicks.length - 1; i2++) {
      var startTick = lastLevelTicks[i2].value;
      var endTick = lastLevelTicks[i2 + 1].value;
      if (startTick === endTick) {
        continue;
      }
      var interval = void 0;
      var getterName = void 0;
      var setterName = void 0;
      var isDate = false;
      switch (unitName) {
        case "year":
          interval = Math.max(1, Math.round(approxInterval / ONE_DAY / 365));
          getterName = fullYearGetterName(isUTC);
          setterName = fullYearSetterName(isUTC);
          break;
        case "half-year":
        case "quarter":
        case "month":
          interval = getMonthInterval(approxInterval);
          getterName = monthGetterName(isUTC);
          setterName = monthSetterName(isUTC);
          break;
        case "week":
        case "half-week":
        case "day":
          interval = getDateInterval(approxInterval);
          getterName = dateGetterName(isUTC);
          setterName = dateSetterName(isUTC);
          isDate = true;
          break;
        case "half-day":
        case "quarter-day":
        case "hour":
          interval = getHourInterval(approxInterval);
          getterName = hoursGetterName(isUTC);
          setterName = hoursSetterName(isUTC);
          break;
        case "minute":
          interval = getMinutesAndSecondsInterval(approxInterval, true);
          getterName = minutesGetterName(isUTC);
          setterName = minutesSetterName(isUTC);
          break;
        case "second":
          interval = getMinutesAndSecondsInterval(approxInterval, false);
          getterName = secondsGetterName(isUTC);
          setterName = secondsSetterName(isUTC);
          break;
        case "millisecond":
          interval = getMillisecondsInterval(approxInterval);
          getterName = millisecondsGetterName(isUTC);
          setterName = millisecondsSetterName(isUTC);
          break;
      }
      addTicksInSpan(interval, startTick, endTick, getterName, setterName, isDate, newAddedTicks);
      if (unitName === "year" && levelTicks2.length > 1 && i2 === 0) {
        levelTicks2.unshift({
          value: levelTicks2[0].value - interval
        });
      }
    }
    for (var i2 = 0; i2 < newAddedTicks.length; i2++) {
      levelTicks2.push(newAddedTicks[i2]);
    }
    return newAddedTicks;
  }
  var levelsTicks = [];
  var currentLevelTicks = [];
  var tickCount = 0;
  var lastLevelTickCount = 0;
  for (var i = 0; i < unitNames.length && iter++ < safeLimit; ++i) {
    var primaryTimeUnit = getPrimaryTimeUnit(unitNames[i]);
    if (!isPrimaryTimeUnit(unitNames[i])) {
      continue;
    }
    addLevelTicks(unitNames[i], levelsTicks[levelsTicks.length - 1] || [], currentLevelTicks);
    var nextPrimaryTimeUnit = unitNames[i + 1] ? getPrimaryTimeUnit(unitNames[i + 1]) : null;
    if (primaryTimeUnit !== nextPrimaryTimeUnit) {
      if (currentLevelTicks.length) {
        lastLevelTickCount = tickCount;
        currentLevelTicks.sort(function(a, b2) {
          return a.value - b2.value;
        });
        var levelTicksRemoveDuplicated = [];
        for (var i_1 = 0; i_1 < currentLevelTicks.length; ++i_1) {
          var tickValue = currentLevelTicks[i_1].value;
          if (i_1 === 0 || currentLevelTicks[i_1 - 1].value !== tickValue) {
            levelTicksRemoveDuplicated.push(currentLevelTicks[i_1]);
            if (tickValue >= extent3[0] && tickValue <= extent3[1]) {
              tickCount++;
            }
          }
        }
        var targetTickNum = (extent3[1] - extent3[0]) / approxInterval;
        if (tickCount > targetTickNum * 1.5 && lastLevelTickCount > targetTickNum / 1.5) {
          break;
        }
        levelsTicks.push(levelTicksRemoveDuplicated);
        if (tickCount > targetTickNum || bottomUnitName === unitNames[i]) {
          break;
        }
      }
      currentLevelTicks = [];
    }
  }
  var levelsTicksInExtent = filter(map$1(levelsTicks, function(levelTicks2) {
    return filter(levelTicks2, function(tick) {
      return tick.value >= extent3[0] && tick.value <= extent3[1] && !tick.notAdd;
    });
  }), function(levelTicks2) {
    return levelTicks2.length > 0;
  });
  var ticks = [];
  var maxLevel = levelsTicksInExtent.length - 1;
  for (var i = 0; i < levelsTicksInExtent.length; ++i) {
    var levelTicks = levelsTicksInExtent[i];
    for (var k2 = 0; k2 < levelTicks.length; ++k2) {
      ticks.push({
        value: levelTicks[k2].value,
        level: maxLevel - i
      });
    }
  }
  ticks.sort(function(a, b2) {
    return a.value - b2.value;
  });
  var result = [];
  for (var i = 0; i < ticks.length; ++i) {
    if (i === 0 || ticks[i].value !== ticks[i - 1].value) {
      result.push(ticks[i]);
    }
  }
  return result;
}
Scale$1.registerClass(TimeScale);
var TimeScale$1 = TimeScale;
var scaleProto = Scale$1.prototype;
var intervalScaleProto = IntervalScale$1.prototype;
var roundingErrorFix = round$3;
var mathFloor$1 = Math.floor;
var mathCeil$1 = Math.ceil;
var mathPow$1 = Math.pow;
var mathLog$1 = Math.log;
var LogScale = function(_super) {
  __extends(LogScale2, _super);
  function LogScale2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "log";
    _this.base = 10;
    _this._originalScale = new IntervalScale$1();
    _this._interval = 0;
    return _this;
  }
  LogScale2.prototype.getTicks = function(expandToNicedExtent) {
    var originalScale = this._originalScale;
    var extent3 = this._extent;
    var originalExtent = originalScale.getExtent();
    var ticks = intervalScaleProto.getTicks.call(this, expandToNicedExtent);
    return map$1(ticks, function(tick) {
      var val = tick.value;
      var powVal = round$3(mathPow$1(this.base, val));
      powVal = val === extent3[0] && this._fixMin ? fixRoundingError(powVal, originalExtent[0]) : powVal;
      powVal = val === extent3[1] && this._fixMax ? fixRoundingError(powVal, originalExtent[1]) : powVal;
      return {
        value: powVal
      };
    }, this);
  };
  LogScale2.prototype.setExtent = function(start2, end2) {
    var base2 = this.base;
    start2 = mathLog$1(start2) / mathLog$1(base2);
    end2 = mathLog$1(end2) / mathLog$1(base2);
    intervalScaleProto.setExtent.call(this, start2, end2);
  };
  LogScale2.prototype.getExtent = function() {
    var base2 = this.base;
    var extent3 = scaleProto.getExtent.call(this);
    extent3[0] = mathPow$1(base2, extent3[0]);
    extent3[1] = mathPow$1(base2, extent3[1]);
    var originalScale = this._originalScale;
    var originalExtent = originalScale.getExtent();
    this._fixMin && (extent3[0] = fixRoundingError(extent3[0], originalExtent[0]));
    this._fixMax && (extent3[1] = fixRoundingError(extent3[1], originalExtent[1]));
    return extent3;
  };
  LogScale2.prototype.unionExtent = function(extent3) {
    this._originalScale.unionExtent(extent3);
    var base2 = this.base;
    extent3[0] = mathLog$1(extent3[0]) / mathLog$1(base2);
    extent3[1] = mathLog$1(extent3[1]) / mathLog$1(base2);
    scaleProto.unionExtent.call(this, extent3);
  };
  LogScale2.prototype.unionExtentFromData = function(data, dim) {
    this.unionExtent(data.getApproximateExtent(dim));
  };
  LogScale2.prototype.calcNiceTicks = function(approxTickNum) {
    approxTickNum = approxTickNum || 10;
    var extent3 = this._extent;
    var span = extent3[1] - extent3[0];
    if (span === Infinity || span <= 0) {
      return;
    }
    var interval = quantity(span);
    var err = approxTickNum / span * interval;
    if (err <= 0.5) {
      interval *= 10;
    }
    while (!isNaN(interval) && Math.abs(interval) < 1 && Math.abs(interval) > 0) {
      interval *= 10;
    }
    var niceExtent = [round$3(mathCeil$1(extent3[0] / interval) * interval), round$3(mathFloor$1(extent3[1] / interval) * interval)];
    this._interval = interval;
    this._niceExtent = niceExtent;
  };
  LogScale2.prototype.calcNiceExtent = function(opt) {
    intervalScaleProto.calcNiceExtent.call(this, opt);
    this._fixMin = opt.fixMin;
    this._fixMax = opt.fixMax;
  };
  LogScale2.prototype.parse = function(val) {
    return val;
  };
  LogScale2.prototype.contain = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return contain$1(val, this._extent);
  };
  LogScale2.prototype.normalize = function(val) {
    val = mathLog$1(val) / mathLog$1(this.base);
    return normalize$3(val, this._extent);
  };
  LogScale2.prototype.scale = function(val) {
    val = scale(val, this._extent);
    return mathPow$1(this.base, val);
  };
  LogScale2.type = "log";
  return LogScale2;
}(Scale$1);
var proto = LogScale.prototype;
proto.getMinorTicks = intervalScaleProto.getMinorTicks;
proto.getLabel = intervalScaleProto.getLabel;
function fixRoundingError(val, originalVal) {
  return roundingErrorFix(val, getPrecision(originalVal));
}
Scale$1.registerClass(LogScale);
var LogScale$1 = LogScale;
var ScaleRawExtentInfo = function() {
  function ScaleRawExtentInfo2(scale2, model, originalExtent) {
    this._prepareParams(scale2, model, originalExtent);
  }
  ScaleRawExtentInfo2.prototype._prepareParams = function(scale2, model, dataExtent) {
    if (dataExtent[1] < dataExtent[0]) {
      dataExtent = [NaN, NaN];
    }
    this._dataMin = dataExtent[0];
    this._dataMax = dataExtent[1];
    var isOrdinal = this._isOrdinal = scale2.type === "ordinal";
    this._needCrossZero = scale2.type === "interval" && model.getNeedCrossZero && model.getNeedCrossZero();
    var modelMinRaw = this._modelMinRaw = model.get("min", true);
    if (isFunction(modelMinRaw)) {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMinRaw !== "dataMin") {
      this._modelMinNum = parseAxisModelMinMax(scale2, modelMinRaw);
    }
    var modelMaxRaw = this._modelMaxRaw = model.get("max", true);
    if (isFunction(modelMaxRaw)) {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw({
        min: dataExtent[0],
        max: dataExtent[1]
      }));
    } else if (modelMaxRaw !== "dataMax") {
      this._modelMaxNum = parseAxisModelMinMax(scale2, modelMaxRaw);
    }
    if (isOrdinal) {
      this._axisDataLen = model.getCategories().length;
    } else {
      var boundaryGap = model.get("boundaryGap");
      var boundaryGapArr = isArray$1(boundaryGap) ? boundaryGap : [boundaryGap || 0, boundaryGap || 0];
      if (typeof boundaryGapArr[0] === "boolean" || typeof boundaryGapArr[1] === "boolean") {
        this._boundaryGapInner = [0, 0];
      } else {
        this._boundaryGapInner = [parsePercent$1(boundaryGapArr[0], 1), parsePercent$1(boundaryGapArr[1], 1)];
      }
    }
  };
  ScaleRawExtentInfo2.prototype.calculate = function() {
    var isOrdinal = this._isOrdinal;
    var dataMin = this._dataMin;
    var dataMax = this._dataMax;
    var axisDataLen = this._axisDataLen;
    var boundaryGapInner = this._boundaryGapInner;
    var span = !isOrdinal ? dataMax - dataMin || Math.abs(dataMin) : null;
    var min3 = this._modelMinRaw === "dataMin" ? dataMin : this._modelMinNum;
    var max3 = this._modelMaxRaw === "dataMax" ? dataMax : this._modelMaxNum;
    var minFixed = min3 != null;
    var maxFixed = max3 != null;
    if (min3 == null) {
      min3 = isOrdinal ? axisDataLen ? 0 : NaN : dataMin - boundaryGapInner[0] * span;
    }
    if (max3 == null) {
      max3 = isOrdinal ? axisDataLen ? axisDataLen - 1 : NaN : dataMax + boundaryGapInner[1] * span;
    }
    (min3 == null || !isFinite(min3)) && (min3 = NaN);
    (max3 == null || !isFinite(max3)) && (max3 = NaN);
    var isBlank = eqNaN(min3) || eqNaN(max3) || isOrdinal && !axisDataLen;
    if (this._needCrossZero) {
      if (min3 > 0 && max3 > 0 && !minFixed) {
        min3 = 0;
      }
      if (min3 < 0 && max3 < 0 && !maxFixed) {
        max3 = 0;
      }
    }
    var determinedMin = this._determinedMin;
    var determinedMax = this._determinedMax;
    if (determinedMin != null) {
      min3 = determinedMin;
      minFixed = true;
    }
    if (determinedMax != null) {
      max3 = determinedMax;
      maxFixed = true;
    }
    return {
      min: min3,
      max: max3,
      minFixed,
      maxFixed,
      isBlank
    };
  };
  ScaleRawExtentInfo2.prototype.modifyDataMinMax = function(minMaxName, val) {
    this[DATA_MIN_MAX_ATTR[minMaxName]] = val;
  };
  ScaleRawExtentInfo2.prototype.setDeterminedMinMax = function(minMaxName, val) {
    var attr = DETERMINED_MIN_MAX_ATTR[minMaxName];
    this[attr] = val;
  };
  ScaleRawExtentInfo2.prototype.freeze = function() {
    this.frozen = true;
  };
  return ScaleRawExtentInfo2;
}();
var DETERMINED_MIN_MAX_ATTR = {
  min: "_determinedMin",
  max: "_determinedMax"
};
var DATA_MIN_MAX_ATTR = {
  min: "_dataMin",
  max: "_dataMax"
};
function ensureScaleRawExtentInfo(scale2, model, originalExtent) {
  var rawExtentInfo = scale2.rawExtentInfo;
  if (rawExtentInfo) {
    return rawExtentInfo;
  }
  rawExtentInfo = new ScaleRawExtentInfo(scale2, model, originalExtent);
  scale2.rawExtentInfo = rawExtentInfo;
  return rawExtentInfo;
}
function parseAxisModelMinMax(scale2, minMax) {
  return minMax == null ? null : eqNaN(minMax) ? NaN : scale2.parse(minMax);
}
function getScaleExtent(scale2, model) {
  var scaleType = scale2.type;
  var rawExtentResult = ensureScaleRawExtentInfo(scale2, model, scale2.getExtent()).calculate();
  scale2.setBlank(rawExtentResult.isBlank);
  var min3 = rawExtentResult.min;
  var max3 = rawExtentResult.max;
  var ecModel = model.ecModel;
  if (ecModel && scaleType === "time") {
    var barSeriesModels = prepareLayoutBarSeries("bar", ecModel);
    var isBaseAxisAndHasBarSeries_1 = false;
    each$f(barSeriesModels, function(seriesModel) {
      isBaseAxisAndHasBarSeries_1 = isBaseAxisAndHasBarSeries_1 || seriesModel.getBaseAxis() === model.axis;
    });
    if (isBaseAxisAndHasBarSeries_1) {
      var barWidthAndOffset = makeColumnLayout(barSeriesModels);
      var adjustedScale = adjustScaleForOverflow(min3, max3, model, barWidthAndOffset);
      min3 = adjustedScale.min;
      max3 = adjustedScale.max;
    }
  }
  return {
    extent: [min3, max3],
    fixMin: rawExtentResult.minFixed,
    fixMax: rawExtentResult.maxFixed
  };
}
function adjustScaleForOverflow(min3, max3, model, barWidthAndOffset) {
  var axisExtent = model.axis.getExtent();
  var axisLength = axisExtent[1] - axisExtent[0];
  var barsOnCurrentAxis = retrieveColumnLayout(barWidthAndOffset, model.axis);
  if (barsOnCurrentAxis === void 0) {
    return {
      min: min3,
      max: max3
    };
  }
  var minOverflow = Infinity;
  each$f(barsOnCurrentAxis, function(item) {
    minOverflow = Math.min(item.offset, minOverflow);
  });
  var maxOverflow = -Infinity;
  each$f(barsOnCurrentAxis, function(item) {
    maxOverflow = Math.max(item.offset + item.width, maxOverflow);
  });
  minOverflow = Math.abs(minOverflow);
  maxOverflow = Math.abs(maxOverflow);
  var totalOverFlow = minOverflow + maxOverflow;
  var oldRange = max3 - min3;
  var oldRangePercentOfNew = 1 - (minOverflow + maxOverflow) / axisLength;
  var overflowBuffer = oldRange / oldRangePercentOfNew - oldRange;
  max3 += overflowBuffer * (maxOverflow / totalOverFlow);
  min3 -= overflowBuffer * (minOverflow / totalOverFlow);
  return {
    min: min3,
    max: max3
  };
}
function niceScaleExtent(scale2, inModel) {
  var model = inModel;
  var extentInfo = getScaleExtent(scale2, model);
  var extent3 = extentInfo.extent;
  var splitNumber = model.get("splitNumber");
  if (scale2 instanceof LogScale$1) {
    scale2.base = model.get("logBase");
  }
  var scaleType = scale2.type;
  var interval = model.get("interval");
  var isIntervalOrTime = scaleType === "interval" || scaleType === "time";
  scale2.setExtent(extent3[0], extent3[1]);
  scale2.calcNiceExtent({
    splitNumber,
    fixMin: extentInfo.fixMin,
    fixMax: extentInfo.fixMax,
    minInterval: isIntervalOrTime ? model.get("minInterval") : null,
    maxInterval: isIntervalOrTime ? model.get("maxInterval") : null
  });
  if (interval != null) {
    scale2.setInterval && scale2.setInterval(interval);
  }
}
function createScaleByModel$1(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getOrdinalMeta ? model.getOrdinalMeta() : model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new (Scale$1.getClass(axisType) || IntervalScale$1)();
    }
  }
}
function ifAxisCrossZero(axis) {
  var dataExtent = axis.scale.getExtent();
  var min3 = dataExtent[0];
  var max3 = dataExtent[1];
  return !(min3 > 0 && max3 > 0 || min3 < 0 && max3 < 0);
}
function makeLabelFormatter(axis) {
  var labelFormatter = axis.getLabelModel().get("formatter");
  var categoryTickStart = axis.type === "category" ? axis.scale.getExtent()[0] : null;
  if (axis.scale.type === "time") {
    return function(tpl) {
      return function(tick, idx) {
        return axis.scale.getFormattedLabel(tick, idx, tpl);
      };
    }(labelFormatter);
  } else if (isString(labelFormatter)) {
    return function(tpl) {
      return function(tick) {
        var label = axis.scale.getLabel(tick);
        var text = tpl.replace("{value}", label != null ? label : "");
        return text;
      };
    }(labelFormatter);
  } else if (isFunction(labelFormatter)) {
    return function(cb) {
      return function(tick, idx) {
        if (categoryTickStart != null) {
          idx = tick.value - categoryTickStart;
        }
        return cb(getAxisRawValue(axis, tick), idx, tick.level != null ? {
          level: tick.level
        } : null);
      };
    }(labelFormatter);
  } else {
    return function(tick) {
      return axis.scale.getLabel(tick);
    };
  }
}
function getAxisRawValue(axis, tick) {
  return axis.type === "category" ? axis.scale.getLabel(tick) : tick.value;
}
function estimateLabelUnionRect(axis) {
  var axisModel = axis.model;
  var scale2 = axis.scale;
  if (!axisModel.get(["axisLabel", "show"]) || scale2.isBlank()) {
    return;
  }
  var realNumberScaleTicks;
  var tickCount;
  var categoryScaleExtent = scale2.getExtent();
  if (scale2 instanceof OrdinalScale$1) {
    tickCount = scale2.count();
  } else {
    realNumberScaleTicks = scale2.getTicks();
    tickCount = realNumberScaleTicks.length;
  }
  var axisLabelModel = axis.getLabelModel();
  var labelFormatter = makeLabelFormatter(axis);
  var rect;
  var step = 1;
  if (tickCount > 40) {
    step = Math.ceil(tickCount / 40);
  }
  for (var i = 0; i < tickCount; i += step) {
    var tick = realNumberScaleTicks ? realNumberScaleTicks[i] : {
      value: categoryScaleExtent[0] + i
    };
    var label = labelFormatter(tick, i);
    var unrotatedSingleRect = axisLabelModel.getTextRect(label);
    var singleRect = rotateTextRect(unrotatedSingleRect, axisLabelModel.get("rotate") || 0);
    rect ? rect.union(singleRect) : rect = singleRect;
  }
  return rect;
}
function rotateTextRect(textRect, rotate2) {
  var rotateRadians = rotate2 * Math.PI / 180;
  var beforeWidth = textRect.width;
  var beforeHeight = textRect.height;
  var afterWidth = beforeWidth * Math.abs(Math.cos(rotateRadians)) + Math.abs(beforeHeight * Math.sin(rotateRadians));
  var afterHeight = beforeWidth * Math.abs(Math.sin(rotateRadians)) + Math.abs(beforeHeight * Math.cos(rotateRadians));
  var rotatedRect = new BoundingRect$1(textRect.x, textRect.y, afterWidth, afterHeight);
  return rotatedRect;
}
function getOptionCategoryInterval(model) {
  var interval = model.get("interval");
  return interval == null ? "auto" : interval;
}
function shouldShowAllLabels(axis) {
  return axis.type === "category" && getOptionCategoryInterval(axis.getLabelModel()) === 0;
}
function getDataDimensionsOnAxis(data, axisDim) {
  var dataDimMap = {};
  each$f(data.mapDimensionsAll(axisDim), function(dataDim) {
    dataDimMap[getStackedDimension(data, dataDim)] = true;
  });
  return keys(dataDimMap);
}
function unionAxisExtentFromData(dataExtent, data, axisDim) {
  if (data) {
    each$f(getDataDimensionsOnAxis(data, axisDim), function(dim) {
      var seriesExtent = data.getApproximateExtent(dim);
      seriesExtent[0] < dataExtent[0] && (dataExtent[0] = seriesExtent[0]);
      seriesExtent[1] > dataExtent[1] && (dataExtent[1] = seriesExtent[1]);
    });
  }
}
var AxisModelCommonMixin = function() {
  function AxisModelCommonMixin2() {
  }
  AxisModelCommonMixin2.prototype.getNeedCrossZero = function() {
    var option = this.option;
    return !option.scale;
  };
  AxisModelCommonMixin2.prototype.getCoordSysModel = function() {
    return;
  };
  return AxisModelCommonMixin2;
}();
var EPSILON = 1e-8;
function isAroundEqual(a, b2) {
  return Math.abs(a - b2) < EPSILON;
}
function contain(points2, x2, y2) {
  var w2 = 0;
  var p2 = points2[0];
  if (!p2) {
    return false;
  }
  for (var i = 1; i < points2.length; i++) {
    var p22 = points2[i];
    w2 += windingLine(p2[0], p2[1], p22[0], p22[1], x2, y2);
    p2 = p22;
  }
  var p0 = points2[0];
  if (!isAroundEqual(p2[0], p0[0]) || !isAroundEqual(p2[1], p0[1])) {
    w2 += windingLine(p2[0], p2[1], p0[0], p0[1], x2, y2);
  }
  return w2 !== 0;
}
var TMP_TRANSFORM = [];
function transformPoints(points2, transform2) {
  for (var p2 = 0; p2 < points2.length; p2++) {
    applyTransform$1(points2[p2], points2[p2], transform2);
  }
}
function updateBBoxFromPoints(points2, min3, max3, projection) {
  for (var i = 0; i < points2.length; i++) {
    var p2 = points2[i];
    if (projection) {
      p2 = projection.project(p2);
    }
    if (p2 && isFinite(p2[0]) && isFinite(p2[1])) {
      min$1(min3, min3, p2);
      max$1(max3, max3, p2);
    }
  }
}
function centroid$1(points2) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = points2.length;
  var x0 = points2[len2 - 1][0];
  var y0 = points2[len2 - 1][1];
  for (var i = 0; i < len2; i++) {
    var x1 = points2[i][0];
    var y1 = points2[i][1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
    x0 = x1;
    y0 = y1;
  }
  return signedArea ? [cx / signedArea / 3, cy / signedArea / 3, signedArea] : [points2[0][0] || 0, points2[0][1] || 0];
}
var Region = function() {
  function Region2(name) {
    this.name = name;
  }
  Region2.prototype.setCenter = function(center2) {
    this._center = center2;
  };
  Region2.prototype.getCenter = function() {
    var center2 = this._center;
    if (!center2) {
      center2 = this._center = this.calcCenter();
    }
    return center2;
  };
  return Region2;
}();
var GeoJSONPolygonGeometry = function() {
  function GeoJSONPolygonGeometry2(exterior, interiors) {
    this.type = "polygon";
    this.exterior = exterior;
    this.interiors = interiors;
  }
  return GeoJSONPolygonGeometry2;
}();
var GeoJSONLineStringGeometry = function() {
  function GeoJSONLineStringGeometry2(points2) {
    this.type = "linestring";
    this.points = points2;
  }
  return GeoJSONLineStringGeometry2;
}();
var GeoJSONRegion = function(_super) {
  __extends(GeoJSONRegion2, _super);
  function GeoJSONRegion2(name, geometries, cp) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoJSON";
    _this.geometries = geometries;
    _this._center = cp && [cp[0], cp[1]];
    return _this;
  }
  GeoJSONRegion2.prototype.calcCenter = function() {
    var geometries = this.geometries;
    var largestGeo;
    var largestGeoSize = 0;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      var exterior = geo.exterior;
      var size = exterior && exterior.length;
      if (size > largestGeoSize) {
        largestGeo = geo;
        largestGeoSize = size;
      }
    }
    if (largestGeo) {
      return centroid$1(largestGeo.exterior);
    }
    var rect = this.getBoundingRect();
    return [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.getBoundingRect = function(projection) {
    var rect = this._rect;
    if (rect && !projection) {
      return rect;
    }
    var min3 = [Infinity, Infinity];
    var max3 = [-Infinity, -Infinity];
    var geometries = this.geometries;
    each$f(geometries, function(geo) {
      if (geo.type === "polygon") {
        updateBBoxFromPoints(geo.exterior, min3, max3, projection);
      } else {
        each$f(geo.points, function(points2) {
          updateBBoxFromPoints(points2, min3, max3, projection);
        });
      }
    });
    if (!(isFinite(min3[0]) && isFinite(min3[1]) && isFinite(max3[0]) && isFinite(max3[1]))) {
      min3[0] = min3[1] = max3[0] = max3[1] = 0;
    }
    rect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    if (!projection) {
      this._rect = rect;
    }
    return rect;
  };
  GeoJSONRegion2.prototype.contain = function(coord) {
    var rect = this.getBoundingRect();
    var geometries = this.geometries;
    if (!rect.contain(coord[0], coord[1])) {
      return false;
    }
    loopGeo:
      for (var i = 0, len2 = geometries.length; i < len2; i++) {
        var geo = geometries[i];
        if (geo.type !== "polygon") {
          continue;
        }
        var exterior = geo.exterior;
        var interiors = geo.interiors;
        if (contain(exterior, coord[0], coord[1])) {
          for (var k2 = 0; k2 < (interiors ? interiors.length : 0); k2++) {
            if (contain(interiors[k2], coord[0], coord[1])) {
              continue loopGeo;
            }
          }
          return true;
        }
      }
    return false;
  };
  GeoJSONRegion2.prototype.transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var aspect = rect.width / rect.height;
    if (!width) {
      width = aspect * height;
    } else if (!height) {
      height = width / aspect;
    }
    var target = new BoundingRect$1(x2, y2, width, height);
    var transform2 = rect.calculateTransform(target);
    var geometries = this.geometries;
    for (var i = 0; i < geometries.length; i++) {
      var geo = geometries[i];
      if (geo.type === "polygon") {
        transformPoints(geo.exterior, transform2);
        each$f(geo.interiors, function(interior) {
          transformPoints(interior, transform2);
        });
      } else {
        each$f(geo.points, function(points2) {
          transformPoints(points2, transform2);
        });
      }
    }
    rect = this._rect;
    rect.copy(target);
    this._center = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  };
  GeoJSONRegion2.prototype.cloneShallow = function(name) {
    name == null && (name = this.name);
    var newRegion = new GeoJSONRegion2(name, this.geometries, this._center);
    newRegion._rect = this._rect;
    newRegion.transformTo = null;
    return newRegion;
  };
  return GeoJSONRegion2;
}(Region);
var GeoSVGRegion = function(_super) {
  __extends(GeoSVGRegion2, _super);
  function GeoSVGRegion2(name, elOnlyForCalculate) {
    var _this = _super.call(this, name) || this;
    _this.type = "geoSVG";
    _this._elOnlyForCalculate = elOnlyForCalculate;
    return _this;
  }
  GeoSVGRegion2.prototype.calcCenter = function() {
    var el = this._elOnlyForCalculate;
    var rect = el.getBoundingRect();
    var center2 = [rect.x + rect.width / 2, rect.y + rect.height / 2];
    var mat = identity(TMP_TRANSFORM);
    var target = el;
    while (target && !target.isGeoSVGGraphicRoot) {
      mul(mat, target.getLocalTransform(), mat);
      target = target.parent;
    }
    invert(mat, mat);
    applyTransform$1(center2, center2, mat);
    return center2;
  };
  return GeoSVGRegion2;
}(Region);
function decode(json) {
  if (!json.UTF8Encoding) {
    return json;
  }
  var jsonCompressed = json;
  var encodeScale = jsonCompressed.UTF8Scale;
  if (encodeScale == null) {
    encodeScale = 1024;
  }
  var features2 = jsonCompressed.features;
  each$f(features2, function(feature) {
    var geometry = feature.geometry;
    var encodeOffsets = geometry.encodeOffsets;
    var coordinates = geometry.coordinates;
    if (!encodeOffsets) {
      return;
    }
    switch (geometry.type) {
      case "LineString":
        geometry.coordinates = decodeRing(coordinates, encodeOffsets, encodeScale);
        break;
      case "Polygon":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiLineString":
        decodeRings(coordinates, encodeOffsets, encodeScale);
        break;
      case "MultiPolygon":
        each$f(coordinates, function(rings, idx) {
          return decodeRings(rings, encodeOffsets[idx], encodeScale);
        });
    }
  });
  jsonCompressed.UTF8Encoding = false;
  return jsonCompressed;
}
function decodeRings(rings, encodeOffsets, encodeScale) {
  for (var c2 = 0; c2 < rings.length; c2++) {
    rings[c2] = decodeRing(rings[c2], encodeOffsets[c2], encodeScale);
  }
}
function decodeRing(coordinate, encodeOffsets, encodeScale) {
  var result = [];
  var prevX = encodeOffsets[0];
  var prevY = encodeOffsets[1];
  for (var i = 0; i < coordinate.length; i += 2) {
    var x2 = coordinate.charCodeAt(i) - 64;
    var y2 = coordinate.charCodeAt(i + 1) - 64;
    x2 = x2 >> 1 ^ -(x2 & 1);
    y2 = y2 >> 1 ^ -(y2 & 1);
    x2 += prevX;
    y2 += prevY;
    prevX = x2;
    prevY = y2;
    result.push([x2 / encodeScale, y2 / encodeScale]);
  }
  return result;
}
function parseGeoJSON(geoJson, nameProperty) {
  geoJson = decode(geoJson);
  return map$1(filter(geoJson.features, function(featureObj) {
    return featureObj.geometry && featureObj.properties && featureObj.geometry.coordinates.length > 0;
  }), function(featureObj) {
    var properties = featureObj.properties;
    var geo = featureObj.geometry;
    var geometries = [];
    switch (geo.type) {
      case "Polygon":
        var coordinates = geo.coordinates;
        geometries.push(new GeoJSONPolygonGeometry(coordinates[0], coordinates.slice(1)));
        break;
      case "MultiPolygon":
        each$f(geo.coordinates, function(item) {
          if (item[0]) {
            geometries.push(new GeoJSONPolygonGeometry(item[0], item.slice(1)));
          }
        });
        break;
      case "LineString":
        geometries.push(new GeoJSONLineStringGeometry([geo.coordinates]));
        break;
      case "MultiLineString":
        geometries.push(new GeoJSONLineStringGeometry(geo.coordinates));
    }
    var region = new GeoJSONRegion(properties[nameProperty || "name"], geometries, properties.cp);
    region.properties = properties;
    return region;
  });
}
var inner$g = makeInner();
function createAxisLabels(axis) {
  return axis.type === "category" ? makeCategoryLabels(axis) : makeRealNumberLabels(axis);
}
function createAxisTicks(axis, tickModel) {
  return axis.type === "category" ? makeCategoryTicks(axis, tickModel) : {
    ticks: map$1(axis.scale.getTicks(), function(tick) {
      return tick.value;
    })
  };
}
function makeCategoryLabels(axis) {
  var labelModel = axis.getLabelModel();
  var result = makeCategoryLabelsActually(axis, labelModel);
  return !labelModel.get("show") || axis.scale.isBlank() ? {
    labels: [],
    labelCategoryInterval: result.labelCategoryInterval
  } : result;
}
function makeCategoryLabelsActually(axis, labelModel) {
  var labelsCache = getListCache(axis, "labels");
  var optionLabelInterval = getOptionCategoryInterval(labelModel);
  var result = listCacheGet(labelsCache, optionLabelInterval);
  if (result) {
    return result;
  }
  var labels;
  var numericLabelInterval;
  if (isFunction(optionLabelInterval)) {
    labels = makeLabelsByCustomizedCategoryInterval(axis, optionLabelInterval);
  } else {
    numericLabelInterval = optionLabelInterval === "auto" ? makeAutoCategoryInterval(axis) : optionLabelInterval;
    labels = makeLabelsByNumericCategoryInterval(axis, numericLabelInterval);
  }
  return listCacheSet(labelsCache, optionLabelInterval, {
    labels,
    labelCategoryInterval: numericLabelInterval
  });
}
function makeCategoryTicks(axis, tickModel) {
  var ticksCache = getListCache(axis, "ticks");
  var optionTickInterval = getOptionCategoryInterval(tickModel);
  var result = listCacheGet(ticksCache, optionTickInterval);
  if (result) {
    return result;
  }
  var ticks;
  var tickCategoryInterval;
  if (!tickModel.get("show") || axis.scale.isBlank()) {
    ticks = [];
  }
  if (isFunction(optionTickInterval)) {
    ticks = makeLabelsByCustomizedCategoryInterval(axis, optionTickInterval, true);
  } else if (optionTickInterval === "auto") {
    var labelsResult = makeCategoryLabelsActually(axis, axis.getLabelModel());
    tickCategoryInterval = labelsResult.labelCategoryInterval;
    ticks = map$1(labelsResult.labels, function(labelItem) {
      return labelItem.tickValue;
    });
  } else {
    tickCategoryInterval = optionTickInterval;
    ticks = makeLabelsByNumericCategoryInterval(axis, tickCategoryInterval, true);
  }
  return listCacheSet(ticksCache, optionTickInterval, {
    ticks,
    tickCategoryInterval
  });
}
function makeRealNumberLabels(axis) {
  var ticks = axis.scale.getTicks();
  var labelFormatter = makeLabelFormatter(axis);
  return {
    labels: map$1(ticks, function(tick, idx) {
      return {
        level: tick.level,
        formattedLabel: labelFormatter(tick, idx),
        rawLabel: axis.scale.getLabel(tick),
        tickValue: tick.value
      };
    })
  };
}
function getListCache(axis, prop) {
  return inner$g(axis)[prop] || (inner$g(axis)[prop] = []);
}
function listCacheGet(cache, key) {
  for (var i = 0; i < cache.length; i++) {
    if (cache[i].key === key) {
      return cache[i].value;
    }
  }
}
function listCacheSet(cache, key, value) {
  cache.push({
    key,
    value
  });
  return value;
}
function makeAutoCategoryInterval(axis) {
  var result = inner$g(axis).autoInterval;
  return result != null ? result : inner$g(axis).autoInterval = axis.calculateCategoryInterval();
}
function calculateCategoryInterval(axis) {
  var params = fetchAutoCategoryIntervalCalculationParams(axis);
  var labelFormatter = makeLabelFormatter(axis);
  var rotation = (params.axisRotate - params.labelRotate) / 180 * Math.PI;
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var tickCount = ordinalScale.count();
  if (ordinalExtent[1] - ordinalExtent[0] < 1) {
    return 0;
  }
  var step = 1;
  if (tickCount > 40) {
    step = Math.max(1, Math.floor(tickCount / 40));
  }
  var tickValue = ordinalExtent[0];
  var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
  var unitW = Math.abs(unitSpan * Math.cos(rotation));
  var unitH = Math.abs(unitSpan * Math.sin(rotation));
  var maxW = 0;
  var maxH = 0;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    var width = 0;
    var height = 0;
    var rect = getBoundingRect(labelFormatter({
      value: tickValue
    }), params.font, "center", "top");
    width = rect.width * 1.3;
    height = rect.height * 1.3;
    maxW = Math.max(maxW, width, 7);
    maxH = Math.max(maxH, height, 7);
  }
  var dw = maxW / unitW;
  var dh = maxH / unitH;
  isNaN(dw) && (dw = Infinity);
  isNaN(dh) && (dh = Infinity);
  var interval = Math.max(0, Math.floor(Math.min(dw, dh)));
  var cache = inner$g(axis.model);
  var axisExtent = axis.getExtent();
  var lastAutoInterval = cache.lastAutoInterval;
  var lastTickCount = cache.lastTickCount;
  if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval && cache.axisExtent0 === axisExtent[0] && cache.axisExtent1 === axisExtent[1]) {
    interval = lastAutoInterval;
  } else {
    cache.lastTickCount = tickCount;
    cache.lastAutoInterval = interval;
    cache.axisExtent0 = axisExtent[0];
    cache.axisExtent1 = axisExtent[1];
  }
  return interval;
}
function fetchAutoCategoryIntervalCalculationParams(axis) {
  var labelModel = axis.getLabelModel();
  return {
    axisRotate: axis.getRotate ? axis.getRotate() : axis.isHorizontal && !axis.isHorizontal() ? 90 : 0,
    labelRotate: labelModel.get("rotate") || 0,
    font: labelModel.getFont()
  };
}
function makeLabelsByNumericCategoryInterval(axis, categoryInterval, onlyTick) {
  var labelFormatter = makeLabelFormatter(axis);
  var ordinalScale = axis.scale;
  var ordinalExtent = ordinalScale.getExtent();
  var labelModel = axis.getLabelModel();
  var result = [];
  var step = Math.max((categoryInterval || 0) + 1, 1);
  var startTick = ordinalExtent[0];
  var tickCount = ordinalScale.count();
  if (startTick !== 0 && step > 1 && tickCount / step > 2) {
    startTick = Math.round(Math.ceil(startTick / step) * step);
  }
  var showAllLabel = shouldShowAllLabels(axis);
  var includeMinLabel = labelModel.get("showMinLabel") || showAllLabel;
  var includeMaxLabel = labelModel.get("showMaxLabel") || showAllLabel;
  if (includeMinLabel && startTick !== ordinalExtent[0]) {
    addItem(ordinalExtent[0]);
  }
  var tickValue = startTick;
  for (; tickValue <= ordinalExtent[1]; tickValue += step) {
    addItem(tickValue);
  }
  if (includeMaxLabel && tickValue - step !== ordinalExtent[1]) {
    addItem(ordinalExtent[1]);
  }
  function addItem(tickValue2) {
    var tickObj = {
      value: tickValue2
    };
    result.push(onlyTick ? tickValue2 : {
      formattedLabel: labelFormatter(tickObj),
      rawLabel: ordinalScale.getLabel(tickObj),
      tickValue: tickValue2
    });
  }
  return result;
}
function makeLabelsByCustomizedCategoryInterval(axis, categoryInterval, onlyTick) {
  var ordinalScale = axis.scale;
  var labelFormatter = makeLabelFormatter(axis);
  var result = [];
  each$f(ordinalScale.getTicks(), function(tick) {
    var rawLabel = ordinalScale.getLabel(tick);
    var tickValue = tick.value;
    if (categoryInterval(tick.value, rawLabel)) {
      result.push(onlyTick ? tickValue : {
        formattedLabel: labelFormatter(tick),
        rawLabel,
        tickValue
      });
    }
  });
  return result;
}
var NORMALIZED_EXTENT = [0, 1];
var Axis = function() {
  function Axis2(dim, scale2, extent3) {
    this.onBand = false;
    this.inverse = false;
    this.dim = dim;
    this.scale = scale2;
    this._extent = extent3 || [0, 0];
  }
  Axis2.prototype.contain = function(coord) {
    var extent3 = this._extent;
    var min3 = Math.min(extent3[0], extent3[1]);
    var max3 = Math.max(extent3[0], extent3[1]);
    return coord >= min3 && coord <= max3;
  };
  Axis2.prototype.containData = function(data) {
    return this.scale.contain(data);
  };
  Axis2.prototype.getExtent = function() {
    return this._extent.slice();
  };
  Axis2.prototype.getPixelPrecision = function(dataExtent) {
    return getPixelPrecision(dataExtent || this.scale.getExtent(), this._extent);
  };
  Axis2.prototype.setExtent = function(start2, end2) {
    var extent3 = this._extent;
    extent3[0] = start2;
    extent3[1] = end2;
  };
  Axis2.prototype.dataToCoord = function(data, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    data = scale2.normalize(data);
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    return linearMap$2(data, NORMALIZED_EXTENT, extent3, clamp2);
  };
  Axis2.prototype.coordToData = function(coord, clamp2) {
    var extent3 = this._extent;
    var scale2 = this.scale;
    if (this.onBand && scale2.type === "ordinal") {
      extent3 = extent3.slice();
      fixExtentWithBands(extent3, scale2.count());
    }
    var t2 = linearMap$2(coord, extent3, NORMALIZED_EXTENT, clamp2);
    return this.scale.scale(t2);
  };
  Axis2.prototype.pointToData = function(point, clamp2) {
    return;
  };
  Axis2.prototype.getTicksCoords = function(opt) {
    opt = opt || {};
    var tickModel = opt.tickModel || this.getTickModel();
    var result = createAxisTicks(this, tickModel);
    var ticks = result.ticks;
    var ticksCoords = map$1(ticks, function(tickVal) {
      return {
        coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(tickVal) : tickVal),
        tickValue: tickVal
      };
    }, this);
    var alignWithLabel = tickModel.get("alignWithLabel");
    fixOnBandTicksCoords(this, ticksCoords, alignWithLabel, opt.clamp);
    return ticksCoords;
  };
  Axis2.prototype.getMinorTicksCoords = function() {
    if (this.scale.type === "ordinal") {
      return [];
    }
    var minorTickModel = this.model.getModel("minorTick");
    var splitNumber = minorTickModel.get("splitNumber");
    if (!(splitNumber > 0 && splitNumber < 100)) {
      splitNumber = 5;
    }
    var minorTicks = this.scale.getMinorTicks(splitNumber);
    var minorTicksCoords = map$1(minorTicks, function(minorTicksGroup) {
      return map$1(minorTicksGroup, function(minorTick) {
        return {
          coord: this.dataToCoord(minorTick),
          tickValue: minorTick
        };
      }, this);
    }, this);
    return minorTicksCoords;
  };
  Axis2.prototype.getViewLabels = function() {
    return createAxisLabels(this).labels;
  };
  Axis2.prototype.getLabelModel = function() {
    return this.model.getModel("axisLabel");
  };
  Axis2.prototype.getTickModel = function() {
    return this.model.getModel("axisTick");
  };
  Axis2.prototype.getBandWidth = function() {
    var axisExtent = this._extent;
    var dataExtent = this.scale.getExtent();
    var len2 = dataExtent[1] - dataExtent[0] + (this.onBand ? 1 : 0);
    len2 === 0 && (len2 = 1);
    var size = Math.abs(axisExtent[1] - axisExtent[0]);
    return Math.abs(size) / len2;
  };
  Axis2.prototype.calculateCategoryInterval = function() {
    return calculateCategoryInterval(this);
  };
  return Axis2;
}();
function fixExtentWithBands(extent3, nTick) {
  var size = extent3[1] - extent3[0];
  var len2 = nTick;
  var margin = size / len2 / 2;
  extent3[0] += margin;
  extent3[1] -= margin;
}
function fixOnBandTicksCoords(axis, ticksCoords, alignWithLabel, clamp2) {
  var ticksLen = ticksCoords.length;
  if (!axis.onBand || alignWithLabel || !ticksLen) {
    return;
  }
  var axisExtent = axis.getExtent();
  var last;
  var diffSize;
  if (ticksLen === 1) {
    ticksCoords[0].coord = axisExtent[0];
    last = ticksCoords[1] = {
      coord: axisExtent[0]
    };
  } else {
    var crossLen = ticksCoords[ticksLen - 1].tickValue - ticksCoords[0].tickValue;
    var shift_1 = (ticksCoords[ticksLen - 1].coord - ticksCoords[0].coord) / crossLen;
    each$f(ticksCoords, function(ticksItem) {
      ticksItem.coord -= shift_1 / 2;
    });
    var dataExtent = axis.scale.getExtent();
    diffSize = 1 + dataExtent[1] - ticksCoords[ticksLen - 1].tickValue;
    last = {
      coord: ticksCoords[ticksLen - 1].coord + shift_1 * diffSize
    };
    ticksCoords.push(last);
  }
  var inverse = axisExtent[0] > axisExtent[1];
  if (littleThan2(ticksCoords[0].coord, axisExtent[0])) {
    clamp2 ? ticksCoords[0].coord = axisExtent[0] : ticksCoords.shift();
  }
  if (clamp2 && littleThan2(axisExtent[0], ticksCoords[0].coord)) {
    ticksCoords.unshift({
      coord: axisExtent[0]
    });
  }
  if (littleThan2(axisExtent[1], last.coord)) {
    clamp2 ? last.coord = axisExtent[1] : ticksCoords.pop();
  }
  if (clamp2 && littleThan2(last.coord, axisExtent[1])) {
    ticksCoords.push({
      coord: axisExtent[1]
    });
  }
  function littleThan2(a, b2) {
    a = round$3(a);
    b2 = round$3(b2);
    return inverse ? a > b2 : a < b2;
  }
}
var Axis$1 = Axis;
var PI2$3 = Math.PI * 2;
var CMD$1 = PathProxy$1.CMD;
var DEFAULT_SEARCH_SPACE = ["top", "right", "bottom", "left"];
function getCandidateAnchor(pos, distance2, rect, outPt, outDir) {
  var width = rect.width;
  var height = rect.height;
  switch (pos) {
    case "top":
      outPt.set(rect.x + width / 2, rect.y - distance2);
      outDir.set(0, -1);
      break;
    case "bottom":
      outPt.set(rect.x + width / 2, rect.y + height + distance2);
      outDir.set(0, 1);
      break;
    case "left":
      outPt.set(rect.x - distance2, rect.y + height / 2);
      outDir.set(-1, 0);
      break;
    case "right":
      outPt.set(rect.x + width + distance2, rect.y + height / 2);
      outDir.set(1, 0);
      break;
  }
}
function projectPointToArc(cx, cy, r2, startAngle, endAngle, anticlockwise, x2, y2, out2) {
  x2 -= cx;
  y2 -= cy;
  var d2 = Math.sqrt(x2 * x2 + y2 * y2);
  x2 /= d2;
  y2 /= d2;
  var ox = x2 * r2 + cx;
  var oy = y2 * r2 + cy;
  if (Math.abs(startAngle - endAngle) % PI2$3 < 1e-4) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  if (anticlockwise) {
    var tmp = startAngle;
    startAngle = normalizeRadian(endAngle);
    endAngle = normalizeRadian(tmp);
  } else {
    startAngle = normalizeRadian(startAngle);
    endAngle = normalizeRadian(endAngle);
  }
  if (startAngle > endAngle) {
    endAngle += PI2$3;
  }
  var angle = Math.atan2(y2, x2);
  if (angle < 0) {
    angle += PI2$3;
  }
  if (angle >= startAngle && angle <= endAngle || angle + PI2$3 >= startAngle && angle + PI2$3 <= endAngle) {
    out2[0] = ox;
    out2[1] = oy;
    return d2 - r2;
  }
  var x1 = r2 * Math.cos(startAngle) + cx;
  var y1 = r2 * Math.sin(startAngle) + cy;
  var x22 = r2 * Math.cos(endAngle) + cx;
  var y22 = r2 * Math.sin(endAngle) + cy;
  var d1 = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
  var d22 = (x22 - x2) * (x22 - x2) + (y22 - y2) * (y22 - y2);
  if (d1 < d22) {
    out2[0] = x1;
    out2[1] = y1;
    return Math.sqrt(d1);
  } else {
    out2[0] = x22;
    out2[1] = y22;
    return Math.sqrt(d22);
  }
}
function projectPointToLine(x1, y1, x2, y2, x3, y3, out2, limitToEnds) {
  var dx = x3 - x1;
  var dy = y3 - y1;
  var dx1 = x2 - x1;
  var dy1 = y2 - y1;
  var lineLen = Math.sqrt(dx1 * dx1 + dy1 * dy1);
  dx1 /= lineLen;
  dy1 /= lineLen;
  var projectedLen = dx * dx1 + dy * dy1;
  var t2 = projectedLen / lineLen;
  if (limitToEnds) {
    t2 = Math.min(Math.max(t2, 0), 1);
  }
  t2 *= lineLen;
  var ox = out2[0] = x1 + t2 * dx1;
  var oy = out2[1] = y1 + t2 * dy1;
  return Math.sqrt((ox - x3) * (ox - x3) + (oy - y3) * (oy - y3));
}
function projectPointToRect(x1, y1, width, height, x2, y2, out2) {
  if (width < 0) {
    x1 = x1 + width;
    width = -width;
  }
  if (height < 0) {
    y1 = y1 + height;
    height = -height;
  }
  var x22 = x1 + width;
  var y22 = y1 + height;
  var ox = out2[0] = Math.min(Math.max(x2, x1), x22);
  var oy = out2[1] = Math.min(Math.max(y2, y1), y22);
  return Math.sqrt((ox - x2) * (ox - x2) + (oy - y2) * (oy - y2));
}
var tmpPt = [];
function nearestPointOnRect(pt, rect, out2) {
  var dist2 = projectPointToRect(rect.x, rect.y, rect.width, rect.height, pt.x, pt.y, tmpPt);
  out2.set(tmpPt[0], tmpPt[1]);
  return dist2;
}
function nearestPointOnPath(pt, path, out2) {
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  var x1;
  var y1;
  var minDist = Infinity;
  var data = path.data;
  var x2 = pt.x;
  var y2 = pt.y;
  for (var i = 0; i < data.length; ) {
    var cmd = data[i++];
    if (i === 1) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
    }
    var d2 = minDist;
    switch (cmd) {
      case CMD$1.M:
        x0 = data[i++];
        y0 = data[i++];
        xi = x0;
        yi = y0;
        break;
      case CMD$1.L:
        d2 = projectPointToLine(xi, yi, data[i], data[i + 1], x2, y2, tmpPt, true);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.C:
        d2 = cubicProjectPoint(xi, yi, data[i++], data[i++], data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.Q:
        d2 = quadraticProjectPoint(xi, yi, data[i++], data[i++], data[i], data[i + 1], x2, y2, tmpPt);
        xi = data[i++];
        yi = data[i++];
        break;
      case CMD$1.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var theta = data[i++];
        var dTheta = data[i++];
        i += 1;
        var anticlockwise = !!(1 - data[i++]);
        x1 = Math.cos(theta) * rx + cx;
        y1 = Math.sin(theta) * ry + cy;
        if (i <= 1) {
          x0 = x1;
          y0 = y1;
        }
        var _x = (x2 - cx) * ry / rx + cx;
        d2 = projectPointToArc(cx, cy, ry, theta, theta + dTheta, anticlockwise, _x, y2, tmpPt);
        xi = Math.cos(theta + dTheta) * rx + cx;
        yi = Math.sin(theta + dTheta) * ry + cy;
        break;
      case CMD$1.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        var width = data[i++];
        var height = data[i++];
        d2 = projectPointToRect(x0, y0, width, height, x2, y2, tmpPt);
        break;
      case CMD$1.Z:
        d2 = projectPointToLine(xi, yi, x0, y0, x2, y2, tmpPt, true);
        xi = x0;
        yi = y0;
        break;
    }
    if (d2 < minDist) {
      minDist = d2;
      out2.set(tmpPt[0], tmpPt[1]);
    }
  }
  return minDist;
}
var pt0 = new Point$1();
var pt1 = new Point$1();
var pt2 = new Point$1();
var dir = new Point$1();
var dir2 = new Point$1();
function updateLabelLinePoints(target, labelLineModel) {
  if (!target) {
    return;
  }
  var labelLine = target.getTextGuideLine();
  var label = target.getTextContent();
  if (!(label && labelLine)) {
    return;
  }
  var labelGuideConfig = target.textGuideLineConfig || {};
  var points2 = [[0, 0], [0, 0], [0, 0]];
  var searchSpace = labelGuideConfig.candidates || DEFAULT_SEARCH_SPACE;
  var labelRect = label.getBoundingRect().clone();
  labelRect.applyTransform(label.getComputedTransform());
  var minDist = Infinity;
  var anchorPoint = labelGuideConfig.anchor;
  var targetTransform = target.getComputedTransform();
  var targetInversedTransform = targetTransform && invert([], targetTransform);
  var len2 = labelLineModel.get("length2") || 0;
  if (anchorPoint) {
    pt2.copy(anchorPoint);
  }
  for (var i = 0; i < searchSpace.length; i++) {
    var candidate = searchSpace[i];
    getCandidateAnchor(candidate, 0, labelRect, pt0, dir);
    Point$1.scaleAndAdd(pt1, pt0, dir, len2);
    pt1.transform(targetInversedTransform);
    var boundingRect = target.getBoundingRect();
    var dist2 = anchorPoint ? anchorPoint.distance(pt1) : target instanceof Path$1 ? nearestPointOnPath(pt1, target.path, pt2) : nearestPointOnRect(pt1, boundingRect, pt2);
    if (dist2 < minDist) {
      minDist = dist2;
      pt1.transform(targetTransform);
      pt2.transform(targetTransform);
      pt2.toArray(points2[0]);
      pt1.toArray(points2[1]);
      pt0.toArray(points2[2]);
    }
  }
  limitTurnAngle(points2, labelLineModel.get("minTurnAngle"));
  labelLine.setShape({
    points: points2
  });
}
var tmpArr = [];
var tmpProjPoint = new Point$1();
function limitTurnAngle(linePoints, minTurnAngle) {
  if (!(minTurnAngle <= 180 && minTurnAngle > 0)) {
    return;
  }
  minTurnAngle = minTurnAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt0, pt1);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(dir2);
  var minTurnAngleCos = Math.cos(minTurnAngle);
  if (minTurnAngleCos < angleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI - minTurnAngle));
    var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
    if (isNaN(t2)) {
      return;
    }
    if (t2 < 0) {
      Point$1.copy(tmpProjPoint, pt1);
    } else if (t2 > 1) {
      Point$1.copy(tmpProjPoint, pt2);
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function limitSurfaceAngle(linePoints, surfaceNormal, maxSurfaceAngle) {
  if (!(maxSurfaceAngle <= 180 && maxSurfaceAngle > 0)) {
    return;
  }
  maxSurfaceAngle = maxSurfaceAngle / 180 * Math.PI;
  pt0.fromArray(linePoints[0]);
  pt1.fromArray(linePoints[1]);
  pt2.fromArray(linePoints[2]);
  Point$1.sub(dir, pt1, pt0);
  Point$1.sub(dir2, pt2, pt1);
  var len1 = dir.len();
  var len2 = dir2.len();
  if (len1 < 1e-3 || len2 < 1e-3) {
    return;
  }
  dir.scale(1 / len1);
  dir2.scale(1 / len2);
  var angleCos = dir.dot(surfaceNormal);
  var maxSurfaceAngleCos = Math.cos(maxSurfaceAngle);
  if (angleCos < maxSurfaceAngleCos) {
    var d2 = projectPointToLine(pt1.x, pt1.y, pt2.x, pt2.y, pt0.x, pt0.y, tmpArr, false);
    tmpProjPoint.fromArray(tmpArr);
    var HALF_PI = Math.PI / 2;
    var angle2 = Math.acos(dir2.dot(surfaceNormal));
    var newAngle = HALF_PI + angle2 - maxSurfaceAngle;
    if (newAngle >= HALF_PI) {
      Point$1.copy(tmpProjPoint, pt2);
    } else {
      tmpProjPoint.scaleAndAdd(dir2, d2 / Math.tan(Math.PI / 2 - newAngle));
      var t2 = pt2.x !== pt1.x ? (tmpProjPoint.x - pt1.x) / (pt2.x - pt1.x) : (tmpProjPoint.y - pt1.y) / (pt2.y - pt1.y);
      if (isNaN(t2)) {
        return;
      }
      if (t2 < 0) {
        Point$1.copy(tmpProjPoint, pt1);
      } else if (t2 > 1) {
        Point$1.copy(tmpProjPoint, pt2);
      }
    }
    tmpProjPoint.toArray(linePoints[1]);
  }
}
function setLabelLineState(labelLine, ignore, stateName, stateModel) {
  var isNormal = stateName === "normal";
  var stateObj = isNormal ? labelLine : labelLine.ensureState(stateName);
  stateObj.ignore = ignore;
  var smooth = stateModel.get("smooth");
  if (smooth && smooth === true) {
    smooth = 0.3;
  }
  stateObj.shape = stateObj.shape || {};
  if (smooth > 0) {
    stateObj.shape.smooth = smooth;
  }
  var styleObj = stateModel.getModel("lineStyle").getLineStyle();
  isNormal ? labelLine.useStyle(styleObj) : stateObj.style = styleObj;
}
function buildLabelLinePath(path, shape) {
  var smooth = shape.smooth;
  var points2 = shape.points;
  if (!points2) {
    return;
  }
  path.moveTo(points2[0][0], points2[0][1]);
  if (smooth > 0 && points2.length >= 3) {
    var len1 = dist$1(points2[0], points2[1]);
    var len2 = dist$1(points2[1], points2[2]);
    if (!len1 || !len2) {
      path.lineTo(points2[1][0], points2[1][1]);
      path.lineTo(points2[2][0], points2[2][1]);
      return;
    }
    var moveLen = Math.min(len1, len2) * smooth;
    var midPoint0 = lerp$1([], points2[1], points2[0], moveLen / len1);
    var midPoint2 = lerp$1([], points2[1], points2[2], moveLen / len2);
    var midPoint1 = lerp$1([], midPoint0, midPoint2, 0.5);
    path.bezierCurveTo(midPoint0[0], midPoint0[1], midPoint0[0], midPoint0[1], midPoint1[0], midPoint1[1]);
    path.bezierCurveTo(midPoint2[0], midPoint2[1], midPoint2[0], midPoint2[1], points2[2][0], points2[2][1]);
  } else {
    for (var i = 1; i < points2.length; i++) {
      path.lineTo(points2[i][0], points2[i][1]);
    }
  }
}
function setLabelLineStyle(targetEl, statesModels, defaultStyle) {
  var labelLine = targetEl.getTextGuideLine();
  var label = targetEl.getTextContent();
  if (!label) {
    if (labelLine) {
      targetEl.removeTextGuideLine();
    }
    return;
  }
  var normalModel = statesModels.normal;
  var showNormal = normalModel.get("show");
  var labelIgnoreNormal = label.ignore;
  for (var i = 0; i < DISPLAY_STATES.length; i++) {
    var stateName = DISPLAY_STATES[i];
    var stateModel = statesModels[stateName];
    var isNormal = stateName === "normal";
    if (stateModel) {
      var stateShow = stateModel.get("show");
      var isLabelIgnored = isNormal ? labelIgnoreNormal : retrieve2(label.states[stateName] && label.states[stateName].ignore, labelIgnoreNormal);
      if (isLabelIgnored || !retrieve2(stateShow, showNormal)) {
        var stateObj = isNormal ? labelLine : labelLine && labelLine.states.normal;
        if (stateObj) {
          stateObj.ignore = true;
        }
        continue;
      }
      if (!labelLine) {
        labelLine = new Polyline$3();
        targetEl.setTextGuideLine(labelLine);
        if (!isNormal && (labelIgnoreNormal || !showNormal)) {
          setLabelLineState(labelLine, true, "normal", statesModels.normal);
        }
        if (targetEl.stateProxy) {
          labelLine.stateProxy = targetEl.stateProxy;
        }
      }
      setLabelLineState(labelLine, false, stateName, stateModel);
    }
  }
  if (labelLine) {
    defaults(labelLine.style, defaultStyle);
    labelLine.style.fill = null;
    var showAbove = normalModel.get("showAbove");
    var labelLineConfig = targetEl.textGuideLineConfig = targetEl.textGuideLineConfig || {};
    labelLineConfig.showAbove = showAbove || false;
    labelLine.buildPath = buildLabelLinePath;
  }
}
function getLabelLineStatesModels(itemModel, labelLineName) {
  labelLineName = labelLineName || "labelLine";
  var statesModels = {
    normal: itemModel.getModel(labelLineName)
  };
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    var stateName = SPECIAL_STATES[i];
    statesModels[stateName] = itemModel.getModel([stateName, labelLineName]);
  }
  return statesModels;
}
function prepareLayoutList(input) {
  var list = [];
  for (var i = 0; i < input.length; i++) {
    var rawItem = input[i];
    if (rawItem.defaultAttr.ignore) {
      continue;
    }
    var label = rawItem.label;
    var transform2 = label.getComputedTransform();
    var localRect = label.getBoundingRect();
    var isAxisAligned = !transform2 || transform2[1] < 1e-5 && transform2[2] < 1e-5;
    var minMargin = label.style.margin || 0;
    var globalRect = localRect.clone();
    globalRect.applyTransform(transform2);
    globalRect.x -= minMargin / 2;
    globalRect.y -= minMargin / 2;
    globalRect.width += minMargin;
    globalRect.height += minMargin;
    var obb = isAxisAligned ? new OrientedBoundingRect$1(localRect, transform2) : null;
    list.push({
      label,
      labelLine: rawItem.labelLine,
      rect: globalRect,
      localRect,
      obb,
      priority: rawItem.priority,
      defaultAttr: rawItem.defaultAttr,
      layoutOption: rawItem.computedLayoutOption,
      axisAligned: isAxisAligned,
      transform: transform2
    });
  }
  return list;
}
function shiftLayout(list, xyDim, sizeDim, minBound, maxBound, balanceShift) {
  var len2 = list.length;
  if (len2 < 2) {
    return;
  }
  list.sort(function(a, b2) {
    return a.rect[xyDim] - b2.rect[xyDim];
  });
  var lastPos = 0;
  var delta;
  var adjusted = false;
  var totalShifts = 0;
  for (var i = 0; i < len2; i++) {
    var item = list[i];
    var rect = item.rect;
    delta = rect[xyDim] - lastPos;
    if (delta < 0) {
      rect[xyDim] -= delta;
      item.label[xyDim] -= delta;
      adjusted = true;
    }
    var shift = Math.max(-delta, 0);
    totalShifts += shift;
    lastPos = rect[xyDim] + rect[sizeDim];
  }
  if (totalShifts > 0 && balanceShift) {
    shiftList(-totalShifts / len2, 0, len2);
  }
  var first = list[0];
  var last = list[len2 - 1];
  var minGap;
  var maxGap;
  updateMinMaxGap();
  minGap < 0 && squeezeGaps(-minGap, 0.8);
  maxGap < 0 && squeezeGaps(maxGap, 0.8);
  updateMinMaxGap();
  takeBoundsGap(minGap, maxGap, 1);
  takeBoundsGap(maxGap, minGap, -1);
  updateMinMaxGap();
  if (minGap < 0) {
    squeezeWhenBailout(-minGap);
  }
  if (maxGap < 0) {
    squeezeWhenBailout(maxGap);
  }
  function updateMinMaxGap() {
    minGap = first.rect[xyDim] - minBound;
    maxGap = maxBound - last.rect[xyDim] - last.rect[sizeDim];
  }
  function takeBoundsGap(gapThisBound, gapOtherBound, moveDir) {
    if (gapThisBound < 0) {
      var moveFromMaxGap = Math.min(gapOtherBound, -gapThisBound);
      if (moveFromMaxGap > 0) {
        shiftList(moveFromMaxGap * moveDir, 0, len2);
        var remained = moveFromMaxGap + gapThisBound;
        if (remained < 0) {
          squeezeGaps(-remained * moveDir, 1);
        }
      } else {
        squeezeGaps(-gapThisBound * moveDir, 1);
      }
    }
  }
  function shiftList(delta2, start2, end2) {
    if (delta2 !== 0) {
      adjusted = true;
    }
    for (var i2 = start2; i2 < end2; i2++) {
      var item2 = list[i2];
      var rect2 = item2.rect;
      rect2[xyDim] += delta2;
      item2.label[xyDim] += delta2;
    }
  }
  function squeezeGaps(delta2, maxSqeezePercent) {
    var gaps = [];
    var totalGaps = 0;
    for (var i2 = 1; i2 < len2; i2++) {
      var prevItemRect = list[i2 - 1].rect;
      var gap = Math.max(list[i2].rect[xyDim] - prevItemRect[xyDim] - prevItemRect[sizeDim], 0);
      gaps.push(gap);
      totalGaps += gap;
    }
    if (!totalGaps) {
      return;
    }
    var squeezePercent = Math.min(Math.abs(delta2) / totalGaps, maxSqeezePercent);
    if (delta2 > 0) {
      for (var i2 = 0; i2 < len2 - 1; i2++) {
        var movement = gaps[i2] * squeezePercent;
        shiftList(movement, 0, i2 + 1);
      }
    } else {
      for (var i2 = len2 - 1; i2 > 0; i2--) {
        var movement = gaps[i2 - 1] * squeezePercent;
        shiftList(-movement, i2, len2);
      }
    }
  }
  function squeezeWhenBailout(delta2) {
    var dir3 = delta2 < 0 ? -1 : 1;
    delta2 = Math.abs(delta2);
    var moveForEachLabel = Math.ceil(delta2 / (len2 - 1));
    for (var i2 = 0; i2 < len2 - 1; i2++) {
      if (dir3 > 0) {
        shiftList(moveForEachLabel, 0, i2 + 1);
      } else {
        shiftList(-moveForEachLabel, len2 - i2 - 1, len2);
      }
      delta2 -= moveForEachLabel;
      if (delta2 <= 0) {
        return;
      }
    }
  }
  return adjusted;
}
function shiftLayoutOnX(list, leftBound, rightBound, balanceShift) {
  return shiftLayout(list, "x", "width", leftBound, rightBound, balanceShift);
}
function shiftLayoutOnY(list, topBound, bottomBound, balanceShift) {
  return shiftLayout(list, "y", "height", topBound, bottomBound, balanceShift);
}
function hideOverlap(labelList) {
  var displayedLabels = [];
  labelList.sort(function(a, b2) {
    return b2.priority - a.priority;
  });
  var globalRect = new BoundingRect$1(0, 0, 0, 0);
  function hideEl(el) {
    if (!el.ignore) {
      var emphasisState = el.ensureState("emphasis");
      if (emphasisState.ignore == null) {
        emphasisState.ignore = false;
      }
    }
    el.ignore = true;
  }
  for (var i = 0; i < labelList.length; i++) {
    var labelItem = labelList[i];
    var isAxisAligned = labelItem.axisAligned;
    var localRect = labelItem.localRect;
    var transform2 = labelItem.transform;
    var label = labelItem.label;
    var labelLine = labelItem.labelLine;
    globalRect.copy(labelItem.rect);
    globalRect.width -= 0.1;
    globalRect.height -= 0.1;
    globalRect.x += 0.05;
    globalRect.y += 0.05;
    var obb = labelItem.obb;
    var overlapped = false;
    for (var j = 0; j < displayedLabels.length; j++) {
      var existsTextCfg = displayedLabels[j];
      if (!globalRect.intersect(existsTextCfg.rect)) {
        continue;
      }
      if (isAxisAligned && existsTextCfg.axisAligned) {
        overlapped = true;
        break;
      }
      if (!existsTextCfg.obb) {
        existsTextCfg.obb = new OrientedBoundingRect$1(existsTextCfg.localRect, existsTextCfg.transform);
      }
      if (!obb) {
        obb = new OrientedBoundingRect$1(localRect, transform2);
      }
      if (obb.intersect(existsTextCfg.obb)) {
        overlapped = true;
        break;
      }
    }
    if (overlapped) {
      hideEl(label);
      labelLine && hideEl(labelLine);
    } else {
      label.attr("ignore", labelItem.defaultAttr.ignore);
      labelLine && labelLine.attr("ignore", labelItem.defaultAttr.labelGuideIgnore);
      displayedLabels.push(labelItem);
    }
  }
}
function cloneArr(points2) {
  if (points2) {
    var newPoints = [];
    for (var i = 0; i < points2.length; i++) {
      newPoints.push(points2[i].slice());
    }
    return newPoints;
  }
}
function prepareLayoutCallbackParams(labelItem, hostEl) {
  var label = labelItem.label;
  var labelLine = hostEl && hostEl.getTextGuideLine();
  return {
    dataIndex: labelItem.dataIndex,
    dataType: labelItem.dataType,
    seriesIndex: labelItem.seriesModel.seriesIndex,
    text: labelItem.label.style.text,
    rect: labelItem.hostRect,
    labelRect: labelItem.rect,
    align: label.style.align,
    verticalAlign: label.style.verticalAlign,
    labelLinePoints: cloneArr(labelLine && labelLine.shape.points)
  };
}
var LABEL_OPTION_TO_STYLE_KEYS = ["align", "verticalAlign", "width", "height", "fontSize"];
var dummyTransformable = new Transformable$1();
var labelLayoutInnerStore = makeInner();
var labelLineAnimationStore = makeInner();
function extendWithKeys(target, source, keys2) {
  for (var i = 0; i < keys2.length; i++) {
    var key = keys2[i];
    if (source[key] != null) {
      target[key] = source[key];
    }
  }
}
var LABEL_LAYOUT_PROPS = ["x", "y", "rotation"];
var LabelManager = function() {
  function LabelManager2() {
    this._labelList = [];
    this._chartViewList = [];
  }
  LabelManager2.prototype.clearLabels = function() {
    this._labelList = [];
    this._chartViewList = [];
  };
  LabelManager2.prototype._addLabel = function(dataIndex, dataType, seriesModel, label, layoutOption) {
    var labelStyle = label.style;
    var hostEl = label.__hostTarget;
    var textConfig = hostEl.textConfig || {};
    var labelTransform = label.getComputedTransform();
    var labelRect = label.getBoundingRect().plain();
    BoundingRect$1.applyTransform(labelRect, labelRect, labelTransform);
    if (labelTransform) {
      dummyTransformable.setLocalTransform(labelTransform);
    } else {
      dummyTransformable.x = dummyTransformable.y = dummyTransformable.rotation = dummyTransformable.originX = dummyTransformable.originY = 0;
      dummyTransformable.scaleX = dummyTransformable.scaleY = 1;
    }
    var host = label.__hostTarget;
    var hostRect;
    if (host) {
      hostRect = host.getBoundingRect().plain();
      var transform2 = host.getComputedTransform();
      BoundingRect$1.applyTransform(hostRect, hostRect, transform2);
    }
    var labelGuide = hostRect && host.getTextGuideLine();
    this._labelList.push({
      label,
      labelLine: labelGuide,
      seriesModel,
      dataIndex,
      dataType,
      layoutOption,
      computedLayoutOption: null,
      rect: labelRect,
      hostRect,
      priority: hostRect ? hostRect.width * hostRect.height : 0,
      defaultAttr: {
        ignore: label.ignore,
        labelGuideIgnore: labelGuide && labelGuide.ignore,
        x: dummyTransformable.x,
        y: dummyTransformable.y,
        scaleX: dummyTransformable.scaleX,
        scaleY: dummyTransformable.scaleY,
        rotation: dummyTransformable.rotation,
        style: {
          x: labelStyle.x,
          y: labelStyle.y,
          align: labelStyle.align,
          verticalAlign: labelStyle.verticalAlign,
          width: labelStyle.width,
          height: labelStyle.height,
          fontSize: labelStyle.fontSize
        },
        cursor: label.cursor,
        attachedPos: textConfig.position,
        attachedRot: textConfig.rotation
      }
    });
  };
  LabelManager2.prototype.addLabelsOfSeries = function(chartView) {
    var _this = this;
    this._chartViewList.push(chartView);
    var seriesModel = chartView.__model;
    var layoutOption = seriesModel.get("labelLayout");
    if (!(isFunction(layoutOption) || keys(layoutOption).length)) {
      return;
    }
    chartView.group.traverse(function(child) {
      if (child.ignore) {
        return true;
      }
      var textEl = child.getTextContent();
      var ecData = getECData(child);
      if (textEl && !textEl.disableLabelLayout) {
        _this._addLabel(ecData.dataIndex, ecData.dataType, seriesModel, textEl, layoutOption);
      }
    });
  };
  LabelManager2.prototype.updateLayoutConfig = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    function createDragHandler(el, labelLineModel) {
      return function() {
        updateLabelLinePoints(el, labelLineModel);
      };
    }
    for (var i = 0; i < this._labelList.length; i++) {
      var labelItem = this._labelList[i];
      var label = labelItem.label;
      var hostEl = label.__hostTarget;
      var defaultLabelAttr = labelItem.defaultAttr;
      var layoutOption = void 0;
      if (isFunction(labelItem.layoutOption)) {
        layoutOption = labelItem.layoutOption(prepareLayoutCallbackParams(labelItem, hostEl));
      } else {
        layoutOption = labelItem.layoutOption;
      }
      layoutOption = layoutOption || {};
      labelItem.computedLayoutOption = layoutOption;
      var degreeToRadian = Math.PI / 180;
      if (hostEl) {
        hostEl.setTextConfig({
          local: false,
          position: layoutOption.x != null || layoutOption.y != null ? null : defaultLabelAttr.attachedPos,
          rotation: layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.attachedRot,
          offset: [layoutOption.dx || 0, layoutOption.dy || 0]
        });
      }
      var needsUpdateLabelLine = false;
      if (layoutOption.x != null) {
        label.x = parsePercent(layoutOption.x, width);
        label.setStyle("x", 0);
        needsUpdateLabelLine = true;
      } else {
        label.x = defaultLabelAttr.x;
        label.setStyle("x", defaultLabelAttr.style.x);
      }
      if (layoutOption.y != null) {
        label.y = parsePercent(layoutOption.y, height);
        label.setStyle("y", 0);
        needsUpdateLabelLine = true;
      } else {
        label.y = defaultLabelAttr.y;
        label.setStyle("y", defaultLabelAttr.style.y);
      }
      if (layoutOption.labelLinePoints) {
        var guideLine = hostEl.getTextGuideLine();
        if (guideLine) {
          guideLine.setShape({
            points: layoutOption.labelLinePoints
          });
          needsUpdateLabelLine = false;
        }
      }
      var labelLayoutStore = labelLayoutInnerStore(label);
      labelLayoutStore.needsUpdateLabelLine = needsUpdateLabelLine;
      label.rotation = layoutOption.rotate != null ? layoutOption.rotate * degreeToRadian : defaultLabelAttr.rotation;
      label.scaleX = defaultLabelAttr.scaleX;
      label.scaleY = defaultLabelAttr.scaleY;
      for (var k2 = 0; k2 < LABEL_OPTION_TO_STYLE_KEYS.length; k2++) {
        var key = LABEL_OPTION_TO_STYLE_KEYS[k2];
        label.setStyle(key, layoutOption[key] != null ? layoutOption[key] : defaultLabelAttr.style[key]);
      }
      if (layoutOption.draggable) {
        label.draggable = true;
        label.cursor = "move";
        if (hostEl) {
          var hostModel = labelItem.seriesModel;
          if (labelItem.dataIndex != null) {
            var data = labelItem.seriesModel.getData(labelItem.dataType);
            hostModel = data.getItemModel(labelItem.dataIndex);
          }
          label.on("drag", createDragHandler(hostEl, hostModel.getModel("labelLine")));
        }
      } else {
        label.off("drag");
        label.cursor = defaultLabelAttr.cursor;
      }
    }
  };
  LabelManager2.prototype.layout = function(api) {
    var width = api.getWidth();
    var height = api.getHeight();
    var labelList = prepareLayoutList(this._labelList);
    var labelsNeedsAdjustOnX = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftX";
    });
    var labelsNeedsAdjustOnY = filter(labelList, function(item) {
      return item.layoutOption.moveOverlap === "shiftY";
    });
    shiftLayoutOnX(labelsNeedsAdjustOnX, 0, width);
    shiftLayoutOnY(labelsNeedsAdjustOnY, 0, height);
    var labelsNeedsHideOverlap = filter(labelList, function(item) {
      return item.layoutOption.hideOverlap;
    });
    hideOverlap(labelsNeedsHideOverlap);
  };
  LabelManager2.prototype.processLabelsOverall = function() {
    var _this = this;
    each$f(this._chartViewList, function(chartView) {
      var seriesModel = chartView.__model;
      var ignoreLabelLineUpdate = chartView.ignoreLabelLineUpdate;
      var animationEnabled = seriesModel.isAnimationEnabled();
      chartView.group.traverse(function(child) {
        if (child.ignore && !child.forceLabelAnimation) {
          return true;
        }
        var needsUpdateLabelLine = !ignoreLabelLineUpdate;
        var label = child.getTextContent();
        if (!needsUpdateLabelLine && label) {
          needsUpdateLabelLine = labelLayoutInnerStore(label).needsUpdateLabelLine;
        }
        if (needsUpdateLabelLine) {
          _this._updateLabelLine(child, seriesModel);
        }
        if (animationEnabled) {
          _this._animateLabels(child, seriesModel);
        }
      });
    });
  };
  LabelManager2.prototype._updateLabelLine = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var ecData = getECData(el);
    var dataIndex = ecData.dataIndex;
    if (textEl && dataIndex != null) {
      var data = seriesModel.getData(ecData.dataType);
      var itemModel = data.getItemModel(dataIndex);
      var defaultStyle = {};
      var visualStyle = data.getItemVisual(dataIndex, "style");
      var visualType = data.getVisual("drawType");
      defaultStyle.stroke = visualStyle[visualType];
      var labelLineModel = itemModel.getModel("labelLine");
      setLabelLineStyle(el, getLabelLineStatesModels(itemModel), defaultStyle);
      updateLabelLinePoints(el, labelLineModel);
    }
  };
  LabelManager2.prototype._animateLabels = function(el, seriesModel) {
    var textEl = el.getTextContent();
    var guideLine = el.getTextGuideLine();
    if (textEl && (el.forceLabelAnimation || !textEl.ignore && !textEl.invisible && !el.disableLabelAnimation && !isElementRemoved(el))) {
      var layoutStore = labelLayoutInnerStore(textEl);
      var oldLayout = layoutStore.oldLayout;
      var ecData = getECData(el);
      var dataIndex = ecData.dataIndex;
      var newProps = {
        x: textEl.x,
        y: textEl.y,
        rotation: textEl.rotation
      };
      var data = seriesModel.getData(ecData.dataType);
      if (!oldLayout) {
        textEl.attr(newProps);
        if (!labelInner(textEl).valueAnimation) {
          var oldOpacity = retrieve2(textEl.style.opacity, 1);
          textEl.style.opacity = 0;
          initProps(textEl, {
            style: {
              opacity: oldOpacity
            }
          }, seriesModel, dataIndex);
        }
      } else {
        textEl.attr(oldLayout);
        var prevStates = el.prevStates;
        if (prevStates) {
          if (indexOf(prevStates, "select") >= 0) {
            textEl.attr(layoutStore.oldLayoutSelect);
          }
          if (indexOf(prevStates, "emphasis") >= 0) {
            textEl.attr(layoutStore.oldLayoutEmphasis);
          }
        }
        updateProps$1(textEl, newProps, seriesModel, dataIndex);
      }
      layoutStore.oldLayout = newProps;
      if (textEl.states.select) {
        var layoutSelect = layoutStore.oldLayoutSelect = {};
        extendWithKeys(layoutSelect, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutSelect, textEl.states.select, LABEL_LAYOUT_PROPS);
      }
      if (textEl.states.emphasis) {
        var layoutEmphasis = layoutStore.oldLayoutEmphasis = {};
        extendWithKeys(layoutEmphasis, newProps, LABEL_LAYOUT_PROPS);
        extendWithKeys(layoutEmphasis, textEl.states.emphasis, LABEL_LAYOUT_PROPS);
      }
      animateLabelValue(textEl, dataIndex, data, seriesModel, seriesModel);
    }
    if (guideLine && !guideLine.ignore && !guideLine.invisible) {
      var layoutStore = labelLineAnimationStore(guideLine);
      var oldLayout = layoutStore.oldLayout;
      var newLayout = {
        points: guideLine.shape.points
      };
      if (!oldLayout) {
        guideLine.setShape(newLayout);
        guideLine.style.strokePercent = 0;
        initProps(guideLine, {
          style: {
            strokePercent: 1
          }
        }, seriesModel);
      } else {
        guideLine.attr({
          shape: oldLayout
        });
        updateProps$1(guideLine, {
          shape: newLayout
        }, seriesModel);
      }
      layoutStore.oldLayout = newLayout;
    }
  };
  return LabelManager2;
}();
var LabelManager$1 = LabelManager;
var getLabelManager = makeInner();
function installLabelLayout(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    if (!labelManager) {
      labelManager = getLabelManager(api).labelManager = new LabelManager$1();
    }
    labelManager.clearLabels();
  });
  registers.registerUpdateLifecycle("series:layoutlabels", function(ecModel, api, params) {
    var labelManager = getLabelManager(api).labelManager;
    params.updatedSeries.forEach(function(series) {
      labelManager.addLabelsOfSeries(api.getViewOfSeriesModel(series));
    });
    labelManager.updateLayoutConfig(api);
    labelManager.layout(api);
    labelManager.processLabelsOverall();
  });
}
var mathSin = Math.sin;
var mathCos = Math.cos;
var PI$4 = Math.PI;
var PI2$2 = Math.PI * 2;
var degree = 180 / PI$4;
var SVGPathRebuilder = function() {
  function SVGPathRebuilder2() {
  }
  SVGPathRebuilder2.prototype.reset = function(precision) {
    this._start = true;
    this._d = [];
    this._str = "";
    this._p = Math.pow(10, precision || 4);
  };
  SVGPathRebuilder2.prototype.moveTo = function(x2, y2) {
    this._add("M", x2, y2);
  };
  SVGPathRebuilder2.prototype.lineTo = function(x2, y2) {
    this._add("L", x2, y2);
  };
  SVGPathRebuilder2.prototype.bezierCurveTo = function(x2, y2, x22, y22, x3, y3) {
    this._add("C", x2, y2, x22, y22, x3, y3);
  };
  SVGPathRebuilder2.prototype.quadraticCurveTo = function(x2, y2, x22, y22) {
    this._add("Q", x2, y2, x22, y22);
  };
  SVGPathRebuilder2.prototype.arc = function(cx, cy, r2, startAngle, endAngle, anticlockwise) {
    this.ellipse(cx, cy, r2, r2, 0, startAngle, endAngle, anticlockwise);
  };
  SVGPathRebuilder2.prototype.ellipse = function(cx, cy, rx, ry, psi, startAngle, endAngle, anticlockwise) {
    var dTheta = endAngle - startAngle;
    var clockwise = !anticlockwise;
    var dThetaPositive = Math.abs(dTheta);
    var isCircle = isAroundZero(dThetaPositive - PI2$2) || (clockwise ? dTheta >= PI2$2 : -dTheta >= PI2$2);
    var unifiedTheta = dTheta > 0 ? dTheta % PI2$2 : dTheta % PI2$2 + PI2$2;
    var large = false;
    if (isCircle) {
      large = true;
    } else if (isAroundZero(dThetaPositive)) {
      large = false;
    } else {
      large = unifiedTheta >= PI$4 === !!clockwise;
    }
    var x0 = cx + rx * mathCos(startAngle);
    var y0 = cy + ry * mathSin(startAngle);
    if (this._start) {
      this._add("M", x0, y0);
    }
    var xRot = Math.round(psi * degree);
    if (isCircle) {
      var p2 = 1 / this._p;
      var dTheta_1 = (clockwise ? 1 : -1) * (PI2$2 - p2);
      this._add("A", rx, ry, xRot, 1, +clockwise, cx + rx * mathCos(startAngle + dTheta_1), cy + ry * mathSin(startAngle + dTheta_1));
      if (p2 > 0.01) {
        this._add("A", rx, ry, xRot, 0, +clockwise, x0, y0);
      }
    } else {
      var x2 = cx + rx * mathCos(endAngle);
      var y2 = cy + ry * mathSin(endAngle);
      this._add("A", rx, ry, xRot, +large, +clockwise, x2, y2);
    }
  };
  SVGPathRebuilder2.prototype.rect = function(x2, y2, w2, h) {
    this._add("M", x2, y2);
    this._add("l", w2, 0);
    this._add("l", 0, h);
    this._add("l", -w2, 0);
    this._add("Z");
  };
  SVGPathRebuilder2.prototype.closePath = function() {
    if (this._d.length > 0) {
      this._add("Z");
    }
  };
  SVGPathRebuilder2.prototype._add = function(cmd, a, b2, c2, d2, e2, f2, g2, h) {
    var vals = [];
    var p2 = this._p;
    for (var i = 1; i < arguments.length; i++) {
      var val = arguments[i];
      if (isNaN(val)) {
        this._invalid = true;
        return;
      }
      vals.push(Math.round(val * p2) / p2);
    }
    this._d.push(cmd + vals.join(" "));
    this._start = cmd === "Z";
  };
  SVGPathRebuilder2.prototype.generateStr = function() {
    this._str = this._invalid ? "" : this._d.join("");
    this._d = [];
  };
  SVGPathRebuilder2.prototype.getStr = function() {
    return this._str;
  };
  return SVGPathRebuilder2;
}();
var SVGPathRebuilder$1 = SVGPathRebuilder;
var NONE = "none";
var mathRound = Math.round;
function pathHasFill(style) {
  var fill = style.fill;
  return fill != null && fill !== NONE;
}
function pathHasStroke(style) {
  var stroke = style.stroke;
  return stroke != null && stroke !== NONE;
}
var strokeProps = ["lineCap", "miterLimit", "lineJoin"];
var svgStrokeProps = map$1(strokeProps, function(prop) {
  return "stroke-" + prop.toLowerCase();
});
function mapStyleToAttrs(updateAttr2, style, el, forceUpdate) {
  var opacity = style.opacity == null ? 1 : style.opacity;
  if (el instanceof ZRImage$1) {
    updateAttr2("opacity", opacity);
    return;
  }
  if (pathHasFill(style)) {
    var fill = normalizeColor(style.fill);
    updateAttr2("fill", fill.color);
    var fillOpacity = style.fillOpacity != null ? style.fillOpacity * fill.opacity * opacity : fill.opacity * opacity;
    if (forceUpdate || fillOpacity < 1) {
      updateAttr2("fill-opacity", fillOpacity);
    }
  } else {
    updateAttr2("fill", NONE);
  }
  if (pathHasStroke(style)) {
    var stroke = normalizeColor(style.stroke);
    updateAttr2("stroke", stroke.color);
    var strokeScale = style.strokeNoScale ? el.getLineScale() : 1;
    var strokeWidth = strokeScale ? (style.lineWidth || 0) / strokeScale : 0;
    var strokeOpacity = style.strokeOpacity != null ? style.strokeOpacity * stroke.opacity * opacity : stroke.opacity * opacity;
    var strokeFirst = style.strokeFirst;
    if (forceUpdate || strokeWidth !== 1) {
      updateAttr2("stroke-width", strokeWidth);
    }
    if (forceUpdate || strokeFirst) {
      updateAttr2("paint-order", strokeFirst ? "stroke" : "fill");
    }
    if (forceUpdate || strokeOpacity < 1) {
      updateAttr2("stroke-opacity", strokeOpacity);
    }
    if (style.lineDash) {
      var _a2 = getLineDash(el), lineDash = _a2[0], lineDashOffset = _a2[1];
      if (lineDash) {
        lineDashOffset = mathRound(lineDashOffset || 0);
        updateAttr2("stroke-dasharray", lineDash.join(","));
        if (lineDashOffset || forceUpdate) {
          updateAttr2("stroke-dashoffset", lineDashOffset);
        }
      }
    } else if (forceUpdate) {
      updateAttr2("stroke-dasharray", NONE);
    }
    for (var i = 0; i < strokeProps.length; i++) {
      var propName = strokeProps[i];
      if (forceUpdate || style[propName] !== DEFAULT_PATH_STYLE[propName]) {
        var val = style[propName] || DEFAULT_PATH_STYLE[propName];
        val && updateAttr2(svgStrokeProps[i], val);
      }
    }
  } else if (forceUpdate) {
    updateAttr2("stroke", NONE);
  }
}
var SVGNS = "http://www.w3.org/2000/svg";
var XLINKNS = "http://www.w3.org/1999/xlink";
var XMLNS = "http://www.w3.org/2000/xmlns/";
var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
function createElement(name) {
  return document.createElementNS(SVGNS, name);
}
function createVNode(tag, key, attrs, children, text) {
  return {
    tag,
    attrs: attrs || {},
    children,
    text,
    key
  };
}
function createElementOpen(name, attrs) {
  var attrsStr = [];
  if (attrs) {
    for (var key in attrs) {
      var val = attrs[key];
      var part = key;
      if (val === false) {
        continue;
      } else if (val !== true && val != null) {
        part += '="' + val + '"';
      }
      attrsStr.push(part);
    }
  }
  return "<" + name + " " + attrsStr.join(" ") + ">";
}
function createElementClose(name) {
  return "</" + name + ">";
}
function vNodeToString(el, opts) {
  opts = opts || {};
  var S = opts.newline ? "\n" : "";
  function convertElToString(el2) {
    var children = el2.children, tag = el2.tag, attrs = el2.attrs;
    return createElementOpen(tag, attrs) + (el2.text || "") + (children ? "" + S + map$1(children, function(child) {
      return convertElToString(child);
    }).join(S) + S : "") + createElementClose(tag);
  }
  return convertElToString(el);
}
function getCssString(selectorNodes, animationNodes, opts) {
  opts = opts || {};
  var S = opts.newline ? "\n" : "";
  var bracketBegin = " {" + S;
  var bracketEnd = S + "}";
  var selectors = map$1(keys(selectorNodes), function(className) {
    return className + bracketBegin + map$1(keys(selectorNodes[className]), function(attrName) {
      return attrName + ":" + selectorNodes[className][attrName] + ";";
    }).join(S) + bracketEnd;
  }).join(S);
  var animations = map$1(keys(animationNodes), function(animationName) {
    return "@keyframes " + animationName + bracketBegin + map$1(keys(animationNodes[animationName]), function(percent) {
      return percent + bracketBegin + map$1(keys(animationNodes[animationName][percent]), function(attrName) {
        var val = animationNodes[animationName][percent][attrName];
        if (attrName === "d") {
          val = 'path("' + val + '")';
        }
        return attrName + ":" + val + ";";
      }).join(S) + bracketEnd;
    }).join(S) + bracketEnd;
  }).join(S);
  if (!selectors && !animations) {
    return "";
  }
  return ["<![CDATA[", selectors, animations, "]]>"].join(S);
}
function createBrushScope(zrId) {
  return {
    zrId,
    shadowCache: {},
    patternCache: {},
    gradientCache: {},
    clipPathCache: {},
    defs: {},
    cssNodes: {},
    cssAnims: {},
    cssClassIdx: 0,
    cssAnimIdx: 0,
    shadowIdx: 0,
    gradientIdx: 0,
    patternIdx: 0,
    clipPathIdx: 0
  };
}
function createSVGVNode(width, height, children, useViewBox) {
  return createVNode("svg", "root", {
    "width": width,
    "height": height,
    "xmlns": SVGNS,
    "xmlns:xlink": XLINKNS,
    "version": "1.1",
    "baseProfile": "full",
    "viewBox": useViewBox ? "0 0 " + width + " " + height : false
  }, children);
}
var EASING_MAP = {
  cubicIn: "0.32,0,0.67,0",
  cubicOut: "0.33,1,0.68,1",
  cubicInOut: "0.65,0,0.35,1",
  quadraticIn: "0.11,0,0.5,0",
  quadraticOut: "0.5,1,0.89,1",
  quadraticInOut: "0.45,0,0.55,1",
  quarticIn: "0.5,0,0.75,0",
  quarticOut: "0.25,1,0.5,1",
  quarticInOut: "0.76,0,0.24,1",
  quinticIn: "0.64,0,0.78,0",
  quinticOut: "0.22,1,0.36,1",
  quinticInOut: "0.83,0,0.17,1",
  sinusoidalIn: "0.12,0,0.39,0",
  sinusoidalOut: "0.61,1,0.88,1",
  sinusoidalInOut: "0.37,0,0.63,1",
  exponentialIn: "0.7,0,0.84,0",
  exponentialOut: "0.16,1,0.3,1",
  exponentialInOut: "0.87,0,0.13,1",
  circularIn: "0.55,0,1,0.45",
  circularOut: "0,0.55,0.45,1",
  circularInOut: "0.85,0,0.15,1"
};
var transformOriginKey = "transform-origin";
function buildPathString(el, kfShape, path) {
  var shape = extend({}, el.shape);
  extend(shape, kfShape);
  el.buildPath(path, shape);
  var svgPathBuilder = new SVGPathRebuilder$1();
  svgPathBuilder.reset(getPathPrecision(el));
  path.rebuildPath(svgPathBuilder, 1);
  svgPathBuilder.generateStr();
  return svgPathBuilder.getStr();
}
function setTransformOrigin(target, transform2) {
  var originX = transform2.originX, originY = transform2.originY;
  if (originX || originY) {
    target[transformOriginKey] = originX + "px " + originY + "px";
  }
}
var ANIMATE_STYLE_MAP = {
  fill: "fill",
  opacity: "opacity",
  lineWidth: "stroke-width",
  lineDashOffset: "stroke-dashoffset"
};
function addAnimation(cssAnim, scope) {
  var animationName = scope.zrId + "-ani-" + scope.cssAnimIdx++;
  scope.cssAnims[animationName] = cssAnim;
  return animationName;
}
function createCompoundPathCSSAnimation(el, attrs, scope) {
  var paths = el.shape.paths;
  var composedAnim = {};
  var cssAnimationCfg;
  var cssAnimationName;
  each$f(paths, function(path) {
    var subScope = createBrushScope(scope.zrId);
    subScope.animation = true;
    createCSSAnimation(path, {}, subScope, true);
    var cssAnims = subScope.cssAnims;
    var cssNodes = subScope.cssNodes;
    var animNames = keys(cssAnims);
    var len2 = animNames.length;
    if (!len2) {
      return;
    }
    cssAnimationName = animNames[len2 - 1];
    var lastAnim = cssAnims[cssAnimationName];
    for (var percent in lastAnim) {
      var kf = lastAnim[percent];
      composedAnim[percent] = composedAnim[percent] || { d: "" };
      composedAnim[percent].d += kf.d || "";
    }
    for (var className in cssNodes) {
      var val = cssNodes[className].animation;
      if (val.indexOf(cssAnimationName) >= 0) {
        cssAnimationCfg = val;
      }
    }
  });
  if (!cssAnimationCfg) {
    return;
  }
  attrs.d = false;
  var animationName = addAnimation(composedAnim, scope);
  return cssAnimationCfg.replace(cssAnimationName, animationName);
}
function getEasingFunc(easing) {
  return isString(easing) ? EASING_MAP[easing] ? "cubic-bezier(" + EASING_MAP[easing] + ")" : createCubicEasingFunc(easing) ? easing : "" : "";
}
function createCSSAnimation(el, attrs, scope, onlyShape) {
  var animators = el.animators;
  var len2 = animators.length;
  var cssAnimations = [];
  if (el instanceof CompoundPath$1) {
    var animationCfg = createCompoundPathCSSAnimation(el, attrs, scope);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    } else if (!len2) {
      return;
    }
  } else if (!len2) {
    return;
  }
  var groupAnimators = {};
  for (var i = 0; i < len2; i++) {
    var animator = animators[i];
    var cfgArr = [animator.getMaxTime() / 1e3 + "s"];
    var easing = getEasingFunc(animator.getClip().easing);
    var delay = animator.getDelay();
    if (easing) {
      cfgArr.push(easing);
    } else {
      cfgArr.push("linear");
    }
    if (delay) {
      cfgArr.push(delay / 1e3 + "s");
    }
    if (animator.getLoop()) {
      cfgArr.push("infinite");
    }
    var cfg = cfgArr.join(" ");
    groupAnimators[cfg] = groupAnimators[cfg] || [cfg, []];
    groupAnimators[cfg][1].push(animator);
  }
  function createSingleCSSAnimation(groupAnimator) {
    var animators2 = groupAnimator[1];
    var len3 = animators2.length;
    var transformKfs = {};
    var shapeKfs = {};
    var finalKfs = {};
    var animationTimingFunctionAttrName = "animation-timing-function";
    function saveAnimatorTrackToCssKfs(animator3, cssKfs, toCssAttrName) {
      var tracks = animator3.getTracks();
      var maxTime = animator3.getMaxTime();
      for (var k2 = 0; k2 < tracks.length; k2++) {
        var track = tracks[k2];
        if (track.needsAnimate()) {
          var kfs = track.keyframes;
          var attrName = track.propName;
          toCssAttrName && (attrName = toCssAttrName(attrName));
          if (attrName) {
            for (var i3 = 0; i3 < kfs.length; i3++) {
              var kf = kfs[i3];
              var percent2 = Math.round(kf.time / maxTime * 100) + "%";
              var kfEasing = getEasingFunc(kf.easing);
              var rawValue = kf.rawValue;
              if (isString(rawValue) || isNumber(rawValue)) {
                cssKfs[percent2] = cssKfs[percent2] || {};
                cssKfs[percent2][attrName] = kf.rawValue;
                if (kfEasing) {
                  cssKfs[percent2][animationTimingFunctionAttrName] = kfEasing;
                }
              }
            }
          }
        }
      }
    }
    for (var i2 = 0; i2 < len3; i2++) {
      var animator2 = animators2[i2];
      var targetProp = animator2.targetName;
      if (!targetProp) {
        !onlyShape && saveAnimatorTrackToCssKfs(animator2, transformKfs);
      } else if (targetProp === "shape") {
        saveAnimatorTrackToCssKfs(animator2, shapeKfs);
      }
    }
    for (var percent in transformKfs) {
      var transform2 = {};
      copyTransform(transform2, el);
      extend(transform2, transformKfs[percent]);
      var str = getSRTTransformString(transform2);
      var timingFunction = transformKfs[percent][animationTimingFunctionAttrName];
      finalKfs[percent] = str ? {
        transform: str
      } : {};
      setTransformOrigin(finalKfs[percent], transform2);
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    var path;
    var canAnimateShape = true;
    for (var percent in shapeKfs) {
      finalKfs[percent] = finalKfs[percent] || {};
      var isFirst = !path;
      var timingFunction = shapeKfs[percent][animationTimingFunctionAttrName];
      if (isFirst) {
        path = new PathProxy$1();
      }
      var len_1 = path.len();
      path.reset();
      finalKfs[percent].d = buildPathString(el, shapeKfs[percent], path);
      var newLen = path.len();
      if (!isFirst && len_1 !== newLen) {
        canAnimateShape = false;
        break;
      }
      if (timingFunction) {
        finalKfs[percent][animationTimingFunctionAttrName] = timingFunction;
      }
    }
    if (!canAnimateShape) {
      for (var percent in finalKfs) {
        delete finalKfs[percent].d;
      }
    }
    if (!onlyShape) {
      for (var i2 = 0; i2 < len3; i2++) {
        var animator2 = animators2[i2];
        var targetProp = animator2.targetName;
        if (targetProp === "style") {
          saveAnimatorTrackToCssKfs(animator2, finalKfs, function(propName) {
            return ANIMATE_STYLE_MAP[propName];
          });
        }
      }
    }
    var percents = keys(finalKfs);
    var allTransformOriginSame = true;
    var transformOrigin;
    for (var i2 = 1; i2 < percents.length; i2++) {
      var p0 = percents[i2 - 1];
      var p1 = percents[i2];
      if (finalKfs[p0][transformOriginKey] !== finalKfs[p1][transformOriginKey]) {
        allTransformOriginSame = false;
        break;
      }
      transformOrigin = finalKfs[p0][transformOriginKey];
    }
    if (allTransformOriginSame && transformOrigin) {
      for (var percent in finalKfs) {
        if (finalKfs[percent][transformOriginKey]) {
          delete finalKfs[percent][transformOriginKey];
        }
      }
      attrs[transformOriginKey] = transformOrigin;
    }
    if (filter(percents, function(percent2) {
      return keys(finalKfs[percent2]).length > 0;
    }).length) {
      var animationName = addAnimation(finalKfs, scope);
      return animationName + " " + groupAnimator[0] + " both";
    }
  }
  for (var key in groupAnimators) {
    var animationCfg = createSingleCSSAnimation(groupAnimators[key]);
    if (animationCfg) {
      cssAnimations.push(animationCfg);
    }
  }
  if (cssAnimations.length) {
    var className = scope.zrId + "-cls-" + scope.cssClassIdx++;
    scope.cssNodes["." + className] = {
      animation: cssAnimations.join(",")
    };
    attrs["class"] = className;
  }
}
var round$1 = Math.round;
function isImageLike(val) {
  return val && isString(val.src);
}
function isCanvasLike(val) {
  return val && isFunction(val.toDataURL);
}
function setStyleAttrs(attrs, style, el, scope) {
  mapStyleToAttrs(function(key, val) {
    var isFillStroke = key === "fill" || key === "stroke";
    if (isFillStroke && isGradient(val)) {
      setGradient(style, attrs, key, scope);
    } else if (isFillStroke && isPattern(val)) {
      setPattern(el, attrs, key, scope);
    } else {
      attrs[key] = val;
    }
  }, style, el, false);
  setShadow(el, attrs, scope);
}
function noRotateScale(m2) {
  return isAroundZero(m2[0] - 1) && isAroundZero(m2[1]) && isAroundZero(m2[2]) && isAroundZero(m2[3] - 1);
}
function noTranslate(m2) {
  return isAroundZero(m2[4]) && isAroundZero(m2[5]);
}
function setTransform(attrs, m2, compress) {
  if (m2 && !(noTranslate(m2) && noRotateScale(m2))) {
    var mul2 = compress ? 10 : 1e4;
    attrs.transform = noRotateScale(m2) ? "translate(" + round$1(m2[4] * mul2) / mul2 + " " + round$1(m2[5] * mul2) / mul2 + ")" : getMatrixStr(m2);
  }
}
function convertPolyShape(shape, attrs, mul2) {
  var points2 = shape.points;
  var strArr = [];
  for (var i = 0; i < points2.length; i++) {
    strArr.push(round$1(points2[i][0] * mul2) / mul2);
    strArr.push(round$1(points2[i][1] * mul2) / mul2);
  }
  attrs.points = strArr.join(" ");
}
function validatePolyShape(shape) {
  return !shape.smooth;
}
function createAttrsConvert(desc) {
  var normalizedDesc = map$1(desc, function(item) {
    return typeof item === "string" ? [item, item] : item;
  });
  return function(shape, attrs, mul2) {
    for (var i = 0; i < normalizedDesc.length; i++) {
      var item = normalizedDesc[i];
      var val = shape[item[0]];
      if (val != null) {
        attrs[item[1]] = round$1(val * mul2) / mul2;
      }
    }
  };
}
var buitinShapesDef = {
  circle: [createAttrsConvert(["cx", "cy", "r"])],
  polyline: [convertPolyShape, validatePolyShape],
  polygon: [convertPolyShape, validatePolyShape]
};
function hasShapeAnimation(el) {
  var animators = el.animators;
  for (var i = 0; i < animators.length; i++) {
    if (animators[i].targetName === "shape") {
      return true;
    }
  }
  return false;
}
function brushSVGPath(el, scope) {
  var style = el.style;
  var shape = el.shape;
  var builtinShpDef = buitinShapesDef[el.type];
  var attrs = {};
  var needsAnimate = scope.animation;
  var svgElType = "path";
  var strokePercent = el.style.strokePercent;
  var precision = scope.compress && getPathPrecision(el) || 4;
  if (builtinShpDef && !scope.willUpdate && !(builtinShpDef[1] && !builtinShpDef[1](shape)) && !(needsAnimate && hasShapeAnimation(el)) && !(strokePercent < 1)) {
    svgElType = el.type;
    var mul2 = Math.pow(10, precision);
    builtinShpDef[0](shape, attrs, mul2);
  } else {
    if (!el.path) {
      el.createPathProxy();
    }
    var path = el.path;
    if (el.shapeChanged()) {
      path.beginPath();
      el.buildPath(path, el.shape);
      el.pathUpdated();
    }
    var pathVersion = path.getVersion();
    var elExt = el;
    var svgPathBuilder = elExt.__svgPathBuilder;
    if (elExt.__svgPathVersion !== pathVersion || !svgPathBuilder || strokePercent !== elExt.__svgPathStrokePercent) {
      if (!svgPathBuilder) {
        svgPathBuilder = elExt.__svgPathBuilder = new SVGPathRebuilder$1();
      }
      svgPathBuilder.reset(precision);
      path.rebuildPath(svgPathBuilder, strokePercent);
      svgPathBuilder.generateStr();
      elExt.__svgPathVersion = pathVersion;
      elExt.__svgPathStrokePercent = strokePercent;
    }
    attrs.d = svgPathBuilder.getStr();
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode(svgElType, el.id + "", attrs);
}
function brushSVGImage(el, scope) {
  var style = el.style;
  var image = style.image;
  if (image && !isString(image)) {
    if (isImageLike(image)) {
      image = image.src;
    } else if (isCanvasLike(image)) {
      image = image.toDataURL();
    }
  }
  if (!image) {
    return;
  }
  var x2 = style.x || 0;
  var y2 = style.y || 0;
  var dw = style.width;
  var dh = style.height;
  var attrs = {
    href: image,
    width: dw,
    height: dh
  };
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("image", el.id + "", attrs);
}
function brushSVGTSpan(el, scope) {
  var style = el.style;
  var text = style.text;
  text != null && (text += "");
  if (!text || isNaN(style.x) || isNaN(style.y)) {
    return;
  }
  var font = style.font || DEFAULT_FONT;
  var x2 = style.x || 0;
  var y2 = adjustTextY$1(style.y || 0, getLineHeight(font), style.textBaseline);
  var textAlign = TEXT_ALIGN_TO_ANCHOR[style.textAlign] || style.textAlign;
  var attrs = {
    "dominant-baseline": "central",
    "text-anchor": textAlign
  };
  if (hasSeparateFont(style)) {
    var separatedFontStr = "";
    var fontStyle = style.fontStyle;
    var fontSize = parseFontSize(style.fontSize);
    if (!parseFloat(fontSize)) {
      return;
    }
    var fontFamily = style.fontFamily || DEFAULT_FONT_FAMILY;
    var fontWeight = style.fontWeight;
    separatedFontStr += "font-size:" + fontSize + ";font-family:" + fontFamily + ";";
    if (fontStyle && fontStyle !== "normal") {
      separatedFontStr += "font-style:" + fontStyle + ";";
    }
    if (fontWeight && fontWeight !== "normal") {
      separatedFontStr += "font-weight:" + fontWeight + ";";
    }
    attrs.style = separatedFontStr;
  } else {
    attrs.style = "font: " + font;
  }
  if (text.match(/\s/)) {
    attrs["xml:space"] = "preserve";
  }
  if (x2) {
    attrs.x = x2;
  }
  if (y2) {
    attrs.y = y2;
  }
  setTransform(attrs, el.transform);
  setStyleAttrs(attrs, style, el, scope);
  scope.animation && createCSSAnimation(el, attrs, scope);
  return createVNode("text", el.id + "", attrs, void 0, text);
}
function brush(el, scope) {
  if (el instanceof Path$1) {
    return brushSVGPath(el, scope);
  } else if (el instanceof ZRImage$1) {
    return brushSVGImage(el, scope);
  } else if (el instanceof TSpan$1) {
    return brushSVGTSpan(el, scope);
  }
}
function setShadow(el, attrs, scope) {
  var style = el.style;
  if (hasShadow(style)) {
    var shadowKey = getShadowKey(el);
    var shadowCache = scope.shadowCache;
    var shadowId = shadowCache[shadowKey];
    if (!shadowId) {
      var globalScale = el.getGlobalScale();
      var scaleX = globalScale[0];
      var scaleY = globalScale[1];
      if (!scaleX || !scaleY) {
        return;
      }
      var offsetX = style.shadowOffsetX || 0;
      var offsetY = style.shadowOffsetY || 0;
      var blur_1 = style.shadowBlur;
      var _a2 = normalizeColor(style.shadowColor), opacity = _a2.opacity, color = _a2.color;
      var stdDx = blur_1 / 2 / scaleX;
      var stdDy = blur_1 / 2 / scaleY;
      var stdDeviation = stdDx + " " + stdDy;
      shadowId = scope.zrId + "-s" + scope.shadowIdx++;
      scope.defs[shadowId] = createVNode("filter", shadowId, {
        "id": shadowId,
        "x": "-100%",
        "y": "-100%",
        "width": "300%",
        "height": "300%"
      }, [
        createVNode("feDropShadow", "", {
          "dx": offsetX / scaleX,
          "dy": offsetY / scaleY,
          "stdDeviation": stdDeviation,
          "flood-color": color,
          "flood-opacity": opacity
        })
      ]);
      shadowCache[shadowKey] = shadowId;
    }
    attrs.filter = getIdURL(shadowId);
  }
}
function setGradient(style, attrs, target, scope) {
  var val = style[target];
  var gradientTag;
  var gradientAttrs = {
    "gradientUnits": val.global ? "userSpaceOnUse" : "objectBoundingBox"
  };
  if (isLinearGradient(val)) {
    gradientTag = "linearGradient";
    gradientAttrs.x1 = val.x;
    gradientAttrs.y1 = val.y;
    gradientAttrs.x2 = val.x2;
    gradientAttrs.y2 = val.y2;
  } else if (isRadialGradient(val)) {
    gradientTag = "radialGradient";
    gradientAttrs.cx = retrieve2(val.x, 0.5);
    gradientAttrs.cy = retrieve2(val.y, 0.5);
    gradientAttrs.r = retrieve2(val.r, 0.5);
  } else {
    return;
  }
  var colors = val.colorStops;
  var colorStops = [];
  for (var i = 0, len2 = colors.length; i < len2; ++i) {
    var offset = round4(colors[i].offset) * 100 + "%";
    var stopColor = colors[i].color;
    var _a2 = normalizeColor(stopColor), color = _a2.color, opacity = _a2.opacity;
    var stopsAttrs = {
      "offset": offset
    };
    stopsAttrs["stop-color"] = color;
    if (opacity < 1) {
      stopsAttrs["stop-opacity"] = opacity;
    }
    colorStops.push(createVNode("stop", i + "", stopsAttrs));
  }
  var gradientVNode = createVNode(gradientTag, "", gradientAttrs, colorStops);
  var gradientKey = vNodeToString(gradientVNode);
  var gradientCache = scope.gradientCache;
  var gradientId = gradientCache[gradientKey];
  if (!gradientId) {
    gradientId = scope.zrId + "-g" + scope.gradientIdx++;
    gradientCache[gradientKey] = gradientId;
    gradientAttrs.id = gradientId;
    scope.defs[gradientId] = createVNode(gradientTag, gradientId, gradientAttrs, colorStops);
  }
  attrs[target] = getIdURL(gradientId);
}
function setPattern(el, attrs, target, scope) {
  var val = el.style[target];
  var patternAttrs = {
    "patternUnits": "userSpaceOnUse"
  };
  var child;
  if (isImagePattern(val)) {
    var imageWidth_1 = val.imageWidth;
    var imageHeight_1 = val.imageHeight;
    var imageSrc = void 0;
    var patternImage = val.image;
    if (isString(patternImage)) {
      imageSrc = patternImage;
    } else if (isImageLike(patternImage)) {
      imageSrc = patternImage.src;
    } else if (isCanvasLike(patternImage)) {
      imageSrc = patternImage.toDataURL();
    }
    if (typeof Image === "undefined") {
      var errMsg = "Image width/height must been given explictly in svg-ssr renderer.";
      assert(imageWidth_1, errMsg);
      assert(imageHeight_1, errMsg);
    } else if (imageWidth_1 == null || imageHeight_1 == null) {
      var setSizeToVNode_1 = function(vNode, img) {
        if (vNode) {
          var svgEl = vNode.elm;
          var width = vNode.attrs.width = imageWidth_1 || img.width;
          var height = vNode.attrs.height = imageHeight_1 || img.height;
          if (svgEl) {
            svgEl.setAttribute("width", width);
            svgEl.setAttribute("height", height);
          }
        }
      };
      var createdImage = createOrUpdateImage(imageSrc, null, el, function(img) {
        setSizeToVNode_1(patternVNode, img);
        setSizeToVNode_1(child, img);
      });
      if (createdImage && createdImage.width && createdImage.height) {
        imageWidth_1 = imageWidth_1 || createdImage.width;
        imageHeight_1 = imageHeight_1 || createdImage.height;
      }
    }
    child = createVNode("image", "img", {
      href: imageSrc,
      width: imageWidth_1,
      height: imageHeight_1
    });
    patternAttrs.width = imageWidth_1;
    patternAttrs.height = imageHeight_1;
  } else if (val.svgElement) {
    child = clone$4(val.svgElement);
    patternAttrs.width = val.svgWidth;
    patternAttrs.height = val.svgHeight;
  }
  if (!child) {
    return;
  }
  patternAttrs.patternTransform = getSRTTransformString(val);
  var patternVNode = createVNode("pattern", "", patternAttrs, [child]);
  var patternKey = vNodeToString(patternVNode);
  var patternCache = scope.patternCache;
  var patternId = patternCache[patternKey];
  if (!patternId) {
    patternId = scope.zrId + "-p" + scope.patternIdx++;
    patternCache[patternKey] = patternId;
    patternAttrs.id = patternId;
    patternVNode = scope.defs[patternId] = createVNode("pattern", patternId, patternAttrs, [child]);
  }
  attrs[target] = getIdURL(patternId);
}
function setClipPath(clipPath, attrs, scope) {
  var clipPathCache = scope.clipPathCache, defs = scope.defs;
  var clipPathId = clipPathCache[clipPath.id];
  if (!clipPathId) {
    clipPathId = scope.zrId + "-c" + scope.clipPathIdx++;
    var clipPathAttrs = {
      id: clipPathId
    };
    clipPathCache[clipPath.id] = clipPathId;
    defs[clipPathId] = createVNode("clipPath", clipPathId, clipPathAttrs, [brushSVGPath(clipPath, scope)]);
  }
  attrs["clip-path"] = getIdURL(clipPathId);
}
function createTextNode(text) {
  return document.createTextNode(text);
}
function insertBefore(parentNode2, newNode, referenceNode) {
  parentNode2.insertBefore(newNode, referenceNode);
}
function removeChild(node, child) {
  node.removeChild(child);
}
function appendChild(node, child) {
  node.appendChild(child);
}
function parentNode(node) {
  return node.parentNode;
}
function nextSibling(node) {
  return node.nextSibling;
}
function setTextContent(node, text) {
  node.textContent = text;
}
var colonChar = 58;
var xChar = 120;
var emptyNode = createVNode("", "");
function isUndef(s) {
  return s === void 0;
}
function isDef(s) {
  return s !== void 0;
}
function createKeyToOldIdx(children, beginIdx, endIdx) {
  var map2 = {};
  for (var i = beginIdx; i <= endIdx; ++i) {
    var key = children[i].key;
    if (key !== void 0) {
      map2[key] = i;
    }
  }
  return map2;
}
function sameVnode(vnode1, vnode2) {
  var isSameKey = vnode1.key === vnode2.key;
  var isSameTag = vnode1.tag === vnode2.tag;
  return isSameTag && isSameKey;
}
function createElm(vnode) {
  var i;
  var children = vnode.children;
  var tag = vnode.tag;
  if (isDef(tag)) {
    var elm = vnode.elm = createElement(tag);
    updateAttrs(emptyNode, vnode);
    if (isArray$1(children)) {
      for (i = 0; i < children.length; ++i) {
        var ch = children[i];
        if (ch != null) {
          appendChild(elm, createElm(ch));
        }
      }
    } else if (isDef(vnode.text) && !isObject$4(vnode.text)) {
      appendChild(elm, createTextNode(vnode.text));
    }
  } else {
    vnode.elm = createTextNode(vnode.text);
  }
  return vnode.elm;
}
function addVnodes(parentElm, before, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch = vnodes[startIdx];
    if (ch != null) {
      insertBefore(parentElm, createElm(ch), before);
    }
  }
}
function removeVnodes(parentElm, vnodes, startIdx, endIdx) {
  for (; startIdx <= endIdx; ++startIdx) {
    var ch = vnodes[startIdx];
    if (ch != null) {
      if (isDef(ch.tag)) {
        var parent_1 = parentNode(ch.elm);
        removeChild(parent_1, ch.elm);
      } else {
        removeChild(parentElm, ch.elm);
      }
    }
  }
}
function updateAttrs(oldVnode, vnode) {
  var key;
  var elm = vnode.elm;
  var oldAttrs = oldVnode && oldVnode.attrs || {};
  var attrs = vnode.attrs || {};
  if (oldAttrs === attrs) {
    return;
  }
  for (key in attrs) {
    var cur = attrs[key];
    var old = oldAttrs[key];
    if (old !== cur) {
      if (cur === true) {
        elm.setAttribute(key, "");
      } else if (cur === false) {
        elm.removeAttribute(key);
      } else {
        if (key.charCodeAt(0) !== xChar) {
          elm.setAttribute(key, cur);
        } else if (key === "xmlns:xlink" || key === "xmlns") {
          elm.setAttributeNS(XMLNS, key, cur);
        } else if (key.charCodeAt(3) === colonChar) {
          elm.setAttributeNS(XML_NAMESPACE, key, cur);
        } else if (key.charCodeAt(5) === colonChar) {
          elm.setAttributeNS(XLINKNS, key, cur);
        } else {
          elm.setAttribute(key, cur);
        }
      }
    }
  }
  for (key in oldAttrs) {
    if (!(key in attrs)) {
      elm.removeAttribute(key);
    }
  }
}
function updateChildren(parentElm, oldCh, newCh) {
  var oldStartIdx = 0;
  var newStartIdx = 0;
  var oldEndIdx = oldCh.length - 1;
  var oldStartVnode = oldCh[0];
  var oldEndVnode = oldCh[oldEndIdx];
  var newEndIdx = newCh.length - 1;
  var newStartVnode = newCh[0];
  var newEndVnode = newCh[newEndIdx];
  var oldKeyToIdx;
  var idxInOld;
  var elmToMove;
  var before;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newStartVnode)) {
      patchVnode(oldStartVnode, newStartVnode);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (sameVnode(oldEndVnode, newEndVnode)) {
      patchVnode(oldEndVnode, newEndVnode);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldStartVnode, newEndVnode)) {
      patchVnode(oldStartVnode, newEndVnode);
      insertBefore(parentElm, oldStartVnode.elm, nextSibling(oldEndVnode.elm));
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (sameVnode(oldEndVnode, newStartVnode)) {
      patchVnode(oldEndVnode, newStartVnode);
      insertBefore(parentElm, oldEndVnode.elm, oldStartVnode.elm);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      if (isUndef(oldKeyToIdx)) {
        oldKeyToIdx = createKeyToOldIdx(oldCh, oldStartIdx, oldEndIdx);
      }
      idxInOld = oldKeyToIdx[newStartVnode.key];
      if (isUndef(idxInOld)) {
        insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
      } else {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.tag !== newStartVnode.tag) {
          insertBefore(parentElm, createElm(newStartVnode), oldStartVnode.elm);
        } else {
          patchVnode(elmToMove, newStartVnode);
          oldCh[idxInOld] = void 0;
          insertBefore(parentElm, elmToMove.elm, oldStartVnode.elm);
        }
      }
      newStartVnode = newCh[++newStartIdx];
    }
  }
  if (oldStartIdx <= oldEndIdx || newStartIdx <= newEndIdx) {
    if (oldStartIdx > oldEndIdx) {
      before = newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].elm;
      addVnodes(parentElm, before, newCh, newStartIdx, newEndIdx);
    } else {
      removeVnodes(parentElm, oldCh, oldStartIdx, oldEndIdx);
    }
  }
}
function patchVnode(oldVnode, vnode) {
  var elm = vnode.elm = oldVnode.elm;
  var oldCh = oldVnode.children;
  var ch = vnode.children;
  if (oldVnode === vnode) {
    return;
  }
  updateAttrs(oldVnode, vnode);
  if (isUndef(vnode.text)) {
    if (isDef(oldCh) && isDef(ch)) {
      if (oldCh !== ch) {
        updateChildren(elm, oldCh, ch);
      }
    } else if (isDef(ch)) {
      if (isDef(oldVnode.text)) {
        setTextContent(elm, "");
      }
      addVnodes(elm, null, ch, 0, ch.length - 1);
    } else if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    } else if (isDef(oldVnode.text)) {
      setTextContent(elm, "");
    }
  } else if (oldVnode.text !== vnode.text) {
    if (isDef(oldCh)) {
      removeVnodes(elm, oldCh, 0, oldCh.length - 1);
    }
    setTextContent(elm, vnode.text);
  }
}
function patch(oldVnode, vnode) {
  if (sameVnode(oldVnode, vnode)) {
    patchVnode(oldVnode, vnode);
  } else {
    var elm = oldVnode.elm;
    var parent_2 = parentNode(elm);
    createElm(vnode);
    if (parent_2 !== null) {
      insertBefore(parent_2, vnode.elm, nextSibling(elm));
      removeVnodes(parent_2, [oldVnode], 0, 0);
    }
  }
  return vnode;
}
var svgId = 0;
var SVGPainter = function() {
  function SVGPainter2(root2, storage2, opts) {
    this.type = "svg";
    this.refreshHover = createMethodNotSupport();
    this.configLayer = createMethodNotSupport();
    this.storage = storage2;
    this._opts = opts = extend({}, opts);
    this.root = root2;
    this._id = "zr" + svgId++;
    this._oldVNode = createSVGVNode(opts.width, opts.height);
    if (root2 && !opts.ssr) {
      var viewport = this._viewport = document.createElement("div");
      viewport.style.cssText = "position:relative;overflow:hidden";
      var svgDom = this._svgDom = this._oldVNode.elm = createElement("svg");
      updateAttrs(null, this._oldVNode);
      viewport.appendChild(svgDom);
      root2.appendChild(viewport);
    }
    this.resize(opts.width, opts.height);
  }
  SVGPainter2.prototype.getType = function() {
    return this.type;
  };
  SVGPainter2.prototype.getViewportRoot = function() {
    return this._viewport;
  };
  SVGPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  SVGPainter2.prototype.getSvgDom = function() {
    return this._svgDom;
  };
  SVGPainter2.prototype.refresh = function() {
    if (this.root) {
      var vnode = this.renderToVNode({
        willUpdate: true
      });
      vnode.attrs.style = "position:absolute;left:0;top:0;user-select:none";
      patch(this._oldVNode, vnode);
      this._oldVNode = vnode;
    }
  };
  SVGPainter2.prototype.renderOneToVNode = function(el) {
    return brush(el, createBrushScope(this._id));
  };
  SVGPainter2.prototype.renderToVNode = function(opts) {
    opts = opts || {};
    var list = this.storage.getDisplayList(true);
    var bgColor = this._backgroundColor;
    var width = this._width;
    var height = this._height;
    var scope = createBrushScope(this._id);
    scope.animation = opts.animation;
    scope.willUpdate = opts.willUpdate;
    scope.compress = opts.compress;
    var children = [];
    if (bgColor && bgColor !== "none") {
      var _a2 = normalizeColor(bgColor), color = _a2.color, opacity = _a2.opacity;
      this._bgVNode = createVNode("rect", "bg", {
        width,
        height,
        x: "0",
        y: "0",
        id: "0",
        fill: color,
        "fill-opacity": opacity
      });
      children.push(this._bgVNode);
    } else {
      this._bgVNode = null;
    }
    var mainVNode = !opts.compress ? this._mainVNode = createVNode("g", "main", {}, []) : null;
    this._paintList(list, scope, mainVNode ? mainVNode.children : children);
    mainVNode && children.push(mainVNode);
    var defs = map$1(keys(scope.defs), function(id2) {
      return scope.defs[id2];
    });
    if (defs.length) {
      children.push(createVNode("defs", "defs", {}, defs));
    }
    if (opts.animation) {
      var animationCssStr = getCssString(scope.cssNodes, scope.cssAnims, { newline: true });
      if (animationCssStr) {
        var styleNode = createVNode("style", "stl", {}, [], animationCssStr);
        children.push(styleNode);
      }
    }
    return createSVGVNode(width, height, children, opts.useViewBox);
  };
  SVGPainter2.prototype.renderToString = function(opts) {
    opts = opts || {};
    return vNodeToString(this.renderToVNode({
      animation: retrieve2(opts.cssAnimation, true),
      willUpdate: false,
      compress: true,
      useViewBox: retrieve2(opts.useViewBox, true)
    }), { newline: true });
  };
  SVGPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    var bgVNode = this._bgVNode;
    if (bgVNode && bgVNode.elm) {
      var _a2 = normalizeColor(backgroundColor2), color = _a2.color, opacity = _a2.opacity;
      bgVNode.elm.setAttribute("fill", color);
      if (opacity < 1) {
        bgVNode.elm.setAttribute("fill-opacity", opacity);
      }
    }
  };
  SVGPainter2.prototype.getSvgRoot = function() {
    return this._mainVNode && this._mainVNode.elm;
  };
  SVGPainter2.prototype._paintList = function(list, scope, out2) {
    var listLen = list.length;
    var clipPathsGroupsStack = [];
    var clipPathsGroupsStackDepth = 0;
    var currentClipPathGroup;
    var prevClipPaths;
    var clipGroupNodeIdx = 0;
    for (var i = 0; i < listLen; i++) {
      var displayable = list[i];
      if (!displayable.invisible) {
        var clipPaths = displayable.__clipPaths;
        var len2 = clipPaths && clipPaths.length || 0;
        var prevLen = prevClipPaths && prevClipPaths.length || 0;
        var lca = void 0;
        for (lca = Math.max(len2 - 1, prevLen - 1); lca >= 0; lca--) {
          if (clipPaths && prevClipPaths && clipPaths[lca] === prevClipPaths[lca]) {
            break;
          }
        }
        for (var i_1 = prevLen - 1; i_1 > lca; i_1--) {
          clipPathsGroupsStackDepth--;
          currentClipPathGroup = clipPathsGroupsStack[clipPathsGroupsStackDepth - 1];
        }
        for (var i_2 = lca + 1; i_2 < len2; i_2++) {
          var groupAttrs = {};
          setClipPath(clipPaths[i_2], groupAttrs, scope);
          var g2 = createVNode("g", "clip-g-" + clipGroupNodeIdx++, groupAttrs, []);
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(g2);
          clipPathsGroupsStack[clipPathsGroupsStackDepth++] = g2;
          currentClipPathGroup = g2;
        }
        prevClipPaths = clipPaths;
        var ret = brush(displayable, scope);
        if (ret) {
          (currentClipPathGroup ? currentClipPathGroup.children : out2).push(ret);
        }
      }
    }
  };
  SVGPainter2.prototype.resize = function(width, height) {
    var opts = this._opts;
    var root2 = this.root;
    var viewport = this._viewport;
    width != null && (opts.width = width);
    height != null && (opts.height = height);
    if (root2 && viewport) {
      viewport.style.display = "none";
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      viewport.style.display = "";
    }
    if (this._width !== width || this._height !== height) {
      this._width = width;
      this._height = height;
      if (viewport) {
        var viewportStyle = viewport.style;
        viewportStyle.width = width + "px";
        viewportStyle.height = height + "px";
      }
      var svgDom = this._svgDom;
      if (svgDom) {
        svgDom.setAttribute("width", width);
        svgDom.setAttribute("height", height);
      }
    }
  };
  SVGPainter2.prototype.getWidth = function() {
    return this._width;
  };
  SVGPainter2.prototype.getHeight = function() {
    return this._height;
  };
  SVGPainter2.prototype.dispose = function() {
    if (this.root) {
      this.root.innerHTML = "";
    }
    this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
  };
  SVGPainter2.prototype.clear = function() {
    if (this._svgDom) {
      this._svgDom.innerHTML = null;
    }
    this._oldVNode = null;
  };
  SVGPainter2.prototype.toDataURL = function(base64) {
    var str = encodeURIComponent(this.renderToString());
    var prefix = "data:image/svg+xml;";
    if (base64) {
      str = encodeBase64(str);
      return str && prefix + "base64," + str;
    }
    return prefix + "charset=UTF-8," + str;
  };
  return SVGPainter2;
}();
function createMethodNotSupport(method4) {
  return function() {
  };
}
var SVGPainter$1 = SVGPainter;
function install$S(registers) {
  registers.registerPainter("svg", SVGPainter$1);
}
function createDom(id2, painter, dpr2) {
  var newDom = platformApi.createCanvas();
  var width = painter.getWidth();
  var height = painter.getHeight();
  var newDomStyle = newDom.style;
  if (newDomStyle) {
    newDomStyle.position = "absolute";
    newDomStyle.left = "0";
    newDomStyle.top = "0";
    newDomStyle.width = width + "px";
    newDomStyle.height = height + "px";
    newDom.setAttribute("data-zr-dom-id", id2);
  }
  newDom.width = width * dpr2;
  newDom.height = height * dpr2;
  return newDom;
}
var Layer = function(_super) {
  __extends(Layer2, _super);
  function Layer2(id2, painter, dpr2) {
    var _this = _super.call(this) || this;
    _this.motionBlur = false;
    _this.lastFrameAlpha = 0.7;
    _this.dpr = 1;
    _this.virtual = false;
    _this.config = {};
    _this.incremental = false;
    _this.zlevel = 0;
    _this.maxRepaintRectCount = 5;
    _this.__dirty = true;
    _this.__firstTimePaint = true;
    _this.__used = false;
    _this.__drawIndex = 0;
    _this.__startIndex = 0;
    _this.__endIndex = 0;
    _this.__prevStartIndex = null;
    _this.__prevEndIndex = null;
    var dom;
    dpr2 = dpr2 || devicePixelRatio;
    if (typeof id2 === "string") {
      dom = createDom(id2, painter, dpr2);
    } else if (isObject$4(id2)) {
      dom = id2;
      id2 = dom.id;
    }
    _this.id = id2;
    _this.dom = dom;
    var domStyle = dom.style;
    if (domStyle) {
      disableUserSelect(dom);
      dom.onselectstart = function() {
        return false;
      };
      domStyle.padding = "0";
      domStyle.margin = "0";
      domStyle.borderWidth = "0";
    }
    _this.painter = painter;
    _this.dpr = dpr2;
    return _this;
  }
  Layer2.prototype.getElementCount = function() {
    return this.__endIndex - this.__startIndex;
  };
  Layer2.prototype.afterBrush = function() {
    this.__prevStartIndex = this.__startIndex;
    this.__prevEndIndex = this.__endIndex;
  };
  Layer2.prototype.initContext = function() {
    this.ctx = this.dom.getContext("2d");
    this.ctx.dpr = this.dpr;
  };
  Layer2.prototype.setUnpainted = function() {
    this.__firstTimePaint = true;
  };
  Layer2.prototype.createBackBuffer = function() {
    var dpr2 = this.dpr;
    this.domBack = createDom("back-" + this.id, this.painter, dpr2);
    this.ctxBack = this.domBack.getContext("2d");
    if (dpr2 !== 1) {
      this.ctxBack.scale(dpr2, dpr2);
    }
  };
  Layer2.prototype.createRepaintRects = function(displayList, prevList, viewWidth, viewHeight) {
    if (this.__firstTimePaint) {
      this.__firstTimePaint = false;
      return null;
    }
    var mergedRepaintRects = [];
    var maxRepaintRectCount = this.maxRepaintRectCount;
    var full = false;
    var pendingRect = new BoundingRect$1(0, 0, 0, 0);
    function addRectToMergePool(rect) {
      if (!rect.isFinite() || rect.isZero()) {
        return;
      }
      if (mergedRepaintRects.length === 0) {
        var boundingRect = new BoundingRect$1(0, 0, 0, 0);
        boundingRect.copy(rect);
        mergedRepaintRects.push(boundingRect);
      } else {
        var isMerged = false;
        var minDeltaArea = Infinity;
        var bestRectToMergeIdx = 0;
        for (var i2 = 0; i2 < mergedRepaintRects.length; ++i2) {
          var mergedRect = mergedRepaintRects[i2];
          if (mergedRect.intersect(rect)) {
            var pendingRect_1 = new BoundingRect$1(0, 0, 0, 0);
            pendingRect_1.copy(mergedRect);
            pendingRect_1.union(rect);
            mergedRepaintRects[i2] = pendingRect_1;
            isMerged = true;
            break;
          } else if (full) {
            pendingRect.copy(rect);
            pendingRect.union(mergedRect);
            var aArea = rect.width * rect.height;
            var bArea = mergedRect.width * mergedRect.height;
            var pendingArea = pendingRect.width * pendingRect.height;
            var deltaArea = pendingArea - aArea - bArea;
            if (deltaArea < minDeltaArea) {
              minDeltaArea = deltaArea;
              bestRectToMergeIdx = i2;
            }
          }
        }
        if (full) {
          mergedRepaintRects[bestRectToMergeIdx].union(rect);
          isMerged = true;
        }
        if (!isMerged) {
          var boundingRect = new BoundingRect$1(0, 0, 0, 0);
          boundingRect.copy(rect);
          mergedRepaintRects.push(boundingRect);
        }
        if (!full) {
          full = mergedRepaintRects.length >= maxRepaintRectCount;
        }
      }
    }
    for (var i = this.__startIndex; i < this.__endIndex; ++i) {
      var el = displayList[i];
      if (el) {
        var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
        var prevRect = el.__isRendered && (el.__dirty & REDRAW_BIT || !shouldPaint) ? el.getPrevPaintRect() : null;
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
        var curRect = shouldPaint && (el.__dirty & REDRAW_BIT || !el.__isRendered) ? el.getPaintRect() : null;
        if (curRect) {
          addRectToMergePool(curRect);
        }
      }
    }
    for (var i = this.__prevStartIndex; i < this.__prevEndIndex; ++i) {
      var el = prevList[i];
      var shouldPaint = el.shouldBePainted(viewWidth, viewHeight, true, true);
      if (el && (!shouldPaint || !el.__zr) && el.__isRendered) {
        var prevRect = el.getPrevPaintRect();
        if (prevRect) {
          addRectToMergePool(prevRect);
        }
      }
    }
    var hasIntersections;
    do {
      hasIntersections = false;
      for (var i = 0; i < mergedRepaintRects.length; ) {
        if (mergedRepaintRects[i].isZero()) {
          mergedRepaintRects.splice(i, 1);
          continue;
        }
        for (var j = i + 1; j < mergedRepaintRects.length; ) {
          if (mergedRepaintRects[i].intersect(mergedRepaintRects[j])) {
            hasIntersections = true;
            mergedRepaintRects[i].union(mergedRepaintRects[j]);
            mergedRepaintRects.splice(j, 1);
          } else {
            j++;
          }
        }
        i++;
      }
    } while (hasIntersections);
    this._paintRects = mergedRepaintRects;
    return mergedRepaintRects;
  };
  Layer2.prototype.debugGetPaintRects = function() {
    return (this._paintRects || []).slice();
  };
  Layer2.prototype.resize = function(width, height) {
    var dpr2 = this.dpr;
    var dom = this.dom;
    var domStyle = dom.style;
    var domBack = this.domBack;
    if (domStyle) {
      domStyle.width = width + "px";
      domStyle.height = height + "px";
    }
    dom.width = width * dpr2;
    dom.height = height * dpr2;
    if (domBack) {
      domBack.width = width * dpr2;
      domBack.height = height * dpr2;
      if (dpr2 !== 1) {
        this.ctxBack.scale(dpr2, dpr2);
      }
    }
  };
  Layer2.prototype.clear = function(clearAll, clearColor, repaintRects) {
    var dom = this.dom;
    var ctx = this.ctx;
    var width = dom.width;
    var height = dom.height;
    clearColor = clearColor || this.clearColor;
    var haveMotionBLur = this.motionBlur && !clearAll;
    var lastFrameAlpha = this.lastFrameAlpha;
    var dpr2 = this.dpr;
    var self2 = this;
    if (haveMotionBLur) {
      if (!this.domBack) {
        this.createBackBuffer();
      }
      this.ctxBack.globalCompositeOperation = "copy";
      this.ctxBack.drawImage(dom, 0, 0, width / dpr2, height / dpr2);
    }
    var domBack = this.domBack;
    function doClear(x2, y2, width2, height2) {
      ctx.clearRect(x2, y2, width2, height2);
      if (clearColor && clearColor !== "transparent") {
        var clearColorGradientOrPattern = void 0;
        if (isGradientObject(clearColor)) {
          clearColorGradientOrPattern = clearColor.__canvasGradient || getCanvasGradient(ctx, clearColor, {
            x: 0,
            y: 0,
            width: width2,
            height: height2
          });
          clearColor.__canvasGradient = clearColorGradientOrPattern;
        } else if (isImagePatternObject(clearColor)) {
          clearColorGradientOrPattern = createCanvasPattern(ctx, clearColor, {
            dirty: function() {
              self2.setUnpainted();
              self2.__painter.refresh();
            }
          });
        }
        ctx.save();
        ctx.fillStyle = clearColorGradientOrPattern || clearColor;
        ctx.fillRect(x2, y2, width2, height2);
        ctx.restore();
      }
      if (haveMotionBLur) {
        ctx.save();
        ctx.globalAlpha = lastFrameAlpha;
        ctx.drawImage(domBack, x2, y2, width2, height2);
        ctx.restore();
      }
    }
    if (!repaintRects || haveMotionBLur) {
      doClear(0, 0, width, height);
    } else if (repaintRects.length) {
      each$f(repaintRects, function(rect) {
        doClear(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
      });
    }
  };
  return Layer2;
}(Eventful$1);
var Layer$1 = Layer;
var HOVER_LAYER_ZLEVEL = 1e5;
var CANVAS_ZLEVEL = 314159;
var EL_AFTER_INCREMENTAL_INC = 0.01;
var INCREMENTAL_INC = 1e-3;
function isLayerValid(layer) {
  if (!layer) {
    return false;
  }
  if (layer.__builtin__) {
    return true;
  }
  if (typeof layer.resize !== "function" || typeof layer.refresh !== "function") {
    return false;
  }
  return true;
}
function createRoot(width, height) {
  var domRoot = document.createElement("div");
  domRoot.style.cssText = [
    "position:relative",
    "width:" + width + "px",
    "height:" + height + "px",
    "padding:0",
    "margin:0",
    "border-width:0"
  ].join(";") + ";";
  return domRoot;
}
var CanvasPainter = function() {
  function CanvasPainter2(root2, storage2, opts, id2) {
    this.type = "canvas";
    this._zlevelList = [];
    this._prevDisplayList = [];
    this._layers = {};
    this._layerConfig = {};
    this._needsManuallyCompositing = false;
    this.type = "canvas";
    var singleCanvas = !root2.nodeName || root2.nodeName.toUpperCase() === "CANVAS";
    this._opts = opts = extend({}, opts || {});
    this.dpr = opts.devicePixelRatio || devicePixelRatio;
    this._singleCanvas = singleCanvas;
    this.root = root2;
    var rootStyle = root2.style;
    if (rootStyle) {
      disableUserSelect(root2);
      root2.innerHTML = "";
    }
    this.storage = storage2;
    var zlevelList = this._zlevelList;
    this._prevDisplayList = [];
    var layers = this._layers;
    if (!singleCanvas) {
      this._width = getSize$1(root2, 0, opts);
      this._height = getSize$1(root2, 1, opts);
      var domRoot = this._domRoot = createRoot(this._width, this._height);
      root2.appendChild(domRoot);
    } else {
      var rootCanvas = root2;
      var width = rootCanvas.width;
      var height = rootCanvas.height;
      if (opts.width != null) {
        width = opts.width;
      }
      if (opts.height != null) {
        height = opts.height;
      }
      this.dpr = opts.devicePixelRatio || 1;
      rootCanvas.width = width * this.dpr;
      rootCanvas.height = height * this.dpr;
      this._width = width;
      this._height = height;
      var mainLayer = new Layer$1(rootCanvas, this, this.dpr);
      mainLayer.__builtin__ = true;
      mainLayer.initContext();
      layers[CANVAS_ZLEVEL] = mainLayer;
      mainLayer.zlevel = CANVAS_ZLEVEL;
      zlevelList.push(CANVAS_ZLEVEL);
      this._domRoot = root2;
    }
  }
  CanvasPainter2.prototype.getType = function() {
    return "canvas";
  };
  CanvasPainter2.prototype.isSingleCanvas = function() {
    return this._singleCanvas;
  };
  CanvasPainter2.prototype.getViewportRoot = function() {
    return this._domRoot;
  };
  CanvasPainter2.prototype.getViewportRootOffset = function() {
    var viewportRoot = this.getViewportRoot();
    if (viewportRoot) {
      return {
        offsetLeft: viewportRoot.offsetLeft || 0,
        offsetTop: viewportRoot.offsetTop || 0
      };
    }
  };
  CanvasPainter2.prototype.refresh = function(paintAll) {
    var list = this.storage.getDisplayList(true);
    var prevList = this._prevDisplayList;
    var zlevelList = this._zlevelList;
    this._redrawId = Math.random();
    this._paintList(list, prevList, paintAll, this._redrawId);
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__ && layer.refresh) {
        var clearColor = i === 0 ? this._backgroundColor : null;
        layer.refresh(clearColor);
      }
    }
    if (this._opts.useDirtyRect) {
      this._prevDisplayList = list.slice();
    }
    return this;
  };
  CanvasPainter2.prototype.refreshHover = function() {
    this._paintHoverList(this.storage.getDisplayList(false));
  };
  CanvasPainter2.prototype._paintHoverList = function(list) {
    var len2 = list.length;
    var hoverLayer = this._hoverlayer;
    hoverLayer && hoverLayer.clear();
    if (!len2) {
      return;
    }
    var scope = {
      inHover: true,
      viewWidth: this._width,
      viewHeight: this._height
    };
    var ctx;
    for (var i = 0; i < len2; i++) {
      var el = list[i];
      if (el.__inHover) {
        if (!hoverLayer) {
          hoverLayer = this._hoverlayer = this.getLayer(HOVER_LAYER_ZLEVEL);
        }
        if (!ctx) {
          ctx = hoverLayer.ctx;
          ctx.save();
        }
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    if (ctx) {
      ctx.restore();
    }
  };
  CanvasPainter2.prototype.getHoverLayer = function() {
    return this.getLayer(HOVER_LAYER_ZLEVEL);
  };
  CanvasPainter2.prototype.paintOne = function(ctx, el) {
    brushSingle(ctx, el);
  };
  CanvasPainter2.prototype._paintList = function(list, prevList, paintAll, redrawId) {
    if (this._redrawId !== redrawId) {
      return;
    }
    paintAll = paintAll || false;
    this._updateLayerStatus(list);
    var _a2 = this._doPaintList(list, prevList, paintAll), finished = _a2.finished, needsRefreshHover = _a2.needsRefreshHover;
    if (this._needsManuallyCompositing) {
      this._compositeManually();
    }
    if (needsRefreshHover) {
      this._paintHoverList(list);
    }
    if (!finished) {
      var self_1 = this;
      requestAnimationFrame$2(function() {
        self_1._paintList(list, prevList, paintAll, redrawId);
      });
    } else {
      this.eachLayer(function(layer) {
        layer.afterBrush && layer.afterBrush();
      });
    }
  };
  CanvasPainter2.prototype._compositeManually = function() {
    var ctx = this.getLayer(CANVAS_ZLEVEL).ctx;
    var width = this._domRoot.width;
    var height = this._domRoot.height;
    ctx.clearRect(0, 0, width, height);
    this.eachBuiltinLayer(function(layer) {
      if (layer.virtual) {
        ctx.drawImage(layer.dom, 0, 0, width, height);
      }
    });
  };
  CanvasPainter2.prototype._doPaintList = function(list, prevList, paintAll) {
    var _this = this;
    var layerList = [];
    var useDirtyRect = this._opts.useDirtyRect;
    for (var zi = 0; zi < this._zlevelList.length; zi++) {
      var zlevel = this._zlevelList[zi];
      var layer = this._layers[zlevel];
      if (layer.__builtin__ && layer !== this._hoverlayer && (layer.__dirty || paintAll)) {
        layerList.push(layer);
      }
    }
    var finished = true;
    var needsRefreshHover = false;
    var _loop_1 = function(k3) {
      var layer2 = layerList[k3];
      var ctx = layer2.ctx;
      var repaintRects = useDirtyRect && layer2.createRepaintRects(list, prevList, this_1._width, this_1._height);
      var start2 = paintAll ? layer2.__startIndex : layer2.__drawIndex;
      var useTimer = !paintAll && layer2.incremental && Date.now;
      var startTime = useTimer && Date.now();
      var clearColor = layer2.zlevel === this_1._zlevelList[0] ? this_1._backgroundColor : null;
      if (layer2.__startIndex === layer2.__endIndex) {
        layer2.clear(false, clearColor, repaintRects);
      } else if (start2 === layer2.__startIndex) {
        var firstEl = list[start2];
        if (!firstEl.incremental || !firstEl.notClear || paintAll) {
          layer2.clear(false, clearColor, repaintRects);
        }
      }
      if (start2 === -1) {
        console.error("For some unknown reason. drawIndex is -1");
        start2 = layer2.__startIndex;
      }
      var i;
      var repaint = function(repaintRect) {
        var scope = {
          inHover: false,
          allClipped: false,
          prevEl: null,
          viewWidth: _this._width,
          viewHeight: _this._height
        };
        for (i = start2; i < layer2.__endIndex; i++) {
          var el = list[i];
          if (el.__inHover) {
            needsRefreshHover = true;
          }
          _this._doPaintEl(el, layer2, useDirtyRect, repaintRect, scope, i === layer2.__endIndex - 1);
          if (useTimer) {
            var dTime = Date.now() - startTime;
            if (dTime > 15) {
              break;
            }
          }
        }
        if (scope.prevElClipPaths) {
          ctx.restore();
        }
      };
      if (repaintRects) {
        if (repaintRects.length === 0) {
          i = layer2.__endIndex;
        } else {
          var dpr2 = this_1.dpr;
          for (var r2 = 0; r2 < repaintRects.length; ++r2) {
            var rect = repaintRects[r2];
            ctx.save();
            ctx.beginPath();
            ctx.rect(rect.x * dpr2, rect.y * dpr2, rect.width * dpr2, rect.height * dpr2);
            ctx.clip();
            repaint(rect);
            ctx.restore();
          }
        }
      } else {
        ctx.save();
        repaint();
        ctx.restore();
      }
      layer2.__drawIndex = i;
      if (layer2.__drawIndex < layer2.__endIndex) {
        finished = false;
      }
    };
    var this_1 = this;
    for (var k2 = 0; k2 < layerList.length; k2++) {
      _loop_1(k2);
    }
    if (env$1.wxa) {
      each$f(this._layers, function(layer2) {
        if (layer2 && layer2.ctx && layer2.ctx.draw) {
          layer2.ctx.draw();
        }
      });
    }
    return {
      finished,
      needsRefreshHover
    };
  };
  CanvasPainter2.prototype._doPaintEl = function(el, currentLayer, useDirtyRect, repaintRect, scope, isLast) {
    var ctx = currentLayer.ctx;
    if (useDirtyRect) {
      var paintRect = el.getPaintRect();
      if (!repaintRect || paintRect && paintRect.intersect(repaintRect)) {
        brush$1(ctx, el, scope, isLast);
        el.setPrevPaintRect(paintRect);
      }
    } else {
      brush$1(ctx, el, scope, isLast);
    }
  };
  CanvasPainter2.prototype.getLayer = function(zlevel, virtual) {
    if (this._singleCanvas && !this._needsManuallyCompositing) {
      zlevel = CANVAS_ZLEVEL;
    }
    var layer = this._layers[zlevel];
    if (!layer) {
      layer = new Layer$1("zr_" + zlevel, this, this.dpr);
      layer.zlevel = zlevel;
      layer.__builtin__ = true;
      if (this._layerConfig[zlevel]) {
        merge(layer, this._layerConfig[zlevel], true);
      } else if (this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC]) {
        merge(layer, this._layerConfig[zlevel - EL_AFTER_INCREMENTAL_INC], true);
      }
      if (virtual) {
        layer.virtual = virtual;
      }
      this.insertLayer(zlevel, layer);
      layer.initContext();
    }
    return layer;
  };
  CanvasPainter2.prototype.insertLayer = function(zlevel, layer) {
    var layersMap = this._layers;
    var zlevelList = this._zlevelList;
    var len2 = zlevelList.length;
    var domRoot = this._domRoot;
    var prevLayer = null;
    var i = -1;
    if (layersMap[zlevel]) {
      return;
    }
    if (!isLayerValid(layer)) {
      return;
    }
    if (len2 > 0 && zlevel > zlevelList[0]) {
      for (i = 0; i < len2 - 1; i++) {
        if (zlevelList[i] < zlevel && zlevelList[i + 1] > zlevel) {
          break;
        }
      }
      prevLayer = layersMap[zlevelList[i]];
    }
    zlevelList.splice(i + 1, 0, zlevel);
    layersMap[zlevel] = layer;
    if (!layer.virtual) {
      if (prevLayer) {
        var prevDom = prevLayer.dom;
        if (prevDom.nextSibling) {
          domRoot.insertBefore(layer.dom, prevDom.nextSibling);
        } else {
          domRoot.appendChild(layer.dom);
        }
      } else {
        if (domRoot.firstChild) {
          domRoot.insertBefore(layer.dom, domRoot.firstChild);
        } else {
          domRoot.appendChild(layer.dom);
        }
      }
    }
    layer.__painter = this;
  };
  CanvasPainter2.prototype.eachLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      cb.call(context, this._layers[z2], z2);
    }
  };
  CanvasPainter2.prototype.eachBuiltinLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (layer.__builtin__) {
        cb.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.eachOtherLayer = function(cb, context) {
    var zlevelList = this._zlevelList;
    for (var i = 0; i < zlevelList.length; i++) {
      var z2 = zlevelList[i];
      var layer = this._layers[z2];
      if (!layer.__builtin__) {
        cb.call(context, layer, z2);
      }
    }
  };
  CanvasPainter2.prototype.getLayers = function() {
    return this._layers;
  };
  CanvasPainter2.prototype._updateLayerStatus = function(list) {
    this.eachBuiltinLayer(function(layer2, z2) {
      layer2.__dirty = layer2.__used = false;
    });
    function updatePrevLayer(idx) {
      if (prevLayer) {
        if (prevLayer.__endIndex !== idx) {
          prevLayer.__dirty = true;
        }
        prevLayer.__endIndex = idx;
      }
    }
    if (this._singleCanvas) {
      for (var i_1 = 1; i_1 < list.length; i_1++) {
        var el = list[i_1];
        if (el.zlevel !== list[i_1 - 1].zlevel || el.incremental) {
          this._needsManuallyCompositing = true;
          break;
        }
      }
    }
    var prevLayer = null;
    var incrementalLayerCount = 0;
    var prevZlevel;
    var i;
    for (i = 0; i < list.length; i++) {
      var el = list[i];
      var zlevel = el.zlevel;
      var layer = void 0;
      if (prevZlevel !== zlevel) {
        prevZlevel = zlevel;
        incrementalLayerCount = 0;
      }
      if (el.incremental) {
        layer = this.getLayer(zlevel + INCREMENTAL_INC, this._needsManuallyCompositing);
        layer.incremental = true;
        incrementalLayerCount = 1;
      } else {
        layer = this.getLayer(zlevel + (incrementalLayerCount > 0 ? EL_AFTER_INCREMENTAL_INC : 0), this._needsManuallyCompositing);
      }
      if (!layer.__builtin__) {
        logError("ZLevel " + zlevel + " has been used by unkown layer " + layer.id);
      }
      if (layer !== prevLayer) {
        layer.__used = true;
        if (layer.__startIndex !== i) {
          layer.__dirty = true;
        }
        layer.__startIndex = i;
        if (!layer.incremental) {
          layer.__drawIndex = i;
        } else {
          layer.__drawIndex = -1;
        }
        updatePrevLayer(i);
        prevLayer = layer;
      }
      if (el.__dirty & REDRAW_BIT && !el.__inHover) {
        layer.__dirty = true;
        if (layer.incremental && layer.__drawIndex < 0) {
          layer.__drawIndex = i;
        }
      }
    }
    updatePrevLayer(i);
    this.eachBuiltinLayer(function(layer2, z2) {
      if (!layer2.__used && layer2.getElementCount() > 0) {
        layer2.__dirty = true;
        layer2.__startIndex = layer2.__endIndex = layer2.__drawIndex = 0;
      }
      if (layer2.__dirty && layer2.__drawIndex < 0) {
        layer2.__drawIndex = layer2.__startIndex;
      }
    });
  };
  CanvasPainter2.prototype.clear = function() {
    this.eachBuiltinLayer(this._clearLayer);
    return this;
  };
  CanvasPainter2.prototype._clearLayer = function(layer) {
    layer.clear();
  };
  CanvasPainter2.prototype.setBackgroundColor = function(backgroundColor2) {
    this._backgroundColor = backgroundColor2;
    each$f(this._layers, function(layer) {
      layer.setUnpainted();
    });
  };
  CanvasPainter2.prototype.configLayer = function(zlevel, config) {
    if (config) {
      var layerConfig = this._layerConfig;
      if (!layerConfig[zlevel]) {
        layerConfig[zlevel] = config;
      } else {
        merge(layerConfig[zlevel], config, true);
      }
      for (var i = 0; i < this._zlevelList.length; i++) {
        var _zlevel = this._zlevelList[i];
        if (_zlevel === zlevel || _zlevel === zlevel + EL_AFTER_INCREMENTAL_INC) {
          var layer = this._layers[_zlevel];
          merge(layer, layerConfig[zlevel], true);
        }
      }
    }
  };
  CanvasPainter2.prototype.delLayer = function(zlevel) {
    var layers = this._layers;
    var zlevelList = this._zlevelList;
    var layer = layers[zlevel];
    if (!layer) {
      return;
    }
    layer.dom.parentNode.removeChild(layer.dom);
    delete layers[zlevel];
    zlevelList.splice(indexOf(zlevelList, zlevel), 1);
  };
  CanvasPainter2.prototype.resize = function(width, height) {
    if (!this._domRoot.style) {
      if (width == null || height == null) {
        return;
      }
      this._width = width;
      this._height = height;
      this.getLayer(CANVAS_ZLEVEL).resize(width, height);
    } else {
      var domRoot = this._domRoot;
      domRoot.style.display = "none";
      var opts = this._opts;
      var root2 = this.root;
      width != null && (opts.width = width);
      height != null && (opts.height = height);
      width = getSize$1(root2, 0, opts);
      height = getSize$1(root2, 1, opts);
      domRoot.style.display = "";
      if (this._width !== width || height !== this._height) {
        domRoot.style.width = width + "px";
        domRoot.style.height = height + "px";
        for (var id2 in this._layers) {
          if (this._layers.hasOwnProperty(id2)) {
            this._layers[id2].resize(width, height);
          }
        }
        this.refresh(true);
      }
      this._width = width;
      this._height = height;
    }
    return this;
  };
  CanvasPainter2.prototype.clearLayer = function(zlevel) {
    var layer = this._layers[zlevel];
    if (layer) {
      layer.clear();
    }
  };
  CanvasPainter2.prototype.dispose = function() {
    this.root.innerHTML = "";
    this.root = this.storage = this._domRoot = this._layers = null;
  };
  CanvasPainter2.prototype.getRenderedCanvas = function(opts) {
    opts = opts || {};
    if (this._singleCanvas && !this._compositeManually) {
      return this._layers[CANVAS_ZLEVEL].dom;
    }
    var imageLayer = new Layer$1("image", this, opts.pixelRatio || this.dpr);
    imageLayer.initContext();
    imageLayer.clear(false, opts.backgroundColor || this._backgroundColor);
    var ctx = imageLayer.ctx;
    if (opts.pixelRatio <= this.dpr) {
      this.refresh();
      var width_1 = imageLayer.dom.width;
      var height_1 = imageLayer.dom.height;
      this.eachLayer(function(layer) {
        if (layer.__builtin__) {
          ctx.drawImage(layer.dom, 0, 0, width_1, height_1);
        } else if (layer.renderToCanvas) {
          ctx.save();
          layer.renderToCanvas(ctx);
          ctx.restore();
        }
      });
    } else {
      var scope = {
        inHover: false,
        viewWidth: this._width,
        viewHeight: this._height
      };
      var displayList = this.storage.getDisplayList(true);
      for (var i = 0, len2 = displayList.length; i < len2; i++) {
        var el = displayList[i];
        brush$1(ctx, el, scope, i === len2 - 1);
      }
    }
    return imageLayer.dom;
  };
  CanvasPainter2.prototype.getWidth = function() {
    return this._width;
  };
  CanvasPainter2.prototype.getHeight = function() {
    return this._height;
  };
  return CanvasPainter2;
}();
var CanvasPainter$1 = CanvasPainter;
function install$R(registers) {
  registers.registerPainter("canvas", CanvasPainter$1);
}
var LineSeriesModel = function(_super) {
  __extends(LineSeriesModel2, _super);
  function LineSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LineSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  LineSeriesModel2.prototype.getInitialData = function(option) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  LineSeriesModel2.prototype.getLegendIcon = function(opt) {
    var group = new Group$4();
    var line = createSymbol$1("line", 0, opt.itemHeight / 2, opt.itemWidth, 0, opt.lineStyle.stroke, false);
    group.add(line);
    line.setStyle(opt.lineStyle);
    var visualType = this.getData().getVisual("symbol");
    var visualRotate = this.getData().getVisual("symbolRotate");
    var symbolType = visualType === "none" ? "circle" : visualType;
    var size = opt.itemHeight * 0.8;
    var symbol = createSymbol$1(symbolType, (opt.itemWidth - size) / 2, (opt.itemHeight - size) / 2, size, size, opt.itemStyle.fill);
    group.add(symbol);
    symbol.setStyle(opt.itemStyle);
    var symbolRotate = opt.iconRotate === "inherit" ? visualRotate : opt.iconRotate || 0;
    symbol.rotation = symbolRotate * Math.PI / 180;
    symbol.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
    if (symbolType.indexOf("empty") > -1) {
      symbol.style.stroke = symbol.style.fill;
      symbol.style.fill = "#fff";
      symbol.style.lineWidth = 2;
    }
    return group;
  };
  LineSeriesModel2.type = "series.line";
  LineSeriesModel2.dependencies = ["grid", "polar"];
  LineSeriesModel2.defaultOption = {
    z: 3,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    clip: true,
    label: {
      position: "top"
    },
    endLabel: {
      show: false,
      valueAnimation: true,
      distance: 8
    },
    lineStyle: {
      width: 2,
      type: "solid"
    },
    emphasis: {
      scale: true
    },
    step: false,
    smooth: false,
    smoothMonotone: null,
    symbol: "emptyCircle",
    symbolSize: 4,
    symbolRotate: null,
    showSymbol: true,
    showAllSymbol: "auto",
    connectNulls: false,
    sampling: "none",
    animationEasing: "linear",
    progressive: 0,
    hoverLayerThreshold: Infinity,
    universalTransition: {
      divideShape: "clone"
    },
    triggerLineEvent: false
  };
  return LineSeriesModel2;
}(SeriesModel$1);
var LineSeries = LineSeriesModel;
function getDefaultLabel(data, dataIndex) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  var len2 = labelDims.length;
  if (len2 === 1) {
    var rawVal = retrieveRawValue(data, dataIndex, labelDims[0]);
    return rawVal != null ? rawVal + "" : null;
  } else if (len2) {
    var vals = [];
    for (var i = 0; i < labelDims.length; i++) {
      vals.push(retrieveRawValue(data, dataIndex, labelDims[i]));
    }
    return vals.join(" ");
  }
}
function getDefaultInterpolatedLabel(data, interpolatedValue) {
  var labelDims = data.mapDimensionsAll("defaultedLabel");
  if (!isArray$1(interpolatedValue)) {
    return interpolatedValue + "";
  }
  var vals = [];
  for (var i = 0; i < labelDims.length; i++) {
    var dimIndex = data.getDimensionIndex(labelDims[i]);
    if (dimIndex >= 0) {
      vals.push(interpolatedValue[dimIndex]);
    }
  }
  return vals.join(" ");
}
var Symbol$1 = function(_super) {
  __extends(Symbol2, _super);
  function Symbol2(data, idx, seriesScope, opts) {
    var _this = _super.call(this) || this;
    _this.updateData(data, idx, seriesScope, opts);
    return _this;
  }
  Symbol2.prototype._createSymbol = function(symbolType, data, idx, symbolSize, keepAspect) {
    this.removeAll();
    var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2, null, keepAspect);
    symbolPath.attr({
      z2: 100,
      culling: true,
      scaleX: symbolSize[0] / 2,
      scaleY: symbolSize[1] / 2
    });
    symbolPath.drift = driftSymbol;
    this._symbolType = symbolType;
    this.add(symbolPath);
  };
  Symbol2.prototype.stopSymbolAnimation = function(toLastFrame) {
    this.childAt(0).stopAnimation(null, toLastFrame);
  };
  Symbol2.prototype.getSymbolType = function() {
    return this._symbolType;
  };
  Symbol2.prototype.getSymbolPath = function() {
    return this.childAt(0);
  };
  Symbol2.prototype.highlight = function() {
    enterEmphasis(this.childAt(0));
  };
  Symbol2.prototype.downplay = function() {
    leaveEmphasis(this.childAt(0));
  };
  Symbol2.prototype.setZ = function(zlevel, z2) {
    var symbolPath = this.childAt(0);
    symbolPath.zlevel = zlevel;
    symbolPath.z = z2;
  };
  Symbol2.prototype.setDraggable = function(draggable) {
    var symbolPath = this.childAt(0);
    symbolPath.draggable = draggable;
    symbolPath.cursor = draggable ? "move" : symbolPath.cursor;
  };
  Symbol2.prototype.updateData = function(data, idx, seriesScope, opts) {
    this.silent = false;
    var symbolType = data.getItemVisual(idx, "symbol") || "circle";
    var seriesModel = data.hostModel;
    var symbolSize = Symbol2.getSymbolSize(data, idx);
    var isInit = symbolType !== this._symbolType;
    var disableAnimation = opts && opts.disableAnimation;
    if (isInit) {
      var keepAspect = data.getItemVisual(idx, "symbolKeepAspect");
      this._createSymbol(symbolType, data, idx, symbolSize, keepAspect);
    } else {
      var symbolPath = this.childAt(0);
      symbolPath.silent = false;
      var target = {
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2
      };
      disableAnimation ? symbolPath.attr(target) : updateProps$1(symbolPath, target, seriesModel, idx);
      saveOldStyle(symbolPath);
    }
    this._updateCommon(data, idx, symbolSize, seriesScope, opts);
    if (isInit) {
      var symbolPath = this.childAt(0);
      if (!disableAnimation) {
        var target = {
          scaleX: this._sizeX,
          scaleY: this._sizeY,
          style: {
            opacity: symbolPath.style.opacity
          }
        };
        symbolPath.scaleX = symbolPath.scaleY = 0;
        symbolPath.style.opacity = 0;
        initProps(symbolPath, target, seriesModel, idx);
      }
    }
    if (disableAnimation) {
      this.childAt(0).stopAnimation("leave");
    }
  };
  Symbol2.prototype._updateCommon = function(data, idx, symbolSize, seriesScope, opts) {
    var symbolPath = this.childAt(0);
    var seriesModel = data.hostModel;
    var emphasisItemStyle;
    var blurItemStyle;
    var selectItemStyle;
    var focus;
    var blurScope;
    var emphasisDisabled;
    var labelStatesModels;
    var hoverScale;
    var cursorStyle;
    if (seriesScope) {
      emphasisItemStyle = seriesScope.emphasisItemStyle;
      blurItemStyle = seriesScope.blurItemStyle;
      selectItemStyle = seriesScope.selectItemStyle;
      focus = seriesScope.focus;
      blurScope = seriesScope.blurScope;
      labelStatesModels = seriesScope.labelStatesModels;
      hoverScale = seriesScope.hoverScale;
      cursorStyle = seriesScope.cursorStyle;
      emphasisDisabled = seriesScope.emphasisDisabled;
    }
    if (!seriesScope || data.hasItemOption) {
      var itemModel = seriesScope && seriesScope.itemModel ? seriesScope.itemModel : data.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisItemStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      selectItemStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
      blurItemStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      emphasisDisabled = emphasisModel.get("disabled");
      labelStatesModels = getLabelStatesModels(itemModel);
      hoverScale = emphasisModel.getShallow("scale");
      cursorStyle = itemModel.getShallow("cursor");
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    symbolPath.attr("rotation", (symbolRotate || 0) * Math.PI / 180 || 0);
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      symbolPath.x = symbolOffset[0];
      symbolPath.y = symbolOffset[1];
    }
    cursorStyle && symbolPath.attr("cursor", cursorStyle);
    var symbolStyle = data.getItemVisual(idx, "style");
    var visualColor = symbolStyle.fill;
    if (symbolPath instanceof ZRImage$1) {
      var pathStyle = symbolPath.style;
      symbolPath.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolStyle));
    } else {
      if (symbolPath.__isEmptyBrush) {
        symbolPath.useStyle(extend({}, symbolStyle));
      } else {
        symbolPath.useStyle(symbolStyle);
      }
      symbolPath.style.decal = null;
      symbolPath.setColor(visualColor, opts && opts.symbolInnerColor);
      symbolPath.style.strokeNoScale = true;
    }
    var liftZ = data.getItemVisual(idx, "liftZ");
    var z2Origin = this._z2;
    if (liftZ != null) {
      if (z2Origin == null) {
        this._z2 = symbolPath.z2;
        symbolPath.z2 += liftZ;
      }
    } else if (z2Origin != null) {
      symbolPath.z2 = z2Origin;
      this._z2 = null;
    }
    var useNameLabel = opts && opts.useNameLabel;
    setLabelStyle(symbolPath, labelStatesModels, {
      labelFetcher: seriesModel,
      labelDataIndex: idx,
      defaultText: getLabelDefaultText,
      inheritColor: visualColor,
      defaultOpacity: symbolStyle.opacity
    });
    function getLabelDefaultText(idx2) {
      return useNameLabel ? data.getName(idx2) : getDefaultLabel(data, idx2);
    }
    this._sizeX = symbolSize[0] / 2;
    this._sizeY = symbolSize[1] / 2;
    var emphasisState = symbolPath.ensureState("emphasis");
    emphasisState.style = emphasisItemStyle;
    symbolPath.ensureState("select").style = selectItemStyle;
    symbolPath.ensureState("blur").style = blurItemStyle;
    if (hoverScale) {
      var scaleRatio = Math.max(1.1, 3 / this._sizeY);
      emphasisState.scaleX = this._sizeX * scaleRatio;
      emphasisState.scaleY = this._sizeY * scaleRatio;
    }
    this.setSymbolScale(1);
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Symbol2.prototype.setSymbolScale = function(scale2) {
    this.scaleX = this.scaleY = scale2;
  };
  Symbol2.prototype.fadeOut = function(cb, seriesModel, opt) {
    var symbolPath = this.childAt(0);
    var dataIndex = getECData(this).dataIndex;
    var animationOpt = opt && opt.animation;
    this.silent = symbolPath.silent = true;
    if (opt && opt.fadeLabel) {
      var textContent = symbolPath.getTextContent();
      if (textContent) {
        removeElement(textContent, {
          style: {
            opacity: 0
          }
        }, seriesModel, {
          dataIndex,
          removeOpt: animationOpt,
          cb: function() {
            symbolPath.removeTextContent();
          }
        });
      }
    } else {
      symbolPath.removeTextContent();
    }
    removeElement(symbolPath, {
      style: {
        opacity: 0
      },
      scaleX: 0,
      scaleY: 0
    }, seriesModel, {
      dataIndex,
      cb,
      removeOpt: animationOpt
    });
  };
  Symbol2.getSymbolSize = function(data, idx) {
    return normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
  };
  return Symbol2;
}(Group$4);
function driftSymbol(dx, dy) {
  this.parent.drift(dx, dy);
}
var SymbolClz = Symbol$1;
function symbolNeedsDraw$1(data, point, idx, opt) {
  return point && !isNaN(point[0]) && !isNaN(point[1]) && !(opt.isIgnore && opt.isIgnore(idx)) && !(opt.clipShape && !opt.clipShape.contain(point[0], point[1])) && data.getItemVisual(idx, "symbol") !== "none";
}
function normalizeUpdateOpt(opt) {
  if (opt != null && !isObject$4(opt)) {
    opt = {
      isIgnore: opt
    };
  }
  return opt || {};
}
function makeSeriesScope$2(data) {
  var seriesModel = data.hostModel;
  var emphasisModel = seriesModel.getModel("emphasis");
  return {
    emphasisItemStyle: emphasisModel.getModel("itemStyle").getItemStyle(),
    blurItemStyle: seriesModel.getModel(["blur", "itemStyle"]).getItemStyle(),
    selectItemStyle: seriesModel.getModel(["select", "itemStyle"]).getItemStyle(),
    focus: emphasisModel.get("focus"),
    blurScope: emphasisModel.get("blurScope"),
    emphasisDisabled: emphasisModel.get("disabled"),
    hoverScale: emphasisModel.get("scale"),
    labelStatesModels: getLabelStatesModels(seriesModel),
    cursorStyle: seriesModel.get("cursor")
  };
}
var SymbolDraw = function() {
  function SymbolDraw2(SymbolCtor) {
    this.group = new Group$4();
    this._SymbolCtor = SymbolCtor || SymbolClz;
  }
  SymbolDraw2.prototype.updateData = function(data, opt) {
    this._progressiveEls = null;
    opt = normalizeUpdateOpt(opt);
    var group = this.group;
    var seriesModel = data.hostModel;
    var oldData = this._data;
    var SymbolCtor = this._SymbolCtor;
    var disableAnimation = opt.disableAnimation;
    var seriesScope = makeSeriesScope$2(data);
    var symbolUpdateOpt = {
      disableAnimation
    };
    var getSymbolPoint = opt.getSymbolPoint || function(idx) {
      return data.getItemLayout(idx);
    };
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      var point = getSymbolPoint(newIdx);
      if (symbolNeedsDraw$1(data, point, newIdx, opt)) {
        var symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      var point = getSymbolPoint(newIdx);
      if (!symbolNeedsDraw$1(data, point, newIdx, opt)) {
        group.remove(symbolEl);
        return;
      }
      var newSymbolType = data.getItemVisual(newIdx, "symbol") || "circle";
      var oldSymbolType = symbolEl && symbolEl.getSymbolType && symbolEl.getSymbolType();
      if (!symbolEl || oldSymbolType && oldSymbolType !== newSymbolType) {
        group.remove(symbolEl);
        symbolEl = new SymbolCtor(data, newIdx, seriesScope, symbolUpdateOpt);
        symbolEl.setPosition(point);
      } else {
        symbolEl.updateData(data, newIdx, seriesScope, symbolUpdateOpt);
        var target = {
          x: point[0],
          y: point[1]
        };
        disableAnimation ? symbolEl.attr(target) : updateProps$1(symbolEl, target, seriesModel);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && el.fadeOut(function() {
        group.remove(el);
      }, seriesModel);
    }).execute();
    this._getSymbolPoint = getSymbolPoint;
    this._data = data;
  };
  SymbolDraw2.prototype.updateLayout = function() {
    var _this = this;
    var data = this._data;
    if (data) {
      data.eachItemGraphicEl(function(el, idx) {
        var point = _this._getSymbolPoint(idx);
        el.setPosition(point);
        el.markRedraw();
      });
    }
  };
  SymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._seriesScope = makeSeriesScope$2(data);
    this._data = null;
    this.group.removeAll();
  };
  SymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    this._progressiveEls = [];
    opt = normalizeUpdateOpt(opt);
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var point = data.getItemLayout(idx);
      if (symbolNeedsDraw$1(data, point, idx, opt)) {
        var el = new this._SymbolCtor(data, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        el.setPosition(point);
        this.group.add(el);
        data.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  SymbolDraw2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  SymbolDraw2.prototype.remove = function(enableAnimation) {
    var group = this.group;
    var data = this._data;
    if (data && enableAnimation) {
      data.eachItemGraphicEl(function(el) {
        el.fadeOut(function() {
          group.remove(el);
        }, data.hostModel);
      });
    } else {
      group.removeAll();
    }
  };
  return SymbolDraw2;
}();
var SymbolDraw$1 = SymbolDraw;
function prepareDataCoordInfo(coordSys, data, valueOrigin) {
  var baseAxis = coordSys.getBaseAxis();
  var valueAxis2 = coordSys.getOtherAxis(baseAxis);
  var valueStart = getValueStart(valueAxis2, valueOrigin);
  var baseAxisDim = baseAxis.dim;
  var valueAxisDim = valueAxis2.dim;
  var valueDim = data.mapDimension(valueAxisDim);
  var baseDim = data.mapDimension(baseAxisDim);
  var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
  var dims = map$1(coordSys.dimensions, function(coordDim) {
    return data.mapDimension(coordDim);
  });
  var stacked = false;
  var stackResultDim = data.getCalculationInfo("stackResultDimension");
  if (isDimensionStacked(data, dims[0])) {
    stacked = true;
    dims[0] = stackResultDim;
  }
  if (isDimensionStacked(data, dims[1])) {
    stacked = true;
    dims[1] = stackResultDim;
  }
  return {
    dataDimsForPoint: dims,
    valueStart,
    valueAxisDim,
    baseAxisDim,
    stacked: !!stacked,
    valueDim,
    baseDim,
    baseDataOffset,
    stackedOverDimension: data.getCalculationInfo("stackedOverDimension")
  };
}
function getValueStart(valueAxis2, valueOrigin) {
  var valueStart = 0;
  var extent3 = valueAxis2.scale.getExtent();
  if (valueOrigin === "start") {
    valueStart = extent3[0];
  } else if (valueOrigin === "end") {
    valueStart = extent3[1];
  } else {
    if (extent3[0] > 0) {
      valueStart = extent3[0];
    } else if (extent3[1] < 0) {
      valueStart = extent3[1];
    }
  }
  return valueStart;
}
function getStackedOnPoint(dataCoordInfo, coordSys, data, idx) {
  var value = NaN;
  if (dataCoordInfo.stacked) {
    value = data.get(data.getCalculationInfo("stackedOverDimension"), idx);
  }
  if (isNaN(value)) {
    value = dataCoordInfo.valueStart;
  }
  var baseDataOffset = dataCoordInfo.baseDataOffset;
  var stackedData = [];
  stackedData[baseDataOffset] = data.get(dataCoordInfo.baseDim, idx);
  stackedData[1 - baseDataOffset] = value;
  return coordSys.dataToPoint(stackedData);
}
function diffData(oldData, newData) {
  var diffResult = [];
  newData.diff(oldData).add(function(idx) {
    diffResult.push({
      cmd: "+",
      idx
    });
  }).update(function(newIdx, oldIdx) {
    diffResult.push({
      cmd: "=",
      idx: oldIdx,
      idx1: newIdx
    });
  }).remove(function(idx) {
    diffResult.push({
      cmd: "-",
      idx
    });
  }).execute();
  return diffResult;
}
function lineAnimationDiff(oldData, newData, oldStackedOnPoints, newStackedOnPoints, oldCoordSys, newCoordSys, oldValueOrigin, newValueOrigin) {
  var diff = diffData(oldData, newData);
  var currPoints = [];
  var nextPoints = [];
  var currStackedPoints = [];
  var nextStackedPoints = [];
  var status = [];
  var sortedIndices = [];
  var rawIndices = [];
  var newDataOldCoordInfo = prepareDataCoordInfo(oldCoordSys, newData, oldValueOrigin);
  var oldPoints = oldData.getLayout("points") || [];
  var newPoints = newData.getLayout("points") || [];
  for (var i = 0; i < diff.length; i++) {
    var diffItem = diff[i];
    var pointAdded = true;
    var oldIdx2 = void 0;
    var newIdx2 = void 0;
    switch (diffItem.cmd) {
      case "=":
        oldIdx2 = diffItem.idx * 2;
        newIdx2 = diffItem.idx1 * 2;
        var currentX = oldPoints[oldIdx2];
        var currentY = oldPoints[oldIdx2 + 1];
        var nextX = newPoints[newIdx2];
        var nextY = newPoints[newIdx2 + 1];
        if (isNaN(currentX) || isNaN(currentY)) {
          currentX = nextX;
          currentY = nextY;
        }
        currPoints.push(currentX, currentY);
        nextPoints.push(nextX, nextY);
        currStackedPoints.push(oldStackedOnPoints[oldIdx2], oldStackedOnPoints[oldIdx2 + 1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(diffItem.idx1));
        break;
      case "+":
        var newIdx = diffItem.idx;
        var newDataDimsForPoint = newDataOldCoordInfo.dataDimsForPoint;
        var oldPt = oldCoordSys.dataToPoint([newData.get(newDataDimsForPoint[0], newIdx), newData.get(newDataDimsForPoint[1], newIdx)]);
        newIdx2 = newIdx * 2;
        currPoints.push(oldPt[0], oldPt[1]);
        nextPoints.push(newPoints[newIdx2], newPoints[newIdx2 + 1]);
        var stackedOnPoint = getStackedOnPoint(newDataOldCoordInfo, oldCoordSys, newData, newIdx);
        currStackedPoints.push(stackedOnPoint[0], stackedOnPoint[1]);
        nextStackedPoints.push(newStackedOnPoints[newIdx2], newStackedOnPoints[newIdx2 + 1]);
        rawIndices.push(newData.getRawIndex(newIdx));
        break;
      case "-":
        pointAdded = false;
    }
    if (pointAdded) {
      status.push(diffItem);
      sortedIndices.push(sortedIndices.length);
    }
  }
  sortedIndices.sort(function(a, b2) {
    return rawIndices[a] - rawIndices[b2];
  });
  var len2 = currPoints.length;
  var sortedCurrPoints = createFloat32Array(len2);
  var sortedNextPoints = createFloat32Array(len2);
  var sortedCurrStackedPoints = createFloat32Array(len2);
  var sortedNextStackedPoints = createFloat32Array(len2);
  var sortedStatus = [];
  for (var i = 0; i < sortedIndices.length; i++) {
    var idx = sortedIndices[i];
    var i2 = i * 2;
    var idx2 = idx * 2;
    sortedCurrPoints[i2] = currPoints[idx2];
    sortedCurrPoints[i2 + 1] = currPoints[idx2 + 1];
    sortedNextPoints[i2] = nextPoints[idx2];
    sortedNextPoints[i2 + 1] = nextPoints[idx2 + 1];
    sortedCurrStackedPoints[i2] = currStackedPoints[idx2];
    sortedCurrStackedPoints[i2 + 1] = currStackedPoints[idx2 + 1];
    sortedNextStackedPoints[i2] = nextStackedPoints[idx2];
    sortedNextStackedPoints[i2 + 1] = nextStackedPoints[idx2 + 1];
    sortedStatus[i] = status[idx];
  }
  return {
    current: sortedCurrPoints,
    next: sortedNextPoints,
    stackedOnCurrent: sortedCurrStackedPoints,
    stackedOnNext: sortedNextStackedPoints,
    status: sortedStatus
  };
}
var mathMin$5 = Math.min;
var mathMax$5 = Math.max;
function isPointNull$1(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function drawSegment(ctx, points2, start2, segLen, allLen, dir3, smooth, smoothMonotone, connectNulls) {
  var prevX;
  var prevY;
  var cpx0;
  var cpy0;
  var cpx1;
  var cpy1;
  var idx = start2;
  var k2 = 0;
  for (; k2 < segLen; k2++) {
    var x2 = points2[idx * 2];
    var y2 = points2[idx * 2 + 1];
    if (idx >= allLen || idx < 0) {
      break;
    }
    if (isPointNull$1(x2, y2)) {
      if (connectNulls) {
        idx += dir3;
        continue;
      }
      break;
    }
    if (idx === start2) {
      ctx[dir3 > 0 ? "moveTo" : "lineTo"](x2, y2);
      cpx0 = x2;
      cpy0 = y2;
    } else {
      var dx = x2 - prevX;
      var dy = y2 - prevY;
      if (dx * dx + dy * dy < 0.5) {
        idx += dir3;
        continue;
      }
      if (smooth > 0) {
        var nextIdx = idx + dir3;
        var nextX = points2[nextIdx * 2];
        var nextY = points2[nextIdx * 2 + 1];
        while (nextX === x2 && nextY === y2 && k2 < segLen) {
          k2++;
          nextIdx += dir3;
          idx += dir3;
          nextX = points2[nextIdx * 2];
          nextY = points2[nextIdx * 2 + 1];
          x2 = points2[idx * 2];
          y2 = points2[idx * 2 + 1];
          dx = x2 - prevX;
          dy = y2 - prevY;
        }
        var tmpK = k2 + 1;
        if (connectNulls) {
          while (isPointNull$1(nextX, nextY) && tmpK < segLen) {
            tmpK++;
            nextIdx += dir3;
            nextX = points2[nextIdx * 2];
            nextY = points2[nextIdx * 2 + 1];
          }
        }
        var ratioNextSeg = 0.5;
        var vx = 0;
        var vy = 0;
        var nextCpx0 = void 0;
        var nextCpy0 = void 0;
        if (tmpK >= segLen || isPointNull$1(nextX, nextY)) {
          cpx1 = x2;
          cpy1 = y2;
        } else {
          vx = nextX - prevX;
          vy = nextY - prevY;
          var dx0 = x2 - prevX;
          var dx1 = nextX - x2;
          var dy0 = y2 - prevY;
          var dy1 = nextY - y2;
          var lenPrevSeg = void 0;
          var lenNextSeg = void 0;
          if (smoothMonotone === "x") {
            lenPrevSeg = Math.abs(dx0);
            lenNextSeg = Math.abs(dx1);
            var dir_1 = vx > 0 ? 1 : -1;
            cpx1 = x2 - dir_1 * lenPrevSeg * smooth;
            cpy1 = y2;
            nextCpx0 = x2 + dir_1 * lenNextSeg * smooth;
            nextCpy0 = y2;
          } else if (smoothMonotone === "y") {
            lenPrevSeg = Math.abs(dy0);
            lenNextSeg = Math.abs(dy1);
            var dir_2 = vy > 0 ? 1 : -1;
            cpx1 = x2;
            cpy1 = y2 - dir_2 * lenPrevSeg * smooth;
            nextCpx0 = x2;
            nextCpy0 = y2 + dir_2 * lenNextSeg * smooth;
          } else {
            lenPrevSeg = Math.sqrt(dx0 * dx0 + dy0 * dy0);
            lenNextSeg = Math.sqrt(dx1 * dx1 + dy1 * dy1);
            ratioNextSeg = lenNextSeg / (lenNextSeg + lenPrevSeg);
            cpx1 = x2 - vx * smooth * (1 - ratioNextSeg);
            cpy1 = y2 - vy * smooth * (1 - ratioNextSeg);
            nextCpx0 = x2 + vx * smooth * ratioNextSeg;
            nextCpy0 = y2 + vy * smooth * ratioNextSeg;
            nextCpx0 = mathMin$5(nextCpx0, mathMax$5(nextX, x2));
            nextCpy0 = mathMin$5(nextCpy0, mathMax$5(nextY, y2));
            nextCpx0 = mathMax$5(nextCpx0, mathMin$5(nextX, x2));
            nextCpy0 = mathMax$5(nextCpy0, mathMin$5(nextY, y2));
            vx = nextCpx0 - x2;
            vy = nextCpy0 - y2;
            cpx1 = x2 - vx * lenPrevSeg / lenNextSeg;
            cpy1 = y2 - vy * lenPrevSeg / lenNextSeg;
            cpx1 = mathMin$5(cpx1, mathMax$5(prevX, x2));
            cpy1 = mathMin$5(cpy1, mathMax$5(prevY, y2));
            cpx1 = mathMax$5(cpx1, mathMin$5(prevX, x2));
            cpy1 = mathMax$5(cpy1, mathMin$5(prevY, y2));
            vx = x2 - cpx1;
            vy = y2 - cpy1;
            nextCpx0 = x2 + vx * lenNextSeg / lenPrevSeg;
            nextCpy0 = y2 + vy * lenNextSeg / lenPrevSeg;
          }
        }
        ctx.bezierCurveTo(cpx0, cpy0, cpx1, cpy1, x2, y2);
        cpx0 = nextCpx0;
        cpy0 = nextCpy0;
      } else {
        ctx.lineTo(x2, y2);
      }
    }
    prevX = x2;
    prevY = y2;
    idx += dir3;
  }
  return k2;
}
var ECPolylineShape = function() {
  function ECPolylineShape2() {
    this.smooth = 0;
    this.smoothConstraint = true;
  }
  return ECPolylineShape2;
}();
var ECPolyline = function(_super) {
  __extends(ECPolyline2, _super);
  function ECPolyline2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polyline";
    return _this;
  }
  ECPolyline2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECPolyline2.prototype.getDefaultShape = function() {
    return new ECPolylineShape();
  };
  ECPolyline2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var i = 0;
    var len2 = points2.length / 2;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      i += drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, shape.smoothMonotone, shape.connectNulls) + 1;
    }
  };
  ECPolyline2.prototype.getPointOn = function(xOrY, dim) {
    if (!this.path) {
      this.createPathProxy();
      this.buildPath(this.path, this.shape);
    }
    var path = this.path;
    var data = path.data;
    var CMD2 = PathProxy$1.CMD;
    var x0;
    var y0;
    var isDimX = dim === "x";
    var roots2 = [];
    for (var i = 0; i < data.length; ) {
      var cmd = data[i++];
      var x2 = void 0;
      var y2 = void 0;
      var x22 = void 0;
      var y22 = void 0;
      var x3 = void 0;
      var y3 = void 0;
      var t2 = void 0;
      switch (cmd) {
        case CMD2.M:
          x0 = data[i++];
          y0 = data[i++];
          break;
        case CMD2.L:
          x2 = data[i++];
          y2 = data[i++];
          t2 = isDimX ? (xOrY - x0) / (x2 - x0) : (xOrY - y0) / (y2 - y0);
          if (t2 <= 1 && t2 >= 0) {
            var val = isDimX ? (y2 - y0) * t2 + y0 : (x2 - x0) * t2 + x0;
            return isDimX ? [xOrY, val] : [val, xOrY];
          }
          x0 = x2;
          y0 = y2;
          break;
        case CMD2.C:
          x2 = data[i++];
          y2 = data[i++];
          x22 = data[i++];
          y22 = data[i++];
          x3 = data[i++];
          y3 = data[i++];
          var nRoot = isDimX ? cubicRootAt(x0, x2, x22, x3, xOrY, roots2) : cubicRootAt(y0, y2, y22, y3, xOrY, roots2);
          if (nRoot > 0) {
            for (var i_1 = 0; i_1 < nRoot; i_1++) {
              var t_1 = roots2[i_1];
              if (t_1 <= 1 && t_1 >= 0) {
                var val = isDimX ? cubicAt(y0, y2, y22, y3, t_1) : cubicAt(x0, x2, x22, x3, t_1);
                return isDimX ? [xOrY, val] : [val, xOrY];
              }
            }
          }
          x0 = x3;
          y0 = y3;
          break;
      }
    }
  };
  return ECPolyline2;
}(Path$1);
var ECPolygonShape = function(_super) {
  __extends(ECPolygonShape2, _super);
  function ECPolygonShape2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return ECPolygonShape2;
}(ECPolylineShape);
var ECPolygon = function(_super) {
  __extends(ECPolygon2, _super);
  function ECPolygon2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-polygon";
    return _this;
  }
  ECPolygon2.prototype.getDefaultShape = function() {
    return new ECPolygonShape();
  };
  ECPolygon2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var stackedOnPoints = shape.stackedOnPoints;
    var i = 0;
    var len2 = points2.length / 2;
    var smoothMonotone = shape.smoothMonotone;
    if (shape.connectNulls) {
      for (; len2 > 0; len2--) {
        if (!isPointNull$1(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
          break;
        }
      }
      for (; i < len2; i++) {
        if (!isPointNull$1(points2[i * 2], points2[i * 2 + 1])) {
          break;
        }
      }
    }
    while (i < len2) {
      var k2 = drawSegment(ctx, points2, i, len2, len2, 1, shape.smooth, smoothMonotone, shape.connectNulls);
      drawSegment(ctx, stackedOnPoints, i + k2 - 1, k2, len2, -1, shape.stackedOnSmooth, smoothMonotone, shape.connectNulls);
      i += k2 + 1;
      ctx.closePath();
    }
  };
  return ECPolygon2;
}(Path$1);
function createGridClipPath(cartesian, hasAnimation, seriesModel, done, during) {
  var rect = cartesian.getArea();
  var x2 = rect.x;
  var y2 = rect.y;
  var width = rect.width;
  var height = rect.height;
  var lineWidth = seriesModel.get(["lineStyle", "width"]) || 2;
  x2 -= lineWidth / 2;
  y2 -= lineWidth / 2;
  width += lineWidth;
  height += lineWidth;
  x2 = Math.floor(x2);
  width = Math.round(width);
  var clipPath = new Rect$3({
    shape: {
      x: x2,
      y: y2,
      width,
      height
    }
  });
  if (hasAnimation) {
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var isAxisInversed = baseAxis.inverse;
    if (isHorizontal) {
      if (isAxisInversed) {
        clipPath.shape.x += width;
      }
      clipPath.shape.width = 0;
    } else {
      if (!isAxisInversed) {
        clipPath.shape.y += height;
      }
      clipPath.shape.height = 0;
    }
    var duringCb = isFunction(during) ? function(percent) {
      during(percent, clipPath);
    } : null;
    initProps(clipPath, {
      shape: {
        width,
        height,
        x: x2,
        y: y2
      }
    }, seriesModel, null, done, duringCb);
  }
  return clipPath;
}
function createPolarClipPath(polar, hasAnimation, seriesModel) {
  var sectorArea = polar.getArea();
  var r0 = round$3(sectorArea.r0, 1);
  var r2 = round$3(sectorArea.r, 1);
  var clipPath = new Sector$1({
    shape: {
      cx: round$3(polar.cx, 1),
      cy: round$3(polar.cy, 1),
      r0,
      r: r2,
      startAngle: sectorArea.startAngle,
      endAngle: sectorArea.endAngle,
      clockwise: sectorArea.clockwise
    }
  });
  if (hasAnimation) {
    var isRadial = polar.getBaseAxis().dim === "angle";
    if (isRadial) {
      clipPath.shape.endAngle = sectorArea.startAngle;
    } else {
      clipPath.shape.r = r0;
    }
    initProps(clipPath, {
      shape: {
        endAngle: sectorArea.endAngle,
        r: r2
      }
    }, seriesModel);
  }
  return clipPath;
}
function createClipPath(coordSys, hasAnimation, seriesModel, done, during) {
  if (!coordSys) {
    return null;
  } else if (coordSys.type === "polar") {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  } else if (coordSys.type === "cartesian2d") {
    return createGridClipPath(coordSys, hasAnimation, seriesModel, done, during);
  }
  return null;
}
function isCoordinateSystemType(coordSys, type4) {
  return coordSys.type === type4;
}
function isPointsSame(points1, points2) {
  if (points1.length !== points2.length) {
    return;
  }
  for (var i = 0; i < points1.length; i++) {
    if (points1[i] !== points2[i]) {
      return;
    }
  }
  return true;
}
function bboxFromPoints(points2) {
  var minX = Infinity;
  var minY = Infinity;
  var maxX = -Infinity;
  var maxY = -Infinity;
  for (var i = 0; i < points2.length; ) {
    var x2 = points2[i++];
    var y2 = points2[i++];
    if (!isNaN(x2)) {
      minX = Math.min(x2, minX);
      maxX = Math.max(x2, maxX);
    }
    if (!isNaN(y2)) {
      minY = Math.min(y2, minY);
      maxY = Math.max(y2, maxY);
    }
  }
  return [[minX, minY], [maxX, maxY]];
}
function getBoundingDiff(points1, points2) {
  var _a2 = bboxFromPoints(points1), min1 = _a2[0], max1 = _a2[1];
  var _b2 = bboxFromPoints(points2), min22 = _b2[0], max22 = _b2[1];
  return Math.max(Math.abs(min1[0] - min22[0]), Math.abs(min1[1] - min22[1]), Math.abs(max1[0] - max22[0]), Math.abs(max1[1] - max22[1]));
}
function getSmooth(smooth) {
  return isNumber(smooth) ? smooth : smooth ? 0.5 : 0;
}
function getStackedOnPoints(coordSys, data, dataCoordInfo) {
  if (!dataCoordInfo.valueDim) {
    return [];
  }
  var len2 = data.count();
  var points2 = createFloat32Array(len2 * 2);
  for (var idx = 0; idx < len2; idx++) {
    var pt = getStackedOnPoint(dataCoordInfo, coordSys, data, idx);
    points2[idx * 2] = pt[0];
    points2[idx * 2 + 1] = pt[1];
  }
  return points2;
}
function turnPointsIntoStep(points2, coordSys, stepTurnAt, connectNulls) {
  var baseAxis = coordSys.getBaseAxis();
  var baseIndex = baseAxis.dim === "x" || baseAxis.dim === "radius" ? 0 : 1;
  var stepPoints = [];
  var i = 0;
  var stepPt = [];
  var pt = [];
  var nextPt = [];
  var filteredPoints = [];
  if (connectNulls) {
    for (i = 0; i < points2.length; i += 2) {
      if (!isNaN(points2[i]) && !isNaN(points2[i + 1])) {
        filteredPoints.push(points2[i], points2[i + 1]);
      }
    }
    points2 = filteredPoints;
  }
  for (i = 0; i < points2.length - 2; i += 2) {
    nextPt[0] = points2[i + 2];
    nextPt[1] = points2[i + 3];
    pt[0] = points2[i];
    pt[1] = points2[i + 1];
    stepPoints.push(pt[0], pt[1]);
    switch (stepTurnAt) {
      case "end":
        stepPt[baseIndex] = nextPt[baseIndex];
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        break;
      case "middle":
        var middle = (pt[baseIndex] + nextPt[baseIndex]) / 2;
        var stepPt2 = [];
        stepPt[baseIndex] = stepPt2[baseIndex] = middle;
        stepPt[1 - baseIndex] = pt[1 - baseIndex];
        stepPt2[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
        stepPoints.push(stepPt2[0], stepPt2[1]);
        break;
      default:
        stepPt[baseIndex] = pt[baseIndex];
        stepPt[1 - baseIndex] = nextPt[1 - baseIndex];
        stepPoints.push(stepPt[0], stepPt[1]);
    }
  }
  stepPoints.push(points2[i++], points2[i++]);
  return stepPoints;
}
function clipColorStops(colorStops, maxSize) {
  var newColorStops = [];
  var len2 = colorStops.length;
  var prevOutOfRangeColorStop;
  var prevInRangeColorStop;
  function lerpStop(stop0, stop1, clippedCoord) {
    var coord0 = stop0.coord;
    var p2 = (clippedCoord - coord0) / (stop1.coord - coord0);
    var color = lerp(p2, [stop0.color, stop1.color]);
    return {
      coord: clippedCoord,
      color
    };
  }
  for (var i = 0; i < len2; i++) {
    var stop_1 = colorStops[i];
    var coord = stop_1.coord;
    if (coord < 0) {
      prevOutOfRangeColorStop = stop_1;
    } else if (coord > maxSize) {
      if (prevInRangeColorStop) {
        newColorStops.push(lerpStop(prevInRangeColorStop, stop_1, maxSize));
      } else if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0), lerpStop(prevOutOfRangeColorStop, stop_1, maxSize));
      }
      break;
    } else {
      if (prevOutOfRangeColorStop) {
        newColorStops.push(lerpStop(prevOutOfRangeColorStop, stop_1, 0));
        prevOutOfRangeColorStop = null;
      }
      newColorStops.push(stop_1);
      prevInRangeColorStop = stop_1;
    }
  }
  return newColorStops;
}
function getVisualGradient(data, coordSys, api) {
  var visualMetaList = data.getVisual("visualMeta");
  if (!visualMetaList || !visualMetaList.length || !data.count()) {
    return;
  }
  if (coordSys.type !== "cartesian2d") {
    return;
  }
  var coordDim;
  var visualMeta;
  for (var i = visualMetaList.length - 1; i >= 0; i--) {
    var dimInfo = data.getDimensionInfo(visualMetaList[i].dimension);
    coordDim = dimInfo && dimInfo.coordDim;
    if (coordDim === "x" || coordDim === "y") {
      visualMeta = visualMetaList[i];
      break;
    }
  }
  if (!visualMeta) {
    return;
  }
  var axis = coordSys.getAxis(coordDim);
  var colorStops = map$1(visualMeta.stops, function(stop2) {
    return {
      coord: axis.toGlobalCoord(axis.dataToCoord(stop2.value)),
      color: stop2.color
    };
  });
  var stopLen = colorStops.length;
  var outerColors = visualMeta.outerColors.slice();
  if (stopLen && colorStops[0].coord > colorStops[stopLen - 1].coord) {
    colorStops.reverse();
    outerColors.reverse();
  }
  var colorStopsInRange = clipColorStops(colorStops, coordDim === "x" ? api.getWidth() : api.getHeight());
  var inRangeStopLen = colorStopsInRange.length;
  if (!inRangeStopLen && stopLen) {
    return colorStops[0].coord < 0 ? outerColors[1] ? outerColors[1] : colorStops[stopLen - 1].color : outerColors[0] ? outerColors[0] : colorStops[0].color;
  }
  var tinyExtent = 10;
  var minCoord = colorStopsInRange[0].coord - tinyExtent;
  var maxCoord = colorStopsInRange[inRangeStopLen - 1].coord + tinyExtent;
  var coordSpan = maxCoord - minCoord;
  if (coordSpan < 1e-3) {
    return "transparent";
  }
  each$f(colorStopsInRange, function(stop2) {
    stop2.offset = (stop2.coord - minCoord) / coordSpan;
  });
  colorStopsInRange.push({
    offset: inRangeStopLen ? colorStopsInRange[inRangeStopLen - 1].offset : 0.5,
    color: outerColors[1] || "transparent"
  });
  colorStopsInRange.unshift({
    offset: inRangeStopLen ? colorStopsInRange[0].offset : 0.5,
    color: outerColors[0] || "transparent"
  });
  var gradient = new LinearGradient$1(0, 0, 0, 0, colorStopsInRange, true);
  gradient[coordDim] = minCoord;
  gradient[coordDim + "2"] = maxCoord;
  return gradient;
}
function getIsIgnoreFunc(seriesModel, data, coordSys) {
  var showAllSymbol = seriesModel.get("showAllSymbol");
  var isAuto = showAllSymbol === "auto";
  if (showAllSymbol && !isAuto) {
    return;
  }
  var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
  if (!categoryAxis2) {
    return;
  }
  if (isAuto && canShowAllSymbolForCategory(categoryAxis2, data)) {
    return;
  }
  var categoryDataDim = data.mapDimension(categoryAxis2.dim);
  var labelMap = {};
  each$f(categoryAxis2.getViewLabels(), function(labelItem) {
    var ordinalNumber = categoryAxis2.scale.getRawOrdinalNumber(labelItem.tickValue);
    labelMap[ordinalNumber] = 1;
  });
  return function(dataIndex) {
    return !labelMap.hasOwnProperty(data.get(categoryDataDim, dataIndex));
  };
}
function canShowAllSymbolForCategory(categoryAxis2, data) {
  var axisExtent = categoryAxis2.getExtent();
  var availSize = Math.abs(axisExtent[1] - axisExtent[0]) / categoryAxis2.scale.count();
  isNaN(availSize) && (availSize = 0);
  var dataLen = data.count();
  var step = Math.max(1, Math.round(dataLen / 5));
  for (var dataIndex = 0; dataIndex < dataLen; dataIndex += step) {
    if (SymbolClz.getSymbolSize(data, dataIndex)[categoryAxis2.isHorizontal() ? 1 : 0] * 1.5 > availSize) {
      return false;
    }
  }
  return true;
}
function isPointNull(x2, y2) {
  return isNaN(x2) || isNaN(y2);
}
function getLastIndexNotNull(points2) {
  var len2 = points2.length / 2;
  for (; len2 > 0; len2--) {
    if (!isPointNull(points2[len2 * 2 - 2], points2[len2 * 2 - 1])) {
      break;
    }
  }
  return len2 - 1;
}
function getPointAtIndex(points2, idx) {
  return [points2[idx * 2], points2[idx * 2 + 1]];
}
function getIndexRange(points2, xOrY, dim) {
  var len2 = points2.length / 2;
  var dimIdx = dim === "x" ? 0 : 1;
  var a;
  var b2;
  var prevIndex = 0;
  var nextIndex = -1;
  for (var i = 0; i < len2; i++) {
    b2 = points2[i * 2 + dimIdx];
    if (isNaN(b2) || isNaN(points2[i * 2 + 1 - dimIdx])) {
      continue;
    }
    if (i === 0) {
      a = b2;
      continue;
    }
    if (a <= xOrY && b2 >= xOrY || a >= xOrY && b2 <= xOrY) {
      nextIndex = i;
      break;
    }
    prevIndex = i;
    a = b2;
  }
  return {
    range: [prevIndex, nextIndex],
    t: (xOrY - a) / (b2 - a)
  };
}
function anyStateShowEndLabel(seriesModel) {
  if (seriesModel.get(["endLabel", "show"])) {
    return true;
  }
  for (var i = 0; i < SPECIAL_STATES.length; i++) {
    if (seriesModel.get([SPECIAL_STATES[i], "endLabel", "show"])) {
      return true;
    }
  }
  return false;
}
function createLineClipPath(lineView, coordSys, hasAnimation, seriesModel) {
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    var endLabelModel_1 = seriesModel.getModel("endLabel");
    var valueAnimation_1 = endLabelModel_1.get("valueAnimation");
    var data_1 = seriesModel.getData();
    var labelAnimationRecord_1 = {
      lastFrameIndex: 0
    };
    var during = anyStateShowEndLabel(seriesModel) ? function(percent, clipRect) {
      lineView._endLabelOnDuring(percent, clipRect, data_1, labelAnimationRecord_1, valueAnimation_1, endLabelModel_1, coordSys);
    } : null;
    var isHorizontal = coordSys.getBaseAxis().isHorizontal();
    var clipPath = createGridClipPath(coordSys, hasAnimation, seriesModel, function() {
      var endLabel = lineView._endLabel;
      if (endLabel && hasAnimation) {
        if (labelAnimationRecord_1.originalX != null) {
          endLabel.attr({
            x: labelAnimationRecord_1.originalX,
            y: labelAnimationRecord_1.originalY
          });
        }
      }
    }, during);
    if (!seriesModel.get("clip", true)) {
      var rectShape = clipPath.shape;
      var expandSize = Math.max(rectShape.width, rectShape.height);
      if (isHorizontal) {
        rectShape.y -= expandSize;
        rectShape.height += expandSize * 2;
      } else {
        rectShape.x -= expandSize;
        rectShape.width += expandSize * 2;
      }
    }
    if (during) {
      during(1, clipPath);
    }
    return clipPath;
  } else {
    return createPolarClipPath(coordSys, hasAnimation, seriesModel);
  }
}
function getEndLabelStateSpecified(endLabelModel, coordSys) {
  var baseAxis = coordSys.getBaseAxis();
  var isHorizontal = baseAxis.isHorizontal();
  var isBaseInversed = baseAxis.inverse;
  var align = isHorizontal ? isBaseInversed ? "right" : "left" : "center";
  var verticalAlign = isHorizontal ? "middle" : isBaseInversed ? "top" : "bottom";
  return {
    normal: {
      align: endLabelModel.get("align") || align,
      verticalAlign: endLabelModel.get("verticalAlign") || verticalAlign
    }
  };
}
var LineView = function(_super) {
  __extends(LineView2, _super);
  function LineView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  LineView2.prototype.init = function() {
    var lineGroup = new Group$4();
    var symbolDraw = new SymbolDraw$1();
    this.group.add(symbolDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineGroup = lineGroup;
  };
  LineView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var lineStyleModel = seriesModel.getModel("lineStyle");
    var areaStyleModel = seriesModel.getModel("areaStyle");
    var points2 = data.getLayout("points") || [];
    var isCoordSysPolar = coordSys.type === "polar";
    var prevCoordSys = this._coordSys;
    var symbolDraw = this._symbolDraw;
    var polyline = this._polyline;
    var polygon = this._polygon;
    var lineGroup = this._lineGroup;
    var hasAnimation = seriesModel.get("animation");
    var isAreaChart = !areaStyleModel.isEmpty();
    var valueOrigin = areaStyleModel.get("origin");
    var dataCoordInfo = prepareDataCoordInfo(coordSys, data, valueOrigin);
    var stackedOnPoints = isAreaChart && getStackedOnPoints(coordSys, data, dataCoordInfo);
    var showSymbol = seriesModel.get("showSymbol");
    var connectNulls = seriesModel.get("connectNulls");
    var isIgnoreFunc = showSymbol && !isCoordSysPolar && getIsIgnoreFunc(seriesModel, data, coordSys);
    var oldData = this._data;
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    if (!showSymbol) {
      symbolDraw.remove();
    }
    group.add(lineGroup);
    var step = !isCoordSysPolar ? seriesModel.get("step") : false;
    var clipShapeForSymbol;
    if (coordSys && coordSys.getArea && seriesModel.get("clip", true)) {
      clipShapeForSymbol = coordSys.getArea();
      if (clipShapeForSymbol.width != null) {
        clipShapeForSymbol.x -= 0.1;
        clipShapeForSymbol.y -= 0.1;
        clipShapeForSymbol.width += 0.2;
        clipShapeForSymbol.height += 0.2;
      } else if (clipShapeForSymbol.r0) {
        clipShapeForSymbol.r0 -= 0.5;
        clipShapeForSymbol.r += 0.5;
      }
    }
    this._clipShapeForSymbol = clipShapeForSymbol;
    var visualColor = getVisualGradient(data, coordSys, api) || data.getVisual("style")[data.getVisual("drawType")];
    if (!(polyline && prevCoordSys.type === coordSys.type && step === this._step)) {
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      hasAnimation && this._initSymbolLabelAnimation(data, coordSys, clipShapeForSymbol);
      if (step) {
        points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
        if (stackedOnPoints) {
          stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
        }
      }
      polyline = this._newPolyline(points2);
      if (isAreaChart) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
    } else {
      if (isAreaChart && !polygon) {
        polygon = this._newPolygon(points2, stackedOnPoints);
      } else if (polygon && !isAreaChart) {
        lineGroup.remove(polygon);
        polygon = this._polygon = null;
      }
      if (!isCoordSysPolar) {
        this._initOrUpdateEndLabel(seriesModel, coordSys, convertToColorString(visualColor));
      }
      var oldClipPath = lineGroup.getClipPath();
      if (oldClipPath) {
        var newClipPath = createLineClipPath(this, coordSys, false, seriesModel);
        initProps(oldClipPath, {
          shape: newClipPath.shape
        }, seriesModel);
      } else {
        lineGroup.setClipPath(createLineClipPath(this, coordSys, true, seriesModel));
      }
      showSymbol && symbolDraw.updateData(data, {
        isIgnore: isIgnoreFunc,
        clipShape: clipShapeForSymbol,
        disableAnimation: true,
        getSymbolPoint: function(idx) {
          return [points2[idx * 2], points2[idx * 2 + 1]];
        }
      });
      if (!isPointsSame(this._stackedOnPoints, stackedOnPoints) || !isPointsSame(this._points, points2)) {
        if (hasAnimation) {
          this._doUpdateAnimation(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls);
        } else {
          if (step) {
            points2 = turnPointsIntoStep(points2, coordSys, step, connectNulls);
            if (stackedOnPoints) {
              stackedOnPoints = turnPointsIntoStep(stackedOnPoints, coordSys, step, connectNulls);
            }
          }
          polyline.setShape({
            points: points2
          });
          polygon && polygon.setShape({
            points: points2,
            stackedOnPoints
          });
        }
      }
    }
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    polyline.useStyle(defaults(lineStyleModel.getLineStyle(), {
      fill: "none",
      stroke: visualColor,
      lineJoin: "bevel"
    }));
    setStatesStylesFromModel(polyline, seriesModel, "lineStyle");
    if (polyline.style.lineWidth > 0 && seriesModel.get(["emphasis", "lineStyle", "width"]) === "bolder") {
      var emphasisLineStyle = polyline.getState("emphasis").style;
      emphasisLineStyle.lineWidth = +polyline.style.lineWidth + 1;
    }
    getECData(polyline).seriesIndex = seriesModel.seriesIndex;
    toggleHoverEmphasis(polyline, focus, blurScope, emphasisDisabled);
    var smooth = getSmooth(seriesModel.get("smooth"));
    var smoothMonotone = seriesModel.get("smoothMonotone");
    polyline.setShape({
      smooth,
      smoothMonotone,
      connectNulls
    });
    if (polygon) {
      var stackedOnSeries = data.getCalculationInfo("stackedOnSeries");
      var stackedOnSmooth = 0;
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: visualColor,
        opacity: 0.7,
        lineJoin: "bevel",
        decal: data.getVisual("style").decal
      }));
      if (stackedOnSeries) {
        stackedOnSmooth = getSmooth(stackedOnSeries.get("smooth"));
      }
      polygon.setShape({
        smooth,
        stackedOnSmooth,
        smoothMonotone,
        connectNulls
      });
      setStatesStylesFromModel(polygon, seriesModel, "areaStyle");
      getECData(polygon).seriesIndex = seriesModel.seriesIndex;
      toggleHoverEmphasis(polygon, focus, blurScope, emphasisDisabled);
    }
    var changePolyState = function(toState) {
      _this._changePolyState(toState);
    };
    data.eachItemGraphicEl(function(el) {
      el && (el.onHoverStateChange = changePolyState);
    });
    this._polyline.onHoverStateChange = changePolyState;
    this._data = data;
    this._coordSys = coordSys;
    this._stackedOnPoints = stackedOnPoints;
    this._points = points2;
    this._step = step;
    this._valueOrigin = valueOrigin;
    if (seriesModel.get("triggerLineEvent")) {
      this.packEventData(seriesModel, polyline);
      polygon && this.packEventData(seriesModel, polygon);
    }
  };
  LineView2.prototype.packEventData = function(seriesModel, el) {
    getECData(el).eventData = {
      componentType: "series",
      componentSubType: "line",
      componentIndex: seriesModel.componentIndex,
      seriesIndex: seriesModel.seriesIndex,
      seriesName: seriesModel.name,
      seriesType: "line"
    };
  };
  LineView2.prototype.highlight = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("emphasis");
    if (!(dataIndex instanceof Array) && dataIndex != null && dataIndex >= 0) {
      var points2 = data.getLayout("points");
      var symbol = data.getItemGraphicEl(dataIndex);
      if (!symbol) {
        var x2 = points2[dataIndex * 2];
        var y2 = points2[dataIndex * 2 + 1];
        if (isNaN(x2) || isNaN(y2)) {
          return;
        }
        if (this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(x2, y2)) {
          return;
        }
        var zlevel = seriesModel.get("zlevel");
        var z2 = seriesModel.get("z");
        symbol = new SymbolClz(data, dataIndex);
        symbol.x = x2;
        symbol.y = y2;
        symbol.setZ(zlevel, z2);
        var symbolLabel = symbol.getSymbolPath().getTextContent();
        if (symbolLabel) {
          symbolLabel.zlevel = zlevel;
          symbolLabel.z = z2;
          symbolLabel.z2 = this._polyline.z2 + 1;
        }
        symbol.__temp = true;
        data.setItemGraphicEl(dataIndex, symbol);
        symbol.stopSymbolAnimation(true);
        this.group.add(symbol);
      }
      symbol.highlight();
    } else {
      ChartView$1.prototype.highlight.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype.downplay = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var dataIndex = queryDataIndex(data, payload);
    this._changePolyState("normal");
    if (dataIndex != null && dataIndex >= 0) {
      var symbol = data.getItemGraphicEl(dataIndex);
      if (symbol) {
        if (symbol.__temp) {
          data.setItemGraphicEl(dataIndex, null);
          this.group.remove(symbol);
        } else {
          symbol.downplay();
        }
      }
    } else {
      ChartView$1.prototype.downplay.call(this, seriesModel, ecModel, api, payload);
    }
  };
  LineView2.prototype._changePolyState = function(toState) {
    var polygon = this._polygon;
    setStatesFlag(this._polyline, toState);
    polygon && setStatesFlag(polygon, toState);
  };
  LineView2.prototype._newPolyline = function(points2) {
    var polyline = this._polyline;
    if (polyline) {
      this._lineGroup.remove(polyline);
    }
    polyline = new ECPolyline({
      shape: {
        points: points2
      },
      segmentIgnoreThreshold: 2,
      z2: 10
    });
    this._lineGroup.add(polyline);
    this._polyline = polyline;
    return polyline;
  };
  LineView2.prototype._newPolygon = function(points2, stackedOnPoints) {
    var polygon = this._polygon;
    if (polygon) {
      this._lineGroup.remove(polygon);
    }
    polygon = new ECPolygon({
      shape: {
        points: points2,
        stackedOnPoints
      },
      segmentIgnoreThreshold: 2
    });
    this._lineGroup.add(polygon);
    this._polygon = polygon;
    return polygon;
  };
  LineView2.prototype._initSymbolLabelAnimation = function(data, coordSys, clipShape) {
    var isHorizontalOrRadial;
    var isCoordSysPolar;
    var baseAxis = coordSys.getBaseAxis();
    var isAxisInverse = baseAxis.inverse;
    if (coordSys.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
      isCoordSysPolar = false;
    } else if (coordSys.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
      isCoordSysPolar = true;
    }
    var seriesModel = data.hostModel;
    var seriesDuration = seriesModel.get("animationDuration");
    if (isFunction(seriesDuration)) {
      seriesDuration = seriesDuration(null);
    }
    var seriesDalay = seriesModel.get("animationDelay") || 0;
    var seriesDalayValue = isFunction(seriesDalay) ? seriesDalay(null) : seriesDalay;
    data.eachItemGraphicEl(function(symbol, idx) {
      var el = symbol;
      if (el) {
        var point = [symbol.x, symbol.y];
        var start2 = void 0;
        var end2 = void 0;
        var current = void 0;
        if (clipShape) {
          if (isCoordSysPolar) {
            var polarClip = clipShape;
            var coord = coordSys.pointToCoord(point);
            if (isHorizontalOrRadial) {
              start2 = polarClip.startAngle;
              end2 = polarClip.endAngle;
              current = -coord[1] / 180 * Math.PI;
            } else {
              start2 = polarClip.r0;
              end2 = polarClip.r;
              current = coord[0];
            }
          } else {
            var gridClip = clipShape;
            if (isHorizontalOrRadial) {
              start2 = gridClip.x;
              end2 = gridClip.x + gridClip.width;
              current = symbol.x;
            } else {
              start2 = gridClip.y + gridClip.height;
              end2 = gridClip.y;
              current = symbol.y;
            }
          }
        }
        var ratio = end2 === start2 ? 0 : (current - start2) / (end2 - start2);
        if (isAxisInverse) {
          ratio = 1 - ratio;
        }
        var delay = isFunction(seriesDalay) ? seriesDalay(idx) : seriesDuration * ratio + seriesDalayValue;
        var symbolPath = el.getSymbolPath();
        var text = symbolPath.getTextContent();
        el.attr({
          scaleX: 0,
          scaleY: 0
        });
        el.animateTo({
          scaleX: 1,
          scaleY: 1
        }, {
          duration: 200,
          setToFinal: true,
          delay
        });
        if (text) {
          text.animateFrom({
            style: {
              opacity: 0
            }
          }, {
            duration: 300,
            delay
          });
        }
        symbolPath.disableLabelAnimation = true;
      }
    });
  };
  LineView2.prototype._initOrUpdateEndLabel = function(seriesModel, coordSys, inheritColor) {
    var endLabelModel = seriesModel.getModel("endLabel");
    if (anyStateShowEndLabel(seriesModel)) {
      var data_2 = seriesModel.getData();
      var polyline = this._polyline;
      var points2 = data_2.getLayout("points");
      if (!points2) {
        polyline.removeTextContent();
        this._endLabel = null;
        return;
      }
      var endLabel = this._endLabel;
      if (!endLabel) {
        endLabel = this._endLabel = new ZRText$1({
          z2: 200
        });
        endLabel.ignoreClip = true;
        polyline.setTextContent(this._endLabel);
        polyline.disableLabelAnimation = true;
      }
      var dataIndex = getLastIndexNotNull(points2);
      if (dataIndex >= 0) {
        setLabelStyle(polyline, getLabelStatesModels(seriesModel, "endLabel"), {
          inheritColor,
          labelFetcher: seriesModel,
          labelDataIndex: dataIndex,
          defaultText: function(dataIndex2, opt, interpolatedValue) {
            return interpolatedValue != null ? getDefaultInterpolatedLabel(data_2, interpolatedValue) : getDefaultLabel(data_2, dataIndex2);
          },
          enableTextSetter: true
        }, getEndLabelStateSpecified(endLabelModel, coordSys));
        polyline.textConfig.position = null;
      }
    } else if (this._endLabel) {
      this._polyline.removeTextContent();
      this._endLabel = null;
    }
  };
  LineView2.prototype._endLabelOnDuring = function(percent, clipRect, data, animationRecord, valueAnimation, endLabelModel, coordSys) {
    var endLabel = this._endLabel;
    var polyline = this._polyline;
    if (endLabel) {
      if (percent < 1 && animationRecord.originalX == null) {
        animationRecord.originalX = endLabel.x;
        animationRecord.originalY = endLabel.y;
      }
      var points2 = data.getLayout("points");
      var seriesModel = data.hostModel;
      var connectNulls = seriesModel.get("connectNulls");
      var precision = endLabelModel.get("precision");
      var distance2 = endLabelModel.get("distance") || 0;
      var baseAxis = coordSys.getBaseAxis();
      var isHorizontal = baseAxis.isHorizontal();
      var isBaseInversed = baseAxis.inverse;
      var clipShape = clipRect.shape;
      var xOrY = isBaseInversed ? isHorizontal ? clipShape.x : clipShape.y + clipShape.height : isHorizontal ? clipShape.x + clipShape.width : clipShape.y;
      var distanceX = (isHorizontal ? distance2 : 0) * (isBaseInversed ? -1 : 1);
      var distanceY = (isHorizontal ? 0 : -distance2) * (isBaseInversed ? -1 : 1);
      var dim = isHorizontal ? "x" : "y";
      var dataIndexRange = getIndexRange(points2, xOrY, dim);
      var indices = dataIndexRange.range;
      var diff = indices[1] - indices[0];
      var value = void 0;
      if (diff >= 1) {
        if (diff > 1 && !connectNulls) {
          var pt = getPointAtIndex(points2, indices[0]);
          endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          valueAnimation && (value = seriesModel.getRawValue(indices[0]));
        } else {
          var pt = polyline.getPointOn(xOrY, dim);
          pt && endLabel.attr({
            x: pt[0] + distanceX,
            y: pt[1] + distanceY
          });
          var startValue = seriesModel.getRawValue(indices[0]);
          var endValue = seriesModel.getRawValue(indices[1]);
          valueAnimation && (value = interpolateRawValues(data, precision, startValue, endValue, dataIndexRange.t));
        }
        animationRecord.lastFrameIndex = indices[0];
      } else {
        var idx = percent === 1 || animationRecord.lastFrameIndex > 0 ? indices[0] : 0;
        var pt = getPointAtIndex(points2, idx);
        valueAnimation && (value = seriesModel.getRawValue(idx));
        endLabel.attr({
          x: pt[0] + distanceX,
          y: pt[1] + distanceY
        });
      }
      if (valueAnimation) {
        labelInner(endLabel).setLabelText(value);
      }
    }
  };
  LineView2.prototype._doUpdateAnimation = function(data, stackedOnPoints, coordSys, api, step, valueOrigin, connectNulls) {
    var polyline = this._polyline;
    var polygon = this._polygon;
    var seriesModel = data.hostModel;
    var diff = lineAnimationDiff(this._data, data, this._stackedOnPoints, stackedOnPoints, this._coordSys, coordSys, this._valueOrigin);
    var current = diff.current;
    var stackedOnCurrent = diff.stackedOnCurrent;
    var next = diff.next;
    var stackedOnNext = diff.stackedOnNext;
    if (step) {
      current = turnPointsIntoStep(diff.current, coordSys, step, connectNulls);
      stackedOnCurrent = turnPointsIntoStep(diff.stackedOnCurrent, coordSys, step, connectNulls);
      next = turnPointsIntoStep(diff.next, coordSys, step, connectNulls);
      stackedOnNext = turnPointsIntoStep(diff.stackedOnNext, coordSys, step, connectNulls);
    }
    if (getBoundingDiff(current, next) > 3e3 || polygon && getBoundingDiff(stackedOnCurrent, stackedOnNext) > 3e3) {
      polyline.stopAnimation();
      polyline.setShape({
        points: next
      });
      if (polygon) {
        polygon.stopAnimation();
        polygon.setShape({
          points: next,
          stackedOnPoints: stackedOnNext
        });
      }
      return;
    }
    polyline.shape.__points = diff.current;
    polyline.shape.points = current;
    var target = {
      shape: {
        points: next
      }
    };
    if (diff.current !== current) {
      target.shape.__points = diff.next;
    }
    polyline.stopAnimation();
    updateProps$1(polyline, target, seriesModel);
    if (polygon) {
      polygon.setShape({
        points: current,
        stackedOnPoints: stackedOnCurrent
      });
      polygon.stopAnimation();
      updateProps$1(polygon, {
        shape: {
          stackedOnPoints: stackedOnNext
        }
      }, seriesModel);
      if (polyline.shape.points !== polygon.shape.points) {
        polygon.shape.points = polyline.shape.points;
      }
    }
    var updatedDataInfo = [];
    var diffStatus = diff.status;
    for (var i = 0; i < diffStatus.length; i++) {
      var cmd = diffStatus[i].cmd;
      if (cmd === "=") {
        var el = data.getItemGraphicEl(diffStatus[i].idx1);
        if (el) {
          updatedDataInfo.push({
            el,
            ptIdx: i
          });
        }
      }
    }
    if (polyline.animators && polyline.animators.length) {
      polyline.animators[0].during(function() {
        polygon && polygon.dirtyShape();
        var points2 = polyline.shape.__points;
        for (var i2 = 0; i2 < updatedDataInfo.length; i2++) {
          var el2 = updatedDataInfo[i2].el;
          var offset = updatedDataInfo[i2].ptIdx * 2;
          el2.x = points2[offset];
          el2.y = points2[offset + 1];
          el2.markRedraw();
        }
      });
    }
  };
  LineView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var oldData = this._data;
    this._lineGroup.removeAll();
    this._symbolDraw.remove(true);
    oldData && oldData.eachItemGraphicEl(function(el, idx) {
      if (el.__temp) {
        group.remove(el);
        oldData.setItemGraphicEl(idx, null);
      }
    });
    this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
  };
  LineView2.type = "line";
  return LineView2;
}(ChartView$1);
var LineView$1 = LineView;
function pointsLayout(seriesType2, forceStoreInTypedArray) {
  return {
    seriesType: seriesType2,
    plan: createRenderPlanner(),
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var coordSys = seriesModel.coordinateSystem;
      var pipelineContext = seriesModel.pipelineContext;
      var useTypedArray = forceStoreInTypedArray || pipelineContext.large;
      if (!coordSys) {
        return;
      }
      var dims = map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }).slice(0, 2);
      var dimLen = dims.length;
      var stackResultDim = data.getCalculationInfo("stackResultDimension");
      if (isDimensionStacked(data, dims[0])) {
        dims[0] = stackResultDim;
      }
      if (isDimensionStacked(data, dims[1])) {
        dims[1] = stackResultDim;
      }
      var store = data.getStore();
      var dimIdx0 = data.getDimensionIndex(dims[0]);
      var dimIdx1 = data.getDimensionIndex(dims[1]);
      return dimLen && {
        progress: function(params, data2) {
          var segCount = params.end - params.start;
          var points2 = useTypedArray && createFloat32Array(segCount * dimLen);
          var tmpIn = [];
          var tmpOut = [];
          for (var i = params.start, offset = 0; i < params.end; i++) {
            var point = void 0;
            if (dimLen === 1) {
              var x2 = store.get(dimIdx0, i);
              point = coordSys.dataToPoint(x2, null, tmpOut);
            } else {
              tmpIn[0] = store.get(dimIdx0, i);
              tmpIn[1] = store.get(dimIdx1, i);
              point = coordSys.dataToPoint(tmpIn, null, tmpOut);
            }
            if (useTypedArray) {
              points2[offset++] = point[0];
              points2[offset++] = point[1];
            } else {
              data2.setItemLayout(i, point.slice());
            }
          }
          useTypedArray && data2.setLayout("points", points2);
        }
      };
    }
  };
}
var samplers = {
  average: function(frame) {
    var sum2 = 0;
    var count2 = 0;
    for (var i = 0; i < frame.length; i++) {
      if (!isNaN(frame[i])) {
        sum2 += frame[i];
        count2++;
      }
    }
    return count2 === 0 ? NaN : sum2 / count2;
  },
  sum: function(frame) {
    var sum2 = 0;
    for (var i = 0; i < frame.length; i++) {
      sum2 += frame[i] || 0;
    }
    return sum2;
  },
  max: function(frame) {
    var max3 = -Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] > max3 && (max3 = frame[i]);
    }
    return isFinite(max3) ? max3 : NaN;
  },
  min: function(frame) {
    var min3 = Infinity;
    for (var i = 0; i < frame.length; i++) {
      frame[i] < min3 && (min3 = frame[i]);
    }
    return isFinite(min3) ? min3 : NaN;
  },
  nearest: function(frame) {
    return frame[0];
  }
};
var indexSampler = function(frame) {
  return Math.round(frame.length / 2);
};
function dataSample(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel, api) {
      var data = seriesModel.getData();
      var sampling = seriesModel.get("sampling");
      var coordSys = seriesModel.coordinateSystem;
      var count2 = data.count();
      if (count2 > 10 && coordSys.type === "cartesian2d" && sampling) {
        var baseAxis = coordSys.getBaseAxis();
        var valueAxis2 = coordSys.getOtherAxis(baseAxis);
        var extent3 = baseAxis.getExtent();
        var dpr2 = api.getDevicePixelRatio();
        var size = Math.abs(extent3[1] - extent3[0]) * (dpr2 || 1);
        var rate = Math.round(count2 / size);
        if (isFinite(rate) && rate > 1) {
          if (sampling === "lttb") {
            seriesModel.setData(data.lttbDownSample(data.mapDimension(valueAxis2.dim), 1 / rate));
          }
          var sampler = void 0;
          if (isString(sampling)) {
            sampler = samplers[sampling];
          } else if (isFunction(sampling)) {
            sampler = sampling;
          }
          if (sampler) {
            seriesModel.setData(data.downSample(data.mapDimension(valueAxis2.dim), 1 / rate, sampler, indexSampler));
          }
        }
      }
    }
  };
}
function install$Q(registers) {
  registers.registerChartView(LineView$1);
  registers.registerSeriesModel(LineSeries);
  registers.registerLayout(pointsLayout("line", true));
  registers.registerVisual({
    seriesType: "line",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      var lineStyle = seriesModel.getModel("lineStyle").getLineStyle();
      if (lineStyle && !lineStyle.stroke) {
        lineStyle.stroke = data.getVisual("style").fill;
      }
      data.setVisual("legendLineStyle", lineStyle);
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("line"));
}
var BaseBarSeriesModel = function(_super) {
  __extends(BaseBarSeriesModel2, _super);
  function BaseBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BaseBarSeriesModel2.type;
    return _this;
  }
  BaseBarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  BaseBarSeriesModel2.prototype.getMarkerPosition = function(value) {
    var coordSys = this.coordinateSystem;
    if (coordSys && coordSys.clampData) {
      var pt = coordSys.dataToPoint(coordSys.clampData(value));
      var data = this.getData();
      var offset = data.getLayout("offset");
      var size = data.getLayout("size");
      var offsetIndex = coordSys.getBaseAxis().isHorizontal() ? 0 : 1;
      pt[offsetIndex] += offset + size / 2;
      return pt;
    }
    return [NaN, NaN];
  };
  BaseBarSeriesModel2.type = "series.__base_bar__";
  BaseBarSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    barMinHeight: 0,
    barMinAngle: 0,
    large: false,
    largeThreshold: 400,
    progressive: 3e3,
    progressiveChunkMode: "mod"
  };
  return BaseBarSeriesModel2;
}(SeriesModel$1);
SeriesModel$1.registerClass(BaseBarSeriesModel);
var BaseBarSeriesModel$1 = BaseBarSeriesModel;
var BarSeriesModel = function(_super) {
  __extends(BarSeriesModel2, _super);
  function BarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BarSeriesModel2.type;
    return _this;
  }
  BarSeriesModel2.prototype.getInitialData = function() {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true,
      createInvertedIndices: !!this.get("realtimeSort", true) || null
    });
  };
  BarSeriesModel2.prototype.getProgressive = function() {
    return this.get("large") ? this.get("progressive") : false;
  };
  BarSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.get("progressiveThreshold");
    var largeThreshold = this.get("largeThreshold");
    if (largeThreshold > progressiveThreshold) {
      progressiveThreshold = largeThreshold;
    }
    return progressiveThreshold;
  };
  BarSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.rect(data.getItemLayout(dataIndex));
  };
  BarSeriesModel2.type = "series.bar";
  BarSeriesModel2.dependencies = ["grid", "polar"];
  BarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    clip: true,
    roundCap: false,
    showBackground: false,
    backgroundStyle: {
      color: "rgba(180, 180, 180, 0.2)",
      borderColor: null,
      borderWidth: 0,
      borderType: "solid",
      borderRadius: 0,
      shadowBlur: 0,
      shadowColor: null,
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    realtimeSort: false
  });
  return BarSeriesModel2;
}(BaseBarSeriesModel$1);
var BarSeries = BarSeriesModel;
var SausageShape = function() {
  function SausageShape2() {
    this.cx = 0;
    this.cy = 0;
    this.r0 = 0;
    this.r = 0;
    this.startAngle = 0;
    this.endAngle = Math.PI * 2;
    this.clockwise = true;
  }
  return SausageShape2;
}();
var SausagePath = function(_super) {
  __extends(SausagePath2, _super);
  function SausagePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "sausage";
    return _this;
  }
  SausagePath2.prototype.getDefaultShape = function() {
    return new SausageShape();
  };
  SausagePath2.prototype.buildPath = function(ctx, shape) {
    var cx = shape.cx;
    var cy = shape.cy;
    var r0 = Math.max(shape.r0 || 0, 0);
    var r2 = Math.max(shape.r, 0);
    var dr = (r2 - r0) * 0.5;
    var rCenter = r0 + dr;
    var startAngle = shape.startAngle;
    var endAngle = shape.endAngle;
    var clockwise = shape.clockwise;
    var PI22 = Math.PI * 2;
    var lessThanCircle = clockwise ? endAngle - startAngle < PI22 : startAngle - endAngle < PI22;
    if (!lessThanCircle) {
      startAngle = endAngle - (clockwise ? PI22 : -PI22);
    }
    var unitStartX = Math.cos(startAngle);
    var unitStartY = Math.sin(startAngle);
    var unitEndX = Math.cos(endAngle);
    var unitEndY = Math.sin(endAngle);
    if (lessThanCircle) {
      ctx.moveTo(unitStartX * r0 + cx, unitStartY * r0 + cy);
      ctx.arc(unitStartX * rCenter + cx, unitStartY * rCenter + cy, dr, -Math.PI + startAngle, startAngle, !clockwise);
    } else {
      ctx.moveTo(unitStartX * r2 + cx, unitStartY * r2 + cy);
    }
    ctx.arc(cx, cy, r2, startAngle, endAngle, !clockwise);
    ctx.arc(unitEndX * rCenter + cx, unitEndY * rCenter + cy, dr, endAngle - Math.PI * 2, endAngle - Math.PI, !clockwise);
    if (r0 !== 0) {
      ctx.arc(cx, cy, r0, endAngle, startAngle, clockwise);
    }
  };
  return SausagePath2;
}(Path$1);
var Sausage = SausagePath;
function createSectorCalculateTextPosition(positionMapping, opts) {
  opts = opts || {};
  var isRoundCap = opts.isRoundCap;
  return function(out2, opts2, boundingRect) {
    var textPosition = opts2.position;
    if (!textPosition || textPosition instanceof Array) {
      return calculateTextPosition(out2, opts2, boundingRect);
    }
    var mappedSectorPosition = positionMapping(textPosition);
    var distance2 = opts2.distance != null ? opts2.distance : 5;
    var sector = this.shape;
    var cx = sector.cx;
    var cy = sector.cy;
    var r2 = sector.r;
    var r0 = sector.r0;
    var middleR = (r2 + r0) / 2;
    var startAngle = sector.startAngle;
    var endAngle = sector.endAngle;
    var middleAngle = (startAngle + endAngle) / 2;
    var extraDist = isRoundCap ? Math.abs(r2 - r0) / 2 : 0;
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var x2 = cx + r2 * mathCos2(startAngle);
    var y2 = cy + r2 * mathSin2(startAngle);
    var textAlign = "left";
    var textVerticalAlign = "top";
    switch (mappedSectorPosition) {
      case "startArc":
        x2 = cx + (r0 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "insideStartArc":
        x2 = cx + (r0 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r0 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "startAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, distance2 + extraDist, false);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      case "insideStartAngle":
        x2 = cx + middleR * mathCos2(startAngle) + adjustAngleDistanceX(startAngle, -distance2 + extraDist, false);
        y2 = cy + middleR * mathSin2(startAngle) + adjustAngleDistanceY(startAngle, -distance2 + extraDist, false);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "middle":
        x2 = cx + middleR * mathCos2(middleAngle);
        y2 = cy + middleR * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "middle";
        break;
      case "endArc":
        x2 = cx + (r2 + distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 + distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "bottom";
        break;
      case "insideEndArc":
        x2 = cx + (r2 - distance2) * mathCos2(middleAngle);
        y2 = cy + (r2 - distance2) * mathSin2(middleAngle);
        textAlign = "center";
        textVerticalAlign = "top";
        break;
      case "endAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, distance2 + extraDist, true);
        textAlign = "left";
        textVerticalAlign = "middle";
        break;
      case "insideEndAngle":
        x2 = cx + middleR * mathCos2(endAngle) + adjustAngleDistanceX(endAngle, -distance2 + extraDist, true);
        y2 = cy + middleR * mathSin2(endAngle) + adjustAngleDistanceY(endAngle, -distance2 + extraDist, true);
        textAlign = "right";
        textVerticalAlign = "middle";
        break;
      default:
        return calculateTextPosition(out2, opts2, boundingRect);
    }
    out2 = out2 || {};
    out2.x = x2;
    out2.y = y2;
    out2.align = textAlign;
    out2.verticalAlign = textVerticalAlign;
    return out2;
  };
}
function setSectorTextRotation(sector, textPosition, positionMapping, rotateType) {
  if (isNumber(rotateType)) {
    sector.setTextConfig({
      rotation: rotateType
    });
    return;
  } else if (isArray$1(textPosition)) {
    sector.setTextConfig({
      rotation: 0
    });
    return;
  }
  var shape = sector.shape;
  var startAngle = shape.clockwise ? shape.startAngle : shape.endAngle;
  var endAngle = shape.clockwise ? shape.endAngle : shape.startAngle;
  var middleAngle = (startAngle + endAngle) / 2;
  var anchorAngle;
  var mappedSectorPosition = positionMapping(textPosition);
  switch (mappedSectorPosition) {
    case "startArc":
    case "insideStartArc":
    case "middle":
    case "insideEndArc":
    case "endArc":
      anchorAngle = middleAngle;
      break;
    case "startAngle":
    case "insideStartAngle":
      anchorAngle = startAngle;
      break;
    case "endAngle":
    case "insideEndAngle":
      anchorAngle = endAngle;
      break;
    default:
      sector.setTextConfig({
        rotation: 0
      });
      return;
  }
  var rotate2 = Math.PI * 1.5 - anchorAngle;
  if (mappedSectorPosition === "middle" && rotate2 > Math.PI / 2 && rotate2 < Math.PI * 1.5) {
    rotate2 -= Math.PI;
  }
  sector.setTextConfig({
    rotation: rotate2
  });
}
function adjustAngleDistanceX(angle, distance2, isEnd) {
  return distance2 * Math.sin(angle) * (isEnd ? -1 : 1);
}
function adjustAngleDistanceY(angle, distance2, isEnd) {
  return distance2 * Math.cos(angle) * (isEnd ? 1 : -1);
}
var mathMax$4 = Math.max;
var mathMin$4 = Math.min;
function getClipArea(coord, data) {
  var coordSysClipArea = coord.getArea && coord.getArea();
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var baseAxis = coord.getBaseAxis();
    if (baseAxis.type !== "category" || !baseAxis.onBand) {
      var expandWidth = data.getLayout("bandWidth");
      if (baseAxis.isHorizontal()) {
        coordSysClipArea.x -= expandWidth;
        coordSysClipArea.width += expandWidth * 2;
      } else {
        coordSysClipArea.y -= expandWidth;
        coordSysClipArea.height += expandWidth * 2;
      }
    }
  }
  return coordSysClipArea;
}
var BarView = function(_super) {
  __extends(BarView2, _super);
  function BarView2() {
    var _this = _super.call(this) || this;
    _this.type = BarView2.type;
    _this._isFirstFrame = true;
    return _this;
  }
  BarView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._model = seriesModel;
    this._removeOnRenderedListener(api);
    this._updateDrawMode(seriesModel);
    var coordinateSystemType = seriesModel.get("coordinateSystem");
    if (coordinateSystemType === "cartesian2d" || coordinateSystemType === "polar") {
      this._progressiveEls = null;
      this._isLargeDraw ? this._renderLarge(seriesModel, ecModel, api) : this._renderNormal(seriesModel, ecModel, api, payload);
    }
  };
  BarView2.prototype.incrementalPrepareRender = function(seriesModel) {
    this._clear();
    this._updateDrawMode(seriesModel);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype.incrementalRender = function(params, seriesModel) {
    this._progressiveEls = [];
    this._incrementalRenderLarge(params, seriesModel);
  };
  BarView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  BarView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  BarView2.prototype._renderNormal = function(seriesModel, ecModel, api, payload) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coord = seriesModel.coordinateSystem;
    var baseAxis = coord.getBaseAxis();
    var isHorizontalOrRadial;
    if (coord.type === "cartesian2d") {
      isHorizontalOrRadial = baseAxis.isHorizontal();
    } else if (coord.type === "polar") {
      isHorizontalOrRadial = baseAxis.dim === "angle";
    }
    var animationModel = seriesModel.isAnimationEnabled() ? seriesModel : null;
    var realtimeSortCfg = shouldRealtimeSort(seriesModel, coord);
    if (realtimeSortCfg) {
      this._enableRealtimeSort(realtimeSortCfg, data, api);
    }
    var needsClip = seriesModel.get("clip", true) || realtimeSortCfg;
    var coordSysClipArea = getClipArea(coord, data);
    group.removeClipPath();
    var roundCap = seriesModel.get("roundCap", true);
    var drawBackground = seriesModel.get("showBackground", true);
    var backgroundModel = seriesModel.getModel("backgroundStyle");
    var barBorderRadius = backgroundModel.get("borderRadius") || 0;
    var bgEls = [];
    var oldBgEls = this._backgroundEls;
    var isInitSort = payload && payload.isInitSort;
    var isChangeOrder = payload && payload.type === "changeAxisOrder";
    function createBackground(dataIndex) {
      var bgLayout = getLayout[coord.type](data, dataIndex);
      var bgEl = createBackgroundEl(coord, isHorizontalOrRadial, bgLayout);
      bgEl.useStyle(backgroundModel.getItemStyle());
      if (coord.type === "cartesian2d") {
        bgEl.setShape("r", barBorderRadius);
      }
      bgEls[dataIndex] = bgEl;
      return bgEl;
    }
    data.diff(oldData).add(function(dataIndex) {
      var itemModel = data.getItemModel(dataIndex);
      var layout2 = getLayout[coord.type](data, dataIndex, itemModel);
      if (drawBackground) {
        createBackground(dataIndex);
      }
      if (!data.hasValue(dataIndex) || !isValidLayout[coord.type](layout2)) {
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
      }
      var el = elementCreator[coord.type](seriesModel, data, dataIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, false, roundCap);
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, dataIndex, isHorizontalOrRadial, false, false);
      } else {
        initProps(el, {
          shape: layout2
        }, seriesModel, dataIndex);
      }
      data.setItemGraphicEl(dataIndex, el);
      group.add(el);
      el.ignore = isClipped;
    }).update(function(newIndex, oldIndex) {
      var itemModel = data.getItemModel(newIndex);
      var layout2 = getLayout[coord.type](data, newIndex, itemModel);
      if (drawBackground) {
        var bgEl = void 0;
        if (oldBgEls.length === 0) {
          bgEl = createBackground(oldIndex);
        } else {
          bgEl = oldBgEls[oldIndex];
          bgEl.useStyle(backgroundModel.getItemStyle());
          if (coord.type === "cartesian2d") {
            bgEl.setShape("r", barBorderRadius);
          }
          bgEls[newIndex] = bgEl;
        }
        var bgLayout = getLayout[coord.type](data, newIndex);
        var shape = createBackgroundShape(isHorizontalOrRadial, bgLayout, coord);
        updateProps$1(bgEl, {
          shape
        }, animationModel, newIndex);
      }
      var el = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex) || !isValidLayout[coord.type](layout2)) {
        group.remove(el);
        return;
      }
      var isClipped = false;
      if (needsClip) {
        isClipped = clip[coord.type](coordSysClipArea, layout2);
        if (isClipped) {
          group.remove(el);
        }
      }
      if (!el) {
        el = elementCreator[coord.type](seriesModel, data, newIndex, layout2, isHorizontalOrRadial, animationModel, baseAxis.model, !!el, roundCap);
      } else {
        saveOldStyle(el);
      }
      if (realtimeSortCfg) {
        el.forceLabelAnimation = true;
      }
      if (isChangeOrder) {
        var textEl = el.getTextContent();
        if (textEl) {
          var labelInnerStore = labelInner(textEl);
          if (labelInnerStore.prevValue != null) {
            labelInnerStore.prevValue = labelInnerStore.value;
          }
        }
      } else {
        updateStyle(el, data, newIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, coord.type === "polar");
      }
      if (isInitSort) {
        el.attr({
          shape: layout2
        });
      } else if (realtimeSortCfg) {
        updateRealtimeAnimation(realtimeSortCfg, animationModel, el, layout2, newIndex, isHorizontalOrRadial, true, isChangeOrder);
      } else {
        updateProps$1(el, {
          shape: layout2
        }, seriesModel, newIndex, null);
      }
      data.setItemGraphicEl(newIndex, el);
      el.ignore = isClipped;
      group.add(el);
    }).remove(function(dataIndex) {
      var el = oldData.getItemGraphicEl(dataIndex);
      el && removeElementWithFadeOut(el, seriesModel, dataIndex);
    }).execute();
    var bgGroup = this._backgroundGroup || (this._backgroundGroup = new Group$4());
    bgGroup.removeAll();
    for (var i = 0; i < bgEls.length; ++i) {
      bgGroup.add(bgEls[i]);
    }
    group.add(bgGroup);
    this._backgroundEls = bgEls;
    this._data = data;
  };
  BarView2.prototype._renderLarge = function(seriesModel, ecModel, api) {
    this._clear();
    createLarge$1(seriesModel, this.group);
    this._updateLargeClip(seriesModel);
  };
  BarView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    this._removeBackground();
    createLarge$1(seriesModel, this.group, this._progressiveEls, true);
  };
  BarView2.prototype._updateLargeClip = function(seriesModel) {
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    var group = this.group;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
  };
  BarView2.prototype._enableRealtimeSort = function(realtimeSortCfg, data, api) {
    var _this = this;
    if (!data.count()) {
      return;
    }
    var baseAxis = realtimeSortCfg.baseAxis;
    if (this._isFirstFrame) {
      this._dispatchInitSort(data, realtimeSortCfg, api);
      this._isFirstFrame = false;
    } else {
      var orderMapping_1 = function(idx) {
        var el = data.getItemGraphicEl(idx);
        var shape = el && el.shape;
        return shape && Math.abs(baseAxis.isHorizontal() ? shape.height : shape.width) || 0;
      };
      this._onRendered = function() {
        _this._updateSortWithinSameData(data, orderMapping_1, baseAxis, api);
      };
      api.getZr().on("rendered", this._onRendered);
    }
  };
  BarView2.prototype._dataSort = function(data, baseAxis, orderMapping) {
    var info = [];
    data.each(data.mapDimension(baseAxis.dim), function(ordinalNumber, dataIdx) {
      var mappedValue = orderMapping(dataIdx);
      mappedValue = mappedValue == null ? NaN : mappedValue;
      info.push({
        dataIndex: dataIdx,
        mappedValue,
        ordinalNumber
      });
    });
    info.sort(function(a, b2) {
      return b2.mappedValue - a.mappedValue;
    });
    return {
      ordinalNumbers: map$1(info, function(item) {
        return item.ordinalNumber;
      })
    };
  };
  BarView2.prototype._isOrderChangedWithinSameData = function(data, orderMapping, baseAxis) {
    var scale2 = baseAxis.scale;
    var ordinalDataDim = data.mapDimension(baseAxis.dim);
    var lastValue = Number.MAX_VALUE;
    for (var tickNum = 0, len2 = scale2.getOrdinalMeta().categories.length; tickNum < len2; ++tickNum) {
      var rawIdx = data.rawIndexOf(ordinalDataDim, scale2.getRawOrdinalNumber(tickNum));
      var value = rawIdx < 0 ? Number.MIN_VALUE : orderMapping(data.indexOfRawIndex(rawIdx));
      if (value > lastValue) {
        return true;
      }
      lastValue = value;
    }
    return false;
  };
  BarView2.prototype._isOrderDifferentInView = function(orderInfo, baseAxis) {
    var scale2 = baseAxis.scale;
    var extent3 = scale2.getExtent();
    var tickNum = Math.max(0, extent3[0]);
    var tickMax = Math.min(extent3[1], scale2.getOrdinalMeta().categories.length - 1);
    for (; tickNum <= tickMax; ++tickNum) {
      if (orderInfo.ordinalNumbers[tickNum] !== scale2.getRawOrdinalNumber(tickNum)) {
        return true;
      }
    }
  };
  BarView2.prototype._updateSortWithinSameData = function(data, orderMapping, baseAxis, api) {
    if (!this._isOrderChangedWithinSameData(data, orderMapping, baseAxis)) {
      return;
    }
    var sortInfo = this._dataSort(data, baseAxis, orderMapping);
    if (this._isOrderDifferentInView(sortInfo, baseAxis)) {
      this._removeOnRenderedListener(api);
      api.dispatchAction({
        type: "changeAxisOrder",
        componentType: baseAxis.dim + "Axis",
        axisId: baseAxis.index,
        sortInfo
      });
    }
  };
  BarView2.prototype._dispatchInitSort = function(data, realtimeSortCfg, api) {
    var baseAxis = realtimeSortCfg.baseAxis;
    var sortResult = this._dataSort(data, baseAxis, function(dataIdx) {
      return data.get(data.mapDimension(realtimeSortCfg.otherAxis.dim), dataIdx);
    });
    api.dispatchAction({
      type: "changeAxisOrder",
      componentType: baseAxis.dim + "Axis",
      isInitSort: true,
      axisId: baseAxis.index,
      sortInfo: sortResult
    });
  };
  BarView2.prototype.remove = function(ecModel, api) {
    this._clear(this._model);
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype.dispose = function(ecModel, api) {
    this._removeOnRenderedListener(api);
  };
  BarView2.prototype._removeOnRenderedListener = function(api) {
    if (this._onRendered) {
      api.getZr().off("rendered", this._onRendered);
      this._onRendered = null;
    }
  };
  BarView2.prototype._clear = function(model) {
    var group = this.group;
    var data = this._data;
    if (model && model.isAnimationEnabled() && data && !this._isLargeDraw) {
      this._removeBackground();
      this._backgroundEls = [];
      data.eachItemGraphicEl(function(el) {
        removeElementWithFadeOut(el, model, getECData(el).dataIndex);
      });
    } else {
      group.removeAll();
    }
    this._data = null;
    this._isFirstFrame = true;
  };
  BarView2.prototype._removeBackground = function() {
    this.group.remove(this._backgroundGroup);
    this._backgroundGroup = null;
  };
  BarView2.type = "bar";
  return BarView2;
}(ChartView$1);
var clip = {
  cartesian2d: function(coordSysBoundingRect, layout2) {
    var signWidth = layout2.width < 0 ? -1 : 1;
    var signHeight = layout2.height < 0 ? -1 : 1;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    var coordSysX2 = coordSysBoundingRect.x + coordSysBoundingRect.width;
    var coordSysY2 = coordSysBoundingRect.y + coordSysBoundingRect.height;
    var x2 = mathMax$4(layout2.x, coordSysBoundingRect.x);
    var x22 = mathMin$4(layout2.x + layout2.width, coordSysX2);
    var y2 = mathMax$4(layout2.y, coordSysBoundingRect.y);
    var y22 = mathMin$4(layout2.y + layout2.height, coordSysY2);
    var xClipped = x22 < x2;
    var yClipped = y22 < y2;
    layout2.x = xClipped && x2 > coordSysX2 ? x22 : x2;
    layout2.y = yClipped && y2 > coordSysY2 ? y22 : y2;
    layout2.width = xClipped ? 0 : x22 - x2;
    layout2.height = yClipped ? 0 : y22 - y2;
    if (signWidth < 0) {
      layout2.x += layout2.width;
      layout2.width = -layout2.width;
    }
    if (signHeight < 0) {
      layout2.y += layout2.height;
      layout2.height = -layout2.height;
    }
    return xClipped || yClipped;
  },
  polar: function(coordSysClipArea, layout2) {
    var signR = layout2.r0 <= layout2.r ? 1 : -1;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    var r2 = mathMin$4(layout2.r, coordSysClipArea.r);
    var r0 = mathMax$4(layout2.r0, coordSysClipArea.r0);
    layout2.r = r2;
    layout2.r0 = r0;
    var clipped = r2 - r0 < 0;
    if (signR < 0) {
      var tmp = layout2.r;
      layout2.r = layout2.r0;
      layout2.r0 = tmp;
    }
    return clipped;
  }
};
var elementCreator = {
  cartesian2d: function(seriesModel, data, newIndex, layout2, isHorizontal, animationModel, axisModel, isUpdate, roundCap) {
    var rect = new Rect$3({
      shape: extend({}, layout2),
      z2: 1
    });
    rect.__dataIndex = newIndex;
    rect.name = "item";
    if (animationModel) {
      var rectShape = rect.shape;
      var animateProperty = isHorizontal ? "height" : "width";
      rectShape[animateProperty] = 0;
    }
    return rect;
  },
  polar: function(seriesModel, data, newIndex, layout2, isRadial, animationModel, axisModel, isUpdate, roundCap) {
    var ShapeClass = !isRadial && roundCap ? Sausage : Sector$1;
    var sector = new ShapeClass({
      shape: layout2,
      z2: 1
    });
    sector.name = "item";
    var positionMap = createPolarPositionMapping(isRadial);
    sector.calculateTextPosition = createSectorCalculateTextPosition(positionMap, {
      isRoundCap: ShapeClass === Sausage
    });
    if (animationModel) {
      var sectorShape = sector.shape;
      var animateProperty = isRadial ? "r" : "endAngle";
      var animateTarget = {};
      sectorShape[animateProperty] = isRadial ? 0 : layout2.startAngle;
      animateTarget[animateProperty] = layout2[animateProperty];
      (isUpdate ? updateProps$1 : initProps)(sector, {
        shape: animateTarget
      }, animationModel);
    }
    return sector;
  }
};
function shouldRealtimeSort(seriesModel, coordSys) {
  var realtimeSortOption = seriesModel.get("realtimeSort", true);
  var baseAxis = coordSys.getBaseAxis();
  if (realtimeSortOption && baseAxis.type === "category" && coordSys.type === "cartesian2d") {
    return {
      baseAxis,
      otherAxis: coordSys.getOtherAxis(baseAxis)
    };
  }
}
function updateRealtimeAnimation(realtimeSortCfg, seriesAnimationModel, el, layout2, newIndex, isHorizontal, isUpdate, isChangeOrder) {
  var seriesTarget;
  var axisTarget;
  if (isHorizontal) {
    axisTarget = {
      x: layout2.x,
      width: layout2.width
    };
    seriesTarget = {
      y: layout2.y,
      height: layout2.height
    };
  } else {
    axisTarget = {
      y: layout2.y,
      height: layout2.height
    };
    seriesTarget = {
      x: layout2.x,
      width: layout2.width
    };
  }
  if (!isChangeOrder) {
    (isUpdate ? updateProps$1 : initProps)(el, {
      shape: seriesTarget
    }, seriesAnimationModel, newIndex, null);
  }
  var axisAnimationModel = seriesAnimationModel ? realtimeSortCfg.baseAxis.model : null;
  (isUpdate ? updateProps$1 : initProps)(el, {
    shape: axisTarget
  }, axisAnimationModel, newIndex);
}
function checkPropertiesNotValid(obj, props) {
  for (var i = 0; i < props.length; i++) {
    if (!isFinite(obj[props[i]])) {
      return true;
    }
  }
  return false;
}
var rectPropties = ["x", "y", "width", "height"];
var polarPropties = ["cx", "cy", "r", "startAngle", "endAngle"];
var isValidLayout = {
  cartesian2d: function(layout2) {
    return !checkPropertiesNotValid(layout2, rectPropties);
  },
  polar: function(layout2) {
    return !checkPropertiesNotValid(layout2, polarPropties);
  }
};
var getLayout = {
  cartesian2d: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    var fixedLineWidth = itemModel ? getLineWidth(itemModel, layout2) : 0;
    var signX = layout2.width > 0 ? 1 : -1;
    var signY = layout2.height > 0 ? 1 : -1;
    return {
      x: layout2.x + signX * fixedLineWidth / 2,
      y: layout2.y + signY * fixedLineWidth / 2,
      width: layout2.width - signX * fixedLineWidth,
      height: layout2.height - signY * fixedLineWidth
    };
  },
  polar: function(data, dataIndex, itemModel) {
    var layout2 = data.getItemLayout(dataIndex);
    return {
      cx: layout2.cx,
      cy: layout2.cy,
      r0: layout2.r0,
      r: layout2.r,
      startAngle: layout2.startAngle,
      endAngle: layout2.endAngle,
      clockwise: layout2.clockwise
    };
  }
};
function isZeroOnPolar(layout2) {
  return layout2.startAngle != null && layout2.endAngle != null && layout2.startAngle === layout2.endAngle;
}
function createPolarPositionMapping(isRadial) {
  return function(isRadial2) {
    var arcOrAngle = isRadial2 ? "Arc" : "Angle";
    return function(position2) {
      switch (position2) {
        case "start":
        case "insideStart":
        case "end":
        case "insideEnd":
          return position2 + arcOrAngle;
        default:
          return position2;
      }
    };
  }(isRadial);
}
function updateStyle(el, data, dataIndex, itemModel, layout2, seriesModel, isHorizontalOrRadial, isPolar) {
  var style = data.getItemVisual(dataIndex, "style");
  if (!isPolar) {
    el.setShape("r", itemModel.get(["itemStyle", "borderRadius"]) || 0);
  }
  el.useStyle(style);
  var cursorStyle = itemModel.getShallow("cursor");
  cursorStyle && el.attr("cursor", cursorStyle);
  var labelPositionOutside = isPolar ? isHorizontalOrRadial ? layout2.r >= layout2.r0 ? "endArc" : "startArc" : layout2.endAngle >= layout2.startAngle ? "endAngle" : "startAngle" : isHorizontalOrRadial ? layout2.height >= 0 ? "bottom" : "top" : layout2.width >= 0 ? "right" : "left";
  var labelStatesModels = getLabelStatesModels(itemModel);
  setLabelStyle(el, labelStatesModels, {
    labelFetcher: seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(seriesModel.getData(), dataIndex),
    inheritColor: style.fill,
    defaultOpacity: style.opacity,
    defaultOutsidePosition: labelPositionOutside
  });
  var label = el.getTextContent();
  if (isPolar && label) {
    var position2 = itemModel.get(["label", "position"]);
    el.textConfig.inside = position2 === "middle" ? true : null;
    setSectorTextRotation(el, position2 === "outside" ? labelPositionOutside : position2, createPolarPositionMapping(isHorizontalOrRadial), itemModel.get(["label", "rotate"]));
  }
  setLabelValueAnimation(label, labelStatesModels, seriesModel.getRawValue(dataIndex), function(value) {
    return getDefaultInterpolatedLabel(data, value);
  });
  var emphasisModel = itemModel.getModel(["emphasis"]);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  setStatesStylesFromModel(el, itemModel);
  if (isZeroOnPolar(layout2)) {
    el.style.fill = "none";
    el.style.stroke = "none";
    each$f(el.states, function(state) {
      if (state.style) {
        state.style.fill = state.style.stroke = "none";
      }
    });
  }
}
function getLineWidth(itemModel, rawLayout) {
  var borderColor = itemModel.get(["itemStyle", "borderColor"]);
  if (!borderColor || borderColor === "none") {
    return 0;
  }
  var lineWidth = itemModel.get(["itemStyle", "borderWidth"]) || 0;
  var width = isNaN(rawLayout.width) ? Number.MAX_VALUE : Math.abs(rawLayout.width);
  var height = isNaN(rawLayout.height) ? Number.MAX_VALUE : Math.abs(rawLayout.height);
  return Math.min(lineWidth, width, height);
}
var LagePathShape = function() {
  function LagePathShape2() {
  }
  return LagePathShape2;
}();
var LargePath = function(_super) {
  __extends(LargePath2, _super);
  function LargePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeBar";
    return _this;
  }
  LargePath2.prototype.getDefaultShape = function() {
    return new LagePathShape();
  };
  LargePath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    var baseDimIdx = this.baseDimIdx;
    var valueDimIdx = 1 - this.baseDimIdx;
    var startPoint = [];
    var size = [];
    var barWidth = this.barWidth;
    for (var i = 0; i < points2.length; i += 3) {
      size[baseDimIdx] = barWidth;
      size[valueDimIdx] = points2[i + 2];
      startPoint[baseDimIdx] = points2[i + baseDimIdx];
      startPoint[valueDimIdx] = points2[i + valueDimIdx];
      ctx.rect(startPoint[0], startPoint[1], size[0], size[1]);
    }
  };
  return LargePath2;
}(Path$1);
function createLarge$1(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var baseDimIdx = data.getLayout("valueAxisHorizontal") ? 1 : 0;
  var largeDataIndices = data.getLayout("largeDataIndices");
  var barWidth = data.getLayout("size");
  var backgroundModel = seriesModel.getModel("backgroundStyle");
  var bgPoints = data.getLayout("largeBackgroundPoints");
  if (bgPoints) {
    var bgEl = new LargePath({
      shape: {
        points: bgPoints
      },
      incremental: !!incremental,
      silent: true,
      z2: 0
    });
    bgEl.baseDimIdx = baseDimIdx;
    bgEl.largeDataIndices = largeDataIndices;
    bgEl.barWidth = barWidth;
    bgEl.useStyle(backgroundModel.getItemStyle());
    group.add(bgEl);
    progressiveEls && progressiveEls.push(bgEl);
  }
  var el = new LargePath({
    shape: {
      points: data.getLayout("largePoints")
    },
    incremental: !!incremental,
    z2: 1
  });
  el.baseDimIdx = baseDimIdx;
  el.largeDataIndices = largeDataIndices;
  el.barWidth = barWidth;
  group.add(el);
  el.useStyle(data.getVisual("style"));
  getECData(el).seriesIndex = seriesModel.seriesIndex;
  if (!seriesModel.get("silent")) {
    el.on("mousedown", largePathUpdateDataIndex);
    el.on("mousemove", largePathUpdateDataIndex);
  }
  progressiveEls && progressiveEls.push(el);
}
var largePathUpdateDataIndex = throttle(function(event) {
  var largePath = this;
  var dataIndex = largePathFindDataIndex(largePath, event.offsetX, event.offsetY);
  getECData(largePath).dataIndex = dataIndex >= 0 ? dataIndex : null;
}, 30, false);
function largePathFindDataIndex(largePath, x2, y2) {
  var baseDimIdx = largePath.baseDimIdx;
  var valueDimIdx = 1 - baseDimIdx;
  var points2 = largePath.shape.points;
  var largeDataIndices = largePath.largeDataIndices;
  var startPoint = [];
  var size = [];
  var barWidth = largePath.barWidth;
  for (var i = 0, len2 = points2.length / 3; i < len2; i++) {
    var ii = i * 3;
    size[baseDimIdx] = barWidth;
    size[valueDimIdx] = points2[ii + 2];
    startPoint[baseDimIdx] = points2[ii + baseDimIdx];
    startPoint[valueDimIdx] = points2[ii + valueDimIdx];
    if (size[valueDimIdx] < 0) {
      startPoint[valueDimIdx] += size[valueDimIdx];
      size[valueDimIdx] = -size[valueDimIdx];
    }
    if (x2 >= startPoint[0] && x2 <= startPoint[0] + size[0] && y2 >= startPoint[1] && y2 <= startPoint[1] + size[1]) {
      return largeDataIndices[i];
    }
  }
  return -1;
}
function createBackgroundShape(isHorizontalOrRadial, layout2, coord) {
  if (isCoordinateSystemType(coord, "cartesian2d")) {
    var rectShape = layout2;
    var coordLayout = coord.getArea();
    return {
      x: isHorizontalOrRadial ? rectShape.x : coordLayout.x,
      y: isHorizontalOrRadial ? coordLayout.y : rectShape.y,
      width: isHorizontalOrRadial ? rectShape.width : coordLayout.width,
      height: isHorizontalOrRadial ? coordLayout.height : rectShape.height
    };
  } else {
    var coordLayout = coord.getArea();
    var sectorShape = layout2;
    return {
      cx: coordLayout.cx,
      cy: coordLayout.cy,
      r0: isHorizontalOrRadial ? coordLayout.r0 : sectorShape.r0,
      r: isHorizontalOrRadial ? coordLayout.r : sectorShape.r,
      startAngle: isHorizontalOrRadial ? sectorShape.startAngle : 0,
      endAngle: isHorizontalOrRadial ? sectorShape.endAngle : Math.PI * 2
    };
  }
}
function createBackgroundEl(coord, isHorizontalOrRadial, layout2) {
  var ElementClz = coord.type === "polar" ? Sector$1 : Rect$3;
  return new ElementClz({
    shape: createBackgroundShape(isHorizontalOrRadial, layout2, coord),
    silent: true,
    z2: 0
  });
}
var BarView$1 = BarView;
function install$P(registers) {
  registers.registerChartView(BarView$1);
  registers.registerSeriesModel(BarSeries);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "bar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("bar"));
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, dataSample("bar"));
  registers.registerAction({
    type: "changeAxisOrder",
    event: "changeAxisOrder",
    update: "update"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      if (payload.sortInfo) {
        componentModel.axis.setCategorySortInfo(payload.sortInfo);
      }
    });
  });
}
var PI2$1 = Math.PI * 2;
var RADIAN$2 = Math.PI / 180;
function getViewRect$5(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getBasicPieLayout(seriesModel, api) {
  var viewRect2 = getViewRect$5(seriesModel, api);
  var center2 = seriesModel.get("center");
  var radius = seriesModel.get("radius");
  if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  if (!isArray$1(center2)) {
    center2 = [center2, center2];
  }
  var width = parsePercent(viewRect2.width, api.getWidth());
  var height = parsePercent(viewRect2.height, api.getHeight());
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], width) + viewRect2.x;
  var cy = parsePercent(center2[1], height) + viewRect2.y;
  var r0 = parsePercent(radius[0], size / 2);
  var r2 = parsePercent(radius[1], size / 2);
  return {
    cx,
    cy,
    r0,
    r: r2
  };
}
function pieLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var viewRect2 = getViewRect$5(seriesModel, api);
    var _a2 = getBasicPieLayout(seriesModel, api), cx = _a2.cx, cy = _a2.cy, r2 = _a2.r, r0 = _a2.r0;
    var startAngle = -seriesModel.get("startAngle") * RADIAN$2;
    var minAngle = seriesModel.get("minAngle") * RADIAN$2;
    var validDataCount = 0;
    data.each(valueDim, function(value) {
      !isNaN(value) && validDataCount++;
    });
    var sum2 = data.getSum(valueDim);
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var clockwise = seriesModel.get("clockwise");
    var roseType = seriesModel.get("roseType");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var extent3 = data.getDataExtent(valueDim);
    extent3[0] = 0;
    var restAngle = PI2$1;
    var valueSumLargerThanMinAngle = 0;
    var currentAngle = startAngle;
    var dir3 = clockwise ? 1 : -1;
    data.setLayout({
      viewRect: viewRect2,
      r: r2
    });
    data.each(valueDim, function(value, idx) {
      var angle;
      if (isNaN(value)) {
        data.setItemLayout(idx, {
          angle: NaN,
          startAngle: NaN,
          endAngle: NaN,
          clockwise,
          cx,
          cy,
          r0,
          r: roseType ? NaN : r2
        });
        return;
      }
      if (roseType !== "area") {
        angle = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
      } else {
        angle = PI2$1 / validDataCount;
      }
      if (angle < minAngle) {
        angle = minAngle;
        restAngle -= minAngle;
      } else {
        valueSumLargerThanMinAngle += value;
      }
      var endAngle = currentAngle + dir3 * angle;
      data.setItemLayout(idx, {
        angle,
        startAngle: currentAngle,
        endAngle,
        clockwise,
        cx,
        cy,
        r0,
        r: roseType ? linearMap$2(value, extent3, [r0, r2]) : r2
      });
      currentAngle = endAngle;
    });
    if (restAngle < PI2$1 && validDataCount) {
      if (restAngle <= 1e-3) {
        var angle_1 = PI2$1 / validDataCount;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_1 = data.getItemLayout(idx);
            layout_1.angle = angle_1;
            layout_1.startAngle = startAngle + dir3 * idx * angle_1;
            layout_1.endAngle = startAngle + dir3 * (idx + 1) * angle_1;
          }
        });
      } else {
        unitRadian = restAngle / valueSumLargerThanMinAngle;
        currentAngle = startAngle;
        data.each(valueDim, function(value, idx) {
          if (!isNaN(value)) {
            var layout_2 = data.getItemLayout(idx);
            var angle = layout_2.angle === minAngle ? minAngle : value * unitRadian;
            layout_2.startAngle = currentAngle;
            layout_2.endAngle = currentAngle + dir3 * angle;
            currentAngle += dir3 * angle;
          }
        });
      }
    }
  });
}
function dataFilter$1(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var legendModels = ecModel.findComponents({
        mainType: "legend"
      });
      if (!legendModels || !legendModels.length) {
        return;
      }
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var name = data.getName(idx);
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(name)) {
            return false;
          }
        }
        return true;
      });
    }
  };
}
var RADIAN$1 = Math.PI / 180;
function adjustSingleSide(list, cx, cy, r2, dir3, viewWidth, viewHeight, viewLeft, viewTop, farthestX) {
  if (list.length < 2) {
    return;
  }
  function recalculateXOnSemiToAlignOnEllipseCurve(semi) {
    var rB = semi.rB;
    var rB2 = rB * rB;
    for (var i2 = 0; i2 < semi.list.length; i2++) {
      var item = semi.list[i2];
      var dy = Math.abs(item.label.y - cy);
      var rA = r2 + item.len;
      var rA2 = rA * rA;
      var dx2 = Math.sqrt((1 - Math.abs(dy * dy / rB2)) * rA2);
      var newX = cx + (dx2 + item.len2) * dir3;
      var deltaX = newX - item.label.x;
      var newTargetWidth = item.targetTextWidth - deltaX * dir3;
      constrainTextWidth(item, newTargetWidth, true);
      item.label.x = newX;
    }
  }
  function recalculateX(items) {
    var topSemi = {
      list: [],
      maxY: 0
    };
    var bottomSemi = {
      list: [],
      maxY: 0
    };
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].labelAlignTo !== "none") {
        continue;
      }
      var item = items[i2];
      var semi = item.label.y > cy ? bottomSemi : topSemi;
      var dy = Math.abs(item.label.y - cy);
      if (dy >= semi.maxY) {
        var dx2 = item.label.x - cx - item.len2 * dir3;
        var rA = r2 + item.len;
        var rB = Math.abs(dx2) < rA ? Math.sqrt(dy * dy / (1 - dx2 * dx2 / rA / rA)) : rA;
        semi.rB = rB;
        semi.maxY = dy;
      }
      semi.list.push(item);
    }
    recalculateXOnSemiToAlignOnEllipseCurve(topSemi);
    recalculateXOnSemiToAlignOnEllipseCurve(bottomSemi);
  }
  var len2 = list.length;
  for (var i = 0; i < len2; i++) {
    if (list[i].position === "outer" && list[i].labelAlignTo === "labelLine") {
      var dx = list[i].label.x - farthestX;
      list[i].linePoints[1][0] += dx;
      list[i].label.x = farthestX;
    }
  }
  if (shiftLayoutOnY(list, viewTop, viewTop + viewHeight)) {
    recalculateX(list);
  }
}
function avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop) {
  var leftList = [];
  var rightList = [];
  var leftmostX = Number.MAX_VALUE;
  var rightmostX = -Number.MAX_VALUE;
  for (var i = 0; i < labelLayoutList.length; i++) {
    var label = labelLayoutList[i].label;
    if (isPositionCenter(labelLayoutList[i])) {
      continue;
    }
    if (label.x < cx) {
      leftmostX = Math.min(leftmostX, label.x);
      leftList.push(labelLayoutList[i]);
    } else {
      rightmostX = Math.max(rightmostX, label.x);
      rightList.push(labelLayoutList[i]);
    }
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      if (layout2.labelStyleWidth != null) {
        continue;
      }
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var targetTextWidth = void 0;
      if (layout2.labelAlignTo === "edge") {
        if (label.x < cx) {
          targetTextWidth = linePoints[2][0] - layout2.labelDistance - viewLeft - layout2.edgeDistance;
        } else {
          targetTextWidth = viewLeft + viewWidth - layout2.edgeDistance - linePoints[2][0] - layout2.labelDistance;
        }
      } else if (layout2.labelAlignTo === "labelLine") {
        if (label.x < cx) {
          targetTextWidth = leftmostX - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - rightmostX - layout2.bleedMargin;
        }
      } else {
        if (label.x < cx) {
          targetTextWidth = label.x - viewLeft - layout2.bleedMargin;
        } else {
          targetTextWidth = viewLeft + viewWidth - label.x - layout2.bleedMargin;
        }
      }
      layout2.targetTextWidth = targetTextWidth;
      constrainTextWidth(layout2, targetTextWidth);
    }
  }
  adjustSingleSide(rightList, cx, cy, r2, 1, viewWidth, viewHeight, viewLeft, viewTop, rightmostX);
  adjustSingleSide(leftList, cx, cy, r2, -1, viewWidth, viewHeight, viewLeft, viewTop, leftmostX);
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    if (!isPositionCenter(layout2) && layout2.linePoints) {
      var label = layout2.label;
      var linePoints = layout2.linePoints;
      var isAlignToEdge = layout2.labelAlignTo === "edge";
      var padding = label.style.padding;
      var paddingH = padding ? padding[1] + padding[3] : 0;
      var extraPaddingH = label.style.backgroundColor ? 0 : paddingH;
      var realTextWidth = layout2.rect.width + extraPaddingH;
      var dist2 = linePoints[1][0] - linePoints[2][0];
      if (isAlignToEdge) {
        if (label.x < cx) {
          linePoints[2][0] = viewLeft + layout2.edgeDistance + realTextWidth + layout2.labelDistance;
        } else {
          linePoints[2][0] = viewLeft + viewWidth - layout2.edgeDistance - realTextWidth - layout2.labelDistance;
        }
      } else {
        if (label.x < cx) {
          linePoints[2][0] = label.x + layout2.labelDistance;
        } else {
          linePoints[2][0] = label.x - layout2.labelDistance;
        }
        linePoints[1][0] = linePoints[2][0] + dist2;
      }
      linePoints[1][1] = linePoints[2][1] = label.y;
    }
  }
}
function constrainTextWidth(layout2, availableWidth, forceRecalculate) {
  if (forceRecalculate === void 0) {
    forceRecalculate = false;
  }
  if (layout2.labelStyleWidth != null) {
    return;
  }
  var label = layout2.label;
  var style = label.style;
  var textRect = layout2.rect;
  var bgColor = style.backgroundColor;
  var padding = style.padding;
  var paddingH = padding ? padding[1] + padding[3] : 0;
  var overflow = style.overflow;
  var oldOuterWidth = textRect.width + (bgColor ? 0 : paddingH);
  if (availableWidth < oldOuterWidth || forceRecalculate) {
    var oldHeight = textRect.height;
    if (overflow && overflow.match("break")) {
      label.setStyle("backgroundColor", null);
      label.setStyle("width", availableWidth - paddingH);
      var innerRect = label.getBoundingRect();
      label.setStyle("width", Math.ceil(innerRect.width));
      label.setStyle("backgroundColor", bgColor);
    } else {
      var availableInnerWidth = availableWidth - paddingH;
      var newWidth = availableWidth < oldOuterWidth ? availableInnerWidth : forceRecalculate ? availableInnerWidth > layout2.unconstrainedWidth ? null : availableInnerWidth : null;
      label.setStyle("width", newWidth);
    }
    var newRect = label.getBoundingRect();
    textRect.width = newRect.width;
    var margin = (label.style.margin || 0) + 2.1;
    textRect.height = newRect.height + margin;
    textRect.y -= (textRect.height - oldHeight) / 2;
  }
}
function isPositionCenter(sectorShape) {
  return sectorShape.position === "center";
}
function pieLabelLayout(seriesModel) {
  var data = seriesModel.getData();
  var labelLayoutList = [];
  var cx;
  var cy;
  var hasLabelRotate = false;
  var minShowLabelRadian = (seriesModel.get("minShowLabelAngle") || 0) * RADIAN$1;
  var viewRect2 = data.getLayout("viewRect");
  var r2 = data.getLayout("r");
  var viewWidth = viewRect2.width;
  var viewLeft = viewRect2.x;
  var viewTop = viewRect2.y;
  var viewHeight = viewRect2.height;
  function setNotShow(el) {
    el.ignore = true;
  }
  function isLabelShown(label2) {
    if (!label2.ignore) {
      return true;
    }
    for (var key in label2.states) {
      if (label2.states[key].ignore === false) {
        return true;
      }
    }
    return false;
  }
  data.each(function(idx) {
    var sector = data.getItemGraphicEl(idx);
    var sectorShape = sector.shape;
    var label2 = sector.getTextContent();
    var labelLine2 = sector.getTextGuideLine();
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position") || itemModel.get(["emphasis", "label", "position"]);
    var labelDistance = labelModel.get("distanceToLabelLine");
    var labelAlignTo = labelModel.get("alignTo");
    var edgeDistance = parsePercent(labelModel.get("edgeDistance"), viewWidth);
    var bleedMargin = labelModel.get("bleedMargin");
    var labelLineModel = itemModel.getModel("labelLine");
    var labelLineLen = labelLineModel.get("length");
    labelLineLen = parsePercent(labelLineLen, viewWidth);
    var labelLineLen2 = labelLineModel.get("length2");
    labelLineLen2 = parsePercent(labelLineLen2, viewWidth);
    if (Math.abs(sectorShape.endAngle - sectorShape.startAngle) < minShowLabelRadian) {
      each$f(label2.states, setNotShow);
      label2.ignore = true;
      return;
    }
    if (!isLabelShown(label2)) {
      return;
    }
    var midAngle = (sectorShape.startAngle + sectorShape.endAngle) / 2;
    var nx = Math.cos(midAngle);
    var ny = Math.sin(midAngle);
    var textX;
    var textY;
    var linePoints2;
    var textAlign;
    cx = sectorShape.cx;
    cy = sectorShape.cy;
    var isLabelInside = labelPosition === "inside" || labelPosition === "inner";
    if (labelPosition === "center") {
      textX = sectorShape.cx;
      textY = sectorShape.cy;
      textAlign = "center";
    } else {
      var x1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * nx : sectorShape.r * nx) + cx;
      var y1 = (isLabelInside ? (sectorShape.r + sectorShape.r0) / 2 * ny : sectorShape.r * ny) + cy;
      textX = x1 + nx * 3;
      textY = y1 + ny * 3;
      if (!isLabelInside) {
        var x2 = x1 + nx * (labelLineLen + r2 - sectorShape.r);
        var y2 = y1 + ny * (labelLineLen + r2 - sectorShape.r);
        var x3 = x2 + (nx < 0 ? -1 : 1) * labelLineLen2;
        var y3 = y2;
        if (labelAlignTo === "edge") {
          textX = nx < 0 ? viewLeft + edgeDistance : viewLeft + viewWidth - edgeDistance;
        } else {
          textX = x3 + (nx < 0 ? -labelDistance : labelDistance);
        }
        textY = y3;
        linePoints2 = [[x1, y1], [x2, y2], [x3, y3]];
      }
      textAlign = isLabelInside ? "center" : labelAlignTo === "edge" ? nx > 0 ? "right" : "left" : nx > 0 ? "left" : "right";
    }
    var PI3 = Math.PI;
    var labelRotate = 0;
    var rotate2 = labelModel.get("rotate");
    if (isNumber(rotate2)) {
      labelRotate = rotate2 * (PI3 / 180);
    } else if (labelPosition === "center") {
      labelRotate = 0;
    } else if (rotate2 === "radial" || rotate2 === true) {
      var radialAngle = nx < 0 ? -midAngle + PI3 : -midAngle;
      labelRotate = radialAngle;
    } else if (rotate2 === "tangential" && labelPosition !== "outside" && labelPosition !== "outer") {
      var rad = Math.atan2(nx, ny);
      if (rad < 0) {
        rad = PI3 * 2 + rad;
      }
      var isDown = ny > 0;
      if (isDown) {
        rad = PI3 + rad;
      }
      labelRotate = rad - PI3;
    }
    hasLabelRotate = !!labelRotate;
    label2.x = textX;
    label2.y = textY;
    label2.rotation = labelRotate;
    label2.setStyle({
      verticalAlign: "middle"
    });
    if (!isLabelInside) {
      var textRect = label2.getBoundingRect().clone();
      textRect.applyTransform(label2.getComputedTransform());
      var margin = (label2.style.margin || 0) + 2.1;
      textRect.y -= margin / 2;
      textRect.height += margin;
      labelLayoutList.push({
        label: label2,
        labelLine: labelLine2,
        position: labelPosition,
        len: labelLineLen,
        len2: labelLineLen2,
        minTurnAngle: labelLineModel.get("minTurnAngle"),
        maxSurfaceAngle: labelLineModel.get("maxSurfaceAngle"),
        surfaceNormal: new Point$1(nx, ny),
        linePoints: linePoints2,
        textAlign,
        labelDistance,
        labelAlignTo,
        edgeDistance,
        bleedMargin,
        rect: textRect,
        unconstrainedWidth: textRect.width,
        labelStyleWidth: label2.style.width
      });
    } else {
      label2.setStyle({
        align: textAlign
      });
      var selectState2 = label2.states.select;
      if (selectState2) {
        selectState2.x += label2.x;
        selectState2.y += label2.y;
      }
    }
    sector.setTextConfig({
      inside: isLabelInside
    });
  });
  if (!hasLabelRotate && seriesModel.get("avoidLabelOverlap")) {
    avoidOverlap(labelLayoutList, cx, cy, r2, viewWidth, viewHeight, viewLeft, viewTop);
  }
  for (var i = 0; i < labelLayoutList.length; i++) {
    var layout2 = labelLayoutList[i];
    var label = layout2.label;
    var labelLine = layout2.labelLine;
    var notShowLabel = isNaN(label.x) || isNaN(label.y);
    if (label) {
      label.setStyle({
        align: layout2.textAlign
      });
      if (notShowLabel) {
        each$f(label.states, setNotShow);
        label.ignore = true;
      }
      var selectState = label.states.select;
      if (selectState) {
        selectState.x += label.x;
        selectState.y += label.y;
      }
    }
    if (labelLine) {
      var linePoints = layout2.linePoints;
      if (notShowLabel || !linePoints) {
        each$f(labelLine.states, setNotShow);
        labelLine.ignore = true;
      } else {
        limitTurnAngle(linePoints, layout2.minTurnAngle);
        limitSurfaceAngle(linePoints, layout2.surfaceNormal, layout2.maxSurfaceAngle);
        labelLine.setShape({
          points: linePoints
        });
        label.__hostTarget.textGuideLineConfig = {
          anchor: new Point$1(linePoints[0][0], linePoints[0][1])
        };
      }
    }
  }
}
function getSectorCornerRadius(model, shape, zeroIfNull) {
  var cornerRadius = model.get("borderRadius");
  if (cornerRadius == null) {
    return zeroIfNull ? {
      cornerRadius: 0
    } : null;
  }
  if (!isArray$1(cornerRadius)) {
    cornerRadius = [cornerRadius, cornerRadius, cornerRadius, cornerRadius];
  }
  var dr = Math.abs(shape.r || 0 - shape.r0 || 0);
  return {
    cornerRadius: map$1(cornerRadius, function(cr) {
      return parsePercent$1(cr, dr);
    })
  };
}
var PiePiece = function(_super) {
  __extends(PiePiece2, _super);
  function PiePiece2(data, idx, startAngle) {
    var _this = _super.call(this) || this;
    _this.z2 = 2;
    var text = new ZRText$1();
    _this.setTextContent(text);
    _this.updateData(data, idx, startAngle, true);
    return _this;
  }
  PiePiece2.prototype.updateData = function(data, idx, startAngle, firstCreate) {
    var sector = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = data.getItemLayout(idx);
    var sectorShape = extend(getSectorCornerRadius(itemModel.getModel("itemStyle"), layout2, true), layout2);
    if (isNaN(sectorShape.startAngle)) {
      sector.setShape(sectorShape);
      return;
    }
    if (firstCreate) {
      sector.setShape(sectorShape);
      var animationType = seriesModel.getShallow("animationType");
      if (seriesModel.ecModel.ssr) {
        initProps(sector, {
          scaleX: 0,
          scaleY: 0
        }, seriesModel, {
          dataIndex: idx,
          isFrom: true
        });
        sector.originX = sectorShape.cx;
        sector.originY = sectorShape.cy;
      } else if (animationType === "scale") {
        sector.shape.r = layout2.r0;
        initProps(sector, {
          shape: {
            r: layout2.r
          }
        }, seriesModel, idx);
      } else {
        if (startAngle != null) {
          sector.setShape({
            startAngle,
            endAngle: startAngle
          });
          initProps(sector, {
            shape: {
              startAngle: layout2.startAngle,
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        } else {
          sector.shape.endAngle = layout2.startAngle;
          updateProps$1(sector, {
            shape: {
              endAngle: layout2.endAngle
            }
          }, seriesModel, idx);
        }
      }
    } else {
      saveOldStyle(sector);
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel, idx);
    }
    sector.useStyle(data.getItemVisual(idx, "style"));
    setStatesStylesFromModel(sector, itemModel);
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var offset = seriesModel.get("selectedOffset");
    var dx = Math.cos(midAngle) * offset;
    var dy = Math.sin(midAngle) * offset;
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._updateLabel(seriesModel, data, idx);
    sector.ensureState("emphasis").shape = extend({
      r: layout2.r + (emphasisModel.get("scale") ? emphasisModel.get("scaleSize") || 0 : 0)
    }, getSectorCornerRadius(emphasisModel.getModel("itemStyle"), layout2));
    extend(sector.ensureState("select"), {
      x: dx,
      y: dy,
      shape: getSectorCornerRadius(itemModel.getModel(["select", "itemStyle"]), layout2)
    });
    extend(sector.ensureState("blur"), {
      shape: getSectorCornerRadius(itemModel.getModel(["blur", "itemStyle"]), layout2)
    });
    var labelLine = sector.getTextGuideLine();
    var labelText = sector.getTextContent();
    labelLine && extend(labelLine.ensureState("select"), {
      x: dx,
      y: dy
    });
    extend(labelText.ensureState("select"), {
      x: dx,
      y: dy
    });
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  PiePiece2.prototype._updateLabel = function(seriesModel, data, idx) {
    var sector = this;
    var itemModel = data.getItemModel(idx);
    var labelLineModel = itemModel.getModel("labelLine");
    var style = data.getItemVisual(idx, "style");
    var visualColor = style && style.fill;
    var visualOpacity = style && style.opacity;
    setLabelStyle(sector, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      defaultText: seriesModel.getFormattedLabel(idx, "normal") || data.getName(idx)
    });
    var labelText = sector.getTextContent();
    sector.setTextConfig({
      position: null,
      rotation: null
    });
    labelText.attr({
      z2: 10
    });
    var labelPosition = seriesModel.get(["label", "position"]);
    if (labelPosition !== "outside" && labelPosition !== "outer") {
      sector.removeTextGuideLine();
    } else {
      var polyline = this.getTextGuideLine();
      if (!polyline) {
        polyline = new Polyline$3();
        this.setTextGuideLine(polyline);
      }
      setLabelLineStyle(this, getLabelLineStatesModels(itemModel), {
        stroke: visualColor,
        opacity: retrieve3(labelLineModel.get(["lineStyle", "opacity"]), visualOpacity, 1)
      });
    }
  };
  return PiePiece2;
}(Sector$1);
var PieView = function(_super) {
  __extends(PieView2, _super);
  function PieView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  PieView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var startAngle;
    if (!oldData && data.count() > 0) {
      var shape = data.getItemLayout(0);
      for (var s = 1; isNaN(shape && shape.startAngle) && s < data.count(); ++s) {
        shape = data.getItemLayout(s);
      }
      if (shape) {
        startAngle = shape.startAngle;
      }
    }
    if (this._emptyCircleSector) {
      group.remove(this._emptyCircleSector);
    }
    if (data.count() === 0 && seriesModel.get("showEmptyCircle")) {
      var sector = new Sector$1({
        shape: getBasicPieLayout(seriesModel, api)
      });
      sector.useStyle(seriesModel.getModel("emptyCircleStyle").getItemStyle());
      this._emptyCircleSector = sector;
      group.add(sector);
    }
    data.diff(oldData).add(function(idx) {
      var piePiece = new PiePiece(data, idx, startAngle);
      data.setItemGraphicEl(idx, piePiece);
      group.add(piePiece);
    }).update(function(newIdx, oldIdx) {
      var piePiece = oldData.getItemGraphicEl(oldIdx);
      piePiece.updateData(data, newIdx, startAngle);
      piePiece.off("click");
      group.add(piePiece);
      data.setItemGraphicEl(newIdx, piePiece);
    }).remove(function(idx) {
      var piePiece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piePiece, seriesModel, idx);
    }).execute();
    pieLabelLayout(seriesModel);
    if (seriesModel.get("animationTypeUpdate") !== "expansion") {
      this._data = data;
    }
  };
  PieView2.prototype.dispose = function() {
  };
  PieView2.prototype.containPoint = function(point, seriesModel) {
    var data = seriesModel.getData();
    var itemLayout = data.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  PieView2.type = "pie";
  return PieView2;
}(ChartView$1);
var PieView$1 = PieView;
function createSeriesDataSimply(seriesModel, opt, nameList) {
  opt = isArray$1(opt) && {
    coordDimensions: opt
  } || extend({
    encodeDefine: seriesModel.getEncode()
  }, opt);
  var source = seriesModel.getSource();
  var dimensions = prepareSeriesDataSchema(source, opt).dimensions;
  var list = new SeriesData$1(dimensions, seriesModel);
  list.initData(source, nameList);
  return list;
}
var LegendVisualProvider = function() {
  function LegendVisualProvider2(getDataWithEncodedVisual, getRawData2) {
    this._getDataWithEncodedVisual = getDataWithEncodedVisual;
    this._getRawData = getRawData2;
  }
  LegendVisualProvider2.prototype.getAllNames = function() {
    var rawData = this._getRawData();
    return rawData.mapArray(rawData.getName);
  };
  LegendVisualProvider2.prototype.containName = function(name) {
    var rawData = this._getRawData();
    return rawData.indexOfName(name) >= 0;
  };
  LegendVisualProvider2.prototype.indexOfName = function(name) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.indexOfName(name);
  };
  LegendVisualProvider2.prototype.getItemVisual = function(dataIndex, key) {
    var dataWithEncodedVisual = this._getDataWithEncodedVisual();
    return dataWithEncodedVisual.getItemVisual(dataIndex, key);
  };
  return LegendVisualProvider2;
}();
var LegendVisualProvider$1 = LegendVisualProvider;
var PieSeriesModel = function(_super) {
  __extends(PieSeriesModel2, _super);
  function PieSeriesModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PieSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  PieSeriesModel2.prototype.mergeOption = function() {
    _super.prototype.mergeOption.apply(this, arguments);
  };
  PieSeriesModel2.prototype.getInitialData = function() {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  PieSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueList = [];
    data.each(data.mapDimension("value"), function(value) {
      valueList.push(value);
    });
    params.percent = getPercentWithPrecision(valueList, dataIndex, data.hostModel.get("percentPrecision"));
    params.$vars.push("percent");
    return params;
  };
  PieSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  PieSeriesModel2.type = "series.pie";
  PieSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    minShowLabelAngle: 0,
    selectedOffset: 10,
    percentPrecision: 2,
    stillShowZeroSum: true,
    left: 0,
    top: 0,
    right: 0,
    bottom: 0,
    width: null,
    height: null,
    label: {
      rotate: 0,
      show: true,
      overflow: "truncate",
      position: "outer",
      alignTo: "none",
      edgeDistance: "25%",
      bleedMargin: 10,
      distanceToLabelLine: 5
    },
    labelLine: {
      show: true,
      length: 15,
      length2: 15,
      smooth: false,
      minTurnAngle: 90,
      maxSurfaceAngle: 90,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      borderWidth: 1,
      borderJoin: "round"
    },
    showEmptyCircle: true,
    emptyCircleStyle: {
      color: "lightgray",
      opacity: 1
    },
    labelLayout: {
      hideOverlap: true
    },
    emphasis: {
      scale: true,
      scaleSize: 5
    },
    avoidLabelOverlap: true,
    animationType: "expansion",
    animationDuration: 1e3,
    animationTypeUpdate: "transition",
    animationEasingUpdate: "cubicInOut",
    animationDurationUpdate: 500,
    animationEasing: "cubicInOut"
  };
  return PieSeriesModel2;
}(SeriesModel$1);
var PieSeriesModel$1 = PieSeriesModel;
function negativeDataFilter(seriesType2) {
  return {
    seriesType: seriesType2,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      data.filterSelf(function(idx) {
        var valueDim = data.mapDimension("value");
        var curValue = data.get(valueDim, idx);
        if (isNumber(curValue) && !isNaN(curValue) && curValue < 0) {
          return false;
        }
        return true;
      });
    }
  };
}
function install$O(registers) {
  registers.registerChartView(PieView$1);
  registers.registerSeriesModel(PieSeriesModel$1);
  createLegacyDataSelectAction("pie", registers.registerAction);
  registers.registerLayout(curry$1(pieLayout, "pie"));
  registers.registerProcessor(dataFilter$1("pie"));
  registers.registerProcessor(negativeDataFilter("pie"));
}
var ScatterSeriesModel = function(_super) {
  __extends(ScatterSeriesModel2, _super);
  function ScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  ScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  ScatterSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 5e3 : this.get("progressive");
    }
    return progressive;
  };
  ScatterSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 1e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  ScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  ScatterSeriesModel2.prototype.getZLevelKey = function() {
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
  };
  ScatterSeriesModel2.type = "series.scatter";
  ScatterSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  ScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    symbolSize: 10,
    large: false,
    largeThreshold: 2e3,
    itemStyle: {
      opacity: 0.8
    },
    emphasis: {
      scale: true
    },
    clip: true,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    universalTransition: {
      divideShape: "clone"
    }
  };
  return ScatterSeriesModel2;
}(SeriesModel$1);
var ScatterSeriesModel$1 = ScatterSeriesModel;
var BOOST_SIZE_THRESHOLD = 4;
var LargeSymbolPathShape = function() {
  function LargeSymbolPathShape2() {
  }
  return LargeSymbolPathShape2;
}();
var LargeSymbolPath = function(_super) {
  __extends(LargeSymbolPath2, _super);
  function LargeSymbolPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeSymbolPath2.prototype.getDefaultShape = function() {
    return new LargeSymbolPathShape();
  };
  LargeSymbolPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeSymbolPath2.prototype.buildPath = function(path, shape) {
    var points2 = shape.points;
    var size = shape.size;
    var symbolProxy = this.symbolProxy;
    var symbolProxyShape = symbolProxy.shape;
    var ctx = path.getContext ? path.getContext() : path;
    var canBoost = ctx && size[0] < BOOST_SIZE_THRESHOLD;
    var softClipShape = this.softClipShape;
    var i;
    if (canBoost) {
      this._ctx = ctx;
      return;
    }
    this._ctx = null;
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      symbolProxyShape.x = x2 - size[0] / 2;
      symbolProxyShape.y = y2 - size[1] / 2;
      symbolProxyShape.width = size[0];
      symbolProxyShape.height = size[1];
      symbolProxy.buildPath(path, symbolProxyShape, true);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.afterBrush = function() {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var ctx = this._ctx;
    var softClipShape = this.softClipShape;
    var i;
    if (!ctx) {
      return;
    }
    for (i = this._off; i < points2.length; ) {
      var x2 = points2[i++];
      var y2 = points2[i++];
      if (isNaN(x2) || isNaN(y2)) {
        continue;
      }
      if (softClipShape && !softClipShape.contain(x2, y2)) {
        continue;
      }
      ctx.fillRect(x2 - size[0] / 2, y2 - size[1] / 2, size[0], size[1]);
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeSymbolPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var points2 = shape.points;
    var size = shape.size;
    var w2 = Math.max(size[0], 4);
    var h = Math.max(size[1], 4);
    for (var idx = points2.length / 2 - 1; idx >= 0; idx--) {
      var i = idx * 2;
      var x0 = points2[i] - w2 / 2;
      var y0 = points2[i + 1] - h / 2;
      if (x2 >= x0 && y2 >= y0 && x2 <= x0 + w2 && y2 <= y0 + h) {
        return idx;
      }
    }
    return -1;
  };
  LargeSymbolPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeSymbolPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.points;
      var size = shape.size;
      var w2 = size[0];
      var h = size[1];
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX - w2 / 2, minY - h / 2, maxX - minX + w2, maxY - minY + h);
    }
    return rect;
  };
  return LargeSymbolPath2;
}(Path$1);
var LargeSymbolDraw = function() {
  function LargeSymbolDraw2() {
    this.group = new Group$4();
  }
  LargeSymbolDraw2.prototype.updateData = function(data, opt) {
    this._clear();
    var symbolEl = this._create();
    symbolEl.setShape({
      points: data.getLayout("points")
    });
    this._setCommon(symbolEl, data, opt);
  };
  LargeSymbolDraw2.prototype.updateLayout = function(data) {
    var points2 = data.getLayout("points");
    this.group.eachChild(function(child) {
      if (child.startIndex != null) {
        var len2 = (child.endIndex - child.startIndex) * 2;
        var byteOffset = child.startIndex * 4 * 2;
        points2 = new Float32Array(points2.buffer, byteOffset, len2);
      }
      child.setShape("points", points2);
      child.reset();
    });
  };
  LargeSymbolDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this._clear();
  };
  LargeSymbolDraw2.prototype.incrementalUpdate = function(taskParams, data, opt) {
    var lastAdded = this._newAdded[0];
    var points2 = data.getLayout("points");
    var oldPoints = lastAdded && lastAdded.shape.points;
    if (oldPoints && oldPoints.length < 2e4) {
      var oldLen = oldPoints.length;
      var newPoints = new Float32Array(oldLen + points2.length);
      newPoints.set(oldPoints);
      newPoints.set(points2, oldLen);
      lastAdded.endIndex = taskParams.end;
      lastAdded.setShape({
        points: newPoints
      });
    } else {
      this._newAdded = [];
      var symbolEl = this._create();
      symbolEl.startIndex = taskParams.start;
      symbolEl.endIndex = taskParams.end;
      symbolEl.incremental = true;
      symbolEl.setShape({
        points: points2
      });
      this._setCommon(symbolEl, data, opt);
    }
  };
  LargeSymbolDraw2.prototype.eachRendered = function(cb) {
    this._newAdded[0] && cb(this._newAdded[0]);
  };
  LargeSymbolDraw2.prototype._create = function() {
    var symbolEl = new LargeSymbolPath({
      cursor: "default"
    });
    this.group.add(symbolEl);
    this._newAdded.push(symbolEl);
    return symbolEl;
  };
  LargeSymbolDraw2.prototype._setCommon = function(symbolEl, data, opt) {
    var hostModel = data.hostModel;
    opt = opt || {};
    var size = data.getVisual("symbolSize");
    symbolEl.setShape("size", size instanceof Array ? size : [size, size]);
    symbolEl.softClipShape = opt.clipShape || null;
    symbolEl.symbolProxy = createSymbol$1(data.getVisual("symbol"), 0, 0, 0, 0);
    symbolEl.setColor = symbolEl.symbolProxy.setColor;
    var extrudeShadow = symbolEl.shape.size[0] < BOOST_SIZE_THRESHOLD;
    symbolEl.useStyle(hostModel.getModel("itemStyle").getItemStyle(extrudeShadow ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
    var globalStyle = data.getVisual("style");
    var visualColor = globalStyle && globalStyle.fill;
    if (visualColor) {
      symbolEl.setColor(visualColor);
    }
    var ecData = getECData(symbolEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    symbolEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = symbolEl.hoverDataIdx;
      if (dataIndex >= 0) {
        ecData.dataIndex = dataIndex + (symbolEl.startIndex || 0);
      }
    });
  };
  LargeSymbolDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeSymbolDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeSymbolDraw2;
}();
var LargeSymbolDraw$1 = LargeSymbolDraw;
var ScatterView = function(_super) {
  __extends(ScatterView2, _super);
  function ScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScatterView2.type;
    return _this;
  }
  ScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = true;
  };
  ScatterView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var symbolDraw = this._updateSymbolDraw(data, seriesModel);
    symbolDraw.incrementalPrepareUpdate(data);
    this._finished = false;
  };
  ScatterView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._symbolDraw.incrementalUpdate(taskParams, seriesModel.getData(), {
      clipShape: this._getClipShape(seriesModel)
    });
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  ScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    if (!this._finished || data.count() > 1e4) {
      return {
        update: true
      };
    } else {
      var res = pointsLayout("").reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._symbolDraw.updateLayout(data);
    }
  };
  ScatterView2.prototype.eachRendered = function(cb) {
    this._symbolDraw && this._symbolDraw.eachRendered(cb);
  };
  ScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  ScatterView2.prototype._updateSymbolDraw = function(data, seriesModel) {
    var symbolDraw = this._symbolDraw;
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!symbolDraw || isLargeDraw !== this._isLargeDraw) {
      symbolDraw && symbolDraw.remove();
      symbolDraw = this._symbolDraw = isLargeDraw ? new LargeSymbolDraw$1() : new SymbolDraw$1();
      this._isLargeDraw = isLargeDraw;
      this.group.removeAll();
    }
    this.group.add(symbolDraw.group);
    return symbolDraw;
  };
  ScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
    this._symbolDraw = null;
  };
  ScatterView2.prototype.dispose = function() {
  };
  ScatterView2.type = "scatter";
  return ScatterView2;
}(ChartView$1);
var ScatterView$1 = ScatterView;
var GridModel = function(_super) {
  __extends(GridModel2, _super);
  function GridModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  GridModel2.type = "grid";
  GridModel2.dependencies = ["xAxis", "yAxis"];
  GridModel2.layoutMode = "box";
  GridModel2.defaultOption = {
    show: false,
    z: 0,
    left: "10%",
    top: 60,
    right: "10%",
    bottom: 70,
    containLabel: false,
    backgroundColor: "rgba(0,0,0,0)",
    borderWidth: 1,
    borderColor: "#ccc"
  };
  return GridModel2;
}(ComponentModel$1);
var GridModel$1 = GridModel;
var CartesianAxisModel = function(_super) {
  __extends(CartesianAxisModel2, _super);
  function CartesianAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("grid", SINGLE_REFERRING).models[0];
  };
  CartesianAxisModel2.type = "cartesian2dAxis";
  return CartesianAxisModel2;
}(ComponentModel$1);
mixin(CartesianAxisModel, AxisModelCommonMixin);
var defaultOption$1 = {
  show: true,
  z: 0,
  inverse: false,
  name: "",
  nameLocation: "end",
  nameRotate: null,
  nameTruncate: {
    maxWidth: null,
    ellipsis: "...",
    placeholder: "."
  },
  nameTextStyle: {},
  nameGap: 15,
  silent: false,
  triggerEvent: false,
  tooltip: {
    show: false
  },
  axisPointer: {},
  axisLine: {
    show: true,
    onZero: true,
    onZeroAxisIndex: null,
    lineStyle: {
      color: "#6E7079",
      width: 1,
      type: "solid"
    },
    symbol: ["none", "none"],
    symbolSize: [10, 15]
  },
  axisTick: {
    show: true,
    inside: false,
    length: 5,
    lineStyle: {
      width: 1
    }
  },
  axisLabel: {
    show: true,
    inside: false,
    rotate: 0,
    showMinLabel: null,
    showMaxLabel: null,
    margin: 8,
    fontSize: 12
  },
  splitLine: {
    show: true,
    lineStyle: {
      color: ["#E0E6F1"],
      width: 1,
      type: "solid"
    }
  },
  splitArea: {
    show: false,
    areaStyle: {
      color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"]
    }
  }
};
var categoryAxis = merge({
  boundaryGap: true,
  deduplication: null,
  splitLine: {
    show: false
  },
  axisTick: {
    alignWithLabel: false,
    interval: "auto"
  },
  axisLabel: {
    interval: "auto"
  }
}, defaultOption$1);
var valueAxis = merge({
  boundaryGap: [0, 0],
  axisLine: {
    show: "auto"
  },
  axisTick: {
    show: "auto"
  },
  splitNumber: 5,
  minorTick: {
    show: false,
    splitNumber: 5,
    length: 3,
    lineStyle: {}
  },
  minorSplitLine: {
    show: false,
    lineStyle: {
      color: "#F4F7FD",
      width: 1
    }
  }
}, defaultOption$1);
var timeAxis = merge({
  splitNumber: 6,
  axisLabel: {
    showMinLabel: false,
    showMaxLabel: false,
    rich: {
      primary: {
        fontWeight: "bold"
      }
    }
  },
  splitLine: {
    show: false
  }
}, valueAxis);
var logAxis = defaults({
  logBase: 10
}, valueAxis);
var axisDefault = {
  category: categoryAxis,
  value: valueAxis,
  time: timeAxis,
  log: logAxis
};
var AXIS_TYPES = {
  value: 1,
  category: 1,
  time: 1,
  log: 1
};
function axisModelCreator(registers, axisName, BaseAxisModelClass, extraDefaultOption) {
  each$f(AXIS_TYPES, function(v4, axisType) {
    var defaultOption2 = merge(merge({}, axisDefault[axisType], true), extraDefaultOption, true);
    var AxisModel = function(_super) {
      __extends(AxisModel2, _super);
      function AxisModel2() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.type = axisName + "Axis." + axisType;
        return _this;
      }
      AxisModel2.prototype.mergeDefaultAndTheme = function(option, ecModel) {
        var layoutMode = fetchLayoutMode(this);
        var inputPositionParams = layoutMode ? getLayoutParams(option) : {};
        var themeModel = ecModel.getTheme();
        merge(option, themeModel.get(axisType + "Axis"));
        merge(option, this.getDefaultOption());
        option.type = getAxisType(option);
        if (layoutMode) {
          mergeLayoutParam(option, inputPositionParams, layoutMode);
        }
      };
      AxisModel2.prototype.optionUpdated = function() {
        var thisOption = this.option;
        if (thisOption.type === "category") {
          this.__ordinalMeta = OrdinalMeta$1.createByAxisModel(this);
        }
      };
      AxisModel2.prototype.getCategories = function(rawData) {
        var option = this.option;
        if (option.type === "category") {
          if (rawData) {
            return option.data;
          }
          return this.__ordinalMeta.categories;
        }
      };
      AxisModel2.prototype.getOrdinalMeta = function() {
        return this.__ordinalMeta;
      };
      AxisModel2.type = axisName + "Axis." + axisType;
      AxisModel2.defaultOption = defaultOption2;
      return AxisModel2;
    }(BaseAxisModelClass);
    registers.registerComponentModel(AxisModel);
  });
  registers.registerSubTypeDefaulter(axisName + "Axis", getAxisType);
}
function getAxisType(option) {
  return option.type || (option.data ? "category" : "value");
}
var Cartesian = function() {
  function Cartesian2(name) {
    this.type = "cartesian";
    this._dimList = [];
    this._axes = {};
    this.name = name || "";
  }
  Cartesian2.prototype.getAxis = function(dim) {
    return this._axes[dim];
  };
  Cartesian2.prototype.getAxes = function() {
    return map$1(this._dimList, function(dim) {
      return this._axes[dim];
    }, this);
  };
  Cartesian2.prototype.getAxesByScale = function(scaleType) {
    scaleType = scaleType.toLowerCase();
    return filter(this.getAxes(), function(axis) {
      return axis.scale.type === scaleType;
    });
  };
  Cartesian2.prototype.addAxis = function(axis) {
    var dim = axis.dim;
    this._axes[dim] = axis;
    this._dimList.push(dim);
  };
  return Cartesian2;
}();
var Cartesian$1 = Cartesian;
var cartesian2DDimensions = ["x", "y"];
function canCalculateAffineTransform(scale2) {
  return scale2.type === "interval" || scale2.type === "time";
}
var Cartesian2D = function(_super) {
  __extends(Cartesian2D2, _super);
  function Cartesian2D2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "cartesian2d";
    _this.dimensions = cartesian2DDimensions;
    return _this;
  }
  Cartesian2D2.prototype.calcAffineTransform = function() {
    this._transform = this._invTransform = null;
    var xAxisScale = this.getAxis("x").scale;
    var yAxisScale = this.getAxis("y").scale;
    if (!canCalculateAffineTransform(xAxisScale) || !canCalculateAffineTransform(yAxisScale)) {
      return;
    }
    var xScaleExtent = xAxisScale.getExtent();
    var yScaleExtent = yAxisScale.getExtent();
    var start2 = this.dataToPoint([xScaleExtent[0], yScaleExtent[0]]);
    var end2 = this.dataToPoint([xScaleExtent[1], yScaleExtent[1]]);
    var xScaleSpan = xScaleExtent[1] - xScaleExtent[0];
    var yScaleSpan = yScaleExtent[1] - yScaleExtent[0];
    if (!xScaleSpan || !yScaleSpan) {
      return;
    }
    var scaleX = (end2[0] - start2[0]) / xScaleSpan;
    var scaleY = (end2[1] - start2[1]) / yScaleSpan;
    var translateX = start2[0] - xScaleExtent[0] * scaleX;
    var translateY = start2[1] - yScaleExtent[0] * scaleY;
    var m2 = this._transform = [scaleX, 0, 0, scaleY, translateX, translateY];
    this._invTransform = invert([], m2);
  };
  Cartesian2D2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
  };
  Cartesian2D2.prototype.containPoint = function(point) {
    var axisX = this.getAxis("x");
    var axisY = this.getAxis("y");
    return axisX.contain(axisX.toLocalCoord(point[0])) && axisY.contain(axisY.toLocalCoord(point[1]));
  };
  Cartesian2D2.prototype.containData = function(data) {
    return this.getAxis("x").containData(data[0]) && this.getAxis("y").containData(data[1]);
  };
  Cartesian2D2.prototype.dataToPoint = function(data, clamp2, out2) {
    out2 = out2 || [];
    var xVal = data[0];
    var yVal = data[1];
    if (this._transform && xVal != null && isFinite(xVal) && yVal != null && isFinite(yVal)) {
      return applyTransform$1(out2, data, this._transform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.toGlobalCoord(xAxis.dataToCoord(xVal, clamp2));
    out2[1] = yAxis.toGlobalCoord(yAxis.dataToCoord(yVal, clamp2));
    return out2;
  };
  Cartesian2D2.prototype.clampData = function(data, out2) {
    var xScale = this.getAxis("x").scale;
    var yScale = this.getAxis("y").scale;
    var xAxisExtent = xScale.getExtent();
    var yAxisExtent = yScale.getExtent();
    var x2 = xScale.parse(data[0]);
    var y2 = yScale.parse(data[1]);
    out2 = out2 || [];
    out2[0] = Math.min(Math.max(Math.min(xAxisExtent[0], xAxisExtent[1]), x2), Math.max(xAxisExtent[0], xAxisExtent[1]));
    out2[1] = Math.min(Math.max(Math.min(yAxisExtent[0], yAxisExtent[1]), y2), Math.max(yAxisExtent[0], yAxisExtent[1]));
    return out2;
  };
  Cartesian2D2.prototype.pointToData = function(point, clamp2) {
    var out2 = [];
    if (this._invTransform) {
      return applyTransform$1(out2, point, this._invTransform);
    }
    var xAxis = this.getAxis("x");
    var yAxis = this.getAxis("y");
    out2[0] = xAxis.coordToData(xAxis.toLocalCoord(point[0]), clamp2);
    out2[1] = yAxis.coordToData(yAxis.toLocalCoord(point[1]), clamp2);
    return out2;
  };
  Cartesian2D2.prototype.getOtherAxis = function(axis) {
    return this.getAxis(axis.dim === "x" ? "y" : "x");
  };
  Cartesian2D2.prototype.getArea = function() {
    var xExtent = this.getAxis("x").getGlobalExtent();
    var yExtent = this.getAxis("y").getGlobalExtent();
    var x2 = Math.min(xExtent[0], xExtent[1]);
    var y2 = Math.min(yExtent[0], yExtent[1]);
    var width = Math.max(xExtent[0], xExtent[1]) - x2;
    var height = Math.max(yExtent[0], yExtent[1]) - y2;
    return new BoundingRect$1(x2, y2, width, height);
  };
  return Cartesian2D2;
}(Cartesian$1);
var Cartesian2D$1 = Cartesian2D;
var Axis2D = function(_super) {
  __extends(Axis2D2, _super);
  function Axis2D2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.index = 0;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  Axis2D2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  Axis2D2.prototype.getGlobalExtent = function(asc2) {
    var ret = this.getExtent();
    ret[0] = this.toGlobalCoord(ret[0]);
    ret[1] = this.toGlobalCoord(ret[1]);
    asc2 && ret[0] > ret[1] && ret.reverse();
    return ret;
  };
  Axis2D2.prototype.pointToData = function(point, clamp2) {
    return this.coordToData(this.toLocalCoord(point[this.dim === "x" ? 0 : 1]), clamp2);
  };
  Axis2D2.prototype.setCategorySortInfo = function(info) {
    if (this.type !== "category") {
      return false;
    }
    this.model.option.categorySortInfo = info;
    this.scale.setSortInfo(info);
  };
  return Axis2D2;
}(Axis$1);
var Axis2D$1 = Axis2D;
function layout$2(gridModel, axisModel, opt) {
  opt = opt || {};
  var grid = gridModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var otherAxisOnZeroOf = axis.getAxesOnZeroOf()[0];
  var rawAxisPosition = axis.position;
  var axisPosition = otherAxisOnZeroOf ? "onZero" : rawAxisPosition;
  var axisDim = axis.dim;
  var rect = grid.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var idx = {
    left: 0,
    right: 1,
    top: 0,
    bottom: 1,
    onZero: 2
  };
  var axisOffset = axisModel.get("offset") || 0;
  var posBound = axisDim === "x" ? [rectBound[2] - axisOffset, rectBound[3] + axisOffset] : [rectBound[0] - axisOffset, rectBound[1] + axisOffset];
  if (otherAxisOnZeroOf) {
    var onZeroCoord = otherAxisOnZeroOf.toGlobalCoord(otherAxisOnZeroOf.dataToCoord(0));
    posBound[idx.onZero] = Math.max(Math.min(onZeroCoord, posBound[1]), posBound[0]);
  }
  layout2.position = [axisDim === "y" ? posBound[idx[axisPosition]] : rectBound[0], axisDim === "x" ? posBound[idx[axisPosition]] : rectBound[3]];
  layout2.rotation = Math.PI / 2 * (axisDim === "x" ? 0 : 1);
  var dirMap = {
    top: -1,
    bottom: 1,
    left: -1,
    right: 1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = dirMap[rawAxisPosition];
  layout2.labelOffset = otherAxisOnZeroOf ? posBound[idx[rawAxisPosition]] - posBound[idx.onZero] : 0;
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotate = axisModel.get(["axisLabel", "rotate"]);
  layout2.labelRotate = axisPosition === "top" ? -labelRotate : labelRotate;
  layout2.z2 = 1;
  return layout2;
}
function isCartesian2DSeries(seriesModel) {
  return seriesModel.get("coordinateSystem") === "cartesian2d";
}
function findAxisModels(seriesModel) {
  var axisModelMap = {
    xAxisModel: null,
    yAxisModel: null
  };
  each$f(axisModelMap, function(v4, key) {
    var axisType = key.replace(/Model$/, "");
    var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
    axisModelMap[key] = axisModel;
  });
  return axisModelMap;
}
var mathLog = Math.log;
function alignScaleTicks(scale2, axisModel, alignToScale) {
  var intervalScaleProto2 = IntervalScale$1.prototype;
  var alignToTicks = intervalScaleProto2.getTicks.call(alignToScale);
  var alignToNicedTicks = intervalScaleProto2.getTicks.call(alignToScale, true);
  var alignToSplitNumber = alignToTicks.length - 1;
  var alignToInterval = intervalScaleProto2.getInterval.call(alignToScale);
  var scaleExtent = getScaleExtent(scale2, axisModel);
  var rawExtent = scaleExtent.extent;
  var isMinFixed = scaleExtent.fixMin;
  var isMaxFixed = scaleExtent.fixMax;
  if (scale2.type === "log") {
    var logBase = mathLog(scale2.base);
    rawExtent = [mathLog(rawExtent[0]) / logBase, mathLog(rawExtent[1]) / logBase];
  }
  scale2.setExtent(rawExtent[0], rawExtent[1]);
  scale2.calcNiceExtent({
    splitNumber: alignToSplitNumber,
    fixMin: isMinFixed,
    fixMax: isMaxFixed
  });
  var extent3 = intervalScaleProto2.getExtent.call(scale2);
  if (isMinFixed) {
    rawExtent[0] = extent3[0];
  }
  if (isMaxFixed) {
    rawExtent[1] = extent3[1];
  }
  var interval = intervalScaleProto2.getInterval.call(scale2);
  var min3 = rawExtent[0];
  var max3 = rawExtent[1];
  if (isMinFixed && isMaxFixed) {
    interval = (max3 - min3) / alignToSplitNumber;
  } else if (isMinFixed) {
    max3 = rawExtent[0] + interval * alignToSplitNumber;
    while (max3 < rawExtent[1] && isFinite(max3) && isFinite(rawExtent[1])) {
      interval = increaseInterval(interval);
      max3 = rawExtent[0] + interval * alignToSplitNumber;
    }
  } else if (isMaxFixed) {
    min3 = rawExtent[1] - interval * alignToSplitNumber;
    while (min3 > rawExtent[0] && isFinite(min3) && isFinite(rawExtent[0])) {
      interval = increaseInterval(interval);
      min3 = rawExtent[1] - interval * alignToSplitNumber;
    }
  } else {
    var nicedSplitNumber = scale2.getTicks().length - 1;
    if (nicedSplitNumber > alignToSplitNumber) {
      interval = increaseInterval(interval);
    }
    var range3 = interval * alignToSplitNumber;
    max3 = Math.ceil(rawExtent[1] / interval) * interval;
    min3 = round$3(max3 - range3);
    if (min3 < 0 && rawExtent[0] >= 0) {
      min3 = 0;
      max3 = round$3(range3);
    } else if (max3 > 0 && rawExtent[1] <= 0) {
      max3 = 0;
      min3 = -round$3(range3);
    }
  }
  var t0 = (alignToTicks[0].value - alignToNicedTicks[0].value) / alignToInterval;
  var t1 = (alignToTicks[alignToSplitNumber].value - alignToNicedTicks[alignToSplitNumber].value) / alignToInterval;
  intervalScaleProto2.setExtent.call(scale2, min3 + interval * t0, max3 + interval * t1);
  intervalScaleProto2.setInterval.call(scale2, interval);
  if (t0 || t1) {
    intervalScaleProto2.setNiceExtent.call(scale2, min3 + interval, max3 - interval);
  }
}
var Grid = function() {
  function Grid2(gridModel, ecModel, api) {
    this.type = "grid";
    this._coordsMap = {};
    this._coordsList = [];
    this._axesMap = {};
    this._axesList = [];
    this.axisPointerEnabled = true;
    this.dimensions = cartesian2DDimensions;
    this._initCartesian(gridModel, ecModel, api);
    this.model = gridModel;
  }
  Grid2.prototype.getRect = function() {
    return this._rect;
  };
  Grid2.prototype.update = function(ecModel, api) {
    var axesMap = this._axesMap;
    this._updateScale(ecModel, this.model);
    function updateAxisTicks(axes) {
      var alignTo;
      var axesIndices = keys(axes);
      var len2 = axesIndices.length;
      if (!len2) {
        return;
      }
      var axisNeedsAlign = [];
      for (var i = len2 - 1; i >= 0; i--) {
        var idx = +axesIndices[i];
        var axis = axes[idx];
        var model = axis.model;
        var scale2 = axis.scale;
        if (isIntervalOrLogScale(scale2) && model.get("alignTicks") && model.get("interval") == null) {
          axisNeedsAlign.push(axis);
        } else {
          niceScaleExtent(scale2, model);
          if (isIntervalOrLogScale(scale2)) {
            alignTo = axis;
          }
        }
      }
      if (axisNeedsAlign.length) {
        if (!alignTo) {
          alignTo = axisNeedsAlign.pop();
          niceScaleExtent(alignTo.scale, alignTo.model);
        }
        each$f(axisNeedsAlign, function(axis2) {
          alignScaleTicks(axis2.scale, axis2.model, alignTo.scale);
        });
      }
    }
    updateAxisTicks(axesMap.x);
    updateAxisTicks(axesMap.y);
    var onZeroRecords = {};
    each$f(axesMap.x, function(xAxis) {
      fixAxisOnZero(axesMap, "y", xAxis, onZeroRecords);
    });
    each$f(axesMap.y, function(yAxis) {
      fixAxisOnZero(axesMap, "x", yAxis, onZeroRecords);
    });
    this.resize(this.model, api);
  };
  Grid2.prototype.resize = function(gridModel, api, ignoreContainLabel) {
    var boxLayoutParams = gridModel.getBoxLayoutParams();
    var isContainLabel = !ignoreContainLabel && gridModel.get("containLabel");
    var gridRect = getLayoutRect(boxLayoutParams, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._rect = gridRect;
    var axesList = this._axesList;
    adjustAxes();
    if (isContainLabel) {
      each$f(axesList, function(axis) {
        if (!axis.model.get(["axisLabel", "inside"])) {
          var labelUnionRect = estimateLabelUnionRect(axis);
          if (labelUnionRect) {
            var dim = axis.isHorizontal() ? "height" : "width";
            var margin = axis.model.get(["axisLabel", "margin"]);
            gridRect[dim] -= labelUnionRect[dim] + margin;
            if (axis.position === "top") {
              gridRect.y += labelUnionRect.height + margin;
            } else if (axis.position === "left") {
              gridRect.x += labelUnionRect.width + margin;
            }
          }
        }
      });
      adjustAxes();
    }
    each$f(this._coordsList, function(coord) {
      coord.calcAffineTransform();
    });
    function adjustAxes() {
      each$f(axesList, function(axis) {
        var isHorizontal = axis.isHorizontal();
        var extent3 = isHorizontal ? [0, gridRect.width] : [0, gridRect.height];
        var idx = axis.inverse ? 1 : 0;
        axis.setExtent(extent3[idx], extent3[1 - idx]);
        updateAxisTransform(axis, isHorizontal ? gridRect.x : gridRect.y);
      });
    }
  };
  Grid2.prototype.getAxis = function(dim, axisIndex) {
    var axesMapOnDim = this._axesMap[dim];
    if (axesMapOnDim != null) {
      return axesMapOnDim[axisIndex || 0];
    }
  };
  Grid2.prototype.getAxes = function() {
    return this._axesList.slice();
  };
  Grid2.prototype.getCartesian = function(xAxisIndex, yAxisIndex) {
    if (xAxisIndex != null && yAxisIndex != null) {
      var key = "x" + xAxisIndex + "y" + yAxisIndex;
      return this._coordsMap[key];
    }
    if (isObject$4(xAxisIndex)) {
      yAxisIndex = xAxisIndex.yAxisIndex;
      xAxisIndex = xAxisIndex.xAxisIndex;
    }
    for (var i = 0, coordList = this._coordsList; i < coordList.length; i++) {
      if (coordList[i].getAxis("x").index === xAxisIndex || coordList[i].getAxis("y").index === yAxisIndex) {
        return coordList[i];
      }
    }
  };
  Grid2.prototype.getCartesians = function() {
    return this._coordsList.slice();
  };
  Grid2.prototype.convertToPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.dataToPoint(value) : target.axis ? target.axis.toGlobalCoord(target.axis.dataToCoord(value)) : null;
  };
  Grid2.prototype.convertFromPixel = function(ecModel, finder, value) {
    var target = this._findConvertTarget(finder);
    return target.cartesian ? target.cartesian.pointToData(value) : target.axis ? target.axis.coordToData(target.axis.toLocalCoord(value)) : null;
  };
  Grid2.prototype._findConvertTarget = function(finder) {
    var seriesModel = finder.seriesModel;
    var xAxisModel = finder.xAxisModel || seriesModel && seriesModel.getReferringComponents("xAxis", SINGLE_REFERRING).models[0];
    var yAxisModel = finder.yAxisModel || seriesModel && seriesModel.getReferringComponents("yAxis", SINGLE_REFERRING).models[0];
    var gridModel = finder.gridModel;
    var coordsList = this._coordsList;
    var cartesian;
    var axis;
    if (seriesModel) {
      cartesian = seriesModel.coordinateSystem;
      indexOf(coordsList, cartesian) < 0 && (cartesian = null);
    } else if (xAxisModel && yAxisModel) {
      cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    } else if (xAxisModel) {
      axis = this.getAxis("x", xAxisModel.componentIndex);
    } else if (yAxisModel) {
      axis = this.getAxis("y", yAxisModel.componentIndex);
    } else if (gridModel) {
      var grid = gridModel.coordinateSystem;
      if (grid === this) {
        cartesian = this._coordsList[0];
      }
    }
    return {
      cartesian,
      axis
    };
  };
  Grid2.prototype.containPoint = function(point) {
    var coord = this._coordsList[0];
    if (coord) {
      return coord.containPoint(point);
    }
  };
  Grid2.prototype._initCartesian = function(gridModel, ecModel, api) {
    var _this = this;
    var grid = this;
    var axisPositionUsed = {
      left: false,
      right: false,
      top: false,
      bottom: false
    };
    var axesMap = {
      x: {},
      y: {}
    };
    var axesCount = {
      x: 0,
      y: 0
    };
    ecModel.eachComponent("xAxis", createAxisCreator("x"), this);
    ecModel.eachComponent("yAxis", createAxisCreator("y"), this);
    if (!axesCount.x || !axesCount.y) {
      this._axesMap = {};
      this._axesList = [];
      return;
    }
    this._axesMap = axesMap;
    each$f(axesMap.x, function(xAxis, xAxisIndex) {
      each$f(axesMap.y, function(yAxis, yAxisIndex) {
        var key = "x" + xAxisIndex + "y" + yAxisIndex;
        var cartesian = new Cartesian2D$1(key);
        cartesian.master = _this;
        cartesian.model = gridModel;
        _this._coordsMap[key] = cartesian;
        _this._coordsList.push(cartesian);
        cartesian.addAxis(xAxis);
        cartesian.addAxis(yAxis);
      });
    });
    function createAxisCreator(dimName) {
      return function(axisModel, idx) {
        if (!isAxisUsedInTheGrid(axisModel, gridModel)) {
          return;
        }
        var axisPosition = axisModel.get("position");
        if (dimName === "x") {
          if (axisPosition !== "top" && axisPosition !== "bottom") {
            axisPosition = axisPositionUsed.bottom ? "top" : "bottom";
          }
        } else {
          if (axisPosition !== "left" && axisPosition !== "right") {
            axisPosition = axisPositionUsed.left ? "right" : "left";
          }
        }
        axisPositionUsed[axisPosition] = true;
        var axis = new Axis2D$1(dimName, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisPosition);
        var isCategory2 = axis.type === "category";
        axis.onBand = isCategory2 && axisModel.get("boundaryGap");
        axis.inverse = axisModel.get("inverse");
        axisModel.axis = axis;
        axis.model = axisModel;
        axis.grid = grid;
        axis.index = idx;
        grid._axesList.push(axis);
        axesMap[dimName][idx] = axis;
        axesCount[dimName]++;
      };
    }
  };
  Grid2.prototype._updateScale = function(ecModel, gridModel) {
    each$f(this._axesList, function(axis) {
      axis.scale.setExtent(Infinity, -Infinity);
      if (axis.type === "category") {
        var categorySortInfo = axis.model.get("categorySortInfo");
        axis.scale.setSortInfo(categorySortInfo);
      }
    });
    ecModel.eachSeries(function(seriesModel) {
      if (isCartesian2DSeries(seriesModel)) {
        var axesModelMap = findAxisModels(seriesModel);
        var xAxisModel = axesModelMap.xAxisModel;
        var yAxisModel = axesModelMap.yAxisModel;
        if (!isAxisUsedInTheGrid(xAxisModel, gridModel) || !isAxisUsedInTheGrid(yAxisModel, gridModel)) {
          return;
        }
        var cartesian = this.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
        var data = seriesModel.getData();
        var xAxis = cartesian.getAxis("x");
        var yAxis = cartesian.getAxis("y");
        unionExtent(data, xAxis);
        unionExtent(data, yAxis);
      }
    }, this);
    function unionExtent(data, axis) {
      each$f(getDataDimensionsOnAxis(data, axis.dim), function(dim) {
        axis.scale.unionExtentFromData(data, dim);
      });
    }
  };
  Grid2.prototype.getTooltipAxes = function(dim) {
    var baseAxes = [];
    var otherAxes = [];
    each$f(this.getCartesians(), function(cartesian) {
      var baseAxis = dim != null && dim !== "auto" ? cartesian.getAxis(dim) : cartesian.getBaseAxis();
      var otherAxis = cartesian.getOtherAxis(baseAxis);
      indexOf(baseAxes, baseAxis) < 0 && baseAxes.push(baseAxis);
      indexOf(otherAxes, otherAxis) < 0 && otherAxes.push(otherAxis);
    });
    return {
      baseAxes,
      otherAxes
    };
  };
  Grid2.create = function(ecModel, api) {
    var grids = [];
    ecModel.eachComponent("grid", function(gridModel, idx) {
      var grid = new Grid2(gridModel, ecModel, api);
      grid.name = "grid_" + idx;
      grid.resize(gridModel, api, true);
      gridModel.coordinateSystem = grid;
      grids.push(grid);
    });
    ecModel.eachSeries(function(seriesModel) {
      if (!isCartesian2DSeries(seriesModel)) {
        return;
      }
      var axesModelMap = findAxisModels(seriesModel);
      var xAxisModel = axesModelMap.xAxisModel;
      var yAxisModel = axesModelMap.yAxisModel;
      var gridModel = xAxisModel.getCoordSysModel();
      var grid = gridModel.coordinateSystem;
      seriesModel.coordinateSystem = grid.getCartesian(xAxisModel.componentIndex, yAxisModel.componentIndex);
    });
    return grids;
  };
  Grid2.dimensions = cartesian2DDimensions;
  return Grid2;
}();
function isAxisUsedInTheGrid(axisModel, gridModel) {
  return axisModel.getCoordSysModel() === gridModel;
}
function fixAxisOnZero(axesMap, otherAxisDim, axis, onZeroRecords) {
  axis.getAxesOnZeroOf = function() {
    return otherAxisOnZeroOf ? [otherAxisOnZeroOf] : [];
  };
  var otherAxes = axesMap[otherAxisDim];
  var otherAxisOnZeroOf;
  var axisModel = axis.model;
  var onZero = axisModel.get(["axisLine", "onZero"]);
  var onZeroAxisIndex = axisModel.get(["axisLine", "onZeroAxisIndex"]);
  if (!onZero) {
    return;
  }
  if (onZeroAxisIndex != null) {
    if (canOnZeroToAxis(otherAxes[onZeroAxisIndex])) {
      otherAxisOnZeroOf = otherAxes[onZeroAxisIndex];
    }
  } else {
    for (var idx in otherAxes) {
      if (otherAxes.hasOwnProperty(idx) && canOnZeroToAxis(otherAxes[idx]) && !onZeroRecords[getOnZeroRecordKey(otherAxes[idx])]) {
        otherAxisOnZeroOf = otherAxes[idx];
        break;
      }
    }
  }
  if (otherAxisOnZeroOf) {
    onZeroRecords[getOnZeroRecordKey(otherAxisOnZeroOf)] = true;
  }
  function getOnZeroRecordKey(axis2) {
    return axis2.dim + "_" + axis2.index;
  }
}
function canOnZeroToAxis(axis) {
  return axis && axis.type !== "category" && axis.type !== "time" && ifAxisCrossZero(axis);
}
function updateAxisTransform(axis, coordBase) {
  var axisExtent = axis.getExtent();
  var axisExtentSum = axisExtent[0] + axisExtent[1];
  axis.toGlobalCoord = axis.dim === "x" ? function(coord) {
    return coord + coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
  axis.toLocalCoord = axis.dim === "x" ? function(coord) {
    return coord - coordBase;
  } : function(coord) {
    return axisExtentSum - coord + coordBase;
  };
}
var Grid$1 = Grid;
var PI$3 = Math.PI;
var AxisBuilder = function() {
  function AxisBuilder2(axisModel, opt) {
    this.group = new Group$4();
    this.opt = opt;
    this.axisModel = axisModel;
    defaults(opt, {
      labelOffset: 0,
      nameDirection: 1,
      tickDirection: 1,
      labelDirection: 1,
      silent: true,
      handleAutoShown: function() {
        return true;
      }
    });
    var transformGroup = new Group$4({
      x: opt.position[0],
      y: opt.position[1],
      rotation: opt.rotation
    });
    transformGroup.updateTransform();
    this._transformGroup = transformGroup;
  }
  AxisBuilder2.prototype.hasBuilder = function(name) {
    return !!builders[name];
  };
  AxisBuilder2.prototype.add = function(name) {
    builders[name](this.opt, this.axisModel, this.group, this._transformGroup);
  };
  AxisBuilder2.prototype.getGroup = function() {
    return this.group;
  };
  AxisBuilder2.innerTextLayout = function(axisRotation, textRotation, direction) {
    var rotationDiff = remRadian(textRotation - axisRotation);
    var textAlign;
    var textVerticalAlign;
    if (isRadianAroundZero(rotationDiff)) {
      textVerticalAlign = direction > 0 ? "top" : "bottom";
      textAlign = "center";
    } else if (isRadianAroundZero(rotationDiff - PI$3)) {
      textVerticalAlign = direction > 0 ? "bottom" : "top";
      textAlign = "center";
    } else {
      textVerticalAlign = "middle";
      if (rotationDiff > 0 && rotationDiff < PI$3) {
        textAlign = direction > 0 ? "right" : "left";
      } else {
        textAlign = direction > 0 ? "left" : "right";
      }
    }
    return {
      rotation: rotationDiff,
      textAlign,
      textVerticalAlign
    };
  };
  AxisBuilder2.makeAxisEventDataBase = function(axisModel) {
    var eventData = {
      componentType: axisModel.mainType,
      componentIndex: axisModel.componentIndex
    };
    eventData[axisModel.mainType + "Index"] = axisModel.componentIndex;
    return eventData;
  };
  AxisBuilder2.isLabelSilent = function(axisModel) {
    var tooltipOpt = axisModel.get("tooltip");
    return axisModel.get("silent") || !(axisModel.get("triggerEvent") || tooltipOpt && tooltipOpt.show);
  };
  return AxisBuilder2;
}();
var builders = {
  axisLine: function(opt, axisModel, group, transformGroup) {
    var shown = axisModel.get(["axisLine", "show"]);
    if (shown === "auto" && opt.handleAutoShown) {
      shown = opt.handleAutoShown("axisLine");
    }
    if (!shown) {
      return;
    }
    var extent3 = axisModel.axis.getExtent();
    var matrix = transformGroup.transform;
    var pt12 = [extent3[0], 0];
    var pt22 = [extent3[1], 0];
    if (matrix) {
      applyTransform$1(pt12, pt12, matrix);
      applyTransform$1(pt22, pt22, matrix);
    }
    var lineStyle = extend({
      lineCap: "round"
    }, axisModel.getModel(["axisLine", "lineStyle"]).getLineStyle());
    var line = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: lineStyle,
      strokeContainThreshold: opt.strokeContainThreshold || 5,
      silent: true,
      z2: 1
    });
    line.anid = "line";
    group.add(line);
    var arrows = axisModel.get(["axisLine", "symbol"]);
    if (arrows != null) {
      var arrowSize = axisModel.get(["axisLine", "symbolSize"]);
      if (isString(arrows)) {
        arrows = [arrows, arrows];
      }
      if (isString(arrowSize) || isNumber(arrowSize)) {
        arrowSize = [arrowSize, arrowSize];
      }
      var arrowOffset = normalizeSymbolOffset(axisModel.get(["axisLine", "symbolOffset"]) || 0, arrowSize);
      var symbolWidth_1 = arrowSize[0];
      var symbolHeight_1 = arrowSize[1];
      each$f([{
        rotate: opt.rotation + Math.PI / 2,
        offset: arrowOffset[0],
        r: 0
      }, {
        rotate: opt.rotation - Math.PI / 2,
        offset: arrowOffset[1],
        r: Math.sqrt((pt12[0] - pt22[0]) * (pt12[0] - pt22[0]) + (pt12[1] - pt22[1]) * (pt12[1] - pt22[1]))
      }], function(point, index2) {
        if (arrows[index2] !== "none" && arrows[index2] != null) {
          var symbol = createSymbol$1(arrows[index2], -symbolWidth_1 / 2, -symbolHeight_1 / 2, symbolWidth_1, symbolHeight_1, lineStyle.stroke, true);
          var r2 = point.r + point.offset;
          symbol.attr({
            rotation: point.rotate,
            x: pt12[0] + r2 * Math.cos(opt.rotation),
            y: pt12[1] - r2 * Math.sin(opt.rotation),
            silent: true,
            z2: 11
          });
          group.add(symbol);
        }
      });
    }
  },
  axisTickLabel: function(opt, axisModel, group, transformGroup) {
    var ticksEls = buildAxisMajorTicks(group, transformGroup, axisModel, opt);
    var labelEls = buildAxisLabel(group, transformGroup, axisModel, opt);
    fixMinMaxLabelShow(axisModel, labelEls, ticksEls);
    buildAxisMinorTicks(group, transformGroup, axisModel, opt.tickDirection);
    if (axisModel.get(["axisLabel", "hideOverlap"])) {
      var labelList = prepareLayoutList(map$1(labelEls, function(label) {
        return {
          label,
          priority: label.z2,
          defaultAttr: {
            ignore: label.ignore
          }
        };
      }));
      hideOverlap(labelList);
    }
  },
  axisName: function(opt, axisModel, group, transformGroup) {
    var name = retrieve(opt.axisName, axisModel.get("name"));
    if (!name) {
      return;
    }
    var nameLocation = axisModel.get("nameLocation");
    var nameDirection = opt.nameDirection;
    var textStyleModel = axisModel.getModel("nameTextStyle");
    var gap = axisModel.get("nameGap") || 0;
    var extent3 = axisModel.axis.getExtent();
    var gapSignal = extent3[0] > extent3[1] ? -1 : 1;
    var pos = [
      nameLocation === "start" ? extent3[0] - gapSignal * gap : nameLocation === "end" ? extent3[1] + gapSignal * gap : (extent3[0] + extent3[1]) / 2,
      isNameLocationCenter(nameLocation) ? opt.labelOffset + nameDirection * gap : 0
    ];
    var labelLayout2;
    var nameRotation = axisModel.get("nameRotate");
    if (nameRotation != null) {
      nameRotation = nameRotation * PI$3 / 180;
    }
    var axisNameAvailableWidth;
    if (isNameLocationCenter(nameLocation)) {
      labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, nameRotation != null ? nameRotation : opt.rotation, nameDirection);
    } else {
      labelLayout2 = endTextLayout(opt.rotation, nameLocation, nameRotation || 0, extent3);
      axisNameAvailableWidth = opt.axisNameAvailableWidth;
      if (axisNameAvailableWidth != null) {
        axisNameAvailableWidth = Math.abs(axisNameAvailableWidth / Math.sin(labelLayout2.rotation));
        !isFinite(axisNameAvailableWidth) && (axisNameAvailableWidth = null);
      }
    }
    var textFont = textStyleModel.getFont();
    var truncateOpt = axisModel.get("nameTruncate", true) || {};
    var ellipsis = truncateOpt.ellipsis;
    var maxWidth = retrieve(opt.nameTruncateMaxWidth, truncateOpt.maxWidth, axisNameAvailableWidth);
    var textEl = new ZRText$1({
      x: pos[0],
      y: pos[1],
      rotation: labelLayout2.rotation,
      silent: AxisBuilder.isLabelSilent(axisModel),
      style: createTextStyle(textStyleModel, {
        text: name,
        font: textFont,
        overflow: "truncate",
        width: maxWidth,
        ellipsis,
        fill: textStyleModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]),
        align: textStyleModel.get("align") || labelLayout2.textAlign,
        verticalAlign: textStyleModel.get("verticalAlign") || labelLayout2.textVerticalAlign
      }),
      z2: 1
    });
    setTooltipConfig({
      el: textEl,
      componentModel: axisModel,
      itemName: name
    });
    textEl.__fullText = name;
    textEl.anid = "name";
    if (axisModel.get("triggerEvent")) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisName";
      eventData.name = name;
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    group.add(textEl);
    textEl.decomposeTransform();
  }
};
function endTextLayout(rotation, textPosition, textRotate, extent3) {
  var rotationDiff = remRadian(textRotate - rotation);
  var textAlign;
  var textVerticalAlign;
  var inverse = extent3[0] > extent3[1];
  var onLeft = textPosition === "start" && !inverse || textPosition !== "start" && inverse;
  if (isRadianAroundZero(rotationDiff - PI$3 / 2)) {
    textVerticalAlign = onLeft ? "bottom" : "top";
    textAlign = "center";
  } else if (isRadianAroundZero(rotationDiff - PI$3 * 1.5)) {
    textVerticalAlign = onLeft ? "top" : "bottom";
    textAlign = "center";
  } else {
    textVerticalAlign = "middle";
    if (rotationDiff < PI$3 * 1.5 && rotationDiff > PI$3 / 2) {
      textAlign = onLeft ? "left" : "right";
    } else {
      textAlign = onLeft ? "right" : "left";
    }
  }
  return {
    rotation: rotationDiff,
    textAlign,
    textVerticalAlign
  };
}
function fixMinMaxLabelShow(axisModel, labelEls, tickEls) {
  if (shouldShowAllLabels(axisModel.axis)) {
    return;
  }
  var showMinLabel = axisModel.get(["axisLabel", "showMinLabel"]);
  var showMaxLabel = axisModel.get(["axisLabel", "showMaxLabel"]);
  labelEls = labelEls || [];
  tickEls = tickEls || [];
  var firstLabel = labelEls[0];
  var nextLabel = labelEls[1];
  var lastLabel = labelEls[labelEls.length - 1];
  var prevLabel = labelEls[labelEls.length - 2];
  var firstTick = tickEls[0];
  var nextTick = tickEls[1];
  var lastTick = tickEls[tickEls.length - 1];
  var prevTick = tickEls[tickEls.length - 2];
  if (showMinLabel === false) {
    ignoreEl(firstLabel);
    ignoreEl(firstTick);
  } else if (isTwoLabelOverlapped(firstLabel, nextLabel)) {
    if (showMinLabel) {
      ignoreEl(nextLabel);
      ignoreEl(nextTick);
    } else {
      ignoreEl(firstLabel);
      ignoreEl(firstTick);
    }
  }
  if (showMaxLabel === false) {
    ignoreEl(lastLabel);
    ignoreEl(lastTick);
  } else if (isTwoLabelOverlapped(prevLabel, lastLabel)) {
    if (showMaxLabel) {
      ignoreEl(prevLabel);
      ignoreEl(prevTick);
    } else {
      ignoreEl(lastLabel);
      ignoreEl(lastTick);
    }
  }
}
function ignoreEl(el) {
  el && (el.ignore = true);
}
function isTwoLabelOverlapped(current, next) {
  var firstRect = current && current.getBoundingRect().clone();
  var nextRect = next && next.getBoundingRect().clone();
  if (!firstRect || !nextRect) {
    return;
  }
  var mRotationBack = identity([]);
  rotate(mRotationBack, mRotationBack, -current.rotation);
  firstRect.applyTransform(mul([], mRotationBack, current.getLocalTransform()));
  nextRect.applyTransform(mul([], mRotationBack, next.getLocalTransform()));
  return firstRect.intersect(nextRect);
}
function isNameLocationCenter(nameLocation) {
  return nameLocation === "middle" || nameLocation === "center";
}
function createTicks(ticksCoords, tickTransform, tickEndCoord, tickLineStyle, anidPrefix) {
  var tickEls = [];
  var pt12 = [];
  var pt22 = [];
  for (var i = 0; i < ticksCoords.length; i++) {
    var tickCoord = ticksCoords[i].coord;
    pt12[0] = tickCoord;
    pt12[1] = 0;
    pt22[0] = tickCoord;
    pt22[1] = tickEndCoord;
    if (tickTransform) {
      applyTransform$1(pt12, pt12, tickTransform);
      applyTransform$1(pt22, pt22, tickTransform);
    }
    var tickEl = new Line$3({
      subPixelOptimize: true,
      shape: {
        x1: pt12[0],
        y1: pt12[1],
        x2: pt22[0],
        y2: pt22[1]
      },
      style: tickLineStyle,
      z2: 2,
      autoBatch: true,
      silent: true
    });
    tickEl.anid = anidPrefix + "_" + ticksCoords[i].tickValue;
    tickEls.push(tickEl);
  }
  return tickEls;
}
function buildAxisMajorTicks(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var tickModel = axisModel.getModel("axisTick");
  var shown = tickModel.get("show");
  if (shown === "auto" && opt.handleAutoShown) {
    shown = opt.handleAutoShown("axisTick");
  }
  if (!shown || axis.scale.isBlank()) {
    return;
  }
  var lineStyleModel = tickModel.getModel("lineStyle");
  var tickEndCoord = opt.tickDirection * tickModel.get("length");
  var ticksCoords = axis.getTicksCoords();
  var ticksEls = createTicks(ticksCoords, transformGroup.transform, tickEndCoord, defaults(lineStyleModel.getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }), "ticks");
  for (var i = 0; i < ticksEls.length; i++) {
    group.add(ticksEls[i]);
  }
  return ticksEls;
}
function buildAxisMinorTicks(group, transformGroup, axisModel, tickDirection) {
  var axis = axisModel.axis;
  var minorTickModel = axisModel.getModel("minorTick");
  if (!minorTickModel.get("show") || axis.scale.isBlank()) {
    return;
  }
  var minorTicksCoords = axis.getMinorTicksCoords();
  if (!minorTicksCoords.length) {
    return;
  }
  var lineStyleModel = minorTickModel.getModel("lineStyle");
  var tickEndCoord = tickDirection * minorTickModel.get("length");
  var minorTickLineStyle = defaults(lineStyleModel.getLineStyle(), defaults(axisModel.getModel("axisTick").getLineStyle(), {
    stroke: axisModel.get(["axisLine", "lineStyle", "color"])
  }));
  for (var i = 0; i < minorTicksCoords.length; i++) {
    var minorTicksEls = createTicks(minorTicksCoords[i], transformGroup.transform, tickEndCoord, minorTickLineStyle, "minorticks_" + i);
    for (var k2 = 0; k2 < minorTicksEls.length; k2++) {
      group.add(minorTicksEls[k2]);
    }
  }
}
function buildAxisLabel(group, transformGroup, axisModel, opt) {
  var axis = axisModel.axis;
  var show = retrieve(opt.axisLabelShow, axisModel.get(["axisLabel", "show"]));
  if (!show || axis.scale.isBlank()) {
    return;
  }
  var labelModel = axisModel.getModel("axisLabel");
  var labelMargin = labelModel.get("margin");
  var labels = axis.getViewLabels();
  var labelRotation = (retrieve(opt.labelRotate, labelModel.get("rotate")) || 0) * PI$3 / 180;
  var labelLayout2 = AxisBuilder.innerTextLayout(opt.rotation, labelRotation, opt.labelDirection);
  var rawCategoryData = axisModel.getCategories && axisModel.getCategories(true);
  var labelEls = [];
  var silent = AxisBuilder.isLabelSilent(axisModel);
  var triggerEvent = axisModel.get("triggerEvent");
  each$f(labels, function(labelItem, index2) {
    var tickValue = axis.scale.type === "ordinal" ? axis.scale.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
    var formattedLabel = labelItem.formattedLabel;
    var rawLabel = labelItem.rawLabel;
    var itemLabelModel = labelModel;
    if (rawCategoryData && rawCategoryData[tickValue]) {
      var rawCategoryItem = rawCategoryData[tickValue];
      if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
        itemLabelModel = new Model$1(rawCategoryItem.textStyle, labelModel, axisModel.ecModel);
      }
    }
    var textColor = itemLabelModel.getTextColor() || axisModel.get(["axisLine", "lineStyle", "color"]);
    var tickCoord = axis.dataToCoord(tickValue);
    var textEl = new ZRText$1({
      x: tickCoord,
      y: opt.labelOffset + opt.labelDirection * labelMargin,
      rotation: labelLayout2.rotation,
      silent,
      z2: 10 + (labelItem.level || 0),
      style: createTextStyle(itemLabelModel, {
        text: formattedLabel,
        align: itemLabelModel.getShallow("align", true) || labelLayout2.textAlign,
        verticalAlign: itemLabelModel.getShallow("verticalAlign", true) || itemLabelModel.getShallow("baseline", true) || labelLayout2.textVerticalAlign,
        fill: isFunction(textColor) ? textColor(axis.type === "category" ? rawLabel : axis.type === "value" ? tickValue + "" : tickValue, index2) : textColor
      })
    });
    textEl.anid = "label_" + tickValue;
    if (triggerEvent) {
      var eventData = AxisBuilder.makeAxisEventDataBase(axisModel);
      eventData.targetType = "axisLabel";
      eventData.value = rawLabel;
      eventData.tickIndex = index2;
      if (axis.type === "category") {
        eventData.dataIndex = tickValue;
      }
      getECData(textEl).eventData = eventData;
    }
    transformGroup.add(textEl);
    textEl.updateTransform();
    labelEls.push(textEl);
    group.add(textEl);
    textEl.decomposeTransform();
  });
  return labelEls;
}
var AxisBuilder$1 = AxisBuilder;
function collect(ecModel, api) {
  var result = {
    axesInfo: {},
    seriesInvolved: false,
    coordSysAxesInfo: {},
    coordSysMap: {}
  };
  collectAxesInfo(result, ecModel, api);
  result.seriesInvolved && collectSeriesInfo(result, ecModel);
  return result;
}
function collectAxesInfo(result, ecModel, api) {
  var globalTooltipModel = ecModel.getComponent("tooltip");
  var globalAxisPointerModel = ecModel.getComponent("axisPointer");
  var linksOption = globalAxisPointerModel.get("link", true) || [];
  var linkGroups = [];
  each$f(api.getCoordinateSystems(), function(coordSys) {
    if (!coordSys.axisPointerEnabled) {
      return;
    }
    var coordSysKey = makeKey(coordSys.model);
    var axesInfoInCoordSys = result.coordSysAxesInfo[coordSysKey] = {};
    result.coordSysMap[coordSysKey] = coordSys;
    var coordSysModel = coordSys.model;
    var baseTooltipModel = coordSysModel.getModel("tooltip", globalTooltipModel);
    each$f(coordSys.getAxes(), curry$1(saveTooltipAxisInfo, false, null));
    if (coordSys.getTooltipAxes && globalTooltipModel && baseTooltipModel.get("show")) {
      var triggerAxis = baseTooltipModel.get("trigger") === "axis";
      var cross = baseTooltipModel.get(["axisPointer", "type"]) === "cross";
      var tooltipAxes = coordSys.getTooltipAxes(baseTooltipModel.get(["axisPointer", "axis"]));
      if (triggerAxis || cross) {
        each$f(tooltipAxes.baseAxes, curry$1(saveTooltipAxisInfo, cross ? "cross" : true, triggerAxis));
      }
      if (cross) {
        each$f(tooltipAxes.otherAxes, curry$1(saveTooltipAxisInfo, "cross", false));
      }
    }
    function saveTooltipAxisInfo(fromTooltip, triggerTooltip, axis) {
      var axisPointerModel = axis.model.getModel("axisPointer", globalAxisPointerModel);
      var axisPointerShow = axisPointerModel.get("show");
      if (!axisPointerShow || axisPointerShow === "auto" && !fromTooltip && !isHandleTrigger(axisPointerModel)) {
        return;
      }
      if (triggerTooltip == null) {
        triggerTooltip = axisPointerModel.get("triggerTooltip");
      }
      axisPointerModel = fromTooltip ? makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) : axisPointerModel;
      var snap = axisPointerModel.get("snap");
      var axisKey = makeKey(axis.model);
      var involveSeries = triggerTooltip || snap || axis.type === "category";
      var axisInfo = result.axesInfo[axisKey] = {
        key: axisKey,
        axis,
        coordSys,
        axisPointerModel,
        triggerTooltip,
        involveSeries,
        snap,
        useHandle: isHandleTrigger(axisPointerModel),
        seriesModels: [],
        linkGroup: null
      };
      axesInfoInCoordSys[axisKey] = axisInfo;
      result.seriesInvolved = result.seriesInvolved || involveSeries;
      var groupIndex = getLinkGroupIndex(linksOption, axis);
      if (groupIndex != null) {
        var linkGroup = linkGroups[groupIndex] || (linkGroups[groupIndex] = {
          axesInfo: {}
        });
        linkGroup.axesInfo[axisKey] = axisInfo;
        linkGroup.mapper = linksOption[groupIndex].mapper;
        axisInfo.linkGroup = linkGroup;
      }
    }
  });
}
function makeAxisPointerModel(axis, baseTooltipModel, globalAxisPointerModel, ecModel, fromTooltip, triggerTooltip) {
  var tooltipAxisPointerModel = baseTooltipModel.getModel("axisPointer");
  var fields = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"];
  var volatileOption = {};
  each$f(fields, function(field) {
    volatileOption[field] = clone$4(tooltipAxisPointerModel.get(field));
  });
  volatileOption.snap = axis.type !== "category" && !!triggerTooltip;
  if (tooltipAxisPointerModel.get("type") === "cross") {
    volatileOption.type = "line";
  }
  var labelOption = volatileOption.label || (volatileOption.label = {});
  labelOption.show == null && (labelOption.show = false);
  if (fromTooltip === "cross") {
    var tooltipAxisPointerLabelShow = tooltipAxisPointerModel.get(["label", "show"]);
    labelOption.show = tooltipAxisPointerLabelShow != null ? tooltipAxisPointerLabelShow : true;
    if (!triggerTooltip) {
      var crossStyle = volatileOption.lineStyle = tooltipAxisPointerModel.get("crossStyle");
      crossStyle && defaults(labelOption, crossStyle.textStyle);
    }
  }
  return axis.model.getModel("axisPointer", new Model$1(volatileOption, globalAxisPointerModel, ecModel));
}
function collectSeriesInfo(result, ecModel) {
  ecModel.eachSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesTooltipTrigger = seriesModel.get(["tooltip", "trigger"], true);
    var seriesTooltipShow = seriesModel.get(["tooltip", "show"], true);
    if (!coordSys || seriesTooltipTrigger === "none" || seriesTooltipTrigger === false || seriesTooltipTrigger === "item" || seriesTooltipShow === false || seriesModel.get(["axisPointer", "show"], true) === false) {
      return;
    }
    each$f(result.coordSysAxesInfo[makeKey(coordSys.model)], function(axisInfo) {
      var axis = axisInfo.axis;
      if (coordSys.getAxis(axis.dim) === axis) {
        axisInfo.seriesModels.push(seriesModel);
        axisInfo.seriesDataCount == null && (axisInfo.seriesDataCount = 0);
        axisInfo.seriesDataCount += seriesModel.getData().count();
      }
    });
  });
}
function getLinkGroupIndex(linksOption, axis) {
  var axisModel = axis.model;
  var dim = axis.dim;
  for (var i = 0; i < linksOption.length; i++) {
    var linkOption = linksOption[i] || {};
    if (checkPropInLink(linkOption[dim + "AxisId"], axisModel.id) || checkPropInLink(linkOption[dim + "AxisIndex"], axisModel.componentIndex) || checkPropInLink(linkOption[dim + "AxisName"], axisModel.name)) {
      return i;
    }
  }
}
function checkPropInLink(linkPropValue, axisPropValue) {
  return linkPropValue === "all" || isArray$1(linkPropValue) && indexOf(linkPropValue, axisPropValue) >= 0 || linkPropValue === axisPropValue;
}
function fixValue(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  if (!axisInfo) {
    return;
  }
  var axisPointerModel = axisInfo.axisPointerModel;
  var scale2 = axisInfo.axis.scale;
  var option = axisPointerModel.option;
  var status = axisPointerModel.get("status");
  var value = axisPointerModel.get("value");
  if (value != null) {
    value = scale2.parse(value);
  }
  var useHandle = isHandleTrigger(axisPointerModel);
  if (status == null) {
    option.status = useHandle ? "show" : "hide";
  }
  var extent3 = scale2.getExtent().slice();
  extent3[0] > extent3[1] && extent3.reverse();
  if (value == null || value > extent3[1]) {
    value = extent3[1];
  }
  if (value < extent3[0]) {
    value = extent3[0];
  }
  option.value = value;
  if (useHandle) {
    option.status = axisInfo.axis.scale.isBlank() ? "hide" : "show";
  }
}
function getAxisInfo$1(axisModel) {
  var coordSysAxesInfo = (axisModel.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
  return coordSysAxesInfo && coordSysAxesInfo.axesInfo[makeKey(axisModel)];
}
function getAxisPointerModel(axisModel) {
  var axisInfo = getAxisInfo$1(axisModel);
  return axisInfo && axisInfo.axisPointerModel;
}
function isHandleTrigger(axisPointerModel) {
  return !!axisPointerModel.get(["handle", "show"]);
}
function makeKey(model) {
  return model.type + "||" + model.id;
}
var axisPointerClazz = {};
var AxisView = function(_super) {
  __extends(AxisView2, _super);
  function AxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisView2.type;
    return _this;
  }
  AxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.axisPointerClass && fixValue(axisModel);
    _super.prototype.render.apply(this, arguments);
    this._doUpdateAxisPointerClass(axisModel, api, true);
  };
  AxisView2.prototype.updateAxisPointer = function(axisModel, ecModel, api, payload) {
    this._doUpdateAxisPointerClass(axisModel, api, false);
  };
  AxisView2.prototype.remove = function(ecModel, api) {
    var axisPointer = this._axisPointer;
    axisPointer && axisPointer.remove(api);
  };
  AxisView2.prototype.dispose = function(ecModel, api) {
    this._disposeAxisPointer(api);
    _super.prototype.dispose.apply(this, arguments);
  };
  AxisView2.prototype._doUpdateAxisPointerClass = function(axisModel, api, forceRender) {
    var Clazz = AxisView2.getAxisPointerClass(this.axisPointerClass);
    if (!Clazz) {
      return;
    }
    var axisPointerModel = getAxisPointerModel(axisModel);
    axisPointerModel ? (this._axisPointer || (this._axisPointer = new Clazz())).render(axisModel, axisPointerModel, api, forceRender) : this._disposeAxisPointer(api);
  };
  AxisView2.prototype._disposeAxisPointer = function(api) {
    this._axisPointer && this._axisPointer.dispose(api);
    this._axisPointer = null;
  };
  AxisView2.registerAxisPointerClass = function(type4, clazz) {
    axisPointerClazz[type4] = clazz;
  };
  AxisView2.getAxisPointerClass = function(type4) {
    return type4 && axisPointerClazz[type4];
  };
  AxisView2.type = "axis";
  return AxisView2;
}(ComponentView$1);
var AxisView$1 = AxisView;
var inner$f = makeInner();
function rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel) {
  var axis = axisModel.axis;
  if (axis.scale.isBlank()) {
    return;
  }
  var splitAreaModel = axisModel.getModel("splitArea");
  var areaStyleModel = splitAreaModel.getModel("areaStyle");
  var areaColors = areaStyleModel.get("color");
  var gridRect = gridModel.coordinateSystem.getRect();
  var ticksCoords = axis.getTicksCoords({
    tickModel: splitAreaModel,
    clamp: true
  });
  if (!ticksCoords.length) {
    return;
  }
  var areaColorsLen = areaColors.length;
  var lastSplitAreaColors = inner$f(axisView).splitAreaColors;
  var newSplitAreaColors = createHashMap();
  var colorIndex = 0;
  if (lastSplitAreaColors) {
    for (var i = 0; i < ticksCoords.length; i++) {
      var cIndex = lastSplitAreaColors.get(ticksCoords[i].tickValue);
      if (cIndex != null) {
        colorIndex = (cIndex + (areaColorsLen - 1) * i) % areaColorsLen;
        break;
      }
    }
  }
  var prev = axis.toGlobalCoord(ticksCoords[0].coord);
  var areaStyle = areaStyleModel.getAreaStyle();
  areaColors = isArray$1(areaColors) ? areaColors : [areaColors];
  for (var i = 1; i < ticksCoords.length; i++) {
    var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
    var x2 = void 0;
    var y2 = void 0;
    var width = void 0;
    var height = void 0;
    if (axis.isHorizontal()) {
      x2 = prev;
      y2 = gridRect.y;
      width = tickCoord - x2;
      height = gridRect.height;
      prev = x2 + width;
    } else {
      x2 = gridRect.x;
      y2 = prev;
      width = gridRect.width;
      height = tickCoord - y2;
      prev = y2 + height;
    }
    var tickValue = ticksCoords[i - 1].tickValue;
    tickValue != null && newSplitAreaColors.set(tickValue, colorIndex);
    axisGroup.add(new Rect$3({
      anid: tickValue != null ? "area_" + tickValue : null,
      shape: {
        x: x2,
        y: y2,
        width,
        height
      },
      style: defaults({
        fill: areaColors[colorIndex]
      }, areaStyle),
      autoBatch: true,
      silent: true
    }));
    colorIndex = (colorIndex + 1) % areaColorsLen;
  }
  inner$f(axisView).splitAreaColors = newSplitAreaColors;
}
function rectCoordAxisHandleRemove(axisView) {
  inner$f(axisView).splitAreaColors = null;
}
var axisBuilderAttrs$3 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$2 = ["splitArea", "splitLine", "minorSplitLine"];
var CartesianAxisView = function(_super) {
  __extends(CartesianAxisView2, _super);
  function CartesianAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianAxisView2.type;
    _this.axisPointerClass = "CartesianAxisPointer";
    return _this;
  }
  CartesianAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var gridModel = axisModel.getCoordSysModel();
    var layout2 = layout$2(gridModel, axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, extend({
      handleAutoShown: function(elementType) {
        var cartesians = gridModel.coordinateSystem.getCartesians();
        for (var i = 0; i < cartesians.length; i++) {
          if (isIntervalOrLogScale(cartesians[i].getOtherAxis(axisModel.axis).scale)) {
            return true;
          }
        }
        return false;
      }
    }, layout2));
    each$f(axisBuilderAttrs$3, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    each$f(selfBuilderAttrs$2, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders$2[name](this, this._axisGroup, axisModel, gridModel);
      }
    }, this);
    var isInitialSortFromBarRacing = payload && payload.type === "changeAxisOrder" && payload.isInitSort;
    if (!isInitialSortFromBarRacing) {
      groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    }
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  CartesianAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  CartesianAxisView2.type = "cartesianAxis";
  return CartesianAxisView2;
}(AxisView$1);
var axisElementBuilders$2 = {
  splitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = isArray$1(lineColors) ? lineColors : [lineColors];
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < ticksCoords.length; i++) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      var tickValue = ticksCoords[i].tickValue;
      axisGroup.add(new Line$3({
        anid: tickValue != null ? "line_" + ticksCoords[i].tickValue : null,
        subPixelOptimize: true,
        autoBatch: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        style: defaults({
          stroke: lineColors[colorIndex]
        }, lineStyle),
        silent: true
      }));
    }
  },
  minorSplitLine: function(axisView, axisGroup, axisModel, gridModel) {
    var axis = axisModel.axis;
    var minorSplitLineModel = axisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var gridRect = gridModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var minorTicksCoords = axis.getMinorTicksCoords();
    if (!minorTicksCoords.length) {
      return;
    }
    var p1 = [];
    var p2 = [];
    var lineStyle = lineStyleModel.getLineStyle();
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        var tickCoord = axis.toGlobalCoord(minorTicksCoords[i][k2].coord);
        if (isHorizontal) {
          p1[0] = tickCoord;
          p1[1] = gridRect.y;
          p2[0] = tickCoord;
          p2[1] = gridRect.y + gridRect.height;
        } else {
          p1[0] = gridRect.x;
          p1[1] = tickCoord;
          p2[0] = gridRect.x + gridRect.width;
          p2[1] = tickCoord;
        }
        axisGroup.add(new Line$3({
          anid: "minor_line_" + minorTicksCoords[i][k2].tickValue,
          subPixelOptimize: true,
          autoBatch: true,
          shape: {
            x1: p1[0],
            y1: p1[1],
            x2: p2[0],
            y2: p2[1]
          },
          style: lineStyle,
          silent: true
        }));
      }
    }
  },
  splitArea: function(axisView, axisGroup, axisModel, gridModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, gridModel);
  }
};
var CartesianXAxisView = function(_super) {
  __extends(CartesianXAxisView2, _super);
  function CartesianXAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView2.type;
    return _this;
  }
  CartesianXAxisView2.type = "xAxis";
  return CartesianXAxisView2;
}(CartesianAxisView);
var CartesianYAxisView = function(_super) {
  __extends(CartesianYAxisView2, _super);
  function CartesianYAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CartesianXAxisView.type;
    return _this;
  }
  CartesianYAxisView2.type = "yAxis";
  return CartesianYAxisView2;
}(CartesianAxisView);
var GridView = function(_super) {
  __extends(GridView2, _super);
  function GridView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "grid";
    return _this;
  }
  GridView2.prototype.render = function(gridModel, ecModel) {
    this.group.removeAll();
    if (gridModel.get("show")) {
      this.group.add(new Rect$3({
        shape: gridModel.coordinateSystem.getRect(),
        style: defaults({
          fill: gridModel.get("backgroundColor")
        }, gridModel.getItemStyle()),
        silent: true,
        z2: -1
      }));
    }
  };
  GridView2.type = "grid";
  return GridView2;
}(ComponentView$1);
var extraOption = {
  offset: 0
};
function install$N(registers) {
  registers.registerComponentView(GridView);
  registers.registerComponentModel(GridModel$1);
  registers.registerCoordinateSystem("cartesian2d", Grid$1);
  axisModelCreator(registers, "x", CartesianAxisModel, extraOption);
  axisModelCreator(registers, "y", CartesianAxisModel, extraOption);
  registers.registerComponentView(CartesianXAxisView);
  registers.registerComponentView(CartesianYAxisView);
  registers.registerPreprocessor(function(option) {
    if (option.xAxis && option.yAxis && !option.grid) {
      option.grid = {};
    }
  });
}
function install$M(registers) {
  use(install$N);
  registers.registerSeriesModel(ScatterSeriesModel$1);
  registers.registerChartView(ScatterView$1);
  registers.registerLayout(pointsLayout("scatter"));
}
function radarLayout(ecModel) {
  ecModel.eachSeriesByType("radar", function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var axes = coordSys.getIndicatorAxes();
    each$f(axes, function(axis, axisIndex) {
      data.each(data.mapDimension(axes[axisIndex].dim), function(val, dataIndex) {
        points2[dataIndex] = points2[dataIndex] || [];
        var point = coordSys.dataToPoint(val, axisIndex);
        points2[dataIndex][axisIndex] = isValidPoint(point) ? point : getValueMissingPoint(coordSys);
      });
    });
    data.each(function(idx) {
      var firstPoint = find(points2[idx], function(point) {
        return isValidPoint(point);
      }) || getValueMissingPoint(coordSys);
      points2[idx].push(firstPoint.slice());
      data.setItemLayout(idx, points2[idx]);
    });
  });
}
function isValidPoint(point) {
  return !isNaN(point[0]) && !isNaN(point[1]);
}
function getValueMissingPoint(coordSys) {
  return [coordSys.cx, coordSys.cy];
}
function radarBackwardCompat(option) {
  var polarOptArr = option.polar;
  if (polarOptArr) {
    if (!isArray$1(polarOptArr)) {
      polarOptArr = [polarOptArr];
    }
    var polarNotRadar_1 = [];
    each$f(polarOptArr, function(polarOpt, idx) {
      if (polarOpt.indicator) {
        if (polarOpt.type && !polarOpt.shape) {
          polarOpt.shape = polarOpt.type;
        }
        option.radar = option.radar || [];
        if (!isArray$1(option.radar)) {
          option.radar = [option.radar];
        }
        option.radar.push(polarOpt);
      } else {
        polarNotRadar_1.push(polarOpt);
      }
    });
    option.polar = polarNotRadar_1;
  }
  each$f(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "radar" && seriesOpt.polarIndex) {
      seriesOpt.radarIndex = seriesOpt.polarIndex;
    }
  });
}
var RadarView$2 = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(seriesModel, ecModel, api) {
    var polar = seriesModel.coordinateSystem;
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    function createSymbol2(data2, idx) {
      var symbolType = data2.getItemVisual(idx, "symbol") || "circle";
      if (symbolType === "none") {
        return;
      }
      var symbolSize = normalizeSymbolSize(data2.getItemVisual(idx, "symbolSize"));
      var symbolPath = createSymbol$1(symbolType, -1, -1, 2, 2);
      var symbolRotate = data2.getItemVisual(idx, "symbolRotate") || 0;
      symbolPath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 100,
        scaleX: symbolSize[0] / 2,
        scaleY: symbolSize[1] / 2,
        rotation: symbolRotate * Math.PI / 180 || 0
      });
      return symbolPath;
    }
    function updateSymbols(oldPoints, newPoints, symbolGroup, data2, idx, isInit) {
      symbolGroup.removeAll();
      for (var i = 0; i < newPoints.length - 1; i++) {
        var symbolPath = createSymbol2(data2, idx);
        if (symbolPath) {
          symbolPath.__dimIdx = i;
          if (oldPoints[i]) {
            symbolPath.setPosition(oldPoints[i]);
            graphic[isInit ? "initProps" : "updateProps"](symbolPath, {
              x: newPoints[i][0],
              y: newPoints[i][1]
            }, seriesModel, idx);
          } else {
            symbolPath.setPosition(newPoints[i]);
          }
          symbolGroup.add(symbolPath);
        }
      }
    }
    function getInitialPoints(points2) {
      return map$1(points2, function(pt) {
        return [polar.cx, polar.cy];
      });
    }
    data.diff(oldData).add(function(idx) {
      var points2 = data.getItemLayout(idx);
      if (!points2) {
        return;
      }
      var polygon = new Polygon$1();
      var polyline = new Polyline$3();
      var target = {
        shape: {
          points: points2
        }
      };
      polygon.shape.points = getInitialPoints(points2);
      polyline.shape.points = getInitialPoints(points2);
      initProps(polygon, target, seriesModel, idx);
      initProps(polyline, target, seriesModel, idx);
      var itemGroup = new Group$4();
      var symbolGroup = new Group$4();
      itemGroup.add(polyline);
      itemGroup.add(polygon);
      itemGroup.add(symbolGroup);
      updateSymbols(polyline.shape.points, points2, symbolGroup, data, idx, true);
      data.setItemGraphicEl(idx, itemGroup);
    }).update(function(newIdx, oldIdx) {
      var itemGroup = oldData.getItemGraphicEl(oldIdx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var target = {
        shape: {
          points: data.getItemLayout(newIdx)
        }
      };
      if (!target.shape.points) {
        return;
      }
      updateSymbols(polyline.shape.points, target.shape.points, symbolGroup, data, newIdx, false);
      saveOldStyle(polygon);
      saveOldStyle(polyline);
      updateProps$1(polyline, target, seriesModel);
      updateProps$1(polygon, target, seriesModel);
      data.setItemGraphicEl(newIdx, itemGroup);
    }).remove(function(idx) {
      group.remove(oldData.getItemGraphicEl(idx));
    }).execute();
    data.eachItemGraphicEl(function(itemGroup, idx) {
      var itemModel = data.getItemModel(idx);
      var polyline = itemGroup.childAt(0);
      var polygon = itemGroup.childAt(1);
      var symbolGroup = itemGroup.childAt(2);
      var itemStyle = data.getItemVisual(idx, "style");
      var color = itemStyle.fill;
      group.add(itemGroup);
      polyline.useStyle(defaults(itemModel.getModel("lineStyle").getLineStyle(), {
        fill: "none",
        stroke: color
      }));
      setStatesStylesFromModel(polyline, itemModel, "lineStyle");
      setStatesStylesFromModel(polygon, itemModel, "areaStyle");
      var areaStyleModel = itemModel.getModel("areaStyle");
      var polygonIgnore = areaStyleModel.isEmpty() && areaStyleModel.parentModel.isEmpty();
      polygon.ignore = polygonIgnore;
      each$f(["emphasis", "select", "blur"], function(stateName) {
        var stateModel = itemModel.getModel([stateName, "areaStyle"]);
        var stateIgnore = stateModel.isEmpty() && stateModel.parentModel.isEmpty();
        polygon.ensureState(stateName).ignore = stateIgnore && polygonIgnore;
      });
      polygon.useStyle(defaults(areaStyleModel.getAreaStyle(), {
        fill: color,
        opacity: 0.7,
        decal: itemStyle.decal
      }));
      var emphasisModel = itemModel.getModel("emphasis");
      var itemHoverStyle = emphasisModel.getModel("itemStyle").getItemStyle();
      symbolGroup.eachChild(function(symbolPath) {
        if (symbolPath instanceof ZRImage$1) {
          var pathStyle = symbolPath.style;
          symbolPath.useStyle(extend({
            image: pathStyle.image,
            x: pathStyle.x,
            y: pathStyle.y,
            width: pathStyle.width,
            height: pathStyle.height
          }, itemStyle));
        } else {
          symbolPath.useStyle(itemStyle);
          symbolPath.setColor(color);
          symbolPath.style.strokeNoScale = true;
        }
        var pathEmphasisState = symbolPath.ensureState("emphasis");
        pathEmphasisState.style = clone$4(itemHoverStyle);
        var defaultText = data.getStore().get(data.getDimensionIndex(symbolPath.__dimIdx), idx);
        (defaultText == null || isNaN(defaultText)) && (defaultText = "");
        setLabelStyle(symbolPath, getLabelStatesModels(itemModel), {
          labelFetcher: data.hostModel,
          labelDataIndex: idx,
          labelDimIndex: symbolPath.__dimIdx,
          defaultText,
          inheritColor: color,
          defaultOpacity: itemStyle.opacity
        });
      });
      toggleHoverEmphasis(itemGroup, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    this._data = data;
  };
  RadarView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ChartView$1);
var RadarView$3 = RadarView$2;
var RadarSeriesModel = function(_super) {
  __extends(RadarSeriesModel2, _super);
  function RadarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  RadarSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  RadarSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      generateCoord: "indicator_",
      generateCoordCount: Infinity
    });
  };
  RadarSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var coordSys = this.coordinateSystem;
    var indicatorAxes = coordSys.getIndicatorAxes();
    var name = this.getData().getName(dataIndex);
    var nameToDisplay = name === "" ? this.name : name;
    var markerColor = retrieveVisualColorForTooltipMarker(this, dataIndex);
    return createTooltipMarkup("section", {
      header: nameToDisplay,
      sortBlocks: true,
      blocks: map$1(indicatorAxes, function(axis) {
        var val = data.get(data.mapDimension(axis.dim), dataIndex);
        return createTooltipMarkup("nameValue", {
          markerType: "subItem",
          markerColor,
          name: axis.name,
          value: val,
          sortParam: val
        });
      })
    });
  };
  RadarSeriesModel2.prototype.getTooltipPosition = function(dataIndex) {
    if (dataIndex != null) {
      var data_1 = this.getData();
      var coordSys = this.coordinateSystem;
      var values = data_1.getValues(map$1(coordSys.dimensions, function(dim) {
        return data_1.mapDimension(dim);
      }), dataIndex);
      for (var i = 0, len2 = values.length; i < len2; i++) {
        if (!isNaN(values[i])) {
          var indicatorAxes = coordSys.getIndicatorAxes();
          return coordSys.coordToPoint(indicatorAxes[i].dataToCoord(values[i]), i);
        }
      }
    }
  };
  RadarSeriesModel2.type = "series.radar";
  RadarSeriesModel2.dependencies = ["radar"];
  RadarSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "radar",
    legendHoverLink: true,
    radarIndex: 0,
    lineStyle: {
      width: 2,
      type: "solid",
      join: "round"
    },
    label: {
      position: "top"
    },
    symbolSize: 8
  };
  return RadarSeriesModel2;
}(SeriesModel$1);
var RadarSeriesModel$1 = RadarSeriesModel;
var valueAxisDefault = axisDefault.value;
function defaultsShow(opt, show) {
  return defaults({
    show
  }, opt);
}
var RadarModel = function(_super) {
  __extends(RadarModel2, _super);
  function RadarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarModel2.type;
    return _this;
  }
  RadarModel2.prototype.optionUpdated = function() {
    var boundaryGap = this.get("boundaryGap");
    var splitNumber = this.get("splitNumber");
    var scale2 = this.get("scale");
    var axisLine = this.get("axisLine");
    var axisTick = this.get("axisTick");
    var axisLabel = this.get("axisLabel");
    var nameTextStyle = this.get("axisName");
    var showName = this.get(["axisName", "show"]);
    var nameFormatter = this.get(["axisName", "formatter"]);
    var nameGap = this.get("axisNameGap");
    var triggerEvent = this.get("triggerEvent");
    var indicatorModels = map$1(this.get("indicator") || [], function(indicatorOpt) {
      if (indicatorOpt.max != null && indicatorOpt.max > 0 && !indicatorOpt.min) {
        indicatorOpt.min = 0;
      } else if (indicatorOpt.min != null && indicatorOpt.min < 0 && !indicatorOpt.max) {
        indicatorOpt.max = 0;
      }
      var iNameTextStyle = nameTextStyle;
      if (indicatorOpt.color != null) {
        iNameTextStyle = defaults({
          color: indicatorOpt.color
        }, nameTextStyle);
      }
      var innerIndicatorOpt = merge(clone$4(indicatorOpt), {
        boundaryGap,
        splitNumber,
        scale: scale2,
        axisLine,
        axisTick,
        axisLabel,
        name: indicatorOpt.text,
        showName,
        nameLocation: "end",
        nameGap,
        nameTextStyle: iNameTextStyle,
        triggerEvent
      }, false);
      if (!showName) {
        innerIndicatorOpt.name = "";
      }
      if (isString(nameFormatter)) {
        var indName = innerIndicatorOpt.name;
        innerIndicatorOpt.name = nameFormatter.replace("{value}", indName != null ? indName : "");
      } else if (isFunction(nameFormatter)) {
        innerIndicatorOpt.name = nameFormatter(innerIndicatorOpt.name, innerIndicatorOpt);
      }
      var model = new Model$1(innerIndicatorOpt, null, this.ecModel);
      mixin(model, AxisModelCommonMixin.prototype);
      model.mainType = "radar";
      model.componentIndex = this.componentIndex;
      return model;
    }, this);
    this._indicatorModels = indicatorModels;
  };
  RadarModel2.prototype.getIndicatorModels = function() {
    return this._indicatorModels;
  };
  RadarModel2.type = "radar";
  RadarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "75%",
    startAngle: 90,
    axisName: {
      show: true
    },
    boundaryGap: [0, 0],
    splitNumber: 5,
    axisNameGap: 15,
    scale: false,
    shape: "polygon",
    axisLine: merge({
      lineStyle: {
        color: "#bbb"
      }
    }, valueAxisDefault.axisLine),
    axisLabel: defaultsShow(valueAxisDefault.axisLabel, false),
    axisTick: defaultsShow(valueAxisDefault.axisTick, false),
    splitLine: defaultsShow(valueAxisDefault.splitLine, true),
    splitArea: defaultsShow(valueAxisDefault.splitArea, true),
    indicator: []
  };
  return RadarModel2;
}(ComponentModel$1);
var RadarModel$1 = RadarModel;
var axisBuilderAttrs$2 = ["axisLine", "axisTickLabel", "axisName"];
var RadarView = function(_super) {
  __extends(RadarView2, _super);
  function RadarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadarView2.type;
    return _this;
  }
  RadarView2.prototype.render = function(radarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    this._buildAxes(radarModel);
    this._buildSplitLineAndArea(radarModel);
  };
  RadarView2.prototype._buildAxes = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    var axisBuilders = map$1(indicatorAxes, function(indicatorAxis) {
      var axisName = indicatorAxis.model.get("showName") ? indicatorAxis.name : "";
      var axisBuilder = new AxisBuilder$1(indicatorAxis.model, {
        axisName,
        position: [radar.cx, radar.cy],
        rotation: indicatorAxis.angle,
        labelDirection: -1,
        tickDirection: -1,
        nameDirection: 1
      });
      return axisBuilder;
    });
    each$f(axisBuilders, function(axisBuilder) {
      each$f(axisBuilderAttrs$2, axisBuilder.add, axisBuilder);
      this.group.add(axisBuilder.getGroup());
    }, this);
  };
  RadarView2.prototype._buildSplitLineAndArea = function(radarModel) {
    var radar = radarModel.coordinateSystem;
    var indicatorAxes = radar.getIndicatorAxes();
    if (!indicatorAxes.length) {
      return;
    }
    var shape = radarModel.get("shape");
    var splitLineModel = radarModel.getModel("splitLine");
    var splitAreaModel = radarModel.getModel("splitArea");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var showSplitLine = splitLineModel.get("show");
    var showSplitArea = splitAreaModel.get("show");
    var splitLineColors = lineStyleModel.get("color");
    var splitAreaColors = areaStyleModel.get("color");
    var splitLineColorsArr = isArray$1(splitLineColors) ? splitLineColors : [splitLineColors];
    var splitAreaColorsArr = isArray$1(splitAreaColors) ? splitAreaColors : [splitAreaColors];
    var splitLines = [];
    var splitAreas = [];
    function getColorIndex(areaOrLine, areaOrLineColorList, idx) {
      var colorIndex2 = idx % areaOrLineColorList.length;
      areaOrLine[colorIndex2] = areaOrLine[colorIndex2] || [];
      return colorIndex2;
    }
    if (shape === "circle") {
      var ticksRadius = indicatorAxes[0].getTicksCoords();
      var cx = radar.cx;
      var cy = radar.cy;
      for (var i = 0; i < ticksRadius.length; i++) {
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Circle$1({
            shape: {
              cx,
              cy,
              r: ticksRadius[i].coord
            }
          }));
        }
        if (showSplitArea && i < ticksRadius.length - 1) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i);
          splitAreas[colorIndex].push(new Ring$1({
            shape: {
              cx,
              cy,
              r0: ticksRadius[i].coord,
              r: ticksRadius[i + 1].coord
            }
          }));
        }
      }
    } else {
      var realSplitNumber_1;
      var axesTicksPoints = map$1(indicatorAxes, function(indicatorAxis, idx) {
        var ticksCoords = indicatorAxis.getTicksCoords();
        realSplitNumber_1 = realSplitNumber_1 == null ? ticksCoords.length - 1 : Math.min(ticksCoords.length - 1, realSplitNumber_1);
        return map$1(ticksCoords, function(tickCoord) {
          return radar.coordToPoint(tickCoord.coord, idx);
        });
      });
      var prevPoints = [];
      for (var i = 0; i <= realSplitNumber_1; i++) {
        var points2 = [];
        for (var j = 0; j < indicatorAxes.length; j++) {
          points2.push(axesTicksPoints[j][i]);
        }
        if (points2[0]) {
          points2.push(points2[0].slice());
        }
        if (showSplitLine) {
          var colorIndex = getColorIndex(splitLines, splitLineColorsArr, i);
          splitLines[colorIndex].push(new Polyline$3({
            shape: {
              points: points2
            }
          }));
        }
        if (showSplitArea && prevPoints) {
          var colorIndex = getColorIndex(splitAreas, splitAreaColorsArr, i - 1);
          splitAreas[colorIndex].push(new Polygon$1({
            shape: {
              points: points2.concat(prevPoints)
            }
          }));
        }
        prevPoints = points2.slice().reverse();
      }
    }
    var lineStyle = lineStyleModel.getLineStyle();
    var areaStyle = areaStyleModel.getAreaStyle();
    each$f(splitAreas, function(splitAreas2, idx) {
      this.group.add(mergePath(splitAreas2, {
        style: defaults({
          stroke: "none",
          fill: splitAreaColorsArr[idx % splitAreaColorsArr.length]
        }, areaStyle),
        silent: true
      }));
    }, this);
    each$f(splitLines, function(splitLines2, idx) {
      this.group.add(mergePath(splitLines2, {
        style: defaults({
          fill: "none",
          stroke: splitLineColorsArr[idx % splitLineColorsArr.length]
        }, lineStyle),
        silent: true
      }));
    }, this);
  };
  RadarView2.type = "radar";
  return RadarView2;
}(ComponentView$1);
var RadarView$1 = RadarView;
var IndicatorAxis = function(_super) {
  __extends(IndicatorAxis2, _super);
  function IndicatorAxis2(dim, scale2, radiusExtent) {
    var _this = _super.call(this, dim, scale2, radiusExtent) || this;
    _this.type = "value";
    _this.angle = 0;
    _this.name = "";
    return _this;
  }
  return IndicatorAxis2;
}(Axis$1);
var IndicatorAxis$1 = IndicatorAxis;
var Radar = function() {
  function Radar2(radarModel, ecModel, api) {
    this.dimensions = [];
    this._model = radarModel;
    this._indicatorAxes = map$1(radarModel.getIndicatorModels(), function(indicatorModel, idx) {
      var dim = "indicator_" + idx;
      var indicatorAxis = new IndicatorAxis$1(dim, new IntervalScale$1());
      indicatorAxis.name = indicatorModel.get("name");
      indicatorAxis.model = indicatorModel;
      indicatorModel.axis = indicatorAxis;
      this.dimensions.push(dim);
      return indicatorAxis;
    }, this);
    this.resize(radarModel, api);
  }
  Radar2.prototype.getIndicatorAxes = function() {
    return this._indicatorAxes;
  };
  Radar2.prototype.dataToPoint = function(value, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    return this.coordToPoint(indicatorAxis.dataToCoord(value), indicatorIndex);
  };
  Radar2.prototype.coordToPoint = function(coord, indicatorIndex) {
    var indicatorAxis = this._indicatorAxes[indicatorIndex];
    var angle = indicatorAxis.angle;
    var x2 = this.cx + coord * Math.cos(angle);
    var y2 = this.cy - coord * Math.sin(angle);
    return [x2, y2];
  };
  Radar2.prototype.pointToData = function(pt) {
    var dx = pt[0] - this.cx;
    var dy = pt[1] - this.cy;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx);
    var minRadianDiff = Infinity;
    var closestAxis;
    var closestAxisIdx = -1;
    for (var i = 0; i < this._indicatorAxes.length; i++) {
      var indicatorAxis = this._indicatorAxes[i];
      var diff = Math.abs(radian - indicatorAxis.angle);
      if (diff < minRadianDiff) {
        closestAxis = indicatorAxis;
        closestAxisIdx = i;
        minRadianDiff = diff;
      }
    }
    return [closestAxisIdx, +(closestAxis && closestAxis.coordToData(radius))];
  };
  Radar2.prototype.resize = function(radarModel, api) {
    var center2 = radarModel.get("center");
    var viewWidth = api.getWidth();
    var viewHeight = api.getHeight();
    var viewSize = Math.min(viewWidth, viewHeight) / 2;
    this.cx = parsePercent(center2[0], viewWidth);
    this.cy = parsePercent(center2[1], viewHeight);
    this.startAngle = radarModel.get("startAngle") * Math.PI / 180;
    var radius = radarModel.get("radius");
    if (isString(radius) || isNumber(radius)) {
      radius = [0, radius];
    }
    this.r0 = parsePercent(radius[0], viewSize);
    this.r = parsePercent(radius[1], viewSize);
    each$f(this._indicatorAxes, function(indicatorAxis, idx) {
      indicatorAxis.setExtent(this.r0, this.r);
      var angle = this.startAngle + idx * Math.PI * 2 / this._indicatorAxes.length;
      angle = Math.atan2(Math.sin(angle), Math.cos(angle));
      indicatorAxis.angle = angle;
    }, this);
  };
  Radar2.prototype.update = function(ecModel, api) {
    var indicatorAxes = this._indicatorAxes;
    var radarModel = this._model;
    each$f(indicatorAxes, function(indicatorAxis) {
      indicatorAxis.scale.setExtent(Infinity, -Infinity);
    });
    ecModel.eachSeriesByType("radar", function(radarSeries, idx) {
      if (radarSeries.get("coordinateSystem") !== "radar" || ecModel.getComponent("radar", radarSeries.get("radarIndex")) !== radarModel) {
        return;
      }
      var data = radarSeries.getData();
      each$f(indicatorAxes, function(indicatorAxis) {
        indicatorAxis.scale.unionExtentFromData(data, data.mapDimension(indicatorAxis.dim));
      });
    }, this);
    var splitNumber = radarModel.get("splitNumber");
    var dummyScale = new IntervalScale$1();
    dummyScale.setExtent(0, splitNumber);
    dummyScale.setInterval(1);
    each$f(indicatorAxes, function(indicatorAxis, idx) {
      alignScaleTicks(indicatorAxis.scale, indicatorAxis.model, dummyScale);
    });
  };
  Radar2.prototype.convertToPixel = function(ecModel, finder, value) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    console.warn("Not implemented.");
    return null;
  };
  Radar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Radar2.create = function(ecModel, api) {
    var radarList = [];
    ecModel.eachComponent("radar", function(radarModel) {
      var radar = new Radar2(radarModel, ecModel, api);
      radarList.push(radar);
      radarModel.coordinateSystem = radar;
    });
    ecModel.eachSeriesByType("radar", function(radarSeries) {
      if (radarSeries.get("coordinateSystem") === "radar") {
        radarSeries.coordinateSystem = radarList[radarSeries.get("radarIndex") || 0];
      }
    });
    return radarList;
  };
  Radar2.dimensions = [];
  return Radar2;
}();
var Radar$1 = Radar;
function install$L(registers) {
  registers.registerCoordinateSystem("radar", Radar$1);
  registers.registerComponentModel(RadarModel$1);
  registers.registerComponentView(RadarView$1);
  registers.registerVisual({
    seriesType: "radar",
    reset: function(seriesModel) {
      var data = seriesModel.getData();
      data.each(function(idx) {
        data.setItemVisual(idx, "legendIcon", "roundRect");
      });
      data.setVisual("legendIcon", "roundRect");
    }
  });
}
function install$K(registers) {
  use(install$L);
  registers.registerChartView(RadarView$3);
  registers.registerSeriesModel(RadarSeriesModel$1);
  registers.registerLayout(radarLayout);
  registers.registerProcessor(dataFilter$1("radar"));
  registers.registerPreprocessor(radarBackwardCompat);
}
var ATTR = "\0_ec_interaction_mutex";
function take(zr, resourceKey, userKey) {
  var store = getStore(zr);
  store[resourceKey] = userKey;
}
function release(zr, resourceKey, userKey) {
  var store = getStore(zr);
  var uKey = store[resourceKey];
  if (uKey === userKey) {
    store[resourceKey] = null;
  }
}
function isTaken(zr, resourceKey) {
  return !!getStore(zr)[resourceKey];
}
function getStore(zr) {
  return zr[ATTR] || (zr[ATTR] = {});
}
registerAction({
  type: "takeGlobalCursor",
  event: "globalCursorTaken",
  update: "update"
}, noop);
var RoamController = function(_super) {
  __extends(RoamController2, _super);
  function RoamController2(zr) {
    var _this = _super.call(this) || this;
    _this._zr = zr;
    var mousedownHandler = bind$1(_this._mousedownHandler, _this);
    var mousemoveHandler = bind$1(_this._mousemoveHandler, _this);
    var mouseupHandler = bind$1(_this._mouseupHandler, _this);
    var mousewheelHandler = bind$1(_this._mousewheelHandler, _this);
    var pinchHandler = bind$1(_this._pinchHandler, _this);
    _this.enable = function(controlType, opt) {
      this.disable();
      this._opt = defaults(clone$4(opt) || {}, {
        zoomOnMouseWheel: true,
        moveOnMouseMove: true,
        moveOnMouseWheel: false,
        preventDefaultMouseMove: true
      });
      if (controlType == null) {
        controlType = true;
      }
      if (controlType === true || controlType === "move" || controlType === "pan") {
        zr.on("mousedown", mousedownHandler);
        zr.on("mousemove", mousemoveHandler);
        zr.on("mouseup", mouseupHandler);
      }
      if (controlType === true || controlType === "scale" || controlType === "zoom") {
        zr.on("mousewheel", mousewheelHandler);
        zr.on("pinch", pinchHandler);
      }
    };
    _this.disable = function() {
      zr.off("mousedown", mousedownHandler);
      zr.off("mousemove", mousemoveHandler);
      zr.off("mouseup", mouseupHandler);
      zr.off("mousewheel", mousewheelHandler);
      zr.off("pinch", pinchHandler);
    };
    return _this;
  }
  RoamController2.prototype.isDragging = function() {
    return this._dragging;
  };
  RoamController2.prototype.isPinching = function() {
    return this._pinching;
  };
  RoamController2.prototype.setPointerChecker = function(pointerChecker) {
    this.pointerChecker = pointerChecker;
  };
  RoamController2.prototype.dispose = function() {
    this.disable();
  };
  RoamController2.prototype._mousedownHandler = function(e2) {
    if (isMiddleOrRightButtonOnMouseUpDown(e2) || e2.target && e2.target.draggable) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    if (this.pointerChecker && this.pointerChecker(e2, x2, y2)) {
      this._x = x2;
      this._y = y2;
      this._dragging = true;
    }
  };
  RoamController2.prototype._mousemoveHandler = function(e2) {
    if (!this._dragging || !isAvailableBehavior("moveOnMouseMove", e2, this._opt) || e2.gestureEvent === "pinch" || isTaken(this._zr, "globalPan")) {
      return;
    }
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var oldX = this._x;
    var oldY = this._y;
    var dx = x2 - oldX;
    var dy = y2 - oldY;
    this._x = x2;
    this._y = y2;
    this._opt.preventDefaultMouseMove && stop(e2.event);
    trigger$1(this, "pan", "moveOnMouseMove", e2, {
      dx,
      dy,
      oldX,
      oldY,
      newX: x2,
      newY: y2,
      isAvailableBehavior: null
    });
  };
  RoamController2.prototype._mouseupHandler = function(e2) {
    if (!isMiddleOrRightButtonOnMouseUpDown(e2)) {
      this._dragging = false;
    }
  };
  RoamController2.prototype._mousewheelHandler = function(e2) {
    var shouldZoom = isAvailableBehavior("zoomOnMouseWheel", e2, this._opt);
    var shouldMove = isAvailableBehavior("moveOnMouseWheel", e2, this._opt);
    var wheelDelta = e2.wheelDelta;
    var absWheelDeltaDelta = Math.abs(wheelDelta);
    var originX = e2.offsetX;
    var originY = e2.offsetY;
    if (wheelDelta === 0 || !shouldZoom && !shouldMove) {
      return;
    }
    if (shouldZoom) {
      var factor = absWheelDeltaDelta > 3 ? 1.4 : absWheelDeltaDelta > 1 ? 1.2 : 1.1;
      var scale2 = wheelDelta > 0 ? factor : 1 / factor;
      checkPointerAndTrigger(this, "zoom", "zoomOnMouseWheel", e2, {
        scale: scale2,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
    if (shouldMove) {
      var absDelta = Math.abs(wheelDelta);
      var scrollDelta = (wheelDelta > 0 ? 1 : -1) * (absDelta > 3 ? 0.4 : absDelta > 1 ? 0.15 : 0.05);
      checkPointerAndTrigger(this, "scrollMove", "moveOnMouseWheel", e2, {
        scrollDelta,
        originX,
        originY,
        isAvailableBehavior: null
      });
    }
  };
  RoamController2.prototype._pinchHandler = function(e2) {
    if (isTaken(this._zr, "globalPan")) {
      return;
    }
    var scale2 = e2.pinchScale > 1 ? 1.1 : 1 / 1.1;
    checkPointerAndTrigger(this, "zoom", null, e2, {
      scale: scale2,
      originX: e2.pinchX,
      originY: e2.pinchY,
      isAvailableBehavior: null
    });
  };
  return RoamController2;
}(Eventful$1);
function checkPointerAndTrigger(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  if (controller.pointerChecker && controller.pointerChecker(e2, contollerEvent.originX, contollerEvent.originY)) {
    stop(e2.event);
    trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent);
  }
}
function trigger$1(controller, eventName, behaviorToCheck, e2, contollerEvent) {
  contollerEvent.isAvailableBehavior = bind$1(isAvailableBehavior, null, behaviorToCheck, e2);
  controller.trigger(eventName, contollerEvent);
}
function isAvailableBehavior(behaviorToCheck, e2, settings) {
  var setting = settings[behaviorToCheck];
  return !behaviorToCheck || setting && (!isString(setting) || e2.event[setting + "Key"]);
}
var RoamController$1 = RoamController;
function updateViewOnPan(controllerHost, dx, dy) {
  var target = controllerHost.target;
  target.x += dx;
  target.y += dy;
  target.dirty();
}
function updateViewOnZoom(controllerHost, zoomDelta, zoomX, zoomY) {
  var target = controllerHost.target;
  var zoomLimit = controllerHost.zoomLimit;
  var newZoom = controllerHost.zoom = controllerHost.zoom || 1;
  newZoom *= zoomDelta;
  if (zoomLimit) {
    var zoomMin = zoomLimit.min || 0;
    var zoomMax = zoomLimit.max || Infinity;
    newZoom = Math.max(Math.min(zoomMax, newZoom), zoomMin);
  }
  var zoomScale = newZoom / controllerHost.zoom;
  controllerHost.zoom = newZoom;
  target.x -= (zoomX - target.x) * (zoomScale - 1);
  target.y -= (zoomY - target.y) * (zoomScale - 1);
  target.scaleX *= zoomScale;
  target.scaleY *= zoomScale;
  target.dirty();
}
var IRRELEVANT_EXCLUDES = {
  "axisPointer": 1,
  "tooltip": 1,
  "brush": 1
};
function onIrrelevantElement(e2, api, targetCoordSysModel) {
  var model = api.getComponentByElement(e2.topTarget);
  var coordSys = model && model.coordinateSystem;
  return model && model !== targetCoordSysModel && !IRRELEVANT_EXCLUDES.hasOwnProperty(model.mainType) && coordSys && coordSys.model !== targetCoordSysModel;
}
function parseXML(svg) {
  if (isString(svg)) {
    var parser = new DOMParser();
    svg = parser.parseFromString(svg, "text/xml");
  }
  var svgNode = svg;
  if (svgNode.nodeType === 9) {
    svgNode = svgNode.firstChild;
  }
  while (svgNode.nodeName.toLowerCase() !== "svg" || svgNode.nodeType !== 1) {
    svgNode = svgNode.nextSibling;
  }
  return svgNode;
}
var nodeParsers;
var INHERITABLE_STYLE_ATTRIBUTES_MAP = {
  "fill": "fill",
  "stroke": "stroke",
  "stroke-width": "lineWidth",
  "opacity": "opacity",
  "fill-opacity": "fillOpacity",
  "stroke-opacity": "strokeOpacity",
  "stroke-dasharray": "lineDash",
  "stroke-dashoffset": "lineDashOffset",
  "stroke-linecap": "lineCap",
  "stroke-linejoin": "lineJoin",
  "stroke-miterlimit": "miterLimit",
  "font-family": "fontFamily",
  "font-size": "fontSize",
  "font-style": "fontStyle",
  "font-weight": "fontWeight",
  "text-anchor": "textAlign",
  "visibility": "visibility",
  "display": "display"
};
var INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS = keys(INHERITABLE_STYLE_ATTRIBUTES_MAP);
var SELF_STYLE_ATTRIBUTES_MAP = {
  "alignment-baseline": "textBaseline",
  "stop-color": "stopColor"
};
var SELF_STYLE_ATTRIBUTES_MAP_KEYS = keys(SELF_STYLE_ATTRIBUTES_MAP);
var SVGParser = function() {
  function SVGParser2() {
    this._defs = {};
    this._root = null;
  }
  SVGParser2.prototype.parse = function(xml, opt) {
    opt = opt || {};
    var svg = parseXML(xml);
    this._defsUsePending = [];
    var root2 = new Group$4();
    this._root = root2;
    var named = [];
    var viewBox = svg.getAttribute("viewBox") || "";
    var width = parseFloat(svg.getAttribute("width") || opt.width);
    var height = parseFloat(svg.getAttribute("height") || opt.height);
    isNaN(width) && (width = null);
    isNaN(height) && (height = null);
    parseAttributes(svg, root2, null, true, false);
    var child = svg.firstChild;
    while (child) {
      this._parseNode(child, root2, named, null, false, false);
      child = child.nextSibling;
    }
    applyDefs(this._defs, this._defsUsePending);
    this._defsUsePending = [];
    var viewBoxRect;
    var viewBoxTransform;
    if (viewBox) {
      var viewBoxArr = splitNumberSequence(viewBox);
      if (viewBoxArr.length >= 4) {
        viewBoxRect = {
          x: parseFloat(viewBoxArr[0] || 0),
          y: parseFloat(viewBoxArr[1] || 0),
          width: parseFloat(viewBoxArr[2]),
          height: parseFloat(viewBoxArr[3])
        };
      }
    }
    if (viewBoxRect && width != null && height != null) {
      viewBoxTransform = makeViewBoxTransform(viewBoxRect, { x: 0, y: 0, width, height });
      if (!opt.ignoreViewBox) {
        var elRoot = root2;
        root2 = new Group$4();
        root2.add(elRoot);
        elRoot.scaleX = elRoot.scaleY = viewBoxTransform.scale;
        elRoot.x = viewBoxTransform.x;
        elRoot.y = viewBoxTransform.y;
      }
    }
    if (!opt.ignoreRootClip && width != null && height != null) {
      root2.setClipPath(new Rect$3({
        shape: { x: 0, y: 0, width, height }
      }));
    }
    return {
      root: root2,
      width,
      height,
      viewBoxRect,
      viewBoxTransform,
      named
    };
  };
  SVGParser2.prototype._parseNode = function(xmlNode, parentGroup, named, namedFrom, isInDefs, isInText) {
    var nodeName = xmlNode.nodeName.toLowerCase();
    var el;
    var namedFromForSub = namedFrom;
    if (nodeName === "defs") {
      isInDefs = true;
    }
    if (nodeName === "text") {
      isInText = true;
    }
    if (nodeName === "defs" || nodeName === "switch") {
      el = parentGroup;
    } else {
      if (!isInDefs) {
        var parser_1 = nodeParsers[nodeName];
        if (parser_1 && hasOwn(nodeParsers, nodeName)) {
          el = parser_1.call(this, xmlNode, parentGroup);
          var nameAttr = xmlNode.getAttribute("name");
          if (nameAttr) {
            var newNamed = {
              name: nameAttr,
              namedFrom: null,
              svgNodeTagLower: nodeName,
              el
            };
            named.push(newNamed);
            if (nodeName === "g") {
              namedFromForSub = newNamed;
            }
          } else if (namedFrom) {
            named.push({
              name: namedFrom.name,
              namedFrom,
              svgNodeTagLower: nodeName,
              el
            });
          }
          parentGroup.add(el);
        }
      }
      var parser = paintServerParsers[nodeName];
      if (parser && hasOwn(paintServerParsers, nodeName)) {
        var def = parser.call(this, xmlNode);
        var id2 = xmlNode.getAttribute("id");
        if (id2) {
          this._defs[id2] = def;
        }
      }
    }
    if (el && el.isGroup) {
      var child = xmlNode.firstChild;
      while (child) {
        if (child.nodeType === 1) {
          this._parseNode(child, el, named, namedFromForSub, isInDefs, isInText);
        } else if (child.nodeType === 3 && isInText) {
          this._parseText(child, el);
        }
        child = child.nextSibling;
      }
    }
  };
  SVGParser2.prototype._parseText = function(xmlNode, parentGroup) {
    var text = new TSpan$1({
      style: {
        text: xmlNode.textContent
      },
      silent: true,
      x: this._textX || 0,
      y: this._textY || 0
    });
    inheritStyle(parentGroup, text);
    parseAttributes(xmlNode, text, this._defsUsePending, false, false);
    applyTextAlignment(text, parentGroup);
    var textStyle = text.style;
    var fontSize = textStyle.fontSize;
    if (fontSize && fontSize < 9) {
      textStyle.fontSize = 9;
      text.scaleX *= fontSize / 9;
      text.scaleY *= fontSize / 9;
    }
    var font = (textStyle.fontSize || textStyle.fontFamily) && [
      textStyle.fontStyle,
      textStyle.fontWeight,
      (textStyle.fontSize || 12) + "px",
      textStyle.fontFamily || "sans-serif"
    ].join(" ");
    textStyle.font = font;
    var rect = text.getBoundingRect();
    this._textX += rect.width;
    parentGroup.add(text);
    return text;
  };
  SVGParser2.internalField = function() {
    nodeParsers = {
      "g": function(xmlNode, parentGroup) {
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, false);
        return g2;
      },
      "rect": function(xmlNode, parentGroup) {
        var rect = new Rect$3();
        inheritStyle(parentGroup, rect);
        parseAttributes(xmlNode, rect, this._defsUsePending, false, false);
        rect.setShape({
          x: parseFloat(xmlNode.getAttribute("x") || "0"),
          y: parseFloat(xmlNode.getAttribute("y") || "0"),
          width: parseFloat(xmlNode.getAttribute("width") || "0"),
          height: parseFloat(xmlNode.getAttribute("height") || "0")
        });
        rect.silent = true;
        return rect;
      },
      "circle": function(xmlNode, parentGroup) {
        var circle = new Circle$1();
        inheritStyle(parentGroup, circle);
        parseAttributes(xmlNode, circle, this._defsUsePending, false, false);
        circle.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          r: parseFloat(xmlNode.getAttribute("r") || "0")
        });
        circle.silent = true;
        return circle;
      },
      "line": function(xmlNode, parentGroup) {
        var line = new Line$3();
        inheritStyle(parentGroup, line);
        parseAttributes(xmlNode, line, this._defsUsePending, false, false);
        line.setShape({
          x1: parseFloat(xmlNode.getAttribute("x1") || "0"),
          y1: parseFloat(xmlNode.getAttribute("y1") || "0"),
          x2: parseFloat(xmlNode.getAttribute("x2") || "0"),
          y2: parseFloat(xmlNode.getAttribute("y2") || "0")
        });
        line.silent = true;
        return line;
      },
      "ellipse": function(xmlNode, parentGroup) {
        var ellipse = new Ellipse$1();
        inheritStyle(parentGroup, ellipse);
        parseAttributes(xmlNode, ellipse, this._defsUsePending, false, false);
        ellipse.setShape({
          cx: parseFloat(xmlNode.getAttribute("cx") || "0"),
          cy: parseFloat(xmlNode.getAttribute("cy") || "0"),
          rx: parseFloat(xmlNode.getAttribute("rx") || "0"),
          ry: parseFloat(xmlNode.getAttribute("ry") || "0")
        });
        ellipse.silent = true;
        return ellipse;
      },
      "polygon": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polygon = new Polygon$1({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polygon);
        parseAttributes(xmlNode, polygon, this._defsUsePending, false, false);
        return polygon;
      },
      "polyline": function(xmlNode, parentGroup) {
        var pointsStr = xmlNode.getAttribute("points");
        var pointsArr;
        if (pointsStr) {
          pointsArr = parsePoints(pointsStr);
        }
        var polyline = new Polyline$3({
          shape: {
            points: pointsArr || []
          },
          silent: true
        });
        inheritStyle(parentGroup, polyline);
        parseAttributes(xmlNode, polyline, this._defsUsePending, false, false);
        return polyline;
      },
      "image": function(xmlNode, parentGroup) {
        var img = new ZRImage$1();
        inheritStyle(parentGroup, img);
        parseAttributes(xmlNode, img, this._defsUsePending, false, false);
        img.setStyle({
          image: xmlNode.getAttribute("xlink:href") || xmlNode.getAttribute("href"),
          x: +xmlNode.getAttribute("x"),
          y: +xmlNode.getAttribute("y"),
          width: +xmlNode.getAttribute("width"),
          height: +xmlNode.getAttribute("height")
        });
        img.silent = true;
        return img;
      },
      "text": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x") || "0";
        var y2 = xmlNode.getAttribute("y") || "0";
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        this._textX = parseFloat(x2) + parseFloat(dx);
        this._textY = parseFloat(y2) + parseFloat(dy);
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        return g2;
      },
      "tspan": function(xmlNode, parentGroup) {
        var x2 = xmlNode.getAttribute("x");
        var y2 = xmlNode.getAttribute("y");
        if (x2 != null) {
          this._textX = parseFloat(x2);
        }
        if (y2 != null) {
          this._textY = parseFloat(y2);
        }
        var dx = xmlNode.getAttribute("dx") || "0";
        var dy = xmlNode.getAttribute("dy") || "0";
        var g2 = new Group$4();
        inheritStyle(parentGroup, g2);
        parseAttributes(xmlNode, g2, this._defsUsePending, false, true);
        this._textX += parseFloat(dx);
        this._textY += parseFloat(dy);
        return g2;
      },
      "path": function(xmlNode, parentGroup) {
        var d2 = xmlNode.getAttribute("d") || "";
        var path = createFromString(d2);
        inheritStyle(parentGroup, path);
        parseAttributes(xmlNode, path, this._defsUsePending, false, false);
        path.silent = true;
        return path;
      }
    };
  }();
  return SVGParser2;
}();
var paintServerParsers = {
  "lineargradient": function(xmlNode) {
    var x1 = parseInt(xmlNode.getAttribute("x1") || "0", 10);
    var y1 = parseInt(xmlNode.getAttribute("y1") || "0", 10);
    var x2 = parseInt(xmlNode.getAttribute("x2") || "10", 10);
    var y2 = parseInt(xmlNode.getAttribute("y2") || "0", 10);
    var gradient = new LinearGradient$1(x1, y1, x2, y2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  },
  "radialgradient": function(xmlNode) {
    var cx = parseInt(xmlNode.getAttribute("cx") || "0", 10);
    var cy = parseInt(xmlNode.getAttribute("cy") || "0", 10);
    var r2 = parseInt(xmlNode.getAttribute("r") || "0", 10);
    var gradient = new RadialGradient$1(cx, cy, r2);
    parsePaintServerUnit(xmlNode, gradient);
    parseGradientColorStops(xmlNode, gradient);
    return gradient;
  }
};
function parsePaintServerUnit(xmlNode, gradient) {
  var gradientUnits = xmlNode.getAttribute("gradientUnits");
  if (gradientUnits === "userSpaceOnUse") {
    gradient.global = true;
  }
}
function parseGradientColorStops(xmlNode, gradient) {
  var stop2 = xmlNode.firstChild;
  while (stop2) {
    if (stop2.nodeType === 1 && stop2.nodeName.toLocaleLowerCase() === "stop") {
      var offsetStr = stop2.getAttribute("offset");
      var offset = void 0;
      if (offsetStr && offsetStr.indexOf("%") > 0) {
        offset = parseInt(offsetStr, 10) / 100;
      } else if (offsetStr) {
        offset = parseFloat(offsetStr);
      } else {
        offset = 0;
      }
      var styleVals = {};
      parseInlineStyle(stop2, styleVals, styleVals);
      var stopColor = styleVals.stopColor || stop2.getAttribute("stop-color") || "#000000";
      gradient.colorStops.push({
        offset,
        color: stopColor
      });
    }
    stop2 = stop2.nextSibling;
  }
}
function inheritStyle(parent, child) {
  if (parent && parent.__inheritedStyle) {
    if (!child.__inheritedStyle) {
      child.__inheritedStyle = {};
    }
    defaults(child.__inheritedStyle, parent.__inheritedStyle);
  }
}
function parsePoints(pointsString) {
  var list = splitNumberSequence(pointsString);
  var points2 = [];
  for (var i = 0; i < list.length; i += 2) {
    var x2 = parseFloat(list[i]);
    var y2 = parseFloat(list[i + 1]);
    points2.push([x2, y2]);
  }
  return points2;
}
function parseAttributes(xmlNode, el, defsUsePending, onlyInlineStyle, isTextGroup) {
  var disp = el;
  var inheritedStyle = disp.__inheritedStyle = disp.__inheritedStyle || {};
  var selfStyle = {};
  if (xmlNode.nodeType === 1) {
    parseTransformAttribute(xmlNode, el);
    parseInlineStyle(xmlNode, inheritedStyle, selfStyle);
    if (!onlyInlineStyle) {
      parseAttributeStyle(xmlNode, inheritedStyle, selfStyle);
    }
  }
  disp.style = disp.style || {};
  if (inheritedStyle.fill != null) {
    disp.style.fill = getFillStrokeStyle(disp, "fill", inheritedStyle.fill, defsUsePending);
  }
  if (inheritedStyle.stroke != null) {
    disp.style.stroke = getFillStrokeStyle(disp, "stroke", inheritedStyle.stroke, defsUsePending);
  }
  each$f([
    "lineWidth",
    "opacity",
    "fillOpacity",
    "strokeOpacity",
    "miterLimit",
    "fontSize"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = parseFloat(inheritedStyle[propName]);
    }
  });
  each$f([
    "lineDashOffset",
    "lineCap",
    "lineJoin",
    "fontWeight",
    "fontFamily",
    "fontStyle",
    "textAlign"
  ], function(propName) {
    if (inheritedStyle[propName] != null) {
      disp.style[propName] = inheritedStyle[propName];
    }
  });
  if (isTextGroup) {
    disp.__selfStyle = selfStyle;
  }
  if (inheritedStyle.lineDash) {
    disp.style.lineDash = map$1(splitNumberSequence(inheritedStyle.lineDash), function(str) {
      return parseFloat(str);
    });
  }
  if (inheritedStyle.visibility === "hidden" || inheritedStyle.visibility === "collapse") {
    disp.invisible = true;
  }
  if (inheritedStyle.display === "none") {
    disp.ignore = true;
  }
}
function applyTextAlignment(text, parentGroup) {
  var parentSelfStyle = parentGroup.__selfStyle;
  if (parentSelfStyle) {
    var textBaseline = parentSelfStyle.textBaseline;
    var zrTextBaseline = textBaseline;
    if (!textBaseline || textBaseline === "auto") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "baseline") {
      zrTextBaseline = "alphabetic";
    } else if (textBaseline === "before-edge" || textBaseline === "text-before-edge") {
      zrTextBaseline = "top";
    } else if (textBaseline === "after-edge" || textBaseline === "text-after-edge") {
      zrTextBaseline = "bottom";
    } else if (textBaseline === "central" || textBaseline === "mathematical") {
      zrTextBaseline = "middle";
    }
    text.style.textBaseline = zrTextBaseline;
  }
  var parentInheritedStyle = parentGroup.__inheritedStyle;
  if (parentInheritedStyle) {
    var textAlign = parentInheritedStyle.textAlign;
    var zrTextAlign = textAlign;
    if (textAlign) {
      if (textAlign === "middle") {
        zrTextAlign = "center";
      }
      text.style.textAlign = zrTextAlign;
    }
  }
}
var urlRegex = /^url\(\s*#(.*?)\)/;
function getFillStrokeStyle(el, method4, str, defsUsePending) {
  var urlMatch = str && str.match(urlRegex);
  if (urlMatch) {
    var url2 = trim$1(urlMatch[1]);
    defsUsePending.push([el, method4, url2]);
    return;
  }
  if (str === "none") {
    str = null;
  }
  return str;
}
function applyDefs(defs, defsUsePending) {
  for (var i = 0; i < defsUsePending.length; i++) {
    var item = defsUsePending[i];
    item[0].style[item[1]] = defs[item[2]];
  }
}
var numberReg = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
function splitNumberSequence(rawStr) {
  return rawStr.match(numberReg) || [];
}
var transformRegex = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g;
var DEGREE_TO_ANGLE = Math.PI / 180;
function parseTransformAttribute(xmlNode, node) {
  var transform2 = xmlNode.getAttribute("transform");
  if (transform2) {
    transform2 = transform2.replace(/,/g, " ");
    var transformOps_1 = [];
    var mt = null;
    transform2.replace(transformRegex, function(str, type5, value2) {
      transformOps_1.push(type5, value2);
      return "";
    });
    for (var i = transformOps_1.length - 1; i > 0; i -= 2) {
      var value = transformOps_1[i];
      var type4 = transformOps_1[i - 1];
      var valueArr = splitNumberSequence(value);
      mt = mt || create$1();
      switch (type4) {
        case "translate":
          translate(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || "0")]);
          break;
        case "scale":
          scale$1(mt, mt, [parseFloat(valueArr[0]), parseFloat(valueArr[1] || valueArr[0])]);
          break;
        case "rotate":
          rotate(mt, mt, -parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          break;
        case "skewX":
          var sx = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, 0, sx, 1, 0, 0], mt);
          break;
        case "skewY":
          var sy = Math.tan(parseFloat(valueArr[0]) * DEGREE_TO_ANGLE);
          mul(mt, [1, sy, 0, 1, 0, 0], mt);
          break;
        case "matrix":
          mt[0] = parseFloat(valueArr[0]);
          mt[1] = parseFloat(valueArr[1]);
          mt[2] = parseFloat(valueArr[2]);
          mt[3] = parseFloat(valueArr[3]);
          mt[4] = parseFloat(valueArr[4]);
          mt[5] = parseFloat(valueArr[5]);
          break;
      }
    }
    node.setLocalTransform(mt);
  }
}
var styleRegex = /([^\s:;]+)\s*:\s*([^:;]+)/g;
function parseInlineStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  var style = xmlNode.getAttribute("style");
  if (!style) {
    return;
  }
  styleRegex.lastIndex = 0;
  var styleRegResult;
  while ((styleRegResult = styleRegex.exec(style)) != null) {
    var svgStlAttr = styleRegResult[1];
    var zrInheritableStlAttr = hasOwn(INHERITABLE_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? INHERITABLE_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrInheritableStlAttr) {
      inheritableStyleResult[zrInheritableStlAttr] = styleRegResult[2];
    }
    var zrSelfStlAttr = hasOwn(SELF_STYLE_ATTRIBUTES_MAP, svgStlAttr) ? SELF_STYLE_ATTRIBUTES_MAP[svgStlAttr] : null;
    if (zrSelfStlAttr) {
      selfStyleResult[zrSelfStlAttr] = styleRegResult[2];
    }
  }
}
function parseAttributeStyle(xmlNode, inheritableStyleResult, selfStyleResult) {
  for (var i = 0; i < INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = INHERITABLE_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      inheritableStyleResult[INHERITABLE_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
  for (var i = 0; i < SELF_STYLE_ATTRIBUTES_MAP_KEYS.length; i++) {
    var svgAttrName = SELF_STYLE_ATTRIBUTES_MAP_KEYS[i];
    var attrValue = xmlNode.getAttribute(svgAttrName);
    if (attrValue != null) {
      selfStyleResult[SELF_STYLE_ATTRIBUTES_MAP[svgAttrName]] = attrValue;
    }
  }
}
function makeViewBoxTransform(viewBoxRect, boundingRect) {
  var scaleX = boundingRect.width / viewBoxRect.width;
  var scaleY = boundingRect.height / viewBoxRect.height;
  var scale2 = Math.min(scaleX, scaleY);
  return {
    scale: scale2,
    x: -(viewBoxRect.x + viewBoxRect.width / 2) * scale2 + (boundingRect.x + boundingRect.width / 2),
    y: -(viewBoxRect.y + viewBoxRect.height / 2) * scale2 + (boundingRect.y + boundingRect.height / 2)
  };
}
function parseSVG(xml, opt) {
  var parser = new SVGParser();
  return parser.parse(xml, opt);
}
var REGION_AVAILABLE_SVG_TAG_MAP = createHashMap([
  "rect",
  "circle",
  "line",
  "ellipse",
  "polygon",
  "polyline",
  "path",
  "text",
  "tspan",
  "g"
]);
var GeoSVGResource = function() {
  function GeoSVGResource2(mapName, svg) {
    this.type = "geoSVG";
    this._usedGraphicMap = createHashMap();
    this._freedGraphics = [];
    this._mapName = mapName;
    this._parsedXML = parseXML(svg);
  }
  GeoSVGResource2.prototype.load = function() {
    var firstGraphic = this._firstGraphic;
    if (!firstGraphic) {
      firstGraphic = this._firstGraphic = this._buildGraphic(this._parsedXML);
      this._freedGraphics.push(firstGraphic);
      this._boundingRect = this._firstGraphic.boundingRect.clone();
      var _a2 = createRegions(firstGraphic.named), regions = _a2.regions, regionsMap = _a2.regionsMap;
      this._regions = regions;
      this._regionsMap = regionsMap;
    }
    return {
      boundingRect: this._boundingRect,
      regions: this._regions,
      regionsMap: this._regionsMap
    };
  };
  GeoSVGResource2.prototype._buildGraphic = function(svgXML) {
    var result;
    var rootFromParse;
    try {
      result = svgXML && parseSVG(svgXML, {
        ignoreViewBox: true,
        ignoreRootClip: true
      }) || {};
      rootFromParse = result.root;
      assert(rootFromParse != null);
    } catch (e2) {
      throw new Error("Invalid svg format\n" + e2.message);
    }
    var root2 = new Group$4();
    root2.add(rootFromParse);
    root2.isGeoSVGGraphicRoot = true;
    var svgWidth = result.width;
    var svgHeight = result.height;
    var viewBoxRect = result.viewBoxRect;
    var boundingRect = this._boundingRect;
    if (!boundingRect) {
      var bRectX = void 0;
      var bRectY = void 0;
      var bRectWidth = void 0;
      var bRectHeight = void 0;
      if (svgWidth != null) {
        bRectX = 0;
        bRectWidth = svgWidth;
      } else if (viewBoxRect) {
        bRectX = viewBoxRect.x;
        bRectWidth = viewBoxRect.width;
      }
      if (svgHeight != null) {
        bRectY = 0;
        bRectHeight = svgHeight;
      } else if (viewBoxRect) {
        bRectY = viewBoxRect.y;
        bRectHeight = viewBoxRect.height;
      }
      if (bRectX == null || bRectY == null) {
        var calculatedBoundingRect = rootFromParse.getBoundingRect();
        if (bRectX == null) {
          bRectX = calculatedBoundingRect.x;
          bRectWidth = calculatedBoundingRect.width;
        }
        if (bRectY == null) {
          bRectY = calculatedBoundingRect.y;
          bRectHeight = calculatedBoundingRect.height;
        }
      }
      boundingRect = this._boundingRect = new BoundingRect$1(bRectX, bRectY, bRectWidth, bRectHeight);
    }
    if (viewBoxRect) {
      var viewBoxTransform = makeViewBoxTransform(viewBoxRect, boundingRect);
      rootFromParse.scaleX = rootFromParse.scaleY = viewBoxTransform.scale;
      rootFromParse.x = viewBoxTransform.x;
      rootFromParse.y = viewBoxTransform.y;
    }
    root2.setClipPath(new Rect$3({
      shape: boundingRect.plain()
    }));
    var named = [];
    each$f(result.named, function(namedItem) {
      if (REGION_AVAILABLE_SVG_TAG_MAP.get(namedItem.svgNodeTagLower) != null) {
        named.push(namedItem);
        setSilent(namedItem.el);
      }
    });
    return {
      root: root2,
      boundingRect,
      named
    };
  };
  GeoSVGResource2.prototype.useGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      return svgGraphic;
    }
    svgGraphic = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML);
    usedRootMap.set(hostKey, svgGraphic);
    return svgGraphic;
  };
  GeoSVGResource2.prototype.freeGraphic = function(hostKey) {
    var usedRootMap = this._usedGraphicMap;
    var svgGraphic = usedRootMap.get(hostKey);
    if (svgGraphic) {
      usedRootMap.removeKey(hostKey);
      this._freedGraphics.push(svgGraphic);
    }
  };
  return GeoSVGResource2;
}();
function setSilent(el) {
  el.silent = false;
  if (el.isGroup) {
    el.traverse(function(child) {
      child.silent = false;
    });
  }
}
function createRegions(named) {
  var regions = [];
  var regionsMap = createHashMap();
  each$f(named, function(namedItem) {
    if (namedItem.namedFrom != null) {
      return;
    }
    var region = new GeoSVGRegion(namedItem.name, namedItem.el);
    regions.push(region);
    regionsMap.set(namedItem.name, region);
  });
  return {
    regions,
    regionsMap
  };
}
var geoCoord = [126, 25];
var nanhaiName = "\u5357\u6D77\u8BF8\u5C9B";
var points$1 = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
for (var i = 0; i < points$1.length; i++) {
  for (var k$1 = 0; k$1 < points$1[i].length; k$1++) {
    points$1[i][k$1][0] /= 10.5;
    points$1[i][k$1][1] /= -10.5 / 0.75;
    points$1[i][k$1][0] += geoCoord[0];
    points$1[i][k$1][1] += geoCoord[1];
  }
}
function fixNanhai(mapType, regions) {
  if (mapType === "china") {
    for (var i = 0; i < regions.length; i++) {
      if (regions[i].name === nanhaiName) {
        return;
      }
    }
    regions.push(new GeoJSONRegion(nanhaiName, map$1(points$1, function(exterior) {
      return {
        type: "polygon",
        exterior
      };
    }), geoCoord));
  }
}
var coordsOffsetMap = {
  "\u5357\u6D77\u8BF8\u5C9B": [32, 80],
  "\u5E7F\u4E1C": [0, -10],
  "\u9999\u6E2F": [10, 5],
  "\u6FB3\u95E8": [-10, 10],
  "\u5929\u6D25": [5, 5]
};
function fixTextCoords(mapType, region) {
  if (mapType === "china") {
    var coordFix = coordsOffsetMap[region.name];
    if (coordFix) {
      var cp = region.getCenter();
      cp[0] += coordFix[0] / 10.5;
      cp[1] += -coordFix[1] / (10.5 / 0.75);
      region.setCenter(cp);
    }
  }
}
var points = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
function fixDiaoyuIsland(mapType, region) {
  if (mapType === "china" && region.name === "\u53F0\u6E7E") {
    region.geometries.push({
      type: "polygon",
      exterior: points[0]
    });
  }
}
var DEFAULT_NAME_PROPERTY = "name";
var GeoJSONResource = function() {
  function GeoJSONResource2(mapName, geoJSON, specialAreas) {
    this.type = "geoJSON";
    this._parsedMap = createHashMap();
    this._mapName = mapName;
    this._specialAreas = specialAreas;
    this._geoJSON = parseInput(geoJSON);
  }
  GeoJSONResource2.prototype.load = function(nameMap, nameProperty) {
    nameProperty = nameProperty || DEFAULT_NAME_PROPERTY;
    var parsed = this._parsedMap.get(nameProperty);
    if (!parsed) {
      var rawRegions = this._parseToRegions(nameProperty);
      parsed = this._parsedMap.set(nameProperty, {
        regions: rawRegions,
        boundingRect: calculateBoundingRect(rawRegions)
      });
    }
    var regionsMap = createHashMap();
    var finalRegions = [];
    each$f(parsed.regions, function(region) {
      var regionName = region.name;
      if (nameMap && hasOwn(nameMap, regionName)) {
        region = region.cloneShallow(regionName = nameMap[regionName]);
      }
      finalRegions.push(region);
      regionsMap.set(regionName, region);
    });
    return {
      regions: finalRegions,
      boundingRect: parsed.boundingRect || new BoundingRect$1(0, 0, 0, 0),
      regionsMap
    };
  };
  GeoJSONResource2.prototype._parseToRegions = function(nameProperty) {
    var mapName = this._mapName;
    var geoJSON = this._geoJSON;
    var rawRegions;
    try {
      rawRegions = geoJSON ? parseGeoJSON(geoJSON, nameProperty) : [];
    } catch (e2) {
      throw new Error("Invalid geoJson format\n" + e2.message);
    }
    fixNanhai(mapName, rawRegions);
    each$f(rawRegions, function(region) {
      var regionName = region.name;
      fixTextCoords(mapName, region);
      fixDiaoyuIsland(mapName, region);
      var specialArea = this._specialAreas && this._specialAreas[regionName];
      if (specialArea) {
        region.transformTo(specialArea.left, specialArea.top, specialArea.width, specialArea.height);
      }
    }, this);
    return rawRegions;
  };
  GeoJSONResource2.prototype.getMapForUser = function() {
    return {
      geoJson: this._geoJSON,
      geoJSON: this._geoJSON,
      specialAreas: this._specialAreas
    };
  };
  return GeoJSONResource2;
}();
function calculateBoundingRect(regions) {
  var rect;
  for (var i = 0; i < regions.length; i++) {
    var regionRect = regions[i].getBoundingRect();
    rect = rect || regionRect.clone();
    rect.union(regionRect);
  }
  return rect;
}
function parseInput(source) {
  return !isString(source) ? source : typeof JSON !== "undefined" && JSON.parse ? JSON.parse(source) : new Function("return (" + source + ");")();
}
var storage = createHashMap();
var geoSourceManager = {
  registerMap: function(mapName, rawDef, rawSpecialAreas) {
    if (rawDef.svg) {
      var resource = new GeoSVGResource(mapName, rawDef.svg);
      storage.set(mapName, resource);
    } else {
      var geoJSON = rawDef.geoJson || rawDef.geoJSON;
      if (geoJSON && !rawDef.features) {
        rawSpecialAreas = rawDef.specialAreas;
      } else {
        geoJSON = rawDef;
      }
      var resource = new GeoJSONResource(mapName, geoJSON, rawSpecialAreas);
      storage.set(mapName, resource);
    }
  },
  getGeoResource: function(mapName) {
    return storage.get(mapName);
  },
  getMapForUser: function(mapName) {
    var resource = storage.get(mapName);
    return resource && resource.type === "geoJSON" && resource.getMapForUser();
  },
  load: function(mapName, nameMap, nameProperty) {
    var resource = storage.get(mapName);
    if (!resource) {
      return;
    }
    return resource.load(nameMap, nameProperty);
  }
};
var OPTION_STYLE_ENABLED_TAGS = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"];
var OPTION_STYLE_ENABLED_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS);
var STATE_TRIGGER_TAG_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var LABEL_HOST_MAP = createHashMap(OPTION_STYLE_ENABLED_TAGS.concat(["g"]));
var mapLabelRaw = makeInner();
function getFixedItemStyle(model) {
  var itemStyle = model.getItemStyle();
  var areaColor = model.get("areaColor");
  if (areaColor != null) {
    itemStyle.fill = areaColor;
  }
  return itemStyle;
}
function fixLineStyle(styleHost) {
  var style = styleHost.style;
  if (style) {
    style.stroke = style.stroke || style.fill;
    style.fill = null;
  }
}
var MapDraw = function() {
  function MapDraw2(api) {
    var group = new Group$4();
    this.uid = getUID("ec_map_draw");
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    this.group = group;
    group.add(this._regionsGroup = new Group$4());
    group.add(this._svgGroup = new Group$4());
  }
  MapDraw2.prototype.draw = function(mapOrGeoModel, ecModel, api, fromView, payload) {
    var isGeo = mapOrGeoModel.mainType === "geo";
    var data = mapOrGeoModel.getData && mapOrGeoModel.getData();
    isGeo && ecModel.eachComponent({
      mainType: "series",
      subType: "map"
    }, function(mapSeries) {
      if (!data && mapSeries.getHostGeoModel() === mapOrGeoModel) {
        data = mapSeries.getData();
      }
    });
    var geo = mapOrGeoModel.coordinateSystem;
    var regionsGroup = this._regionsGroup;
    var group = this.group;
    var transformInfo = geo.getTransformInfo();
    var transformInfoRaw = transformInfo.raw;
    var transformInfoRoam = transformInfo.roam;
    var isFirstDraw = !regionsGroup.childAt(0) || payload;
    if (isFirstDraw) {
      group.x = transformInfoRoam.x;
      group.y = transformInfoRoam.y;
      group.scaleX = transformInfoRoam.scaleX;
      group.scaleY = transformInfoRoam.scaleY;
      group.dirty();
    } else {
      updateProps$1(group, transformInfoRoam, mapOrGeoModel);
    }
    var isVisualEncodedByVisualMap = data && data.getVisual("visualMeta") && data.getVisual("visualMeta").length > 0;
    var viewBuildCtx = {
      api,
      geo,
      mapOrGeoModel,
      data,
      isVisualEncodedByVisualMap,
      isGeo,
      transformInfoRaw
    };
    if (geo.resourceType === "geoJSON") {
      this._buildGeoJSON(viewBuildCtx);
    } else if (geo.resourceType === "geoSVG") {
      this._buildSVG(viewBuildCtx);
    }
    this._updateController(mapOrGeoModel, ecModel, api);
    this._updateMapSelectHandler(mapOrGeoModel, regionsGroup, api, fromView);
  };
  MapDraw2.prototype._buildGeoJSON = function(viewBuildCtx) {
    var regionsGroupByName = this._regionsGroupByName = createHashMap();
    var regionsInfoByName = createHashMap();
    var regionsGroup = this._regionsGroup;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
    var data = viewBuildCtx.data;
    var projection = viewBuildCtx.geo.projection;
    var projectionStream = projection && projection.stream;
    function transformPoint(point, project) {
      if (project) {
        point = project(point);
      }
      return point && [point[0] * transformInfoRaw.scaleX + transformInfoRaw.x, point[1] * transformInfoRaw.scaleY + transformInfoRaw.y];
    }
    function transformPolygonPoints(inPoints) {
      var outPoints = [];
      var project = !projectionStream && projection && projection.project;
      for (var i = 0; i < inPoints.length; ++i) {
        var newPt = transformPoint(inPoints[i], project);
        newPt && outPoints.push(newPt);
      }
      return outPoints;
    }
    function getPolyShape(points2) {
      return {
        shape: {
          points: transformPolygonPoints(points2)
        }
      };
    }
    regionsGroup.removeAll();
    each$f(viewBuildCtx.geo.regions, function(region) {
      var regionName = region.name;
      var regionGroup = regionsGroupByName.get(regionName);
      var _a2 = regionsInfoByName.get(regionName) || {}, dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      if (!regionGroup) {
        regionGroup = regionsGroupByName.set(regionName, new Group$4());
        regionsGroup.add(regionGroup);
        dataIdx = data ? data.indexOfName(regionName) : null;
        regionModel = viewBuildCtx.isGeo ? mapOrGeoModel.getRegionModel(regionName) : data ? data.getItemModel(dataIdx) : null;
        regionsInfoByName.set(regionName, {
          dataIdx,
          regionModel
        });
      }
      var polygonSubpaths = [];
      var polylineSubpaths = [];
      each$f(region.geometries, function(geometry) {
        if (geometry.type === "polygon") {
          var polys = [geometry.exterior].concat(geometry.interiors || []);
          if (projectionStream) {
            polys = projectPolys(polys, projectionStream);
          }
          each$f(polys, function(poly) {
            polygonSubpaths.push(new Polygon$1(getPolyShape(poly)));
          });
        } else {
          var points2 = geometry.points;
          if (projectionStream) {
            points2 = projectPolys(points2, projectionStream, true);
          }
          each$f(points2, function(points3) {
            polylineSubpaths.push(new Polyline$3(getPolyShape(points3)));
          });
        }
      });
      var centerPt = transformPoint(region.getCenter(), projection && projection.project);
      function createCompoundPath(subpaths, isLine) {
        if (!subpaths.length) {
          return;
        }
        var compoundPath = new CompoundPath$1({
          culling: true,
          segmentIgnoreThreshold: 1,
          shape: {
            paths: subpaths
          }
        });
        regionGroup.add(compoundPath);
        applyOptionStyleForRegion(viewBuildCtx, compoundPath, dataIdx, regionModel);
        resetLabelForRegion(viewBuildCtx, compoundPath, regionName, regionModel, mapOrGeoModel, dataIdx, centerPt);
        if (isLine) {
          fixLineStyle(compoundPath);
          each$f(compoundPath.states, fixLineStyle);
        }
      }
      createCompoundPath(polygonSubpaths);
      createCompoundPath(polylineSubpaths, true);
    });
    regionsGroupByName.each(function(regionGroup, regionName) {
      var _a2 = regionsInfoByName.get(regionName), dataIdx = _a2.dataIdx, regionModel = _a2.regionModel;
      resetEventTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel, dataIdx);
      resetTooltipForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
      resetStateTriggerForRegion(viewBuildCtx, regionGroup, regionName, regionModel, mapOrGeoModel);
    }, this);
  };
  MapDraw2.prototype._buildSVG = function(viewBuildCtx) {
    var mapName = viewBuildCtx.geo.map;
    var transformInfoRaw = viewBuildCtx.transformInfoRaw;
    this._svgGroup.x = transformInfoRaw.x;
    this._svgGroup.y = transformInfoRaw.y;
    this._svgGroup.scaleX = transformInfoRaw.scaleX;
    this._svgGroup.scaleY = transformInfoRaw.scaleY;
    if (this._svgResourceChanged(mapName)) {
      this._freeSVG();
      this._useSVG(mapName);
    }
    var svgDispatcherMap = this._svgDispatcherMap = createHashMap();
    var focusSelf = false;
    each$f(this._svgGraphicRecord.named, function(namedItem) {
      var regionName = namedItem.name;
      var mapOrGeoModel = viewBuildCtx.mapOrGeoModel;
      var data = viewBuildCtx.data;
      var svgNodeTagLower = namedItem.svgNodeTagLower;
      var el = namedItem.el;
      var dataIdx = data ? data.indexOfName(regionName) : null;
      var regionModel = mapOrGeoModel.getRegionModel(regionName);
      if (OPTION_STYLE_ENABLED_TAG_MAP.get(svgNodeTagLower) != null && el instanceof Displayable$1) {
        applyOptionStyleForRegion(viewBuildCtx, el, dataIdx, regionModel);
      }
      if (el instanceof Displayable$1) {
        el.culling = true;
      }
      el.z2EmphasisLift = 0;
      if (!namedItem.namedFrom) {
        if (LABEL_HOST_MAP.get(svgNodeTagLower) != null) {
          resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, null);
        }
        resetEventTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx);
        resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
        if (STATE_TRIGGER_TAG_MAP.get(svgNodeTagLower) != null) {
          var focus_1 = resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel);
          if (focus_1 === "self") {
            focusSelf = true;
          }
          var els = svgDispatcherMap.get(regionName) || svgDispatcherMap.set(regionName, []);
          els.push(el);
        }
      }
    }, this);
    this._enableBlurEntireSVG(focusSelf, viewBuildCtx);
  };
  MapDraw2.prototype._enableBlurEntireSVG = function(focusSelf, viewBuildCtx) {
    if (focusSelf && viewBuildCtx.isGeo) {
      var blurStyle = viewBuildCtx.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle();
      var opacity_1 = blurStyle.opacity;
      this._svgGraphicRecord.root.traverse(function(el) {
        if (!el.isGroup) {
          setDefaultStateProxy(el);
          var style = el.ensureState("blur").style || {};
          if (style.opacity == null && opacity_1 != null) {
            style.opacity = opacity_1;
          }
          el.ensureState("emphasis");
        }
      });
    }
  };
  MapDraw2.prototype.remove = function() {
    this._regionsGroup.removeAll();
    this._regionsGroupByName = null;
    this._svgGroup.removeAll();
    this._freeSVG();
    this._controller.dispose();
    this._controllerHost = null;
  };
  MapDraw2.prototype.findHighDownDispatchers = function(name, geoModel) {
    if (name == null) {
      return [];
    }
    var geo = geoModel.coordinateSystem;
    if (geo.resourceType === "geoJSON") {
      var regionsGroupByName = this._regionsGroupByName;
      if (regionsGroupByName) {
        var regionGroup = regionsGroupByName.get(name);
        return regionGroup ? [regionGroup] : [];
      }
    } else if (geo.resourceType === "geoSVG") {
      return this._svgDispatcherMap && this._svgDispatcherMap.get(name) || [];
    }
  };
  MapDraw2.prototype._svgResourceChanged = function(mapName) {
    return this._svgMapName !== mapName;
  };
  MapDraw2.prototype._useSVG = function(mapName) {
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      var svgGraphic = resource.useGraphic(this.uid);
      this._svgGroup.add(svgGraphic.root);
      this._svgGraphicRecord = svgGraphic;
      this._svgMapName = mapName;
    }
  };
  MapDraw2.prototype._freeSVG = function() {
    var mapName = this._svgMapName;
    if (mapName == null) {
      return;
    }
    var resource = geoSourceManager.getGeoResource(mapName);
    if (resource && resource.type === "geoSVG") {
      resource.freeGraphic(this.uid);
    }
    this._svgGraphicRecord = null;
    this._svgDispatcherMap = null;
    this._svgGroup.removeAll();
    this._svgMapName = null;
  };
  MapDraw2.prototype._updateController = function(mapOrGeoModel, ecModel, api) {
    var geo = mapOrGeoModel.coordinateSystem;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    controllerHost.zoomLimit = mapOrGeoModel.get("scaleLimit");
    controllerHost.zoom = geo.getZoom();
    controller.enable(mapOrGeoModel.get("roam") || false);
    var mainType = mapOrGeoModel.mainType;
    function makeActionBase() {
      var action = {
        type: "geoRoam",
        componentType: mainType
      };
      action[mainType + "Id"] = mapOrGeoModel.id;
      return action;
    }
    controller.off("pan").on("pan", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction(extend(makeActionBase(), {
        dx: e2.dx,
        dy: e2.dy,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.off("zoom").on("zoom", function(e2) {
      this._mouseDownFlag = false;
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction(extend(makeActionBase(), {
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY,
        animation: {
          duration: 0
        }
      }));
    }, this);
    controller.setPointerChecker(function(e2, x2, y2) {
      return geo.containPoint([x2, y2]) && !onIrrelevantElement(e2, api, mapOrGeoModel);
    });
  };
  MapDraw2.prototype.resetForLabelLayout = function() {
    this.group.traverse(function(el) {
      var label = el.getTextContent();
      if (label) {
        label.ignore = mapLabelRaw(label).ignore;
      }
    });
  };
  MapDraw2.prototype._updateMapSelectHandler = function(mapOrGeoModel, regionsGroup, api, fromView) {
    var mapDraw = this;
    regionsGroup.off("mousedown");
    regionsGroup.off("click");
    if (mapOrGeoModel.get("selectedMode")) {
      regionsGroup.on("mousedown", function() {
        mapDraw._mouseDownFlag = true;
      });
      regionsGroup.on("click", function(e2) {
        if (!mapDraw._mouseDownFlag) {
          return;
        }
        mapDraw._mouseDownFlag = false;
      });
    }
  };
  return MapDraw2;
}();
function applyOptionStyleForRegion(viewBuildCtx, el, dataIndex, regionModel) {
  var normalStyleModel = regionModel.getModel("itemStyle");
  var emphasisStyleModel = regionModel.getModel(["emphasis", "itemStyle"]);
  var blurStyleModel = regionModel.getModel(["blur", "itemStyle"]);
  var selectStyleModel = regionModel.getModel(["select", "itemStyle"]);
  var normalStyle = getFixedItemStyle(normalStyleModel);
  var emphasisStyle = getFixedItemStyle(emphasisStyleModel);
  var selectStyle = getFixedItemStyle(selectStyleModel);
  var blurStyle = getFixedItemStyle(blurStyleModel);
  var data = viewBuildCtx.data;
  if (data) {
    var style = data.getItemVisual(dataIndex, "style");
    var decal = data.getItemVisual(dataIndex, "decal");
    if (viewBuildCtx.isVisualEncodedByVisualMap && style.fill) {
      normalStyle.fill = style.fill;
    }
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, viewBuildCtx.api);
    }
  }
  el.setStyle(normalStyle);
  el.style.strokeNoScale = true;
  el.ensureState("emphasis").style = emphasisStyle;
  el.ensureState("select").style = selectStyle;
  el.ensureState("blur").style = blurStyle;
  setDefaultStateProxy(el);
}
function resetLabelForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel, dataIdx, labelXY) {
  var data = viewBuildCtx.data;
  var isGeo = viewBuildCtx.isGeo;
  var isDataNaN = data && isNaN(data.get(data.mapDimension("value"), dataIdx));
  var itemLayout = data && data.getItemLayout(dataIdx);
  if (isGeo || isDataNaN || itemLayout && itemLayout.showLabel) {
    var query = !isGeo ? dataIdx : regionName;
    var labelFetcher = void 0;
    if (!data || dataIdx >= 0) {
      labelFetcher = mapOrGeoModel;
    }
    var specifiedTextOpt = labelXY ? {
      normal: {
        align: "center",
        verticalAlign: "middle"
      }
    } : null;
    setLabelStyle(el, getLabelStatesModels(regionModel), {
      labelFetcher,
      labelDataIndex: query,
      defaultText: regionName
    }, specifiedTextOpt);
    var textEl = el.getTextContent();
    if (textEl) {
      mapLabelRaw(textEl).ignore = textEl.ignore;
      if (el.textConfig && labelXY) {
        var rect = el.getBoundingRect().clone();
        el.textConfig.layoutRect = rect;
        el.textConfig.position = [(labelXY[0] - rect.x) / rect.width * 100 + "%", (labelXY[1] - rect.y) / rect.height * 100 + "%"];
      }
    }
    el.disableLabelAnimation = true;
  } else {
    el.removeTextContent();
    el.removeTextConfig();
    el.disableLabelAnimation = null;
  }
}
function resetEventTriggerForRegion(viewBuildCtx, eventTrigger, regionName, regionModel, mapOrGeoModel, dataIdx) {
  if (viewBuildCtx.data) {
    viewBuildCtx.data.setItemGraphicEl(dataIdx, eventTrigger);
  } else {
    getECData(eventTrigger).eventData = {
      componentType: "geo",
      componentIndex: mapOrGeoModel.componentIndex,
      geoIndex: mapOrGeoModel.componentIndex,
      name: regionName,
      region: regionModel && regionModel.option || {}
    };
  }
}
function resetTooltipForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  if (!viewBuildCtx.data) {
    setTooltipConfig({
      el,
      componentModel: mapOrGeoModel,
      itemName: regionName,
      itemTooltipOption: regionModel.get("tooltip")
    });
  }
}
function resetStateTriggerForRegion(viewBuildCtx, el, regionName, regionModel, mapOrGeoModel) {
  el.highDownSilentOnTouch = !!mapOrGeoModel.get("selectedMode");
  var emphasisModel = regionModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  toggleHoverEmphasis(el, focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  if (viewBuildCtx.isGeo) {
    enableComponentHighDownFeatures(el, mapOrGeoModel, regionName);
  }
  return focus;
}
function projectPolys(rings, createStream, isLine) {
  var polygons = [];
  var curPoly;
  function startPolygon() {
    curPoly = [];
  }
  function endPolygon() {
    if (curPoly.length) {
      polygons.push(curPoly);
      curPoly = [];
    }
  }
  var stream = createStream({
    polygonStart: startPolygon,
    polygonEnd: endPolygon,
    lineStart: startPolygon,
    lineEnd: endPolygon,
    point: function(x2, y2) {
      if (isFinite(x2) && isFinite(y2)) {
        curPoly.push([x2, y2]);
      }
    },
    sphere: function() {
    }
  });
  !isLine && stream.polygonStart();
  each$f(rings, function(ring) {
    stream.lineStart();
    for (var i = 0; i < ring.length; i++) {
      stream.point(ring[i][0], ring[i][1]);
    }
    stream.lineEnd();
  });
  !isLine && stream.polygonEnd();
  return polygons;
}
var MapDraw$1 = MapDraw;
var MapView = function(_super) {
  __extends(MapView2, _super);
  function MapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapView2.type;
    return _this;
  }
  MapView2.prototype.render = function(mapModel, ecModel, api, payload) {
    if (payload && payload.type === "mapToggleSelect" && payload.from === this.uid) {
      return;
    }
    var group = this.group;
    group.removeAll();
    if (mapModel.getHostGeoModel()) {
      return;
    }
    if (this._mapDraw && payload && payload.type === "geoRoam") {
      this._mapDraw.resetForLabelLayout();
    }
    if (!(payload && payload.type === "geoRoam" && payload.componentType === "series" && payload.seriesId === mapModel.id)) {
      if (mapModel.needsDrawMap) {
        var mapDraw = this._mapDraw || new MapDraw$1(api);
        group.add(mapDraw.group);
        mapDraw.draw(mapModel, ecModel, api, this, payload);
        this._mapDraw = mapDraw;
      } else {
        this._mapDraw && this._mapDraw.remove();
        this._mapDraw = null;
      }
    } else {
      var mapDraw = this._mapDraw;
      mapDraw && group.add(mapDraw.group);
    }
    mapModel.get("showLegendSymbol") && ecModel.getComponent("legend") && this._renderSymbols(mapModel, ecModel, api);
  };
  MapView2.prototype.remove = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
    this.group.removeAll();
  };
  MapView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
    this._mapDraw = null;
  };
  MapView2.prototype._renderSymbols = function(mapModel, ecModel, api) {
    var originalData = mapModel.originalData;
    var group = this.group;
    originalData.each(originalData.mapDimension("value"), function(value, originalDataIndex) {
      if (isNaN(value)) {
        return;
      }
      var layout2 = originalData.getItemLayout(originalDataIndex);
      if (!layout2 || !layout2.point) {
        return;
      }
      var point = layout2.point;
      var offset = layout2.offset;
      var circle = new Circle$1({
        style: {
          fill: mapModel.getData().getVisual("style").fill
        },
        shape: {
          cx: point[0] + offset * 9,
          cy: point[1],
          r: 3
        },
        silent: true,
        z2: 8 + (!offset ? Z2_EMPHASIS_LIFT + 1 : 0)
      });
      if (!offset) {
        var fullData = mapModel.mainSeries.getData();
        var name_1 = originalData.getName(originalDataIndex);
        var fullIndex_1 = fullData.indexOfName(name_1);
        var itemModel = originalData.getItemModel(originalDataIndex);
        var labelModel = itemModel.getModel("label");
        var regionGroup = fullData.getItemGraphicEl(fullIndex_1);
        setLabelStyle(circle, getLabelStatesModels(itemModel), {
          labelFetcher: {
            getFormattedLabel: function(idx, state) {
              return mapModel.getFormattedLabel(fullIndex_1, state);
            }
          },
          defaultText: name_1
        });
        circle.disableLabelAnimation = true;
        if (!labelModel.get("position")) {
          circle.setTextConfig({
            position: "bottom"
          });
        }
        regionGroup.onHoverStateChange = function(toState) {
          setStatesFlag(circle, toState);
        };
      }
      group.add(circle);
    });
  };
  MapView2.type = "map";
  return MapView2;
}(ChartView$1);
var MapView$1 = MapView;
var MapSeries = function(_super) {
  __extends(MapSeries2, _super);
  function MapSeries2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MapSeries2.type;
    _this.needsDrawMap = false;
    _this.seriesGroup = [];
    _this.getTooltipPosition = function(dataIndex) {
      if (dataIndex != null) {
        var name_1 = this.getData().getName(dataIndex);
        var geo = this.coordinateSystem;
        var region = geo.getRegion(name_1);
        return region && geo.dataToPoint(region.getCenter());
      }
    };
    return _this;
  }
  MapSeries2.prototype.getInitialData = function(option) {
    var data = createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
    var dataNameMap = createHashMap();
    var toAppendNames = [];
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      var name_2 = data.getName(i);
      dataNameMap.set(name_2, true);
    }
    var geoSource = geoSourceManager.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
    each$f(geoSource.regions, function(region) {
      var name = region.name;
      if (!dataNameMap.get(name)) {
        toAppendNames.push(name);
      }
    });
    data.appendValues([], toAppendNames);
    return data;
  };
  MapSeries2.prototype.getHostGeoModel = function() {
    var geoIndex = this.option.geoIndex;
    return geoIndex != null ? this.ecModel.getComponent("geo", geoIndex) : null;
  };
  MapSeries2.prototype.getMapType = function() {
    return (this.getHostGeoModel() || this).option.map;
  };
  MapSeries2.prototype.getRawValue = function(dataIndex) {
    var data = this.getData();
    return data.get(data.mapDimension("value"), dataIndex);
  };
  MapSeries2.prototype.getRegionModel = function(regionName) {
    var data = this.getData();
    return data.getItemModel(data.indexOfName(regionName));
  };
  MapSeries2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    var seriesGroup = this.seriesGroup;
    var seriesNames = [];
    for (var i = 0; i < seriesGroup.length; i++) {
      var otherIndex = seriesGroup[i].originalData.indexOfName(name);
      var valueDim = data.mapDimension("value");
      if (!isNaN(seriesGroup[i].originalData.get(valueDim, otherIndex))) {
        seriesNames.push(seriesGroup[i].name);
      }
    }
    return createTooltipMarkup("section", {
      header: seriesNames.join(", "),
      noHeader: !seriesNames.length,
      blocks: [createTooltipMarkup("nameValue", {
        name,
        value
      })]
    });
  };
  MapSeries2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  MapSeries2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  MapSeries2.prototype.getLegendIcon = function(opt) {
    var iconType = opt.icon || "roundRect";
    var icon = createSymbol$1(iconType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill);
    icon.setStyle(opt.itemStyle);
    icon.style.stroke = "none";
    if (iconType.indexOf("empty") > -1) {
      icon.style.stroke = icon.style.fill;
      icon.style.fill = "#fff";
      icon.style.lineWidth = 2;
    }
    return icon;
  };
  MapSeries2.type = "series.map";
  MapSeries2.dependencies = ["geo"];
  MapSeries2.layoutMode = "box";
  MapSeries2.defaultOption = {
    z: 2,
    coordinateSystem: "geo",
    map: "",
    left: "center",
    top: "center",
    aspectScale: null,
    showLegendSymbol: true,
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    selectedMode: true,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444",
      areaColor: "#eee"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        areaColor: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    nameProperty: "name"
  };
  return MapSeries2;
}(SeriesModel$1);
var MapSeries$1 = MapSeries;
function dataStatistics(datas, statisticType) {
  var dataNameMap = {};
  each$f(datas, function(data) {
    data.each(data.mapDimension("value"), function(value, idx) {
      var mapKey = "ec-" + data.getName(idx);
      dataNameMap[mapKey] = dataNameMap[mapKey] || [];
      if (!isNaN(value)) {
        dataNameMap[mapKey].push(value);
      }
    });
  });
  return datas[0].map(datas[0].mapDimension("value"), function(value, idx) {
    var mapKey = "ec-" + datas[0].getName(idx);
    var sum2 = 0;
    var min3 = Infinity;
    var max3 = -Infinity;
    var len2 = dataNameMap[mapKey].length;
    for (var i = 0; i < len2; i++) {
      min3 = Math.min(min3, dataNameMap[mapKey][i]);
      max3 = Math.max(max3, dataNameMap[mapKey][i]);
      sum2 += dataNameMap[mapKey][i];
    }
    var result;
    if (statisticType === "min") {
      result = min3;
    } else if (statisticType === "max") {
      result = max3;
    } else if (statisticType === "average") {
      result = sum2 / len2;
    } else {
      result = sum2;
    }
    return len2 === 0 ? NaN : result;
  });
}
function mapDataStatistic(ecModel) {
  var seriesGroups = {};
  ecModel.eachSeriesByType("map", function(seriesModel) {
    var hostGeoModel = seriesModel.getHostGeoModel();
    var key = hostGeoModel ? "o" + hostGeoModel.id : "i" + seriesModel.getMapType();
    (seriesGroups[key] = seriesGroups[key] || []).push(seriesModel);
  });
  each$f(seriesGroups, function(seriesList, key) {
    var data = dataStatistics(map$1(seriesList, function(seriesModel) {
      return seriesModel.getData();
    }), seriesList[0].get("mapValueCalculation"));
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].originalData = seriesList[i].getData();
    }
    for (var i = 0; i < seriesList.length; i++) {
      seriesList[i].seriesGroup = seriesList;
      seriesList[i].needsDrawMap = i === 0 && !seriesList[i].getHostGeoModel();
      seriesList[i].setData(data.cloneShallow());
      seriesList[i].mainSeries = seriesList[0];
    }
  });
}
function mapSymbolLayout(ecModel) {
  var processedMapType = {};
  ecModel.eachSeriesByType("map", function(mapSeries) {
    var mapType = mapSeries.getMapType();
    if (mapSeries.getHostGeoModel() || processedMapType[mapType]) {
      return;
    }
    var mapSymbolOffsets = {};
    each$f(mapSeries.seriesGroup, function(subMapSeries) {
      var geo = subMapSeries.coordinateSystem;
      var data2 = subMapSeries.originalData;
      if (subMapSeries.get("showLegendSymbol") && ecModel.getComponent("legend")) {
        data2.each(data2.mapDimension("value"), function(value, idx) {
          var name = data2.getName(idx);
          var region = geo.getRegion(name);
          if (!region || isNaN(value)) {
            return;
          }
          var offset = mapSymbolOffsets[name] || 0;
          var point = geo.dataToPoint(region.getCenter());
          mapSymbolOffsets[name] = offset + 1;
          data2.setItemLayout(idx, {
            point,
            offset
          });
        });
      }
    });
    var data = mapSeries.getData();
    data.each(function(idx) {
      var name = data.getName(idx);
      var layout2 = data.getItemLayout(idx) || {};
      layout2.showLabel = !mapSymbolOffsets[name];
      data.setItemLayout(idx, layout2);
    });
    processedMapType[mapType] = true;
  });
}
var v2ApplyTransform = applyTransform$1;
var View = function(_super) {
  __extends(View2, _super);
  function View2(name) {
    var _this = _super.call(this) || this;
    _this.type = "view";
    _this.dimensions = ["x", "y"];
    _this._roamTransformable = new Transformable$1();
    _this._rawTransformable = new Transformable$1();
    _this.name = name;
    return _this;
  }
  View2.prototype.setBoundingRect = function(x2, y2, width, height) {
    this._rect = new BoundingRect$1(x2, y2, width, height);
    return this._rect;
  };
  View2.prototype.getBoundingRect = function() {
    return this._rect;
  };
  View2.prototype.setViewRect = function(x2, y2, width, height) {
    this._transformTo(x2, y2, width, height);
    this._viewRect = new BoundingRect$1(x2, y2, width, height);
  };
  View2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var rawTransform = this._rawTransformable;
    rawTransform.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransform.parent;
    rawTransform.parent = null;
    rawTransform.decomposeTransform();
    rawTransform.parent = rawParent;
    this._updateTransform();
  };
  View2.prototype.setCenter = function(centerCoord) {
    if (!centerCoord) {
      return;
    }
    this._center = centerCoord;
    this._updateCenterAndZoom();
  };
  View2.prototype.setZoom = function(zoom) {
    zoom = zoom || 1;
    var zoomLimit = this.zoomLimit;
    if (zoomLimit) {
      if (zoomLimit.max != null) {
        zoom = Math.min(zoomLimit.max, zoom);
      }
      if (zoomLimit.min != null) {
        zoom = Math.max(zoomLimit.min, zoom);
      }
    }
    this._zoom = zoom;
    this._updateCenterAndZoom();
  };
  View2.prototype.getDefaultCenter = function() {
    var rawRect = this.getBoundingRect();
    var cx = rawRect.x + rawRect.width / 2;
    var cy = rawRect.y + rawRect.height / 2;
    return [cx, cy];
  };
  View2.prototype.getCenter = function() {
    return this._center || this.getDefaultCenter();
  };
  View2.prototype.getZoom = function() {
    return this._zoom || 1;
  };
  View2.prototype.getRoamTransform = function() {
    return this._roamTransformable.getLocalTransform();
  };
  View2.prototype._updateCenterAndZoom = function() {
    var rawTransformMatrix = this._rawTransformable.getLocalTransform();
    var roamTransform = this._roamTransformable;
    var defaultCenter = this.getDefaultCenter();
    var center2 = this.getCenter();
    var zoom = this.getZoom();
    center2 = applyTransform$1([], center2, rawTransformMatrix);
    defaultCenter = applyTransform$1([], defaultCenter, rawTransformMatrix);
    roamTransform.originX = center2[0];
    roamTransform.originY = center2[1];
    roamTransform.x = defaultCenter[0] - center2[0];
    roamTransform.y = defaultCenter[1] - center2[1];
    roamTransform.scaleX = roamTransform.scaleY = zoom;
    this._updateTransform();
  };
  View2.prototype._updateTransform = function() {
    var roamTransformable = this._roamTransformable;
    var rawTransformable = this._rawTransformable;
    rawTransformable.parent = roamTransformable;
    roamTransformable.updateTransform();
    rawTransformable.updateTransform();
    copy(this.transform || (this.transform = []), rawTransformable.transform || create$1());
    this._rawTransform = rawTransformable.getLocalTransform();
    this.invTransform = this.invTransform || [];
    invert(this.invTransform, this.transform);
    this.decomposeTransform();
  };
  View2.prototype.getTransformInfo = function() {
    var rawTransformable = this._rawTransformable;
    var roamTransformable = this._roamTransformable;
    var dummyTransformable2 = new Transformable$1();
    dummyTransformable2.transform = roamTransformable.transform;
    dummyTransformable2.decomposeTransform();
    return {
      roam: {
        x: dummyTransformable2.x,
        y: dummyTransformable2.y,
        scaleX: dummyTransformable2.scaleX,
        scaleY: dummyTransformable2.scaleY
      },
      raw: {
        x: rawTransformable.x,
        y: rawTransformable.y,
        scaleX: rawTransformable.scaleX,
        scaleY: rawTransformable.scaleY
      }
    };
  };
  View2.prototype.getViewRect = function() {
    return this._viewRect;
  };
  View2.prototype.getViewRectAfterRoam = function() {
    var rect = this.getBoundingRect().clone();
    rect.applyTransform(this.transform);
    return rect;
  };
  View2.prototype.dataToPoint = function(data, noRoam, out2) {
    var transform2 = noRoam ? this._rawTransform : this.transform;
    out2 = out2 || [];
    return transform2 ? v2ApplyTransform(out2, data, transform2) : copy$1(out2, data);
  };
  View2.prototype.pointToData = function(point) {
    var invTransform = this.invTransform;
    return invTransform ? v2ApplyTransform([], point, invTransform) : [point[0], point[1]];
  };
  View2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  View2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$4(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  View2.prototype.containPoint = function(point) {
    return this.getViewRectAfterRoam().contain(point[0], point[1]);
  };
  View2.dimensions = ["x", "y"];
  return View2;
}(Transformable$1);
function getCoordSys$4(finder) {
  var seriesModel = finder.seriesModel;
  return seriesModel ? seriesModel.coordinateSystem : null;
}
var View$1 = View;
var GEO_DEFAULT_PARAMS = {
  "geoJSON": {
    aspectScale: 0.75,
    invertLongitute: true
  },
  "geoSVG": {
    aspectScale: 1,
    invertLongitute: false
  }
};
var geo2DDimensions = ["lng", "lat"];
var Geo = function(_super) {
  __extends(Geo2, _super);
  function Geo2(name, map2, opt) {
    var _this = _super.call(this, name) || this;
    _this.dimensions = geo2DDimensions;
    _this.type = "geo";
    _this._nameCoordMap = createHashMap();
    _this.map = map2;
    var projection = opt.projection;
    var source = geoSourceManager.load(map2, opt.nameMap, opt.nameProperty);
    var resource = geoSourceManager.getGeoResource(map2);
    _this.resourceType = resource ? resource.type : null;
    var regions = _this.regions = source.regions;
    var defaultParams = GEO_DEFAULT_PARAMS[resource.type];
    _this._regionsMap = source.regionsMap;
    _this.regions = source.regions;
    _this.projection = projection;
    var boundingRect;
    if (projection) {
      for (var i = 0; i < regions.length; i++) {
        var regionRect = regions[i].getBoundingRect(projection);
        boundingRect = boundingRect || regionRect.clone();
        boundingRect.union(regionRect);
      }
    } else {
      boundingRect = source.boundingRect;
    }
    _this.setBoundingRect(boundingRect.x, boundingRect.y, boundingRect.width, boundingRect.height);
    _this.aspectScale = projection ? 1 : retrieve2(opt.aspectScale, defaultParams.aspectScale);
    _this._invertLongitute = projection ? false : defaultParams.invertLongitute;
    return _this;
  }
  Geo2.prototype._transformTo = function(x2, y2, width, height) {
    var rect = this.getBoundingRect();
    var invertLongitute = this._invertLongitute;
    rect = rect.clone();
    if (invertLongitute) {
      rect.y = -rect.y - rect.height;
    }
    var rawTransformable = this._rawTransformable;
    rawTransformable.transform = rect.calculateTransform(new BoundingRect$1(x2, y2, width, height));
    var rawParent = rawTransformable.parent;
    rawTransformable.parent = null;
    rawTransformable.decomposeTransform();
    rawTransformable.parent = rawParent;
    if (invertLongitute) {
      rawTransformable.scaleY = -rawTransformable.scaleY;
    }
    this._updateTransform();
  };
  Geo2.prototype.getRegion = function(name) {
    return this._regionsMap.get(name);
  };
  Geo2.prototype.getRegionByCoord = function(coord) {
    var regions = this.regions;
    for (var i = 0; i < regions.length; i++) {
      var region = regions[i];
      if (region.type === "geoJSON" && region.contain(coord)) {
        return regions[i];
      }
    }
  };
  Geo2.prototype.addGeoCoord = function(name, geoCoord2) {
    this._nameCoordMap.set(name, geoCoord2);
  };
  Geo2.prototype.getGeoCoord = function(name) {
    var region = this._regionsMap.get(name);
    return this._nameCoordMap.get(name) || region && region.getCenter();
  };
  Geo2.prototype.dataToPoint = function(data, noRoam, out2) {
    if (isString(data)) {
      data = this.getGeoCoord(data);
    }
    if (data) {
      var projection = this.projection;
      if (projection) {
        data = projection.project(data);
      }
      return data && this.projectedToPoint(data);
    }
  };
  Geo2.prototype.pointToData = function(point) {
    var projection = this.projection;
    if (projection) {
      point = projection.unproject(point);
    }
    return point && this.pointToProjected(point);
  };
  Geo2.prototype.pointToProjected = function(point) {
    return _super.prototype.pointToData.call(this, point);
  };
  Geo2.prototype.projectedToPoint = function(projected, noRoam, out2) {
    return _super.prototype.dataToPoint.call(this, projected, noRoam, out2);
  };
  Geo2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Geo2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$3(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  return Geo2;
}(View$1);
mixin(Geo, View$1);
function getCoordSys$3(finder) {
  var geoModel = finder.geoModel;
  var seriesModel = finder.seriesModel;
  return geoModel ? geoModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem || (seriesModel.getReferringComponents("geo", SINGLE_REFERRING).models[0] || {}).coordinateSystem : null;
}
var Geo$1 = Geo;
function resizeGeo(geoModel, api) {
  var boundingCoords = geoModel.get("boundingCoords");
  if (boundingCoords != null) {
    var leftTop_1 = boundingCoords[0];
    var rightBottom_1 = boundingCoords[1];
    if (!(isFinite(leftTop_1[0]) && isFinite(leftTop_1[1]) && isFinite(rightBottom_1[0]) && isFinite(rightBottom_1[1])))
      ;
    else {
      var projection_1 = this.projection;
      if (projection_1) {
        var xMin = leftTop_1[0];
        var yMin = leftTop_1[1];
        var xMax = rightBottom_1[0];
        var yMax = rightBottom_1[1];
        leftTop_1 = [Infinity, Infinity];
        rightBottom_1 = [-Infinity, -Infinity];
        var sampleLine = function(x0, y0, x1, y1) {
          var dx = x1 - x0;
          var dy = y1 - y0;
          for (var i = 0; i <= 100; i++) {
            var p2 = i / 100;
            var pt = projection_1.project([x0 + dx * p2, y0 + dy * p2]);
            min$1(leftTop_1, leftTop_1, pt);
            max$1(rightBottom_1, rightBottom_1, pt);
          }
        };
        sampleLine(xMin, yMin, xMax, yMin);
        sampleLine(xMax, yMin, xMax, yMax);
        sampleLine(xMax, yMax, xMin, yMax);
        sampleLine(xMin, yMax, xMax, yMin);
      }
      this.setBoundingRect(leftTop_1[0], leftTop_1[1], rightBottom_1[0] - leftTop_1[0], rightBottom_1[1] - leftTop_1[1]);
    }
  }
  var rect = this.getBoundingRect();
  var centerOption = geoModel.get("layoutCenter");
  var sizeOption = geoModel.get("layoutSize");
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  var aspect = rect.width / rect.height * this.aspectScale;
  var useCenterAndSize = false;
  var center2;
  var size;
  if (centerOption && sizeOption) {
    center2 = [parsePercent(centerOption[0], viewWidth), parsePercent(centerOption[1], viewHeight)];
    size = parsePercent(sizeOption, Math.min(viewWidth, viewHeight));
    if (!isNaN(center2[0]) && !isNaN(center2[1]) && !isNaN(size)) {
      useCenterAndSize = true;
    }
  }
  var viewRect2;
  if (useCenterAndSize) {
    viewRect2 = {};
    if (aspect > 1) {
      viewRect2.width = size;
      viewRect2.height = size / aspect;
    } else {
      viewRect2.height = size;
      viewRect2.width = size * aspect;
    }
    viewRect2.y = center2[1] - viewRect2.height / 2;
    viewRect2.x = center2[0] - viewRect2.width / 2;
  } else {
    var boxLayoutOption = geoModel.getBoxLayoutParams();
    boxLayoutOption.aspect = aspect;
    viewRect2 = getLayoutRect(boxLayoutOption, {
      width: viewWidth,
      height: viewHeight
    });
  }
  this.setViewRect(viewRect2.x, viewRect2.y, viewRect2.width, viewRect2.height);
  this.setCenter(geoModel.get("center"));
  this.setZoom(geoModel.get("zoom"));
}
function setGeoCoords(geo, model) {
  each$f(model.get("geoCoord"), function(geoCoord2, name) {
    geo.addGeoCoord(name, geoCoord2);
  });
}
var GeoCreator = function() {
  function GeoCreator2() {
    this.dimensions = geo2DDimensions;
  }
  GeoCreator2.prototype.create = function(ecModel, api) {
    var geoList = [];
    function getCommonGeoProperties(model) {
      return {
        nameProperty: model.get("nameProperty"),
        aspectScale: model.get("aspectScale"),
        projection: model.get("projection")
      };
    }
    ecModel.eachComponent("geo", function(geoModel, idx) {
      var mapName = geoModel.get("map");
      var geo = new Geo$1(mapName + idx, mapName, extend({
        nameMap: geoModel.get("nameMap")
      }, getCommonGeoProperties(geoModel)));
      geo.zoomLimit = geoModel.get("scaleLimit");
      geoList.push(geo);
      geoModel.coordinateSystem = geo;
      geo.model = geoModel;
      geo.resize = resizeGeo;
      geo.resize(geoModel, api);
    });
    ecModel.eachSeries(function(seriesModel) {
      var coordSys = seriesModel.get("coordinateSystem");
      if (coordSys === "geo") {
        var geoIndex = seriesModel.get("geoIndex") || 0;
        seriesModel.coordinateSystem = geoList[geoIndex];
      }
    });
    var mapModelGroupBySeries = {};
    ecModel.eachSeriesByType("map", function(seriesModel) {
      if (!seriesModel.getHostGeoModel()) {
        var mapType = seriesModel.getMapType();
        mapModelGroupBySeries[mapType] = mapModelGroupBySeries[mapType] || [];
        mapModelGroupBySeries[mapType].push(seriesModel);
      }
    });
    each$f(mapModelGroupBySeries, function(mapSeries, mapType) {
      var nameMapList = map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("nameMap");
      });
      var geo = new Geo$1(mapType, mapType, extend({
        nameMap: mergeAll(nameMapList)
      }, getCommonGeoProperties(mapSeries[0])));
      geo.zoomLimit = retrieve.apply(null, map$1(mapSeries, function(singleMapSeries) {
        return singleMapSeries.get("scaleLimit");
      }));
      geoList.push(geo);
      geo.resize = resizeGeo;
      geo.resize(mapSeries[0], api);
      each$f(mapSeries, function(singleMapSeries) {
        singleMapSeries.coordinateSystem = geo;
        setGeoCoords(geo, singleMapSeries);
      });
    });
    return geoList;
  };
  GeoCreator2.prototype.getFilledRegions = function(originRegionArr, mapName, nameMap, nameProperty) {
    var regionsArr = (originRegionArr || []).slice();
    var dataNameMap = createHashMap();
    for (var i = 0; i < regionsArr.length; i++) {
      dataNameMap.set(regionsArr[i].name, regionsArr[i]);
    }
    var source = geoSourceManager.load(mapName, nameMap, nameProperty);
    each$f(source.regions, function(region) {
      var name = region.name;
      !dataNameMap.get(name) && regionsArr.push({
        name
      });
    });
    return regionsArr;
  };
  return GeoCreator2;
}();
var geoCreator = new GeoCreator();
var geoCreator$1 = geoCreator;
var GeoModel = function(_super) {
  __extends(GeoModel2, _super);
  function GeoModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoModel2.type;
    return _this;
  }
  GeoModel2.prototype.init = function(option, parentModel, ecModel) {
    var source = geoSourceManager.getGeoResource(option.map);
    if (source && source.type === "geoJSON") {
      var itemStyle = option.itemStyle = option.itemStyle || {};
      if (!("color" in itemStyle)) {
        itemStyle.color = "#eee";
      }
    }
    this.mergeDefaultAndTheme(option, ecModel);
    defaultEmphasis(option, "label", ["show"]);
  };
  GeoModel2.prototype.optionUpdated = function() {
    var _this = this;
    var option = this.option;
    option.regions = geoCreator$1.getFilledRegions(option.regions, option.map, option.nameMap, option.nameProperty);
    var selectedMap = {};
    this._optionModelMap = reduce(option.regions || [], function(optionModelMap, regionOpt) {
      var regionName = regionOpt.name;
      if (regionName) {
        optionModelMap.set(regionName, new Model$1(regionOpt, _this, _this.ecModel));
        if (regionOpt.selected) {
          selectedMap[regionName] = true;
        }
      }
      return optionModelMap;
    }, createHashMap());
    if (!option.selectedMap) {
      option.selectedMap = selectedMap;
    }
  };
  GeoModel2.prototype.getRegionModel = function(name) {
    return this._optionModelMap.get(name) || new Model$1(null, this, this.ecModel);
  };
  GeoModel2.prototype.getFormattedLabel = function(name, status) {
    var regionModel = this.getRegionModel(name);
    var formatter = status === "normal" ? regionModel.get(["label", "formatter"]) : regionModel.get(["emphasis", "label", "formatter"]);
    var params = {
      name
    };
    if (isFunction(formatter)) {
      params.status = status;
      return formatter(params);
    } else if (isString(formatter)) {
      return formatter.replace("{a}", name != null ? name : "");
    }
  };
  GeoModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GeoModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GeoModel2.prototype.select = function(name) {
    var option = this.option;
    var selectedMode = option.selectedMode;
    if (!selectedMode) {
      return;
    }
    if (selectedMode !== "multiple") {
      option.selectedMap = null;
    }
    var selectedMap = option.selectedMap || (option.selectedMap = {});
    selectedMap[name] = true;
  };
  GeoModel2.prototype.unSelect = function(name) {
    var selectedMap = this.option.selectedMap;
    if (selectedMap) {
      selectedMap[name] = false;
    }
  };
  GeoModel2.prototype.toggleSelected = function(name) {
    this[this.isSelected(name) ? "unSelect" : "select"](name);
  };
  GeoModel2.prototype.isSelected = function(name) {
    var selectedMap = this.option.selectedMap;
    return !!(selectedMap && selectedMap[name]);
  };
  GeoModel2.type = "geo";
  GeoModel2.layoutMode = "box";
  GeoModel2.defaultOption = {
    z: 0,
    show: true,
    left: "center",
    top: "center",
    aspectScale: null,
    silent: false,
    map: "",
    boundingCoords: null,
    center: null,
    zoom: 1,
    scaleLimit: null,
    label: {
      show: false,
      color: "#000"
    },
    itemStyle: {
      borderWidth: 0.5,
      borderColor: "#444"
    },
    emphasis: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    select: {
      label: {
        show: true,
        color: "rgb(100,0,0)"
      },
      itemStyle: {
        color: "rgba(255,215,0,0.8)"
      }
    },
    regions: []
  };
  return GeoModel2;
}(ComponentModel$1);
var GeoModel$1 = GeoModel;
function getCenterCoord(view, point) {
  return view.pointToProjected ? view.pointToProjected(point) : view.pointToData(point);
}
function updateCenterAndZoom(view, payload, zoomLimit) {
  var previousZoom = view.getZoom();
  var center2 = view.getCenter();
  var zoom = payload.zoom;
  var point = view.projectedToPoint ? view.projectedToPoint(center2) : view.dataToPoint(center2);
  if (payload.dx != null && payload.dy != null) {
    point[0] -= payload.dx;
    point[1] -= payload.dy;
    view.setCenter(getCenterCoord(view, point));
  }
  if (zoom != null) {
    if (zoomLimit) {
      var zoomMin = zoomLimit.min || 0;
      var zoomMax = zoomLimit.max || Infinity;
      zoom = Math.max(Math.min(previousZoom * zoom, zoomMax), zoomMin) / previousZoom;
    }
    view.scaleX *= zoom;
    view.scaleY *= zoom;
    var fixX = (payload.originX - view.x) * (zoom - 1);
    var fixY = (payload.originY - view.y) * (zoom - 1);
    view.x -= fixX;
    view.y -= fixY;
    view.updateTransform();
    view.setCenter(getCenterCoord(view, point));
    view.setZoom(zoom * previousZoom);
  }
  return {
    center: view.getCenter(),
    zoom: view.getZoom()
  };
}
var GeoView = function(_super) {
  __extends(GeoView2, _super);
  function GeoView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GeoView2.type;
    _this.focusBlurEnabled = true;
    return _this;
  }
  GeoView2.prototype.init = function(ecModel, api) {
    this._api = api;
  };
  GeoView2.prototype.render = function(geoModel, ecModel, api, payload) {
    this._model = geoModel;
    if (!geoModel.get("show")) {
      this._mapDraw && this._mapDraw.remove();
      this._mapDraw = null;
      return;
    }
    if (!this._mapDraw) {
      this._mapDraw = new MapDraw$1(api);
    }
    var mapDraw = this._mapDraw;
    mapDraw.draw(geoModel, ecModel, api, this, payload);
    mapDraw.group.on("click", this._handleRegionClick, this);
    mapDraw.group.silent = geoModel.get("silent");
    this.group.add(mapDraw.group);
    this.updateSelectStatus(geoModel, ecModel, api);
  };
  GeoView2.prototype._handleRegionClick = function(e2) {
    var eventData;
    findEventDispatcher(e2.target, function(current) {
      return (eventData = getECData(current).eventData) != null;
    }, true);
    if (eventData) {
      this._api.dispatchAction({
        type: "geoToggleSelect",
        geoId: this._model.id,
        name: eventData.name
      });
    }
  };
  GeoView2.prototype.updateSelectStatus = function(model, ecModel, api) {
    var _this = this;
    this._mapDraw.group.traverse(function(node) {
      var eventData = getECData(node).eventData;
      if (eventData) {
        _this._model.isSelected(eventData.name) ? api.enterSelect(node) : api.leaveSelect(node);
        return true;
      }
    });
  };
  GeoView2.prototype.findHighDownDispatchers = function(name) {
    return this._mapDraw && this._mapDraw.findHighDownDispatchers(name, this._model);
  };
  GeoView2.prototype.dispose = function() {
    this._mapDraw && this._mapDraw.remove();
  };
  GeoView2.type = "geo";
  return GeoView2;
}(ComponentView$1);
var GeoView$1 = GeoView;
function registerMap(mapName, geoJson, specialAreas) {
  geoSourceManager.registerMap(mapName, geoJson, specialAreas);
}
function install$J(registers) {
  registers.registerCoordinateSystem("geo", geoCreator$1);
  registers.registerComponentModel(GeoModel$1);
  registers.registerComponentView(GeoView$1);
  registers.registerImpl("registerMap", registerMap);
  registers.registerImpl("getMap", function(mapName) {
    return geoSourceManager.getMapForUser(mapName);
  });
  function makeAction(method4, actionInfo2) {
    actionInfo2.update = "geo:updateSelectStatus";
    registers.registerAction(actionInfo2, function(payload, ecModel) {
      var selected = {};
      var allSelected = [];
      ecModel.eachComponent({
        mainType: "geo",
        query: payload
      }, function(geoModel) {
        geoModel[method4](payload.name);
        var geo = geoModel.coordinateSystem;
        each$f(geo.regions, function(region) {
          selected[region.name] = geoModel.isSelected(region.name) || false;
        });
        var names2 = [];
        each$f(selected, function(v4, name) {
          selected[name] && names2.push(name);
        });
        allSelected.push({
          geoIndex: geoModel.componentIndex,
          name: names2
        });
      });
      return {
        selected,
        allSelected,
        name: payload.name
      };
    });
  }
  makeAction("toggleSelected", {
    type: "geoToggleSelect",
    event: "geoselectchanged"
  });
  makeAction("select", {
    type: "geoSelect",
    event: "geoselected"
  });
  makeAction("unSelect", {
    type: "geoUnSelect",
    event: "geounselected"
  });
  registers.registerAction({
    type: "geoRoam",
    event: "geoRoam",
    update: "updateTransform"
  }, function(payload, ecModel) {
    var componentType = payload.componentType || "series";
    ecModel.eachComponent({
      mainType: componentType,
      query: payload
    }, function(componentModel) {
      var geo = componentModel.coordinateSystem;
      if (geo.type !== "geo") {
        return;
      }
      var res = updateCenterAndZoom(geo, payload, componentModel.get("scaleLimit"));
      componentModel.setCenter && componentModel.setCenter(res.center);
      componentModel.setZoom && componentModel.setZoom(res.zoom);
      if (componentType === "series") {
        each$f(componentModel.seriesGroup, function(seriesModel) {
          seriesModel.setCenter(res.center);
          seriesModel.setZoom(res.zoom);
        });
      }
    });
  });
}
function install$I(registers) {
  use(install$J);
  registers.registerChartView(MapView$1);
  registers.registerSeriesModel(MapSeries$1);
  registers.registerLayout(mapSymbolLayout);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, mapDataStatistic);
  createLegacyDataSelectAction("map", registers.registerAction);
}
function init(inRoot) {
  var root2 = inRoot;
  root2.hierNode = {
    defaultAncestor: null,
    ancestor: root2,
    prelim: 0,
    modifier: 0,
    change: 0,
    shift: 0,
    i: 0,
    thread: null
  };
  var nodes = [root2];
  var node;
  var children;
  while (node = nodes.pop()) {
    children = node.children;
    if (node.isExpand && children.length) {
      var n2 = children.length;
      for (var i = n2 - 1; i >= 0; i--) {
        var child = children[i];
        child.hierNode = {
          defaultAncestor: null,
          ancestor: child,
          prelim: 0,
          modifier: 0,
          change: 0,
          shift: 0,
          i,
          thread: null
        };
        nodes.push(child);
      }
    }
  }
}
function firstWalk(node, separation2) {
  var children = node.isExpand ? node.children : [];
  var siblings = node.parentNode.children;
  var subtreeW = node.hierNode.i ? siblings[node.hierNode.i - 1] : null;
  if (children.length) {
    executeShifts(node);
    var midPoint = (children[0].hierNode.prelim + children[children.length - 1].hierNode.prelim) / 2;
    if (subtreeW) {
      node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
      node.hierNode.modifier = node.hierNode.prelim - midPoint;
    } else {
      node.hierNode.prelim = midPoint;
    }
  } else if (subtreeW) {
    node.hierNode.prelim = subtreeW.hierNode.prelim + separation2(node, subtreeW);
  }
  node.parentNode.hierNode.defaultAncestor = apportion(node, subtreeW, node.parentNode.hierNode.defaultAncestor || siblings[0], separation2);
}
function secondWalk(node) {
  var nodeX = node.hierNode.prelim + node.parentNode.hierNode.modifier;
  node.setLayout({
    x: nodeX
  }, true);
  node.hierNode.modifier += node.parentNode.hierNode.modifier;
}
function separation(cb) {
  return arguments.length ? cb : defaultSeparation;
}
function radialCoordinate(rad, r2) {
  rad -= Math.PI / 2;
  return {
    x: r2 * Math.cos(rad),
    y: r2 * Math.sin(rad)
  };
}
function getViewRect$4(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function executeShifts(node) {
  var children = node.children;
  var n2 = children.length;
  var shift = 0;
  var change = 0;
  while (--n2 >= 0) {
    var child = children[n2];
    child.hierNode.prelim += shift;
    child.hierNode.modifier += shift;
    change += child.hierNode.change;
    shift += child.hierNode.shift + change;
  }
}
function apportion(subtreeV, subtreeW, ancestor, separation2) {
  if (subtreeW) {
    var nodeOutRight = subtreeV;
    var nodeInRight = subtreeV;
    var nodeOutLeft = nodeInRight.parentNode.children[0];
    var nodeInLeft = subtreeW;
    var sumOutRight = nodeOutRight.hierNode.modifier;
    var sumInRight = nodeInRight.hierNode.modifier;
    var sumOutLeft = nodeOutLeft.hierNode.modifier;
    var sumInLeft = nodeInLeft.hierNode.modifier;
    while (nodeInLeft = nextRight(nodeInLeft), nodeInRight = nextLeft(nodeInRight), nodeInLeft && nodeInRight) {
      nodeOutRight = nextRight(nodeOutRight);
      nodeOutLeft = nextLeft(nodeOutLeft);
      nodeOutRight.hierNode.ancestor = subtreeV;
      var shift = nodeInLeft.hierNode.prelim + sumInLeft - nodeInRight.hierNode.prelim - sumInRight + separation2(nodeInLeft, nodeInRight);
      if (shift > 0) {
        moveSubtree(nextAncestor(nodeInLeft, subtreeV, ancestor), subtreeV, shift);
        sumInRight += shift;
        sumOutRight += shift;
      }
      sumInLeft += nodeInLeft.hierNode.modifier;
      sumInRight += nodeInRight.hierNode.modifier;
      sumOutRight += nodeOutRight.hierNode.modifier;
      sumOutLeft += nodeOutLeft.hierNode.modifier;
    }
    if (nodeInLeft && !nextRight(nodeOutRight)) {
      nodeOutRight.hierNode.thread = nodeInLeft;
      nodeOutRight.hierNode.modifier += sumInLeft - sumOutRight;
    }
    if (nodeInRight && !nextLeft(nodeOutLeft)) {
      nodeOutLeft.hierNode.thread = nodeInRight;
      nodeOutLeft.hierNode.modifier += sumInRight - sumOutLeft;
      ancestor = subtreeV;
    }
  }
  return ancestor;
}
function nextRight(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[children.length - 1] : node.hierNode.thread;
}
function nextLeft(node) {
  var children = node.children;
  return children.length && node.isExpand ? children[0] : node.hierNode.thread;
}
function nextAncestor(nodeInLeft, node, ancestor) {
  return nodeInLeft.hierNode.ancestor.parentNode === node.parentNode ? nodeInLeft.hierNode.ancestor : ancestor;
}
function moveSubtree(wl, wr, shift) {
  var change = shift / (wr.hierNode.i - wl.hierNode.i);
  wr.hierNode.change -= change;
  wr.hierNode.shift += shift;
  wr.hierNode.modifier += shift;
  wr.hierNode.prelim += shift;
  wl.hierNode.change += change;
}
function defaultSeparation(node1, node2) {
  return node1.parentNode === node2.parentNode ? 1 : 2;
}
var TreeEdgeShape = function() {
  function TreeEdgeShape2() {
    this.parentPoint = [];
    this.childPoints = [];
  }
  return TreeEdgeShape2;
}();
var TreePath = function(_super) {
  __extends(TreePath2, _super);
  function TreePath2(opts) {
    return _super.call(this, opts) || this;
  }
  TreePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  TreePath2.prototype.getDefaultShape = function() {
    return new TreeEdgeShape();
  };
  TreePath2.prototype.buildPath = function(ctx, shape) {
    var childPoints = shape.childPoints;
    var childLen = childPoints.length;
    var parentPoint = shape.parentPoint;
    var firstChildPos = childPoints[0];
    var lastChildPos = childPoints[childLen - 1];
    if (childLen === 1) {
      ctx.moveTo(parentPoint[0], parentPoint[1]);
      ctx.lineTo(firstChildPos[0], firstChildPos[1]);
      return;
    }
    var orient = shape.orient;
    var forkDim = orient === "TB" || orient === "BT" ? 0 : 1;
    var otherDim = 1 - forkDim;
    var forkPosition = parsePercent(shape.forkPosition, 1);
    var tmpPoint = [];
    tmpPoint[forkDim] = parentPoint[forkDim];
    tmpPoint[otherDim] = parentPoint[otherDim] + (lastChildPos[otherDim] - parentPoint[otherDim]) * forkPosition;
    ctx.moveTo(parentPoint[0], parentPoint[1]);
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.moveTo(firstChildPos[0], firstChildPos[1]);
    tmpPoint[forkDim] = firstChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    tmpPoint[forkDim] = lastChildPos[forkDim];
    ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    ctx.lineTo(lastChildPos[0], lastChildPos[1]);
    for (var i = 1; i < childLen - 1; i++) {
      var point = childPoints[i];
      ctx.moveTo(point[0], point[1]);
      tmpPoint[forkDim] = point[forkDim];
      ctx.lineTo(tmpPoint[0], tmpPoint[1]);
    }
  };
  return TreePath2;
}(Path$1);
var TreeView = function(_super) {
  __extends(TreeView2, _super);
  function TreeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreeView2.type;
    _this._mainGroup = new Group$4();
    return _this;
  }
  TreeView2.prototype.init = function(ecModel, api) {
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: this.group
    };
    this.group.add(this._mainGroup);
  };
  TreeView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var layoutInfo = seriesModel.layoutInfo;
    var group = this._mainGroup;
    var layout2 = seriesModel.get("layout");
    if (layout2 === "radial") {
      group.x = layoutInfo.x + layoutInfo.width / 2;
      group.y = layoutInfo.y + layoutInfo.height / 2;
    } else {
      group.x = layoutInfo.x;
      group.y = layoutInfo.y;
    }
    this._updateViewCoordSys(seriesModel);
    this._updateController(seriesModel, ecModel, api);
    var oldData = this._data;
    data.diff(oldData).add(function(newIdx) {
      if (symbolNeedsDraw(data, newIdx)) {
        updateNode(data, newIdx, null, group, seriesModel);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!symbolNeedsDraw(data, newIdx)) {
        symbolEl && removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
        return;
      }
      updateNode(data, newIdx, symbolEl, group, seriesModel);
    }).remove(function(oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (symbolEl) {
        removeNode(oldData, oldIdx, symbolEl, group, seriesModel);
      }
    }).execute();
    this._nodeScaleRatio = seriesModel.get("nodeScaleRatio");
    this._updateNodeAndLinkScale(seriesModel);
    if (seriesModel.get("expandAndCollapse") === true) {
      data.eachItemGraphicEl(function(el, dataIndex) {
        el.off("click").on("click", function() {
          api.dispatchAction({
            type: "treeExpandAndCollapse",
            seriesId: seriesModel.id,
            dataIndex
          });
        });
      });
    }
    this._data = data;
  };
  TreeView2.prototype._updateViewCoordSys = function(seriesModel) {
    var data = seriesModel.getData();
    var points2 = [];
    data.each(function(idx) {
      var layout2 = data.getItemLayout(idx);
      if (layout2 && !isNaN(layout2.x) && !isNaN(layout2.y)) {
        points2.push([+layout2.x, +layout2.y]);
      }
    });
    var min3 = [];
    var max3 = [];
    fromPoints(points2, min3, max3);
    var oldMin = this._min;
    var oldMax = this._max;
    if (max3[0] - min3[0] === 0) {
      min3[0] = oldMin ? oldMin[0] : min3[0] - 1;
      max3[0] = oldMax ? oldMax[0] : max3[0] + 1;
    }
    if (max3[1] - min3[1] === 0) {
      min3[1] = oldMin ? oldMin[1] : min3[1] - 1;
      max3[1] = oldMax ? oldMax[1] : max3[1] + 1;
    }
    var viewCoordSys = seriesModel.coordinateSystem = new View$1();
    viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
    viewCoordSys.setBoundingRect(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
    viewCoordSys.setCenter(seriesModel.get("center"));
    viewCoordSys.setZoom(seriesModel.get("zoom"));
    this.group.attr({
      x: viewCoordSys.x,
      y: viewCoordSys.y,
      scaleX: viewCoordSys.scaleX,
      scaleY: viewCoordSys.scaleY
    });
    this._min = min3;
    this._max = max3;
  };
  TreeView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "treeRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale(seriesModel);
      api.updateLabelLayout();
    });
  };
  TreeView2.prototype._updateNodeAndLinkScale = function(seriesModel) {
    var data = seriesModel.getData();
    var nodeScale = this._getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el.setSymbolScale(nodeScale);
    });
  };
  TreeView2.prototype._getNodeGlobalScale = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type !== "view") {
      return 1;
    }
    var nodeScaleRatio = this._nodeScaleRatio;
    var groupZoom = coordSys.scaleX || 1;
    var roamZoom = coordSys.getZoom();
    var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
    return nodeScale / groupZoom;
  };
  TreeView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  TreeView2.prototype.remove = function() {
    this._mainGroup.removeAll();
    this._data = null;
  };
  TreeView2.type = "tree";
  return TreeView2;
}(ChartView$1);
function symbolNeedsDraw(data, dataIndex) {
  var layout2 = data.getItemLayout(dataIndex);
  return layout2 && !isNaN(layout2.x) && !isNaN(layout2.y);
}
function updateNode(data, dataIndex, symbolEl, group, seriesModel) {
  var isInit = !symbolEl;
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var itemModel = node.getModel();
  var visualColor = node.getVisual("style").fill;
  var symbolInnerColor = node.isExpand === false && node.children.length !== 0 ? visualColor : "#fff";
  var virtualRoot = data.tree.root;
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceLayout = source.getLayout();
  var sourceOldLayout = sourceSymbolEl ? {
    x: sourceSymbolEl.__oldX,
    y: sourceSymbolEl.__oldY,
    rawX: sourceSymbolEl.__radialOldRawX,
    rawY: sourceSymbolEl.__radialOldRawY
  } : sourceLayout;
  var targetLayout = node.getLayout();
  if (isInit) {
    symbolEl = new SymbolClz(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
    symbolEl.x = sourceOldLayout.x;
    symbolEl.y = sourceOldLayout.y;
  } else {
    symbolEl.updateData(data, dataIndex, null, {
      symbolInnerColor,
      useNameLabel: true
    });
  }
  symbolEl.__radialOldRawX = symbolEl.__radialRawX;
  symbolEl.__radialOldRawY = symbolEl.__radialRawY;
  symbolEl.__radialRawX = targetLayout.rawX;
  symbolEl.__radialRawY = targetLayout.rawY;
  group.add(symbolEl);
  data.setItemGraphicEl(dataIndex, symbolEl);
  symbolEl.__oldX = symbolEl.x;
  symbolEl.__oldY = symbolEl.y;
  updateProps$1(symbolEl, {
    x: targetLayout.x,
    y: targetLayout.y
  }, seriesModel);
  var symbolPath = symbolEl.getSymbolPath();
  if (seriesModel.get("layout") === "radial") {
    var realRoot = virtualRoot.children[0];
    var rootLayout = realRoot.getLayout();
    var length_1 = realRoot.children.length;
    var rad = void 0;
    var isLeft = void 0;
    if (targetLayout.x === rootLayout.x && node.isExpand === true) {
      var center2 = {
        x: (realRoot.children[0].getLayout().x + realRoot.children[length_1 - 1].getLayout().x) / 2,
        y: (realRoot.children[0].getLayout().y + realRoot.children[length_1 - 1].getLayout().y) / 2
      };
      rad = Math.atan2(center2.y - rootLayout.y, center2.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      isLeft = center2.x < rootLayout.x;
      if (isLeft) {
        rad = rad - Math.PI;
      }
    } else {
      rad = Math.atan2(targetLayout.y - rootLayout.y, targetLayout.x - rootLayout.x);
      if (rad < 0) {
        rad = Math.PI * 2 + rad;
      }
      if (node.children.length === 0 || node.children.length !== 0 && node.isExpand === false) {
        isLeft = targetLayout.x < rootLayout.x;
        if (isLeft) {
          rad = rad - Math.PI;
        }
      } else {
        isLeft = targetLayout.x > rootLayout.x;
        if (!isLeft) {
          rad = rad - Math.PI;
        }
      }
    }
    var textPosition = isLeft ? "left" : "right";
    var normalLabelModel = itemModel.getModel("label");
    var rotate2 = normalLabelModel.get("rotate");
    var labelRotateRadian = rotate2 * (Math.PI / 180);
    var textContent = symbolPath.getTextContent();
    if (textContent) {
      symbolPath.setTextConfig({
        position: normalLabelModel.get("position") || textPosition,
        rotation: rotate2 == null ? -rad : labelRotateRadian,
        origin: "center"
      });
      textContent.setStyle("verticalAlign", "middle");
    }
  }
  var focus = itemModel.get(["emphasis", "focus"]);
  var focusDataIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : null;
  if (focusDataIndices) {
    getECData(symbolEl).focus = focusDataIndices;
  }
  drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group);
  if (symbolEl.__edge) {
    symbolEl.onHoverStateChange = function(toState) {
      if (toState !== "blur") {
        var parentEl = node.parentNode && data.getItemGraphicEl(node.parentNode.dataIndex);
        if (!(parentEl && parentEl.hoverState === HOVER_STATE_BLUR)) {
          setStatesFlag(symbolEl.__edge, toState);
        }
      }
    };
  }
}
function drawEdge(seriesModel, node, virtualRoot, symbolEl, sourceOldLayout, sourceLayout, targetLayout, group) {
  var itemModel = node.getModel();
  var edgeShape = seriesModel.get("edgeShape");
  var layout2 = seriesModel.get("layout");
  var orient = seriesModel.getOrient();
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  var edgeForkPosition = seriesModel.get("edgeForkPosition");
  var lineStyle = itemModel.getModel("lineStyle").getLineStyle();
  var edge = symbolEl.__edge;
  if (edgeShape === "curve") {
    if (node.parentNode && node.parentNode !== virtualRoot) {
      if (!edge) {
        edge = symbolEl.__edge = new BezierCurve$1({
          shape: getEdgeShape(layout2, orient, curvature, sourceOldLayout, sourceOldLayout)
        });
      }
      updateProps$1(edge, {
        shape: getEdgeShape(layout2, orient, curvature, sourceLayout, targetLayout)
      }, seriesModel);
    }
  } else if (edgeShape === "polyline") {
    if (layout2 === "orthogonal") {
      if (node !== virtualRoot && node.children && node.children.length !== 0 && node.isExpand === true) {
        var children = node.children;
        var childPoints = [];
        for (var i = 0; i < children.length; i++) {
          var childLayout = children[i].getLayout();
          childPoints.push([childLayout.x, childLayout.y]);
        }
        if (!edge) {
          edge = symbolEl.__edge = new TreePath({
            shape: {
              parentPoint: [targetLayout.x, targetLayout.y],
              childPoints: [[targetLayout.x, targetLayout.y]],
              orient,
              forkPosition: edgeForkPosition
            }
          });
        }
        updateProps$1(edge, {
          shape: {
            parentPoint: [targetLayout.x, targetLayout.y],
            childPoints
          }
        }, seriesModel);
      }
    }
  }
  if (edge) {
    edge.useStyle(defaults({
      strokeNoScale: true,
      fill: null
    }, lineStyle));
    setStatesStylesFromModel(edge, itemModel, "lineStyle");
    setDefaultStateProxy(edge);
    group.add(edge);
  }
}
function removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt) {
  var virtualRoot = data.tree.root;
  var _a2 = getSourceNode(virtualRoot, node), source = _a2.source, sourceLayout = _a2.sourceLayout;
  var symbolEl = data.getItemGraphicEl(node.dataIndex);
  if (!symbolEl) {
    return;
  }
  var sourceSymbolEl = data.getItemGraphicEl(source.dataIndex);
  var sourceEdge = sourceSymbolEl.__edge;
  var edge = symbolEl.__edge || (source.isExpand === false || source.children.length === 1 ? sourceEdge : void 0);
  var edgeShape = seriesModel.get("edgeShape");
  var layoutOpt = seriesModel.get("layout");
  var orient = seriesModel.get("orient");
  var curvature = seriesModel.get(["lineStyle", "curveness"]);
  if (edge) {
    if (edgeShape === "curve") {
      removeElement(edge, {
        shape: getEdgeShape(layoutOpt, orient, curvature, sourceLayout, sourceLayout),
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    } else if (edgeShape === "polyline" && seriesModel.get("layout") === "orthogonal") {
      removeElement(edge, {
        shape: {
          parentPoint: [sourceLayout.x, sourceLayout.y],
          childPoints: [[sourceLayout.x, sourceLayout.y]]
        },
        style: {
          opacity: 0
        }
      }, seriesModel, {
        cb: function() {
          group.remove(edge);
        },
        removeOpt: removeAnimationOpt
      });
    }
  }
}
function getSourceNode(virtualRoot, node) {
  var source = node.parentNode === virtualRoot ? node : node.parentNode || node;
  var sourceLayout;
  while (sourceLayout = source.getLayout(), sourceLayout == null) {
    source = source.parentNode === virtualRoot ? source : source.parentNode || source;
  }
  return {
    source,
    sourceLayout
  };
}
function removeNode(data, dataIndex, symbolEl, group, seriesModel) {
  var node = data.tree.getNodeByDataIndex(dataIndex);
  var virtualRoot = data.tree.root;
  var sourceLayout = getSourceNode(virtualRoot, node).sourceLayout;
  var removeAnimationOpt = {
    duration: seriesModel.get("animationDurationUpdate"),
    easing: seriesModel.get("animationEasingUpdate")
  };
  removeElement(symbolEl, {
    x: sourceLayout.x + 1,
    y: sourceLayout.y + 1
  }, seriesModel, {
    cb: function() {
      group.remove(symbolEl);
      data.setItemGraphicEl(dataIndex, null);
    },
    removeOpt: removeAnimationOpt
  });
  symbolEl.fadeOut(null, data.hostModel, {
    fadeLabel: true,
    animation: removeAnimationOpt
  });
  node.children.forEach(function(childNode) {
    removeNodeEdge(childNode, data, group, seriesModel, removeAnimationOpt);
  });
  removeNodeEdge(node, data, group, seriesModel, removeAnimationOpt);
}
function getEdgeShape(layoutOpt, orient, curvature, sourceLayout, targetLayout) {
  var cpx1;
  var cpy1;
  var cpx2;
  var cpy2;
  var x1;
  var x2;
  var y1;
  var y2;
  if (layoutOpt === "radial") {
    x1 = sourceLayout.rawX;
    y1 = sourceLayout.rawY;
    x2 = targetLayout.rawX;
    y2 = targetLayout.rawY;
    var radialCoor1 = radialCoordinate(x1, y1);
    var radialCoor2 = radialCoordinate(x1, y1 + (y2 - y1) * curvature);
    var radialCoor3 = radialCoordinate(x2, y2 + (y1 - y2) * curvature);
    var radialCoor4 = radialCoordinate(x2, y2);
    return {
      x1: radialCoor1.x || 0,
      y1: radialCoor1.y || 0,
      x2: radialCoor4.x || 0,
      y2: radialCoor4.y || 0,
      cpx1: radialCoor2.x || 0,
      cpy1: radialCoor2.y || 0,
      cpx2: radialCoor3.x || 0,
      cpy2: radialCoor3.y || 0
    };
  } else {
    x1 = sourceLayout.x;
    y1 = sourceLayout.y;
    x2 = targetLayout.x;
    y2 = targetLayout.y;
    if (orient === "LR" || orient === "RL") {
      cpx1 = x1 + (x2 - x1) * curvature;
      cpy1 = y1;
      cpx2 = x2 + (x1 - x2) * curvature;
      cpy2 = y2;
    }
    if (orient === "TB" || orient === "BT") {
      cpx1 = x1;
      cpy1 = y1 + (y2 - y1) * curvature;
      cpx2 = x2;
      cpy2 = y2 + (y1 - y2) * curvature;
    }
  }
  return {
    x1,
    y1,
    x2,
    y2,
    cpx1,
    cpy1,
    cpx2,
    cpy2
  };
}
var TreeView$1 = TreeView;
var inner$e = makeInner();
function linkSeriesData(opt) {
  var mainData = opt.mainData;
  var datas = opt.datas;
  if (!datas) {
    datas = {
      main: mainData
    };
    opt.datasAttr = {
      main: "data"
    };
  }
  opt.datas = opt.mainData = null;
  linkAll(mainData, datas, opt);
  each$f(datas, function(data) {
    each$f(mainData.TRANSFERABLE_METHODS, function(methodName) {
      data.wrapMethod(methodName, curry$1(transferInjection, opt));
    });
  });
  mainData.wrapMethod("cloneShallow", curry$1(cloneShallowInjection, opt));
  each$f(mainData.CHANGABLE_METHODS, function(methodName) {
    mainData.wrapMethod(methodName, curry$1(changeInjection, opt));
  });
  assert(datas[mainData.dataType] === mainData);
}
function transferInjection(opt, res) {
  if (isMainData(this)) {
    var datas = extend({}, inner$e(this).datas);
    datas[this.dataType] = res;
    linkAll(res, datas, opt);
  } else {
    linkSingle(res, this.dataType, inner$e(this).mainData, opt);
  }
  return res;
}
function changeInjection(opt, res) {
  opt.struct && opt.struct.update();
  return res;
}
function cloneShallowInjection(opt, res) {
  each$f(inner$e(res).datas, function(data, dataType) {
    data !== res && linkSingle(data.cloneShallow(), dataType, res, opt);
  });
  return res;
}
function getLinkedData(dataType) {
  var mainData = inner$e(this).mainData;
  return dataType == null || mainData == null ? mainData : inner$e(mainData).datas[dataType];
}
function getLinkedDataAll() {
  var mainData = inner$e(this).mainData;
  return mainData == null ? [{
    data: mainData
  }] : map$1(keys(inner$e(mainData).datas), function(type4) {
    return {
      type: type4,
      data: inner$e(mainData).datas[type4]
    };
  });
}
function isMainData(data) {
  return inner$e(data).mainData === data;
}
function linkAll(mainData, datas, opt) {
  inner$e(mainData).datas = {};
  each$f(datas, function(data, dataType) {
    linkSingle(data, dataType, mainData, opt);
  });
}
function linkSingle(data, dataType, mainData, opt) {
  inner$e(mainData).datas[dataType] = data;
  inner$e(data).mainData = mainData;
  data.dataType = dataType;
  if (opt.struct) {
    data[opt.structAttr] = opt.struct;
    opt.struct[opt.datasAttr[dataType]] = data;
  }
  data.getLinkedData = getLinkedData;
  data.getLinkedDataAll = getLinkedDataAll;
}
var TreeNode = function() {
  function TreeNode2(name, hostTree) {
    this.depth = 0;
    this.height = 0;
    this.dataIndex = -1;
    this.children = [];
    this.viewChildren = [];
    this.isExpand = false;
    this.name = name || "";
    this.hostTree = hostTree;
  }
  TreeNode2.prototype.isRemoved = function() {
    return this.dataIndex < 0;
  };
  TreeNode2.prototype.eachNode = function(options, cb, context) {
    if (isFunction(options)) {
      context = cb;
      cb = options;
      options = null;
    }
    options = options || {};
    if (isString(options)) {
      options = {
        order: options
      };
    }
    var order = options.order || "preorder";
    var children = this[options.attr || "children"];
    var suppressVisitSub;
    order === "preorder" && (suppressVisitSub = cb.call(context, this));
    for (var i = 0; !suppressVisitSub && i < children.length; i++) {
      children[i].eachNode(options, cb, context);
    }
    order === "postorder" && cb.call(context, this);
  };
  TreeNode2.prototype.updateDepthAndHeight = function(depth) {
    var height = 0;
    this.depth = depth;
    for (var i = 0; i < this.children.length; i++) {
      var child = this.children[i];
      child.updateDepthAndHeight(depth + 1);
      if (child.height > height) {
        height = child.height;
      }
    }
    this.height = height + 1;
  };
  TreeNode2.prototype.getNodeById = function(id2) {
    if (this.getId() === id2) {
      return this;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].getNodeById(id2);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.contains = function(node) {
    if (node === this) {
      return true;
    }
    for (var i = 0, children = this.children, len2 = children.length; i < len2; i++) {
      var res = children[i].contains(node);
      if (res) {
        return res;
      }
    }
  };
  TreeNode2.prototype.getAncestors = function(includeSelf) {
    var ancestors = [];
    var node = includeSelf ? this : this.parentNode;
    while (node) {
      ancestors.push(node);
      node = node.parentNode;
    }
    ancestors.reverse();
    return ancestors;
  };
  TreeNode2.prototype.getAncestorsIndices = function() {
    var indices = [];
    var currNode = this;
    while (currNode) {
      indices.push(currNode.dataIndex);
      currNode = currNode.parentNode;
    }
    indices.reverse();
    return indices;
  };
  TreeNode2.prototype.getDescendantIndices = function() {
    var indices = [];
    this.eachNode(function(childNode) {
      indices.push(childNode.dataIndex);
    });
    return indices;
  };
  TreeNode2.prototype.getValue = function(dimension) {
    var data = this.hostTree.data;
    return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
  };
  TreeNode2.prototype.setLayout = function(layout2, merge2) {
    this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, layout2, merge2);
  };
  TreeNode2.prototype.getLayout = function() {
    return this.hostTree.data.getItemLayout(this.dataIndex);
  };
  TreeNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var hostTree = this.hostTree;
    var itemModel = hostTree.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  TreeNode2.prototype.getLevelModel = function() {
    return (this.hostTree.levelModels || [])[this.depth];
  };
  TreeNode2.prototype.setVisual = function(key, value) {
    this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, key, value);
  };
  TreeNode2.prototype.getVisual = function(key) {
    return this.hostTree.data.getItemVisual(this.dataIndex, key);
  };
  TreeNode2.prototype.getRawIndex = function() {
    return this.hostTree.data.getRawIndex(this.dataIndex);
  };
  TreeNode2.prototype.getId = function() {
    return this.hostTree.data.getId(this.dataIndex);
  };
  TreeNode2.prototype.getChildIndex = function() {
    if (this.parentNode) {
      var children = this.parentNode.children;
      for (var i = 0; i < children.length; ++i) {
        if (children[i] === this) {
          return i;
        }
      }
      return -1;
    }
    return -1;
  };
  TreeNode2.prototype.isAncestorOf = function(node) {
    var parent = node.parentNode;
    while (parent) {
      if (parent === this) {
        return true;
      }
      parent = parent.parentNode;
    }
    return false;
  };
  TreeNode2.prototype.isDescendantOf = function(node) {
    return node !== this && node.isAncestorOf(this);
  };
  return TreeNode2;
}();
var Tree = function() {
  function Tree2(hostModel) {
    this.type = "tree";
    this._nodes = [];
    this.hostModel = hostModel;
  }
  Tree2.prototype.eachNode = function(options, cb, context) {
    this.root.eachNode(options, cb, context);
  };
  Tree2.prototype.getNodeByDataIndex = function(dataIndex) {
    var rawIndex = this.data.getRawIndex(dataIndex);
    return this._nodes[rawIndex];
  };
  Tree2.prototype.getNodeById = function(name) {
    return this.root.getNodeById(name);
  };
  Tree2.prototype.update = function() {
    var data = this.data;
    var nodes = this._nodes;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
  };
  Tree2.prototype.clearLayouts = function() {
    this.data.clearItemLayouts();
  };
  Tree2.createTree = function(dataRoot, hostModel, beforeLink) {
    var tree = new Tree2(hostModel);
    var listData = [];
    var dimMax = 1;
    buildHierarchy(dataRoot);
    function buildHierarchy(dataNode, parentNode2) {
      var value = dataNode.value;
      dimMax = Math.max(dimMax, isArray$1(value) ? value.length : 1);
      listData.push(dataNode);
      var node = new TreeNode(convertOptionIdName(dataNode.name, ""), tree);
      parentNode2 ? addChild(node, parentNode2) : tree.root = node;
      tree._nodes.push(node);
      var children = dataNode.children;
      if (children) {
        for (var i = 0; i < children.length; i++) {
          buildHierarchy(children[i], node);
        }
      }
    }
    tree.root.updateDepthAndHeight(0);
    var dimensions = prepareSeriesDataSchema(listData, {
      coordDimensions: ["value"],
      dimensionsCount: dimMax
    }).dimensions;
    var list = new SeriesData$1(dimensions, hostModel);
    list.initData(listData);
    beforeLink && beforeLink(list);
    linkSeriesData({
      mainData: list,
      struct: tree,
      structAttr: "tree"
    });
    tree.update();
    return tree;
  };
  return Tree2;
}();
function addChild(child, node) {
  var children = node.children;
  if (child.parentNode === node) {
    return;
  }
  children.push(child);
  child.parentNode = node;
}
var Tree$1 = Tree;
function retrieveTargetInfo(payload, validPayloadTypes, seriesModel) {
  if (payload && indexOf(validPayloadTypes, payload.type) >= 0) {
    var root2 = seriesModel.getData().tree.root;
    var targetNode = payload.targetNode;
    if (isString(targetNode)) {
      targetNode = root2.getNodeById(targetNode);
    }
    if (targetNode && root2.contains(targetNode)) {
      return {
        node: targetNode
      };
    }
    var targetNodeId = payload.targetNodeId;
    if (targetNodeId != null && (targetNode = root2.getNodeById(targetNodeId))) {
      return {
        node: targetNode
      };
    }
  }
}
function getPathToRoot(node) {
  var path = [];
  while (node) {
    node = node.parentNode;
    node && path.push(node);
  }
  return path.reverse();
}
function aboveViewRoot(viewRoot, node) {
  var viewPath = getPathToRoot(viewRoot);
  return indexOf(viewPath, node) >= 0;
}
function wrapTreePathInfo(node, seriesModel) {
  var treePathInfo = [];
  while (node) {
    var nodeDataIndex = node.dataIndex;
    treePathInfo.push({
      name: node.name,
      dataIndex: nodeDataIndex,
      value: seriesModel.getRawValue(nodeDataIndex)
    });
    node = node.parentNode;
  }
  treePathInfo.reverse();
  return treePathInfo;
}
var TreeSeriesModel = function(_super) {
  __extends(TreeSeriesModel2, _super);
  function TreeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.hasSymbolVisual = true;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  TreeSeriesModel2.prototype.getInitialData = function(option) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    var leaves = option.leaves || {};
    var leavesModel = new Model$1(leaves, this, this.ecModel);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        if (!(node && node.children.length && node.isExpand)) {
          model.parentModel = leavesModel;
        }
        return model;
      });
    }
    var treeDepth = 0;
    tree.eachNode("preorder", function(node) {
      if (node.depth > treeDepth) {
        treeDepth = node.depth;
      }
    });
    var expandAndCollapse = option.expandAndCollapse;
    var expandTreeDepth = expandAndCollapse && option.initialTreeDepth >= 0 ? option.initialTreeDepth : treeDepth;
    tree.root.eachNode("preorder", function(node) {
      var item = node.hostTree.data.getRawDataItem(node.dataIndex);
      node.isExpand = item && item.collapsed != null ? !item.collapsed : node.depth <= expandTreeDepth;
    });
    return tree.data;
  };
  TreeSeriesModel2.prototype.getOrient = function() {
    var orient = this.get("orient");
    if (orient === "horizontal") {
      orient = "LR";
    } else if (orient === "vertical") {
      orient = "TB";
    }
    return orient;
  };
  TreeSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  TreeSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  TreeSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var tree = this.getData().tree;
    var realRoot = tree.root.children[0];
    var node = tree.getNodeByDataIndex(dataIndex);
    var value = node.getValue();
    var name = node.name;
    while (node && node !== realRoot) {
      name = node.parentNode.name + "." + name;
      node = node.parentNode;
    }
    return createTooltipMarkup("nameValue", {
      name,
      value,
      noValue: isNaN(value) || value == null
    });
  };
  TreeSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    return params;
  };
  TreeSeriesModel2.type = "series.tree";
  TreeSeriesModel2.layoutMode = "box";
  TreeSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "12%",
    top: "12%",
    right: "12%",
    bottom: "12%",
    layout: "orthogonal",
    edgeShape: "curve",
    edgeForkPosition: "50%",
    roam: false,
    nodeScaleRatio: 0.4,
    center: null,
    zoom: 1,
    orient: "LR",
    symbol: "emptyCircle",
    symbolSize: 7,
    expandAndCollapse: true,
    initialTreeDepth: 2,
    lineStyle: {
      color: "#ccc",
      width: 1.5,
      curveness: 0.5
    },
    itemStyle: {
      color: "lightsteelblue",
      borderWidth: 1.5
    },
    label: {
      show: true
    },
    animationEasing: "linear",
    animationDuration: 700,
    animationDurationUpdate: 500
  };
  return TreeSeriesModel2;
}(SeriesModel$1);
var TreeSeriesModel$1 = TreeSeriesModel;
function eachAfter(root2, callback, separation2) {
  var nodes = [root2];
  var next = [];
  var node;
  while (node = nodes.pop()) {
    next.push(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = 0; i < children.length; i++) {
          nodes.push(children[i]);
        }
      }
    }
  }
  while (node = next.pop()) {
    callback(node, separation2);
  }
}
function eachBefore(root2, callback) {
  var nodes = [root2];
  var node;
  while (node = nodes.pop()) {
    callback(node);
    if (node.isExpand) {
      var children = node.children;
      if (children.length) {
        for (var i = children.length - 1; i >= 0; i--) {
          nodes.push(children[i]);
        }
      }
    }
  }
}
function treeLayout(ecModel, api) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    commonLayout(seriesModel, api);
  });
}
function commonLayout(seriesModel, api) {
  var layoutInfo = getViewRect$4(seriesModel, api);
  seriesModel.layoutInfo = layoutInfo;
  var layout2 = seriesModel.get("layout");
  var width = 0;
  var height = 0;
  var separation$1 = null;
  if (layout2 === "radial") {
    width = 2 * Math.PI;
    height = Math.min(layoutInfo.height, layoutInfo.width) / 2;
    separation$1 = separation(function(node1, node2) {
      return (node1.parentNode === node2.parentNode ? 1 : 2) / node1.depth;
    });
  } else {
    width = layoutInfo.width;
    height = layoutInfo.height;
    separation$1 = separation();
  }
  var virtualRoot = seriesModel.getData().tree.root;
  var realRoot = virtualRoot.children[0];
  if (realRoot) {
    init(virtualRoot);
    eachAfter(realRoot, firstWalk, separation$1);
    virtualRoot.hierNode.modifier = -realRoot.hierNode.prelim;
    eachBefore(realRoot, secondWalk);
    var left_1 = realRoot;
    var right_1 = realRoot;
    var bottom_1 = realRoot;
    eachBefore(realRoot, function(node) {
      var x2 = node.getLayout().x;
      if (x2 < left_1.getLayout().x) {
        left_1 = node;
      }
      if (x2 > right_1.getLayout().x) {
        right_1 = node;
      }
      if (node.depth > bottom_1.depth) {
        bottom_1 = node;
      }
    });
    var delta = left_1 === right_1 ? 1 : separation$1(left_1, right_1) / 2;
    var tx_1 = delta - left_1.getLayout().x;
    var kx_1 = 0;
    var ky_1 = 0;
    var coorX_1 = 0;
    var coorY_1 = 0;
    if (layout2 === "radial") {
      kx_1 = width / (right_1.getLayout().x + delta + tx_1);
      ky_1 = height / (bottom_1.depth - 1 || 1);
      eachBefore(realRoot, function(node) {
        coorX_1 = (node.getLayout().x + tx_1) * kx_1;
        coorY_1 = (node.depth - 1) * ky_1;
        var finalCoor = radialCoordinate(coorX_1, coorY_1);
        node.setLayout({
          x: finalCoor.x,
          y: finalCoor.y,
          rawX: coorX_1,
          rawY: coorY_1
        }, true);
      });
    } else {
      var orient_1 = seriesModel.getOrient();
      if (orient_1 === "RL" || orient_1 === "LR") {
        ky_1 = height / (right_1.getLayout().x + delta + tx_1);
        kx_1 = width / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorY_1 = (node.getLayout().x + tx_1) * ky_1;
          coorX_1 = orient_1 === "LR" ? (node.depth - 1) * kx_1 : width - (node.depth - 1) * kx_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      } else if (orient_1 === "TB" || orient_1 === "BT") {
        kx_1 = width / (right_1.getLayout().x + delta + tx_1);
        ky_1 = height / (bottom_1.depth - 1 || 1);
        eachBefore(realRoot, function(node) {
          coorX_1 = (node.getLayout().x + tx_1) * kx_1;
          coorY_1 = orient_1 === "TB" ? (node.depth - 1) * ky_1 : height - (node.depth - 1) * ky_1;
          node.setLayout({
            x: coorX_1,
            y: coorY_1
          }, true);
        });
      }
    }
  }
}
function treeVisual(ecModel) {
  ecModel.eachSeriesByType("tree", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style = model.getModel("itemStyle").getItemStyle();
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style);
    });
  });
}
function installTreeAction(registers) {
  registers.registerAction({
    type: "treeExpandAndCollapse",
    event: "treeExpandAndCollapse",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var dataIndex = payload.dataIndex;
      var tree = seriesModel.getData().tree;
      var node = tree.getNodeByDataIndex(dataIndex);
      node.isExpand = !node.isExpand;
    });
  });
  registers.registerAction({
    type: "treeRoam",
    event: "treeRoam",
    update: "none"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "tree",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
function install$H(registers) {
  registers.registerChartView(TreeView$1);
  registers.registerSeriesModel(TreeSeriesModel$1);
  registers.registerLayout(treeLayout);
  registers.registerVisual(treeVisual);
  installTreeAction(registers);
}
var actionTypes = ["treemapZoomToNode", "treemapRender", "treemapMove"];
function installTreemapAction(registers) {
  for (var i = 0; i < actionTypes.length; i++) {
    registers.registerAction({
      type: actionTypes[i],
      update: "updateView"
    }, noop);
  }
  registers.registerAction({
    type: "treemapRootToNode",
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "treemap",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var types2 = ["treemapZoomToNode", "treemapRootToNode"];
      var targetInfo = retrieveTargetInfo(payload, types2, model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
}
function enableAriaDecalForTree(seriesModel) {
  var data = seriesModel.getData();
  var tree = data.tree;
  var decalPaletteScope2 = {};
  tree.eachNode(function(node) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var decal = getDecalFromPalette(seriesModel.ecModel, current.name || current.dataIndex + "", decalPaletteScope2);
    node.setVisual("decal", decal);
  });
}
var TreemapSeriesModel = function(_super) {
  __extends(TreemapSeriesModel2, _super);
  function TreemapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapSeriesModel2.type;
    _this.preventUsingHoverLayer = true;
    return _this;
  }
  TreemapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue$1(root2);
    var levels = option.levels || [];
    var designatedVisualItemStyle = this.designatedVisualItemStyle = {};
    var designatedVisualModel = new Model$1({
      itemStyle: designatedVisualItemStyle
    }, this, ecModel);
    levels = option.levels = setDefault(levels, ecModel);
    var levelModels = map$1(levels || [], function(levelDefine) {
      return new Model$1(levelDefine, designatedVisualModel, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = node ? levelModels[node.depth] : null;
        model.parentModel = levelModel || designatedVisualModel;
        return model;
      });
    }
    return tree.data;
  };
  TreemapSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  TreemapSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var name = data.getName(dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  TreemapSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treeAncestors = wrapTreePathInfo(node, this);
    params.treePathInfo = params.treeAncestors;
    return params;
  };
  TreemapSeriesModel2.prototype.setLayoutInfo = function(layoutInfo) {
    this.layoutInfo = this.layoutInfo || {};
    extend(this.layoutInfo, layoutInfo);
  };
  TreemapSeriesModel2.prototype.mapIdToIndex = function(id2) {
    var idIndexMap = this._idIndexMap;
    if (!idIndexMap) {
      idIndexMap = this._idIndexMap = createHashMap();
      this._idIndexMapCount = 0;
    }
    var index2 = idIndexMap.get(id2);
    if (index2 == null) {
      idIndexMap.set(id2, index2 = this._idIndexMapCount++);
    }
    return index2;
  };
  TreemapSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  TreemapSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  TreemapSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  TreemapSeriesModel2.type = "series.treemap";
  TreemapSeriesModel2.layoutMode = "box";
  TreemapSeriesModel2.defaultOption = {
    progressive: 0,
    left: "center",
    top: "middle",
    width: "80%",
    height: "80%",
    sort: true,
    clipWindow: "origin",
    squareRatio: 0.5 * (1 + Math.sqrt(5)),
    leafDepth: null,
    drillDownIcon: "\u25B6",
    zoomToNodeRatio: 0.32 * 0.32,
    roam: true,
    nodeClick: "zoomToNode",
    animation: true,
    animationDurationUpdate: 900,
    animationEasing: "quinticInOut",
    breadcrumb: {
      show: true,
      height: 22,
      left: "center",
      top: "bottom",
      emptyItemWidth: 25,
      itemStyle: {
        color: "rgba(0,0,0,0.7)",
        textStyle: {
          color: "#fff"
        }
      }
    },
    label: {
      show: true,
      distance: 0,
      padding: 5,
      position: "inside",
      color: "#fff",
      overflow: "truncate"
    },
    upperLabel: {
      show: false,
      position: [0, "50%"],
      height: 20,
      overflow: "truncate",
      verticalAlign: "middle"
    },
    itemStyle: {
      color: null,
      colorAlpha: null,
      colorSaturation: null,
      borderWidth: 0,
      gapWidth: 0,
      borderColor: "#fff",
      borderColorSaturation: null
    },
    emphasis: {
      upperLabel: {
        show: true,
        position: [0, "50%"],
        overflow: "truncate",
        verticalAlign: "middle"
      }
    },
    visualDimension: 0,
    visualMin: null,
    visualMax: null,
    color: [],
    colorAlpha: null,
    colorSaturation: null,
    colorMappingBy: "index",
    visibleMin: 10,
    childrenVisibleMin: null,
    levels: []
  };
  return TreemapSeriesModel2;
}(SeriesModel$1);
function completeTreeValue$1(dataNode) {
  var sum2 = 0;
  each$f(dataNode.children, function(child) {
    completeTreeValue$1(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
function setDefault(levels, ecModel) {
  var globalColorList = normalizeToArray(ecModel.get("color"));
  var globalDecalList = normalizeToArray(ecModel.get(["aria", "decal", "decals"]));
  if (!globalColorList) {
    return;
  }
  levels = levels || [];
  var hasColorDefine;
  var hasDecalDefine;
  each$f(levels, function(levelDefine) {
    var model = new Model$1(levelDefine);
    var modelColor = model.get("color");
    var modelDecal = model.get("decal");
    if (model.get(["itemStyle", "color"]) || modelColor && modelColor !== "none") {
      hasColorDefine = true;
    }
    if (model.get(["itemStyle", "decal"]) || modelDecal && modelDecal !== "none") {
      hasDecalDefine = true;
    }
  });
  var level0 = levels[0] || (levels[0] = {});
  if (!hasColorDefine) {
    level0.color = globalColorList.slice();
  }
  if (!hasDecalDefine && globalDecalList) {
    level0.decal = globalDecalList.slice();
  }
  return levels;
}
var TreemapSeriesModel$1 = TreemapSeriesModel;
var TEXT_PADDING = 8;
var ITEM_GAP = 8;
var ARRAY_LENGTH = 5;
var Breadcrumb = function() {
  function Breadcrumb2(containerGroup) {
    this.group = new Group$4();
    containerGroup.add(this.group);
  }
  Breadcrumb2.prototype.render = function(seriesModel, api, targetNode, onSelect) {
    var model = seriesModel.getModel("breadcrumb");
    var thisGroup = this.group;
    thisGroup.removeAll();
    if (!model.get("show") || !targetNode) {
      return;
    }
    var normalStyleModel = model.getModel("itemStyle");
    var textStyleModel = normalStyleModel.getModel("textStyle");
    var layoutParam = {
      pos: {
        left: model.get("left"),
        right: model.get("right"),
        top: model.get("top"),
        bottom: model.get("bottom")
      },
      box: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      emptyItemWidth: model.get("emptyItemWidth"),
      totalWidth: 0,
      renderList: []
    };
    this._prepare(targetNode, layoutParam, textStyleModel);
    this._renderContent(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect);
    positionElement(thisGroup, layoutParam.pos, layoutParam.box);
  };
  Breadcrumb2.prototype._prepare = function(targetNode, layoutParam, textStyleModel) {
    for (var node = targetNode; node; node = node.parentNode) {
      var text = convertOptionIdName(node.getModel().get("name"), "");
      var textRect = textStyleModel.getTextRect(text);
      var itemWidth = Math.max(textRect.width + TEXT_PADDING * 2, layoutParam.emptyItemWidth);
      layoutParam.totalWidth += itemWidth + ITEM_GAP;
      layoutParam.renderList.push({
        node,
        text,
        width: itemWidth
      });
    }
  };
  Breadcrumb2.prototype._renderContent = function(seriesModel, layoutParam, normalStyleModel, textStyleModel, onSelect) {
    var lastX = 0;
    var emptyItemWidth = layoutParam.emptyItemWidth;
    var height = seriesModel.get(["breadcrumb", "height"]);
    var availableSize = getAvailableSize(layoutParam.pos, layoutParam.box);
    var totalWidth = layoutParam.totalWidth;
    var renderList = layoutParam.renderList;
    for (var i = renderList.length - 1; i >= 0; i--) {
      var item = renderList[i];
      var itemNode = item.node;
      var itemWidth = item.width;
      var text = item.text;
      if (totalWidth > availableSize.width) {
        totalWidth -= itemWidth - emptyItemWidth;
        itemWidth = emptyItemWidth;
        text = null;
      }
      var el = new Polygon$1({
        shape: {
          points: makeItemPoints(lastX, 0, itemWidth, height, i === renderList.length - 1, i === 0)
        },
        style: defaults(normalStyleModel.getItemStyle(), {
          lineJoin: "bevel"
        }),
        textContent: new ZRText$1({
          style: {
            text,
            fill: textStyleModel.getTextColor(),
            font: textStyleModel.getFont()
          }
        }),
        textConfig: {
          position: "inside"
        },
        z2: Z2_EMPHASIS_LIFT * 1e4,
        onclick: curry$1(onSelect, itemNode)
      });
      el.disableLabelAnimation = true;
      this.group.add(el);
      packEventData(el, seriesModel, itemNode);
      lastX += itemWidth + ITEM_GAP;
    }
  };
  Breadcrumb2.prototype.remove = function() {
    this.group.removeAll();
  };
  return Breadcrumb2;
}();
function makeItemPoints(x2, y2, itemWidth, itemHeight, head, tail) {
  var points2 = [[head ? x2 : x2 - ARRAY_LENGTH, y2], [x2 + itemWidth, y2], [x2 + itemWidth, y2 + itemHeight], [head ? x2 : x2 - ARRAY_LENGTH, y2 + itemHeight]];
  !tail && points2.splice(2, 0, [x2 + itemWidth + ARRAY_LENGTH, y2 + itemHeight / 2]);
  !head && points2.push([x2, y2 + itemHeight / 2]);
  return points2;
}
function packEventData(el, seriesModel, itemNode) {
  getECData(el).eventData = {
    componentType: "series",
    componentSubType: "treemap",
    componentIndex: seriesModel.componentIndex,
    seriesIndex: seriesModel.seriesIndex,
    seriesName: seriesModel.name,
    seriesType: "treemap",
    selfType: "breadcrumb",
    nodeData: {
      dataIndex: itemNode && itemNode.dataIndex,
      name: itemNode && itemNode.name
    },
    treePathInfo: itemNode && wrapTreePathInfo(itemNode, seriesModel)
  };
}
var Breadcrumb$1 = Breadcrumb;
var AnimationWrap = function() {
  function AnimationWrap2() {
    this._storage = [];
    this._elExistsMap = {};
  }
  AnimationWrap2.prototype.add = function(el, target, duration, delay, easing) {
    if (this._elExistsMap[el.id]) {
      return false;
    }
    this._elExistsMap[el.id] = true;
    this._storage.push({
      el,
      target,
      duration,
      delay,
      easing
    });
    return true;
  };
  AnimationWrap2.prototype.finished = function(callback) {
    this._finishedCallback = callback;
    return this;
  };
  AnimationWrap2.prototype.start = function() {
    var _this = this;
    var count2 = this._storage.length;
    var checkTerminate = function() {
      count2--;
      if (count2 <= 0) {
        _this._storage.length = 0;
        _this._elExistsMap = {};
        _this._finishedCallback && _this._finishedCallback();
      }
    };
    for (var i = 0, len2 = this._storage.length; i < len2; i++) {
      var item = this._storage[i];
      item.el.animateTo(item.target, {
        duration: item.duration,
        delay: item.delay,
        easing: item.easing,
        setToFinal: true,
        done: checkTerminate,
        aborted: checkTerminate
      });
    }
    return this;
  };
  return AnimationWrap2;
}();
function createWrap() {
  return new AnimationWrap();
}
var Group$2 = Group$4;
var Rect$1 = Rect$3;
var DRAG_THRESHOLD = 3;
var PATH_LABEL_NOAMAL = "label";
var PATH_UPPERLABEL_NORMAL = "upperLabel";
var Z2_BASE = Z2_EMPHASIS_LIFT * 10;
var Z2_BG = Z2_EMPHASIS_LIFT * 2;
var Z2_CONTENT = Z2_EMPHASIS_LIFT * 3;
var getStateItemStyle = makeStyleMapper([
  ["fill", "color"],
  ["stroke", "strokeColor"],
  ["lineWidth", "strokeWidth"],
  ["shadowBlur"],
  ["shadowOffsetX"],
  ["shadowOffsetY"],
  ["shadowColor"]
]);
var getItemStyleNormal = function(model) {
  var itemStyle = getStateItemStyle(model);
  itemStyle.stroke = itemStyle.fill = itemStyle.lineWidth = null;
  return itemStyle;
};
var inner$d = makeInner();
var TreemapView = function(_super) {
  __extends(TreemapView2, _super);
  function TreemapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TreemapView2.type;
    _this._state = "ready";
    _this._storage = createStorage();
    return _this;
  }
  TreemapView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var models = ecModel.findComponents({
      mainType: "series",
      subType: "treemap",
      query: payload
    });
    if (indexOf(models, seriesModel) < 0) {
      return;
    }
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var payloadType = payload && payload.type;
    var layoutInfo = seriesModel.layoutInfo;
    var isInit = !this._oldTree;
    var thisStorage = this._storage;
    var reRoot = payloadType === "treemapRootToNode" && targetInfo && thisStorage ? {
      rootNodeGroup: thisStorage.nodeGroup[targetInfo.node.getRawIndex()],
      direction: payload.direction
    } : null;
    var containerGroup = this._giveContainerGroup(layoutInfo);
    var hasAnimation = seriesModel.get("animation");
    var renderResult = this._doRender(containerGroup, seriesModel, reRoot);
    hasAnimation && !isInit && (!payloadType || payloadType === "treemapZoomToNode" || payloadType === "treemapRootToNode") ? this._doAnimation(containerGroup, renderResult, seriesModel, reRoot) : renderResult.renderFinally();
    this._resetController(api);
    this._renderBreadcrumb(seriesModel, api, targetInfo);
  };
  TreemapView2.prototype._giveContainerGroup = function(layoutInfo) {
    var containerGroup = this._containerGroup;
    if (!containerGroup) {
      containerGroup = this._containerGroup = new Group$2();
      this._initEvents(containerGroup);
      this.group.add(containerGroup);
    }
    containerGroup.x = layoutInfo.x;
    containerGroup.y = layoutInfo.y;
    return containerGroup;
  };
  TreemapView2.prototype._doRender = function(containerGroup, seriesModel, reRoot) {
    var thisTree = seriesModel.getData().tree;
    var oldTree = this._oldTree;
    var lastsForAnimation = createStorage();
    var thisStorage = createStorage();
    var oldStorage = this._storage;
    var willInvisibleEls = [];
    function doRenderNode(thisNode, oldNode, parentGroup, depth) {
      return renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth);
    }
    dualTravel(thisTree.root ? [thisTree.root] : [], oldTree && oldTree.root ? [oldTree.root] : [], containerGroup, thisTree === oldTree || !oldTree, 0);
    var willDeleteEls = clearStorage(oldStorage);
    this._oldTree = thisTree;
    this._storage = thisStorage;
    return {
      lastsForAnimation,
      willDeleteEls,
      renderFinally
    };
    function dualTravel(thisViewChildren, oldViewChildren, parentGroup, sameTree, depth) {
      if (sameTree) {
        oldViewChildren = thisViewChildren;
        each$f(thisViewChildren, function(child, index2) {
          !child.isRemoved() && processNode(index2, index2);
        });
      } else {
        new DataDiffer$1(oldViewChildren, thisViewChildren, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      }
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIndex, oldIndex) {
        var thisNode = newIndex != null ? thisViewChildren[newIndex] : null;
        var oldNode = oldIndex != null ? oldViewChildren[oldIndex] : null;
        var group = doRenderNode(thisNode, oldNode, parentGroup, depth);
        group && dualTravel(thisNode && thisNode.viewChildren || [], oldNode && oldNode.viewChildren || [], group, sameTree, depth + 1);
      }
    }
    function clearStorage(storage2) {
      var willDeleteEls2 = createStorage();
      storage2 && each$f(storage2, function(store, storageName) {
        var delEls = willDeleteEls2[storageName];
        each$f(store, function(el) {
          el && (delEls.push(el), inner$d(el).willDelete = true);
        });
      });
      return willDeleteEls2;
    }
    function renderFinally() {
      each$f(willDeleteEls, function(els) {
        each$f(els, function(el) {
          el.parent && el.parent.remove(el);
        });
      });
      each$f(willInvisibleEls, function(el) {
        el.invisible = true;
        el.dirty();
      });
    }
  };
  TreemapView2.prototype._doAnimation = function(containerGroup, renderResult, seriesModel, reRoot) {
    var durationOption = seriesModel.get("animationDurationUpdate");
    var easingOption = seriesModel.get("animationEasing");
    var duration = (isFunction(durationOption) ? 0 : durationOption) || 0;
    var easing = (isFunction(easingOption) ? null : easingOption) || "cubicOut";
    var animationWrap = createWrap();
    each$f(renderResult.willDeleteEls, function(store, storageName) {
      each$f(store, function(el, rawIndex) {
        if (el.invisible) {
          return;
        }
        var parent = el.parent;
        var target;
        var innerStore = inner$d(parent);
        if (reRoot && reRoot.direction === "drillDown") {
          target = parent === reRoot.rootNodeGroup ? {
            shape: {
              x: 0,
              y: 0,
              width: innerStore.nodeWidth,
              height: innerStore.nodeHeight
            },
            style: {
              opacity: 0
            }
          } : {
            style: {
              opacity: 0
            }
          };
        } else {
          var targetX = 0;
          var targetY = 0;
          if (!innerStore.willDelete) {
            targetX = innerStore.nodeWidth / 2;
            targetY = innerStore.nodeHeight / 2;
          }
          target = storageName === "nodeGroup" ? {
            x: targetX,
            y: targetY,
            style: {
              opacity: 0
            }
          } : {
            shape: {
              x: targetX,
              y: targetY,
              width: 0,
              height: 0
            },
            style: {
              opacity: 0
            }
          };
        }
        target && animationWrap.add(el, target, duration, 0, easing);
      });
    });
    each$f(this._storage, function(store, storageName) {
      each$f(store, function(el, rawIndex) {
        var last = renderResult.lastsForAnimation[storageName][rawIndex];
        var target = {};
        if (!last) {
          return;
        }
        if (el instanceof Group$4) {
          if (last.oldX != null) {
            target.x = el.x;
            target.y = el.y;
            el.x = last.oldX;
            el.y = last.oldY;
          }
        } else {
          if (last.oldShape) {
            target.shape = extend({}, el.shape);
            el.setShape(last.oldShape);
          }
          if (last.fadein) {
            el.setStyle("opacity", 0);
            target.style = {
              opacity: 1
            };
          } else if (el.style.opacity !== 1) {
            target.style = {
              opacity: 1
            };
          }
        }
        animationWrap.add(el, target, duration, 0, easing);
      });
    }, this);
    this._state = "animating";
    animationWrap.finished(bind$1(function() {
      this._state = "ready";
      renderResult.renderFinally();
    }, this)).start();
  };
  TreemapView2.prototype._resetController = function(api) {
    var controller = this._controller;
    if (!controller) {
      controller = this._controller = new RoamController$1(api.getZr());
      controller.enable(this.seriesModel.get("roam"));
      controller.on("pan", bind$1(this._onPan, this));
      controller.on("zoom", bind$1(this._onZoom, this));
    }
    var rect = new BoundingRect$1(0, 0, api.getWidth(), api.getHeight());
    controller.setPointerChecker(function(e2, x2, y2) {
      return rect.contain(x2, y2);
    });
  };
  TreemapView2.prototype._clearController = function() {
    var controller = this._controller;
    if (controller) {
      controller.dispose();
      controller = null;
    }
  };
  TreemapView2.prototype._onPan = function(e2) {
    if (this._state !== "animating" && (Math.abs(e2.dx) > DRAG_THRESHOLD || Math.abs(e2.dy) > DRAG_THRESHOLD)) {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      this.api.dispatchAction({
        type: "treemapMove",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rootLayout.x + e2.dx,
          y: rootLayout.y + e2.dy,
          width: rootLayout.width,
          height: rootLayout.height
        }
      });
    }
  };
  TreemapView2.prototype._onZoom = function(e2) {
    var mouseX = e2.originX;
    var mouseY = e2.originY;
    if (this._state !== "animating") {
      var root2 = this.seriesModel.getData().tree.root;
      if (!root2) {
        return;
      }
      var rootLayout = root2.getLayout();
      if (!rootLayout) {
        return;
      }
      var rect = new BoundingRect$1(rootLayout.x, rootLayout.y, rootLayout.width, rootLayout.height);
      var layoutInfo = this.seriesModel.layoutInfo;
      mouseX -= layoutInfo.x;
      mouseY -= layoutInfo.y;
      var m2 = create$1();
      translate(m2, m2, [-mouseX, -mouseY]);
      scale$1(m2, m2, [e2.scale, e2.scale]);
      translate(m2, m2, [mouseX, mouseY]);
      rect.applyTransform(m2);
      this.api.dispatchAction({
        type: "treemapRender",
        from: this.uid,
        seriesId: this.seriesModel.id,
        rootRect: {
          x: rect.x,
          y: rect.y,
          width: rect.width,
          height: rect.height
        }
      });
    }
  };
  TreemapView2.prototype._initEvents = function(containerGroup) {
    var _this = this;
    containerGroup.on("click", function(e2) {
      if (_this._state !== "ready") {
        return;
      }
      var nodeClick = _this.seriesModel.get("nodeClick", true);
      if (!nodeClick) {
        return;
      }
      var targetInfo = _this.findTarget(e2.offsetX, e2.offsetY);
      if (!targetInfo) {
        return;
      }
      var node = targetInfo.node;
      if (node.getLayout().isLeafRoot) {
        _this._rootToNode(targetInfo);
      } else {
        if (nodeClick === "zoomToNode") {
          _this._zoomToNode(targetInfo);
        } else if (nodeClick === "link") {
          var itemModel = node.hostTree.data.getItemModel(node.dataIndex);
          var link = itemModel.get("link", true);
          var linkTarget = itemModel.get("target", true) || "blank";
          link && windowOpen(link, linkTarget);
        }
      }
    }, this);
  };
  TreemapView2.prototype._renderBreadcrumb = function(seriesModel, api, targetInfo) {
    var _this = this;
    if (!targetInfo) {
      targetInfo = seriesModel.get("leafDepth", true) != null ? {
        node: seriesModel.getViewRoot()
      } : this.findTarget(api.getWidth() / 2, api.getHeight() / 2);
      if (!targetInfo) {
        targetInfo = {
          node: seriesModel.getData().tree.root
        };
      }
    }
    (this._breadcrumb || (this._breadcrumb = new Breadcrumb$1(this.group))).render(seriesModel, api, targetInfo.node, function(node) {
      if (_this._state !== "animating") {
        aboveViewRoot(seriesModel.getViewRoot(), node) ? _this._rootToNode({
          node
        }) : _this._zoomToNode({
          node
        });
      }
    });
  };
  TreemapView2.prototype.remove = function() {
    this._clearController();
    this._containerGroup && this._containerGroup.removeAll();
    this._storage = createStorage();
    this._state = "ready";
    this._breadcrumb && this._breadcrumb.remove();
  };
  TreemapView2.prototype.dispose = function() {
    this._clearController();
  };
  TreemapView2.prototype._zoomToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapZoomToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype._rootToNode = function(targetInfo) {
    this.api.dispatchAction({
      type: "treemapRootToNode",
      from: this.uid,
      seriesId: this.seriesModel.id,
      targetNode: targetInfo.node
    });
  };
  TreemapView2.prototype.findTarget = function(x2, y2) {
    var targetInfo;
    var viewRoot = this.seriesModel.getViewRoot();
    viewRoot.eachNode({
      attr: "viewChildren",
      order: "preorder"
    }, function(node) {
      var bgEl = this._storage.background[node.getRawIndex()];
      if (bgEl) {
        var point = bgEl.transformCoordToLocal(x2, y2);
        var shape = bgEl.shape;
        if (shape.x <= point[0] && point[0] <= shape.x + shape.width && shape.y <= point[1] && point[1] <= shape.y + shape.height) {
          targetInfo = {
            node,
            offsetX: point[0],
            offsetY: point[1]
          };
        } else {
          return false;
        }
      }
    }, this);
    return targetInfo;
  };
  TreemapView2.type = "treemap";
  return TreemapView2;
}(ChartView$1);
function createStorage() {
  return {
    nodeGroup: [],
    background: [],
    content: []
  };
}
function renderNode(seriesModel, thisStorage, oldStorage, reRoot, lastsForAnimation, willInvisibleEls, thisNode, oldNode, parentGroup, depth) {
  if (!thisNode) {
    return;
  }
  var thisLayout = thisNode.getLayout();
  var data = seriesModel.getData();
  var nodeModel = thisNode.getModel();
  data.setItemGraphicEl(thisNode.dataIndex, null);
  if (!thisLayout || !thisLayout.isInView) {
    return;
  }
  var thisWidth = thisLayout.width;
  var thisHeight = thisLayout.height;
  var borderWidth = thisLayout.borderWidth;
  var thisInvisible = thisLayout.invisible;
  var thisRawIndex = thisNode.getRawIndex();
  var oldRawIndex = oldNode && oldNode.getRawIndex();
  var thisViewChildren = thisNode.viewChildren;
  var upperHeight = thisLayout.upperHeight;
  var isParent = thisViewChildren && thisViewChildren.length;
  var itemStyleNormalModel = nodeModel.getModel("itemStyle");
  var itemStyleEmphasisModel = nodeModel.getModel(["emphasis", "itemStyle"]);
  var itemStyleBlurModel = nodeModel.getModel(["blur", "itemStyle"]);
  var itemStyleSelectModel = nodeModel.getModel(["select", "itemStyle"]);
  var borderRadius = itemStyleNormalModel.get("borderRadius") || 0;
  var group = giveGraphic("nodeGroup", Group$2);
  if (!group) {
    return;
  }
  parentGroup.add(group);
  group.x = thisLayout.x || 0;
  group.y = thisLayout.y || 0;
  group.markRedraw();
  inner$d(group).nodeWidth = thisWidth;
  inner$d(group).nodeHeight = thisHeight;
  if (thisLayout.isAboveViewRoot) {
    return group;
  }
  var bg = giveGraphic("background", Rect$1, depth, Z2_BG);
  bg && renderBackground(group, bg, isParent && thisLayout.upperLabelHeight);
  var emphasisModel = nodeModel.getModel("emphasis");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var isDisabled = emphasisModel.get("disabled");
  var focusOrIndices = focus === "ancestor" ? thisNode.getAncestorsIndices() : focus === "descendant" ? thisNode.getDescendantIndices() : focus;
  if (isParent) {
    if (isHighDownDispatcher(group)) {
      setAsHighDownDispatcher(group, false);
    }
    if (bg) {
      setAsHighDownDispatcher(bg, !isDisabled);
      data.setItemGraphicEl(thisNode.dataIndex, bg);
      enableHoverFocus(bg, focusOrIndices, blurScope);
    }
  } else {
    var content = giveGraphic("content", Rect$1, depth, Z2_CONTENT);
    content && renderContent(group, content);
    bg.disableMorphing = true;
    if (bg && isHighDownDispatcher(bg)) {
      setAsHighDownDispatcher(bg, false);
    }
    setAsHighDownDispatcher(group, !isDisabled);
    data.setItemGraphicEl(thisNode.dataIndex, group);
    enableHoverFocus(group, focusOrIndices, blurScope);
  }
  return group;
  function renderBackground(group2, bg2, useUpperLabel) {
    var ecData = getECData(bg2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    bg2.setShape({
      x: 0,
      y: 0,
      width: thisWidth,
      height: thisHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(bg2);
    } else {
      bg2.invisible = false;
      var style = thisNode.getVisual("style");
      var visualBorderColor = style.stroke;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualBorderColor;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      emphasisStyle.fill = itemStyleEmphasisModel.get("borderColor");
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      blurStyle.fill = itemStyleBlurModel.get("borderColor");
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      selectStyle.fill = itemStyleSelectModel.get("borderColor");
      if (useUpperLabel) {
        var upperLabelWidth = thisWidth - 2 * borderWidth;
        prepareText(bg2, visualBorderColor, style.opacity, {
          x: borderWidth,
          y: 0,
          width: upperLabelWidth,
          height: upperHeight
        });
      } else {
        bg2.removeTextContent();
      }
      bg2.setStyle(normalStyle);
      bg2.ensureState("emphasis").style = emphasisStyle;
      bg2.ensureState("blur").style = blurStyle;
      bg2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(bg2);
    }
    group2.add(bg2);
  }
  function renderContent(group2, content2) {
    var ecData = getECData(content2);
    ecData.dataIndex = thisNode.dataIndex;
    ecData.seriesIndex = seriesModel.seriesIndex;
    var contentWidth = Math.max(thisWidth - 2 * borderWidth, 0);
    var contentHeight = Math.max(thisHeight - 2 * borderWidth, 0);
    content2.culling = true;
    content2.setShape({
      x: borderWidth,
      y: borderWidth,
      width: contentWidth,
      height: contentHeight,
      r: borderRadius
    });
    if (thisInvisible) {
      processInvisible(content2);
    } else {
      content2.invisible = false;
      var nodeStyle = thisNode.getVisual("style");
      var visualColor = nodeStyle.fill;
      var normalStyle = getItemStyleNormal(itemStyleNormalModel);
      normalStyle.fill = visualColor;
      normalStyle.decal = nodeStyle.decal;
      var emphasisStyle = getStateItemStyle(itemStyleEmphasisModel);
      var blurStyle = getStateItemStyle(itemStyleBlurModel);
      var selectStyle = getStateItemStyle(itemStyleSelectModel);
      prepareText(content2, visualColor, nodeStyle.opacity, null);
      content2.setStyle(normalStyle);
      content2.ensureState("emphasis").style = emphasisStyle;
      content2.ensureState("blur").style = blurStyle;
      content2.ensureState("select").style = selectStyle;
      setDefaultStateProxy(content2);
    }
    group2.add(content2);
  }
  function processInvisible(element) {
    !element.invisible && willInvisibleEls.push(element);
  }
  function prepareText(rectEl, visualColor, visualOpacity, upperLabelRect) {
    var normalLabelModel = nodeModel.getModel(upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL);
    var defaultText = convertOptionIdName(nodeModel.get("name"), null);
    var isShow = normalLabelModel.getShallow("show");
    setLabelStyle(rectEl, getLabelStatesModels(nodeModel, upperLabelRect ? PATH_UPPERLABEL_NORMAL : PATH_LABEL_NOAMAL), {
      defaultText: isShow ? defaultText : null,
      inheritColor: visualColor,
      defaultOpacity: visualOpacity,
      labelFetcher: seriesModel,
      labelDataIndex: thisNode.dataIndex
    });
    var textEl = rectEl.getTextContent();
    if (!textEl) {
      return;
    }
    var textStyle = textEl.style;
    var textPadding = normalizeCssArray$1(textStyle.padding || 0);
    if (upperLabelRect) {
      rectEl.setTextConfig({
        layoutRect: upperLabelRect
      });
      textEl.disableLabelLayout = true;
    }
    textEl.beforeUpdate = function() {
      var width = Math.max((upperLabelRect ? upperLabelRect.width : rectEl.shape.width) - textPadding[1] - textPadding[3], 0);
      var height = Math.max((upperLabelRect ? upperLabelRect.height : rectEl.shape.height) - textPadding[0] - textPadding[2], 0);
      if (textStyle.width !== width || textStyle.height !== height) {
        textEl.setStyle({
          width,
          height
        });
      }
    };
    textStyle.truncateMinChar = 2;
    textStyle.lineOverflow = "truncate";
    addDrillDownIcon(textStyle, upperLabelRect, thisLayout);
    var textEmphasisState = textEl.getState("emphasis");
    addDrillDownIcon(textEmphasisState ? textEmphasisState.style : null, upperLabelRect, thisLayout);
  }
  function addDrillDownIcon(style, upperLabelRect, thisLayout2) {
    var text = style ? style.text : null;
    if (!upperLabelRect && thisLayout2.isLeafRoot && text != null) {
      var iconChar = seriesModel.get("drillDownIcon", true);
      style.text = iconChar ? iconChar + " " + text : text;
    }
  }
  function giveGraphic(storageName, Ctor, depth2, z2) {
    var element = oldRawIndex != null && oldStorage[storageName][oldRawIndex];
    var lasts = lastsForAnimation[storageName];
    if (element) {
      oldStorage[storageName][oldRawIndex] = null;
      prepareAnimationWhenHasOld(lasts, element);
    } else if (!thisInvisible) {
      element = new Ctor();
      if (element instanceof Displayable$1) {
        element.z2 = calculateZ2(depth2, z2);
      }
      prepareAnimationWhenNoOld(lasts, element);
    }
    return thisStorage[storageName][thisRawIndex] = element;
  }
  function prepareAnimationWhenHasOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    if (element instanceof Group$2) {
      lastCfg.oldX = element.x;
      lastCfg.oldY = element.y;
    } else {
      lastCfg.oldShape = extend({}, element.shape);
    }
  }
  function prepareAnimationWhenNoOld(lasts, element) {
    var lastCfg = lasts[thisRawIndex] = {};
    var parentNode2 = thisNode.parentNode;
    var isGroup = element instanceof Group$4;
    if (parentNode2 && (!reRoot || reRoot.direction === "drillDown")) {
      var parentOldX = 0;
      var parentOldY = 0;
      var parentOldBg = lastsForAnimation.background[parentNode2.getRawIndex()];
      if (!reRoot && parentOldBg && parentOldBg.oldShape) {
        parentOldX = parentOldBg.oldShape.width;
        parentOldY = parentOldBg.oldShape.height;
      }
      if (isGroup) {
        lastCfg.oldX = 0;
        lastCfg.oldY = parentOldY;
      } else {
        lastCfg.oldShape = {
          x: parentOldX,
          y: parentOldY,
          width: 0,
          height: 0
        };
      }
    }
    lastCfg.fadein = !isGroup;
  }
}
function calculateZ2(depth, z2InLevel) {
  return depth * Z2_BASE + z2InLevel;
}
var TreemapView$1 = TreemapView;
var each$c = each$f;
var isObject$1 = isObject$4;
var CATEGORY_DEFAULT_VISUAL_INDEX = -1;
var VisualMapping = function() {
  function VisualMapping2(option) {
    var mappingMethod = option.mappingMethod;
    var visualType = option.type;
    var thisOption = this.option = clone$4(option);
    this.type = visualType;
    this.mappingMethod = mappingMethod;
    this._normalizeData = normalizers[mappingMethod];
    var visualHandler = VisualMapping2.visualHandlers[visualType];
    this.applyVisual = visualHandler.applyVisual;
    this.getColorMapper = visualHandler.getColorMapper;
    this._normalizedToVisual = visualHandler._normalizedToVisual[mappingMethod];
    if (mappingMethod === "piecewise") {
      normalizeVisualRange(thisOption);
      preprocessForPiecewise(thisOption);
    } else if (mappingMethod === "category") {
      thisOption.categories ? preprocessForSpecifiedCategory(thisOption) : normalizeVisualRange(thisOption, true);
    } else {
      assert(mappingMethod !== "linear" || thisOption.dataExtent);
      normalizeVisualRange(thisOption);
    }
  }
  VisualMapping2.prototype.mapValueToVisual = function(value) {
    var normalized = this._normalizeData(value);
    return this._normalizedToVisual(normalized, value);
  };
  VisualMapping2.prototype.getNormalizer = function() {
    return bind$1(this._normalizeData, this);
  };
  VisualMapping2.listVisualTypes = function() {
    return keys(VisualMapping2.visualHandlers);
  };
  VisualMapping2.isValidType = function(visualType) {
    return VisualMapping2.visualHandlers.hasOwnProperty(visualType);
  };
  VisualMapping2.eachVisual = function(visual, callback, context) {
    if (isObject$4(visual)) {
      each$f(visual, callback, context);
    } else {
      callback.call(context, visual);
    }
  };
  VisualMapping2.mapVisual = function(visual, callback, context) {
    var isPrimary;
    var newVisual = isArray$1(visual) ? [] : isObject$4(visual) ? {} : (isPrimary = true, null);
    VisualMapping2.eachVisual(visual, function(v4, key) {
      var newVal = callback.call(context, v4, key);
      isPrimary ? newVisual = newVal : newVisual[key] = newVal;
    });
    return newVisual;
  };
  VisualMapping2.retrieveVisuals = function(obj) {
    var ret = {};
    var hasVisual;
    obj && each$c(VisualMapping2.visualHandlers, function(h, visualType) {
      if (obj.hasOwnProperty(visualType)) {
        ret[visualType] = obj[visualType];
        hasVisual = true;
      }
    });
    return hasVisual ? ret : null;
  };
  VisualMapping2.prepareVisualTypes = function(visualTypes) {
    if (isArray$1(visualTypes)) {
      visualTypes = visualTypes.slice();
    } else if (isObject$1(visualTypes)) {
      var types_1 = [];
      each$c(visualTypes, function(item, type4) {
        types_1.push(type4);
      });
      visualTypes = types_1;
    } else {
      return [];
    }
    visualTypes.sort(function(type1, type22) {
      return type22 === "color" && type1 !== "color" && type1.indexOf("color") === 0 ? 1 : -1;
    });
    return visualTypes;
  };
  VisualMapping2.dependsOn = function(visualType1, visualType2) {
    return visualType2 === "color" ? !!(visualType1 && visualType1.indexOf(visualType2) === 0) : visualType1 === visualType2;
  };
  VisualMapping2.findPieceIndex = function(value, pieceList, findClosestWhenOutside) {
    var possibleI;
    var abs2 = Infinity;
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var pieceValue = pieceList[i].value;
      if (pieceValue != null) {
        if (pieceValue === value || isString(pieceValue) && pieceValue === value + "") {
          return i;
        }
        findClosestWhenOutside && updatePossible(pieceValue, i);
      }
    }
    for (var i = 0, len2 = pieceList.length; i < len2; i++) {
      var piece = pieceList[i];
      var interval = piece.interval;
      var close_1 = piece.close;
      if (interval) {
        if (interval[0] === -Infinity) {
          if (littleThan(close_1[1], value, interval[1])) {
            return i;
          }
        } else if (interval[1] === Infinity) {
          if (littleThan(close_1[0], interval[0], value)) {
            return i;
          }
        } else if (littleThan(close_1[0], interval[0], value) && littleThan(close_1[1], value, interval[1])) {
          return i;
        }
        findClosestWhenOutside && updatePossible(interval[0], i);
        findClosestWhenOutside && updatePossible(interval[1], i);
      }
    }
    if (findClosestWhenOutside) {
      return value === Infinity ? pieceList.length - 1 : value === -Infinity ? 0 : possibleI;
    }
    function updatePossible(val, index2) {
      var newAbs = Math.abs(val - value);
      if (newAbs < abs2) {
        abs2 = newAbs;
        possibleI = index2;
      }
    }
  };
  VisualMapping2.visualHandlers = {
    color: {
      applyVisual: makeApplyVisual("color"),
      getColorMapper: function() {
        var thisOption = this.option;
        return bind$1(thisOption.mappingMethod === "category" ? function(value, isNormalized) {
          !isNormalized && (value = this._normalizeData(value));
          return doMapCategory.call(this, value);
        } : function(value, isNormalized, out2) {
          var returnRGBArray = !!out2;
          !isNormalized && (value = this._normalizeData(value));
          out2 = fastLerp(value, thisOption.parsedVisual, out2);
          return returnRGBArray ? out2 : stringify(out2, "rgba");
        }, this);
      },
      _normalizedToVisual: {
        linear: function(normalized) {
          return stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
        },
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = stringify(fastLerp(normalized, this.option.parsedVisual), "rgba");
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    colorHue: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, value);
    }),
    colorSaturation: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, value);
    }),
    colorLightness: makePartialColorVisualHandler(function(color, value) {
      return modifyHSL(color, null, null, value);
    }),
    colorAlpha: makePartialColorVisualHandler(function(color, value) {
      return modifyAlpha(color, value);
    }),
    decal: {
      applyVisual: makeApplyVisual("decal"),
      _normalizedToVisual: {
        linear: null,
        category: doMapCategory,
        piecewise: null,
        fixed: null
      }
    },
    opacity: {
      applyVisual: makeApplyVisual("opacity"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    },
    liftZ: {
      applyVisual: makeApplyVisual("liftZ"),
      _normalizedToVisual: {
        linear: doMapFixed,
        category: doMapFixed,
        piecewise: doMapFixed,
        fixed: doMapFixed
      }
    },
    symbol: {
      applyVisual: function(value, getter, setter) {
        var symbolCfg = this.mapValueToVisual(value);
        setter("symbol", symbolCfg);
      },
      _normalizedToVisual: {
        linear: doMapToArray,
        category: doMapCategory,
        piecewise: function(normalized, value) {
          var result = getSpecifiedVisual.call(this, value);
          if (result == null) {
            result = doMapToArray.call(this, normalized);
          }
          return result;
        },
        fixed: doMapFixed
      }
    },
    symbolSize: {
      applyVisual: makeApplyVisual("symbolSize"),
      _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
    }
  };
  return VisualMapping2;
}();
function preprocessForPiecewise(thisOption) {
  var pieceList = thisOption.pieceList;
  thisOption.hasSpecialVisual = false;
  each$f(pieceList, function(piece, index2) {
    piece.originIndex = index2;
    if (piece.visual != null) {
      thisOption.hasSpecialVisual = true;
    }
  });
}
function preprocessForSpecifiedCategory(thisOption) {
  var categories = thisOption.categories;
  var categoryMap = thisOption.categoryMap = {};
  var visual = thisOption.visual;
  each$c(categories, function(cate, index2) {
    categoryMap[cate] = index2;
  });
  if (!isArray$1(visual)) {
    var visualArr_1 = [];
    if (isObject$4(visual)) {
      each$c(visual, function(v4, cate) {
        var index2 = categoryMap[cate];
        visualArr_1[index2 != null ? index2 : CATEGORY_DEFAULT_VISUAL_INDEX] = v4;
      });
    } else {
      visualArr_1[CATEGORY_DEFAULT_VISUAL_INDEX] = visual;
    }
    visual = setVisualToOption(thisOption, visualArr_1);
  }
  for (var i = categories.length - 1; i >= 0; i--) {
    if (visual[i] == null) {
      delete categoryMap[categories[i]];
      categories.pop();
    }
  }
}
function normalizeVisualRange(thisOption, isCategory2) {
  var visual = thisOption.visual;
  var visualArr = [];
  if (isObject$4(visual)) {
    each$c(visual, function(v4) {
      visualArr.push(v4);
    });
  } else if (visual != null) {
    visualArr.push(visual);
  }
  var doNotNeedPair = {
    color: 1,
    symbol: 1
  };
  if (!isCategory2 && visualArr.length === 1 && !doNotNeedPair.hasOwnProperty(thisOption.type)) {
    visualArr[1] = visualArr[0];
  }
  setVisualToOption(thisOption, visualArr);
}
function makePartialColorVisualHandler(applyValue) {
  return {
    applyVisual: function(value, getter, setter) {
      var colorChannel = this.mapValueToVisual(value);
      setter("color", applyValue(getter("color"), colorChannel));
    },
    _normalizedToVisual: createNormalizedToNumericVisual([0, 1])
  };
}
function doMapToArray(normalized) {
  var visual = this.option.visual;
  return visual[Math.round(linearMap$2(normalized, [0, 1], [0, visual.length - 1], true))] || {};
}
function makeApplyVisual(visualType) {
  return function(value, getter, setter) {
    setter(visualType, this.mapValueToVisual(value));
  };
}
function doMapCategory(normalized) {
  var visual = this.option.visual;
  return visual[this.option.loop && normalized !== CATEGORY_DEFAULT_VISUAL_INDEX ? normalized % visual.length : normalized];
}
function doMapFixed() {
  return this.option.visual[0];
}
function createNormalizedToNumericVisual(sourceExtent) {
  return {
    linear: function(normalized) {
      return linearMap$2(normalized, sourceExtent, this.option.visual, true);
    },
    category: doMapCategory,
    piecewise: function(normalized, value) {
      var result = getSpecifiedVisual.call(this, value);
      if (result == null) {
        result = linearMap$2(normalized, sourceExtent, this.option.visual, true);
      }
      return result;
    },
    fixed: doMapFixed
  };
}
function getSpecifiedVisual(value) {
  var thisOption = this.option;
  var pieceList = thisOption.pieceList;
  if (thisOption.hasSpecialVisual) {
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList);
    var piece = pieceList[pieceIndex];
    if (piece && piece.visual) {
      return piece.visual[this.type];
    }
  }
}
function setVisualToOption(thisOption, visualArr) {
  thisOption.visual = visualArr;
  if (thisOption.type === "color") {
    thisOption.parsedVisual = map$1(visualArr, function(item) {
      return parse(item);
    });
  }
  return visualArr;
}
var normalizers = {
  linear: function(value) {
    return linearMap$2(value, this.option.dataExtent, [0, 1], true);
  },
  piecewise: function(value) {
    var pieceList = this.option.pieceList;
    var pieceIndex = VisualMapping.findPieceIndex(value, pieceList, true);
    if (pieceIndex != null) {
      return linearMap$2(pieceIndex, [0, pieceList.length - 1], [0, 1], true);
    }
  },
  category: function(value) {
    var index2 = this.option.categories ? this.option.categoryMap[value] : value;
    return index2 == null ? CATEGORY_DEFAULT_VISUAL_INDEX : index2;
  },
  fixed: noop
};
function littleThan(close, a, b2) {
  return close ? a <= b2 : a < b2;
}
var VisualMapping$1 = VisualMapping;
var ITEM_STYLE_NORMAL = "itemStyle";
var inner$c = makeInner();
var treemapVisual = {
  seriesType: "treemap",
  reset: function(seriesModel) {
    var tree = seriesModel.getData().tree;
    var root2 = tree.root;
    if (root2.isRemoved()) {
      return;
    }
    travelTree(root2, {}, seriesModel.getViewRoot().getAncestors(), seriesModel);
  }
};
function travelTree(node, designatedVisual, viewRootAncestors, seriesModel) {
  var nodeModel = node.getModel();
  var nodeLayout = node.getLayout();
  var data = node.hostTree.data;
  if (!nodeLayout || nodeLayout.invisible || !nodeLayout.isInView) {
    return;
  }
  var nodeItemStyleModel = nodeModel.getModel(ITEM_STYLE_NORMAL);
  var visuals = buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel);
  var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
  var borderColor = nodeItemStyleModel.get("borderColor");
  var borderColorSaturation = nodeItemStyleModel.get("borderColorSaturation");
  var thisNodeColor;
  if (borderColorSaturation != null) {
    thisNodeColor = calculateColor(visuals);
    borderColor = calculateBorderColor(borderColorSaturation, thisNodeColor);
  }
  existsStyle.stroke = borderColor;
  var viewChildren = node.viewChildren;
  if (!viewChildren || !viewChildren.length) {
    thisNodeColor = calculateColor(visuals);
    existsStyle.fill = thisNodeColor;
  } else {
    var mapping_1 = buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren);
    each$f(viewChildren, function(child, index2) {
      if (child.depth >= viewRootAncestors.length || child === viewRootAncestors[child.depth]) {
        var childVisual = mapVisual$1(nodeModel, visuals, child, index2, mapping_1, seriesModel);
        travelTree(child, childVisual, viewRootAncestors, seriesModel);
      }
    });
  }
}
function buildVisuals(nodeItemStyleModel, designatedVisual, seriesModel) {
  var visuals = extend({}, designatedVisual);
  var designatedVisualItemStyle = seriesModel.designatedVisualItemStyle;
  each$f(["color", "colorAlpha", "colorSaturation"], function(visualName) {
    designatedVisualItemStyle[visualName] = designatedVisual[visualName];
    var val = nodeItemStyleModel.get(visualName);
    designatedVisualItemStyle[visualName] = null;
    val != null && (visuals[visualName] = val);
  });
  return visuals;
}
function calculateColor(visuals) {
  var color = getValueVisualDefine(visuals, "color");
  if (color) {
    var colorAlpha = getValueVisualDefine(visuals, "colorAlpha");
    var colorSaturation = getValueVisualDefine(visuals, "colorSaturation");
    if (colorSaturation) {
      color = modifyHSL(color, null, null, colorSaturation);
    }
    if (colorAlpha) {
      color = modifyAlpha(color, colorAlpha);
    }
    return color;
  }
}
function calculateBorderColor(borderColorSaturation, thisNodeColor) {
  return thisNodeColor != null ? modifyHSL(thisNodeColor, null, null, borderColorSaturation) : null;
}
function getValueVisualDefine(visuals, name) {
  var value = visuals[name];
  if (value != null && value !== "none") {
    return value;
  }
}
function buildVisualMapping(node, nodeModel, nodeLayout, nodeItemStyleModel, visuals, viewChildren) {
  if (!viewChildren || !viewChildren.length) {
    return;
  }
  var rangeVisual = getRangeVisual(nodeModel, "color") || visuals.color != null && visuals.color !== "none" && (getRangeVisual(nodeModel, "colorAlpha") || getRangeVisual(nodeModel, "colorSaturation"));
  if (!rangeVisual) {
    return;
  }
  var visualMin = nodeModel.get("visualMin");
  var visualMax = nodeModel.get("visualMax");
  var dataExtent = nodeLayout.dataExtent.slice();
  visualMin != null && visualMin < dataExtent[0] && (dataExtent[0] = visualMin);
  visualMax != null && visualMax > dataExtent[1] && (dataExtent[1] = visualMax);
  var colorMappingBy = nodeModel.get("colorMappingBy");
  var opt = {
    type: rangeVisual.name,
    dataExtent,
    visual: rangeVisual.range
  };
  if (opt.type === "color" && (colorMappingBy === "index" || colorMappingBy === "id")) {
    opt.mappingMethod = "category";
    opt.loop = true;
  } else {
    opt.mappingMethod = "linear";
  }
  var mapping = new VisualMapping$1(opt);
  inner$c(mapping).drColorMappingBy = colorMappingBy;
  return mapping;
}
function getRangeVisual(nodeModel, name) {
  var range3 = nodeModel.get(name);
  return isArray$1(range3) && range3.length ? {
    name,
    range: range3
  } : null;
}
function mapVisual$1(nodeModel, visuals, child, index2, mapping, seriesModel) {
  var childVisuals = extend({}, visuals);
  if (mapping) {
    var mappingType = mapping.type;
    var colorMappingBy = mappingType === "color" && inner$c(mapping).drColorMappingBy;
    var value = colorMappingBy === "index" ? index2 : colorMappingBy === "id" ? seriesModel.mapIdToIndex(child.getId()) : child.getValue(nodeModel.get("visualDimension"));
    childVisuals[mappingType] = mapping.mapValueToVisual(value);
  }
  return childVisuals;
}
var mathMax$3 = Math.max;
var mathMin$3 = Math.min;
var retrieveValue = retrieve;
var each$b = each$f;
var PATH_BORDER_WIDTH = ["itemStyle", "borderWidth"];
var PATH_GAP_WIDTH = ["itemStyle", "gapWidth"];
var PATH_UPPER_LABEL_SHOW = ["upperLabel", "show"];
var PATH_UPPER_LABEL_HEIGHT = ["upperLabel", "height"];
var treemapLayout = {
  seriesType: "treemap",
  reset: function(seriesModel, ecModel, api, payload) {
    var ecWidth = api.getWidth();
    var ecHeight = api.getHeight();
    var seriesOption = seriesModel.option;
    var layoutInfo = getLayoutRect(seriesModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    var size = seriesOption.size || [];
    var containerWidth = parsePercent(retrieveValue(layoutInfo.width, size[0]), ecWidth);
    var containerHeight = parsePercent(retrieveValue(layoutInfo.height, size[1]), ecHeight);
    var payloadType = payload && payload.type;
    var types2 = ["treemapZoomToNode", "treemapRootToNode"];
    var targetInfo = retrieveTargetInfo(payload, types2, seriesModel);
    var rootRect = payloadType === "treemapRender" || payloadType === "treemapMove" ? payload.rootRect : null;
    var viewRoot = seriesModel.getViewRoot();
    var viewAbovePath = getPathToRoot(viewRoot);
    if (payloadType !== "treemapMove") {
      var rootSize = payloadType === "treemapZoomToNode" ? estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) : rootRect ? [rootRect.width, rootRect.height] : [containerWidth, containerHeight];
      var sort_1 = seriesOption.sort;
      if (sort_1 && sort_1 !== "asc" && sort_1 !== "desc") {
        sort_1 = "desc";
      }
      var options = {
        squareRatio: seriesOption.squareRatio,
        sort: sort_1,
        leafDepth: seriesOption.leafDepth
      };
      viewRoot.hostTree.clearLayouts();
      var viewRootLayout_1 = {
        x: 0,
        y: 0,
        width: rootSize[0],
        height: rootSize[1],
        area: rootSize[0] * rootSize[1]
      };
      viewRoot.setLayout(viewRootLayout_1);
      squarify(viewRoot, options, false, 0);
      viewRootLayout_1 = viewRoot.getLayout();
      each$b(viewAbovePath, function(node, index2) {
        var childValue = (viewAbovePath[index2 + 1] || viewRoot).getValue();
        node.setLayout(extend({
          dataExtent: [childValue, childValue],
          borderWidth: 0,
          upperHeight: 0
        }, viewRootLayout_1));
      });
    }
    var treeRoot = seriesModel.getData().tree.root;
    treeRoot.setLayout(calculateRootPosition(layoutInfo, rootRect, targetInfo), true);
    seriesModel.setLayoutInfo(layoutInfo);
    prunning(treeRoot, new BoundingRect$1(-layoutInfo.x, -layoutInfo.y, ecWidth, ecHeight), viewAbovePath, viewRoot, 0);
  }
};
function squarify(node, options, hideChildren, depth) {
  var width;
  var height;
  if (node.isRemoved()) {
    return;
  }
  var thisLayout = node.getLayout();
  width = thisLayout.width;
  height = thisLayout.height;
  var nodeModel = node.getModel();
  var borderWidth = nodeModel.get(PATH_BORDER_WIDTH);
  var halfGapWidth = nodeModel.get(PATH_GAP_WIDTH) / 2;
  var upperLabelHeight = getUpperLabelHeight(nodeModel);
  var upperHeight = Math.max(borderWidth, upperLabelHeight);
  var layoutOffset = borderWidth - halfGapWidth;
  var layoutOffsetUpper = upperHeight - halfGapWidth;
  node.setLayout({
    borderWidth,
    upperHeight,
    upperLabelHeight
  }, true);
  width = mathMax$3(width - 2 * layoutOffset, 0);
  height = mathMax$3(height - layoutOffset - layoutOffsetUpper, 0);
  var totalArea = width * height;
  var viewChildren = initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth);
  if (!viewChildren.length) {
    return;
  }
  var rect = {
    x: layoutOffset,
    y: layoutOffsetUpper,
    width,
    height
  };
  var rowFixedLength = mathMin$3(width, height);
  var best = Infinity;
  var row = [];
  row.area = 0;
  for (var i = 0, len2 = viewChildren.length; i < len2; ) {
    var child = viewChildren[i];
    row.push(child);
    row.area += child.getLayout().area;
    var score = worst(row, rowFixedLength, options.squareRatio);
    if (score <= best) {
      i++;
      best = score;
    } else {
      row.area -= row.pop().getLayout().area;
      position(row, rowFixedLength, rect, halfGapWidth, false);
      rowFixedLength = mathMin$3(rect.width, rect.height);
      row.length = row.area = 0;
      best = Infinity;
    }
  }
  if (row.length) {
    position(row, rowFixedLength, rect, halfGapWidth, true);
  }
  if (!hideChildren) {
    var childrenVisibleMin = nodeModel.get("childrenVisibleMin");
    if (childrenVisibleMin != null && totalArea < childrenVisibleMin) {
      hideChildren = true;
    }
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    squarify(viewChildren[i], options, hideChildren, depth + 1);
  }
}
function initChildren$1(node, nodeModel, totalArea, options, hideChildren, depth) {
  var viewChildren = node.children || [];
  var orderBy = options.sort;
  orderBy !== "asc" && orderBy !== "desc" && (orderBy = null);
  var overLeafDepth = options.leafDepth != null && options.leafDepth <= depth;
  if (hideChildren && !overLeafDepth) {
    return node.viewChildren = [];
  }
  viewChildren = filter(viewChildren, function(child) {
    return !child.isRemoved();
  });
  sort$1(viewChildren, orderBy);
  var info = statistic(nodeModel, viewChildren, orderBy);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  info.sum = filterByThreshold(nodeModel, totalArea, info.sum, orderBy, viewChildren);
  if (info.sum === 0) {
    return node.viewChildren = [];
  }
  for (var i = 0, len2 = viewChildren.length; i < len2; i++) {
    var area = viewChildren[i].getValue() / info.sum * totalArea;
    viewChildren[i].setLayout({
      area
    });
  }
  if (overLeafDepth) {
    viewChildren.length && node.setLayout({
      isLeafRoot: true
    }, true);
    viewChildren.length = 0;
  }
  node.viewChildren = viewChildren;
  node.setLayout({
    dataExtent: info.dataExtent
  }, true);
  return viewChildren;
}
function filterByThreshold(nodeModel, totalArea, sum2, orderBy, orderedChildren) {
  if (!orderBy) {
    return sum2;
  }
  var visibleMin = nodeModel.get("visibleMin");
  var len2 = orderedChildren.length;
  var deletePoint = len2;
  for (var i = len2 - 1; i >= 0; i--) {
    var value = orderedChildren[orderBy === "asc" ? len2 - i - 1 : i].getValue();
    if (value / sum2 * totalArea < visibleMin) {
      deletePoint = i;
      sum2 -= value;
    }
  }
  orderBy === "asc" ? orderedChildren.splice(0, len2 - deletePoint) : orderedChildren.splice(deletePoint, len2 - deletePoint);
  return sum2;
}
function sort$1(viewChildren, orderBy) {
  if (orderBy) {
    viewChildren.sort(function(a, b2) {
      var diff = orderBy === "asc" ? a.getValue() - b2.getValue() : b2.getValue() - a.getValue();
      return diff === 0 ? orderBy === "asc" ? a.dataIndex - b2.dataIndex : b2.dataIndex - a.dataIndex : diff;
    });
  }
  return viewChildren;
}
function statistic(nodeModel, children, orderBy) {
  var sum2 = 0;
  for (var i = 0, len2 = children.length; i < len2; i++) {
    sum2 += children[i].getValue();
  }
  var dimension = nodeModel.get("visualDimension");
  var dataExtent;
  if (!children || !children.length) {
    dataExtent = [NaN, NaN];
  } else if (dimension === "value" && orderBy) {
    dataExtent = [children[children.length - 1].getValue(), children[0].getValue()];
    orderBy === "asc" && dataExtent.reverse();
  } else {
    dataExtent = [Infinity, -Infinity];
    each$b(children, function(child) {
      var value = child.getValue(dimension);
      value < dataExtent[0] && (dataExtent[0] = value);
      value > dataExtent[1] && (dataExtent[1] = value);
    });
  }
  return {
    sum: sum2,
    dataExtent
  };
}
function worst(row, rowFixedLength, ratio) {
  var areaMax = 0;
  var areaMin = Infinity;
  for (var i = 0, area = void 0, len2 = row.length; i < len2; i++) {
    area = row[i].getLayout().area;
    if (area) {
      area < areaMin && (areaMin = area);
      area > areaMax && (areaMax = area);
    }
  }
  var squareArea = row.area * row.area;
  var f2 = rowFixedLength * rowFixedLength * ratio;
  return squareArea ? mathMax$3(f2 * areaMax / squareArea, squareArea / (f2 * areaMin)) : Infinity;
}
function position(row, rowFixedLength, rect, halfGapWidth, flush) {
  var idx0WhenH = rowFixedLength === rect.width ? 0 : 1;
  var idx1WhenH = 1 - idx0WhenH;
  var xy = ["x", "y"];
  var wh = ["width", "height"];
  var last = rect[xy[idx0WhenH]];
  var rowOtherLength = rowFixedLength ? row.area / rowFixedLength : 0;
  if (flush || rowOtherLength > rect[wh[idx1WhenH]]) {
    rowOtherLength = rect[wh[idx1WhenH]];
  }
  for (var i = 0, rowLen = row.length; i < rowLen; i++) {
    var node = row[i];
    var nodeLayout = {};
    var step = rowOtherLength ? node.getLayout().area / rowOtherLength : 0;
    var wh1 = nodeLayout[wh[idx1WhenH]] = mathMax$3(rowOtherLength - 2 * halfGapWidth, 0);
    var remain = rect[xy[idx0WhenH]] + rect[wh[idx0WhenH]] - last;
    var modWH = i === rowLen - 1 || remain < step ? remain : step;
    var wh0 = nodeLayout[wh[idx0WhenH]] = mathMax$3(modWH - 2 * halfGapWidth, 0);
    nodeLayout[xy[idx1WhenH]] = rect[xy[idx1WhenH]] + mathMin$3(halfGapWidth, wh1 / 2);
    nodeLayout[xy[idx0WhenH]] = last + mathMin$3(halfGapWidth, wh0 / 2);
    last += modWH;
    node.setLayout(nodeLayout, true);
  }
  rect[xy[idx1WhenH]] += rowOtherLength;
  rect[wh[idx1WhenH]] -= rowOtherLength;
}
function estimateRootSize(seriesModel, targetInfo, viewRoot, containerWidth, containerHeight) {
  var currNode = (targetInfo || {}).node;
  var defaultSize = [containerWidth, containerHeight];
  if (!currNode || currNode === viewRoot) {
    return defaultSize;
  }
  var parent;
  var viewArea = containerWidth * containerHeight;
  var area = viewArea * seriesModel.option.zoomToNodeRatio;
  while (parent = currNode.parentNode) {
    var sum2 = 0;
    var siblings = parent.children;
    for (var i = 0, len2 = siblings.length; i < len2; i++) {
      sum2 += siblings[i].getValue();
    }
    var currNodeValue = currNode.getValue();
    if (currNodeValue === 0) {
      return defaultSize;
    }
    area *= sum2 / currNodeValue;
    var parentModel = parent.getModel();
    var borderWidth = parentModel.get(PATH_BORDER_WIDTH);
    var upperHeight = Math.max(borderWidth, getUpperLabelHeight(parentModel));
    area += 4 * borderWidth * borderWidth + (3 * borderWidth + upperHeight) * Math.pow(area, 0.5);
    area > MAX_SAFE_INTEGER && (area = MAX_SAFE_INTEGER);
    currNode = parent;
  }
  area < viewArea && (area = viewArea);
  var scale2 = Math.pow(area / viewArea, 0.5);
  return [containerWidth * scale2, containerHeight * scale2];
}
function calculateRootPosition(layoutInfo, rootRect, targetInfo) {
  if (rootRect) {
    return {
      x: rootRect.x,
      y: rootRect.y
    };
  }
  var defaultPosition = {
    x: 0,
    y: 0
  };
  if (!targetInfo) {
    return defaultPosition;
  }
  var targetNode = targetInfo.node;
  var layout2 = targetNode.getLayout();
  if (!layout2) {
    return defaultPosition;
  }
  var targetCenter = [layout2.width / 2, layout2.height / 2];
  var node = targetNode;
  while (node) {
    var nodeLayout = node.getLayout();
    targetCenter[0] += nodeLayout.x;
    targetCenter[1] += nodeLayout.y;
    node = node.parentNode;
  }
  return {
    x: layoutInfo.width / 2 - targetCenter[0],
    y: layoutInfo.height / 2 - targetCenter[1]
  };
}
function prunning(node, clipRect, viewAbovePath, viewRoot, depth) {
  var nodeLayout = node.getLayout();
  var nodeInViewAbovePath = viewAbovePath[depth];
  var isAboveViewRoot = nodeInViewAbovePath && nodeInViewAbovePath === node;
  if (nodeInViewAbovePath && !isAboveViewRoot || depth === viewAbovePath.length && node !== viewRoot) {
    return;
  }
  node.setLayout({
    isInView: true,
    invisible: !isAboveViewRoot && !clipRect.intersect(nodeLayout),
    isAboveViewRoot
  }, true);
  var childClipRect = new BoundingRect$1(clipRect.x - nodeLayout.x, clipRect.y - nodeLayout.y, clipRect.width, clipRect.height);
  each$b(node.viewChildren || [], function(child) {
    prunning(child, childClipRect, viewAbovePath, viewRoot, depth + 1);
  });
}
function getUpperLabelHeight(model) {
  return model.get(PATH_UPPER_LABEL_SHOW) ? model.get(PATH_UPPER_LABEL_HEIGHT) : 0;
}
function install$G(registers) {
  registers.registerSeriesModel(TreemapSeriesModel$1);
  registers.registerChartView(TreemapView$1);
  registers.registerVisual(treemapVisual);
  registers.registerLayout(treemapLayout);
  installTreemapAction(registers);
}
function categoryFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (!legendModels || !legendModels.length) {
    return;
  }
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var categoriesData = graphSeries.getCategoriesData();
    var graph = graphSeries.getGraph();
    var data = graph.data;
    var categoryNames = categoriesData.mapArray(categoriesData.getName);
    data.filterSelf(function(idx) {
      var model = data.getItemModel(idx);
      var category = model.getShallow("category");
      if (category != null) {
        if (isNumber(category)) {
          category = categoryNames[category];
        }
        for (var i = 0; i < legendModels.length; i++) {
          if (!legendModels[i].isSelected(category)) {
            return false;
          }
        }
      }
      return true;
    });
  });
}
function categoryVisual(ecModel) {
  var paletteScope = {};
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var categoriesData = seriesModel.getCategoriesData();
    var data = seriesModel.getData();
    var categoryNameIdxMap = {};
    categoriesData.each(function(idx) {
      var name = categoriesData.getName(idx);
      categoryNameIdxMap["ec-" + name] = idx;
      var itemModel = categoriesData.getItemModel(idx);
      var style = itemModel.getModel("itemStyle").getItemStyle();
      if (!style.fill) {
        style.fill = seriesModel.getColorFromPalette(name, paletteScope);
      }
      categoriesData.setItemVisual(idx, "style", style);
      var symbolVisualList = ["symbol", "symbolSize", "symbolKeepAspect"];
      for (var i = 0; i < symbolVisualList.length; i++) {
        var symbolVisual = itemModel.getShallow(symbolVisualList[i], true);
        if (symbolVisual != null) {
          categoriesData.setItemVisual(idx, symbolVisualList[i], symbolVisual);
        }
      }
    });
    if (categoriesData.count()) {
      data.each(function(idx) {
        var model = data.getItemModel(idx);
        var categoryIdx = model.getShallow("category");
        if (categoryIdx != null) {
          if (isString(categoryIdx)) {
            categoryIdx = categoryNameIdxMap["ec-" + categoryIdx];
          }
          var categoryStyle = categoriesData.getItemVisual(categoryIdx, "style");
          var style = data.ensureUniqueItemVisual(idx, "style");
          extend(style, categoryStyle);
          var visualList = ["symbol", "symbolSize", "symbolKeepAspect"];
          for (var i = 0; i < visualList.length; i++) {
            data.setItemVisual(idx, visualList[i], categoriesData.getItemVisual(categoryIdx, visualList[i]));
          }
        }
      });
    }
  });
}
function normalize$2(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
function graphEdgeVisual(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var edgeData = seriesModel.getEdgeData();
    var symbolType = normalize$2(seriesModel.get("edgeSymbol"));
    var symbolSize = normalize$2(seriesModel.get("edgeSymbolSize"));
    edgeData.setVisual("fromSymbol", symbolType && symbolType[0]);
    edgeData.setVisual("toSymbol", symbolType && symbolType[1]);
    edgeData.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    edgeData.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    edgeData.setVisual("style", seriesModel.getModel("lineStyle").getLineStyle());
    edgeData.each(function(idx) {
      var itemModel = edgeData.getItemModel(idx);
      var edge = graph.getEdgeByIndex(idx);
      var symbolType2 = normalize$2(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$2(itemModel.getShallow("symbolSize", true));
      var style = itemModel.getModel("lineStyle").getLineStyle();
      var existsStyle = edgeData.ensureUniqueItemVisual(idx, "style");
      extend(existsStyle, style);
      switch (existsStyle.stroke) {
        case "source": {
          var nodeStyle = edge.node1.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
        case "target": {
          var nodeStyle = edge.node2.getVisual("style");
          existsStyle.stroke = nodeStyle && nodeStyle.fill;
          break;
        }
      }
      symbolType2[0] && edge.setVisual("fromSymbol", symbolType2[0]);
      symbolType2[1] && edge.setVisual("toSymbol", symbolType2[1]);
      symbolSize2[0] && edge.setVisual("fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && edge.setVisual("toSymbolSize", symbolSize2[1]);
    });
  });
}
var KEY_DELIMITER = "-->";
var getAutoCurvenessParams = function(seriesModel) {
  return seriesModel.get("autoCurveness") || null;
};
var createCurveness = function(seriesModel, appendLength) {
  var autoCurvenessParmas = getAutoCurvenessParams(seriesModel);
  var length = 20;
  var curvenessList = [];
  if (isNumber(autoCurvenessParmas)) {
    length = autoCurvenessParmas;
  } else if (isArray$1(autoCurvenessParmas)) {
    seriesModel.__curvenessList = autoCurvenessParmas;
    return;
  }
  if (appendLength > length) {
    length = appendLength;
  }
  var len2 = length % 2 ? length + 2 : length + 3;
  curvenessList = [];
  for (var i = 0; i < len2; i++) {
    curvenessList.push((i % 2 ? i + 1 : i) / 10 * (i % 2 ? -1 : 1));
  }
  seriesModel.__curvenessList = curvenessList;
};
var getKeyOfEdges = function(n1, n2, seriesModel) {
  var source = [n1.id, n1.dataIndex].join(".");
  var target = [n2.id, n2.dataIndex].join(".");
  return [seriesModel.uid, source, target].join(KEY_DELIMITER);
};
var getOppositeKey = function(key) {
  var keys2 = key.split(KEY_DELIMITER);
  return [keys2[0], keys2[2], keys2[1]].join(KEY_DELIMITER);
};
var getEdgeFromMap = function(edge, seriesModel) {
  var key = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  return seriesModel.__edgeMap[key];
};
var getTotalLengthBetweenNodes = function(edge, seriesModel) {
  var len2 = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node1, edge.node2, seriesModel), seriesModel);
  var lenV = getEdgeMapLengthWithKey(getKeyOfEdges(edge.node2, edge.node1, seriesModel), seriesModel);
  return len2 + lenV;
};
var getEdgeMapLengthWithKey = function(key, seriesModel) {
  var edgeMap = seriesModel.__edgeMap;
  return edgeMap[key] ? edgeMap[key].length : 0;
};
function initCurvenessList(seriesModel) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  seriesModel.__curvenessList = [];
  seriesModel.__edgeMap = {};
  createCurveness(seriesModel);
}
function createEdgeMapForCurveness(n1, n2, seriesModel, index2) {
  if (!getAutoCurvenessParams(seriesModel)) {
    return;
  }
  var key = getKeyOfEdges(n1, n2, seriesModel);
  var edgeMap = seriesModel.__edgeMap;
  var oppositeEdges = edgeMap[getOppositeKey(key)];
  if (edgeMap[key] && !oppositeEdges) {
    edgeMap[key].isForward = true;
  } else if (oppositeEdges && edgeMap[key]) {
    oppositeEdges.isForward = true;
    edgeMap[key].isForward = false;
  }
  edgeMap[key] = edgeMap[key] || [];
  edgeMap[key].push(index2);
}
function getCurvenessForEdge(edge, seriesModel, index2, needReverse) {
  var autoCurvenessParams = getAutoCurvenessParams(seriesModel);
  var isArrayParam = isArray$1(autoCurvenessParams);
  if (!autoCurvenessParams) {
    return null;
  }
  var edgeArray = getEdgeFromMap(edge, seriesModel);
  if (!edgeArray) {
    return null;
  }
  var edgeIndex = -1;
  for (var i = 0; i < edgeArray.length; i++) {
    if (edgeArray[i] === index2) {
      edgeIndex = i;
      break;
    }
  }
  var totalLen = getTotalLengthBetweenNodes(edge, seriesModel);
  createCurveness(seriesModel, totalLen);
  edge.lineStyle = edge.lineStyle || {};
  var curKey = getKeyOfEdges(edge.node1, edge.node2, seriesModel);
  var curvenessList = seriesModel.__curvenessList;
  var parityCorrection = isArrayParam ? 0 : totalLen % 2 ? 0 : 1;
  if (!edgeArray.isForward) {
    var oppositeKey = getOppositeKey(curKey);
    var len2 = getEdgeMapLengthWithKey(oppositeKey, seriesModel);
    var resValue = curvenessList[edgeIndex + len2 + parityCorrection];
    if (needReverse) {
      if (isArrayParam) {
        if (autoCurvenessParams && autoCurvenessParams[0] === 0) {
          return (len2 + parityCorrection) % 2 ? resValue : -resValue;
        } else {
          return ((len2 % 2 ? 0 : 1) + parityCorrection) % 2 ? resValue : -resValue;
        }
      } else {
        return (len2 + parityCorrection) % 2 ? resValue : -resValue;
      }
    } else {
      return curvenessList[edgeIndex + len2 + parityCorrection];
    }
  } else {
    return curvenessList[parityCorrection + edgeIndex];
  }
}
function simpleLayout(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var graph = seriesModel.getGraph();
  graph.eachNode(function(node) {
    var model = node.getModel();
    node.setLayout([+model.get("x"), +model.get("y")]);
  });
  simpleLayoutEdge(graph, seriesModel);
}
function simpleLayoutEdge(graph, seriesModel) {
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, seriesModel, index2, true), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var points2 = [p1, p2];
    if (+curveness) {
      points2.push([(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * curveness]);
    }
    edge.setLayout(points2);
  });
}
function graphSimpleLayout(ecModel, api) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var layout2 = seriesModel.get("layout");
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      var data_1 = seriesModel.getData();
      var dimensions_1 = [];
      each$f(coordSys.dimensions, function(coordDim) {
        dimensions_1 = dimensions_1.concat(data_1.mapDimensionsAll(coordDim));
      });
      for (var dataIndex = 0; dataIndex < data_1.count(); dataIndex++) {
        var value = [];
        var hasValue = false;
        for (var i = 0; i < dimensions_1.length; i++) {
          var val = data_1.get(dimensions_1[i], dataIndex);
          if (!isNaN(val)) {
            hasValue = true;
          }
          value.push(val);
        }
        if (hasValue) {
          data_1.setItemLayout(dataIndex, coordSys.dataToPoint(value));
        } else {
          data_1.setItemLayout(dataIndex, [NaN, NaN]);
        }
      }
      simpleLayoutEdge(data_1.graph, seriesModel);
    } else if (!layout2 || layout2 === "none") {
      simpleLayout(seriesModel);
    }
  });
}
function getNodeGlobalScale(seriesModel) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys.type !== "view") {
    return 1;
  }
  var nodeScaleRatio = seriesModel.option.nodeScaleRatio;
  var groupZoom = coordSys.scaleX;
  var roamZoom = coordSys.getZoom();
  var nodeScale = (roamZoom - 1) * nodeScaleRatio + 1;
  return nodeScale / groupZoom;
}
function getSymbolSize(node) {
  var symbolSize = node.getVisual("symbolSize");
  if (symbolSize instanceof Array) {
    symbolSize = (symbolSize[0] + symbolSize[1]) / 2;
  }
  return +symbolSize;
}
var PI$2 = Math.PI;
var _symbolRadiansHalf = [];
function circularLayout(seriesModel, basedOn) {
  var coordSys = seriesModel.coordinateSystem;
  if (coordSys && coordSys.type !== "view") {
    return;
  }
  var rect = coordSys.getBoundingRect();
  var nodeData = seriesModel.getData();
  var graph = nodeData.graph;
  var cx = rect.width / 2 + rect.x;
  var cy = rect.height / 2 + rect.y;
  var r2 = Math.min(rect.width, rect.height) / 2;
  var count2 = nodeData.count();
  nodeData.setLayout({
    cx,
    cy
  });
  if (!count2) {
    return;
  }
  _layoutNodesBasedOn[basedOn](seriesModel, graph, nodeData, r2, cx, cy, count2);
  graph.eachEdge(function(edge, index2) {
    var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), getCurvenessForEdge(edge, seriesModel, index2), 0);
    var p1 = clone$3(edge.node1.getLayout());
    var p2 = clone$3(edge.node2.getLayout());
    var cp1;
    var x12 = (p1[0] + p2[0]) / 2;
    var y12 = (p1[1] + p2[1]) / 2;
    if (+curveness) {
      curveness *= 3;
      cp1 = [cx * curveness + x12 * (1 - curveness), cy * curveness + y12 * (1 - curveness)];
    }
    edge.setLayout([p1, p2, cp1]);
  });
}
var _layoutNodesBasedOn = {
  value: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var angle = 0;
    var sum2 = nodeData.getSum("value");
    var unitAngle = Math.PI * 2 / (sum2 || count2);
    graph.eachNode(function(node) {
      var value = node.getValue("value");
      var radianHalf = unitAngle * (sum2 ? value : 1) / 2;
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  },
  symbolSize: function(seriesModel, graph, nodeData, r2, cx, cy, count2) {
    var sumRadian = 0;
    _symbolRadiansHalf.length = count2;
    var nodeScale = getNodeGlobalScale(seriesModel);
    graph.eachNode(function(node) {
      var symbolSize = getSymbolSize(node);
      isNaN(symbolSize) && (symbolSize = 2);
      symbolSize < 0 && (symbolSize = 0);
      symbolSize *= nodeScale;
      var symbolRadianHalf = Math.asin(symbolSize / 2 / r2);
      isNaN(symbolRadianHalf) && (symbolRadianHalf = PI$2 / 2);
      _symbolRadiansHalf[node.dataIndex] = symbolRadianHalf;
      sumRadian += symbolRadianHalf * 2;
    });
    var halfRemainRadian = (2 * PI$2 - sumRadian) / count2 / 2;
    var angle = 0;
    graph.eachNode(function(node) {
      var radianHalf = halfRemainRadian + _symbolRadiansHalf[node.dataIndex];
      angle += radianHalf;
      node.setLayout([r2 * Math.cos(angle) + cx, r2 * Math.sin(angle) + cy]);
      angle += radianHalf;
    });
  }
};
function graphCircularLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    if (seriesModel.get("layout") === "circular") {
      circularLayout(seriesModel, "symbolSize");
    }
  });
}
var scaleAndAdd = scaleAndAdd$1;
function forceLayout(inNodes, inEdges, opts) {
  var nodes = inNodes;
  var edges = inEdges;
  var rect = opts.rect;
  var width = rect.width;
  var height = rect.height;
  var center2 = [rect.x + width / 2, rect.y + height / 2];
  var gravity = opts.gravity == null ? 0.1 : opts.gravity;
  for (var i = 0; i < nodes.length; i++) {
    var n2 = nodes[i];
    if (!n2.p) {
      n2.p = create$2(width * (Math.random() - 0.5) + center2[0], height * (Math.random() - 0.5) + center2[1]);
    }
    n2.pp = clone$3(n2.p);
    n2.edges = null;
  }
  var initialFriction = opts.friction == null ? 0.6 : opts.friction;
  var friction = initialFriction;
  var beforeStepCallback;
  var afterStepCallback;
  return {
    warmUp: function() {
      friction = initialFriction * 0.8;
    },
    setFixed: function(idx) {
      nodes[idx].fixed = true;
    },
    setUnfixed: function(idx) {
      nodes[idx].fixed = false;
    },
    beforeStep: function(cb) {
      beforeStepCallback = cb;
    },
    afterStep: function(cb) {
      afterStepCallback = cb;
    },
    step: function(cb) {
      beforeStepCallback && beforeStepCallback(nodes, edges);
      var v12 = [];
      var nLen = nodes.length;
      for (var i2 = 0; i2 < edges.length; i2++) {
        var e2 = edges[i2];
        if (e2.ignoreForceLayout) {
          continue;
        }
        var n1 = e2.n1;
        var n22 = e2.n2;
        sub(v12, n22.p, n1.p);
        var d2 = len(v12) - e2.d;
        var w2 = n22.w / (n1.w + n22.w);
        if (isNaN(w2)) {
          w2 = 0;
        }
        normalize$4(v12, v12);
        !n1.fixed && scaleAndAdd(n1.p, n1.p, v12, w2 * d2 * friction);
        !n22.fixed && scaleAndAdd(n22.p, n22.p, v12, -(1 - w2) * d2 * friction);
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v12, center2, n3.p);
          scaleAndAdd(n3.p, n3.p, v12, gravity * friction);
        }
      }
      for (var i2 = 0; i2 < nLen; i2++) {
        var n1 = nodes[i2];
        for (var j = i2 + 1; j < nLen; j++) {
          var n22 = nodes[j];
          sub(v12, n22.p, n1.p);
          var d2 = len(v12);
          if (d2 === 0) {
            set$2(v12, Math.random() - 0.5, Math.random() - 0.5);
            d2 = 1;
          }
          var repFact = (n1.rep + n22.rep) / d2 / d2;
          !n1.fixed && scaleAndAdd(n1.pp, n1.pp, v12, repFact);
          !n22.fixed && scaleAndAdd(n22.pp, n22.pp, v12, -repFact);
        }
      }
      var v4 = [];
      for (var i2 = 0; i2 < nLen; i2++) {
        var n3 = nodes[i2];
        if (!n3.fixed) {
          sub(v4, n3.p, n3.pp);
          scaleAndAdd(n3.p, n3.p, v4, friction);
          copy$1(n3.pp, n3.p);
        }
      }
      friction = friction * 0.992;
      var finished = friction < 0.01;
      afterStepCallback && afterStepCallback(nodes, edges, finished);
      cb && cb(finished);
    }
  };
}
function graphForceLayout(ecModel) {
  ecModel.eachSeriesByType("graph", function(graphSeries) {
    var coordSys = graphSeries.coordinateSystem;
    if (coordSys && coordSys.type !== "view") {
      return;
    }
    if (graphSeries.get("layout") === "force") {
      var preservedPoints_1 = graphSeries.preservedPoints || {};
      var graph_1 = graphSeries.getGraph();
      var nodeData_1 = graph_1.data;
      var edgeData = graph_1.edgeData;
      var forceModel = graphSeries.getModel("force");
      var initLayout = forceModel.get("initLayout");
      if (graphSeries.preservedPoints) {
        nodeData_1.each(function(idx) {
          var id2 = nodeData_1.getId(idx);
          nodeData_1.setItemLayout(idx, preservedPoints_1[id2] || [NaN, NaN]);
        });
      } else if (!initLayout || initLayout === "none") {
        simpleLayout(graphSeries);
      } else if (initLayout === "circular") {
        circularLayout(graphSeries, "value");
      }
      var nodeDataExtent_1 = nodeData_1.getDataExtent("value");
      var edgeDataExtent_1 = edgeData.getDataExtent("value");
      var repulsion = forceModel.get("repulsion");
      var edgeLength = forceModel.get("edgeLength");
      var repulsionArr_1 = isArray$1(repulsion) ? repulsion : [repulsion, repulsion];
      var edgeLengthArr_1 = isArray$1(edgeLength) ? edgeLength : [edgeLength, edgeLength];
      edgeLengthArr_1 = [edgeLengthArr_1[1], edgeLengthArr_1[0]];
      var nodes_1 = nodeData_1.mapArray("value", function(value, idx) {
        var point = nodeData_1.getItemLayout(idx);
        var rep = linearMap$2(value, nodeDataExtent_1, repulsionArr_1);
        if (isNaN(rep)) {
          rep = (repulsionArr_1[0] + repulsionArr_1[1]) / 2;
        }
        return {
          w: rep,
          rep,
          fixed: nodeData_1.getItemModel(idx).get("fixed"),
          p: !point || isNaN(point[0]) || isNaN(point[1]) ? null : point
        };
      });
      var edges = edgeData.mapArray("value", function(value, idx) {
        var edge = graph_1.getEdgeByIndex(idx);
        var d2 = linearMap$2(value, edgeDataExtent_1, edgeLengthArr_1);
        if (isNaN(d2)) {
          d2 = (edgeLengthArr_1[0] + edgeLengthArr_1[1]) / 2;
        }
        var edgeModel = edge.getModel();
        var curveness = retrieve3(edge.getModel().get(["lineStyle", "curveness"]), -getCurvenessForEdge(edge, graphSeries, idx, true), 0);
        return {
          n1: nodes_1[edge.node1.dataIndex],
          n2: nodes_1[edge.node2.dataIndex],
          d: d2,
          curveness,
          ignoreForceLayout: edgeModel.get("ignoreForceLayout")
        };
      });
      var rect = coordSys.getBoundingRect();
      var forceInstance = forceLayout(nodes_1, edges, {
        rect,
        gravity: forceModel.get("gravity"),
        friction: forceModel.get("friction")
      });
      forceInstance.beforeStep(function(nodes, edges2) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (nodes[i].fixed) {
            copy$1(nodes[i].p, graph_1.getNodeByIndex(i).getLayout());
          }
        }
      });
      forceInstance.afterStep(function(nodes, edges2, stopped) {
        for (var i = 0, l2 = nodes.length; i < l2; i++) {
          if (!nodes[i].fixed) {
            graph_1.getNodeByIndex(i).setLayout(nodes[i].p);
          }
          preservedPoints_1[nodeData_1.getId(i)] = nodes[i].p;
        }
        for (var i = 0, l2 = edges2.length; i < l2; i++) {
          var e2 = edges2[i];
          var edge = graph_1.getEdgeByIndex(i);
          var p1 = e2.n1.p;
          var p2 = e2.n2.p;
          var points2 = edge.getLayout();
          points2 = points2 ? points2.slice() : [];
          points2[0] = points2[0] || [];
          points2[1] = points2[1] || [];
          copy$1(points2[0], p1);
          copy$1(points2[1], p2);
          if (+e2.curveness) {
            points2[2] = [(p1[0] + p2[0]) / 2 - (p1[1] - p2[1]) * e2.curveness, (p1[1] + p2[1]) / 2 - (p2[0] - p1[0]) * e2.curveness];
          }
          edge.setLayout(points2);
        }
      });
      graphSeries.forceLayout = forceInstance;
      graphSeries.preservedPoints = preservedPoints_1;
      forceInstance.step();
    } else {
      graphSeries.forceLayout = null;
    }
  });
}
function getViewRect$3(seriesModel, api, aspect) {
  var option = extend(seriesModel.getBoxLayoutParams(), {
    aspect
  });
  return getLayoutRect(option, {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function createViewCoordSys(ecModel, api) {
  var viewList = [];
  ecModel.eachSeriesByType("graph", function(seriesModel) {
    var coordSysType = seriesModel.get("coordinateSystem");
    if (!coordSysType || coordSysType === "view") {
      var data_1 = seriesModel.getData();
      var positions = data_1.mapArray(function(idx) {
        var itemModel = data_1.getItemModel(idx);
        return [+itemModel.get("x"), +itemModel.get("y")];
      });
      var min3 = [];
      var max3 = [];
      fromPoints(positions, min3, max3);
      if (max3[0] - min3[0] === 0) {
        max3[0] += 1;
        min3[0] -= 1;
      }
      if (max3[1] - min3[1] === 0) {
        max3[1] += 1;
        min3[1] -= 1;
      }
      var aspect = (max3[0] - min3[0]) / (max3[1] - min3[1]);
      var viewRect2 = getViewRect$3(seriesModel, api, aspect);
      if (isNaN(aspect)) {
        min3 = [viewRect2.x, viewRect2.y];
        max3 = [viewRect2.x + viewRect2.width, viewRect2.y + viewRect2.height];
      }
      var bbWidth = max3[0] - min3[0];
      var bbHeight = max3[1] - min3[1];
      var viewWidth = viewRect2.width;
      var viewHeight = viewRect2.height;
      var viewCoordSys = seriesModel.coordinateSystem = new View$1();
      viewCoordSys.zoomLimit = seriesModel.get("scaleLimit");
      viewCoordSys.setBoundingRect(min3[0], min3[1], bbWidth, bbHeight);
      viewCoordSys.setViewRect(viewRect2.x, viewRect2.y, viewWidth, viewHeight);
      viewCoordSys.setCenter(seriesModel.get("center"));
      viewCoordSys.setZoom(seriesModel.get("zoom"));
      viewList.push(viewCoordSys);
    }
  });
  return viewList;
}
var straightLineProto = Line$3.prototype;
var bezierCurveProto = BezierCurve$1.prototype;
var StraightLineShape = function() {
  function StraightLineShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.percent = 1;
  }
  return StraightLineShape2;
}();
(function(_super) {
  __extends(CurveShape, _super);
  function CurveShape() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  return CurveShape;
})(StraightLineShape);
function isStraightLine(shape) {
  return isNaN(+shape.cpx1) || isNaN(+shape.cpy1);
}
var ECLinePath = function(_super) {
  __extends(ECLinePath2, _super);
  function ECLinePath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "ec-line";
    return _this;
  }
  ECLinePath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  ECLinePath2.prototype.getDefaultShape = function() {
    return new StraightLineShape();
  };
  ECLinePath2.prototype.buildPath = function(ctx, shape) {
    if (isStraightLine(shape)) {
      straightLineProto.buildPath.call(this, ctx, shape);
    } else {
      bezierCurveProto.buildPath.call(this, ctx, shape);
    }
  };
  ECLinePath2.prototype.pointAt = function(t2) {
    if (isStraightLine(this.shape)) {
      return straightLineProto.pointAt.call(this, t2);
    } else {
      return bezierCurveProto.pointAt.call(this, t2);
    }
  };
  ECLinePath2.prototype.tangentAt = function(t2) {
    var shape = this.shape;
    var p2 = isStraightLine(shape) ? [shape.x2 - shape.x1, shape.y2 - shape.y1] : bezierCurveProto.tangentAt.call(this, t2);
    return normalize$4(p2, p2);
  };
  return ECLinePath2;
}(Path$1);
var ECLinePath$1 = ECLinePath;
var SYMBOL_CATEGORIES = ["fromSymbol", "toSymbol"];
function makeSymbolTypeKey(symbolCategory) {
  return "_" + symbolCategory + "Type";
}
function createSymbol(name, lineData, idx) {
  var symbolType = lineData.getItemVisual(idx, name);
  if (!symbolType || symbolType === "none") {
    return;
  }
  var symbolSize = lineData.getItemVisual(idx, name + "Size");
  var symbolRotate = lineData.getItemVisual(idx, name + "Rotate");
  var symbolOffset = lineData.getItemVisual(idx, name + "Offset");
  var symbolKeepAspect = lineData.getItemVisual(idx, name + "KeepAspect");
  var symbolSizeArr = normalizeSymbolSize(symbolSize);
  var symbolOffsetArr = normalizeSymbolOffset(symbolOffset || 0, symbolSizeArr);
  var symbolPath = createSymbol$1(symbolType, -symbolSizeArr[0] / 2 + symbolOffsetArr[0], -symbolSizeArr[1] / 2 + symbolOffsetArr[1], symbolSizeArr[0], symbolSizeArr[1], null, symbolKeepAspect);
  symbolPath.__specifiedRotation = symbolRotate == null || isNaN(symbolRotate) ? void 0 : +symbolRotate * Math.PI / 180 || 0;
  symbolPath.name = name;
  return symbolPath;
}
function createLine(points2) {
  var line = new ECLinePath$1({
    name: "line",
    subPixelOptimize: true
  });
  setLinePoints(line.shape, points2);
  return line;
}
function setLinePoints(targetShape, points2) {
  targetShape.x1 = points2[0][0];
  targetShape.y1 = points2[0][1];
  targetShape.x2 = points2[1][0];
  targetShape.y2 = points2[1][1];
  targetShape.percent = 1;
  var cp1 = points2[2];
  if (cp1) {
    targetShape.cpx1 = cp1[0];
    targetShape.cpy1 = cp1[1];
  } else {
    targetShape.cpx1 = NaN;
    targetShape.cpy1 = NaN;
  }
}
var Line = function(_super) {
  __extends(Line2, _super);
  function Line2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createLine(lineData, idx, seriesScope);
    return _this;
  }
  Line2.prototype._createLine = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var linePoints = lineData.getItemLayout(idx);
    var line = createLine(linePoints);
    line.shape.percent = 0;
    initProps(line, {
      shape: {
        percent: 1
      }
    }, seriesModel, idx);
    this.add(line);
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = createSymbol(symbolCategory, lineData, idx);
      this.add(symbol);
      this[makeSymbolTypeKey(symbolCategory)] = lineData.getItemVisual(idx, symbolCategory);
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var linePoints = lineData.getItemLayout(idx);
    var target = {
      shape: {}
    };
    setLinePoints(target.shape, linePoints);
    updateProps$1(line, target, seriesModel, idx);
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbolType = lineData.getItemVisual(idx, symbolCategory);
      var key = makeSymbolTypeKey(symbolCategory);
      if (this[key] !== symbolType) {
        this.remove(this.childOfName(symbolCategory));
        var symbol = createSymbol(symbolCategory, lineData, idx);
        this.add(symbol);
      }
      this[key] = symbolType;
    }, this);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Line2.prototype.getLinePath = function() {
    return this.childAt(0);
  };
  Line2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childOfName("line");
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var blurLineStyle = seriesScope && seriesScope.blurLineStyle;
    var selectLineStyle = seriesScope && seriesScope.selectLineStyle;
    var labelStatesModels = seriesScope && seriesScope.labelStatesModels;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    if (!seriesScope || lineData.hasItemOption) {
      var itemModel = lineData.getItemModel(idx);
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      blurLineStyle = itemModel.getModel(["blur", "lineStyle"]).getLineStyle();
      selectLineStyle = itemModel.getModel(["select", "lineStyle"]).getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
      labelStatesModels = getLabelStatesModels(itemModel);
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var visualColor = lineStyle.stroke;
    line.useStyle(lineStyle);
    line.style.fill = null;
    line.style.strokeNoScale = true;
    line.ensureState("emphasis").style = emphasisLineStyle;
    line.ensureState("blur").style = blurLineStyle;
    line.ensureState("select").style = selectLineStyle;
    each$f(SYMBOL_CATEGORIES, function(symbolCategory) {
      var symbol = this.childOfName(symbolCategory);
      if (symbol) {
        symbol.setColor(visualColor);
        symbol.style.opacity = lineStyle.opacity;
        for (var i = 0; i < SPECIAL_STATES.length; i++) {
          var stateName = SPECIAL_STATES[i];
          var lineState = line.getState(stateName);
          if (lineState) {
            var lineStateStyle = lineState.style || {};
            var state = symbol.ensureState(stateName);
            var stateStyle = state.style || (state.style = {});
            if (lineStateStyle.stroke != null) {
              stateStyle[symbol.__isEmptyBrush ? "stroke" : "fill"] = lineStateStyle.stroke;
            }
            if (lineStateStyle.opacity != null) {
              stateStyle.opacity = lineStateStyle.opacity;
            }
          }
        }
        symbol.markRedraw();
      }
    }, this);
    var rawVal = seriesModel.getRawValue(idx);
    setLabelStyle(this, labelStatesModels, {
      labelDataIndex: idx,
      labelFetcher: {
        getFormattedLabel: function(dataIndex, stateName) {
          return seriesModel.getFormattedLabel(dataIndex, stateName, lineData.dataType);
        }
      },
      inheritColor: visualColor || "#000",
      defaultOpacity: lineStyle.opacity,
      defaultText: (rawVal == null ? lineData.getName(idx) : isFinite(rawVal) ? round$3(rawVal) : rawVal) + ""
    });
    var label = this.getTextContent();
    if (label) {
      var labelNormalModel = labelStatesModels.normal;
      label.__align = label.style.align;
      label.__verticalAlign = label.style.verticalAlign;
      label.__position = labelNormalModel.get("position") || "middle";
      var distance2 = labelNormalModel.get("distance");
      if (!isArray$1(distance2)) {
        distance2 = [distance2, distance2];
      }
      label.__labelDistance = distance2;
    }
    this.setTextConfig({
      position: null,
      local: true,
      inside: false
    });
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Line2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  Line2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  Line2.prototype.updateLayout = function(lineData, idx) {
    this.setLinePoints(lineData.getItemLayout(idx));
  };
  Line2.prototype.setLinePoints = function(points2) {
    var linePath = this.childOfName("line");
    setLinePoints(linePath.shape, points2);
    linePath.dirty();
  };
  Line2.prototype.beforeUpdate = function() {
    var lineGroup = this;
    var symbolFrom = lineGroup.childOfName("fromSymbol");
    var symbolTo = lineGroup.childOfName("toSymbol");
    var label = lineGroup.getTextContent();
    if (!symbolFrom && !symbolTo && (!label || label.ignore)) {
      return;
    }
    var invScale = 1;
    var parentNode2 = this.parent;
    while (parentNode2) {
      if (parentNode2.scaleX) {
        invScale /= parentNode2.scaleX;
      }
      parentNode2 = parentNode2.parent;
    }
    var line = lineGroup.childOfName("line");
    if (!this.__dirty && !line.__dirty) {
      return;
    }
    var percent = line.shape.percent;
    var fromPos = line.pointAt(0);
    var toPos = line.pointAt(percent);
    var d2 = sub([], toPos, fromPos);
    normalize$4(d2, d2);
    function setSymbolRotation(symbol, percent2) {
      var specifiedRotation = symbol.__specifiedRotation;
      if (specifiedRotation == null) {
        var tangent2 = line.tangentAt(percent2);
        symbol.attr("rotation", (percent2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(tangent2[1], tangent2[0]));
      } else {
        symbol.attr("rotation", specifiedRotation);
      }
    }
    if (symbolFrom) {
      symbolFrom.setPosition(fromPos);
      setSymbolRotation(symbolFrom, 0);
      symbolFrom.scaleX = symbolFrom.scaleY = invScale * percent;
      symbolFrom.markRedraw();
    }
    if (symbolTo) {
      symbolTo.setPosition(toPos);
      setSymbolRotation(symbolTo, 1);
      symbolTo.scaleX = symbolTo.scaleY = invScale * percent;
      symbolTo.markRedraw();
    }
    if (label && !label.ignore) {
      label.x = label.y = 0;
      label.originX = label.originY = 0;
      var textAlign = void 0;
      var textVerticalAlign = void 0;
      var distance2 = label.__labelDistance;
      var distanceX = distance2[0] * invScale;
      var distanceY = distance2[1] * invScale;
      var halfPercent = percent / 2;
      var tangent = line.tangentAt(halfPercent);
      var n2 = [tangent[1], -tangent[0]];
      var cp = line.pointAt(halfPercent);
      if (n2[1] > 0) {
        n2[0] = -n2[0];
        n2[1] = -n2[1];
      }
      var dir3 = tangent[0] < 0 ? -1 : 1;
      if (label.__position !== "start" && label.__position !== "end") {
        var rotation = -Math.atan2(tangent[1], tangent[0]);
        if (toPos[0] < fromPos[0]) {
          rotation = Math.PI + rotation;
        }
        label.rotation = rotation;
      }
      var dy = void 0;
      switch (label.__position) {
        case "insideStartTop":
        case "insideMiddleTop":
        case "insideEndTop":
        case "middle":
          dy = -distanceY;
          textVerticalAlign = "bottom";
          break;
        case "insideStartBottom":
        case "insideMiddleBottom":
        case "insideEndBottom":
          dy = distanceY;
          textVerticalAlign = "top";
          break;
        default:
          dy = 0;
          textVerticalAlign = "middle";
      }
      switch (label.__position) {
        case "end":
          label.x = d2[0] * distanceX + toPos[0];
          label.y = d2[1] * distanceY + toPos[1];
          textAlign = d2[0] > 0.8 ? "left" : d2[0] < -0.8 ? "right" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "top" : d2[1] < -0.8 ? "bottom" : "middle";
          break;
        case "start":
          label.x = -d2[0] * distanceX + fromPos[0];
          label.y = -d2[1] * distanceY + fromPos[1];
          textAlign = d2[0] > 0.8 ? "right" : d2[0] < -0.8 ? "left" : "center";
          textVerticalAlign = d2[1] > 0.8 ? "bottom" : d2[1] < -0.8 ? "top" : "middle";
          break;
        case "insideStartTop":
        case "insideStart":
        case "insideStartBottom":
          label.x = distanceX * dir3 + fromPos[0];
          label.y = fromPos[1] + dy;
          textAlign = tangent[0] < 0 ? "right" : "left";
          label.originX = -distanceX * dir3;
          label.originY = -dy;
          break;
        case "insideMiddleTop":
        case "insideMiddle":
        case "insideMiddleBottom":
        case "middle":
          label.x = cp[0];
          label.y = cp[1] + dy;
          textAlign = "center";
          label.originY = -dy;
          break;
        case "insideEndTop":
        case "insideEnd":
        case "insideEndBottom":
          label.x = -distanceX * dir3 + toPos[0];
          label.y = toPos[1] + dy;
          textAlign = tangent[0] >= 0 ? "right" : "left";
          label.originX = distanceX * dir3;
          label.originY = -dy;
          break;
      }
      label.scaleX = label.scaleY = invScale;
      label.setStyle({
        verticalAlign: label.__verticalAlign || textVerticalAlign,
        align: label.__align || textAlign
      });
    }
  };
  return Line2;
}(Group$4);
var Line$1 = Line;
var LineDraw = function() {
  function LineDraw2(LineCtor) {
    this.group = new Group$4();
    this._LineCtor = LineCtor || Line$1;
  }
  LineDraw2.prototype.updateData = function(lineData) {
    var _this = this;
    this._progressiveEls = null;
    var lineDraw = this;
    var group = lineDraw.group;
    var oldLineData = lineDraw._lineData;
    lineDraw._lineData = lineData;
    if (!oldLineData) {
      group.removeAll();
    }
    var seriesScope = makeSeriesScope$1(lineData);
    lineData.diff(oldLineData).add(function(idx) {
      _this._doAdd(lineData, idx, seriesScope);
    }).update(function(newIdx, oldIdx) {
      _this._doUpdate(oldLineData, lineData, oldIdx, newIdx, seriesScope);
    }).remove(function(idx) {
      group.remove(oldLineData.getItemGraphicEl(idx));
    }).execute();
  };
  LineDraw2.prototype.updateLayout = function() {
    var lineData = this._lineData;
    if (!lineData) {
      return;
    }
    lineData.eachItemGraphicEl(function(el, idx) {
      el.updateLayout(lineData, idx);
    }, this);
  };
  LineDraw2.prototype.incrementalPrepareUpdate = function(lineData) {
    this._seriesScope = makeSeriesScope$1(lineData);
    this._lineData = null;
    this.group.removeAll();
  };
  LineDraw2.prototype.incrementalUpdate = function(taskParams, lineData) {
    this._progressiveEls = [];
    function updateIncrementalAndHover(el2) {
      if (!el2.isGroup && !isEffectObject(el2)) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = taskParams.start; idx < taskParams.end; idx++) {
      var itemLayout = lineData.getItemLayout(idx);
      if (lineNeedsDraw(itemLayout)) {
        var el = new this._LineCtor(lineData, idx, this._seriesScope);
        el.traverse(updateIncrementalAndHover);
        this.group.add(el);
        lineData.setItemGraphicEl(idx, el);
        this._progressiveEls.push(el);
      }
    }
  };
  LineDraw2.prototype.remove = function() {
    this.group.removeAll();
  };
  LineDraw2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  LineDraw2.prototype._doAdd = function(lineData, idx, seriesScope) {
    var itemLayout = lineData.getItemLayout(idx);
    if (!lineNeedsDraw(itemLayout)) {
      return;
    }
    var el = new this._LineCtor(lineData, idx, seriesScope);
    lineData.setItemGraphicEl(idx, el);
    this.group.add(el);
  };
  LineDraw2.prototype._doUpdate = function(oldLineData, newLineData, oldIdx, newIdx, seriesScope) {
    var itemEl = oldLineData.getItemGraphicEl(oldIdx);
    if (!lineNeedsDraw(newLineData.getItemLayout(newIdx))) {
      this.group.remove(itemEl);
      return;
    }
    if (!itemEl) {
      itemEl = new this._LineCtor(newLineData, newIdx, seriesScope);
    } else {
      itemEl.updateData(newLineData, newIdx, seriesScope);
    }
    newLineData.setItemGraphicEl(newIdx, itemEl);
    this.group.add(itemEl);
  };
  return LineDraw2;
}();
function isEffectObject(el) {
  return el.animators && el.animators.length > 0;
}
function makeSeriesScope$1(lineData) {
  var hostModel = lineData.hostModel;
  var emphasisModel = hostModel.getModel("emphasis");
  return {
    lineStyle: hostModel.getModel("lineStyle").getLineStyle(),
    emphasisLineStyle: emphasisModel.getModel(["lineStyle"]).getLineStyle(),
    blurLineStyle: hostModel.getModel(["blur", "lineStyle"]).getLineStyle(),
    selectLineStyle: hostModel.getModel(["select", "lineStyle"]).getLineStyle(),
    emphasisDisabled: emphasisModel.get("disabled"),
    blurScope: emphasisModel.get("blurScope"),
    focus: emphasisModel.get("focus"),
    labelStatesModels: getLabelStatesModels(hostModel)
  };
}
function isPointNaN(pt) {
  return isNaN(pt[0]) || isNaN(pt[1]);
}
function lineNeedsDraw(pts) {
  return pts && !isPointNaN(pts[0]) && !isPointNaN(pts[1]);
}
var LineDraw$1 = LineDraw;
var v1 = [];
var v2 = [];
var v3 = [];
var quadraticAt = quadraticAt$1;
var v2DistSquare = distSquare;
var mathAbs = Math.abs;
function intersectCurveCircle(curvePoints, center2, radius) {
  var p0 = curvePoints[0];
  var p1 = curvePoints[1];
  var p2 = curvePoints[2];
  var d2 = Infinity;
  var t2;
  var radiusSquare = radius * radius;
  var interval = 0.1;
  for (var _t = 0.1; _t <= 0.9; _t += 0.1) {
    v1[0] = quadraticAt(p0[0], p1[0], p2[0], _t);
    v1[1] = quadraticAt(p0[1], p1[1], p2[1], _t);
    var diff = mathAbs(v2DistSquare(v1, center2) - radiusSquare);
    if (diff < d2) {
      d2 = diff;
      t2 = _t;
    }
  }
  for (var i = 0; i < 32; i++) {
    var next = t2 + interval;
    v2[0] = quadraticAt(p0[0], p1[0], p2[0], t2);
    v2[1] = quadraticAt(p0[1], p1[1], p2[1], t2);
    v3[0] = quadraticAt(p0[0], p1[0], p2[0], next);
    v3[1] = quadraticAt(p0[1], p1[1], p2[1], next);
    var diff = v2DistSquare(v2, center2) - radiusSquare;
    if (mathAbs(diff) < 0.01) {
      break;
    }
    var nextDiff = v2DistSquare(v3, center2) - radiusSquare;
    interval /= 2;
    if (diff < 0) {
      if (nextDiff >= 0) {
        t2 = t2 + interval;
      } else {
        t2 = t2 - interval;
      }
    } else {
      if (nextDiff >= 0) {
        t2 = t2 - interval;
      } else {
        t2 = t2 + interval;
      }
    }
  }
  return t2;
}
function adjustEdge(graph, scale2) {
  var tmp0 = [];
  var quadraticSubdivide$1 = quadraticSubdivide;
  var pts = [[], [], []];
  var pts2 = [[], []];
  var v4 = [];
  scale2 /= 2;
  graph.eachEdge(function(edge, idx) {
    var linePoints = edge.getLayout();
    var fromSymbol = edge.getVisual("fromSymbol");
    var toSymbol = edge.getVisual("toSymbol");
    if (!linePoints.__original) {
      linePoints.__original = [clone$3(linePoints[0]), clone$3(linePoints[1])];
      if (linePoints[2]) {
        linePoints.__original.push(clone$3(linePoints[2]));
      }
    }
    var originalPoints = linePoints.__original;
    if (linePoints[2] != null) {
      copy$1(pts[0], originalPoints[0]);
      copy$1(pts[1], originalPoints[2]);
      copy$1(pts[2], originalPoints[1]);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        var t2 = intersectCurveCircle(pts, originalPoints[0], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[0][0] = tmp0[3];
        pts[1][0] = tmp0[4];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[0][1] = tmp0[3];
        pts[1][1] = tmp0[4];
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        var t2 = intersectCurveCircle(pts, originalPoints[1], symbolSize * scale2);
        quadraticSubdivide$1(pts[0][0], pts[1][0], pts[2][0], t2, tmp0);
        pts[1][0] = tmp0[1];
        pts[2][0] = tmp0[2];
        quadraticSubdivide$1(pts[0][1], pts[1][1], pts[2][1], t2, tmp0);
        pts[1][1] = tmp0[1];
        pts[2][1] = tmp0[2];
      }
      copy$1(linePoints[0], pts[0]);
      copy$1(linePoints[1], pts[2]);
      copy$1(linePoints[2], pts[1]);
    } else {
      copy$1(pts2[0], originalPoints[0]);
      copy$1(pts2[1], originalPoints[1]);
      sub(v4, pts2[1], pts2[0]);
      normalize$4(v4, v4);
      if (fromSymbol && fromSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node1);
        scaleAndAdd$1(pts2[0], pts2[0], v4, symbolSize * scale2);
      }
      if (toSymbol && toSymbol !== "none") {
        var symbolSize = getSymbolSize(edge.node2);
        scaleAndAdd$1(pts2[1], pts2[1], v4, -symbolSize * scale2);
      }
      copy$1(linePoints[0], pts2[0]);
      copy$1(linePoints[1], pts2[1]);
    }
  });
}
function isViewCoordSys(coordSys) {
  return coordSys.type === "view";
}
var GraphView = function(_super) {
  __extends(GraphView2, _super);
  function GraphView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphView2.type;
    return _this;
  }
  GraphView2.prototype.init = function(ecModel, api) {
    var symbolDraw = new SymbolDraw$1();
    var lineDraw = new LineDraw$1();
    var group = this.group;
    this._controller = new RoamController$1(api.getZr());
    this._controllerHost = {
      target: group
    };
    group.add(symbolDraw.group);
    group.add(lineDraw.group);
    this._symbolDraw = symbolDraw;
    this._lineDraw = lineDraw;
    this._firstRender = true;
  };
  GraphView2.prototype.render = function(seriesModel, ecModel, api) {
    var _this = this;
    var coordSys = seriesModel.coordinateSystem;
    this._model = seriesModel;
    var symbolDraw = this._symbolDraw;
    var lineDraw = this._lineDraw;
    var group = this.group;
    if (isViewCoordSys(coordSys)) {
      var groupNewProp = {
        x: coordSys.x,
        y: coordSys.y,
        scaleX: coordSys.scaleX,
        scaleY: coordSys.scaleY
      };
      if (this._firstRender) {
        group.attr(groupNewProp);
      } else {
        updateProps$1(group, groupNewProp, seriesModel);
      }
    }
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    var data = seriesModel.getData();
    symbolDraw.updateData(data);
    var edgeData = seriesModel.getEdgeData();
    lineDraw.updateData(edgeData);
    this._updateNodeAndLinkScale();
    this._updateController(seriesModel, ecModel, api);
    clearTimeout(this._layoutTimeout);
    var forceLayout2 = seriesModel.forceLayout;
    var layoutAnimation = seriesModel.get(["force", "layoutAnimation"]);
    if (forceLayout2) {
      this._startForceLayoutIteration(forceLayout2, layoutAnimation);
    }
    data.graph.eachNode(function(node) {
      var idx = node.dataIndex;
      var el = node.getGraphicEl();
      var itemModel = node.getModel();
      if (!el) {
        return;
      }
      el.off("drag").off("dragend");
      var draggable = itemModel.get("draggable");
      if (draggable) {
        el.on("drag", function() {
          if (forceLayout2) {
            forceLayout2.warmUp();
            !_this._layouting && _this._startForceLayoutIteration(forceLayout2, layoutAnimation);
            forceLayout2.setFixed(idx);
            data.setItemLayout(idx, [el.x, el.y]);
          }
        }).on("dragend", function() {
          if (forceLayout2) {
            forceLayout2.setUnfixed(idx);
          }
        });
      }
      el.setDraggable(draggable && !!forceLayout2);
      var focus = itemModel.get(["emphasis", "focus"]);
      if (focus === "adjacency") {
        getECData(el).focus = node.getAdjacentDataIndices();
      }
    });
    data.graph.eachEdge(function(edge) {
      var el = edge.getGraphicEl();
      var focus = edge.getModel().get(["emphasis", "focus"]);
      if (!el) {
        return;
      }
      if (focus === "adjacency") {
        getECData(el).focus = {
          edge: [edge.dataIndex],
          node: [edge.node1.dataIndex, edge.node2.dataIndex]
        };
      }
    });
    var circularRotateLabel = seriesModel.get("layout") === "circular" && seriesModel.get(["circular", "rotateLabel"]);
    var cx = data.getLayout("cx");
    var cy = data.getLayout("cy");
    data.eachItemGraphicEl(function(el, idx) {
      var itemModel = data.getItemModel(idx);
      var labelRotate = itemModel.get(["label", "rotate"]) || 0;
      var symbolPath = el.getSymbolPath();
      if (circularRotateLabel) {
        var pos = data.getItemLayout(idx);
        var rad = Math.atan2(pos[1] - cy, pos[0] - cx);
        if (rad < 0) {
          rad = Math.PI * 2 + rad;
        }
        var isLeft = pos[0] < cx;
        if (isLeft) {
          rad = rad - Math.PI;
        }
        var textPosition = isLeft ? "left" : "right";
        symbolPath.setTextConfig({
          rotation: -rad,
          position: textPosition,
          origin: "center"
        });
        var emphasisState = symbolPath.ensureState("emphasis");
        extend(emphasisState.textConfig || (emphasisState.textConfig = {}), {
          position: textPosition
        });
      } else {
        symbolPath.setTextConfig({
          rotation: labelRotate *= Math.PI / 180
        });
      }
    });
    this._firstRender = false;
  };
  GraphView2.prototype.dispose = function() {
    this._controller && this._controller.dispose();
    this._controllerHost = null;
  };
  GraphView2.prototype._startForceLayoutIteration = function(forceLayout2, layoutAnimation) {
    var self2 = this;
    (function step() {
      forceLayout2.step(function(stopped) {
        self2.updateLayout(self2._model);
        (self2._layouting = !stopped) && (layoutAnimation ? self2._layoutTimeout = setTimeout(step, 16) : step());
      });
    })();
  };
  GraphView2.prototype._updateController = function(seriesModel, ecModel, api) {
    var _this = this;
    var controller = this._controller;
    var controllerHost = this._controllerHost;
    var group = this.group;
    controller.setPointerChecker(function(e2, x2, y2) {
      var rect = group.getBoundingRect();
      rect.applyTransform(group.transform);
      return rect.contain(x2, y2) && !onIrrelevantElement(e2, api, seriesModel);
    });
    if (!isViewCoordSys(seriesModel.coordinateSystem)) {
      controller.disable();
      return;
    }
    controller.enable(seriesModel.get("roam"));
    controllerHost.zoomLimit = seriesModel.get("scaleLimit");
    controllerHost.zoom = seriesModel.coordinateSystem.getZoom();
    controller.off("pan").off("zoom").on("pan", function(e2) {
      updateViewOnPan(controllerHost, e2.dx, e2.dy);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        dx: e2.dx,
        dy: e2.dy
      });
    }).on("zoom", function(e2) {
      updateViewOnZoom(controllerHost, e2.scale, e2.originX, e2.originY);
      api.dispatchAction({
        seriesId: seriesModel.id,
        type: "graphRoam",
        zoom: e2.scale,
        originX: e2.originX,
        originY: e2.originY
      });
      _this._updateNodeAndLinkScale();
      adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
      _this._lineDraw.updateLayout();
      api.updateLabelLayout();
    });
  };
  GraphView2.prototype._updateNodeAndLinkScale = function() {
    var seriesModel = this._model;
    var data = seriesModel.getData();
    var nodeScale = getNodeGlobalScale(seriesModel);
    data.eachItemGraphicEl(function(el, idx) {
      el && el.setSymbolScale(nodeScale);
    });
  };
  GraphView2.prototype.updateLayout = function(seriesModel) {
    adjustEdge(seriesModel.getGraph(), getNodeGlobalScale(seriesModel));
    this._symbolDraw.updateLayout();
    this._lineDraw.updateLayout();
  };
  GraphView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove();
    this._lineDraw && this._lineDraw.remove();
  };
  GraphView2.type = "graph";
  return GraphView2;
}(ChartView$1);
var GraphView$1 = GraphView;
function generateNodeKey(id2) {
  return "_EC_" + id2;
}
var Graph = function() {
  function Graph2(directed) {
    this.type = "graph";
    this.nodes = [];
    this.edges = [];
    this._nodesMap = {};
    this._edgesMap = {};
    this._directed = directed || false;
  }
  Graph2.prototype.isDirected = function() {
    return this._directed;
  };
  Graph2.prototype.addNode = function(id2, dataIndex) {
    id2 = id2 == null ? "" + dataIndex : "" + id2;
    var nodesMap = this._nodesMap;
    if (nodesMap[generateNodeKey(id2)]) {
      return;
    }
    var node = new GraphNode(id2, dataIndex);
    node.hostGraph = this;
    this.nodes.push(node);
    nodesMap[generateNodeKey(id2)] = node;
    return node;
  };
  Graph2.prototype.getNodeByIndex = function(dataIndex) {
    var rawIdx = this.data.getRawIndex(dataIndex);
    return this.nodes[rawIdx];
  };
  Graph2.prototype.getNodeById = function(id2) {
    return this._nodesMap[generateNodeKey(id2)];
  };
  Graph2.prototype.addEdge = function(n1, n2, dataIndex) {
    var nodesMap = this._nodesMap;
    var edgesMap = this._edgesMap;
    if (isNumber(n1)) {
      n1 = this.nodes[n1];
    }
    if (isNumber(n2)) {
      n2 = this.nodes[n2];
    }
    if (!(n1 instanceof GraphNode)) {
      n1 = nodesMap[generateNodeKey(n1)];
    }
    if (!(n2 instanceof GraphNode)) {
      n2 = nodesMap[generateNodeKey(n2)];
    }
    if (!n1 || !n2) {
      return;
    }
    var key = n1.id + "-" + n2.id;
    var edge = new GraphEdge(n1, n2, dataIndex);
    edge.hostGraph = this;
    if (this._directed) {
      n1.outEdges.push(edge);
      n2.inEdges.push(edge);
    }
    n1.edges.push(edge);
    if (n1 !== n2) {
      n2.edges.push(edge);
    }
    this.edges.push(edge);
    edgesMap[key] = edge;
    return edge;
  };
  Graph2.prototype.getEdgeByIndex = function(dataIndex) {
    var rawIdx = this.edgeData.getRawIndex(dataIndex);
    return this.edges[rawIdx];
  };
  Graph2.prototype.getEdge = function(n1, n2) {
    if (n1 instanceof GraphNode) {
      n1 = n1.id;
    }
    if (n2 instanceof GraphNode) {
      n2 = n2.id;
    }
    var edgesMap = this._edgesMap;
    if (this._directed) {
      return edgesMap[n1 + "-" + n2];
    } else {
      return edgesMap[n1 + "-" + n2] || edgesMap[n2 + "-" + n1];
    }
  };
  Graph2.prototype.eachNode = function(cb, context) {
    var nodes = this.nodes;
    var len2 = nodes.length;
    for (var i = 0; i < len2; i++) {
      if (nodes[i].dataIndex >= 0) {
        cb.call(context, nodes[i], i);
      }
    }
  };
  Graph2.prototype.eachEdge = function(cb, context) {
    var edges = this.edges;
    var len2 = edges.length;
    for (var i = 0; i < len2; i++) {
      if (edges[i].dataIndex >= 0 && edges[i].node1.dataIndex >= 0 && edges[i].node2.dataIndex >= 0) {
        cb.call(context, edges[i], i);
      }
    }
  };
  Graph2.prototype.breadthFirstTraverse = function(cb, startNode, direction, context) {
    if (!(startNode instanceof GraphNode)) {
      startNode = this._nodesMap[generateNodeKey(startNode)];
    }
    if (!startNode) {
      return;
    }
    var edgeType = direction === "out" ? "outEdges" : direction === "in" ? "inEdges" : "edges";
    for (var i = 0; i < this.nodes.length; i++) {
      this.nodes[i].__visited = false;
    }
    if (cb.call(context, startNode, null)) {
      return;
    }
    var queue = [startNode];
    while (queue.length) {
      var currentNode = queue.shift();
      var edges = currentNode[edgeType];
      for (var i = 0; i < edges.length; i++) {
        var e2 = edges[i];
        var otherNode = e2.node1 === currentNode ? e2.node2 : e2.node1;
        if (!otherNode.__visited) {
          if (cb.call(context, otherNode, currentNode)) {
            return;
          }
          queue.push(otherNode);
          otherNode.__visited = true;
        }
      }
    }
  };
  Graph2.prototype.update = function() {
    var data = this.data;
    var edgeData = this.edgeData;
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0, len2 = nodes.length; i < len2; i++) {
      nodes[i].dataIndex = -1;
    }
    for (var i = 0, len2 = data.count(); i < len2; i++) {
      nodes[data.getRawIndex(i)].dataIndex = i;
    }
    edgeData.filterSelf(function(idx) {
      var edge = edges[edgeData.getRawIndex(idx)];
      return edge.node1.dataIndex >= 0 && edge.node2.dataIndex >= 0;
    });
    for (var i = 0, len2 = edges.length; i < len2; i++) {
      edges[i].dataIndex = -1;
    }
    for (var i = 0, len2 = edgeData.count(); i < len2; i++) {
      edges[edgeData.getRawIndex(i)].dataIndex = i;
    }
  };
  Graph2.prototype.clone = function() {
    var graph = new Graph2(this._directed);
    var nodes = this.nodes;
    var edges = this.edges;
    for (var i = 0; i < nodes.length; i++) {
      graph.addNode(nodes[i].id, nodes[i].dataIndex);
    }
    for (var i = 0; i < edges.length; i++) {
      var e2 = edges[i];
      graph.addEdge(e2.node1.id, e2.node2.id, e2.dataIndex);
    }
    return graph;
  };
  return Graph2;
}();
var GraphNode = function() {
  function GraphNode2(id2, dataIndex) {
    this.inEdges = [];
    this.outEdges = [];
    this.edges = [];
    this.dataIndex = -1;
    this.id = id2 == null ? "" : id2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphNode2.prototype.degree = function() {
    return this.edges.length;
  };
  GraphNode2.prototype.inDegree = function() {
    return this.inEdges.length;
  };
  GraphNode2.prototype.outDegree = function() {
    return this.outEdges.length;
  };
  GraphNode2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.data.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphNode2.prototype.getAdjacentDataIndices = function() {
    var dataIndices = {
      edge: [],
      node: []
    };
    for (var i = 0; i < this.edges.length; i++) {
      var adjacentEdge = this.edges[i];
      if (adjacentEdge.dataIndex < 0) {
        continue;
      }
      dataIndices.edge.push(adjacentEdge.dataIndex);
      dataIndices.node.push(adjacentEdge.node1.dataIndex, adjacentEdge.node2.dataIndex);
    }
    return dataIndices;
  };
  return GraphNode2;
}();
var GraphEdge = function() {
  function GraphEdge2(n1, n2, dataIndex) {
    this.dataIndex = -1;
    this.node1 = n1;
    this.node2 = n2;
    this.dataIndex = dataIndex == null ? -1 : dataIndex;
  }
  GraphEdge2.prototype.getModel = function(path) {
    if (this.dataIndex < 0) {
      return;
    }
    var graph = this.hostGraph;
    var itemModel = graph.edgeData.getItemModel(this.dataIndex);
    return itemModel.getModel(path);
  };
  GraphEdge2.prototype.getAdjacentDataIndices = function() {
    return {
      edge: [this.dataIndex],
      node: [this.node1.dataIndex, this.node2.dataIndex]
    };
  };
  return GraphEdge2;
}();
function createGraphDataProxyMixin(hostName, dataName) {
  return {
    getValue: function(dimension) {
      var data = this[hostName][dataName];
      return data.getStore().get(data.getDimensionIndex(dimension || "value"), this.dataIndex);
    },
    setVisual: function(key, value) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemVisual(this.dataIndex, key, value);
    },
    getVisual: function(key) {
      return this[hostName][dataName].getItemVisual(this.dataIndex, key);
    },
    setLayout: function(layout2, merge2) {
      this.dataIndex >= 0 && this[hostName][dataName].setItemLayout(this.dataIndex, layout2, merge2);
    },
    getLayout: function() {
      return this[hostName][dataName].getItemLayout(this.dataIndex);
    },
    getGraphicEl: function() {
      return this[hostName][dataName].getItemGraphicEl(this.dataIndex);
    },
    getRawIndex: function() {
      return this[hostName][dataName].getRawIndex(this.dataIndex);
    }
  };
}
mixin(GraphNode, createGraphDataProxyMixin("hostGraph", "data"));
mixin(GraphEdge, createGraphDataProxyMixin("hostGraph", "edgeData"));
var Graph$1 = Graph;
function createGraphFromNodeEdge(nodes, edges, seriesModel, directed, beforeLink) {
  var graph = new Graph$1(directed);
  for (var i = 0; i < nodes.length; i++) {
    graph.addNode(retrieve(nodes[i].id, nodes[i].name, i), i);
  }
  var linkNameList = [];
  var validEdges = [];
  var linkCount = 0;
  for (var i = 0; i < edges.length; i++) {
    var link = edges[i];
    var source = link.source;
    var target = link.target;
    if (graph.addEdge(source, target, linkCount)) {
      validEdges.push(link);
      linkNameList.push(retrieve(convertOptionIdName(link.id, null), source + " > " + target));
      linkCount++;
    }
  }
  var coordSys = seriesModel.get("coordinateSystem");
  var nodeData;
  if (coordSys === "cartesian2d" || coordSys === "polar") {
    nodeData = createSeriesData(nodes, seriesModel);
  } else {
    var coordSysCtor = CoordinateSystem.get(coordSys);
    var coordDimensions = coordSysCtor ? coordSysCtor.dimensions || [] : [];
    if (indexOf(coordDimensions, "value") < 0) {
      coordDimensions.concat(["value"]);
    }
    var dimensions = prepareSeriesDataSchema(nodes, {
      coordDimensions,
      encodeDefine: seriesModel.getEncode()
    }).dimensions;
    nodeData = new SeriesData$1(dimensions, seriesModel);
    nodeData.initData(nodes);
  }
  var edgeData = new SeriesData$1(["value"], seriesModel);
  edgeData.initData(validEdges, linkNameList);
  beforeLink && beforeLink(nodeData, edgeData);
  linkSeriesData({
    mainData: nodeData,
    struct: graph,
    structAttr: "graph",
    datas: {
      node: nodeData,
      edge: edgeData
    },
    datasAttr: {
      node: "data",
      edge: "edgeData"
    }
  });
  graph.update();
  return graph;
}
var GraphSeriesModel = function(_super) {
  __extends(GraphSeriesModel2, _super);
  function GraphSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  GraphSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    var self2 = this;
    function getCategoriesData() {
      return self2._categoriesData;
    }
    this.legendVisualProvider = new LegendVisualProvider$1(getCategoriesData, getCategoriesData);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this.fillDataTextStyle(option.edges || option.links);
    this._updateCategoriesData();
  };
  GraphSeriesModel2.prototype.mergeDefaultAndTheme = function(option) {
    _super.prototype.mergeDefaultAndTheme.apply(this, arguments);
    defaultEmphasis(option, "edgeLabel", ["show"]);
  };
  GraphSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var edges = option.edges || option.links || [];
    var nodes = option.data || option.nodes || [];
    var self2 = this;
    if (nodes && edges) {
      initCurvenessList(this);
      var graph = createGraphFromNodeEdge(nodes, edges, this, true, beforeLink);
      each$f(graph.edges, function(edge) {
        createEdgeMapForCurveness(edge.node1, edge.node2, this, edge.dataIndex);
      }, this);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model) {
        var categoriesModels = self2._categoriesModels;
        var categoryIdx = model.getShallow("category");
        var categoryModel = categoriesModels[categoryIdx];
        if (categoryModel) {
          categoryModel.parentModel = model.parentModel;
          model.parentModel = categoryModel;
        }
        return model;
      });
      var oldGetModel = Model$1.prototype.getModel;
      function newGetModel(path, parentModel) {
        var model = oldGetModel.call(this, path, parentModel);
        model.resolveParentPath = resolveParentPath;
        return model;
      }
      edgeData.wrapMethod("getItemModel", function(model) {
        model.resolveParentPath = resolveParentPath;
        model.getModel = newGetModel;
        return model;
      });
      function resolveParentPath(pathArr) {
        if (pathArr && (pathArr[0] === "label" || pathArr[1] === "label")) {
          var newPathArr = pathArr.slice();
          if (pathArr[0] === "label") {
            newPathArr[0] = "edgeLabel";
          } else if (pathArr[1] === "label") {
            newPathArr[1] = "edgeLabel";
          }
          return newPathArr;
        }
        return pathArr;
      }
    }
  };
  GraphSeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  GraphSeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  GraphSeriesModel2.prototype.getCategoriesData = function() {
    return this._categoriesData;
  };
  GraphSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    if (dataType === "edge") {
      var nodeData = this.getData();
      var params = this.getDataParams(dataIndex, dataType);
      var edge = nodeData.graph.getEdgeByIndex(dataIndex);
      var sourceName = nodeData.getName(edge.node1.dataIndex);
      var targetName = nodeData.getName(edge.node2.dataIndex);
      var nameArr = [];
      sourceName != null && nameArr.push(sourceName);
      targetName != null && nameArr.push(targetName);
      return createTooltipMarkup("nameValue", {
        name: nameArr.join(" > "),
        value: params.value,
        noValue: params.value == null
      });
    }
    var nodeMarkup = defaultSeriesFormatTooltip({
      series: this,
      dataIndex,
      multipleSeries
    });
    return nodeMarkup;
  };
  GraphSeriesModel2.prototype._updateCategoriesData = function() {
    var categories = map$1(this.option.categories || [], function(category) {
      return category.value != null ? category : extend({
        value: 0
      }, category);
    });
    var categoriesData = new SeriesData$1(["value"], this);
    categoriesData.initData(categories);
    this._categoriesData = categoriesData;
    this._categoriesModels = categoriesData.mapArray(function(idx) {
      return categoriesData.getItemModel(idx);
    });
  };
  GraphSeriesModel2.prototype.setZoom = function(zoom) {
    this.option.zoom = zoom;
  };
  GraphSeriesModel2.prototype.setCenter = function(center2) {
    this.option.center = center2;
  };
  GraphSeriesModel2.prototype.isAnimationEnabled = function() {
    return _super.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
  };
  GraphSeriesModel2.type = "series.graph";
  GraphSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  GraphSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    legendHoverLink: true,
    layout: null,
    circular: {
      rotateLabel: false
    },
    force: {
      initLayout: null,
      repulsion: [0, 50],
      gravity: 0.1,
      friction: 0.6,
      edgeLength: 30,
      layoutAnimation: true
    },
    left: "center",
    top: "center",
    symbol: "circle",
    symbolSize: 10,
    edgeSymbol: ["none", "none"],
    edgeSymbolSize: 10,
    edgeLabel: {
      position: "middle",
      distance: 5
    },
    draggable: false,
    roam: false,
    center: null,
    zoom: 1,
    nodeScaleRatio: 0.6,
    label: {
      show: false,
      formatter: "{b}"
    },
    itemStyle: {},
    lineStyle: {
      color: "#aaa",
      width: 1,
      opacity: 0.5
    },
    emphasis: {
      scale: true,
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return GraphSeriesModel2;
}(SeriesModel$1);
var GraphSeriesModel$1 = GraphSeriesModel;
var actionInfo$1 = {
  type: "graphRoam",
  event: "graphRoam",
  update: "none"
};
function install$F(registers) {
  registers.registerChartView(GraphView$1);
  registers.registerSeriesModel(GraphSeriesModel$1);
  registers.registerProcessor(categoryFilter);
  registers.registerVisual(categoryVisual);
  registers.registerVisual(graphEdgeVisual);
  registers.registerLayout(graphSimpleLayout);
  registers.registerLayout(registers.PRIORITY.VISUAL.POST_CHART_LAYOUT, graphCircularLayout);
  registers.registerLayout(graphForceLayout);
  registers.registerCoordinateSystem("graphView", {
    dimensions: View$1.dimensions,
    create: createViewCoordSys
  });
  registers.registerAction({
    type: "focusNodeAdjacency",
    event: "focusNodeAdjacency",
    update: "series:focusNodeAdjacency"
  }, noop);
  registers.registerAction({
    type: "unfocusNodeAdjacency",
    event: "unfocusNodeAdjacency",
    update: "series:unfocusNodeAdjacency"
  }, noop);
  registers.registerAction(actionInfo$1, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      query: payload
    }, function(seriesModel) {
      var coordSys = seriesModel.coordinateSystem;
      var res = updateCenterAndZoom(coordSys, payload);
      seriesModel.setCenter && seriesModel.setCenter(res.center);
      seriesModel.setZoom && seriesModel.setZoom(res.zoom);
    });
  });
}
var PointerShape = function() {
  function PointerShape2() {
    this.angle = 0;
    this.width = 10;
    this.r = 10;
    this.x = 0;
    this.y = 0;
  }
  return PointerShape2;
}();
var PointerPath = function(_super) {
  __extends(PointerPath2, _super);
  function PointerPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "pointer";
    return _this;
  }
  PointerPath2.prototype.getDefaultShape = function() {
    return new PointerShape();
  };
  PointerPath2.prototype.buildPath = function(ctx, shape) {
    var mathCos2 = Math.cos;
    var mathSin2 = Math.sin;
    var r2 = shape.r;
    var width = shape.width;
    var angle = shape.angle;
    var x2 = shape.x - mathCos2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    var y2 = shape.y - mathSin2(angle) * width * (width >= r2 / 3 ? 1 : 2);
    angle = shape.angle - Math.PI / 2;
    ctx.moveTo(x2, y2);
    ctx.lineTo(shape.x + mathCos2(angle) * width, shape.y + mathSin2(angle) * width);
    ctx.lineTo(shape.x + mathCos2(shape.angle) * r2, shape.y + mathSin2(shape.angle) * r2);
    ctx.lineTo(shape.x - mathCos2(angle) * width, shape.y - mathSin2(angle) * width);
    ctx.lineTo(x2, y2);
  };
  return PointerPath2;
}(Path$1);
var PointerPath$1 = PointerPath;
function parsePosition(seriesModel, api) {
  var center2 = seriesModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  var size = Math.min(width, height);
  var cx = parsePercent(center2[0], api.getWidth());
  var cy = parsePercent(center2[1], api.getHeight());
  var r2 = parsePercent(seriesModel.get("radius"), size / 2);
  return {
    cx,
    cy,
    r: r2
  };
}
function formatLabel(value, labelFormatter) {
  var label = value == null ? "" : value + "";
  if (labelFormatter) {
    if (isString(labelFormatter)) {
      label = labelFormatter.replace("{value}", label);
    } else if (isFunction(labelFormatter)) {
      label = labelFormatter(value);
    }
  }
  return label;
}
var PI2 = Math.PI * 2;
var GaugeView = function(_super) {
  __extends(GaugeView2, _super);
  function GaugeView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeView2.type;
    return _this;
  }
  GaugeView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeAll();
    var colorList = seriesModel.get(["axisLine", "lineStyle", "color"]);
    var posInfo = parsePosition(seriesModel, api);
    this._renderMain(seriesModel, ecModel, api, colorList, posInfo);
    this._data = seriesModel.getData();
  };
  GaugeView2.prototype.dispose = function() {
  };
  GaugeView2.prototype._renderMain = function(seriesModel, ecModel, api, colorList, posInfo) {
    var group = this.group;
    var clockwise = seriesModel.get("clockwise");
    var startAngle = -seriesModel.get("startAngle") / 180 * Math.PI;
    var endAngle = -seriesModel.get("endAngle") / 180 * Math.PI;
    var axisLineModel = seriesModel.getModel("axisLine");
    var roundCap = axisLineModel.get("roundCap");
    var MainPath = roundCap ? Sausage : Sector$1;
    var showAxis = axisLineModel.get("show");
    var lineStyleModel = axisLineModel.getModel("lineStyle");
    var axisLineWidth = lineStyleModel.get("width");
    var angleRangeSpan = !((endAngle - startAngle) % PI2) && endAngle !== startAngle ? PI2 : (endAngle - startAngle) % PI2;
    var prevEndAngle = startAngle;
    for (var i = 0; showAxis && i < colorList.length; i++) {
      var percent = Math.min(Math.max(colorList[i][0], 0), 1);
      endAngle = startAngle + angleRangeSpan * percent;
      var sector = new MainPath({
        shape: {
          startAngle: prevEndAngle,
          endAngle,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0: posInfo.r - axisLineWidth,
          r: posInfo.r
        },
        silent: true
      });
      sector.setStyle({
        fill: colorList[i][1]
      });
      sector.setStyle(lineStyleModel.getLineStyle(["color", "width"]));
      group.add(sector);
      prevEndAngle = endAngle;
    }
    var getColor = function(percent2) {
      if (percent2 <= 0) {
        return colorList[0][1];
      }
      var i2;
      for (i2 = 0; i2 < colorList.length; i2++) {
        if (colorList[i2][0] >= percent2 && (i2 === 0 ? 0 : colorList[i2 - 1][0]) < percent2) {
          return colorList[i2][1];
        }
      }
      return colorList[i2 - 1][1];
    };
    if (!clockwise) {
      var tmp = startAngle;
      startAngle = endAngle;
      endAngle = tmp;
    }
    this._renderTicks(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
    this._renderTitleAndDetail(seriesModel, ecModel, api, getColor, posInfo);
    this._renderAnchor(seriesModel, posInfo);
    this._renderPointer(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth);
  };
  GaugeView2.prototype._renderTicks = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var cx = posInfo.cx;
    var cy = posInfo.cy;
    var r2 = posInfo.r;
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var splitLineModel = seriesModel.getModel("splitLine");
    var tickModel = seriesModel.getModel("axisTick");
    var labelModel = seriesModel.getModel("axisLabel");
    var splitNumber = seriesModel.get("splitNumber");
    var subSplitNumber = tickModel.get("splitNumber");
    var splitLineLen = parsePercent(splitLineModel.get("length"), r2);
    var tickLen = parsePercent(tickModel.get("length"), r2);
    var angle = startAngle;
    var step = (endAngle - startAngle) / splitNumber;
    var subStep = step / subSplitNumber;
    var splitLineStyle = splitLineModel.getModel("lineStyle").getLineStyle();
    var tickLineStyle = tickModel.getModel("lineStyle").getLineStyle();
    var splitLineDistance = splitLineModel.get("distance");
    var unitX;
    var unitY;
    for (var i = 0; i <= splitNumber; i++) {
      unitX = Math.cos(angle);
      unitY = Math.sin(angle);
      if (splitLineModel.get("show")) {
        var distance2 = splitLineDistance ? splitLineDistance + axisLineWidth : axisLineWidth;
        var splitLine = new Line$3({
          shape: {
            x1: unitX * (r2 - distance2) + cx,
            y1: unitY * (r2 - distance2) + cy,
            x2: unitX * (r2 - splitLineLen - distance2) + cx,
            y2: unitY * (r2 - splitLineLen - distance2) + cy
          },
          style: splitLineStyle,
          silent: true
        });
        if (splitLineStyle.stroke === "auto") {
          splitLine.setStyle({
            stroke: getColor(i / splitNumber)
          });
        }
        group.add(splitLine);
      }
      if (labelModel.get("show")) {
        var distance2 = labelModel.get("distance") + splitLineDistance;
        var label = formatLabel(round$3(i / splitNumber * (maxVal - minVal) + minVal), labelModel.get("formatter"));
        var autoColor = getColor(i / splitNumber);
        group.add(new ZRText$1({
          style: createTextStyle(labelModel, {
            text: label,
            x: unitX * (r2 - splitLineLen - distance2) + cx,
            y: unitY * (r2 - splitLineLen - distance2) + cy,
            verticalAlign: unitY < -0.8 ? "top" : unitY > 0.8 ? "bottom" : "middle",
            align: unitX < -0.4 ? "left" : unitX > 0.4 ? "right" : "center"
          }, {
            inheritColor: autoColor
          }),
          silent: true
        }));
      }
      if (tickModel.get("show") && i !== splitNumber) {
        var distance2 = tickModel.get("distance");
        distance2 = distance2 ? distance2 + axisLineWidth : axisLineWidth;
        for (var j = 0; j <= subSplitNumber; j++) {
          unitX = Math.cos(angle);
          unitY = Math.sin(angle);
          var tickLine = new Line$3({
            shape: {
              x1: unitX * (r2 - distance2) + cx,
              y1: unitY * (r2 - distance2) + cy,
              x2: unitX * (r2 - tickLen - distance2) + cx,
              y2: unitY * (r2 - tickLen - distance2) + cy
            },
            silent: true,
            style: tickLineStyle
          });
          if (tickLineStyle.stroke === "auto") {
            tickLine.setStyle({
              stroke: getColor((i + j / subSplitNumber) / splitNumber)
            });
          }
          group.add(tickLine);
          angle += subStep;
        }
        angle -= subStep;
      } else {
        angle += step;
      }
    }
  };
  GaugeView2.prototype._renderPointer = function(seriesModel, ecModel, api, getColor, posInfo, startAngle, endAngle, clockwise, axisLineWidth) {
    var group = this.group;
    var oldData = this._data;
    var oldProgressData = this._progressEls;
    var progressList = [];
    var showPointer2 = seriesModel.get(["pointer", "show"]);
    var progressModel = seriesModel.getModel("progress");
    var showProgress = progressModel.get("show");
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var valueExtent = [minVal, maxVal];
    var angleExtent = [startAngle, endAngle];
    function createPointer(idx, angle) {
      var itemModel = data.getItemModel(idx);
      var pointerModel = itemModel.getModel("pointer");
      var pointerWidth = parsePercent(pointerModel.get("width"), posInfo.r);
      var pointerLength = parsePercent(pointerModel.get("length"), posInfo.r);
      var pointerStr = seriesModel.get(["pointer", "icon"]);
      var pointerOffset = pointerModel.get("offsetCenter");
      var pointerOffsetX = parsePercent(pointerOffset[0], posInfo.r);
      var pointerOffsetY = parsePercent(pointerOffset[1], posInfo.r);
      var pointerKeepAspect = pointerModel.get("keepAspect");
      var pointer;
      if (pointerStr) {
        pointer = createSymbol$1(pointerStr, pointerOffsetX - pointerWidth / 2, pointerOffsetY - pointerLength, pointerWidth, pointerLength, null, pointerKeepAspect);
      } else {
        pointer = new PointerPath$1({
          shape: {
            angle: -Math.PI / 2,
            width: pointerWidth,
            r: pointerLength,
            x: pointerOffsetX,
            y: pointerOffsetY
          }
        });
      }
      pointer.rotation = -(angle + Math.PI / 2);
      pointer.x = posInfo.cx;
      pointer.y = posInfo.cy;
      return pointer;
    }
    function createProgress(idx, endAngle2) {
      var roundCap = progressModel.get("roundCap");
      var ProgressPath = roundCap ? Sausage : Sector$1;
      var isOverlap = progressModel.get("overlap");
      var progressWidth = isOverlap ? progressModel.get("width") : axisLineWidth / data.count();
      var r0 = isOverlap ? posInfo.r - progressWidth : posInfo.r - (idx + 1) * progressWidth;
      var r2 = isOverlap ? posInfo.r : posInfo.r - idx * progressWidth;
      var progress = new ProgressPath({
        shape: {
          startAngle,
          endAngle: endAngle2,
          cx: posInfo.cx,
          cy: posInfo.cy,
          clockwise,
          r0,
          r: r2
        }
      });
      isOverlap && (progress.z2 = maxVal - data.get(valueDim, idx) % maxVal);
      return progress;
    }
    if (showProgress || showPointer2) {
      data.diff(oldData).add(function(idx) {
        var val = data.get(valueDim, idx);
        if (showPointer2) {
          var pointer = createPointer(idx, startAngle);
          initProps(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(idx, pointer);
        }
        if (showProgress) {
          var progress = createProgress(idx, startAngle);
          var isClip = progressModel.get("clip");
          initProps(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, idx, progress);
          progressList[idx] = progress;
        }
      }).update(function(newIdx, oldIdx) {
        var val = data.get(valueDim, newIdx);
        if (showPointer2) {
          var previousPointer = oldData.getItemGraphicEl(oldIdx);
          var previousRotate = previousPointer ? previousPointer.rotation : startAngle;
          var pointer = createPointer(newIdx, previousRotate);
          pointer.rotation = previousRotate;
          updateProps$1(pointer, {
            rotation: -((isNaN(+val) ? angleExtent[0] : linearMap$2(val, valueExtent, angleExtent, true)) + Math.PI / 2)
          }, seriesModel);
          group.add(pointer);
          data.setItemGraphicEl(newIdx, pointer);
        }
        if (showProgress) {
          var previousProgress = oldProgressData[oldIdx];
          var previousEndAngle = previousProgress ? previousProgress.shape.endAngle : startAngle;
          var progress = createProgress(newIdx, previousEndAngle);
          var isClip = progressModel.get("clip");
          updateProps$1(progress, {
            shape: {
              endAngle: linearMap$2(val, valueExtent, angleExtent, isClip)
            }
          }, seriesModel);
          group.add(progress);
          setCommonECData(seriesModel.seriesIndex, data.dataType, newIdx, progress);
          progressList[newIdx] = progress;
        }
      }).execute();
      data.each(function(idx) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel = itemModel.getModel("emphasis");
        var focus = emphasisModel.get("focus");
        var blurScope = emphasisModel.get("blurScope");
        var emphasisDisabled = emphasisModel.get("disabled");
        if (showPointer2) {
          var pointer = data.getItemGraphicEl(idx);
          var symbolStyle = data.getItemVisual(idx, "style");
          var visualColor = symbolStyle.fill;
          if (pointer instanceof ZRImage$1) {
            var pathStyle = pointer.style;
            pointer.useStyle(extend({
              image: pathStyle.image,
              x: pathStyle.x,
              y: pathStyle.y,
              width: pathStyle.width,
              height: pathStyle.height
            }, symbolStyle));
          } else {
            pointer.useStyle(symbolStyle);
            pointer.type !== "pointer" && pointer.setColor(visualColor);
          }
          pointer.setStyle(itemModel.getModel(["pointer", "itemStyle"]).getItemStyle());
          if (pointer.style.fill === "auto") {
            pointer.setStyle("fill", getColor(linearMap$2(data.get(valueDim, idx), valueExtent, [0, 1], true)));
          }
          pointer.z2EmphasisLift = 0;
          setStatesStylesFromModel(pointer, itemModel);
          toggleHoverEmphasis(pointer, focus, blurScope, emphasisDisabled);
        }
        if (showProgress) {
          var progress = progressList[idx];
          progress.useStyle(data.getItemVisual(idx, "style"));
          progress.setStyle(itemModel.getModel(["progress", "itemStyle"]).getItemStyle());
          progress.z2EmphasisLift = 0;
          setStatesStylesFromModel(progress, itemModel);
          toggleHoverEmphasis(progress, focus, blurScope, emphasisDisabled);
        }
      });
      this._progressEls = progressList;
    }
  };
  GaugeView2.prototype._renderAnchor = function(seriesModel, posInfo) {
    var anchorModel = seriesModel.getModel("anchor");
    var showAnchor = anchorModel.get("show");
    if (showAnchor) {
      var anchorSize = anchorModel.get("size");
      var anchorType = anchorModel.get("icon");
      var offsetCenter = anchorModel.get("offsetCenter");
      var anchorKeepAspect = anchorModel.get("keepAspect");
      var anchor = createSymbol$1(anchorType, posInfo.cx - anchorSize / 2 + parsePercent(offsetCenter[0], posInfo.r), posInfo.cy - anchorSize / 2 + parsePercent(offsetCenter[1], posInfo.r), anchorSize, anchorSize, null, anchorKeepAspect);
      anchor.z2 = anchorModel.get("showAbove") ? 1 : 0;
      anchor.setStyle(anchorModel.getModel("itemStyle").getItemStyle());
      this.group.add(anchor);
    }
  };
  GaugeView2.prototype._renderTitleAndDetail = function(seriesModel, ecModel, api, getColor, posInfo) {
    var _this = this;
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var minVal = +seriesModel.get("min");
    var maxVal = +seriesModel.get("max");
    var contentGroup = new Group$4();
    var newTitleEls = [];
    var newDetailEls = [];
    var hasAnimation = seriesModel.isAnimationEnabled();
    var showPointerAbove = seriesModel.get(["pointer", "showAbove"]);
    data.diff(this._data).add(function(idx) {
      newTitleEls[idx] = new ZRText$1({
        silent: true
      });
      newDetailEls[idx] = new ZRText$1({
        silent: true
      });
    }).update(function(idx, oldIdx) {
      newTitleEls[idx] = _this._titleEls[oldIdx];
      newDetailEls[idx] = _this._detailEls[oldIdx];
    }).execute();
    data.each(function(idx) {
      var itemModel = data.getItemModel(idx);
      var value = data.get(valueDim, idx);
      var itemGroup = new Group$4();
      var autoColor = getColor(linearMap$2(value, [minVal, maxVal], [0, 1], true));
      var itemTitleModel = itemModel.getModel("title");
      if (itemTitleModel.get("show")) {
        var titleOffsetCenter = itemTitleModel.get("offsetCenter");
        var titleX = posInfo.cx + parsePercent(titleOffsetCenter[0], posInfo.r);
        var titleY = posInfo.cy + parsePercent(titleOffsetCenter[1], posInfo.r);
        var labelEl = newTitleEls[idx];
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemTitleModel, {
            x: titleX,
            y: titleY,
            text: data.getName(idx),
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: autoColor
          })
        });
        itemGroup.add(labelEl);
      }
      var itemDetailModel = itemModel.getModel("detail");
      if (itemDetailModel.get("show")) {
        var detailOffsetCenter = itemDetailModel.get("offsetCenter");
        var detailX = posInfo.cx + parsePercent(detailOffsetCenter[0], posInfo.r);
        var detailY = posInfo.cy + parsePercent(detailOffsetCenter[1], posInfo.r);
        var width = parsePercent(itemDetailModel.get("width"), posInfo.r);
        var height = parsePercent(itemDetailModel.get("height"), posInfo.r);
        var detailColor = seriesModel.get(["progress", "show"]) ? data.getItemVisual(idx, "style").fill : autoColor;
        var labelEl = newDetailEls[idx];
        var formatter_1 = itemDetailModel.get("formatter");
        labelEl.attr({
          z2: showPointerAbove ? 0 : 2,
          style: createTextStyle(itemDetailModel, {
            x: detailX,
            y: detailY,
            text: formatLabel(value, formatter_1),
            width: isNaN(width) ? null : width,
            height: isNaN(height) ? null : height,
            align: "center",
            verticalAlign: "middle"
          }, {
            inheritColor: detailColor
          })
        });
        setLabelValueAnimation(labelEl, {
          normal: itemDetailModel
        }, value, function(value2) {
          return formatLabel(value2, formatter_1);
        });
        hasAnimation && animateLabelValue(labelEl, idx, data, seriesModel, {
          getFormattedLabel: function(labelDataIndex, status, dataType, labelDimIndex, fmt, extendParams) {
            return formatLabel(extendParams ? extendParams.interpolatedValue : value, formatter_1);
          }
        });
        itemGroup.add(labelEl);
      }
      contentGroup.add(itemGroup);
    });
    this.group.add(contentGroup);
    this._titleEls = newTitleEls;
    this._detailEls = newDetailEls;
  };
  GaugeView2.type = "gauge";
  return GaugeView2;
}(ChartView$1);
var GaugeView$1 = GaugeView;
var GaugeSeriesModel = function(_super) {
  __extends(GaugeSeriesModel2, _super);
  function GaugeSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GaugeSeriesModel2.type;
    _this.visualStyleAccessPath = "itemStyle";
    return _this;
  }
  GaugeSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, ["value"]);
  };
  GaugeSeriesModel2.type = "series.gauge";
  GaugeSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    center: ["50%", "50%"],
    legendHoverLink: true,
    radius: "75%",
    startAngle: 225,
    endAngle: -45,
    clockwise: true,
    min: 0,
    max: 100,
    splitNumber: 10,
    axisLine: {
      show: true,
      roundCap: false,
      lineStyle: {
        color: [[1, "#E6EBF8"]],
        width: 10
      }
    },
    progress: {
      show: false,
      overlap: true,
      width: 10,
      roundCap: false,
      clip: true
    },
    splitLine: {
      show: true,
      length: 10,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 3,
        type: "solid"
      }
    },
    axisTick: {
      show: true,
      splitNumber: 5,
      length: 6,
      distance: 10,
      lineStyle: {
        color: "#63677A",
        width: 1,
        type: "solid"
      }
    },
    axisLabel: {
      show: true,
      distance: 15,
      color: "#464646",
      fontSize: 12
    },
    pointer: {
      icon: null,
      offsetCenter: [0, 0],
      show: true,
      showAbove: true,
      length: "60%",
      width: 6,
      keepAspect: false
    },
    anchor: {
      show: false,
      showAbove: false,
      size: 6,
      icon: "circle",
      offsetCenter: [0, 0],
      keepAspect: false,
      itemStyle: {
        color: "#fff",
        borderWidth: 0,
        borderColor: "#5470c6"
      }
    },
    title: {
      show: true,
      offsetCenter: [0, "20%"],
      color: "#464646",
      fontSize: 16,
      valueAnimation: false
    },
    detail: {
      show: true,
      backgroundColor: "rgba(0,0,0,0)",
      borderWidth: 0,
      borderColor: "#ccc",
      width: 100,
      height: null,
      padding: [5, 10],
      offsetCenter: [0, "40%"],
      color: "#464646",
      fontSize: 30,
      fontWeight: "bold",
      lineHeight: 30,
      valueAnimation: false
    }
  };
  return GaugeSeriesModel2;
}(SeriesModel$1);
var GaugeSeriesModel$1 = GaugeSeriesModel;
function install$E(registers) {
  registers.registerChartView(GaugeView$1);
  registers.registerSeriesModel(GaugeSeriesModel$1);
}
var opacityAccessPath$1 = ["itemStyle", "opacity"];
var FunnelPiece = function(_super) {
  __extends(FunnelPiece2, _super);
  function FunnelPiece2(data, idx) {
    var _this = _super.call(this) || this;
    var polygon = _this;
    var labelLine = new Polyline$3();
    var text = new ZRText$1();
    polygon.setTextContent(text);
    _this.setTextGuideLine(labelLine);
    _this.updateData(data, idx, true);
    return _this;
  }
  FunnelPiece2.prototype.updateData = function(data, idx, firstCreate) {
    var polygon = this;
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var emphasisModel = itemModel.getModel("emphasis");
    var opacity = itemModel.get(opacityAccessPath$1);
    opacity = opacity == null ? 1 : opacity;
    if (!firstCreate) {
      saveOldStyle(polygon);
    }
    polygon.useStyle(data.getItemVisual(idx, "style"));
    polygon.style.lineJoin = "round";
    if (firstCreate) {
      polygon.setShape({
        points: layout2.points
      });
      polygon.style.opacity = 0;
      initProps(polygon, {
        style: {
          opacity
        }
      }, seriesModel, idx);
    } else {
      updateProps$1(polygon, {
        style: {
          opacity
        },
        shape: {
          points: layout2.points
        }
      }, seriesModel, idx);
    }
    setStatesStylesFromModel(polygon, itemModel);
    this._updateLabel(data, idx);
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  FunnelPiece2.prototype._updateLabel = function(data, idx) {
    var polygon = this;
    var labelLine = this.getTextGuideLine();
    var labelText = polygon.getTextContent();
    var seriesModel = data.hostModel;
    var itemModel = data.getItemModel(idx);
    var layout2 = data.getItemLayout(idx);
    var labelLayout2 = layout2.label;
    var style = data.getItemVisual(idx, "style");
    var visualColor = style.fill;
    setLabelStyle(labelText, getLabelStatesModels(itemModel), {
      labelFetcher: data.hostModel,
      labelDataIndex: idx,
      defaultOpacity: style.opacity,
      defaultText: data.getName(idx)
    }, {
      normal: {
        align: labelLayout2.textAlign,
        verticalAlign: labelLayout2.verticalAlign
      }
    });
    polygon.setTextConfig({
      local: true,
      inside: !!labelLayout2.inside,
      insideStroke: visualColor,
      outsideFill: visualColor
    });
    var linePoints = labelLayout2.linePoints;
    labelLine.setShape({
      points: linePoints
    });
    polygon.textGuideLineConfig = {
      anchor: linePoints ? new Point$1(linePoints[0][0], linePoints[0][1]) : null
    };
    updateProps$1(labelText, {
      style: {
        x: labelLayout2.x,
        y: labelLayout2.y
      }
    }, seriesModel, idx);
    labelText.attr({
      rotation: labelLayout2.rotation,
      originX: labelLayout2.x,
      originY: labelLayout2.y,
      z2: 10
    });
    setLabelLineStyle(polygon, getLabelLineStatesModels(itemModel), {
      stroke: visualColor
    });
  };
  return FunnelPiece2;
}(Polygon$1);
var FunnelView = function(_super) {
  __extends(FunnelView2, _super);
  function FunnelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelView2.type;
    _this.ignoreLabelLineUpdate = true;
    return _this;
  }
  FunnelView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    data.diff(oldData).add(function(idx) {
      var funnelPiece = new FunnelPiece(data, idx);
      data.setItemGraphicEl(idx, funnelPiece);
      group.add(funnelPiece);
    }).update(function(newIdx, oldIdx) {
      var piece = oldData.getItemGraphicEl(oldIdx);
      piece.updateData(data, newIdx);
      group.add(piece);
      data.setItemGraphicEl(newIdx, piece);
    }).remove(function(idx) {
      var piece = oldData.getItemGraphicEl(idx);
      removeElementWithFadeOut(piece, seriesModel, idx);
    }).execute();
    this._data = data;
  };
  FunnelView2.prototype.remove = function() {
    this.group.removeAll();
    this._data = null;
  };
  FunnelView2.prototype.dispose = function() {
  };
  FunnelView2.type = "funnel";
  return FunnelView2;
}(ChartView$1);
var FunnelView$1 = FunnelView;
var FunnelSeriesModel = function(_super) {
  __extends(FunnelSeriesModel2, _super);
  function FunnelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = FunnelSeriesModel2.type;
    return _this;
  }
  FunnelSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
    this._defaultLabelLine(option);
  };
  FunnelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesDataSimply(this, {
      coordDimensions: ["value"],
      encodeDefaulter: curry$1(makeSeriesEncodeForNameBased, this)
    });
  };
  FunnelSeriesModel2.prototype._defaultLabelLine = function(option) {
    defaultEmphasis(option, "labelLine", ["show"]);
    var labelLineNormalOpt = option.labelLine;
    var labelLineEmphasisOpt = option.emphasis.labelLine;
    labelLineNormalOpt.show = labelLineNormalOpt.show && option.label.show;
    labelLineEmphasisOpt.show = labelLineEmphasisOpt.show && option.emphasis.label.show;
  };
  FunnelSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var data = this.getData();
    var params = _super.prototype.getDataParams.call(this, dataIndex);
    var valueDim = data.mapDimension("value");
    var sum2 = data.getSum(valueDim);
    params.percent = !sum2 ? 0 : +(data.get(valueDim, dataIndex) / sum2 * 100).toFixed(2);
    params.$vars.push("percent");
    return params;
  };
  FunnelSeriesModel2.type = "series.funnel";
  FunnelSeriesModel2.defaultOption = {
    z: 2,
    legendHoverLink: true,
    colorBy: "data",
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    minSize: "0%",
    maxSize: "100%",
    sort: "descending",
    orient: "vertical",
    gap: 0,
    funnelAlign: "center",
    label: {
      show: true,
      position: "outer"
    },
    labelLine: {
      show: true,
      length: 20,
      lineStyle: {
        width: 1
      }
    },
    itemStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return FunnelSeriesModel2;
}(SeriesModel$1);
var FunnelSeriesModel$1 = FunnelSeriesModel;
function getViewRect$2(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function getSortedIndices(data, sort2) {
  var valueDim = data.mapDimension("value");
  var valueArr = data.mapArray(valueDim, function(val) {
    return val;
  });
  var indices = [];
  var isAscending = sort2 === "ascending";
  for (var i = 0, len2 = data.count(); i < len2; i++) {
    indices[i] = i;
  }
  if (isFunction(sort2)) {
    indices.sort(sort2);
  } else if (sort2 !== "none") {
    indices.sort(function(a, b2) {
      return isAscending ? valueArr[a] - valueArr[b2] : valueArr[b2] - valueArr[a];
    });
  }
  return indices;
}
function labelLayout(data) {
  var seriesModel = data.hostModel;
  var orient = seriesModel.get("orient");
  data.each(function(idx) {
    var itemModel = data.getItemModel(idx);
    var labelModel = itemModel.getModel("label");
    var labelPosition = labelModel.get("position");
    var labelLineModel = itemModel.getModel("labelLine");
    var layout2 = data.getItemLayout(idx);
    var points2 = layout2.points;
    var isLabelInside = labelPosition === "inner" || labelPosition === "inside" || labelPosition === "center" || labelPosition === "insideLeft" || labelPosition === "insideRight";
    var textAlign;
    var textX;
    var textY;
    var linePoints;
    if (isLabelInside) {
      if (labelPosition === "insideLeft") {
        textX = (points2[0][0] + points2[3][0]) / 2 + 5;
        textY = (points2[0][1] + points2[3][1]) / 2;
        textAlign = "left";
      } else if (labelPosition === "insideRight") {
        textX = (points2[1][0] + points2[2][0]) / 2 - 5;
        textY = (points2[1][1] + points2[2][1]) / 2;
        textAlign = "right";
      } else {
        textX = (points2[0][0] + points2[1][0] + points2[2][0] + points2[3][0]) / 4;
        textY = (points2[0][1] + points2[1][1] + points2[2][1] + points2[3][1]) / 4;
        textAlign = "center";
      }
      linePoints = [[textX, textY], [textX, textY]];
    } else {
      var x1 = void 0;
      var y1 = void 0;
      var x2 = void 0;
      var y2 = void 0;
      var labelLineLen = labelLineModel.get("length");
      if (labelPosition === "left") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        x2 = x1 - labelLineLen;
        textX = x2 - 5;
        textAlign = "right";
      } else if (labelPosition === "right") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        x2 = x1 + labelLineLen;
        textX = x2 + 5;
        textAlign = "left";
      } else if (labelPosition === "top") {
        x1 = (points2[3][0] + points2[0][0]) / 2;
        y1 = (points2[3][1] + points2[0][1]) / 2;
        y2 = y1 - labelLineLen;
        textY = y2 - 5;
        textAlign = "center";
      } else if (labelPosition === "bottom") {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        y2 = y1 + labelLineLen;
        textY = y2 + 5;
        textAlign = "center";
      } else if (labelPosition === "rightTop") {
        x1 = orient === "horizontal" ? points2[3][0] : points2[1][0];
        y1 = orient === "horizontal" ? points2[3][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "top";
        }
      } else if (labelPosition === "rightBottom") {
        x1 = points2[2][0];
        y1 = points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "bottom";
        }
      } else if (labelPosition === "leftTop") {
        x1 = points2[0][0];
        y1 = orient === "horizontal" ? points2[0][1] : points2[1][1];
        if (orient === "horizontal") {
          y2 = y1 - labelLineLen;
          textY = y2 - 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else if (labelPosition === "leftBottom") {
        x1 = orient === "horizontal" ? points2[1][0] : points2[3][0];
        y1 = orient === "horizontal" ? points2[1][1] : points2[2][1];
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 - labelLineLen;
          textX = x2 - 5;
          textAlign = "right";
        }
      } else {
        x1 = (points2[1][0] + points2[2][0]) / 2;
        y1 = (points2[1][1] + points2[2][1]) / 2;
        if (orient === "horizontal") {
          y2 = y1 + labelLineLen;
          textY = y2 + 5;
          textAlign = "center";
        } else {
          x2 = x1 + labelLineLen;
          textX = x2 + 5;
          textAlign = "left";
        }
      }
      if (orient === "horizontal") {
        x2 = x1;
        textX = x2;
      } else {
        y2 = y1;
        textY = y2;
      }
      linePoints = [[x1, y1], [x2, y2]];
    }
    layout2.label = {
      linePoints,
      x: textX,
      y: textY,
      verticalAlign: "middle",
      textAlign,
      inside: isLabelInside
    };
  });
}
function funnelLayout(ecModel, api) {
  ecModel.eachSeriesByType("funnel", function(seriesModel) {
    var data = seriesModel.getData();
    var valueDim = data.mapDimension("value");
    var sort2 = seriesModel.get("sort");
    var viewRect2 = getViewRect$2(seriesModel, api);
    var orient = seriesModel.get("orient");
    var viewWidth = viewRect2.width;
    var viewHeight = viewRect2.height;
    var indices = getSortedIndices(data, sort2);
    var x2 = viewRect2.x;
    var y2 = viewRect2.y;
    var sizeExtent = orient === "horizontal" ? [parsePercent(seriesModel.get("minSize"), viewHeight), parsePercent(seriesModel.get("maxSize"), viewHeight)] : [parsePercent(seriesModel.get("minSize"), viewWidth), parsePercent(seriesModel.get("maxSize"), viewWidth)];
    var dataExtent = data.getDataExtent(valueDim);
    var min3 = seriesModel.get("min");
    var max3 = seriesModel.get("max");
    if (min3 == null) {
      min3 = Math.min(dataExtent[0], 0);
    }
    if (max3 == null) {
      max3 = dataExtent[1];
    }
    var funnelAlign = seriesModel.get("funnelAlign");
    var gap = seriesModel.get("gap");
    var viewSize = orient === "horizontal" ? viewWidth : viewHeight;
    var itemSize = (viewSize - gap * (data.count() - 1)) / data.count();
    var getLinePoints = function(idx2, offset) {
      if (orient === "horizontal") {
        var val_1 = data.get(valueDim, idx2) || 0;
        var itemHeight = linearMap$2(val_1, [min3, max3], sizeExtent, true);
        var y0 = void 0;
        switch (funnelAlign) {
          case "top":
            y0 = y2;
            break;
          case "center":
            y0 = y2 + (viewHeight - itemHeight) / 2;
            break;
          case "bottom":
            y0 = y2 + (viewHeight - itemHeight);
            break;
        }
        return [[offset, y0], [offset, y0 + itemHeight]];
      }
      var val = data.get(valueDim, idx2) || 0;
      var itemWidth = linearMap$2(val, [min3, max3], sizeExtent, true);
      var x0;
      switch (funnelAlign) {
        case "left":
          x0 = x2;
          break;
        case "center":
          x0 = x2 + (viewWidth - itemWidth) / 2;
          break;
        case "right":
          x0 = x2 + viewWidth - itemWidth;
          break;
      }
      return [[x0, offset], [x0 + itemWidth, offset]];
    };
    if (sort2 === "ascending") {
      itemSize = -itemSize;
      gap = -gap;
      if (orient === "horizontal") {
        x2 += viewWidth;
      } else {
        y2 += viewHeight;
      }
      indices = indices.reverse();
    }
    for (var i = 0; i < indices.length; i++) {
      var idx = indices[i];
      var nextIdx = indices[i + 1];
      var itemModel = data.getItemModel(idx);
      if (orient === "horizontal") {
        var width = itemModel.get(["itemStyle", "width"]);
        if (width == null) {
          width = itemSize;
        } else {
          width = parsePercent(width, viewWidth);
          if (sort2 === "ascending") {
            width = -width;
          }
        }
        var start2 = getLinePoints(idx, x2);
        var end2 = getLinePoints(nextIdx, x2 + width);
        x2 += width + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      } else {
        var height = itemModel.get(["itemStyle", "height"]);
        if (height == null) {
          height = itemSize;
        } else {
          height = parsePercent(height, viewHeight);
          if (sort2 === "ascending") {
            height = -height;
          }
        }
        var start2 = getLinePoints(idx, y2);
        var end2 = getLinePoints(nextIdx, y2 + height);
        y2 += height + gap;
        data.setItemLayout(idx, {
          points: start2.concat(end2.slice().reverse())
        });
      }
    }
    labelLayout(data);
  });
}
function install$D(registers) {
  registers.registerChartView(FunnelView$1);
  registers.registerSeriesModel(FunnelSeriesModel$1);
  registers.registerLayout(funnelLayout);
  registers.registerProcessor(dataFilter$1("funnel"));
}
var DEFAULT_SMOOTH = 0.3;
var ParallelView$2 = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    _this._dataGroup = new Group$4();
    _this._initialized = false;
    return _this;
  }
  ParallelView2.prototype.init = function() {
    this.group.add(this._dataGroup);
  };
  ParallelView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    this._progressiveEls = null;
    var dataGroup = this._dataGroup;
    var data = seriesModel.getData();
    var oldData = this._data;
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    data.diff(oldData).add(add2).update(update).remove(remove).execute();
    function add2(newDataIndex) {
      var line = addEl(data, dataGroup, newDataIndex, dimensions, coordSys);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function update(newDataIndex, oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      var points2 = createLinePoints(data, newDataIndex, dimensions, coordSys);
      data.setItemGraphicEl(newDataIndex, line);
      updateProps$1(line, {
        shape: {
          points: points2
        }
      }, seriesModel, newDataIndex);
      saveOldStyle(line);
      updateElCommon(line, data, newDataIndex, seriesScope);
    }
    function remove(oldDataIndex) {
      var line = oldData.getItemGraphicEl(oldDataIndex);
      dataGroup.remove(line);
    }
    if (!this._initialized) {
      this._initialized = true;
      var clipPath = createGridClipShape$2(coordSys, seriesModel, function() {
        setTimeout(function() {
          dataGroup.removeClipPath();
        });
      });
      dataGroup.setClipPath(clipPath);
    }
    this._data = data;
  };
  ParallelView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._initialized = true;
    this._data = null;
    this._dataGroup.removeAll();
  };
  ParallelView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    var data = seriesModel.getData();
    var coordSys = seriesModel.coordinateSystem;
    var dimensions = coordSys.dimensions;
    var seriesScope = makeSeriesScope(seriesModel);
    var progressiveEls = this._progressiveEls = [];
    for (var dataIndex = taskParams.start; dataIndex < taskParams.end; dataIndex++) {
      var line = addEl(data, this._dataGroup, dataIndex, dimensions, coordSys);
      line.incremental = true;
      updateElCommon(line, data, dataIndex, seriesScope);
      progressiveEls.push(line);
    }
  };
  ParallelView2.prototype.remove = function() {
    this._dataGroup && this._dataGroup.removeAll();
    this._data = null;
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ChartView$1);
function createGridClipShape$2(coordSys, seriesModel, cb) {
  var parallelModel = coordSys.model;
  var rect = coordSys.getRect();
  var rectEl = new Rect$3({
    shape: {
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    }
  });
  var dim = parallelModel.get("layout") === "horizontal" ? "width" : "height";
  rectEl.setShape(dim, 0);
  initProps(rectEl, {
    shape: {
      width: rect.width,
      height: rect.height
    }
  }, seriesModel, cb);
  return rectEl;
}
function createLinePoints(data, dataIndex, dimensions, coordSys) {
  var points2 = [];
  for (var i = 0; i < dimensions.length; i++) {
    var dimName = dimensions[i];
    var value = data.get(data.mapDimension(dimName), dataIndex);
    if (!isEmptyValue$1(value, coordSys.getAxis(dimName).type)) {
      points2.push(coordSys.dataToPoint(value, dimName));
    }
  }
  return points2;
}
function addEl(data, dataGroup, dataIndex, dimensions, coordSys) {
  var points2 = createLinePoints(data, dataIndex, dimensions, coordSys);
  var line = new Polyline$3({
    shape: {
      points: points2
    },
    z2: 10
  });
  dataGroup.add(line);
  data.setItemGraphicEl(dataIndex, line);
  return line;
}
function makeSeriesScope(seriesModel) {
  var smooth = seriesModel.get("smooth", true);
  smooth === true && (smooth = DEFAULT_SMOOTH);
  smooth = numericToNumber(smooth);
  eqNaN(smooth) && (smooth = 0);
  return {
    smooth
  };
}
function updateElCommon(el, data, dataIndex, seriesScope) {
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.fill = null;
  el.setShape("smooth", seriesScope.smooth);
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel, "lineStyle");
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function isEmptyValue$1(val, axisType) {
  return axisType === "category" ? val == null : val == null || isNaN(val);
}
var ParallelView$3 = ParallelView$2;
var ParallelSeriesModel = function(_super) {
  __extends(ParallelSeriesModel2, _super);
  function ParallelSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  ParallelSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: bind$1(makeDefaultEncode, null, this)
    });
  };
  ParallelSeriesModel2.prototype.getRawIndicesByActiveState = function(activeState) {
    var coordSys = this.coordinateSystem;
    var data = this.getData();
    var indices = [];
    coordSys.eachActiveState(data, function(theActiveState, dataIndex) {
      if (activeState === theActiveState) {
        indices.push(data.getRawIndex(dataIndex));
      }
    });
    return indices;
  };
  ParallelSeriesModel2.type = "series.parallel";
  ParallelSeriesModel2.dependencies = ["parallel"];
  ParallelSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "parallel",
    parallelIndex: 0,
    label: {
      show: false
    },
    inactiveOpacity: 0.05,
    activeOpacity: 1,
    lineStyle: {
      width: 1,
      opacity: 0.45,
      type: "solid"
    },
    emphasis: {
      label: {
        show: false
      }
    },
    progressive: 500,
    smooth: false,
    animationEasing: "linear"
  };
  return ParallelSeriesModel2;
}(SeriesModel$1);
function makeDefaultEncode(seriesModel) {
  var parallelModel = seriesModel.ecModel.getComponent("parallel", seriesModel.get("parallelIndex"));
  if (!parallelModel) {
    return;
  }
  var encodeDefine = {};
  each$f(parallelModel.dimensions, function(axisDim) {
    var dataDimIndex = convertDimNameToNumber(axisDim);
    encodeDefine[axisDim] = dataDimIndex;
  });
  return encodeDefine;
}
function convertDimNameToNumber(dimName) {
  return +dimName.replace("dim", "");
}
var ParallelSeriesModel$1 = ParallelSeriesModel;
var opacityAccessPath = ["lineStyle", "opacity"];
var parallelVisual = {
  seriesType: "parallel",
  reset: function(seriesModel, ecModel) {
    var coordSys = seriesModel.coordinateSystem;
    var opacityMap = {
      normal: seriesModel.get(["lineStyle", "opacity"]),
      active: seriesModel.get("activeOpacity"),
      inactive: seriesModel.get("inactiveOpacity")
    };
    return {
      progress: function(params, data) {
        coordSys.eachActiveState(data, function(activeState, dataIndex) {
          var opacity = opacityMap[activeState];
          if (activeState === "normal" && data.hasItemOption) {
            var itemOpacity = data.getItemModel(dataIndex).get(opacityAccessPath, true);
            itemOpacity != null && (opacity = itemOpacity);
          }
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          existsStyle.opacity = opacity;
        }, params.start, params.end);
      }
    };
  }
};
var parallelVisual$1 = parallelVisual;
function parallelPreprocessor(option) {
  createParallelIfNeeded(option);
  mergeAxisOptionFromParallel(option);
}
function createParallelIfNeeded(option) {
  if (option.parallel) {
    return;
  }
  var hasParallelSeries = false;
  each$f(option.series, function(seriesOpt) {
    if (seriesOpt && seriesOpt.type === "parallel") {
      hasParallelSeries = true;
    }
  });
  if (hasParallelSeries) {
    option.parallel = [{}];
  }
}
function mergeAxisOptionFromParallel(option) {
  var axes = normalizeToArray(option.parallelAxis);
  each$f(axes, function(axisOption) {
    if (!isObject$4(axisOption)) {
      return;
    }
    var parallelIndex = axisOption.parallelIndex || 0;
    var parallelOption = normalizeToArray(option.parallel)[parallelIndex];
    if (parallelOption && parallelOption.parallelAxisDefault) {
      merge(axisOption, parallelOption.parallelAxisDefault, false);
    }
  });
}
var CLICK_THRESHOLD = 5;
var ParallelView = function(_super) {
  __extends(ParallelView2, _super);
  function ParallelView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelView2.type;
    return _this;
  }
  ParallelView2.prototype.render = function(parallelModel, ecModel, api) {
    this._model = parallelModel;
    this._api = api;
    if (!this._handlers) {
      this._handlers = {};
      each$f(handlers$1, function(handler, eventName) {
        api.getZr().on(eventName, this._handlers[eventName] = bind$1(handler, this));
      }, this);
    }
    createOrUpdate(this, "_throttledDispatchExpand", parallelModel.get("axisExpandRate"), "fixRate");
  };
  ParallelView2.prototype.dispose = function(ecModel, api) {
    clear$1(this, "_throttledDispatchExpand");
    each$f(this._handlers, function(handler, eventName) {
      api.getZr().off(eventName, handler);
    });
    this._handlers = null;
  };
  ParallelView2.prototype._throttledDispatchExpand = function(opt) {
    this._dispatchExpand(opt);
  };
  ParallelView2.prototype._dispatchExpand = function(opt) {
    opt && this._api.dispatchAction(extend({
      type: "parallelAxisExpand"
    }, opt));
  };
  ParallelView2.type = "parallel";
  return ParallelView2;
}(ComponentView$1);
var handlers$1 = {
  mousedown: function(e2) {
    if (checkTrigger(this, "click")) {
      this._mouseDownPoint = [e2.offsetX, e2.offsetY];
    }
  },
  mouseup: function(e2) {
    var mouseDownPoint = this._mouseDownPoint;
    if (checkTrigger(this, "click") && mouseDownPoint) {
      var point = [e2.offsetX, e2.offsetY];
      var dist2 = Math.pow(mouseDownPoint[0] - point[0], 2) + Math.pow(mouseDownPoint[1] - point[1], 2);
      if (dist2 > CLICK_THRESHOLD) {
        return;
      }
      var result = this._model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
      result.behavior !== "none" && this._dispatchExpand({
        axisExpandWindow: result.axisExpandWindow
      });
    }
    this._mouseDownPoint = null;
  },
  mousemove: function(e2) {
    if (this._mouseDownPoint || !checkTrigger(this, "mousemove")) {
      return;
    }
    var model = this._model;
    var result = model.coordinateSystem.getSlidedAxisExpandWindow([e2.offsetX, e2.offsetY]);
    var behavior = result.behavior;
    behavior === "jump" && this._throttledDispatchExpand.debounceNextCall(model.get("axisExpandDebounce"));
    this._throttledDispatchExpand(behavior === "none" ? null : {
      axisExpandWindow: result.axisExpandWindow,
      animation: behavior === "jump" ? null : {
        duration: 0
      }
    });
  }
};
function checkTrigger(view, triggerOn) {
  var model = view._model;
  return model.get("axisExpandable") && model.get("axisExpandTriggerOn") === triggerOn;
}
var ParallelView$1 = ParallelView;
var ParallelModel = function(_super) {
  __extends(ParallelModel2, _super);
  function ParallelModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelModel2.type;
    return _this;
  }
  ParallelModel2.prototype.init = function() {
    _super.prototype.init.apply(this, arguments);
    this.mergeOption({});
  };
  ParallelModel2.prototype.mergeOption = function(newOption) {
    var thisOption = this.option;
    newOption && merge(thisOption, newOption, true);
    this._initDimensions();
  };
  ParallelModel2.prototype.contains = function(model, ecModel) {
    var parallelIndex = model.get("parallelIndex");
    return parallelIndex != null && ecModel.getComponent("parallel", parallelIndex) === this;
  };
  ParallelModel2.prototype.setAxisExpand = function(opt) {
    each$f(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(name) {
      if (opt.hasOwnProperty(name)) {
        this.option[name] = opt[name];
      }
    }, this);
  };
  ParallelModel2.prototype._initDimensions = function() {
    var dimensions = this.dimensions = [];
    var parallelAxisIndex = this.parallelAxisIndex = [];
    var axisModels = filter(this.ecModel.queryComponents({
      mainType: "parallelAxis"
    }), function(axisModel) {
      return (axisModel.get("parallelIndex") || 0) === this.componentIndex;
    }, this);
    each$f(axisModels, function(axisModel) {
      dimensions.push("dim" + axisModel.get("dim"));
      parallelAxisIndex.push(axisModel.componentIndex);
    });
  };
  ParallelModel2.type = "parallel";
  ParallelModel2.dependencies = ["parallelAxis"];
  ParallelModel2.layoutMode = "box";
  ParallelModel2.defaultOption = {
    z: 0,
    left: 80,
    top: 60,
    right: 80,
    bottom: 60,
    layout: "horizontal",
    axisExpandable: false,
    axisExpandCenter: null,
    axisExpandCount: 0,
    axisExpandWidth: 50,
    axisExpandRate: 17,
    axisExpandDebounce: 50,
    axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4],
    axisExpandTriggerOn: "click",
    parallelAxisDefault: null
  };
  return ParallelModel2;
}(ComponentModel$1);
var ParallelModel$1 = ParallelModel;
var ParallelAxis = function(_super) {
  __extends(ParallelAxis2, _super);
  function ParallelAxis2(dim, scale2, coordExtent, axisType, axisIndex) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.axisIndex = axisIndex;
    return _this;
  }
  ParallelAxis2.prototype.isHorizontal = function() {
    return this.coordinateSystem.getModel().get("layout") !== "horizontal";
  };
  return ParallelAxis2;
}(Axis$1);
var ParallelAxis$1 = ParallelAxis;
function sliderMove(delta, handleEnds, extent3, handleIndex, minSpan, maxSpan) {
  delta = delta || 0;
  var extentSpan = extent3[1] - extent3[0];
  if (minSpan != null) {
    minSpan = restrict$1(minSpan, [0, extentSpan]);
  }
  if (maxSpan != null) {
    maxSpan = Math.max(maxSpan, minSpan != null ? minSpan : 0);
  }
  if (handleIndex === "all") {
    var handleSpan = Math.abs(handleEnds[1] - handleEnds[0]);
    handleSpan = restrict$1(handleSpan, [0, extentSpan]);
    minSpan = maxSpan = restrict$1(handleSpan, [minSpan, maxSpan]);
    handleIndex = 0;
  }
  handleEnds[0] = restrict$1(handleEnds[0], extent3);
  handleEnds[1] = restrict$1(handleEnds[1], extent3);
  var originalDistSign = getSpanSign(handleEnds, handleIndex);
  handleEnds[handleIndex] += delta;
  var extentMinSpan = minSpan || 0;
  var realExtent = extent3.slice();
  originalDistSign.sign < 0 ? realExtent[0] += extentMinSpan : realExtent[1] -= extentMinSpan;
  handleEnds[handleIndex] = restrict$1(handleEnds[handleIndex], realExtent);
  var currDistSign;
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (minSpan != null && (currDistSign.sign !== originalDistSign.sign || currDistSign.span < minSpan)) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + originalDistSign.sign * minSpan;
  }
  currDistSign = getSpanSign(handleEnds, handleIndex);
  if (maxSpan != null && currDistSign.span > maxSpan) {
    handleEnds[1 - handleIndex] = handleEnds[handleIndex] + currDistSign.sign * maxSpan;
  }
  return handleEnds;
}
function getSpanSign(handleEnds, handleIndex) {
  var dist2 = handleEnds[handleIndex] - handleEnds[1 - handleIndex];
  return {
    span: Math.abs(dist2),
    sign: dist2 > 0 ? -1 : dist2 < 0 ? 1 : handleIndex ? -1 : 1
  };
}
function restrict$1(value, extend2) {
  return Math.min(extend2[1] != null ? extend2[1] : Infinity, Math.max(extend2[0] != null ? extend2[0] : -Infinity, value));
}
var each$a = each$f;
var mathMin$2 = Math.min;
var mathMax$2 = Math.max;
var mathFloor = Math.floor;
var mathCeil = Math.ceil;
var round = round$3;
var PI$1 = Math.PI;
var Parallel = function() {
  function Parallel2(parallelModel, ecModel, api) {
    this.type = "parallel";
    this._axesMap = createHashMap();
    this._axesLayout = {};
    this.dimensions = parallelModel.dimensions;
    this._model = parallelModel;
    this._init(parallelModel, ecModel, api);
  }
  Parallel2.prototype._init = function(parallelModel, ecModel, api) {
    var dimensions = parallelModel.dimensions;
    var parallelAxisIndex = parallelModel.parallelAxisIndex;
    each$a(dimensions, function(dim, idx) {
      var axisIndex = parallelAxisIndex[idx];
      var axisModel = ecModel.getComponent("parallelAxis", axisIndex);
      var axis = this._axesMap.set(dim, new ParallelAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisIndex));
      var isCategory2 = axis.type === "category";
      axis.onBand = isCategory2 && axisModel.get("boundaryGap");
      axis.inverse = axisModel.get("inverse");
      axisModel.axis = axis;
      axis.model = axisModel;
      axis.coordinateSystem = axisModel.coordinateSystem = this;
    }, this);
  };
  Parallel2.prototype.update = function(ecModel, api) {
    this._updateAxesFromSeries(this._model, ecModel);
  };
  Parallel2.prototype.containPoint = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var axisBase = layoutInfo.axisBase;
    var layoutBase = layoutInfo.layoutBase;
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var pAxis = point[1 - pixelDimIndex];
    var pLayout = point[pixelDimIndex];
    return pAxis >= axisBase && pAxis <= axisBase + layoutInfo.axisLength && pLayout >= layoutBase && pLayout <= layoutBase + layoutInfo.layoutLength;
  };
  Parallel2.prototype.getModel = function() {
    return this._model;
  };
  Parallel2.prototype._updateAxesFromSeries = function(parallelModel, ecModel) {
    ecModel.eachSeries(function(seriesModel) {
      if (!parallelModel.contains(seriesModel, ecModel)) {
        return;
      }
      var data = seriesModel.getData();
      each$a(this.dimensions, function(dim) {
        var axis = this._axesMap.get(dim);
        axis.scale.unionExtentFromData(data, data.mapDimension(dim));
        niceScaleExtent(axis.scale, axis.model);
      }, this);
    }, this);
  };
  Parallel2.prototype.resize = function(parallelModel, api) {
    this._rect = getLayoutRect(parallelModel.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._layoutAxes();
  };
  Parallel2.prototype.getRect = function() {
    return this._rect;
  };
  Parallel2.prototype._makeLayoutInfo = function() {
    var parallelModel = this._model;
    var rect = this._rect;
    var xy = ["x", "y"];
    var wh = ["width", "height"];
    var layout2 = parallelModel.get("layout");
    var pixelDimIndex = layout2 === "horizontal" ? 0 : 1;
    var layoutLength = rect[wh[pixelDimIndex]];
    var layoutExtent = [0, layoutLength];
    var axisCount = this.dimensions.length;
    var axisExpandWidth = restrict(parallelModel.get("axisExpandWidth"), layoutExtent);
    var axisExpandCount = restrict(parallelModel.get("axisExpandCount") || 0, [0, axisCount]);
    var axisExpandable = parallelModel.get("axisExpandable") && axisCount > 3 && axisCount > axisExpandCount && axisExpandCount > 1 && axisExpandWidth > 0 && layoutLength > 0;
    var axisExpandWindow = parallelModel.get("axisExpandWindow");
    var winSize;
    if (!axisExpandWindow) {
      winSize = restrict(axisExpandWidth * (axisExpandCount - 1), layoutExtent);
      var axisExpandCenter = parallelModel.get("axisExpandCenter") || mathFloor(axisCount / 2);
      axisExpandWindow = [axisExpandWidth * axisExpandCenter - winSize / 2];
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    } else {
      winSize = restrict(axisExpandWindow[1] - axisExpandWindow[0], layoutExtent);
      axisExpandWindow[1] = axisExpandWindow[0] + winSize;
    }
    var axisCollapseWidth = (layoutLength - winSize) / (axisCount - axisExpandCount);
    axisCollapseWidth < 3 && (axisCollapseWidth = 0);
    var winInnerIndices = [mathFloor(round(axisExpandWindow[0] / axisExpandWidth, 1)) + 1, mathCeil(round(axisExpandWindow[1] / axisExpandWidth, 1)) - 1];
    var axisExpandWindow0Pos = axisCollapseWidth / axisExpandWidth * axisExpandWindow[0];
    return {
      layout: layout2,
      pixelDimIndex,
      layoutBase: rect[xy[pixelDimIndex]],
      layoutLength,
      axisBase: rect[xy[1 - pixelDimIndex]],
      axisLength: rect[wh[1 - pixelDimIndex]],
      axisExpandable,
      axisExpandWidth,
      axisCollapseWidth,
      axisExpandWindow,
      axisCount,
      winInnerIndices,
      axisExpandWindow0Pos
    };
  };
  Parallel2.prototype._layoutAxes = function() {
    var rect = this._rect;
    var axes = this._axesMap;
    var dimensions = this.dimensions;
    var layoutInfo = this._makeLayoutInfo();
    var layout2 = layoutInfo.layout;
    axes.each(function(axis) {
      var axisExtent = [0, layoutInfo.axisLength];
      var idx = axis.inverse ? 1 : 0;
      axis.setExtent(axisExtent[idx], axisExtent[1 - idx]);
    });
    each$a(dimensions, function(dim, idx) {
      var posInfo = (layoutInfo.axisExpandable ? layoutAxisWithExpand : layoutAxisWithoutExpand)(idx, layoutInfo);
      var positionTable = {
        horizontal: {
          x: posInfo.position,
          y: layoutInfo.axisLength
        },
        vertical: {
          x: 0,
          y: posInfo.position
        }
      };
      var rotationTable = {
        horizontal: PI$1 / 2,
        vertical: 0
      };
      var position2 = [positionTable[layout2].x + rect.x, positionTable[layout2].y + rect.y];
      var rotation = rotationTable[layout2];
      var transform2 = create$1();
      rotate(transform2, transform2, rotation);
      translate(transform2, transform2, position2);
      this._axesLayout[dim] = {
        position: position2,
        rotation,
        transform: transform2,
        axisNameAvailableWidth: posInfo.axisNameAvailableWidth,
        axisLabelShow: posInfo.axisLabelShow,
        nameTruncateMaxWidth: posInfo.nameTruncateMaxWidth,
        tickDirection: 1,
        labelDirection: 1
      };
    }, this);
  };
  Parallel2.prototype.getAxis = function(dim) {
    return this._axesMap.get(dim);
  };
  Parallel2.prototype.dataToPoint = function(value, dim) {
    return this.axisCoordToPoint(this._axesMap.get(dim).dataToCoord(value), dim);
  };
  Parallel2.prototype.eachActiveState = function(data, callback, start2, end2) {
    start2 == null && (start2 = 0);
    end2 == null && (end2 = data.count());
    var axesMap = this._axesMap;
    var dimensions = this.dimensions;
    var dataDimensions = [];
    var axisModels = [];
    each$f(dimensions, function(axisDim) {
      dataDimensions.push(data.mapDimension(axisDim));
      axisModels.push(axesMap.get(axisDim).model);
    });
    var hasActiveSet = this.hasAxisBrushed();
    for (var dataIndex = start2; dataIndex < end2; dataIndex++) {
      var activeState = void 0;
      if (!hasActiveSet) {
        activeState = "normal";
      } else {
        activeState = "active";
        var values = data.getValues(dataDimensions, dataIndex);
        for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
          var state = axisModels[j].getActiveState(values[j]);
          if (state === "inactive") {
            activeState = "inactive";
            break;
          }
        }
      }
      callback(activeState, dataIndex);
    }
  };
  Parallel2.prototype.hasAxisBrushed = function() {
    var dimensions = this.dimensions;
    var axesMap = this._axesMap;
    var hasActiveSet = false;
    for (var j = 0, lenj = dimensions.length; j < lenj; j++) {
      if (axesMap.get(dimensions[j]).model.getActiveState() !== "normal") {
        hasActiveSet = true;
      }
    }
    return hasActiveSet;
  };
  Parallel2.prototype.axisCoordToPoint = function(coord, dim) {
    var axisLayout = this._axesLayout[dim];
    return applyTransform([coord, 0], axisLayout.transform);
  };
  Parallel2.prototype.getAxisLayout = function(dim) {
    return clone$4(this._axesLayout[dim]);
  };
  Parallel2.prototype.getSlidedAxisExpandWindow = function(point) {
    var layoutInfo = this._makeLayoutInfo();
    var pixelDimIndex = layoutInfo.pixelDimIndex;
    var axisExpandWindow = layoutInfo.axisExpandWindow.slice();
    var winSize = axisExpandWindow[1] - axisExpandWindow[0];
    var extent3 = [0, layoutInfo.axisExpandWidth * (layoutInfo.axisCount - 1)];
    if (!this.containPoint(point)) {
      return {
        behavior: "none",
        axisExpandWindow
      };
    }
    var pointCoord = point[pixelDimIndex] - layoutInfo.layoutBase - layoutInfo.axisExpandWindow0Pos;
    var delta;
    var behavior = "slide";
    var axisCollapseWidth = layoutInfo.axisCollapseWidth;
    var triggerArea = this._model.get("axisExpandSlideTriggerArea");
    var useJump = triggerArea[0] != null;
    if (axisCollapseWidth) {
      if (useJump && axisCollapseWidth && pointCoord < winSize * triggerArea[0]) {
        behavior = "jump";
        delta = pointCoord - winSize * triggerArea[2];
      } else if (useJump && axisCollapseWidth && pointCoord > winSize * (1 - triggerArea[0])) {
        behavior = "jump";
        delta = pointCoord - winSize * (1 - triggerArea[2]);
      } else {
        (delta = pointCoord - winSize * triggerArea[1]) >= 0 && (delta = pointCoord - winSize * (1 - triggerArea[1])) <= 0 && (delta = 0);
      }
      delta *= layoutInfo.axisExpandWidth / axisCollapseWidth;
      delta ? sliderMove(delta, axisExpandWindow, extent3, "all") : behavior = "none";
    } else {
      var winSize2 = axisExpandWindow[1] - axisExpandWindow[0];
      var pos = extent3[1] * pointCoord / winSize2;
      axisExpandWindow = [mathMax$2(0, pos - winSize2 / 2)];
      axisExpandWindow[1] = mathMin$2(extent3[1], axisExpandWindow[0] + winSize2);
      axisExpandWindow[0] = axisExpandWindow[1] - winSize2;
    }
    return {
      axisExpandWindow,
      behavior
    };
  };
  return Parallel2;
}();
function restrict(len2, extent3) {
  return mathMin$2(mathMax$2(len2, extent3[0]), extent3[1]);
}
function layoutAxisWithoutExpand(axisIndex, layoutInfo) {
  var step = layoutInfo.layoutLength / (layoutInfo.axisCount - 1);
  return {
    position: step * axisIndex,
    axisNameAvailableWidth: step,
    axisLabelShow: true
  };
}
function layoutAxisWithExpand(axisIndex, layoutInfo) {
  var layoutLength = layoutInfo.layoutLength;
  var axisExpandWidth = layoutInfo.axisExpandWidth;
  var axisCount = layoutInfo.axisCount;
  var axisCollapseWidth = layoutInfo.axisCollapseWidth;
  var winInnerIndices = layoutInfo.winInnerIndices;
  var position2;
  var axisNameAvailableWidth = axisCollapseWidth;
  var axisLabelShow = false;
  var nameTruncateMaxWidth;
  if (axisIndex < winInnerIndices[0]) {
    position2 = axisIndex * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  } else if (axisIndex <= winInnerIndices[1]) {
    position2 = layoutInfo.axisExpandWindow0Pos + axisIndex * axisExpandWidth - layoutInfo.axisExpandWindow[0];
    axisNameAvailableWidth = axisExpandWidth;
    axisLabelShow = true;
  } else {
    position2 = layoutLength - (axisCount - 1 - axisIndex) * axisCollapseWidth;
    nameTruncateMaxWidth = axisCollapseWidth;
  }
  return {
    position: position2,
    axisNameAvailableWidth,
    axisLabelShow,
    nameTruncateMaxWidth
  };
}
var Parallel$1 = Parallel;
function createParallelCoordSys(ecModel, api) {
  var coordSysList = [];
  ecModel.eachComponent("parallel", function(parallelModel, idx) {
    var coordSys = new Parallel$1(parallelModel, ecModel, api);
    coordSys.name = "parallel_" + idx;
    coordSys.resize(parallelModel, api);
    parallelModel.coordinateSystem = coordSys;
    coordSys.model = parallelModel;
    coordSysList.push(coordSys);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "parallel") {
      var parallelModel = seriesModel.getReferringComponents("parallel", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = parallelModel.coordinateSystem;
    }
  });
  return coordSysList;
}
var parallelCoordSysCreator = {
  create: createParallelCoordSys
};
var parallelCoordSysCreator$1 = parallelCoordSysCreator;
var ParallelAxisModel = function(_super) {
  __extends(ParallelAxisModel2, _super);
  function ParallelAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisModel2.type;
    _this.activeIntervals = [];
    return _this;
  }
  ParallelAxisModel2.prototype.getAreaSelectStyle = function() {
    return makeStyleMapper([
      ["fill", "color"],
      ["lineWidth", "borderWidth"],
      ["stroke", "borderColor"],
      ["width", "width"],
      ["opacity", "opacity"]
    ])(this.getModel("areaSelectStyle"));
  };
  ParallelAxisModel2.prototype.setActiveIntervals = function(intervals) {
    var activeIntervals = this.activeIntervals = clone$4(intervals);
    if (activeIntervals) {
      for (var i = activeIntervals.length - 1; i >= 0; i--) {
        asc$2(activeIntervals[i]);
      }
    }
  };
  ParallelAxisModel2.prototype.getActiveState = function(value) {
    var activeIntervals = this.activeIntervals;
    if (!activeIntervals.length) {
      return "normal";
    }
    if (value == null || isNaN(+value)) {
      return "inactive";
    }
    if (activeIntervals.length === 1) {
      var interval = activeIntervals[0];
      if (interval[0] <= value && value <= interval[1]) {
        return "active";
      }
    } else {
      for (var i = 0, len2 = activeIntervals.length; i < len2; i++) {
        if (activeIntervals[i][0] <= value && value <= activeIntervals[i][1]) {
          return "active";
        }
      }
    }
    return "inactive";
  };
  return ParallelAxisModel2;
}(ComponentModel$1);
mixin(ParallelAxisModel, AxisModelCommonMixin);
var ParallelAxisModel$1 = ParallelAxisModel;
var BRUSH_PANEL_GLOBAL = true;
var mathMin$1 = Math.min;
var mathMax$1 = Math.max;
var mathPow = Math.pow;
var COVER_Z = 1e4;
var UNSELECT_THRESHOLD = 6;
var MIN_RESIZE_LINE_WIDTH = 6;
var MUTEX_RESOURCE_KEY = "globalPan";
var DIRECTION_MAP = {
  w: [0, 0],
  e: [0, 1],
  n: [1, 0],
  s: [1, 1]
};
var CURSOR_MAP = {
  w: "ew",
  e: "ew",
  n: "ns",
  s: "ns",
  ne: "nesw",
  sw: "nesw",
  nw: "nwse",
  se: "nwse"
};
var DEFAULT_BRUSH_OPT = {
  brushStyle: {
    lineWidth: 2,
    stroke: "rgba(210,219,238,0.3)",
    fill: "#D2DBEE"
  },
  transformable: true,
  brushMode: "single",
  removeOnClick: false
};
var baseUID = 0;
var BrushController = function(_super) {
  __extends(BrushController2, _super);
  function BrushController2(zr) {
    var _this = _super.call(this) || this;
    _this._track = [];
    _this._covers = [];
    _this._handlers = {};
    _this._zr = zr;
    _this.group = new Group$4();
    _this._uid = "brushController_" + baseUID++;
    each$f(pointerHandlers, function(handler, eventName) {
      this._handlers[eventName] = bind$1(handler, this);
    }, _this);
    return _this;
  }
  BrushController2.prototype.enableBrush = function(brushOption) {
    this._brushType && this._doDisableBrush();
    brushOption.brushType && this._doEnableBrush(brushOption);
    return this;
  };
  BrushController2.prototype._doEnableBrush = function(brushOption) {
    var zr = this._zr;
    if (!this._enableGlobalPan) {
      take(zr, MUTEX_RESOURCE_KEY, this._uid);
    }
    each$f(this._handlers, function(handler, eventName) {
      zr.on(eventName, handler);
    });
    this._brushType = brushOption.brushType;
    this._brushOption = merge(clone$4(DEFAULT_BRUSH_OPT), brushOption, true);
  };
  BrushController2.prototype._doDisableBrush = function() {
    var zr = this._zr;
    release(zr, MUTEX_RESOURCE_KEY, this._uid);
    each$f(this._handlers, function(handler, eventName) {
      zr.off(eventName, handler);
    });
    this._brushType = this._brushOption = null;
  };
  BrushController2.prototype.setPanels = function(panelOpts) {
    if (panelOpts && panelOpts.length) {
      var panels_1 = this._panels = {};
      each$f(panelOpts, function(panelOpts2) {
        panels_1[panelOpts2.panelId] = clone$4(panelOpts2);
      });
    } else {
      this._panels = null;
    }
    return this;
  };
  BrushController2.prototype.mount = function(opt) {
    opt = opt || {};
    this._enableGlobalPan = opt.enableGlobalPan;
    var thisGroup = this.group;
    this._zr.add(thisGroup);
    thisGroup.attr({
      x: opt.x || 0,
      y: opt.y || 0,
      rotation: opt.rotation || 0,
      scaleX: opt.scaleX || 1,
      scaleY: opt.scaleY || 1
    });
    this._transform = thisGroup.getLocalTransform();
    return this;
  };
  BrushController2.prototype.updateCovers = function(coverConfigList) {
    coverConfigList = map$1(coverConfigList, function(coverConfig) {
      return merge(clone$4(DEFAULT_BRUSH_OPT), coverConfig, true);
    });
    var tmpIdPrefix = "\0-brush-index-";
    var oldCovers = this._covers;
    var newCovers = this._covers = [];
    var controller = this;
    var creatingCover = this._creatingCover;
    new DataDiffer$1(oldCovers, coverConfigList, oldGetKey, getKey2).add(addOrUpdate).update(addOrUpdate).remove(remove).execute();
    return this;
    function getKey2(brushOption, index2) {
      return (brushOption.id != null ? brushOption.id : tmpIdPrefix + index2) + "-" + brushOption.brushType;
    }
    function oldGetKey(cover, index2) {
      return getKey2(cover.__brushOption, index2);
    }
    function addOrUpdate(newIndex, oldIndex) {
      var newBrushInternal = coverConfigList[newIndex];
      if (oldIndex != null && oldCovers[oldIndex] === creatingCover) {
        newCovers[newIndex] = oldCovers[oldIndex];
      } else {
        var cover = newCovers[newIndex] = oldIndex != null ? (oldCovers[oldIndex].__brushOption = newBrushInternal, oldCovers[oldIndex]) : endCreating(controller, createCover(controller, newBrushInternal));
        updateCoverAfterCreation(controller, cover);
      }
    }
    function remove(oldIndex) {
      if (oldCovers[oldIndex] !== creatingCover) {
        controller.group.remove(oldCovers[oldIndex]);
      }
    }
  };
  BrushController2.prototype.unmount = function() {
    this.enableBrush(false);
    clearCovers(this);
    this._zr.remove(this.group);
    return this;
  };
  BrushController2.prototype.dispose = function() {
    this.unmount();
    this.off();
  };
  return BrushController2;
}(Eventful$1);
function createCover(controller, brushOption) {
  var cover = coverRenderers[brushOption.brushType].createCover(controller, brushOption);
  cover.__brushOption = brushOption;
  updateZ$1(cover, brushOption);
  controller.group.add(cover);
  return cover;
}
function endCreating(controller, creatingCover) {
  var coverRenderer = getCoverRenderer(creatingCover);
  if (coverRenderer.endCreating) {
    coverRenderer.endCreating(controller, creatingCover);
    updateZ$1(creatingCover, creatingCover.__brushOption);
  }
  return creatingCover;
}
function updateCoverShape(controller, cover) {
  var brushOption = cover.__brushOption;
  getCoverRenderer(cover).updateCoverShape(controller, cover, brushOption.range, brushOption);
}
function updateZ$1(cover, brushOption) {
  var z2 = brushOption.z;
  z2 == null && (z2 = COVER_Z);
  cover.traverse(function(el) {
    el.z = z2;
    el.z2 = z2;
  });
}
function updateCoverAfterCreation(controller, cover) {
  getCoverRenderer(cover).updateCommon(controller, cover);
  updateCoverShape(controller, cover);
}
function getCoverRenderer(cover) {
  return coverRenderers[cover.__brushOption.brushType];
}
function getPanelByPoint(controller, e2, localCursorPoint) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panel;
  var transform2 = controller._transform;
  each$f(panels, function(pn) {
    pn.isTargetByCursor(e2, localCursorPoint, transform2) && (panel = pn);
  });
  return panel;
}
function getPanelByCover(controller, cover) {
  var panels = controller._panels;
  if (!panels) {
    return BRUSH_PANEL_GLOBAL;
  }
  var panelId = cover.__brushOption.panelId;
  return panelId != null ? panels[panelId] : BRUSH_PANEL_GLOBAL;
}
function clearCovers(controller) {
  var covers = controller._covers;
  var originalLength = covers.length;
  each$f(covers, function(cover) {
    controller.group.remove(cover);
  }, controller);
  covers.length = 0;
  return !!originalLength;
}
function trigger(controller, opt) {
  var areas = map$1(controller._covers, function(cover) {
    var brushOption = cover.__brushOption;
    var range3 = clone$4(brushOption.range);
    return {
      brushType: brushOption.brushType,
      panelId: brushOption.panelId,
      range: range3
    };
  });
  controller.trigger("brush", {
    areas,
    isEnd: !!opt.isEnd,
    removeOnClick: !!opt.removeOnClick
  });
}
function shouldShowCover(controller) {
  var track = controller._track;
  if (!track.length) {
    return false;
  }
  var p2 = track[track.length - 1];
  var p1 = track[0];
  var dx = p2[0] - p1[0];
  var dy = p2[1] - p1[1];
  var dist2 = mathPow(dx * dx + dy * dy, 0.5);
  return dist2 > UNSELECT_THRESHOLD;
}
function getTrackEnds(track) {
  var tail = track.length - 1;
  tail < 0 && (tail = 0);
  return [track[0], track[tail]];
}
function createBaseRectCover(rectRangeConverter, controller, brushOption, edgeNameSequences) {
  var cover = new Group$4();
  cover.add(new Rect$3({
    name: "main",
    style: makeStyle(brushOption),
    silent: true,
    draggable: true,
    cursor: "move",
    drift: curry$1(driftRect, rectRangeConverter, controller, cover, ["n", "s", "w", "e"]),
    ondragend: curry$1(trigger, controller, {
      isEnd: true
    })
  }));
  each$f(edgeNameSequences, function(nameSequence) {
    cover.add(new Rect$3({
      name: nameSequence.join(""),
      style: {
        opacity: 0
      },
      draggable: true,
      silent: true,
      invisible: true,
      drift: curry$1(driftRect, rectRangeConverter, controller, cover, nameSequence),
      ondragend: curry$1(trigger, controller, {
        isEnd: true
      })
    }));
  });
  return cover;
}
function updateBaseRect(controller, cover, localRange, brushOption) {
  var lineWidth = brushOption.brushStyle.lineWidth || 0;
  var handleSize = mathMax$1(lineWidth, MIN_RESIZE_LINE_WIDTH);
  var x2 = localRange[0][0];
  var y2 = localRange[1][0];
  var xa = x2 - lineWidth / 2;
  var ya = y2 - lineWidth / 2;
  var x22 = localRange[0][1];
  var y22 = localRange[1][1];
  var x2a = x22 - handleSize + lineWidth / 2;
  var y2a = y22 - handleSize + lineWidth / 2;
  var width = x22 - x2;
  var height = y22 - y2;
  var widtha = width + lineWidth;
  var heighta = height + lineWidth;
  updateRectShape(controller, cover, "main", x2, y2, width, height);
  if (brushOption.transformable) {
    updateRectShape(controller, cover, "w", xa, ya, handleSize, heighta);
    updateRectShape(controller, cover, "e", x2a, ya, handleSize, heighta);
    updateRectShape(controller, cover, "n", xa, ya, widtha, handleSize);
    updateRectShape(controller, cover, "s", xa, y2a, widtha, handleSize);
    updateRectShape(controller, cover, "nw", xa, ya, handleSize, handleSize);
    updateRectShape(controller, cover, "ne", x2a, ya, handleSize, handleSize);
    updateRectShape(controller, cover, "sw", xa, y2a, handleSize, handleSize);
    updateRectShape(controller, cover, "se", x2a, y2a, handleSize, handleSize);
  }
}
function updateCommon$1(controller, cover) {
  var brushOption = cover.__brushOption;
  var transformable = brushOption.transformable;
  var mainEl = cover.childAt(0);
  mainEl.useStyle(makeStyle(brushOption));
  mainEl.attr({
    silent: !transformable,
    cursor: transformable ? "move" : "default"
  });
  each$f([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(nameSequence) {
    var el = cover.childOfName(nameSequence.join(""));
    var globalDir = nameSequence.length === 1 ? getGlobalDirection1(controller, nameSequence[0]) : getGlobalDirection2(controller, nameSequence);
    el && el.attr({
      silent: !transformable,
      invisible: !transformable,
      cursor: transformable ? CURSOR_MAP[globalDir] + "-resize" : null
    });
  });
}
function updateRectShape(controller, cover, name, x2, y2, w2, h) {
  var el = cover.childOfName(name);
  el && el.setShape(pointsToRect(clipByPanel(controller, cover, [[x2, y2], [x2 + w2, y2 + h]])));
}
function makeStyle(brushOption) {
  return defaults({
    strokeNoScale: true
  }, brushOption.brushStyle);
}
function formatRectRange(x2, y2, x22, y22) {
  var min3 = [mathMin$1(x2, x22), mathMin$1(y2, y22)];
  var max3 = [mathMax$1(x2, x22), mathMax$1(y2, y22)];
  return [
    [min3[0], max3[0]],
    [min3[1], max3[1]]
  ];
}
function getTransform(controller) {
  return getTransform$1(controller.group);
}
function getGlobalDirection1(controller, localDirName) {
  var map2 = {
    w: "left",
    e: "right",
    n: "top",
    s: "bottom"
  };
  var inverseMap = {
    left: "w",
    right: "e",
    top: "n",
    bottom: "s"
  };
  var dir3 = transformDirection(map2[localDirName], getTransform(controller));
  return inverseMap[dir3];
}
function getGlobalDirection2(controller, localDirNameSeq) {
  var globalDir = [getGlobalDirection1(controller, localDirNameSeq[0]), getGlobalDirection1(controller, localDirNameSeq[1])];
  (globalDir[0] === "e" || globalDir[0] === "w") && globalDir.reverse();
  return globalDir.join("");
}
function driftRect(rectRangeConverter, controller, cover, dirNameSequence, dx, dy) {
  var brushOption = cover.__brushOption;
  var rectRange = rectRangeConverter.toRectRange(brushOption.range);
  var localDelta = toLocalDelta(controller, dx, dy);
  each$f(dirNameSequence, function(dirName) {
    var ind = DIRECTION_MAP[dirName];
    rectRange[ind[0]][ind[1]] += localDelta[ind[0]];
  });
  brushOption.range = rectRangeConverter.fromRectRange(formatRectRange(rectRange[0][0], rectRange[1][0], rectRange[0][1], rectRange[1][1]));
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function driftPolygon(controller, cover, dx, dy) {
  var range3 = cover.__brushOption.range;
  var localDelta = toLocalDelta(controller, dx, dy);
  each$f(range3, function(point) {
    point[0] += localDelta[0];
    point[1] += localDelta[1];
  });
  updateCoverAfterCreation(controller, cover);
  trigger(controller, {
    isEnd: false
  });
}
function toLocalDelta(controller, dx, dy) {
  var thisGroup = controller.group;
  var localD = thisGroup.transformCoordToLocal(dx, dy);
  var localZero = thisGroup.transformCoordToLocal(0, 0);
  return [localD[0] - localZero[0], localD[1] - localZero[1]];
}
function clipByPanel(controller, cover, data) {
  var panel = getPanelByCover(controller, cover);
  return panel && panel !== BRUSH_PANEL_GLOBAL ? panel.clipPath(data, controller._transform) : clone$4(data);
}
function pointsToRect(points2) {
  var xmin = mathMin$1(points2[0][0], points2[1][0]);
  var ymin = mathMin$1(points2[0][1], points2[1][1]);
  var xmax = mathMax$1(points2[0][0], points2[1][0]);
  var ymax = mathMax$1(points2[0][1], points2[1][1]);
  return {
    x: xmin,
    y: ymin,
    width: xmax - xmin,
    height: ymax - ymin
  };
}
function resetCursor(controller, e2, localCursorPoint) {
  if (!controller._brushType || isOutsideZrArea(controller, e2.offsetX, e2.offsetY)) {
    return;
  }
  var zr = controller._zr;
  var covers = controller._covers;
  var currPanel = getPanelByPoint(controller, e2, localCursorPoint);
  if (!controller._dragging) {
    for (var i = 0; i < covers.length; i++) {
      var brushOption = covers[i].__brushOption;
      if (currPanel && (currPanel === BRUSH_PANEL_GLOBAL || brushOption.panelId === currPanel.panelId) && coverRenderers[brushOption.brushType].contain(covers[i], localCursorPoint[0], localCursorPoint[1])) {
        return;
      }
    }
  }
  currPanel && zr.setCursorStyle("crosshair");
}
function preventDefault(e2) {
  var rawE = e2.event;
  rawE.preventDefault && rawE.preventDefault();
}
function mainShapeContain(cover, x2, y2) {
  return cover.childOfName("main").contain(x2, y2);
}
function updateCoverByMouse(controller, e2, localCursorPoint, isEnd) {
  var creatingCover = controller._creatingCover;
  var panel = controller._creatingPanel;
  var thisBrushOption = controller._brushOption;
  var eventParams;
  controller._track.push(localCursorPoint.slice());
  if (shouldShowCover(controller) || creatingCover) {
    if (panel && !creatingCover) {
      thisBrushOption.brushMode === "single" && clearCovers(controller);
      var brushOption = clone$4(thisBrushOption);
      brushOption.brushType = determineBrushType(brushOption.brushType, panel);
      brushOption.panelId = panel === BRUSH_PANEL_GLOBAL ? null : panel.panelId;
      creatingCover = controller._creatingCover = createCover(controller, brushOption);
      controller._covers.push(creatingCover);
    }
    if (creatingCover) {
      var coverRenderer = coverRenderers[determineBrushType(controller._brushType, panel)];
      var coverBrushOption = creatingCover.__brushOption;
      coverBrushOption.range = coverRenderer.getCreatingRange(clipByPanel(controller, creatingCover, controller._track));
      if (isEnd) {
        endCreating(controller, creatingCover);
        coverRenderer.updateCommon(controller, creatingCover);
      }
      updateCoverShape(controller, creatingCover);
      eventParams = {
        isEnd
      };
    }
  } else if (isEnd && thisBrushOption.brushMode === "single" && thisBrushOption.removeOnClick) {
    if (getPanelByPoint(controller, e2, localCursorPoint) && clearCovers(controller)) {
      eventParams = {
        isEnd,
        removeOnClick: true
      };
    }
  }
  return eventParams;
}
function determineBrushType(brushType, panel) {
  if (brushType === "auto") {
    return panel.defaultBrushType;
  }
  return brushType;
}
var pointerHandlers = {
  mousedown: function(e2) {
    if (this._dragging) {
      handleDragEnd(this, e2);
    } else if (!e2.target || !e2.target.draggable) {
      preventDefault(e2);
      var localCursorPoint = this.group.transformCoordToLocal(e2.offsetX, e2.offsetY);
      this._creatingCover = null;
      var panel = this._creatingPanel = getPanelByPoint(this, e2, localCursorPoint);
      if (panel) {
        this._dragging = true;
        this._track = [localCursorPoint.slice()];
      }
    }
  },
  mousemove: function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = this.group.transformCoordToLocal(x2, y2);
    resetCursor(this, e2, localCursorPoint);
    if (this._dragging) {
      preventDefault(e2);
      var eventParams = updateCoverByMouse(this, e2, localCursorPoint, false);
      eventParams && trigger(this, eventParams);
    }
  },
  mouseup: function(e2) {
    handleDragEnd(this, e2);
  }
};
function handleDragEnd(controller, e2) {
  if (controller._dragging) {
    preventDefault(e2);
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    var localCursorPoint = controller.group.transformCoordToLocal(x2, y2);
    var eventParams = updateCoverByMouse(controller, e2, localCursorPoint, true);
    controller._dragging = false;
    controller._track = [];
    controller._creatingCover = null;
    eventParams && trigger(controller, eventParams);
  }
}
function isOutsideZrArea(controller, x2, y2) {
  var zr = controller._zr;
  return x2 < 0 || x2 > zr.getWidth() || y2 < 0 || y2 > zr.getHeight();
}
var coverRenderers = {
  lineX: getLineRenderer(0),
  lineY: getLineRenderer(1),
  rect: {
    createCover: function(controller, brushOption) {
      function returnInput(range3) {
        return range3;
      }
      return createBaseRectCover({
        toRectRange: returnInput,
        fromRectRange: returnInput
      }, controller, brushOption, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      return formatRectRange(ends[1][0], ends[1][1], ends[0][0], ends[0][1]);
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      updateBaseRect(controller, cover, localRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  },
  polygon: {
    createCover: function(controller, brushOption) {
      var cover = new Group$4();
      cover.add(new Polyline$3({
        name: "main",
        style: makeStyle(brushOption),
        silent: true
      }));
      return cover;
    },
    getCreatingRange: function(localTrack) {
      return localTrack;
    },
    endCreating: function(controller, cover) {
      cover.remove(cover.childAt(0));
      cover.add(new Polygon$1({
        name: "main",
        draggable: true,
        drift: curry$1(driftPolygon, controller, cover),
        ondragend: curry$1(trigger, controller, {
          isEnd: true
        })
      }));
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      cover.childAt(0).setShape({
        points: clipByPanel(controller, cover, localRange)
      });
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  }
};
function getLineRenderer(xyIndex) {
  return {
    createCover: function(controller, brushOption) {
      return createBaseRectCover({
        toRectRange: function(range3) {
          var rectRange = [range3, [0, 100]];
          xyIndex && rectRange.reverse();
          return rectRange;
        },
        fromRectRange: function(rectRange) {
          return rectRange[xyIndex];
        }
      }, controller, brushOption, [[["w"], ["e"]], [["n"], ["s"]]][xyIndex]);
    },
    getCreatingRange: function(localTrack) {
      var ends = getTrackEnds(localTrack);
      var min3 = mathMin$1(ends[0][xyIndex], ends[1][xyIndex]);
      var max3 = mathMax$1(ends[0][xyIndex], ends[1][xyIndex]);
      return [min3, max3];
    },
    updateCoverShape: function(controller, cover, localRange, brushOption) {
      var otherExtent;
      var panel = getPanelByCover(controller, cover);
      if (panel !== BRUSH_PANEL_GLOBAL && panel.getLinearBrushOtherExtent) {
        otherExtent = panel.getLinearBrushOtherExtent(xyIndex);
      } else {
        var zr = controller._zr;
        otherExtent = [0, [zr.getWidth(), zr.getHeight()][1 - xyIndex]];
      }
      var rectRange = [localRange, otherExtent];
      xyIndex && rectRange.reverse();
      updateBaseRect(controller, cover, rectRange, brushOption);
    },
    updateCommon: updateCommon$1,
    contain: mainShapeContain
  };
}
var BrushController$1 = BrushController;
function makeRectPanelClipPath(rect) {
  rect = normalizeRect(rect);
  return function(localPoints) {
    return clipPointsByRect(localPoints, rect);
  };
}
function makeLinearBrushOtherExtent(rect, specifiedXYIndex) {
  rect = normalizeRect(rect);
  return function(xyIndex) {
    var idx = specifiedXYIndex != null ? specifiedXYIndex : xyIndex;
    var brushWidth = idx ? rect.width : rect.height;
    var base2 = idx ? rect.x : rect.y;
    return [base2, base2 + (brushWidth || 0)];
  };
}
function makeRectIsTargetByCursor(rect, api, targetModel) {
  var boundingRect = normalizeRect(rect);
  return function(e2, localCursorPoint) {
    return boundingRect.contain(localCursorPoint[0], localCursorPoint[1]) && !onIrrelevantElement(e2, api, targetModel);
  };
}
function normalizeRect(rect) {
  return BoundingRect$1.create(rect);
}
var elementList$1 = ["axisLine", "axisTickLabel", "axisName"];
var ParallelAxisView = function(_super) {
  __extends(ParallelAxisView2, _super);
  function ParallelAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ParallelAxisView2.type;
    return _this;
  }
  ParallelAxisView2.prototype.init = function(ecModel, api) {
    _super.prototype.init.apply(this, arguments);
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this));
  };
  ParallelAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    if (fromAxisAreaSelect(axisModel, ecModel, payload)) {
      return;
    }
    this.axisModel = axisModel;
    this.api = api;
    this.group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    this.group.add(this._axisGroup);
    if (!axisModel.get("show")) {
      return;
    }
    var coordSysModel = getCoordSysModel(axisModel, ecModel);
    var coordSys = coordSysModel.coordinateSystem;
    var areaSelectStyle = axisModel.getAreaSelectStyle();
    var areaWidth = areaSelectStyle.width;
    var dim = axisModel.axis.dim;
    var axisLayout = coordSys.getAxisLayout(dim);
    var builderOpt = extend({
      strokeContainThreshold: areaWidth
    }, axisLayout);
    var axisBuilder = new AxisBuilder$1(axisModel, builderOpt);
    each$f(elementList$1, axisBuilder.add, axisBuilder);
    this._axisGroup.add(axisBuilder.getGroup());
    this._refreshBrushController(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
  };
  ParallelAxisView2.prototype._refreshBrushController = function(builderOpt, areaSelectStyle, axisModel, coordSysModel, areaWidth, api) {
    var extent3 = axisModel.axis.getExtent();
    var extentLen = extent3[1] - extent3[0];
    var extra = Math.min(30, Math.abs(extentLen) * 0.1);
    var rect = BoundingRect$1.create({
      x: extent3[0],
      y: -areaWidth / 2,
      width: extentLen,
      height: areaWidth
    });
    rect.x -= extra;
    rect.width += 2 * extra;
    this._brushController.mount({
      enableGlobalPan: true,
      rotation: builderOpt.rotation,
      x: builderOpt.position[0],
      y: builderOpt.position[1]
    }).setPanels([{
      panelId: "pl",
      clipPath: makeRectPanelClipPath(rect),
      isTargetByCursor: makeRectIsTargetByCursor(rect, api, coordSysModel),
      getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect, 0)
    }]).enableBrush({
      brushType: "lineX",
      brushStyle: areaSelectStyle,
      removeOnClick: true
    }).updateCovers(getCoverInfoList(axisModel));
  };
  ParallelAxisView2.prototype._onBrush = function(eventParam) {
    var coverInfoList = eventParam.areas;
    var axisModel = this.axisModel;
    var axis = axisModel.axis;
    var intervals = map$1(coverInfoList, function(coverInfo) {
      return [axis.coordToData(coverInfo.range[0], true), axis.coordToData(coverInfo.range[1], true)];
    });
    if (!axisModel.option.realtime === eventParam.isEnd || eventParam.removeOnClick) {
      this.api.dispatchAction({
        type: "axisAreaSelect",
        parallelAxisId: axisModel.id,
        intervals
      });
    }
  };
  ParallelAxisView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  ParallelAxisView2.type = "parallelAxis";
  return ParallelAxisView2;
}(ComponentView$1);
function fromAxisAreaSelect(axisModel, ecModel, payload) {
  return payload && payload.type === "axisAreaSelect" && ecModel.findComponents({
    mainType: "parallelAxis",
    query: payload
  })[0] === axisModel;
}
function getCoverInfoList(axisModel) {
  var axis = axisModel.axis;
  return map$1(axisModel.activeIntervals, function(interval) {
    return {
      brushType: "lineX",
      panelId: "pl",
      range: [axis.dataToCoord(interval[0], true), axis.dataToCoord(interval[1], true)]
    };
  });
}
function getCoordSysModel(axisModel, ecModel) {
  return ecModel.getComponent("parallel", axisModel.get("parallelIndex"));
}
var ParallelAxisView$1 = ParallelAxisView;
var actionInfo = {
  type: "axisAreaSelect",
  event: "axisAreaSelected"
};
function installParallelActions(registers) {
  registers.registerAction(actionInfo, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallelAxis",
      query: payload
    }, function(parallelAxisModel) {
      parallelAxisModel.axis.model.setActiveIntervals(payload.intervals);
    });
  });
  registers.registerAction("parallelAxisExpand", function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "parallel",
      query: payload
    }, function(parallelModel) {
      parallelModel.setAxisExpand(payload);
    });
  });
}
var defaultAxisOption = {
  type: "value",
  areaSelectStyle: {
    width: 20,
    borderWidth: 1,
    borderColor: "rgba(160,197,232)",
    color: "rgba(160,197,232)",
    opacity: 0.3
  },
  realtime: true,
  z: 10
};
function install$C(registers) {
  registers.registerComponentView(ParallelView$1);
  registers.registerComponentModel(ParallelModel$1);
  registers.registerCoordinateSystem("parallel", parallelCoordSysCreator$1);
  registers.registerPreprocessor(parallelPreprocessor);
  registers.registerComponentModel(ParallelAxisModel$1);
  registers.registerComponentView(ParallelAxisView$1);
  axisModelCreator(registers, "parallel", ParallelAxisModel$1, defaultAxisOption);
  installParallelActions(registers);
}
function install$B(registers) {
  use(install$C);
  registers.registerChartView(ParallelView$3);
  registers.registerSeriesModel(ParallelSeriesModel$1);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, parallelVisual$1);
}
var SankeyPathShape = function() {
  function SankeyPathShape2() {
    this.x1 = 0;
    this.y1 = 0;
    this.x2 = 0;
    this.y2 = 0;
    this.cpx1 = 0;
    this.cpy1 = 0;
    this.cpx2 = 0;
    this.cpy2 = 0;
    this.extent = 0;
  }
  return SankeyPathShape2;
}();
var SankeyPath = function(_super) {
  __extends(SankeyPath2, _super);
  function SankeyPath2(opts) {
    return _super.call(this, opts) || this;
  }
  SankeyPath2.prototype.getDefaultShape = function() {
    return new SankeyPathShape();
  };
  SankeyPath2.prototype.buildPath = function(ctx, shape) {
    var extent3 = shape.extent;
    ctx.moveTo(shape.x1, shape.y1);
    ctx.bezierCurveTo(shape.cpx1, shape.cpy1, shape.cpx2, shape.cpy2, shape.x2, shape.y2);
    if (shape.orient === "vertical") {
      ctx.lineTo(shape.x2 + extent3, shape.y2);
      ctx.bezierCurveTo(shape.cpx2 + extent3, shape.cpy2, shape.cpx1 + extent3, shape.cpy1, shape.x1 + extent3, shape.y1);
    } else {
      ctx.lineTo(shape.x2, shape.y2 + extent3);
      ctx.bezierCurveTo(shape.cpx2, shape.cpy2 + extent3, shape.cpx1, shape.cpy1 + extent3, shape.x1, shape.y1 + extent3);
    }
    ctx.closePath();
  };
  SankeyPath2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  SankeyPath2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  return SankeyPath2;
}(Path$1);
var SankeyView = function(_super) {
  __extends(SankeyView2, _super);
  function SankeyView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeyView2.type;
    _this._focusAdjacencyDisabled = false;
    return _this;
  }
  SankeyView2.prototype.render = function(seriesModel, ecModel, api) {
    var sankeyView = this;
    var graph = seriesModel.getGraph();
    var group = this.group;
    var layoutInfo = seriesModel.layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var nodeData = seriesModel.getData();
    var edgeData = seriesModel.getData("edge");
    var orient = seriesModel.get("orient");
    this._model = seriesModel;
    group.removeAll();
    group.x = layoutInfo.x;
    group.y = layoutInfo.y;
    graph.eachEdge(function(edge) {
      var curve = new SankeyPath();
      var ecData = getECData(curve);
      ecData.dataIndex = edge.dataIndex;
      ecData.seriesIndex = seriesModel.seriesIndex;
      ecData.dataType = "edge";
      var edgeModel = edge.getModel();
      var lineStyleModel = edgeModel.getModel("lineStyle");
      var curvature = lineStyleModel.get("curveness");
      var n1Layout = edge.node1.getLayout();
      var node1Model = edge.node1.getModel();
      var dragX1 = node1Model.get("localX");
      var dragY1 = node1Model.get("localY");
      var n2Layout = edge.node2.getLayout();
      var node2Model = edge.node2.getModel();
      var dragX2 = node2Model.get("localX");
      var dragY2 = node2Model.get("localY");
      var edgeLayout = edge.getLayout();
      var x1;
      var y1;
      var x2;
      var y2;
      var cpx1;
      var cpy1;
      var cpx2;
      var cpy2;
      curve.shape.extent = Math.max(1, edgeLayout.dy);
      curve.shape.orient = orient;
      if (orient === "vertical") {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + edgeLayout.sy;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + n1Layout.dy;
        x2 = (dragX2 != null ? dragX2 * width : n2Layout.x) + edgeLayout.ty;
        y2 = dragY2 != null ? dragY2 * height : n2Layout.y;
        cpx1 = x1;
        cpy1 = y1 * (1 - curvature) + y2 * curvature;
        cpx2 = x2;
        cpy2 = y1 * curvature + y2 * (1 - curvature);
      } else {
        x1 = (dragX1 != null ? dragX1 * width : n1Layout.x) + n1Layout.dx;
        y1 = (dragY1 != null ? dragY1 * height : n1Layout.y) + edgeLayout.sy;
        x2 = dragX2 != null ? dragX2 * width : n2Layout.x;
        y2 = (dragY2 != null ? dragY2 * height : n2Layout.y) + edgeLayout.ty;
        cpx1 = x1 * (1 - curvature) + x2 * curvature;
        cpy1 = y1;
        cpx2 = x1 * curvature + x2 * (1 - curvature);
        cpy2 = y2;
      }
      curve.setShape({
        x1,
        y1,
        x2,
        y2,
        cpx1,
        cpy1,
        cpx2,
        cpy2
      });
      curve.useStyle(lineStyleModel.getItemStyle());
      switch (curve.style.fill) {
        case "source":
          curve.style.fill = edge.node1.getVisual("color");
          curve.style.decal = edge.node1.getVisual("style").decal;
          break;
        case "target":
          curve.style.fill = edge.node2.getVisual("color");
          curve.style.decal = edge.node2.getVisual("style").decal;
          break;
        case "gradient":
          var sourceColor = edge.node1.getVisual("color");
          var targetColor = edge.node2.getVisual("color");
          if (isString(sourceColor) && isString(targetColor)) {
            curve.style.fill = new LinearGradient$1(0, 0, +(orient === "horizontal"), +(orient === "vertical"), [{
              color: sourceColor,
              offset: 0
            }, {
              color: targetColor,
              offset: 1
            }]);
          }
      }
      var emphasisModel = edgeModel.getModel("emphasis");
      setStatesStylesFromModel(curve, edgeModel, "lineStyle", function(model) {
        return model.getItemStyle();
      });
      group.add(curve);
      edgeData.setItemGraphicEl(edge.dataIndex, curve);
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(curve, focus === "adjacency" ? edge.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
      getECData(curve).dataType = "edge";
    });
    graph.eachNode(function(node) {
      var layout2 = node.getLayout();
      var itemModel = node.getModel();
      var dragX = itemModel.get("localX");
      var dragY = itemModel.get("localY");
      var emphasisModel = itemModel.getModel("emphasis");
      var rect = new Rect$3({
        shape: {
          x: dragX != null ? dragX * width : layout2.x,
          y: dragY != null ? dragY * height : layout2.y,
          width: layout2.dx,
          height: layout2.dy
        },
        style: itemModel.getModel("itemStyle").getItemStyle(),
        z2: 10
      });
      setLabelStyle(rect, getLabelStatesModels(itemModel), {
        labelFetcher: seriesModel,
        labelDataIndex: node.dataIndex,
        defaultText: node.id
      });
      rect.disableLabelAnimation = true;
      rect.setStyle("fill", node.getVisual("color"));
      rect.setStyle("decal", node.getVisual("style").decal);
      setStatesStylesFromModel(rect, itemModel);
      group.add(rect);
      nodeData.setItemGraphicEl(node.dataIndex, rect);
      getECData(rect).dataType = "node";
      var focus = emphasisModel.get("focus");
      toggleHoverEmphasis(rect, focus === "adjacency" ? node.getAdjacentDataIndices() : focus, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    });
    nodeData.eachItemGraphicEl(function(el, dataIndex) {
      var itemModel = nodeData.getItemModel(dataIndex);
      if (itemModel.get("draggable")) {
        el.drift = function(dx, dy) {
          sankeyView._focusAdjacencyDisabled = true;
          this.shape.x += dx;
          this.shape.y += dy;
          this.dirty();
          api.dispatchAction({
            type: "dragNode",
            seriesId: seriesModel.id,
            dataIndex: nodeData.getRawIndex(dataIndex),
            localX: this.shape.x / width,
            localY: this.shape.y / height
          });
        };
        el.ondragend = function() {
          sankeyView._focusAdjacencyDisabled = false;
        };
        el.draggable = true;
        el.cursor = "move";
      }
    });
    if (!this._data && seriesModel.isAnimationEnabled()) {
      group.setClipPath(createGridClipShape$1(group.getBoundingRect(), seriesModel, function() {
        group.removeClipPath();
      }));
    }
    this._data = seriesModel.getData();
  };
  SankeyView2.prototype.dispose = function() {
  };
  SankeyView2.type = "sankey";
  return SankeyView2;
}(ChartView$1);
function createGridClipShape$1(rect, seriesModel, cb) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      width: rect.width + 20
    }
  }, seriesModel, cb);
  return rectEl;
}
var SankeyView$1 = SankeyView;
var SankeySeriesModel = function(_super) {
  __extends(SankeySeriesModel2, _super);
  function SankeySeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SankeySeriesModel2.type;
    return _this;
  }
  SankeySeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var links = option.edges || option.links;
    var nodes = option.data || option.nodes;
    var levels = option.levels;
    this.levelModels = [];
    var levelModels = this.levelModels;
    for (var i = 0; i < levels.length; i++) {
      if (levels[i].depth != null && levels[i].depth >= 0) {
        levelModels[levels[i].depth] = new Model$1(levels[i], this, ecModel);
      }
    }
    if (nodes && links) {
      var graph = createGraphFromNodeEdge(nodes, links, this, true, beforeLink);
      return graph.data;
    }
    function beforeLink(nodeData, edgeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var layout2 = seriesModel.getData().getItemLayout(idx);
        if (layout2) {
          var nodeDepth = layout2.depth;
          var levelModel = seriesModel.levelModels[nodeDepth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
      edgeData.wrapMethod("getItemModel", function(model, idx) {
        var seriesModel = model.parentModel;
        var edge = seriesModel.getGraph().getEdgeByIndex(idx);
        var layout2 = edge.node1.getLayout();
        if (layout2) {
          var depth = layout2.depth;
          var levelModel = seriesModel.levelModels[depth];
          if (levelModel) {
            model.parentModel = levelModel;
          }
        }
        return model;
      });
    }
  };
  SankeySeriesModel2.prototype.setNodePosition = function(dataIndex, localPosition) {
    var nodes = this.option.data || this.option.nodes;
    var dataItem = nodes[dataIndex];
    dataItem.localX = localPosition[0];
    dataItem.localY = localPosition[1];
  };
  SankeySeriesModel2.prototype.getGraph = function() {
    return this.getData().graph;
  };
  SankeySeriesModel2.prototype.getEdgeData = function() {
    return this.getGraph().edgeData;
  };
  SankeySeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    function noValue(val) {
      return isNaN(val) || val == null;
    }
    if (dataType === "edge") {
      var params = this.getDataParams(dataIndex, dataType);
      var rawDataOpt = params.data;
      var edgeValue = params.value;
      var edgeName = rawDataOpt.source + " -- " + rawDataOpt.target;
      return createTooltipMarkup("nameValue", {
        name: edgeName,
        value: edgeValue,
        noValue: noValue(edgeValue)
      });
    } else {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var value = node.getLayout().value;
      var name_1 = this.getDataParams(dataIndex, dataType).data.name;
      return createTooltipMarkup("nameValue", {
        name: name_1 != null ? name_1 + "" : null,
        value,
        noValue: noValue(value)
      });
    }
  };
  SankeySeriesModel2.prototype.optionUpdated = function() {
  };
  SankeySeriesModel2.prototype.getDataParams = function(dataIndex, dataType) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    if (params.value == null && dataType === "node") {
      var node = this.getGraph().getNodeByIndex(dataIndex);
      var nodeValue = node.getLayout().value;
      params.value = nodeValue;
    }
    return params;
  };
  SankeySeriesModel2.type = "series.sankey";
  SankeySeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "view",
    left: "5%",
    top: "5%",
    right: "20%",
    bottom: "5%",
    orient: "horizontal",
    nodeWidth: 20,
    nodeGap: 8,
    draggable: true,
    layoutIterations: 32,
    label: {
      show: true,
      position: "right",
      fontSize: 12
    },
    levels: [],
    nodeAlign: "justify",
    lineStyle: {
      color: "#314656",
      opacity: 0.2,
      curveness: 0.5
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        opacity: 0.5
      }
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    },
    animationEasing: "linear",
    animationDuration: 1e3
  };
  return SankeySeriesModel2;
}(SeriesModel$1);
var SankeySeriesModel$1 = SankeySeriesModel;
function sankeyLayout(ecModel, api) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var nodeWidth = seriesModel.get("nodeWidth");
    var nodeGap = seriesModel.get("nodeGap");
    var layoutInfo = getViewRect$1(seriesModel, api);
    seriesModel.layoutInfo = layoutInfo;
    var width = layoutInfo.width;
    var height = layoutInfo.height;
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    var edges = graph.edges;
    computeNodeValues(nodes);
    var filteredNodes = filter(nodes, function(node) {
      return node.getLayout().value === 0;
    });
    var iterations = filteredNodes.length !== 0 ? 0 : seriesModel.get("layoutIterations");
    var orient = seriesModel.get("orient");
    var nodeAlign = seriesModel.get("nodeAlign");
    layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign);
  });
}
function getViewRect$1(seriesModel, api) {
  return getLayoutRect(seriesModel.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  });
}
function layoutSankey(nodes, edges, nodeWidth, nodeGap, width, height, iterations, orient, nodeAlign) {
  computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign);
  computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient);
  computeEdgeDepths(nodes, orient);
}
function computeNodeValues(nodes) {
  each$f(nodes, function(node) {
    var value1 = sum(node.outEdges, getEdgeValue);
    var value2 = sum(node.inEdges, getEdgeValue);
    var nodeRawValue = node.getValue() || 0;
    var value = Math.max(value1, value2, nodeRawValue);
    node.setLayout({
      value
    }, true);
  });
}
function computeNodeBreadths(nodes, edges, nodeWidth, width, height, orient, nodeAlign) {
  var remainEdges = [];
  var indegreeArr = [];
  var zeroIndegrees = [];
  var nextTargetNode = [];
  var x2 = 0;
  for (var i = 0; i < edges.length; i++) {
    remainEdges[i] = 1;
  }
  for (var i = 0; i < nodes.length; i++) {
    indegreeArr[i] = nodes[i].inEdges.length;
    if (indegreeArr[i] === 0) {
      zeroIndegrees.push(nodes[i]);
    }
  }
  var maxNodeDepth = -1;
  while (zeroIndegrees.length) {
    for (var idx = 0; idx < zeroIndegrees.length; idx++) {
      var node = zeroIndegrees[idx];
      var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
      var isItemDepth = item.depth != null && item.depth >= 0;
      if (isItemDepth && item.depth > maxNodeDepth) {
        maxNodeDepth = item.depth;
      }
      node.setLayout({
        depth: isItemDepth ? item.depth : x2
      }, true);
      orient === "vertical" ? node.setLayout({
        dy: nodeWidth
      }, true) : node.setLayout({
        dx: nodeWidth
      }, true);
      for (var edgeIdx = 0; edgeIdx < node.outEdges.length; edgeIdx++) {
        var edge = node.outEdges[edgeIdx];
        var indexEdge = edges.indexOf(edge);
        remainEdges[indexEdge] = 0;
        var targetNode = edge.node2;
        var nodeIndex = nodes.indexOf(targetNode);
        if (--indegreeArr[nodeIndex] === 0 && nextTargetNode.indexOf(targetNode) < 0) {
          nextTargetNode.push(targetNode);
        }
      }
    }
    ++x2;
    zeroIndegrees = nextTargetNode;
    nextTargetNode = [];
  }
  for (var i = 0; i < remainEdges.length; i++) {
    if (remainEdges[i] === 1) {
      throw new Error("Sankey is a DAG, the original data has cycle!");
    }
  }
  var maxDepth = maxNodeDepth > x2 - 1 ? maxNodeDepth : x2 - 1;
  if (nodeAlign && nodeAlign !== "left") {
    adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth);
  }
  var kx = orient === "vertical" ? (height - nodeWidth) / maxDepth : (width - nodeWidth) / maxDepth;
  scaleNodeBreadths(nodes, kx, orient);
}
function isNodeDepth(node) {
  var item = node.hostGraph.data.getRawDataItem(node.dataIndex);
  return item.depth != null && item.depth >= 0;
}
function adjustNodeWithNodeAlign(nodes, nodeAlign, orient, maxDepth) {
  if (nodeAlign === "right") {
    var nextSourceNode = [];
    var remainNodes = nodes;
    var nodeHeight = 0;
    while (remainNodes.length) {
      for (var i = 0; i < remainNodes.length; i++) {
        var node = remainNodes[i];
        node.setLayout({
          skNodeHeight: nodeHeight
        }, true);
        for (var j = 0; j < node.inEdges.length; j++) {
          var edge = node.inEdges[j];
          if (nextSourceNode.indexOf(edge.node1) < 0) {
            nextSourceNode.push(edge.node1);
          }
        }
      }
      remainNodes = nextSourceNode;
      nextSourceNode = [];
      ++nodeHeight;
    }
    each$f(nodes, function(node2) {
      if (!isNodeDepth(node2)) {
        node2.setLayout({
          depth: Math.max(0, maxDepth - node2.getLayout().skNodeHeight)
        }, true);
      }
    });
  } else if (nodeAlign === "justify") {
    moveSinksRight(nodes, maxDepth);
  }
}
function moveSinksRight(nodes, maxDepth) {
  each$f(nodes, function(node) {
    if (!isNodeDepth(node) && !node.outEdges.length) {
      node.setLayout({
        depth: maxDepth
      }, true);
    }
  });
}
function scaleNodeBreadths(nodes, kx, orient) {
  each$f(nodes, function(node) {
    var nodeDepth = node.getLayout().depth * kx;
    orient === "vertical" ? node.setLayout({
      y: nodeDepth
    }, true) : node.setLayout({
      x: nodeDepth
    }, true);
  });
}
function computeNodeDepths(nodes, edges, height, width, nodeGap, iterations, orient) {
  var nodesByBreadth = prepareNodesByBreadth(nodes, orient);
  initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient);
  resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  for (var alpha = 1; iterations > 0; iterations--) {
    alpha *= 0.99;
    relaxRightToLeft(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
    relaxLeftToRight(nodesByBreadth, alpha, orient);
    resolveCollisions(nodesByBreadth, nodeGap, height, width, orient);
  }
}
function prepareNodesByBreadth(nodes, orient) {
  var nodesByBreadth = [];
  var keyAttr = orient === "vertical" ? "y" : "x";
  var groupResult = groupData(nodes, function(node) {
    return node.getLayout()[keyAttr];
  });
  groupResult.keys.sort(function(a, b2) {
    return a - b2;
  });
  each$f(groupResult.keys, function(key) {
    nodesByBreadth.push(groupResult.buckets.get(key));
  });
  return nodesByBreadth;
}
function initializeNodeDepth(nodesByBreadth, edges, height, width, nodeGap, orient) {
  var minKy = Infinity;
  each$f(nodesByBreadth, function(nodes) {
    var n2 = nodes.length;
    var sum2 = 0;
    each$f(nodes, function(node) {
      sum2 += node.getLayout().value;
    });
    var ky = orient === "vertical" ? (width - (n2 - 1) * nodeGap) / sum2 : (height - (n2 - 1) * nodeGap) / sum2;
    if (ky < minKy) {
      minKy = ky;
    }
  });
  each$f(nodesByBreadth, function(nodes) {
    each$f(nodes, function(node, i) {
      var nodeDy = node.getLayout().value * minKy;
      if (orient === "vertical") {
        node.setLayout({
          x: i
        }, true);
        node.setLayout({
          dx: nodeDy
        }, true);
      } else {
        node.setLayout({
          y: i
        }, true);
        node.setLayout({
          dy: nodeDy
        }, true);
      }
    });
  });
  each$f(edges, function(edge) {
    var edgeDy = +edge.getValue() * minKy;
    edge.setLayout({
      dy: edgeDy
    }, true);
  });
}
function resolveCollisions(nodesByBreadth, nodeGap, height, width, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$f(nodesByBreadth, function(nodes) {
    nodes.sort(function(a, b2) {
      return a.getLayout()[keyAttr] - b2.getLayout()[keyAttr];
    });
    var nodeX;
    var node;
    var dy;
    var y0 = 0;
    var n2 = nodes.length;
    var nodeDyAttr = orient === "vertical" ? "dx" : "dy";
    for (var i = 0; i < n2; i++) {
      node = nodes[i];
      dy = y0 - node.getLayout()[keyAttr];
      if (dy > 0) {
        nodeX = node.getLayout()[keyAttr] + dy;
        orient === "vertical" ? node.setLayout({
          x: nodeX
        }, true) : node.setLayout({
          y: nodeX
        }, true);
      }
      y0 = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap;
    }
    var viewWidth = orient === "vertical" ? width : height;
    dy = y0 - nodeGap - viewWidth;
    if (dy > 0) {
      nodeX = node.getLayout()[keyAttr] - dy;
      orient === "vertical" ? node.setLayout({
        x: nodeX
      }, true) : node.setLayout({
        y: nodeX
      }, true);
      y0 = nodeX;
      for (var i = n2 - 2; i >= 0; --i) {
        node = nodes[i];
        dy = node.getLayout()[keyAttr] + node.getLayout()[nodeDyAttr] + nodeGap - y0;
        if (dy > 0) {
          nodeX = node.getLayout()[keyAttr] - dy;
          orient === "vertical" ? node.setLayout({
            x: nodeX
          }, true) : node.setLayout({
            y: nodeX
          }, true);
        }
        y0 = node.getLayout()[keyAttr];
      }
    }
  });
}
function relaxRightToLeft(nodesByBreadth, alpha, orient) {
  each$f(nodesByBreadth.slice().reverse(), function(nodes) {
    each$f(nodes, function(node) {
      if (node.outEdges.length) {
        var y2 = sum(node.outEdges, weightedTarget, orient) / sum(node.outEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.outEdges.length;
          y2 = len2 ? sum(node.outEdges, centerTarget, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function weightedTarget(edge, orient) {
  return center(edge.node2, orient) * edge.getValue();
}
function centerTarget(edge, orient) {
  return center(edge.node2, orient);
}
function weightedSource(edge, orient) {
  return center(edge.node1, orient) * edge.getValue();
}
function centerSource(edge, orient) {
  return center(edge.node1, orient);
}
function center(node, orient) {
  return orient === "vertical" ? node.getLayout().x + node.getLayout().dx / 2 : node.getLayout().y + node.getLayout().dy / 2;
}
function getEdgeValue(edge) {
  return edge.getValue();
}
function sum(array4, cb, orient) {
  var sum2 = 0;
  var len2 = array4.length;
  var i = -1;
  while (++i < len2) {
    var value = +cb(array4[i], orient);
    if (!isNaN(value)) {
      sum2 += value;
    }
  }
  return sum2;
}
function relaxLeftToRight(nodesByBreadth, alpha, orient) {
  each$f(nodesByBreadth, function(nodes) {
    each$f(nodes, function(node) {
      if (node.inEdges.length) {
        var y2 = sum(node.inEdges, weightedSource, orient) / sum(node.inEdges, getEdgeValue);
        if (isNaN(y2)) {
          var len2 = node.inEdges.length;
          y2 = len2 ? sum(node.inEdges, centerSource, orient) / len2 : 0;
        }
        if (orient === "vertical") {
          var nodeX = node.getLayout().x + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            x: nodeX
          }, true);
        } else {
          var nodeY = node.getLayout().y + (y2 - center(node, orient)) * alpha;
          node.setLayout({
            y: nodeY
          }, true);
        }
      }
    });
  });
}
function computeEdgeDepths(nodes, orient) {
  var keyAttr = orient === "vertical" ? "x" : "y";
  each$f(nodes, function(node) {
    node.outEdges.sort(function(a, b2) {
      return a.node2.getLayout()[keyAttr] - b2.node2.getLayout()[keyAttr];
    });
    node.inEdges.sort(function(a, b2) {
      return a.node1.getLayout()[keyAttr] - b2.node1.getLayout()[keyAttr];
    });
  });
  each$f(nodes, function(node) {
    var sy = 0;
    var ty = 0;
    each$f(node.outEdges, function(edge) {
      edge.setLayout({
        sy
      }, true);
      sy += edge.getLayout().dy;
    });
    each$f(node.inEdges, function(edge) {
      edge.setLayout({
        ty
      }, true);
      ty += edge.getLayout().dy;
    });
  });
}
function sankeyVisual(ecModel) {
  ecModel.eachSeriesByType("sankey", function(seriesModel) {
    var graph = seriesModel.getGraph();
    var nodes = graph.nodes;
    if (nodes.length) {
      var minValue_1 = Infinity;
      var maxValue_1 = -Infinity;
      each$f(nodes, function(node) {
        var nodeValue = node.getLayout().value;
        if (nodeValue < minValue_1) {
          minValue_1 = nodeValue;
        }
        if (nodeValue > maxValue_1) {
          maxValue_1 = nodeValue;
        }
      });
      each$f(nodes, function(node) {
        var mapping = new VisualMapping$1({
          type: "color",
          mappingMethod: "linear",
          dataExtent: [minValue_1, maxValue_1],
          visual: seriesModel.get("color")
        });
        var mapValueToColor = mapping.mapValueToVisual(node.getLayout().value);
        var customColor = node.getModel().get(["itemStyle", "color"]);
        if (customColor != null) {
          node.setVisual("color", customColor);
          node.setVisual("style", {
            fill: customColor
          });
        } else {
          node.setVisual("color", mapValueToColor);
          node.setVisual("style", {
            fill: mapValueToColor
          });
        }
      });
    }
  });
}
function install$A(registers) {
  registers.registerChartView(SankeyView$1);
  registers.registerSeriesModel(SankeySeriesModel$1);
  registers.registerLayout(sankeyLayout);
  registers.registerVisual(sankeyVisual);
  registers.registerAction({
    type: "dragNode",
    event: "dragnode",
    update: "update"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sankey",
      query: payload
    }, function(seriesModel) {
      seriesModel.setNodePosition(payload.dataIndex, [payload.localX, payload.localY]);
    });
  });
}
var WhiskerBoxCommonMixin = function() {
  function WhiskerBoxCommonMixin2() {
  }
  WhiskerBoxCommonMixin2.prototype.getInitialData = function(option, ecModel) {
    var ordinalMeta;
    var xAxisModel = ecModel.getComponent("xAxis", this.get("xAxisIndex"));
    var yAxisModel = ecModel.getComponent("yAxis", this.get("yAxisIndex"));
    var xAxisType = xAxisModel.get("type");
    var yAxisType = yAxisModel.get("type");
    var addOrdinal;
    if (xAxisType === "category") {
      option.layout = "horizontal";
      ordinalMeta = xAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else if (yAxisType === "category") {
      option.layout = "vertical";
      ordinalMeta = yAxisModel.getOrdinalMeta();
      addOrdinal = true;
    } else {
      option.layout = option.layout || "horizontal";
    }
    var coordDims = ["x", "y"];
    var baseAxisDimIndex = option.layout === "horizontal" ? 0 : 1;
    var baseAxisDim = this._baseAxisDim = coordDims[baseAxisDimIndex];
    var otherAxisDim = coordDims[1 - baseAxisDimIndex];
    var axisModels = [xAxisModel, yAxisModel];
    var baseAxisType = axisModels[baseAxisDimIndex].get("type");
    var otherAxisType = axisModels[1 - baseAxisDimIndex].get("type");
    var data = option.data;
    if (data && addOrdinal) {
      var newOptionData_1 = [];
      each$f(data, function(item, index2) {
        var newItem;
        if (isArray$1(item)) {
          newItem = item.slice();
          item.unshift(index2);
        } else if (isArray$1(item.value)) {
          newItem = extend({}, item);
          newItem.value = newItem.value.slice();
          item.value.unshift(index2);
        } else {
          newItem = item;
        }
        newOptionData_1.push(newItem);
      });
      option.data = newOptionData_1;
    }
    var defaultValueDimensions = this.defaultValueDimensions;
    var coordDimensions = [{
      name: baseAxisDim,
      type: getDimensionTypeByAxis(baseAxisType),
      ordinalMeta,
      otherDims: {
        tooltip: false,
        itemName: 0
      },
      dimsDef: ["base"]
    }, {
      name: otherAxisDim,
      type: getDimensionTypeByAxis(otherAxisType),
      dimsDef: defaultValueDimensions.slice()
    }];
    return createSeriesDataSimply(this, {
      coordDimensions,
      dimensionsCount: defaultValueDimensions.length + 1,
      encodeDefaulter: curry$1(makeSeriesEncodeForAxisCoordSys, coordDimensions, this)
    });
  };
  WhiskerBoxCommonMixin2.prototype.getBaseAxis = function() {
    var dim = this._baseAxisDim;
    return this.ecModel.getComponent(dim + "Axis", this.get(dim + "AxisIndex")).axis;
  };
  return WhiskerBoxCommonMixin2;
}();
var BoxplotSeriesModel = function(_super) {
  __extends(BoxplotSeriesModel2, _super);
  function BoxplotSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "min",
      defaultTooltip: true
    }, {
      name: "Q1",
      defaultTooltip: true
    }, {
      name: "median",
      defaultTooltip: true
    }, {
      name: "Q3",
      defaultTooltip: true
    }, {
      name: "max",
      defaultTooltip: true
    }];
    _this.visualDrawType = "stroke";
    return _this;
  }
  BoxplotSeriesModel2.type = "series.boxplot";
  BoxplotSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  BoxplotSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    boxWidth: [7, 50],
    itemStyle: {
      color: "#fff",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2,
        shadowBlur: 5,
        shadowOffsetX: 1,
        shadowOffsetY: 1,
        shadowColor: "rgba(0,0,0,0.2)"
      }
    },
    animationDuration: 800
  };
  return BoxplotSeriesModel2;
}(SeriesModel$1);
mixin(BoxplotSeriesModel, WhiskerBoxCommonMixin, true);
var BoxplotSeriesModel$1 = BoxplotSeriesModel;
var BoxplotView = function(_super) {
  __extends(BoxplotView2, _super);
  function BoxplotView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BoxplotView2.type;
    return _this;
  }
  BoxplotView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var group = this.group;
    var oldData = this._data;
    if (!this._data) {
      group.removeAll();
    }
    var constDim = seriesModel.get("layout") === "horizontal" ? 1 : 0;
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        var symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim, true);
        data.setItemGraphicEl(newIdx, symbolEl);
        group.add(symbolEl);
      }
    }).update(function(newIdx, oldIdx) {
      var symbolEl = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(symbolEl);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (!symbolEl) {
        symbolEl = createNormalBox$1(itemLayout, data, newIdx, constDim);
      } else {
        saveOldStyle(symbolEl);
        updateNormalBoxData(itemLayout, symbolEl, data, newIdx);
      }
      group.add(symbolEl);
      data.setItemGraphicEl(newIdx, symbolEl);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  BoxplotView2.prototype.remove = function(ecModel) {
    var group = this.group;
    var data = this._data;
    this._data = null;
    data && data.eachItemGraphicEl(function(el) {
      el && group.remove(el);
    });
  };
  BoxplotView2.type = "boxplot";
  return BoxplotView2;
}(ChartView$1);
var BoxPathShape = function() {
  function BoxPathShape2() {
  }
  return BoxPathShape2;
}();
var BoxPath = function(_super) {
  __extends(BoxPath2, _super);
  function BoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "boxplotBoxPath";
    return _this;
  }
  BoxPath2.prototype.getDefaultShape = function() {
    return new BoxPathShape();
  };
  BoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    var i = 0;
    ctx.moveTo(ends[i][0], ends[i][1]);
    i++;
    for (; i < 4; i++) {
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
    ctx.closePath();
    for (; i < ends.length; i++) {
      ctx.moveTo(ends[i][0], ends[i][1]);
      i++;
      ctx.lineTo(ends[i][0], ends[i][1]);
    }
  };
  return BoxPath2;
}(Path$1);
function createNormalBox$1(itemLayout, data, dataIndex, constDim, isInit) {
  var ends = itemLayout.ends;
  var el = new BoxPath({
    shape: {
      points: isInit ? transInit$1(ends, constDim, itemLayout) : ends
    }
  });
  updateNormalBoxData(itemLayout, el, data, dataIndex, isInit);
  return el;
}
function updateNormalBoxData(itemLayout, el, data, dataIndex, isInit) {
  var seriesModel = data.hostModel;
  var updateMethod = graphic[isInit ? "initProps" : "updateProps"];
  updateMethod(el, {
    shape: {
      points: itemLayout.ends
    }
  }, seriesModel, dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.z2 = 100;
  var itemModel = data.getItemModel(dataIndex);
  var emphasisModel = itemModel.getModel("emphasis");
  setStatesStylesFromModel(el, itemModel);
  toggleHoverEmphasis(el, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
}
function transInit$1(points2, dim, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[dim] = itemLayout.initBaseline;
    return point;
  });
}
var BoxplotView$1 = BoxplotView;
function boxplotVisual(ecModel, api) {
}
var each$9 = each$f;
function boxplotLayout(ecModel) {
  var groupResult = groupSeriesByAxis(ecModel);
  each$9(groupResult, function(groupItem) {
    var seriesModels = groupItem.seriesModels;
    if (!seriesModels.length) {
      return;
    }
    calculateBase(groupItem);
    each$9(seriesModels, function(seriesModel, idx) {
      layoutSingleSeries(seriesModel, groupItem.boxOffsetList[idx], groupItem.boxWidthList[idx]);
    });
  });
}
function groupSeriesByAxis(ecModel) {
  var result = [];
  var axisList = [];
  ecModel.eachSeriesByType("boxplot", function(seriesModel) {
    var baseAxis = seriesModel.getBaseAxis();
    var idx = indexOf(axisList, baseAxis);
    if (idx < 0) {
      idx = axisList.length;
      axisList[idx] = baseAxis;
      result[idx] = {
        axis: baseAxis,
        seriesModels: []
      };
    }
    result[idx].seriesModels.push(seriesModel);
  });
  return result;
}
function calculateBase(groupItem) {
  var baseAxis = groupItem.axis;
  var seriesModels = groupItem.seriesModels;
  var seriesCount = seriesModels.length;
  var boxWidthList = groupItem.boxWidthList = [];
  var boxOffsetList = groupItem.boxOffsetList = [];
  var boundList = [];
  var bandWidth;
  if (baseAxis.type === "category") {
    bandWidth = baseAxis.getBandWidth();
  } else {
    var maxDataCount_1 = 0;
    each$9(seriesModels, function(seriesModel) {
      maxDataCount_1 = Math.max(maxDataCount_1, seriesModel.getData().count());
    });
    var extent3 = baseAxis.getExtent();
    bandWidth = Math.abs(extent3[1] - extent3[0]) / maxDataCount_1;
  }
  each$9(seriesModels, function(seriesModel) {
    var boxWidthBound = seriesModel.get("boxWidth");
    if (!isArray$1(boxWidthBound)) {
      boxWidthBound = [boxWidthBound, boxWidthBound];
    }
    boundList.push([parsePercent(boxWidthBound[0], bandWidth) || 0, parsePercent(boxWidthBound[1], bandWidth) || 0]);
  });
  var availableWidth = bandWidth * 0.8 - 2;
  var boxGap = availableWidth / seriesCount * 0.3;
  var boxWidth = (availableWidth - boxGap * (seriesCount - 1)) / seriesCount;
  var base2 = boxWidth / 2 - availableWidth / 2;
  each$9(seriesModels, function(seriesModel, idx) {
    boxOffsetList.push(base2);
    base2 += boxGap + boxWidth;
    boxWidthList.push(Math.min(Math.max(boxWidth, boundList[idx][0]), boundList[idx][1]));
  });
}
function layoutSingleSeries(seriesModel, offset, boxWidth) {
  var coordSys = seriesModel.coordinateSystem;
  var data = seriesModel.getData();
  var halfWidth = boxWidth / 2;
  var cDimIdx = seriesModel.get("layout") === "horizontal" ? 0 : 1;
  var vDimIdx = 1 - cDimIdx;
  var coordDims = ["x", "y"];
  var cDim = data.mapDimension(coordDims[cDimIdx]);
  var vDims = data.mapDimensionsAll(coordDims[vDimIdx]);
  if (cDim == null || vDims.length < 5) {
    return;
  }
  for (var dataIndex = 0; dataIndex < data.count(); dataIndex++) {
    var axisDimVal = data.get(cDim, dataIndex);
    var median = getPoint(axisDimVal, vDims[2], dataIndex);
    var end1 = getPoint(axisDimVal, vDims[0], dataIndex);
    var end2 = getPoint(axisDimVal, vDims[1], dataIndex);
    var end4 = getPoint(axisDimVal, vDims[3], dataIndex);
    var end5 = getPoint(axisDimVal, vDims[4], dataIndex);
    var ends = [];
    addBodyEnd(ends, end2, false);
    addBodyEnd(ends, end4, true);
    ends.push(end1, end2, end5, end4);
    layEndLine(ends, end1);
    layEndLine(ends, end5);
    layEndLine(ends, median);
    data.setItemLayout(dataIndex, {
      initBaseline: median[vDimIdx],
      ends
    });
  }
  function getPoint(axisDimVal2, dim, dataIndex2) {
    var val = data.get(dim, dataIndex2);
    var p2 = [];
    p2[cDimIdx] = axisDimVal2;
    p2[vDimIdx] = val;
    var point;
    if (isNaN(axisDimVal2) || isNaN(val)) {
      point = [NaN, NaN];
    } else {
      point = coordSys.dataToPoint(p2);
      point[cDimIdx] += offset;
    }
    return point;
  }
  function addBodyEnd(ends2, point, start2) {
    var point1 = point.slice();
    var point2 = point.slice();
    point1[cDimIdx] += halfWidth;
    point2[cDimIdx] -= halfWidth;
    start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
  }
  function layEndLine(ends2, endCenter) {
    var from = endCenter.slice();
    var to = endCenter.slice();
    from[cDimIdx] -= halfWidth;
    to[cDimIdx] += halfWidth;
    ends2.push(from, to);
  }
}
function prepareBoxplotData(rawData, opt) {
  opt = opt || {};
  var boxData = [];
  var outliers = [];
  var boundIQR = opt.boundIQR;
  var useExtreme = boundIQR === "none" || boundIQR === 0;
  for (var i = 0; i < rawData.length; i++) {
    var ascList = asc$2(rawData[i].slice());
    var Q1 = quantile(ascList, 0.25);
    var Q2 = quantile(ascList, 0.5);
    var Q3 = quantile(ascList, 0.75);
    var min3 = ascList[0];
    var max3 = ascList[ascList.length - 1];
    var bound = (boundIQR == null ? 1.5 : boundIQR) * (Q3 - Q1);
    var low = useExtreme ? min3 : Math.max(min3, Q1 - bound);
    var high = useExtreme ? max3 : Math.min(max3, Q3 + bound);
    var itemNameFormatter = opt.itemNameFormatter;
    var itemName = isFunction(itemNameFormatter) ? itemNameFormatter({
      value: i
    }) : isString(itemNameFormatter) ? itemNameFormatter.replace("{value}", i + "") : i + "";
    boxData.push([itemName, low, Q1, Q2, Q3, high]);
    for (var j = 0; j < ascList.length; j++) {
      var dataItem = ascList[j];
      if (dataItem < low || dataItem > high) {
        var outlier = [itemName, dataItem];
        outliers.push(outlier);
      }
    }
  }
  return {
    boxData,
    outliers
  };
}
var boxplotTransform = {
  type: "echarts:boxplot",
  transform: function transform(params) {
    var upstream = params.upstream;
    if (upstream.sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS) {
      var errMsg = "";
      throwError(errMsg);
    }
    var result = prepareBoxplotData(upstream.getRawData(), params.config);
    return [{
      dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"],
      data: result.boxData
    }, {
      data: result.outliers
    }];
  }
};
function install$z(registers) {
  registers.registerSeriesModel(BoxplotSeriesModel$1);
  registers.registerChartView(BoxplotView$1);
  registers.registerVisual(boxplotVisual);
  registers.registerLayout(boxplotLayout);
  registers.registerTransform(boxplotTransform);
}
var SKIP_PROPS = ["color", "borderColor"];
var CandlestickView = function(_super) {
  __extends(CandlestickView2, _super);
  function CandlestickView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickView2.type;
    return _this;
  }
  CandlestickView2.prototype.render = function(seriesModel, ecModel, api) {
    this.group.removeClipPath();
    this._progressiveEls = null;
    this._updateDrawMode(seriesModel);
    this._isLargeDraw ? this._renderLarge(seriesModel) : this._renderNormal(seriesModel);
  };
  CandlestickView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this._clear();
    this._updateDrawMode(seriesModel);
  };
  CandlestickView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    this._progressiveEls = [];
    this._isLargeDraw ? this._incrementalRenderLarge(params, seriesModel) : this._incrementalRenderNormal(params, seriesModel);
  };
  CandlestickView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  CandlestickView2.prototype._updateDrawMode = function(seriesModel) {
    var isLargeDraw = seriesModel.pipelineContext.large;
    if (this._isLargeDraw == null || isLargeDraw !== this._isLargeDraw) {
      this._isLargeDraw = isLargeDraw;
      this._clear();
    }
  };
  CandlestickView2.prototype._renderNormal = function(seriesModel) {
    var data = seriesModel.getData();
    var oldData = this._data;
    var group = this.group;
    var isSimpleBox = data.getLayout("isSimpleBox");
    var needsClip = seriesModel.get("clip", true);
    var coord = seriesModel.coordinateSystem;
    var clipArea = coord.getArea && coord.getArea();
    if (!this._data) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      if (data.hasValue(newIdx)) {
        var itemLayout = data.getItemLayout(newIdx);
        if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
          return;
        }
        var el = createNormalBox(itemLayout, newIdx, true);
        initProps(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        setBoxCommon(el, data, newIdx, isSimpleBox);
        group.add(el);
        data.setItemGraphicEl(newIdx, el);
      }
    }).update(function(newIdx, oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      if (!data.hasValue(newIdx)) {
        group.remove(el);
        return;
      }
      var itemLayout = data.getItemLayout(newIdx);
      if (needsClip && isNormalBoxClipped(clipArea, itemLayout)) {
        group.remove(el);
        return;
      }
      if (!el) {
        el = createNormalBox(itemLayout);
      } else {
        updateProps$1(el, {
          shape: {
            points: itemLayout.ends
          }
        }, seriesModel, newIdx);
        saveOldStyle(el);
      }
      setBoxCommon(el, data, newIdx, isSimpleBox);
      group.add(el);
      data.setItemGraphicEl(newIdx, el);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      el && group.remove(el);
    }).execute();
    this._data = data;
  };
  CandlestickView2.prototype._renderLarge = function(seriesModel) {
    this._clear();
    createLarge(seriesModel, this.group);
    var clipPath = seriesModel.get("clip", true) ? createClipPath(seriesModel.coordinateSystem, false, seriesModel) : null;
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
  };
  CandlestickView2.prototype._incrementalRenderNormal = function(params, seriesModel) {
    var data = seriesModel.getData();
    var isSimpleBox = data.getLayout("isSimpleBox");
    var dataIndex;
    while ((dataIndex = params.next()) != null) {
      var itemLayout = data.getItemLayout(dataIndex);
      var el = createNormalBox(itemLayout);
      setBoxCommon(el, data, dataIndex, isSimpleBox);
      el.incremental = true;
      this.group.add(el);
      this._progressiveEls.push(el);
    }
  };
  CandlestickView2.prototype._incrementalRenderLarge = function(params, seriesModel) {
    createLarge(seriesModel, this.group, this._progressiveEls, true);
  };
  CandlestickView2.prototype.remove = function(ecModel) {
    this._clear();
  };
  CandlestickView2.prototype._clear = function() {
    this.group.removeAll();
    this._data = null;
  };
  CandlestickView2.type = "candlestick";
  return CandlestickView2;
}(ChartView$1);
var NormalBoxPathShape = function() {
  function NormalBoxPathShape2() {
  }
  return NormalBoxPathShape2;
}();
var NormalBoxPath = function(_super) {
  __extends(NormalBoxPath2, _super);
  function NormalBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "normalCandlestickBox";
    return _this;
  }
  NormalBoxPath2.prototype.getDefaultShape = function() {
    return new NormalBoxPathShape();
  };
  NormalBoxPath2.prototype.buildPath = function(ctx, shape) {
    var ends = shape.points;
    if (this.__simpleBox) {
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[6][0], ends[6][1]);
    } else {
      ctx.moveTo(ends[0][0], ends[0][1]);
      ctx.lineTo(ends[1][0], ends[1][1]);
      ctx.lineTo(ends[2][0], ends[2][1]);
      ctx.lineTo(ends[3][0], ends[3][1]);
      ctx.closePath();
      ctx.moveTo(ends[4][0], ends[4][1]);
      ctx.lineTo(ends[5][0], ends[5][1]);
      ctx.moveTo(ends[6][0], ends[6][1]);
      ctx.lineTo(ends[7][0], ends[7][1]);
    }
  };
  return NormalBoxPath2;
}(Path$1);
function createNormalBox(itemLayout, dataIndex, isInit) {
  var ends = itemLayout.ends;
  return new NormalBoxPath({
    shape: {
      points: isInit ? transInit(ends, itemLayout) : ends
    },
    z2: 100
  });
}
function isNormalBoxClipped(clipArea, itemLayout) {
  var clipped = true;
  for (var i = 0; i < itemLayout.ends.length; i++) {
    if (clipArea.contain(itemLayout.ends[i][0], itemLayout.ends[i][1])) {
      clipped = false;
      break;
    }
  }
  return clipped;
}
function setBoxCommon(el, data, dataIndex, isSimpleBox) {
  var itemModel = data.getItemModel(dataIndex);
  el.useStyle(data.getItemVisual(dataIndex, "style"));
  el.style.strokeNoScale = true;
  el.__simpleBox = isSimpleBox;
  setStatesStylesFromModel(el, itemModel);
}
function transInit(points2, itemLayout) {
  return map$1(points2, function(point) {
    point = point.slice();
    point[1] = itemLayout.initBaseline;
    return point;
  });
}
var LargeBoxPathShape = function() {
  function LargeBoxPathShape2() {
  }
  return LargeBoxPathShape2;
}();
var LargeBoxPath = function(_super) {
  __extends(LargeBoxPath2, _super);
  function LargeBoxPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this.type = "largeCandlestickBox";
    return _this;
  }
  LargeBoxPath2.prototype.getDefaultShape = function() {
    return new LargeBoxPathShape();
  };
  LargeBoxPath2.prototype.buildPath = function(ctx, shape) {
    var points2 = shape.points;
    for (var i = 0; i < points2.length; ) {
      if (this.__sign === points2[i++]) {
        var x2 = points2[i++];
        ctx.moveTo(x2, points2[i++]);
        ctx.lineTo(x2, points2[i++]);
      } else {
        i += 3;
      }
    }
  };
  return LargeBoxPath2;
}(Path$1);
function createLarge(seriesModel, group, progressiveEls, incremental) {
  var data = seriesModel.getData();
  var largePoints = data.getLayout("largePoints");
  var elP = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: 1
  });
  group.add(elP);
  var elN = new LargeBoxPath({
    shape: {
      points: largePoints
    },
    __sign: -1
  });
  group.add(elN);
  setLargeStyle(1, elP, seriesModel);
  setLargeStyle(-1, elN, seriesModel);
  if (incremental) {
    elP.incremental = true;
    elN.incremental = true;
  }
  if (progressiveEls) {
    progressiveEls.push(elP, elN);
  }
}
function setLargeStyle(sign, el, seriesModel, data) {
  var borderColor = seriesModel.get(["itemStyle", sign > 0 ? "borderColor" : "borderColor0"]) || seriesModel.get(["itemStyle", sign > 0 ? "color" : "color0"]);
  var itemStyle = seriesModel.getModel("itemStyle").getItemStyle(SKIP_PROPS);
  el.useStyle(itemStyle);
  el.style.fill = null;
  el.style.stroke = borderColor;
}
var CandlestickView$1 = CandlestickView;
var CandlestickSeriesModel = function(_super) {
  __extends(CandlestickSeriesModel2, _super);
  function CandlestickSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CandlestickSeriesModel2.type;
    _this.defaultValueDimensions = [{
      name: "open",
      defaultTooltip: true
    }, {
      name: "close",
      defaultTooltip: true
    }, {
      name: "lowest",
      defaultTooltip: true
    }, {
      name: "highest",
      defaultTooltip: true
    }];
    return _this;
  }
  CandlestickSeriesModel2.prototype.getShadowDim = function() {
    return "open";
  };
  CandlestickSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    var itemLayout = data.getItemLayout(dataIndex);
    return itemLayout && selectors.rect(itemLayout.brushRect);
  };
  CandlestickSeriesModel2.type = "series.candlestick";
  CandlestickSeriesModel2.dependencies = ["xAxis", "yAxis", "grid"];
  CandlestickSeriesModel2.defaultOption = {
    z: 2,
    coordinateSystem: "cartesian2d",
    legendHoverLink: true,
    layout: null,
    clip: true,
    itemStyle: {
      color: "#eb5454",
      color0: "#47b262",
      borderColor: "#eb5454",
      borderColor0: "#47b262",
      borderWidth: 1
    },
    emphasis: {
      scale: true,
      itemStyle: {
        borderWidth: 2
      }
    },
    barMaxWidth: null,
    barMinWidth: null,
    barWidth: null,
    large: true,
    largeThreshold: 600,
    progressive: 3e3,
    progressiveThreshold: 1e4,
    progressiveChunkMode: "mod",
    animationEasing: "linear",
    animationDuration: 300
  };
  return CandlestickSeriesModel2;
}(SeriesModel$1);
mixin(CandlestickSeriesModel, WhiskerBoxCommonMixin, true);
var CandlestickSeriesModel$1 = CandlestickSeriesModel;
function candlestickPreprocessor(option) {
  if (!option || !isArray$1(option.series)) {
    return;
  }
  each$f(option.series, function(seriesItem) {
    if (isObject$4(seriesItem) && seriesItem.type === "k") {
      seriesItem.type = "candlestick";
    }
  });
}
var positiveBorderColorQuery = ["itemStyle", "borderColor"];
var negativeBorderColorQuery = ["itemStyle", "borderColor0"];
var positiveColorQuery = ["itemStyle", "color"];
var negativeColorQuery = ["itemStyle", "color0"];
var candlestickVisual = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  performRawSeries: true,
  reset: function(seriesModel, ecModel) {
    function getColor(sign, model) {
      return model.get(sign > 0 ? positiveColorQuery : negativeColorQuery);
    }
    function getBorderColor(sign, model) {
      return model.get(sign > 0 ? positiveBorderColorQuery : negativeBorderColorQuery);
    }
    if (ecModel.isSeriesFiltered(seriesModel)) {
      return;
    }
    var isLargeRender = seriesModel.pipelineContext.large;
    return !isLargeRender && {
      progress: function(params, data) {
        var dataIndex;
        while ((dataIndex = params.next()) != null) {
          var itemModel = data.getItemModel(dataIndex);
          var sign = data.getItemLayout(dataIndex).sign;
          var style = itemModel.getItemStyle();
          style.fill = getColor(sign, itemModel);
          style.stroke = getBorderColor(sign, itemModel) || style.fill;
          var existsStyle = data.ensureUniqueItemVisual(dataIndex, "style");
          extend(existsStyle, style);
        }
      }
    };
  }
};
var candlestickVisual$1 = candlestickVisual;
var candlestickLayout = {
  seriesType: "candlestick",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var data = seriesModel.getData();
    var candleWidth = calculateCandleWidth(seriesModel, data);
    var cDimIdx = 0;
    var vDimIdx = 1;
    var coordDims = ["x", "y"];
    var cDimI = data.getDimensionIndex(data.mapDimension(coordDims[cDimIdx]));
    var vDimsI = map$1(data.mapDimensionsAll(coordDims[vDimIdx]), data.getDimensionIndex, data);
    var openDimI = vDimsI[0];
    var closeDimI = vDimsI[1];
    var lowestDimI = vDimsI[2];
    var highestDimI = vDimsI[3];
    data.setLayout({
      candleWidth,
      isSimpleBox: candleWidth <= 1.3
    });
    if (cDimI < 0 || vDimsI.length < 4) {
      return;
    }
    return {
      progress: seriesModel.pipelineContext.large ? largeProgress : normalProgress
    };
    function normalProgress(params, data2) {
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        var ocLow = Math.min(openVal, closeVal);
        var ocHigh = Math.max(openVal, closeVal);
        var ocLowPoint = getPoint(ocLow, axisDimVal);
        var ocHighPoint = getPoint(ocHigh, axisDimVal);
        var lowestPoint = getPoint(lowestVal, axisDimVal);
        var highestPoint = getPoint(highestVal, axisDimVal);
        var ends = [];
        addBodyEnd(ends, ocHighPoint, 0);
        addBodyEnd(ends, ocLowPoint, 1);
        ends.push(subPixelOptimizePoint(highestPoint), subPixelOptimizePoint(ocHighPoint), subPixelOptimizePoint(lowestPoint), subPixelOptimizePoint(ocLowPoint));
        data2.setItemLayout(dataIndex, {
          sign: getSign(store, dataIndex, openVal, closeVal, closeDimI),
          initBaseline: openVal > closeVal ? ocHighPoint[vDimIdx] : ocLowPoint[vDimIdx],
          ends,
          brushRect: makeBrushRect(lowestVal, highestVal, axisDimVal)
        });
      }
      function getPoint(val, axisDimVal2) {
        var p2 = [];
        p2[cDimIdx] = axisDimVal2;
        p2[vDimIdx] = val;
        return isNaN(axisDimVal2) || isNaN(val) ? [NaN, NaN] : coordSys.dataToPoint(p2);
      }
      function addBodyEnd(ends2, point, start2) {
        var point1 = point.slice();
        var point2 = point.slice();
        point1[cDimIdx] = subPixelOptimize(point1[cDimIdx] + candleWidth / 2, 1, false);
        point2[cDimIdx] = subPixelOptimize(point2[cDimIdx] - candleWidth / 2, 1, true);
        start2 ? ends2.push(point1, point2) : ends2.push(point2, point1);
      }
      function makeBrushRect(lowestVal2, highestVal2, axisDimVal2) {
        var pmin = getPoint(lowestVal2, axisDimVal2);
        var pmax = getPoint(highestVal2, axisDimVal2);
        pmin[cDimIdx] -= candleWidth / 2;
        pmax[cDimIdx] -= candleWidth / 2;
        return {
          x: pmin[0],
          y: pmin[1],
          width: candleWidth,
          height: pmax[1] - pmin[1]
        };
      }
      function subPixelOptimizePoint(point) {
        point[cDimIdx] = subPixelOptimize(point[cDimIdx], 1);
        return point;
      }
    }
    function largeProgress(params, data2) {
      var points2 = createFloat32Array(params.count * 4);
      var offset = 0;
      var point;
      var tmpIn = [];
      var tmpOut = [];
      var dataIndex;
      var store = data2.getStore();
      while ((dataIndex = params.next()) != null) {
        var axisDimVal = store.get(cDimI, dataIndex);
        var openVal = store.get(openDimI, dataIndex);
        var closeVal = store.get(closeDimI, dataIndex);
        var lowestVal = store.get(lowestDimI, dataIndex);
        var highestVal = store.get(highestDimI, dataIndex);
        if (isNaN(axisDimVal) || isNaN(lowestVal) || isNaN(highestVal)) {
          points2[offset++] = NaN;
          offset += 3;
          continue;
        }
        points2[offset++] = getSign(store, dataIndex, openVal, closeVal, closeDimI);
        tmpIn[cDimIdx] = axisDimVal;
        tmpIn[vDimIdx] = lowestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset++] = point ? point[0] : NaN;
        points2[offset++] = point ? point[1] : NaN;
        tmpIn[vDimIdx] = highestVal;
        point = coordSys.dataToPoint(tmpIn, null, tmpOut);
        points2[offset++] = point ? point[1] : NaN;
      }
      data2.setLayout("largePoints", points2);
    }
  }
};
function getSign(store, dataIndex, openVal, closeVal, closeDimI) {
  var sign;
  if (openVal > closeVal) {
    sign = -1;
  } else if (openVal < closeVal) {
    sign = 1;
  } else {
    sign = dataIndex > 0 ? store.get(closeDimI, dataIndex - 1) <= closeVal ? 1 : -1 : 1;
  }
  return sign;
}
function calculateCandleWidth(seriesModel, data) {
  var baseAxis = seriesModel.getBaseAxis();
  var extent3;
  var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : (extent3 = baseAxis.getExtent(), Math.abs(extent3[1] - extent3[0]) / data.count());
  var barMaxWidth = parsePercent(retrieve2(seriesModel.get("barMaxWidth"), bandWidth), bandWidth);
  var barMinWidth = parsePercent(retrieve2(seriesModel.get("barMinWidth"), 1), bandWidth);
  var barWidth = seriesModel.get("barWidth");
  return barWidth != null ? parsePercent(barWidth, bandWidth) : Math.max(Math.min(bandWidth / 2, barMaxWidth), barMinWidth);
}
var candlestickLayout$1 = candlestickLayout;
function install$y(registers) {
  registers.registerChartView(CandlestickView$1);
  registers.registerSeriesModel(CandlestickSeriesModel$1);
  registers.registerPreprocessor(candlestickPreprocessor);
  registers.registerVisual(candlestickVisual$1);
  registers.registerLayout(candlestickLayout$1);
}
function updateRipplePath(rippleGroup, effectCfg) {
  var color = effectCfg.rippleEffectColor || effectCfg.color;
  rippleGroup.eachChild(function(ripplePath) {
    ripplePath.attr({
      z: effectCfg.z,
      zlevel: effectCfg.zlevel,
      style: {
        stroke: effectCfg.brushType === "stroke" ? color : null,
        fill: effectCfg.brushType === "fill" ? color : null
      }
    });
  });
}
var EffectSymbol = function(_super) {
  __extends(EffectSymbol2, _super);
  function EffectSymbol2(data, idx) {
    var _this = _super.call(this) || this;
    var symbol = new SymbolClz(data, idx);
    var rippleGroup = new Group$4();
    _this.add(symbol);
    _this.add(rippleGroup);
    _this.updateData(data, idx);
    return _this;
  }
  EffectSymbol2.prototype.stopEffectAnimation = function() {
    this.childAt(1).removeAll();
  };
  EffectSymbol2.prototype.startEffectAnimation = function(effectCfg) {
    var symbolType = effectCfg.symbolType;
    var color = effectCfg.color;
    var rippleNumber = effectCfg.rippleNumber;
    var rippleGroup = this.childAt(1);
    for (var i = 0; i < rippleNumber; i++) {
      var ripplePath = createSymbol$1(symbolType, -1, -1, 2, 2, color);
      ripplePath.attr({
        style: {
          strokeNoScale: true
        },
        z2: 99,
        silent: true,
        scaleX: 0.5,
        scaleY: 0.5
      });
      var delay = -i / rippleNumber * effectCfg.period + effectCfg.effectOffset;
      ripplePath.animate("", true).when(effectCfg.period, {
        scaleX: effectCfg.rippleScale / 2,
        scaleY: effectCfg.rippleScale / 2
      }).delay(delay).start();
      ripplePath.animateStyle(true).when(effectCfg.period, {
        opacity: 0
      }).delay(delay).start();
      rippleGroup.add(ripplePath);
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.updateEffectAnimation = function(effectCfg) {
    var oldEffectCfg = this._effectCfg;
    var rippleGroup = this.childAt(1);
    var DIFFICULT_PROPS = ["symbolType", "period", "rippleScale", "rippleNumber"];
    for (var i = 0; i < DIFFICULT_PROPS.length; i++) {
      var propName = DIFFICULT_PROPS[i];
      if (oldEffectCfg[propName] !== effectCfg[propName]) {
        this.stopEffectAnimation();
        this.startEffectAnimation(effectCfg);
        return;
      }
    }
    updateRipplePath(rippleGroup, effectCfg);
  };
  EffectSymbol2.prototype.highlight = function() {
    enterEmphasis(this);
  };
  EffectSymbol2.prototype.downplay = function() {
    leaveEmphasis(this);
  };
  EffectSymbol2.prototype.getSymbolType = function() {
    var symbol = this.childAt(0);
    return symbol && symbol.getSymbolType();
  };
  EffectSymbol2.prototype.updateData = function(data, idx) {
    var _this = this;
    var seriesModel = data.hostModel;
    this.childAt(0).updateData(data, idx);
    var rippleGroup = this.childAt(1);
    var itemModel = data.getItemModel(idx);
    var symbolType = data.getItemVisual(idx, "symbol");
    var symbolSize = normalizeSymbolSize(data.getItemVisual(idx, "symbolSize"));
    var symbolStyle = data.getItemVisual(idx, "style");
    var color = symbolStyle && symbolStyle.fill;
    var emphasisModel = itemModel.getModel("emphasis");
    rippleGroup.setScale(symbolSize);
    rippleGroup.traverse(function(ripplePath) {
      ripplePath.setStyle("fill", color);
    });
    var symbolOffset = normalizeSymbolOffset(data.getItemVisual(idx, "symbolOffset"), symbolSize);
    if (symbolOffset) {
      rippleGroup.x = symbolOffset[0];
      rippleGroup.y = symbolOffset[1];
    }
    var symbolRotate = data.getItemVisual(idx, "symbolRotate");
    rippleGroup.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
    var effectCfg = {};
    effectCfg.showEffectOn = seriesModel.get("showEffectOn");
    effectCfg.rippleScale = itemModel.get(["rippleEffect", "scale"]);
    effectCfg.brushType = itemModel.get(["rippleEffect", "brushType"]);
    effectCfg.period = itemModel.get(["rippleEffect", "period"]) * 1e3;
    effectCfg.effectOffset = idx / data.count();
    effectCfg.z = seriesModel.getShallow("z") || 0;
    effectCfg.zlevel = seriesModel.getShallow("zlevel") || 0;
    effectCfg.symbolType = symbolType;
    effectCfg.color = color;
    effectCfg.rippleEffectColor = itemModel.get(["rippleEffect", "color"]);
    effectCfg.rippleNumber = itemModel.get(["rippleEffect", "number"]);
    if (effectCfg.showEffectOn === "render") {
      this._effectCfg ? this.updateEffectAnimation(effectCfg) : this.startEffectAnimation(effectCfg);
      this._effectCfg = effectCfg;
    } else {
      this._effectCfg = null;
      this.stopEffectAnimation();
      this.onHoverStateChange = function(toState) {
        if (toState === "emphasis") {
          if (effectCfg.showEffectOn !== "render") {
            _this.startEffectAnimation(effectCfg);
          }
        } else if (toState === "normal") {
          if (effectCfg.showEffectOn !== "render") {
            _this.stopEffectAnimation();
          }
        }
      };
    }
    this._effectCfg = effectCfg;
    toggleHoverEmphasis(this, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  EffectSymbol2.prototype.fadeOut = function(cb) {
    cb && cb();
  };
  return EffectSymbol2;
}(Group$4);
var EffectSymbol$1 = EffectSymbol;
var EffectScatterView = function(_super) {
  __extends(EffectScatterView2, _super);
  function EffectScatterView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterView2.type;
    return _this;
  }
  EffectScatterView2.prototype.init = function() {
    this._symbolDraw = new SymbolDraw$1(EffectSymbol$1);
  };
  EffectScatterView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var effectSymbolDraw = this._symbolDraw;
    effectSymbolDraw.updateData(data, {
      clipShape: this._getClipShape(seriesModel)
    });
    this.group.add(effectSymbolDraw.group);
  };
  EffectScatterView2.prototype._getClipShape = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    var clipArea = coordSys && coordSys.getArea && coordSys.getArea();
    return seriesModel.get("clip", true) ? clipArea : null;
  };
  EffectScatterView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    this.group.dirty();
    var res = pointsLayout("").reset(seriesModel, ecModel, api);
    if (res.progress) {
      res.progress({
        start: 0,
        end: data.count(),
        count: data.count()
      }, data);
    }
    this._symbolDraw.updateLayout();
  };
  EffectScatterView2.prototype._updateGroupTransform = function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && coordSys.getRoamTransform) {
      this.group.transform = clone$2(coordSys.getRoamTransform());
      this.group.decomposeTransform();
    }
  };
  EffectScatterView2.prototype.remove = function(ecModel, api) {
    this._symbolDraw && this._symbolDraw.remove(true);
  };
  EffectScatterView2.type = "effectScatter";
  return EffectScatterView2;
}(ChartView$1);
var EffectScatterView$1 = EffectScatterView;
var EffectScatterSeriesModel = function(_super) {
  __extends(EffectScatterSeriesModel2, _super);
  function EffectScatterSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = EffectScatterSeriesModel2.type;
    _this.hasSymbolVisual = true;
    return _this;
  }
  EffectScatterSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      useEncodeDefaulter: true
    });
  };
  EffectScatterSeriesModel2.prototype.brushSelector = function(dataIndex, data, selectors) {
    return selectors.point(data.getItemLayout(dataIndex));
  };
  EffectScatterSeriesModel2.type = "series.effectScatter";
  EffectScatterSeriesModel2.dependencies = ["grid", "polar"];
  EffectScatterSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    effectType: "ripple",
    progressive: 0,
    showEffectOn: "render",
    clip: true,
    rippleEffect: {
      period: 4,
      scale: 2.5,
      brushType: "fill",
      number: 3
    },
    universalTransition: {
      divideShape: "clone"
    },
    symbolSize: 10
  };
  return EffectScatterSeriesModel2;
}(SeriesModel$1);
var EffectScatterSeriesModel$1 = EffectScatterSeriesModel;
function install$x(registers) {
  registers.registerChartView(EffectScatterView$1);
  registers.registerSeriesModel(EffectScatterSeriesModel$1);
  registers.registerLayout(pointsLayout("effectScatter"));
}
var EffectLine = function(_super) {
  __extends(EffectLine2, _super);
  function EffectLine2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this.add(_this.createLine(lineData, idx, seriesScope));
    _this._updateEffectSymbol(lineData, idx);
    return _this;
  }
  EffectLine2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Line$1(lineData, idx, seriesScope);
  };
  EffectLine2.prototype._updateEffectSymbol = function(lineData, idx) {
    var itemModel = lineData.getItemModel(idx);
    var effectModel = itemModel.getModel("effect");
    var size = effectModel.get("symbolSize");
    var symbolType = effectModel.get("symbol");
    if (!isArray$1(size)) {
      size = [size, size];
    }
    var lineStyle = lineData.getItemVisual(idx, "style");
    var color = effectModel.get("color") || lineStyle && lineStyle.stroke;
    var symbol = this.childAt(1);
    if (this._symbolType !== symbolType) {
      this.remove(symbol);
      symbol = createSymbol$1(symbolType, -0.5, -0.5, 1, 1, color);
      symbol.z2 = 100;
      symbol.culling = true;
      this.add(symbol);
    }
    if (!symbol) {
      return;
    }
    symbol.setStyle("shadowColor", color);
    symbol.setStyle(effectModel.getItemStyle(["color"]));
    symbol.scaleX = size[0];
    symbol.scaleY = size[1];
    symbol.setColor(color);
    this._symbolType = symbolType;
    this._symbolScale = size;
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  EffectLine2.prototype._updateEffectAnimation = function(lineData, effectModel, idx) {
    var symbol = this.childAt(1);
    if (!symbol) {
      return;
    }
    var points2 = lineData.getItemLayout(idx);
    var period = effectModel.get("period") * 1e3;
    var loop = effectModel.get("loop");
    var constantSpeed = effectModel.get("constantSpeed");
    var delayExpr = retrieve(effectModel.get("delay"), function(idx2) {
      return idx2 / lineData.count() * period / 3;
    });
    symbol.ignore = true;
    this._updateAnimationPoints(symbol, points2);
    if (constantSpeed > 0) {
      period = this._getLineLength(symbol) / constantSpeed * 1e3;
    }
    if (period !== this._period || loop !== this._loop) {
      symbol.stopAnimation();
      var delayNum = void 0;
      if (isFunction(delayExpr)) {
        delayNum = delayExpr(idx);
      } else {
        delayNum = delayExpr;
      }
      if (symbol.__t > 0) {
        delayNum = -period * symbol.__t;
      }
      this._animateSymbol(symbol, period, delayNum, loop);
    }
    this._period = period;
    this._loop = loop;
  };
  EffectLine2.prototype._animateSymbol = function(symbol, period, delayNum, loop) {
    if (period > 0) {
      symbol.__t = 0;
      var self_1 = this;
      var animator = symbol.animate("", loop).when(period, {
        __t: 1
      }).delay(delayNum).during(function() {
        self_1._updateSymbolPosition(symbol);
      });
      if (!loop) {
        animator.done(function() {
          self_1.remove(symbol);
        });
      }
      animator.start();
    }
  };
  EffectLine2.prototype._getLineLength = function(symbol) {
    return dist$1(symbol.__p1, symbol.__cp1) + dist$1(symbol.__cp1, symbol.__p2);
  };
  EffectLine2.prototype._updateAnimationPoints = function(symbol, points2) {
    symbol.__p1 = points2[0];
    symbol.__p2 = points2[1];
    symbol.__cp1 = points2[2] || [(points2[0][0] + points2[1][0]) / 2, (points2[0][1] + points2[1][1]) / 2];
  };
  EffectLine2.prototype.updateData = function(lineData, idx, seriesScope) {
    this.childAt(0).updateData(lineData, idx, seriesScope);
    this._updateEffectSymbol(lineData, idx);
  };
  EffectLine2.prototype._updateSymbolPosition = function(symbol) {
    var p1 = symbol.__p1;
    var p2 = symbol.__p2;
    var cp1 = symbol.__cp1;
    var t2 = symbol.__t;
    var pos = [symbol.x, symbol.y];
    var lastPos = pos.slice();
    var quadraticAt2 = quadraticAt$1;
    var quadraticDerivativeAt$1 = quadraticDerivativeAt;
    pos[0] = quadraticAt2(p1[0], cp1[0], p2[0], t2);
    pos[1] = quadraticAt2(p1[1], cp1[1], p2[1], t2);
    var tx = quadraticDerivativeAt$1(p1[0], cp1[0], p2[0], t2);
    var ty = quadraticDerivativeAt$1(p1[1], cp1[1], p2[1], t2);
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    if (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") {
      if (symbol.__lastT !== void 0 && symbol.__lastT < symbol.__t) {
        symbol.scaleY = dist$1(lastPos, pos) * 1.05;
        if (t2 === 1) {
          pos[0] = lastPos[0] + (pos[0] - lastPos[0]) / 2;
          pos[1] = lastPos[1] + (pos[1] - lastPos[1]) / 2;
        }
      } else if (symbol.__lastT === 1) {
        symbol.scaleY = 2 * dist$1(p1, pos);
      } else {
        symbol.scaleY = this._symbolScale[1];
      }
    }
    symbol.__lastT = symbol.__t;
    symbol.ignore = false;
    symbol.x = pos[0];
    symbol.y = pos[1];
  };
  EffectLine2.prototype.updateLayout = function(lineData, idx) {
    this.childAt(0).updateLayout(lineData, idx);
    var effectModel = lineData.getItemModel(idx).getModel("effect");
    this._updateEffectAnimation(lineData, effectModel, idx);
  };
  return EffectLine2;
}(Group$4);
var EffectLine$1 = EffectLine;
var Polyline = function(_super) {
  __extends(Polyline2, _super);
  function Polyline2(lineData, idx, seriesScope) {
    var _this = _super.call(this) || this;
    _this._createPolyline(lineData, idx, seriesScope);
    return _this;
  }
  Polyline2.prototype._createPolyline = function(lineData, idx, seriesScope) {
    var points2 = lineData.getItemLayout(idx);
    var line = new Polyline$3({
      shape: {
        points: points2
      }
    });
    this.add(line);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype.updateData = function(lineData, idx, seriesScope) {
    var seriesModel = lineData.hostModel;
    var line = this.childAt(0);
    var target = {
      shape: {
        points: lineData.getItemLayout(idx)
      }
    };
    updateProps$1(line, target, seriesModel, idx);
    this._updateCommonStl(lineData, idx, seriesScope);
  };
  Polyline2.prototype._updateCommonStl = function(lineData, idx, seriesScope) {
    var line = this.childAt(0);
    var itemModel = lineData.getItemModel(idx);
    var emphasisLineStyle = seriesScope && seriesScope.emphasisLineStyle;
    var focus = seriesScope && seriesScope.focus;
    var blurScope = seriesScope && seriesScope.blurScope;
    var emphasisDisabled = seriesScope && seriesScope.emphasisDisabled;
    if (!seriesScope || lineData.hasItemOption) {
      var emphasisModel = itemModel.getModel("emphasis");
      emphasisLineStyle = emphasisModel.getModel("lineStyle").getLineStyle();
      emphasisDisabled = emphasisModel.get("disabled");
      focus = emphasisModel.get("focus");
      blurScope = emphasisModel.get("blurScope");
    }
    line.useStyle(lineData.getItemVisual(idx, "style"));
    line.style.fill = null;
    line.style.strokeNoScale = true;
    var lineEmphasisState = line.ensureState("emphasis");
    lineEmphasisState.style = emphasisLineStyle;
    toggleHoverEmphasis(this, focus, blurScope, emphasisDisabled);
  };
  Polyline2.prototype.updateLayout = function(lineData, idx) {
    var polyline = this.childAt(0);
    polyline.setShape("points", lineData.getItemLayout(idx));
  };
  return Polyline2;
}(Group$4);
var Polyline$1 = Polyline;
var EffectPolyline = function(_super) {
  __extends(EffectPolyline2, _super);
  function EffectPolyline2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this._lastFrame = 0;
    _this._lastFramePercent = 0;
    return _this;
  }
  EffectPolyline2.prototype.createLine = function(lineData, idx, seriesScope) {
    return new Polyline$1(lineData, idx, seriesScope);
  };
  EffectPolyline2.prototype._updateAnimationPoints = function(symbol, points2) {
    this._points = points2;
    var accLenArr = [0];
    var len2 = 0;
    for (var i = 1; i < points2.length; i++) {
      var p1 = points2[i - 1];
      var p2 = points2[i];
      len2 += dist$1(p1, p2);
      accLenArr.push(len2);
    }
    if (len2 === 0) {
      this._length = 0;
      return;
    }
    for (var i = 0; i < accLenArr.length; i++) {
      accLenArr[i] /= len2;
    }
    this._offsets = accLenArr;
    this._length = len2;
  };
  EffectPolyline2.prototype._getLineLength = function() {
    return this._length;
  };
  EffectPolyline2.prototype._updateSymbolPosition = function(symbol) {
    var t2 = symbol.__t;
    var points2 = this._points;
    var offsets = this._offsets;
    var len2 = points2.length;
    if (!offsets) {
      return;
    }
    var lastFrame = this._lastFrame;
    var frame;
    if (t2 < this._lastFramePercent) {
      var start2 = Math.min(lastFrame + 1, len2 - 1);
      for (frame = start2; frame >= 0; frame--) {
        if (offsets[frame] <= t2) {
          break;
        }
      }
      frame = Math.min(frame, len2 - 2);
    } else {
      for (frame = lastFrame; frame < len2; frame++) {
        if (offsets[frame] > t2) {
          break;
        }
      }
      frame = Math.min(frame - 1, len2 - 2);
    }
    var p2 = (t2 - offsets[frame]) / (offsets[frame + 1] - offsets[frame]);
    var p0 = points2[frame];
    var p1 = points2[frame + 1];
    symbol.x = p0[0] * (1 - p2) + p2 * p1[0];
    symbol.y = p0[1] * (1 - p2) + p2 * p1[1];
    var tx = p1[0] - p0[0];
    var ty = p1[1] - p0[1];
    symbol.rotation = -Math.atan2(ty, tx) - Math.PI / 2;
    this._lastFrame = frame;
    this._lastFramePercent = t2;
    symbol.ignore = false;
  };
  return EffectPolyline2;
}(EffectLine$1);
var EffectPolyline$1 = EffectPolyline;
var LargeLinesPathShape = function() {
  function LargeLinesPathShape2() {
    this.polyline = false;
    this.curveness = 0;
    this.segs = [];
  }
  return LargeLinesPathShape2;
}();
var LargeLinesPath = function(_super) {
  __extends(LargeLinesPath2, _super);
  function LargeLinesPath2(opts) {
    var _this = _super.call(this, opts) || this;
    _this._off = 0;
    _this.hoverDataIdx = -1;
    return _this;
  }
  LargeLinesPath2.prototype.reset = function() {
    this.notClear = false;
    this._off = 0;
  };
  LargeLinesPath2.prototype.getDefaultStyle = function() {
    return {
      stroke: "#000",
      fill: null
    };
  };
  LargeLinesPath2.prototype.getDefaultShape = function() {
    return new LargeLinesPathShape();
  };
  LargeLinesPath2.prototype.buildPath = function(ctx, shape) {
    var segs = shape.segs;
    var curveness = shape.curveness;
    var i;
    if (shape.polyline) {
      for (i = this._off; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          ctx.moveTo(segs[i++], segs[i++]);
          for (var k2 = 1; k2 < count2; k2++) {
            ctx.lineTo(segs[i++], segs[i++]);
          }
        }
      }
    } else {
      for (i = this._off; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        ctx.moveTo(x0, y0);
        if (curveness > 0) {
          var x2 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y2 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          ctx.quadraticCurveTo(x2, y2, x1, y1);
        } else {
          ctx.lineTo(x1, y1);
        }
      }
    }
    if (this.incremental) {
      this._off = i;
      this.notClear = true;
    }
  };
  LargeLinesPath2.prototype.findDataIndex = function(x2, y2) {
    var shape = this.shape;
    var segs = shape.segs;
    var curveness = shape.curveness;
    var lineWidth = this.style.lineWidth;
    if (shape.polyline) {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var count2 = segs[i++];
        if (count2 > 0) {
          var x0 = segs[i++];
          var y0 = segs[i++];
          for (var k2 = 1; k2 < count2; k2++) {
            var x1 = segs[i++];
            var y1 = segs[i++];
            if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
              return dataIndex;
            }
          }
        }
        dataIndex++;
      }
    } else {
      var dataIndex = 0;
      for (var i = 0; i < segs.length; ) {
        var x0 = segs[i++];
        var y0 = segs[i++];
        var x1 = segs[i++];
        var y1 = segs[i++];
        if (curveness > 0) {
          var x22 = (x0 + x1) / 2 - (y0 - y1) * curveness;
          var y22 = (y0 + y1) / 2 - (x1 - x0) * curveness;
          if (containStroke$2(x0, y0, x22, y22, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        } else {
          if (containStroke$4(x0, y0, x1, y1, lineWidth, x2, y2)) {
            return dataIndex;
          }
        }
        dataIndex++;
      }
    }
    return -1;
  };
  LargeLinesPath2.prototype.contain = function(x2, y2) {
    var localPos = this.transformCoordToLocal(x2, y2);
    var rect = this.getBoundingRect();
    x2 = localPos[0];
    y2 = localPos[1];
    if (rect.contain(x2, y2)) {
      var dataIdx = this.hoverDataIdx = this.findDataIndex(x2, y2);
      return dataIdx >= 0;
    }
    this.hoverDataIdx = -1;
    return false;
  };
  LargeLinesPath2.prototype.getBoundingRect = function() {
    var rect = this._rect;
    if (!rect) {
      var shape = this.shape;
      var points2 = shape.segs;
      var minX = Infinity;
      var minY = Infinity;
      var maxX = -Infinity;
      var maxY = -Infinity;
      for (var i = 0; i < points2.length; ) {
        var x2 = points2[i++];
        var y2 = points2[i++];
        minX = Math.min(x2, minX);
        maxX = Math.max(x2, maxX);
        minY = Math.min(y2, minY);
        maxY = Math.max(y2, maxY);
      }
      rect = this._rect = new BoundingRect$1(minX, minY, maxX, maxY);
    }
    return rect;
  };
  return LargeLinesPath2;
}(Path$1);
var LargeLineDraw = function() {
  function LargeLineDraw2() {
    this.group = new Group$4();
  }
  LargeLineDraw2.prototype.updateData = function(data) {
    this._clear();
    var lineEl = this._create();
    lineEl.setShape({
      segs: data.getLayout("linesPoints")
    });
    this._setCommon(lineEl, data);
  };
  LargeLineDraw2.prototype.incrementalPrepareUpdate = function(data) {
    this.group.removeAll();
    this._clear();
  };
  LargeLineDraw2.prototype.incrementalUpdate = function(taskParams, data) {
    var lastAdded = this._newAdded[0];
    var linePoints = data.getLayout("linesPoints");
    var oldSegs = lastAdded && lastAdded.shape.segs;
    if (oldSegs && oldSegs.length < 2e4) {
      var oldLen = oldSegs.length;
      var newSegs = new Float32Array(oldLen + linePoints.length);
      newSegs.set(oldSegs);
      newSegs.set(linePoints, oldLen);
      lastAdded.setShape({
        segs: newSegs
      });
    } else {
      this._newAdded = [];
      var lineEl = this._create();
      lineEl.incremental = true;
      lineEl.setShape({
        segs: linePoints
      });
      this._setCommon(lineEl, data);
      lineEl.__startIndex = taskParams.start;
    }
  };
  LargeLineDraw2.prototype.remove = function() {
    this._clear();
  };
  LargeLineDraw2.prototype.eachRendered = function(cb) {
    this._newAdded[0] && cb(this._newAdded[0]);
  };
  LargeLineDraw2.prototype._create = function() {
    var lineEl = new LargeLinesPath({
      cursor: "default"
    });
    this._newAdded.push(lineEl);
    this.group.add(lineEl);
    return lineEl;
  };
  LargeLineDraw2.prototype._setCommon = function(lineEl, data, isIncremental) {
    var hostModel = data.hostModel;
    lineEl.setShape({
      polyline: hostModel.get("polyline"),
      curveness: hostModel.get(["lineStyle", "curveness"])
    });
    lineEl.useStyle(hostModel.getModel("lineStyle").getLineStyle());
    lineEl.style.strokeNoScale = true;
    var style = data.getVisual("style");
    if (style && style.stroke) {
      lineEl.setStyle("stroke", style.stroke);
    }
    lineEl.setStyle("fill", null);
    var ecData = getECData(lineEl);
    ecData.seriesIndex = hostModel.seriesIndex;
    lineEl.on("mousemove", function(e2) {
      ecData.dataIndex = null;
      var dataIndex = lineEl.hoverDataIdx;
      if (dataIndex > 0) {
        ecData.dataIndex = dataIndex + lineEl.__startIndex;
      }
    });
  };
  LargeLineDraw2.prototype._clear = function() {
    this._newAdded = [];
    this.group.removeAll();
  };
  return LargeLineDraw2;
}();
var LargeLineDraw$1 = LargeLineDraw;
var linesLayout = {
  seriesType: "lines",
  plan: createRenderPlanner(),
  reset: function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (!coordSys) {
      return;
    }
    var isPolyline = seriesModel.get("polyline");
    var isLarge = seriesModel.pipelineContext.large;
    return {
      progress: function(params, lineData) {
        var lineCoords = [];
        if (isLarge) {
          var points2 = void 0;
          var segCount = params.end - params.start;
          if (isPolyline) {
            var totalCoordsCount = 0;
            for (var i = params.start; i < params.end; i++) {
              totalCoordsCount += seriesModel.getLineCoordsCount(i);
            }
            points2 = new Float32Array(segCount + totalCoordsCount * 2);
          } else {
            points2 = new Float32Array(segCount * 4);
          }
          var offset = 0;
          var pt = [];
          for (var i = params.start; i < params.end; i++) {
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            if (isPolyline) {
              points2[offset++] = len2;
            }
            for (var k2 = 0; k2 < len2; k2++) {
              pt = coordSys.dataToPoint(lineCoords[k2], false, pt);
              points2[offset++] = pt[0];
              points2[offset++] = pt[1];
            }
          }
          lineData.setLayout("linesPoints", points2);
        } else {
          for (var i = params.start; i < params.end; i++) {
            var itemModel = lineData.getItemModel(i);
            var len2 = seriesModel.getLineCoords(i, lineCoords);
            var pts = [];
            if (isPolyline) {
              for (var j = 0; j < len2; j++) {
                pts.push(coordSys.dataToPoint(lineCoords[j]));
              }
            } else {
              pts[0] = coordSys.dataToPoint(lineCoords[0]);
              pts[1] = coordSys.dataToPoint(lineCoords[1]);
              var curveness = itemModel.get(["lineStyle", "curveness"]);
              if (+curveness) {
                pts[2] = [(pts[0][0] + pts[1][0]) / 2 - (pts[0][1] - pts[1][1]) * curveness, (pts[0][1] + pts[1][1]) / 2 - (pts[1][0] - pts[0][0]) * curveness];
              }
            }
            lineData.setItemLayout(i, pts);
          }
        }
      }
    };
  }
};
var linesLayout$1 = linesLayout;
var LinesView = function(_super) {
  __extends(LinesView2, _super);
  function LinesView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesView2.type;
    return _this;
  }
  LinesView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    var zlevel = seriesModel.get("zlevel");
    var trailLength = seriesModel.get(["effect", "trailLength"]);
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg) {
      zr.painter.getLayer(zlevel).clear(true);
    }
    if (this._lastZlevel != null && !isSvg) {
      zr.configLayer(this._lastZlevel, {
        motionBlur: false
      });
    }
    if (this._showEffect(seriesModel) && trailLength > 0) {
      if (!isSvg) {
        zr.configLayer(zlevel, {
          motionBlur: true,
          lastFrameAlpha: Math.max(Math.min(trailLength / 10 + 0.9, 1), 0)
        });
      }
    }
    lineDraw.updateData(data);
    var clipPath = seriesModel.get("clip", true) && createClipPath(seriesModel.coordinateSystem, false, seriesModel);
    if (clipPath) {
      this.group.setClipPath(clipPath);
    } else {
      this.group.removeClipPath();
    }
    this._lastZlevel = zlevel;
    this._finished = true;
  };
  LinesView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var lineDraw = this._updateLineDraw(data, seriesModel);
    lineDraw.incrementalPrepareUpdate(data);
    this._clearLayer(api);
    this._finished = false;
  };
  LinesView2.prototype.incrementalRender = function(taskParams, seriesModel, ecModel) {
    this._lineDraw.incrementalUpdate(taskParams, seriesModel.getData());
    this._finished = taskParams.end === seriesModel.getData().count();
  };
  LinesView2.prototype.eachRendered = function(cb) {
    this._lineDraw && this._lineDraw.eachRendered(cb);
  };
  LinesView2.prototype.updateTransform = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var pipelineContext = seriesModel.pipelineContext;
    if (!this._finished || pipelineContext.large || pipelineContext.progressiveRender) {
      return {
        update: true
      };
    } else {
      var res = linesLayout$1.reset(seriesModel, ecModel, api);
      if (res.progress) {
        res.progress({
          start: 0,
          end: data.count(),
          count: data.count()
        }, data);
      }
      this._lineDraw.updateLayout();
      this._clearLayer(api);
    }
  };
  LinesView2.prototype._updateLineDraw = function(data, seriesModel) {
    var lineDraw = this._lineDraw;
    var hasEffect = this._showEffect(seriesModel);
    var isPolyline = !!seriesModel.get("polyline");
    var pipelineContext = seriesModel.pipelineContext;
    var isLargeDraw = pipelineContext.large;
    if (!lineDraw || hasEffect !== this._hasEffet || isPolyline !== this._isPolyline || isLargeDraw !== this._isLargeDraw) {
      if (lineDraw) {
        lineDraw.remove();
      }
      lineDraw = this._lineDraw = isLargeDraw ? new LargeLineDraw$1() : new LineDraw$1(isPolyline ? hasEffect ? EffectPolyline$1 : Polyline$1 : hasEffect ? EffectLine$1 : Line$1);
      this._hasEffet = hasEffect;
      this._isPolyline = isPolyline;
      this._isLargeDraw = isLargeDraw;
    }
    this.group.add(lineDraw.group);
    return lineDraw;
  };
  LinesView2.prototype._showEffect = function(seriesModel) {
    return !!seriesModel.get(["effect", "show"]);
  };
  LinesView2.prototype._clearLayer = function(api) {
    var zr = api.getZr();
    var isSvg = zr.painter.getType() === "svg";
    if (!isSvg && this._lastZlevel != null) {
      zr.painter.getLayer(this._lastZlevel).clear(true);
    }
  };
  LinesView2.prototype.remove = function(ecModel, api) {
    this._lineDraw && this._lineDraw.remove();
    this._lineDraw = null;
    this._clearLayer(api);
  };
  LinesView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  LinesView2.type = "lines";
  return LinesView2;
}(ChartView$1);
var LinesView$1 = LinesView;
var Uint32Arr = typeof Uint32Array === "undefined" ? Array : Uint32Array;
var Float64Arr = typeof Float64Array === "undefined" ? Array : Float64Array;
function compatEc2(seriesOpt) {
  var data = seriesOpt.data;
  if (data && data[0] && data[0][0] && data[0][0].coord) {
    seriesOpt.data = map$1(data, function(itemOpt) {
      var coords = [itemOpt[0].coord, itemOpt[1].coord];
      var target = {
        coords
      };
      if (itemOpt[0].name) {
        target.fromName = itemOpt[0].name;
      }
      if (itemOpt[1].name) {
        target.toName = itemOpt[1].name;
      }
      return mergeAll([target, itemOpt[0], itemOpt[1]]);
    });
  }
}
var LinesSeriesModel = function(_super) {
  __extends(LinesSeriesModel2, _super);
  function LinesSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LinesSeriesModel2.type;
    _this.visualStyleAccessPath = "lineStyle";
    _this.visualDrawType = "stroke";
    return _this;
  }
  LinesSeriesModel2.prototype.init = function(option) {
    option.data = option.data || [];
    compatEc2(option);
    var result = this._processFlatCoordsArray(option.data);
    this._flatCoords = result.flatCoords;
    this._flatCoordsOffset = result.flatCoordsOffset;
    if (result.flatCoords) {
      option.data = new Float32Array(result.count);
    }
    _super.prototype.init.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.mergeOption = function(option) {
    compatEc2(option);
    if (option.data) {
      var result = this._processFlatCoordsArray(option.data);
      this._flatCoords = result.flatCoords;
      this._flatCoordsOffset = result.flatCoordsOffset;
      if (result.flatCoords) {
        option.data = new Float32Array(result.count);
      }
    }
    _super.prototype.mergeOption.apply(this, arguments);
  };
  LinesSeriesModel2.prototype.appendData = function(params) {
    var result = this._processFlatCoordsArray(params.data);
    if (result.flatCoords) {
      if (!this._flatCoords) {
        this._flatCoords = result.flatCoords;
        this._flatCoordsOffset = result.flatCoordsOffset;
      } else {
        this._flatCoords = concatArray(this._flatCoords, result.flatCoords);
        this._flatCoordsOffset = concatArray(this._flatCoordsOffset, result.flatCoordsOffset);
      }
      params.data = new Float32Array(result.count);
    }
    this.getRawData().appendData(params.data);
  };
  LinesSeriesModel2.prototype._getCoordsFromItemModel = function(idx) {
    var itemModel = this.getData().getItemModel(idx);
    var coords = itemModel.option instanceof Array ? itemModel.option : itemModel.getShallow("coords");
    return coords;
  };
  LinesSeriesModel2.prototype.getLineCoordsCount = function(idx) {
    if (this._flatCoordsOffset) {
      return this._flatCoordsOffset[idx * 2 + 1];
    } else {
      return this._getCoordsFromItemModel(idx).length;
    }
  };
  LinesSeriesModel2.prototype.getLineCoords = function(idx, out2) {
    if (this._flatCoordsOffset) {
      var offset = this._flatCoordsOffset[idx * 2];
      var len2 = this._flatCoordsOffset[idx * 2 + 1];
      for (var i = 0; i < len2; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = this._flatCoords[offset + i * 2];
        out2[i][1] = this._flatCoords[offset + i * 2 + 1];
      }
      return len2;
    } else {
      var coords = this._getCoordsFromItemModel(idx);
      for (var i = 0; i < coords.length; i++) {
        out2[i] = out2[i] || [];
        out2[i][0] = coords[i][0];
        out2[i][1] = coords[i][1];
      }
      return coords.length;
    }
  };
  LinesSeriesModel2.prototype._processFlatCoordsArray = function(data) {
    var startOffset = 0;
    if (this._flatCoords) {
      startOffset = this._flatCoords.length;
    }
    if (isNumber(data[0])) {
      var len2 = data.length;
      var coordsOffsetAndLenStorage = new Uint32Arr(len2);
      var coordsStorage = new Float64Arr(len2);
      var coordsCursor = 0;
      var offsetCursor = 0;
      var dataCount = 0;
      for (var i = 0; i < len2; ) {
        dataCount++;
        var count2 = data[i++];
        coordsOffsetAndLenStorage[offsetCursor++] = coordsCursor + startOffset;
        coordsOffsetAndLenStorage[offsetCursor++] = count2;
        for (var k2 = 0; k2 < count2; k2++) {
          var x2 = data[i++];
          var y2 = data[i++];
          coordsStorage[coordsCursor++] = x2;
          coordsStorage[coordsCursor++] = y2;
        }
      }
      return {
        flatCoordsOffset: new Uint32Array(coordsOffsetAndLenStorage.buffer, 0, offsetCursor),
        flatCoords: coordsStorage,
        count: dataCount
      };
    }
    return {
      flatCoordsOffset: null,
      flatCoords: null,
      count: data.length
    };
  };
  LinesSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var lineData = new SeriesData$1(["value"], this);
    lineData.hasItemOption = false;
    lineData.initData(option.data, [], function(dataItem, dimName, dataIndex, dimIndex) {
      if (dataItem instanceof Array) {
        return NaN;
      } else {
        lineData.hasItemOption = true;
        var value = dataItem.value;
        if (value != null) {
          return value instanceof Array ? value[dimIndex] : value;
        }
      }
    });
    return lineData;
  };
  LinesSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var itemModel = data.getItemModel(dataIndex);
    var name = itemModel.get("name");
    if (name) {
      return name;
    }
    var fromName = itemModel.get("fromName");
    var toName = itemModel.get("toName");
    var nameArr = [];
    fromName != null && nameArr.push(fromName);
    toName != null && nameArr.push(toName);
    return createTooltipMarkup("nameValue", {
      name: nameArr.join(" > ")
    });
  };
  LinesSeriesModel2.prototype.preventIncremental = function() {
    return !!this.get(["effect", "show"]);
  };
  LinesSeriesModel2.prototype.getProgressive = function() {
    var progressive = this.option.progressive;
    if (progressive == null) {
      return this.option.large ? 1e4 : this.get("progressive");
    }
    return progressive;
  };
  LinesSeriesModel2.prototype.getProgressiveThreshold = function() {
    var progressiveThreshold = this.option.progressiveThreshold;
    if (progressiveThreshold == null) {
      return this.option.large ? 2e4 : this.get("progressiveThreshold");
    }
    return progressiveThreshold;
  };
  LinesSeriesModel2.prototype.getZLevelKey = function() {
    var effectModel = this.getModel("effect");
    var trailLength = effectModel.get("trailLength");
    return this.getData().count() > this.getProgressiveThreshold() ? this.id : effectModel.get("show") && trailLength > 0 ? trailLength + "" : "";
  };
  LinesSeriesModel2.type = "series.lines";
  LinesSeriesModel2.dependencies = ["grid", "polar", "geo", "calendar"];
  LinesSeriesModel2.defaultOption = {
    coordinateSystem: "geo",
    z: 2,
    legendHoverLink: true,
    xAxisIndex: 0,
    yAxisIndex: 0,
    symbol: ["none", "none"],
    symbolSize: [10, 10],
    geoIndex: 0,
    effect: {
      show: false,
      period: 4,
      constantSpeed: 0,
      symbol: "circle",
      symbolSize: 3,
      loop: true,
      trailLength: 0.2
    },
    large: false,
    largeThreshold: 2e3,
    polyline: false,
    clip: true,
    label: {
      show: false,
      position: "end"
    },
    lineStyle: {
      opacity: 0.5
    }
  };
  return LinesSeriesModel2;
}(SeriesModel$1);
var LinesSeriesModel$1 = LinesSeriesModel;
function normalize$1(a) {
  if (!(a instanceof Array)) {
    a = [a, a];
  }
  return a;
}
var linesVisual = {
  seriesType: "lines",
  reset: function(seriesModel) {
    var symbolType = normalize$1(seriesModel.get("symbol"));
    var symbolSize = normalize$1(seriesModel.get("symbolSize"));
    var data = seriesModel.getData();
    data.setVisual("fromSymbol", symbolType && symbolType[0]);
    data.setVisual("toSymbol", symbolType && symbolType[1]);
    data.setVisual("fromSymbolSize", symbolSize && symbolSize[0]);
    data.setVisual("toSymbolSize", symbolSize && symbolSize[1]);
    function dataEach(data2, idx) {
      var itemModel = data2.getItemModel(idx);
      var symbolType2 = normalize$1(itemModel.getShallow("symbol", true));
      var symbolSize2 = normalize$1(itemModel.getShallow("symbolSize", true));
      symbolType2[0] && data2.setItemVisual(idx, "fromSymbol", symbolType2[0]);
      symbolType2[1] && data2.setItemVisual(idx, "toSymbol", symbolType2[1]);
      symbolSize2[0] && data2.setItemVisual(idx, "fromSymbolSize", symbolSize2[0]);
      symbolSize2[1] && data2.setItemVisual(idx, "toSymbolSize", symbolSize2[1]);
    }
    return {
      dataEach: data.hasItemOption ? dataEach : null
    };
  }
};
var linesVisual$1 = linesVisual;
function install$w(registers) {
  registers.registerChartView(LinesView$1);
  registers.registerSeriesModel(LinesSeriesModel$1);
  registers.registerLayout(linesLayout$1);
  registers.registerVisual(linesVisual$1);
}
var GRADIENT_LEVELS = 256;
var HeatmapLayer = function() {
  function HeatmapLayer2() {
    this.blurSize = 30;
    this.pointSize = 20;
    this.maxOpacity = 1;
    this.minOpacity = 0;
    this._gradientPixels = {
      inRange: null,
      outOfRange: null
    };
    var canvas = platformApi.createCanvas();
    this.canvas = canvas;
  }
  HeatmapLayer2.prototype.update = function(data, width, height, normalize2, colorFunc, isInRange) {
    var brush2 = this._getBrush();
    var gradientInRange = this._getGradient(colorFunc, "inRange");
    var gradientOutOfRange = this._getGradient(colorFunc, "outOfRange");
    var r2 = this.pointSize + this.blurSize;
    var canvas = this.canvas;
    var ctx = canvas.getContext("2d");
    var len2 = data.length;
    canvas.width = width;
    canvas.height = height;
    for (var i = 0; i < len2; ++i) {
      var p2 = data[i];
      var x2 = p2[0];
      var y2 = p2[1];
      var value = p2[2];
      var alpha = normalize2(value);
      ctx.globalAlpha = alpha;
      ctx.drawImage(brush2, x2 - r2, y2 - r2);
    }
    if (!canvas.width || !canvas.height) {
      return canvas;
    }
    var imageData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    var pixels = imageData.data;
    var offset = 0;
    var pixelLen = pixels.length;
    var minOpacity = this.minOpacity;
    var maxOpacity = this.maxOpacity;
    var diffOpacity = maxOpacity - minOpacity;
    while (offset < pixelLen) {
      var alpha = pixels[offset + 3] / 256;
      var gradientOffset = Math.floor(alpha * (GRADIENT_LEVELS - 1)) * 4;
      if (alpha > 0) {
        var gradient = isInRange(alpha) ? gradientInRange : gradientOutOfRange;
        alpha > 0 && (alpha = alpha * diffOpacity + minOpacity);
        pixels[offset++] = gradient[gradientOffset];
        pixels[offset++] = gradient[gradientOffset + 1];
        pixels[offset++] = gradient[gradientOffset + 2];
        pixels[offset++] = gradient[gradientOffset + 3] * alpha * 256;
      } else {
        offset += 4;
      }
    }
    ctx.putImageData(imageData, 0, 0);
    return canvas;
  };
  HeatmapLayer2.prototype._getBrush = function() {
    var brushCanvas = this._brushCanvas || (this._brushCanvas = platformApi.createCanvas());
    var r2 = this.pointSize + this.blurSize;
    var d2 = r2 * 2;
    brushCanvas.width = d2;
    brushCanvas.height = d2;
    var ctx = brushCanvas.getContext("2d");
    ctx.clearRect(0, 0, d2, d2);
    ctx.shadowOffsetX = d2;
    ctx.shadowBlur = this.blurSize;
    ctx.shadowColor = "#000";
    ctx.beginPath();
    ctx.arc(-r2, r2, this.pointSize, 0, Math.PI * 2, true);
    ctx.closePath();
    ctx.fill();
    return brushCanvas;
  };
  HeatmapLayer2.prototype._getGradient = function(colorFunc, state) {
    var gradientPixels = this._gradientPixels;
    var pixelsSingleState = gradientPixels[state] || (gradientPixels[state] = new Uint8ClampedArray(256 * 4));
    var color = [0, 0, 0, 0];
    var off = 0;
    for (var i = 0; i < 256; i++) {
      colorFunc[state](i / 255, true, color);
      pixelsSingleState[off++] = color[0];
      pixelsSingleState[off++] = color[1];
      pixelsSingleState[off++] = color[2];
      pixelsSingleState[off++] = color[3];
    }
    return pixelsSingleState;
  };
  return HeatmapLayer2;
}();
var HeatmapLayer$1 = HeatmapLayer;
function getIsInPiecewiseRange(dataExtent, pieceList, selected) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  pieceList = map$1(pieceList, function(piece) {
    return {
      interval: [(piece.interval[0] - dataExtent[0]) / dataSpan, (piece.interval[1] - dataExtent[0]) / dataSpan]
    };
  });
  var len2 = pieceList.length;
  var lastIndex = 0;
  return function(val) {
    var i;
    for (i = lastIndex; i < len2; i++) {
      var interval = pieceList[i].interval;
      if (interval[0] <= val && val <= interval[1]) {
        lastIndex = i;
        break;
      }
    }
    if (i === len2) {
      for (i = lastIndex - 1; i >= 0; i--) {
        var interval = pieceList[i].interval;
        if (interval[0] <= val && val <= interval[1]) {
          lastIndex = i;
          break;
        }
      }
    }
    return i >= 0 && i < len2 && selected[i];
  };
}
function getIsInContinuousRange(dataExtent, range3) {
  var dataSpan = dataExtent[1] - dataExtent[0];
  range3 = [(range3[0] - dataExtent[0]) / dataSpan, (range3[1] - dataExtent[0]) / dataSpan];
  return function(val) {
    return val >= range3[0] && val <= range3[1];
  };
}
function isGeoCoordSys(coordSys) {
  var dimensions = coordSys.dimensions;
  return dimensions[0] === "lng" && dimensions[1] === "lat";
}
var HeatmapView = function(_super) {
  __extends(HeatmapView2, _super);
  function HeatmapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapView2.type;
    return _this;
  }
  HeatmapView2.prototype.render = function(seriesModel, ecModel, api) {
    var visualMapOfThisSeries;
    ecModel.eachComponent("visualMap", function(visualMap) {
      visualMap.eachTargetSeries(function(targetSeries) {
        if (targetSeries === seriesModel) {
          visualMapOfThisSeries = visualMap;
        }
      });
    });
    this._progressiveEls = null;
    this.group.removeAll();
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys.type === "cartesian2d" || coordSys.type === "calendar") {
      this._renderOnCartesianAndCalendar(seriesModel, api, 0, seriesModel.getData().count());
    } else if (isGeoCoordSys(coordSys)) {
      this._renderOnGeo(coordSys, seriesModel, visualMapOfThisSeries, api);
    }
  };
  HeatmapView2.prototype.incrementalPrepareRender = function(seriesModel, ecModel, api) {
    this.group.removeAll();
  };
  HeatmapView2.prototype.incrementalRender = function(params, seriesModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys) {
      if (isGeoCoordSys(coordSys)) {
        this.render(seriesModel, ecModel, api);
      } else {
        this._progressiveEls = [];
        this._renderOnCartesianAndCalendar(seriesModel, api, params.start, params.end, true);
      }
    }
  };
  HeatmapView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  HeatmapView2.prototype._renderOnCartesianAndCalendar = function(seriesModel, api, start2, end2, incremental) {
    var coordSys = seriesModel.coordinateSystem;
    var width;
    var height;
    var xAxisExtent;
    var yAxisExtent;
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      width = xAxis.getBandWidth();
      height = yAxis.getBandWidth();
      xAxisExtent = xAxis.scale.getExtent();
      yAxisExtent = yAxis.scale.getExtent();
    }
    var group = this.group;
    var data = seriesModel.getData();
    var emphasisStyle = seriesModel.getModel(["emphasis", "itemStyle"]).getItemStyle();
    var blurStyle = seriesModel.getModel(["blur", "itemStyle"]).getItemStyle();
    var selectStyle = seriesModel.getModel(["select", "itemStyle"]).getItemStyle();
    var borderRadius = seriesModel.get(["itemStyle", "borderRadius"]);
    var labelStatesModels = getLabelStatesModels(seriesModel);
    var emphasisModel = seriesModel.getModel("emphasis");
    var focus = emphasisModel.get("focus");
    var blurScope = emphasisModel.get("blurScope");
    var emphasisDisabled = emphasisModel.get("disabled");
    var dataDims = isCoordinateSystemType(coordSys, "cartesian2d") ? [data.mapDimension("x"), data.mapDimension("y"), data.mapDimension("value")] : [data.mapDimension("time"), data.mapDimension("value")];
    for (var idx = start2; idx < end2; idx++) {
      var rect = void 0;
      var style = data.getItemVisual(idx, "style");
      if (isCoordinateSystemType(coordSys, "cartesian2d")) {
        var dataDimX = data.get(dataDims[0], idx);
        var dataDimY = data.get(dataDims[1], idx);
        if (isNaN(data.get(dataDims[2], idx)) || dataDimX < xAxisExtent[0] || dataDimX > xAxisExtent[1] || dataDimY < yAxisExtent[0] || dataDimY > yAxisExtent[1]) {
          continue;
        }
        var point = coordSys.dataToPoint([dataDimX, dataDimY]);
        rect = new Rect$3({
          shape: {
            x: Math.floor(Math.round(point[0]) - width / 2),
            y: Math.floor(Math.round(point[1]) - height / 2),
            width: Math.ceil(width),
            height: Math.ceil(height)
          },
          style
        });
      } else {
        if (isNaN(data.get(dataDims[1], idx))) {
          continue;
        }
        rect = new Rect$3({
          z2: 1,
          shape: coordSys.dataToRect([data.get(dataDims[0], idx)]).contentShape,
          style
        });
      }
      if (data.hasItemOption) {
        var itemModel = data.getItemModel(idx);
        var emphasisModel_1 = itemModel.getModel("emphasis");
        emphasisStyle = emphasisModel_1.getModel("itemStyle").getItemStyle();
        blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
        selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
        borderRadius = itemModel.get(["itemStyle", "borderRadius"]);
        focus = emphasisModel_1.get("focus");
        blurScope = emphasisModel_1.get("blurScope");
        emphasisDisabled = emphasisModel_1.get("disabled");
        labelStatesModels = getLabelStatesModels(itemModel);
      }
      rect.shape.r = borderRadius;
      var rawValue = seriesModel.getRawValue(idx);
      var defaultText = "-";
      if (rawValue && rawValue[2] != null) {
        defaultText = rawValue[2] + "";
      }
      setLabelStyle(rect, labelStatesModels, {
        labelFetcher: seriesModel,
        labelDataIndex: idx,
        defaultOpacity: style.opacity,
        defaultText
      });
      rect.ensureState("emphasis").style = emphasisStyle;
      rect.ensureState("blur").style = blurStyle;
      rect.ensureState("select").style = selectStyle;
      toggleHoverEmphasis(rect, focus, blurScope, emphasisDisabled);
      rect.incremental = incremental;
      if (incremental) {
        rect.states.emphasis.hoverLayer = true;
      }
      group.add(rect);
      data.setItemGraphicEl(idx, rect);
      if (this._progressiveEls) {
        this._progressiveEls.push(rect);
      }
    }
  };
  HeatmapView2.prototype._renderOnGeo = function(geo, seriesModel, visualMapModel, api) {
    var inRangeVisuals = visualMapModel.targetVisuals.inRange;
    var outOfRangeVisuals = visualMapModel.targetVisuals.outOfRange;
    var data = seriesModel.getData();
    var hmLayer = this._hmLayer || this._hmLayer || new HeatmapLayer$1();
    hmLayer.blurSize = seriesModel.get("blurSize");
    hmLayer.pointSize = seriesModel.get("pointSize");
    hmLayer.minOpacity = seriesModel.get("minOpacity");
    hmLayer.maxOpacity = seriesModel.get("maxOpacity");
    var rect = geo.getViewRect().clone();
    var roamTransform = geo.getRoamTransform();
    rect.applyTransform(roamTransform);
    var x2 = Math.max(rect.x, 0);
    var y2 = Math.max(rect.y, 0);
    var x22 = Math.min(rect.width + rect.x, api.getWidth());
    var y22 = Math.min(rect.height + rect.y, api.getHeight());
    var width = x22 - x2;
    var height = y22 - y2;
    var dims = [data.mapDimension("lng"), data.mapDimension("lat"), data.mapDimension("value")];
    var points2 = data.mapArray(dims, function(lng, lat, value) {
      var pt = geo.dataToPoint([lng, lat]);
      pt[0] -= x2;
      pt[1] -= y2;
      pt.push(value);
      return pt;
    });
    var dataExtent = visualMapModel.getExtent();
    var isInRange = visualMapModel.type === "visualMap.continuous" ? getIsInContinuousRange(dataExtent, visualMapModel.option.range) : getIsInPiecewiseRange(dataExtent, visualMapModel.getPieceList(), visualMapModel.option.selected);
    hmLayer.update(points2, width, height, inRangeVisuals.color.getNormalizer(), {
      inRange: inRangeVisuals.color.getColorMapper(),
      outOfRange: outOfRangeVisuals.color.getColorMapper()
    }, isInRange);
    var img = new ZRImage$1({
      style: {
        width,
        height,
        x: x2,
        y: y2,
        image: hmLayer.canvas
      },
      silent: true
    });
    this.group.add(img);
  };
  HeatmapView2.type = "heatmap";
  return HeatmapView2;
}(ChartView$1);
var HeatmapView$1 = HeatmapView;
var HeatmapSeriesModel = function(_super) {
  __extends(HeatmapSeriesModel2, _super);
  function HeatmapSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = HeatmapSeriesModel2.type;
    return _this;
  }
  HeatmapSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this, {
      generateCoord: "value"
    });
  };
  HeatmapSeriesModel2.prototype.preventIncremental = function() {
    var coordSysCreator = CoordinateSystem.get(this.get("coordinateSystem"));
    if (coordSysCreator && coordSysCreator.dimensions) {
      return coordSysCreator.dimensions[0] === "lng" && coordSysCreator.dimensions[1] === "lat";
    }
  };
  HeatmapSeriesModel2.type = "series.heatmap";
  HeatmapSeriesModel2.dependencies = ["grid", "geo", "calendar"];
  HeatmapSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    geoIndex: 0,
    blurSize: 30,
    pointSize: 20,
    maxOpacity: 1,
    minOpacity: 0,
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  };
  return HeatmapSeriesModel2;
}(SeriesModel$1);
var HeatmapSeriesModel$1 = HeatmapSeriesModel;
function install$v(registers) {
  registers.registerChartView(HeatmapView$1);
  registers.registerSeriesModel(HeatmapSeriesModel$1);
}
var BAR_BORDER_WIDTH_QUERY = ["itemStyle", "borderWidth"];
var LAYOUT_ATTRS = [{
  xy: "x",
  wh: "width",
  index: 0,
  posDesc: ["left", "right"]
}, {
  xy: "y",
  wh: "height",
  index: 1,
  posDesc: ["top", "bottom"]
}];
var pathForLineWidth = new Circle$1();
var PictorialBarView = function(_super) {
  __extends(PictorialBarView2, _super);
  function PictorialBarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarView2.type;
    return _this;
  }
  PictorialBarView2.prototype.render = function(seriesModel, ecModel, api) {
    var group = this.group;
    var data = seriesModel.getData();
    var oldData = this._data;
    var cartesian = seriesModel.coordinateSystem;
    var baseAxis = cartesian.getBaseAxis();
    var isHorizontal = baseAxis.isHorizontal();
    var coordSysRect = cartesian.master.getRect();
    var opt = {
      ecSize: {
        width: api.getWidth(),
        height: api.getHeight()
      },
      seriesModel,
      coordSys: cartesian,
      coordSysExtent: [[coordSysRect.x, coordSysRect.x + coordSysRect.width], [coordSysRect.y, coordSysRect.y + coordSysRect.height]],
      isHorizontal,
      valueDim: LAYOUT_ATTRS[+isHorizontal],
      categoryDim: LAYOUT_ATTRS[1 - +isHorizontal]
    };
    data.diff(oldData).add(function(dataIndex) {
      if (!data.hasValue(dataIndex)) {
        return;
      }
      var itemModel = getItemModel(data, dataIndex);
      var symbolMeta = getSymbolMeta(data, dataIndex, itemModel, opt);
      var bar = createBar(data, opt, symbolMeta);
      data.setItemGraphicEl(dataIndex, bar);
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).update(function(newIndex, oldIndex) {
      var bar = oldData.getItemGraphicEl(oldIndex);
      if (!data.hasValue(newIndex)) {
        group.remove(bar);
        return;
      }
      var itemModel = getItemModel(data, newIndex);
      var symbolMeta = getSymbolMeta(data, newIndex, itemModel, opt);
      var pictorialShapeStr = getShapeStr(data, symbolMeta);
      if (bar && pictorialShapeStr !== bar.__pictorialShapeStr) {
        group.remove(bar);
        data.setItemGraphicEl(newIndex, null);
        bar = null;
      }
      if (bar) {
        updateBar(bar, opt, symbolMeta);
      } else {
        bar = createBar(data, opt, symbolMeta, true);
      }
      data.setItemGraphicEl(newIndex, bar);
      bar.__pictorialSymbolMeta = symbolMeta;
      group.add(bar);
      updateCommon(bar, opt, symbolMeta);
    }).remove(function(dataIndex) {
      var bar = oldData.getItemGraphicEl(dataIndex);
      bar && removeBar(oldData, dataIndex, bar.__pictorialSymbolMeta.animationModel, bar);
    }).execute();
    this._data = data;
    return this.group;
  };
  PictorialBarView2.prototype.remove = function(ecModel, api) {
    var group = this.group;
    var data = this._data;
    if (ecModel.get("animation")) {
      if (data) {
        data.eachItemGraphicEl(function(bar) {
          removeBar(data, getECData(bar).dataIndex, ecModel, bar);
        });
      }
    } else {
      group.removeAll();
    }
  };
  PictorialBarView2.type = "pictorialBar";
  return PictorialBarView2;
}(ChartView$1);
function getSymbolMeta(data, dataIndex, itemModel, opt) {
  var layout2 = data.getItemLayout(dataIndex);
  var symbolRepeat = itemModel.get("symbolRepeat");
  var symbolClip = itemModel.get("symbolClip");
  var symbolPosition = itemModel.get("symbolPosition") || "start";
  var symbolRotate = itemModel.get("symbolRotate");
  var rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  var symbolPatternSize = itemModel.get("symbolPatternSize") || 2;
  var isAnimationEnabled2 = itemModel.isAnimationEnabled();
  var symbolMeta = {
    dataIndex,
    layout: layout2,
    itemModel,
    symbolType: data.getItemVisual(dataIndex, "symbol") || "circle",
    style: data.getItemVisual(dataIndex, "style"),
    symbolClip,
    symbolRepeat,
    symbolRepeatDirection: itemModel.get("symbolRepeatDirection"),
    symbolPatternSize,
    rotation,
    animationModel: isAnimationEnabled2 ? itemModel : null,
    hoverScale: isAnimationEnabled2 && itemModel.get(["emphasis", "scale"]),
    z2: itemModel.getShallow("z", true) || 0
  };
  prepareBarLength(itemModel, symbolRepeat, layout2, opt, symbolMeta);
  prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, symbolMeta.boundingLength, symbolMeta.pxSign, symbolPatternSize, opt, symbolMeta);
  prepareLineWidth(itemModel, symbolMeta.symbolScale, rotation, opt, symbolMeta);
  var symbolSize = symbolMeta.symbolSize;
  var symbolOffset = normalizeSymbolOffset(itemModel.get("symbolOffset"), symbolSize);
  prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, symbolMeta.valueLineWidth, symbolMeta.boundingLength, symbolMeta.repeatCutLength, opt, symbolMeta);
  return symbolMeta;
}
function prepareBarLength(itemModel, symbolRepeat, layout2, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var symbolBoundingData = itemModel.get("symbolBoundingData");
  var valueAxis2 = opt.coordSys.getOtherAxis(opt.coordSys.getBaseAxis());
  var zeroPx = valueAxis2.toGlobalCoord(valueAxis2.dataToCoord(0));
  var pxSignIdx = 1 - +(layout2[valueDim.wh] <= 0);
  var boundingLength;
  if (isArray$1(symbolBoundingData)) {
    var symbolBoundingExtent = [convertToCoordOnAxis(valueAxis2, symbolBoundingData[0]) - zeroPx, convertToCoordOnAxis(valueAxis2, symbolBoundingData[1]) - zeroPx];
    symbolBoundingExtent[1] < symbolBoundingExtent[0] && symbolBoundingExtent.reverse();
    boundingLength = symbolBoundingExtent[pxSignIdx];
  } else if (symbolBoundingData != null) {
    boundingLength = convertToCoordOnAxis(valueAxis2, symbolBoundingData) - zeroPx;
  } else if (symbolRepeat) {
    boundingLength = opt.coordSysExtent[valueDim.index][pxSignIdx] - zeroPx;
  } else {
    boundingLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.boundingLength = boundingLength;
  if (symbolRepeat) {
    outputSymbolMeta.repeatCutLength = layout2[valueDim.wh];
  }
  outputSymbolMeta.pxSign = boundingLength > 0 ? 1 : -1;
}
function convertToCoordOnAxis(axis, value) {
  return axis.toGlobalCoord(axis.dataToCoord(axis.scale.parse(value)));
}
function prepareSymbolSize(data, dataIndex, layout2, symbolRepeat, symbolClip, boundingLength, pxSign, symbolPatternSize, opt, outputSymbolMeta) {
  var valueDim = opt.valueDim;
  var categoryDim = opt.categoryDim;
  var categorySize = Math.abs(layout2[categoryDim.wh]);
  var symbolSize = data.getItemVisual(dataIndex, "symbolSize");
  var parsedSymbolSize;
  if (isArray$1(symbolSize)) {
    parsedSymbolSize = symbolSize.slice();
  } else {
    if (symbolSize == null) {
      parsedSymbolSize = ["100%", "100%"];
    } else {
      parsedSymbolSize = [symbolSize, symbolSize];
    }
  }
  parsedSymbolSize[categoryDim.index] = parsePercent(parsedSymbolSize[categoryDim.index], categorySize);
  parsedSymbolSize[valueDim.index] = parsePercent(parsedSymbolSize[valueDim.index], symbolRepeat ? categorySize : Math.abs(boundingLength));
  outputSymbolMeta.symbolSize = parsedSymbolSize;
  var symbolScale = outputSymbolMeta.symbolScale = [parsedSymbolSize[0] / symbolPatternSize, parsedSymbolSize[1] / symbolPatternSize];
  symbolScale[valueDim.index] *= (opt.isHorizontal ? -1 : 1) * pxSign;
}
function prepareLineWidth(itemModel, symbolScale, rotation, opt, outputSymbolMeta) {
  var valueLineWidth = itemModel.get(BAR_BORDER_WIDTH_QUERY) || 0;
  if (valueLineWidth) {
    pathForLineWidth.attr({
      scaleX: symbolScale[0],
      scaleY: symbolScale[1],
      rotation
    });
    pathForLineWidth.updateTransform();
    valueLineWidth /= pathForLineWidth.getLineScale();
    valueLineWidth *= symbolScale[opt.valueDim.index];
  }
  outputSymbolMeta.valueLineWidth = valueLineWidth || 0;
}
function prepareLayoutInfo(itemModel, symbolSize, layout2, symbolRepeat, symbolClip, symbolOffset, symbolPosition, valueLineWidth, boundingLength, repeatCutLength, opt, outputSymbolMeta) {
  var categoryDim = opt.categoryDim;
  var valueDim = opt.valueDim;
  var pxSign = outputSymbolMeta.pxSign;
  var unitLength = Math.max(symbolSize[valueDim.index] + valueLineWidth, 0);
  var pathLen = unitLength;
  if (symbolRepeat) {
    var absBoundingLength = Math.abs(boundingLength);
    var symbolMargin = retrieve(itemModel.get("symbolMargin"), "15%") + "";
    var hasEndGap = false;
    if (symbolMargin.lastIndexOf("!") === symbolMargin.length - 1) {
      hasEndGap = true;
      symbolMargin = symbolMargin.slice(0, symbolMargin.length - 1);
    }
    var symbolMarginNumeric = parsePercent(symbolMargin, symbolSize[valueDim.index]);
    var uLenWithMargin = Math.max(unitLength + symbolMarginNumeric * 2, 0);
    var endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    var repeatSpecified = isNumeric(symbolRepeat);
    var repeatTimes = repeatSpecified ? symbolRepeat : toIntTimes((absBoundingLength + endFix) / uLenWithMargin);
    var mDiff = absBoundingLength - repeatTimes * unitLength;
    symbolMarginNumeric = mDiff / 2 / (hasEndGap ? repeatTimes : Math.max(repeatTimes - 1, 1));
    uLenWithMargin = unitLength + symbolMarginNumeric * 2;
    endFix = hasEndGap ? 0 : symbolMarginNumeric * 2;
    if (!repeatSpecified && symbolRepeat !== "fixed") {
      repeatTimes = repeatCutLength ? toIntTimes((Math.abs(repeatCutLength) + endFix) / uLenWithMargin) : 0;
    }
    pathLen = repeatTimes * uLenWithMargin - endFix;
    outputSymbolMeta.repeatTimes = repeatTimes;
    outputSymbolMeta.symbolMargin = symbolMarginNumeric;
  }
  var sizeFix = pxSign * (pathLen / 2);
  var pathPosition = outputSymbolMeta.pathPosition = [];
  pathPosition[categoryDim.index] = layout2[categoryDim.wh] / 2;
  pathPosition[valueDim.index] = symbolPosition === "start" ? sizeFix : symbolPosition === "end" ? boundingLength - sizeFix : boundingLength / 2;
  if (symbolOffset) {
    pathPosition[0] += symbolOffset[0];
    pathPosition[1] += symbolOffset[1];
  }
  var bundlePosition = outputSymbolMeta.bundlePosition = [];
  bundlePosition[categoryDim.index] = layout2[categoryDim.xy];
  bundlePosition[valueDim.index] = layout2[valueDim.xy];
  var barRectShape = outputSymbolMeta.barRectShape = extend({}, layout2);
  barRectShape[valueDim.wh] = pxSign * Math.max(Math.abs(layout2[valueDim.wh]), Math.abs(pathPosition[valueDim.index] + sizeFix));
  barRectShape[categoryDim.wh] = layout2[categoryDim.wh];
  var clipShape = outputSymbolMeta.clipShape = {};
  clipShape[categoryDim.xy] = -layout2[categoryDim.xy];
  clipShape[categoryDim.wh] = opt.ecSize[categoryDim.wh];
  clipShape[valueDim.xy] = 0;
  clipShape[valueDim.wh] = layout2[valueDim.wh];
}
function createPath(symbolMeta) {
  var symbolPatternSize = symbolMeta.symbolPatternSize;
  var path = createSymbol$1(symbolMeta.symbolType, -symbolPatternSize / 2, -symbolPatternSize / 2, symbolPatternSize, symbolPatternSize);
  path.attr({
    culling: true
  });
  path.type !== "image" && path.setStyle({
    strokeNoScale: true
  });
  return path;
}
function createOrUpdateRepeatSymbols(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var symbolSize = symbolMeta.symbolSize;
  var valueLineWidth = symbolMeta.valueLineWidth;
  var pathPosition = symbolMeta.pathPosition;
  var valueDim = opt.valueDim;
  var repeatTimes = symbolMeta.repeatTimes || 0;
  var index2 = 0;
  var unit = symbolSize[opt.valueDim.index] + valueLineWidth + symbolMeta.symbolMargin * 2;
  eachPath(bar, function(path2) {
    path2.__pictorialAnimationIndex = index2;
    path2.__pictorialRepeatTimes = repeatTimes;
    if (index2 < repeatTimes) {
      updateAttr(path2, null, makeTarget(index2), symbolMeta, isUpdate);
    } else {
      updateAttr(path2, null, {
        scaleX: 0,
        scaleY: 0
      }, symbolMeta, isUpdate, function() {
        bundle.remove(path2);
      });
    }
    index2++;
  });
  for (; index2 < repeatTimes; index2++) {
    var path = createPath(symbolMeta);
    path.__pictorialAnimationIndex = index2;
    path.__pictorialRepeatTimes = repeatTimes;
    bundle.add(path);
    var target = makeTarget(index2);
    updateAttr(path, {
      x: target.x,
      y: target.y,
      scaleX: 0,
      scaleY: 0
    }, {
      scaleX: target.scaleX,
      scaleY: target.scaleY,
      rotation: target.rotation
    }, symbolMeta, isUpdate);
  }
  function makeTarget(index3) {
    var position2 = pathPosition.slice();
    var pxSign = symbolMeta.pxSign;
    var i = index3;
    if (symbolMeta.symbolRepeatDirection === "start" ? pxSign > 0 : pxSign < 0) {
      i = repeatTimes - 1 - index3;
    }
    position2[valueDim.index] = unit * (i - repeatTimes / 2 + 0.5) + pathPosition[valueDim.index];
    return {
      x: position2[0],
      y: position2[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    };
  }
}
function createOrUpdateSingleSymbol(bar, opt, symbolMeta, isUpdate) {
  var bundle = bar.__pictorialBundle;
  var mainPath = bar.__pictorialMainPath;
  if (!mainPath) {
    mainPath = bar.__pictorialMainPath = createPath(symbolMeta);
    bundle.add(mainPath);
    updateAttr(mainPath, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: 0,
      scaleY: 0,
      rotation: symbolMeta.rotation
    }, {
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1]
    }, symbolMeta, isUpdate);
  } else {
    updateAttr(mainPath, null, {
      x: symbolMeta.pathPosition[0],
      y: symbolMeta.pathPosition[1],
      scaleX: symbolMeta.symbolScale[0],
      scaleY: symbolMeta.symbolScale[1],
      rotation: symbolMeta.rotation
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateBarRect(bar, symbolMeta, isUpdate) {
  var rectShape = extend({}, symbolMeta.barRectShape);
  var barRect = bar.__pictorialBarRect;
  if (!barRect) {
    barRect = bar.__pictorialBarRect = new Rect$3({
      z2: 2,
      shape: rectShape,
      silent: true,
      style: {
        stroke: "transparent",
        fill: "transparent",
        lineWidth: 0
      }
    });
    barRect.disableMorphing = true;
    bar.add(barRect);
  } else {
    updateAttr(barRect, null, {
      shape: rectShape
    }, symbolMeta, isUpdate);
  }
}
function createOrUpdateClip(bar, opt, symbolMeta, isUpdate) {
  if (symbolMeta.symbolClip) {
    var clipPath = bar.__pictorialClipPath;
    var clipShape = extend({}, symbolMeta.clipShape);
    var valueDim = opt.valueDim;
    var animationModel = symbolMeta.animationModel;
    var dataIndex = symbolMeta.dataIndex;
    if (clipPath) {
      updateProps$1(clipPath, {
        shape: clipShape
      }, animationModel, dataIndex);
    } else {
      clipShape[valueDim.wh] = 0;
      clipPath = new Rect$3({
        shape: clipShape
      });
      bar.__pictorialBundle.setClipPath(clipPath);
      bar.__pictorialClipPath = clipPath;
      var target = {};
      target[valueDim.wh] = symbolMeta.clipShape[valueDim.wh];
      graphic[isUpdate ? "updateProps" : "initProps"](clipPath, {
        shape: target
      }, animationModel, dataIndex);
    }
  }
}
function getItemModel(data, dataIndex) {
  var itemModel = data.getItemModel(dataIndex);
  itemModel.getAnimationDelayParams = getAnimationDelayParams;
  itemModel.isAnimationEnabled = isAnimationEnabled;
  return itemModel;
}
function getAnimationDelayParams(path) {
  return {
    index: path.__pictorialAnimationIndex,
    count: path.__pictorialRepeatTimes
  };
}
function isAnimationEnabled() {
  return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
}
function createBar(data, opt, symbolMeta, isUpdate) {
  var bar = new Group$4();
  var bundle = new Group$4();
  bar.add(bundle);
  bar.__pictorialBundle = bundle;
  bundle.x = symbolMeta.bundlePosition[0];
  bundle.y = symbolMeta.bundlePosition[1];
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta);
  }
  createOrUpdateBarRect(bar, symbolMeta, isUpdate);
  createOrUpdateClip(bar, opt, symbolMeta, isUpdate);
  bar.__pictorialShapeStr = getShapeStr(data, symbolMeta);
  bar.__pictorialSymbolMeta = symbolMeta;
  return bar;
}
function updateBar(bar, opt, symbolMeta) {
  var animationModel = symbolMeta.animationModel;
  var dataIndex = symbolMeta.dataIndex;
  var bundle = bar.__pictorialBundle;
  updateProps$1(bundle, {
    x: symbolMeta.bundlePosition[0],
    y: symbolMeta.bundlePosition[1]
  }, animationModel, dataIndex);
  if (symbolMeta.symbolRepeat) {
    createOrUpdateRepeatSymbols(bar, opt, symbolMeta, true);
  } else {
    createOrUpdateSingleSymbol(bar, opt, symbolMeta, true);
  }
  createOrUpdateBarRect(bar, symbolMeta, true);
  createOrUpdateClip(bar, opt, symbolMeta, true);
}
function removeBar(data, dataIndex, animationModel, bar) {
  var labelRect = bar.__pictorialBarRect;
  labelRect && labelRect.removeTextContent();
  var pathes = [];
  eachPath(bar, function(path) {
    pathes.push(path);
  });
  bar.__pictorialMainPath && pathes.push(bar.__pictorialMainPath);
  bar.__pictorialClipPath && (animationModel = null);
  each$f(pathes, function(path) {
    removeElement(path, {
      scaleX: 0,
      scaleY: 0
    }, animationModel, dataIndex, function() {
      bar.parent && bar.parent.remove(bar);
    });
  });
  data.setItemGraphicEl(dataIndex, null);
}
function getShapeStr(data, symbolMeta) {
  return [data.getItemVisual(symbolMeta.dataIndex, "symbol") || "none", !!symbolMeta.symbolRepeat, !!symbolMeta.symbolClip].join(":");
}
function eachPath(bar, cb, context) {
  each$f(bar.__pictorialBundle.children(), function(el) {
    el !== bar.__pictorialBarRect && cb.call(context, el);
  });
}
function updateAttr(el, immediateAttrs, animationAttrs, symbolMeta, isUpdate, cb) {
  immediateAttrs && el.attr(immediateAttrs);
  if (symbolMeta.symbolClip && !isUpdate) {
    animationAttrs && el.attr(animationAttrs);
  } else {
    animationAttrs && graphic[isUpdate ? "updateProps" : "initProps"](el, animationAttrs, symbolMeta.animationModel, symbolMeta.dataIndex, cb);
  }
}
function updateCommon(bar, opt, symbolMeta) {
  var dataIndex = symbolMeta.dataIndex;
  var itemModel = symbolMeta.itemModel;
  var emphasisModel = itemModel.getModel("emphasis");
  var emphasisStyle = emphasisModel.getModel("itemStyle").getItemStyle();
  var blurStyle = itemModel.getModel(["blur", "itemStyle"]).getItemStyle();
  var selectStyle = itemModel.getModel(["select", "itemStyle"]).getItemStyle();
  var cursorStyle = itemModel.getShallow("cursor");
  var focus = emphasisModel.get("focus");
  var blurScope = emphasisModel.get("blurScope");
  var hoverScale = emphasisModel.get("scale");
  eachPath(bar, function(path) {
    if (path instanceof ZRImage$1) {
      var pathStyle = path.style;
      path.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, symbolMeta.style));
    } else {
      path.useStyle(symbolMeta.style);
    }
    var emphasisState = path.ensureState("emphasis");
    emphasisState.style = emphasisStyle;
    if (hoverScale) {
      emphasisState.scaleX = path.scaleX * 1.1;
      emphasisState.scaleY = path.scaleY * 1.1;
    }
    path.ensureState("blur").style = blurStyle;
    path.ensureState("select").style = selectStyle;
    cursorStyle && (path.cursor = cursorStyle);
    path.z2 = symbolMeta.z2;
  });
  var barPositionOutside = opt.valueDim.posDesc[+(symbolMeta.boundingLength > 0)];
  var barRect = bar.__pictorialBarRect;
  setLabelStyle(barRect, getLabelStatesModels(itemModel), {
    labelFetcher: opt.seriesModel,
    labelDataIndex: dataIndex,
    defaultText: getDefaultLabel(opt.seriesModel.getData(), dataIndex),
    inheritColor: symbolMeta.style.fill,
    defaultOpacity: symbolMeta.style.opacity,
    defaultOutsidePosition: barPositionOutside
  });
  toggleHoverEmphasis(bar, focus, blurScope, emphasisModel.get("disabled"));
}
function toIntTimes(times) {
  var roundedTimes = Math.round(times);
  return Math.abs(times - roundedTimes) < 1e-4 ? roundedTimes : Math.ceil(times);
}
var PictorialBarView$1 = PictorialBarView;
var PictorialBarSeriesModel = function(_super) {
  __extends(PictorialBarSeriesModel2, _super);
  function PictorialBarSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PictorialBarSeriesModel2.type;
    _this.hasSymbolVisual = true;
    _this.defaultSymbol = "roundRect";
    return _this;
  }
  PictorialBarSeriesModel2.prototype.getInitialData = function(option) {
    option.stack = null;
    return _super.prototype.getInitialData.apply(this, arguments);
  };
  PictorialBarSeriesModel2.type = "series.pictorialBar";
  PictorialBarSeriesModel2.dependencies = ["grid"];
  PictorialBarSeriesModel2.defaultOption = inheritDefaultOption(BaseBarSeriesModel$1.defaultOption, {
    symbol: "circle",
    symbolSize: null,
    symbolRotate: null,
    symbolPosition: null,
    symbolOffset: null,
    symbolMargin: null,
    symbolRepeat: false,
    symbolRepeatDirection: "end",
    symbolClip: false,
    symbolBoundingData: null,
    symbolPatternSize: 400,
    barGap: "-100%",
    progressive: 0,
    emphasis: {
      scale: false
    },
    select: {
      itemStyle: {
        borderColor: "#212121"
      }
    }
  });
  return PictorialBarSeriesModel2;
}(BaseBarSeriesModel$1);
var PictorialBarSeriesModel$1 = PictorialBarSeriesModel;
function install$u(registers) {
  registers.registerChartView(PictorialBarView$1);
  registers.registerSeriesModel(PictorialBarSeriesModel$1);
  registers.registerLayout(registers.PRIORITY.VISUAL.LAYOUT, curry$1(layout$3, "pictorialBar"));
  registers.registerLayout(registers.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, createProgressiveLayout("pictorialBar"));
}
var ThemeRiverView = function(_super) {
  __extends(ThemeRiverView2, _super);
  function ThemeRiverView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverView2.type;
    _this._layers = [];
    return _this;
  }
  ThemeRiverView2.prototype.render = function(seriesModel, ecModel, api) {
    var data = seriesModel.getData();
    var self2 = this;
    var group = this.group;
    var layersSeries = seriesModel.getLayerSeries();
    var layoutInfo = data.getLayout("layoutInfo");
    var rect = layoutInfo.rect;
    var boundaryGap = layoutInfo.boundaryGap;
    group.x = 0;
    group.y = rect.y + boundaryGap[0];
    function keyGetter(item) {
      return item.name;
    }
    var dataDiffer = new DataDiffer$1(this._layersSeries || [], layersSeries, keyGetter, keyGetter);
    var newLayersGroups = [];
    dataDiffer.add(bind$1(process2, this, "add")).update(bind$1(process2, this, "update")).remove(bind$1(process2, this, "remove")).execute();
    function process2(status, idx, oldIdx) {
      var oldLayersGroups = self2._layers;
      if (status === "remove") {
        group.remove(oldLayersGroups[idx]);
        return;
      }
      var points0 = [];
      var points1 = [];
      var style;
      var indices = layersSeries[idx].indices;
      var j = 0;
      for (; j < indices.length; j++) {
        var layout2 = data.getItemLayout(indices[j]);
        var x2 = layout2.x;
        var y0 = layout2.y0;
        var y2 = layout2.y;
        points0.push(x2, y0);
        points1.push(x2, y0 + y2);
        style = data.getItemVisual(indices[j], "style");
      }
      var polygon;
      var textLayout = data.getItemLayout(indices[0]);
      var labelModel = seriesModel.getModel("label");
      var margin = labelModel.get("margin");
      var emphasisModel = seriesModel.getModel("emphasis");
      if (status === "add") {
        var layerGroup = newLayersGroups[idx] = new Group$4();
        polygon = new ECPolygon({
          shape: {
            points: points0,
            stackedOnPoints: points1,
            smooth: 0.4,
            stackedOnSmooth: 0.4,
            smoothConstraint: false
          },
          z2: 0
        });
        layerGroup.add(polygon);
        group.add(layerGroup);
        if (seriesModel.isAnimationEnabled()) {
          polygon.setClipPath(createGridClipShape(polygon.getBoundingRect(), seriesModel, function() {
            polygon.removeClipPath();
          }));
        }
      } else {
        var layerGroup = oldLayersGroups[oldIdx];
        polygon = layerGroup.childAt(0);
        group.add(layerGroup);
        newLayersGroups[idx] = layerGroup;
        updateProps$1(polygon, {
          shape: {
            points: points0,
            stackedOnPoints: points1
          }
        }, seriesModel);
        saveOldStyle(polygon);
      }
      setLabelStyle(polygon, getLabelStatesModels(seriesModel), {
        labelDataIndex: indices[j - 1],
        defaultText: data.getName(indices[j - 1]),
        inheritColor: style.fill
      }, {
        normal: {
          verticalAlign: "middle"
        }
      });
      polygon.setTextConfig({
        position: null,
        local: true
      });
      var labelEl = polygon.getTextContent();
      if (labelEl) {
        labelEl.x = textLayout.x - margin;
        labelEl.y = textLayout.y0 + textLayout.y / 2;
      }
      polygon.useStyle(style);
      data.setItemGraphicEl(idx, polygon);
      setStatesStylesFromModel(polygon, seriesModel);
      toggleHoverEmphasis(polygon, emphasisModel.get("focus"), emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
    }
    this._layersSeries = layersSeries;
    this._layers = newLayersGroups;
  };
  ThemeRiverView2.type = "themeRiver";
  return ThemeRiverView2;
}(ChartView$1);
function createGridClipShape(rect, seriesModel, cb) {
  var rectEl = new Rect$3({
    shape: {
      x: rect.x - 10,
      y: rect.y - 10,
      width: 0,
      height: rect.height + 20
    }
  });
  initProps(rectEl, {
    shape: {
      x: rect.x - 50,
      width: rect.width + 100,
      height: rect.height + 20
    }
  }, seriesModel, cb);
  return rectEl;
}
var ThemeRiverView$1 = ThemeRiverView;
var DATA_NAME_INDEX = 2;
var ThemeRiverSeriesModel = function(_super) {
  __extends(ThemeRiverSeriesModel2, _super);
  function ThemeRiverSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ThemeRiverSeriesModel2.type;
    return _this;
  }
  ThemeRiverSeriesModel2.prototype.init = function(option) {
    _super.prototype.init.apply(this, arguments);
    this.legendVisualProvider = new LegendVisualProvider$1(bind$1(this.getData, this), bind$1(this.getRawData, this));
  };
  ThemeRiverSeriesModel2.prototype.fixData = function(data) {
    var rawDataLength = data.length;
    var timeValueKeys = {};
    var groupResult = groupData(data, function(item) {
      if (!timeValueKeys.hasOwnProperty(item[0] + "")) {
        timeValueKeys[item[0] + ""] = -1;
      }
      return item[2];
    });
    var layerData = [];
    groupResult.buckets.each(function(items, key) {
      layerData.push({
        name: key,
        dataList: items
      });
    });
    var layerNum = layerData.length;
    for (var k2 = 0; k2 < layerNum; ++k2) {
      var name_1 = layerData[k2].name;
      for (var j = 0; j < layerData[k2].dataList.length; ++j) {
        var timeValue = layerData[k2].dataList[j][0] + "";
        timeValueKeys[timeValue] = k2;
      }
      for (var timeValue in timeValueKeys) {
        if (timeValueKeys.hasOwnProperty(timeValue) && timeValueKeys[timeValue] !== k2) {
          timeValueKeys[timeValue] = k2;
          data[rawDataLength] = [timeValue, 0, name_1];
          rawDataLength++;
        }
      }
    }
    return data;
  };
  ThemeRiverSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var singleAxisModel = this.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
    var axisType = singleAxisModel.get("type");
    var filterData = filter(option.data, function(dataItem) {
      return dataItem[2] !== void 0;
    });
    var data = this.fixData(filterData || []);
    var nameList = [];
    var nameMap = this.nameMap = createHashMap();
    var count2 = 0;
    for (var i = 0; i < data.length; ++i) {
      nameList.push(data[i][DATA_NAME_INDEX]);
      if (!nameMap.get(data[i][DATA_NAME_INDEX])) {
        nameMap.set(data[i][DATA_NAME_INDEX], count2);
        count2++;
      }
    }
    var dimensions = prepareSeriesDataSchema(data, {
      coordDimensions: ["single"],
      dimensionsDefine: [{
        name: "time",
        type: getDimensionTypeByAxis(axisType)
      }, {
        name: "value",
        type: "float"
      }, {
        name: "name",
        type: "ordinal"
      }],
      encodeDefine: {
        single: 0,
        value: 1,
        itemName: 2
      }
    }).dimensions;
    var list = new SeriesData$1(dimensions, this);
    list.initData(data);
    return list;
  };
  ThemeRiverSeriesModel2.prototype.getLayerSeries = function() {
    var data = this.getData();
    var lenCount = data.count();
    var indexArr = [];
    for (var i = 0; i < lenCount; ++i) {
      indexArr[i] = i;
    }
    var timeDim = data.mapDimension("single");
    var groupResult = groupData(indexArr, function(index2) {
      return data.get("name", index2);
    });
    var layerSeries = [];
    groupResult.buckets.each(function(items, key) {
      items.sort(function(index1, index2) {
        return data.get(timeDim, index1) - data.get(timeDim, index2);
      });
      layerSeries.push({
        name: key,
        indices: items
      });
    });
    return layerSeries;
  };
  ThemeRiverSeriesModel2.prototype.getAxisTooltipData = function(dim, value, baseAxis) {
    if (!isArray$1(dim)) {
      dim = dim ? [dim] : [];
    }
    var data = this.getData();
    var layerSeries = this.getLayerSeries();
    var indices = [];
    var layerNum = layerSeries.length;
    var nestestValue;
    for (var i = 0; i < layerNum; ++i) {
      var minDist = Number.MAX_VALUE;
      var nearestIdx = -1;
      var pointNum = layerSeries[i].indices.length;
      for (var j = 0; j < pointNum; ++j) {
        var theValue = data.get(dim[0], layerSeries[i].indices[j]);
        var dist2 = Math.abs(theValue - value);
        if (dist2 <= minDist) {
          nestestValue = theValue;
          minDist = dist2;
          nearestIdx = layerSeries[i].indices[j];
        }
      }
      indices.push(nearestIdx);
    }
    return {
      dataIndices: indices,
      nestestValue
    };
  };
  ThemeRiverSeriesModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var name = data.getName(dataIndex);
    var value = data.get(data.mapDimension("value"), dataIndex);
    return createTooltipMarkup("nameValue", {
      name,
      value
    });
  };
  ThemeRiverSeriesModel2.type = "series.themeRiver";
  ThemeRiverSeriesModel2.dependencies = ["singleAxis"];
  ThemeRiverSeriesModel2.defaultOption = {
    z: 2,
    colorBy: "data",
    coordinateSystem: "singleAxis",
    boundaryGap: ["10%", "10%"],
    singleAxisIndex: 0,
    animationEasing: "linear",
    label: {
      margin: 4,
      show: true,
      position: "left",
      fontSize: 11
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return ThemeRiverSeriesModel2;
}(SeriesModel$1);
var ThemeRiverSeriesModel$1 = ThemeRiverSeriesModel;
function themeRiverLayout(ecModel, api) {
  ecModel.eachSeriesByType("themeRiver", function(seriesModel) {
    var data = seriesModel.getData();
    var single = seriesModel.coordinateSystem;
    var layoutInfo = {};
    var rect = single.getRect();
    layoutInfo.rect = rect;
    var boundaryGap = seriesModel.get("boundaryGap");
    var axis = single.getAxis();
    layoutInfo.boundaryGap = boundaryGap;
    if (axis.orient === "horizontal") {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.height);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.height);
      var height = rect.height - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, height);
    } else {
      boundaryGap[0] = parsePercent(boundaryGap[0], rect.width);
      boundaryGap[1] = parsePercent(boundaryGap[1], rect.width);
      var width = rect.width - boundaryGap[0] - boundaryGap[1];
      doThemeRiverLayout(data, seriesModel, width);
    }
    data.setLayout("layoutInfo", layoutInfo);
  });
}
function doThemeRiverLayout(data, seriesModel, height) {
  if (!data.count()) {
    return;
  }
  var coordSys = seriesModel.coordinateSystem;
  var layerSeries = seriesModel.getLayerSeries();
  var timeDim = data.mapDimension("single");
  var valueDim = data.mapDimension("value");
  var layerPoints = map$1(layerSeries, function(singleLayer) {
    return map$1(singleLayer.indices, function(idx) {
      var pt = coordSys.dataToPoint(data.get(timeDim, idx));
      pt[1] = data.get(valueDim, idx);
      return pt;
    });
  });
  var base2 = computeBaseline(layerPoints);
  var baseLine = base2.y0;
  var ky = height / base2.max;
  var n2 = layerSeries.length;
  var m2 = layerSeries[0].indices.length;
  var baseY0;
  for (var j = 0; j < m2; ++j) {
    baseY0 = baseLine[j] * ky;
    data.setItemLayout(layerSeries[0].indices[j], {
      layerIndex: 0,
      x: layerPoints[0][j][0],
      y0: baseY0,
      y: layerPoints[0][j][1] * ky
    });
    for (var i = 1; i < n2; ++i) {
      baseY0 += layerPoints[i - 1][j][1] * ky;
      data.setItemLayout(layerSeries[i].indices[j], {
        layerIndex: i,
        x: layerPoints[i][j][0],
        y0: baseY0,
        y: layerPoints[i][j][1] * ky
      });
    }
  }
}
function computeBaseline(data) {
  var layerNum = data.length;
  var pointNum = data[0].length;
  var sums = [];
  var y0 = [];
  var max3 = 0;
  for (var i = 0; i < pointNum; ++i) {
    var temp = 0;
    for (var j = 0; j < layerNum; ++j) {
      temp += data[j][i][1];
    }
    if (temp > max3) {
      max3 = temp;
    }
    sums.push(temp);
  }
  for (var k2 = 0; k2 < pointNum; ++k2) {
    y0[k2] = (max3 - sums[k2]) / 2;
  }
  max3 = 0;
  for (var l2 = 0; l2 < pointNum; ++l2) {
    var sum2 = sums[l2] + y0[l2];
    if (sum2 > max3) {
      max3 = sum2;
    }
  }
  return {
    y0,
    max: max3
  };
}
function install$t(registers) {
  registers.registerChartView(ThemeRiverView$1);
  registers.registerSeriesModel(ThemeRiverSeriesModel$1);
  registers.registerLayout(themeRiverLayout);
  registers.registerProcessor(dataFilter$1("themeRiver"));
}
var DEFAULT_SECTOR_Z = 2;
var DEFAULT_TEXT_Z = 4;
var SunburstPiece = function(_super) {
  __extends(SunburstPiece2, _super);
  function SunburstPiece2(node, seriesModel, ecModel, api) {
    var _this = _super.call(this) || this;
    _this.z2 = DEFAULT_SECTOR_Z;
    _this.textConfig = {
      inside: true
    };
    getECData(_this).seriesIndex = seriesModel.seriesIndex;
    var text = new ZRText$1({
      z2: DEFAULT_TEXT_Z,
      silent: node.getModel().get(["label", "silent"])
    });
    _this.setTextContent(text);
    _this.updateData(true, node, seriesModel, ecModel, api);
    return _this;
  }
  SunburstPiece2.prototype.updateData = function(firstCreate, node, seriesModel, ecModel, api) {
    this.node = node;
    node.piece = this;
    seriesModel = seriesModel || this._seriesModel;
    ecModel = ecModel || this._ecModel;
    var sector = this;
    getECData(sector).dataIndex = node.dataIndex;
    var itemModel = node.getModel();
    var emphasisModel = itemModel.getModel("emphasis");
    var layout2 = node.getLayout();
    var sectorShape = extend({}, layout2);
    sectorShape.label = null;
    var normalStyle = node.getVisual("style");
    normalStyle.lineJoin = "bevel";
    var decal = node.getVisual("decal");
    if (decal) {
      normalStyle.decal = createOrUpdatePatternFromDecal(decal, api);
    }
    var cornerRadius = getSectorCornerRadius(itemModel.getModel("itemStyle"), sectorShape, true);
    extend(sectorShape, cornerRadius);
    each$f(SPECIAL_STATES, function(stateName) {
      var state = sector.ensureState(stateName);
      var itemStyleModel = itemModel.getModel([stateName, "itemStyle"]);
      state.style = itemStyleModel.getItemStyle();
      var cornerRadius2 = getSectorCornerRadius(itemStyleModel, sectorShape);
      if (cornerRadius2) {
        state.shape = cornerRadius2;
      }
    });
    if (firstCreate) {
      sector.setShape(sectorShape);
      sector.shape.r = layout2.r0;
      updateProps$1(sector, {
        shape: {
          r: layout2.r
        }
      }, seriesModel, node.dataIndex);
    } else {
      updateProps$1(sector, {
        shape: sectorShape
      }, seriesModel);
      saveOldStyle(sector);
    }
    sector.useStyle(normalStyle);
    this._updateLabel(seriesModel);
    var cursorStyle = itemModel.getShallow("cursor");
    cursorStyle && sector.attr("cursor", cursorStyle);
    this._seriesModel = seriesModel || this._seriesModel;
    this._ecModel = ecModel || this._ecModel;
    var focus = emphasisModel.get("focus");
    var focusOrIndices = focus === "ancestor" ? node.getAncestorsIndices() : focus === "descendant" ? node.getDescendantIndices() : focus;
    toggleHoverEmphasis(this, focusOrIndices, emphasisModel.get("blurScope"), emphasisModel.get("disabled"));
  };
  SunburstPiece2.prototype._updateLabel = function(seriesModel) {
    var _this = this;
    var itemModel = this.node.getModel();
    var normalLabelModel = itemModel.getModel("label");
    var layout2 = this.node.getLayout();
    var angle = layout2.endAngle - layout2.startAngle;
    var midAngle = (layout2.startAngle + layout2.endAngle) / 2;
    var dx = Math.cos(midAngle);
    var dy = Math.sin(midAngle);
    var sector = this;
    var label = sector.getTextContent();
    var dataIndex = this.node.dataIndex;
    var labelMinAngle = normalLabelModel.get("minAngle") / 180 * Math.PI;
    var isNormalShown = normalLabelModel.get("show") && !(labelMinAngle != null && Math.abs(angle) < labelMinAngle);
    label.ignore = !isNormalShown;
    each$f(DISPLAY_STATES, function(stateName) {
      var labelStateModel = stateName === "normal" ? itemModel.getModel("label") : itemModel.getModel([stateName, "label"]);
      var isNormal = stateName === "normal";
      var state = isNormal ? label : label.ensureState(stateName);
      var text = seriesModel.getFormattedLabel(dataIndex, stateName);
      if (isNormal) {
        text = text || _this.node.name;
      }
      state.style = createTextStyle(labelStateModel, {}, null, stateName !== "normal", true);
      if (text) {
        state.style.text = text;
      }
      var isShown = labelStateModel.get("show");
      if (isShown != null && !isNormal) {
        state.ignore = !isShown;
      }
      var labelPosition = getLabelAttr(labelStateModel, "position");
      var sectorState = isNormal ? sector : sector.states[stateName];
      var labelColor = sectorState.style.fill;
      sectorState.textConfig = {
        outsideFill: labelStateModel.get("color") === "inherit" ? labelColor : null,
        inside: labelPosition !== "outside"
      };
      var r2;
      var labelPadding = getLabelAttr(labelStateModel, "distance") || 0;
      var textAlign = getLabelAttr(labelStateModel, "align");
      if (labelPosition === "outside") {
        r2 = layout2.r + labelPadding;
        textAlign = midAngle > Math.PI / 2 ? "right" : "left";
      } else {
        if (!textAlign || textAlign === "center") {
          if (angle === 2 * Math.PI && layout2.r0 === 0) {
            r2 = 0;
          } else {
            r2 = (layout2.r + layout2.r0) / 2;
          }
          textAlign = "center";
        } else if (textAlign === "left") {
          r2 = layout2.r0 + labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "right";
          }
        } else if (textAlign === "right") {
          r2 = layout2.r - labelPadding;
          if (midAngle > Math.PI / 2) {
            textAlign = "left";
          }
        }
      }
      state.style.align = textAlign;
      state.style.verticalAlign = getLabelAttr(labelStateModel, "verticalAlign") || "middle";
      state.x = r2 * dx + layout2.cx;
      state.y = r2 * dy + layout2.cy;
      var rotateType = getLabelAttr(labelStateModel, "rotate");
      var rotate2 = 0;
      if (rotateType === "radial") {
        rotate2 = -midAngle;
        if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (rotateType === "tangential") {
        rotate2 = Math.PI / 2 - midAngle;
        if (rotate2 > Math.PI / 2) {
          rotate2 -= Math.PI;
        } else if (rotate2 < -Math.PI / 2) {
          rotate2 += Math.PI;
        }
      } else if (isNumber(rotateType)) {
        rotate2 = rotateType * Math.PI / 180;
      }
      state.rotation = rotate2;
    });
    function getLabelAttr(model, name) {
      var stateAttr = model.get(name);
      if (stateAttr == null) {
        return normalLabelModel.get(name);
      }
      return stateAttr;
    }
    label.dirtyStyle();
  };
  return SunburstPiece2;
}(Sector$1);
var SunburstPiece$1 = SunburstPiece;
var ROOT_TO_NODE_ACTION = "sunburstRootToNode";
var HIGHLIGHT_ACTION = "sunburstHighlight";
var UNHIGHLIGHT_ACTION = "sunburstUnhighlight";
function installSunburstAction(registers) {
  registers.registerAction({
    type: ROOT_TO_NODE_ACTION,
    update: "updateView"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleRootToNode);
    function handleRootToNode(model, index2) {
      var targetInfo = retrieveTargetInfo(payload, [ROOT_TO_NODE_ACTION], model);
      if (targetInfo) {
        var originViewRoot = model.getViewRoot();
        if (originViewRoot) {
          payload.direction = aboveViewRoot(originViewRoot, targetInfo.node) ? "rollUp" : "drillDown";
        }
        model.resetViewRoot(targetInfo.node);
      }
    }
  });
  registers.registerAction({
    type: HIGHLIGHT_ACTION,
    update: "none"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    ecModel.eachComponent({
      mainType: "series",
      subType: "sunburst",
      query: payload
    }, handleHighlight);
    function handleHighlight(model) {
      var targetInfo = retrieveTargetInfo(payload, [HIGHLIGHT_ACTION], model);
      if (targetInfo) {
        payload.dataIndex = targetInfo.node.dataIndex;
      }
    }
    api.dispatchAction(extend(payload, {
      type: "highlight"
    }));
  });
  registers.registerAction({
    type: UNHIGHLIGHT_ACTION,
    update: "updateView"
  }, function(payload, ecModel, api) {
    payload = extend({}, payload);
    api.dispatchAction(extend(payload, {
      type: "downplay"
    }));
  });
}
var SunburstView = function(_super) {
  __extends(SunburstView2, _super);
  function SunburstView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstView2.type;
    return _this;
  }
  SunburstView2.prototype.render = function(seriesModel, ecModel, api, payload) {
    var self2 = this;
    this.seriesModel = seriesModel;
    this.api = api;
    this.ecModel = ecModel;
    var data = seriesModel.getData();
    var virtualRoot = data.tree.root;
    var newRoot = seriesModel.getViewRoot();
    var group = this.group;
    var renderLabelForZeroData = seriesModel.get("renderLabelForZeroData");
    var newChildren = [];
    newRoot.eachNode(function(node) {
      newChildren.push(node);
    });
    var oldChildren = this._oldChildren || [];
    dualTravel(newChildren, oldChildren);
    renderRollUp(virtualRoot, newRoot);
    this._initEvents();
    this._oldChildren = newChildren;
    function dualTravel(newChildren2, oldChildren2) {
      if (newChildren2.length === 0 && oldChildren2.length === 0) {
        return;
      }
      new DataDiffer$1(oldChildren2, newChildren2, getKey2, getKey2).add(processNode).update(processNode).remove(curry$1(processNode, null)).execute();
      function getKey2(node) {
        return node.getId();
      }
      function processNode(newIdx, oldIdx) {
        var newNode = newIdx == null ? null : newChildren2[newIdx];
        var oldNode = oldIdx == null ? null : oldChildren2[oldIdx];
        doRenderNode(newNode, oldNode);
      }
    }
    function doRenderNode(newNode, oldNode) {
      if (!renderLabelForZeroData && newNode && !newNode.getValue()) {
        newNode = null;
      }
      if (newNode !== virtualRoot && oldNode !== virtualRoot) {
        if (oldNode && oldNode.piece) {
          if (newNode) {
            oldNode.piece.updateData(false, newNode, seriesModel, ecModel, api);
            data.setItemGraphicEl(newNode.dataIndex, oldNode.piece);
          } else {
            removeNode2(oldNode);
          }
        } else if (newNode) {
          var piece = new SunburstPiece$1(newNode, seriesModel, ecModel, api);
          group.add(piece);
          data.setItemGraphicEl(newNode.dataIndex, piece);
        }
      }
    }
    function removeNode2(node) {
      if (!node) {
        return;
      }
      if (node.piece) {
        group.remove(node.piece);
        node.piece = null;
      }
    }
    function renderRollUp(virtualRoot2, viewRoot) {
      if (viewRoot.depth > 0) {
        if (self2.virtualPiece) {
          self2.virtualPiece.updateData(false, virtualRoot2, seriesModel, ecModel, api);
        } else {
          self2.virtualPiece = new SunburstPiece$1(virtualRoot2, seriesModel, ecModel, api);
          group.add(self2.virtualPiece);
        }
        viewRoot.piece.off("click");
        self2.virtualPiece.on("click", function(e2) {
          self2._rootToNode(viewRoot.parentNode);
        });
      } else if (self2.virtualPiece) {
        group.remove(self2.virtualPiece);
        self2.virtualPiece = null;
      }
    }
  };
  SunburstView2.prototype._initEvents = function() {
    var _this = this;
    this.group.off("click");
    this.group.on("click", function(e2) {
      var targetFound = false;
      var viewRoot = _this.seriesModel.getViewRoot();
      viewRoot.eachNode(function(node) {
        if (!targetFound && node.piece && node.piece === e2.target) {
          var nodeClick = node.getModel().get("nodeClick");
          if (nodeClick === "rootToNode") {
            _this._rootToNode(node);
          } else if (nodeClick === "link") {
            var itemModel = node.getModel();
            var link = itemModel.get("link");
            if (link) {
              var linkTarget = itemModel.get("target", true) || "_blank";
              windowOpen(link, linkTarget);
            }
          }
          targetFound = true;
        }
      });
    });
  };
  SunburstView2.prototype._rootToNode = function(node) {
    if (node !== this.seriesModel.getViewRoot()) {
      this.api.dispatchAction({
        type: ROOT_TO_NODE_ACTION,
        from: this.uid,
        seriesId: this.seriesModel.id,
        targetNode: node
      });
    }
  };
  SunburstView2.prototype.containPoint = function(point, seriesModel) {
    var treeRoot = seriesModel.getData();
    var itemLayout = treeRoot.getItemLayout(0);
    if (itemLayout) {
      var dx = point[0] - itemLayout.cx;
      var dy = point[1] - itemLayout.cy;
      var radius = Math.sqrt(dx * dx + dy * dy);
      return radius <= itemLayout.r && radius >= itemLayout.r0;
    }
  };
  SunburstView2.type = "sunburst";
  return SunburstView2;
}(ChartView$1);
var SunburstView$1 = SunburstView;
var SunburstSeriesModel = function(_super) {
  __extends(SunburstSeriesModel2, _super);
  function SunburstSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SunburstSeriesModel2.type;
    _this.ignoreStyleOnData = true;
    return _this;
  }
  SunburstSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    var root2 = {
      name: option.name,
      children: option.data
    };
    completeTreeValue(root2);
    var levelModels = this._levelModels = map$1(option.levels || [], function(levelDefine) {
      return new Model$1(levelDefine, this, ecModel);
    }, this);
    var tree = Tree$1.createTree(root2, this, beforeLink);
    function beforeLink(nodeData) {
      nodeData.wrapMethod("getItemModel", function(model, idx) {
        var node = tree.getNodeByDataIndex(idx);
        var levelModel = levelModels[node.depth];
        levelModel && (model.parentModel = levelModel);
        return model;
      });
    }
    return tree.data;
  };
  SunburstSeriesModel2.prototype.optionUpdated = function() {
    this.resetViewRoot();
  };
  SunburstSeriesModel2.prototype.getDataParams = function(dataIndex) {
    var params = _super.prototype.getDataParams.apply(this, arguments);
    var node = this.getData().tree.getNodeByDataIndex(dataIndex);
    params.treePathInfo = wrapTreePathInfo(node, this);
    return params;
  };
  SunburstSeriesModel2.prototype.getLevelModel = function(node) {
    return this._levelModels && this._levelModels[node.depth];
  };
  SunburstSeriesModel2.prototype.getViewRoot = function() {
    return this._viewRoot;
  };
  SunburstSeriesModel2.prototype.resetViewRoot = function(viewRoot) {
    viewRoot ? this._viewRoot = viewRoot : viewRoot = this._viewRoot;
    var root2 = this.getRawData().tree.root;
    if (!viewRoot || viewRoot !== root2 && !root2.contains(viewRoot)) {
      this._viewRoot = root2;
    }
  };
  SunburstSeriesModel2.prototype.enableAriaDecal = function() {
    enableAriaDecalForTree(this);
  };
  SunburstSeriesModel2.type = "series.sunburst";
  SunburstSeriesModel2.defaultOption = {
    z: 2,
    center: ["50%", "50%"],
    radius: [0, "75%"],
    clockwise: true,
    startAngle: 90,
    minAngle: 0,
    stillShowZeroSum: true,
    nodeClick: "rootToNode",
    renderLabelForZeroData: false,
    label: {
      rotate: "radial",
      show: true,
      opacity: 1,
      align: "center",
      position: "inside",
      distance: 5,
      silent: true
    },
    itemStyle: {
      borderWidth: 1,
      borderColor: "white",
      borderType: "solid",
      shadowBlur: 0,
      shadowColor: "rgba(0, 0, 0, 0.2)",
      shadowOffsetX: 0,
      shadowOffsetY: 0,
      opacity: 1
    },
    emphasis: {
      focus: "descendant"
    },
    blur: {
      itemStyle: {
        opacity: 0.2
      },
      label: {
        opacity: 0.1
      }
    },
    animationType: "expansion",
    animationDuration: 1e3,
    animationDurationUpdate: 500,
    data: [],
    sort: "desc"
  };
  return SunburstSeriesModel2;
}(SeriesModel$1);
function completeTreeValue(dataNode) {
  var sum2 = 0;
  each$f(dataNode.children, function(child) {
    completeTreeValue(child);
    var childValue = child.value;
    isArray$1(childValue) && (childValue = childValue[0]);
    sum2 += childValue;
  });
  var thisValue = dataNode.value;
  if (isArray$1(thisValue)) {
    thisValue = thisValue[0];
  }
  if (thisValue == null || isNaN(thisValue)) {
    thisValue = sum2;
  }
  if (thisValue < 0) {
    thisValue = 0;
  }
  isArray$1(dataNode.value) ? dataNode.value[0] = thisValue : dataNode.value = thisValue;
}
var SunburstSeriesModel$1 = SunburstSeriesModel;
var RADIAN = Math.PI / 180;
function sunburstLayout(seriesType2, ecModel, api) {
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    var center2 = seriesModel.get("center");
    var radius = seriesModel.get("radius");
    if (!isArray$1(radius)) {
      radius = [0, radius];
    }
    if (!isArray$1(center2)) {
      center2 = [center2, center2];
    }
    var width = api.getWidth();
    var height = api.getHeight();
    var size = Math.min(width, height);
    var cx = parsePercent(center2[0], width);
    var cy = parsePercent(center2[1], height);
    var r0 = parsePercent(radius[0], size / 2);
    var r2 = parsePercent(radius[1], size / 2);
    var startAngle = -seriesModel.get("startAngle") * RADIAN;
    var minAngle = seriesModel.get("minAngle") * RADIAN;
    var virtualRoot = seriesModel.getData().tree.root;
    var treeRoot = seriesModel.getViewRoot();
    var rootDepth = treeRoot.depth;
    var sort2 = seriesModel.get("sort");
    if (sort2 != null) {
      initChildren(treeRoot, sort2);
    }
    var validDataCount = 0;
    each$f(treeRoot.children, function(child) {
      !isNaN(child.getValue()) && validDataCount++;
    });
    var sum2 = treeRoot.getValue();
    var unitRadian = Math.PI / (sum2 || validDataCount) * 2;
    var renderRollupNode = treeRoot.depth > 0;
    var levels = treeRoot.height - (renderRollupNode ? -1 : 1);
    var rPerLevel = (r2 - r0) / (levels || 1);
    var clockwise = seriesModel.get("clockwise");
    var stillShowZeroSum = seriesModel.get("stillShowZeroSum");
    var dir3 = clockwise ? 1 : -1;
    var renderNode2 = function(node, startAngle2) {
      if (!node) {
        return;
      }
      var endAngle = startAngle2;
      if (node !== virtualRoot) {
        var value = node.getValue();
        var angle2 = sum2 === 0 && stillShowZeroSum ? unitRadian : value * unitRadian;
        if (angle2 < minAngle) {
          angle2 = minAngle;
        }
        endAngle = startAngle2 + dir3 * angle2;
        var depth = node.depth - rootDepth - (renderRollupNode ? -1 : 1);
        var rStart2 = r0 + rPerLevel * depth;
        var rEnd2 = r0 + rPerLevel * (depth + 1);
        var levelModel = seriesModel.getLevelModel(node);
        if (levelModel) {
          var r0_1 = levelModel.get("r0", true);
          var r_1 = levelModel.get("r", true);
          var radius_1 = levelModel.get("radius", true);
          if (radius_1 != null) {
            r0_1 = radius_1[0];
            r_1 = radius_1[1];
          }
          r0_1 != null && (rStart2 = parsePercent(r0_1, size / 2));
          r_1 != null && (rEnd2 = parsePercent(r_1, size / 2));
        }
        node.setLayout({
          angle: angle2,
          startAngle: startAngle2,
          endAngle,
          clockwise,
          cx,
          cy,
          r0: rStart2,
          r: rEnd2
        });
      }
      if (node.children && node.children.length) {
        var siblingAngle_1 = 0;
        each$f(node.children, function(node2) {
          siblingAngle_1 += renderNode2(node2, startAngle2 + siblingAngle_1);
        });
      }
      return endAngle - startAngle2;
    };
    if (renderRollupNode) {
      var rStart = r0;
      var rEnd = r0 + rPerLevel;
      var angle = Math.PI * 2;
      virtualRoot.setLayout({
        angle,
        startAngle,
        endAngle: startAngle + angle,
        clockwise,
        cx,
        cy,
        r0: rStart,
        r: rEnd
      });
    }
    renderNode2(treeRoot, startAngle);
  });
}
function initChildren(node, sortOrder) {
  var children = node.children || [];
  node.children = sort(children, sortOrder);
  if (children.length) {
    each$f(node.children, function(child) {
      initChildren(child, sortOrder);
    });
  }
}
function sort(children, sortOrder) {
  if (isFunction(sortOrder)) {
    var sortTargets = map$1(children, function(child, idx) {
      var value = child.getValue();
      return {
        params: {
          depth: child.depth,
          height: child.height,
          dataIndex: child.dataIndex,
          getValue: function() {
            return value;
          }
        },
        index: idx
      };
    });
    sortTargets.sort(function(a, b2) {
      return sortOrder(a.params, b2.params);
    });
    return map$1(sortTargets, function(target) {
      return children[target.index];
    });
  } else {
    var isAsc_1 = sortOrder === "asc";
    return children.sort(function(a, b2) {
      var diff = (a.getValue() - b2.getValue()) * (isAsc_1 ? 1 : -1);
      return diff === 0 ? (a.dataIndex - b2.dataIndex) * (isAsc_1 ? -1 : 1) : diff;
    });
  }
}
function sunburstVisual(ecModel) {
  var paletteScope = {};
  function pickColor(node, seriesModel, treeHeight) {
    var current = node;
    while (current && current.depth > 1) {
      current = current.parentNode;
    }
    var color = seriesModel.getColorFromPalette(current.name || current.dataIndex + "", paletteScope);
    if (node.depth > 1 && isString(color)) {
      color = lift(color, (node.depth - 1) / (treeHeight - 1) * 0.5);
    }
    return color;
  }
  ecModel.eachSeriesByType("sunburst", function(seriesModel) {
    var data = seriesModel.getData();
    var tree = data.tree;
    tree.eachNode(function(node) {
      var model = node.getModel();
      var style = model.getModel("itemStyle").getItemStyle();
      if (!style.fill) {
        style.fill = pickColor(node, seriesModel, tree.root.height);
      }
      var existsStyle = data.ensureUniqueItemVisual(node.dataIndex, "style");
      extend(existsStyle, style);
    });
  });
}
function install$s(registers) {
  registers.registerChartView(SunburstView$1);
  registers.registerSeriesModel(SunburstSeriesModel$1);
  registers.registerLayout(curry$1(sunburstLayout, "sunburst"));
  registers.registerProcessor(curry$1(dataFilter$1, "sunburst"));
  registers.registerVisual(sunburstVisual);
  installSunburstAction(registers);
}
var STYLE_VISUAL_TYPE = {
  color: "fill",
  borderColor: "stroke"
};
var NON_STYLE_VISUAL_PROPS = {
  symbol: 1,
  symbolSize: 1,
  symbolKeepAspect: 1,
  legendIcon: 1,
  visualMeta: 1,
  liftZ: 1,
  decal: 1
};
var customInnerStore = makeInner();
var CustomSeriesModel = function(_super) {
  __extends(CustomSeriesModel2, _super);
  function CustomSeriesModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomSeriesModel2.type;
    return _this;
  }
  CustomSeriesModel2.prototype.optionUpdated = function() {
    this.currentZLevel = this.get("zlevel", true);
    this.currentZ = this.get("z", true);
  };
  CustomSeriesModel2.prototype.getInitialData = function(option, ecModel) {
    return createSeriesData(null, this);
  };
  CustomSeriesModel2.prototype.getDataParams = function(dataIndex, dataType, el) {
    var params = _super.prototype.getDataParams.call(this, dataIndex, dataType);
    el && (params.info = customInnerStore(el).info);
    return params;
  };
  CustomSeriesModel2.type = "series.custom";
  CustomSeriesModel2.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"];
  CustomSeriesModel2.defaultOption = {
    coordinateSystem: "cartesian2d",
    z: 2,
    legendHoverLink: true,
    clip: false
  };
  return CustomSeriesModel2;
}(SeriesModel$1);
var CustomSeriesModel$1 = CustomSeriesModel;
function dataToCoordSize$3(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["x", "y"], function(dim, dimIdx) {
    var axis = this.getAxis(dim);
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
  }, this);
}
function cartesianPrepareCustom(coordSys) {
  var rect = coordSys.master.getRect();
  return {
    coordSys: {
      type: "cartesian2d",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$3, coordSys)
    }
  };
}
function dataToCoordSize$2(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1([0, 1], function(dimIdx) {
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var p1 = [];
    var p2 = [];
    p1[dimIdx] = val - halfSize;
    p2[dimIdx] = val + halfSize;
    p1[1 - dimIdx] = p2[1 - dimIdx] = dataItem[1 - dimIdx];
    return Math.abs(this.dataToPoint(p1)[dimIdx] - this.dataToPoint(p2)[dimIdx]);
  }, this);
}
function geoPrepareCustom(coordSys) {
  var rect = coordSys.getBoundingRect();
  return {
    coordSys: {
      type: "geo",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      zoom: coordSys.getZoom()
    },
    api: {
      coord: function(data) {
        return coordSys.dataToPoint(data);
      },
      size: bind$1(dataToCoordSize$2, coordSys)
    }
  };
}
function dataToCoordSize$1(dataSize, dataItem) {
  var axis = this.getAxis();
  var val = dataItem instanceof Array ? dataItem[0] : dataItem;
  var halfSize = (dataSize instanceof Array ? dataSize[0] : dataSize) / 2;
  return axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
}
function singlePrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  return {
    coordSys: {
      type: "singleAxis",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height
    },
    api: {
      coord: function(val) {
        return coordSys.dataToPoint(val);
      },
      size: bind$1(dataToCoordSize$1, coordSys)
    }
  };
}
function dataToCoordSize(dataSize, dataItem) {
  dataItem = dataItem || [0, 0];
  return map$1(["Radius", "Angle"], function(dim, dimIdx) {
    var getterName = "get" + dim + "Axis";
    var axis = this[getterName]();
    var val = dataItem[dimIdx];
    var halfSize = dataSize[dimIdx] / 2;
    var result = axis.type === "category" ? axis.getBandWidth() : Math.abs(axis.dataToCoord(val - halfSize) - axis.dataToCoord(val + halfSize));
    if (dim === "Angle") {
      result = result * Math.PI / 180;
    }
    return result;
  }, this);
}
function polarPrepareCustom(coordSys) {
  var radiusAxis = coordSys.getRadiusAxis();
  var angleAxis = coordSys.getAngleAxis();
  var radius = radiusAxis.getExtent();
  radius[0] > radius[1] && radius.reverse();
  return {
    coordSys: {
      type: "polar",
      cx: coordSys.cx,
      cy: coordSys.cy,
      r: radius[1],
      r0: radius[0]
    },
    api: {
      coord: function(data) {
        var radius2 = radiusAxis.dataToRadius(data[0]);
        var angle = angleAxis.dataToAngle(data[1]);
        var coord = coordSys.coordToPoint([radius2, angle]);
        coord.push(radius2, angle * Math.PI / 180);
        return coord;
      },
      size: bind$1(dataToCoordSize, coordSys)
    }
  };
}
function calendarPrepareCustom(coordSys) {
  var rect = coordSys.getRect();
  var rangeInfo = coordSys.getRangeInfo();
  return {
    coordSys: {
      type: "calendar",
      x: rect.x,
      y: rect.y,
      width: rect.width,
      height: rect.height,
      cellWidth: coordSys.getCellWidth(),
      cellHeight: coordSys.getCellHeight(),
      rangeInfo: {
        start: rangeInfo.start,
        end: rangeInfo.end,
        weeks: rangeInfo.weeks,
        dayCount: rangeInfo.allDay
      }
    },
    api: {
      coord: function(data, clamp2) {
        return coordSys.dataToPoint(data, clamp2);
      }
    }
  };
}
function isEC4CompatibleStyle(style, elType, hasOwnTextContentOption, hasOwnTextConfig) {
  return style && (style.legacy || style.legacy !== false && !hasOwnTextContentOption && !hasOwnTextConfig && elType !== "tspan" && (elType === "text" || hasOwn(style, "text")));
}
function convertFromEC4CompatibleStyle(hostStyle, elType, isNormal) {
  var srcStyle = hostStyle;
  var textConfig;
  var textContent;
  var textContentStyle;
  if (elType === "text") {
    textContentStyle = srcStyle;
  } else {
    textContentStyle = {};
    hasOwn(srcStyle, "text") && (textContentStyle.text = srcStyle.text);
    hasOwn(srcStyle, "rich") && (textContentStyle.rich = srcStyle.rich);
    hasOwn(srcStyle, "textFill") && (textContentStyle.fill = srcStyle.textFill);
    hasOwn(srcStyle, "textStroke") && (textContentStyle.stroke = srcStyle.textStroke);
    hasOwn(srcStyle, "fontFamily") && (textContentStyle.fontFamily = srcStyle.fontFamily);
    hasOwn(srcStyle, "fontSize") && (textContentStyle.fontSize = srcStyle.fontSize);
    hasOwn(srcStyle, "fontStyle") && (textContentStyle.fontStyle = srcStyle.fontStyle);
    hasOwn(srcStyle, "fontWeight") && (textContentStyle.fontWeight = srcStyle.fontWeight);
    textContent = {
      type: "text",
      style: textContentStyle,
      silent: true
    };
    textConfig = {};
    var hasOwnPos = hasOwn(srcStyle, "textPosition");
    if (isNormal) {
      textConfig.position = hasOwnPos ? srcStyle.textPosition : "inside";
    } else {
      hasOwnPos && (textConfig.position = srcStyle.textPosition);
    }
    hasOwn(srcStyle, "textPosition") && (textConfig.position = srcStyle.textPosition);
    hasOwn(srcStyle, "textOffset") && (textConfig.offset = srcStyle.textOffset);
    hasOwn(srcStyle, "textRotation") && (textConfig.rotation = srcStyle.textRotation);
    hasOwn(srcStyle, "textDistance") && (textConfig.distance = srcStyle.textDistance);
  }
  convertEC4CompatibleRichItem(textContentStyle, hostStyle);
  each$f(textContentStyle.rich, function(richItem) {
    convertEC4CompatibleRichItem(richItem, richItem);
  });
  return {
    textConfig,
    textContent
  };
}
function convertEC4CompatibleRichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  richItem.font = richItem.textFont || richItem.font;
  hasOwn(richItem, "textStrokeWidth") && (out2.lineWidth = richItem.textStrokeWidth);
  hasOwn(richItem, "textAlign") && (out2.align = richItem.textAlign);
  hasOwn(richItem, "textVerticalAlign") && (out2.verticalAlign = richItem.textVerticalAlign);
  hasOwn(richItem, "textLineHeight") && (out2.lineHeight = richItem.textLineHeight);
  hasOwn(richItem, "textWidth") && (out2.width = richItem.textWidth);
  hasOwn(richItem, "textHeight") && (out2.height = richItem.textHeight);
  hasOwn(richItem, "textBackgroundColor") && (out2.backgroundColor = richItem.textBackgroundColor);
  hasOwn(richItem, "textPadding") && (out2.padding = richItem.textPadding);
  hasOwn(richItem, "textBorderColor") && (out2.borderColor = richItem.textBorderColor);
  hasOwn(richItem, "textBorderWidth") && (out2.borderWidth = richItem.textBorderWidth);
  hasOwn(richItem, "textBorderRadius") && (out2.borderRadius = richItem.textBorderRadius);
  hasOwn(richItem, "textBoxShadowColor") && (out2.shadowColor = richItem.textBoxShadowColor);
  hasOwn(richItem, "textBoxShadowBlur") && (out2.shadowBlur = richItem.textBoxShadowBlur);
  hasOwn(richItem, "textBoxShadowOffsetX") && (out2.shadowOffsetX = richItem.textBoxShadowOffsetX);
  hasOwn(richItem, "textBoxShadowOffsetY") && (out2.shadowOffsetY = richItem.textBoxShadowOffsetY);
}
function convertToEC4StyleForCustomSerise(itemStl, txStl, txCfg) {
  var out2 = itemStl;
  out2.textPosition = out2.textPosition || txCfg.position || "inside";
  txCfg.offset != null && (out2.textOffset = txCfg.offset);
  txCfg.rotation != null && (out2.textRotation = txCfg.rotation);
  txCfg.distance != null && (out2.textDistance = txCfg.distance);
  var isInside = out2.textPosition.indexOf("inside") >= 0;
  var hostFill = itemStl.fill || "#000";
  convertToEC4RichItem(out2, txStl);
  var textFillNotSet = out2.textFill == null;
  if (isInside) {
    if (textFillNotSet) {
      out2.textFill = txCfg.insideFill || "#fff";
      !out2.textStroke && txCfg.insideStroke && (out2.textStroke = txCfg.insideStroke);
      !out2.textStroke && (out2.textStroke = hostFill);
      out2.textStrokeWidth == null && (out2.textStrokeWidth = 2);
    }
  } else {
    if (textFillNotSet) {
      out2.textFill = itemStl.fill || txCfg.outsideFill || "#000";
    }
    !out2.textStroke && txCfg.outsideStroke && (out2.textStroke = txCfg.outsideStroke);
  }
  out2.text = txStl.text;
  out2.rich = txStl.rich;
  each$f(txStl.rich, function(richItem) {
    convertToEC4RichItem(richItem, richItem);
  });
  return out2;
}
function convertToEC4RichItem(out2, richItem) {
  if (!richItem) {
    return;
  }
  hasOwn(richItem, "fill") && (out2.textFill = richItem.fill);
  hasOwn(richItem, "stroke") && (out2.textStroke = richItem.fill);
  hasOwn(richItem, "lineWidth") && (out2.textStrokeWidth = richItem.lineWidth);
  hasOwn(richItem, "font") && (out2.font = richItem.font);
  hasOwn(richItem, "fontStyle") && (out2.fontStyle = richItem.fontStyle);
  hasOwn(richItem, "fontWeight") && (out2.fontWeight = richItem.fontWeight);
  hasOwn(richItem, "fontSize") && (out2.fontSize = richItem.fontSize);
  hasOwn(richItem, "fontFamily") && (out2.fontFamily = richItem.fontFamily);
  hasOwn(richItem, "align") && (out2.textAlign = richItem.align);
  hasOwn(richItem, "verticalAlign") && (out2.textVerticalAlign = richItem.verticalAlign);
  hasOwn(richItem, "lineHeight") && (out2.textLineHeight = richItem.lineHeight);
  hasOwn(richItem, "width") && (out2.textWidth = richItem.width);
  hasOwn(richItem, "height") && (out2.textHeight = richItem.height);
  hasOwn(richItem, "backgroundColor") && (out2.textBackgroundColor = richItem.backgroundColor);
  hasOwn(richItem, "padding") && (out2.textPadding = richItem.padding);
  hasOwn(richItem, "borderColor") && (out2.textBorderColor = richItem.borderColor);
  hasOwn(richItem, "borderWidth") && (out2.textBorderWidth = richItem.borderWidth);
  hasOwn(richItem, "borderRadius") && (out2.textBorderRadius = richItem.borderRadius);
  hasOwn(richItem, "shadowColor") && (out2.textBoxShadowColor = richItem.shadowColor);
  hasOwn(richItem, "shadowBlur") && (out2.textBoxShadowBlur = richItem.shadowBlur);
  hasOwn(richItem, "shadowOffsetX") && (out2.textBoxShadowOffsetX = richItem.shadowOffsetX);
  hasOwn(richItem, "shadowOffsetY") && (out2.textBoxShadowOffsetY = richItem.shadowOffsetY);
  hasOwn(richItem, "textShadowColor") && (out2.textShadowColor = richItem.textShadowColor);
  hasOwn(richItem, "textShadowBlur") && (out2.textShadowBlur = richItem.textShadowBlur);
  hasOwn(richItem, "textShadowOffsetX") && (out2.textShadowOffsetX = richItem.textShadowOffsetX);
  hasOwn(richItem, "textShadowOffsetY") && (out2.textShadowOffsetY = richItem.textShadowOffsetY);
}
var LEGACY_TRANSFORM_PROPS_MAP = {
  position: ["x", "y"],
  scale: ["scaleX", "scaleY"],
  origin: ["originX", "originY"]
};
var LEGACY_TRANSFORM_PROPS = keys(LEGACY_TRANSFORM_PROPS_MAP);
reduce(TRANSFORMABLE_PROPS, function(obj, key) {
  obj[key] = 1;
  return obj;
}, {});
TRANSFORMABLE_PROPS.join(", ");
var ELEMENT_ANIMATABLE_PROPS = ["", "style", "shape", "extra"];
var transitionInnerStore = makeInner();
function getElementAnimationConfig(animationType, el, elOption, parentModel, dataIndex) {
  var animationProp = animationType + "Animation";
  var config = getAnimationConfig(animationType, parentModel, dataIndex) || {};
  var userDuring = transitionInnerStore(el).userDuring;
  if (config.duration > 0) {
    config.during = userDuring ? bind$1(duringCall, {
      el,
      userDuring
    }) : null;
    config.setToFinal = true;
    config.scope = animationType;
  }
  extend(config, elOption[animationProp]);
  return config;
}
function applyUpdateTransition(el, elOption, animatableModel, opts) {
  opts = opts || {};
  var dataIndex = opts.dataIndex, isInit = opts.isInit, clearStyle = opts.clearStyle;
  var hasAnimation = animatableModel.isAnimationEnabled();
  var store = transitionInnerStore(el);
  var styleOpt = elOption.style;
  store.userDuring = elOption.during;
  var transFromProps = {};
  var propsToSet = {};
  prepareTransformAllPropsFinal(el, elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("shape", elOption, propsToSet);
  prepareShapeOrExtraAllPropsFinal("extra", elOption, propsToSet);
  if (!isInit && hasAnimation) {
    prepareTransformTransitionFrom(el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("shape", el, elOption, transFromProps);
    prepareShapeOrExtraTransitionFrom("extra", el, elOption, transFromProps);
    prepareStyleTransitionFrom(el, elOption, styleOpt, transFromProps);
  }
  propsToSet.style = styleOpt;
  applyPropsDirectly(el, propsToSet, clearStyle);
  applyMiscProps(el, elOption);
  if (hasAnimation) {
    if (isInit) {
      var enterFromProps_1 = {};
      each$f(ELEMENT_ANIMATABLE_PROPS, function(propName) {
        var prop = propName ? elOption[propName] : elOption;
        if (prop && prop.enterFrom) {
          if (propName) {
            enterFromProps_1[propName] = enterFromProps_1[propName] || {};
          }
          extend(propName ? enterFromProps_1[propName] : enterFromProps_1, prop.enterFrom);
        }
      });
      var config = getElementAnimationConfig("enter", el, elOption, animatableModel, dataIndex);
      if (config.duration > 0) {
        el.animateFrom(enterFromProps_1, config);
      }
    } else {
      applyPropsTransition(el, elOption, dataIndex || 0, animatableModel, transFromProps);
    }
  }
  updateLeaveTo(el, elOption);
  styleOpt ? el.dirty() : el.markRedraw();
}
function updateLeaveTo(el, elOption) {
  var leaveToProps = transitionInnerStore(el).leaveToProps;
  for (var i = 0; i < ELEMENT_ANIMATABLE_PROPS.length; i++) {
    var propName = ELEMENT_ANIMATABLE_PROPS[i];
    var prop = propName ? elOption[propName] : elOption;
    if (prop && prop.leaveTo) {
      if (!leaveToProps) {
        leaveToProps = transitionInnerStore(el).leaveToProps = {};
      }
      if (propName) {
        leaveToProps[propName] = leaveToProps[propName] || {};
      }
      extend(propName ? leaveToProps[propName] : leaveToProps, prop.leaveTo);
    }
  }
}
function applyLeaveTransition(el, elOption, animatableModel, onRemove) {
  if (el) {
    var parent_1 = el.parent;
    var leaveToProps = transitionInnerStore(el).leaveToProps;
    if (leaveToProps) {
      var config = getElementAnimationConfig("update", el, elOption, animatableModel, 0);
      config.done = function() {
        parent_1.remove(el);
        onRemove && onRemove();
      };
      el.animateTo(leaveToProps, config);
    } else {
      parent_1.remove(el);
      onRemove && onRemove();
    }
  }
}
function isTransitionAll(transition) {
  return transition === "all";
}
function applyPropsDirectly(el, allPropsFinal, clearStyle) {
  var styleOpt = allPropsFinal.style;
  if (!el.isGroup && styleOpt) {
    if (clearStyle) {
      el.useStyle({});
      var animators = el.animators;
      for (var i = 0; i < animators.length; i++) {
        var animator = animators[i];
        if (animator.targetName === "style") {
          animator.changeTarget(el.style);
        }
      }
    }
    el.setStyle(styleOpt);
  }
  if (allPropsFinal) {
    allPropsFinal.style = null;
    allPropsFinal && el.attr(allPropsFinal);
    allPropsFinal.style = styleOpt;
  }
}
function applyPropsTransition(el, elOption, dataIndex, model, transFromProps) {
  if (transFromProps) {
    var config = getElementAnimationConfig("update", el, elOption, model, dataIndex);
    if (config.duration > 0) {
      el.animateFrom(transFromProps, config);
    }
  }
}
function applyMiscProps(el, elOption) {
  hasOwn(elOption, "silent") && (el.silent = elOption.silent);
  hasOwn(elOption, "ignore") && (el.ignore = elOption.ignore);
  if (el instanceof Displayable$1) {
    hasOwn(elOption, "invisible") && (el.invisible = elOption.invisible);
  }
  if (el instanceof Path$1) {
    hasOwn(elOption, "autoBatch") && (el.autoBatch = elOption.autoBatch);
  }
}
var tmpDuringScope = {};
var transitionDuringAPI = {
  setTransform: function(key, val) {
    tmpDuringScope.el[key] = val;
    return this;
  },
  getTransform: function(key) {
    return tmpDuringScope.el[key];
  },
  setShape: function(key, val) {
    var el = tmpDuringScope.el;
    var shape = el.shape || (el.shape = {});
    shape[key] = val;
    el.dirtyShape && el.dirtyShape();
    return this;
  },
  getShape: function(key) {
    var shape = tmpDuringScope.el.shape;
    if (shape) {
      return shape[key];
    }
  },
  setStyle: function(key, val) {
    var el = tmpDuringScope.el;
    var style = el.style;
    if (style) {
      style[key] = val;
      el.dirtyStyle && el.dirtyStyle();
    }
    return this;
  },
  getStyle: function(key) {
    var style = tmpDuringScope.el.style;
    if (style) {
      return style[key];
    }
  },
  setExtra: function(key, val) {
    var extra = tmpDuringScope.el.extra || (tmpDuringScope.el.extra = {});
    extra[key] = val;
    return this;
  },
  getExtra: function(key) {
    var extra = tmpDuringScope.el.extra;
    if (extra) {
      return extra[key];
    }
  }
};
function duringCall() {
  var scope = this;
  var el = scope.el;
  if (!el) {
    return;
  }
  var latestUserDuring = transitionInnerStore(el).userDuring;
  var scopeUserDuring = scope.userDuring;
  if (latestUserDuring !== scopeUserDuring) {
    scope.el = scope.userDuring = null;
    return;
  }
  tmpDuringScope.el = el;
  scopeUserDuring(transitionDuringAPI);
}
function prepareShapeOrExtraTransitionFrom(mainAttr, fromEl, elOption, transFromProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var elPropsInAttr = fromEl[mainAttr];
  var transFromPropsInAttr;
  if (elPropsInAttr) {
    var transition = elOption.transition;
    var attrTransition = attrOpt.transition;
    if (attrTransition) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      if (isTransitionAll(attrTransition)) {
        extend(transFromPropsInAttr, elPropsInAttr);
      } else {
        var transitionKeys = normalizeToArray(attrTransition);
        for (var i = 0; i < transitionKeys.length; i++) {
          var key = transitionKeys[i];
          var elVal = elPropsInAttr[key];
          transFromPropsInAttr[key] = elVal;
        }
      }
    } else if (isTransitionAll(transition) || indexOf(transition, mainAttr) >= 0) {
      !transFromPropsInAttr && (transFromPropsInAttr = transFromProps[mainAttr] = {});
      var elPropsInAttrKeys = keys(elPropsInAttr);
      for (var i = 0; i < elPropsInAttrKeys.length; i++) {
        var key = elPropsInAttrKeys[i];
        var elVal = elPropsInAttr[key];
        if (isNonStyleTransitionEnabled(attrOpt[key], elVal)) {
          transFromPropsInAttr[key] = elVal;
        }
      }
    }
  }
}
function prepareShapeOrExtraAllPropsFinal(mainAttr, elOption, allProps) {
  var attrOpt = elOption[mainAttr];
  if (!attrOpt) {
    return;
  }
  var allPropsInAttr = allProps[mainAttr] = {};
  var keysInAttr = keys(attrOpt);
  for (var i = 0; i < keysInAttr.length; i++) {
    var key = keysInAttr[i];
    allPropsInAttr[key] = cloneValue(attrOpt[key]);
  }
}
function prepareTransformTransitionFrom(el, elOption, transFromProps) {
  var transition = elOption.transition;
  var transitionKeys = isTransitionAll(transition) ? TRANSFORMABLE_PROPS : normalizeToArray(transition || []);
  for (var i = 0; i < transitionKeys.length; i++) {
    var key = transitionKeys[i];
    if (key === "style" || key === "shape" || key === "extra") {
      continue;
    }
    var elVal = el[key];
    transFromProps[key] = elVal;
  }
}
function prepareTransformAllPropsFinal(el, elOption, allProps) {
  for (var i = 0; i < LEGACY_TRANSFORM_PROPS.length; i++) {
    var legacyName = LEGACY_TRANSFORM_PROPS[i];
    var xyName = LEGACY_TRANSFORM_PROPS_MAP[legacyName];
    var legacyArr = elOption[legacyName];
    if (legacyArr) {
      allProps[xyName[0]] = legacyArr[0];
      allProps[xyName[1]] = legacyArr[1];
    }
  }
  for (var i = 0; i < TRANSFORMABLE_PROPS.length; i++) {
    var key = TRANSFORMABLE_PROPS[i];
    if (elOption[key] != null) {
      allProps[key] = elOption[key];
    }
  }
}
function prepareStyleTransitionFrom(fromEl, elOption, styleOpt, transFromProps) {
  if (!styleOpt) {
    return;
  }
  var fromElStyle = fromEl.style;
  var transFromStyleProps;
  if (fromElStyle) {
    var styleTransition = styleOpt.transition;
    var elTransition = elOption.transition;
    if (styleTransition && !isTransitionAll(styleTransition)) {
      var transitionKeys = normalizeToArray(styleTransition);
      !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
      for (var i = 0; i < transitionKeys.length; i++) {
        var key = transitionKeys[i];
        var elVal = fromElStyle[key];
        transFromStyleProps[key] = elVal;
      }
    } else if (fromEl.getAnimationStyleProps && (isTransitionAll(elTransition) || isTransitionAll(styleTransition) || indexOf(elTransition, "style") >= 0)) {
      var animationProps = fromEl.getAnimationStyleProps();
      var animationStyleProps = animationProps ? animationProps.style : null;
      if (animationStyleProps) {
        !transFromStyleProps && (transFromStyleProps = transFromProps.style = {});
        var styleKeys = keys(styleOpt);
        for (var i = 0; i < styleKeys.length; i++) {
          var key = styleKeys[i];
          if (animationStyleProps[key]) {
            var elVal = fromElStyle[key];
            transFromStyleProps[key] = elVal;
          }
        }
      }
    }
  }
}
function isNonStyleTransitionEnabled(optVal, elVal) {
  return !isArrayLike(optVal) ? optVal != null && isFinite(optVal) : optVal !== elVal;
}
var getStateToRestore = makeInner();
var KEYFRAME_EXCLUDE_KEYS = ["percent", "easing", "shape", "style", "extra"];
function stopPreviousKeyframeAnimationAndRestore(el) {
  el.stopAnimation("keyframe");
  el.attr(getStateToRestore(el));
}
function applyKeyframeAnimation(el, animationOpts, animatableModel) {
  if (!animatableModel.isAnimationEnabled() || !animationOpts) {
    return;
  }
  if (isArray$1(animationOpts)) {
    each$f(animationOpts, function(singleAnimationOpts) {
      applyKeyframeAnimation(el, singleAnimationOpts, animatableModel);
    });
    return;
  }
  var keyframes = animationOpts.keyframes;
  var duration = animationOpts.duration;
  if (animatableModel && duration == null) {
    var config = getAnimationConfig("enter", animatableModel, 0);
    duration = config && config.duration;
  }
  if (!keyframes || !duration) {
    return;
  }
  var stateToRestore = getStateToRestore(el);
  each$f(ELEMENT_ANIMATABLE_PROPS, function(targetPropName) {
    if (targetPropName && !el[targetPropName]) {
      return;
    }
    var animator;
    keyframes.sort(function(a, b2) {
      return a.percent - b2.percent;
    });
    each$f(keyframes, function(kf) {
      var animators = el.animators;
      var kfValues = targetPropName ? kf[targetPropName] : kf;
      if (!kfValues) {
        return;
      }
      var propKeys = keys(kfValues);
      if (!targetPropName) {
        propKeys = filter(propKeys, function(key) {
          return indexOf(KEYFRAME_EXCLUDE_KEYS, key) < 0;
        });
      }
      if (!propKeys.length) {
        return;
      }
      if (!animator) {
        animator = el.animate(targetPropName, animationOpts.loop, true);
        animator.scope = "keyframe";
      }
      for (var i = 0; i < animators.length; i++) {
        if (animators[i] !== animator && animators[i].targetName === animator.targetName) {
          animators[i].stopTracks(propKeys);
        }
      }
      targetPropName && (stateToRestore[targetPropName] = stateToRestore[targetPropName] || {});
      var savedTarget = targetPropName ? stateToRestore[targetPropName] : stateToRestore;
      each$f(propKeys, function(key) {
        savedTarget[key] = ((targetPropName ? el[targetPropName] : el) || {})[key];
      });
      animator.whenWithKeys(duration * kf.percent, kfValues, propKeys, kf.easing);
    });
    if (!animator) {
      return;
    }
    animator.delay(animationOpts.delay || 0).duration(duration).start(animationOpts.easing);
  });
}
var EMPHASIS = "emphasis";
var NORMAL = "normal";
var BLUR = "blur";
var SELECT = "select";
var STATES = [NORMAL, EMPHASIS, BLUR, SELECT];
var PATH_ITEM_STYLE = {
  normal: ["itemStyle"],
  emphasis: [EMPHASIS, "itemStyle"],
  blur: [BLUR, "itemStyle"],
  select: [SELECT, "itemStyle"]
};
var PATH_LABEL = {
  normal: ["label"],
  emphasis: [EMPHASIS, "label"],
  blur: [BLUR, "label"],
  select: [SELECT, "label"]
};
var DEFAULT_TRANSITION = ["x", "y"];
var GROUP_DIFF_PREFIX = "e\0\0";
var attachedTxInfoTmp = {
  normal: {},
  emphasis: {},
  blur: {},
  select: {}
};
var prepareCustoms = {
  cartesian2d: cartesianPrepareCustom,
  geo: geoPrepareCustom,
  singleAxis: singlePrepareCustom,
  polar: polarPrepareCustom,
  calendar: calendarPrepareCustom
};
function isPath(el) {
  return el instanceof Path$1;
}
function isDisplayable(el) {
  return el instanceof Displayable$1;
}
function copyElement(sourceEl, targetEl) {
  targetEl.copyTransform(sourceEl);
  if (isDisplayable(targetEl) && isDisplayable(sourceEl)) {
    targetEl.setStyle(sourceEl.style);
    targetEl.z = sourceEl.z;
    targetEl.z2 = sourceEl.z2;
    targetEl.zlevel = sourceEl.zlevel;
    targetEl.invisible = sourceEl.invisible;
    targetEl.ignore = sourceEl.ignore;
    if (isPath(targetEl) && isPath(sourceEl)) {
      targetEl.setShape(sourceEl.shape);
    }
  }
}
var CustomChartView = function(_super) {
  __extends(CustomChartView2, _super);
  function CustomChartView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CustomChartView2.type;
    return _this;
  }
  CustomChartView2.prototype.render = function(customSeries, ecModel, api, payload) {
    this._progressiveEls = null;
    var oldData = this._data;
    var data = customSeries.getData();
    var group = this.group;
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    if (!oldData) {
      group.removeAll();
    }
    data.diff(oldData).add(function(newIdx) {
      createOrUpdateItem(api, null, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).remove(function(oldIdx) {
      var el = oldData.getItemGraphicEl(oldIdx);
      applyLeaveTransition(el, customInnerStore(el).option, customSeries);
    }).update(function(newIdx, oldIdx) {
      var oldEl = oldData.getItemGraphicEl(oldIdx);
      createOrUpdateItem(api, oldEl, newIdx, renderItem(newIdx, payload), customSeries, group, data);
    }).execute();
    var clipPath = customSeries.get("clip", true) ? createClipPath(customSeries.coordinateSystem, false, customSeries) : null;
    if (clipPath) {
      group.setClipPath(clipPath);
    } else {
      group.removeClipPath();
    }
    this._data = data;
  };
  CustomChartView2.prototype.incrementalPrepareRender = function(customSeries, ecModel, api) {
    this.group.removeAll();
    this._data = null;
  };
  CustomChartView2.prototype.incrementalRender = function(params, customSeries, ecModel, api, payload) {
    var data = customSeries.getData();
    var renderItem = makeRenderItem(customSeries, data, ecModel, api);
    var progressiveEls = this._progressiveEls = [];
    function setIncrementalAndHoverLayer(el2) {
      if (!el2.isGroup) {
        el2.incremental = true;
        el2.ensureState("emphasis").hoverLayer = true;
      }
    }
    for (var idx = params.start; idx < params.end; idx++) {
      var el = createOrUpdateItem(null, null, idx, renderItem(idx, payload), customSeries, this.group, data);
      if (el) {
        el.traverse(setIncrementalAndHoverLayer);
        progressiveEls.push(el);
      }
    }
  };
  CustomChartView2.prototype.eachRendered = function(cb) {
    traverseElements(this._progressiveEls || this.group, cb);
  };
  CustomChartView2.prototype.filterForExposedEvent = function(eventType, query, targetEl, packedEvent) {
    var elementName = query.element;
    if (elementName == null || targetEl.name === elementName) {
      return true;
    }
    while ((targetEl = targetEl.__hostTarget || targetEl.parent) && targetEl !== this.group) {
      if (targetEl.name === elementName) {
        return true;
      }
    }
    return false;
  };
  CustomChartView2.type = "custom";
  return CustomChartView2;
}(ChartView$1);
var CustomChartView$1 = CustomChartView;
function createEl$1(elOption) {
  var graphicType = elOption.type;
  var el;
  if (graphicType === "path") {
    var shape = elOption.shape;
    var pathRect = shape.width != null && shape.height != null ? {
      x: shape.x || 0,
      y: shape.y || 0,
      width: shape.width,
      height: shape.height
    } : null;
    var pathData = getPathData(shape);
    el = makePath(pathData, null, pathRect, shape.layout || "center");
    customInnerStore(el).customPathData = pathData;
  } else if (graphicType === "image") {
    el = new ZRImage$1({});
    customInnerStore(el).customImagePath = elOption.style.image;
  } else if (graphicType === "text") {
    el = new ZRText$1({});
  } else if (graphicType === "group") {
    el = new Group$4();
  } else if (graphicType === "compoundPath") {
    throw new Error('"compoundPath" is not supported yet.');
  } else {
    var Clz = getShapeClass(graphicType);
    if (!Clz) {
      var errMsg = "";
      throwError(errMsg);
    }
    el = new Clz();
  }
  customInnerStore(el).customGraphicType = graphicType;
  el.name = elOption.name;
  el.z2EmphasisLift = 1;
  el.z2SelectLift = 1;
  return el;
}
function updateElNormal(api, el, dataIndex, elOption, attachedTxInfo, seriesModel, isInit) {
  stopPreviousKeyframeAnimationAndRestore(el);
  var txCfgOpt = attachedTxInfo && attachedTxInfo.normal.cfg;
  if (txCfgOpt) {
    el.setTextConfig(txCfgOpt);
  }
  if (elOption && elOption.transition == null) {
    elOption.transition = DEFAULT_TRANSITION;
  }
  var styleOpt = elOption && elOption.style;
  if (styleOpt) {
    if (el.type === "text") {
      var textOptionStyle = styleOpt;
      hasOwn(textOptionStyle, "textFill") && (textOptionStyle.fill = textOptionStyle.textFill);
      hasOwn(textOptionStyle, "textStroke") && (textOptionStyle.stroke = textOptionStyle.textStroke);
    }
    var decalPattern = void 0;
    var decalObj = isPath(el) ? styleOpt.decal : null;
    if (api && decalObj) {
      decalObj.dirty = true;
      decalPattern = createOrUpdatePatternFromDecal(decalObj, api);
    }
    styleOpt.__decalPattern = decalPattern;
  }
  if (isDisplayable(el)) {
    if (styleOpt) {
      var decalPattern = styleOpt.__decalPattern;
      if (decalPattern) {
        styleOpt.decal = decalPattern;
      }
    }
  }
  applyUpdateTransition(el, elOption, seriesModel, {
    dataIndex,
    isInit,
    clearStyle: true
  });
  applyKeyframeAnimation(el, elOption.keyframeAnimation, seriesModel);
}
function updateElOnState(state, el, elStateOpt, styleOpt, attachedTxInfo) {
  var elDisplayable = el.isGroup ? null : el;
  var txCfgOpt = attachedTxInfo && attachedTxInfo[state].cfg;
  if (elDisplayable) {
    var stateObj = elDisplayable.ensureState(state);
    if (styleOpt === false) {
      var existingEmphasisState = elDisplayable.getState(state);
      if (existingEmphasisState) {
        existingEmphasisState.style = null;
      }
    } else {
      stateObj.style = styleOpt || null;
    }
    if (txCfgOpt) {
      stateObj.textConfig = txCfgOpt;
    }
    setDefaultStateProxy(elDisplayable);
  }
}
function updateZ(el, elOption, seriesModel) {
  if (el.isGroup) {
    return;
  }
  var elDisplayable = el;
  var currentZ = seriesModel.currentZ;
  var currentZLevel = seriesModel.currentZLevel;
  elDisplayable.z = currentZ;
  elDisplayable.zlevel = currentZLevel;
  var optZ2 = elOption.z2;
  optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  for (var i = 0; i < STATES.length; i++) {
    updateZForEachState(elDisplayable, elOption, STATES[i]);
  }
}
function updateZForEachState(elDisplayable, elOption, state) {
  var isNormal = state === NORMAL;
  var elStateOpt = isNormal ? elOption : retrieveStateOption(elOption, state);
  var optZ2 = elStateOpt ? elStateOpt.z2 : null;
  var stateObj;
  if (optZ2 != null) {
    stateObj = isNormal ? elDisplayable : elDisplayable.ensureState(state);
    stateObj.z2 = optZ2 || 0;
  }
}
function makeRenderItem(customSeries, data, ecModel, api) {
  var renderItem = customSeries.get("renderItem");
  var coordSys = customSeries.coordinateSystem;
  var prepareResult2 = {};
  if (coordSys) {
    prepareResult2 = coordSys.prepareCustoms ? coordSys.prepareCustoms(coordSys) : prepareCustoms[coordSys.type](coordSys);
  }
  var userAPI = defaults({
    getWidth: api.getWidth,
    getHeight: api.getHeight,
    getZr: api.getZr,
    getDevicePixelRatio: api.getDevicePixelRatio,
    value,
    style,
    ordinalRawValue,
    styleEmphasis,
    visual,
    barLayout,
    currentSeriesIndices,
    font
  }, prepareResult2.api || {});
  var userParams = {
    context: {},
    seriesId: customSeries.id,
    seriesName: customSeries.name,
    seriesIndex: customSeries.seriesIndex,
    coordSys: prepareResult2.coordSys,
    dataInsideLength: data.count(),
    encode: wrapEncodeDef(customSeries.getData())
  };
  var currDataIndexInside;
  var currItemModel;
  var currItemStyleModels = {};
  var currLabelModels = {};
  var seriesItemStyleModels = {};
  var seriesLabelModels = {};
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    seriesItemStyleModels[stateName] = customSeries.getModel(PATH_ITEM_STYLE[stateName]);
    seriesLabelModels[stateName] = customSeries.getModel(PATH_LABEL[stateName]);
  }
  function getItemModel2(dataIndexInside) {
    return dataIndexInside === currDataIndexInside ? currItemModel || (currItemModel = data.getItemModel(dataIndexInside)) : data.getItemModel(dataIndexInside);
  }
  function getItemStyleModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesItemStyleModels[state] : dataIndexInside === currDataIndexInside ? currItemStyleModels[state] || (currItemStyleModels[state] = getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state])) : getItemModel2(dataIndexInside).getModel(PATH_ITEM_STYLE[state]);
  }
  function getLabelModel(dataIndexInside, state) {
    return !data.hasItemOption ? seriesLabelModels[state] : dataIndexInside === currDataIndexInside ? currLabelModels[state] || (currLabelModels[state] = getItemModel2(dataIndexInside).getModel(PATH_LABEL[state])) : getItemModel2(dataIndexInside).getModel(PATH_LABEL[state]);
  }
  return function(dataIndexInside, payload) {
    currDataIndexInside = dataIndexInside;
    currItemModel = null;
    currItemStyleModels = {};
    currLabelModels = {};
    return renderItem && renderItem(defaults({
      dataIndexInside,
      dataIndex: data.getRawIndex(dataIndexInside),
      actionType: payload ? payload.type : null
    }, userParams), userAPI);
  };
  function value(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    return data.getStore().get(data.getDimensionIndex(dim || 0), dataIndexInside);
  }
  function ordinalRawValue(dim, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    dim = dim || 0;
    var dimInfo = data.getDimensionInfo(dim);
    if (!dimInfo) {
      var dimIndex = data.getDimensionIndex(dim);
      return dimIndex >= 0 ? data.getStore().get(dimIndex, dataIndexInside) : void 0;
    }
    var val = data.get(dimInfo.name, dataIndexInside);
    var ordinalMeta = dimInfo && dimInfo.ordinalMeta;
    return ordinalMeta ? ordinalMeta.categories[val] : val;
  }
  function style(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var style2 = data.getItemVisual(dataIndexInside, "style");
    var visualColor = style2 && style2.fill;
    var opacity = style2 && style2.opacity;
    var itemStyle = getItemStyleModel(dataIndexInside, NORMAL).getItemStyle();
    visualColor != null && (itemStyle.fill = visualColor);
    opacity != null && (itemStyle.opacity = opacity);
    var opt = {
      inheritColor: isString(visualColor) ? visualColor : "#000"
    };
    var labelModel = getLabelModel(dataIndexInside, NORMAL);
    var textStyle = createTextStyle(labelModel, null, opt, false, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve2(customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, opt, false);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function styleEmphasis(userProps, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    var itemStyle = getItemStyleModel(dataIndexInside, EMPHASIS).getItemStyle();
    var labelModel = getLabelModel(dataIndexInside, EMPHASIS);
    var textStyle = createTextStyle(labelModel, null, null, true, true);
    textStyle.text = labelModel.getShallow("show") ? retrieve3(customSeries.getFormattedLabel(dataIndexInside, EMPHASIS), customSeries.getFormattedLabel(dataIndexInside, NORMAL), getDefaultLabel(data, dataIndexInside)) : null;
    var textConfig = createTextConfig(labelModel, null, true);
    preFetchFromExtra(userProps, itemStyle);
    itemStyle = convertToEC4StyleForCustomSerise(itemStyle, textStyle, textConfig);
    userProps && applyUserPropsAfter(itemStyle, userProps);
    itemStyle.legacy = true;
    return itemStyle;
  }
  function applyUserPropsAfter(itemStyle, extra) {
    for (var key in extra) {
      if (hasOwn(extra, key)) {
        itemStyle[key] = extra[key];
      }
    }
  }
  function preFetchFromExtra(extra, itemStyle) {
    if (extra) {
      extra.textFill && (itemStyle.textFill = extra.textFill);
      extra.textPosition && (itemStyle.textPosition = extra.textPosition);
    }
  }
  function visual(visualType, dataIndexInside) {
    dataIndexInside == null && (dataIndexInside = currDataIndexInside);
    if (hasOwn(STYLE_VISUAL_TYPE, visualType)) {
      var style_1 = data.getItemVisual(dataIndexInside, "style");
      return style_1 ? style_1[STYLE_VISUAL_TYPE[visualType]] : null;
    }
    if (hasOwn(NON_STYLE_VISUAL_PROPS, visualType)) {
      return data.getItemVisual(dataIndexInside, visualType);
    }
  }
  function barLayout(opt) {
    if (coordSys.type === "cartesian2d") {
      var baseAxis = coordSys.getBaseAxis();
      return getLayoutOnAxis(defaults({
        axis: baseAxis
      }, opt));
    }
  }
  function currentSeriesIndices() {
    return ecModel.getCurrentSeriesIndices();
  }
  function font(opt) {
    return getFont(opt, ecModel);
  }
}
function wrapEncodeDef(data) {
  var encodeDef = {};
  each$f(data.dimensions, function(dimName) {
    var dimInfo = data.getDimensionInfo(dimName);
    if (!dimInfo.isExtraCoord) {
      var coordDim = dimInfo.coordDim;
      var dataDims = encodeDef[coordDim] = encodeDef[coordDim] || [];
      dataDims[dimInfo.coordDimIndex] = data.getDimensionIndex(dimName);
    }
  });
  return encodeDef;
}
function createOrUpdateItem(api, existsEl, dataIndex, elOption, seriesModel, group, data) {
  if (!elOption) {
    group.remove(existsEl);
    return;
  }
  var el = doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group);
  el && data.setItemGraphicEl(dataIndex, el);
  el && toggleHoverEmphasis(el, elOption.focus, elOption.blurScope, elOption.emphasisDisabled);
  return el;
}
function doCreateOrUpdateEl(api, existsEl, dataIndex, elOption, seriesModel, group) {
  var toBeReplacedIdx = -1;
  var oldEl = existsEl;
  if (existsEl && doesElNeedRecreate(existsEl, elOption, seriesModel)) {
    toBeReplacedIdx = indexOf(group.childrenRef(), existsEl);
    existsEl = null;
  }
  var isInit = !existsEl;
  var el = existsEl;
  if (!el) {
    el = createEl$1(elOption);
    if (oldEl) {
      copyElement(oldEl, el);
    }
  } else {
    el.clearStates();
  }
  if (elOption.morph === false) {
    el.disableMorphing = true;
  } else if (el.disableMorphing) {
    el.disableMorphing = false;
  }
  attachedTxInfoTmp.normal.cfg = attachedTxInfoTmp.normal.conOpt = attachedTxInfoTmp.emphasis.cfg = attachedTxInfoTmp.emphasis.conOpt = attachedTxInfoTmp.blur.cfg = attachedTxInfoTmp.blur.conOpt = attachedTxInfoTmp.select.cfg = attachedTxInfoTmp.select.conOpt = null;
  attachedTxInfoTmp.isLegacy = false;
  doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfoTmp);
  doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit);
  updateElNormal(api, el, dataIndex, elOption, attachedTxInfoTmp, seriesModel, isInit);
  hasOwn(elOption, "info") && (customInnerStore(el).info = elOption.info);
  for (var i = 0; i < STATES.length; i++) {
    var stateName = STATES[i];
    if (stateName !== NORMAL) {
      var otherStateOpt = retrieveStateOption(elOption, stateName);
      var otherStyleOpt = retrieveStyleOptionOnState(elOption, otherStateOpt, stateName);
      updateElOnState(stateName, el, otherStateOpt, otherStyleOpt, attachedTxInfoTmp);
    }
  }
  updateZ(el, elOption, seriesModel);
  if (elOption.type === "group") {
    mergeChildren(api, el, dataIndex, elOption, seriesModel);
  }
  if (toBeReplacedIdx >= 0) {
    group.replaceAt(el, toBeReplacedIdx);
  } else {
    group.add(el);
  }
  return el;
}
function doesElNeedRecreate(el, elOption, seriesModel) {
  var elInner = customInnerStore(el);
  var elOptionType = elOption.type;
  var elOptionShape = elOption.shape;
  var elOptionStyle = elOption.style;
  return seriesModel.isUniversalTransitionEnabled() || elOptionType != null && elOptionType !== elInner.customGraphicType || elOptionType === "path" && hasOwnPathData(elOptionShape) && getPathData(elOptionShape) !== elInner.customPathData || elOptionType === "image" && hasOwn(elOptionStyle, "image") && elOptionStyle.image !== elInner.customImagePath;
}
function doCreateOrUpdateClipPath(el, dataIndex, elOption, seriesModel, isInit) {
  var clipPathOpt = elOption.clipPath;
  if (clipPathOpt === false) {
    if (el && el.getClipPath()) {
      el.removeClipPath();
    }
  } else if (clipPathOpt) {
    var clipPath = el.getClipPath();
    if (clipPath && doesElNeedRecreate(clipPath, clipPathOpt, seriesModel)) {
      clipPath = null;
    }
    if (!clipPath) {
      clipPath = createEl$1(clipPathOpt);
      el.setClipPath(clipPath);
    }
    updateElNormal(null, clipPath, dataIndex, clipPathOpt, null, seriesModel, isInit);
  }
}
function doCreateOrUpdateAttachedTx(el, dataIndex, elOption, seriesModel, isInit, attachedTxInfo) {
  if (el.isGroup) {
    return;
  }
  processTxInfo(elOption, null, attachedTxInfo);
  processTxInfo(elOption, EMPHASIS, attachedTxInfo);
  var txConOptNormal = attachedTxInfo.normal.conOpt;
  var txConOptEmphasis = attachedTxInfo.emphasis.conOpt;
  var txConOptBlur = attachedTxInfo.blur.conOpt;
  var txConOptSelect = attachedTxInfo.select.conOpt;
  if (txConOptNormal != null || txConOptEmphasis != null || txConOptSelect != null || txConOptBlur != null) {
    var textContent = el.getTextContent();
    if (txConOptNormal === false) {
      textContent && el.removeTextContent();
    } else {
      txConOptNormal = attachedTxInfo.normal.conOpt = txConOptNormal || {
        type: "text"
      };
      if (!textContent) {
        textContent = createEl$1(txConOptNormal);
        el.setTextContent(textContent);
      } else {
        textContent.clearStates();
      }
      updateElNormal(null, textContent, dataIndex, txConOptNormal, null, seriesModel, isInit);
      var txConStlOptNormal = txConOptNormal && txConOptNormal.style;
      for (var i = 0; i < STATES.length; i++) {
        var stateName = STATES[i];
        if (stateName !== NORMAL) {
          var txConOptOtherState = attachedTxInfo[stateName].conOpt;
          updateElOnState(stateName, textContent, txConOptOtherState, retrieveStyleOptionOnState(txConOptNormal, txConOptOtherState, stateName), null);
        }
      }
      txConStlOptNormal ? textContent.dirty() : textContent.markRedraw();
    }
  }
}
function processTxInfo(elOption, state, attachedTxInfo) {
  var stateOpt = !state ? elOption : retrieveStateOption(elOption, state);
  var styleOpt = !state ? elOption.style : retrieveStyleOptionOnState(elOption, stateOpt, EMPHASIS);
  var elType = elOption.type;
  var txCfg = stateOpt ? stateOpt.textConfig : null;
  var txConOptNormal = elOption.textContent;
  var txConOpt = !txConOptNormal ? null : !state ? txConOptNormal : retrieveStateOption(txConOptNormal, state);
  if (styleOpt && (attachedTxInfo.isLegacy || isEC4CompatibleStyle(styleOpt, elType, !!txCfg, !!txConOpt))) {
    attachedTxInfo.isLegacy = true;
    var convertResult = convertFromEC4CompatibleStyle(styleOpt, elType, !state);
    if (!txCfg && convertResult.textConfig) {
      txCfg = convertResult.textConfig;
    }
    if (!txConOpt && convertResult.textContent) {
      txConOpt = convertResult.textContent;
    }
  }
  if (!state && txConOpt) {
    var txConOptNormal_1 = txConOpt;
    !txConOptNormal_1.type && (txConOptNormal_1.type = "text");
  }
  var info = !state ? attachedTxInfo.normal : attachedTxInfo[state];
  info.cfg = txCfg;
  info.conOpt = txConOpt;
}
function retrieveStateOption(elOption, state) {
  return !state ? elOption : elOption ? elOption[state] : null;
}
function retrieveStyleOptionOnState(stateOptionNormal, stateOption, state) {
  var style = stateOption && stateOption.style;
  if (style == null && state === EMPHASIS && stateOptionNormal) {
    style = stateOptionNormal.styleEmphasis;
  }
  return style;
}
function mergeChildren(api, el, dataIndex, elOption, seriesModel) {
  var newChildren = elOption.children;
  var newLen = newChildren ? newChildren.length : 0;
  var mergeChildren2 = elOption.$mergeChildren;
  var byName = mergeChildren2 === "byName" || elOption.diffChildrenByName;
  var notMerge = mergeChildren2 === false;
  if (!newLen && !byName && !notMerge) {
    return;
  }
  if (byName) {
    diffGroupChildren({
      api,
      oldChildren: el.children() || [],
      newChildren: newChildren || [],
      dataIndex,
      seriesModel,
      group: el
    });
    return;
  }
  notMerge && el.removeAll();
  var index2 = 0;
  for (; index2 < newLen; index2++) {
    newChildren[index2] && doCreateOrUpdateEl(api, el.childAt(index2), dataIndex, newChildren[index2], seriesModel, el);
  }
  for (var i = el.childCount() - 1; i >= index2; i--) {
    var child = el.childAt(i);
    applyLeaveTransition(child, customInnerStore(el).option, seriesModel);
  }
}
function diffGroupChildren(context) {
  new DataDiffer$1(context.oldChildren, context.newChildren, getKey, getKey, context).add(processAddUpdate).update(processAddUpdate).remove(processRemove).execute();
}
function getKey(item, idx) {
  var name = item && item.name;
  return name != null ? name : GROUP_DIFF_PREFIX + idx;
}
function processAddUpdate(newIndex, oldIndex) {
  var context = this.context;
  var childOption = newIndex != null ? context.newChildren[newIndex] : null;
  var child = oldIndex != null ? context.oldChildren[oldIndex] : null;
  doCreateOrUpdateEl(context.api, child, context.dataIndex, childOption, context.seriesModel, context.group);
}
function processRemove(oldIndex) {
  var context = this.context;
  var child = context.oldChildren[oldIndex];
  applyLeaveTransition(child, customInnerStore(child).option, context.seriesModel);
}
function getPathData(shape) {
  return shape && (shape.pathData || shape.d);
}
function hasOwnPathData(shape) {
  return shape && (hasOwn(shape, "pathData") || hasOwn(shape, "d"));
}
function install$r(registers) {
  registers.registerChartView(CustomChartView$1);
  registers.registerSeriesModel(CustomSeriesModel$1);
}
var inner$b = makeInner();
var clone$1 = clone$4;
var bind = bind$1;
var BaseAxisPointer = function() {
  function BaseAxisPointer2() {
    this._dragging = false;
    this.animationThreshold = 15;
  }
  BaseAxisPointer2.prototype.render = function(axisModel, axisPointerModel, api, forceRender) {
    var value = axisPointerModel.get("value");
    var status = axisPointerModel.get("status");
    this._axisModel = axisModel;
    this._axisPointerModel = axisPointerModel;
    this._api = api;
    if (!forceRender && this._lastValue === value && this._lastStatus === status) {
      return;
    }
    this._lastValue = value;
    this._lastStatus = status;
    var group = this._group;
    var handle = this._handle;
    if (!status || status === "hide") {
      group && group.hide();
      handle && handle.hide();
      return;
    }
    group && group.show();
    handle && handle.show();
    var elOption = {};
    this.makeElOption(elOption, value, axisModel, axisPointerModel, api);
    var graphicKey = elOption.graphicKey;
    if (graphicKey !== this._lastGraphicKey) {
      this.clear(api);
    }
    this._lastGraphicKey = graphicKey;
    var moveAnimation = this._moveAnimation = this.determineAnimation(axisModel, axisPointerModel);
    if (!group) {
      group = this._group = new Group$4();
      this.createPointerEl(group, elOption, axisModel, axisPointerModel);
      this.createLabelEl(group, elOption, axisModel, axisPointerModel);
      api.getZr().add(group);
    } else {
      var doUpdateProps = curry$1(updateProps, axisPointerModel, moveAnimation);
      this.updatePointerEl(group, elOption, doUpdateProps);
      this.updateLabelEl(group, elOption, doUpdateProps, axisPointerModel);
    }
    updateMandatoryProps(group, axisPointerModel, true);
    this._renderHandle(value);
  };
  BaseAxisPointer2.prototype.remove = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.dispose = function(api) {
    this.clear(api);
  };
  BaseAxisPointer2.prototype.determineAnimation = function(axisModel, axisPointerModel) {
    var animation = axisPointerModel.get("animation");
    var axis = axisModel.axis;
    var isCategoryAxis = axis.type === "category";
    var useSnap = axisPointerModel.get("snap");
    if (!useSnap && !isCategoryAxis) {
      return false;
    }
    if (animation === "auto" || animation == null) {
      var animationThreshold = this.animationThreshold;
      if (isCategoryAxis && axis.getBandWidth() > animationThreshold) {
        return true;
      }
      if (useSnap) {
        var seriesDataCount = getAxisInfo$1(axisModel).seriesDataCount;
        var axisExtent = axis.getExtent();
        return Math.abs(axisExtent[0] - axisExtent[1]) / seriesDataCount > animationThreshold;
      }
      return false;
    }
    return animation === true;
  };
  BaseAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
  };
  BaseAxisPointer2.prototype.createPointerEl = function(group, elOption, axisModel, axisPointerModel) {
    var pointerOption = elOption.pointer;
    if (pointerOption) {
      var pointerEl = inner$b(group).pointerEl = new graphic[pointerOption.type](clone$1(elOption.pointer));
      group.add(pointerEl);
    }
  };
  BaseAxisPointer2.prototype.createLabelEl = function(group, elOption, axisModel, axisPointerModel) {
    if (elOption.label) {
      var labelEl = inner$b(group).labelEl = new ZRText$1(clone$1(elOption.label));
      group.add(labelEl);
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype.updatePointerEl = function(group, elOption, updateProps2) {
    var pointerEl = inner$b(group).pointerEl;
    if (pointerEl && elOption.pointer) {
      pointerEl.setStyle(elOption.pointer.style);
      updateProps2(pointerEl, {
        shape: elOption.pointer.shape
      });
    }
  };
  BaseAxisPointer2.prototype.updateLabelEl = function(group, elOption, updateProps2, axisPointerModel) {
    var labelEl = inner$b(group).labelEl;
    if (labelEl) {
      labelEl.setStyle(elOption.label.style);
      updateProps2(labelEl, {
        x: elOption.label.x,
        y: elOption.label.y
      });
      updateLabelShowHide(labelEl, axisPointerModel);
    }
  };
  BaseAxisPointer2.prototype._renderHandle = function(value) {
    if (this._dragging || !this.updateHandleTransform) {
      return;
    }
    var axisPointerModel = this._axisPointerModel;
    var zr = this._api.getZr();
    var handle = this._handle;
    var handleModel = axisPointerModel.getModel("handle");
    var status = axisPointerModel.get("status");
    if (!handleModel.get("show") || !status || status === "hide") {
      handle && zr.remove(handle);
      this._handle = null;
      return;
    }
    var isInit;
    if (!this._handle) {
      isInit = true;
      handle = this._handle = createIcon(handleModel.get("icon"), {
        cursor: "move",
        draggable: true,
        onmousemove: function(e2) {
          stop(e2.event);
        },
        onmousedown: bind(this._onHandleDragMove, this, 0, 0),
        drift: bind(this._onHandleDragMove, this),
        ondragend: bind(this._onHandleDragEnd, this)
      });
      zr.add(handle);
    }
    updateMandatoryProps(handle, axisPointerModel, false);
    handle.setStyle(handleModel.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
    var handleSize = handleModel.get("size");
    if (!isArray$1(handleSize)) {
      handleSize = [handleSize, handleSize];
    }
    handle.scaleX = handleSize[0] / 2;
    handle.scaleY = handleSize[1] / 2;
    createOrUpdate(this, "_doDispatchAxisPointer", handleModel.get("throttle") || 0, "fixRate");
    this._moveHandleToValue(value, isInit);
  };
  BaseAxisPointer2.prototype._moveHandleToValue = function(value, isInit) {
    updateProps(this._axisPointerModel, !isInit && this._moveAnimation, this._handle, getHandleTransProps(this.getHandleTransform(value, this._axisModel, this._axisPointerModel)));
  };
  BaseAxisPointer2.prototype._onHandleDragMove = function(dx, dy) {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    this._dragging = true;
    var trans = this.updateHandleTransform(getHandleTransProps(handle), [dx, dy], this._axisModel, this._axisPointerModel);
    this._payloadInfo = trans;
    handle.stopAnimation();
    handle.attr(getHandleTransProps(trans));
    inner$b(handle).lastProp = null;
    this._doDispatchAxisPointer();
  };
  BaseAxisPointer2.prototype._doDispatchAxisPointer = function() {
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var payloadInfo = this._payloadInfo;
    var axisModel = this._axisModel;
    this._api.dispatchAction({
      type: "updateAxisPointer",
      x: payloadInfo.cursorPoint[0],
      y: payloadInfo.cursorPoint[1],
      tooltipOption: payloadInfo.tooltipOption,
      axesInfo: [{
        axisDim: axisModel.axis.dim,
        axisIndex: axisModel.componentIndex
      }]
    });
  };
  BaseAxisPointer2.prototype._onHandleDragEnd = function() {
    this._dragging = false;
    var handle = this._handle;
    if (!handle) {
      return;
    }
    var value = this._axisPointerModel.get("value");
    this._moveHandleToValue(value);
    this._api.dispatchAction({
      type: "hideTip"
    });
  };
  BaseAxisPointer2.prototype.clear = function(api) {
    this._lastValue = null;
    this._lastStatus = null;
    var zr = api.getZr();
    var group = this._group;
    var handle = this._handle;
    if (zr && group) {
      this._lastGraphicKey = null;
      group && zr.remove(group);
      handle && zr.remove(handle);
      this._group = null;
      this._handle = null;
      this._payloadInfo = null;
    }
    clear$1(this, "_doDispatchAxisPointer");
  };
  BaseAxisPointer2.prototype.doClear = function() {
  };
  BaseAxisPointer2.prototype.buildLabel = function(xy, wh, xDimIndex) {
    xDimIndex = xDimIndex || 0;
    return {
      x: xy[xDimIndex],
      y: xy[1 - xDimIndex],
      width: wh[xDimIndex],
      height: wh[1 - xDimIndex]
    };
  };
  return BaseAxisPointer2;
}();
function updateProps(animationModel, moveAnimation, el, props) {
  if (!propsEqual(inner$b(el).lastProp, props)) {
    inner$b(el).lastProp = props;
    moveAnimation ? updateProps$1(el, props, animationModel) : (el.stopAnimation(), el.attr(props));
  }
}
function propsEqual(lastProps, newProps) {
  if (isObject$4(lastProps) && isObject$4(newProps)) {
    var equals_1 = true;
    each$f(newProps, function(item, key) {
      equals_1 = equals_1 && propsEqual(lastProps[key], item);
    });
    return !!equals_1;
  } else {
    return lastProps === newProps;
  }
}
function updateLabelShowHide(labelEl, axisPointerModel) {
  labelEl[axisPointerModel.get(["label", "show"]) ? "show" : "hide"]();
}
function getHandleTransProps(trans) {
  return {
    x: trans.x || 0,
    y: trans.y || 0,
    rotation: trans.rotation || 0
  };
}
function updateMandatoryProps(group, axisPointerModel, silent) {
  var z2 = axisPointerModel.get("z");
  var zlevel = axisPointerModel.get("zlevel");
  group && group.traverse(function(el) {
    if (el.type !== "group") {
      z2 != null && (el.z = z2);
      zlevel != null && (el.zlevel = zlevel);
      el.silent = silent;
    }
  });
}
var BaseAxisPointer$1 = BaseAxisPointer;
function buildElStyle(axisPointerModel) {
  var axisPointerType = axisPointerModel.get("type");
  var styleModel = axisPointerModel.getModel(axisPointerType + "Style");
  var style;
  if (axisPointerType === "line") {
    style = styleModel.getLineStyle();
    style.fill = null;
  } else if (axisPointerType === "shadow") {
    style = styleModel.getAreaStyle();
    style.stroke = null;
  }
  return style;
}
function buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos) {
  var value = axisPointerModel.get("value");
  var text = getValueLabel(value, axisModel.axis, axisModel.ecModel, axisPointerModel.get("seriesDataIndices"), {
    precision: axisPointerModel.get(["label", "precision"]),
    formatter: axisPointerModel.get(["label", "formatter"])
  });
  var labelModel = axisPointerModel.getModel("label");
  var paddings = normalizeCssArray(labelModel.get("padding") || 0);
  var font = labelModel.getFont();
  var textRect = getBoundingRect(text, font);
  var position2 = labelPos.position;
  var width = textRect.width + paddings[1] + paddings[3];
  var height = textRect.height + paddings[0] + paddings[2];
  var align = labelPos.align;
  align === "right" && (position2[0] -= width);
  align === "center" && (position2[0] -= width / 2);
  var verticalAlign = labelPos.verticalAlign;
  verticalAlign === "bottom" && (position2[1] -= height);
  verticalAlign === "middle" && (position2[1] -= height / 2);
  confineInContainer(position2, width, height, api);
  var bgColor = labelModel.get("backgroundColor");
  if (!bgColor || bgColor === "auto") {
    bgColor = axisModel.get(["axisLine", "lineStyle", "color"]);
  }
  elOption.label = {
    x: position2[0],
    y: position2[1],
    style: createTextStyle(labelModel, {
      text,
      font,
      fill: labelModel.getTextColor(),
      padding: paddings,
      backgroundColor: bgColor
    }),
    z2: 10
  };
}
function confineInContainer(position2, width, height, api) {
  var viewWidth = api.getWidth();
  var viewHeight = api.getHeight();
  position2[0] = Math.min(position2[0] + width, viewWidth) - width;
  position2[1] = Math.min(position2[1] + height, viewHeight) - height;
  position2[0] = Math.max(position2[0], 0);
  position2[1] = Math.max(position2[1], 0);
}
function getValueLabel(value, axis, ecModel, seriesDataIndices, opt) {
  value = axis.scale.parse(value);
  var text = axis.scale.getLabel({
    value
  }, {
    precision: opt.precision
  });
  var formatter = opt.formatter;
  if (formatter) {
    var params_1 = {
      value: getAxisRawValue(axis, {
        value
      }),
      axisDimension: axis.dim,
      axisIndex: axis.index,
      seriesData: []
    };
    each$f(seriesDataIndices, function(idxItem) {
      var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
      var dataIndex = idxItem.dataIndexInside;
      var dataParams = series && series.getDataParams(dataIndex);
      dataParams && params_1.seriesData.push(dataParams);
    });
    if (isString(formatter)) {
      text = formatter.replace("{value}", text);
    } else if (isFunction(formatter)) {
      text = formatter(params_1);
    }
  }
  return text;
}
function getTransformedPosition(axis, value, layoutInfo) {
  var transform2 = create$1();
  rotate(transform2, transform2, layoutInfo.rotation);
  translate(transform2, transform2, layoutInfo.position);
  return applyTransform([axis.dataToCoord(value), (layoutInfo.labelOffset || 0) + (layoutInfo.labelDirection || 1) * (layoutInfo.labelMargin || 0)], transform2);
}
function buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api) {
  var textLayout = AxisBuilder$1.innerTextLayout(layoutInfo.rotation, 0, layoutInfo.labelDirection);
  layoutInfo.labelMargin = axisPointerModel.get(["label", "margin"]);
  buildLabelElOption(elOption, axisModel, axisPointerModel, api, {
    position: getTransformedPosition(axisModel.axis, value, layoutInfo),
    align: textLayout.textAlign,
    verticalAlign: textLayout.textVerticalAlign
  });
}
function makeLineShape(p1, p2, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x1: p1[xDimIndex],
    y1: p1[1 - xDimIndex],
    x2: p2[xDimIndex],
    y2: p2[1 - xDimIndex]
  };
}
function makeRectShape(xy, wh, xDimIndex) {
  xDimIndex = xDimIndex || 0;
  return {
    x: xy[xDimIndex],
    y: xy[1 - xDimIndex],
    width: wh[xDimIndex],
    height: wh[1 - xDimIndex]
  };
}
function makeSectorShape(cx, cy, r0, r2, startAngle, endAngle) {
  return {
    cx,
    cy,
    r0,
    r: r2,
    startAngle,
    endAngle,
    clockwise: true
  };
}
var CartesianAxisPointer = function(_super) {
  __extends(CartesianAxisPointer2, _super);
  function CartesianAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  CartesianAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisPointerType = axisPointerModel.get("type");
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var pixelValue = axis.toGlobalCoord(axis.dataToCoord(value, true));
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$2[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$2(grid.model, axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  CartesianAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$2(axisModel.axis.grid.model, axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var pos = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: pos[0],
      y: pos[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  CartesianAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var grid = axis.grid;
    var axisExtent = axis.getGlobalExtent(true);
    var otherExtent = getCartesian(grid, axis).getOtherAxis(axis).getGlobalExtent();
    var dimIndex = axis.dim === "x" ? 0 : 1;
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    var tooltipOptions = [{
      verticalAlign: "middle"
    }, {
      align: "center"
    }];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: tooltipOptions[dimIndex]
    };
  };
  return CartesianAxisPointer2;
}(BaseAxisPointer$1);
function getCartesian(grid, axis) {
  var opt = {};
  opt[axis.dim + "AxisIndex"] = axis.index;
  return grid.getCartesian(opt);
}
var pointerShapeBuilder$2 = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getAxisDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getAxisDimIndex(axis))
    };
  }
};
function getAxisDimIndex(axis) {
  return axis.dim === "x" ? 0 : 1;
}
var CartesianAxisPointer$1 = CartesianAxisPointer;
var AxisPointerModel = function(_super) {
  __extends(AxisPointerModel2, _super);
  function AxisPointerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerModel2.type;
    return _this;
  }
  AxisPointerModel2.type = "axisPointer";
  AxisPointerModel2.defaultOption = {
    show: "auto",
    z: 50,
    type: "line",
    snap: false,
    triggerTooltip: true,
    value: null,
    status: null,
    link: [],
    animation: null,
    animationDurationUpdate: 200,
    lineStyle: {
      color: "#B9BEC9",
      width: 1,
      type: "dashed"
    },
    shadowStyle: {
      color: "rgba(210,219,238,0.2)"
    },
    label: {
      show: true,
      formatter: null,
      precision: "auto",
      margin: 3,
      color: "#fff",
      padding: [5, 7, 5, 7],
      backgroundColor: "auto",
      borderColor: null,
      borderWidth: 0,
      borderRadius: 3
    },
    handle: {
      show: false,
      icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z",
      size: 45,
      margin: 50,
      color: "#333",
      shadowBlur: 3,
      shadowColor: "#aaa",
      shadowOffsetX: 0,
      shadowOffsetY: 2,
      throttle: 40
    }
  };
  return AxisPointerModel2;
}(ComponentModel$1);
var AxisPointerModel$1 = AxisPointerModel;
var inner$a = makeInner();
var each$8 = each$f;
function register(key, api, handler) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  inner$a(zr).records || (inner$a(zr).records = {});
  initGlobalListeners(zr, api);
  var record = inner$a(zr).records[key] || (inner$a(zr).records[key] = {});
  record.handler = handler;
}
function initGlobalListeners(zr, api) {
  if (inner$a(zr).initialized) {
    return;
  }
  inner$a(zr).initialized = true;
  useHandler("click", curry$1(doEnter, "click"));
  useHandler("mousemove", curry$1(doEnter, "mousemove"));
  useHandler("globalout", onLeave);
  function useHandler(eventType, cb) {
    zr.on(eventType, function(e2) {
      var dis = makeDispatchAction$1(api);
      each$8(inner$a(zr).records, function(record) {
        record && cb(record, e2, dis.dispatchAction);
      });
      dispatchTooltipFinally(dis.pendings, api);
    });
  }
}
function dispatchTooltipFinally(pendings, api) {
  var showLen = pendings.showTip.length;
  var hideLen = pendings.hideTip.length;
  var actuallyPayload;
  if (showLen) {
    actuallyPayload = pendings.showTip[showLen - 1];
  } else if (hideLen) {
    actuallyPayload = pendings.hideTip[hideLen - 1];
  }
  if (actuallyPayload) {
    actuallyPayload.dispatchAction = null;
    api.dispatchAction(actuallyPayload);
  }
}
function onLeave(record, e2, dispatchAction2) {
  record.handler("leave", null, dispatchAction2);
}
function doEnter(currTrigger, record, e2, dispatchAction2) {
  record.handler(currTrigger, e2, dispatchAction2);
}
function makeDispatchAction$1(api) {
  var pendings = {
    showTip: [],
    hideTip: []
  };
  var dispatchAction2 = function(payload) {
    var pendingList = pendings[payload.type];
    if (pendingList) {
      pendingList.push(payload);
    } else {
      payload.dispatchAction = dispatchAction2;
      api.dispatchAction(payload);
    }
  };
  return {
    dispatchAction: dispatchAction2,
    pendings
  };
}
function unregister(key, api) {
  if (env$1.node) {
    return;
  }
  var zr = api.getZr();
  var record = (inner$a(zr).records || {})[key];
  if (record) {
    inner$a(zr).records[key] = null;
  }
}
var AxisPointerView = function(_super) {
  __extends(AxisPointerView2, _super);
  function AxisPointerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AxisPointerView2.type;
    return _this;
  }
  AxisPointerView2.prototype.render = function(globalAxisPointerModel, ecModel, api) {
    var globalTooltipModel = ecModel.getComponent("tooltip");
    var triggerOn = globalAxisPointerModel.get("triggerOn") || globalTooltipModel && globalTooltipModel.get("triggerOn") || "mousemove|click";
    register("axisPointer", api, function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none" && (currTrigger === "leave" || triggerOn.indexOf(currTrigger) >= 0)) {
        dispatchAction2({
          type: "updateAxisPointer",
          currTrigger,
          x: e2 && e2.offsetX,
          y: e2 && e2.offsetY
        });
      }
    });
  };
  AxisPointerView2.prototype.remove = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.prototype.dispose = function(ecModel, api) {
    unregister("axisPointer", api);
  };
  AxisPointerView2.type = "axisPointer";
  return AxisPointerView2;
}(ComponentView$1);
var AxisPointerView$1 = AxisPointerView;
function findPointFromSeries(finder, ecModel) {
  var point = [];
  var seriesIndex = finder.seriesIndex;
  var seriesModel;
  if (seriesIndex == null || !(seriesModel = ecModel.getSeriesByIndex(seriesIndex))) {
    return {
      point: []
    };
  }
  var data = seriesModel.getData();
  var dataIndex = queryDataIndex(data, finder);
  if (dataIndex == null || dataIndex < 0 || isArray$1(dataIndex)) {
    return {
      point: []
    };
  }
  var el = data.getItemGraphicEl(dataIndex);
  var coordSys = seriesModel.coordinateSystem;
  if (seriesModel.getTooltipPosition) {
    point = seriesModel.getTooltipPosition(dataIndex) || [];
  } else if (coordSys && coordSys.dataToPoint) {
    if (finder.isStacked) {
      var baseAxis = coordSys.getBaseAxis();
      var valueAxis2 = coordSys.getOtherAxis(baseAxis);
      var valueAxisDim = valueAxis2.dim;
      var baseAxisDim = baseAxis.dim;
      var baseDataOffset = valueAxisDim === "x" || valueAxisDim === "radius" ? 1 : 0;
      var baseDim = data.mapDimension(baseAxisDim);
      var stackedData = [];
      stackedData[baseDataOffset] = data.get(baseDim, dataIndex);
      stackedData[1 - baseDataOffset] = data.get(data.getCalculationInfo("stackResultDimension"), dataIndex);
      point = coordSys.dataToPoint(stackedData) || [];
    } else {
      point = coordSys.dataToPoint(data.getValues(map$1(coordSys.dimensions, function(dim) {
        return data.mapDimension(dim);
      }), dataIndex)) || [];
    }
  } else if (el) {
    var rect = el.getBoundingRect().clone();
    rect.applyTransform(el.transform);
    point = [rect.x + rect.width / 2, rect.y + rect.height / 2];
  }
  return {
    point,
    el
  };
}
var inner$9 = makeInner();
function axisTrigger(payload, ecModel, api) {
  var currTrigger = payload.currTrigger;
  var point = [payload.x, payload.y];
  var finder = payload;
  var dispatchAction2 = payload.dispatchAction || bind$1(api.dispatchAction, api);
  var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
  if (!coordSysAxesInfo) {
    return;
  }
  if (illegalPoint(point)) {
    point = findPointFromSeries({
      seriesIndex: finder.seriesIndex,
      dataIndex: finder.dataIndex
    }, ecModel).point;
  }
  var isIllegalPoint = illegalPoint(point);
  var inputAxesInfo = finder.axesInfo;
  var axesInfo = coordSysAxesInfo.axesInfo;
  var shouldHide = currTrigger === "leave" || illegalPoint(point);
  var outputPayload = {};
  var showValueMap = {};
  var dataByCoordSys = {
    list: [],
    map: {}
  };
  var updaters = {
    showPointer: curry$1(showPointer, showValueMap),
    showTooltip: curry$1(showTooltip, dataByCoordSys)
  };
  each$f(coordSysAxesInfo.coordSysMap, function(coordSys, coordSysKey) {
    var coordSysContainsPoint = isIllegalPoint || coordSys.containPoint(point);
    each$f(coordSysAxesInfo.coordSysAxesInfo[coordSysKey], function(axisInfo, key) {
      var axis = axisInfo.axis;
      var inputAxisInfo = findInputAxisInfo(inputAxesInfo, axisInfo);
      if (!shouldHide && coordSysContainsPoint && (!inputAxesInfo || inputAxisInfo)) {
        var val = inputAxisInfo && inputAxisInfo.value;
        if (val == null && !isIllegalPoint) {
          val = axis.pointToData(point);
        }
        val != null && processOnAxis(axisInfo, val, updaters, false, outputPayload);
      }
    });
  });
  var linkTriggers = {};
  each$f(axesInfo, function(tarAxisInfo, tarKey) {
    var linkGroup = tarAxisInfo.linkGroup;
    if (linkGroup && !showValueMap[tarKey]) {
      each$f(linkGroup.axesInfo, function(srcAxisInfo, srcKey) {
        var srcValItem = showValueMap[srcKey];
        if (srcAxisInfo !== tarAxisInfo && srcValItem) {
          var val = srcValItem.value;
          linkGroup.mapper && (val = tarAxisInfo.axis.scale.parse(linkGroup.mapper(val, makeMapperParam(srcAxisInfo), makeMapperParam(tarAxisInfo))));
          linkTriggers[tarAxisInfo.key] = val;
        }
      });
    }
  });
  each$f(linkTriggers, function(val, tarKey) {
    processOnAxis(axesInfo[tarKey], val, updaters, true, outputPayload);
  });
  updateModelActually(showValueMap, axesInfo, outputPayload);
  dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2);
  dispatchHighDownActually(axesInfo, dispatchAction2, api);
  return outputPayload;
}
function processOnAxis(axisInfo, newValue, updaters, noSnap, outputFinder) {
  var axis = axisInfo.axis;
  if (axis.scale.isBlank() || !axis.containData(newValue)) {
    return;
  }
  if (!axisInfo.involveSeries) {
    updaters.showPointer(axisInfo, newValue);
    return;
  }
  var payloadInfo = buildPayloadsBySeries(newValue, axisInfo);
  var payloadBatch = payloadInfo.payloadBatch;
  var snapToValue = payloadInfo.snapToValue;
  if (payloadBatch[0] && outputFinder.seriesIndex == null) {
    extend(outputFinder, payloadBatch[0]);
  }
  if (!noSnap && axisInfo.snap) {
    if (axis.containData(snapToValue) && snapToValue != null) {
      newValue = snapToValue;
    }
  }
  updaters.showPointer(axisInfo, newValue, payloadBatch);
  updaters.showTooltip(axisInfo, payloadInfo, snapToValue);
}
function buildPayloadsBySeries(value, axisInfo) {
  var axis = axisInfo.axis;
  var dim = axis.dim;
  var snapToValue = value;
  var payloadBatch = [];
  var minDist = Number.MAX_VALUE;
  var minDiff = -1;
  each$f(axisInfo.seriesModels, function(series, idx) {
    var dataDim = series.getData().mapDimensionsAll(dim);
    var seriesNestestValue;
    var dataIndices;
    if (series.getAxisTooltipData) {
      var result = series.getAxisTooltipData(dataDim, value, axis);
      dataIndices = result.dataIndices;
      seriesNestestValue = result.nestestValue;
    } else {
      dataIndices = series.getData().indicesOfNearest(dataDim[0], value, axis.type === "category" ? 0.5 : null);
      if (!dataIndices.length) {
        return;
      }
      seriesNestestValue = series.getData().get(dataDim[0], dataIndices[0]);
    }
    if (seriesNestestValue == null || !isFinite(seriesNestestValue)) {
      return;
    }
    var diff = value - seriesNestestValue;
    var dist2 = Math.abs(diff);
    if (dist2 <= minDist) {
      if (dist2 < minDist || diff >= 0 && minDiff < 0) {
        minDist = dist2;
        minDiff = diff;
        snapToValue = seriesNestestValue;
        payloadBatch.length = 0;
      }
      each$f(dataIndices, function(dataIndex) {
        payloadBatch.push({
          seriesIndex: series.seriesIndex,
          dataIndexInside: dataIndex,
          dataIndex: series.getData().getRawIndex(dataIndex)
        });
      });
    }
  });
  return {
    payloadBatch,
    snapToValue
  };
}
function showPointer(showValueMap, axisInfo, value, payloadBatch) {
  showValueMap[axisInfo.key] = {
    value,
    payloadBatch
  };
}
function showTooltip(dataByCoordSys, axisInfo, payloadInfo, value) {
  var payloadBatch = payloadInfo.payloadBatch;
  var axis = axisInfo.axis;
  var axisModel = axis.model;
  var axisPointerModel = axisInfo.axisPointerModel;
  if (!axisInfo.triggerTooltip || !payloadBatch.length) {
    return;
  }
  var coordSysModel = axisInfo.coordSys.model;
  var coordSysKey = makeKey(coordSysModel);
  var coordSysItem = dataByCoordSys.map[coordSysKey];
  if (!coordSysItem) {
    coordSysItem = dataByCoordSys.map[coordSysKey] = {
      coordSysId: coordSysModel.id,
      coordSysIndex: coordSysModel.componentIndex,
      coordSysType: coordSysModel.type,
      coordSysMainType: coordSysModel.mainType,
      dataByAxis: []
    };
    dataByCoordSys.list.push(coordSysItem);
  }
  coordSysItem.dataByAxis.push({
    axisDim: axis.dim,
    axisIndex: axisModel.componentIndex,
    axisType: axisModel.type,
    axisId: axisModel.id,
    value,
    valueLabelOpt: {
      precision: axisPointerModel.get(["label", "precision"]),
      formatter: axisPointerModel.get(["label", "formatter"])
    },
    seriesDataIndices: payloadBatch.slice()
  });
}
function updateModelActually(showValueMap, axesInfo, outputPayload) {
  var outputAxesInfo = outputPayload.axesInfo = [];
  each$f(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    var valItem = showValueMap[key];
    if (valItem) {
      !axisInfo.useHandle && (option.status = "show");
      option.value = valItem.value;
      option.seriesDataIndices = (valItem.payloadBatch || []).slice();
    } else {
      !axisInfo.useHandle && (option.status = "hide");
    }
    option.status === "show" && outputAxesInfo.push({
      axisDim: axisInfo.axis.dim,
      axisIndex: axisInfo.axis.model.componentIndex,
      value: option.value
    });
  });
}
function dispatchTooltipActually(dataByCoordSys, point, payload, dispatchAction2) {
  if (illegalPoint(point) || !dataByCoordSys.list.length) {
    dispatchAction2({
      type: "hideTip"
    });
    return;
  }
  var sampleItem = ((dataByCoordSys.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
  dispatchAction2({
    type: "showTip",
    escapeConnect: true,
    x: point[0],
    y: point[1],
    tooltipOption: payload.tooltipOption,
    position: payload.position,
    dataIndexInside: sampleItem.dataIndexInside,
    dataIndex: sampleItem.dataIndex,
    seriesIndex: sampleItem.seriesIndex,
    dataByCoordSys: dataByCoordSys.list
  });
}
function dispatchHighDownActually(axesInfo, dispatchAction2, api) {
  var zr = api.getZr();
  var highDownKey = "axisPointerLastHighlights";
  var lastHighlights = inner$9(zr)[highDownKey] || {};
  var newHighlights = inner$9(zr)[highDownKey] = {};
  each$f(axesInfo, function(axisInfo, key) {
    var option = axisInfo.axisPointerModel.option;
    option.status === "show" && each$f(option.seriesDataIndices, function(batchItem) {
      var key2 = batchItem.seriesIndex + " | " + batchItem.dataIndex;
      newHighlights[key2] = batchItem;
    });
  });
  var toHighlight = [];
  var toDownplay = [];
  each$f(lastHighlights, function(batchItem, key) {
    !newHighlights[key] && toDownplay.push(batchItem);
  });
  each$f(newHighlights, function(batchItem, key) {
    !lastHighlights[key] && toHighlight.push(batchItem);
  });
  toDownplay.length && api.dispatchAction({
    type: "downplay",
    escapeConnect: true,
    notBlur: true,
    batch: toDownplay
  });
  toHighlight.length && api.dispatchAction({
    type: "highlight",
    escapeConnect: true,
    notBlur: true,
    batch: toHighlight
  });
}
function findInputAxisInfo(inputAxesInfo, axisInfo) {
  for (var i = 0; i < (inputAxesInfo || []).length; i++) {
    var inputAxisInfo = inputAxesInfo[i];
    if (axisInfo.axis.dim === inputAxisInfo.axisDim && axisInfo.axis.model.componentIndex === inputAxisInfo.axisIndex) {
      return inputAxisInfo;
    }
  }
}
function makeMapperParam(axisInfo) {
  var axisModel = axisInfo.axis.model;
  var item = {};
  var dim = item.axisDim = axisInfo.axis.dim;
  item.axisIndex = item[dim + "AxisIndex"] = axisModel.componentIndex;
  item.axisName = item[dim + "AxisName"] = axisModel.name;
  item.axisId = item[dim + "AxisId"] = axisModel.id;
  return item;
}
function illegalPoint(point) {
  return !point || point[0] == null || isNaN(point[0]) || point[1] == null || isNaN(point[1]);
}
function install$q(registers) {
  AxisView$1.registerAxisPointerClass("CartesianAxisPointer", CartesianAxisPointer$1);
  registers.registerComponentModel(AxisPointerModel$1);
  registers.registerComponentView(AxisPointerView$1);
  registers.registerPreprocessor(function(option) {
    if (option) {
      (!option.axisPointer || option.axisPointer.length === 0) && (option.axisPointer = {});
      var link = option.axisPointer.link;
      if (link && !isArray$1(link)) {
        option.axisPointer.link = [link];
      }
    }
  });
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.STATISTIC, function(ecModel, api) {
    ecModel.getComponent("axisPointer").coordSysAxesInfo = collect(ecModel, api);
  });
  registers.registerAction({
    type: "updateAxisPointer",
    event: "updateAxisPointer",
    update: ":updateAxisPointer"
  }, axisTrigger);
}
function install$p(registers) {
  use(install$N);
  use(install$q);
}
var PolarAxisPointer = function(_super) {
  __extends(PolarAxisPointer2, _super);
  function PolarAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    if (axis.dim === "angle") {
      this.animationThreshold = Math.PI / 18;
    }
    var polar = axis.polar;
    var otherAxis = polar.getOtherAxis(axis);
    var otherExtent = otherAxis.getExtent();
    var coordValue = axis.dataToCoord(value);
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder$1[axisPointerType](axis, polar, coordValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var labelMargin = axisPointerModel.get(["label", "margin"]);
    var labelPos = getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin);
    buildLabelElOption(elOption, axisModel, axisPointerModel, api, labelPos);
  };
  return PolarAxisPointer2;
}(BaseAxisPointer$1);
function getLabelPosition(value, axisModel, axisPointerModel, polar, labelMargin) {
  var axis = axisModel.axis;
  var coord = axis.dataToCoord(value);
  var axisAngle = polar.getAngleAxis().getExtent()[0];
  axisAngle = axisAngle / 180 * Math.PI;
  var radiusExtent = polar.getRadiusAxis().getExtent();
  var position2;
  var align;
  var verticalAlign;
  if (axis.dim === "radius") {
    var transform2 = create$1();
    rotate(transform2, transform2, axisAngle);
    translate(transform2, transform2, [polar.cx, polar.cy]);
    position2 = applyTransform([coord, -labelMargin], transform2);
    var labelRotation = axisModel.getModel("axisLabel").get("rotate") || 0;
    var labelLayout2 = AxisBuilder$1.innerTextLayout(axisAngle, labelRotation * Math.PI / 180, -1);
    align = labelLayout2.textAlign;
    verticalAlign = labelLayout2.textVerticalAlign;
  } else {
    var r2 = radiusExtent[1];
    position2 = polar.coordToPoint([r2 + labelMargin, coord]);
    var cx = polar.cx;
    var cy = polar.cy;
    align = Math.abs(position2[0] - cx) / r2 < 0.3 ? "center" : position2[0] > cx ? "left" : "right";
    verticalAlign = Math.abs(position2[1] - cy) / r2 < 0.3 ? "middle" : position2[1] > cy ? "top" : "bottom";
  }
  return {
    position: position2,
    align,
    verticalAlign
  };
}
var pointerShapeBuilder$1 = {
  line: function(axis, polar, coordValue, otherExtent) {
    return axis.dim === "angle" ? {
      type: "Line",
      shape: makeLineShape(polar.coordToPoint([otherExtent[0], coordValue]), polar.coordToPoint([otherExtent[1], coordValue]))
    } : {
      type: "Circle",
      shape: {
        cx: polar.cx,
        cy: polar.cy,
        r: coordValue
      }
    };
  },
  shadow: function(axis, polar, coordValue, otherExtent) {
    var bandWidth = Math.max(1, axis.getBandWidth());
    var radian = Math.PI / 180;
    return axis.dim === "angle" ? {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, otherExtent[0], otherExtent[1], (-coordValue - bandWidth / 2) * radian, (-coordValue + bandWidth / 2) * radian)
    } : {
      type: "Sector",
      shape: makeSectorShape(polar.cx, polar.cy, coordValue - bandWidth / 2, coordValue + bandWidth / 2, 0, Math.PI * 2)
    };
  }
};
var PolarAxisPointer$1 = PolarAxisPointer;
var PolarModel = function(_super) {
  __extends(PolarModel2, _super);
  function PolarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarModel2.type;
    return _this;
  }
  PolarModel2.prototype.findAxisModel = function(axisType) {
    var foundAxisModel;
    var ecModel = this.ecModel;
    ecModel.eachComponent(axisType, function(axisModel) {
      if (axisModel.getCoordSysModel() === this) {
        foundAxisModel = axisModel;
      }
    }, this);
    return foundAxisModel;
  };
  PolarModel2.type = "polar";
  PolarModel2.dependencies = ["radiusAxis", "angleAxis"];
  PolarModel2.defaultOption = {
    z: 0,
    center: ["50%", "50%"],
    radius: "80%"
  };
  return PolarModel2;
}(ComponentModel$1);
var PolarModel$1 = PolarModel;
var PolarAxisModel = function(_super) {
  __extends(PolarAxisModel2, _super);
  function PolarAxisModel2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  PolarAxisModel2.prototype.getCoordSysModel = function() {
    return this.getReferringComponents("polar", SINGLE_REFERRING).models[0];
  };
  PolarAxisModel2.type = "polarAxis";
  return PolarAxisModel2;
}(ComponentModel$1);
mixin(PolarAxisModel, AxisModelCommonMixin);
var AngleAxisModel = function(_super) {
  __extends(AngleAxisModel2, _super);
  function AngleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisModel2.type;
    return _this;
  }
  AngleAxisModel2.type = "angleAxis";
  return AngleAxisModel2;
}(PolarAxisModel);
var RadiusAxisModel = function(_super) {
  __extends(RadiusAxisModel2, _super);
  function RadiusAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisModel2.type;
    return _this;
  }
  RadiusAxisModel2.type = "radiusAxis";
  return RadiusAxisModel2;
}(PolarAxisModel);
var RadiusAxis = function(_super) {
  __extends(RadiusAxis2, _super);
  function RadiusAxis2(scale2, radiusExtent) {
    return _super.call(this, "radius", scale2, radiusExtent) || this;
  }
  RadiusAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  return RadiusAxis2;
}(Axis$1);
RadiusAxis.prototype.dataToRadius = Axis$1.prototype.dataToCoord;
RadiusAxis.prototype.radiusToData = Axis$1.prototype.coordToData;
var RadiusAxis$1 = RadiusAxis;
var inner$8 = makeInner();
var AngleAxis = function(_super) {
  __extends(AngleAxis2, _super);
  function AngleAxis2(scale2, angleExtent) {
    return _super.call(this, "angle", scale2, angleExtent || [0, 360]) || this;
  }
  AngleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.polar.pointToData(point, clamp2)[this.dim === "radius" ? 0 : 1];
  };
  AngleAxis2.prototype.calculateCategoryInterval = function() {
    var axis = this;
    var labelModel = axis.getLabelModel();
    var ordinalScale = axis.scale;
    var ordinalExtent = ordinalScale.getExtent();
    var tickCount = ordinalScale.count();
    if (ordinalExtent[1] - ordinalExtent[0] < 1) {
      return 0;
    }
    var tickValue = ordinalExtent[0];
    var unitSpan = axis.dataToCoord(tickValue + 1) - axis.dataToCoord(tickValue);
    var unitH = Math.abs(unitSpan);
    var rect = getBoundingRect(tickValue == null ? "" : tickValue + "", labelModel.getFont(), "center", "top");
    var maxH = Math.max(rect.height, 7);
    var dh = maxH / unitH;
    isNaN(dh) && (dh = Infinity);
    var interval = Math.max(0, Math.floor(dh));
    var cache = inner$8(axis.model);
    var lastAutoInterval = cache.lastAutoInterval;
    var lastTickCount = cache.lastTickCount;
    if (lastAutoInterval != null && lastTickCount != null && Math.abs(lastAutoInterval - interval) <= 1 && Math.abs(lastTickCount - tickCount) <= 1 && lastAutoInterval > interval) {
      interval = lastAutoInterval;
    } else {
      cache.lastTickCount = tickCount;
      cache.lastAutoInterval = interval;
    }
    return interval;
  };
  return AngleAxis2;
}(Axis$1);
AngleAxis.prototype.dataToAngle = Axis$1.prototype.dataToCoord;
AngleAxis.prototype.angleToData = Axis$1.prototype.coordToData;
var AngleAxis$1 = AngleAxis;
var polarDimensions = ["radius", "angle"];
var Polar = function() {
  function Polar2(name) {
    this.dimensions = polarDimensions;
    this.type = "polar";
    this.cx = 0;
    this.cy = 0;
    this._radiusAxis = new RadiusAxis$1();
    this._angleAxis = new AngleAxis$1();
    this.axisPointerEnabled = true;
    this.name = name || "";
    this._radiusAxis.polar = this._angleAxis.polar = this;
  }
  Polar2.prototype.containPoint = function(point) {
    var coord = this.pointToCoord(point);
    return this._radiusAxis.contain(coord[0]) && this._angleAxis.contain(coord[1]);
  };
  Polar2.prototype.containData = function(data) {
    return this._radiusAxis.containData(data[0]) && this._angleAxis.containData(data[1]);
  };
  Polar2.prototype.getAxis = function(dim) {
    var key = "_" + dim + "Axis";
    return this[key];
  };
  Polar2.prototype.getAxes = function() {
    return [this._radiusAxis, this._angleAxis];
  };
  Polar2.prototype.getAxesByScale = function(scaleType) {
    var axes = [];
    var angleAxis = this._angleAxis;
    var radiusAxis = this._radiusAxis;
    angleAxis.scale.type === scaleType && axes.push(angleAxis);
    radiusAxis.scale.type === scaleType && axes.push(radiusAxis);
    return axes;
  };
  Polar2.prototype.getAngleAxis = function() {
    return this._angleAxis;
  };
  Polar2.prototype.getRadiusAxis = function() {
    return this._radiusAxis;
  };
  Polar2.prototype.getOtherAxis = function(axis) {
    var angleAxis = this._angleAxis;
    return axis === angleAxis ? this._radiusAxis : angleAxis;
  };
  Polar2.prototype.getBaseAxis = function() {
    return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
  };
  Polar2.prototype.getTooltipAxes = function(dim) {
    var baseAxis = dim != null && dim !== "auto" ? this.getAxis(dim) : this.getBaseAxis();
    return {
      baseAxes: [baseAxis],
      otherAxes: [this.getOtherAxis(baseAxis)]
    };
  };
  Polar2.prototype.dataToPoint = function(data, clamp2) {
    return this.coordToPoint([this._radiusAxis.dataToRadius(data[0], clamp2), this._angleAxis.dataToAngle(data[1], clamp2)]);
  };
  Polar2.prototype.pointToData = function(point, clamp2) {
    var coord = this.pointToCoord(point);
    return [this._radiusAxis.radiusToData(coord[0], clamp2), this._angleAxis.angleToData(coord[1], clamp2)];
  };
  Polar2.prototype.pointToCoord = function(point) {
    var dx = point[0] - this.cx;
    var dy = point[1] - this.cy;
    var angleAxis = this.getAngleAxis();
    var extent3 = angleAxis.getExtent();
    var minAngle = Math.min(extent3[0], extent3[1]);
    var maxAngle = Math.max(extent3[0], extent3[1]);
    angleAxis.inverse ? minAngle = maxAngle - 360 : maxAngle = minAngle + 360;
    var radius = Math.sqrt(dx * dx + dy * dy);
    dx /= radius;
    dy /= radius;
    var radian = Math.atan2(-dy, dx) / Math.PI * 180;
    var dir3 = radian < minAngle ? 1 : -1;
    while (radian < minAngle || radian > maxAngle) {
      radian += dir3 * 360;
    }
    return [radius, radian];
  };
  Polar2.prototype.coordToPoint = function(coord) {
    var radius = coord[0];
    var radian = coord[1] / 180 * Math.PI;
    var x2 = Math.cos(radian) * radius + this.cx;
    var y2 = -Math.sin(radian) * radius + this.cy;
    return [x2, y2];
  };
  Polar2.prototype.getArea = function() {
    var angleAxis = this.getAngleAxis();
    var radiusAxis = this.getRadiusAxis();
    var radiusExtent = radiusAxis.getExtent().slice();
    radiusExtent[0] > radiusExtent[1] && radiusExtent.reverse();
    var angleExtent = angleAxis.getExtent();
    var RADIAN2 = Math.PI / 180;
    return {
      cx: this.cx,
      cy: this.cy,
      r0: radiusExtent[0],
      r: radiusExtent[1],
      startAngle: -angleExtent[0] * RADIAN2,
      endAngle: -angleExtent[1] * RADIAN2,
      clockwise: angleAxis.inverse,
      contain: function(x2, y2) {
        var dx = x2 - this.cx;
        var dy = y2 - this.cy;
        var d2 = dx * dx + dy * dy - 1e-4;
        var r2 = this.r;
        var r0 = this.r0;
        return d2 <= r2 * r2 && d2 >= r0 * r0;
      }
    };
  };
  Polar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Polar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$2(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Polar2;
}();
function getCoordSys$2(finder) {
  var seriesModel = finder.seriesModel;
  var polarModel = finder.polarModel;
  return polarModel && polarModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
var Polar$1 = Polar;
function resizePolar(polar, polarModel, api) {
  var center2 = polarModel.get("center");
  var width = api.getWidth();
  var height = api.getHeight();
  polar.cx = parsePercent(center2[0], width);
  polar.cy = parsePercent(center2[1], height);
  var radiusAxis = polar.getRadiusAxis();
  var size = Math.min(width, height) / 2;
  var radius = polarModel.get("radius");
  if (radius == null) {
    radius = [0, "100%"];
  } else if (!isArray$1(radius)) {
    radius = [0, radius];
  }
  var parsedRadius = [parsePercent(radius[0], size), parsePercent(radius[1], size)];
  radiusAxis.inverse ? radiusAxis.setExtent(parsedRadius[1], parsedRadius[0]) : radiusAxis.setExtent(parsedRadius[0], parsedRadius[1]);
}
function updatePolarScale(ecModel, api) {
  var polar = this;
  var angleAxis = polar.getAngleAxis();
  var radiusAxis = polar.getRadiusAxis();
  angleAxis.scale.setExtent(Infinity, -Infinity);
  radiusAxis.scale.setExtent(Infinity, -Infinity);
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.coordinateSystem === polar) {
      var data_1 = seriesModel.getData();
      each$f(getDataDimensionsOnAxis(data_1, "radius"), function(dim) {
        radiusAxis.scale.unionExtentFromData(data_1, dim);
      });
      each$f(getDataDimensionsOnAxis(data_1, "angle"), function(dim) {
        angleAxis.scale.unionExtentFromData(data_1, dim);
      });
    }
  });
  niceScaleExtent(angleAxis.scale, angleAxis.model);
  niceScaleExtent(radiusAxis.scale, radiusAxis.model);
  if (angleAxis.type === "category" && !angleAxis.onBand) {
    var extent3 = angleAxis.getExtent();
    var diff = 360 / angleAxis.scale.count();
    angleAxis.inverse ? extent3[1] += diff : extent3[1] -= diff;
    angleAxis.setExtent(extent3[0], extent3[1]);
  }
}
function isAngleAxisModel(axisModel) {
  return axisModel.mainType === "angleAxis";
}
function setAxis(axis, axisModel) {
  axis.type = axisModel.get("type");
  axis.scale = createScaleByModel$1(axisModel);
  axis.onBand = axisModel.get("boundaryGap") && axis.type === "category";
  axis.inverse = axisModel.get("inverse");
  if (isAngleAxisModel(axisModel)) {
    axis.inverse = axis.inverse !== axisModel.get("clockwise");
    var startAngle = axisModel.get("startAngle");
    axis.setExtent(startAngle, startAngle + (axis.inverse ? -360 : 360));
  }
  axisModel.axis = axis;
  axis.model = axisModel;
}
var polarCreator = {
  dimensions: polarDimensions,
  create: function(ecModel, api) {
    var polarList = [];
    ecModel.eachComponent("polar", function(polarModel, idx) {
      var polar = new Polar$1(idx + "");
      polar.update = updatePolarScale;
      var radiusAxis = polar.getRadiusAxis();
      var angleAxis = polar.getAngleAxis();
      var radiusAxisModel = polarModel.findAxisModel("radiusAxis");
      var angleAxisModel = polarModel.findAxisModel("angleAxis");
      setAxis(radiusAxis, radiusAxisModel);
      setAxis(angleAxis, angleAxisModel);
      resizePolar(polar, polarModel, api);
      polarList.push(polar);
      polarModel.coordinateSystem = polar;
      polar.model = polarModel;
    });
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.get("coordinateSystem") === "polar") {
        var polarModel = seriesModel.getReferringComponents("polar", SINGLE_REFERRING).models[0];
        seriesModel.coordinateSystem = polarModel.coordinateSystem;
      }
    });
    return polarList;
  }
};
var polarCreator$1 = polarCreator;
var elementList = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
function getAxisLineShape(polar, rExtent, angle) {
  rExtent[1] > rExtent[0] && (rExtent = rExtent.slice().reverse());
  var start2 = polar.coordToPoint([rExtent[0], angle]);
  var end2 = polar.coordToPoint([rExtent[1], angle]);
  return {
    x1: start2[0],
    y1: start2[1],
    x2: end2[0],
    y2: end2[1]
  };
}
function getRadiusIdx(polar) {
  var radiusAxis = polar.getRadiusAxis();
  return radiusAxis.inverse ? 0 : 1;
}
function fixAngleOverlap(list) {
  var firstItem = list[0];
  var lastItem = list[list.length - 1];
  if (firstItem && lastItem && Math.abs(Math.abs(firstItem.coord - lastItem.coord) - 360) < 1e-4) {
    list.pop();
  }
}
var AngleAxisView = function(_super) {
  __extends(AngleAxisView2, _super);
  function AngleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = AngleAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  AngleAxisView2.prototype.render = function(angleAxisModel, ecModel) {
    this.group.removeAll();
    if (!angleAxisModel.get("show")) {
      return;
    }
    var angleAxis = angleAxisModel.axis;
    var polar = angleAxis.polar;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var ticksAngles = angleAxis.getTicksCoords();
    var minorTickAngles = angleAxis.getMinorTicksCoords();
    var labels = map$1(angleAxis.getViewLabels(), function(labelItem) {
      labelItem = clone$4(labelItem);
      var scale2 = angleAxis.scale;
      var tickValue = scale2.type === "ordinal" ? scale2.getRawOrdinalNumber(labelItem.tickValue) : labelItem.tickValue;
      labelItem.coord = angleAxis.dataToCoord(tickValue);
      return labelItem;
    });
    fixAngleOverlap(labels);
    fixAngleOverlap(ticksAngles);
    each$f(elementList, function(name) {
      if (angleAxisModel.get([name, "show"]) && (!angleAxis.scale.isBlank() || name === "axisLine")) {
        angelAxisElementsBuilders[name](this.group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels);
      }
    }, this);
  };
  AngleAxisView2.type = "angleAxis";
  return AngleAxisView2;
}(AxisView$1);
var angelAxisElementsBuilders = {
  axisLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var lineStyleModel = angleAxisModel.getModel(["axisLine", "lineStyle"]);
    var rId = getRadiusIdx(polar);
    var r0Id = rId ? 0 : 1;
    var shape;
    if (radiusExtent[r0Id] === 0) {
      shape = new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    } else {
      shape = new Ring$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: radiusExtent[rId],
          r0: radiusExtent[r0Id]
        },
        style: lineStyleModel.getLineStyle(),
        z2: 1,
        silent: true
      });
    }
    shape.style.fill = null;
    group.add(shape);
  },
  axisTick: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var tickModel = angleAxisModel.getModel("axisTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * tickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = map$1(ticksAngles, function(tickAngleItem) {
      return new Line$3({
        shape: getAxisLineShape(polar, [radius, radius + tickLen], tickAngleItem.coord)
      });
    });
    group.add(mergePath(lines, {
      style: defaults(tickModel.getModel("lineStyle").getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      })
    }));
  },
  minorTick: function(group, angleAxisModel, polar, tickAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var tickModel = angleAxisModel.getModel("axisTick");
    var minorTickModel = angleAxisModel.getModel("minorTick");
    var tickLen = (tickModel.get("inside") ? -1 : 1) * minorTickModel.get("length");
    var radius = radiusExtent[getRadiusIdx(polar)];
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, [radius, radius + tickLen], minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults(minorTickModel.getModel("lineStyle").getLineStyle(), defaults(tickModel.getLineStyle(), {
        stroke: angleAxisModel.get(["axisLine", "lineStyle", "color"])
      }))
    }));
  },
  axisLabel: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent, labels) {
    var rawCategoryData = angleAxisModel.getCategories(true);
    var commonLabelModel = angleAxisModel.getModel("axisLabel");
    var labelMargin = commonLabelModel.get("margin");
    var triggerEvent = angleAxisModel.get("triggerEvent");
    each$f(labels, function(labelItem, idx) {
      var labelModel = commonLabelModel;
      var tickValue = labelItem.tickValue;
      var r2 = radiusExtent[getRadiusIdx(polar)];
      var p2 = polar.coordToPoint([r2 + labelMargin, labelItem.coord]);
      var cx = polar.cx;
      var cy = polar.cy;
      var labelTextAlign = Math.abs(p2[0] - cx) / r2 < 0.3 ? "center" : p2[0] > cx ? "left" : "right";
      var labelTextVerticalAlign = Math.abs(p2[1] - cy) / r2 < 0.3 ? "middle" : p2[1] > cy ? "top" : "bottom";
      if (rawCategoryData && rawCategoryData[tickValue]) {
        var rawCategoryItem = rawCategoryData[tickValue];
        if (isObject$4(rawCategoryItem) && rawCategoryItem.textStyle) {
          labelModel = new Model$1(rawCategoryItem.textStyle, commonLabelModel, commonLabelModel.ecModel);
        }
      }
      var textEl = new ZRText$1({
        silent: AxisBuilder$1.isLabelSilent(angleAxisModel),
        style: createTextStyle(labelModel, {
          x: p2[0],
          y: p2[1],
          fill: labelModel.getTextColor() || angleAxisModel.get(["axisLine", "lineStyle", "color"]),
          text: labelItem.formattedLabel,
          align: labelTextAlign,
          verticalAlign: labelTextVerticalAlign
        })
      });
      group.add(textEl);
      if (triggerEvent) {
        var eventData = AxisBuilder$1.makeAxisEventDataBase(angleAxisModel);
        eventData.targetType = "axisLabel";
        eventData.value = labelItem.rawLabel;
        getECData(textEl).eventData = eventData;
      }
    }, this);
  },
  splitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    var splitLineModel = angleAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksAngles.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        shape: getAxisLineShape(polar, radiusExtent, ticksAngles[i].coord)
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyleModel.getLineStyle()),
        silent: true,
        z: angleAxisModel.get("z")
      }));
    }
  },
  minorSplitLine: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!minorTickAngles.length) {
      return;
    }
    var minorSplitLineModel = angleAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTickAngles.length; i++) {
      for (var k2 = 0; k2 < minorTickAngles[i].length; k2++) {
        lines.push(new Line$3({
          shape: getAxisLineShape(polar, radiusExtent, minorTickAngles[i][k2].coord)
        }));
      }
    }
    group.add(mergePath(lines, {
      style: lineStyleModel.getLineStyle(),
      silent: true,
      z: angleAxisModel.get("z")
    }));
  },
  splitArea: function(group, angleAxisModel, polar, ticksAngles, minorTickAngles, radiusExtent) {
    if (!ticksAngles.length) {
      return;
    }
    var splitAreaModel = angleAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var RADIAN2 = Math.PI / 180;
    var prevAngle = -ticksAngles[0].coord * RADIAN2;
    var r0 = Math.min(radiusExtent[0], radiusExtent[1]);
    var r1 = Math.max(radiusExtent[0], radiusExtent[1]);
    var clockwise = angleAxisModel.get("clockwise");
    for (var i = 1, len2 = ticksAngles.length; i <= len2; i++) {
      var coord = i === len2 ? ticksAngles[0].coord : ticksAngles[i].coord;
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0,
          r: r1,
          startAngle: prevAngle,
          endAngle: -coord * RADIAN2,
          clockwise
        },
        silent: true
      }));
      prevAngle = -coord * RADIAN2;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
var AngleAxisView$1 = AngleAxisView;
var axisBuilderAttrs$1 = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs$1 = ["splitLine", "splitArea", "minorSplitLine"];
var RadiusAxisView = function(_super) {
  __extends(RadiusAxisView2, _super);
  function RadiusAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = RadiusAxisView2.type;
    _this.axisPointerClass = "PolarAxisPointer";
    return _this;
  }
  RadiusAxisView2.prototype.render = function(radiusAxisModel, ecModel) {
    this.group.removeAll();
    if (!radiusAxisModel.get("show")) {
      return;
    }
    var oldAxisGroup = this._axisGroup;
    var newAxisGroup = this._axisGroup = new Group$4();
    this.group.add(newAxisGroup);
    var radiusAxis = radiusAxisModel.axis;
    var polar = radiusAxis.polar;
    var angleAxis = polar.getAngleAxis();
    var ticksCoords = radiusAxis.getTicksCoords();
    var minorTicksCoords = radiusAxis.getMinorTicksCoords();
    var axisAngle = angleAxis.getExtent()[0];
    var radiusExtent = radiusAxis.getExtent();
    var layout2 = layoutAxis(polar, radiusAxisModel, axisAngle);
    var axisBuilder = new AxisBuilder$1(radiusAxisModel, layout2);
    each$f(axisBuilderAttrs$1, axisBuilder.add, axisBuilder);
    newAxisGroup.add(axisBuilder.getGroup());
    groupTransition(oldAxisGroup, newAxisGroup, radiusAxisModel);
    each$f(selfBuilderAttrs$1, function(name) {
      if (radiusAxisModel.get([name, "show"]) && !radiusAxis.scale.isBlank()) {
        axisElementBuilders$1[name](this.group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords);
      }
    }, this);
  };
  RadiusAxisView2.type = "radiusAxis";
  return RadiusAxisView2;
}(AxisView$1);
var axisElementBuilders$1 = {
  splitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    var splitLineModel = radiusAxisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    var lineCount = 0;
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var splitLines = [];
    for (var i = 0; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Circle$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r: ticksCoords[i].coord
        }
      }));
    }
    for (var i = 0; i < splitLines.length; i++) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length],
          fill: null
        }, lineStyleModel.getLineStyle()),
        silent: true
      }));
    }
  },
  minorSplitLine: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords, minorTicksCoords) {
    if (!minorTicksCoords.length) {
      return;
    }
    var minorSplitLineModel = radiusAxisModel.getModel("minorSplitLine");
    var lineStyleModel = minorSplitLineModel.getModel("lineStyle");
    var lines = [];
    for (var i = 0; i < minorTicksCoords.length; i++) {
      for (var k2 = 0; k2 < minorTicksCoords[i].length; k2++) {
        lines.push(new Circle$1({
          shape: {
            cx: polar.cx,
            cy: polar.cy,
            r: minorTicksCoords[i][k2].coord
          }
        }));
      }
    }
    group.add(mergePath(lines, {
      style: defaults({
        fill: null
      }, lineStyleModel.getLineStyle()),
      silent: true
    }));
  },
  splitArea: function(group, radiusAxisModel, polar, axisAngle, radiusExtent, ticksCoords) {
    if (!ticksCoords.length) {
      return;
    }
    var splitAreaModel = radiusAxisModel.getModel("splitArea");
    var areaStyleModel = splitAreaModel.getModel("areaStyle");
    var areaColors = areaStyleModel.get("color");
    var lineCount = 0;
    areaColors = areaColors instanceof Array ? areaColors : [areaColors];
    var splitAreas = [];
    var prevRadius = ticksCoords[0].coord;
    for (var i = 1; i < ticksCoords.length; i++) {
      var colorIndex = lineCount++ % areaColors.length;
      splitAreas[colorIndex] = splitAreas[colorIndex] || [];
      splitAreas[colorIndex].push(new Sector$1({
        shape: {
          cx: polar.cx,
          cy: polar.cy,
          r0: prevRadius,
          r: ticksCoords[i].coord,
          startAngle: 0,
          endAngle: Math.PI * 2
        },
        silent: true
      }));
      prevRadius = ticksCoords[i].coord;
    }
    for (var i = 0; i < splitAreas.length; i++) {
      group.add(mergePath(splitAreas[i], {
        style: defaults({
          fill: areaColors[i % areaColors.length]
        }, areaStyleModel.getAreaStyle()),
        silent: true
      }));
    }
  }
};
function layoutAxis(polar, radiusAxisModel, axisAngle) {
  return {
    position: [polar.cx, polar.cy],
    rotation: axisAngle / 180 * Math.PI,
    labelDirection: -1,
    tickDirection: -1,
    nameDirection: 1,
    labelRotate: radiusAxisModel.getModel("axisLabel").get("rotate"),
    z2: 1
  };
}
var RadiusAxisView$1 = RadiusAxisView;
function getSeriesStackId(seriesModel) {
  return seriesModel.get("stack") || "__ec_stack_" + seriesModel.seriesIndex;
}
function getAxisKey(polar, axis) {
  return axis.dim + polar.model.componentIndex;
}
function barLayoutPolar(seriesType2, ecModel, api) {
  var lastStackCoords = {};
  var barWidthAndOffset = calRadialBar(filter(ecModel.getSeriesByType(seriesType2), function(seriesModel) {
    return !ecModel.isSeriesFiltered(seriesModel) && seriesModel.coordinateSystem && seriesModel.coordinateSystem.type === "polar";
  }));
  ecModel.eachSeriesByType(seriesType2, function(seriesModel) {
    if (seriesModel.coordinateSystem.type !== "polar") {
      return;
    }
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var stackId = getSeriesStackId(seriesModel);
    var columnLayoutInfo = barWidthAndOffset[axisKey][stackId];
    var columnOffset = columnLayoutInfo.offset;
    var columnWidth = columnLayoutInfo.width;
    var valueAxis2 = polar.getOtherAxis(baseAxis);
    var cx = seriesModel.coordinateSystem.cx;
    var cy = seriesModel.coordinateSystem.cy;
    var barMinHeight = seriesModel.get("barMinHeight") || 0;
    var barMinAngle = seriesModel.get("barMinAngle") || 0;
    lastStackCoords[stackId] = lastStackCoords[stackId] || [];
    var valueDim = data.mapDimension(valueAxis2.dim);
    var baseDim = data.mapDimension(baseAxis.dim);
    var stacked = isDimensionStacked(data, valueDim);
    var clampLayout = baseAxis.dim !== "radius" || !seriesModel.get("roundCap", true);
    var valueAxisStart = valueAxis2.dataToCoord(0);
    for (var idx = 0, len2 = data.count(); idx < len2; idx++) {
      var value = data.get(valueDim, idx);
      var baseValue = data.get(baseDim, idx);
      var sign = value >= 0 ? "p" : "n";
      var baseCoord = valueAxisStart;
      if (stacked) {
        if (!lastStackCoords[stackId][baseValue]) {
          lastStackCoords[stackId][baseValue] = {
            p: valueAxisStart,
            n: valueAxisStart
          };
        }
        baseCoord = lastStackCoords[stackId][baseValue][sign];
      }
      var r0 = void 0;
      var r2 = void 0;
      var startAngle = void 0;
      var endAngle = void 0;
      if (valueAxis2.dim === "radius") {
        var radiusSpan = valueAxis2.dataToCoord(value) - valueAxisStart;
        var angle = baseAxis.dataToCoord(baseValue);
        if (Math.abs(radiusSpan) < barMinHeight) {
          radiusSpan = (radiusSpan < 0 ? -1 : 1) * barMinHeight;
        }
        r0 = baseCoord;
        r2 = baseCoord + radiusSpan;
        startAngle = angle - columnOffset;
        endAngle = startAngle - columnWidth;
        stacked && (lastStackCoords[stackId][baseValue][sign] = r2);
      } else {
        var angleSpan = valueAxis2.dataToCoord(value, clampLayout) - valueAxisStart;
        var radius = baseAxis.dataToCoord(baseValue);
        if (Math.abs(angleSpan) < barMinAngle) {
          angleSpan = (angleSpan < 0 ? -1 : 1) * barMinAngle;
        }
        r0 = radius + columnOffset;
        r2 = r0 + columnWidth;
        startAngle = baseCoord;
        endAngle = baseCoord + angleSpan;
        stacked && (lastStackCoords[stackId][baseValue][sign] = endAngle);
      }
      data.setItemLayout(idx, {
        cx,
        cy,
        r0,
        r: r2,
        startAngle: -startAngle * Math.PI / 180,
        endAngle: -endAngle * Math.PI / 180,
        clockwise: startAngle >= endAngle
      });
    }
  });
}
function calRadialBar(barSeries) {
  var columnsMap = {};
  each$f(barSeries, function(seriesModel, idx) {
    var data = seriesModel.getData();
    var polar = seriesModel.coordinateSystem;
    var baseAxis = polar.getBaseAxis();
    var axisKey = getAxisKey(polar, baseAxis);
    var axisExtent = baseAxis.getExtent();
    var bandWidth = baseAxis.type === "category" ? baseAxis.getBandWidth() : Math.abs(axisExtent[1] - axisExtent[0]) / data.count();
    var columnsOnAxis = columnsMap[axisKey] || {
      bandWidth,
      remainedWidth: bandWidth,
      autoWidthCount: 0,
      categoryGap: "20%",
      gap: "30%",
      stacks: {}
    };
    var stacks = columnsOnAxis.stacks;
    columnsMap[axisKey] = columnsOnAxis;
    var stackId = getSeriesStackId(seriesModel);
    if (!stacks[stackId]) {
      columnsOnAxis.autoWidthCount++;
    }
    stacks[stackId] = stacks[stackId] || {
      width: 0,
      maxWidth: 0
    };
    var barWidth = parsePercent(seriesModel.get("barWidth"), bandWidth);
    var barMaxWidth = parsePercent(seriesModel.get("barMaxWidth"), bandWidth);
    var barGap = seriesModel.get("barGap");
    var barCategoryGap = seriesModel.get("barCategoryGap");
    if (barWidth && !stacks[stackId].width) {
      barWidth = Math.min(columnsOnAxis.remainedWidth, barWidth);
      stacks[stackId].width = barWidth;
      columnsOnAxis.remainedWidth -= barWidth;
    }
    barMaxWidth && (stacks[stackId].maxWidth = barMaxWidth);
    barGap != null && (columnsOnAxis.gap = barGap);
    barCategoryGap != null && (columnsOnAxis.categoryGap = barCategoryGap);
  });
  var result = {};
  each$f(columnsMap, function(columnsOnAxis, coordSysName) {
    result[coordSysName] = {};
    var stacks = columnsOnAxis.stacks;
    var bandWidth = columnsOnAxis.bandWidth;
    var categoryGap = parsePercent(columnsOnAxis.categoryGap, bandWidth);
    var barGapPercent = parsePercent(columnsOnAxis.gap, 1);
    var remainedWidth = columnsOnAxis.remainedWidth;
    var autoWidthCount = columnsOnAxis.autoWidthCount;
    var autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    each$f(stacks, function(column, stack) {
      var maxWidth = column.maxWidth;
      if (maxWidth && maxWidth < autoWidth) {
        maxWidth = Math.min(maxWidth, remainedWidth);
        if (column.width) {
          maxWidth = Math.min(maxWidth, column.width);
        }
        remainedWidth -= maxWidth;
        column.width = maxWidth;
        autoWidthCount--;
      }
    });
    autoWidth = (remainedWidth - categoryGap) / (autoWidthCount + (autoWidthCount - 1) * barGapPercent);
    autoWidth = Math.max(autoWidth, 0);
    var widthSum = 0;
    var lastColumn;
    each$f(stacks, function(column, idx) {
      if (!column.width) {
        column.width = autoWidth;
      }
      lastColumn = column;
      widthSum += column.width * (1 + barGapPercent);
    });
    if (lastColumn) {
      widthSum -= lastColumn.width * barGapPercent;
    }
    var offset = -widthSum / 2;
    each$f(stacks, function(column, stackId) {
      result[coordSysName][stackId] = result[coordSysName][stackId] || {
        offset,
        width: column.width
      };
      offset += column.width * (1 + barGapPercent);
    });
  });
  return result;
}
var angleAxisExtraOption = {
  startAngle: 90,
  clockwise: true,
  splitNumber: 12,
  axisLabel: {
    rotate: 0
  }
};
var radiusAxisExtraOption = {
  splitNumber: 5
};
var PolarView = function(_super) {
  __extends(PolarView2, _super);
  function PolarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PolarView2.type;
    return _this;
  }
  PolarView2.type = "polar";
  return PolarView2;
}(ComponentView$1);
function install$o(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("PolarAxisPointer", PolarAxisPointer$1);
  registers.registerCoordinateSystem("polar", polarCreator$1);
  registers.registerComponentModel(PolarModel$1);
  registers.registerComponentView(PolarView);
  axisModelCreator(registers, "angle", AngleAxisModel, angleAxisExtraOption);
  axisModelCreator(registers, "radius", RadiusAxisModel, radiusAxisExtraOption);
  registers.registerComponentView(AngleAxisView$1);
  registers.registerComponentView(RadiusAxisView$1);
  registers.registerLayout(curry$1(barLayoutPolar, "bar"));
}
function layout$1(axisModel, opt) {
  opt = opt || {};
  var single = axisModel.coordinateSystem;
  var axis = axisModel.axis;
  var layout2 = {};
  var axisPosition = axis.position;
  var orient = axis.orient;
  var rect = single.getRect();
  var rectBound = [rect.x, rect.x + rect.width, rect.y, rect.y + rect.height];
  var positionMap = {
    horizontal: {
      top: rectBound[2],
      bottom: rectBound[3]
    },
    vertical: {
      left: rectBound[0],
      right: rectBound[1]
    }
  };
  layout2.position = [orient === "vertical" ? positionMap.vertical[axisPosition] : rectBound[0], orient === "horizontal" ? positionMap.horizontal[axisPosition] : rectBound[3]];
  var r2 = {
    horizontal: 0,
    vertical: 1
  };
  layout2.rotation = Math.PI / 2 * r2[orient];
  var directionMap = {
    top: -1,
    bottom: 1,
    right: 1,
    left: -1
  };
  layout2.labelDirection = layout2.tickDirection = layout2.nameDirection = directionMap[axisPosition];
  if (axisModel.get(["axisTick", "inside"])) {
    layout2.tickDirection = -layout2.tickDirection;
  }
  if (retrieve(opt.labelInside, axisModel.get(["axisLabel", "inside"]))) {
    layout2.labelDirection = -layout2.labelDirection;
  }
  var labelRotation = opt.rotate;
  labelRotation == null && (labelRotation = axisModel.get(["axisLabel", "rotate"]));
  layout2.labelRotation = axisPosition === "top" ? -labelRotation : labelRotation;
  layout2.z2 = 1;
  return layout2;
}
var axisBuilderAttrs = ["axisLine", "axisTickLabel", "axisName"];
var selfBuilderAttrs = ["splitArea", "splitLine"];
var SingleAxisView = function(_super) {
  __extends(SingleAxisView2, _super);
  function SingleAxisView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisView2.type;
    _this.axisPointerClass = "SingleAxisPointer";
    return _this;
  }
  SingleAxisView2.prototype.render = function(axisModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    var oldAxisGroup = this._axisGroup;
    this._axisGroup = new Group$4();
    var layout2 = layout$1(axisModel);
    var axisBuilder = new AxisBuilder$1(axisModel, layout2);
    each$f(axisBuilderAttrs, axisBuilder.add, axisBuilder);
    group.add(this._axisGroup);
    group.add(axisBuilder.getGroup());
    each$f(selfBuilderAttrs, function(name) {
      if (axisModel.get([name, "show"])) {
        axisElementBuilders[name](this, this.group, this._axisGroup, axisModel);
      }
    }, this);
    groupTransition(oldAxisGroup, this._axisGroup, axisModel);
    _super.prototype.render.call(this, axisModel, ecModel, api, payload);
  };
  SingleAxisView2.prototype.remove = function() {
    rectCoordAxisHandleRemove(this);
  };
  SingleAxisView2.type = "singleAxis";
  return SingleAxisView2;
}(AxisView$1);
var axisElementBuilders = {
  splitLine: function(axisView, group, axisGroup, axisModel) {
    var axis = axisModel.axis;
    if (axis.scale.isBlank()) {
      return;
    }
    var splitLineModel = axisModel.getModel("splitLine");
    var lineStyleModel = splitLineModel.getModel("lineStyle");
    var lineColors = lineStyleModel.get("color");
    lineColors = lineColors instanceof Array ? lineColors : [lineColors];
    var gridRect = axisModel.coordinateSystem.getRect();
    var isHorizontal = axis.isHorizontal();
    var splitLines = [];
    var lineCount = 0;
    var ticksCoords = axis.getTicksCoords({
      tickModel: splitLineModel
    });
    var p1 = [];
    var p2 = [];
    for (var i = 0; i < ticksCoords.length; ++i) {
      var tickCoord = axis.toGlobalCoord(ticksCoords[i].coord);
      if (isHorizontal) {
        p1[0] = tickCoord;
        p1[1] = gridRect.y;
        p2[0] = tickCoord;
        p2[1] = gridRect.y + gridRect.height;
      } else {
        p1[0] = gridRect.x;
        p1[1] = tickCoord;
        p2[0] = gridRect.x + gridRect.width;
        p2[1] = tickCoord;
      }
      var colorIndex = lineCount++ % lineColors.length;
      splitLines[colorIndex] = splitLines[colorIndex] || [];
      splitLines[colorIndex].push(new Line$3({
        subPixelOptimize: true,
        shape: {
          x1: p1[0],
          y1: p1[1],
          x2: p2[0],
          y2: p2[1]
        },
        silent: true
      }));
    }
    var lineStyle = lineStyleModel.getLineStyle(["color"]);
    for (var i = 0; i < splitLines.length; ++i) {
      group.add(mergePath(splitLines[i], {
        style: defaults({
          stroke: lineColors[i % lineColors.length]
        }, lineStyle),
        silent: true
      }));
    }
  },
  splitArea: function(axisView, group, axisGroup, axisModel) {
    rectCoordAxisBuildSplitArea(axisView, axisGroup, axisModel, axisModel);
  }
};
var SingleAxisView$1 = SingleAxisView;
var SingleAxisModel = function(_super) {
  __extends(SingleAxisModel2, _super);
  function SingleAxisModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleAxisModel2.type;
    return _this;
  }
  SingleAxisModel2.prototype.getCoordSysModel = function() {
    return this;
  };
  SingleAxisModel2.type = "singleAxis";
  SingleAxisModel2.layoutMode = "box";
  SingleAxisModel2.defaultOption = {
    left: "5%",
    top: "5%",
    right: "5%",
    bottom: "5%",
    type: "value",
    position: "bottom",
    orient: "horizontal",
    axisLine: {
      show: true,
      lineStyle: {
        width: 1,
        type: "solid"
      }
    },
    tooltip: {
      show: true
    },
    axisTick: {
      show: true,
      length: 6,
      lineStyle: {
        width: 1
      }
    },
    axisLabel: {
      show: true,
      interval: "auto"
    },
    splitLine: {
      show: true,
      lineStyle: {
        type: "dashed",
        opacity: 0.2
      }
    }
  };
  return SingleAxisModel2;
}(ComponentModel$1);
mixin(SingleAxisModel, AxisModelCommonMixin.prototype);
var SingleAxisModel$1 = SingleAxisModel;
var SingleAxis = function(_super) {
  __extends(SingleAxis2, _super);
  function SingleAxis2(dim, scale2, coordExtent, axisType, position2) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    _this.position = position2 || "bottom";
    return _this;
  }
  SingleAxis2.prototype.isHorizontal = function() {
    var position2 = this.position;
    return position2 === "top" || position2 === "bottom";
  };
  SingleAxis2.prototype.pointToData = function(point, clamp2) {
    return this.coordinateSystem.pointToData(point)[0];
  };
  return SingleAxis2;
}(Axis$1);
var SingleAxis$1 = SingleAxis;
var singleDimensions = ["single"];
var Single = function() {
  function Single2(axisModel, ecModel, api) {
    this.type = "single";
    this.dimension = "single";
    this.dimensions = singleDimensions;
    this.axisPointerEnabled = true;
    this.model = axisModel;
    this._init(axisModel, ecModel, api);
  }
  Single2.prototype._init = function(axisModel, ecModel, api) {
    var dim = this.dimension;
    var axis = new SingleAxis$1(dim, createScaleByModel$1(axisModel), [0, 0], axisModel.get("type"), axisModel.get("position"));
    var isCategory2 = axis.type === "category";
    axis.onBand = isCategory2 && axisModel.get("boundaryGap");
    axis.inverse = axisModel.get("inverse");
    axis.orient = axisModel.get("orient");
    axisModel.axis = axis;
    axis.model = axisModel;
    axis.coordinateSystem = this;
    this._axis = axis;
  };
  Single2.prototype.update = function(ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      if (seriesModel.coordinateSystem === this) {
        var data_1 = seriesModel.getData();
        each$f(data_1.mapDimensionsAll(this.dimension), function(dim) {
          this._axis.scale.unionExtentFromData(data_1, dim);
        }, this);
        niceScaleExtent(this._axis.scale, this._axis.model);
      }
    }, this);
  };
  Single2.prototype.resize = function(axisModel, api) {
    this._rect = getLayoutRect({
      left: axisModel.get("left"),
      top: axisModel.get("top"),
      right: axisModel.get("right"),
      bottom: axisModel.get("bottom"),
      width: axisModel.get("width"),
      height: axisModel.get("height")
    }, {
      width: api.getWidth(),
      height: api.getHeight()
    });
    this._adjustAxis();
  };
  Single2.prototype.getRect = function() {
    return this._rect;
  };
  Single2.prototype._adjustAxis = function() {
    var rect = this._rect;
    var axis = this._axis;
    var isHorizontal = axis.isHorizontal();
    var extent3 = isHorizontal ? [0, rect.width] : [0, rect.height];
    var idx = axis.reverse ? 1 : 0;
    axis.setExtent(extent3[idx], extent3[1 - idx]);
    this._updateAxisTransform(axis, isHorizontal ? rect.x : rect.y);
  };
  Single2.prototype._updateAxisTransform = function(axis, coordBase) {
    var axisExtent = axis.getExtent();
    var extentSum = axisExtent[0] + axisExtent[1];
    var isHorizontal = axis.isHorizontal();
    axis.toGlobalCoord = isHorizontal ? function(coord) {
      return coord + coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
    axis.toLocalCoord = isHorizontal ? function(coord) {
      return coord - coordBase;
    } : function(coord) {
      return extentSum - coord + coordBase;
    };
  };
  Single2.prototype.getAxis = function() {
    return this._axis;
  };
  Single2.prototype.getBaseAxis = function() {
    return this._axis;
  };
  Single2.prototype.getAxes = function() {
    return [this._axis];
  };
  Single2.prototype.getTooltipAxes = function() {
    return {
      baseAxes: [this.getAxis()],
      otherAxes: []
    };
  };
  Single2.prototype.containPoint = function(point) {
    var rect = this.getRect();
    var axis = this.getAxis();
    var orient = axis.orient;
    if (orient === "horizontal") {
      return axis.contain(axis.toLocalCoord(point[0])) && point[1] >= rect.y && point[1] <= rect.y + rect.height;
    } else {
      return axis.contain(axis.toLocalCoord(point[1])) && point[0] >= rect.y && point[0] <= rect.y + rect.height;
    }
  };
  Single2.prototype.pointToData = function(point) {
    var axis = this.getAxis();
    return [axis.coordToData(axis.toLocalCoord(point[axis.orient === "horizontal" ? 0 : 1]))];
  };
  Single2.prototype.dataToPoint = function(val) {
    var axis = this.getAxis();
    var rect = this.getRect();
    var pt = [];
    var idx = axis.orient === "horizontal" ? 0 : 1;
    if (val instanceof Array) {
      val = val[0];
    }
    pt[idx] = axis.toGlobalCoord(axis.dataToCoord(+val));
    pt[1 - idx] = idx === 0 ? rect.y + rect.height / 2 : rect.x + rect.width / 2;
    return pt;
  };
  Single2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.dataToPoint(value) : null;
  };
  Single2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys$1(finder);
    return coordSys === this ? this.pointToData(pixel) : null;
  };
  return Single2;
}();
function getCoordSys$1(finder) {
  var seriesModel = finder.seriesModel;
  var singleModel = finder.singleAxisModel;
  return singleModel && singleModel.coordinateSystem || seriesModel && seriesModel.coordinateSystem;
}
function create(ecModel, api) {
  var singles = [];
  ecModel.eachComponent("singleAxis", function(axisModel, idx) {
    var single = new Single(axisModel, ecModel, api);
    single.name = "single_" + idx;
    single.resize(axisModel, api);
    axisModel.coordinateSystem = single;
    singles.push(single);
  });
  ecModel.eachSeries(function(seriesModel) {
    if (seriesModel.get("coordinateSystem") === "singleAxis") {
      var singleAxisModel = seriesModel.getReferringComponents("singleAxis", SINGLE_REFERRING).models[0];
      seriesModel.coordinateSystem = singleAxisModel && singleAxisModel.coordinateSystem;
    }
  });
  return singles;
}
var singleCreator = {
  create,
  dimensions: singleDimensions
};
var singleCreator$1 = singleCreator;
var XY$1 = ["x", "y"];
var WH$1 = ["width", "height"];
var SingleAxisPointer = function(_super) {
  __extends(SingleAxisPointer2, _super);
  function SingleAxisPointer2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SingleAxisPointer2.prototype.makeElOption = function(elOption, value, axisModel, axisPointerModel, api) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var otherExtent = getGlobalExtent(coordSys, 1 - getPointDimIndex(axis));
    var pixelValue = coordSys.dataToPoint(value)[0];
    var axisPointerType = axisPointerModel.get("type");
    if (axisPointerType && axisPointerType !== "none") {
      var elStyle = buildElStyle(axisPointerModel);
      var pointerOption = pointerShapeBuilder[axisPointerType](axis, pixelValue, otherExtent);
      pointerOption.style = elStyle;
      elOption.graphicKey = pointerOption.type;
      elOption.pointer = pointerOption;
    }
    var layoutInfo = layout$1(axisModel);
    buildCartesianSingleLabelElOption(value, elOption, layoutInfo, axisModel, axisPointerModel, api);
  };
  SingleAxisPointer2.prototype.getHandleTransform = function(value, axisModel, axisPointerModel) {
    var layoutInfo = layout$1(axisModel, {
      labelInside: false
    });
    layoutInfo.labelMargin = axisPointerModel.get(["handle", "margin"]);
    var position2 = getTransformedPosition(axisModel.axis, value, layoutInfo);
    return {
      x: position2[0],
      y: position2[1],
      rotation: layoutInfo.rotation + (layoutInfo.labelDirection < 0 ? Math.PI : 0)
    };
  };
  SingleAxisPointer2.prototype.updateHandleTransform = function(transform2, delta, axisModel, axisPointerModel) {
    var axis = axisModel.axis;
    var coordSys = axis.coordinateSystem;
    var dimIndex = getPointDimIndex(axis);
    var axisExtent = getGlobalExtent(coordSys, dimIndex);
    var currPosition = [transform2.x, transform2.y];
    currPosition[dimIndex] += delta[dimIndex];
    currPosition[dimIndex] = Math.min(axisExtent[1], currPosition[dimIndex]);
    currPosition[dimIndex] = Math.max(axisExtent[0], currPosition[dimIndex]);
    var otherExtent = getGlobalExtent(coordSys, 1 - dimIndex);
    var cursorOtherValue = (otherExtent[1] + otherExtent[0]) / 2;
    var cursorPoint = [cursorOtherValue, cursorOtherValue];
    cursorPoint[dimIndex] = currPosition[dimIndex];
    return {
      x: currPosition[0],
      y: currPosition[1],
      rotation: transform2.rotation,
      cursorPoint,
      tooltipOption: {
        verticalAlign: "middle"
      }
    };
  };
  return SingleAxisPointer2;
}(BaseAxisPointer$1);
var pointerShapeBuilder = {
  line: function(axis, pixelValue, otherExtent) {
    var targetShape = makeLineShape([pixelValue, otherExtent[0]], [pixelValue, otherExtent[1]], getPointDimIndex(axis));
    return {
      type: "Line",
      subPixelOptimize: true,
      shape: targetShape
    };
  },
  shadow: function(axis, pixelValue, otherExtent) {
    var bandWidth = axis.getBandWidth();
    var span = otherExtent[1] - otherExtent[0];
    return {
      type: "Rect",
      shape: makeRectShape([pixelValue - bandWidth / 2, otherExtent[0]], [bandWidth, span], getPointDimIndex(axis))
    };
  }
};
function getPointDimIndex(axis) {
  return axis.isHorizontal() ? 0 : 1;
}
function getGlobalExtent(coordSys, dimIndex) {
  var rect = coordSys.getRect();
  return [rect[XY$1[dimIndex]], rect[XY$1[dimIndex]] + rect[WH$1[dimIndex]]];
}
var SingleAxisPointer$1 = SingleAxisPointer;
var SingleView = function(_super) {
  __extends(SingleView2, _super);
  function SingleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SingleView2.type;
    return _this;
  }
  SingleView2.type = "single";
  return SingleView2;
}(ComponentView$1);
function install$n(registers) {
  use(install$q);
  AxisView$1.registerAxisPointerClass("SingleAxisPointer", SingleAxisPointer$1);
  registers.registerComponentView(SingleView);
  registers.registerComponentView(SingleAxisView$1);
  registers.registerComponentModel(SingleAxisModel$1);
  axisModelCreator(registers, "single", SingleAxisModel$1, SingleAxisModel$1.defaultOption);
  registers.registerCoordinateSystem("single", singleCreator$1);
}
var CalendarModel = function(_super) {
  __extends(CalendarModel2, _super);
  function CalendarModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarModel2.type;
    return _this;
  }
  CalendarModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(option, inputPositionParams);
  };
  CalendarModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    mergeAndNormalizeLayoutParams$1(this.option, option);
  };
  CalendarModel2.prototype.getCellSize = function() {
    return this.option.cellSize;
  };
  CalendarModel2.type = "calendar";
  CalendarModel2.defaultOption = {
    z: 2,
    left: 80,
    top: 60,
    cellSize: 20,
    orient: "horizontal",
    splitLine: {
      show: true,
      lineStyle: {
        color: "#000",
        width: 1,
        type: "solid"
      }
    },
    itemStyle: {
      color: "#fff",
      borderWidth: 1,
      borderColor: "#ccc"
    },
    dayLabel: {
      show: true,
      firstDay: 0,
      position: "start",
      margin: "50%",
      color: "#000"
    },
    monthLabel: {
      show: true,
      position: "start",
      margin: 5,
      align: "center",
      formatter: null,
      color: "#000"
    },
    yearLabel: {
      show: true,
      position: null,
      margin: 30,
      formatter: null,
      color: "#ccc",
      fontFamily: "sans-serif",
      fontWeight: "bolder",
      fontSize: 20
    }
  };
  return CalendarModel2;
}(ComponentModel$1);
function mergeAndNormalizeLayoutParams$1(target, raw) {
  var cellSize = target.cellSize;
  var cellSizeArr;
  if (!isArray$1(cellSize)) {
    cellSizeArr = target.cellSize = [cellSize, cellSize];
  } else {
    cellSizeArr = cellSize;
  }
  if (cellSizeArr.length === 1) {
    cellSizeArr[1] = cellSizeArr[0];
  }
  var ignoreSize = map$1([0, 1], function(hvIdx) {
    if (sizeCalculable(raw, hvIdx)) {
      cellSizeArr[hvIdx] = "auto";
    }
    return cellSizeArr[hvIdx] != null && cellSizeArr[hvIdx] !== "auto";
  });
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize
  });
}
var CalendarModel$1 = CalendarModel;
var CalendarView = function(_super) {
  __extends(CalendarView2, _super);
  function CalendarView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = CalendarView2.type;
    return _this;
  }
  CalendarView2.prototype.render = function(calendarModel, ecModel, api) {
    var group = this.group;
    group.removeAll();
    var coordSys = calendarModel.coordinateSystem;
    var rangeData = coordSys.getRangeInfo();
    var orient = coordSys.getOrient();
    var localeModel = ecModel.getLocaleModel();
    this._renderDayRect(calendarModel, rangeData, group);
    this._renderLines(calendarModel, rangeData, orient, group);
    this._renderYearText(calendarModel, rangeData, orient, group);
    this._renderMonthText(calendarModel, localeModel, orient, group);
    this._renderWeekText(calendarModel, localeModel, rangeData, orient, group);
  };
  CalendarView2.prototype._renderDayRect = function(calendarModel, rangeData, group) {
    var coordSys = calendarModel.coordinateSystem;
    var itemRectStyleModel = calendarModel.getModel("itemStyle").getItemStyle();
    var sw = coordSys.getCellWidth();
    var sh = coordSys.getCellHeight();
    for (var i = rangeData.start.time; i <= rangeData.end.time; i = coordSys.getNextNDay(i, 1).time) {
      var point = coordSys.dataToRect([i], false).tl;
      var rect = new Rect$3({
        shape: {
          x: point[0],
          y: point[1],
          width: sw,
          height: sh
        },
        cursor: "default",
        style: itemRectStyleModel
      });
      group.add(rect);
    }
  };
  CalendarView2.prototype._renderLines = function(calendarModel, rangeData, orient, group) {
    var self2 = this;
    var coordSys = calendarModel.coordinateSystem;
    var lineStyleModel = calendarModel.getModel(["splitLine", "lineStyle"]).getLineStyle();
    var show = calendarModel.get(["splitLine", "show"]);
    var lineWidth = lineStyleModel.lineWidth;
    this._tlpoints = [];
    this._blpoints = [];
    this._firstDayOfMonth = [];
    this._firstDayPoints = [];
    var firstDay = rangeData.start;
    for (var i = 0; firstDay.time <= rangeData.end.time; i++) {
      addPoints(firstDay.formatedDate);
      if (i === 0) {
        firstDay = coordSys.getDateInfo(rangeData.start.y + "-" + rangeData.start.m);
      }
      var date4 = firstDay.date;
      date4.setMonth(date4.getMonth() + 1);
      firstDay = coordSys.getDateInfo(date4);
    }
    addPoints(coordSys.getNextNDay(rangeData.end.time, 1).formatedDate);
    function addPoints(date5) {
      self2._firstDayOfMonth.push(coordSys.getDateInfo(date5));
      self2._firstDayPoints.push(coordSys.dataToRect([date5], false).tl);
      var points2 = self2._getLinePointsOfOneWeek(calendarModel, date5, orient);
      self2._tlpoints.push(points2[0]);
      self2._blpoints.push(points2[points2.length - 1]);
      show && self2._drawSplitline(points2, lineStyleModel, group);
    }
    show && this._drawSplitline(self2._getEdgesPoints(self2._tlpoints, lineWidth, orient), lineStyleModel, group);
    show && this._drawSplitline(self2._getEdgesPoints(self2._blpoints, lineWidth, orient), lineStyleModel, group);
  };
  CalendarView2.prototype._getEdgesPoints = function(points2, lineWidth, orient) {
    var rs = [points2[0].slice(), points2[points2.length - 1].slice()];
    var idx = orient === "horizontal" ? 0 : 1;
    rs[0][idx] = rs[0][idx] - lineWidth / 2;
    rs[1][idx] = rs[1][idx] + lineWidth / 2;
    return rs;
  };
  CalendarView2.prototype._drawSplitline = function(points2, lineStyle, group) {
    var poyline = new Polyline$3({
      z2: 20,
      shape: {
        points: points2
      },
      style: lineStyle
    });
    group.add(poyline);
  };
  CalendarView2.prototype._getLinePointsOfOneWeek = function(calendarModel, date4, orient) {
    var coordSys = calendarModel.coordinateSystem;
    var parsedDate = coordSys.getDateInfo(date4);
    var points2 = [];
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(parsedDate.time, i);
      var point = coordSys.dataToRect([tmpD.time], false);
      points2[2 * tmpD.day] = point.tl;
      points2[2 * tmpD.day + 1] = point[orient === "horizontal" ? "bl" : "tr"];
    }
    return points2;
  };
  CalendarView2.prototype._formatterLabel = function(formatter, params) {
    if (isString(formatter) && formatter) {
      return formatTplSimple(formatter, params);
    }
    if (isFunction(formatter)) {
      return formatter(params);
    }
    return params.nameMap;
  };
  CalendarView2.prototype._yearTextPositionControl = function(textEl, point, orient, position2, margin) {
    var x2 = point[0];
    var y2 = point[1];
    var aligns = ["center", "bottom"];
    if (position2 === "bottom") {
      y2 += margin;
      aligns = ["center", "top"];
    } else if (position2 === "left") {
      x2 -= margin;
    } else if (position2 === "right") {
      x2 += margin;
      aligns = ["center", "top"];
    } else {
      y2 -= margin;
    }
    var rotate2 = 0;
    if (position2 === "left" || position2 === "right") {
      rotate2 = Math.PI / 2;
    }
    return {
      rotation: rotate2,
      x: x2,
      y: y2,
      style: {
        align: aligns[0],
        verticalAlign: aligns[1]
      }
    };
  };
  CalendarView2.prototype._renderYearText = function(calendarModel, rangeData, orient, group) {
    var yearLabel = calendarModel.getModel("yearLabel");
    if (!yearLabel.get("show")) {
      return;
    }
    var margin = yearLabel.get("margin");
    var pos = yearLabel.get("position");
    if (!pos) {
      pos = orient !== "horizontal" ? "top" : "left";
    }
    var points2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]];
    var xc = (points2[0][0] + points2[1][0]) / 2;
    var yc = (points2[0][1] + points2[1][1]) / 2;
    var idx = orient === "horizontal" ? 0 : 1;
    var posPoints = {
      top: [xc, points2[idx][1]],
      bottom: [xc, points2[1 - idx][1]],
      left: [points2[1 - idx][0], yc],
      right: [points2[idx][0], yc]
    };
    var name = rangeData.start.y;
    if (+rangeData.end.y > +rangeData.start.y) {
      name = name + "-" + rangeData.end.y;
    }
    var formatter = yearLabel.get("formatter");
    var params = {
      start: rangeData.start.y,
      end: rangeData.end.y,
      nameMap: name
    };
    var content = this._formatterLabel(formatter, params);
    var yearText = new ZRText$1({
      z2: 30,
      style: createTextStyle(yearLabel, {
        text: content
      })
    });
    yearText.attr(this._yearTextPositionControl(yearText, posPoints[pos], orient, pos, margin));
    group.add(yearText);
  };
  CalendarView2.prototype._monthTextPositionControl = function(point, isCenter, orient, position2, margin) {
    var align = "left";
    var vAlign = "top";
    var x2 = point[0];
    var y2 = point[1];
    if (orient === "horizontal") {
      y2 = y2 + margin;
      if (isCenter) {
        align = "center";
      }
      if (position2 === "start") {
        vAlign = "bottom";
      }
    } else {
      x2 = x2 + margin;
      if (isCenter) {
        vAlign = "middle";
      }
      if (position2 === "start") {
        align = "right";
      }
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderMonthText = function(calendarModel, localeModel, orient, group) {
    var monthLabel = calendarModel.getModel("monthLabel");
    if (!monthLabel.get("show")) {
      return;
    }
    var nameMap = monthLabel.get("nameMap");
    var margin = monthLabel.get("margin");
    var pos = monthLabel.get("position");
    var align = monthLabel.get("align");
    var termPoints = [this._tlpoints, this._blpoints];
    if (!nameMap || isString(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      nameMap = localeModel.get(["time", "monthAbbr"]) || [];
    }
    var idx = pos === "start" ? 0 : 1;
    var axis = orient === "horizontal" ? 0 : 1;
    margin = pos === "start" ? -margin : margin;
    var isCenter = align === "center";
    for (var i = 0; i < termPoints[idx].length - 1; i++) {
      var tmp = termPoints[idx][i].slice();
      var firstDay = this._firstDayOfMonth[i];
      if (isCenter) {
        var firstDayPoints = this._firstDayPoints[i];
        tmp[axis] = (firstDayPoints[axis] + termPoints[0][i + 1][axis]) / 2;
      }
      var formatter = monthLabel.get("formatter");
      var name_1 = nameMap[+firstDay.m - 1];
      var params = {
        yyyy: firstDay.y,
        yy: (firstDay.y + "").slice(2),
        MM: firstDay.m,
        M: +firstDay.m,
        nameMap: name_1
      };
      var content = this._formatterLabel(formatter, params);
      var monthText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(monthLabel, {
          text: content
        }), this._monthTextPositionControl(tmp, isCenter, orient, pos, margin))
      });
      group.add(monthText);
    }
  };
  CalendarView2.prototype._weekTextPositionControl = function(point, orient, position2, margin, cellSize) {
    var align = "center";
    var vAlign = "middle";
    var x2 = point[0];
    var y2 = point[1];
    var isStart = position2 === "start";
    if (orient === "horizontal") {
      x2 = x2 + margin + (isStart ? 1 : -1) * cellSize[0] / 2;
      align = isStart ? "right" : "left";
    } else {
      y2 = y2 + margin + (isStart ? 1 : -1) * cellSize[1] / 2;
      vAlign = isStart ? "bottom" : "top";
    }
    return {
      x: x2,
      y: y2,
      align,
      verticalAlign: vAlign
    };
  };
  CalendarView2.prototype._renderWeekText = function(calendarModel, localeModel, rangeData, orient, group) {
    var dayLabel = calendarModel.getModel("dayLabel");
    if (!dayLabel.get("show")) {
      return;
    }
    var coordSys = calendarModel.coordinateSystem;
    var pos = dayLabel.get("position");
    var nameMap = dayLabel.get("nameMap");
    var margin = dayLabel.get("margin");
    var firstDayOfWeek = coordSys.getFirstDayOfWeek();
    if (!nameMap || isString(nameMap)) {
      if (nameMap) {
        localeModel = getLocaleModel(nameMap) || localeModel;
      }
      var dayOfWeekShort = localeModel.get(["time", "dayOfWeekShort"]);
      nameMap = dayOfWeekShort || map$1(localeModel.get(["time", "dayOfWeekAbbr"]), function(val) {
        return val[0];
      });
    }
    var start2 = coordSys.getNextNDay(rangeData.end.time, 7 - rangeData.lweek).time;
    var cellSize = [coordSys.getCellWidth(), coordSys.getCellHeight()];
    margin = parsePercent(margin, Math.min(cellSize[1], cellSize[0]));
    if (pos === "start") {
      start2 = coordSys.getNextNDay(rangeData.start.time, -(7 + rangeData.fweek)).time;
      margin = -margin;
    }
    for (var i = 0; i < 7; i++) {
      var tmpD = coordSys.getNextNDay(start2, i);
      var point = coordSys.dataToRect([tmpD.time], false).center;
      var day = i;
      day = Math.abs((i + firstDayOfWeek) % 7);
      var weekText = new ZRText$1({
        z2: 30,
        style: extend(createTextStyle(dayLabel, {
          text: nameMap[day]
        }), this._weekTextPositionControl(point, orient, pos, margin, cellSize))
      });
      group.add(weekText);
    }
  };
  CalendarView2.type = "calendar";
  return CalendarView2;
}(ComponentView$1);
var CalendarView$1 = CalendarView;
var PROXIMATE_ONE_DAY = 864e5;
var Calendar = function() {
  function Calendar2(calendarModel, ecModel, api) {
    this.type = "calendar";
    this.dimensions = Calendar2.dimensions;
    this.getDimensionsInfo = Calendar2.getDimensionsInfo;
    this._model = calendarModel;
  }
  Calendar2.getDimensionsInfo = function() {
    return [{
      name: "time",
      type: "time"
    }, "value"];
  };
  Calendar2.prototype.getRangeInfo = function() {
    return this._rangeInfo;
  };
  Calendar2.prototype.getModel = function() {
    return this._model;
  };
  Calendar2.prototype.getRect = function() {
    return this._rect;
  };
  Calendar2.prototype.getCellWidth = function() {
    return this._sw;
  };
  Calendar2.prototype.getCellHeight = function() {
    return this._sh;
  };
  Calendar2.prototype.getOrient = function() {
    return this._orient;
  };
  Calendar2.prototype.getFirstDayOfWeek = function() {
    return this._firstDayOfWeek;
  };
  Calendar2.prototype.getDateInfo = function(date4) {
    date4 = parseDate(date4);
    var y2 = date4.getFullYear();
    var m2 = date4.getMonth() + 1;
    var mStr = m2 < 10 ? "0" + m2 : "" + m2;
    var d2 = date4.getDate();
    var dStr = d2 < 10 ? "0" + d2 : "" + d2;
    var day = date4.getDay();
    day = Math.abs((day + 7 - this.getFirstDayOfWeek()) % 7);
    return {
      y: y2 + "",
      m: mStr,
      d: dStr,
      day,
      time: date4.getTime(),
      formatedDate: y2 + "-" + mStr + "-" + dStr,
      date: date4
    };
  };
  Calendar2.prototype.getNextNDay = function(date4, n2) {
    n2 = n2 || 0;
    if (n2 === 0) {
      return this.getDateInfo(date4);
    }
    date4 = new Date(this.getDateInfo(date4).time);
    date4.setDate(date4.getDate() + n2);
    return this.getDateInfo(date4);
  };
  Calendar2.prototype.update = function(ecModel, api) {
    this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay");
    this._orient = this._model.get("orient");
    this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0;
    this._rangeInfo = this._getRangeInfo(this._initRangeOption());
    var weeks = this._rangeInfo.weeks || 1;
    var whNames = ["width", "height"];
    var cellSize = this._model.getCellSize().slice();
    var layoutParams = this._model.getBoxLayoutParams();
    var cellNumbers = this._orient === "horizontal" ? [weeks, 7] : [7, weeks];
    each$f([0, 1], function(idx) {
      if (cellSizeSpecified(cellSize, idx)) {
        layoutParams[whNames[idx]] = cellSize[idx] * cellNumbers[idx];
      }
    });
    var whGlobal = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var calendarRect = this._rect = getLayoutRect(layoutParams, whGlobal);
    each$f([0, 1], function(idx) {
      if (!cellSizeSpecified(cellSize, idx)) {
        cellSize[idx] = calendarRect[whNames[idx]] / cellNumbers[idx];
      }
    });
    function cellSizeSpecified(cellSize2, idx) {
      return cellSize2[idx] != null && cellSize2[idx] !== "auto";
    }
    this._sw = cellSize[0];
    this._sh = cellSize[1];
  };
  Calendar2.prototype.dataToPoint = function(data, clamp2) {
    isArray$1(data) && (data = data[0]);
    clamp2 == null && (clamp2 = true);
    var dayInfo = this.getDateInfo(data);
    var range3 = this._rangeInfo;
    var date4 = dayInfo.formatedDate;
    if (clamp2 && !(dayInfo.time >= range3.start.time && dayInfo.time < range3.end.time + PROXIMATE_ONE_DAY)) {
      return [NaN, NaN];
    }
    var week = dayInfo.day;
    var nthWeek = this._getRangeInfo([range3.start.time, date4]).nthWeek;
    if (this._orient === "vertical") {
      return [this._rect.x + week * this._sw + this._sw / 2, this._rect.y + nthWeek * this._sh + this._sh / 2];
    }
    return [this._rect.x + nthWeek * this._sw + this._sw / 2, this._rect.y + week * this._sh + this._sh / 2];
  };
  Calendar2.prototype.pointToData = function(point) {
    var date4 = this.pointToDate(point);
    return date4 && date4.time;
  };
  Calendar2.prototype.dataToRect = function(data, clamp2) {
    var point = this.dataToPoint(data, clamp2);
    return {
      contentShape: {
        x: point[0] - (this._sw - this._lineWidth) / 2,
        y: point[1] - (this._sh - this._lineWidth) / 2,
        width: this._sw - this._lineWidth,
        height: this._sh - this._lineWidth
      },
      center: point,
      tl: [point[0] - this._sw / 2, point[1] - this._sh / 2],
      tr: [point[0] + this._sw / 2, point[1] - this._sh / 2],
      br: [point[0] + this._sw / 2, point[1] + this._sh / 2],
      bl: [point[0] - this._sw / 2, point[1] + this._sh / 2]
    };
  };
  Calendar2.prototype.pointToDate = function(point) {
    var nthX = Math.floor((point[0] - this._rect.x) / this._sw) + 1;
    var nthY = Math.floor((point[1] - this._rect.y) / this._sh) + 1;
    var range3 = this._rangeInfo.range;
    if (this._orient === "vertical") {
      return this._getDateByWeeksAndDay(nthY, nthX - 1, range3);
    }
    return this._getDateByWeeksAndDay(nthX, nthY - 1, range3);
  };
  Calendar2.prototype.convertToPixel = function(ecModel, finder, value) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.dataToPoint(value) : null;
  };
  Calendar2.prototype.convertFromPixel = function(ecModel, finder, pixel) {
    var coordSys = getCoordSys(finder);
    return coordSys === this ? coordSys.pointToData(pixel) : null;
  };
  Calendar2.prototype.containPoint = function(point) {
    console.warn("Not implemented.");
    return false;
  };
  Calendar2.prototype._initRangeOption = function() {
    var range3 = this._model.get("range");
    var normalizedRange;
    if (isArray$1(range3) && range3.length === 1) {
      range3 = range3[0];
    }
    if (!isArray$1(range3)) {
      var rangeStr = range3.toString();
      if (/^\d{4}$/.test(rangeStr)) {
        normalizedRange = [rangeStr + "-01-01", rangeStr + "-12-31"];
      }
      if (/^\d{4}[\/|-]\d{1,2}$/.test(rangeStr)) {
        var start2 = this.getDateInfo(rangeStr);
        var firstDay = start2.date;
        firstDay.setMonth(firstDay.getMonth() + 1);
        var end2 = this.getNextNDay(firstDay, -1);
        normalizedRange = [start2.formatedDate, end2.formatedDate];
      }
      if (/^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(rangeStr)) {
        normalizedRange = [rangeStr, rangeStr];
      }
    } else {
      normalizedRange = range3;
    }
    if (!normalizedRange) {
      return range3;
    }
    var tmp = this._getRangeInfo(normalizedRange);
    if (tmp.start.time > tmp.end.time) {
      normalizedRange.reverse();
    }
    return normalizedRange;
  };
  Calendar2.prototype._getRangeInfo = function(range3) {
    var parsedRange = [this.getDateInfo(range3[0]), this.getDateInfo(range3[1])];
    var reversed;
    if (parsedRange[0].time > parsedRange[1].time) {
      reversed = true;
      parsedRange.reverse();
    }
    var allDay = Math.floor(parsedRange[1].time / PROXIMATE_ONE_DAY) - Math.floor(parsedRange[0].time / PROXIMATE_ONE_DAY) + 1;
    var date4 = new Date(parsedRange[0].time);
    var startDateNum = date4.getDate();
    var endDateNum = parsedRange[1].date.getDate();
    date4.setDate(startDateNum + allDay - 1);
    var dateNum = date4.getDate();
    if (dateNum !== endDateNum) {
      var sign = date4.getTime() - parsedRange[1].time > 0 ? 1 : -1;
      while ((dateNum = date4.getDate()) !== endDateNum && (date4.getTime() - parsedRange[1].time) * sign > 0) {
        allDay -= sign;
        date4.setDate(dateNum - sign);
      }
    }
    var weeks = Math.floor((allDay + parsedRange[0].day + 6) / 7);
    var nthWeek = reversed ? -weeks + 1 : weeks - 1;
    reversed && parsedRange.reverse();
    return {
      range: [parsedRange[0].formatedDate, parsedRange[1].formatedDate],
      start: parsedRange[0],
      end: parsedRange[1],
      allDay,
      weeks,
      nthWeek,
      fweek: parsedRange[0].day,
      lweek: parsedRange[1].day
    };
  };
  Calendar2.prototype._getDateByWeeksAndDay = function(nthWeek, day, range3) {
    var rangeInfo = this._getRangeInfo(range3);
    if (nthWeek > rangeInfo.weeks || nthWeek === 0 && day < rangeInfo.fweek || nthWeek === rangeInfo.weeks && day > rangeInfo.lweek) {
      return null;
    }
    var nthDay = (nthWeek - 1) * 7 - rangeInfo.fweek + day;
    var date4 = new Date(rangeInfo.start.time);
    date4.setDate(+rangeInfo.start.d + nthDay);
    return this.getDateInfo(date4);
  };
  Calendar2.create = function(ecModel, api) {
    var calendarList = [];
    ecModel.eachComponent("calendar", function(calendarModel) {
      var calendar = new Calendar2(calendarModel, ecModel, api);
      calendarList.push(calendar);
      calendarModel.coordinateSystem = calendar;
    });
    ecModel.eachSeries(function(calendarSeries) {
      if (calendarSeries.get("coordinateSystem") === "calendar") {
        calendarSeries.coordinateSystem = calendarList[calendarSeries.get("calendarIndex") || 0];
      }
    });
    return calendarList;
  };
  Calendar2.dimensions = ["time", "value"];
  return Calendar2;
}();
function getCoordSys(finder) {
  var calendarModel = finder.calendarModel;
  var seriesModel = finder.seriesModel;
  var coordSys = calendarModel ? calendarModel.coordinateSystem : seriesModel ? seriesModel.coordinateSystem : null;
  return coordSys;
}
var Calendar$1 = Calendar;
function install$m(registers) {
  registers.registerComponentModel(CalendarModel$1);
  registers.registerComponentView(CalendarView$1);
  registers.registerCoordinateSystem("calendar", Calendar$1);
}
function setKeyInfoToNewElOption(resultItem, newElOption) {
  var existElOption = resultItem.existing;
  newElOption.id = resultItem.keyInfo.id;
  !newElOption.type && existElOption && (newElOption.type = existElOption.type);
  if (newElOption.parentId == null) {
    var newElParentOption = newElOption.parentOption;
    if (newElParentOption) {
      newElOption.parentId = newElParentOption.id;
    } else if (existElOption) {
      newElOption.parentId = existElOption.parentId;
    }
  }
  newElOption.parentOption = null;
}
function isSetLoc(obj, props) {
  var isSet;
  each$f(props, function(prop) {
    obj[prop] != null && obj[prop] !== "auto" && (isSet = true);
  });
  return isSet;
}
function mergeNewElOptionToExist(existList, index2, newElOption) {
  var newElOptCopy = extend({}, newElOption);
  var existElOption = existList[index2];
  var $action = newElOption.$action || "merge";
  if ($action === "merge") {
    if (existElOption) {
      merge(existElOption, newElOptCopy, true);
      mergeLayoutParam(existElOption, newElOptCopy, {
        ignoreSize: true
      });
      copyLayoutParams(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption);
      copyTransitionInfo(newElOption, existElOption, "shape");
      copyTransitionInfo(newElOption, existElOption, "style");
      copyTransitionInfo(newElOption, existElOption, "extra");
      newElOption.clipPath = existElOption.clipPath;
    } else {
      existList[index2] = newElOptCopy;
    }
  } else if ($action === "replace") {
    existList[index2] = newElOptCopy;
  } else if ($action === "remove") {
    existElOption && (existList[index2] = null);
  }
}
var TRANSITION_PROPS_TO_COPY = ["transition", "enterFrom", "leaveTo"];
var ROOT_TRANSITION_PROPS_TO_COPY = TRANSITION_PROPS_TO_COPY.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
function copyTransitionInfo(target, source, targetProp) {
  if (targetProp) {
    if (!target[targetProp] && source[targetProp]) {
      target[targetProp] = {};
    }
    target = target[targetProp];
    source = source[targetProp];
  }
  if (!target || !source) {
    return;
  }
  var props = targetProp ? TRANSITION_PROPS_TO_COPY : ROOT_TRANSITION_PROPS_TO_COPY;
  for (var i = 0; i < props.length; i++) {
    var prop = props[i];
    if (target[prop] == null && source[prop] != null) {
      target[prop] = source[prop];
    }
  }
}
function setLayoutInfoToExist(existItem, newElOption) {
  if (!existItem) {
    return;
  }
  existItem.hv = newElOption.hv = [
    isSetLoc(newElOption, ["left", "right"]),
    isSetLoc(newElOption, ["top", "bottom"])
  ];
  if (existItem.type === "group") {
    var existingGroupOpt = existItem;
    var newGroupOpt = newElOption;
    existingGroupOpt.width == null && (existingGroupOpt.width = newGroupOpt.width = 0);
    existingGroupOpt.height == null && (existingGroupOpt.height = newGroupOpt.height = 0);
  }
}
var GraphicComponentModel = function(_super) {
  __extends(GraphicComponentModel2, _super);
  function GraphicComponentModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentModel2.type;
    _this.preventAutoZ = true;
    return _this;
  }
  GraphicComponentModel2.prototype.mergeOption = function(option, ecModel) {
    var elements = this.option.elements;
    this.option.elements = null;
    _super.prototype.mergeOption.call(this, option, ecModel);
    this.option.elements = elements;
  };
  GraphicComponentModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    var newList = (isInit ? thisOption : newOption).elements;
    var existList = thisOption.elements = isInit ? [] : thisOption.elements;
    var flattenedList = [];
    this._flatten(newList, flattenedList, null);
    var mappingResult = mappingToExists(existList, flattenedList, "normalMerge");
    var elOptionsToUpdate = this._elOptionsToUpdate = [];
    each$f(mappingResult, function(resultItem, index2) {
      var newElOption = resultItem.newOption;
      if (!newElOption) {
        return;
      }
      elOptionsToUpdate.push(newElOption);
      setKeyInfoToNewElOption(resultItem, newElOption);
      mergeNewElOptionToExist(existList, index2, newElOption);
      setLayoutInfoToExist(existList[index2], newElOption);
    }, this);
    thisOption.elements = filter(existList, function(item) {
      item && delete item.$action;
      return item != null;
    });
  };
  GraphicComponentModel2.prototype._flatten = function(optionList, result, parentOption) {
    each$f(optionList, function(option) {
      if (!option) {
        return;
      }
      if (parentOption) {
        option.parentOption = parentOption;
      }
      result.push(option);
      var children = option.children;
      if (option.type === "group" && children) {
        this._flatten(children, result, option);
      }
      delete option.children;
    }, this);
  };
  GraphicComponentModel2.prototype.useElOptionsToUpdate = function() {
    var els = this._elOptionsToUpdate;
    this._elOptionsToUpdate = null;
    return els;
  };
  GraphicComponentModel2.type = "graphic";
  GraphicComponentModel2.defaultOption = {
    elements: []
  };
  return GraphicComponentModel2;
}(ComponentModel$1);
var nonShapeGraphicElements = {
  path: null,
  compoundPath: null,
  group: Group$4,
  image: ZRImage$1,
  text: ZRText$1
};
var inner$7 = makeInner();
var GraphicComponentView = function(_super) {
  __extends(GraphicComponentView2, _super);
  function GraphicComponentView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = GraphicComponentView2.type;
    return _this;
  }
  GraphicComponentView2.prototype.init = function() {
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.render = function(graphicModel, ecModel, api) {
    if (graphicModel !== this._lastGraphicModel) {
      this._clear();
    }
    this._lastGraphicModel = graphicModel;
    this._updateElements(graphicModel);
    this._relocate(graphicModel, api);
  };
  GraphicComponentView2.prototype._updateElements = function(graphicModel) {
    var elOptionsToUpdate = graphicModel.useElOptionsToUpdate();
    if (!elOptionsToUpdate) {
      return;
    }
    var elMap = this._elMap;
    var rootGroup = this.group;
    var globalZ = graphicModel.get("z");
    var globalZLevel = graphicModel.get("zlevel");
    each$f(elOptionsToUpdate, function(elOption) {
      var id2 = convertOptionIdName(elOption.id, null);
      var elExisting = id2 != null ? elMap.get(id2) : null;
      var parentId = convertOptionIdName(elOption.parentId, null);
      var targetElParent = parentId != null ? elMap.get(parentId) : rootGroup;
      var elType = elOption.type;
      var elOptionStyle = elOption.style;
      if (elType === "text" && elOptionStyle) {
        if (elOption.hv && elOption.hv[1]) {
          elOptionStyle.textVerticalAlign = elOptionStyle.textBaseline = elOptionStyle.verticalAlign = elOptionStyle.align = null;
        }
      }
      var textContentOption = elOption.textContent;
      var textConfig = elOption.textConfig;
      if (elOptionStyle && isEC4CompatibleStyle(elOptionStyle, elType, !!textConfig, !!textContentOption)) {
        var convertResult = convertFromEC4CompatibleStyle(elOptionStyle, elType, true);
        if (!textConfig && convertResult.textConfig) {
          textConfig = elOption.textConfig = convertResult.textConfig;
        }
        if (!textContentOption && convertResult.textContent) {
          textContentOption = convertResult.textContent;
        }
      }
      var elOptionCleaned = getCleanedElOption(elOption);
      var $action = elOption.$action || "merge";
      var isMerge = $action === "merge";
      var isReplace = $action === "replace";
      if (isMerge) {
        var isInit = !elExisting;
        var el_1 = elExisting;
        if (isInit) {
          el_1 = createEl(id2, targetElParent, elOption.type, elMap);
        } else {
          el_1 && (inner$7(el_1).isNew = false);
          stopPreviousKeyframeAnimationAndRestore(el_1);
        }
        if (el_1) {
          applyUpdateTransition(el_1, elOptionCleaned, graphicModel, {
            isInit
          });
          updateCommonAttrs(el_1, elOption, globalZ, globalZLevel);
        }
      } else if (isReplace) {
        removeEl$1(elExisting, elOption, elMap, graphicModel);
        var el_2 = createEl(id2, targetElParent, elOption.type, elMap);
        if (el_2) {
          applyUpdateTransition(el_2, elOptionCleaned, graphicModel, {
            isInit: true
          });
          updateCommonAttrs(el_2, elOption, globalZ, globalZLevel);
        }
      } else if ($action === "remove") {
        updateLeaveTo(elExisting, elOption);
        removeEl$1(elExisting, elOption, elMap, graphicModel);
      }
      var el = elMap.get(id2);
      if (el && textContentOption) {
        if (isMerge) {
          var textContentExisting = el.getTextContent();
          textContentExisting ? textContentExisting.attr(textContentOption) : el.setTextContent(new ZRText$1(textContentOption));
        } else if (isReplace) {
          el.setTextContent(new ZRText$1(textContentOption));
        }
      }
      if (el) {
        var clipPathOption = elOption.clipPath;
        if (clipPathOption) {
          var clipPathType = clipPathOption.type;
          var clipPath = void 0;
          var isInit = false;
          if (isMerge) {
            var oldClipPath = el.getClipPath();
            isInit = !oldClipPath || inner$7(oldClipPath).type !== clipPathType;
            clipPath = isInit ? newEl(clipPathType) : oldClipPath;
          } else if (isReplace) {
            isInit = true;
            clipPath = newEl(clipPathType);
          }
          el.setClipPath(clipPath);
          applyUpdateTransition(clipPath, clipPathOption, graphicModel, {
            isInit
          });
          applyKeyframeAnimation(clipPath, clipPathOption.keyframeAnimation, graphicModel);
        }
        var elInner = inner$7(el);
        el.setTextConfig(textConfig);
        elInner.option = elOption;
        setEventData(el, graphicModel, elOption);
        setTooltipConfig({
          el,
          componentModel: graphicModel,
          itemName: el.name,
          itemTooltipOption: elOption.tooltip
        });
        applyKeyframeAnimation(el, elOption.keyframeAnimation, graphicModel);
      }
    });
  };
  GraphicComponentView2.prototype._relocate = function(graphicModel, api) {
    var elOptions = graphicModel.option.elements;
    var rootGroup = this.group;
    var elMap = this._elMap;
    var apiWidth = api.getWidth();
    var apiHeight = api.getHeight();
    var xy = ["x", "y"];
    for (var i = 0; i < elOptions.length; i++) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el || !el.isGroup) {
        continue;
      }
      var parentEl = el.parent;
      var isParentRoot = parentEl === rootGroup;
      var elInner = inner$7(el);
      var parentElInner = inner$7(parentEl);
      elInner.width = parsePercent(elInner.option.width, isParentRoot ? apiWidth : parentElInner.width) || 0;
      elInner.height = parsePercent(elInner.option.height, isParentRoot ? apiHeight : parentElInner.height) || 0;
    }
    for (var i = elOptions.length - 1; i >= 0; i--) {
      var elOption = elOptions[i];
      var id2 = convertOptionIdName(elOption.id, null);
      var el = id2 != null ? elMap.get(id2) : null;
      if (!el) {
        continue;
      }
      var parentEl = el.parent;
      var parentElInner = inner$7(parentEl);
      var containerInfo = parentEl === rootGroup ? {
        width: apiWidth,
        height: apiHeight
      } : {
        width: parentElInner.width,
        height: parentElInner.height
      };
      var layoutPos = {};
      var layouted = positionElement(el, elOption, containerInfo, null, {
        hv: elOption.hv,
        boundingMode: elOption.bounding
      }, layoutPos);
      if (!inner$7(el).isNew && layouted) {
        var transition = elOption.transition;
        var animatePos = {};
        for (var k2 = 0; k2 < xy.length; k2++) {
          var key = xy[k2];
          var val = layoutPos[key];
          if (transition && (isTransitionAll(transition) || indexOf(transition, key) >= 0)) {
            animatePos[key] = val;
          } else {
            el[key] = val;
          }
        }
        updateProps$1(el, animatePos, graphicModel, 0);
      } else {
        el.attr(layoutPos);
      }
    }
  };
  GraphicComponentView2.prototype._clear = function() {
    var _this = this;
    var elMap = this._elMap;
    elMap.each(function(el) {
      removeEl$1(el, inner$7(el).option, elMap, _this._lastGraphicModel);
    });
    this._elMap = createHashMap();
  };
  GraphicComponentView2.prototype.dispose = function() {
    this._clear();
  };
  GraphicComponentView2.type = "graphic";
  return GraphicComponentView2;
}(ComponentView$1);
function newEl(graphicType) {
  var Clz = hasOwn(nonShapeGraphicElements, graphicType) ? nonShapeGraphicElements[graphicType] : getShapeClass(graphicType);
  var el = new Clz({});
  inner$7(el).type = graphicType;
  return el;
}
function createEl(id2, targetElParent, graphicType, elMap) {
  var el = newEl(graphicType);
  targetElParent.add(el);
  elMap.set(id2, el);
  inner$7(el).id = id2;
  inner$7(el).isNew = true;
  return el;
}
function removeEl$1(elExisting, elOption, elMap, graphicModel) {
  var existElParent = elExisting && elExisting.parent;
  if (existElParent) {
    elExisting.type === "group" && elExisting.traverse(function(el) {
      removeEl$1(el, elOption, elMap, graphicModel);
    });
    applyLeaveTransition(elExisting, elOption, graphicModel);
    elMap.removeKey(inner$7(elExisting).id);
  }
}
function updateCommonAttrs(el, elOption, defaultZ, defaultZlevel) {
  if (!el.isGroup) {
    var elDisplayable = el;
    elDisplayable.cursor = retrieve2(elOption.cursor, Displayable$1.prototype.cursor);
    elDisplayable.z = retrieve2(elOption.z, defaultZ || 0);
    elDisplayable.zlevel = retrieve2(elOption.zlevel, defaultZlevel || 0);
    var optZ2 = elOption.z2;
    optZ2 != null && (elDisplayable.z2 = optZ2 || 0);
  }
  each$f(keys(elOption), function(key) {
    var val = elOption[key];
    if (key.indexOf("on") === 0 && isFunction(val)) {
      el[key] = val;
    }
  });
  el.draggable = elOption.draggable;
  elOption.name != null && (el.name = elOption.name);
  elOption.id != null && (el.id = elOption.id);
}
function getCleanedElOption(elOption) {
  elOption = extend({}, elOption);
  each$f(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(LOCATION_PARAMS), function(name) {
    delete elOption[name];
  });
  return elOption;
}
function setEventData(el, graphicModel, elOption) {
  var eventData = getECData(el).eventData;
  if (!el.silent && !el.ignore && !eventData) {
    eventData = getECData(el).eventData = {
      componentType: "graphic",
      componentIndex: graphicModel.componentIndex,
      name: el.name
    };
  }
  if (eventData) {
    eventData.info = elOption.info;
  }
}
function install$l(registers) {
  registers.registerComponentModel(GraphicComponentModel);
  registers.registerComponentView(GraphicComponentView);
  registers.registerPreprocessor(function(option) {
    var graphicOption = option.graphic;
    if (isArray$1(graphicOption)) {
      if (!graphicOption[0] || !graphicOption[0].elements) {
        option.graphic = [{
          elements: graphicOption
        }];
      } else {
        option.graphic = [option.graphic[0]];
      }
    } else if (graphicOption && !graphicOption.elements) {
      option.graphic = [{
        elements: [graphicOption]
      }];
    }
  });
}
var DATA_ZOOM_AXIS_DIMENSIONS = ["x", "y", "radius", "angle", "single"];
var SERIES_COORDS = ["cartesian2d", "polar", "singleAxis"];
function isCoordSupported(seriesModel) {
  var coordType = seriesModel.get("coordinateSystem");
  return indexOf(SERIES_COORDS, coordType) >= 0;
}
function getAxisMainType(axisDim) {
  return axisDim + "Axis";
}
function findEffectedDataZooms(ecModel, payload) {
  var axisRecords = createHashMap();
  var effectedModels = [];
  var effectedModelMap = createHashMap();
  ecModel.eachComponent({
    mainType: "dataZoom",
    query: payload
  }, function(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid)) {
      addToEffected(dataZoomModel);
    }
  });
  var foundNewLink;
  do {
    foundNewLink = false;
    ecModel.eachComponent("dataZoom", processSingle);
  } while (foundNewLink);
  function processSingle(dataZoomModel) {
    if (!effectedModelMap.get(dataZoomModel.uid) && isLinked(dataZoomModel)) {
      addToEffected(dataZoomModel);
      foundNewLink = true;
    }
  }
  function addToEffected(dataZoom) {
    effectedModelMap.set(dataZoom.uid, true);
    effectedModels.push(dataZoom);
    markAxisControlled(dataZoom);
  }
  function isLinked(dataZoomModel) {
    var isLink = false;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var axisIdxArr = axisRecords.get(axisDim);
      if (axisIdxArr && axisIdxArr[axisIndex]) {
        isLink = true;
      }
    });
    return isLink;
  }
  function markAxisControlled(dataZoomModel) {
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      (axisRecords.get(axisDim) || axisRecords.set(axisDim, []))[axisIndex] = true;
    });
  }
  return effectedModels;
}
function collectReferCoordSysModelInfo(dataZoomModel) {
  var ecModel = dataZoomModel.ecModel;
  var coordSysInfoWrap = {
    infoList: [],
    infoMap: createHashMap()
  };
  dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
    var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    if (!axisModel) {
      return;
    }
    var coordSysModel = axisModel.getCoordSysModel();
    if (!coordSysModel) {
      return;
    }
    var coordSysUid = coordSysModel.uid;
    var coordSysInfo = coordSysInfoWrap.infoMap.get(coordSysUid);
    if (!coordSysInfo) {
      coordSysInfo = {
        model: coordSysModel,
        axisModels: []
      };
      coordSysInfoWrap.infoList.push(coordSysInfo);
      coordSysInfoWrap.infoMap.set(coordSysUid, coordSysInfo);
    }
    coordSysInfo.axisModels.push(axisModel);
  });
  return coordSysInfoWrap;
}
var DataZoomAxisInfo = function() {
  function DataZoomAxisInfo2() {
    this.indexList = [];
    this.indexMap = [];
  }
  DataZoomAxisInfo2.prototype.add = function(axisCmptIdx) {
    if (!this.indexMap[axisCmptIdx]) {
      this.indexList.push(axisCmptIdx);
      this.indexMap[axisCmptIdx] = true;
    }
  };
  return DataZoomAxisInfo2;
}();
var DataZoomModel = function(_super) {
  __extends(DataZoomModel2, _super);
  function DataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomModel2.type;
    _this._autoThrottle = true;
    _this._noTarget = true;
    _this._rangePropMode = ["percent", "percent"];
    return _this;
  }
  DataZoomModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputRawOption = retrieveRawOption(option);
    this.settledOption = inputRawOption;
    this.mergeDefaultAndTheme(option, ecModel);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype.mergeOption = function(newOption) {
    var inputRawOption = retrieveRawOption(newOption);
    merge(this.option, newOption, true);
    merge(this.settledOption, inputRawOption, true);
    this._doInit(inputRawOption);
  };
  DataZoomModel2.prototype._doInit = function(inputRawOption) {
    var thisOption = this.option;
    this._setDefaultThrottle(inputRawOption);
    this._updateRangeUse(inputRawOption);
    var settledOption = this.settledOption;
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      if (this._rangePropMode[index2] === "value") {
        thisOption[names2[0]] = settledOption[names2[0]] = null;
      }
    }, this);
    this._resetTarget();
  };
  DataZoomModel2.prototype._resetTarget = function() {
    var optionOrient = this.get("orient", true);
    var targetAxisIndexMap = this._targetAxisInfoMap = createHashMap();
    var hasAxisSpecified = this._fillSpecifiedTargetAxis(targetAxisIndexMap);
    if (hasAxisSpecified) {
      this._orient = optionOrient || this._makeAutoOrientByTargetAxis();
    } else {
      this._orient = optionOrient || "horizontal";
      this._fillAutoTargetAxisByOrient(targetAxisIndexMap, this._orient);
    }
    this._noTarget = true;
    targetAxisIndexMap.each(function(axisInfo) {
      if (axisInfo.indexList.length) {
        this._noTarget = false;
      }
    }, this);
  };
  DataZoomModel2.prototype._fillSpecifiedTargetAxis = function(targetAxisIndexMap) {
    var hasAxisSpecified = false;
    each$f(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim) {
      var refering = this.getReferringComponents(getAxisMainType(axisDim), MULTIPLE_REFERRING);
      if (!refering.specified) {
        return;
      }
      hasAxisSpecified = true;
      var axisInfo = new DataZoomAxisInfo();
      each$f(refering.models, function(axisModel) {
        axisInfo.add(axisModel.componentIndex);
      });
      targetAxisIndexMap.set(axisDim, axisInfo);
    }, this);
    return hasAxisSpecified;
  };
  DataZoomModel2.prototype._fillAutoTargetAxisByOrient = function(targetAxisIndexMap, orient) {
    var ecModel = this.ecModel;
    var needAuto = true;
    if (needAuto) {
      var axisDim = orient === "vertical" ? "y" : "x";
      var axisModels = ecModel.findComponents({
        mainType: axisDim + "Axis"
      });
      setParallelAxis(axisModels, axisDim);
    }
    if (needAuto) {
      var axisModels = ecModel.findComponents({
        mainType: "singleAxis",
        filter: function(axisModel) {
          return axisModel.get("orient", true) === orient;
        }
      });
      setParallelAxis(axisModels, "single");
    }
    function setParallelAxis(axisModels2, axisDim2) {
      var axisModel = axisModels2[0];
      if (!axisModel) {
        return;
      }
      var axisInfo = new DataZoomAxisInfo();
      axisInfo.add(axisModel.componentIndex);
      targetAxisIndexMap.set(axisDim2, axisInfo);
      needAuto = false;
      if (axisDim2 === "x" || axisDim2 === "y") {
        var gridModel_1 = axisModel.getReferringComponents("grid", SINGLE_REFERRING).models[0];
        gridModel_1 && each$f(axisModels2, function(axModel) {
          if (axisModel.componentIndex !== axModel.componentIndex && gridModel_1 === axModel.getReferringComponents("grid", SINGLE_REFERRING).models[0]) {
            axisInfo.add(axModel.componentIndex);
          }
        });
      }
    }
    if (needAuto) {
      each$f(DATA_ZOOM_AXIS_DIMENSIONS, function(axisDim2) {
        if (!needAuto) {
          return;
        }
        var axisModels2 = ecModel.findComponents({
          mainType: getAxisMainType(axisDim2),
          filter: function(axisModel) {
            return axisModel.get("type", true) === "category";
          }
        });
        if (axisModels2[0]) {
          var axisInfo = new DataZoomAxisInfo();
          axisInfo.add(axisModels2[0].componentIndex);
          targetAxisIndexMap.set(axisDim2, axisInfo);
          needAuto = false;
        }
      }, this);
    }
  };
  DataZoomModel2.prototype._makeAutoOrientByTargetAxis = function() {
    var dim;
    this.eachTargetAxis(function(axisDim) {
      !dim && (dim = axisDim);
    }, this);
    return dim === "y" ? "vertical" : "horizontal";
  };
  DataZoomModel2.prototype._setDefaultThrottle = function(inputRawOption) {
    if (inputRawOption.hasOwnProperty("throttle")) {
      this._autoThrottle = false;
    }
    if (this._autoThrottle) {
      var globalOption = this.ecModel.option;
      this.option.throttle = globalOption.animation && globalOption.animationDurationUpdate > 0 ? 100 : 20;
    }
  };
  DataZoomModel2.prototype._updateRangeUse = function(inputRawOption) {
    var rangePropMode = this._rangePropMode;
    var rangeModeInOption = this.get("rangeMode");
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2, index2) {
      var percentSpecified = inputRawOption[names2[0]] != null;
      var valueSpecified = inputRawOption[names2[1]] != null;
      if (percentSpecified && !valueSpecified) {
        rangePropMode[index2] = "percent";
      } else if (!percentSpecified && valueSpecified) {
        rangePropMode[index2] = "value";
      } else if (rangeModeInOption) {
        rangePropMode[index2] = rangeModeInOption[index2];
      } else if (percentSpecified) {
        rangePropMode[index2] = "percent";
      }
    });
  };
  DataZoomModel2.prototype.noTarget = function() {
    return this._noTarget;
  };
  DataZoomModel2.prototype.getFirstTargetAxisModel = function() {
    var firstAxisModel;
    this.eachTargetAxis(function(axisDim, axisIndex) {
      if (firstAxisModel == null) {
        firstAxisModel = this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
      }
    }, this);
    return firstAxisModel;
  };
  DataZoomModel2.prototype.eachTargetAxis = function(callback, context) {
    this._targetAxisInfoMap.each(function(axisInfo, axisDim) {
      each$f(axisInfo.indexList, function(axisIndex) {
        callback.call(context, axisDim, axisIndex);
      });
    });
  };
  DataZoomModel2.prototype.getAxisProxy = function(axisDim, axisIndex) {
    var axisModel = this.getAxisModel(axisDim, axisIndex);
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
  };
  DataZoomModel2.prototype.getAxisModel = function(axisDim, axisIndex) {
    var axisInfo = this._targetAxisInfoMap.get(axisDim);
    if (axisInfo && axisInfo.indexMap[axisIndex]) {
      return this.ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
    }
  };
  DataZoomModel2.prototype.setRawRange = function(opt) {
    var thisOption = this.option;
    var settledOption = this.settledOption;
    each$f([["start", "startValue"], ["end", "endValue"]], function(names2) {
      if (opt[names2[0]] != null || opt[names2[1]] != null) {
        thisOption[names2[0]] = settledOption[names2[0]] = opt[names2[0]];
        thisOption[names2[1]] = settledOption[names2[1]] = opt[names2[1]];
      }
    }, this);
    this._updateRangeUse(opt);
  };
  DataZoomModel2.prototype.setCalculatedRange = function(opt) {
    var option = this.option;
    each$f(["start", "startValue", "end", "endValue"], function(name) {
      option[name] = opt[name];
    });
  };
  DataZoomModel2.prototype.getPercentRange = function() {
    var axisProxy = this.findRepresentativeAxisProxy();
    if (axisProxy) {
      return axisProxy.getDataPercentWindow();
    }
  };
  DataZoomModel2.prototype.getValueRange = function(axisDim, axisIndex) {
    if (axisDim == null && axisIndex == null) {
      var axisProxy = this.findRepresentativeAxisProxy();
      if (axisProxy) {
        return axisProxy.getDataValueWindow();
      }
    } else {
      return this.getAxisProxy(axisDim, axisIndex).getDataValueWindow();
    }
  };
  DataZoomModel2.prototype.findRepresentativeAxisProxy = function(axisModel) {
    if (axisModel) {
      return axisModel.__dzAxisProxy;
    }
    var firstProxy;
    var axisDimList = this._targetAxisInfoMap.keys();
    for (var i = 0; i < axisDimList.length; i++) {
      var axisDim = axisDimList[i];
      var axisInfo = this._targetAxisInfoMap.get(axisDim);
      for (var j = 0; j < axisInfo.indexList.length; j++) {
        var proxy = this.getAxisProxy(axisDim, axisInfo.indexList[j]);
        if (proxy.hostedBy(this)) {
          return proxy;
        }
        if (!firstProxy) {
          firstProxy = proxy;
        }
      }
    }
    return firstProxy;
  };
  DataZoomModel2.prototype.getRangePropMode = function() {
    return this._rangePropMode.slice();
  };
  DataZoomModel2.prototype.getOrient = function() {
    return this._orient;
  };
  DataZoomModel2.type = "dataZoom";
  DataZoomModel2.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"];
  DataZoomModel2.defaultOption = {
    z: 4,
    filterMode: "filter",
    start: 0,
    end: 100
  };
  return DataZoomModel2;
}(ComponentModel$1);
function retrieveRawOption(option) {
  var ret = {};
  each$f(["start", "end", "startValue", "endValue", "throttle"], function(name) {
    option.hasOwnProperty(name) && (ret[name] = option[name]);
  });
  return ret;
}
var DataZoomModel$1 = DataZoomModel;
var SelectDataZoomModel = function(_super) {
  __extends(SelectDataZoomModel2, _super);
  function SelectDataZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomModel2.type;
    return _this;
  }
  SelectDataZoomModel2.type = "dataZoom.select";
  return SelectDataZoomModel2;
}(DataZoomModel$1);
var SelectZoomModel = SelectDataZoomModel;
var DataZoomView = function(_super) {
  __extends(DataZoomView2, _super);
  function DataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = DataZoomView2.type;
    return _this;
  }
  DataZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    this.dataZoomModel = dataZoomModel;
    this.ecModel = ecModel;
    this.api = api;
  };
  DataZoomView2.type = "dataZoom";
  return DataZoomView2;
}(ComponentView$1);
var DataZoomView$1 = DataZoomView;
var SelectDataZoomView = function(_super) {
  __extends(SelectDataZoomView2, _super);
  function SelectDataZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SelectDataZoomView2.type;
    return _this;
  }
  SelectDataZoomView2.type = "dataZoom.select";
  return SelectDataZoomView2;
}(DataZoomView$1);
var SelectZoomView = SelectDataZoomView;
var each$7 = each$f;
var asc$1 = asc$2;
var AxisProxy = function() {
  function AxisProxy2(dimName, axisIndex, dataZoomModel, ecModel) {
    this._dimName = dimName;
    this._axisIndex = axisIndex;
    this.ecModel = ecModel;
    this._dataZoomModel = dataZoomModel;
  }
  AxisProxy2.prototype.hostedBy = function(dataZoomModel) {
    return this._dataZoomModel === dataZoomModel;
  };
  AxisProxy2.prototype.getDataValueWindow = function() {
    return this._valueWindow.slice();
  };
  AxisProxy2.prototype.getDataPercentWindow = function() {
    return this._percentWindow.slice();
  };
  AxisProxy2.prototype.getTargetSeriesModels = function() {
    var seriesModels = [];
    this.ecModel.eachSeries(function(seriesModel) {
      if (isCoordSupported(seriesModel)) {
        var axisMainType = getAxisMainType(this._dimName);
        var axisModel = seriesModel.getReferringComponents(axisMainType, SINGLE_REFERRING).models[0];
        if (axisModel && this._axisIndex === axisModel.componentIndex) {
          seriesModels.push(seriesModel);
        }
      }
    }, this);
    return seriesModels;
  };
  AxisProxy2.prototype.getAxisModel = function() {
    return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
  };
  AxisProxy2.prototype.getMinMaxSpan = function() {
    return clone$4(this._minMaxSpan);
  };
  AxisProxy2.prototype.calculateDataWindow = function(opt) {
    var dataExtent = this._dataExtent;
    var axisModel = this.getAxisModel();
    var scale2 = axisModel.axis.scale;
    var rangePropMode = this._dataZoomModel.getRangePropMode();
    var percentExtent = [0, 100];
    var percentWindow = [];
    var valueWindow = [];
    var hasPropModeValue;
    each$7(["start", "end"], function(prop, idx) {
      var boundPercent = opt[prop];
      var boundValue = opt[prop + "Value"];
      if (rangePropMode[idx] === "percent") {
        boundPercent == null && (boundPercent = percentExtent[idx]);
        boundValue = scale2.parse(linearMap$2(boundPercent, percentExtent, dataExtent));
      } else {
        hasPropModeValue = true;
        boundValue = boundValue == null ? dataExtent[idx] : scale2.parse(boundValue);
        boundPercent = linearMap$2(boundValue, dataExtent, percentExtent);
      }
      valueWindow[idx] = boundValue;
      percentWindow[idx] = boundPercent;
    });
    asc$1(valueWindow);
    asc$1(percentWindow);
    var spans = this._minMaxSpan;
    hasPropModeValue ? restrictSet(valueWindow, percentWindow, dataExtent, percentExtent, false) : restrictSet(percentWindow, valueWindow, percentExtent, dataExtent, true);
    function restrictSet(fromWindow, toWindow, fromExtent, toExtent, toValue) {
      var suffix = toValue ? "Span" : "ValueSpan";
      sliderMove(0, fromWindow, fromExtent, "all", spans["min" + suffix], spans["max" + suffix]);
      for (var i = 0; i < 2; i++) {
        toWindow[i] = linearMap$2(fromWindow[i], fromExtent, toExtent, true);
        toValue && (toWindow[i] = scale2.parse(toWindow[i]));
      }
    }
    return {
      valueWindow,
      percentWindow
    };
  };
  AxisProxy2.prototype.reset = function(dataZoomModel) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var targetSeries = this.getTargetSeriesModels();
    this._dataExtent = calculateDataExtent(this, this._dimName, targetSeries);
    this._updateMinMaxSpan();
    var dataWindow = this.calculateDataWindow(dataZoomModel.settledOption);
    this._valueWindow = dataWindow.valueWindow;
    this._percentWindow = dataWindow.percentWindow;
    this._setAxisModel();
  };
  AxisProxy2.prototype.filterData = function(dataZoomModel, api) {
    if (dataZoomModel !== this._dataZoomModel) {
      return;
    }
    var axisDim = this._dimName;
    var seriesModels = this.getTargetSeriesModels();
    var filterMode = dataZoomModel.get("filterMode");
    var valueWindow = this._valueWindow;
    if (filterMode === "none") {
      return;
    }
    each$7(seriesModels, function(seriesModel) {
      var seriesData = seriesModel.getData();
      var dataDims = seriesData.mapDimensionsAll(axisDim);
      if (!dataDims.length) {
        return;
      }
      if (filterMode === "weakFilter") {
        var store_1 = seriesData.getStore();
        var dataDimIndices_1 = map$1(dataDims, function(dim) {
          return seriesData.getDimensionIndex(dim);
        }, seriesData);
        seriesData.filterSelf(function(dataIndex) {
          var leftOut;
          var rightOut;
          var hasValue;
          for (var i = 0; i < dataDims.length; i++) {
            var value = store_1.get(dataDimIndices_1[i], dataIndex);
            var thisHasValue = !isNaN(value);
            var thisLeftOut = value < valueWindow[0];
            var thisRightOut = value > valueWindow[1];
            if (thisHasValue && !thisLeftOut && !thisRightOut) {
              return true;
            }
            thisHasValue && (hasValue = true);
            thisLeftOut && (leftOut = true);
            thisRightOut && (rightOut = true);
          }
          return hasValue && leftOut && rightOut;
        });
      } else {
        each$7(dataDims, function(dim) {
          if (filterMode === "empty") {
            seriesModel.setData(seriesData = seriesData.map(dim, function(value) {
              return !isInWindow(value) ? NaN : value;
            }));
          } else {
            var range3 = {};
            range3[dim] = valueWindow;
            seriesData.selectRange(range3);
          }
        });
      }
      each$7(dataDims, function(dim) {
        seriesData.setApproximateExtent(valueWindow, dim);
      });
    });
    function isInWindow(value) {
      return value >= valueWindow[0] && value <= valueWindow[1];
    }
  };
  AxisProxy2.prototype._updateMinMaxSpan = function() {
    var minMaxSpan = this._minMaxSpan = {};
    var dataZoomModel = this._dataZoomModel;
    var dataExtent = this._dataExtent;
    each$7(["min", "max"], function(minMax) {
      var percentSpan = dataZoomModel.get(minMax + "Span");
      var valueSpan = dataZoomModel.get(minMax + "ValueSpan");
      valueSpan != null && (valueSpan = this.getAxisModel().axis.scale.parse(valueSpan));
      if (valueSpan != null) {
        percentSpan = linearMap$2(dataExtent[0] + valueSpan, dataExtent, [0, 100], true);
      } else if (percentSpan != null) {
        valueSpan = linearMap$2(percentSpan, [0, 100], dataExtent, true) - dataExtent[0];
      }
      minMaxSpan[minMax + "Span"] = percentSpan;
      minMaxSpan[minMax + "ValueSpan"] = valueSpan;
    }, this);
  };
  AxisProxy2.prototype._setAxisModel = function() {
    var axisModel = this.getAxisModel();
    var percentWindow = this._percentWindow;
    var valueWindow = this._valueWindow;
    if (!percentWindow) {
      return;
    }
    var precision = getPixelPrecision(valueWindow, [0, 500]);
    precision = Math.min(precision, 20);
    var rawExtentInfo = axisModel.axis.scale.rawExtentInfo;
    if (percentWindow[0] !== 0) {
      rawExtentInfo.setDeterminedMinMax("min", +valueWindow[0].toFixed(precision));
    }
    if (percentWindow[1] !== 100) {
      rawExtentInfo.setDeterminedMinMax("max", +valueWindow[1].toFixed(precision));
    }
    rawExtentInfo.freeze();
  };
  return AxisProxy2;
}();
function calculateDataExtent(axisProxy, axisDim, seriesModels) {
  var dataExtent = [Infinity, -Infinity];
  each$7(seriesModels, function(seriesModel) {
    unionAxisExtentFromData(dataExtent, seriesModel.getData(), axisDim);
  });
  var axisModel = axisProxy.getAxisModel();
  var rawExtentResult = ensureScaleRawExtentInfo(axisModel.axis.scale, axisModel, dataExtent).calculate();
  return [rawExtentResult.min, rawExtentResult.max];
}
var AxisProxy$1 = AxisProxy;
var dataZoomProcessor = {
  getTargetSeries: function(ecModel) {
    function eachAxisModel(cb) {
      ecModel.eachComponent("dataZoom", function(dataZoomModel) {
        dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
          var axisModel = ecModel.getComponent(getAxisMainType(axisDim), axisIndex);
          cb(axisDim, axisIndex, axisModel, dataZoomModel);
        });
      });
    }
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      axisModel.__dzAxisProxy = null;
    });
    var proxyList = [];
    eachAxisModel(function(axisDim, axisIndex, axisModel, dataZoomModel) {
      if (!axisModel.__dzAxisProxy) {
        axisModel.__dzAxisProxy = new AxisProxy$1(axisDim, axisIndex, dataZoomModel, ecModel);
        proxyList.push(axisModel.__dzAxisProxy);
      }
    });
    var seriesModelMap = createHashMap();
    each$f(proxyList, function(axisProxy) {
      each$f(axisProxy.getTargetSeriesModels(), function(seriesModel) {
        seriesModelMap.set(seriesModel.uid, seriesModel);
      });
    });
    return seriesModelMap;
  },
  overallReset: function(ecModel, api) {
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).reset(dataZoomModel);
      });
      dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
        dataZoomModel.getAxisProxy(axisDim, axisIndex).filterData(dataZoomModel, api);
      });
    });
    ecModel.eachComponent("dataZoom", function(dataZoomModel) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var percentRange = axisProxy.getDataPercentWindow();
        var valueRange = axisProxy.getDataValueWindow();
        dataZoomModel.setCalculatedRange({
          start: percentRange[0],
          end: percentRange[1],
          startValue: valueRange[0],
          endValue: valueRange[1]
        });
      }
    });
  }
};
var dataZoomProcessor$1 = dataZoomProcessor;
function installDataZoomAction(registers) {
  registers.registerAction("dataZoom", function(payload, ecModel) {
    var effectedModels = findEffectedDataZooms(ecModel, payload);
    each$f(effectedModels, function(dataZoomModel) {
      dataZoomModel.setRawRange({
        start: payload.start,
        end: payload.end,
        startValue: payload.startValue,
        endValue: payload.endValue
      });
    });
  });
}
var installed$1 = false;
function installCommon$1(registers) {
  if (installed$1) {
    return;
  }
  installed$1 = true;
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, dataZoomProcessor$1);
  installDataZoomAction(registers);
  registers.registerSubTypeDefaulter("dataZoom", function() {
    return "slider";
  });
}
function install$k(registers) {
  registers.registerComponentModel(SelectZoomModel);
  registers.registerComponentView(SelectZoomView);
  installCommon$1(registers);
}
var ToolboxFeature = function() {
  function ToolboxFeature2() {
  }
  return ToolboxFeature2;
}();
var features = {};
function registerFeature(name, ctor) {
  features[name] = ctor;
}
function getFeature(name) {
  return features[name];
}
var ToolboxModel = function(_super) {
  __extends(ToolboxModel2, _super);
  function ToolboxModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ToolboxModel2.type;
    return _this;
  }
  ToolboxModel2.prototype.optionUpdated = function() {
    _super.prototype.optionUpdated.apply(this, arguments);
    var ecModel = this.ecModel;
    each$f(this.option.feature, function(featureOpt, featureName) {
      var Feature = getFeature(featureName);
      if (Feature) {
        if (Feature.getDefaultOption) {
          Feature.defaultOption = Feature.getDefaultOption(ecModel);
        }
        merge(featureOpt, Feature.defaultOption);
      }
    });
  };
  ToolboxModel2.type = "toolbox";
  ToolboxModel2.layoutMode = {
    type: "box",
    ignoreSize: true
  };
  ToolboxModel2.defaultOption = {
    show: true,
    z: 6,
    orient: "horizontal",
    left: "right",
    top: "top",
    backgroundColor: "transparent",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemSize: 15,
    itemGap: 8,
    showTitle: true,
    iconStyle: {
      borderColor: "#666",
      color: "none"
    },
    emphasis: {
      iconStyle: {
        borderColor: "#3E98C5"
      }
    },
    tooltip: {
      show: false,
      position: "bottom"
    }
  };
  return ToolboxModel2;
}(ComponentModel$1);
var ToolboxModel$1 = ToolboxModel;
function layout(group, componentModel, api) {
  var boxLayoutParams = componentModel.getBoxLayoutParams();
  var padding = componentModel.get("padding");
  var viewportSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var rect = getLayoutRect(boxLayoutParams, viewportSize, padding);
  box(componentModel.get("orient"), group, componentModel.get("itemGap"), rect.width, rect.height);
  positionElement(group, boxLayoutParams, viewportSize, padding);
}
function makeBackground(rect, componentModel) {
  var padding = normalizeCssArray(componentModel.get("padding"));
  var style = componentModel.getItemStyle(["color", "opacity"]);
  style.fill = componentModel.get("backgroundColor");
  rect = new Rect$3({
    shape: {
      x: rect.x - padding[3],
      y: rect.y - padding[0],
      width: rect.width + padding[1] + padding[3],
      height: rect.height + padding[0] + padding[2],
      r: componentModel.get("borderRadius")
    },
    style,
    silent: true,
    z2: -1
  });
  return rect;
}
var ToolboxView = function(_super) {
  __extends(ToolboxView2, _super);
  function ToolboxView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  ToolboxView2.prototype.render = function(toolboxModel, ecModel, api, payload) {
    var group = this.group;
    group.removeAll();
    if (!toolboxModel.get("show")) {
      return;
    }
    var itemSize = +toolboxModel.get("itemSize");
    var featureOpts = toolboxModel.get("feature") || {};
    var features2 = this._features || (this._features = {});
    var featureNames = [];
    each$f(featureOpts, function(opt, name) {
      featureNames.push(name);
    });
    new DataDiffer$1(this._featureNames || [], featureNames).add(processFeature).update(processFeature).remove(curry$1(processFeature, null)).execute();
    this._featureNames = featureNames;
    function processFeature(newIndex, oldIndex) {
      var featureName = featureNames[newIndex];
      var oldName = featureNames[oldIndex];
      var featureOpt = featureOpts[featureName];
      var featureModel = new Model$1(featureOpt, toolboxModel, toolboxModel.ecModel);
      var feature;
      if (payload && payload.newTitle != null && payload.featureName === featureName) {
        featureOpt.title = payload.newTitle;
      }
      if (featureName && !oldName) {
        if (isUserFeatureName(featureName)) {
          feature = {
            onclick: featureModel.option.onclick,
            featureName
          };
        } else {
          var Feature = getFeature(featureName);
          if (!Feature) {
            return;
          }
          feature = new Feature();
        }
        features2[featureName] = feature;
      } else {
        feature = features2[oldName];
        if (!feature) {
          return;
        }
      }
      feature.uid = getUID("toolbox-feature");
      feature.model = featureModel;
      feature.ecModel = ecModel;
      feature.api = api;
      var isToolboxFeature = feature instanceof ToolboxFeature;
      if (!featureName && oldName) {
        isToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
        return;
      }
      if (!featureModel.get("show") || isToolboxFeature && feature.unusable) {
        isToolboxFeature && feature.remove && feature.remove(ecModel, api);
        return;
      }
      createIconPaths(featureModel, feature, featureName);
      featureModel.setIconStatus = function(iconName, status) {
        var option = this.option;
        var iconPaths = this.iconPaths;
        option.iconStatus = option.iconStatus || {};
        option.iconStatus[iconName] = status;
        if (iconPaths[iconName]) {
          (status === "emphasis" ? enterEmphasis : leaveEmphasis)(iconPaths[iconName]);
        }
      };
      if (feature instanceof ToolboxFeature) {
        if (feature.render) {
          feature.render(featureModel, ecModel, api, payload);
        }
      }
    }
    function createIconPaths(featureModel, feature, featureName) {
      var iconStyleModel = featureModel.getModel("iconStyle");
      var iconStyleEmphasisModel = featureModel.getModel(["emphasis", "iconStyle"]);
      var icons = feature instanceof ToolboxFeature && feature.getIcons ? feature.getIcons() : featureModel.get("icon");
      var titles = featureModel.get("title") || {};
      var iconsMap;
      var titlesMap;
      if (isString(icons)) {
        iconsMap = {};
        iconsMap[featureName] = icons;
      } else {
        iconsMap = icons;
      }
      if (isString(titles)) {
        titlesMap = {};
        titlesMap[featureName] = titles;
      } else {
        titlesMap = titles;
      }
      var iconPaths = featureModel.iconPaths = {};
      each$f(iconsMap, function(iconStr, iconName) {
        var path = createIcon(iconStr, {}, {
          x: -itemSize / 2,
          y: -itemSize / 2,
          width: itemSize,
          height: itemSize
        });
        path.setStyle(iconStyleModel.getItemStyle());
        var pathEmphasisState = path.ensureState("emphasis");
        pathEmphasisState.style = iconStyleEmphasisModel.getItemStyle();
        var textContent = new ZRText$1({
          style: {
            text: titlesMap[iconName],
            align: iconStyleEmphasisModel.get("textAlign"),
            borderRadius: iconStyleEmphasisModel.get("textBorderRadius"),
            padding: iconStyleEmphasisModel.get("textPadding"),
            fill: null
          },
          ignore: true
        });
        path.setTextContent(textContent);
        setTooltipConfig({
          el: path,
          componentModel: toolboxModel,
          itemName: iconName,
          formatterParamsExtra: {
            title: titlesMap[iconName]
          }
        });
        path.__title = titlesMap[iconName];
        path.on("mouseover", function() {
          var hoverStyle = iconStyleEmphasisModel.getItemStyle();
          var defaultTextPosition = toolboxModel.get("orient") === "vertical" ? toolboxModel.get("right") == null ? "right" : "left" : toolboxModel.get("bottom") == null ? "bottom" : "top";
          textContent.setStyle({
            fill: iconStyleEmphasisModel.get("textFill") || hoverStyle.fill || hoverStyle.stroke || "#000",
            backgroundColor: iconStyleEmphasisModel.get("textBackgroundColor")
          });
          path.setTextConfig({
            position: iconStyleEmphasisModel.get("textPosition") || defaultTextPosition
          });
          textContent.ignore = !toolboxModel.get("showTitle");
          enterEmphasis(this);
        }).on("mouseout", function() {
          if (featureModel.get(["iconStatus", iconName]) !== "emphasis") {
            leaveEmphasis(this);
          }
          textContent.hide();
        });
        (featureModel.get(["iconStatus", iconName]) === "emphasis" ? enterEmphasis : leaveEmphasis)(path);
        group.add(path);
        path.on("click", bind$1(feature.onclick, feature, ecModel, api, iconName));
        iconPaths[iconName] = path;
      });
    }
    layout(group, toolboxModel, api);
    group.add(makeBackground(group.getBoundingRect(), toolboxModel));
    group.eachChild(function(icon) {
      var titleText = icon.__title;
      var emphasisState = icon.ensureState("emphasis");
      var emphasisTextConfig = emphasisState.textConfig || (emphasisState.textConfig = {});
      var textContent = icon.getTextContent();
      var emphasisTextState = textContent && textContent.states.emphasis;
      if (emphasisTextState && !isFunction(emphasisTextState) && titleText) {
        var emphasisTextStyle = emphasisTextState.style || (emphasisTextState.style = {});
        var rect = getBoundingRect(titleText, ZRText$1.makeFont(emphasisTextStyle));
        var offsetX = icon.x + group.x;
        var offsetY = icon.y + group.y + itemSize;
        var needPutOnTop = false;
        if (offsetY + rect.height > api.getHeight()) {
          emphasisTextConfig.position = "top";
          needPutOnTop = true;
        }
        var topOffset = needPutOnTop ? -5 - rect.height : itemSize + 8;
        if (offsetX + rect.width / 2 > api.getWidth()) {
          emphasisTextConfig.position = ["100%", topOffset];
          emphasisTextStyle.align = "right";
        } else if (offsetX - rect.width / 2 < 0) {
          emphasisTextConfig.position = [0, topOffset];
          emphasisTextStyle.align = "left";
        }
      }
    });
  };
  ToolboxView2.prototype.updateView = function(toolboxModel, ecModel, api, payload) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.updateView && feature.updateView(feature.model, ecModel, api, payload);
    });
  };
  ToolboxView2.prototype.remove = function(ecModel, api) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.remove && feature.remove(ecModel, api);
    });
    this.group.removeAll();
  };
  ToolboxView2.prototype.dispose = function(ecModel, api) {
    each$f(this._features, function(feature) {
      feature instanceof ToolboxFeature && feature.dispose && feature.dispose(ecModel, api);
    });
  };
  ToolboxView2.type = "toolbox";
  return ToolboxView2;
}(ComponentView$1);
function isUserFeatureName(featureName) {
  return featureName.indexOf("my") === 0;
}
var ToolboxView$1 = ToolboxView;
var SaveAsImage = function(_super) {
  __extends(SaveAsImage2, _super);
  function SaveAsImage2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  SaveAsImage2.prototype.onclick = function(ecModel, api) {
    var model = this.model;
    var title = model.get("name") || ecModel.get("title.0.text") || "echarts";
    var isSvg = api.getZr().painter.getType() === "svg";
    var type4 = isSvg ? "svg" : model.get("type", true) || "png";
    var url2 = api.getConnectedDataURL({
      type: type4,
      backgroundColor: model.get("backgroundColor", true) || ecModel.get("backgroundColor") || "#fff",
      connectedBackgroundColor: model.get("connectedBackgroundColor"),
      excludeComponents: model.get("excludeComponents"),
      pixelRatio: model.get("pixelRatio")
    });
    var browser = env$1.browser;
    if (isFunction(MouseEvent) && (browser.newEdge || !browser.ie && !browser.edge)) {
      var $a = document.createElement("a");
      $a.download = title + "." + type4;
      $a.target = "_blank";
      $a.href = url2;
      var evt = new MouseEvent("click", {
        view: document.defaultView,
        bubbles: true,
        cancelable: false
      });
      $a.dispatchEvent(evt);
    } else {
      if (window.navigator.msSaveOrOpenBlob || isSvg) {
        var parts = url2.split(",");
        var base64Encoded = parts[0].indexOf("base64") > -1;
        var bstr = isSvg ? decodeURIComponent(parts[1]) : parts[1];
        base64Encoded && (bstr = window.atob(bstr));
        var filename = title + "." + type4;
        if (window.navigator.msSaveOrOpenBlob) {
          var n2 = bstr.length;
          var u8arr = new Uint8Array(n2);
          while (n2--) {
            u8arr[n2] = bstr.charCodeAt(n2);
          }
          var blob = new Blob([u8arr]);
          window.navigator.msSaveOrOpenBlob(blob, filename);
        } else {
          var frame = document.createElement("iframe");
          document.body.appendChild(frame);
          var cw = frame.contentWindow;
          var doc = cw.document;
          doc.open("image/svg+xml", "replace");
          doc.write(bstr);
          doc.close();
          cw.focus();
          doc.execCommand("SaveAs", true, filename);
          document.body.removeChild(frame);
        }
      } else {
        var lang = model.get("lang");
        var html = '<body style="margin:0;"><img src="' + url2 + '" style="max-width:100%;" title="' + (lang && lang[0] || "") + '" /></body>';
        var tab = window.open();
        tab.document.write(html);
        tab.document.title = title;
      }
    }
  };
  SaveAsImage2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0",
      title: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "title"]),
      type: "png",
      connectedBackgroundColor: "#fff",
      name: "",
      excludeComponents: ["toolbox"],
      lang: ecModel.getLocaleModel().get(["toolbox", "saveAsImage", "lang"])
    };
    return defaultOption2;
  };
  return SaveAsImage2;
}(ToolboxFeature);
var SaveAsImage$1 = SaveAsImage;
var INNER_STACK_KEYWORD = "__ec_magicType_stack__";
var radioTypes = [["line", "bar"], ["stack"]];
var MagicType = function(_super) {
  __extends(MagicType2, _super);
  function MagicType2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  MagicType2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon");
    var icons = {};
    each$f(model.get("type"), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  MagicType2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: [],
      icon: {
        line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4",
        bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7",
        stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "magicType", "title"]),
      option: {},
      seriesIndex: {}
    };
    return defaultOption2;
  };
  MagicType2.prototype.onclick = function(ecModel, api, type4) {
    var model = this.model;
    var seriesIndex = model.get(["seriesIndex", type4]);
    if (!seriesOptGenreator[type4]) {
      return;
    }
    var newOption = {
      series: []
    };
    var generateNewSeriesTypes = function(seriesModel) {
      var seriesType2 = seriesModel.subType;
      var seriesId = seriesModel.id;
      var newSeriesOpt = seriesOptGenreator[type4](seriesType2, seriesId, seriesModel, model);
      if (newSeriesOpt) {
        defaults(newSeriesOpt, seriesModel.option);
        newOption.series.push(newSeriesOpt);
      }
      var coordSys = seriesModel.coordinateSystem;
      if (coordSys && coordSys.type === "cartesian2d" && (type4 === "line" || type4 === "bar")) {
        var categoryAxis2 = coordSys.getAxesByScale("ordinal")[0];
        if (categoryAxis2) {
          var axisDim = categoryAxis2.dim;
          var axisType = axisDim + "Axis";
          var axisModel = seriesModel.getReferringComponents(axisType, SINGLE_REFERRING).models[0];
          var axisIndex = axisModel.componentIndex;
          newOption[axisType] = newOption[axisType] || [];
          for (var i = 0; i <= axisIndex; i++) {
            newOption[axisType][axisIndex] = newOption[axisType][axisIndex] || {};
          }
          newOption[axisType][axisIndex].boundaryGap = type4 === "bar";
        }
      }
    };
    each$f(radioTypes, function(radio) {
      if (indexOf(radio, type4) >= 0) {
        each$f(radio, function(item) {
          model.setIconStatus(item, "normal");
        });
      }
    });
    model.setIconStatus(type4, "emphasis");
    ecModel.eachComponent({
      mainType: "series",
      query: seriesIndex == null ? null : {
        seriesIndex
      }
    }, generateNewSeriesTypes);
    var newTitle;
    var currentType = type4;
    if (type4 === "stack") {
      newTitle = merge({
        stack: model.option.title.tiled,
        tiled: model.option.title.stack
      }, model.option.title);
      if (model.get(["iconStatus", type4]) !== "emphasis") {
        currentType = "tiled";
      }
    }
    api.dispatchAction({
      type: "changeMagicType",
      currentType,
      newOption,
      newTitle,
      featureName: "magicType"
    });
  };
  return MagicType2;
}(ToolboxFeature);
var seriesOptGenreator = {
  "line": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "bar") {
      return merge({
        id: seriesId,
        type: "line",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "line"]) || {}, true);
    }
  },
  "bar": function(seriesType2, seriesId, seriesModel, model) {
    if (seriesType2 === "line") {
      return merge({
        id: seriesId,
        type: "bar",
        data: seriesModel.get("data"),
        stack: seriesModel.get("stack"),
        markPoint: seriesModel.get("markPoint"),
        markLine: seriesModel.get("markLine")
      }, model.get(["option", "bar"]) || {}, true);
    }
  },
  "stack": function(seriesType2, seriesId, seriesModel, model) {
    var isStack = seriesModel.get("stack") === INNER_STACK_KEYWORD;
    if (seriesType2 === "line" || seriesType2 === "bar") {
      model.setIconStatus("stack", isStack ? "normal" : "emphasis");
      return merge({
        id: seriesId,
        stack: isStack ? "" : INNER_STACK_KEYWORD
      }, model.get(["option", "stack"]) || {}, true);
    }
  }
};
registerAction({
  type: "changeMagicType",
  event: "magicTypeChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.mergeOption(payload.newOption);
});
var MagicType$1 = MagicType;
var BLOCK_SPLITER = new Array(60).join("-");
var ITEM_SPLITER = "	";
function groupSeries(ecModel) {
  var seriesGroupByCategoryAxis = {};
  var otherSeries = [];
  var meta = [];
  ecModel.eachRawSeries(function(seriesModel) {
    var coordSys = seriesModel.coordinateSystem;
    if (coordSys && (coordSys.type === "cartesian2d" || coordSys.type === "polar")) {
      var baseAxis = coordSys.getBaseAxis();
      if (baseAxis.type === "category") {
        var key = baseAxis.dim + "_" + baseAxis.index;
        if (!seriesGroupByCategoryAxis[key]) {
          seriesGroupByCategoryAxis[key] = {
            categoryAxis: baseAxis,
            valueAxis: coordSys.getOtherAxis(baseAxis),
            series: []
          };
          meta.push({
            axisDim: baseAxis.dim,
            axisIndex: baseAxis.index
          });
        }
        seriesGroupByCategoryAxis[key].series.push(seriesModel);
      } else {
        otherSeries.push(seriesModel);
      }
    } else {
      otherSeries.push(seriesModel);
    }
  });
  return {
    seriesGroupByCategoryAxis,
    other: otherSeries,
    meta
  };
}
function assembleSeriesWithCategoryAxis(groups) {
  var tables = [];
  each$f(groups, function(group, key) {
    var categoryAxis2 = group.categoryAxis;
    var valueAxis2 = group.valueAxis;
    var valueAxisDim = valueAxis2.dim;
    var headers = [" "].concat(map$1(group.series, function(series) {
      return series.name;
    }));
    var columns = [categoryAxis2.model.getCategories()];
    each$f(group.series, function(series) {
      var rawData = series.getRawData();
      columns.push(series.getRawData().mapArray(rawData.mapDimension(valueAxisDim), function(val) {
        return val;
      }));
    });
    var lines = [headers.join(ITEM_SPLITER)];
    for (var i = 0; i < columns[0].length; i++) {
      var items = [];
      for (var j = 0; j < columns.length; j++) {
        items.push(columns[j][i]);
      }
      lines.push(items.join(ITEM_SPLITER));
    }
    tables.push(lines.join("\n"));
  });
  return tables.join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function assembleOtherSeries(series) {
  return map$1(series, function(series2) {
    var data = series2.getRawData();
    var lines = [series2.name];
    var vals = [];
    data.each(data.dimensions, function() {
      var argLen = arguments.length;
      var dataIndex = arguments[argLen - 1];
      var name = data.getName(dataIndex);
      for (var i = 0; i < argLen - 1; i++) {
        vals[i] = arguments[i];
      }
      lines.push((name ? name + ITEM_SPLITER : "") + vals.join(ITEM_SPLITER));
    });
    return lines.join("\n");
  }).join("\n\n" + BLOCK_SPLITER + "\n\n");
}
function getContentFromModel(ecModel) {
  var result = groupSeries(ecModel);
  return {
    value: filter([assembleSeriesWithCategoryAxis(result.seriesGroupByCategoryAxis), assembleOtherSeries(result.other)], function(str) {
      return !!str.replace(/[\n\t\s]/g, "");
    }).join("\n\n" + BLOCK_SPLITER + "\n\n"),
    meta: result.meta
  };
}
function trim(str) {
  return str.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function isTSVFormat(block) {
  var firstLine = block.slice(0, block.indexOf("\n"));
  if (firstLine.indexOf(ITEM_SPLITER) >= 0) {
    return true;
  }
}
var itemSplitRegex = new RegExp("[" + ITEM_SPLITER + "]+", "g");
function parseTSVContents(tsv) {
  var tsvLines = tsv.split(/\n+/g);
  var headers = trim(tsvLines.shift()).split(itemSplitRegex);
  var categories = [];
  var series = map$1(headers, function(header) {
    return {
      name: header,
      data: []
    };
  });
  for (var i = 0; i < tsvLines.length; i++) {
    var items = trim(tsvLines[i]).split(itemSplitRegex);
    categories.push(items.shift());
    for (var j = 0; j < items.length; j++) {
      series[j] && (series[j].data[i] = items[j]);
    }
  }
  return {
    series,
    categories
  };
}
function parseListContents(str) {
  var lines = str.split(/\n+/g);
  var seriesName = trim(lines.shift());
  var data = [];
  for (var i = 0; i < lines.length; i++) {
    var line = trim(lines[i]);
    if (!line) {
      continue;
    }
    var items = line.split(itemSplitRegex);
    var name_1 = "";
    var value = void 0;
    var hasName = false;
    if (isNaN(items[0])) {
      hasName = true;
      name_1 = items[0];
      items = items.slice(1);
      data[i] = {
        name: name_1,
        value: []
      };
      value = data[i].value;
    } else {
      value = data[i] = [];
    }
    for (var j = 0; j < items.length; j++) {
      value.push(+items[j]);
    }
    if (value.length === 1) {
      hasName ? data[i].value = value[0] : data[i] = value[0];
    }
  }
  return {
    name: seriesName,
    data
  };
}
function parseContents(str, blockMetaList) {
  var blocks = str.split(new RegExp("\n*" + BLOCK_SPLITER + "\n*", "g"));
  var newOption = {
    series: []
  };
  each$f(blocks, function(block, idx) {
    if (isTSVFormat(block)) {
      var result = parseTSVContents(block);
      var blockMeta = blockMetaList[idx];
      var axisKey = blockMeta.axisDim + "Axis";
      if (blockMeta) {
        newOption[axisKey] = newOption[axisKey] || [];
        newOption[axisKey][blockMeta.axisIndex] = {
          data: result.categories
        };
        newOption.series = newOption.series.concat(result.series);
      }
    } else {
      var result = parseListContents(block);
      newOption.series.push(result);
    }
  });
  return newOption;
}
var DataView = function(_super) {
  __extends(DataView2, _super);
  function DataView2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataView2.prototype.onclick = function(ecModel, api) {
    setTimeout(function() {
      api.dispatchAction({
        type: "hideTip"
      });
    });
    var container2 = api.getDom();
    var model = this.model;
    if (this._dom) {
      container2.removeChild(this._dom);
    }
    var root2 = document.createElement("div");
    root2.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px";
    root2.style.backgroundColor = model.get("backgroundColor") || "#fff";
    var header = document.createElement("h4");
    var lang = model.get("lang") || [];
    header.innerHTML = lang[0] || model.get("title");
    header.style.cssText = "margin:10px 20px";
    header.style.color = model.get("textColor");
    var viewMain = document.createElement("div");
    var textarea = document.createElement("textarea");
    viewMain.style.cssText = "overflow:auto";
    var optionToContent = model.get("optionToContent");
    var contentToOption = model.get("contentToOption");
    var result = getContentFromModel(ecModel);
    if (isFunction(optionToContent)) {
      var htmlOrDom = optionToContent(api.getOption());
      if (isString(htmlOrDom)) {
        viewMain.innerHTML = htmlOrDom;
      } else if (isDom(htmlOrDom)) {
        viewMain.appendChild(htmlOrDom);
      }
    } else {
      textarea.readOnly = model.get("readOnly");
      var style = textarea.style;
      style.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none";
      style.color = model.get("textColor");
      style.borderColor = model.get("textareaBorderColor");
      style.backgroundColor = model.get("textareaColor");
      textarea.value = result.value;
      viewMain.appendChild(textarea);
    }
    var blockMetaList = result.meta;
    var buttonContainer = document.createElement("div");
    buttonContainer.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
    var buttonStyle = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px";
    var closeButton = document.createElement("div");
    var refreshButton = document.createElement("div");
    buttonStyle += ";background-color:" + model.get("buttonColor");
    buttonStyle += ";color:" + model.get("buttonTextColor");
    var self2 = this;
    function close() {
      container2.removeChild(root2);
      self2._dom = null;
    }
    addEventListener(closeButton, "click", close);
    addEventListener(refreshButton, "click", function() {
      if (contentToOption == null && optionToContent != null || contentToOption != null && optionToContent == null) {
        close();
        return;
      }
      var newOption;
      try {
        if (isFunction(contentToOption)) {
          newOption = contentToOption(viewMain, api.getOption());
        } else {
          newOption = parseContents(textarea.value, blockMetaList);
        }
      } catch (e2) {
        close();
        throw new Error("Data view format error " + e2);
      }
      if (newOption) {
        api.dispatchAction({
          type: "changeDataView",
          newOption
        });
      }
      close();
    });
    closeButton.innerHTML = lang[1];
    refreshButton.innerHTML = lang[2];
    refreshButton.style.cssText = closeButton.style.cssText = buttonStyle;
    !model.get("readOnly") && buttonContainer.appendChild(refreshButton);
    buttonContainer.appendChild(closeButton);
    root2.appendChild(header);
    root2.appendChild(viewMain);
    root2.appendChild(buttonContainer);
    viewMain.style.height = container2.clientHeight - 80 + "px";
    container2.appendChild(root2);
    this._dom = root2;
  };
  DataView2.prototype.remove = function(ecModel, api) {
    this._dom && api.getDom().removeChild(this._dom);
  };
  DataView2.prototype.dispose = function(ecModel, api) {
    this.remove(ecModel, api);
  };
  DataView2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      readOnly: false,
      optionToContent: null,
      contentToOption: null,
      icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28",
      title: ecModel.getLocaleModel().get(["toolbox", "dataView", "title"]),
      lang: ecModel.getLocaleModel().get(["toolbox", "dataView", "lang"]),
      backgroundColor: "#fff",
      textColor: "#000",
      textareaColor: "#fff",
      textareaBorderColor: "#333",
      buttonColor: "#c23531",
      buttonTextColor: "#fff"
    };
    return defaultOption2;
  };
  return DataView2;
}(ToolboxFeature);
function tryMergeDataOption(newData, originalData) {
  return map$1(newData, function(newVal, idx) {
    var original = originalData && originalData[idx];
    if (isObject$4(original) && !isArray$1(original)) {
      var newValIsObject = isObject$4(newVal) && !isArray$1(newVal);
      if (!newValIsObject) {
        newVal = {
          value: newVal
        };
      }
      var shouldDeleteName = original.name != null && newVal.name == null;
      newVal = defaults(newVal, original);
      shouldDeleteName && delete newVal.name;
      return newVal;
    } else {
      return newVal;
    }
  });
}
registerAction({
  type: "changeDataView",
  event: "dataViewChanged",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  var newSeriesOptList = [];
  each$f(payload.newOption.series, function(seriesOpt) {
    var seriesModel = ecModel.getSeriesByName(seriesOpt.name)[0];
    if (!seriesModel) {
      newSeriesOptList.push(extend({
        type: "scatter"
      }, seriesOpt));
    } else {
      var originalData = seriesModel.get("data");
      newSeriesOptList.push({
        name: seriesOpt.name,
        data: tryMergeDataOption(seriesOpt.data, originalData)
      });
    }
  });
  ecModel.mergeOption(defaults({
    series: newSeriesOptList
  }, payload.newOption));
});
var DataView$1 = DataView;
var each$6 = each$f;
var inner$6 = makeInner();
function push(ecModel, newSnapshot) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  each$6(newSnapshot, function(batchItem, dataZoomId) {
    var i = storedSnapshots.length - 1;
    for (; i >= 0; i--) {
      var snapshot = storedSnapshots[i];
      if (snapshot[dataZoomId]) {
        break;
      }
    }
    if (i < 0) {
      var dataZoomModel = ecModel.queryComponents({
        mainType: "dataZoom",
        subType: "select",
        id: dataZoomId
      })[0];
      if (dataZoomModel) {
        var percentRange = dataZoomModel.getPercentRange();
        storedSnapshots[0][dataZoomId] = {
          dataZoomId,
          start: percentRange[0],
          end: percentRange[1]
        };
      }
    }
  });
  storedSnapshots.push(newSnapshot);
}
function pop(ecModel) {
  var storedSnapshots = getStoreSnapshots(ecModel);
  var head = storedSnapshots[storedSnapshots.length - 1];
  storedSnapshots.length > 1 && storedSnapshots.pop();
  var snapshot = {};
  each$6(head, function(batchItem, dataZoomId) {
    for (var i = storedSnapshots.length - 1; i >= 0; i--) {
      batchItem = storedSnapshots[i][dataZoomId];
      if (batchItem) {
        snapshot[dataZoomId] = batchItem;
        break;
      }
    }
  });
  return snapshot;
}
function clear(ecModel) {
  inner$6(ecModel).snapshots = null;
}
function count(ecModel) {
  return getStoreSnapshots(ecModel).length;
}
function getStoreSnapshots(ecModel) {
  var store = inner$6(ecModel);
  if (!store.snapshots) {
    store.snapshots = [{}];
  }
  return store.snapshots;
}
var RestoreOption = function(_super) {
  __extends(RestoreOption2, _super);
  function RestoreOption2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  RestoreOption2.prototype.onclick = function(ecModel, api) {
    clear(ecModel);
    api.dispatchAction({
      type: "restore",
      from: this.uid
    });
  };
  RestoreOption2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5",
      title: ecModel.getLocaleModel().get(["toolbox", "restore", "title"])
    };
    return defaultOption2;
  };
  return RestoreOption2;
}(ToolboxFeature);
registerAction({
  type: "restore",
  event: "restore",
  update: "prepareAndUpdate"
}, function(payload, ecModel) {
  ecModel.resetOption("recreate");
});
var Restore = RestoreOption;
var INCLUDE_FINDER_MAIN_TYPES = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"];
var BrushTargetManager = function() {
  function BrushTargetManager2(finder, ecModel, opt) {
    var _this = this;
    this._targetInfoList = [];
    var foundCpts = parseFinder(ecModel, finder);
    each$f(targetInfoBuilders, function(builder, type4) {
      if (!opt || !opt.include || indexOf(opt.include, type4) >= 0) {
        builder(foundCpts, _this._targetInfoList);
      }
    });
  }
  BrushTargetManager2.prototype.setOutputRanges = function(areas, ecModel) {
    this.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      (area.coordRanges || (area.coordRanges = [])).push(coordRange);
      if (!area.coordRange) {
        area.coordRange = coordRange;
        var result = coordConvert[area.brushType](0, coordSys, coordRange);
        area.__rangeOffset = {
          offset: diffProcessor[area.brushType](result.values, area.range, [1, 1]),
          xyMinMax: result.xyMinMax
        };
      }
    });
    return areas;
  };
  BrushTargetManager2.prototype.matchOutputRanges = function(areas, ecModel, cb) {
    each$f(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      if (targetInfo && targetInfo !== true) {
        each$f(targetInfo.coordSyses, function(coordSys) {
          var result = coordConvert[area.brushType](1, coordSys, area.range, true);
          cb(area, result.values, coordSys, ecModel);
        });
      }
    }, this);
  };
  BrushTargetManager2.prototype.setInputRanges = function(areas, ecModel) {
    each$f(areas, function(area) {
      var targetInfo = this.findTargetInfo(area, ecModel);
      area.range = area.range || [];
      if (targetInfo && targetInfo !== true) {
        area.panelId = targetInfo.panelId;
        var result = coordConvert[area.brushType](0, targetInfo.coordSys, area.coordRange);
        var rangeOffset = area.__rangeOffset;
        area.range = rangeOffset ? diffProcessor[area.brushType](result.values, rangeOffset.offset, getScales(result.xyMinMax, rangeOffset.xyMinMax)) : result.values;
      }
    }, this);
  };
  BrushTargetManager2.prototype.makePanelOpts = function(api, getDefaultBrushType) {
    return map$1(this._targetInfoList, function(targetInfo) {
      var rect = targetInfo.getPanelRect();
      return {
        panelId: targetInfo.panelId,
        defaultBrushType: getDefaultBrushType ? getDefaultBrushType(targetInfo) : null,
        clipPath: makeRectPanelClipPath(rect),
        isTargetByCursor: makeRectIsTargetByCursor(rect, api, targetInfo.coordSysModel),
        getLinearBrushOtherExtent: makeLinearBrushOtherExtent(rect)
      };
    });
  };
  BrushTargetManager2.prototype.controlSeries = function(area, seriesModel, ecModel) {
    var targetInfo = this.findTargetInfo(area, ecModel);
    return targetInfo === true || targetInfo && indexOf(targetInfo.coordSyses, seriesModel.coordinateSystem) >= 0;
  };
  BrushTargetManager2.prototype.findTargetInfo = function(area, ecModel) {
    var targetInfoList = this._targetInfoList;
    var foundCpts = parseFinder(ecModel, area);
    for (var i = 0; i < targetInfoList.length; i++) {
      var targetInfo = targetInfoList[i];
      var areaPanelId = area.panelId;
      if (areaPanelId) {
        if (targetInfo.panelId === areaPanelId) {
          return targetInfo;
        }
      } else {
        for (var j = 0; j < targetInfoMatchers.length; j++) {
          if (targetInfoMatchers[j](foundCpts, targetInfo)) {
            return targetInfo;
          }
        }
      }
    }
    return true;
  };
  return BrushTargetManager2;
}();
function formatMinMax(minMax) {
  minMax[0] > minMax[1] && minMax.reverse();
  return minMax;
}
function parseFinder(ecModel, finder) {
  return parseFinder$1(ecModel, finder, {
    includeMainTypes: INCLUDE_FINDER_MAIN_TYPES
  });
}
var targetInfoBuilders = {
  grid: function(foundCpts, targetInfoList) {
    var xAxisModels = foundCpts.xAxisModels;
    var yAxisModels = foundCpts.yAxisModels;
    var gridModels = foundCpts.gridModels;
    var gridModelMap = createHashMap();
    var xAxesHas = {};
    var yAxesHas = {};
    if (!xAxisModels && !yAxisModels && !gridModels) {
      return;
    }
    each$f(xAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
    });
    each$f(yAxisModels, function(axisModel) {
      var gridModel = axisModel.axis.grid.model;
      gridModelMap.set(gridModel.id, gridModel);
      yAxesHas[gridModel.id] = true;
    });
    each$f(gridModels, function(gridModel) {
      gridModelMap.set(gridModel.id, gridModel);
      xAxesHas[gridModel.id] = true;
      yAxesHas[gridModel.id] = true;
    });
    gridModelMap.each(function(gridModel) {
      var grid = gridModel.coordinateSystem;
      var cartesians = [];
      each$f(grid.getCartesians(), function(cartesian, index2) {
        if (indexOf(xAxisModels, cartesian.getAxis("x").model) >= 0 || indexOf(yAxisModels, cartesian.getAxis("y").model) >= 0) {
          cartesians.push(cartesian);
        }
      });
      targetInfoList.push({
        panelId: "grid--" + gridModel.id,
        gridModel,
        coordSysModel: gridModel,
        coordSys: cartesians[0],
        coordSyses: cartesians,
        getPanelRect: panelRectBuilders.grid,
        xAxisDeclared: xAxesHas[gridModel.id],
        yAxisDeclared: yAxesHas[gridModel.id]
      });
    });
  },
  geo: function(foundCpts, targetInfoList) {
    each$f(foundCpts.geoModels, function(geoModel) {
      var coordSys = geoModel.coordinateSystem;
      targetInfoList.push({
        panelId: "geo--" + geoModel.id,
        geoModel,
        coordSysModel: geoModel,
        coordSys,
        coordSyses: [coordSys],
        getPanelRect: panelRectBuilders.geo
      });
    });
  }
};
var targetInfoMatchers = [
  function(foundCpts, targetInfo) {
    var xAxisModel = foundCpts.xAxisModel;
    var yAxisModel = foundCpts.yAxisModel;
    var gridModel = foundCpts.gridModel;
    !gridModel && xAxisModel && (gridModel = xAxisModel.axis.grid.model);
    !gridModel && yAxisModel && (gridModel = yAxisModel.axis.grid.model);
    return gridModel && gridModel === targetInfo.gridModel;
  },
  function(foundCpts, targetInfo) {
    var geoModel = foundCpts.geoModel;
    return geoModel && geoModel === targetInfo.geoModel;
  }
];
var panelRectBuilders = {
  grid: function() {
    return this.coordSys.master.getRect().clone();
  },
  geo: function() {
    var coordSys = this.coordSys;
    var rect = coordSys.getBoundingRect().clone();
    rect.applyTransform(getTransform$1(coordSys));
    return rect;
  }
};
var coordConvert = {
  lineX: curry$1(axisConvert, 0),
  lineY: curry$1(axisConvert, 1),
  rect: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xminymin = to ? coordSys.pointToData([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][0], rangeOrCoordRange[1][0]], clamp2);
    var xmaxymax = to ? coordSys.pointToData([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2) : coordSys.dataToPoint([rangeOrCoordRange[0][1], rangeOrCoordRange[1][1]], clamp2);
    var values = [formatMinMax([xminymin[0], xmaxymax[0]]), formatMinMax([xminymin[1], xmaxymax[1]])];
    return {
      values,
      xyMinMax: values
    };
  },
  polygon: function(to, coordSys, rangeOrCoordRange, clamp2) {
    var xyMinMax = [[Infinity, -Infinity], [Infinity, -Infinity]];
    var values = map$1(rangeOrCoordRange, function(item) {
      var p2 = to ? coordSys.pointToData(item, clamp2) : coordSys.dataToPoint(item, clamp2);
      xyMinMax[0][0] = Math.min(xyMinMax[0][0], p2[0]);
      xyMinMax[1][0] = Math.min(xyMinMax[1][0], p2[1]);
      xyMinMax[0][1] = Math.max(xyMinMax[0][1], p2[0]);
      xyMinMax[1][1] = Math.max(xyMinMax[1][1], p2[1]);
      return p2;
    });
    return {
      values,
      xyMinMax
    };
  }
};
function axisConvert(axisNameIndex, to, coordSys, rangeOrCoordRange) {
  var axis = coordSys.getAxis(["x", "y"][axisNameIndex]);
  var values = formatMinMax(map$1([0, 1], function(i) {
    return to ? axis.coordToData(axis.toLocalCoord(rangeOrCoordRange[i]), true) : axis.toGlobalCoord(axis.dataToCoord(rangeOrCoordRange[i]));
  }));
  var xyMinMax = [];
  xyMinMax[axisNameIndex] = values;
  xyMinMax[1 - axisNameIndex] = [NaN, NaN];
  return {
    values,
    xyMinMax
  };
}
var diffProcessor = {
  lineX: curry$1(axisDiffProcessor, 0),
  lineY: curry$1(axisDiffProcessor, 1),
  rect: function(values, refer, scales) {
    return [[values[0][0] - scales[0] * refer[0][0], values[0][1] - scales[0] * refer[0][1]], [values[1][0] - scales[1] * refer[1][0], values[1][1] - scales[1] * refer[1][1]]];
  },
  polygon: function(values, refer, scales) {
    return map$1(values, function(item, idx) {
      return [item[0] - scales[0] * refer[idx][0], item[1] - scales[1] * refer[idx][1]];
    });
  }
};
function axisDiffProcessor(axisNameIndex, values, refer, scales) {
  return [values[0] - scales[axisNameIndex] * refer[0], values[1] - scales[axisNameIndex] * refer[1]];
}
function getScales(xyMinMaxCurr, xyMinMaxOrigin) {
  var sizeCurr = getSize(xyMinMaxCurr);
  var sizeOrigin = getSize(xyMinMaxOrigin);
  var scales = [sizeCurr[0] / sizeOrigin[0], sizeCurr[1] / sizeOrigin[1]];
  isNaN(scales[0]) && (scales[0] = 1);
  isNaN(scales[1]) && (scales[1] = 1);
  return scales;
}
function getSize(xyMinMax) {
  return xyMinMax ? [xyMinMax[0][1] - xyMinMax[0][0], xyMinMax[1][1] - xyMinMax[1][0]] : [NaN, NaN];
}
var BrushTargetManager$1 = BrushTargetManager;
var each$5 = each$f;
var DATA_ZOOM_ID_BASE = makeInternalComponentId("toolbox-dataZoom_");
var DataZoomFeature = function(_super) {
  __extends(DataZoomFeature2, _super);
  function DataZoomFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  DataZoomFeature2.prototype.render = function(featureModel, ecModel, api, payload) {
    if (!this._brushController) {
      this._brushController = new BrushController$1(api.getZr());
      this._brushController.on("brush", bind$1(this._onBrush, this)).mount();
    }
    updateZoomBtnStatus(featureModel, ecModel, this, payload, api);
    updateBackBtnStatus(featureModel, ecModel);
  };
  DataZoomFeature2.prototype.onclick = function(ecModel, api, type4) {
    handlers[type4].call(this);
  };
  DataZoomFeature2.prototype.remove = function(ecModel, api) {
    this._brushController && this._brushController.unmount();
  };
  DataZoomFeature2.prototype.dispose = function(ecModel, api) {
    this._brushController && this._brushController.dispose();
  };
  DataZoomFeature2.prototype._onBrush = function(eventParam) {
    var areas = eventParam.areas;
    if (!eventParam.isEnd || !areas.length) {
      return;
    }
    var snapshot = {};
    var ecModel = this.ecModel;
    this._brushController.updateCovers([]);
    var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(this.model), ecModel, {
      include: ["grid"]
    });
    brushTargetManager.matchOutputRanges(areas, ecModel, function(area, coordRange, coordSys) {
      if (coordSys.type !== "cartesian2d") {
        return;
      }
      var brushType = area.brushType;
      if (brushType === "rect") {
        setBatch("x", coordSys, coordRange[0]);
        setBatch("y", coordSys, coordRange[1]);
      } else {
        setBatch({
          lineX: "x",
          lineY: "y"
        }[brushType], coordSys, coordRange);
      }
    });
    push(ecModel, snapshot);
    this._dispatchZoomAction(snapshot);
    function setBatch(dimName, coordSys, minMax) {
      var axis = coordSys.getAxis(dimName);
      var axisModel = axis.model;
      var dataZoomModel = findDataZoom(dimName, axisModel, ecModel);
      var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy(axisModel).getMinMaxSpan();
      if (minMaxSpan.minValueSpan != null || minMaxSpan.maxValueSpan != null) {
        minMax = sliderMove(0, minMax.slice(), axis.scale.getExtent(), 0, minMaxSpan.minValueSpan, minMaxSpan.maxValueSpan);
      }
      dataZoomModel && (snapshot[dataZoomModel.id] = {
        dataZoomId: dataZoomModel.id,
        startValue: minMax[0],
        endValue: minMax[1]
      });
    }
    function findDataZoom(dimName, axisModel, ecModel2) {
      var found;
      ecModel2.eachComponent({
        mainType: "dataZoom",
        subType: "select"
      }, function(dzModel) {
        var has2 = dzModel.getAxisModel(dimName, axisModel.componentIndex);
        has2 && (found = dzModel);
      });
      return found;
    }
  };
  DataZoomFeature2.prototype._dispatchZoomAction = function(snapshot) {
    var batch = [];
    each$5(snapshot, function(batchItem, dataZoomId) {
      batch.push(clone$4(batchItem));
    });
    batch.length && this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      batch
    });
  };
  DataZoomFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      filterMode: "filter",
      icon: {
        zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1",
        back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "dataZoom", "title"]),
      brushStyle: {
        borderWidth: 0,
        color: "rgba(210,219,238,0.2)"
      }
    };
    return defaultOption2;
  };
  return DataZoomFeature2;
}(ToolboxFeature);
var handlers = {
  zoom: function() {
    var nextActive = !this._isZoomActive;
    this.api.dispatchAction({
      type: "takeGlobalCursor",
      key: "dataZoomSelect",
      dataZoomSelectActive: nextActive
    });
  },
  back: function() {
    this._dispatchZoomAction(pop(this.ecModel));
  }
};
function makeAxisFinder(dzFeatureModel) {
  var setting = {
    xAxisIndex: dzFeatureModel.get("xAxisIndex", true),
    yAxisIndex: dzFeatureModel.get("yAxisIndex", true),
    xAxisId: dzFeatureModel.get("xAxisId", true),
    yAxisId: dzFeatureModel.get("yAxisId", true)
  };
  if (setting.xAxisIndex == null && setting.xAxisId == null) {
    setting.xAxisIndex = "all";
  }
  if (setting.yAxisIndex == null && setting.yAxisId == null) {
    setting.yAxisIndex = "all";
  }
  return setting;
}
function updateBackBtnStatus(featureModel, ecModel) {
  featureModel.setIconStatus("back", count(ecModel) > 1 ? "emphasis" : "normal");
}
function updateZoomBtnStatus(featureModel, ecModel, view, payload, api) {
  var zoomActive = view._isZoomActive;
  if (payload && payload.type === "takeGlobalCursor") {
    zoomActive = payload.key === "dataZoomSelect" ? payload.dataZoomSelectActive : false;
  }
  view._isZoomActive = zoomActive;
  featureModel.setIconStatus("zoom", zoomActive ? "emphasis" : "normal");
  var brushTargetManager = new BrushTargetManager$1(makeAxisFinder(featureModel), ecModel, {
    include: ["grid"]
  });
  var panels = brushTargetManager.makePanelOpts(api, function(targetInfo) {
    return targetInfo.xAxisDeclared && !targetInfo.yAxisDeclared ? "lineX" : !targetInfo.xAxisDeclared && targetInfo.yAxisDeclared ? "lineY" : "rect";
  });
  view._brushController.setPanels(panels).enableBrush(zoomActive && panels.length ? {
    brushType: "auto",
    brushStyle: featureModel.getModel("brushStyle").getItemStyle()
  } : false);
}
registerInternalOptionCreator("dataZoom", function(ecModel) {
  var toolboxModel = ecModel.getComponent("toolbox", 0);
  var featureDataZoomPath = ["feature", "dataZoom"];
  if (!toolboxModel || toolboxModel.get(featureDataZoomPath) == null) {
    return;
  }
  var dzFeatureModel = toolboxModel.getModel(featureDataZoomPath);
  var dzOptions = [];
  var finder = makeAxisFinder(dzFeatureModel);
  var finderResult = parseFinder$1(ecModel, finder);
  each$5(finderResult.xAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "xAxis", "xAxisIndex");
  });
  each$5(finderResult.yAxisModels, function(axisModel) {
    return buildInternalOptions(axisModel, "yAxis", "yAxisIndex");
  });
  function buildInternalOptions(axisModel, axisMainType, axisIndexPropName) {
    var axisIndex = axisModel.componentIndex;
    var newOpt = {
      type: "select",
      $fromToolbox: true,
      filterMode: dzFeatureModel.get("filterMode", true) || "filter",
      id: DATA_ZOOM_ID_BASE + axisMainType + axisIndex
    };
    newOpt[axisIndexPropName] = axisIndex;
    dzOptions.push(newOpt);
  }
  return dzOptions;
});
var DataZoom = DataZoomFeature;
function install$j(registers) {
  registers.registerComponentModel(ToolboxModel$1);
  registers.registerComponentView(ToolboxView$1);
  registerFeature("saveAsImage", SaveAsImage$1);
  registerFeature("magicType", MagicType$1);
  registerFeature("dataView", DataView$1);
  registerFeature("dataZoom", DataZoom);
  registerFeature("restore", Restore);
  use(install$k);
}
var TooltipModel = function(_super) {
  __extends(TooltipModel2, _super);
  function TooltipModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipModel2.type;
    return _this;
  }
  TooltipModel2.type = "tooltip";
  TooltipModel2.dependencies = ["axisPointer"];
  TooltipModel2.defaultOption = {
    z: 60,
    show: true,
    showContent: true,
    trigger: "item",
    triggerOn: "mousemove|click",
    alwaysShowContent: false,
    displayMode: "single",
    renderMode: "auto",
    confine: null,
    showDelay: 0,
    hideDelay: 100,
    transitionDuration: 0.4,
    enterable: false,
    backgroundColor: "#fff",
    shadowBlur: 10,
    shadowColor: "rgba(0, 0, 0, .2)",
    shadowOffsetX: 1,
    shadowOffsetY: 2,
    borderRadius: 4,
    borderWidth: 1,
    padding: null,
    extraCssText: "",
    axisPointer: {
      type: "line",
      axis: "auto",
      animation: "auto",
      animationDurationUpdate: 200,
      animationEasingUpdate: "exponentialOut",
      crossStyle: {
        color: "#999",
        width: 1,
        type: "dashed",
        textStyle: {}
      }
    },
    textStyle: {
      color: "#666",
      fontSize: 14
    }
  };
  return TooltipModel2;
}(ComponentModel$1);
var TooltipModel$1 = TooltipModel;
function shouldTooltipConfine(tooltipModel) {
  var confineOption = tooltipModel.get("confine");
  return confineOption != null ? !!confineOption : tooltipModel.get("renderMode") === "richText";
}
function testStyle(styleProps) {
  if (!env$1.domSupported) {
    return;
  }
  var style = document.documentElement.style;
  for (var i = 0, len2 = styleProps.length; i < len2; i++) {
    if (styleProps[i] in style) {
      return styleProps[i];
    }
  }
}
var TRANSFORM_VENDOR = testStyle(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]);
var TRANSITION_VENDOR = testStyle(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
function toCSSVendorPrefix(styleVendor, styleProp) {
  if (!styleVendor) {
    return styleProp;
  }
  styleProp = toCamelCase(styleProp, true);
  var idx = styleVendor.indexOf(styleProp);
  styleVendor = idx === -1 ? styleProp : "-" + styleVendor.slice(0, idx) + "-" + styleProp;
  return styleVendor.toLowerCase();
}
function getComputedStyle$1(el, style) {
  var stl = el.currentStyle || document.defaultView && document.defaultView.getComputedStyle(el);
  return stl ? style ? stl[style] : stl : null;
}
var CSS_TRANSITION_VENDOR = toCSSVendorPrefix(TRANSITION_VENDOR, "transition");
var CSS_TRANSFORM_VENDOR = toCSSVendorPrefix(TRANSFORM_VENDOR, "transform");
var gCssText = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (env$1.transform3dSupported ? "will-change:transform;" : "");
function mirrorPos(pos) {
  pos = pos === "left" ? "right" : pos === "right" ? "left" : pos === "top" ? "bottom" : "top";
  return pos;
}
function assembleArrow(tooltipModel, borderColor, arrowPosition) {
  if (!isString(arrowPosition) || arrowPosition === "inside") {
    return "";
  }
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var borderWidth = tooltipModel.get("borderWidth");
  borderColor = convertToColorString(borderColor);
  var arrowPos = mirrorPos(arrowPosition);
  var arrowSize = Math.max(Math.round(borderWidth) * 1.5, 6);
  var positionStyle = "";
  var transformStyle = CSS_TRANSFORM_VENDOR + ":";
  var rotateDeg;
  if (indexOf(["left", "right"], arrowPos) > -1) {
    positionStyle += "top:50%";
    transformStyle += "translateY(-50%) rotate(" + (rotateDeg = arrowPos === "left" ? -225 : -45) + "deg)";
  } else {
    positionStyle += "left:50%";
    transformStyle += "translateX(-50%) rotate(" + (rotateDeg = arrowPos === "top" ? 225 : 45) + "deg)";
  }
  var rotateRadian = rotateDeg * Math.PI / 180;
  var arrowWH = arrowSize + borderWidth;
  var rotatedWH = arrowWH * Math.abs(Math.cos(rotateRadian)) + arrowWH * Math.abs(Math.sin(rotateRadian));
  var arrowOffset = Math.round(((rotatedWH - Math.SQRT2 * borderWidth) / 2 + Math.SQRT2 * borderWidth - (rotatedWH - arrowWH) / 2) * 100) / 100;
  positionStyle += ";" + arrowPos + ":-" + arrowOffset + "px";
  var borderStyle = borderColor + " solid " + borderWidth + "px;";
  var styleCss = ["position:absolute;width:" + arrowSize + "px;height:" + arrowSize + "px;", positionStyle + ";" + transformStyle + ";", "border-bottom:" + borderStyle, "border-right:" + borderStyle, "background-color:" + backgroundColor2 + ";"];
  return '<div style="' + styleCss.join("") + '"></div>';
}
function assembleTransition(duration, onlyFade) {
  var transitionCurve = "cubic-bezier(0.23,1,0.32,1)";
  var transitionOption = " " + duration / 2 + "s " + transitionCurve;
  var transitionText = "opacity" + transitionOption + ",visibility" + transitionOption;
  if (!onlyFade) {
    transitionOption = " " + duration + "s " + transitionCurve;
    transitionText += env$1.transformSupported ? "," + CSS_TRANSFORM_VENDOR + transitionOption : ",left" + transitionOption + ",top" + transitionOption;
  }
  return CSS_TRANSITION_VENDOR + ":" + transitionText;
}
function assembleTransform(x2, y2, toString) {
  var x0 = x2.toFixed(0) + "px";
  var y0 = y2.toFixed(0) + "px";
  if (!env$1.transformSupported) {
    return toString ? "top:" + y0 + ";left:" + x0 + ";" : [["top", y0], ["left", x0]];
  }
  var is3d = env$1.transform3dSupported;
  var translate2 = "translate" + (is3d ? "3d" : "") + "(" + x0 + "," + y0 + (is3d ? ",0" : "") + ")";
  return toString ? "top:0;left:0;" + CSS_TRANSFORM_VENDOR + ":" + translate2 + ";" : [["top", 0], ["left", 0], [TRANSFORM_VENDOR, translate2]];
}
function assembleFont(textStyleModel) {
  var cssText = [];
  var fontSize = textStyleModel.get("fontSize");
  var color = textStyleModel.getTextColor();
  color && cssText.push("color:" + color);
  cssText.push("font:" + textStyleModel.getFont());
  fontSize && cssText.push("line-height:" + Math.round(fontSize * 3 / 2) + "px");
  var shadowColor = textStyleModel.get("textShadowColor");
  var shadowBlur = textStyleModel.get("textShadowBlur") || 0;
  var shadowOffsetX = textStyleModel.get("textShadowOffsetX") || 0;
  var shadowOffsetY = textStyleModel.get("textShadowOffsetY") || 0;
  shadowColor && shadowBlur && cssText.push("text-shadow:" + shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor);
  each$f(["decoration", "align"], function(name) {
    var val = textStyleModel.get(name);
    val && cssText.push("text-" + name + ":" + val);
  });
  return cssText.join(";");
}
function assembleCssText(tooltipModel, enableTransition, onlyFade) {
  var cssText = [];
  var transitionDuration = tooltipModel.get("transitionDuration");
  var backgroundColor2 = tooltipModel.get("backgroundColor");
  var shadowBlur = tooltipModel.get("shadowBlur");
  var shadowColor = tooltipModel.get("shadowColor");
  var shadowOffsetX = tooltipModel.get("shadowOffsetX");
  var shadowOffsetY = tooltipModel.get("shadowOffsetY");
  var textStyleModel = tooltipModel.getModel("textStyle");
  var padding = getPaddingFromTooltipModel(tooltipModel, "html");
  var boxShadow = shadowOffsetX + "px " + shadowOffsetY + "px " + shadowBlur + "px " + shadowColor;
  cssText.push("box-shadow:" + boxShadow);
  enableTransition && transitionDuration && cssText.push(assembleTransition(transitionDuration, onlyFade));
  if (backgroundColor2) {
    cssText.push("background-color:" + backgroundColor2);
  }
  each$f(["width", "color", "radius"], function(name) {
    var borderName = "border-" + name;
    var camelCase = toCamelCase(borderName);
    var val = tooltipModel.get(camelCase);
    val != null && cssText.push(borderName + ":" + val + (name === "color" ? "" : "px"));
  });
  cssText.push(assembleFont(textStyleModel));
  if (padding != null) {
    cssText.push("padding:" + normalizeCssArray(padding).join("px ") + "px");
  }
  return cssText.join(";") + ";";
}
function makeStyleCoord$1(out2, zr, appendToBody, zrX, zrY) {
  var zrPainter = zr && zr.painter;
  if (appendToBody) {
    var zrViewportRoot = zrPainter && zrPainter.getViewportRoot();
    if (zrViewportRoot) {
      transformLocalCoord(out2, zrViewportRoot, document.body, zrX, zrY);
    }
  } else {
    out2[0] = zrX;
    out2[1] = zrY;
    var viewportRootOffset = zrPainter && zrPainter.getViewportRootOffset();
    if (viewportRootOffset) {
      out2[0] += viewportRootOffset.offsetLeft;
      out2[1] += viewportRootOffset.offsetTop;
    }
  }
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipHTMLContent = function() {
  function TooltipHTMLContent2(container2, api, opt) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._firstShow = true;
    this._longHide = true;
    if (env$1.wxa) {
      return null;
    }
    var el = document.createElement("div");
    el.domBelongToZr = true;
    this.el = el;
    var zr = this._zr = api.getZr();
    var appendToBody = this._appendToBody = opt && opt.appendToBody;
    makeStyleCoord$1(this._styleCoord, zr, appendToBody, api.getWidth() / 2, api.getHeight() / 2);
    if (appendToBody) {
      document.body.appendChild(el);
    } else {
      container2.appendChild(el);
    }
    this._container = container2;
    var self2 = this;
    el.onmouseenter = function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    };
    el.onmousemove = function(e2) {
      e2 = e2 || window.event;
      if (!self2._enterable) {
        var handler = zr.handler;
        var zrViewportRoot = zr.painter.getViewportRoot();
        normalizeEvent(zrViewportRoot, e2, true);
        handler.dispatch("mousemove", e2);
      }
    };
    el.onmouseleave = function() {
      self2._inContent = false;
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
    };
  }
  TooltipHTMLContent2.prototype.update = function(tooltipModel) {
    var container2 = this._container;
    var position2 = getComputedStyle$1(container2, "position");
    var domStyle = container2.style;
    if (domStyle.position !== "absolute" && position2 !== "absolute") {
      domStyle.position = "relative";
    }
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
    this.el.className = tooltipModel.get("className") || "";
  };
  TooltipHTMLContent2.prototype.show = function(tooltipModel, nearPointColor) {
    clearTimeout(this._hideTimeout);
    clearTimeout(this._longHideTimeout);
    var el = this.el;
    var style = el.style;
    var styleCoord = this._styleCoord;
    if (!el.innerHTML) {
      style.display = "none";
    } else {
      style.cssText = gCssText + assembleCssText(tooltipModel, !this._firstShow, this._longHide) + assembleTransform(styleCoord[0], styleCoord[1], true) + ("border-color:" + convertToColorString(nearPointColor) + ";") + (tooltipModel.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none"));
    }
    this._show = true;
    this._firstShow = false;
    this._longHide = false;
  };
  TooltipHTMLContent2.prototype.setContent = function(content, markers, tooltipModel, borderColor, arrowPosition) {
    var el = this.el;
    if (content == null) {
      el.innerHTML = "";
      return;
    }
    var arrow = "";
    if (isString(arrowPosition) && tooltipModel.get("trigger") === "item" && !shouldTooltipConfine(tooltipModel)) {
      arrow = assembleArrow(tooltipModel, borderColor, arrowPosition);
    }
    if (isString(content)) {
      el.innerHTML = content + arrow;
    } else if (content) {
      el.innerHTML = "";
      if (!isArray$1(content)) {
        content = [content];
      }
      for (var i = 0; i < content.length; i++) {
        if (isDom(content[i]) && content[i].parentNode !== el) {
          el.appendChild(content[i]);
        }
      }
      if (arrow && el.childNodes.length) {
        var arrowEl = document.createElement("div");
        arrowEl.innerHTML = arrow;
        el.appendChild(arrowEl);
      }
    }
  };
  TooltipHTMLContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipHTMLContent2.prototype.getSize = function() {
    var el = this.el;
    return [el.offsetWidth, el.offsetHeight];
  };
  TooltipHTMLContent2.prototype.moveTo = function(zrX, zrY) {
    var styleCoord = this._styleCoord;
    makeStyleCoord$1(styleCoord, this._zr, this._appendToBody, zrX, zrY);
    if (styleCoord[0] != null && styleCoord[1] != null) {
      var style_1 = this.el.style;
      var transforms = assembleTransform(styleCoord[0], styleCoord[1]);
      each$f(transforms, function(transform2) {
        style_1[transform2[0]] = transform2[1];
      });
    }
  };
  TooltipHTMLContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipHTMLContent2.prototype.hide = function() {
    var _this = this;
    var style = this.el.style;
    style.visibility = "hidden";
    style.opacity = "0";
    env$1.transform3dSupported && (style.willChange = "");
    this._show = false;
    this._longHideTimeout = setTimeout(function() {
      return _this._longHide = true;
    }, 500);
  };
  TooltipHTMLContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipHTMLContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipHTMLContent2.prototype.dispose = function() {
    this.el.parentNode.removeChild(this.el);
  };
  return TooltipHTMLContent2;
}();
var TooltipHTMLContent$1 = TooltipHTMLContent;
var TooltipRichContent = function() {
  function TooltipRichContent2(api) {
    this._show = false;
    this._styleCoord = [0, 0, 0, 0];
    this._enterable = true;
    this._zr = api.getZr();
    makeStyleCoord(this._styleCoord, this._zr, api.getWidth() / 2, api.getHeight() / 2);
  }
  TooltipRichContent2.prototype.update = function(tooltipModel) {
    var alwaysShowContent = tooltipModel.get("alwaysShowContent");
    alwaysShowContent && this._moveIfResized();
  };
  TooltipRichContent2.prototype.show = function() {
    if (this._hideTimeout) {
      clearTimeout(this._hideTimeout);
    }
    this.el.show();
    this._show = true;
  };
  TooltipRichContent2.prototype.setContent = function(content, markupStyleCreator, tooltipModel, borderColor, arrowPosition) {
    var _this = this;
    if (isObject$4(content)) {
      throwError("");
    }
    if (this.el) {
      this._zr.remove(this.el);
    }
    var textStyleModel = tooltipModel.getModel("textStyle");
    this.el = new ZRText$1({
      style: {
        rich: markupStyleCreator.richTextStyles,
        text: content,
        lineHeight: 22,
        borderWidth: 1,
        borderColor,
        textShadowColor: textStyleModel.get("textShadowColor"),
        fill: tooltipModel.get(["textStyle", "color"]),
        padding: getPaddingFromTooltipModel(tooltipModel, "richText"),
        verticalAlign: "top",
        align: "left"
      },
      z: tooltipModel.get("z")
    });
    each$f(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(propName) {
      _this.el.style[propName] = tooltipModel.get(propName);
    });
    each$f(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(propName) {
      _this.el.style[propName] = textStyleModel.get(propName) || 0;
    });
    this._zr.add(this.el);
    var self2 = this;
    this.el.on("mouseover", function() {
      if (self2._enterable) {
        clearTimeout(self2._hideTimeout);
        self2._show = true;
      }
      self2._inContent = true;
    });
    this.el.on("mouseout", function() {
      if (self2._enterable) {
        if (self2._show) {
          self2.hideLater(self2._hideDelay);
        }
      }
      self2._inContent = false;
    });
  };
  TooltipRichContent2.prototype.setEnterable = function(enterable) {
    this._enterable = enterable;
  };
  TooltipRichContent2.prototype.getSize = function() {
    var el = this.el;
    var bounding = this.el.getBoundingRect();
    var shadowOuterSize = calcShadowOuterSize(el.style);
    return [bounding.width + shadowOuterSize.left + shadowOuterSize.right, bounding.height + shadowOuterSize.top + shadowOuterSize.bottom];
  };
  TooltipRichContent2.prototype.moveTo = function(x2, y2) {
    var el = this.el;
    if (el) {
      var styleCoord = this._styleCoord;
      makeStyleCoord(styleCoord, this._zr, x2, y2);
      x2 = styleCoord[0];
      y2 = styleCoord[1];
      var style = el.style;
      var borderWidth = mathMaxWith0(style.borderWidth || 0);
      var shadowOuterSize = calcShadowOuterSize(style);
      el.x = x2 + borderWidth + shadowOuterSize.left;
      el.y = y2 + borderWidth + shadowOuterSize.top;
      el.markRedraw();
    }
  };
  TooltipRichContent2.prototype._moveIfResized = function() {
    var ratioX = this._styleCoord[2];
    var ratioY = this._styleCoord[3];
    this.moveTo(ratioX * this._zr.getWidth(), ratioY * this._zr.getHeight());
  };
  TooltipRichContent2.prototype.hide = function() {
    if (this.el) {
      this.el.hide();
    }
    this._show = false;
  };
  TooltipRichContent2.prototype.hideLater = function(time) {
    if (this._show && !(this._inContent && this._enterable)) {
      if (time) {
        this._hideDelay = time;
        this._show = false;
        this._hideTimeout = setTimeout(bind$1(this.hide, this), time);
      } else {
        this.hide();
      }
    }
  };
  TooltipRichContent2.prototype.isShow = function() {
    return this._show;
  };
  TooltipRichContent2.prototype.dispose = function() {
    this._zr.remove(this.el);
  };
  return TooltipRichContent2;
}();
function mathMaxWith0(val) {
  return Math.max(0, val);
}
function calcShadowOuterSize(style) {
  var shadowBlur = mathMaxWith0(style.shadowBlur || 0);
  var shadowOffsetX = mathMaxWith0(style.shadowOffsetX || 0);
  var shadowOffsetY = mathMaxWith0(style.shadowOffsetY || 0);
  return {
    left: mathMaxWith0(shadowBlur - shadowOffsetX),
    right: mathMaxWith0(shadowBlur + shadowOffsetX),
    top: mathMaxWith0(shadowBlur - shadowOffsetY),
    bottom: mathMaxWith0(shadowBlur + shadowOffsetY)
  };
}
function makeStyleCoord(out2, zr, zrX, zrY) {
  out2[0] = zrX;
  out2[1] = zrY;
  out2[2] = out2[0] / zr.getWidth();
  out2[3] = out2[1] / zr.getHeight();
}
var TooltipRichContent$1 = TooltipRichContent;
var proxyRect = new Rect$3({
  shape: {
    x: -1,
    y: -1,
    width: 2,
    height: 2
  }
});
var TooltipView = function(_super) {
  __extends(TooltipView2, _super);
  function TooltipView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TooltipView2.type;
    return _this;
  }
  TooltipView2.prototype.init = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    var tooltipModel = ecModel.getComponent("tooltip");
    var renderMode = this._renderMode = getTooltipRenderMode(tooltipModel.get("renderMode"));
    this._tooltipContent = renderMode === "richText" ? new TooltipRichContent$1(api) : new TooltipHTMLContent$1(api.getDom(), api, {
      appendToBody: tooltipModel.get("appendToBody", true)
    });
  };
  TooltipView2.prototype.render = function(tooltipModel, ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    this.group.removeAll();
    this._tooltipModel = tooltipModel;
    this._ecModel = ecModel;
    this._api = api;
    this._alwaysShowContent = tooltipModel.get("alwaysShowContent");
    var tooltipContent = this._tooltipContent;
    tooltipContent.update(tooltipModel);
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    this._initGlobalListener();
    this._keepShow();
    if (this._renderMode !== "richText" && tooltipModel.get("transitionDuration")) {
      createOrUpdate(this, "_updatePosition", 50, "fixRate");
    } else {
      clear$1(this, "_updatePosition");
    }
  };
  TooltipView2.prototype._initGlobalListener = function() {
    var tooltipModel = this._tooltipModel;
    var triggerOn = tooltipModel.get("triggerOn");
    register("itemTooltip", this._api, bind$1(function(currTrigger, e2, dispatchAction2) {
      if (triggerOn !== "none") {
        if (triggerOn.indexOf(currTrigger) >= 0) {
          this._tryShow(e2, dispatchAction2);
        } else if (currTrigger === "leave") {
          this._hide(dispatchAction2);
        }
      }
    }, this));
  };
  TooltipView2.prototype._keepShow = function() {
    var tooltipModel = this._tooltipModel;
    var ecModel = this._ecModel;
    var api = this._api;
    if (this._lastX != null && this._lastY != null && tooltipModel.get("triggerOn") !== "none") {
      var self_1 = this;
      clearTimeout(this._refreshUpdateTimeout);
      this._refreshUpdateTimeout = setTimeout(function() {
        !api.isDisposed() && self_1.manuallyShowTip(tooltipModel, ecModel, api, {
          x: self_1._lastX,
          y: self_1._lastY,
          dataByCoordSys: self_1._lastDataByCoordSys
        });
      });
    }
  };
  TooltipView2.prototype.manuallyShowTip = function(tooltipModel, ecModel, api, payload) {
    if (payload.from === this.uid || env$1.node || !api.getDom()) {
      return;
    }
    var dispatchAction2 = makeDispatchAction(payload, api);
    this._ticket = "";
    var dataByCoordSys = payload.dataByCoordSys;
    var cmptRef = findComponentReference(payload, ecModel, api);
    if (cmptRef) {
      var rect = cmptRef.el.getBoundingRect().clone();
      rect.applyTransform(cmptRef.el.transform);
      this._tryShow({
        offsetX: rect.x + rect.width / 2,
        offsetY: rect.y + rect.height / 2,
        target: cmptRef.el,
        position: payload.position,
        positionDefault: "bottom"
      }, dispatchAction2);
    } else if (payload.tooltip && payload.x != null && payload.y != null) {
      var el = proxyRect;
      el.x = payload.x;
      el.y = payload.y;
      el.update();
      getECData(el).tooltipConfig = {
        name: null,
        option: payload.tooltip
      };
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        target: el
      }, dispatchAction2);
    } else if (dataByCoordSys) {
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        dataByCoordSys,
        tooltipOption: payload.tooltipOption
      }, dispatchAction2);
    } else if (payload.seriesIndex != null) {
      if (this._manuallyAxisShowTip(tooltipModel, ecModel, api, payload)) {
        return;
      }
      var pointInfo = findPointFromSeries(payload, ecModel);
      var cx = pointInfo.point[0];
      var cy = pointInfo.point[1];
      if (cx != null && cy != null) {
        this._tryShow({
          offsetX: cx,
          offsetY: cy,
          target: pointInfo.el,
          position: payload.position,
          positionDefault: "bottom"
        }, dispatchAction2);
      }
    } else if (payload.x != null && payload.y != null) {
      api.dispatchAction({
        type: "updateAxisPointer",
        x: payload.x,
        y: payload.y
      });
      this._tryShow({
        offsetX: payload.x,
        offsetY: payload.y,
        position: payload.position,
        target: api.getZr().findHover(payload.x, payload.y).target
      }, dispatchAction2);
    }
  };
  TooltipView2.prototype.manuallyHideTip = function(tooltipModel, ecModel, api, payload) {
    var tooltipContent = this._tooltipContent;
    if (!this._alwaysShowContent && this._tooltipModel) {
      tooltipContent.hideLater(this._tooltipModel.get("hideDelay"));
    }
    this._lastX = this._lastY = this._lastDataByCoordSys = null;
    if (payload.from !== this.uid) {
      this._hide(makeDispatchAction(payload, api));
    }
  };
  TooltipView2.prototype._manuallyAxisShowTip = function(tooltipModel, ecModel, api, payload) {
    var seriesIndex = payload.seriesIndex;
    var dataIndex = payload.dataIndex;
    var coordSysAxesInfo = ecModel.getComponent("axisPointer").coordSysAxesInfo;
    if (seriesIndex == null || dataIndex == null || coordSysAxesInfo == null) {
      return;
    }
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    if (!seriesModel) {
      return;
    }
    var data = seriesModel.getData();
    var tooltipCascadedModel = buildTooltipModel([data.getItemModel(dataIndex), seriesModel, (seriesModel.coordinateSystem || {}).model], this._tooltipModel);
    if (tooltipCascadedModel.get("trigger") !== "axis") {
      return;
    }
    api.dispatchAction({
      type: "updateAxisPointer",
      seriesIndex,
      dataIndex,
      position: payload.position
    });
    return true;
  };
  TooltipView2.prototype._tryShow = function(e2, dispatchAction2) {
    var el = e2.target;
    var tooltipModel = this._tooltipModel;
    if (!tooltipModel) {
      return;
    }
    this._lastX = e2.offsetX;
    this._lastY = e2.offsetY;
    var dataByCoordSys = e2.dataByCoordSys;
    if (dataByCoordSys && dataByCoordSys.length) {
      this._showAxisTooltip(dataByCoordSys, e2);
    } else if (el) {
      this._lastDataByCoordSys = null;
      var seriesDispatcher_1;
      var cmptDispatcher_1;
      findEventDispatcher(el, function(target) {
        if (getECData(target).dataIndex != null) {
          seriesDispatcher_1 = target;
          return true;
        }
        if (getECData(target).tooltipConfig != null) {
          cmptDispatcher_1 = target;
          return true;
        }
      }, true);
      if (seriesDispatcher_1) {
        this._showSeriesItemTooltip(e2, seriesDispatcher_1, dispatchAction2);
      } else if (cmptDispatcher_1) {
        this._showComponentItemTooltip(e2, cmptDispatcher_1, dispatchAction2);
      } else {
        this._hide(dispatchAction2);
      }
    } else {
      this._lastDataByCoordSys = null;
      this._hide(dispatchAction2);
    }
  };
  TooltipView2.prototype._showOrMove = function(tooltipModel, cb) {
    var delay = tooltipModel.get("showDelay");
    cb = bind$1(cb, this);
    clearTimeout(this._showTimout);
    delay > 0 ? this._showTimout = setTimeout(cb, delay) : cb();
  };
  TooltipView2.prototype._showAxisTooltip = function(dataByCoordSys, e2) {
    var ecModel = this._ecModel;
    var globalTooltipModel = this._tooltipModel;
    var point = [e2.offsetX, e2.offsetY];
    var singleTooltipModel = buildTooltipModel([e2.tooltipOption], globalTooltipModel);
    var renderMode = this._renderMode;
    var cbParamsList = [];
    var articleMarkup = createTooltipMarkup("section", {
      blocks: [],
      noHeader: true
    });
    var markupTextArrLegacy = [];
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    each$f(dataByCoordSys, function(itemCoordSys) {
      each$f(itemCoordSys.dataByAxis, function(axisItem) {
        var axisModel = ecModel.getComponent(axisItem.axisDim + "Axis", axisItem.axisIndex);
        var axisValue = axisItem.value;
        if (!axisModel || axisValue == null) {
          return;
        }
        var axisValueLabel = getValueLabel(axisValue, axisModel.axis, ecModel, axisItem.seriesDataIndices, axisItem.valueLabelOpt);
        var axisSectionMarkup = createTooltipMarkup("section", {
          header: axisValueLabel,
          noHeader: !trim$1(axisValueLabel),
          sortBlocks: true,
          blocks: []
        });
        articleMarkup.blocks.push(axisSectionMarkup);
        each$f(axisItem.seriesDataIndices, function(idxItem) {
          var series = ecModel.getSeriesByIndex(idxItem.seriesIndex);
          var dataIndex = idxItem.dataIndexInside;
          var cbParams = series.getDataParams(dataIndex);
          if (cbParams.dataIndex < 0) {
            return;
          }
          cbParams.axisDim = axisItem.axisDim;
          cbParams.axisIndex = axisItem.axisIndex;
          cbParams.axisType = axisItem.axisType;
          cbParams.axisId = axisItem.axisId;
          cbParams.axisValue = getAxisRawValue(axisModel.axis, {
            value: axisValue
          });
          cbParams.axisValueLabel = axisValueLabel;
          cbParams.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(cbParams.color), renderMode);
          var seriesTooltipResult = normalizeTooltipFormatResult(series.formatTooltip(dataIndex, true, null));
          var frag = seriesTooltipResult.frag;
          if (frag) {
            var valueFormatter = buildTooltipModel([series], globalTooltipModel).get("valueFormatter");
            axisSectionMarkup.blocks.push(valueFormatter ? extend({
              valueFormatter
            }, frag) : frag);
          }
          if (seriesTooltipResult.text) {
            markupTextArrLegacy.push(seriesTooltipResult.text);
          }
          cbParamsList.push(cbParams);
        });
      });
    });
    articleMarkup.blocks.reverse();
    markupTextArrLegacy.reverse();
    var positionExpr = e2.position;
    var orderMode = singleTooltipModel.get("order");
    var builtMarkupText = buildTooltipMarkup(articleMarkup, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), singleTooltipModel.get("textStyle"));
    builtMarkupText && markupTextArrLegacy.unshift(builtMarkupText);
    var blockBreak = renderMode === "richText" ? "\n\n" : "<br/>";
    var allMarkupText = markupTextArrLegacy.join(blockBreak);
    this._showOrMove(singleTooltipModel, function() {
      if (this._updateContentNotChangedOnAxis(dataByCoordSys, cbParamsList)) {
        this._updatePosition(singleTooltipModel, positionExpr, point[0], point[1], this._tooltipContent, cbParamsList);
      } else {
        this._showTooltipContent(singleTooltipModel, allMarkupText, cbParamsList, Math.random() + "", point[0], point[1], positionExpr, null, markupStyleCreator);
      }
    });
  };
  TooltipView2.prototype._showSeriesItemTooltip = function(e2, dispatcher, dispatchAction2) {
    var ecModel = this._ecModel;
    var ecData = getECData(dispatcher);
    var seriesIndex = ecData.seriesIndex;
    var seriesModel = ecModel.getSeriesByIndex(seriesIndex);
    var dataModel = ecData.dataModel || seriesModel;
    var dataIndex = ecData.dataIndex;
    var dataType = ecData.dataType;
    var data = dataModel.getData(dataType);
    var renderMode = this._renderMode;
    var positionDefault = e2.positionDefault;
    var tooltipModel = buildTooltipModel([data.getItemModel(dataIndex), dataModel, seriesModel && (seriesModel.coordinateSystem || {}).model], this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var tooltipTrigger = tooltipModel.get("trigger");
    if (tooltipTrigger != null && tooltipTrigger !== "item") {
      return;
    }
    var params = dataModel.getDataParams(dataIndex, dataType);
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    params.marker = markupStyleCreator.makeTooltipMarker("item", convertToColorString(params.color), renderMode);
    var seriesTooltipResult = normalizeTooltipFormatResult(dataModel.formatTooltip(dataIndex, false, dataType));
    var orderMode = tooltipModel.get("order");
    var valueFormatter = tooltipModel.get("valueFormatter");
    var frag = seriesTooltipResult.frag;
    var markupText = frag ? buildTooltipMarkup(valueFormatter ? extend({
      valueFormatter
    }, frag) : frag, markupStyleCreator, renderMode, orderMode, ecModel.get("useUTC"), tooltipModel.get("textStyle")) : seriesTooltipResult.text;
    var asyncTicket = "item_" + dataModel.name + "_" + dataIndex;
    this._showOrMove(tooltipModel, function() {
      this._showTooltipContent(tooltipModel, markupText, params, asyncTicket, e2.offsetX, e2.offsetY, e2.position, e2.target, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      dataIndexInside: dataIndex,
      dataIndex: data.getRawIndex(dataIndex),
      seriesIndex,
      from: this.uid
    });
  };
  TooltipView2.prototype._showComponentItemTooltip = function(e2, el, dispatchAction2) {
    var ecData = getECData(el);
    var tooltipConfig = ecData.tooltipConfig;
    var tooltipOpt = tooltipConfig.option || {};
    if (isString(tooltipOpt)) {
      var content = tooltipOpt;
      tooltipOpt = {
        content,
        formatter: content
      };
    }
    var tooltipModelCascade = [tooltipOpt];
    var cmpt = this._ecModel.getComponent(ecData.componentMainType, ecData.componentIndex);
    if (cmpt) {
      tooltipModelCascade.push(cmpt);
    }
    tooltipModelCascade.push({
      formatter: tooltipOpt.content
    });
    var positionDefault = e2.positionDefault;
    var subTooltipModel = buildTooltipModel(tooltipModelCascade, this._tooltipModel, positionDefault ? {
      position: positionDefault
    } : null);
    var defaultHtml = subTooltipModel.get("content");
    var asyncTicket = Math.random() + "";
    var markupStyleCreator = new TooltipMarkupStyleCreator();
    this._showOrMove(subTooltipModel, function() {
      var formatterParams = clone$4(subTooltipModel.get("formatterParams") || {});
      this._showTooltipContent(subTooltipModel, defaultHtml, formatterParams, asyncTicket, e2.offsetX, e2.offsetY, e2.position, el, markupStyleCreator);
    });
    dispatchAction2({
      type: "showTip",
      from: this.uid
    });
  };
  TooltipView2.prototype._showTooltipContent = function(tooltipModel, defaultHtml, params, asyncTicket, x2, y2, positionExpr, el, markupStyleCreator) {
    this._ticket = "";
    if (!tooltipModel.get("showContent") || !tooltipModel.get("show")) {
      return;
    }
    var tooltipContent = this._tooltipContent;
    tooltipContent.setEnterable(tooltipModel.get("enterable"));
    var formatter = tooltipModel.get("formatter");
    positionExpr = positionExpr || tooltipModel.get("position");
    var html = defaultHtml;
    var nearPoint = this._getNearestPoint([x2, y2], params, tooltipModel.get("trigger"), tooltipModel.get("borderColor"));
    var nearPointColor = nearPoint.color;
    if (formatter) {
      if (isString(formatter)) {
        var useUTC = tooltipModel.ecModel.get("useUTC");
        var params0 = isArray$1(params) ? params[0] : params;
        var isTimeAxis = params0 && params0.axisType && params0.axisType.indexOf("time") >= 0;
        html = formatter;
        if (isTimeAxis) {
          html = format$1(params0.axisValue, html, useUTC);
        }
        html = formatTpl(html, params, true);
      } else if (isFunction(formatter)) {
        var callback = bind$1(function(cbTicket, html2) {
          if (cbTicket === this._ticket) {
            tooltipContent.setContent(html2, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
            this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
          }
        }, this);
        this._ticket = asyncTicket;
        html = formatter(params, asyncTicket, callback);
      } else {
        html = formatter;
      }
    }
    tooltipContent.setContent(html, markupStyleCreator, tooltipModel, nearPointColor, positionExpr);
    tooltipContent.show(tooltipModel, nearPointColor);
    this._updatePosition(tooltipModel, positionExpr, x2, y2, tooltipContent, params, el);
  };
  TooltipView2.prototype._getNearestPoint = function(point, tooltipDataParams, trigger2, borderColor) {
    if (trigger2 === "axis" || isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || (this._renderMode === "html" ? "#fff" : "none")
      };
    }
    if (!isArray$1(tooltipDataParams)) {
      return {
        color: borderColor || tooltipDataParams.color || tooltipDataParams.borderColor
      };
    }
  };
  TooltipView2.prototype._updatePosition = function(tooltipModel, positionExpr, x2, y2, content, params, el) {
    var viewWidth = this._api.getWidth();
    var viewHeight = this._api.getHeight();
    positionExpr = positionExpr || tooltipModel.get("position");
    var contentSize = content.getSize();
    var align = tooltipModel.get("align");
    var vAlign = tooltipModel.get("verticalAlign");
    var rect = el && el.getBoundingRect().clone();
    el && rect.applyTransform(el.transform);
    if (isFunction(positionExpr)) {
      positionExpr = positionExpr([x2, y2], params, content.el, rect, {
        viewSize: [viewWidth, viewHeight],
        contentSize: contentSize.slice()
      });
    }
    if (isArray$1(positionExpr)) {
      x2 = parsePercent(positionExpr[0], viewWidth);
      y2 = parsePercent(positionExpr[1], viewHeight);
    } else if (isObject$4(positionExpr)) {
      var boxLayoutPosition = positionExpr;
      boxLayoutPosition.width = contentSize[0];
      boxLayoutPosition.height = contentSize[1];
      var layoutRect = getLayoutRect(boxLayoutPosition, {
        width: viewWidth,
        height: viewHeight
      });
      x2 = layoutRect.x;
      y2 = layoutRect.y;
      align = null;
      vAlign = null;
    } else if (isString(positionExpr) && el) {
      var pos = calcTooltipPosition(positionExpr, rect, contentSize, tooltipModel.get("borderWidth"));
      x2 = pos[0];
      y2 = pos[1];
    } else {
      var pos = refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, align ? null : 20, vAlign ? null : 20);
      x2 = pos[0];
      y2 = pos[1];
    }
    align && (x2 -= isCenterAlign(align) ? contentSize[0] / 2 : align === "right" ? contentSize[0] : 0);
    vAlign && (y2 -= isCenterAlign(vAlign) ? contentSize[1] / 2 : vAlign === "bottom" ? contentSize[1] : 0);
    if (shouldTooltipConfine(tooltipModel)) {
      var pos = confineTooltipPosition(x2, y2, content, viewWidth, viewHeight);
      x2 = pos[0];
      y2 = pos[1];
    }
    content.moveTo(x2, y2);
  };
  TooltipView2.prototype._updateContentNotChangedOnAxis = function(dataByCoordSys, cbParamsList) {
    var lastCoordSys = this._lastDataByCoordSys;
    var lastCbParamsList = this._cbParamsList;
    var contentNotChanged = !!lastCoordSys && lastCoordSys.length === dataByCoordSys.length;
    contentNotChanged && each$f(lastCoordSys, function(lastItemCoordSys, indexCoordSys) {
      var lastDataByAxis = lastItemCoordSys.dataByAxis || [];
      var thisItemCoordSys = dataByCoordSys[indexCoordSys] || {};
      var thisDataByAxis = thisItemCoordSys.dataByAxis || [];
      contentNotChanged = contentNotChanged && lastDataByAxis.length === thisDataByAxis.length;
      contentNotChanged && each$f(lastDataByAxis, function(lastItem, indexAxis) {
        var thisItem = thisDataByAxis[indexAxis] || {};
        var lastIndices = lastItem.seriesDataIndices || [];
        var newIndices = thisItem.seriesDataIndices || [];
        contentNotChanged = contentNotChanged && lastItem.value === thisItem.value && lastItem.axisType === thisItem.axisType && lastItem.axisId === thisItem.axisId && lastIndices.length === newIndices.length;
        contentNotChanged && each$f(lastIndices, function(lastIdxItem, j) {
          var newIdxItem = newIndices[j];
          contentNotChanged = contentNotChanged && lastIdxItem.seriesIndex === newIdxItem.seriesIndex && lastIdxItem.dataIndex === newIdxItem.dataIndex;
        });
        lastCbParamsList && each$f(lastItem.seriesDataIndices, function(idxItem) {
          var seriesIdx = idxItem.seriesIndex;
          var cbParams = cbParamsList[seriesIdx];
          var lastCbParams = lastCbParamsList[seriesIdx];
          if (cbParams && lastCbParams && lastCbParams.data !== cbParams.data) {
            contentNotChanged = false;
          }
        });
      });
    });
    this._lastDataByCoordSys = dataByCoordSys;
    this._cbParamsList = cbParamsList;
    return !!contentNotChanged;
  };
  TooltipView2.prototype._hide = function(dispatchAction2) {
    this._lastDataByCoordSys = null;
    dispatchAction2({
      type: "hideTip",
      from: this.uid
    });
  };
  TooltipView2.prototype.dispose = function(ecModel, api) {
    if (env$1.node || !api.getDom()) {
      return;
    }
    clear$1(this, "_updatePosition");
    this._tooltipContent.dispose();
    unregister("itemTooltip", api);
  };
  TooltipView2.type = "tooltip";
  return TooltipView2;
}(ComponentView$1);
function buildTooltipModel(modelCascade, globalTooltipModel, defaultTooltipOption) {
  var ecModel = globalTooltipModel.ecModel;
  var resultModel;
  if (defaultTooltipOption) {
    resultModel = new Model$1(defaultTooltipOption, ecModel, ecModel);
    resultModel = new Model$1(globalTooltipModel.option, resultModel, ecModel);
  } else {
    resultModel = globalTooltipModel;
  }
  for (var i = modelCascade.length - 1; i >= 0; i--) {
    var tooltipOpt = modelCascade[i];
    if (tooltipOpt) {
      if (tooltipOpt instanceof Model$1) {
        tooltipOpt = tooltipOpt.get("tooltip", true);
      }
      if (isString(tooltipOpt)) {
        tooltipOpt = {
          formatter: tooltipOpt
        };
      }
      if (tooltipOpt) {
        resultModel = new Model$1(tooltipOpt, resultModel, ecModel);
      }
    }
  }
  return resultModel;
}
function makeDispatchAction(payload, api) {
  return payload.dispatchAction || bind$1(api.dispatchAction, api);
}
function refixTooltipPosition(x2, y2, content, viewWidth, viewHeight, gapH, gapV) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  if (gapH != null) {
    if (x2 + width + gapH + 2 > viewWidth) {
      x2 -= width + gapH;
    } else {
      x2 += gapH;
    }
  }
  if (gapV != null) {
    if (y2 + height + gapV > viewHeight) {
      y2 -= height + gapV;
    } else {
      y2 += gapV;
    }
  }
  return [x2, y2];
}
function confineTooltipPosition(x2, y2, content, viewWidth, viewHeight) {
  var size = content.getSize();
  var width = size[0];
  var height = size[1];
  x2 = Math.min(x2 + width, viewWidth) - width;
  y2 = Math.min(y2 + height, viewHeight) - height;
  x2 = Math.max(x2, 0);
  y2 = Math.max(y2, 0);
  return [x2, y2];
}
function calcTooltipPosition(position2, rect, contentSize, borderWidth) {
  var domWidth = contentSize[0];
  var domHeight = contentSize[1];
  var offset = Math.ceil(Math.SQRT2 * borderWidth) + 8;
  var x2 = 0;
  var y2 = 0;
  var rectWidth = rect.width;
  var rectHeight = rect.height;
  switch (position2) {
    case "inside":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "top":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y - domHeight - offset;
      break;
    case "bottom":
      x2 = rect.x + rectWidth / 2 - domWidth / 2;
      y2 = rect.y + rectHeight + offset;
      break;
    case "left":
      x2 = rect.x - domWidth - offset;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
      break;
    case "right":
      x2 = rect.x + rectWidth + offset;
      y2 = rect.y + rectHeight / 2 - domHeight / 2;
  }
  return [x2, y2];
}
function isCenterAlign(align) {
  return align === "center" || align === "middle";
}
function findComponentReference(payload, ecModel, api) {
  var queryOptionMap = preParseFinder(payload).queryOptionMap;
  var componentMainType = queryOptionMap.keys()[0];
  if (!componentMainType || componentMainType === "series") {
    return;
  }
  var queryResult = queryReferringComponents(ecModel, componentMainType, queryOptionMap.get(componentMainType), {
    useDefault: false,
    enableAll: false,
    enableNone: false
  });
  var model = queryResult.models[0];
  if (!model) {
    return;
  }
  var view = api.getViewOfComponentModel(model);
  var el;
  view.group.traverse(function(subEl) {
    var tooltipConfig = getECData(subEl).tooltipConfig;
    if (tooltipConfig && tooltipConfig.name === payload.name) {
      el = subEl;
      return true;
    }
  });
  if (el) {
    return {
      componentMainType,
      componentIndex: model.componentIndex,
      el
    };
  }
}
var TooltipView$1 = TooltipView;
function install$i(registers) {
  use(install$q);
  registers.registerComponentModel(TooltipModel$1);
  registers.registerComponentView(TooltipView$1);
  registers.registerAction({
    type: "showTip",
    event: "showTip",
    update: "tooltip:manuallyShowTip"
  }, noop);
  registers.registerAction({
    type: "hideTip",
    event: "hideTip",
    update: "tooltip:manuallyHideTip"
  }, noop);
}
var DEFAULT_TOOLBOX_BTNS = ["rect", "polygon", "keep", "clear"];
function brushPreprocessor(option, isNew) {
  var brushComponents = normalizeToArray(option ? option.brush : []);
  if (!brushComponents.length) {
    return;
  }
  var brushComponentSpecifiedBtns = [];
  each$f(brushComponents, function(brushOpt) {
    var tbs = brushOpt.hasOwnProperty("toolbox") ? brushOpt.toolbox : [];
    if (tbs instanceof Array) {
      brushComponentSpecifiedBtns = brushComponentSpecifiedBtns.concat(tbs);
    }
  });
  var toolbox = option && option.toolbox;
  if (isArray$1(toolbox)) {
    toolbox = toolbox[0];
  }
  if (!toolbox) {
    toolbox = {
      feature: {}
    };
    option.toolbox = [toolbox];
  }
  var toolboxFeature = toolbox.feature || (toolbox.feature = {});
  var toolboxBrush = toolboxFeature.brush || (toolboxFeature.brush = {});
  var brushTypes = toolboxBrush.type || (toolboxBrush.type = []);
  brushTypes.push.apply(brushTypes, brushComponentSpecifiedBtns);
  removeDuplicate(brushTypes);
  if (isNew && !brushTypes.length) {
    brushTypes.push.apply(brushTypes, DEFAULT_TOOLBOX_BTNS);
  }
}
function removeDuplicate(arr) {
  var map2 = {};
  each$f(arr, function(val) {
    map2[val] = 1;
  });
  arr.length = 0;
  each$f(map2, function(flag, val) {
    arr.push(val);
  });
}
var each$4 = each$f;
function hasKeys(obj) {
  if (obj) {
    for (var name_1 in obj) {
      if (obj.hasOwnProperty(name_1)) {
        return true;
      }
    }
  }
}
function createVisualMappings(option, stateList, supplementVisualOption) {
  var visualMappings = {};
  each$4(stateList, function(state) {
    var mappings = visualMappings[state] = createMappings();
    each$4(option[state], function(visualData, visualType) {
      if (!VisualMapping$1.isValidType(visualType)) {
        return;
      }
      var mappingOption = {
        type: visualType,
        visual: visualData
      };
      supplementVisualOption && supplementVisualOption(mappingOption, state);
      mappings[visualType] = new VisualMapping$1(mappingOption);
      if (visualType === "opacity") {
        mappingOption = clone$4(mappingOption);
        mappingOption.type = "colorAlpha";
        mappings.__hidden.__alphaForOpacity = new VisualMapping$1(mappingOption);
      }
    });
  });
  return visualMappings;
  function createMappings() {
    var Creater = function() {
    };
    Creater.prototype.__hidden = Creater.prototype;
    var obj = new Creater();
    return obj;
  }
}
function replaceVisualOption(thisOption, newOption, keys2) {
  var has2;
  each$f(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      has2 = true;
    }
  });
  has2 && each$f(keys2, function(key) {
    if (newOption.hasOwnProperty(key) && hasKeys(newOption[key])) {
      thisOption[key] = clone$4(newOption[key]);
    } else {
      delete thisOption[key];
    }
  });
}
function applyVisual(stateList, visualMappings, data, getValueState, scope, dimension) {
  var visualTypesMap = {};
  each$f(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  var dataIndex;
  function getVisual(key) {
    return getItemVisualFromData(data, dataIndex, key);
  }
  function setVisual(key, value) {
    setItemVisualFromData(data, dataIndex, key, value);
  }
  if (dimension == null) {
    data.each(eachItem);
  } else {
    data.each([dimension], eachItem);
  }
  function eachItem(valueOrIndex, index2) {
    dataIndex = dimension == null ? valueOrIndex : index2;
    var rawDataItem = data.getRawDataItem(dataIndex);
    if (rawDataItem && rawDataItem.visualMap === false) {
      return;
    }
    var valueState = getValueState.call(scope, valueOrIndex);
    var mappings = visualMappings[valueState];
    var visualTypes = visualTypesMap[valueState];
    for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
      var type4 = visualTypes[i];
      mappings[type4] && mappings[type4].applyVisual(valueOrIndex, getVisual, setVisual);
    }
  }
}
function incrementalApplyVisual(stateList, visualMappings, getValueState, dim) {
  var visualTypesMap = {};
  each$f(stateList, function(state) {
    var visualTypes = VisualMapping$1.prepareVisualTypes(visualMappings[state]);
    visualTypesMap[state] = visualTypes;
  });
  return {
    progress: function progress(params, data) {
      var dimIndex;
      if (dim != null) {
        dimIndex = data.getDimensionIndex(dim);
      }
      function getVisual(key) {
        return getItemVisualFromData(data, dataIndex, key);
      }
      function setVisual(key, value2) {
        setItemVisualFromData(data, dataIndex, key, value2);
      }
      var dataIndex;
      var store = data.getStore();
      while ((dataIndex = params.next()) != null) {
        var rawDataItem = data.getRawDataItem(dataIndex);
        if (rawDataItem && rawDataItem.visualMap === false) {
          continue;
        }
        var value = dim != null ? store.get(dimIndex, dataIndex) : dataIndex;
        var valueState = getValueState(value);
        var mappings = visualMappings[valueState];
        var visualTypes = visualTypesMap[valueState];
        for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
          var type4 = visualTypes[i];
          mappings[type4] && mappings[type4].applyVisual(value, getVisual, setVisual);
        }
      }
    }
  };
}
function makeBrushCommonSelectorForSeries(area) {
  var brushType = area.brushType;
  var selectors = {
    point: function(itemLayout) {
      return selector[brushType].point(itemLayout, selectors, area);
    },
    rect: function(itemLayout) {
      return selector[brushType].rect(itemLayout, selectors, area);
    }
  };
  return selectors;
}
var selector = {
  lineX: getLineSelectors(0),
  lineY: getLineSelectors(1),
  rect: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.intersect(itemLayout);
    }
  },
  polygon: {
    point: function(itemLayout, selectors, area) {
      return itemLayout && area.boundingRect.contain(itemLayout[0], itemLayout[1]) && contain(area.range, itemLayout[0], itemLayout[1]);
    },
    rect: function(itemLayout, selectors, area) {
      var points2 = area.range;
      if (!itemLayout || points2.length <= 1) {
        return false;
      }
      var x2 = itemLayout.x;
      var y2 = itemLayout.y;
      var width = itemLayout.width;
      var height = itemLayout.height;
      var p2 = points2[0];
      if (contain(points2, x2, y2) || contain(points2, x2 + width, y2) || contain(points2, x2, y2 + height) || contain(points2, x2 + width, y2 + height) || BoundingRect$1.create(itemLayout).contain(p2[0], p2[1]) || linePolygonIntersect(x2, y2, x2 + width, y2, points2) || linePolygonIntersect(x2, y2, x2, y2 + height, points2) || linePolygonIntersect(x2 + width, y2, x2 + width, y2 + height, points2) || linePolygonIntersect(x2, y2 + height, x2 + width, y2 + height, points2)) {
        return true;
      }
    }
  }
};
function getLineSelectors(xyIndex) {
  var xy = ["x", "y"];
  var wh = ["width", "height"];
  return {
    point: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var p2 = itemLayout[xyIndex];
        return inLineRange(p2, range3);
      }
    },
    rect: function(itemLayout, selectors, area) {
      if (itemLayout) {
        var range3 = area.range;
        var layoutRange = [itemLayout[xy[xyIndex]], itemLayout[xy[xyIndex]] + itemLayout[wh[xyIndex]]];
        layoutRange[1] < layoutRange[0] && layoutRange.reverse();
        return inLineRange(layoutRange[0], range3) || inLineRange(layoutRange[1], range3) || inLineRange(range3[0], layoutRange) || inLineRange(range3[1], layoutRange);
      }
    }
  };
}
function inLineRange(p2, range3) {
  return range3[0] <= p2 && p2 <= range3[1];
}
var STATE_LIST = ["inBrush", "outOfBrush"];
var DISPATCH_METHOD = "__ecBrushSelect";
var DISPATCH_FLAG = "__ecInBrushSelectEvent";
function layoutCovers(ecModel) {
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    var brushTargetManager = brushModel.brushTargetManager = new BrushTargetManager$1(brushModel.option, ecModel);
    brushTargetManager.setInputRanges(brushModel.areas, ecModel);
  });
}
function brushVisual(ecModel, api, payload) {
  var brushSelected = [];
  var throttleType;
  var throttleDelay;
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel) {
    payload && payload.type === "takeGlobalCursor" && brushModel.setBrushOption(payload.key === "brush" ? payload.brushOption : {
      brushType: false
    });
  });
  layoutCovers(ecModel);
  ecModel.eachComponent({
    mainType: "brush"
  }, function(brushModel, brushIndex) {
    var thisBrushSelected = {
      brushId: brushModel.id,
      brushIndex,
      brushName: brushModel.name,
      areas: clone$4(brushModel.areas),
      selected: []
    };
    brushSelected.push(thisBrushSelected);
    var brushOption = brushModel.option;
    var brushLink = brushOption.brushLink;
    var linkedSeriesMap = [];
    var selectedDataIndexForLink = [];
    var rangeInfoBySeries = [];
    var hasBrushExists = false;
    if (!brushIndex) {
      throttleType = brushOption.throttleType;
      throttleDelay = brushOption.throttleDelay;
    }
    var areas = map$1(brushModel.areas, function(area) {
      var builder = boundingRectBuilders[area.brushType];
      var selectableArea = defaults({
        boundingRect: builder ? builder(area) : void 0
      }, area);
      selectableArea.selectors = makeBrushCommonSelectorForSeries(selectableArea);
      return selectableArea;
    });
    var visualMappings = createVisualMappings(brushModel.option, STATE_LIST, function(mappingOption) {
      mappingOption.mappingMethod = "fixed";
    });
    isArray$1(brushLink) && each$f(brushLink, function(seriesIndex) {
      linkedSeriesMap[seriesIndex] = 1;
    });
    function linkOthers(seriesIndex) {
      return brushLink === "all" || !!linkedSeriesMap[seriesIndex];
    }
    function brushed(rangeInfoList) {
      return !!rangeInfoList.length;
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var rangeInfoList = rangeInfoBySeries[seriesIndex] = [];
      seriesModel.subType === "parallel" ? stepAParallel(seriesModel, seriesIndex) : stepAOthers(seriesModel, seriesIndex, rangeInfoList);
    });
    function stepAParallel(seriesModel, seriesIndex) {
      var coordSys = seriesModel.coordinateSystem;
      hasBrushExists = hasBrushExists || coordSys.hasAxisBrushed();
      linkOthers(seriesIndex) && coordSys.eachActiveState(seriesModel.getData(), function(activeState, dataIndex) {
        activeState === "active" && (selectedDataIndexForLink[dataIndex] = 1);
      });
    }
    function stepAOthers(seriesModel, seriesIndex, rangeInfoList) {
      if (!seriesModel.brushSelector || brushModelNotControll(brushModel, seriesIndex)) {
        return;
      }
      each$f(areas, function(area) {
        if (brushModel.brushTargetManager.controlSeries(area, seriesModel, ecModel)) {
          rangeInfoList.push(area);
        }
        hasBrushExists = hasBrushExists || brushed(rangeInfoList);
      });
      if (linkOthers(seriesIndex) && brushed(rangeInfoList)) {
        var data_1 = seriesModel.getData();
        data_1.each(function(dataIndex) {
          if (checkInRange(seriesModel, rangeInfoList, data_1, dataIndex)) {
            selectedDataIndexForLink[dataIndex] = 1;
          }
        });
      }
    }
    ecModel.eachSeries(function(seriesModel, seriesIndex) {
      var seriesBrushSelected = {
        seriesId: seriesModel.id,
        seriesIndex,
        seriesName: seriesModel.name,
        dataIndex: []
      };
      thisBrushSelected.selected.push(seriesBrushSelected);
      var rangeInfoList = rangeInfoBySeries[seriesIndex];
      var data = seriesModel.getData();
      var getValueState = linkOthers(seriesIndex) ? function(dataIndex) {
        return selectedDataIndexForLink[dataIndex] ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      } : function(dataIndex) {
        return checkInRange(seriesModel, rangeInfoList, data, dataIndex) ? (seriesBrushSelected.dataIndex.push(data.getRawIndex(dataIndex)), "inBrush") : "outOfBrush";
      };
      (linkOthers(seriesIndex) ? hasBrushExists : brushed(rangeInfoList)) && applyVisual(STATE_LIST, visualMappings, data, getValueState);
    });
  });
  dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload);
}
function dispatchAction$1(api, throttleType, throttleDelay, brushSelected, payload) {
  if (!payload) {
    return;
  }
  var zr = api.getZr();
  if (zr[DISPATCH_FLAG]) {
    return;
  }
  if (!zr[DISPATCH_METHOD]) {
    zr[DISPATCH_METHOD] = doDispatch;
  }
  var fn = createOrUpdate(zr, DISPATCH_METHOD, throttleDelay, throttleType);
  fn(api, brushSelected);
}
function doDispatch(api, brushSelected) {
  if (!api.isDisposed()) {
    var zr = api.getZr();
    zr[DISPATCH_FLAG] = true;
    api.dispatchAction({
      type: "brushSelect",
      batch: brushSelected
    });
    zr[DISPATCH_FLAG] = false;
  }
}
function checkInRange(seriesModel, rangeInfoList, data, dataIndex) {
  for (var i = 0, len2 = rangeInfoList.length; i < len2; i++) {
    var area = rangeInfoList[i];
    if (seriesModel.brushSelector(dataIndex, data, area.selectors, area)) {
      return true;
    }
  }
}
function brushModelNotControll(brushModel, seriesIndex) {
  var seriesIndices = brushModel.option.seriesIndex;
  return seriesIndices != null && seriesIndices !== "all" && (isArray$1(seriesIndices) ? indexOf(seriesIndices, seriesIndex) < 0 : seriesIndex !== seriesIndices);
}
var boundingRectBuilders = {
  rect: function(area) {
    return getBoundingRectFromMinMax(area.range);
  },
  polygon: function(area) {
    var minMax;
    var range3 = area.range;
    for (var i = 0, len2 = range3.length; i < len2; i++) {
      minMax = minMax || [[Infinity, -Infinity], [Infinity, -Infinity]];
      var rg = range3[i];
      rg[0] < minMax[0][0] && (minMax[0][0] = rg[0]);
      rg[0] > minMax[0][1] && (minMax[0][1] = rg[0]);
      rg[1] < minMax[1][0] && (minMax[1][0] = rg[1]);
      rg[1] > minMax[1][1] && (minMax[1][1] = rg[1]);
    }
    return minMax && getBoundingRectFromMinMax(minMax);
  }
};
function getBoundingRectFromMinMax(minMax) {
  return new BoundingRect$1(minMax[0][0], minMax[1][0], minMax[0][1] - minMax[0][0], minMax[1][1] - minMax[1][0]);
}
var BrushView = function(_super) {
  __extends(BrushView2, _super);
  function BrushView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushView2.type;
    return _this;
  }
  BrushView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
    this.model;
    (this._brushController = new BrushController$1(api.getZr())).on("brush", bind$1(this._onBrush, this)).mount();
  };
  BrushView2.prototype.render = function(brushModel, ecModel, api, payload) {
    this.model = brushModel;
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateTransform = function(brushModel, ecModel, api, payload) {
    layoutCovers(ecModel);
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateVisual = function(brushModel, ecModel, api, payload) {
    this.updateTransform(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype.updateView = function(brushModel, ecModel, api, payload) {
    this._updateController(brushModel, ecModel, api, payload);
  };
  BrushView2.prototype._updateController = function(brushModel, ecModel, api, payload) {
    (!payload || payload.$from !== brushModel.id) && this._brushController.setPanels(brushModel.brushTargetManager.makePanelOpts(api)).enableBrush(brushModel.brushOption).updateCovers(brushModel.areas.slice());
  };
  BrushView2.prototype.dispose = function() {
    this._brushController.dispose();
  };
  BrushView2.prototype._onBrush = function(eventParam) {
    var modelId = this.model.id;
    var areas = this.model.brushTargetManager.setOutputRanges(eventParam.areas, this.ecModel);
    (!eventParam.isEnd || eventParam.removeOnClick) && this.api.dispatchAction({
      type: "brush",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
    eventParam.isEnd && this.api.dispatchAction({
      type: "brushEnd",
      brushId: modelId,
      areas: clone$4(areas),
      $from: modelId
    });
  };
  BrushView2.type = "brush";
  return BrushView2;
}(ComponentView$1);
var BrushView$1 = BrushView;
var DEFAULT_OUT_OF_BRUSH_COLOR = "#ddd";
var BrushModel = function(_super) {
  __extends(BrushModel2, _super);
  function BrushModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = BrushModel2.type;
    _this.areas = [];
    _this.brushOption = {};
    return _this;
  }
  BrushModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, ["inBrush", "outOfBrush"]);
    var inBrush = thisOption.inBrush = thisOption.inBrush || {};
    thisOption.outOfBrush = thisOption.outOfBrush || {
      color: DEFAULT_OUT_OF_BRUSH_COLOR
    };
    if (!inBrush.hasOwnProperty("liftZ")) {
      inBrush.liftZ = 5;
    }
  };
  BrushModel2.prototype.setAreas = function(areas) {
    if (!areas) {
      return;
    }
    this.areas = map$1(areas, function(area) {
      return generateBrushOption(this.option, area);
    }, this);
  };
  BrushModel2.prototype.setBrushOption = function(brushOption) {
    this.brushOption = generateBrushOption(this.option, brushOption);
    this.brushType = this.brushOption.brushType;
  };
  BrushModel2.type = "brush";
  BrushModel2.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"];
  BrushModel2.defaultOption = {
    seriesIndex: "all",
    brushType: "rect",
    brushMode: "single",
    transformable: true,
    brushStyle: {
      borderWidth: 1,
      color: "rgba(210,219,238,0.3)",
      borderColor: "#D2DBEE"
    },
    throttleType: "fixRate",
    throttleDelay: 0,
    removeOnClick: true,
    z: 1e4
  };
  return BrushModel2;
}(ComponentModel$1);
function generateBrushOption(option, brushOption) {
  return merge({
    brushType: option.brushType,
    brushMode: option.brushMode,
    transformable: option.transformable,
    brushStyle: new Model$1(option.brushStyle).getItemStyle(),
    removeOnClick: option.removeOnClick,
    z: option.z
  }, brushOption, true);
}
var BrushModel$1 = BrushModel;
var ICON_TYPES = ["rect", "polygon", "lineX", "lineY", "keep", "clear"];
var BrushFeature = function(_super) {
  __extends(BrushFeature2, _super);
  function BrushFeature2() {
    return _super !== null && _super.apply(this, arguments) || this;
  }
  BrushFeature2.prototype.render = function(featureModel, ecModel, api) {
    var brushType;
    var brushMode;
    var isBrushed;
    ecModel.eachComponent({
      mainType: "brush"
    }, function(brushModel) {
      brushType = brushModel.brushType;
      brushMode = brushModel.brushOption.brushMode || "single";
      isBrushed = isBrushed || !!brushModel.areas.length;
    });
    this._brushType = brushType;
    this._brushMode = brushMode;
    each$f(featureModel.get("type", true), function(type4) {
      featureModel.setIconStatus(type4, (type4 === "keep" ? brushMode === "multiple" : type4 === "clear" ? isBrushed : type4 === brushType) ? "emphasis" : "normal");
    });
  };
  BrushFeature2.prototype.updateView = function(featureModel, ecModel, api) {
    this.render(featureModel, ecModel, api);
  };
  BrushFeature2.prototype.getIcons = function() {
    var model = this.model;
    var availableIcons = model.get("icon", true);
    var icons = {};
    each$f(model.get("type", true), function(type4) {
      if (availableIcons[type4]) {
        icons[type4] = availableIcons[type4];
      }
    });
    return icons;
  };
  BrushFeature2.prototype.onclick = function(ecModel, api, type4) {
    var brushType = this._brushType;
    var brushMode = this._brushMode;
    if (type4 === "clear") {
      api.dispatchAction({
        type: "axisAreaSelect",
        intervals: []
      });
      api.dispatchAction({
        type: "brush",
        command: "clear",
        areas: []
      });
    } else {
      api.dispatchAction({
        type: "takeGlobalCursor",
        key: "brush",
        brushOption: {
          brushType: type4 === "keep" ? brushType : brushType === type4 ? false : type4,
          brushMode: type4 === "keep" ? brushMode === "multiple" ? "single" : "multiple" : brushMode
        }
      });
    }
  };
  BrushFeature2.getDefaultOption = function(ecModel) {
    var defaultOption2 = {
      show: true,
      type: ICON_TYPES.slice(),
      icon: {
        rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13",
        polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2",
        lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4",
        lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4",
        keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z",
        clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2"
      },
      title: ecModel.getLocaleModel().get(["toolbox", "brush", "title"])
    };
    return defaultOption2;
  };
  return BrushFeature2;
}(ToolboxFeature);
var BrushFeature$1 = BrushFeature;
function install$h(registers) {
  registers.registerComponentView(BrushView$1);
  registers.registerComponentModel(BrushModel$1);
  registers.registerPreprocessor(brushPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.BRUSH, brushVisual);
  registers.registerAction({
    type: "brush",
    event: "brush",
    update: "updateVisual"
  }, function(payload, ecModel) {
    ecModel.eachComponent({
      mainType: "brush",
      query: payload
    }, function(brushModel) {
      brushModel.setAreas(payload.areas);
    });
  });
  registers.registerAction({
    type: "brushSelect",
    event: "brushSelected",
    update: "none"
  }, noop);
  registers.registerAction({
    type: "brushEnd",
    event: "brushEnd",
    update: "none"
  }, noop);
  registerFeature("brush", BrushFeature$1);
}
var TitleModel = function(_super) {
  __extends(TitleModel2, _super);
  function TitleModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  TitleModel2.type = "title";
  TitleModel2.defaultOption = {
    z: 6,
    show: true,
    text: "",
    target: "blank",
    subtext: "",
    subtarget: "blank",
    left: 0,
    top: 0,
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    textStyle: {
      fontSize: 18,
      fontWeight: "bold",
      color: "#464646"
    },
    subtextStyle: {
      fontSize: 12,
      color: "#6E7079"
    }
  };
  return TitleModel2;
}(ComponentModel$1);
var TitleView = function(_super) {
  __extends(TitleView2, _super);
  function TitleView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TitleView2.type;
    return _this;
  }
  TitleView2.prototype.render = function(titleModel, ecModel, api) {
    this.group.removeAll();
    if (!titleModel.get("show")) {
      return;
    }
    var group = this.group;
    var textStyleModel = titleModel.getModel("textStyle");
    var subtextStyleModel = titleModel.getModel("subtextStyle");
    var textAlign = titleModel.get("textAlign");
    var textVerticalAlign = retrieve2(titleModel.get("textBaseline"), titleModel.get("textVerticalAlign"));
    var textEl = new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: titleModel.get("text"),
        fill: textStyleModel.getTextColor()
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var textRect = textEl.getBoundingRect();
    var subText = titleModel.get("subtext");
    var subTextEl = new ZRText$1({
      style: createTextStyle(subtextStyleModel, {
        text: subText,
        fill: subtextStyleModel.getTextColor(),
        y: textRect.height + titleModel.get("itemGap"),
        verticalAlign: "top"
      }, {
        disableBox: true
      }),
      z2: 10
    });
    var link = titleModel.get("link");
    var sublink = titleModel.get("sublink");
    var triggerEvent = titleModel.get("triggerEvent", true);
    textEl.silent = !link && !triggerEvent;
    subTextEl.silent = !sublink && !triggerEvent;
    if (link) {
      textEl.on("click", function() {
        windowOpen(link, "_" + titleModel.get("target"));
      });
    }
    if (sublink) {
      subTextEl.on("click", function() {
        windowOpen(sublink, "_" + titleModel.get("subtarget"));
      });
    }
    getECData(textEl).eventData = getECData(subTextEl).eventData = triggerEvent ? {
      componentType: "title",
      componentIndex: titleModel.componentIndex
    } : null;
    group.add(textEl);
    subText && group.add(subTextEl);
    var groupRect = group.getBoundingRect();
    var layoutOption = titleModel.getBoxLayoutParams();
    layoutOption.width = groupRect.width;
    layoutOption.height = groupRect.height;
    var layoutRect = getLayoutRect(layoutOption, {
      width: api.getWidth(),
      height: api.getHeight()
    }, titleModel.get("padding"));
    if (!textAlign) {
      textAlign = titleModel.get("left") || titleModel.get("right");
      if (textAlign === "middle") {
        textAlign = "center";
      }
      if (textAlign === "right") {
        layoutRect.x += layoutRect.width;
      } else if (textAlign === "center") {
        layoutRect.x += layoutRect.width / 2;
      }
    }
    if (!textVerticalAlign) {
      textVerticalAlign = titleModel.get("top") || titleModel.get("bottom");
      if (textVerticalAlign === "center") {
        textVerticalAlign = "middle";
      }
      if (textVerticalAlign === "bottom") {
        layoutRect.y += layoutRect.height;
      } else if (textVerticalAlign === "middle") {
        layoutRect.y += layoutRect.height / 2;
      }
      textVerticalAlign = textVerticalAlign || "top";
    }
    group.x = layoutRect.x;
    group.y = layoutRect.y;
    group.markRedraw();
    var alignStyle = {
      align: textAlign,
      verticalAlign: textVerticalAlign
    };
    textEl.setStyle(alignStyle);
    subTextEl.setStyle(alignStyle);
    groupRect = group.getBoundingRect();
    var padding = layoutRect.margin;
    var style = titleModel.getItemStyle(["color", "opacity"]);
    style.fill = titleModel.get("backgroundColor");
    var rect = new Rect$3({
      shape: {
        x: groupRect.x - padding[3],
        y: groupRect.y - padding[0],
        width: groupRect.width + padding[1] + padding[3],
        height: groupRect.height + padding[0] + padding[2],
        r: titleModel.get("borderRadius")
      },
      style,
      subPixelOptimize: true,
      silent: true
    });
    group.add(rect);
  };
  TitleView2.type = "title";
  return TitleView2;
}(ComponentView$1);
function install$g(registers) {
  registers.registerComponentModel(TitleModel);
  registers.registerComponentView(TitleView);
}
var TimelineModel = function(_super) {
  __extends(TimelineModel2, _super);
  function TimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineModel2.type;
    _this.layoutMode = "box";
    return _this;
  }
  TimelineModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._initData();
  };
  TimelineModel2.prototype.mergeOption = function(option) {
    _super.prototype.mergeOption.apply(this, arguments);
    this._initData();
  };
  TimelineModel2.prototype.setCurrentIndex = function(currentIndex) {
    if (currentIndex == null) {
      currentIndex = this.option.currentIndex;
    }
    var count2 = this._data.count();
    if (this.option.loop) {
      currentIndex = (currentIndex % count2 + count2) % count2;
    } else {
      currentIndex >= count2 && (currentIndex = count2 - 1);
      currentIndex < 0 && (currentIndex = 0);
    }
    this.option.currentIndex = currentIndex;
  };
  TimelineModel2.prototype.getCurrentIndex = function() {
    return this.option.currentIndex;
  };
  TimelineModel2.prototype.isIndexMax = function() {
    return this.getCurrentIndex() >= this._data.count() - 1;
  };
  TimelineModel2.prototype.setPlayState = function(state) {
    this.option.autoPlay = !!state;
  };
  TimelineModel2.prototype.getPlayState = function() {
    return !!this.option.autoPlay;
  };
  TimelineModel2.prototype._initData = function() {
    var thisOption = this.option;
    var dataArr = thisOption.data || [];
    var axisType = thisOption.axisType;
    var names2 = this._names = [];
    var processedDataArr;
    if (axisType === "category") {
      processedDataArr = [];
      each$f(dataArr, function(item, index2) {
        var value = convertOptionIdName(getDataItemValue(item), "");
        var newItem;
        if (isObject$4(item)) {
          newItem = clone$4(item);
          newItem.value = index2;
        } else {
          newItem = index2;
        }
        processedDataArr.push(newItem);
        names2.push(value);
      });
    } else {
      processedDataArr = dataArr;
    }
    var dimType = {
      category: "ordinal",
      time: "time",
      value: "number"
    }[axisType] || "number";
    var data = this._data = new SeriesData$1([{
      name: "value",
      type: dimType
    }], this);
    data.initData(processedDataArr, names2);
  };
  TimelineModel2.prototype.getData = function() {
    return this._data;
  };
  TimelineModel2.prototype.getCategories = function() {
    if (this.get("axisType") === "category") {
      return this._names.slice();
    }
  };
  TimelineModel2.type = "timeline";
  TimelineModel2.defaultOption = {
    z: 4,
    show: true,
    axisType: "time",
    realtime: true,
    left: "20%",
    top: null,
    right: "20%",
    bottom: 0,
    width: null,
    height: 40,
    padding: 5,
    controlPosition: "left",
    autoPlay: false,
    rewind: false,
    loop: true,
    playInterval: 2e3,
    currentIndex: 0,
    itemStyle: {},
    label: {
      color: "#000"
    },
    data: []
  };
  return TimelineModel2;
}(ComponentModel$1);
var TimelineModel$1 = TimelineModel;
var SliderTimelineModel = function(_super) {
  __extends(SliderTimelineModel2, _super);
  function SliderTimelineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineModel2.type;
    return _this;
  }
  SliderTimelineModel2.type = "timeline.slider";
  SliderTimelineModel2.defaultOption = inheritDefaultOption(TimelineModel$1.defaultOption, {
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderWidth: 0,
    orient: "horizontal",
    inverse: false,
    tooltip: {
      trigger: "item"
    },
    symbol: "circle",
    symbolSize: 12,
    lineStyle: {
      show: true,
      width: 2,
      color: "#DAE1F5"
    },
    label: {
      position: "auto",
      show: true,
      interval: "auto",
      rotate: 0,
      color: "#A4B1D7"
    },
    itemStyle: {
      color: "#A4B1D7",
      borderWidth: 1
    },
    checkpointStyle: {
      symbol: "circle",
      symbolSize: 15,
      color: "#316bf3",
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0, 0, 0, 0.3)",
      animation: true,
      animationDuration: 300,
      animationEasing: "quinticInOut"
    },
    controlStyle: {
      show: true,
      showPlayBtn: true,
      showPrevBtn: true,
      showNextBtn: true,
      itemSize: 24,
      itemGap: 12,
      position: "left",
      playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z",
      stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z",
      nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z",
      prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z",
      prevBtnSize: 18,
      nextBtnSize: 18,
      color: "#A4B1D7",
      borderColor: "#A4B1D7",
      borderWidth: 1
    },
    emphasis: {
      label: {
        show: true,
        color: "#6f778d"
      },
      itemStyle: {
        color: "#316BF3"
      },
      controlStyle: {
        color: "#316BF3",
        borderColor: "#316BF3",
        borderWidth: 2
      }
    },
    progress: {
      lineStyle: {
        color: "#316BF3"
      },
      itemStyle: {
        color: "#316BF3"
      },
      label: {
        color: "#6f778d"
      }
    },
    data: []
  });
  return SliderTimelineModel2;
}(TimelineModel$1);
mixin(SliderTimelineModel, DataFormatMixin.prototype);
var SliderTimelineModel$1 = SliderTimelineModel;
var TimelineView = function(_super) {
  __extends(TimelineView2, _super);
  function TimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = TimelineView2.type;
    return _this;
  }
  TimelineView2.type = "timeline";
  return TimelineView2;
}(ComponentView$1);
var TimelineView$1 = TimelineView;
var TimelineAxis = function(_super) {
  __extends(TimelineAxis2, _super);
  function TimelineAxis2(dim, scale2, coordExtent, axisType) {
    var _this = _super.call(this, dim, scale2, coordExtent) || this;
    _this.type = axisType || "value";
    return _this;
  }
  TimelineAxis2.prototype.getLabelModel = function() {
    return this.model.getModel("label");
  };
  TimelineAxis2.prototype.isHorizontal = function() {
    return this.model.get("orient") === "horizontal";
  };
  return TimelineAxis2;
}(Axis$1);
var TimelineAxis$1 = TimelineAxis;
var PI = Math.PI;
var labelDataIndexStore = makeInner();
var SliderTimelineView = function(_super) {
  __extends(SliderTimelineView2, _super);
  function SliderTimelineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderTimelineView2.type;
    return _this;
  }
  SliderTimelineView2.prototype.init = function(ecModel, api) {
    this.api = api;
  };
  SliderTimelineView2.prototype.render = function(timelineModel, ecModel, api) {
    this.model = timelineModel;
    this.api = api;
    this.ecModel = ecModel;
    this.group.removeAll();
    if (timelineModel.get("show", true)) {
      var layoutInfo_1 = this._layout(timelineModel, api);
      var mainGroup_1 = this._createGroup("_mainGroup");
      var labelGroup = this._createGroup("_labelGroup");
      var axis_1 = this._axis = this._createAxis(layoutInfo_1, timelineModel);
      timelineModel.formatTooltip = function(dataIndex) {
        var name = axis_1.scale.getLabel({
          value: dataIndex
        });
        return createTooltipMarkup("nameValue", {
          noName: true,
          value: name
        });
      };
      each$f(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(name) {
        this["_render" + name](layoutInfo_1, mainGroup_1, axis_1, timelineModel);
      }, this);
      this._renderAxisLabel(layoutInfo_1, labelGroup, axis_1, timelineModel);
      this._position(layoutInfo_1, timelineModel);
    }
    this._doPlayStop();
    this._updateTicksStatus();
  };
  SliderTimelineView2.prototype.remove = function() {
    this._clearTimer();
    this.group.removeAll();
  };
  SliderTimelineView2.prototype.dispose = function() {
    this._clearTimer();
  };
  SliderTimelineView2.prototype._layout = function(timelineModel, api) {
    var labelPosOpt = timelineModel.get(["label", "position"]);
    var orient = timelineModel.get("orient");
    var viewRect2 = getViewRect(timelineModel, api);
    var parsedLabelPos;
    if (labelPosOpt == null || labelPosOpt === "auto") {
      parsedLabelPos = orient === "horizontal" ? viewRect2.y + viewRect2.height / 2 < api.getHeight() / 2 ? "-" : "+" : viewRect2.x + viewRect2.width / 2 < api.getWidth() / 2 ? "+" : "-";
    } else if (isString(labelPosOpt)) {
      parsedLabelPos = {
        horizontal: {
          top: "-",
          bottom: "+"
        },
        vertical: {
          left: "-",
          right: "+"
        }
      }[orient][labelPosOpt];
    } else {
      parsedLabelPos = labelPosOpt;
    }
    var labelAlignMap = {
      horizontal: "center",
      vertical: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "left" : "right"
    };
    var labelBaselineMap = {
      horizontal: parsedLabelPos >= 0 || parsedLabelPos === "+" ? "top" : "bottom",
      vertical: "middle"
    };
    var rotationMap = {
      horizontal: 0,
      vertical: PI / 2
    };
    var mainLength = orient === "vertical" ? viewRect2.height : viewRect2.width;
    var controlModel = timelineModel.getModel("controlStyle");
    var showControl = controlModel.get("show", true);
    var controlSize = showControl ? controlModel.get("itemSize") : 0;
    var controlGap = showControl ? controlModel.get("itemGap") : 0;
    var sizePlusGap = controlSize + controlGap;
    var labelRotation = timelineModel.get(["label", "rotate"]) || 0;
    labelRotation = labelRotation * PI / 180;
    var playPosition;
    var prevBtnPosition;
    var nextBtnPosition;
    var controlPosition = controlModel.get("position", true);
    var showPlayBtn = showControl && controlModel.get("showPlayBtn", true);
    var showPrevBtn = showControl && controlModel.get("showPrevBtn", true);
    var showNextBtn = showControl && controlModel.get("showNextBtn", true);
    var xLeft = 0;
    var xRight = mainLength;
    if (controlPosition === "left" || controlPosition === "bottom") {
      showPlayBtn && (playPosition = [0, 0], xLeft += sizePlusGap);
      showPrevBtn && (prevBtnPosition = [xLeft, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    } else {
      showPlayBtn && (playPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
      showPrevBtn && (prevBtnPosition = [0, 0], xLeft += sizePlusGap);
      showNextBtn && (nextBtnPosition = [xRight - controlSize, 0], xRight -= sizePlusGap);
    }
    var axisExtent = [xLeft, xRight];
    if (timelineModel.get("inverse")) {
      axisExtent.reverse();
    }
    return {
      viewRect: viewRect2,
      mainLength,
      orient,
      rotation: rotationMap[orient],
      labelRotation,
      labelPosOpt: parsedLabelPos,
      labelAlign: timelineModel.get(["label", "align"]) || labelAlignMap[orient],
      labelBaseline: timelineModel.get(["label", "verticalAlign"]) || timelineModel.get(["label", "baseline"]) || labelBaselineMap[orient],
      playPosition,
      prevBtnPosition,
      nextBtnPosition,
      axisExtent,
      controlSize,
      controlGap
    };
  };
  SliderTimelineView2.prototype._position = function(layoutInfo, timelineModel) {
    var mainGroup = this._mainGroup;
    var labelGroup = this._labelGroup;
    var viewRect2 = layoutInfo.viewRect;
    if (layoutInfo.orient === "vertical") {
      var m2 = create$1();
      var rotateOriginX = viewRect2.x;
      var rotateOriginY = viewRect2.y + viewRect2.height;
      translate(m2, m2, [-rotateOriginX, -rotateOriginY]);
      rotate(m2, m2, -PI / 2);
      translate(m2, m2, [rotateOriginX, rotateOriginY]);
      viewRect2 = viewRect2.clone();
      viewRect2.applyTransform(m2);
    }
    var viewBound = getBound(viewRect2);
    var mainBound = getBound(mainGroup.getBoundingRect());
    var labelBound = getBound(labelGroup.getBoundingRect());
    var mainPosition = [mainGroup.x, mainGroup.y];
    var labelsPosition = [labelGroup.x, labelGroup.y];
    labelsPosition[0] = mainPosition[0] = viewBound[0][0];
    var labelPosOpt = layoutInfo.labelPosOpt;
    if (labelPosOpt == null || isString(labelPosOpt)) {
      var mainBoundIdx = labelPosOpt === "+" ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      toBound(labelsPosition, labelBound, viewBound, 1, 1 - mainBoundIdx);
    } else {
      var mainBoundIdx = labelPosOpt >= 0 ? 0 : 1;
      toBound(mainPosition, mainBound, viewBound, 1, mainBoundIdx);
      labelsPosition[1] = mainPosition[1] + labelPosOpt;
    }
    mainGroup.setPosition(mainPosition);
    labelGroup.setPosition(labelsPosition);
    mainGroup.rotation = labelGroup.rotation = layoutInfo.rotation;
    setOrigin(mainGroup);
    setOrigin(labelGroup);
    function setOrigin(targetGroup) {
      targetGroup.originX = viewBound[0][0] - targetGroup.x;
      targetGroup.originY = viewBound[1][0] - targetGroup.y;
    }
    function getBound(rect) {
      return [[rect.x, rect.x + rect.width], [rect.y, rect.y + rect.height]];
    }
    function toBound(fromPos, from, to, dimIdx, boundIdx) {
      fromPos[dimIdx] += to[dimIdx][boundIdx] - from[dimIdx][boundIdx];
    }
  };
  SliderTimelineView2.prototype._createAxis = function(layoutInfo, timelineModel) {
    var data = timelineModel.getData();
    var axisType = timelineModel.get("axisType");
    var scale2 = createScaleByModel(timelineModel, axisType);
    scale2.getTicks = function() {
      return data.mapArray(["value"], function(value) {
        return {
          value
        };
      });
    };
    var dataExtent = data.getDataExtent("value");
    scale2.setExtent(dataExtent[0], dataExtent[1]);
    scale2.calcNiceTicks();
    var axis = new TimelineAxis$1("value", scale2, layoutInfo.axisExtent, axisType);
    axis.model = timelineModel;
    return axis;
  };
  SliderTimelineView2.prototype._createGroup = function(key) {
    var newGroup = this[key] = new Group$4();
    this.group.add(newGroup);
    return newGroup;
  };
  SliderTimelineView2.prototype._renderAxisLine = function(layoutInfo, group, axis, timelineModel) {
    var axisExtent = axis.getExtent();
    if (!timelineModel.get(["lineStyle", "show"])) {
      return;
    }
    var line = new Line$3({
      shape: {
        x1: axisExtent[0],
        y1: 0,
        x2: axisExtent[1],
        y2: 0
      },
      style: extend({
        lineCap: "round"
      }, timelineModel.getModel("lineStyle").getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(line);
    var progressLine = this._progressLine = new Line$3({
      shape: {
        x1: axisExtent[0],
        x2: this._currentPointer ? this._currentPointer.x : axisExtent[0],
        y1: 0,
        y2: 0
      },
      style: defaults({
        lineCap: "round",
        lineWidth: line.style.lineWidth
      }, timelineModel.getModel(["progress", "lineStyle"]).getLineStyle()),
      silent: true,
      z2: 1
    });
    group.add(progressLine);
  };
  SliderTimelineView2.prototype._renderAxisTick = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var data = timelineModel.getData();
    var ticks = axis.scale.getTicks();
    this._tickSymbols = [];
    each$f(ticks, function(tick) {
      var tickCoord = axis.dataToCoord(tick.value);
      var itemModel = data.getItemModel(tick.value);
      var itemStyleModel = itemModel.getModel("itemStyle");
      var hoverStyleModel = itemModel.getModel(["emphasis", "itemStyle"]);
      var progressStyleModel = itemModel.getModel(["progress", "itemStyle"]);
      var symbolOpt = {
        x: tickCoord,
        y: 0,
        onclick: bind$1(_this._changeTimeline, _this, tick.value)
      };
      var el = giveSymbol(itemModel, itemStyleModel, group, symbolOpt);
      el.ensureState("emphasis").style = hoverStyleModel.getItemStyle();
      el.ensureState("progress").style = progressStyleModel.getItemStyle();
      enableHoverEmphasis(el);
      var ecData = getECData(el);
      if (itemModel.get("tooltip")) {
        ecData.dataIndex = tick.value;
        ecData.dataModel = timelineModel;
      } else {
        ecData.dataIndex = ecData.dataModel = null;
      }
      _this._tickSymbols.push(el);
    });
  };
  SliderTimelineView2.prototype._renderAxisLabel = function(layoutInfo, group, axis, timelineModel) {
    var _this = this;
    var labelModel = axis.getLabelModel();
    if (!labelModel.get("show")) {
      return;
    }
    var data = timelineModel.getData();
    var labels = axis.getViewLabels();
    this._tickLabels = [];
    each$f(labels, function(labelItem) {
      var dataIndex = labelItem.tickValue;
      var itemModel = data.getItemModel(dataIndex);
      var normalLabelModel = itemModel.getModel("label");
      var hoverLabelModel = itemModel.getModel(["emphasis", "label"]);
      var progressLabelModel = itemModel.getModel(["progress", "label"]);
      var tickCoord = axis.dataToCoord(labelItem.tickValue);
      var textEl = new ZRText$1({
        x: tickCoord,
        y: 0,
        rotation: layoutInfo.labelRotation - layoutInfo.rotation,
        onclick: bind$1(_this._changeTimeline, _this, dataIndex),
        silent: false,
        style: createTextStyle(normalLabelModel, {
          text: labelItem.formattedLabel,
          align: layoutInfo.labelAlign,
          verticalAlign: layoutInfo.labelBaseline
        })
      });
      textEl.ensureState("emphasis").style = createTextStyle(hoverLabelModel);
      textEl.ensureState("progress").style = createTextStyle(progressLabelModel);
      group.add(textEl);
      enableHoverEmphasis(textEl);
      labelDataIndexStore(textEl).dataIndex = dataIndex;
      _this._tickLabels.push(textEl);
    });
  };
  SliderTimelineView2.prototype._renderControl = function(layoutInfo, group, axis, timelineModel) {
    var controlSize = layoutInfo.controlSize;
    var rotation = layoutInfo.rotation;
    var itemStyle = timelineModel.getModel("controlStyle").getItemStyle();
    var hoverStyle = timelineModel.getModel(["emphasis", "controlStyle"]).getItemStyle();
    var playState = timelineModel.getPlayState();
    var inverse = timelineModel.get("inverse", true);
    makeBtn(layoutInfo.nextBtnPosition, "next", bind$1(this._changeTimeline, this, inverse ? "-" : "+"));
    makeBtn(layoutInfo.prevBtnPosition, "prev", bind$1(this._changeTimeline, this, inverse ? "+" : "-"));
    makeBtn(layoutInfo.playPosition, playState ? "stop" : "play", bind$1(this._handlePlayClick, this, !playState), true);
    function makeBtn(position2, iconName, onclick, willRotate) {
      if (!position2) {
        return;
      }
      var iconSize = parsePercent$1(retrieve2(timelineModel.get(["controlStyle", iconName + "BtnSize"]), controlSize), controlSize);
      var rect = [0, -iconSize / 2, iconSize, iconSize];
      var btn = makeControlIcon(timelineModel, iconName + "Icon", rect, {
        x: position2[0],
        y: position2[1],
        originX: controlSize / 2,
        originY: 0,
        rotation: willRotate ? -rotation : 0,
        rectHover: true,
        style: itemStyle,
        onclick
      });
      btn.ensureState("emphasis").style = hoverStyle;
      group.add(btn);
      enableHoverEmphasis(btn);
    }
  };
  SliderTimelineView2.prototype._renderCurrentPointer = function(layoutInfo, group, axis, timelineModel) {
    var data = timelineModel.getData();
    var currentIndex = timelineModel.getCurrentIndex();
    var pointerModel = data.getItemModel(currentIndex).getModel("checkpointStyle");
    var me = this;
    var callback = {
      onCreate: function(pointer) {
        pointer.draggable = true;
        pointer.drift = bind$1(me._handlePointerDrag, me);
        pointer.ondragend = bind$1(me._handlePointerDragend, me);
        pointerMoveTo(pointer, me._progressLine, currentIndex, axis, timelineModel, true);
      },
      onUpdate: function(pointer) {
        pointerMoveTo(pointer, me._progressLine, currentIndex, axis, timelineModel);
      }
    };
    this._currentPointer = giveSymbol(pointerModel, pointerModel, this._mainGroup, {}, this._currentPointer, callback);
  };
  SliderTimelineView2.prototype._handlePlayClick = function(nextState) {
    this._clearTimer();
    this.api.dispatchAction({
      type: "timelinePlayChange",
      playState: nextState,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._handlePointerDrag = function(dx, dy, e2) {
    this._clearTimer();
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY]);
  };
  SliderTimelineView2.prototype._handlePointerDragend = function(e2) {
    this._pointerChangeTimeline([e2.offsetX, e2.offsetY], true);
  };
  SliderTimelineView2.prototype._pointerChangeTimeline = function(mousePos, trigger2) {
    var toCoord = this._toAxisCoord(mousePos)[0];
    var axis = this._axis;
    var axisExtent = asc$2(axis.getExtent().slice());
    toCoord > axisExtent[1] && (toCoord = axisExtent[1]);
    toCoord < axisExtent[0] && (toCoord = axisExtent[0]);
    this._currentPointer.x = toCoord;
    this._currentPointer.markRedraw();
    this._progressLine.shape.x2 = toCoord;
    this._progressLine.dirty();
    var targetDataIndex = this._findNearestTick(toCoord);
    var timelineModel = this.model;
    if (trigger2 || targetDataIndex !== timelineModel.getCurrentIndex() && timelineModel.get("realtime")) {
      this._changeTimeline(targetDataIndex);
    }
  };
  SliderTimelineView2.prototype._doPlayStop = function() {
    var _this = this;
    this._clearTimer();
    if (this.model.getPlayState()) {
      this._timer = setTimeout(function() {
        var timelineModel = _this.model;
        _this._changeTimeline(timelineModel.getCurrentIndex() + (timelineModel.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval"));
    }
  };
  SliderTimelineView2.prototype._toAxisCoord = function(vertex) {
    var trans = this._mainGroup.getLocalTransform();
    return applyTransform(vertex, trans, true);
  };
  SliderTimelineView2.prototype._findNearestTick = function(axisCoord) {
    var data = this.model.getData();
    var dist2 = Infinity;
    var targetDataIndex;
    var axis = this._axis;
    data.each(["value"], function(value, dataIndex) {
      var coord = axis.dataToCoord(value);
      var d2 = Math.abs(coord - axisCoord);
      if (d2 < dist2) {
        dist2 = d2;
        targetDataIndex = dataIndex;
      }
    });
    return targetDataIndex;
  };
  SliderTimelineView2.prototype._clearTimer = function() {
    if (this._timer) {
      clearTimeout(this._timer);
      this._timer = null;
    }
  };
  SliderTimelineView2.prototype._changeTimeline = function(nextIndex) {
    var currentIndex = this.model.getCurrentIndex();
    if (nextIndex === "+") {
      nextIndex = currentIndex + 1;
    } else if (nextIndex === "-") {
      nextIndex = currentIndex - 1;
    }
    this.api.dispatchAction({
      type: "timelineChange",
      currentIndex: nextIndex,
      from: this.uid
    });
  };
  SliderTimelineView2.prototype._updateTicksStatus = function() {
    var currentIndex = this.model.getCurrentIndex();
    var tickSymbols = this._tickSymbols;
    var tickLabels = this._tickLabels;
    if (tickSymbols) {
      for (var i = 0; i < tickSymbols.length; i++) {
        tickSymbols && tickSymbols[i] && tickSymbols[i].toggleState("progress", i < currentIndex);
      }
    }
    if (tickLabels) {
      for (var i = 0; i < tickLabels.length; i++) {
        tickLabels && tickLabels[i] && tickLabels[i].toggleState("progress", labelDataIndexStore(tickLabels[i]).dataIndex <= currentIndex);
      }
    }
  };
  SliderTimelineView2.type = "timeline.slider";
  return SliderTimelineView2;
}(TimelineView$1);
function createScaleByModel(model, axisType) {
  axisType = axisType || model.get("type");
  if (axisType) {
    switch (axisType) {
      case "category":
        return new OrdinalScale$1({
          ordinalMeta: model.getCategories(),
          extent: [Infinity, -Infinity]
        });
      case "time":
        return new TimeScale$1({
          locale: model.ecModel.getLocaleModel(),
          useUTC: model.ecModel.get("useUTC")
        });
      default:
        return new IntervalScale$1();
    }
  }
}
function getViewRect(model, api) {
  return getLayoutRect(model.getBoxLayoutParams(), {
    width: api.getWidth(),
    height: api.getHeight()
  }, model.get("padding"));
}
function makeControlIcon(timelineModel, objPath, rect, opts) {
  var style = opts.style;
  var icon = createIcon(timelineModel.get(["controlStyle", objPath]), opts || {}, new BoundingRect$1(rect[0], rect[1], rect[2], rect[3]));
  if (style) {
    icon.setStyle(style);
  }
  return icon;
}
function giveSymbol(hostModel, itemStyleModel, group, opt, symbol, callback) {
  var color = itemStyleModel.get("color");
  if (!symbol) {
    var symbolType = hostModel.get("symbol");
    symbol = createSymbol$1(symbolType, -1, -1, 2, 2, color);
    symbol.setStyle("strokeNoScale", true);
    group.add(symbol);
    callback && callback.onCreate(symbol);
  } else {
    symbol.setColor(color);
    group.add(symbol);
    callback && callback.onUpdate(symbol);
  }
  var itemStyle = itemStyleModel.getItemStyle(["color"]);
  symbol.setStyle(itemStyle);
  opt = merge({
    rectHover: true,
    z2: 100
  }, opt, true);
  var symbolSize = normalizeSymbolSize(hostModel.get("symbolSize"));
  opt.scaleX = symbolSize[0] / 2;
  opt.scaleY = symbolSize[1] / 2;
  var symbolOffset = normalizeSymbolOffset(hostModel.get("symbolOffset"), symbolSize);
  if (symbolOffset) {
    opt.x = (opt.x || 0) + symbolOffset[0];
    opt.y = (opt.y || 0) + symbolOffset[1];
  }
  var symbolRotate = hostModel.get("symbolRotate");
  opt.rotation = (symbolRotate || 0) * Math.PI / 180 || 0;
  symbol.attr(opt);
  symbol.updateTransform();
  return symbol;
}
function pointerMoveTo(pointer, progressLine, dataIndex, axis, timelineModel, noAnimation) {
  if (pointer.dragging) {
    return;
  }
  var pointerModel = timelineModel.getModel("checkpointStyle");
  var toCoord = axis.dataToCoord(timelineModel.getData().get("value", dataIndex));
  if (noAnimation || !pointerModel.get("animation", true)) {
    pointer.attr({
      x: toCoord,
      y: 0
    });
    progressLine && progressLine.attr({
      shape: {
        x2: toCoord
      }
    });
  } else {
    var animationCfg = {
      duration: pointerModel.get("animationDuration", true),
      easing: pointerModel.get("animationEasing", true)
    };
    pointer.stopAnimation(null, true);
    pointer.animateTo({
      x: toCoord,
      y: 0
    }, animationCfg);
    progressLine && progressLine.animateTo({
      shape: {
        x2: toCoord
      }
    }, animationCfg);
  }
}
var SliderTimelineView$1 = SliderTimelineView;
function installTimelineAction(registers) {
  registers.registerAction({
    type: "timelineChange",
    event: "timelineChanged",
    update: "prepareAndUpdate"
  }, function(payload, ecModel, api) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.currentIndex != null) {
      timelineModel.setCurrentIndex(payload.currentIndex);
      if (!timelineModel.get("loop", true) && timelineModel.isIndexMax() && timelineModel.getPlayState()) {
        timelineModel.setPlayState(false);
        api.dispatchAction({
          type: "timelinePlayChange",
          playState: false,
          from: payload.from
        });
      }
    }
    ecModel.resetOption("timeline", {
      replaceMerge: timelineModel.get("replaceMerge", true)
    });
    return defaults({
      currentIndex: timelineModel.option.currentIndex
    }, payload);
  });
  registers.registerAction({
    type: "timelinePlayChange",
    event: "timelinePlayChanged",
    update: "update"
  }, function(payload, ecModel) {
    var timelineModel = ecModel.getComponent("timeline");
    if (timelineModel && payload.playState != null) {
      timelineModel.setPlayState(payload.playState);
    }
  });
}
function timelinePreprocessor(option) {
  var timelineOpt = option && option.timeline;
  if (!isArray$1(timelineOpt)) {
    timelineOpt = timelineOpt ? [timelineOpt] : [];
  }
  each$f(timelineOpt, function(opt) {
    if (!opt) {
      return;
    }
    compatibleEC2(opt);
  });
}
function compatibleEC2(opt) {
  var type4 = opt.type;
  var ec2Types = {
    "number": "value",
    "time": "time"
  };
  if (ec2Types[type4]) {
    opt.axisType = ec2Types[type4];
    delete opt.type;
  }
  transferItem(opt);
  if (has$1(opt, "controlPosition")) {
    var controlStyle = opt.controlStyle || (opt.controlStyle = {});
    if (!has$1(controlStyle, "position")) {
      controlStyle.position = opt.controlPosition;
    }
    if (controlStyle.position === "none" && !has$1(controlStyle, "show")) {
      controlStyle.show = false;
      delete controlStyle.position;
    }
    delete opt.controlPosition;
  }
  each$f(opt.data || [], function(dataItem) {
    if (isObject$4(dataItem) && !isArray$1(dataItem)) {
      if (!has$1(dataItem, "value") && has$1(dataItem, "name")) {
        dataItem.value = dataItem.name;
      }
      transferItem(dataItem);
    }
  });
}
function transferItem(opt) {
  var itemStyle = opt.itemStyle || (opt.itemStyle = {});
  var itemStyleEmphasis = itemStyle.emphasis || (itemStyle.emphasis = {});
  var label = opt.label || opt.label || {};
  var labelNormal = label.normal || (label.normal = {});
  var excludeLabelAttr = {
    normal: 1,
    emphasis: 1
  };
  each$f(label, function(value, name) {
    if (!excludeLabelAttr[name] && !has$1(labelNormal, name)) {
      labelNormal[name] = value;
    }
  });
  if (itemStyleEmphasis.label && !has$1(label, "emphasis")) {
    label.emphasis = itemStyleEmphasis.label;
    delete itemStyleEmphasis.label;
  }
}
function has$1(obj, attr) {
  return obj.hasOwnProperty(attr);
}
function install$f(registers) {
  registers.registerComponentModel(SliderTimelineModel$1);
  registers.registerComponentView(SliderTimelineView$1);
  registers.registerSubTypeDefaulter("timeline", function() {
    return "slider";
  });
  installTimelineAction(registers);
  registers.registerPreprocessor(timelinePreprocessor);
}
function checkMarkerInSeries(seriesOpts, markerType) {
  if (!seriesOpts) {
    return false;
  }
  var seriesOptArr = isArray$1(seriesOpts) ? seriesOpts : [seriesOpts];
  for (var idx = 0; idx < seriesOptArr.length; idx++) {
    if (seriesOptArr[idx] && seriesOptArr[idx][markerType]) {
      return true;
    }
  }
  return false;
}
function fillLabel(opt) {
  defaultEmphasis(opt, "label", ["show"]);
}
var inner$5 = makeInner();
var MarkerModel = function(_super) {
  __extends(MarkerModel2, _super);
  function MarkerModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerModel2.type;
    _this.createdBySelf = false;
    return _this;
  }
  MarkerModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    this._mergeOption(option, ecModel, false, true);
  };
  MarkerModel2.prototype.isAnimationEnabled = function() {
    if (env$1.node) {
      return false;
    }
    var hostSeries = this.__hostSeries;
    return this.getShallow("animation") && hostSeries && hostSeries.isAnimationEnabled();
  };
  MarkerModel2.prototype.mergeOption = function(newOpt, ecModel) {
    this._mergeOption(newOpt, ecModel, false, false);
  };
  MarkerModel2.prototype._mergeOption = function(newOpt, ecModel, createdBySelf, isInit) {
    var componentType = this.mainType;
    if (!createdBySelf) {
      ecModel.eachSeries(function(seriesModel) {
        var markerOpt = seriesModel.get(this.mainType, true);
        var markerModel = inner$5(seriesModel)[componentType];
        if (!markerOpt || !markerOpt.data) {
          inner$5(seriesModel)[componentType] = null;
          return;
        }
        if (!markerModel) {
          if (isInit) {
            fillLabel(markerOpt);
          }
          each$f(markerOpt.data, function(item) {
            if (item instanceof Array) {
              fillLabel(item[0]);
              fillLabel(item[1]);
            } else {
              fillLabel(item);
            }
          });
          markerModel = this.createMarkerModelFromSeries(markerOpt, this, ecModel);
          extend(markerModel, {
            mainType: this.mainType,
            seriesIndex: seriesModel.seriesIndex,
            name: seriesModel.name,
            createdBySelf: true
          });
          markerModel.__hostSeries = seriesModel;
        } else {
          markerModel._mergeOption(markerOpt, ecModel, true);
        }
        inner$5(seriesModel)[componentType] = markerModel;
      }, this);
    }
  };
  MarkerModel2.prototype.formatTooltip = function(dataIndex, multipleSeries, dataType) {
    var data = this.getData();
    var value = this.getRawValue(dataIndex);
    var itemName = data.getName(dataIndex);
    return createTooltipMarkup("section", {
      header: this.name,
      blocks: [createTooltipMarkup("nameValue", {
        name: itemName,
        value,
        noName: !itemName,
        noValue: value == null
      })]
    });
  };
  MarkerModel2.prototype.getData = function() {
    return this._data;
  };
  MarkerModel2.prototype.setData = function(data) {
    this._data = data;
  };
  MarkerModel2.getMarkerModelFromSeries = function(seriesModel, componentType) {
    return inner$5(seriesModel)[componentType];
  };
  MarkerModel2.type = "marker";
  MarkerModel2.dependencies = ["series", "grid", "polar", "geo"];
  return MarkerModel2;
}(ComponentModel$1);
mixin(MarkerModel, DataFormatMixin.prototype);
var MarkerModel$1 = MarkerModel;
var MarkPointModel = function(_super) {
  __extends(MarkPointModel2, _super);
  function MarkPointModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointModel2.type;
    return _this;
  }
  MarkPointModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkPointModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkPointModel2.type = "markPoint";
  MarkPointModel2.defaultOption = {
    z: 5,
    symbol: "pin",
    symbolSize: 50,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "inside"
    },
    itemStyle: {
      borderWidth: 2
    },
    emphasis: {
      label: {
        show: true
      }
    }
  };
  return MarkPointModel2;
}(MarkerModel$1);
var MarkPointModel$1 = MarkPointModel;
function hasXOrY(item) {
  return !(isNaN(parseFloat(item.x)) && isNaN(parseFloat(item.y)));
}
function hasXAndY(item) {
  return !isNaN(parseFloat(item.x)) && !isNaN(parseFloat(item.y));
}
function markerTypeCalculatorWithExtent(markerType, data, otherDataDim, targetDataDim, otherCoordIndex, targetCoordIndex) {
  var coordArr = [];
  var stacked = isDimensionStacked(data, targetDataDim);
  var calcDataDim = stacked ? data.getCalculationInfo("stackResultDimension") : targetDataDim;
  var value = numCalculate(data, calcDataDim, markerType);
  var dataIndex = data.indicesOfNearest(calcDataDim, value)[0];
  coordArr[otherCoordIndex] = data.get(otherDataDim, dataIndex);
  coordArr[targetCoordIndex] = data.get(calcDataDim, dataIndex);
  var coordArrValue = data.get(targetDataDim, dataIndex);
  var precision = getPrecision(data.get(targetDataDim, dataIndex));
  precision = Math.min(precision, 20);
  if (precision >= 0) {
    coordArr[targetCoordIndex] = +coordArr[targetCoordIndex].toFixed(precision);
  }
  return [coordArr, coordArrValue];
}
var markerTypeCalculator = {
  min: curry$1(markerTypeCalculatorWithExtent, "min"),
  max: curry$1(markerTypeCalculatorWithExtent, "max"),
  average: curry$1(markerTypeCalculatorWithExtent, "average"),
  median: curry$1(markerTypeCalculatorWithExtent, "median")
};
function dataTransform(seriesModel, item) {
  var data = seriesModel.getData();
  var coordSys = seriesModel.coordinateSystem;
  if (item && !hasXAndY(item) && !isArray$1(item.coord) && coordSys) {
    var dims = coordSys.dimensions;
    var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
    item = clone$4(item);
    if (item.type && markerTypeCalculator[item.type] && axisInfo.baseAxis && axisInfo.valueAxis) {
      var otherCoordIndex = indexOf(dims, axisInfo.baseAxis.dim);
      var targetCoordIndex = indexOf(dims, axisInfo.valueAxis.dim);
      var coordInfo = markerTypeCalculator[item.type](data, axisInfo.baseDataDim, axisInfo.valueDataDim, otherCoordIndex, targetCoordIndex);
      item.coord = coordInfo[0];
      item.value = coordInfo[1];
    } else {
      var coord = [item.xAxis != null ? item.xAxis : item.radiusAxis, item.yAxis != null ? item.yAxis : item.angleAxis];
      for (var i = 0; i < 2; i++) {
        if (markerTypeCalculator[coord[i]]) {
          coord[i] = numCalculate(data, data.mapDimension(dims[i]), coord[i]);
        }
      }
      item.coord = coord;
    }
  }
  return item;
}
function getAxisInfo(item, data, coordSys, seriesModel) {
  var ret = {};
  if (item.valueIndex != null || item.valueDim != null) {
    ret.valueDataDim = item.valueIndex != null ? data.getDimension(item.valueIndex) : item.valueDim;
    ret.valueAxis = coordSys.getAxis(dataDimToCoordDim(seriesModel, ret.valueDataDim));
    ret.baseAxis = coordSys.getOtherAxis(ret.valueAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
  } else {
    ret.baseAxis = seriesModel.getBaseAxis();
    ret.valueAxis = coordSys.getOtherAxis(ret.baseAxis);
    ret.baseDataDim = data.mapDimension(ret.baseAxis.dim);
    ret.valueDataDim = data.mapDimension(ret.valueAxis.dim);
  }
  return ret;
}
function dataDimToCoordDim(seriesModel, dataDim) {
  var dimItem = seriesModel.getData().getDimensionInfo(dataDim);
  return dimItem && dimItem.coordDim;
}
function dataFilter(coordSys, item) {
  return coordSys && coordSys.containData && item.coord && !hasXOrY(item) ? coordSys.containData(item.coord) : true;
}
function createMarkerDimValueGetter(inCoordSys, dims) {
  return inCoordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = dimIndex < 2 ? item.coord && item.coord[dimIndex] : item.value;
    return parseDataValue(rawVal, dims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dims[dimIndex]);
  };
}
function numCalculate(data, valueDataDim, type4) {
  if (type4 === "average") {
    var sum_1 = 0;
    var count_1 = 0;
    data.each(valueDataDim, function(val, idx) {
      if (!isNaN(val)) {
        sum_1 += val;
        count_1++;
      }
    });
    return sum_1 / count_1;
  } else if (type4 === "median") {
    return data.getMedian(valueDataDim);
  } else {
    return data.getDataExtent(valueDataDim)[type4 === "max" ? 1 : 0];
  }
}
var inner$4 = makeInner();
var MarkerView = function(_super) {
  __extends(MarkerView2, _super);
  function MarkerView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkerView2.type;
    return _this;
  }
  MarkerView2.prototype.init = function() {
    this.markerGroupMap = createHashMap();
  };
  MarkerView2.prototype.render = function(markerModel, ecModel, api) {
    var _this = this;
    var markerGroupMap = this.markerGroupMap;
    markerGroupMap.each(function(item) {
      inner$4(item).keep = false;
    });
    ecModel.eachSeries(function(seriesModel) {
      var markerModel2 = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      markerModel2 && _this.renderSeries(seriesModel, markerModel2, ecModel, api);
    });
    markerGroupMap.each(function(item) {
      !inner$4(item).keep && _this.group.remove(item.group);
    });
  };
  MarkerView2.prototype.markKeep = function(drawGroup) {
    inner$4(drawGroup).keep = true;
  };
  MarkerView2.prototype.blurSeries = function(seriesModelList) {
    var _this = this;
    each$f(seriesModelList, function(seriesModel) {
      var markerModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, _this.type);
      if (markerModel) {
        var data = markerModel.getData();
        data.eachItemGraphicEl(function(el) {
          if (el) {
            enterBlur(el);
          }
        });
      }
    });
  };
  MarkerView2.type = "marker";
  return MarkerView2;
}(ComponentView$1);
var MarkerView$1 = MarkerView;
function updateMarkerLayout(mpData, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  mpData.each(function(idx) {
    var itemModel = mpData.getItemModel(idx);
    var point;
    var xPx = parsePercent(itemModel.get("x"), api.getWidth());
    var yPx = parsePercent(itemModel.get("y"), api.getHeight());
    if (!isNaN(xPx) && !isNaN(yPx)) {
      point = [xPx, yPx];
    } else if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(mpData.getValues(mpData.dimensions, idx));
    } else if (coordSys) {
      var x2 = mpData.get(coordSys.dimensions[0], idx);
      var y2 = mpData.get(coordSys.dimensions[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
    mpData.setItemLayout(idx, point);
  });
}
var MarkPointView = function(_super) {
  __extends(MarkPointView2, _super);
  function MarkPointView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkPointView2.type;
    return _this;
  }
  MarkPointView2.prototype.updateTransform = function(markPointModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mpModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markPoint");
      if (mpModel) {
        updateMarkerLayout(mpModel.getData(), seriesModel, api);
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkPointView2.prototype.renderSeries = function(seriesModel, mpModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var symbolDrawMap = this.markerGroupMap;
    var symbolDraw = symbolDrawMap.get(seriesId) || symbolDrawMap.set(seriesId, new SymbolDraw$1());
    var mpData = createData(coordSys, seriesModel, mpModel);
    mpModel.setData(mpData);
    updateMarkerLayout(mpModel.getData(), seriesModel, api);
    mpData.each(function(idx) {
      var itemModel = mpData.getItemModel(idx);
      var symbol = itemModel.getShallow("symbol");
      var symbolSize = itemModel.getShallow("symbolSize");
      var symbolRotate = itemModel.getShallow("symbolRotate");
      var symbolOffset = itemModel.getShallow("symbolOffset");
      var symbolKeepAspect = itemModel.getShallow("symbolKeepAspect");
      if (isFunction(symbol) || isFunction(symbolSize) || isFunction(symbolRotate) || isFunction(symbolOffset)) {
        var rawIdx = mpModel.getRawValue(idx);
        var dataParams = mpModel.getDataParams(idx);
        if (isFunction(symbol)) {
          symbol = symbol(rawIdx, dataParams);
        }
        if (isFunction(symbolSize)) {
          symbolSize = symbolSize(rawIdx, dataParams);
        }
        if (isFunction(symbolRotate)) {
          symbolRotate = symbolRotate(rawIdx, dataParams);
        }
        if (isFunction(symbolOffset)) {
          symbolOffset = symbolOffset(rawIdx, dataParams);
        }
      }
      var style = itemModel.getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style.fill) {
        style.fill = color;
      }
      mpData.setItemVisual(idx, {
        symbol,
        symbolSize,
        symbolRotate,
        symbolOffset,
        symbolKeepAspect,
        style
      });
    });
    symbolDraw.updateData(mpData);
    this.group.add(symbolDraw.group);
    mpData.eachItemGraphicEl(function(el) {
      el.traverse(function(child) {
        getECData(child).dataModel = mpModel;
      });
    });
    this.markKeep(symbolDraw);
    symbolDraw.group.silent = mpModel.get("silent") || seriesModel.get("silent");
  };
  MarkPointView2.type = "markPoint";
  return MarkPointView2;
}(MarkerView$1);
function createData(coordSys, seriesModel, mpModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var mpData = new SeriesData$1(coordDimsInfos, mpModel);
  var dataOpt = map$1(mpModel.get("data"), curry$1(dataTransform, seriesModel));
  if (coordSys) {
    dataOpt = filter(dataOpt, curry$1(dataFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  mpData.initData(dataOpt, null, dimValueGetter);
  return mpData;
}
var MarkPointView$1 = MarkPointView;
function install$e(registers) {
  registers.registerComponentModel(MarkPointModel$1);
  registers.registerComponentView(MarkPointView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markPoint")) {
      opt.markPoint = opt.markPoint || {};
    }
  });
}
var MarkLineModel = function(_super) {
  __extends(MarkLineModel2, _super);
  function MarkLineModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineModel2.type;
    return _this;
  }
  MarkLineModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkLineModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkLineModel2.type = "markLine";
  MarkLineModel2.defaultOption = {
    z: 5,
    symbol: ["circle", "arrow"],
    symbolSize: [8, 16],
    symbolOffset: 0,
    precision: 2,
    tooltip: {
      trigger: "item"
    },
    label: {
      show: true,
      position: "end",
      distance: 5
    },
    lineStyle: {
      type: "dashed"
    },
    emphasis: {
      label: {
        show: true
      },
      lineStyle: {
        width: 3
      }
    },
    animationEasing: "linear"
  };
  return MarkLineModel2;
}(MarkerModel$1);
var MarkLineModel$1 = MarkLineModel;
var inner$3 = makeInner();
var markLineTransform = function(seriesModel, coordSys, mlModel, item) {
  var data = seriesModel.getData();
  var itemArray;
  if (!isArray$1(item)) {
    var mlType = item.type;
    if (mlType === "min" || mlType === "max" || mlType === "average" || mlType === "median" || item.xAxis != null || item.yAxis != null) {
      var valueAxis2 = void 0;
      var value = void 0;
      if (item.yAxis != null || item.xAxis != null) {
        valueAxis2 = coordSys.getAxis(item.yAxis != null ? "y" : "x");
        value = retrieve(item.yAxis, item.xAxis);
      } else {
        var axisInfo = getAxisInfo(item, data, coordSys, seriesModel);
        valueAxis2 = axisInfo.valueAxis;
        var valueDataDim = getStackedDimension(data, axisInfo.valueDataDim);
        value = numCalculate(data, valueDataDim, mlType);
      }
      var valueIndex = valueAxis2.dim === "x" ? 0 : 1;
      var baseIndex = 1 - valueIndex;
      var mlFrom = clone$4(item);
      var mlTo = {
        coord: []
      };
      mlFrom.type = null;
      mlFrom.coord = [];
      mlFrom.coord[baseIndex] = -Infinity;
      mlTo.coord[baseIndex] = Infinity;
      var precision = mlModel.get("precision");
      if (precision >= 0 && isNumber(value)) {
        value = +value.toFixed(Math.min(precision, 20));
      }
      mlFrom.coord[valueIndex] = mlTo.coord[valueIndex] = value;
      itemArray = [mlFrom, mlTo, {
        type: mlType,
        valueIndex: item.valueIndex,
        value
      }];
    } else {
      itemArray = [];
    }
  } else {
    itemArray = item;
  }
  var normalizedItem = [dataTransform(seriesModel, itemArray[0]), dataTransform(seriesModel, itemArray[1]), extend({}, itemArray[2])];
  normalizedItem[2].type = normalizedItem[2].type || null;
  merge(normalizedItem[2], normalizedItem[0]);
  merge(normalizedItem[2], normalizedItem[1]);
  return normalizedItem;
};
function isInifinity$1(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkLineHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  var dimName = coordSys.dimensions[dimIndex];
  return isInifinity$1(fromCoord[otherDimIndex]) && isInifinity$1(toCoord[otherDimIndex]) && fromCoord[dimIndex] === toCoord[dimIndex] && coordSys.getAxis(dimName).containData(fromCoord[dimIndex]);
}
function markLineFilter(coordSys, item) {
  if (coordSys.type === "cartesian2d") {
    var fromCoord = item[0].coord;
    var toCoord = item[1].coord;
    if (fromCoord && toCoord && (ifMarkLineHasOnlyDim(1, fromCoord, toCoord, coordSys) || ifMarkLineHasOnlyDim(0, fromCoord, toCoord, coordSys))) {
      return true;
    }
  }
  return dataFilter(coordSys, item[0]) && dataFilter(coordSys, item[1]);
}
function updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get("x"), api.getWidth());
  var yPx = parsePercent(itemModel.get("y"), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(data.dimensions, idx));
    } else {
      var dims = coordSys.dimensions;
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      point = coordSys.dataToPoint([x2, y2]);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var dims = coordSys.dimensions;
      if (isInifinity$1(data.get(dims[0], idx))) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[isFrom ? 0 : 1]);
      } else if (isInifinity$1(data.get(dims[1], idx))) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[isFrom ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  data.setItemLayout(idx, point);
}
var MarkLineView = function(_super) {
  __extends(MarkLineView2, _super);
  function MarkLineView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkLineView2.type;
    return _this;
  }
  MarkLineView2.prototype.updateTransform = function(markLineModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var mlModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markLine");
      if (mlModel) {
        var mlData_1 = mlModel.getData();
        var fromData_1 = inner$3(mlModel).from;
        var toData_1 = inner$3(mlModel).to;
        fromData_1.each(function(idx) {
          updateSingleMarkerEndLayout(fromData_1, idx, true, seriesModel, api);
          updateSingleMarkerEndLayout(toData_1, idx, false, seriesModel, api);
        });
        mlData_1.each(function(idx) {
          mlData_1.setItemLayout(idx, [fromData_1.getItemLayout(idx), toData_1.getItemLayout(idx)]);
        });
        this.markerGroupMap.get(seriesModel.id).updateLayout();
      }
    }, this);
  };
  MarkLineView2.prototype.renderSeries = function(seriesModel, mlModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var lineDrawMap = this.markerGroupMap;
    var lineDraw = lineDrawMap.get(seriesId) || lineDrawMap.set(seriesId, new LineDraw$1());
    this.group.add(lineDraw.group);
    var mlData = createList$1(coordSys, seriesModel, mlModel);
    var fromData = mlData.from;
    var toData = mlData.to;
    var lineData = mlData.line;
    inner$3(mlModel).from = fromData;
    inner$3(mlModel).to = toData;
    mlModel.setData(lineData);
    var symbolType = mlModel.get("symbol");
    var symbolSize = mlModel.get("symbolSize");
    var symbolRotate = mlModel.get("symbolRotate");
    var symbolOffset = mlModel.get("symbolOffset");
    if (!isArray$1(symbolType)) {
      symbolType = [symbolType, symbolType];
    }
    if (!isArray$1(symbolSize)) {
      symbolSize = [symbolSize, symbolSize];
    }
    if (!isArray$1(symbolRotate)) {
      symbolRotate = [symbolRotate, symbolRotate];
    }
    if (!isArray$1(symbolOffset)) {
      symbolOffset = [symbolOffset, symbolOffset];
    }
    mlData.from.each(function(idx) {
      updateDataVisualAndLayout(fromData, idx, true);
      updateDataVisualAndLayout(toData, idx, false);
    });
    lineData.each(function(idx) {
      var lineStyle = lineData.getItemModel(idx).getModel("lineStyle").getLineStyle();
      lineData.setItemLayout(idx, [fromData.getItemLayout(idx), toData.getItemLayout(idx)]);
      if (lineStyle.stroke == null) {
        lineStyle.stroke = fromData.getItemVisual(idx, "style").fill;
      }
      lineData.setItemVisual(idx, {
        fromSymbolKeepAspect: fromData.getItemVisual(idx, "symbolKeepAspect"),
        fromSymbolOffset: fromData.getItemVisual(idx, "symbolOffset"),
        fromSymbolRotate: fromData.getItemVisual(idx, "symbolRotate"),
        fromSymbolSize: fromData.getItemVisual(idx, "symbolSize"),
        fromSymbol: fromData.getItemVisual(idx, "symbol"),
        toSymbolKeepAspect: toData.getItemVisual(idx, "symbolKeepAspect"),
        toSymbolOffset: toData.getItemVisual(idx, "symbolOffset"),
        toSymbolRotate: toData.getItemVisual(idx, "symbolRotate"),
        toSymbolSize: toData.getItemVisual(idx, "symbolSize"),
        toSymbol: toData.getItemVisual(idx, "symbol"),
        style: lineStyle
      });
    });
    lineDraw.updateData(lineData);
    mlData.line.eachItemGraphicEl(function(el, idx) {
      el.traverse(function(child) {
        getECData(child).dataModel = mlModel;
      });
    });
    function updateDataVisualAndLayout(data, idx, isFrom) {
      var itemModel = data.getItemModel(idx);
      updateSingleMarkerEndLayout(data, idx, isFrom, seriesModel, api);
      var style = itemModel.getModel("itemStyle").getItemStyle();
      if (style.fill == null) {
        style.fill = getVisualFromData(seriesData, "color");
      }
      data.setItemVisual(idx, {
        symbolKeepAspect: itemModel.get("symbolKeepAspect"),
        symbolOffset: retrieve2(itemModel.get("symbolOffset", true), symbolOffset[isFrom ? 0 : 1]),
        symbolRotate: retrieve2(itemModel.get("symbolRotate", true), symbolRotate[isFrom ? 0 : 1]),
        symbolSize: retrieve2(itemModel.get("symbolSize"), symbolSize[isFrom ? 0 : 1]),
        symbol: retrieve2(itemModel.get("symbol", true), symbolType[isFrom ? 0 : 1]),
        style
      });
    }
    this.markKeep(lineDraw);
    lineDraw.group.silent = mlModel.get("silent") || seriesModel.get("silent");
  };
  MarkLineView2.type = "markLine";
  return MarkLineView2;
}(MarkerView$1);
function createList$1(coordSys, seriesModel, mlModel) {
  var coordDimsInfos;
  if (coordSys) {
    coordDimsInfos = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var info = seriesModel.getData().getDimensionInfo(seriesModel.getData().mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
  } else {
    coordDimsInfos = [{
      name: "value",
      type: "float"
    }];
  }
  var fromData = new SeriesData$1(coordDimsInfos, mlModel);
  var toData = new SeriesData$1(coordDimsInfos, mlModel);
  var lineData = new SeriesData$1([], mlModel);
  var optData = map$1(mlModel.get("data"), curry$1(markLineTransform, seriesModel, coordSys, mlModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markLineFilter, coordSys));
  }
  var dimValueGetter = createMarkerDimValueGetter(!!coordSys, coordDimsInfos);
  fromData.initData(map$1(optData, function(item) {
    return item[0];
  }), null, dimValueGetter);
  toData.initData(map$1(optData, function(item) {
    return item[1];
  }), null, dimValueGetter);
  lineData.initData(map$1(optData, function(item) {
    return item[2];
  }));
  lineData.hasItemOption = true;
  return {
    from: fromData,
    to: toData,
    line: lineData
  };
}
var MarkLineView$1 = MarkLineView;
function install$d(registers) {
  registers.registerComponentModel(MarkLineModel$1);
  registers.registerComponentView(MarkLineView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markLine")) {
      opt.markLine = opt.markLine || {};
    }
  });
}
var MarkAreaModel = function(_super) {
  __extends(MarkAreaModel2, _super);
  function MarkAreaModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaModel2.type;
    return _this;
  }
  MarkAreaModel2.prototype.createMarkerModelFromSeries = function(markerOpt, masterMarkerModel, ecModel) {
    return new MarkAreaModel2(markerOpt, masterMarkerModel, ecModel);
  };
  MarkAreaModel2.type = "markArea";
  MarkAreaModel2.defaultOption = {
    z: 1,
    tooltip: {
      trigger: "item"
    },
    animation: false,
    label: {
      show: true,
      position: "top"
    },
    itemStyle: {
      borderWidth: 0
    },
    emphasis: {
      label: {
        show: true,
        position: "top"
      }
    }
  };
  return MarkAreaModel2;
}(MarkerModel$1);
var MarkAreaModel$1 = MarkAreaModel;
var inner$2 = makeInner();
var markAreaTransform = function(seriesModel, coordSys, maModel, item) {
  var lt2 = dataTransform(seriesModel, item[0]);
  var rb2 = dataTransform(seriesModel, item[1]);
  var ltCoord = lt2.coord;
  var rbCoord = rb2.coord;
  ltCoord[0] = retrieve(ltCoord[0], -Infinity);
  ltCoord[1] = retrieve(ltCoord[1], -Infinity);
  rbCoord[0] = retrieve(rbCoord[0], Infinity);
  rbCoord[1] = retrieve(rbCoord[1], Infinity);
  var result = mergeAll([{}, lt2, rb2]);
  result.coord = [lt2.coord, rb2.coord];
  result.x0 = lt2.x;
  result.y0 = lt2.y;
  result.x1 = rb2.x;
  result.y1 = rb2.y;
  return result;
};
function isInifinity(val) {
  return !isNaN(val) && !isFinite(val);
}
function ifMarkAreaHasOnlyDim(dimIndex, fromCoord, toCoord, coordSys) {
  var otherDimIndex = 1 - dimIndex;
  return isInifinity(fromCoord[otherDimIndex]) && isInifinity(toCoord[otherDimIndex]);
}
function markAreaFilter(coordSys, item) {
  var fromCoord = item.coord[0];
  var toCoord = item.coord[1];
  if (isCoordinateSystemType(coordSys, "cartesian2d")) {
    if (fromCoord && toCoord && (ifMarkAreaHasOnlyDim(1, fromCoord, toCoord) || ifMarkAreaHasOnlyDim(0, fromCoord, toCoord))) {
      return true;
    }
  }
  return dataFilter(coordSys, {
    coord: fromCoord,
    x: item.x0,
    y: item.y0
  }) || dataFilter(coordSys, {
    coord: toCoord,
    x: item.x1,
    y: item.y1
  });
}
function getSingleMarkerEndPoint(data, idx, dims, seriesModel, api) {
  var coordSys = seriesModel.coordinateSystem;
  var itemModel = data.getItemModel(idx);
  var point;
  var xPx = parsePercent(itemModel.get(dims[0]), api.getWidth());
  var yPx = parsePercent(itemModel.get(dims[1]), api.getHeight());
  if (!isNaN(xPx) && !isNaN(yPx)) {
    point = [xPx, yPx];
  } else {
    if (seriesModel.getMarkerPosition) {
      point = seriesModel.getMarkerPosition(data.getValues(dims, idx));
    } else {
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      var pt = [x2, y2];
      coordSys.clampData && coordSys.clampData(pt, pt);
      point = coordSys.dataToPoint(pt, true);
    }
    if (isCoordinateSystemType(coordSys, "cartesian2d")) {
      var xAxis = coordSys.getAxis("x");
      var yAxis = coordSys.getAxis("y");
      var x2 = data.get(dims[0], idx);
      var y2 = data.get(dims[1], idx);
      if (isInifinity(x2)) {
        point[0] = xAxis.toGlobalCoord(xAxis.getExtent()[dims[0] === "x0" ? 0 : 1]);
      } else if (isInifinity(y2)) {
        point[1] = yAxis.toGlobalCoord(yAxis.getExtent()[dims[1] === "y0" ? 0 : 1]);
      }
    }
    if (!isNaN(xPx)) {
      point[0] = xPx;
    }
    if (!isNaN(yPx)) {
      point[1] = yPx;
    }
  }
  return point;
}
var dimPermutations = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]];
var MarkAreaView = function(_super) {
  __extends(MarkAreaView2, _super);
  function MarkAreaView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = MarkAreaView2.type;
    return _this;
  }
  MarkAreaView2.prototype.updateTransform = function(markAreaModel, ecModel, api) {
    ecModel.eachSeries(function(seriesModel) {
      var maModel = MarkerModel$1.getMarkerModelFromSeries(seriesModel, "markArea");
      if (maModel) {
        var areaData_1 = maModel.getData();
        areaData_1.each(function(idx) {
          var points2 = map$1(dimPermutations, function(dim) {
            return getSingleMarkerEndPoint(areaData_1, idx, dim, seriesModel, api);
          });
          areaData_1.setItemLayout(idx, points2);
          var el = areaData_1.getItemGraphicEl(idx);
          el.setShape("points", points2);
        });
      }
    }, this);
  };
  MarkAreaView2.prototype.renderSeries = function(seriesModel, maModel, ecModel, api) {
    var coordSys = seriesModel.coordinateSystem;
    var seriesId = seriesModel.id;
    var seriesData = seriesModel.getData();
    var areaGroupMap = this.markerGroupMap;
    var polygonGroup = areaGroupMap.get(seriesId) || areaGroupMap.set(seriesId, {
      group: new Group$4()
    });
    this.group.add(polygonGroup.group);
    this.markKeep(polygonGroup);
    var areaData = createList(coordSys, seriesModel, maModel);
    maModel.setData(areaData);
    areaData.each(function(idx) {
      var points2 = map$1(dimPermutations, function(dim) {
        return getSingleMarkerEndPoint(areaData, idx, dim, seriesModel, api);
      });
      var xAxisScale = coordSys.getAxis("x").scale;
      var yAxisScale = coordSys.getAxis("y").scale;
      var xAxisExtent = xAxisScale.getExtent();
      var yAxisExtent = yAxisScale.getExtent();
      var xPointExtent = [xAxisScale.parse(areaData.get("x0", idx)), xAxisScale.parse(areaData.get("x1", idx))];
      var yPointExtent = [yAxisScale.parse(areaData.get("y0", idx)), yAxisScale.parse(areaData.get("y1", idx))];
      asc$2(xPointExtent);
      asc$2(yPointExtent);
      var overlapped = !(xAxisExtent[0] > xPointExtent[1] || xAxisExtent[1] < xPointExtent[0] || yAxisExtent[0] > yPointExtent[1] || yAxisExtent[1] < yPointExtent[0]);
      var allClipped = !overlapped;
      areaData.setItemLayout(idx, {
        points: points2,
        allClipped
      });
      var style = areaData.getItemModel(idx).getModel("itemStyle").getItemStyle();
      var color = getVisualFromData(seriesData, "color");
      if (!style.fill) {
        style.fill = color;
        if (isString(style.fill)) {
          style.fill = modifyAlpha(style.fill, 0.4);
        }
      }
      if (!style.stroke) {
        style.stroke = color;
      }
      areaData.setItemVisual(idx, "style", style);
    });
    areaData.diff(inner$2(polygonGroup).data).add(function(idx) {
      var layout2 = areaData.getItemLayout(idx);
      if (!layout2.allClipped) {
        var polygon = new Polygon$1({
          shape: {
            points: layout2.points
          }
        });
        areaData.setItemGraphicEl(idx, polygon);
        polygonGroup.group.add(polygon);
      }
    }).update(function(newIdx, oldIdx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(oldIdx);
      var layout2 = areaData.getItemLayout(newIdx);
      if (!layout2.allClipped) {
        if (polygon) {
          updateProps$1(polygon, {
            shape: {
              points: layout2.points
            }
          }, maModel, newIdx);
        } else {
          polygon = new Polygon$1({
            shape: {
              points: layout2.points
            }
          });
        }
        areaData.setItemGraphicEl(newIdx, polygon);
        polygonGroup.group.add(polygon);
      } else if (polygon) {
        polygonGroup.group.remove(polygon);
      }
    }).remove(function(idx) {
      var polygon = inner$2(polygonGroup).data.getItemGraphicEl(idx);
      polygonGroup.group.remove(polygon);
    }).execute();
    areaData.eachItemGraphicEl(function(polygon, idx) {
      var itemModel = areaData.getItemModel(idx);
      var style = areaData.getItemVisual(idx, "style");
      polygon.useStyle(areaData.getItemVisual(idx, "style"));
      setLabelStyle(polygon, getLabelStatesModels(itemModel), {
        labelFetcher: maModel,
        labelDataIndex: idx,
        defaultText: areaData.getName(idx) || "",
        inheritColor: isString(style.fill) ? modifyAlpha(style.fill, 1) : "#000"
      });
      setStatesStylesFromModel(polygon, itemModel);
      toggleHoverEmphasis(polygon, null, null, itemModel.get(["emphasis", "disabled"]));
      getECData(polygon).dataModel = maModel;
    });
    inner$2(polygonGroup).data = areaData;
    polygonGroup.group.silent = maModel.get("silent") || seriesModel.get("silent");
  };
  MarkAreaView2.type = "markArea";
  return MarkAreaView2;
}(MarkerView$1);
function createList(coordSys, seriesModel, maModel) {
  var areaData;
  var dataDims;
  var dims = ["x0", "y0", "x1", "y1"];
  if (coordSys) {
    var coordDimsInfos_1 = map$1(coordSys && coordSys.dimensions, function(coordDim) {
      var data = seriesModel.getData();
      var info = data.getDimensionInfo(data.mapDimension(coordDim)) || {};
      return extend(extend({}, info), {
        name: coordDim,
        ordinalMeta: null
      });
    });
    dataDims = map$1(dims, function(dim, idx) {
      return {
        name: dim,
        type: coordDimsInfos_1[idx % 2].type
      };
    });
    areaData = new SeriesData$1(dataDims, maModel);
  } else {
    dataDims = [{
      name: "value",
      type: "float"
    }];
    areaData = new SeriesData$1(dataDims, maModel);
  }
  var optData = map$1(maModel.get("data"), curry$1(markAreaTransform, seriesModel, coordSys, maModel));
  if (coordSys) {
    optData = filter(optData, curry$1(markAreaFilter, coordSys));
  }
  var dimValueGetter = coordSys ? function(item, dimName, dataIndex, dimIndex) {
    var rawVal = item.coord[Math.floor(dimIndex / 2)][dimIndex % 2];
    return parseDataValue(rawVal, dataDims[dimIndex]);
  } : function(item, dimName, dataIndex, dimIndex) {
    return parseDataValue(item.value, dataDims[dimIndex]);
  };
  areaData.initData(optData, null, dimValueGetter);
  areaData.hasItemOption = true;
  return areaData;
}
var MarkAreaView$1 = MarkAreaView;
function install$c(registers) {
  registers.registerComponentModel(MarkAreaModel$1);
  registers.registerComponentView(MarkAreaView$1);
  registers.registerPreprocessor(function(opt) {
    if (checkMarkerInSeries(opt.series, "markArea")) {
      opt.markArea = opt.markArea || {};
    }
  });
}
var getDefaultSelectorOptions = function(ecModel, type4) {
  if (type4 === "all") {
    return {
      type: "all",
      title: ecModel.getLocaleModel().get(["legend", "selector", "all"])
    };
  } else if (type4 === "inverse") {
    return {
      type: "inverse",
      title: ecModel.getLocaleModel().get(["legend", "selector", "inverse"])
    };
  }
};
var LegendModel = function(_super) {
  __extends(LegendModel2, _super);
  function LegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendModel2.type;
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    return _this;
  }
  LegendModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
    option.selected = option.selected || {};
    this._updateSelector(option);
  };
  LegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    this._updateSelector(option);
  };
  LegendModel2.prototype._updateSelector = function(option) {
    var selector2 = option.selector;
    var ecModel = this.ecModel;
    if (selector2 === true) {
      selector2 = option.selector = ["all", "inverse"];
    }
    if (isArray$1(selector2)) {
      each$f(selector2, function(item, index2) {
        isString(item) && (item = {
          type: item
        });
        selector2[index2] = merge(item, getDefaultSelectorOptions(ecModel, item.type));
      });
    }
  };
  LegendModel2.prototype.optionUpdated = function() {
    this._updateData(this.ecModel);
    var legendData = this._data;
    if (legendData[0] && this.get("selectedMode") === "single") {
      var hasSelected = false;
      for (var i = 0; i < legendData.length; i++) {
        var name_1 = legendData[i].get("name");
        if (this.isSelected(name_1)) {
          this.select(name_1);
          hasSelected = true;
          break;
        }
      }
      !hasSelected && this.select(legendData[0].get("name"));
    }
  };
  LegendModel2.prototype._updateData = function(ecModel) {
    var potentialData = [];
    var availableNames = [];
    ecModel.eachRawSeries(function(seriesModel) {
      var seriesName = seriesModel.name;
      availableNames.push(seriesName);
      var isPotential;
      if (seriesModel.legendVisualProvider) {
        var provider = seriesModel.legendVisualProvider;
        var names2 = provider.getAllNames();
        if (!ecModel.isSeriesFiltered(seriesModel)) {
          availableNames = availableNames.concat(names2);
        }
        if (names2.length) {
          potentialData = potentialData.concat(names2);
        } else {
          isPotential = true;
        }
      } else {
        isPotential = true;
      }
      if (isPotential && isNameSpecified(seriesModel)) {
        potentialData.push(seriesModel.name);
      }
    });
    this._availableNames = availableNames;
    var rawData = this.get("data") || potentialData;
    var legendData = map$1(rawData, function(dataItem) {
      if (isString(dataItem) || isNumber(dataItem)) {
        dataItem = {
          name: dataItem
        };
      }
      return new Model$1(dataItem, this, this.ecModel);
    }, this);
    this._data = legendData;
  };
  LegendModel2.prototype.getData = function() {
    return this._data;
  };
  LegendModel2.prototype.select = function(name) {
    var selected = this.option.selected;
    var selectedMode = this.get("selectedMode");
    if (selectedMode === "single") {
      var data = this._data;
      each$f(data, function(dataItem) {
        selected[dataItem.get("name")] = false;
      });
    }
    selected[name] = true;
  };
  LegendModel2.prototype.unSelect = function(name) {
    if (this.get("selectedMode") !== "single") {
      this.option.selected[name] = false;
    }
  };
  LegendModel2.prototype.toggleSelected = function(name) {
    var selected = this.option.selected;
    if (!selected.hasOwnProperty(name)) {
      selected[name] = true;
    }
    this[selected[name] ? "unSelect" : "select"](name);
  };
  LegendModel2.prototype.allSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$f(data, function(dataItem) {
      selected[dataItem.get("name", true)] = true;
    });
  };
  LegendModel2.prototype.inverseSelect = function() {
    var data = this._data;
    var selected = this.option.selected;
    each$f(data, function(dataItem) {
      var name = dataItem.get("name", true);
      if (!selected.hasOwnProperty(name)) {
        selected[name] = true;
      }
      selected[name] = !selected[name];
    });
  };
  LegendModel2.prototype.isSelected = function(name) {
    var selected = this.option.selected;
    return !(selected.hasOwnProperty(name) && !selected[name]) && indexOf(this._availableNames, name) >= 0;
  };
  LegendModel2.prototype.getOrient = function() {
    return this.get("orient") === "vertical" ? {
      index: 1,
      name: "vertical"
    } : {
      index: 0,
      name: "horizontal"
    };
  };
  LegendModel2.type = "legend.plain";
  LegendModel2.dependencies = ["series"];
  LegendModel2.defaultOption = {
    z: 4,
    show: true,
    orient: "horizontal",
    left: "center",
    top: 0,
    align: "auto",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    borderRadius: 0,
    borderWidth: 0,
    padding: 5,
    itemGap: 10,
    itemWidth: 25,
    itemHeight: 14,
    symbolRotate: "inherit",
    symbolKeepAspect: true,
    inactiveColor: "#ccc",
    inactiveBorderColor: "#ccc",
    inactiveBorderWidth: "auto",
    itemStyle: {
      color: "inherit",
      opacity: "inherit",
      borderColor: "inherit",
      borderWidth: "auto",
      borderCap: "inherit",
      borderJoin: "inherit",
      borderDashOffset: "inherit",
      borderMiterLimit: "inherit"
    },
    lineStyle: {
      width: "auto",
      color: "inherit",
      inactiveColor: "#ccc",
      inactiveWidth: 2,
      opacity: "inherit",
      type: "inherit",
      cap: "inherit",
      join: "inherit",
      dashOffset: "inherit",
      miterLimit: "inherit"
    },
    textStyle: {
      color: "#333"
    },
    selectedMode: true,
    selector: false,
    selectorLabel: {
      show: true,
      borderRadius: 10,
      padding: [3, 5, 3, 5],
      fontSize: 12,
      fontFamily: "sans-serif",
      color: "#666",
      borderWidth: 1,
      borderColor: "#666"
    },
    emphasis: {
      selectorLabel: {
        show: true,
        color: "#eee",
        backgroundColor: "#666"
      }
    },
    selectorPosition: "auto",
    selectorItemGap: 7,
    selectorButtonGap: 10,
    tooltip: {
      show: false
    }
  };
  return LegendModel2;
}(ComponentModel$1);
var LegendModel$1 = LegendModel;
var curry = curry$1;
var each$3 = each$f;
var Group$1 = Group$4;
var LegendView = function(_super) {
  __extends(LegendView2, _super);
  function LegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = LegendView2.type;
    _this.newlineDisabled = false;
    return _this;
  }
  LegendView2.prototype.init = function() {
    this.group.add(this._contentGroup = new Group$1());
    this.group.add(this._selectorGroup = new Group$1());
    this._isFirstRender = true;
  };
  LegendView2.prototype.getContentGroup = function() {
    return this._contentGroup;
  };
  LegendView2.prototype.getSelectorGroup = function() {
    return this._selectorGroup;
  };
  LegendView2.prototype.render = function(legendModel, ecModel, api) {
    var isFirstRender = this._isFirstRender;
    this._isFirstRender = false;
    this.resetInner();
    if (!legendModel.get("show", true)) {
      return;
    }
    var itemAlign = legendModel.get("align");
    var orient = legendModel.get("orient");
    if (!itemAlign || itemAlign === "auto") {
      itemAlign = legendModel.get("left") === "right" && orient === "vertical" ? "right" : "left";
    }
    var selector2 = legendModel.get("selector", true);
    var selectorPosition = legendModel.get("selectorPosition", true);
    if (selector2 && (!selectorPosition || selectorPosition === "auto")) {
      selectorPosition = orient === "horizontal" ? "end" : "start";
    }
    this.renderInner(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var positionInfo = legendModel.getBoxLayoutParams();
    var viewportSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var padding = legendModel.get("padding");
    var maxSize = getLayoutRect(positionInfo, viewportSize, padding);
    var mainRect = this.layoutInner(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition);
    var layoutRect = getLayoutRect(defaults({
      width: mainRect.width,
      height: mainRect.height
    }, positionInfo), viewportSize, padding);
    this.group.x = layoutRect.x - mainRect.x;
    this.group.y = layoutRect.y - mainRect.y;
    this.group.markRedraw();
    this.group.add(this._backgroundEl = makeBackground(mainRect, legendModel));
  };
  LegendView2.prototype.resetInner = function() {
    this.getContentGroup().removeAll();
    this._backgroundEl && this.group.remove(this._backgroundEl);
    this.getSelectorGroup().removeAll();
  };
  LegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var legendDrawnMap = createHashMap();
    var selectMode = legendModel.get("selectedMode");
    var excludeSeriesId = [];
    ecModel.eachRawSeries(function(seriesModel) {
      !seriesModel.get("legendHoverLink") && excludeSeriesId.push(seriesModel.id);
    });
    each$3(legendModel.getData(), function(legendItemModel, dataIndex) {
      var name = legendItemModel.get("name");
      if (!this.newlineDisabled && (name === "" || name === "\n")) {
        var g2 = new Group$1();
        g2.newline = true;
        contentGroup.add(g2);
        return;
      }
      var seriesModel = ecModel.getSeriesByName(name)[0];
      if (legendDrawnMap.get(name)) {
        return;
      }
      if (seriesModel) {
        var data = seriesModel.getData();
        var lineVisualStyle = data.getVisual("legendLineStyle") || {};
        var legendIcon = data.getVisual("legendIcon");
        var style = data.getVisual("style");
        var itemGroup = this._createItem(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, style, legendIcon, selectMode);
        itemGroup.on("click", curry(dispatchSelectAction, name, null, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, seriesModel.name, null, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, seriesModel.name, null, api, excludeSeriesId));
        legendDrawnMap.set(name, true);
      } else {
        ecModel.eachRawSeries(function(seriesModel2) {
          if (legendDrawnMap.get(name)) {
            return;
          }
          if (seriesModel2.legendVisualProvider) {
            var provider = seriesModel2.legendVisualProvider;
            if (!provider.containName(name)) {
              return;
            }
            var idx = provider.indexOfName(name);
            var style2 = provider.getItemVisual(idx, "style");
            var legendIcon2 = provider.getItemVisual(idx, "legendIcon");
            var colorArr = parse(style2.fill);
            if (colorArr && colorArr[3] === 0) {
              colorArr[3] = 0.2;
              style2 = extend(extend({}, style2), {
                fill: stringify(colorArr, "rgba")
              });
            }
            var itemGroup2 = this._createItem(seriesModel2, name, dataIndex, legendItemModel, legendModel, itemAlign, {}, style2, legendIcon2, selectMode);
            itemGroup2.on("click", curry(dispatchSelectAction, null, name, api, excludeSeriesId)).on("mouseover", curry(dispatchHighlightAction, null, name, api, excludeSeriesId)).on("mouseout", curry(dispatchDownplayAction, null, name, api, excludeSeriesId));
            legendDrawnMap.set(name, true);
          }
        }, this);
      }
    }, this);
    if (selector2) {
      this._createSelector(selector2, legendModel, api, orient, selectorPosition);
    }
  };
  LegendView2.prototype._createSelector = function(selector2, legendModel, api, orient, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    each$3(selector2, function createSelectorButton(selectorItem) {
      var type4 = selectorItem.type;
      var labelText = new ZRText$1({
        style: {
          x: 0,
          y: 0,
          align: "center",
          verticalAlign: "middle"
        },
        onclick: function() {
          api.dispatchAction({
            type: type4 === "all" ? "legendAllSelect" : "legendInverseSelect"
          });
        }
      });
      selectorGroup.add(labelText);
      var labelModel = legendModel.getModel("selectorLabel");
      var emphasisLabelModel = legendModel.getModel(["emphasis", "selectorLabel"]);
      setLabelStyle(labelText, {
        normal: labelModel,
        emphasis: emphasisLabelModel
      }, {
        defaultText: selectorItem.title
      });
      enableHoverEmphasis(labelText);
    });
  };
  LegendView2.prototype._createItem = function(seriesModel, name, dataIndex, legendItemModel, legendModel, itemAlign, lineVisualStyle, itemVisualStyle, legendIcon, selectMode) {
    var drawType = seriesModel.visualDrawType;
    var itemWidth = legendModel.get("itemWidth");
    var itemHeight = legendModel.get("itemHeight");
    var isSelected = legendModel.isSelected(name);
    var iconRotate = legendItemModel.get("symbolRotate");
    var symbolKeepAspect = legendItemModel.get("symbolKeepAspect");
    var legendIconType = legendItemModel.get("icon");
    legendIcon = legendIconType || legendIcon || "roundRect";
    var style = getLegendStyle(legendIcon, legendItemModel, lineVisualStyle, itemVisualStyle, drawType, isSelected);
    var itemGroup = new Group$1();
    var textStyleModel = legendItemModel.getModel("textStyle");
    if (isFunction(seriesModel.getLegendIcon) && (!legendIconType || legendIconType === "inherit")) {
      itemGroup.add(seriesModel.getLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate,
        itemStyle: style.itemStyle,
        lineStyle: style.lineStyle,
        symbolKeepAspect
      }));
    } else {
      var rotate2 = legendIconType === "inherit" && seriesModel.getData().getVisual("symbol") ? iconRotate === "inherit" ? seriesModel.getData().getVisual("symbolRotate") : iconRotate : 0;
      itemGroup.add(getDefaultLegendIcon({
        itemWidth,
        itemHeight,
        icon: legendIcon,
        iconRotate: rotate2,
        itemStyle: style.itemStyle,
        lineStyle: style.lineStyle,
        symbolKeepAspect
      }));
    }
    var textX = itemAlign === "left" ? itemWidth + 5 : -5;
    var textAlign = itemAlign;
    var formatter = legendModel.get("formatter");
    var content = name;
    if (isString(formatter) && formatter) {
      content = formatter.replace("{name}", name != null ? name : "");
    } else if (isFunction(formatter)) {
      content = formatter(name);
    }
    var inactiveColor = legendItemModel.get("inactiveColor");
    itemGroup.add(new ZRText$1({
      style: createTextStyle(textStyleModel, {
        text: content,
        x: textX,
        y: itemHeight / 2,
        fill: isSelected ? textStyleModel.getTextColor() : inactiveColor,
        align: textAlign,
        verticalAlign: "middle"
      })
    }));
    var hitRect = new Rect$3({
      shape: itemGroup.getBoundingRect(),
      invisible: true
    });
    var tooltipModel = legendItemModel.getModel("tooltip");
    if (tooltipModel.get("show")) {
      setTooltipConfig({
        el: hitRect,
        componentModel: legendModel,
        itemName: name,
        itemTooltipOption: tooltipModel.option
      });
    }
    itemGroup.add(hitRect);
    itemGroup.eachChild(function(child) {
      child.silent = true;
    });
    hitRect.silent = !selectMode;
    this.getContentGroup().add(itemGroup);
    enableHoverEmphasis(itemGroup);
    itemGroup.__legendDataIndex = dataIndex;
    return itemGroup;
  };
  LegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var contentGroup = this.getContentGroup();
    var selectorGroup = this.getSelectorGroup();
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), maxSize.width, maxSize.height);
    var contentRect = contentGroup.getBoundingRect();
    var contentPos = [-contentRect.x, -contentRect.y];
    selectorGroup.markRedraw();
    contentGroup.markRedraw();
    if (selector2) {
      box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
      var selectorRect = selectorGroup.getBoundingRect();
      var selectorPos = [-selectorRect.x, -selectorRect.y];
      var selectorButtonGap = legendModel.get("selectorButtonGap", true);
      var orientIdx = legendModel.getOrient().index;
      var wh = orientIdx === 0 ? "width" : "height";
      var hw = orientIdx === 0 ? "height" : "width";
      var yx = orientIdx === 0 ? "y" : "x";
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += contentRect[wh] + selectorButtonGap;
      } else {
        contentPos[orientIdx] += selectorRect[wh] + selectorButtonGap;
      }
      selectorPos[1 - orientIdx] += contentRect[hw] / 2 - selectorRect[hw] / 2;
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      var mainRect = {
        x: 0,
        y: 0
      };
      mainRect[wh] = contentRect[wh] + selectorButtonGap + selectorRect[wh];
      mainRect[hw] = Math.max(contentRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(0, selectorRect[yx] + selectorPos[1 - orientIdx]);
      return mainRect;
    } else {
      contentGroup.x = contentPos[0];
      contentGroup.y = contentPos[1];
      return this.group.getBoundingRect();
    }
  };
  LegendView2.prototype.remove = function() {
    this.getContentGroup().removeAll();
    this._isFirstRender = true;
  };
  LegendView2.type = "legend.plain";
  return LegendView2;
}(ComponentView$1);
function getLegendStyle(iconType, legendModel, lineVisualStyle, itemVisualStyle, drawType, isSelected) {
  function handleCommonProps(style, visualStyle) {
    if (style.lineWidth === "auto") {
      style.lineWidth = visualStyle.lineWidth > 0 ? 2 : 0;
    }
    each$3(style, function(propVal, propName) {
      style[propName] === "inherit" && (style[propName] = visualStyle[propName]);
    });
  }
  var legendItemModel = legendModel.getModel("itemStyle");
  var itemStyle = legendItemModel.getItemStyle();
  var iconBrushType = iconType.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
  itemStyle.decal = itemVisualStyle.decal;
  if (itemStyle.fill === "inherit") {
    itemStyle.fill = itemVisualStyle[drawType];
  }
  if (itemStyle.stroke === "inherit") {
    itemStyle.stroke = itemVisualStyle[iconBrushType];
  }
  if (itemStyle.opacity === "inherit") {
    itemStyle.opacity = (drawType === "fill" ? itemVisualStyle : lineVisualStyle).opacity;
  }
  handleCommonProps(itemStyle, itemVisualStyle);
  var legendLineModel = legendModel.getModel("lineStyle");
  var lineStyle = legendLineModel.getLineStyle();
  handleCommonProps(lineStyle, lineVisualStyle);
  itemStyle.fill === "auto" && (itemStyle.fill = itemVisualStyle.fill);
  itemStyle.stroke === "auto" && (itemStyle.stroke = itemVisualStyle.fill);
  lineStyle.stroke === "auto" && (lineStyle.stroke = itemVisualStyle.fill);
  if (!isSelected) {
    var borderWidth = legendModel.get("inactiveBorderWidth");
    var visualHasBorder = itemStyle[iconBrushType];
    itemStyle.lineWidth = borderWidth === "auto" ? itemVisualStyle.lineWidth > 0 && visualHasBorder ? 2 : 0 : itemStyle.lineWidth;
    itemStyle.fill = legendModel.get("inactiveColor");
    itemStyle.stroke = legendModel.get("inactiveBorderColor");
    lineStyle.stroke = legendLineModel.get("inactiveColor");
    lineStyle.lineWidth = legendLineModel.get("inactiveWidth");
  }
  return {
    itemStyle,
    lineStyle
  };
}
function getDefaultLegendIcon(opt) {
  var symboType = opt.icon || "roundRect";
  var icon = createSymbol$1(symboType, 0, 0, opt.itemWidth, opt.itemHeight, opt.itemStyle.fill, opt.symbolKeepAspect);
  icon.setStyle(opt.itemStyle);
  icon.rotation = (opt.iconRotate || 0) * Math.PI / 180;
  icon.setOrigin([opt.itemWidth / 2, opt.itemHeight / 2]);
  if (symboType.indexOf("empty") > -1) {
    icon.style.stroke = icon.style.fill;
    icon.style.fill = "#fff";
    icon.style.lineWidth = 2;
  }
  return icon;
}
function dispatchSelectAction(seriesName, dataName, api, excludeSeriesId) {
  dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId);
  api.dispatchAction({
    type: "legendToggleSelect",
    name: seriesName != null ? seriesName : dataName
  });
  dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId);
}
function isUseHoverLayer(api) {
  var list = api.getZr().storage.getDisplayList();
  var emphasisState;
  var i = 0;
  var len2 = list.length;
  while (i < len2 && !(emphasisState = list[i].states.emphasis)) {
    i++;
  }
  return emphasisState && emphasisState.hoverLayer;
}
function dispatchHighlightAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "highlight",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
function dispatchDownplayAction(seriesName, dataName, api, excludeSeriesId) {
  if (!isUseHoverLayer(api)) {
    api.dispatchAction({
      type: "downplay",
      seriesName,
      name: dataName,
      excludeSeriesId
    });
  }
}
var LegendView$1 = LegendView;
function legendFilter(ecModel) {
  var legendModels = ecModel.findComponents({
    mainType: "legend"
  });
  if (legendModels && legendModels.length) {
    ecModel.filterSeries(function(series) {
      for (var i = 0; i < legendModels.length; i++) {
        if (!legendModels[i].isSelected(series.name)) {
          return false;
        }
      }
      return true;
    });
  }
}
function legendSelectActionHandler(methodName, payload, ecModel) {
  var selectedMap = {};
  var isToggleSelect = methodName === "toggleSelected";
  var isSelected;
  ecModel.eachComponent("legend", function(legendModel) {
    if (isToggleSelect && isSelected != null) {
      legendModel[isSelected ? "select" : "unSelect"](payload.name);
    } else if (methodName === "allSelect" || methodName === "inverseSelect") {
      legendModel[methodName]();
    } else {
      legendModel[methodName](payload.name);
      isSelected = legendModel.isSelected(payload.name);
    }
    var legendData = legendModel.getData();
    each$f(legendData, function(model) {
      var name = model.get("name");
      if (name === "\n" || name === "") {
        return;
      }
      var isItemSelected = legendModel.isSelected(name);
      if (selectedMap.hasOwnProperty(name)) {
        selectedMap[name] = selectedMap[name] && isItemSelected;
      } else {
        selectedMap[name] = isItemSelected;
      }
    });
  });
  return methodName === "allSelect" || methodName === "inverseSelect" ? {
    selected: selectedMap
  } : {
    name: payload.name,
    selected: selectedMap
  };
}
function installLegendAction(registers) {
  registers.registerAction("legendToggleSelect", "legendselectchanged", curry$1(legendSelectActionHandler, "toggleSelected"));
  registers.registerAction("legendAllSelect", "legendselectall", curry$1(legendSelectActionHandler, "allSelect"));
  registers.registerAction("legendInverseSelect", "legendinverseselect", curry$1(legendSelectActionHandler, "inverseSelect"));
  registers.registerAction("legendSelect", "legendselected", curry$1(legendSelectActionHandler, "select"));
  registers.registerAction("legendUnSelect", "legendunselected", curry$1(legendSelectActionHandler, "unSelect"));
}
function install$b(registers) {
  registers.registerComponentModel(LegendModel$1);
  registers.registerComponentView(LegendView$1);
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.SERIES_FILTER, legendFilter);
  registers.registerSubTypeDefaulter("legend", function() {
    return "plain";
  });
  installLegendAction(registers);
}
var ScrollableLegendModel = function(_super) {
  __extends(ScrollableLegendModel2, _super);
  function ScrollableLegendModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendModel2.type;
    return _this;
  }
  ScrollableLegendModel2.prototype.setScrollDataIndex = function(scrollDataIndex) {
    this.option.scrollDataIndex = scrollDataIndex;
  };
  ScrollableLegendModel2.prototype.init = function(option, parentModel, ecModel) {
    var inputPositionParams = getLayoutParams(option);
    _super.prototype.init.call(this, option, parentModel, ecModel);
    mergeAndNormalizeLayoutParams(this, option, inputPositionParams);
  };
  ScrollableLegendModel2.prototype.mergeOption = function(option, ecModel) {
    _super.prototype.mergeOption.call(this, option, ecModel);
    mergeAndNormalizeLayoutParams(this, this.option, option);
  };
  ScrollableLegendModel2.type = "legend.scroll";
  ScrollableLegendModel2.defaultOption = inheritDefaultOption(LegendModel$1.defaultOption, {
    scrollDataIndex: 0,
    pageButtonItemGap: 5,
    pageButtonGap: null,
    pageButtonPosition: "end",
    pageFormatter: "{current}/{total}",
    pageIcons: {
      horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"],
      vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"]
    },
    pageIconColor: "#2f4554",
    pageIconInactiveColor: "#aaa",
    pageIconSize: 15,
    pageTextStyle: {
      color: "#333"
    },
    animationDurationUpdate: 800
  });
  return ScrollableLegendModel2;
}(LegendModel$1);
function mergeAndNormalizeLayoutParams(legendModel, target, raw) {
  var orient = legendModel.getOrient();
  var ignoreSize = [1, 1];
  ignoreSize[orient.index] = 0;
  mergeLayoutParam(target, raw, {
    type: "box",
    ignoreSize: !!ignoreSize
  });
}
var ScrollableLegendModel$1 = ScrollableLegendModel;
var Group = Group$4;
var WH = ["width", "height"];
var XY = ["x", "y"];
var ScrollableLegendView = function(_super) {
  __extends(ScrollableLegendView2, _super);
  function ScrollableLegendView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ScrollableLegendView2.type;
    _this.newlineDisabled = true;
    _this._currentIndex = 0;
    return _this;
  }
  ScrollableLegendView2.prototype.init = function() {
    _super.prototype.init.call(this);
    this.group.add(this._containerGroup = new Group());
    this._containerGroup.add(this.getContentGroup());
    this.group.add(this._controllerGroup = new Group());
  };
  ScrollableLegendView2.prototype.resetInner = function() {
    _super.prototype.resetInner.call(this);
    this._controllerGroup.removeAll();
    this._containerGroup.removeClipPath();
    this._containerGroup.__rectSize = null;
  };
  ScrollableLegendView2.prototype.renderInner = function(itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition) {
    var self2 = this;
    _super.prototype.renderInner.call(this, itemAlign, legendModel, ecModel, api, selector2, orient, selectorPosition);
    var controllerGroup = this._controllerGroup;
    var pageIconSize = legendModel.get("pageIconSize", true);
    var pageIconSizeArr = isArray$1(pageIconSize) ? pageIconSize : [pageIconSize, pageIconSize];
    createPageButton("pagePrev", 0);
    var pageTextStyleModel = legendModel.getModel("pageTextStyle");
    controllerGroup.add(new ZRText$1({
      name: "pageText",
      style: {
        text: "xx/xx",
        fill: pageTextStyleModel.getTextColor(),
        font: pageTextStyleModel.getFont(),
        verticalAlign: "middle",
        align: "center"
      },
      silent: true
    }));
    createPageButton("pageNext", 1);
    function createPageButton(name, iconIdx) {
      var pageDataIndexName = name + "DataIndex";
      var icon = createIcon(legendModel.get("pageIcons", true)[legendModel.getOrient().name][iconIdx], {
        onclick: bind$1(self2._pageGo, self2, pageDataIndexName, legendModel, api)
      }, {
        x: -pageIconSizeArr[0] / 2,
        y: -pageIconSizeArr[1] / 2,
        width: pageIconSizeArr[0],
        height: pageIconSizeArr[1]
      });
      icon.name = name;
      controllerGroup.add(icon);
    }
  };
  ScrollableLegendView2.prototype.layoutInner = function(legendModel, itemAlign, maxSize, isFirstRender, selector2, selectorPosition) {
    var selectorGroup = this.getSelectorGroup();
    var orientIdx = legendModel.getOrient().index;
    var wh = WH[orientIdx];
    var xy = XY[orientIdx];
    var hw = WH[1 - orientIdx];
    var yx = XY[1 - orientIdx];
    selector2 && box("horizontal", selectorGroup, legendModel.get("selectorItemGap", true));
    var selectorButtonGap = legendModel.get("selectorButtonGap", true);
    var selectorRect = selectorGroup.getBoundingRect();
    var selectorPos = [-selectorRect.x, -selectorRect.y];
    var processMaxSize = clone$4(maxSize);
    selector2 && (processMaxSize[wh] = maxSize[wh] - selectorRect[wh] - selectorButtonGap);
    var mainRect = this._layoutContentAndController(legendModel, isFirstRender, processMaxSize, orientIdx, wh, hw, yx, xy);
    if (selector2) {
      if (selectorPosition === "end") {
        selectorPos[orientIdx] += mainRect[wh] + selectorButtonGap;
      } else {
        var offset = selectorRect[wh] + selectorButtonGap;
        selectorPos[orientIdx] -= offset;
        mainRect[xy] -= offset;
      }
      mainRect[wh] += selectorRect[wh] + selectorButtonGap;
      selectorPos[1 - orientIdx] += mainRect[yx] + mainRect[hw] / 2 - selectorRect[hw] / 2;
      mainRect[hw] = Math.max(mainRect[hw], selectorRect[hw]);
      mainRect[yx] = Math.min(mainRect[yx], selectorRect[yx] + selectorPos[1 - orientIdx]);
      selectorGroup.x = selectorPos[0];
      selectorGroup.y = selectorPos[1];
      selectorGroup.markRedraw();
    }
    return mainRect;
  };
  ScrollableLegendView2.prototype._layoutContentAndController = function(legendModel, isFirstRender, maxSize, orientIdx, wh, hw, yx, xy) {
    var contentGroup = this.getContentGroup();
    var containerGroup = this._containerGroup;
    var controllerGroup = this._controllerGroup;
    box(legendModel.get("orient"), contentGroup, legendModel.get("itemGap"), !orientIdx ? null : maxSize.width, orientIdx ? null : maxSize.height);
    box("horizontal", controllerGroup, legendModel.get("pageButtonItemGap", true));
    var contentRect = contentGroup.getBoundingRect();
    var controllerRect = controllerGroup.getBoundingRect();
    var showController = this._showController = contentRect[wh] > maxSize[wh];
    var contentPos = [-contentRect.x, -contentRect.y];
    if (!isFirstRender) {
      contentPos[orientIdx] = contentGroup[xy];
    }
    var containerPos = [0, 0];
    var controllerPos = [-controllerRect.x, -controllerRect.y];
    var pageButtonGap = retrieve2(legendModel.get("pageButtonGap", true), legendModel.get("itemGap", true));
    if (showController) {
      var pageButtonPosition = legendModel.get("pageButtonPosition", true);
      if (pageButtonPosition === "end") {
        controllerPos[orientIdx] += maxSize[wh] - controllerRect[wh];
      } else {
        containerPos[orientIdx] += controllerRect[wh] + pageButtonGap;
      }
    }
    controllerPos[1 - orientIdx] += contentRect[hw] / 2 - controllerRect[hw] / 2;
    contentGroup.setPosition(contentPos);
    containerGroup.setPosition(containerPos);
    controllerGroup.setPosition(controllerPos);
    var mainRect = {
      x: 0,
      y: 0
    };
    mainRect[wh] = showController ? maxSize[wh] : contentRect[wh];
    mainRect[hw] = Math.max(contentRect[hw], controllerRect[hw]);
    mainRect[yx] = Math.min(0, controllerRect[yx] + controllerPos[1 - orientIdx]);
    containerGroup.__rectSize = maxSize[wh];
    if (showController) {
      var clipShape = {
        x: 0,
        y: 0
      };
      clipShape[wh] = Math.max(maxSize[wh] - controllerRect[wh] - pageButtonGap, 0);
      clipShape[hw] = mainRect[hw];
      containerGroup.setClipPath(new Rect$3({
        shape: clipShape
      }));
      containerGroup.__rectSize = clipShape[wh];
    } else {
      controllerGroup.eachChild(function(child) {
        child.attr({
          invisible: true,
          silent: true
        });
      });
    }
    var pageInfo = this._getPageInfo(legendModel);
    pageInfo.pageIndex != null && updateProps$1(contentGroup, {
      x: pageInfo.contentPosition[0],
      y: pageInfo.contentPosition[1]
    }, showController ? legendModel : null);
    this._updatePageInfoView(legendModel, pageInfo);
    return mainRect;
  };
  ScrollableLegendView2.prototype._pageGo = function(to, legendModel, api) {
    var scrollDataIndex = this._getPageInfo(legendModel)[to];
    scrollDataIndex != null && api.dispatchAction({
      type: "legendScroll",
      scrollDataIndex,
      legendId: legendModel.id
    });
  };
  ScrollableLegendView2.prototype._updatePageInfoView = function(legendModel, pageInfo) {
    var controllerGroup = this._controllerGroup;
    each$f(["pagePrev", "pageNext"], function(name) {
      var key = name + "DataIndex";
      var canJump = pageInfo[key] != null;
      var icon = controllerGroup.childOfName(name);
      if (icon) {
        icon.setStyle("fill", canJump ? legendModel.get("pageIconColor", true) : legendModel.get("pageIconInactiveColor", true));
        icon.cursor = canJump ? "pointer" : "default";
      }
    });
    var pageText = controllerGroup.childOfName("pageText");
    var pageFormatter = legendModel.get("pageFormatter");
    var pageIndex = pageInfo.pageIndex;
    var current = pageIndex != null ? pageIndex + 1 : 0;
    var total = pageInfo.pageCount;
    pageText && pageFormatter && pageText.setStyle("text", isString(pageFormatter) ? pageFormatter.replace("{current}", current == null ? "" : current + "").replace("{total}", total == null ? "" : total + "") : pageFormatter({
      current,
      total
    }));
  };
  ScrollableLegendView2.prototype._getPageInfo = function(legendModel) {
    var scrollDataIndex = legendModel.get("scrollDataIndex", true);
    var contentGroup = this.getContentGroup();
    var containerRectSize = this._containerGroup.__rectSize;
    var orientIdx = legendModel.getOrient().index;
    var wh = WH[orientIdx];
    var xy = XY[orientIdx];
    var targetItemIndex = this._findTargetItemIndex(scrollDataIndex);
    var children = contentGroup.children();
    var targetItem = children[targetItemIndex];
    var itemCount = children.length;
    var pCount = !itemCount ? 0 : 1;
    var result = {
      contentPosition: [contentGroup.x, contentGroup.y],
      pageCount: pCount,
      pageIndex: pCount - 1,
      pagePrevDataIndex: null,
      pageNextDataIndex: null
    };
    if (!targetItem) {
      return result;
    }
    var targetItemInfo = getItemInfo(targetItem);
    result.contentPosition[orientIdx] = -targetItemInfo.s;
    for (var i = targetItemIndex + 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i <= itemCount; ++i) {
      currItemInfo = getItemInfo(children[i]);
      if (!currItemInfo && winEndItemInfo.e > winStartItemInfo.s + containerRectSize || currItemInfo && !intersect2(currItemInfo, winStartItemInfo.s)) {
        if (winEndItemInfo.i > winStartItemInfo.i) {
          winStartItemInfo = winEndItemInfo;
        } else {
          winStartItemInfo = currItemInfo;
        }
        if (winStartItemInfo) {
          if (result.pageNextDataIndex == null) {
            result.pageNextDataIndex = winStartItemInfo.i;
          }
          ++result.pageCount;
        }
      }
      winEndItemInfo = currItemInfo;
    }
    for (var i = targetItemIndex - 1, winStartItemInfo = targetItemInfo, winEndItemInfo = targetItemInfo, currItemInfo = null; i >= -1; --i) {
      currItemInfo = getItemInfo(children[i]);
      if ((!currItemInfo || !intersect2(winEndItemInfo, currItemInfo.s)) && winStartItemInfo.i < winEndItemInfo.i) {
        winEndItemInfo = winStartItemInfo;
        if (result.pagePrevDataIndex == null) {
          result.pagePrevDataIndex = winStartItemInfo.i;
        }
        ++result.pageCount;
        ++result.pageIndex;
      }
      winStartItemInfo = currItemInfo;
    }
    return result;
    function getItemInfo(el) {
      if (el) {
        var itemRect = el.getBoundingRect();
        var start2 = itemRect[xy] + el[xy];
        return {
          s: start2,
          e: start2 + itemRect[wh],
          i: el.__legendDataIndex
        };
      }
    }
    function intersect2(itemInfo, winStart) {
      return itemInfo.e >= winStart && itemInfo.s <= winStart + containerRectSize;
    }
  };
  ScrollableLegendView2.prototype._findTargetItemIndex = function(targetDataIndex) {
    if (!this._showController) {
      return 0;
    }
    var index2;
    var contentGroup = this.getContentGroup();
    var defaultIndex;
    contentGroup.eachChild(function(child, idx) {
      var legendDataIdx = child.__legendDataIndex;
      if (defaultIndex == null && legendDataIdx != null) {
        defaultIndex = idx;
      }
      if (legendDataIdx === targetDataIndex) {
        index2 = idx;
      }
    });
    return index2 != null ? index2 : defaultIndex;
  };
  ScrollableLegendView2.type = "legend.scroll";
  return ScrollableLegendView2;
}(LegendView$1);
var ScrollableLegendView$1 = ScrollableLegendView;
function installScrollableLegendAction(registers) {
  registers.registerAction("legendScroll", "legendscroll", function(payload, ecModel) {
    var scrollDataIndex = payload.scrollDataIndex;
    scrollDataIndex != null && ecModel.eachComponent({
      mainType: "legend",
      subType: "scroll",
      query: payload
    }, function(legendModel) {
      legendModel.setScrollDataIndex(scrollDataIndex);
    });
  });
}
function install$a(registers) {
  use(install$b);
  registers.registerComponentModel(ScrollableLegendModel$1);
  registers.registerComponentView(ScrollableLegendView$1);
  installScrollableLegendAction(registers);
}
function install$9(registers) {
  use(install$b);
  use(install$a);
}
var InsideZoomModel = function(_super) {
  __extends(InsideZoomModel2, _super);
  function InsideZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = InsideZoomModel2.type;
    return _this;
  }
  InsideZoomModel2.type = "dataZoom.inside";
  InsideZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    disabled: false,
    zoomLock: false,
    zoomOnMouseWheel: true,
    moveOnMouseMove: true,
    moveOnMouseWheel: false,
    preventDefaultMouseMove: true
  });
  return InsideZoomModel2;
}(DataZoomModel$1);
var InsideZoomModel$1 = InsideZoomModel;
var inner$1 = makeInner();
function setViewInfoToCoordSysRecord(api, dataZoomModel, getRange) {
  inner$1(api).coordSysRecordMap.each(function(coordSysRecord) {
    var dzInfo = coordSysRecord.dataZoomInfoMap.get(dataZoomModel.uid);
    if (dzInfo) {
      dzInfo.getRange = getRange;
    }
  });
}
function disposeCoordSysRecordIfNeeded(api, dataZoomModel) {
  var coordSysRecordMap = inner$1(api).coordSysRecordMap;
  var coordSysKeyArr = coordSysRecordMap.keys();
  for (var i = 0; i < coordSysKeyArr.length; i++) {
    var coordSysKey = coordSysKeyArr[i];
    var coordSysRecord = coordSysRecordMap.get(coordSysKey);
    var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
    if (dataZoomInfoMap) {
      var dzUid = dataZoomModel.uid;
      var dzInfo = dataZoomInfoMap.get(dzUid);
      if (dzInfo) {
        dataZoomInfoMap.removeKey(dzUid);
        if (!dataZoomInfoMap.keys().length) {
          disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        }
      }
    }
  }
}
function disposeCoordSysRecord(coordSysRecordMap, coordSysRecord) {
  if (coordSysRecord) {
    coordSysRecordMap.removeKey(coordSysRecord.model.uid);
    var controller = coordSysRecord.controller;
    controller && controller.dispose();
  }
}
function createCoordSysRecord(api, coordSysModel) {
  var coordSysRecord = {
    model: coordSysModel,
    containsPoint: curry$1(containsPoint, coordSysModel),
    dispatchAction: curry$1(dispatchAction, api),
    dataZoomInfoMap: null,
    controller: null
  };
  var controller = coordSysRecord.controller = new RoamController$1(api.getZr());
  each$f(["pan", "zoom", "scrollMove"], function(eventName) {
    controller.on(eventName, function(event) {
      var batch = [];
      coordSysRecord.dataZoomInfoMap.each(function(dzInfo) {
        if (!event.isAvailableBehavior(dzInfo.model.option)) {
          return;
        }
        var method4 = (dzInfo.getRange || {})[eventName];
        var range3 = method4 && method4(dzInfo.dzReferCoordSysInfo, coordSysRecord.model.mainType, coordSysRecord.controller, event);
        !dzInfo.model.get("disabled", true) && range3 && batch.push({
          dataZoomId: dzInfo.model.id,
          start: range3[0],
          end: range3[1]
        });
      });
      batch.length && coordSysRecord.dispatchAction(batch);
    });
  });
  return coordSysRecord;
}
function dispatchAction(api, batch) {
  if (!api.isDisposed()) {
    api.dispatchAction({
      type: "dataZoom",
      animation: {
        easing: "cubicOut",
        duration: 100
      },
      batch
    });
  }
}
function containsPoint(coordSysModel, e2, x2, y2) {
  return coordSysModel.coordinateSystem.containPoint([x2, y2]);
}
function mergeControllerParams(dataZoomInfoMap) {
  var controlType;
  var prefix = "type_";
  var typePriority = {
    "type_true": 2,
    "type_move": 1,
    "type_false": 0,
    "type_undefined": -1
  };
  var preventDefaultMouseMove = true;
  dataZoomInfoMap.each(function(dataZoomInfo) {
    var dataZoomModel = dataZoomInfo.model;
    var oneType = dataZoomModel.get("disabled", true) ? false : dataZoomModel.get("zoomLock", true) ? "move" : true;
    if (typePriority[prefix + oneType] > typePriority[prefix + controlType]) {
      controlType = oneType;
    }
    preventDefaultMouseMove = preventDefaultMouseMove && dataZoomModel.get("preventDefaultMouseMove", true);
  });
  return {
    controlType,
    opt: {
      zoomOnMouseWheel: true,
      moveOnMouseMove: true,
      moveOnMouseWheel: true,
      preventDefaultMouseMove: !!preventDefaultMouseMove
    }
  };
}
function installDataZoomRoamProcessor(registers) {
  registers.registerProcessor(registers.PRIORITY.PROCESSOR.FILTER, function(ecModel, api) {
    var apiInner = inner$1(api);
    var coordSysRecordMap = apiInner.coordSysRecordMap || (apiInner.coordSysRecordMap = createHashMap());
    coordSysRecordMap.each(function(coordSysRecord) {
      coordSysRecord.dataZoomInfoMap = null;
    });
    ecModel.eachComponent({
      mainType: "dataZoom",
      subType: "inside"
    }, function(dataZoomModel) {
      var dzReferCoordSysWrap = collectReferCoordSysModelInfo(dataZoomModel);
      each$f(dzReferCoordSysWrap.infoList, function(dzCoordSysInfo) {
        var coordSysUid = dzCoordSysInfo.model.uid;
        var coordSysRecord = coordSysRecordMap.get(coordSysUid) || coordSysRecordMap.set(coordSysUid, createCoordSysRecord(api, dzCoordSysInfo.model));
        var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap || (coordSysRecord.dataZoomInfoMap = createHashMap());
        dataZoomInfoMap.set(dataZoomModel.uid, {
          dzReferCoordSysInfo: dzCoordSysInfo,
          model: dataZoomModel,
          getRange: null
        });
      });
    });
    coordSysRecordMap.each(function(coordSysRecord) {
      var controller = coordSysRecord.controller;
      var firstDzInfo;
      var dataZoomInfoMap = coordSysRecord.dataZoomInfoMap;
      if (dataZoomInfoMap) {
        var firstDzKey = dataZoomInfoMap.keys()[0];
        if (firstDzKey != null) {
          firstDzInfo = dataZoomInfoMap.get(firstDzKey);
        }
      }
      if (!firstDzInfo) {
        disposeCoordSysRecord(coordSysRecordMap, coordSysRecord);
        return;
      }
      var controllerParams = mergeControllerParams(dataZoomInfoMap);
      controller.enable(controllerParams.controlType, controllerParams.opt);
      controller.setPointerChecker(coordSysRecord.containsPoint);
      createOrUpdate(coordSysRecord, "dispatchAction", firstDzInfo.model.get("throttle", true), "fixRate");
    });
  });
}
var InsideZoomView = function(_super) {
  __extends(InsideZoomView2, _super);
  function InsideZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataZoom.inside";
    return _this;
  }
  InsideZoomView2.prototype.render = function(dataZoomModel, ecModel, api) {
    _super.prototype.render.apply(this, arguments);
    if (dataZoomModel.noTarget()) {
      this._clear();
      return;
    }
    this.range = dataZoomModel.getPercentRange();
    setViewInfoToCoordSysRecord(api, dataZoomModel, {
      pan: bind$1(getRangeHandlers.pan, this),
      zoom: bind$1(getRangeHandlers.zoom, this),
      scrollMove: bind$1(getRangeHandlers.scrollMove, this)
    });
  };
  InsideZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  InsideZoomView2.prototype._clear = function() {
    disposeCoordSysRecordIfNeeded(this.api, this.dataZoomModel);
    this.range = null;
  };
  InsideZoomView2.type = "dataZoom.inside";
  return InsideZoomView2;
}(DataZoomView$1);
var getRangeHandlers = {
  zoom: function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var directionInfo = getDirectionInfo[coordSysMainType](null, [e2.originX, e2.originY], axisModel, controller, coordSysInfo);
    var percentPoint = (directionInfo.signal > 0 ? directionInfo.pixelStart + directionInfo.pixelLength - directionInfo.pixel : directionInfo.pixel - directionInfo.pixelStart) / directionInfo.pixelLength * (range3[1] - range3[0]) + range3[0];
    var scale2 = Math.max(1 / e2.scale, 0);
    range3[0] = (range3[0] - percentPoint) * scale2 + percentPoint;
    range3[1] = (range3[1] - percentPoint) * scale2 + percentPoint;
    var minMaxSpan = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    sliderMove(0, range3, [0, 100], 0, minMaxSpan.minSpan, minMaxSpan.maxSpan);
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  },
  pan: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([e2.oldX, e2.oldY], [e2.newX, e2.newY], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * directionInfo.pixel / directionInfo.pixelLength;
  }),
  scrollMove: makeMover(function(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2) {
    var directionInfo = getDirectionInfo[coordSysMainType]([0, 0], [e2.scrollDelta, e2.scrollDelta], axisModel, controller, coordSysInfo);
    return directionInfo.signal * (range3[1] - range3[0]) * e2.scrollDelta;
  })
};
function makeMover(getPercentDelta) {
  return function(coordSysInfo, coordSysMainType, controller, e2) {
    var lastRange = this.range;
    var range3 = lastRange.slice();
    var axisModel = coordSysInfo.axisModels[0];
    if (!axisModel) {
      return;
    }
    var percentDelta = getPercentDelta(range3, axisModel, coordSysInfo, coordSysMainType, controller, e2);
    sliderMove(percentDelta, range3, [0, 100], "all");
    this.range = range3;
    if (lastRange[0] !== range3[0] || lastRange[1] !== range3[1]) {
      return range3;
    }
  };
}
var getDirectionInfo = {
  grid: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    oldPoint = oldPoint || [0, 0];
    if (axis.dim === "x") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  polar: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var ret = {};
    var polar = coordSysInfo.model.coordinateSystem;
    var radiusExtent = polar.getRadiusAxis().getExtent();
    var angleExtent = polar.getAngleAxis().getExtent();
    oldPoint = oldPoint ? polar.pointToCoord(oldPoint) : [0, 0];
    newPoint = polar.pointToCoord(newPoint);
    if (axisModel.mainType === "radiusAxis") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = radiusExtent[1] - radiusExtent[0];
      ret.pixelStart = radiusExtent[0];
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = angleExtent[1] - angleExtent[0];
      ret.pixelStart = angleExtent[0];
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  },
  singleAxis: function(oldPoint, newPoint, axisModel, controller, coordSysInfo) {
    var axis = axisModel.axis;
    var rect = coordSysInfo.model.coordinateSystem.getRect();
    var ret = {};
    oldPoint = oldPoint || [0, 0];
    if (axis.orient === "horizontal") {
      ret.pixel = newPoint[0] - oldPoint[0];
      ret.pixelLength = rect.width;
      ret.pixelStart = rect.x;
      ret.signal = axis.inverse ? 1 : -1;
    } else {
      ret.pixel = newPoint[1] - oldPoint[1];
      ret.pixelLength = rect.height;
      ret.pixelStart = rect.y;
      ret.signal = axis.inverse ? -1 : 1;
    }
    return ret;
  }
};
var InsideZoomView$1 = InsideZoomView;
function install$8(registers) {
  installCommon$1(registers);
  registers.registerComponentModel(InsideZoomModel$1);
  registers.registerComponentView(InsideZoomView$1);
  installDataZoomRoamProcessor(registers);
}
var SliderZoomModel = function(_super) {
  __extends(SliderZoomModel2, _super);
  function SliderZoomModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomModel2.type;
    return _this;
  }
  SliderZoomModel2.type = "dataZoom.slider";
  SliderZoomModel2.layoutMode = "box";
  SliderZoomModel2.defaultOption = inheritDefaultOption(DataZoomModel$1.defaultOption, {
    show: true,
    right: "ph",
    top: "ph",
    width: "ph",
    height: "ph",
    left: null,
    bottom: null,
    borderColor: "#d2dbee",
    borderRadius: 3,
    backgroundColor: "rgba(47,69,84,0)",
    dataBackground: {
      lineStyle: {
        color: "#d2dbee",
        width: 0.5
      },
      areaStyle: {
        color: "#d2dbee",
        opacity: 0.2
      }
    },
    selectedDataBackground: {
      lineStyle: {
        color: "#8fb0f7",
        width: 0.5
      },
      areaStyle: {
        color: "#8fb0f7",
        opacity: 0.2
      }
    },
    fillerColor: "rgba(135,175,274,0.2)",
    handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z",
    handleSize: "100%",
    handleStyle: {
      color: "#fff",
      borderColor: "#ACB8D1"
    },
    moveHandleSize: 7,
    moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z",
    moveHandleStyle: {
      color: "#D2DBEE",
      opacity: 0.7
    },
    showDetail: true,
    showDataShadow: "auto",
    realtime: true,
    zoomLock: false,
    textStyle: {
      color: "#6E7079"
    },
    brushSelect: true,
    brushStyle: {
      color: "rgba(135,175,274,0.15)"
    },
    emphasis: {
      handleStyle: {
        borderColor: "#8FB0F7"
      },
      moveHandleStyle: {
        color: "#8FB0F7"
      }
    }
  });
  return SliderZoomModel2;
}(DataZoomModel$1);
var SliderZoomModel$1 = SliderZoomModel;
var Rect = Rect$3;
var DEFAULT_LOCATION_EDGE_GAP = 7;
var DEFAULT_FRAME_BORDER_WIDTH = 1;
var DEFAULT_FILLER_SIZE = 30;
var DEFAULT_MOVE_HANDLE_SIZE = 7;
var HORIZONTAL = "horizontal";
var VERTICAL = "vertical";
var LABEL_GAP = 5;
var SHOW_DATA_SHADOW_SERIES_TYPE = ["line", "bar", "candlestick", "scatter"];
var REALTIME_ANIMATION_CONFIG = {
  easing: "cubicOut",
  duration: 100,
  delay: 0
};
var SliderZoomView = function(_super) {
  __extends(SliderZoomView2, _super);
  function SliderZoomView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = SliderZoomView2.type;
    _this._displayables = {};
    return _this;
  }
  SliderZoomView2.prototype.init = function(ecModel, api) {
    this.api = api;
    this._onBrush = bind$1(this._onBrush, this);
    this._onBrushEnd = bind$1(this._onBrushEnd, this);
  };
  SliderZoomView2.prototype.render = function(dataZoomModel, ecModel, api, payload) {
    _super.prototype.render.apply(this, arguments);
    createOrUpdate(this, "_dispatchZoomAction", dataZoomModel.get("throttle"), "fixRate");
    this._orient = dataZoomModel.getOrient();
    if (dataZoomModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    if (dataZoomModel.noTarget()) {
      this._clear();
      this.group.removeAll();
      return;
    }
    if (!payload || payload.type !== "dataZoom" || payload.from !== this.uid) {
      this._buildView();
    }
    this._updateView();
  };
  SliderZoomView2.prototype.dispose = function() {
    this._clear();
    _super.prototype.dispose.apply(this, arguments);
  };
  SliderZoomView2.prototype._clear = function() {
    clear$1(this, "_dispatchZoomAction");
    var zr = this.api.getZr();
    zr.off("mousemove", this._onBrush);
    zr.off("mouseup", this._onBrushEnd);
  };
  SliderZoomView2.prototype._buildView = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    this._brushing = false;
    this._displayables.brushRect = null;
    this._resetLocation();
    this._resetInterval();
    var barGroup = this._displayables.sliderGroup = new Group$4();
    this._renderBackground();
    this._renderHandle();
    this._renderDataShadow();
    thisGroup.add(barGroup);
    this._positionGroup();
  };
  SliderZoomView2.prototype._resetLocation = function() {
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var showMoveHandle = dataZoomModel.get("brushSelect");
    var moveHandleSize = showMoveHandle ? DEFAULT_MOVE_HANDLE_SIZE : 0;
    var coordRect = this._findCoordRect();
    var ecSize = {
      width: api.getWidth(),
      height: api.getHeight()
    };
    var positionInfo = this._orient === HORIZONTAL ? {
      right: ecSize.width - coordRect.x - coordRect.width,
      top: ecSize.height - DEFAULT_FILLER_SIZE - DEFAULT_LOCATION_EDGE_GAP - moveHandleSize,
      width: coordRect.width,
      height: DEFAULT_FILLER_SIZE
    } : {
      right: DEFAULT_LOCATION_EDGE_GAP,
      top: coordRect.y,
      width: DEFAULT_FILLER_SIZE,
      height: coordRect.height
    };
    var layoutParams = getLayoutParams(dataZoomModel.option);
    each$f(["right", "top", "width", "height"], function(name) {
      if (layoutParams[name] === "ph") {
        layoutParams[name] = positionInfo[name];
      }
    });
    var layoutRect = getLayoutRect(layoutParams, ecSize);
    this._location = {
      x: layoutRect.x,
      y: layoutRect.y
    };
    this._size = [layoutRect.width, layoutRect.height];
    this._orient === VERTICAL && this._size.reverse();
  };
  SliderZoomView2.prototype._positionGroup = function() {
    var thisGroup = this.group;
    var location = this._location;
    var orient = this._orient;
    var targetAxisModel = this.dataZoomModel.getFirstTargetAxisModel();
    var inverse = targetAxisModel && targetAxisModel.get("inverse");
    var sliderGroup = this._displayables.sliderGroup;
    var otherAxisInverse = (this._dataShadowInfo || {}).otherAxisInverse;
    sliderGroup.attr(orient === HORIZONTAL && !inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: 1
    } : orient === HORIZONTAL && inverse ? {
      scaleY: otherAxisInverse ? 1 : -1,
      scaleX: -1
    } : orient === VERTICAL && !inverse ? {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: 1,
      rotation: Math.PI / 2
    } : {
      scaleY: otherAxisInverse ? -1 : 1,
      scaleX: -1,
      rotation: Math.PI / 2
    });
    var rect = thisGroup.getBoundingRect([sliderGroup]);
    thisGroup.x = location.x - rect.x;
    thisGroup.y = location.y - rect.y;
    thisGroup.markRedraw();
  };
  SliderZoomView2.prototype._getViewExtent = function() {
    return [0, this._size[0]];
  };
  SliderZoomView2.prototype._renderBackground = function() {
    var dataZoomModel = this.dataZoomModel;
    var size = this._size;
    var barGroup = this._displayables.sliderGroup;
    var brushSelect = dataZoomModel.get("brushSelect");
    barGroup.add(new Rect({
      silent: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: dataZoomModel.get("backgroundColor")
      },
      z2: -40
    }));
    var clickPanel = new Rect({
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1]
      },
      style: {
        fill: "transparent"
      },
      z2: 0,
      onclick: bind$1(this._onClickPanel, this)
    });
    var zr = this.api.getZr();
    if (brushSelect) {
      clickPanel.on("mousedown", this._onBrushStart, this);
      clickPanel.cursor = "crosshair";
      zr.on("mousemove", this._onBrush);
      zr.on("mouseup", this._onBrushEnd);
    } else {
      zr.off("mousemove", this._onBrush);
      zr.off("mouseup", this._onBrushEnd);
    }
    barGroup.add(clickPanel);
  };
  SliderZoomView2.prototype._renderDataShadow = function() {
    var info = this._dataShadowInfo = this._prepareDataShadowInfo();
    this._displayables.dataShadowSegs = [];
    if (!info) {
      return;
    }
    var size = this._size;
    var oldSize = this._shadowSize || [];
    var seriesModel = info.series;
    var data = seriesModel.getRawData();
    var otherDim = seriesModel.getShadowDim ? seriesModel.getShadowDim() : info.otherDim;
    if (otherDim == null) {
      return;
    }
    var polygonPts = this._shadowPolygonPts;
    var polylinePts = this._shadowPolylinePts;
    if (data !== this._shadowData || otherDim !== this._shadowDim || size[0] !== oldSize[0] || size[1] !== oldSize[1]) {
      var otherDataExtent_1 = data.getDataExtent(otherDim);
      var otherOffset = (otherDataExtent_1[1] - otherDataExtent_1[0]) * 0.3;
      otherDataExtent_1 = [otherDataExtent_1[0] - otherOffset, otherDataExtent_1[1] + otherOffset];
      var otherShadowExtent_1 = [0, size[1]];
      var thisShadowExtent = [0, size[0]];
      var areaPoints_1 = [[size[0], 0], [0, 0]];
      var linePoints_1 = [];
      var step_1 = thisShadowExtent[1] / (data.count() - 1);
      var thisCoord_1 = 0;
      var stride_1 = Math.round(data.count() / size[0]);
      var lastIsEmpty_1;
      data.each([otherDim], function(value, index2) {
        if (stride_1 > 0 && index2 % stride_1) {
          thisCoord_1 += step_1;
          return;
        }
        var isEmpty = value == null || isNaN(value) || value === "";
        var otherCoord = isEmpty ? 0 : linearMap$2(value, otherDataExtent_1, otherShadowExtent_1, true);
        if (isEmpty && !lastIsEmpty_1 && index2) {
          areaPoints_1.push([areaPoints_1[areaPoints_1.length - 1][0], 0]);
          linePoints_1.push([linePoints_1[linePoints_1.length - 1][0], 0]);
        } else if (!isEmpty && lastIsEmpty_1) {
          areaPoints_1.push([thisCoord_1, 0]);
          linePoints_1.push([thisCoord_1, 0]);
        }
        areaPoints_1.push([thisCoord_1, otherCoord]);
        linePoints_1.push([thisCoord_1, otherCoord]);
        thisCoord_1 += step_1;
        lastIsEmpty_1 = isEmpty;
      });
      polygonPts = this._shadowPolygonPts = areaPoints_1;
      polylinePts = this._shadowPolylinePts = linePoints_1;
    }
    this._shadowData = data;
    this._shadowDim = otherDim;
    this._shadowSize = [size[0], size[1]];
    var dataZoomModel = this.dataZoomModel;
    function createDataShadowGroup(isSelectedArea) {
      var model = dataZoomModel.getModel(isSelectedArea ? "selectedDataBackground" : "dataBackground");
      var group2 = new Group$4();
      var polygon = new Polygon$1({
        shape: {
          points: polygonPts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("areaStyle").getAreaStyle(),
        silent: true,
        z2: -20
      });
      var polyline = new Polyline$3({
        shape: {
          points: polylinePts
        },
        segmentIgnoreThreshold: 1,
        style: model.getModel("lineStyle").getLineStyle(),
        silent: true,
        z2: -19
      });
      group2.add(polygon);
      group2.add(polyline);
      return group2;
    }
    for (var i = 0; i < 3; i++) {
      var group = createDataShadowGroup(i === 1);
      this._displayables.sliderGroup.add(group);
      this._displayables.dataShadowSegs.push(group);
    }
  };
  SliderZoomView2.prototype._prepareDataShadowInfo = function() {
    var dataZoomModel = this.dataZoomModel;
    var showDataShadow = dataZoomModel.get("showDataShadow");
    if (showDataShadow === false) {
      return;
    }
    var result;
    var ecModel = this.ecModel;
    dataZoomModel.eachTargetAxis(function(axisDim, axisIndex) {
      var seriesModels = dataZoomModel.getAxisProxy(axisDim, axisIndex).getTargetSeriesModels();
      each$f(seriesModels, function(seriesModel) {
        if (result) {
          return;
        }
        if (showDataShadow !== true && indexOf(SHOW_DATA_SHADOW_SERIES_TYPE, seriesModel.get("type")) < 0) {
          return;
        }
        var thisAxis = ecModel.getComponent(getAxisMainType(axisDim), axisIndex).axis;
        var otherDim = getOtherDim(axisDim);
        var otherAxisInverse;
        var coordSys = seriesModel.coordinateSystem;
        if (otherDim != null && coordSys.getOtherAxis) {
          otherAxisInverse = coordSys.getOtherAxis(thisAxis).inverse;
        }
        otherDim = seriesModel.getData().mapDimension(otherDim);
        result = {
          thisAxis,
          series: seriesModel,
          thisDim: axisDim,
          otherDim,
          otherAxisInverse
        };
      }, this);
    }, this);
    return result;
  };
  SliderZoomView2.prototype._renderHandle = function() {
    var thisGroup = this.group;
    var displayables = this._displayables;
    var handles = displayables.handles = [null, null];
    var handleLabels = displayables.handleLabels = [null, null];
    var sliderGroup = this._displayables.sliderGroup;
    var size = this._size;
    var dataZoomModel = this.dataZoomModel;
    var api = this.api;
    var borderRadius = dataZoomModel.get("borderRadius") || 0;
    var brushSelect = dataZoomModel.get("brushSelect");
    var filler = displayables.filler = new Rect({
      silent: brushSelect,
      style: {
        fill: dataZoomModel.get("fillerColor")
      },
      textConfig: {
        position: "inside"
      }
    });
    sliderGroup.add(filler);
    sliderGroup.add(new Rect({
      silent: true,
      subPixelOptimize: true,
      shape: {
        x: 0,
        y: 0,
        width: size[0],
        height: size[1],
        r: borderRadius
      },
      style: {
        stroke: dataZoomModel.get("dataBackgroundColor") || dataZoomModel.get("borderColor"),
        lineWidth: DEFAULT_FRAME_BORDER_WIDTH,
        fill: "rgba(0,0,0,0)"
      }
    }));
    each$f([0, 1], function(handleIndex) {
      var iconStr = dataZoomModel.get("handleIcon");
      if (!symbolBuildProxies[iconStr] && iconStr.indexOf("path://") < 0 && iconStr.indexOf("image://") < 0) {
        iconStr = "path://" + iconStr;
      }
      var path = createSymbol$1(iconStr, -1, 0, 2, 2, null, true);
      path.attr({
        cursor: getCursor$1(this._orient),
        draggable: true,
        drift: bind$1(this._onDragMove, this, handleIndex),
        ondragend: bind$1(this._onDragEnd, this),
        onmouseover: bind$1(this._showDataInfo, this, true),
        onmouseout: bind$1(this._showDataInfo, this, false),
        z2: 5
      });
      var bRect = path.getBoundingRect();
      var handleSize = dataZoomModel.get("handleSize");
      this._handleHeight = parsePercent(handleSize, this._size[1]);
      this._handleWidth = bRect.width / bRect.height * this._handleHeight;
      path.setStyle(dataZoomModel.getModel("handleStyle").getItemStyle());
      path.style.strokeNoScale = true;
      path.rectHover = true;
      path.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
      enableHoverEmphasis(path);
      var handleColor = dataZoomModel.get("handleColor");
      if (handleColor != null) {
        path.style.fill = handleColor;
      }
      sliderGroup.add(handles[handleIndex] = path);
      var textStyleModel = dataZoomModel.getModel("textStyle");
      thisGroup.add(handleLabels[handleIndex] = new ZRText$1({
        silent: true,
        invisible: true,
        style: createTextStyle(textStyleModel, {
          x: 0,
          y: 0,
          text: "",
          verticalAlign: "middle",
          align: "center",
          fill: textStyleModel.getTextColor(),
          font: textStyleModel.getFont()
        }),
        z2: 10
      }));
    }, this);
    var actualMoveZone = filler;
    if (brushSelect) {
      var moveHandleHeight = parsePercent(dataZoomModel.get("moveHandleSize"), size[1]);
      var moveHandle_1 = displayables.moveHandle = new Rect$3({
        style: dataZoomModel.getModel("moveHandleStyle").getItemStyle(),
        silent: true,
        shape: {
          r: [0, 0, 2, 2],
          y: size[1] - 0.5,
          height: moveHandleHeight
        }
      });
      var iconSize = moveHandleHeight * 0.8;
      var moveHandleIcon = displayables.moveHandleIcon = createSymbol$1(dataZoomModel.get("moveHandleIcon"), -iconSize / 2, -iconSize / 2, iconSize, iconSize, "#fff", true);
      moveHandleIcon.silent = true;
      moveHandleIcon.y = size[1] + moveHandleHeight / 2 - 0.5;
      moveHandle_1.ensureState("emphasis").style = dataZoomModel.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
      var moveZoneExpandSize = Math.min(size[1] / 2, Math.max(moveHandleHeight, 10));
      actualMoveZone = displayables.moveZone = new Rect$3({
        invisible: true,
        shape: {
          y: size[1] - moveZoneExpandSize,
          height: moveHandleHeight + moveZoneExpandSize
        }
      });
      actualMoveZone.on("mouseover", function() {
        api.enterEmphasis(moveHandle_1);
      }).on("mouseout", function() {
        api.leaveEmphasis(moveHandle_1);
      });
      sliderGroup.add(moveHandle_1);
      sliderGroup.add(moveHandleIcon);
      sliderGroup.add(actualMoveZone);
    }
    actualMoveZone.attr({
      draggable: true,
      cursor: getCursor$1(this._orient),
      drift: bind$1(this._onDragMove, this, "all"),
      ondragstart: bind$1(this._showDataInfo, this, true),
      ondragend: bind$1(this._onDragEnd, this),
      onmouseover: bind$1(this._showDataInfo, this, true),
      onmouseout: bind$1(this._showDataInfo, this, false)
    });
  };
  SliderZoomView2.prototype._resetInterval = function() {
    var range3 = this._range = this.dataZoomModel.getPercentRange();
    var viewExtent = this._getViewExtent();
    this._handleEnds = [linearMap$2(range3[0], [0, 100], viewExtent, true), linearMap$2(range3[1], [0, 100], viewExtent, true)];
  };
  SliderZoomView2.prototype._updateInterval = function(handleIndex, delta) {
    var dataZoomModel = this.dataZoomModel;
    var handleEnds = this._handleEnds;
    var viewExtend = this._getViewExtent();
    var minMaxSpan = dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
    var percentExtent = [0, 100];
    sliderMove(delta, handleEnds, viewExtend, dataZoomModel.get("zoomLock") ? "all" : handleIndex, minMaxSpan.minSpan != null ? linearMap$2(minMaxSpan.minSpan, percentExtent, viewExtend, true) : null, minMaxSpan.maxSpan != null ? linearMap$2(minMaxSpan.maxSpan, percentExtent, viewExtend, true) : null);
    var lastRange = this._range;
    var range3 = this._range = asc$2([linearMap$2(handleEnds[0], viewExtend, percentExtent, true), linearMap$2(handleEnds[1], viewExtend, percentExtent, true)]);
    return !lastRange || lastRange[0] !== range3[0] || lastRange[1] !== range3[1];
  };
  SliderZoomView2.prototype._updateView = function(nonRealtime) {
    var displaybles = this._displayables;
    var handleEnds = this._handleEnds;
    var handleInterval = asc$2(handleEnds.slice());
    var size = this._size;
    each$f([0, 1], function(handleIndex) {
      var handle = displaybles.handles[handleIndex];
      var handleHeight = this._handleHeight;
      handle.attr({
        scaleX: handleHeight / 2,
        scaleY: handleHeight / 2,
        x: handleEnds[handleIndex] + (handleIndex ? -1 : 1),
        y: size[1] / 2 - handleHeight / 2
      });
    }, this);
    displaybles.filler.setShape({
      x: handleInterval[0],
      y: 0,
      width: handleInterval[1] - handleInterval[0],
      height: size[1]
    });
    var viewExtent = {
      x: handleInterval[0],
      width: handleInterval[1] - handleInterval[0]
    };
    if (displaybles.moveHandle) {
      displaybles.moveHandle.setShape(viewExtent);
      displaybles.moveZone.setShape(viewExtent);
      displaybles.moveZone.getBoundingRect();
      displaybles.moveHandleIcon && displaybles.moveHandleIcon.attr("x", viewExtent.x + viewExtent.width / 2);
    }
    var dataShadowSegs = displaybles.dataShadowSegs;
    var segIntervals = [0, handleInterval[0], handleInterval[1], size[0]];
    for (var i = 0; i < dataShadowSegs.length; i++) {
      var segGroup = dataShadowSegs[i];
      var clipPath = segGroup.getClipPath();
      if (!clipPath) {
        clipPath = new Rect$3();
        segGroup.setClipPath(clipPath);
      }
      clipPath.setShape({
        x: segIntervals[i],
        y: 0,
        width: segIntervals[i + 1] - segIntervals[i],
        height: size[1]
      });
    }
    this._updateDataInfo(nonRealtime);
  };
  SliderZoomView2.prototype._updateDataInfo = function(nonRealtime) {
    var dataZoomModel = this.dataZoomModel;
    var displaybles = this._displayables;
    var handleLabels = displaybles.handleLabels;
    var orient = this._orient;
    var labelTexts = ["", ""];
    if (dataZoomModel.get("showDetail")) {
      var axisProxy = dataZoomModel.findRepresentativeAxisProxy();
      if (axisProxy) {
        var axis = axisProxy.getAxisModel().axis;
        var range3 = this._range;
        var dataInterval = nonRealtime ? axisProxy.calculateDataWindow({
          start: range3[0],
          end: range3[1]
        }).valueWindow : axisProxy.getDataValueWindow();
        labelTexts = [this._formatLabel(dataInterval[0], axis), this._formatLabel(dataInterval[1], axis)];
      }
    }
    var orderedHandleEnds = asc$2(this._handleEnds.slice());
    setLabel.call(this, 0);
    setLabel.call(this, 1);
    function setLabel(handleIndex) {
      var barTransform = getTransform$1(displaybles.handles[handleIndex].parent, this.group);
      var direction = transformDirection(handleIndex === 0 ? "right" : "left", barTransform);
      var offset = this._handleWidth / 2 + LABEL_GAP;
      var textPoint = applyTransform([orderedHandleEnds[handleIndex] + (handleIndex === 0 ? -offset : offset), this._size[1] / 2], barTransform);
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        verticalAlign: orient === HORIZONTAL ? "middle" : direction,
        align: orient === HORIZONTAL ? direction : "center",
        text: labelTexts[handleIndex]
      });
    }
  };
  SliderZoomView2.prototype._formatLabel = function(value, axis) {
    var dataZoomModel = this.dataZoomModel;
    var labelFormatter = dataZoomModel.get("labelFormatter");
    var labelPrecision = dataZoomModel.get("labelPrecision");
    if (labelPrecision == null || labelPrecision === "auto") {
      labelPrecision = axis.getPixelPrecision();
    }
    var valueStr = value == null || isNaN(value) ? "" : axis.type === "category" || axis.type === "time" ? axis.scale.getLabel({
      value: Math.round(value)
    }) : value.toFixed(Math.min(labelPrecision, 20));
    return isFunction(labelFormatter) ? labelFormatter(value, valueStr) : isString(labelFormatter) ? labelFormatter.replace("{value}", valueStr) : valueStr;
  };
  SliderZoomView2.prototype._showDataInfo = function(showOrHide) {
    showOrHide = this._dragging || showOrHide;
    var displayables = this._displayables;
    var handleLabels = displayables.handleLabels;
    handleLabels[0].attr("invisible", !showOrHide);
    handleLabels[1].attr("invisible", !showOrHide);
    displayables.moveHandle && this.api[showOrHide ? "enterEmphasis" : "leaveEmphasis"](displayables.moveHandle, 1);
  };
  SliderZoomView2.prototype._onDragMove = function(handleIndex, dx, dy, event) {
    this._dragging = true;
    stop(event.event);
    var barTransform = this._displayables.sliderGroup.getLocalTransform();
    var vertex = applyTransform([dx, dy], barTransform, true);
    var changed = this._updateInterval(handleIndex, vertex[0]);
    var realtime = this.dataZoomModel.get("realtime");
    this._updateView(!realtime);
    changed && realtime && this._dispatchZoomAction(true);
  };
  SliderZoomView2.prototype._onDragEnd = function() {
    this._dragging = false;
    this._showDataInfo(false);
    var realtime = this.dataZoomModel.get("realtime");
    !realtime && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onClickPanel = function(e2) {
    var size = this._size;
    var localPoint = this._displayables.sliderGroup.transformCoordToLocal(e2.offsetX, e2.offsetY);
    if (localPoint[0] < 0 || localPoint[0] > size[0] || localPoint[1] < 0 || localPoint[1] > size[1]) {
      return;
    }
    var handleEnds = this._handleEnds;
    var center2 = (handleEnds[0] + handleEnds[1]) / 2;
    var changed = this._updateInterval("all", localPoint[0] - center2);
    this._updateView();
    changed && this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrushStart = function(e2) {
    var x2 = e2.offsetX;
    var y2 = e2.offsetY;
    this._brushStart = new Point$1(x2, y2);
    this._brushing = true;
    this._brushStartTime = +new Date();
  };
  SliderZoomView2.prototype._onBrushEnd = function(e2) {
    if (!this._brushing) {
      return;
    }
    var brushRect = this._displayables.brushRect;
    this._brushing = false;
    if (!brushRect) {
      return;
    }
    brushRect.attr("ignore", true);
    var brushShape = brushRect.shape;
    var brushEndTime = +new Date();
    if (brushEndTime - this._brushStartTime < 200 && Math.abs(brushShape.width) < 5) {
      return;
    }
    var viewExtend = this._getViewExtent();
    var percentExtent = [0, 100];
    this._range = asc$2([linearMap$2(brushShape.x, viewExtend, percentExtent, true), linearMap$2(brushShape.x + brushShape.width, viewExtend, percentExtent, true)]);
    this._handleEnds = [brushShape.x, brushShape.x + brushShape.width];
    this._updateView();
    this._dispatchZoomAction(false);
  };
  SliderZoomView2.prototype._onBrush = function(e2) {
    if (this._brushing) {
      stop(e2.event);
      this._updateBrushRect(e2.offsetX, e2.offsetY);
    }
  };
  SliderZoomView2.prototype._updateBrushRect = function(mouseX, mouseY) {
    var displayables = this._displayables;
    var dataZoomModel = this.dataZoomModel;
    var brushRect = displayables.brushRect;
    if (!brushRect) {
      brushRect = displayables.brushRect = new Rect({
        silent: true,
        style: dataZoomModel.getModel("brushStyle").getItemStyle()
      });
      displayables.sliderGroup.add(brushRect);
    }
    brushRect.attr("ignore", false);
    var brushStart = this._brushStart;
    var sliderGroup = this._displayables.sliderGroup;
    var endPoint = sliderGroup.transformCoordToLocal(mouseX, mouseY);
    var startPoint = sliderGroup.transformCoordToLocal(brushStart.x, brushStart.y);
    var size = this._size;
    endPoint[0] = Math.max(Math.min(size[0], endPoint[0]), 0);
    brushRect.setShape({
      x: startPoint[0],
      y: 0,
      width: endPoint[0] - startPoint[0],
      height: size[1]
    });
  };
  SliderZoomView2.prototype._dispatchZoomAction = function(realtime) {
    var range3 = this._range;
    this.api.dispatchAction({
      type: "dataZoom",
      from: this.uid,
      dataZoomId: this.dataZoomModel.id,
      animation: realtime ? REALTIME_ANIMATION_CONFIG : null,
      start: range3[0],
      end: range3[1]
    });
  };
  SliderZoomView2.prototype._findCoordRect = function() {
    var rect;
    var coordSysInfoList = collectReferCoordSysModelInfo(this.dataZoomModel).infoList;
    if (!rect && coordSysInfoList.length) {
      var coordSys = coordSysInfoList[0].model.coordinateSystem;
      rect = coordSys.getRect && coordSys.getRect();
    }
    if (!rect) {
      var width = this.api.getWidth();
      var height = this.api.getHeight();
      rect = {
        x: width * 0.2,
        y: height * 0.2,
        width: width * 0.6,
        height: height * 0.6
      };
    }
    return rect;
  };
  SliderZoomView2.type = "dataZoom.slider";
  return SliderZoomView2;
}(DataZoomView$1);
function getOtherDim(thisDim) {
  var map2 = {
    x: "y",
    y: "x",
    radius: "angle",
    angle: "radius"
  };
  return map2[thisDim];
}
function getCursor$1(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var SliderZoomView$1 = SliderZoomView;
function install$7(registers) {
  registers.registerComponentModel(SliderZoomModel$1);
  registers.registerComponentView(SliderZoomView$1);
  installCommon$1(registers);
}
function install$6(registers) {
  use(install$8);
  use(install$7);
}
var visualDefault = {
  get: function(visualType, key, isCategory2) {
    var value = clone$4((defaultOption[visualType] || {})[key]);
    return isCategory2 ? isArray$1(value) ? value[value.length - 1] : value : value;
  }
};
var defaultOption = {
  color: {
    active: ["#006edd", "#e0ffff"],
    inactive: ["rgba(0,0,0,0)"]
  },
  colorHue: {
    active: [0, 360],
    inactive: [0, 0]
  },
  colorSaturation: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  colorLightness: {
    active: [0.9, 0.5],
    inactive: [0, 0]
  },
  colorAlpha: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  opacity: {
    active: [0.3, 1],
    inactive: [0, 0]
  },
  symbol: {
    active: ["circle", "roundRect", "diamond"],
    inactive: ["none"]
  },
  symbolSize: {
    active: [10, 50],
    inactive: [0, 0]
  }
};
var visualDefault$1 = visualDefault;
var mapVisual = VisualMapping$1.mapVisual;
var eachVisual = VisualMapping$1.eachVisual;
var isArray = isArray$1;
var each$2 = each$f;
var asc = asc$2;
var linearMap$1 = linearMap$2;
var VisualMapModel = function(_super) {
  __extends(VisualMapModel2, _super);
  function VisualMapModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapModel2.type;
    _this.stateList = ["inRange", "outOfRange"];
    _this.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"];
    _this.layoutMode = {
      type: "box",
      ignoreSize: true
    };
    _this.dataBound = [-Infinity, Infinity];
    _this.targetVisuals = {};
    _this.controllerVisuals = {};
    return _this;
  }
  VisualMapModel2.prototype.init = function(option, parentModel, ecModel) {
    this.mergeDefaultAndTheme(option, ecModel);
  };
  VisualMapModel2.prototype.optionUpdated = function(newOption, isInit) {
    var thisOption = this.option;
    !isInit && replaceVisualOption(thisOption, newOption, this.replacableOptionKeys);
    this.textStyleModel = this.getModel("textStyle");
    this.resetItemSize();
    this.completeVisualOption();
  };
  VisualMapModel2.prototype.resetVisual = function(supplementVisualOption) {
    var stateList = this.stateList;
    supplementVisualOption = bind$1(supplementVisualOption, this);
    this.controllerVisuals = createVisualMappings(this.option.controller, stateList, supplementVisualOption);
    this.targetVisuals = createVisualMappings(this.option.target, stateList, supplementVisualOption);
  };
  VisualMapModel2.prototype.getItemSymbol = function() {
    return null;
  };
  VisualMapModel2.prototype.getTargetSeriesIndices = function() {
    var optionSeriesIndex = this.option.seriesIndex;
    var seriesIndices = [];
    if (optionSeriesIndex == null || optionSeriesIndex === "all") {
      this.ecModel.eachSeries(function(seriesModel, index2) {
        seriesIndices.push(index2);
      });
    } else {
      seriesIndices = normalizeToArray(optionSeriesIndex);
    }
    return seriesIndices;
  };
  VisualMapModel2.prototype.eachTargetSeries = function(callback, context) {
    each$f(this.getTargetSeriesIndices(), function(seriesIndex) {
      var seriesModel = this.ecModel.getSeriesByIndex(seriesIndex);
      if (seriesModel) {
        callback.call(context, seriesModel);
      }
    }, this);
  };
  VisualMapModel2.prototype.isTargetSeries = function(seriesModel) {
    var is = false;
    this.eachTargetSeries(function(model) {
      model === seriesModel && (is = true);
    });
    return is;
  };
  VisualMapModel2.prototype.formatValueText = function(value, isCategory2, edgeSymbols) {
    var option = this.option;
    var precision = option.precision;
    var dataBound = this.dataBound;
    var formatter = option.formatter;
    var isMinMax;
    edgeSymbols = edgeSymbols || ["<", ">"];
    if (isArray$1(value)) {
      value = value.slice();
      isMinMax = true;
    }
    var textValue = isCategory2 ? value : isMinMax ? [toFixed(value[0]), toFixed(value[1])] : toFixed(value);
    if (isString(formatter)) {
      return formatter.replace("{value}", isMinMax ? textValue[0] : textValue).replace("{value2}", isMinMax ? textValue[1] : textValue);
    } else if (isFunction(formatter)) {
      return isMinMax ? formatter(value[0], value[1]) : formatter(value);
    }
    if (isMinMax) {
      if (value[0] === dataBound[0]) {
        return edgeSymbols[0] + " " + textValue[1];
      } else if (value[1] === dataBound[1]) {
        return edgeSymbols[1] + " " + textValue[0];
      } else {
        return textValue[0] + " - " + textValue[1];
      }
    } else {
      return textValue;
    }
    function toFixed(val) {
      return val === dataBound[0] ? "min" : val === dataBound[1] ? "max" : (+val).toFixed(Math.min(precision, 20));
    }
  };
  VisualMapModel2.prototype.resetExtent = function() {
    var thisOption = this.option;
    var extent3 = asc([thisOption.min, thisOption.max]);
    this._dataExtent = extent3;
  };
  VisualMapModel2.prototype.getDataDimensionIndex = function(data) {
    var optDim = this.option.dimension;
    if (optDim != null) {
      return data.getDimensionIndex(optDim);
    }
    var dimNames = data.dimensions;
    for (var i = dimNames.length - 1; i >= 0; i--) {
      var dimName = dimNames[i];
      var dimInfo = data.getDimensionInfo(dimName);
      if (!dimInfo.isCalculationCoord) {
        return dimInfo.storeDimIndex;
      }
    }
  };
  VisualMapModel2.prototype.getExtent = function() {
    return this._dataExtent.slice();
  };
  VisualMapModel2.prototype.completeVisualOption = function() {
    var ecModel = this.ecModel;
    var thisOption = this.option;
    var base2 = {
      inRange: thisOption.inRange,
      outOfRange: thisOption.outOfRange
    };
    var target = thisOption.target || (thisOption.target = {});
    var controller = thisOption.controller || (thisOption.controller = {});
    merge(target, base2);
    merge(controller, base2);
    var isCategory2 = this.isCategory();
    completeSingle.call(this, target);
    completeSingle.call(this, controller);
    completeInactive.call(this, target, "inRange", "outOfRange");
    completeController.call(this, controller);
    function completeSingle(base3) {
      if (isArray(thisOption.color) && !base3.inRange) {
        base3.inRange = {
          color: thisOption.color.slice().reverse()
        };
      }
      base3.inRange = base3.inRange || {
        color: ecModel.get("gradientColor")
      };
    }
    function completeInactive(base3, stateExist, stateAbsent) {
      var optExist = base3[stateExist];
      var optAbsent = base3[stateAbsent];
      if (optExist && !optAbsent) {
        optAbsent = base3[stateAbsent] = {};
        each$2(optExist, function(visualData, visualType) {
          if (!VisualMapping$1.isValidType(visualType)) {
            return;
          }
          var defa = visualDefault$1.get(visualType, "inactive", isCategory2);
          if (defa != null) {
            optAbsent[visualType] = defa;
            if (visualType === "color" && !optAbsent.hasOwnProperty("opacity") && !optAbsent.hasOwnProperty("colorAlpha")) {
              optAbsent.opacity = [0, 0];
            }
          }
        });
      }
    }
    function completeController(controller2) {
      var symbolExists = (controller2.inRange || {}).symbol || (controller2.outOfRange || {}).symbol;
      var symbolSizeExists = (controller2.inRange || {}).symbolSize || (controller2.outOfRange || {}).symbolSize;
      var inactiveColor = this.get("inactiveColor");
      var itemSymbol = this.getItemSymbol();
      var defaultSymbol = itemSymbol || "roundRect";
      each$2(this.stateList, function(state) {
        var itemSize = this.itemSize;
        var visuals = controller2[state];
        if (!visuals) {
          visuals = controller2[state] = {
            color: isCategory2 ? inactiveColor : [inactiveColor]
          };
        }
        if (visuals.symbol == null) {
          visuals.symbol = symbolExists && clone$4(symbolExists) || (isCategory2 ? defaultSymbol : [defaultSymbol]);
        }
        if (visuals.symbolSize == null) {
          visuals.symbolSize = symbolSizeExists && clone$4(symbolSizeExists) || (isCategory2 ? itemSize[0] : [itemSize[0], itemSize[0]]);
        }
        visuals.symbol = mapVisual(visuals.symbol, function(symbol) {
          return symbol === "none" ? defaultSymbol : symbol;
        });
        var symbolSize = visuals.symbolSize;
        if (symbolSize != null) {
          var max_1 = -Infinity;
          eachVisual(symbolSize, function(value) {
            value > max_1 && (max_1 = value);
          });
          visuals.symbolSize = mapVisual(symbolSize, function(value) {
            return linearMap$1(value, [0, max_1], [0, itemSize[0]], true);
          });
        }
      }, this);
    }
  };
  VisualMapModel2.prototype.resetItemSize = function() {
    this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
  };
  VisualMapModel2.prototype.isCategory = function() {
    return !!this.option.categories;
  };
  VisualMapModel2.prototype.setSelected = function(selected) {
  };
  VisualMapModel2.prototype.getSelected = function() {
    return null;
  };
  VisualMapModel2.prototype.getValueState = function(value) {
    return null;
  };
  VisualMapModel2.prototype.getVisualMeta = function(getColorVisual2) {
    return null;
  };
  VisualMapModel2.type = "visualMap";
  VisualMapModel2.dependencies = ["series"];
  VisualMapModel2.defaultOption = {
    show: true,
    z: 4,
    seriesIndex: "all",
    min: 0,
    max: 200,
    left: 0,
    right: null,
    top: null,
    bottom: 0,
    itemWidth: null,
    itemHeight: null,
    inverse: false,
    orient: "vertical",
    backgroundColor: "rgba(0,0,0,0)",
    borderColor: "#ccc",
    contentColor: "#5793f3",
    inactiveColor: "#aaa",
    borderWidth: 0,
    padding: 5,
    textGap: 10,
    precision: 0,
    textStyle: {
      color: "#333"
    }
  };
  return VisualMapModel2;
}(ComponentModel$1);
var VisualMapModel$1 = VisualMapModel;
var DEFAULT_BAR_BOUND = [20, 140];
var ContinuousModel = function(_super) {
  __extends(ContinuousModel2, _super);
  function ContinuousModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousModel2.type;
    return _this;
  }
  ContinuousModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    this.resetVisual(function(mappingOption) {
      mappingOption.mappingMethod = "linear";
      mappingOption.dataExtent = this.getExtent();
    });
    this._resetRange();
  };
  ContinuousModel2.prototype.resetItemSize = function() {
    _super.prototype.resetItemSize.apply(this, arguments);
    var itemSize = this.itemSize;
    (itemSize[0] == null || isNaN(itemSize[0])) && (itemSize[0] = DEFAULT_BAR_BOUND[0]);
    (itemSize[1] == null || isNaN(itemSize[1])) && (itemSize[1] = DEFAULT_BAR_BOUND[1]);
  };
  ContinuousModel2.prototype._resetRange = function() {
    var dataExtent = this.getExtent();
    var range3 = this.option.range;
    if (!range3 || range3.auto) {
      dataExtent.auto = 1;
      this.option.range = dataExtent;
    } else if (isArray$1(range3)) {
      if (range3[0] > range3[1]) {
        range3.reverse();
      }
      range3[0] = Math.max(range3[0], dataExtent[0]);
      range3[1] = Math.min(range3[1], dataExtent[1]);
    }
  };
  ContinuousModel2.prototype.completeVisualOption = function() {
    _super.prototype.completeVisualOption.apply(this, arguments);
    each$f(this.stateList, function(state) {
      var symbolSize = this.option.controller[state].symbolSize;
      if (symbolSize && symbolSize[0] !== symbolSize[1]) {
        symbolSize[0] = symbolSize[1] / 3;
      }
    }, this);
  };
  ContinuousModel2.prototype.setSelected = function(selected) {
    this.option.range = selected.slice();
    this._resetRange();
  };
  ContinuousModel2.prototype.getSelected = function() {
    var dataExtent = this.getExtent();
    var dataInterval = asc$2((this.get("range") || []).slice());
    dataInterval[0] > dataExtent[1] && (dataInterval[0] = dataExtent[1]);
    dataInterval[1] > dataExtent[1] && (dataInterval[1] = dataExtent[1]);
    dataInterval[0] < dataExtent[0] && (dataInterval[0] = dataExtent[0]);
    dataInterval[1] < dataExtent[0] && (dataInterval[1] = dataExtent[0]);
    return dataInterval;
  };
  ContinuousModel2.prototype.getValueState = function(value) {
    var range3 = this.option.range;
    var dataExtent = this.getExtent();
    return (range3[0] <= dataExtent[0] || range3[0] <= value) && (range3[1] >= dataExtent[1] || value <= range3[1]) ? "inRange" : "outOfRange";
  };
  ContinuousModel2.prototype.findTargetDataIndices = function(range3) {
    var result = [];
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        range3[0] <= value && value <= range3[1] && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  ContinuousModel2.prototype.getVisualMeta = function(getColorVisual2) {
    var oVals = getColorStopValues(this, "outOfRange", this.getExtent());
    var iVals = getColorStopValues(this, "inRange", this.option.range.slice());
    var stops = [];
    function setStop(value, valueState) {
      stops.push({
        value,
        color: getColorVisual2(value, valueState)
      });
    }
    var iIdx = 0;
    var oIdx = 0;
    var iLen = iVals.length;
    var oLen = oVals.length;
    for (; oIdx < oLen && (!iVals.length || oVals[oIdx] <= iVals[0]); oIdx++) {
      if (oVals[oIdx] < iVals[iIdx]) {
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    for (var first = 1; iIdx < iLen; iIdx++, first = 0) {
      first && stops.length && setStop(iVals[iIdx], "outOfRange");
      setStop(iVals[iIdx], "inRange");
    }
    for (var first = 1; oIdx < oLen; oIdx++) {
      if (!iVals.length || iVals[iVals.length - 1] < oVals[oIdx]) {
        if (first) {
          stops.length && setStop(stops[stops.length - 1].value, "outOfRange");
          first = 0;
        }
        setStop(oVals[oIdx], "outOfRange");
      }
    }
    var stopsLen = stops.length;
    return {
      stops,
      outerColors: [stopsLen ? stops[0].color : "transparent", stopsLen ? stops[stopsLen - 1].color : "transparent"]
    };
  };
  ContinuousModel2.type = "visualMap.continuous";
  ContinuousModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    align: "auto",
    calculable: false,
    hoverLink: true,
    realtime: true,
    handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z",
    handleSize: "120%",
    handleStyle: {
      borderColor: "#fff",
      borderWidth: 1
    },
    indicatorIcon: "circle",
    indicatorSize: "50%",
    indicatorStyle: {
      borderColor: "#fff",
      borderWidth: 2,
      shadowBlur: 2,
      shadowOffsetX: 1,
      shadowOffsetY: 1,
      shadowColor: "rgba(0,0,0,0.2)"
    }
  });
  return ContinuousModel2;
}(VisualMapModel$1);
function getColorStopValues(visualMapModel, valueState, dataExtent) {
  if (dataExtent[0] === dataExtent[1]) {
    return dataExtent.slice();
  }
  var count2 = 200;
  var step = (dataExtent[1] - dataExtent[0]) / count2;
  var value = dataExtent[0];
  var stopValues = [];
  for (var i = 0; i <= count2 && value < dataExtent[1]; i++) {
    stopValues.push(value);
    value += step;
  }
  stopValues.push(dataExtent[1]);
  return stopValues;
}
var ContinuousModel$1 = ContinuousModel;
var VisualMapView = function(_super) {
  __extends(VisualMapView2, _super);
  function VisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = VisualMapView2.type;
    _this.autoPositionValues = {
      left: 1,
      right: 1,
      top: 1,
      bottom: 1
    };
    return _this;
  }
  VisualMapView2.prototype.init = function(ecModel, api) {
    this.ecModel = ecModel;
    this.api = api;
  };
  VisualMapView2.prototype.render = function(visualMapModel, ecModel, api, payload) {
    this.visualMapModel = visualMapModel;
    if (visualMapModel.get("show") === false) {
      this.group.removeAll();
      return;
    }
    this.doRender(visualMapModel, ecModel, api, payload);
  };
  VisualMapView2.prototype.renderBackground = function(group) {
    var visualMapModel = this.visualMapModel;
    var padding = normalizeCssArray(visualMapModel.get("padding") || 0);
    var rect = group.getBoundingRect();
    group.add(new Rect$3({
      z2: -1,
      silent: true,
      shape: {
        x: rect.x - padding[3],
        y: rect.y - padding[0],
        width: rect.width + padding[3] + padding[1],
        height: rect.height + padding[0] + padding[2]
      },
      style: {
        fill: visualMapModel.get("backgroundColor"),
        stroke: visualMapModel.get("borderColor"),
        lineWidth: visualMapModel.get("borderWidth")
      }
    }));
  };
  VisualMapView2.prototype.getControllerVisual = function(targetValue, visualCluster, opts) {
    opts = opts || {};
    var forceState = opts.forceState;
    var visualMapModel = this.visualMapModel;
    var visualObj = {};
    if (visualCluster === "color") {
      var defaultColor = visualMapModel.get("contentColor");
      visualObj.color = defaultColor;
    }
    function getter(key) {
      return visualObj[key];
    }
    function setter(key, value) {
      visualObj[key] = value;
    }
    var mappings = visualMapModel.controllerVisuals[forceState || visualMapModel.getValueState(targetValue)];
    var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
    each$f(visualTypes, function(type4) {
      var visualMapping = mappings[type4];
      if (opts.convertOpacityToAlpha && type4 === "opacity") {
        type4 = "colorAlpha";
        visualMapping = mappings.__alphaForOpacity;
      }
      if (VisualMapping$1.dependsOn(type4, visualCluster)) {
        visualMapping && visualMapping.applyVisual(targetValue, getter, setter);
      }
    });
    return visualObj[visualCluster];
  };
  VisualMapView2.prototype.positionGroup = function(group) {
    var model = this.visualMapModel;
    var api = this.api;
    positionElement(group, model.getBoxLayoutParams(), {
      width: api.getWidth(),
      height: api.getHeight()
    });
  };
  VisualMapView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
  };
  VisualMapView2.type = "visualMap";
  return VisualMapView2;
}(ComponentView$1);
var VisualMapView$1 = VisualMapView;
var paramsSet = [["left", "right", "width"], ["top", "bottom", "height"]];
function getItemAlign(visualMapModel, api, itemSize) {
  var modelOption = visualMapModel.option;
  var itemAlign = modelOption.align;
  if (itemAlign != null && itemAlign !== "auto") {
    return itemAlign;
  }
  var ecSize = {
    width: api.getWidth(),
    height: api.getHeight()
  };
  var realIndex = modelOption.orient === "horizontal" ? 1 : 0;
  var reals = paramsSet[realIndex];
  var fakeValue = [0, null, 10];
  var layoutInput = {};
  for (var i = 0; i < 3; i++) {
    layoutInput[paramsSet[1 - realIndex][i]] = fakeValue[i];
    layoutInput[reals[i]] = i === 2 ? itemSize[0] : modelOption[reals[i]];
  }
  var rParam = [["x", "width", 3], ["y", "height", 0]][realIndex];
  var rect = getLayoutRect(layoutInput, ecSize, modelOption.padding);
  return reals[(rect.margin[rParam[2]] || 0) + rect[rParam[0]] + rect[rParam[1]] * 0.5 < ecSize[rParam[1]] * 0.5 ? 0 : 1];
}
function makeHighDownBatch(batch, visualMapModel) {
  each$f(batch || [], function(batchItem) {
    if (batchItem.dataIndex != null) {
      batchItem.dataIndexInside = batchItem.dataIndex;
      batchItem.dataIndex = null;
    }
    batchItem.highlightKey = "visualMap" + (visualMapModel ? visualMapModel.componentIndex : "");
  });
  return batch;
}
var linearMap = linearMap$2;
var each$1 = each$f;
var mathMin = Math.min;
var mathMax = Math.max;
var HOVER_LINK_SIZE = 12;
var HOVER_LINK_OUT = 6;
var ContinuousView = function(_super) {
  __extends(ContinuousView2, _super);
  function ContinuousView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = ContinuousView2.type;
    _this._shapes = {};
    _this._dataInterval = [];
    _this._handleEnds = [];
    _this._hoverLinkDataIndices = [];
    return _this;
  }
  ContinuousView2.prototype.doRender = function(visualMapModel, ecModel, api, payload) {
    this._api = api;
    if (!payload || payload.type !== "selectDataRange" || payload.from !== this.uid) {
      this._buildView();
    }
  };
  ContinuousView2.prototype._buildView = function() {
    this.group.removeAll();
    var visualMapModel = this.visualMapModel;
    var thisGroup = this.group;
    this._orient = visualMapModel.get("orient");
    this._useHandle = visualMapModel.get("calculable");
    this._resetInterval();
    this._renderBar(thisGroup);
    var dataRangeText = visualMapModel.get("text");
    this._renderEndsText(thisGroup, dataRangeText, 0);
    this._renderEndsText(thisGroup, dataRangeText, 1);
    this._updateView(true);
    this.renderBackground(thisGroup);
    this._updateView();
    this._enableHoverLinkToSeries();
    this._enableHoverLinkFromSeries();
    this.positionGroup(thisGroup);
  };
  ContinuousView2.prototype._renderEndsText = function(group, dataRangeText, endsIndex) {
    if (!dataRangeText) {
      return;
    }
    var text = dataRangeText[1 - endsIndex];
    text = text != null ? text + "" : "";
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var itemSize = visualMapModel.itemSize;
    var barGroup = this._shapes.mainGroup;
    var position2 = this._applyTransform([itemSize[0] / 2, endsIndex === 0 ? -textGap : itemSize[1] + textGap], barGroup);
    var align = this._applyTransform(endsIndex === 0 ? "bottom" : "top", barGroup);
    var orient = this._orient;
    var textStyleModel = this.visualMapModel.textStyleModel;
    this.group.add(new ZRText$1({
      style: {
        x: position2[0],
        y: position2[1],
        verticalAlign: orient === "horizontal" ? "middle" : align,
        align: orient === "horizontal" ? align : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
  };
  ContinuousView2.prototype._renderBar = function(targetGroup) {
    var visualMapModel = this.visualMapModel;
    var shapes = this._shapes;
    var itemSize = visualMapModel.itemSize;
    var orient = this._orient;
    var useHandle = this._useHandle;
    var itemAlign = getItemAlign(visualMapModel, this.api, itemSize);
    var mainGroup = shapes.mainGroup = this._createBarGroup(itemAlign);
    var gradientBarGroup = new Group$4();
    mainGroup.add(gradientBarGroup);
    gradientBarGroup.add(shapes.outOfRange = createPolygon());
    gradientBarGroup.add(shapes.inRange = createPolygon(null, useHandle ? getCursor(this._orient) : null, bind$1(this._dragHandle, this, "all", false), bind$1(this._dragHandle, this, "all", true)));
    gradientBarGroup.setClipPath(new Rect$3({
      shape: {
        x: 0,
        y: 0,
        width: itemSize[0],
        height: itemSize[1],
        r: 3
      }
    }));
    var textRect = visualMapModel.textStyleModel.getTextRect("\u56FD");
    var textSize = mathMax(textRect.width, textRect.height);
    if (useHandle) {
      shapes.handleThumbs = [];
      shapes.handleLabels = [];
      shapes.handleLabelPoints = [];
      this._createHandle(visualMapModel, mainGroup, 0, itemSize, textSize, orient);
      this._createHandle(visualMapModel, mainGroup, 1, itemSize, textSize, orient);
    }
    this._createIndicator(visualMapModel, mainGroup, itemSize, textSize, orient);
    targetGroup.add(mainGroup);
  };
  ContinuousView2.prototype._createHandle = function(visualMapModel, mainGroup, handleIndex, itemSize, textSize, orient) {
    var onDrift = bind$1(this._dragHandle, this, handleIndex, false);
    var onDragEnd = bind$1(this._dragHandle, this, handleIndex, true);
    var handleSize = parsePercent$1(visualMapModel.get("handleSize"), itemSize[0]);
    var handleThumb = createSymbol$1(visualMapModel.get("handleIcon"), -handleSize / 2, -handleSize / 2, handleSize, handleSize, null, true);
    var cursor = getCursor(this._orient);
    handleThumb.attr({
      cursor,
      draggable: true,
      drift: onDrift,
      ondragend: onDragEnd,
      onmousemove: function(e2) {
        stop(e2.event);
      }
    });
    handleThumb.x = itemSize[0] / 2;
    handleThumb.useStyle(visualMapModel.getModel("handleStyle").getItemStyle());
    handleThumb.setStyle({
      strokeNoScale: true,
      strokeFirst: true
    });
    handleThumb.style.lineWidth *= 2;
    handleThumb.ensureState("emphasis").style = visualMapModel.getModel(["emphasis", "handleStyle"]).getItemStyle();
    setAsHighDownDispatcher(handleThumb, true);
    mainGroup.add(handleThumb);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var handleLabel = new ZRText$1({
      cursor,
      draggable: true,
      drift: onDrift,
      onmousemove: function(e2) {
        stop(e2.event);
      },
      ondragend: onDragEnd,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    handleLabel.ensureState("blur").style = {
      opacity: 0.1
    };
    handleLabel.stateTransition = {
      duration: 200
    };
    this.group.add(handleLabel);
    var handleLabelPoint = [handleSize, 0];
    var shapes = this._shapes;
    shapes.handleThumbs[handleIndex] = handleThumb;
    shapes.handleLabelPoints[handleIndex] = handleLabelPoint;
    shapes.handleLabels[handleIndex] = handleLabel;
  };
  ContinuousView2.prototype._createIndicator = function(visualMapModel, mainGroup, itemSize, textSize, orient) {
    var scale2 = parsePercent$1(visualMapModel.get("indicatorSize"), itemSize[0]);
    var indicator = createSymbol$1(visualMapModel.get("indicatorIcon"), -scale2 / 2, -scale2 / 2, scale2, scale2, null, true);
    indicator.attr({
      cursor: "move",
      invisible: true,
      silent: true,
      x: itemSize[0] / 2
    });
    var indicatorStyle = visualMapModel.getModel("indicatorStyle").getItemStyle();
    if (indicator instanceof ZRImage$1) {
      var pathStyle = indicator.style;
      indicator.useStyle(extend({
        image: pathStyle.image,
        x: pathStyle.x,
        y: pathStyle.y,
        width: pathStyle.width,
        height: pathStyle.height
      }, indicatorStyle));
    } else {
      indicator.useStyle(indicatorStyle);
    }
    mainGroup.add(indicator);
    var textStyleModel = this.visualMapModel.textStyleModel;
    var indicatorLabel = new ZRText$1({
      silent: true,
      invisible: true,
      style: {
        x: 0,
        y: 0,
        text: "",
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    });
    this.group.add(indicatorLabel);
    var indicatorLabelPoint = [(orient === "horizontal" ? textSize / 2 : HOVER_LINK_OUT) + itemSize[0] / 2, 0];
    var shapes = this._shapes;
    shapes.indicator = indicator;
    shapes.indicatorLabel = indicatorLabel;
    shapes.indicatorLabelPoint = indicatorLabelPoint;
    this._firstShowIndicator = true;
  };
  ContinuousView2.prototype._dragHandle = function(handleIndex, isEnd, dx, dy) {
    if (!this._useHandle) {
      return;
    }
    this._dragging = !isEnd;
    if (!isEnd) {
      var vertex = this._applyTransform([dx, dy], this._shapes.mainGroup, true);
      this._updateInterval(handleIndex, vertex[1]);
      this._hideIndicator();
      this._updateView();
    }
    if (isEnd === !this.visualMapModel.get("realtime")) {
      this.api.dispatchAction({
        type: "selectDataRange",
        from: this.uid,
        visualMapId: this.visualMapModel.id,
        selected: this._dataInterval.slice()
      });
    }
    if (isEnd) {
      !this._hovering && this._clearHoverLinkToSeries();
    } else if (useHoverLinkOnHandle(this.visualMapModel)) {
      this._doHoverLinkToSeries(this._handleEnds[handleIndex], false);
    }
  };
  ContinuousView2.prototype._resetInterval = function() {
    var visualMapModel = this.visualMapModel;
    var dataInterval = this._dataInterval = visualMapModel.getSelected();
    var dataExtent = visualMapModel.getExtent();
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    this._handleEnds = [linearMap(dataInterval[0], dataExtent, sizeExtent, true), linearMap(dataInterval[1], dataExtent, sizeExtent, true)];
  };
  ContinuousView2.prototype._updateInterval = function(handleIndex, delta) {
    delta = delta || 0;
    var visualMapModel = this.visualMapModel;
    var handleEnds = this._handleEnds;
    var sizeExtent = [0, visualMapModel.itemSize[1]];
    sliderMove(delta, handleEnds, sizeExtent, handleIndex, 0);
    var dataExtent = visualMapModel.getExtent();
    this._dataInterval = [linearMap(handleEnds[0], sizeExtent, dataExtent, true), linearMap(handleEnds[1], sizeExtent, dataExtent, true)];
  };
  ContinuousView2.prototype._updateView = function(forSketch) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var shapes = this._shapes;
    var outOfRangeHandleEnds = [0, visualMapModel.itemSize[1]];
    var inRangeHandleEnds = forSketch ? outOfRangeHandleEnds : this._handleEnds;
    var visualInRange = this._createBarVisual(this._dataInterval, dataExtent, inRangeHandleEnds, "inRange");
    var visualOutOfRange = this._createBarVisual(dataExtent, dataExtent, outOfRangeHandleEnds, "outOfRange");
    shapes.inRange.setStyle({
      fill: visualInRange.barColor
    }).setShape("points", visualInRange.barPoints);
    shapes.outOfRange.setStyle({
      fill: visualOutOfRange.barColor
    }).setShape("points", visualOutOfRange.barPoints);
    this._updateHandle(inRangeHandleEnds, visualInRange);
  };
  ContinuousView2.prototype._createBarVisual = function(dataInterval, dataExtent, handleEnds, forceState) {
    var opts = {
      forceState,
      convertOpacityToAlpha: true
    };
    var colorStops = this._makeColorGradient(dataInterval, opts);
    var symbolSizes = [this.getControllerVisual(dataInterval[0], "symbolSize", opts), this.getControllerVisual(dataInterval[1], "symbolSize", opts)];
    var barPoints = this._createBarPoints(handleEnds, symbolSizes);
    return {
      barColor: new LinearGradient$1(0, 0, 0, 1, colorStops),
      barPoints,
      handlesColor: [colorStops[0].color, colorStops[colorStops.length - 1].color]
    };
  };
  ContinuousView2.prototype._makeColorGradient = function(dataInterval, opts) {
    var sampleNumber = 100;
    var colorStops = [];
    var step = (dataInterval[1] - dataInterval[0]) / sampleNumber;
    colorStops.push({
      color: this.getControllerVisual(dataInterval[0], "color", opts),
      offset: 0
    });
    for (var i = 1; i < sampleNumber; i++) {
      var currValue = dataInterval[0] + step * i;
      if (currValue > dataInterval[1]) {
        break;
      }
      colorStops.push({
        color: this.getControllerVisual(currValue, "color", opts),
        offset: i / sampleNumber
      });
    }
    colorStops.push({
      color: this.getControllerVisual(dataInterval[1], "color", opts),
      offset: 1
    });
    return colorStops;
  };
  ContinuousView2.prototype._createBarPoints = function(handleEnds, symbolSizes) {
    var itemSize = this.visualMapModel.itemSize;
    return [[itemSize[0] - symbolSizes[0], handleEnds[0]], [itemSize[0], handleEnds[0]], [itemSize[0], handleEnds[1]], [itemSize[0] - symbolSizes[1], handleEnds[1]]];
  };
  ContinuousView2.prototype._createBarGroup = function(itemAlign) {
    var orient = this._orient;
    var inverse = this.visualMapModel.get("inverse");
    return new Group$4(orient === "horizontal" && !inverse ? {
      scaleX: itemAlign === "bottom" ? 1 : -1,
      rotation: Math.PI / 2
    } : orient === "horizontal" && inverse ? {
      scaleX: itemAlign === "bottom" ? -1 : 1,
      rotation: -Math.PI / 2
    } : orient === "vertical" && !inverse ? {
      scaleX: itemAlign === "left" ? 1 : -1,
      scaleY: -1
    } : {
      scaleX: itemAlign === "left" ? 1 : -1
    });
  };
  ContinuousView2.prototype._updateHandle = function(handleEnds, visualInRange) {
    if (!this._useHandle) {
      return;
    }
    var shapes = this._shapes;
    var visualMapModel = this.visualMapModel;
    var handleThumbs = shapes.handleThumbs;
    var handleLabels = shapes.handleLabels;
    var itemSize = visualMapModel.itemSize;
    var dataExtent = visualMapModel.getExtent();
    each$1([0, 1], function(handleIndex) {
      var handleThumb = handleThumbs[handleIndex];
      handleThumb.setStyle("fill", visualInRange.handlesColor[handleIndex]);
      handleThumb.y = handleEnds[handleIndex];
      var val = linearMap(handleEnds[handleIndex], [0, itemSize[1]], dataExtent, true);
      var symbolSize = this.getControllerVisual(val, "symbolSize");
      handleThumb.scaleX = handleThumb.scaleY = symbolSize / itemSize[0];
      handleThumb.x = itemSize[0] - symbolSize / 2;
      var textPoint = applyTransform(shapes.handleLabelPoints[handleIndex], getTransform$1(handleThumb, this.group));
      handleLabels[handleIndex].setStyle({
        x: textPoint[0],
        y: textPoint[1],
        text: visualMapModel.formatValueText(this._dataInterval[handleIndex]),
        verticalAlign: "middle",
        align: this._orient === "vertical" ? this._applyTransform("left", shapes.mainGroup) : "center"
      });
    }, this);
  };
  ContinuousView2.prototype._showIndicator = function(cursorValue, textValue, rangeSymbol, halfHoverLinkSize) {
    var visualMapModel = this.visualMapModel;
    var dataExtent = visualMapModel.getExtent();
    var itemSize = visualMapModel.itemSize;
    var sizeExtent = [0, itemSize[1]];
    var shapes = this._shapes;
    var indicator = shapes.indicator;
    if (!indicator) {
      return;
    }
    indicator.attr("invisible", false);
    var opts = {
      convertOpacityToAlpha: true
    };
    var color = this.getControllerVisual(cursorValue, "color", opts);
    var symbolSize = this.getControllerVisual(cursorValue, "symbolSize");
    var y2 = linearMap(cursorValue, dataExtent, sizeExtent, true);
    var x2 = itemSize[0] - symbolSize / 2;
    var oldIndicatorPos = {
      x: indicator.x,
      y: indicator.y
    };
    indicator.y = y2;
    indicator.x = x2;
    var textPoint = applyTransform(shapes.indicatorLabelPoint, getTransform$1(indicator, this.group));
    var indicatorLabel = shapes.indicatorLabel;
    indicatorLabel.attr("invisible", false);
    var align = this._applyTransform("left", shapes.mainGroup);
    var orient = this._orient;
    var isHorizontal = orient === "horizontal";
    indicatorLabel.setStyle({
      text: (rangeSymbol ? rangeSymbol : "") + visualMapModel.formatValueText(textValue),
      verticalAlign: isHorizontal ? align : "middle",
      align: isHorizontal ? "center" : align
    });
    var indicatorNewProps = {
      x: x2,
      y: y2,
      style: {
        fill: color
      }
    };
    var labelNewProps = {
      style: {
        x: textPoint[0],
        y: textPoint[1]
      }
    };
    if (visualMapModel.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
      var animationCfg = {
        duration: 100,
        easing: "cubicInOut",
        additive: true
      };
      indicator.x = oldIndicatorPos.x;
      indicator.y = oldIndicatorPos.y;
      indicator.animateTo(indicatorNewProps, animationCfg);
      indicatorLabel.animateTo(labelNewProps, animationCfg);
    } else {
      indicator.attr(indicatorNewProps);
      indicatorLabel.attr(labelNewProps);
    }
    this._firstShowIndicator = false;
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.enterBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._enableHoverLinkToSeries = function() {
    var self2 = this;
    this._shapes.mainGroup.on("mousemove", function(e2) {
      self2._hovering = true;
      if (!self2._dragging) {
        var itemSize = self2.visualMapModel.itemSize;
        var pos = self2._applyTransform([e2.offsetX, e2.offsetY], self2._shapes.mainGroup, true, true);
        pos[1] = mathMin(mathMax(0, pos[1]), itemSize[1]);
        self2._doHoverLinkToSeries(pos[1], 0 <= pos[0] && pos[0] <= itemSize[0]);
      }
    }).on("mouseout", function() {
      self2._hovering = false;
      !self2._dragging && self2._clearHoverLinkToSeries();
    });
  };
  ContinuousView2.prototype._enableHoverLinkFromSeries = function() {
    var zr = this.api.getZr();
    if (this.visualMapModel.option.hoverLink) {
      zr.on("mouseover", this._hoverLinkFromSeriesMouseOver, this);
      zr.on("mouseout", this._hideIndicator, this);
    } else {
      this._clearHoverLinkFromSeries();
    }
  };
  ContinuousView2.prototype._doHoverLinkToSeries = function(cursorPos, hoverOnBar) {
    var visualMapModel = this.visualMapModel;
    var itemSize = visualMapModel.itemSize;
    if (!visualMapModel.option.hoverLink) {
      return;
    }
    var sizeExtent = [0, itemSize[1]];
    var dataExtent = visualMapModel.getExtent();
    cursorPos = mathMin(mathMax(sizeExtent[0], cursorPos), sizeExtent[1]);
    var halfHoverLinkSize = getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent);
    var hoverRange = [cursorPos - halfHoverLinkSize, cursorPos + halfHoverLinkSize];
    var cursorValue = linearMap(cursorPos, sizeExtent, dataExtent, true);
    var valueRange = [linearMap(hoverRange[0], sizeExtent, dataExtent, true), linearMap(hoverRange[1], sizeExtent, dataExtent, true)];
    hoverRange[0] < sizeExtent[0] && (valueRange[0] = -Infinity);
    hoverRange[1] > sizeExtent[1] && (valueRange[1] = Infinity);
    if (hoverOnBar) {
      if (valueRange[0] === -Infinity) {
        this._showIndicator(cursorValue, valueRange[1], "< ", halfHoverLinkSize);
      } else if (valueRange[1] === Infinity) {
        this._showIndicator(cursorValue, valueRange[0], "> ", halfHoverLinkSize);
      } else {
        this._showIndicator(cursorValue, cursorValue, "\u2248 ", halfHoverLinkSize);
      }
    }
    var oldBatch = this._hoverLinkDataIndices;
    var newBatch = [];
    if (hoverOnBar || useHoverLinkOnHandle(visualMapModel)) {
      newBatch = this._hoverLinkDataIndices = visualMapModel.findTargetDataIndices(valueRange);
    }
    var resultBatches = compressBatches(oldBatch, newBatch);
    this._dispatchHighDown("downplay", makeHighDownBatch(resultBatches[0], visualMapModel));
    this._dispatchHighDown("highlight", makeHighDownBatch(resultBatches[1], visualMapModel));
  };
  ContinuousView2.prototype._hoverLinkFromSeriesMouseOver = function(e2) {
    var el = e2.target;
    var visualMapModel = this.visualMapModel;
    if (!el || getECData(el).dataIndex == null) {
      return;
    }
    var ecData = getECData(el);
    var dataModel = this.ecModel.getSeriesByIndex(ecData.seriesIndex);
    if (!visualMapModel.isTargetSeries(dataModel)) {
      return;
    }
    var data = dataModel.getData(ecData.dataType);
    var value = data.getStore().get(visualMapModel.getDataDimensionIndex(data), ecData.dataIndex);
    if (!isNaN(value)) {
      this._showIndicator(value, value);
    }
  };
  ContinuousView2.prototype._hideIndicator = function() {
    var shapes = this._shapes;
    shapes.indicator && shapes.indicator.attr("invisible", true);
    shapes.indicatorLabel && shapes.indicatorLabel.attr("invisible", true);
    var handleLabels = this._shapes.handleLabels;
    if (handleLabels) {
      for (var i = 0; i < handleLabels.length; i++) {
        this._api.leaveBlur(handleLabels[i]);
      }
    }
  };
  ContinuousView2.prototype._clearHoverLinkToSeries = function() {
    this._hideIndicator();
    var indices = this._hoverLinkDataIndices;
    this._dispatchHighDown("downplay", makeHighDownBatch(indices, this.visualMapModel));
    indices.length = 0;
  };
  ContinuousView2.prototype._clearHoverLinkFromSeries = function() {
    this._hideIndicator();
    var zr = this.api.getZr();
    zr.off("mouseover", this._hoverLinkFromSeriesMouseOver);
    zr.off("mouseout", this._hideIndicator);
  };
  ContinuousView2.prototype._applyTransform = function(vertex, element, inverse, global2) {
    var transform2 = getTransform$1(element, global2 ? null : this.group);
    return isArray$1(vertex) ? applyTransform(vertex, transform2, inverse) : transformDirection(vertex, transform2, inverse);
  };
  ContinuousView2.prototype._dispatchHighDown = function(type4, batch) {
    batch && batch.length && this.api.dispatchAction({
      type: type4,
      batch
    });
  };
  ContinuousView2.prototype.dispose = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.prototype.remove = function() {
    this._clearHoverLinkFromSeries();
    this._clearHoverLinkToSeries();
  };
  ContinuousView2.type = "visualMap.continuous";
  return ContinuousView2;
}(VisualMapView$1);
function createPolygon(points2, cursor, onDrift, onDragEnd) {
  return new Polygon$1({
    shape: {
      points: points2
    },
    draggable: !!onDrift,
    cursor,
    drift: onDrift,
    onmousemove: function(e2) {
      stop(e2.event);
    },
    ondragend: onDragEnd
  });
}
function getHalfHoverLinkSize(visualMapModel, dataExtent, sizeExtent) {
  var halfHoverLinkSize = HOVER_LINK_SIZE / 2;
  var hoverLinkDataSize = visualMapModel.get("hoverLinkDataSize");
  if (hoverLinkDataSize) {
    halfHoverLinkSize = linearMap(hoverLinkDataSize, dataExtent, sizeExtent, true) / 2;
  }
  return halfHoverLinkSize;
}
function useHoverLinkOnHandle(visualMapModel) {
  var hoverLinkOnHandle = visualMapModel.get("hoverLinkOnHandle");
  return !!(hoverLinkOnHandle == null ? visualMapModel.get("realtime") : hoverLinkOnHandle);
}
function getCursor(orient) {
  return orient === "vertical" ? "ns-resize" : "ew-resize";
}
var ContinuousView$1 = ContinuousView;
var visualMapActionInfo = {
  type: "selectDataRange",
  event: "dataRangeSelected",
  update: "update"
};
var visualMapActionHander = function(payload, ecModel) {
  ecModel.eachComponent({
    mainType: "visualMap",
    query: payload
  }, function(model) {
    model.setSelected(payload.selected);
  });
};
var visualMapEncodingHandlers = [
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var resetDefines = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        var pipelineContext = seriesModel.pipelineContext;
        if (!visualMapModel.isTargetSeries(seriesModel) || pipelineContext && pipelineContext.large) {
          return;
        }
        resetDefines.push(incrementalApplyVisual(visualMapModel.stateList, visualMapModel.targetVisuals, bind$1(visualMapModel.getValueState, visualMapModel), visualMapModel.getDataDimensionIndex(seriesModel.getData())));
      });
      return resetDefines;
    }
  },
  {
    createOnAllSeries: true,
    reset: function(seriesModel, ecModel) {
      var data = seriesModel.getData();
      var visualMetaList = [];
      ecModel.eachComponent("visualMap", function(visualMapModel) {
        if (visualMapModel.isTargetSeries(seriesModel)) {
          var visualMeta = visualMapModel.getVisualMeta(bind$1(getColorVisual, null, seriesModel, visualMapModel)) || {
            stops: [],
            outerColors: []
          };
          var dimIdx = visualMapModel.getDataDimensionIndex(data);
          if (dimIdx >= 0) {
            visualMeta.dimension = dimIdx;
            visualMetaList.push(visualMeta);
          }
        }
      });
      seriesModel.getData().setVisual("visualMeta", visualMetaList);
    }
  }
];
function getColorVisual(seriesModel, visualMapModel, value, valueState) {
  var mappings = visualMapModel.targetVisuals[valueState];
  var visualTypes = VisualMapping$1.prepareVisualTypes(mappings);
  var resultVisual = {
    color: getVisualFromData(seriesModel.getData(), "color")
  };
  for (var i = 0, len2 = visualTypes.length; i < len2; i++) {
    var type4 = visualTypes[i];
    var mapping = mappings[type4 === "opacity" ? "__alphaForOpacity" : type4];
    mapping && mapping.applyVisual(value, getVisual, setVisual);
  }
  return resultVisual.color;
  function getVisual(key) {
    return resultVisual[key];
  }
  function setVisual(key, value2) {
    resultVisual[key] = value2;
  }
}
var each = each$f;
function visualMapPreprocessor(option) {
  var visualMap = option && option.visualMap;
  if (!isArray$1(visualMap)) {
    visualMap = visualMap ? [visualMap] : [];
  }
  each(visualMap, function(opt) {
    if (!opt) {
      return;
    }
    if (has(opt, "splitList") && !has(opt, "pieces")) {
      opt.pieces = opt.splitList;
      delete opt.splitList;
    }
    var pieces = opt.pieces;
    if (pieces && isArray$1(pieces)) {
      each(pieces, function(piece) {
        if (isObject$4(piece)) {
          if (has(piece, "start") && !has(piece, "min")) {
            piece.min = piece.start;
          }
          if (has(piece, "end") && !has(piece, "max")) {
            piece.max = piece.end;
          }
        }
      });
    }
  });
}
function has(obj, name) {
  return obj && obj.hasOwnProperty && obj.hasOwnProperty(name);
}
var installed = false;
function installCommon(registers) {
  if (installed) {
    return;
  }
  installed = true;
  registers.registerSubTypeDefaulter("visualMap", function(option) {
    return !option.categories && (!(option.pieces ? option.pieces.length > 0 : option.splitNumber > 0) || option.calculable) ? "continuous" : "piecewise";
  });
  registers.registerAction(visualMapActionInfo, visualMapActionHander);
  each$f(visualMapEncodingHandlers, function(handler) {
    registers.registerVisual(registers.PRIORITY.VISUAL.COMPONENT, handler);
  });
  registers.registerPreprocessor(visualMapPreprocessor);
}
function install$5(registers) {
  registers.registerComponentModel(ContinuousModel$1);
  registers.registerComponentView(ContinuousView$1);
  installCommon(registers);
}
var PiecewiseModel = function(_super) {
  __extends(PiecewiseModel2, _super);
  function PiecewiseModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseModel2.type;
    _this._pieceList = [];
    return _this;
  }
  PiecewiseModel2.prototype.optionUpdated = function(newOption, isInit) {
    _super.prototype.optionUpdated.apply(this, arguments);
    this.resetExtent();
    var mode = this._mode = this._determineMode();
    this._pieceList = [];
    resetMethods[this._mode].call(this, this._pieceList);
    this._resetSelected(newOption, isInit);
    var categories = this.option.categories;
    this.resetVisual(function(mappingOption, state) {
      if (mode === "categories") {
        mappingOption.mappingMethod = "category";
        mappingOption.categories = clone$4(categories);
      } else {
        mappingOption.dataExtent = this.getExtent();
        mappingOption.mappingMethod = "piecewise";
        mappingOption.pieceList = map$1(this._pieceList, function(piece) {
          piece = clone$4(piece);
          if (state !== "inRange") {
            piece.visual = null;
          }
          return piece;
        });
      }
    });
  };
  PiecewiseModel2.prototype.completeVisualOption = function() {
    var option = this.option;
    var visualTypesInPieces = {};
    var visualTypes = VisualMapping$1.listVisualTypes();
    var isCategory2 = this.isCategory();
    each$f(option.pieces, function(piece) {
      each$f(visualTypes, function(visualType) {
        if (piece.hasOwnProperty(visualType)) {
          visualTypesInPieces[visualType] = 1;
        }
      });
    });
    each$f(visualTypesInPieces, function(v4, visualType) {
      var exists = false;
      each$f(this.stateList, function(state) {
        exists = exists || has2(option, state, visualType) || has2(option.target, state, visualType);
      }, this);
      !exists && each$f(this.stateList, function(state) {
        (option[state] || (option[state] = {}))[visualType] = visualDefault$1.get(visualType, state === "inRange" ? "active" : "inactive", isCategory2);
      });
    }, this);
    function has2(obj, state, visualType) {
      return obj && obj[state] && obj[state].hasOwnProperty(visualType);
    }
    _super.prototype.completeVisualOption.apply(this, arguments);
  };
  PiecewiseModel2.prototype._resetSelected = function(newOption, isInit) {
    var thisOption = this.option;
    var pieceList = this._pieceList;
    var selected = (isInit ? thisOption : newOption).selected || {};
    thisOption.selected = selected;
    each$f(pieceList, function(piece, index2) {
      var key = this.getSelectedMapKey(piece);
      if (!selected.hasOwnProperty(key)) {
        selected[key] = true;
      }
    }, this);
    if (thisOption.selectedMode === "single") {
      var hasSel_1 = false;
      each$f(pieceList, function(piece, index2) {
        var key = this.getSelectedMapKey(piece);
        if (selected[key]) {
          hasSel_1 ? selected[key] = false : hasSel_1 = true;
        }
      }, this);
    }
  };
  PiecewiseModel2.prototype.getItemSymbol = function() {
    return this.get("itemSymbol");
  };
  PiecewiseModel2.prototype.getSelectedMapKey = function(piece) {
    return this._mode === "categories" ? piece.value + "" : piece.index + "";
  };
  PiecewiseModel2.prototype.getPieceList = function() {
    return this._pieceList;
  };
  PiecewiseModel2.prototype._determineMode = function() {
    var option = this.option;
    return option.pieces && option.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
  };
  PiecewiseModel2.prototype.setSelected = function(selected) {
    this.option.selected = clone$4(selected);
  };
  PiecewiseModel2.prototype.getValueState = function(value) {
    var index2 = VisualMapping$1.findPieceIndex(value, this._pieceList);
    return index2 != null ? this.option.selected[this.getSelectedMapKey(this._pieceList[index2])] ? "inRange" : "outOfRange" : "outOfRange";
  };
  PiecewiseModel2.prototype.findTargetDataIndices = function(pieceIndex) {
    var result = [];
    var pieceList = this._pieceList;
    this.eachTargetSeries(function(seriesModel) {
      var dataIndices = [];
      var data = seriesModel.getData();
      data.each(this.getDataDimensionIndex(data), function(value, dataIndex) {
        var pIdx = VisualMapping$1.findPieceIndex(value, pieceList);
        pIdx === pieceIndex && dataIndices.push(dataIndex);
      }, this);
      result.push({
        seriesId: seriesModel.id,
        dataIndex: dataIndices
      });
    }, this);
    return result;
  };
  PiecewiseModel2.prototype.getRepresentValue = function(piece) {
    var representValue;
    if (this.isCategory()) {
      representValue = piece.value;
    } else {
      if (piece.value != null) {
        representValue = piece.value;
      } else {
        var pieceInterval = piece.interval || [];
        representValue = pieceInterval[0] === -Infinity && pieceInterval[1] === Infinity ? 0 : (pieceInterval[0] + pieceInterval[1]) / 2;
      }
    }
    return representValue;
  };
  PiecewiseModel2.prototype.getVisualMeta = function(getColorVisual2) {
    if (this.isCategory()) {
      return;
    }
    var stops = [];
    var outerColors = ["", ""];
    var visualMapModel = this;
    function setStop(interval, valueState) {
      var representValue = visualMapModel.getRepresentValue({
        interval
      });
      if (!valueState) {
        valueState = visualMapModel.getValueState(representValue);
      }
      var color = getColorVisual2(representValue, valueState);
      if (interval[0] === -Infinity) {
        outerColors[0] = color;
      } else if (interval[1] === Infinity) {
        outerColors[1] = color;
      } else {
        stops.push({
          value: interval[0],
          color
        }, {
          value: interval[1],
          color
        });
      }
    }
    var pieceList = this._pieceList.slice();
    if (!pieceList.length) {
      pieceList.push({
        interval: [-Infinity, Infinity]
      });
    } else {
      var edge = pieceList[0].interval[0];
      edge !== -Infinity && pieceList.unshift({
        interval: [-Infinity, edge]
      });
      edge = pieceList[pieceList.length - 1].interval[1];
      edge !== Infinity && pieceList.push({
        interval: [edge, Infinity]
      });
    }
    var curr = -Infinity;
    each$f(pieceList, function(piece) {
      var interval = piece.interval;
      if (interval) {
        interval[0] > curr && setStop([curr, interval[0]], "outOfRange");
        setStop(interval.slice());
        curr = interval[1];
      }
    }, this);
    return {
      stops,
      outerColors
    };
  };
  PiecewiseModel2.type = "visualMap.piecewise";
  PiecewiseModel2.defaultOption = inheritDefaultOption(VisualMapModel$1.defaultOption, {
    selected: null,
    minOpen: false,
    maxOpen: false,
    align: "auto",
    itemWidth: 20,
    itemHeight: 14,
    itemSymbol: "roundRect",
    pieces: null,
    categories: null,
    splitNumber: 5,
    selectedMode: "multiple",
    itemGap: 10,
    hoverLink: true
  });
  return PiecewiseModel2;
}(VisualMapModel$1);
var resetMethods = {
  splitNumber: function(outPieceList) {
    var thisOption = this.option;
    var precision = Math.min(thisOption.precision, 20);
    var dataExtent = this.getExtent();
    var splitNumber = thisOption.splitNumber;
    splitNumber = Math.max(parseInt(splitNumber, 10), 1);
    thisOption.splitNumber = splitNumber;
    var splitStep = (dataExtent[1] - dataExtent[0]) / splitNumber;
    while (+splitStep.toFixed(precision) !== splitStep && precision < 5) {
      precision++;
    }
    thisOption.precision = precision;
    splitStep = +splitStep.toFixed(precision);
    if (thisOption.minOpen) {
      outPieceList.push({
        interval: [-Infinity, dataExtent[0]],
        close: [0, 0]
      });
    }
    for (var index2 = 0, curr = dataExtent[0]; index2 < splitNumber; curr += splitStep, index2++) {
      var max3 = index2 === splitNumber - 1 ? dataExtent[1] : curr + splitStep;
      outPieceList.push({
        interval: [curr, max3],
        close: [1, 1]
      });
    }
    if (thisOption.maxOpen) {
      outPieceList.push({
        interval: [dataExtent[1], Infinity],
        close: [0, 0]
      });
    }
    reformIntervals(outPieceList);
    each$f(outPieceList, function(piece, index3) {
      piece.index = index3;
      piece.text = this.formatValueText(piece.interval);
    }, this);
  },
  categories: function(outPieceList) {
    var thisOption = this.option;
    each$f(thisOption.categories, function(cate) {
      outPieceList.push({
        text: this.formatValueText(cate, true),
        value: cate
      });
    }, this);
    normalizeReverse(thisOption, outPieceList);
  },
  pieces: function(outPieceList) {
    var thisOption = this.option;
    each$f(thisOption.pieces, function(pieceListItem, index2) {
      if (!isObject$4(pieceListItem)) {
        pieceListItem = {
          value: pieceListItem
        };
      }
      var item = {
        text: "",
        index: index2
      };
      if (pieceListItem.label != null) {
        item.text = pieceListItem.label;
      }
      if (pieceListItem.hasOwnProperty("value")) {
        var value = item.value = pieceListItem.value;
        item.interval = [value, value];
        item.close = [1, 1];
      } else {
        var interval = item.interval = [];
        var close_1 = item.close = [0, 0];
        var closeList = [1, 0, 1];
        var infinityList = [-Infinity, Infinity];
        var useMinMax = [];
        for (var lg = 0; lg < 2; lg++) {
          var names2 = [["gte", "gt", "min"], ["lte", "lt", "max"]][lg];
          for (var i = 0; i < 3 && interval[lg] == null; i++) {
            interval[lg] = pieceListItem[names2[i]];
            close_1[lg] = closeList[i];
            useMinMax[lg] = i === 2;
          }
          interval[lg] == null && (interval[lg] = infinityList[lg]);
        }
        useMinMax[0] && interval[1] === Infinity && (close_1[0] = 0);
        useMinMax[1] && interval[0] === -Infinity && (close_1[1] = 0);
        if (interval[0] === interval[1] && close_1[0] && close_1[1]) {
          item.value = interval[0];
        }
      }
      item.visual = VisualMapping$1.retrieveVisuals(pieceListItem);
      outPieceList.push(item);
    }, this);
    normalizeReverse(thisOption, outPieceList);
    reformIntervals(outPieceList);
    each$f(outPieceList, function(piece) {
      var close = piece.close;
      var edgeSymbols = [["<", "\u2264"][close[1]], [">", "\u2265"][close[0]]];
      piece.text = piece.text || this.formatValueText(piece.value != null ? piece.value : piece.interval, false, edgeSymbols);
    }, this);
  }
};
function normalizeReverse(thisOption, pieceList) {
  var inverse = thisOption.inverse;
  if (thisOption.orient === "vertical" ? !inverse : inverse) {
    pieceList.reverse();
  }
}
var PiecewiseModel$1 = PiecewiseModel;
var PiecewiseVisualMapView = function(_super) {
  __extends(PiecewiseVisualMapView2, _super);
  function PiecewiseVisualMapView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = PiecewiseVisualMapView2.type;
    return _this;
  }
  PiecewiseVisualMapView2.prototype.doRender = function() {
    var thisGroup = this.group;
    thisGroup.removeAll();
    var visualMapModel = this.visualMapModel;
    var textGap = visualMapModel.get("textGap");
    var textStyleModel = visualMapModel.textStyleModel;
    var textFont = textStyleModel.getFont();
    var textFill = textStyleModel.getTextColor();
    var itemAlign = this._getItemAlign();
    var itemSize = visualMapModel.itemSize;
    var viewData = this._getViewData();
    var endsText = viewData.endsText;
    var showLabel = retrieve(visualMapModel.get("showLabel", true), !endsText);
    endsText && this._renderEndsText(thisGroup, endsText[0], itemSize, showLabel, itemAlign);
    each$f(viewData.viewPieceList, function(item) {
      var piece = item.piece;
      var itemGroup = new Group$4();
      itemGroup.onclick = bind$1(this._onItemClick, this, piece);
      this._enableHoverLink(itemGroup, item.indexInModelPieceList);
      var representValue = visualMapModel.getRepresentValue(piece);
      this._createItemSymbol(itemGroup, representValue, [0, 0, itemSize[0], itemSize[1]]);
      if (showLabel) {
        var visualState = this.visualMapModel.getValueState(representValue);
        itemGroup.add(new ZRText$1({
          style: {
            x: itemAlign === "right" ? -textGap : itemSize[0] + textGap,
            y: itemSize[1] / 2,
            text: piece.text,
            verticalAlign: "middle",
            align: itemAlign,
            font: textFont,
            fill: textFill,
            opacity: visualState === "outOfRange" ? 0.5 : 1
          }
        }));
      }
      thisGroup.add(itemGroup);
    }, this);
    endsText && this._renderEndsText(thisGroup, endsText[1], itemSize, showLabel, itemAlign);
    box(visualMapModel.get("orient"), thisGroup, visualMapModel.get("itemGap"));
    this.renderBackground(thisGroup);
    this.positionGroup(thisGroup);
  };
  PiecewiseVisualMapView2.prototype._enableHoverLink = function(itemGroup, pieceIndex) {
    var _this = this;
    itemGroup.on("mouseover", function() {
      return onHoverLink("highlight");
    }).on("mouseout", function() {
      return onHoverLink("downplay");
    });
    var onHoverLink = function(method4) {
      var visualMapModel = _this.visualMapModel;
      visualMapModel.option.hoverLink && _this.api.dispatchAction({
        type: method4,
        batch: makeHighDownBatch(visualMapModel.findTargetDataIndices(pieceIndex), visualMapModel)
      });
    };
  };
  PiecewiseVisualMapView2.prototype._getItemAlign = function() {
    var visualMapModel = this.visualMapModel;
    var modelOption = visualMapModel.option;
    if (modelOption.orient === "vertical") {
      return getItemAlign(visualMapModel, this.api, visualMapModel.itemSize);
    } else {
      var align = modelOption.align;
      if (!align || align === "auto") {
        align = "left";
      }
      return align;
    }
  };
  PiecewiseVisualMapView2.prototype._renderEndsText = function(group, text, itemSize, showLabel, itemAlign) {
    if (!text) {
      return;
    }
    var itemGroup = new Group$4();
    var textStyleModel = this.visualMapModel.textStyleModel;
    itemGroup.add(new ZRText$1({
      style: {
        x: showLabel ? itemAlign === "right" ? itemSize[0] : 0 : itemSize[0] / 2,
        y: itemSize[1] / 2,
        verticalAlign: "middle",
        align: showLabel ? itemAlign : "center",
        text,
        font: textStyleModel.getFont(),
        fill: textStyleModel.getTextColor()
      }
    }));
    group.add(itemGroup);
  };
  PiecewiseVisualMapView2.prototype._getViewData = function() {
    var visualMapModel = this.visualMapModel;
    var viewPieceList = map$1(visualMapModel.getPieceList(), function(piece, index2) {
      return {
        piece,
        indexInModelPieceList: index2
      };
    });
    var endsText = visualMapModel.get("text");
    var orient = visualMapModel.get("orient");
    var inverse = visualMapModel.get("inverse");
    if (orient === "horizontal" ? inverse : !inverse) {
      viewPieceList.reverse();
    } else if (endsText) {
      endsText = endsText.slice().reverse();
    }
    return {
      viewPieceList,
      endsText
    };
  };
  PiecewiseVisualMapView2.prototype._createItemSymbol = function(group, representValue, shapeParam) {
    group.add(createSymbol$1(this.getControllerVisual(representValue, "symbol"), shapeParam[0], shapeParam[1], shapeParam[2], shapeParam[3], this.getControllerVisual(representValue, "color")));
  };
  PiecewiseVisualMapView2.prototype._onItemClick = function(piece) {
    var visualMapModel = this.visualMapModel;
    var option = visualMapModel.option;
    var selected = clone$4(option.selected);
    var newKey = visualMapModel.getSelectedMapKey(piece);
    if (option.selectedMode === "single") {
      selected[newKey] = true;
      each$f(selected, function(o, key) {
        selected[key] = key === newKey;
      });
    } else {
      selected[newKey] = !selected[newKey];
    }
    this.api.dispatchAction({
      type: "selectDataRange",
      from: this.uid,
      visualMapId: this.visualMapModel.id,
      selected
    });
  };
  PiecewiseVisualMapView2.type = "visualMap.piecewise";
  return PiecewiseVisualMapView2;
}(VisualMapView$1);
var PiecewiseView = PiecewiseVisualMapView;
function install$4(registers) {
  registers.registerComponentModel(PiecewiseModel$1);
  registers.registerComponentView(PiecewiseView);
  installCommon(registers);
}
function install$3(registers) {
  use(install$5);
  use(install$4);
}
var DEFAULT_OPTION = {
  label: {
    enabled: true
  },
  decal: {
    show: false
  }
};
var inner = makeInner();
var decalPaletteScope = {};
function ariaVisual(ecModel, api) {
  var ariaModel = ecModel.getModel("aria");
  if (!ariaModel.get("enabled")) {
    return;
  }
  var defaultOption2 = clone$4(DEFAULT_OPTION);
  merge(defaultOption2.label, ecModel.getLocaleModel().get("aria"), false);
  merge(ariaModel.option, defaultOption2, false);
  setDecal();
  setLabel();
  function setDecal() {
    var decalModel = ariaModel.getModel("decal");
    var useDecal = decalModel.get("show");
    if (useDecal) {
      var paletteScopeGroupByType_1 = createHashMap();
      ecModel.eachSeries(function(seriesModel) {
        if (seriesModel.isColorBySeries()) {
          return;
        }
        var decalScope = paletteScopeGroupByType_1.get(seriesModel.type);
        if (!decalScope) {
          decalScope = {};
          paletteScopeGroupByType_1.set(seriesModel.type, decalScope);
        }
        inner(seriesModel).scope = decalScope;
      });
      ecModel.eachRawSeries(function(seriesModel) {
        if (ecModel.isSeriesFiltered(seriesModel)) {
          return;
        }
        if (isFunction(seriesModel.enableAriaDecal)) {
          seriesModel.enableAriaDecal();
          return;
        }
        var data = seriesModel.getData();
        if (!seriesModel.isColorBySeries()) {
          var dataAll_1 = seriesModel.getRawData();
          var idxMap_1 = {};
          var decalScope_1 = inner(seriesModel).scope;
          data.each(function(idx) {
            var rawIdx = data.getRawIndex(idx);
            idxMap_1[rawIdx] = idx;
          });
          var dataCount_1 = dataAll_1.count();
          dataAll_1.each(function(rawIdx) {
            var idx = idxMap_1[rawIdx];
            var name = dataAll_1.getName(rawIdx) || rawIdx + "";
            var paletteDecal2 = getDecalFromPalette(seriesModel.ecModel, name, decalScope_1, dataCount_1);
            var specifiedDecal2 = data.getItemVisual(idx, "decal");
            data.setItemVisual(idx, "decal", mergeDecal(specifiedDecal2, paletteDecal2));
          });
        } else {
          var paletteDecal = getDecalFromPalette(seriesModel.ecModel, seriesModel.name, decalPaletteScope, ecModel.getSeriesCount());
          var specifiedDecal = data.getVisual("decal");
          data.setVisual("decal", mergeDecal(specifiedDecal, paletteDecal));
        }
        function mergeDecal(specifiedDecal2, paletteDecal2) {
          var resultDecal = specifiedDecal2 ? extend(extend({}, paletteDecal2), specifiedDecal2) : paletteDecal2;
          resultDecal.dirty = true;
          return resultDecal;
        }
      });
    }
  }
  function setLabel() {
    var labelLocale = ecModel.getLocaleModel().get("aria");
    var labelModel = ariaModel.getModel("label");
    labelModel.option = defaults(labelModel.option, labelLocale);
    if (!labelModel.get("enabled")) {
      return;
    }
    var dom = api.getZr().dom;
    if (labelModel.get("description")) {
      dom.setAttribute("aria-label", labelModel.get("description"));
      return;
    }
    var seriesCnt = ecModel.getSeriesCount();
    var maxDataCnt = labelModel.get(["data", "maxCount"]) || 10;
    var maxSeriesCnt = labelModel.get(["series", "maxCount"]) || 10;
    var displaySeriesCnt = Math.min(seriesCnt, maxSeriesCnt);
    var ariaLabel;
    if (seriesCnt < 1) {
      return;
    } else {
      var title = getTitle();
      if (title) {
        var withTitle = labelModel.get(["general", "withTitle"]);
        ariaLabel = replace(withTitle, {
          title
        });
      } else {
        ariaLabel = labelModel.get(["general", "withoutTitle"]);
      }
      var seriesLabels_1 = [];
      var prefix = seriesCnt > 1 ? labelModel.get(["series", "multiple", "prefix"]) : labelModel.get(["series", "single", "prefix"]);
      ariaLabel += replace(prefix, {
        seriesCount: seriesCnt
      });
      ecModel.eachSeries(function(seriesModel, idx) {
        if (idx < displaySeriesCnt) {
          var seriesLabel = void 0;
          var seriesName = seriesModel.get("name");
          var withName = seriesName ? "withName" : "withoutName";
          seriesLabel = seriesCnt > 1 ? labelModel.get(["series", "multiple", withName]) : labelModel.get(["series", "single", withName]);
          seriesLabel = replace(seriesLabel, {
            seriesId: seriesModel.seriesIndex,
            seriesName: seriesModel.get("name"),
            seriesType: getSeriesTypeName(seriesModel.subType)
          });
          var data = seriesModel.getData();
          if (data.count() > maxDataCnt) {
            var partialLabel = labelModel.get(["data", "partialData"]);
            seriesLabel += replace(partialLabel, {
              displayCnt: maxDataCnt
            });
          } else {
            seriesLabel += labelModel.get(["data", "allData"]);
          }
          var middleSeparator_1 = labelModel.get(["data", "separator", "middle"]);
          var endSeparator_1 = labelModel.get(["data", "separator", "end"]);
          var dataLabels = [];
          for (var i = 0; i < data.count(); i++) {
            if (i < maxDataCnt) {
              var name_1 = data.getName(i);
              var value = data.getValues(i);
              var dataLabel = labelModel.get(["data", name_1 ? "withName" : "withoutName"]);
              dataLabels.push(replace(dataLabel, {
                name: name_1,
                value: value.join(middleSeparator_1)
              }));
            }
          }
          seriesLabel += dataLabels.join(middleSeparator_1) + endSeparator_1;
          seriesLabels_1.push(seriesLabel);
        }
      });
      var separatorModel = labelModel.getModel(["series", "multiple", "separator"]);
      var middleSeparator = separatorModel.get("middle");
      var endSeparator = separatorModel.get("end");
      ariaLabel += seriesLabels_1.join(middleSeparator) + endSeparator;
      dom.setAttribute("aria-label", ariaLabel);
    }
  }
  function replace(str, keyValues) {
    if (!isString(str)) {
      return str;
    }
    var result = str;
    each$f(keyValues, function(value, key) {
      result = result.replace(new RegExp("\\{\\s*" + key + "\\s*\\}", "g"), value);
    });
    return result;
  }
  function getTitle() {
    var title = ecModel.get("title");
    if (title && title.length) {
      title = title[0];
    }
    return title && title.text;
  }
  function getSeriesTypeName(type4) {
    return ecModel.getLocaleModel().get(["series", "typeNames"])[type4] || "\u81EA\u5B9A\u4E49\u56FE";
  }
}
function ariaPreprocessor(option) {
  if (!option || !option.aria) {
    return;
  }
  var aria = option.aria;
  if (aria.show != null) {
    aria.enabled = aria.show;
  }
  aria.label = aria.label || {};
  each$f(["description", "general", "series", "data"], function(name) {
    if (aria[name] != null) {
      aria.label[name] = aria[name];
    }
  });
}
function install$2(registers) {
  registers.registerPreprocessor(ariaPreprocessor);
  registers.registerVisual(registers.PRIORITY.VISUAL.ARIA, ariaVisual);
}
var RELATIONAL_EXPRESSION_OP_ALIAS_MAP = {
  value: "eq",
  "<": "lt",
  "<=": "lte",
  ">": "gt",
  ">=": "gte",
  "=": "eq",
  "!=": "ne",
  "<>": "ne"
};
var RegExpEvaluator = function() {
  function RegExpEvaluator2(rVal) {
    var condValue = this._condVal = isString(rVal) ? new RegExp(rVal) : isRegExp(rVal) ? rVal : null;
    if (condValue == null) {
      var errMsg = "";
      throwError(errMsg);
    }
  }
  RegExpEvaluator2.prototype.evaluate = function(lVal) {
    var type4 = typeof lVal;
    return isString(type4) ? this._condVal.test(lVal) : isNumber(type4) ? this._condVal.test(lVal + "") : false;
  };
  return RegExpEvaluator2;
}();
var ConstConditionInternal = function() {
  function ConstConditionInternal2() {
  }
  ConstConditionInternal2.prototype.evaluate = function() {
    return this.value;
  };
  return ConstConditionInternal2;
}();
var AndConditionInternal = function() {
  function AndConditionInternal2() {
  }
  AndConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (!children[i].evaluate()) {
        return false;
      }
    }
    return true;
  };
  return AndConditionInternal2;
}();
var OrConditionInternal = function() {
  function OrConditionInternal2() {
  }
  OrConditionInternal2.prototype.evaluate = function() {
    var children = this.children;
    for (var i = 0; i < children.length; i++) {
      if (children[i].evaluate()) {
        return true;
      }
    }
    return false;
  };
  return OrConditionInternal2;
}();
var NotConditionInternal = function() {
  function NotConditionInternal2() {
  }
  NotConditionInternal2.prototype.evaluate = function() {
    return !this.child.evaluate();
  };
  return NotConditionInternal2;
}();
var RelationalConditionInternal = function() {
  function RelationalConditionInternal2() {
  }
  RelationalConditionInternal2.prototype.evaluate = function() {
    var needParse = !!this.valueParser;
    var getValue2 = this.getValue;
    var tarValRaw = getValue2(this.valueGetterParam);
    var tarValParsed = needParse ? this.valueParser(tarValRaw) : null;
    for (var i = 0; i < this.subCondList.length; i++) {
      if (!this.subCondList[i].evaluate(needParse ? tarValParsed : tarValRaw)) {
        return false;
      }
    }
    return true;
  };
  return RelationalConditionInternal2;
}();
function parseOption(exprOption, getters) {
  if (exprOption === true || exprOption === false) {
    var cond = new ConstConditionInternal();
    cond.value = exprOption;
    return cond;
  }
  var errMsg = "";
  if (!isObjectNotArray(exprOption)) {
    throwError(errMsg);
  }
  if (exprOption.and) {
    return parseAndOrOption("and", exprOption, getters);
  } else if (exprOption.or) {
    return parseAndOrOption("or", exprOption, getters);
  } else if (exprOption.not) {
    return parseNotOption(exprOption, getters);
  }
  return parseRelationalOption(exprOption, getters);
}
function parseAndOrOption(op, exprOption, getters) {
  var subOptionArr = exprOption[op];
  var errMsg = "";
  if (!isArray$1(subOptionArr)) {
    throwError(errMsg);
  }
  if (!subOptionArr.length) {
    throwError(errMsg);
  }
  var cond = op === "and" ? new AndConditionInternal() : new OrConditionInternal();
  cond.children = map$1(subOptionArr, function(subOption) {
    return parseOption(subOption, getters);
  });
  if (!cond.children.length) {
    throwError(errMsg);
  }
  return cond;
}
function parseNotOption(exprOption, getters) {
  var subOption = exprOption.not;
  var errMsg = "";
  if (!isObjectNotArray(subOption)) {
    throwError(errMsg);
  }
  var cond = new NotConditionInternal();
  cond.child = parseOption(subOption, getters);
  if (!cond.child) {
    throwError(errMsg);
  }
  return cond;
}
function parseRelationalOption(exprOption, getters) {
  var errMsg = "";
  var valueGetterParam = getters.prepareGetValue(exprOption);
  var subCondList = [];
  var exprKeys = keys(exprOption);
  var parserName = exprOption.parser;
  var valueParser = parserName ? getRawValueParser(parserName) : null;
  for (var i = 0; i < exprKeys.length; i++) {
    var keyRaw = exprKeys[i];
    if (keyRaw === "parser" || getters.valueGetterAttrMap.get(keyRaw)) {
      continue;
    }
    var op = hasOwn(RELATIONAL_EXPRESSION_OP_ALIAS_MAP, keyRaw) ? RELATIONAL_EXPRESSION_OP_ALIAS_MAP[keyRaw] : keyRaw;
    var condValueRaw = exprOption[keyRaw];
    var condValueParsed = valueParser ? valueParser(condValueRaw) : condValueRaw;
    var evaluator = createFilterComparator(op, condValueParsed) || op === "reg" && new RegExpEvaluator(condValueParsed);
    if (!evaluator) {
      throwError(errMsg);
    }
    subCondList.push(evaluator);
  }
  if (!subCondList.length) {
    throwError(errMsg);
  }
  var cond = new RelationalConditionInternal();
  cond.valueGetterParam = valueGetterParam;
  cond.valueParser = valueParser;
  cond.getValue = getters.getValue;
  cond.subCondList = subCondList;
  return cond;
}
function isObjectNotArray(val) {
  return isObject$4(val) && !isArrayLike(val);
}
var ConditionalExpressionParsed = function() {
  function ConditionalExpressionParsed2(exprOption, getters) {
    this._cond = parseOption(exprOption, getters);
  }
  ConditionalExpressionParsed2.prototype.evaluate = function() {
    return this._cond.evaluate();
  };
  return ConditionalExpressionParsed2;
}();
function parseConditionalExpression(exprOption, getters) {
  return new ConditionalExpressionParsed(exprOption, getters);
}
var filterTransform = {
  type: "echarts:filter",
  transform: function(params) {
    var upstream = params.upstream;
    var rawItem;
    var condition = parseConditionalExpression(params.config, {
      valueGetterAttrMap: createHashMap({
        dimension: true
      }),
      prepareGetValue: function(exprOption) {
        var errMsg = "";
        var dimLoose = exprOption.dimension;
        if (!hasOwn(exprOption, "dimension")) {
          throwError(errMsg);
        }
        var dimInfo = upstream.getDimensionInfo(dimLoose);
        if (!dimInfo) {
          throwError(errMsg);
        }
        return {
          dimIdx: dimInfo.index
        };
      },
      getValue: function(param) {
        return upstream.retrieveValueFromItem(rawItem, param.dimIdx);
      }
    });
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      rawItem = upstream.getRawDataItem(i);
      if (condition.evaluate()) {
        resultData.push(rawItem);
      }
    }
    return {
      data: resultData
    };
  }
};
var sortTransform = {
  type: "echarts:sort",
  transform: function(params) {
    var upstream = params.upstream;
    var config = params.config;
    var errMsg = "";
    var orderExprList = normalizeToArray(config);
    if (!orderExprList.length) {
      throwError(errMsg);
    }
    var orderDefList = [];
    each$f(orderExprList, function(orderExpr) {
      var dimLoose = orderExpr.dimension;
      var order = orderExpr.order;
      var parserName = orderExpr.parser;
      var incomparable = orderExpr.incomparable;
      if (dimLoose == null) {
        throwError(errMsg);
      }
      if (order !== "asc" && order !== "desc") {
        throwError(errMsg);
      }
      if (incomparable && incomparable !== "min" && incomparable !== "max") {
        var errMsg_1 = "";
        throwError(errMsg_1);
      }
      if (order !== "asc" && order !== "desc") {
        var errMsg_2 = "";
        throwError(errMsg_2);
      }
      var dimInfo = upstream.getDimensionInfo(dimLoose);
      if (!dimInfo) {
        throwError(errMsg);
      }
      var parser = parserName ? getRawValueParser(parserName) : null;
      if (parserName && !parser) {
        throwError(errMsg);
      }
      orderDefList.push({
        dimIdx: dimInfo.index,
        parser,
        comparator: new SortOrderComparator(order, incomparable)
      });
    });
    var sourceFormat = upstream.sourceFormat;
    if (sourceFormat !== SOURCE_FORMAT_ARRAY_ROWS && sourceFormat !== SOURCE_FORMAT_OBJECT_ROWS) {
      throwError(errMsg);
    }
    var resultData = [];
    for (var i = 0, len2 = upstream.count(); i < len2; i++) {
      resultData.push(upstream.getRawDataItem(i));
    }
    resultData.sort(function(item0, item1) {
      for (var i2 = 0; i2 < orderDefList.length; i2++) {
        var orderDef = orderDefList[i2];
        var val0 = upstream.retrieveValueFromItem(item0, orderDef.dimIdx);
        var val1 = upstream.retrieveValueFromItem(item1, orderDef.dimIdx);
        if (orderDef.parser) {
          val0 = orderDef.parser(val0);
          val1 = orderDef.parser(val1);
        }
        var result = orderDef.comparator.evaluate(val0, val1);
        if (result !== 0) {
          return result;
        }
      }
      return 0;
    });
    return {
      data: resultData
    };
  }
};
function install$1(registers) {
  registers.registerTransform(filterTransform);
  registers.registerTransform(sortTransform);
}
var DatasetModel = function(_super) {
  __extends(DatasetModel2, _super);
  function DatasetModel2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetModel2.prototype.init = function(option, parentModel, ecModel) {
    _super.prototype.init.call(this, option, parentModel, ecModel);
    this._sourceManager = new SourceManager(this);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.mergeOption = function(newOption, ecModel) {
    _super.prototype.mergeOption.call(this, newOption, ecModel);
    disableTransformOptionMerge(this);
  };
  DatasetModel2.prototype.optionUpdated = function() {
    this._sourceManager.dirty();
  };
  DatasetModel2.prototype.getSourceManager = function() {
    return this._sourceManager;
  };
  DatasetModel2.type = "dataset";
  DatasetModel2.defaultOption = {
    seriesLayoutBy: SERIES_LAYOUT_BY_COLUMN
  };
  return DatasetModel2;
}(ComponentModel$1);
var DatasetView = function(_super) {
  __extends(DatasetView2, _super);
  function DatasetView2() {
    var _this = _super !== null && _super.apply(this, arguments) || this;
    _this.type = "dataset";
    return _this;
  }
  DatasetView2.type = "dataset";
  return DatasetView2;
}(ComponentView$1);
function install(registers) {
  registers.registerComponentModel(DatasetModel);
  registers.registerComponentView(DatasetView);
}
var CMD = PathProxy$1.CMD;
function aroundEqual(a, b2) {
  return Math.abs(a - b2) < 1e-5;
}
function pathToBezierCurves(path) {
  var data = path.data;
  var len2 = path.len();
  var bezierArrayGroups = [];
  var currentSubpath;
  var xi = 0;
  var yi = 0;
  var x0 = 0;
  var y0 = 0;
  function createNewSubpath(x3, y3) {
    if (currentSubpath && currentSubpath.length > 2) {
      bezierArrayGroups.push(currentSubpath);
    }
    currentSubpath = [x3, y3];
  }
  function addLine(x02, y02, x12, y12) {
    if (!(aroundEqual(x02, x12) && aroundEqual(y02, y12))) {
      currentSubpath.push(x02, y02, x12, y12, x12, y12);
    }
  }
  function addArc(startAngle2, endAngle2, cx2, cy2, rx2, ry2) {
    var delta = Math.abs(endAngle2 - startAngle2);
    var len3 = Math.tan(delta / 4) * 4 / 3;
    var dir3 = endAngle2 < startAngle2 ? -1 : 1;
    var c1 = Math.cos(startAngle2);
    var s1 = Math.sin(startAngle2);
    var c2 = Math.cos(endAngle2);
    var s2 = Math.sin(endAngle2);
    var x12 = c1 * rx2 + cx2;
    var y12 = s1 * ry2 + cy2;
    var x4 = c2 * rx2 + cx2;
    var y4 = s2 * ry2 + cy2;
    var hx = rx2 * len3 * dir3;
    var hy = ry2 * len3 * dir3;
    currentSubpath.push(x12 - hx * s1, y12 + hy * c1, x4 + hx * s2, y4 - hy * c2, x4, y4);
  }
  var x1;
  var y1;
  var x2;
  var y2;
  for (var i = 0; i < len2; ) {
    var cmd = data[i++];
    var isFirst = i === 1;
    if (isFirst) {
      xi = data[i];
      yi = data[i + 1];
      x0 = xi;
      y0 = yi;
      if (cmd === CMD.L || cmd === CMD.C || cmd === CMD.Q) {
        currentSubpath = [x0, y0];
      }
    }
    switch (cmd) {
      case CMD.M:
        xi = x0 = data[i++];
        yi = y0 = data[i++];
        createNewSubpath(x0, y0);
        break;
      case CMD.L:
        x1 = data[i++];
        y1 = data[i++];
        addLine(xi, yi, x1, y1);
        xi = x1;
        yi = y1;
        break;
      case CMD.C:
        currentSubpath.push(data[i++], data[i++], data[i++], data[i++], xi = data[i++], yi = data[i++]);
        break;
      case CMD.Q:
        x1 = data[i++];
        y1 = data[i++];
        x2 = data[i++];
        y2 = data[i++];
        currentSubpath.push(xi + 2 / 3 * (x1 - xi), yi + 2 / 3 * (y1 - yi), x2 + 2 / 3 * (x1 - x2), y2 + 2 / 3 * (y1 - y2), x2, y2);
        xi = x2;
        yi = y2;
        break;
      case CMD.A:
        var cx = data[i++];
        var cy = data[i++];
        var rx = data[i++];
        var ry = data[i++];
        var startAngle = data[i++];
        var endAngle = data[i++] + startAngle;
        i += 1;
        var anticlockwise = !data[i++];
        x1 = Math.cos(startAngle) * rx + cx;
        y1 = Math.sin(startAngle) * ry + cy;
        if (isFirst) {
          x0 = x1;
          y0 = y1;
          createNewSubpath(x0, y0);
        } else {
          addLine(xi, yi, x1, y1);
        }
        xi = Math.cos(endAngle) * rx + cx;
        yi = Math.sin(endAngle) * ry + cy;
        var step = (anticlockwise ? -1 : 1) * Math.PI / 2;
        for (var angle = startAngle; anticlockwise ? angle > endAngle : angle < endAngle; angle += step) {
          var nextAngle = anticlockwise ? Math.max(angle + step, endAngle) : Math.min(angle + step, endAngle);
          addArc(angle, nextAngle, cx, cy, rx, ry);
        }
        break;
      case CMD.R:
        x0 = xi = data[i++];
        y0 = yi = data[i++];
        x1 = x0 + data[i++];
        y1 = y0 + data[i++];
        createNewSubpath(x1, y0);
        addLine(x1, y0, x1, y1);
        addLine(x1, y1, x0, y1);
        addLine(x0, y1, x0, y0);
        addLine(x0, y0, x1, y0);
        break;
      case CMD.Z:
        currentSubpath && addLine(xi, yi, x0, y0);
        xi = x0;
        yi = y0;
        break;
    }
  }
  if (currentSubpath && currentSubpath.length > 2) {
    bezierArrayGroups.push(currentSubpath);
  }
  return bezierArrayGroups;
}
function adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, out2, scale2) {
  if (aroundEqual(x0, x1) && aroundEqual(y0, y1) && aroundEqual(x2, x3) && aroundEqual(y2, y3)) {
    out2.push(x3, y3);
    return;
  }
  var PIXEL_DISTANCE = 2 / scale2;
  var PIXEL_DISTANCE_SQR = PIXEL_DISTANCE * PIXEL_DISTANCE;
  var dx = x3 - x0;
  var dy = y3 - y0;
  var d2 = Math.sqrt(dx * dx + dy * dy);
  dx /= d2;
  dy /= d2;
  var dx1 = x1 - x0;
  var dy1 = y1 - y0;
  var dx2 = x2 - x3;
  var dy2 = y2 - y3;
  var cp1LenSqr = dx1 * dx1 + dy1 * dy1;
  var cp2LenSqr = dx2 * dx2 + dy2 * dy2;
  if (cp1LenSqr < PIXEL_DISTANCE_SQR && cp2LenSqr < PIXEL_DISTANCE_SQR) {
    out2.push(x3, y3);
    return;
  }
  var projLen1 = dx * dx1 + dy * dy1;
  var projLen2 = -dx * dx2 - dy * dy2;
  var d1Sqr = cp1LenSqr - projLen1 * projLen1;
  var d2Sqr = cp2LenSqr - projLen2 * projLen2;
  if (d1Sqr < PIXEL_DISTANCE_SQR && projLen1 >= 0 && d2Sqr < PIXEL_DISTANCE_SQR && projLen2 >= 0) {
    out2.push(x3, y3);
    return;
  }
  var tmpSegX = [];
  var tmpSegY = [];
  cubicSubdivide(x0, x1, x2, x3, 0.5, tmpSegX);
  cubicSubdivide(y0, y1, y2, y3, 0.5, tmpSegY);
  adpativeBezier(tmpSegX[0], tmpSegY[0], tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], tmpSegX[3], tmpSegY[3], out2, scale2);
  adpativeBezier(tmpSegX[4], tmpSegY[4], tmpSegX[5], tmpSegY[5], tmpSegX[6], tmpSegY[6], tmpSegX[7], tmpSegY[7], out2, scale2);
}
function pathToPolygons(path, scale2) {
  var bezierArrayGroups = pathToBezierCurves(path);
  var polygons = [];
  scale2 = scale2 || 1;
  for (var i = 0; i < bezierArrayGroups.length; i++) {
    var beziers = bezierArrayGroups[i];
    var polygon = [];
    var x0 = beziers[0];
    var y0 = beziers[1];
    polygon.push(x0, y0);
    for (var k2 = 2; k2 < beziers.length; ) {
      var x1 = beziers[k2++];
      var y1 = beziers[k2++];
      var x2 = beziers[k2++];
      var y2 = beziers[k2++];
      var x3 = beziers[k2++];
      var y3 = beziers[k2++];
      adpativeBezier(x0, y0, x1, y1, x2, y2, x3, y3, polygon, scale2);
      x0 = x3;
      y0 = y3;
    }
    polygons.push(polygon);
  }
  return polygons;
}
function getDividingGrids(dimSize, rowDim, count2) {
  var rowSize = dimSize[rowDim];
  var columnSize = dimSize[1 - rowDim];
  var ratio = Math.abs(rowSize / columnSize);
  var rowCount = Math.ceil(Math.sqrt(ratio * count2));
  var columnCount = Math.floor(count2 / rowCount);
  if (columnCount === 0) {
    columnCount = 1;
    rowCount = count2;
  }
  var grids = [];
  for (var i = 0; i < rowCount; i++) {
    grids.push(columnCount);
  }
  var currentCount = rowCount * columnCount;
  var remained = count2 - currentCount;
  if (remained > 0) {
    for (var i = 0; i < remained; i++) {
      grids[i % rowCount] += 1;
    }
  }
  return grids;
}
function divideSector(sectorShape, count2, outShapes) {
  var r0 = sectorShape.r0;
  var r2 = sectorShape.r;
  var startAngle = sectorShape.startAngle;
  var endAngle = sectorShape.endAngle;
  var angle = Math.abs(endAngle - startAngle);
  var arcLen = angle * r2;
  var deltaR = r2 - r0;
  var isAngleRow = arcLen > Math.abs(deltaR);
  var grids = getDividingGrids([arcLen, deltaR], isAngleRow ? 0 : 1, count2);
  var rowSize = (isAngleRow ? angle : deltaR) / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = (isAngleRow ? deltaR : angle) / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      if (isAngleRow) {
        newShape.startAngle = startAngle + rowSize * row;
        newShape.endAngle = startAngle + rowSize * (row + 1);
        newShape.r0 = r0 + columnSize * column;
        newShape.r = r0 + columnSize * (column + 1);
      } else {
        newShape.startAngle = startAngle + columnSize * column;
        newShape.endAngle = startAngle + columnSize * (column + 1);
        newShape.r0 = r0 + rowSize * row;
        newShape.r = r0 + rowSize * (row + 1);
      }
      newShape.clockwise = sectorShape.clockwise;
      newShape.cx = sectorShape.cx;
      newShape.cy = sectorShape.cy;
      outShapes.push(newShape);
    }
  }
}
function divideRect(rectShape, count2, outShapes) {
  var width = rectShape.width;
  var height = rectShape.height;
  var isHorizontalRow = width > height;
  var grids = getDividingGrids([width, height], isHorizontalRow ? 0 : 1, count2);
  var rowSizeDim = isHorizontalRow ? "width" : "height";
  var columnSizeDim = isHorizontalRow ? "height" : "width";
  var rowDim = isHorizontalRow ? "x" : "y";
  var columnDim = isHorizontalRow ? "y" : "x";
  var rowSize = rectShape[rowSizeDim] / grids.length;
  for (var row = 0; row < grids.length; row++) {
    var columnSize = rectShape[columnSizeDim] / grids[row];
    for (var column = 0; column < grids[row]; column++) {
      var newShape = {};
      newShape[rowDim] = row * rowSize;
      newShape[columnDim] = column * columnSize;
      newShape[rowSizeDim] = rowSize;
      newShape[columnSizeDim] = columnSize;
      newShape.x += rectShape.x;
      newShape.y += rectShape.y;
      outShapes.push(newShape);
    }
  }
}
function crossProduct2d(x1, y1, x2, y2) {
  return x1 * y2 - x2 * y1;
}
function lineLineIntersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y) {
  var mx = a2x - a1x;
  var my = a2y - a1y;
  var nx = b2x - b1x;
  var ny = b2y - b1y;
  var nmCrossProduct = crossProduct2d(nx, ny, mx, my);
  if (Math.abs(nmCrossProduct) < 1e-6) {
    return null;
  }
  var b1a1x = a1x - b1x;
  var b1a1y = a1y - b1y;
  var p2 = crossProduct2d(b1a1x, b1a1y, nx, ny) / nmCrossProduct;
  if (p2 < 0 || p2 > 1) {
    return null;
  }
  return new Point$1(p2 * mx + a1x, p2 * my + a1y);
}
function projPtOnLine(pt, lineA, lineB) {
  var dir3 = new Point$1();
  Point$1.sub(dir3, lineB, lineA);
  dir3.normalize();
  var dir22 = new Point$1();
  Point$1.sub(dir22, pt, lineA);
  var len2 = dir22.dot(dir3);
  return len2;
}
function addToPoly(poly, pt) {
  var last = poly[poly.length - 1];
  if (last && last[0] === pt[0] && last[1] === pt[1]) {
    return;
  }
  poly.push(pt);
}
function splitPolygonByLine(points2, lineA, lineB) {
  var len2 = points2.length;
  var intersections = [];
  for (var i = 0; i < len2; i++) {
    var p0 = points2[i];
    var p1 = points2[(i + 1) % len2];
    var intersectionPt = lineLineIntersect(p0[0], p0[1], p1[0], p1[1], lineA.x, lineA.y, lineB.x, lineB.y);
    if (intersectionPt) {
      intersections.push({
        projPt: projPtOnLine(intersectionPt, lineA, lineB),
        pt: intersectionPt,
        idx: i
      });
    }
  }
  if (intersections.length < 2) {
    return [{ points: points2 }, { points: points2 }];
  }
  intersections.sort(function(a, b2) {
    return a.projPt - b2.projPt;
  });
  var splitPt0 = intersections[0];
  var splitPt1 = intersections[intersections.length - 1];
  if (splitPt1.idx < splitPt0.idx) {
    var tmp = splitPt0;
    splitPt0 = splitPt1;
    splitPt1 = tmp;
  }
  var splitPt0Arr = [splitPt0.pt.x, splitPt0.pt.y];
  var splitPt1Arr = [splitPt1.pt.x, splitPt1.pt.y];
  var newPolyA = [splitPt0Arr];
  var newPolyB = [splitPt1Arr];
  for (var i = splitPt0.idx + 1; i <= splitPt1.idx; i++) {
    addToPoly(newPolyA, points2[i].slice());
  }
  addToPoly(newPolyA, splitPt1Arr);
  addToPoly(newPolyA, splitPt0Arr);
  for (var i = splitPt1.idx + 1; i <= splitPt0.idx + len2; i++) {
    addToPoly(newPolyB, points2[i % len2].slice());
  }
  addToPoly(newPolyB, splitPt0Arr);
  addToPoly(newPolyB, splitPt1Arr);
  return [{
    points: newPolyA
  }, {
    points: newPolyB
  }];
}
function binaryDividePolygon(polygonShape) {
  var points2 = polygonShape.points;
  var min3 = [];
  var max3 = [];
  fromPoints(points2, min3, max3);
  var boundingRect = new BoundingRect$1(min3[0], min3[1], max3[0] - min3[0], max3[1] - min3[1]);
  var width = boundingRect.width;
  var height = boundingRect.height;
  var x2 = boundingRect.x;
  var y2 = boundingRect.y;
  var pt02 = new Point$1();
  var pt12 = new Point$1();
  if (width > height) {
    pt02.x = pt12.x = x2 + width / 2;
    pt02.y = y2;
    pt12.y = y2 + height;
  } else {
    pt02.y = pt12.y = y2 + height / 2;
    pt02.x = x2;
    pt12.x = x2 + width;
  }
  return splitPolygonByLine(points2, pt02, pt12);
}
function binaryDivideRecursive(divider, shape, count2, out2) {
  if (count2 === 1) {
    out2.push(shape);
  } else {
    var mid = Math.floor(count2 / 2);
    var sub2 = divider(shape);
    binaryDivideRecursive(divider, sub2[0], mid, out2);
    binaryDivideRecursive(divider, sub2[1], count2 - mid, out2);
  }
  return out2;
}
function clone(path, count2) {
  var paths = [];
  for (var i = 0; i < count2; i++) {
    paths.push(clonePath(path));
  }
  return paths;
}
function copyPathProps(source, target) {
  target.setStyle(source.style);
  target.z = source.z;
  target.z2 = source.z2;
  target.zlevel = source.zlevel;
}
function polygonConvert(points2) {
  var out2 = [];
  for (var i = 0; i < points2.length; ) {
    out2.push([points2[i++], points2[i++]]);
  }
  return out2;
}
function split(path, count2) {
  var outShapes = [];
  var shape = path.shape;
  var OutShapeCtor;
  switch (path.type) {
    case "rect":
      divideRect(shape, count2, outShapes);
      OutShapeCtor = Rect$3;
      break;
    case "sector":
      divideSector(shape, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    case "circle":
      divideSector({
        r0: 0,
        r: shape.r,
        startAngle: 0,
        endAngle: Math.PI * 2,
        cx: shape.cx,
        cy: shape.cy
      }, count2, outShapes);
      OutShapeCtor = Sector$1;
      break;
    default:
      var m2 = path.getComputedTransform();
      var scale2 = m2 ? Math.sqrt(Math.max(m2[0] * m2[0] + m2[1] * m2[1], m2[2] * m2[2] + m2[3] * m2[3])) : 1;
      var polygons = map$1(pathToPolygons(path.getUpdatedPathProxy(), scale2), function(poly) {
        return polygonConvert(poly);
      });
      var polygonCount = polygons.length;
      if (polygonCount === 0) {
        binaryDivideRecursive(binaryDividePolygon, {
          points: polygons[0]
        }, count2, outShapes);
      } else if (polygonCount === count2) {
        for (var i = 0; i < polygonCount; i++) {
          outShapes.push({
            points: polygons[i]
          });
        }
      } else {
        var totalArea_1 = 0;
        var items = map$1(polygons, function(poly) {
          var min3 = [];
          var max3 = [];
          fromPoints(poly, min3, max3);
          var area = (max3[1] - min3[1]) * (max3[0] - min3[0]);
          totalArea_1 += area;
          return { poly, area };
        });
        items.sort(function(a, b2) {
          return b2.area - a.area;
        });
        var left = count2;
        for (var i = 0; i < polygonCount; i++) {
          var item = items[i];
          if (left <= 0) {
            break;
          }
          var selfCount = i === polygonCount - 1 ? left : Math.ceil(item.area / totalArea_1 * count2);
          if (selfCount < 0) {
            continue;
          }
          binaryDivideRecursive(binaryDividePolygon, {
            points: item.poly
          }, selfCount, outShapes);
          left -= selfCount;
        }
      }
      OutShapeCtor = Polygon$1;
      break;
  }
  if (!OutShapeCtor) {
    return clone(path, count2);
  }
  var out2 = [];
  for (var i = 0; i < outShapes.length; i++) {
    var subPath = new OutShapeCtor();
    subPath.setShape(outShapes[i]);
    copyPathProps(path, subPath);
    out2.push(subPath);
  }
  return out2;
}
function alignSubpath(subpath1, subpath2) {
  var len1 = subpath1.length;
  var len2 = subpath2.length;
  if (len1 === len2) {
    return [subpath1, subpath2];
  }
  var tmpSegX = [];
  var tmpSegY = [];
  var shorterPath = len1 < len2 ? subpath1 : subpath2;
  var shorterLen = Math.min(len1, len2);
  var diff = Math.abs(len2 - len1) / 6;
  var shorterBezierCount = (shorterLen - 2) / 6;
  var eachCurveSubDivCount = Math.ceil(diff / shorterBezierCount) + 1;
  var newSubpath = [shorterPath[0], shorterPath[1]];
  var remained = diff;
  for (var i = 2; i < shorterLen; ) {
    var x0 = shorterPath[i - 2];
    var y0 = shorterPath[i - 1];
    var x1 = shorterPath[i++];
    var y1 = shorterPath[i++];
    var x2 = shorterPath[i++];
    var y2 = shorterPath[i++];
    var x3 = shorterPath[i++];
    var y3 = shorterPath[i++];
    if (remained <= 0) {
      newSubpath.push(x1, y1, x2, y2, x3, y3);
      continue;
    }
    var actualSubDivCount = Math.min(remained, eachCurveSubDivCount - 1) + 1;
    for (var k2 = 1; k2 <= actualSubDivCount; k2++) {
      var p2 = k2 / actualSubDivCount;
      cubicSubdivide(x0, x1, x2, x3, p2, tmpSegX);
      cubicSubdivide(y0, y1, y2, y3, p2, tmpSegY);
      x0 = tmpSegX[3];
      y0 = tmpSegY[3];
      newSubpath.push(tmpSegX[1], tmpSegY[1], tmpSegX[2], tmpSegY[2], x0, y0);
      x1 = tmpSegX[5];
      y1 = tmpSegY[5];
      x2 = tmpSegX[6];
      y2 = tmpSegY[6];
    }
    remained -= actualSubDivCount - 1;
  }
  return shorterPath === subpath1 ? [newSubpath, subpath2] : [subpath1, newSubpath];
}
function createSubpath(lastSubpathSubpath, otherSubpath) {
  var len2 = lastSubpathSubpath.length;
  var lastX = lastSubpathSubpath[len2 - 2];
  var lastY = lastSubpathSubpath[len2 - 1];
  var newSubpath = [];
  for (var i = 0; i < otherSubpath.length; ) {
    newSubpath[i++] = lastX;
    newSubpath[i++] = lastY;
  }
  return newSubpath;
}
function alignBezierCurves(array1, array22) {
  var _a2;
  var lastSubpath1;
  var lastSubpath2;
  var newArray1 = [];
  var newArray2 = [];
  for (var i = 0; i < Math.max(array1.length, array22.length); i++) {
    var subpath1 = array1[i];
    var subpath2 = array22[i];
    var newSubpath1 = void 0;
    var newSubpath2 = void 0;
    if (!subpath1) {
      newSubpath1 = createSubpath(lastSubpath1 || subpath2, subpath2);
      newSubpath2 = subpath2;
    } else if (!subpath2) {
      newSubpath2 = createSubpath(lastSubpath2 || subpath1, subpath1);
      newSubpath1 = subpath1;
    } else {
      _a2 = alignSubpath(subpath1, subpath2), newSubpath1 = _a2[0], newSubpath2 = _a2[1];
      lastSubpath1 = newSubpath1;
      lastSubpath2 = newSubpath2;
    }
    newArray1.push(newSubpath1);
    newArray2.push(newSubpath2);
  }
  return [newArray1, newArray2];
}
function centroid(array4) {
  var signedArea = 0;
  var cx = 0;
  var cy = 0;
  var len2 = array4.length;
  for (var i = 0, j = len2 - 2; i < len2; j = i, i += 2) {
    var x0 = array4[j];
    var y0 = array4[j + 1];
    var x1 = array4[i];
    var y1 = array4[i + 1];
    var a = x0 * y1 - x1 * y0;
    signedArea += a;
    cx += (x0 + x1) * a;
    cy += (y0 + y1) * a;
  }
  if (signedArea === 0) {
    return [array4[0] || 0, array4[1] || 0];
  }
  return [cx / signedArea / 3, cy / signedArea / 3, signedArea];
}
function findBestRingOffset(fromSubBeziers, toSubBeziers, fromCp, toCp) {
  var bezierCount = (fromSubBeziers.length - 2) / 6;
  var bestScore = Infinity;
  var bestOffset = 0;
  var len2 = fromSubBeziers.length;
  var len22 = len2 - 2;
  for (var offset = 0; offset < bezierCount; offset++) {
    var cursorOffset = offset * 6;
    var score = 0;
    for (var k2 = 0; k2 < len2; k2 += 2) {
      var idx = k2 === 0 ? cursorOffset : (cursorOffset + k2 - 2) % len22 + 2;
      var x0 = fromSubBeziers[idx] - fromCp[0];
      var y0 = fromSubBeziers[idx + 1] - fromCp[1];
      var x1 = toSubBeziers[k2] - toCp[0];
      var y1 = toSubBeziers[k2 + 1] - toCp[1];
      var dx = x1 - x0;
      var dy = y1 - y0;
      score += dx * dx + dy * dy;
    }
    if (score < bestScore) {
      bestScore = score;
      bestOffset = offset;
    }
  }
  return bestOffset;
}
function reverse(array4) {
  var newArr = [];
  var len2 = array4.length;
  for (var i = 0; i < len2; i += 2) {
    newArr[i] = array4[len2 - i - 2];
    newArr[i + 1] = array4[len2 - i - 1];
  }
  return newArr;
}
function findBestMorphingRotation(fromArr, toArr2, searchAngleIteration, searchAngleRange) {
  var result = [];
  var fromNeedsReverse;
  for (var i = 0; i < fromArr.length; i++) {
    var fromSubpathBezier = fromArr[i];
    var toSubpathBezier = toArr2[i];
    var fromCp = centroid(fromSubpathBezier);
    var toCp = centroid(toSubpathBezier);
    if (fromNeedsReverse == null) {
      fromNeedsReverse = fromCp[2] < 0 !== toCp[2] < 0;
    }
    var newFromSubpathBezier = [];
    var newToSubpathBezier = [];
    var bestAngle = 0;
    var bestScore = Infinity;
    var tmpArr2 = [];
    var len2 = fromSubpathBezier.length;
    if (fromNeedsReverse) {
      fromSubpathBezier = reverse(fromSubpathBezier);
    }
    var offset = findBestRingOffset(fromSubpathBezier, toSubpathBezier, fromCp, toCp) * 6;
    var len22 = len2 - 2;
    for (var k2 = 0; k2 < len22; k2 += 2) {
      var idx = (offset + k2) % len22 + 2;
      newFromSubpathBezier[k2 + 2] = fromSubpathBezier[idx] - fromCp[0];
      newFromSubpathBezier[k2 + 3] = fromSubpathBezier[idx + 1] - fromCp[1];
    }
    newFromSubpathBezier[0] = fromSubpathBezier[offset] - fromCp[0];
    newFromSubpathBezier[1] = fromSubpathBezier[offset + 1] - fromCp[1];
    if (searchAngleIteration > 0) {
      var step = searchAngleRange / searchAngleIteration;
      for (var angle = -searchAngleRange / 2; angle <= searchAngleRange / 2; angle += step) {
        var sa = Math.sin(angle);
        var ca = Math.cos(angle);
        var score = 0;
        for (var k2 = 0; k2 < fromSubpathBezier.length; k2 += 2) {
          var x0 = newFromSubpathBezier[k2];
          var y0 = newFromSubpathBezier[k2 + 1];
          var x1 = toSubpathBezier[k2] - toCp[0];
          var y1 = toSubpathBezier[k2 + 1] - toCp[1];
          var newX1 = x1 * ca - y1 * sa;
          var newY1 = x1 * sa + y1 * ca;
          tmpArr2[k2] = newX1;
          tmpArr2[k2 + 1] = newY1;
          var dx = newX1 - x0;
          var dy = newY1 - y0;
          score += dx * dx + dy * dy;
        }
        if (score < bestScore) {
          bestScore = score;
          bestAngle = angle;
          for (var m2 = 0; m2 < tmpArr2.length; m2++) {
            newToSubpathBezier[m2] = tmpArr2[m2];
          }
        }
      }
    } else {
      for (var i_1 = 0; i_1 < len2; i_1 += 2) {
        newToSubpathBezier[i_1] = toSubpathBezier[i_1] - toCp[0];
        newToSubpathBezier[i_1 + 1] = toSubpathBezier[i_1 + 1] - toCp[1];
      }
    }
    result.push({
      from: newFromSubpathBezier,
      to: newToSubpathBezier,
      fromCp,
      toCp,
      rotation: -bestAngle
    });
  }
  return result;
}
function isCombineMorphing(path) {
  return path.__isCombineMorphing;
}
var SAVED_METHOD_PREFIX = "__mOriginal_";
function saveAndModifyMethod(obj, methodName, modifiers) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  var originalMethod = obj[savedMethodName] || obj[methodName];
  if (!obj[savedMethodName]) {
    obj[savedMethodName] = obj[methodName];
  }
  var replace = modifiers.replace;
  var after = modifiers.after;
  var before = modifiers.before;
  obj[methodName] = function() {
    var args = arguments;
    var res;
    before && before.apply(this, args);
    if (replace) {
      res = replace.apply(this, args);
    } else {
      res = originalMethod.apply(this, args);
    }
    after && after.apply(this, args);
    return res;
  };
}
function restoreMethod(obj, methodName) {
  var savedMethodName = SAVED_METHOD_PREFIX + methodName;
  if (obj[savedMethodName]) {
    obj[methodName] = obj[savedMethodName];
    obj[savedMethodName] = null;
  }
}
function applyTransformOnBeziers(bezierCurves, mm) {
  for (var i = 0; i < bezierCurves.length; i++) {
    var subBeziers = bezierCurves[i];
    for (var k2 = 0; k2 < subBeziers.length; ) {
      var x2 = subBeziers[k2];
      var y2 = subBeziers[k2 + 1];
      subBeziers[k2++] = mm[0] * x2 + mm[2] * y2 + mm[4];
      subBeziers[k2++] = mm[1] * x2 + mm[3] * y2 + mm[5];
    }
  }
}
function prepareMorphPath(fromPath, toPath) {
  var fromPathProxy = fromPath.getUpdatedPathProxy();
  var toPathProxy = toPath.getUpdatedPathProxy();
  var _a2 = alignBezierCurves(pathToBezierCurves(fromPathProxy), pathToBezierCurves(toPathProxy)), fromBezierCurves = _a2[0], toBezierCurves = _a2[1];
  var fromPathTransform = fromPath.getComputedTransform();
  var toPathTransform = toPath.getComputedTransform();
  function updateIdentityTransform() {
    this.transform = null;
  }
  fromPathTransform && applyTransformOnBeziers(fromBezierCurves, fromPathTransform);
  toPathTransform && applyTransformOnBeziers(toBezierCurves, toPathTransform);
  saveAndModifyMethod(toPath, "updateTransform", { replace: updateIdentityTransform });
  toPath.transform = null;
  var morphingData = findBestMorphingRotation(fromBezierCurves, toBezierCurves, 10, Math.PI);
  var tmpArr2 = [];
  saveAndModifyMethod(toPath, "buildPath", { replace: function(path) {
    var t2 = toPath.__morphT;
    var onet = 1 - t2;
    var newCp = [];
    for (var i = 0; i < morphingData.length; i++) {
      var item = morphingData[i];
      var from = item.from;
      var to = item.to;
      var angle = item.rotation * t2;
      var fromCp = item.fromCp;
      var toCp = item.toCp;
      var sa = Math.sin(angle);
      var ca = Math.cos(angle);
      lerp$1(newCp, fromCp, toCp, t2);
      for (var m2 = 0; m2 < from.length; m2 += 2) {
        var x0_1 = from[m2];
        var y0_1 = from[m2 + 1];
        var x1 = to[m2];
        var y1 = to[m2 + 1];
        var x2 = x0_1 * onet + x1 * t2;
        var y2 = y0_1 * onet + y1 * t2;
        tmpArr2[m2] = x2 * ca - y2 * sa + newCp[0];
        tmpArr2[m2 + 1] = x2 * sa + y2 * ca + newCp[1];
      }
      var x0 = tmpArr2[0];
      var y0 = tmpArr2[1];
      path.moveTo(x0, y0);
      for (var m2 = 2; m2 < from.length; ) {
        var x1 = tmpArr2[m2++];
        var y1 = tmpArr2[m2++];
        var x22 = tmpArr2[m2++];
        var y22 = tmpArr2[m2++];
        var x3 = tmpArr2[m2++];
        var y3 = tmpArr2[m2++];
        if (x0 === x1 && y0 === y1 && x22 === x3 && y22 === y3) {
          path.lineTo(x3, y3);
        } else {
          path.bezierCurveTo(x1, y1, x22, y22, x3, y3);
        }
        x0 = x3;
        y0 = y3;
      }
    }
  } });
}
function morphPath(fromPath, toPath, animationOpts) {
  if (!fromPath || !toPath) {
    return toPath;
  }
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  prepareMorphPath(fromPath, toPath);
  toPath.__morphT = 0;
  function restoreToPath() {
    restoreMethod(toPath, "buildPath");
    restoreMethod(toPath, "updateTransform");
    toPath.__morphT = -1;
    toPath.createPathProxy();
    toPath.dirtyShape();
  }
  toPath.animateTo({
    __morphT: 1
  }, defaults({
    during: function(p2) {
      toPath.dirtyShape();
      oldDuring && oldDuring(p2);
    },
    done: function() {
      restoreToPath();
      oldDone && oldDone();
    }
  }, animationOpts));
  return toPath;
}
function hilbert(x2, y2, minX, minY, maxX, maxY) {
  var bits = 16;
  x2 = maxX === minX ? 0 : Math.round(32767 * (x2 - minX) / (maxX - minX));
  y2 = maxY === minY ? 0 : Math.round(32767 * (y2 - minY) / (maxY - minY));
  var d2 = 0;
  var tmp;
  for (var s = (1 << bits) / 2; s > 0; s /= 2) {
    var rx = 0;
    var ry = 0;
    if ((x2 & s) > 0) {
      rx = 1;
    }
    if ((y2 & s) > 0) {
      ry = 1;
    }
    d2 += s * s * (3 * rx ^ ry);
    if (ry === 0) {
      if (rx === 1) {
        x2 = s - 1 - x2;
        y2 = s - 1 - y2;
      }
      tmp = x2;
      x2 = y2;
      y2 = tmp;
    }
  }
  return d2;
}
function sortPaths(pathList) {
  var xMin = Infinity;
  var yMin = Infinity;
  var xMax = -Infinity;
  var yMax = -Infinity;
  var cps = map$1(pathList, function(path) {
    var rect = path.getBoundingRect();
    var m2 = path.getComputedTransform();
    var x2 = rect.x + rect.width / 2 + (m2 ? m2[4] : 0);
    var y2 = rect.y + rect.height / 2 + (m2 ? m2[5] : 0);
    xMin = Math.min(x2, xMin);
    yMin = Math.min(y2, yMin);
    xMax = Math.max(x2, xMax);
    yMax = Math.max(y2, yMax);
    return [x2, y2];
  });
  var items = map$1(cps, function(cp, idx) {
    return {
      cp,
      z: hilbert(cp[0], cp[1], xMin, yMin, xMax, yMax),
      path: pathList[idx]
    };
  });
  return items.sort(function(a, b2) {
    return a.z - b2.z;
  }).map(function(item) {
    return item.path;
  });
}
function defaultDividePath(param) {
  return split(param.path, param.count);
}
function createEmptyReturn() {
  return {
    fromIndividuals: [],
    toIndividuals: [],
    count: 0
  };
}
function combineMorph(fromList, toPath, animationOpts) {
  var fromPathList = [];
  function addFromPath(fromList2) {
    for (var i2 = 0; i2 < fromList2.length; i2++) {
      var from2 = fromList2[i2];
      if (isCombineMorphing(from2)) {
        addFromPath(from2.childrenRef());
      } else if (from2 instanceof Path$1) {
        fromPathList.push(from2);
      }
    }
  }
  addFromPath(fromList);
  var separateCount = fromPathList.length;
  if (!separateCount) {
    return createEmptyReturn();
  }
  var dividePath = animationOpts.dividePath || defaultDividePath;
  var toSubPathList = dividePath({
    path: toPath,
    count: separateCount
  });
  if (toSubPathList.length !== separateCount) {
    console.error("Invalid morphing: unmatched splitted path");
    return createEmptyReturn();
  }
  fromPathList = sortPaths(fromPathList);
  toSubPathList = sortPaths(toSubPathList);
  var oldDone = animationOpts.done;
  var oldDuring = animationOpts.during;
  var individualDelay = animationOpts.individualDelay;
  var identityTransform = new Transformable$1();
  for (var i = 0; i < separateCount; i++) {
    var from = fromPathList[i];
    var to = toSubPathList[i];
    to.parent = toPath;
    to.copyTransform(identityTransform);
    if (!individualDelay) {
      prepareMorphPath(from, to);
    }
  }
  toPath.__isCombineMorphing = true;
  toPath.childrenRef = function() {
    return toSubPathList;
  };
  function addToSubPathListToZr(zr) {
    for (var i2 = 0; i2 < toSubPathList.length; i2++) {
      toSubPathList[i2].addSelfToZr(zr);
    }
  }
  saveAndModifyMethod(toPath, "addSelfToZr", {
    after: function(zr) {
      addToSubPathListToZr(zr);
    }
  });
  saveAndModifyMethod(toPath, "removeSelfFromZr", {
    after: function(zr) {
      for (var i2 = 0; i2 < toSubPathList.length; i2++) {
        toSubPathList[i2].removeSelfFromZr(zr);
      }
    }
  });
  function restoreToPath() {
    toPath.__isCombineMorphing = false;
    toPath.__morphT = -1;
    toPath.childrenRef = null;
    restoreMethod(toPath, "addSelfToZr");
    restoreMethod(toPath, "removeSelfFromZr");
  }
  var toLen = toSubPathList.length;
  if (individualDelay) {
    var animating_1 = toLen;
    var eachDone = function() {
      animating_1--;
      if (animating_1 === 0) {
        restoreToPath();
        oldDone && oldDone();
      }
    };
    for (var i = 0; i < toLen; i++) {
      var indivdualAnimationOpts = individualDelay ? defaults({
        delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toSubPathList[i]),
        done: eachDone
      }, animationOpts) : animationOpts;
      morphPath(fromPathList[i], toSubPathList[i], indivdualAnimationOpts);
    }
  } else {
    toPath.__morphT = 0;
    toPath.animateTo({
      __morphT: 1
    }, defaults({
      during: function(p2) {
        for (var i2 = 0; i2 < toLen; i2++) {
          var child = toSubPathList[i2];
          child.__morphT = toPath.__morphT;
          child.dirtyShape();
        }
        oldDuring && oldDuring(p2);
      },
      done: function() {
        restoreToPath();
        for (var i2 = 0; i2 < fromList.length; i2++) {
          restoreMethod(fromList[i2], "updateTransform");
        }
        oldDone && oldDone();
      }
    }, animationOpts));
  }
  if (toPath.__zr) {
    addToSubPathListToZr(toPath.__zr);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toSubPathList,
    count: toLen
  };
}
function separateMorph(fromPath, toPathList, animationOpts) {
  var toLen = toPathList.length;
  var fromPathList = [];
  var dividePath = animationOpts.dividePath || defaultDividePath;
  function addFromPath(fromList) {
    for (var i2 = 0; i2 < fromList.length; i2++) {
      var from = fromList[i2];
      if (isCombineMorphing(from)) {
        addFromPath(from.childrenRef());
      } else if (from instanceof Path$1) {
        fromPathList.push(from);
      }
    }
  }
  if (isCombineMorphing(fromPath)) {
    addFromPath(fromPath.childrenRef());
    var fromLen = fromPathList.length;
    if (fromLen < toLen) {
      var k2 = 0;
      for (var i = fromLen; i < toLen; i++) {
        fromPathList.push(clonePath(fromPathList[k2++ % fromLen]));
      }
    }
    fromPathList.length = toLen;
  } else {
    fromPathList = dividePath({ path: fromPath, count: toLen });
    var fromPathTransform = fromPath.getComputedTransform();
    for (var i = 0; i < fromPathList.length; i++) {
      fromPathList[i].setLocalTransform(fromPathTransform);
    }
    if (fromPathList.length !== toLen) {
      console.error("Invalid morphing: unmatched splitted path");
      return createEmptyReturn();
    }
  }
  fromPathList = sortPaths(fromPathList);
  toPathList = sortPaths(toPathList);
  var individualDelay = animationOpts.individualDelay;
  for (var i = 0; i < toLen; i++) {
    var indivdualAnimationOpts = individualDelay ? defaults({
      delay: (animationOpts.delay || 0) + individualDelay(i, toLen, fromPathList[i], toPathList[i])
    }, animationOpts) : animationOpts;
    morphPath(fromPathList[i], toPathList[i], indivdualAnimationOpts);
  }
  return {
    fromIndividuals: fromPathList,
    toIndividuals: toPathList,
    count: toPathList.length
  };
}
function isMultiple(elements) {
  return isArray$1(elements[0]);
}
function prepareMorphBatches(one, many) {
  var batches = [];
  var batchCount = one.length;
  for (var i = 0; i < batchCount; i++) {
    batches.push({
      one: one[i],
      many: []
    });
  }
  for (var i = 0; i < many.length; i++) {
    var len2 = many[i].length;
    var k2 = void 0;
    for (k2 = 0; k2 < len2; k2++) {
      batches[k2 % batchCount].many.push(many[i][k2]);
    }
  }
  var off = 0;
  for (var i = batchCount - 1; i >= 0; i--) {
    if (!batches[i].many.length) {
      var moveFrom = batches[off].many;
      if (moveFrom.length <= 1) {
        if (off) {
          off = 0;
        } else {
          return batches;
        }
      }
      var len2 = moveFrom.length;
      var mid = Math.ceil(len2 / 2);
      batches[i].many = moveFrom.slice(mid, len2);
      batches[off].many = moveFrom.slice(0, mid);
      off++;
    }
  }
  return batches;
}
var pathDividers = {
  clone: function(params) {
    var ret = [];
    var approxOpacity = 1 - Math.pow(1 - params.path.style.opacity, 1 / params.count);
    for (var i = 0; i < params.count; i++) {
      var cloned = clonePath(params.path);
      cloned.setStyle("opacity", approxOpacity);
      ret.push(cloned);
    }
    return ret;
  },
  split: null
};
function applyMorphAnimation(from, to, divideShape, seriesModel, dataIndex, animateOtherProps) {
  if (!from.length || !to.length) {
    return;
  }
  var updateAnimationCfg = getAnimationConfig("update", seriesModel, dataIndex);
  if (!(updateAnimationCfg && updateAnimationCfg.duration > 0)) {
    return;
  }
  var animationDelay = seriesModel.getModel("universalTransition").get("delay");
  var animationCfg = Object.assign({
    setToFinal: true
  }, updateAnimationCfg);
  var many;
  var one;
  if (isMultiple(from)) {
    many = from;
    one = to;
  }
  if (isMultiple(to)) {
    many = to;
    one = from;
  }
  function morphOneBatch(batch, fromIsMany2, animateIndex2, animateCount2, forceManyOne) {
    var batchMany = batch.many;
    var batchOne = batch.one;
    if (batchMany.length === 1 && !forceManyOne) {
      var batchFrom = fromIsMany2 ? batchMany[0] : batchOne;
      var batchTo = fromIsMany2 ? batchOne : batchMany[0];
      if (isCombineMorphing(batchFrom)) {
        morphOneBatch({
          many: [batchFrom],
          one: batchTo
        }, true, animateIndex2, animateCount2, true);
      } else {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(animateIndex2, animateCount2)
        }, animationCfg) : animationCfg;
        morphPath(batchFrom, batchTo, individualAnimationCfg);
        animateOtherProps(batchFrom, batchTo, batchFrom, batchTo, individualAnimationCfg);
      }
    } else {
      var separateAnimationCfg = defaults({
        dividePath: pathDividers[divideShape],
        individualDelay: animationDelay && function(idx, count3, fromPath, toPath) {
          return animationDelay(idx + animateIndex2, animateCount2);
        }
      }, animationCfg);
      var _a2 = fromIsMany2 ? combineMorph(batchMany, batchOne, separateAnimationCfg) : separateMorph(batchOne, batchMany, separateAnimationCfg), fromIndividuals = _a2.fromIndividuals, toIndividuals = _a2.toIndividuals;
      var count2 = fromIndividuals.length;
      for (var k2 = 0; k2 < count2; k2++) {
        var individualAnimationCfg = animationDelay ? defaults({
          delay: animationDelay(k2, count2)
        }, animationCfg) : animationCfg;
        animateOtherProps(fromIndividuals[k2], toIndividuals[k2], fromIsMany2 ? batchMany[k2] : batch.one, fromIsMany2 ? batch.one : batchMany[k2], individualAnimationCfg);
      }
    }
  }
  var fromIsMany = many ? many === from : from.length > to.length;
  var morphBatches = many ? prepareMorphBatches(one, many) : prepareMorphBatches(fromIsMany ? to : from, [fromIsMany ? from : to]);
  var animateCount = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    animateCount += morphBatches[i].many.length;
  }
  var animateIndex = 0;
  for (var i = 0; i < morphBatches.length; i++) {
    morphOneBatch(morphBatches[i], fromIsMany, animateIndex, animateCount);
    animateIndex += morphBatches[i].many.length;
  }
}
function getPathList(elements) {
  if (!elements) {
    return [];
  }
  if (isArray$1(elements)) {
    var pathList_1 = [];
    for (var i = 0; i < elements.length; i++) {
      pathList_1.push(getPathList(elements[i]));
    }
    return pathList_1;
  }
  var pathList = [];
  elements.traverse(function(el) {
    if (el instanceof Path$1 && !el.disableMorphing && !el.invisible && !el.ignore) {
      pathList.push(el);
    }
  });
  return pathList;
}
var DATA_COUNT_THRESHOLD = 1e4;
var getUniversalTransitionGlobalStore = makeInner();
function getGroupIdDimension(data) {
  var dimensions = data.dimensions;
  for (var i = 0; i < dimensions.length; i++) {
    var dimInfo = data.getDimensionInfo(dimensions[i]);
    if (dimInfo && dimInfo.otherDims.itemGroupId === 0) {
      return dimensions[i];
    }
  }
}
function flattenDataDiffItems(list) {
  var items = [];
  each$f(list, function(seriesInfo) {
    var data = seriesInfo.data;
    if (data.count() > DATA_COUNT_THRESHOLD) {
      return;
    }
    var indices = data.getIndices();
    var groupDim = getGroupIdDimension(data);
    for (var dataIndex = 0; dataIndex < indices.length; dataIndex++) {
      items.push({
        data,
        dim: seriesInfo.dim || groupDim,
        divide: seriesInfo.divide,
        dataIndex
      });
    }
  });
  return items;
}
function fadeInElement(newEl2, newSeries, newIndex) {
  newEl2.traverse(function(el) {
    if (el instanceof Path$1) {
      initProps(el, {
        style: {
          opacity: 0
        }
      }, newSeries, {
        dataIndex: newIndex,
        isFrom: true
      });
    }
  });
}
function removeEl(el) {
  if (el.parent) {
    var computedTransform = el.getComputedTransform();
    el.setLocalTransform(computedTransform);
    el.parent.remove(el);
  }
}
function stopAnimation(el) {
  el.stopAnimation();
  if (el.isGroup) {
    el.traverse(function(child) {
      child.stopAnimation();
    });
  }
}
function animateElementStyles(el, dataIndex, seriesModel) {
  var animationConfig = getAnimationConfig("update", seriesModel, dataIndex);
  animationConfig && el.traverse(function(child) {
    if (child instanceof Displayable$1) {
      var oldStyle = getOldStyle(child);
      if (oldStyle) {
        child.animateFrom({
          style: oldStyle
        }, animationConfig);
      }
    }
  });
}
function isAllIdSame(oldDiffItems, newDiffItems) {
  var len2 = oldDiffItems.length;
  if (len2 !== newDiffItems.length) {
    return false;
  }
  for (var i = 0; i < len2; i++) {
    var oldItem = oldDiffItems[i];
    var newItem = newDiffItems[i];
    if (oldItem.data.getId(oldItem.dataIndex) !== newItem.data.getId(newItem.dataIndex)) {
      return false;
    }
  }
  return true;
}
function transitionBetween(oldList, newList, api) {
  var oldDiffItems = flattenDataDiffItems(oldList);
  var newDiffItems = flattenDataDiffItems(newList);
  function updateMorphingPathProps(from, to, rawFrom, rawTo, animationCfg) {
    if (rawFrom || from) {
      to.animateFrom({
        style: rawFrom && rawFrom !== from ? extend(extend({}, rawFrom.style), from.style) : from.style
      }, animationCfg);
    }
  }
  function findKeyDim(items) {
    for (var i2 = 0; i2 < items.length; i2++) {
      if (items[i2].dim) {
        return items[i2].dim;
      }
    }
  }
  var oldKeyDim = findKeyDim(oldDiffItems);
  var newKeyDim = findKeyDim(newDiffItems);
  var hasMorphAnimation = false;
  function createKeyGetter(isOld, onlyGetId) {
    return function(diffItem) {
      var data = diffItem.data;
      var dataIndex = diffItem.dataIndex;
      if (onlyGetId) {
        return data.getId(dataIndex);
      }
      var dataGroupId = data.hostModel && data.hostModel.get("dataGroupId");
      var keyDim = isOld ? oldKeyDim || newKeyDim : newKeyDim || oldKeyDim;
      var dimInfo = keyDim && data.getDimensionInfo(keyDim);
      var dimOrdinalMeta = dimInfo && dimInfo.ordinalMeta;
      if (dimInfo) {
        var key = data.get(dimInfo.name, dataIndex);
        if (dimOrdinalMeta) {
          return dimOrdinalMeta.categories[key] || key + "";
        }
        return key + "";
      }
      var itemVal = data.getRawDataItem(dataIndex);
      if (itemVal && itemVal.groupId) {
        return itemVal.groupId + "";
      }
      return dataGroupId || data.getId(dataIndex);
    };
  }
  var useId = isAllIdSame(oldDiffItems, newDiffItems);
  var isElementStillInChart = {};
  if (!useId) {
    for (var i = 0; i < newDiffItems.length; i++) {
      var newItem = newDiffItems[i];
      var el = newItem.data.getItemGraphicEl(newItem.dataIndex);
      if (el) {
        isElementStillInChart[el.id] = true;
      }
    }
  }
  function updateOneToOne(newIndex, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var newItem2 = newDiffItems[newIndex];
    var newSeries = newItem2.data.hostModel;
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    var newEl2 = newItem2.data.getItemGraphicEl(newItem2.dataIndex);
    if (oldEl === newEl2) {
      newEl2 && animateElementStyles(newEl2, newItem2.dataIndex, newSeries);
      return;
    }
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newIndex);
      }
    }
  }
  new DataDiffer$1(oldDiffItems, newDiffItems, createKeyGetter(true, useId), createKeyGetter(false, useId), null, "multiple").update(updateOneToOne).updateManyToOne(function(newIndex, oldIndices) {
    var newItem2 = newDiffItems[newIndex];
    var newData = newItem2.data;
    var newSeries = newData.hostModel;
    var newEl2 = newData.getItemGraphicEl(newItem2.dataIndex);
    var oldElsList = filter(map$1(oldIndices, function(idx) {
      return oldDiffItems[idx].data.getItemGraphicEl(oldDiffItems[idx].dataIndex);
    }), function(oldEl) {
      return oldEl && oldEl !== newEl2 && !isElementStillInChart[oldEl.id];
    });
    if (newEl2) {
      stopAnimation(newEl2);
      if (oldElsList.length) {
        each$f(oldElsList, function(oldEl) {
          stopAnimation(oldEl);
          removeEl(oldEl);
        });
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldElsList), getPathList(newEl2), newItem2.divide, newSeries, newIndex, updateMorphingPathProps);
      } else {
        fadeInElement(newEl2, newSeries, newItem2.dataIndex);
      }
    }
  }).updateOneToMany(function(newIndices, oldIndex) {
    var oldItem = oldDiffItems[oldIndex];
    var oldEl = oldItem.data.getItemGraphicEl(oldItem.dataIndex);
    if (oldEl && isElementStillInChart[oldEl.id]) {
      return;
    }
    var newElsList = filter(map$1(newIndices, function(idx) {
      return newDiffItems[idx].data.getItemGraphicEl(newDiffItems[idx].dataIndex);
    }), function(el2) {
      return el2 && el2 !== oldEl;
    });
    var newSeris = newDiffItems[newIndices[0]].data.hostModel;
    if (newElsList.length) {
      each$f(newElsList, function(newEl2) {
        return stopAnimation(newEl2);
      });
      if (oldEl) {
        stopAnimation(oldEl);
        removeEl(oldEl);
        hasMorphAnimation = true;
        applyMorphAnimation(getPathList(oldEl), getPathList(newElsList), oldItem.divide, newSeris, newIndices[0], updateMorphingPathProps);
      } else {
        each$f(newElsList, function(newEl2) {
          return fadeInElement(newEl2, newSeris, newIndices[0]);
        });
      }
    }
  }).updateManyToMany(function(newIndices, oldIndices) {
    new DataDiffer$1(oldIndices, newIndices, function(rawIdx) {
      return oldDiffItems[rawIdx].data.getId(oldDiffItems[rawIdx].dataIndex);
    }, function(rawIdx) {
      return newDiffItems[rawIdx].data.getId(newDiffItems[rawIdx].dataIndex);
    }).update(function(newIndex, oldIndex) {
      updateOneToOne(newIndices[newIndex], oldIndices[oldIndex]);
    }).execute();
  }).execute();
  if (hasMorphAnimation) {
    each$f(newList, function(_a2) {
      var data = _a2.data;
      var seriesModel = data.hostModel;
      var view = seriesModel && api.getViewOfSeriesModel(seriesModel);
      var animationCfg = getAnimationConfig("update", seriesModel, 0);
      if (view && seriesModel.isAnimationEnabled() && animationCfg && animationCfg.duration > 0) {
        view.group.traverse(function(el2) {
          if (el2 instanceof Path$1 && !el2.animators.length) {
            el2.animateFrom({
              style: {
                opacity: 0
              }
            }, animationCfg);
          }
        });
      }
    });
  }
}
function getSeriesTransitionKey(series) {
  var seriesKey = series.getModel("universalTransition").get("seriesKey");
  if (!seriesKey) {
    return series.id;
  }
  return seriesKey;
}
function convertArraySeriesKeyToString(seriesKey) {
  if (isArray$1(seriesKey)) {
    return seriesKey.sort().join(",");
  }
  return seriesKey;
}
function getDivideShapeFromData(data) {
  if (data.hostModel) {
    return data.hostModel.getModel("universalTransition").get("divideShape");
  }
}
function findTransitionSeriesBatches(globalStore, params) {
  var updateBatches = createHashMap();
  var oldDataMap = createHashMap();
  var oldDataMapForSplit = createHashMap();
  each$f(globalStore.oldSeries, function(series, idx) {
    var oldData = globalStore.oldData[idx];
    var transitionKey = getSeriesTransitionKey(series);
    var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
    oldDataMap.set(transitionKeyStr, oldData);
    if (isArray$1(transitionKey)) {
      each$f(transitionKey, function(key) {
        oldDataMapForSplit.set(key, {
          data: oldData,
          key: transitionKeyStr
        });
      });
    }
  });
  each$f(params.updatedSeries, function(series) {
    if (series.isUniversalTransitionEnabled() && series.isAnimationEnabled()) {
      var newData = series.getData();
      var transitionKey = getSeriesTransitionKey(series);
      var transitionKeyStr = convertArraySeriesKeyToString(transitionKey);
      var oldData = oldDataMap.get(transitionKeyStr);
      if (oldData) {
        updateBatches.set(transitionKeyStr, {
          oldSeries: [{
            divide: getDivideShapeFromData(oldData),
            data: oldData
          }],
          newSeries: [{
            divide: getDivideShapeFromData(newData),
            data: newData
          }]
        });
      } else {
        if (isArray$1(transitionKey)) {
          var oldSeries_1 = [];
          each$f(transitionKey, function(key) {
            var oldData2 = oldDataMap.get(key);
            if (oldData2) {
              oldSeries_1.push({
                divide: getDivideShapeFromData(oldData2),
                data: oldData2
              });
            }
          });
          if (oldSeries_1.length) {
            updateBatches.set(transitionKeyStr, {
              oldSeries: oldSeries_1,
              newSeries: [{
                data: newData,
                divide: getDivideShapeFromData(newData)
              }]
            });
          }
        } else {
          var oldData_1 = oldDataMapForSplit.get(transitionKey);
          if (oldData_1) {
            var batch = updateBatches.get(oldData_1.key);
            if (!batch) {
              batch = {
                oldSeries: [{
                  data: oldData_1.data,
                  divide: getDivideShapeFromData(oldData_1.data)
                }],
                newSeries: []
              };
              updateBatches.set(oldData_1.key, batch);
            }
            batch.newSeries.push({
              data: newData,
              divide: getDivideShapeFromData(newData)
            });
          }
        }
      }
    }
  });
  return updateBatches;
}
function querySeries(series, finder) {
  for (var i = 0; i < series.length; i++) {
    var found = finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id;
    if (found) {
      return i;
    }
  }
}
function transitionSeriesFromOpt(transitionOpt, globalStore, params, api) {
  var from = [];
  var to = [];
  each$f(normalizeToArray(transitionOpt.from), function(finder) {
    var idx = querySeries(globalStore.oldSeries, finder);
    if (idx >= 0) {
      from.push({
        data: globalStore.oldData[idx],
        divide: getDivideShapeFromData(globalStore.oldData[idx]),
        dim: finder.dimension
      });
    }
  });
  each$f(normalizeToArray(transitionOpt.to), function(finder) {
    var idx = querySeries(params.updatedSeries, finder);
    if (idx >= 0) {
      var data = params.updatedSeries[idx].getData();
      to.push({
        data,
        divide: getDivideShapeFromData(data),
        dim: finder.dimension
      });
    }
  });
  if (from.length > 0 && to.length > 0) {
    transitionBetween(from, to, api);
  }
}
function installUniversalTransition(registers) {
  registers.registerUpdateLifecycle("series:beforeupdate", function(ecMOdel, api, params) {
    each$f(normalizeToArray(params.seriesTransition), function(transOpt) {
      each$f(normalizeToArray(transOpt.to), function(finder) {
        var series = params.updatedSeries;
        for (var i = 0; i < series.length; i++) {
          if (finder.seriesIndex != null && finder.seriesIndex === series[i].seriesIndex || finder.seriesId != null && finder.seriesId === series[i].id) {
            series[i][SERIES_UNIVERSAL_TRANSITION_PROP] = true;
          }
        }
      });
    });
  });
  registers.registerUpdateLifecycle("series:transition", function(ecModel, api, params) {
    var globalStore = getUniversalTransitionGlobalStore(api);
    if (globalStore.oldSeries && params.updatedSeries && params.optionChanged) {
      var transitionOpt = params.seriesTransition;
      if (transitionOpt) {
        each$f(normalizeToArray(transitionOpt), function(opt) {
          transitionSeriesFromOpt(opt, globalStore, params, api);
        });
      } else {
        var updateBatches_1 = findTransitionSeriesBatches(globalStore, params);
        each$f(updateBatches_1.keys(), function(key) {
          var batch = updateBatches_1.get(key);
          transitionBetween(batch.oldSeries, batch.newSeries, api);
        });
      }
      each$f(params.updatedSeries, function(series) {
        if (series[SERIES_UNIVERSAL_TRANSITION_PROP]) {
          series[SERIES_UNIVERSAL_TRANSITION_PROP] = false;
        }
      });
    }
    var allSeries = ecModel.getSeries();
    var savedSeries = globalStore.oldSeries = [];
    var savedData = globalStore.oldData = [];
    for (var i = 0; i < allSeries.length; i++) {
      var data = allSeries[i].getData();
      if (data.count() < DATA_COUNT_THRESHOLD) {
        savedSeries.push(allSeries[i]);
        savedData.push(data);
      }
    }
  });
}
use([install$R]);
use([install$S]);
use([install$Q, install$P, install$O, install$M, install$K, install$I, install$H, install$G, install$F, install$E, install$D, install$B, install$A, install$z, install$y, install$x, install$w, install$v, install$u, install$t, install$s, install$r]);
use(install$p);
use(install$o);
use(install$J);
use(install$n);
use(install$C);
use(install$m);
use(install$l);
use(install$j);
use(install$i);
use(install$q);
use(install$h);
use(install$g);
use(install$f);
use(install$e);
use(install$d);
use(install$c);
use(install$9);
use(install$6);
use(install$8);
use(install$7);
use(install$3);
use(install$5);
use(install$4);
use(install$2);
use(install$1);
use(install);
use(installUniversalTransition);
use(installLabelLayout);
function useEcharts(options) {
  const {
    defaultOptions
  } = options != null ? options : {};
  const container2 = useRef(null);
  const chart = useRef();
  const optionsRef = useRef(defaultOptions);
  useEffect(() => {
    if (!container2.current) {
      return;
    }
    const myEcharts = init$1(container2.current);
    chart.current = myEcharts;
    if (optionsRef.current) {
      myEcharts.setOption(optionsRef.current);
    }
  }, []);
  useEffect(() => {
    return () => {
      var _a2, _b2, _c2, _d;
      (_b2 = (_a2 = chart.current) == null ? void 0 : _a2.dispose) == null ? void 0 : _b2.call(_a2);
      (_d = (_c2 = chart.current) == null ? void 0 : _c2.off) == null ? void 0 : _d.call(_c2, "*");
      chart.current = void 0;
    };
  }, []);
  useEventListener("resize", () => {
    requestAnimationFrame(() => {
      var _a2, _b2;
      (_b2 = (_a2 = chart == null ? void 0 : chart.current) == null ? void 0 : _a2.resize) == null ? void 0 : _b2.call(_a2);
    });
  });
  return {
    chart,
    container: container2
  };
}
class Charts {
  constructor() {
    __publicField(this, "chartsEmitters", /* @__PURE__ */ new Map());
    __publicField(this, "add", (id2, chart, option, title) => {
      if (chart && option) {
        this.chartsEmitters.set(id2, {
          chart,
          option,
          title
        });
      } else {
        console.log("\u6DFB\u52A0\u5931\u8D25");
      }
    });
    __publicField(this, "get", (id2) => {
      return this.chartsEmitters.get(id2);
    });
    __publicField(this, "clear", () => {
      this.chartsEmitters.clear();
    });
    __publicField(this, "delete", (id2) => {
      this.chartsEmitters.delete(id2);
    });
    __publicField(this, "list", () => {
      var _a2, _b2, _c2;
      const list = [];
      for (const key of this.chartsEmitters.keys()) {
        list.push({
          id: key,
          chart: (_a2 = this.chartsEmitters.get(key)) == null ? void 0 : _a2.chart,
          option: (_b2 = this.chartsEmitters.get(key)) == null ? void 0 : _b2.option,
          title: (_c2 = this.chartsEmitters.get(key)) == null ? void 0 : _c2.title
        });
      }
      return list;
    });
  }
}
const _Charts = new Charts();
var lodash = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
(function(module, exports) {
  (function() {
    var undefined$1;
    var VERSION = "4.17.21";
    var LARGE_ARRAY_SIZE = 200;
    var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT2 = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
    var HASH_UNDEFINED = "__lodash_hash_undefined__";
    var MAX_MEMOIZE_SIZE = 500;
    var PLACEHOLDER = "__lodash_placeholder__";
    var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
    var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
    var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
    var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
    var HOT_COUNT = 800, HOT_SPAN = 16;
    var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
    var INFINITY = 1 / 0, MAX_SAFE_INTEGER2 = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN2 = 0 / 0;
    var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
    var wrapFlags = [
      ["ary", WRAP_ARY_FLAG],
      ["bind", WRAP_BIND_FLAG],
      ["bindKey", WRAP_BIND_KEY_FLAG],
      ["curry", WRAP_CURRY_FLAG],
      ["curryRight", WRAP_CURRY_RIGHT_FLAG],
      ["flip", WRAP_FLIP_FLAG],
      ["partial", WRAP_PARTIAL_FLAG],
      ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
      ["rearg", WRAP_REARG_FLAG]
    ];
    var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag2 = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag2 = "[object Symbol]", undefinedTag2 = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
    var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
    var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
    var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
    var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
    var reTrimStart2 = /^\s+/;
    var reWhitespace2 = /\s/;
    var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
    var reEscapeChar = /\\(\\)?/g;
    var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
    var reFlags = /\w*$/;
    var reIsBadHex2 = /^[-+]0x[0-9a-f]+$/i;
    var reIsBinary2 = /^0b[01]+$/i;
    var reIsHostCtor = /^\[object .+?Constructor\]$/;
    var reIsOctal2 = /^0o[0-7]+$/i;
    var reIsUint = /^(?:0|[1-9]\d*)$/;
    var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
    var reNoMatch = /($^)/;
    var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
    var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
    var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
    var reApos = RegExp(rsApos, "g");
    var reComboMark = RegExp(rsCombo, "g");
    var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    var reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    var contextProps = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ];
    var templateCounter = -1;
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
    var cloneableTags = {};
    cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag2] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
    cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
    var deburredLetters = {
      "\xC0": "A",
      "\xC1": "A",
      "\xC2": "A",
      "\xC3": "A",
      "\xC4": "A",
      "\xC5": "A",
      "\xE0": "a",
      "\xE1": "a",
      "\xE2": "a",
      "\xE3": "a",
      "\xE4": "a",
      "\xE5": "a",
      "\xC7": "C",
      "\xE7": "c",
      "\xD0": "D",
      "\xF0": "d",
      "\xC8": "E",
      "\xC9": "E",
      "\xCA": "E",
      "\xCB": "E",
      "\xE8": "e",
      "\xE9": "e",
      "\xEA": "e",
      "\xEB": "e",
      "\xCC": "I",
      "\xCD": "I",
      "\xCE": "I",
      "\xCF": "I",
      "\xEC": "i",
      "\xED": "i",
      "\xEE": "i",
      "\xEF": "i",
      "\xD1": "N",
      "\xF1": "n",
      "\xD2": "O",
      "\xD3": "O",
      "\xD4": "O",
      "\xD5": "O",
      "\xD6": "O",
      "\xD8": "O",
      "\xF2": "o",
      "\xF3": "o",
      "\xF4": "o",
      "\xF5": "o",
      "\xF6": "o",
      "\xF8": "o",
      "\xD9": "U",
      "\xDA": "U",
      "\xDB": "U",
      "\xDC": "U",
      "\xF9": "u",
      "\xFA": "u",
      "\xFB": "u",
      "\xFC": "u",
      "\xDD": "Y",
      "\xFD": "y",
      "\xFF": "y",
      "\xC6": "Ae",
      "\xE6": "ae",
      "\xDE": "Th",
      "\xFE": "th",
      "\xDF": "ss",
      "\u0100": "A",
      "\u0102": "A",
      "\u0104": "A",
      "\u0101": "a",
      "\u0103": "a",
      "\u0105": "a",
      "\u0106": "C",
      "\u0108": "C",
      "\u010A": "C",
      "\u010C": "C",
      "\u0107": "c",
      "\u0109": "c",
      "\u010B": "c",
      "\u010D": "c",
      "\u010E": "D",
      "\u0110": "D",
      "\u010F": "d",
      "\u0111": "d",
      "\u0112": "E",
      "\u0114": "E",
      "\u0116": "E",
      "\u0118": "E",
      "\u011A": "E",
      "\u0113": "e",
      "\u0115": "e",
      "\u0117": "e",
      "\u0119": "e",
      "\u011B": "e",
      "\u011C": "G",
      "\u011E": "G",
      "\u0120": "G",
      "\u0122": "G",
      "\u011D": "g",
      "\u011F": "g",
      "\u0121": "g",
      "\u0123": "g",
      "\u0124": "H",
      "\u0126": "H",
      "\u0125": "h",
      "\u0127": "h",
      "\u0128": "I",
      "\u012A": "I",
      "\u012C": "I",
      "\u012E": "I",
      "\u0130": "I",
      "\u0129": "i",
      "\u012B": "i",
      "\u012D": "i",
      "\u012F": "i",
      "\u0131": "i",
      "\u0134": "J",
      "\u0135": "j",
      "\u0136": "K",
      "\u0137": "k",
      "\u0138": "k",
      "\u0139": "L",
      "\u013B": "L",
      "\u013D": "L",
      "\u013F": "L",
      "\u0141": "L",
      "\u013A": "l",
      "\u013C": "l",
      "\u013E": "l",
      "\u0140": "l",
      "\u0142": "l",
      "\u0143": "N",
      "\u0145": "N",
      "\u0147": "N",
      "\u014A": "N",
      "\u0144": "n",
      "\u0146": "n",
      "\u0148": "n",
      "\u014B": "n",
      "\u014C": "O",
      "\u014E": "O",
      "\u0150": "O",
      "\u014D": "o",
      "\u014F": "o",
      "\u0151": "o",
      "\u0154": "R",
      "\u0156": "R",
      "\u0158": "R",
      "\u0155": "r",
      "\u0157": "r",
      "\u0159": "r",
      "\u015A": "S",
      "\u015C": "S",
      "\u015E": "S",
      "\u0160": "S",
      "\u015B": "s",
      "\u015D": "s",
      "\u015F": "s",
      "\u0161": "s",
      "\u0162": "T",
      "\u0164": "T",
      "\u0166": "T",
      "\u0163": "t",
      "\u0165": "t",
      "\u0167": "t",
      "\u0168": "U",
      "\u016A": "U",
      "\u016C": "U",
      "\u016E": "U",
      "\u0170": "U",
      "\u0172": "U",
      "\u0169": "u",
      "\u016B": "u",
      "\u016D": "u",
      "\u016F": "u",
      "\u0171": "u",
      "\u0173": "u",
      "\u0174": "W",
      "\u0175": "w",
      "\u0176": "Y",
      "\u0177": "y",
      "\u0178": "Y",
      "\u0179": "Z",
      "\u017B": "Z",
      "\u017D": "Z",
      "\u017A": "z",
      "\u017C": "z",
      "\u017E": "z",
      "\u0132": "IJ",
      "\u0133": "ij",
      "\u0152": "Oe",
      "\u0153": "oe",
      "\u0149": "'n",
      "\u017F": "s"
    };
    var htmlEscapes = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    };
    var htmlUnescapes = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    };
    var stringEscapes = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    };
    var freeParseFloat = parseFloat, freeParseInt2 = parseInt;
    var freeGlobal2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports = exports && !exports.nodeType && exports;
    var freeModule = freeExports && true && module && !module.nodeType && module;
    var moduleExports = freeModule && freeModule.exports === freeExports;
    var freeProcess = moduleExports && freeGlobal2.process;
    var nodeUtil = function() {
      try {
        var types2 = freeModule && freeModule.require && freeModule.require("util").types;
        if (types2) {
          return types2;
        }
        return freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch (e2) {
      }
    }();
    var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayAggregator(array4, setter, iteratee, accumulator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        var value = array4[index2];
        setter(accumulator, value, iteratee(value), array4);
      }
      return accumulator;
    }
    function arrayEach(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (iteratee(array4[index2], index2, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEachRight(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      while (length--) {
        if (iteratee(array4[length], length, array4) === false) {
          break;
        }
      }
      return array4;
    }
    function arrayEvery(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (!predicate(array4[index2], index2, array4)) {
          return false;
        }
      }
      return true;
    }
    function arrayFilter(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (predicate(value, index2, array4)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayIncludes(array4, value) {
      var length = array4 == null ? 0 : array4.length;
      return !!length && baseIndexOf(array4, value, 0) > -1;
    }
    function arrayIncludesWith(array4, value, comparator) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (comparator(value, array4[index2])) {
          return true;
        }
      }
      return false;
    }
    function arrayMap(array4, iteratee) {
      var index2 = -1, length = array4 == null ? 0 : array4.length, result = Array(length);
      while (++index2 < length) {
        result[index2] = iteratee(array4[index2], index2, array4);
      }
      return result;
    }
    function arrayPush(array4, values) {
      var index2 = -1, length = values.length, offset = array4.length;
      while (++index2 < length) {
        array4[offset + index2] = values[index2];
      }
      return array4;
    }
    function arrayReduce(array4, iteratee, accumulator, initAccum) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[++index2];
      }
      while (++index2 < length) {
        accumulator = iteratee(accumulator, array4[index2], index2, array4);
      }
      return accumulator;
    }
    function arrayReduceRight(array4, iteratee, accumulator, initAccum) {
      var length = array4 == null ? 0 : array4.length;
      if (initAccum && length) {
        accumulator = array4[--length];
      }
      while (length--) {
        accumulator = iteratee(accumulator, array4[length], length, array4);
      }
      return accumulator;
    }
    function arraySome(array4, predicate) {
      var index2 = -1, length = array4 == null ? 0 : array4.length;
      while (++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return true;
        }
      }
      return false;
    }
    var asciiSize = baseProperty("length");
    function asciiToArray(string3) {
      return string3.split("");
    }
    function asciiWords(string3) {
      return string3.match(reAsciiWord) || [];
    }
    function baseFindKey(collection, predicate, eachFunc) {
      var result;
      eachFunc(collection, function(value, key, collection2) {
        if (predicate(value, key, collection2)) {
          result = key;
          return false;
        }
      });
      return result;
    }
    function baseFindIndex(array4, predicate, fromIndex, fromRight) {
      var length = array4.length, index2 = fromIndex + (fromRight ? 1 : -1);
      while (fromRight ? index2-- : ++index2 < length) {
        if (predicate(array4[index2], index2, array4)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIndexOf(array4, value, fromIndex) {
      return value === value ? strictIndexOf(array4, value, fromIndex) : baseFindIndex(array4, baseIsNaN, fromIndex);
    }
    function baseIndexOfWith(array4, value, fromIndex, comparator) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (comparator(array4[index2], value)) {
          return index2;
        }
      }
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseMean(array4, iteratee) {
      var length = array4 == null ? 0 : array4.length;
      return length ? baseSum(array4, iteratee) / length : NAN2;
    }
    function baseProperty(key) {
      return function(object4) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function basePropertyOf(object4) {
      return function(key) {
        return object4 == null ? undefined$1 : object4[key];
      };
    }
    function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
      eachFunc(collection, function(value, index2, collection2) {
        accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index2, collection2);
      });
      return accumulator;
    }
    function baseSortBy(array4, comparer) {
      var length = array4.length;
      array4.sort(comparer);
      while (length--) {
        array4[length] = array4[length].value;
      }
      return array4;
    }
    function baseSum(array4, iteratee) {
      var result, index2 = -1, length = array4.length;
      while (++index2 < length) {
        var current = iteratee(array4[index2]);
        if (current !== undefined$1) {
          result = result === undefined$1 ? current : result + current;
        }
      }
      return result;
    }
    function baseTimes(n2, iteratee) {
      var index2 = -1, result = Array(n2);
      while (++index2 < n2) {
        result[index2] = iteratee(index2);
      }
      return result;
    }
    function baseToPairs(object4, props) {
      return arrayMap(props, function(key) {
        return [key, object4[key]];
      });
    }
    function baseTrim2(string3) {
      return string3 ? string3.slice(0, trimmedEndIndex2(string3) + 1).replace(reTrimStart2, "") : string3;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function baseValues(object4, props) {
      return arrayMap(props, function(key) {
        return object4[key];
      });
    }
    function cacheHas(cache, key) {
      return cache.has(key);
    }
    function charsStartIndex(strSymbols, chrSymbols) {
      var index2 = -1, length = strSymbols.length;
      while (++index2 < length && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function charsEndIndex(strSymbols, chrSymbols) {
      var index2 = strSymbols.length;
      while (index2-- && baseIndexOf(chrSymbols, strSymbols[index2], 0) > -1) {
      }
      return index2;
    }
    function countHolders(array4, placeholder) {
      var length = array4.length, result = 0;
      while (length--) {
        if (array4[length] === placeholder) {
          ++result;
        }
      }
      return result;
    }
    var deburrLetter = basePropertyOf(deburredLetters);
    var escapeHtmlChar = basePropertyOf(htmlEscapes);
    function escapeStringChar(chr) {
      return "\\" + stringEscapes[chr];
    }
    function getValue2(object4, key) {
      return object4 == null ? undefined$1 : object4[key];
    }
    function hasUnicode(string3) {
      return reHasUnicode.test(string3);
    }
    function hasUnicodeWord(string3) {
      return reHasUnicodeWord.test(string3);
    }
    function iteratorToArray(iterator2) {
      var data, result = [];
      while (!(data = iterator2.next()).done) {
        result.push(data.value);
      }
      return result;
    }
    function mapToArray(map2) {
      var index2 = -1, result = Array(map2.size);
      map2.forEach(function(value, key) {
        result[++index2] = [key, value];
      });
      return result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function replaceHolders(array4, placeholder) {
      var index2 = -1, length = array4.length, resIndex = 0, result = [];
      while (++index2 < length) {
        var value = array4[index2];
        if (value === placeholder || value === PLACEHOLDER) {
          array4[index2] = PLACEHOLDER;
          result[resIndex++] = index2;
        }
      }
      return result;
    }
    function setToArray(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = value;
      });
      return result;
    }
    function setToPairs(set2) {
      var index2 = -1, result = Array(set2.size);
      set2.forEach(function(value) {
        result[++index2] = [value, value];
      });
      return result;
    }
    function strictIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex - 1, length = array4.length;
      while (++index2 < length) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return -1;
    }
    function strictLastIndexOf(array4, value, fromIndex) {
      var index2 = fromIndex + 1;
      while (index2--) {
        if (array4[index2] === value) {
          return index2;
        }
      }
      return index2;
    }
    function stringSize(string3) {
      return hasUnicode(string3) ? unicodeSize(string3) : asciiSize(string3);
    }
    function stringToArray(string3) {
      return hasUnicode(string3) ? unicodeToArray(string3) : asciiToArray(string3);
    }
    function trimmedEndIndex2(string3) {
      var index2 = string3.length;
      while (index2-- && reWhitespace2.test(string3.charAt(index2))) {
      }
      return index2;
    }
    var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
    function unicodeSize(string3) {
      var result = reUnicode.lastIndex = 0;
      while (reUnicode.test(string3)) {
        ++result;
      }
      return result;
    }
    function unicodeToArray(string3) {
      return string3.match(reUnicode) || [];
    }
    function unicodeWords(string3) {
      return string3.match(reUnicodeWord) || [];
    }
    var runInContext = function runInContext2(context) {
      context = context == null ? root2 : _.defaults(root2.Object(), context, _.pick(root2, contextProps));
      var Array2 = context.Array, Date2 = context.Date, Error2 = context.Error, Function2 = context.Function, Math2 = context.Math, Object2 = context.Object, RegExp2 = context.RegExp, String2 = context.String, TypeError2 = context.TypeError;
      var arrayProto2 = Array2.prototype, funcProto = Function2.prototype, objectProto2 = Object2.prototype;
      var coreJsData = context["__core-js_shared__"];
      var funcToString = funcProto.toString;
      var hasOwnProperty2 = objectProto2.hasOwnProperty;
      var idCounter = 0;
      var maskSrcKey = function() {
        var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
        return uid ? "Symbol(src)_1." + uid : "";
      }();
      var nativeObjectToString2 = objectProto2.toString;
      var objectCtorString = funcToString.call(Object2);
      var oldDash = root2._;
      var reIsNative = RegExp2("^" + funcToString.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$");
      var Buffer2 = moduleExports ? context.Buffer : undefined$1, Symbol2 = context.Symbol, Uint8Array2 = context.Uint8Array, allocUnsafe = Buffer2 ? Buffer2.allocUnsafe : undefined$1, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto2.propertyIsEnumerable, splice = arrayProto2.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined$1, symIterator = Symbol2 ? Symbol2.iterator : undefined$1, symToStringTag2 = Symbol2 ? Symbol2.toStringTag : undefined$1;
      var defineProperty = function() {
        try {
          var func = getNative(Object2, "defineProperty");
          func({}, "", {});
          return func;
        } catch (e2) {
        }
      }();
      var ctxClearTimeout = context.clearTimeout !== root2.clearTimeout && context.clearTimeout, ctxNow = Date2 && Date2.now !== root2.Date.now && Date2.now, ctxSetTimeout = context.setTimeout !== root2.setTimeout && context.setTimeout;
      var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : undefined$1, nativeIsFinite = context.isFinite, nativeJoin = arrayProto2.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax2 = Math2.max, nativeMin2 = Math2.min, nativeNow = Date2.now, nativeParseInt = context.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto2.reverse;
      var DataView2 = getNative(context, "DataView"), Map2 = getNative(context, "Map"), Promise2 = getNative(context, "Promise"), Set2 = getNative(context, "Set"), WeakMap3 = getNative(context, "WeakMap"), nativeCreate = getNative(Object2, "create");
      var metaMap = WeakMap3 && new WeakMap3();
      var realNames = {};
      var dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap3);
      var symbolProto = Symbol2 ? Symbol2.prototype : undefined$1, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined$1, symbolToString = symbolProto ? symbolProto.toString : undefined$1;
      function lodash2(value) {
        if (isObjectLike2(value) && !isArray2(value) && !(value instanceof LazyWrapper)) {
          if (value instanceof LodashWrapper) {
            return value;
          }
          if (hasOwnProperty2.call(value, "__wrapped__")) {
            return wrapperClone(value);
          }
        }
        return new LodashWrapper(value);
      }
      var baseCreate = function() {
        function object4() {
        }
        return function(proto2) {
          if (!isObject2(proto2)) {
            return {};
          }
          if (objectCreate) {
            return objectCreate(proto2);
          }
          object4.prototype = proto2;
          var result2 = new object4();
          object4.prototype = undefined$1;
          return result2;
        };
      }();
      function baseLodash() {
      }
      function LodashWrapper(value, chainAll) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__chain__ = !!chainAll;
        this.__index__ = 0;
        this.__values__ = undefined$1;
      }
      lodash2.templateSettings = {
        "escape": reEscape,
        "evaluate": reEvaluate,
        "interpolate": reInterpolate,
        "variable": "",
        "imports": {
          "_": lodash2
        }
      };
      lodash2.prototype = baseLodash.prototype;
      lodash2.prototype.constructor = lodash2;
      LodashWrapper.prototype = baseCreate(baseLodash.prototype);
      LodashWrapper.prototype.constructor = LodashWrapper;
      function LazyWrapper(value) {
        this.__wrapped__ = value;
        this.__actions__ = [];
        this.__dir__ = 1;
        this.__filtered__ = false;
        this.__iteratees__ = [];
        this.__takeCount__ = MAX_ARRAY_LENGTH;
        this.__views__ = [];
      }
      function lazyClone() {
        var result2 = new LazyWrapper(this.__wrapped__);
        result2.__actions__ = copyArray(this.__actions__);
        result2.__dir__ = this.__dir__;
        result2.__filtered__ = this.__filtered__;
        result2.__iteratees__ = copyArray(this.__iteratees__);
        result2.__takeCount__ = this.__takeCount__;
        result2.__views__ = copyArray(this.__views__);
        return result2;
      }
      function lazyReverse() {
        if (this.__filtered__) {
          var result2 = new LazyWrapper(this);
          result2.__dir__ = -1;
          result2.__filtered__ = true;
        } else {
          result2 = this.clone();
          result2.__dir__ *= -1;
        }
        return result2;
      }
      function lazyValue() {
        var array4 = this.__wrapped__.value(), dir3 = this.__dir__, isArr = isArray2(array4), isRight = dir3 < 0, arrLength = isArr ? array4.length : 0, view = getView(0, arrLength, this.__views__), start2 = view.start, end2 = view.end, length = end2 - start2, index2 = isRight ? end2 : start2 - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin2(length, this.__takeCount__);
        if (!isArr || !isRight && arrLength == length && takeCount == length) {
          return baseWrapperValue(array4, this.__actions__);
        }
        var result2 = [];
        outer:
          while (length-- && resIndex < takeCount) {
            index2 += dir3;
            var iterIndex = -1, value = array4[index2];
            while (++iterIndex < iterLength) {
              var data = iteratees[iterIndex], iteratee2 = data.iteratee, type4 = data.type, computed = iteratee2(value);
              if (type4 == LAZY_MAP_FLAG) {
                value = computed;
              } else if (!computed) {
                if (type4 == LAZY_FILTER_FLAG) {
                  continue outer;
                } else {
                  break outer;
                }
              }
            }
            result2[resIndex++] = value;
          }
        return result2;
      }
      LazyWrapper.prototype = baseCreate(baseLodash.prototype);
      LazyWrapper.prototype.constructor = LazyWrapper;
      function Hash(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function hashClear() {
        this.__data__ = nativeCreate ? nativeCreate(null) : {};
        this.size = 0;
      }
      function hashDelete(key) {
        var result2 = this.has(key) && delete this.__data__[key];
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function hashGet(key) {
        var data = this.__data__;
        if (nativeCreate) {
          var result2 = data[key];
          return result2 === HASH_UNDEFINED ? undefined$1 : result2;
        }
        return hasOwnProperty2.call(data, key) ? data[key] : undefined$1;
      }
      function hashHas(key) {
        var data = this.__data__;
        return nativeCreate ? data[key] !== undefined$1 : hasOwnProperty2.call(data, key);
      }
      function hashSet(key, value) {
        var data = this.__data__;
        this.size += this.has(key) ? 0 : 1;
        data[key] = nativeCreate && value === undefined$1 ? HASH_UNDEFINED : value;
        return this;
      }
      Hash.prototype.clear = hashClear;
      Hash.prototype["delete"] = hashDelete;
      Hash.prototype.get = hashGet;
      Hash.prototype.has = hashHas;
      Hash.prototype.set = hashSet;
      function ListCache(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function listCacheClear() {
        this.__data__ = [];
        this.size = 0;
      }
      function listCacheDelete(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          return false;
        }
        var lastIndex = data.length - 1;
        if (index2 == lastIndex) {
          data.pop();
        } else {
          splice.call(data, index2, 1);
        }
        --this.size;
        return true;
      }
      function listCacheGet2(key) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        return index2 < 0 ? undefined$1 : data[index2][1];
      }
      function listCacheHas(key) {
        return assocIndexOf(this.__data__, key) > -1;
      }
      function listCacheSet2(key, value) {
        var data = this.__data__, index2 = assocIndexOf(data, key);
        if (index2 < 0) {
          ++this.size;
          data.push([key, value]);
        } else {
          data[index2][1] = value;
        }
        return this;
      }
      ListCache.prototype.clear = listCacheClear;
      ListCache.prototype["delete"] = listCacheDelete;
      ListCache.prototype.get = listCacheGet2;
      ListCache.prototype.has = listCacheHas;
      ListCache.prototype.set = listCacheSet2;
      function MapCache(entries) {
        var index2 = -1, length = entries == null ? 0 : entries.length;
        this.clear();
        while (++index2 < length) {
          var entry = entries[index2];
          this.set(entry[0], entry[1]);
        }
      }
      function mapCacheClear() {
        this.size = 0;
        this.__data__ = {
          "hash": new Hash(),
          "map": new (Map2 || ListCache)(),
          "string": new Hash()
        };
      }
      function mapCacheDelete(key) {
        var result2 = getMapData(this, key)["delete"](key);
        this.size -= result2 ? 1 : 0;
        return result2;
      }
      function mapCacheGet(key) {
        return getMapData(this, key).get(key);
      }
      function mapCacheHas(key) {
        return getMapData(this, key).has(key);
      }
      function mapCacheSet(key, value) {
        var data = getMapData(this, key), size2 = data.size;
        data.set(key, value);
        this.size += data.size == size2 ? 0 : 1;
        return this;
      }
      MapCache.prototype.clear = mapCacheClear;
      MapCache.prototype["delete"] = mapCacheDelete;
      MapCache.prototype.get = mapCacheGet;
      MapCache.prototype.has = mapCacheHas;
      MapCache.prototype.set = mapCacheSet;
      function SetCache(values2) {
        var index2 = -1, length = values2 == null ? 0 : values2.length;
        this.__data__ = new MapCache();
        while (++index2 < length) {
          this.add(values2[index2]);
        }
      }
      function setCacheAdd(value) {
        this.__data__.set(value, HASH_UNDEFINED);
        return this;
      }
      function setCacheHas(value) {
        return this.__data__.has(value);
      }
      SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
      SetCache.prototype.has = setCacheHas;
      function Stack(entries) {
        var data = this.__data__ = new ListCache(entries);
        this.size = data.size;
      }
      function stackClear() {
        this.__data__ = new ListCache();
        this.size = 0;
      }
      function stackDelete(key) {
        var data = this.__data__, result2 = data["delete"](key);
        this.size = data.size;
        return result2;
      }
      function stackGet(key) {
        return this.__data__.get(key);
      }
      function stackHas(key) {
        return this.__data__.has(key);
      }
      function stackSet(key, value) {
        var data = this.__data__;
        if (data instanceof ListCache) {
          var pairs = data.__data__;
          if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
            pairs.push([key, value]);
            this.size = ++data.size;
            return this;
          }
          data = this.__data__ = new MapCache(pairs);
        }
        data.set(key, value);
        this.size = data.size;
        return this;
      }
      Stack.prototype.clear = stackClear;
      Stack.prototype["delete"] = stackDelete;
      Stack.prototype.get = stackGet;
      Stack.prototype.has = stackHas;
      Stack.prototype.set = stackSet;
      function arrayLikeKeys(value, inherited) {
        var isArr = isArray2(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String2) : [], length = result2.length;
        for (var key in value) {
          if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function arraySample(array4) {
        var length = array4.length;
        return length ? array4[baseRandom(0, length - 1)] : undefined$1;
      }
      function arraySampleSize(array4, n2) {
        return shuffleSelf(copyArray(array4), baseClamp(n2, 0, array4.length));
      }
      function arrayShuffle(array4) {
        return shuffleSelf(copyArray(array4));
      }
      function assignMergeValue(object4, key, value) {
        if (value !== undefined$1 && !eq(object4[key], value) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assignValue(object4, key, value) {
        var objValue = object4[key];
        if (!(hasOwnProperty2.call(object4, key) && eq(objValue, value)) || value === undefined$1 && !(key in object4)) {
          baseAssignValue(object4, key, value);
        }
      }
      function assocIndexOf(array4, key) {
        var length = array4.length;
        while (length--) {
          if (eq(array4[length][0], key)) {
            return length;
          }
        }
        return -1;
      }
      function baseAggregator(collection, setter, iteratee2, accumulator) {
        baseEach(collection, function(value, key, collection2) {
          setter(accumulator, value, iteratee2(value), collection2);
        });
        return accumulator;
      }
      function baseAssign(object4, source) {
        return object4 && copyObject(source, keys2(source), object4);
      }
      function baseAssignIn(object4, source) {
        return object4 && copyObject(source, keysIn(source), object4);
      }
      function baseAssignValue(object4, key, value) {
        if (key == "__proto__" && defineProperty) {
          defineProperty(object4, key, {
            "configurable": true,
            "enumerable": true,
            "value": value,
            "writable": true
          });
        } else {
          object4[key] = value;
        }
      }
      function baseAt(object4, paths) {
        var index2 = -1, length = paths.length, result2 = Array2(length), skip = object4 == null;
        while (++index2 < length) {
          result2[index2] = skip ? undefined$1 : get2(object4, paths[index2]);
        }
        return result2;
      }
      function baseClamp(number4, lower, upper) {
        if (number4 === number4) {
          if (upper !== undefined$1) {
            number4 = number4 <= upper ? number4 : upper;
          }
          if (lower !== undefined$1) {
            number4 = number4 >= lower ? number4 : lower;
          }
        }
        return number4;
      }
      function baseClone(value, bitmask, customizer, key, object4, stack) {
        var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
        if (customizer) {
          result2 = object4 ? customizer(value, key, object4, stack) : customizer(value);
        }
        if (result2 !== undefined$1) {
          return result2;
        }
        if (!isObject2(value)) {
          return value;
        }
        var isArr = isArray2(value);
        if (isArr) {
          result2 = initCloneArray(value);
          if (!isDeep) {
            return copyArray(value, result2);
          }
        } else {
          var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
          if (isBuffer(value)) {
            return cloneBuffer(value, isDeep);
          }
          if (tag == objectTag || tag == argsTag || isFunc && !object4) {
            result2 = isFlat || isFunc ? {} : initCloneObject(value);
            if (!isDeep) {
              return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
            }
          } else {
            if (!cloneableTags[tag]) {
              return object4 ? value : {};
            }
            result2 = initCloneByTag(value, tag, isDeep);
          }
        }
        stack || (stack = new Stack());
        var stacked = stack.get(value);
        if (stacked) {
          return stacked;
        }
        stack.set(value, result2);
        if (isSet(value)) {
          value.forEach(function(subValue) {
            result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
          });
        } else if (isMap(value)) {
          value.forEach(function(subValue, key2) {
            result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
        }
        var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys2;
        var props = isArr ? undefined$1 : keysFunc(value);
        arrayEach(props || value, function(subValue, key2) {
          if (props) {
            key2 = subValue;
            subValue = value[key2];
          }
          assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
        });
        return result2;
      }
      function baseConforms(source) {
        var props = keys2(source);
        return function(object4) {
          return baseConformsTo(object4, source, props);
        };
      }
      function baseConformsTo(object4, source, props) {
        var length = props.length;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (length--) {
          var key = props[length], predicate = source[key], value = object4[key];
          if (value === undefined$1 && !(key in object4) || !predicate(value)) {
            return false;
          }
        }
        return true;
      }
      function baseDelay(func, wait, args) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return setTimeout2(function() {
          func.apply(undefined$1, args);
        }, wait);
      }
      function baseDifference(array4, values2, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, isCommon = true, length = array4.length, result2 = [], valuesLength = values2.length;
        if (!length) {
          return result2;
        }
        if (iteratee2) {
          values2 = arrayMap(values2, baseUnary(iteratee2));
        }
        if (comparator) {
          includes2 = arrayIncludesWith;
          isCommon = false;
        } else if (values2.length >= LARGE_ARRAY_SIZE) {
          includes2 = cacheHas;
          isCommon = false;
          values2 = new SetCache(values2);
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 == null ? value : iteratee2(value);
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var valuesIndex = valuesLength;
              while (valuesIndex--) {
                if (values2[valuesIndex] === computed) {
                  continue outer;
                }
              }
              result2.push(value);
            } else if (!includes2(values2, computed, comparator)) {
              result2.push(value);
            }
          }
        return result2;
      }
      var baseEach = createBaseEach(baseForOwn);
      var baseEachRight = createBaseEach(baseForOwnRight, true);
      function baseEvery(collection, predicate) {
        var result2 = true;
        baseEach(collection, function(value, index2, collection2) {
          result2 = !!predicate(value, index2, collection2);
          return result2;
        });
        return result2;
      }
      function baseExtremum(array4, iteratee2, comparator) {
        var index2 = -1, length = array4.length;
        while (++index2 < length) {
          var value = array4[index2], current = iteratee2(value);
          if (current != null && (computed === undefined$1 ? current === current && !isSymbol2(current) : comparator(current, computed))) {
            var computed = current, result2 = value;
          }
        }
        return result2;
      }
      function baseFill(array4, value, start2, end2) {
        var length = array4.length;
        start2 = toInteger(start2);
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 === undefined$1 || end2 > length ? length : toInteger(end2);
        if (end2 < 0) {
          end2 += length;
        }
        end2 = start2 > end2 ? 0 : toLength(end2);
        while (start2 < end2) {
          array4[start2++] = value;
        }
        return array4;
      }
      function baseFilter(collection, predicate) {
        var result2 = [];
        baseEach(collection, function(value, index2, collection2) {
          if (predicate(value, index2, collection2)) {
            result2.push(value);
          }
        });
        return result2;
      }
      function baseFlatten(array4, depth, predicate, isStrict, result2) {
        var index2 = -1, length = array4.length;
        predicate || (predicate = isFlattenable);
        result2 || (result2 = []);
        while (++index2 < length) {
          var value = array4[index2];
          if (depth > 0 && predicate(value)) {
            if (depth > 1) {
              baseFlatten(value, depth - 1, predicate, isStrict, result2);
            } else {
              arrayPush(result2, value);
            }
          } else if (!isStrict) {
            result2[result2.length] = value;
          }
        }
        return result2;
      }
      var baseFor = createBaseFor();
      var baseForRight = createBaseFor(true);
      function baseForOwn(object4, iteratee2) {
        return object4 && baseFor(object4, iteratee2, keys2);
      }
      function baseForOwnRight(object4, iteratee2) {
        return object4 && baseForRight(object4, iteratee2, keys2);
      }
      function baseFunctions(object4, props) {
        return arrayFilter(props, function(key) {
          return isFunction2(object4[key]);
        });
      }
      function baseGet(object4, path) {
        path = castPath(path, object4);
        var index2 = 0, length = path.length;
        while (object4 != null && index2 < length) {
          object4 = object4[toKey(path[index2++])];
        }
        return index2 && index2 == length ? object4 : undefined$1;
      }
      function baseGetAllKeys(object4, keysFunc, symbolsFunc) {
        var result2 = keysFunc(object4);
        return isArray2(object4) ? result2 : arrayPush(result2, symbolsFunc(object4));
      }
      function baseGetTag2(value) {
        if (value == null) {
          return value === undefined$1 ? undefinedTag2 : nullTag2;
        }
        return symToStringTag2 && symToStringTag2 in Object2(value) ? getRawTag2(value) : objectToString2(value);
      }
      function baseGt(value, other) {
        return value > other;
      }
      function baseHas(object4, key) {
        return object4 != null && hasOwnProperty2.call(object4, key);
      }
      function baseHasIn(object4, key) {
        return object4 != null && key in Object2(object4);
      }
      function baseInRange(number4, start2, end2) {
        return number4 >= nativeMin2(start2, end2) && number4 < nativeMax2(start2, end2);
      }
      function baseIntersection(arrays, iteratee2, comparator) {
        var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
        while (othIndex--) {
          var array4 = arrays[othIndex];
          if (othIndex && iteratee2) {
            array4 = arrayMap(array4, baseUnary(iteratee2));
          }
          maxLength = nativeMin2(array4.length, maxLength);
          caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array4.length >= 120) ? new SetCache(othIndex && array4) : undefined$1;
        }
        array4 = arrays[0];
        var index2 = -1, seen = caches[0];
        outer:
          while (++index2 < length && result2.length < maxLength) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (!(seen ? cacheHas(seen, computed) : includes2(result2, computed, comparator))) {
              othIndex = othLength;
              while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                  continue outer;
                }
              }
              if (seen) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseInverter(object4, setter, iteratee2, accumulator) {
        baseForOwn(object4, function(value, key, object5) {
          setter(accumulator, iteratee2(value), key, object5);
        });
        return accumulator;
      }
      function baseInvoke(object4, path, args) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        var func = object4 == null ? object4 : object4[toKey(last(path))];
        return func == null ? undefined$1 : apply(func, object4, args);
      }
      function baseIsArguments(value) {
        return isObjectLike2(value) && baseGetTag2(value) == argsTag;
      }
      function baseIsArrayBuffer(value) {
        return isObjectLike2(value) && baseGetTag2(value) == arrayBufferTag;
      }
      function baseIsDate(value) {
        return isObjectLike2(value) && baseGetTag2(value) == dateTag;
      }
      function baseIsEqual(value, other, bitmask, customizer, stack) {
        if (value === other) {
          return true;
        }
        if (value == null || other == null || !isObjectLike2(value) && !isObjectLike2(other)) {
          return value !== value && other !== other;
        }
        return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
      }
      function baseIsEqualDeep(object4, other, bitmask, customizer, equalFunc, stack) {
        var objIsArr = isArray2(object4), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag : getTag(object4), othTag = othIsArr ? arrayTag : getTag(other);
        objTag = objTag == argsTag ? objectTag : objTag;
        othTag = othTag == argsTag ? objectTag : othTag;
        var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
        if (isSameTag && isBuffer(object4)) {
          if (!isBuffer(other)) {
            return false;
          }
          objIsArr = true;
          objIsObj = false;
        }
        if (isSameTag && !objIsObj) {
          stack || (stack = new Stack());
          return objIsArr || isTypedArray2(object4) ? equalArrays(object4, other, bitmask, customizer, equalFunc, stack) : equalByTag(object4, other, objTag, bitmask, customizer, equalFunc, stack);
        }
        if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
          var objIsWrapped = objIsObj && hasOwnProperty2.call(object4, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
          if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object4.value() : object4, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new Stack());
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
          }
        }
        if (!isSameTag) {
          return false;
        }
        stack || (stack = new Stack());
        return equalObjects(object4, other, bitmask, customizer, equalFunc, stack);
      }
      function baseIsMap(value) {
        return isObjectLike2(value) && getTag(value) == mapTag;
      }
      function baseIsMatch(object4, source, matchData, customizer) {
        var index2 = matchData.length, length = index2, noCustomizer = !customizer;
        if (object4 == null) {
          return !length;
        }
        object4 = Object2(object4);
        while (index2--) {
          var data = matchData[index2];
          if (noCustomizer && data[2] ? data[1] !== object4[data[0]] : !(data[0] in object4)) {
            return false;
          }
        }
        while (++index2 < length) {
          data = matchData[index2];
          var key = data[0], objValue = object4[key], srcValue = data[1];
          if (noCustomizer && data[2]) {
            if (objValue === undefined$1 && !(key in object4)) {
              return false;
            }
          } else {
            var stack = new Stack();
            if (customizer) {
              var result2 = customizer(objValue, srcValue, key, object4, source, stack);
            }
            if (!(result2 === undefined$1 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result2)) {
              return false;
            }
          }
        }
        return true;
      }
      function baseIsNative(value) {
        if (!isObject2(value) || isMasked(value)) {
          return false;
        }
        var pattern4 = isFunction2(value) ? reIsNative : reIsHostCtor;
        return pattern4.test(toSource(value));
      }
      function baseIsRegExp(value) {
        return isObjectLike2(value) && baseGetTag2(value) == regexpTag;
      }
      function baseIsSet(value) {
        return isObjectLike2(value) && getTag(value) == setTag;
      }
      function baseIsTypedArray(value) {
        return isObjectLike2(value) && isLength(value.length) && !!typedArrayTags[baseGetTag2(value)];
      }
      function baseIteratee(value) {
        if (typeof value == "function") {
          return value;
        }
        if (value == null) {
          return identity2;
        }
        if (typeof value == "object") {
          return isArray2(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
        }
        return property(value);
      }
      function baseKeys(object4) {
        if (!isPrototype(object4)) {
          return nativeKeys(object4);
        }
        var result2 = [];
        for (var key in Object2(object4)) {
          if (hasOwnProperty2.call(object4, key) && key != "constructor") {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseKeysIn(object4) {
        if (!isObject2(object4)) {
          return nativeKeysIn(object4);
        }
        var isProto = isPrototype(object4), result2 = [];
        for (var key in object4) {
          if (!(key == "constructor" && (isProto || !hasOwnProperty2.call(object4, key)))) {
            result2.push(key);
          }
        }
        return result2;
      }
      function baseLt(value, other) {
        return value < other;
      }
      function baseMap(collection, iteratee2) {
        var index2 = -1, result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value, key, collection2) {
          result2[++index2] = iteratee2(value, key, collection2);
        });
        return result2;
      }
      function baseMatches(source) {
        var matchData = getMatchData(source);
        if (matchData.length == 1 && matchData[0][2]) {
          return matchesStrictComparable(matchData[0][0], matchData[0][1]);
        }
        return function(object4) {
          return object4 === source || baseIsMatch(object4, source, matchData);
        };
      }
      function baseMatchesProperty(path, srcValue) {
        if (isKey(path) && isStrictComparable(srcValue)) {
          return matchesStrictComparable(toKey(path), srcValue);
        }
        return function(object4) {
          var objValue = get2(object4, path);
          return objValue === undefined$1 && objValue === srcValue ? hasIn(object4, path) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
        };
      }
      function baseMerge(object4, source, srcIndex, customizer, stack) {
        if (object4 === source) {
          return;
        }
        baseFor(source, function(srcValue, key) {
          stack || (stack = new Stack());
          if (isObject2(srcValue)) {
            baseMergeDeep(object4, source, key, srcIndex, baseMerge, customizer, stack);
          } else {
            var newValue = customizer ? customizer(safeGet(object4, key), srcValue, key + "", object4, source, stack) : undefined$1;
            if (newValue === undefined$1) {
              newValue = srcValue;
            }
            assignMergeValue(object4, key, newValue);
          }
        }, keysIn);
      }
      function baseMergeDeep(object4, source, key, srcIndex, mergeFunc, customizer, stack) {
        var objValue = safeGet(object4, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
        if (stacked) {
          assignMergeValue(object4, key, stacked);
          return;
        }
        var newValue = customizer ? customizer(objValue, srcValue, key + "", object4, source, stack) : undefined$1;
        var isCommon = newValue === undefined$1;
        if (isCommon) {
          var isArr = isArray2(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray2(srcValue);
          newValue = srcValue;
          if (isArr || isBuff || isTyped) {
            if (isArray2(objValue)) {
              newValue = objValue;
            } else if (isArrayLikeObject(objValue)) {
              newValue = copyArray(objValue);
            } else if (isBuff) {
              isCommon = false;
              newValue = cloneBuffer(srcValue, true);
            } else if (isTyped) {
              isCommon = false;
              newValue = cloneTypedArray(srcValue, true);
            } else {
              newValue = [];
            }
          } else if (isPlainObject(srcValue) || isArguments(srcValue)) {
            newValue = objValue;
            if (isArguments(objValue)) {
              newValue = toPlainObject(objValue);
            } else if (!isObject2(objValue) || isFunction2(objValue)) {
              newValue = initCloneObject(srcValue);
            }
          } else {
            isCommon = false;
          }
        }
        if (isCommon) {
          stack.set(srcValue, newValue);
          mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
          stack["delete"](srcValue);
        }
        assignMergeValue(object4, key, newValue);
      }
      function baseNth(array4, n2) {
        var length = array4.length;
        if (!length) {
          return;
        }
        n2 += n2 < 0 ? length : 0;
        return isIndex(n2, length) ? array4[n2] : undefined$1;
      }
      function baseOrderBy(collection, iteratees, orders) {
        if (iteratees.length) {
          iteratees = arrayMap(iteratees, function(iteratee2) {
            if (isArray2(iteratee2)) {
              return function(value) {
                return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
              };
            }
            return iteratee2;
          });
        } else {
          iteratees = [identity2];
        }
        var index2 = -1;
        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
        var result2 = baseMap(collection, function(value, key, collection2) {
          var criteria = arrayMap(iteratees, function(iteratee2) {
            return iteratee2(value);
          });
          return { "criteria": criteria, "index": ++index2, "value": value };
        });
        return baseSortBy(result2, function(object4, other) {
          return compareMultiple(object4, other, orders);
        });
      }
      function basePick(object4, paths) {
        return basePickBy(object4, paths, function(value, path) {
          return hasIn(object4, path);
        });
      }
      function basePickBy(object4, paths, predicate) {
        var index2 = -1, length = paths.length, result2 = {};
        while (++index2 < length) {
          var path = paths[index2], value = baseGet(object4, path);
          if (predicate(value, path)) {
            baseSet(result2, castPath(path, object4), value);
          }
        }
        return result2;
      }
      function basePropertyDeep(path) {
        return function(object4) {
          return baseGet(object4, path);
        };
      }
      function basePullAll(array4, values2, iteratee2, comparator) {
        var indexOf3 = comparator ? baseIndexOfWith : baseIndexOf, index2 = -1, length = values2.length, seen = array4;
        if (array4 === values2) {
          values2 = copyArray(values2);
        }
        if (iteratee2) {
          seen = arrayMap(array4, baseUnary(iteratee2));
        }
        while (++index2 < length) {
          var fromIndex = 0, value = values2[index2], computed = iteratee2 ? iteratee2(value) : value;
          while ((fromIndex = indexOf3(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array4) {
              splice.call(seen, fromIndex, 1);
            }
            splice.call(array4, fromIndex, 1);
          }
        }
        return array4;
      }
      function basePullAt(array4, indexes) {
        var length = array4 ? indexes.length : 0, lastIndex = length - 1;
        while (length--) {
          var index2 = indexes[length];
          if (length == lastIndex || index2 !== previous) {
            var previous = index2;
            if (isIndex(index2)) {
              splice.call(array4, index2, 1);
            } else {
              baseUnset(array4, index2);
            }
          }
        }
        return array4;
      }
      function baseRandom(lower, upper) {
        return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
      }
      function baseRange(start2, end2, step, fromRight) {
        var index2 = -1, length = nativeMax2(nativeCeil((end2 - start2) / (step || 1)), 0), result2 = Array2(length);
        while (length--) {
          result2[fromRight ? length : ++index2] = start2;
          start2 += step;
        }
        return result2;
      }
      function baseRepeat(string3, n2) {
        var result2 = "";
        if (!string3 || n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return result2;
        }
        do {
          if (n2 % 2) {
            result2 += string3;
          }
          n2 = nativeFloor(n2 / 2);
          if (n2) {
            string3 += string3;
          }
        } while (n2);
        return result2;
      }
      function baseRest(func, start2) {
        return setToString(overRest(func, start2, identity2), func + "");
      }
      function baseSample(collection) {
        return arraySample(values(collection));
      }
      function baseSampleSize(collection, n2) {
        var array4 = values(collection);
        return shuffleSelf(array4, baseClamp(n2, 0, array4.length));
      }
      function baseSet(object4, path, value, customizer) {
        if (!isObject2(object4)) {
          return object4;
        }
        path = castPath(path, object4);
        var index2 = -1, length = path.length, lastIndex = length - 1, nested = object4;
        while (nested != null && ++index2 < length) {
          var key = toKey(path[index2]), newValue = value;
          if (key === "__proto__" || key === "constructor" || key === "prototype") {
            return object4;
          }
          if (index2 != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
            if (newValue === undefined$1) {
              newValue = isObject2(objValue) ? objValue : isIndex(path[index2 + 1]) ? [] : {};
            }
          }
          assignValue(nested, key, newValue);
          nested = nested[key];
        }
        return object4;
      }
      var baseSetData = !metaMap ? identity2 : function(func, data) {
        metaMap.set(func, data);
        return func;
      };
      var baseSetToString = !defineProperty ? identity2 : function(func, string3) {
        return defineProperty(func, "toString", {
          "configurable": true,
          "enumerable": false,
          "value": constant(string3),
          "writable": true
        });
      };
      function baseShuffle(collection) {
        return shuffleSelf(values(collection));
      }
      function baseSlice(array4, start2, end2) {
        var index2 = -1, length = array4.length;
        if (start2 < 0) {
          start2 = -start2 > length ? 0 : length + start2;
        }
        end2 = end2 > length ? length : end2;
        if (end2 < 0) {
          end2 += length;
        }
        length = start2 > end2 ? 0 : end2 - start2 >>> 0;
        start2 >>>= 0;
        var result2 = Array2(length);
        while (++index2 < length) {
          result2[index2] = array4[index2 + start2];
        }
        return result2;
      }
      function baseSome(collection, predicate) {
        var result2;
        baseEach(collection, function(value, index2, collection2) {
          result2 = predicate(value, index2, collection2);
          return !result2;
        });
        return !!result2;
      }
      function baseSortedIndex(array4, value, retHighest) {
        var low = 0, high = array4 == null ? low : array4.length;
        if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
          while (low < high) {
            var mid = low + high >>> 1, computed = array4[mid];
            if (computed !== null && !isSymbol2(computed) && (retHighest ? computed <= value : computed < value)) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return high;
        }
        return baseSortedIndexBy(array4, value, identity2, retHighest);
      }
      function baseSortedIndexBy(array4, value, iteratee2, retHighest) {
        var low = 0, high = array4 == null ? 0 : array4.length;
        if (high === 0) {
          return 0;
        }
        value = iteratee2(value);
        var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol2(value), valIsUndefined = value === undefined$1;
        while (low < high) {
          var mid = nativeFloor((low + high) / 2), computed = iteratee2(array4[mid]), othIsDefined = computed !== undefined$1, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol2(computed);
          if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
          } else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
          } else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
          } else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
          } else if (othIsNull || othIsSymbol) {
            setLow = false;
          } else {
            setLow = retHighest ? computed <= value : computed < value;
          }
          if (setLow) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return nativeMin2(high, MAX_ARRAY_INDEX);
      }
      function baseSortedUniq(array4, iteratee2) {
        var index2 = -1, length = array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
          if (!index2 || !eq(computed, seen)) {
            var seen = computed;
            result2[resIndex++] = value === 0 ? 0 : value;
          }
        }
        return result2;
      }
      function baseToNumber(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        return +value;
      }
      function baseToString(value) {
        if (typeof value == "string") {
          return value;
        }
        if (isArray2(value)) {
          return arrayMap(value, baseToString) + "";
        }
        if (isSymbol2(value)) {
          return symbolToString ? symbolToString.call(value) : "";
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function baseUniq(array4, iteratee2, comparator) {
        var index2 = -1, includes2 = arrayIncludes, length = array4.length, isCommon = true, result2 = [], seen = result2;
        if (comparator) {
          isCommon = false;
          includes2 = arrayIncludesWith;
        } else if (length >= LARGE_ARRAY_SIZE) {
          var set3 = iteratee2 ? null : createSet(array4);
          if (set3) {
            return setToArray(set3);
          }
          isCommon = false;
          includes2 = cacheHas;
          seen = new SetCache();
        } else {
          seen = iteratee2 ? [] : result2;
        }
        outer:
          while (++index2 < length) {
            var value = array4[index2], computed = iteratee2 ? iteratee2(value) : value;
            value = comparator || value !== 0 ? value : 0;
            if (isCommon && computed === computed) {
              var seenIndex = seen.length;
              while (seenIndex--) {
                if (seen[seenIndex] === computed) {
                  continue outer;
                }
              }
              if (iteratee2) {
                seen.push(computed);
              }
              result2.push(value);
            } else if (!includes2(seen, computed, comparator)) {
              if (seen !== result2) {
                seen.push(computed);
              }
              result2.push(value);
            }
          }
        return result2;
      }
      function baseUnset(object4, path) {
        path = castPath(path, object4);
        object4 = parent(object4, path);
        return object4 == null || delete object4[toKey(last(path))];
      }
      function baseUpdate(object4, path, updater, customizer) {
        return baseSet(object4, path, updater(baseGet(object4, path)), customizer);
      }
      function baseWhile(array4, predicate, isDrop, fromRight) {
        var length = array4.length, index2 = fromRight ? length : -1;
        while ((fromRight ? index2-- : ++index2 < length) && predicate(array4[index2], index2, array4)) {
        }
        return isDrop ? baseSlice(array4, fromRight ? 0 : index2, fromRight ? index2 + 1 : length) : baseSlice(array4, fromRight ? index2 + 1 : 0, fromRight ? length : index2);
      }
      function baseWrapperValue(value, actions2) {
        var result2 = value;
        if (result2 instanceof LazyWrapper) {
          result2 = result2.value();
        }
        return arrayReduce(actions2, function(result3, action) {
          return action.func.apply(action.thisArg, arrayPush([result3], action.args));
        }, result2);
      }
      function baseXor(arrays, iteratee2, comparator) {
        var length = arrays.length;
        if (length < 2) {
          return length ? baseUniq(arrays[0]) : [];
        }
        var index2 = -1, result2 = Array2(length);
        while (++index2 < length) {
          var array4 = arrays[index2], othIndex = -1;
          while (++othIndex < length) {
            if (othIndex != index2) {
              result2[index2] = baseDifference(result2[index2] || array4, arrays[othIndex], iteratee2, comparator);
            }
          }
        }
        return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
      }
      function baseZipObject(props, values2, assignFunc) {
        var index2 = -1, length = props.length, valsLength = values2.length, result2 = {};
        while (++index2 < length) {
          var value = index2 < valsLength ? values2[index2] : undefined$1;
          assignFunc(result2, props[index2], value);
        }
        return result2;
      }
      function castArrayLikeObject(value) {
        return isArrayLikeObject(value) ? value : [];
      }
      function castFunction(value) {
        return typeof value == "function" ? value : identity2;
      }
      function castPath(value, object4) {
        if (isArray2(value)) {
          return value;
        }
        return isKey(value, object4) ? [value] : stringToPath(toString(value));
      }
      var castRest = baseRest;
      function castSlice(array4, start2, end2) {
        var length = array4.length;
        end2 = end2 === undefined$1 ? length : end2;
        return !start2 && end2 >= length ? array4 : baseSlice(array4, start2, end2);
      }
      var clearTimeout2 = ctxClearTimeout || function(id2) {
        return root2.clearTimeout(id2);
      };
      function cloneBuffer(buffer, isDeep) {
        if (isDeep) {
          return buffer.slice();
        }
        var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
        buffer.copy(result2);
        return result2;
      }
      function cloneArrayBuffer(arrayBuffer) {
        var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
        new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
        return result2;
      }
      function cloneDataView(dataView, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
        return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
      }
      function cloneRegExp(regexp4) {
        var result2 = new regexp4.constructor(regexp4.source, reFlags.exec(regexp4));
        result2.lastIndex = regexp4.lastIndex;
        return result2;
      }
      function cloneSymbol(symbol) {
        return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
      }
      function cloneTypedArray(typedArray, isDeep) {
        var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
        return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
      }
      function compareAscending(value, other) {
        if (value !== other) {
          var valIsDefined = value !== undefined$1, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol2(value);
          var othIsDefined = other !== undefined$1, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol2(other);
          if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
            return 1;
          }
          if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
            return -1;
          }
        }
        return 0;
      }
      function compareMultiple(object4, other, orders) {
        var index2 = -1, objCriteria = object4.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
        while (++index2 < length) {
          var result2 = compareAscending(objCriteria[index2], othCriteria[index2]);
          if (result2) {
            if (index2 >= ordersLength) {
              return result2;
            }
            var order = orders[index2];
            return result2 * (order == "desc" ? -1 : 1);
          }
        }
        return object4.index - other.index;
      }
      function composeArgs(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
        while (++leftIndex < leftLength) {
          result2[leftIndex] = partials[leftIndex];
        }
        while (++argsIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[holders[argsIndex]] = args[argsIndex];
          }
        }
        while (rangeLength--) {
          result2[leftIndex++] = args[argsIndex++];
        }
        return result2;
      }
      function composeArgsRight(args, partials, holders, isCurried) {
        var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax2(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
        while (++argsIndex < rangeLength) {
          result2[argsIndex] = args[argsIndex];
        }
        var offset = argsIndex;
        while (++rightIndex < rightLength) {
          result2[offset + rightIndex] = partials[rightIndex];
        }
        while (++holdersIndex < holdersLength) {
          if (isUncurried || argsIndex < argsLength) {
            result2[offset + holders[holdersIndex]] = args[argsIndex++];
          }
        }
        return result2;
      }
      function copyArray(source, array4) {
        var index2 = -1, length = source.length;
        array4 || (array4 = Array2(length));
        while (++index2 < length) {
          array4[index2] = source[index2];
        }
        return array4;
      }
      function copyObject(source, props, object4, customizer) {
        var isNew = !object4;
        object4 || (object4 = {});
        var index2 = -1, length = props.length;
        while (++index2 < length) {
          var key = props[index2];
          var newValue = customizer ? customizer(object4[key], source[key], key, object4, source) : undefined$1;
          if (newValue === undefined$1) {
            newValue = source[key];
          }
          if (isNew) {
            baseAssignValue(object4, key, newValue);
          } else {
            assignValue(object4, key, newValue);
          }
        }
        return object4;
      }
      function copySymbols(source, object4) {
        return copyObject(source, getSymbols(source), object4);
      }
      function copySymbolsIn(source, object4) {
        return copyObject(source, getSymbolsIn(source), object4);
      }
      function createAggregator(setter, initializer) {
        return function(collection, iteratee2) {
          var func = isArray2(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
          return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
        };
      }
      function createAssigner(assigner) {
        return baseRest(function(object4, sources) {
          var index2 = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined$1, guard = length > 2 ? sources[2] : undefined$1;
          customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined$1;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            customizer = length < 3 ? undefined$1 : customizer;
            length = 1;
          }
          object4 = Object2(object4);
          while (++index2 < length) {
            var source = sources[index2];
            if (source) {
              assigner(object4, source, index2, customizer);
            }
          }
          return object4;
        });
      }
      function createBaseEach(eachFunc, fromRight) {
        return function(collection, iteratee2) {
          if (collection == null) {
            return collection;
          }
          if (!isArrayLike2(collection)) {
            return eachFunc(collection, iteratee2);
          }
          var length = collection.length, index2 = fromRight ? length : -1, iterable = Object2(collection);
          while (fromRight ? index2-- : ++index2 < length) {
            if (iteratee2(iterable[index2], index2, iterable) === false) {
              break;
            }
          }
          return collection;
        };
      }
      function createBaseFor(fromRight) {
        return function(object4, iteratee2, keysFunc) {
          var index2 = -1, iterable = Object2(object4), props = keysFunc(object4), length = props.length;
          while (length--) {
            var key = props[fromRight ? length : ++index2];
            if (iteratee2(iterable[key], key, iterable) === false) {
              break;
            }
          }
          return object4;
        };
      }
      function createBind(func, bitmask, thisArg) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return fn.apply(isBind ? thisArg : this, arguments);
        }
        return wrapper;
      }
      function createCaseFirst(methodName) {
        return function(string3) {
          string3 = toString(string3);
          var strSymbols = hasUnicode(string3) ? stringToArray(string3) : undefined$1;
          var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
          var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string3.slice(1);
          return chr[methodName]() + trailing;
        };
      }
      function createCompounder(callback) {
        return function(string3) {
          return arrayReduce(words(deburr(string3).replace(reApos, "")), callback, "");
        };
      }
      function createCtor(Ctor) {
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return new Ctor();
            case 1:
              return new Ctor(args[0]);
            case 2:
              return new Ctor(args[0], args[1]);
            case 3:
              return new Ctor(args[0], args[1], args[2]);
            case 4:
              return new Ctor(args[0], args[1], args[2], args[3]);
            case 5:
              return new Ctor(args[0], args[1], args[2], args[3], args[4]);
            case 6:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
            case 7:
              return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
          }
          var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
          return isObject2(result2) ? result2 : thisBinding;
        };
      }
      function createCurry(func, bitmask, arity) {
        var Ctor = createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length, placeholder = getHolder(wrapper);
          while (index2--) {
            args[index2] = arguments[index2];
          }
          var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
          length -= holders.length;
          if (length < arity) {
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, undefined$1, args, holders, undefined$1, undefined$1, arity - length);
          }
          var fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          return apply(fn, this, args);
        }
        return wrapper;
      }
      function createFind(findIndexFunc) {
        return function(collection, predicate, fromIndex) {
          var iterable = Object2(collection);
          if (!isArrayLike2(collection)) {
            var iteratee2 = getIteratee(predicate, 3);
            collection = keys2(collection);
            predicate = function(key) {
              return iteratee2(iterable[key], key, iterable);
            };
          }
          var index2 = findIndexFunc(collection, predicate, fromIndex);
          return index2 > -1 ? iterable[iteratee2 ? collection[index2] : index2] : undefined$1;
        };
      }
      function createFlow(fromRight) {
        return flatRest(function(funcs) {
          var length = funcs.length, index2 = length, prereq = LodashWrapper.prototype.thru;
          if (fromRight) {
            funcs.reverse();
          }
          while (index2--) {
            var func = funcs[index2];
            if (typeof func != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT2);
            }
            if (prereq && !wrapper && getFuncName(func) == "wrapper") {
              var wrapper = new LodashWrapper([], true);
            }
          }
          index2 = wrapper ? index2 : length;
          while (++index2 < length) {
            func = funcs[index2];
            var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined$1;
            if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
              wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
            } else {
              wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
            }
          }
          return function() {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray2(value)) {
              return wrapper.plant(value).value();
            }
            var index3 = 0, result2 = length ? funcs[index3].apply(this, args) : value;
            while (++index3 < length) {
              result2 = funcs[index3].call(this, result2);
            }
            return result2;
          };
        });
      }
      function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
        var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined$1 : createCtor(func);
        function wrapper() {
          var length = arguments.length, args = Array2(length), index2 = length;
          while (index2--) {
            args[index2] = arguments[index2];
          }
          if (isCurried) {
            var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
          }
          if (partials) {
            args = composeArgs(args, partials, holders, isCurried);
          }
          if (partialsRight) {
            args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
          }
          length -= holdersCount;
          if (isCurried && length < arity) {
            var newHolders = replaceHolders(args, placeholder);
            return createRecurry(func, bitmask, createHybrid, wrapper.placeholder, thisArg, args, newHolders, argPos, ary2, arity - length);
          }
          var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
          length = args.length;
          if (argPos) {
            args = reorder(args, argPos);
          } else if (isFlip && length > 1) {
            args.reverse();
          }
          if (isAry && ary2 < length) {
            args.length = ary2;
          }
          if (this && this !== root2 && this instanceof wrapper) {
            fn = Ctor || createCtor(fn);
          }
          return fn.apply(thisBinding, args);
        }
        return wrapper;
      }
      function createInverter(setter, toIteratee) {
        return function(object4, iteratee2) {
          return baseInverter(object4, setter, toIteratee(iteratee2), {});
        };
      }
      function createMathOperation(operator, defaultValue) {
        return function(value, other) {
          var result2;
          if (value === undefined$1 && other === undefined$1) {
            return defaultValue;
          }
          if (value !== undefined$1) {
            result2 = value;
          }
          if (other !== undefined$1) {
            if (result2 === undefined$1) {
              return other;
            }
            if (typeof value == "string" || typeof other == "string") {
              value = baseToString(value);
              other = baseToString(other);
            } else {
              value = baseToNumber(value);
              other = baseToNumber(other);
            }
            result2 = operator(value, other);
          }
          return result2;
        };
      }
      function createOver(arrayFunc) {
        return flatRest(function(iteratees) {
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          return baseRest(function(args) {
            var thisArg = this;
            return arrayFunc(iteratees, function(iteratee2) {
              return apply(iteratee2, thisArg, args);
            });
          });
        });
      }
      function createPadding(length, chars) {
        chars = chars === undefined$1 ? " " : baseToString(chars);
        var charsLength = chars.length;
        if (charsLength < 2) {
          return charsLength ? baseRepeat(chars, length) : chars;
        }
        var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
        return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
      }
      function createPartial(func, bitmask, thisArg, partials) {
        var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
        function wrapper() {
          var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root2 && this instanceof wrapper ? Ctor : func;
          while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
          }
          while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
          }
          return apply(fn, isBind ? thisArg : this, args);
        }
        return wrapper;
      }
      function createRange(fromRight) {
        return function(start2, end2, step) {
          if (step && typeof step != "number" && isIterateeCall(start2, end2, step)) {
            end2 = step = undefined$1;
          }
          start2 = toFinite(start2);
          if (end2 === undefined$1) {
            end2 = start2;
            start2 = 0;
          } else {
            end2 = toFinite(end2);
          }
          step = step === undefined$1 ? start2 < end2 ? 1 : -1 : toFinite(step);
          return baseRange(start2, end2, step, fromRight);
        };
      }
      function createRelationalOperation(operator) {
        return function(value, other) {
          if (!(typeof value == "string" && typeof other == "string")) {
            value = toNumber2(value);
            other = toNumber2(other);
          }
          return operator(value, other);
        };
      }
      function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
        var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined$1, newHoldersRight = isCurry ? undefined$1 : holders, newPartials = isCurry ? partials : undefined$1, newPartialsRight = isCurry ? undefined$1 : partials;
        bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
        bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
        if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
          bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
        }
        var newData = [
          func,
          bitmask,
          thisArg,
          newPartials,
          newHolders,
          newPartialsRight,
          newHoldersRight,
          argPos,
          ary2,
          arity
        ];
        var result2 = wrapFunc.apply(undefined$1, newData);
        if (isLaziable(func)) {
          setData(result2, newData);
        }
        result2.placeholder = placeholder;
        return setWrapToString(result2, func, bitmask);
      }
      function createRound(methodName) {
        var func = Math2[methodName];
        return function(number4, precision) {
          number4 = toNumber2(number4);
          precision = precision == null ? 0 : nativeMin2(toInteger(precision), 292);
          if (precision && nativeIsFinite(number4)) {
            var pair = (toString(number4) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
            pair = (toString(value) + "e").split("e");
            return +(pair[0] + "e" + (+pair[1] - precision));
          }
          return func(number4);
        };
      }
      var createSet = !(Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
        return new Set2(values2);
      };
      function createToPairs(keysFunc) {
        return function(object4) {
          var tag = getTag(object4);
          if (tag == mapTag) {
            return mapToArray(object4);
          }
          if (tag == setTag) {
            return setToPairs(object4);
          }
          return baseToPairs(object4, keysFunc(object4));
        };
      }
      function createWrap2(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
        var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
        if (!isBindKey && typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var length = partials ? partials.length : 0;
        if (!length) {
          bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
          partials = holders = undefined$1;
        }
        ary2 = ary2 === undefined$1 ? ary2 : nativeMax2(toInteger(ary2), 0);
        arity = arity === undefined$1 ? arity : toInteger(arity);
        length -= holders ? holders.length : 0;
        if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
          var partialsRight = partials, holdersRight = holders;
          partials = holders = undefined$1;
        }
        var data = isBindKey ? undefined$1 : getData(func);
        var newData = [
          func,
          bitmask,
          thisArg,
          partials,
          holders,
          partialsRight,
          holdersRight,
          argPos,
          ary2,
          arity
        ];
        if (data) {
          mergeData(newData, data);
        }
        func = newData[0];
        bitmask = newData[1];
        thisArg = newData[2];
        partials = newData[3];
        holders = newData[4];
        arity = newData[9] = newData[9] === undefined$1 ? isBindKey ? 0 : func.length : nativeMax2(newData[9] - length, 0);
        if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
          bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
        }
        if (!bitmask || bitmask == WRAP_BIND_FLAG) {
          var result2 = createBind(func, bitmask, thisArg);
        } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
          result2 = createCurry(func, bitmask, arity);
        } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
          result2 = createPartial(func, bitmask, thisArg, partials);
        } else {
          result2 = createHybrid.apply(undefined$1, newData);
        }
        var setter = data ? baseSetData : setData;
        return setWrapToString(setter(result2, newData), func, bitmask);
      }
      function customDefaultsAssignIn(objValue, srcValue, key, object4) {
        if (objValue === undefined$1 || eq(objValue, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
          return srcValue;
        }
        return objValue;
      }
      function customDefaultsMerge(objValue, srcValue, key, object4, source, stack) {
        if (isObject2(objValue) && isObject2(srcValue)) {
          stack.set(srcValue, objValue);
          baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
          stack["delete"](srcValue);
        }
        return objValue;
      }
      function customOmitClone(value) {
        return isPlainObject(value) ? undefined$1 : value;
      }
      function equalArrays(array4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array4.length, othLength = other.length;
        if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
          return false;
        }
        var arrStacked = stack.get(array4);
        var othStacked = stack.get(other);
        if (arrStacked && othStacked) {
          return arrStacked == other && othStacked == array4;
        }
        var index2 = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined$1;
        stack.set(array4, other);
        stack.set(other, array4);
        while (++index2 < arrLength) {
          var arrValue = array4[index2], othValue = other[index2];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, arrValue, index2, other, array4, stack) : customizer(arrValue, othValue, index2, array4, other, stack);
          }
          if (compared !== undefined$1) {
            if (compared) {
              continue;
            }
            result2 = false;
            break;
          }
          if (seen) {
            if (!arraySome(other, function(othValue2, othIndex) {
              if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                return seen.push(othIndex);
              }
            })) {
              result2 = false;
              break;
            }
          } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
            result2 = false;
            break;
          }
        }
        stack["delete"](array4);
        stack["delete"](other);
        return result2;
      }
      function equalByTag(object4, other, tag, bitmask, customizer, equalFunc, stack) {
        switch (tag) {
          case dataViewTag:
            if (object4.byteLength != other.byteLength || object4.byteOffset != other.byteOffset) {
              return false;
            }
            object4 = object4.buffer;
            other = other.buffer;
          case arrayBufferTag:
            if (object4.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object4), new Uint8Array2(other))) {
              return false;
            }
            return true;
          case boolTag:
          case dateTag:
          case numberTag:
            return eq(+object4, +other);
          case errorTag:
            return object4.name == other.name && object4.message == other.message;
          case regexpTag:
          case stringTag:
            return object4 == other + "";
          case mapTag:
            var convert = mapToArray;
          case setTag:
            var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
            convert || (convert = setToArray);
            if (object4.size != other.size && !isPartial) {
              return false;
            }
            var stacked = stack.get(object4);
            if (stacked) {
              return stacked == other;
            }
            bitmask |= COMPARE_UNORDERED_FLAG;
            stack.set(object4, other);
            var result2 = equalArrays(convert(object4), convert(other), bitmask, customizer, equalFunc, stack);
            stack["delete"](object4);
            return result2;
          case symbolTag2:
            if (symbolValueOf) {
              return symbolValueOf.call(object4) == symbolValueOf.call(other);
            }
        }
        return false;
      }
      function equalObjects(object4, other, bitmask, customizer, equalFunc, stack) {
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object4), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
        if (objLength != othLength && !isPartial) {
          return false;
        }
        var index2 = objLength;
        while (index2--) {
          var key = objProps[index2];
          if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
            return false;
          }
        }
        var objStacked = stack.get(object4);
        var othStacked = stack.get(other);
        if (objStacked && othStacked) {
          return objStacked == other && othStacked == object4;
        }
        var result2 = true;
        stack.set(object4, other);
        stack.set(other, object4);
        var skipCtor = isPartial;
        while (++index2 < objLength) {
          key = objProps[index2];
          var objValue = object4[key], othValue = other[key];
          if (customizer) {
            var compared = isPartial ? customizer(othValue, objValue, key, other, object4, stack) : customizer(objValue, othValue, key, object4, other, stack);
          }
          if (!(compared === undefined$1 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
            result2 = false;
            break;
          }
          skipCtor || (skipCtor = key == "constructor");
        }
        if (result2 && !skipCtor) {
          var objCtor = object4.constructor, othCtor = other.constructor;
          if (objCtor != othCtor && ("constructor" in object4 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
            result2 = false;
          }
        }
        stack["delete"](object4);
        stack["delete"](other);
        return result2;
      }
      function flatRest(func) {
        return setToString(overRest(func, undefined$1, flatten), func + "");
      }
      function getAllKeys(object4) {
        return baseGetAllKeys(object4, keys2, getSymbols);
      }
      function getAllKeysIn(object4) {
        return baseGetAllKeys(object4, keysIn, getSymbolsIn);
      }
      var getData = !metaMap ? noop2 : function(func) {
        return metaMap.get(func);
      };
      function getFuncName(func) {
        var result2 = func.name + "", array4 = realNames[result2], length = hasOwnProperty2.call(realNames, result2) ? array4.length : 0;
        while (length--) {
          var data = array4[length], otherFunc = data.func;
          if (otherFunc == null || otherFunc == func) {
            return data.name;
          }
        }
        return result2;
      }
      function getHolder(func) {
        var object4 = hasOwnProperty2.call(lodash2, "placeholder") ? lodash2 : func;
        return object4.placeholder;
      }
      function getIteratee() {
        var result2 = lodash2.iteratee || iteratee;
        result2 = result2 === iteratee ? baseIteratee : result2;
        return arguments.length ? result2(arguments[0], arguments[1]) : result2;
      }
      function getMapData(map3, key) {
        var data = map3.__data__;
        return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
      }
      function getMatchData(object4) {
        var result2 = keys2(object4), length = result2.length;
        while (length--) {
          var key = result2[length], value = object4[key];
          result2[length] = [key, value, isStrictComparable(value)];
        }
        return result2;
      }
      function getNative(object4, key) {
        var value = getValue2(object4, key);
        return baseIsNative(value) ? value : undefined$1;
      }
      function getRawTag2(value) {
        var isOwn = hasOwnProperty2.call(value, symToStringTag2), tag = value[symToStringTag2];
        try {
          value[symToStringTag2] = undefined$1;
          var unmasked = true;
        } catch (e2) {
        }
        var result2 = nativeObjectToString2.call(value);
        if (unmasked) {
          if (isOwn) {
            value[symToStringTag2] = tag;
          } else {
            delete value[symToStringTag2];
          }
        }
        return result2;
      }
      var getSymbols = !nativeGetSymbols ? stubArray : function(object4) {
        if (object4 == null) {
          return [];
        }
        object4 = Object2(object4);
        return arrayFilter(nativeGetSymbols(object4), function(symbol) {
          return propertyIsEnumerable.call(object4, symbol);
        });
      };
      var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object4) {
        var result2 = [];
        while (object4) {
          arrayPush(result2, getSymbols(object4));
          object4 = getPrototype(object4);
        }
        return result2;
      };
      var getTag = baseGetTag2;
      if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap3 && getTag(new WeakMap3()) != weakMapTag) {
        getTag = function(value) {
          var result2 = baseGetTag2(value), Ctor = result2 == objectTag ? value.constructor : undefined$1, ctorString = Ctor ? toSource(Ctor) : "";
          if (ctorString) {
            switch (ctorString) {
              case dataViewCtorString:
                return dataViewTag;
              case mapCtorString:
                return mapTag;
              case promiseCtorString:
                return promiseTag;
              case setCtorString:
                return setTag;
              case weakMapCtorString:
                return weakMapTag;
            }
          }
          return result2;
        };
      }
      function getView(start2, end2, transforms) {
        var index2 = -1, length = transforms.length;
        while (++index2 < length) {
          var data = transforms[index2], size2 = data.size;
          switch (data.type) {
            case "drop":
              start2 += size2;
              break;
            case "dropRight":
              end2 -= size2;
              break;
            case "take":
              end2 = nativeMin2(end2, start2 + size2);
              break;
            case "takeRight":
              start2 = nativeMax2(start2, end2 - size2);
              break;
          }
        }
        return { "start": start2, "end": end2 };
      }
      function getWrapDetails(source) {
        var match = source.match(reWrapDetails);
        return match ? match[1].split(reSplitDetails) : [];
      }
      function hasPath(object4, path, hasFunc) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length, result2 = false;
        while (++index2 < length) {
          var key = toKey(path[index2]);
          if (!(result2 = object4 != null && hasFunc(object4, key))) {
            break;
          }
          object4 = object4[key];
        }
        if (result2 || ++index2 != length) {
          return result2;
        }
        length = object4 == null ? 0 : object4.length;
        return !!length && isLength(length) && isIndex(key, length) && (isArray2(object4) || isArguments(object4));
      }
      function initCloneArray(array4) {
        var length = array4.length, result2 = new array4.constructor(length);
        if (length && typeof array4[0] == "string" && hasOwnProperty2.call(array4, "index")) {
          result2.index = array4.index;
          result2.input = array4.input;
        }
        return result2;
      }
      function initCloneObject(object4) {
        return typeof object4.constructor == "function" && !isPrototype(object4) ? baseCreate(getPrototype(object4)) : {};
      }
      function initCloneByTag(object4, tag, isDeep) {
        var Ctor = object4.constructor;
        switch (tag) {
          case arrayBufferTag:
            return cloneArrayBuffer(object4);
          case boolTag:
          case dateTag:
            return new Ctor(+object4);
          case dataViewTag:
            return cloneDataView(object4, isDeep);
          case float32Tag:
          case float64Tag:
          case int8Tag:
          case int16Tag:
          case int32Tag:
          case uint8Tag:
          case uint8ClampedTag:
          case uint16Tag:
          case uint32Tag:
            return cloneTypedArray(object4, isDeep);
          case mapTag:
            return new Ctor();
          case numberTag:
          case stringTag:
            return new Ctor(object4);
          case regexpTag:
            return cloneRegExp(object4);
          case setTag:
            return new Ctor();
          case symbolTag2:
            return cloneSymbol(object4);
        }
      }
      function insertWrapDetails(source, details) {
        var length = details.length;
        if (!length) {
          return source;
        }
        var lastIndex = length - 1;
        details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
        details = details.join(length > 2 ? ", " : " ");
        return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
      }
      function isFlattenable(value) {
        return isArray2(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
      }
      function isIndex(value, length) {
        var type4 = typeof value;
        length = length == null ? MAX_SAFE_INTEGER2 : length;
        return !!length && (type4 == "number" || type4 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
      }
      function isIterateeCall(value, index2, object4) {
        if (!isObject2(object4)) {
          return false;
        }
        var type4 = typeof index2;
        if (type4 == "number" ? isArrayLike2(object4) && isIndex(index2, object4.length) : type4 == "string" && index2 in object4) {
          return eq(object4[index2], value);
        }
        return false;
      }
      function isKey(value, object4) {
        if (isArray2(value)) {
          return false;
        }
        var type4 = typeof value;
        if (type4 == "number" || type4 == "symbol" || type4 == "boolean" || value == null || isSymbol2(value)) {
          return true;
        }
        return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object4 != null && value in Object2(object4);
      }
      function isKeyable(value) {
        var type4 = typeof value;
        return type4 == "string" || type4 == "number" || type4 == "symbol" || type4 == "boolean" ? value !== "__proto__" : value === null;
      }
      function isLaziable(func) {
        var funcName = getFuncName(func), other = lodash2[funcName];
        if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
          return false;
        }
        if (func === other) {
          return true;
        }
        var data = getData(other);
        return !!data && func === data[0];
      }
      function isMasked(func) {
        return !!maskSrcKey && maskSrcKey in func;
      }
      var isMaskable = coreJsData ? isFunction2 : stubFalse;
      function isPrototype(value) {
        var Ctor = value && value.constructor, proto2 = typeof Ctor == "function" && Ctor.prototype || objectProto2;
        return value === proto2;
      }
      function isStrictComparable(value) {
        return value === value && !isObject2(value);
      }
      function matchesStrictComparable(key, srcValue) {
        return function(object4) {
          if (object4 == null) {
            return false;
          }
          return object4[key] === srcValue && (srcValue !== undefined$1 || key in Object2(object4));
        };
      }
      function memoizeCapped(func) {
        var result2 = memoize(func, function(key) {
          if (cache.size === MAX_MEMOIZE_SIZE) {
            cache.clear();
          }
          return key;
        });
        var cache = result2.cache;
        return result2;
      }
      function mergeData(data, source) {
        var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
        var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
        if (!(isCommon || isCombo)) {
          return data;
        }
        if (srcBitmask & WRAP_BIND_FLAG) {
          data[2] = source[2];
          newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
        }
        var value = source[3];
        if (value) {
          var partials = data[3];
          data[3] = partials ? composeArgs(partials, value, source[4]) : value;
          data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
        }
        value = source[5];
        if (value) {
          partials = data[5];
          data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
          data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
        }
        value = source[7];
        if (value) {
          data[7] = value;
        }
        if (srcBitmask & WRAP_ARY_FLAG) {
          data[8] = data[8] == null ? source[8] : nativeMin2(data[8], source[8]);
        }
        if (data[9] == null) {
          data[9] = source[9];
        }
        data[0] = source[0];
        data[1] = newBitmask;
        return data;
      }
      function nativeKeysIn(object4) {
        var result2 = [];
        if (object4 != null) {
          for (var key in Object2(object4)) {
            result2.push(key);
          }
        }
        return result2;
      }
      function objectToString2(value) {
        return nativeObjectToString2.call(value);
      }
      function overRest(func, start2, transform3) {
        start2 = nativeMax2(start2 === undefined$1 ? func.length - 1 : start2, 0);
        return function() {
          var args = arguments, index2 = -1, length = nativeMax2(args.length - start2, 0), array4 = Array2(length);
          while (++index2 < length) {
            array4[index2] = args[start2 + index2];
          }
          index2 = -1;
          var otherArgs = Array2(start2 + 1);
          while (++index2 < start2) {
            otherArgs[index2] = args[index2];
          }
          otherArgs[start2] = transform3(array4);
          return apply(func, this, otherArgs);
        };
      }
      function parent(object4, path) {
        return path.length < 2 ? object4 : baseGet(object4, baseSlice(path, 0, -1));
      }
      function reorder(array4, indexes) {
        var arrLength = array4.length, length = nativeMin2(indexes.length, arrLength), oldArray = copyArray(array4);
        while (length--) {
          var index2 = indexes[length];
          array4[length] = isIndex(index2, arrLength) ? oldArray[index2] : undefined$1;
        }
        return array4;
      }
      function safeGet(object4, key) {
        if (key === "constructor" && typeof object4[key] === "function") {
          return;
        }
        if (key == "__proto__") {
          return;
        }
        return object4[key];
      }
      var setData = shortOut(baseSetData);
      var setTimeout2 = ctxSetTimeout || function(func, wait) {
        return root2.setTimeout(func, wait);
      };
      var setToString = shortOut(baseSetToString);
      function setWrapToString(wrapper, reference, bitmask) {
        var source = reference + "";
        return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
      }
      function shortOut(func) {
        var count2 = 0, lastCalled = 0;
        return function() {
          var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
          lastCalled = stamp;
          if (remaining > 0) {
            if (++count2 >= HOT_COUNT) {
              return arguments[0];
            }
          } else {
            count2 = 0;
          }
          return func.apply(undefined$1, arguments);
        };
      }
      function shuffleSelf(array4, size2) {
        var index2 = -1, length = array4.length, lastIndex = length - 1;
        size2 = size2 === undefined$1 ? length : size2;
        while (++index2 < size2) {
          var rand = baseRandom(index2, lastIndex), value = array4[rand];
          array4[rand] = array4[index2];
          array4[index2] = value;
        }
        array4.length = size2;
        return array4;
      }
      var stringToPath = memoizeCapped(function(string3) {
        var result2 = [];
        if (string3.charCodeAt(0) === 46) {
          result2.push("");
        }
        string3.replace(rePropName, function(match, number4, quote, subString) {
          result2.push(quote ? subString.replace(reEscapeChar, "$1") : number4 || match);
        });
        return result2;
      });
      function toKey(value) {
        if (typeof value == "string" || isSymbol2(value)) {
          return value;
        }
        var result2 = value + "";
        return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
      }
      function toSource(func) {
        if (func != null) {
          try {
            return funcToString.call(func);
          } catch (e2) {
          }
          try {
            return func + "";
          } catch (e2) {
          }
        }
        return "";
      }
      function updateWrapDetails(details, bitmask) {
        arrayEach(wrapFlags, function(pair) {
          var value = "_." + pair[0];
          if (bitmask & pair[1] && !arrayIncludes(details, value)) {
            details.push(value);
          }
        });
        return details.sort();
      }
      function wrapperClone(wrapper) {
        if (wrapper instanceof LazyWrapper) {
          return wrapper.clone();
        }
        var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
        result2.__actions__ = copyArray(wrapper.__actions__);
        result2.__index__ = wrapper.__index__;
        result2.__values__ = wrapper.__values__;
        return result2;
      }
      function chunk(array4, size2, guard) {
        if (guard ? isIterateeCall(array4, size2, guard) : size2 === undefined$1) {
          size2 = 1;
        } else {
          size2 = nativeMax2(toInteger(size2), 0);
        }
        var length = array4 == null ? 0 : array4.length;
        if (!length || size2 < 1) {
          return [];
        }
        var index2 = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
        while (index2 < length) {
          result2[resIndex++] = baseSlice(array4, index2, index2 += size2);
        }
        return result2;
      }
      function compact(array4) {
        var index2 = -1, length = array4 == null ? 0 : array4.length, resIndex = 0, result2 = [];
        while (++index2 < length) {
          var value = array4[index2];
          if (value) {
            result2[resIndex++] = value;
          }
        }
        return result2;
      }
      function concat() {
        var length = arguments.length;
        if (!length) {
          return [];
        }
        var args = Array2(length - 1), array4 = arguments[0], index2 = length;
        while (index2--) {
          args[index2 - 1] = arguments[index2];
        }
        return arrayPush(isArray2(array4) ? copyArray(array4) : [array4], baseFlatten(args, 1));
      }
      var difference = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
      });
      var differenceBy = baseRest(function(array4, values2) {
        var iteratee2 = last(values2);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
      });
      var differenceWith = baseRest(function(array4, values2) {
        var comparator = last(values2);
        if (isArrayLikeObject(comparator)) {
          comparator = undefined$1;
        }
        return isArrayLikeObject(array4) ? baseDifference(array4, baseFlatten(values2, 1, isArrayLikeObject, true), undefined$1, comparator) : [];
      });
      function drop(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function dropRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function dropRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true, true) : [];
      }
      function dropWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), true) : [];
      }
      function fill(array4, value, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (start2 && typeof start2 != "number" && isIterateeCall(array4, value, start2)) {
          start2 = 0;
          end2 = length;
        }
        return baseFill(array4, value, start2, end2);
      }
      function findIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2);
      }
      function findLastIndex(array4, predicate, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length - 1;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = fromIndex < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return baseFindIndex(array4, getIteratee(predicate, 3), index2, true);
      }
      function flatten(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, 1) : [];
      }
      function flattenDeep(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseFlatten(array4, INFINITY) : [];
      }
      function flattenDepth(array4, depth) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(array4, depth);
      }
      function fromPairs(pairs) {
        var index2 = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
        while (++index2 < length) {
          var pair = pairs[index2];
          result2[pair[0]] = pair[1];
        }
        return result2;
      }
      function head(array4) {
        return array4 && array4.length ? array4[0] : undefined$1;
      }
      function indexOf2(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = fromIndex == null ? 0 : toInteger(fromIndex);
        if (index2 < 0) {
          index2 = nativeMax2(length + index2, 0);
        }
        return baseIndexOf(array4, value, index2);
      }
      function initial(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 0, -1) : [];
      }
      var intersection = baseRest(function(arrays) {
        var mapped = arrayMap(arrays, castArrayLikeObject);
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
      });
      var intersectionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        if (iteratee2 === last(mapped)) {
          iteratee2 = undefined$1;
        } else {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
      });
      var intersectionWith = baseRest(function(arrays) {
        var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        if (comparator) {
          mapped.pop();
        }
        return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined$1, comparator) : [];
      });
      function join(array4, separator) {
        return array4 == null ? "" : nativeJoin.call(array4, separator);
      }
      function last(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? array4[length - 1] : undefined$1;
      }
      function lastIndexOf(array4, value, fromIndex) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return -1;
        }
        var index2 = length;
        if (fromIndex !== undefined$1) {
          index2 = toInteger(fromIndex);
          index2 = index2 < 0 ? nativeMax2(length + index2, 0) : nativeMin2(index2, length - 1);
        }
        return value === value ? strictLastIndexOf(array4, value, index2) : baseFindIndex(array4, baseIsNaN, index2, true);
      }
      function nth(array4, n2) {
        return array4 && array4.length ? baseNth(array4, toInteger(n2)) : undefined$1;
      }
      var pull = baseRest(pullAll);
      function pullAll(array4, values2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2) : array4;
      }
      function pullAllBy(array4, values2, iteratee2) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, getIteratee(iteratee2, 2)) : array4;
      }
      function pullAllWith(array4, values2, comparator) {
        return array4 && array4.length && values2 && values2.length ? basePullAll(array4, values2, undefined$1, comparator) : array4;
      }
      var pullAt = flatRest(function(array4, indexes) {
        var length = array4 == null ? 0 : array4.length, result2 = baseAt(array4, indexes);
        basePullAt(array4, arrayMap(indexes, function(index2) {
          return isIndex(index2, length) ? +index2 : index2;
        }).sort(compareAscending));
        return result2;
      });
      function remove(array4, predicate) {
        var result2 = [];
        if (!(array4 && array4.length)) {
          return result2;
        }
        var index2 = -1, indexes = [], length = array4.length;
        predicate = getIteratee(predicate, 3);
        while (++index2 < length) {
          var value = array4[index2];
          if (predicate(value, index2, array4)) {
            result2.push(value);
            indexes.push(index2);
          }
        }
        basePullAt(array4, indexes);
        return result2;
      }
      function reverse2(array4) {
        return array4 == null ? array4 : nativeReverse.call(array4);
      }
      function slice2(array4, start2, end2) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        if (end2 && typeof end2 != "number" && isIterateeCall(array4, start2, end2)) {
          start2 = 0;
          end2 = length;
        } else {
          start2 = start2 == null ? 0 : toInteger(start2);
          end2 = end2 === undefined$1 ? length : toInteger(end2);
        }
        return baseSlice(array4, start2, end2);
      }
      function sortedIndex(array4, value) {
        return baseSortedIndex(array4, value);
      }
      function sortedIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2));
      }
      function sortedIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value);
          if (index2 < length && eq(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedLastIndex(array4, value) {
        return baseSortedIndex(array4, value, true);
      }
      function sortedLastIndexBy(array4, value, iteratee2) {
        return baseSortedIndexBy(array4, value, getIteratee(iteratee2, 2), true);
      }
      function sortedLastIndexOf(array4, value) {
        var length = array4 == null ? 0 : array4.length;
        if (length) {
          var index2 = baseSortedIndex(array4, value, true) - 1;
          if (eq(array4[index2], value)) {
            return index2;
          }
        }
        return -1;
      }
      function sortedUniq(array4) {
        return array4 && array4.length ? baseSortedUniq(array4) : [];
      }
      function sortedUniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseSortedUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function tail(array4) {
        var length = array4 == null ? 0 : array4.length;
        return length ? baseSlice(array4, 1, length) : [];
      }
      function take2(array4, n2, guard) {
        if (!(array4 && array4.length)) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        return baseSlice(array4, 0, n2 < 0 ? 0 : n2);
      }
      function takeRight(array4, n2, guard) {
        var length = array4 == null ? 0 : array4.length;
        if (!length) {
          return [];
        }
        n2 = guard || n2 === undefined$1 ? 1 : toInteger(n2);
        n2 = length - n2;
        return baseSlice(array4, n2 < 0 ? 0 : n2, length);
      }
      function takeRightWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3), false, true) : [];
      }
      function takeWhile(array4, predicate) {
        return array4 && array4.length ? baseWhile(array4, getIteratee(predicate, 3)) : [];
      }
      var union = baseRest(function(arrays) {
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
      });
      var unionBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
      });
      var unionWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
      });
      function uniq(array4) {
        return array4 && array4.length ? baseUniq(array4) : [];
      }
      function uniqBy(array4, iteratee2) {
        return array4 && array4.length ? baseUniq(array4, getIteratee(iteratee2, 2)) : [];
      }
      function uniqWith(array4, comparator) {
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return array4 && array4.length ? baseUniq(array4, undefined$1, comparator) : [];
      }
      function unzip(array4) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var length = 0;
        array4 = arrayFilter(array4, function(group) {
          if (isArrayLikeObject(group)) {
            length = nativeMax2(group.length, length);
            return true;
          }
        });
        return baseTimes(length, function(index2) {
          return arrayMap(array4, baseProperty(index2));
        });
      }
      function unzipWith(array4, iteratee2) {
        if (!(array4 && array4.length)) {
          return [];
        }
        var result2 = unzip(array4);
        if (iteratee2 == null) {
          return result2;
        }
        return arrayMap(result2, function(group) {
          return apply(iteratee2, undefined$1, group);
        });
      }
      var without = baseRest(function(array4, values2) {
        return isArrayLikeObject(array4) ? baseDifference(array4, values2) : [];
      });
      var xor = baseRest(function(arrays) {
        return baseXor(arrayFilter(arrays, isArrayLikeObject));
      });
      var xorBy = baseRest(function(arrays) {
        var iteratee2 = last(arrays);
        if (isArrayLikeObject(iteratee2)) {
          iteratee2 = undefined$1;
        }
        return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
      });
      var xorWith = baseRest(function(arrays) {
        var comparator = last(arrays);
        comparator = typeof comparator == "function" ? comparator : undefined$1;
        return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined$1, comparator);
      });
      var zip = baseRest(unzip);
      function zipObject(props, values2) {
        return baseZipObject(props || [], values2 || [], assignValue);
      }
      function zipObjectDeep(props, values2) {
        return baseZipObject(props || [], values2 || [], baseSet);
      }
      var zipWith = baseRest(function(arrays) {
        var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined$1;
        iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined$1;
        return unzipWith(arrays, iteratee2);
      });
      function chain(value) {
        var result2 = lodash2(value);
        result2.__chain__ = true;
        return result2;
      }
      function tap(value, interceptor) {
        interceptor(value);
        return value;
      }
      function thru(value, interceptor) {
        return interceptor(value);
      }
      var wrapperAt = flatRest(function(paths) {
        var length = paths.length, start2 = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object4) {
          return baseAt(object4, paths);
        };
        if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start2)) {
          return this.thru(interceptor);
        }
        value = value.slice(start2, +start2 + (length ? 1 : 0));
        value.__actions__.push({
          "func": thru,
          "args": [interceptor],
          "thisArg": undefined$1
        });
        return new LodashWrapper(value, this.__chain__).thru(function(array4) {
          if (length && !array4.length) {
            array4.push(undefined$1);
          }
          return array4;
        });
      });
      function wrapperChain() {
        return chain(this);
      }
      function wrapperCommit() {
        return new LodashWrapper(this.value(), this.__chain__);
      }
      function wrapperNext() {
        if (this.__values__ === undefined$1) {
          this.__values__ = toArray2(this.value());
        }
        var done = this.__index__ >= this.__values__.length, value = done ? undefined$1 : this.__values__[this.__index__++];
        return { "done": done, "value": value };
      }
      function wrapperToIterator() {
        return this;
      }
      function wrapperPlant(value) {
        var result2, parent2 = this;
        while (parent2 instanceof baseLodash) {
          var clone3 = wrapperClone(parent2);
          clone3.__index__ = 0;
          clone3.__values__ = undefined$1;
          if (result2) {
            previous.__wrapped__ = clone3;
          } else {
            result2 = clone3;
          }
          var previous = clone3;
          parent2 = parent2.__wrapped__;
        }
        previous.__wrapped__ = value;
        return result2;
      }
      function wrapperReverse() {
        var value = this.__wrapped__;
        if (value instanceof LazyWrapper) {
          var wrapped = value;
          if (this.__actions__.length) {
            wrapped = new LazyWrapper(this);
          }
          wrapped = wrapped.reverse();
          wrapped.__actions__.push({
            "func": thru,
            "args": [reverse2],
            "thisArg": undefined$1
          });
          return new LodashWrapper(wrapped, this.__chain__);
        }
        return this.thru(reverse2);
      }
      function wrapperValue() {
        return baseWrapperValue(this.__wrapped__, this.__actions__);
      }
      var countBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          ++result2[key];
        } else {
          baseAssignValue(result2, key, 1);
        }
      });
      function every(collection, predicate, guard) {
        var func = isArray2(collection) ? arrayEvery : baseEvery;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      function filter2(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter : baseFilter;
        return func(collection, getIteratee(predicate, 3));
      }
      var find2 = createFind(findIndex);
      var findLast = createFind(findLastIndex);
      function flatMap(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), 1);
      }
      function flatMapDeep(collection, iteratee2) {
        return baseFlatten(map2(collection, iteratee2), INFINITY);
      }
      function flatMapDepth(collection, iteratee2, depth) {
        depth = depth === undefined$1 ? 1 : toInteger(depth);
        return baseFlatten(map2(collection, iteratee2), depth);
      }
      function forEach(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEach : baseEach;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function forEachRight(collection, iteratee2) {
        var func = isArray2(collection) ? arrayEachRight : baseEachRight;
        return func(collection, getIteratee(iteratee2, 3));
      }
      var groupBy = createAggregator(function(result2, value, key) {
        if (hasOwnProperty2.call(result2, key)) {
          result2[key].push(value);
        } else {
          baseAssignValue(result2, key, [value]);
        }
      });
      function includes(collection, value, fromIndex, guard) {
        collection = isArrayLike2(collection) ? collection : values(collection);
        fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
        var length = collection.length;
        if (fromIndex < 0) {
          fromIndex = nativeMax2(length + fromIndex, 0);
        }
        return isString2(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
      }
      var invokeMap = baseRest(function(collection, path, args) {
        var index2 = -1, isFunc = typeof path == "function", result2 = isArrayLike2(collection) ? Array2(collection.length) : [];
        baseEach(collection, function(value) {
          result2[++index2] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
        });
        return result2;
      });
      var keyBy = createAggregator(function(result2, value, key) {
        baseAssignValue(result2, key, value);
      });
      function map2(collection, iteratee2) {
        var func = isArray2(collection) ? arrayMap : baseMap;
        return func(collection, getIteratee(iteratee2, 3));
      }
      function orderBy(collection, iteratees, orders, guard) {
        if (collection == null) {
          return [];
        }
        if (!isArray2(iteratees)) {
          iteratees = iteratees == null ? [] : [iteratees];
        }
        orders = guard ? undefined$1 : orders;
        if (!isArray2(orders)) {
          orders = orders == null ? [] : [orders];
        }
        return baseOrderBy(collection, iteratees, orders);
      }
      var partition = createAggregator(function(result2, value, key) {
        result2[key ? 0 : 1].push(value);
      }, function() {
        return [[], []];
      });
      function reduce2(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
      }
      function reduceRight(collection, iteratee2, accumulator) {
        var func = isArray2(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
        return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
      }
      function reject(collection, predicate) {
        var func = isArray2(collection) ? arrayFilter : baseFilter;
        return func(collection, negate(getIteratee(predicate, 3)));
      }
      function sample(collection) {
        var func = isArray2(collection) ? arraySample : baseSample;
        return func(collection);
      }
      function sampleSize(collection, n2, guard) {
        if (guard ? isIterateeCall(collection, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        var func = isArray2(collection) ? arraySampleSize : baseSampleSize;
        return func(collection, n2);
      }
      function shuffle(collection) {
        var func = isArray2(collection) ? arrayShuffle : baseShuffle;
        return func(collection);
      }
      function size(collection) {
        if (collection == null) {
          return 0;
        }
        if (isArrayLike2(collection)) {
          return isString2(collection) ? stringSize(collection) : collection.length;
        }
        var tag = getTag(collection);
        if (tag == mapTag || tag == setTag) {
          return collection.size;
        }
        return baseKeys(collection).length;
      }
      function some(collection, predicate, guard) {
        var func = isArray2(collection) ? arraySome : baseSome;
        if (guard && isIterateeCall(collection, predicate, guard)) {
          predicate = undefined$1;
        }
        return func(collection, getIteratee(predicate, 3));
      }
      var sortBy = baseRest(function(collection, iteratees) {
        if (collection == null) {
          return [];
        }
        var length = iteratees.length;
        if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
          iteratees = [];
        } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
          iteratees = [iteratees[0]];
        }
        return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
      });
      var now2 = ctxNow || function() {
        return root2.Date.now();
      };
      function after(n2, func) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 < 1) {
            return func.apply(this, arguments);
          }
        };
      }
      function ary(func, n2, guard) {
        n2 = guard ? undefined$1 : n2;
        n2 = func && n2 == null ? func.length : n2;
        return createWrap2(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n2);
      }
      function before(n2, func) {
        var result2;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        n2 = toInteger(n2);
        return function() {
          if (--n2 > 0) {
            result2 = func.apply(this, arguments);
          }
          if (n2 <= 1) {
            func = undefined$1;
          }
          return result2;
        };
      }
      var bind2 = baseRest(function(func, thisArg, partials) {
        var bitmask = WRAP_BIND_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bind2));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(func, bitmask, thisArg, partials, holders);
      });
      var bindKey = baseRest(function(object4, key, partials) {
        var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
        if (partials.length) {
          var holders = replaceHolders(partials, getHolder(bindKey));
          bitmask |= WRAP_PARTIAL_FLAG;
        }
        return createWrap2(key, bitmask, object4, partials, holders);
      });
      function curry2(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curry2.placeholder;
        return result2;
      }
      function curryRight(func, arity, guard) {
        arity = guard ? undefined$1 : arity;
        var result2 = createWrap2(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
        result2.placeholder = curryRight.placeholder;
        return result2;
      }
      function debounce2(func, wait, options) {
        var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        wait = toNumber2(wait) || 0;
        if (isObject2(options)) {
          leading = !!options.leading;
          maxing = "maxWait" in options;
          maxWait = maxing ? nativeMax2(toNumber2(options.maxWait) || 0, wait) : maxWait;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        function invokeFunc(time) {
          var args = lastArgs, thisArg = lastThis;
          lastArgs = lastThis = undefined$1;
          lastInvokeTime = time;
          result2 = func.apply(thisArg, args);
          return result2;
        }
        function leadingEdge(time) {
          lastInvokeTime = time;
          timerId = setTimeout2(timerExpired, wait);
          return leading ? invokeFunc(time) : result2;
        }
        function remainingWait(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
          return maxing ? nativeMin2(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
        }
        function shouldInvoke(time) {
          var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
          return lastCallTime === undefined$1 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
        }
        function timerExpired() {
          var time = now2();
          if (shouldInvoke(time)) {
            return trailingEdge(time);
          }
          timerId = setTimeout2(timerExpired, remainingWait(time));
        }
        function trailingEdge(time) {
          timerId = undefined$1;
          if (trailing && lastArgs) {
            return invokeFunc(time);
          }
          lastArgs = lastThis = undefined$1;
          return result2;
        }
        function cancel2() {
          if (timerId !== undefined$1) {
            clearTimeout2(timerId);
          }
          lastInvokeTime = 0;
          lastArgs = lastCallTime = lastThis = timerId = undefined$1;
        }
        function flush() {
          return timerId === undefined$1 ? result2 : trailingEdge(now2());
        }
        function debounced() {
          var time = now2(), isInvoking = shouldInvoke(time);
          lastArgs = arguments;
          lastThis = this;
          lastCallTime = time;
          if (isInvoking) {
            if (timerId === undefined$1) {
              return leadingEdge(lastCallTime);
            }
            if (maxing) {
              clearTimeout2(timerId);
              timerId = setTimeout2(timerExpired, wait);
              return invokeFunc(lastCallTime);
            }
          }
          if (timerId === undefined$1) {
            timerId = setTimeout2(timerExpired, wait);
          }
          return result2;
        }
        debounced.cancel = cancel2;
        debounced.flush = flush;
        return debounced;
      }
      var defer = baseRest(function(func, args) {
        return baseDelay(func, 1, args);
      });
      var delay = baseRest(function(func, wait, args) {
        return baseDelay(func, toNumber2(wait) || 0, args);
      });
      function flip(func) {
        return createWrap2(func, WRAP_FLIP_FLAG);
      }
      function memoize(func, resolver) {
        if (typeof func != "function" || resolver != null && typeof resolver != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        var memoized = function() {
          var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
          if (cache.has(key)) {
            return cache.get(key);
          }
          var result2 = func.apply(this, args);
          memoized.cache = cache.set(key, result2) || cache;
          return result2;
        };
        memoized.cache = new (memoize.Cache || MapCache)();
        return memoized;
      }
      memoize.Cache = MapCache;
      function negate(predicate) {
        if (typeof predicate != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        return function() {
          var args = arguments;
          switch (args.length) {
            case 0:
              return !predicate.call(this);
            case 1:
              return !predicate.call(this, args[0]);
            case 2:
              return !predicate.call(this, args[0], args[1]);
            case 3:
              return !predicate.call(this, args[0], args[1], args[2]);
          }
          return !predicate.apply(this, args);
        };
      }
      function once(func) {
        return before(2, func);
      }
      var overArgs = castRest(function(func, transforms) {
        transforms = transforms.length == 1 && isArray2(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
        var funcsLength = transforms.length;
        return baseRest(function(args) {
          var index2 = -1, length = nativeMin2(args.length, funcsLength);
          while (++index2 < length) {
            args[index2] = transforms[index2].call(this, args[index2]);
          }
          return apply(func, this, args);
        });
      });
      var partial = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partial));
        return createWrap2(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
      });
      var partialRight = baseRest(function(func, partials) {
        var holders = replaceHolders(partials, getHolder(partialRight));
        return createWrap2(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
      });
      var rearg = flatRest(function(func, indexes) {
        return createWrap2(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
      });
      function rest(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 === undefined$1 ? start2 : toInteger(start2);
        return baseRest(func, start2);
      }
      function spread(func, start2) {
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        start2 = start2 == null ? 0 : nativeMax2(toInteger(start2), 0);
        return baseRest(function(args) {
          var array4 = args[start2], otherArgs = castSlice(args, 0, start2);
          if (array4) {
            arrayPush(otherArgs, array4);
          }
          return apply(func, this, otherArgs);
        });
      }
      function throttle2(func, wait, options) {
        var leading = true, trailing = true;
        if (typeof func != "function") {
          throw new TypeError2(FUNC_ERROR_TEXT2);
        }
        if (isObject2(options)) {
          leading = "leading" in options ? !!options.leading : leading;
          trailing = "trailing" in options ? !!options.trailing : trailing;
        }
        return debounce2(func, wait, {
          "leading": leading,
          "maxWait": wait,
          "trailing": trailing
        });
      }
      function unary(func) {
        return ary(func, 1);
      }
      function wrap(value, wrapper) {
        return partial(castFunction(wrapper), value);
      }
      function castArray() {
        if (!arguments.length) {
          return [];
        }
        var value = arguments[0];
        return isArray2(value) ? value : [value];
      }
      function clone2(value) {
        return baseClone(value, CLONE_SYMBOLS_FLAG);
      }
      function cloneWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
      }
      function cloneDeep(value) {
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
      }
      function cloneDeepWith(value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
      }
      function conformsTo(object4, source) {
        return source == null || baseConformsTo(object4, source, keys2(source));
      }
      function eq(value, other) {
        return value === other || value !== value && other !== other;
      }
      var gt = createRelationalOperation(baseGt);
      var gte = createRelationalOperation(function(value, other) {
        return value >= other;
      });
      var isArguments = baseIsArguments(function() {
        return arguments;
      }()) ? baseIsArguments : function(value) {
        return isObjectLike2(value) && hasOwnProperty2.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
      };
      var isArray2 = Array2.isArray;
      var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
      function isArrayLike2(value) {
        return value != null && isLength(value.length) && !isFunction2(value);
      }
      function isArrayLikeObject(value) {
        return isObjectLike2(value) && isArrayLike2(value);
      }
      function isBoolean(value) {
        return value === true || value === false || isObjectLike2(value) && baseGetTag2(value) == boolTag;
      }
      var isBuffer = nativeIsBuffer || stubFalse;
      var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
      function isElement(value) {
        return isObjectLike2(value) && value.nodeType === 1 && !isPlainObject(value);
      }
      function isEmpty(value) {
        if (value == null) {
          return true;
        }
        if (isArrayLike2(value) && (isArray2(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray2(value) || isArguments(value))) {
          return !value.length;
        }
        var tag = getTag(value);
        if (tag == mapTag || tag == setTag) {
          return !value.size;
        }
        if (isPrototype(value)) {
          return !baseKeys(value).length;
        }
        for (var key in value) {
          if (hasOwnProperty2.call(value, key)) {
            return false;
          }
        }
        return true;
      }
      function isEqual(value, other) {
        return baseIsEqual(value, other);
      }
      function isEqualWith(value, other, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        var result2 = customizer ? customizer(value, other) : undefined$1;
        return result2 === undefined$1 ? baseIsEqual(value, other, undefined$1, customizer) : !!result2;
      }
      function isError(value) {
        if (!isObjectLike2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
      }
      function isFinite2(value) {
        return typeof value == "number" && nativeIsFinite(value);
      }
      function isFunction2(value) {
        if (!isObject2(value)) {
          return false;
        }
        var tag = baseGetTag2(value);
        return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
      }
      function isInteger(value) {
        return typeof value == "number" && value == toInteger(value);
      }
      function isLength(value) {
        return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
      }
      function isObject2(value) {
        var type4 = typeof value;
        return value != null && (type4 == "object" || type4 == "function");
      }
      function isObjectLike2(value) {
        return value != null && typeof value == "object";
      }
      var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
      function isMatch(object4, source) {
        return object4 === source || baseIsMatch(object4, source, getMatchData(source));
      }
      function isMatchWith(object4, source, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return baseIsMatch(object4, source, getMatchData(source), customizer);
      }
      function isNaN2(value) {
        return isNumber2(value) && value != +value;
      }
      function isNative(value) {
        if (isMaskable(value)) {
          throw new Error2(CORE_ERROR_TEXT);
        }
        return baseIsNative(value);
      }
      function isNull(value) {
        return value === null;
      }
      function isNil(value) {
        return value == null;
      }
      function isNumber2(value) {
        return typeof value == "number" || isObjectLike2(value) && baseGetTag2(value) == numberTag;
      }
      function isPlainObject(value) {
        if (!isObjectLike2(value) || baseGetTag2(value) != objectTag) {
          return false;
        }
        var proto2 = getPrototype(value);
        if (proto2 === null) {
          return true;
        }
        var Ctor = hasOwnProperty2.call(proto2, "constructor") && proto2.constructor;
        return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
      }
      var isRegExp2 = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
      function isSafeInteger(value) {
        return isInteger(value) && value >= -MAX_SAFE_INTEGER2 && value <= MAX_SAFE_INTEGER2;
      }
      var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
      function isString2(value) {
        return typeof value == "string" || !isArray2(value) && isObjectLike2(value) && baseGetTag2(value) == stringTag;
      }
      function isSymbol2(value) {
        return typeof value == "symbol" || isObjectLike2(value) && baseGetTag2(value) == symbolTag2;
      }
      var isTypedArray2 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
      function isUndefined(value) {
        return value === undefined$1;
      }
      function isWeakMap(value) {
        return isObjectLike2(value) && getTag(value) == weakMapTag;
      }
      function isWeakSet(value) {
        return isObjectLike2(value) && baseGetTag2(value) == weakSetTag;
      }
      var lt2 = createRelationalOperation(baseLt);
      var lte = createRelationalOperation(function(value, other) {
        return value <= other;
      });
      function toArray2(value) {
        if (!value) {
          return [];
        }
        if (isArrayLike2(value)) {
          return isString2(value) ? stringToArray(value) : copyArray(value);
        }
        if (symIterator && value[symIterator]) {
          return iteratorToArray(value[symIterator]());
        }
        var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
        return func(value);
      }
      function toFinite(value) {
        if (!value) {
          return value === 0 ? value : 0;
        }
        value = toNumber2(value);
        if (value === INFINITY || value === -INFINITY) {
          var sign = value < 0 ? -1 : 1;
          return sign * MAX_INTEGER;
        }
        return value === value ? value : 0;
      }
      function toInteger(value) {
        var result2 = toFinite(value), remainder = result2 % 1;
        return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
      }
      function toLength(value) {
        return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
      }
      function toNumber2(value) {
        if (typeof value == "number") {
          return value;
        }
        if (isSymbol2(value)) {
          return NAN2;
        }
        if (isObject2(value)) {
          var other = typeof value.valueOf == "function" ? value.valueOf() : value;
          value = isObject2(other) ? other + "" : other;
        }
        if (typeof value != "string") {
          return value === 0 ? value : +value;
        }
        value = baseTrim2(value);
        var isBinary = reIsBinary2.test(value);
        return isBinary || reIsOctal2.test(value) ? freeParseInt2(value.slice(2), isBinary ? 2 : 8) : reIsBadHex2.test(value) ? NAN2 : +value;
      }
      function toPlainObject(value) {
        return copyObject(value, keysIn(value));
      }
      function toSafeInteger(value) {
        return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER2, MAX_SAFE_INTEGER2) : value === 0 ? value : 0;
      }
      function toString(value) {
        return value == null ? "" : baseToString(value);
      }
      var assign = createAssigner(function(object4, source) {
        if (isPrototype(source) || isArrayLike2(source)) {
          copyObject(source, keys2(source), object4);
          return;
        }
        for (var key in source) {
          if (hasOwnProperty2.call(source, key)) {
            assignValue(object4, key, source[key]);
          }
        }
      });
      var assignIn = createAssigner(function(object4, source) {
        copyObject(source, keysIn(source), object4);
      });
      var assignInWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keysIn(source), object4, customizer);
      });
      var assignWith = createAssigner(function(object4, source, srcIndex, customizer) {
        copyObject(source, keys2(source), object4, customizer);
      });
      var at = flatRest(baseAt);
      function create2(prototype, properties) {
        var result2 = baseCreate(prototype);
        return properties == null ? result2 : baseAssign(result2, properties);
      }
      var defaults2 = baseRest(function(object4, sources) {
        object4 = Object2(object4);
        var index2 = -1;
        var length = sources.length;
        var guard = length > 2 ? sources[2] : undefined$1;
        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          length = 1;
        }
        while (++index2 < length) {
          var source = sources[index2];
          var props = keysIn(source);
          var propsIndex = -1;
          var propsLength = props.length;
          while (++propsIndex < propsLength) {
            var key = props[propsIndex];
            var value = object4[key];
            if (value === undefined$1 || eq(value, objectProto2[key]) && !hasOwnProperty2.call(object4, key)) {
              object4[key] = source[key];
            }
          }
        }
        return object4;
      });
      var defaultsDeep = baseRest(function(args) {
        args.push(undefined$1, customDefaultsMerge);
        return apply(mergeWith, undefined$1, args);
      });
      function findKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwn);
      }
      function findLastKey(object4, predicate) {
        return baseFindKey(object4, getIteratee(predicate, 3), baseForOwnRight);
      }
      function forIn(object4, iteratee2) {
        return object4 == null ? object4 : baseFor(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forInRight(object4, iteratee2) {
        return object4 == null ? object4 : baseForRight(object4, getIteratee(iteratee2, 3), keysIn);
      }
      function forOwn(object4, iteratee2) {
        return object4 && baseForOwn(object4, getIteratee(iteratee2, 3));
      }
      function forOwnRight(object4, iteratee2) {
        return object4 && baseForOwnRight(object4, getIteratee(iteratee2, 3));
      }
      function functions(object4) {
        return object4 == null ? [] : baseFunctions(object4, keys2(object4));
      }
      function functionsIn(object4) {
        return object4 == null ? [] : baseFunctions(object4, keysIn(object4));
      }
      function get2(object4, path, defaultValue) {
        var result2 = object4 == null ? undefined$1 : baseGet(object4, path);
        return result2 === undefined$1 ? defaultValue : result2;
      }
      function has2(object4, path) {
        return object4 != null && hasPath(object4, path, baseHas);
      }
      function hasIn(object4, path) {
        return object4 != null && hasPath(object4, path, baseHasIn);
      }
      var invert2 = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        result2[value] = key;
      }, constant(identity2));
      var invertBy = createInverter(function(result2, value, key) {
        if (value != null && typeof value.toString != "function") {
          value = nativeObjectToString2.call(value);
        }
        if (hasOwnProperty2.call(result2, value)) {
          result2[value].push(key);
        } else {
          result2[value] = [key];
        }
      }, getIteratee);
      var invoke = baseRest(baseInvoke);
      function keys2(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys(object4) : baseKeys(object4);
      }
      function keysIn(object4) {
        return isArrayLike2(object4) ? arrayLikeKeys(object4, true) : baseKeysIn(object4);
      }
      function mapKeys(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, iteratee2(value, key, object5), value);
        });
        return result2;
      }
      function mapValues(object4, iteratee2) {
        var result2 = {};
        iteratee2 = getIteratee(iteratee2, 3);
        baseForOwn(object4, function(value, key, object5) {
          baseAssignValue(result2, key, iteratee2(value, key, object5));
        });
        return result2;
      }
      var merge2 = createAssigner(function(object4, source, srcIndex) {
        baseMerge(object4, source, srcIndex);
      });
      var mergeWith = createAssigner(function(object4, source, srcIndex, customizer) {
        baseMerge(object4, source, srcIndex, customizer);
      });
      var omit = flatRest(function(object4, paths) {
        var result2 = {};
        if (object4 == null) {
          return result2;
        }
        var isDeep = false;
        paths = arrayMap(paths, function(path) {
          path = castPath(path, object4);
          isDeep || (isDeep = path.length > 1);
          return path;
        });
        copyObject(object4, getAllKeysIn(object4), result2);
        if (isDeep) {
          result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
        }
        var length = paths.length;
        while (length--) {
          baseUnset(result2, paths[length]);
        }
        return result2;
      });
      function omitBy(object4, predicate) {
        return pickBy(object4, negate(getIteratee(predicate)));
      }
      var pick = flatRest(function(object4, paths) {
        return object4 == null ? {} : basePick(object4, paths);
      });
      function pickBy(object4, predicate) {
        if (object4 == null) {
          return {};
        }
        var props = arrayMap(getAllKeysIn(object4), function(prop) {
          return [prop];
        });
        predicate = getIteratee(predicate);
        return basePickBy(object4, props, function(value, path) {
          return predicate(value, path[0]);
        });
      }
      function result(object4, path, defaultValue) {
        path = castPath(path, object4);
        var index2 = -1, length = path.length;
        if (!length) {
          length = 1;
          object4 = undefined$1;
        }
        while (++index2 < length) {
          var value = object4 == null ? undefined$1 : object4[toKey(path[index2])];
          if (value === undefined$1) {
            index2 = length;
            value = defaultValue;
          }
          object4 = isFunction2(value) ? value.call(object4) : value;
        }
        return object4;
      }
      function set2(object4, path, value) {
        return object4 == null ? object4 : baseSet(object4, path, value);
      }
      function setWith(object4, path, value, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseSet(object4, path, value, customizer);
      }
      var toPairs = createToPairs(keys2);
      var toPairsIn = createToPairs(keysIn);
      function transform2(object4, iteratee2, accumulator) {
        var isArr = isArray2(object4), isArrLike = isArr || isBuffer(object4) || isTypedArray2(object4);
        iteratee2 = getIteratee(iteratee2, 4);
        if (accumulator == null) {
          var Ctor = object4 && object4.constructor;
          if (isArrLike) {
            accumulator = isArr ? new Ctor() : [];
          } else if (isObject2(object4)) {
            accumulator = isFunction2(Ctor) ? baseCreate(getPrototype(object4)) : {};
          } else {
            accumulator = {};
          }
        }
        (isArrLike ? arrayEach : baseForOwn)(object4, function(value, index2, object5) {
          return iteratee2(accumulator, value, index2, object5);
        });
        return accumulator;
      }
      function unset(object4, path) {
        return object4 == null ? true : baseUnset(object4, path);
      }
      function update(object4, path, updater) {
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater));
      }
      function updateWith(object4, path, updater, customizer) {
        customizer = typeof customizer == "function" ? customizer : undefined$1;
        return object4 == null ? object4 : baseUpdate(object4, path, castFunction(updater), customizer);
      }
      function values(object4) {
        return object4 == null ? [] : baseValues(object4, keys2(object4));
      }
      function valuesIn(object4) {
        return object4 == null ? [] : baseValues(object4, keysIn(object4));
      }
      function clamp2(number4, lower, upper) {
        if (upper === undefined$1) {
          upper = lower;
          lower = undefined$1;
        }
        if (upper !== undefined$1) {
          upper = toNumber2(upper);
          upper = upper === upper ? upper : 0;
        }
        if (lower !== undefined$1) {
          lower = toNumber2(lower);
          lower = lower === lower ? lower : 0;
        }
        return baseClamp(toNumber2(number4), lower, upper);
      }
      function inRange(number4, start2, end2) {
        start2 = toFinite(start2);
        if (end2 === undefined$1) {
          end2 = start2;
          start2 = 0;
        } else {
          end2 = toFinite(end2);
        }
        number4 = toNumber2(number4);
        return baseInRange(number4, start2, end2);
      }
      function random(lower, upper, floating) {
        if (floating && typeof floating != "boolean" && isIterateeCall(lower, upper, floating)) {
          upper = floating = undefined$1;
        }
        if (floating === undefined$1) {
          if (typeof upper == "boolean") {
            floating = upper;
            upper = undefined$1;
          } else if (typeof lower == "boolean") {
            floating = lower;
            lower = undefined$1;
          }
        }
        if (lower === undefined$1 && upper === undefined$1) {
          lower = 0;
          upper = 1;
        } else {
          lower = toFinite(lower);
          if (upper === undefined$1) {
            upper = lower;
            lower = 0;
          } else {
            upper = toFinite(upper);
          }
        }
        if (lower > upper) {
          var temp = lower;
          lower = upper;
          upper = temp;
        }
        if (floating || lower % 1 || upper % 1) {
          var rand = nativeRandom();
          return nativeMin2(lower + rand * (upper - lower + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
        }
        return baseRandom(lower, upper);
      }
      var camelCase = createCompounder(function(result2, word, index2) {
        word = word.toLowerCase();
        return result2 + (index2 ? capitalize(word) : word);
      });
      function capitalize(string3) {
        return upperFirst(toString(string3).toLowerCase());
      }
      function deburr(string3) {
        string3 = toString(string3);
        return string3 && string3.replace(reLatin, deburrLetter).replace(reComboMark, "");
      }
      function endsWith(string3, target, position2) {
        string3 = toString(string3);
        target = baseToString(target);
        var length = string3.length;
        position2 = position2 === undefined$1 ? length : baseClamp(toInteger(position2), 0, length);
        var end2 = position2;
        position2 -= target.length;
        return position2 >= 0 && string3.slice(position2, end2) == target;
      }
      function escape(string3) {
        string3 = toString(string3);
        return string3 && reHasUnescapedHtml.test(string3) ? string3.replace(reUnescapedHtml, escapeHtmlChar) : string3;
      }
      function escapeRegExp(string3) {
        string3 = toString(string3);
        return string3 && reHasRegExpChar.test(string3) ? string3.replace(reRegExpChar, "\\$&") : string3;
      }
      var kebabCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "-" : "") + word.toLowerCase();
      });
      var lowerCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toLowerCase();
      });
      var lowerFirst = createCaseFirst("toLowerCase");
      function pad3(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        if (!length || strLength >= length) {
          return string3;
        }
        var mid = (length - strLength) / 2;
        return createPadding(nativeFloor(mid), chars) + string3 + createPadding(nativeCeil(mid), chars);
      }
      function padEnd(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? string3 + createPadding(length - strLength, chars) : string3;
      }
      function padStart(string3, length, chars) {
        string3 = toString(string3);
        length = toInteger(length);
        var strLength = length ? stringSize(string3) : 0;
        return length && strLength < length ? createPadding(length - strLength, chars) + string3 : string3;
      }
      function parseInt2(string3, radix, guard) {
        if (guard || radix == null) {
          radix = 0;
        } else if (radix) {
          radix = +radix;
        }
        return nativeParseInt(toString(string3).replace(reTrimStart2, ""), radix || 0);
      }
      function repeat(string3, n2, guard) {
        if (guard ? isIterateeCall(string3, n2, guard) : n2 === undefined$1) {
          n2 = 1;
        } else {
          n2 = toInteger(n2);
        }
        return baseRepeat(toString(string3), n2);
      }
      function replace() {
        var args = arguments, string3 = toString(args[0]);
        return args.length < 3 ? string3 : string3.replace(args[1], args[2]);
      }
      var snakeCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? "_" : "") + word.toLowerCase();
      });
      function split2(string3, separator, limit) {
        if (limit && typeof limit != "number" && isIterateeCall(string3, separator, limit)) {
          separator = limit = undefined$1;
        }
        limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
        if (!limit) {
          return [];
        }
        string3 = toString(string3);
        if (string3 && (typeof separator == "string" || separator != null && !isRegExp2(separator))) {
          separator = baseToString(separator);
          if (!separator && hasUnicode(string3)) {
            return castSlice(stringToArray(string3), 0, limit);
          }
        }
        return string3.split(separator, limit);
      }
      var startCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + upperFirst(word);
      });
      function startsWith(string3, target, position2) {
        string3 = toString(string3);
        position2 = position2 == null ? 0 : baseClamp(toInteger(position2), 0, string3.length);
        target = baseToString(target);
        return string3.slice(position2, position2 + target.length) == target;
      }
      function template(string3, options, guard) {
        var settings = lodash2.templateSettings;
        if (guard && isIterateeCall(string3, options, guard)) {
          options = undefined$1;
        }
        string3 = toString(string3);
        options = assignInWith({}, options, settings, customDefaultsAssignIn);
        var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys2(imports), importsValues = baseValues(imports, importsKeys);
        var isEscaping, isEvaluating, index2 = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
        var reDelimiters = RegExp2((options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$", "g");
        var sourceURL = "//# sourceURL=" + (hasOwnProperty2.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
        string3.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
          interpolateValue || (interpolateValue = esTemplateValue);
          source += string3.slice(index2, offset).replace(reUnescapedString, escapeStringChar);
          if (escapeValue) {
            isEscaping = true;
            source += "' +\n__e(" + escapeValue + ") +\n'";
          }
          if (evaluateValue) {
            isEvaluating = true;
            source += "';\n" + evaluateValue + ";\n__p += '";
          }
          if (interpolateValue) {
            source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
          }
          index2 = offset + match.length;
          return match;
        });
        source += "';\n";
        var variable = hasOwnProperty2.call(options, "variable") && options.variable;
        if (!variable) {
          source = "with (obj) {\n" + source + "\n}\n";
        } else if (reForbiddenIdentifierChars.test(variable)) {
          throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
        }
        source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
        source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
        var result2 = attempt(function() {
          return Function2(importsKeys, sourceURL + "return " + source).apply(undefined$1, importsValues);
        });
        result2.source = source;
        if (isError(result2)) {
          throw result2;
        }
        return result2;
      }
      function toLower(value) {
        return toString(value).toLowerCase();
      }
      function toUpper(value) {
        return toString(value).toUpperCase();
      }
      function trim2(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return baseTrim2(string3);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), chrSymbols = stringToArray(chars), start2 = charsStartIndex(strSymbols, chrSymbols), end2 = charsEndIndex(strSymbols, chrSymbols) + 1;
        return castSlice(strSymbols, start2, end2).join("");
      }
      function trimEnd(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.slice(0, trimmedEndIndex2(string3) + 1);
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), end2 = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
        return castSlice(strSymbols, 0, end2).join("");
      }
      function trimStart(string3, chars, guard) {
        string3 = toString(string3);
        if (string3 && (guard || chars === undefined$1)) {
          return string3.replace(reTrimStart2, "");
        }
        if (!string3 || !(chars = baseToString(chars))) {
          return string3;
        }
        var strSymbols = stringToArray(string3), start2 = charsStartIndex(strSymbols, stringToArray(chars));
        return castSlice(strSymbols, start2).join("");
      }
      function truncate(string3, options) {
        var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
        if (isObject2(options)) {
          var separator = "separator" in options ? options.separator : separator;
          length = "length" in options ? toInteger(options.length) : length;
          omission = "omission" in options ? baseToString(options.omission) : omission;
        }
        string3 = toString(string3);
        var strLength = string3.length;
        if (hasUnicode(string3)) {
          var strSymbols = stringToArray(string3);
          strLength = strSymbols.length;
        }
        if (length >= strLength) {
          return string3;
        }
        var end2 = length - stringSize(omission);
        if (end2 < 1) {
          return omission;
        }
        var result2 = strSymbols ? castSlice(strSymbols, 0, end2).join("") : string3.slice(0, end2);
        if (separator === undefined$1) {
          return result2 + omission;
        }
        if (strSymbols) {
          end2 += result2.length - end2;
        }
        if (isRegExp2(separator)) {
          if (string3.slice(end2).search(separator)) {
            var match, substring = result2;
            if (!separator.global) {
              separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
            }
            separator.lastIndex = 0;
            while (match = separator.exec(substring)) {
              var newEnd = match.index;
            }
            result2 = result2.slice(0, newEnd === undefined$1 ? end2 : newEnd);
          }
        } else if (string3.indexOf(baseToString(separator), end2) != end2) {
          var index2 = result2.lastIndexOf(separator);
          if (index2 > -1) {
            result2 = result2.slice(0, index2);
          }
        }
        return result2 + omission;
      }
      function unescape2(string3) {
        string3 = toString(string3);
        return string3 && reHasEscapedHtml.test(string3) ? string3.replace(reEscapedHtml, unescapeHtmlChar) : string3;
      }
      var upperCase = createCompounder(function(result2, word, index2) {
        return result2 + (index2 ? " " : "") + word.toUpperCase();
      });
      var upperFirst = createCaseFirst("toUpperCase");
      function words(string3, pattern4, guard) {
        string3 = toString(string3);
        pattern4 = guard ? undefined$1 : pattern4;
        if (pattern4 === undefined$1) {
          return hasUnicodeWord(string3) ? unicodeWords(string3) : asciiWords(string3);
        }
        return string3.match(pattern4) || [];
      }
      var attempt = baseRest(function(func, args) {
        try {
          return apply(func, undefined$1, args);
        } catch (e2) {
          return isError(e2) ? e2 : new Error2(e2);
        }
      });
      var bindAll = flatRest(function(object4, methodNames) {
        arrayEach(methodNames, function(key) {
          key = toKey(key);
          baseAssignValue(object4, key, bind2(object4[key], object4));
        });
        return object4;
      });
      function cond(pairs) {
        var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
        pairs = !length ? [] : arrayMap(pairs, function(pair) {
          if (typeof pair[1] != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT2);
          }
          return [toIteratee(pair[0]), pair[1]];
        });
        return baseRest(function(args) {
          var index2 = -1;
          while (++index2 < length) {
            var pair = pairs[index2];
            if (apply(pair[0], this, args)) {
              return apply(pair[1], this, args);
            }
          }
        });
      }
      function conforms(source) {
        return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
      }
      function constant(value) {
        return function() {
          return value;
        };
      }
      function defaultTo(value, defaultValue) {
        return value == null || value !== value ? defaultValue : value;
      }
      var flow = createFlow();
      var flowRight = createFlow(true);
      function identity2(value) {
        return value;
      }
      function iteratee(func) {
        return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
      }
      function matches(source) {
        return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
      }
      function matchesProperty(path, srcValue) {
        return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
      }
      var method4 = baseRest(function(path, args) {
        return function(object4) {
          return baseInvoke(object4, path, args);
        };
      });
      var methodOf = baseRest(function(object4, args) {
        return function(path) {
          return baseInvoke(object4, path, args);
        };
      });
      function mixin2(object4, source, options) {
        var props = keys2(source), methodNames = baseFunctions(source, props);
        if (options == null && !(isObject2(source) && (methodNames.length || !props.length))) {
          options = source;
          source = object4;
          object4 = this;
          methodNames = baseFunctions(source, keys2(source));
        }
        var chain2 = !(isObject2(options) && "chain" in options) || !!options.chain, isFunc = isFunction2(object4);
        arrayEach(methodNames, function(methodName) {
          var func = source[methodName];
          object4[methodName] = func;
          if (isFunc) {
            object4.prototype[methodName] = function() {
              var chainAll = this.__chain__;
              if (chain2 || chainAll) {
                var result2 = object4(this.__wrapped__), actions2 = result2.__actions__ = copyArray(this.__actions__);
                actions2.push({ "func": func, "args": arguments, "thisArg": object4 });
                result2.__chain__ = chainAll;
                return result2;
              }
              return func.apply(object4, arrayPush([this.value()], arguments));
            };
          }
        });
        return object4;
      }
      function noConflict() {
        if (root2._ === this) {
          root2._ = oldDash;
        }
        return this;
      }
      function noop2() {
      }
      function nthArg(n2) {
        n2 = toInteger(n2);
        return baseRest(function(args) {
          return baseNth(args, n2);
        });
      }
      var over = createOver(arrayMap);
      var overEvery = createOver(arrayEvery);
      var overSome = createOver(arraySome);
      function property(path) {
        return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
      }
      function propertyOf(object4) {
        return function(path) {
          return object4 == null ? undefined$1 : baseGet(object4, path);
        };
      }
      var range3 = createRange();
      var rangeRight = createRange(true);
      function stubArray() {
        return [];
      }
      function stubFalse() {
        return false;
      }
      function stubObject() {
        return {};
      }
      function stubString() {
        return "";
      }
      function stubTrue() {
        return true;
      }
      function times(n2, iteratee2) {
        n2 = toInteger(n2);
        if (n2 < 1 || n2 > MAX_SAFE_INTEGER2) {
          return [];
        }
        var index2 = MAX_ARRAY_LENGTH, length = nativeMin2(n2, MAX_ARRAY_LENGTH);
        iteratee2 = getIteratee(iteratee2);
        n2 -= MAX_ARRAY_LENGTH;
        var result2 = baseTimes(length, iteratee2);
        while (++index2 < n2) {
          iteratee2(index2);
        }
        return result2;
      }
      function toPath(value) {
        if (isArray2(value)) {
          return arrayMap(value, toKey);
        }
        return isSymbol2(value) ? [value] : copyArray(stringToPath(toString(value)));
      }
      function uniqueId(prefix) {
        var id2 = ++idCounter;
        return toString(prefix) + id2;
      }
      var add2 = createMathOperation(function(augend, addend) {
        return augend + addend;
      }, 0);
      var ceil = createRound("ceil");
      var divide = createMathOperation(function(dividend, divisor) {
        return dividend / divisor;
      }, 1);
      var floor = createRound("floor");
      function max3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseGt) : undefined$1;
      }
      function maxBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseGt) : undefined$1;
      }
      function mean(array4) {
        return baseMean(array4, identity2);
      }
      function meanBy(array4, iteratee2) {
        return baseMean(array4, getIteratee(iteratee2, 2));
      }
      function min3(array4) {
        return array4 && array4.length ? baseExtremum(array4, identity2, baseLt) : undefined$1;
      }
      function minBy(array4, iteratee2) {
        return array4 && array4.length ? baseExtremum(array4, getIteratee(iteratee2, 2), baseLt) : undefined$1;
      }
      var multiply = createMathOperation(function(multiplier, multiplicand) {
        return multiplier * multiplicand;
      }, 1);
      var round2 = createRound("round");
      var subtract = createMathOperation(function(minuend, subtrahend) {
        return minuend - subtrahend;
      }, 0);
      function sum2(array4) {
        return array4 && array4.length ? baseSum(array4, identity2) : 0;
      }
      function sumBy(array4, iteratee2) {
        return array4 && array4.length ? baseSum(array4, getIteratee(iteratee2, 2)) : 0;
      }
      lodash2.after = after;
      lodash2.ary = ary;
      lodash2.assign = assign;
      lodash2.assignIn = assignIn;
      lodash2.assignInWith = assignInWith;
      lodash2.assignWith = assignWith;
      lodash2.at = at;
      lodash2.before = before;
      lodash2.bind = bind2;
      lodash2.bindAll = bindAll;
      lodash2.bindKey = bindKey;
      lodash2.castArray = castArray;
      lodash2.chain = chain;
      lodash2.chunk = chunk;
      lodash2.compact = compact;
      lodash2.concat = concat;
      lodash2.cond = cond;
      lodash2.conforms = conforms;
      lodash2.constant = constant;
      lodash2.countBy = countBy;
      lodash2.create = create2;
      lodash2.curry = curry2;
      lodash2.curryRight = curryRight;
      lodash2.debounce = debounce2;
      lodash2.defaults = defaults2;
      lodash2.defaultsDeep = defaultsDeep;
      lodash2.defer = defer;
      lodash2.delay = delay;
      lodash2.difference = difference;
      lodash2.differenceBy = differenceBy;
      lodash2.differenceWith = differenceWith;
      lodash2.drop = drop;
      lodash2.dropRight = dropRight;
      lodash2.dropRightWhile = dropRightWhile;
      lodash2.dropWhile = dropWhile;
      lodash2.fill = fill;
      lodash2.filter = filter2;
      lodash2.flatMap = flatMap;
      lodash2.flatMapDeep = flatMapDeep;
      lodash2.flatMapDepth = flatMapDepth;
      lodash2.flatten = flatten;
      lodash2.flattenDeep = flattenDeep;
      lodash2.flattenDepth = flattenDepth;
      lodash2.flip = flip;
      lodash2.flow = flow;
      lodash2.flowRight = flowRight;
      lodash2.fromPairs = fromPairs;
      lodash2.functions = functions;
      lodash2.functionsIn = functionsIn;
      lodash2.groupBy = groupBy;
      lodash2.initial = initial;
      lodash2.intersection = intersection;
      lodash2.intersectionBy = intersectionBy;
      lodash2.intersectionWith = intersectionWith;
      lodash2.invert = invert2;
      lodash2.invertBy = invertBy;
      lodash2.invokeMap = invokeMap;
      lodash2.iteratee = iteratee;
      lodash2.keyBy = keyBy;
      lodash2.keys = keys2;
      lodash2.keysIn = keysIn;
      lodash2.map = map2;
      lodash2.mapKeys = mapKeys;
      lodash2.mapValues = mapValues;
      lodash2.matches = matches;
      lodash2.matchesProperty = matchesProperty;
      lodash2.memoize = memoize;
      lodash2.merge = merge2;
      lodash2.mergeWith = mergeWith;
      lodash2.method = method4;
      lodash2.methodOf = methodOf;
      lodash2.mixin = mixin2;
      lodash2.negate = negate;
      lodash2.nthArg = nthArg;
      lodash2.omit = omit;
      lodash2.omitBy = omitBy;
      lodash2.once = once;
      lodash2.orderBy = orderBy;
      lodash2.over = over;
      lodash2.overArgs = overArgs;
      lodash2.overEvery = overEvery;
      lodash2.overSome = overSome;
      lodash2.partial = partial;
      lodash2.partialRight = partialRight;
      lodash2.partition = partition;
      lodash2.pick = pick;
      lodash2.pickBy = pickBy;
      lodash2.property = property;
      lodash2.propertyOf = propertyOf;
      lodash2.pull = pull;
      lodash2.pullAll = pullAll;
      lodash2.pullAllBy = pullAllBy;
      lodash2.pullAllWith = pullAllWith;
      lodash2.pullAt = pullAt;
      lodash2.range = range3;
      lodash2.rangeRight = rangeRight;
      lodash2.rearg = rearg;
      lodash2.reject = reject;
      lodash2.remove = remove;
      lodash2.rest = rest;
      lodash2.reverse = reverse2;
      lodash2.sampleSize = sampleSize;
      lodash2.set = set2;
      lodash2.setWith = setWith;
      lodash2.shuffle = shuffle;
      lodash2.slice = slice2;
      lodash2.sortBy = sortBy;
      lodash2.sortedUniq = sortedUniq;
      lodash2.sortedUniqBy = sortedUniqBy;
      lodash2.split = split2;
      lodash2.spread = spread;
      lodash2.tail = tail;
      lodash2.take = take2;
      lodash2.takeRight = takeRight;
      lodash2.takeRightWhile = takeRightWhile;
      lodash2.takeWhile = takeWhile;
      lodash2.tap = tap;
      lodash2.throttle = throttle2;
      lodash2.thru = thru;
      lodash2.toArray = toArray2;
      lodash2.toPairs = toPairs;
      lodash2.toPairsIn = toPairsIn;
      lodash2.toPath = toPath;
      lodash2.toPlainObject = toPlainObject;
      lodash2.transform = transform2;
      lodash2.unary = unary;
      lodash2.union = union;
      lodash2.unionBy = unionBy;
      lodash2.unionWith = unionWith;
      lodash2.uniq = uniq;
      lodash2.uniqBy = uniqBy;
      lodash2.uniqWith = uniqWith;
      lodash2.unset = unset;
      lodash2.unzip = unzip;
      lodash2.unzipWith = unzipWith;
      lodash2.update = update;
      lodash2.updateWith = updateWith;
      lodash2.values = values;
      lodash2.valuesIn = valuesIn;
      lodash2.without = without;
      lodash2.words = words;
      lodash2.wrap = wrap;
      lodash2.xor = xor;
      lodash2.xorBy = xorBy;
      lodash2.xorWith = xorWith;
      lodash2.zip = zip;
      lodash2.zipObject = zipObject;
      lodash2.zipObjectDeep = zipObjectDeep;
      lodash2.zipWith = zipWith;
      lodash2.entries = toPairs;
      lodash2.entriesIn = toPairsIn;
      lodash2.extend = assignIn;
      lodash2.extendWith = assignInWith;
      mixin2(lodash2, lodash2);
      lodash2.add = add2;
      lodash2.attempt = attempt;
      lodash2.camelCase = camelCase;
      lodash2.capitalize = capitalize;
      lodash2.ceil = ceil;
      lodash2.clamp = clamp2;
      lodash2.clone = clone2;
      lodash2.cloneDeep = cloneDeep;
      lodash2.cloneDeepWith = cloneDeepWith;
      lodash2.cloneWith = cloneWith;
      lodash2.conformsTo = conformsTo;
      lodash2.deburr = deburr;
      lodash2.defaultTo = defaultTo;
      lodash2.divide = divide;
      lodash2.endsWith = endsWith;
      lodash2.eq = eq;
      lodash2.escape = escape;
      lodash2.escapeRegExp = escapeRegExp;
      lodash2.every = every;
      lodash2.find = find2;
      lodash2.findIndex = findIndex;
      lodash2.findKey = findKey;
      lodash2.findLast = findLast;
      lodash2.findLastIndex = findLastIndex;
      lodash2.findLastKey = findLastKey;
      lodash2.floor = floor;
      lodash2.forEach = forEach;
      lodash2.forEachRight = forEachRight;
      lodash2.forIn = forIn;
      lodash2.forInRight = forInRight;
      lodash2.forOwn = forOwn;
      lodash2.forOwnRight = forOwnRight;
      lodash2.get = get2;
      lodash2.gt = gt;
      lodash2.gte = gte;
      lodash2.has = has2;
      lodash2.hasIn = hasIn;
      lodash2.head = head;
      lodash2.identity = identity2;
      lodash2.includes = includes;
      lodash2.indexOf = indexOf2;
      lodash2.inRange = inRange;
      lodash2.invoke = invoke;
      lodash2.isArguments = isArguments;
      lodash2.isArray = isArray2;
      lodash2.isArrayBuffer = isArrayBuffer;
      lodash2.isArrayLike = isArrayLike2;
      lodash2.isArrayLikeObject = isArrayLikeObject;
      lodash2.isBoolean = isBoolean;
      lodash2.isBuffer = isBuffer;
      lodash2.isDate = isDate;
      lodash2.isElement = isElement;
      lodash2.isEmpty = isEmpty;
      lodash2.isEqual = isEqual;
      lodash2.isEqualWith = isEqualWith;
      lodash2.isError = isError;
      lodash2.isFinite = isFinite2;
      lodash2.isFunction = isFunction2;
      lodash2.isInteger = isInteger;
      lodash2.isLength = isLength;
      lodash2.isMap = isMap;
      lodash2.isMatch = isMatch;
      lodash2.isMatchWith = isMatchWith;
      lodash2.isNaN = isNaN2;
      lodash2.isNative = isNative;
      lodash2.isNil = isNil;
      lodash2.isNull = isNull;
      lodash2.isNumber = isNumber2;
      lodash2.isObject = isObject2;
      lodash2.isObjectLike = isObjectLike2;
      lodash2.isPlainObject = isPlainObject;
      lodash2.isRegExp = isRegExp2;
      lodash2.isSafeInteger = isSafeInteger;
      lodash2.isSet = isSet;
      lodash2.isString = isString2;
      lodash2.isSymbol = isSymbol2;
      lodash2.isTypedArray = isTypedArray2;
      lodash2.isUndefined = isUndefined;
      lodash2.isWeakMap = isWeakMap;
      lodash2.isWeakSet = isWeakSet;
      lodash2.join = join;
      lodash2.kebabCase = kebabCase;
      lodash2.last = last;
      lodash2.lastIndexOf = lastIndexOf;
      lodash2.lowerCase = lowerCase;
      lodash2.lowerFirst = lowerFirst;
      lodash2.lt = lt2;
      lodash2.lte = lte;
      lodash2.max = max3;
      lodash2.maxBy = maxBy;
      lodash2.mean = mean;
      lodash2.meanBy = meanBy;
      lodash2.min = min3;
      lodash2.minBy = minBy;
      lodash2.stubArray = stubArray;
      lodash2.stubFalse = stubFalse;
      lodash2.stubObject = stubObject;
      lodash2.stubString = stubString;
      lodash2.stubTrue = stubTrue;
      lodash2.multiply = multiply;
      lodash2.nth = nth;
      lodash2.noConflict = noConflict;
      lodash2.noop = noop2;
      lodash2.now = now2;
      lodash2.pad = pad3;
      lodash2.padEnd = padEnd;
      lodash2.padStart = padStart;
      lodash2.parseInt = parseInt2;
      lodash2.random = random;
      lodash2.reduce = reduce2;
      lodash2.reduceRight = reduceRight;
      lodash2.repeat = repeat;
      lodash2.replace = replace;
      lodash2.result = result;
      lodash2.round = round2;
      lodash2.runInContext = runInContext2;
      lodash2.sample = sample;
      lodash2.size = size;
      lodash2.snakeCase = snakeCase;
      lodash2.some = some;
      lodash2.sortedIndex = sortedIndex;
      lodash2.sortedIndexBy = sortedIndexBy;
      lodash2.sortedIndexOf = sortedIndexOf;
      lodash2.sortedLastIndex = sortedLastIndex;
      lodash2.sortedLastIndexBy = sortedLastIndexBy;
      lodash2.sortedLastIndexOf = sortedLastIndexOf;
      lodash2.startCase = startCase;
      lodash2.startsWith = startsWith;
      lodash2.subtract = subtract;
      lodash2.sum = sum2;
      lodash2.sumBy = sumBy;
      lodash2.template = template;
      lodash2.times = times;
      lodash2.toFinite = toFinite;
      lodash2.toInteger = toInteger;
      lodash2.toLength = toLength;
      lodash2.toLower = toLower;
      lodash2.toNumber = toNumber2;
      lodash2.toSafeInteger = toSafeInteger;
      lodash2.toString = toString;
      lodash2.toUpper = toUpper;
      lodash2.trim = trim2;
      lodash2.trimEnd = trimEnd;
      lodash2.trimStart = trimStart;
      lodash2.truncate = truncate;
      lodash2.unescape = unescape2;
      lodash2.uniqueId = uniqueId;
      lodash2.upperCase = upperCase;
      lodash2.upperFirst = upperFirst;
      lodash2.each = forEach;
      lodash2.eachRight = forEachRight;
      lodash2.first = head;
      mixin2(lodash2, function() {
        var source = {};
        baseForOwn(lodash2, function(func, methodName) {
          if (!hasOwnProperty2.call(lodash2.prototype, methodName)) {
            source[methodName] = func;
          }
        });
        return source;
      }(), { "chain": false });
      lodash2.VERSION = VERSION;
      arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
        lodash2[methodName].placeholder = lodash2;
      });
      arrayEach(["drop", "take"], function(methodName, index2) {
        LazyWrapper.prototype[methodName] = function(n2) {
          n2 = n2 === undefined$1 ? 1 : nativeMax2(toInteger(n2), 0);
          var result2 = this.__filtered__ && !index2 ? new LazyWrapper(this) : this.clone();
          if (result2.__filtered__) {
            result2.__takeCount__ = nativeMin2(n2, result2.__takeCount__);
          } else {
            result2.__views__.push({
              "size": nativeMin2(n2, MAX_ARRAY_LENGTH),
              "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
            });
          }
          return result2;
        };
        LazyWrapper.prototype[methodName + "Right"] = function(n2) {
          return this.reverse()[methodName](n2).reverse();
        };
      });
      arrayEach(["filter", "map", "takeWhile"], function(methodName, index2) {
        var type4 = index2 + 1, isFilter = type4 == LAZY_FILTER_FLAG || type4 == LAZY_WHILE_FLAG;
        LazyWrapper.prototype[methodName] = function(iteratee2) {
          var result2 = this.clone();
          result2.__iteratees__.push({
            "iteratee": getIteratee(iteratee2, 3),
            "type": type4
          });
          result2.__filtered__ = result2.__filtered__ || isFilter;
          return result2;
        };
      });
      arrayEach(["head", "last"], function(methodName, index2) {
        var takeName = "take" + (index2 ? "Right" : "");
        LazyWrapper.prototype[methodName] = function() {
          return this[takeName](1).value()[0];
        };
      });
      arrayEach(["initial", "tail"], function(methodName, index2) {
        var dropName = "drop" + (index2 ? "" : "Right");
        LazyWrapper.prototype[methodName] = function() {
          return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
        };
      });
      LazyWrapper.prototype.compact = function() {
        return this.filter(identity2);
      };
      LazyWrapper.prototype.find = function(predicate) {
        return this.filter(predicate).head();
      };
      LazyWrapper.prototype.findLast = function(predicate) {
        return this.reverse().find(predicate);
      };
      LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
        if (typeof path == "function") {
          return new LazyWrapper(this);
        }
        return this.map(function(value) {
          return baseInvoke(value, path, args);
        });
      });
      LazyWrapper.prototype.reject = function(predicate) {
        return this.filter(negate(getIteratee(predicate)));
      };
      LazyWrapper.prototype.slice = function(start2, end2) {
        start2 = toInteger(start2);
        var result2 = this;
        if (result2.__filtered__ && (start2 > 0 || end2 < 0)) {
          return new LazyWrapper(result2);
        }
        if (start2 < 0) {
          result2 = result2.takeRight(-start2);
        } else if (start2) {
          result2 = result2.drop(start2);
        }
        if (end2 !== undefined$1) {
          end2 = toInteger(end2);
          result2 = end2 < 0 ? result2.dropRight(-end2) : result2.take(end2 - start2);
        }
        return result2;
      };
      LazyWrapper.prototype.takeRightWhile = function(predicate) {
        return this.reverse().takeWhile(predicate).reverse();
      };
      LazyWrapper.prototype.toArray = function() {
        return this.take(MAX_ARRAY_LENGTH);
      };
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash2[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
        if (!lodashFunc) {
          return;
        }
        lodash2.prototype[methodName] = function() {
          var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray2(value);
          var interceptor = function(value2) {
            var result3 = lodashFunc.apply(lodash2, arrayPush([value2], args));
            return isTaker && chainAll ? result3[0] : result3;
          };
          if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
            isLazy = useLazy = false;
          }
          var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
          if (!retUnwrapped && useLazy) {
            value = onlyLazy ? value : new LazyWrapper(this);
            var result2 = func.apply(value, args);
            result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined$1 });
            return new LodashWrapper(result2, chainAll);
          }
          if (isUnwrapped && onlyLazy) {
            return func.apply(this, args);
          }
          result2 = this.thru(interceptor);
          return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
        };
      });
      arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
        var func = arrayProto2[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
        lodash2.prototype[methodName] = function() {
          var args = arguments;
          if (retUnwrapped && !this.__chain__) {
            var value = this.value();
            return func.apply(isArray2(value) ? value : [], args);
          }
          return this[chainName](function(value2) {
            return func.apply(isArray2(value2) ? value2 : [], args);
          });
        };
      });
      baseForOwn(LazyWrapper.prototype, function(func, methodName) {
        var lodashFunc = lodash2[methodName];
        if (lodashFunc) {
          var key = lodashFunc.name + "";
          if (!hasOwnProperty2.call(realNames, key)) {
            realNames[key] = [];
          }
          realNames[key].push({ "name": methodName, "func": lodashFunc });
        }
      });
      realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
        "name": "wrapper",
        "func": undefined$1
      }];
      LazyWrapper.prototype.clone = lazyClone;
      LazyWrapper.prototype.reverse = lazyReverse;
      LazyWrapper.prototype.value = lazyValue;
      lodash2.prototype.at = wrapperAt;
      lodash2.prototype.chain = wrapperChain;
      lodash2.prototype.commit = wrapperCommit;
      lodash2.prototype.next = wrapperNext;
      lodash2.prototype.plant = wrapperPlant;
      lodash2.prototype.reverse = wrapperReverse;
      lodash2.prototype.toJSON = lodash2.prototype.valueOf = lodash2.prototype.value = wrapperValue;
      lodash2.prototype.first = lodash2.prototype.head;
      if (symIterator) {
        lodash2.prototype[symIterator] = wrapperToIterator;
      }
      return lodash2;
    };
    var _ = runInContext();
    if (freeModule) {
      (freeModule.exports = _)._ = _;
      freeExports._ = _;
    } else {
      root2._ = _;
    }
  }).call(commonjsGlobal);
})(lodash, lodash.exports);
class EventEmitter {
  constructor() {
    __publicField(this, "subscriptions", /* @__PURE__ */ new Map());
    __publicField(this, "emitEffectCache", /* @__PURE__ */ new Map());
    __publicField(this, "useSubscription", (event, listener) => {
      const callbackRef = useRef();
      useEffect(() => {
        var _a2, _b2;
        callbackRef.current = listener;
        function subscription(val) {
          if (callbackRef.current) {
            callbackRef.current(val);
          }
        }
        const subscriptions = (_b2 = (_a2 = this.subscriptions) == null ? void 0 : _a2.get(event)) != null ? _b2 : [];
        subscriptions.push(subscription);
        this.subscriptions.set(event, subscriptions);
        this.emitEffect(event);
        return () => {
          this.subscriptions.delete(event);
        };
      }, []);
    });
    __publicField(this, "emit", (event, ...args) => {
      if (typeof event === "string" || typeof event === "number") {
        const subscriptionValuesCallback = this.subscriptions.get(event);
        subscriptionValuesCallback == null ? void 0 : subscriptionValuesCallback.forEach((callback) => {
          callback == null ? void 0 : callback({
            params: lodash.exports.cloneDeep(args),
            event
          });
        });
        this.emitEffectCache.set(event, {
          params: lodash.exports.cloneDeep(args),
          event
        });
      } else
        throw new TypeError("event must be string or number !");
    });
    __publicField(this, "emitEffect", (event) => {
      const emitEffectCache = this.emitEffectCache.get(event);
      const listeners = this.subscriptions.get(event);
      if (emitEffectCache)
        listeners == null ? void 0 : listeners.forEach((listener) => {
          listener == null ? void 0 : listener(__spreadValues({}, emitEffectCache));
        });
    });
    __publicField(this, "removeListener", (event) => {
      this.subscriptions.delete(event);
    });
    __publicField(this, "clear", () => {
      this.subscriptions.clear();
    });
    this.clear();
  }
}
const eventEmitterOverall = new EventEmitter();
function useEventEmitter(options) {
  const ref = useRef();
  const eventEmitterOptions = useMemo(() => options != null ? options : { global: false }, [options]);
  if (!ref.current) {
    ref.current = eventEmitterOptions.global ? ref.current = eventEmitterOverall : ref.current = new EventEmitter();
  }
  useEffect(() => {
    return () => {
      var _a2;
      return (_a2 = ref.current) == null ? void 0 : _a2.clear();
    };
  }, []);
  return ref.current;
}
const useEchartsTool = ({
  id: id2,
  title,
  chart,
  option
}, deps) => {
  const ref = useRef(_Charts);
  const event = useEventEmitter({ global: true });
  useDebounceEffect(() => {
    if (ref.current && (chart == null ? void 0 : chart.current) && id2 && option) {
      ref.current.add(id2, chart == null ? void 0 : chart.current, option, title);
      event.emit("list");
    }
  }, deps != null ? deps : [], {
    wait: 100
  });
  return { tool: ref.current };
};
var IconContext = /* @__PURE__ */ createContext({});
var IconContext$1 = IconContext;
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function ownKeys(object4, enumerableOnly) {
  var keys2 = Object.keys(object4);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object4);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object4, sym).enumerable;
    })), keys2.push.apply(keys2, symbols);
  }
  return keys2;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null)
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _arrayLikeToArray(arr, len2) {
  if (len2 == null || len2 > arr.length)
    len2 = arr.length;
  for (var i = 0, arr2 = new Array(len2); i < len2; i++) {
    arr2[i] = arr[i];
  }
  return arr2;
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray(o, minLen);
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
var classnames = { exports: {} };
/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
(function(module) {
  (function() {
    var hasOwn2 = {}.hasOwnProperty;
    function classNames2() {
      var classes = [];
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (!arg)
          continue;
        var argType = typeof arg;
        if (argType === "string" || argType === "number") {
          classes.push(arg);
        } else if (Array.isArray(arg)) {
          if (arg.length) {
            var inner2 = classNames2.apply(null, arg);
            if (inner2) {
              classes.push(inner2);
            }
          }
        } else if (argType === "object") {
          if (arg.toString === Object.prototype.toString) {
            for (var key in arg) {
              if (hasOwn2.call(arg, key) && arg[key]) {
                classes.push(key);
              }
            }
          } else {
            classes.push(arg.toString());
          }
        }
      }
      return classes.join(" ");
    }
    if (module.exports) {
      classNames2.default = classNames2;
      module.exports = classNames2;
    } else {
      window.classNames = classNames2;
    }
  })();
})(classnames);
var classNames = classnames.exports;
function _typeof(obj) {
  "@babel/helpers - typeof";
  return _typeof = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && typeof Symbol == "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
function bound01(n2, max3) {
  if (isOnePointZero(n2)) {
    n2 = "100%";
  }
  var isPercent = isPercentage(n2);
  n2 = max3 === 360 ? n2 : Math.min(max3, Math.max(0, parseFloat(n2)));
  if (isPercent) {
    n2 = parseInt(String(n2 * max3), 10) / 100;
  }
  if (Math.abs(n2 - max3) < 1e-6) {
    return 1;
  }
  if (max3 === 360) {
    n2 = (n2 < 0 ? n2 % max3 + max3 : n2 % max3) / parseFloat(String(max3));
  } else {
    n2 = n2 % max3 / parseFloat(String(max3));
  }
  return n2;
}
function isOnePointZero(n2) {
  return typeof n2 === "string" && n2.indexOf(".") !== -1 && parseFloat(n2) === 1;
}
function isPercentage(n2) {
  return typeof n2 === "string" && n2.indexOf("%") !== -1;
}
function boundAlpha(a) {
  a = parseFloat(a);
  if (isNaN(a) || a < 0 || a > 1) {
    a = 1;
  }
  return a;
}
function convertToPercentage(n2) {
  if (n2 <= 1) {
    return Number(n2) * 100 + "%";
  }
  return n2;
}
function pad2(c2) {
  return c2.length === 1 ? "0" + c2 : String(c2);
}
function rgbToRgb(r2, g2, b2) {
  return {
    r: bound01(r2, 255) * 255,
    g: bound01(g2, 255) * 255,
    b: bound01(b2, 255) * 255
  };
}
function hue2rgb(p2, q2, t2) {
  if (t2 < 0) {
    t2 += 1;
  }
  if (t2 > 1) {
    t2 -= 1;
  }
  if (t2 < 1 / 6) {
    return p2 + (q2 - p2) * (6 * t2);
  }
  if (t2 < 1 / 2) {
    return q2;
  }
  if (t2 < 2 / 3) {
    return p2 + (q2 - p2) * (2 / 3 - t2) * 6;
  }
  return p2;
}
function hslToRgb(h, s, l2) {
  var r2;
  var g2;
  var b2;
  h = bound01(h, 360);
  s = bound01(s, 100);
  l2 = bound01(l2, 100);
  if (s === 0) {
    g2 = l2;
    b2 = l2;
    r2 = l2;
  } else {
    var q2 = l2 < 0.5 ? l2 * (1 + s) : l2 + s - l2 * s;
    var p2 = 2 * l2 - q2;
    r2 = hue2rgb(p2, q2, h + 1 / 3);
    g2 = hue2rgb(p2, q2, h);
    b2 = hue2rgb(p2, q2, h - 1 / 3);
  }
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHsv(r2, g2, b2) {
  r2 = bound01(r2, 255);
  g2 = bound01(g2, 255);
  b2 = bound01(b2, 255);
  var max3 = Math.max(r2, g2, b2);
  var min3 = Math.min(r2, g2, b2);
  var h = 0;
  var v4 = max3;
  var d2 = max3 - min3;
  var s = max3 === 0 ? 0 : d2 / max3;
  if (max3 === min3) {
    h = 0;
  } else {
    switch (max3) {
      case r2:
        h = (g2 - b2) / d2 + (g2 < b2 ? 6 : 0);
        break;
      case g2:
        h = (b2 - r2) / d2 + 2;
        break;
      case b2:
        h = (r2 - g2) / d2 + 4;
        break;
    }
    h /= 6;
  }
  return { h, s, v: v4 };
}
function hsvToRgb(h, s, v4) {
  h = bound01(h, 360) * 6;
  s = bound01(s, 100);
  v4 = bound01(v4, 100);
  var i = Math.floor(h);
  var f2 = h - i;
  var p2 = v4 * (1 - s);
  var q2 = v4 * (1 - f2 * s);
  var t2 = v4 * (1 - (1 - f2) * s);
  var mod = i % 6;
  var r2 = [v4, q2, p2, p2, t2, v4][mod];
  var g2 = [t2, v4, v4, q2, p2, p2][mod];
  var b2 = [p2, p2, t2, v4, v4, q2][mod];
  return { r: r2 * 255, g: g2 * 255, b: b2 * 255 };
}
function rgbToHex(r2, g2, b2, allow3Char) {
  var hex2 = [
    pad2(Math.round(r2).toString(16)),
    pad2(Math.round(g2).toString(16)),
    pad2(Math.round(b2).toString(16))
  ];
  if (allow3Char && hex2[0].startsWith(hex2[0].charAt(1)) && hex2[1].startsWith(hex2[1].charAt(1)) && hex2[2].startsWith(hex2[2].charAt(1))) {
    return hex2[0].charAt(0) + hex2[1].charAt(0) + hex2[2].charAt(0);
  }
  return hex2.join("");
}
function convertHexToDecimal(h) {
  return parseIntFromHex(h) / 255;
}
function parseIntFromHex(val) {
  return parseInt(val, 16);
}
var names = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function inputToRGB(color) {
  var rgb = { r: 0, g: 0, b: 0 };
  var a = 1;
  var s = null;
  var v4 = null;
  var l2 = null;
  var ok = false;
  var format2 = false;
  if (typeof color === "string") {
    color = stringInputToObject(color);
  }
  if (typeof color === "object") {
    if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
      rgb = rgbToRgb(color.r, color.g, color.b);
      ok = true;
      format2 = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
      s = convertToPercentage(color.s);
      v4 = convertToPercentage(color.v);
      rgb = hsvToRgb(color.h, s, v4);
      ok = true;
      format2 = "hsv";
    } else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
      s = convertToPercentage(color.s);
      l2 = convertToPercentage(color.l);
      rgb = hslToRgb(color.h, s, l2);
      ok = true;
      format2 = "hsl";
    }
    if (Object.prototype.hasOwnProperty.call(color, "a")) {
      a = color.a;
    }
  }
  a = boundAlpha(a);
  return {
    ok,
    format: color.format || format2,
    r: Math.min(255, Math.max(rgb.r, 0)),
    g: Math.min(255, Math.max(rgb.g, 0)),
    b: Math.min(255, Math.max(rgb.b, 0)),
    a
  };
}
var CSS_INTEGER = "[-\\+]?\\d+%?";
var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";
var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";
var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
var matchers = {
  CSS_UNIT: new RegExp(CSS_UNIT),
  rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
  rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
  hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
  hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
  hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
  hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
  hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
  hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
  hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
};
function stringInputToObject(color) {
  color = color.trim().toLowerCase();
  if (color.length === 0) {
    return false;
  }
  var named = false;
  if (names[color]) {
    color = names[color];
    named = true;
  } else if (color === "transparent") {
    return { r: 0, g: 0, b: 0, a: 0, format: "name" };
  }
  var match = matchers.rgb.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3] };
  }
  match = matchers.rgba.exec(color);
  if (match) {
    return { r: match[1], g: match[2], b: match[3], a: match[4] };
  }
  match = matchers.hsl.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3] };
  }
  match = matchers.hsla.exec(color);
  if (match) {
    return { h: match[1], s: match[2], l: match[3], a: match[4] };
  }
  match = matchers.hsv.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3] };
  }
  match = matchers.hsva.exec(color);
  if (match) {
    return { h: match[1], s: match[2], v: match[3], a: match[4] };
  }
  match = matchers.hex8.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      a: convertHexToDecimal(match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex6.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1]),
      g: parseIntFromHex(match[2]),
      b: parseIntFromHex(match[3]),
      format: named ? "name" : "hex"
    };
  }
  match = matchers.hex4.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      a: convertHexToDecimal(match[4] + match[4]),
      format: named ? "name" : "hex8"
    };
  }
  match = matchers.hex3.exec(color);
  if (match) {
    return {
      r: parseIntFromHex(match[1] + match[1]),
      g: parseIntFromHex(match[2] + match[2]),
      b: parseIntFromHex(match[3] + match[3]),
      format: named ? "name" : "hex"
    };
  }
  return false;
}
function isValidCSSUnit(color) {
  return Boolean(matchers.CSS_UNIT.exec(String(color)));
}
var hueStep = 2;
var saturationStep = 0.16;
var saturationStep2 = 0.05;
var brightnessStep1 = 0.05;
var brightnessStep2 = 0.15;
var lightColorCount = 5;
var darkColorCount = 4;
var darkColorMap = [{
  index: 7,
  opacity: 0.15
}, {
  index: 6,
  opacity: 0.25
}, {
  index: 5,
  opacity: 0.3
}, {
  index: 5,
  opacity: 0.45
}, {
  index: 5,
  opacity: 0.65
}, {
  index: 5,
  opacity: 0.85
}, {
  index: 4,
  opacity: 0.9
}, {
  index: 3,
  opacity: 0.95
}, {
  index: 2,
  opacity: 0.97
}, {
  index: 1,
  opacity: 0.98
}];
function toHsv(_ref) {
  var r2 = _ref.r, g2 = _ref.g, b2 = _ref.b;
  var hsv = rgbToHsv(r2, g2, b2);
  return {
    h: hsv.h * 360,
    s: hsv.s,
    v: hsv.v
  };
}
function toHex(_ref2) {
  var r2 = _ref2.r, g2 = _ref2.g, b2 = _ref2.b;
  return "#".concat(rgbToHex(r2, g2, b2, false));
}
function mix(rgb1, rgb2, amount) {
  var p2 = amount / 100;
  var rgb = {
    r: (rgb2.r - rgb1.r) * p2 + rgb1.r,
    g: (rgb2.g - rgb1.g) * p2 + rgb1.g,
    b: (rgb2.b - rgb1.b) * p2 + rgb1.b
  };
  return rgb;
}
function getHue(hsv, i, light) {
  var hue;
  if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
    hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
  } else {
    hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
  }
  if (hue < 0) {
    hue += 360;
  } else if (hue >= 360) {
    hue -= 360;
  }
  return hue;
}
function getSaturation(hsv, i, light) {
  if (hsv.h === 0 && hsv.s === 0) {
    return hsv.s;
  }
  var saturation;
  if (light) {
    saturation = hsv.s - saturationStep * i;
  } else if (i === darkColorCount) {
    saturation = hsv.s + saturationStep;
  } else {
    saturation = hsv.s + saturationStep2 * i;
  }
  if (saturation > 1) {
    saturation = 1;
  }
  if (light && i === lightColorCount && saturation > 0.1) {
    saturation = 0.1;
  }
  if (saturation < 0.06) {
    saturation = 0.06;
  }
  return Number(saturation.toFixed(2));
}
function getValue$2(hsv, i, light) {
  var value;
  if (light) {
    value = hsv.v + brightnessStep1 * i;
  } else {
    value = hsv.v - brightnessStep2 * i;
  }
  if (value > 1) {
    value = 1;
  }
  return Number(value.toFixed(2));
}
function generate$1(color) {
  var opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var patterns = [];
  var pColor = inputToRGB(color);
  for (var i = lightColorCount; i > 0; i -= 1) {
    var hsv = toHsv(pColor);
    var colorString = toHex(inputToRGB({
      h: getHue(hsv, i, true),
      s: getSaturation(hsv, i, true),
      v: getValue$2(hsv, i, true)
    }));
    patterns.push(colorString);
  }
  patterns.push(toHex(pColor));
  for (var _i = 1; _i <= darkColorCount; _i += 1) {
    var _hsv = toHsv(pColor);
    var _colorString = toHex(inputToRGB({
      h: getHue(_hsv, _i),
      s: getSaturation(_hsv, _i),
      v: getValue$2(_hsv, _i)
    }));
    patterns.push(_colorString);
  }
  if (opts.theme === "dark") {
    return darkColorMap.map(function(_ref3) {
      var index2 = _ref3.index, opacity = _ref3.opacity;
      var darkColorString = toHex(mix(inputToRGB(opts.backgroundColor || "#141414"), inputToRGB(patterns[index2]), opacity * 100));
      return darkColorString;
    });
  }
  return patterns;
}
var presetPrimaryColors = {
  red: "#F5222D",
  volcano: "#FA541C",
  orange: "#FA8C16",
  gold: "#FAAD14",
  yellow: "#FADB14",
  lime: "#A0D911",
  green: "#52C41A",
  cyan: "#13C2C2",
  blue: "#1890FF",
  geekblue: "#2F54EB",
  purple: "#722ED1",
  magenta: "#EB2F96",
  grey: "#666666"
};
var presetPalettes = {};
var presetDarkPalettes = {};
Object.keys(presetPrimaryColors).forEach(function(key) {
  presetPalettes[key] = generate$1(presetPrimaryColors[key]);
  presetPalettes[key].primary = presetPalettes[key][5];
  presetDarkPalettes[key] = generate$1(presetPrimaryColors[key], {
    theme: "dark",
    backgroundColor: "#141414"
  });
  presetDarkPalettes[key].primary = presetDarkPalettes[key][5];
});
presetPalettes.red;
presetPalettes.volcano;
presetPalettes.gold;
presetPalettes.orange;
presetPalettes.yellow;
presetPalettes.lime;
presetPalettes.green;
presetPalettes.cyan;
presetPalettes.blue;
presetPalettes.geekblue;
presetPalettes.purple;
presetPalettes.magenta;
presetPalettes.grey;
var warned = {};
function warning$2(valid, message) {
}
function call(method4, valid, message) {
  if (!valid && !warned[message]) {
    method4(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning$2, valid, message);
}
function canUseDom() {
  return !!(typeof window !== "undefined" && window.document && window.document.createElement);
}
var MARK_KEY = "rc-util-key";
function getMark() {
  var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, mark = _ref.mark;
  if (mark) {
    return mark.startsWith("data-") ? mark : "data-".concat(mark);
  }
  return MARK_KEY;
}
function getContainer(option) {
  if (option.attachTo) {
    return option.attachTo;
  }
  var head = document.querySelector("head");
  return head || document.body;
}
function injectCSS(css) {
  var _option$csp;
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  if (!canUseDom()) {
    return null;
  }
  var styleNode = document.createElement("style");
  if ((_option$csp = option.csp) === null || _option$csp === void 0 ? void 0 : _option$csp.nonce) {
    var _option$csp2;
    styleNode.nonce = (_option$csp2 = option.csp) === null || _option$csp2 === void 0 ? void 0 : _option$csp2.nonce;
  }
  styleNode.innerHTML = css;
  var container2 = getContainer(option);
  var firstChild = container2.firstChild;
  if (option.prepend && container2.prepend) {
    container2.prepend(styleNode);
  } else if (option.prepend && firstChild) {
    container2.insertBefore(styleNode, firstChild);
  } else {
    container2.appendChild(styleNode);
  }
  return styleNode;
}
var containerCache = /* @__PURE__ */ new Map();
function findExistNode(key) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var container2 = getContainer(option);
  return Array.from(containerCache.get(container2).children).find(function(node) {
    return node.tagName === "STYLE" && node.getAttribute(getMark(option)) === key;
  });
}
function updateCSS(css, key) {
  var option = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var container2 = getContainer(option);
  if (!containerCache.has(container2)) {
    var placeholderStyle = injectCSS("", option);
    var parentNode2 = placeholderStyle.parentNode;
    containerCache.set(container2, parentNode2);
    parentNode2.removeChild(placeholderStyle);
  }
  var existNode = findExistNode(key, option);
  if (existNode) {
    var _option$csp3, _option$csp4;
    if (((_option$csp3 = option.csp) === null || _option$csp3 === void 0 ? void 0 : _option$csp3.nonce) && existNode.nonce !== ((_option$csp4 = option.csp) === null || _option$csp4 === void 0 ? void 0 : _option$csp4.nonce)) {
      var _option$csp5;
      existNode.nonce = (_option$csp5 = option.csp) === null || _option$csp5 === void 0 ? void 0 : _option$csp5.nonce;
    }
    if (existNode.innerHTML !== css) {
      existNode.innerHTML = css;
    }
    return existNode;
  }
  var newNode = injectCSS(css, option);
  newNode.setAttribute(getMark(option), key);
  return newNode;
}
function warning$1(valid, message) {
  warningOnce(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return _typeof(target) === "object" && typeof target.name === "string" && typeof target.theme === "string" && (_typeof(target.icon) === "object" || typeof target.icon === "function");
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  return Object.keys(attrs).reduce(function(acc, key) {
    var val = attrs[key];
    switch (key) {
      case "class":
        acc.className = val;
        delete acc.class;
        break;
      default:
        acc[key] = val;
    }
    return acc;
  }, {});
}
function generate(node, key, rootProps) {
  if (!rootProps) {
    return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2({
      key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function(child, index2) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
    }));
  }
  return /* @__PURE__ */ React__default.createElement(node.tag, _objectSpread2(_objectSpread2({
    key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function(child, index2) {
    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index2));
  }));
}
function getSecondaryColor(primaryColor) {
  return generate$1(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }
  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
}
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var useInsertStyles = function useInsertStyles2() {
  var styleStr = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : iconStyles;
  var _useContext = useContext(IconContext$1), csp = _useContext.csp;
  useEffect(function() {
    updateCSS(styleStr, "@ant-design-icons", {
      prepend: true,
      csp
    });
  }, []);
};
var _excluded$4 = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"];
var twoToneColorPalette = {
  primaryColor: "#333",
  secondaryColor: "#E6E6E6",
  calculated: false
};
function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor, secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || getSecondaryColor(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}
function getTwoToneColors() {
  return _objectSpread2({}, twoToneColorPalette);
}
var IconBase = function IconBase2(props) {
  var icon = props.icon, className = props.className, onClick = props.onClick, style = props.style, primaryColor = props.primaryColor, secondaryColor = props.secondaryColor, restProps = _objectWithoutProperties(props, _excluded$4);
  var colors = twoToneColorPalette;
  if (primaryColor) {
    colors = {
      primaryColor,
      secondaryColor: secondaryColor || getSecondaryColor(primaryColor)
    };
  }
  useInsertStyles();
  warning$1(isIconDefinition(icon), "icon should be icon definiton, but got ".concat(icon));
  if (!isIconDefinition(icon)) {
    return null;
  }
  var target = icon;
  if (target && typeof target.icon === "function") {
    target = _objectSpread2(_objectSpread2({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }
  return generate(target.icon, "svg-".concat(target.name), _objectSpread2({
    className,
    onClick,
    style,
    "data-icon": target.name,
    width: "1em",
    height: "1em",
    fill: "currentColor",
    "aria-hidden": "true"
  }, restProps));
};
IconBase.displayName = "IconReact";
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;
var ReactIcon = IconBase;
function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return ReactIcon.setTwoToneColors({
    primaryColor,
    secondaryColor
  });
}
function getTwoToneColor() {
  var colors = ReactIcon.getTwoToneColors();
  if (!colors.calculated) {
    return colors.primaryColor;
  }
  return [colors.primaryColor, colors.secondaryColor];
}
var _excluded$3 = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
setTwoToneColor("#1890ff");
var Icon = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var className = props.className, icon = props.icon, spin = props.spin, rotate2 = props.rotate, tabIndex = props.tabIndex, onClick = props.onClick, twoToneColor = props.twoToneColor, restProps = _objectWithoutProperties(props, _excluded$3);
  var _React$useContext = React.useContext(IconContext$1), _React$useContext$pre = _React$useContext.prefixCls, prefixCls = _React$useContext$pre === void 0 ? "anticon" : _React$useContext$pre;
  var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(icon.name), !!icon.name), _defineProperty(_classNames, "".concat(prefixCls, "-spin"), !!spin || icon.name === "loading"), _classNames), className);
  var iconTabIndex = tabIndex;
  if (iconTabIndex === void 0 && onClick) {
    iconTabIndex = -1;
  }
  var svgStyle = rotate2 ? {
    msTransform: "rotate(".concat(rotate2, "deg)"),
    transform: "rotate(".concat(rotate2, "deg)")
  } : void 0;
  var _normalizeTwoToneColo = normalizeTwoToneColors(twoToneColor), _normalizeTwoToneColo2 = _slicedToArray(_normalizeTwoToneColo, 2), primaryColor = _normalizeTwoToneColo2[0], secondaryColor = _normalizeTwoToneColo2[1];
  return /* @__PURE__ */ React.createElement("span", _objectSpread2(_objectSpread2({
    role: "img",
    "aria-label": icon.name
  }, restProps), {}, {
    ref,
    tabIndex: iconTabIndex,
    onClick,
    className: classString
  }), /* @__PURE__ */ React.createElement(ReactIcon, {
    icon,
    primaryColor,
    secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = "AntdIcon";
Icon.getTwoToneColor = getTwoToneColor;
Icon.setTwoToneColor = setTwoToneColor;
var AntdIcon = Icon;
var LoadingOutlined$2 = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, "name": "loading", "theme": "outlined" };
var LoadingOutlinedSvg = LoadingOutlined$2;
var LoadingOutlined = function LoadingOutlined2(props, ref) {
  return /* @__PURE__ */ React.createElement(AntdIcon, _objectSpread2(_objectSpread2({}, props), {}, {
    ref,
    icon: LoadingOutlinedSvg
  }));
};
LoadingOutlined.displayName = "LoadingOutlined";
var LoadingOutlined$1 = /* @__PURE__ */ React.forwardRef(LoadingOutlined);
function _extends$1() {
  _extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _setPrototypeOf$1(o, p2) {
  _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf$1(o, p2);
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass)
    _setPrototypeOf$1(subClass, superClass);
}
function _getPrototypeOf$1(o) {
  _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf$1(o);
}
function _isNativeReflectConstruct$1() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _assertThisInitialized(self2) {
  if (self2 === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self2;
}
function _possibleConstructorReturn(self2, call2) {
  if (call2 && (_typeof(call2) === "object" || typeof call2 === "function")) {
    return call2;
  } else if (call2 !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self2);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct$1();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf$1(Derived), result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf$1(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
var reactIs = { exports: {} };
var reactIs_production_min = {};
/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b = typeof Symbol === "function" && Symbol.for, c = b ? Symbol.for("react.element") : 60103, d = b ? Symbol.for("react.portal") : 60106, e = b ? Symbol.for("react.fragment") : 60107, f$1 = b ? Symbol.for("react.strict_mode") : 60108, g$1 = b ? Symbol.for("react.profiler") : 60114, h$1 = b ? Symbol.for("react.provider") : 60109, k = b ? Symbol.for("react.context") : 60110, l = b ? Symbol.for("react.async_mode") : 60111, m$1 = b ? Symbol.for("react.concurrent_mode") : 60111, n$1 = b ? Symbol.for("react.forward_ref") : 60112, p$1 = b ? Symbol.for("react.suspense") : 60113, q$1 = b ? Symbol.for("react.suspense_list") : 60120, r = b ? Symbol.for("react.memo") : 60115, t = b ? Symbol.for("react.lazy") : 60116, v = b ? Symbol.for("react.block") : 60121, w = b ? Symbol.for("react.fundamental") : 60117, x = b ? Symbol.for("react.responder") : 60118, y = b ? Symbol.for("react.scope") : 60119;
function z(a) {
  if (typeof a === "object" && a !== null) {
    var u = a.$$typeof;
    switch (u) {
      case c:
        switch (a = a.type, a) {
          case l:
          case m$1:
          case e:
          case g$1:
          case f$1:
          case p$1:
            return a;
          default:
            switch (a = a && a.$$typeof, a) {
              case k:
              case n$1:
              case t:
              case r:
              case h$1:
                return a;
              default:
                return u;
            }
        }
      case d:
        return u;
    }
  }
}
function A(a) {
  return z(a) === m$1;
}
reactIs_production_min.AsyncMode = l;
reactIs_production_min.ConcurrentMode = m$1;
reactIs_production_min.ContextConsumer = k;
reactIs_production_min.ContextProvider = h$1;
reactIs_production_min.Element = c;
reactIs_production_min.ForwardRef = n$1;
reactIs_production_min.Fragment = e;
reactIs_production_min.Lazy = t;
reactIs_production_min.Memo = r;
reactIs_production_min.Portal = d;
reactIs_production_min.Profiler = g$1;
reactIs_production_min.StrictMode = f$1;
reactIs_production_min.Suspense = p$1;
reactIs_production_min.isAsyncMode = function(a) {
  return A(a) || z(a) === l;
};
reactIs_production_min.isConcurrentMode = A;
reactIs_production_min.isContextConsumer = function(a) {
  return z(a) === k;
};
reactIs_production_min.isContextProvider = function(a) {
  return z(a) === h$1;
};
reactIs_production_min.isElement = function(a) {
  return typeof a === "object" && a !== null && a.$$typeof === c;
};
reactIs_production_min.isForwardRef = function(a) {
  return z(a) === n$1;
};
reactIs_production_min.isFragment = function(a) {
  return z(a) === e;
};
reactIs_production_min.isLazy = function(a) {
  return z(a) === t;
};
reactIs_production_min.isMemo = function(a) {
  return z(a) === r;
};
reactIs_production_min.isPortal = function(a) {
  return z(a) === d;
};
reactIs_production_min.isProfiler = function(a) {
  return z(a) === g$1;
};
reactIs_production_min.isStrictMode = function(a) {
  return z(a) === f$1;
};
reactIs_production_min.isSuspense = function(a) {
  return z(a) === p$1;
};
reactIs_production_min.isValidElementType = function(a) {
  return typeof a === "string" || typeof a === "function" || a === e || a === m$1 || a === g$1 || a === f$1 || a === p$1 || a === q$1 || typeof a === "object" && a !== null && (a.$$typeof === t || a.$$typeof === r || a.$$typeof === h$1 || a.$$typeof === k || a.$$typeof === n$1 || a.$$typeof === w || a.$$typeof === x || a.$$typeof === y || a.$$typeof === v);
};
reactIs_production_min.typeOf = z;
{
  reactIs.exports = reactIs_production_min;
}
function toArray$1(children) {
  var option = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var ret = [];
  React__default.Children.forEach(children, function(child) {
    if ((child === void 0 || child === null) && !option.keepEmpty) {
      return;
    }
    if (Array.isArray(child)) {
      ret = ret.concat(toArray$1(child));
    } else if (reactIs.exports.isFragment(child) && child.props) {
      ret = ret.concat(toArray$1(child.props.children, option));
    } else {
      ret.push(child);
    }
  });
  return ret;
}
function fillRef(ref, node) {
  if (typeof ref === "function") {
    ref(node);
  } else if (_typeof(ref) === "object" && ref && "current" in ref) {
    ref.current = node;
  }
}
function composeRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  var refList = refs.filter(function(ref) {
    return ref;
  });
  if (refList.length <= 1) {
    return refList[0];
  }
  return function(node) {
    refs.forEach(function(ref) {
      fillRef(ref, node);
    });
  };
}
function supportRef(nodeOrComponent) {
  var _type$prototype, _nodeOrComponent$prot;
  var type4 = reactIs.exports.isMemo(nodeOrComponent) ? nodeOrComponent.type.type : nodeOrComponent.type;
  if (typeof type4 === "function" && !((_type$prototype = type4.prototype) === null || _type$prototype === void 0 ? void 0 : _type$prototype.render)) {
    return false;
  }
  if (typeof nodeOrComponent === "function" && !((_nodeOrComponent$prot = nodeOrComponent.prototype) === null || _nodeOrComponent$prot === void 0 ? void 0 : _nodeOrComponent$prot.render)) {
    return false;
  }
  return true;
}
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
var HOOK_MARK = "RC_FORM_INTERNAL_HOOKS";
var warningFunc = function warningFunc2() {
  warningOnce(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
};
var Context = /* @__PURE__ */ React.createContext({
  getFieldValue: warningFunc,
  getFieldsValue: warningFunc,
  getFieldError: warningFunc,
  getFieldWarning: warningFunc,
  getFieldsError: warningFunc,
  isFieldsTouched: warningFunc,
  isFieldTouched: warningFunc,
  isFieldValidating: warningFunc,
  isFieldsValidating: warningFunc,
  resetFields: warningFunc,
  setFields: warningFunc,
  setFieldsValue: warningFunc,
  validateFields: warningFunc,
  submit: warningFunc,
  getInternalHooks: function getInternalHooks() {
    warningFunc();
    return {
      dispatch: warningFunc,
      initEntityValue: warningFunc,
      registerField: warningFunc,
      useSubscribe: warningFunc,
      setInitialValues: warningFunc,
      setCallbacks: warningFunc,
      getFields: warningFunc,
      setValidateMessages: warningFunc,
      setPreserve: warningFunc,
      getInitialValue: warningFunc
    };
  }
});
function toArray(value) {
  if (value === void 0 || value === null) {
    return [];
  }
  return Array.isArray(value) ? value : [value];
}
var runtime = { exports: {} };
(function(module) {
  var runtime2 = function(exports) {
    var Op = Object.prototype;
    var hasOwn2 = Op.hasOwnProperty;
    var undefined$1;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self2, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context2(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self2, context);
      return generator;
    }
    exports.wrap = wrap;
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }
    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};
    function Generator() {
    }
    function GeneratorFunction() {
    }
    function GeneratorFunctionPrototype() {
    }
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function() {
      return this;
    });
    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn2.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = GeneratorFunctionPrototype;
    define(Gp, "constructor", GeneratorFunctionPrototype);
    define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
    GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction");
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method4) {
        define(prototype, method4, function(arg) {
          return this._invoke(method4, arg);
        });
      });
    }
    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };
    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };
    exports.awrap = function(arg) {
      return { __await: arg };
    };
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method4, arg, resolve, reject) {
        var record = tryCatch(generator[method4], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value && typeof value === "object" && hasOwn2.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value2) {
              invoke("next", value2, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }
          return PromiseImpl.resolve(value).then(function(unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }
      var previousPromise;
      function enqueue(method4, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method4, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
      this._invoke = enqueue;
    }
    defineIteratorMethods(AsyncIterator.prototype);
    define(AsyncIterator.prototype, asyncIteratorSymbol, function() {
      return this;
    });
    exports.AsyncIterator = AsyncIterator;
    exports.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0)
        PromiseImpl = Promise;
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
        return result.done ? result.value : iter.next();
      });
    };
    function makeInvokeMethod(innerFn, self2, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method4, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }
        if (state === GenStateCompleted) {
          if (method4 === "throw") {
            throw arg;
          }
          return doneResult();
        }
        context.method = method4;
        context.arg = arg;
        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel)
                continue;
              return delegateResult;
            }
          }
          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }
            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }
          state = GenStateExecuting;
          var record = tryCatch(innerFn, self2, context);
          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;
            if (record.arg === ContinueSentinel) {
              continue;
            }
            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var method4 = delegate.iterator[context.method];
      if (method4 === undefined$1) {
        context.delegate = null;
        if (context.method === "throw") {
          if (delegate.iterator["return"]) {
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);
            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }
          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }
        return ContinueSentinel;
      }
      var record = tryCatch(method4, delegate.iterator, context.arg);
      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }
      var info = record.arg;
      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }
      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }
      } else {
        return info;
      }
      context.delegate = null;
      return ContinueSentinel;
    }
    defineIteratorMethods(Gp);
    define(Gp, toStringTagSymbol, "Generator");
    define(Gp, iteratorSymbol, function() {
      return this;
    });
    define(Gp, "toString", function() {
      return "[object Generator]";
    });
    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };
      if (1 in locs) {
        entry.catchLoc = locs[1];
      }
      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }
      this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }
    function Context2(tryLocsList) {
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }
    exports.keys = function(object4) {
      var keys2 = [];
      for (var key in object4) {
        keys2.push(key);
      }
      keys2.reverse();
      return function next() {
        while (keys2.length) {
          var key2 = keys2.pop();
          if (key2 in object4) {
            next.value = key2;
            next.done = false;
            return next;
          }
        }
        next.done = true;
        return next;
      };
    };
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }
        if (typeof iterable.next === "function") {
          return iterable;
        }
        if (!isNaN(iterable.length)) {
          var i = -1, next = function next2() {
            while (++i < iterable.length) {
              if (hasOwn2.call(iterable, i)) {
                next2.value = iterable[i];
                next2.done = false;
                return next2;
              }
            }
            next2.value = undefined$1;
            next2.done = true;
            return next2;
          };
          return next.next = next;
        }
      }
      return { next: doneResult };
    }
    exports.values = values;
    function doneResult() {
      return { value: undefined$1, done: true };
    }
    Context2.prototype = {
      constructor: Context2,
      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined$1;
        this.tryEntries.forEach(resetTryEntry);
        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn2.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },
      stop: function() {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }
        return this.rval;
      },
      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }
        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;
          if (caught) {
            context.method = "next";
            context.arg = undefined$1;
          }
          return !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;
          if (entry.tryLoc === "root") {
            return handle("end");
          }
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn2.call(entry, "catchLoc");
            var hasFinally = hasOwn2.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function(type4, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn2.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        if (finallyEntry && (type4 === "break" || type4 === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }
        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type4;
        record.arg = arg;
        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }
        return this.complete(record);
      },
      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }
        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }
        return ContinueSentinel;
      },
      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName,
          nextLoc
        };
        if (this.method === "next") {
          this.arg = undefined$1;
        }
        return ContinueSentinel;
      }
    };
    return exports;
  }(module.exports);
  try {
    regeneratorRuntime = runtime2;
  } catch (accidentalStrictMode) {
    if (typeof globalThis === "object") {
      globalThis.regeneratorRuntime = runtime2;
    } else {
      Function("r", "regeneratorRuntime = r")(runtime2);
    }
  }
})(runtime);
var regenerator = runtime.exports;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p2) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf(o, p2);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct2(Parent2, args2, Class2) {
      var a = [null];
      a.push.apply(a, args2);
      var Constructor = Function.bind.apply(Parent2, a);
      var instance = new Constructor();
      if (Class2)
        _setPrototypeOf(instance, Class2.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
  _wrapNativeSuper = function _wrapNativeSuper2(Class2) {
    if (Class2 === null || !_isNativeFunction(Class2))
      return Class2;
    if (typeof Class2 !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class2))
        return _cache.get(Class2);
      _cache.set(Class2, Wrapper);
    }
    function Wrapper() {
      return _construct(Class2, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class2.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class2);
  };
  return _wrapNativeSuper(Class);
}
var formatRegExp = /%[sdj%]/g;
var warning = function warning2() {
};
if (typeof process !== "undefined" && process.env && false) {
  warning = function warning3(type4, errors) {
    if (typeof console !== "undefined" && console.warn && typeof ASYNC_VALIDATOR_NO_WARNING === "undefined") {
      if (errors.every(function(e2) {
        return typeof e2 === "string";
      })) {
        console.warn(type4, errors);
      }
    }
  };
}
function convertFieldsError(errors) {
  if (!errors || !errors.length)
    return null;
  var fields = {};
  errors.forEach(function(error) {
    var field = error.field;
    fields[field] = fields[field] || [];
    fields[field].push(error);
  });
  return fields;
}
function format(template) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }
  var i = 0;
  var len2 = args.length;
  if (typeof template === "function") {
    return template.apply(null, args);
  }
  if (typeof template === "string") {
    var str = template.replace(formatRegExp, function(x2) {
      if (x2 === "%%") {
        return "%";
      }
      if (i >= len2) {
        return x2;
      }
      switch (x2) {
        case "%s":
          return String(args[i++]);
        case "%d":
          return Number(args[i++]);
        case "%j":
          try {
            return JSON.stringify(args[i++]);
          } catch (_) {
            return "[Circular]";
          }
          break;
        default:
          return x2;
      }
    });
    return str;
  }
  return template;
}
function isNativeStringType(type4) {
  return type4 === "string" || type4 === "url" || type4 === "hex" || type4 === "email" || type4 === "date" || type4 === "pattern";
}
function isEmptyValue(value, type4) {
  if (value === void 0 || value === null) {
    return true;
  }
  if (type4 === "array" && Array.isArray(value) && !value.length) {
    return true;
  }
  if (isNativeStringType(type4) && typeof value === "string" && !value) {
    return true;
  }
  return false;
}
function asyncParallelArray(arr, func, callback) {
  var results = [];
  var total = 0;
  var arrLength = arr.length;
  function count2(errors) {
    results.push.apply(results, errors || []);
    total++;
    if (total === arrLength) {
      callback(results);
    }
  }
  arr.forEach(function(a) {
    func(a, count2);
  });
}
function asyncSerialArray(arr, func, callback) {
  var index2 = 0;
  var arrLength = arr.length;
  function next(errors) {
    if (errors && errors.length) {
      callback(errors);
      return;
    }
    var original = index2;
    index2 = index2 + 1;
    if (original < arrLength) {
      func(arr[original], next);
    } else {
      callback([]);
    }
  }
  next([]);
}
function flattenObjArr(objArr) {
  var ret = [];
  Object.keys(objArr).forEach(function(k2) {
    ret.push.apply(ret, objArr[k2] || []);
  });
  return ret;
}
var AsyncValidationError = /* @__PURE__ */ function(_Error) {
  _inheritsLoose(AsyncValidationError2, _Error);
  function AsyncValidationError2(errors, fields) {
    var _this;
    _this = _Error.call(this, "Async Validation Error") || this;
    _this.errors = errors;
    _this.fields = fields;
    return _this;
  }
  return AsyncValidationError2;
}(/* @__PURE__ */ _wrapNativeSuper(Error));
function asyncMap(objArr, option, func, callback, source) {
  if (option.first) {
    var _pending = new Promise(function(resolve, reject) {
      var next = function next2(errors) {
        callback(errors);
        return errors.length ? reject(new AsyncValidationError(errors, convertFieldsError(errors))) : resolve(source);
      };
      var flattenArr = flattenObjArr(objArr);
      asyncSerialArray(flattenArr, func, next);
    });
    _pending["catch"](function(e2) {
      return e2;
    });
    return _pending;
  }
  var firstFields = option.firstFields === true ? Object.keys(objArr) : option.firstFields || [];
  var objArrKeys = Object.keys(objArr);
  var objArrLength = objArrKeys.length;
  var total = 0;
  var results = [];
  var pending = new Promise(function(resolve, reject) {
    var next = function next2(errors) {
      results.push.apply(results, errors);
      total++;
      if (total === objArrLength) {
        callback(results);
        return results.length ? reject(new AsyncValidationError(results, convertFieldsError(results))) : resolve(source);
      }
    };
    if (!objArrKeys.length) {
      callback(results);
      resolve(source);
    }
    objArrKeys.forEach(function(key) {
      var arr = objArr[key];
      if (firstFields.indexOf(key) !== -1) {
        asyncSerialArray(arr, func, next);
      } else {
        asyncParallelArray(arr, func, next);
      }
    });
  });
  pending["catch"](function(e2) {
    return e2;
  });
  return pending;
}
function isErrorObj(obj) {
  return !!(obj && obj.message !== void 0);
}
function getValue$1(value, path) {
  var v4 = value;
  for (var i = 0; i < path.length; i++) {
    if (v4 == void 0) {
      return v4;
    }
    v4 = v4[path[i]];
  }
  return v4;
}
function complementError(rule, source) {
  return function(oe) {
    var fieldValue;
    if (rule.fullFields) {
      fieldValue = getValue$1(source, rule.fullFields);
    } else {
      fieldValue = source[oe.field || rule.fullField];
    }
    if (isErrorObj(oe)) {
      oe.field = oe.field || rule.fullField;
      oe.fieldValue = fieldValue;
      return oe;
    }
    return {
      message: typeof oe === "function" ? oe() : oe,
      fieldValue,
      field: oe.field || rule.fullField
    };
  };
}
function deepMerge(target, source) {
  if (source) {
    for (var s in source) {
      if (source.hasOwnProperty(s)) {
        var value = source[s];
        if (typeof value === "object" && typeof target[s] === "object") {
          target[s] = _extends({}, target[s], value);
        } else {
          target[s] = value;
        }
      }
    }
  }
  return target;
}
var required$1 = function required(rule, value, source, errors, options, type4) {
  if (rule.required && (!source.hasOwnProperty(rule.field) || isEmptyValue(value, type4 || rule.type))) {
    errors.push(format(options.messages.required, rule.fullField));
  }
};
var whitespace = function whitespace2(rule, value, source, errors, options) {
  if (/^\s+$/.test(value) || value === "") {
    errors.push(format(options.messages.whitespace, rule.fullField));
  }
};
var pattern$2 = {
  email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/,
  url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"),
  hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i
};
var types = {
  integer: function integer(value) {
    return types.number(value) && parseInt(value, 10) === value;
  },
  "float": function float(value) {
    return types.number(value) && !types.integer(value);
  },
  array: function array(value) {
    return Array.isArray(value);
  },
  regexp: function regexp(value) {
    if (value instanceof RegExp) {
      return true;
    }
    try {
      return !!new RegExp(value);
    } catch (e2) {
      return false;
    }
  },
  date: function date(value) {
    return typeof value.getTime === "function" && typeof value.getMonth === "function" && typeof value.getYear === "function" && !isNaN(value.getTime());
  },
  number: function number(value) {
    if (isNaN(value)) {
      return false;
    }
    return typeof value === "number";
  },
  object: function object(value) {
    return typeof value === "object" && !types.array(value);
  },
  method: function method(value) {
    return typeof value === "function";
  },
  email: function email(value) {
    return typeof value === "string" && value.length <= 320 && !!value.match(pattern$2.email);
  },
  url: function url(value) {
    return typeof value === "string" && value.length <= 2048 && !!value.match(pattern$2.url);
  },
  hex: function hex(value) {
    return typeof value === "string" && !!value.match(pattern$2.hex);
  }
};
var type$1 = function type(rule, value, source, errors, options) {
  if (rule.required && value === void 0) {
    required$1(rule, value, source, errors, options);
    return;
  }
  var custom = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"];
  var ruleType = rule.type;
  if (custom.indexOf(ruleType) > -1) {
    if (!types[ruleType](value)) {
      errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
    }
  } else if (ruleType && typeof value !== rule.type) {
    errors.push(format(options.messages.types[ruleType], rule.fullField, rule.type));
  }
};
var range = function range2(rule, value, source, errors, options) {
  var len2 = typeof rule.len === "number";
  var min3 = typeof rule.min === "number";
  var max3 = typeof rule.max === "number";
  var spRegexp = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
  var val = value;
  var key = null;
  var num = typeof value === "number";
  var str = typeof value === "string";
  var arr = Array.isArray(value);
  if (num) {
    key = "number";
  } else if (str) {
    key = "string";
  } else if (arr) {
    key = "array";
  }
  if (!key) {
    return false;
  }
  if (arr) {
    val = value.length;
  }
  if (str) {
    val = value.replace(spRegexp, "_").length;
  }
  if (len2) {
    if (val !== rule.len) {
      errors.push(format(options.messages[key].len, rule.fullField, rule.len));
    }
  } else if (min3 && !max3 && val < rule.min) {
    errors.push(format(options.messages[key].min, rule.fullField, rule.min));
  } else if (max3 && !min3 && val > rule.max) {
    errors.push(format(options.messages[key].max, rule.fullField, rule.max));
  } else if (min3 && max3 && (val < rule.min || val > rule.max)) {
    errors.push(format(options.messages[key].range, rule.fullField, rule.min, rule.max));
  }
};
var ENUM$1 = "enum";
var enumerable$1 = function enumerable(rule, value, source, errors, options) {
  rule[ENUM$1] = Array.isArray(rule[ENUM$1]) ? rule[ENUM$1] : [];
  if (rule[ENUM$1].indexOf(value) === -1) {
    errors.push(format(options.messages[ENUM$1], rule.fullField, rule[ENUM$1].join(", ")));
  }
};
var pattern$1 = function pattern(rule, value, source, errors, options) {
  if (rule.pattern) {
    if (rule.pattern instanceof RegExp) {
      rule.pattern.lastIndex = 0;
      if (!rule.pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    } else if (typeof rule.pattern === "string") {
      var _pattern = new RegExp(rule.pattern);
      if (!_pattern.test(value)) {
        errors.push(format(options.messages.pattern.mismatch, rule.fullField, value, rule.pattern));
      }
    }
  }
};
var rules = {
  required: required$1,
  whitespace,
  type: type$1,
  range,
  "enum": enumerable$1,
  pattern: pattern$1
};
var string = function string2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "string");
    if (!isEmptyValue(value, "string")) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
      rules.pattern(rule, value, source, errors, options);
      if (rule.whitespace === true) {
        rules.whitespace(rule, value, source, errors, options);
      }
    }
  }
  callback(errors);
};
var method2 = function method3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var number2 = function number3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (value === "") {
      value = void 0;
    }
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var _boolean = function _boolean2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var regexp2 = function regexp3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var integer2 = function integer3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var floatFn = function floatFn2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var array2 = function array3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if ((value === void 0 || value === null) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, "array");
    if (value !== void 0 && value !== null) {
      rules.type(rule, value, source, errors, options);
      rules.range(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var object2 = function object3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var ENUM = "enum";
var enumerable2 = function enumerable3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (value !== void 0) {
      rules[ENUM](rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var pattern2 = function pattern3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "string") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "string")) {
      rules.pattern(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var date2 = function date3(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, "date") && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
    if (!isEmptyValue(value, "date")) {
      var dateObject;
      if (value instanceof Date) {
        dateObject = value;
      } else {
        dateObject = new Date(value);
      }
      rules.type(rule, dateObject, source, errors, options);
      if (dateObject) {
        rules.range(rule, dateObject.getTime(), source, errors, options);
      }
    }
  }
  callback(errors);
};
var required2 = function required3(rule, value, callback, source, options) {
  var errors = [];
  var type4 = Array.isArray(value) ? "array" : typeof value;
  rules.required(rule, value, source, errors, options, type4);
  callback(errors);
};
var type2 = function type3(rule, value, callback, source, options) {
  var ruleType = rule.type;
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value, ruleType) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options, ruleType);
    if (!isEmptyValue(value, ruleType)) {
      rules.type(rule, value, source, errors, options);
    }
  }
  callback(errors);
};
var any = function any2(rule, value, callback, source, options) {
  var errors = [];
  var validate = rule.required || !rule.required && source.hasOwnProperty(rule.field);
  if (validate) {
    if (isEmptyValue(value) && !rule.required) {
      return callback();
    }
    rules.required(rule, value, source, errors, options);
  }
  callback(errors);
};
var validators = {
  string,
  method: method2,
  number: number2,
  "boolean": _boolean,
  regexp: regexp2,
  integer: integer2,
  "float": floatFn,
  array: array2,
  object: object2,
  "enum": enumerable2,
  pattern: pattern2,
  date: date2,
  url: type2,
  hex: type2,
  email: type2,
  required: required2,
  any
};
function newMessages() {
  return {
    "default": "Validation error on field %s",
    required: "%s is required",
    "enum": "%s must be one of %s",
    whitespace: "%s cannot be empty",
    date: {
      format: "%s date %s is invalid for format %s",
      parse: "%s date could not be parsed, %s is invalid ",
      invalid: "%s date %s is invalid"
    },
    types: {
      string: "%s is not a %s",
      method: "%s is not a %s (function)",
      array: "%s is not an %s",
      object: "%s is not an %s",
      number: "%s is not a %s",
      date: "%s is not a %s",
      "boolean": "%s is not a %s",
      integer: "%s is not an %s",
      "float": "%s is not a %s",
      regexp: "%s is not a valid %s",
      email: "%s is not a valid %s",
      url: "%s is not a valid %s",
      hex: "%s is not a valid %s"
    },
    string: {
      len: "%s must be exactly %s characters",
      min: "%s must be at least %s characters",
      max: "%s cannot be longer than %s characters",
      range: "%s must be between %s and %s characters"
    },
    number: {
      len: "%s must equal %s",
      min: "%s cannot be less than %s",
      max: "%s cannot be greater than %s",
      range: "%s must be between %s and %s"
    },
    array: {
      len: "%s must be exactly %s in length",
      min: "%s cannot be less than %s in length",
      max: "%s cannot be greater than %s in length",
      range: "%s must be between %s and %s in length"
    },
    pattern: {
      mismatch: "%s value %s does not match pattern %s"
    },
    clone: function clone2() {
      var cloned = JSON.parse(JSON.stringify(this));
      cloned.clone = this.clone;
      return cloned;
    }
  };
}
var messages = newMessages();
var Schema = /* @__PURE__ */ function() {
  function Schema2(descriptor) {
    this.rules = null;
    this._messages = messages;
    this.define(descriptor);
  }
  var _proto = Schema2.prototype;
  _proto.define = function define(rules2) {
    var _this = this;
    if (!rules2) {
      throw new Error("Cannot configure a schema with no rules");
    }
    if (typeof rules2 !== "object" || Array.isArray(rules2)) {
      throw new Error("Rules must be an object");
    }
    this.rules = {};
    Object.keys(rules2).forEach(function(name) {
      var item = rules2[name];
      _this.rules[name] = Array.isArray(item) ? item : [item];
    });
  };
  _proto.messages = function messages2(_messages) {
    if (_messages) {
      this._messages = deepMerge(newMessages(), _messages);
    }
    return this._messages;
  };
  _proto.validate = function validate(source_, o, oc) {
    var _this2 = this;
    if (o === void 0) {
      o = {};
    }
    if (oc === void 0) {
      oc = function oc2() {
      };
    }
    var source = source_;
    var options = o;
    var callback = oc;
    if (typeof options === "function") {
      callback = options;
      options = {};
    }
    if (!this.rules || Object.keys(this.rules).length === 0) {
      if (callback) {
        callback(null, source);
      }
      return Promise.resolve(source);
    }
    function complete(results) {
      var errors = [];
      var fields = {};
      function add2(e2) {
        if (Array.isArray(e2)) {
          var _errors;
          errors = (_errors = errors).concat.apply(_errors, e2);
        } else {
          errors.push(e2);
        }
      }
      for (var i = 0; i < results.length; i++) {
        add2(results[i]);
      }
      if (!errors.length) {
        callback(null, source);
      } else {
        fields = convertFieldsError(errors);
        callback(errors, fields);
      }
    }
    if (options.messages) {
      var messages$1 = this.messages();
      if (messages$1 === messages) {
        messages$1 = newMessages();
      }
      deepMerge(messages$1, options.messages);
      options.messages = messages$1;
    } else {
      options.messages = this.messages();
    }
    var series = {};
    var keys2 = options.keys || Object.keys(this.rules);
    keys2.forEach(function(z2) {
      var arr = _this2.rules[z2];
      var value = source[z2];
      arr.forEach(function(r2) {
        var rule = r2;
        if (typeof rule.transform === "function") {
          if (source === source_) {
            source = _extends({}, source);
          }
          value = source[z2] = rule.transform(value);
        }
        if (typeof rule === "function") {
          rule = {
            validator: rule
          };
        } else {
          rule = _extends({}, rule);
        }
        rule.validator = _this2.getValidationMethod(rule);
        if (!rule.validator) {
          return;
        }
        rule.field = z2;
        rule.fullField = rule.fullField || z2;
        rule.type = _this2.getType(rule);
        series[z2] = series[z2] || [];
        series[z2].push({
          rule,
          value,
          source,
          field: z2
        });
      });
    });
    var errorFields = {};
    return asyncMap(series, options, function(data, doIt) {
      var rule = data.rule;
      var deep = (rule.type === "object" || rule.type === "array") && (typeof rule.fields === "object" || typeof rule.defaultField === "object");
      deep = deep && (rule.required || !rule.required && data.value);
      rule.field = data.field;
      function addFullField(key, schema) {
        return _extends({}, schema, {
          fullField: rule.fullField + "." + key,
          fullFields: rule.fullFields ? [].concat(rule.fullFields, [key]) : [key]
        });
      }
      function cb(e2) {
        if (e2 === void 0) {
          e2 = [];
        }
        var errorList = Array.isArray(e2) ? e2 : [e2];
        if (!options.suppressWarning && errorList.length) {
          Schema2.warning("async-validator:", errorList);
        }
        if (errorList.length && rule.message !== void 0) {
          errorList = [].concat(rule.message);
        }
        var filledErrors = errorList.map(complementError(rule, source));
        if (options.first && filledErrors.length) {
          errorFields[rule.field] = 1;
          return doIt(filledErrors);
        }
        if (!deep) {
          doIt(filledErrors);
        } else {
          if (rule.required && !data.value) {
            if (rule.message !== void 0) {
              filledErrors = [].concat(rule.message).map(complementError(rule, source));
            } else if (options.error) {
              filledErrors = [options.error(rule, format(options.messages.required, rule.field))];
            }
            return doIt(filledErrors);
          }
          var fieldsSchema = {};
          if (rule.defaultField) {
            Object.keys(data.value).map(function(key) {
              fieldsSchema[key] = rule.defaultField;
            });
          }
          fieldsSchema = _extends({}, fieldsSchema, data.rule.fields);
          var paredFieldsSchema = {};
          Object.keys(fieldsSchema).forEach(function(field) {
            var fieldSchema = fieldsSchema[field];
            var fieldSchemaList = Array.isArray(fieldSchema) ? fieldSchema : [fieldSchema];
            paredFieldsSchema[field] = fieldSchemaList.map(addFullField.bind(null, field));
          });
          var schema = new Schema2(paredFieldsSchema);
          schema.messages(options.messages);
          if (data.rule.options) {
            data.rule.options.messages = options.messages;
            data.rule.options.error = options.error;
          }
          schema.validate(data.value, data.rule.options || options, function(errs) {
            var finalErrors = [];
            if (filledErrors && filledErrors.length) {
              finalErrors.push.apply(finalErrors, filledErrors);
            }
            if (errs && errs.length) {
              finalErrors.push.apply(finalErrors, errs);
            }
            doIt(finalErrors.length ? finalErrors : null);
          });
        }
      }
      var res;
      if (rule.asyncValidator) {
        res = rule.asyncValidator(rule, data.value, cb, data.source, options);
      } else if (rule.validator) {
        res = rule.validator(rule, data.value, cb, data.source, options);
        if (res === true) {
          cb();
        } else if (res === false) {
          cb(typeof rule.message === "function" ? rule.message(rule.fullField || rule.field) : rule.message || (rule.fullField || rule.field) + " fails");
        } else if (res instanceof Array) {
          cb(res);
        } else if (res instanceof Error) {
          cb(res.message);
        }
      }
      if (res && res.then) {
        res.then(function() {
          return cb();
        }, function(e2) {
          return cb(e2);
        });
      }
    }, function(results) {
      complete(results);
    }, source);
  };
  _proto.getType = function getType(rule) {
    if (rule.type === void 0 && rule.pattern instanceof RegExp) {
      rule.type = "pattern";
    }
    if (typeof rule.validator !== "function" && rule.type && !validators.hasOwnProperty(rule.type)) {
      throw new Error(format("Unknown rule type %s", rule.type));
    }
    return rule.type || "string";
  };
  _proto.getValidationMethod = function getValidationMethod(rule) {
    if (typeof rule.validator === "function") {
      return rule.validator;
    }
    var keys2 = Object.keys(rule);
    var messageIndex = keys2.indexOf("message");
    if (messageIndex !== -1) {
      keys2.splice(messageIndex, 1);
    }
    if (keys2.length === 1 && keys2[0] === "required") {
      return validators.required;
    }
    return validators[this.getType(rule)] || void 0;
  };
  return Schema2;
}();
Schema.register = function register2(type4, validator) {
  if (typeof validator !== "function") {
    throw new Error("Cannot register a validator by type, validator is not a function");
  }
  validators[type4] = validator;
};
Schema.warning = warning;
Schema.messages = messages;
Schema.validators = validators;
var typeTemplate$1 = "'${name}' is not a valid ${type}";
var defaultValidateMessages = {
  default: "Validation error on field '${name}'",
  required: "'${name}' is required",
  enum: "'${name}' must be one of [${enum}]",
  whitespace: "'${name}' cannot be empty",
  date: {
    format: "'${name}' is invalid for format date",
    parse: "'${name}' could not be parsed as date",
    invalid: "'${name}' is invalid date"
  },
  types: {
    string: typeTemplate$1,
    method: typeTemplate$1,
    array: typeTemplate$1,
    object: typeTemplate$1,
    number: typeTemplate$1,
    date: typeTemplate$1,
    boolean: typeTemplate$1,
    integer: typeTemplate$1,
    float: typeTemplate$1,
    regexp: typeTemplate$1,
    email: typeTemplate$1,
    url: typeTemplate$1,
    hex: typeTemplate$1
  },
  string: {
    len: "'${name}' must be exactly ${len} characters",
    min: "'${name}' must be at least ${min} characters",
    max: "'${name}' cannot be longer than ${max} characters",
    range: "'${name}' must be between ${min} and ${max} characters"
  },
  number: {
    len: "'${name}' must equal ${len}",
    min: "'${name}' cannot be less than ${min}",
    max: "'${name}' cannot be greater than ${max}",
    range: "'${name}' must be between ${min} and ${max}"
  },
  array: {
    len: "'${name}' must be exactly ${len} in length",
    min: "'${name}' cannot be less than ${min} in length",
    max: "'${name}' cannot be greater than ${max} in length",
    range: "'${name}' must be between ${min} and ${max} in length"
  },
  pattern: {
    mismatch: "'${name}' does not match pattern ${pattern}"
  }
};
function get(entity, path) {
  var current = entity;
  for (var i = 0; i < path.length; i += 1) {
    if (current === null || current === void 0) {
      return void 0;
    }
    current = current[path[i]];
  }
  return current;
}
function _toArray(arr) {
  return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
}
function internalSet(entity, paths, value, removeIfUndefined) {
  if (!paths.length) {
    return value;
  }
  var _paths = _toArray(paths), path = _paths[0], restPath = _paths.slice(1);
  var clone2;
  if (!entity && typeof path === "number") {
    clone2 = [];
  } else if (Array.isArray(entity)) {
    clone2 = _toConsumableArray(entity);
  } else {
    clone2 = _objectSpread2({}, entity);
  }
  if (removeIfUndefined && value === void 0 && restPath.length === 1) {
    delete clone2[path][restPath[0]];
  } else {
    clone2[path] = internalSet(clone2[path], restPath, value, removeIfUndefined);
  }
  return clone2;
}
function set(entity, paths, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  if (paths.length && removeIfUndefined && value === void 0 && !get(entity, paths.slice(0, -1))) {
    return entity;
  }
  return internalSet(entity, paths, value, removeIfUndefined);
}
function getNamePath(path) {
  return toArray(path);
}
function getValue(store, namePath) {
  var value = get(store, namePath);
  return value;
}
function setValue(store, namePath, value) {
  var removeIfUndefined = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
  var newStore = set(store, namePath, value, removeIfUndefined);
  return newStore;
}
function cloneByNamePathList(store, namePathList) {
  var newStore = {};
  namePathList.forEach(function(namePath) {
    var value = getValue(store, namePath);
    newStore = setValue(newStore, namePath, value);
  });
  return newStore;
}
function containsNamePath(namePathList, namePath) {
  return namePathList && namePathList.some(function(path) {
    return matchNamePath(path, namePath);
  });
}
function isObject(obj) {
  return _typeof(obj) === "object" && obj !== null && Object.getPrototypeOf(obj) === Object.prototype;
}
function internalSetValues(store, values) {
  var newStore = Array.isArray(store) ? _toConsumableArray(store) : _objectSpread2({}, store);
  if (!values) {
    return newStore;
  }
  Object.keys(values).forEach(function(key) {
    var prevValue = newStore[key];
    var value = values[key];
    var recursive = isObject(prevValue) && isObject(value);
    newStore[key] = recursive ? internalSetValues(prevValue, value || {}) : value;
  });
  return newStore;
}
function setValues(store) {
  for (var _len = arguments.length, restValues = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    restValues[_key - 1] = arguments[_key];
  }
  return restValues.reduce(function(current, newStore) {
    return internalSetValues(current, newStore);
  }, store);
}
function matchNamePath(namePath, changedNamePath) {
  if (!namePath || !changedNamePath || namePath.length !== changedNamePath.length) {
    return false;
  }
  return namePath.every(function(nameUnit, i) {
    return changedNamePath[i] === nameUnit;
  });
}
function isSimilar(source, target) {
  if (source === target) {
    return true;
  }
  if (!source && target || source && !target) {
    return false;
  }
  if (!source || !target || _typeof(source) !== "object" || _typeof(target) !== "object") {
    return false;
  }
  var sourceKeys = Object.keys(source);
  var targetKeys = Object.keys(target);
  var keys2 = new Set([].concat(_toConsumableArray(sourceKeys), _toConsumableArray(targetKeys)));
  return _toConsumableArray(keys2).every(function(key) {
    var sourceValue = source[key];
    var targetValue = target[key];
    if (typeof sourceValue === "function" && typeof targetValue === "function") {
      return true;
    }
    return sourceValue === targetValue;
  });
}
function defaultGetValueFromEvent(valuePropName) {
  var event = arguments.length <= 1 ? void 0 : arguments[1];
  if (event && event.target && _typeof(event.target) === "object" && valuePropName in event.target) {
    return event.target[valuePropName];
  }
  return event;
}
function move(array4, moveIndex, toIndex) {
  var length = array4.length;
  if (moveIndex < 0 || moveIndex >= length || toIndex < 0 || toIndex >= length) {
    return array4;
  }
  var item = array4[moveIndex];
  var diff = moveIndex - toIndex;
  if (diff > 0) {
    return [].concat(_toConsumableArray(array4.slice(0, toIndex)), [item], _toConsumableArray(array4.slice(toIndex, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, length)));
  }
  if (diff < 0) {
    return [].concat(_toConsumableArray(array4.slice(0, moveIndex)), _toConsumableArray(array4.slice(moveIndex + 1, toIndex + 1)), [item], _toConsumableArray(array4.slice(toIndex + 1, length)));
  }
  return array4;
}
var AsyncValidator = Schema;
function replaceMessage(template, kv) {
  return template.replace(/\$\{\w+\}/g, function(str) {
    var key = str.slice(2, -1);
    return kv[key];
  });
}
function validateRule(_x, _x2, _x3, _x4, _x5) {
  return _validateRule.apply(this, arguments);
}
function _validateRule() {
  _validateRule = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee2(name, value, rule, options, messageVariables) {
    var cloneRule, subRuleField, validator, messages2, result, subResults, kv, fillVariableResult;
    return regenerator.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cloneRule = _objectSpread2({}, rule);
            delete cloneRule.ruleIndex;
            subRuleField = null;
            if (cloneRule && cloneRule.type === "array" && cloneRule.defaultField) {
              subRuleField = cloneRule.defaultField;
              delete cloneRule.defaultField;
            }
            validator = new AsyncValidator(_defineProperty({}, name, [cloneRule]));
            messages2 = setValues({}, defaultValidateMessages, options.validateMessages);
            validator.messages(messages2);
            result = [];
            _context2.prev = 8;
            _context2.next = 11;
            return Promise.resolve(validator.validate(_defineProperty({}, name, value), _objectSpread2({}, options)));
          case 11:
            _context2.next = 16;
            break;
          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](8);
            if (_context2.t0.errors) {
              result = _context2.t0.errors.map(function(_ref4, index2) {
                var message = _ref4.message;
                return /* @__PURE__ */ React.isValidElement(message) ? /* @__PURE__ */ React.cloneElement(message, {
                  key: "error_".concat(index2)
                }) : message;
              });
            } else {
              console.error(_context2.t0);
              result = [messages2.default];
            }
          case 16:
            if (!(!result.length && subRuleField)) {
              _context2.next = 21;
              break;
            }
            _context2.next = 19;
            return Promise.all(value.map(function(subValue, i) {
              return validateRule("".concat(name, ".").concat(i), subValue, subRuleField, options, messageVariables);
            }));
          case 19:
            subResults = _context2.sent;
            return _context2.abrupt("return", subResults.reduce(function(prev, errors) {
              return [].concat(_toConsumableArray(prev), _toConsumableArray(errors));
            }, []));
          case 21:
            kv = _objectSpread2(_objectSpread2({}, rule), {}, {
              name,
              enum: (rule.enum || []).join(", ")
            }, messageVariables);
            fillVariableResult = result.map(function(error) {
              if (typeof error === "string") {
                return replaceMessage(error, kv);
              }
              return error;
            });
            return _context2.abrupt("return", fillVariableResult);
          case 24:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[8, 13]]);
  }));
  return _validateRule.apply(this, arguments);
}
function validateRules(namePath, value, rules2, options, validateFirst, messageVariables) {
  var name = namePath.join(".");
  var filledRules = rules2.map(function(currentRule, ruleIndex) {
    var originValidatorFunc = currentRule.validator;
    var cloneRule = _objectSpread2(_objectSpread2({}, currentRule), {}, {
      ruleIndex
    });
    if (originValidatorFunc) {
      cloneRule.validator = function(rule, val, callback) {
        var hasPromise = false;
        var wrappedCallback = function wrappedCallback2() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          Promise.resolve().then(function() {
            warningOnce(!hasPromise, "Your validator function has already return a promise. `callback` will be ignored.");
            if (!hasPromise) {
              callback.apply(void 0, args);
            }
          });
        };
        var promise = originValidatorFunc(rule, val, wrappedCallback);
        hasPromise = promise && typeof promise.then === "function" && typeof promise.catch === "function";
        warningOnce(hasPromise, "`callback` is deprecated. Please return a promise instead.");
        if (hasPromise) {
          promise.then(function() {
            callback();
          }).catch(function(err) {
            callback(err || " ");
          });
        }
      };
    }
    return cloneRule;
  }).sort(function(_ref, _ref2) {
    var w1 = _ref.warningOnly, i1 = _ref.ruleIndex;
    var w2 = _ref2.warningOnly, i2 = _ref2.ruleIndex;
    if (!!w1 === !!w2) {
      return i1 - i2;
    }
    if (w1) {
      return 1;
    }
    return -1;
  });
  var summaryPromise;
  if (validateFirst === true) {
    summaryPromise = new Promise(/* @__PURE__ */ function() {
      var _ref3 = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee(resolve, reject) {
        var i, rule, errors;
        return regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                i = 0;
              case 1:
                if (!(i < filledRules.length)) {
                  _context.next = 12;
                  break;
                }
                rule = filledRules[i];
                _context.next = 5;
                return validateRule(name, value, rule, options, messageVariables);
              case 5:
                errors = _context.sent;
                if (!errors.length) {
                  _context.next = 9;
                  break;
                }
                reject([{
                  errors,
                  rule
                }]);
                return _context.abrupt("return");
              case 9:
                i += 1;
                _context.next = 1;
                break;
              case 12:
                resolve([]);
              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return function(_x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }());
  } else {
    var rulePromises = filledRules.map(function(rule) {
      return validateRule(name, value, rule, options, messageVariables).then(function(errors) {
        return {
          errors,
          rule
        };
      });
    });
    summaryPromise = (validateFirst ? finishOnFirstFailed(rulePromises) : finishOnAllFailed(rulePromises)).then(function(errors) {
      return Promise.reject(errors);
    });
  }
  summaryPromise.catch(function(e2) {
    return e2;
  });
  return summaryPromise;
}
function finishOnAllFailed(_x8) {
  return _finishOnAllFailed.apply(this, arguments);
}
function _finishOnAllFailed() {
  _finishOnAllFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee3(rulePromises) {
    return regenerator.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", Promise.all(rulePromises).then(function(errorsList) {
              var _ref5;
              var errors = (_ref5 = []).concat.apply(_ref5, _toConsumableArray(errorsList));
              return errors;
            }));
          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _finishOnAllFailed.apply(this, arguments);
}
function finishOnFirstFailed(_x9) {
  return _finishOnFirstFailed.apply(this, arguments);
}
function _finishOnFirstFailed() {
  _finishOnFirstFailed = _asyncToGenerator(/* @__PURE__ */ regenerator.mark(function _callee4(rulePromises) {
    var count2;
    return regenerator.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            count2 = 0;
            return _context4.abrupt("return", new Promise(function(resolve) {
              rulePromises.forEach(function(promise) {
                promise.then(function(ruleError) {
                  if (ruleError.errors.length) {
                    resolve([ruleError]);
                  }
                  count2 += 1;
                  if (count2 === rulePromises.length) {
                    resolve([]);
                  }
                });
              });
            }));
          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _finishOnFirstFailed.apply(this, arguments);
}
var _excluded$2 = ["name"];
var EMPTY_ERRORS = [];
function requireUpdate(shouldUpdate, prev, next, prevValue, nextValue, info) {
  if (typeof shouldUpdate === "function") {
    return shouldUpdate(prev, next, "source" in info ? {
      source: info.source
    } : {});
  }
  return prevValue !== nextValue;
}
var Field = /* @__PURE__ */ function(_React$Component) {
  _inherits(Field2, _React$Component);
  var _super = _createSuper(Field2);
  function Field2(props) {
    var _this;
    _classCallCheck(this, Field2);
    _this = _super.call(this, props);
    _this.state = {
      resetCount: 0
    };
    _this.cancelRegisterFunc = null;
    _this.mounted = false;
    _this.touched = false;
    _this.dirty = false;
    _this.validatePromise = null;
    _this.prevValidating = void 0;
    _this.errors = EMPTY_ERRORS;
    _this.warnings = EMPTY_ERRORS;
    _this.cancelRegister = function() {
      var _this$props = _this.props, preserve = _this$props.preserve, isListField = _this$props.isListField, name = _this$props.name;
      if (_this.cancelRegisterFunc) {
        _this.cancelRegisterFunc(isListField, preserve, getNamePath(name));
      }
      _this.cancelRegisterFunc = null;
    };
    _this.getNamePath = function() {
      var _this$props2 = _this.props, name = _this$props2.name, fieldContext = _this$props2.fieldContext;
      var _fieldContext$prefixN = fieldContext.prefixName, prefixName = _fieldContext$prefixN === void 0 ? [] : _fieldContext$prefixN;
      return name !== void 0 ? [].concat(_toConsumableArray(prefixName), _toConsumableArray(name)) : [];
    };
    _this.getRules = function() {
      var _this$props3 = _this.props, _this$props3$rules = _this$props3.rules, rules2 = _this$props3$rules === void 0 ? [] : _this$props3$rules, fieldContext = _this$props3.fieldContext;
      return rules2.map(function(rule) {
        if (typeof rule === "function") {
          return rule(fieldContext);
        }
        return rule;
      });
    };
    _this.refresh = function() {
      if (!_this.mounted)
        return;
      _this.setState(function(_ref) {
        var resetCount = _ref.resetCount;
        return {
          resetCount: resetCount + 1
        };
      });
    };
    _this.triggerMetaEvent = function(destroy) {
      var onMetaChange = _this.props.onMetaChange;
      onMetaChange === null || onMetaChange === void 0 ? void 0 : onMetaChange(_objectSpread2(_objectSpread2({}, _this.getMeta()), {}, {
        destroy
      }));
    };
    _this.onStoreChange = function(prevStore, namePathList, info) {
      var _this$props4 = _this.props, shouldUpdate = _this$props4.shouldUpdate, _this$props4$dependen = _this$props4.dependencies, dependencies = _this$props4$dependen === void 0 ? [] : _this$props4$dependen, onReset = _this$props4.onReset;
      var store = info.store;
      var namePath = _this.getNamePath();
      var prevValue = _this.getValue(prevStore);
      var curValue = _this.getValue(store);
      var namePathMatch = namePathList && containsNamePath(namePathList, namePath);
      if (info.type === "valueUpdate" && info.source === "external" && prevValue !== curValue) {
        _this.touched = true;
        _this.dirty = true;
        _this.validatePromise = null;
        _this.errors = EMPTY_ERRORS;
        _this.warnings = EMPTY_ERRORS;
        _this.triggerMetaEvent();
      }
      switch (info.type) {
        case "reset":
          if (!namePathList || namePathMatch) {
            _this.touched = false;
            _this.dirty = false;
            _this.validatePromise = null;
            _this.errors = EMPTY_ERRORS;
            _this.warnings = EMPTY_ERRORS;
            _this.triggerMetaEvent();
            onReset === null || onReset === void 0 ? void 0 : onReset();
            _this.refresh();
            return;
          }
          break;
        case "remove": {
          if (shouldUpdate) {
            _this.reRender();
            return;
          }
          break;
        }
        case "setField": {
          if (namePathMatch) {
            var data = info.data;
            if ("touched" in data) {
              _this.touched = data.touched;
            }
            if ("validating" in data && !("originRCField" in data)) {
              _this.validatePromise = data.validating ? Promise.resolve([]) : null;
            }
            if ("errors" in data) {
              _this.errors = data.errors || EMPTY_ERRORS;
            }
            if ("warnings" in data) {
              _this.warnings = data.warnings || EMPTY_ERRORS;
            }
            _this.dirty = true;
            _this.triggerMetaEvent();
            _this.reRender();
            return;
          }
          if (shouldUpdate && !namePath.length && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
        }
        case "dependenciesUpdate": {
          var dependencyList = dependencies.map(getNamePath);
          if (dependencyList.some(function(dependency) {
            return containsNamePath(info.relatedFields, dependency);
          })) {
            _this.reRender();
            return;
          }
          break;
        }
        default:
          if (namePathMatch || (!dependencies.length || namePath.length || shouldUpdate) && requireUpdate(shouldUpdate, prevStore, store, prevValue, curValue, info)) {
            _this.reRender();
            return;
          }
          break;
      }
      if (shouldUpdate === true) {
        _this.reRender();
      }
    };
    _this.validateRules = function(options) {
      var namePath = _this.getNamePath();
      var currentValue = _this.getValue();
      var rootPromise = Promise.resolve().then(function() {
        if (!_this.mounted) {
          return [];
        }
        var _this$props5 = _this.props, _this$props5$validate = _this$props5.validateFirst, validateFirst = _this$props5$validate === void 0 ? false : _this$props5$validate, messageVariables = _this$props5.messageVariables;
        var _ref2 = options || {}, triggerName = _ref2.triggerName;
        var filteredRules = _this.getRules();
        if (triggerName) {
          filteredRules = filteredRules.filter(function(rule) {
            var validateTrigger = rule.validateTrigger;
            if (!validateTrigger) {
              return true;
            }
            var triggerList = toArray(validateTrigger);
            return triggerList.includes(triggerName);
          });
        }
        var promise = validateRules(namePath, currentValue, filteredRules, options, validateFirst, messageVariables);
        promise.catch(function(e2) {
          return e2;
        }).then(function() {
          var ruleErrors = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : EMPTY_ERRORS;
          if (_this.validatePromise === rootPromise) {
            _this.validatePromise = null;
            var nextErrors = [];
            var nextWarnings = [];
            ruleErrors.forEach(function(_ref3) {
              var warningOnly = _ref3.rule.warningOnly, _ref3$errors = _ref3.errors, errors = _ref3$errors === void 0 ? EMPTY_ERRORS : _ref3$errors;
              if (warningOnly) {
                nextWarnings.push.apply(nextWarnings, _toConsumableArray(errors));
              } else {
                nextErrors.push.apply(nextErrors, _toConsumableArray(errors));
              }
            });
            _this.errors = nextErrors;
            _this.warnings = nextWarnings;
            _this.triggerMetaEvent();
            _this.reRender();
          }
        });
        return promise;
      });
      _this.validatePromise = rootPromise;
      _this.dirty = true;
      _this.errors = EMPTY_ERRORS;
      _this.warnings = EMPTY_ERRORS;
      _this.triggerMetaEvent();
      _this.reRender();
      return rootPromise;
    };
    _this.isFieldValidating = function() {
      return !!_this.validatePromise;
    };
    _this.isFieldTouched = function() {
      return _this.touched;
    };
    _this.isFieldDirty = function() {
      if (_this.dirty || _this.props.initialValue !== void 0) {
        return true;
      }
      var fieldContext = _this.props.fieldContext;
      var _fieldContext$getInte = fieldContext.getInternalHooks(HOOK_MARK), getInitialValue = _fieldContext$getInte.getInitialValue;
      if (getInitialValue(_this.getNamePath()) !== void 0) {
        return true;
      }
      return false;
    };
    _this.getErrors = function() {
      return _this.errors;
    };
    _this.getWarnings = function() {
      return _this.warnings;
    };
    _this.isListField = function() {
      return _this.props.isListField;
    };
    _this.isList = function() {
      return _this.props.isList;
    };
    _this.isPreserve = function() {
      return _this.props.preserve;
    };
    _this.getMeta = function() {
      _this.prevValidating = _this.isFieldValidating();
      var meta = {
        touched: _this.isFieldTouched(),
        validating: _this.prevValidating,
        errors: _this.errors,
        warnings: _this.warnings,
        name: _this.getNamePath()
      };
      return meta;
    };
    _this.getOnlyChild = function(children) {
      if (typeof children === "function") {
        var meta = _this.getMeta();
        return _objectSpread2(_objectSpread2({}, _this.getOnlyChild(children(_this.getControlled(), meta, _this.props.fieldContext))), {}, {
          isFunction: true
        });
      }
      var childList = toArray$1(children);
      if (childList.length !== 1 || !/* @__PURE__ */ React.isValidElement(childList[0])) {
        return {
          child: childList,
          isFunction: false
        };
      }
      return {
        child: childList[0],
        isFunction: false
      };
    };
    _this.getValue = function(store) {
      var getFieldsValue = _this.props.fieldContext.getFieldsValue;
      var namePath = _this.getNamePath();
      return getValue(store || getFieldsValue(true), namePath);
    };
    _this.getControlled = function() {
      var childProps = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      var _this$props6 = _this.props, trigger2 = _this$props6.trigger, validateTrigger = _this$props6.validateTrigger, getValueFromEvent = _this$props6.getValueFromEvent, normalize2 = _this$props6.normalize, valuePropName = _this$props6.valuePropName, getValueProps = _this$props6.getValueProps, fieldContext = _this$props6.fieldContext;
      var mergedValidateTrigger = validateTrigger !== void 0 ? validateTrigger : fieldContext.validateTrigger;
      var namePath = _this.getNamePath();
      var getInternalHooks3 = fieldContext.getInternalHooks, getFieldsValue = fieldContext.getFieldsValue;
      var _getInternalHooks = getInternalHooks3(HOOK_MARK), dispatch2 = _getInternalHooks.dispatch;
      var value = _this.getValue();
      var mergedGetValueProps = getValueProps || function(val) {
        return _defineProperty({}, valuePropName, val);
      };
      var originTriggerFunc = childProps[trigger2];
      var control = _objectSpread2(_objectSpread2({}, childProps), mergedGetValueProps(value));
      control[trigger2] = function() {
        _this.touched = true;
        _this.dirty = true;
        _this.triggerMetaEvent();
        var newValue;
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }
        if (getValueFromEvent) {
          newValue = getValueFromEvent.apply(void 0, args);
        } else {
          newValue = defaultGetValueFromEvent.apply(void 0, [valuePropName].concat(args));
        }
        if (normalize2) {
          newValue = normalize2(newValue, value, getFieldsValue(true));
        }
        dispatch2({
          type: "updateValue",
          namePath,
          value: newValue
        });
        if (originTriggerFunc) {
          originTriggerFunc.apply(void 0, args);
        }
      };
      var validateTriggerList = toArray(mergedValidateTrigger || []);
      validateTriggerList.forEach(function(triggerName) {
        var originTrigger = control[triggerName];
        control[triggerName] = function() {
          if (originTrigger) {
            originTrigger.apply(void 0, arguments);
          }
          var rules2 = _this.props.rules;
          if (rules2 && rules2.length) {
            dispatch2({
              type: "validateField",
              namePath,
              triggerName
            });
          }
        };
      });
      return control;
    };
    if (props.fieldContext) {
      var getInternalHooks2 = props.fieldContext.getInternalHooks;
      var _getInternalHooks2 = getInternalHooks2(HOOK_MARK), initEntityValue = _getInternalHooks2.initEntityValue;
      initEntityValue(_assertThisInitialized(_this));
    }
    return _this;
  }
  _createClass(Field2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props7 = this.props, shouldUpdate = _this$props7.shouldUpdate, fieldContext = _this$props7.fieldContext;
      this.mounted = true;
      if (fieldContext) {
        var getInternalHooks2 = fieldContext.getInternalHooks;
        var _getInternalHooks3 = getInternalHooks2(HOOK_MARK), registerField = _getInternalHooks3.registerField;
        this.cancelRegisterFunc = registerField(this);
      }
      if (shouldUpdate === true) {
        this.reRender();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.cancelRegister();
      this.triggerMetaEvent(true);
      this.mounted = false;
    }
  }, {
    key: "reRender",
    value: function reRender() {
      if (!this.mounted)
        return;
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render2() {
      var resetCount = this.state.resetCount;
      var children = this.props.children;
      var _this$getOnlyChild = this.getOnlyChild(children), child = _this$getOnlyChild.child, isFunction2 = _this$getOnlyChild.isFunction;
      var returnChildNode;
      if (isFunction2) {
        returnChildNode = child;
      } else if (/* @__PURE__ */ React.isValidElement(child)) {
        returnChildNode = /* @__PURE__ */ React.cloneElement(child, this.getControlled(child.props));
      } else {
        warningOnce(!child, "`children` of Field is not validate ReactElement.");
        returnChildNode = child;
      }
      return /* @__PURE__ */ React.createElement(React.Fragment, {
        key: resetCount
      }, returnChildNode);
    }
  }]);
  return Field2;
}(React.Component);
Field.contextType = Context;
Field.defaultProps = {
  trigger: "onChange",
  valuePropName: "value"
};
function WrapperField(_ref5) {
  var name = _ref5.name, restProps = _objectWithoutProperties(_ref5, _excluded$2);
  var fieldContext = React.useContext(Context);
  var namePath = name !== void 0 ? getNamePath(name) : void 0;
  var key = "keep";
  if (!restProps.isListField) {
    key = "_".concat((namePath || []).join("_"));
  }
  return /* @__PURE__ */ React.createElement(Field, _extends$1({
    key,
    name: namePath
  }, restProps, {
    fieldContext
  }));
}
var ListContext = /* @__PURE__ */ React.createContext(null);
var List = function List2(_ref) {
  var name = _ref.name, initialValue = _ref.initialValue, children = _ref.children, rules2 = _ref.rules, validateTrigger = _ref.validateTrigger;
  var context = React.useContext(Context);
  var keyRef = React.useRef({
    keys: [],
    id: 0
  });
  var keyManager = keyRef.current;
  var prefixName = React.useMemo(function() {
    var parentPrefixName = getNamePath(context.prefixName) || [];
    return [].concat(_toConsumableArray(parentPrefixName), _toConsumableArray(getNamePath(name)));
  }, [context.prefixName, name]);
  var fieldContext = React.useMemo(function() {
    return _objectSpread2(_objectSpread2({}, context), {}, {
      prefixName
    });
  }, [context, prefixName]);
  var listContext = React.useMemo(function() {
    return {
      getKey: function getKey2(namePath) {
        var len2 = prefixName.length;
        var pathName = namePath[len2];
        return [keyManager.keys[pathName], namePath.slice(len2 + 1)];
      }
    };
  }, [prefixName]);
  if (typeof children !== "function") {
    warningOnce(false, "Form.List only accepts function as children.");
    return null;
  }
  var shouldUpdate = function shouldUpdate2(prevValue, nextValue, _ref2) {
    var source = _ref2.source;
    if (source === "internal") {
      return false;
    }
    return prevValue !== nextValue;
  };
  return /* @__PURE__ */ React.createElement(ListContext.Provider, {
    value: listContext
  }, /* @__PURE__ */ React.createElement(Context.Provider, {
    value: fieldContext
  }, /* @__PURE__ */ React.createElement(WrapperField, {
    name: [],
    shouldUpdate,
    rules: rules2,
    validateTrigger,
    initialValue,
    isList: true
  }, function(_ref3, meta) {
    var _ref3$value = _ref3.value, value = _ref3$value === void 0 ? [] : _ref3$value, onChange = _ref3.onChange;
    var getFieldValue = context.getFieldValue;
    var getNewValue = function getNewValue2() {
      var values = getFieldValue(prefixName || []);
      return values || [];
    };
    var operations = {
      add: function add2(defaultValue, index2) {
        var newValue = getNewValue();
        if (index2 >= 0 && index2 <= newValue.length) {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys.slice(0, index2)), [keyManager.id], _toConsumableArray(keyManager.keys.slice(index2)));
          onChange([].concat(_toConsumableArray(newValue.slice(0, index2)), [defaultValue], _toConsumableArray(newValue.slice(index2))));
        } else {
          keyManager.keys = [].concat(_toConsumableArray(keyManager.keys), [keyManager.id]);
          onChange([].concat(_toConsumableArray(newValue), [defaultValue]));
        }
        keyManager.id += 1;
      },
      remove: function remove(index2) {
        var newValue = getNewValue();
        var indexSet = new Set(Array.isArray(index2) ? index2 : [index2]);
        if (indexSet.size <= 0) {
          return;
        }
        keyManager.keys = keyManager.keys.filter(function(_, keysIndex) {
          return !indexSet.has(keysIndex);
        });
        onChange(newValue.filter(function(_, valueIndex) {
          return !indexSet.has(valueIndex);
        }));
      },
      move: function move$1(from, to) {
        if (from === to) {
          return;
        }
        var newValue = getNewValue();
        if (from < 0 || from >= newValue.length || to < 0 || to >= newValue.length) {
          return;
        }
        keyManager.keys = move(keyManager.keys, from, to);
        onChange(move(newValue, from, to));
      }
    };
    var listValue = value || [];
    if (!Array.isArray(listValue)) {
      listValue = [];
    }
    return children(listValue.map(function(__, index2) {
      var key = keyManager.keys[index2];
      if (key === void 0) {
        keyManager.keys[index2] = keyManager.id;
        key = keyManager.keys[index2];
        keyManager.id += 1;
      }
      return {
        name: index2,
        key,
        isListField: true
      };
    }), operations, meta);
  })));
};
function allPromiseFinish(promiseList) {
  var hasError = false;
  var count2 = promiseList.length;
  var results = [];
  if (!promiseList.length) {
    return Promise.resolve([]);
  }
  return new Promise(function(resolve, reject) {
    promiseList.forEach(function(promise, index2) {
      promise.catch(function(e2) {
        hasError = true;
        return e2;
      }).then(function(result) {
        count2 -= 1;
        results[index2] = result;
        if (count2 > 0) {
          return;
        }
        if (hasError) {
          reject(results);
        }
        resolve(results);
      });
    });
  });
}
var SPLIT = "__@field_split__";
function normalize(namePath) {
  return namePath.map(function(cell) {
    return "".concat(_typeof(cell), ":").concat(cell);
  }).join(SPLIT);
}
var NameMap = /* @__PURE__ */ function() {
  function NameMap2() {
    _classCallCheck(this, NameMap2);
    this.kvs = /* @__PURE__ */ new Map();
  }
  _createClass(NameMap2, [{
    key: "set",
    value: function set2(key, value) {
      this.kvs.set(normalize(key), value);
    }
  }, {
    key: "get",
    value: function get2(key) {
      return this.kvs.get(normalize(key));
    }
  }, {
    key: "update",
    value: function update(key, updater) {
      var origin = this.get(key);
      var next = updater(origin);
      if (!next) {
        this.delete(key);
      } else {
        this.set(key, next);
      }
    }
  }, {
    key: "delete",
    value: function _delete(key) {
      this.kvs.delete(normalize(key));
    }
  }, {
    key: "map",
    value: function map2(callback) {
      return _toConsumableArray(this.kvs.entries()).map(function(_ref) {
        var _ref2 = _slicedToArray(_ref, 2), key = _ref2[0], value = _ref2[1];
        var cells = key.split(SPLIT);
        return callback({
          key: cells.map(function(cell) {
            var _cell$match = cell.match(/^([^:]*):(.*)$/), _cell$match2 = _slicedToArray(_cell$match, 3), type4 = _cell$match2[1], unit = _cell$match2[2];
            return type4 === "number" ? Number(unit) : unit;
          }),
          value
        });
      });
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = {};
      this.map(function(_ref3) {
        var key = _ref3.key, value = _ref3.value;
        json[key.join(".")] = value;
        return null;
      });
      return json;
    }
  }]);
  return NameMap2;
}();
var _excluded$1 = ["name", "errors"];
var FormStore = /* @__PURE__ */ _createClass(function FormStore2(forceRootUpdate) {
  var _this = this;
  _classCallCheck(this, FormStore2);
  this.formHooked = false;
  this.forceRootUpdate = void 0;
  this.subscribable = true;
  this.store = {};
  this.fieldEntities = [];
  this.initialValues = {};
  this.callbacks = {};
  this.validateMessages = null;
  this.preserve = null;
  this.lastValidatePromise = null;
  this.getForm = function() {
    return {
      getFieldValue: _this.getFieldValue,
      getFieldsValue: _this.getFieldsValue,
      getFieldError: _this.getFieldError,
      getFieldWarning: _this.getFieldWarning,
      getFieldsError: _this.getFieldsError,
      isFieldsTouched: _this.isFieldsTouched,
      isFieldTouched: _this.isFieldTouched,
      isFieldValidating: _this.isFieldValidating,
      isFieldsValidating: _this.isFieldsValidating,
      resetFields: _this.resetFields,
      setFields: _this.setFields,
      setFieldsValue: _this.setFieldsValue,
      validateFields: _this.validateFields,
      submit: _this.submit,
      getInternalHooks: _this.getInternalHooks
    };
  };
  this.getInternalHooks = function(key) {
    if (key === HOOK_MARK) {
      _this.formHooked = true;
      return {
        dispatch: _this.dispatch,
        initEntityValue: _this.initEntityValue,
        registerField: _this.registerField,
        useSubscribe: _this.useSubscribe,
        setInitialValues: _this.setInitialValues,
        setCallbacks: _this.setCallbacks,
        setValidateMessages: _this.setValidateMessages,
        getFields: _this.getFields,
        setPreserve: _this.setPreserve,
        getInitialValue: _this.getInitialValue
      };
    }
    warningOnce(false, "`getInternalHooks` is internal usage. Should not call directly.");
    return null;
  };
  this.useSubscribe = function(subscribable) {
    _this.subscribable = subscribable;
  };
  this.setInitialValues = function(initialValues, init2) {
    _this.initialValues = initialValues || {};
    if (init2) {
      _this.store = setValues({}, initialValues, _this.store);
    }
  };
  this.getInitialValue = function(namePath) {
    return getValue(_this.initialValues, namePath);
  };
  this.setCallbacks = function(callbacks) {
    _this.callbacks = callbacks;
  };
  this.setValidateMessages = function(validateMessages) {
    _this.validateMessages = validateMessages;
  };
  this.setPreserve = function(preserve) {
    _this.preserve = preserve;
  };
  this.timeoutId = null;
  this.warningUnhooked = function() {
  };
  this.getFieldEntities = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    if (!pure) {
      return _this.fieldEntities;
    }
    return _this.fieldEntities.filter(function(field) {
      return field.getNamePath().length;
    });
  };
  this.getFieldsMap = function() {
    var pure = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
    var cache = new NameMap();
    _this.getFieldEntities(pure).forEach(function(field) {
      var namePath = field.getNamePath();
      cache.set(namePath, field);
    });
    return cache;
  };
  this.getFieldEntitiesForNamePathList = function(nameList) {
    if (!nameList) {
      return _this.getFieldEntities(true);
    }
    var cache = _this.getFieldsMap(true);
    return nameList.map(function(name) {
      var namePath = getNamePath(name);
      return cache.get(namePath) || {
        INVALIDATE_NAME_PATH: getNamePath(name)
      };
    });
  };
  this.getFieldsValue = function(nameList, filterFunc) {
    _this.warningUnhooked();
    if (nameList === true && !filterFunc) {
      return _this.store;
    }
    var fieldEntities = _this.getFieldEntitiesForNamePathList(Array.isArray(nameList) ? nameList : null);
    var filteredNameList = [];
    fieldEntities.forEach(function(entity) {
      var _entity$isListField;
      var namePath = "INVALIDATE_NAME_PATH" in entity ? entity.INVALIDATE_NAME_PATH : entity.getNamePath();
      if (!nameList && ((_entity$isListField = entity.isListField) === null || _entity$isListField === void 0 ? void 0 : _entity$isListField.call(entity))) {
        return;
      }
      if (!filterFunc) {
        filteredNameList.push(namePath);
      } else {
        var meta = "getMeta" in entity ? entity.getMeta() : null;
        if (filterFunc(meta)) {
          filteredNameList.push(namePath);
        }
      }
    });
    return cloneByNamePathList(_this.store, filteredNameList.map(getNamePath));
  };
  this.getFieldValue = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    return getValue(_this.store, namePath);
  };
  this.getFieldsError = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntitiesForNamePathList(nameList);
    return fieldEntities.map(function(entity, index2) {
      if (entity && !("INVALIDATE_NAME_PATH" in entity)) {
        return {
          name: entity.getNamePath(),
          errors: entity.getErrors(),
          warnings: entity.getWarnings()
        };
      }
      return {
        name: getNamePath(nameList[index2]),
        errors: [],
        warnings: []
      };
    });
  };
  this.getFieldError = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.errors;
  };
  this.getFieldWarning = function(name) {
    _this.warningUnhooked();
    var namePath = getNamePath(name);
    var fieldError = _this.getFieldsError([namePath])[0];
    return fieldError.warnings;
  };
  this.isFieldsTouched = function() {
    _this.warningUnhooked();
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var arg0 = args[0], arg1 = args[1];
    var namePathList;
    var isAllFieldsTouched = false;
    if (args.length === 0) {
      namePathList = null;
    } else if (args.length === 1) {
      if (Array.isArray(arg0)) {
        namePathList = arg0.map(getNamePath);
        isAllFieldsTouched = false;
      } else {
        namePathList = null;
        isAllFieldsTouched = arg0;
      }
    } else {
      namePathList = arg0.map(getNamePath);
      isAllFieldsTouched = arg1;
    }
    var fieldEntities = _this.getFieldEntities(true);
    var isFieldTouched = function isFieldTouched2(field) {
      return field.isFieldTouched();
    };
    if (!namePathList) {
      return isAllFieldsTouched ? fieldEntities.every(isFieldTouched) : fieldEntities.some(isFieldTouched);
    }
    var map2 = new NameMap();
    namePathList.forEach(function(shortNamePath) {
      map2.set(shortNamePath, []);
    });
    fieldEntities.forEach(function(field) {
      var fieldNamePath = field.getNamePath();
      namePathList.forEach(function(shortNamePath) {
        if (shortNamePath.every(function(nameUnit, i) {
          return fieldNamePath[i] === nameUnit;
        })) {
          map2.update(shortNamePath, function(list) {
            return [].concat(_toConsumableArray(list), [field]);
          });
        }
      });
    });
    var isNamePathListTouched = function isNamePathListTouched2(entities) {
      return entities.some(isFieldTouched);
    };
    var namePathListEntities = map2.map(function(_ref) {
      var value = _ref.value;
      return value;
    });
    return isAllFieldsTouched ? namePathListEntities.every(isNamePathListTouched) : namePathListEntities.some(isNamePathListTouched);
  };
  this.isFieldTouched = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsTouched([name]);
  };
  this.isFieldsValidating = function(nameList) {
    _this.warningUnhooked();
    var fieldEntities = _this.getFieldEntities();
    if (!nameList) {
      return fieldEntities.some(function(testField) {
        return testField.isFieldValidating();
      });
    }
    var namePathList = nameList.map(getNamePath);
    return fieldEntities.some(function(testField) {
      var fieldNamePath = testField.getNamePath();
      return containsNamePath(namePathList, fieldNamePath) && testField.isFieldValidating();
    });
  };
  this.isFieldValidating = function(name) {
    _this.warningUnhooked();
    return _this.isFieldsValidating([name]);
  };
  this.resetWithFieldInitialValue = function() {
    var info = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var cache = new NameMap();
    var fieldEntities = _this.getFieldEntities(true);
    fieldEntities.forEach(function(field) {
      var initialValue = field.props.initialValue;
      var namePath = field.getNamePath();
      if (initialValue !== void 0) {
        var records = cache.get(namePath) || /* @__PURE__ */ new Set();
        records.add({
          entity: field,
          value: initialValue
        });
        cache.set(namePath, records);
      }
    });
    var resetWithFields = function resetWithFields2(entities) {
      entities.forEach(function(field) {
        var initialValue = field.props.initialValue;
        if (initialValue !== void 0) {
          var namePath = field.getNamePath();
          var formInitialValue = _this.getInitialValue(namePath);
          if (formInitialValue !== void 0) {
            warningOnce(false, "Form already set 'initialValues' with path '".concat(namePath.join("."), "'. Field can not overwrite it."));
          } else {
            var records = cache.get(namePath);
            if (records && records.size > 1) {
              warningOnce(false, "Multiple Field with path '".concat(namePath.join("."), "' set 'initialValue'. Can not decide which one to pick."));
            } else if (records) {
              var originValue = _this.getFieldValue(namePath);
              if (!info.skipExist || originValue === void 0) {
                _this.store = setValue(_this.store, namePath, _toConsumableArray(records)[0].value);
              }
            }
          }
        }
      });
    };
    var requiredFieldEntities;
    if (info.entities) {
      requiredFieldEntities = info.entities;
    } else if (info.namePathList) {
      requiredFieldEntities = [];
      info.namePathList.forEach(function(namePath) {
        var records = cache.get(namePath);
        if (records) {
          var _requiredFieldEntitie;
          (_requiredFieldEntitie = requiredFieldEntities).push.apply(_requiredFieldEntitie, _toConsumableArray(_toConsumableArray(records).map(function(r2) {
            return r2.entity;
          })));
        }
      });
    } else {
      requiredFieldEntities = fieldEntities;
    }
    resetWithFields(requiredFieldEntities);
  };
  this.resetFields = function(nameList) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (!nameList) {
      _this.store = setValues({}, _this.initialValues);
      _this.resetWithFieldInitialValue();
      _this.notifyObservers(prevStore, null, {
        type: "reset"
      });
      return;
    }
    var namePathList = nameList.map(getNamePath);
    namePathList.forEach(function(namePath) {
      var initialValue = _this.getInitialValue(namePath);
      _this.store = setValue(_this.store, namePath, initialValue);
    });
    _this.resetWithFieldInitialValue({
      namePathList
    });
    _this.notifyObservers(prevStore, namePathList, {
      type: "reset"
    });
  };
  this.setFields = function(fields) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    fields.forEach(function(fieldData) {
      var name = fieldData.name;
      fieldData.errors;
      var data = _objectWithoutProperties(fieldData, _excluded$1);
      var namePath = getNamePath(name);
      if ("value" in data) {
        _this.store = setValue(_this.store, namePath, data.value);
      }
      _this.notifyObservers(prevStore, [namePath], {
        type: "setField",
        data: fieldData
      });
    });
  };
  this.getFields = function() {
    var entities = _this.getFieldEntities(true);
    var fields = entities.map(function(field) {
      var namePath = field.getNamePath();
      var meta = field.getMeta();
      var fieldData = _objectSpread2(_objectSpread2({}, meta), {}, {
        name: namePath,
        value: _this.getFieldValue(namePath)
      });
      Object.defineProperty(fieldData, "originRCField", {
        value: true
      });
      return fieldData;
    });
    return fields;
  };
  this.initEntityValue = function(entity) {
    var initialValue = entity.props.initialValue;
    if (initialValue !== void 0) {
      var namePath = entity.getNamePath();
      var prevValue = getValue(_this.store, namePath);
      if (prevValue === void 0) {
        _this.store = setValue(_this.store, namePath, initialValue);
      }
    }
  };
  this.registerField = function(entity) {
    _this.fieldEntities.push(entity);
    if (entity.props.initialValue !== void 0) {
      var prevStore = _this.store;
      _this.resetWithFieldInitialValue({
        entities: [entity],
        skipExist: true
      });
      _this.notifyObservers(prevStore, [entity.getNamePath()], {
        type: "valueUpdate",
        source: "internal"
      });
    }
    return function(isListField, preserve) {
      var subNamePath = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
      _this.fieldEntities = _this.fieldEntities.filter(function(item) {
        return item !== entity;
      });
      var mergedPreserve = preserve !== void 0 ? preserve : _this.preserve;
      if (mergedPreserve === false && (!isListField || subNamePath.length > 1)) {
        var namePath = entity.getNamePath();
        var defaultValue = isListField ? void 0 : getValue(_this.initialValues, namePath);
        if (namePath.length && _this.getFieldValue(namePath) !== defaultValue && _this.fieldEntities.every(function(field) {
          return !matchNamePath(field.getNamePath(), namePath);
        })) {
          var _prevStore = _this.store;
          _this.store = setValue(_prevStore, namePath, defaultValue, true);
          _this.notifyObservers(_prevStore, [namePath], {
            type: "remove"
          });
          _this.triggerDependenciesUpdate(_prevStore, namePath);
        }
      }
    };
  };
  this.dispatch = function(action) {
    switch (action.type) {
      case "updateValue": {
        var namePath = action.namePath, value = action.value;
        _this.updateValue(namePath, value);
        break;
      }
      case "validateField": {
        var _namePath = action.namePath, triggerName = action.triggerName;
        _this.validateFields([_namePath], {
          triggerName
        });
        break;
      }
    }
  };
  this.notifyObservers = function(prevStore, namePathList, info) {
    if (_this.subscribable) {
      var mergedInfo = _objectSpread2(_objectSpread2({}, info), {}, {
        store: _this.getFieldsValue(true)
      });
      _this.getFieldEntities().forEach(function(_ref2) {
        var onStoreChange = _ref2.onStoreChange;
        onStoreChange(prevStore, namePathList, mergedInfo);
      });
    } else {
      _this.forceRootUpdate();
    }
  };
  this.triggerDependenciesUpdate = function(prevStore, namePath) {
    var childrenFields = _this.getDependencyChildrenFields(namePath);
    if (childrenFields.length) {
      _this.validateFields(childrenFields);
    }
    _this.notifyObservers(prevStore, childrenFields, {
      type: "dependenciesUpdate",
      relatedFields: [namePath].concat(_toConsumableArray(childrenFields))
    });
    return childrenFields;
  };
  this.updateValue = function(name, value) {
    var namePath = getNamePath(name);
    var prevStore = _this.store;
    _this.store = setValue(_this.store, namePath, value);
    _this.notifyObservers(prevStore, [namePath], {
      type: "valueUpdate",
      source: "internal"
    });
    var childrenFields = _this.triggerDependenciesUpdate(prevStore, namePath);
    var onValuesChange = _this.callbacks.onValuesChange;
    if (onValuesChange) {
      var changedValues = cloneByNamePathList(_this.store, [namePath]);
      onValuesChange(changedValues, _this.getFieldsValue());
    }
    _this.triggerOnFieldsChange([namePath].concat(_toConsumableArray(childrenFields)));
  };
  this.setFieldsValue = function(store) {
    _this.warningUnhooked();
    var prevStore = _this.store;
    if (store) {
      _this.store = setValues(_this.store, store);
    }
    _this.notifyObservers(prevStore, null, {
      type: "valueUpdate",
      source: "external"
    });
  };
  this.getDependencyChildrenFields = function(rootNamePath) {
    var children = /* @__PURE__ */ new Set();
    var childrenFields = [];
    var dependencies2fields = new NameMap();
    _this.getFieldEntities().forEach(function(field) {
      var dependencies = field.props.dependencies;
      (dependencies || []).forEach(function(dependency) {
        var dependencyNamePath = getNamePath(dependency);
        dependencies2fields.update(dependencyNamePath, function() {
          var fields = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
          fields.add(field);
          return fields;
        });
      });
    });
    var fillChildren = function fillChildren2(namePath) {
      var fields = dependencies2fields.get(namePath) || /* @__PURE__ */ new Set();
      fields.forEach(function(field) {
        if (!children.has(field)) {
          children.add(field);
          var fieldNamePath = field.getNamePath();
          if (field.isFieldDirty() && fieldNamePath.length) {
            childrenFields.push(fieldNamePath);
            fillChildren2(fieldNamePath);
          }
        }
      });
    };
    fillChildren(rootNamePath);
    return childrenFields;
  };
  this.triggerOnFieldsChange = function(namePathList, filedErrors) {
    var onFieldsChange = _this.callbacks.onFieldsChange;
    if (onFieldsChange) {
      var fields = _this.getFields();
      if (filedErrors) {
        var cache = new NameMap();
        filedErrors.forEach(function(_ref3) {
          var name = _ref3.name, errors = _ref3.errors;
          cache.set(name, errors);
        });
        fields.forEach(function(field) {
          field.errors = cache.get(field.name) || field.errors;
        });
      }
      var changedFields = fields.filter(function(_ref4) {
        var fieldName = _ref4.name;
        return containsNamePath(namePathList, fieldName);
      });
      onFieldsChange(changedFields, fields);
    }
  };
  this.validateFields = function(nameList, options) {
    _this.warningUnhooked();
    var provideNameList = !!nameList;
    var namePathList = provideNameList ? nameList.map(getNamePath) : [];
    var promiseList = [];
    _this.getFieldEntities(true).forEach(function(field) {
      if (!provideNameList) {
        namePathList.push(field.getNamePath());
      }
      if ((options === null || options === void 0 ? void 0 : options.recursive) && provideNameList) {
        var namePath = field.getNamePath();
        if (namePath.every(function(nameUnit, i) {
          return nameList[i] === nameUnit || nameList[i] === void 0;
        })) {
          namePathList.push(namePath);
        }
      }
      if (!field.props.rules || !field.props.rules.length) {
        return;
      }
      var fieldNamePath = field.getNamePath();
      if (!provideNameList || containsNamePath(namePathList, fieldNamePath)) {
        var promise = field.validateRules(_objectSpread2({
          validateMessages: _objectSpread2(_objectSpread2({}, defaultValidateMessages), _this.validateMessages)
        }, options));
        promiseList.push(promise.then(function() {
          return {
            name: fieldNamePath,
            errors: [],
            warnings: []
          };
        }).catch(function(ruleErrors) {
          var mergedErrors = [];
          var mergedWarnings = [];
          ruleErrors.forEach(function(_ref5) {
            var warningOnly = _ref5.rule.warningOnly, errors = _ref5.errors;
            if (warningOnly) {
              mergedWarnings.push.apply(mergedWarnings, _toConsumableArray(errors));
            } else {
              mergedErrors.push.apply(mergedErrors, _toConsumableArray(errors));
            }
          });
          if (mergedErrors.length) {
            return Promise.reject({
              name: fieldNamePath,
              errors: mergedErrors,
              warnings: mergedWarnings
            });
          }
          return {
            name: fieldNamePath,
            errors: mergedErrors,
            warnings: mergedWarnings
          };
        }));
      }
    });
    var summaryPromise = allPromiseFinish(promiseList);
    _this.lastValidatePromise = summaryPromise;
    summaryPromise.catch(function(results) {
      return results;
    }).then(function(results) {
      var resultNamePathList = results.map(function(_ref6) {
        var name = _ref6.name;
        return name;
      });
      _this.notifyObservers(_this.store, resultNamePathList, {
        type: "validateFinish"
      });
      _this.triggerOnFieldsChange(resultNamePathList, results);
    });
    var returnPromise = summaryPromise.then(function() {
      if (_this.lastValidatePromise === summaryPromise) {
        return Promise.resolve(_this.getFieldsValue(namePathList));
      }
      return Promise.reject([]);
    }).catch(function(results) {
      var errorList = results.filter(function(result) {
        return result && result.errors.length;
      });
      return Promise.reject({
        values: _this.getFieldsValue(namePathList),
        errorFields: errorList,
        outOfDate: _this.lastValidatePromise !== summaryPromise
      });
    });
    returnPromise.catch(function(e2) {
      return e2;
    });
    return returnPromise;
  };
  this.submit = function() {
    _this.warningUnhooked();
    _this.validateFields().then(function(values) {
      var onFinish = _this.callbacks.onFinish;
      if (onFinish) {
        try {
          onFinish(values);
        } catch (err) {
          console.error(err);
        }
      }
    }).catch(function(e2) {
      var onFinishFailed = _this.callbacks.onFinishFailed;
      if (onFinishFailed) {
        onFinishFailed(e2);
      }
    });
  };
  this.forceRootUpdate = forceRootUpdate;
});
function useForm(form) {
  var formRef = React.useRef();
  var _React$useState = React.useState({}), _React$useState2 = _slicedToArray(_React$useState, 2), forceUpdate = _React$useState2[1];
  if (!formRef.current) {
    if (form) {
      formRef.current = form;
    } else {
      var forceReRender = function forceReRender2() {
        forceUpdate({});
      };
      var formStore = new FormStore(forceReRender);
      formRef.current = formStore.getForm();
    }
  }
  return [formRef.current];
}
var FormContext = /* @__PURE__ */ React.createContext({
  triggerFormChange: function triggerFormChange() {
  },
  triggerFormFinish: function triggerFormFinish() {
  },
  registerForm: function registerForm() {
  },
  unregisterForm: function unregisterForm() {
  }
});
var FormProvider = function FormProvider2(_ref) {
  var validateMessages = _ref.validateMessages, onFormChange = _ref.onFormChange, onFormFinish = _ref.onFormFinish, children = _ref.children;
  var formContext = React.useContext(FormContext);
  var formsRef = React.useRef({});
  return /* @__PURE__ */ React.createElement(FormContext.Provider, {
    value: _objectSpread2(_objectSpread2({}, formContext), {}, {
      validateMessages: _objectSpread2(_objectSpread2({}, formContext.validateMessages), validateMessages),
      triggerFormChange: function triggerFormChange2(name, changedFields) {
        if (onFormChange) {
          onFormChange(name, {
            changedFields,
            forms: formsRef.current
          });
        }
        formContext.triggerFormChange(name, changedFields);
      },
      triggerFormFinish: function triggerFormFinish2(name, values) {
        if (onFormFinish) {
          onFormFinish(name, {
            values,
            forms: formsRef.current
          });
        }
        formContext.triggerFormFinish(name, values);
      },
      registerForm: function registerForm2(name, form) {
        if (name) {
          formsRef.current = _objectSpread2(_objectSpread2({}, formsRef.current), {}, _defineProperty({}, name, form));
        }
        formContext.registerForm(name, form);
      },
      unregisterForm: function unregisterForm2(name) {
        var newForms = _objectSpread2({}, formsRef.current);
        delete newForms[name];
        formsRef.current = newForms;
        formContext.unregisterForm(name);
      }
    })
  }, children);
};
var _excluded = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"];
var Form = function Form2(_ref, ref) {
  var name = _ref.name, initialValues = _ref.initialValues, fields = _ref.fields, form = _ref.form, preserve = _ref.preserve, children = _ref.children, _ref$component = _ref.component, Component = _ref$component === void 0 ? "form" : _ref$component, validateMessages = _ref.validateMessages, _ref$validateTrigger = _ref.validateTrigger, validateTrigger = _ref$validateTrigger === void 0 ? "onChange" : _ref$validateTrigger, onValuesChange = _ref.onValuesChange, _onFieldsChange = _ref.onFieldsChange, _onFinish = _ref.onFinish, onFinishFailed = _ref.onFinishFailed, restProps = _objectWithoutProperties(_ref, _excluded);
  var formContext = React.useContext(FormContext);
  var _useForm = useForm(form), _useForm2 = _slicedToArray(_useForm, 1), formInstance = _useForm2[0];
  var _formInstance$getInte = formInstance.getInternalHooks(HOOK_MARK), useSubscribe = _formInstance$getInte.useSubscribe, setInitialValues = _formInstance$getInte.setInitialValues, setCallbacks = _formInstance$getInte.setCallbacks, setValidateMessages = _formInstance$getInte.setValidateMessages, setPreserve = _formInstance$getInte.setPreserve;
  React.useImperativeHandle(ref, function() {
    return formInstance;
  });
  React.useEffect(function() {
    formContext.registerForm(name, formInstance);
    return function() {
      formContext.unregisterForm(name);
    };
  }, [formContext, formInstance, name]);
  setValidateMessages(_objectSpread2(_objectSpread2({}, formContext.validateMessages), validateMessages));
  setCallbacks({
    onValuesChange,
    onFieldsChange: function onFieldsChange(changedFields) {
      formContext.triggerFormChange(name, changedFields);
      if (_onFieldsChange) {
        for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          rest[_key - 1] = arguments[_key];
        }
        _onFieldsChange.apply(void 0, [changedFields].concat(rest));
      }
    },
    onFinish: function onFinish(values2) {
      formContext.triggerFormFinish(name, values2);
      if (_onFinish) {
        _onFinish(values2);
      }
    },
    onFinishFailed
  });
  setPreserve(preserve);
  var mountRef = React.useRef(null);
  setInitialValues(initialValues, !mountRef.current);
  if (!mountRef.current) {
    mountRef.current = true;
  }
  var childrenNode = children;
  var childrenRenderProps = typeof children === "function";
  if (childrenRenderProps) {
    var values = formInstance.getFieldsValue(true);
    childrenNode = children(values, formInstance);
  }
  useSubscribe(!childrenRenderProps);
  var prevFieldsRef = React.useRef();
  React.useEffect(function() {
    if (!isSimilar(prevFieldsRef.current || [], fields || [])) {
      formInstance.setFields(fields || []);
    }
    prevFieldsRef.current = fields;
  }, [fields, formInstance]);
  var formContextValue = React.useMemo(function() {
    return _objectSpread2(_objectSpread2({}, formInstance), {}, {
      validateTrigger
    });
  }, [formInstance, validateTrigger]);
  var wrapperNode = /* @__PURE__ */ React.createElement(Context.Provider, {
    value: formContextValue
  }, childrenNode);
  if (Component === false) {
    return wrapperNode;
  }
  return /* @__PURE__ */ React.createElement(Component, _extends$1({}, restProps, {
    onSubmit: function onSubmit(event) {
      event.preventDefault();
      event.stopPropagation();
      formInstance.submit();
    },
    onReset: function onReset(event) {
      var _restProps$onReset;
      event.preventDefault();
      formInstance.resetFields();
      (_restProps$onReset = restProps.onReset) === null || _restProps$onReset === void 0 ? void 0 : _restProps$onReset.call(restProps, event);
    }
  }), wrapperNode);
};
var InternalForm = /* @__PURE__ */ React.forwardRef(Form);
var RefForm = InternalForm;
RefForm.FormProvider = FormProvider;
RefForm.Field = WrapperField;
RefForm.List = List;
RefForm.useForm = useForm;
var devWarning = function(valid, component, message) {
  warningOnce(valid, "[antd: ".concat(component, "] ").concat(message));
};
var enUS$1 = {
  items_per_page: "/ page",
  jump_to: "Go to",
  jump_to_confirm: "confirm",
  page: "Page",
  prev_page: "Previous Page",
  next_page: "Next Page",
  prev_5: "Previous 5 Pages",
  next_5: "Next 5 Pages",
  prev_3: "Previous 3 Pages",
  next_3: "Next 3 Pages",
  page_size: "Page Size"
};
var locale$2 = {
  locale: "en_US",
  today: "Today",
  now: "Now",
  backToToday: "Back to today",
  ok: "Ok",
  clear: "Clear",
  month: "Month",
  year: "Year",
  timeSelect: "select time",
  dateSelect: "select date",
  weekSelect: "Choose a week",
  monthSelect: "Choose a month",
  yearSelect: "Choose a year",
  decadeSelect: "Choose a decade",
  yearFormat: "YYYY",
  dateFormat: "M/D/YYYY",
  dayFormat: "D",
  dateTimeFormat: "M/D/YYYY HH:mm:ss",
  monthBeforeYear: true,
  previousMonth: "Previous month (PageUp)",
  nextMonth: "Next month (PageDown)",
  previousYear: "Last year (Control + left)",
  nextYear: "Next year (Control + right)",
  previousDecade: "Last decade",
  nextDecade: "Next decade",
  previousCentury: "Last century",
  nextCentury: "Next century"
};
var locale$1 = {
  placeholder: "Select time",
  rangePlaceholder: ["Start time", "End time"]
};
var TimePicker = locale$1;
var locale = {
  lang: _extends$1({
    placeholder: "Select date",
    yearPlaceholder: "Select year",
    quarterPlaceholder: "Select quarter",
    monthPlaceholder: "Select month",
    weekPlaceholder: "Select week",
    rangePlaceholder: ["Start date", "End date"],
    rangeYearPlaceholder: ["Start year", "End year"],
    rangeQuarterPlaceholder: ["Start quarter", "End quarter"],
    rangeMonthPlaceholder: ["Start month", "End month"],
    rangeWeekPlaceholder: ["Start week", "End week"]
  }, locale$2),
  timePickerLocale: _extends$1({}, TimePicker)
};
var enUS = locale;
var typeTemplate = "${label} is not a valid ${type}";
var localeValues = {
  locale: "en",
  Pagination: enUS$1,
  DatePicker: enUS,
  TimePicker,
  Calendar: enUS,
  global: {
    placeholder: "Please select"
  },
  Table: {
    filterTitle: "Filter menu",
    filterConfirm: "OK",
    filterReset: "Reset",
    filterEmptyText: "No filters",
    filterCheckall: "Select all items",
    filterSearchPlaceholder: "Search in filters",
    emptyText: "No data",
    selectAll: "Select current page",
    selectInvert: "Invert current page",
    selectNone: "Clear all data",
    selectionAll: "Select all data",
    sortTitle: "Sort",
    expand: "Expand row",
    collapse: "Collapse row",
    triggerDesc: "Click to sort descending",
    triggerAsc: "Click to sort ascending",
    cancelSort: "Click to cancel sorting"
  },
  Modal: {
    okText: "OK",
    cancelText: "Cancel",
    justOkText: "OK"
  },
  Popconfirm: {
    okText: "OK",
    cancelText: "Cancel"
  },
  Transfer: {
    titles: ["", ""],
    searchPlaceholder: "Search here",
    itemUnit: "item",
    itemsUnit: "items",
    remove: "Remove",
    selectCurrent: "Select current page",
    removeCurrent: "Remove current page",
    selectAll: "Select all data",
    removeAll: "Remove all data",
    selectInvert: "Invert current page"
  },
  Upload: {
    uploading: "Uploading...",
    removeFile: "Remove file",
    uploadError: "Upload error",
    previewFile: "Preview file",
    downloadFile: "Download file"
  },
  Empty: {
    description: "No Data"
  },
  Icon: {
    icon: "icon"
  },
  Text: {
    edit: "Edit",
    copy: "Copy",
    copied: "Copied",
    expand: "Expand"
  },
  PageHeader: {
    back: "Back"
  },
  Form: {
    optional: "(optional)",
    defaultValidateMessages: {
      "default": "Field validation error for ${label}",
      required: "Please enter ${label}",
      "enum": "${label} must be one of [${enum}]",
      whitespace: "${label} cannot be a blank character",
      date: {
        format: "${label} date format is invalid",
        parse: "${label} cannot be converted to a date",
        invalid: "${label} is an invalid date"
      },
      types: {
        string: typeTemplate,
        method: typeTemplate,
        array: typeTemplate,
        object: typeTemplate,
        number: typeTemplate,
        date: typeTemplate,
        "boolean": typeTemplate,
        integer: typeTemplate,
        "float": typeTemplate,
        regexp: typeTemplate,
        email: typeTemplate,
        url: typeTemplate,
        hex: typeTemplate
      },
      string: {
        len: "${label} must be ${len} characters",
        min: "${label} must be at least ${min} characters",
        max: "${label} must be up to ${max} characters",
        range: "${label} must be between ${min}-${max} characters"
      },
      number: {
        len: "${label} must be equal to ${len}",
        min: "${label} must be minimum ${min}",
        max: "${label} must be maximum ${max}",
        range: "${label} must be between ${min}-${max}"
      },
      array: {
        len: "Must be ${len} ${label}",
        min: "At least ${min} ${label}",
        max: "At most ${max} ${label}",
        range: "The amount of ${label} must be between ${min}-${max}"
      },
      pattern: {
        mismatch: "${label} does not match the pattern ${pattern}"
      }
    }
  },
  Image: {
    preview: "Preview"
  }
};
var defaultLocale = localeValues;
var LocaleContext = /* @__PURE__ */ createContext(void 0);
var LocaleContext$1 = LocaleContext;
var LocaleReceiver = /* @__PURE__ */ function(_React$Component) {
  _inherits(LocaleReceiver2, _React$Component);
  var _super = _createSuper(LocaleReceiver2);
  function LocaleReceiver2() {
    _classCallCheck(this, LocaleReceiver2);
    return _super.apply(this, arguments);
  }
  _createClass(LocaleReceiver2, [{
    key: "getLocale",
    value: function getLocale() {
      var _this$props = this.props, componentName = _this$props.componentName, defaultLocale$1 = _this$props.defaultLocale;
      var locale2 = defaultLocale$1 || defaultLocale[componentName !== null && componentName !== void 0 ? componentName : "global"];
      var antLocale = this.context;
      var localeFromContext = componentName && antLocale ? antLocale[componentName] : {};
      return _extends$1(_extends$1({}, locale2 instanceof Function ? locale2() : locale2), localeFromContext || {});
    }
  }, {
    key: "getLocaleCode",
    value: function getLocaleCode() {
      var antLocale = this.context;
      var localeCode = antLocale && antLocale.locale;
      if (antLocale && antLocale.exist && !localeCode) {
        return defaultLocale.locale;
      }
      return localeCode;
    }
  }, {
    key: "render",
    value: function render2() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    }
  }]);
  return LocaleReceiver2;
}(React.Component);
LocaleReceiver.defaultProps = {
  componentName: "global"
};
LocaleReceiver.contextType = LocaleContext$1;
var Empty$2 = function Empty() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-default");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "184",
    height: "152",
    viewBox: "0 0 184 152",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(24 31.67)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "67.797",
    cy: "106.89",
    rx: "67.797",
    ry: "12.668"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-1"),
    d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-2"),
    d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z",
    transform: "translate(13.56)"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-3"),
    d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z"
  }), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-4"),
    d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z"
  })), /* @__PURE__ */ React.createElement("path", {
    className: "".concat(prefixCls, "-path-5"),
    d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    transform: "translate(149.65 15.383)"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    cx: "20.654",
    cy: "3.167",
    rx: "2.849",
    ry: "2.815"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z"
  }))));
};
var DefaultEmptyImg = Empty$2;
var Simple = function Simple2() {
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls;
  var prefixCls = getPrefixCls("empty-img-simple");
  return /* @__PURE__ */ React.createElement("svg", {
    className: prefixCls,
    width: "64",
    height: "41",
    viewBox: "0 0 64 41",
    xmlns: "http://www.w3.org/2000/svg"
  }, /* @__PURE__ */ React.createElement("g", {
    transform: "translate(0 1)",
    fill: "none",
    fillRule: "evenodd"
  }, /* @__PURE__ */ React.createElement("ellipse", {
    className: "".concat(prefixCls, "-ellipse"),
    cx: "32",
    cy: "33",
    rx: "32",
    ry: "7"
  }), /* @__PURE__ */ React.createElement("g", {
    className: "".concat(prefixCls, "-g"),
    fillRule: "nonzero"
  }, /* @__PURE__ */ React.createElement("path", {
    d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z"
  }), /* @__PURE__ */ React.createElement("path", {
    d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z",
    className: "".concat(prefixCls, "-path")
  }))));
};
var SimpleEmptyImg = Simple;
var __rest$3 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var defaultEmptyImg = /* @__PURE__ */ React.createElement(DefaultEmptyImg, null);
var simpleEmptyImg = /* @__PURE__ */ React.createElement(SimpleEmptyImg, null);
var Empty2 = function Empty3(_a2) {
  var className = _a2.className, customizePrefixCls = _a2.prefixCls, _a$image = _a2.image, image = _a$image === void 0 ? defaultEmptyImg : _a$image, description = _a2.description, children = _a2.children, imageStyle = _a2.imageStyle, restProps = __rest$3(_a2, ["className", "prefixCls", "image", "description", "children", "imageStyle"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  return /* @__PURE__ */ React.createElement(LocaleReceiver, {
    componentName: "Empty"
  }, function(locale2) {
    var _classNames;
    var prefixCls = getPrefixCls("empty", customizePrefixCls);
    var des = typeof description !== "undefined" ? description : locale2.description;
    var alt = typeof des === "string" ? des : "empty";
    var imageNode = null;
    if (typeof image === "string") {
      imageNode = /* @__PURE__ */ React.createElement("img", {
        alt,
        src: image
      });
    } else {
      imageNode = image;
    }
    return /* @__PURE__ */ React.createElement("div", _extends$1({
      className: classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-normal"), image === simpleEmptyImg), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className)
    }, restProps), /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-image"),
      style: imageStyle
    }, imageNode), des && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-description")
    }, des), children && /* @__PURE__ */ React.createElement("div", {
      className: "".concat(prefixCls, "-footer")
    }, children));
  });
};
Empty2.PRESENTED_IMAGE_DEFAULT = defaultEmptyImg;
Empty2.PRESENTED_IMAGE_SIMPLE = simpleEmptyImg;
var Empty$1 = Empty2;
var renderEmpty = function renderEmpty2(componentName) {
  return /* @__PURE__ */ React.createElement(ConfigConsumer, null, function(_ref) {
    var getPrefixCls = _ref.getPrefixCls;
    var prefix = getPrefixCls("empty");
    switch (componentName) {
      case "Table":
      case "List":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE
        });
      case "Select":
      case "TreeSelect":
      case "Cascader":
      case "Transfer":
      case "Mentions":
        return /* @__PURE__ */ React.createElement(Empty$1, {
          image: Empty$1.PRESENTED_IMAGE_SIMPLE,
          className: "".concat(prefix, "-small")
        });
      default:
        return /* @__PURE__ */ React.createElement(Empty$1, null);
    }
  });
};
var defaultRenderEmpty = renderEmpty;
var defaultGetPrefixCls = function defaultGetPrefixCls2(suffixCls, customizePrefixCls) {
  if (customizePrefixCls)
    return customizePrefixCls;
  return suffixCls ? "ant-".concat(suffixCls) : "ant";
};
var ConfigContext = /* @__PURE__ */ React.createContext({
  getPrefixCls: defaultGetPrefixCls,
  renderEmpty: defaultRenderEmpty
});
var ConfigConsumer = ConfigContext.Consumer;
var SizeContext = /* @__PURE__ */ React.createContext(void 0);
var SizeContext$1 = SizeContext;
var raf = function raf2(callback) {
  return +setTimeout(callback, 16);
};
var caf = function caf2(num) {
  return clearTimeout(num);
};
if (typeof window !== "undefined" && "requestAnimationFrame" in window) {
  raf = function raf3(callback) {
    return window.requestAnimationFrame(callback);
  };
  caf = function caf3(handle) {
    return window.cancelAnimationFrame(handle);
  };
}
var rafUUID = 0;
var rafIds = /* @__PURE__ */ new Map();
function cleanup(id2) {
  rafIds.delete(id2);
}
function wrapperRaf$1(callback) {
  var times = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  rafUUID += 1;
  var id2 = rafUUID;
  function callRef(leftTimes) {
    if (leftTimes === 0) {
      cleanup(id2);
      callback();
    } else {
      var realId = raf(function() {
        callRef(leftTimes - 1);
      });
      rafIds.set(id2, realId);
    }
  }
  callRef(times);
  return id2;
}
wrapperRaf$1.cancel = function(id2) {
  var realId = rafIds.get(id2);
  cleanup(realId);
  return caf(realId);
};
function useControlledState(defaultStateValue, option) {
  var _ref = option || {}, defaultValue = _ref.defaultValue, value = _ref.value, onChange = _ref.onChange, postState = _ref.postState;
  var _React$useState = React.useState(function() {
    if (value !== void 0) {
      return value;
    }
    if (defaultValue !== void 0) {
      return typeof defaultValue === "function" ? defaultValue() : defaultValue;
    }
    return typeof defaultStateValue === "function" ? defaultStateValue() : defaultStateValue;
  }), _React$useState2 = _slicedToArray(_React$useState, 2), innerValue = _React$useState2[0], setInnerValue = _React$useState2[1];
  var mergedValue = value !== void 0 ? value : innerValue;
  if (postState) {
    mergedValue = postState(mergedValue);
  }
  var onChangeRef = React.useRef(onChange);
  onChangeRef.current = onChange;
  var triggerChange = React.useCallback(function(newValue) {
    setInnerValue(newValue);
    if (mergedValue !== newValue && onChangeRef.current) {
      onChangeRef.current(newValue, mergedValue);
    }
  }, [mergedValue, onChangeRef]);
  var firstRenderRef = React.useRef(true);
  React.useEffect(function() {
    if (firstRenderRef.current) {
      firstRenderRef.current = false;
      return;
    }
    if (value === void 0) {
      setInnerValue(value);
    }
  }, [value]);
  return [mergedValue, triggerChange];
}
var KeyCode = {
  MAC_ENTER: 3,
  BACKSPACE: 8,
  TAB: 9,
  NUM_CENTER: 12,
  ENTER: 13,
  SHIFT: 16,
  CTRL: 17,
  ALT: 18,
  PAUSE: 19,
  CAPS_LOCK: 20,
  ESC: 27,
  SPACE: 32,
  PAGE_UP: 33,
  PAGE_DOWN: 34,
  END: 35,
  HOME: 36,
  LEFT: 37,
  UP: 38,
  RIGHT: 39,
  DOWN: 40,
  PRINT_SCREEN: 44,
  INSERT: 45,
  DELETE: 46,
  ZERO: 48,
  ONE: 49,
  TWO: 50,
  THREE: 51,
  FOUR: 52,
  FIVE: 53,
  SIX: 54,
  SEVEN: 55,
  EIGHT: 56,
  NINE: 57,
  QUESTION_MARK: 63,
  A: 65,
  B: 66,
  C: 67,
  D: 68,
  E: 69,
  F: 70,
  G: 71,
  H: 72,
  I: 73,
  J: 74,
  K: 75,
  L: 76,
  M: 77,
  N: 78,
  O: 79,
  P: 80,
  Q: 81,
  R: 82,
  S: 83,
  T: 84,
  U: 85,
  V: 86,
  W: 87,
  X: 88,
  Y: 89,
  Z: 90,
  META: 91,
  WIN_KEY_RIGHT: 92,
  CONTEXT_MENU: 93,
  NUM_ZERO: 96,
  NUM_ONE: 97,
  NUM_TWO: 98,
  NUM_THREE: 99,
  NUM_FOUR: 100,
  NUM_FIVE: 101,
  NUM_SIX: 102,
  NUM_SEVEN: 103,
  NUM_EIGHT: 104,
  NUM_NINE: 105,
  NUM_MULTIPLY: 106,
  NUM_PLUS: 107,
  NUM_MINUS: 109,
  NUM_PERIOD: 110,
  NUM_DIVISION: 111,
  F1: 112,
  F2: 113,
  F3: 114,
  F4: 115,
  F5: 116,
  F6: 117,
  F7: 118,
  F8: 119,
  F9: 120,
  F10: 121,
  F11: 122,
  F12: 123,
  NUMLOCK: 144,
  SEMICOLON: 186,
  DASH: 189,
  EQUALS: 187,
  COMMA: 188,
  PERIOD: 190,
  SLASH: 191,
  APOSTROPHE: 192,
  SINGLE_QUOTE: 222,
  OPEN_SQUARE_BRACKET: 219,
  BACKSLASH: 220,
  CLOSE_SQUARE_BRACKET: 221,
  WIN_KEY: 224,
  MAC_FF_META: 224,
  WIN_IME: 229,
  isTextModifyingKeyEvent: function isTextModifyingKeyEvent(e2) {
    var keyCode = e2.keyCode;
    if (e2.altKey && !e2.ctrlKey || e2.metaKey || keyCode >= KeyCode.F1 && keyCode <= KeyCode.F12) {
      return false;
    }
    switch (keyCode) {
      case KeyCode.ALT:
      case KeyCode.CAPS_LOCK:
      case KeyCode.CONTEXT_MENU:
      case KeyCode.CTRL:
      case KeyCode.DOWN:
      case KeyCode.END:
      case KeyCode.ESC:
      case KeyCode.HOME:
      case KeyCode.INSERT:
      case KeyCode.LEFT:
      case KeyCode.MAC_FF_META:
      case KeyCode.META:
      case KeyCode.NUMLOCK:
      case KeyCode.NUM_CENTER:
      case KeyCode.PAGE_DOWN:
      case KeyCode.PAGE_UP:
      case KeyCode.PAUSE:
      case KeyCode.PRINT_SCREEN:
      case KeyCode.RIGHT:
      case KeyCode.SHIFT:
      case KeyCode.UP:
      case KeyCode.WIN_KEY:
      case KeyCode.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  },
  isCharacterKey: function isCharacterKey(keyCode) {
    if (keyCode >= KeyCode.ZERO && keyCode <= KeyCode.NINE) {
      return true;
    }
    if (keyCode >= KeyCode.NUM_ZERO && keyCode <= KeyCode.NUM_MULTIPLY) {
      return true;
    }
    if (keyCode >= KeyCode.A && keyCode <= KeyCode.Z) {
      return true;
    }
    if (window.navigator.userAgent.indexOf("WebKit") !== -1 && keyCode === 0) {
      return true;
    }
    switch (keyCode) {
      case KeyCode.SPACE:
      case KeyCode.QUESTION_MARK:
      case KeyCode.NUM_PLUS:
      case KeyCode.NUM_MINUS:
      case KeyCode.NUM_PERIOD:
      case KeyCode.NUM_DIVISION:
      case KeyCode.SEMICOLON:
      case KeyCode.DASH:
      case KeyCode.EQUALS:
      case KeyCode.COMMA:
      case KeyCode.PERIOD:
      case KeyCode.SLASH:
      case KeyCode.APOSTROPHE:
      case KeyCode.SINGLE_QUOTE:
      case KeyCode.OPEN_SQUARE_BRACKET:
      case KeyCode.BACKSLASH:
      case KeyCode.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  }
};
var tuple = function tuple2() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }
  return args;
};
var isValidElement = React.isValidElement;
function replaceElement(element, replacement, props) {
  if (!isValidElement(element))
    return replacement;
  return /* @__PURE__ */ React.cloneElement(element, typeof props === "function" ? props(element.props || {}) : props);
}
function cloneElement(element, props) {
  return replaceElement(element, element, props);
}
var responsiveArray = ["xxl", "xl", "lg", "md", "sm", "xs"];
var responsiveMap = {
  xs: "(max-width: 575px)",
  sm: "(min-width: 576px)",
  md: "(min-width: 768px)",
  lg: "(min-width: 992px)",
  xl: "(min-width: 1200px)",
  xxl: "(min-width: 1600px)"
};
var subscribers = /* @__PURE__ */ new Map();
var subUid = -1;
var screens = {};
var responsiveObserve = {
  matchHandlers: {},
  dispatch: function dispatch(pointMap) {
    screens = pointMap;
    subscribers.forEach(function(func) {
      return func(screens);
    });
    return subscribers.size >= 1;
  },
  subscribe: function subscribe(func) {
    if (!subscribers.size)
      this.register();
    subUid += 1;
    subscribers.set(subUid, func);
    func(screens);
    return subUid;
  },
  unsubscribe: function unsubscribe(token) {
    subscribers["delete"](token);
    if (!subscribers.size)
      this.unregister();
  },
  unregister: function unregister2() {
    var _this = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var handler = _this.matchHandlers[matchMediaQuery];
      handler === null || handler === void 0 ? void 0 : handler.mql.removeListener(handler === null || handler === void 0 ? void 0 : handler.listener);
    });
    subscribers.clear();
  },
  register: function register3() {
    var _this2 = this;
    Object.keys(responsiveMap).forEach(function(screen) {
      var matchMediaQuery = responsiveMap[screen];
      var listener = function listener2(_ref) {
        var matches = _ref.matches;
        _this2.dispatch(_extends$1(_extends$1({}, screens), _defineProperty({}, screen, matches)));
      };
      var mql = window.matchMedia(matchMediaQuery);
      mql.addListener(listener);
      _this2.matchHandlers[matchMediaQuery] = {
        mql,
        listener
      };
      listener(mql);
    });
  }
};
var ResponsiveObserve = responsiveObserve;
var id = 0;
var ids = {};
function wrapperRaf(callback) {
  var delayFrames = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  var myId = id++;
  var restFrames = delayFrames;
  function internalCallback() {
    restFrames -= 1;
    if (restFrames <= 0) {
      callback();
      delete ids[myId];
    } else {
      ids[myId] = wrapperRaf$1(internalCallback);
    }
  }
  ids[myId] = wrapperRaf$1(internalCallback);
  return myId;
}
wrapperRaf.cancel = function cancel(pid) {
  if (pid === void 0)
    return;
  wrapperRaf$1.cancel(ids[pid]);
  delete ids[pid];
};
wrapperRaf.ids = ids;
var styleForPseudo;
function isHidden(element) {
  return !element || element.offsetParent === null || element.hidden;
}
function isNotGrey(color) {
  var match = (color || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
  if (match && match[1] && match[2] && match[3]) {
    return !(match[1] === match[2] && match[2] === match[3]);
  }
  return true;
}
var Wave = /* @__PURE__ */ function(_React$Component) {
  _inherits(Wave2, _React$Component);
  var _super = _createSuper(Wave2);
  function Wave2() {
    var _this;
    _classCallCheck(this, Wave2);
    _this = _super.apply(this, arguments);
    _this.containerRef = /* @__PURE__ */ React.createRef();
    _this.animationStart = false;
    _this.destroyed = false;
    _this.onClick = function(node, waveColor) {
      var _a2, _b2;
      var _this$props = _this.props, insertExtraNode = _this$props.insertExtraNode, disabled = _this$props.disabled;
      if (disabled || !node || isHidden(node) || node.className.indexOf("-leave") >= 0) {
        return;
      }
      _this.extraNode = document.createElement("div");
      var _assertThisInitialize = _assertThisInitialized(_this), extraNode = _assertThisInitialize.extraNode;
      var getPrefixCls = _this.context.getPrefixCls;
      extraNode.className = "".concat(getPrefixCls(""), "-click-animating-node");
      var attributeName = _this.getAttributeName();
      node.setAttribute(attributeName, "true");
      if (waveColor && waveColor !== "#ffffff" && waveColor !== "rgb(255, 255, 255)" && isNotGrey(waveColor) && !/rgba\((?:\d*, ){3}0\)/.test(waveColor) && waveColor !== "transparent") {
        extraNode.style.borderColor = waveColor;
        var nodeRoot = ((_a2 = node.getRootNode) === null || _a2 === void 0 ? void 0 : _a2.call(node)) || node.ownerDocument;
        var nodeBody = nodeRoot instanceof Document ? nodeRoot.body : (_b2 = nodeRoot.firstChild) !== null && _b2 !== void 0 ? _b2 : nodeRoot;
        styleForPseudo = updateCSS("\n      [".concat(getPrefixCls(""), "-click-animating-without-extra-node='true']::after, .").concat(getPrefixCls(""), "-click-animating-node {\n        --antd-wave-shadow-color: ").concat(waveColor, ";\n      }"), "antd-wave", {
          csp: _this.csp,
          attachTo: nodeBody
        });
      }
      if (insertExtraNode) {
        node.appendChild(extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.addEventListener("".concat(name, "start"), _this.onTransitionStart);
        node.addEventListener("".concat(name, "end"), _this.onTransitionEnd);
      });
    };
    _this.onTransitionStart = function(e2) {
      if (_this.destroyed) {
        return;
      }
      var node = _this.containerRef.current;
      if (!e2 || e2.target !== node || _this.animationStart) {
        return;
      }
      _this.resetEffect(node);
    };
    _this.onTransitionEnd = function(e2) {
      if (!e2 || e2.animationName !== "fadeEffect") {
        return;
      }
      _this.resetEffect(e2.target);
    };
    _this.bindAnimationEvent = function(node) {
      if (!node || !node.getAttribute || node.getAttribute("disabled") || node.className.indexOf("disabled") >= 0) {
        return;
      }
      var onClick = function onClick2(e2) {
        if (e2.target.tagName === "INPUT" || isHidden(e2.target)) {
          return;
        }
        _this.resetEffect(node);
        var waveColor = getComputedStyle(node).getPropertyValue("border-top-color") || getComputedStyle(node).getPropertyValue("border-color") || getComputedStyle(node).getPropertyValue("background-color");
        _this.clickWaveTimeoutId = window.setTimeout(function() {
          return _this.onClick(node, waveColor);
        }, 0);
        wrapperRaf.cancel(_this.animationStartId);
        _this.animationStart = true;
        _this.animationStartId = wrapperRaf(function() {
          _this.animationStart = false;
        }, 10);
      };
      node.addEventListener("click", onClick, true);
      return {
        cancel: function cancel2() {
          node.removeEventListener("click", onClick, true);
        }
      };
    };
    _this.renderWave = function(_ref) {
      var csp = _ref.csp;
      var children = _this.props.children;
      _this.csp = csp;
      if (!/* @__PURE__ */ React.isValidElement(children))
        return children;
      var ref = _this.containerRef;
      if (supportRef(children)) {
        ref = composeRef(children.ref, _this.containerRef);
      }
      return cloneElement(children, {
        ref
      });
    };
    return _this;
  }
  _createClass(Wave2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = this.containerRef.current;
      if (!node || node.nodeType !== 1) {
        return;
      }
      this.instance = this.bindAnimationEvent(node);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.instance) {
        this.instance.cancel();
      }
      if (this.clickWaveTimeoutId) {
        clearTimeout(this.clickWaveTimeoutId);
      }
      this.destroyed = true;
    }
  }, {
    key: "getAttributeName",
    value: function getAttributeName() {
      var getPrefixCls = this.context.getPrefixCls;
      var insertExtraNode = this.props.insertExtraNode;
      return insertExtraNode ? "".concat(getPrefixCls(""), "-click-animating") : "".concat(getPrefixCls(""), "-click-animating-without-extra-node");
    }
  }, {
    key: "resetEffect",
    value: function resetEffect(node) {
      var _this2 = this;
      if (!node || node === this.extraNode || !(node instanceof Element)) {
        return;
      }
      var insertExtraNode = this.props.insertExtraNode;
      var attributeName = this.getAttributeName();
      node.setAttribute(attributeName, "false");
      if (styleForPseudo) {
        styleForPseudo.innerHTML = "";
      }
      if (insertExtraNode && this.extraNode && node.contains(this.extraNode)) {
        node.removeChild(this.extraNode);
      }
      ["transition", "animation"].forEach(function(name) {
        node.removeEventListener("".concat(name, "start"), _this2.onTransitionStart);
        node.removeEventListener("".concat(name, "end"), _this2.onTransitionEnd);
      });
    }
  }, {
    key: "render",
    value: function render2() {
      return /* @__PURE__ */ React.createElement(ConfigConsumer, null, this.renderWave);
    }
  }]);
  return Wave2;
}(React.Component);
Wave.contextType = ConfigContext;
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React__default, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c2, a, k2) {
  var b2, d2 = {}, e2 = null, l2 = null;
  k2 !== void 0 && (e2 = "" + k2);
  a.key !== void 0 && (e2 = "" + a.key);
  a.ref !== void 0 && (l2 = a.ref);
  for (b2 in a)
    n.call(a, b2) && !p.hasOwnProperty(b2) && (d2[b2] = a[b2]);
  if (c2 && c2.defaultProps)
    for (b2 in a = c2.defaultProps, a)
      d2[b2] === void 0 && (d2[b2] = a[b2]);
  return { $$typeof: g, type: c2, key: e2, ref: l2, props: d2, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const jsxs = jsxRuntime.exports.jsxs;
var RowContext = /* @__PURE__ */ createContext({});
var RowContext$1 = RowContext;
var canUseDocElement = function canUseDocElement2() {
  return canUseDom() && window.document.documentElement;
};
var flexGapSupported;
var detectFlexGapSupported = function detectFlexGapSupported2() {
  if (!canUseDocElement()) {
    return false;
  }
  if (flexGapSupported !== void 0) {
    return flexGapSupported;
  }
  var flex = document.createElement("div");
  flex.style.display = "flex";
  flex.style.flexDirection = "column";
  flex.style.rowGap = "1px";
  flex.appendChild(document.createElement("div"));
  flex.appendChild(document.createElement("div"));
  document.body.appendChild(flex);
  flexGapSupported = flex.scrollHeight === 1;
  document.body.removeChild(flex);
  return flexGapSupported;
};
var useFlexGapSupport = function() {
  var _React$useState = React.useState(false), _React$useState2 = _slicedToArray(_React$useState, 2), flexible = _React$useState2[0], setFlexible = _React$useState2[1];
  React.useEffect(function() {
    setFlexible(detectFlexGapSupported());
  }, []);
  return flexible;
};
var __rest$2 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
tuple("top", "middle", "bottom", "stretch");
tuple("start", "end", "center", "space-around", "space-between");
var Row = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var customizePrefixCls = props.prefixCls, justify = props.justify, align = props.align, className = props.className, style = props.style, children = props.children, _props$gutter = props.gutter, gutter = _props$gutter === void 0 ? 0 : _props$gutter, wrap = props.wrap, others = __rest$2(props, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]);
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useState = React.useState({
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
    xxl: true
  }), _React$useState2 = _slicedToArray(_React$useState, 2), screens2 = _React$useState2[0], setScreens = _React$useState2[1];
  var supportFlexGap = useFlexGapSupport();
  var gutterRef = React.useRef(gutter);
  React.useEffect(function() {
    var token = ResponsiveObserve.subscribe(function(screen) {
      var currentGutter = gutterRef.current || 0;
      if (!Array.isArray(currentGutter) && _typeof(currentGutter) === "object" || Array.isArray(currentGutter) && (_typeof(currentGutter[0]) === "object" || _typeof(currentGutter[1]) === "object")) {
        setScreens(screen);
      }
    });
    return function() {
      return ResponsiveObserve.unsubscribe(token);
    };
  }, []);
  var getGutter = function getGutter2() {
    var results = [0, 0];
    var normalizedGutter = Array.isArray(gutter) ? gutter : [gutter, 0];
    normalizedGutter.forEach(function(g2, index2) {
      if (_typeof(g2) === "object") {
        for (var i = 0; i < responsiveArray.length; i++) {
          var breakpoint = responsiveArray[i];
          if (screens2[breakpoint] && g2[breakpoint] !== void 0) {
            results[index2] = g2[breakpoint];
            break;
          }
        }
      } else {
        results[index2] = g2 || 0;
      }
    });
    return results;
  };
  var prefixCls = getPrefixCls("row", customizePrefixCls);
  var gutters = getGutter();
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-no-wrap"), wrap === false), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(justify), justify), _defineProperty(_classNames, "".concat(prefixCls, "-").concat(align), align), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  var rowStyle = {};
  var horizontalGutter = gutters[0] > 0 ? gutters[0] / -2 : void 0;
  var verticalGutter = gutters[1] > 0 ? gutters[1] / -2 : void 0;
  if (horizontalGutter) {
    rowStyle.marginLeft = horizontalGutter;
    rowStyle.marginRight = horizontalGutter;
  }
  if (supportFlexGap) {
    var _gutters = _slicedToArray(gutters, 2);
    rowStyle.rowGap = _gutters[1];
  } else if (verticalGutter) {
    rowStyle.marginTop = verticalGutter;
    rowStyle.marginBottom = verticalGutter;
  }
  var _gutters2 = _slicedToArray(gutters, 2), gutterH = _gutters2[0], gutterV = _gutters2[1];
  var rowContext = React.useMemo(function() {
    return {
      gutter: [gutterH, gutterV],
      wrap,
      supportFlexGap
    };
  }, [gutterH, gutterV, wrap, supportFlexGap]);
  return /* @__PURE__ */ React.createElement(RowContext$1.Provider, {
    value: rowContext
  }, /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    className: classes,
    style: _extends$1(_extends$1({}, rowStyle), style),
    ref
  }), children));
});
Row.displayName = "Row";
var Row$1 = Row;
var __rest$1 = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
function parseFlex(flex) {
  if (typeof flex === "number") {
    return "".concat(flex, " ").concat(flex, " auto");
  }
  if (/^\d+(\.\d+)?(px|em|rem|%)$/.test(flex)) {
    return "0 0 ".concat(flex);
  }
  return flex;
}
var sizes = ["xs", "sm", "md", "lg", "xl", "xxl"];
var Col = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var _classNames;
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var _React$useContext2 = React.useContext(RowContext$1), gutter = _React$useContext2.gutter, wrap = _React$useContext2.wrap, supportFlexGap = _React$useContext2.supportFlexGap;
  var customizePrefixCls = props.prefixCls, span = props.span, order = props.order, offset = props.offset, push2 = props.push, pull = props.pull, className = props.className, children = props.children, flex = props.flex, style = props.style, others = __rest$1(props, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]);
  var prefixCls = getPrefixCls("col", customizePrefixCls);
  var sizeClassObj = {};
  sizes.forEach(function(size) {
    var _extends2;
    var sizeProps = {};
    var propSize = props[size];
    if (typeof propSize === "number") {
      sizeProps.span = propSize;
    } else if (_typeof(propSize) === "object") {
      sizeProps = propSize || {};
    }
    delete others[size];
    sizeClassObj = _extends$1(_extends$1({}, sizeClassObj), (_extends2 = {}, _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-").concat(sizeProps.span), sizeProps.span !== void 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-order-").concat(sizeProps.order), sizeProps.order || sizeProps.order === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-offset-").concat(sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-push-").concat(sizeProps.push), sizeProps.push || sizeProps.push === 0), _defineProperty(_extends2, "".concat(prefixCls, "-").concat(size, "-pull-").concat(sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _defineProperty(_extends2, "".concat(prefixCls, "-rtl"), direction === "rtl"), _extends2));
  });
  var classes = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-").concat(span), span !== void 0), _defineProperty(_classNames, "".concat(prefixCls, "-order-").concat(order), order), _defineProperty(_classNames, "".concat(prefixCls, "-offset-").concat(offset), offset), _defineProperty(_classNames, "".concat(prefixCls, "-push-").concat(push2), push2), _defineProperty(_classNames, "".concat(prefixCls, "-pull-").concat(pull), pull), _classNames), className, sizeClassObj);
  var mergedStyle = {};
  if (gutter && gutter[0] > 0) {
    var horizontalGutter = gutter[0] / 2;
    mergedStyle.paddingLeft = horizontalGutter;
    mergedStyle.paddingRight = horizontalGutter;
  }
  if (gutter && gutter[1] > 0 && !supportFlexGap) {
    var verticalGutter = gutter[1] / 2;
    mergedStyle.paddingTop = verticalGutter;
    mergedStyle.paddingBottom = verticalGutter;
  }
  if (flex) {
    mergedStyle.flex = parseFlex(flex);
    if (wrap === false && !mergedStyle.minWidth) {
      mergedStyle.minWidth = 0;
    }
  }
  return /* @__PURE__ */ React.createElement("div", _extends$1({}, others, {
    style: _extends$1(_extends$1({}, mergedStyle), style),
    className: classes,
    ref
  }), children);
});
Col.displayName = "Col";
var Col$1 = Col;
var Switch$2 = React.forwardRef(function(_ref, ref) {
  var _classNames;
  var _ref$prefixCls = _ref.prefixCls, prefixCls = _ref$prefixCls === void 0 ? "rc-switch" : _ref$prefixCls, className = _ref.className, checked = _ref.checked, defaultChecked = _ref.defaultChecked, disabled = _ref.disabled, loadingIcon = _ref.loadingIcon, checkedChildren = _ref.checkedChildren, unCheckedChildren = _ref.unCheckedChildren, onClick = _ref.onClick, onChange = _ref.onChange, onKeyDown = _ref.onKeyDown, restProps = _objectWithoutProperties(_ref, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]);
  var _useMergedState = useControlledState(false, {
    value: checked,
    defaultValue: defaultChecked
  }), _useMergedState2 = _slicedToArray(_useMergedState, 2), innerChecked = _useMergedState2[0], setInnerChecked = _useMergedState2[1];
  function triggerChange(newChecked, event) {
    var mergedChecked = innerChecked;
    if (!disabled) {
      mergedChecked = newChecked;
      setInnerChecked(mergedChecked);
      onChange === null || onChange === void 0 ? void 0 : onChange(mergedChecked, event);
    }
    return mergedChecked;
  }
  function onInternalKeyDown(e2) {
    if (e2.which === KeyCode.LEFT) {
      triggerChange(false, e2);
    } else if (e2.which === KeyCode.RIGHT) {
      triggerChange(true, e2);
    }
    onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(e2);
  }
  function onInternalClick(e2) {
    var ret = triggerChange(!innerChecked, e2);
    onClick === null || onClick === void 0 ? void 0 : onClick(ret, e2);
  }
  var switchClassName = classNames(prefixCls, className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-checked"), innerChecked), _defineProperty(_classNames, "".concat(prefixCls, "-disabled"), disabled), _classNames));
  return React.createElement("button", Object.assign({}, restProps, {
    type: "button",
    role: "switch",
    "aria-checked": innerChecked,
    disabled,
    className: switchClassName,
    ref,
    onKeyDown: onInternalKeyDown,
    onClick: onInternalClick
  }), loadingIcon, React.createElement("span", {
    className: "".concat(prefixCls, "-inner")
  }, innerChecked ? checkedChildren : unCheckedChildren));
});
Switch$2.displayName = "Switch";
var __rest = globalThis && globalThis.__rest || function(s, e2) {
  var t2 = {};
  for (var p2 in s) {
    if (Object.prototype.hasOwnProperty.call(s, p2) && e2.indexOf(p2) < 0)
      t2[p2] = s[p2];
  }
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p2 = Object.getOwnPropertySymbols(s); i < p2.length; i++) {
      if (e2.indexOf(p2[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p2[i]))
        t2[p2[i]] = s[p2[i]];
    }
  return t2;
};
var Switch = /* @__PURE__ */ React.forwardRef(function(_a2, ref) {
  var _classNames;
  var customizePrefixCls = _a2.prefixCls, customizeSize = _a2.size, loading = _a2.loading, _a$className = _a2.className, className = _a$className === void 0 ? "" : _a$className, disabled = _a2.disabled, props = __rest(_a2, ["prefixCls", "size", "loading", "className", "disabled"]);
  devWarning("checked" in props || !("value" in props), "Switch", "`value` is not a valid prop, do you mean `checked`?");
  var _React$useContext = React.useContext(ConfigContext), getPrefixCls = _React$useContext.getPrefixCls, direction = _React$useContext.direction;
  var size = React.useContext(SizeContext$1);
  var prefixCls = getPrefixCls("switch", customizePrefixCls);
  var loadingIcon = /* @__PURE__ */ React.createElement("div", {
    className: "".concat(prefixCls, "-handle")
  }, loading && /* @__PURE__ */ React.createElement(LoadingOutlined$1, {
    className: "".concat(prefixCls, "-loading-icon")
  }));
  var classes = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-small"), (customizeSize || size) === "small"), _defineProperty(_classNames, "".concat(prefixCls, "-loading"), loading), _defineProperty(_classNames, "".concat(prefixCls, "-rtl"), direction === "rtl"), _classNames), className);
  return /* @__PURE__ */ React.createElement(Wave, {
    insertExtraNode: true
  }, /* @__PURE__ */ React.createElement(Switch$2, _extends$1({}, props, {
    prefixCls,
    className: classes,
    disabled: disabled || loading,
    ref,
    loadingIcon
  })));
});
Switch.__ANT_SWITCH = true;
Switch.displayName = "Switch";
var Switch$1 = Switch;
var _default = "";
var index$7 = "";
var index$6 = "";
var index$5 = "";
var index$4 = "";
var index$3 = "";
var index$2 = "";
var index$1 = "";
const container = "_container_oi76t_1";
var styles = {
  container,
  "function": "_function_oi76t_10"
};
var index = "";
var reactEchartsJson_cjs = {};
(function(exports) {
  var _an = Object.defineProperty;
  var jet = Object.getOwnPropertySymbols;
  var xan = Object.prototype.hasOwnProperty, wan = Object.prototype.propertyIsEnumerable;
  var NIe = (l3, r3, e3) => r3 in l3 ? _an(l3, r3, { enumerable: true, configurable: true, writable: true, value: e3 }) : l3[r3] = e3, Get = (l3, r3) => {
    for (var e3 in r3 || (r3 = {}))
      xan.call(r3, e3) && NIe(l3, e3, r3[e3]);
    if (jet)
      for (var e3 of jet(r3))
        wan.call(r3, e3) && NIe(l3, e3, r3[e3]);
    return l3;
  };
  var y_ = (l3, r3, e3) => (NIe(l3, typeof r3 != "symbol" ? r3 + "" : r3, e3), e3);
  Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
  var Nc = React__default;
  function San(l3) {
    return l3 && typeof l3 == "object" && "default" in l3 ? l3 : { default: l3 };
  }
  function Can(l3) {
    if (l3 && l3.__esModule)
      return l3;
    var r3 = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
    return l3 && Object.keys(l3).forEach(function(e3) {
      if (e3 !== "default") {
        var u = Object.getOwnPropertyDescriptor(l3, e3);
        Object.defineProperty(r3, e3, u.get ? u : { enumerable: true, get: function() {
          return l3[e3];
        } });
      }
    }), r3.default = l3, Object.freeze(r3);
  }
  var uj = San(Nc), ma = Can(Nc), Man = globalThis && globalThis.__read || function(l3, r3) {
    var e3 = typeof Symbol == "function" && l3[Symbol.iterator];
    if (!e3)
      return l3;
    var u = e3.call(l3), h, v4 = [], m3;
    try {
      for (; (r3 === void 0 || r3-- > 0) && !(h = u.next()).done; )
        v4.push(h.value);
    } catch (x3) {
      m3 = { error: x3 };
    } finally {
      try {
        h && !h.done && (e3 = u.return) && e3.call(u);
      } finally {
        if (m3)
          throw m3.error;
      }
    }
    return v4;
  };
  function Tan(l3, r3) {
    l3 === void 0 && (l3 = false);
    var e3 = Man(Nc.useState(l3), 2), u = e3[0], h = e3[1], v4 = Nc.useMemo(function() {
      var m3 = r3 === void 0 ? !l3 : r3, x3 = function() {
        return h(function(N) {
          return N === l3 ? m3 : l3;
        });
      }, C = function(N) {
        return h(N);
      }, A2 = function() {
        return h(l3);
      }, D = function() {
        return h(m3);
      };
      return { toggle: x3, set: C, setLeft: A2, setRight: D };
    }, []);
    return [u, v4];
  }
  var Aan = globalThis && globalThis.__read || function(l3, r3) {
    var e3 = typeof Symbol == "function" && l3[Symbol.iterator];
    if (!e3)
      return l3;
    var u = e3.call(l3), h, v4 = [], m3;
    try {
      for (; (r3 === void 0 || r3-- > 0) && !(h = u.next()).done; )
        v4.push(h.value);
    } catch (x3) {
      m3 = { error: x3 };
    } finally {
      try {
        h && !h.done && (e3 = u.return) && e3.call(u);
      } finally {
        if (m3)
          throw m3.error;
      }
    }
    return v4;
  };
  function Ian(l3) {
    l3 === void 0 && (l3 = false);
    var r3 = Aan(Tan(l3), 2), e3 = r3[0], u = r3[1], h = u.toggle, v4 = u.set, m3 = Nc.useMemo(function() {
      var x3 = function() {
        return v4(true);
      }, C = function() {
        return v4(false);
      };
      return { toggle: h, set: function(D) {
        return v4(!!D);
      }, setTrue: x3, setFalse: C };
    }, []);
    return [e3, m3];
  }
  function _3e(l3) {
    var r3 = Nc.useRef(l3);
    return r3.current = l3, r3;
  }
  var Ean = !!(typeof window != "undefined" && window.document && window.document.createElement), Dan = Ean;
  function Tlt(l3, r3) {
    if (!!Dan) {
      if (!l3)
        return r3;
      var e3;
      return typeof l3 == "function" ? e3 = l3() : "current" in l3 ? e3 = l3.current : e3 = l3, e3;
    }
  }
  var kan = function(r3) {
    var e3 = _3e(r3);
    Nc.useEffect(function() {
      return function() {
        e3.current();
      };
    }, []);
  }, x3e = kan;
  function Het(l3, r3) {
    if (l3 === r3)
      return true;
    for (var e3 = 0; e3 < l3.length; e3++)
      if (!Object.is(l3[e3], r3[e3]))
        return false;
    return true;
  }
  var Oan = function(r3) {
    var e3 = function(h, v4, m3) {
      var x3 = Nc.useRef(false), C = Nc.useRef([]), A2 = Nc.useRef([]), D = Nc.useRef();
      r3(function() {
        var P, N = Array.isArray(m3) ? m3 : [m3], j = N.map(function(W) {
          return Tlt(W);
        });
        if (!x3.current) {
          x3.current = true, C.current = j, A2.current = v4, D.current = h();
          return;
        }
        (j.length !== C.current.length || !Het(j, C.current) || !Het(v4, A2.current)) && ((P = D.current) === null || P === void 0 || P.call(D), C.current = j, A2.current = v4, D.current = h());
      }), x3e(function() {
        var P;
        (P = D.current) === null || P === void 0 || P.call(D), x3.current = false;
      });
    };
    return e3;
  }, Pan = Oan, Lan = Pan(Nc.useEffect), Ran = Lan, p2 = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof commonjsGlobal != "undefined" ? commonjsGlobal : typeof self != "undefined" ? self : {};
  function Nan(l3) {
    return l3 && l3.__esModule && Object.prototype.hasOwnProperty.call(l3, "default") ? l3.default : l3;
  }
  function Fan(l3) {
    var r3 = typeof l3;
    return l3 != null && (r3 == "object" || r3 == "function");
  }
  var Alt = Fan, Van = typeof p2 == "object" && p2 && p2.Object === Object && p2, Ban = Van, zan = Ban, jan = typeof self == "object" && self && self.Object === Object && self, Gan = zan || jan || Function("return this")(), Ilt = Gan, Han = Ilt, Wan = function() {
    return Han.Date.now();
  }, Uan = Wan, qan = /\s/;
  function $an(l3) {
    for (var r3 = l3.length; r3-- && qan.test(l3.charAt(r3)); )
      ;
    return r3;
  }
  var Xan = $an, Yan = Xan, Kan = /^\s+/;
  function Zan(l3) {
    return l3 && l3.slice(0, Yan(l3) + 1).replace(Kan, "");
  }
  var Jan = Zan, Qan = Ilt, eon = Qan.Symbol, Elt = eon, Wet = Elt, Dlt = Object.prototype, ton = Dlt.hasOwnProperty, non = Dlt.toString, zK = Wet ? Wet.toStringTag : void 0;
  function ron(l3) {
    var r3 = ton.call(l3, zK), e3 = l3[zK];
    try {
      l3[zK] = void 0;
      var u = true;
    } catch {
    }
    var h = non.call(l3);
    return u && (r3 ? l3[zK] = e3 : delete l3[zK]), h;
  }
  var ion = ron, aon = Object.prototype, oon = aon.toString;
  function son(l3) {
    return oon.call(l3);
  }
  var lon = son, Uet = Elt, uon = ion, con = lon, fon = "[object Null]", hon = "[object Undefined]", qet = Uet ? Uet.toStringTag : void 0;
  function pon(l3) {
    return l3 == null ? l3 === void 0 ? hon : fon : qet && qet in Object(l3) ? uon(l3) : con(l3);
  }
  var don = pon;
  function von(l3) {
    return l3 != null && typeof l3 == "object";
  }
  var gon = von, yon = don, mon = gon, bon = "[object Symbol]";
  function _on(l3) {
    return typeof l3 == "symbol" || mon(l3) && yon(l3) == bon;
  }
  var xon = _on, won = Jan, $et = Alt, Son = xon, Xet = 0 / 0, Con = /^[-+]0x[0-9a-f]+$/i, Mon = /^0b[01]+$/i, Ton = /^0o[0-7]+$/i, Aon = parseInt;
  function Ion(l3) {
    if (typeof l3 == "number")
      return l3;
    if (Son(l3))
      return Xet;
    if ($et(l3)) {
      var r3 = typeof l3.valueOf == "function" ? l3.valueOf() : l3;
      l3 = $et(r3) ? r3 + "" : r3;
    }
    if (typeof l3 != "string")
      return l3 === 0 ? l3 : +l3;
    l3 = won(l3);
    var e3 = Mon.test(l3);
    return e3 || Ton.test(l3) ? Aon(l3.slice(2), e3 ? 2 : 8) : Con.test(l3) ? Xet : +l3;
  }
  var Eon = Ion, Don = Alt, FIe = Uan, Yet = Eon, kon = "Expected a function", Oon = Math.max, Pon = Math.min;
  function Lon(l3, r3, e3) {
    var u, h, v4, m3, x3, C, A2 = 0, D = false, P = false, N = true;
    if (typeof l3 != "function")
      throw new TypeError(kon);
    r3 = Yet(r3) || 0, Don(e3) && (D = !!e3.leading, P = "maxWait" in e3, v4 = P ? Oon(Yet(e3.maxWait) || 0, r3) : v4, N = "trailing" in e3 ? !!e3.trailing : N);
    function j(Oe) {
      var We = u, Ue = h;
      return u = h = void 0, A2 = Oe, m3 = l3.apply(Ue, We), m3;
    }
    function W(Oe) {
      return A2 = Oe, x3 = setTimeout(ne, r3), D ? j(Oe) : m3;
    }
    function K(Oe) {
      var We = Oe - C, Ue = Oe - A2, qe = r3 - We;
      return P ? Pon(qe, v4 - Ue) : qe;
    }
    function te(Oe) {
      var We = Oe - C, Ue = Oe - A2;
      return C === void 0 || We >= r3 || We < 0 || P && Ue >= v4;
    }
    function ne() {
      var Oe = FIe();
      if (te(Oe))
        return ce(Oe);
      x3 = setTimeout(ne, K(Oe));
    }
    function ce(Oe) {
      return x3 = void 0, N && u ? j(Oe) : (u = h = void 0, m3);
    }
    function me() {
      x3 !== void 0 && clearTimeout(x3), A2 = 0, u = C = h = x3 = void 0;
    }
    function ve() {
      return x3 === void 0 ? m3 : ce(FIe());
    }
    function Be() {
      var Oe = FIe(), We = te(Oe);
      if (u = arguments, h = this, C = Oe, We) {
        if (x3 === void 0)
          return W(C);
        if (P)
          return clearTimeout(x3), x3 = setTimeout(ne, r3), j(C);
      }
      return x3 === void 0 && (x3 = setTimeout(ne, r3)), m3;
    }
    return Be.cancel = me, Be.flush = ve, Be;
  }
  var Ron = Lon, Non = globalThis && globalThis.__read || function(l3, r3) {
    var e3 = typeof Symbol == "function" && l3[Symbol.iterator];
    if (!e3)
      return l3;
    var u = e3.call(l3), h, v4 = [], m3;
    try {
      for (; (r3 === void 0 || r3-- > 0) && !(h = u.next()).done; )
        v4.push(h.value);
    } catch (x3) {
      m3 = { error: x3 };
    } finally {
      try {
        h && !h.done && (e3 = u.return) && e3.call(u);
      } finally {
        if (m3)
          throw m3.error;
      }
    }
    return v4;
  }, Fon = globalThis && globalThis.__spread || function() {
    for (var l3 = [], r3 = 0; r3 < arguments.length; r3++)
      l3 = l3.concat(Non(arguments[r3]));
    return l3;
  };
  function Von(l3, r3) {
    var e3, u = _3e(l3), h = (e3 = r3 == null ? void 0 : r3.wait) !== null && e3 !== void 0 ? e3 : 1e3, v4 = Nc.useMemo(function() {
      return Ron(function() {
        for (var m3 = [], x3 = 0; x3 < arguments.length; x3++)
          m3[x3] = arguments[x3];
        return u.current.apply(u, Fon(m3));
      }, h, r3);
    }, []);
    return x3e(function() {
      v4.cancel();
    }), { run: v4, cancel: v4.cancel, flush: v4.flush };
  }
  var Bon = function(r3) {
    return function(e3, u) {
      var h = Nc.useRef(false);
      r3(function() {
        return function() {
          h.current = false;
        };
      }, []), r3(function() {
        if (!h.current)
          h.current = true;
        else
          return e3();
      }, u);
    };
  }, zon = Bon(Nc.useEffect), jon = globalThis && globalThis.__read || function(l3, r3) {
    var e3 = typeof Symbol == "function" && l3[Symbol.iterator];
    if (!e3)
      return l3;
    var u = e3.call(l3), h, v4 = [], m3;
    try {
      for (; (r3 === void 0 || r3-- > 0) && !(h = u.next()).done; )
        v4.push(h.value);
    } catch (x3) {
      m3 = { error: x3 };
    } finally {
      try {
        h && !h.done && (e3 = u.return) && e3.call(u);
      } finally {
        if (m3)
          throw m3.error;
      }
    }
    return v4;
  };
  function Gon(l3, r3, e3) {
    var u = jon(Nc.useState({}), 2), h = u[0], v4 = u[1], m3 = Von(function() {
      v4({});
    }, e3), x3 = m3.run, C = m3.cancel;
    Nc.useEffect(function() {
      return x3();
    }, r3), x3e(C), zon(l3, [h]);
  }
  function Hon(l3, r3, e3) {
    e3 === void 0 && (e3 = {});
    var u = _3e(r3);
    Ran(function() {
      var h = Tlt(e3.target, window);
      if (!!(h != null && h.addEventListener)) {
        var v4 = function(x3) {
          return u.current(x3);
        };
        return h.addEventListener(l3, v4, { capture: e3.capture, once: e3.once, passive: e3.passive }), function() {
          h.removeEventListener(l3, v4, { capture: e3.capture });
        };
      }
    }, [l3, e3.capture, e3.once, e3.passive], e3.target);
  }
  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.
  
  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  var y5e = function(l3, r3) {
    return y5e = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(e3, u) {
      e3.__proto__ = u;
    } || function(e3, u) {
      for (var h in u)
        Object.prototype.hasOwnProperty.call(u, h) && (e3[h] = u[h]);
    }, y5e(l3, r3);
  };
  function ar(l3, r3) {
    if (typeof r3 != "function" && r3 !== null)
      throw new TypeError("Class extends value " + String(r3) + " is not a constructor or null");
    y5e(l3, r3);
    function e3() {
      this.constructor = l3;
    }
    l3.prototype = r3 === null ? Object.create(r3) : (e3.prototype = r3.prototype, new e3());
  }
  var Won = function() {
    function l3() {
      this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
    }
    return l3;
  }(), Uon = function() {
    function l3() {
      this.browser = new Won(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
    }
    return l3;
  }(), gN = new Uon();
  typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (gN.wxa = true, gN.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? gN.worker = true : typeof navigator == "undefined" ? (gN.node = true, gN.svgSupported = true) : qon(navigator.userAgent, gN);
  function qon(l3, r3) {
    var e3 = r3.browser, u = l3.match(/Firefox\/([\d.]+)/), h = l3.match(/MSIE\s([\d.]+)/) || l3.match(/Trident\/.+?rv:(([\d.]+))/), v4 = l3.match(/Edge?\/([\d.]+)/), m3 = /micromessenger/i.test(l3);
    u && (e3.firefox = true, e3.version = u[1]), h && (e3.ie = true, e3.version = h[1]), v4 && (e3.edge = true, e3.version = v4[1], e3.newEdge = +v4[1].split(".")[0] > 18), m3 && (e3.weChat = true), r3.svgSupported = typeof SVGRect != "undefined", r3.touchEventsSupported = "ontouchstart" in window && !e3.ie && !e3.edge, r3.pointerEventsSupported = "onpointerdown" in window && (e3.edge || e3.ie && +e3.version >= 11), r3.domSupported = typeof document != "undefined";
    var x3 = document.documentElement.style;
    r3.transform3dSupported = (e3.ie && "transition" in x3 || e3.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in x3) && !("OTransition" in x3), r3.transformSupported = r3.transform3dSupported || e3.ie && +e3.version >= 9;
  }
  var Fc = gN, w3e = 12, klt = "sans-serif", KO = w3e + "px " + klt, $on = 20, Xon = 100, Yon = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
  function Kon(l3) {
    var r3 = {};
    if (typeof JSON == "undefined")
      return r3;
    for (var e3 = 0; e3 < l3.length; e3++) {
      var u = String.fromCharCode(e3 + 32), h = (l3.charCodeAt(e3) - $on) / Xon;
      r3[u] = h;
    }
    return r3;
  }
  var Zon = Kon(Yon), l5 = { createCanvas: function() {
    return typeof document != "undefined" && document.createElement("canvas");
  }, measureText: function() {
    var l3, r3;
    return function(e3, u) {
      if (!l3) {
        var h = l5.createCanvas();
        l3 = h && h.getContext("2d");
      }
      if (l3)
        return r3 !== u && (r3 = l3.font = u || KO), l3.measureText(e3);
      e3 = e3 || "", u = u || KO;
      var v4 = /^([0-9]*?)px$/.exec(u), m3 = +(v4 && v4[1]) || w3e, x3 = 0;
      if (u.indexOf("mono") >= 0)
        x3 = m3 * e3.length;
      else
        for (var C = 0; C < e3.length; C++) {
          var A2 = Zon[e3[C]];
          x3 += A2 == null ? m3 : A2 * m3;
        }
      return { width: x3 };
    };
  }(), loadImage: function(l3, r3, e3) {
    var u = new Image();
    return u.onload = r3, u.onerror = e3, u.src = l3, u;
  } }, Olt = WA(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(l3, r3) {
    return l3["[object " + r3 + "]"] = true, l3;
  }, {}), Plt = WA(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(l3, r3) {
    return l3["[object " + r3 + "Array]"] = true, l3;
  }, {}), bj = Object.prototype.toString, Fhe = Array.prototype, Jon = Fhe.forEach, Qon = Fhe.filter, S3e = Fhe.slice, esn = Fhe.map, Ket = function() {
  }.constructor, oce = Ket ? Ket.prototype : null, C3e = "__proto__", tsn = 2311;
  function Llt() {
    return tsn++;
  }
  function M3e() {
    for (var l3 = [], r3 = 0; r3 < arguments.length; r3++)
      l3[r3] = arguments[r3];
    typeof console != "undefined" && console.error.apply(console, l3);
  }
  function bs(l3) {
    if (l3 == null || typeof l3 != "object")
      return l3;
    var r3 = l3, e3 = bj.call(l3);
    if (e3 === "[object Array]") {
      if (!OZ(l3)) {
        r3 = [];
        for (var u = 0, h = l3.length; u < h; u++)
          r3[u] = bs(l3[u]);
      }
    } else if (Plt[e3]) {
      if (!OZ(l3)) {
        var v4 = l3.constructor;
        if (v4.from)
          r3 = v4.from(l3);
        else {
          r3 = new v4(l3.length);
          for (var u = 0, h = l3.length; u < h; u++)
            r3[u] = l3[u];
        }
      }
    } else if (!Olt[e3] && !OZ(l3) && !ZZ(l3)) {
      r3 = {};
      for (var m3 in l3)
        l3.hasOwnProperty(m3) && m3 !== C3e && (r3[m3] = bs(l3[m3]));
    }
    return r3;
  }
  function ol(l3, r3, e3) {
    if (!ls(r3) || !ls(l3))
      return e3 ? bs(r3) : l3;
    for (var u in r3)
      if (r3.hasOwnProperty(u) && u !== C3e) {
        var h = l3[u], v4 = r3[u];
        ls(v4) && ls(h) && !Ni(v4) && !Ni(h) && !ZZ(v4) && !ZZ(h) && !Zet(v4) && !Zet(h) && !OZ(v4) && !OZ(h) ? ol(h, v4, e3) : (e3 || !(u in l3)) && (l3[u] = bs(r3[u]));
      }
    return l3;
  }
  function T3e(l3, r3) {
    for (var e3 = l3[0], u = 1, h = l3.length; u < h; u++)
      e3 = ol(e3, l3[u], r3);
    return e3;
  }
  function fi(l3, r3) {
    if (Object.assign)
      Object.assign(l3, r3);
    else
      for (var e3 in r3)
        r3.hasOwnProperty(e3) && e3 !== C3e && (l3[e3] = r3[e3]);
    return l3;
  }
  function ns(l3, r3, e3) {
    for (var u = yu(r3), h = 0; h < u.length; h++) {
      var v4 = u[h];
      (e3 ? r3[v4] != null : l3[v4] == null) && (l3[v4] = r3[v4]);
    }
    return l3;
  }
  function Cl(l3, r3) {
    if (l3) {
      if (l3.indexOf)
        return l3.indexOf(r3);
      for (var e3 = 0, u = l3.length; e3 < u; e3++)
        if (l3[e3] === r3)
          return e3;
    }
    return -1;
  }
  function nsn(l3, r3) {
    var e3 = l3.prototype;
    function u() {
    }
    u.prototype = r3.prototype, l3.prototype = new u();
    for (var h in e3)
      e3.hasOwnProperty(h) && (l3.prototype[h] = e3[h]);
    l3.prototype.constructor = l3, l3.superClass = r3;
  }
  function Fv(l3, r3, e3) {
    if (l3 = "prototype" in l3 ? l3.prototype : l3, r3 = "prototype" in r3 ? r3.prototype : r3, Object.getOwnPropertyNames)
      for (var u = Object.getOwnPropertyNames(r3), h = 0; h < u.length; h++) {
        var v4 = u[h];
        v4 !== "constructor" && (e3 ? r3[v4] != null : l3[v4] == null) && (l3[v4] = r3[v4]);
      }
    else
      ns(l3, r3, e3);
  }
  function m1(l3) {
    return !l3 || typeof l3 == "string" ? false : typeof l3.length == "number";
  }
  function mt(l3, r3, e3) {
    if (!!(l3 && r3))
      if (l3.forEach && l3.forEach === Jon)
        l3.forEach(r3, e3);
      else if (l3.length === +l3.length)
        for (var u = 0, h = l3.length; u < h; u++)
          r3.call(e3, l3[u], u, l3);
      else
        for (var v4 in l3)
          l3.hasOwnProperty(v4) && r3.call(e3, l3[v4], v4, l3);
  }
  function Bi(l3, r3, e3) {
    if (!l3)
      return [];
    if (!r3)
      return A3e(l3);
    if (l3.map && l3.map === esn)
      return l3.map(r3, e3);
    for (var u = [], h = 0, v4 = l3.length; h < v4; h++)
      u.push(r3.call(e3, l3[h], h, l3));
    return u;
  }
  function WA(l3, r3, e3, u) {
    if (!!(l3 && r3)) {
      for (var h = 0, v4 = l3.length; h < v4; h++)
        e3 = r3.call(u, e3, l3[h], h, l3);
      return e3;
    }
  }
  function jf(l3, r3, e3) {
    if (!l3)
      return [];
    if (!r3)
      return A3e(l3);
    if (l3.filter && l3.filter === Qon)
      return l3.filter(r3, e3);
    for (var u = [], h = 0, v4 = l3.length; h < v4; h++)
      r3.call(e3, l3[h], h, l3) && u.push(l3[h]);
    return u;
  }
  function rsn(l3, r3, e3) {
    if (!!(l3 && r3)) {
      for (var u = 0, h = l3.length; u < h; u++)
        if (r3.call(e3, l3[u], u, l3))
          return l3[u];
    }
  }
  function yu(l3) {
    if (!l3)
      return [];
    if (Object.keys)
      return Object.keys(l3);
    var r3 = [];
    for (var e3 in l3)
      l3.hasOwnProperty(e3) && r3.push(e3);
    return r3;
  }
  function isn(l3, r3) {
    for (var e3 = [], u = 2; u < arguments.length; u++)
      e3[u - 2] = arguments[u];
    return function() {
      return l3.apply(r3, e3.concat(S3e.call(arguments)));
    };
  }
  var no = oce && Xo(oce.bind) ? oce.call.bind(oce.bind) : isn;
  function Fs(l3) {
    for (var r3 = [], e3 = 1; e3 < arguments.length; e3++)
      r3[e3 - 1] = arguments[e3];
    return function() {
      return l3.apply(this, r3.concat(S3e.call(arguments)));
    };
  }
  function Ni(l3) {
    return Array.isArray ? Array.isArray(l3) : bj.call(l3) === "[object Array]";
  }
  function Xo(l3) {
    return typeof l3 == "function";
  }
  function qa(l3) {
    return typeof l3 == "string";
  }
  function m5e(l3) {
    return bj.call(l3) === "[object String]";
  }
  function Vc(l3) {
    return typeof l3 == "number";
  }
  function ls(l3) {
    var r3 = typeof l3;
    return r3 === "function" || !!l3 && r3 === "object";
  }
  function Zet(l3) {
    return !!Olt[bj.call(l3)];
  }
  function ew(l3) {
    return !!Plt[bj.call(l3)];
  }
  function ZZ(l3) {
    return typeof l3 == "object" && typeof l3.nodeType == "number" && typeof l3.ownerDocument == "object";
  }
  function Vhe(l3) {
    return l3.colorStops != null;
  }
  function asn(l3) {
    return l3.image != null;
  }
  function osn(l3) {
    return bj.call(l3) === "[object RegExp]";
  }
  function JZ(l3) {
    return l3 !== l3;
  }
  function ey() {
    for (var l3 = [], r3 = 0; r3 < arguments.length; r3++)
      l3[r3] = arguments[r3];
    for (var e3 = 0, u = l3.length; e3 < u; e3++)
      if (l3[e3] != null)
        return l3[e3];
  }
  function dl(l3, r3) {
    return l3 != null ? l3 : r3;
  }
  function t5(l3, r3, e3) {
    return l3 != null ? l3 : r3 != null ? r3 : e3;
  }
  function A3e(l3) {
    for (var r3 = [], e3 = 1; e3 < arguments.length; e3++)
      r3[e3 - 1] = arguments[e3];
    return S3e.apply(l3, r3);
  }
  function I3e(l3) {
    if (typeof l3 == "number")
      return [l3, l3, l3, l3];
    var r3 = l3.length;
    return r3 === 2 ? [l3[0], l3[1], l3[0], l3[1]] : r3 === 3 ? [l3[0], l3[1], l3[2], l3[1]] : l3;
  }
  function mb(l3, r3) {
    if (!l3)
      throw new Error(r3);
  }
  function hM(l3) {
    return l3 == null ? null : typeof l3.trim == "function" ? l3.trim() : l3.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
  }
  var Rlt = "__ec_primitive__";
  function Ffe(l3) {
    l3[Rlt] = true;
  }
  function OZ(l3) {
    return l3[Rlt];
  }
  var ssn = function() {
    function l3(r3) {
      this.data = {};
      var e3 = Ni(r3);
      this.data = {};
      var u = this;
      r3 instanceof l3 ? r3.each(h) : r3 && mt(r3, h);
      function h(v4, m3) {
        e3 ? u.set(v4, m3) : u.set(m3, v4);
      }
    }
    return l3.prototype.get = function(r3) {
      return this.data.hasOwnProperty(r3) ? this.data[r3] : null;
    }, l3.prototype.set = function(r3, e3) {
      return this.data[r3] = e3;
    }, l3.prototype.each = function(r3, e3) {
      for (var u in this.data)
        this.data.hasOwnProperty(u) && r3.call(e3, this.data[u], u);
    }, l3.prototype.keys = function() {
      return yu(this.data);
    }, l3.prototype.removeKey = function(r3) {
      delete this.data[r3];
    }, l3;
  }();
  function Ho(l3) {
    return new ssn(l3);
  }
  function b5e(l3, r3) {
    for (var e3 = new l3.constructor(l3.length + r3.length), u = 0; u < l3.length; u++)
      e3[u] = l3[u];
    for (var h = l3.length, u = 0; u < r3.length; u++)
      e3[u + h] = r3[u];
    return e3;
  }
  function Bhe(l3, r3) {
    var e3;
    if (Object.create)
      e3 = Object.create(l3);
    else {
      var u = function() {
      };
      u.prototype = l3, e3 = new u();
    }
    return r3 && fi(e3, r3), e3;
  }
  function Nlt(l3) {
    var r3 = l3.style;
    r3.webkitUserSelect = "none", r3.userSelect = "none", r3.webkitTapHighlightColor = "rgba(0,0,0,0)", r3["-webkit-touch-callout"] = "none";
  }
  function vo(l3, r3) {
    return l3.hasOwnProperty(r3);
  }
  function Rv() {
  }
  var vfe = 180 / Math.PI;
  function KN(l3, r3) {
    return l3 == null && (l3 = 0), r3 == null && (r3 = 0), [l3, r3];
  }
  function db(l3, r3) {
    return l3[0] = r3[0], l3[1] = r3[1], l3;
  }
  function n5(l3) {
    return [l3[0], l3[1]];
  }
  function lsn(l3, r3, e3) {
    return l3[0] = r3, l3[1] = e3, l3;
  }
  function Jet(l3, r3, e3) {
    return l3[0] = r3[0] + e3[0], l3[1] = r3[1] + e3[1], l3;
  }
  function _5e(l3, r3, e3, u) {
    return l3[0] = r3[0] + e3[0] * u, l3[1] = r3[1] + e3[1] * u, l3;
  }
  function IN(l3, r3, e3) {
    return l3[0] = r3[0] - e3[0], l3[1] = r3[1] - e3[1], l3;
  }
  function x5e(l3) {
    return Math.sqrt(usn(l3));
  }
  function usn(l3) {
    return l3[0] * l3[0] + l3[1] * l3[1];
  }
  function VIe(l3, r3, e3) {
    return l3[0] = r3[0] * e3, l3[1] = r3[1] * e3, l3;
  }
  function IJ(l3, r3) {
    var e3 = x5e(r3);
    return e3 === 0 ? (l3[0] = 0, l3[1] = 0) : (l3[0] = r3[0] / e3, l3[1] = r3[1] / e3), l3;
  }
  function w5e(l3, r3) {
    return Math.sqrt((l3[0] - r3[0]) * (l3[0] - r3[0]) + (l3[1] - r3[1]) * (l3[1] - r3[1]));
  }
  var RO = w5e;
  function csn(l3, r3) {
    return (l3[0] - r3[0]) * (l3[0] - r3[0]) + (l3[1] - r3[1]) * (l3[1] - r3[1]);
  }
  var LN = csn;
  function gfe(l3, r3, e3, u) {
    return l3[0] = r3[0] + u * (e3[0] - r3[0]), l3[1] = r3[1] + u * (e3[1] - r3[1]), l3;
  }
  function am(l3, r3, e3) {
    var u = r3[0], h = r3[1];
    return l3[0] = e3[0] * u + e3[2] * h + e3[4], l3[1] = e3[1] * u + e3[3] * h + e3[5], l3;
  }
  function NO(l3, r3, e3) {
    return l3[0] = Math.min(r3[0], e3[0]), l3[1] = Math.min(r3[1], e3[1]), l3;
  }
  function FO(l3, r3, e3) {
    return l3[0] = Math.max(r3[0], e3[0]), l3[1] = Math.max(r3[1], e3[1]), l3;
  }
  var xz = function() {
    function l3(r3, e3) {
      this.target = r3, this.topTarget = e3 && e3.topTarget;
    }
    return l3;
  }(), fsn = function() {
    function l3(r3) {
      this.handler = r3, r3.on("mousedown", this._dragStart, this), r3.on("mousemove", this._drag, this), r3.on("mouseup", this._dragEnd, this);
    }
    return l3.prototype._dragStart = function(r3) {
      for (var e3 = r3.target; e3 && !e3.draggable; )
        e3 = e3.parent || e3.__hostTarget;
      e3 && (this._draggingTarget = e3, e3.dragging = true, this._x = r3.offsetX, this._y = r3.offsetY, this.handler.dispatchToElement(new xz(e3, r3), "dragstart", r3.event));
    }, l3.prototype._drag = function(r3) {
      var e3 = this._draggingTarget;
      if (e3) {
        var u = r3.offsetX, h = r3.offsetY, v4 = u - this._x, m3 = h - this._y;
        this._x = u, this._y = h, e3.drift(v4, m3, r3), this.handler.dispatchToElement(new xz(e3, r3), "drag", r3.event);
        var x3 = this.handler.findHover(u, h, e3).target, C = this._dropTarget;
        this._dropTarget = x3, e3 !== x3 && (C && x3 !== C && this.handler.dispatchToElement(new xz(C, r3), "dragleave", r3.event), x3 && x3 !== C && this.handler.dispatchToElement(new xz(x3, r3), "dragenter", r3.event));
      }
    }, l3.prototype._dragEnd = function(r3) {
      var e3 = this._draggingTarget;
      e3 && (e3.dragging = false), this.handler.dispatchToElement(new xz(e3, r3), "dragend", r3.event), this._dropTarget && this.handler.dispatchToElement(new xz(this._dropTarget, r3), "drop", r3.event), this._draggingTarget = null, this._dropTarget = null;
    }, l3;
  }(), hsn = fsn, psn = function() {
    function l3(r3) {
      r3 && (this._$eventProcessor = r3);
    }
    return l3.prototype.on = function(r3, e3, u, h) {
      this._$handlers || (this._$handlers = {});
      var v4 = this._$handlers;
      if (typeof e3 == "function" && (h = u, u = e3, e3 = null), !u || !r3)
        return this;
      var m3 = this._$eventProcessor;
      e3 != null && m3 && m3.normalizeQuery && (e3 = m3.normalizeQuery(e3)), v4[r3] || (v4[r3] = []);
      for (var x3 = 0; x3 < v4[r3].length; x3++)
        if (v4[r3][x3].h === u)
          return this;
      var C = { h: u, query: e3, ctx: h || this, callAtLast: u.zrEventfulCallAtLast }, A2 = v4[r3].length - 1, D = v4[r3][A2];
      return D && D.callAtLast ? v4[r3].splice(A2, 0, C) : v4[r3].push(C), this;
    }, l3.prototype.isSilent = function(r3) {
      var e3 = this._$handlers;
      return !e3 || !e3[r3] || !e3[r3].length;
    }, l3.prototype.off = function(r3, e3) {
      var u = this._$handlers;
      if (!u)
        return this;
      if (!r3)
        return this._$handlers = {}, this;
      if (e3) {
        if (u[r3]) {
          for (var h = [], v4 = 0, m3 = u[r3].length; v4 < m3; v4++)
            u[r3][v4].h !== e3 && h.push(u[r3][v4]);
          u[r3] = h;
        }
        u[r3] && u[r3].length === 0 && delete u[r3];
      } else
        delete u[r3];
      return this;
    }, l3.prototype.trigger = function(r3) {
      for (var e3 = [], u = 1; u < arguments.length; u++)
        e3[u - 1] = arguments[u];
      if (!this._$handlers)
        return this;
      var h = this._$handlers[r3], v4 = this._$eventProcessor;
      if (h)
        for (var m3 = e3.length, x3 = h.length, C = 0; C < x3; C++) {
          var A2 = h[C];
          if (!(v4 && v4.filter && A2.query != null && !v4.filter(r3, A2.query)))
            switch (m3) {
              case 0:
                A2.h.call(A2.ctx);
                break;
              case 1:
                A2.h.call(A2.ctx, e3[0]);
                break;
              case 2:
                A2.h.call(A2.ctx, e3[0], e3[1]);
                break;
              default:
                A2.h.apply(A2.ctx, e3);
                break;
            }
        }
      return v4 && v4.afterTrigger && v4.afterTrigger(r3), this;
    }, l3.prototype.triggerWithContext = function(r3) {
      for (var e3 = [], u = 1; u < arguments.length; u++)
        e3[u - 1] = arguments[u];
      if (!this._$handlers)
        return this;
      var h = this._$handlers[r3], v4 = this._$eventProcessor;
      if (h)
        for (var m3 = e3.length, x3 = e3[m3 - 1], C = h.length, A2 = 0; A2 < C; A2++) {
          var D = h[A2];
          if (!(v4 && v4.filter && D.query != null && !v4.filter(r3, D.query)))
            switch (m3) {
              case 0:
                D.h.call(x3);
                break;
              case 1:
                D.h.call(x3, e3[0]);
                break;
              case 2:
                D.h.call(x3, e3[0], e3[1]);
                break;
              default:
                D.h.apply(x3, e3.slice(1, m3 - 1));
                break;
            }
        }
      return v4 && v4.afterTrigger && v4.afterTrigger(r3), this;
    }, l3;
  }(), w2 = psn, dsn = Math.log(2);
  function S5e(l3, r3, e3, u, h, v4) {
    var m3 = u + "-" + h, x3 = l3.length;
    if (v4.hasOwnProperty(m3))
      return v4[m3];
    if (r3 === 1) {
      var C = Math.round(Math.log((1 << x3) - 1 & ~h) / dsn);
      return l3[e3][C];
    }
    for (var A2 = u | 1 << e3, D = e3 + 1; u & 1 << D; )
      D++;
    for (var P = 0, N = 0, j = 0; N < x3; N++) {
      var W = 1 << N;
      W & h || (P += (j % 2 ? -1 : 1) * l3[e3][N] * S5e(l3, r3 - 1, D, A2, h | W, v4), j++);
    }
    return v4[m3] = P, P;
  }
  function Qet(l3, r3) {
    var e3 = [[l3[0], l3[1], 1, 0, 0, 0, -r3[0] * l3[0], -r3[0] * l3[1]], [0, 0, 0, l3[0], l3[1], 1, -r3[1] * l3[0], -r3[1] * l3[1]], [l3[2], l3[3], 1, 0, 0, 0, -r3[2] * l3[2], -r3[2] * l3[3]], [0, 0, 0, l3[2], l3[3], 1, -r3[3] * l3[2], -r3[3] * l3[3]], [l3[4], l3[5], 1, 0, 0, 0, -r3[4] * l3[4], -r3[4] * l3[5]], [0, 0, 0, l3[4], l3[5], 1, -r3[5] * l3[4], -r3[5] * l3[5]], [l3[6], l3[7], 1, 0, 0, 0, -r3[6] * l3[6], -r3[6] * l3[7]], [0, 0, 0, l3[6], l3[7], 1, -r3[7] * l3[6], -r3[7] * l3[7]]], u = {}, h = S5e(e3, 8, 0, 0, 0, u);
    if (h !== 0) {
      for (var v4 = [], m3 = 0; m3 < 8; m3++)
        for (var x3 = 0; x3 < 8; x3++)
          v4[x3] == null && (v4[x3] = 0), v4[x3] += ((m3 + x3) % 2 ? -1 : 1) * S5e(e3, 7, m3 === 0 ? 1 : 0, 1 << m3, 1 << x3, u) / h * r3[m3];
      return function(C, A2, D) {
        var P = A2 * v4[6] + D * v4[7] + 1;
        C[0] = (A2 * v4[0] + D * v4[1] + v4[2]) / P, C[1] = (A2 * v4[3] + D * v4[4] + v4[5]) / P;
      };
    }
  }
  var ett = "___zrEVENTSAVED", BIe = [];
  function vsn(l3, r3, e3, u, h) {
    return C5e(BIe, r3, u, h, true) && C5e(l3, e3, BIe[0], BIe[1]);
  }
  function C5e(l3, r3, e3, u, h) {
    if (r3.getBoundingClientRect && Fc.domSupported && !Flt(r3)) {
      var v4 = r3[ett] || (r3[ett] = {}), m3 = gsn(r3, v4), x3 = ysn(m3, v4, h);
      if (x3)
        return x3(l3, e3, u), true;
    }
    return false;
  }
  function gsn(l3, r3) {
    var e3 = r3.markers;
    if (e3)
      return e3;
    e3 = r3.markers = [];
    for (var u = ["left", "right"], h = ["top", "bottom"], v4 = 0; v4 < 4; v4++) {
      var m3 = document.createElement("div"), x3 = m3.style, C = v4 % 2, A2 = (v4 >> 1) % 2;
      x3.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", u[C] + ":0", h[A2] + ":0", u[1 - C] + ":auto", h[1 - A2] + ":auto", ""].join("!important;"), l3.appendChild(m3), e3.push(m3);
    }
    return e3;
  }
  function ysn(l3, r3, e3) {
    for (var u = e3 ? "invTrans" : "trans", h = r3[u], v4 = r3.srcCoords, m3 = [], x3 = [], C = true, A2 = 0; A2 < 4; A2++) {
      var D = l3[A2].getBoundingClientRect(), P = 2 * A2, N = D.left, j = D.top;
      m3.push(N, j), C = C && v4 && N === v4[P] && j === v4[P + 1], x3.push(l3[A2].offsetLeft, l3[A2].offsetTop);
    }
    return C && h ? h : (r3.srcCoords = m3, r3[u] = e3 ? Qet(x3, m3) : Qet(m3, x3));
  }
  function Flt(l3) {
    return l3.nodeName.toUpperCase() === "CANVAS";
  }
  var msn = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, zIe = [], bsn = Fc.browser.firefox && +Fc.browser.version.split(".")[0] < 39;
  function M5e(l3, r3, e3, u) {
    return e3 = e3 || {}, u ? ttt(l3, r3, e3) : bsn && r3.layerX != null && r3.layerX !== r3.offsetX ? (e3.zrX = r3.layerX, e3.zrY = r3.layerY) : r3.offsetX != null ? (e3.zrX = r3.offsetX, e3.zrY = r3.offsetY) : ttt(l3, r3, e3), e3;
  }
  function ttt(l3, r3, e3) {
    if (Fc.domSupported && l3.getBoundingClientRect) {
      var u = r3.clientX, h = r3.clientY;
      if (Flt(l3)) {
        var v4 = l3.getBoundingClientRect();
        e3.zrX = u - v4.left, e3.zrY = h - v4.top;
        return;
      } else if (C5e(zIe, l3, u, h)) {
        e3.zrX = zIe[0], e3.zrY = zIe[1];
        return;
      }
    }
    e3.zrX = e3.zrY = 0;
  }
  function E3e(l3) {
    return l3 || window.event;
  }
  function s2(l3, r3, e3) {
    if (r3 = E3e(r3), r3.zrX != null)
      return r3;
    var u = r3.type, h = u && u.indexOf("touch") >= 0;
    if (h) {
      var m3 = u !== "touchend" ? r3.targetTouches[0] : r3.changedTouches[0];
      m3 && M5e(l3, m3, r3, e3);
    } else {
      M5e(l3, r3, r3, e3);
      var v4 = _sn(r3);
      r3.zrDelta = v4 ? v4 / 120 : -(r3.detail || 0) / 3;
    }
    var x3 = r3.button;
    return r3.which == null && x3 !== void 0 && msn.test(r3.type) && (r3.which = x3 & 1 ? 1 : x3 & 2 ? 3 : x3 & 4 ? 2 : 0), r3;
  }
  function _sn(l3) {
    var r3 = l3.wheelDelta;
    if (r3)
      return r3;
    var e3 = l3.deltaX, u = l3.deltaY;
    if (e3 == null || u == null)
      return r3;
    var h = Math.abs(u !== 0 ? u : e3), v4 = u > 0 ? -1 : u < 0 ? 1 : e3 > 0 ? -1 : 1;
    return 3 * h * v4;
  }
  function T5e(l3, r3, e3, u) {
    l3.addEventListener(r3, e3, u);
  }
  function xsn(l3, r3, e3, u) {
    l3.removeEventListener(r3, e3, u);
  }
  var u5 = function(l3) {
    l3.preventDefault(), l3.stopPropagation(), l3.cancelBubble = true;
  };
  function ntt(l3) {
    return l3.which === 2 || l3.which === 3;
  }
  var wsn = function() {
    function l3() {
      this._track = [];
    }
    return l3.prototype.recognize = function(r3, e3, u) {
      return this._doTrack(r3, e3, u), this._recognize(r3);
    }, l3.prototype.clear = function() {
      return this._track.length = 0, this;
    }, l3.prototype._doTrack = function(r3, e3, u) {
      var h = r3.touches;
      if (!!h) {
        for (var v4 = { points: [], touches: [], target: e3, event: r3 }, m3 = 0, x3 = h.length; m3 < x3; m3++) {
          var C = h[m3], A2 = M5e(u, C, {});
          v4.points.push([A2.zrX, A2.zrY]), v4.touches.push(C);
        }
        this._track.push(v4);
      }
    }, l3.prototype._recognize = function(r3) {
      for (var e3 in jIe)
        if (jIe.hasOwnProperty(e3)) {
          var u = jIe[e3](this._track, r3);
          if (u)
            return u;
        }
    }, l3;
  }();
  function rtt(l3) {
    var r3 = l3[1][0] - l3[0][0], e3 = l3[1][1] - l3[0][1];
    return Math.sqrt(r3 * r3 + e3 * e3);
  }
  function Ssn(l3) {
    return [(l3[0][0] + l3[1][0]) / 2, (l3[0][1] + l3[1][1]) / 2];
  }
  var jIe = { pinch: function(l3, r3) {
    var e3 = l3.length;
    if (!!e3) {
      var u = (l3[e3 - 1] || {}).points, h = (l3[e3 - 2] || {}).points || u;
      if (h && h.length > 1 && u && u.length > 1) {
        var v4 = rtt(u) / rtt(h);
        !isFinite(v4) && (v4 = 1), r3.pinchScale = v4;
        var m3 = Ssn(u);
        return r3.pinchX = m3[0], r3.pinchY = m3[1], { type: "pinch", target: l3[0].target, event: r3 };
      }
    }
  } }, Vlt = "silent";
  function Csn(l3, r3, e3) {
    return { type: l3, event: e3, target: r3.target, topTarget: r3.topTarget, cancelBubble: false, offsetX: e3.zrX, offsetY: e3.zrY, gestureEvent: e3.gestureEvent, pinchX: e3.pinchX, pinchY: e3.pinchY, pinchScale: e3.pinchScale, wheelDelta: e3.zrDelta, zrByTouch: e3.zrByTouch, which: e3.which, stop: Msn };
  }
  function Msn() {
    u5(this.event);
  }
  var Tsn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.handler = null, e3;
    }
    return r3.prototype.dispose = function() {
    }, r3.prototype.setCursor = function() {
    }, r3;
  }(w2), jK = function() {
    function l3(r3, e3) {
      this.x = r3, this.y = e3;
    }
    return l3;
  }(), Asn = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], Blt = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4) {
      var m3 = l3.call(this) || this;
      return m3._hovered = new jK(0, 0), m3.storage = e3, m3.painter = u, m3.painterRoot = v4, h = h || new Tsn(), m3.proxy = null, m3.setHandlerProxy(h), m3._draggingMgr = new hsn(m3), m3;
    }
    return r3.prototype.setHandlerProxy = function(e3) {
      this.proxy && this.proxy.dispose(), e3 && (mt(Asn, function(u) {
        e3.on && e3.on(u, this[u], this);
      }, this), e3.handler = this), this.proxy = e3;
    }, r3.prototype.mousemove = function(e3) {
      var u = e3.zrX, h = e3.zrY, v4 = zlt(this, u, h), m3 = this._hovered, x3 = m3.target;
      x3 && !x3.__zr && (m3 = this.findHover(m3.x, m3.y), x3 = m3.target);
      var C = this._hovered = v4 ? new jK(u, h) : this.findHover(u, h), A2 = C.target, D = this.proxy;
      D.setCursor && D.setCursor(A2 ? A2.cursor : "default"), x3 && A2 !== x3 && this.dispatchToElement(m3, "mouseout", e3), this.dispatchToElement(C, "mousemove", e3), A2 && A2 !== x3 && this.dispatchToElement(C, "mouseover", e3);
    }, r3.prototype.mouseout = function(e3) {
      var u = e3.zrEventControl;
      u !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", e3), u !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: e3 });
    }, r3.prototype.resize = function() {
      this._hovered = new jK(0, 0);
    }, r3.prototype.dispatch = function(e3, u) {
      var h = this[e3];
      h && h.call(this, u);
    }, r3.prototype.dispose = function() {
      this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
    }, r3.prototype.setCursorStyle = function(e3) {
      var u = this.proxy;
      u.setCursor && u.setCursor(e3);
    }, r3.prototype.dispatchToElement = function(e3, u, h) {
      e3 = e3 || {};
      var v4 = e3.target;
      if (!(v4 && v4.silent)) {
        for (var m3 = "on" + u, x3 = Csn(u, e3, h); v4 && (v4[m3] && (x3.cancelBubble = !!v4[m3].call(v4, x3)), v4.trigger(u, x3), v4 = v4.__hostTarget ? v4.__hostTarget : v4.parent, !x3.cancelBubble); )
          ;
        x3.cancelBubble || (this.trigger(u, x3), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(C) {
          typeof C[m3] == "function" && C[m3].call(C, x3), C.trigger && C.trigger(u, x3);
        }));
      }
    }, r3.prototype.findHover = function(e3, u, h) {
      for (var v4 = this.storage.getDisplayList(), m3 = new jK(e3, u), x3 = v4.length - 1; x3 >= 0; x3--) {
        var C = void 0;
        if (v4[x3] !== h && !v4[x3].ignore && (C = Isn(v4[x3], e3, u)) && (!m3.topTarget && (m3.topTarget = v4[x3]), C !== Vlt)) {
          m3.target = v4[x3];
          break;
        }
      }
      return m3;
    }, r3.prototype.processGesture = function(e3, u) {
      this._gestureMgr || (this._gestureMgr = new wsn());
      var h = this._gestureMgr;
      u === "start" && h.clear();
      var v4 = h.recognize(e3, this.findHover(e3.zrX, e3.zrY, null).target, this.proxy.dom);
      if (u === "end" && h.clear(), v4) {
        var m3 = v4.type;
        e3.gestureEvent = m3;
        var x3 = new jK();
        x3.target = v4.target, this.dispatchToElement(x3, m3, v4.event);
      }
    }, r3;
  }(w2);
  mt(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(l3) {
    Blt.prototype[l3] = function(r3) {
      var e3 = r3.zrX, u = r3.zrY, h = zlt(this, e3, u), v4, m3;
      if ((l3 !== "mouseup" || !h) && (v4 = this.findHover(e3, u), m3 = v4.target), l3 === "mousedown")
        this._downEl = m3, this._downPoint = [r3.zrX, r3.zrY], this._upEl = m3;
      else if (l3 === "mouseup")
        this._upEl = m3;
      else if (l3 === "click") {
        if (this._downEl !== this._upEl || !this._downPoint || RO(this._downPoint, [r3.zrX, r3.zrY]) > 4)
          return;
        this._downPoint = null;
      }
      this.dispatchToElement(v4, l3, r3);
    };
  });
  function Isn(l3, r3, e3) {
    if (l3[l3.rectHover ? "rectContain" : "contain"](r3, e3)) {
      for (var u = l3, h = void 0, v4 = false; u; ) {
        if (u.ignoreClip && (v4 = true), !v4) {
          var m3 = u.getClipPath();
          if (m3 && !m3.contain(r3, e3))
            return false;
          u.silent && (h = true);
        }
        var x3 = u.__hostTarget;
        u = x3 || u.parent;
      }
      return h ? Vlt : true;
    }
    return false;
  }
  function zlt(l3, r3, e3) {
    var u = l3.painter;
    return r3 < 0 || r3 > u.getWidth() || e3 < 0 || e3 > u.getHeight();
  }
  var Esn = Blt, jlt = 32, GK = 7;
  function Dsn(l3) {
    for (var r3 = 0; l3 >= jlt; )
      r3 |= l3 & 1, l3 >>= 1;
    return l3 + r3;
  }
  function itt(l3, r3, e3, u) {
    var h = r3 + 1;
    if (h === e3)
      return 1;
    if (u(l3[h++], l3[r3]) < 0) {
      for (; h < e3 && u(l3[h], l3[h - 1]) < 0; )
        h++;
      ksn(l3, r3, h);
    } else
      for (; h < e3 && u(l3[h], l3[h - 1]) >= 0; )
        h++;
    return h - r3;
  }
  function ksn(l3, r3, e3) {
    for (e3--; r3 < e3; ) {
      var u = l3[r3];
      l3[r3++] = l3[e3], l3[e3--] = u;
    }
  }
  function att(l3, r3, e3, u, h) {
    for (u === r3 && u++; u < e3; u++) {
      for (var v4 = l3[u], m3 = r3, x3 = u, C; m3 < x3; )
        C = m3 + x3 >>> 1, h(v4, l3[C]) < 0 ? x3 = C : m3 = C + 1;
      var A2 = u - m3;
      switch (A2) {
        case 3:
          l3[m3 + 3] = l3[m3 + 2];
        case 2:
          l3[m3 + 2] = l3[m3 + 1];
        case 1:
          l3[m3 + 1] = l3[m3];
          break;
        default:
          for (; A2 > 0; )
            l3[m3 + A2] = l3[m3 + A2 - 1], A2--;
      }
      l3[m3] = v4;
    }
  }
  function GIe(l3, r3, e3, u, h, v4) {
    var m3 = 0, x3 = 0, C = 1;
    if (v4(l3, r3[e3 + h]) > 0) {
      for (x3 = u - h; C < x3 && v4(l3, r3[e3 + h + C]) > 0; )
        m3 = C, C = (C << 1) + 1, C <= 0 && (C = x3);
      C > x3 && (C = x3), m3 += h, C += h;
    } else {
      for (x3 = h + 1; C < x3 && v4(l3, r3[e3 + h - C]) <= 0; )
        m3 = C, C = (C << 1) + 1, C <= 0 && (C = x3);
      C > x3 && (C = x3);
      var A2 = m3;
      m3 = h - C, C = h - A2;
    }
    for (m3++; m3 < C; ) {
      var D = m3 + (C - m3 >>> 1);
      v4(l3, r3[e3 + D]) > 0 ? m3 = D + 1 : C = D;
    }
    return C;
  }
  function HIe(l3, r3, e3, u, h, v4) {
    var m3 = 0, x3 = 0, C = 1;
    if (v4(l3, r3[e3 + h]) < 0) {
      for (x3 = h + 1; C < x3 && v4(l3, r3[e3 + h - C]) < 0; )
        m3 = C, C = (C << 1) + 1, C <= 0 && (C = x3);
      C > x3 && (C = x3);
      var A2 = m3;
      m3 = h - C, C = h - A2;
    } else {
      for (x3 = u - h; C < x3 && v4(l3, r3[e3 + h + C]) >= 0; )
        m3 = C, C = (C << 1) + 1, C <= 0 && (C = x3);
      C > x3 && (C = x3), m3 += h, C += h;
    }
    for (m3++; m3 < C; ) {
      var D = m3 + (C - m3 >>> 1);
      v4(l3, r3[e3 + D]) < 0 ? C = D : m3 = D + 1;
    }
    return C;
  }
  function Osn(l3, r3) {
    var e3 = GK, u, h, v4 = 0, m3 = [];
    u = [], h = [];
    function x3(j, W) {
      u[v4] = j, h[v4] = W, v4 += 1;
    }
    function C() {
      for (; v4 > 1; ) {
        var j = v4 - 2;
        if (j >= 1 && h[j - 1] <= h[j] + h[j + 1] || j >= 2 && h[j - 2] <= h[j] + h[j - 1])
          h[j - 1] < h[j + 1] && j--;
        else if (h[j] > h[j + 1])
          break;
        D(j);
      }
    }
    function A2() {
      for (; v4 > 1; ) {
        var j = v4 - 2;
        j > 0 && h[j - 1] < h[j + 1] && j--, D(j);
      }
    }
    function D(j) {
      var W = u[j], K = h[j], te = u[j + 1], ne = h[j + 1];
      h[j] = K + ne, j === v4 - 3 && (u[j + 1] = u[j + 2], h[j + 1] = h[j + 2]), v4--;
      var ce = HIe(l3[te], l3, W, K, 0, r3);
      W += ce, K -= ce, K !== 0 && (ne = GIe(l3[W + K - 1], l3, te, ne, ne - 1, r3), ne !== 0 && (K <= ne ? P(W, K, te, ne) : N(W, K, te, ne)));
    }
    function P(j, W, K, te) {
      var ne = 0;
      for (ne = 0; ne < W; ne++)
        m3[ne] = l3[j + ne];
      var ce = 0, me = K, ve = j;
      if (l3[ve++] = l3[me++], --te === 0) {
        for (ne = 0; ne < W; ne++)
          l3[ve + ne] = m3[ce + ne];
        return;
      }
      if (W === 1) {
        for (ne = 0; ne < te; ne++)
          l3[ve + ne] = l3[me + ne];
        l3[ve + te] = m3[ce];
        return;
      }
      for (var Be = e3, Oe, We, Ue; ; ) {
        Oe = 0, We = 0, Ue = false;
        do
          if (r3(l3[me], m3[ce]) < 0) {
            if (l3[ve++] = l3[me++], We++, Oe = 0, --te === 0) {
              Ue = true;
              break;
            }
          } else if (l3[ve++] = m3[ce++], Oe++, We = 0, --W === 1) {
            Ue = true;
            break;
          }
        while ((Oe | We) < Be);
        if (Ue)
          break;
        do {
          if (Oe = HIe(l3[me], m3, ce, W, 0, r3), Oe !== 0) {
            for (ne = 0; ne < Oe; ne++)
              l3[ve + ne] = m3[ce + ne];
            if (ve += Oe, ce += Oe, W -= Oe, W <= 1) {
              Ue = true;
              break;
            }
          }
          if (l3[ve++] = l3[me++], --te === 0) {
            Ue = true;
            break;
          }
          if (We = GIe(m3[ce], l3, me, te, 0, r3), We !== 0) {
            for (ne = 0; ne < We; ne++)
              l3[ve + ne] = l3[me + ne];
            if (ve += We, me += We, te -= We, te === 0) {
              Ue = true;
              break;
            }
          }
          if (l3[ve++] = m3[ce++], --W === 1) {
            Ue = true;
            break;
          }
          Be--;
        } while (Oe >= GK || We >= GK);
        if (Ue)
          break;
        Be < 0 && (Be = 0), Be += 2;
      }
      if (e3 = Be, e3 < 1 && (e3 = 1), W === 1) {
        for (ne = 0; ne < te; ne++)
          l3[ve + ne] = l3[me + ne];
        l3[ve + te] = m3[ce];
      } else {
        if (W === 0)
          throw new Error();
        for (ne = 0; ne < W; ne++)
          l3[ve + ne] = m3[ce + ne];
      }
    }
    function N(j, W, K, te) {
      var ne = 0;
      for (ne = 0; ne < te; ne++)
        m3[ne] = l3[K + ne];
      var ce = j + W - 1, me = te - 1, ve = K + te - 1, Be = 0, Oe = 0;
      if (l3[ve--] = l3[ce--], --W === 0) {
        for (Be = ve - (te - 1), ne = 0; ne < te; ne++)
          l3[Be + ne] = m3[ne];
        return;
      }
      if (te === 1) {
        for (ve -= W, ce -= W, Oe = ve + 1, Be = ce + 1, ne = W - 1; ne >= 0; ne--)
          l3[Oe + ne] = l3[Be + ne];
        l3[ve] = m3[me];
        return;
      }
      for (var We = e3; ; ) {
        var Ue = 0, qe = 0, Ze = false;
        do
          if (r3(m3[me], l3[ce]) < 0) {
            if (l3[ve--] = l3[ce--], Ue++, qe = 0, --W === 0) {
              Ze = true;
              break;
            }
          } else if (l3[ve--] = m3[me--], qe++, Ue = 0, --te === 1) {
            Ze = true;
            break;
          }
        while ((Ue | qe) < We);
        if (Ze)
          break;
        do {
          if (Ue = W - HIe(m3[me], l3, j, W, W - 1, r3), Ue !== 0) {
            for (ve -= Ue, ce -= Ue, W -= Ue, Oe = ve + 1, Be = ce + 1, ne = Ue - 1; ne >= 0; ne--)
              l3[Oe + ne] = l3[Be + ne];
            if (W === 0) {
              Ze = true;
              break;
            }
          }
          if (l3[ve--] = m3[me--], --te === 1) {
            Ze = true;
            break;
          }
          if (qe = te - GIe(l3[ce], m3, 0, te, te - 1, r3), qe !== 0) {
            for (ve -= qe, me -= qe, te -= qe, Oe = ve + 1, Be = me + 1, ne = 0; ne < qe; ne++)
              l3[Oe + ne] = m3[Be + ne];
            if (te <= 1) {
              Ze = true;
              break;
            }
          }
          if (l3[ve--] = l3[ce--], --W === 0) {
            Ze = true;
            break;
          }
          We--;
        } while (Ue >= GK || qe >= GK);
        if (Ze)
          break;
        We < 0 && (We = 0), We += 2;
      }
      if (e3 = We, e3 < 1 && (e3 = 1), te === 1) {
        for (ve -= W, ce -= W, Oe = ve + 1, Be = ce + 1, ne = W - 1; ne >= 0; ne--)
          l3[Oe + ne] = l3[Be + ne];
        l3[ve] = m3[me];
      } else {
        if (te === 0)
          throw new Error();
        for (Be = ve - (te - 1), ne = 0; ne < te; ne++)
          l3[Be + ne] = m3[ne];
      }
    }
    return { mergeRuns: C, forceMergeRuns: A2, pushRun: x3 };
  }
  function yfe(l3, r3, e3, u) {
    e3 || (e3 = 0), u || (u = l3.length);
    var h = u - e3;
    if (!(h < 2)) {
      var v4 = 0;
      if (h < jlt) {
        v4 = itt(l3, e3, u, r3), att(l3, e3, u, e3 + v4, r3);
        return;
      }
      var m3 = Osn(l3, r3), x3 = Dsn(h);
      do {
        if (v4 = itt(l3, e3, u, r3), v4 < x3) {
          var C = h;
          C > x3 && (C = x3), att(l3, e3, e3 + C, e3 + v4, r3), v4 = C;
        }
        m3.pushRun(e3, v4), m3.mergeRuns(), h -= v4, e3 += v4;
      } while (h !== 0);
      m3.forceMergeRuns();
    }
  }
  var Kx = 1, bZ = 2, Hz = 4, ott = false;
  function WIe() {
    ott || (ott = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
  }
  function stt(l3, r3) {
    return l3.zlevel === r3.zlevel ? l3.z === r3.z ? l3.z2 - r3.z2 : l3.z - r3.z : l3.zlevel - r3.zlevel;
  }
  var Psn = function() {
    function l3() {
      this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = stt;
    }
    return l3.prototype.traverse = function(r3, e3) {
      for (var u = 0; u < this._roots.length; u++)
        this._roots[u].traverse(r3, e3);
    }, l3.prototype.getDisplayList = function(r3, e3) {
      e3 = e3 || false;
      var u = this._displayList;
      return (r3 || !u.length) && this.updateDisplayList(e3), u;
    }, l3.prototype.updateDisplayList = function(r3) {
      this._displayListLen = 0;
      for (var e3 = this._roots, u = this._displayList, h = 0, v4 = e3.length; h < v4; h++)
        this._updateAndAddDisplayable(e3[h], null, r3);
      u.length = this._displayListLen, yfe(u, stt);
    }, l3.prototype._updateAndAddDisplayable = function(r3, e3, u) {
      if (!(r3.ignore && !u)) {
        r3.beforeUpdate(), r3.update(), r3.afterUpdate();
        var h = r3.getClipPath();
        if (r3.ignoreClip)
          e3 = null;
        else if (h) {
          e3 ? e3 = e3.slice() : e3 = [];
          for (var v4 = h, m3 = r3; v4; )
            v4.parent = m3, v4.updateTransform(), e3.push(v4), m3 = v4, v4 = v4.getClipPath();
        }
        if (r3.childrenRef) {
          for (var x3 = r3.childrenRef(), C = 0; C < x3.length; C++) {
            var A2 = x3[C];
            r3.__dirty && (A2.__dirty |= Kx), this._updateAndAddDisplayable(A2, e3, u);
          }
          r3.__dirty = 0;
        } else {
          var D = r3;
          e3 && e3.length ? D.__clipPaths = e3 : D.__clipPaths && D.__clipPaths.length > 0 && (D.__clipPaths = []), isNaN(D.z) && (WIe(), D.z = 0), isNaN(D.z2) && (WIe(), D.z2 = 0), isNaN(D.zlevel) && (WIe(), D.zlevel = 0), this._displayList[this._displayListLen++] = D;
        }
        var P = r3.getDecalElement && r3.getDecalElement();
        P && this._updateAndAddDisplayable(P, e3, u);
        var N = r3.getTextGuideLine();
        N && this._updateAndAddDisplayable(N, e3, u);
        var j = r3.getTextContent();
        j && this._updateAndAddDisplayable(j, e3, u);
      }
    }, l3.prototype.addRoot = function(r3) {
      r3.__zr && r3.__zr.storage === this || this._roots.push(r3);
    }, l3.prototype.delRoot = function(r3) {
      if (r3 instanceof Array) {
        for (var e3 = 0, u = r3.length; e3 < u; e3++)
          this.delRoot(r3[e3]);
        return;
      }
      var h = Cl(this._roots, r3);
      h >= 0 && this._roots.splice(h, 1);
    }, l3.prototype.delAllRoots = function() {
      this._roots = [], this._displayList = [], this._displayListLen = 0;
    }, l3.prototype.getRoots = function() {
      return this._roots;
    }, l3.prototype.dispose = function() {
      this._displayList = null, this._roots = null;
    }, l3;
  }(), Lsn = Psn, Glt;
  Glt = Fc.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(l3) {
    return setTimeout(l3, 16);
  };
  var A5e = Glt, mfe = { linear: function(l3) {
    return l3;
  }, quadraticIn: function(l3) {
    return l3 * l3;
  }, quadraticOut: function(l3) {
    return l3 * (2 - l3);
  }, quadraticInOut: function(l3) {
    return (l3 *= 2) < 1 ? 0.5 * l3 * l3 : -0.5 * (--l3 * (l3 - 2) - 1);
  }, cubicIn: function(l3) {
    return l3 * l3 * l3;
  }, cubicOut: function(l3) {
    return --l3 * l3 * l3 + 1;
  }, cubicInOut: function(l3) {
    return (l3 *= 2) < 1 ? 0.5 * l3 * l3 * l3 : 0.5 * ((l3 -= 2) * l3 * l3 + 2);
  }, quarticIn: function(l3) {
    return l3 * l3 * l3 * l3;
  }, quarticOut: function(l3) {
    return 1 - --l3 * l3 * l3 * l3;
  }, quarticInOut: function(l3) {
    return (l3 *= 2) < 1 ? 0.5 * l3 * l3 * l3 * l3 : -0.5 * ((l3 -= 2) * l3 * l3 * l3 - 2);
  }, quinticIn: function(l3) {
    return l3 * l3 * l3 * l3 * l3;
  }, quinticOut: function(l3) {
    return --l3 * l3 * l3 * l3 * l3 + 1;
  }, quinticInOut: function(l3) {
    return (l3 *= 2) < 1 ? 0.5 * l3 * l3 * l3 * l3 * l3 : 0.5 * ((l3 -= 2) * l3 * l3 * l3 * l3 + 2);
  }, sinusoidalIn: function(l3) {
    return 1 - Math.cos(l3 * Math.PI / 2);
  }, sinusoidalOut: function(l3) {
    return Math.sin(l3 * Math.PI / 2);
  }, sinusoidalInOut: function(l3) {
    return 0.5 * (1 - Math.cos(Math.PI * l3));
  }, exponentialIn: function(l3) {
    return l3 === 0 ? 0 : Math.pow(1024, l3 - 1);
  }, exponentialOut: function(l3) {
    return l3 === 1 ? 1 : 1 - Math.pow(2, -10 * l3);
  }, exponentialInOut: function(l3) {
    return l3 === 0 ? 0 : l3 === 1 ? 1 : (l3 *= 2) < 1 ? 0.5 * Math.pow(1024, l3 - 1) : 0.5 * (-Math.pow(2, -10 * (l3 - 1)) + 2);
  }, circularIn: function(l3) {
    return 1 - Math.sqrt(1 - l3 * l3);
  }, circularOut: function(l3) {
    return Math.sqrt(1 - --l3 * l3);
  }, circularInOut: function(l3) {
    return (l3 *= 2) < 1 ? -0.5 * (Math.sqrt(1 - l3 * l3) - 1) : 0.5 * (Math.sqrt(1 - (l3 -= 2) * l3) + 1);
  }, elasticIn: function(l3) {
    var r3, e3 = 0.1, u = 0.4;
    return l3 === 0 ? 0 : l3 === 1 ? 1 : (!e3 || e3 < 1 ? (e3 = 1, r3 = u / 4) : r3 = u * Math.asin(1 / e3) / (2 * Math.PI), -(e3 * Math.pow(2, 10 * (l3 -= 1)) * Math.sin((l3 - r3) * (2 * Math.PI) / u)));
  }, elasticOut: function(l3) {
    var r3, e3 = 0.1, u = 0.4;
    return l3 === 0 ? 0 : l3 === 1 ? 1 : (!e3 || e3 < 1 ? (e3 = 1, r3 = u / 4) : r3 = u * Math.asin(1 / e3) / (2 * Math.PI), e3 * Math.pow(2, -10 * l3) * Math.sin((l3 - r3) * (2 * Math.PI) / u) + 1);
  }, elasticInOut: function(l3) {
    var r3, e3 = 0.1, u = 0.4;
    return l3 === 0 ? 0 : l3 === 1 ? 1 : (!e3 || e3 < 1 ? (e3 = 1, r3 = u / 4) : r3 = u * Math.asin(1 / e3) / (2 * Math.PI), (l3 *= 2) < 1 ? -0.5 * (e3 * Math.pow(2, 10 * (l3 -= 1)) * Math.sin((l3 - r3) * (2 * Math.PI) / u)) : e3 * Math.pow(2, -10 * (l3 -= 1)) * Math.sin((l3 - r3) * (2 * Math.PI) / u) * 0.5 + 1);
  }, backIn: function(l3) {
    var r3 = 1.70158;
    return l3 * l3 * ((r3 + 1) * l3 - r3);
  }, backOut: function(l3) {
    var r3 = 1.70158;
    return --l3 * l3 * ((r3 + 1) * l3 + r3) + 1;
  }, backInOut: function(l3) {
    var r3 = 2.5949095;
    return (l3 *= 2) < 1 ? 0.5 * (l3 * l3 * ((r3 + 1) * l3 - r3)) : 0.5 * ((l3 -= 2) * l3 * ((r3 + 1) * l3 + r3) + 2);
  }, bounceIn: function(l3) {
    return 1 - mfe.bounceOut(1 - l3);
  }, bounceOut: function(l3) {
    return l3 < 1 / 2.75 ? 7.5625 * l3 * l3 : l3 < 2 / 2.75 ? 7.5625 * (l3 -= 1.5 / 2.75) * l3 + 0.75 : l3 < 2.5 / 2.75 ? 7.5625 * (l3 -= 2.25 / 2.75) * l3 + 0.9375 : 7.5625 * (l3 -= 2.625 / 2.75) * l3 + 0.984375;
  }, bounceInOut: function(l3) {
    return l3 < 0.5 ? mfe.bounceIn(l3 * 2) * 0.5 : mfe.bounceOut(l3 * 2 - 1) * 0.5 + 0.5;
  } }, Hlt = mfe, sce = Math.pow, qO = Math.sqrt, Vfe = 1e-8, Wlt = 1e-4, ltt = qO(3), lce = 1 / 3, LA = KN(), f2 = KN(), rj = KN();
  function VO(l3) {
    return l3 > -Vfe && l3 < Vfe;
  }
  function Ult(l3) {
    return l3 > Vfe || l3 < -Vfe;
  }
  function i0(l3, r3, e3, u, h) {
    var v4 = 1 - h;
    return v4 * v4 * (v4 * l3 + 3 * h * r3) + h * h * (h * u + 3 * v4 * e3);
  }
  function utt(l3, r3, e3, u, h) {
    var v4 = 1 - h;
    return 3 * (((r3 - l3) * v4 + 2 * (e3 - r3) * h) * v4 + (u - e3) * h * h);
  }
  function Bfe(l3, r3, e3, u, h, v4) {
    var m3 = u + 3 * (r3 - e3) - l3, x3 = 3 * (e3 - r3 * 2 + l3), C = 3 * (r3 - l3), A2 = l3 - h, D = x3 * x3 - 3 * m3 * C, P = x3 * C - 9 * m3 * A2, N = C * C - 3 * x3 * A2, j = 0;
    if (VO(D) && VO(P))
      if (VO(x3))
        v4[0] = 0;
      else {
        var W = -C / x3;
        W >= 0 && W <= 1 && (v4[j++] = W);
      }
    else {
      var K = P * P - 4 * D * N;
      if (VO(K)) {
        var te = P / D, W = -x3 / m3 + te, ne = -te / 2;
        W >= 0 && W <= 1 && (v4[j++] = W), ne >= 0 && ne <= 1 && (v4[j++] = ne);
      } else if (K > 0) {
        var ce = qO(K), me = D * x3 + 1.5 * m3 * (-P + ce), ve = D * x3 + 1.5 * m3 * (-P - ce);
        me < 0 ? me = -sce(-me, lce) : me = sce(me, lce), ve < 0 ? ve = -sce(-ve, lce) : ve = sce(ve, lce);
        var W = (-x3 - (me + ve)) / (3 * m3);
        W >= 0 && W <= 1 && (v4[j++] = W);
      } else {
        var Be = (2 * D * x3 - 3 * m3 * P) / (2 * qO(D * D * D)), Oe = Math.acos(Be) / 3, We = qO(D), Ue = Math.cos(Oe), W = (-x3 - 2 * We * Ue) / (3 * m3), ne = (-x3 + We * (Ue + ltt * Math.sin(Oe))) / (3 * m3), qe = (-x3 + We * (Ue - ltt * Math.sin(Oe))) / (3 * m3);
        W >= 0 && W <= 1 && (v4[j++] = W), ne >= 0 && ne <= 1 && (v4[j++] = ne), qe >= 0 && qe <= 1 && (v4[j++] = qe);
      }
    }
    return j;
  }
  function qlt(l3, r3, e3, u, h) {
    var v4 = 6 * e3 - 12 * r3 + 6 * l3, m3 = 9 * r3 + 3 * u - 3 * l3 - 9 * e3, x3 = 3 * r3 - 3 * l3, C = 0;
    if (VO(m3)) {
      if (Ult(v4)) {
        var A2 = -x3 / v4;
        A2 >= 0 && A2 <= 1 && (h[C++] = A2);
      }
    } else {
      var D = v4 * v4 - 4 * m3 * x3;
      if (VO(D))
        h[0] = -v4 / (2 * m3);
      else if (D > 0) {
        var P = qO(D), A2 = (-v4 + P) / (2 * m3), N = (-v4 - P) / (2 * m3);
        A2 >= 0 && A2 <= 1 && (h[C++] = A2), N >= 0 && N <= 1 && (h[C++] = N);
      }
    }
    return C;
  }
  function ZO(l3, r3, e3, u, h, v4) {
    var m3 = (r3 - l3) * h + l3, x3 = (e3 - r3) * h + r3, C = (u - e3) * h + e3, A2 = (x3 - m3) * h + m3, D = (C - x3) * h + x3, P = (D - A2) * h + A2;
    v4[0] = l3, v4[1] = m3, v4[2] = A2, v4[3] = P, v4[4] = P, v4[5] = D, v4[6] = C, v4[7] = u;
  }
  function $lt(l3, r3, e3, u, h, v4, m3, x3, C, A2, D) {
    var P, N = 5e-3, j = 1 / 0, W, K, te, ne;
    LA[0] = C, LA[1] = A2;
    for (var ce = 0; ce < 1; ce += 0.05)
      f2[0] = i0(l3, e3, h, m3, ce), f2[1] = i0(r3, u, v4, x3, ce), te = LN(LA, f2), te < j && (P = ce, j = te);
    j = 1 / 0;
    for (var me = 0; me < 32 && !(N < Wlt); me++)
      W = P - N, K = P + N, f2[0] = i0(l3, e3, h, m3, W), f2[1] = i0(r3, u, v4, x3, W), te = LN(f2, LA), W >= 0 && te < j ? (P = W, j = te) : (rj[0] = i0(l3, e3, h, m3, K), rj[1] = i0(r3, u, v4, x3, K), ne = LN(rj, LA), K <= 1 && ne < j ? (P = K, j = ne) : N *= 0.5);
    return D && (D[0] = i0(l3, e3, h, m3, P), D[1] = i0(r3, u, v4, x3, P)), qO(j);
  }
  function Rsn(l3, r3, e3, u, h, v4, m3, x3, C) {
    for (var A2 = l3, D = r3, P = 0, N = 1 / C, j = 1; j <= C; j++) {
      var W = j * N, K = i0(l3, e3, h, m3, W), te = i0(r3, u, v4, x3, W), ne = K - A2, ce = te - D;
      P += Math.sqrt(ne * ne + ce * ce), A2 = K, D = te;
    }
    return P;
  }
  function Q0(l3, r3, e3, u) {
    var h = 1 - u;
    return h * (h * l3 + 2 * u * r3) + u * u * e3;
  }
  function I5e(l3, r3, e3, u) {
    return 2 * ((1 - u) * (r3 - l3) + u * (e3 - r3));
  }
  function Nsn(l3, r3, e3, u, h) {
    var v4 = l3 - 2 * r3 + e3, m3 = 2 * (r3 - l3), x3 = l3 - u, C = 0;
    if (VO(v4)) {
      if (Ult(m3)) {
        var A2 = -x3 / m3;
        A2 >= 0 && A2 <= 1 && (h[C++] = A2);
      }
    } else {
      var D = m3 * m3 - 4 * v4 * x3;
      if (VO(D)) {
        var A2 = -m3 / (2 * v4);
        A2 >= 0 && A2 <= 1 && (h[C++] = A2);
      } else if (D > 0) {
        var P = qO(D), A2 = (-m3 + P) / (2 * v4), N = (-m3 - P) / (2 * v4);
        A2 >= 0 && A2 <= 1 && (h[C++] = A2), N >= 0 && N <= 1 && (h[C++] = N);
      }
    }
    return C;
  }
  function Xlt(l3, r3, e3) {
    var u = l3 + e3 - 2 * r3;
    return u === 0 ? 0.5 : (l3 - r3) / u;
  }
  function QZ(l3, r3, e3, u, h) {
    var v4 = (r3 - l3) * u + l3, m3 = (e3 - r3) * u + r3, x3 = (m3 - v4) * u + v4;
    h[0] = l3, h[1] = v4, h[2] = x3, h[3] = x3, h[4] = m3, h[5] = e3;
  }
  function Ylt(l3, r3, e3, u, h, v4, m3, x3, C) {
    var A2, D = 5e-3, P = 1 / 0;
    LA[0] = m3, LA[1] = x3;
    for (var N = 0; N < 1; N += 0.05) {
      f2[0] = Q0(l3, e3, h, N), f2[1] = Q0(r3, u, v4, N);
      var j = LN(LA, f2);
      j < P && (A2 = N, P = j);
    }
    P = 1 / 0;
    for (var W = 0; W < 32 && !(D < Wlt); W++) {
      var K = A2 - D, te = A2 + D;
      f2[0] = Q0(l3, e3, h, K), f2[1] = Q0(r3, u, v4, K);
      var j = LN(f2, LA);
      if (K >= 0 && j < P)
        A2 = K, P = j;
      else {
        rj[0] = Q0(l3, e3, h, te), rj[1] = Q0(r3, u, v4, te);
        var ne = LN(rj, LA);
        te <= 1 && ne < P ? (A2 = te, P = ne) : D *= 0.5;
      }
    }
    return C && (C[0] = Q0(l3, e3, h, A2), C[1] = Q0(r3, u, v4, A2)), qO(P);
  }
  function Fsn(l3, r3, e3, u, h, v4, m3) {
    for (var x3 = l3, C = r3, A2 = 0, D = 1 / m3, P = 1; P <= m3; P++) {
      var N = P * D, j = Q0(l3, e3, h, N), W = Q0(r3, u, v4, N), K = j - x3, te = W - C;
      A2 += Math.sqrt(K * K + te * te), x3 = j, C = W;
    }
    return A2;
  }
  var Vsn = /cubic-bezier\(([0-9,\.e ]+)\)/;
  function D3e(l3) {
    var r3 = l3 && Vsn.exec(l3);
    if (r3) {
      var e3 = r3[1].split(","), u = +hM(e3[0]), h = +hM(e3[1]), v4 = +hM(e3[2]), m3 = +hM(e3[3]);
      if (isNaN(u + h + v4 + m3))
        return;
      var x3 = [];
      return function(C) {
        return C <= 0 ? 0 : C >= 1 ? 1 : Bfe(0, u, v4, 1, C, x3) && i0(0, h, m3, 1, x3[0]);
      };
    }
  }
  var Bsn = function() {
    function l3(r3) {
      this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = r3.life || 1e3, this._delay = r3.delay || 0, this.loop = r3.loop || false, this.onframe = r3.onframe || Rv, this.ondestroy = r3.ondestroy || Rv, this.onrestart = r3.onrestart || Rv, r3.easing && this.setEasing(r3.easing);
    }
    return l3.prototype.step = function(r3, e3) {
      if (this._inited || (this._startTime = r3 + this._delay, this._inited = true), this._paused) {
        this._pausedTime += e3;
        return;
      }
      var u = this._life, h = r3 - this._startTime - this._pausedTime, v4 = h / u;
      v4 < 0 && (v4 = 0), v4 = Math.min(v4, 1);
      var m3 = this.easingFunc, x3 = m3 ? m3(v4) : v4;
      if (this.onframe(x3), v4 === 1)
        if (this.loop) {
          var C = h % u;
          this._startTime = r3 - C, this._pausedTime = 0, this.onrestart();
        } else
          return true;
      return false;
    }, l3.prototype.pause = function() {
      this._paused = true;
    }, l3.prototype.resume = function() {
      this._paused = false;
    }, l3.prototype.setEasing = function(r3) {
      this.easing = r3, this.easingFunc = Xo(r3) ? r3 : Hlt[r3] || D3e(r3);
    }, l3;
  }(), zsn = Bsn, Klt = function() {
    function l3(r3) {
      this.value = r3;
    }
    return l3;
  }(), jsn = function() {
    function l3() {
      this._len = 0;
    }
    return l3.prototype.insert = function(r3) {
      var e3 = new Klt(r3);
      return this.insertEntry(e3), e3;
    }, l3.prototype.insertEntry = function(r3) {
      this.head ? (this.tail.next = r3, r3.prev = this.tail, r3.next = null, this.tail = r3) : this.head = this.tail = r3, this._len++;
    }, l3.prototype.remove = function(r3) {
      var e3 = r3.prev, u = r3.next;
      e3 ? e3.next = u : this.head = u, u ? u.prev = e3 : this.tail = e3, r3.next = r3.prev = null, this._len--;
    }, l3.prototype.len = function() {
      return this._len;
    }, l3.prototype.clear = function() {
      this.head = this.tail = null, this._len = 0;
    }, l3;
  }(), Gsn = function() {
    function l3(r3) {
      this._list = new jsn(), this._maxSize = 10, this._map = {}, this._maxSize = r3;
    }
    return l3.prototype.put = function(r3, e3) {
      var u = this._list, h = this._map, v4 = null;
      if (h[r3] == null) {
        var m3 = u.len(), x3 = this._lastRemovedEntry;
        if (m3 >= this._maxSize && m3 > 0) {
          var C = u.head;
          u.remove(C), delete h[C.key], v4 = C.value, this._lastRemovedEntry = C;
        }
        x3 ? x3.value = e3 : x3 = new Klt(e3), x3.key = r3, u.insertEntry(x3), h[r3] = x3;
      }
      return v4;
    }, l3.prototype.get = function(r3) {
      var e3 = this._map[r3], u = this._list;
      if (e3 != null)
        return e3 !== u.tail && (u.remove(e3), u.insertEntry(e3)), e3.value;
    }, l3.prototype.clear = function() {
      this._list.clear(), this._map = {};
    }, l3.prototype.len = function() {
      return this._list.len();
    }, l3;
  }(), EJ = Gsn, ctt = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
  function dM(l3) {
    return l3 = Math.round(l3), l3 < 0 ? 0 : l3 > 255 ? 255 : l3;
  }
  function Hsn(l3) {
    return l3 = Math.round(l3), l3 < 0 ? 0 : l3 > 360 ? 360 : l3;
  }
  function eJ(l3) {
    return l3 < 0 ? 0 : l3 > 1 ? 1 : l3;
  }
  function UIe(l3) {
    var r3 = l3;
    return r3.length && r3.charAt(r3.length - 1) === "%" ? dM(parseFloat(r3) / 100 * 255) : dM(parseInt(r3, 10));
  }
  function cj(l3) {
    var r3 = l3;
    return r3.length && r3.charAt(r3.length - 1) === "%" ? eJ(parseFloat(r3) / 100) : eJ(parseFloat(r3));
  }
  function qIe(l3, r3, e3) {
    return e3 < 0 ? e3 += 1 : e3 > 1 && (e3 -= 1), e3 * 6 < 1 ? l3 + (r3 - l3) * e3 * 6 : e3 * 2 < 1 ? r3 : e3 * 3 < 2 ? l3 + (r3 - l3) * (2 / 3 - e3) * 6 : l3;
  }
  function BO(l3, r3, e3) {
    return l3 + (r3 - l3) * e3;
  }
  function o2(l3, r3, e3, u, h) {
    return l3[0] = r3, l3[1] = e3, l3[2] = u, l3[3] = h, l3;
  }
  function E5e(l3, r3) {
    return l3[0] = r3[0], l3[1] = r3[1], l3[2] = r3[2], l3[3] = r3[3], l3;
  }
  var Zlt = new EJ(20), uce = null;
  function wz(l3, r3) {
    uce && E5e(uce, r3), uce = Zlt.put(l3, uce || r3.slice());
  }
  function Jx(l3, r3) {
    if (!!l3) {
      r3 = r3 || [];
      var e3 = Zlt.get(l3);
      if (e3)
        return E5e(r3, e3);
      l3 = l3 + "";
      var u = l3.replace(/ /g, "").toLowerCase();
      if (u in ctt)
        return E5e(r3, ctt[u]), wz(l3, r3), r3;
      var h = u.length;
      if (u.charAt(0) === "#") {
        if (h === 4 || h === 5) {
          var v4 = parseInt(u.slice(1, 4), 16);
          if (!(v4 >= 0 && v4 <= 4095)) {
            o2(r3, 0, 0, 0, 1);
            return;
          }
          return o2(r3, (v4 & 3840) >> 4 | (v4 & 3840) >> 8, v4 & 240 | (v4 & 240) >> 4, v4 & 15 | (v4 & 15) << 4, h === 5 ? parseInt(u.slice(4), 16) / 15 : 1), wz(l3, r3), r3;
        } else if (h === 7 || h === 9) {
          var v4 = parseInt(u.slice(1, 7), 16);
          if (!(v4 >= 0 && v4 <= 16777215)) {
            o2(r3, 0, 0, 0, 1);
            return;
          }
          return o2(r3, (v4 & 16711680) >> 16, (v4 & 65280) >> 8, v4 & 255, h === 9 ? parseInt(u.slice(7), 16) / 255 : 1), wz(l3, r3), r3;
        }
        return;
      }
      var m3 = u.indexOf("("), x3 = u.indexOf(")");
      if (m3 !== -1 && x3 + 1 === h) {
        var C = u.substr(0, m3), A2 = u.substr(m3 + 1, x3 - (m3 + 1)).split(","), D = 1;
        switch (C) {
          case "rgba":
            if (A2.length !== 4)
              return A2.length === 3 ? o2(r3, +A2[0], +A2[1], +A2[2], 1) : o2(r3, 0, 0, 0, 1);
            D = cj(A2.pop());
          case "rgb":
            if (A2.length !== 3) {
              o2(r3, 0, 0, 0, 1);
              return;
            }
            return o2(r3, UIe(A2[0]), UIe(A2[1]), UIe(A2[2]), D), wz(l3, r3), r3;
          case "hsla":
            if (A2.length !== 4) {
              o2(r3, 0, 0, 0, 1);
              return;
            }
            return A2[3] = cj(A2[3]), D5e(A2, r3), wz(l3, r3), r3;
          case "hsl":
            if (A2.length !== 3) {
              o2(r3, 0, 0, 0, 1);
              return;
            }
            return D5e(A2, r3), wz(l3, r3), r3;
          default:
            return;
        }
      }
      o2(r3, 0, 0, 0, 1);
    }
  }
  function D5e(l3, r3) {
    var e3 = (parseFloat(l3[0]) % 360 + 360) % 360 / 360, u = cj(l3[1]), h = cj(l3[2]), v4 = h <= 0.5 ? h * (u + 1) : h + u - h * u, m3 = h * 2 - v4;
    return r3 = r3 || [], o2(r3, dM(qIe(m3, v4, e3 + 1 / 3) * 255), dM(qIe(m3, v4, e3) * 255), dM(qIe(m3, v4, e3 - 1 / 3) * 255), 1), l3.length === 4 && (r3[3] = l3[3]), r3;
  }
  function Wsn(l3) {
    if (!!l3) {
      var r3 = l3[0] / 255, e3 = l3[1] / 255, u = l3[2] / 255, h = Math.min(r3, e3, u), v4 = Math.max(r3, e3, u), m3 = v4 - h, x3 = (v4 + h) / 2, C, A2;
      if (m3 === 0)
        C = 0, A2 = 0;
      else {
        x3 < 0.5 ? A2 = m3 / (v4 + h) : A2 = m3 / (2 - v4 - h);
        var D = ((v4 - r3) / 6 + m3 / 2) / m3, P = ((v4 - e3) / 6 + m3 / 2) / m3, N = ((v4 - u) / 6 + m3 / 2) / m3;
        r3 === v4 ? C = N - P : e3 === v4 ? C = 1 / 3 + D - N : u === v4 && (C = 2 / 3 + P - D), C < 0 && (C += 1), C > 1 && (C -= 1);
      }
      var j = [C * 360, A2, x3];
      return l3[3] != null && j.push(l3[3]), j;
    }
  }
  function k5e(l3, r3) {
    var e3 = Jx(l3);
    if (e3) {
      for (var u = 0; u < 3; u++)
        r3 < 0 ? e3[u] = e3[u] * (1 - r3) | 0 : e3[u] = (255 - e3[u]) * r3 + e3[u] | 0, e3[u] > 255 ? e3[u] = 255 : e3[u] < 0 && (e3[u] = 0);
      return r5(e3, e3.length === 4 ? "rgba" : "rgb");
    }
  }
  function $Ie(l3, r3, e3) {
    if (!(!(r3 && r3.length) || !(l3 >= 0 && l3 <= 1))) {
      e3 = e3 || [];
      var u = l3 * (r3.length - 1), h = Math.floor(u), v4 = Math.ceil(u), m3 = r3[h], x3 = r3[v4], C = u - h;
      return e3[0] = dM(BO(m3[0], x3[0], C)), e3[1] = dM(BO(m3[1], x3[1], C)), e3[2] = dM(BO(m3[2], x3[2], C)), e3[3] = eJ(BO(m3[3], x3[3], C)), e3;
    }
  }
  function Usn(l3, r3, e3) {
    if (!(!(r3 && r3.length) || !(l3 >= 0 && l3 <= 1))) {
      var u = l3 * (r3.length - 1), h = Math.floor(u), v4 = Math.ceil(u), m3 = Jx(r3[h]), x3 = Jx(r3[v4]), C = u - h, A2 = r5([dM(BO(m3[0], x3[0], C)), dM(BO(m3[1], x3[1], C)), dM(BO(m3[2], x3[2], C)), eJ(BO(m3[3], x3[3], C))], "rgba");
      return e3 ? { color: A2, leftIndex: h, rightIndex: v4, value: u } : A2;
    }
  }
  function PZ(l3, r3, e3, u) {
    var h = Jx(l3);
    if (l3)
      return h = Wsn(h), r3 != null && (h[0] = Hsn(r3)), e3 != null && (h[1] = cj(e3)), u != null && (h[2] = cj(u)), r5(D5e(h), "rgba");
  }
  function zfe(l3, r3) {
    var e3 = Jx(l3);
    if (e3 && r3 != null)
      return e3[3] = eJ(r3), r5(e3, "rgba");
  }
  function r5(l3, r3) {
    if (!(!l3 || !l3.length)) {
      var e3 = l3[0] + "," + l3[1] + "," + l3[2];
      return (r3 === "rgba" || r3 === "hsva" || r3 === "hsla") && (e3 += "," + l3[3]), r3 + "(" + e3 + ")";
    }
  }
  function jfe(l3, r3) {
    var e3 = Jx(l3);
    return e3 ? (0.299 * e3[0] + 0.587 * e3[1] + 0.114 * e3[2]) * e3[3] / 255 + (1 - e3[3]) * r3 : 0;
  }
  var Gfe = Math.round;
  function fj(l3) {
    var r3;
    if (!l3 || l3 === "transparent")
      l3 = "none";
    else if (typeof l3 == "string" && l3.indexOf("rgba") > -1) {
      var e3 = Jx(l3);
      e3 && (l3 = "rgb(" + e3[0] + "," + e3[1] + "," + e3[2] + ")", r3 = e3[3]);
    }
    return { color: l3, opacity: r3 == null ? 1 : r3 };
  }
  var ftt = 1e-4;
  function zO(l3) {
    return l3 < ftt && l3 > -ftt;
  }
  function cce(l3) {
    return Gfe(l3 * 1e3) / 1e3;
  }
  function O5e(l3) {
    return Gfe(l3 * 1e4) / 1e4;
  }
  function qsn(l3) {
    return "matrix(" + cce(l3[0]) + "," + cce(l3[1]) + "," + cce(l3[2]) + "," + cce(l3[3]) + "," + O5e(l3[4]) + "," + O5e(l3[5]) + ")";
  }
  var $sn = { left: "start", right: "end", center: "middle", middle: "middle" };
  function Xsn(l3, r3, e3) {
    return e3 === "top" ? l3 += r3 / 2 : e3 === "bottom" && (l3 -= r3 / 2), l3;
  }
  function Ysn(l3) {
    return l3 && (l3.shadowBlur || l3.shadowOffsetX || l3.shadowOffsetY);
  }
  function Ksn(l3) {
    var r3 = l3.style, e3 = l3.getGlobalScale();
    return [r3.shadowColor, (r3.shadowBlur || 0).toFixed(2), (r3.shadowOffsetX || 0).toFixed(2), (r3.shadowOffsetY || 0).toFixed(2), e3[0], e3[1]].join(",");
  }
  function Jlt(l3) {
    return l3 && !!l3.image;
  }
  function Zsn(l3) {
    return l3 && !!l3.svgElement;
  }
  function Jsn(l3) {
    return Jlt(l3) || Zsn(l3);
  }
  function Qlt(l3) {
    return l3.type === "linear";
  }
  function eut(l3) {
    return l3.type === "radial";
  }
  function Qsn(l3) {
    return l3 && (l3.type === "linear" || l3.type === "radial");
  }
  function zhe(l3) {
    return "url(#" + l3 + ")";
  }
  function tut(l3) {
    var r3 = l3.getGlobalScale(), e3 = Math.max(r3[0], r3[1]);
    return Math.max(Math.ceil(Math.log(e3) / Math.log(10)), 1);
  }
  function nut(l3) {
    var r3 = l3.x || 0, e3 = l3.y || 0, u = (l3.rotation || 0) * vfe, h = dl(l3.scaleX, 1), v4 = dl(l3.scaleY, 1), m3 = l3.skewX || 0, x3 = l3.skewY || 0, C = [];
    return (r3 || e3) && C.push("translate(" + r3 + "px," + e3 + "px)"), u && C.push("rotate(" + u + ")"), (h !== 1 || v4 !== 1) && C.push("scale(" + h + "," + v4 + ")"), (m3 || x3) && C.push("skew(" + Gfe(m3 * vfe) + "deg, " + Gfe(x3 * vfe) + "deg)"), C.join(" ");
  }
  var eln = function() {
    return Fc.hasGlobalWindow && Xo(window.btoa) ? function(l3) {
      return window.btoa(unescape(l3));
    } : typeof Buffer != "undefined" ? function(l3) {
      return Buffer.from(l3).toString("base64");
    } : function(l3) {
      return null;
    };
  }(), P5e = Array.prototype.slice;
  function ZD(l3, r3, e3) {
    return (r3 - l3) * e3 + l3;
  }
  function XIe(l3, r3, e3, u) {
    for (var h = r3.length, v4 = 0; v4 < h; v4++)
      l3[v4] = ZD(r3[v4], e3[v4], u);
    return l3;
  }
  function tln(l3, r3, e3, u) {
    for (var h = r3.length, v4 = h && r3[0].length, m3 = 0; m3 < h; m3++) {
      l3[m3] || (l3[m3] = []);
      for (var x3 = 0; x3 < v4; x3++)
        l3[m3][x3] = ZD(r3[m3][x3], e3[m3][x3], u);
    }
    return l3;
  }
  function fce(l3, r3, e3, u) {
    for (var h = r3.length, v4 = 0; v4 < h; v4++)
      l3[v4] = r3[v4] + e3[v4] * u;
    return l3;
  }
  function htt(l3, r3, e3, u) {
    for (var h = r3.length, v4 = h && r3[0].length, m3 = 0; m3 < h; m3++) {
      l3[m3] || (l3[m3] = []);
      for (var x3 = 0; x3 < v4; x3++)
        l3[m3][x3] = r3[m3][x3] + e3[m3][x3] * u;
    }
    return l3;
  }
  function nln(l3, r3) {
    for (var e3 = l3.length, u = r3.length, h = e3 > u ? r3 : l3, v4 = Math.min(e3, u), m3 = h[v4 - 1] || { color: [0, 0, 0, 0], offset: 0 }, x3 = v4; x3 < Math.max(e3, u); x3++)
      h.push({ offset: m3.offset, color: m3.color.slice() });
  }
  function rln(l3, r3, e3) {
    var u = l3, h = r3;
    if (!(!u.push || !h.push)) {
      var v4 = u.length, m3 = h.length;
      if (v4 !== m3) {
        var x3 = v4 > m3;
        if (x3)
          u.length = m3;
        else
          for (var C = v4; C < m3; C++)
            u.push(e3 === 1 ? h[C] : P5e.call(h[C]));
      }
      for (var A2 = u[0] && u[0].length, C = 0; C < u.length; C++)
        if (e3 === 1)
          isNaN(u[C]) && (u[C] = h[C]);
        else
          for (var D = 0; D < A2; D++)
            isNaN(u[C][D]) && (u[C][D] = h[C][D]);
    }
  }
  function LZ(l3) {
    if (m1(l3)) {
      var r3 = l3.length;
      if (m1(l3[0])) {
        for (var e3 = [], u = 0; u < r3; u++)
          e3.push(P5e.call(l3[u]));
        return e3;
      }
      return P5e.call(l3);
    }
    return l3;
  }
  function bfe(l3) {
    return l3[0] = Math.floor(l3[0]) || 0, l3[1] = Math.floor(l3[1]) || 0, l3[2] = Math.floor(l3[2]) || 0, l3[3] = l3[3] == null ? 1 : l3[3], "rgba(" + l3.join(",") + ")";
  }
  function iln(l3) {
    return m1(l3 && l3[0]) ? 2 : 1;
  }
  var hce = 0, _fe = 1, rut = 2, _Z = 3, L5e = 4, R5e = 5, ptt = 6;
  function dtt(l3) {
    return l3 === L5e || l3 === R5e;
  }
  function pce(l3) {
    return l3 === _fe || l3 === rut;
  }
  var HK = [0, 0, 0, 0], aln = function() {
    function l3(r3) {
      this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = r3;
    }
    return l3.prototype.isFinished = function() {
      return this._finished;
    }, l3.prototype.setFinished = function() {
      this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
    }, l3.prototype.needsAnimate = function() {
      return this.keyframes.length >= 1;
    }, l3.prototype.getAdditiveTrack = function() {
      return this._additiveTrack;
    }, l3.prototype.addKeyframe = function(r3, e3, u) {
      this._needsSort = true;
      var h = this.keyframes, v4 = h.length, m3 = false, x3 = ptt, C = e3;
      if (m1(e3)) {
        var A2 = iln(e3);
        x3 = A2, (A2 === 1 && !Vc(e3[0]) || A2 === 2 && !Vc(e3[0][0])) && (m3 = true);
      } else if (Vc(e3) && !JZ(e3))
        x3 = hce;
      else if (qa(e3))
        if (!isNaN(+e3))
          x3 = hce;
        else {
          var D = Jx(e3);
          D && (C = D, x3 = _Z);
        }
      else if (Vhe(e3)) {
        var P = fi({}, C);
        P.colorStops = Bi(e3.colorStops, function(j) {
          return { offset: j.offset, color: Jx(j.color) };
        }), Qlt(e3) ? x3 = L5e : eut(e3) && (x3 = R5e), C = P;
      }
      v4 === 0 ? this.valType = x3 : (x3 !== this.valType || x3 === ptt) && (m3 = true), this.discrete = this.discrete || m3;
      var N = { time: r3, value: C, rawValue: e3, percent: 0 };
      return u && (N.easing = u, N.easingFunc = Xo(u) ? u : Hlt[u] || D3e(u)), h.push(N), N;
    }, l3.prototype.prepare = function(r3, e3) {
      var u = this.keyframes;
      this._needsSort && u.sort(function(K, te) {
        return K.time - te.time;
      });
      for (var h = this.valType, v4 = u.length, m3 = u[v4 - 1], x3 = this.discrete, C = pce(h), A2 = dtt(h), D = 0; D < v4; D++) {
        var P = u[D], N = P.value, j = m3.value;
        P.percent = P.time / r3, x3 || (C && D !== v4 - 1 ? rln(N, j, h) : A2 && nln(N.colorStops, j.colorStops));
      }
      if (!x3 && h !== R5e && e3 && this.needsAnimate() && e3.needsAnimate() && h === e3.valType && !e3._finished) {
        this._additiveTrack = e3;
        for (var W = u[0].value, D = 0; D < v4; D++)
          h === hce ? u[D].additiveValue = u[D].value - W : h === _Z ? u[D].additiveValue = fce([], u[D].value, W, -1) : pce(h) && (u[D].additiveValue = h === _fe ? fce([], u[D].value, W, -1) : htt([], u[D].value, W, -1));
      }
    }, l3.prototype.step = function(r3, e3) {
      if (!this._finished) {
        this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
        var u = this._additiveTrack != null, h = u ? "additiveValue" : "value", v4 = this.valType, m3 = this.keyframes, x3 = m3.length, C = this.propName, A2 = v4 === _Z, D, P = this._lastFr, N = Math.min, j, W;
        if (x3 === 1)
          j = W = m3[0];
        else {
          if (e3 < 0)
            D = 0;
          else if (e3 < this._lastFrP) {
            var K = N(P + 1, x3 - 1);
            for (D = K; D >= 0 && !(m3[D].percent <= e3); D--)
              ;
            D = N(D, x3 - 2);
          } else {
            for (D = P; D < x3 && !(m3[D].percent > e3); D++)
              ;
            D = N(D - 1, x3 - 2);
          }
          W = m3[D + 1], j = m3[D];
        }
        if (!!(j && W)) {
          this._lastFr = D, this._lastFrP = e3;
          var te = W.percent - j.percent, ne = te === 0 ? 1 : N((e3 - j.percent) / te, 1);
          W.easingFunc && (ne = W.easingFunc(ne));
          var ce = u ? this._additiveValue : A2 ? HK : r3[C];
          if ((pce(v4) || A2) && !ce && (ce = this._additiveValue = []), this.discrete)
            r3[C] = ne < 1 ? j.rawValue : W.rawValue;
          else if (pce(v4))
            v4 === _fe ? XIe(ce, j[h], W[h], ne) : tln(ce, j[h], W[h], ne);
          else if (dtt(v4)) {
            var me = j[h], ve = W[h], Be = v4 === L5e;
            r3[C] = { type: Be ? "linear" : "radial", x: ZD(me.x, ve.x, ne), y: ZD(me.y, ve.y, ne), colorStops: Bi(me.colorStops, function(We, Ue) {
              var qe = ve.colorStops[Ue];
              return { offset: ZD(We.offset, qe.offset, ne), color: bfe(XIe([], We.color, qe.color, ne)) };
            }), global: ve.global }, Be ? (r3[C].x2 = ZD(me.x2, ve.x2, ne), r3[C].y2 = ZD(me.y2, ve.y2, ne)) : r3[C].r = ZD(me.r, ve.r, ne);
          } else if (A2)
            XIe(ce, j[h], W[h], ne), u || (r3[C] = bfe(ce));
          else {
            var Oe = ZD(j[h], W[h], ne);
            u ? this._additiveValue = Oe : r3[C] = Oe;
          }
          u && this._addToTarget(r3);
        }
      }
    }, l3.prototype._addToTarget = function(r3) {
      var e3 = this.valType, u = this.propName, h = this._additiveValue;
      e3 === hce ? r3[u] = r3[u] + h : e3 === _Z ? (Jx(r3[u], HK), fce(HK, HK, h, 1), r3[u] = bfe(HK)) : e3 === _fe ? fce(r3[u], r3[u], h, 1) : e3 === rut && htt(r3[u], r3[u], h, 1);
    }, l3;
  }(), k3e = function() {
    function l3(r3, e3, u, h) {
      if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = r3, this._loop = e3, e3 && h) {
        M3e("Can' use additive animation on looped animation.");
        return;
      }
      this._additiveAnimators = h, this._allowDiscrete = u;
    }
    return l3.prototype.getMaxTime = function() {
      return this._maxTime;
    }, l3.prototype.getDelay = function() {
      return this._delay;
    }, l3.prototype.getLoop = function() {
      return this._loop;
    }, l3.prototype.getTarget = function() {
      return this._target;
    }, l3.prototype.changeTarget = function(r3) {
      this._target = r3;
    }, l3.prototype.when = function(r3, e3, u) {
      return this.whenWithKeys(r3, e3, yu(e3), u);
    }, l3.prototype.whenWithKeys = function(r3, e3, u, h) {
      for (var v4 = this._tracks, m3 = 0; m3 < u.length; m3++) {
        var x3 = u[m3], C = v4[x3];
        if (!C) {
          C = v4[x3] = new aln(x3);
          var A2 = void 0, D = this._getAdditiveTrack(x3);
          if (D) {
            var P = D.keyframes, N = P[P.length - 1];
            A2 = N && N.value, D.valType === _Z && A2 && (A2 = bfe(A2));
          } else
            A2 = this._target[x3];
          if (A2 == null)
            continue;
          r3 > 0 && C.addKeyframe(0, LZ(A2), h), this._trackKeys.push(x3);
        }
        C.addKeyframe(r3, LZ(e3[x3]), h);
      }
      return this._maxTime = Math.max(this._maxTime, r3), this;
    }, l3.prototype.pause = function() {
      this._clip.pause(), this._paused = true;
    }, l3.prototype.resume = function() {
      this._clip.resume(), this._paused = false;
    }, l3.prototype.isPaused = function() {
      return !!this._paused;
    }, l3.prototype.duration = function(r3) {
      return this._maxTime = r3, this._force = true, this;
    }, l3.prototype._doneCallback = function() {
      this._setTracksFinished(), this._clip = null;
      var r3 = this._doneCbs;
      if (r3)
        for (var e3 = r3.length, u = 0; u < e3; u++)
          r3[u].call(this);
    }, l3.prototype._abortedCallback = function() {
      this._setTracksFinished();
      var r3 = this.animation, e3 = this._abortedCbs;
      if (r3 && r3.removeClip(this._clip), this._clip = null, e3)
        for (var u = 0; u < e3.length; u++)
          e3[u].call(this);
    }, l3.prototype._setTracksFinished = function() {
      for (var r3 = this._tracks, e3 = this._trackKeys, u = 0; u < e3.length; u++)
        r3[e3[u]].setFinished();
    }, l3.prototype._getAdditiveTrack = function(r3) {
      var e3, u = this._additiveAnimators;
      if (u)
        for (var h = 0; h < u.length; h++) {
          var v4 = u[h].getTrack(r3);
          v4 && (e3 = v4);
        }
      return e3;
    }, l3.prototype.start = function(r3) {
      if (!(this._started > 0)) {
        this._started = 1;
        for (var e3 = this, u = [], h = this._maxTime || 0, v4 = 0; v4 < this._trackKeys.length; v4++) {
          var m3 = this._trackKeys[v4], x3 = this._tracks[m3], C = this._getAdditiveTrack(m3), A2 = x3.keyframes, D = A2.length;
          if (x3.prepare(h, C), x3.needsAnimate())
            if (!this._allowDiscrete && x3.discrete) {
              var P = A2[D - 1];
              P && (e3._target[x3.propName] = P.rawValue), x3.setFinished();
            } else
              u.push(x3);
        }
        if (u.length || this._force) {
          var N = new zsn({ life: h, loop: this._loop, delay: this._delay || 0, onframe: function(j) {
            e3._started = 2;
            var W = e3._additiveAnimators;
            if (W) {
              for (var K = false, te = 0; te < W.length; te++)
                if (W[te]._clip) {
                  K = true;
                  break;
                }
              K || (e3._additiveAnimators = null);
            }
            for (var te = 0; te < u.length; te++)
              u[te].step(e3._target, j);
            var ne = e3._onframeCbs;
            if (ne)
              for (var te = 0; te < ne.length; te++)
                ne[te](e3._target, j);
          }, ondestroy: function() {
            e3._doneCallback();
          } });
          this._clip = N, this.animation && this.animation.addClip(N), r3 && N.setEasing(r3);
        } else
          this._doneCallback();
        return this;
      }
    }, l3.prototype.stop = function(r3) {
      if (!!this._clip) {
        var e3 = this._clip;
        r3 && e3.onframe(1), this._abortedCallback();
      }
    }, l3.prototype.delay = function(r3) {
      return this._delay = r3, this;
    }, l3.prototype.during = function(r3) {
      return r3 && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(r3)), this;
    }, l3.prototype.done = function(r3) {
      return r3 && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(r3)), this;
    }, l3.prototype.aborted = function(r3) {
      return r3 && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(r3)), this;
    }, l3.prototype.getClip = function() {
      return this._clip;
    }, l3.prototype.getTrack = function(r3) {
      return this._tracks[r3];
    }, l3.prototype.getTracks = function() {
      var r3 = this;
      return Bi(this._trackKeys, function(e3) {
        return r3._tracks[e3];
      });
    }, l3.prototype.stopTracks = function(r3, e3) {
      if (!r3.length || !this._clip)
        return true;
      for (var u = this._tracks, h = this._trackKeys, v4 = 0; v4 < r3.length; v4++) {
        var m3 = u[r3[v4]];
        m3 && !m3.isFinished() && (e3 ? m3.step(this._target, 1) : this._started === 1 && m3.step(this._target, 0), m3.setFinished());
      }
      for (var x3 = true, v4 = 0; v4 < h.length; v4++)
        if (!u[h[v4]].isFinished()) {
          x3 = false;
          break;
        }
      return x3 && this._abortedCallback(), x3;
    }, l3.prototype.saveTo = function(r3, e3, u) {
      if (!!r3) {
        e3 = e3 || this._trackKeys;
        for (var h = 0; h < e3.length; h++) {
          var v4 = e3[h], m3 = this._tracks[v4];
          if (!(!m3 || m3.isFinished())) {
            var x3 = m3.keyframes, C = x3[u ? 0 : x3.length - 1];
            C && (r3[v4] = LZ(C.rawValue));
          }
        }
      }
    }, l3.prototype.__changeFinalValue = function(r3, e3) {
      e3 = e3 || yu(r3);
      for (var u = 0; u < e3.length; u++) {
        var h = e3[u], v4 = this._tracks[h];
        if (!!v4) {
          var m3 = v4.keyframes;
          if (m3.length > 1) {
            var x3 = m3.pop();
            v4.addKeyframe(x3.time, r3[h]), v4.prepare(this._maxTime, v4.getAdditiveTrack());
          }
        }
      }
    }, l3;
  }();
  function Yz() {
    return new Date().getTime();
  }
  var oln = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this) || this;
      return u._running = false, u._time = 0, u._pausedTime = 0, u._pauseStart = 0, u._paused = false, e3 = e3 || {}, u.stage = e3.stage || {}, u;
    }
    return r3.prototype.addClip = function(e3) {
      e3.animation && this.removeClip(e3), this._head ? (this._tail.next = e3, e3.prev = this._tail, e3.next = null, this._tail = e3) : this._head = this._tail = e3, e3.animation = this;
    }, r3.prototype.addAnimator = function(e3) {
      e3.animation = this;
      var u = e3.getClip();
      u && this.addClip(u);
    }, r3.prototype.removeClip = function(e3) {
      if (!!e3.animation) {
        var u = e3.prev, h = e3.next;
        u ? u.next = h : this._head = h, h ? h.prev = u : this._tail = u, e3.next = e3.prev = e3.animation = null;
      }
    }, r3.prototype.removeAnimator = function(e3) {
      var u = e3.getClip();
      u && this.removeClip(u), e3.animation = null;
    }, r3.prototype.update = function(e3) {
      for (var u = Yz() - this._pausedTime, h = u - this._time, v4 = this._head; v4; ) {
        var m3 = v4.next, x3 = v4.step(u, h);
        x3 && (v4.ondestroy(), this.removeClip(v4)), v4 = m3;
      }
      this._time = u, e3 || (this.trigger("frame", h), this.stage.update && this.stage.update());
    }, r3.prototype._startLoop = function() {
      var e3 = this;
      this._running = true;
      function u() {
        e3._running && (A5e(u), !e3._paused && e3.update());
      }
      A5e(u);
    }, r3.prototype.start = function() {
      this._running || (this._time = Yz(), this._pausedTime = 0, this._startLoop());
    }, r3.prototype.stop = function() {
      this._running = false;
    }, r3.prototype.pause = function() {
      this._paused || (this._pauseStart = Yz(), this._paused = true);
    }, r3.prototype.resume = function() {
      this._paused && (this._pausedTime += Yz() - this._pauseStart, this._paused = false);
    }, r3.prototype.clear = function() {
      for (var e3 = this._head; e3; ) {
        var u = e3.next;
        e3.prev = e3.next = e3.animation = null, e3 = u;
      }
      this._head = this._tail = null;
    }, r3.prototype.isFinished = function() {
      return this._head == null;
    }, r3.prototype.animate = function(e3, u) {
      u = u || {}, this.start();
      var h = new k3e(e3, u.loop);
      return this.addAnimator(h), h;
    }, r3;
  }(w2), sln = oln, lln = 300, YIe = Fc.domSupported, KIe = function() {
    var l3 = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], r3 = ["touchstart", "touchend", "touchmove"], e3 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, u = Bi(l3, function(h) {
      var v4 = h.replace("mouse", "pointer");
      return e3.hasOwnProperty(v4) ? v4 : h;
    });
    return { mouse: l3, touch: r3, pointer: u };
  }(), vtt = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, gtt = false;
  function N5e(l3) {
    var r3 = l3.pointerType;
    return r3 === "pen" || r3 === "touch";
  }
  function uln(l3) {
    l3.touching = true, l3.touchTimer != null && (clearTimeout(l3.touchTimer), l3.touchTimer = null), l3.touchTimer = setTimeout(function() {
      l3.touching = false, l3.touchTimer = null;
    }, 700);
  }
  function ZIe(l3) {
    l3 && (l3.zrByTouch = true);
  }
  function cln(l3, r3) {
    return s2(l3.dom, new fln(l3, r3), true);
  }
  function iut(l3, r3) {
    for (var e3 = r3, u = false; e3 && e3.nodeType !== 9 && !(u = e3.domBelongToZr || e3 !== r3 && e3 === l3.painterRoot); )
      e3 = e3.parentNode;
    return u;
  }
  var fln = function() {
    function l3(r3, e3) {
      this.stopPropagation = Rv, this.stopImmediatePropagation = Rv, this.preventDefault = Rv, this.type = e3.type, this.target = this.currentTarget = r3.dom, this.pointerType = e3.pointerType, this.clientX = e3.clientX, this.clientY = e3.clientY;
    }
    return l3;
  }(), uM = { mousedown: function(l3) {
    l3 = s2(this.dom, l3), this.__mayPointerCapture = [l3.zrX, l3.zrY], this.trigger("mousedown", l3);
  }, mousemove: function(l3) {
    l3 = s2(this.dom, l3);
    var r3 = this.__mayPointerCapture;
    r3 && (l3.zrX !== r3[0] || l3.zrY !== r3[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", l3);
  }, mouseup: function(l3) {
    l3 = s2(this.dom, l3), this.__togglePointerCapture(false), this.trigger("mouseup", l3);
  }, mouseout: function(l3) {
    l3 = s2(this.dom, l3);
    var r3 = l3.toElement || l3.relatedTarget;
    iut(this, r3) || (this.__pointerCapturing && (l3.zrEventControl = "no_globalout"), this.trigger("mouseout", l3));
  }, wheel: function(l3) {
    gtt = true, l3 = s2(this.dom, l3), this.trigger("mousewheel", l3);
  }, mousewheel: function(l3) {
    gtt || (l3 = s2(this.dom, l3), this.trigger("mousewheel", l3));
  }, touchstart: function(l3) {
    l3 = s2(this.dom, l3), ZIe(l3), this.__lastTouchMoment = new Date(), this.handler.processGesture(l3, "start"), uM.mousemove.call(this, l3), uM.mousedown.call(this, l3);
  }, touchmove: function(l3) {
    l3 = s2(this.dom, l3), ZIe(l3), this.handler.processGesture(l3, "change"), uM.mousemove.call(this, l3);
  }, touchend: function(l3) {
    l3 = s2(this.dom, l3), ZIe(l3), this.handler.processGesture(l3, "end"), uM.mouseup.call(this, l3), +new Date() - +this.__lastTouchMoment < lln && uM.click.call(this, l3);
  }, pointerdown: function(l3) {
    uM.mousedown.call(this, l3);
  }, pointermove: function(l3) {
    N5e(l3) || uM.mousemove.call(this, l3);
  }, pointerup: function(l3) {
    uM.mouseup.call(this, l3);
  }, pointerout: function(l3) {
    N5e(l3) || uM.mouseout.call(this, l3);
  } };
  mt(["click", "dblclick", "contextmenu"], function(l3) {
    uM[l3] = function(r3) {
      r3 = s2(this.dom, r3), this.trigger(l3, r3);
    };
  });
  var F5e = { pointermove: function(l3) {
    N5e(l3) || F5e.mousemove.call(this, l3);
  }, pointerup: function(l3) {
    F5e.mouseup.call(this, l3);
  }, mousemove: function(l3) {
    this.trigger("mousemove", l3);
  }, mouseup: function(l3) {
    var r3 = this.__pointerCapturing;
    this.__togglePointerCapture(false), this.trigger("mouseup", l3), r3 && (l3.zrEventControl = "only_globalout", this.trigger("mouseout", l3));
  } };
  function hln(l3, r3) {
    var e3 = r3.domHandlers;
    Fc.pointerEventsSupported ? mt(KIe.pointer, function(u) {
      xfe(r3, u, function(h) {
        e3[u].call(l3, h);
      });
    }) : (Fc.touchEventsSupported && mt(KIe.touch, function(u) {
      xfe(r3, u, function(h) {
        e3[u].call(l3, h), uln(r3);
      });
    }), mt(KIe.mouse, function(u) {
      xfe(r3, u, function(h) {
        h = E3e(h), r3.touching || e3[u].call(l3, h);
      });
    }));
  }
  function pln(l3, r3) {
    Fc.pointerEventsSupported ? mt(vtt.pointer, e3) : Fc.touchEventsSupported || mt(vtt.mouse, e3);
    function e3(u) {
      function h(v4) {
        v4 = E3e(v4), iut(l3, v4.target) || (v4 = cln(l3, v4), r3.domHandlers[u].call(l3, v4));
      }
      xfe(r3, u, h, { capture: true });
    }
  }
  function xfe(l3, r3, e3, u) {
    l3.mounted[r3] = e3, l3.listenerOpts[r3] = u, T5e(l3.domTarget, r3, e3, u);
  }
  function JIe(l3) {
    var r3 = l3.mounted;
    for (var e3 in r3)
      r3.hasOwnProperty(e3) && xsn(l3.domTarget, e3, r3[e3], l3.listenerOpts[e3]);
    l3.mounted = {};
  }
  var ytt = function() {
    function l3(r3, e3) {
      this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = r3, this.domHandlers = e3;
    }
    return l3;
  }(), dln = function(l3) {
    ar(r3, l3);
    function r3(e3, u) {
      var h = l3.call(this) || this;
      return h.__pointerCapturing = false, h.dom = e3, h.painterRoot = u, h._localHandlerScope = new ytt(e3, uM), YIe && (h._globalHandlerScope = new ytt(document, F5e)), hln(h, h._localHandlerScope), h;
    }
    return r3.prototype.dispose = function() {
      JIe(this._localHandlerScope), YIe && JIe(this._globalHandlerScope);
    }, r3.prototype.setCursor = function(e3) {
      this.dom.style && (this.dom.style.cursor = e3 || "default");
    }, r3.prototype.__togglePointerCapture = function(e3) {
      if (this.__mayPointerCapture = null, YIe && +this.__pointerCapturing ^ +e3) {
        this.__pointerCapturing = e3;
        var u = this._globalHandlerScope;
        e3 ? pln(this, u) : JIe(u);
      }
    }, r3;
  }(w2), vln = dln, aut = 1;
  Fc.hasGlobalWindow && (aut = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
  var Hfe = aut, V5e = 0.4, B5e = "#333", z5e = "#ccc", gln = "#eee";
  function _2() {
    return [1, 0, 0, 1, 0, 0];
  }
  function jhe(l3) {
    return l3[0] = 1, l3[1] = 0, l3[2] = 0, l3[3] = 1, l3[4] = 0, l3[5] = 0, l3;
  }
  function O3e(l3, r3) {
    return l3[0] = r3[0], l3[1] = r3[1], l3[2] = r3[2], l3[3] = r3[3], l3[4] = r3[4], l3[5] = r3[5], l3;
  }
  function i5(l3, r3, e3) {
    var u = r3[0] * e3[0] + r3[2] * e3[1], h = r3[1] * e3[0] + r3[3] * e3[1], v4 = r3[0] * e3[2] + r3[2] * e3[3], m3 = r3[1] * e3[2] + r3[3] * e3[3], x3 = r3[0] * e3[4] + r3[2] * e3[5] + r3[4], C = r3[1] * e3[4] + r3[3] * e3[5] + r3[5];
    return l3[0] = u, l3[1] = h, l3[2] = v4, l3[3] = m3, l3[4] = x3, l3[5] = C, l3;
  }
  function UA(l3, r3, e3) {
    return l3[0] = r3[0], l3[1] = r3[1], l3[2] = r3[2], l3[3] = r3[3], l3[4] = r3[4] + e3[0], l3[5] = r3[5] + e3[1], l3;
  }
  function ZN(l3, r3, e3) {
    var u = r3[0], h = r3[2], v4 = r3[4], m3 = r3[1], x3 = r3[3], C = r3[5], A2 = Math.sin(e3), D = Math.cos(e3);
    return l3[0] = u * D + m3 * A2, l3[1] = -u * A2 + m3 * D, l3[2] = h * D + x3 * A2, l3[3] = -h * A2 + D * x3, l3[4] = D * v4 + A2 * C, l3[5] = D * C - A2 * v4, l3;
  }
  function P3e(l3, r3, e3) {
    var u = e3[0], h = e3[1];
    return l3[0] = r3[0] * u, l3[1] = r3[1] * h, l3[2] = r3[2] * u, l3[3] = r3[3] * h, l3[4] = r3[4] * u, l3[5] = r3[5] * h, l3;
  }
  function _j(l3, r3) {
    var e3 = r3[0], u = r3[2], h = r3[4], v4 = r3[1], m3 = r3[3], x3 = r3[5], C = e3 * m3 - v4 * u;
    return C ? (C = 1 / C, l3[0] = m3 * C, l3[1] = -v4 * C, l3[2] = -u * C, l3[3] = e3 * C, l3[4] = (u * x3 - m3 * h) * C, l3[5] = (v4 * h - e3 * x3) * C, l3) : null;
  }
  function yln(l3) {
    var r3 = _2();
    return O3e(r3, l3), r3;
  }
  var mtt = jhe, btt = 5e-5;
  function W6(l3) {
    return l3 > btt || l3 < -btt;
  }
  var U6 = [], Sz = [], QIe = _2(), eEe = Math.abs, mln = function() {
    function l3() {
    }
    return l3.prototype.getLocalTransform = function(r3) {
      return l3.getLocalTransform(this, r3);
    }, l3.prototype.setPosition = function(r3) {
      this.x = r3[0], this.y = r3[1];
    }, l3.prototype.setScale = function(r3) {
      this.scaleX = r3[0], this.scaleY = r3[1];
    }, l3.prototype.setSkew = function(r3) {
      this.skewX = r3[0], this.skewY = r3[1];
    }, l3.prototype.setOrigin = function(r3) {
      this.originX = r3[0], this.originY = r3[1];
    }, l3.prototype.needLocalTransform = function() {
      return W6(this.rotation) || W6(this.x) || W6(this.y) || W6(this.scaleX - 1) || W6(this.scaleY - 1) || W6(this.skewX) || W6(this.skewY);
    }, l3.prototype.updateTransform = function() {
      var r3 = this.parent && this.parent.transform, e3 = this.needLocalTransform(), u = this.transform;
      if (!(e3 || r3)) {
        u && mtt(u);
        return;
      }
      u = u || _2(), e3 ? this.getLocalTransform(u) : mtt(u), r3 && (e3 ? i5(u, r3, u) : O3e(u, r3)), this.transform = u, this._resolveGlobalScaleRatio(u);
    }, l3.prototype._resolveGlobalScaleRatio = function(r3) {
      var e3 = this.globalScaleRatio;
      if (e3 != null && e3 !== 1) {
        this.getGlobalScale(U6);
        var u = U6[0] < 0 ? -1 : 1, h = U6[1] < 0 ? -1 : 1, v4 = ((U6[0] - u) * e3 + u) / U6[0] || 0, m3 = ((U6[1] - h) * e3 + h) / U6[1] || 0;
        r3[0] *= v4, r3[1] *= v4, r3[2] *= m3, r3[3] *= m3;
      }
      this.invTransform = this.invTransform || _2(), _j(this.invTransform, r3);
    }, l3.prototype.getComputedTransform = function() {
      for (var r3 = this, e3 = []; r3; )
        e3.push(r3), r3 = r3.parent;
      for (; r3 = e3.pop(); )
        r3.updateTransform();
      return this.transform;
    }, l3.prototype.setLocalTransform = function(r3) {
      if (!!r3) {
        var e3 = r3[0] * r3[0] + r3[1] * r3[1], u = r3[2] * r3[2] + r3[3] * r3[3], h = Math.atan2(r3[1], r3[0]), v4 = Math.PI / 2 + h - Math.atan2(r3[3], r3[2]);
        u = Math.sqrt(u) * Math.cos(v4), e3 = Math.sqrt(e3), this.skewX = v4, this.skewY = 0, this.rotation = -h, this.x = +r3[4], this.y = +r3[5], this.scaleX = e3, this.scaleY = u, this.originX = 0, this.originY = 0;
      }
    }, l3.prototype.decomposeTransform = function() {
      if (!!this.transform) {
        var r3 = this.parent, e3 = this.transform;
        r3 && r3.transform && (i5(Sz, r3.invTransform, e3), e3 = Sz);
        var u = this.originX, h = this.originY;
        (u || h) && (QIe[4] = u, QIe[5] = h, i5(Sz, e3, QIe), Sz[4] -= u, Sz[5] -= h, e3 = Sz), this.setLocalTransform(e3);
      }
    }, l3.prototype.getGlobalScale = function(r3) {
      var e3 = this.transform;
      return r3 = r3 || [], e3 ? (r3[0] = Math.sqrt(e3[0] * e3[0] + e3[1] * e3[1]), r3[1] = Math.sqrt(e3[2] * e3[2] + e3[3] * e3[3]), e3[0] < 0 && (r3[0] = -r3[0]), e3[3] < 0 && (r3[1] = -r3[1]), r3) : (r3[0] = 1, r3[1] = 1, r3);
    }, l3.prototype.transformCoordToLocal = function(r3, e3) {
      var u = [r3, e3], h = this.invTransform;
      return h && am(u, u, h), u;
    }, l3.prototype.transformCoordToGlobal = function(r3, e3) {
      var u = [r3, e3], h = this.transform;
      return h && am(u, u, h), u;
    }, l3.prototype.getLineScale = function() {
      var r3 = this.transform;
      return r3 && eEe(r3[0] - 1) > 1e-10 && eEe(r3[3] - 1) > 1e-10 ? Math.sqrt(eEe(r3[0] * r3[3] - r3[2] * r3[1])) : 1;
    }, l3.prototype.copyTransform = function(r3) {
      out2(this, r3);
    }, l3.getLocalTransform = function(r3, e3) {
      e3 = e3 || [];
      var u = r3.originX || 0, h = r3.originY || 0, v4 = r3.scaleX, m3 = r3.scaleY, x3 = r3.anchorX, C = r3.anchorY, A2 = r3.rotation || 0, D = r3.x, P = r3.y, N = r3.skewX ? Math.tan(r3.skewX) : 0, j = r3.skewY ? Math.tan(-r3.skewY) : 0;
      if (u || h || x3 || C) {
        var W = u + x3, K = h + C;
        e3[4] = -W * v4 - N * K * m3, e3[5] = -K * m3 - j * W * v4;
      } else
        e3[4] = e3[5] = 0;
      return e3[0] = v4, e3[3] = m3, e3[1] = j * v4, e3[2] = N * m3, A2 && ZN(e3, e3, A2), e3[4] += u + D, e3[5] += h + P, e3;
    }, l3.initDefaultProps = function() {
      var r3 = l3.prototype;
      r3.scaleX = r3.scaleY = r3.globalScaleRatio = 1, r3.x = r3.y = r3.originX = r3.originY = r3.skewX = r3.skewY = r3.rotation = r3.anchorX = r3.anchorY = 0;
    }(), l3;
  }(), qA = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
  function out2(l3, r3) {
    for (var e3 = 0; e3 < qA.length; e3++) {
      var u = qA[e3];
      l3[u] = r3[u];
    }
  }
  var QD = mln, bln = function() {
    function l3(r3, e3) {
      this.x = r3 || 0, this.y = e3 || 0;
    }
    return l3.prototype.copy = function(r3) {
      return this.x = r3.x, this.y = r3.y, this;
    }, l3.prototype.clone = function() {
      return new l3(this.x, this.y);
    }, l3.prototype.set = function(r3, e3) {
      return this.x = r3, this.y = e3, this;
    }, l3.prototype.equal = function(r3) {
      return r3.x === this.x && r3.y === this.y;
    }, l3.prototype.add = function(r3) {
      return this.x += r3.x, this.y += r3.y, this;
    }, l3.prototype.scale = function(r3) {
      this.x *= r3, this.y *= r3;
    }, l3.prototype.scaleAndAdd = function(r3, e3) {
      this.x += r3.x * e3, this.y += r3.y * e3;
    }, l3.prototype.sub = function(r3) {
      return this.x -= r3.x, this.y -= r3.y, this;
    }, l3.prototype.dot = function(r3) {
      return this.x * r3.x + this.y * r3.y;
    }, l3.prototype.len = function() {
      return Math.sqrt(this.x * this.x + this.y * this.y);
    }, l3.prototype.lenSquare = function() {
      return this.x * this.x + this.y * this.y;
    }, l3.prototype.normalize = function() {
      var r3 = this.len();
      return this.x /= r3, this.y /= r3, this;
    }, l3.prototype.distance = function(r3) {
      var e3 = this.x - r3.x, u = this.y - r3.y;
      return Math.sqrt(e3 * e3 + u * u);
    }, l3.prototype.distanceSquare = function(r3) {
      var e3 = this.x - r3.x, u = this.y - r3.y;
      return e3 * e3 + u * u;
    }, l3.prototype.negate = function() {
      return this.x = -this.x, this.y = -this.y, this;
    }, l3.prototype.transform = function(r3) {
      if (!!r3) {
        var e3 = this.x, u = this.y;
        return this.x = r3[0] * e3 + r3[2] * u + r3[4], this.y = r3[1] * e3 + r3[3] * u + r3[5], this;
      }
    }, l3.prototype.toArray = function(r3) {
      return r3[0] = this.x, r3[1] = this.y, r3;
    }, l3.prototype.fromArray = function(r3) {
      this.x = r3[0], this.y = r3[1];
    }, l3.set = function(r3, e3, u) {
      r3.x = e3, r3.y = u;
    }, l3.copy = function(r3, e3) {
      r3.x = e3.x, r3.y = e3.y;
    }, l3.len = function(r3) {
      return Math.sqrt(r3.x * r3.x + r3.y * r3.y);
    }, l3.lenSquare = function(r3) {
      return r3.x * r3.x + r3.y * r3.y;
    }, l3.dot = function(r3, e3) {
      return r3.x * e3.x + r3.y * e3.y;
    }, l3.add = function(r3, e3, u) {
      r3.x = e3.x + u.x, r3.y = e3.y + u.y;
    }, l3.sub = function(r3, e3, u) {
      r3.x = e3.x - u.x, r3.y = e3.y - u.y;
    }, l3.scale = function(r3, e3, u) {
      r3.x = e3.x * u, r3.y = e3.y * u;
    }, l3.scaleAndAdd = function(r3, e3, u, h) {
      r3.x = e3.x + u.x * h, r3.y = e3.y + u.y * h;
    }, l3.lerp = function(r3, e3, u, h) {
      var v4 = 1 - h;
      r3.x = v4 * e3.x + h * u.x, r3.y = v4 * e3.y + h * u.y;
    }, l3;
  }(), nl = bln, dce = Math.min, vce = Math.max, q6 = new nl(), $6 = new nl(), X6 = new nl(), Y6 = new nl(), WK = new nl(), UK = new nl(), _ln = function() {
    function l3(r3, e3, u, h) {
      u < 0 && (r3 = r3 + u, u = -u), h < 0 && (e3 = e3 + h, h = -h), this.x = r3, this.y = e3, this.width = u, this.height = h;
    }
    return l3.prototype.union = function(r3) {
      var e3 = dce(r3.x, this.x), u = dce(r3.y, this.y);
      isFinite(this.x) && isFinite(this.width) ? this.width = vce(r3.x + r3.width, this.x + this.width) - e3 : this.width = r3.width, isFinite(this.y) && isFinite(this.height) ? this.height = vce(r3.y + r3.height, this.y + this.height) - u : this.height = r3.height, this.x = e3, this.y = u;
    }, l3.prototype.applyTransform = function(r3) {
      l3.applyTransform(this, this, r3);
    }, l3.prototype.calculateTransform = function(r3) {
      var e3 = this, u = r3.width / e3.width, h = r3.height / e3.height, v4 = _2();
      return UA(v4, v4, [-e3.x, -e3.y]), P3e(v4, v4, [u, h]), UA(v4, v4, [r3.x, r3.y]), v4;
    }, l3.prototype.intersect = function(r3, e3) {
      if (!r3)
        return false;
      r3 instanceof l3 || (r3 = l3.create(r3));
      var u = this, h = u.x, v4 = u.x + u.width, m3 = u.y, x3 = u.y + u.height, C = r3.x, A2 = r3.x + r3.width, D = r3.y, P = r3.y + r3.height, N = !(v4 < C || A2 < h || x3 < D || P < m3);
      if (e3) {
        var j = 1 / 0, W = 0, K = Math.abs(v4 - C), te = Math.abs(A2 - h), ne = Math.abs(x3 - D), ce = Math.abs(P - m3), me = Math.min(K, te), ve = Math.min(ne, ce);
        v4 < C || A2 < h ? me > W && (W = me, K < te ? nl.set(UK, -K, 0) : nl.set(UK, te, 0)) : me < j && (j = me, K < te ? nl.set(WK, K, 0) : nl.set(WK, -te, 0)), x3 < D || P < m3 ? ve > W && (W = ve, ne < ce ? nl.set(UK, 0, -ne) : nl.set(UK, 0, ce)) : me < j && (j = me, ne < ce ? nl.set(WK, 0, ne) : nl.set(WK, 0, -ce));
      }
      return e3 && nl.copy(e3, N ? WK : UK), N;
    }, l3.prototype.contain = function(r3, e3) {
      var u = this;
      return r3 >= u.x && r3 <= u.x + u.width && e3 >= u.y && e3 <= u.y + u.height;
    }, l3.prototype.clone = function() {
      return new l3(this.x, this.y, this.width, this.height);
    }, l3.prototype.copy = function(r3) {
      l3.copy(this, r3);
    }, l3.prototype.plain = function() {
      return { x: this.x, y: this.y, width: this.width, height: this.height };
    }, l3.prototype.isFinite = function() {
      return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
    }, l3.prototype.isZero = function() {
      return this.width === 0 || this.height === 0;
    }, l3.create = function(r3) {
      return new l3(r3.x, r3.y, r3.width, r3.height);
    }, l3.copy = function(r3, e3) {
      r3.x = e3.x, r3.y = e3.y, r3.width = e3.width, r3.height = e3.height;
    }, l3.applyTransform = function(r3, e3, u) {
      if (!u) {
        r3 !== e3 && l3.copy(r3, e3);
        return;
      }
      if (u[1] < 1e-5 && u[1] > -1e-5 && u[2] < 1e-5 && u[2] > -1e-5) {
        var h = u[0], v4 = u[3], m3 = u[4], x3 = u[5];
        r3.x = e3.x * h + m3, r3.y = e3.y * v4 + x3, r3.width = e3.width * h, r3.height = e3.height * v4, r3.width < 0 && (r3.x += r3.width, r3.width = -r3.width), r3.height < 0 && (r3.y += r3.height, r3.height = -r3.height);
        return;
      }
      q6.x = X6.x = e3.x, q6.y = Y6.y = e3.y, $6.x = Y6.x = e3.x + e3.width, $6.y = X6.y = e3.y + e3.height, q6.transform(u), Y6.transform(u), $6.transform(u), X6.transform(u), r3.x = dce(q6.x, $6.x, X6.x, Y6.x), r3.y = dce(q6.y, $6.y, X6.y, Y6.y);
      var C = vce(q6.x, $6.x, X6.x, Y6.x), A2 = vce(q6.y, $6.y, X6.y, Y6.y);
      r3.width = C - r3.x, r3.height = A2 - r3.y;
    }, l3;
  }(), Ml = _ln, _tt = {};
  function Qx(l3, r3) {
    r3 = r3 || KO;
    var e3 = _tt[r3];
    e3 || (e3 = _tt[r3] = new EJ(500));
    var u = e3.get(l3);
    return u == null && (u = l5.measureText(l3, r3).width, e3.put(l3, u)), u;
  }
  function xtt(l3, r3, e3, u) {
    var h = Qx(l3, r3), v4 = Ghe(r3), m3 = xZ(0, h, e3), x3 = Wz(0, v4, u), C = new Ml(m3, x3, h, v4);
    return C;
  }
  function DJ(l3, r3, e3, u) {
    var h = ((l3 || "") + "").split(`
`), v4 = h.length;
    if (v4 === 1)
      return xtt(h[0], r3, e3, u);
    for (var m3 = new Ml(0, 0, 0, 0), x3 = 0; x3 < h.length; x3++) {
      var C = xtt(h[x3], r3, e3, u);
      x3 === 0 ? m3.copy(C) : m3.union(C);
    }
    return m3;
  }
  function xZ(l3, r3, e3) {
    return e3 === "right" ? l3 -= r3 : e3 === "center" && (l3 -= r3 / 2), l3;
  }
  function Wz(l3, r3, e3) {
    return e3 === "middle" ? l3 -= r3 / 2 : e3 === "bottom" && (l3 -= r3), l3;
  }
  function Ghe(l3) {
    return Qx("\u56FD", l3);
  }
  function gM(l3, r3) {
    return typeof l3 == "string" ? l3.lastIndexOf("%") >= 0 ? parseFloat(l3) / 100 * r3 : parseFloat(l3) : l3;
  }
  function Wfe(l3, r3, e3) {
    var u = r3.position || "inside", h = r3.distance != null ? r3.distance : 5, v4 = e3.height, m3 = e3.width, x3 = v4 / 2, C = e3.x, A2 = e3.y, D = "left", P = "top";
    if (u instanceof Array)
      C += gM(u[0], e3.width), A2 += gM(u[1], e3.height), D = null, P = null;
    else
      switch (u) {
        case "left":
          C -= h, A2 += x3, D = "right", P = "middle";
          break;
        case "right":
          C += h + m3, A2 += x3, P = "middle";
          break;
        case "top":
          C += m3 / 2, A2 -= h, D = "center", P = "bottom";
          break;
        case "bottom":
          C += m3 / 2, A2 += v4 + h, D = "center";
          break;
        case "inside":
          C += m3 / 2, A2 += x3, D = "center", P = "middle";
          break;
        case "insideLeft":
          C += h, A2 += x3, P = "middle";
          break;
        case "insideRight":
          C += m3 - h, A2 += x3, D = "right", P = "middle";
          break;
        case "insideTop":
          C += m3 / 2, A2 += h, D = "center";
          break;
        case "insideBottom":
          C += m3 / 2, A2 += v4 - h, D = "center", P = "bottom";
          break;
        case "insideTopLeft":
          C += h, A2 += h;
          break;
        case "insideTopRight":
          C += m3 - h, A2 += h, D = "right";
          break;
        case "insideBottomLeft":
          C += h, A2 += v4 - h, P = "bottom";
          break;
        case "insideBottomRight":
          C += m3 - h, A2 += v4 - h, D = "right", P = "bottom";
          break;
      }
    return l3 = l3 || {}, l3.x = C, l3.y = A2, l3.align = D, l3.verticalAlign = P, l3;
  }
  var tEe = "__zr_normal__", nEe = qA.concat(["ignore"]), xln = WA(qA, function(l3, r3) {
    return l3[r3] = true, l3;
  }, { ignore: false }), Cz = {}, wln = new Ml(0, 0, 0, 0), L3e = function() {
    function l3(r3) {
      this.id = Llt(), this.animators = [], this.currentStates = [], this.states = {}, this._init(r3);
    }
    return l3.prototype._init = function(r3) {
      this.attr(r3);
    }, l3.prototype.drift = function(r3, e3, u) {
      switch (this.draggable) {
        case "horizontal":
          e3 = 0;
          break;
        case "vertical":
          r3 = 0;
          break;
      }
      var h = this.transform;
      h || (h = this.transform = [1, 0, 0, 1, 0, 0]), h[4] += r3, h[5] += e3, this.decomposeTransform(), this.markRedraw();
    }, l3.prototype.beforeUpdate = function() {
    }, l3.prototype.afterUpdate = function() {
    }, l3.prototype.update = function() {
      this.updateTransform(), this.__dirty && this.updateInnerText();
    }, l3.prototype.updateInnerText = function(r3) {
      var e3 = this._textContent;
      if (e3 && (!e3.ignore || r3)) {
        this.textConfig || (this.textConfig = {});
        var u = this.textConfig, h = u.local, v4 = e3.innerTransformable, m3 = void 0, x3 = void 0, C = false;
        v4.parent = h ? this : null;
        var A2 = false;
        if (v4.copyTransform(e3), u.position != null) {
          var D = wln;
          u.layoutRect ? D.copy(u.layoutRect) : D.copy(this.getBoundingRect()), h || D.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(Cz, u, D) : Wfe(Cz, u, D), v4.x = Cz.x, v4.y = Cz.y, m3 = Cz.align, x3 = Cz.verticalAlign;
          var P = u.origin;
          if (P && u.rotation != null) {
            var N = void 0, j = void 0;
            P === "center" ? (N = D.width * 0.5, j = D.height * 0.5) : (N = gM(P[0], D.width), j = gM(P[1], D.height)), A2 = true, v4.originX = -v4.x + N + (h ? 0 : D.x), v4.originY = -v4.y + j + (h ? 0 : D.y);
          }
        }
        u.rotation != null && (v4.rotation = u.rotation);
        var W = u.offset;
        W && (v4.x += W[0], v4.y += W[1], A2 || (v4.originX = -W[0], v4.originY = -W[1]));
        var K = u.inside == null ? typeof u.position == "string" && u.position.indexOf("inside") >= 0 : u.inside, te = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), ne = void 0, ce = void 0, me = void 0;
        K && this.canBeInsideText() ? (ne = u.insideFill, ce = u.insideStroke, (ne == null || ne === "auto") && (ne = this.getInsideTextFill()), (ce == null || ce === "auto") && (ce = this.getInsideTextStroke(ne), me = true)) : (ne = u.outsideFill, ce = u.outsideStroke, (ne == null || ne === "auto") && (ne = this.getOutsideFill()), (ce == null || ce === "auto") && (ce = this.getOutsideStroke(ne), me = true)), ne = ne || "#000", (ne !== te.fill || ce !== te.stroke || me !== te.autoStroke || m3 !== te.align || x3 !== te.verticalAlign) && (C = true, te.fill = ne, te.stroke = ce, te.autoStroke = me, te.align = m3, te.verticalAlign = x3, e3.setDefaultTextStyle(te)), e3.__dirty |= Kx, C && e3.dirtyStyle(true);
      }
    }, l3.prototype.canBeInsideText = function() {
      return true;
    }, l3.prototype.getInsideTextFill = function() {
      return "#fff";
    }, l3.prototype.getInsideTextStroke = function(r3) {
      return "#000";
    }, l3.prototype.getOutsideFill = function() {
      return this.__zr && this.__zr.isDarkMode() ? z5e : B5e;
    }, l3.prototype.getOutsideStroke = function(r3) {
      var e3 = this.__zr && this.__zr.getBackgroundColor(), u = typeof e3 == "string" && Jx(e3);
      u || (u = [255, 255, 255, 1]);
      for (var h = u[3], v4 = this.__zr.isDarkMode(), m3 = 0; m3 < 3; m3++)
        u[m3] = u[m3] * h + (v4 ? 0 : 255) * (1 - h);
      return u[3] = 1, r5(u, "rgba");
    }, l3.prototype.traverse = function(r3, e3) {
    }, l3.prototype.attrKV = function(r3, e3) {
      r3 === "textConfig" ? this.setTextConfig(e3) : r3 === "textContent" ? this.setTextContent(e3) : r3 === "clipPath" ? this.setClipPath(e3) : r3 === "extra" ? (this.extra = this.extra || {}, fi(this.extra, e3)) : this[r3] = e3;
    }, l3.prototype.hide = function() {
      this.ignore = true, this.markRedraw();
    }, l3.prototype.show = function() {
      this.ignore = false, this.markRedraw();
    }, l3.prototype.attr = function(r3, e3) {
      if (typeof r3 == "string")
        this.attrKV(r3, e3);
      else if (ls(r3))
        for (var u = r3, h = yu(u), v4 = 0; v4 < h.length; v4++) {
          var m3 = h[v4];
          this.attrKV(m3, r3[m3]);
        }
      return this.markRedraw(), this;
    }, l3.prototype.saveCurrentToNormalState = function(r3) {
      this._innerSaveToNormal(r3);
      for (var e3 = this._normalState, u = 0; u < this.animators.length; u++) {
        var h = this.animators[u], v4 = h.__fromStateTransition;
        if (!(h.getLoop() || v4 && v4 !== tEe)) {
          var m3 = h.targetName, x3 = m3 ? e3[m3] : e3;
          h.saveTo(x3);
        }
      }
    }, l3.prototype._innerSaveToNormal = function(r3) {
      var e3 = this._normalState;
      e3 || (e3 = this._normalState = {}), r3.textConfig && !e3.textConfig && (e3.textConfig = this.textConfig), this._savePrimaryToNormal(r3, e3, nEe);
    }, l3.prototype._savePrimaryToNormal = function(r3, e3, u) {
      for (var h = 0; h < u.length; h++) {
        var v4 = u[h];
        r3[v4] != null && !(v4 in e3) && (e3[v4] = this[v4]);
      }
    }, l3.prototype.hasState = function() {
      return this.currentStates.length > 0;
    }, l3.prototype.getState = function(r3) {
      return this.states[r3];
    }, l3.prototype.ensureState = function(r3) {
      var e3 = this.states;
      return e3[r3] || (e3[r3] = {}), e3[r3];
    }, l3.prototype.clearStates = function(r3) {
      this.useState(tEe, false, r3);
    }, l3.prototype.useState = function(r3, e3, u, h) {
      var v4 = r3 === tEe, m3 = this.hasState();
      if (!(!m3 && v4)) {
        var x3 = this.currentStates, C = this.stateTransition;
        if (!(Cl(x3, r3) >= 0 && (e3 || x3.length === 1))) {
          var A2;
          if (this.stateProxy && !v4 && (A2 = this.stateProxy(r3)), A2 || (A2 = this.states && this.states[r3]), !A2 && !v4) {
            M3e("State " + r3 + " not exists.");
            return;
          }
          v4 || this.saveCurrentToNormalState(A2);
          var D = !!(A2 && A2.hoverLayer || h);
          D && this._toggleHoverLayerFlag(true), this._applyStateObj(r3, A2, this._normalState, e3, !u && !this.__inHover && C && C.duration > 0, C);
          var P = this._textContent, N = this._textGuide;
          return P && P.useState(r3, e3, u, D), N && N.useState(r3, e3, u, D), v4 ? (this.currentStates = [], this._normalState = {}) : e3 ? this.currentStates.push(r3) : this.currentStates = [r3], this._updateAnimationTargets(), this.markRedraw(), !D && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Kx), A2;
        }
      }
    }, l3.prototype.useStates = function(r3, e3, u) {
      if (!r3.length)
        this.clearStates();
      else {
        var h = [], v4 = this.currentStates, m3 = r3.length, x3 = m3 === v4.length;
        if (x3) {
          for (var C = 0; C < m3; C++)
            if (r3[C] !== v4[C]) {
              x3 = false;
              break;
            }
        }
        if (x3)
          return;
        for (var C = 0; C < m3; C++) {
          var A2 = r3[C], D = void 0;
          this.stateProxy && (D = this.stateProxy(A2, r3)), D || (D = this.states[A2]), D && h.push(D);
        }
        var P = h[m3 - 1], N = !!(P && P.hoverLayer || u);
        N && this._toggleHoverLayerFlag(true);
        var j = this._mergeStates(h), W = this.stateTransition;
        this.saveCurrentToNormalState(j), this._applyStateObj(r3.join(","), j, this._normalState, false, !e3 && !this.__inHover && W && W.duration > 0, W);
        var K = this._textContent, te = this._textGuide;
        K && K.useStates(r3, e3, N), te && te.useStates(r3, e3, N), this._updateAnimationTargets(), this.currentStates = r3.slice(), this.markRedraw(), !N && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~Kx);
      }
    }, l3.prototype._updateAnimationTargets = function() {
      for (var r3 = 0; r3 < this.animators.length; r3++) {
        var e3 = this.animators[r3];
        e3.targetName && e3.changeTarget(this[e3.targetName]);
      }
    }, l3.prototype.removeState = function(r3) {
      var e3 = Cl(this.currentStates, r3);
      if (e3 >= 0) {
        var u = this.currentStates.slice();
        u.splice(e3, 1), this.useStates(u);
      }
    }, l3.prototype.replaceState = function(r3, e3, u) {
      var h = this.currentStates.slice(), v4 = Cl(h, r3), m3 = Cl(h, e3) >= 0;
      v4 >= 0 ? m3 ? h.splice(v4, 1) : h[v4] = e3 : u && !m3 && h.push(e3), this.useStates(h);
    }, l3.prototype.toggleState = function(r3, e3) {
      e3 ? this.useState(r3, true) : this.removeState(r3);
    }, l3.prototype._mergeStates = function(r3) {
      for (var e3 = {}, u, h = 0; h < r3.length; h++) {
        var v4 = r3[h];
        fi(e3, v4), v4.textConfig && (u = u || {}, fi(u, v4.textConfig));
      }
      return u && (e3.textConfig = u), e3;
    }, l3.prototype._applyStateObj = function(r3, e3, u, h, v4, m3) {
      var x3 = !(e3 && h);
      e3 && e3.textConfig ? (this.textConfig = fi({}, h ? this.textConfig : u.textConfig), fi(this.textConfig, e3.textConfig)) : x3 && u.textConfig && (this.textConfig = u.textConfig);
      for (var C = {}, A2 = false, D = 0; D < nEe.length; D++) {
        var P = nEe[D], N = v4 && xln[P];
        e3 && e3[P] != null ? N ? (A2 = true, C[P] = e3[P]) : this[P] = e3[P] : x3 && u[P] != null && (N ? (A2 = true, C[P] = u[P]) : this[P] = u[P]);
      }
      if (!v4)
        for (var D = 0; D < this.animators.length; D++) {
          var j = this.animators[D], W = j.targetName;
          j.getLoop() || j.__changeFinalValue(W ? (e3 || u)[W] : e3 || u);
        }
      A2 && this._transitionState(r3, C, m3);
    }, l3.prototype._attachComponent = function(r3) {
      if (!(r3.__zr && !r3.__hostTarget) && r3 !== this) {
        var e3 = this.__zr;
        e3 && r3.addSelfToZr(e3), r3.__zr = e3, r3.__hostTarget = this;
      }
    }, l3.prototype._detachComponent = function(r3) {
      r3.__zr && r3.removeSelfFromZr(r3.__zr), r3.__zr = null, r3.__hostTarget = null;
    }, l3.prototype.getClipPath = function() {
      return this._clipPath;
    }, l3.prototype.setClipPath = function(r3) {
      this._clipPath && this._clipPath !== r3 && this.removeClipPath(), this._attachComponent(r3), this._clipPath = r3, this.markRedraw();
    }, l3.prototype.removeClipPath = function() {
      var r3 = this._clipPath;
      r3 && (this._detachComponent(r3), this._clipPath = null, this.markRedraw());
    }, l3.prototype.getTextContent = function() {
      return this._textContent;
    }, l3.prototype.setTextContent = function(r3) {
      var e3 = this._textContent;
      e3 !== r3 && (e3 && e3 !== r3 && this.removeTextContent(), r3.innerTransformable = new QD(), this._attachComponent(r3), this._textContent = r3, this.markRedraw());
    }, l3.prototype.setTextConfig = function(r3) {
      this.textConfig || (this.textConfig = {}), fi(this.textConfig, r3), this.markRedraw();
    }, l3.prototype.removeTextConfig = function() {
      this.textConfig = null, this.markRedraw();
    }, l3.prototype.removeTextContent = function() {
      var r3 = this._textContent;
      r3 && (r3.innerTransformable = null, this._detachComponent(r3), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
    }, l3.prototype.getTextGuideLine = function() {
      return this._textGuide;
    }, l3.prototype.setTextGuideLine = function(r3) {
      this._textGuide && this._textGuide !== r3 && this.removeTextGuideLine(), this._attachComponent(r3), this._textGuide = r3, this.markRedraw();
    }, l3.prototype.removeTextGuideLine = function() {
      var r3 = this._textGuide;
      r3 && (this._detachComponent(r3), this._textGuide = null, this.markRedraw());
    }, l3.prototype.markRedraw = function() {
      this.__dirty |= Kx;
      var r3 = this.__zr;
      r3 && (this.__inHover ? r3.refreshHover() : r3.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
    }, l3.prototype.dirty = function() {
      this.markRedraw();
    }, l3.prototype._toggleHoverLayerFlag = function(r3) {
      this.__inHover = r3;
      var e3 = this._textContent, u = this._textGuide;
      e3 && (e3.__inHover = r3), u && (u.__inHover = r3);
    }, l3.prototype.addSelfToZr = function(r3) {
      if (this.__zr !== r3) {
        this.__zr = r3;
        var e3 = this.animators;
        if (e3)
          for (var u = 0; u < e3.length; u++)
            r3.animation.addAnimator(e3[u]);
        this._clipPath && this._clipPath.addSelfToZr(r3), this._textContent && this._textContent.addSelfToZr(r3), this._textGuide && this._textGuide.addSelfToZr(r3);
      }
    }, l3.prototype.removeSelfFromZr = function(r3) {
      if (!!this.__zr) {
        this.__zr = null;
        var e3 = this.animators;
        if (e3)
          for (var u = 0; u < e3.length; u++)
            r3.animation.removeAnimator(e3[u]);
        this._clipPath && this._clipPath.removeSelfFromZr(r3), this._textContent && this._textContent.removeSelfFromZr(r3), this._textGuide && this._textGuide.removeSelfFromZr(r3);
      }
    }, l3.prototype.animate = function(r3, e3, u) {
      var h = r3 ? this[r3] : this, v4 = new k3e(h, e3, u);
      return r3 && (v4.targetName = r3), this.addAnimator(v4, r3), v4;
    }, l3.prototype.addAnimator = function(r3, e3) {
      var u = this.__zr, h = this;
      r3.during(function() {
        h.updateDuringAnimation(e3);
      }).done(function() {
        var v4 = h.animators, m3 = Cl(v4, r3);
        m3 >= 0 && v4.splice(m3, 1);
      }), this.animators.push(r3), u && u.animation.addAnimator(r3), u && u.wakeUp();
    }, l3.prototype.updateDuringAnimation = function(r3) {
      this.markRedraw();
    }, l3.prototype.stopAnimation = function(r3, e3) {
      for (var u = this.animators, h = u.length, v4 = [], m3 = 0; m3 < h; m3++) {
        var x3 = u[m3];
        !r3 || r3 === x3.scope ? x3.stop(e3) : v4.push(x3);
      }
      return this.animators = v4, this;
    }, l3.prototype.animateTo = function(r3, e3, u) {
      rEe(this, r3, e3, u);
    }, l3.prototype.animateFrom = function(r3, e3, u) {
      rEe(this, r3, e3, u, true);
    }, l3.prototype._transitionState = function(r3, e3, u, h) {
      for (var v4 = rEe(this, e3, u, h), m3 = 0; m3 < v4.length; m3++)
        v4[m3].__fromStateTransition = r3;
    }, l3.prototype.getBoundingRect = function() {
      return null;
    }, l3.prototype.getPaintRect = function() {
      return null;
    }, l3.initDefaultProps = function() {
      var r3 = l3.prototype;
      r3.type = "element", r3.name = "", r3.ignore = r3.silent = r3.isGroup = r3.draggable = r3.dragging = r3.ignoreClip = r3.__inHover = false, r3.__dirty = Kx;
      function e3(u, h, v4, m3) {
        Object.defineProperty(r3, u, { get: function() {
          if (!this[h]) {
            var C = this[h] = [];
            x3(this, C);
          }
          return this[h];
        }, set: function(C) {
          this[v4] = C[0], this[m3] = C[1], this[h] = C, x3(this, C);
        } });
        function x3(C, A2) {
          Object.defineProperty(A2, 0, { get: function() {
            return C[v4];
          }, set: function(D) {
            C[v4] = D;
          } }), Object.defineProperty(A2, 1, { get: function() {
            return C[m3];
          }, set: function(D) {
            C[m3] = D;
          } });
        }
      }
      Object.defineProperty && (e3("position", "_legacyPos", "x", "y"), e3("scale", "_legacyScale", "scaleX", "scaleY"), e3("origin", "_legacyOrigin", "originX", "originY"));
    }(), l3;
  }();
  Fv(L3e, w2);
  Fv(L3e, QD);
  function rEe(l3, r3, e3, u, h) {
    e3 = e3 || {};
    var v4 = [];
    sut(l3, "", l3, r3, e3, u, v4, h);
    var m3 = v4.length, x3 = false, C = e3.done, A2 = e3.aborted, D = function() {
      x3 = true, m3--, m3 <= 0 && (x3 ? C && C() : A2 && A2());
    }, P = function() {
      m3--, m3 <= 0 && (x3 ? C && C() : A2 && A2());
    };
    m3 || C && C(), v4.length > 0 && e3.during && v4[0].during(function(W, K) {
      e3.during(K);
    });
    for (var N = 0; N < v4.length; N++) {
      var j = v4[N];
      D && j.done(D), P && j.aborted(P), e3.force && j.duration(e3.duration), j.start(e3.easing);
    }
    return v4;
  }
  function iEe(l3, r3, e3) {
    for (var u = 0; u < e3; u++)
      l3[u] = r3[u];
  }
  function Sln(l3) {
    return m1(l3[0]);
  }
  function Cln(l3, r3, e3) {
    if (m1(r3[e3]))
      if (m1(l3[e3]) || (l3[e3] = []), ew(r3[e3])) {
        var u = r3[e3].length;
        l3[e3].length !== u && (l3[e3] = new r3[e3].constructor(u), iEe(l3[e3], r3[e3], u));
      } else {
        var h = r3[e3], v4 = l3[e3], m3 = h.length;
        if (Sln(h))
          for (var x3 = h[0].length, C = 0; C < m3; C++)
            v4[C] ? iEe(v4[C], h[C], x3) : v4[C] = Array.prototype.slice.call(h[C]);
        else
          iEe(v4, h, m3);
        v4.length = h.length;
      }
    else
      l3[e3] = r3[e3];
  }
  function Mln(l3, r3) {
    return l3 === r3 || m1(l3) && m1(r3) && Tln(l3, r3);
  }
  function Tln(l3, r3) {
    var e3 = l3.length;
    if (e3 !== r3.length)
      return false;
    for (var u = 0; u < e3; u++)
      if (l3[u] !== r3[u])
        return false;
    return true;
  }
  function sut(l3, r3, e3, u, h, v4, m3, x3) {
    for (var C = yu(u), A2 = h.duration, D = h.delay, P = h.additive, N = h.setToFinal, j = !ls(v4), W = l3.animators, K = [], te = 0; te < C.length; te++) {
      var ne = C[te], ce = u[ne];
      if (ce != null && e3[ne] != null && (j || v4[ne]))
        if (ls(ce) && !m1(ce) && !Vhe(ce)) {
          if (r3) {
            x3 || (e3[ne] = ce, l3.updateDuringAnimation(r3));
            continue;
          }
          sut(l3, ne, e3[ne], ce, h, v4 && v4[ne], m3, x3);
        } else
          K.push(ne);
      else
        x3 || (e3[ne] = ce, l3.updateDuringAnimation(r3), K.push(ne));
    }
    var me = K.length;
    if (!P && me)
      for (var ve = 0; ve < W.length; ve++) {
        var Be = W[ve];
        if (Be.targetName === r3) {
          var Oe = Be.stopTracks(K);
          if (Oe) {
            var We = Cl(W, Be);
            W.splice(We, 1);
          }
        }
      }
    if (h.force || (K = jf(K, function(ct) {
      return !Mln(u[ct], e3[ct]);
    }), me = K.length), me > 0 || h.force && !m3.length) {
      var Ue = void 0, qe = void 0, Ze = void 0;
      if (x3) {
        qe = {}, N && (Ue = {});
        for (var ve = 0; ve < me; ve++) {
          var ne = K[ve];
          qe[ne] = e3[ne], N ? Ue[ne] = u[ne] : e3[ne] = u[ne];
        }
      } else if (N) {
        Ze = {};
        for (var ve = 0; ve < me; ve++) {
          var ne = K[ve];
          Ze[ne] = LZ(e3[ne]), Cln(e3, u, ne);
        }
      }
      var Be = new k3e(e3, false, false, P ? jf(W, function(_t) {
        return _t.targetName === r3;
      }) : null);
      Be.targetName = r3, h.scope && (Be.scope = h.scope), N && Ue && Be.whenWithKeys(0, Ue, K), Ze && Be.whenWithKeys(0, Ze, K), Be.whenWithKeys(A2 == null ? 500 : A2, x3 ? qe : u, K).delay(D || 0), l3.addAnimator(Be, r3), m3.push(Be);
    }
  }
  var lut = L3e, uut = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this) || this;
      return u.isGroup = true, u._children = [], u.attr(e3), u;
    }
    return r3.prototype.childrenRef = function() {
      return this._children;
    }, r3.prototype.children = function() {
      return this._children.slice();
    }, r3.prototype.childAt = function(e3) {
      return this._children[e3];
    }, r3.prototype.childOfName = function(e3) {
      for (var u = this._children, h = 0; h < u.length; h++)
        if (u[h].name === e3)
          return u[h];
    }, r3.prototype.childCount = function() {
      return this._children.length;
    }, r3.prototype.add = function(e3) {
      return e3 && e3 !== this && e3.parent !== this && (this._children.push(e3), this._doAdd(e3)), this;
    }, r3.prototype.addBefore = function(e3, u) {
      if (e3 && e3 !== this && e3.parent !== this && u && u.parent === this) {
        var h = this._children, v4 = h.indexOf(u);
        v4 >= 0 && (h.splice(v4, 0, e3), this._doAdd(e3));
      }
      return this;
    }, r3.prototype.replace = function(e3, u) {
      var h = Cl(this._children, e3);
      return h >= 0 && this.replaceAt(u, h), this;
    }, r3.prototype.replaceAt = function(e3, u) {
      var h = this._children, v4 = h[u];
      if (e3 && e3 !== this && e3.parent !== this && e3 !== v4) {
        h[u] = e3, v4.parent = null;
        var m3 = this.__zr;
        m3 && v4.removeSelfFromZr(m3), this._doAdd(e3);
      }
      return this;
    }, r3.prototype._doAdd = function(e3) {
      e3.parent && e3.parent.remove(e3), e3.parent = this;
      var u = this.__zr;
      u && u !== e3.__zr && e3.addSelfToZr(u), u && u.refresh();
    }, r3.prototype.remove = function(e3) {
      var u = this.__zr, h = this._children, v4 = Cl(h, e3);
      return v4 < 0 ? this : (h.splice(v4, 1), e3.parent = null, u && e3.removeSelfFromZr(u), u && u.refresh(), this);
    }, r3.prototype.removeAll = function() {
      for (var e3 = this._children, u = this.__zr, h = 0; h < e3.length; h++) {
        var v4 = e3[h];
        u && v4.removeSelfFromZr(u), v4.parent = null;
      }
      return e3.length = 0, this;
    }, r3.prototype.eachChild = function(e3, u) {
      for (var h = this._children, v4 = 0; v4 < h.length; v4++) {
        var m3 = h[v4];
        e3.call(u, m3, v4);
      }
      return this;
    }, r3.prototype.traverse = function(e3, u) {
      for (var h = 0; h < this._children.length; h++) {
        var v4 = this._children[h], m3 = e3.call(u, v4);
        v4.isGroup && !m3 && v4.traverse(e3, u);
      }
      return this;
    }, r3.prototype.addSelfToZr = function(e3) {
      l3.prototype.addSelfToZr.call(this, e3);
      for (var u = 0; u < this._children.length; u++) {
        var h = this._children[u];
        h.addSelfToZr(e3);
      }
    }, r3.prototype.removeSelfFromZr = function(e3) {
      l3.prototype.removeSelfFromZr.call(this, e3);
      for (var u = 0; u < this._children.length; u++) {
        var h = this._children[u];
        h.removeSelfFromZr(e3);
      }
    }, r3.prototype.getBoundingRect = function(e3) {
      for (var u = new Ml(0, 0, 0, 0), h = e3 || this._children, v4 = [], m3 = null, x3 = 0; x3 < h.length; x3++) {
        var C = h[x3];
        if (!(C.ignore || C.invisible)) {
          var A2 = C.getBoundingRect(), D = C.getLocalTransform(v4);
          D ? (Ml.applyTransform(u, A2, D), m3 = m3 || u.clone(), m3.union(u)) : (m3 = m3 || A2.clone(), m3.union(A2));
        }
      }
      return m3 || u;
    }, r3;
  }(lut);
  uut.prototype.type = "group";
  var Cs = uut;
  /*!
  * ZRender, a high performance 2d drawing library.
  *
  * Copyright (c) 2013, Baidu Inc.
  * All rights reserved.
  *
  * LICENSE
  * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
  */
  var wfe = {}, cut = {};
  function Aln(l3) {
    delete cut[l3];
  }
  function Iln(l3) {
    if (!l3)
      return false;
    if (typeof l3 == "string")
      return jfe(l3, 1) < V5e;
    if (l3.colorStops) {
      for (var r3 = l3.colorStops, e3 = 0, u = r3.length, h = 0; h < u; h++)
        e3 += jfe(r3[h].color, 1);
      return e3 /= u, e3 < V5e;
    }
    return false;
  }
  var Eln = function() {
    function l3(r3, e3, u) {
      var h = this;
      this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, u = u || {}, this.dom = e3, this.id = r3;
      var v4 = new Lsn(), m3 = u.renderer || "canvas";
      wfe[m3] || (m3 = yu(wfe)[0]), u.useDirtyRect = u.useDirtyRect == null ? false : u.useDirtyRect;
      var x3 = new wfe[m3](e3, v4, u, r3), C = u.ssr || x3.ssrOnly;
      this.storage = v4, this.painter = x3;
      var A2 = !Fc.node && !Fc.worker && !C ? new vln(x3.getViewportRoot(), x3.root) : null;
      this.handler = new Esn(v4, x3, A2, x3.root), this.animation = new sln({ stage: { update: C ? null : function() {
        return h._flush(true);
      } } }), C || this.animation.start();
    }
    return l3.prototype.add = function(r3) {
      !r3 || (this.storage.addRoot(r3), r3.addSelfToZr(this), this.refresh());
    }, l3.prototype.remove = function(r3) {
      !r3 || (this.storage.delRoot(r3), r3.removeSelfFromZr(this), this.refresh());
    }, l3.prototype.configLayer = function(r3, e3) {
      this.painter.configLayer && this.painter.configLayer(r3, e3), this.refresh();
    }, l3.prototype.setBackgroundColor = function(r3) {
      this.painter.setBackgroundColor && this.painter.setBackgroundColor(r3), this.refresh(), this._backgroundColor = r3, this._darkMode = Iln(r3);
    }, l3.prototype.getBackgroundColor = function() {
      return this._backgroundColor;
    }, l3.prototype.setDarkMode = function(r3) {
      this._darkMode = r3;
    }, l3.prototype.isDarkMode = function() {
      return this._darkMode;
    }, l3.prototype.refreshImmediately = function(r3) {
      r3 || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
    }, l3.prototype.refresh = function() {
      this._needsRefresh = true, this.animation.start();
    }, l3.prototype.flush = function() {
      this._flush(false);
    }, l3.prototype._flush = function(r3) {
      var e3, u = Yz();
      this._needsRefresh && (e3 = true, this.refreshImmediately(r3)), this._needsRefreshHover && (e3 = true, this.refreshHoverImmediately());
      var h = Yz();
      e3 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: h - u })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
    }, l3.prototype.setSleepAfterStill = function(r3) {
      this._sleepAfterStill = r3;
    }, l3.prototype.wakeUp = function() {
      this.animation.start(), this._stillFrameAccum = 0;
    }, l3.prototype.refreshHover = function() {
      this._needsRefreshHover = true;
    }, l3.prototype.refreshHoverImmediately = function() {
      this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
    }, l3.prototype.resize = function(r3) {
      r3 = r3 || {}, this.painter.resize(r3.width, r3.height), this.handler.resize();
    }, l3.prototype.clearAnimation = function() {
      this.animation.clear();
    }, l3.prototype.getWidth = function() {
      return this.painter.getWidth();
    }, l3.prototype.getHeight = function() {
      return this.painter.getHeight();
    }, l3.prototype.setCursorStyle = function(r3) {
      this.handler.setCursorStyle(r3);
    }, l3.prototype.findHover = function(r3, e3) {
      return this.handler.findHover(r3, e3);
    }, l3.prototype.on = function(r3, e3, u) {
      return this.handler.on(r3, e3, u), this;
    }, l3.prototype.off = function(r3, e3) {
      this.handler.off(r3, e3);
    }, l3.prototype.trigger = function(r3, e3) {
      this.handler.trigger(r3, e3);
    }, l3.prototype.clear = function() {
      for (var r3 = this.storage.getRoots(), e3 = 0; e3 < r3.length; e3++)
        r3[e3] instanceof Cs && r3[e3].removeSelfFromZr(this);
      this.storage.delAllRoots(), this.painter.clear();
    }, l3.prototype.dispose = function() {
      this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, Aln(this.id);
    }, l3;
  }();
  function wtt(l3, r3) {
    var e3 = new Eln(Llt(), l3, r3);
    return cut[e3.id] = e3, e3;
  }
  function Dln(l3, r3) {
    wfe[l3] = r3;
  }
  var Stt = 1e-4, fut = 20;
  function kln(l3) {
    return l3.replace(/^\s+|\s+$/g, "");
  }
  function _f(l3, r3, e3, u) {
    var h = r3[0], v4 = r3[1], m3 = e3[0], x3 = e3[1], C = v4 - h, A2 = x3 - m3;
    if (C === 0)
      return A2 === 0 ? m3 : (m3 + x3) / 2;
    if (u)
      if (C > 0) {
        if (l3 <= h)
          return m3;
        if (l3 >= v4)
          return x3;
      } else {
        if (l3 >= h)
          return m3;
        if (l3 <= v4)
          return x3;
      }
    else {
      if (l3 === h)
        return m3;
      if (l3 === v4)
        return x3;
    }
    return (l3 - h) / C * A2 + m3;
  }
  function za(l3, r3) {
    switch (l3) {
      case "center":
      case "middle":
        l3 = "50%";
        break;
      case "left":
      case "top":
        l3 = "0%";
        break;
      case "right":
      case "bottom":
        l3 = "100%";
        break;
    }
    return qa(l3) ? kln(l3).match(/%$/) ? parseFloat(l3) / 100 * r3 : parseFloat(l3) : l3 == null ? NaN : +l3;
  }
  function jd(l3, r3, e3) {
    return r3 == null && (r3 = 10), r3 = Math.min(Math.max(0, r3), fut), l3 = (+l3).toFixed(r3), e3 ? l3 : +l3;
  }
  function g2(l3) {
    return l3.sort(function(r3, e3) {
      return r3 - e3;
    }), l3;
  }
  function NA(l3) {
    if (l3 = +l3, isNaN(l3))
      return 0;
    if (l3 > 1e-14) {
      for (var r3 = 1, e3 = 0; e3 < 15; e3++, r3 *= 10)
        if (Math.round(l3 * r3) / r3 === l3)
          return e3;
    }
    return Oln(l3);
  }
  function Oln(l3) {
    var r3 = l3.toString().toLowerCase(), e3 = r3.indexOf("e"), u = e3 > 0 ? +r3.slice(e3 + 1) : 0, h = e3 > 0 ? e3 : r3.length, v4 = r3.indexOf("."), m3 = v4 < 0 ? 0 : h - 1 - v4;
    return Math.max(0, m3 - u);
  }
  function hut(l3, r3) {
    var e3 = Math.log, u = Math.LN10, h = Math.floor(e3(l3[1] - l3[0]) / u), v4 = Math.round(e3(Math.abs(r3[1] - r3[0])) / u), m3 = Math.min(Math.max(-h + v4, 0), 20);
    return isFinite(m3) ? m3 : 20;
  }
  function Pln(l3, r3, e3) {
    if (!l3[r3])
      return 0;
    var u = WA(l3, function(W, K) {
      return W + (isNaN(K) ? 0 : K);
    }, 0);
    if (u === 0)
      return 0;
    for (var h = Math.pow(10, e3), v4 = Bi(l3, function(W) {
      return (isNaN(W) ? 0 : W) / u * h * 100;
    }), m3 = h * 100, x3 = Bi(v4, function(W) {
      return Math.floor(W);
    }), C = WA(x3, function(W, K) {
      return W + K;
    }, 0), A2 = Bi(v4, function(W, K) {
      return W - x3[K];
    }); C < m3; ) {
      for (var D = Number.NEGATIVE_INFINITY, P = null, N = 0, j = A2.length; N < j; ++N)
        A2[N] > D && (D = A2[N], P = N);
      ++x3[P], A2[P] = 0, ++C;
    }
    return x3[r3] / h;
  }
  function Lln(l3, r3) {
    var e3 = Math.max(NA(l3), NA(r3)), u = l3 + r3;
    return e3 > fut ? u : jd(u, e3);
  }
  var Ctt = 9007199254740991;
  function put(l3) {
    var r3 = Math.PI * 2;
    return (l3 % r3 + r3) % r3;
  }
  function Ufe(l3) {
    return l3 > -Stt && l3 < Stt;
  }
  var Rln = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
  function $A(l3) {
    if (l3 instanceof Date)
      return l3;
    if (qa(l3)) {
      var r3 = Rln.exec(l3);
      if (!r3)
        return new Date(NaN);
      if (r3[8]) {
        var e3 = +r3[4] || 0;
        return r3[8].toUpperCase() !== "Z" && (e3 -= +r3[8].slice(0, 3)), new Date(Date.UTC(+r3[1], +(r3[2] || 1) - 1, +r3[3] || 1, e3, +(r3[5] || 0), +r3[6] || 0, r3[7] ? +r3[7].substring(0, 3) : 0));
      } else
        return new Date(+r3[1], +(r3[2] || 1) - 1, +r3[3] || 1, +r3[4] || 0, +(r3[5] || 0), +r3[6] || 0, r3[7] ? +r3[7].substring(0, 3) : 0);
    } else if (l3 == null)
      return new Date(NaN);
    return new Date(Math.round(l3));
  }
  function Nln(l3) {
    return Math.pow(10, R3e(l3));
  }
  function R3e(l3) {
    if (l3 === 0)
      return 0;
    var r3 = Math.floor(Math.log(l3) / Math.LN10);
    return l3 / Math.pow(10, r3) >= 10 && r3++, r3;
  }
  function dut(l3, r3) {
    var e3 = R3e(l3), u = Math.pow(10, e3), h = l3 / u, v4;
    return r3 ? h < 1.5 ? v4 = 1 : h < 2.5 ? v4 = 2 : h < 4 ? v4 = 3 : h < 7 ? v4 = 5 : v4 = 10 : h < 1 ? v4 = 1 : h < 2 ? v4 = 2 : h < 3 ? v4 = 3 : h < 5 ? v4 = 5 : v4 = 10, l3 = v4 * u, e3 >= -20 ? +l3.toFixed(e3 < 0 ? -e3 : 0) : l3;
  }
  function aEe(l3, r3) {
    var e3 = (l3.length - 1) * r3 + 1, u = Math.floor(e3), h = +l3[u - 1], v4 = e3 - u;
    return v4 ? h + v4 * (l3[u] - h) : h;
  }
  function Mtt(l3) {
    l3.sort(function(C, A2) {
      return x3(C, A2, 0) ? -1 : 1;
    });
    for (var r3 = -1 / 0, e3 = 1, u = 0; u < l3.length; ) {
      for (var h = l3[u].interval, v4 = l3[u].close, m3 = 0; m3 < 2; m3++)
        h[m3] <= r3 && (h[m3] = r3, v4[m3] = m3 ? 1 : 1 - e3), r3 = h[m3], e3 = v4[m3];
      h[0] === h[1] && v4[0] * v4[1] !== 1 ? l3.splice(u, 1) : u++;
    }
    return l3;
    function x3(C, A2, D) {
      return C.interval[D] < A2.interval[D] || C.interval[D] === A2.interval[D] && (C.close[D] - A2.close[D] === (D ? -1 : 1) || !D && x3(C, A2, 1));
    }
  }
  function c5(l3) {
    var r3 = parseFloat(l3);
    return r3 == l3 && (r3 !== 0 || !qa(l3) || l3.indexOf("x") <= 0) ? r3 : NaN;
  }
  function vut(l3) {
    return !isNaN(c5(l3));
  }
  function gut() {
    return Math.round(Math.random() * 9);
  }
  function yut(l3, r3) {
    return r3 === 0 ? l3 : yut(r3, l3 % r3);
  }
  function Ttt(l3, r3) {
    return l3 == null ? r3 : r3 == null ? l3 : l3 * r3 / yut(l3, r3);
  }
  function Xc(l3) {
    throw new Error(l3);
  }
  function Att(l3, r3, e3) {
    return (r3 - l3) * e3 + l3;
  }
  var mut = "series\0", but = "\0_ec_\0";
  function Gf(l3) {
    return l3 instanceof Array ? l3 : l3 == null ? [] : [l3];
  }
  function HN(l3, r3, e3) {
    if (l3) {
      l3[r3] = l3[r3] || {}, l3.emphasis = l3.emphasis || {}, l3.emphasis[r3] = l3.emphasis[r3] || {};
      for (var u = 0, h = e3.length; u < h; u++) {
        var v4 = e3[u];
        !l3.emphasis[r3].hasOwnProperty(v4) && l3[r3].hasOwnProperty(v4) && (l3.emphasis[r3][v4] = l3[r3][v4]);
      }
    }
  }
  var Itt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
  function xj(l3) {
    return ls(l3) && !Ni(l3) && !(l3 instanceof Date) ? l3.value : l3;
  }
  function Fln(l3) {
    return ls(l3) && !(l3 instanceof Array);
  }
  function _ut(l3, r3, e3) {
    var u = e3 === "normalMerge", h = e3 === "replaceMerge", v4 = e3 === "replaceAll";
    l3 = l3 || [], r3 = (r3 || []).slice();
    var m3 = Ho();
    mt(r3, function(C, A2) {
      if (!ls(C)) {
        r3[A2] = null;
        return;
      }
    });
    var x3 = Vln(l3, m3, e3);
    return (u || h) && Bln(x3, l3, m3, r3), u && zln(x3, r3), u || h ? jln(x3, r3, h) : v4 && Gln(x3, r3), Hln(x3), x3;
  }
  function Vln(l3, r3, e3) {
    var u = [];
    if (e3 === "replaceAll")
      return u;
    for (var h = 0; h < l3.length; h++) {
      var v4 = l3[h];
      v4 && v4.id != null && r3.set(v4.id, h), u.push({ existing: e3 === "replaceMerge" || tJ(v4) ? null : v4, newOption: null, keyInfo: null, brandNew: null });
    }
    return u;
  }
  function Bln(l3, r3, e3, u) {
    mt(u, function(h, v4) {
      if (!(!h || h.id == null)) {
        var m3 = RZ(h.id), x3 = e3.get(m3);
        if (x3 != null) {
          var C = l3[x3];
          mb(!C.newOption, 'Duplicated option on id "' + m3 + '".'), C.newOption = h, C.existing = r3[x3], u[v4] = null;
        }
      }
    });
  }
  function zln(l3, r3) {
    mt(r3, function(e3, u) {
      if (!(!e3 || e3.name == null))
        for (var h = 0; h < l3.length; h++) {
          var v4 = l3[h].existing;
          if (!l3[h].newOption && v4 && (v4.id == null || e3.id == null) && !tJ(e3) && !tJ(v4) && xut("name", v4, e3)) {
            l3[h].newOption = e3, r3[u] = null;
            return;
          }
        }
    });
  }
  function jln(l3, r3, e3) {
    mt(r3, function(u) {
      if (!!u) {
        for (var h, v4 = 0; (h = l3[v4]) && (h.newOption || tJ(h.existing) || h.existing && u.id != null && !xut("id", u, h.existing)); )
          v4++;
        h ? (h.newOption = u, h.brandNew = e3) : l3.push({ newOption: u, brandNew: e3, existing: null, keyInfo: null }), v4++;
      }
    });
  }
  function Gln(l3, r3) {
    mt(r3, function(e3) {
      l3.push({ newOption: e3, brandNew: true, existing: null, keyInfo: null });
    });
  }
  function Hln(l3) {
    var r3 = Ho();
    mt(l3, function(e3) {
      var u = e3.existing;
      u && r3.set(u.id, e3);
    }), mt(l3, function(e3) {
      var u = e3.newOption;
      mb(!u || u.id == null || !r3.get(u.id) || r3.get(u.id) === e3, "id duplicates: " + (u && u.id)), u && u.id != null && r3.set(u.id, e3), !e3.keyInfo && (e3.keyInfo = {});
    }), mt(l3, function(e3, u) {
      var h = e3.existing, v4 = e3.newOption, m3 = e3.keyInfo;
      if (!!ls(v4)) {
        if (m3.name = v4.name != null ? RZ(v4.name) : h ? h.name : mut + u, h)
          m3.id = RZ(h.id);
        else if (v4.id != null)
          m3.id = RZ(v4.id);
        else {
          var x3 = 0;
          do
            m3.id = "\0" + m3.name + "\0" + x3++;
          while (r3.get(m3.id));
        }
        r3.set(m3.id, e3);
      }
    });
  }
  function xut(l3, r3, e3) {
    var u = pg(r3[l3], null), h = pg(e3[l3], null);
    return u != null && h != null && u === h;
  }
  function RZ(l3) {
    return pg(l3, "");
  }
  function pg(l3, r3) {
    return l3 == null ? r3 : qa(l3) ? l3 : Vc(l3) || m5e(l3) ? l3 + "" : r3;
  }
  function N3e(l3) {
    var r3 = l3.name;
    return !!(r3 && r3.indexOf(mut));
  }
  function tJ(l3) {
    return l3 && l3.id != null && RZ(l3.id).indexOf(but) === 0;
  }
  function Wln(l3) {
    return but + l3;
  }
  function Uln(l3, r3, e3) {
    mt(l3, function(u) {
      var h = u.newOption;
      ls(h) && (u.keyInfo.mainType = r3, u.keyInfo.subType = qln(r3, h, u.existing, e3));
    });
  }
  function qln(l3, r3, e3, u) {
    var h = r3.type ? r3.type : e3 ? e3.subType : u.determineSubType(l3, r3);
    return h;
  }
  function $ln(l3, r3) {
    var e3 = {}, u = {};
    return h(l3 || [], e3), h(r3 || [], u, e3), [v4(e3), v4(u)];
    function h(m3, x3, C) {
      for (var A2 = 0, D = m3.length; A2 < D; A2++) {
        var P = pg(m3[A2].seriesId, null);
        if (P == null)
          return;
        for (var N = Gf(m3[A2].dataIndex), j = C && C[P], W = 0, K = N.length; W < K; W++) {
          var te = N[W];
          j && j[te] ? j[te] = null : (x3[P] || (x3[P] = {}))[te] = 1;
        }
      }
    }
    function v4(m3, x3) {
      var C = [];
      for (var A2 in m3)
        if (m3.hasOwnProperty(A2) && m3[A2] != null)
          if (x3)
            C.push(+A2);
          else {
            var D = v4(m3[A2], true);
            D.length && C.push({ seriesId: A2, dataIndex: D });
          }
      return C;
    }
  }
  function WN(l3, r3) {
    if (r3.dataIndexInside != null)
      return r3.dataIndexInside;
    if (r3.dataIndex != null)
      return Ni(r3.dataIndex) ? Bi(r3.dataIndex, function(e3) {
        return l3.indexOfRawIndex(e3);
      }) : l3.indexOfRawIndex(r3.dataIndex);
    if (r3.name != null)
      return Ni(r3.name) ? Bi(r3.name, function(e3) {
        return l3.indexOfName(e3);
      }) : l3.indexOfName(r3.name);
  }
  function pc() {
    var l3 = "__ec_inner_" + Xln++;
    return function(r3) {
      return r3[l3] || (r3[l3] = {});
    };
  }
  var Xln = gut();
  function NZ(l3, r3, e3) {
    var u = F3e(r3, e3), h = u.mainTypeSpecified, v4 = u.queryOptionMap, m3 = u.others, x3 = m3, C = e3 ? e3.defaultMainType : null;
    return !h && C && v4.set(C, {}), v4.each(function(A2, D) {
      var P = kJ(l3, D, A2, { useDefault: C === D, enableAll: e3 && e3.enableAll != null ? e3.enableAll : true, enableNone: e3 && e3.enableNone != null ? e3.enableNone : true });
      x3[D + "Models"] = P.models, x3[D + "Model"] = P.models[0];
    }), x3;
  }
  function F3e(l3, r3) {
    var e3;
    if (qa(l3)) {
      var u = {};
      u[l3 + "Index"] = 0, e3 = u;
    } else
      e3 = l3;
    var h = Ho(), v4 = {}, m3 = false;
    return mt(e3, function(x3, C) {
      if (C === "dataIndex" || C === "dataIndexInside") {
        v4[C] = x3;
        return;
      }
      var A2 = C.match(/^(\w+)(Index|Id|Name)$/) || [], D = A2[1], P = (A2[2] || "").toLowerCase();
      if (!(!D || !P || r3 && r3.includeMainTypes && Cl(r3.includeMainTypes, D) < 0)) {
        m3 = m3 || !!D;
        var N = h.get(D) || h.set(D, {});
        N[P] = x3;
      }
    }), { mainTypeSpecified: m3, queryOptionMap: h, others: v4 };
  }
  var Lv = { useDefault: true, enableAll: false, enableNone: false }, Yln = { useDefault: false, enableAll: true, enableNone: true };
  function kJ(l3, r3, e3, u) {
    u = u || Lv;
    var h = e3.index, v4 = e3.id, m3 = e3.name, x3 = { models: null, specified: h != null || v4 != null || m3 != null };
    if (!x3.specified) {
      var C = void 0;
      return x3.models = u.useDefault && (C = l3.getComponent(r3)) ? [C] : [], x3;
    }
    return h === "none" || h === false ? (mb(u.enableNone, '`"none"` or `false` is not a valid value on index option.'), x3.models = [], x3) : (h === "all" && (mb(u.enableAll, '`"all"` is not a valid value on index option.'), h = v4 = m3 = null), x3.models = l3.queryComponents({ mainType: r3, index: h, id: v4, name: m3 }), x3);
  }
  function wut(l3, r3, e3) {
    l3.setAttribute ? l3.setAttribute(r3, e3) : l3[r3] = e3;
  }
  function Kln(l3, r3) {
    return l3.getAttribute ? l3.getAttribute(r3) : l3[r3];
  }
  function Zln(l3) {
    return l3 === "auto" ? Fc.domSupported ? "html" : "richText" : l3 || "html";
  }
  function j5e(l3, r3) {
    var e3 = Ho(), u = [];
    return mt(l3, function(h) {
      var v4 = r3(h);
      (e3.get(v4) || (u.push(v4), e3.set(v4, []))).push(h);
    }), { keys: u, buckets: e3 };
  }
  function Sut(l3, r3, e3, u, h) {
    var v4 = r3 == null || r3 === "auto";
    if (u == null)
      return u;
    if (Vc(u)) {
      var m3 = Att(e3 || 0, u, h);
      return jd(m3, v4 ? Math.max(NA(e3 || 0), NA(u)) : r3);
    } else {
      if (qa(u))
        return h < 1 ? e3 : u;
      for (var x3 = [], C = e3, A2 = u, D = Math.max(C ? C.length : 0, A2.length), P = 0; P < D; ++P) {
        var N = l3.getDimensionInfo(P);
        if (N && N.type === "ordinal")
          x3[P] = (h < 1 && C ? C : A2)[P];
        else {
          var j = C && C[P] ? C[P] : 0, W = A2[P], m3 = Att(j, W, h);
          x3[P] = jd(m3, v4 ? Math.max(NA(j), NA(W)) : r3);
        }
      }
      return x3;
    }
  }
  var Jln = ".", K6 = "___EC__COMPONENT__CONTAINER___", Cut = "___EC__EXTENDED_CLASS___";
  function FA(l3) {
    var r3 = { main: "", sub: "" };
    if (l3) {
      var e3 = l3.split(Jln);
      r3.main = e3[0] || "", r3.sub = e3[1] || "";
    }
    return r3;
  }
  function Qln(l3) {
    mb(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(l3), 'componentType "' + l3 + '" illegal');
  }
  function eun(l3) {
    return !!(l3 && l3[Cut]);
  }
  function V3e(l3, r3) {
    l3.$constructor = l3, l3.extend = function(e3) {
      var u = this, h;
      return tun(u) ? h = function(v4) {
        ar(m3, v4);
        function m3() {
          return v4.apply(this, arguments) || this;
        }
        return m3;
      }(u) : (h = function() {
        (e3.$constructor || u).apply(this, arguments);
      }, nsn(h, this)), fi(h.prototype, e3), h[Cut] = true, h.extend = this.extend, h.superCall = iun, h.superApply = aun, h.superClass = u, h;
    };
  }
  function tun(l3) {
    return Xo(l3) && /^class\s/.test(Function.prototype.toString.call(l3));
  }
  function Mut(l3, r3) {
    l3.extend = r3.extend;
  }
  var nun = Math.round(Math.random() * 10);
  function run(l3) {
    var r3 = ["__\0is_clz", nun++].join("_");
    l3.prototype[r3] = true, l3.isInstance = function(e3) {
      return !!(e3 && e3[r3]);
    };
  }
  function iun(l3, r3) {
    for (var e3 = [], u = 2; u < arguments.length; u++)
      e3[u - 2] = arguments[u];
    return this.superClass.prototype[r3].apply(l3, e3);
  }
  function aun(l3, r3, e3) {
    return this.superClass.prototype[r3].apply(l3, e3);
  }
  function Hhe(l3) {
    var r3 = {};
    l3.registerClass = function(u) {
      var h = u.type || u.prototype.type;
      if (h) {
        Qln(h), u.prototype.type = h;
        var v4 = FA(h);
        if (!v4.sub)
          r3[v4.main] = u;
        else if (v4.sub !== K6) {
          var m3 = e3(v4);
          m3[v4.sub] = u;
        }
      }
      return u;
    }, l3.getClass = function(u, h, v4) {
      var m3 = r3[u];
      if (m3 && m3[K6] && (m3 = h ? m3[h] : null), v4 && !m3)
        throw new Error(h ? "Component " + u + "." + (h || "") + " is used but not imported." : u + ".type should be specified.");
      return m3;
    }, l3.getClassesByMainType = function(u) {
      var h = FA(u), v4 = [], m3 = r3[h.main];
      return m3 && m3[K6] ? mt(m3, function(x3, C) {
        C !== K6 && v4.push(x3);
      }) : v4.push(m3), v4;
    }, l3.hasClass = function(u) {
      var h = FA(u);
      return !!r3[h.main];
    }, l3.getAllClassMainTypes = function() {
      var u = [];
      return mt(r3, function(h, v4) {
        u.push(v4);
      }), u;
    }, l3.hasSubTypes = function(u) {
      var h = FA(u), v4 = r3[h.main];
      return v4 && v4[K6];
    };
    function e3(u) {
      var h = r3[u.main];
      return (!h || !h[K6]) && (h = r3[u.main] = {}, h[K6] = true), h;
    }
  }
  function UN(l3, r3) {
    for (var e3 = 0; e3 < l3.length; e3++)
      l3[e3][1] || (l3[e3][1] = l3[e3][0]);
    return r3 = r3 || false, function(u, h, v4) {
      for (var m3 = {}, x3 = 0; x3 < l3.length; x3++) {
        var C = l3[x3][1];
        if (!(h && Cl(h, C) >= 0 || v4 && Cl(v4, C) < 0)) {
          var A2 = u.getShallow(C, r3);
          A2 != null && (m3[l3[x3][0]] = A2);
        }
      }
      return m3;
    };
  }
  var oun = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], sun = UN(oun), lun = function() {
    function l3() {
    }
    return l3.prototype.getAreaStyle = function(r3, e3) {
      return sun(this, r3, e3);
    }, l3;
  }(), G5e = new EJ(50);
  function uun(l3) {
    if (typeof l3 == "string") {
      var r3 = G5e.get(l3);
      return r3 && r3.image;
    } else
      return l3;
  }
  function B3e(l3, r3, e3, u, h) {
    if (l3)
      if (typeof l3 == "string") {
        if (r3 && r3.__zrImageSrc === l3 || !e3)
          return r3;
        var v4 = G5e.get(l3), m3 = { hostEl: e3, cb: u, cbPayload: h };
        if (v4)
          r3 = v4.image, !Whe(r3) && v4.pending.push(m3);
        else {
          var x3 = l5.loadImage(l3, Ett, Ett);
          x3.__zrImageSrc = l3, G5e.put(l3, x3.__cachedImgObj = { image: x3, pending: [m3] });
        }
        return r3;
      } else
        return l3;
    else
      return r3;
  }
  function Ett() {
    var l3 = this.__cachedImgObj;
    this.onload = this.onerror = this.__cachedImgObj = null;
    for (var r3 = 0; r3 < l3.pending.length; r3++) {
      var e3 = l3.pending[r3], u = e3.cb;
      u && u(this, e3.cbPayload), e3.hostEl.dirty();
    }
    l3.pending.length = 0;
  }
  function Whe(l3) {
    return l3 && l3.width && l3.height;
  }
  var oEe = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
  function cun(l3, r3, e3, u, h) {
    if (!r3)
      return "";
    var v4 = (l3 + "").split(`
`);
    h = Tut(r3, e3, u, h);
    for (var m3 = 0, x3 = v4.length; m3 < x3; m3++)
      v4[m3] = Aut(v4[m3], h);
    return v4.join(`
`);
  }
  function Tut(l3, r3, e3, u) {
    u = u || {};
    var h = fi({}, u);
    h.font = r3, e3 = dl(e3, "..."), h.maxIterations = dl(u.maxIterations, 2);
    var v4 = h.minChar = dl(u.minChar, 0);
    h.cnCharWidth = Qx("\u56FD", r3);
    var m3 = h.ascCharWidth = Qx("a", r3);
    h.placeholder = dl(u.placeholder, "");
    for (var x3 = l3 = Math.max(0, l3 - 1), C = 0; C < v4 && x3 >= m3; C++)
      x3 -= m3;
    var A2 = Qx(e3, r3);
    return A2 > x3 && (e3 = "", A2 = 0), x3 = l3 - A2, h.ellipsis = e3, h.ellipsisWidth = A2, h.contentWidth = x3, h.containerWidth = l3, h;
  }
  function Aut(l3, r3) {
    var e3 = r3.containerWidth, u = r3.font, h = r3.contentWidth;
    if (!e3)
      return "";
    var v4 = Qx(l3, u);
    if (v4 <= e3)
      return l3;
    for (var m3 = 0; ; m3++) {
      if (v4 <= h || m3 >= r3.maxIterations) {
        l3 += r3.ellipsis;
        break;
      }
      var x3 = m3 === 0 ? fun(l3, h, r3.ascCharWidth, r3.cnCharWidth) : v4 > 0 ? Math.floor(l3.length * h / v4) : 0;
      l3 = l3.substr(0, x3), v4 = Qx(l3, u);
    }
    return l3 === "" && (l3 = r3.placeholder), l3;
  }
  function fun(l3, r3, e3, u) {
    for (var h = 0, v4 = 0, m3 = l3.length; v4 < m3 && h < r3; v4++) {
      var x3 = l3.charCodeAt(v4);
      h += 0 <= x3 && x3 <= 127 ? e3 : u;
    }
    return v4;
  }
  function hun(l3, r3) {
    l3 != null && (l3 += "");
    var e3 = r3.overflow, u = r3.padding, h = r3.font, v4 = e3 === "truncate", m3 = Ghe(h), x3 = dl(r3.lineHeight, m3), C = !!r3.backgroundColor, A2 = r3.lineOverflow === "truncate", D = r3.width, P;
    D != null && (e3 === "break" || e3 === "breakAll") ? P = l3 ? Iut(l3, r3.font, D, e3 === "breakAll", 0).lines : [] : P = l3 ? l3.split(`
`) : [];
    var N = P.length * x3, j = dl(r3.height, N);
    if (N > j && A2) {
      var W = Math.floor(j / x3);
      P = P.slice(0, W);
    }
    if (l3 && v4 && D != null)
      for (var K = Tut(D, h, r3.ellipsis, { minChar: r3.truncateMinChar, placeholder: r3.placeholder }), te = 0; te < P.length; te++)
        P[te] = Aut(P[te], K);
    for (var ne = j, ce = 0, te = 0; te < P.length; te++)
      ce = Math.max(Qx(P[te], h), ce);
    D == null && (D = ce);
    var me = ce;
    return u && (ne += u[0] + u[2], me += u[1] + u[3], D += u[1] + u[3]), C && (me = D), { lines: P, height: j, outerWidth: me, outerHeight: ne, lineHeight: x3, calculatedLineHeight: m3, contentWidth: ce, contentHeight: N, width: D };
  }
  var pun = function() {
    function l3() {
    }
    return l3;
  }(), Dtt = function() {
    function l3(r3) {
      this.tokens = [], r3 && (this.tokens = r3);
    }
    return l3;
  }(), dun = function() {
    function l3() {
      this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
    }
    return l3;
  }();
  function vun(l3, r3) {
    var e3 = new dun();
    if (l3 != null && (l3 += ""), !l3)
      return e3;
    for (var u = r3.width, h = r3.height, v4 = r3.overflow, m3 = (v4 === "break" || v4 === "breakAll") && u != null ? { width: u, accumWidth: 0, breakAll: v4 === "breakAll" } : null, x3 = oEe.lastIndex = 0, C; (C = oEe.exec(l3)) != null; ) {
      var A2 = C.index;
      A2 > x3 && sEe(e3, l3.substring(x3, A2), r3, m3), sEe(e3, C[2], r3, m3, C[1]), x3 = oEe.lastIndex;
    }
    x3 < l3.length && sEe(e3, l3.substring(x3, l3.length), r3, m3);
    var D = [], P = 0, N = 0, j = r3.padding, W = v4 === "truncate", K = r3.lineOverflow === "truncate";
    function te(hn, xn, zn) {
      hn.width = xn, hn.lineHeight = zn, P += zn, N = Math.max(N, xn);
    }
    e:
      for (var ne = 0; ne < e3.lines.length; ne++) {
        for (var ce = e3.lines[ne], me = 0, ve = 0, Be = 0; Be < ce.tokens.length; Be++) {
          var Oe = ce.tokens[Be], We = Oe.styleName && r3.rich[Oe.styleName] || {}, Ue = Oe.textPadding = We.padding, qe = Ue ? Ue[1] + Ue[3] : 0, Ze = Oe.font = We.font || r3.font;
          Oe.contentHeight = Ghe(Ze);
          var ct = dl(We.height, Oe.contentHeight);
          if (Oe.innerHeight = ct, Ue && (ct += Ue[0] + Ue[2]), Oe.height = ct, Oe.lineHeight = t5(We.lineHeight, r3.lineHeight, ct), Oe.align = We && We.align || r3.align, Oe.verticalAlign = We && We.verticalAlign || "middle", K && h != null && P + Oe.lineHeight > h) {
            Be > 0 ? (ce.tokens = ce.tokens.slice(0, Be), te(ce, ve, me), e3.lines = e3.lines.slice(0, ne + 1)) : e3.lines = e3.lines.slice(0, ne);
            break e;
          }
          var _t = We.width, pt = _t == null || _t === "auto";
          if (typeof _t == "string" && _t.charAt(_t.length - 1) === "%")
            Oe.percentWidth = _t, D.push(Oe), Oe.contentWidth = Qx(Oe.text, Ze);
          else {
            if (pt) {
              var zt = We.backgroundColor, Zt = zt && zt.image;
              Zt && (Zt = uun(Zt), Whe(Zt) && (Oe.width = Math.max(Oe.width, Zt.width * ct / Zt.height)));
            }
            var Ft = W && u != null ? u - ve : null;
            Ft != null && Ft < Oe.width ? !pt || Ft < qe ? (Oe.text = "", Oe.width = Oe.contentWidth = 0) : (Oe.text = cun(Oe.text, Ft - qe, Ze, r3.ellipsis, { minChar: r3.truncateMinChar }), Oe.width = Oe.contentWidth = Qx(Oe.text, Ze)) : Oe.contentWidth = Qx(Oe.text, Ze);
          }
          Oe.width += qe, ve += Oe.width, We && (me = Math.max(me, Oe.lineHeight));
        }
        te(ce, ve, me);
      }
    e3.outerWidth = e3.width = dl(u, N), e3.outerHeight = e3.height = dl(h, P), e3.contentHeight = P, e3.contentWidth = N, j && (e3.outerWidth += j[1] + j[3], e3.outerHeight += j[0] + j[2]);
    for (var ne = 0; ne < D.length; ne++) {
      var Oe = D[ne], Kn = Oe.percentWidth;
      Oe.width = parseInt(Kn, 10) / 100 * e3.width;
    }
    return e3;
  }
  function sEe(l3, r3, e3, u, h) {
    var v4 = r3 === "", m3 = h && e3.rich[h] || {}, x3 = l3.lines, C = m3.font || e3.font, A2 = false, D, P;
    if (u) {
      var N = m3.padding, j = N ? N[1] + N[3] : 0;
      if (m3.width != null && m3.width !== "auto") {
        var W = gM(m3.width, u.width) + j;
        x3.length > 0 && W + u.accumWidth > u.width && (D = r3.split(`
`), A2 = true), u.accumWidth = W;
      } else {
        var K = Iut(r3, C, u.width, u.breakAll, u.accumWidth);
        u.accumWidth = K.accumWidth + j, P = K.linesWidths, D = K.lines;
      }
    } else
      D = r3.split(`
`);
    for (var te = 0; te < D.length; te++) {
      var ne = D[te], ce = new pun();
      if (ce.styleName = h, ce.text = ne, ce.isLineHolder = !ne && !v4, typeof m3.width == "number" ? ce.width = m3.width : ce.width = P ? P[te] : Qx(ne, C), !te && !A2) {
        var me = (x3[x3.length - 1] || (x3[0] = new Dtt())).tokens, ve = me.length;
        ve === 1 && me[0].isLineHolder ? me[0] = ce : (ne || !ve || v4) && me.push(ce);
      } else
        x3.push(new Dtt([ce]));
    }
  }
  function gun(l3) {
    var r3 = l3.charCodeAt(0);
    return r3 >= 33 && r3 <= 383;
  }
  var yun = WA(",&?/;] ".split(""), function(l3, r3) {
    return l3[r3] = true, l3;
  }, {});
  function mun(l3) {
    return gun(l3) ? !!yun[l3] : true;
  }
  function Iut(l3, r3, e3, u, h) {
    for (var v4 = [], m3 = [], x3 = "", C = "", A2 = 0, D = 0, P = 0; P < l3.length; P++) {
      var N = l3.charAt(P);
      if (N === `
`) {
        C && (x3 += C, D += A2), v4.push(x3), m3.push(D), x3 = "", C = "", A2 = 0, D = 0;
        continue;
      }
      var j = Qx(N, r3), W = u ? false : !mun(N);
      if (v4.length ? D + j > e3 : h + D + j > e3) {
        D ? (x3 || C) && (W ? (x3 || (x3 = C, C = "", A2 = 0, D = A2), v4.push(x3), m3.push(D - A2), C += N, A2 += j, x3 = "", D = A2) : (C && (x3 += C, C = "", A2 = 0), v4.push(x3), m3.push(D), x3 = N, D = j)) : W ? (v4.push(C), m3.push(A2), C = N, A2 = j) : (v4.push(N), m3.push(j));
        continue;
      }
      D += j, W ? (C += N, A2 += j) : (C && (x3 += C, C = "", A2 = 0), x3 += N);
    }
    return !v4.length && !x3 && (x3 = l3, C = "", A2 = 0), C && (x3 += C), x3 && (v4.push(x3), m3.push(D)), v4.length === 1 && (D += h), { accumWidth: D, lines: v4, linesWidths: m3 };
  }
  var H5e = "__zr_style_" + Math.round(Math.random() * 10), RN = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, Uhe = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
  RN[H5e] = true;
  var ktt = ["z", "z2", "invisible"], bun = ["invisible"], _un = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype._init = function(e3) {
      for (var u = yu(e3), h = 0; h < u.length; h++) {
        var v4 = u[h];
        v4 === "style" ? this.useStyle(e3[v4]) : l3.prototype.attrKV.call(this, v4, e3[v4]);
      }
      this.style || this.useStyle({});
    }, r3.prototype.beforeBrush = function() {
    }, r3.prototype.afterBrush = function() {
    }, r3.prototype.innerBeforeBrush = function() {
    }, r3.prototype.innerAfterBrush = function() {
    }, r3.prototype.shouldBePainted = function(e3, u, h, v4) {
      var m3 = this.transform;
      if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && xun(this, e3, u) || m3 && !m3[0] && !m3[3])
        return false;
      if (h && this.__clipPaths) {
        for (var x3 = 0; x3 < this.__clipPaths.length; ++x3)
          if (this.__clipPaths[x3].isZeroArea())
            return false;
      }
      if (v4 && this.parent)
        for (var C = this.parent; C; ) {
          if (C.ignore)
            return false;
          C = C.parent;
        }
      return true;
    }, r3.prototype.contain = function(e3, u) {
      return this.rectContain(e3, u);
    }, r3.prototype.traverse = function(e3, u) {
      e3.call(u, this);
    }, r3.prototype.rectContain = function(e3, u) {
      var h = this.transformCoordToLocal(e3, u), v4 = this.getBoundingRect();
      return v4.contain(h[0], h[1]);
    }, r3.prototype.getPaintRect = function() {
      var e3 = this._paintRect;
      if (!this._paintRect || this.__dirty) {
        var u = this.transform, h = this.getBoundingRect(), v4 = this.style, m3 = v4.shadowBlur || 0, x3 = v4.shadowOffsetX || 0, C = v4.shadowOffsetY || 0;
        e3 = this._paintRect || (this._paintRect = new Ml(0, 0, 0, 0)), u ? Ml.applyTransform(e3, h, u) : e3.copy(h), (m3 || x3 || C) && (e3.width += m3 * 2 + Math.abs(x3), e3.height += m3 * 2 + Math.abs(C), e3.x = Math.min(e3.x, e3.x + x3 - m3), e3.y = Math.min(e3.y, e3.y + C - m3));
        var A2 = this.dirtyRectTolerance;
        e3.isZero() || (e3.x = Math.floor(e3.x - A2), e3.y = Math.floor(e3.y - A2), e3.width = Math.ceil(e3.width + 1 + A2 * 2), e3.height = Math.ceil(e3.height + 1 + A2 * 2));
      }
      return e3;
    }, r3.prototype.setPrevPaintRect = function(e3) {
      e3 ? (this._prevPaintRect = this._prevPaintRect || new Ml(0, 0, 0, 0), this._prevPaintRect.copy(e3)) : this._prevPaintRect = null;
    }, r3.prototype.getPrevPaintRect = function() {
      return this._prevPaintRect;
    }, r3.prototype.animateStyle = function(e3) {
      return this.animate("style", e3);
    }, r3.prototype.updateDuringAnimation = function(e3) {
      e3 === "style" ? this.dirtyStyle() : this.markRedraw();
    }, r3.prototype.attrKV = function(e3, u) {
      e3 !== "style" ? l3.prototype.attrKV.call(this, e3, u) : this.style ? this.setStyle(u) : this.useStyle(u);
    }, r3.prototype.setStyle = function(e3, u) {
      return typeof e3 == "string" ? this.style[e3] = u : fi(this.style, e3), this.dirtyStyle(), this;
    }, r3.prototype.dirtyStyle = function(e3) {
      e3 || this.markRedraw(), this.__dirty |= bZ, this._rect && (this._rect = null);
    }, r3.prototype.dirty = function() {
      this.dirtyStyle();
    }, r3.prototype.styleChanged = function() {
      return !!(this.__dirty & bZ);
    }, r3.prototype.styleUpdated = function() {
      this.__dirty &= ~bZ;
    }, r3.prototype.createStyle = function(e3) {
      return Bhe(RN, e3);
    }, r3.prototype.useStyle = function(e3) {
      e3[H5e] || (e3 = this.createStyle(e3)), this.__inHover ? this.__hoverStyle = e3 : this.style = e3, this.dirtyStyle();
    }, r3.prototype.isStyleObject = function(e3) {
      return e3[H5e];
    }, r3.prototype._innerSaveToNormal = function(e3) {
      l3.prototype._innerSaveToNormal.call(this, e3);
      var u = this._normalState;
      e3.style && !u.style && (u.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(e3, u, ktt);
    }, r3.prototype._applyStateObj = function(e3, u, h, v4, m3, x3) {
      l3.prototype._applyStateObj.call(this, e3, u, h, v4, m3, x3);
      var C = !(u && v4), A2;
      if (u && u.style ? m3 ? v4 ? A2 = u.style : (A2 = this._mergeStyle(this.createStyle(), h.style), this._mergeStyle(A2, u.style)) : (A2 = this._mergeStyle(this.createStyle(), v4 ? this.style : h.style), this._mergeStyle(A2, u.style)) : C && (A2 = h.style), A2)
        if (m3) {
          var D = this.style;
          if (this.style = this.createStyle(C ? {} : D), C)
            for (var P = yu(D), N = 0; N < P.length; N++) {
              var j = P[N];
              j in A2 && (A2[j] = A2[j], this.style[j] = D[j]);
            }
          for (var W = yu(A2), N = 0; N < W.length; N++) {
            var j = W[N];
            this.style[j] = this.style[j];
          }
          this._transitionState(e3, { style: A2 }, x3, this.getAnimationStyleProps());
        } else
          this.useStyle(A2);
      for (var K = this.__inHover ? bun : ktt, N = 0; N < K.length; N++) {
        var j = K[N];
        u && u[j] != null ? this[j] = u[j] : C && h[j] != null && (this[j] = h[j]);
      }
    }, r3.prototype._mergeStates = function(e3) {
      for (var u = l3.prototype._mergeStates.call(this, e3), h, v4 = 0; v4 < e3.length; v4++) {
        var m3 = e3[v4];
        m3.style && (h = h || {}, this._mergeStyle(h, m3.style));
      }
      return h && (u.style = h), u;
    }, r3.prototype._mergeStyle = function(e3, u) {
      return fi(e3, u), e3;
    }, r3.prototype.getAnimationStyleProps = function() {
      return Uhe;
    }, r3.initDefaultProps = function() {
      var e3 = r3.prototype;
      e3.type = "displayable", e3.invisible = false, e3.z = 0, e3.z2 = 0, e3.zlevel = 0, e3.culling = false, e3.cursor = "pointer", e3.rectHover = false, e3.incremental = false, e3._rect = null, e3.dirtyRectTolerance = 0, e3.__dirty = Kx | bZ;
    }(), r3;
  }(lut), lEe = new Ml(0, 0, 0, 0), uEe = new Ml(0, 0, 0, 0);
  function xun(l3, r3, e3) {
    return lEe.copy(l3.getBoundingRect()), l3.transform && lEe.applyTransform(l3.transform), uEe.width = r3, uEe.height = e3, !lEe.intersect(uEe);
  }
  var x2 = _un, __ = Math.min, x_ = Math.max, cEe = Math.sin, fEe = Math.cos, Z6 = Math.PI * 2, gce = KN(), yce = KN(), mce = KN();
  function qhe(l3, r3, e3) {
    if (l3.length !== 0) {
      for (var u = l3[0], h = u[0], v4 = u[0], m3 = u[1], x3 = u[1], C = 1; C < l3.length; C++)
        u = l3[C], h = __(h, u[0]), v4 = x_(v4, u[0]), m3 = __(m3, u[1]), x3 = x_(x3, u[1]);
      r3[0] = h, r3[1] = m3, e3[0] = v4, e3[1] = x3;
    }
  }
  function Ott(l3, r3, e3, u, h, v4) {
    h[0] = __(l3, e3), h[1] = __(r3, u), v4[0] = x_(l3, e3), v4[1] = x_(r3, u);
  }
  var Ptt = [], Ltt = [];
  function wun(l3, r3, e3, u, h, v4, m3, x3, C, A2) {
    var D = qlt, P = i0, N = D(l3, e3, h, m3, Ptt);
    C[0] = 1 / 0, C[1] = 1 / 0, A2[0] = -1 / 0, A2[1] = -1 / 0;
    for (var j = 0; j < N; j++) {
      var W = P(l3, e3, h, m3, Ptt[j]);
      C[0] = __(W, C[0]), A2[0] = x_(W, A2[0]);
    }
    N = D(r3, u, v4, x3, Ltt);
    for (var j = 0; j < N; j++) {
      var K = P(r3, u, v4, x3, Ltt[j]);
      C[1] = __(K, C[1]), A2[1] = x_(K, A2[1]);
    }
    C[0] = __(l3, C[0]), A2[0] = x_(l3, A2[0]), C[0] = __(m3, C[0]), A2[0] = x_(m3, A2[0]), C[1] = __(r3, C[1]), A2[1] = x_(r3, A2[1]), C[1] = __(x3, C[1]), A2[1] = x_(x3, A2[1]);
  }
  function Sun(l3, r3, e3, u, h, v4, m3, x3) {
    var C = Xlt, A2 = Q0, D = x_(__(C(l3, e3, h), 1), 0), P = x_(__(C(r3, u, v4), 1), 0), N = A2(l3, e3, h, D), j = A2(r3, u, v4, P);
    m3[0] = __(l3, h, N), m3[1] = __(r3, v4, j), x3[0] = x_(l3, h, N), x3[1] = x_(r3, v4, j);
  }
  function Cun(l3, r3, e3, u, h, v4, m3, x3, C) {
    var A2 = NO, D = FO, P = Math.abs(h - v4);
    if (P % Z6 < 1e-4 && P > 1e-4) {
      x3[0] = l3 - e3, x3[1] = r3 - u, C[0] = l3 + e3, C[1] = r3 + u;
      return;
    }
    if (gce[0] = fEe(h) * e3 + l3, gce[1] = cEe(h) * u + r3, yce[0] = fEe(v4) * e3 + l3, yce[1] = cEe(v4) * u + r3, A2(x3, gce, yce), D(C, gce, yce), h = h % Z6, h < 0 && (h = h + Z6), v4 = v4 % Z6, v4 < 0 && (v4 = v4 + Z6), h > v4 && !m3 ? v4 += Z6 : h < v4 && m3 && (h += Z6), m3) {
      var N = v4;
      v4 = h, h = N;
    }
    for (var j = 0; j < v4; j += Math.PI / 2)
      j > h && (mce[0] = fEe(j) * e3 + l3, mce[1] = cEe(j) * u + r3, A2(x3, mce, x3), D(C, mce, C));
  }
  var ch = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, J6 = [], Q6 = [], TA = [], SO = [], AA = [], IA = [], hEe = Math.min, pEe = Math.max, eN = Math.cos, tN = Math.sin, $D = Math.abs, W5e = Math.PI, kO = W5e * 2, dEe = typeof Float32Array != "undefined", qK = [];
  function vEe(l3) {
    var r3 = Math.round(l3 / W5e * 1e8) / 1e8;
    return r3 % 2 * W5e;
  }
  function Mun(l3, r3) {
    var e3 = vEe(l3[0]);
    e3 < 0 && (e3 += kO);
    var u = e3 - l3[0], h = l3[1];
    h += u, !r3 && h - e3 >= kO ? h = e3 + kO : r3 && e3 - h >= kO ? h = e3 - kO : !r3 && e3 > h ? h = e3 + (kO - vEe(e3 - h)) : r3 && e3 < h && (h = e3 - (kO - vEe(h - e3))), l3[0] = e3, l3[1] = h;
  }
  var Tun = function() {
    function l3(r3) {
      this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, r3 && (this._saveData = false), this._saveData && (this.data = []);
    }
    return l3.prototype.increaseVersion = function() {
      this._version++;
    }, l3.prototype.getVersion = function() {
      return this._version;
    }, l3.prototype.setScale = function(r3, e3, u) {
      u = u || 0, u > 0 && (this._ux = $D(u / Hfe / r3) || 0, this._uy = $D(u / Hfe / e3) || 0);
    }, l3.prototype.setDPR = function(r3) {
      this.dpr = r3;
    }, l3.prototype.setContext = function(r3) {
      this._ctx = r3;
    }, l3.prototype.getContext = function() {
      return this._ctx;
    }, l3.prototype.beginPath = function() {
      return this._ctx && this._ctx.beginPath(), this.reset(), this;
    }, l3.prototype.reset = function() {
      this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
    }, l3.prototype.moveTo = function(r3, e3) {
      return this._drawPendingPt(), this.addData(ch.M, r3, e3), this._ctx && this._ctx.moveTo(r3, e3), this._x0 = r3, this._y0 = e3, this._xi = r3, this._yi = e3, this;
    }, l3.prototype.lineTo = function(r3, e3) {
      var u = $D(r3 - this._xi), h = $D(e3 - this._yi), v4 = u > this._ux || h > this._uy;
      if (this.addData(ch.L, r3, e3), this._ctx && v4 && this._ctx.lineTo(r3, e3), v4)
        this._xi = r3, this._yi = e3, this._pendingPtDist = 0;
      else {
        var m3 = u * u + h * h;
        m3 > this._pendingPtDist && (this._pendingPtX = r3, this._pendingPtY = e3, this._pendingPtDist = m3);
      }
      return this;
    }, l3.prototype.bezierCurveTo = function(r3, e3, u, h, v4, m3) {
      return this._drawPendingPt(), this.addData(ch.C, r3, e3, u, h, v4, m3), this._ctx && this._ctx.bezierCurveTo(r3, e3, u, h, v4, m3), this._xi = v4, this._yi = m3, this;
    }, l3.prototype.quadraticCurveTo = function(r3, e3, u, h) {
      return this._drawPendingPt(), this.addData(ch.Q, r3, e3, u, h), this._ctx && this._ctx.quadraticCurveTo(r3, e3, u, h), this._xi = u, this._yi = h, this;
    }, l3.prototype.arc = function(r3, e3, u, h, v4, m3) {
      this._drawPendingPt(), qK[0] = h, qK[1] = v4, Mun(qK, m3), h = qK[0], v4 = qK[1];
      var x3 = v4 - h;
      return this.addData(ch.A, r3, e3, u, u, h, x3, 0, m3 ? 0 : 1), this._ctx && this._ctx.arc(r3, e3, u, h, v4, m3), this._xi = eN(v4) * u + r3, this._yi = tN(v4) * u + e3, this;
    }, l3.prototype.arcTo = function(r3, e3, u, h, v4) {
      return this._drawPendingPt(), this._ctx && this._ctx.arcTo(r3, e3, u, h, v4), this;
    }, l3.prototype.rect = function(r3, e3, u, h) {
      return this._drawPendingPt(), this._ctx && this._ctx.rect(r3, e3, u, h), this.addData(ch.R, r3, e3, u, h), this;
    }, l3.prototype.closePath = function() {
      this._drawPendingPt(), this.addData(ch.Z);
      var r3 = this._ctx, e3 = this._x0, u = this._y0;
      return r3 && r3.closePath(), this._xi = e3, this._yi = u, this;
    }, l3.prototype.fill = function(r3) {
      r3 && r3.fill(), this.toStatic();
    }, l3.prototype.stroke = function(r3) {
      r3 && r3.stroke(), this.toStatic();
    }, l3.prototype.len = function() {
      return this._len;
    }, l3.prototype.setData = function(r3) {
      var e3 = r3.length;
      !(this.data && this.data.length === e3) && dEe && (this.data = new Float32Array(e3));
      for (var u = 0; u < e3; u++)
        this.data[u] = r3[u];
      this._len = e3;
    }, l3.prototype.appendPath = function(r3) {
      r3 instanceof Array || (r3 = [r3]);
      for (var e3 = r3.length, u = 0, h = this._len, v4 = 0; v4 < e3; v4++)
        u += r3[v4].len();
      dEe && this.data instanceof Float32Array && (this.data = new Float32Array(h + u));
      for (var v4 = 0; v4 < e3; v4++)
        for (var m3 = r3[v4].data, x3 = 0; x3 < m3.length; x3++)
          this.data[h++] = m3[x3];
      this._len = h;
    }, l3.prototype.addData = function(r3, e3, u, h, v4, m3, x3, C, A2) {
      if (!!this._saveData) {
        var D = this.data;
        this._len + arguments.length > D.length && (this._expandData(), D = this.data);
        for (var P = 0; P < arguments.length; P++)
          D[this._len++] = arguments[P];
      }
    }, l3.prototype._drawPendingPt = function() {
      this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
    }, l3.prototype._expandData = function() {
      if (!(this.data instanceof Array)) {
        for (var r3 = [], e3 = 0; e3 < this._len; e3++)
          r3[e3] = this.data[e3];
        this.data = r3;
      }
    }, l3.prototype.toStatic = function() {
      if (!!this._saveData) {
        this._drawPendingPt();
        var r3 = this.data;
        r3 instanceof Array && (r3.length = this._len, dEe && this._len > 11 && (this.data = new Float32Array(r3)));
      }
    }, l3.prototype.getBoundingRect = function() {
      TA[0] = TA[1] = AA[0] = AA[1] = Number.MAX_VALUE, SO[0] = SO[1] = IA[0] = IA[1] = -Number.MAX_VALUE;
      var r3 = this.data, e3 = 0, u = 0, h = 0, v4 = 0, m3;
      for (m3 = 0; m3 < this._len; ) {
        var x3 = r3[m3++], C = m3 === 1;
        switch (C && (e3 = r3[m3], u = r3[m3 + 1], h = e3, v4 = u), x3) {
          case ch.M:
            e3 = h = r3[m3++], u = v4 = r3[m3++], AA[0] = h, AA[1] = v4, IA[0] = h, IA[1] = v4;
            break;
          case ch.L:
            Ott(e3, u, r3[m3], r3[m3 + 1], AA, IA), e3 = r3[m3++], u = r3[m3++];
            break;
          case ch.C:
            wun(e3, u, r3[m3++], r3[m3++], r3[m3++], r3[m3++], r3[m3], r3[m3 + 1], AA, IA), e3 = r3[m3++], u = r3[m3++];
            break;
          case ch.Q:
            Sun(e3, u, r3[m3++], r3[m3++], r3[m3], r3[m3 + 1], AA, IA), e3 = r3[m3++], u = r3[m3++];
            break;
          case ch.A:
            var A2 = r3[m3++], D = r3[m3++], P = r3[m3++], N = r3[m3++], j = r3[m3++], W = r3[m3++] + j;
            m3 += 1;
            var K = !r3[m3++];
            C && (h = eN(j) * P + A2, v4 = tN(j) * N + D), Cun(A2, D, P, N, j, W, K, AA, IA), e3 = eN(W) * P + A2, u = tN(W) * N + D;
            break;
          case ch.R:
            h = e3 = r3[m3++], v4 = u = r3[m3++];
            var te = r3[m3++], ne = r3[m3++];
            Ott(h, v4, h + te, v4 + ne, AA, IA);
            break;
          case ch.Z:
            e3 = h, u = v4;
            break;
        }
        NO(TA, TA, AA), FO(SO, SO, IA);
      }
      return m3 === 0 && (TA[0] = TA[1] = SO[0] = SO[1] = 0), new Ml(TA[0], TA[1], SO[0] - TA[0], SO[1] - TA[1]);
    }, l3.prototype._calculateLength = function() {
      var r3 = this.data, e3 = this._len, u = this._ux, h = this._uy, v4 = 0, m3 = 0, x3 = 0, C = 0;
      this._pathSegLen || (this._pathSegLen = []);
      for (var A2 = this._pathSegLen, D = 0, P = 0, N = 0; N < e3; ) {
        var j = r3[N++], W = N === 1;
        W && (v4 = r3[N], m3 = r3[N + 1], x3 = v4, C = m3);
        var K = -1;
        switch (j) {
          case ch.M:
            v4 = x3 = r3[N++], m3 = C = r3[N++];
            break;
          case ch.L: {
            var te = r3[N++], ne = r3[N++], ce = te - v4, me = ne - m3;
            ($D(ce) > u || $D(me) > h || N === e3 - 1) && (K = Math.sqrt(ce * ce + me * me), v4 = te, m3 = ne);
            break;
          }
          case ch.C: {
            var ve = r3[N++], Be = r3[N++], te = r3[N++], ne = r3[N++], Oe = r3[N++], We = r3[N++];
            K = Rsn(v4, m3, ve, Be, te, ne, Oe, We, 10), v4 = Oe, m3 = We;
            break;
          }
          case ch.Q: {
            var ve = r3[N++], Be = r3[N++], te = r3[N++], ne = r3[N++];
            K = Fsn(v4, m3, ve, Be, te, ne, 10), v4 = te, m3 = ne;
            break;
          }
          case ch.A:
            var Ue = r3[N++], qe = r3[N++], Ze = r3[N++], ct = r3[N++], _t = r3[N++], pt = r3[N++], zt = pt + _t;
            N += 1, r3[N++], W && (x3 = eN(_t) * Ze + Ue, C = tN(_t) * ct + qe), K = pEe(Ze, ct) * hEe(kO, Math.abs(pt)), v4 = eN(zt) * Ze + Ue, m3 = tN(zt) * ct + qe;
            break;
          case ch.R: {
            x3 = v4 = r3[N++], C = m3 = r3[N++];
            var Zt = r3[N++], Ft = r3[N++];
            K = Zt * 2 + Ft * 2;
            break;
          }
          case ch.Z: {
            var ce = x3 - v4, me = C - m3;
            K = Math.sqrt(ce * ce + me * me), v4 = x3, m3 = C;
            break;
          }
        }
        K >= 0 && (A2[P++] = K, D += K);
      }
      return this._pathLen = D, D;
    }, l3.prototype.rebuildPath = function(r3, e3) {
      var u = this.data, h = this._ux, v4 = this._uy, m3 = this._len, x3, C, A2, D, P, N, j = e3 < 1, W, K, te = 0, ne = 0, ce, me = 0, ve, Be;
      if (j && (this._pathSegLen || this._calculateLength(), W = this._pathSegLen, K = this._pathLen, ce = e3 * K, !ce))
        return;
      e:
        for (var Oe = 0; Oe < m3; ) {
          var We = u[Oe++], Ue = Oe === 1;
          switch (Ue && (A2 = u[Oe], D = u[Oe + 1], x3 = A2, C = D), We !== ch.L && me > 0 && (r3.lineTo(ve, Be), me = 0), We) {
            case ch.M:
              x3 = A2 = u[Oe++], C = D = u[Oe++], r3.moveTo(A2, D);
              break;
            case ch.L: {
              P = u[Oe++], N = u[Oe++];
              var qe = $D(P - A2), Ze = $D(N - D);
              if (qe > h || Ze > v4) {
                if (j) {
                  var ct = W[ne++];
                  if (te + ct > ce) {
                    var _t = (ce - te) / ct;
                    r3.lineTo(A2 * (1 - _t) + P * _t, D * (1 - _t) + N * _t);
                    break e;
                  }
                  te += ct;
                }
                r3.lineTo(P, N), A2 = P, D = N, me = 0;
              } else {
                var pt = qe * qe + Ze * Ze;
                pt > me && (ve = P, Be = N, me = pt);
              }
              break;
            }
            case ch.C: {
              var zt = u[Oe++], Zt = u[Oe++], Ft = u[Oe++], Kn = u[Oe++], hn = u[Oe++], xn = u[Oe++];
              if (j) {
                var ct = W[ne++];
                if (te + ct > ce) {
                  var _t = (ce - te) / ct;
                  ZO(A2, zt, Ft, hn, _t, J6), ZO(D, Zt, Kn, xn, _t, Q6), r3.bezierCurveTo(J6[1], Q6[1], J6[2], Q6[2], J6[3], Q6[3]);
                  break e;
                }
                te += ct;
              }
              r3.bezierCurveTo(zt, Zt, Ft, Kn, hn, xn), A2 = hn, D = xn;
              break;
            }
            case ch.Q: {
              var zt = u[Oe++], Zt = u[Oe++], Ft = u[Oe++], Kn = u[Oe++];
              if (j) {
                var ct = W[ne++];
                if (te + ct > ce) {
                  var _t = (ce - te) / ct;
                  QZ(A2, zt, Ft, _t, J6), QZ(D, Zt, Kn, _t, Q6), r3.quadraticCurveTo(J6[1], Q6[1], J6[2], Q6[2]);
                  break e;
                }
                te += ct;
              }
              r3.quadraticCurveTo(zt, Zt, Ft, Kn), A2 = Ft, D = Kn;
              break;
            }
            case ch.A:
              var zn = u[Oe++], or = u[Oe++], vr = u[Oe++], la = u[Oe++], Ba = u[Oe++], Lo = u[Oe++], Ao = u[Oe++], oo = !u[Oe++], Pa = vr > la ? vr : la, fo = $D(vr - la) > 1e-3, Co = Ba + Lo, $a = false;
              if (j) {
                var ct = W[ne++];
                te + ct > ce && (Co = Ba + Lo * (ce - te) / ct, $a = true), te += ct;
              }
              if (fo && r3.ellipse ? r3.ellipse(zn, or, vr, la, Ao, Ba, Co, oo) : r3.arc(zn, or, Pa, Ba, Co, oo), $a)
                break e;
              Ue && (x3 = eN(Ba) * vr + zn, C = tN(Ba) * la + or), A2 = eN(Co) * vr + zn, D = tN(Co) * la + or;
              break;
            case ch.R:
              x3 = A2 = u[Oe], C = D = u[Oe + 1], P = u[Oe++], N = u[Oe++];
              var Yo = u[Oe++], Qu = u[Oe++];
              if (j) {
                var ct = W[ne++];
                if (te + ct > ce) {
                  var ds = ce - te;
                  r3.moveTo(P, N), r3.lineTo(P + hEe(ds, Yo), N), ds -= Yo, ds > 0 && r3.lineTo(P + Yo, N + hEe(ds, Qu)), ds -= Qu, ds > 0 && r3.lineTo(P + pEe(Yo - ds, 0), N + Qu), ds -= Yo, ds > 0 && r3.lineTo(P, N + pEe(Qu - ds, 0));
                  break e;
                }
                te += ct;
              }
              r3.rect(P, N, Yo, Qu);
              break;
            case ch.Z:
              if (j) {
                var ct = W[ne++];
                if (te + ct > ce) {
                  var _t = (ce - te) / ct;
                  r3.lineTo(A2 * (1 - _t) + x3 * _t, D * (1 - _t) + C * _t);
                  break e;
                }
                te += ct;
              }
              r3.closePath(), A2 = x3, D = C;
          }
        }
    }, l3.prototype.clone = function() {
      var r3 = new l3(), e3 = this.data;
      return r3.data = e3.slice ? e3.slice() : Array.prototype.slice.call(e3), r3._len = this._len, r3;
    }, l3.CMD = ch, l3.initDefaultProps = function() {
      var r3 = l3.prototype;
      r3._saveData = true, r3._ux = 0, r3._uy = 0, r3._pendingPtDist = 0, r3._version = 0;
    }(), l3;
  }(), XA = Tun;
  function PO(l3, r3, e3, u, h, v4, m3) {
    if (h === 0)
      return false;
    var x3 = h, C = 0, A2 = l3;
    if (m3 > r3 + x3 && m3 > u + x3 || m3 < r3 - x3 && m3 < u - x3 || v4 > l3 + x3 && v4 > e3 + x3 || v4 < l3 - x3 && v4 < e3 - x3)
      return false;
    if (l3 !== e3)
      C = (r3 - u) / (l3 - e3), A2 = (l3 * u - e3 * r3) / (l3 - e3);
    else
      return Math.abs(v4 - l3) <= x3 / 2;
    var D = C * v4 - m3 + A2, P = D * D / (C * C + 1);
    return P <= x3 / 2 * x3 / 2;
  }
  function Aun(l3, r3, e3, u, h, v4, m3, x3, C, A2, D) {
    if (C === 0)
      return false;
    var P = C;
    if (D > r3 + P && D > u + P && D > v4 + P && D > x3 + P || D < r3 - P && D < u - P && D < v4 - P && D < x3 - P || A2 > l3 + P && A2 > e3 + P && A2 > h + P && A2 > m3 + P || A2 < l3 - P && A2 < e3 - P && A2 < h - P && A2 < m3 - P)
      return false;
    var N = $lt(l3, r3, e3, u, h, v4, m3, x3, A2, D, null);
    return N <= P / 2;
  }
  function Eut(l3, r3, e3, u, h, v4, m3, x3, C) {
    if (m3 === 0)
      return false;
    var A2 = m3;
    if (C > r3 + A2 && C > u + A2 && C > v4 + A2 || C < r3 - A2 && C < u - A2 && C < v4 - A2 || x3 > l3 + A2 && x3 > e3 + A2 && x3 > h + A2 || x3 < l3 - A2 && x3 < e3 - A2 && x3 < h - A2)
      return false;
    var D = Ylt(l3, r3, e3, u, h, v4, x3, C, null);
    return D <= A2 / 2;
  }
  var Rtt = Math.PI * 2;
  function jO(l3) {
    return l3 %= Rtt, l3 < 0 && (l3 += Rtt), l3;
  }
  var $K = Math.PI * 2;
  function Iun(l3, r3, e3, u, h, v4, m3, x3, C) {
    if (m3 === 0)
      return false;
    var A2 = m3;
    x3 -= l3, C -= r3;
    var D = Math.sqrt(x3 * x3 + C * C);
    if (D - A2 > e3 || D + A2 < e3)
      return false;
    if (Math.abs(u - h) % $K < 1e-4)
      return true;
    if (v4) {
      var P = u;
      u = jO(h), h = jO(P);
    } else
      u = jO(u), h = jO(h);
    u > h && (h += $K);
    var N = Math.atan2(C, x3);
    return N < 0 && (N += $K), N >= u && N <= h || N + $K >= u && N + $K <= h;
  }
  function JD(l3, r3, e3, u, h, v4) {
    if (v4 > r3 && v4 > u || v4 < r3 && v4 < u || u === r3)
      return 0;
    var m3 = (v4 - r3) / (u - r3), x3 = u < r3 ? 1 : -1;
    (m3 === 1 || m3 === 0) && (x3 = u < r3 ? 0.5 : -0.5);
    var C = m3 * (e3 - l3) + l3;
    return C === h ? 1 / 0 : C > h ? x3 : 0;
  }
  var CO = XA.CMD, nN = Math.PI * 2, Eun = 1e-4;
  function Dun(l3, r3) {
    return Math.abs(l3 - r3) < Eun;
  }
  var vb = [-1, -1, -1], u2 = [-1, -1];
  function kun() {
    var l3 = u2[0];
    u2[0] = u2[1], u2[1] = l3;
  }
  function Oun(l3, r3, e3, u, h, v4, m3, x3, C, A2) {
    if (A2 > r3 && A2 > u && A2 > v4 && A2 > x3 || A2 < r3 && A2 < u && A2 < v4 && A2 < x3)
      return 0;
    var D = Bfe(r3, u, v4, x3, A2, vb);
    if (D === 0)
      return 0;
    for (var P = 0, N = -1, j = void 0, W = void 0, K = 0; K < D; K++) {
      var te = vb[K], ne = te === 0 || te === 1 ? 0.5 : 1, ce = i0(l3, e3, h, m3, te);
      ce < C || (N < 0 && (N = qlt(r3, u, v4, x3, u2), u2[1] < u2[0] && N > 1 && kun(), j = i0(r3, u, v4, x3, u2[0]), N > 1 && (W = i0(r3, u, v4, x3, u2[1]))), N === 2 ? te < u2[0] ? P += j < r3 ? ne : -ne : te < u2[1] ? P += W < j ? ne : -ne : P += x3 < W ? ne : -ne : te < u2[0] ? P += j < r3 ? ne : -ne : P += x3 < j ? ne : -ne);
    }
    return P;
  }
  function Pun(l3, r3, e3, u, h, v4, m3, x3) {
    if (x3 > r3 && x3 > u && x3 > v4 || x3 < r3 && x3 < u && x3 < v4)
      return 0;
    var C = Nsn(r3, u, v4, x3, vb);
    if (C === 0)
      return 0;
    var A2 = Xlt(r3, u, v4);
    if (A2 >= 0 && A2 <= 1) {
      for (var D = 0, P = Q0(r3, u, v4, A2), N = 0; N < C; N++) {
        var j = vb[N] === 0 || vb[N] === 1 ? 0.5 : 1, W = Q0(l3, e3, h, vb[N]);
        W < m3 || (vb[N] < A2 ? D += P < r3 ? j : -j : D += v4 < P ? j : -j);
      }
      return D;
    } else {
      var j = vb[0] === 0 || vb[0] === 1 ? 0.5 : 1, W = Q0(l3, e3, h, vb[0]);
      return W < m3 ? 0 : v4 < r3 ? j : -j;
    }
  }
  function Lun(l3, r3, e3, u, h, v4, m3, x3) {
    if (x3 -= r3, x3 > e3 || x3 < -e3)
      return 0;
    var C = Math.sqrt(e3 * e3 - x3 * x3);
    vb[0] = -C, vb[1] = C;
    var A2 = Math.abs(u - h);
    if (A2 < 1e-4)
      return 0;
    if (A2 >= nN - 1e-4) {
      u = 0, h = nN;
      var D = v4 ? 1 : -1;
      return m3 >= vb[0] + l3 && m3 <= vb[1] + l3 ? D : 0;
    }
    if (u > h) {
      var P = u;
      u = h, h = P;
    }
    u < 0 && (u += nN, h += nN);
    for (var N = 0, j = 0; j < 2; j++) {
      var W = vb[j];
      if (W + l3 > m3) {
        var K = Math.atan2(x3, W), D = v4 ? 1 : -1;
        K < 0 && (K = nN + K), (K >= u && K <= h || K + nN >= u && K + nN <= h) && (K > Math.PI / 2 && K < Math.PI * 1.5 && (D = -D), N += D);
      }
    }
    return N;
  }
  function Dut(l3, r3, e3, u, h) {
    for (var v4 = l3.data, m3 = l3.len(), x3 = 0, C = 0, A2 = 0, D = 0, P = 0, N, j, W = 0; W < m3; ) {
      var K = v4[W++], te = W === 1;
      switch (K === CO.M && W > 1 && (e3 || (x3 += JD(C, A2, D, P, u, h))), te && (C = v4[W], A2 = v4[W + 1], D = C, P = A2), K) {
        case CO.M:
          D = v4[W++], P = v4[W++], C = D, A2 = P;
          break;
        case CO.L:
          if (e3) {
            if (PO(C, A2, v4[W], v4[W + 1], r3, u, h))
              return true;
          } else
            x3 += JD(C, A2, v4[W], v4[W + 1], u, h) || 0;
          C = v4[W++], A2 = v4[W++];
          break;
        case CO.C:
          if (e3) {
            if (Aun(C, A2, v4[W++], v4[W++], v4[W++], v4[W++], v4[W], v4[W + 1], r3, u, h))
              return true;
          } else
            x3 += Oun(C, A2, v4[W++], v4[W++], v4[W++], v4[W++], v4[W], v4[W + 1], u, h) || 0;
          C = v4[W++], A2 = v4[W++];
          break;
        case CO.Q:
          if (e3) {
            if (Eut(C, A2, v4[W++], v4[W++], v4[W], v4[W + 1], r3, u, h))
              return true;
          } else
            x3 += Pun(C, A2, v4[W++], v4[W++], v4[W], v4[W + 1], u, h) || 0;
          C = v4[W++], A2 = v4[W++];
          break;
        case CO.A:
          var ne = v4[W++], ce = v4[W++], me = v4[W++], ve = v4[W++], Be = v4[W++], Oe = v4[W++];
          W += 1;
          var We = !!(1 - v4[W++]);
          N = Math.cos(Be) * me + ne, j = Math.sin(Be) * ve + ce, te ? (D = N, P = j) : x3 += JD(C, A2, N, j, u, h);
          var Ue = (u - ne) * ve / me + ne;
          if (e3) {
            if (Iun(ne, ce, ve, Be, Be + Oe, We, r3, Ue, h))
              return true;
          } else
            x3 += Lun(ne, ce, ve, Be, Be + Oe, We, Ue, h);
          C = Math.cos(Be + Oe) * me + ne, A2 = Math.sin(Be + Oe) * ve + ce;
          break;
        case CO.R:
          D = C = v4[W++], P = A2 = v4[W++];
          var qe = v4[W++], Ze = v4[W++];
          if (N = D + qe, j = P + Ze, e3) {
            if (PO(D, P, N, P, r3, u, h) || PO(N, P, N, j, r3, u, h) || PO(N, j, D, j, r3, u, h) || PO(D, j, D, P, r3, u, h))
              return true;
          } else
            x3 += JD(N, P, N, j, u, h), x3 += JD(D, j, D, P, u, h);
          break;
        case CO.Z:
          if (e3) {
            if (PO(C, A2, D, P, r3, u, h))
              return true;
          } else
            x3 += JD(C, A2, D, P, u, h);
          C = D, A2 = P;
          break;
      }
    }
    return !e3 && !Dun(A2, P) && (x3 += JD(C, A2, D, P, u, h) || 0), x3 !== 0;
  }
  function Run(l3, r3, e3) {
    return Dut(l3, 0, false, r3, e3);
  }
  function Nun(l3, r3, e3, u) {
    return Dut(l3, r3, true, e3, u);
  }
  var qfe = ns({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, RN), Fun = { style: ns({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, Uhe.style) }, gEe = qA.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), Vun = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.update = function() {
      var e3 = this;
      l3.prototype.update.call(this);
      var u = this.style;
      if (u.decal) {
        var h = this._decalEl = this._decalEl || new r3();
        h.buildPath === r3.prototype.buildPath && (h.buildPath = function(C) {
          e3.buildPath(C, e3.shape);
        }), h.silent = true;
        var v4 = h.style;
        for (var m3 in u)
          v4[m3] !== u[m3] && (v4[m3] = u[m3]);
        v4.fill = u.fill ? u.decal : null, v4.decal = null, v4.shadowColor = null, u.strokeFirst && (v4.stroke = null);
        for (var x3 = 0; x3 < gEe.length; ++x3)
          h[gEe[x3]] = this[gEe[x3]];
        h.__dirty |= Kx;
      } else
        this._decalEl && (this._decalEl = null);
    }, r3.prototype.getDecalElement = function() {
      return this._decalEl;
    }, r3.prototype._init = function(e3) {
      var u = yu(e3);
      this.shape = this.getDefaultShape();
      var h = this.getDefaultStyle();
      h && this.useStyle(h);
      for (var v4 = 0; v4 < u.length; v4++) {
        var m3 = u[v4], x3 = e3[m3];
        m3 === "style" ? this.style ? fi(this.style, x3) : this.useStyle(x3) : m3 === "shape" ? fi(this.shape, x3) : l3.prototype.attrKV.call(this, m3, x3);
      }
      this.style || this.useStyle({});
    }, r3.prototype.getDefaultStyle = function() {
      return null;
    }, r3.prototype.getDefaultShape = function() {
      return {};
    }, r3.prototype.canBeInsideText = function() {
      return this.hasFill();
    }, r3.prototype.getInsideTextFill = function() {
      var e3 = this.style.fill;
      if (e3 !== "none") {
        if (qa(e3)) {
          var u = jfe(e3, 0);
          return u > 0.5 ? B5e : u > 0.2 ? gln : z5e;
        } else if (e3)
          return z5e;
      }
      return B5e;
    }, r3.prototype.getInsideTextStroke = function(e3) {
      var u = this.style.fill;
      if (qa(u)) {
        var h = this.__zr, v4 = !!(h && h.isDarkMode()), m3 = jfe(e3, 0) < V5e;
        if (v4 === m3)
          return u;
      }
    }, r3.prototype.buildPath = function(e3, u, h) {
    }, r3.prototype.pathUpdated = function() {
      this.__dirty &= ~Hz;
    }, r3.prototype.getUpdatedPathProxy = function(e3) {
      return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, e3), this.path;
    }, r3.prototype.createPathProxy = function() {
      this.path = new XA(false);
    }, r3.prototype.hasStroke = function() {
      var e3 = this.style, u = e3.stroke;
      return !(u == null || u === "none" || !(e3.lineWidth > 0));
    }, r3.prototype.hasFill = function() {
      var e3 = this.style, u = e3.fill;
      return u != null && u !== "none";
    }, r3.prototype.getBoundingRect = function() {
      var e3 = this._rect, u = this.style, h = !e3;
      if (h) {
        var v4 = false;
        this.path || (v4 = true, this.createPathProxy());
        var m3 = this.path;
        (v4 || this.__dirty & Hz) && (m3.beginPath(), this.buildPath(m3, this.shape, false), this.pathUpdated()), e3 = m3.getBoundingRect();
      }
      if (this._rect = e3, this.hasStroke() && this.path && this.path.len() > 0) {
        var x3 = this._rectStroke || (this._rectStroke = e3.clone());
        if (this.__dirty || h) {
          x3.copy(e3);
          var C = u.strokeNoScale ? this.getLineScale() : 1, A2 = u.lineWidth;
          if (!this.hasFill()) {
            var D = this.strokeContainThreshold;
            A2 = Math.max(A2, D == null ? 4 : D);
          }
          C > 1e-10 && (x3.width += A2 / C, x3.height += A2 / C, x3.x -= A2 / C / 2, x3.y -= A2 / C / 2);
        }
        return x3;
      }
      return e3;
    }, r3.prototype.contain = function(e3, u) {
      var h = this.transformCoordToLocal(e3, u), v4 = this.getBoundingRect(), m3 = this.style;
      if (e3 = h[0], u = h[1], v4.contain(e3, u)) {
        var x3 = this.path;
        if (this.hasStroke()) {
          var C = m3.lineWidth, A2 = m3.strokeNoScale ? this.getLineScale() : 1;
          if (A2 > 1e-10 && (this.hasFill() || (C = Math.max(C, this.strokeContainThreshold)), Nun(x3, C / A2, e3, u)))
            return true;
        }
        if (this.hasFill())
          return Run(x3, e3, u);
      }
      return false;
    }, r3.prototype.dirtyShape = function() {
      this.__dirty |= Hz, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
    }, r3.prototype.dirty = function() {
      this.dirtyStyle(), this.dirtyShape();
    }, r3.prototype.animateShape = function(e3) {
      return this.animate("shape", e3);
    }, r3.prototype.updateDuringAnimation = function(e3) {
      e3 === "style" ? this.dirtyStyle() : e3 === "shape" ? this.dirtyShape() : this.markRedraw();
    }, r3.prototype.attrKV = function(e3, u) {
      e3 === "shape" ? this.setShape(u) : l3.prototype.attrKV.call(this, e3, u);
    }, r3.prototype.setShape = function(e3, u) {
      var h = this.shape;
      return h || (h = this.shape = {}), typeof e3 == "string" ? h[e3] = u : fi(h, e3), this.dirtyShape(), this;
    }, r3.prototype.shapeChanged = function() {
      return !!(this.__dirty & Hz);
    }, r3.prototype.createStyle = function(e3) {
      return Bhe(qfe, e3);
    }, r3.prototype._innerSaveToNormal = function(e3) {
      l3.prototype._innerSaveToNormal.call(this, e3);
      var u = this._normalState;
      e3.shape && !u.shape && (u.shape = fi({}, this.shape));
    }, r3.prototype._applyStateObj = function(e3, u, h, v4, m3, x3) {
      l3.prototype._applyStateObj.call(this, e3, u, h, v4, m3, x3);
      var C = !(u && v4), A2;
      if (u && u.shape ? m3 ? v4 ? A2 = u.shape : (A2 = fi({}, h.shape), fi(A2, u.shape)) : (A2 = fi({}, v4 ? this.shape : h.shape), fi(A2, u.shape)) : C && (A2 = h.shape), A2)
        if (m3) {
          this.shape = fi({}, this.shape);
          for (var D = {}, P = yu(A2), N = 0; N < P.length; N++) {
            var j = P[N];
            typeof A2[j] == "object" ? this.shape[j] = A2[j] : D[j] = A2[j];
          }
          this._transitionState(e3, { shape: D }, x3);
        } else
          this.shape = A2, this.dirtyShape();
    }, r3.prototype._mergeStates = function(e3) {
      for (var u = l3.prototype._mergeStates.call(this, e3), h, v4 = 0; v4 < e3.length; v4++) {
        var m3 = e3[v4];
        m3.shape && (h = h || {}, this._mergeStyle(h, m3.shape));
      }
      return h && (u.shape = h), u;
    }, r3.prototype.getAnimationStyleProps = function() {
      return Fun;
    }, r3.prototype.isZeroArea = function() {
      return false;
    }, r3.extend = function(e3) {
      var u = function(v4) {
        ar(m3, v4);
        function m3(x3) {
          var C = v4.call(this, x3) || this;
          return e3.init && e3.init.call(C, x3), C;
        }
        return m3.prototype.getDefaultStyle = function() {
          return bs(e3.style);
        }, m3.prototype.getDefaultShape = function() {
          return bs(e3.shape);
        }, m3;
      }(r3);
      for (var h in e3)
        typeof e3[h] == "function" && (u.prototype[h] = e3[h]);
      return u;
    }, r3.initDefaultProps = function() {
      var e3 = r3.prototype;
      e3.type = "path", e3.strokeContainThreshold = 5, e3.segmentIgnoreThreshold = 0, e3.subPixelOptimize = false, e3.autoBatch = false, e3.__dirty = Kx | bZ | Hz;
    }(), r3;
  }(x2), Nl = Vun, Bun = ns({ strokeFirst: true, font: KO, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, qfe), kut = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.hasStroke = function() {
      var e3 = this.style, u = e3.stroke;
      return u != null && u !== "none" && e3.lineWidth > 0;
    }, r3.prototype.hasFill = function() {
      var e3 = this.style, u = e3.fill;
      return u != null && u !== "none";
    }, r3.prototype.createStyle = function(e3) {
      return Bhe(Bun, e3);
    }, r3.prototype.setBoundingRect = function(e3) {
      this._rect = e3;
    }, r3.prototype.getBoundingRect = function() {
      var e3 = this.style;
      if (!this._rect) {
        var u = e3.text;
        u != null ? u += "" : u = "";
        var h = DJ(u, e3.font, e3.textAlign, e3.textBaseline);
        if (h.x += e3.x || 0, h.y += e3.y || 0, this.hasStroke()) {
          var v4 = e3.lineWidth;
          h.x -= v4 / 2, h.y -= v4 / 2, h.width += v4, h.height += v4;
        }
        this._rect = h;
      }
      return this._rect;
    }, r3.initDefaultProps = function() {
      var e3 = r3.prototype;
      e3.dirtyRectTolerance = 10;
    }(), r3;
  }(x2);
  kut.prototype.type = "tspan";
  var nJ = kut, zun = ns({ x: 0, y: 0 }, RN), jun = { style: ns({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, Uhe.style) };
  function Gun(l3) {
    return !!(l3 && typeof l3 != "string" && l3.width && l3.height);
  }
  var Out = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.createStyle = function(e3) {
      return Bhe(zun, e3);
    }, r3.prototype._getSize = function(e3) {
      var u = this.style, h = u[e3];
      if (h != null)
        return h;
      var v4 = Gun(u.image) ? u.image : this.__image;
      if (!v4)
        return 0;
      var m3 = e3 === "width" ? "height" : "width", x3 = u[m3];
      return x3 == null ? v4[e3] : v4[e3] / v4[m3] * x3;
    }, r3.prototype.getWidth = function() {
      return this._getSize("width");
    }, r3.prototype.getHeight = function() {
      return this._getSize("height");
    }, r3.prototype.getAnimationStyleProps = function() {
      return jun;
    }, r3.prototype.getBoundingRect = function() {
      var e3 = this.style;
      return this._rect || (this._rect = new Ml(e3.x || 0, e3.y || 0, this.getWidth(), this.getHeight())), this._rect;
    }, r3;
  }(x2);
  Out.prototype.type = "image";
  var lm = Out;
  function Hun(l3, r3) {
    var e3 = r3.x, u = r3.y, h = r3.width, v4 = r3.height, m3 = r3.r, x3, C, A2, D;
    h < 0 && (e3 = e3 + h, h = -h), v4 < 0 && (u = u + v4, v4 = -v4), typeof m3 == "number" ? x3 = C = A2 = D = m3 : m3 instanceof Array ? m3.length === 1 ? x3 = C = A2 = D = m3[0] : m3.length === 2 ? (x3 = A2 = m3[0], C = D = m3[1]) : m3.length === 3 ? (x3 = m3[0], C = D = m3[1], A2 = m3[2]) : (x3 = m3[0], C = m3[1], A2 = m3[2], D = m3[3]) : x3 = C = A2 = D = 0;
    var P;
    x3 + C > h && (P = x3 + C, x3 *= h / P, C *= h / P), A2 + D > h && (P = A2 + D, A2 *= h / P, D *= h / P), C + A2 > v4 && (P = C + A2, C *= v4 / P, A2 *= v4 / P), x3 + D > v4 && (P = x3 + D, x3 *= v4 / P, D *= v4 / P), l3.moveTo(e3 + x3, u), l3.lineTo(e3 + h - C, u), C !== 0 && l3.arc(e3 + h - C, u + C, C, -Math.PI / 2, 0), l3.lineTo(e3 + h, u + v4 - A2), A2 !== 0 && l3.arc(e3 + h - A2, u + v4 - A2, A2, 0, Math.PI / 2), l3.lineTo(e3 + D, u + v4), D !== 0 && l3.arc(e3 + D, u + v4 - D, D, Math.PI / 2, Math.PI), l3.lineTo(e3, u + x3), x3 !== 0 && l3.arc(e3 + x3, u + x3, x3, Math.PI, Math.PI * 1.5);
  }
  var Kz = Math.round;
  function Put(l3, r3, e3) {
    if (!!r3) {
      var u = r3.x1, h = r3.x2, v4 = r3.y1, m3 = r3.y2;
      l3.x1 = u, l3.x2 = h, l3.y1 = v4, l3.y2 = m3;
      var x3 = e3 && e3.lineWidth;
      return x3 && (Kz(u * 2) === Kz(h * 2) && (l3.x1 = l3.x2 = EN(u, x3, true)), Kz(v4 * 2) === Kz(m3 * 2) && (l3.y1 = l3.y2 = EN(v4, x3, true))), l3;
    }
  }
  function Lut(l3, r3, e3) {
    if (!!r3) {
      var u = r3.x, h = r3.y, v4 = r3.width, m3 = r3.height;
      l3.x = u, l3.y = h, l3.width = v4, l3.height = m3;
      var x3 = e3 && e3.lineWidth;
      return x3 && (l3.x = EN(u, x3, true), l3.y = EN(h, x3, true), l3.width = Math.max(EN(u + v4, x3, false) - l3.x, v4 === 0 ? 0 : 1), l3.height = Math.max(EN(h + m3, x3, false) - l3.y, m3 === 0 ? 0 : 1)), l3;
    }
  }
  function EN(l3, r3, e3) {
    if (!r3)
      return l3;
    var u = Kz(l3 * 2);
    return (u + Kz(r3)) % 2 === 0 ? u / 2 : (u + (e3 ? 1 : -1)) / 2;
  }
  var Wun = function() {
    function l3() {
      this.x = 0, this.y = 0, this.width = 0, this.height = 0;
    }
    return l3;
  }(), Uun = {}, Rut = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new Wun();
    }, r3.prototype.buildPath = function(e3, u) {
      var h, v4, m3, x3;
      if (this.subPixelOptimize) {
        var C = Lut(Uun, u, this.style);
        h = C.x, v4 = C.y, m3 = C.width, x3 = C.height, C.r = u.r, u = C;
      } else
        h = u.x, v4 = u.y, m3 = u.width, x3 = u.height;
      u.r ? Hun(e3, u) : e3.rect(h, v4, m3, x3);
    }, r3.prototype.isZeroArea = function() {
      return !this.shape.width || !this.shape.height;
    }, r3;
  }(Nl);
  Rut.prototype.type = "rect";
  var Ju = Rut, Ntt = { fill: "#000" }, Ftt = 2, qun = { style: ns({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, Uhe.style) }, Nut = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this) || this;
      return u.type = "text", u._children = [], u._defaultStyle = Ntt, u.attr(e3), u;
    }
    return r3.prototype.childrenRef = function() {
      return this._children;
    }, r3.prototype.update = function() {
      l3.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
      for (var e3 = 0; e3 < this._children.length; e3++) {
        var u = this._children[e3];
        u.zlevel = this.zlevel, u.z = this.z, u.z2 = this.z2, u.culling = this.culling, u.cursor = this.cursor, u.invisible = this.invisible;
      }
    }, r3.prototype.updateTransform = function() {
      var e3 = this.innerTransformable;
      e3 ? (e3.updateTransform(), e3.transform && (this.transform = e3.transform)) : l3.prototype.updateTransform.call(this);
    }, r3.prototype.getLocalTransform = function(e3) {
      var u = this.innerTransformable;
      return u ? u.getLocalTransform(e3) : l3.prototype.getLocalTransform.call(this, e3);
    }, r3.prototype.getComputedTransform = function() {
      return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), l3.prototype.getComputedTransform.call(this);
    }, r3.prototype._updateSubTexts = function() {
      this._childCursor = 0, Yun(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
    }, r3.prototype.addSelfToZr = function(e3) {
      l3.prototype.addSelfToZr.call(this, e3);
      for (var u = 0; u < this._children.length; u++)
        this._children[u].__zr = e3;
    }, r3.prototype.removeSelfFromZr = function(e3) {
      l3.prototype.removeSelfFromZr.call(this, e3);
      for (var u = 0; u < this._children.length; u++)
        this._children[u].__zr = null;
    }, r3.prototype.getBoundingRect = function() {
      if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
        for (var e3 = new Ml(0, 0, 0, 0), u = this._children, h = [], v4 = null, m3 = 0; m3 < u.length; m3++) {
          var x3 = u[m3], C = x3.getBoundingRect(), A2 = x3.getLocalTransform(h);
          A2 ? (e3.copy(C), e3.applyTransform(A2), v4 = v4 || e3.clone(), v4.union(e3)) : (v4 = v4 || C.clone(), v4.union(C));
        }
        this._rect = v4 || e3;
      }
      return this._rect;
    }, r3.prototype.setDefaultTextStyle = function(e3) {
      this._defaultStyle = e3 || Ntt;
    }, r3.prototype.setTextContent = function(e3) {
    }, r3.prototype._mergeStyle = function(e3, u) {
      if (!u)
        return e3;
      var h = u.rich, v4 = e3.rich || h && {};
      return fi(e3, u), h && v4 ? (this._mergeRich(v4, h), e3.rich = v4) : v4 && (e3.rich = v4), e3;
    }, r3.prototype._mergeRich = function(e3, u) {
      for (var h = yu(u), v4 = 0; v4 < h.length; v4++) {
        var m3 = h[v4];
        e3[m3] = e3[m3] || {}, fi(e3[m3], u[m3]);
      }
    }, r3.prototype.getAnimationStyleProps = function() {
      return qun;
    }, r3.prototype._getOrCreateChild = function(e3) {
      var u = this._children[this._childCursor];
      return (!u || !(u instanceof e3)) && (u = new e3()), this._children[this._childCursor++] = u, u.__zr = this.__zr, u.parent = this, u;
    }, r3.prototype._updatePlainTexts = function() {
      var e3 = this.style, u = e3.font || KO, h = e3.padding, v4 = Wtt(e3), m3 = hun(v4, e3), x3 = yEe(e3), C = !!e3.backgroundColor, A2 = m3.outerHeight, D = m3.outerWidth, P = m3.contentWidth, N = m3.lines, j = m3.lineHeight, W = this._defaultStyle, K = e3.x || 0, te = e3.y || 0, ne = e3.align || W.align || "left", ce = e3.verticalAlign || W.verticalAlign || "top", me = K, ve = Wz(te, m3.contentHeight, ce);
      if (x3 || h) {
        var Be = xZ(K, D, ne), Oe = Wz(te, A2, ce);
        x3 && this._renderBackground(e3, e3, Be, Oe, D, A2);
      }
      ve += j / 2, h && (me = Htt(K, ne, h), ce === "top" ? ve += h[0] : ce === "bottom" && (ve -= h[2]));
      for (var We = 0, Ue = false, qe = Gtt("fill" in e3 ? e3.fill : (Ue = true, W.fill)), Ze = jtt("stroke" in e3 ? e3.stroke : !C && (!W.autoStroke || Ue) ? (We = Ftt, W.stroke) : null), ct = e3.textShadowBlur > 0, _t = e3.width != null && (e3.overflow === "truncate" || e3.overflow === "break" || e3.overflow === "breakAll"), pt = m3.calculatedLineHeight, zt = 0; zt < N.length; zt++) {
        var Zt = this._getOrCreateChild(nJ), Ft = Zt.createStyle();
        Zt.useStyle(Ft), Ft.text = N[zt], Ft.x = me, Ft.y = ve, ne && (Ft.textAlign = ne), Ft.textBaseline = "middle", Ft.opacity = e3.opacity, Ft.strokeFirst = true, ct && (Ft.shadowBlur = e3.textShadowBlur || 0, Ft.shadowColor = e3.textShadowColor || "transparent", Ft.shadowOffsetX = e3.textShadowOffsetX || 0, Ft.shadowOffsetY = e3.textShadowOffsetY || 0), Ft.stroke = Ze, Ft.fill = qe, Ze && (Ft.lineWidth = e3.lineWidth || We, Ft.lineDash = e3.lineDash, Ft.lineDashOffset = e3.lineDashOffset || 0), Ft.font = u, Btt(Ft, e3), ve += j, _t && Zt.setBoundingRect(new Ml(xZ(Ft.x, e3.width, Ft.textAlign), Wz(Ft.y, pt, Ft.textBaseline), P, pt));
      }
    }, r3.prototype._updateRichTexts = function() {
      var e3 = this.style, u = Wtt(e3), h = vun(u, e3), v4 = h.width, m3 = h.outerWidth, x3 = h.outerHeight, C = e3.padding, A2 = e3.x || 0, D = e3.y || 0, P = this._defaultStyle, N = e3.align || P.align, j = e3.verticalAlign || P.verticalAlign, W = xZ(A2, m3, N), K = Wz(D, x3, j), te = W, ne = K;
      C && (te += C[3], ne += C[0]);
      var ce = te + v4;
      yEe(e3) && this._renderBackground(e3, e3, W, K, m3, x3);
      for (var me = !!e3.backgroundColor, ve = 0; ve < h.lines.length; ve++) {
        for (var Be = h.lines[ve], Oe = Be.tokens, We = Oe.length, Ue = Be.lineHeight, qe = Be.width, Ze = 0, ct = te, _t = ce, pt = We - 1, zt = void 0; Ze < We && (zt = Oe[Ze], !zt.align || zt.align === "left"); )
          this._placeToken(zt, e3, Ue, ne, ct, "left", me), qe -= zt.width, ct += zt.width, Ze++;
        for (; pt >= 0 && (zt = Oe[pt], zt.align === "right"); )
          this._placeToken(zt, e3, Ue, ne, _t, "right", me), qe -= zt.width, _t -= zt.width, pt--;
        for (ct += (v4 - (ct - te) - (ce - _t) - qe) / 2; Ze <= pt; )
          zt = Oe[Ze], this._placeToken(zt, e3, Ue, ne, ct + zt.width / 2, "center", me), ct += zt.width, Ze++;
        ne += Ue;
      }
    }, r3.prototype._placeToken = function(e3, u, h, v4, m3, x3, C) {
      var A2 = u.rich[e3.styleName] || {};
      A2.text = e3.text;
      var D = e3.verticalAlign, P = v4 + h / 2;
      D === "top" ? P = v4 + e3.height / 2 : D === "bottom" && (P = v4 + h - e3.height / 2);
      var N = !e3.isLineHolder && yEe(A2);
      N && this._renderBackground(A2, u, x3 === "right" ? m3 - e3.width : x3 === "center" ? m3 - e3.width / 2 : m3, P - e3.height / 2, e3.width, e3.height);
      var j = !!A2.backgroundColor, W = e3.textPadding;
      W && (m3 = Htt(m3, x3, W), P -= e3.height / 2 - W[0] - e3.innerHeight / 2);
      var K = this._getOrCreateChild(nJ), te = K.createStyle();
      K.useStyle(te);
      var ne = this._defaultStyle, ce = false, me = 0, ve = Gtt("fill" in A2 ? A2.fill : "fill" in u ? u.fill : (ce = true, ne.fill)), Be = jtt("stroke" in A2 ? A2.stroke : "stroke" in u ? u.stroke : !j && !C && (!ne.autoStroke || ce) ? (me = Ftt, ne.stroke) : null), Oe = A2.textShadowBlur > 0 || u.textShadowBlur > 0;
      te.text = e3.text, te.x = m3, te.y = P, Oe && (te.shadowBlur = A2.textShadowBlur || u.textShadowBlur || 0, te.shadowColor = A2.textShadowColor || u.textShadowColor || "transparent", te.shadowOffsetX = A2.textShadowOffsetX || u.textShadowOffsetX || 0, te.shadowOffsetY = A2.textShadowOffsetY || u.textShadowOffsetY || 0), te.textAlign = x3, te.textBaseline = "middle", te.font = e3.font || KO, te.opacity = t5(A2.opacity, u.opacity, 1), Btt(te, A2), Be && (te.lineWidth = t5(A2.lineWidth, u.lineWidth, me), te.lineDash = dl(A2.lineDash, u.lineDash), te.lineDashOffset = u.lineDashOffset || 0, te.stroke = Be), ve && (te.fill = ve);
      var We = e3.contentWidth, Ue = e3.contentHeight;
      K.setBoundingRect(new Ml(xZ(te.x, We, te.textAlign), Wz(te.y, Ue, te.textBaseline), We, Ue));
    }, r3.prototype._renderBackground = function(e3, u, h, v4, m3, x3) {
      var C = e3.backgroundColor, A2 = e3.borderWidth, D = e3.borderColor, P = C && C.image, N = C && !P, j = e3.borderRadius, W = this, K, te;
      if (N || e3.lineHeight || A2 && D) {
        K = this._getOrCreateChild(Ju), K.useStyle(K.createStyle()), K.style.fill = null;
        var ne = K.shape;
        ne.x = h, ne.y = v4, ne.width = m3, ne.height = x3, ne.r = j, K.dirtyShape();
      }
      if (N) {
        var ce = K.style;
        ce.fill = C || null, ce.fillOpacity = dl(e3.fillOpacity, 1);
      } else if (P) {
        te = this._getOrCreateChild(lm), te.onload = function() {
          W.dirtyStyle();
        };
        var me = te.style;
        me.image = C.image, me.x = h, me.y = v4, me.width = m3, me.height = x3;
      }
      if (A2 && D) {
        var ce = K.style;
        ce.lineWidth = A2, ce.stroke = D, ce.strokeOpacity = dl(e3.strokeOpacity, 1), ce.lineDash = e3.borderDash, ce.lineDashOffset = e3.borderDashOffset || 0, K.strokeContainThreshold = 0, K.hasFill() && K.hasStroke() && (ce.strokeFirst = true, ce.lineWidth *= 2);
      }
      var ve = (K || te).style;
      ve.shadowBlur = e3.shadowBlur || 0, ve.shadowColor = e3.shadowColor || "transparent", ve.shadowOffsetX = e3.shadowOffsetX || 0, ve.shadowOffsetY = e3.shadowOffsetY || 0, ve.opacity = t5(e3.opacity, u.opacity, 1);
    }, r3.makeFont = function(e3) {
      var u = "";
      return Vut(e3) && (u = [e3.fontStyle, e3.fontWeight, Fut(e3.fontSize), e3.fontFamily || "sans-serif"].join(" ")), u && hM(u) || e3.textFont || e3.font;
    }, r3;
  }(x2), $un = { left: true, right: 1, center: 1 }, Xun = { top: 1, bottom: 1, middle: 1 }, Vtt = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
  function Fut(l3) {
    return typeof l3 == "string" && (l3.indexOf("px") !== -1 || l3.indexOf("rem") !== -1 || l3.indexOf("em") !== -1) ? l3 : isNaN(+l3) ? w3e + "px" : l3 + "px";
  }
  function Btt(l3, r3) {
    for (var e3 = 0; e3 < Vtt.length; e3++) {
      var u = Vtt[e3], h = r3[u];
      h != null && (l3[u] = h);
    }
  }
  function Vut(l3) {
    return l3.fontSize != null || l3.fontFamily || l3.fontWeight;
  }
  function Yun(l3) {
    return ztt(l3), mt(l3.rich, ztt), l3;
  }
  function ztt(l3) {
    if (l3) {
      l3.font = Nut.makeFont(l3);
      var r3 = l3.align;
      r3 === "middle" && (r3 = "center"), l3.align = r3 == null || $un[r3] ? r3 : "left";
      var e3 = l3.verticalAlign;
      e3 === "center" && (e3 = "middle"), l3.verticalAlign = e3 == null || Xun[e3] ? e3 : "top";
      var u = l3.padding;
      u && (l3.padding = I3e(l3.padding));
    }
  }
  function jtt(l3, r3) {
    return l3 == null || r3 <= 0 || l3 === "transparent" || l3 === "none" ? null : l3.image || l3.colorStops ? "#000" : l3;
  }
  function Gtt(l3) {
    return l3 == null || l3 === "none" ? null : l3.image || l3.colorStops ? "#000" : l3;
  }
  function Htt(l3, r3, e3) {
    return r3 === "right" ? l3 - e3[1] : r3 === "center" ? l3 + e3[3] / 2 - e3[1] / 2 : l3 + e3[3];
  }
  function Wtt(l3) {
    var r3 = l3.text;
    return r3 != null && (r3 += ""), r3;
  }
  function yEe(l3) {
    return !!(l3.backgroundColor || l3.lineHeight || l3.borderWidth && l3.borderColor);
  }
  var Ec = Nut, Ps = pc(), U5e = function(l3, r3, e3, u) {
    if (u) {
      var h = Ps(u);
      h.dataIndex = e3, h.dataType = r3, h.seriesIndex = l3, u.type === "group" && u.traverse(function(v4) {
        var m3 = Ps(v4);
        m3.seriesIndex = l3, m3.dataIndex = e3, m3.dataType = r3;
      });
    }
  }, Utt = 1, qtt = {}, But = pc(), z3e = pc(), j3e = 0, OJ = 1, $he = 2, bb = ["emphasis", "blur", "select"], rJ = ["normal", "emphasis", "blur", "select"], wj = 10, Kun = 9, NN = "highlight", Sfe = "downplay", FZ = "select", Cfe = "unselect", VZ = "toggleSelect";
  function Mz(l3) {
    return l3 != null && l3 !== "none";
  }
  var $tt = new EJ(100);
  function Xtt(l3) {
    if (qa(l3)) {
      var r3 = $tt.get(l3);
      return r3 || (r3 = k5e(l3, -0.1), $tt.put(l3, r3)), r3;
    } else if (Vhe(l3)) {
      var e3 = fi({}, l3);
      return e3.colorStops = Bi(l3.colorStops, function(u) {
        return { offset: u.offset, color: k5e(u.color, -0.1) };
      }), e3;
    }
    return l3;
  }
  function Xhe(l3, r3, e3) {
    l3.onHoverStateChange && (l3.hoverState || 0) !== e3 && l3.onHoverStateChange(r3), l3.hoverState = e3;
  }
  function zut(l3) {
    Xhe(l3, "emphasis", $he);
  }
  function jut(l3) {
    l3.hoverState === $he && Xhe(l3, "normal", j3e);
  }
  function G3e(l3) {
    Xhe(l3, "blur", OJ);
  }
  function Gut(l3) {
    l3.hoverState === OJ && Xhe(l3, "normal", j3e);
  }
  function Zun(l3) {
    l3.selected = true;
  }
  function Jun(l3) {
    l3.selected = false;
  }
  function Ytt(l3, r3, e3) {
    r3(l3, e3);
  }
  function d5(l3, r3, e3) {
    Ytt(l3, r3, e3), l3.isGroup && l3.traverse(function(u) {
      Ytt(u, r3, e3);
    });
  }
  function $fe(l3, r3) {
    switch (r3) {
      case "emphasis":
        l3.hoverState = $he;
        break;
      case "normal":
        l3.hoverState = j3e;
        break;
      case "blur":
        l3.hoverState = OJ;
        break;
      case "select":
        l3.selected = true;
    }
  }
  function Qun(l3, r3, e3, u) {
    for (var h = l3.style, v4 = {}, m3 = 0; m3 < r3.length; m3++) {
      var x3 = r3[m3], C = h[x3];
      v4[x3] = C == null ? u && u[x3] : C;
    }
    for (var m3 = 0; m3 < l3.animators.length; m3++) {
      var A2 = l3.animators[m3];
      A2.__fromStateTransition && A2.__fromStateTransition.indexOf(e3) < 0 && A2.targetName === "style" && A2.saveTo(v4, r3);
    }
    return v4;
  }
  function ecn(l3, r3, e3, u) {
    var h = e3 && Cl(e3, "select") >= 0, v4 = false;
    if (l3 instanceof Nl) {
      var m3 = But(l3), x3 = h && m3.selectFill || m3.normalFill, C = h && m3.selectStroke || m3.normalStroke;
      if (Mz(x3) || Mz(C)) {
        u = u || {};
        var A2 = u.style || {};
        A2.fill === "inherit" ? (v4 = true, u = fi({}, u), A2 = fi({}, A2), A2.fill = x3) : !Mz(A2.fill) && Mz(x3) ? (v4 = true, u = fi({}, u), A2 = fi({}, A2), A2.fill = Xtt(x3)) : !Mz(A2.stroke) && Mz(C) && (v4 || (u = fi({}, u), A2 = fi({}, A2)), A2.stroke = Xtt(C)), u.style = A2;
      }
    }
    if (u && u.z2 == null) {
      v4 || (u = fi({}, u));
      var D = l3.z2EmphasisLift;
      u.z2 = l3.z2 + (D != null ? D : wj);
    }
    return u;
  }
  function tcn(l3, r3, e3) {
    if (e3 && e3.z2 == null) {
      e3 = fi({}, e3);
      var u = l3.z2SelectLift;
      e3.z2 = l3.z2 + (u != null ? u : Kun);
    }
    return e3;
  }
  function ncn(l3, r3, e3) {
    var u = Cl(l3.currentStates, r3) >= 0, h = l3.style.opacity, v4 = u ? null : Qun(l3, ["opacity"], r3, { opacity: 1 });
    e3 = e3 || {};
    var m3 = e3.style || {};
    return m3.opacity == null && (e3 = fi({}, e3), m3 = fi({ opacity: u ? h : v4.opacity * 0.1 }, m3), e3.style = m3), e3;
  }
  function mEe(l3, r3) {
    var e3 = this.states[l3];
    if (this.style) {
      if (l3 === "emphasis")
        return ecn(this, l3, r3, e3);
      if (l3 === "blur")
        return ncn(this, l3, e3);
      if (l3 === "select")
        return tcn(this, l3, e3);
    }
    return e3;
  }
  function qN(l3) {
    l3.stateProxy = mEe;
    var r3 = l3.getTextContent(), e3 = l3.getTextGuideLine();
    r3 && (r3.stateProxy = mEe), e3 && (e3.stateProxy = mEe);
  }
  function Ktt(l3, r3) {
    !$ut(l3, r3) && !l3.__highByOuter && d5(l3, zut);
  }
  function Ztt(l3, r3) {
    !$ut(l3, r3) && !l3.__highByOuter && d5(l3, jut);
  }
  function zA(l3, r3) {
    l3.__highByOuter |= 1 << (r3 || 0), d5(l3, zut);
  }
  function jA(l3, r3) {
    !(l3.__highByOuter &= ~(1 << (r3 || 0))) && d5(l3, jut);
  }
  function Hut(l3) {
    d5(l3, G3e);
  }
  function Wut(l3) {
    d5(l3, Gut);
  }
  function Uut(l3) {
    d5(l3, Zun);
  }
  function qut(l3) {
    d5(l3, Jun);
  }
  function $ut(l3, r3) {
    return l3.__highDownSilentOnTouch && r3.zrByTouch;
  }
  function Xut(l3) {
    var r3 = l3.getModel();
    r3.eachComponent(function(e3, u) {
      var h = z3e(u);
      if (h.isBlured) {
        var v4 = e3 === "series" ? l3.getViewOfSeriesModel(u) : l3.getViewOfComponentModel(u);
        v4.group.traverse(function(m3) {
          Gut(m3);
        });
      }
      h.isBlured = false;
    });
  }
  function q5e(l3, r3, e3, u) {
    var h = u.getModel();
    e3 = e3 || "coordinateSystem";
    function v4(A2, D) {
      for (var P = 0; P < D.length; P++) {
        var N = A2.getItemGraphicEl(D[P]);
        N && Wut(N);
      }
    }
    if (l3 != null && !(!r3 || r3 === "none")) {
      var m3 = h.getSeriesByIndex(l3), x3 = m3.coordinateSystem;
      x3 && x3.master && (x3 = x3.master);
      var C = [];
      h.eachSeries(function(A2) {
        var D = m3 === A2, P = A2.coordinateSystem;
        P && P.master && (P = P.master);
        var N = P && x3 ? P === x3 : D;
        if (!(e3 === "series" && !D || e3 === "coordinateSystem" && !N || r3 === "series" && D)) {
          var j = u.getViewOfSeriesModel(A2);
          if (j.group.traverse(function(te) {
            G3e(te);
          }), m1(r3))
            v4(A2.getData(), r3);
          else if (ls(r3))
            for (var W = yu(r3), K = 0; K < W.length; K++)
              v4(A2.getData(W[K]), r3[W[K]]);
          C.push(A2), z3e(A2).isBlured = true;
        }
      }), h.eachComponent(function(A2, D) {
        if (A2 !== "series") {
          var P = u.getViewOfComponentModel(D);
          P && P.blurSeries && P.blurSeries(C, h);
        }
      });
    }
  }
  function $5e(l3, r3, e3) {
    if (!(l3 == null || r3 == null)) {
      var u = e3.getModel().getComponent(l3, r3);
      if (!!u) {
        z3e(u).isBlured = true;
        var h = e3.getViewOfComponentModel(u);
        !h || !h.focusBlurEnabled || h.group.traverse(function(v4) {
          G3e(v4);
        });
      }
    }
  }
  function rcn(l3, r3, e3) {
    var u = l3.seriesIndex, h = l3.getData(r3.dataType);
    if (!!h) {
      var v4 = WN(h, r3);
      v4 = (Ni(v4) ? v4[0] : v4) || 0;
      var m3 = h.getItemGraphicEl(v4);
      if (!m3)
        for (var x3 = h.count(), C = 0; !m3 && C < x3; )
          m3 = h.getItemGraphicEl(C++);
      if (m3) {
        var A2 = Ps(m3);
        q5e(u, A2.focus, A2.blurScope, e3);
      } else {
        var D = l3.get(["emphasis", "focus"]), P = l3.get(["emphasis", "blurScope"]);
        D != null && q5e(u, D, P, e3);
      }
    }
  }
  function H3e(l3, r3, e3, u) {
    var h = { focusSelf: false, dispatchers: null };
    if (l3 == null || l3 === "series" || r3 == null || e3 == null)
      return h;
    var v4 = u.getModel().getComponent(l3, r3);
    if (!v4)
      return h;
    var m3 = u.getViewOfComponentModel(v4);
    if (!m3 || !m3.findHighDownDispatchers)
      return h;
    for (var x3 = m3.findHighDownDispatchers(e3), C, A2 = 0; A2 < x3.length; A2++)
      if (Ps(x3[A2]).focus === "self") {
        C = true;
        break;
      }
    return { focusSelf: C, dispatchers: x3 };
  }
  function icn(l3, r3, e3) {
    var u = Ps(l3), h = H3e(u.componentMainType, u.componentIndex, u.componentHighDownName, e3), v4 = h.dispatchers, m3 = h.focusSelf;
    v4 ? (m3 && $5e(u.componentMainType, u.componentIndex, e3), mt(v4, function(x3) {
      return Ktt(x3, r3);
    })) : (q5e(u.seriesIndex, u.focus, u.blurScope, e3), u.focus === "self" && $5e(u.componentMainType, u.componentIndex, e3), Ktt(l3, r3));
  }
  function acn(l3, r3, e3) {
    Xut(e3);
    var u = Ps(l3), h = H3e(u.componentMainType, u.componentIndex, u.componentHighDownName, e3).dispatchers;
    h ? mt(h, function(v4) {
      return Ztt(v4, r3);
    }) : Ztt(l3, r3);
  }
  function ocn(l3, r3, e3) {
    if (!!Y5e(r3)) {
      var u = r3.dataType, h = l3.getData(u), v4 = WN(h, r3);
      Ni(v4) || (v4 = [v4]), l3[r3.type === VZ ? "toggleSelect" : r3.type === FZ ? "select" : "unselect"](v4, u);
    }
  }
  function Jtt(l3) {
    var r3 = l3.getAllData();
    mt(r3, function(e3) {
      var u = e3.data, h = e3.type;
      u.eachItemGraphicEl(function(v4, m3) {
        l3.isSelected(m3, h) ? Uut(v4) : qut(v4);
      });
    });
  }
  function scn(l3) {
    var r3 = [];
    return l3.eachSeries(function(e3) {
      var u = e3.getAllData();
      mt(u, function(h) {
        h.data;
        var v4 = h.type, m3 = e3.getSelectedDataIndices();
        if (m3.length > 0) {
          var x3 = { dataIndex: m3, seriesIndex: e3.seriesIndex };
          v4 != null && (x3.dataType = v4), r3.push(x3);
        }
      });
    }), r3;
  }
  function FN(l3, r3, e3) {
    DN(l3, true), d5(l3, qN), X5e(l3, r3, e3);
  }
  function lcn(l3) {
    DN(l3, false);
  }
  function Gd(l3, r3, e3, u) {
    u ? lcn(l3) : FN(l3, r3, e3);
  }
  function X5e(l3, r3, e3) {
    var u = Ps(l3);
    r3 != null ? (u.focus = r3, u.blurScope = e3) : u.focus && (u.focus = null);
  }
  var Qtt = ["emphasis", "blur", "select"], ucn = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
  function sm(l3, r3, e3, u) {
    e3 = e3 || "itemStyle";
    for (var h = 0; h < Qtt.length; h++) {
      var v4 = Qtt[h], m3 = r3.getModel([v4, e3]), x3 = l3.ensureState(v4);
      x3.style = u ? u(m3) : m3[ucn[e3]]();
    }
  }
  function DN(l3, r3) {
    var e3 = r3 === false, u = l3;
    l3.highDownSilentOnTouch && (u.__highDownSilentOnTouch = l3.highDownSilentOnTouch), (!e3 || u.__highDownDispatcher) && (u.__highByOuter = u.__highByOuter || 0, u.__highDownDispatcher = !e3);
  }
  function iJ(l3) {
    return !!(l3 && l3.__highDownDispatcher);
  }
  function ccn(l3, r3, e3) {
    var u = Ps(l3);
    u.componentMainType = r3.mainType, u.componentIndex = r3.componentIndex, u.componentHighDownName = e3;
  }
  function fcn(l3) {
    var r3 = qtt[l3];
    return r3 == null && Utt <= 32 && (r3 = qtt[l3] = Utt++), r3;
  }
  function Y5e(l3) {
    var r3 = l3.type;
    return r3 === FZ || r3 === Cfe || r3 === VZ;
  }
  function ent(l3) {
    var r3 = l3.type;
    return r3 === NN || r3 === Sfe;
  }
  function hcn(l3) {
    var r3 = But(l3);
    r3.normalFill = l3.style.fill, r3.normalStroke = l3.style.stroke;
    var e3 = l3.states.select || {};
    r3.selectFill = e3.style && e3.style.fill || null, r3.selectStroke = e3.style && e3.style.stroke || null;
  }
  var Tz = XA.CMD, pcn = [[], [], []], tnt = Math.sqrt, dcn = Math.atan2;
  function Yut(l3, r3) {
    if (!!r3) {
      var e3 = l3.data, u = l3.len(), h, v4, m3, x3, C, A2, D = Tz.M, P = Tz.C, N = Tz.L, j = Tz.R, W = Tz.A, K = Tz.Q;
      for (m3 = 0, x3 = 0; m3 < u; ) {
        switch (h = e3[m3++], x3 = m3, v4 = 0, h) {
          case D:
            v4 = 1;
            break;
          case N:
            v4 = 1;
            break;
          case P:
            v4 = 3;
            break;
          case K:
            v4 = 2;
            break;
          case W:
            var te = r3[4], ne = r3[5], ce = tnt(r3[0] * r3[0] + r3[1] * r3[1]), me = tnt(r3[2] * r3[2] + r3[3] * r3[3]), ve = dcn(-r3[1] / me, r3[0] / ce);
            e3[m3] *= ce, e3[m3++] += te, e3[m3] *= me, e3[m3++] += ne, e3[m3++] *= ce, e3[m3++] *= me, e3[m3++] += ve, e3[m3++] += ve, m3 += 2, x3 = m3;
            break;
          case j:
            A2[0] = e3[m3++], A2[1] = e3[m3++], am(A2, A2, r3), e3[x3++] = A2[0], e3[x3++] = A2[1], A2[0] += e3[m3++], A2[1] += e3[m3++], am(A2, A2, r3), e3[x3++] = A2[0], e3[x3++] = A2[1];
        }
        for (C = 0; C < v4; C++) {
          var Be = pcn[C];
          Be[0] = e3[m3++], Be[1] = e3[m3++], am(Be, Be, r3), e3[x3++] = Be[0], e3[x3++] = Be[1];
        }
      }
      l3.increaseVersion();
    }
  }
  var bEe = Math.sqrt, bce = Math.sin, _ce = Math.cos, XK = Math.PI;
  function nnt(l3) {
    return Math.sqrt(l3[0] * l3[0] + l3[1] * l3[1]);
  }
  function K5e(l3, r3) {
    return (l3[0] * r3[0] + l3[1] * r3[1]) / (nnt(l3) * nnt(r3));
  }
  function rnt(l3, r3) {
    return (l3[0] * r3[1] < l3[1] * r3[0] ? -1 : 1) * Math.acos(K5e(l3, r3));
  }
  function int(l3, r3, e3, u, h, v4, m3, x3, C, A2, D) {
    var P = C * (XK / 180), N = _ce(P) * (l3 - e3) / 2 + bce(P) * (r3 - u) / 2, j = -1 * bce(P) * (l3 - e3) / 2 + _ce(P) * (r3 - u) / 2, W = N * N / (m3 * m3) + j * j / (x3 * x3);
    W > 1 && (m3 *= bEe(W), x3 *= bEe(W));
    var K = (h === v4 ? -1 : 1) * bEe((m3 * m3 * (x3 * x3) - m3 * m3 * (j * j) - x3 * x3 * (N * N)) / (m3 * m3 * (j * j) + x3 * x3 * (N * N))) || 0, te = K * m3 * j / x3, ne = K * -x3 * N / m3, ce = (l3 + e3) / 2 + _ce(P) * te - bce(P) * ne, me = (r3 + u) / 2 + bce(P) * te + _ce(P) * ne, ve = rnt([1, 0], [(N - te) / m3, (j - ne) / x3]), Be = [(N - te) / m3, (j - ne) / x3], Oe = [(-1 * N - te) / m3, (-1 * j - ne) / x3], We = rnt(Be, Oe);
    if (K5e(Be, Oe) <= -1 && (We = XK), K5e(Be, Oe) >= 1 && (We = 0), We < 0) {
      var Ue = Math.round(We / XK * 1e6) / 1e6;
      We = XK * 2 + Ue % 2 * XK;
    }
    D.addData(A2, ce, me, m3, x3, ve, We, P, v4);
  }
  var vcn = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, gcn = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function ycn(l3) {
    var r3 = new XA();
    if (!l3)
      return r3;
    var e3 = 0, u = 0, h = e3, v4 = u, m3, x3 = XA.CMD, C = l3.match(vcn);
    if (!C)
      return r3;
    for (var A2 = 0; A2 < C.length; A2++) {
      for (var D = C[A2], P = D.charAt(0), N = void 0, j = D.match(gcn) || [], W = j.length, K = 0; K < W; K++)
        j[K] = parseFloat(j[K]);
      for (var te = 0; te < W; ) {
        var ne = void 0, ce = void 0, me = void 0, ve = void 0, Be = void 0, Oe = void 0, We = void 0, Ue = e3, qe = u, Ze = void 0, ct = void 0;
        switch (P) {
          case "l":
            e3 += j[te++], u += j[te++], N = x3.L, r3.addData(N, e3, u);
            break;
          case "L":
            e3 = j[te++], u = j[te++], N = x3.L, r3.addData(N, e3, u);
            break;
          case "m":
            e3 += j[te++], u += j[te++], N = x3.M, r3.addData(N, e3, u), h = e3, v4 = u, P = "l";
            break;
          case "M":
            e3 = j[te++], u = j[te++], N = x3.M, r3.addData(N, e3, u), h = e3, v4 = u, P = "L";
            break;
          case "h":
            e3 += j[te++], N = x3.L, r3.addData(N, e3, u);
            break;
          case "H":
            e3 = j[te++], N = x3.L, r3.addData(N, e3, u);
            break;
          case "v":
            u += j[te++], N = x3.L, r3.addData(N, e3, u);
            break;
          case "V":
            u = j[te++], N = x3.L, r3.addData(N, e3, u);
            break;
          case "C":
            N = x3.C, r3.addData(N, j[te++], j[te++], j[te++], j[te++], j[te++], j[te++]), e3 = j[te - 2], u = j[te - 1];
            break;
          case "c":
            N = x3.C, r3.addData(N, j[te++] + e3, j[te++] + u, j[te++] + e3, j[te++] + u, j[te++] + e3, j[te++] + u), e3 += j[te - 2], u += j[te - 1];
            break;
          case "S":
            ne = e3, ce = u, Ze = r3.len(), ct = r3.data, m3 === x3.C && (ne += e3 - ct[Ze - 4], ce += u - ct[Ze - 3]), N = x3.C, Ue = j[te++], qe = j[te++], e3 = j[te++], u = j[te++], r3.addData(N, ne, ce, Ue, qe, e3, u);
            break;
          case "s":
            ne = e3, ce = u, Ze = r3.len(), ct = r3.data, m3 === x3.C && (ne += e3 - ct[Ze - 4], ce += u - ct[Ze - 3]), N = x3.C, Ue = e3 + j[te++], qe = u + j[te++], e3 += j[te++], u += j[te++], r3.addData(N, ne, ce, Ue, qe, e3, u);
            break;
          case "Q":
            Ue = j[te++], qe = j[te++], e3 = j[te++], u = j[te++], N = x3.Q, r3.addData(N, Ue, qe, e3, u);
            break;
          case "q":
            Ue = j[te++] + e3, qe = j[te++] + u, e3 += j[te++], u += j[te++], N = x3.Q, r3.addData(N, Ue, qe, e3, u);
            break;
          case "T":
            ne = e3, ce = u, Ze = r3.len(), ct = r3.data, m3 === x3.Q && (ne += e3 - ct[Ze - 4], ce += u - ct[Ze - 3]), e3 = j[te++], u = j[te++], N = x3.Q, r3.addData(N, ne, ce, e3, u);
            break;
          case "t":
            ne = e3, ce = u, Ze = r3.len(), ct = r3.data, m3 === x3.Q && (ne += e3 - ct[Ze - 4], ce += u - ct[Ze - 3]), e3 += j[te++], u += j[te++], N = x3.Q, r3.addData(N, ne, ce, e3, u);
            break;
          case "A":
            me = j[te++], ve = j[te++], Be = j[te++], Oe = j[te++], We = j[te++], Ue = e3, qe = u, e3 = j[te++], u = j[te++], N = x3.A, int(Ue, qe, e3, u, Oe, We, me, ve, Be, N, r3);
            break;
          case "a":
            me = j[te++], ve = j[te++], Be = j[te++], Oe = j[te++], We = j[te++], Ue = e3, qe = u, e3 += j[te++], u += j[te++], N = x3.A, int(Ue, qe, e3, u, Oe, We, me, ve, Be, N, r3);
            break;
        }
      }
      (P === "z" || P === "Z") && (N = x3.Z, r3.addData(N), e3 = h, u = v4), m3 = N;
    }
    return r3.toStatic(), r3;
  }
  var Kut = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.applyTransform = function(e3) {
    }, r3;
  }(Nl);
  function Zut(l3) {
    return l3.setData != null;
  }
  function Jut(l3, r3) {
    var e3 = ycn(l3), u = fi({}, r3);
    return u.buildPath = function(h) {
      if (Zut(h)) {
        h.setData(e3.data);
        var v4 = h.getContext();
        v4 && h.rebuildPath(v4, 1);
      } else {
        var v4 = h;
        e3.rebuildPath(v4, 1);
      }
    }, u.applyTransform = function(h) {
      Yut(e3, h), this.dirtyShape();
    }, u;
  }
  function Qut(l3, r3) {
    return new Kut(Jut(l3, r3));
  }
  function mcn(l3, r3) {
    var e3 = Jut(l3, r3), u = function(h) {
      ar(v4, h);
      function v4(m3) {
        var x3 = h.call(this, m3) || this;
        return x3.applyTransform = e3.applyTransform, x3.buildPath = e3.buildPath, x3;
      }
      return v4;
    }(Kut);
    return u;
  }
  function bcn(l3, r3) {
    for (var e3 = [], u = l3.length, h = 0; h < u; h++) {
      var v4 = l3[h];
      e3.push(v4.getUpdatedPathProxy(true));
    }
    var m3 = new Nl(r3);
    return m3.createPathProxy(), m3.buildPath = function(x3) {
      if (Zut(x3)) {
        x3.appendPath(e3);
        var C = x3.getContext();
        C && x3.rebuildPath(C, 1);
      }
    }, m3;
  }
  function W3e(l3, r3) {
    r3 = r3 || {};
    var e3 = new Nl();
    return l3.shape && e3.setShape(l3.shape), e3.setStyle(l3.style), r3.bakeTransform ? Yut(e3.path, l3.getComputedTransform()) : r3.toLocal ? e3.setLocalTransform(l3.getComputedTransform()) : e3.copyTransform(l3), e3.buildPath = l3.buildPath, e3.applyTransform = e3.applyTransform, e3.z = l3.z, e3.z2 = l3.z2, e3.zlevel = l3.zlevel, e3;
  }
  var _cn = function() {
    function l3() {
      this.cx = 0, this.cy = 0, this.r = 0;
    }
    return l3;
  }(), ect = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new _cn();
    }, r3.prototype.buildPath = function(e3, u) {
      e3.moveTo(u.cx + u.r, u.cy), e3.arc(u.cx, u.cy, u.r, 0, Math.PI * 2);
    }, r3;
  }(Nl);
  ect.prototype.type = "circle";
  var YA = ect, xcn = function() {
    function l3() {
      this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
    }
    return l3;
  }(), tct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new xcn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = 0.5522848, v4 = u.cx, m3 = u.cy, x3 = u.rx, C = u.ry, A2 = x3 * h, D = C * h;
      e3.moveTo(v4 - x3, m3), e3.bezierCurveTo(v4 - x3, m3 - D, v4 - A2, m3 - C, v4, m3 - C), e3.bezierCurveTo(v4 + A2, m3 - C, v4 + x3, m3 - D, v4 + x3, m3), e3.bezierCurveTo(v4 + x3, m3 + D, v4 + A2, m3 + C, v4, m3 + C), e3.bezierCurveTo(v4 - A2, m3 + C, v4 - x3, m3 + D, v4 - x3, m3), e3.closePath();
    }, r3;
  }(Nl);
  tct.prototype.type = "ellipse";
  var U3e = tct, nct = Math.PI, _Ee = nct * 2, rN = Math.sin, Az = Math.cos, wcn = Math.acos, p1 = Math.atan2, ant = Math.abs, BZ = Math.sqrt, wZ = Math.max, EA = Math.min, sM = 1e-4;
  function Scn(l3, r3, e3, u, h, v4, m3, x3) {
    var C = e3 - l3, A2 = u - r3, D = m3 - h, P = x3 - v4, N = P * C - D * A2;
    if (!(N * N < sM))
      return N = (D * (r3 - v4) - P * (l3 - h)) / N, [l3 + N * C, r3 + N * A2];
  }
  function xce(l3, r3, e3, u, h, v4, m3) {
    var x3 = l3 - e3, C = r3 - u, A2 = (m3 ? v4 : -v4) / BZ(x3 * x3 + C * C), D = A2 * C, P = -A2 * x3, N = l3 + D, j = r3 + P, W = e3 + D, K = u + P, te = (N + W) / 2, ne = (j + K) / 2, ce = W - N, me = K - j, ve = ce * ce + me * me, Be = h - v4, Oe = N * K - W * j, We = (me < 0 ? -1 : 1) * BZ(wZ(0, Be * Be * ve - Oe * Oe)), Ue = (Oe * me - ce * We) / ve, qe = (-Oe * ce - me * We) / ve, Ze = (Oe * me + ce * We) / ve, ct = (-Oe * ce + me * We) / ve, _t = Ue - te, pt = qe - ne, zt = Ze - te, Zt = ct - ne;
    return _t * _t + pt * pt > zt * zt + Zt * Zt && (Ue = Ze, qe = ct), { cx: Ue, cy: qe, x0: -D, y0: -P, x1: Ue * (h / Be - 1), y1: qe * (h / Be - 1) };
  }
  function Ccn(l3) {
    var r3;
    if (Ni(l3)) {
      var e3 = l3.length;
      if (!e3)
        return l3;
      e3 === 1 ? r3 = [l3[0], l3[0], 0, 0] : e3 === 2 ? r3 = [l3[0], l3[0], l3[1], l3[1]] : e3 === 3 ? r3 = l3.concat(l3[2]) : r3 = l3;
    } else
      r3 = [l3, l3, l3, l3];
    return r3;
  }
  function Mcn(l3, r3) {
    var e3, u = wZ(r3.r, 0), h = wZ(r3.r0 || 0, 0), v4 = u > 0, m3 = h > 0;
    if (!(!v4 && !m3)) {
      if (v4 || (u = h, h = 0), h > u) {
        var x3 = u;
        u = h, h = x3;
      }
      var C = r3.startAngle, A2 = r3.endAngle;
      if (!(isNaN(C) || isNaN(A2))) {
        var D = r3.cx, P = r3.cy, N = !!r3.clockwise, j = ant(A2 - C), W = j > _Ee && j % _Ee;
        if (W > sM && (j = W), !(u > sM))
          l3.moveTo(D, P);
        else if (j > _Ee - sM)
          l3.moveTo(D + u * Az(C), P + u * rN(C)), l3.arc(D, P, u, C, A2, !N), h > sM && (l3.moveTo(D + h * Az(A2), P + h * rN(A2)), l3.arc(D, P, h, A2, C, N));
        else {
          var K = void 0, te = void 0, ne = void 0, ce = void 0, me = void 0, ve = void 0, Be = void 0, Oe = void 0, We = void 0, Ue = void 0, qe = void 0, Ze = void 0, ct = void 0, _t = void 0, pt = void 0, zt = void 0, Zt = u * Az(C), Ft = u * rN(C), Kn = h * Az(A2), hn = h * rN(A2), xn = j > sM;
          if (xn) {
            var zn = r3.cornerRadius;
            zn && (e3 = Ccn(zn), K = e3[0], te = e3[1], ne = e3[2], ce = e3[3]);
            var or = ant(u - h) / 2;
            if (me = EA(or, ne), ve = EA(or, ce), Be = EA(or, K), Oe = EA(or, te), qe = We = wZ(me, ve), Ze = Ue = wZ(Be, Oe), (We > sM || Ue > sM) && (ct = u * Az(A2), _t = u * rN(A2), pt = h * Az(C), zt = h * rN(C), j < nct)) {
              var vr = Scn(Zt, Ft, pt, zt, ct, _t, Kn, hn);
              if (vr) {
                var la = Zt - vr[0], Ba = Ft - vr[1], Lo = ct - vr[0], Ao = _t - vr[1], oo = 1 / rN(wcn((la * Lo + Ba * Ao) / (BZ(la * la + Ba * Ba) * BZ(Lo * Lo + Ao * Ao))) / 2), Pa = BZ(vr[0] * vr[0] + vr[1] * vr[1]);
                qe = EA(We, (u - Pa) / (oo + 1)), Ze = EA(Ue, (h - Pa) / (oo - 1));
              }
            }
          }
          if (!xn)
            l3.moveTo(D + Zt, P + Ft);
          else if (qe > sM) {
            var fo = EA(ne, qe), Co = EA(ce, qe), $a = xce(pt, zt, Zt, Ft, u, fo, N), Yo = xce(ct, _t, Kn, hn, u, Co, N);
            l3.moveTo(D + $a.cx + $a.x0, P + $a.cy + $a.y0), qe < We && fo === Co ? l3.arc(D + $a.cx, P + $a.cy, qe, p1($a.y0, $a.x0), p1(Yo.y0, Yo.x0), !N) : (fo > 0 && l3.arc(D + $a.cx, P + $a.cy, fo, p1($a.y0, $a.x0), p1($a.y1, $a.x1), !N), l3.arc(D, P, u, p1($a.cy + $a.y1, $a.cx + $a.x1), p1(Yo.cy + Yo.y1, Yo.cx + Yo.x1), !N), Co > 0 && l3.arc(D + Yo.cx, P + Yo.cy, Co, p1(Yo.y1, Yo.x1), p1(Yo.y0, Yo.x0), !N));
          } else
            l3.moveTo(D + Zt, P + Ft), l3.arc(D, P, u, C, A2, !N);
          if (!(h > sM) || !xn)
            l3.lineTo(D + Kn, P + hn);
          else if (Ze > sM) {
            var fo = EA(K, Ze), Co = EA(te, Ze), $a = xce(Kn, hn, ct, _t, h, -Co, N), Yo = xce(Zt, Ft, pt, zt, h, -fo, N);
            l3.lineTo(D + $a.cx + $a.x0, P + $a.cy + $a.y0), Ze < Ue && fo === Co ? l3.arc(D + $a.cx, P + $a.cy, Ze, p1($a.y0, $a.x0), p1(Yo.y0, Yo.x0), !N) : (Co > 0 && l3.arc(D + $a.cx, P + $a.cy, Co, p1($a.y0, $a.x0), p1($a.y1, $a.x1), !N), l3.arc(D, P, h, p1($a.cy + $a.y1, $a.cx + $a.x1), p1(Yo.cy + Yo.y1, Yo.cx + Yo.x1), N), fo > 0 && l3.arc(D + Yo.cx, P + Yo.cy, fo, p1(Yo.y1, Yo.x1), p1(Yo.y0, Yo.x0), !N));
          } else
            l3.lineTo(D + Kn, P + hn), l3.arc(D, P, h, A2, C, N);
        }
        l3.closePath();
      }
    }
  }
  var Tcn = function() {
    function l3() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
    }
    return l3;
  }(), rct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new Tcn();
    }, r3.prototype.buildPath = function(e3, u) {
      Mcn(e3, u);
    }, r3.prototype.isZeroArea = function() {
      return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
    }, r3;
  }(Nl);
  rct.prototype.type = "sector";
  var S_ = rct, Acn = function() {
    function l3() {
      this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
    }
    return l3;
  }(), ict = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new Acn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.cx, v4 = u.cy, m3 = Math.PI * 2;
      e3.moveTo(h + u.r, v4), e3.arc(h, v4, u.r, 0, m3, false), e3.moveTo(h + u.r0, v4), e3.arc(h, v4, u.r0, 0, m3, true);
    }, r3;
  }(Nl);
  ict.prototype.type = "ring";
  var Yhe = ict;
  function Icn(l3, r3, e3, u) {
    var h = [], v4 = [], m3 = [], x3 = [], C, A2, D, P;
    if (u) {
      D = [1 / 0, 1 / 0], P = [-1 / 0, -1 / 0];
      for (var N = 0, j = l3.length; N < j; N++)
        NO(D, D, l3[N]), FO(P, P, l3[N]);
      NO(D, D, u[0]), FO(P, P, u[1]);
    }
    for (var N = 0, j = l3.length; N < j; N++) {
      var W = l3[N];
      if (e3)
        C = l3[N ? N - 1 : j - 1], A2 = l3[(N + 1) % j];
      else if (N === 0 || N === j - 1) {
        h.push(n5(l3[N]));
        continue;
      } else
        C = l3[N - 1], A2 = l3[N + 1];
      IN(v4, A2, C), VIe(v4, v4, r3);
      var K = w5e(W, C), te = w5e(W, A2), ne = K + te;
      ne !== 0 && (K /= ne, te /= ne), VIe(m3, v4, -K), VIe(x3, v4, te);
      var ce = Jet([], W, m3), me = Jet([], W, x3);
      u && (FO(ce, ce, D), NO(ce, ce, P), FO(me, me, D), NO(me, me, P)), h.push(ce), h.push(me);
    }
    return e3 && h.push(h.shift()), h;
  }
  function act(l3, r3, e3) {
    var u = r3.smooth, h = r3.points;
    if (h && h.length >= 2) {
      if (u) {
        var v4 = Icn(h, u, e3, r3.smoothConstraint);
        l3.moveTo(h[0][0], h[0][1]);
        for (var m3 = h.length, x3 = 0; x3 < (e3 ? m3 : m3 - 1); x3++) {
          var C = v4[x3 * 2], A2 = v4[x3 * 2 + 1], D = h[(x3 + 1) % m3];
          l3.bezierCurveTo(C[0], C[1], A2[0], A2[1], D[0], D[1]);
        }
      } else {
        l3.moveTo(h[0][0], h[0][1]);
        for (var x3 = 1, P = h.length; x3 < P; x3++)
          l3.lineTo(h[x3][0], h[x3][1]);
      }
      e3 && l3.closePath();
    }
  }
  var Ecn = function() {
    function l3() {
      this.points = null, this.smooth = 0, this.smoothConstraint = null;
    }
    return l3;
  }(), oct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new Ecn();
    }, r3.prototype.buildPath = function(e3, u) {
      act(e3, u, true);
    }, r3;
  }(Nl);
  oct.prototype.type = "polygon";
  var C_ = oct, Dcn = function() {
    function l3() {
      this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
    }
    return l3;
  }(), sct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new Dcn();
    }, r3.prototype.buildPath = function(e3, u) {
      act(e3, u, false);
    }, r3;
  }(Nl);
  sct.prototype.type = "polyline";
  var M_ = sct, kcn = {}, Ocn = function() {
    function l3() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return l3;
  }(), lct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new Ocn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h, v4, m3, x3;
      if (this.subPixelOptimize) {
        var C = Put(kcn, u, this.style);
        h = C.x1, v4 = C.y1, m3 = C.x2, x3 = C.y2;
      } else
        h = u.x1, v4 = u.y1, m3 = u.x2, x3 = u.y2;
      var A2 = u.percent;
      A2 !== 0 && (e3.moveTo(h, v4), A2 < 1 && (m3 = h * (1 - A2) + m3 * A2, x3 = v4 * (1 - A2) + x3 * A2), e3.lineTo(m3, x3));
    }, r3.prototype.pointAt = function(e3) {
      var u = this.shape;
      return [u.x1 * (1 - e3) + u.x2 * e3, u.y1 * (1 - e3) + u.y2 * e3];
    }, r3;
  }(Nl);
  lct.prototype.type = "line";
  var ty = lct, m_ = [], Pcn = function() {
    function l3() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
    }
    return l3;
  }();
  function ont(l3, r3, e3) {
    var u = l3.cpx2, h = l3.cpy2;
    return u != null || h != null ? [(e3 ? utt : i0)(l3.x1, l3.cpx1, l3.cpx2, l3.x2, r3), (e3 ? utt : i0)(l3.y1, l3.cpy1, l3.cpy2, l3.y2, r3)] : [(e3 ? I5e : Q0)(l3.x1, l3.cpx1, l3.x2, r3), (e3 ? I5e : Q0)(l3.y1, l3.cpy1, l3.y2, r3)];
  }
  var uct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new Pcn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.x1, v4 = u.y1, m3 = u.x2, x3 = u.y2, C = u.cpx1, A2 = u.cpy1, D = u.cpx2, P = u.cpy2, N = u.percent;
      N !== 0 && (e3.moveTo(h, v4), D == null || P == null ? (N < 1 && (QZ(h, C, m3, N, m_), C = m_[1], m3 = m_[2], QZ(v4, A2, x3, N, m_), A2 = m_[1], x3 = m_[2]), e3.quadraticCurveTo(C, A2, m3, x3)) : (N < 1 && (ZO(h, C, D, m3, N, m_), C = m_[1], D = m_[2], m3 = m_[3], ZO(v4, A2, P, x3, N, m_), A2 = m_[1], P = m_[2], x3 = m_[3]), e3.bezierCurveTo(C, A2, D, P, m3, x3)));
    }, r3.prototype.pointAt = function(e3) {
      return ont(this.shape, e3, false);
    }, r3.prototype.tangentAt = function(e3) {
      var u = ont(this.shape, e3, true);
      return IJ(u, u);
    }, r3;
  }(Nl);
  uct.prototype.type = "bezier-curve";
  var Khe = uct, Lcn = function() {
    function l3() {
      this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return l3;
  }(), cct = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new Lcn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.cx, v4 = u.cy, m3 = Math.max(u.r, 0), x3 = u.startAngle, C = u.endAngle, A2 = u.clockwise, D = Math.cos(x3), P = Math.sin(x3);
      e3.moveTo(D * m3 + h, P * m3 + v4), e3.arc(h, v4, m3, x3, C, !A2);
    }, r3;
  }(Nl);
  cct.prototype.type = "arc";
  var q3e = cct, Rcn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "compound", e3;
    }
    return r3.prototype._updatePathDirty = function() {
      for (var e3 = this.shape.paths, u = this.shapeChanged(), h = 0; h < e3.length; h++)
        u = u || e3[h].shapeChanged();
      u && this.dirtyShape();
    }, r3.prototype.beforeBrush = function() {
      this._updatePathDirty();
      for (var e3 = this.shape.paths || [], u = this.getGlobalScale(), h = 0; h < e3.length; h++)
        e3[h].path || e3[h].createPathProxy(), e3[h].path.setScale(u[0], u[1], e3[h].segmentIgnoreThreshold);
    }, r3.prototype.buildPath = function(e3, u) {
      for (var h = u.paths || [], v4 = 0; v4 < h.length; v4++)
        h[v4].buildPath(e3, h[v4].shape, true);
    }, r3.prototype.afterBrush = function() {
      for (var e3 = this.shape.paths || [], u = 0; u < e3.length; u++)
        e3[u].pathUpdated();
    }, r3.prototype.getBoundingRect = function() {
      return this._updatePathDirty.call(this), Nl.prototype.getBoundingRect.call(this);
    }, r3;
  }(Nl), $3e = Rcn, Ncn = function() {
    function l3(r3) {
      this.colorStops = r3 || [];
    }
    return l3.prototype.addColorStop = function(r3, e3) {
      this.colorStops.push({ offset: r3, color: e3 });
    }, l3;
  }(), fct = Ncn, Fcn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4, m3, x3) {
      var C = l3.call(this, m3) || this;
      return C.x = e3 == null ? 0 : e3, C.y = u == null ? 0 : u, C.x2 = h == null ? 1 : h, C.y2 = v4 == null ? 0 : v4, C.type = "linear", C.global = x3 || false, C;
    }
    return r3;
  }(fct), PJ = Fcn, Vcn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4, m3) {
      var x3 = l3.call(this, v4) || this;
      return x3.x = e3 == null ? 0.5 : e3, x3.y = u == null ? 0.5 : u, x3.r = h == null ? 0.5 : h, x3.type = "radial", x3.global = m3 || false, x3;
    }
    return r3;
  }(fct), hct = Vcn, iN = [0, 0], aN = [0, 0], wce = new nl(), Sce = new nl(), Bcn = function() {
    function l3(r3, e3) {
      this._corners = [], this._axes = [], this._origin = [0, 0];
      for (var u = 0; u < 4; u++)
        this._corners[u] = new nl();
      for (var u = 0; u < 2; u++)
        this._axes[u] = new nl();
      r3 && this.fromBoundingRect(r3, e3);
    }
    return l3.prototype.fromBoundingRect = function(r3, e3) {
      var u = this._corners, h = this._axes, v4 = r3.x, m3 = r3.y, x3 = v4 + r3.width, C = m3 + r3.height;
      if (u[0].set(v4, m3), u[1].set(x3, m3), u[2].set(x3, C), u[3].set(v4, C), e3)
        for (var A2 = 0; A2 < 4; A2++)
          u[A2].transform(e3);
      nl.sub(h[0], u[1], u[0]), nl.sub(h[1], u[3], u[0]), h[0].normalize(), h[1].normalize();
      for (var A2 = 0; A2 < 2; A2++)
        this._origin[A2] = h[A2].dot(u[0]);
    }, l3.prototype.intersect = function(r3, e3) {
      var u = true, h = !e3;
      return wce.set(1 / 0, 1 / 0), Sce.set(0, 0), !this._intersectCheckOneSide(this, r3, wce, Sce, h, 1) && (u = false, h) || !this._intersectCheckOneSide(r3, this, wce, Sce, h, -1) && (u = false, h) || h || nl.copy(e3, u ? wce : Sce), u;
    }, l3.prototype._intersectCheckOneSide = function(r3, e3, u, h, v4, m3) {
      for (var x3 = true, C = 0; C < 2; C++) {
        var A2 = this._axes[C];
        if (this._getProjMinMaxOnAxis(C, r3._corners, iN), this._getProjMinMaxOnAxis(C, e3._corners, aN), iN[1] < aN[0] || iN[0] > aN[1]) {
          if (x3 = false, v4)
            return x3;
          var D = Math.abs(aN[0] - iN[1]), P = Math.abs(iN[0] - aN[1]);
          Math.min(D, P) > h.len() && (D < P ? nl.scale(h, A2, -D * m3) : nl.scale(h, A2, P * m3));
        } else if (u) {
          var D = Math.abs(aN[0] - iN[1]), P = Math.abs(iN[0] - aN[1]);
          Math.min(D, P) < u.len() && (D < P ? nl.scale(u, A2, D * m3) : nl.scale(u, A2, -P * m3));
        }
      }
      return x3;
    }, l3.prototype._getProjMinMaxOnAxis = function(r3, e3, u) {
      for (var h = this._axes[r3], v4 = this._origin, m3 = e3[0].dot(h) + v4[r3], x3 = m3, C = m3, A2 = 1; A2 < e3.length; A2++) {
        var D = e3[A2].dot(h) + v4[r3];
        x3 = Math.min(D, x3), C = Math.max(D, C);
      }
      u[0] = x3, u[1] = C;
    }, l3;
  }(), Xfe = Bcn, zcn = [], jcn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.notClear = true, e3.incremental = true, e3._displayables = [], e3._temporaryDisplayables = [], e3._cursor = 0, e3;
    }
    return r3.prototype.traverse = function(e3, u) {
      e3.call(u, this);
    }, r3.prototype.useStyle = function() {
      this.style = {};
    }, r3.prototype.getCursor = function() {
      return this._cursor;
    }, r3.prototype.innerAfterBrush = function() {
      this._cursor = this._displayables.length;
    }, r3.prototype.clearDisplaybles = function() {
      this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
    }, r3.prototype.clearTemporalDisplayables = function() {
      this._temporaryDisplayables = [];
    }, r3.prototype.addDisplayable = function(e3, u) {
      u ? this._temporaryDisplayables.push(e3) : this._displayables.push(e3), this.markRedraw();
    }, r3.prototype.addDisplayables = function(e3, u) {
      u = u || false;
      for (var h = 0; h < e3.length; h++)
        this.addDisplayable(e3[h], u);
    }, r3.prototype.getDisplayables = function() {
      return this._displayables;
    }, r3.prototype.getTemporalDisplayables = function() {
      return this._temporaryDisplayables;
    }, r3.prototype.eachPendingDisplayable = function(e3) {
      for (var u = this._cursor; u < this._displayables.length; u++)
        e3 && e3(this._displayables[u]);
      for (var u = 0; u < this._temporaryDisplayables.length; u++)
        e3 && e3(this._temporaryDisplayables[u]);
    }, r3.prototype.update = function() {
      this.updateTransform();
      for (var e3 = this._cursor; e3 < this._displayables.length; e3++) {
        var u = this._displayables[e3];
        u.parent = this, u.update(), u.parent = null;
      }
      for (var e3 = 0; e3 < this._temporaryDisplayables.length; e3++) {
        var u = this._temporaryDisplayables[e3];
        u.parent = this, u.update(), u.parent = null;
      }
    }, r3.prototype.getBoundingRect = function() {
      if (!this._rect) {
        for (var e3 = new Ml(1 / 0, 1 / 0, -1 / 0, -1 / 0), u = 0; u < this._displayables.length; u++) {
          var h = this._displayables[u], v4 = h.getBoundingRect().clone();
          h.needLocalTransform() && v4.applyTransform(h.getLocalTransform(zcn)), e3.union(v4);
        }
        this._rect = e3;
      }
      return this._rect;
    }, r3.prototype.contain = function(e3, u) {
      var h = this.transformCoordToLocal(e3, u), v4 = this.getBoundingRect();
      if (v4.contain(h[0], h[1]))
        for (var m3 = 0; m3 < this._displayables.length; m3++) {
          var x3 = this._displayables[m3];
          if (x3.contain(e3, u))
            return true;
        }
      return false;
    }, r3;
  }(x2), Gcn = jcn, pct = pc();
  function Sj(l3, r3, e3, u, h) {
    var v4;
    if (r3 && r3.ecModel) {
      var m3 = r3.ecModel.getUpdatePayload();
      v4 = m3 && m3.animation;
    }
    var x3 = r3 && r3.isAnimationEnabled(), C = l3 === "update";
    if (x3) {
      var A2 = void 0, D = void 0, P = void 0;
      u ? (A2 = dl(u.duration, 200), D = dl(u.easing, "cubicOut"), P = 0) : (A2 = r3.getShallow(C ? "animationDurationUpdate" : "animationDuration"), D = r3.getShallow(C ? "animationEasingUpdate" : "animationEasing"), P = r3.getShallow(C ? "animationDelayUpdate" : "animationDelay")), v4 && (v4.duration != null && (A2 = v4.duration), v4.easing != null && (D = v4.easing), v4.delay != null && (P = v4.delay)), Xo(P) && (P = P(e3, h)), Xo(A2) && (A2 = A2(e3));
      var N = { duration: A2 || 0, delay: P, easing: D };
      return N;
    } else
      return null;
  }
  function X3e(l3, r3, e3, u, h, v4, m3) {
    var x3 = false, C;
    Xo(h) ? (m3 = v4, v4 = h, h = null) : ls(h) && (v4 = h.cb, m3 = h.during, x3 = h.isFrom, C = h.removeOpt, h = h.dataIndex);
    var A2 = l3 === "leave";
    A2 || r3.stopAnimation("leave");
    var D = Sj(l3, u, h, A2 ? C || {} : null, u && u.getAnimationDelayParams ? u.getAnimationDelayParams(r3, h) : null);
    if (D && D.duration > 0) {
      var P = D.duration, N = D.delay, j = D.easing, W = { duration: P, delay: N || 0, easing: j, done: v4, force: !!v4 || !!m3, setToFinal: !A2, scope: l3, during: m3 };
      x3 ? r3.animateFrom(e3, W) : r3.animateTo(e3, W);
    } else
      r3.stopAnimation(), !x3 && r3.attr(e3), m3 && m3(1), v4 && v4();
  }
  function hc(l3, r3, e3, u, h, v4) {
    X3e("update", l3, r3, e3, u, h, v4);
  }
  function Np(l3, r3, e3, u, h, v4) {
    X3e("enter", l3, r3, e3, u, h, v4);
  }
  function ij(l3) {
    if (!l3.__zr)
      return true;
    for (var r3 = 0; r3 < l3.animators.length; r3++) {
      var e3 = l3.animators[r3];
      if (e3.scope === "leave")
        return true;
    }
    return false;
  }
  function JO(l3, r3, e3, u, h, v4) {
    ij(l3) || X3e("leave", l3, r3, e3, u, h, v4);
  }
  function snt(l3, r3, e3, u) {
    l3.removeTextContent(), l3.removeTextGuideLine(), JO(l3, { style: { opacity: 0 } }, r3, e3, u);
  }
  function aJ(l3, r3, e3) {
    function u() {
      l3.parent && l3.parent.remove(l3);
    }
    l3.isGroup ? l3.traverse(function(h) {
      h.isGroup || snt(h, r3, e3, u);
    }) : snt(l3, r3, e3, u);
  }
  function yM(l3) {
    pct(l3).oldStyle = l3.style;
  }
  function Hcn(l3) {
    return pct(l3).oldStyle;
  }
  var Yfe = Math.max, Kfe = Math.min, Z5e = {};
  function Wcn(l3) {
    return Nl.extend(l3);
  }
  var Ucn = mcn;
  function qcn(l3, r3) {
    return Ucn(l3, r3);
  }
  function mM(l3, r3) {
    Z5e[l3] = r3;
  }
  function Y3e(l3) {
    if (Z5e.hasOwnProperty(l3))
      return Z5e[l3];
  }
  function Zhe(l3, r3, e3, u) {
    var h = Qut(l3, r3);
    return e3 && (u === "center" && (e3 = vct(e3, h.getBoundingRect())), gct(h, e3)), h;
  }
  function dct(l3, r3, e3) {
    var u = new lm({ style: { image: l3, x: r3.x, y: r3.y, width: r3.width, height: r3.height }, onload: function(h) {
      if (e3 === "center") {
        var v4 = { width: h.width, height: h.height };
        u.setStyle(vct(r3, v4));
      }
    } });
    return u;
  }
  function vct(l3, r3) {
    var e3 = r3.width / r3.height, u = l3.height * e3, h;
    u <= l3.width ? h = l3.height : (u = l3.width, h = u / e3);
    var v4 = l3.x + l3.width / 2, m3 = l3.y + l3.height / 2;
    return { x: v4 - u / 2, y: m3 - h / 2, width: u, height: h };
  }
  var d2 = bcn;
  function gct(l3, r3) {
    if (!!l3.applyTransform) {
      var e3 = l3.getBoundingRect(), u = e3.calculateTransform(r3);
      l3.applyTransform(u);
    }
  }
  function $cn(l3) {
    return Put(l3.shape, l3.shape, l3.style), l3;
  }
  function Xcn(l3) {
    return Lut(l3.shape, l3.shape, l3.style), l3;
  }
  var Mfe = EN;
  function VN(l3, r3) {
    for (var e3 = jhe([]); l3 && l3 !== r3; )
      i5(e3, l3.getLocalTransform(), e3), l3 = l3.parent;
    return e3;
  }
  function vM(l3, r3, e3) {
    return r3 && !m1(r3) && (r3 = QD.getLocalTransform(r3)), e3 && (r3 = _j([], r3)), am([], l3, r3);
  }
  function Jhe(l3, r3, e3) {
    var u = r3[4] === 0 || r3[5] === 0 || r3[0] === 0 ? 1 : Math.abs(2 * r3[4] / r3[0]), h = r3[4] === 0 || r3[5] === 0 || r3[2] === 0 ? 1 : Math.abs(2 * r3[4] / r3[2]), v4 = [l3 === "left" ? -u : l3 === "right" ? u : 0, l3 === "top" ? -h : l3 === "bottom" ? h : 0];
    return v4 = vM(v4, r3, e3), Math.abs(v4[0]) > Math.abs(v4[1]) ? v4[0] > 0 ? "right" : "left" : v4[1] > 0 ? "bottom" : "top";
  }
  function lnt(l3) {
    return !l3.isGroup;
  }
  function Ycn(l3) {
    return l3.shape != null;
  }
  function LJ(l3, r3, e3) {
    if (!l3 || !r3)
      return;
    function u(m3) {
      var x3 = {};
      return m3.traverse(function(C) {
        lnt(C) && C.anid && (x3[C.anid] = C);
      }), x3;
    }
    function h(m3) {
      var x3 = { x: m3.x, y: m3.y, rotation: m3.rotation };
      return Ycn(m3) && (x3.shape = fi({}, m3.shape)), x3;
    }
    var v4 = u(l3);
    r3.traverse(function(m3) {
      if (lnt(m3) && m3.anid) {
        var x3 = v4[m3.anid];
        if (x3) {
          var C = h(m3);
          m3.attr(h(x3)), hc(m3, C, e3, Ps(m3).dataIndex);
        }
      }
    });
  }
  function yct(l3, r3) {
    return Bi(l3, function(e3) {
      var u = e3[0];
      u = Yfe(u, r3.x), u = Kfe(u, r3.x + r3.width);
      var h = e3[1];
      return h = Yfe(h, r3.y), h = Kfe(h, r3.y + r3.height), [u, h];
    });
  }
  function Kcn(l3, r3) {
    var e3 = Yfe(l3.x, r3.x), u = Kfe(l3.x + l3.width, r3.x + r3.width), h = Yfe(l3.y, r3.y), v4 = Kfe(l3.y + l3.height, r3.y + r3.height);
    if (u >= e3 && v4 >= h)
      return { x: e3, y: h, width: u - e3, height: v4 - h };
  }
  function RJ(l3, r3, e3) {
    var u = fi({ rectHover: true }, r3), h = u.style = { strokeNoScale: true };
    if (e3 = e3 || { x: -1, y: -1, width: 2, height: 2 }, l3)
      return l3.indexOf("image://") === 0 ? (h.image = l3.slice(8), ns(h, e3), new lm(u)) : Zhe(l3.replace("path://", ""), u, e3, "center");
  }
  function SZ(l3, r3, e3, u, h) {
    for (var v4 = 0, m3 = h[h.length - 1]; v4 < h.length; v4++) {
      var x3 = h[v4];
      if (mct(l3, r3, e3, u, x3[0], x3[1], m3[0], m3[1]))
        return true;
      m3 = x3;
    }
  }
  function mct(l3, r3, e3, u, h, v4, m3, x3) {
    var C = e3 - l3, A2 = u - r3, D = m3 - h, P = x3 - v4, N = xEe(D, P, C, A2);
    if (Zcn(N))
      return false;
    var j = l3 - h, W = r3 - v4, K = xEe(j, W, C, A2) / N;
    if (K < 0 || K > 1)
      return false;
    var te = xEe(j, W, D, P) / N;
    return !(te < 0 || te > 1);
  }
  function xEe(l3, r3, e3, u) {
    return l3 * u - e3 * r3;
  }
  function Zcn(l3) {
    return l3 <= 1e-6 && l3 >= -1e-6;
  }
  function Cj(l3) {
    var r3 = l3.itemTooltipOption, e3 = l3.componentModel, u = l3.itemName, h = qa(r3) ? { formatter: r3 } : r3, v4 = e3.mainType, m3 = e3.componentIndex, x3 = { componentType: v4, name: u, $vars: ["name"] };
    x3[v4 + "Index"] = m3;
    var C = l3.formatterParamsExtra;
    C && mt(yu(C), function(D) {
      vo(x3, D) || (x3[D] = C[D], x3.$vars.push(D));
    });
    var A2 = Ps(l3.el);
    A2.componentMainType = v4, A2.componentIndex = m3, A2.tooltipConfig = { name: u, option: ns({ content: u, formatterParams: x3 }, h) };
  }
  function unt(l3, r3) {
    var e3;
    l3.isGroup && (e3 = r3(l3)), e3 || l3.traverse(r3);
  }
  function oP(l3, r3) {
    if (l3)
      if (Ni(l3))
        for (var e3 = 0; e3 < l3.length; e3++)
          unt(l3[e3], r3);
      else
        unt(l3, r3);
  }
  mM("circle", YA);
  mM("ellipse", U3e);
  mM("sector", S_);
  mM("ring", Yhe);
  mM("polygon", C_);
  mM("polyline", M_);
  mM("rect", Ju);
  mM("line", ty);
  mM("bezierCurve", Khe);
  mM("arc", q3e);
  var NJ = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: hc, initProps: Np, removeElement: JO, removeElementWithFadeOut: aJ, isElementRemoved: ij, extendShape: Wcn, extendPath: qcn, registerShape: mM, getShapeClass: Y3e, makePath: Zhe, makeImage: dct, mergePath: d2, resizePath: gct, subPixelOptimizeLine: $cn, subPixelOptimizeRect: Xcn, subPixelOptimize: Mfe, getTransform: VN, applyTransform: vM, transformDirection: Jhe, groupTransition: LJ, clipPointsByRect: yct, clipRectByRect: Kcn, createIcon: RJ, linePolygonIntersect: SZ, lineLineIntersect: mct, setTooltipConfig: Cj, traverseElements: oP, Group: Cs, Image: lm, Text: Ec, Circle: YA, Ellipse: U3e, Sector: S_, Ring: Yhe, Polygon: C_, Polyline: M_, Rect: Ju, Line: ty, BezierCurve: Khe, Arc: q3e, IncrementalDisplayable: Gcn, CompoundPath: $3e, LinearGradient: PJ, RadialGradient: hct, BoundingRect: Ml, OrientedBoundingRect: Xfe, Point: nl, Path: Nl }, Symbol.toStringTag, { value: "Module" })), Qhe = {};
  function bct(l3, r3) {
    for (var e3 = 0; e3 < bb.length; e3++) {
      var u = bb[e3], h = r3[u], v4 = l3.ensureState(u);
      v4.style = v4.style || {}, v4.style.text = h;
    }
    var m3 = l3.currentStates.slice();
    l3.clearStates(true), l3.setStyle({ text: r3.normal }), l3.useStates(m3, true);
  }
  function J5e(l3, r3, e3) {
    var u = l3.labelFetcher, h = l3.labelDataIndex, v4 = l3.labelDimIndex, m3 = r3.normal, x3;
    u && (x3 = u.getFormattedLabel(h, "normal", null, v4, m3 && m3.get("formatter"), e3 != null ? { interpolatedValue: e3 } : null)), x3 == null && (x3 = Xo(l3.defaultText) ? l3.defaultText(h, l3, e3) : l3.defaultText);
    for (var C = { normal: x3 }, A2 = 0; A2 < bb.length; A2++) {
      var D = bb[A2], P = r3[D];
      C[D] = dl(u ? u.getFormattedLabel(h, D, null, v4, P && P.get("formatter")) : null, x3);
    }
    return C;
  }
  function _1(l3, r3, e3, u) {
    e3 = e3 || Qhe;
    for (var h = l3 instanceof Ec, v4 = false, m3 = 0; m3 < rJ.length; m3++) {
      var x3 = r3[rJ[m3]];
      if (x3 && x3.getShallow("show")) {
        v4 = true;
        break;
      }
    }
    var C = h ? l3 : l3.getTextContent();
    if (v4) {
      h || (C || (C = new Ec(), l3.setTextContent(C)), l3.stateProxy && (C.stateProxy = l3.stateProxy));
      var A2 = J5e(e3, r3), D = r3.normal, P = !!D.getShallow("show"), N = ov(D, u && u.normal, e3, false, !h);
      N.text = A2.normal, h || l3.setTextConfig(Zfe(D, e3, false));
      for (var m3 = 0; m3 < bb.length; m3++) {
        var j = bb[m3], x3 = r3[j];
        if (x3) {
          var W = C.ensureState(j), K = !!dl(x3.getShallow("show"), P);
          if (K !== P && (W.ignore = !K), W.style = ov(x3, u && u[j], e3, true, !h), W.style.text = A2[j], !h) {
            var te = l3.ensureState(j);
            te.textConfig = Zfe(x3, e3, true);
          }
        }
      }
      C.silent = !!D.getShallow("silent"), C.style.x != null && (N.x = C.style.x), C.style.y != null && (N.y = C.style.y), C.ignore = !P, C.useStyle(N), C.dirty(), e3.enableTextSetter && (Mj(C).setLabelText = function(ne) {
        var ce = J5e(e3, r3, ne);
        bct(C, ce);
      });
    } else
      C && (C.ignore = true);
    l3.dirty();
  }
  function ny(l3, r3) {
    r3 = r3 || "label";
    for (var e3 = { normal: l3.getModel(r3) }, u = 0; u < bb.length; u++) {
      var h = bb[u];
      e3[h] = l3.getModel([h, r3]);
    }
    return e3;
  }
  function ov(l3, r3, e3, u, h) {
    var v4 = {};
    return Jcn(v4, l3, e3, u, h), r3 && fi(v4, r3), v4;
  }
  function Zfe(l3, r3, e3) {
    r3 = r3 || {};
    var u = {}, h, v4 = l3.getShallow("rotate"), m3 = dl(l3.getShallow("distance"), e3 ? null : 5), x3 = l3.getShallow("offset");
    return h = l3.getShallow("position") || (e3 ? null : "inside"), h === "outside" && (h = r3.defaultOutsidePosition || "top"), h != null && (u.position = h), x3 != null && (u.offset = x3), v4 != null && (v4 *= Math.PI / 180, u.rotation = v4), m3 != null && (u.distance = m3), u.outsideFill = l3.get("color") === "inherit" ? r3.inheritColor || null : "auto", u;
  }
  function Jcn(l3, r3, e3, u, h) {
    e3 = e3 || Qhe;
    var v4 = r3.ecModel, m3 = v4 && v4.option.textStyle, x3 = Qcn(r3), C;
    if (x3) {
      C = {};
      for (var A2 in x3)
        if (x3.hasOwnProperty(A2)) {
          var D = r3.getModel(["rich", A2]);
          pnt(C[A2] = {}, D, m3, e3, u, h, false, true);
        }
    }
    C && (l3.rich = C);
    var P = r3.get("overflow");
    P && (l3.overflow = P);
    var N = r3.get("minMargin");
    N != null && (l3.margin = N), pnt(l3, r3, m3, e3, u, h, true, false);
  }
  function Qcn(l3) {
    for (var r3; l3 && l3 !== l3.ecModel; ) {
      var e3 = (l3.option || Qhe).rich;
      if (e3) {
        r3 = r3 || {};
        for (var u = yu(e3), h = 0; h < u.length; h++) {
          var v4 = u[h];
          r3[v4] = 1;
        }
      }
      l3 = l3.parentModel;
    }
    return r3;
  }
  var cnt = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], fnt = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], hnt = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
  function pnt(l3, r3, e3, u, h, v4, m3, x3) {
    e3 = !h && e3 || Qhe;
    var C = u && u.inheritColor, A2 = r3.getShallow("color"), D = r3.getShallow("textBorderColor"), P = dl(r3.getShallow("opacity"), e3.opacity);
    (A2 === "inherit" || A2 === "auto") && (C ? A2 = C : A2 = null), (D === "inherit" || D === "auto") && (C ? D = C : D = null), v4 || (A2 = A2 || e3.color, D = D || e3.textBorderColor), A2 != null && (l3.fill = A2), D != null && (l3.stroke = D);
    var N = dl(r3.getShallow("textBorderWidth"), e3.textBorderWidth);
    N != null && (l3.lineWidth = N);
    var j = dl(r3.getShallow("textBorderType"), e3.textBorderType);
    j != null && (l3.lineDash = j);
    var W = dl(r3.getShallow("textBorderDashOffset"), e3.textBorderDashOffset);
    W != null && (l3.lineDashOffset = W), !h && P == null && !x3 && (P = u && u.defaultOpacity), P != null && (l3.opacity = P), !h && !v4 && l3.fill == null && u.inheritColor && (l3.fill = u.inheritColor);
    for (var K = 0; K < cnt.length; K++) {
      var te = cnt[K], ne = dl(r3.getShallow(te), e3[te]);
      ne != null && (l3[te] = ne);
    }
    for (var K = 0; K < fnt.length; K++) {
      var te = fnt[K], ne = r3.getShallow(te);
      ne != null && (l3[te] = ne);
    }
    if (l3.verticalAlign == null) {
      var ce = r3.getShallow("baseline");
      ce != null && (l3.verticalAlign = ce);
    }
    if (!m3 || !u.disableBox) {
      for (var K = 0; K < hnt.length; K++) {
        var te = hnt[K], ne = r3.getShallow(te);
        ne != null && (l3[te] = ne);
      }
      var me = r3.getShallow("borderType");
      me != null && (l3.borderDash = me), (l3.backgroundColor === "auto" || l3.backgroundColor === "inherit") && C && (l3.backgroundColor = C), (l3.borderColor === "auto" || l3.borderColor === "inherit") && C && (l3.borderColor = C);
    }
  }
  function _ct(l3, r3) {
    var e3 = r3 && r3.getModel("textStyle");
    return hM([l3.fontStyle || e3 && e3.getShallow("fontStyle") || "", l3.fontWeight || e3 && e3.getShallow("fontWeight") || "", (l3.fontSize || e3 && e3.getShallow("fontSize") || 12) + "px", l3.fontFamily || e3 && e3.getShallow("fontFamily") || "sans-serif"].join(" "));
  }
  var Mj = pc();
  function xct(l3, r3, e3, u) {
    if (!!l3) {
      var h = Mj(l3);
      h.prevValue = h.value, h.value = e3;
      var v4 = r3.normal;
      h.valueAnimation = v4.get("valueAnimation"), h.valueAnimation && (h.precision = v4.get("precision"), h.defaultInterpolatedText = u, h.statesModels = r3);
    }
  }
  function wct(l3, r3, e3, u, h) {
    var v4 = Mj(l3);
    if (!v4.valueAnimation || v4.prevValue === v4.value)
      return;
    var m3 = v4.defaultInterpolatedText, x3 = dl(v4.interpolatedValue, v4.prevValue), C = v4.value;
    function A2(D) {
      var P = Sut(e3, v4.precision, x3, C, D);
      v4.interpolatedValue = D === 1 ? null : P;
      var N = J5e({ labelDataIndex: r3, labelFetcher: h, defaultText: m3 ? m3(P) : P + "" }, v4.statesModels, P);
      bct(l3, N);
    }
    l3.percent = 0, (v4.prevValue == null ? Np : hc)(l3, { percent: 1 }, u, r3, null, A2);
  }
  var efn = ["textStyle", "color"], wEe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], SEe = new Ec(), tfn = function() {
    function l3() {
    }
    return l3.prototype.getTextColor = function(r3) {
      var e3 = this.ecModel;
      return this.getShallow("color") || (!r3 && e3 ? e3.get(efn) : null);
    }, l3.prototype.getFont = function() {
      return _ct({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
    }, l3.prototype.getTextRect = function(r3) {
      for (var e3 = { text: r3, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, u = 0; u < wEe.length; u++)
        e3[wEe[u]] = this.getShallow(wEe[u]);
      return SEe.useStyle(e3), SEe.update(), SEe.getBoundingRect();
    }, l3;
  }(), nfn = tfn, Sct = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], rfn = UN(Sct), ifn = function() {
    function l3() {
    }
    return l3.prototype.getLineStyle = function(r3) {
      return rfn(this, r3);
    }, l3;
  }(), Cct = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], afn = UN(Cct), ofn = function() {
    function l3() {
    }
    return l3.prototype.getItemStyle = function(r3, e3) {
      return afn(this, r3, e3);
    }, l3;
  }(), JN = function() {
    function l3(r3, e3, u) {
      this.parentModel = e3, this.ecModel = u, this.option = r3;
    }
    return l3.prototype.init = function(r3, e3, u) {
      for (var h = [], v4 = 3; v4 < arguments.length; v4++)
        h[v4 - 3] = arguments[v4];
    }, l3.prototype.mergeOption = function(r3, e3) {
      ol(this.option, r3, true);
    }, l3.prototype.get = function(r3, e3) {
      return r3 == null ? this.option : this._doGet(this.parsePath(r3), !e3 && this.parentModel);
    }, l3.prototype.getShallow = function(r3, e3) {
      var u = this.option, h = u == null ? u : u[r3];
      if (h == null && !e3) {
        var v4 = this.parentModel;
        v4 && (h = v4.getShallow(r3));
      }
      return h;
    }, l3.prototype.getModel = function(r3, e3) {
      var u = r3 != null, h = u ? this.parsePath(r3) : null, v4 = u ? this._doGet(h) : this.option;
      return e3 = e3 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(h)), new l3(v4, e3, this.ecModel);
    }, l3.prototype.isEmpty = function() {
      return this.option == null;
    }, l3.prototype.restoreData = function() {
    }, l3.prototype.clone = function() {
      var r3 = this.constructor;
      return new r3(bs(this.option));
    }, l3.prototype.parsePath = function(r3) {
      return typeof r3 == "string" ? r3.split(".") : r3;
    }, l3.prototype.resolveParentPath = function(r3) {
      return r3;
    }, l3.prototype.isAnimationEnabled = function() {
      if (!Fc.node && this.option) {
        if (this.option.animation != null)
          return !!this.option.animation;
        if (this.parentModel)
          return this.parentModel.isAnimationEnabled();
      }
    }, l3.prototype._doGet = function(r3, e3) {
      var u = this.option;
      if (!r3)
        return u;
      for (var h = 0; h < r3.length && !(!!r3[h] && (u = u && typeof u == "object" ? u[r3[h]] : null, u == null)); h++)
        ;
      return u == null && e3 && (u = e3._doGet(this.resolveParentPath(r3), e3.parentModel)), u;
    }, l3;
  }();
  V3e(JN);
  run(JN);
  Fv(JN, ifn);
  Fv(JN, ofn);
  Fv(JN, lun);
  Fv(JN, nfn);
  var Bh = JN, sfn = Math.round(Math.random() * 10);
  function Tj(l3) {
    return [l3 || "", sfn++].join("_");
  }
  function lfn(l3) {
    var r3 = {};
    l3.registerSubTypeDefaulter = function(e3, u) {
      var h = FA(e3);
      r3[h.main] = u;
    }, l3.determineSubType = function(e3, u) {
      var h = u.type;
      if (!h) {
        var v4 = FA(e3).main;
        l3.hasSubTypes(e3) && r3[v4] && (h = r3[v4](u));
      }
      return h;
    };
  }
  function ufn(l3, r3) {
    l3.topologicalTravel = function(v4, m3, x3, C) {
      if (!v4.length)
        return;
      var A2 = e3(m3), D = A2.graph, P = A2.noEntryList, N = {};
      for (mt(v4, function(ce) {
        N[ce] = true;
      }); P.length; ) {
        var j = P.pop(), W = D[j], K = !!N[j];
        K && (x3.call(C, j, W.originalDeps.slice()), delete N[j]), mt(W.successor, K ? ne : te);
      }
      mt(N, function() {
        var ce = "";
        throw new Error(ce);
      });
      function te(ce) {
        D[ce].entryCount--, D[ce].entryCount === 0 && P.push(ce);
      }
      function ne(ce) {
        N[ce] = true, te(ce);
      }
    };
    function e3(v4) {
      var m3 = {}, x3 = [];
      return mt(v4, function(C) {
        var A2 = u(m3, C), D = A2.originalDeps = r3(C), P = h(D, v4);
        A2.entryCount = P.length, A2.entryCount === 0 && x3.push(C), mt(P, function(N) {
          Cl(A2.predecessor, N) < 0 && A2.predecessor.push(N);
          var j = u(m3, N);
          Cl(j.successor, N) < 0 && j.successor.push(C);
        });
      }), { graph: m3, noEntryList: x3 };
    }
    function u(v4, m3) {
      return v4[m3] || (v4[m3] = { predecessor: [], successor: [] }), v4[m3];
    }
    function h(v4, m3) {
      var x3 = [];
      return mt(v4, function(C) {
        Cl(m3, C) >= 0 && x3.push(C);
      }), x3;
    }
  }
  function sP(l3, r3) {
    return ol(ol({}, l3, true), r3, true);
  }
  var cfn = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, ffn = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, Jfe = "ZH", K3e = "EN", oJ = K3e, Tfe = {}, Z3e = {}, Mct = Fc.domSupported ? function() {
    var l3 = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
    return l3.indexOf(Jfe) > -1 ? Jfe : oJ;
  }() : oJ;
  function Tct(l3, r3) {
    l3 = l3.toUpperCase(), Z3e[l3] = new Bh(r3), Tfe[l3] = r3;
  }
  function hfn(l3) {
    if (qa(l3)) {
      var r3 = Tfe[l3.toUpperCase()] || {};
      return l3 === Jfe || l3 === K3e ? bs(r3) : ol(bs(r3), bs(Tfe[oJ]), false);
    } else
      return ol(bs(l3), bs(Tfe[oJ]), false);
  }
  function Q5e(l3) {
    return Z3e[l3];
  }
  function pfn() {
    return Z3e[oJ];
  }
  Tct(K3e, cfn);
  Tct(Jfe, ffn);
  var J3e = 1e3, Q3e = J3e * 60, zZ = Q3e * 60, v22 = zZ * 24, dnt = v22 * 365, CZ = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, Cce = "{yyyy}-{MM}-{dd}", vnt = { year: "{yyyy}", month: "{yyyy}-{MM}", day: Cce, hour: Cce + " " + CZ.hour, minute: Cce + " " + CZ.minute, second: Cce + " " + CZ.second, millisecond: CZ.none }, CEe = ["year", "month", "day", "hour", "minute", "second", "millisecond"], Act = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
  function oN(l3, r3) {
    return l3 += "", "0000".substr(0, r3 - l3.length) + l3;
  }
  function aj(l3) {
    switch (l3) {
      case "half-year":
      case "quarter":
        return "month";
      case "week":
      case "half-week":
        return "day";
      case "half-day":
      case "quarter-day":
        return "hour";
      default:
        return l3;
    }
  }
  function dfn(l3) {
    return l3 === aj(l3);
  }
  function vfn(l3) {
    switch (l3) {
      case "year":
      case "month":
        return "day";
      case "millisecond":
        return "millisecond";
      default:
        return "second";
    }
  }
  function epe(l3, r3, e3, u) {
    var h = $A(l3), v4 = h[eOe(e3)](), m3 = h[oj(e3)]() + 1, x3 = Math.floor((m3 - 1) / 4) + 1, C = h[tpe(e3)](), A2 = h["get" + (e3 ? "UTC" : "") + "Day"](), D = h[sJ(e3)](), P = (D - 1) % 12 + 1, N = h[npe(e3)](), j = h[rpe(e3)](), W = h[ipe(e3)](), K = u instanceof Bh ? u : Q5e(u || Mct) || pfn(), te = K.getModel("time"), ne = te.get("month"), ce = te.get("monthAbbr"), me = te.get("dayOfWeek"), ve = te.get("dayOfWeekAbbr");
    return (r3 || "").replace(/{yyyy}/g, v4 + "").replace(/{yy}/g, v4 % 100 + "").replace(/{Q}/g, x3 + "").replace(/{MMMM}/g, ne[m3 - 1]).replace(/{MMM}/g, ce[m3 - 1]).replace(/{MM}/g, oN(m3, 2)).replace(/{M}/g, m3 + "").replace(/{dd}/g, oN(C, 2)).replace(/{d}/g, C + "").replace(/{eeee}/g, me[A2]).replace(/{ee}/g, ve[A2]).replace(/{e}/g, A2 + "").replace(/{HH}/g, oN(D, 2)).replace(/{H}/g, D + "").replace(/{hh}/g, oN(P + "", 2)).replace(/{h}/g, P + "").replace(/{mm}/g, oN(N, 2)).replace(/{m}/g, N + "").replace(/{ss}/g, oN(j, 2)).replace(/{s}/g, j + "").replace(/{SSS}/g, oN(W, 3)).replace(/{S}/g, W + "");
  }
  function gfn(l3, r3, e3, u, h) {
    var v4 = null;
    if (qa(e3))
      v4 = e3;
    else if (Xo(e3))
      v4 = e3(l3.value, r3, { level: l3.level });
    else {
      var m3 = fi({}, CZ);
      if (l3.level > 0)
        for (var x3 = 0; x3 < CEe.length; ++x3)
          m3[CEe[x3]] = "{primary|" + m3[CEe[x3]] + "}";
      var C = e3 ? e3.inherit === false ? e3 : ns(e3, m3) : m3, A2 = Ict(l3.value, h);
      if (C[A2])
        v4 = C[A2];
      else if (C.inherit) {
        for (var D = Act.indexOf(A2), x3 = D - 1; x3 >= 0; --x3)
          if (C[A2]) {
            v4 = C[A2];
            break;
          }
        v4 = v4 || m3.none;
      }
      if (Ni(v4)) {
        var P = l3.level == null ? 0 : l3.level >= 0 ? l3.level : v4.length + l3.level;
        P = Math.min(P, v4.length - 1), v4 = v4[P];
      }
    }
    return epe(new Date(l3.value), v4, h, u);
  }
  function Ict(l3, r3) {
    var e3 = $A(l3), u = e3[oj(r3)]() + 1, h = e3[tpe(r3)](), v4 = e3[sJ(r3)](), m3 = e3[npe(r3)](), x3 = e3[rpe(r3)](), C = e3[ipe(r3)](), A2 = C === 0, D = A2 && x3 === 0, P = D && m3 === 0, N = P && v4 === 0, j = N && h === 1, W = j && u === 1;
    return W ? "year" : j ? "month" : N ? "day" : P ? "hour" : D ? "minute" : A2 ? "second" : "millisecond";
  }
  function gnt(l3, r3, e3) {
    var u = Vc(l3) ? $A(l3) : l3;
    switch (r3 = r3 || Ict(l3, e3), r3) {
      case "year":
        return u[eOe(e3)]();
      case "half-year":
        return u[oj(e3)]() >= 6 ? 1 : 0;
      case "quarter":
        return Math.floor((u[oj(e3)]() + 1) / 4);
      case "month":
        return u[oj(e3)]();
      case "day":
        return u[tpe(e3)]();
      case "half-day":
        return u[sJ(e3)]() / 24;
      case "hour":
        return u[sJ(e3)]();
      case "minute":
        return u[npe(e3)]();
      case "second":
        return u[rpe(e3)]();
      case "millisecond":
        return u[ipe(e3)]();
    }
  }
  function eOe(l3) {
    return l3 ? "getUTCFullYear" : "getFullYear";
  }
  function oj(l3) {
    return l3 ? "getUTCMonth" : "getMonth";
  }
  function tpe(l3) {
    return l3 ? "getUTCDate" : "getDate";
  }
  function sJ(l3) {
    return l3 ? "getUTCHours" : "getHours";
  }
  function npe(l3) {
    return l3 ? "getUTCMinutes" : "getMinutes";
  }
  function rpe(l3) {
    return l3 ? "getUTCSeconds" : "getSeconds";
  }
  function ipe(l3) {
    return l3 ? "getUTCMilliseconds" : "getMilliseconds";
  }
  function yfn(l3) {
    return l3 ? "setUTCFullYear" : "setFullYear";
  }
  function Ect(l3) {
    return l3 ? "setUTCMonth" : "setMonth";
  }
  function Dct(l3) {
    return l3 ? "setUTCDate" : "setDate";
  }
  function kct(l3) {
    return l3 ? "setUTCHours" : "setHours";
  }
  function Oct(l3) {
    return l3 ? "setUTCMinutes" : "setMinutes";
  }
  function Pct(l3) {
    return l3 ? "setUTCSeconds" : "setSeconds";
  }
  function Lct(l3) {
    return l3 ? "setUTCMilliseconds" : "setMilliseconds";
  }
  function Rct(l3) {
    if (!vut(l3))
      return qa(l3) ? l3 : "-";
    var r3 = (l3 + "").split(".");
    return r3[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (r3.length > 1 ? "." + r3[1] : "");
  }
  function Nct(l3, r3) {
    return l3 = (l3 || "").toLowerCase().replace(/-(.)/g, function(e3, u) {
      return u.toUpperCase();
    }), r3 && l3 && (l3 = l3.charAt(0).toUpperCase() + l3.slice(1)), l3;
  }
  var Aj = I3e, mfn = /([&<>"'])/g, bfn = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
  function Yx(l3) {
    return l3 == null ? "" : (l3 + "").replace(mfn, function(r3, e3) {
      return bfn[e3];
    });
  }
  function eke(l3, r3, e3) {
    var u = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
    function h(D) {
      return D && hM(D) ? D : "-";
    }
    function v4(D) {
      return !!(D != null && !isNaN(D) && isFinite(D));
    }
    var m3 = r3 === "time", x3 = l3 instanceof Date;
    if (m3 || x3) {
      var C = m3 ? $A(l3) : l3;
      if (isNaN(+C)) {
        if (x3)
          return "-";
      } else
        return epe(C, u, e3);
    }
    if (r3 === "ordinal")
      return m5e(l3) ? h(l3) : Vc(l3) && v4(l3) ? l3 + "" : "-";
    var A2 = c5(l3);
    return v4(A2) ? Rct(A2) : m5e(l3) ? h(l3) : typeof l3 == "boolean" ? l3 + "" : "-";
  }
  var ynt = ["a", "b", "c", "d", "e", "f", "g"], MEe = function(l3, r3) {
    return "{" + l3 + (r3 == null ? "" : r3) + "}";
  };
  function Fct(l3, r3, e3) {
    Ni(r3) || (r3 = [r3]);
    var u = r3.length;
    if (!u)
      return "";
    for (var h = r3[0].$vars || [], v4 = 0; v4 < h.length; v4++) {
      var m3 = ynt[v4];
      l3 = l3.replace(MEe(m3), MEe(m3, 0));
    }
    for (var x3 = 0; x3 < u; x3++)
      for (var C = 0; C < h.length; C++) {
        var A2 = r3[x3][h[C]];
        l3 = l3.replace(MEe(ynt[C], x3), e3 ? Yx(A2) : A2);
      }
    return l3;
  }
  function _fn(l3, r3, e3) {
    return mt(r3, function(u, h) {
      l3 = l3.replace("{" + h + "}", e3 ? Yx(u) : u);
    }), l3;
  }
  function xfn(l3, r3) {
    var e3 = qa(l3) ? { color: l3, extraCssText: r3 } : l3 || {}, u = e3.color, h = e3.type;
    r3 = e3.extraCssText;
    var v4 = e3.renderMode || "html";
    if (!u)
      return "";
    if (v4 === "html")
      return h === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + Yx(u) + ";" + (r3 || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + Yx(u) + ";" + (r3 || "") + '"></span>';
    var m3 = e3.markerId || "markerX";
    return { renderMode: v4, content: "{" + m3 + "|}  ", style: h === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: u } : { width: 10, height: 10, borderRadius: 5, backgroundColor: u } };
  }
  function $N(l3, r3) {
    return r3 = r3 || "transparent", qa(l3) ? l3 : ls(l3) && l3.colorStops && (l3.colorStops[0] || {}).color || r3;
  }
  function Qfe(l3, r3) {
    if (r3 === "_blank" || r3 === "blank") {
      var e3 = window.open();
      e3.opener = null, e3.location.href = l3;
    } else
      window.open(l3, r3);
  }
  var Afe = mt, Vct = ["left", "right", "top", "bottom", "width", "height"], kN = [["width", "left", "right"], ["height", "top", "bottom"]];
  function tOe(l3, r3, e3, u, h) {
    var v4 = 0, m3 = 0;
    u == null && (u = 1 / 0), h == null && (h = 1 / 0);
    var x3 = 0;
    r3.eachChild(function(C, A2) {
      var D = C.getBoundingRect(), P = r3.childAt(A2 + 1), N = P && P.getBoundingRect(), j, W;
      if (l3 === "horizontal") {
        var K = D.width + (N ? -N.x + D.x : 0);
        j = v4 + K, j > u || C.newline ? (v4 = 0, j = K, m3 += x3 + e3, x3 = D.height) : x3 = Math.max(x3, D.height);
      } else {
        var te = D.height + (N ? -N.y + D.y : 0);
        W = m3 + te, W > h || C.newline ? (v4 += x3 + e3, m3 = 0, W = te, x3 = D.width) : x3 = Math.max(x3, D.width);
      }
      C.newline || (C.x = v4, C.y = m3, C.markRedraw(), l3 === "horizontal" ? v4 = j + e3 : m3 = W + e3);
    });
  }
  var BN = tOe;
  Fs(tOe, "vertical");
  Fs(tOe, "horizontal");
  function wfn(l3, r3, e3) {
    var u = r3.width, h = r3.height, v4 = za(l3.left, u), m3 = za(l3.top, h), x3 = za(l3.right, u), C = za(l3.bottom, h);
    return (isNaN(v4) || isNaN(parseFloat(l3.left))) && (v4 = 0), (isNaN(x3) || isNaN(parseFloat(l3.right))) && (x3 = u), (isNaN(m3) || isNaN(parseFloat(l3.top))) && (m3 = 0), (isNaN(C) || isNaN(parseFloat(l3.bottom))) && (C = h), e3 = Aj(e3 || 0), { width: Math.max(x3 - v4 - e3[1] - e3[3], 0), height: Math.max(C - m3 - e3[0] - e3[2], 0) };
  }
  function dg(l3, r3, e3) {
    e3 = Aj(e3 || 0);
    var u = r3.width, h = r3.height, v4 = za(l3.left, u), m3 = za(l3.top, h), x3 = za(l3.right, u), C = za(l3.bottom, h), A2 = za(l3.width, u), D = za(l3.height, h), P = e3[2] + e3[0], N = e3[1] + e3[3], j = l3.aspect;
    switch (isNaN(A2) && (A2 = u - x3 - N - v4), isNaN(D) && (D = h - C - P - m3), j != null && (isNaN(A2) && isNaN(D) && (j > u / h ? A2 = u * 0.8 : D = h * 0.8), isNaN(A2) && (A2 = j * D), isNaN(D) && (D = A2 / j)), isNaN(v4) && (v4 = u - x3 - A2 - N), isNaN(m3) && (m3 = h - C - D - P), l3.left || l3.right) {
      case "center":
        v4 = u / 2 - A2 / 2 - e3[3];
        break;
      case "right":
        v4 = u - A2 - N;
        break;
    }
    switch (l3.top || l3.bottom) {
      case "middle":
      case "center":
        m3 = h / 2 - D / 2 - e3[0];
        break;
      case "bottom":
        m3 = h - D - P;
        break;
    }
    v4 = v4 || 0, m3 = m3 || 0, isNaN(A2) && (A2 = u - N - v4 - (x3 || 0)), isNaN(D) && (D = h - P - m3 - (C || 0));
    var W = new Ml(v4 + e3[3], m3 + e3[0], A2, D);
    return W.margin = e3, W;
  }
  function ape(l3, r3, e3, u, h, v4) {
    var m3 = !h || !h.hv || h.hv[0], x3 = !h || !h.hv || h.hv[1], C = h && h.boundingMode || "all";
    if (v4 = v4 || l3, v4.x = l3.x, v4.y = l3.y, !m3 && !x3)
      return false;
    var A2;
    if (C === "raw")
      A2 = l3.type === "group" ? new Ml(0, 0, +r3.width || 0, +r3.height || 0) : l3.getBoundingRect();
    else if (A2 = l3.getBoundingRect(), l3.needLocalTransform()) {
      var D = l3.getLocalTransform();
      A2 = A2.clone(), A2.applyTransform(D);
    }
    var P = dg(ns({ width: A2.width, height: A2.height }, r3), e3, u), N = m3 ? P.x - A2.x : 0, j = x3 ? P.y - A2.y : 0;
    return C === "raw" ? (v4.x = N, v4.y = j) : (v4.x += N, v4.y += j), v4 === l3 && l3.markRedraw(), true;
  }
  function Sfn(l3, r3) {
    return l3[kN[r3][0]] != null || l3[kN[r3][1]] != null && l3[kN[r3][2]] != null;
  }
  function lJ(l3) {
    var r3 = l3.layoutMode || l3.constructor.layoutMode;
    return ls(r3) ? r3 : r3 ? { type: r3 } : null;
  }
  function QO(l3, r3, e3) {
    var u = e3 && e3.ignoreSize;
    !Ni(u) && (u = [u, u]);
    var h = m3(kN[0], 0), v4 = m3(kN[1], 1);
    A2(kN[0], l3, h), A2(kN[1], l3, v4);
    function m3(D, P) {
      var N = {}, j = 0, W = {}, K = 0, te = 2;
      if (Afe(D, function(me) {
        W[me] = l3[me];
      }), Afe(D, function(me) {
        x3(r3, me) && (N[me] = W[me] = r3[me]), C(N, me) && j++, C(W, me) && K++;
      }), u[P])
        return C(r3, D[1]) ? W[D[2]] = null : C(r3, D[2]) && (W[D[1]] = null), W;
      if (K === te || !j)
        return W;
      if (j >= te)
        return N;
      for (var ne = 0; ne < D.length; ne++) {
        var ce = D[ne];
        if (!x3(N, ce) && x3(l3, ce)) {
          N[ce] = l3[ce];
          break;
        }
      }
      return N;
    }
    function x3(D, P) {
      return D.hasOwnProperty(P);
    }
    function C(D, P) {
      return D[P] != null && D[P] !== "auto";
    }
    function A2(D, P, N) {
      Afe(D, function(j) {
        P[j] = N[j];
      });
    }
  }
  function Ij(l3) {
    return Bct({}, l3);
  }
  function Bct(l3, r3) {
    return r3 && l3 && Afe(Vct, function(e3) {
      r3.hasOwnProperty(e3) && (l3[e3] = r3[e3]);
    }), l3;
  }
  var Cfn = pc(), Ej = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this, e3, u, h) || this;
      return v4.uid = Tj("ec_cpt_model"), v4;
    }
    return r3.prototype.init = function(e3, u, h) {
      this.mergeDefaultAndTheme(e3, h);
    }, r3.prototype.mergeDefaultAndTheme = function(e3, u) {
      var h = lJ(this), v4 = h ? Ij(e3) : {}, m3 = u.getTheme();
      ol(e3, m3.get(this.mainType)), ol(e3, this.getDefaultOption()), h && QO(e3, v4, h);
    }, r3.prototype.mergeOption = function(e3, u) {
      ol(this.option, e3, true);
      var h = lJ(this);
      h && QO(this.option, e3, h);
    }, r3.prototype.optionUpdated = function(e3, u) {
    }, r3.prototype.getDefaultOption = function() {
      var e3 = this.constructor;
      if (!eun(e3))
        return e3.defaultOption;
      var u = Cfn(this);
      if (!u.defaultOption) {
        for (var h = [], v4 = e3; v4; ) {
          var m3 = v4.prototype.defaultOption;
          m3 && h.push(m3), v4 = v4.superClass;
        }
        for (var x3 = {}, C = h.length - 1; C >= 0; C--)
          x3 = ol(x3, h[C], true);
        u.defaultOption = x3;
      }
      return u.defaultOption;
    }, r3.prototype.getReferringComponents = function(e3, u) {
      var h = e3 + "Index", v4 = e3 + "Id";
      return kJ(this.ecModel, e3, { index: this.get(h, true), id: this.get(v4, true) }, u);
    }, r3.prototype.getBoxLayoutParams = function() {
      var e3 = this;
      return { left: e3.get("left"), top: e3.get("top"), right: e3.get("right"), bottom: e3.get("bottom"), width: e3.get("width"), height: e3.get("height") };
    }, r3.prototype.getZLevelKey = function() {
      return "";
    }, r3.prototype.setZLevel = function(e3) {
      this.option.zlevel = e3;
    }, r3.protoInitialize = function() {
      var e3 = r3.prototype;
      e3.type = "component", e3.id = "", e3.name = "", e3.mainType = "", e3.subType = "", e3.componentIndex = 0;
    }(), r3;
  }(Bh);
  Mut(Ej, Bh);
  Hhe(Ej);
  lfn(Ej);
  ufn(Ej, Mfn);
  function Mfn(l3) {
    var r3 = [];
    return mt(Ej.getClassesByMainType(l3), function(e3) {
      r3 = r3.concat(e3.dependencies || e3.prototype.dependencies || []);
    }), r3 = Bi(r3, function(e3) {
      return FA(e3).main;
    }), l3 !== "dataset" && Cl(r3, "dataset") <= 0 && r3.unshift("dataset"), r3;
  }
  var fc = Ej, zct = "";
  typeof navigator != "undefined" && (zct = navigator.platform || "");
  var Iz = "rgba(0, 0, 0, 0.2)", Tfn = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: Iz, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: Iz, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: Iz, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: Iz, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: Iz, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: Iz, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: zct.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, jct = Ho(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), S2 = "original", b1 = "arrayRows", C2 = "objectRows", KA = "keyedColumns", $O = "typedArray", Gct = "unknown", GA = "column", Dj = "row", im = { Must: 1, Might: 2, Not: 3 }, Hct = pc();
  function Afn(l3) {
    Hct(l3).datasetMap = Ho();
  }
  function Wct(l3, r3, e3) {
    var u = {}, h = rOe(r3);
    if (!h || !l3)
      return u;
    var v4 = [], m3 = [], x3 = r3.ecModel, C = Hct(x3).datasetMap, A2 = h.uid + "_" + e3.seriesLayoutBy, D, P;
    l3 = l3.slice(), mt(l3, function(K, te) {
      var ne = ls(K) ? K : l3[te] = { name: K };
      ne.type === "ordinal" && D == null && (D = te, P = W(ne)), u[ne.name] = [];
    });
    var N = C.get(A2) || C.set(A2, { categoryWayDim: P, valueWayDim: 0 });
    mt(l3, function(K, te) {
      var ne = K.name, ce = W(K);
      if (D == null) {
        var me = N.valueWayDim;
        j(u[ne], me, ce), j(m3, me, ce), N.valueWayDim += ce;
      } else if (D === te)
        j(u[ne], 0, ce), j(v4, 0, ce);
      else {
        var me = N.categoryWayDim;
        j(u[ne], me, ce), j(m3, me, ce), N.categoryWayDim += ce;
      }
    });
    function j(K, te, ne) {
      for (var ce = 0; ce < ne; ce++)
        K.push(te + ce);
    }
    function W(K) {
      var te = K.dimsDef;
      return te ? te.length : 1;
    }
    return v4.length && (u.itemName = v4), m3.length && (u.seriesName = m3), u;
  }
  function nOe(l3, r3, e3) {
    var u = {}, h = rOe(l3);
    if (!h)
      return u;
    var v4 = r3.sourceFormat, m3 = r3.dimensionsDefine, x3;
    (v4 === C2 || v4 === KA) && mt(m3, function(D, P) {
      (ls(D) ? D.name : D) === "name" && (x3 = P);
    });
    var C = function() {
      for (var D = {}, P = {}, N = [], j = 0, W = Math.min(5, e3); j < W; j++) {
        var K = qct(r3.data, v4, r3.seriesLayoutBy, m3, r3.startIndex, j);
        N.push(K);
        var te = K === im.Not;
        if (te && D.v == null && j !== x3 && (D.v = j), (D.n == null || D.n === D.v || !te && N[D.n] === im.Not) && (D.n = j), ne(D) && N[D.n] !== im.Not)
          return D;
        te || (K === im.Might && P.v == null && j !== x3 && (P.v = j), (P.n == null || P.n === P.v) && (P.n = j));
      }
      function ne(ce) {
        return ce.v != null && ce.n != null;
      }
      return ne(D) ? D : ne(P) ? P : null;
    }();
    if (C) {
      u.value = [C.v];
      var A2 = x3 != null ? x3 : C.n;
      u.itemName = [A2], u.seriesName = [A2];
    }
    return u;
  }
  function rOe(l3) {
    var r3 = l3.get("data", true);
    if (!r3)
      return kJ(l3.ecModel, "dataset", { index: l3.get("datasetIndex", true), id: l3.get("datasetId", true) }, Lv).models[0];
  }
  function Ifn(l3) {
    return !l3.get("transform", true) && !l3.get("fromTransformResult", true) ? [] : kJ(l3.ecModel, "dataset", { index: l3.get("fromDatasetIndex", true), id: l3.get("fromDatasetId", true) }, Lv).models;
  }
  function Uct(l3, r3) {
    return qct(l3.data, l3.sourceFormat, l3.seriesLayoutBy, l3.dimensionsDefine, l3.startIndex, r3);
  }
  function qct(l3, r3, e3, u, h, v4) {
    var m3, x3 = 5;
    if (ew(l3))
      return im.Not;
    var C, A2;
    if (u) {
      var D = u[v4];
      ls(D) ? (C = D.name, A2 = D.type) : qa(D) && (C = D);
    }
    if (A2 != null)
      return A2 === "ordinal" ? im.Must : im.Not;
    if (r3 === b1) {
      var P = l3;
      if (e3 === Dj) {
        for (var N = P[v4], j = 0; j < (N || []).length && j < x3; j++)
          if ((m3 = ve(N[h + j])) != null)
            return m3;
      } else
        for (var j = 0; j < P.length && j < x3; j++) {
          var W = P[h + j];
          if (W && (m3 = ve(W[v4])) != null)
            return m3;
        }
    } else if (r3 === C2) {
      var K = l3;
      if (!C)
        return im.Not;
      for (var j = 0; j < K.length && j < x3; j++) {
        var te = K[j];
        if (te && (m3 = ve(te[C])) != null)
          return m3;
      }
    } else if (r3 === KA) {
      var ne = l3;
      if (!C)
        return im.Not;
      var N = ne[C];
      if (!N || ew(N))
        return im.Not;
      for (var j = 0; j < N.length && j < x3; j++)
        if ((m3 = ve(N[j])) != null)
          return m3;
    } else if (r3 === S2)
      for (var ce = l3, j = 0; j < ce.length && j < x3; j++) {
        var te = ce[j], me = xj(te);
        if (!Ni(me))
          return im.Not;
        if ((m3 = ve(me[v4])) != null)
          return m3;
      }
    function ve(Be) {
      var Oe = qa(Be);
      if (Be != null && isFinite(Be) && Be !== "")
        return Oe ? im.Might : im.Not;
      if (Oe && Be !== "-")
        return im.Must;
    }
    return im.Not;
  }
  var tke = Ho();
  function Efn(l3, r3) {
    mb(tke.get(l3) == null && r3), tke.set(l3, r3);
  }
  function Dfn(l3, r3, e3) {
    var u = tke.get(r3);
    if (!u)
      return e3;
    var h = u(l3);
    return h ? e3.concat(h) : e3;
  }
  var mnt = pc(), kfn = pc(), iOe = function() {
    function l3() {
    }
    return l3.prototype.getColorFromPalette = function(r3, e3, u) {
      var h = Gf(this.get("color", true)), v4 = this.get("colorLayer", true);
      return $ct(this, mnt, h, v4, r3, e3, u);
    }, l3.prototype.clearColorPalette = function() {
      Pfn(this, mnt);
    }, l3;
  }();
  function nke(l3, r3, e3, u) {
    var h = Gf(l3.get(["aria", "decal", "decals"]));
    return $ct(l3, kfn, h, null, r3, e3, u);
  }
  function Ofn(l3, r3) {
    for (var e3 = l3.length, u = 0; u < e3; u++)
      if (l3[u].length > r3)
        return l3[u];
    return l3[e3 - 1];
  }
  function $ct(l3, r3, e3, u, h, v4, m3) {
    v4 = v4 || l3;
    var x3 = r3(v4), C = x3.paletteIdx || 0, A2 = x3.paletteNameMap = x3.paletteNameMap || {};
    if (A2.hasOwnProperty(h))
      return A2[h];
    var D = m3 == null || !u ? e3 : Ofn(u, m3);
    if (D = D || e3, !(!D || !D.length)) {
      var P = D[C];
      return h && (A2[h] = P), x3.paletteIdx = (C + 1) % D.length, P;
    }
  }
  function Pfn(l3, r3) {
    r3(l3).paletteIdx = 0, r3(l3).paletteNameMap = {};
  }
  var Mce, YK, bnt, _nt = "\0_ec_inner", Lfn = 1, Xct = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.init = function(e3, u, h, v4, m3, x3) {
      v4 = v4 || {}, this.option = null, this._theme = new Bh(v4), this._locale = new Bh(m3), this._optionManager = x3;
    }, r3.prototype.setOption = function(e3, u, h) {
      var v4 = Snt(u);
      this._optionManager.setOption(e3, h, v4), this._resetOption(null, v4);
    }, r3.prototype.resetOption = function(e3, u) {
      return this._resetOption(e3, Snt(u));
    }, r3.prototype._resetOption = function(e3, u) {
      var h = false, v4 = this._optionManager;
      if (!e3 || e3 === "recreate") {
        var m3 = v4.mountOption(e3 === "recreate");
        !this.option || e3 === "recreate" ? bnt(this, m3) : (this.restoreData(), this._mergeOption(m3, u)), h = true;
      }
      if ((e3 === "timeline" || e3 === "media") && this.restoreData(), !e3 || e3 === "recreate" || e3 === "timeline") {
        var x3 = v4.getTimelineOption(this);
        x3 && (h = true, this._mergeOption(x3, u));
      }
      if (!e3 || e3 === "recreate" || e3 === "media") {
        var C = v4.getMediaOption(this);
        C.length && mt(C, function(A2) {
          h = true, this._mergeOption(A2, u);
        }, this);
      }
      return h;
    }, r3.prototype.mergeOption = function(e3) {
      this._mergeOption(e3, null);
    }, r3.prototype._mergeOption = function(e3, u) {
      var h = this.option, v4 = this._componentsMap, m3 = this._componentsCount, x3 = [], C = Ho(), A2 = u && u.replaceMergeMainTypeMap;
      Afn(this), mt(e3, function(P, N) {
        P != null && (fc.hasClass(N) ? N && (x3.push(N), C.set(N, true)) : h[N] = h[N] == null ? bs(P) : ol(h[N], P, true));
      }), A2 && A2.each(function(P, N) {
        fc.hasClass(N) && !C.get(N) && (x3.push(N), C.set(N, true));
      }), fc.topologicalTravel(x3, fc.getAllClassMainTypes(), D, this);
      function D(P) {
        var N = Dfn(this, P, Gf(e3[P])), j = v4.get(P), W = j ? A2 && A2.get(P) ? "replaceMerge" : "normalMerge" : "replaceAll", K = _ut(j, N, W);
        Uln(K, P, fc), h[P] = null, v4.set(P, null), m3.set(P, 0);
        var te = [], ne = [], ce = 0, me;
        mt(K, function(ve, Be) {
          var Oe = ve.existing, We = ve.newOption;
          if (!We)
            Oe && (Oe.mergeOption({}, this), Oe.optionUpdated({}, false));
          else {
            var Ue = P === "series", qe = fc.getClass(P, ve.keyInfo.subType, !Ue);
            if (!qe)
              return;
            if (P === "tooltip") {
              if (me)
                return;
              me = true;
            }
            if (Oe && Oe.constructor === qe)
              Oe.name = ve.keyInfo.name, Oe.mergeOption(We, this), Oe.optionUpdated(We, false);
            else {
              var Ze = fi({ componentIndex: Be }, ve.keyInfo);
              Oe = new qe(We, this, this, Ze), fi(Oe, Ze), ve.brandNew && (Oe.__requireNewView = true), Oe.init(We, this, this), Oe.optionUpdated(null, true);
            }
          }
          Oe ? (te.push(Oe.option), ne.push(Oe), ce++) : (te.push(void 0), ne.push(void 0));
        }, this), h[P] = te, v4.set(P, ne), m3.set(P, ce), P === "series" && Mce(this);
      }
      this._seriesIndices || Mce(this);
    }, r3.prototype.getOption = function() {
      var e3 = bs(this.option);
      return mt(e3, function(u, h) {
        if (fc.hasClass(h)) {
          for (var v4 = Gf(u), m3 = v4.length, x3 = false, C = m3 - 1; C >= 0; C--)
            v4[C] && !tJ(v4[C]) ? x3 = true : (v4[C] = null, !x3 && m3--);
          v4.length = m3, e3[h] = v4;
        }
      }), delete e3[_nt], e3;
    }, r3.prototype.getTheme = function() {
      return this._theme;
    }, r3.prototype.getLocaleModel = function() {
      return this._locale;
    }, r3.prototype.setUpdatePayload = function(e3) {
      this._payload = e3;
    }, r3.prototype.getUpdatePayload = function() {
      return this._payload;
    }, r3.prototype.getComponent = function(e3, u) {
      var h = this._componentsMap.get(e3);
      if (h) {
        var v4 = h[u || 0];
        if (v4)
          return v4;
        if (u == null) {
          for (var m3 = 0; m3 < h.length; m3++)
            if (h[m3])
              return h[m3];
        }
      }
    }, r3.prototype.queryComponents = function(e3) {
      var u = e3.mainType;
      if (!u)
        return [];
      var h = e3.index, v4 = e3.id, m3 = e3.name, x3 = this._componentsMap.get(u);
      if (!x3 || !x3.length)
        return [];
      var C;
      return h != null ? (C = [], mt(Gf(h), function(A2) {
        x3[A2] && C.push(x3[A2]);
      })) : v4 != null ? C = xnt("id", v4, x3) : m3 != null ? C = xnt("name", m3, x3) : C = jf(x3, function(A2) {
        return !!A2;
      }), wnt(C, e3);
    }, r3.prototype.findComponents = function(e3) {
      var u = e3.query, h = e3.mainType, v4 = x3(u), m3 = v4 ? this.queryComponents(v4) : jf(this._componentsMap.get(h), function(A2) {
        return !!A2;
      });
      return C(wnt(m3, e3));
      function x3(A2) {
        var D = h + "Index", P = h + "Id", N = h + "Name";
        return A2 && (A2[D] != null || A2[P] != null || A2[N] != null) ? { mainType: h, index: A2[D], id: A2[P], name: A2[N] } : null;
      }
      function C(A2) {
        return e3.filter ? jf(A2, e3.filter) : A2;
      }
    }, r3.prototype.eachComponent = function(e3, u, h) {
      var v4 = this._componentsMap;
      if (Xo(e3)) {
        var m3 = u, x3 = e3;
        v4.each(function(P, N) {
          for (var j = 0; P && j < P.length; j++) {
            var W = P[j];
            W && x3.call(m3, N, W, W.componentIndex);
          }
        });
      } else
        for (var C = qa(e3) ? v4.get(e3) : ls(e3) ? this.findComponents(e3) : null, A2 = 0; C && A2 < C.length; A2++) {
          var D = C[A2];
          D && u.call(h, D, D.componentIndex);
        }
    }, r3.prototype.getSeriesByName = function(e3) {
      var u = pg(e3, null);
      return jf(this._componentsMap.get("series"), function(h) {
        return !!h && u != null && h.name === u;
      });
    }, r3.prototype.getSeriesByIndex = function(e3) {
      return this._componentsMap.get("series")[e3];
    }, r3.prototype.getSeriesByType = function(e3) {
      return jf(this._componentsMap.get("series"), function(u) {
        return !!u && u.subType === e3;
      });
    }, r3.prototype.getSeries = function() {
      return jf(this._componentsMap.get("series"), function(e3) {
        return !!e3;
      });
    }, r3.prototype.getSeriesCount = function() {
      return this._componentsCount.get("series");
    }, r3.prototype.eachSeries = function(e3, u) {
      YK(this), mt(this._seriesIndices, function(h) {
        var v4 = this._componentsMap.get("series")[h];
        e3.call(u, v4, h);
      }, this);
    }, r3.prototype.eachRawSeries = function(e3, u) {
      mt(this._componentsMap.get("series"), function(h) {
        h && e3.call(u, h, h.componentIndex);
      });
    }, r3.prototype.eachSeriesByType = function(e3, u, h) {
      YK(this), mt(this._seriesIndices, function(v4) {
        var m3 = this._componentsMap.get("series")[v4];
        m3.subType === e3 && u.call(h, m3, v4);
      }, this);
    }, r3.prototype.eachRawSeriesByType = function(e3, u, h) {
      return mt(this.getSeriesByType(e3), u, h);
    }, r3.prototype.isSeriesFiltered = function(e3) {
      return YK(this), this._seriesIndicesMap.get(e3.componentIndex) == null;
    }, r3.prototype.getCurrentSeriesIndices = function() {
      return (this._seriesIndices || []).slice();
    }, r3.prototype.filterSeries = function(e3, u) {
      YK(this);
      var h = [];
      mt(this._seriesIndices, function(v4) {
        var m3 = this._componentsMap.get("series")[v4];
        e3.call(u, m3, v4) && h.push(v4);
      }, this), this._seriesIndices = h, this._seriesIndicesMap = Ho(h);
    }, r3.prototype.restoreData = function(e3) {
      Mce(this);
      var u = this._componentsMap, h = [];
      u.each(function(v4, m3) {
        fc.hasClass(m3) && h.push(m3);
      }), fc.topologicalTravel(h, fc.getAllClassMainTypes(), function(v4) {
        mt(u.get(v4), function(m3) {
          m3 && (v4 !== "series" || !Rfn(m3, e3)) && m3.restoreData();
        });
      });
    }, r3.internalField = function() {
      Mce = function(e3) {
        var u = e3._seriesIndices = [];
        mt(e3._componentsMap.get("series"), function(h) {
          h && u.push(h.componentIndex);
        }), e3._seriesIndicesMap = Ho(u);
      }, YK = function(e3) {
      }, bnt = function(e3, u) {
        e3.option = {}, e3.option[_nt] = Lfn, e3._componentsMap = Ho({ series: [] }), e3._componentsCount = Ho();
        var h = u.aria;
        ls(h) && h.enabled == null && (h.enabled = true), Nfn(u, e3._theme.option), ol(u, Tfn, false), e3._mergeOption(u, null);
      };
    }(), r3;
  }(Bh);
  function Rfn(l3, r3) {
    if (r3) {
      var e3 = r3.seriesIndex, u = r3.seriesId, h = r3.seriesName;
      return e3 != null && l3.componentIndex !== e3 || u != null && l3.id !== u || h != null && l3.name !== h;
    }
  }
  function Nfn(l3, r3) {
    var e3 = l3.color && !l3.colorLayer;
    mt(r3, function(u, h) {
      h === "colorLayer" && e3 || fc.hasClass(h) || (typeof u == "object" ? l3[h] = l3[h] ? ol(l3[h], u, false) : bs(u) : l3[h] == null && (l3[h] = u));
    });
  }
  function xnt(l3, r3, e3) {
    if (Ni(r3)) {
      var u = Ho();
      return mt(r3, function(v4) {
        if (v4 != null) {
          var m3 = pg(v4, null);
          m3 != null && u.set(v4, true);
        }
      }), jf(e3, function(v4) {
        return v4 && u.get(v4[l3]);
      });
    } else {
      var h = pg(r3, null);
      return jf(e3, function(v4) {
        return v4 && h != null && v4[l3] === h;
      });
    }
  }
  function wnt(l3, r3) {
    return r3.hasOwnProperty("subType") ? jf(l3, function(e3) {
      return e3 && e3.subType === r3.subType;
    }) : l3;
  }
  function Snt(l3) {
    var r3 = Ho();
    return l3 && mt(Gf(l3.replaceMerge), function(e3) {
      r3.set(e3, true);
    }), { replaceMergeMainTypeMap: r3 };
  }
  Fv(Xct, iOe);
  var Yct = Xct, Ffn = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], Vfn = function() {
    function l3(r3) {
      mt(Ffn, function(e3) {
        this[e3] = no(r3[e3], r3);
      }, this);
    }
    return l3;
  }(), Kct = Vfn, TEe = {}, Bfn = function() {
    function l3() {
      this._coordinateSystems = [];
    }
    return l3.prototype.create = function(r3, e3) {
      var u = [];
      mt(TEe, function(h, v4) {
        var m3 = h.create(r3, e3);
        u = u.concat(m3 || []);
      }), this._coordinateSystems = u;
    }, l3.prototype.update = function(r3, e3) {
      mt(this._coordinateSystems, function(u) {
        u.update && u.update(r3, e3);
      });
    }, l3.prototype.getCoordinateSystems = function() {
      return this._coordinateSystems.slice();
    }, l3.register = function(r3, e3) {
      TEe[r3] = e3;
    }, l3.get = function(r3) {
      return TEe[r3];
    }, l3;
  }(), FJ = Bfn, zfn = /^(min|max)?(.+)$/, jfn = function() {
    function l3(r3) {
      this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = r3;
    }
    return l3.prototype.setOption = function(r3, e3, u) {
      r3 && (mt(Gf(r3.series), function(m3) {
        m3 && m3.data && ew(m3.data) && Ffe(m3.data);
      }), mt(Gf(r3.dataset), function(m3) {
        m3 && m3.source && ew(m3.source) && Ffe(m3.source);
      })), r3 = bs(r3);
      var h = this._optionBackup, v4 = Gfn(r3, e3, !h);
      this._newBaseOption = v4.baseOption, h ? (v4.timelineOptions.length && (h.timelineOptions = v4.timelineOptions), v4.mediaList.length && (h.mediaList = v4.mediaList), v4.mediaDefault && (h.mediaDefault = v4.mediaDefault)) : this._optionBackup = v4;
    }, l3.prototype.mountOption = function(r3) {
      var e3 = this._optionBackup;
      return this._timelineOptions = e3.timelineOptions, this._mediaList = e3.mediaList, this._mediaDefault = e3.mediaDefault, this._currentMediaIndices = [], bs(r3 ? e3.baseOption : this._newBaseOption);
    }, l3.prototype.getTimelineOption = function(r3) {
      var e3, u = this._timelineOptions;
      if (u.length) {
        var h = r3.getComponent("timeline");
        h && (e3 = bs(u[h.getCurrentIndex()]));
      }
      return e3;
    }, l3.prototype.getMediaOption = function(r3) {
      var e3 = this._api.getWidth(), u = this._api.getHeight(), h = this._mediaList, v4 = this._mediaDefault, m3 = [], x3 = [];
      if (!h.length && !v4)
        return x3;
      for (var C = 0, A2 = h.length; C < A2; C++)
        Hfn(h[C].query, e3, u) && m3.push(C);
      return !m3.length && v4 && (m3 = [-1]), m3.length && !Ufn(m3, this._currentMediaIndices) && (x3 = Bi(m3, function(D) {
        return bs(D === -1 ? v4.option : h[D].option);
      })), this._currentMediaIndices = m3, x3;
    }, l3;
  }();
  function Gfn(l3, r3, e3) {
    var u = [], h, v4, m3 = l3.baseOption, x3 = l3.timeline, C = l3.options, A2 = l3.media, D = !!l3.media, P = !!(C || x3 || m3 && m3.timeline);
    m3 ? (v4 = m3, v4.timeline || (v4.timeline = x3)) : ((P || D) && (l3.options = l3.media = null), v4 = l3), D && Ni(A2) && mt(A2, function(j) {
      j && j.option && (j.query ? u.push(j) : h || (h = j));
    }), N(v4), mt(C, function(j) {
      return N(j);
    }), mt(u, function(j) {
      return N(j.option);
    });
    function N(j) {
      mt(r3, function(W) {
        W(j, e3);
      });
    }
    return { baseOption: v4, timelineOptions: C || [], mediaDefault: h, mediaList: u };
  }
  function Hfn(l3, r3, e3) {
    var u = { width: r3, height: e3, aspectratio: r3 / e3 }, h = true;
    return mt(l3, function(v4, m3) {
      var x3 = m3.match(zfn);
      if (!(!x3 || !x3[1] || !x3[2])) {
        var C = x3[1], A2 = x3[2].toLowerCase();
        Wfn(u[A2], v4, C) || (h = false);
      }
    }), h;
  }
  function Wfn(l3, r3, e3) {
    return e3 === "min" ? l3 >= r3 : e3 === "max" ? l3 <= r3 : l3 === r3;
  }
  function Ufn(l3, r3) {
    return l3.join(",") === r3.join(",");
  }
  var qfn = jfn, oM = mt, uJ = ls, Cnt = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
  function AEe(l3) {
    var r3 = l3 && l3.itemStyle;
    if (!!r3)
      for (var e3 = 0, u = Cnt.length; e3 < u; e3++) {
        var h = Cnt[e3], v4 = r3.normal, m3 = r3.emphasis;
        v4 && v4[h] && (l3[h] = l3[h] || {}, l3[h].normal ? ol(l3[h].normal, v4[h]) : l3[h].normal = v4[h], v4[h] = null), m3 && m3[h] && (l3[h] = l3[h] || {}, l3[h].emphasis ? ol(l3[h].emphasis, m3[h]) : l3[h].emphasis = m3[h], m3[h] = null);
      }
  }
  function v12(l3, r3, e3) {
    if (l3 && l3[r3] && (l3[r3].normal || l3[r3].emphasis)) {
      var u = l3[r3].normal, h = l3[r3].emphasis;
      u && (e3 ? (l3[r3].normal = l3[r3].emphasis = null, ns(l3[r3], u)) : l3[r3] = u), h && (l3.emphasis = l3.emphasis || {}, l3.emphasis[r3] = h, h.focus && (l3.emphasis.focus = h.focus), h.blurScope && (l3.emphasis.blurScope = h.blurScope));
    }
  }
  function MZ(l3) {
    v12(l3, "itemStyle"), v12(l3, "lineStyle"), v12(l3, "areaStyle"), v12(l3, "label"), v12(l3, "labelLine"), v12(l3, "upperLabel"), v12(l3, "edgeLabel");
  }
  function Pv(l3, r3) {
    var e3 = uJ(l3) && l3[r3], u = uJ(e3) && e3.textStyle;
    if (u)
      for (var h = 0, v4 = Itt.length; h < v4; h++) {
        var m3 = Itt[h];
        u.hasOwnProperty(m3) && (e3[m3] = u[m3]);
      }
  }
  function l2(l3) {
    l3 && (MZ(l3), Pv(l3, "label"), l3.emphasis && Pv(l3.emphasis, "label"));
  }
  function $fn(l3) {
    if (!!uJ(l3)) {
      AEe(l3), MZ(l3), Pv(l3, "label"), Pv(l3, "upperLabel"), Pv(l3, "edgeLabel"), l3.emphasis && (Pv(l3.emphasis, "label"), Pv(l3.emphasis, "upperLabel"), Pv(l3.emphasis, "edgeLabel"));
      var r3 = l3.markPoint;
      r3 && (AEe(r3), l2(r3));
      var e3 = l3.markLine;
      e3 && (AEe(e3), l2(e3));
      var u = l3.markArea;
      u && l2(u);
      var h = l3.data;
      if (l3.type === "graph") {
        h = h || l3.nodes;
        var v4 = l3.links || l3.edges;
        if (v4 && !ew(v4))
          for (var m3 = 0; m3 < v4.length; m3++)
            l2(v4[m3]);
        mt(l3.categories, function(A2) {
          MZ(A2);
        });
      }
      if (h && !ew(h))
        for (var m3 = 0; m3 < h.length; m3++)
          l2(h[m3]);
      if (r3 = l3.markPoint, r3 && r3.data)
        for (var x3 = r3.data, m3 = 0; m3 < x3.length; m3++)
          l2(x3[m3]);
      if (e3 = l3.markLine, e3 && e3.data)
        for (var C = e3.data, m3 = 0; m3 < C.length; m3++)
          Ni(C[m3]) ? (l2(C[m3][0]), l2(C[m3][1])) : l2(C[m3]);
      l3.type === "gauge" ? (Pv(l3, "axisLabel"), Pv(l3, "title"), Pv(l3, "detail")) : l3.type === "treemap" ? (v12(l3.breadcrumb, "itemStyle"), mt(l3.levels, function(A2) {
        MZ(A2);
      })) : l3.type === "tree" && MZ(l3.leaves);
    }
  }
  function XD(l3) {
    return Ni(l3) ? l3 : l3 ? [l3] : [];
  }
  function Mnt(l3) {
    return (Ni(l3) ? l3[0] : l3) || {};
  }
  function Xfn(l3, r3) {
    oM(XD(l3.series), function(u) {
      uJ(u) && $fn(u);
    });
    var e3 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
    r3 && e3.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), oM(e3, function(u) {
      oM(XD(l3[u]), function(h) {
        h && (Pv(h, "axisLabel"), Pv(h.axisPointer, "label"));
      });
    }), oM(XD(l3.parallel), function(u) {
      var h = u && u.parallelAxisDefault;
      Pv(h, "axisLabel"), Pv(h && h.axisPointer, "label");
    }), oM(XD(l3.calendar), function(u) {
      v12(u, "itemStyle"), Pv(u, "dayLabel"), Pv(u, "monthLabel"), Pv(u, "yearLabel");
    }), oM(XD(l3.radar), function(u) {
      Pv(u, "name"), u.name && u.axisName == null && (u.axisName = u.name, delete u.name), u.nameGap != null && u.axisNameGap == null && (u.axisNameGap = u.nameGap, delete u.nameGap);
    }), oM(XD(l3.geo), function(u) {
      uJ(u) && (l2(u), oM(XD(u.regions), function(h) {
        l2(h);
      }));
    }), oM(XD(l3.timeline), function(u) {
      l2(u), v12(u, "label"), v12(u, "itemStyle"), v12(u, "controlStyle", true);
      var h = u.data;
      Ni(h) && mt(h, function(v4) {
        ls(v4) && (v12(v4, "label"), v12(v4, "itemStyle"));
      });
    }), oM(XD(l3.toolbox), function(u) {
      v12(u, "iconStyle"), oM(u.feature, function(h) {
        v12(h, "iconStyle");
      });
    }), Pv(Mnt(l3.axisPointer), "label"), Pv(Mnt(l3.tooltip).axisPointer, "label");
  }
  function Yfn(l3, r3) {
    for (var e3 = r3.split(","), u = l3, h = 0; h < e3.length && (u = u && u[e3[h]], u != null); h++)
      ;
    return u;
  }
  function Kfn(l3, r3, e3, u) {
    for (var h = r3.split(","), v4 = l3, m3, x3 = 0; x3 < h.length - 1; x3++)
      m3 = h[x3], v4[m3] == null && (v4[m3] = {}), v4 = v4[m3];
    (u || v4[h[x3]] == null) && (v4[h[x3]] = e3);
  }
  function Tnt(l3) {
    l3 && mt(Zfn, function(r3) {
      r3[0] in l3 && !(r3[1] in l3) && (l3[r3[1]] = l3[r3[0]]);
    });
  }
  var Zfn = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], Jfn = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], IEe = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
  function KK(l3) {
    var r3 = l3 && l3.itemStyle;
    if (r3)
      for (var e3 = 0; e3 < IEe.length; e3++) {
        var u = IEe[e3][1], h = IEe[e3][0];
        r3[u] != null && (r3[h] = r3[u]);
      }
  }
  function Ant(l3) {
    !l3 || l3.alignTo === "edge" && l3.margin != null && l3.edgeDistance == null && (l3.edgeDistance = l3.margin);
  }
  function Int(l3) {
    !l3 || l3.downplay && !l3.blur && (l3.blur = l3.downplay);
  }
  function Qfn(l3) {
    !l3 || l3.focusNodeAdjacency != null && (l3.emphasis = l3.emphasis || {}, l3.emphasis.focus == null && (l3.emphasis.focus = "adjacency"));
  }
  function Zct(l3, r3) {
    if (l3)
      for (var e3 = 0; e3 < l3.length; e3++)
        r3(l3[e3]), l3[e3] && Zct(l3[e3].children, r3);
  }
  function Jct(l3, r3) {
    Xfn(l3, r3), l3.series = Gf(l3.series), mt(l3.series, function(e3) {
      if (!!ls(e3)) {
        var u = e3.type;
        if (u === "line")
          e3.clipOverflow != null && (e3.clip = e3.clipOverflow);
        else if (u === "pie" || u === "gauge") {
          e3.clockWise != null && (e3.clockwise = e3.clockWise), Ant(e3.label);
          var h = e3.data;
          if (h && !ew(h))
            for (var v4 = 0; v4 < h.length; v4++)
              Ant(h[v4]);
          e3.hoverOffset != null && (e3.emphasis = e3.emphasis || {}, (e3.emphasis.scaleSize = null) && (e3.emphasis.scaleSize = e3.hoverOffset));
        } else if (u === "gauge") {
          var m3 = Yfn(e3, "pointer.color");
          m3 != null && Kfn(e3, "itemStyle.color", m3);
        } else if (u === "bar") {
          KK(e3), KK(e3.backgroundStyle), KK(e3.emphasis);
          var h = e3.data;
          if (h && !ew(h))
            for (var v4 = 0; v4 < h.length; v4++)
              typeof h[v4] == "object" && (KK(h[v4]), KK(h[v4] && h[v4].emphasis));
        } else if (u === "sunburst") {
          var x3 = e3.highlightPolicy;
          x3 && (e3.emphasis = e3.emphasis || {}, e3.emphasis.focus || (e3.emphasis.focus = x3)), Int(e3), Zct(e3.data, Int);
        } else
          u === "graph" || u === "sankey" ? Qfn(e3) : u === "map" && (e3.mapType && !e3.map && (e3.map = e3.mapType), e3.mapLocation && ns(e3, e3.mapLocation));
        e3.hoverAnimation != null && (e3.emphasis = e3.emphasis || {}, e3.emphasis && e3.emphasis.scale == null && (e3.emphasis.scale = e3.hoverAnimation)), Tnt(e3);
      }
    }), l3.dataRange && (l3.visualMap = l3.dataRange), mt(Jfn, function(e3) {
      var u = l3[e3];
      u && (Ni(u) || (u = [u]), mt(u, function(h) {
        Tnt(h);
      }));
    });
  }
  function ehn(l3) {
    var r3 = Ho();
    l3.eachSeries(function(e3) {
      var u = e3.get("stack");
      if (u) {
        var h = r3.get(u) || r3.set(u, []), v4 = e3.getData(), m3 = { stackResultDimension: v4.getCalculationInfo("stackResultDimension"), stackedOverDimension: v4.getCalculationInfo("stackedOverDimension"), stackedDimension: v4.getCalculationInfo("stackedDimension"), stackedByDimension: v4.getCalculationInfo("stackedByDimension"), isStackedByIndex: v4.getCalculationInfo("isStackedByIndex"), data: v4, seriesModel: e3 };
        if (!m3.stackedDimension || !(m3.isStackedByIndex || m3.stackedByDimension))
          return;
        h.length && v4.setCalculationInfo("stackedOnSeries", h[h.length - 1].seriesModel), h.push(m3);
      }
    }), r3.each(thn);
  }
  function thn(l3) {
    mt(l3, function(r3, e3) {
      var u = [], h = [NaN, NaN], v4 = [r3.stackResultDimension, r3.stackedOverDimension], m3 = r3.data, x3 = r3.isStackedByIndex;
      m3.modify(v4, function(C, A2, D) {
        var P = m3.get(r3.stackedDimension, D);
        if (isNaN(P))
          return h;
        var N, j;
        x3 ? j = m3.getRawIndex(D) : N = m3.get(r3.stackedByDimension, D);
        for (var W = NaN, K = e3 - 1; K >= 0; K--) {
          var te = l3[K];
          if (x3 || (j = te.data.rawIndexOf(te.stackedByDimension, N)), j >= 0) {
            var ne = te.data.getByRawIndex(te.stackResultDimension, j);
            if (P >= 0 && ne > 0 || P <= 0 && ne < 0) {
              P = Lln(P, ne), W = ne;
              break;
            }
          }
        }
        return u[0] = P, u[1] = W, u;
      });
    });
  }
  var ope = function() {
    function l3(r3) {
      this.data = r3.data || (r3.sourceFormat === KA ? {} : []), this.sourceFormat = r3.sourceFormat || Gct, this.seriesLayoutBy = r3.seriesLayoutBy || GA, this.startIndex = r3.startIndex || 0, this.dimensionsDetectedCount = r3.dimensionsDetectedCount, this.metaRawOption = r3.metaRawOption;
      var e3 = this.dimensionsDefine = r3.dimensionsDefine;
      if (e3)
        for (var u = 0; u < e3.length; u++) {
          var h = e3[u];
          h.type == null && Uct(this, u) === im.Must && (h.type = "ordinal");
        }
    }
    return l3;
  }();
  function aOe(l3) {
    return l3 instanceof ope;
  }
  function rke(l3, r3, e3) {
    e3 = e3 || Qct(l3);
    var u = r3.seriesLayoutBy, h = rhn(l3, e3, u, r3.sourceHeader, r3.dimensions), v4 = new ope({ data: l3, sourceFormat: e3, seriesLayoutBy: u, dimensionsDefine: h.dimensionsDefine, startIndex: h.startIndex, dimensionsDetectedCount: h.dimensionsDetectedCount, metaRawOption: bs(r3) });
    return v4;
  }
  function oOe(l3) {
    return new ope({ data: l3, sourceFormat: ew(l3) ? $O : S2 });
  }
  function nhn(l3) {
    return new ope({ data: l3.data, sourceFormat: l3.sourceFormat, seriesLayoutBy: l3.seriesLayoutBy, dimensionsDefine: bs(l3.dimensionsDefine), startIndex: l3.startIndex, dimensionsDetectedCount: l3.dimensionsDetectedCount });
  }
  function Qct(l3) {
    var r3 = Gct;
    if (ew(l3))
      r3 = $O;
    else if (Ni(l3)) {
      l3.length === 0 && (r3 = b1);
      for (var e3 = 0, u = l3.length; e3 < u; e3++) {
        var h = l3[e3];
        if (h != null) {
          if (Ni(h)) {
            r3 = b1;
            break;
          } else if (ls(h)) {
            r3 = C2;
            break;
          }
        }
      }
    } else if (ls(l3)) {
      for (var v4 in l3)
        if (vo(l3, v4) && m1(l3[v4])) {
          r3 = KA;
          break;
        }
    }
    return r3;
  }
  function rhn(l3, r3, e3, u, h) {
    var v4, m3;
    if (!l3)
      return { dimensionsDefine: Ent(h), startIndex: m3, dimensionsDetectedCount: v4 };
    if (r3 === b1) {
      var x3 = l3;
      u === "auto" || u == null ? Dnt(function(A2) {
        A2 != null && A2 !== "-" && (qa(A2) ? m3 == null && (m3 = 1) : m3 = 0);
      }, e3, x3, 10) : m3 = Vc(u) ? u : u ? 1 : 0, !h && m3 === 1 && (h = [], Dnt(function(A2, D) {
        h[D] = A2 != null ? A2 + "" : "";
      }, e3, x3, 1 / 0)), v4 = h ? h.length : e3 === Dj ? x3.length : x3[0] ? x3[0].length : null;
    } else if (r3 === C2)
      h || (h = ihn(l3));
    else if (r3 === KA)
      h || (h = [], mt(l3, function(A2, D) {
        h.push(D);
      }));
    else if (r3 === S2) {
      var C = xj(l3[0]);
      v4 = Ni(C) && C.length || 1;
    }
    return { startIndex: m3, dimensionsDefine: Ent(h), dimensionsDetectedCount: v4 };
  }
  function ihn(l3) {
    for (var r3 = 0, e3; r3 < l3.length && !(e3 = l3[r3++]); )
      ;
    if (e3) {
      var u = [];
      return mt(e3, function(h, v4) {
        u.push(v4);
      }), u;
    }
  }
  function Ent(l3) {
    if (!!l3) {
      var r3 = Ho();
      return Bi(l3, function(e3, u) {
        e3 = ls(e3) ? e3 : { name: e3 };
        var h = { name: e3.name, displayName: e3.displayName, type: e3.type };
        if (h.name == null)
          return h;
        h.name += "", h.displayName == null && (h.displayName = h.name);
        var v4 = r3.get(h.name);
        return v4 ? h.name += "-" + v4.count++ : r3.set(h.name, { count: 1 }), h;
      });
    }
  }
  function Dnt(l3, r3, e3, u) {
    if (r3 === Dj)
      for (var h = 0; h < e3.length && h < u; h++)
        l3(e3[h] ? e3[h][0] : null, h);
    else
      for (var v4 = e3[0] || [], h = 0; h < v4.length && h < u; h++)
        l3(v4[h], h);
  }
  function eft(l3) {
    var r3 = l3.sourceFormat;
    return r3 === C2 || r3 === KA;
  }
  var sN, lN, uN, knt, Ont, tft = function() {
    function l3(r3, e3) {
      var u = aOe(r3) ? r3 : oOe(r3);
      this._source = u;
      var h = this._data = u.data;
      u.sourceFormat === $O && (this._offset = 0, this._dimSize = e3, this._data = h), Ont(this, h, u);
    }
    return l3.prototype.getSource = function() {
      return this._source;
    }, l3.prototype.count = function() {
      return 0;
    }, l3.prototype.getItem = function(r3, e3) {
    }, l3.prototype.appendData = function(r3) {
    }, l3.prototype.clean = function() {
    }, l3.protoInitialize = function() {
      var r3 = l3.prototype;
      r3.pure = false, r3.persistent = true;
    }(), l3.internalField = function() {
      var r3;
      Ont = function(m3, x3, C) {
        var A2 = C.sourceFormat, D = C.seriesLayoutBy, P = C.startIndex, N = C.dimensionsDefine, j = knt[sOe(A2, D)];
        if (fi(m3, j), A2 === $O)
          m3.getItem = e3, m3.count = h, m3.fillStorage = u;
        else {
          var W = nft(A2, D);
          m3.getItem = no(W, null, x3, P, N);
          var K = rft(A2, D);
          m3.count = no(K, null, x3, P, N);
        }
      };
      var e3 = function(m3, x3) {
        m3 = m3 - this._offset, x3 = x3 || [];
        for (var C = this._data, A2 = this._dimSize, D = A2 * m3, P = 0; P < A2; P++)
          x3[P] = C[D + P];
        return x3;
      }, u = function(m3, x3, C, A2) {
        for (var D = this._data, P = this._dimSize, N = 0; N < P; N++) {
          for (var j = A2[N], W = j[0] == null ? 1 / 0 : j[0], K = j[1] == null ? -1 / 0 : j[1], te = x3 - m3, ne = C[N], ce = 0; ce < te; ce++) {
            var me = D[ce * P + N];
            ne[m3 + ce] = me, me < W && (W = me), me > K && (K = me);
          }
          j[0] = W, j[1] = K;
        }
      }, h = function() {
        return this._data ? this._data.length / this._dimSize : 0;
      };
      knt = (r3 = {}, r3[b1 + "_" + GA] = { pure: true, appendData: v4 }, r3[b1 + "_" + Dj] = { pure: true, appendData: function() {
        throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
      } }, r3[C2] = { pure: true, appendData: v4 }, r3[KA] = { pure: true, appendData: function(m3) {
        var x3 = this._data;
        mt(m3, function(C, A2) {
          for (var D = x3[A2] || (x3[A2] = []), P = 0; P < (C || []).length; P++)
            D.push(C[P]);
        });
      } }, r3[S2] = { appendData: v4 }, r3[$O] = { persistent: false, pure: true, appendData: function(m3) {
        this._data = m3;
      }, clean: function() {
        this._offset += this.count(), this._data = null;
      } }, r3);
      function v4(m3) {
        for (var x3 = 0; x3 < m3.length; x3++)
          this._data.push(m3[x3]);
      }
    }(), l3;
  }(), Pnt = function(l3, r3, e3, u) {
    return l3[u];
  }, ahn = (sN = {}, sN[b1 + "_" + GA] = function(l3, r3, e3, u) {
    return l3[u + r3];
  }, sN[b1 + "_" + Dj] = function(l3, r3, e3, u, h) {
    u += r3;
    for (var v4 = h || [], m3 = l3, x3 = 0; x3 < m3.length; x3++) {
      var C = m3[x3];
      v4[x3] = C ? C[u] : null;
    }
    return v4;
  }, sN[C2] = Pnt, sN[KA] = function(l3, r3, e3, u, h) {
    for (var v4 = h || [], m3 = 0; m3 < e3.length; m3++) {
      var x3 = e3[m3].name, C = l3[x3];
      v4[m3] = C ? C[u] : null;
    }
    return v4;
  }, sN[S2] = Pnt, sN);
  function nft(l3, r3) {
    var e3 = ahn[sOe(l3, r3)];
    return e3;
  }
  var Lnt = function(l3, r3, e3) {
    return l3.length;
  }, ohn = (lN = {}, lN[b1 + "_" + GA] = function(l3, r3, e3) {
    return Math.max(0, l3.length - r3);
  }, lN[b1 + "_" + Dj] = function(l3, r3, e3) {
    var u = l3[0];
    return u ? Math.max(0, u.length - r3) : 0;
  }, lN[C2] = Lnt, lN[KA] = function(l3, r3, e3) {
    var u = e3[0].name, h = l3[u];
    return h ? h.length : 0;
  }, lN[S2] = Lnt, lN);
  function rft(l3, r3) {
    var e3 = ohn[sOe(l3, r3)];
    return e3;
  }
  var EEe = function(l3, r3, e3) {
    return l3[r3];
  }, shn = (uN = {}, uN[b1] = EEe, uN[C2] = function(l3, r3, e3) {
    return l3[e3];
  }, uN[KA] = EEe, uN[S2] = function(l3, r3, e3) {
    var u = xj(l3);
    return u instanceof Array ? u[r3] : u;
  }, uN[$O] = EEe, uN);
  function ift(l3) {
    var r3 = shn[l3];
    return r3;
  }
  function sOe(l3, r3) {
    return l3 === b1 ? l3 + "_" + r3 : l3;
  }
  function hj(l3, r3, e3) {
    if (!!l3) {
      var u = l3.getRawDataItem(r3);
      if (u != null) {
        var h = l3.getStore(), v4 = h.getSource().sourceFormat;
        if (e3 != null) {
          var m3 = l3.getDimensionIndex(e3), x3 = h.getDimensionProperty(m3);
          return ift(v4)(u, m3, x3);
        } else {
          var C = u;
          return v4 === S2 && (C = xj(u)), C;
        }
      }
    }
  }
  var lhn = /\{@(.+?)\}/g, lOe = function() {
    function l3() {
    }
    return l3.prototype.getDataParams = function(r3, e3) {
      var u = this.getData(e3), h = this.getRawValue(r3, e3), v4 = u.getRawIndex(r3), m3 = u.getName(r3), x3 = u.getRawDataItem(r3), C = u.getItemVisual(r3, "style"), A2 = C && C[u.getItemVisual(r3, "drawType") || "fill"], D = C && C.stroke, P = this.mainType, N = P === "series", j = u.userOutput && u.userOutput.get();
      return { componentType: P, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: N ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: N ? this.id : null, seriesName: N ? this.name : null, name: m3, dataIndex: v4, data: x3, dataType: e3, value: h, color: A2, borderColor: D, dimensionNames: j ? j.fullDimensions : null, encode: j ? j.encode : null, $vars: ["seriesName", "name", "value"] };
    }, l3.prototype.getFormattedLabel = function(r3, e3, u, h, v4, m3) {
      e3 = e3 || "normal";
      var x3 = this.getData(u), C = this.getDataParams(r3, u);
      if (m3 && (C.value = m3.interpolatedValue), h != null && Ni(C.value) && (C.value = C.value[h]), !v4) {
        var A2 = x3.getItemModel(r3);
        v4 = A2.get(e3 === "normal" ? ["label", "formatter"] : [e3, "label", "formatter"]);
      }
      if (Xo(v4))
        return C.status = e3, C.dimensionIndex = h, v4(C);
      if (qa(v4)) {
        var D = Fct(v4, C);
        return D.replace(lhn, function(P, N) {
          var j = N.length, W = N;
          W.charAt(0) === "[" && W.charAt(j - 1) === "]" && (W = +W.slice(1, j - 1));
          var K = hj(x3, r3, W);
          if (m3 && Ni(m3.interpolatedValue)) {
            var te = x3.getDimensionIndex(W);
            te >= 0 && (K = m3.interpolatedValue[te]);
          }
          return K != null ? K + "" : "";
        });
      }
    }, l3.prototype.getRawValue = function(r3, e3) {
      return hj(this.getData(e3), r3);
    }, l3.prototype.formatTooltip = function(r3, e3, u) {
    }, l3;
  }();
  function Rnt(l3) {
    var r3, e3;
    return ls(l3) ? l3.type && (e3 = l3) : r3 = l3, { text: r3, frag: e3 };
  }
  function jZ(l3) {
    return new uhn(l3);
  }
  var uhn = function() {
    function l3(r3) {
      r3 = r3 || {}, this._reset = r3.reset, this._plan = r3.plan, this._count = r3.count, this._onDirty = r3.onDirty, this._dirty = true;
    }
    return l3.prototype.perform = function(r3) {
      var e3 = this._upstream, u = r3 && r3.skip;
      if (this._dirty && e3) {
        var h = this.context;
        h.data = h.outputData = e3.context.outputData;
      }
      this.__pipeline && (this.__pipeline.currentTask = this);
      var v4;
      this._plan && !u && (v4 = this._plan(this.context));
      var m3 = D(this._modBy), x3 = this._modDataCount || 0, C = D(r3 && r3.modBy), A2 = r3 && r3.modDataCount || 0;
      (m3 !== C || x3 !== A2) && (v4 = "reset");
      function D(ce) {
        return !(ce >= 1) && (ce = 1), ce;
      }
      var P;
      (this._dirty || v4 === "reset") && (this._dirty = false, P = this._doReset(u)), this._modBy = C, this._modDataCount = A2;
      var N = r3 && r3.step;
      if (e3 ? this._dueEnd = e3._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
        var j = this._dueIndex, W = Math.min(N != null ? this._dueIndex + N : 1 / 0, this._dueEnd);
        if (!u && (P || j < W)) {
          var K = this._progress;
          if (Ni(K))
            for (var te = 0; te < K.length; te++)
              this._doProgress(K[te], j, W, C, A2);
          else
            this._doProgress(K, j, W, C, A2);
        }
        this._dueIndex = W;
        var ne = this._settedOutputEnd != null ? this._settedOutputEnd : W;
        this._outputDueEnd = ne;
      } else
        this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
      return this.unfinished();
    }, l3.prototype.dirty = function() {
      this._dirty = true, this._onDirty && this._onDirty(this.context);
    }, l3.prototype._doProgress = function(r3, e3, u, h, v4) {
      Nnt.reset(e3, u, h, v4), this._callingProgress = r3, this._callingProgress({ start: e3, end: u, count: u - e3, next: Nnt.next }, this.context);
    }, l3.prototype._doReset = function(r3) {
      this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
      var e3, u;
      !r3 && this._reset && (e3 = this._reset(this.context), e3 && e3.progress && (u = e3.forceFirstProgress, e3 = e3.progress), Ni(e3) && !e3.length && (e3 = null)), this._progress = e3, this._modBy = this._modDataCount = null;
      var h = this._downstream;
      return h && h.dirty(), u;
    }, l3.prototype.unfinished = function() {
      return this._progress && this._dueIndex < this._dueEnd;
    }, l3.prototype.pipe = function(r3) {
      (this._downstream !== r3 || this._dirty) && (this._downstream = r3, r3._upstream = this, r3.dirty());
    }, l3.prototype.dispose = function() {
      this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
    }, l3.prototype.getUpstream = function() {
      return this._upstream;
    }, l3.prototype.getDownstream = function() {
      return this._downstream;
    }, l3.prototype.setOutputEnd = function(r3) {
      this._outputDueEnd = this._settedOutputEnd = r3;
    }, l3;
  }(), Nnt = function() {
    var l3, r3, e3, u, h, v4 = { reset: function(C, A2, D, P) {
      r3 = C, l3 = A2, e3 = D, u = P, h = Math.ceil(u / e3), v4.next = e3 > 1 && u > 0 ? x3 : m3;
    } };
    return v4;
    function m3() {
      return r3 < l3 ? r3++ : null;
    }
    function x3() {
      var C = r3 % h * e3 + Math.ceil(r3 / h), A2 = r3 >= l3 ? null : C < u ? C : r3;
      return r3++, A2;
    }
  }();
  function XO(l3, r3) {
    var e3 = r3 && r3.type;
    return e3 === "ordinal" ? l3 : (e3 === "time" && !Vc(l3) && l3 != null && l3 !== "-" && (l3 = +$A(l3)), l3 == null || l3 === "" ? NaN : +l3);
  }
  var chn = Ho({ number: function(l3) {
    return parseFloat(l3);
  }, time: function(l3) {
    return +$A(l3);
  }, trim: function(l3) {
    return qa(l3) ? hM(l3) : l3;
  } });
  function aft(l3) {
    return chn.get(l3);
  }
  var oft = { lt: function(l3, r3) {
    return l3 < r3;
  }, lte: function(l3, r3) {
    return l3 <= r3;
  }, gt: function(l3, r3) {
    return l3 > r3;
  }, gte: function(l3, r3) {
    return l3 >= r3;
  } }, fhn = function() {
    function l3(r3, e3) {
      if (!Vc(e3)) {
        var u = "";
        Xc(u);
      }
      this._opFn = oft[r3], this._rvalFloat = c5(e3);
    }
    return l3.prototype.evaluate = function(r3) {
      return Vc(r3) ? this._opFn(r3, this._rvalFloat) : this._opFn(c5(r3), this._rvalFloat);
    }, l3;
  }(), sft = function() {
    function l3(r3, e3) {
      var u = r3 === "desc";
      this._resultLT = u ? 1 : -1, e3 == null && (e3 = u ? "min" : "max"), this._incomparable = e3 === "min" ? -1 / 0 : 1 / 0;
    }
    return l3.prototype.evaluate = function(r3, e3) {
      var u = Vc(r3) ? r3 : c5(r3), h = Vc(e3) ? e3 : c5(e3), v4 = isNaN(u), m3 = isNaN(h);
      if (v4 && (u = this._incomparable), m3 && (h = this._incomparable), v4 && m3) {
        var x3 = qa(r3), C = qa(e3);
        x3 && (u = C ? r3 : 0), C && (h = x3 ? e3 : 0);
      }
      return u < h ? this._resultLT : u > h ? -this._resultLT : 0;
    }, l3;
  }(), hhn = function() {
    function l3(r3, e3) {
      this._rval = e3, this._isEQ = r3, this._rvalTypeof = typeof e3, this._rvalFloat = c5(e3);
    }
    return l3.prototype.evaluate = function(r3) {
      var e3 = r3 === this._rval;
      if (!e3) {
        var u = typeof r3;
        u !== this._rvalTypeof && (u === "number" || this._rvalTypeof === "number") && (e3 = c5(r3) === this._rvalFloat);
      }
      return this._isEQ ? e3 : !e3;
    }, l3;
  }();
  function phn(l3, r3) {
    return l3 === "eq" || l3 === "ne" ? new hhn(l3 === "eq", r3) : vo(oft, l3) ? new fhn(l3, r3) : null;
  }
  var dhn = function() {
    function l3() {
    }
    return l3.prototype.getRawData = function() {
      throw new Error("not supported");
    }, l3.prototype.getRawDataItem = function(r3) {
      throw new Error("not supported");
    }, l3.prototype.cloneRawData = function() {
    }, l3.prototype.getDimensionInfo = function(r3) {
    }, l3.prototype.cloneAllDimensionInfo = function() {
    }, l3.prototype.count = function() {
    }, l3.prototype.retrieveValue = function(r3, e3) {
    }, l3.prototype.retrieveValueFromItem = function(r3, e3) {
    }, l3.prototype.convertValue = function(r3, e3) {
      return XO(r3, e3);
    }, l3;
  }();
  function vhn(l3, r3) {
    var e3 = new dhn(), u = l3.data, h = e3.sourceFormat = l3.sourceFormat, v4 = l3.startIndex, m3 = "";
    l3.seriesLayoutBy !== GA && Xc(m3);
    var x3 = [], C = {}, A2 = l3.dimensionsDefine;
    if (A2)
      mt(A2, function(K, te) {
        var ne = K.name, ce = { index: te, name: ne, displayName: K.displayName };
        if (x3.push(ce), ne != null) {
          var me = "";
          vo(C, ne) && Xc(me), C[ne] = ce;
        }
      });
    else
      for (var D = 0; D < l3.dimensionsDetectedCount; D++)
        x3.push({ index: D });
    var P = nft(h, GA);
    r3.__isBuiltIn && (e3.getRawDataItem = function(K) {
      return P(u, v4, x3, K);
    }, e3.getRawData = no(ghn, null, l3)), e3.cloneRawData = no(yhn, null, l3);
    var N = rft(h, GA);
    e3.count = no(N, null, u, v4, x3);
    var j = ift(h);
    e3.retrieveValue = function(K, te) {
      var ne = P(u, v4, x3, K);
      return W(ne, te);
    };
    var W = e3.retrieveValueFromItem = function(K, te) {
      if (K != null) {
        var ne = x3[te];
        if (ne)
          return j(K, te, ne.name);
      }
    };
    return e3.getDimensionInfo = no(mhn, null, x3, C), e3.cloneAllDimensionInfo = no(bhn, null, x3), e3;
  }
  function ghn(l3) {
    var r3 = l3.sourceFormat;
    if (!uOe(r3)) {
      var e3 = "";
      Xc(e3);
    }
    return l3.data;
  }
  function yhn(l3) {
    var r3 = l3.sourceFormat, e3 = l3.data;
    if (!uOe(r3)) {
      var u = "";
      Xc(u);
    }
    if (r3 === b1) {
      for (var h = [], v4 = 0, m3 = e3.length; v4 < m3; v4++)
        h.push(e3[v4].slice());
      return h;
    } else if (r3 === C2) {
      for (var h = [], v4 = 0, m3 = e3.length; v4 < m3; v4++)
        h.push(fi({}, e3[v4]));
      return h;
    }
  }
  function mhn(l3, r3, e3) {
    if (e3 != null) {
      if (Vc(e3) || !isNaN(e3) && !vo(r3, e3))
        return l3[e3];
      if (vo(r3, e3))
        return r3[e3];
    }
  }
  function bhn(l3) {
    return bs(l3);
  }
  var lft = Ho();
  function _hn(l3) {
    l3 = bs(l3);
    var r3 = l3.type, e3 = "";
    r3 || Xc(e3);
    var u = r3.split(":");
    u.length !== 2 && Xc(e3);
    var h = false;
    u[0] === "echarts" && (r3 = u[1], h = true), l3.__isBuiltIn = h, lft.set(r3, l3);
  }
  function xhn(l3, r3, e3) {
    var u = Gf(l3), h = u.length, v4 = "";
    h || Xc(v4);
    for (var m3 = 0, x3 = h; m3 < x3; m3++) {
      var C = u[m3];
      r3 = whn(C, r3), m3 !== x3 - 1 && (r3.length = Math.max(r3.length, 1));
    }
    return r3;
  }
  function whn(l3, r3, e3, u) {
    var h = "";
    r3.length || Xc(h), ls(l3) || Xc(h);
    var v4 = l3.type, m3 = lft.get(v4);
    m3 || Xc(h);
    var x3 = Bi(r3, function(A2) {
      return vhn(A2, m3);
    }), C = Gf(m3.transform({ upstream: x3[0], upstreamList: x3, config: bs(l3.config) }));
    return Bi(C, function(A2, D) {
      var P = "";
      ls(A2) || Xc(P), A2.data || Xc(P);
      var N = Qct(A2.data);
      uOe(N) || Xc(P);
      var j, W = r3[0];
      if (W && D === 0 && !A2.dimensions) {
        var K = W.startIndex;
        K && (A2.data = W.data.slice(0, K).concat(A2.data)), j = { seriesLayoutBy: GA, sourceHeader: K, dimensions: W.metaRawOption.dimensions };
      } else
        j = { seriesLayoutBy: GA, sourceHeader: 0, dimensions: A2.dimensions };
      return rke(A2.data, j, null);
    });
  }
  function uOe(l3) {
    return l3 === b1 || l3 === C2;
  }
  var spe = "undefined", Shn = typeof Uint32Array === spe ? Array : Uint32Array, Chn = typeof Uint16Array === spe ? Array : Uint16Array, uft = typeof Int32Array === spe ? Array : Int32Array, Fnt = typeof Float64Array === spe ? Array : Float64Array, cft = { float: Fnt, int: uft, ordinal: Array, number: Array, time: Fnt }, DEe;
  function ZK(l3) {
    return l3 > 65535 ? Shn : Chn;
  }
  function Ez() {
    return [1 / 0, -1 / 0];
  }
  function Mhn(l3) {
    var r3 = l3.constructor;
    return r3 === Array ? l3.slice() : new r3(l3);
  }
  function Vnt(l3, r3, e3, u, h) {
    var v4 = cft[e3 || "float"];
    if (h) {
      var m3 = l3[r3], x3 = m3 && m3.length;
      if (x3 !== u) {
        for (var C = new v4(u), A2 = 0; A2 < x3; A2++)
          C[A2] = m3[A2];
        l3[r3] = C;
      }
    } else
      l3[r3] = new v4(u);
  }
  var ike = function() {
    function l3() {
      this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = Ho();
    }
    return l3.prototype.initData = function(r3, e3, u) {
      this._provider = r3, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
      var h = r3.getSource(), v4 = this.defaultDimValueGetter = DEe[h.sourceFormat];
      this._dimValueGetter = u || v4, this._rawExtent = [], eft(h), this._dimensions = Bi(e3, function(m3) {
        return { type: m3.type, property: m3.property };
      }), this._initDataFromProvider(0, r3.count());
    }, l3.prototype.getProvider = function() {
      return this._provider;
    }, l3.prototype.getSource = function() {
      return this._provider.getSource();
    }, l3.prototype.ensureCalculationDimension = function(r3, e3) {
      var u = this._calcDimNameToIdx, h = this._dimensions, v4 = u.get(r3);
      if (v4 != null) {
        if (h[v4].type === e3)
          return v4;
      } else
        v4 = h.length;
      return h[v4] = { type: e3 }, u.set(r3, v4), this._chunks[v4] = new cft[e3 || "float"](this._rawCount), this._rawExtent[v4] = Ez(), v4;
    }, l3.prototype.collectOrdinalMeta = function(r3, e3) {
      var u = this._chunks[r3], h = this._dimensions[r3], v4 = this._rawExtent, m3 = h.ordinalOffset || 0, x3 = u.length;
      m3 === 0 && (v4[r3] = Ez());
      for (var C = v4[r3], A2 = m3; A2 < x3; A2++) {
        var D = u[A2] = e3.parseAndCollect(u[A2]);
        C[0] = Math.min(D, C[0]), C[1] = Math.max(D, C[1]);
      }
      h.ordinalMeta = e3, h.ordinalOffset = x3, h.type = "ordinal";
    }, l3.prototype.getOrdinalMeta = function(r3) {
      var e3 = this._dimensions[r3], u = e3.ordinalMeta;
      return u;
    }, l3.prototype.getDimensionProperty = function(r3) {
      var e3 = this._dimensions[r3];
      return e3 && e3.property;
    }, l3.prototype.appendData = function(r3) {
      var e3 = this._provider, u = this.count();
      e3.appendData(r3);
      var h = e3.count();
      return e3.persistent || (h += u), u < h && this._initDataFromProvider(u, h, true), [u, h];
    }, l3.prototype.appendValues = function(r3, e3) {
      for (var u = this._chunks, h = this._dimensions, v4 = h.length, m3 = this._rawExtent, x3 = this.count(), C = x3 + Math.max(r3.length, e3 || 0), A2 = 0; A2 < v4; A2++) {
        var D = h[A2];
        Vnt(u, A2, D.type, C, true);
      }
      for (var P = [], N = x3; N < C; N++)
        for (var j = N - x3, W = 0; W < v4; W++) {
          var D = h[W], K = DEe.arrayRows.call(this, r3[j] || P, D.property, j, W);
          u[W][N] = K;
          var te = m3[W];
          K < te[0] && (te[0] = K), K > te[1] && (te[1] = K);
        }
      return this._rawCount = this._count = C, { start: x3, end: C };
    }, l3.prototype._initDataFromProvider = function(r3, e3, u) {
      for (var h = this._provider, v4 = this._chunks, m3 = this._dimensions, x3 = m3.length, C = this._rawExtent, A2 = Bi(m3, function(ce) {
        return ce.property;
      }), D = 0; D < x3; D++) {
        var P = m3[D];
        C[D] || (C[D] = Ez()), Vnt(v4, D, P.type, e3, u);
      }
      if (h.fillStorage)
        h.fillStorage(r3, e3, v4, C);
      else
        for (var N = [], j = r3; j < e3; j++) {
          N = h.getItem(j, N);
          for (var W = 0; W < x3; W++) {
            var K = v4[W], te = this._dimValueGetter(N, A2[W], j, W);
            K[j] = te;
            var ne = C[W];
            te < ne[0] && (ne[0] = te), te > ne[1] && (ne[1] = te);
          }
        }
      !h.persistent && h.clean && h.clean(), this._rawCount = this._count = e3, this._extent = [];
    }, l3.prototype.count = function() {
      return this._count;
    }, l3.prototype.get = function(r3, e3) {
      if (!(e3 >= 0 && e3 < this._count))
        return NaN;
      var u = this._chunks[r3];
      return u ? u[this.getRawIndex(e3)] : NaN;
    }, l3.prototype.getValues = function(r3, e3) {
      var u = [], h = [];
      if (e3 == null) {
        e3 = r3, r3 = [];
        for (var v4 = 0; v4 < this._dimensions.length; v4++)
          h.push(v4);
      } else
        h = r3;
      for (var v4 = 0, m3 = h.length; v4 < m3; v4++)
        u.push(this.get(h[v4], e3));
      return u;
    }, l3.prototype.getByRawIndex = function(r3, e3) {
      if (!(e3 >= 0 && e3 < this._rawCount))
        return NaN;
      var u = this._chunks[r3];
      return u ? u[e3] : NaN;
    }, l3.prototype.getSum = function(r3) {
      var e3 = this._chunks[r3], u = 0;
      if (e3)
        for (var h = 0, v4 = this.count(); h < v4; h++) {
          var m3 = this.get(r3, h);
          isNaN(m3) || (u += m3);
        }
      return u;
    }, l3.prototype.getMedian = function(r3) {
      var e3 = [];
      this.each([r3], function(v4) {
        isNaN(v4) || e3.push(v4);
      });
      var u = e3.sort(function(v4, m3) {
        return v4 - m3;
      }), h = this.count();
      return h === 0 ? 0 : h % 2 === 1 ? u[(h - 1) / 2] : (u[h / 2] + u[h / 2 - 1]) / 2;
    }, l3.prototype.indexOfRawIndex = function(r3) {
      if (r3 >= this._rawCount || r3 < 0)
        return -1;
      if (!this._indices)
        return r3;
      var e3 = this._indices, u = e3[r3];
      if (u != null && u < this._count && u === r3)
        return r3;
      for (var h = 0, v4 = this._count - 1; h <= v4; ) {
        var m3 = (h + v4) / 2 | 0;
        if (e3[m3] < r3)
          h = m3 + 1;
        else if (e3[m3] > r3)
          v4 = m3 - 1;
        else
          return m3;
      }
      return -1;
    }, l3.prototype.indicesOfNearest = function(r3, e3, u) {
      var h = this._chunks, v4 = h[r3], m3 = [];
      if (!v4)
        return m3;
      u == null && (u = 1 / 0);
      for (var x3 = 1 / 0, C = -1, A2 = 0, D = 0, P = this.count(); D < P; D++) {
        var N = this.getRawIndex(D), j = e3 - v4[N], W = Math.abs(j);
        W <= u && ((W < x3 || W === x3 && j >= 0 && C < 0) && (x3 = W, C = j, A2 = 0), j === C && (m3[A2++] = D));
      }
      return m3.length = A2, m3;
    }, l3.prototype.getIndices = function() {
      var r3, e3 = this._indices;
      if (e3) {
        var u = e3.constructor, h = this._count;
        if (u === Array) {
          r3 = new u(h);
          for (var v4 = 0; v4 < h; v4++)
            r3[v4] = e3[v4];
        } else
          r3 = new u(e3.buffer, 0, h);
      } else {
        var u = ZK(this._rawCount);
        r3 = new u(this.count());
        for (var v4 = 0; v4 < r3.length; v4++)
          r3[v4] = v4;
      }
      return r3;
    }, l3.prototype.filter = function(r3, e3) {
      if (!this._count)
        return this;
      for (var u = this.clone(), h = u.count(), v4 = ZK(u._rawCount), m3 = new v4(h), x3 = [], C = r3.length, A2 = 0, D = r3[0], P = u._chunks, N = 0; N < h; N++) {
        var j = void 0, W = u.getRawIndex(N);
        if (C === 0)
          j = e3(N);
        else if (C === 1) {
          var K = P[D][W];
          j = e3(K, N);
        } else {
          for (var te = 0; te < C; te++)
            x3[te] = P[r3[te]][W];
          x3[te] = N, j = e3.apply(null, x3);
        }
        j && (m3[A2++] = W);
      }
      return A2 < h && (u._indices = m3), u._count = A2, u._extent = [], u._updateGetRawIdx(), u;
    }, l3.prototype.selectRange = function(r3) {
      var e3 = this.clone(), u = e3._count;
      if (!u)
        return this;
      var h = yu(r3), v4 = h.length;
      if (!v4)
        return this;
      var m3 = e3.count(), x3 = ZK(e3._rawCount), C = new x3(m3), A2 = 0, D = h[0], P = r3[D][0], N = r3[D][1], j = e3._chunks, W = false;
      if (!e3._indices) {
        var K = 0;
        if (v4 === 1) {
          for (var te = j[h[0]], ne = 0; ne < u; ne++) {
            var ce = te[ne];
            (ce >= P && ce <= N || isNaN(ce)) && (C[A2++] = K), K++;
          }
          W = true;
        } else if (v4 === 2) {
          for (var te = j[h[0]], me = j[h[1]], ve = r3[h[1]][0], Be = r3[h[1]][1], ne = 0; ne < u; ne++) {
            var ce = te[ne], Oe = me[ne];
            (ce >= P && ce <= N || isNaN(ce)) && (Oe >= ve && Oe <= Be || isNaN(Oe)) && (C[A2++] = K), K++;
          }
          W = true;
        }
      }
      if (!W)
        if (v4 === 1)
          for (var ne = 0; ne < m3; ne++) {
            var We = e3.getRawIndex(ne), ce = j[h[0]][We];
            (ce >= P && ce <= N || isNaN(ce)) && (C[A2++] = We);
          }
        else
          for (var ne = 0; ne < m3; ne++) {
            for (var Ue = true, We = e3.getRawIndex(ne), qe = 0; qe < v4; qe++) {
              var Ze = h[qe], ce = j[Ze][We];
              (ce < r3[Ze][0] || ce > r3[Ze][1]) && (Ue = false);
            }
            Ue && (C[A2++] = e3.getRawIndex(ne));
          }
      return A2 < m3 && (e3._indices = C), e3._count = A2, e3._extent = [], e3._updateGetRawIdx(), e3;
    }, l3.prototype.map = function(r3, e3) {
      var u = this.clone(r3);
      return this._updateDims(u, r3, e3), u;
    }, l3.prototype.modify = function(r3, e3) {
      this._updateDims(this, r3, e3);
    }, l3.prototype._updateDims = function(r3, e3, u) {
      for (var h = r3._chunks, v4 = [], m3 = e3.length, x3 = r3.count(), C = [], A2 = r3._rawExtent, D = 0; D < e3.length; D++)
        A2[e3[D]] = Ez();
      for (var P = 0; P < x3; P++) {
        for (var N = r3.getRawIndex(P), j = 0; j < m3; j++)
          C[j] = h[e3[j]][N];
        C[m3] = P;
        var W = u && u.apply(null, C);
        if (W != null) {
          typeof W != "object" && (v4[0] = W, W = v4);
          for (var D = 0; D < W.length; D++) {
            var K = e3[D], te = W[D], ne = A2[K], ce = h[K];
            ce && (ce[N] = te), te < ne[0] && (ne[0] = te), te > ne[1] && (ne[1] = te);
          }
        }
      }
    }, l3.prototype.lttbDownSample = function(r3, e3) {
      var u = this.clone([r3], true), h = u._chunks, v4 = h[r3], m3 = this.count(), x3 = 0, C = Math.floor(1 / e3), A2 = this.getRawIndex(0), D, P, N, j = new (ZK(this._rawCount))(Math.min((Math.ceil(m3 / C) + 2) * 2, m3));
      j[x3++] = A2;
      for (var W = 1; W < m3 - 1; W += C) {
        for (var K = Math.min(W + C, m3 - 1), te = Math.min(W + C * 2, m3), ne = (te + K) / 2, ce = 0, me = K; me < te; me++) {
          var ve = this.getRawIndex(me), Be = v4[ve];
          isNaN(Be) || (ce += Be);
        }
        ce /= te - K;
        var Oe = W, We = Math.min(W + C, m3), Ue = W - 1, qe = v4[A2];
        D = -1, N = Oe;
        for (var Ze = -1, ct = 0, me = Oe; me < We; me++) {
          var ve = this.getRawIndex(me), Be = v4[ve];
          if (isNaN(Be)) {
            ct++, Ze < 0 && (Ze = ve);
            continue;
          }
          P = Math.abs((Ue - ne) * (Be - qe) - (Ue - me) * (ce - qe)), P > D && (D = P, N = ve);
        }
        ct > 0 && ct < We - Oe && (j[x3++] = Math.min(Ze, N), N = Math.max(Ze, N)), j[x3++] = N, A2 = N;
      }
      return j[x3++] = this.getRawIndex(m3 - 1), u._count = x3, u._indices = j, u.getRawIndex = this._getRawIdx, u;
    }, l3.prototype.downSample = function(r3, e3, u, h) {
      for (var v4 = this.clone([r3], true), m3 = v4._chunks, x3 = [], C = Math.floor(1 / e3), A2 = m3[r3], D = this.count(), P = v4._rawExtent[r3] = Ez(), N = new (ZK(this._rawCount))(Math.ceil(D / C)), j = 0, W = 0; W < D; W += C) {
        C > D - W && (C = D - W, x3.length = C);
        for (var K = 0; K < C; K++) {
          var te = this.getRawIndex(W + K);
          x3[K] = A2[te];
        }
        var ne = u(x3), ce = this.getRawIndex(Math.min(W + h(x3, ne) || 0, D - 1));
        A2[ce] = ne, ne < P[0] && (P[0] = ne), ne > P[1] && (P[1] = ne), N[j++] = ce;
      }
      return v4._count = j, v4._indices = N, v4._updateGetRawIdx(), v4;
    }, l3.prototype.each = function(r3, e3) {
      if (!!this._count)
        for (var u = r3.length, h = this._chunks, v4 = 0, m3 = this.count(); v4 < m3; v4++) {
          var x3 = this.getRawIndex(v4);
          switch (u) {
            case 0:
              e3(v4);
              break;
            case 1:
              e3(h[r3[0]][x3], v4);
              break;
            case 2:
              e3(h[r3[0]][x3], h[r3[1]][x3], v4);
              break;
            default:
              for (var C = 0, A2 = []; C < u; C++)
                A2[C] = h[r3[C]][x3];
              A2[C] = v4, e3.apply(null, A2);
          }
        }
    }, l3.prototype.getDataExtent = function(r3) {
      var e3 = this._chunks[r3], u = Ez();
      if (!e3)
        return u;
      var h = this.count(), v4 = !this._indices, m3;
      if (v4)
        return this._rawExtent[r3].slice();
      if (m3 = this._extent[r3], m3)
        return m3.slice();
      m3 = u;
      for (var x3 = m3[0], C = m3[1], A2 = 0; A2 < h; A2++) {
        var D = this.getRawIndex(A2), P = e3[D];
        P < x3 && (x3 = P), P > C && (C = P);
      }
      return m3 = [x3, C], this._extent[r3] = m3, m3;
    }, l3.prototype.getRawDataItem = function(r3) {
      var e3 = this.getRawIndex(r3);
      if (this._provider.persistent)
        return this._provider.getItem(e3);
      for (var u = [], h = this._chunks, v4 = 0; v4 < h.length; v4++)
        u.push(h[v4][e3]);
      return u;
    }, l3.prototype.clone = function(r3, e3) {
      var u = new l3(), h = this._chunks, v4 = r3 && WA(r3, function(x3, C) {
        return x3[C] = true, x3;
      }, {});
      if (v4)
        for (var m3 = 0; m3 < h.length; m3++)
          u._chunks[m3] = v4[m3] ? Mhn(h[m3]) : h[m3];
      else
        u._chunks = h;
      return this._copyCommonProps(u), e3 || (u._indices = this._cloneIndices()), u._updateGetRawIdx(), u;
    }, l3.prototype._copyCommonProps = function(r3) {
      r3._count = this._count, r3._rawCount = this._rawCount, r3._provider = this._provider, r3._dimensions = this._dimensions, r3._extent = bs(this._extent), r3._rawExtent = bs(this._rawExtent);
    }, l3.prototype._cloneIndices = function() {
      if (this._indices) {
        var r3 = this._indices.constructor, e3 = void 0;
        if (r3 === Array) {
          var u = this._indices.length;
          e3 = new r3(u);
          for (var h = 0; h < u; h++)
            e3[h] = this._indices[h];
        } else
          e3 = new r3(this._indices);
        return e3;
      }
      return null;
    }, l3.prototype._getRawIdxIdentity = function(r3) {
      return r3;
    }, l3.prototype._getRawIdx = function(r3) {
      return r3 < this._count && r3 >= 0 ? this._indices[r3] : -1;
    }, l3.prototype._updateGetRawIdx = function() {
      this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
    }, l3.internalField = function() {
      function r3(e3, u, h, v4) {
        return XO(e3[v4], this._dimensions[v4]);
      }
      DEe = { arrayRows: r3, objectRows: function(e3, u, h, v4) {
        return XO(e3[u], this._dimensions[v4]);
      }, keyedColumns: r3, original: function(e3, u, h, v4) {
        var m3 = e3 && (e3.value == null ? e3 : e3.value);
        return XO(m3 instanceof Array ? m3[v4] : m3, this._dimensions[v4]);
      }, typedArray: function(e3, u, h, v4) {
        return e3[v4];
      } };
    }(), l3;
  }(), fft = function() {
    function l3(r3) {
      this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = r3;
    }
    return l3.prototype.dirty = function() {
      this._setLocalSource([], []), this._storeList = [], this._dirty = true;
    }, l3.prototype._setLocalSource = function(r3, e3) {
      this._sourceList = r3, this._upstreamSignList = e3, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
    }, l3.prototype._getVersionSign = function() {
      return this._sourceHost.uid + "_" + this._versionSignBase;
    }, l3.prototype.prepareSource = function() {
      this._isDirty() && (this._createSource(), this._dirty = false);
    }, l3.prototype._createSource = function() {
      this._setLocalSource([], []);
      var r3 = this._sourceHost, e3 = this._getUpstreamSourceManagers(), u = !!e3.length, h, v4;
      if (Tce(r3)) {
        var m3 = r3, x3 = void 0, C = void 0, A2 = void 0;
        if (u) {
          var D = e3[0];
          D.prepareSource(), A2 = D.getSource(), x3 = A2.data, C = A2.sourceFormat, v4 = [D._getVersionSign()];
        } else
          x3 = m3.get("data", true), C = ew(x3) ? $O : S2, v4 = [];
        var P = this._getSourceMetaRawOption() || {}, N = A2 && A2.metaRawOption || {}, j = dl(P.seriesLayoutBy, N.seriesLayoutBy) || null, W = dl(P.sourceHeader, N.sourceHeader), K = dl(P.dimensions, N.dimensions), te = j !== N.seriesLayoutBy || !!W != !!N.sourceHeader || K;
        h = te ? [rke(x3, { seriesLayoutBy: j, sourceHeader: W, dimensions: K }, C)] : [];
      } else {
        var ne = r3;
        if (u) {
          var ce = this._applyTransform(e3);
          h = ce.sourceList, v4 = ce.upstreamSignList;
        } else {
          var me = ne.get("source", true);
          h = [rke(me, this._getSourceMetaRawOption(), null)], v4 = [];
        }
      }
      this._setLocalSource(h, v4);
    }, l3.prototype._applyTransform = function(r3) {
      var e3 = this._sourceHost, u = e3.get("transform", true), h = e3.get("fromTransformResult", true);
      if (h != null) {
        var v4 = "";
        r3.length !== 1 && znt(v4);
      }
      var m3, x3 = [], C = [];
      return mt(r3, function(A2) {
        A2.prepareSource();
        var D = A2.getSource(h || 0), P = "";
        h != null && !D && znt(P), x3.push(D), C.push(A2._getVersionSign());
      }), u ? m3 = xhn(u, x3, { datasetIndex: e3.componentIndex }) : h != null && (m3 = [nhn(x3[0])]), { sourceList: m3, upstreamSignList: C };
    }, l3.prototype._isDirty = function() {
      if (this._dirty)
        return true;
      for (var r3 = this._getUpstreamSourceManagers(), e3 = 0; e3 < r3.length; e3++) {
        var u = r3[e3];
        if (u._isDirty() || this._upstreamSignList[e3] !== u._getVersionSign())
          return true;
      }
    }, l3.prototype.getSource = function(r3) {
      r3 = r3 || 0;
      var e3 = this._sourceList[r3];
      if (!e3) {
        var u = this._getUpstreamSourceManagers();
        return u[0] && u[0].getSource(r3);
      }
      return e3;
    }, l3.prototype.getSharedDataStore = function(r3) {
      var e3 = r3.makeStoreSchema();
      return this._innerGetDataStore(e3.dimensions, r3.source, e3.hash);
    }, l3.prototype._innerGetDataStore = function(r3, e3, u) {
      var h = 0, v4 = this._storeList, m3 = v4[h];
      m3 || (m3 = v4[h] = {});
      var x3 = m3[u];
      if (!x3) {
        var C = this._getUpstreamSourceManagers()[0];
        Tce(this._sourceHost) && C ? x3 = C._innerGetDataStore(r3, e3, u) : (x3 = new ike(), x3.initData(new tft(e3, r3.length), r3)), m3[u] = x3;
      }
      return x3;
    }, l3.prototype._getUpstreamSourceManagers = function() {
      var r3 = this._sourceHost;
      if (Tce(r3)) {
        var e3 = rOe(r3);
        return e3 ? [e3.getSourceManager()] : [];
      } else
        return Bi(Ifn(r3), function(u) {
          return u.getSourceManager();
        });
    }, l3.prototype._getSourceMetaRawOption = function() {
      var r3 = this._sourceHost, e3, u, h;
      if (Tce(r3))
        e3 = r3.get("seriesLayoutBy", true), u = r3.get("sourceHeader", true), h = r3.get("dimensions", true);
      else if (!this._getUpstreamSourceManagers().length) {
        var v4 = r3;
        e3 = v4.get("seriesLayoutBy", true), u = v4.get("sourceHeader", true), h = v4.get("dimensions", true);
      }
      return { seriesLayoutBy: e3, sourceHeader: u, dimensions: h };
    }, l3;
  }();
  function Bnt(l3) {
    var r3 = l3.option.transform;
    r3 && Ffe(l3.option.transform);
  }
  function Tce(l3) {
    return l3.mainType === "series";
  }
  function znt(l3) {
    throw new Error(l3);
  }
  var hft = "line-height:1";
  function pft(l3, r3) {
    var e3 = l3.color || "#6e7079", u = l3.fontSize || 12, h = l3.fontWeight || "400", v4 = l3.color || "#464646", m3 = l3.fontSize || 14, x3 = l3.fontWeight || "900";
    return r3 === "html" ? { nameStyle: "font-size:" + Yx(u + "") + "px;color:" + Yx(e3) + ";font-weight:" + Yx(h + ""), valueStyle: "font-size:" + Yx(m3 + "") + "px;color:" + Yx(v4) + ";font-weight:" + Yx(x3 + "") } : { nameStyle: { fontSize: u, fill: e3, fontWeight: h }, valueStyle: { fontSize: m3, fill: v4, fontWeight: x3 } };
  }
  var Thn = [0, 10, 20, 30], Ahn = ["", `
`, `

`, `


`];
  function o0(l3, r3) {
    return r3.type = l3, r3;
  }
  function ake(l3) {
    return l3.type === "section";
  }
  function dft(l3) {
    return ake(l3) ? Ihn : Ehn;
  }
  function vft(l3) {
    if (ake(l3)) {
      var r3 = 0, e3 = l3.blocks.length, u = e3 > 1 || e3 > 0 && !l3.noHeader;
      return mt(l3.blocks, function(h) {
        var v4 = vft(h);
        v4 >= r3 && (r3 = v4 + +(u && (!v4 || ake(h) && !h.noHeader)));
      }), r3;
    }
    return 0;
  }
  function Ihn(l3, r3, e3, u) {
    var h = r3.noHeader, v4 = Dhn(vft(r3)), m3 = [], x3 = r3.blocks || [];
    mb(!x3 || Ni(x3)), x3 = x3 || [];
    var C = l3.orderMode;
    if (r3.sortBlocks && C) {
      x3 = x3.slice();
      var A2 = { valueAsc: "asc", valueDesc: "desc" };
      if (vo(A2, C)) {
        var D = new sft(A2[C], null);
        x3.sort(function(W, K) {
          return D.evaluate(W.sortParam, K.sortParam);
        });
      } else
        C === "seriesDesc" && x3.reverse();
    }
    mt(x3, function(W, K) {
      var te = r3.valueFormatter, ne = dft(W)(te ? fi(fi({}, l3), { valueFormatter: te }) : l3, W, K > 0 ? v4.html : 0, u);
      ne != null && m3.push(ne);
    });
    var P = l3.renderMode === "richText" ? m3.join(v4.richText) : oke(m3.join(""), h ? e3 : v4.html);
    if (h)
      return P;
    var N = eke(r3.header, "ordinal", l3.useUTC), j = pft(u, l3.renderMode).nameStyle;
    return l3.renderMode === "richText" ? gft(l3, N, j) + v4.richText + P : oke('<div style="' + j + ";" + hft + ';">' + Yx(N) + "</div>" + P, e3);
  }
  function Ehn(l3, r3, e3, u) {
    var h = l3.renderMode, v4 = r3.noName, m3 = r3.noValue, x3 = !r3.markerType, C = r3.name, A2 = l3.useUTC, D = r3.valueFormatter || l3.valueFormatter || function(ve) {
      return ve = Ni(ve) ? ve : [ve], Bi(ve, function(Be, Oe) {
        return eke(Be, Ni(j) ? j[Oe] : j, A2);
      });
    };
    if (!(v4 && m3)) {
      var P = x3 ? "" : l3.markupStyleCreator.makeTooltipMarker(r3.markerType, r3.markerColor || "#333", h), N = v4 ? "" : eke(C, "ordinal", A2), j = r3.valueType, W = m3 ? [] : D(r3.value), K = !x3 || !v4, te = !x3 && v4, ne = pft(u, h), ce = ne.nameStyle, me = ne.valueStyle;
      return h === "richText" ? (x3 ? "" : P) + (v4 ? "" : gft(l3, N, ce)) + (m3 ? "" : Phn(l3, W, K, te, me)) : oke((x3 ? "" : P) + (v4 ? "" : khn(N, !x3, ce)) + (m3 ? "" : Ohn(W, K, te, me)), e3);
    }
  }
  function jnt(l3, r3, e3, u, h, v4) {
    if (!!l3) {
      var m3 = dft(l3), x3 = { useUTC: h, renderMode: e3, orderMode: u, markupStyleCreator: r3, valueFormatter: l3.valueFormatter };
      return m3(x3, l3, 0, v4);
    }
  }
  function Dhn(l3) {
    return { html: Thn[l3], richText: Ahn[l3] };
  }
  function oke(l3, r3) {
    var e3 = '<div style="clear:both"></div>', u = "margin: " + r3 + "px 0 0";
    return '<div style="' + u + ";" + hft + ';">' + l3 + e3 + "</div>";
  }
  function khn(l3, r3, e3) {
    var u = r3 ? "margin-left:2px" : "";
    return '<span style="' + e3 + ";" + u + '">' + Yx(l3) + "</span>";
  }
  function Ohn(l3, r3, e3, u) {
    var h = e3 ? "10px" : "20px", v4 = r3 ? "float:right;margin-left:" + h : "";
    return l3 = Ni(l3) ? l3 : [l3], '<span style="' + v4 + ";" + u + '">' + Bi(l3, function(m3) {
      return Yx(m3);
    }).join("&nbsp;&nbsp;") + "</span>";
  }
  function gft(l3, r3, e3) {
    return l3.markupStyleCreator.wrapRichTextStyle(r3, e3);
  }
  function Phn(l3, r3, e3, u, h) {
    var v4 = [h], m3 = u ? 10 : 20;
    return e3 && v4.push({ padding: [0, 0, 0, m3], align: "right" }), l3.markupStyleCreator.wrapRichTextStyle(Ni(r3) ? r3.join("  ") : r3, v4);
  }
  function yft(l3, r3) {
    var e3 = l3.getData().getItemVisual(r3, "style"), u = e3[l3.visualDrawType];
    return $N(u);
  }
  function mft(l3, r3) {
    var e3 = l3.get("padding");
    return e3 != null ? e3 : r3 === "richText" ? [8, 10] : 10;
  }
  var kEe = function() {
    function l3() {
      this.richTextStyles = {}, this._nextStyleNameId = gut();
    }
    return l3.prototype._generateStyleName = function() {
      return "__EC_aUTo_" + this._nextStyleNameId++;
    }, l3.prototype.makeTooltipMarker = function(r3, e3, u) {
      var h = u === "richText" ? this._generateStyleName() : null, v4 = xfn({ color: e3, type: r3, renderMode: u, markerId: h });
      return qa(v4) ? v4 : (this.richTextStyles[h] = v4.style, v4.content);
    }, l3.prototype.wrapRichTextStyle = function(r3, e3) {
      var u = {};
      Ni(e3) ? mt(e3, function(v4) {
        return fi(u, v4);
      }) : fi(u, e3);
      var h = this._generateStyleName();
      return this.richTextStyles[h] = u, "{" + h + "|" + r3 + "}";
    }, l3;
  }();
  function bft(l3) {
    var r3 = l3.series, e3 = l3.dataIndex, u = l3.multipleSeries, h = r3.getData(), v4 = h.mapDimensionsAll("defaultedTooltip"), m3 = v4.length, x3 = r3.getRawValue(e3), C = Ni(x3), A2 = yft(r3, e3), D, P, N, j;
    if (m3 > 1 || C && !m3) {
      var W = Lhn(x3, r3, e3, v4, A2);
      D = W.inlineValues, P = W.inlineValueTypes, N = W.blocks, j = W.inlineValues[0];
    } else if (m3) {
      var K = h.getDimensionInfo(v4[0]);
      j = D = hj(h, e3, v4[0]), P = K.type;
    } else
      j = D = C ? x3[0] : x3;
    var te = N3e(r3), ne = te && r3.name || "", ce = h.getName(e3), me = u ? ne : ce;
    return o0("section", { header: ne, noHeader: u || !te, sortParam: j, blocks: [o0("nameValue", { markerType: "item", markerColor: A2, name: me, noName: !hM(me), value: D, valueType: P })].concat(N || []) });
  }
  function Lhn(l3, r3, e3, u, h) {
    var v4 = r3.getData(), m3 = WA(l3, function(P, N, j) {
      var W = v4.getDimensionInfo(j);
      return P = P || W && W.tooltip !== false && W.displayName != null;
    }, false), x3 = [], C = [], A2 = [];
    u.length ? mt(u, function(P) {
      D(hj(v4, e3, P), P);
    }) : mt(l3, D);
    function D(P, N) {
      var j = v4.getDimensionInfo(N);
      !j || j.otherDims.tooltip === false || (m3 ? A2.push(o0("nameValue", { markerType: "subItem", markerColor: h, name: j.displayName, value: P, valueType: j.type })) : (x3.push(P), C.push(j.type)));
    }
    return { inlineValues: x3, inlineValueTypes: C, blocks: A2 };
  }
  var MO = pc();
  function Ace(l3, r3) {
    return l3.getName(r3) || l3.getId(r3);
  }
  var Ife = "__universalTransitionEnabled", lpe = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3._selectedDataIndicesMap = {}, e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      this.seriesIndex = this.componentIndex, this.dataTask = jZ({ count: Nhn, reset: Fhn }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(e3, h);
      var v4 = MO(this).sourceManager = new fft(this);
      v4.prepareSource();
      var m3 = this.getInitialData(e3, h);
      Hnt(m3, this), this.dataTask.context.data = m3, MO(this).dataBeforeProcessed = m3, Gnt(this), this._initSelectedMapFromData(m3);
    }, r3.prototype.mergeDefaultAndTheme = function(e3, u) {
      var h = lJ(this), v4 = h ? Ij(e3) : {}, m3 = this.subType;
      fc.hasClass(m3) && (m3 += "Series"), ol(e3, u.getTheme().get(this.subType)), ol(e3, this.getDefaultOption()), HN(e3, "label", ["show"]), this.fillDataTextStyle(e3.data), h && QO(e3, v4, h);
    }, r3.prototype.mergeOption = function(e3, u) {
      e3 = ol(this.option, e3, true), this.fillDataTextStyle(e3.data);
      var h = lJ(this);
      h && QO(this.option, e3, h);
      var v4 = MO(this).sourceManager;
      v4.dirty(), v4.prepareSource();
      var m3 = this.getInitialData(e3, u);
      Hnt(m3, this), this.dataTask.dirty(), this.dataTask.context.data = m3, MO(this).dataBeforeProcessed = m3, Gnt(this), this._initSelectedMapFromData(m3);
    }, r3.prototype.fillDataTextStyle = function(e3) {
      if (e3 && !ew(e3))
        for (var u = ["show"], h = 0; h < e3.length; h++)
          e3[h] && e3[h].label && HN(e3[h], "label", u);
    }, r3.prototype.getInitialData = function(e3, u) {
    }, r3.prototype.appendData = function(e3) {
      var u = this.getRawData();
      u.appendData(e3.data);
    }, r3.prototype.getData = function(e3) {
      var u = ske(this);
      if (u) {
        var h = u.context.data;
        return e3 == null ? h : h.getLinkedData(e3);
      } else
        return MO(this).data;
    }, r3.prototype.getAllData = function() {
      var e3 = this.getData();
      return e3 && e3.getLinkedDataAll ? e3.getLinkedDataAll() : [{ data: e3 }];
    }, r3.prototype.setData = function(e3) {
      var u = ske(this);
      if (u) {
        var h = u.context;
        h.outputData = e3, u !== this.dataTask && (h.data = e3);
      }
      MO(this).data = e3;
    }, r3.prototype.getEncode = function() {
      var e3 = this.get("encode", true);
      if (e3)
        return Ho(e3);
    }, r3.prototype.getSourceManager = function() {
      return MO(this).sourceManager;
    }, r3.prototype.getSource = function() {
      return this.getSourceManager().getSource();
    }, r3.prototype.getRawData = function() {
      return MO(this).dataBeforeProcessed;
    }, r3.prototype.getColorBy = function() {
      var e3 = this.get("colorBy");
      return e3 || "series";
    }, r3.prototype.isColorBySeries = function() {
      return this.getColorBy() === "series";
    }, r3.prototype.getBaseAxis = function() {
      var e3 = this.coordinateSystem;
      return e3 && e3.getBaseAxis && e3.getBaseAxis();
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      return bft({ series: this, dataIndex: e3, multipleSeries: u });
    }, r3.prototype.isAnimationEnabled = function() {
      var e3 = this.ecModel;
      if (Fc.node && !(e3 && e3.ssr))
        return false;
      var u = this.getShallow("animation");
      return u && this.getData().count() > this.getShallow("animationThreshold") && (u = false), !!u;
    }, r3.prototype.restoreData = function() {
      this.dataTask.dirty();
    }, r3.prototype.getColorFromPalette = function(e3, u, h) {
      var v4 = this.ecModel, m3 = iOe.prototype.getColorFromPalette.call(this, e3, u, h);
      return m3 || (m3 = v4.getColorFromPalette(e3, u, h)), m3;
    }, r3.prototype.coordDimToDataDim = function(e3) {
      return this.getRawData().mapDimensionsAll(e3);
    }, r3.prototype.getProgressive = function() {
      return this.get("progressive");
    }, r3.prototype.getProgressiveThreshold = function() {
      return this.get("progressiveThreshold");
    }, r3.prototype.select = function(e3, u) {
      this._innerSelect(this.getData(u), e3);
    }, r3.prototype.unselect = function(e3, u) {
      var h = this.option.selectedMap;
      if (!!h) {
        var v4 = this.option.selectedMode, m3 = this.getData(u);
        if (v4 === "series" || h === "all") {
          this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
          return;
        }
        for (var x3 = 0; x3 < e3.length; x3++) {
          var C = e3[x3], A2 = Ace(m3, C);
          h[A2] = false, this._selectedDataIndicesMap[A2] = -1;
        }
      }
    }, r3.prototype.toggleSelect = function(e3, u) {
      for (var h = [], v4 = 0; v4 < e3.length; v4++)
        h[0] = e3[v4], this.isSelected(e3[v4], u) ? this.unselect(h, u) : this.select(h, u);
    }, r3.prototype.getSelectedDataIndices = function() {
      if (this.option.selectedMap === "all")
        return [].slice.call(this.getData().getIndices());
      for (var e3 = this._selectedDataIndicesMap, u = yu(e3), h = [], v4 = 0; v4 < u.length; v4++) {
        var m3 = e3[u[v4]];
        m3 >= 0 && h.push(m3);
      }
      return h;
    }, r3.prototype.isSelected = function(e3, u) {
      var h = this.option.selectedMap;
      if (!h)
        return false;
      var v4 = this.getData(u);
      return (h === "all" || h[Ace(v4, e3)]) && !v4.getItemModel(e3).get(["select", "disabled"]);
    }, r3.prototype.isUniversalTransitionEnabled = function() {
      if (this[Ife])
        return true;
      var e3 = this.option.universalTransition;
      return e3 ? e3 === true ? true : e3 && e3.enabled : false;
    }, r3.prototype._innerSelect = function(e3, u) {
      var h, v4, m3 = this.option, x3 = m3.selectedMode, C = u.length;
      if (!(!x3 || !C)) {
        if (x3 === "series")
          m3.selectedMap = "all";
        else if (x3 === "multiple") {
          ls(m3.selectedMap) || (m3.selectedMap = {});
          for (var A2 = m3.selectedMap, D = 0; D < C; D++) {
            var P = u[D], N = Ace(e3, P);
            A2[N] = true, this._selectedDataIndicesMap[N] = e3.getRawIndex(P);
          }
        } else if (x3 === "single" || x3 === true) {
          var j = u[C - 1], N = Ace(e3, j);
          m3.selectedMap = (h = {}, h[N] = true, h), this._selectedDataIndicesMap = (v4 = {}, v4[N] = e3.getRawIndex(j), v4);
        }
      }
    }, r3.prototype._initSelectedMapFromData = function(e3) {
      if (!this.option.selectedMap) {
        var u = [];
        e3.hasItemOption && e3.each(function(h) {
          var v4 = e3.getRawDataItem(h);
          v4 && v4.selected && u.push(h);
        }), u.length > 0 && this._innerSelect(e3, u);
      }
    }, r3.registerClass = function(e3) {
      return fc.registerClass(e3);
    }, r3.protoInitialize = function() {
      var e3 = r3.prototype;
      e3.type = "series.__base__", e3.seriesIndex = 0, e3.ignoreStyleOnData = false, e3.hasSymbolVisual = false, e3.defaultSymbol = "circle", e3.visualStyleAccessPath = "itemStyle", e3.visualDrawType = "fill";
    }(), r3;
  }(fc);
  Fv(lpe, lOe);
  Fv(lpe, iOe);
  Mut(lpe, fc);
  function Gnt(l3) {
    var r3 = l3.name;
    N3e(l3) || (l3.name = Rhn(l3) || r3);
  }
  function Rhn(l3) {
    var r3 = l3.getRawData(), e3 = r3.mapDimensionsAll("seriesName"), u = [];
    return mt(e3, function(h) {
      var v4 = r3.getDimensionInfo(h);
      v4.displayName && u.push(v4.displayName);
    }), u.join(" ");
  }
  function Nhn(l3) {
    return l3.model.getRawData().count();
  }
  function Fhn(l3) {
    var r3 = l3.model;
    return r3.setData(r3.getRawData().cloneShallow()), Vhn;
  }
  function Vhn(l3, r3) {
    r3.outputData && l3.end > r3.outputData.count() && r3.model.getRawData().cloneShallow(r3.outputData);
  }
  function Hnt(l3, r3) {
    mt(b5e(l3.CHANGABLE_METHODS, l3.DOWNSAMPLE_METHODS), function(e3) {
      l3.wrapMethod(e3, Fs(Bhn, r3));
    });
  }
  function Bhn(l3, r3) {
    var e3 = ske(l3);
    return e3 && e3.setOutputEnd((r3 || this).count()), r3;
  }
  function ske(l3) {
    var r3 = (l3.ecModel || {}).scheduler, e3 = r3 && r3.getPipeline(l3.uid);
    if (e3) {
      var u = e3.currentTask;
      if (u) {
        var h = u.agentStubMap;
        h && (u = h.get(l3.uid));
      }
      return u;
    }
  }
  var Fp = lpe, cOe = function() {
    function l3() {
      this.group = new Cs(), this.uid = Tj("viewComponent");
    }
    return l3.prototype.init = function(r3, e3) {
    }, l3.prototype.render = function(r3, e3, u, h) {
    }, l3.prototype.dispose = function(r3, e3) {
    }, l3.prototype.updateView = function(r3, e3, u, h) {
    }, l3.prototype.updateLayout = function(r3, e3, u, h) {
    }, l3.prototype.updateVisual = function(r3, e3, u, h) {
    }, l3.prototype.blurSeries = function(r3, e3) {
    }, l3.prototype.eachRendered = function(r3) {
      var e3 = this.group;
      e3 && e3.traverse(r3);
    }, l3;
  }();
  V3e(cOe);
  Hhe(cOe);
  var yd = cOe;
  function kj() {
    var l3 = pc();
    return function(r3) {
      var e3 = l3(r3), u = r3.pipelineContext, h = !!e3.large, v4 = !!e3.progressiveRender, m3 = e3.large = !!(u && u.large), x3 = e3.progressiveRender = !!(u && u.progressiveRender);
      return (h !== m3 || v4 !== x3) && "reset";
    };
  }
  var _ft = pc(), zhn = kj(), fOe = function() {
    function l3() {
      this.group = new Cs(), this.uid = Tj("viewChart"), this.renderTask = jZ({ plan: jhn, reset: Ghn }), this.renderTask.context = { view: this };
    }
    return l3.prototype.init = function(r3, e3) {
    }, l3.prototype.render = function(r3, e3, u, h) {
    }, l3.prototype.highlight = function(r3, e3, u, h) {
      var v4 = r3.getData(h && h.dataType);
      !v4 || Unt(v4, h, "emphasis");
    }, l3.prototype.downplay = function(r3, e3, u, h) {
      var v4 = r3.getData(h && h.dataType);
      !v4 || Unt(v4, h, "normal");
    }, l3.prototype.remove = function(r3, e3) {
      this.group.removeAll();
    }, l3.prototype.dispose = function(r3, e3) {
    }, l3.prototype.updateView = function(r3, e3, u, h) {
      this.render(r3, e3, u, h);
    }, l3.prototype.updateLayout = function(r3, e3, u, h) {
      this.render(r3, e3, u, h);
    }, l3.prototype.updateVisual = function(r3, e3, u, h) {
      this.render(r3, e3, u, h);
    }, l3.prototype.eachRendered = function(r3) {
      oP(this.group, r3);
    }, l3.markUpdateMethod = function(r3, e3) {
      _ft(r3).updateMethod = e3;
    }, l3.protoInitialize = function() {
      var r3 = l3.prototype;
      r3.type = "chart";
    }(), l3;
  }();
  function Wnt(l3, r3, e3) {
    l3 && iJ(l3) && (r3 === "emphasis" ? zA : jA)(l3, e3);
  }
  function Unt(l3, r3, e3) {
    var u = WN(l3, r3), h = r3 && r3.highlightKey != null ? fcn(r3.highlightKey) : null;
    u != null ? mt(Gf(u), function(v4) {
      Wnt(l3.getItemGraphicEl(v4), e3, h);
    }) : l3.eachItemGraphicEl(function(v4) {
      Wnt(v4, e3, h);
    });
  }
  V3e(fOe);
  Hhe(fOe);
  function jhn(l3) {
    return zhn(l3.model);
  }
  function Ghn(l3) {
    var r3 = l3.model, e3 = l3.ecModel, u = l3.api, h = l3.payload, v4 = r3.pipelineContext.progressiveRender, m3 = l3.view, x3 = h && _ft(h).updateMethod, C = v4 ? "incrementalPrepareRender" : x3 && m3[x3] ? x3 : "render";
    return C !== "render" && m3[C](r3, e3, u, h), Hhn[C];
  }
  var Hhn = { incrementalPrepareRender: { progress: function(l3, r3) {
    r3.view.incrementalRender(l3, r3.model, r3.ecModel, r3.api, r3.payload);
  } }, render: { forceFirstProgress: true, progress: function(l3, r3) {
    r3.view.render(r3.model, r3.ecModel, r3.api, r3.payload);
  } } }, zh = fOe, ehe = "\0__throttleOriginMethod", qnt = "\0__throttleRate", $nt = "\0__throttleType";
  function hOe(l3, r3, e3) {
    var u, h = 0, v4 = 0, m3 = null, x3, C, A2, D;
    r3 = r3 || 0;
    function P() {
      v4 = new Date().getTime(), m3 = null, l3.apply(C, A2 || []);
    }
    var N = function() {
      for (var j = [], W = 0; W < arguments.length; W++)
        j[W] = arguments[W];
      u = new Date().getTime(), C = this, A2 = j;
      var K = D || r3, te = D || e3;
      D = null, x3 = u - (te ? h : v4) - K, clearTimeout(m3), te ? m3 = setTimeout(P, K) : x3 >= 0 ? P() : m3 = setTimeout(P, -x3), h = u;
    };
    return N.clear = function() {
      m3 && (clearTimeout(m3), m3 = null);
    }, N.debounceNextCall = function(j) {
      D = j;
    }, N;
  }
  function Oj(l3, r3, e3, u) {
    var h = l3[r3];
    if (!!h) {
      var v4 = h[ehe] || h, m3 = h[$nt], x3 = h[qnt];
      if (x3 !== e3 || m3 !== u) {
        if (e3 == null || !u)
          return l3[r3] = v4;
        h = l3[r3] = hOe(v4, e3, u === "debounce"), h[ehe] = v4, h[$nt] = u, h[qnt] = e3;
      }
      return h;
    }
  }
  function cJ(l3, r3) {
    var e3 = l3[r3];
    e3 && e3[ehe] && (e3.clear && e3.clear(), l3[r3] = e3[ehe]);
  }
  var Xnt = pc(), Ynt = { itemStyle: UN(Cct, true), lineStyle: UN(Sct, true) }, Whn = { lineStyle: "stroke", itemStyle: "fill" };
  function xft(l3, r3) {
    var e3 = l3.visualStyleMapper || Ynt[r3];
    return e3 || (console.warn("Unkown style type '" + r3 + "'."), Ynt.itemStyle);
  }
  function wft(l3, r3) {
    var e3 = l3.visualDrawType || Whn[r3];
    return e3 || (console.warn("Unkown style type '" + r3 + "'."), "fill");
  }
  var Uhn = { createOnAllSeries: true, performRawSeries: true, reset: function(l3, r3) {
    var e3 = l3.getData(), u = l3.visualStyleAccessPath || "itemStyle", h = l3.getModel(u), v4 = xft(l3, u), m3 = v4(h), x3 = h.getShallow("decal");
    x3 && (e3.setVisual("decal", x3), x3.dirty = true);
    var C = wft(l3, u), A2 = m3[C], D = Xo(A2) ? A2 : null, P = m3.fill === "auto" || m3.stroke === "auto";
    if (!m3[C] || D || P) {
      var N = l3.getColorFromPalette(l3.name, null, r3.getSeriesCount());
      m3[C] || (m3[C] = N, e3.setVisual("colorFromPalette", true)), m3.fill = m3.fill === "auto" || Xo(m3.fill) ? N : m3.fill, m3.stroke = m3.stroke === "auto" || Xo(m3.stroke) ? N : m3.stroke;
    }
    if (e3.setVisual("style", m3), e3.setVisual("drawType", C), !r3.isSeriesFiltered(l3) && D)
      return e3.setVisual("colorFromPalette", false), { dataEach: function(j, W) {
        var K = l3.getDataParams(W), te = fi({}, m3);
        te[C] = D(K), j.setItemVisual(W, "style", te);
      } };
  } }, JK = new Bh(), qhn = { createOnAllSeries: true, performRawSeries: true, reset: function(l3, r3) {
    if (!(l3.ignoreStyleOnData || r3.isSeriesFiltered(l3))) {
      var e3 = l3.getData(), u = l3.visualStyleAccessPath || "itemStyle", h = xft(l3, u), v4 = e3.getVisual("drawType");
      return { dataEach: e3.hasItemOption ? function(m3, x3) {
        var C = m3.getRawDataItem(x3);
        if (C && C[u]) {
          JK.option = C[u];
          var A2 = h(JK), D = m3.ensureUniqueItemVisual(x3, "style");
          fi(D, A2), JK.option.decal && (m3.setItemVisual(x3, "decal", JK.option.decal), JK.option.decal.dirty = true), v4 in A2 && m3.setItemVisual(x3, "colorFromPalette", false);
        }
      } : null };
    }
  } }, $hn = { performRawSeries: true, overallReset: function(l3) {
    var r3 = Ho();
    l3.eachSeries(function(e3) {
      var u = e3.getColorBy();
      if (!e3.isColorBySeries()) {
        var h = e3.type + "-" + u, v4 = r3.get(h);
        v4 || (v4 = {}, r3.set(h, v4)), Xnt(e3).scope = v4;
      }
    }), l3.eachSeries(function(e3) {
      if (!(e3.isColorBySeries() || l3.isSeriesFiltered(e3))) {
        var u = e3.getRawData(), h = {}, v4 = e3.getData(), m3 = Xnt(e3).scope, x3 = e3.visualStyleAccessPath || "itemStyle", C = wft(e3, x3);
        v4.each(function(A2) {
          var D = v4.getRawIndex(A2);
          h[D] = A2;
        }), u.each(function(A2) {
          var D = h[A2], P = v4.getItemVisual(D, "colorFromPalette");
          if (P) {
            var N = v4.ensureUniqueItemVisual(D, "style"), j = u.getName(A2) || A2 + "", W = u.count();
            N[C] = e3.getColorFromPalette(j, m3, W);
          }
        });
      }
    });
  } }, Ice = Math.PI;
  function Xhn(l3, r3) {
    r3 = r3 || {}, ns(r3, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
    var e3 = new Cs(), u = new Ju({ style: { fill: r3.maskColor }, zlevel: r3.zlevel, z: 1e4 });
    e3.add(u);
    var h = new Ec({ style: { text: r3.text, fill: r3.textColor, fontSize: r3.fontSize, fontWeight: r3.fontWeight, fontStyle: r3.fontStyle, fontFamily: r3.fontFamily }, zlevel: r3.zlevel, z: 10001 }), v4 = new Ju({ style: { fill: "none" }, textContent: h, textConfig: { position: "right", distance: 10 }, zlevel: r3.zlevel, z: 10001 });
    e3.add(v4);
    var m3;
    return r3.showSpinner && (m3 = new q3e({ shape: { startAngle: -Ice / 2, endAngle: -Ice / 2 + 0.1, r: r3.spinnerRadius }, style: { stroke: r3.color, lineCap: "round", lineWidth: r3.lineWidth }, zlevel: r3.zlevel, z: 10001 }), m3.animateShape(true).when(1e3, { endAngle: Ice * 3 / 2 }).start("circularInOut"), m3.animateShape(true).when(1e3, { startAngle: Ice * 3 / 2 }).delay(300).start("circularInOut"), e3.add(m3)), e3.resize = function() {
      var x3 = h.getBoundingRect().width, C = r3.showSpinner ? r3.spinnerRadius : 0, A2 = (l3.getWidth() - C * 2 - (r3.showSpinner && x3 ? 10 : 0) - x3) / 2 - (r3.showSpinner && x3 ? 0 : 5 + x3 / 2) + (r3.showSpinner ? 0 : x3 / 2) + (x3 ? 0 : C), D = l3.getHeight() / 2;
      r3.showSpinner && m3.setShape({ cx: A2, cy: D }), v4.setShape({ x: A2 - C, y: D - C, width: C * 2, height: C * 2 }), u.setShape({ x: 0, y: 0, width: l3.getWidth(), height: l3.getHeight() });
    }, e3.resize(), e3;
  }
  var Yhn = function() {
    function l3(r3, e3, u, h) {
      this._stageTaskMap = Ho(), this.ecInstance = r3, this.api = e3, u = this._dataProcessorHandlers = u.slice(), h = this._visualHandlers = h.slice(), this._allHandlers = u.concat(h);
    }
    return l3.prototype.restoreData = function(r3, e3) {
      r3.restoreData(e3), this._stageTaskMap.each(function(u) {
        var h = u.overallTask;
        h && h.dirty();
      });
    }, l3.prototype.getPerformArgs = function(r3, e3) {
      if (!!r3.__pipeline) {
        var u = this._pipelineMap.get(r3.__pipeline.id), h = u.context, v4 = !e3 && u.progressiveEnabled && (!h || h.progressiveRender) && r3.__idxInPipeline > u.blockIndex, m3 = v4 ? u.step : null, x3 = h && h.modDataCount, C = x3 != null ? Math.ceil(x3 / m3) : null;
        return { step: m3, modBy: C, modDataCount: x3 };
      }
    }, l3.prototype.getPipeline = function(r3) {
      return this._pipelineMap.get(r3);
    }, l3.prototype.updateStreamModes = function(r3, e3) {
      var u = this._pipelineMap.get(r3.uid), h = r3.getData(), v4 = h.count(), m3 = u.progressiveEnabled && e3.incrementalPrepareRender && v4 >= u.threshold, x3 = r3.get("large") && v4 >= r3.get("largeThreshold"), C = r3.get("progressiveChunkMode") === "mod" ? v4 : null;
      r3.pipelineContext = u.context = { progressiveRender: m3, modDataCount: C, large: x3 };
    }, l3.prototype.restorePipelines = function(r3) {
      var e3 = this, u = e3._pipelineMap = Ho();
      r3.eachSeries(function(h) {
        var v4 = h.getProgressive(), m3 = h.uid;
        u.set(m3, { id: m3, head: null, tail: null, threshold: h.getProgressiveThreshold(), progressiveEnabled: v4 && !(h.preventIncremental && h.preventIncremental()), blockIndex: -1, step: Math.round(v4 || 700), count: 0 }), e3._pipe(h, h.dataTask);
      });
    }, l3.prototype.prepareStageTasks = function() {
      var r3 = this._stageTaskMap, e3 = this.api.getModel(), u = this.api;
      mt(this._allHandlers, function(h) {
        var v4 = r3.get(h.uid) || r3.set(h.uid, {}), m3 = "";
        mb(!(h.reset && h.overallReset), m3), h.reset && this._createSeriesStageTask(h, v4, e3, u), h.overallReset && this._createOverallStageTask(h, v4, e3, u);
      }, this);
    }, l3.prototype.prepareView = function(r3, e3, u, h) {
      var v4 = r3.renderTask, m3 = v4.context;
      m3.model = e3, m3.ecModel = u, m3.api = h, v4.__block = !r3.incrementalPrepareRender, this._pipe(e3, v4);
    }, l3.prototype.performDataProcessorTasks = function(r3, e3) {
      this._performStageTasks(this._dataProcessorHandlers, r3, e3, { block: true });
    }, l3.prototype.performVisualTasks = function(r3, e3, u) {
      this._performStageTasks(this._visualHandlers, r3, e3, u);
    }, l3.prototype._performStageTasks = function(r3, e3, u, h) {
      h = h || {};
      var v4 = false, m3 = this;
      mt(r3, function(C, A2) {
        if (!(h.visualType && h.visualType !== C.visualType)) {
          var D = m3._stageTaskMap.get(C.uid), P = D.seriesTaskMap, N = D.overallTask;
          if (N) {
            var j, W = N.agentStubMap;
            W.each(function(te) {
              x3(h, te) && (te.dirty(), j = true);
            }), j && N.dirty(), m3.updatePayload(N, u);
            var K = m3.getPerformArgs(N, h.block);
            W.each(function(te) {
              te.perform(K);
            }), N.perform(K) && (v4 = true);
          } else
            P && P.each(function(te, ne) {
              x3(h, te) && te.dirty();
              var ce = m3.getPerformArgs(te, h.block);
              ce.skip = !C.performRawSeries && e3.isSeriesFiltered(te.context.model), m3.updatePayload(te, u), te.perform(ce) && (v4 = true);
            });
        }
      });
      function x3(C, A2) {
        return C.setDirty && (!C.dirtyMap || C.dirtyMap.get(A2.__pipeline.id));
      }
      this.unfinished = v4 || this.unfinished;
    }, l3.prototype.performSeriesTasks = function(r3) {
      var e3;
      r3.eachSeries(function(u) {
        e3 = u.dataTask.perform() || e3;
      }), this.unfinished = e3 || this.unfinished;
    }, l3.prototype.plan = function() {
      this._pipelineMap.each(function(r3) {
        var e3 = r3.tail;
        do {
          if (e3.__block) {
            r3.blockIndex = e3.__idxInPipeline;
            break;
          }
          e3 = e3.getUpstream();
        } while (e3);
      });
    }, l3.prototype.updatePayload = function(r3, e3) {
      e3 !== "remain" && (r3.context.payload = e3);
    }, l3.prototype._createSeriesStageTask = function(r3, e3, u, h) {
      var v4 = this, m3 = e3.seriesTaskMap, x3 = e3.seriesTaskMap = Ho(), C = r3.seriesType, A2 = r3.getTargetSeries;
      r3.createOnAllSeries ? u.eachRawSeries(D) : C ? u.eachRawSeriesByType(C, D) : A2 && A2(u, h).each(D);
      function D(P) {
        var N = P.uid, j = x3.set(N, m3 && m3.get(N) || jZ({ plan: epn, reset: tpn, count: rpn }));
        j.context = { model: P, ecModel: u, api: h, useClearVisual: r3.isVisual && !r3.isLayout, plan: r3.plan, reset: r3.reset, scheduler: v4 }, v4._pipe(P, j);
      }
    }, l3.prototype._createOverallStageTask = function(r3, e3, u, h) {
      var v4 = this, m3 = e3.overallTask = e3.overallTask || jZ({ reset: Khn });
      m3.context = { ecModel: u, api: h, overallReset: r3.overallReset, scheduler: v4 };
      var x3 = m3.agentStubMap, C = m3.agentStubMap = Ho(), A2 = r3.seriesType, D = r3.getTargetSeries, P = true, N = false, j = "";
      mb(!r3.createOnAllSeries, j), A2 ? u.eachRawSeriesByType(A2, W) : D ? D(u, h).each(W) : (P = false, mt(u.getSeries(), W));
      function W(K) {
        var te = K.uid, ne = C.set(te, x3 && x3.get(te) || (N = true, jZ({ reset: Zhn, onDirty: Qhn })));
        ne.context = { model: K, overallProgress: P }, ne.agent = m3, ne.__block = P, v4._pipe(K, ne);
      }
      N && m3.dirty();
    }, l3.prototype._pipe = function(r3, e3) {
      var u = r3.uid, h = this._pipelineMap.get(u);
      !h.head && (h.head = e3), h.tail && h.tail.pipe(e3), h.tail = e3, e3.__idxInPipeline = h.count++, e3.__pipeline = h;
    }, l3.wrapStageHandler = function(r3, e3) {
      return Xo(r3) && (r3 = { overallReset: r3, seriesType: ipn(r3) }), r3.uid = Tj("stageHandler"), e3 && (r3.visualType = e3), r3;
    }, l3;
  }();
  function Khn(l3) {
    l3.overallReset(l3.ecModel, l3.api, l3.payload);
  }
  function Zhn(l3) {
    return l3.overallProgress && Jhn;
  }
  function Jhn() {
    this.agent.dirty(), this.getDownstream().dirty();
  }
  function Qhn() {
    this.agent && this.agent.dirty();
  }
  function epn(l3) {
    return l3.plan ? l3.plan(l3.model, l3.ecModel, l3.api, l3.payload) : null;
  }
  function tpn(l3) {
    l3.useClearVisual && l3.data.clearAllVisual();
    var r3 = l3.resetDefines = Gf(l3.reset(l3.model, l3.ecModel, l3.api, l3.payload));
    return r3.length > 1 ? Bi(r3, function(e3, u) {
      return Sft(u);
    }) : npn;
  }
  var npn = Sft(0);
  function Sft(l3) {
    return function(r3, e3) {
      var u = e3.data, h = e3.resetDefines[l3];
      if (h && h.dataEach)
        for (var v4 = r3.start; v4 < r3.end; v4++)
          h.dataEach(u, v4);
      else
        h && h.progress && h.progress(r3, u);
    };
  }
  function rpn(l3) {
    return l3.data.count();
  }
  function ipn(l3) {
    the = null;
    try {
      l3(fJ, Cft);
    } catch {
    }
    return the;
  }
  var fJ = {}, Cft = {}, the;
  Mft(fJ, Yct);
  Mft(Cft, Kct);
  fJ.eachSeriesByType = fJ.eachRawSeriesByType = function(l3) {
    the = l3;
  };
  fJ.eachComponent = function(l3) {
    l3.mainType === "series" && l3.subType && (the = l3.subType);
  };
  function Mft(l3, r3) {
    for (var e3 in r3.prototype)
      l3[e3] = Rv;
  }
  var Tft = Yhn, Knt = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], apn = { color: Knt, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], Knt] }, pb = "#B9B8CE", Znt = "#100C2A", Ece = function() {
    return { axisLine: { lineStyle: { color: pb } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
  }, Jnt = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], Aft = { darkMode: true, color: Jnt, backgroundColor: Znt, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: pb } }, textStyle: { color: pb }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: pb } }, dataZoom: { borderColor: "#71708A", textStyle: { color: pb }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: pb } }, timeline: { lineStyle: { color: pb }, label: { color: pb }, controlStyle: { color: pb, borderColor: pb } }, calendar: { itemStyle: { color: Znt }, dayLabel: { color: pb }, monthLabel: { color: pb }, yearLabel: { color: pb } }, timeAxis: Ece(), logAxis: Ece(), valueAxis: Ece(), categoryAxis: Ece(), line: { symbol: "circle" }, graph: { color: Jnt }, gauge: { title: { color: pb }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: pb }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
  Aft.categoryAxis.splitLine.show = false;
  var opn = Aft, spn = function() {
    function l3() {
    }
    return l3.prototype.normalizeQuery = function(r3) {
      var e3 = {}, u = {}, h = {};
      if (qa(r3)) {
        var v4 = FA(r3);
        e3.mainType = v4.main || null, e3.subType = v4.sub || null;
      } else {
        var m3 = ["Index", "Name", "Id"], x3 = { name: 1, dataIndex: 1, dataType: 1 };
        mt(r3, function(C, A2) {
          for (var D = false, P = 0; P < m3.length; P++) {
            var N = m3[P], j = A2.lastIndexOf(N);
            if (j > 0 && j === A2.length - N.length) {
              var W = A2.slice(0, j);
              W !== "data" && (e3.mainType = W, e3[N.toLowerCase()] = C, D = true);
            }
          }
          x3.hasOwnProperty(A2) && (u[A2] = C, D = true), D || (h[A2] = C);
        });
      }
      return { cptQuery: e3, dataQuery: u, otherQuery: h };
    }, l3.prototype.filter = function(r3, e3) {
      var u = this.eventInfo;
      if (!u)
        return true;
      var h = u.targetEl, v4 = u.packedEvent, m3 = u.model, x3 = u.view;
      if (!m3 || !x3)
        return true;
      var C = e3.cptQuery, A2 = e3.dataQuery;
      return D(C, m3, "mainType") && D(C, m3, "subType") && D(C, m3, "index", "componentIndex") && D(C, m3, "name") && D(C, m3, "id") && D(A2, v4, "name") && D(A2, v4, "dataIndex") && D(A2, v4, "dataType") && (!x3.filterForExposedEvent || x3.filterForExposedEvent(r3, e3.otherQuery, h, v4));
      function D(P, N, j, W) {
        return P[j] == null || N[W || j] === P[j];
      }
    }, l3.prototype.afterTrigger = function() {
      this.eventInfo = null;
    }, l3;
  }(), lke = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], Qnt = lke.concat(["symbolKeepAspect"]), lpn = { createOnAllSeries: true, performRawSeries: true, reset: function(l3, r3) {
    var e3 = l3.getData();
    if (l3.legendIcon && e3.setVisual("legendIcon", l3.legendIcon), !l3.hasSymbolVisual)
      return;
    for (var u = {}, h = {}, v4 = false, m3 = 0; m3 < lke.length; m3++) {
      var x3 = lke[m3], C = l3.get(x3);
      Xo(C) ? (v4 = true, h[x3] = C) : u[x3] = C;
    }
    if (u.symbol = u.symbol || l3.defaultSymbol, e3.setVisual(fi({ legendIcon: l3.legendIcon || u.symbol, symbolKeepAspect: l3.get("symbolKeepAspect") }, u)), r3.isSeriesFiltered(l3))
      return;
    var A2 = yu(h);
    function D(P, N) {
      for (var j = l3.getRawValue(N), W = l3.getDataParams(N), K = 0; K < A2.length; K++) {
        var te = A2[K];
        P.setItemVisual(N, te, h[te](j, W));
      }
    }
    return { dataEach: v4 ? D : null };
  } }, upn = { createOnAllSeries: true, performRawSeries: true, reset: function(l3, r3) {
    if (!l3.hasSymbolVisual || r3.isSeriesFiltered(l3))
      return;
    var e3 = l3.getData();
    function u(h, v4) {
      for (var m3 = h.getItemModel(v4), x3 = 0; x3 < Qnt.length; x3++) {
        var C = Qnt[x3], A2 = m3.getShallow(C, true);
        A2 != null && h.setItemVisual(v4, C, A2);
      }
    }
    return { dataEach: e3.hasItemOption ? u : null };
  } };
  function pOe(l3, r3, e3) {
    switch (e3) {
      case "color":
        var u = l3.getItemVisual(r3, "style");
        return u[l3.getVisual("drawType")];
      case "opacity":
        return l3.getItemVisual(r3, "style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return l3.getItemVisual(r3, e3);
    }
  }
  function VJ(l3, r3) {
    switch (r3) {
      case "color":
        var e3 = l3.getVisual("style");
        return e3[l3.getVisual("drawType")];
      case "opacity":
        return l3.getVisual("style").opacity;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        return l3.getVisual(r3);
    }
  }
  function Ift(l3, r3, e3, u) {
    switch (e3) {
      case "color":
        var h = l3.ensureUniqueItemVisual(r3, "style");
        h[l3.getVisual("drawType")] = u, l3.setItemVisual(r3, "colorFromPalette", false);
        break;
      case "opacity":
        l3.ensureUniqueItemVisual(r3, "style").opacity = u;
        break;
      case "symbol":
      case "symbolSize":
      case "liftZ":
        l3.setItemVisual(r3, e3, u);
        break;
    }
  }
  function Eft(l3, r3) {
    function e3(u, h) {
      var v4 = [];
      return u.eachComponent({ mainType: "series", subType: l3, query: h }, function(m3) {
        v4.push(m3.seriesIndex);
      }), v4;
    }
    mt([[l3 + "ToggleSelect", "toggleSelect"], [l3 + "Select", "select"], [l3 + "UnSelect", "unselect"]], function(u) {
      r3(u[0], function(h, v4, m3) {
        h = fi({}, h), m3.dispatchAction(fi(h, { type: u[1], seriesIndex: e3(v4, h) }));
      });
    });
  }
  function Dz(l3, r3, e3, u, h) {
    var v4 = l3 + r3;
    e3.isSilent(v4) || u.eachComponent({ mainType: "series", subType: "pie" }, function(m3) {
      for (var x3 = m3.seriesIndex, C = m3.option.selectedMap, A2 = h.selected, D = 0; D < A2.length; D++)
        if (A2[D].seriesIndex === x3) {
          var P = m3.getData(), N = WN(P, h.fromActionPayload);
          e3.trigger(v4, { type: v4, seriesId: m3.id, name: Ni(N) ? P.getName(N[0]) : P.getName(N), selected: qa(C) ? C : fi({}, C) });
        }
    });
  }
  function cpn(l3, r3, e3) {
    l3.on("selectchanged", function(u) {
      var h = e3.getModel();
      u.isFromClick ? (Dz("map", "selectchanged", r3, h, u), Dz("pie", "selectchanged", r3, h, u)) : u.fromAction === "select" ? (Dz("map", "selected", r3, h, u), Dz("pie", "selected", r3, h, u)) : u.fromAction === "unselect" && (Dz("map", "unselected", r3, h, u), Dz("pie", "unselected", r3, h, u));
    });
  }
  function Zz(l3, r3, e3) {
    for (var u; l3 && !(r3(l3) && (u = l3, e3)); )
      l3 = l3.__hostTarget || l3.parent;
    return u;
  }
  var fpn = Math.round(Math.random() * 9), hpn = typeof Object.defineProperty == "function", ppn = function() {
    function l3() {
      this._id = "__ec_inner_" + fpn++;
    }
    return l3.prototype.get = function(r3) {
      return this._guard(r3)[this._id];
    }, l3.prototype.set = function(r3, e3) {
      var u = this._guard(r3);
      return hpn ? Object.defineProperty(u, this._id, { value: e3, enumerable: false, configurable: true }) : u[this._id] = e3, this;
    }, l3.prototype.delete = function(r3) {
      return this.has(r3) ? (delete this._guard(r3)[this._id], true) : false;
    }, l3.prototype.has = function(r3) {
      return !!this._guard(r3)[this._id];
    }, l3.prototype._guard = function(r3) {
      if (r3 !== Object(r3))
        throw TypeError("Value of WeakMap is not a non-null object.");
      return r3;
    }, l3;
  }(), dpn = ppn, vpn = Nl.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(l3, r3) {
    var e3 = r3.cx, u = r3.cy, h = r3.width / 2, v4 = r3.height / 2;
    l3.moveTo(e3, u - v4), l3.lineTo(e3 + h, u + v4), l3.lineTo(e3 - h, u + v4), l3.closePath();
  } }), gpn = Nl.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(l3, r3) {
    var e3 = r3.cx, u = r3.cy, h = r3.width / 2, v4 = r3.height / 2;
    l3.moveTo(e3, u - v4), l3.lineTo(e3 + h, u), l3.lineTo(e3, u + v4), l3.lineTo(e3 - h, u), l3.closePath();
  } }), ypn = Nl.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(l3, r3) {
    var e3 = r3.x, u = r3.y, h = r3.width / 5 * 3, v4 = Math.max(h, r3.height), m3 = h / 2, x3 = m3 * m3 / (v4 - m3), C = u - v4 + m3 + x3, A2 = Math.asin(x3 / m3), D = Math.cos(A2) * m3, P = Math.sin(A2), N = Math.cos(A2), j = m3 * 0.6, W = m3 * 0.7;
    l3.moveTo(e3 - D, C + x3), l3.arc(e3, C, m3, Math.PI - A2, Math.PI * 2 + A2), l3.bezierCurveTo(e3 + D - P * j, C + x3 + N * j, e3, u - W, e3, u), l3.bezierCurveTo(e3, u - W, e3 - D + P * j, C + x3 + N * j, e3 - D, C + x3), l3.closePath();
  } }), mpn = Nl.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(l3, r3) {
    var e3 = r3.height, u = r3.width, h = r3.x, v4 = r3.y, m3 = u / 3 * 2;
    l3.moveTo(h, v4), l3.lineTo(h + m3, v4 + e3), l3.lineTo(h, v4 + e3 / 4 * 3), l3.lineTo(h - m3, v4 + e3), l3.lineTo(h, v4), l3.closePath();
  } }), bpn = { line: ty, rect: Ju, roundRect: Ju, square: Ju, circle: YA, diamond: gpn, pin: ypn, arrow: mpn, triangle: vpn }, _pn = { line: function(l3, r3, e3, u, h) {
    h.x1 = l3, h.y1 = r3 + u / 2, h.x2 = l3 + e3, h.y2 = r3 + u / 2;
  }, rect: function(l3, r3, e3, u, h) {
    h.x = l3, h.y = r3, h.width = e3, h.height = u;
  }, roundRect: function(l3, r3, e3, u, h) {
    h.x = l3, h.y = r3, h.width = e3, h.height = u, h.r = Math.min(e3, u) / 4;
  }, square: function(l3, r3, e3, u, h) {
    var v4 = Math.min(e3, u);
    h.x = l3, h.y = r3, h.width = v4, h.height = v4;
  }, circle: function(l3, r3, e3, u, h) {
    h.cx = l3 + e3 / 2, h.cy = r3 + u / 2, h.r = Math.min(e3, u) / 2;
  }, diamond: function(l3, r3, e3, u, h) {
    h.cx = l3 + e3 / 2, h.cy = r3 + u / 2, h.width = e3, h.height = u;
  }, pin: function(l3, r3, e3, u, h) {
    h.x = l3 + e3 / 2, h.y = r3 + u / 2, h.width = e3, h.height = u;
  }, arrow: function(l3, r3, e3, u, h) {
    h.x = l3 + e3 / 2, h.y = r3 + u / 2, h.width = e3, h.height = u;
  }, triangle: function(l3, r3, e3, u, h) {
    h.cx = l3 + e3 / 2, h.cy = r3 + u / 2, h.width = e3, h.height = u;
  } }, nhe = {};
  mt(bpn, function(l3, r3) {
    nhe[r3] = new l3();
  });
  var xpn = Nl.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(l3, r3, e3) {
    var u = Wfe(l3, r3, e3), h = this.shape;
    return h && h.symbolType === "pin" && r3.position === "inside" && (u.y = e3.y + e3.height * 0.4), u;
  }, buildPath: function(l3, r3, e3) {
    var u = r3.symbolType;
    if (u !== "none") {
      var h = nhe[u];
      h || (u = "rect", h = nhe[u]), _pn[u](r3.x, r3.y, r3.width, r3.height, h.shape), h.buildPath(l3, h.shape, e3);
    }
  } });
  function wpn(l3, r3) {
    if (this.type !== "image") {
      var e3 = this.style;
      this.__isEmptyBrush ? (e3.stroke = l3, e3.fill = r3 || "#fff", e3.lineWidth = 2) : this.shape.symbolType === "line" ? e3.stroke = l3 : e3.fill = l3, this.markRedraw();
    }
  }
  function Nv(l3, r3, e3, u, h, v4, m3) {
    var x3 = l3.indexOf("empty") === 0;
    x3 && (l3 = l3.substr(5, 1).toLowerCase() + l3.substr(6));
    var C;
    return l3.indexOf("image://") === 0 ? C = dct(l3.slice(8), new Ml(r3, e3, u, h), m3 ? "center" : "cover") : l3.indexOf("path://") === 0 ? C = Zhe(l3.slice(7), {}, new Ml(r3, e3, u, h), m3 ? "center" : "cover") : C = new xpn({ shape: { symbolType: l3, x: r3, y: e3, width: u, height: h } }), C.__isEmptyBrush = x3, C.setColor = wpn, v4 && C.setColor(v4), C;
  }
  function BJ(l3) {
    return Ni(l3) || (l3 = [+l3, +l3]), [l3[0] || 0, l3[1] || 0];
  }
  function Pj(l3, r3) {
    if (l3 != null)
      return Ni(l3) || (l3 = [l3, l3]), [za(l3[0], r3[0]) || 0, za(dl(l3[1], l3[0]), r3[1]) || 0];
  }
  function Spn(l3, r3, e3) {
    var u = r3.x == null ? 0 : r3.x, h = r3.x2 == null ? 1 : r3.x2, v4 = r3.y == null ? 0 : r3.y, m3 = r3.y2 == null ? 0 : r3.y2;
    r3.global || (u = u * e3.width + e3.x, h = h * e3.width + e3.x, v4 = v4 * e3.height + e3.y, m3 = m3 * e3.height + e3.y), u = isNaN(u) ? 0 : u, h = isNaN(h) ? 1 : h, v4 = isNaN(v4) ? 0 : v4, m3 = isNaN(m3) ? 0 : m3;
    var x3 = l3.createLinearGradient(u, v4, h, m3);
    return x3;
  }
  function Cpn(l3, r3, e3) {
    var u = e3.width, h = e3.height, v4 = Math.min(u, h), m3 = r3.x == null ? 0.5 : r3.x, x3 = r3.y == null ? 0.5 : r3.y, C = r3.r == null ? 0.5 : r3.r;
    r3.global || (m3 = m3 * u + e3.x, x3 = x3 * h + e3.y, C = C * v4);
    var A2 = l3.createRadialGradient(m3, x3, 0, m3, x3, C);
    return A2;
  }
  function uke(l3, r3, e3) {
    for (var u = r3.type === "radial" ? Cpn(l3, r3, e3) : Spn(l3, r3, e3), h = r3.colorStops, v4 = 0; v4 < h.length; v4++)
      u.addColorStop(h[v4].offset, h[v4].color);
    return u;
  }
  function Mpn(l3, r3) {
    if (l3 === r3 || !l3 && !r3)
      return false;
    if (!l3 || !r3 || l3.length !== r3.length)
      return true;
    for (var e3 = 0; e3 < l3.length; e3++)
      if (l3[e3] !== r3[e3])
        return true;
    return false;
  }
  function Dce(l3) {
    return parseInt(l3, 10);
  }
  function Jz(l3, r3, e3) {
    var u = ["width", "height"][r3], h = ["clientWidth", "clientHeight"][r3], v4 = ["paddingLeft", "paddingTop"][r3], m3 = ["paddingRight", "paddingBottom"][r3];
    if (e3[u] != null && e3[u] !== "auto")
      return parseFloat(e3[u]);
    var x3 = document.defaultView.getComputedStyle(l3);
    return (l3[h] || Dce(x3[u]) || Dce(l3.style[u])) - (Dce(x3[v4]) || 0) - (Dce(x3[m3]) || 0) | 0;
  }
  function Tpn(l3, r3) {
    return !l3 || l3 === "solid" || !(r3 > 0) ? null : l3 === "dashed" ? [4 * r3, 2 * r3] : l3 === "dotted" ? [r3] : Vc(l3) ? [l3] : Ni(l3) ? l3 : null;
  }
  function dOe(l3) {
    var r3 = l3.style, e3 = r3.lineDash && r3.lineWidth > 0 && Tpn(r3.lineDash, r3.lineWidth), u = r3.lineDashOffset;
    if (e3) {
      var h = r3.strokeNoScale && l3.getLineScale ? l3.getLineScale() : 1;
      h && h !== 1 && (e3 = Bi(e3, function(v4) {
        return v4 / h;
      }), u /= h);
    }
    return [e3, u];
  }
  var Apn = new XA(true);
  function rhe(l3) {
    var r3 = l3.stroke;
    return !(r3 == null || r3 === "none" || !(l3.lineWidth > 0));
  }
  function ert(l3) {
    return typeof l3 == "string" && l3 !== "none";
  }
  function ihe(l3) {
    var r3 = l3.fill;
    return r3 != null && r3 !== "none";
  }
  function trt(l3, r3) {
    if (r3.fillOpacity != null && r3.fillOpacity !== 1) {
      var e3 = l3.globalAlpha;
      l3.globalAlpha = r3.fillOpacity * r3.opacity, l3.fill(), l3.globalAlpha = e3;
    } else
      l3.fill();
  }
  function nrt(l3, r3) {
    if (r3.strokeOpacity != null && r3.strokeOpacity !== 1) {
      var e3 = l3.globalAlpha;
      l3.globalAlpha = r3.strokeOpacity * r3.opacity, l3.stroke(), l3.globalAlpha = e3;
    } else
      l3.stroke();
  }
  function cke(l3, r3, e3) {
    var u = B3e(r3.image, r3.__image, e3);
    if (Whe(u)) {
      var h = l3.createPattern(u, r3.repeat || "repeat");
      if (typeof DOMMatrix == "function" && h && h.setTransform) {
        var v4 = new DOMMatrix();
        v4.translateSelf(r3.x || 0, r3.y || 0), v4.rotateSelf(0, 0, (r3.rotation || 0) * vfe), v4.scaleSelf(r3.scaleX || 1, r3.scaleY || 1), h.setTransform(v4);
      }
      return h;
    }
  }
  function Ipn(l3, r3, e3, u) {
    var h, v4 = rhe(e3), m3 = ihe(e3), x3 = e3.strokePercent, C = x3 < 1, A2 = !r3.path;
    (!r3.silent || C) && A2 && r3.createPathProxy();
    var D = r3.path || Apn, P = r3.__dirty;
    if (!u) {
      var N = e3.fill, j = e3.stroke, W = m3 && !!N.colorStops, K = v4 && !!j.colorStops, te = m3 && !!N.image, ne = v4 && !!j.image, ce = void 0, me = void 0, ve = void 0, Be = void 0, Oe = void 0;
      (W || K) && (Oe = r3.getBoundingRect()), W && (ce = P ? uke(l3, N, Oe) : r3.__canvasFillGradient, r3.__canvasFillGradient = ce), K && (me = P ? uke(l3, j, Oe) : r3.__canvasStrokeGradient, r3.__canvasStrokeGradient = me), te && (ve = P || !r3.__canvasFillPattern ? cke(l3, N, r3) : r3.__canvasFillPattern, r3.__canvasFillPattern = ve), ne && (Be = P || !r3.__canvasStrokePattern ? cke(l3, j, r3) : r3.__canvasStrokePattern, r3.__canvasStrokePattern = ve), W ? l3.fillStyle = ce : te && (ve ? l3.fillStyle = ve : m3 = false), K ? l3.strokeStyle = me : ne && (Be ? l3.strokeStyle = Be : v4 = false);
    }
    var We = r3.getGlobalScale();
    D.setScale(We[0], We[1], r3.segmentIgnoreThreshold);
    var Ue, qe;
    l3.setLineDash && e3.lineDash && (h = dOe(r3), Ue = h[0], qe = h[1]);
    var Ze = true;
    (A2 || P & Hz) && (D.setDPR(l3.dpr), C ? D.setContext(null) : (D.setContext(l3), Ze = false), D.reset(), r3.buildPath(D, r3.shape, u), D.toStatic(), r3.pathUpdated()), Ze && D.rebuildPath(l3, C ? x3 : 1), Ue && (l3.setLineDash(Ue), l3.lineDashOffset = qe), u || (e3.strokeFirst ? (v4 && nrt(l3, e3), m3 && trt(l3, e3)) : (m3 && trt(l3, e3), v4 && nrt(l3, e3))), Ue && l3.setLineDash([]);
  }
  function Epn(l3, r3, e3) {
    var u = r3.__image = B3e(e3.image, r3.__image, r3, r3.onload);
    if (!(!u || !Whe(u))) {
      var h = e3.x || 0, v4 = e3.y || 0, m3 = r3.getWidth(), x3 = r3.getHeight(), C = u.width / u.height;
      if (m3 == null && x3 != null ? m3 = x3 * C : x3 == null && m3 != null ? x3 = m3 / C : m3 == null && x3 == null && (m3 = u.width, x3 = u.height), e3.sWidth && e3.sHeight) {
        var A2 = e3.sx || 0, D = e3.sy || 0;
        l3.drawImage(u, A2, D, e3.sWidth, e3.sHeight, h, v4, m3, x3);
      } else if (e3.sx && e3.sy) {
        var A2 = e3.sx, D = e3.sy, P = m3 - A2, N = x3 - D;
        l3.drawImage(u, A2, D, P, N, h, v4, m3, x3);
      } else
        l3.drawImage(u, h, v4, m3, x3);
    }
  }
  function Dpn(l3, r3, e3) {
    var u, h = e3.text;
    if (h != null && (h += ""), h) {
      l3.font = e3.font || KO, l3.textAlign = e3.textAlign, l3.textBaseline = e3.textBaseline;
      var v4 = void 0, m3 = void 0;
      l3.setLineDash && e3.lineDash && (u = dOe(r3), v4 = u[0], m3 = u[1]), v4 && (l3.setLineDash(v4), l3.lineDashOffset = m3), e3.strokeFirst ? (rhe(e3) && l3.strokeText(h, e3.x, e3.y), ihe(e3) && l3.fillText(h, e3.x, e3.y)) : (ihe(e3) && l3.fillText(h, e3.x, e3.y), rhe(e3) && l3.strokeText(h, e3.x, e3.y)), v4 && l3.setLineDash([]);
    }
  }
  var rrt = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], irt = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
  function Dft(l3, r3, e3, u, h) {
    var v4 = false;
    if (!u && (e3 = e3 || {}, r3 === e3))
      return false;
    if (u || r3.opacity !== e3.opacity) {
      w_(l3, h), v4 = true;
      var m3 = Math.max(Math.min(r3.opacity, 1), 0);
      l3.globalAlpha = isNaN(m3) ? RN.opacity : m3;
    }
    (u || r3.blend !== e3.blend) && (v4 || (w_(l3, h), v4 = true), l3.globalCompositeOperation = r3.blend || RN.blend);
    for (var x3 = 0; x3 < rrt.length; x3++) {
      var C = rrt[x3];
      (u || r3[C] !== e3[C]) && (v4 || (w_(l3, h), v4 = true), l3[C] = l3.dpr * (r3[C] || 0));
    }
    return (u || r3.shadowColor !== e3.shadowColor) && (v4 || (w_(l3, h), v4 = true), l3.shadowColor = r3.shadowColor || RN.shadowColor), v4;
  }
  function art(l3, r3, e3, u, h) {
    var v4 = hJ(r3, h.inHover), m3 = u ? null : e3 && hJ(e3, h.inHover) || {};
    if (v4 === m3)
      return false;
    var x3 = Dft(l3, v4, m3, u, h);
    if ((u || v4.fill !== m3.fill) && (x3 || (w_(l3, h), x3 = true), ert(v4.fill) && (l3.fillStyle = v4.fill)), (u || v4.stroke !== m3.stroke) && (x3 || (w_(l3, h), x3 = true), ert(v4.stroke) && (l3.strokeStyle = v4.stroke)), (u || v4.opacity !== m3.opacity) && (x3 || (w_(l3, h), x3 = true), l3.globalAlpha = v4.opacity == null ? 1 : v4.opacity), r3.hasStroke()) {
      var C = v4.lineWidth, A2 = C / (v4.strokeNoScale && r3.getLineScale ? r3.getLineScale() : 1);
      l3.lineWidth !== A2 && (x3 || (w_(l3, h), x3 = true), l3.lineWidth = A2);
    }
    for (var D = 0; D < irt.length; D++) {
      var P = irt[D], N = P[0];
      (u || v4[N] !== m3[N]) && (x3 || (w_(l3, h), x3 = true), l3[N] = v4[N] || P[1]);
    }
    return x3;
  }
  function kpn(l3, r3, e3, u, h) {
    return Dft(l3, hJ(r3, h.inHover), e3 && hJ(e3, h.inHover), u, h);
  }
  function kft(l3, r3) {
    var e3 = r3.transform, u = l3.dpr || 1;
    e3 ? l3.setTransform(u * e3[0], u * e3[1], u * e3[2], u * e3[3], u * e3[4], u * e3[5]) : l3.setTransform(u, 0, 0, u, 0, 0);
  }
  function Opn(l3, r3, e3) {
    for (var u = false, h = 0; h < l3.length; h++) {
      var v4 = l3[h];
      u = u || v4.isZeroArea(), kft(r3, v4), r3.beginPath(), v4.buildPath(r3, v4.shape), r3.clip();
    }
    e3.allClipped = u;
  }
  function Ppn(l3, r3) {
    return l3 && r3 ? l3[0] !== r3[0] || l3[1] !== r3[1] || l3[2] !== r3[2] || l3[3] !== r3[3] || l3[4] !== r3[4] || l3[5] !== r3[5] : !(!l3 && !r3);
  }
  var ort = 1, srt = 2, lrt = 3, urt = 4;
  function Lpn(l3) {
    var r3 = ihe(l3), e3 = rhe(l3);
    return !(l3.lineDash || !(+r3 ^ +e3) || r3 && typeof l3.fill != "string" || e3 && typeof l3.stroke != "string" || l3.strokePercent < 1 || l3.strokeOpacity < 1 || l3.fillOpacity < 1);
  }
  function w_(l3, r3) {
    r3.batchFill && l3.fill(), r3.batchStroke && l3.stroke(), r3.batchFill = "", r3.batchStroke = "";
  }
  function hJ(l3, r3) {
    return r3 && l3.__hoverStyle || l3.style;
  }
  function Oft(l3, r3) {
    ON(l3, r3, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
  }
  function ON(l3, r3, e3, u) {
    var h = r3.transform;
    if (!r3.shouldBePainted(e3.viewWidth, e3.viewHeight, false, false)) {
      r3.__dirty &= ~Kx, r3.__isRendered = false;
      return;
    }
    var v4 = r3.__clipPaths, m3 = e3.prevElClipPaths, x3 = false, C = false;
    if ((!m3 || Mpn(v4, m3)) && (m3 && m3.length && (w_(l3, e3), l3.restore(), C = x3 = true, e3.prevElClipPaths = null, e3.allClipped = false, e3.prevEl = null), v4 && v4.length && (w_(l3, e3), l3.save(), Opn(v4, l3, e3), x3 = true), e3.prevElClipPaths = v4), e3.allClipped) {
      r3.__isRendered = false;
      return;
    }
    r3.beforeBrush && r3.beforeBrush(), r3.innerBeforeBrush();
    var A2 = e3.prevEl;
    A2 || (C = x3 = true);
    var D = r3 instanceof Nl && r3.autoBatch && Lpn(r3.style);
    x3 || Ppn(h, A2.transform) ? (w_(l3, e3), kft(l3, r3)) : D || w_(l3, e3);
    var P = hJ(r3, e3.inHover);
    r3 instanceof Nl ? (e3.lastDrawType !== ort && (C = true, e3.lastDrawType = ort), art(l3, r3, A2, C, e3), (!D || !e3.batchFill && !e3.batchStroke) && l3.beginPath(), Ipn(l3, r3, P, D), D && (e3.batchFill = P.fill || "", e3.batchStroke = P.stroke || "")) : r3 instanceof nJ ? (e3.lastDrawType !== lrt && (C = true, e3.lastDrawType = lrt), art(l3, r3, A2, C, e3), Dpn(l3, r3, P)) : r3 instanceof lm ? (e3.lastDrawType !== srt && (C = true, e3.lastDrawType = srt), kpn(l3, r3, A2, C, e3), Epn(l3, r3, P)) : r3.getTemporalDisplayables && (e3.lastDrawType !== urt && (C = true, e3.lastDrawType = urt), Rpn(l3, r3, e3)), D && u && w_(l3, e3), r3.innerAfterBrush(), r3.afterBrush && r3.afterBrush(), e3.prevEl = r3, r3.__dirty = 0, r3.__isRendered = true;
  }
  function Rpn(l3, r3, e3) {
    var u = r3.getDisplayables(), h = r3.getTemporalDisplayables();
    l3.save();
    var v4 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: e3.viewWidth, viewHeight: e3.viewHeight, inHover: e3.inHover }, m3, x3;
    for (m3 = r3.getCursor(), x3 = u.length; m3 < x3; m3++) {
      var C = u[m3];
      C.beforeBrush && C.beforeBrush(), C.innerBeforeBrush(), ON(l3, C, v4, m3 === x3 - 1), C.innerAfterBrush(), C.afterBrush && C.afterBrush(), v4.prevEl = C;
    }
    for (var A2 = 0, D = h.length; A2 < D; A2++) {
      var C = h[A2];
      C.beforeBrush && C.beforeBrush(), C.innerBeforeBrush(), ON(l3, C, v4, A2 === D - 1), C.innerAfterBrush(), C.afterBrush && C.afterBrush(), v4.prevEl = C;
    }
    r3.clearTemporalDisplayables(), r3.notClear = true, l3.restore();
  }
  var OEe = new dpn(), crt = new EJ(100), frt = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
  function pJ(l3, r3) {
    if (l3 === "none")
      return null;
    var e3 = r3.getDevicePixelRatio(), u = r3.getZr(), h = u.painter.type === "svg";
    l3.dirty && OEe.delete(l3);
    var v4 = OEe.get(l3);
    if (v4)
      return v4;
    var m3 = ns(l3, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
    m3.backgroundColor === "none" && (m3.backgroundColor = null);
    var x3 = { repeat: "repeat" };
    return C(x3), x3.rotation = m3.rotation, x3.scaleX = x3.scaleY = h ? 1 : 1 / e3, OEe.set(l3, x3), l3.dirty = false, x3;
    function C(A2) {
      for (var D = [e3], P = true, N = 0; N < frt.length; ++N) {
        var j = m3[frt[N]];
        if (j != null && !Ni(j) && !qa(j) && !Vc(j) && typeof j != "boolean") {
          P = false;
          break;
        }
        D.push(j);
      }
      var W;
      if (P) {
        W = D.join(",") + (h ? "-svg" : "");
        var K = crt.get(W);
        K && (h ? A2.svgElement = K : A2.image = K);
      }
      var te = Lft(m3.dashArrayX), ne = Npn(m3.dashArrayY), ce = Pft(m3.symbol), me = Fpn(te), ve = Rft(ne), Be = !h && l5.createCanvas(), Oe = h && { tag: "g", attrs: {}, key: "dcl", children: [] }, We = qe(), Ue;
      Be && (Be.width = We.width * e3, Be.height = We.height * e3, Ue = Be.getContext("2d")), Ze(), P && crt.put(W, Be || Oe), A2.image = Be, A2.svgElement = Oe, A2.svgWidth = We.width, A2.svgHeight = We.height;
      function qe() {
        for (var ct = 1, _t = 0, pt = me.length; _t < pt; ++_t)
          ct = Ttt(ct, me[_t]);
        for (var zt = 1, _t = 0, pt = ce.length; _t < pt; ++_t)
          zt = Ttt(zt, ce[_t].length);
        ct *= zt;
        var Zt = ve * me.length * ce.length;
        return { width: Math.max(1, Math.min(ct, m3.maxTileWidth)), height: Math.max(1, Math.min(Zt, m3.maxTileHeight)) };
      }
      function Ze() {
        Ue && (Ue.clearRect(0, 0, Be.width, Be.height), m3.backgroundColor && (Ue.fillStyle = m3.backgroundColor, Ue.fillRect(0, 0, Be.width, Be.height)));
        for (var ct = 0, _t = 0; _t < ne.length; ++_t)
          ct += ne[_t];
        if (ct <= 0)
          return;
        for (var pt = -ve, zt = 0, Zt = 0, Ft = 0; pt < We.height; ) {
          if (zt % 2 === 0) {
            for (var Kn = Zt / 2 % ce.length, hn = 0, xn = 0, zn = 0; hn < We.width * 2; ) {
              for (var or = 0, _t = 0; _t < te[Ft].length; ++_t)
                or += te[Ft][_t];
              if (or <= 0)
                break;
              if (xn % 2 === 0) {
                var vr = (1 - m3.symbolSize) * 0.5, la = hn + te[Ft][xn] * vr, Ba = pt + ne[zt] * vr, Lo = te[Ft][xn] * m3.symbolSize, Ao = ne[zt] * m3.symbolSize, oo = zn / 2 % ce[Kn].length;
                Pa(la, Ba, Lo, Ao, ce[Kn][oo]);
              }
              hn += te[Ft][xn], ++zn, ++xn, xn === te[Ft].length && (xn = 0);
            }
            ++Ft, Ft === te.length && (Ft = 0);
          }
          pt += ne[zt], ++Zt, ++zt, zt === ne.length && (zt = 0);
        }
        function Pa(fo, Co, $a, Yo, Qu) {
          var ds = h ? 1 : e3, Lu = Nv(Qu, fo * ds, Co * ds, $a * ds, Yo * ds, m3.color, m3.symbolKeepAspect);
          if (h) {
            var dc = u.painter.renderOneToVNode(Lu);
            dc && Oe.children.push(dc);
          } else
            Oft(Ue, Lu);
        }
      }
    }
  }
  function Pft(l3) {
    if (!l3 || l3.length === 0)
      return [["rect"]];
    if (qa(l3))
      return [[l3]];
    for (var r3 = true, e3 = 0; e3 < l3.length; ++e3)
      if (!qa(l3[e3])) {
        r3 = false;
        break;
      }
    if (r3)
      return Pft([l3]);
    for (var u = [], e3 = 0; e3 < l3.length; ++e3)
      qa(l3[e3]) ? u.push([l3[e3]]) : u.push(l3[e3]);
    return u;
  }
  function Lft(l3) {
    if (!l3 || l3.length === 0)
      return [[0, 0]];
    if (Vc(l3)) {
      var r3 = Math.ceil(l3);
      return [[r3, r3]];
    }
    for (var e3 = true, u = 0; u < l3.length; ++u)
      if (!Vc(l3[u])) {
        e3 = false;
        break;
      }
    if (e3)
      return Lft([l3]);
    for (var h = [], u = 0; u < l3.length; ++u)
      if (Vc(l3[u])) {
        var r3 = Math.ceil(l3[u]);
        h.push([r3, r3]);
      } else {
        var r3 = Bi(l3[u], function(x3) {
          return Math.ceil(x3);
        });
        r3.length % 2 === 1 ? h.push(r3.concat(r3)) : h.push(r3);
      }
    return h;
  }
  function Npn(l3) {
    if (!l3 || typeof l3 == "object" && l3.length === 0)
      return [0, 0];
    if (Vc(l3)) {
      var r3 = Math.ceil(l3);
      return [r3, r3];
    }
    var e3 = Bi(l3, function(u) {
      return Math.ceil(u);
    });
    return l3.length % 2 ? e3.concat(e3) : e3;
  }
  function Fpn(l3) {
    return Bi(l3, function(r3) {
      return Rft(r3);
    });
  }
  function Rft(l3) {
    for (var r3 = 0, e3 = 0; e3 < l3.length; ++e3)
      r3 += l3[e3];
    return l3.length % 2 === 1 ? r3 * 2 : r3;
  }
  function Vpn(l3, r3) {
    l3.eachRawSeries(function(e3) {
      if (!l3.isSeriesFiltered(e3)) {
        var u = e3.getData();
        u.hasItemVisual() && u.each(function(m3) {
          var x3 = u.getItemVisual(m3, "decal");
          if (x3) {
            var C = u.ensureUniqueItemVisual(m3, "style");
            C.decal = pJ(x3, r3);
          }
        });
        var h = u.getVisual("decal");
        if (h) {
          var v4 = u.getVisual("style");
          v4.decal = pJ(h, r3);
        }
      }
    });
  }
  var Bpn = new w2(), cM = Bpn, Nft = {};
  function zpn(l3, r3) {
    Nft[l3] = r3;
  }
  function jpn(l3) {
    return Nft[l3];
  }
  var Gpn = typeof window != "undefined", Hpn = 1, Wpn = 800, Upn = 900, qpn = 1e3, $pn = 2e3, Xpn = 5e3, Fft = 1e3, Ypn = 1100, vOe = 2e3, Vft = 3e3, Kpn = 4e3, upe = 4500, Zpn = 4600, Jpn = 5e3, Qpn = 6e3, Bft = 7e3, edn = { PROCESSOR: { FILTER: qpn, SERIES_FILTER: Wpn, STATISTIC: Xpn }, VISUAL: { LAYOUT: Fft, PROGRESSIVE_LAYOUT: Ypn, GLOBAL: vOe, CHART: Vft, POST_CHART_LAYOUT: Zpn, COMPONENT: Kpn, BRUSH: Jpn, CHART_ITEM: upe, ARIA: Qpn, DECAL: Bft } }, d1 = "__flagInMainProcess", b_ = "__pendingUpdate", PEe = "__needsUpdateStatus", hrt = /^[a-zA-Z0-9_]+$/, LEe = "__connectUpdateStatus", prt = 0, tdn = 1, ndn = 2;
  function zft(l3) {
    return function() {
      for (var r3 = [], e3 = 0; e3 < arguments.length; e3++)
        r3[e3] = arguments[e3];
      if (this.isDisposed()) {
        this.id;
        return;
      }
      return Gft(this, l3, r3);
    };
  }
  function jft(l3) {
    return function() {
      for (var r3 = [], e3 = 0; e3 < arguments.length; e3++)
        r3[e3] = arguments[e3];
      return Gft(this, l3, r3);
    };
  }
  function Gft(l3, r3, e3) {
    return e3[0] = e3[0] && e3[0].toLowerCase(), w2.prototype[r3].apply(l3, e3);
  }
  var Hft = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3;
  }(w2), Wft = Hft.prototype;
  Wft.on = jft("on");
  Wft.off = jft("off");
  var kz, REe, kce, TO, NEe, FEe, VEe, QK, eZ, drt, vrt, BEe, grt, Oce, yrt, Uft, e2, mrt, qft = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this, new spn()) || this;
      v4._chartsViews = [], v4._chartsMap = {}, v4._componentsViews = [], v4._componentsMap = {}, v4._pendingActions = [], h = h || {}, qa(u) && (u = $ft[u]), v4._dom = e3;
      var m3 = "canvas", x3 = false, C = v4._zr = wtt(e3, { renderer: h.renderer || m3, devicePixelRatio: h.devicePixelRatio, width: h.width, height: h.height, ssr: h.ssr, useDirtyRect: h.useDirtyRect == null ? x3 : h.useDirtyRect });
      v4._ssr = h.ssr, v4._throttledZrFlush = hOe(no(C.flush, C), 17), u = bs(u), u && Jct(u, true), v4._theme = u, v4._locale = hfn(h.locale || Mct), v4._coordSysMgr = new FJ();
      var A2 = v4._api = yrt(v4);
      function D(P, N) {
        return P.__prio - N.__prio;
      }
      return yfe(ohe, D), yfe(fke, D), v4._scheduler = new Tft(v4, A2, fke, ohe), v4._messageCenter = new Hft(), v4._initEvents(), v4.resize = no(v4.resize, v4), C.animation.on("frame", v4._onframe, v4), drt(C, v4), vrt(C, v4), Ffe(v4), v4;
    }
    return r3.prototype._onframe = function() {
      if (!this._disposed) {
        mrt(this);
        var e3 = this._scheduler;
        if (this[b_]) {
          var u = this[b_].silent;
          this[d1] = true;
          try {
            kz(this), TO.update.call(this, null, this[b_].updateParams);
          } catch (C) {
            throw this[d1] = false, this[b_] = null, C;
          }
          this._zr.flush(), this[d1] = false, this[b_] = null, QK.call(this, u), eZ.call(this, u);
        } else if (e3.unfinished) {
          var h = Hpn, v4 = this._model, m3 = this._api;
          e3.unfinished = false;
          do {
            var x3 = +new Date();
            e3.performSeriesTasks(v4), e3.performDataProcessorTasks(v4), FEe(this, v4), e3.performVisualTasks(v4), Oce(this, this._model, m3, "remain", {}), h -= +new Date() - x3;
          } while (h > 0 && e3.unfinished);
          e3.unfinished || this._zr.flush();
        }
      }
    }, r3.prototype.getDom = function() {
      return this._dom;
    }, r3.prototype.getId = function() {
      return this.id;
    }, r3.prototype.getZr = function() {
      return this._zr;
    }, r3.prototype.isSSR = function() {
      return this._ssr;
    }, r3.prototype.setOption = function(e3, u, h) {
      if (!this[d1]) {
        if (this._disposed) {
          this.id;
          return;
        }
        var v4, m3, x3;
        if (ls(u) && (h = u.lazyUpdate, v4 = u.silent, m3 = u.replaceMerge, x3 = u.transition, u = u.notMerge), this[d1] = true, !this._model || u) {
          var C = new qfn(this._api), A2 = this._theme, D = this._model = new Yct();
          D.scheduler = this._scheduler, D.ssr = this._ssr, D.init(null, null, null, A2, this._locale, C);
        }
        this._model.setOption(e3, { replaceMerge: m3 }, hke);
        var P = { seriesTransition: x3, optionChanged: true };
        if (h)
          this[b_] = { silent: v4, updateParams: P }, this[d1] = false, this.getZr().wakeUp();
        else {
          try {
            kz(this), TO.update.call(this, null, P);
          } catch (N) {
            throw this[b_] = null, this[d1] = false, N;
          }
          this._ssr || this._zr.flush(), this[b_] = null, this[d1] = false, QK.call(this, v4), eZ.call(this, v4);
        }
      }
    }, r3.prototype.setTheme = function() {
    }, r3.prototype.getModel = function() {
      return this._model;
    }, r3.prototype.getOption = function() {
      return this._model && this._model.getOption();
    }, r3.prototype.getWidth = function() {
      return this._zr.getWidth();
    }, r3.prototype.getHeight = function() {
      return this._zr.getHeight();
    }, r3.prototype.getDevicePixelRatio = function() {
      return this._zr.painter.dpr || Gpn && window.devicePixelRatio || 1;
    }, r3.prototype.getRenderedCanvas = function(e3) {
      return this.renderToCanvas(e3);
    }, r3.prototype.renderToCanvas = function(e3) {
      e3 = e3 || {};
      var u = this._zr.painter;
      return u.getRenderedCanvas({ backgroundColor: e3.backgroundColor || this._model.get("backgroundColor"), pixelRatio: e3.pixelRatio || this.getDevicePixelRatio() });
    }, r3.prototype.renderToSVGString = function(e3) {
      e3 = e3 || {};
      var u = this._zr.painter;
      return u.renderToString({ useViewBox: e3.useViewBox });
    }, r3.prototype.getSvgDataURL = function() {
      if (!!Fc.svgSupported) {
        var e3 = this._zr, u = e3.storage.getDisplayList();
        return mt(u, function(h) {
          h.stopAnimation(null, true);
        }), e3.painter.toDataURL();
      }
    }, r3.prototype.getDataURL = function(e3) {
      if (this._disposed) {
        this.id;
        return;
      }
      e3 = e3 || {};
      var u = e3.excludeComponents, h = this._model, v4 = [], m3 = this;
      mt(u, function(C) {
        h.eachComponent({ mainType: C }, function(A2) {
          var D = m3._componentsMap[A2.__viewId];
          D.group.ignore || (v4.push(D), D.group.ignore = true);
        });
      });
      var x3 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(e3).toDataURL("image/" + (e3 && e3.type || "png"));
      return mt(v4, function(C) {
        C.group.ignore = false;
      }), x3;
    }, r3.prototype.getConnectedDataURL = function(e3) {
      if (this._disposed) {
        this.id;
        return;
      }
      var u = e3.type === "svg", h = this.group, v4 = Math.min, m3 = Math.max, x3 = 1 / 0;
      if (brt[h]) {
        var C = x3, A2 = x3, D = -x3, P = -x3, N = [], j = e3 && e3.pixelRatio || this.getDevicePixelRatio();
        mt(HZ, function(me, ve) {
          if (me.group === h) {
            var Be = u ? me.getZr().painter.getSvgDom().innerHTML : me.renderToCanvas(bs(e3)), Oe = me.getDom().getBoundingClientRect();
            C = v4(Oe.left, C), A2 = v4(Oe.top, A2), D = m3(Oe.right, D), P = m3(Oe.bottom, P), N.push({ dom: Be, left: Oe.left, top: Oe.top });
          }
        }), C *= j, A2 *= j, D *= j, P *= j;
        var W = D - C, K = P - A2, te = l5.createCanvas(), ne = wtt(te, { renderer: u ? "svg" : "canvas" });
        if (ne.resize({ width: W, height: K }), u) {
          var ce = "";
          return mt(N, function(me) {
            var ve = me.left - C, Be = me.top - A2;
            ce += '<g transform="translate(' + ve + "," + Be + ')">' + me.dom + "</g>";
          }), ne.painter.getSvgRoot().innerHTML = ce, e3.connectedBackgroundColor && ne.painter.setBackgroundColor(e3.connectedBackgroundColor), ne.refreshImmediately(), ne.painter.toDataURL();
        } else
          return e3.connectedBackgroundColor && ne.add(new Ju({ shape: { x: 0, y: 0, width: W, height: K }, style: { fill: e3.connectedBackgroundColor } })), mt(N, function(me) {
            var ve = new lm({ style: { x: me.left * j - C, y: me.top * j - A2, image: me.dom } });
            ne.add(ve);
          }), ne.refreshImmediately(), te.toDataURL("image/" + (e3 && e3.type || "png"));
      } else
        return this.getDataURL(e3);
    }, r3.prototype.convertToPixel = function(e3, u) {
      return NEe(this, "convertToPixel", e3, u);
    }, r3.prototype.convertFromPixel = function(e3, u) {
      return NEe(this, "convertFromPixel", e3, u);
    }, r3.prototype.containPixel = function(e3, u) {
      if (this._disposed) {
        this.id;
        return;
      }
      var h = this._model, v4, m3 = NZ(h, e3);
      return mt(m3, function(x3, C) {
        C.indexOf("Models") >= 0 && mt(x3, function(A2) {
          var D = A2.coordinateSystem;
          if (D && D.containPoint)
            v4 = v4 || !!D.containPoint(u);
          else if (C === "seriesModels") {
            var P = this._chartsMap[A2.__viewId];
            P && P.containPoint && (v4 = v4 || P.containPoint(u, A2));
          }
        }, this);
      }, this), !!v4;
    }, r3.prototype.getVisual = function(e3, u) {
      var h = this._model, v4 = NZ(h, e3, { defaultMainType: "series" }), m3 = v4.seriesModel, x3 = m3.getData(), C = v4.hasOwnProperty("dataIndexInside") ? v4.dataIndexInside : v4.hasOwnProperty("dataIndex") ? x3.indexOfRawIndex(v4.dataIndex) : null;
      return C != null ? pOe(x3, C, u) : VJ(x3, u);
    }, r3.prototype.getViewOfComponentModel = function(e3) {
      return this._componentsMap[e3.__viewId];
    }, r3.prototype.getViewOfSeriesModel = function(e3) {
      return this._chartsMap[e3.__viewId];
    }, r3.prototype._initEvents = function() {
      var e3 = this;
      mt(rdn, function(u) {
        var h = function(v4) {
          var m3 = e3.getModel(), x3 = v4.target, C, A2 = u === "globalout";
          if (A2 ? C = {} : x3 && Zz(x3, function(W) {
            var K = Ps(W);
            if (K && K.dataIndex != null) {
              var te = K.dataModel || m3.getSeriesByIndex(K.seriesIndex);
              return C = te && te.getDataParams(K.dataIndex, K.dataType) || {}, true;
            } else if (K.eventData)
              return C = fi({}, K.eventData), true;
          }, true), C) {
            var D = C.componentType, P = C.componentIndex;
            (D === "markLine" || D === "markPoint" || D === "markArea") && (D = "series", P = C.seriesIndex);
            var N = D && P != null && m3.getComponent(D, P), j = N && e3[N.mainType === "series" ? "_chartsMap" : "_componentsMap"][N.__viewId];
            C.event = v4, C.type = u, e3._$eventProcessor.eventInfo = { targetEl: x3, packedEvent: C, model: N, view: j }, e3.trigger(u, C);
          }
        };
        h.zrEventfulCallAtLast = true, e3._zr.on(u, h, e3);
      }), mt(GZ, function(u, h) {
        e3._messageCenter.on(h, function(v4) {
          this.trigger(h, v4);
        }, e3);
      }), mt(["selectchanged"], function(u) {
        e3._messageCenter.on(u, function(h) {
          this.trigger(u, h);
        }, e3);
      }), cpn(this._messageCenter, this, this._api);
    }, r3.prototype.isDisposed = function() {
      return this._disposed;
    }, r3.prototype.clear = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this.setOption({ series: [] }, true);
    }, r3.prototype.dispose = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._disposed = true;
      var e3 = this.getDom();
      e3 && wut(this.getDom(), yOe, "");
      var u = this, h = u._api, v4 = u._model;
      mt(u._componentsViews, function(m3) {
        m3.dispose(v4, h);
      }), mt(u._chartsViews, function(m3) {
        m3.dispose(v4, h);
      }), u._zr.dispose(), u._dom = u._model = u._chartsMap = u._componentsMap = u._chartsViews = u._componentsViews = u._scheduler = u._api = u._zr = u._throttledZrFlush = u._theme = u._coordSysMgr = u._messageCenter = null, delete HZ[u.id];
    }, r3.prototype.resize = function(e3) {
      if (!this[d1]) {
        if (this._disposed) {
          this.id;
          return;
        }
        this._zr.resize(e3);
        var u = this._model;
        if (this._loadingFX && this._loadingFX.resize(), !!u) {
          var h = u.resetOption("media"), v4 = e3 && e3.silent;
          this[b_] && (v4 == null && (v4 = this[b_].silent), h = true, this[b_] = null), this[d1] = true;
          try {
            h && kz(this), TO.update.call(this, { type: "resize", animation: fi({ duration: 0 }, e3 && e3.animation) });
          } catch (m3) {
            throw this[d1] = false, m3;
          }
          this[d1] = false, QK.call(this, v4), eZ.call(this, v4);
        }
      }
    }, r3.prototype.showLoading = function(e3, u) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (ls(e3) && (u = e3, e3 = ""), e3 = e3 || "default", this.hideLoading(), !!pke[e3]) {
        var h = pke[e3](this._api, u), v4 = this._zr;
        this._loadingFX = h, v4.add(h);
      }
    }, r3.prototype.hideLoading = function() {
      if (this._disposed) {
        this.id;
        return;
      }
      this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
    }, r3.prototype.makeActionFromEvent = function(e3) {
      var u = fi({}, e3);
      return u.type = GZ[e3.type], u;
    }, r3.prototype.dispatchAction = function(e3, u) {
      if (this._disposed) {
        this.id;
        return;
      }
      if (ls(u) || (u = { silent: !!u }), !!ahe[e3.type] && !!this._model) {
        if (this[d1]) {
          this._pendingActions.push(e3);
          return;
        }
        var h = u.silent;
        VEe.call(this, e3, h);
        var v4 = u.flush;
        v4 ? this._zr.flush() : v4 !== false && Fc.browser.weChat && this._throttledZrFlush(), QK.call(this, h), eZ.call(this, h);
      }
    }, r3.prototype.updateLabelLayout = function() {
      cM.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
    }, r3.prototype.appendData = function(e3) {
      if (this._disposed) {
        this.id;
        return;
      }
      var u = e3.seriesIndex, h = this.getModel(), v4 = h.getSeriesByIndex(u);
      v4.appendData(e3), this._scheduler.unfinished = true, this.getZr().wakeUp();
    }, r3.internalField = function() {
      kz = function(P) {
        var N = P._scheduler;
        N.restorePipelines(P._model), N.prepareStageTasks(), REe(P, true), REe(P, false), N.plan();
      }, REe = function(P, N) {
        for (var j = P._model, W = P._scheduler, K = N ? P._componentsViews : P._chartsViews, te = N ? P._componentsMap : P._chartsMap, ne = P._zr, ce = P._api, me = 0; me < K.length; me++)
          K[me].__alive = false;
        N ? j.eachComponent(function(Oe, We) {
          Oe !== "series" && ve(We);
        }) : j.eachSeries(ve);
        function ve(Oe) {
          var We = Oe.__requireNewView;
          Oe.__requireNewView = false;
          var Ue = "_ec_" + Oe.id + "_" + Oe.type, qe = !We && te[Ue];
          if (!qe) {
            var Ze = FA(Oe.type), ct = N ? yd.getClass(Ze.main, Ze.sub) : zh.getClass(Ze.sub);
            qe = new ct(), qe.init(j, ce), te[Ue] = qe, K.push(qe), ne.add(qe.group);
          }
          Oe.__viewId = qe.__id = Ue, qe.__alive = true, qe.__model = Oe, qe.group.__ecComponentInfo = { mainType: Oe.mainType, index: Oe.componentIndex }, !N && W.prepareView(qe, Oe, j, ce);
        }
        for (var me = 0; me < K.length; ) {
          var Be = K[me];
          Be.__alive ? me++ : (!N && Be.renderTask.dispose(), ne.remove(Be.group), Be.dispose(j, ce), K.splice(me, 1), te[Be.__id] === Be && delete te[Be.__id], Be.__id = Be.group.__ecComponentInfo = null);
        }
      }, kce = function(P, N, j, W, K) {
        var te = P._model;
        if (te.setUpdatePayload(j), !W) {
          mt([].concat(P._componentsViews).concat(P._chartsViews), Be);
          return;
        }
        var ne = {};
        ne[W + "Id"] = j[W + "Id"], ne[W + "Index"] = j[W + "Index"], ne[W + "Name"] = j[W + "Name"];
        var ce = { mainType: W, query: ne };
        K && (ce.subType = K);
        var me = j.excludeSeriesId, ve;
        me != null && (ve = Ho(), mt(Gf(me), function(Oe) {
          var We = pg(Oe, null);
          We != null && ve.set(We, true);
        })), te && te.eachComponent(ce, function(Oe) {
          var We = ve && ve.get(Oe.id) !== null;
          if (!We)
            if (ent(j))
              if (Oe instanceof Fp)
                j.type === NN && !j.notBlur && !Oe.get(["emphasis", "disabled"]) && rcn(Oe, j, P._api);
              else {
                var Ue = H3e(Oe.mainType, Oe.componentIndex, j.name, P._api), qe = Ue.focusSelf, Ze = Ue.dispatchers;
                j.type === NN && qe && !j.notBlur && $5e(Oe.mainType, Oe.componentIndex, P._api), Ze && mt(Ze, function(ct) {
                  j.type === NN ? zA(ct) : jA(ct);
                });
              }
            else
              Y5e(j) && Oe instanceof Fp && (ocn(Oe, j, P._api), Jtt(Oe), e2(P));
        }, P), te && te.eachComponent(ce, function(Oe) {
          var We = ve && ve.get(Oe.id) !== null;
          We || Be(P[W === "series" ? "_chartsMap" : "_componentsMap"][Oe.__viewId]);
        }, P);
        function Be(Oe) {
          Oe && Oe.__alive && Oe[N] && Oe[N](Oe.__model, te, P._api, j);
        }
      }, TO = { prepareAndUpdate: function(P) {
        kz(this), TO.update.call(this, P, { optionChanged: P.newOption != null });
      }, update: function(P, N) {
        var j = this._model, W = this._api, K = this._zr, te = this._coordSysMgr, ne = this._scheduler;
        if (!!j) {
          j.setUpdatePayload(P), ne.restoreData(j, P), ne.performSeriesTasks(j), te.create(j, W), ne.performDataProcessorTasks(j, P), FEe(this, j), te.update(j, W), e3(j), ne.performVisualTasks(j, P), BEe(this, j, W, P, N);
          var ce = j.get("backgroundColor") || "transparent", me = j.get("darkMode");
          K.setBackgroundColor(ce), me != null && me !== "auto" && K.setDarkMode(me), cM.trigger("afterupdate", j, W);
        }
      }, updateTransform: function(P) {
        var N = this, j = this._model, W = this._api;
        if (!!j) {
          j.setUpdatePayload(P);
          var K = [];
          j.eachComponent(function(ne, ce) {
            if (ne !== "series") {
              var me = N.getViewOfComponentModel(ce);
              if (me && me.__alive)
                if (me.updateTransform) {
                  var ve = me.updateTransform(ce, j, W, P);
                  ve && ve.update && K.push(me);
                } else
                  K.push(me);
            }
          });
          var te = Ho();
          j.eachSeries(function(ne) {
            var ce = N._chartsMap[ne.__viewId];
            if (ce.updateTransform) {
              var me = ce.updateTransform(ne, j, W, P);
              me && me.update && te.set(ne.uid, 1);
            } else
              te.set(ne.uid, 1);
          }), e3(j), this._scheduler.performVisualTasks(j, P, { setDirty: true, dirtyMap: te }), Oce(this, j, W, P, {}, te), cM.trigger("afterupdate", j, W);
        }
      }, updateView: function(P) {
        var N = this._model;
        !N || (N.setUpdatePayload(P), zh.markUpdateMethod(P, "updateView"), e3(N), this._scheduler.performVisualTasks(N, P, { setDirty: true }), BEe(this, N, this._api, P, {}), cM.trigger("afterupdate", N, this._api));
      }, updateVisual: function(P) {
        var N = this, j = this._model;
        !j || (j.setUpdatePayload(P), j.eachSeries(function(W) {
          W.getData().clearAllVisual();
        }), zh.markUpdateMethod(P, "updateVisual"), e3(j), this._scheduler.performVisualTasks(j, P, { visualType: "visual", setDirty: true }), j.eachComponent(function(W, K) {
          if (W !== "series") {
            var te = N.getViewOfComponentModel(K);
            te && te.__alive && te.updateVisual(K, j, N._api, P);
          }
        }), j.eachSeries(function(W) {
          var K = N._chartsMap[W.__viewId];
          K.updateVisual(W, j, N._api, P);
        }), cM.trigger("afterupdate", j, this._api));
      }, updateLayout: function(P) {
        TO.update.call(this, P);
      } }, NEe = function(P, N, j, W) {
        if (P._disposed) {
          P.id;
          return;
        }
        for (var K = P._model, te = P._coordSysMgr.getCoordinateSystems(), ne, ce = NZ(K, j), me = 0; me < te.length; me++) {
          var ve = te[me];
          if (ve[N] && (ne = ve[N](K, ce, W)) != null)
            return ne;
        }
      }, FEe = function(P, N) {
        var j = P._chartsMap, W = P._scheduler;
        N.eachSeries(function(K) {
          W.updateStreamModes(K, j[K.__viewId]);
        });
      }, VEe = function(P, N) {
        var j = this, W = this.getModel(), K = P.type, te = P.escapeConnect, ne = ahe[K], ce = ne.actionInfo, me = (ce.update || "update").split(":"), ve = me.pop(), Be = me[0] != null && FA(me[0]);
        this[d1] = true;
        var Oe = [P], We = false;
        P.batch && (We = true, Oe = Bi(P.batch, function(zt) {
          return zt = ns(fi({}, zt), P), zt.batch = null, zt;
        }));
        var Ue = [], qe, Ze = Y5e(P), ct = ent(P);
        if (ct && Xut(this._api), mt(Oe, function(zt) {
          if (qe = ne.action(zt, j._model, j._api), qe = qe || fi({}, zt), qe.type = ce.event || qe.type, Ue.push(qe), ct) {
            var Zt = F3e(P), Ft = Zt.queryOptionMap, Kn = Zt.mainTypeSpecified, hn = Kn ? Ft.keys()[0] : "series";
            kce(j, ve, zt, hn), e2(j);
          } else
            Ze ? (kce(j, ve, zt, "series"), e2(j)) : Be && kce(j, ve, zt, Be.main, Be.sub);
        }), ve !== "none" && !ct && !Ze && !Be)
          try {
            this[b_] ? (kz(this), TO.update.call(this, P), this[b_] = null) : TO[ve].call(this, P);
          } catch (zt) {
            throw this[d1] = false, zt;
          }
        if (We ? qe = { type: ce.event || K, escapeConnect: te, batch: Ue } : qe = Ue[0], this[d1] = false, !N) {
          var _t = this._messageCenter;
          if (_t.trigger(qe.type, qe), Ze) {
            var pt = { type: "selectchanged", escapeConnect: te, selected: scn(W), isFromClick: P.isFromClick || false, fromAction: P.type, fromActionPayload: P };
            _t.trigger(pt.type, pt);
          }
        }
      }, QK = function(P) {
        for (var N = this._pendingActions; N.length; ) {
          var j = N.shift();
          VEe.call(this, j, P);
        }
      }, eZ = function(P) {
        !P && this.trigger("updated");
      }, drt = function(P, N) {
        P.on("rendered", function(j) {
          N.trigger("rendered", j), P.animation.isFinished() && !N[b_] && !N._scheduler.unfinished && !N._pendingActions.length && N.trigger("finished");
        });
      }, vrt = function(P, N) {
        P.on("mouseover", function(j) {
          var W = j.target, K = Zz(W, iJ);
          K && (icn(K, j, N._api), e2(N));
        }).on("mouseout", function(j) {
          var W = j.target, K = Zz(W, iJ);
          K && (acn(K, j, N._api), e2(N));
        }).on("click", function(j) {
          var W = j.target, K = Zz(W, function(ce) {
            return Ps(ce).dataIndex != null;
          }, true);
          if (K) {
            var te = K.selected ? "unselect" : "select", ne = Ps(K);
            N._api.dispatchAction({ type: te, dataType: ne.dataType, dataIndexInside: ne.dataIndex, seriesIndex: ne.seriesIndex, isFromClick: true });
          }
        });
      };
      function e3(P) {
        P.clearColorPalette(), P.eachSeries(function(N) {
          N.clearColorPalette();
        });
      }
      function u(P) {
        var N = [], j = [], W = false;
        if (P.eachComponent(function(ce, me) {
          var ve = me.get("zlevel") || 0, Be = me.get("z") || 0, Oe = me.getZLevelKey();
          W = W || !!Oe, (ce === "series" ? j : N).push({ zlevel: ve, z: Be, idx: me.componentIndex, type: ce, key: Oe });
        }), W) {
          var K = N.concat(j), te, ne;
          yfe(K, function(ce, me) {
            return ce.zlevel === me.zlevel ? ce.z - me.z : ce.zlevel - me.zlevel;
          }), mt(K, function(ce) {
            var me = P.getComponent(ce.type, ce.idx), ve = ce.zlevel, Be = ce.key;
            te != null && (ve = Math.max(te, ve)), Be ? (ve === te && Be !== ne && ve++, ne = Be) : ne && (ve === te && ve++, ne = ""), te = ve, me.setZLevel(ve);
          });
        }
      }
      BEe = function(P, N, j, W, K) {
        u(N), grt(P, N, j, W, K), mt(P._chartsViews, function(te) {
          te.__alive = false;
        }), Oce(P, N, j, W, K), mt(P._chartsViews, function(te) {
          te.__alive || te.remove(N, j);
        });
      }, grt = function(P, N, j, W, K, te) {
        mt(te || P._componentsViews, function(ne) {
          var ce = ne.__model;
          A2(ce, ne), ne.render(ce, N, j, W), x3(ce, ne), D(ce, ne);
        });
      }, Oce = function(P, N, j, W, K, te) {
        var ne = P._scheduler;
        K = fi(K || {}, { updatedSeries: N.getSeries() }), cM.trigger("series:beforeupdate", N, j, K);
        var ce = false;
        N.eachSeries(function(me) {
          var ve = P._chartsMap[me.__viewId];
          ve.__alive = true;
          var Be = ve.renderTask;
          ne.updatePayload(Be, W), A2(me, ve), te && te.get(me.uid) && Be.dirty(), Be.perform(ne.getPerformArgs(Be)) && (ce = true), ve.group.silent = !!me.get("silent"), m3(me, ve), Jtt(me);
        }), ne.unfinished = ce || ne.unfinished, cM.trigger("series:layoutlabels", N, j, K), cM.trigger("series:transition", N, j, K), N.eachSeries(function(me) {
          var ve = P._chartsMap[me.__viewId];
          x3(me, ve), D(me, ve);
        }), v4(P, N), cM.trigger("series:afterupdate", N, j, K);
      }, e2 = function(P) {
        P[PEe] = true, P.getZr().wakeUp();
      }, mrt = function(P) {
        !P[PEe] || (P.getZr().storage.traverse(function(N) {
          ij(N) || h(N);
        }), P[PEe] = false);
      };
      function h(P) {
        for (var N = [], j = P.currentStates, W = 0; W < j.length; W++) {
          var K = j[W];
          K === "emphasis" || K === "blur" || K === "select" || N.push(K);
        }
        P.selected && P.states.select && N.push("select"), P.hoverState === $he && P.states.emphasis ? N.push("emphasis") : P.hoverState === OJ && P.states.blur && N.push("blur"), P.useStates(N);
      }
      function v4(P, N) {
        var j = P._zr, W = j.storage, K = 0;
        W.traverse(function(te) {
          te.isGroup || K++;
        }), K > N.get("hoverLayerThreshold") && !Fc.node && !Fc.worker && N.eachSeries(function(te) {
          if (!te.preventUsingHoverLayer) {
            var ne = P._chartsMap[te.__viewId];
            ne.__alive && ne.eachRendered(function(ce) {
              ce.states.emphasis && (ce.states.emphasis.hoverLayer = true);
            });
          }
        });
      }
      function m3(P, N) {
        var j = P.get("blendMode") || null;
        N.eachRendered(function(W) {
          W.isGroup || (W.style.blend = j);
        });
      }
      function x3(P, N) {
        if (!P.preventAutoZ) {
          var j = P.get("z") || 0, W = P.get("zlevel") || 0;
          N.eachRendered(function(K) {
            return C(K, j, W, -1 / 0), true;
          });
        }
      }
      function C(P, N, j, W) {
        var K = P.getTextContent(), te = P.getTextGuideLine(), ne = P.isGroup;
        if (ne)
          for (var ce = P.childrenRef(), me = 0; me < ce.length; me++)
            W = Math.max(C(ce[me], N, j, W), W);
        else
          P.z = N, P.zlevel = j, W = Math.max(P.z2, W);
        if (K && (K.z = N, K.zlevel = j, isFinite(W) && (K.z2 = W + 2)), te) {
          var ve = P.textGuideLineConfig;
          te.z = N, te.zlevel = j, isFinite(W) && (te.z2 = W + (ve && ve.showAbove ? 1 : -1));
        }
        return W;
      }
      function A2(P, N) {
        N.eachRendered(function(j) {
          if (!ij(j)) {
            var W = j.getTextContent(), K = j.getTextGuideLine();
            j.stateTransition && (j.stateTransition = null), W && W.stateTransition && (W.stateTransition = null), K && K.stateTransition && (K.stateTransition = null), j.hasState() ? (j.prevStates = j.currentStates, j.clearStates()) : j.prevStates && (j.prevStates = null);
          }
        });
      }
      function D(P, N) {
        var j = P.getModel("stateAnimation"), W = P.isAnimationEnabled(), K = j.get("duration"), te = K > 0 ? { duration: K, delay: j.get("delay"), easing: j.get("easing") } : null;
        N.eachRendered(function(ne) {
          if (ne.states && ne.states.emphasis) {
            if (ij(ne))
              return;
            if (ne instanceof Nl && hcn(ne), ne.__dirty) {
              var ce = ne.prevStates;
              ce && ne.useStates(ce);
            }
            if (W) {
              ne.stateTransition = te;
              var me = ne.getTextContent(), ve = ne.getTextGuideLine();
              me && (me.stateTransition = te), ve && (ve.stateTransition = te);
            }
            ne.__dirty && h(ne);
          }
        });
      }
      yrt = function(P) {
        return new (function(N) {
          ar(j, N);
          function j() {
            return N !== null && N.apply(this, arguments) || this;
          }
          return j.prototype.getCoordinateSystems = function() {
            return P._coordSysMgr.getCoordinateSystems();
          }, j.prototype.getComponentByElement = function(W) {
            for (; W; ) {
              var K = W.__ecComponentInfo;
              if (K != null)
                return P._model.getComponent(K.mainType, K.index);
              W = W.parent;
            }
          }, j.prototype.enterEmphasis = function(W, K) {
            zA(W, K), e2(P);
          }, j.prototype.leaveEmphasis = function(W, K) {
            jA(W, K), e2(P);
          }, j.prototype.enterBlur = function(W) {
            Hut(W), e2(P);
          }, j.prototype.leaveBlur = function(W) {
            Wut(W), e2(P);
          }, j.prototype.enterSelect = function(W) {
            Uut(W), e2(P);
          }, j.prototype.leaveSelect = function(W) {
            qut(W), e2(P);
          }, j.prototype.getModel = function() {
            return P.getModel();
          }, j.prototype.getViewOfComponentModel = function(W) {
            return P.getViewOfComponentModel(W);
          }, j.prototype.getViewOfSeriesModel = function(W) {
            return P.getViewOfSeriesModel(W);
          }, j;
        }(Kct))(P);
      }, Uft = function(P) {
        function N(j, W) {
          for (var K = 0; K < j.length; K++) {
            var te = j[K];
            te[LEe] = W;
          }
        }
        mt(GZ, function(j, W) {
          P._messageCenter.on(W, function(K) {
            if (brt[P.group] && P[LEe] !== prt) {
              if (K && K.escapeConnect)
                return;
              var te = P.makeActionFromEvent(K), ne = [];
              mt(HZ, function(ce) {
                ce !== P && ce.group === P.group && ne.push(ce);
              }), N(ne, prt), mt(ne, function(ce) {
                ce[LEe] !== tdn && ce.dispatchAction(te);
              }), N(ne, ndn);
            }
          });
        });
      };
    }(), r3;
  }(w2), gOe = qft.prototype;
  gOe.on = zft("on");
  gOe.off = zft("off");
  gOe.one = function(l3, r3, e3) {
    var u = this;
    function h() {
      for (var v4 = [], m3 = 0; m3 < arguments.length; m3++)
        v4[m3] = arguments[m3];
      r3 && r3.apply && r3.apply(this, v4), u.off(l3, h);
    }
    this.on.call(this, l3, h, e3);
  };
  var rdn = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"];
  var ahe = {}, GZ = {}, fke = [], hke = [], ohe = [], $ft = {}, pke = {}, HZ = {}, brt = {}, idn = +new Date() - 0, yOe = "_echarts_instance_";
  function adn(l3, r3, e3) {
    var u = !(e3 && e3.ssr);
    if (u) {
      var h = odn(l3);
      if (h)
        return h;
    }
    var v4 = new qft(l3, r3, e3);
    return v4.id = "ec_" + idn++, HZ[v4.id] = v4, u && wut(l3, yOe, v4.id), Uft(v4), cM.trigger("afterinit", v4), v4;
  }
  function odn(l3) {
    return HZ[Kln(l3, yOe)];
  }
  function Xft(l3, r3) {
    $ft[l3] = r3;
  }
  function Yft(l3) {
    Cl(hke, l3) < 0 && hke.push(l3);
  }
  function Kft(l3, r3) {
    bOe(fke, l3, r3, $pn);
  }
  function sdn(l3) {
    mOe("afterinit", l3);
  }
  function ldn(l3) {
    mOe("afterupdate", l3);
  }
  function mOe(l3, r3) {
    cM.on(l3, r3);
  }
  function ZA(l3, r3, e3) {
    Xo(r3) && (e3 = r3, r3 = "");
    var u = ls(l3) ? l3.type : [l3, l3 = { event: r3 }][0];
    l3.event = (l3.event || u).toLowerCase(), r3 = l3.event, !GZ[r3] && (mb(hrt.test(u) && hrt.test(r3)), ahe[u] || (ahe[u] = { action: e3, actionInfo: l3 }), GZ[r3] = u);
  }
  function udn(l3, r3) {
    FJ.register(l3, r3);
  }
  function cdn(l3, r3) {
    bOe(ohe, l3, r3, Fft, "layout");
  }
  function QN(l3, r3) {
    bOe(ohe, l3, r3, Vft, "visual");
  }
  var _rt = [];
  function bOe(l3, r3, e3, u, h) {
    if ((Xo(r3) || ls(r3)) && (e3 = r3, r3 = u), !(Cl(_rt, e3) >= 0)) {
      _rt.push(e3);
      var v4 = Tft.wrapStageHandler(e3, h);
      v4.__prio = r3, v4.__raw = e3, l3.push(v4);
    }
  }
  function Zft(l3, r3) {
    pke[l3] = r3;
  }
  function fdn(l3, r3, e3) {
    var u = jpn("registerMap");
    u && u(l3, r3, e3);
  }
  var hdn = _hn;
  QN(vOe, Uhn);
  QN(upe, qhn);
  QN(upe, $hn);
  QN(vOe, lpn);
  QN(upe, upn);
  QN(Bft, Vpn);
  Yft(Jct);
  Kft(Upn, ehn);
  Zft("default", Xhn);
  ZA({ type: NN, event: NN, update: NN }, Rv);
  ZA({ type: Sfe, event: Sfe, update: Sfe }, Rv);
  ZA({ type: FZ, event: FZ, update: FZ }, Rv);
  ZA({ type: Cfe, event: Cfe, update: Cfe }, Rv);
  ZA({ type: VZ, event: VZ, update: VZ }, Rv);
  Xft("light", apn);
  Xft("dark", opn);
  var xrt = [], pdn = { registerPreprocessor: Yft, registerProcessor: Kft, registerPostInit: sdn, registerPostUpdate: ldn, registerUpdateLifecycle: mOe, registerAction: ZA, registerCoordinateSystem: udn, registerLayout: cdn, registerVisual: QN, registerTransform: hdn, registerLoading: Zft, registerMap: fdn, registerImpl: zpn, PRIORITY: edn, ComponentModel: fc, ComponentView: yd, SeriesModel: Fp, ChartView: zh, registerComponentModel: function(l3) {
    fc.registerClass(l3);
  }, registerComponentView: function(l3) {
    yd.registerClass(l3);
  }, registerSeriesModel: function(l3) {
    Fp.registerClass(l3);
  }, registerChartView: function(l3) {
    zh.registerClass(l3);
  }, registerSubTypeDefaulter: function(l3, r3) {
    fc.registerSubTypeDefaulter(l3, r3);
  }, registerPainter: function(l3, r3) {
    Dln(l3, r3);
  } };
  function kl(l3) {
    if (Ni(l3)) {
      mt(l3, function(r3) {
        kl(r3);
      });
      return;
    }
    Cl(xrt, l3) >= 0 || (xrt.push(l3), Xo(l3) && (l3 = { install: l3 }), l3.install(pdn));
  }
  function tZ(l3) {
    return l3 == null ? 0 : l3.length || 1;
  }
  function wrt(l3) {
    return l3;
  }
  var ddn = function() {
    function l3(r3, e3, u, h, v4, m3) {
      this._old = r3, this._new = e3, this._oldKeyGetter = u || wrt, this._newKeyGetter = h || wrt, this.context = v4, this._diffModeMultiple = m3 === "multiple";
    }
    return l3.prototype.add = function(r3) {
      return this._add = r3, this;
    }, l3.prototype.update = function(r3) {
      return this._update = r3, this;
    }, l3.prototype.updateManyToOne = function(r3) {
      return this._updateManyToOne = r3, this;
    }, l3.prototype.updateOneToMany = function(r3) {
      return this._updateOneToMany = r3, this;
    }, l3.prototype.updateManyToMany = function(r3) {
      return this._updateManyToMany = r3, this;
    }, l3.prototype.remove = function(r3) {
      return this._remove = r3, this;
    }, l3.prototype.execute = function() {
      this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
    }, l3.prototype._executeOneToOne = function() {
      var r3 = this._old, e3 = this._new, u = {}, h = new Array(r3.length), v4 = new Array(e3.length);
      this._initIndexMap(r3, null, h, "_oldKeyGetter"), this._initIndexMap(e3, u, v4, "_newKeyGetter");
      for (var m3 = 0; m3 < r3.length; m3++) {
        var x3 = h[m3], C = u[x3], A2 = tZ(C);
        if (A2 > 1) {
          var D = C.shift();
          C.length === 1 && (u[x3] = C[0]), this._update && this._update(D, m3);
        } else
          A2 === 1 ? (u[x3] = null, this._update && this._update(C, m3)) : this._remove && this._remove(m3);
      }
      this._performRestAdd(v4, u);
    }, l3.prototype._executeMultiple = function() {
      var r3 = this._old, e3 = this._new, u = {}, h = {}, v4 = [], m3 = [];
      this._initIndexMap(r3, u, v4, "_oldKeyGetter"), this._initIndexMap(e3, h, m3, "_newKeyGetter");
      for (var x3 = 0; x3 < v4.length; x3++) {
        var C = v4[x3], A2 = u[C], D = h[C], P = tZ(A2), N = tZ(D);
        if (P > 1 && N === 1)
          this._updateManyToOne && this._updateManyToOne(D, A2), h[C] = null;
        else if (P === 1 && N > 1)
          this._updateOneToMany && this._updateOneToMany(D, A2), h[C] = null;
        else if (P === 1 && N === 1)
          this._update && this._update(D, A2), h[C] = null;
        else if (P > 1 && N > 1)
          this._updateManyToMany && this._updateManyToMany(D, A2), h[C] = null;
        else if (P > 1)
          for (var j = 0; j < P; j++)
            this._remove && this._remove(A2[j]);
        else
          this._remove && this._remove(A2);
      }
      this._performRestAdd(m3, h);
    }, l3.prototype._performRestAdd = function(r3, e3) {
      for (var u = 0; u < r3.length; u++) {
        var h = r3[u], v4 = e3[h], m3 = tZ(v4);
        if (m3 > 1)
          for (var x3 = 0; x3 < m3; x3++)
            this._add && this._add(v4[x3]);
        else
          m3 === 1 && this._add && this._add(v4);
        e3[h] = null;
      }
    }, l3.prototype._initIndexMap = function(r3, e3, u, h) {
      for (var v4 = this._diffModeMultiple, m3 = 0; m3 < r3.length; m3++) {
        var x3 = "_ec_" + this[h](r3[m3], m3);
        if (v4 || (u[m3] = x3), !!e3) {
          var C = e3[x3], A2 = tZ(C);
          A2 === 0 ? (e3[x3] = m3, v4 && u.push(x3)) : A2 === 1 ? e3[x3] = [C, m3] : C.push(m3);
        }
      }
    }, l3;
  }(), f5 = ddn, vdn = function() {
    function l3(r3, e3) {
      this._encode = r3, this._schema = e3;
    }
    return l3.prototype.get = function() {
      return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
    }, l3.prototype._getFullDimensionNames = function() {
      return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
    }, l3;
  }();
  function gdn(l3, r3) {
    var e3 = {}, u = e3.encode = {}, h = Ho(), v4 = [], m3 = [], x3 = {};
    mt(l3.dimensions, function(N) {
      var j = l3.getDimensionInfo(N), W = j.coordDim;
      if (W) {
        var K = j.coordDimIndex;
        zEe(u, W)[K] = N, j.isExtraCoord || (h.set(W, 1), ydn(j.type) && (v4[0] = N), zEe(x3, W)[K] = l3.getDimensionIndex(j.name)), j.defaultTooltip && m3.push(N);
      }
      jct.each(function(te, ne) {
        var ce = zEe(u, ne), me = j.otherDims[ne];
        me != null && me !== false && (ce[me] = j.name);
      });
    });
    var C = [], A2 = {};
    h.each(function(N, j) {
      var W = u[j];
      A2[j] = W[0], C = C.concat(W);
    }), e3.dataDimsOnCoord = C, e3.dataDimIndicesOnCoord = Bi(C, function(N) {
      return l3.getDimensionInfo(N).storeDimIndex;
    }), e3.encodeFirstDimNotExtra = A2;
    var D = u.label;
    D && D.length && (v4 = D.slice());
    var P = u.tooltip;
    return P && P.length ? m3 = P.slice() : m3.length || (m3 = v4.slice()), u.defaultedLabel = v4, u.defaultedTooltip = m3, e3.userOutput = new vdn(x3, r3), e3;
  }
  function zEe(l3, r3) {
    return l3.hasOwnProperty(r3) || (l3[r3] = []), l3[r3];
  }
  function she(l3) {
    return l3 === "category" ? "ordinal" : l3 === "time" ? "time" : "float";
  }
  function ydn(l3) {
    return !(l3 === "ordinal" || l3 === "time");
  }
  var mdn = function() {
    function l3(r3) {
      this.otherDims = {}, r3 != null && fi(this, r3);
    }
    return l3;
  }(), Efe = mdn, bdn = pc(), _dn = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, Jft = function() {
    function l3(r3) {
      this.dimensions = r3.dimensions, this._dimOmitted = r3.dimensionOmitted, this.source = r3.source, this._fullDimCount = r3.fullDimensionCount, this._updateDimOmitted(r3.dimensionOmitted);
    }
    return l3.prototype.isDimensionOmitted = function() {
      return this._dimOmitted;
    }, l3.prototype._updateDimOmitted = function(r3) {
      this._dimOmitted = r3, r3 && (this._dimNameMap || (this._dimNameMap = tht(this.source)));
    }, l3.prototype.getSourceDimensionIndex = function(r3) {
      return dl(this._dimNameMap.get(r3), -1);
    }, l3.prototype.getSourceDimension = function(r3) {
      var e3 = this.source.dimensionsDefine;
      if (e3)
        return e3[r3];
    }, l3.prototype.makeStoreSchema = function() {
      for (var r3 = this._fullDimCount, e3 = eft(this.source), u = !nht(r3), h = "", v4 = [], m3 = 0, x3 = 0; m3 < r3; m3++) {
        var C = void 0, A2 = void 0, D = void 0, P = this.dimensions[x3];
        if (P && P.storeDimIndex === m3)
          C = e3 ? P.name : null, A2 = P.type, D = P.ordinalMeta, x3++;
        else {
          var N = this.getSourceDimension(m3);
          N && (C = e3 ? N.name : null, A2 = N.type);
        }
        v4.push({ property: C, type: A2, ordinalMeta: D }), e3 && C != null && (!P || !P.isCalculationCoord) && (h += u ? C.replace(/\`/g, "`1").replace(/\$/g, "`2") : C), h += "$", h += _dn[A2] || "f", D && (h += D.uid), h += "$";
      }
      var j = this.source, W = [j.seriesLayoutBy, j.startIndex, h].join("$$");
      return { dimensions: v4, hash: W };
    }, l3.prototype.makeOutputDimensionNames = function() {
      for (var r3 = [], e3 = 0, u = 0; e3 < this._fullDimCount; e3++) {
        var h = void 0, v4 = this.dimensions[u];
        if (v4 && v4.storeDimIndex === e3)
          v4.isCalculationCoord || (h = v4.name), u++;
        else {
          var m3 = this.getSourceDimension(e3);
          m3 && (h = m3.name);
        }
        r3.push(h);
      }
      return r3;
    }, l3.prototype.appendCalculationDimension = function(r3) {
      this.dimensions.push(r3), r3.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
    }, l3;
  }();
  function Qft(l3) {
    return l3 instanceof Jft;
  }
  function eht(l3) {
    for (var r3 = Ho(), e3 = 0; e3 < (l3 || []).length; e3++) {
      var u = l3[e3], h = ls(u) ? u.name : u;
      h != null && r3.get(h) == null && r3.set(h, e3);
    }
    return r3;
  }
  function tht(l3) {
    var r3 = bdn(l3);
    return r3.dimNameMap || (r3.dimNameMap = eht(l3.dimensionsDefine));
  }
  function nht(l3) {
    return l3 > 30;
  }
  var nZ = ls, AO = Bi, xdn = typeof Int32Array == "undefined" ? Array : Int32Array, wdn = "e\0\0", Srt = -1, Sdn = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], Cdn = ["_approximateExtent"], Crt, Pce, rZ, iZ, jEe, Lce, GEe, Mdn = function() {
    function l3(r3, e3) {
      this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
      var u, h = false;
      Qft(r3) ? (u = r3.dimensions, this._dimOmitted = r3.isDimensionOmitted(), this._schema = r3) : (h = true, u = r3), u = u || ["x", "y"];
      for (var v4 = {}, m3 = [], x3 = {}, C = false, A2 = {}, D = 0; D < u.length; D++) {
        var P = u[D], N = qa(P) ? new Efe({ name: P }) : P instanceof Efe ? P : new Efe(P), j = N.name;
        N.type = N.type || "float", N.coordDim || (N.coordDim = j, N.coordDimIndex = 0);
        var W = N.otherDims = N.otherDims || {};
        m3.push(j), v4[j] = N, A2[j] != null && (C = true), N.createInvertedIndices && (x3[j] = []), W.itemName === 0 && (this._nameDimIdx = D), W.itemId === 0 && (this._idDimIdx = D), h && (N.storeDimIndex = D);
      }
      if (this.dimensions = m3, this._dimInfos = v4, this._initGetDimensionInfo(C), this.hostModel = e3, this._invertedIndicesMap = x3, this._dimOmitted) {
        var K = this._dimIdxToName = Ho();
        mt(m3, function(te) {
          K.set(v4[te].storeDimIndex, te);
        });
      }
    }
    return l3.prototype.getDimension = function(r3) {
      var e3 = this._recognizeDimIndex(r3);
      if (e3 == null)
        return r3;
      if (e3 = r3, !this._dimOmitted)
        return this.dimensions[e3];
      var u = this._dimIdxToName.get(e3);
      if (u != null)
        return u;
      var h = this._schema.getSourceDimension(e3);
      if (h)
        return h.name;
    }, l3.prototype.getDimensionIndex = function(r3) {
      var e3 = this._recognizeDimIndex(r3);
      if (e3 != null)
        return e3;
      if (r3 == null)
        return -1;
      var u = this._getDimInfo(r3);
      return u ? u.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(r3) : -1;
    }, l3.prototype._recognizeDimIndex = function(r3) {
      if (Vc(r3) || r3 != null && !isNaN(r3) && !this._getDimInfo(r3) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(r3) < 0))
        return +r3;
    }, l3.prototype._getStoreDimIndex = function(r3) {
      var e3 = this.getDimensionIndex(r3);
      return e3;
    }, l3.prototype.getDimensionInfo = function(r3) {
      return this._getDimInfo(this.getDimension(r3));
    }, l3.prototype._initGetDimensionInfo = function(r3) {
      var e3 = this._dimInfos;
      this._getDimInfo = r3 ? function(u) {
        return e3.hasOwnProperty(u) ? e3[u] : void 0;
      } : function(u) {
        return e3[u];
      };
    }, l3.prototype.getDimensionsOnCoord = function() {
      return this._dimSummary.dataDimsOnCoord.slice();
    }, l3.prototype.mapDimension = function(r3, e3) {
      var u = this._dimSummary;
      if (e3 == null)
        return u.encodeFirstDimNotExtra[r3];
      var h = u.encode[r3];
      return h ? h[e3] : null;
    }, l3.prototype.mapDimensionsAll = function(r3) {
      var e3 = this._dimSummary, u = e3.encode[r3];
      return (u || []).slice();
    }, l3.prototype.getStore = function() {
      return this._store;
    }, l3.prototype.initData = function(r3, e3, u) {
      var h = this, v4;
      if (r3 instanceof ike && (v4 = r3), !v4) {
        var m3 = this.dimensions, x3 = aOe(r3) || m1(r3) ? new tft(r3, m3.length) : r3;
        v4 = new ike();
        var C = AO(m3, function(A2) {
          return { type: h._dimInfos[A2].type, property: A2 };
        });
        v4.initData(x3, C, u);
      }
      this._store = v4, this._nameList = (e3 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, v4.count()), this._dimSummary = gdn(this, this._schema), this.userOutput = this._dimSummary.userOutput;
    }, l3.prototype.appendData = function(r3) {
      var e3 = this._store.appendData(r3);
      this._doInit(e3[0], e3[1]);
    }, l3.prototype.appendValues = function(r3, e3) {
      var u = this._store.appendValues(r3, e3.length), h = u.start, v4 = u.end, m3 = this._shouldMakeIdFromName();
      if (this._updateOrdinalMeta(), e3)
        for (var x3 = h; x3 < v4; x3++) {
          var C = x3 - h;
          this._nameList[x3] = e3[C], m3 && GEe(this, x3);
        }
    }, l3.prototype._updateOrdinalMeta = function() {
      for (var r3 = this._store, e3 = this.dimensions, u = 0; u < e3.length; u++) {
        var h = this._dimInfos[e3[u]];
        h.ordinalMeta && r3.collectOrdinalMeta(h.storeDimIndex, h.ordinalMeta);
      }
    }, l3.prototype._shouldMakeIdFromName = function() {
      var r3 = this._store.getProvider();
      return this._idDimIdx == null && r3.getSource().sourceFormat !== $O && !r3.fillStorage;
    }, l3.prototype._doInit = function(r3, e3) {
      if (!(r3 >= e3)) {
        var u = this._store, h = u.getProvider();
        this._updateOrdinalMeta();
        var v4 = this._nameList, m3 = this._idList, x3 = h.getSource().sourceFormat, C = x3 === S2;
        if (C && !h.pure)
          for (var A2 = [], D = r3; D < e3; D++) {
            var P = h.getItem(D, A2);
            if (!this.hasItemOption && Fln(P) && (this.hasItemOption = true), P) {
              var N = P.name;
              v4[D] == null && N != null && (v4[D] = pg(N, null));
              var j = P.id;
              m3[D] == null && j != null && (m3[D] = pg(j, null));
            }
          }
        if (this._shouldMakeIdFromName())
          for (var D = r3; D < e3; D++)
            GEe(this, D);
        Crt(this);
      }
    }, l3.prototype.getApproximateExtent = function(r3) {
      return this._approximateExtent[r3] || this._store.getDataExtent(this._getStoreDimIndex(r3));
    }, l3.prototype.setApproximateExtent = function(r3, e3) {
      e3 = this.getDimension(e3), this._approximateExtent[e3] = r3.slice();
    }, l3.prototype.getCalculationInfo = function(r3) {
      return this._calculationInfo[r3];
    }, l3.prototype.setCalculationInfo = function(r3, e3) {
      nZ(r3) ? fi(this._calculationInfo, r3) : this._calculationInfo[r3] = e3;
    }, l3.prototype.getName = function(r3) {
      var e3 = this.getRawIndex(r3), u = this._nameList[e3];
      return u == null && this._nameDimIdx != null && (u = rZ(this, this._nameDimIdx, e3)), u == null && (u = ""), u;
    }, l3.prototype._getCategory = function(r3, e3) {
      var u = this._store.get(r3, e3), h = this._store.getOrdinalMeta(r3);
      return h ? h.categories[u] : u;
    }, l3.prototype.getId = function(r3) {
      return Pce(this, this.getRawIndex(r3));
    }, l3.prototype.count = function() {
      return this._store.count();
    }, l3.prototype.get = function(r3, e3) {
      var u = this._store, h = this._dimInfos[r3];
      if (h)
        return u.get(h.storeDimIndex, e3);
    }, l3.prototype.getByRawIndex = function(r3, e3) {
      var u = this._store, h = this._dimInfos[r3];
      if (h)
        return u.getByRawIndex(h.storeDimIndex, e3);
    }, l3.prototype.getIndices = function() {
      return this._store.getIndices();
    }, l3.prototype.getDataExtent = function(r3) {
      return this._store.getDataExtent(this._getStoreDimIndex(r3));
    }, l3.prototype.getSum = function(r3) {
      return this._store.getSum(this._getStoreDimIndex(r3));
    }, l3.prototype.getMedian = function(r3) {
      return this._store.getMedian(this._getStoreDimIndex(r3));
    }, l3.prototype.getValues = function(r3, e3) {
      var u = this, h = this._store;
      return Ni(r3) ? h.getValues(AO(r3, function(v4) {
        return u._getStoreDimIndex(v4);
      }), e3) : h.getValues(r3);
    }, l3.prototype.hasValue = function(r3) {
      for (var e3 = this._dimSummary.dataDimIndicesOnCoord, u = 0, h = e3.length; u < h; u++)
        if (isNaN(this._store.get(e3[u], r3)))
          return false;
      return true;
    }, l3.prototype.indexOfName = function(r3) {
      for (var e3 = 0, u = this._store.count(); e3 < u; e3++)
        if (this.getName(e3) === r3)
          return e3;
      return -1;
    }, l3.prototype.getRawIndex = function(r3) {
      return this._store.getRawIndex(r3);
    }, l3.prototype.indexOfRawIndex = function(r3) {
      return this._store.indexOfRawIndex(r3);
    }, l3.prototype.rawIndexOf = function(r3, e3) {
      var u = r3 && this._invertedIndicesMap[r3], h = u[e3];
      return h == null || isNaN(h) ? Srt : h;
    }, l3.prototype.indicesOfNearest = function(r3, e3, u) {
      return this._store.indicesOfNearest(this._getStoreDimIndex(r3), e3, u);
    }, l3.prototype.each = function(r3, e3, u) {
      Xo(r3) && (u = e3, e3 = r3, r3 = []);
      var h = u || this, v4 = AO(iZ(r3), this._getStoreDimIndex, this);
      this._store.each(v4, h ? no(e3, h) : e3);
    }, l3.prototype.filterSelf = function(r3, e3, u) {
      Xo(r3) && (u = e3, e3 = r3, r3 = []);
      var h = u || this, v4 = AO(iZ(r3), this._getStoreDimIndex, this);
      return this._store = this._store.filter(v4, h ? no(e3, h) : e3), this;
    }, l3.prototype.selectRange = function(r3) {
      var e3 = this, u = {}, h = yu(r3);
      return mt(h, function(v4) {
        var m3 = e3._getStoreDimIndex(v4);
        u[m3] = r3[v4];
      }), this._store = this._store.selectRange(u), this;
    }, l3.prototype.mapArray = function(r3, e3, u) {
      Xo(r3) && (u = e3, e3 = r3, r3 = []), u = u || this;
      var h = [];
      return this.each(r3, function() {
        h.push(e3 && e3.apply(this, arguments));
      }, u), h;
    }, l3.prototype.map = function(r3, e3, u, h) {
      var v4 = u || h || this, m3 = AO(iZ(r3), this._getStoreDimIndex, this), x3 = Lce(this);
      return x3._store = this._store.map(m3, v4 ? no(e3, v4) : e3), x3;
    }, l3.prototype.modify = function(r3, e3, u, h) {
      var v4 = u || h || this, m3 = AO(iZ(r3), this._getStoreDimIndex, this);
      this._store.modify(m3, v4 ? no(e3, v4) : e3);
    }, l3.prototype.downSample = function(r3, e3, u, h) {
      var v4 = Lce(this);
      return v4._store = this._store.downSample(this._getStoreDimIndex(r3), e3, u, h), v4;
    }, l3.prototype.lttbDownSample = function(r3, e3) {
      var u = Lce(this);
      return u._store = this._store.lttbDownSample(this._getStoreDimIndex(r3), e3), u;
    }, l3.prototype.getRawDataItem = function(r3) {
      return this._store.getRawDataItem(r3);
    }, l3.prototype.getItemModel = function(r3) {
      var e3 = this.hostModel, u = this.getRawDataItem(r3);
      return new Bh(u, e3, e3 && e3.ecModel);
    }, l3.prototype.diff = function(r3) {
      var e3 = this;
      return new f5(r3 ? r3.getStore().getIndices() : [], this.getStore().getIndices(), function(u) {
        return Pce(r3, u);
      }, function(u) {
        return Pce(e3, u);
      });
    }, l3.prototype.getVisual = function(r3) {
      var e3 = this._visual;
      return e3 && e3[r3];
    }, l3.prototype.setVisual = function(r3, e3) {
      this._visual = this._visual || {}, nZ(r3) ? fi(this._visual, r3) : this._visual[r3] = e3;
    }, l3.prototype.getItemVisual = function(r3, e3) {
      var u = this._itemVisuals[r3], h = u && u[e3];
      return h == null ? this.getVisual(e3) : h;
    }, l3.prototype.hasItemVisual = function() {
      return this._itemVisuals.length > 0;
    }, l3.prototype.ensureUniqueItemVisual = function(r3, e3) {
      var u = this._itemVisuals, h = u[r3];
      h || (h = u[r3] = {});
      var v4 = h[e3];
      return v4 == null && (v4 = this.getVisual(e3), Ni(v4) ? v4 = v4.slice() : nZ(v4) && (v4 = fi({}, v4)), h[e3] = v4), v4;
    }, l3.prototype.setItemVisual = function(r3, e3, u) {
      var h = this._itemVisuals[r3] || {};
      this._itemVisuals[r3] = h, nZ(e3) ? fi(h, e3) : h[e3] = u;
    }, l3.prototype.clearAllVisual = function() {
      this._visual = {}, this._itemVisuals = [];
    }, l3.prototype.setLayout = function(r3, e3) {
      nZ(r3) ? fi(this._layout, r3) : this._layout[r3] = e3;
    }, l3.prototype.getLayout = function(r3) {
      return this._layout[r3];
    }, l3.prototype.getItemLayout = function(r3) {
      return this._itemLayouts[r3];
    }, l3.prototype.setItemLayout = function(r3, e3, u) {
      this._itemLayouts[r3] = u ? fi(this._itemLayouts[r3] || {}, e3) : e3;
    }, l3.prototype.clearItemLayouts = function() {
      this._itemLayouts.length = 0;
    }, l3.prototype.setItemGraphicEl = function(r3, e3) {
      var u = this.hostModel && this.hostModel.seriesIndex;
      U5e(u, this.dataType, r3, e3), this._graphicEls[r3] = e3;
    }, l3.prototype.getItemGraphicEl = function(r3) {
      return this._graphicEls[r3];
    }, l3.prototype.eachItemGraphicEl = function(r3, e3) {
      mt(this._graphicEls, function(u, h) {
        u && r3 && r3.call(e3, u, h);
      });
    }, l3.prototype.cloneShallow = function(r3) {
      return r3 || (r3 = new l3(this._schema ? this._schema : AO(this.dimensions, this._getDimInfo, this), this.hostModel)), jEe(r3, this), r3._store = this._store, r3;
    }, l3.prototype.wrapMethod = function(r3, e3) {
      var u = this[r3];
      !Xo(u) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(r3), this[r3] = function() {
        var h = u.apply(this, arguments);
        return e3.apply(this, [h].concat(A3e(arguments)));
      });
    }, l3.internalField = function() {
      Crt = function(r3) {
        var e3 = r3._invertedIndicesMap;
        mt(e3, function(u, h) {
          var v4 = r3._dimInfos[h], m3 = v4.ordinalMeta, x3 = r3._store;
          if (m3) {
            u = e3[h] = new xdn(m3.categories.length);
            for (var C = 0; C < u.length; C++)
              u[C] = Srt;
            for (var C = 0; C < x3.count(); C++)
              u[x3.get(v4.storeDimIndex, C)] = C;
          }
        });
      }, rZ = function(r3, e3, u) {
        return pg(r3._getCategory(e3, u), null);
      }, Pce = function(r3, e3) {
        var u = r3._idList[e3];
        return u == null && r3._idDimIdx != null && (u = rZ(r3, r3._idDimIdx, e3)), u == null && (u = wdn + e3), u;
      }, iZ = function(r3) {
        return Ni(r3) || (r3 = r3 != null ? [r3] : []), r3;
      }, Lce = function(r3) {
        var e3 = new l3(r3._schema ? r3._schema : AO(r3.dimensions, r3._getDimInfo, r3), r3.hostModel);
        return jEe(e3, r3), e3;
      }, jEe = function(r3, e3) {
        mt(Sdn.concat(e3.__wrappedMethods || []), function(u) {
          e3.hasOwnProperty(u) && (r3[u] = e3[u]);
        }), r3.__wrappedMethods = e3.__wrappedMethods, mt(Cdn, function(u) {
          r3[u] = bs(e3[u]);
        }), r3._calculationInfo = fi({}, e3._calculationInfo);
      }, GEe = function(r3, e3) {
        var u = r3._nameList, h = r3._idList, v4 = r3._nameDimIdx, m3 = r3._idDimIdx, x3 = u[e3], C = h[e3];
        if (x3 == null && v4 != null && (u[e3] = x3 = rZ(r3, v4, e3)), C == null && m3 != null && (h[e3] = C = rZ(r3, m3, e3)), C == null && x3 != null) {
          var A2 = r3._nameRepeatCount, D = A2[x3] = (A2[x3] || 0) + 1;
          C = x3, D > 1 && (C += "__ec__" + D), h[e3] = C;
        }
      };
    }(), l3;
  }(), yb = Mdn;
  function zJ(l3, r3) {
    aOe(l3) || (l3 = oOe(l3)), r3 = r3 || {};
    var e3 = r3.coordDimensions || [], u = r3.dimensionsDefine || l3.dimensionsDefine || [], h = Ho(), v4 = [], m3 = Adn(l3, e3, u, r3.dimensionsCount), x3 = r3.canOmitUnusedDimensions && nht(m3), C = u === l3.dimensionsDefine, A2 = C ? tht(l3) : eht(u), D = r3.encodeDefine;
    !D && r3.encodeDefaulter && (D = r3.encodeDefaulter(l3, m3));
    for (var P = Ho(D), N = new uft(m3), j = 0; j < N.length; j++)
      N[j] = -1;
    function W(qe) {
      var Ze = N[qe];
      if (Ze < 0) {
        var ct = u[qe], _t = ls(ct) ? ct : { name: ct }, pt = new Efe(), zt = _t.name;
        zt != null && A2.get(zt) != null && (pt.name = pt.displayName = zt), _t.type != null && (pt.type = _t.type), _t.displayName != null && (pt.displayName = _t.displayName);
        var Zt = v4.length;
        return N[qe] = Zt, pt.storeDimIndex = qe, v4.push(pt), pt;
      }
      return v4[Ze];
    }
    if (!x3)
      for (var j = 0; j < m3; j++)
        W(j);
    P.each(function(qe, Ze) {
      var ct = Gf(qe).slice();
      if (ct.length === 1 && !qa(ct[0]) && ct[0] < 0) {
        P.set(Ze, false);
        return;
      }
      var _t = P.set(Ze, []);
      mt(ct, function(pt, zt) {
        var Zt = qa(pt) ? A2.get(pt) : pt;
        Zt != null && Zt < m3 && (_t[zt] = Zt, te(W(Zt), Ze, zt));
      });
    });
    var K = 0;
    mt(e3, function(qe) {
      var Ze, ct, _t, pt;
      if (qa(qe))
        Ze = qe, pt = {};
      else {
        pt = qe, Ze = pt.name;
        var zt = pt.ordinalMeta;
        pt.ordinalMeta = null, pt = fi({}, pt), pt.ordinalMeta = zt, ct = pt.dimsDef, _t = pt.otherDims, pt.name = pt.coordDim = pt.coordDimIndex = pt.dimsDef = pt.otherDims = null;
      }
      var Zt = P.get(Ze);
      if (Zt !== false) {
        if (Zt = Gf(Zt), !Zt.length)
          for (var Ft = 0; Ft < (ct && ct.length || 1); Ft++) {
            for (; K < m3 && W(K).coordDim != null; )
              K++;
            K < m3 && Zt.push(K++);
          }
        mt(Zt, function(Kn, hn) {
          var xn = W(Kn);
          if (C && pt.type != null && (xn.type = pt.type), te(ns(xn, pt), Ze, hn), xn.name == null && ct) {
            var zn = ct[hn];
            !ls(zn) && (zn = { name: zn }), xn.name = xn.displayName = zn.name, xn.defaultTooltip = zn.defaultTooltip;
          }
          _t && ns(xn.otherDims, _t);
        });
      }
    });
    function te(qe, Ze, ct) {
      jct.get(Ze) != null ? qe.otherDims[Ze] = ct : (qe.coordDim = Ze, qe.coordDimIndex = ct, h.set(Ze, true));
    }
    var ne = r3.generateCoord, ce = r3.generateCoordCount, me = ce != null;
    ce = ne ? ce || 1 : 0;
    var ve = ne || "value";
    function Be(qe) {
      qe.name == null && (qe.name = qe.coordDim);
    }
    if (x3)
      mt(v4, function(qe) {
        Be(qe);
      }), v4.sort(function(qe, Ze) {
        return qe.storeDimIndex - Ze.storeDimIndex;
      });
    else
      for (var Oe = 0; Oe < m3; Oe++) {
        var We = W(Oe), Ue = We.coordDim;
        Ue == null && (We.coordDim = Idn(ve, h, me), We.coordDimIndex = 0, (!ne || ce <= 0) && (We.isExtraCoord = true), ce--), Be(We), We.type == null && (Uct(l3, Oe) === im.Must || We.isExtraCoord && (We.otherDims.itemName != null || We.otherDims.seriesName != null)) && (We.type = "ordinal");
      }
    return Tdn(v4), new Jft({ source: l3, dimensions: v4, fullDimensionCount: m3, dimensionOmitted: x3 });
  }
  function Tdn(l3) {
    for (var r3 = Ho(), e3 = 0; e3 < l3.length; e3++) {
      var u = l3[e3], h = u.name, v4 = r3.get(h) || 0;
      v4 > 0 && (u.name = h + (v4 - 1)), v4++, r3.set(h, v4);
    }
  }
  function Adn(l3, r3, e3, u) {
    var h = Math.max(l3.dimensionsDetectedCount || 1, r3.length, e3.length, u || 0);
    return mt(r3, function(v4) {
      var m3;
      ls(v4) && (m3 = v4.dimsDef) && (h = Math.max(h, m3.length));
    }), h;
  }
  function Idn(l3, r3, e3) {
    var u = r3.data;
    if (e3 || u.hasOwnProperty(l3)) {
      for (var h = 0; u.hasOwnProperty(l3 + h); )
        h++;
      l3 += h;
    }
    return r3.set(l3, true), l3;
  }
  var Edn = function() {
    function l3(r3) {
      this.coordSysDims = [], this.axisMap = Ho(), this.categoryAxisMap = Ho(), this.coordSysName = r3;
    }
    return l3;
  }();
  function Ddn(l3) {
    var r3 = l3.get("coordinateSystem"), e3 = new Edn(r3), u = kdn[r3];
    if (u)
      return u(l3, e3, e3.axisMap, e3.categoryAxisMap), e3;
  }
  var kdn = { cartesian2d: function(l3, r3, e3, u) {
    var h = l3.getReferringComponents("xAxis", Lv).models[0], v4 = l3.getReferringComponents("yAxis", Lv).models[0];
    r3.coordSysDims = ["x", "y"], e3.set("x", h), e3.set("y", v4), Oz(h) && (u.set("x", h), r3.firstCategoryDimIndex = 0), Oz(v4) && (u.set("y", v4), r3.firstCategoryDimIndex == null && (r3.firstCategoryDimIndex = 1));
  }, singleAxis: function(l3, r3, e3, u) {
    var h = l3.getReferringComponents("singleAxis", Lv).models[0];
    r3.coordSysDims = ["single"], e3.set("single", h), Oz(h) && (u.set("single", h), r3.firstCategoryDimIndex = 0);
  }, polar: function(l3, r3, e3, u) {
    var h = l3.getReferringComponents("polar", Lv).models[0], v4 = h.findAxisModel("radiusAxis"), m3 = h.findAxisModel("angleAxis");
    r3.coordSysDims = ["radius", "angle"], e3.set("radius", v4), e3.set("angle", m3), Oz(v4) && (u.set("radius", v4), r3.firstCategoryDimIndex = 0), Oz(m3) && (u.set("angle", m3), r3.firstCategoryDimIndex == null && (r3.firstCategoryDimIndex = 1));
  }, geo: function(l3, r3, e3, u) {
    r3.coordSysDims = ["lng", "lat"];
  }, parallel: function(l3, r3, e3, u) {
    var h = l3.ecModel, v4 = h.getComponent("parallel", l3.get("parallelIndex")), m3 = r3.coordSysDims = v4.dimensions.slice();
    mt(v4.parallelAxisIndex, function(x3, C) {
      var A2 = h.getComponent("parallelAxis", x3), D = m3[C];
      e3.set(D, A2), Oz(A2) && (u.set(D, A2), r3.firstCategoryDimIndex == null && (r3.firstCategoryDimIndex = C));
    });
  } };
  function Oz(l3) {
    return l3.get("type") === "category";
  }
  function Odn(l3, r3, e3) {
    e3 = e3 || {};
    var u = e3.byIndex, h = e3.stackedCoordDimension, v4, m3, x3;
    Pdn(r3) ? v4 = r3 : (m3 = r3.schema, v4 = m3.dimensions, x3 = r3.store);
    var C = !!(l3 && l3.get("stack")), A2, D, P, N;
    if (mt(v4, function(ce, me) {
      qa(ce) && (v4[me] = ce = { name: ce }), C && !ce.isExtraCoord && (!u && !A2 && ce.ordinalMeta && (A2 = ce), !D && ce.type !== "ordinal" && ce.type !== "time" && (!h || h === ce.coordDim) && (D = ce));
    }), D && !u && !A2 && (u = true), D) {
      P = "__\0ecstackresult_" + l3.id, N = "__\0ecstackedover_" + l3.id, A2 && (A2.createInvertedIndices = true);
      var j = D.coordDim, W = D.type, K = 0;
      mt(v4, function(ce) {
        ce.coordDim === j && K++;
      });
      var te = { name: P, coordDim: j, coordDimIndex: K, type: W, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: v4.length }, ne = { name: N, coordDim: N, coordDimIndex: K + 1, type: W, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: v4.length + 1 };
      m3 ? (x3 && (te.storeDimIndex = x3.ensureCalculationDimension(N, W), ne.storeDimIndex = x3.ensureCalculationDimension(P, W)), m3.appendCalculationDimension(te), m3.appendCalculationDimension(ne)) : (v4.push(te), v4.push(ne));
    }
    return { stackedDimension: D && D.name, stackedByDimension: A2 && A2.name, isStackedByIndex: u, stackedOverDimension: N, stackResultDimension: P };
  }
  function Pdn(l3) {
    return !Qft(l3.schema);
  }
  function eP(l3, r3) {
    return !!r3 && r3 === l3.getCalculationInfo("stackedDimension");
  }
  function rht(l3, r3) {
    return eP(l3, r3) ? l3.getCalculationInfo("stackResultDimension") : r3;
  }
  function Ldn(l3, r3) {
    var e3 = l3.get("coordinateSystem"), u = FJ.get(e3), h;
    return r3 && r3.coordSysDims && (h = Bi(r3.coordSysDims, function(v4) {
      var m3 = { name: v4 }, x3 = r3.axisMap.get(v4);
      if (x3) {
        var C = x3.get("type");
        m3.type = she(C);
      }
      return m3;
    })), h || (h = u && (u.getDimensionsInfo ? u.getDimensionsInfo() : u.dimensions.slice()) || ["x", "y"]), h;
  }
  function Rdn(l3, r3, e3) {
    var u, h;
    return e3 && mt(l3, function(v4, m3) {
      var x3 = v4.coordDim, C = e3.categoryAxisMap.get(x3);
      C && (u == null && (u = m3), v4.ordinalMeta = C.getOrdinalMeta(), r3 && (v4.createInvertedIndices = true)), v4.otherDims.itemName != null && (h = true);
    }), !h && u != null && (l3[u].otherDims.itemName = 0), u;
  }
  function v5(l3, r3, e3) {
    e3 = e3 || {};
    var u = r3.getSourceManager(), h, v4 = false;
    l3 ? (v4 = true, h = oOe(l3)) : (h = u.getSource(), v4 = h.sourceFormat === S2);
    var m3 = Ddn(r3), x3 = Ldn(r3, m3), C = e3.useEncodeDefaulter, A2 = Xo(C) ? C : C ? Fs(Wct, x3, r3) : null, D = { coordDimensions: x3, generateCoord: e3.generateCoord, encodeDefine: r3.getEncode(), encodeDefaulter: A2, canOmitUnusedDimensions: !v4 }, P = zJ(h, D), N = Rdn(P.dimensions, e3.createInvertedIndices, m3), j = v4 ? null : u.getSharedDataStore(P), W = Odn(r3, { schema: P, store: j }), K = new yb(P, r3);
    K.setCalculationInfo(W);
    var te = N != null && Ndn(h) ? function(ne, ce, me, ve) {
      return ve === N ? me : this.defaultDimValueGetter(ne, ce, me, ve);
    } : null;
    return K.hasItemOption = false, K.initData(v4 ? h : j, null, te), K;
  }
  function Ndn(l3) {
    if (l3.sourceFormat === S2) {
      var r3 = Fdn(l3.data || []);
      return !Ni(xj(r3));
    }
  }
  function Fdn(l3) {
    for (var r3 = 0; r3 < l3.length && l3[r3] == null; )
      r3++;
    return l3[r3];
  }
  var iht = function() {
    function l3(r3) {
      this._setting = r3 || {}, this._extent = [1 / 0, -1 / 0];
    }
    return l3.prototype.getSetting = function(r3) {
      return this._setting[r3];
    }, l3.prototype.unionExtent = function(r3) {
      var e3 = this._extent;
      r3[0] < e3[0] && (e3[0] = r3[0]), r3[1] > e3[1] && (e3[1] = r3[1]);
    }, l3.prototype.unionExtentFromData = function(r3, e3) {
      this.unionExtent(r3.getApproximateExtent(e3));
    }, l3.prototype.getExtent = function() {
      return this._extent.slice();
    }, l3.prototype.setExtent = function(r3, e3) {
      var u = this._extent;
      isNaN(r3) || (u[0] = r3), isNaN(e3) || (u[1] = e3);
    }, l3.prototype.isInExtentRange = function(r3) {
      return this._extent[0] <= r3 && this._extent[1] >= r3;
    }, l3.prototype.isBlank = function() {
      return this._isBlank;
    }, l3.prototype.setBlank = function(r3) {
      this._isBlank = r3;
    }, l3;
  }();
  Hhe(iht);
  var g5 = iht, Vdn = 0, Bdn = function() {
    function l3(r3) {
      this.categories = r3.categories || [], this._needCollect = r3.needCollect, this._deduplication = r3.deduplication, this.uid = ++Vdn;
    }
    return l3.createByAxisModel = function(r3) {
      var e3 = r3.option, u = e3.data, h = u && Bi(u, zdn);
      return new l3({ categories: h, needCollect: !h, deduplication: e3.dedplication !== false });
    }, l3.prototype.getOrdinal = function(r3) {
      return this._getOrCreateMap().get(r3);
    }, l3.prototype.parseAndCollect = function(r3) {
      var e3, u = this._needCollect;
      if (!qa(r3) && !u)
        return r3;
      if (u && !this._deduplication)
        return e3 = this.categories.length, this.categories[e3] = r3, e3;
      var h = this._getOrCreateMap();
      return e3 = h.get(r3), e3 == null && (u ? (e3 = this.categories.length, this.categories[e3] = r3, h.set(r3, e3)) : e3 = NaN), e3;
    }, l3.prototype._getOrCreateMap = function() {
      return this._map || (this._map = Ho(this.categories));
    }, l3;
  }();
  function zdn(l3) {
    return ls(l3) && l3.value != null ? l3.value : l3 + "";
  }
  var dke = Bdn;
  function vke(l3) {
    return l3.type === "interval" || l3.type === "log";
  }
  function jdn(l3, r3, e3, u) {
    var h = {}, v4 = l3[1] - l3[0], m3 = h.interval = dut(v4 / r3, true);
    e3 != null && m3 < e3 && (m3 = h.interval = e3), u != null && m3 > u && (m3 = h.interval = u);
    var x3 = h.intervalPrecision = aht(m3), C = h.niceTickExtent = [jd(Math.ceil(l3[0] / m3) * m3, x3), jd(Math.floor(l3[1] / m3) * m3, x3)];
    return Gdn(C, l3), h;
  }
  function HEe(l3) {
    var r3 = Math.pow(10, R3e(l3)), e3 = l3 / r3;
    return e3 ? e3 === 2 ? e3 = 3 : e3 === 3 ? e3 = 5 : e3 *= 2 : e3 = 1, jd(e3 * r3);
  }
  function aht(l3) {
    return NA(l3) + 2;
  }
  function Mrt(l3, r3, e3) {
    l3[r3] = Math.max(Math.min(l3[r3], e3[1]), e3[0]);
  }
  function Gdn(l3, r3) {
    !isFinite(l3[0]) && (l3[0] = r3[0]), !isFinite(l3[1]) && (l3[1] = r3[1]), Mrt(l3, 0, r3), Mrt(l3, 1, r3), l3[0] > l3[1] && (l3[0] = l3[1]);
  }
  function cpe(l3, r3) {
    return l3 >= r3[0] && l3 <= r3[1];
  }
  function fpe(l3, r3) {
    return r3[1] === r3[0] ? 0.5 : (l3 - r3[0]) / (r3[1] - r3[0]);
  }
  function hpe(l3, r3) {
    return l3 * (r3[1] - r3[0]) + r3[0];
  }
  var oht = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      u.type = "ordinal";
      var h = u.getSetting("ordinalMeta");
      return h || (h = new dke({})), Ni(h) && (h = new dke({ categories: Bi(h, function(v4) {
        return ls(v4) ? v4.value : v4;
      }) })), u._ordinalMeta = h, u._extent = u.getSetting("extent") || [0, h.categories.length - 1], u;
    }
    return r3.prototype.parse = function(e3) {
      return qa(e3) ? this._ordinalMeta.getOrdinal(e3) : Math.round(e3);
    }, r3.prototype.contain = function(e3) {
      return e3 = this.parse(e3), cpe(e3, this._extent) && this._ordinalMeta.categories[e3] != null;
    }, r3.prototype.normalize = function(e3) {
      return e3 = this._getTickNumber(this.parse(e3)), fpe(e3, this._extent);
    }, r3.prototype.scale = function(e3) {
      return e3 = Math.round(hpe(e3, this._extent)), this.getRawOrdinalNumber(e3);
    }, r3.prototype.getTicks = function() {
      for (var e3 = [], u = this._extent, h = u[0]; h <= u[1]; )
        e3.push({ value: h }), h++;
      return e3;
    }, r3.prototype.getMinorTicks = function(e3) {
    }, r3.prototype.setSortInfo = function(e3) {
      if (e3 == null) {
        this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
        return;
      }
      for (var u = e3.ordinalNumbers, h = this._ordinalNumbersByTick = [], v4 = this._ticksByOrdinalNumber = [], m3 = 0, x3 = this._ordinalMeta.categories.length, C = Math.min(x3, u.length); m3 < C; ++m3) {
        var A2 = u[m3];
        h[m3] = A2, v4[A2] = m3;
      }
      for (var D = 0; m3 < x3; ++m3) {
        for (; v4[D] != null; )
          D++;
        h.push(D), v4[D] = m3;
      }
    }, r3.prototype._getTickNumber = function(e3) {
      var u = this._ticksByOrdinalNumber;
      return u && e3 >= 0 && e3 < u.length ? u[e3] : e3;
    }, r3.prototype.getRawOrdinalNumber = function(e3) {
      var u = this._ordinalNumbersByTick;
      return u && e3 >= 0 && e3 < u.length ? u[e3] : e3;
    }, r3.prototype.getLabel = function(e3) {
      if (!this.isBlank()) {
        var u = this.getRawOrdinalNumber(e3.value), h = this._ordinalMeta.categories[u];
        return h == null ? "" : h + "";
      }
    }, r3.prototype.count = function() {
      return this._extent[1] - this._extent[0] + 1;
    }, r3.prototype.unionExtentFromData = function(e3, u) {
      this.unionExtent(e3.getApproximateExtent(u));
    }, r3.prototype.isInExtentRange = function(e3) {
      return e3 = this._getTickNumber(e3), this._extent[0] <= e3 && this._extent[1] >= e3;
    }, r3.prototype.getOrdinalMeta = function() {
      return this._ordinalMeta;
    }, r3.prototype.calcNiceTicks = function() {
    }, r3.prototype.calcNiceExtent = function() {
    }, r3.type = "ordinal", r3;
  }(g5);
  g5.registerClass(oht);
  var _Oe = oht, cN = jd, sht = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "interval", e3._interval = 0, e3._intervalPrecision = 2, e3;
    }
    return r3.prototype.parse = function(e3) {
      return e3;
    }, r3.prototype.contain = function(e3) {
      return cpe(e3, this._extent);
    }, r3.prototype.normalize = function(e3) {
      return fpe(e3, this._extent);
    }, r3.prototype.scale = function(e3) {
      return hpe(e3, this._extent);
    }, r3.prototype.setExtent = function(e3, u) {
      var h = this._extent;
      isNaN(e3) || (h[0] = parseFloat(e3)), isNaN(u) || (h[1] = parseFloat(u));
    }, r3.prototype.unionExtent = function(e3) {
      var u = this._extent;
      e3[0] < u[0] && (u[0] = e3[0]), e3[1] > u[1] && (u[1] = e3[1]), this.setExtent(u[0], u[1]);
    }, r3.prototype.getInterval = function() {
      return this._interval;
    }, r3.prototype.setInterval = function(e3) {
      this._interval = e3, this._niceExtent = this._extent.slice(), this._intervalPrecision = aht(e3);
    }, r3.prototype.getTicks = function(e3) {
      var u = this._interval, h = this._extent, v4 = this._niceExtent, m3 = this._intervalPrecision, x3 = [];
      if (!u)
        return x3;
      var C = 1e4;
      h[0] < v4[0] && (e3 ? x3.push({ value: cN(v4[0] - u, m3) }) : x3.push({ value: h[0] }));
      for (var A2 = v4[0]; A2 <= v4[1] && (x3.push({ value: A2 }), A2 = cN(A2 + u, m3), A2 !== x3[x3.length - 1].value); )
        if (x3.length > C)
          return [];
      var D = x3.length ? x3[x3.length - 1].value : v4[1];
      return h[1] > D && (e3 ? x3.push({ value: cN(D + u, m3) }) : x3.push({ value: h[1] })), x3;
    }, r3.prototype.getMinorTicks = function(e3) {
      for (var u = this.getTicks(true), h = [], v4 = this.getExtent(), m3 = 1; m3 < u.length; m3++) {
        for (var x3 = u[m3], C = u[m3 - 1], A2 = 0, D = [], P = x3.value - C.value, N = P / e3; A2 < e3 - 1; ) {
          var j = cN(C.value + (A2 + 1) * N);
          j > v4[0] && j < v4[1] && D.push(j), A2++;
        }
        h.push(D);
      }
      return h;
    }, r3.prototype.getLabel = function(e3, u) {
      if (e3 == null)
        return "";
      var h = u && u.precision;
      h == null ? h = NA(e3.value) || 0 : h === "auto" && (h = this._intervalPrecision);
      var v4 = cN(e3.value, h, true);
      return Rct(v4);
    }, r3.prototype.calcNiceTicks = function(e3, u, h) {
      e3 = e3 || 5;
      var v4 = this._extent, m3 = v4[1] - v4[0];
      if (!!isFinite(m3)) {
        m3 < 0 && (m3 = -m3, v4.reverse());
        var x3 = jdn(v4, e3, u, h);
        this._intervalPrecision = x3.intervalPrecision, this._interval = x3.interval, this._niceExtent = x3.niceTickExtent;
      }
    }, r3.prototype.calcNiceExtent = function(e3) {
      var u = this._extent;
      if (u[0] === u[1])
        if (u[0] !== 0) {
          var h = u[0];
          e3.fixMax || (u[1] += h / 2), u[0] -= h / 2;
        } else
          u[1] = 1;
      var v4 = u[1] - u[0];
      isFinite(v4) || (u[0] = 0, u[1] = 1), this.calcNiceTicks(e3.splitNumber, e3.minInterval, e3.maxInterval);
      var m3 = this._interval;
      e3.fixMin || (u[0] = cN(Math.floor(u[0] / m3) * m3)), e3.fixMax || (u[1] = cN(Math.ceil(u[1] / m3) * m3));
    }, r3.prototype.setNiceExtent = function(e3, u) {
      this._niceExtent = [e3, u];
    }, r3.type = "interval", r3;
  }(g5);
  g5.registerClass(sht);
  var tP = sht, lht = typeof Float32Array != "undefined", Hdn = lht ? Float32Array : Array;
  function VA(l3) {
    return Ni(l3) ? lht ? new Float32Array(l3) : l3 : new Hdn(l3);
  }
  var gke = "__ec_stack_";
  function xOe(l3) {
    return l3.get("stack") || gke + l3.seriesIndex;
  }
  function wOe(l3) {
    return l3.dim + l3.index;
  }
  function Wdn(l3) {
    var r3 = [], e3 = l3.axis, u = "axis0";
    if (e3.type === "category") {
      for (var h = e3.getBandWidth(), v4 = 0; v4 < l3.count; v4++)
        r3.push(ns({ bandWidth: h, axisKey: u, stackId: gke + v4 }, l3));
      for (var m3 = fht(r3), x3 = [], v4 = 0; v4 < l3.count; v4++) {
        var C = m3[u][gke + v4];
        C.offsetCenter = C.offset + C.width / 2, x3.push(C);
      }
      return x3;
    }
  }
  function uht(l3, r3) {
    var e3 = [];
    return r3.eachSeriesByType(l3, function(u) {
      dht(u) && e3.push(u);
    }), e3;
  }
  function Udn(l3) {
    var r3 = {};
    mt(l3, function(C) {
      var A2 = C.coordinateSystem, D = A2.getBaseAxis();
      if (!(D.type !== "time" && D.type !== "value"))
        for (var P = C.getData(), N = D.dim + "_" + D.index, j = P.getDimensionIndex(P.mapDimension(D.dim)), W = P.getStore(), K = 0, te = W.count(); K < te; ++K) {
          var ne = W.get(j, K);
          r3[N] ? r3[N].push(ne) : r3[N] = [ne];
        }
    });
    var e3 = {};
    for (var u in r3)
      if (r3.hasOwnProperty(u)) {
        var h = r3[u];
        if (h) {
          h.sort(function(C, A2) {
            return C - A2;
          });
          for (var v4 = null, m3 = 1; m3 < h.length; ++m3) {
            var x3 = h[m3] - h[m3 - 1];
            x3 > 0 && (v4 = v4 === null ? x3 : Math.min(v4, x3));
          }
          e3[u] = v4;
        }
      }
    return e3;
  }
  function cht(l3) {
    var r3 = Udn(l3), e3 = [];
    return mt(l3, function(u) {
      var h = u.coordinateSystem, v4 = h.getBaseAxis(), m3 = v4.getExtent(), x3;
      if (v4.type === "category")
        x3 = v4.getBandWidth();
      else if (v4.type === "value" || v4.type === "time") {
        var C = v4.dim + "_" + v4.index, A2 = r3[C], D = Math.abs(m3[1] - m3[0]), P = v4.scale.getExtent(), N = Math.abs(P[1] - P[0]);
        x3 = A2 ? D / N * A2 : D;
      } else {
        var j = u.getData();
        x3 = Math.abs(m3[1] - m3[0]) / j.count();
      }
      var W = za(u.get("barWidth"), x3), K = za(u.get("barMaxWidth"), x3), te = za(u.get("barMinWidth") || (vht(u) ? 0.5 : 1), x3), ne = u.get("barGap"), ce = u.get("barCategoryGap");
      e3.push({ bandWidth: x3, barWidth: W, barMaxWidth: K, barMinWidth: te, barGap: ne, barCategoryGap: ce, axisKey: wOe(v4), stackId: xOe(u) });
    }), fht(e3);
  }
  function fht(l3) {
    var r3 = {};
    mt(l3, function(u, h) {
      var v4 = u.axisKey, m3 = u.bandWidth, x3 = r3[v4] || { bandWidth: m3, remainedWidth: m3, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, C = x3.stacks;
      r3[v4] = x3;
      var A2 = u.stackId;
      C[A2] || x3.autoWidthCount++, C[A2] = C[A2] || { width: 0, maxWidth: 0 };
      var D = u.barWidth;
      D && !C[A2].width && (C[A2].width = D, D = Math.min(x3.remainedWidth, D), x3.remainedWidth -= D);
      var P = u.barMaxWidth;
      P && (C[A2].maxWidth = P);
      var N = u.barMinWidth;
      N && (C[A2].minWidth = N);
      var j = u.barGap;
      j != null && (x3.gap = j);
      var W = u.barCategoryGap;
      W != null && (x3.categoryGap = W);
    });
    var e3 = {};
    return mt(r3, function(u, h) {
      e3[h] = {};
      var v4 = u.stacks, m3 = u.bandWidth, x3 = u.categoryGap;
      if (x3 == null) {
        var C = yu(v4).length;
        x3 = Math.max(35 - C * 4, 15) + "%";
      }
      var A2 = za(x3, m3), D = za(u.gap, 1), P = u.remainedWidth, N = u.autoWidthCount, j = (P - A2) / (N + (N - 1) * D);
      j = Math.max(j, 0), mt(v4, function(ne) {
        var ce = ne.maxWidth, me = ne.minWidth;
        if (ne.width) {
          var ve = ne.width;
          ce && (ve = Math.min(ve, ce)), me && (ve = Math.max(ve, me)), ne.width = ve, P -= ve + D * ve, N--;
        } else {
          var ve = j;
          ce && ce < ve && (ve = Math.min(ce, P)), me && me > ve && (ve = me), ve !== j && (ne.width = ve, P -= ve + D * ve, N--);
        }
      }), j = (P - A2) / (N + (N - 1) * D), j = Math.max(j, 0);
      var W = 0, K;
      mt(v4, function(ne, ce) {
        ne.width || (ne.width = j), K = ne, W += ne.width * (1 + D);
      }), K && (W -= K.width * D);
      var te = -W / 2;
      mt(v4, function(ne, ce) {
        e3[h][ce] = e3[h][ce] || { bandWidth: m3, offset: te, width: ne.width }, te += ne.width * (1 + D);
      });
    }), e3;
  }
  function qdn(l3, r3, e3) {
    if (l3 && r3) {
      var u = l3[wOe(r3)];
      return u != null && e3 != null ? u[xOe(e3)] : u;
    }
  }
  function hht(l3, r3) {
    var e3 = uht(l3, r3), u = cht(e3);
    mt(e3, function(h) {
      var v4 = h.getData(), m3 = h.coordinateSystem, x3 = m3.getBaseAxis(), C = xOe(h), A2 = u[wOe(x3)][C], D = A2.offset, P = A2.width;
      v4.setLayout({ bandWidth: A2.bandWidth, offset: D, size: P });
    });
  }
  function pht(l3) {
    return { seriesType: l3, plan: kj(), reset: function(r3) {
      if (!!dht(r3)) {
        var e3 = r3.getData(), u = r3.coordinateSystem, h = u.getBaseAxis(), v4 = u.getOtherAxis(h), m3 = e3.getDimensionIndex(e3.mapDimension(v4.dim)), x3 = e3.getDimensionIndex(e3.mapDimension(h.dim)), C = r3.get("showBackground", true), A2 = e3.mapDimension(v4.dim), D = e3.getCalculationInfo("stackResultDimension"), P = eP(e3, A2) && !!e3.getCalculationInfo("stackedOnSeries"), N = v4.isHorizontal(), j = $dn(h, v4), W = vht(r3), K = r3.get("barMinHeight") || 0, te = D && e3.getDimensionIndex(D), ne = e3.getLayout("size"), ce = e3.getLayout("offset");
        return { progress: function(me, ve) {
          for (var Be = me.count, Oe = W && VA(Be * 3), We = W && C && VA(Be * 3), Ue = W && VA(Be), qe = u.master.getRect(), Ze = N ? qe.width : qe.height, ct, _t = ve.getStore(), pt = 0; (ct = me.next()) != null; ) {
            var zt = _t.get(P ? te : m3, ct), Zt = _t.get(x3, ct), Ft = j, Kn = void 0;
            P && (Kn = +zt - _t.get(m3, ct));
            var hn = void 0, xn = void 0, zn = void 0, or = void 0;
            if (N) {
              var vr = u.dataToPoint([zt, Zt]);
              if (P) {
                var la = u.dataToPoint([Kn, Zt]);
                Ft = la[0];
              }
              hn = Ft, xn = vr[1] + ce, zn = vr[0] - Ft, or = ne, Math.abs(zn) < K && (zn = (zn < 0 ? -1 : 1) * K);
            } else {
              var vr = u.dataToPoint([Zt, zt]);
              if (P) {
                var la = u.dataToPoint([Zt, Kn]);
                Ft = la[1];
              }
              hn = vr[0] + ce, xn = Ft, zn = ne, or = vr[1] - Ft, Math.abs(or) < K && (or = (or <= 0 ? -1 : 1) * K);
            }
            W ? (Oe[pt] = hn, Oe[pt + 1] = xn, Oe[pt + 2] = N ? zn : or, We && (We[pt] = N ? qe.x : hn, We[pt + 1] = N ? xn : qe.y, We[pt + 2] = Ze), Ue[ct] = ct) : ve.setItemLayout(ct, { x: hn, y: xn, width: zn, height: or }), pt += 3;
          }
          W && ve.setLayout({ largePoints: Oe, largeDataIndices: Ue, largeBackgroundPoints: We, valueAxisHorizontal: N });
        } };
      }
    } };
  }
  function dht(l3) {
    return l3.coordinateSystem && l3.coordinateSystem.type === "cartesian2d";
  }
  function vht(l3) {
    return l3.pipelineContext && l3.pipelineContext.large;
  }
  function $dn(l3, r3) {
    return r3.toGlobalCoord(r3.dataToCoord(r3.type === "log" ? 1 : 0));
  }
  var Xdn = function(l3, r3, e3, u) {
    for (; e3 < u; ) {
      var h = e3 + u >>> 1;
      l3[h][1] < r3 ? e3 = h + 1 : u = h;
    }
    return e3;
  }, ght = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "time", u;
    }
    return r3.prototype.getLabel = function(e3) {
      var u = this.getSetting("useUTC");
      return epe(e3.value, vnt[vfn(aj(this._minLevelUnit))] || vnt.second, u, this.getSetting("locale"));
    }, r3.prototype.getFormattedLabel = function(e3, u, h) {
      var v4 = this.getSetting("useUTC"), m3 = this.getSetting("locale");
      return gfn(e3, u, h, m3, v4);
    }, r3.prototype.getTicks = function() {
      var e3 = this._interval, u = this._extent, h = [];
      if (!e3)
        return h;
      h.push({ value: u[0], level: 0 });
      var v4 = this.getSetting("useUTC"), m3 = tvn(this._minLevelUnit, this._approxInterval, v4, u);
      return h = h.concat(m3), h.push({ value: u[1], level: 0 }), h;
    }, r3.prototype.calcNiceExtent = function(e3) {
      var u = this._extent;
      if (u[0] === u[1] && (u[0] -= v22, u[1] += v22), u[1] === -1 / 0 && u[0] === 1 / 0) {
        var h = new Date();
        u[1] = +new Date(h.getFullYear(), h.getMonth(), h.getDate()), u[0] = u[1] - v22;
      }
      this.calcNiceTicks(e3.splitNumber, e3.minInterval, e3.maxInterval);
    }, r3.prototype.calcNiceTicks = function(e3, u, h) {
      e3 = e3 || 10;
      var v4 = this._extent, m3 = v4[1] - v4[0];
      this._approxInterval = m3 / e3, u != null && this._approxInterval < u && (this._approxInterval = u), h != null && this._approxInterval > h && (this._approxInterval = h);
      var x3 = Rce.length, C = Math.min(Xdn(Rce, this._approxInterval, 0, x3), x3 - 1);
      this._interval = Rce[C][1], this._minLevelUnit = Rce[Math.max(C - 1, 0)][0];
    }, r3.prototype.parse = function(e3) {
      return Vc(e3) ? e3 : +$A(e3);
    }, r3.prototype.contain = function(e3) {
      return cpe(this.parse(e3), this._extent);
    }, r3.prototype.normalize = function(e3) {
      return fpe(this.parse(e3), this._extent);
    }, r3.prototype.scale = function(e3) {
      return hpe(e3, this._extent);
    }, r3.type = "time", r3;
  }(tP), Rce = [["second", J3e], ["minute", Q3e], ["hour", zZ], ["quarter-day", zZ * 6], ["half-day", zZ * 12], ["day", v22 * 1.2], ["half-week", v22 * 3.5], ["week", v22 * 7], ["month", v22 * 31], ["quarter", v22 * 95], ["half-year", dnt / 2], ["year", dnt]];
  function Ydn(l3, r3, e3, u) {
    var h = $A(r3), v4 = $A(e3), m3 = function(W) {
      return gnt(h, W, u) === gnt(v4, W, u);
    }, x3 = function() {
      return m3("year");
    }, C = function() {
      return x3() && m3("month");
    }, A2 = function() {
      return C() && m3("day");
    }, D = function() {
      return A2() && m3("hour");
    }, P = function() {
      return D() && m3("minute");
    }, N = function() {
      return P() && m3("second");
    }, j = function() {
      return N() && m3("millisecond");
    };
    switch (l3) {
      case "year":
        return x3();
      case "month":
        return C();
      case "day":
        return A2();
      case "hour":
        return D();
      case "minute":
        return P();
      case "second":
        return N();
      case "millisecond":
        return j();
    }
  }
  function Kdn(l3, r3) {
    return l3 /= v22, l3 > 16 ? 16 : l3 > 7.5 ? 7 : l3 > 3.5 ? 4 : l3 > 1.5 ? 2 : 1;
  }
  function Zdn(l3) {
    var r3 = 30 * v22;
    return l3 /= r3, l3 > 6 ? 6 : l3 > 3 ? 3 : l3 > 2 ? 2 : 1;
  }
  function Jdn(l3) {
    return l3 /= zZ, l3 > 12 ? 12 : l3 > 6 ? 6 : l3 > 3.5 ? 4 : l3 > 2 ? 2 : 1;
  }
  function Trt(l3, r3) {
    return l3 /= r3 ? Q3e : J3e, l3 > 30 ? 30 : l3 > 20 ? 20 : l3 > 15 ? 15 : l3 > 10 ? 10 : l3 > 5 ? 5 : l3 > 2 ? 2 : 1;
  }
  function Qdn(l3) {
    return dut(l3, true);
  }
  function evn(l3, r3, e3) {
    var u = new Date(l3);
    switch (aj(r3)) {
      case "year":
      case "month":
        u[Ect(e3)](0);
      case "day":
        u[Dct(e3)](1);
      case "hour":
        u[kct(e3)](0);
      case "minute":
        u[Oct(e3)](0);
      case "second":
        u[Pct(e3)](0), u[Lct(e3)](0);
    }
    return u.getTime();
  }
  function tvn(l3, r3, e3, u) {
    var h = 1e4, v4 = Act, m3 = 0;
    function x3(Ze, ct, _t, pt, zt, Zt, Ft) {
      for (var Kn = new Date(ct), hn = ct, xn = Kn[pt](); hn < _t && hn <= u[1]; )
        Ft.push({ value: hn }), xn += Ze, Kn[zt](xn), hn = Kn.getTime();
      Ft.push({ value: hn, notAdd: true });
    }
    function C(Ze, ct, _t) {
      var pt = [], zt = !ct.length;
      if (!Ydn(aj(Ze), u[0], u[1], e3)) {
        zt && (ct = [{ value: evn(new Date(u[0]), Ze, e3) }, { value: u[1] }]);
        for (var Zt = 0; Zt < ct.length - 1; Zt++) {
          var Ft = ct[Zt].value, Kn = ct[Zt + 1].value;
          if (Ft !== Kn) {
            var hn = void 0, xn = void 0, zn = void 0, or = false;
            switch (Ze) {
              case "year":
                hn = Math.max(1, Math.round(r3 / v22 / 365)), xn = eOe(e3), zn = yfn(e3);
                break;
              case "half-year":
              case "quarter":
              case "month":
                hn = Zdn(r3), xn = oj(e3), zn = Ect(e3);
                break;
              case "week":
              case "half-week":
              case "day":
                hn = Kdn(r3), xn = tpe(e3), zn = Dct(e3), or = true;
                break;
              case "half-day":
              case "quarter-day":
              case "hour":
                hn = Jdn(r3), xn = sJ(e3), zn = kct(e3);
                break;
              case "minute":
                hn = Trt(r3, true), xn = npe(e3), zn = Oct(e3);
                break;
              case "second":
                hn = Trt(r3, false), xn = rpe(e3), zn = Pct(e3);
                break;
              case "millisecond":
                hn = Qdn(r3), xn = ipe(e3), zn = Lct(e3);
                break;
            }
            x3(hn, Ft, Kn, xn, zn, or, pt), Ze === "year" && _t.length > 1 && Zt === 0 && _t.unshift({ value: _t[0].value - hn });
          }
        }
        for (var Zt = 0; Zt < pt.length; Zt++)
          _t.push(pt[Zt]);
        return pt;
      }
    }
    for (var A2 = [], D = [], P = 0, N = 0, j = 0; j < v4.length && m3++ < h; ++j) {
      var W = aj(v4[j]);
      if (!!dfn(v4[j])) {
        C(v4[j], A2[A2.length - 1] || [], D);
        var K = v4[j + 1] ? aj(v4[j + 1]) : null;
        if (W !== K) {
          if (D.length) {
            N = P, D.sort(function(Ze, ct) {
              return Ze.value - ct.value;
            });
            for (var te = [], ne = 0; ne < D.length; ++ne) {
              var ce = D[ne].value;
              (ne === 0 || D[ne - 1].value !== ce) && (te.push(D[ne]), ce >= u[0] && ce <= u[1] && P++);
            }
            var me = (u[1] - u[0]) / r3;
            if (P > me * 1.5 && N > me / 1.5 || (A2.push(te), P > me || l3 === v4[j]))
              break;
          }
          D = [];
        }
      }
    }
    for (var ve = jf(Bi(A2, function(Ze) {
      return jf(Ze, function(ct) {
        return ct.value >= u[0] && ct.value <= u[1] && !ct.notAdd;
      });
    }), function(Ze) {
      return Ze.length > 0;
    }), Be = [], Oe = ve.length - 1, j = 0; j < ve.length; ++j)
      for (var We = ve[j], Ue = 0; Ue < We.length; ++Ue)
        Be.push({ value: We[Ue].value, level: Oe - j });
    Be.sort(function(Ze, ct) {
      return Ze.value - ct.value;
    });
    for (var qe = [], j = 0; j < Be.length; ++j)
      (j === 0 || Be[j].value !== Be[j - 1].value) && qe.push(Be[j]);
    return qe;
  }
  g5.registerClass(ght);
  var yht = ght, Art = g5.prototype, WZ = tP.prototype, nvn = jd, rvn = Math.floor, ivn = Math.ceil, Nce = Math.pow, t2 = Math.log, SOe = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "log", e3.base = 10, e3._originalScale = new tP(), e3._interval = 0, e3;
    }
    return r3.prototype.getTicks = function(e3) {
      var u = this._originalScale, h = this._extent, v4 = u.getExtent(), m3 = WZ.getTicks.call(this, e3);
      return Bi(m3, function(x3) {
        var C = x3.value, A2 = jd(Nce(this.base, C));
        return A2 = C === h[0] && this._fixMin ? Fce(A2, v4[0]) : A2, A2 = C === h[1] && this._fixMax ? Fce(A2, v4[1]) : A2, { value: A2 };
      }, this);
    }, r3.prototype.setExtent = function(e3, u) {
      var h = this.base;
      e3 = t2(e3) / t2(h), u = t2(u) / t2(h), WZ.setExtent.call(this, e3, u);
    }, r3.prototype.getExtent = function() {
      var e3 = this.base, u = Art.getExtent.call(this);
      u[0] = Nce(e3, u[0]), u[1] = Nce(e3, u[1]);
      var h = this._originalScale, v4 = h.getExtent();
      return this._fixMin && (u[0] = Fce(u[0], v4[0])), this._fixMax && (u[1] = Fce(u[1], v4[1])), u;
    }, r3.prototype.unionExtent = function(e3) {
      this._originalScale.unionExtent(e3);
      var u = this.base;
      e3[0] = t2(e3[0]) / t2(u), e3[1] = t2(e3[1]) / t2(u), Art.unionExtent.call(this, e3);
    }, r3.prototype.unionExtentFromData = function(e3, u) {
      this.unionExtent(e3.getApproximateExtent(u));
    }, r3.prototype.calcNiceTicks = function(e3) {
      e3 = e3 || 10;
      var u = this._extent, h = u[1] - u[0];
      if (!(h === 1 / 0 || h <= 0)) {
        var v4 = Nln(h), m3 = e3 / h * v4;
        for (m3 <= 0.5 && (v4 *= 10); !isNaN(v4) && Math.abs(v4) < 1 && Math.abs(v4) > 0; )
          v4 *= 10;
        var x3 = [jd(ivn(u[0] / v4) * v4), jd(rvn(u[1] / v4) * v4)];
        this._interval = v4, this._niceExtent = x3;
      }
    }, r3.prototype.calcNiceExtent = function(e3) {
      WZ.calcNiceExtent.call(this, e3), this._fixMin = e3.fixMin, this._fixMax = e3.fixMax;
    }, r3.prototype.parse = function(e3) {
      return e3;
    }, r3.prototype.contain = function(e3) {
      return e3 = t2(e3) / t2(this.base), cpe(e3, this._extent);
    }, r3.prototype.normalize = function(e3) {
      return e3 = t2(e3) / t2(this.base), fpe(e3, this._extent);
    }, r3.prototype.scale = function(e3) {
      return e3 = hpe(e3, this._extent), Nce(this.base, e3);
    }, r3.type = "log", r3;
  }(g5), mht = SOe.prototype;
  mht.getMinorTicks = WZ.getMinorTicks;
  mht.getLabel = WZ.getLabel;
  function Fce(l3, r3) {
    return nvn(l3, NA(r3));
  }
  g5.registerClass(SOe);
  var avn = SOe, ovn = function() {
    function l3(r3, e3, u) {
      this._prepareParams(r3, e3, u);
    }
    return l3.prototype._prepareParams = function(r3, e3, u) {
      u[1] < u[0] && (u = [NaN, NaN]), this._dataMin = u[0], this._dataMax = u[1];
      var h = this._isOrdinal = r3.type === "ordinal";
      this._needCrossZero = r3.type === "interval" && e3.getNeedCrossZero && e3.getNeedCrossZero();
      var v4 = this._modelMinRaw = e3.get("min", true);
      Xo(v4) ? this._modelMinNum = Vce(r3, v4({ min: u[0], max: u[1] })) : v4 !== "dataMin" && (this._modelMinNum = Vce(r3, v4));
      var m3 = this._modelMaxRaw = e3.get("max", true);
      if (Xo(m3) ? this._modelMaxNum = Vce(r3, m3({ min: u[0], max: u[1] })) : m3 !== "dataMax" && (this._modelMaxNum = Vce(r3, m3)), h)
        this._axisDataLen = e3.getCategories().length;
      else {
        var x3 = e3.get("boundaryGap"), C = Ni(x3) ? x3 : [x3 || 0, x3 || 0];
        typeof C[0] == "boolean" || typeof C[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [gM(C[0], 1), gM(C[1], 1)];
      }
    }, l3.prototype.calculate = function() {
      var r3 = this._isOrdinal, e3 = this._dataMin, u = this._dataMax, h = this._axisDataLen, v4 = this._boundaryGapInner, m3 = r3 ? null : u - e3 || Math.abs(e3), x3 = this._modelMinRaw === "dataMin" ? e3 : this._modelMinNum, C = this._modelMaxRaw === "dataMax" ? u : this._modelMaxNum, A2 = x3 != null, D = C != null;
      x3 == null && (x3 = r3 ? h ? 0 : NaN : e3 - v4[0] * m3), C == null && (C = r3 ? h ? h - 1 : NaN : u + v4[1] * m3), (x3 == null || !isFinite(x3)) && (x3 = NaN), (C == null || !isFinite(C)) && (C = NaN);
      var P = JZ(x3) || JZ(C) || r3 && !h;
      this._needCrossZero && (x3 > 0 && C > 0 && !A2 && (x3 = 0), x3 < 0 && C < 0 && !D && (C = 0));
      var N = this._determinedMin, j = this._determinedMax;
      return N != null && (x3 = N, A2 = true), j != null && (C = j, D = true), { min: x3, max: C, minFixed: A2, maxFixed: D, isBlank: P };
    }, l3.prototype.modifyDataMinMax = function(r3, e3) {
      this[lvn[r3]] = e3;
    }, l3.prototype.setDeterminedMinMax = function(r3, e3) {
      var u = svn[r3];
      this[u] = e3;
    }, l3.prototype.freeze = function() {
      this.frozen = true;
    }, l3;
  }(), svn = { min: "_determinedMin", max: "_determinedMax" }, lvn = { min: "_dataMin", max: "_dataMax" };
  function bht(l3, r3, e3) {
    var u = l3.rawExtentInfo;
    return u || (u = new ovn(l3, r3, e3), l3.rawExtentInfo = u, u);
  }
  function Vce(l3, r3) {
    return r3 == null ? null : JZ(r3) ? NaN : l3.parse(r3);
  }
  function _ht(l3, r3) {
    var e3 = l3.type, u = bht(l3, r3, l3.getExtent()).calculate();
    l3.setBlank(u.isBlank);
    var h = u.min, v4 = u.max, m3 = r3.ecModel;
    if (m3 && e3 === "time") {
      var x3 = uht("bar", m3), C = false;
      if (mt(x3, function(P) {
        C = C || P.getBaseAxis() === r3.axis;
      }), C) {
        var A2 = cht(x3), D = uvn(h, v4, r3, A2);
        h = D.min, v4 = D.max;
      }
    }
    return { extent: [h, v4], fixMin: u.minFixed, fixMax: u.maxFixed };
  }
  function uvn(l3, r3, e3, u) {
    var h = e3.axis.getExtent(), v4 = h[1] - h[0], m3 = qdn(u, e3.axis);
    if (m3 === void 0)
      return { min: l3, max: r3 };
    var x3 = 1 / 0;
    mt(m3, function(j) {
      x3 = Math.min(j.offset, x3);
    });
    var C = -1 / 0;
    mt(m3, function(j) {
      C = Math.max(j.offset + j.width, C);
    }), x3 = Math.abs(x3), C = Math.abs(C);
    var A2 = x3 + C, D = r3 - l3, P = 1 - (x3 + C) / v4, N = D / P - D;
    return r3 += N * (C / A2), l3 -= N * (x3 / A2), { min: l3, max: r3 };
  }
  function pj(l3, r3) {
    var e3 = r3, u = _ht(l3, e3), h = u.extent, v4 = e3.get("splitNumber");
    l3 instanceof avn && (l3.base = e3.get("logBase"));
    var m3 = l3.type, x3 = e3.get("interval"), C = m3 === "interval" || m3 === "time";
    l3.setExtent(h[0], h[1]), l3.calcNiceExtent({ splitNumber: v4, fixMin: u.fixMin, fixMax: u.fixMax, minInterval: C ? e3.get("minInterval") : null, maxInterval: C ? e3.get("maxInterval") : null }), x3 != null && l3.setInterval && l3.setInterval(x3);
  }
  function ppe(l3, r3) {
    if (r3 = r3 || l3.get("type"), r3)
      switch (r3) {
        case "category":
          return new _Oe({ ordinalMeta: l3.getOrdinalMeta ? l3.getOrdinalMeta() : l3.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new yht({ locale: l3.ecModel.getLocaleModel(), useUTC: l3.ecModel.get("useUTC") });
        default:
          return new (g5.getClass(r3) || tP)();
      }
  }
  function cvn(l3) {
    var r3 = l3.scale.getExtent(), e3 = r3[0], u = r3[1];
    return !(e3 > 0 && u > 0 || e3 < 0 && u < 0);
  }
  function jJ(l3) {
    var r3 = l3.getLabelModel().get("formatter"), e3 = l3.type === "category" ? l3.scale.getExtent()[0] : null;
    return l3.scale.type === "time" ? function(u) {
      return function(h, v4) {
        return l3.scale.getFormattedLabel(h, v4, u);
      };
    }(r3) : qa(r3) ? function(u) {
      return function(h) {
        var v4 = l3.scale.getLabel(h), m3 = u.replace("{value}", v4 != null ? v4 : "");
        return m3;
      };
    }(r3) : Xo(r3) ? function(u) {
      return function(h, v4) {
        return e3 != null && (v4 = h.value - e3), u(COe(l3, h), v4, h.level != null ? { level: h.level } : null);
      };
    }(r3) : function(u) {
      return l3.scale.getLabel(u);
    };
  }
  function COe(l3, r3) {
    return l3.type === "category" ? l3.scale.getLabel(r3) : r3.value;
  }
  function fvn(l3) {
    var r3 = l3.model, e3 = l3.scale;
    if (!(!r3.get(["axisLabel", "show"]) || e3.isBlank())) {
      var u, h, v4 = e3.getExtent();
      e3 instanceof _Oe ? h = e3.count() : (u = e3.getTicks(), h = u.length);
      var m3 = l3.getLabelModel(), x3 = jJ(l3), C, A2 = 1;
      h > 40 && (A2 = Math.ceil(h / 40));
      for (var D = 0; D < h; D += A2) {
        var P = u ? u[D] : { value: v4[0] + D }, N = x3(P, D), j = m3.getTextRect(N), W = hvn(j, m3.get("rotate") || 0);
        C ? C.union(W) : C = W;
      }
      return C;
    }
  }
  function hvn(l3, r3) {
    var e3 = r3 * Math.PI / 180, u = l3.width, h = l3.height, v4 = u * Math.abs(Math.cos(e3)) + Math.abs(h * Math.sin(e3)), m3 = u * Math.abs(Math.sin(e3)) + Math.abs(h * Math.cos(e3)), x3 = new Ml(l3.x, l3.y, v4, m3);
    return x3;
  }
  function MOe(l3) {
    var r3 = l3.get("interval");
    return r3 == null ? "auto" : r3;
  }
  function xht(l3) {
    return l3.type === "category" && MOe(l3.getLabelModel()) === 0;
  }
  function lhe(l3, r3) {
    var e3 = {};
    return mt(l3.mapDimensionsAll(r3), function(u) {
      e3[rht(l3, u)] = true;
    }), yu(e3);
  }
  function pvn(l3, r3, e3) {
    r3 && mt(lhe(r3, e3), function(u) {
      var h = r3.getApproximateExtent(u);
      h[0] < l3[0] && (l3[0] = h[0]), h[1] > l3[1] && (l3[1] = h[1]);
    });
  }
  var GJ = function() {
    function l3() {
    }
    return l3.prototype.getNeedCrossZero = function() {
      var r3 = this.option;
      return !r3.scale;
    }, l3.prototype.getCoordSysModel = function() {
    }, l3;
  }(), dvn = 1e-8;
  function Irt(l3, r3) {
    return Math.abs(l3 - r3) < dvn;
  }
  function CN(l3, r3, e3) {
    var u = 0, h = l3[0];
    if (!h)
      return false;
    for (var v4 = 1; v4 < l3.length; v4++) {
      var m3 = l3[v4];
      u += JD(h[0], h[1], m3[0], m3[1], r3, e3), h = m3;
    }
    var x3 = l3[0];
    return (!Irt(h[0], x3[0]) || !Irt(h[1], x3[1])) && (u += JD(h[0], h[1], x3[0], x3[1], r3, e3)), u !== 0;
  }
  var vvn = [];
  function WEe(l3, r3) {
    for (var e3 = 0; e3 < l3.length; e3++)
      am(l3[e3], l3[e3], r3);
  }
  function Ert(l3, r3, e3, u) {
    for (var h = 0; h < l3.length; h++) {
      var v4 = l3[h];
      u && (v4 = u.project(v4)), v4 && isFinite(v4[0]) && isFinite(v4[1]) && (NO(r3, r3, v4), FO(e3, e3, v4));
    }
  }
  function gvn(l3) {
    for (var r3 = 0, e3 = 0, u = 0, h = l3.length, v4 = l3[h - 1][0], m3 = l3[h - 1][1], x3 = 0; x3 < h; x3++) {
      var C = l3[x3][0], A2 = l3[x3][1], D = v4 * A2 - C * m3;
      r3 += D, e3 += (v4 + C) * D, u += (m3 + A2) * D, v4 = C, m3 = A2;
    }
    return r3 ? [e3 / r3 / 3, u / r3 / 3, r3] : [l3[0][0] || 0, l3[0][1] || 0];
  }
  var wht = function() {
    function l3(r3) {
      this.name = r3;
    }
    return l3.prototype.setCenter = function(r3) {
      this._center = r3;
    }, l3.prototype.getCenter = function() {
      var r3 = this._center;
      return r3 || (r3 = this._center = this.calcCenter()), r3;
    }, l3;
  }(), Drt = function() {
    function l3(r3, e3) {
      this.type = "polygon", this.exterior = r3, this.interiors = e3;
    }
    return l3;
  }(), krt = function() {
    function l3(r3) {
      this.type = "linestring", this.points = r3;
    }
    return l3;
  }(), Sht = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this, e3) || this;
      return v4.type = "geoJSON", v4.geometries = u, v4._center = h && [h[0], h[1]], v4;
    }
    return r3.prototype.calcCenter = function() {
      for (var e3 = this.geometries, u, h = 0, v4 = 0; v4 < e3.length; v4++) {
        var m3 = e3[v4], x3 = m3.exterior, C = x3 && x3.length;
        C > h && (u = m3, h = C);
      }
      if (u)
        return gvn(u.exterior);
      var A2 = this.getBoundingRect();
      return [A2.x + A2.width / 2, A2.y + A2.height / 2];
    }, r3.prototype.getBoundingRect = function(e3) {
      var u = this._rect;
      if (u && !e3)
        return u;
      var h = [1 / 0, 1 / 0], v4 = [-1 / 0, -1 / 0], m3 = this.geometries;
      return mt(m3, function(x3) {
        x3.type === "polygon" ? Ert(x3.exterior, h, v4, e3) : mt(x3.points, function(C) {
          Ert(C, h, v4, e3);
        });
      }), isFinite(h[0]) && isFinite(h[1]) && isFinite(v4[0]) && isFinite(v4[1]) || (h[0] = h[1] = v4[0] = v4[1] = 0), u = new Ml(h[0], h[1], v4[0] - h[0], v4[1] - h[1]), e3 || (this._rect = u), u;
    }, r3.prototype.contain = function(e3) {
      var u = this.getBoundingRect(), h = this.geometries;
      if (!u.contain(e3[0], e3[1]))
        return false;
      e:
        for (var v4 = 0, m3 = h.length; v4 < m3; v4++) {
          var x3 = h[v4];
          if (x3.type === "polygon") {
            var C = x3.exterior, A2 = x3.interiors;
            if (CN(C, e3[0], e3[1])) {
              for (var D = 0; D < (A2 ? A2.length : 0); D++)
                if (CN(A2[D], e3[0], e3[1]))
                  continue e;
              return true;
            }
          }
        }
      return false;
    }, r3.prototype.transformTo = function(e3, u, h, v4) {
      var m3 = this.getBoundingRect(), x3 = m3.width / m3.height;
      h ? v4 || (v4 = h / x3) : h = x3 * v4;
      for (var C = new Ml(e3, u, h, v4), A2 = m3.calculateTransform(C), D = this.geometries, P = 0; P < D.length; P++) {
        var N = D[P];
        N.type === "polygon" ? (WEe(N.exterior, A2), mt(N.interiors, function(j) {
          WEe(j, A2);
        })) : mt(N.points, function(j) {
          WEe(j, A2);
        });
      }
      m3 = this._rect, m3.copy(C), this._center = [m3.x + m3.width / 2, m3.y + m3.height / 2];
    }, r3.prototype.cloneShallow = function(e3) {
      e3 == null && (e3 = this.name);
      var u = new r3(e3, this.geometries, this._center);
      return u._rect = this._rect, u.transformTo = null, u;
    }, r3;
  }(wht), yvn = function(l3) {
    ar(r3, l3);
    function r3(e3, u) {
      var h = l3.call(this, e3) || this;
      return h.type = "geoSVG", h._elOnlyForCalculate = u, h;
    }
    return r3.prototype.calcCenter = function() {
      for (var e3 = this._elOnlyForCalculate, u = e3.getBoundingRect(), h = [u.x + u.width / 2, u.y + u.height / 2], v4 = jhe(vvn), m3 = e3; m3 && !m3.isGeoSVGGraphicRoot; )
        i5(v4, m3.getLocalTransform(), v4), m3 = m3.parent;
      return _j(v4, v4), am(h, h, v4), h;
    }, r3;
  }(wht);
  function mvn(l3) {
    if (!l3.UTF8Encoding)
      return l3;
    var r3 = l3, e3 = r3.UTF8Scale;
    e3 == null && (e3 = 1024);
    var u = r3.features;
    return mt(u, function(h) {
      var v4 = h.geometry, m3 = v4.encodeOffsets, x3 = v4.coordinates;
      if (!!m3)
        switch (v4.type) {
          case "LineString":
            v4.coordinates = Cht(x3, m3, e3);
            break;
          case "Polygon":
            UEe(x3, m3, e3);
            break;
          case "MultiLineString":
            UEe(x3, m3, e3);
            break;
          case "MultiPolygon":
            mt(x3, function(C, A2) {
              return UEe(C, m3[A2], e3);
            });
        }
    }), r3.UTF8Encoding = false, r3;
  }
  function UEe(l3, r3, e3) {
    for (var u = 0; u < l3.length; u++)
      l3[u] = Cht(l3[u], r3[u], e3);
  }
  function Cht(l3, r3, e3) {
    for (var u = [], h = r3[0], v4 = r3[1], m3 = 0; m3 < l3.length; m3 += 2) {
      var x3 = l3.charCodeAt(m3) - 64, C = l3.charCodeAt(m3 + 1) - 64;
      x3 = x3 >> 1 ^ -(x3 & 1), C = C >> 1 ^ -(C & 1), x3 += h, C += v4, h = x3, v4 = C, u.push([x3 / e3, C / e3]);
    }
    return u;
  }
  function bvn(l3, r3) {
    return l3 = mvn(l3), Bi(jf(l3.features, function(e3) {
      return e3.geometry && e3.properties && e3.geometry.coordinates.length > 0;
    }), function(e3) {
      var u = e3.properties, h = e3.geometry, v4 = [];
      switch (h.type) {
        case "Polygon":
          var m3 = h.coordinates;
          v4.push(new Drt(m3[0], m3.slice(1)));
          break;
        case "MultiPolygon":
          mt(h.coordinates, function(C) {
            C[0] && v4.push(new Drt(C[0], C.slice(1)));
          });
          break;
        case "LineString":
          v4.push(new krt([h.coordinates]));
          break;
        case "MultiLineString":
          v4.push(new krt(h.coordinates));
      }
      var x3 = new Sht(u[r3 || "name"], v4, u.cp);
      return x3.properties = u, x3;
    });
  }
  var dJ = pc();
  function _vn(l3) {
    return l3.type === "category" ? wvn(l3) : Cvn(l3);
  }
  function xvn(l3, r3) {
    return l3.type === "category" ? Svn(l3, r3) : { ticks: Bi(l3.scale.getTicks(), function(e3) {
      return e3.value;
    }) };
  }
  function wvn(l3) {
    var r3 = l3.getLabelModel(), e3 = Mht(l3, r3);
    return !r3.get("show") || l3.scale.isBlank() ? { labels: [], labelCategoryInterval: e3.labelCategoryInterval } : e3;
  }
  function Mht(l3, r3) {
    var e3 = Tht(l3, "labels"), u = MOe(r3), h = Aht(e3, u);
    if (h)
      return h;
    var v4, m3;
    return Xo(u) ? v4 = Dht(l3, u) : (m3 = u === "auto" ? Mvn(l3) : u, v4 = Eht(l3, m3)), Iht(e3, u, { labels: v4, labelCategoryInterval: m3 });
  }
  function Svn(l3, r3) {
    var e3 = Tht(l3, "ticks"), u = MOe(r3), h = Aht(e3, u);
    if (h)
      return h;
    var v4, m3;
    if ((!r3.get("show") || l3.scale.isBlank()) && (v4 = []), Xo(u))
      v4 = Dht(l3, u, true);
    else if (u === "auto") {
      var x3 = Mht(l3, l3.getLabelModel());
      m3 = x3.labelCategoryInterval, v4 = Bi(x3.labels, function(C) {
        return C.tickValue;
      });
    } else
      m3 = u, v4 = Eht(l3, m3, true);
    return Iht(e3, u, { ticks: v4, tickCategoryInterval: m3 });
  }
  function Cvn(l3) {
    var r3 = l3.scale.getTicks(), e3 = jJ(l3);
    return { labels: Bi(r3, function(u, h) {
      return { level: u.level, formattedLabel: e3(u, h), rawLabel: l3.scale.getLabel(u), tickValue: u.value };
    }) };
  }
  function Tht(l3, r3) {
    return dJ(l3)[r3] || (dJ(l3)[r3] = []);
  }
  function Aht(l3, r3) {
    for (var e3 = 0; e3 < l3.length; e3++)
      if (l3[e3].key === r3)
        return l3[e3].value;
  }
  function Iht(l3, r3, e3) {
    return l3.push({ key: r3, value: e3 }), e3;
  }
  function Mvn(l3) {
    var r3 = dJ(l3).autoInterval;
    return r3 != null ? r3 : dJ(l3).autoInterval = l3.calculateCategoryInterval();
  }
  function Tvn(l3) {
    var r3 = Avn(l3), e3 = jJ(l3), u = (r3.axisRotate - r3.labelRotate) / 180 * Math.PI, h = l3.scale, v4 = h.getExtent(), m3 = h.count();
    if (v4[1] - v4[0] < 1)
      return 0;
    var x3 = 1;
    m3 > 40 && (x3 = Math.max(1, Math.floor(m3 / 40)));
    for (var C = v4[0], A2 = l3.dataToCoord(C + 1) - l3.dataToCoord(C), D = Math.abs(A2 * Math.cos(u)), P = Math.abs(A2 * Math.sin(u)), N = 0, j = 0; C <= v4[1]; C += x3) {
      var W = 0, K = 0, te = DJ(e3({ value: C }), r3.font, "center", "top");
      W = te.width * 1.3, K = te.height * 1.3, N = Math.max(N, W, 7), j = Math.max(j, K, 7);
    }
    var ne = N / D, ce = j / P;
    isNaN(ne) && (ne = 1 / 0), isNaN(ce) && (ce = 1 / 0);
    var me = Math.max(0, Math.floor(Math.min(ne, ce))), ve = dJ(l3.model), Be = l3.getExtent(), Oe = ve.lastAutoInterval, We = ve.lastTickCount;
    return Oe != null && We != null && Math.abs(Oe - me) <= 1 && Math.abs(We - m3) <= 1 && Oe > me && ve.axisExtent0 === Be[0] && ve.axisExtent1 === Be[1] ? me = Oe : (ve.lastTickCount = m3, ve.lastAutoInterval = me, ve.axisExtent0 = Be[0], ve.axisExtent1 = Be[1]), me;
  }
  function Avn(l3) {
    var r3 = l3.getLabelModel();
    return { axisRotate: l3.getRotate ? l3.getRotate() : l3.isHorizontal && !l3.isHorizontal() ? 90 : 0, labelRotate: r3.get("rotate") || 0, font: r3.getFont() };
  }
  function Eht(l3, r3, e3) {
    var u = jJ(l3), h = l3.scale, v4 = h.getExtent(), m3 = l3.getLabelModel(), x3 = [], C = Math.max((r3 || 0) + 1, 1), A2 = v4[0], D = h.count();
    A2 !== 0 && C > 1 && D / C > 2 && (A2 = Math.round(Math.ceil(A2 / C) * C));
    var P = xht(l3), N = m3.get("showMinLabel") || P, j = m3.get("showMaxLabel") || P;
    N && A2 !== v4[0] && K(v4[0]);
    for (var W = A2; W <= v4[1]; W += C)
      K(W);
    j && W - C !== v4[1] && K(v4[1]);
    function K(te) {
      var ne = { value: te };
      x3.push(e3 ? te : { formattedLabel: u(ne), rawLabel: h.getLabel(ne), tickValue: te });
    }
    return x3;
  }
  function Dht(l3, r3, e3) {
    var u = l3.scale, h = jJ(l3), v4 = [];
    return mt(u.getTicks(), function(m3) {
      var x3 = u.getLabel(m3), C = m3.value;
      r3(m3.value, x3) && v4.push(e3 ? C : { formattedLabel: h(m3), rawLabel: x3, tickValue: C });
    }), v4;
  }
  var Ort = [0, 1], Ivn = function() {
    function l3(r3, e3, u) {
      this.onBand = false, this.inverse = false, this.dim = r3, this.scale = e3, this._extent = u || [0, 0];
    }
    return l3.prototype.contain = function(r3) {
      var e3 = this._extent, u = Math.min(e3[0], e3[1]), h = Math.max(e3[0], e3[1]);
      return r3 >= u && r3 <= h;
    }, l3.prototype.containData = function(r3) {
      return this.scale.contain(r3);
    }, l3.prototype.getExtent = function() {
      return this._extent.slice();
    }, l3.prototype.getPixelPrecision = function(r3) {
      return hut(r3 || this.scale.getExtent(), this._extent);
    }, l3.prototype.setExtent = function(r3, e3) {
      var u = this._extent;
      u[0] = r3, u[1] = e3;
    }, l3.prototype.dataToCoord = function(r3, e3) {
      var u = this._extent, h = this.scale;
      return r3 = h.normalize(r3), this.onBand && h.type === "ordinal" && (u = u.slice(), Prt(u, h.count())), _f(r3, Ort, u, e3);
    }, l3.prototype.coordToData = function(r3, e3) {
      var u = this._extent, h = this.scale;
      this.onBand && h.type === "ordinal" && (u = u.slice(), Prt(u, h.count()));
      var v4 = _f(r3, u, Ort, e3);
      return this.scale.scale(v4);
    }, l3.prototype.pointToData = function(r3, e3) {
    }, l3.prototype.getTicksCoords = function(r3) {
      r3 = r3 || {};
      var e3 = r3.tickModel || this.getTickModel(), u = xvn(this, e3), h = u.ticks, v4 = Bi(h, function(x3) {
        return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(x3) : x3), tickValue: x3 };
      }, this), m3 = e3.get("alignWithLabel");
      return Evn(this, v4, m3, r3.clamp), v4;
    }, l3.prototype.getMinorTicksCoords = function() {
      if (this.scale.type === "ordinal")
        return [];
      var r3 = this.model.getModel("minorTick"), e3 = r3.get("splitNumber");
      e3 > 0 && e3 < 100 || (e3 = 5);
      var u = this.scale.getMinorTicks(e3), h = Bi(u, function(v4) {
        return Bi(v4, function(m3) {
          return { coord: this.dataToCoord(m3), tickValue: m3 };
        }, this);
      }, this);
      return h;
    }, l3.prototype.getViewLabels = function() {
      return _vn(this).labels;
    }, l3.prototype.getLabelModel = function() {
      return this.model.getModel("axisLabel");
    }, l3.prototype.getTickModel = function() {
      return this.model.getModel("axisTick");
    }, l3.prototype.getBandWidth = function() {
      var r3 = this._extent, e3 = this.scale.getExtent(), u = e3[1] - e3[0] + (this.onBand ? 1 : 0);
      u === 0 && (u = 1);
      var h = Math.abs(r3[1] - r3[0]);
      return Math.abs(h) / u;
    }, l3.prototype.calculateCategoryInterval = function() {
      return Tvn(this);
    }, l3;
  }();
  function Prt(l3, r3) {
    var e3 = l3[1] - l3[0], u = r3, h = e3 / u / 2;
    l3[0] += h, l3[1] -= h;
  }
  function Evn(l3, r3, e3, u) {
    var h = r3.length;
    if (!l3.onBand || e3 || !h)
      return;
    var v4 = l3.getExtent(), m3, x3;
    if (h === 1)
      r3[0].coord = v4[0], m3 = r3[1] = { coord: v4[0] };
    else {
      var C = r3[h - 1].tickValue - r3[0].tickValue, A2 = (r3[h - 1].coord - r3[0].coord) / C;
      mt(r3, function(j) {
        j.coord -= A2 / 2;
      });
      var D = l3.scale.getExtent();
      x3 = 1 + D[1] - r3[h - 1].tickValue, m3 = { coord: r3[h - 1].coord + A2 * x3 }, r3.push(m3);
    }
    var P = v4[0] > v4[1];
    N(r3[0].coord, v4[0]) && (u ? r3[0].coord = v4[0] : r3.shift()), u && N(v4[0], r3[0].coord) && r3.unshift({ coord: v4[0] }), N(v4[1], m3.coord) && (u ? m3.coord = v4[1] : r3.pop()), u && N(m3.coord, v4[1]) && r3.push({ coord: v4[1] });
    function N(j, W) {
      return j = jd(j), W = jd(W), P ? j > W : j < W;
    }
  }
  var bM = Ivn, aZ = Math.PI * 2, fN = XA.CMD, Dvn = ["top", "right", "bottom", "left"];
  function kvn(l3, r3, e3, u, h) {
    var v4 = e3.width, m3 = e3.height;
    switch (l3) {
      case "top":
        u.set(e3.x + v4 / 2, e3.y - r3), h.set(0, -1);
        break;
      case "bottom":
        u.set(e3.x + v4 / 2, e3.y + m3 + r3), h.set(0, 1);
        break;
      case "left":
        u.set(e3.x - r3, e3.y + m3 / 2), h.set(-1, 0);
        break;
      case "right":
        u.set(e3.x + v4 + r3, e3.y + m3 / 2), h.set(1, 0);
        break;
    }
  }
  function Ovn(l3, r3, e3, u, h, v4, m3, x3, C) {
    m3 -= l3, x3 -= r3;
    var A2 = Math.sqrt(m3 * m3 + x3 * x3);
    m3 /= A2, x3 /= A2;
    var D = m3 * e3 + l3, P = x3 * e3 + r3;
    if (Math.abs(u - h) % aZ < 1e-4)
      return C[0] = D, C[1] = P, A2 - e3;
    if (v4) {
      var N = u;
      u = jO(h), h = jO(N);
    } else
      u = jO(u), h = jO(h);
    u > h && (h += aZ);
    var j = Math.atan2(x3, m3);
    if (j < 0 && (j += aZ), j >= u && j <= h || j + aZ >= u && j + aZ <= h)
      return C[0] = D, C[1] = P, A2 - e3;
    var W = e3 * Math.cos(u) + l3, K = e3 * Math.sin(u) + r3, te = e3 * Math.cos(h) + l3, ne = e3 * Math.sin(h) + r3, ce = (W - m3) * (W - m3) + (K - x3) * (K - x3), me = (te - m3) * (te - m3) + (ne - x3) * (ne - x3);
    return ce < me ? (C[0] = W, C[1] = K, Math.sqrt(ce)) : (C[0] = te, C[1] = ne, Math.sqrt(me));
  }
  function uhe(l3, r3, e3, u, h, v4, m3, x3) {
    var C = h - l3, A2 = v4 - r3, D = e3 - l3, P = u - r3, N = Math.sqrt(D * D + P * P);
    D /= N, P /= N;
    var j = C * D + A2 * P, W = j / N;
    x3 && (W = Math.min(Math.max(W, 0), 1)), W *= N;
    var K = m3[0] = l3 + W * D, te = m3[1] = r3 + W * P;
    return Math.sqrt((K - h) * (K - h) + (te - v4) * (te - v4));
  }
  function kht(l3, r3, e3, u, h, v4, m3) {
    e3 < 0 && (l3 = l3 + e3, e3 = -e3), u < 0 && (r3 = r3 + u, u = -u);
    var x3 = l3 + e3, C = r3 + u, A2 = m3[0] = Math.min(Math.max(h, l3), x3), D = m3[1] = Math.min(Math.max(v4, r3), C);
    return Math.sqrt((A2 - h) * (A2 - h) + (D - v4) * (D - v4));
  }
  var fM = [];
  function Pvn(l3, r3, e3) {
    var u = kht(r3.x, r3.y, r3.width, r3.height, l3.x, l3.y, fM);
    return e3.set(fM[0], fM[1]), u;
  }
  function Lvn(l3, r3, e3) {
    for (var u = 0, h = 0, v4 = 0, m3 = 0, x3, C, A2 = 1 / 0, D = r3.data, P = l3.x, N = l3.y, j = 0; j < D.length; ) {
      var W = D[j++];
      j === 1 && (u = D[j], h = D[j + 1], v4 = u, m3 = h);
      var K = A2;
      switch (W) {
        case fN.M:
          v4 = D[j++], m3 = D[j++], u = v4, h = m3;
          break;
        case fN.L:
          K = uhe(u, h, D[j], D[j + 1], P, N, fM, true), u = D[j++], h = D[j++];
          break;
        case fN.C:
          K = $lt(u, h, D[j++], D[j++], D[j++], D[j++], D[j], D[j + 1], P, N, fM), u = D[j++], h = D[j++];
          break;
        case fN.Q:
          K = Ylt(u, h, D[j++], D[j++], D[j], D[j + 1], P, N, fM), u = D[j++], h = D[j++];
          break;
        case fN.A:
          var te = D[j++], ne = D[j++], ce = D[j++], me = D[j++], ve = D[j++], Be = D[j++];
          j += 1;
          var Oe = !!(1 - D[j++]);
          x3 = Math.cos(ve) * ce + te, C = Math.sin(ve) * me + ne, j <= 1 && (v4 = x3, m3 = C);
          var We = (P - te) * me / ce + te;
          K = Ovn(te, ne, me, ve, ve + Be, Oe, We, N, fM), u = Math.cos(ve + Be) * ce + te, h = Math.sin(ve + Be) * me + ne;
          break;
        case fN.R:
          v4 = u = D[j++], m3 = h = D[j++];
          var Ue = D[j++], qe = D[j++];
          K = kht(v4, m3, Ue, qe, P, N, fM);
          break;
        case fN.Z:
          K = uhe(u, h, v4, m3, P, N, fM, true), u = v4, h = m3;
          break;
      }
      K < A2 && (A2 = K, e3.set(fM[0], fM[1]));
    }
    return A2;
  }
  var pM = new nl(), Vh = new nl(), av = new nl(), BA = new nl(), RA = new nl();
  function Lrt(l3, r3) {
    if (!!l3) {
      var e3 = l3.getTextGuideLine(), u = l3.getTextContent();
      if (!!(u && e3)) {
        var h = l3.textGuideLineConfig || {}, v4 = [[0, 0], [0, 0], [0, 0]], m3 = h.candidates || Dvn, x3 = u.getBoundingRect().clone();
        x3.applyTransform(u.getComputedTransform());
        var C = 1 / 0, A2 = h.anchor, D = l3.getComputedTransform(), P = D && _j([], D), N = r3.get("length2") || 0;
        A2 && av.copy(A2);
        for (var j = 0; j < m3.length; j++) {
          var W = m3[j];
          kvn(W, 0, x3, pM, BA), nl.scaleAndAdd(Vh, pM, BA, N), Vh.transform(P);
          var K = l3.getBoundingRect(), te = A2 ? A2.distance(Vh) : l3 instanceof Nl ? Lvn(Vh, l3.path, av) : Pvn(Vh, K, av);
          te < C && (C = te, Vh.transform(D), av.transform(D), av.toArray(v4[0]), Vh.toArray(v4[1]), pM.toArray(v4[2]));
        }
        Oht(v4, r3.get("minTurnAngle")), e3.setShape({ points: v4 });
      }
    }
  }
  var che = [], gb = new nl();
  function Oht(l3, r3) {
    if (r3 <= 180 && r3 > 0) {
      r3 = r3 / 180 * Math.PI, pM.fromArray(l3[0]), Vh.fromArray(l3[1]), av.fromArray(l3[2]), nl.sub(BA, pM, Vh), nl.sub(RA, av, Vh);
      var e3 = BA.len(), u = RA.len();
      if (!(e3 < 1e-3 || u < 1e-3)) {
        BA.scale(1 / e3), RA.scale(1 / u);
        var h = BA.dot(RA), v4 = Math.cos(r3);
        if (v4 < h) {
          var m3 = uhe(Vh.x, Vh.y, av.x, av.y, pM.x, pM.y, che, false);
          gb.fromArray(che), gb.scaleAndAdd(RA, m3 / Math.tan(Math.PI - r3));
          var x3 = av.x !== Vh.x ? (gb.x - Vh.x) / (av.x - Vh.x) : (gb.y - Vh.y) / (av.y - Vh.y);
          if (isNaN(x3))
            return;
          x3 < 0 ? nl.copy(gb, Vh) : x3 > 1 && nl.copy(gb, av), gb.toArray(l3[1]);
        }
      }
    }
  }
  function Rvn(l3, r3, e3) {
    if (e3 <= 180 && e3 > 0) {
      e3 = e3 / 180 * Math.PI, pM.fromArray(l3[0]), Vh.fromArray(l3[1]), av.fromArray(l3[2]), nl.sub(BA, Vh, pM), nl.sub(RA, av, Vh);
      var u = BA.len(), h = RA.len();
      if (!(u < 1e-3 || h < 1e-3)) {
        BA.scale(1 / u), RA.scale(1 / h);
        var v4 = BA.dot(r3), m3 = Math.cos(e3);
        if (v4 < m3) {
          var x3 = uhe(Vh.x, Vh.y, av.x, av.y, pM.x, pM.y, che, false);
          gb.fromArray(che);
          var C = Math.PI / 2, A2 = Math.acos(RA.dot(r3)), D = C + A2 - e3;
          if (D >= C)
            nl.copy(gb, av);
          else {
            gb.scaleAndAdd(RA, x3 / Math.tan(Math.PI / 2 - D));
            var P = av.x !== Vh.x ? (gb.x - Vh.x) / (av.x - Vh.x) : (gb.y - Vh.y) / (av.y - Vh.y);
            if (isNaN(P))
              return;
            P < 0 ? nl.copy(gb, Vh) : P > 1 && nl.copy(gb, av);
          }
          gb.toArray(l3[1]);
        }
      }
    }
  }
  function Rrt(l3, r3, e3, u) {
    var h = e3 === "normal", v4 = h ? l3 : l3.ensureState(e3);
    v4.ignore = r3;
    var m3 = u.get("smooth");
    m3 && m3 === true && (m3 = 0.3), v4.shape = v4.shape || {}, m3 > 0 && (v4.shape.smooth = m3);
    var x3 = u.getModel("lineStyle").getLineStyle();
    h ? l3.useStyle(x3) : v4.style = x3;
  }
  function Nvn(l3, r3) {
    var e3 = r3.smooth, u = r3.points;
    if (!!u)
      if (l3.moveTo(u[0][0], u[0][1]), e3 > 0 && u.length >= 3) {
        var h = RO(u[0], u[1]), v4 = RO(u[1], u[2]);
        if (!h || !v4) {
          l3.lineTo(u[1][0], u[1][1]), l3.lineTo(u[2][0], u[2][1]);
          return;
        }
        var m3 = Math.min(h, v4) * e3, x3 = gfe([], u[1], u[0], m3 / h), C = gfe([], u[1], u[2], m3 / v4), A2 = gfe([], x3, C, 0.5);
        l3.bezierCurveTo(x3[0], x3[1], x3[0], x3[1], A2[0], A2[1]), l3.bezierCurveTo(C[0], C[1], C[0], C[1], u[2][0], u[2][1]);
      } else
        for (var D = 1; D < u.length; D++)
          l3.lineTo(u[D][0], u[D][1]);
  }
  function TOe(l3, r3, e3) {
    var u = l3.getTextGuideLine(), h = l3.getTextContent();
    if (!h) {
      u && l3.removeTextGuideLine();
      return;
    }
    for (var v4 = r3.normal, m3 = v4.get("show"), x3 = h.ignore, C = 0; C < rJ.length; C++) {
      var A2 = rJ[C], D = r3[A2], P = A2 === "normal";
      if (D) {
        var N = D.get("show"), j = P ? x3 : dl(h.states[A2] && h.states[A2].ignore, x3);
        if (j || !dl(N, m3)) {
          var W = P ? u : u && u.states.normal;
          W && (W.ignore = true);
          continue;
        }
        u || (u = new M_(), l3.setTextGuideLine(u), !P && (x3 || !m3) && Rrt(u, true, "normal", r3.normal), l3.stateProxy && (u.stateProxy = l3.stateProxy)), Rrt(u, false, A2, D);
      }
    }
    if (u) {
      ns(u.style, e3), u.style.fill = null;
      var K = v4.get("showAbove"), te = l3.textGuideLineConfig = l3.textGuideLineConfig || {};
      te.showAbove = K || false, u.buildPath = Nvn;
    }
  }
  function AOe(l3, r3) {
    r3 = r3 || "labelLine";
    for (var e3 = { normal: l3.getModel(r3) }, u = 0; u < bb.length; u++) {
      var h = bb[u];
      e3[h] = l3.getModel([h, r3]);
    }
    return e3;
  }
  function Pht(l3) {
    for (var r3 = [], e3 = 0; e3 < l3.length; e3++) {
      var u = l3[e3];
      if (!u.defaultAttr.ignore) {
        var h = u.label, v4 = h.getComputedTransform(), m3 = h.getBoundingRect(), x3 = !v4 || v4[1] < 1e-5 && v4[2] < 1e-5, C = h.style.margin || 0, A2 = m3.clone();
        A2.applyTransform(v4), A2.x -= C / 2, A2.y -= C / 2, A2.width += C, A2.height += C;
        var D = x3 ? new Xfe(m3, v4) : null;
        r3.push({ label: h, labelLine: u.labelLine, rect: A2, localRect: m3, obb: D, priority: u.priority, defaultAttr: u.defaultAttr, layoutOption: u.computedLayoutOption, axisAligned: x3, transform: v4 });
      }
    }
    return r3;
  }
  function Lht(l3, r3, e3, u, h, v4) {
    var m3 = l3.length;
    if (m3 < 2)
      return;
    l3.sort(function(Ue, qe) {
      return Ue.rect[r3] - qe.rect[r3];
    });
    for (var x3 = 0, C, A2 = false, D = 0, P = 0; P < m3; P++) {
      var N = l3[P], j = N.rect;
      C = j[r3] - x3, C < 0 && (j[r3] -= C, N.label[r3] -= C, A2 = true);
      var W = Math.max(-C, 0);
      D += W, x3 = j[r3] + j[e3];
    }
    D > 0 && v4 && Be(-D / m3, 0, m3);
    var K = l3[0], te = l3[m3 - 1], ne, ce;
    me(), ne < 0 && Oe(-ne, 0.8), ce < 0 && Oe(ce, 0.8), me(), ve(ne, ce, 1), ve(ce, ne, -1), me(), ne < 0 && We(-ne), ce < 0 && We(ce);
    function me() {
      ne = K.rect[r3] - u, ce = h - te.rect[r3] - te.rect[e3];
    }
    function ve(Ue, qe, Ze) {
      if (Ue < 0) {
        var ct = Math.min(qe, -Ue);
        if (ct > 0) {
          Be(ct * Ze, 0, m3);
          var _t = ct + Ue;
          _t < 0 && Oe(-_t * Ze, 1);
        } else
          Oe(-Ue * Ze, 1);
      }
    }
    function Be(Ue, qe, Ze) {
      Ue !== 0 && (A2 = true);
      for (var ct = qe; ct < Ze; ct++) {
        var _t = l3[ct], pt = _t.rect;
        pt[r3] += Ue, _t.label[r3] += Ue;
      }
    }
    function Oe(Ue, qe) {
      for (var Ze = [], ct = 0, _t = 1; _t < m3; _t++) {
        var pt = l3[_t - 1].rect, zt = Math.max(l3[_t].rect[r3] - pt[r3] - pt[e3], 0);
        Ze.push(zt), ct += zt;
      }
      if (!!ct) {
        var Zt = Math.min(Math.abs(Ue) / ct, qe);
        if (Ue > 0)
          for (var _t = 0; _t < m3 - 1; _t++) {
            var Ft = Ze[_t] * Zt;
            Be(Ft, 0, _t + 1);
          }
        else
          for (var _t = m3 - 1; _t > 0; _t--) {
            var Ft = Ze[_t - 1] * Zt;
            Be(-Ft, _t, m3);
          }
      }
    }
    function We(Ue) {
      var qe = Ue < 0 ? -1 : 1;
      Ue = Math.abs(Ue);
      for (var Ze = Math.ceil(Ue / (m3 - 1)), ct = 0; ct < m3 - 1; ct++)
        if (qe > 0 ? Be(Ze, 0, ct + 1) : Be(-Ze, m3 - ct - 1, m3), Ue -= Ze, Ue <= 0)
          return;
    }
    return A2;
  }
  function Fvn(l3, r3, e3, u) {
    return Lht(l3, "x", "width", r3, e3, u);
  }
  function Rht(l3, r3, e3, u) {
    return Lht(l3, "y", "height", r3, e3, u);
  }
  function Nht(l3) {
    var r3 = [];
    l3.sort(function(K, te) {
      return te.priority - K.priority;
    });
    var e3 = new Ml(0, 0, 0, 0);
    function u(K) {
      if (!K.ignore) {
        var te = K.ensureState("emphasis");
        te.ignore == null && (te.ignore = false);
      }
      K.ignore = true;
    }
    for (var h = 0; h < l3.length; h++) {
      var v4 = l3[h], m3 = v4.axisAligned, x3 = v4.localRect, C = v4.transform, A2 = v4.label, D = v4.labelLine;
      e3.copy(v4.rect), e3.width -= 0.1, e3.height -= 0.1, e3.x += 0.05, e3.y += 0.05;
      for (var P = v4.obb, N = false, j = 0; j < r3.length; j++) {
        var W = r3[j];
        if (!!e3.intersect(W.rect)) {
          if (m3 && W.axisAligned) {
            N = true;
            break;
          }
          if (W.obb || (W.obb = new Xfe(W.localRect, W.transform)), P || (P = new Xfe(x3, C)), P.intersect(W.obb)) {
            N = true;
            break;
          }
        }
      }
      N ? (u(A2), D && u(D)) : (A2.attr("ignore", v4.defaultAttr.ignore), D && D.attr("ignore", v4.defaultAttr.labelGuideIgnore), r3.push(v4));
    }
  }
  function Vvn(l3) {
    if (l3) {
      for (var r3 = [], e3 = 0; e3 < l3.length; e3++)
        r3.push(l3[e3].slice());
      return r3;
    }
  }
  function Bvn(l3, r3) {
    var e3 = l3.label, u = r3 && r3.getTextGuideLine();
    return { dataIndex: l3.dataIndex, dataType: l3.dataType, seriesIndex: l3.seriesModel.seriesIndex, text: l3.label.style.text, rect: l3.hostRect, labelRect: l3.rect, align: e3.style.align, verticalAlign: e3.style.verticalAlign, labelLinePoints: Vvn(u && u.shape.points) };
  }
  var Nrt = ["align", "verticalAlign", "width", "height", "fontSize"], Wx = new QD(), qEe = pc(), zvn = pc();
  function Bce(l3, r3, e3) {
    for (var u = 0; u < e3.length; u++) {
      var h = e3[u];
      r3[h] != null && (l3[h] = r3[h]);
    }
  }
  var zce = ["x", "y", "rotation"], jvn = function() {
    function l3() {
      this._labelList = [], this._chartViewList = [];
    }
    return l3.prototype.clearLabels = function() {
      this._labelList = [], this._chartViewList = [];
    }, l3.prototype._addLabel = function(r3, e3, u, h, v4) {
      var m3 = h.style, x3 = h.__hostTarget, C = x3.textConfig || {}, A2 = h.getComputedTransform(), D = h.getBoundingRect().plain();
      Ml.applyTransform(D, D, A2), A2 ? Wx.setLocalTransform(A2) : (Wx.x = Wx.y = Wx.rotation = Wx.originX = Wx.originY = 0, Wx.scaleX = Wx.scaleY = 1);
      var P = h.__hostTarget, N;
      if (P) {
        N = P.getBoundingRect().plain();
        var j = P.getComputedTransform();
        Ml.applyTransform(N, N, j);
      }
      var W = N && P.getTextGuideLine();
      this._labelList.push({ label: h, labelLine: W, seriesModel: u, dataIndex: r3, dataType: e3, layoutOption: v4, computedLayoutOption: null, rect: D, hostRect: N, priority: N ? N.width * N.height : 0, defaultAttr: { ignore: h.ignore, labelGuideIgnore: W && W.ignore, x: Wx.x, y: Wx.y, scaleX: Wx.scaleX, scaleY: Wx.scaleY, rotation: Wx.rotation, style: { x: m3.x, y: m3.y, align: m3.align, verticalAlign: m3.verticalAlign, width: m3.width, height: m3.height, fontSize: m3.fontSize }, cursor: h.cursor, attachedPos: C.position, attachedRot: C.rotation } });
    }, l3.prototype.addLabelsOfSeries = function(r3) {
      var e3 = this;
      this._chartViewList.push(r3);
      var u = r3.__model, h = u.get("labelLayout");
      !(Xo(h) || yu(h).length) || r3.group.traverse(function(v4) {
        if (v4.ignore)
          return true;
        var m3 = v4.getTextContent(), x3 = Ps(v4);
        m3 && !m3.disableLabelLayout && e3._addLabel(x3.dataIndex, x3.dataType, u, m3, h);
      });
    }, l3.prototype.updateLayoutConfig = function(r3) {
      var e3 = r3.getWidth(), u = r3.getHeight();
      function h(me, ve) {
        return function() {
          Lrt(me, ve);
        };
      }
      for (var v4 = 0; v4 < this._labelList.length; v4++) {
        var m3 = this._labelList[v4], x3 = m3.label, C = x3.__hostTarget, A2 = m3.defaultAttr, D = void 0;
        Xo(m3.layoutOption) ? D = m3.layoutOption(Bvn(m3, C)) : D = m3.layoutOption, D = D || {}, m3.computedLayoutOption = D;
        var P = Math.PI / 180;
        C && C.setTextConfig({ local: false, position: D.x != null || D.y != null ? null : A2.attachedPos, rotation: D.rotate != null ? D.rotate * P : A2.attachedRot, offset: [D.dx || 0, D.dy || 0] });
        var N = false;
        if (D.x != null ? (x3.x = za(D.x, e3), x3.setStyle("x", 0), N = true) : (x3.x = A2.x, x3.setStyle("x", A2.style.x)), D.y != null ? (x3.y = za(D.y, u), x3.setStyle("y", 0), N = true) : (x3.y = A2.y, x3.setStyle("y", A2.style.y)), D.labelLinePoints) {
          var j = C.getTextGuideLine();
          j && (j.setShape({ points: D.labelLinePoints }), N = false);
        }
        var W = qEe(x3);
        W.needsUpdateLabelLine = N, x3.rotation = D.rotate != null ? D.rotate * P : A2.rotation, x3.scaleX = A2.scaleX, x3.scaleY = A2.scaleY;
        for (var K = 0; K < Nrt.length; K++) {
          var te = Nrt[K];
          x3.setStyle(te, D[te] != null ? D[te] : A2.style[te]);
        }
        if (D.draggable) {
          if (x3.draggable = true, x3.cursor = "move", C) {
            var ne = m3.seriesModel;
            if (m3.dataIndex != null) {
              var ce = m3.seriesModel.getData(m3.dataType);
              ne = ce.getItemModel(m3.dataIndex);
            }
            x3.on("drag", h(C, ne.getModel("labelLine")));
          }
        } else
          x3.off("drag"), x3.cursor = A2.cursor;
      }
    }, l3.prototype.layout = function(r3) {
      var e3 = r3.getWidth(), u = r3.getHeight(), h = Pht(this._labelList), v4 = jf(h, function(C) {
        return C.layoutOption.moveOverlap === "shiftX";
      }), m3 = jf(h, function(C) {
        return C.layoutOption.moveOverlap === "shiftY";
      });
      Fvn(v4, 0, e3), Rht(m3, 0, u);
      var x3 = jf(h, function(C) {
        return C.layoutOption.hideOverlap;
      });
      Nht(x3);
    }, l3.prototype.processLabelsOverall = function() {
      var r3 = this;
      mt(this._chartViewList, function(e3) {
        var u = e3.__model, h = e3.ignoreLabelLineUpdate, v4 = u.isAnimationEnabled();
        e3.group.traverse(function(m3) {
          if (m3.ignore && !m3.forceLabelAnimation)
            return true;
          var x3 = !h, C = m3.getTextContent();
          !x3 && C && (x3 = qEe(C).needsUpdateLabelLine), x3 && r3._updateLabelLine(m3, u), v4 && r3._animateLabels(m3, u);
        });
      });
    }, l3.prototype._updateLabelLine = function(r3, e3) {
      var u = r3.getTextContent(), h = Ps(r3), v4 = h.dataIndex;
      if (u && v4 != null) {
        var m3 = e3.getData(h.dataType), x3 = m3.getItemModel(v4), C = {}, A2 = m3.getItemVisual(v4, "style"), D = m3.getVisual("drawType");
        C.stroke = A2[D];
        var P = x3.getModel("labelLine");
        TOe(r3, AOe(x3), C), Lrt(r3, P);
      }
    }, l3.prototype._animateLabels = function(r3, e3) {
      var u = r3.getTextContent(), h = r3.getTextGuideLine();
      if (u && (r3.forceLabelAnimation || !u.ignore && !u.invisible && !r3.disableLabelAnimation && !ij(r3))) {
        var v4 = qEe(u), m3 = v4.oldLayout, x3 = Ps(r3), C = x3.dataIndex, A2 = { x: u.x, y: u.y, rotation: u.rotation }, D = e3.getData(x3.dataType);
        if (m3) {
          u.attr(m3);
          var N = r3.prevStates;
          N && (Cl(N, "select") >= 0 && u.attr(v4.oldLayoutSelect), Cl(N, "emphasis") >= 0 && u.attr(v4.oldLayoutEmphasis)), hc(u, A2, e3, C);
        } else if (u.attr(A2), !Mj(u).valueAnimation) {
          var P = dl(u.style.opacity, 1);
          u.style.opacity = 0, Np(u, { style: { opacity: P } }, e3, C);
        }
        if (v4.oldLayout = A2, u.states.select) {
          var j = v4.oldLayoutSelect = {};
          Bce(j, A2, zce), Bce(j, u.states.select, zce);
        }
        if (u.states.emphasis) {
          var W = v4.oldLayoutEmphasis = {};
          Bce(W, A2, zce), Bce(W, u.states.emphasis, zce);
        }
        wct(u, C, D, e3, e3);
      }
      if (h && !h.ignore && !h.invisible) {
        var v4 = zvn(h), m3 = v4.oldLayout, K = { points: h.shape.points };
        m3 ? (h.attr({ shape: m3 }), hc(h, { shape: K }, e3)) : (h.setShape(K), h.style.strokePercent = 0, Np(h, { style: { strokePercent: 1 } }, e3)), v4.oldLayout = K;
      }
    }, l3;
  }(), Gvn = jvn, $Ee = pc();
  function Hvn(l3) {
    l3.registerUpdateLifecycle("series:beforeupdate", function(r3, e3, u) {
      var h = $Ee(e3).labelManager;
      h || (h = $Ee(e3).labelManager = new Gvn()), h.clearLabels();
    }), l3.registerUpdateLifecycle("series:layoutlabels", function(r3, e3, u) {
      var h = $Ee(e3).labelManager;
      u.updatedSeries.forEach(function(v4) {
        h.addLabelsOfSeries(e3.getViewOfSeriesModel(v4));
      }), h.updateLayoutConfig(e3), h.layout(e3), h.processLabelsOverall();
    });
  }
  var XEe = Math.sin, YEe = Math.cos, Fht = Math.PI, hN = Math.PI * 2, Wvn = 180 / Fht, Uvn = function() {
    function l3() {
    }
    return l3.prototype.reset = function(r3) {
      this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, r3 || 4);
    }, l3.prototype.moveTo = function(r3, e3) {
      this._add("M", r3, e3);
    }, l3.prototype.lineTo = function(r3, e3) {
      this._add("L", r3, e3);
    }, l3.prototype.bezierCurveTo = function(r3, e3, u, h, v4, m3) {
      this._add("C", r3, e3, u, h, v4, m3);
    }, l3.prototype.quadraticCurveTo = function(r3, e3, u, h) {
      this._add("Q", r3, e3, u, h);
    }, l3.prototype.arc = function(r3, e3, u, h, v4, m3) {
      this.ellipse(r3, e3, u, u, 0, h, v4, m3);
    }, l3.prototype.ellipse = function(r3, e3, u, h, v4, m3, x3, C) {
      var A2 = x3 - m3, D = !C, P = Math.abs(A2), N = zO(P - hN) || (D ? A2 >= hN : -A2 >= hN), j = A2 > 0 ? A2 % hN : A2 % hN + hN, W = false;
      N ? W = true : zO(P) ? W = false : W = j >= Fht == !!D;
      var K = r3 + u * YEe(m3), te = e3 + h * XEe(m3);
      this._start && this._add("M", K, te);
      var ne = Math.round(v4 * Wvn);
      if (N) {
        var ce = 1 / this._p, me = (D ? 1 : -1) * (hN - ce);
        this._add("A", u, h, ne, 1, +D, r3 + u * YEe(m3 + me), e3 + h * XEe(m3 + me)), ce > 0.01 && this._add("A", u, h, ne, 0, +D, K, te);
      } else {
        var ve = r3 + u * YEe(x3), Be = e3 + h * XEe(x3);
        this._add("A", u, h, ne, +W, +D, ve, Be);
      }
    }, l3.prototype.rect = function(r3, e3, u, h) {
      this._add("M", r3, e3), this._add("l", u, 0), this._add("l", 0, h), this._add("l", -u, 0), this._add("Z");
    }, l3.prototype.closePath = function() {
      this._d.length > 0 && this._add("Z");
    }, l3.prototype._add = function(r3, e3, u, h, v4, m3, x3, C, A2) {
      for (var D = [], P = this._p, N = 1; N < arguments.length; N++) {
        var j = arguments[N];
        if (isNaN(j)) {
          this._invalid = true;
          return;
        }
        D.push(Math.round(j * P) / P);
      }
      this._d.push(r3 + D.join(" ")), this._start = r3 === "Z";
    }, l3.prototype.generateStr = function() {
      this._str = this._invalid ? "" : this._d.join(""), this._d = [];
    }, l3.prototype.getStr = function() {
      return this._str;
    }, l3;
  }(), Vht = Uvn, UZ = "none", qvn = Math.round;
  function $vn(l3) {
    var r3 = l3.fill;
    return r3 != null && r3 !== UZ;
  }
  function Xvn(l3) {
    var r3 = l3.stroke;
    return r3 != null && r3 !== UZ;
  }
  var yke = ["lineCap", "miterLimit", "lineJoin"], Yvn = Bi(yke, function(l3) {
    return "stroke-" + l3.toLowerCase();
  });
  function Kvn(l3, r3, e3, u) {
    var h = r3.opacity == null ? 1 : r3.opacity;
    if (e3 instanceof lm) {
      l3("opacity", h);
      return;
    }
    if ($vn(r3)) {
      var v4 = fj(r3.fill);
      l3("fill", v4.color);
      var m3 = r3.fillOpacity != null ? r3.fillOpacity * v4.opacity * h : v4.opacity * h;
      (u || m3 < 1) && l3("fill-opacity", m3);
    } else
      l3("fill", UZ);
    if (Xvn(r3)) {
      var x3 = fj(r3.stroke);
      l3("stroke", x3.color);
      var C = r3.strokeNoScale ? e3.getLineScale() : 1, A2 = C ? (r3.lineWidth || 0) / C : 0, D = r3.strokeOpacity != null ? r3.strokeOpacity * x3.opacity * h : x3.opacity * h, P = r3.strokeFirst;
      if ((u || A2 !== 1) && l3("stroke-width", A2), (u || P) && l3("paint-order", P ? "stroke" : "fill"), (u || D < 1) && l3("stroke-opacity", D), r3.lineDash) {
        var N = dOe(e3), j = N[0], W = N[1];
        j && (W = qvn(W || 0), l3("stroke-dasharray", j.join(",")), (W || u) && l3("stroke-dashoffset", W));
      } else
        u && l3("stroke-dasharray", UZ);
      for (var K = 0; K < yke.length; K++) {
        var te = yke[K];
        if (u || r3[te] !== qfe[te]) {
          var ne = r3[te] || qfe[te];
          ne && l3(Yvn[K], ne);
        }
      }
    } else
      u && l3("stroke", UZ);
  }
  var Bht = "http://www.w3.org/2000/svg", zht = "http://www.w3.org/1999/xlink", Zvn = "http://www.w3.org/2000/xmlns/", Jvn = "http://www.w3.org/XML/1998/namespace";
  function jht(l3) {
    return document.createElementNS(Bht, l3);
  }
  function a0(l3, r3, e3, u, h) {
    return { tag: l3, attrs: e3 || {}, children: u, text: h, key: r3 };
  }
  function Qvn(l3, r3) {
    var e3 = [];
    if (r3)
      for (var u in r3) {
        var h = r3[u], v4 = u;
        h !== false && (h !== true && h != null && (v4 += '="' + h + '"'), e3.push(v4));
      }
    return "<" + l3 + " " + e3.join(" ") + ">";
  }
  function egn(l3) {
    return "</" + l3 + ">";
  }
  function IOe(l3, r3) {
    r3 = r3 || {};
    var e3 = r3.newline ? `
` : "";
    function u(h) {
      var v4 = h.children, m3 = h.tag, x3 = h.attrs;
      return Qvn(m3, x3) + (h.text || "") + (v4 ? "" + e3 + Bi(v4, function(C) {
        return u(C);
      }).join(e3) + e3 : "") + egn(m3);
    }
    return u(l3);
  }
  function tgn(l3, r3, e3) {
    e3 = e3 || {};
    var u = e3.newline ? `
` : "", h = " {" + u, v4 = u + "}", m3 = Bi(yu(l3), function(C) {
      return C + h + Bi(yu(l3[C]), function(A2) {
        return A2 + ":" + l3[C][A2] + ";";
      }).join(u) + v4;
    }).join(u), x3 = Bi(yu(r3), function(C) {
      return "@keyframes " + C + h + Bi(yu(r3[C]), function(A2) {
        return A2 + h + Bi(yu(r3[C][A2]), function(D) {
          var P = r3[C][A2][D];
          return D === "d" && (P = 'path("' + P + '")'), D + ":" + P + ";";
        }).join(u) + v4;
      }).join(u) + v4;
    }).join(u);
    return !m3 && !x3 ? "" : ["<![CDATA[", m3, x3, "]]>"].join(u);
  }
  function mke(l3) {
    return { zrId: l3, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
  }
  function Frt(l3, r3, e3, u) {
    return a0("svg", "root", { width: l3, height: r3, xmlns: Bht, "xmlns:xlink": zht, version: "1.1", baseProfile: "full", viewBox: u ? "0 0 " + l3 + " " + r3 : false }, e3);
  }
  var Vrt = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, yN = "transform-origin";
  function ngn(l3, r3, e3) {
    var u = fi({}, l3.shape);
    fi(u, r3), l3.buildPath(e3, u);
    var h = new Vht();
    return h.reset(tut(l3)), e3.rebuildPath(h, 1), h.generateStr(), h.getStr();
  }
  function rgn(l3, r3) {
    var e3 = r3.originX, u = r3.originY;
    (e3 || u) && (l3[yN] = e3 + "px " + u + "px");
  }
  var ign = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
  function Ght(l3, r3) {
    var e3 = r3.zrId + "-ani-" + r3.cssAnimIdx++;
    return r3.cssAnims[e3] = l3, e3;
  }
  function agn(l3, r3, e3) {
    var u = l3.shape.paths, h = {}, v4, m3;
    if (mt(u, function(C) {
      var A2 = mke(e3.zrId);
      A2.animation = true, dpe(C, {}, A2, true);
      var D = A2.cssAnims, P = A2.cssNodes, N = yu(D), j = N.length;
      if (!!j) {
        m3 = N[j - 1];
        var W = D[m3];
        for (var K in W) {
          var te = W[K];
          h[K] = h[K] || { d: "" }, h[K].d += te.d || "";
        }
        for (var ne in P) {
          var ce = P[ne].animation;
          ce.indexOf(m3) >= 0 && (v4 = ce);
        }
      }
    }), !!v4) {
      r3.d = false;
      var x3 = Ght(h, e3);
      return v4.replace(m3, x3);
    }
  }
  function Brt(l3) {
    return qa(l3) ? Vrt[l3] ? "cubic-bezier(" + Vrt[l3] + ")" : D3e(l3) ? l3 : "" : "";
  }
  function dpe(l3, r3, e3, u) {
    var h = l3.animators, v4 = h.length, m3 = [];
    if (l3 instanceof $3e) {
      var x3 = agn(l3, r3, e3);
      if (x3)
        m3.push(x3);
      else if (!v4)
        return;
    } else if (!v4)
      return;
    for (var C = {}, A2 = 0; A2 < v4; A2++) {
      var D = h[A2], P = [D.getMaxTime() / 1e3 + "s"], N = Brt(D.getClip().easing), j = D.getDelay();
      N ? P.push(N) : P.push("linear"), j && P.push(j / 1e3 + "s"), D.getLoop() && P.push("infinite");
      var W = P.join(" ");
      C[W] = C[W] || [W, []], C[W][1].push(D);
    }
    function K(ce) {
      var me = ce[1], ve = me.length, Be = {}, Oe = {}, We = {}, Ue = "animation-timing-function";
      function qe(Pa, fo, Co) {
        for (var $a = Pa.getTracks(), Yo = Pa.getMaxTime(), Qu = 0; Qu < $a.length; Qu++) {
          var ds = $a[Qu];
          if (ds.needsAnimate()) {
            var Lu = ds.keyframes, dc = ds.propName;
            if (Co && (dc = Co(dc)), dc)
              for (var Kc = 0; Kc < Lu.length; Kc++) {
                var sv = Lu[Kc], Hf = Math.round(sv.time / Yo * 100) + "%", vg = Brt(sv.easing), Ef = sv.rawValue;
                (qa(Ef) || Vc(Ef)) && (fo[Hf] = fo[Hf] || {}, fo[Hf][dc] = sv.rawValue, vg && (fo[Hf][Ue] = vg));
              }
          }
        }
      }
      for (var Ze = 0; Ze < ve; Ze++) {
        var ct = me[Ze], _t = ct.targetName;
        _t ? _t === "shape" && qe(ct, Oe) : !u && qe(ct, Be);
      }
      for (var pt in Be) {
        var zt = {};
        out2(zt, l3), fi(zt, Be[pt]);
        var Zt = nut(zt), Ft = Be[pt][Ue];
        We[pt] = Zt ? { transform: Zt } : {}, rgn(We[pt], zt), Ft && (We[pt][Ue] = Ft);
      }
      var Kn, hn = true;
      for (var pt in Oe) {
        We[pt] = We[pt] || {};
        var xn = !Kn, Ft = Oe[pt][Ue];
        xn && (Kn = new XA());
        var zn = Kn.len();
        Kn.reset(), We[pt].d = ngn(l3, Oe[pt], Kn);
        var or = Kn.len();
        if (!xn && zn !== or) {
          hn = false;
          break;
        }
        Ft && (We[pt][Ue] = Ft);
      }
      if (!hn)
        for (var pt in We)
          delete We[pt].d;
      if (!u)
        for (var Ze = 0; Ze < ve; Ze++) {
          var ct = me[Ze], _t = ct.targetName;
          _t === "style" && qe(ct, We, function($a) {
            return ign[$a];
          });
        }
      for (var vr = yu(We), la = true, Ba, Ze = 1; Ze < vr.length; Ze++) {
        var Lo = vr[Ze - 1], Ao = vr[Ze];
        if (We[Lo][yN] !== We[Ao][yN]) {
          la = false;
          break;
        }
        Ba = We[Lo][yN];
      }
      if (la && Ba) {
        for (var pt in We)
          We[pt][yN] && delete We[pt][yN];
        r3[yN] = Ba;
      }
      if (jf(vr, function(Pa) {
        return yu(We[Pa]).length > 0;
      }).length) {
        var oo = Ght(We, e3);
        return oo + " " + ce[0] + " both";
      }
    }
    for (var te in C) {
      var x3 = K(C[te]);
      x3 && m3.push(x3);
    }
    if (m3.length) {
      var ne = e3.zrId + "-cls-" + e3.cssClassIdx++;
      e3.cssNodes["." + ne] = { animation: m3.join(",") }, r3.class = ne;
    }
  }
  var vJ = Math.round;
  function Hht(l3) {
    return l3 && qa(l3.src);
  }
  function Wht(l3) {
    return l3 && Xo(l3.toDataURL);
  }
  function EOe(l3, r3, e3, u) {
    Kvn(function(h, v4) {
      var m3 = h === "fill" || h === "stroke";
      m3 && Qsn(v4) ? pgn(r3, l3, h, u) : m3 && Jsn(v4) ? dgn(e3, l3, h, u) : l3[h] = v4;
    }, r3, e3, false), hgn(e3, l3, u);
  }
  function zrt(l3) {
    return zO(l3[0] - 1) && zO(l3[1]) && zO(l3[2]) && zO(l3[3] - 1);
  }
  function ogn(l3) {
    return zO(l3[4]) && zO(l3[5]);
  }
  function DOe(l3, r3, e3) {
    if (r3 && !(ogn(r3) && zrt(r3))) {
      var u = e3 ? 10 : 1e4;
      l3.transform = zrt(r3) ? "translate(" + vJ(r3[4] * u) / u + " " + vJ(r3[5] * u) / u + ")" : qsn(r3);
    }
  }
  function jrt(l3, r3, e3) {
    for (var u = l3.points, h = [], v4 = 0; v4 < u.length; v4++)
      h.push(vJ(u[v4][0] * e3) / e3), h.push(vJ(u[v4][1] * e3) / e3);
    r3.points = h.join(" ");
  }
  function Grt(l3) {
    return !l3.smooth;
  }
  function sgn(l3) {
    var r3 = Bi(l3, function(e3) {
      return typeof e3 == "string" ? [e3, e3] : e3;
    });
    return function(e3, u, h) {
      for (var v4 = 0; v4 < r3.length; v4++) {
        var m3 = r3[v4], x3 = e3[m3[0]];
        x3 != null && (u[m3[1]] = vJ(x3 * h) / h);
      }
    };
  }
  var lgn = { circle: [sgn(["cx", "cy", "r"])], polyline: [jrt, Grt], polygon: [jrt, Grt] };
  function ugn(l3) {
    for (var r3 = l3.animators, e3 = 0; e3 < r3.length; e3++)
      if (r3[e3].targetName === "shape")
        return true;
    return false;
  }
  function Uht(l3, r3) {
    var e3 = l3.style, u = l3.shape, h = lgn[l3.type], v4 = {}, m3 = r3.animation, x3 = "path", C = l3.style.strokePercent, A2 = r3.compress && tut(l3) || 4;
    if (h && !r3.willUpdate && !(h[1] && !h[1](u)) && !(m3 && ugn(l3)) && !(C < 1)) {
      x3 = l3.type;
      var D = Math.pow(10, A2);
      h[0](u, v4, D);
    } else {
      l3.path || l3.createPathProxy();
      var P = l3.path;
      l3.shapeChanged() && (P.beginPath(), l3.buildPath(P, l3.shape), l3.pathUpdated());
      var N = P.getVersion(), j = l3, W = j.__svgPathBuilder;
      (j.__svgPathVersion !== N || !W || C !== j.__svgPathStrokePercent) && (W || (W = j.__svgPathBuilder = new Vht()), W.reset(A2), P.rebuildPath(W, C), W.generateStr(), j.__svgPathVersion = N, j.__svgPathStrokePercent = C), v4.d = W.getStr();
    }
    return DOe(v4, l3.transform), EOe(v4, e3, l3, r3), r3.animation && dpe(l3, v4, r3), a0(x3, l3.id + "", v4);
  }
  function cgn(l3, r3) {
    var e3 = l3.style, u = e3.image;
    if (u && !qa(u) && (Hht(u) ? u = u.src : Wht(u) && (u = u.toDataURL())), !!u) {
      var h = e3.x || 0, v4 = e3.y || 0, m3 = e3.width, x3 = e3.height, C = { href: u, width: m3, height: x3 };
      return h && (C.x = h), v4 && (C.y = v4), DOe(C, l3.transform), EOe(C, e3, l3, r3), r3.animation && dpe(l3, C, r3), a0("image", l3.id + "", C);
    }
  }
  function fgn(l3, r3) {
    var e3 = l3.style, u = e3.text;
    if (u != null && (u += ""), !(!u || isNaN(e3.x) || isNaN(e3.y))) {
      var h = e3.font || KO, v4 = e3.x || 0, m3 = Xsn(e3.y || 0, Ghe(h), e3.textBaseline), x3 = $sn[e3.textAlign] || e3.textAlign, C = { "dominant-baseline": "central", "text-anchor": x3 };
      if (Vut(e3)) {
        var A2 = "", D = e3.fontStyle, P = Fut(e3.fontSize);
        if (!parseFloat(P))
          return;
        var N = e3.fontFamily || klt, j = e3.fontWeight;
        A2 += "font-size:" + P + ";font-family:" + N + ";", D && D !== "normal" && (A2 += "font-style:" + D + ";"), j && j !== "normal" && (A2 += "font-weight:" + j + ";"), C.style = A2;
      } else
        C.style = "font: " + h;
      return u.match(/\s/) && (C["xml:space"] = "preserve"), v4 && (C.x = v4), m3 && (C.y = m3), DOe(C, l3.transform), EOe(C, e3, l3, r3), r3.animation && dpe(l3, C, r3), a0("text", l3.id + "", C, void 0, u);
    }
  }
  function Hrt(l3, r3) {
    if (l3 instanceof Nl)
      return Uht(l3, r3);
    if (l3 instanceof lm)
      return cgn(l3, r3);
    if (l3 instanceof nJ)
      return fgn(l3, r3);
  }
  function hgn(l3, r3, e3) {
    var u = l3.style;
    if (Ysn(u)) {
      var h = Ksn(l3), v4 = e3.shadowCache, m3 = v4[h];
      if (!m3) {
        var x3 = l3.getGlobalScale(), C = x3[0], A2 = x3[1];
        if (!C || !A2)
          return;
        var D = u.shadowOffsetX || 0, P = u.shadowOffsetY || 0, N = u.shadowBlur, j = fj(u.shadowColor), W = j.opacity, K = j.color, te = N / 2 / C, ne = N / 2 / A2, ce = te + " " + ne;
        m3 = e3.zrId + "-s" + e3.shadowIdx++, e3.defs[m3] = a0("filter", m3, { id: m3, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [a0("feDropShadow", "", { dx: D / C, dy: P / A2, stdDeviation: ce, "flood-color": K, "flood-opacity": W })]), v4[h] = m3;
      }
      r3.filter = zhe(m3);
    }
  }
  function pgn(l3, r3, e3, u) {
    var h = l3[e3], v4, m3 = { gradientUnits: h.global ? "userSpaceOnUse" : "objectBoundingBox" };
    if (Qlt(h))
      v4 = "linearGradient", m3.x1 = h.x, m3.y1 = h.y, m3.x2 = h.x2, m3.y2 = h.y2;
    else if (eut(h))
      v4 = "radialGradient", m3.cx = dl(h.x, 0.5), m3.cy = dl(h.y, 0.5), m3.r = dl(h.r, 0.5);
    else
      return;
    for (var x3 = h.colorStops, C = [], A2 = 0, D = x3.length; A2 < D; ++A2) {
      var P = O5e(x3[A2].offset) * 100 + "%", N = x3[A2].color, j = fj(N), W = j.color, K = j.opacity, te = { offset: P };
      te["stop-color"] = W, K < 1 && (te["stop-opacity"] = K), C.push(a0("stop", A2 + "", te));
    }
    var ne = a0(v4, "", m3, C), ce = IOe(ne), me = u.gradientCache, ve = me[ce];
    ve || (ve = u.zrId + "-g" + u.gradientIdx++, me[ce] = ve, m3.id = ve, u.defs[ve] = a0(v4, ve, m3, C)), r3[e3] = zhe(ve);
  }
  function dgn(l3, r3, e3, u) {
    var h = l3.style[e3], v4 = { patternUnits: "userSpaceOnUse" }, m3;
    if (Jlt(h)) {
      var x3 = h.imageWidth, C = h.imageHeight, A2 = void 0, D = h.image;
      if (qa(D) ? A2 = D : Hht(D) ? A2 = D.src : Wht(D) && (A2 = D.toDataURL()), typeof Image == "undefined") {
        var P = "Image width/height must been given explictly in svg-ssr renderer.";
        mb(x3, P), mb(C, P);
      } else if (x3 == null || C == null) {
        var N = function(ce, me) {
          if (ce) {
            var ve = ce.elm, Be = ce.attrs.width = x3 || me.width, Oe = ce.attrs.height = C || me.height;
            ve && (ve.setAttribute("width", Be), ve.setAttribute("height", Oe));
          }
        }, j = B3e(A2, null, l3, function(ce) {
          N(W, ce), N(m3, ce);
        });
        j && j.width && j.height && (x3 = x3 || j.width, C = C || j.height);
      }
      m3 = a0("image", "img", { href: A2, width: x3, height: C }), v4.width = x3, v4.height = C;
    } else
      h.svgElement && (m3 = bs(h.svgElement), v4.width = h.svgWidth, v4.height = h.svgHeight);
    if (!!m3) {
      v4.patternTransform = nut(h);
      var W = a0("pattern", "", v4, [m3]), K = IOe(W), te = u.patternCache, ne = te[K];
      ne || (ne = u.zrId + "-p" + u.patternIdx++, te[K] = ne, v4.id = ne, W = u.defs[ne] = a0("pattern", ne, v4, [m3])), r3[e3] = zhe(ne);
    }
  }
  function vgn(l3, r3, e3) {
    var u = e3.clipPathCache, h = e3.defs, v4 = u[l3.id];
    if (!v4) {
      v4 = e3.zrId + "-c" + e3.clipPathIdx++;
      var m3 = { id: v4 };
      u[l3.id] = v4, h[v4] = a0("clipPath", v4, m3, [Uht(l3, e3)]);
    }
    r3["clip-path"] = zhe(v4);
  }
  function Wrt(l3) {
    return document.createTextNode(l3);
  }
  function MN(l3, r3, e3) {
    l3.insertBefore(r3, e3);
  }
  function Urt(l3, r3) {
    l3.removeChild(r3);
  }
  function qrt(l3, r3) {
    l3.appendChild(r3);
  }
  function qht(l3) {
    return l3.parentNode;
  }
  function $ht(l3) {
    return l3.nextSibling;
  }
  function KEe(l3, r3) {
    l3.textContent = r3;
  }
  var $rt = 58, ggn = 120, ygn = a0("", "");
  function bke(l3) {
    return l3 === void 0;
  }
  function PA(l3) {
    return l3 !== void 0;
  }
  function mgn(l3, r3, e3) {
    for (var u = {}, h = r3; h <= e3; ++h) {
      var v4 = l3[h].key;
      v4 !== void 0 && (u[v4] = h);
    }
    return u;
  }
  function TZ(l3, r3) {
    var e3 = l3.key === r3.key, u = l3.tag === r3.tag;
    return u && e3;
  }
  function gJ(l3) {
    var r3, e3 = l3.children, u = l3.tag;
    if (PA(u)) {
      var h = l3.elm = jht(u);
      if (kOe(ygn, l3), Ni(e3))
        for (r3 = 0; r3 < e3.length; ++r3) {
          var v4 = e3[r3];
          v4 != null && qrt(h, gJ(v4));
        }
      else
        PA(l3.text) && !ls(l3.text) && qrt(h, Wrt(l3.text));
    } else
      l3.elm = Wrt(l3.text);
    return l3.elm;
  }
  function Xht(l3, r3, e3, u, h) {
    for (; u <= h; ++u) {
      var v4 = e3[u];
      v4 != null && MN(l3, gJ(v4), r3);
    }
  }
  function fhe(l3, r3, e3, u) {
    for (; e3 <= u; ++e3) {
      var h = r3[e3];
      if (h != null)
        if (PA(h.tag)) {
          var v4 = qht(h.elm);
          Urt(v4, h.elm);
        } else
          Urt(l3, h.elm);
    }
  }
  function kOe(l3, r3) {
    var e3, u = r3.elm, h = l3 && l3.attrs || {}, v4 = r3.attrs || {};
    if (h !== v4) {
      for (e3 in v4) {
        var m3 = v4[e3], x3 = h[e3];
        x3 !== m3 && (m3 === true ? u.setAttribute(e3, "") : m3 === false ? u.removeAttribute(e3) : e3.charCodeAt(0) !== ggn ? u.setAttribute(e3, m3) : e3 === "xmlns:xlink" || e3 === "xmlns" ? u.setAttributeNS(Zvn, e3, m3) : e3.charCodeAt(3) === $rt ? u.setAttributeNS(Jvn, e3, m3) : e3.charCodeAt(5) === $rt ? u.setAttributeNS(zht, e3, m3) : u.setAttribute(e3, m3));
      }
      for (e3 in h)
        e3 in v4 || u.removeAttribute(e3);
    }
  }
  function bgn(l3, r3, e3) {
    for (var u = 0, h = 0, v4 = r3.length - 1, m3 = r3[0], x3 = r3[v4], C = e3.length - 1, A2 = e3[0], D = e3[C], P, N, j, W; u <= v4 && h <= C; )
      m3 == null ? m3 = r3[++u] : x3 == null ? x3 = r3[--v4] : A2 == null ? A2 = e3[++h] : D == null ? D = e3[--C] : TZ(m3, A2) ? (Uz(m3, A2), m3 = r3[++u], A2 = e3[++h]) : TZ(x3, D) ? (Uz(x3, D), x3 = r3[--v4], D = e3[--C]) : TZ(m3, D) ? (Uz(m3, D), MN(l3, m3.elm, $ht(x3.elm)), m3 = r3[++u], D = e3[--C]) : TZ(x3, A2) ? (Uz(x3, A2), MN(l3, x3.elm, m3.elm), x3 = r3[--v4], A2 = e3[++h]) : (bke(P) && (P = mgn(r3, u, v4)), N = P[A2.key], bke(N) ? MN(l3, gJ(A2), m3.elm) : (j = r3[N], j.tag !== A2.tag ? MN(l3, gJ(A2), m3.elm) : (Uz(j, A2), r3[N] = void 0, MN(l3, j.elm, m3.elm))), A2 = e3[++h]);
    (u <= v4 || h <= C) && (u > v4 ? (W = e3[C + 1] == null ? null : e3[C + 1].elm, Xht(l3, W, e3, h, C)) : fhe(l3, r3, u, v4));
  }
  function Uz(l3, r3) {
    var e3 = r3.elm = l3.elm, u = l3.children, h = r3.children;
    l3 !== r3 && (kOe(l3, r3), bke(r3.text) ? PA(u) && PA(h) ? u !== h && bgn(e3, u, h) : PA(h) ? (PA(l3.text) && KEe(e3, ""), Xht(e3, null, h, 0, h.length - 1)) : PA(u) ? fhe(e3, u, 0, u.length - 1) : PA(l3.text) && KEe(e3, "") : l3.text !== r3.text && (PA(u) && fhe(e3, u, 0, u.length - 1), KEe(e3, r3.text)));
  }
  function _gn(l3, r3) {
    if (TZ(l3, r3))
      Uz(l3, r3);
    else {
      var e3 = l3.elm, u = qht(e3);
      gJ(r3), u !== null && (MN(u, r3.elm, $ht(e3)), fhe(u, [l3], 0, 0));
    }
    return r3;
  }
  var xgn = 0, wgn = function() {
    function l3(r3, e3, u) {
      if (this.type = "svg", this.refreshHover = Xrt(), this.configLayer = Xrt(), this.storage = e3, this._opts = u = fi({}, u), this.root = r3, this._id = "zr" + xgn++, this._oldVNode = Frt(u.width, u.height), r3 && !u.ssr) {
        var h = this._viewport = document.createElement("div");
        h.style.cssText = "position:relative;overflow:hidden";
        var v4 = this._svgDom = this._oldVNode.elm = jht("svg");
        kOe(null, this._oldVNode), h.appendChild(v4), r3.appendChild(h);
      }
      this.resize(u.width, u.height);
    }
    return l3.prototype.getType = function() {
      return this.type;
    }, l3.prototype.getViewportRoot = function() {
      return this._viewport;
    }, l3.prototype.getViewportRootOffset = function() {
      var r3 = this.getViewportRoot();
      if (r3)
        return { offsetLeft: r3.offsetLeft || 0, offsetTop: r3.offsetTop || 0 };
    }, l3.prototype.getSvgDom = function() {
      return this._svgDom;
    }, l3.prototype.refresh = function() {
      if (this.root) {
        var r3 = this.renderToVNode({ willUpdate: true });
        r3.attrs.style = "position:absolute;left:0;top:0;user-select:none", _gn(this._oldVNode, r3), this._oldVNode = r3;
      }
    }, l3.prototype.renderOneToVNode = function(r3) {
      return Hrt(r3, mke(this._id));
    }, l3.prototype.renderToVNode = function(r3) {
      r3 = r3 || {};
      var e3 = this.storage.getDisplayList(true), u = this._backgroundColor, h = this._width, v4 = this._height, m3 = mke(this._id);
      m3.animation = r3.animation, m3.willUpdate = r3.willUpdate, m3.compress = r3.compress;
      var x3 = [];
      if (u && u !== "none") {
        var C = fj(u), A2 = C.color, D = C.opacity;
        this._bgVNode = a0("rect", "bg", { width: h, height: v4, x: "0", y: "0", id: "0", fill: A2, "fill-opacity": D }), x3.push(this._bgVNode);
      } else
        this._bgVNode = null;
      var P = r3.compress ? null : this._mainVNode = a0("g", "main", {}, []);
      this._paintList(e3, m3, P ? P.children : x3), P && x3.push(P);
      var N = Bi(yu(m3.defs), function(K) {
        return m3.defs[K];
      });
      if (N.length && x3.push(a0("defs", "defs", {}, N)), r3.animation) {
        var j = tgn(m3.cssNodes, m3.cssAnims, { newline: true });
        if (j) {
          var W = a0("style", "stl", {}, [], j);
          x3.push(W);
        }
      }
      return Frt(h, v4, x3, r3.useViewBox);
    }, l3.prototype.renderToString = function(r3) {
      return r3 = r3 || {}, IOe(this.renderToVNode({ animation: dl(r3.cssAnimation, true), willUpdate: false, compress: true, useViewBox: dl(r3.useViewBox, true) }), { newline: true });
    }, l3.prototype.setBackgroundColor = function(r3) {
      this._backgroundColor = r3;
      var e3 = this._bgVNode;
      if (e3 && e3.elm) {
        var u = fj(r3), h = u.color, v4 = u.opacity;
        e3.elm.setAttribute("fill", h), v4 < 1 && e3.elm.setAttribute("fill-opacity", v4);
      }
    }, l3.prototype.getSvgRoot = function() {
      return this._mainVNode && this._mainVNode.elm;
    }, l3.prototype._paintList = function(r3, e3, u) {
      for (var h = r3.length, v4 = [], m3 = 0, x3, C, A2 = 0, D = 0; D < h; D++) {
        var P = r3[D];
        if (!P.invisible) {
          var N = P.__clipPaths, j = N && N.length || 0, W = C && C.length || 0, K = void 0;
          for (K = Math.max(j - 1, W - 1); K >= 0 && !(N && C && N[K] === C[K]); K--)
            ;
          for (var te = W - 1; te > K; te--)
            m3--, x3 = v4[m3 - 1];
          for (var ne = K + 1; ne < j; ne++) {
            var ce = {};
            vgn(N[ne], ce, e3);
            var me = a0("g", "clip-g-" + A2++, ce, []);
            (x3 ? x3.children : u).push(me), v4[m3++] = me, x3 = me;
          }
          C = N;
          var ve = Hrt(P, e3);
          ve && (x3 ? x3.children : u).push(ve);
        }
      }
    }, l3.prototype.resize = function(r3, e3) {
      var u = this._opts, h = this.root, v4 = this._viewport;
      if (r3 != null && (u.width = r3), e3 != null && (u.height = e3), h && v4 && (v4.style.display = "none", r3 = Jz(h, 0, u), e3 = Jz(h, 1, u), v4.style.display = ""), this._width !== r3 || this._height !== e3) {
        if (this._width = r3, this._height = e3, v4) {
          var m3 = v4.style;
          m3.width = r3 + "px", m3.height = e3 + "px";
        }
        var x3 = this._svgDom;
        x3 && (x3.setAttribute("width", r3), x3.setAttribute("height", e3));
      }
    }, l3.prototype.getWidth = function() {
      return this._width;
    }, l3.prototype.getHeight = function() {
      return this._height;
    }, l3.prototype.dispose = function() {
      this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
    }, l3.prototype.clear = function() {
      this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
    }, l3.prototype.toDataURL = function(r3) {
      var e3 = encodeURIComponent(this.renderToString()), u = "data:image/svg+xml;";
      return r3 ? (e3 = eln(e3), e3 && u + "base64," + e3) : u + "charset=UTF-8," + e3;
    }, l3;
  }();
  function Xrt(l3) {
    return function() {
    };
  }
  var Sgn = wgn;
  function Cgn(l3) {
    l3.registerPainter("svg", Sgn);
  }
  function Yrt(l3, r3, e3) {
    var u = l5.createCanvas(), h = r3.getWidth(), v4 = r3.getHeight(), m3 = u.style;
    return m3 && (m3.position = "absolute", m3.left = "0", m3.top = "0", m3.width = h + "px", m3.height = v4 + "px", u.setAttribute("data-zr-dom-id", l3)), u.width = h * e3, u.height = v4 * e3, u;
  }
  var Mgn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this) || this;
      v4.motionBlur = false, v4.lastFrameAlpha = 0.7, v4.dpr = 1, v4.virtual = false, v4.config = {}, v4.incremental = false, v4.zlevel = 0, v4.maxRepaintRectCount = 5, v4.__dirty = true, v4.__firstTimePaint = true, v4.__used = false, v4.__drawIndex = 0, v4.__startIndex = 0, v4.__endIndex = 0, v4.__prevStartIndex = null, v4.__prevEndIndex = null;
      var m3;
      h = h || Hfe, typeof e3 == "string" ? m3 = Yrt(e3, u, h) : ls(e3) && (m3 = e3, e3 = m3.id), v4.id = e3, v4.dom = m3;
      var x3 = m3.style;
      return x3 && (Nlt(m3), m3.onselectstart = function() {
        return false;
      }, x3.padding = "0", x3.margin = "0", x3.borderWidth = "0"), v4.painter = u, v4.dpr = h, v4;
    }
    return r3.prototype.getElementCount = function() {
      return this.__endIndex - this.__startIndex;
    }, r3.prototype.afterBrush = function() {
      this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
    }, r3.prototype.initContext = function() {
      this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
    }, r3.prototype.setUnpainted = function() {
      this.__firstTimePaint = true;
    }, r3.prototype.createBackBuffer = function() {
      var e3 = this.dpr;
      this.domBack = Yrt("back-" + this.id, this.painter, e3), this.ctxBack = this.domBack.getContext("2d"), e3 !== 1 && this.ctxBack.scale(e3, e3);
    }, r3.prototype.createRepaintRects = function(e3, u, h, v4) {
      if (this.__firstTimePaint)
        return this.__firstTimePaint = false, null;
      var m3 = [], x3 = this.maxRepaintRectCount, C = false, A2 = new Ml(0, 0, 0, 0);
      function D(ce) {
        if (!(!ce.isFinite() || ce.isZero()))
          if (m3.length === 0) {
            var me = new Ml(0, 0, 0, 0);
            me.copy(ce), m3.push(me);
          } else {
            for (var ve = false, Be = 1 / 0, Oe = 0, We = 0; We < m3.length; ++We) {
              var Ue = m3[We];
              if (Ue.intersect(ce)) {
                var qe = new Ml(0, 0, 0, 0);
                qe.copy(Ue), qe.union(ce), m3[We] = qe, ve = true;
                break;
              } else if (C) {
                A2.copy(ce), A2.union(Ue);
                var Ze = ce.width * ce.height, ct = Ue.width * Ue.height, _t = A2.width * A2.height, pt = _t - Ze - ct;
                pt < Be && (Be = pt, Oe = We);
              }
            }
            if (C && (m3[Oe].union(ce), ve = true), !ve) {
              var me = new Ml(0, 0, 0, 0);
              me.copy(ce), m3.push(me);
            }
            C || (C = m3.length >= x3);
          }
      }
      for (var P = this.__startIndex; P < this.__endIndex; ++P) {
        var N = e3[P];
        if (N) {
          var j = N.shouldBePainted(h, v4, true, true), W = N.__isRendered && (N.__dirty & Kx || !j) ? N.getPrevPaintRect() : null;
          W && D(W);
          var K = j && (N.__dirty & Kx || !N.__isRendered) ? N.getPaintRect() : null;
          K && D(K);
        }
      }
      for (var P = this.__prevStartIndex; P < this.__prevEndIndex; ++P) {
        var N = u[P], j = N.shouldBePainted(h, v4, true, true);
        if (N && (!j || !N.__zr) && N.__isRendered) {
          var W = N.getPrevPaintRect();
          W && D(W);
        }
      }
      var te;
      do {
        te = false;
        for (var P = 0; P < m3.length; ) {
          if (m3[P].isZero()) {
            m3.splice(P, 1);
            continue;
          }
          for (var ne = P + 1; ne < m3.length; )
            m3[P].intersect(m3[ne]) ? (te = true, m3[P].union(m3[ne]), m3.splice(ne, 1)) : ne++;
          P++;
        }
      } while (te);
      return this._paintRects = m3, m3;
    }, r3.prototype.debugGetPaintRects = function() {
      return (this._paintRects || []).slice();
    }, r3.prototype.resize = function(e3, u) {
      var h = this.dpr, v4 = this.dom, m3 = v4.style, x3 = this.domBack;
      m3 && (m3.width = e3 + "px", m3.height = u + "px"), v4.width = e3 * h, v4.height = u * h, x3 && (x3.width = e3 * h, x3.height = u * h, h !== 1 && this.ctxBack.scale(h, h));
    }, r3.prototype.clear = function(e3, u, h) {
      var v4 = this.dom, m3 = this.ctx, x3 = v4.width, C = v4.height;
      u = u || this.clearColor;
      var A2 = this.motionBlur && !e3, D = this.lastFrameAlpha, P = this.dpr, N = this;
      A2 && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(v4, 0, 0, x3 / P, C / P));
      var j = this.domBack;
      function W(K, te, ne, ce) {
        if (m3.clearRect(K, te, ne, ce), u && u !== "transparent") {
          var me = void 0;
          Vhe(u) ? (me = u.__canvasGradient || uke(m3, u, { x: 0, y: 0, width: ne, height: ce }), u.__canvasGradient = me) : asn(u) && (me = cke(m3, u, { dirty: function() {
            N.setUnpainted(), N.__painter.refresh();
          } })), m3.save(), m3.fillStyle = me || u, m3.fillRect(K, te, ne, ce), m3.restore();
        }
        A2 && (m3.save(), m3.globalAlpha = D, m3.drawImage(j, K, te, ne, ce), m3.restore());
      }
      !h || A2 ? W(0, 0, x3, C) : h.length && mt(h, function(K) {
        W(K.x * P, K.y * P, K.width * P, K.height * P);
      });
    }, r3;
  }(w2), ZEe = Mgn, Krt = 1e5, pN = 314159, jce = 0.01, Tgn = 1e-3;
  function Agn(l3) {
    return l3 ? l3.__builtin__ ? true : !(typeof l3.resize != "function" || typeof l3.refresh != "function") : false;
  }
  function Ign(l3, r3) {
    var e3 = document.createElement("div");
    return e3.style.cssText = ["position:relative", "width:" + l3 + "px", "height:" + r3 + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", e3;
  }
  var Egn = function() {
    function l3(r3, e3, u, h) {
      this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
      var v4 = !r3.nodeName || r3.nodeName.toUpperCase() === "CANVAS";
      this._opts = u = fi({}, u || {}), this.dpr = u.devicePixelRatio || Hfe, this._singleCanvas = v4, this.root = r3;
      var m3 = r3.style;
      m3 && (Nlt(r3), r3.innerHTML = ""), this.storage = e3;
      var x3 = this._zlevelList;
      this._prevDisplayList = [];
      var C = this._layers;
      if (v4) {
        var D = r3, P = D.width, N = D.height;
        u.width != null && (P = u.width), u.height != null && (N = u.height), this.dpr = u.devicePixelRatio || 1, D.width = P * this.dpr, D.height = N * this.dpr, this._width = P, this._height = N;
        var j = new ZEe(D, this, this.dpr);
        j.__builtin__ = true, j.initContext(), C[pN] = j, j.zlevel = pN, x3.push(pN), this._domRoot = r3;
      } else {
        this._width = Jz(r3, 0, u), this._height = Jz(r3, 1, u);
        var A2 = this._domRoot = Ign(this._width, this._height);
        r3.appendChild(A2);
      }
    }
    return l3.prototype.getType = function() {
      return "canvas";
    }, l3.prototype.isSingleCanvas = function() {
      return this._singleCanvas;
    }, l3.prototype.getViewportRoot = function() {
      return this._domRoot;
    }, l3.prototype.getViewportRootOffset = function() {
      var r3 = this.getViewportRoot();
      if (r3)
        return { offsetLeft: r3.offsetLeft || 0, offsetTop: r3.offsetTop || 0 };
    }, l3.prototype.refresh = function(r3) {
      var e3 = this.storage.getDisplayList(true), u = this._prevDisplayList, h = this._zlevelList;
      this._redrawId = Math.random(), this._paintList(e3, u, r3, this._redrawId);
      for (var v4 = 0; v4 < h.length; v4++) {
        var m3 = h[v4], x3 = this._layers[m3];
        if (!x3.__builtin__ && x3.refresh) {
          var C = v4 === 0 ? this._backgroundColor : null;
          x3.refresh(C);
        }
      }
      return this._opts.useDirtyRect && (this._prevDisplayList = e3.slice()), this;
    }, l3.prototype.refreshHover = function() {
      this._paintHoverList(this.storage.getDisplayList(false));
    }, l3.prototype._paintHoverList = function(r3) {
      var e3 = r3.length, u = this._hoverlayer;
      if (u && u.clear(), !!e3) {
        for (var h = { inHover: true, viewWidth: this._width, viewHeight: this._height }, v4, m3 = 0; m3 < e3; m3++) {
          var x3 = r3[m3];
          x3.__inHover && (u || (u = this._hoverlayer = this.getLayer(Krt)), v4 || (v4 = u.ctx, v4.save()), ON(v4, x3, h, m3 === e3 - 1));
        }
        v4 && v4.restore();
      }
    }, l3.prototype.getHoverLayer = function() {
      return this.getLayer(Krt);
    }, l3.prototype.paintOne = function(r3, e3) {
      Oft(r3, e3);
    }, l3.prototype._paintList = function(r3, e3, u, h) {
      if (this._redrawId === h) {
        u = u || false, this._updateLayerStatus(r3);
        var v4 = this._doPaintList(r3, e3, u), m3 = v4.finished, x3 = v4.needsRefreshHover;
        if (this._needsManuallyCompositing && this._compositeManually(), x3 && this._paintHoverList(r3), m3)
          this.eachLayer(function(A2) {
            A2.afterBrush && A2.afterBrush();
          });
        else {
          var C = this;
          A5e(function() {
            C._paintList(r3, e3, u, h);
          });
        }
      }
    }, l3.prototype._compositeManually = function() {
      var r3 = this.getLayer(pN).ctx, e3 = this._domRoot.width, u = this._domRoot.height;
      r3.clearRect(0, 0, e3, u), this.eachBuiltinLayer(function(h) {
        h.virtual && r3.drawImage(h.dom, 0, 0, e3, u);
      });
    }, l3.prototype._doPaintList = function(r3, e3, u) {
      for (var h = this, v4 = [], m3 = this._opts.useDirtyRect, x3 = 0; x3 < this._zlevelList.length; x3++) {
        var C = this._zlevelList[x3], A2 = this._layers[C];
        A2.__builtin__ && A2 !== this._hoverlayer && (A2.__dirty || u) && v4.push(A2);
      }
      for (var D = true, P = false, N = function(K) {
        var te = v4[K], ne = te.ctx, ce = m3 && te.createRepaintRects(r3, e3, j._width, j._height), me = u ? te.__startIndex : te.__drawIndex, ve = !u && te.incremental && Date.now, Be = ve && Date.now(), Oe = te.zlevel === j._zlevelList[0] ? j._backgroundColor : null;
        if (te.__startIndex === te.__endIndex)
          te.clear(false, Oe, ce);
        else if (me === te.__startIndex) {
          var We = r3[me];
          (!We.incremental || !We.notClear || u) && te.clear(false, Oe, ce);
        }
        me === -1 && (console.error("For some unknown reason. drawIndex is -1"), me = te.__startIndex);
        var Ue, qe = function(pt) {
          var zt = { inHover: false, allClipped: false, prevEl: null, viewWidth: h._width, viewHeight: h._height };
          for (Ue = me; Ue < te.__endIndex; Ue++) {
            var Zt = r3[Ue];
            if (Zt.__inHover && (P = true), h._doPaintEl(Zt, te, m3, pt, zt, Ue === te.__endIndex - 1), ve) {
              var Ft = Date.now() - Be;
              if (Ft > 15)
                break;
            }
          }
          zt.prevElClipPaths && ne.restore();
        };
        if (ce)
          if (ce.length === 0)
            Ue = te.__endIndex;
          else
            for (var Ze = j.dpr, ct = 0; ct < ce.length; ++ct) {
              var _t = ce[ct];
              ne.save(), ne.beginPath(), ne.rect(_t.x * Ze, _t.y * Ze, _t.width * Ze, _t.height * Ze), ne.clip(), qe(_t), ne.restore();
            }
        else
          ne.save(), qe(), ne.restore();
        te.__drawIndex = Ue, te.__drawIndex < te.__endIndex && (D = false);
      }, j = this, W = 0; W < v4.length; W++)
        N(W);
      return Fc.wxa && mt(this._layers, function(K) {
        K && K.ctx && K.ctx.draw && K.ctx.draw();
      }), { finished: D, needsRefreshHover: P };
    }, l3.prototype._doPaintEl = function(r3, e3, u, h, v4, m3) {
      var x3 = e3.ctx;
      if (u) {
        var C = r3.getPaintRect();
        (!h || C && C.intersect(h)) && (ON(x3, r3, v4, m3), r3.setPrevPaintRect(C));
      } else
        ON(x3, r3, v4, m3);
    }, l3.prototype.getLayer = function(r3, e3) {
      this._singleCanvas && !this._needsManuallyCompositing && (r3 = pN);
      var u = this._layers[r3];
      return u || (u = new ZEe("zr_" + r3, this, this.dpr), u.zlevel = r3, u.__builtin__ = true, this._layerConfig[r3] ? ol(u, this._layerConfig[r3], true) : this._layerConfig[r3 - jce] && ol(u, this._layerConfig[r3 - jce], true), e3 && (u.virtual = e3), this.insertLayer(r3, u), u.initContext()), u;
    }, l3.prototype.insertLayer = function(r3, e3) {
      var u = this._layers, h = this._zlevelList, v4 = h.length, m3 = this._domRoot, x3 = null, C = -1;
      if (!u[r3] && !!Agn(e3)) {
        if (v4 > 0 && r3 > h[0]) {
          for (C = 0; C < v4 - 1 && !(h[C] < r3 && h[C + 1] > r3); C++)
            ;
          x3 = u[h[C]];
        }
        if (h.splice(C + 1, 0, r3), u[r3] = e3, !e3.virtual)
          if (x3) {
            var A2 = x3.dom;
            A2.nextSibling ? m3.insertBefore(e3.dom, A2.nextSibling) : m3.appendChild(e3.dom);
          } else
            m3.firstChild ? m3.insertBefore(e3.dom, m3.firstChild) : m3.appendChild(e3.dom);
        e3.__painter = this;
      }
    }, l3.prototype.eachLayer = function(r3, e3) {
      for (var u = this._zlevelList, h = 0; h < u.length; h++) {
        var v4 = u[h];
        r3.call(e3, this._layers[v4], v4);
      }
    }, l3.prototype.eachBuiltinLayer = function(r3, e3) {
      for (var u = this._zlevelList, h = 0; h < u.length; h++) {
        var v4 = u[h], m3 = this._layers[v4];
        m3.__builtin__ && r3.call(e3, m3, v4);
      }
    }, l3.prototype.eachOtherLayer = function(r3, e3) {
      for (var u = this._zlevelList, h = 0; h < u.length; h++) {
        var v4 = u[h], m3 = this._layers[v4];
        m3.__builtin__ || r3.call(e3, m3, v4);
      }
    }, l3.prototype.getLayers = function() {
      return this._layers;
    }, l3.prototype._updateLayerStatus = function(r3) {
      this.eachBuiltinLayer(function(P, N) {
        P.__dirty = P.__used = false;
      });
      function e3(P) {
        v4 && (v4.__endIndex !== P && (v4.__dirty = true), v4.__endIndex = P);
      }
      if (this._singleCanvas)
        for (var u = 1; u < r3.length; u++) {
          var h = r3[u];
          if (h.zlevel !== r3[u - 1].zlevel || h.incremental) {
            this._needsManuallyCompositing = true;
            break;
          }
        }
      var v4 = null, m3 = 0, x3, C;
      for (C = 0; C < r3.length; C++) {
        var h = r3[C], A2 = h.zlevel, D = void 0;
        x3 !== A2 && (x3 = A2, m3 = 0), h.incremental ? (D = this.getLayer(A2 + Tgn, this._needsManuallyCompositing), D.incremental = true, m3 = 1) : D = this.getLayer(A2 + (m3 > 0 ? jce : 0), this._needsManuallyCompositing), D.__builtin__ || M3e("ZLevel " + A2 + " has been used by unkown layer " + D.id), D !== v4 && (D.__used = true, D.__startIndex !== C && (D.__dirty = true), D.__startIndex = C, D.incremental ? D.__drawIndex = -1 : D.__drawIndex = C, e3(C), v4 = D), h.__dirty & Kx && !h.__inHover && (D.__dirty = true, D.incremental && D.__drawIndex < 0 && (D.__drawIndex = C));
      }
      e3(C), this.eachBuiltinLayer(function(P, N) {
        !P.__used && P.getElementCount() > 0 && (P.__dirty = true, P.__startIndex = P.__endIndex = P.__drawIndex = 0), P.__dirty && P.__drawIndex < 0 && (P.__drawIndex = P.__startIndex);
      });
    }, l3.prototype.clear = function() {
      return this.eachBuiltinLayer(this._clearLayer), this;
    }, l3.prototype._clearLayer = function(r3) {
      r3.clear();
    }, l3.prototype.setBackgroundColor = function(r3) {
      this._backgroundColor = r3, mt(this._layers, function(e3) {
        e3.setUnpainted();
      });
    }, l3.prototype.configLayer = function(r3, e3) {
      if (e3) {
        var u = this._layerConfig;
        u[r3] ? ol(u[r3], e3, true) : u[r3] = e3;
        for (var h = 0; h < this._zlevelList.length; h++) {
          var v4 = this._zlevelList[h];
          if (v4 === r3 || v4 === r3 + jce) {
            var m3 = this._layers[v4];
            ol(m3, u[r3], true);
          }
        }
      }
    }, l3.prototype.delLayer = function(r3) {
      var e3 = this._layers, u = this._zlevelList, h = e3[r3];
      !h || (h.dom.parentNode.removeChild(h.dom), delete e3[r3], u.splice(Cl(u, r3), 1));
    }, l3.prototype.resize = function(r3, e3) {
      if (this._domRoot.style) {
        var u = this._domRoot;
        u.style.display = "none";
        var h = this._opts, v4 = this.root;
        if (r3 != null && (h.width = r3), e3 != null && (h.height = e3), r3 = Jz(v4, 0, h), e3 = Jz(v4, 1, h), u.style.display = "", this._width !== r3 || e3 !== this._height) {
          u.style.width = r3 + "px", u.style.height = e3 + "px";
          for (var m3 in this._layers)
            this._layers.hasOwnProperty(m3) && this._layers[m3].resize(r3, e3);
          this.refresh(true);
        }
        this._width = r3, this._height = e3;
      } else {
        if (r3 == null || e3 == null)
          return;
        this._width = r3, this._height = e3, this.getLayer(pN).resize(r3, e3);
      }
      return this;
    }, l3.prototype.clearLayer = function(r3) {
      var e3 = this._layers[r3];
      e3 && e3.clear();
    }, l3.prototype.dispose = function() {
      this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
    }, l3.prototype.getRenderedCanvas = function(r3) {
      if (r3 = r3 || {}, this._singleCanvas && !this._compositeManually)
        return this._layers[pN].dom;
      var e3 = new ZEe("image", this, r3.pixelRatio || this.dpr);
      e3.initContext(), e3.clear(false, r3.backgroundColor || this._backgroundColor);
      var u = e3.ctx;
      if (r3.pixelRatio <= this.dpr) {
        this.refresh();
        var h = e3.dom.width, v4 = e3.dom.height;
        this.eachLayer(function(P) {
          P.__builtin__ ? u.drawImage(P.dom, 0, 0, h, v4) : P.renderToCanvas && (u.save(), P.renderToCanvas(u), u.restore());
        });
      } else
        for (var m3 = { inHover: false, viewWidth: this._width, viewHeight: this._height }, x3 = this.storage.getDisplayList(true), C = 0, A2 = x3.length; C < A2; C++) {
          var D = x3[C];
          ON(u, D, m3, C === A2 - 1);
        }
      return e3.dom;
    }, l3.prototype.getWidth = function() {
      return this._width;
    }, l3.prototype.getHeight = function() {
      return this._height;
    }, l3;
  }(), Dgn = Egn;
  function kgn(l3) {
    l3.registerPainter("canvas", Dgn);
  }
  var Ogn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.hasSymbolVisual = true, e3;
    }
    return r3.prototype.getInitialData = function(e3) {
      return v5(null, this, { useEncodeDefaulter: true });
    }, r3.prototype.getLegendIcon = function(e3) {
      var u = new Cs(), h = Nv("line", 0, e3.itemHeight / 2, e3.itemWidth, 0, e3.lineStyle.stroke, false);
      u.add(h), h.setStyle(e3.lineStyle);
      var v4 = this.getData().getVisual("symbol"), m3 = this.getData().getVisual("symbolRotate"), x3 = v4 === "none" ? "circle" : v4, C = e3.itemHeight * 0.8, A2 = Nv(x3, (e3.itemWidth - C) / 2, (e3.itemHeight - C) / 2, C, C, e3.itemStyle.fill);
      u.add(A2), A2.setStyle(e3.itemStyle);
      var D = e3.iconRotate === "inherit" ? m3 : e3.iconRotate || 0;
      return A2.rotation = D * Math.PI / 180, A2.setOrigin([e3.itemWidth / 2, e3.itemHeight / 2]), x3.indexOf("empty") > -1 && (A2.style.stroke = A2.style.fill, A2.style.fill = "#fff", A2.style.lineWidth = 2), u;
    }, r3.type = "series.line", r3.dependencies = ["grid", "polar"], r3.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, r3;
  }(Fp), Pgn = Ogn;
  function dj(l3, r3) {
    var e3 = l3.mapDimensionsAll("defaultedLabel"), u = e3.length;
    if (u === 1) {
      var h = hj(l3, r3, e3[0]);
      return h != null ? h + "" : null;
    } else if (u) {
      for (var v4 = [], m3 = 0; m3 < e3.length; m3++)
        v4.push(hj(l3, r3, e3[m3]));
      return v4.join(" ");
    }
  }
  function Yht(l3, r3) {
    var e3 = l3.mapDimensionsAll("defaultedLabel");
    if (!Ni(r3))
      return r3 + "";
    for (var u = [], h = 0; h < e3.length; h++) {
      var v4 = l3.getDimensionIndex(e3[h]);
      v4 >= 0 && u.push(r3[v4]);
    }
    return u.join(" ");
  }
  var Lgn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4) {
      var m3 = l3.call(this) || this;
      return m3.updateData(e3, u, h, v4), m3;
    }
    return r3.prototype._createSymbol = function(e3, u, h, v4, m3) {
      this.removeAll();
      var x3 = Nv(e3, -1, -1, 2, 2, null, m3);
      x3.attr({ z2: 100, culling: true, scaleX: v4[0] / 2, scaleY: v4[1] / 2 }), x3.drift = Rgn, this._symbolType = e3, this.add(x3);
    }, r3.prototype.stopSymbolAnimation = function(e3) {
      this.childAt(0).stopAnimation(null, e3);
    }, r3.prototype.getSymbolType = function() {
      return this._symbolType;
    }, r3.prototype.getSymbolPath = function() {
      return this.childAt(0);
    }, r3.prototype.highlight = function() {
      zA(this.childAt(0));
    }, r3.prototype.downplay = function() {
      jA(this.childAt(0));
    }, r3.prototype.setZ = function(e3, u) {
      var h = this.childAt(0);
      h.zlevel = e3, h.z = u;
    }, r3.prototype.setDraggable = function(e3) {
      var u = this.childAt(0);
      u.draggable = e3, u.cursor = e3 ? "move" : u.cursor;
    }, r3.prototype.updateData = function(e3, u, h, v4) {
      this.silent = false;
      var m3 = e3.getItemVisual(u, "symbol") || "circle", x3 = e3.hostModel, C = r3.getSymbolSize(e3, u), A2 = m3 !== this._symbolType, D = v4 && v4.disableAnimation;
      if (A2) {
        var P = e3.getItemVisual(u, "symbolKeepAspect");
        this._createSymbol(m3, e3, u, C, P);
      } else {
        var N = this.childAt(0);
        N.silent = false;
        var j = { scaleX: C[0] / 2, scaleY: C[1] / 2 };
        D ? N.attr(j) : hc(N, j, x3, u), yM(N);
      }
      if (this._updateCommon(e3, u, C, h, v4), A2) {
        var N = this.childAt(0);
        if (!D) {
          var j = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: N.style.opacity } };
          N.scaleX = N.scaleY = 0, N.style.opacity = 0, Np(N, j, x3, u);
        }
      }
      D && this.childAt(0).stopAnimation("leave");
    }, r3.prototype._updateCommon = function(e3, u, h, v4, m3) {
      var x3 = this.childAt(0), C = e3.hostModel, A2, D, P, N, j, W, K, te, ne;
      if (v4 && (A2 = v4.emphasisItemStyle, D = v4.blurItemStyle, P = v4.selectItemStyle, N = v4.focus, j = v4.blurScope, K = v4.labelStatesModels, te = v4.hoverScale, ne = v4.cursorStyle, W = v4.emphasisDisabled), !v4 || e3.hasItemOption) {
        var ce = v4 && v4.itemModel ? v4.itemModel : e3.getItemModel(u), me = ce.getModel("emphasis");
        A2 = me.getModel("itemStyle").getItemStyle(), P = ce.getModel(["select", "itemStyle"]).getItemStyle(), D = ce.getModel(["blur", "itemStyle"]).getItemStyle(), N = me.get("focus"), j = me.get("blurScope"), W = me.get("disabled"), K = ny(ce), te = me.getShallow("scale"), ne = ce.getShallow("cursor");
      }
      var ve = e3.getItemVisual(u, "symbolRotate");
      x3.attr("rotation", (ve || 0) * Math.PI / 180 || 0);
      var Be = Pj(e3.getItemVisual(u, "symbolOffset"), h);
      Be && (x3.x = Be[0], x3.y = Be[1]), ne && x3.attr("cursor", ne);
      var Oe = e3.getItemVisual(u, "style"), We = Oe.fill;
      if (x3 instanceof lm) {
        var Ue = x3.style;
        x3.useStyle(fi({ image: Ue.image, x: Ue.x, y: Ue.y, width: Ue.width, height: Ue.height }, Oe));
      } else
        x3.__isEmptyBrush ? x3.useStyle(fi({}, Oe)) : x3.useStyle(Oe), x3.style.decal = null, x3.setColor(We, m3 && m3.symbolInnerColor), x3.style.strokeNoScale = true;
      var qe = e3.getItemVisual(u, "liftZ"), Ze = this._z2;
      qe != null ? Ze == null && (this._z2 = x3.z2, x3.z2 += qe) : Ze != null && (x3.z2 = Ze, this._z2 = null);
      var ct = m3 && m3.useNameLabel;
      _1(x3, K, { labelFetcher: C, labelDataIndex: u, defaultText: _t, inheritColor: We, defaultOpacity: Oe.opacity });
      function _t(Zt) {
        return ct ? e3.getName(Zt) : dj(e3, Zt);
      }
      this._sizeX = h[0] / 2, this._sizeY = h[1] / 2;
      var pt = x3.ensureState("emphasis");
      if (pt.style = A2, x3.ensureState("select").style = P, x3.ensureState("blur").style = D, te) {
        var zt = Math.max(1.1, 3 / this._sizeY);
        pt.scaleX = this._sizeX * zt, pt.scaleY = this._sizeY * zt;
      }
      this.setSymbolScale(1), Gd(this, N, j, W);
    }, r3.prototype.setSymbolScale = function(e3) {
      this.scaleX = this.scaleY = e3;
    }, r3.prototype.fadeOut = function(e3, u, h) {
      var v4 = this.childAt(0), m3 = Ps(this).dataIndex, x3 = h && h.animation;
      if (this.silent = v4.silent = true, h && h.fadeLabel) {
        var C = v4.getTextContent();
        C && JO(C, { style: { opacity: 0 } }, u, { dataIndex: m3, removeOpt: x3, cb: function() {
          v4.removeTextContent();
        } });
      } else
        v4.removeTextContent();
      JO(v4, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, u, { dataIndex: m3, cb: e3, removeOpt: x3 });
    }, r3.getSymbolSize = function(e3, u) {
      return BJ(e3.getItemVisual(u, "symbolSize"));
    }, r3;
  }(Cs);
  function Rgn(l3, r3) {
    this.parent.drift(l3, r3);
  }
  var HJ = Lgn;
  function JEe(l3, r3, e3, u) {
    return r3 && !isNaN(r3[0]) && !isNaN(r3[1]) && !(u.isIgnore && u.isIgnore(e3)) && !(u.clipShape && !u.clipShape.contain(r3[0], r3[1])) && l3.getItemVisual(e3, "symbol") !== "none";
  }
  function Zrt(l3) {
    return l3 != null && !ls(l3) && (l3 = { isIgnore: l3 }), l3 || {};
  }
  function Jrt(l3) {
    var r3 = l3.hostModel, e3 = r3.getModel("emphasis");
    return { emphasisItemStyle: e3.getModel("itemStyle").getItemStyle(), blurItemStyle: r3.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: r3.getModel(["select", "itemStyle"]).getItemStyle(), focus: e3.get("focus"), blurScope: e3.get("blurScope"), emphasisDisabled: e3.get("disabled"), hoverScale: e3.get("scale"), labelStatesModels: ny(r3), cursorStyle: r3.get("cursor") };
  }
  var Ngn = function() {
    function l3(r3) {
      this.group = new Cs(), this._SymbolCtor = r3 || HJ;
    }
    return l3.prototype.updateData = function(r3, e3) {
      this._progressiveEls = null, e3 = Zrt(e3);
      var u = this.group, h = r3.hostModel, v4 = this._data, m3 = this._SymbolCtor, x3 = e3.disableAnimation, C = Jrt(r3), A2 = { disableAnimation: x3 }, D = e3.getSymbolPoint || function(P) {
        return r3.getItemLayout(P);
      };
      v4 || u.removeAll(), r3.diff(v4).add(function(P) {
        var N = D(P);
        if (JEe(r3, N, P, e3)) {
          var j = new m3(r3, P, C, A2);
          j.setPosition(N), r3.setItemGraphicEl(P, j), u.add(j);
        }
      }).update(function(P, N) {
        var j = v4.getItemGraphicEl(N), W = D(P);
        if (!JEe(r3, W, P, e3)) {
          u.remove(j);
          return;
        }
        var K = r3.getItemVisual(P, "symbol") || "circle", te = j && j.getSymbolType && j.getSymbolType();
        if (!j || te && te !== K)
          u.remove(j), j = new m3(r3, P, C, A2), j.setPosition(W);
        else {
          j.updateData(r3, P, C, A2);
          var ne = { x: W[0], y: W[1] };
          x3 ? j.attr(ne) : hc(j, ne, h);
        }
        u.add(j), r3.setItemGraphicEl(P, j);
      }).remove(function(P) {
        var N = v4.getItemGraphicEl(P);
        N && N.fadeOut(function() {
          u.remove(N);
        }, h);
      }).execute(), this._getSymbolPoint = D, this._data = r3;
    }, l3.prototype.updateLayout = function() {
      var r3 = this, e3 = this._data;
      e3 && e3.eachItemGraphicEl(function(u, h) {
        var v4 = r3._getSymbolPoint(h);
        u.setPosition(v4), u.markRedraw();
      });
    }, l3.prototype.incrementalPrepareUpdate = function(r3) {
      this._seriesScope = Jrt(r3), this._data = null, this.group.removeAll();
    }, l3.prototype.incrementalUpdate = function(r3, e3, u) {
      this._progressiveEls = [], u = Zrt(u);
      function h(C) {
        C.isGroup || (C.incremental = true, C.ensureState("emphasis").hoverLayer = true);
      }
      for (var v4 = r3.start; v4 < r3.end; v4++) {
        var m3 = e3.getItemLayout(v4);
        if (JEe(e3, m3, v4, u)) {
          var x3 = new this._SymbolCtor(e3, v4, this._seriesScope);
          x3.traverse(h), x3.setPosition(m3), this.group.add(x3), e3.setItemGraphicEl(v4, x3), this._progressiveEls.push(x3);
        }
      }
    }, l3.prototype.eachRendered = function(r3) {
      oP(this._progressiveEls || this.group, r3);
    }, l3.prototype.remove = function(r3) {
      var e3 = this.group, u = this._data;
      u && r3 ? u.eachItemGraphicEl(function(h) {
        h.fadeOut(function() {
          e3.remove(h);
        }, u.hostModel);
      }) : e3.removeAll();
    }, l3;
  }(), WJ = Ngn;
  function Kht(l3, r3, e3) {
    var u = l3.getBaseAxis(), h = l3.getOtherAxis(u), v4 = Fgn(h, e3), m3 = u.dim, x3 = h.dim, C = r3.mapDimension(x3), A2 = r3.mapDimension(m3), D = x3 === "x" || x3 === "radius" ? 1 : 0, P = Bi(l3.dimensions, function(W) {
      return r3.mapDimension(W);
    }), N = false, j = r3.getCalculationInfo("stackResultDimension");
    return eP(r3, P[0]) && (N = true, P[0] = j), eP(r3, P[1]) && (N = true, P[1] = j), { dataDimsForPoint: P, valueStart: v4, valueAxisDim: x3, baseAxisDim: m3, stacked: !!N, valueDim: C, baseDim: A2, baseDataOffset: D, stackedOverDimension: r3.getCalculationInfo("stackedOverDimension") };
  }
  function Fgn(l3, r3) {
    var e3 = 0, u = l3.scale.getExtent();
    return r3 === "start" ? e3 = u[0] : r3 === "end" ? e3 = u[1] : u[0] > 0 ? e3 = u[0] : u[1] < 0 && (e3 = u[1]), e3;
  }
  function Zht(l3, r3, e3, u) {
    var h = NaN;
    l3.stacked && (h = e3.get(e3.getCalculationInfo("stackedOverDimension"), u)), isNaN(h) && (h = l3.valueStart);
    var v4 = l3.baseDataOffset, m3 = [];
    return m3[v4] = e3.get(l3.baseDim, u), m3[1 - v4] = h, r3.dataToPoint(m3);
  }
  function Vgn(l3, r3) {
    var e3 = [];
    return r3.diff(l3).add(function(u) {
      e3.push({ cmd: "+", idx: u });
    }).update(function(u, h) {
      e3.push({ cmd: "=", idx: h, idx1: u });
    }).remove(function(u) {
      e3.push({ cmd: "-", idx: u });
    }).execute(), e3;
  }
  function Bgn(l3, r3, e3, u, h, v4, m3, x3) {
    for (var C = Vgn(l3, r3), A2 = [], D = [], P = [], N = [], j = [], W = [], K = [], te = Kht(h, r3, m3), ne = l3.getLayout("points") || [], ce = r3.getLayout("points") || [], me = 0; me < C.length; me++) {
      var ve = C[me], Be = true, Oe = void 0, We = void 0;
      switch (ve.cmd) {
        case "=":
          Oe = ve.idx * 2, We = ve.idx1 * 2;
          var Ue = ne[Oe], qe = ne[Oe + 1], Ze = ce[We], ct = ce[We + 1];
          (isNaN(Ue) || isNaN(qe)) && (Ue = Ze, qe = ct), A2.push(Ue, qe), D.push(Ze, ct), P.push(e3[Oe], e3[Oe + 1]), N.push(u[We], u[We + 1]), K.push(r3.getRawIndex(ve.idx1));
          break;
        case "+":
          var _t = ve.idx, pt = te.dataDimsForPoint, zt = h.dataToPoint([r3.get(pt[0], _t), r3.get(pt[1], _t)]);
          We = _t * 2, A2.push(zt[0], zt[1]), D.push(ce[We], ce[We + 1]);
          var Zt = Zht(te, h, r3, _t);
          P.push(Zt[0], Zt[1]), N.push(u[We], u[We + 1]), K.push(r3.getRawIndex(_t));
          break;
        case "-":
          Be = false;
      }
      Be && (j.push(ve), W.push(W.length));
    }
    W.sort(function(Lo, Ao) {
      return K[Lo] - K[Ao];
    });
    for (var Ft = A2.length, Kn = VA(Ft), hn = VA(Ft), xn = VA(Ft), zn = VA(Ft), or = [], me = 0; me < W.length; me++) {
      var vr = W[me], la = me * 2, Ba = vr * 2;
      Kn[la] = A2[Ba], Kn[la + 1] = A2[Ba + 1], hn[la] = D[Ba], hn[la + 1] = D[Ba + 1], xn[la] = P[Ba], xn[la + 1] = P[Ba + 1], zn[la] = N[Ba], zn[la + 1] = N[Ba + 1], or[me] = j[vr];
    }
    return { current: Kn, next: hn, stackedOnCurrent: xn, stackedOnNext: zn, status: or };
  }
  var IO = Math.min, EO = Math.max;
  function zN(l3, r3) {
    return isNaN(l3) || isNaN(r3);
  }
  function _ke(l3, r3, e3, u, h, v4, m3, x3, C) {
    for (var A2, D, P, N, j, W, K = e3, te = 0; te < u; te++) {
      var ne = r3[K * 2], ce = r3[K * 2 + 1];
      if (K >= h || K < 0)
        break;
      if (zN(ne, ce)) {
        if (C) {
          K += v4;
          continue;
        }
        break;
      }
      if (K === e3)
        l3[v4 > 0 ? "moveTo" : "lineTo"](ne, ce), P = ne, N = ce;
      else {
        var me = ne - A2, ve = ce - D;
        if (me * me + ve * ve < 0.5) {
          K += v4;
          continue;
        }
        if (m3 > 0) {
          for (var Be = K + v4, Oe = r3[Be * 2], We = r3[Be * 2 + 1]; Oe === ne && We === ce && te < u; )
            te++, Be += v4, K += v4, Oe = r3[Be * 2], We = r3[Be * 2 + 1], ne = r3[K * 2], ce = r3[K * 2 + 1], me = ne - A2, ve = ce - D;
          var Ue = te + 1;
          if (C)
            for (; zN(Oe, We) && Ue < u; )
              Ue++, Be += v4, Oe = r3[Be * 2], We = r3[Be * 2 + 1];
          var qe = 0.5, Ze = 0, ct = 0, _t = void 0, pt = void 0;
          if (Ue >= u || zN(Oe, We))
            j = ne, W = ce;
          else {
            Ze = Oe - A2, ct = We - D;
            var zt = ne - A2, Zt = Oe - ne, Ft = ce - D, Kn = We - ce, hn = void 0, xn = void 0;
            if (x3 === "x") {
              hn = Math.abs(zt), xn = Math.abs(Zt);
              var zn = Ze > 0 ? 1 : -1;
              j = ne - zn * hn * m3, W = ce, _t = ne + zn * xn * m3, pt = ce;
            } else if (x3 === "y") {
              hn = Math.abs(Ft), xn = Math.abs(Kn);
              var or = ct > 0 ? 1 : -1;
              j = ne, W = ce - or * hn * m3, _t = ne, pt = ce + or * xn * m3;
            } else
              hn = Math.sqrt(zt * zt + Ft * Ft), xn = Math.sqrt(Zt * Zt + Kn * Kn), qe = xn / (xn + hn), j = ne - Ze * m3 * (1 - qe), W = ce - ct * m3 * (1 - qe), _t = ne + Ze * m3 * qe, pt = ce + ct * m3 * qe, _t = IO(_t, EO(Oe, ne)), pt = IO(pt, EO(We, ce)), _t = EO(_t, IO(Oe, ne)), pt = EO(pt, IO(We, ce)), Ze = _t - ne, ct = pt - ce, j = ne - Ze * hn / xn, W = ce - ct * hn / xn, j = IO(j, EO(A2, ne)), W = IO(W, EO(D, ce)), j = EO(j, IO(A2, ne)), W = EO(W, IO(D, ce)), Ze = ne - j, ct = ce - W, _t = ne + Ze * xn / hn, pt = ce + ct * xn / hn;
          }
          l3.bezierCurveTo(P, N, j, W, ne, ce), P = _t, N = pt;
        } else
          l3.lineTo(ne, ce);
      }
      A2 = ne, D = ce, K += v4;
    }
    return te;
  }
  var Jht = function() {
    function l3() {
      this.smooth = 0, this.smoothConstraint = true;
    }
    return l3;
  }(), zgn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "ec-polyline", u;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new Jht();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.points, v4 = 0, m3 = h.length / 2;
      if (u.connectNulls) {
        for (; m3 > 0 && zN(h[m3 * 2 - 2], h[m3 * 2 - 1]); m3--)
          ;
        for (; v4 < m3 && zN(h[v4 * 2], h[v4 * 2 + 1]); v4++)
          ;
      }
      for (; v4 < m3; )
        v4 += _ke(e3, h, v4, m3, m3, 1, u.smooth, u.smoothMonotone, u.connectNulls) + 1;
    }, r3.prototype.getPointOn = function(e3, u) {
      this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
      for (var h = this.path, v4 = h.data, m3 = XA.CMD, x3, C, A2 = u === "x", D = [], P = 0; P < v4.length; ) {
        var N = v4[P++], j = void 0, W = void 0, K = void 0, te = void 0, ne = void 0, ce = void 0, me = void 0;
        switch (N) {
          case m3.M:
            x3 = v4[P++], C = v4[P++];
            break;
          case m3.L:
            if (j = v4[P++], W = v4[P++], me = A2 ? (e3 - x3) / (j - x3) : (e3 - C) / (W - C), me <= 1 && me >= 0) {
              var ve = A2 ? (W - C) * me + C : (j - x3) * me + x3;
              return A2 ? [e3, ve] : [ve, e3];
            }
            x3 = j, C = W;
            break;
          case m3.C:
            j = v4[P++], W = v4[P++], K = v4[P++], te = v4[P++], ne = v4[P++], ce = v4[P++];
            var Be = A2 ? Bfe(x3, j, K, ne, e3, D) : Bfe(C, W, te, ce, e3, D);
            if (Be > 0)
              for (var Oe = 0; Oe < Be; Oe++) {
                var We = D[Oe];
                if (We <= 1 && We >= 0) {
                  var ve = A2 ? i0(C, W, te, ce, We) : i0(x3, j, K, ne, We);
                  return A2 ? [e3, ve] : [ve, e3];
                }
              }
            x3 = ne, C = ce;
            break;
        }
      }
    }, r3;
  }(Nl), jgn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3;
  }(Jht), Qht = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "ec-polygon", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new jgn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.points, v4 = u.stackedOnPoints, m3 = 0, x3 = h.length / 2, C = u.smoothMonotone;
      if (u.connectNulls) {
        for (; x3 > 0 && zN(h[x3 * 2 - 2], h[x3 * 2 - 1]); x3--)
          ;
        for (; m3 < x3 && zN(h[m3 * 2], h[m3 * 2 + 1]); m3++)
          ;
      }
      for (; m3 < x3; ) {
        var A2 = _ke(e3, h, m3, x3, x3, 1, u.smooth, C, u.connectNulls);
        _ke(e3, v4, m3 + A2 - 1, A2, x3, -1, u.stackedOnSmooth, C, u.connectNulls), m3 += A2 + 1, e3.closePath();
      }
    }, r3;
  }(Nl);
  function ept(l3, r3, e3, u, h) {
    var v4 = l3.getArea(), m3 = v4.x, x3 = v4.y, C = v4.width, A2 = v4.height, D = e3.get(["lineStyle", "width"]) || 2;
    m3 -= D / 2, x3 -= D / 2, C += D, A2 += D, m3 = Math.floor(m3), C = Math.round(C);
    var P = new Ju({ shape: { x: m3, y: x3, width: C, height: A2 } });
    if (r3) {
      var N = l3.getBaseAxis(), j = N.isHorizontal(), W = N.inverse;
      j ? (W && (P.shape.x += C), P.shape.width = 0) : (W || (P.shape.y += A2), P.shape.height = 0);
      var K = Xo(h) ? function(te) {
        h(te, P);
      } : null;
      Np(P, { shape: { width: C, height: A2, x: m3, y: x3 } }, e3, null, u, K);
    }
    return P;
  }
  function tpt(l3, r3, e3) {
    var u = l3.getArea(), h = jd(u.r0, 1), v4 = jd(u.r, 1), m3 = new S_({ shape: { cx: jd(l3.cx, 1), cy: jd(l3.cy, 1), r0: h, r: v4, startAngle: u.startAngle, endAngle: u.endAngle, clockwise: u.clockwise } });
    if (r3) {
      var x3 = l3.getBaseAxis().dim === "angle";
      x3 ? m3.shape.endAngle = u.startAngle : m3.shape.r = h, Np(m3, { shape: { endAngle: u.endAngle, r: v4 } }, e3);
    }
    return m3;
  }
  function vpe(l3, r3, e3, u, h) {
    if (l3) {
      if (l3.type === "polar")
        return tpt(l3, r3, e3);
      if (l3.type === "cartesian2d")
        return ept(l3, r3, e3, u, h);
    } else
      return null;
    return null;
  }
  function a5(l3, r3) {
    return l3.type === r3;
  }
  function Qrt(l3, r3) {
    if (l3.length === r3.length) {
      for (var e3 = 0; e3 < l3.length; e3++)
        if (l3[e3] !== r3[e3])
          return;
      return true;
    }
  }
  function eit(l3) {
    for (var r3 = 1 / 0, e3 = 1 / 0, u = -1 / 0, h = -1 / 0, v4 = 0; v4 < l3.length; ) {
      var m3 = l3[v4++], x3 = l3[v4++];
      isNaN(m3) || (r3 = Math.min(m3, r3), u = Math.max(m3, u)), isNaN(x3) || (e3 = Math.min(x3, e3), h = Math.max(x3, h));
    }
    return [[r3, e3], [u, h]];
  }
  function tit(l3, r3) {
    var e3 = eit(l3), u = e3[0], h = e3[1], v4 = eit(r3), m3 = v4[0], x3 = v4[1];
    return Math.max(Math.abs(u[0] - m3[0]), Math.abs(u[1] - m3[1]), Math.abs(h[0] - x3[0]), Math.abs(h[1] - x3[1]));
  }
  function nit(l3) {
    return Vc(l3) ? l3 : l3 ? 0.5 : 0;
  }
  function Ggn(l3, r3, e3) {
    if (!e3.valueDim)
      return [];
    for (var u = r3.count(), h = VA(u * 2), v4 = 0; v4 < u; v4++) {
      var m3 = Zht(e3, l3, r3, v4);
      h[v4 * 2] = m3[0], h[v4 * 2 + 1] = m3[1];
    }
    return h;
  }
  function DO(l3, r3, e3, u) {
    var h = r3.getBaseAxis(), v4 = h.dim === "x" || h.dim === "radius" ? 0 : 1, m3 = [], x3 = 0, C = [], A2 = [], D = [], P = [];
    if (u) {
      for (x3 = 0; x3 < l3.length; x3 += 2)
        !isNaN(l3[x3]) && !isNaN(l3[x3 + 1]) && P.push(l3[x3], l3[x3 + 1]);
      l3 = P;
    }
    for (x3 = 0; x3 < l3.length - 2; x3 += 2)
      switch (D[0] = l3[x3 + 2], D[1] = l3[x3 + 3], A2[0] = l3[x3], A2[1] = l3[x3 + 1], m3.push(A2[0], A2[1]), e3) {
        case "end":
          C[v4] = D[v4], C[1 - v4] = A2[1 - v4], m3.push(C[0], C[1]);
          break;
        case "middle":
          var N = (A2[v4] + D[v4]) / 2, j = [];
          C[v4] = j[v4] = N, C[1 - v4] = A2[1 - v4], j[1 - v4] = D[1 - v4], m3.push(C[0], C[1]), m3.push(j[0], j[1]);
          break;
        default:
          C[v4] = A2[v4], C[1 - v4] = D[1 - v4], m3.push(C[0], C[1]);
      }
    return m3.push(l3[x3++], l3[x3++]), m3;
  }
  function Hgn(l3, r3) {
    var e3 = [], u = l3.length, h, v4;
    function m3(D, P, N) {
      var j = D.coord, W = (N - j) / (P.coord - j), K = Usn(W, [D.color, P.color]);
      return { coord: N, color: K };
    }
    for (var x3 = 0; x3 < u; x3++) {
      var C = l3[x3], A2 = C.coord;
      if (A2 < 0)
        h = C;
      else if (A2 > r3) {
        v4 ? e3.push(m3(v4, C, r3)) : h && e3.push(m3(h, C, 0), m3(h, C, r3));
        break;
      } else
        h && (e3.push(m3(h, C, 0)), h = null), e3.push(C), v4 = C;
    }
    return e3;
  }
  function Wgn(l3, r3, e3) {
    var u = l3.getVisual("visualMeta");
    if (!(!u || !u.length || !l3.count()) && r3.type === "cartesian2d") {
      for (var h, v4, m3 = u.length - 1; m3 >= 0; m3--) {
        var x3 = l3.getDimensionInfo(u[m3].dimension);
        if (h = x3 && x3.coordDim, h === "x" || h === "y") {
          v4 = u[m3];
          break;
        }
      }
      if (!!v4) {
        var C = r3.getAxis(h), A2 = Bi(v4.stops, function(me) {
          return { coord: C.toGlobalCoord(C.dataToCoord(me.value)), color: me.color };
        }), D = A2.length, P = v4.outerColors.slice();
        D && A2[0].coord > A2[D - 1].coord && (A2.reverse(), P.reverse());
        var N = Hgn(A2, h === "x" ? e3.getWidth() : e3.getHeight()), j = N.length;
        if (!j && D)
          return A2[0].coord < 0 ? P[1] ? P[1] : A2[D - 1].color : P[0] ? P[0] : A2[0].color;
        var W = 10, K = N[0].coord - W, te = N[j - 1].coord + W, ne = te - K;
        if (ne < 1e-3)
          return "transparent";
        mt(N, function(me) {
          me.offset = (me.coord - K) / ne;
        }), N.push({ offset: j ? N[j - 1].offset : 0.5, color: P[1] || "transparent" }), N.unshift({ offset: j ? N[0].offset : 0.5, color: P[0] || "transparent" });
        var ce = new PJ(0, 0, 0, 0, N, true);
        return ce[h] = K, ce[h + "2"] = te, ce;
      }
    }
  }
  function Ugn(l3, r3, e3) {
    var u = l3.get("showAllSymbol"), h = u === "auto";
    if (!(u && !h)) {
      var v4 = e3.getAxesByScale("ordinal")[0];
      if (!!v4 && !(h && qgn(v4, r3))) {
        var m3 = r3.mapDimension(v4.dim), x3 = {};
        return mt(v4.getViewLabels(), function(C) {
          var A2 = v4.scale.getRawOrdinalNumber(C.tickValue);
          x3[A2] = 1;
        }), function(C) {
          return !x3.hasOwnProperty(r3.get(m3, C));
        };
      }
    }
  }
  function qgn(l3, r3) {
    var e3 = l3.getExtent(), u = Math.abs(e3[1] - e3[0]) / l3.scale.count();
    isNaN(u) && (u = 0);
    for (var h = r3.count(), v4 = Math.max(1, Math.round(h / 5)), m3 = 0; m3 < h; m3 += v4)
      if (HJ.getSymbolSize(r3, m3)[l3.isHorizontal() ? 1 : 0] * 1.5 > u)
        return false;
    return true;
  }
  function $gn(l3, r3) {
    return isNaN(l3) || isNaN(r3);
  }
  function Xgn(l3) {
    for (var r3 = l3.length / 2; r3 > 0 && $gn(l3[r3 * 2 - 2], l3[r3 * 2 - 1]); r3--)
      ;
    return r3 - 1;
  }
  function rit(l3, r3) {
    return [l3[r3 * 2], l3[r3 * 2 + 1]];
  }
  function Ygn(l3, r3, e3) {
    for (var u = l3.length / 2, h = e3 === "x" ? 0 : 1, v4, m3, x3 = 0, C = -1, A2 = 0; A2 < u; A2++)
      if (m3 = l3[A2 * 2 + h], !(isNaN(m3) || isNaN(l3[A2 * 2 + 1 - h]))) {
        if (A2 === 0) {
          v4 = m3;
          continue;
        }
        if (v4 <= r3 && m3 >= r3 || v4 >= r3 && m3 <= r3) {
          C = A2;
          break;
        }
        x3 = A2, v4 = m3;
      }
    return { range: [x3, C], t: (r3 - v4) / (m3 - v4) };
  }
  function npt(l3) {
    if (l3.get(["endLabel", "show"]))
      return true;
    for (var r3 = 0; r3 < bb.length; r3++)
      if (l3.get([bb[r3], "endLabel", "show"]))
        return true;
    return false;
  }
  function QEe(l3, r3, e3, u) {
    if (a5(r3, "cartesian2d")) {
      var h = u.getModel("endLabel"), v4 = h.get("valueAnimation"), m3 = u.getData(), x3 = { lastFrameIndex: 0 }, C = npt(u) ? function(j, W) {
        l3._endLabelOnDuring(j, W, m3, x3, v4, h, r3);
      } : null, A2 = r3.getBaseAxis().isHorizontal(), D = ept(r3, e3, u, function() {
        var j = l3._endLabel;
        j && e3 && x3.originalX != null && j.attr({ x: x3.originalX, y: x3.originalY });
      }, C);
      if (!u.get("clip", true)) {
        var P = D.shape, N = Math.max(P.width, P.height);
        A2 ? (P.y -= N, P.height += N * 2) : (P.x -= N, P.width += N * 2);
      }
      return C && C(1, D), D;
    } else
      return tpt(r3, e3, u);
  }
  function Kgn(l3, r3) {
    var e3 = r3.getBaseAxis(), u = e3.isHorizontal(), h = e3.inverse, v4 = u ? h ? "right" : "left" : "center", m3 = u ? "middle" : h ? "top" : "bottom";
    return { normal: { align: l3.get("align") || v4, verticalAlign: l3.get("verticalAlign") || m3 } };
  }
  var Zgn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.init = function() {
      var e3 = new Cs(), u = new WJ();
      this.group.add(u.group), this._symbolDraw = u, this._lineGroup = e3;
    }, r3.prototype.render = function(e3, u, h) {
      var v4 = this, m3 = e3.coordinateSystem, x3 = this.group, C = e3.getData(), A2 = e3.getModel("lineStyle"), D = e3.getModel("areaStyle"), P = C.getLayout("points") || [], N = m3.type === "polar", j = this._coordSys, W = this._symbolDraw, K = this._polyline, te = this._polygon, ne = this._lineGroup, ce = e3.get("animation"), me = !D.isEmpty(), ve = D.get("origin"), Be = Kht(m3, C, ve), Oe = me && Ggn(m3, C, Be), We = e3.get("showSymbol"), Ue = e3.get("connectNulls"), qe = We && !N && Ugn(e3, C, m3), Ze = this._data;
      Ze && Ze.eachItemGraphicEl(function(Ao, oo) {
        Ao.__temp && (x3.remove(Ao), Ze.setItemGraphicEl(oo, null));
      }), We || W.remove(), x3.add(ne);
      var ct = N ? false : e3.get("step"), _t;
      m3 && m3.getArea && e3.get("clip", true) && (_t = m3.getArea(), _t.width != null ? (_t.x -= 0.1, _t.y -= 0.1, _t.width += 0.2, _t.height += 0.2) : _t.r0 && (_t.r0 -= 0.5, _t.r += 0.5)), this._clipShapeForSymbol = _t;
      var pt = Wgn(C, m3, h) || C.getVisual("style")[C.getVisual("drawType")];
      if (!(K && j.type === m3.type && ct === this._step))
        We && W.updateData(C, { isIgnore: qe, clipShape: _t, disableAnimation: true, getSymbolPoint: function(Ao) {
          return [P[Ao * 2], P[Ao * 2 + 1]];
        } }), ce && this._initSymbolLabelAnimation(C, m3, _t), ct && (P = DO(P, m3, ct, Ue), Oe && (Oe = DO(Oe, m3, ct, Ue))), K = this._newPolyline(P), me && (te = this._newPolygon(P, Oe)), N || this._initOrUpdateEndLabel(e3, m3, $N(pt)), ne.setClipPath(QEe(this, m3, true, e3));
      else {
        me && !te ? te = this._newPolygon(P, Oe) : te && !me && (ne.remove(te), te = this._polygon = null), N || this._initOrUpdateEndLabel(e3, m3, $N(pt));
        var zt = ne.getClipPath();
        if (zt) {
          var Zt = QEe(this, m3, false, e3);
          Np(zt, { shape: Zt.shape }, e3);
        } else
          ne.setClipPath(QEe(this, m3, true, e3));
        We && W.updateData(C, { isIgnore: qe, clipShape: _t, disableAnimation: true, getSymbolPoint: function(Ao) {
          return [P[Ao * 2], P[Ao * 2 + 1]];
        } }), (!Qrt(this._stackedOnPoints, Oe) || !Qrt(this._points, P)) && (ce ? this._doUpdateAnimation(C, Oe, m3, h, ct, ve, Ue) : (ct && (P = DO(P, m3, ct, Ue), Oe && (Oe = DO(Oe, m3, ct, Ue))), K.setShape({ points: P }), te && te.setShape({ points: P, stackedOnPoints: Oe })));
      }
      var Ft = e3.getModel("emphasis"), Kn = Ft.get("focus"), hn = Ft.get("blurScope"), xn = Ft.get("disabled");
      if (K.useStyle(ns(A2.getLineStyle(), { fill: "none", stroke: pt, lineJoin: "bevel" })), sm(K, e3, "lineStyle"), K.style.lineWidth > 0 && e3.get(["emphasis", "lineStyle", "width"]) === "bolder") {
        var zn = K.getState("emphasis").style;
        zn.lineWidth = +K.style.lineWidth + 1;
      }
      Ps(K).seriesIndex = e3.seriesIndex, Gd(K, Kn, hn, xn);
      var or = nit(e3.get("smooth")), vr = e3.get("smoothMonotone");
      if (K.setShape({ smooth: or, smoothMonotone: vr, connectNulls: Ue }), te) {
        var la = C.getCalculationInfo("stackedOnSeries"), Ba = 0;
        te.useStyle(ns(D.getAreaStyle(), { fill: pt, opacity: 0.7, lineJoin: "bevel", decal: C.getVisual("style").decal })), la && (Ba = nit(la.get("smooth"))), te.setShape({ smooth: or, stackedOnSmooth: Ba, smoothMonotone: vr, connectNulls: Ue }), sm(te, e3, "areaStyle"), Ps(te).seriesIndex = e3.seriesIndex, Gd(te, Kn, hn, xn);
      }
      var Lo = function(Ao) {
        v4._changePolyState(Ao);
      };
      C.eachItemGraphicEl(function(Ao) {
        Ao && (Ao.onHoverStateChange = Lo);
      }), this._polyline.onHoverStateChange = Lo, this._data = C, this._coordSys = m3, this._stackedOnPoints = Oe, this._points = P, this._step = ct, this._valueOrigin = ve, e3.get("triggerLineEvent") && (this.packEventData(e3, K), te && this.packEventData(e3, te));
    }, r3.prototype.packEventData = function(e3, u) {
      Ps(u).eventData = { componentType: "series", componentSubType: "line", componentIndex: e3.componentIndex, seriesIndex: e3.seriesIndex, seriesName: e3.name, seriesType: "line" };
    }, r3.prototype.highlight = function(e3, u, h, v4) {
      var m3 = e3.getData(), x3 = WN(m3, v4);
      if (this._changePolyState("emphasis"), !(x3 instanceof Array) && x3 != null && x3 >= 0) {
        var C = m3.getLayout("points"), A2 = m3.getItemGraphicEl(x3);
        if (!A2) {
          var D = C[x3 * 2], P = C[x3 * 2 + 1];
          if (isNaN(D) || isNaN(P) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(D, P))
            return;
          var N = e3.get("zlevel"), j = e3.get("z");
          A2 = new HJ(m3, x3), A2.x = D, A2.y = P, A2.setZ(N, j);
          var W = A2.getSymbolPath().getTextContent();
          W && (W.zlevel = N, W.z = j, W.z2 = this._polyline.z2 + 1), A2.__temp = true, m3.setItemGraphicEl(x3, A2), A2.stopSymbolAnimation(true), this.group.add(A2);
        }
        A2.highlight();
      } else
        zh.prototype.highlight.call(this, e3, u, h, v4);
    }, r3.prototype.downplay = function(e3, u, h, v4) {
      var m3 = e3.getData(), x3 = WN(m3, v4);
      if (this._changePolyState("normal"), x3 != null && x3 >= 0) {
        var C = m3.getItemGraphicEl(x3);
        C && (C.__temp ? (m3.setItemGraphicEl(x3, null), this.group.remove(C)) : C.downplay());
      } else
        zh.prototype.downplay.call(this, e3, u, h, v4);
    }, r3.prototype._changePolyState = function(e3) {
      var u = this._polygon;
      $fe(this._polyline, e3), u && $fe(u, e3);
    }, r3.prototype._newPolyline = function(e3) {
      var u = this._polyline;
      return u && this._lineGroup.remove(u), u = new zgn({ shape: { points: e3 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(u), this._polyline = u, u;
    }, r3.prototype._newPolygon = function(e3, u) {
      var h = this._polygon;
      return h && this._lineGroup.remove(h), h = new Qht({ shape: { points: e3, stackedOnPoints: u }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(h), this._polygon = h, h;
    }, r3.prototype._initSymbolLabelAnimation = function(e3, u, h) {
      var v4, m3, x3 = u.getBaseAxis(), C = x3.inverse;
      u.type === "cartesian2d" ? (v4 = x3.isHorizontal(), m3 = false) : u.type === "polar" && (v4 = x3.dim === "angle", m3 = true);
      var A2 = e3.hostModel, D = A2.get("animationDuration");
      Xo(D) && (D = D(null));
      var P = A2.get("animationDelay") || 0, N = Xo(P) ? P(null) : P;
      e3.eachItemGraphicEl(function(j, W) {
        var K = j;
        if (K) {
          var te = [j.x, j.y], ne = void 0, ce = void 0, me = void 0;
          if (h)
            if (m3) {
              var ve = h, Be = u.pointToCoord(te);
              v4 ? (ne = ve.startAngle, ce = ve.endAngle, me = -Be[1] / 180 * Math.PI) : (ne = ve.r0, ce = ve.r, me = Be[0]);
            } else {
              var Oe = h;
              v4 ? (ne = Oe.x, ce = Oe.x + Oe.width, me = j.x) : (ne = Oe.y + Oe.height, ce = Oe.y, me = j.y);
            }
          var We = ce === ne ? 0 : (me - ne) / (ce - ne);
          C && (We = 1 - We);
          var Ue = Xo(P) ? P(W) : D * We + N, qe = K.getSymbolPath(), Ze = qe.getTextContent();
          K.attr({ scaleX: 0, scaleY: 0 }), K.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: Ue }), Ze && Ze.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: Ue }), qe.disableLabelAnimation = true;
        }
      });
    }, r3.prototype._initOrUpdateEndLabel = function(e3, u, h) {
      var v4 = e3.getModel("endLabel");
      if (npt(e3)) {
        var m3 = e3.getData(), x3 = this._polyline, C = m3.getLayout("points");
        if (!C) {
          x3.removeTextContent(), this._endLabel = null;
          return;
        }
        var A2 = this._endLabel;
        A2 || (A2 = this._endLabel = new Ec({ z2: 200 }), A2.ignoreClip = true, x3.setTextContent(this._endLabel), x3.disableLabelAnimation = true);
        var D = Xgn(C);
        D >= 0 && (_1(x3, ny(e3, "endLabel"), { inheritColor: h, labelFetcher: e3, labelDataIndex: D, defaultText: function(P, N, j) {
          return j != null ? Yht(m3, j) : dj(m3, P);
        }, enableTextSetter: true }, Kgn(v4, u)), x3.textConfig.position = null);
      } else
        this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
    }, r3.prototype._endLabelOnDuring = function(e3, u, h, v4, m3, x3, C) {
      var A2 = this._endLabel, D = this._polyline;
      if (A2) {
        e3 < 1 && v4.originalX == null && (v4.originalX = A2.x, v4.originalY = A2.y);
        var P = h.getLayout("points"), N = h.hostModel, j = N.get("connectNulls"), W = x3.get("precision"), K = x3.get("distance") || 0, te = C.getBaseAxis(), ne = te.isHorizontal(), ce = te.inverse, me = u.shape, ve = ce ? ne ? me.x : me.y + me.height : ne ? me.x + me.width : me.y, Be = (ne ? K : 0) * (ce ? -1 : 1), Oe = (ne ? 0 : -K) * (ce ? -1 : 1), We = ne ? "x" : "y", Ue = Ygn(P, ve, We), qe = Ue.range, Ze = qe[1] - qe[0], ct = void 0;
        if (Ze >= 1) {
          if (Ze > 1 && !j) {
            var _t = rit(P, qe[0]);
            A2.attr({ x: _t[0] + Be, y: _t[1] + Oe }), m3 && (ct = N.getRawValue(qe[0]));
          } else {
            var _t = D.getPointOn(ve, We);
            _t && A2.attr({ x: _t[0] + Be, y: _t[1] + Oe });
            var pt = N.getRawValue(qe[0]), zt = N.getRawValue(qe[1]);
            m3 && (ct = Sut(h, W, pt, zt, Ue.t));
          }
          v4.lastFrameIndex = qe[0];
        } else {
          var Zt = e3 === 1 || v4.lastFrameIndex > 0 ? qe[0] : 0, _t = rit(P, Zt);
          m3 && (ct = N.getRawValue(Zt)), A2.attr({ x: _t[0] + Be, y: _t[1] + Oe });
        }
        m3 && Mj(A2).setLabelText(ct);
      }
    }, r3.prototype._doUpdateAnimation = function(e3, u, h, v4, m3, x3, C) {
      var A2 = this._polyline, D = this._polygon, P = e3.hostModel, N = Bgn(this._data, e3, this._stackedOnPoints, u, this._coordSys, h, this._valueOrigin), j = N.current, W = N.stackedOnCurrent, K = N.next, te = N.stackedOnNext;
      if (m3 && (j = DO(N.current, h, m3, C), W = DO(N.stackedOnCurrent, h, m3, C), K = DO(N.next, h, m3, C), te = DO(N.stackedOnNext, h, m3, C)), tit(j, K) > 3e3 || D && tit(W, te) > 3e3) {
        A2.stopAnimation(), A2.setShape({ points: K }), D && (D.stopAnimation(), D.setShape({ points: K, stackedOnPoints: te }));
        return;
      }
      A2.shape.__points = N.current, A2.shape.points = j;
      var ne = { shape: { points: K } };
      N.current !== j && (ne.shape.__points = N.next), A2.stopAnimation(), hc(A2, ne, P), D && (D.setShape({ points: j, stackedOnPoints: W }), D.stopAnimation(), hc(D, { shape: { stackedOnPoints: te } }, P), A2.shape.points !== D.shape.points && (D.shape.points = A2.shape.points));
      for (var ce = [], me = N.status, ve = 0; ve < me.length; ve++) {
        var Be = me[ve].cmd;
        if (Be === "=") {
          var Oe = e3.getItemGraphicEl(me[ve].idx1);
          Oe && ce.push({ el: Oe, ptIdx: ve });
        }
      }
      A2.animators && A2.animators.length && A2.animators[0].during(function() {
        D && D.dirtyShape();
        for (var We = A2.shape.__points, Ue = 0; Ue < ce.length; Ue++) {
          var qe = ce[Ue].el, Ze = ce[Ue].ptIdx * 2;
          qe.x = We[Ze], qe.y = We[Ze + 1], qe.markRedraw();
        }
      });
    }, r3.prototype.remove = function(e3) {
      var u = this.group, h = this._data;
      this._lineGroup.removeAll(), this._symbolDraw.remove(true), h && h.eachItemGraphicEl(function(v4, m3) {
        v4.__temp && (u.remove(v4), h.setItemGraphicEl(m3, null));
      }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
    }, r3.type = "line", r3;
  }(zh), Jgn = Zgn;
  function UJ(l3, r3) {
    return { seriesType: l3, plan: kj(), reset: function(e3) {
      var u = e3.getData(), h = e3.coordinateSystem, v4 = e3.pipelineContext, m3 = r3 || v4.large;
      if (!!h) {
        var x3 = Bi(h.dimensions, function(j) {
          return u.mapDimension(j);
        }).slice(0, 2), C = x3.length, A2 = u.getCalculationInfo("stackResultDimension");
        eP(u, x3[0]) && (x3[0] = A2), eP(u, x3[1]) && (x3[1] = A2);
        var D = u.getStore(), P = u.getDimensionIndex(x3[0]), N = u.getDimensionIndex(x3[1]);
        return C && { progress: function(j, W) {
          for (var K = j.end - j.start, te = m3 && VA(K * C), ne = [], ce = [], me = j.start, ve = 0; me < j.end; me++) {
            var Be = void 0;
            if (C === 1) {
              var Oe = D.get(P, me);
              Be = h.dataToPoint(Oe, null, ce);
            } else
              ne[0] = D.get(P, me), ne[1] = D.get(N, me), Be = h.dataToPoint(ne, null, ce);
            m3 ? (te[ve++] = Be[0], te[ve++] = Be[1]) : W.setItemLayout(me, Be.slice());
          }
          m3 && W.setLayout("points", te);
        } };
      }
    } };
  }
  var Qgn = { average: function(l3) {
    for (var r3 = 0, e3 = 0, u = 0; u < l3.length; u++)
      isNaN(l3[u]) || (r3 += l3[u], e3++);
    return e3 === 0 ? NaN : r3 / e3;
  }, sum: function(l3) {
    for (var r3 = 0, e3 = 0; e3 < l3.length; e3++)
      r3 += l3[e3] || 0;
    return r3;
  }, max: function(l3) {
    for (var r3 = -1 / 0, e3 = 0; e3 < l3.length; e3++)
      l3[e3] > r3 && (r3 = l3[e3]);
    return isFinite(r3) ? r3 : NaN;
  }, min: function(l3) {
    for (var r3 = 1 / 0, e3 = 0; e3 < l3.length; e3++)
      l3[e3] < r3 && (r3 = l3[e3]);
    return isFinite(r3) ? r3 : NaN;
  }, nearest: function(l3) {
    return l3[0];
  } }, e0n = function(l3) {
    return Math.round(l3.length / 2);
  };
  function rpt(l3) {
    return { seriesType: l3, reset: function(r3, e3, u) {
      var h = r3.getData(), v4 = r3.get("sampling"), m3 = r3.coordinateSystem, x3 = h.count();
      if (x3 > 10 && m3.type === "cartesian2d" && v4) {
        var C = m3.getBaseAxis(), A2 = m3.getOtherAxis(C), D = C.getExtent(), P = u.getDevicePixelRatio(), N = Math.abs(D[1] - D[0]) * (P || 1), j = Math.round(x3 / N);
        if (isFinite(j) && j > 1) {
          v4 === "lttb" && r3.setData(h.lttbDownSample(h.mapDimension(A2.dim), 1 / j));
          var W = void 0;
          qa(v4) ? W = Qgn[v4] : Xo(v4) && (W = v4), W && r3.setData(h.downSample(h.mapDimension(A2.dim), 1 / j, W, e0n));
        }
      }
    } };
  }
  function t0n(l3) {
    l3.registerChartView(Jgn), l3.registerSeriesModel(Pgn), l3.registerLayout(UJ("line", true)), l3.registerVisual({ seriesType: "line", reset: function(r3) {
      var e3 = r3.getData(), u = r3.getModel("lineStyle").getLineStyle();
      u && !u.stroke && (u.stroke = e3.getVisual("style").fill), e3.setVisual("legendLineStyle", u);
    } }), l3.registerProcessor(l3.PRIORITY.PROCESSOR.STATISTIC, rpt("line"));
  }
  var ipt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      return v5(null, this, { useEncodeDefaulter: true });
    }, r3.prototype.getMarkerPosition = function(e3) {
      var u = this.coordinateSystem;
      if (u && u.clampData) {
        var h = u.dataToPoint(u.clampData(e3)), v4 = this.getData(), m3 = v4.getLayout("offset"), x3 = v4.getLayout("size"), C = u.getBaseAxis().isHorizontal() ? 0 : 1;
        return h[C] += m3 + x3 / 2, h;
      }
      return [NaN, NaN];
    }, r3.type = "series.__base_bar__", r3.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, r3;
  }(Fp);
  Fp.registerClass(ipt);
  var hhe = ipt, n0n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.getInitialData = function() {
      return v5(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
    }, r3.prototype.getProgressive = function() {
      return this.get("large") ? this.get("progressive") : false;
    }, r3.prototype.getProgressiveThreshold = function() {
      var e3 = this.get("progressiveThreshold"), u = this.get("largeThreshold");
      return u > e3 && (e3 = u), e3;
    }, r3.prototype.brushSelector = function(e3, u, h) {
      return h.rect(u.getItemLayout(e3));
    }, r3.type = "series.bar", r3.dependencies = ["grid", "polar"], r3.defaultOption = sP(hhe.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), r3;
  }(hhe), r0n = n0n, i0n = function() {
    function l3() {
      this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
    }
    return l3;
  }(), a0n = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "sausage", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new i0n();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.cx, v4 = u.cy, m3 = Math.max(u.r0 || 0, 0), x3 = Math.max(u.r, 0), C = (x3 - m3) * 0.5, A2 = m3 + C, D = u.startAngle, P = u.endAngle, N = u.clockwise, j = Math.PI * 2, W = N ? P - D < j : D - P < j;
      W || (D = P - (N ? j : -j));
      var K = Math.cos(D), te = Math.sin(D), ne = Math.cos(P), ce = Math.sin(P);
      W ? (e3.moveTo(K * m3 + h, te * m3 + v4), e3.arc(K * A2 + h, te * A2 + v4, C, -Math.PI + D, D, !N)) : e3.moveTo(K * x3 + h, te * x3 + v4), e3.arc(h, v4, x3, D, P, !N), e3.arc(ne * A2 + h, ce * A2 + v4, C, P - Math.PI * 2, P - Math.PI, !N), m3 !== 0 && e3.arc(h, v4, m3, P, D, N);
    }, r3;
  }(Nl), phe = a0n;
  function o0n(l3, r3) {
    r3 = r3 || {};
    var e3 = r3.isRoundCap;
    return function(u, h, v4) {
      var m3 = h.position;
      if (!m3 || m3 instanceof Array)
        return Wfe(u, h, v4);
      var x3 = l3(m3), C = h.distance != null ? h.distance : 5, A2 = this.shape, D = A2.cx, P = A2.cy, N = A2.r, j = A2.r0, W = (N + j) / 2, K = A2.startAngle, te = A2.endAngle, ne = (K + te) / 2, ce = e3 ? Math.abs(N - j) / 2 : 0, me = Math.cos, ve = Math.sin, Be = D + N * me(K), Oe = P + N * ve(K), We = "left", Ue = "top";
      switch (x3) {
        case "startArc":
          Be = D + (j - C) * me(ne), Oe = P + (j - C) * ve(ne), We = "center", Ue = "top";
          break;
        case "insideStartArc":
          Be = D + (j + C) * me(ne), Oe = P + (j + C) * ve(ne), We = "center", Ue = "bottom";
          break;
        case "startAngle":
          Be = D + W * me(K) + Gce(K, C + ce, false), Oe = P + W * ve(K) + Hce(K, C + ce, false), We = "right", Ue = "middle";
          break;
        case "insideStartAngle":
          Be = D + W * me(K) + Gce(K, -C + ce, false), Oe = P + W * ve(K) + Hce(K, -C + ce, false), We = "left", Ue = "middle";
          break;
        case "middle":
          Be = D + W * me(ne), Oe = P + W * ve(ne), We = "center", Ue = "middle";
          break;
        case "endArc":
          Be = D + (N + C) * me(ne), Oe = P + (N + C) * ve(ne), We = "center", Ue = "bottom";
          break;
        case "insideEndArc":
          Be = D + (N - C) * me(ne), Oe = P + (N - C) * ve(ne), We = "center", Ue = "top";
          break;
        case "endAngle":
          Be = D + W * me(te) + Gce(te, C + ce, true), Oe = P + W * ve(te) + Hce(te, C + ce, true), We = "left", Ue = "middle";
          break;
        case "insideEndAngle":
          Be = D + W * me(te) + Gce(te, -C + ce, true), Oe = P + W * ve(te) + Hce(te, -C + ce, true), We = "right", Ue = "middle";
          break;
        default:
          return Wfe(u, h, v4);
      }
      return u = u || {}, u.x = Be, u.y = Oe, u.align = We, u.verticalAlign = Ue, u;
    };
  }
  function s0n(l3, r3, e3, u) {
    if (Vc(u)) {
      l3.setTextConfig({ rotation: u });
      return;
    } else if (Ni(r3)) {
      l3.setTextConfig({ rotation: 0 });
      return;
    }
    var h = l3.shape, v4 = h.clockwise ? h.startAngle : h.endAngle, m3 = h.clockwise ? h.endAngle : h.startAngle, x3 = (v4 + m3) / 2, C, A2 = e3(r3);
    switch (A2) {
      case "startArc":
      case "insideStartArc":
      case "middle":
      case "insideEndArc":
      case "endArc":
        C = x3;
        break;
      case "startAngle":
      case "insideStartAngle":
        C = v4;
        break;
      case "endAngle":
      case "insideEndAngle":
        C = m3;
        break;
      default:
        l3.setTextConfig({ rotation: 0 });
        return;
    }
    var D = Math.PI * 1.5 - C;
    A2 === "middle" && D > Math.PI / 2 && D < Math.PI * 1.5 && (D -= Math.PI), l3.setTextConfig({ rotation: D });
  }
  function Gce(l3, r3, e3) {
    return r3 * Math.sin(l3) * (e3 ? -1 : 1);
  }
  function Hce(l3, r3, e3) {
    return r3 * Math.cos(l3) * (e3 ? 1 : -1);
  }
  var eDe = Math.max, tDe = Math.min;
  function l0n(l3, r3) {
    var e3 = l3.getArea && l3.getArea();
    if (a5(l3, "cartesian2d")) {
      var u = l3.getBaseAxis();
      if (u.type !== "category" || !u.onBand) {
        var h = r3.getLayout("bandWidth");
        u.isHorizontal() ? (e3.x -= h, e3.width += h * 2) : (e3.y -= h, e3.height += h * 2);
      }
    }
    return e3;
  }
  var u0n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3.call(this) || this;
      return e3.type = r3.type, e3._isFirstFrame = true, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      this._model = e3, this._removeOnRenderedListener(h), this._updateDrawMode(e3);
      var m3 = e3.get("coordinateSystem");
      (m3 === "cartesian2d" || m3 === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(e3, u, h) : this._renderNormal(e3, u, h, v4));
    }, r3.prototype.incrementalPrepareRender = function(e3) {
      this._clear(), this._updateDrawMode(e3), this._updateLargeClip(e3);
    }, r3.prototype.incrementalRender = function(e3, u) {
      this._progressiveEls = [], this._incrementalRenderLarge(e3, u);
    }, r3.prototype.eachRendered = function(e3) {
      oP(this._progressiveEls || this.group, e3);
    }, r3.prototype._updateDrawMode = function(e3) {
      var u = e3.pipelineContext.large;
      (this._isLargeDraw == null || u !== this._isLargeDraw) && (this._isLargeDraw = u, this._clear());
    }, r3.prototype._renderNormal = function(e3, u, h, v4) {
      var m3 = this.group, x3 = e3.getData(), C = this._data, A2 = e3.coordinateSystem, D = A2.getBaseAxis(), P;
      A2.type === "cartesian2d" ? P = D.isHorizontal() : A2.type === "polar" && (P = D.dim === "angle");
      var N = e3.isAnimationEnabled() ? e3 : null, j = c0n(e3, A2);
      j && this._enableRealtimeSort(j, x3, h);
      var W = e3.get("clip", true) || j, K = l0n(A2, x3);
      m3.removeClipPath();
      var te = e3.get("roundCap", true), ne = e3.get("showBackground", true), ce = e3.getModel("backgroundStyle"), me = ce.get("borderRadius") || 0, ve = [], Be = this._backgroundEls, Oe = v4 && v4.isInitSort, We = v4 && v4.type === "changeAxisOrder";
      function Ue(ct) {
        var _t = Wce[A2.type](x3, ct), pt = y0n(A2, P, _t);
        return pt.useStyle(ce.getItemStyle()), A2.type === "cartesian2d" && pt.setShape("r", me), ve[ct] = pt, pt;
      }
      x3.diff(C).add(function(ct) {
        var _t = x3.getItemModel(ct), pt = Wce[A2.type](x3, ct, _t);
        if (ne && Ue(ct), !(!x3.hasValue(ct) || !lit[A2.type](pt))) {
          var zt = false;
          W && (zt = iit[A2.type](K, pt));
          var Zt = ait[A2.type](e3, x3, ct, pt, P, N, D.model, false, te);
          j && (Zt.forceLabelAnimation = true), uit(Zt, x3, ct, _t, pt, e3, P, A2.type === "polar"), Oe ? Zt.attr({ shape: pt }) : j ? oit(j, N, Zt, pt, ct, P, false, false) : Np(Zt, { shape: pt }, e3, ct), x3.setItemGraphicEl(ct, Zt), m3.add(Zt), Zt.ignore = zt;
        }
      }).update(function(ct, _t) {
        var pt = x3.getItemModel(ct), zt = Wce[A2.type](x3, ct, pt);
        if (ne) {
          var Zt = void 0;
          Be.length === 0 ? Zt = Ue(_t) : (Zt = Be[_t], Zt.useStyle(ce.getItemStyle()), A2.type === "cartesian2d" && Zt.setShape("r", me), ve[ct] = Zt);
          var Ft = Wce[A2.type](x3, ct), Kn = opt(P, Ft, A2);
          hc(Zt, { shape: Kn }, N, ct);
        }
        var hn = C.getItemGraphicEl(_t);
        if (!x3.hasValue(ct) || !lit[A2.type](zt)) {
          m3.remove(hn);
          return;
        }
        var xn = false;
        if (W && (xn = iit[A2.type](K, zt), xn && m3.remove(hn)), hn ? yM(hn) : hn = ait[A2.type](e3, x3, ct, zt, P, N, D.model, !!hn, te), j && (hn.forceLabelAnimation = true), We) {
          var zn = hn.getTextContent();
          if (zn) {
            var or = Mj(zn);
            or.prevValue != null && (or.prevValue = or.value);
          }
        } else
          uit(hn, x3, ct, pt, zt, e3, P, A2.type === "polar");
        Oe ? hn.attr({ shape: zt }) : j ? oit(j, N, hn, zt, ct, P, true, We) : hc(hn, { shape: zt }, e3, ct, null), x3.setItemGraphicEl(ct, hn), hn.ignore = xn, m3.add(hn);
      }).remove(function(ct) {
        var _t = C.getItemGraphicEl(ct);
        _t && aJ(_t, e3, ct);
      }).execute();
      var qe = this._backgroundGroup || (this._backgroundGroup = new Cs());
      qe.removeAll();
      for (var Ze = 0; Ze < ve.length; ++Ze)
        qe.add(ve[Ze]);
      m3.add(qe), this._backgroundEls = ve, this._data = x3;
    }, r3.prototype._renderLarge = function(e3, u, h) {
      this._clear(), fit(e3, this.group), this._updateLargeClip(e3);
    }, r3.prototype._incrementalRenderLarge = function(e3, u) {
      this._removeBackground(), fit(u, this.group, this._progressiveEls, true);
    }, r3.prototype._updateLargeClip = function(e3) {
      var u = e3.get("clip", true) && vpe(e3.coordinateSystem, false, e3), h = this.group;
      u ? h.setClipPath(u) : h.removeClipPath();
    }, r3.prototype._enableRealtimeSort = function(e3, u, h) {
      var v4 = this;
      if (!!u.count()) {
        var m3 = e3.baseAxis;
        if (this._isFirstFrame)
          this._dispatchInitSort(u, e3, h), this._isFirstFrame = false;
        else {
          var x3 = function(C) {
            var A2 = u.getItemGraphicEl(C), D = A2 && A2.shape;
            return D && Math.abs(m3.isHorizontal() ? D.height : D.width) || 0;
          };
          this._onRendered = function() {
            v4._updateSortWithinSameData(u, x3, m3, h);
          }, h.getZr().on("rendered", this._onRendered);
        }
      }
    }, r3.prototype._dataSort = function(e3, u, h) {
      var v4 = [];
      return e3.each(e3.mapDimension(u.dim), function(m3, x3) {
        var C = h(x3);
        C = C == null ? NaN : C, v4.push({ dataIndex: x3, mappedValue: C, ordinalNumber: m3 });
      }), v4.sort(function(m3, x3) {
        return x3.mappedValue - m3.mappedValue;
      }), { ordinalNumbers: Bi(v4, function(m3) {
        return m3.ordinalNumber;
      }) };
    }, r3.prototype._isOrderChangedWithinSameData = function(e3, u, h) {
      for (var v4 = h.scale, m3 = e3.mapDimension(h.dim), x3 = Number.MAX_VALUE, C = 0, A2 = v4.getOrdinalMeta().categories.length; C < A2; ++C) {
        var D = e3.rawIndexOf(m3, v4.getRawOrdinalNumber(C)), P = D < 0 ? Number.MIN_VALUE : u(e3.indexOfRawIndex(D));
        if (P > x3)
          return true;
        x3 = P;
      }
      return false;
    }, r3.prototype._isOrderDifferentInView = function(e3, u) {
      for (var h = u.scale, v4 = h.getExtent(), m3 = Math.max(0, v4[0]), x3 = Math.min(v4[1], h.getOrdinalMeta().categories.length - 1); m3 <= x3; ++m3)
        if (e3.ordinalNumbers[m3] !== h.getRawOrdinalNumber(m3))
          return true;
    }, r3.prototype._updateSortWithinSameData = function(e3, u, h, v4) {
      if (!!this._isOrderChangedWithinSameData(e3, u, h)) {
        var m3 = this._dataSort(e3, h, u);
        this._isOrderDifferentInView(m3, h) && (this._removeOnRenderedListener(v4), v4.dispatchAction({ type: "changeAxisOrder", componentType: h.dim + "Axis", axisId: h.index, sortInfo: m3 }));
      }
    }, r3.prototype._dispatchInitSort = function(e3, u, h) {
      var v4 = u.baseAxis, m3 = this._dataSort(e3, v4, function(x3) {
        return e3.get(e3.mapDimension(u.otherAxis.dim), x3);
      });
      h.dispatchAction({ type: "changeAxisOrder", componentType: v4.dim + "Axis", isInitSort: true, axisId: v4.index, sortInfo: m3 });
    }, r3.prototype.remove = function(e3, u) {
      this._clear(this._model), this._removeOnRenderedListener(u);
    }, r3.prototype.dispose = function(e3, u) {
      this._removeOnRenderedListener(u);
    }, r3.prototype._removeOnRenderedListener = function(e3) {
      this._onRendered && (e3.getZr().off("rendered", this._onRendered), this._onRendered = null);
    }, r3.prototype._clear = function(e3) {
      var u = this.group, h = this._data;
      e3 && e3.isAnimationEnabled() && h && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], h.eachItemGraphicEl(function(v4) {
        aJ(v4, e3, Ps(v4).dataIndex);
      })) : u.removeAll(), this._data = null, this._isFirstFrame = true;
    }, r3.prototype._removeBackground = function() {
      this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
    }, r3.type = "bar", r3;
  }(zh), iit = { cartesian2d: function(l3, r3) {
    var e3 = r3.width < 0 ? -1 : 1, u = r3.height < 0 ? -1 : 1;
    e3 < 0 && (r3.x += r3.width, r3.width = -r3.width), u < 0 && (r3.y += r3.height, r3.height = -r3.height);
    var h = l3.x + l3.width, v4 = l3.y + l3.height, m3 = eDe(r3.x, l3.x), x3 = tDe(r3.x + r3.width, h), C = eDe(r3.y, l3.y), A2 = tDe(r3.y + r3.height, v4), D = x3 < m3, P = A2 < C;
    return r3.x = D && m3 > h ? x3 : m3, r3.y = P && C > v4 ? A2 : C, r3.width = D ? 0 : x3 - m3, r3.height = P ? 0 : A2 - C, e3 < 0 && (r3.x += r3.width, r3.width = -r3.width), u < 0 && (r3.y += r3.height, r3.height = -r3.height), D || P;
  }, polar: function(l3, r3) {
    var e3 = r3.r0 <= r3.r ? 1 : -1;
    if (e3 < 0) {
      var u = r3.r;
      r3.r = r3.r0, r3.r0 = u;
    }
    var h = tDe(r3.r, l3.r), v4 = eDe(r3.r0, l3.r0);
    r3.r = h, r3.r0 = v4;
    var m3 = h - v4 < 0;
    if (e3 < 0) {
      var u = r3.r;
      r3.r = r3.r0, r3.r0 = u;
    }
    return m3;
  } }, ait = { cartesian2d: function(l3, r3, e3, u, h, v4, m3, x3, C) {
    var A2 = new Ju({ shape: fi({}, u), z2: 1 });
    if (A2.__dataIndex = e3, A2.name = "item", v4) {
      var D = A2.shape, P = h ? "height" : "width";
      D[P] = 0;
    }
    return A2;
  }, polar: function(l3, r3, e3, u, h, v4, m3, x3, C) {
    var A2 = !h && C ? phe : S_, D = new A2({ shape: u, z2: 1 });
    D.name = "item";
    var P = apt(h);
    if (D.calculateTextPosition = o0n(P, { isRoundCap: A2 === phe }), v4) {
      var N = D.shape, j = h ? "r" : "endAngle", W = {};
      N[j] = h ? 0 : u.startAngle, W[j] = u[j], (x3 ? hc : Np)(D, { shape: W }, v4);
    }
    return D;
  } };
  function c0n(l3, r3) {
    var e3 = l3.get("realtimeSort", true), u = r3.getBaseAxis();
    if (e3 && u.type === "category" && r3.type === "cartesian2d")
      return { baseAxis: u, otherAxis: r3.getOtherAxis(u) };
  }
  function oit(l3, r3, e3, u, h, v4, m3, x3) {
    var C, A2;
    v4 ? (A2 = { x: u.x, width: u.width }, C = { y: u.y, height: u.height }) : (A2 = { y: u.y, height: u.height }, C = { x: u.x, width: u.width }), x3 || (m3 ? hc : Np)(e3, { shape: C }, r3, h, null);
    var D = r3 ? l3.baseAxis.model : null;
    (m3 ? hc : Np)(e3, { shape: A2 }, D, h);
  }
  function sit(l3, r3) {
    for (var e3 = 0; e3 < r3.length; e3++)
      if (!isFinite(l3[r3[e3]]))
        return true;
    return false;
  }
  var f0n = ["x", "y", "width", "height"], h0n = ["cx", "cy", "r", "startAngle", "endAngle"], lit = { cartesian2d: function(l3) {
    return !sit(l3, f0n);
  }, polar: function(l3) {
    return !sit(l3, h0n);
  } }, Wce = { cartesian2d: function(l3, r3, e3) {
    var u = l3.getItemLayout(r3), h = e3 ? d0n(e3, u) : 0, v4 = u.width > 0 ? 1 : -1, m3 = u.height > 0 ? 1 : -1;
    return { x: u.x + v4 * h / 2, y: u.y + m3 * h / 2, width: u.width - v4 * h, height: u.height - m3 * h };
  }, polar: function(l3, r3, e3) {
    var u = l3.getItemLayout(r3);
    return { cx: u.cx, cy: u.cy, r0: u.r0, r: u.r, startAngle: u.startAngle, endAngle: u.endAngle, clockwise: u.clockwise };
  } };
  function p0n(l3) {
    return l3.startAngle != null && l3.endAngle != null && l3.startAngle === l3.endAngle;
  }
  function apt(l3) {
    return function(r3) {
      var e3 = r3 ? "Arc" : "Angle";
      return function(u) {
        switch (u) {
          case "start":
          case "insideStart":
          case "end":
          case "insideEnd":
            return u + e3;
          default:
            return u;
        }
      };
    }(l3);
  }
  function uit(l3, r3, e3, u, h, v4, m3, x3) {
    var C = r3.getItemVisual(e3, "style");
    x3 || l3.setShape("r", u.get(["itemStyle", "borderRadius"]) || 0), l3.useStyle(C);
    var A2 = u.getShallow("cursor");
    A2 && l3.attr("cursor", A2);
    var D = x3 ? m3 ? h.r >= h.r0 ? "endArc" : "startArc" : h.endAngle >= h.startAngle ? "endAngle" : "startAngle" : m3 ? h.height >= 0 ? "bottom" : "top" : h.width >= 0 ? "right" : "left", P = ny(u);
    _1(l3, P, { labelFetcher: v4, labelDataIndex: e3, defaultText: dj(v4.getData(), e3), inheritColor: C.fill, defaultOpacity: C.opacity, defaultOutsidePosition: D });
    var N = l3.getTextContent();
    if (x3 && N) {
      var j = u.get(["label", "position"]);
      l3.textConfig.inside = j === "middle" ? true : null, s0n(l3, j === "outside" ? D : j, apt(m3), u.get(["label", "rotate"]));
    }
    xct(N, P, v4.getRawValue(e3), function(K) {
      return Yht(r3, K);
    });
    var W = u.getModel(["emphasis"]);
    Gd(l3, W.get("focus"), W.get("blurScope"), W.get("disabled")), sm(l3, u), p0n(h) && (l3.style.fill = "none", l3.style.stroke = "none", mt(l3.states, function(K) {
      K.style && (K.style.fill = K.style.stroke = "none");
    }));
  }
  function d0n(l3, r3) {
    var e3 = l3.get(["itemStyle", "borderColor"]);
    if (!e3 || e3 === "none")
      return 0;
    var u = l3.get(["itemStyle", "borderWidth"]) || 0, h = isNaN(r3.width) ? Number.MAX_VALUE : Math.abs(r3.width), v4 = isNaN(r3.height) ? Number.MAX_VALUE : Math.abs(r3.height);
    return Math.min(u, h, v4);
  }
  var v0n = function() {
    function l3() {
    }
    return l3;
  }(), cit = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "largeBar", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new v0n();
    }, r3.prototype.buildPath = function(e3, u) {
      for (var h = u.points, v4 = this.baseDimIdx, m3 = 1 - this.baseDimIdx, x3 = [], C = [], A2 = this.barWidth, D = 0; D < h.length; D += 3)
        C[v4] = A2, C[m3] = h[D + 2], x3[v4] = h[D + v4], x3[m3] = h[D + m3], e3.rect(x3[0], x3[1], C[0], C[1]);
    }, r3;
  }(Nl);
  function fit(l3, r3, e3, u) {
    var h = l3.getData(), v4 = h.getLayout("valueAxisHorizontal") ? 1 : 0, m3 = h.getLayout("largeDataIndices"), x3 = h.getLayout("size"), C = l3.getModel("backgroundStyle"), A2 = h.getLayout("largeBackgroundPoints");
    if (A2) {
      var D = new cit({ shape: { points: A2 }, incremental: !!u, silent: true, z2: 0 });
      D.baseDimIdx = v4, D.largeDataIndices = m3, D.barWidth = x3, D.useStyle(C.getItemStyle()), r3.add(D), e3 && e3.push(D);
    }
    var P = new cit({ shape: { points: h.getLayout("largePoints") }, incremental: !!u, z2: 1 });
    P.baseDimIdx = v4, P.largeDataIndices = m3, P.barWidth = x3, r3.add(P), P.useStyle(h.getVisual("style")), Ps(P).seriesIndex = l3.seriesIndex, l3.get("silent") || (P.on("mousedown", hit), P.on("mousemove", hit)), e3 && e3.push(P);
  }
  var hit = hOe(function(l3) {
    var r3 = this, e3 = g0n(r3, l3.offsetX, l3.offsetY);
    Ps(r3).dataIndex = e3 >= 0 ? e3 : null;
  }, 30, false);
  function g0n(l3, r3, e3) {
    for (var u = l3.baseDimIdx, h = 1 - u, v4 = l3.shape.points, m3 = l3.largeDataIndices, x3 = [], C = [], A2 = l3.barWidth, D = 0, P = v4.length / 3; D < P; D++) {
      var N = D * 3;
      if (C[u] = A2, C[h] = v4[N + 2], x3[u] = v4[N + u], x3[h] = v4[N + h], C[h] < 0 && (x3[h] += C[h], C[h] = -C[h]), r3 >= x3[0] && r3 <= x3[0] + C[0] && e3 >= x3[1] && e3 <= x3[1] + C[1])
        return m3[D];
    }
    return -1;
  }
  function opt(l3, r3, e3) {
    if (a5(e3, "cartesian2d")) {
      var u = r3, h = e3.getArea();
      return { x: l3 ? u.x : h.x, y: l3 ? h.y : u.y, width: l3 ? u.width : h.width, height: l3 ? h.height : u.height };
    } else {
      var h = e3.getArea(), v4 = r3;
      return { cx: h.cx, cy: h.cy, r0: l3 ? h.r0 : v4.r0, r: l3 ? h.r : v4.r, startAngle: l3 ? v4.startAngle : 0, endAngle: l3 ? v4.endAngle : Math.PI * 2 };
    }
  }
  function y0n(l3, r3, e3) {
    var u = l3.type === "polar" ? S_ : Ju;
    return new u({ shape: opt(r3, e3, l3), silent: true, z2: 0 });
  }
  var m0n = u0n;
  function b0n(l3) {
    l3.registerChartView(m0n), l3.registerSeriesModel(r0n), l3.registerLayout(l3.PRIORITY.VISUAL.LAYOUT, Fs(hht, "bar")), l3.registerLayout(l3.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, pht("bar")), l3.registerProcessor(l3.PRIORITY.PROCESSOR.STATISTIC, rpt("bar")), l3.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(r3, e3) {
      var u = r3.componentType || "series";
      e3.eachComponent({ mainType: u, query: r3 }, function(h) {
        r3.sortInfo && h.axis.setCategorySortInfo(r3.sortInfo);
      });
    });
  }
  var Uce = Math.PI * 2, pit = Math.PI / 180;
  function spt(l3, r3) {
    return dg(l3.getBoxLayoutParams(), { width: r3.getWidth(), height: r3.getHeight() });
  }
  function lpt(l3, r3) {
    var e3 = spt(l3, r3), u = l3.get("center"), h = l3.get("radius");
    Ni(h) || (h = [0, h]), Ni(u) || (u = [u, u]);
    var v4 = za(e3.width, r3.getWidth()), m3 = za(e3.height, r3.getHeight()), x3 = Math.min(v4, m3), C = za(u[0], v4) + e3.x, A2 = za(u[1], m3) + e3.y, D = za(h[0], x3 / 2), P = za(h[1], x3 / 2);
    return { cx: C, cy: A2, r0: D, r: P };
  }
  function _0n(l3, r3, e3) {
    r3.eachSeriesByType(l3, function(u) {
      var h = u.getData(), v4 = h.mapDimension("value"), m3 = spt(u, e3), x3 = lpt(u, e3), C = x3.cx, A2 = x3.cy, D = x3.r, P = x3.r0, N = -u.get("startAngle") * pit, j = u.get("minAngle") * pit, W = 0;
      h.each(v4, function(Ze) {
        !isNaN(Ze) && W++;
      });
      var K = h.getSum(v4), te = Math.PI / (K || W) * 2, ne = u.get("clockwise"), ce = u.get("roseType"), me = u.get("stillShowZeroSum"), ve = h.getDataExtent(v4);
      ve[0] = 0;
      var Be = Uce, Oe = 0, We = N, Ue = ne ? 1 : -1;
      if (h.setLayout({ viewRect: m3, r: D }), h.each(v4, function(Ze, ct) {
        var _t;
        if (isNaN(Ze)) {
          h.setItemLayout(ct, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: ne, cx: C, cy: A2, r0: P, r: ce ? NaN : D });
          return;
        }
        ce !== "area" ? _t = K === 0 && me ? te : Ze * te : _t = Uce / W, _t < j ? (_t = j, Be -= j) : Oe += Ze;
        var pt = We + Ue * _t;
        h.setItemLayout(ct, { angle: _t, startAngle: We, endAngle: pt, clockwise: ne, cx: C, cy: A2, r0: P, r: ce ? _f(Ze, ve, [P, D]) : D }), We = pt;
      }), Be < Uce && W)
        if (Be <= 1e-3) {
          var qe = Uce / W;
          h.each(v4, function(Ze, ct) {
            if (!isNaN(Ze)) {
              var _t = h.getItemLayout(ct);
              _t.angle = qe, _t.startAngle = N + Ue * ct * qe, _t.endAngle = N + Ue * (ct + 1) * qe;
            }
          });
        } else
          te = Be / Oe, We = N, h.each(v4, function(Ze, ct) {
            if (!isNaN(Ze)) {
              var _t = h.getItemLayout(ct), pt = _t.angle === j ? j : Ze * te;
              _t.startAngle = We, _t.endAngle = We + Ue * pt, We += Ue * pt;
            }
          });
    });
  }
  function qJ(l3) {
    return { seriesType: l3, reset: function(r3, e3) {
      var u = e3.findComponents({ mainType: "legend" });
      if (!(!u || !u.length)) {
        var h = r3.getData();
        h.filterSelf(function(v4) {
          for (var m3 = h.getName(v4), x3 = 0; x3 < u.length; x3++)
            if (!u[x3].isSelected(m3))
              return false;
          return true;
        });
      }
    } };
  }
  var x0n = Math.PI / 180;
  function dit(l3, r3, e3, u, h, v4, m3, x3, C, A2) {
    if (l3.length < 2)
      return;
    function D(K) {
      for (var te = K.rB, ne = te * te, ce = 0; ce < K.list.length; ce++) {
        var me = K.list[ce], ve = Math.abs(me.label.y - e3), Be = u + me.len, Oe = Be * Be, We = Math.sqrt((1 - Math.abs(ve * ve / ne)) * Oe), Ue = r3 + (We + me.len2) * h, qe = Ue - me.label.x, Ze = me.targetTextWidth - qe * h;
        upt(me, Ze, true), me.label.x = Ue;
      }
    }
    function P(K) {
      for (var te = { list: [], maxY: 0 }, ne = { list: [], maxY: 0 }, ce = 0; ce < K.length; ce++)
        if (K[ce].labelAlignTo === "none") {
          var me = K[ce], ve = me.label.y > e3 ? ne : te, Be = Math.abs(me.label.y - e3);
          if (Be >= ve.maxY) {
            var Oe = me.label.x - r3 - me.len2 * h, We = u + me.len, Ue = Math.abs(Oe) < We ? Math.sqrt(Be * Be / (1 - Oe * Oe / We / We)) : We;
            ve.rB = Ue, ve.maxY = Be;
          }
          ve.list.push(me);
        }
      D(te), D(ne);
    }
    for (var N = l3.length, j = 0; j < N; j++)
      if (l3[j].position === "outer" && l3[j].labelAlignTo === "labelLine") {
        var W = l3[j].label.x - A2;
        l3[j].linePoints[1][0] += W, l3[j].label.x = A2;
      }
    Rht(l3, C, C + m3) && P(l3);
  }
  function w0n(l3, r3, e3, u, h, v4, m3, x3) {
    for (var C = [], A2 = [], D = Number.MAX_VALUE, P = -Number.MAX_VALUE, N = 0; N < l3.length; N++) {
      var j = l3[N].label;
      nDe(l3[N]) || (j.x < r3 ? (D = Math.min(D, j.x), C.push(l3[N])) : (P = Math.max(P, j.x), A2.push(l3[N])));
    }
    for (var N = 0; N < l3.length; N++) {
      var W = l3[N];
      if (!nDe(W) && W.linePoints) {
        if (W.labelStyleWidth != null)
          continue;
        var j = W.label, K = W.linePoints, te = void 0;
        W.labelAlignTo === "edge" ? j.x < r3 ? te = K[2][0] - W.labelDistance - m3 - W.edgeDistance : te = m3 + h - W.edgeDistance - K[2][0] - W.labelDistance : W.labelAlignTo === "labelLine" ? j.x < r3 ? te = D - m3 - W.bleedMargin : te = m3 + h - P - W.bleedMargin : j.x < r3 ? te = j.x - m3 - W.bleedMargin : te = m3 + h - j.x - W.bleedMargin, W.targetTextWidth = te, upt(W, te);
      }
    }
    dit(A2, r3, e3, u, 1, h, v4, m3, x3, P), dit(C, r3, e3, u, -1, h, v4, m3, x3, D);
    for (var N = 0; N < l3.length; N++) {
      var W = l3[N];
      if (!nDe(W) && W.linePoints) {
        var j = W.label, K = W.linePoints, ne = W.labelAlignTo === "edge", ce = j.style.padding, me = ce ? ce[1] + ce[3] : 0, ve = j.style.backgroundColor ? 0 : me, Be = W.rect.width + ve, Oe = K[1][0] - K[2][0];
        ne ? j.x < r3 ? K[2][0] = m3 + W.edgeDistance + Be + W.labelDistance : K[2][0] = m3 + h - W.edgeDistance - Be - W.labelDistance : (j.x < r3 ? K[2][0] = j.x + W.labelDistance : K[2][0] = j.x - W.labelDistance, K[1][0] = K[2][0] + Oe), K[1][1] = K[2][1] = j.y;
      }
    }
  }
  function upt(l3, r3, e3) {
    if (e3 === void 0 && (e3 = false), l3.labelStyleWidth == null) {
      var u = l3.label, h = u.style, v4 = l3.rect, m3 = h.backgroundColor, x3 = h.padding, C = x3 ? x3[1] + x3[3] : 0, A2 = h.overflow, D = v4.width + (m3 ? 0 : C);
      if (r3 < D || e3) {
        var P = v4.height;
        if (A2 && A2.match("break")) {
          u.setStyle("backgroundColor", null), u.setStyle("width", r3 - C);
          var N = u.getBoundingRect();
          u.setStyle("width", Math.ceil(N.width)), u.setStyle("backgroundColor", m3);
        } else {
          var j = r3 - C, W = r3 < D ? j : e3 ? j > l3.unconstrainedWidth ? null : j : null;
          u.setStyle("width", W);
        }
        var K = u.getBoundingRect();
        v4.width = K.width;
        var te = (u.style.margin || 0) + 2.1;
        v4.height = K.height + te, v4.y -= (v4.height - P) / 2;
      }
    }
  }
  function nDe(l3) {
    return l3.position === "center";
  }
  function S0n(l3) {
    var r3 = l3.getData(), e3 = [], u, h, v4 = false, m3 = (l3.get("minShowLabelAngle") || 0) * x0n, x3 = r3.getLayout("viewRect"), C = r3.getLayout("r"), A2 = x3.width, D = x3.x, P = x3.y, N = x3.height;
    function j(Oe) {
      Oe.ignore = true;
    }
    function W(Oe) {
      if (!Oe.ignore)
        return true;
      for (var We in Oe.states)
        if (Oe.states[We].ignore === false)
          return true;
      return false;
    }
    r3.each(function(Oe) {
      var We = r3.getItemGraphicEl(Oe), Ue = We.shape, qe = We.getTextContent(), Ze = We.getTextGuideLine(), ct = r3.getItemModel(Oe), _t = ct.getModel("label"), pt = _t.get("position") || ct.get(["emphasis", "label", "position"]), zt = _t.get("distanceToLabelLine"), Zt = _t.get("alignTo"), Ft = za(_t.get("edgeDistance"), A2), Kn = _t.get("bleedMargin"), hn = ct.getModel("labelLine"), xn = hn.get("length");
      xn = za(xn, A2);
      var zn = hn.get("length2");
      if (zn = za(zn, A2), Math.abs(Ue.endAngle - Ue.startAngle) < m3) {
        mt(qe.states, j), qe.ignore = true;
        return;
      }
      if (!!W(qe)) {
        var or = (Ue.startAngle + Ue.endAngle) / 2, vr = Math.cos(or), la = Math.sin(or), Ba, Lo, Ao, oo;
        u = Ue.cx, h = Ue.cy;
        var Pa = pt === "inside" || pt === "inner";
        if (pt === "center")
          Ba = Ue.cx, Lo = Ue.cy, oo = "center";
        else {
          var fo = (Pa ? (Ue.r + Ue.r0) / 2 * vr : Ue.r * vr) + u, Co = (Pa ? (Ue.r + Ue.r0) / 2 * la : Ue.r * la) + h;
          if (Ba = fo + vr * 3, Lo = Co + la * 3, !Pa) {
            var $a = fo + vr * (xn + C - Ue.r), Yo = Co + la * (xn + C - Ue.r), Qu = $a + (vr < 0 ? -1 : 1) * zn, ds = Yo;
            Zt === "edge" ? Ba = vr < 0 ? D + Ft : D + A2 - Ft : Ba = Qu + (vr < 0 ? -zt : zt), Lo = ds, Ao = [[fo, Co], [$a, Yo], [Qu, ds]];
          }
          oo = Pa ? "center" : Zt === "edge" ? vr > 0 ? "right" : "left" : vr > 0 ? "left" : "right";
        }
        var Lu = Math.PI, dc = 0, Kc = _t.get("rotate");
        if (Vc(Kc))
          dc = Kc * (Lu / 180);
        else if (pt === "center")
          dc = 0;
        else if (Kc === "radial" || Kc === true) {
          var sv = vr < 0 ? -or + Lu : -or;
          dc = sv;
        } else if (Kc === "tangential" && pt !== "outside" && pt !== "outer") {
          var Hf = Math.atan2(vr, la);
          Hf < 0 && (Hf = Lu * 2 + Hf);
          var vg = la > 0;
          vg && (Hf = Lu + Hf), dc = Hf - Lu;
        }
        if (v4 = !!dc, qe.x = Ba, qe.y = Lo, qe.rotation = dc, qe.setStyle({ verticalAlign: "middle" }), Pa) {
          qe.setStyle({ align: oo });
          var Gh = qe.states.select;
          Gh && (Gh.x += qe.x, Gh.y += qe.y);
        } else {
          var Ef = qe.getBoundingRect().clone();
          Ef.applyTransform(qe.getComputedTransform());
          var md = (qe.style.margin || 0) + 2.1;
          Ef.y -= md / 2, Ef.height += md, e3.push({ label: qe, labelLine: Ze, position: pt, len: xn, len2: zn, minTurnAngle: hn.get("minTurnAngle"), maxSurfaceAngle: hn.get("maxSurfaceAngle"), surfaceNormal: new nl(vr, la), linePoints: Ao, textAlign: oo, labelDistance: zt, labelAlignTo: Zt, edgeDistance: Ft, bleedMargin: Kn, rect: Ef, unconstrainedWidth: Ef.width, labelStyleWidth: qe.style.width });
        }
        We.setTextConfig({ inside: Pa });
      }
    }), !v4 && l3.get("avoidLabelOverlap") && w0n(e3, u, h, C, A2, N, D, P);
    for (var K = 0; K < e3.length; K++) {
      var te = e3[K], ne = te.label, ce = te.labelLine, me = isNaN(ne.x) || isNaN(ne.y);
      if (ne) {
        ne.setStyle({ align: te.textAlign }), me && (mt(ne.states, j), ne.ignore = true);
        var ve = ne.states.select;
        ve && (ve.x += ne.x, ve.y += ne.y);
      }
      if (ce) {
        var Be = te.linePoints;
        me || !Be ? (mt(ce.states, j), ce.ignore = true) : (Oht(Be, te.minTurnAngle), Rvn(Be, te.surfaceNormal, te.maxSurfaceAngle), ce.setShape({ points: Be }), ne.__hostTarget.textGuideLineConfig = { anchor: new nl(Be[0][0], Be[0][1]) });
      }
    }
  }
  function Qz(l3, r3, e3) {
    var u = l3.get("borderRadius");
    if (u == null)
      return e3 ? { cornerRadius: 0 } : null;
    Ni(u) || (u = [u, u, u, u]);
    var h = Math.abs(r3.r || 0 - r3.r0 || 0);
    return { cornerRadius: Bi(u, function(v4) {
      return gM(v4, h);
    }) };
  }
  var C0n = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this) || this;
      v4.z2 = 2;
      var m3 = new Ec();
      return v4.setTextContent(m3), v4.updateData(e3, u, h, true), v4;
    }
    return r3.prototype.updateData = function(e3, u, h, v4) {
      var m3 = this, x3 = e3.hostModel, C = e3.getItemModel(u), A2 = C.getModel("emphasis"), D = e3.getItemLayout(u), P = fi(Qz(C.getModel("itemStyle"), D, true), D);
      if (isNaN(P.startAngle)) {
        m3.setShape(P);
        return;
      }
      if (v4) {
        m3.setShape(P);
        var N = x3.getShallow("animationType");
        x3.ecModel.ssr ? (Np(m3, { scaleX: 0, scaleY: 0 }, x3, { dataIndex: u, isFrom: true }), m3.originX = P.cx, m3.originY = P.cy) : N === "scale" ? (m3.shape.r = D.r0, Np(m3, { shape: { r: D.r } }, x3, u)) : h != null ? (m3.setShape({ startAngle: h, endAngle: h }), Np(m3, { shape: { startAngle: D.startAngle, endAngle: D.endAngle } }, x3, u)) : (m3.shape.endAngle = D.startAngle, hc(m3, { shape: { endAngle: D.endAngle } }, x3, u));
      } else
        yM(m3), hc(m3, { shape: P }, x3, u);
      m3.useStyle(e3.getItemVisual(u, "style")), sm(m3, C);
      var j = (D.startAngle + D.endAngle) / 2, W = x3.get("selectedOffset"), K = Math.cos(j) * W, te = Math.sin(j) * W, ne = C.getShallow("cursor");
      ne && m3.attr("cursor", ne), this._updateLabel(x3, e3, u), m3.ensureState("emphasis").shape = fi({ r: D.r + (A2.get("scale") && A2.get("scaleSize") || 0) }, Qz(A2.getModel("itemStyle"), D)), fi(m3.ensureState("select"), { x: K, y: te, shape: Qz(C.getModel(["select", "itemStyle"]), D) }), fi(m3.ensureState("blur"), { shape: Qz(C.getModel(["blur", "itemStyle"]), D) });
      var ce = m3.getTextGuideLine(), me = m3.getTextContent();
      ce && fi(ce.ensureState("select"), { x: K, y: te }), fi(me.ensureState("select"), { x: K, y: te }), Gd(this, A2.get("focus"), A2.get("blurScope"), A2.get("disabled"));
    }, r3.prototype._updateLabel = function(e3, u, h) {
      var v4 = this, m3 = u.getItemModel(h), x3 = m3.getModel("labelLine"), C = u.getItemVisual(h, "style"), A2 = C && C.fill, D = C && C.opacity;
      _1(v4, ny(m3), { labelFetcher: u.hostModel, labelDataIndex: h, inheritColor: A2, defaultOpacity: D, defaultText: e3.getFormattedLabel(h, "normal") || u.getName(h) });
      var P = v4.getTextContent();
      v4.setTextConfig({ position: null, rotation: null }), P.attr({ z2: 10 });
      var N = e3.get(["label", "position"]);
      if (N !== "outside" && N !== "outer")
        v4.removeTextGuideLine();
      else {
        var j = this.getTextGuideLine();
        j || (j = new M_(), this.setTextGuideLine(j)), TOe(this, AOe(m3), { stroke: A2, opacity: t5(x3.get(["lineStyle", "opacity"]), D, 1) });
      }
    }, r3;
  }(S_), M0n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.ignoreLabelLineUpdate = true, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      var m3 = e3.getData(), x3 = this._data, C = this.group, A2;
      if (!x3 && m3.count() > 0) {
        for (var D = m3.getItemLayout(0), P = 1; isNaN(D && D.startAngle) && P < m3.count(); ++P)
          D = m3.getItemLayout(P);
        D && (A2 = D.startAngle);
      }
      if (this._emptyCircleSector && C.remove(this._emptyCircleSector), m3.count() === 0 && e3.get("showEmptyCircle")) {
        var N = new S_({ shape: lpt(e3, h) });
        N.useStyle(e3.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = N, C.add(N);
      }
      m3.diff(x3).add(function(j) {
        var W = new C0n(m3, j, A2);
        m3.setItemGraphicEl(j, W), C.add(W);
      }).update(function(j, W) {
        var K = x3.getItemGraphicEl(W);
        K.updateData(m3, j, A2), K.off("click"), C.add(K), m3.setItemGraphicEl(j, K);
      }).remove(function(j) {
        var W = x3.getItemGraphicEl(j);
        aJ(W, e3, j);
      }).execute(), S0n(e3), e3.get("animationTypeUpdate") !== "expansion" && (this._data = m3);
    }, r3.prototype.dispose = function() {
    }, r3.prototype.containPoint = function(e3, u) {
      var h = u.getData(), v4 = h.getItemLayout(0);
      if (v4) {
        var m3 = e3[0] - v4.cx, x3 = e3[1] - v4.cy, C = Math.sqrt(m3 * m3 + x3 * x3);
        return C <= v4.r && C >= v4.r0;
      }
    }, r3.type = "pie", r3;
  }(zh), T0n = M0n;
  function Lj(l3, r3, e3) {
    r3 = Ni(r3) && { coordDimensions: r3 } || fi({ encodeDefine: l3.getEncode() }, r3);
    var u = l3.getSource(), h = zJ(u, r3).dimensions, v4 = new yb(h, l3);
    return v4.initData(u, e3), v4;
  }
  var A0n = function() {
    function l3(r3, e3) {
      this._getDataWithEncodedVisual = r3, this._getRawData = e3;
    }
    return l3.prototype.getAllNames = function() {
      var r3 = this._getRawData();
      return r3.mapArray(r3.getName);
    }, l3.prototype.containName = function(r3) {
      var e3 = this._getRawData();
      return e3.indexOfName(r3) >= 0;
    }, l3.prototype.indexOfName = function(r3) {
      var e3 = this._getDataWithEncodedVisual();
      return e3.indexOfName(r3);
    }, l3.prototype.getItemVisual = function(r3, e3) {
      var u = this._getDataWithEncodedVisual();
      return u.getItemVisual(r3, e3);
    }, l3;
  }(), $J = A0n, I0n = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.init = function(e3) {
      l3.prototype.init.apply(this, arguments), this.legendVisualProvider = new $J(no(this.getData, this), no(this.getRawData, this)), this._defaultLabelLine(e3);
    }, r3.prototype.mergeOption = function() {
      l3.prototype.mergeOption.apply(this, arguments);
    }, r3.prototype.getInitialData = function() {
      return Lj(this, { coordDimensions: ["value"], encodeDefaulter: Fs(nOe, this) });
    }, r3.prototype.getDataParams = function(e3) {
      var u = this.getData(), h = l3.prototype.getDataParams.call(this, e3), v4 = [];
      return u.each(u.mapDimension("value"), function(m3) {
        v4.push(m3);
      }), h.percent = Pln(v4, e3, u.hostModel.get("percentPrecision")), h.$vars.push("percent"), h;
    }, r3.prototype._defaultLabelLine = function(e3) {
      HN(e3, "labelLine", ["show"]);
      var u = e3.labelLine, h = e3.emphasis.labelLine;
      u.show = u.show && e3.label.show, h.show = h.show && e3.emphasis.label.show;
    }, r3.type = "series.pie", r3.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, r3;
  }(Fp), E0n = I0n;
  function D0n(l3) {
    return { seriesType: l3, reset: function(r3, e3) {
      var u = r3.getData();
      u.filterSelf(function(h) {
        var v4 = u.mapDimension("value"), m3 = u.get(v4, h);
        return !(Vc(m3) && !isNaN(m3) && m3 < 0);
      });
    } };
  }
  function k0n(l3) {
    l3.registerChartView(T0n), l3.registerSeriesModel(E0n), Eft("pie", l3.registerAction), l3.registerLayout(Fs(_0n, "pie")), l3.registerProcessor(qJ("pie")), l3.registerProcessor(D0n("pie"));
  }
  var O0n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.hasSymbolVisual = true, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      return v5(null, this, { useEncodeDefaulter: true });
    }, r3.prototype.getProgressive = function() {
      var e3 = this.option.progressive;
      return e3 == null ? this.option.large ? 5e3 : this.get("progressive") : e3;
    }, r3.prototype.getProgressiveThreshold = function() {
      var e3 = this.option.progressiveThreshold;
      return e3 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : e3;
    }, r3.prototype.brushSelector = function(e3, u, h) {
      return h.point(u.getItemLayout(e3));
    }, r3.prototype.getZLevelKey = function() {
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
    }, r3.type = "series.scatter", r3.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], r3.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, r3;
  }(Fp), P0n = O0n, cpt = 4, L0n = function() {
    function l3() {
    }
    return l3;
  }(), R0n = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u._off = 0, u.hoverDataIdx = -1, u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new L0n();
    }, r3.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.points, v4 = u.size, m3 = this.symbolProxy, x3 = m3.shape, C = e3.getContext ? e3.getContext() : e3, A2 = C && v4[0] < cpt, D = this.softClipShape, P;
      if (A2) {
        this._ctx = C;
        return;
      }
      for (this._ctx = null, P = this._off; P < h.length; ) {
        var N = h[P++], j = h[P++];
        isNaN(N) || isNaN(j) || D && !D.contain(N, j) || (x3.x = N - v4[0] / 2, x3.y = j - v4[1] / 2, x3.width = v4[0], x3.height = v4[1], m3.buildPath(e3, x3, true));
      }
      this.incremental && (this._off = P, this.notClear = true);
    }, r3.prototype.afterBrush = function() {
      var e3 = this.shape, u = e3.points, h = e3.size, v4 = this._ctx, m3 = this.softClipShape, x3;
      if (!!v4) {
        for (x3 = this._off; x3 < u.length; ) {
          var C = u[x3++], A2 = u[x3++];
          isNaN(C) || isNaN(A2) || m3 && !m3.contain(C, A2) || v4.fillRect(C - h[0] / 2, A2 - h[1] / 2, h[0], h[1]);
        }
        this.incremental && (this._off = x3, this.notClear = true);
      }
    }, r3.prototype.findDataIndex = function(e3, u) {
      for (var h = this.shape, v4 = h.points, m3 = h.size, x3 = Math.max(m3[0], 4), C = Math.max(m3[1], 4), A2 = v4.length / 2 - 1; A2 >= 0; A2--) {
        var D = A2 * 2, P = v4[D] - x3 / 2, N = v4[D + 1] - C / 2;
        if (e3 >= P && u >= N && e3 <= P + x3 && u <= N + C)
          return A2;
      }
      return -1;
    }, r3.prototype.contain = function(e3, u) {
      var h = this.transformCoordToLocal(e3, u), v4 = this.getBoundingRect();
      if (e3 = h[0], u = h[1], v4.contain(e3, u)) {
        var m3 = this.hoverDataIdx = this.findDataIndex(e3, u);
        return m3 >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, r3.prototype.getBoundingRect = function() {
      var e3 = this._rect;
      if (!e3) {
        for (var u = this.shape, h = u.points, v4 = u.size, m3 = v4[0], x3 = v4[1], C = 1 / 0, A2 = 1 / 0, D = -1 / 0, P = -1 / 0, N = 0; N < h.length; ) {
          var j = h[N++], W = h[N++];
          C = Math.min(j, C), D = Math.max(j, D), A2 = Math.min(W, A2), P = Math.max(W, P);
        }
        e3 = this._rect = new Ml(C - m3 / 2, A2 - x3 / 2, D - C + m3, P - A2 + x3);
      }
      return e3;
    }, r3;
  }(Nl), N0n = function() {
    function l3() {
      this.group = new Cs();
    }
    return l3.prototype.updateData = function(r3, e3) {
      this._clear();
      var u = this._create();
      u.setShape({ points: r3.getLayout("points") }), this._setCommon(u, r3, e3);
    }, l3.prototype.updateLayout = function(r3) {
      var e3 = r3.getLayout("points");
      this.group.eachChild(function(u) {
        if (u.startIndex != null) {
          var h = (u.endIndex - u.startIndex) * 2, v4 = u.startIndex * 4 * 2;
          e3 = new Float32Array(e3.buffer, v4, h);
        }
        u.setShape("points", e3), u.reset();
      });
    }, l3.prototype.incrementalPrepareUpdate = function(r3) {
      this._clear();
    }, l3.prototype.incrementalUpdate = function(r3, e3, u) {
      var h = this._newAdded[0], v4 = e3.getLayout("points"), m3 = h && h.shape.points;
      if (m3 && m3.length < 2e4) {
        var x3 = m3.length, C = new Float32Array(x3 + v4.length);
        C.set(m3), C.set(v4, x3), h.endIndex = r3.end, h.setShape({ points: C });
      } else {
        this._newAdded = [];
        var A2 = this._create();
        A2.startIndex = r3.start, A2.endIndex = r3.end, A2.incremental = true, A2.setShape({ points: v4 }), this._setCommon(A2, e3, u);
      }
    }, l3.prototype.eachRendered = function(r3) {
      this._newAdded[0] && r3(this._newAdded[0]);
    }, l3.prototype._create = function() {
      var r3 = new R0n({ cursor: "default" });
      return this.group.add(r3), this._newAdded.push(r3), r3;
    }, l3.prototype._setCommon = function(r3, e3, u) {
      var h = e3.hostModel;
      u = u || {};
      var v4 = e3.getVisual("symbolSize");
      r3.setShape("size", v4 instanceof Array ? v4 : [v4, v4]), r3.softClipShape = u.clipShape || null, r3.symbolProxy = Nv(e3.getVisual("symbol"), 0, 0, 0, 0), r3.setColor = r3.symbolProxy.setColor;
      var m3 = r3.shape.size[0] < cpt;
      r3.useStyle(h.getModel("itemStyle").getItemStyle(m3 ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
      var x3 = e3.getVisual("style"), C = x3 && x3.fill;
      C && r3.setColor(C);
      var A2 = Ps(r3);
      A2.seriesIndex = h.seriesIndex, r3.on("mousemove", function(D) {
        A2.dataIndex = null;
        var P = r3.hoverDataIdx;
        P >= 0 && (A2.dataIndex = P + (r3.startIndex || 0));
      });
    }, l3.prototype.remove = function() {
      this._clear();
    }, l3.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, l3;
  }(), F0n = N0n, V0n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this._updateSymbolDraw(v4, e3);
      m3.updateData(v4, { clipShape: this._getClipShape(e3) }), this._finished = true;
    }, r3.prototype.incrementalPrepareRender = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this._updateSymbolDraw(v4, e3);
      m3.incrementalPrepareUpdate(v4), this._finished = false;
    }, r3.prototype.incrementalRender = function(e3, u, h) {
      this._symbolDraw.incrementalUpdate(e3, u.getData(), { clipShape: this._getClipShape(u) }), this._finished = e3.end === u.getData().count();
    }, r3.prototype.updateTransform = function(e3, u, h) {
      var v4 = e3.getData();
      if (this.group.dirty(), !this._finished || v4.count() > 1e4)
        return { update: true };
      var m3 = UJ("").reset(e3, u, h);
      m3.progress && m3.progress({ start: 0, end: v4.count(), count: v4.count() }, v4), this._symbolDraw.updateLayout(v4);
    }, r3.prototype.eachRendered = function(e3) {
      this._symbolDraw && this._symbolDraw.eachRendered(e3);
    }, r3.prototype._getClipShape = function(e3) {
      var u = e3.coordinateSystem, h = u && u.getArea && u.getArea();
      return e3.get("clip", true) ? h : null;
    }, r3.prototype._updateSymbolDraw = function(e3, u) {
      var h = this._symbolDraw, v4 = u.pipelineContext, m3 = v4.large;
      return (!h || m3 !== this._isLargeDraw) && (h && h.remove(), h = this._symbolDraw = m3 ? new F0n() : new WJ(), this._isLargeDraw = m3, this.group.removeAll()), this.group.add(h.group), h;
    }, r3.prototype.remove = function(e3, u) {
      this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
    }, r3.prototype.dispose = function() {
    }, r3.type = "scatter", r3;
  }(zh), B0n = V0n, z0n = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.type = "grid", r3.dependencies = ["xAxis", "yAxis"], r3.layoutMode = "box", r3.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, r3;
  }(fc), j0n = z0n, xke = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("grid", Lv).models[0];
    }, r3.type = "cartesian2dAxis", r3;
  }(fc);
  Fv(xke, GJ);
  var fpt = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, G0n = ol({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, fpt), OOe = ol({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, fpt), H0n = ol({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, OOe), W0n = ns({ logBase: 10 }, OOe), hpt = { category: G0n, value: OOe, time: H0n, log: W0n }, U0n = { value: 1, category: 1, time: 1, log: 1 };
  function vj(l3, r3, e3, u) {
    mt(U0n, function(h, v4) {
      var m3 = ol(ol({}, hpt[v4], true), u, true), x3 = function(C) {
        ar(A2, C);
        function A2() {
          var D = C !== null && C.apply(this, arguments) || this;
          return D.type = r3 + "Axis." + v4, D;
        }
        return A2.prototype.mergeDefaultAndTheme = function(D, P) {
          var N = lJ(this), j = N ? Ij(D) : {}, W = P.getTheme();
          ol(D, W.get(v4 + "Axis")), ol(D, this.getDefaultOption()), D.type = vit(D), N && QO(D, j, N);
        }, A2.prototype.optionUpdated = function() {
          var D = this.option;
          D.type === "category" && (this.__ordinalMeta = dke.createByAxisModel(this));
        }, A2.prototype.getCategories = function(D) {
          var P = this.option;
          if (P.type === "category")
            return D ? P.data : this.__ordinalMeta.categories;
        }, A2.prototype.getOrdinalMeta = function() {
          return this.__ordinalMeta;
        }, A2.type = r3 + "Axis." + v4, A2.defaultOption = m3, A2;
      }(e3);
      l3.registerComponentModel(x3);
    }), l3.registerSubTypeDefaulter(r3 + "Axis", vit);
  }
  function vit(l3) {
    return l3.type || (l3.data ? "category" : "value");
  }
  var q0n = function() {
    function l3(r3) {
      this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = r3 || "";
    }
    return l3.prototype.getAxis = function(r3) {
      return this._axes[r3];
    }, l3.prototype.getAxes = function() {
      return Bi(this._dimList, function(r3) {
        return this._axes[r3];
      }, this);
    }, l3.prototype.getAxesByScale = function(r3) {
      return r3 = r3.toLowerCase(), jf(this.getAxes(), function(e3) {
        return e3.scale.type === r3;
      });
    }, l3.prototype.addAxis = function(r3) {
      var e3 = r3.dim;
      this._axes[e3] = r3, this._dimList.push(e3);
    }, l3;
  }(), $0n = q0n, wke = ["x", "y"];
  function git(l3) {
    return l3.type === "interval" || l3.type === "time";
  }
  var X0n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "cartesian2d", e3.dimensions = wke, e3;
    }
    return r3.prototype.calcAffineTransform = function() {
      this._transform = this._invTransform = null;
      var e3 = this.getAxis("x").scale, u = this.getAxis("y").scale;
      if (!(!git(e3) || !git(u))) {
        var h = e3.getExtent(), v4 = u.getExtent(), m3 = this.dataToPoint([h[0], v4[0]]), x3 = this.dataToPoint([h[1], v4[1]]), C = h[1] - h[0], A2 = v4[1] - v4[0];
        if (!(!C || !A2)) {
          var D = (x3[0] - m3[0]) / C, P = (x3[1] - m3[1]) / A2, N = m3[0] - h[0] * D, j = m3[1] - v4[0] * P, W = this._transform = [D, 0, 0, P, N, j];
          this._invTransform = _j([], W);
        }
      }
    }, r3.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
    }, r3.prototype.containPoint = function(e3) {
      var u = this.getAxis("x"), h = this.getAxis("y");
      return u.contain(u.toLocalCoord(e3[0])) && h.contain(h.toLocalCoord(e3[1]));
    }, r3.prototype.containData = function(e3) {
      return this.getAxis("x").containData(e3[0]) && this.getAxis("y").containData(e3[1]);
    }, r3.prototype.dataToPoint = function(e3, u, h) {
      h = h || [];
      var v4 = e3[0], m3 = e3[1];
      if (this._transform && v4 != null && isFinite(v4) && m3 != null && isFinite(m3))
        return am(h, e3, this._transform);
      var x3 = this.getAxis("x"), C = this.getAxis("y");
      return h[0] = x3.toGlobalCoord(x3.dataToCoord(v4, u)), h[1] = C.toGlobalCoord(C.dataToCoord(m3, u)), h;
    }, r3.prototype.clampData = function(e3, u) {
      var h = this.getAxis("x").scale, v4 = this.getAxis("y").scale, m3 = h.getExtent(), x3 = v4.getExtent(), C = h.parse(e3[0]), A2 = v4.parse(e3[1]);
      return u = u || [], u[0] = Math.min(Math.max(Math.min(m3[0], m3[1]), C), Math.max(m3[0], m3[1])), u[1] = Math.min(Math.max(Math.min(x3[0], x3[1]), A2), Math.max(x3[0], x3[1])), u;
    }, r3.prototype.pointToData = function(e3, u) {
      var h = [];
      if (this._invTransform)
        return am(h, e3, this._invTransform);
      var v4 = this.getAxis("x"), m3 = this.getAxis("y");
      return h[0] = v4.coordToData(v4.toLocalCoord(e3[0]), u), h[1] = m3.coordToData(m3.toLocalCoord(e3[1]), u), h;
    }, r3.prototype.getOtherAxis = function(e3) {
      return this.getAxis(e3.dim === "x" ? "y" : "x");
    }, r3.prototype.getArea = function() {
      var e3 = this.getAxis("x").getGlobalExtent(), u = this.getAxis("y").getGlobalExtent(), h = Math.min(e3[0], e3[1]), v4 = Math.min(u[0], u[1]), m3 = Math.max(e3[0], e3[1]) - h, x3 = Math.max(u[0], u[1]) - v4;
      return new Ml(h, v4, m3, x3);
    }, r3;
  }($0n), Y0n = X0n, K0n = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4, m3) {
      var x3 = l3.call(this, e3, u, h) || this;
      return x3.index = 0, x3.type = v4 || "value", x3.position = m3 || "bottom", x3;
    }
    return r3.prototype.isHorizontal = function() {
      var e3 = this.position;
      return e3 === "top" || e3 === "bottom";
    }, r3.prototype.getGlobalExtent = function(e3) {
      var u = this.getExtent();
      return u[0] = this.toGlobalCoord(u[0]), u[1] = this.toGlobalCoord(u[1]), e3 && u[0] > u[1] && u.reverse(), u;
    }, r3.prototype.pointToData = function(e3, u) {
      return this.coordToData(this.toLocalCoord(e3[this.dim === "x" ? 0 : 1]), u);
    }, r3.prototype.setCategorySortInfo = function(e3) {
      if (this.type !== "category")
        return false;
      this.model.option.categorySortInfo = e3, this.scale.setSortInfo(e3);
    }, r3;
  }(bM), Z0n = K0n;
  function Ske(l3, r3, e3) {
    e3 = e3 || {};
    var u = l3.coordinateSystem, h = r3.axis, v4 = {}, m3 = h.getAxesOnZeroOf()[0], x3 = h.position, C = m3 ? "onZero" : x3, A2 = h.dim, D = u.getRect(), P = [D.x, D.x + D.width, D.y, D.y + D.height], N = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, j = r3.get("offset") || 0, W = A2 === "x" ? [P[2] - j, P[3] + j] : [P[0] - j, P[1] + j];
    if (m3) {
      var K = m3.toGlobalCoord(m3.dataToCoord(0));
      W[N.onZero] = Math.max(Math.min(K, W[1]), W[0]);
    }
    v4.position = [A2 === "y" ? W[N[C]] : P[0], A2 === "x" ? W[N[C]] : P[3]], v4.rotation = Math.PI / 2 * (A2 === "x" ? 0 : 1);
    var te = { top: -1, bottom: 1, left: -1, right: 1 };
    v4.labelDirection = v4.tickDirection = v4.nameDirection = te[x3], v4.labelOffset = m3 ? W[N[x3]] - W[N.onZero] : 0, r3.get(["axisTick", "inside"]) && (v4.tickDirection = -v4.tickDirection), ey(e3.labelInside, r3.get(["axisLabel", "inside"])) && (v4.labelDirection = -v4.labelDirection);
    var ne = r3.get(["axisLabel", "rotate"]);
    return v4.labelRotate = C === "top" ? -ne : ne, v4.z2 = 1, v4;
  }
  function yit(l3) {
    return l3.get("coordinateSystem") === "cartesian2d";
  }
  function mit(l3) {
    var r3 = { xAxisModel: null, yAxisModel: null };
    return mt(r3, function(e3, u) {
      var h = u.replace(/Model$/, ""), v4 = l3.getReferringComponents(h, Lv).models[0];
      r3[u] = v4;
    }), r3;
  }
  var rDe = Math.log;
  function ppt(l3, r3, e3) {
    var u = tP.prototype, h = u.getTicks.call(e3), v4 = u.getTicks.call(e3, true), m3 = h.length - 1, x3 = u.getInterval.call(e3), C = _ht(l3, r3), A2 = C.extent, D = C.fixMin, P = C.fixMax;
    if (l3.type === "log") {
      var N = rDe(l3.base);
      A2 = [rDe(A2[0]) / N, rDe(A2[1]) / N];
    }
    l3.setExtent(A2[0], A2[1]), l3.calcNiceExtent({ splitNumber: m3, fixMin: D, fixMax: P });
    var j = u.getExtent.call(l3);
    D && (A2[0] = j[0]), P && (A2[1] = j[1]);
    var W = u.getInterval.call(l3), K = A2[0], te = A2[1];
    if (D && P)
      W = (te - K) / m3;
    else if (D)
      for (te = A2[0] + W * m3; te < A2[1] && isFinite(te) && isFinite(A2[1]); )
        W = HEe(W), te = A2[0] + W * m3;
    else if (P)
      for (K = A2[1] - W * m3; K > A2[0] && isFinite(K) && isFinite(A2[0]); )
        W = HEe(W), K = A2[1] - W * m3;
    else {
      var ne = l3.getTicks().length - 1;
      ne > m3 && (W = HEe(W));
      var ce = W * m3;
      te = Math.ceil(A2[1] / W) * W, K = jd(te - ce), K < 0 && A2[0] >= 0 ? (K = 0, te = jd(ce)) : te > 0 && A2[1] <= 0 && (te = 0, K = -jd(ce));
    }
    var me = (h[0].value - v4[0].value) / x3, ve = (h[m3].value - v4[m3].value) / x3;
    u.setExtent.call(l3, K + W * me, te + W * ve), u.setInterval.call(l3, W), (me || ve) && u.setNiceExtent.call(l3, K + W, te - W);
  }
  var J0n = function() {
    function l3(r3, e3, u) {
      this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = wke, this._initCartesian(r3, e3, u), this.model = r3;
    }
    return l3.prototype.getRect = function() {
      return this._rect;
    }, l3.prototype.update = function(r3, e3) {
      var u = this._axesMap;
      this._updateScale(r3, this.model);
      function h(m3) {
        var x3, C = yu(m3), A2 = C.length;
        if (!!A2) {
          for (var D = [], P = A2 - 1; P >= 0; P--) {
            var N = +C[P], j = m3[N], W = j.model, K = j.scale;
            vke(K) && W.get("alignTicks") && W.get("interval") == null ? D.push(j) : (pj(K, W), vke(K) && (x3 = j));
          }
          D.length && (x3 || (x3 = D.pop(), pj(x3.scale, x3.model)), mt(D, function(te) {
            ppt(te.scale, te.model, x3.scale);
          }));
        }
      }
      h(u.x), h(u.y);
      var v4 = {};
      mt(u.x, function(m3) {
        bit(u, "y", m3, v4);
      }), mt(u.y, function(m3) {
        bit(u, "x", m3, v4);
      }), this.resize(this.model, e3);
    }, l3.prototype.resize = function(r3, e3, u) {
      var h = r3.getBoxLayoutParams(), v4 = !u && r3.get("containLabel"), m3 = dg(h, { width: e3.getWidth(), height: e3.getHeight() });
      this._rect = m3;
      var x3 = this._axesList;
      C(), v4 && (mt(x3, function(A2) {
        if (!A2.model.get(["axisLabel", "inside"])) {
          var D = fvn(A2);
          if (D) {
            var P = A2.isHorizontal() ? "height" : "width", N = A2.model.get(["axisLabel", "margin"]);
            m3[P] -= D[P] + N, A2.position === "top" ? m3.y += D.height + N : A2.position === "left" && (m3.x += D.width + N);
          }
        }
      }), C()), mt(this._coordsList, function(A2) {
        A2.calcAffineTransform();
      });
      function C() {
        mt(x3, function(A2) {
          var D = A2.isHorizontal(), P = D ? [0, m3.width] : [0, m3.height], N = A2.inverse ? 1 : 0;
          A2.setExtent(P[N], P[1 - N]), Q0n(A2, D ? m3.x : m3.y);
        });
      }
    }, l3.prototype.getAxis = function(r3, e3) {
      var u = this._axesMap[r3];
      if (u != null)
        return u[e3 || 0];
    }, l3.prototype.getAxes = function() {
      return this._axesList.slice();
    }, l3.prototype.getCartesian = function(r3, e3) {
      if (r3 != null && e3 != null) {
        var u = "x" + r3 + "y" + e3;
        return this._coordsMap[u];
      }
      ls(r3) && (e3 = r3.yAxisIndex, r3 = r3.xAxisIndex);
      for (var h = 0, v4 = this._coordsList; h < v4.length; h++)
        if (v4[h].getAxis("x").index === r3 || v4[h].getAxis("y").index === e3)
          return v4[h];
    }, l3.prototype.getCartesians = function() {
      return this._coordsList.slice();
    }, l3.prototype.convertToPixel = function(r3, e3, u) {
      var h = this._findConvertTarget(e3);
      return h.cartesian ? h.cartesian.dataToPoint(u) : h.axis ? h.axis.toGlobalCoord(h.axis.dataToCoord(u)) : null;
    }, l3.prototype.convertFromPixel = function(r3, e3, u) {
      var h = this._findConvertTarget(e3);
      return h.cartesian ? h.cartesian.pointToData(u) : h.axis ? h.axis.coordToData(h.axis.toLocalCoord(u)) : null;
    }, l3.prototype._findConvertTarget = function(r3) {
      var e3 = r3.seriesModel, u = r3.xAxisModel || e3 && e3.getReferringComponents("xAxis", Lv).models[0], h = r3.yAxisModel || e3 && e3.getReferringComponents("yAxis", Lv).models[0], v4 = r3.gridModel, m3 = this._coordsList, x3, C;
      if (e3)
        x3 = e3.coordinateSystem, Cl(m3, x3) < 0 && (x3 = null);
      else if (u && h)
        x3 = this.getCartesian(u.componentIndex, h.componentIndex);
      else if (u)
        C = this.getAxis("x", u.componentIndex);
      else if (h)
        C = this.getAxis("y", h.componentIndex);
      else if (v4) {
        var A2 = v4.coordinateSystem;
        A2 === this && (x3 = this._coordsList[0]);
      }
      return { cartesian: x3, axis: C };
    }, l3.prototype.containPoint = function(r3) {
      var e3 = this._coordsList[0];
      if (e3)
        return e3.containPoint(r3);
    }, l3.prototype._initCartesian = function(r3, e3, u) {
      var h = this, v4 = this, m3 = { left: false, right: false, top: false, bottom: false }, x3 = { x: {}, y: {} }, C = { x: 0, y: 0 };
      if (e3.eachComponent("xAxis", A2("x"), this), e3.eachComponent("yAxis", A2("y"), this), !C.x || !C.y) {
        this._axesMap = {}, this._axesList = [];
        return;
      }
      this._axesMap = x3, mt(x3.x, function(D, P) {
        mt(x3.y, function(N, j) {
          var W = "x" + P + "y" + j, K = new Y0n(W);
          K.master = h, K.model = r3, h._coordsMap[W] = K, h._coordsList.push(K), K.addAxis(D), K.addAxis(N);
        });
      });
      function A2(D) {
        return function(P, N) {
          if (!!iDe(P, r3)) {
            var j = P.get("position");
            D === "x" ? j !== "top" && j !== "bottom" && (j = m3.bottom ? "top" : "bottom") : j !== "left" && j !== "right" && (j = m3.left ? "right" : "left"), m3[j] = true;
            var W = new Z0n(D, ppe(P), [0, 0], P.get("type"), j), K = W.type === "category";
            W.onBand = K && P.get("boundaryGap"), W.inverse = P.get("inverse"), P.axis = W, W.model = P, W.grid = v4, W.index = N, v4._axesList.push(W), x3[D][N] = W, C[D]++;
          }
        };
      }
    }, l3.prototype._updateScale = function(r3, e3) {
      mt(this._axesList, function(h) {
        if (h.scale.setExtent(1 / 0, -1 / 0), h.type === "category") {
          var v4 = h.model.get("categorySortInfo");
          h.scale.setSortInfo(v4);
        }
      }), r3.eachSeries(function(h) {
        if (yit(h)) {
          var v4 = mit(h), m3 = v4.xAxisModel, x3 = v4.yAxisModel;
          if (!iDe(m3, e3) || !iDe(x3, e3))
            return;
          var C = this.getCartesian(m3.componentIndex, x3.componentIndex), A2 = h.getData(), D = C.getAxis("x"), P = C.getAxis("y");
          u(A2, D), u(A2, P);
        }
      }, this);
      function u(h, v4) {
        mt(lhe(h, v4.dim), function(m3) {
          v4.scale.unionExtentFromData(h, m3);
        });
      }
    }, l3.prototype.getTooltipAxes = function(r3) {
      var e3 = [], u = [];
      return mt(this.getCartesians(), function(h) {
        var v4 = r3 != null && r3 !== "auto" ? h.getAxis(r3) : h.getBaseAxis(), m3 = h.getOtherAxis(v4);
        Cl(e3, v4) < 0 && e3.push(v4), Cl(u, m3) < 0 && u.push(m3);
      }), { baseAxes: e3, otherAxes: u };
    }, l3.create = function(r3, e3) {
      var u = [];
      return r3.eachComponent("grid", function(h, v4) {
        var m3 = new l3(h, r3, e3);
        m3.name = "grid_" + v4, m3.resize(h, e3, true), h.coordinateSystem = m3, u.push(m3);
      }), r3.eachSeries(function(h) {
        if (!!yit(h)) {
          var v4 = mit(h), m3 = v4.xAxisModel, x3 = v4.yAxisModel, C = m3.getCoordSysModel(), A2 = C.coordinateSystem;
          h.coordinateSystem = A2.getCartesian(m3.componentIndex, x3.componentIndex);
        }
      }), u;
    }, l3.dimensions = wke, l3;
  }();
  function iDe(l3, r3) {
    return l3.getCoordSysModel() === r3;
  }
  function bit(l3, r3, e3, u) {
    e3.getAxesOnZeroOf = function() {
      return v4 ? [v4] : [];
    };
    var h = l3[r3], v4, m3 = e3.model, x3 = m3.get(["axisLine", "onZero"]), C = m3.get(["axisLine", "onZeroAxisIndex"]);
    if (!x3)
      return;
    if (C != null)
      _it(h[C]) && (v4 = h[C]);
    else
      for (var A2 in h)
        if (h.hasOwnProperty(A2) && _it(h[A2]) && !u[D(h[A2])]) {
          v4 = h[A2];
          break;
        }
    v4 && (u[D(v4)] = true);
    function D(P) {
      return P.dim + "_" + P.index;
    }
  }
  function _it(l3) {
    return l3 && l3.type !== "category" && l3.type !== "time" && cvn(l3);
  }
  function Q0n(l3, r3) {
    var e3 = l3.getExtent(), u = e3[0] + e3[1];
    l3.toGlobalCoord = l3.dim === "x" ? function(h) {
      return h + r3;
    } : function(h) {
      return u - h + r3;
    }, l3.toLocalCoord = l3.dim === "x" ? function(h) {
      return h - r3;
    } : function(h) {
      return u - h + r3;
    };
  }
  var eyn = J0n, GO = Math.PI, jN = function() {
    function l3(r3, e3) {
      this.group = new Cs(), this.opt = e3, this.axisModel = r3, ns(e3, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
        return true;
      } });
      var u = new Cs({ x: e3.position[0], y: e3.position[1], rotation: e3.rotation });
      u.updateTransform(), this._transformGroup = u;
    }
    return l3.prototype.hasBuilder = function(r3) {
      return !!xit[r3];
    }, l3.prototype.add = function(r3) {
      xit[r3](this.opt, this.axisModel, this.group, this._transformGroup);
    }, l3.prototype.getGroup = function() {
      return this.group;
    }, l3.innerTextLayout = function(r3, e3, u) {
      var h = put(e3 - r3), v4, m3;
      return Ufe(h) ? (m3 = u > 0 ? "top" : "bottom", v4 = "center") : Ufe(h - GO) ? (m3 = u > 0 ? "bottom" : "top", v4 = "center") : (m3 = "middle", h > 0 && h < GO ? v4 = u > 0 ? "right" : "left" : v4 = u > 0 ? "left" : "right"), { rotation: h, textAlign: v4, textVerticalAlign: m3 };
    }, l3.makeAxisEventDataBase = function(r3) {
      var e3 = { componentType: r3.mainType, componentIndex: r3.componentIndex };
      return e3[r3.mainType + "Index"] = r3.componentIndex, e3;
    }, l3.isLabelSilent = function(r3) {
      var e3 = r3.get("tooltip");
      return r3.get("silent") || !(r3.get("triggerEvent") || e3 && e3.show);
    }, l3;
  }(), xit = { axisLine: function(l3, r3, e3, u) {
    var h = r3.get(["axisLine", "show"]);
    if (h === "auto" && l3.handleAutoShown && (h = l3.handleAutoShown("axisLine")), !!h) {
      var v4 = r3.axis.getExtent(), m3 = u.transform, x3 = [v4[0], 0], C = [v4[1], 0];
      m3 && (am(x3, x3, m3), am(C, C, m3));
      var A2 = fi({ lineCap: "round" }, r3.getModel(["axisLine", "lineStyle"]).getLineStyle()), D = new ty({ subPixelOptimize: true, shape: { x1: x3[0], y1: x3[1], x2: C[0], y2: C[1] }, style: A2, strokeContainThreshold: l3.strokeContainThreshold || 5, silent: true, z2: 1 });
      D.anid = "line", e3.add(D);
      var P = r3.get(["axisLine", "symbol"]);
      if (P != null) {
        var N = r3.get(["axisLine", "symbolSize"]);
        qa(P) && (P = [P, P]), (qa(N) || Vc(N)) && (N = [N, N]);
        var j = Pj(r3.get(["axisLine", "symbolOffset"]) || 0, N), W = N[0], K = N[1];
        mt([{ rotate: l3.rotation + Math.PI / 2, offset: j[0], r: 0 }, { rotate: l3.rotation - Math.PI / 2, offset: j[1], r: Math.sqrt((x3[0] - C[0]) * (x3[0] - C[0]) + (x3[1] - C[1]) * (x3[1] - C[1])) }], function(te, ne) {
          if (P[ne] !== "none" && P[ne] != null) {
            var ce = Nv(P[ne], -W / 2, -K / 2, W, K, A2.stroke, true), me = te.r + te.offset;
            ce.attr({ rotation: te.rotate, x: x3[0] + me * Math.cos(l3.rotation), y: x3[1] - me * Math.sin(l3.rotation), silent: true, z2: 11 }), e3.add(ce);
          }
        });
      }
    }
  }, axisTickLabel: function(l3, r3, e3, u) {
    var h = ryn(e3, u, r3, l3), v4 = ayn(e3, u, r3, l3);
    if (nyn(r3, v4, h), iyn(e3, u, r3, l3.tickDirection), r3.get(["axisLabel", "hideOverlap"])) {
      var m3 = Pht(Bi(v4, function(x3) {
        return { label: x3, priority: x3.z2, defaultAttr: { ignore: x3.ignore } };
      }));
      Nht(m3);
    }
  }, axisName: function(l3, r3, e3, u) {
    var h = ey(l3.axisName, r3.get("name"));
    if (!!h) {
      var v4 = r3.get("nameLocation"), m3 = l3.nameDirection, x3 = r3.getModel("nameTextStyle"), C = r3.get("nameGap") || 0, A2 = r3.axis.getExtent(), D = A2[0] > A2[1] ? -1 : 1, P = [v4 === "start" ? A2[0] - D * C : v4 === "end" ? A2[1] + D * C : (A2[0] + A2[1]) / 2, Sit(v4) ? l3.labelOffset + m3 * C : 0], N, j = r3.get("nameRotate");
      j != null && (j = j * GO / 180);
      var W;
      Sit(v4) ? N = jN.innerTextLayout(l3.rotation, j != null ? j : l3.rotation, m3) : (N = tyn(l3.rotation, v4, j || 0, A2), W = l3.axisNameAvailableWidth, W != null && (W = Math.abs(W / Math.sin(N.rotation)), !isFinite(W) && (W = null)));
      var K = x3.getFont(), te = r3.get("nameTruncate", true) || {}, ne = te.ellipsis, ce = ey(l3.nameTruncateMaxWidth, te.maxWidth, W), me = new Ec({ x: P[0], y: P[1], rotation: N.rotation, silent: jN.isLabelSilent(r3), style: ov(x3, { text: h, font: K, overflow: "truncate", width: ce, ellipsis: ne, fill: x3.getTextColor() || r3.get(["axisLine", "lineStyle", "color"]), align: x3.get("align") || N.textAlign, verticalAlign: x3.get("verticalAlign") || N.textVerticalAlign }), z2: 1 });
      if (Cj({ el: me, componentModel: r3, itemName: h }), me.__fullText = h, me.anid = "name", r3.get("triggerEvent")) {
        var ve = jN.makeAxisEventDataBase(r3);
        ve.targetType = "axisName", ve.name = h, Ps(me).eventData = ve;
      }
      u.add(me), me.updateTransform(), e3.add(me), me.decomposeTransform();
    }
  } };
  function tyn(l3, r3, e3, u) {
    var h = put(e3 - l3), v4, m3, x3 = u[0] > u[1], C = r3 === "start" && !x3 || r3 !== "start" && x3;
    return Ufe(h - GO / 2) ? (m3 = C ? "bottom" : "top", v4 = "center") : Ufe(h - GO * 1.5) ? (m3 = C ? "top" : "bottom", v4 = "center") : (m3 = "middle", h < GO * 1.5 && h > GO / 2 ? v4 = C ? "left" : "right" : v4 = C ? "right" : "left"), { rotation: h, textAlign: v4, textVerticalAlign: m3 };
  }
  function nyn(l3, r3, e3) {
    if (!xht(l3.axis)) {
      var u = l3.get(["axisLabel", "showMinLabel"]), h = l3.get(["axisLabel", "showMaxLabel"]);
      r3 = r3 || [], e3 = e3 || [];
      var v4 = r3[0], m3 = r3[1], x3 = r3[r3.length - 1], C = r3[r3.length - 2], A2 = e3[0], D = e3[1], P = e3[e3.length - 1], N = e3[e3.length - 2];
      u === false ? (n2(v4), n2(A2)) : wit(v4, m3) && (u ? (n2(m3), n2(D)) : (n2(v4), n2(A2))), h === false ? (n2(x3), n2(P)) : wit(C, x3) && (h ? (n2(C), n2(N)) : (n2(x3), n2(P)));
    }
  }
  function n2(l3) {
    l3 && (l3.ignore = true);
  }
  function wit(l3, r3) {
    var e3 = l3 && l3.getBoundingRect().clone(), u = r3 && r3.getBoundingRect().clone();
    if (!(!e3 || !u)) {
      var h = jhe([]);
      return ZN(h, h, -l3.rotation), e3.applyTransform(i5([], h, l3.getLocalTransform())), u.applyTransform(i5([], h, r3.getLocalTransform())), e3.intersect(u);
    }
  }
  function Sit(l3) {
    return l3 === "middle" || l3 === "center";
  }
  function dpt(l3, r3, e3, u, h) {
    for (var v4 = [], m3 = [], x3 = [], C = 0; C < l3.length; C++) {
      var A2 = l3[C].coord;
      m3[0] = A2, m3[1] = 0, x3[0] = A2, x3[1] = e3, r3 && (am(m3, m3, r3), am(x3, x3, r3));
      var D = new ty({ subPixelOptimize: true, shape: { x1: m3[0], y1: m3[1], x2: x3[0], y2: x3[1] }, style: u, z2: 2, autoBatch: true, silent: true });
      D.anid = h + "_" + l3[C].tickValue, v4.push(D);
    }
    return v4;
  }
  function ryn(l3, r3, e3, u) {
    var h = e3.axis, v4 = e3.getModel("axisTick"), m3 = v4.get("show");
    if (m3 === "auto" && u.handleAutoShown && (m3 = u.handleAutoShown("axisTick")), !(!m3 || h.scale.isBlank())) {
      for (var x3 = v4.getModel("lineStyle"), C = u.tickDirection * v4.get("length"), A2 = h.getTicksCoords(), D = dpt(A2, r3.transform, C, ns(x3.getLineStyle(), { stroke: e3.get(["axisLine", "lineStyle", "color"]) }), "ticks"), P = 0; P < D.length; P++)
        l3.add(D[P]);
      return D;
    }
  }
  function iyn(l3, r3, e3, u) {
    var h = e3.axis, v4 = e3.getModel("minorTick");
    if (!(!v4.get("show") || h.scale.isBlank())) {
      var m3 = h.getMinorTicksCoords();
      if (!!m3.length)
        for (var x3 = v4.getModel("lineStyle"), C = u * v4.get("length"), A2 = ns(x3.getLineStyle(), ns(e3.getModel("axisTick").getLineStyle(), { stroke: e3.get(["axisLine", "lineStyle", "color"]) })), D = 0; D < m3.length; D++)
          for (var P = dpt(m3[D], r3.transform, C, A2, "minorticks_" + D), N = 0; N < P.length; N++)
            l3.add(P[N]);
    }
  }
  function ayn(l3, r3, e3, u) {
    var h = e3.axis, v4 = ey(u.axisLabelShow, e3.get(["axisLabel", "show"]));
    if (!(!v4 || h.scale.isBlank())) {
      var m3 = e3.getModel("axisLabel"), x3 = m3.get("margin"), C = h.getViewLabels(), A2 = (ey(u.labelRotate, m3.get("rotate")) || 0) * GO / 180, D = jN.innerTextLayout(u.rotation, A2, u.labelDirection), P = e3.getCategories && e3.getCategories(true), N = [], j = jN.isLabelSilent(e3), W = e3.get("triggerEvent");
      return mt(C, function(K, te) {
        var ne = h.scale.type === "ordinal" ? h.scale.getRawOrdinalNumber(K.tickValue) : K.tickValue, ce = K.formattedLabel, me = K.rawLabel, ve = m3;
        if (P && P[ne]) {
          var Be = P[ne];
          ls(Be) && Be.textStyle && (ve = new Bh(Be.textStyle, m3, e3.ecModel));
        }
        var Oe = ve.getTextColor() || e3.get(["axisLine", "lineStyle", "color"]), We = h.dataToCoord(ne), Ue = new Ec({ x: We, y: u.labelOffset + u.labelDirection * x3, rotation: D.rotation, silent: j, z2: 10 + (K.level || 0), style: ov(ve, { text: ce, align: ve.getShallow("align", true) || D.textAlign, verticalAlign: ve.getShallow("verticalAlign", true) || ve.getShallow("baseline", true) || D.textVerticalAlign, fill: Xo(Oe) ? Oe(h.type === "category" ? me : h.type === "value" ? ne + "" : ne, te) : Oe }) });
        if (Ue.anid = "label_" + ne, W) {
          var qe = jN.makeAxisEventDataBase(e3);
          qe.targetType = "axisLabel", qe.value = me, qe.tickIndex = te, h.type === "category" && (qe.dataIndex = ne), Ps(Ue).eventData = qe;
        }
        r3.add(Ue), Ue.updateTransform(), N.push(Ue), l3.add(Ue), Ue.decomposeTransform();
      }), N;
    }
  }
  var h5 = jN;
  function oyn(l3, r3) {
    var e3 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
    return syn(e3, l3, r3), e3.seriesInvolved && uyn(e3, l3), e3;
  }
  function syn(l3, r3, e3) {
    var u = r3.getComponent("tooltip"), h = r3.getComponent("axisPointer"), v4 = h.get("link", true) || [], m3 = [];
    mt(e3.getCoordinateSystems(), function(x3) {
      if (!x3.axisPointerEnabled)
        return;
      var C = yJ(x3.model), A2 = l3.coordSysAxesInfo[C] = {};
      l3.coordSysMap[C] = x3;
      var D = x3.model, P = D.getModel("tooltip", u);
      if (mt(x3.getAxes(), Fs(K, false, null)), x3.getTooltipAxes && u && P.get("show")) {
        var N = P.get("trigger") === "axis", j = P.get(["axisPointer", "type"]) === "cross", W = x3.getTooltipAxes(P.get(["axisPointer", "axis"]));
        (N || j) && mt(W.baseAxes, Fs(K, j ? "cross" : true, N)), j && mt(W.otherAxes, Fs(K, "cross", false));
      }
      function K(te, ne, ce) {
        var me = ce.model.getModel("axisPointer", h), ve = me.get("show");
        if (!(!ve || ve === "auto" && !te && !Cke(me))) {
          ne == null && (ne = me.get("triggerTooltip")), me = te ? lyn(ce, P, h, r3, te, ne) : me;
          var Be = me.get("snap"), Oe = yJ(ce.model), We = ne || Be || ce.type === "category", Ue = l3.axesInfo[Oe] = { key: Oe, axis: ce, coordSys: x3, axisPointerModel: me, triggerTooltip: ne, involveSeries: We, snap: Be, useHandle: Cke(me), seriesModels: [], linkGroup: null };
          A2[Oe] = Ue, l3.seriesInvolved = l3.seriesInvolved || We;
          var qe = cyn(v4, ce);
          if (qe != null) {
            var Ze = m3[qe] || (m3[qe] = { axesInfo: {} });
            Ze.axesInfo[Oe] = Ue, Ze.mapper = v4[qe].mapper, Ue.linkGroup = Ze;
          }
        }
      }
    });
  }
  function lyn(l3, r3, e3, u, h, v4) {
    var m3 = r3.getModel("axisPointer"), x3 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], C = {};
    mt(x3, function(N) {
      C[N] = bs(m3.get(N));
    }), C.snap = l3.type !== "category" && !!v4, m3.get("type") === "cross" && (C.type = "line");
    var A2 = C.label || (C.label = {});
    if (A2.show == null && (A2.show = false), h === "cross") {
      var D = m3.get(["label", "show"]);
      if (A2.show = D != null ? D : true, !v4) {
        var P = C.lineStyle = m3.get("crossStyle");
        P && ns(A2, P.textStyle);
      }
    }
    return l3.model.getModel("axisPointer", new Bh(C, e3, u));
  }
  function uyn(l3, r3) {
    r3.eachSeries(function(e3) {
      var u = e3.coordinateSystem, h = e3.get(["tooltip", "trigger"], true), v4 = e3.get(["tooltip", "show"], true);
      !u || h === "none" || h === false || h === "item" || v4 === false || e3.get(["axisPointer", "show"], true) === false || mt(l3.coordSysAxesInfo[yJ(u.model)], function(m3) {
        var x3 = m3.axis;
        u.getAxis(x3.dim) === x3 && (m3.seriesModels.push(e3), m3.seriesDataCount == null && (m3.seriesDataCount = 0), m3.seriesDataCount += e3.getData().count());
      });
    });
  }
  function cyn(l3, r3) {
    for (var e3 = r3.model, u = r3.dim, h = 0; h < l3.length; h++) {
      var v4 = l3[h] || {};
      if (aDe(v4[u + "AxisId"], e3.id) || aDe(v4[u + "AxisIndex"], e3.componentIndex) || aDe(v4[u + "AxisName"], e3.name))
        return h;
    }
  }
  function aDe(l3, r3) {
    return l3 === "all" || Ni(l3) && Cl(l3, r3) >= 0 || l3 === r3;
  }
  function fyn(l3) {
    var r3 = POe(l3);
    if (!!r3) {
      var e3 = r3.axisPointerModel, u = r3.axis.scale, h = e3.option, v4 = e3.get("status"), m3 = e3.get("value");
      m3 != null && (m3 = u.parse(m3));
      var x3 = Cke(e3);
      v4 == null && (h.status = x3 ? "show" : "hide");
      var C = u.getExtent().slice();
      C[0] > C[1] && C.reverse(), (m3 == null || m3 > C[1]) && (m3 = C[1]), m3 < C[0] && (m3 = C[0]), h.value = m3, x3 && (h.status = r3.axis.scale.isBlank() ? "hide" : "show");
    }
  }
  function POe(l3) {
    var r3 = (l3.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
    return r3 && r3.axesInfo[yJ(l3)];
  }
  function hyn(l3) {
    var r3 = POe(l3);
    return r3 && r3.axisPointerModel;
  }
  function Cke(l3) {
    return !!l3.get(["handle", "show"]);
  }
  function yJ(l3) {
    return l3.type + "||" + l3.id;
  }
  var Cit = {}, pyn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      this.axisPointerClass && fyn(e3), l3.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(e3, h, true);
    }, r3.prototype.updateAxisPointer = function(e3, u, h, v4) {
      this._doUpdateAxisPointerClass(e3, h, false);
    }, r3.prototype.remove = function(e3, u) {
      var h = this._axisPointer;
      h && h.remove(u);
    }, r3.prototype.dispose = function(e3, u) {
      this._disposeAxisPointer(u), l3.prototype.dispose.apply(this, arguments);
    }, r3.prototype._doUpdateAxisPointerClass = function(e3, u, h) {
      var v4 = r3.getAxisPointerClass(this.axisPointerClass);
      if (!!v4) {
        var m3 = hyn(e3);
        m3 ? (this._axisPointer || (this._axisPointer = new v4())).render(e3, m3, u, h) : this._disposeAxisPointer(u);
      }
    }, r3.prototype._disposeAxisPointer = function(e3) {
      this._axisPointer && this._axisPointer.dispose(e3), this._axisPointer = null;
    }, r3.registerAxisPointerClass = function(e3, u) {
      Cit[e3] = u;
    }, r3.getAxisPointerClass = function(e3) {
      return e3 && Cit[e3];
    }, r3.type = "axis", r3;
  }(yd), eF = pyn, Mke = pc();
  function vpt(l3, r3, e3, u) {
    var h = e3.axis;
    if (!h.scale.isBlank()) {
      var v4 = e3.getModel("splitArea"), m3 = v4.getModel("areaStyle"), x3 = m3.get("color"), C = u.coordinateSystem.getRect(), A2 = h.getTicksCoords({ tickModel: v4, clamp: true });
      if (!!A2.length) {
        var D = x3.length, P = Mke(l3).splitAreaColors, N = Ho(), j = 0;
        if (P)
          for (var W = 0; W < A2.length; W++) {
            var K = P.get(A2[W].tickValue);
            if (K != null) {
              j = (K + (D - 1) * W) % D;
              break;
            }
          }
        var te = h.toGlobalCoord(A2[0].coord), ne = m3.getAreaStyle();
        x3 = Ni(x3) ? x3 : [x3];
        for (var W = 1; W < A2.length; W++) {
          var ce = h.toGlobalCoord(A2[W].coord), me = void 0, ve = void 0, Be = void 0, Oe = void 0;
          h.isHorizontal() ? (me = te, ve = C.y, Be = ce - me, Oe = C.height, te = me + Be) : (me = C.x, ve = te, Be = C.width, Oe = ce - ve, te = ve + Oe);
          var We = A2[W - 1].tickValue;
          We != null && N.set(We, j), r3.add(new Ju({ anid: We != null ? "area_" + We : null, shape: { x: me, y: ve, width: Be, height: Oe }, style: ns({ fill: x3[j] }, ne), autoBatch: true, silent: true })), j = (j + 1) % D;
        }
        Mke(l3).splitAreaColors = N;
      }
    }
  }
  function gpt(l3) {
    Mke(l3).splitAreaColors = null;
  }
  var dyn = ["axisLine", "axisTickLabel", "axisName"], vyn = ["splitArea", "splitLine", "minorSplitLine"], ypt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.axisPointerClass = "CartesianAxisPointer", e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      this.group.removeAll();
      var m3 = this._axisGroup;
      if (this._axisGroup = new Cs(), this.group.add(this._axisGroup), !!e3.get("show")) {
        var x3 = e3.getCoordSysModel(), C = Ske(x3, e3), A2 = new h5(e3, fi({ handleAutoShown: function(P) {
          for (var N = x3.coordinateSystem.getCartesians(), j = 0; j < N.length; j++)
            if (vke(N[j].getOtherAxis(e3.axis).scale))
              return true;
          return false;
        } }, C));
        mt(dyn, A2.add, A2), this._axisGroup.add(A2.getGroup()), mt(vyn, function(P) {
          e3.get([P, "show"]) && gyn[P](this, this._axisGroup, e3, x3);
        }, this);
        var D = v4 && v4.type === "changeAxisOrder" && v4.isInitSort;
        D || LJ(m3, this._axisGroup, e3), l3.prototype.render.call(this, e3, u, h, v4);
      }
    }, r3.prototype.remove = function() {
      gpt(this);
    }, r3.type = "cartesianAxis", r3;
  }(eF), gyn = { splitLine: function(l3, r3, e3, u) {
    var h = e3.axis;
    if (!h.scale.isBlank()) {
      var v4 = e3.getModel("splitLine"), m3 = v4.getModel("lineStyle"), x3 = m3.get("color");
      x3 = Ni(x3) ? x3 : [x3];
      for (var C = u.coordinateSystem.getRect(), A2 = h.isHorizontal(), D = 0, P = h.getTicksCoords({ tickModel: v4 }), N = [], j = [], W = m3.getLineStyle(), K = 0; K < P.length; K++) {
        var te = h.toGlobalCoord(P[K].coord);
        A2 ? (N[0] = te, N[1] = C.y, j[0] = te, j[1] = C.y + C.height) : (N[0] = C.x, N[1] = te, j[0] = C.x + C.width, j[1] = te);
        var ne = D++ % x3.length, ce = P[K].tickValue;
        r3.add(new ty({ anid: ce != null ? "line_" + P[K].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: N[0], y1: N[1], x2: j[0], y2: j[1] }, style: ns({ stroke: x3[ne] }, W), silent: true }));
      }
    }
  }, minorSplitLine: function(l3, r3, e3, u) {
    var h = e3.axis, v4 = e3.getModel("minorSplitLine"), m3 = v4.getModel("lineStyle"), x3 = u.coordinateSystem.getRect(), C = h.isHorizontal(), A2 = h.getMinorTicksCoords();
    if (!!A2.length)
      for (var D = [], P = [], N = m3.getLineStyle(), j = 0; j < A2.length; j++)
        for (var W = 0; W < A2[j].length; W++) {
          var K = h.toGlobalCoord(A2[j][W].coord);
          C ? (D[0] = K, D[1] = x3.y, P[0] = K, P[1] = x3.y + x3.height) : (D[0] = x3.x, D[1] = K, P[0] = x3.x + x3.width, P[1] = K), r3.add(new ty({ anid: "minor_line_" + A2[j][W].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: D[0], y1: D[1], x2: P[0], y2: P[1] }, style: N, silent: true }));
        }
  }, splitArea: function(l3, r3, e3, u) {
    vpt(l3, r3, e3, u);
  } }, mpt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "xAxis", r3;
  }(ypt), yyn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = mpt.type, e3;
    }
    return r3.type = "yAxis", r3;
  }(ypt), myn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "grid", e3;
    }
    return r3.prototype.render = function(e3, u) {
      this.group.removeAll(), e3.get("show") && this.group.add(new Ju({ shape: e3.coordinateSystem.getRect(), style: ns({ fill: e3.get("backgroundColor") }, e3.getItemStyle()), silent: true, z2: -1 }));
    }, r3.type = "grid", r3;
  }(yd), Mit = { offset: 0 };
  function bpt(l3) {
    l3.registerComponentView(myn), l3.registerComponentModel(j0n), l3.registerCoordinateSystem("cartesian2d", eyn), vj(l3, "x", xke, Mit), vj(l3, "y", xke, Mit), l3.registerComponentView(mpt), l3.registerComponentView(yyn), l3.registerPreprocessor(function(r3) {
      r3.xAxis && r3.yAxis && !r3.grid && (r3.grid = {});
    });
  }
  function byn(l3) {
    kl(bpt), l3.registerSeriesModel(P0n), l3.registerChartView(B0n), l3.registerLayout(UJ("scatter"));
  }
  function _yn(l3) {
    l3.eachSeriesByType("radar", function(r3) {
      var e3 = r3.getData(), u = [], h = r3.coordinateSystem;
      if (!!h) {
        var v4 = h.getIndicatorAxes();
        mt(v4, function(m3, x3) {
          e3.each(e3.mapDimension(v4[x3].dim), function(C, A2) {
            u[A2] = u[A2] || [];
            var D = h.dataToPoint(C, x3);
            u[A2][x3] = Tit(D) ? D : Ait(h);
          });
        }), e3.each(function(m3) {
          var x3 = rsn(u[m3], function(C) {
            return Tit(C);
          }) || Ait(h);
          u[m3].push(x3.slice()), e3.setItemLayout(m3, u[m3]);
        });
      }
    });
  }
  function Tit(l3) {
    return !isNaN(l3[0]) && !isNaN(l3[1]);
  }
  function Ait(l3) {
    return [l3.cx, l3.cy];
  }
  function xyn(l3) {
    var r3 = l3.polar;
    if (r3) {
      Ni(r3) || (r3 = [r3]);
      var e3 = [];
      mt(r3, function(u, h) {
        u.indicator ? (u.type && !u.shape && (u.shape = u.type), l3.radar = l3.radar || [], Ni(l3.radar) || (l3.radar = [l3.radar]), l3.radar.push(u)) : e3.push(u);
      }), l3.polar = e3;
    }
    mt(l3.series, function(u) {
      u && u.type === "radar" && u.polarIndex && (u.radarIndex = u.polarIndex);
    });
  }
  var wyn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = e3.coordinateSystem, m3 = this.group, x3 = e3.getData(), C = this._data;
      function A2(N, j) {
        var W = N.getItemVisual(j, "symbol") || "circle";
        if (W !== "none") {
          var K = BJ(N.getItemVisual(j, "symbolSize")), te = Nv(W, -1, -1, 2, 2), ne = N.getItemVisual(j, "symbolRotate") || 0;
          return te.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: K[0] / 2, scaleY: K[1] / 2, rotation: ne * Math.PI / 180 || 0 }), te;
        }
      }
      function D(N, j, W, K, te, ne) {
        W.removeAll();
        for (var ce = 0; ce < j.length - 1; ce++) {
          var me = A2(K, te);
          me && (me.__dimIdx = ce, N[ce] ? (me.setPosition(N[ce]), NJ[ne ? "initProps" : "updateProps"](me, { x: j[ce][0], y: j[ce][1] }, e3, te)) : me.setPosition(j[ce]), W.add(me));
        }
      }
      function P(N) {
        return Bi(N, function(j) {
          return [v4.cx, v4.cy];
        });
      }
      x3.diff(C).add(function(N) {
        var j = x3.getItemLayout(N);
        if (!!j) {
          var W = new C_(), K = new M_(), te = { shape: { points: j } };
          W.shape.points = P(j), K.shape.points = P(j), Np(W, te, e3, N), Np(K, te, e3, N);
          var ne = new Cs(), ce = new Cs();
          ne.add(K), ne.add(W), ne.add(ce), D(K.shape.points, j, ce, x3, N, true), x3.setItemGraphicEl(N, ne);
        }
      }).update(function(N, j) {
        var W = C.getItemGraphicEl(j), K = W.childAt(0), te = W.childAt(1), ne = W.childAt(2), ce = { shape: { points: x3.getItemLayout(N) } };
        !ce.shape.points || (D(K.shape.points, ce.shape.points, ne, x3, N, false), yM(te), yM(K), hc(K, ce, e3), hc(te, ce, e3), x3.setItemGraphicEl(N, W));
      }).remove(function(N) {
        m3.remove(C.getItemGraphicEl(N));
      }).execute(), x3.eachItemGraphicEl(function(N, j) {
        var W = x3.getItemModel(j), K = N.childAt(0), te = N.childAt(1), ne = N.childAt(2), ce = x3.getItemVisual(j, "style"), me = ce.fill;
        m3.add(N), K.useStyle(ns(W.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: me })), sm(K, W, "lineStyle"), sm(te, W, "areaStyle");
        var ve = W.getModel("areaStyle"), Be = ve.isEmpty() && ve.parentModel.isEmpty();
        te.ignore = Be, mt(["emphasis", "select", "blur"], function(Ue) {
          var qe = W.getModel([Ue, "areaStyle"]), Ze = qe.isEmpty() && qe.parentModel.isEmpty();
          te.ensureState(Ue).ignore = Ze && Be;
        }), te.useStyle(ns(ve.getAreaStyle(), { fill: me, opacity: 0.7, decal: ce.decal }));
        var Oe = W.getModel("emphasis"), We = Oe.getModel("itemStyle").getItemStyle();
        ne.eachChild(function(Ue) {
          if (Ue instanceof lm) {
            var qe = Ue.style;
            Ue.useStyle(fi({ image: qe.image, x: qe.x, y: qe.y, width: qe.width, height: qe.height }, ce));
          } else
            Ue.useStyle(ce), Ue.setColor(me), Ue.style.strokeNoScale = true;
          var Ze = Ue.ensureState("emphasis");
          Ze.style = bs(We);
          var ct = x3.getStore().get(x3.getDimensionIndex(Ue.__dimIdx), j);
          (ct == null || isNaN(ct)) && (ct = ""), _1(Ue, ny(W), { labelFetcher: x3.hostModel, labelDataIndex: j, labelDimIndex: Ue.__dimIdx, defaultText: ct, inheritColor: me, defaultOpacity: ce.opacity });
        }), Gd(N, Oe.get("focus"), Oe.get("blurScope"), Oe.get("disabled"));
      }), this._data = x3;
    }, r3.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, r3.type = "radar", r3;
  }(zh), Syn = wyn, Cyn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.hasSymbolVisual = true, e3;
    }
    return r3.prototype.init = function(e3) {
      l3.prototype.init.apply(this, arguments), this.legendVisualProvider = new $J(no(this.getData, this), no(this.getRawData, this));
    }, r3.prototype.getInitialData = function(e3, u) {
      return Lj(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      var v4 = this.getData(), m3 = this.coordinateSystem, x3 = m3.getIndicatorAxes(), C = this.getData().getName(e3), A2 = C === "" ? this.name : C, D = yft(this, e3);
      return o0("section", { header: A2, sortBlocks: true, blocks: Bi(x3, function(P) {
        var N = v4.get(v4.mapDimension(P.dim), e3);
        return o0("nameValue", { markerType: "subItem", markerColor: D, name: P.name, value: N, sortParam: N });
      }) });
    }, r3.prototype.getTooltipPosition = function(e3) {
      if (e3 != null) {
        for (var u = this.getData(), h = this.coordinateSystem, v4 = u.getValues(Bi(h.dimensions, function(A2) {
          return u.mapDimension(A2);
        }), e3), m3 = 0, x3 = v4.length; m3 < x3; m3++)
          if (!isNaN(v4[m3])) {
            var C = h.getIndicatorAxes();
            return h.coordToPoint(C[m3].dataToCoord(v4[m3]), m3);
          }
      }
    }, r3.type = "series.radar", r3.dependencies = ["radar"], r3.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, r3;
  }(Fp), Myn = Cyn, oZ = hpt.value;
  function qce(l3, r3) {
    return ns({ show: r3 }, l3);
  }
  var Tyn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.optionUpdated = function() {
      var e3 = this.get("boundaryGap"), u = this.get("splitNumber"), h = this.get("scale"), v4 = this.get("axisLine"), m3 = this.get("axisTick"), x3 = this.get("axisLabel"), C = this.get("axisName"), A2 = this.get(["axisName", "show"]), D = this.get(["axisName", "formatter"]), P = this.get("axisNameGap"), N = this.get("triggerEvent"), j = Bi(this.get("indicator") || [], function(W) {
        W.max != null && W.max > 0 && !W.min ? W.min = 0 : W.min != null && W.min < 0 && !W.max && (W.max = 0);
        var K = C;
        W.color != null && (K = ns({ color: W.color }, C));
        var te = ol(bs(W), { boundaryGap: e3, splitNumber: u, scale: h, axisLine: v4, axisTick: m3, axisLabel: x3, name: W.text, showName: A2, nameLocation: "end", nameGap: P, nameTextStyle: K, triggerEvent: N }, false);
        if (A2 || (te.name = ""), qa(D)) {
          var ne = te.name;
          te.name = D.replace("{value}", ne != null ? ne : "");
        } else
          Xo(D) && (te.name = D(te.name, te));
        var ce = new Bh(te, null, this.ecModel);
        return Fv(ce, GJ.prototype), ce.mainType = "radar", ce.componentIndex = this.componentIndex, ce;
      }, this);
      this._indicatorModels = j;
    }, r3.prototype.getIndicatorModels = function() {
      return this._indicatorModels;
    }, r3.type = "radar", r3.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: ol({ lineStyle: { color: "#bbb" } }, oZ.axisLine), axisLabel: qce(oZ.axisLabel, false), axisTick: qce(oZ.axisTick, false), splitLine: qce(oZ.splitLine, true), splitArea: qce(oZ.splitArea, true), indicator: [] }, r3;
  }(fc), Ayn = Tyn, Iyn = ["axisLine", "axisTickLabel", "axisName"], Eyn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = this.group;
      v4.removeAll(), this._buildAxes(e3), this._buildSplitLineAndArea(e3);
    }, r3.prototype._buildAxes = function(e3) {
      var u = e3.coordinateSystem, h = u.getIndicatorAxes(), v4 = Bi(h, function(m3) {
        var x3 = m3.model.get("showName") ? m3.name : "", C = new h5(m3.model, { axisName: x3, position: [u.cx, u.cy], rotation: m3.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
        return C;
      });
      mt(v4, function(m3) {
        mt(Iyn, m3.add, m3), this.group.add(m3.getGroup());
      }, this);
    }, r3.prototype._buildSplitLineAndArea = function(e3) {
      var u = e3.coordinateSystem, h = u.getIndicatorAxes();
      if (!h.length)
        return;
      var v4 = e3.get("shape"), m3 = e3.getModel("splitLine"), x3 = e3.getModel("splitArea"), C = m3.getModel("lineStyle"), A2 = x3.getModel("areaStyle"), D = m3.get("show"), P = x3.get("show"), N = C.get("color"), j = A2.get("color"), W = Ni(N) ? N : [N], K = Ni(j) ? j : [j], te = [], ne = [];
      function ce(Zt, Ft, Kn) {
        var hn = Kn % Ft.length;
        return Zt[hn] = Zt[hn] || [], hn;
      }
      if (v4 === "circle")
        for (var me = h[0].getTicksCoords(), ve = u.cx, Be = u.cy, Oe = 0; Oe < me.length; Oe++) {
          if (D) {
            var We = ce(te, W, Oe);
            te[We].push(new YA({ shape: { cx: ve, cy: Be, r: me[Oe].coord } }));
          }
          if (P && Oe < me.length - 1) {
            var We = ce(ne, K, Oe);
            ne[We].push(new Yhe({ shape: { cx: ve, cy: Be, r0: me[Oe].coord, r: me[Oe + 1].coord } }));
          }
        }
      else
        for (var Ue, qe = Bi(h, function(Zt, Ft) {
          var Kn = Zt.getTicksCoords();
          return Ue = Ue == null ? Kn.length - 1 : Math.min(Kn.length - 1, Ue), Bi(Kn, function(hn) {
            return u.coordToPoint(hn.coord, Ft);
          });
        }), Ze = [], Oe = 0; Oe <= Ue; Oe++) {
          for (var ct = [], _t = 0; _t < h.length; _t++)
            ct.push(qe[_t][Oe]);
          if (ct[0] && ct.push(ct[0].slice()), D) {
            var We = ce(te, W, Oe);
            te[We].push(new M_({ shape: { points: ct } }));
          }
          if (P && Ze) {
            var We = ce(ne, K, Oe - 1);
            ne[We].push(new C_({ shape: { points: ct.concat(Ze) } }));
          }
          Ze = ct.slice().reverse();
        }
      var pt = C.getLineStyle(), zt = A2.getAreaStyle();
      mt(ne, function(Zt, Ft) {
        this.group.add(d2(Zt, { style: ns({ stroke: "none", fill: K[Ft % K.length] }, zt), silent: true }));
      }, this), mt(te, function(Zt, Ft) {
        this.group.add(d2(Zt, { style: ns({ fill: "none", stroke: W[Ft % W.length] }, pt), silent: true }));
      }, this);
    }, r3.type = "radar", r3;
  }(yd), Dyn = Eyn, kyn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this, e3, u, h) || this;
      return v4.type = "value", v4.angle = 0, v4.name = "", v4;
    }
    return r3;
  }(bM), Oyn = kyn, Pyn = function() {
    function l3(r3, e3, u) {
      this.dimensions = [], this._model = r3, this._indicatorAxes = Bi(r3.getIndicatorModels(), function(h, v4) {
        var m3 = "indicator_" + v4, x3 = new Oyn(m3, new tP());
        return x3.name = h.get("name"), x3.model = h, h.axis = x3, this.dimensions.push(m3), x3;
      }, this), this.resize(r3, u);
    }
    return l3.prototype.getIndicatorAxes = function() {
      return this._indicatorAxes;
    }, l3.prototype.dataToPoint = function(r3, e3) {
      var u = this._indicatorAxes[e3];
      return this.coordToPoint(u.dataToCoord(r3), e3);
    }, l3.prototype.coordToPoint = function(r3, e3) {
      var u = this._indicatorAxes[e3], h = u.angle, v4 = this.cx + r3 * Math.cos(h), m3 = this.cy - r3 * Math.sin(h);
      return [v4, m3];
    }, l3.prototype.pointToData = function(r3) {
      var e3 = r3[0] - this.cx, u = r3[1] - this.cy, h = Math.sqrt(e3 * e3 + u * u);
      e3 /= h, u /= h;
      for (var v4 = Math.atan2(-u, e3), m3 = 1 / 0, x3, C = -1, A2 = 0; A2 < this._indicatorAxes.length; A2++) {
        var D = this._indicatorAxes[A2], P = Math.abs(v4 - D.angle);
        P < m3 && (x3 = D, C = A2, m3 = P);
      }
      return [C, +(x3 && x3.coordToData(h))];
    }, l3.prototype.resize = function(r3, e3) {
      var u = r3.get("center"), h = e3.getWidth(), v4 = e3.getHeight(), m3 = Math.min(h, v4) / 2;
      this.cx = za(u[0], h), this.cy = za(u[1], v4), this.startAngle = r3.get("startAngle") * Math.PI / 180;
      var x3 = r3.get("radius");
      (qa(x3) || Vc(x3)) && (x3 = [0, x3]), this.r0 = za(x3[0], m3), this.r = za(x3[1], m3), mt(this._indicatorAxes, function(C, A2) {
        C.setExtent(this.r0, this.r);
        var D = this.startAngle + A2 * Math.PI * 2 / this._indicatorAxes.length;
        D = Math.atan2(Math.sin(D), Math.cos(D)), C.angle = D;
      }, this);
    }, l3.prototype.update = function(r3, e3) {
      var u = this._indicatorAxes, h = this._model;
      mt(u, function(x3) {
        x3.scale.setExtent(1 / 0, -1 / 0);
      }), r3.eachSeriesByType("radar", function(x3, C) {
        if (!(x3.get("coordinateSystem") !== "radar" || r3.getComponent("radar", x3.get("radarIndex")) !== h)) {
          var A2 = x3.getData();
          mt(u, function(D) {
            D.scale.unionExtentFromData(A2, A2.mapDimension(D.dim));
          });
        }
      }, this);
      var v4 = h.get("splitNumber"), m3 = new tP();
      m3.setExtent(0, v4), m3.setInterval(1), mt(u, function(x3, C) {
        ppt(x3.scale, x3.model, m3);
      });
    }, l3.prototype.convertToPixel = function(r3, e3, u) {
      return console.warn("Not implemented."), null;
    }, l3.prototype.convertFromPixel = function(r3, e3, u) {
      return console.warn("Not implemented."), null;
    }, l3.prototype.containPoint = function(r3) {
      return console.warn("Not implemented."), false;
    }, l3.create = function(r3, e3) {
      var u = [];
      return r3.eachComponent("radar", function(h) {
        var v4 = new l3(h, r3, e3);
        u.push(v4), h.coordinateSystem = v4;
      }), r3.eachSeriesByType("radar", function(h) {
        h.get("coordinateSystem") === "radar" && (h.coordinateSystem = u[h.get("radarIndex") || 0]);
      }), u;
    }, l3.dimensions = [], l3;
  }(), Lyn = Pyn;
  function Ryn(l3) {
    l3.registerCoordinateSystem("radar", Lyn), l3.registerComponentModel(Ayn), l3.registerComponentView(Dyn), l3.registerVisual({ seriesType: "radar", reset: function(r3) {
      var e3 = r3.getData();
      e3.each(function(u) {
        e3.setItemVisual(u, "legendIcon", "roundRect");
      }), e3.setVisual("legendIcon", "roundRect");
    } });
  }
  function Nyn(l3) {
    kl(Ryn), l3.registerChartView(Syn), l3.registerSeriesModel(Myn), l3.registerLayout(_yn), l3.registerProcessor(qJ("radar")), l3.registerPreprocessor(xyn);
  }
  var Iit = "\0_ec_interaction_mutex";
  function Fyn(l3, r3, e3) {
    var u = LOe(l3);
    u[r3] = e3;
  }
  function Vyn(l3, r3, e3) {
    var u = LOe(l3), h = u[r3];
    h === e3 && (u[r3] = null);
  }
  function Eit(l3, r3) {
    return !!LOe(l3)[r3];
  }
  function LOe(l3) {
    return l3[Iit] || (l3[Iit] = {});
  }
  ZA({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, Rv);
  var Byn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this) || this;
      u._zr = e3;
      var h = no(u._mousedownHandler, u), v4 = no(u._mousemoveHandler, u), m3 = no(u._mouseupHandler, u), x3 = no(u._mousewheelHandler, u), C = no(u._pinchHandler, u);
      return u.enable = function(A2, D) {
        this.disable(), this._opt = ns(bs(D) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), A2 == null && (A2 = true), (A2 === true || A2 === "move" || A2 === "pan") && (e3.on("mousedown", h), e3.on("mousemove", v4), e3.on("mouseup", m3)), (A2 === true || A2 === "scale" || A2 === "zoom") && (e3.on("mousewheel", x3), e3.on("pinch", C));
      }, u.disable = function() {
        e3.off("mousedown", h), e3.off("mousemove", v4), e3.off("mouseup", m3), e3.off("mousewheel", x3), e3.off("pinch", C);
      }, u;
    }
    return r3.prototype.isDragging = function() {
      return this._dragging;
    }, r3.prototype.isPinching = function() {
      return this._pinching;
    }, r3.prototype.setPointerChecker = function(e3) {
      this.pointerChecker = e3;
    }, r3.prototype.dispose = function() {
      this.disable();
    }, r3.prototype._mousedownHandler = function(e3) {
      if (!(ntt(e3) || e3.target && e3.target.draggable)) {
        var u = e3.offsetX, h = e3.offsetY;
        this.pointerChecker && this.pointerChecker(e3, u, h) && (this._x = u, this._y = h, this._dragging = true);
      }
    }, r3.prototype._mousemoveHandler = function(e3) {
      if (!(!this._dragging || !Dfe("moveOnMouseMove", e3, this._opt) || e3.gestureEvent === "pinch" || Eit(this._zr, "globalPan"))) {
        var u = e3.offsetX, h = e3.offsetY, v4 = this._x, m3 = this._y, x3 = u - v4, C = h - m3;
        this._x = u, this._y = h, this._opt.preventDefaultMouseMove && u5(e3.event), _pt(this, "pan", "moveOnMouseMove", e3, { dx: x3, dy: C, oldX: v4, oldY: m3, newX: u, newY: h, isAvailableBehavior: null });
      }
    }, r3.prototype._mouseupHandler = function(e3) {
      ntt(e3) || (this._dragging = false);
    }, r3.prototype._mousewheelHandler = function(e3) {
      var u = Dfe("zoomOnMouseWheel", e3, this._opt), h = Dfe("moveOnMouseWheel", e3, this._opt), v4 = e3.wheelDelta, m3 = Math.abs(v4), x3 = e3.offsetX, C = e3.offsetY;
      if (!(v4 === 0 || !u && !h)) {
        if (u) {
          var A2 = m3 > 3 ? 1.4 : m3 > 1 ? 1.2 : 1.1, D = v4 > 0 ? A2 : 1 / A2;
          oDe(this, "zoom", "zoomOnMouseWheel", e3, { scale: D, originX: x3, originY: C, isAvailableBehavior: null });
        }
        if (h) {
          var P = Math.abs(v4), N = (v4 > 0 ? 1 : -1) * (P > 3 ? 0.4 : P > 1 ? 0.15 : 0.05);
          oDe(this, "scrollMove", "moveOnMouseWheel", e3, { scrollDelta: N, originX: x3, originY: C, isAvailableBehavior: null });
        }
      }
    }, r3.prototype._pinchHandler = function(e3) {
      if (!Eit(this._zr, "globalPan")) {
        var u = e3.pinchScale > 1 ? 1.1 : 1 / 1.1;
        oDe(this, "zoom", null, e3, { scale: u, originX: e3.pinchX, originY: e3.pinchY, isAvailableBehavior: null });
      }
    }, r3;
  }(w2);
  function oDe(l3, r3, e3, u, h) {
    l3.pointerChecker && l3.pointerChecker(u, h.originX, h.originY) && (u5(u.event), _pt(l3, r3, e3, u, h));
  }
  function _pt(l3, r3, e3, u, h) {
    h.isAvailableBehavior = no(Dfe, null, e3, u), l3.trigger(r3, h);
  }
  function Dfe(l3, r3, e3) {
    var u = e3[l3];
    return !l3 || u && (!qa(u) || r3.event[u + "Key"]);
  }
  var XJ = Byn;
  function ROe(l3, r3, e3) {
    var u = l3.target;
    u.x += r3, u.y += e3, u.dirty();
  }
  function NOe(l3, r3, e3, u) {
    var h = l3.target, v4 = l3.zoomLimit, m3 = l3.zoom = l3.zoom || 1;
    if (m3 *= r3, v4) {
      var x3 = v4.min || 0, C = v4.max || 1 / 0;
      m3 = Math.max(Math.min(C, m3), x3);
    }
    var A2 = m3 / l3.zoom;
    l3.zoom = m3, h.x -= (e3 - h.x) * (A2 - 1), h.y -= (u - h.y) * (A2 - 1), h.scaleX *= A2, h.scaleY *= A2, h.dirty();
  }
  var zyn = { axisPointer: 1, tooltip: 1, brush: 1 };
  function gpe(l3, r3, e3) {
    var u = r3.getComponentByElement(l3.topTarget), h = u && u.coordinateSystem;
    return u && u !== e3 && !zyn.hasOwnProperty(u.mainType) && h && h.model !== e3;
  }
  function xpt(l3) {
    if (qa(l3)) {
      var r3 = new DOMParser();
      l3 = r3.parseFromString(l3, "text/xml");
    }
    var e3 = l3;
    for (e3.nodeType === 9 && (e3 = e3.firstChild); e3.nodeName.toLowerCase() !== "svg" || e3.nodeType !== 1; )
      e3 = e3.nextSibling;
    return e3;
  }
  var sDe, dhe = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, Dit = yu(dhe), vhe = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, kit = yu(vhe), jyn = function() {
    function l3() {
      this._defs = {}, this._root = null;
    }
    return l3.prototype.parse = function(r3, e3) {
      e3 = e3 || {};
      var u = xpt(r3);
      this._defsUsePending = [];
      var h = new Cs();
      this._root = h;
      var v4 = [], m3 = u.getAttribute("viewBox") || "", x3 = parseFloat(u.getAttribute("width") || e3.width), C = parseFloat(u.getAttribute("height") || e3.height);
      isNaN(x3) && (x3 = null), isNaN(C) && (C = null), Ux(u, h, null, true, false);
      for (var A2 = u.firstChild; A2; )
        this._parseNode(A2, h, v4, null, false, false), A2 = A2.nextSibling;
      Wyn(this._defs, this._defsUsePending), this._defsUsePending = [];
      var D, P;
      if (m3) {
        var N = ype(m3);
        N.length >= 4 && (D = { x: parseFloat(N[0] || 0), y: parseFloat(N[1] || 0), width: parseFloat(N[2]), height: parseFloat(N[3]) });
      }
      if (D && x3 != null && C != null && (P = Spt(D, { x: 0, y: 0, width: x3, height: C }), !e3.ignoreViewBox)) {
        var j = h;
        h = new Cs(), h.add(j), j.scaleX = j.scaleY = P.scale, j.x = P.x, j.y = P.y;
      }
      return !e3.ignoreRootClip && x3 != null && C != null && h.setClipPath(new Ju({ shape: { x: 0, y: 0, width: x3, height: C } })), { root: h, width: x3, height: C, viewBoxRect: D, viewBoxTransform: P, named: v4 };
    }, l3.prototype._parseNode = function(r3, e3, u, h, v4, m3) {
      var x3 = r3.nodeName.toLowerCase(), C, A2 = h;
      if (x3 === "defs" && (v4 = true), x3 === "text" && (m3 = true), x3 === "defs" || x3 === "switch")
        C = e3;
      else {
        if (!v4) {
          var D = sDe[x3];
          if (D && vo(sDe, x3)) {
            C = D.call(this, r3, e3);
            var P = r3.getAttribute("name");
            if (P) {
              var N = { name: P, namedFrom: null, svgNodeTagLower: x3, el: C };
              u.push(N), x3 === "g" && (A2 = N);
            } else
              h && u.push({ name: h.name, namedFrom: h, svgNodeTagLower: x3, el: C });
            e3.add(C);
          }
        }
        var j = Oit[x3];
        if (j && vo(Oit, x3)) {
          var W = j.call(this, r3), K = r3.getAttribute("id");
          K && (this._defs[K] = W);
        }
      }
      if (C && C.isGroup)
        for (var te = r3.firstChild; te; )
          te.nodeType === 1 ? this._parseNode(te, C, u, A2, v4, m3) : te.nodeType === 3 && m3 && this._parseText(te, C), te = te.nextSibling;
    }, l3.prototype._parseText = function(r3, e3) {
      var u = new nJ({ style: { text: r3.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
      r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), Gyn(u, e3);
      var h = u.style, v4 = h.fontSize;
      v4 && v4 < 9 && (h.fontSize = 9, u.scaleX *= v4 / 9, u.scaleY *= v4 / 9);
      var m3 = (h.fontSize || h.fontFamily) && [h.fontStyle, h.fontWeight, (h.fontSize || 12) + "px", h.fontFamily || "sans-serif"].join(" ");
      h.font = m3;
      var x3 = u.getBoundingRect();
      return this._textX += x3.width, e3.add(u), u;
    }, l3.internalField = function() {
      sDe = { g: function(r3, e3) {
        var u = new Cs();
        return r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), u;
      }, rect: function(r3, e3) {
        var u = new Ju();
        return r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), u.setShape({ x: parseFloat(r3.getAttribute("x") || "0"), y: parseFloat(r3.getAttribute("y") || "0"), width: parseFloat(r3.getAttribute("width") || "0"), height: parseFloat(r3.getAttribute("height") || "0") }), u.silent = true, u;
      }, circle: function(r3, e3) {
        var u = new YA();
        return r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), u.setShape({ cx: parseFloat(r3.getAttribute("cx") || "0"), cy: parseFloat(r3.getAttribute("cy") || "0"), r: parseFloat(r3.getAttribute("r") || "0") }), u.silent = true, u;
      }, line: function(r3, e3) {
        var u = new ty();
        return r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), u.setShape({ x1: parseFloat(r3.getAttribute("x1") || "0"), y1: parseFloat(r3.getAttribute("y1") || "0"), x2: parseFloat(r3.getAttribute("x2") || "0"), y2: parseFloat(r3.getAttribute("y2") || "0") }), u.silent = true, u;
      }, ellipse: function(r3, e3) {
        var u = new U3e();
        return r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), u.setShape({ cx: parseFloat(r3.getAttribute("cx") || "0"), cy: parseFloat(r3.getAttribute("cy") || "0"), rx: parseFloat(r3.getAttribute("rx") || "0"), ry: parseFloat(r3.getAttribute("ry") || "0") }), u.silent = true, u;
      }, polygon: function(r3, e3) {
        var u = r3.getAttribute("points"), h;
        u && (h = Rit(u));
        var v4 = new C_({ shape: { points: h || [] }, silent: true });
        return r2(e3, v4), Ux(r3, v4, this._defsUsePending, false, false), v4;
      }, polyline: function(r3, e3) {
        var u = r3.getAttribute("points"), h;
        u && (h = Rit(u));
        var v4 = new M_({ shape: { points: h || [] }, silent: true });
        return r2(e3, v4), Ux(r3, v4, this._defsUsePending, false, false), v4;
      }, image: function(r3, e3) {
        var u = new lm();
        return r2(e3, u), Ux(r3, u, this._defsUsePending, false, false), u.setStyle({ image: r3.getAttribute("xlink:href") || r3.getAttribute("href"), x: +r3.getAttribute("x"), y: +r3.getAttribute("y"), width: +r3.getAttribute("width"), height: +r3.getAttribute("height") }), u.silent = true, u;
      }, text: function(r3, e3) {
        var u = r3.getAttribute("x") || "0", h = r3.getAttribute("y") || "0", v4 = r3.getAttribute("dx") || "0", m3 = r3.getAttribute("dy") || "0";
        this._textX = parseFloat(u) + parseFloat(v4), this._textY = parseFloat(h) + parseFloat(m3);
        var x3 = new Cs();
        return r2(e3, x3), Ux(r3, x3, this._defsUsePending, false, true), x3;
      }, tspan: function(r3, e3) {
        var u = r3.getAttribute("x"), h = r3.getAttribute("y");
        u != null && (this._textX = parseFloat(u)), h != null && (this._textY = parseFloat(h));
        var v4 = r3.getAttribute("dx") || "0", m3 = r3.getAttribute("dy") || "0", x3 = new Cs();
        return r2(e3, x3), Ux(r3, x3, this._defsUsePending, false, true), this._textX += parseFloat(v4), this._textY += parseFloat(m3), x3;
      }, path: function(r3, e3) {
        var u = r3.getAttribute("d") || "", h = Qut(u);
        return r2(e3, h), Ux(r3, h, this._defsUsePending, false, false), h.silent = true, h;
      } };
    }(), l3;
  }(), Oit = { lineargradient: function(l3) {
    var r3 = parseInt(l3.getAttribute("x1") || "0", 10), e3 = parseInt(l3.getAttribute("y1") || "0", 10), u = parseInt(l3.getAttribute("x2") || "10", 10), h = parseInt(l3.getAttribute("y2") || "0", 10), v4 = new PJ(r3, e3, u, h);
    return Pit(l3, v4), Lit(l3, v4), v4;
  }, radialgradient: function(l3) {
    var r3 = parseInt(l3.getAttribute("cx") || "0", 10), e3 = parseInt(l3.getAttribute("cy") || "0", 10), u = parseInt(l3.getAttribute("r") || "0", 10), h = new hct(r3, e3, u);
    return Pit(l3, h), Lit(l3, h), h;
  } };
  function Pit(l3, r3) {
    var e3 = l3.getAttribute("gradientUnits");
    e3 === "userSpaceOnUse" && (r3.global = true);
  }
  function Lit(l3, r3) {
    for (var e3 = l3.firstChild; e3; ) {
      if (e3.nodeType === 1 && e3.nodeName.toLocaleLowerCase() === "stop") {
        var u = e3.getAttribute("offset"), h = void 0;
        u && u.indexOf("%") > 0 ? h = parseInt(u, 10) / 100 : u ? h = parseFloat(u) : h = 0;
        var v4 = {};
        wpt(e3, v4, v4);
        var m3 = v4.stopColor || e3.getAttribute("stop-color") || "#000000";
        r3.colorStops.push({ offset: h, color: m3 });
      }
      e3 = e3.nextSibling;
    }
  }
  function r2(l3, r3) {
    l3 && l3.__inheritedStyle && (r3.__inheritedStyle || (r3.__inheritedStyle = {}), ns(r3.__inheritedStyle, l3.__inheritedStyle));
  }
  function Rit(l3) {
    for (var r3 = ype(l3), e3 = [], u = 0; u < r3.length; u += 2) {
      var h = parseFloat(r3[u]), v4 = parseFloat(r3[u + 1]);
      e3.push([h, v4]);
    }
    return e3;
  }
  function Ux(l3, r3, e3, u, h) {
    var v4 = r3, m3 = v4.__inheritedStyle = v4.__inheritedStyle || {}, x3 = {};
    l3.nodeType === 1 && ($yn(l3, r3), wpt(l3, m3, x3), u || Xyn(l3, m3, x3)), v4.style = v4.style || {}, m3.fill != null && (v4.style.fill = Nit(v4, "fill", m3.fill, e3)), m3.stroke != null && (v4.style.stroke = Nit(v4, "stroke", m3.stroke, e3)), mt(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(C) {
      m3[C] != null && (v4.style[C] = parseFloat(m3[C]));
    }), mt(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(C) {
      m3[C] != null && (v4.style[C] = m3[C]);
    }), h && (v4.__selfStyle = x3), m3.lineDash && (v4.style.lineDash = Bi(ype(m3.lineDash), function(C) {
      return parseFloat(C);
    })), (m3.visibility === "hidden" || m3.visibility === "collapse") && (v4.invisible = true), m3.display === "none" && (v4.ignore = true);
  }
  function Gyn(l3, r3) {
    var e3 = r3.__selfStyle;
    if (e3) {
      var u = e3.textBaseline, h = u;
      !u || u === "auto" || u === "baseline" ? h = "alphabetic" : u === "before-edge" || u === "text-before-edge" ? h = "top" : u === "after-edge" || u === "text-after-edge" ? h = "bottom" : (u === "central" || u === "mathematical") && (h = "middle"), l3.style.textBaseline = h;
    }
    var v4 = r3.__inheritedStyle;
    if (v4) {
      var m3 = v4.textAlign, x3 = m3;
      m3 && (m3 === "middle" && (x3 = "center"), l3.style.textAlign = x3);
    }
  }
  var Hyn = /^url\(\s*#(.*?)\)/;
  function Nit(l3, r3, e3, u) {
    var h = e3 && e3.match(Hyn);
    if (h) {
      var v4 = hM(h[1]);
      u.push([l3, r3, v4]);
      return;
    }
    return e3 === "none" && (e3 = null), e3;
  }
  function Wyn(l3, r3) {
    for (var e3 = 0; e3 < r3.length; e3++) {
      var u = r3[e3];
      u[0].style[u[1]] = l3[u[2]];
    }
  }
  var Uyn = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
  function ype(l3) {
    return l3.match(Uyn) || [];
  }
  var qyn = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, lDe = Math.PI / 180;
  function $yn(l3, r3) {
    var e3 = l3.getAttribute("transform");
    if (e3) {
      e3 = e3.replace(/,/g, " ");
      var u = [], h = null;
      e3.replace(qyn, function(P, N, j) {
        return u.push(N, j), "";
      });
      for (var v4 = u.length - 1; v4 > 0; v4 -= 2) {
        var m3 = u[v4], x3 = u[v4 - 1], C = ype(m3);
        switch (h = h || _2(), x3) {
          case "translate":
            UA(h, h, [parseFloat(C[0]), parseFloat(C[1] || "0")]);
            break;
          case "scale":
            P3e(h, h, [parseFloat(C[0]), parseFloat(C[1] || C[0])]);
            break;
          case "rotate":
            ZN(h, h, -parseFloat(C[0]) * lDe);
            break;
          case "skewX":
            var A2 = Math.tan(parseFloat(C[0]) * lDe);
            i5(h, [1, 0, A2, 1, 0, 0], h);
            break;
          case "skewY":
            var D = Math.tan(parseFloat(C[0]) * lDe);
            i5(h, [1, D, 0, 1, 0, 0], h);
            break;
          case "matrix":
            h[0] = parseFloat(C[0]), h[1] = parseFloat(C[1]), h[2] = parseFloat(C[2]), h[3] = parseFloat(C[3]), h[4] = parseFloat(C[4]), h[5] = parseFloat(C[5]);
            break;
        }
      }
      r3.setLocalTransform(h);
    }
  }
  var Fit = /([^\s:;]+)\s*:\s*([^:;]+)/g;
  function wpt(l3, r3, e3) {
    var u = l3.getAttribute("style");
    if (!!u) {
      Fit.lastIndex = 0;
      for (var h; (h = Fit.exec(u)) != null; ) {
        var v4 = h[1], m3 = vo(dhe, v4) ? dhe[v4] : null;
        m3 && (r3[m3] = h[2]);
        var x3 = vo(vhe, v4) ? vhe[v4] : null;
        x3 && (e3[x3] = h[2]);
      }
    }
  }
  function Xyn(l3, r3, e3) {
    for (var u = 0; u < Dit.length; u++) {
      var h = Dit[u], v4 = l3.getAttribute(h);
      v4 != null && (r3[dhe[h]] = v4);
    }
    for (var u = 0; u < kit.length; u++) {
      var h = kit[u], v4 = l3.getAttribute(h);
      v4 != null && (e3[vhe[h]] = v4);
    }
  }
  function Spt(l3, r3) {
    var e3 = r3.width / l3.width, u = r3.height / l3.height, h = Math.min(e3, u);
    return { scale: h, x: -(l3.x + l3.width / 2) * h + (r3.x + r3.width / 2), y: -(l3.y + l3.height / 2) * h + (r3.y + r3.height / 2) };
  }
  function Yyn(l3, r3) {
    var e3 = new jyn();
    return e3.parse(l3, r3);
  }
  var Kyn = Ho(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), Zyn = function() {
    function l3(r3, e3) {
      this.type = "geoSVG", this._usedGraphicMap = Ho(), this._freedGraphics = [], this._mapName = r3, this._parsedXML = xpt(e3);
    }
    return l3.prototype.load = function() {
      var r3 = this._firstGraphic;
      if (!r3) {
        r3 = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(r3), this._boundingRect = this._firstGraphic.boundingRect.clone();
        var e3 = Qyn(r3.named), u = e3.regions, h = e3.regionsMap;
        this._regions = u, this._regionsMap = h;
      }
      return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
    }, l3.prototype._buildGraphic = function(r3) {
      var e3, u;
      try {
        e3 = r3 && Yyn(r3, { ignoreViewBox: true, ignoreRootClip: true }) || {}, u = e3.root, mb(u != null);
      } catch (te) {
        throw new Error(`Invalid svg format
` + te.message);
      }
      var h = new Cs();
      h.add(u), h.isGeoSVGGraphicRoot = true;
      var v4 = e3.width, m3 = e3.height, x3 = e3.viewBoxRect, C = this._boundingRect;
      if (!C) {
        var A2 = void 0, D = void 0, P = void 0, N = void 0;
        if (v4 != null ? (A2 = 0, P = v4) : x3 && (A2 = x3.x, P = x3.width), m3 != null ? (D = 0, N = m3) : x3 && (D = x3.y, N = x3.height), A2 == null || D == null) {
          var j = u.getBoundingRect();
          A2 == null && (A2 = j.x, P = j.width), D == null && (D = j.y, N = j.height);
        }
        C = this._boundingRect = new Ml(A2, D, P, N);
      }
      if (x3) {
        var W = Spt(x3, C);
        u.scaleX = u.scaleY = W.scale, u.x = W.x, u.y = W.y;
      }
      h.setClipPath(new Ju({ shape: C.plain() }));
      var K = [];
      return mt(e3.named, function(te) {
        Kyn.get(te.svgNodeTagLower) != null && (K.push(te), Jyn(te.el));
      }), { root: h, boundingRect: C, named: K };
    }, l3.prototype.useGraphic = function(r3) {
      var e3 = this._usedGraphicMap, u = e3.get(r3);
      return u || (u = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), e3.set(r3, u), u);
    }, l3.prototype.freeGraphic = function(r3) {
      var e3 = this._usedGraphicMap, u = e3.get(r3);
      u && (e3.removeKey(r3), this._freedGraphics.push(u));
    }, l3;
  }();
  function Jyn(l3) {
    l3.silent = false, l3.isGroup && l3.traverse(function(r3) {
      r3.silent = false;
    });
  }
  function Qyn(l3) {
    var r3 = [], e3 = Ho();
    return mt(l3, function(u) {
      if (u.namedFrom == null) {
        var h = new yvn(u.name, u.el);
        r3.push(h), e3.set(u.name, h);
      }
    }), { regions: r3, regionsMap: e3 };
  }
  var Tke = [126, 25], Vit = "\u5357\u6D77\u8BF8\u5C9B", mN = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]];
  for (var dN = 0; dN < mN.length; dN++)
    for (var Pz = 0; Pz < mN[dN].length; Pz++)
      mN[dN][Pz][0] /= 10.5, mN[dN][Pz][1] /= -10.5 / 0.75, mN[dN][Pz][0] += Tke[0], mN[dN][Pz][1] += Tke[1];
  function emn(l3, r3) {
    if (l3 === "china") {
      for (var e3 = 0; e3 < r3.length; e3++)
        if (r3[e3].name === Vit)
          return;
      r3.push(new Sht(Vit, Bi(mN, function(u) {
        return { type: "polygon", exterior: u };
      }), Tke));
    }
  }
  var tmn = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
  function nmn(l3, r3) {
    if (l3 === "china") {
      var e3 = tmn[r3.name];
      if (e3) {
        var u = r3.getCenter();
        u[0] += e3[0] / 10.5, u[1] += -e3[1] / (10.5 / 0.75), r3.setCenter(u);
      }
    }
  }
  var rmn = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
  function imn(l3, r3) {
    l3 === "china" && r3.name === "\u53F0\u6E7E" && r3.geometries.push({ type: "polygon", exterior: rmn[0] });
  }
  var amn = "name", omn = function() {
    function l3(r3, e3, u) {
      this.type = "geoJSON", this._parsedMap = Ho(), this._mapName = r3, this._specialAreas = u, this._geoJSON = lmn(e3);
    }
    return l3.prototype.load = function(r3, e3) {
      e3 = e3 || amn;
      var u = this._parsedMap.get(e3);
      if (!u) {
        var h = this._parseToRegions(e3);
        u = this._parsedMap.set(e3, { regions: h, boundingRect: smn(h) });
      }
      var v4 = Ho(), m3 = [];
      return mt(u.regions, function(x3) {
        var C = x3.name;
        r3 && vo(r3, C) && (x3 = x3.cloneShallow(C = r3[C])), m3.push(x3), v4.set(C, x3);
      }), { regions: m3, boundingRect: u.boundingRect || new Ml(0, 0, 0, 0), regionsMap: v4 };
    }, l3.prototype._parseToRegions = function(r3) {
      var e3 = this._mapName, u = this._geoJSON, h;
      try {
        h = u ? bvn(u, r3) : [];
      } catch (v4) {
        throw new Error(`Invalid geoJson format
` + v4.message);
      }
      return emn(e3, h), mt(h, function(v4) {
        var m3 = v4.name;
        nmn(e3, v4), imn(e3, v4);
        var x3 = this._specialAreas && this._specialAreas[m3];
        x3 && v4.transformTo(x3.left, x3.top, x3.width, x3.height);
      }, this), h;
    }, l3.prototype.getMapForUser = function() {
      return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
    }, l3;
  }();
  function smn(l3) {
    for (var r3, e3 = 0; e3 < l3.length; e3++) {
      var u = l3[e3].getBoundingRect();
      r3 = r3 || u.clone(), r3.union(u);
    }
    return r3;
  }
  function lmn(l3) {
    return qa(l3) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(l3) : new Function("return (" + l3 + ");")() : l3;
  }
  var sZ = Ho(), p5 = { registerMap: function(l3, r3, e3) {
    if (r3.svg) {
      var u = new Zyn(l3, r3.svg);
      sZ.set(l3, u);
    } else {
      var h = r3.geoJson || r3.geoJSON;
      h && !r3.features ? e3 = r3.specialAreas : h = r3;
      var u = new omn(l3, h, e3);
      sZ.set(l3, u);
    }
  }, getGeoResource: function(l3) {
    return sZ.get(l3);
  }, getMapForUser: function(l3) {
    var r3 = sZ.get(l3);
    return r3 && r3.type === "geoJSON" && r3.getMapForUser();
  }, load: function(l3, r3, e3) {
    var u = sZ.get(l3);
    if (!!u)
      return u.load(r3, e3);
  } }, FOe = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], umn = Ho(FOe), cmn = Ho(FOe.concat(["g"])), fmn = Ho(FOe.concat(["g"])), Cpt = pc();
  function $ce(l3) {
    var r3 = l3.getItemStyle(), e3 = l3.get("areaColor");
    return e3 != null && (r3.fill = e3), r3;
  }
  function Bit(l3) {
    var r3 = l3.style;
    r3 && (r3.stroke = r3.stroke || r3.fill, r3.fill = null);
  }
  var hmn = function() {
    function l3(r3) {
      var e3 = new Cs();
      this.uid = Tj("ec_map_draw"), this._controller = new XJ(r3.getZr()), this._controllerHost = { target: e3 }, this.group = e3, e3.add(this._regionsGroup = new Cs()), e3.add(this._svgGroup = new Cs());
    }
    return l3.prototype.draw = function(r3, e3, u, h, v4) {
      var m3 = r3.mainType === "geo", x3 = r3.getData && r3.getData();
      m3 && e3.eachComponent({ mainType: "series", subType: "map" }, function(ne) {
        !x3 && ne.getHostGeoModel() === r3 && (x3 = ne.getData());
      });
      var C = r3.coordinateSystem, A2 = this._regionsGroup, D = this.group, P = C.getTransformInfo(), N = P.raw, j = P.roam, W = !A2.childAt(0) || v4;
      W ? (D.x = j.x, D.y = j.y, D.scaleX = j.scaleX, D.scaleY = j.scaleY, D.dirty()) : hc(D, j, r3);
      var K = x3 && x3.getVisual("visualMeta") && x3.getVisual("visualMeta").length > 0, te = { api: u, geo: C, mapOrGeoModel: r3, data: x3, isVisualEncodedByVisualMap: K, isGeo: m3, transformInfoRaw: N };
      C.resourceType === "geoJSON" ? this._buildGeoJSON(te) : C.resourceType === "geoSVG" && this._buildSVG(te), this._updateController(r3, e3, u), this._updateMapSelectHandler(r3, A2, u, h);
    }, l3.prototype._buildGeoJSON = function(r3) {
      var e3 = this._regionsGroupByName = Ho(), u = Ho(), h = this._regionsGroup, v4 = r3.transformInfoRaw, m3 = r3.mapOrGeoModel, x3 = r3.data, C = r3.geo.projection, A2 = C && C.stream;
      function D(j, W) {
        return W && (j = W(j)), j && [j[0] * v4.scaleX + v4.x, j[1] * v4.scaleY + v4.y];
      }
      function P(j) {
        for (var W = [], K = !A2 && C && C.project, te = 0; te < j.length; ++te) {
          var ne = D(j[te], K);
          ne && W.push(ne);
        }
        return W;
      }
      function N(j) {
        return { shape: { points: P(j) } };
      }
      h.removeAll(), mt(r3.geo.regions, function(j) {
        var W = j.name, K = e3.get(W), te = u.get(W) || {}, ne = te.dataIdx, ce = te.regionModel;
        K || (K = e3.set(W, new Cs()), h.add(K), ne = x3 ? x3.indexOfName(W) : null, ce = r3.isGeo ? m3.getRegionModel(W) : x3 ? x3.getItemModel(ne) : null, u.set(W, { dataIdx: ne, regionModel: ce }));
        var me = [], ve = [];
        mt(j.geometries, function(We) {
          if (We.type === "polygon") {
            var Ue = [We.exterior].concat(We.interiors || []);
            A2 && (Ue = Uit(Ue, A2)), mt(Ue, function(Ze) {
              me.push(new C_(N(Ze)));
            });
          } else {
            var qe = We.points;
            A2 && (qe = Uit(qe, A2, true)), mt(qe, function(Ze) {
              ve.push(new M_(N(Ze)));
            });
          }
        });
        var Be = D(j.getCenter(), C && C.project);
        function Oe(We, Ue) {
          if (!!We.length) {
            var qe = new $3e({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: We } });
            K.add(qe), zit(r3, qe, ne, ce), jit(r3, qe, W, ce, m3, ne, Be), Ue && (Bit(qe), mt(qe.states, Bit));
          }
        }
        Oe(me), Oe(ve, true);
      }), e3.each(function(j, W) {
        var K = u.get(W), te = K.dataIdx, ne = K.regionModel;
        Git(r3, j, W, ne, m3, te), Hit(r3, j, W, ne, m3), Wit(r3, j, W, ne, m3);
      }, this);
    }, l3.prototype._buildSVG = function(r3) {
      var e3 = r3.geo.map, u = r3.transformInfoRaw;
      this._svgGroup.x = u.x, this._svgGroup.y = u.y, this._svgGroup.scaleX = u.scaleX, this._svgGroup.scaleY = u.scaleY, this._svgResourceChanged(e3) && (this._freeSVG(), this._useSVG(e3));
      var h = this._svgDispatcherMap = Ho(), v4 = false;
      mt(this._svgGraphicRecord.named, function(m3) {
        var x3 = m3.name, C = r3.mapOrGeoModel, A2 = r3.data, D = m3.svgNodeTagLower, P = m3.el, N = A2 ? A2.indexOfName(x3) : null, j = C.getRegionModel(x3);
        if (umn.get(D) != null && P instanceof x2 && zit(r3, P, N, j), P instanceof x2 && (P.culling = true), P.z2EmphasisLift = 0, !m3.namedFrom && (fmn.get(D) != null && jit(r3, P, x3, j, C, N, null), Git(r3, P, x3, j, C, N), Hit(r3, P, x3, j, C), cmn.get(D) != null)) {
          var W = Wit(r3, P, x3, j, C);
          W === "self" && (v4 = true);
          var K = h.get(x3) || h.set(x3, []);
          K.push(P);
        }
      }, this), this._enableBlurEntireSVG(v4, r3);
    }, l3.prototype._enableBlurEntireSVG = function(r3, e3) {
      if (r3 && e3.isGeo) {
        var u = e3.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), h = u.opacity;
        this._svgGraphicRecord.root.traverse(function(v4) {
          if (!v4.isGroup) {
            qN(v4);
            var m3 = v4.ensureState("blur").style || {};
            m3.opacity == null && h != null && (m3.opacity = h), v4.ensureState("emphasis");
          }
        });
      }
    }, l3.prototype.remove = function() {
      this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
    }, l3.prototype.findHighDownDispatchers = function(r3, e3) {
      if (r3 == null)
        return [];
      var u = e3.coordinateSystem;
      if (u.resourceType === "geoJSON") {
        var h = this._regionsGroupByName;
        if (h) {
          var v4 = h.get(r3);
          return v4 ? [v4] : [];
        }
      } else if (u.resourceType === "geoSVG")
        return this._svgDispatcherMap && this._svgDispatcherMap.get(r3) || [];
    }, l3.prototype._svgResourceChanged = function(r3) {
      return this._svgMapName !== r3;
    }, l3.prototype._useSVG = function(r3) {
      var e3 = p5.getGeoResource(r3);
      if (e3 && e3.type === "geoSVG") {
        var u = e3.useGraphic(this.uid);
        this._svgGroup.add(u.root), this._svgGraphicRecord = u, this._svgMapName = r3;
      }
    }, l3.prototype._freeSVG = function() {
      var r3 = this._svgMapName;
      if (r3 != null) {
        var e3 = p5.getGeoResource(r3);
        e3 && e3.type === "geoSVG" && e3.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
      }
    }, l3.prototype._updateController = function(r3, e3, u) {
      var h = r3.coordinateSystem, v4 = this._controller, m3 = this._controllerHost;
      m3.zoomLimit = r3.get("scaleLimit"), m3.zoom = h.getZoom(), v4.enable(r3.get("roam") || false);
      var x3 = r3.mainType;
      function C() {
        var A2 = { type: "geoRoam", componentType: x3 };
        return A2[x3 + "Id"] = r3.id, A2;
      }
      v4.off("pan").on("pan", function(A2) {
        this._mouseDownFlag = false, ROe(m3, A2.dx, A2.dy), u.dispatchAction(fi(C(), { dx: A2.dx, dy: A2.dy, animation: { duration: 0 } }));
      }, this), v4.off("zoom").on("zoom", function(A2) {
        this._mouseDownFlag = false, NOe(m3, A2.scale, A2.originX, A2.originY), u.dispatchAction(fi(C(), { zoom: A2.scale, originX: A2.originX, originY: A2.originY, animation: { duration: 0 } }));
      }, this), v4.setPointerChecker(function(A2, D, P) {
        return h.containPoint([D, P]) && !gpe(A2, u, r3);
      });
    }, l3.prototype.resetForLabelLayout = function() {
      this.group.traverse(function(r3) {
        var e3 = r3.getTextContent();
        e3 && (e3.ignore = Cpt(e3).ignore);
      });
    }, l3.prototype._updateMapSelectHandler = function(r3, e3, u, h) {
      var v4 = this;
      e3.off("mousedown"), e3.off("click"), r3.get("selectedMode") && (e3.on("mousedown", function() {
        v4._mouseDownFlag = true;
      }), e3.on("click", function(m3) {
        !v4._mouseDownFlag || (v4._mouseDownFlag = false);
      }));
    }, l3;
  }();
  function zit(l3, r3, e3, u) {
    var h = u.getModel("itemStyle"), v4 = u.getModel(["emphasis", "itemStyle"]), m3 = u.getModel(["blur", "itemStyle"]), x3 = u.getModel(["select", "itemStyle"]), C = $ce(h), A2 = $ce(v4), D = $ce(x3), P = $ce(m3), N = l3.data;
    if (N) {
      var j = N.getItemVisual(e3, "style"), W = N.getItemVisual(e3, "decal");
      l3.isVisualEncodedByVisualMap && j.fill && (C.fill = j.fill), W && (C.decal = pJ(W, l3.api));
    }
    r3.setStyle(C), r3.style.strokeNoScale = true, r3.ensureState("emphasis").style = A2, r3.ensureState("select").style = D, r3.ensureState("blur").style = P, qN(r3);
  }
  function jit(l3, r3, e3, u, h, v4, m3) {
    var x3 = l3.data, C = l3.isGeo, A2 = x3 && isNaN(x3.get(x3.mapDimension("value"), v4)), D = x3 && x3.getItemLayout(v4);
    if (C || A2 || D && D.showLabel) {
      var P = C ? e3 : v4, N = void 0;
      (!x3 || v4 >= 0) && (N = h);
      var j = m3 ? { normal: { align: "center", verticalAlign: "middle" } } : null;
      _1(r3, ny(u), { labelFetcher: N, labelDataIndex: P, defaultText: e3 }, j);
      var W = r3.getTextContent();
      if (W && (Cpt(W).ignore = W.ignore, r3.textConfig && m3)) {
        var K = r3.getBoundingRect().clone();
        r3.textConfig.layoutRect = K, r3.textConfig.position = [(m3[0] - K.x) / K.width * 100 + "%", (m3[1] - K.y) / K.height * 100 + "%"];
      }
      r3.disableLabelAnimation = true;
    } else
      r3.removeTextContent(), r3.removeTextConfig(), r3.disableLabelAnimation = null;
  }
  function Git(l3, r3, e3, u, h, v4) {
    l3.data ? l3.data.setItemGraphicEl(v4, r3) : Ps(r3).eventData = { componentType: "geo", componentIndex: h.componentIndex, geoIndex: h.componentIndex, name: e3, region: u && u.option || {} };
  }
  function Hit(l3, r3, e3, u, h) {
    l3.data || Cj({ el: r3, componentModel: h, itemName: e3, itemTooltipOption: u.get("tooltip") });
  }
  function Wit(l3, r3, e3, u, h) {
    r3.highDownSilentOnTouch = !!h.get("selectedMode");
    var v4 = u.getModel("emphasis"), m3 = v4.get("focus");
    return Gd(r3, m3, v4.get("blurScope"), v4.get("disabled")), l3.isGeo && ccn(r3, h, e3), m3;
  }
  function Uit(l3, r3, e3) {
    var u = [], h;
    function v4() {
      h = [];
    }
    function m3() {
      h.length && (u.push(h), h = []);
    }
    var x3 = r3({ polygonStart: v4, polygonEnd: m3, lineStart: v4, lineEnd: m3, point: function(C, A2) {
      isFinite(C) && isFinite(A2) && h.push([C, A2]);
    }, sphere: function() {
    } });
    return !e3 && x3.polygonStart(), mt(l3, function(C) {
      x3.lineStart();
      for (var A2 = 0; A2 < C.length; A2++)
        x3.point(C[A2][0], C[A2][1]);
      x3.lineEnd();
    }), !e3 && x3.polygonEnd(), u;
  }
  var Mpt = hmn, pmn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      if (!(v4 && v4.type === "mapToggleSelect" && v4.from === this.uid)) {
        var m3 = this.group;
        if (m3.removeAll(), !e3.getHostGeoModel()) {
          if (this._mapDraw && v4 && v4.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), v4 && v4.type === "geoRoam" && v4.componentType === "series" && v4.seriesId === e3.id) {
            var x3 = this._mapDraw;
            x3 && m3.add(x3.group);
          } else if (e3.needsDrawMap) {
            var x3 = this._mapDraw || new Mpt(h);
            m3.add(x3.group), x3.draw(e3, u, h, this, v4), this._mapDraw = x3;
          } else
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          e3.get("showLegendSymbol") && u.getComponent("legend") && this._renderSymbols(e3, u, h);
        }
      }
    }, r3.prototype.remove = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
    }, r3.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
    }, r3.prototype._renderSymbols = function(e3, u, h) {
      var v4 = e3.originalData, m3 = this.group;
      v4.each(v4.mapDimension("value"), function(x3, C) {
        if (!isNaN(x3)) {
          var A2 = v4.getItemLayout(C);
          if (!(!A2 || !A2.point)) {
            var D = A2.point, P = A2.offset, N = new YA({ style: { fill: e3.getData().getVisual("style").fill }, shape: { cx: D[0] + P * 9, cy: D[1], r: 3 }, silent: true, z2: 8 + (P ? 0 : wj + 1) });
            if (!P) {
              var j = e3.mainSeries.getData(), W = v4.getName(C), K = j.indexOfName(W), te = v4.getItemModel(C), ne = te.getModel("label"), ce = j.getItemGraphicEl(K);
              _1(N, ny(te), { labelFetcher: { getFormattedLabel: function(me, ve) {
                return e3.getFormattedLabel(K, ve);
              } }, defaultText: W }), N.disableLabelAnimation = true, ne.get("position") || N.setTextConfig({ position: "bottom" }), ce.onHoverStateChange = function(me) {
                $fe(N, me);
              };
            }
            m3.add(N);
          }
        }
      });
    }, r3.type = "map", r3;
  }(zh), dmn = pmn, vmn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.needsDrawMap = false, e3.seriesGroup = [], e3.getTooltipPosition = function(u) {
        if (u != null) {
          var h = this.getData().getName(u), v4 = this.coordinateSystem, m3 = v4.getRegion(h);
          return m3 && v4.dataToPoint(m3.getCenter());
        }
      }, e3;
    }
    return r3.prototype.getInitialData = function(e3) {
      for (var u = Lj(this, { coordDimensions: ["value"], encodeDefaulter: Fs(nOe, this) }), h = Ho(), v4 = [], m3 = 0, x3 = u.count(); m3 < x3; m3++) {
        var C = u.getName(m3);
        h.set(C, true);
      }
      var A2 = p5.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
      return mt(A2.regions, function(D) {
        var P = D.name;
        h.get(P) || v4.push(P);
      }), u.appendValues([], v4), u;
    }, r3.prototype.getHostGeoModel = function() {
      var e3 = this.option.geoIndex;
      return e3 != null ? this.ecModel.getComponent("geo", e3) : null;
    }, r3.prototype.getMapType = function() {
      return (this.getHostGeoModel() || this).option.map;
    }, r3.prototype.getRawValue = function(e3) {
      var u = this.getData();
      return u.get(u.mapDimension("value"), e3);
    }, r3.prototype.getRegionModel = function(e3) {
      var u = this.getData();
      return u.getItemModel(u.indexOfName(e3));
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      for (var v4 = this.getData(), m3 = this.getRawValue(e3), x3 = v4.getName(e3), C = this.seriesGroup, A2 = [], D = 0; D < C.length; D++) {
        var P = C[D].originalData.indexOfName(x3), N = v4.mapDimension("value");
        isNaN(C[D].originalData.get(N, P)) || A2.push(C[D].name);
      }
      return o0("section", { header: A2.join(", "), noHeader: !A2.length, blocks: [o0("nameValue", { name: x3, value: m3 })] });
    }, r3.prototype.setZoom = function(e3) {
      this.option.zoom = e3;
    }, r3.prototype.setCenter = function(e3) {
      this.option.center = e3;
    }, r3.prototype.getLegendIcon = function(e3) {
      var u = e3.icon || "roundRect", h = Nv(u, 0, 0, e3.itemWidth, e3.itemHeight, e3.itemStyle.fill);
      return h.setStyle(e3.itemStyle), h.style.stroke = "none", u.indexOf("empty") > -1 && (h.style.stroke = h.style.fill, h.style.fill = "#fff", h.style.lineWidth = 2), h;
    }, r3.type = "series.map", r3.dependencies = ["geo"], r3.layoutMode = "box", r3.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, r3;
  }(Fp), gmn = vmn;
  function ymn(l3, r3) {
    var e3 = {};
    return mt(l3, function(u) {
      u.each(u.mapDimension("value"), function(h, v4) {
        var m3 = "ec-" + u.getName(v4);
        e3[m3] = e3[m3] || [], isNaN(h) || e3[m3].push(h);
      });
    }), l3[0].map(l3[0].mapDimension("value"), function(u, h) {
      for (var v4 = "ec-" + l3[0].getName(h), m3 = 0, x3 = 1 / 0, C = -1 / 0, A2 = e3[v4].length, D = 0; D < A2; D++)
        x3 = Math.min(x3, e3[v4][D]), C = Math.max(C, e3[v4][D]), m3 += e3[v4][D];
      var P;
      return r3 === "min" ? P = x3 : r3 === "max" ? P = C : r3 === "average" ? P = m3 / A2 : P = m3, A2 === 0 ? NaN : P;
    });
  }
  function mmn(l3) {
    var r3 = {};
    l3.eachSeriesByType("map", function(e3) {
      var u = e3.getHostGeoModel(), h = u ? "o" + u.id : "i" + e3.getMapType();
      (r3[h] = r3[h] || []).push(e3);
    }), mt(r3, function(e3, u) {
      for (var h = ymn(Bi(e3, function(m3) {
        return m3.getData();
      }), e3[0].get("mapValueCalculation")), v4 = 0; v4 < e3.length; v4++)
        e3[v4].originalData = e3[v4].getData();
      for (var v4 = 0; v4 < e3.length; v4++)
        e3[v4].seriesGroup = e3, e3[v4].needsDrawMap = v4 === 0 && !e3[v4].getHostGeoModel(), e3[v4].setData(h.cloneShallow()), e3[v4].mainSeries = e3[0];
    });
  }
  function bmn(l3) {
    var r3 = {};
    l3.eachSeriesByType("map", function(e3) {
      var u = e3.getMapType();
      if (!(e3.getHostGeoModel() || r3[u])) {
        var h = {};
        mt(e3.seriesGroup, function(m3) {
          var x3 = m3.coordinateSystem, C = m3.originalData;
          m3.get("showLegendSymbol") && l3.getComponent("legend") && C.each(C.mapDimension("value"), function(A2, D) {
            var P = C.getName(D), N = x3.getRegion(P);
            if (!(!N || isNaN(A2))) {
              var j = h[P] || 0, W = x3.dataToPoint(N.getCenter());
              h[P] = j + 1, C.setItemLayout(D, { point: W, offset: j });
            }
          });
        });
        var v4 = e3.getData();
        v4.each(function(m3) {
          var x3 = v4.getName(m3), C = v4.getItemLayout(m3) || {};
          C.showLabel = !h[x3], v4.setItemLayout(m3, C);
        }), r3[u] = true;
      }
    });
  }
  var qit = am, _mn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this) || this;
      return u.type = "view", u.dimensions = ["x", "y"], u._roamTransformable = new QD(), u._rawTransformable = new QD(), u.name = e3, u;
    }
    return r3.prototype.setBoundingRect = function(e3, u, h, v4) {
      return this._rect = new Ml(e3, u, h, v4), this._rect;
    }, r3.prototype.getBoundingRect = function() {
      return this._rect;
    }, r3.prototype.setViewRect = function(e3, u, h, v4) {
      this._transformTo(e3, u, h, v4), this._viewRect = new Ml(e3, u, h, v4);
    }, r3.prototype._transformTo = function(e3, u, h, v4) {
      var m3 = this.getBoundingRect(), x3 = this._rawTransformable;
      x3.transform = m3.calculateTransform(new Ml(e3, u, h, v4));
      var C = x3.parent;
      x3.parent = null, x3.decomposeTransform(), x3.parent = C, this._updateTransform();
    }, r3.prototype.setCenter = function(e3) {
      !e3 || (this._center = e3, this._updateCenterAndZoom());
    }, r3.prototype.setZoom = function(e3) {
      e3 = e3 || 1;
      var u = this.zoomLimit;
      u && (u.max != null && (e3 = Math.min(u.max, e3)), u.min != null && (e3 = Math.max(u.min, e3))), this._zoom = e3, this._updateCenterAndZoom();
    }, r3.prototype.getDefaultCenter = function() {
      var e3 = this.getBoundingRect(), u = e3.x + e3.width / 2, h = e3.y + e3.height / 2;
      return [u, h];
    }, r3.prototype.getCenter = function() {
      return this._center || this.getDefaultCenter();
    }, r3.prototype.getZoom = function() {
      return this._zoom || 1;
    }, r3.prototype.getRoamTransform = function() {
      return this._roamTransformable.getLocalTransform();
    }, r3.prototype._updateCenterAndZoom = function() {
      var e3 = this._rawTransformable.getLocalTransform(), u = this._roamTransformable, h = this.getDefaultCenter(), v4 = this.getCenter(), m3 = this.getZoom();
      v4 = am([], v4, e3), h = am([], h, e3), u.originX = v4[0], u.originY = v4[1], u.x = h[0] - v4[0], u.y = h[1] - v4[1], u.scaleX = u.scaleY = m3, this._updateTransform();
    }, r3.prototype._updateTransform = function() {
      var e3 = this._roamTransformable, u = this._rawTransformable;
      u.parent = e3, e3.updateTransform(), u.updateTransform(), O3e(this.transform || (this.transform = []), u.transform || _2()), this._rawTransform = u.getLocalTransform(), this.invTransform = this.invTransform || [], _j(this.invTransform, this.transform), this.decomposeTransform();
    }, r3.prototype.getTransformInfo = function() {
      var e3 = this._rawTransformable, u = this._roamTransformable, h = new QD();
      return h.transform = u.transform, h.decomposeTransform(), { roam: { x: h.x, y: h.y, scaleX: h.scaleX, scaleY: h.scaleY }, raw: { x: e3.x, y: e3.y, scaleX: e3.scaleX, scaleY: e3.scaleY } };
    }, r3.prototype.getViewRect = function() {
      return this._viewRect;
    }, r3.prototype.getViewRectAfterRoam = function() {
      var e3 = this.getBoundingRect().clone();
      return e3.applyTransform(this.transform), e3;
    }, r3.prototype.dataToPoint = function(e3, u, h) {
      var v4 = u ? this._rawTransform : this.transform;
      return h = h || [], v4 ? qit(h, e3, v4) : db(h, e3);
    }, r3.prototype.pointToData = function(e3) {
      var u = this.invTransform;
      return u ? qit([], e3, u) : [e3[0], e3[1]];
    }, r3.prototype.convertToPixel = function(e3, u, h) {
      var v4 = $it(u);
      return v4 === this ? v4.dataToPoint(h) : null;
    }, r3.prototype.convertFromPixel = function(e3, u, h) {
      var v4 = $it(u);
      return v4 === this ? v4.pointToData(h) : null;
    }, r3.prototype.containPoint = function(e3) {
      return this.getViewRectAfterRoam().contain(e3[0], e3[1]);
    }, r3.dimensions = ["x", "y"], r3;
  }(QD);
  function $it(l3) {
    var r3 = l3.seriesModel;
    return r3 ? r3.coordinateSystem : null;
  }
  var YJ = _mn, xmn = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, Tpt = ["lng", "lat"], Apt = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this, e3) || this;
      v4.dimensions = Tpt, v4.type = "geo", v4._nameCoordMap = Ho(), v4.map = u;
      var m3 = h.projection, x3 = p5.load(u, h.nameMap, h.nameProperty), C = p5.getGeoResource(u);
      v4.resourceType = C ? C.type : null;
      var A2 = v4.regions = x3.regions, D = xmn[C.type];
      v4._regionsMap = x3.regionsMap, v4.regions = x3.regions, v4.projection = m3;
      var P;
      if (m3)
        for (var N = 0; N < A2.length; N++) {
          var j = A2[N].getBoundingRect(m3);
          P = P || j.clone(), P.union(j);
        }
      else
        P = x3.boundingRect;
      return v4.setBoundingRect(P.x, P.y, P.width, P.height), v4.aspectScale = m3 ? 1 : dl(h.aspectScale, D.aspectScale), v4._invertLongitute = m3 ? false : D.invertLongitute, v4;
    }
    return r3.prototype._transformTo = function(e3, u, h, v4) {
      var m3 = this.getBoundingRect(), x3 = this._invertLongitute;
      m3 = m3.clone(), x3 && (m3.y = -m3.y - m3.height);
      var C = this._rawTransformable;
      C.transform = m3.calculateTransform(new Ml(e3, u, h, v4));
      var A2 = C.parent;
      C.parent = null, C.decomposeTransform(), C.parent = A2, x3 && (C.scaleY = -C.scaleY), this._updateTransform();
    }, r3.prototype.getRegion = function(e3) {
      return this._regionsMap.get(e3);
    }, r3.prototype.getRegionByCoord = function(e3) {
      for (var u = this.regions, h = 0; h < u.length; h++) {
        var v4 = u[h];
        if (v4.type === "geoJSON" && v4.contain(e3))
          return u[h];
      }
    }, r3.prototype.addGeoCoord = function(e3, u) {
      this._nameCoordMap.set(e3, u);
    }, r3.prototype.getGeoCoord = function(e3) {
      var u = this._regionsMap.get(e3);
      return this._nameCoordMap.get(e3) || u && u.getCenter();
    }, r3.prototype.dataToPoint = function(e3, u, h) {
      if (qa(e3) && (e3 = this.getGeoCoord(e3)), e3) {
        var v4 = this.projection;
        return v4 && (e3 = v4.project(e3)), e3 && this.projectedToPoint(e3);
      }
    }, r3.prototype.pointToData = function(e3) {
      var u = this.projection;
      return u && (e3 = u.unproject(e3)), e3 && this.pointToProjected(e3);
    }, r3.prototype.pointToProjected = function(e3) {
      return l3.prototype.pointToData.call(this, e3);
    }, r3.prototype.projectedToPoint = function(e3, u, h) {
      return l3.prototype.dataToPoint.call(this, e3, u, h);
    }, r3.prototype.convertToPixel = function(e3, u, h) {
      var v4 = Xit(u);
      return v4 === this ? v4.dataToPoint(h) : null;
    }, r3.prototype.convertFromPixel = function(e3, u, h) {
      var v4 = Xit(u);
      return v4 === this ? v4.pointToData(h) : null;
    }, r3;
  }(YJ);
  Fv(Apt, YJ);
  function Xit(l3) {
    var r3 = l3.geoModel, e3 = l3.seriesModel;
    return r3 ? r3.coordinateSystem : e3 ? e3.coordinateSystem || (e3.getReferringComponents("geo", Lv).models[0] || {}).coordinateSystem : null;
  }
  var Yit = Apt;
  function Kit(l3, r3) {
    var e3 = l3.get("boundingCoords");
    if (e3 != null) {
      var u = e3[0], h = e3[1];
      if (isFinite(u[0]) && isFinite(u[1]) && isFinite(h[0]) && isFinite(h[1])) {
        var v4 = this.projection;
        if (v4) {
          var m3 = u[0], x3 = u[1], C = h[0], A2 = h[1];
          u = [1 / 0, 1 / 0], h = [-1 / 0, -1 / 0];
          var D = function(Oe, We, Ue, qe) {
            for (var Ze = Ue - Oe, ct = qe - We, _t = 0; _t <= 100; _t++) {
              var pt = _t / 100, zt = v4.project([Oe + Ze * pt, We + ct * pt]);
              NO(u, u, zt), FO(h, h, zt);
            }
          };
          D(m3, x3, C, x3), D(C, x3, C, A2), D(C, A2, m3, A2), D(m3, A2, C, x3);
        }
        this.setBoundingRect(u[0], u[1], h[0] - u[0], h[1] - u[1]);
      }
    }
    var P = this.getBoundingRect(), N = l3.get("layoutCenter"), j = l3.get("layoutSize"), W = r3.getWidth(), K = r3.getHeight(), te = P.width / P.height * this.aspectScale, ne = false, ce, me;
    N && j && (ce = [za(N[0], W), za(N[1], K)], me = za(j, Math.min(W, K)), !isNaN(ce[0]) && !isNaN(ce[1]) && !isNaN(me) && (ne = true));
    var ve;
    if (ne)
      ve = {}, te > 1 ? (ve.width = me, ve.height = me / te) : (ve.height = me, ve.width = me * te), ve.y = ce[1] - ve.height / 2, ve.x = ce[0] - ve.width / 2;
    else {
      var Be = l3.getBoxLayoutParams();
      Be.aspect = te, ve = dg(Be, { width: W, height: K });
    }
    this.setViewRect(ve.x, ve.y, ve.width, ve.height), this.setCenter(l3.get("center")), this.setZoom(l3.get("zoom"));
  }
  function wmn(l3, r3) {
    mt(r3.get("geoCoord"), function(e3, u) {
      l3.addGeoCoord(u, e3);
    });
  }
  var Smn = function() {
    function l3() {
      this.dimensions = Tpt;
    }
    return l3.prototype.create = function(r3, e3) {
      var u = [];
      function h(m3) {
        return { nameProperty: m3.get("nameProperty"), aspectScale: m3.get("aspectScale"), projection: m3.get("projection") };
      }
      r3.eachComponent("geo", function(m3, x3) {
        var C = m3.get("map"), A2 = new Yit(C + x3, C, fi({ nameMap: m3.get("nameMap") }, h(m3)));
        A2.zoomLimit = m3.get("scaleLimit"), u.push(A2), m3.coordinateSystem = A2, A2.model = m3, A2.resize = Kit, A2.resize(m3, e3);
      }), r3.eachSeries(function(m3) {
        var x3 = m3.get("coordinateSystem");
        if (x3 === "geo") {
          var C = m3.get("geoIndex") || 0;
          m3.coordinateSystem = u[C];
        }
      });
      var v4 = {};
      return r3.eachSeriesByType("map", function(m3) {
        if (!m3.getHostGeoModel()) {
          var x3 = m3.getMapType();
          v4[x3] = v4[x3] || [], v4[x3].push(m3);
        }
      }), mt(v4, function(m3, x3) {
        var C = Bi(m3, function(D) {
          return D.get("nameMap");
        }), A2 = new Yit(x3, x3, fi({ nameMap: T3e(C) }, h(m3[0])));
        A2.zoomLimit = ey.apply(null, Bi(m3, function(D) {
          return D.get("scaleLimit");
        })), u.push(A2), A2.resize = Kit, A2.resize(m3[0], e3), mt(m3, function(D) {
          D.coordinateSystem = A2, wmn(A2, D);
        });
      }), u;
    }, l3.prototype.getFilledRegions = function(r3, e3, u, h) {
      for (var v4 = (r3 || []).slice(), m3 = Ho(), x3 = 0; x3 < v4.length; x3++)
        m3.set(v4[x3].name, v4[x3]);
      var C = p5.load(e3, u, h);
      return mt(C.regions, function(A2) {
        var D = A2.name;
        !m3.get(D) && v4.push({ name: D });
      }), v4;
    }, l3;
  }(), Cmn = new Smn(), Ipt = Cmn, Mmn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      var v4 = p5.getGeoResource(e3.map);
      if (v4 && v4.type === "geoJSON") {
        var m3 = e3.itemStyle = e3.itemStyle || {};
        "color" in m3 || (m3.color = "#eee");
      }
      this.mergeDefaultAndTheme(e3, h), HN(e3, "label", ["show"]);
    }, r3.prototype.optionUpdated = function() {
      var e3 = this, u = this.option;
      u.regions = Ipt.getFilledRegions(u.regions, u.map, u.nameMap, u.nameProperty);
      var h = {};
      this._optionModelMap = WA(u.regions || [], function(v4, m3) {
        var x3 = m3.name;
        return x3 && (v4.set(x3, new Bh(m3, e3, e3.ecModel)), m3.selected && (h[x3] = true)), v4;
      }, Ho()), u.selectedMap || (u.selectedMap = h);
    }, r3.prototype.getRegionModel = function(e3) {
      return this._optionModelMap.get(e3) || new Bh(null, this, this.ecModel);
    }, r3.prototype.getFormattedLabel = function(e3, u) {
      var h = this.getRegionModel(e3), v4 = u === "normal" ? h.get(["label", "formatter"]) : h.get(["emphasis", "label", "formatter"]), m3 = { name: e3 };
      if (Xo(v4))
        return m3.status = u, v4(m3);
      if (qa(v4))
        return v4.replace("{a}", e3 != null ? e3 : "");
    }, r3.prototype.setZoom = function(e3) {
      this.option.zoom = e3;
    }, r3.prototype.setCenter = function(e3) {
      this.option.center = e3;
    }, r3.prototype.select = function(e3) {
      var u = this.option, h = u.selectedMode;
      if (!!h) {
        h !== "multiple" && (u.selectedMap = null);
        var v4 = u.selectedMap || (u.selectedMap = {});
        v4[e3] = true;
      }
    }, r3.prototype.unSelect = function(e3) {
      var u = this.option.selectedMap;
      u && (u[e3] = false);
    }, r3.prototype.toggleSelected = function(e3) {
      this[this.isSelected(e3) ? "unSelect" : "select"](e3);
    }, r3.prototype.isSelected = function(e3) {
      var u = this.option.selectedMap;
      return !!(u && u[e3]);
    }, r3.type = "geo", r3.layoutMode = "box", r3.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, r3;
  }(fc), Tmn = Mmn;
  function Zit(l3, r3) {
    return l3.pointToProjected ? l3.pointToProjected(r3) : l3.pointToData(r3);
  }
  function VOe(l3, r3, e3) {
    var u = l3.getZoom(), h = l3.getCenter(), v4 = r3.zoom, m3 = l3.projectedToPoint ? l3.projectedToPoint(h) : l3.dataToPoint(h);
    if (r3.dx != null && r3.dy != null && (m3[0] -= r3.dx, m3[1] -= r3.dy, l3.setCenter(Zit(l3, m3))), v4 != null) {
      if (e3) {
        var x3 = e3.min || 0, C = e3.max || 1 / 0;
        v4 = Math.max(Math.min(u * v4, C), x3) / u;
      }
      l3.scaleX *= v4, l3.scaleY *= v4;
      var A2 = (r3.originX - l3.x) * (v4 - 1), D = (r3.originY - l3.y) * (v4 - 1);
      l3.x -= A2, l3.y -= D, l3.updateTransform(), l3.setCenter(Zit(l3, m3)), l3.setZoom(v4 * u);
    }
    return { center: l3.getCenter(), zoom: l3.getZoom() };
  }
  var Amn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.focusBlurEnabled = true, e3;
    }
    return r3.prototype.init = function(e3, u) {
      this._api = u;
    }, r3.prototype.render = function(e3, u, h, v4) {
      if (this._model = e3, !e3.get("show")) {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
        return;
      }
      this._mapDraw || (this._mapDraw = new Mpt(h));
      var m3 = this._mapDraw;
      m3.draw(e3, u, h, this, v4), m3.group.on("click", this._handleRegionClick, this), m3.group.silent = e3.get("silent"), this.group.add(m3.group), this.updateSelectStatus(e3, u, h);
    }, r3.prototype._handleRegionClick = function(e3) {
      var u;
      Zz(e3.target, function(h) {
        return (u = Ps(h).eventData) != null;
      }, true), u && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: u.name });
    }, r3.prototype.updateSelectStatus = function(e3, u, h) {
      var v4 = this;
      this._mapDraw.group.traverse(function(m3) {
        var x3 = Ps(m3).eventData;
        if (x3)
          return v4._model.isSelected(x3.name) ? h.enterSelect(m3) : h.leaveSelect(m3), true;
      });
    }, r3.prototype.findHighDownDispatchers = function(e3) {
      return this._mapDraw && this._mapDraw.findHighDownDispatchers(e3, this._model);
    }, r3.prototype.dispose = function() {
      this._mapDraw && this._mapDraw.remove();
    }, r3.type = "geo", r3;
  }(yd), Imn = Amn;
  function Emn(l3, r3, e3) {
    p5.registerMap(l3, r3, e3);
  }
  function Ept(l3) {
    l3.registerCoordinateSystem("geo", Ipt), l3.registerComponentModel(Tmn), l3.registerComponentView(Imn), l3.registerImpl("registerMap", Emn), l3.registerImpl("getMap", function(e3) {
      return p5.getMapForUser(e3);
    });
    function r3(e3, u) {
      u.update = "geo:updateSelectStatus", l3.registerAction(u, function(h, v4) {
        var m3 = {}, x3 = [];
        return v4.eachComponent({ mainType: "geo", query: h }, function(C) {
          C[e3](h.name);
          var A2 = C.coordinateSystem;
          mt(A2.regions, function(P) {
            m3[P.name] = C.isSelected(P.name) || false;
          });
          var D = [];
          mt(m3, function(P, N) {
            m3[N] && D.push(N);
          }), x3.push({ geoIndex: C.componentIndex, name: D });
        }), { selected: m3, allSelected: x3, name: h.name };
      });
    }
    r3("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), r3("select", { type: "geoSelect", event: "geoselected" }), r3("unSelect", { type: "geoUnSelect", event: "geounselected" }), l3.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(e3, u) {
      var h = e3.componentType || "series";
      u.eachComponent({ mainType: h, query: e3 }, function(v4) {
        var m3 = v4.coordinateSystem;
        if (m3.type === "geo") {
          var x3 = VOe(m3, e3, v4.get("scaleLimit"));
          v4.setCenter && v4.setCenter(x3.center), v4.setZoom && v4.setZoom(x3.zoom), h === "series" && mt(v4.seriesGroup, function(C) {
            C.setCenter(x3.center), C.setZoom(x3.zoom);
          });
        }
      });
    });
  }
  function Dmn(l3) {
    kl(Ept), l3.registerChartView(dmn), l3.registerSeriesModel(gmn), l3.registerLayout(bmn), l3.registerProcessor(l3.PRIORITY.PROCESSOR.STATISTIC, mmn), Eft("map", l3.registerAction);
  }
  function kmn(l3) {
    var r3 = l3;
    r3.hierNode = { defaultAncestor: null, ancestor: r3, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
    for (var e3 = [r3], u, h; u = e3.pop(); )
      if (h = u.children, u.isExpand && h.length)
        for (var v4 = h.length, m3 = v4 - 1; m3 >= 0; m3--) {
          var x3 = h[m3];
          x3.hierNode = { defaultAncestor: null, ancestor: x3, prelim: 0, modifier: 0, change: 0, shift: 0, i: m3, thread: null }, e3.push(x3);
        }
  }
  function Omn(l3, r3) {
    var e3 = l3.isExpand ? l3.children : [], u = l3.parentNode.children, h = l3.hierNode.i ? u[l3.hierNode.i - 1] : null;
    if (e3.length) {
      Rmn(l3);
      var v4 = (e3[0].hierNode.prelim + e3[e3.length - 1].hierNode.prelim) / 2;
      h ? (l3.hierNode.prelim = h.hierNode.prelim + r3(l3, h), l3.hierNode.modifier = l3.hierNode.prelim - v4) : l3.hierNode.prelim = v4;
    } else
      h && (l3.hierNode.prelim = h.hierNode.prelim + r3(l3, h));
    l3.parentNode.hierNode.defaultAncestor = Nmn(l3, h, l3.parentNode.hierNode.defaultAncestor || u[0], r3);
  }
  function Pmn(l3) {
    var r3 = l3.hierNode.prelim + l3.parentNode.hierNode.modifier;
    l3.setLayout({ x: r3 }, true), l3.hierNode.modifier += l3.parentNode.hierNode.modifier;
  }
  function Jit(l3) {
    return arguments.length ? l3 : Bmn;
  }
  function AZ(l3, r3) {
    return l3 -= Math.PI / 2, { x: r3 * Math.cos(l3), y: r3 * Math.sin(l3) };
  }
  function Lmn(l3, r3) {
    return dg(l3.getBoxLayoutParams(), { width: r3.getWidth(), height: r3.getHeight() });
  }
  function Rmn(l3) {
    for (var r3 = l3.children, e3 = r3.length, u = 0, h = 0; --e3 >= 0; ) {
      var v4 = r3[e3];
      v4.hierNode.prelim += u, v4.hierNode.modifier += u, h += v4.hierNode.change, u += v4.hierNode.shift + h;
    }
  }
  function Nmn(l3, r3, e3, u) {
    if (r3) {
      for (var h = l3, v4 = l3, m3 = v4.parentNode.children[0], x3 = r3, C = h.hierNode.modifier, A2 = v4.hierNode.modifier, D = m3.hierNode.modifier, P = x3.hierNode.modifier; x3 = uDe(x3), v4 = cDe(v4), x3 && v4; ) {
        h = uDe(h), m3 = cDe(m3), h.hierNode.ancestor = l3;
        var N = x3.hierNode.prelim + P - v4.hierNode.prelim - A2 + u(x3, v4);
        N > 0 && (Vmn(Fmn(x3, l3, e3), l3, N), A2 += N, C += N), P += x3.hierNode.modifier, A2 += v4.hierNode.modifier, C += h.hierNode.modifier, D += m3.hierNode.modifier;
      }
      x3 && !uDe(h) && (h.hierNode.thread = x3, h.hierNode.modifier += P - C), v4 && !cDe(m3) && (m3.hierNode.thread = v4, m3.hierNode.modifier += A2 - D, e3 = l3);
    }
    return e3;
  }
  function uDe(l3) {
    var r3 = l3.children;
    return r3.length && l3.isExpand ? r3[r3.length - 1] : l3.hierNode.thread;
  }
  function cDe(l3) {
    var r3 = l3.children;
    return r3.length && l3.isExpand ? r3[0] : l3.hierNode.thread;
  }
  function Fmn(l3, r3, e3) {
    return l3.hierNode.ancestor.parentNode === r3.parentNode ? l3.hierNode.ancestor : e3;
  }
  function Vmn(l3, r3, e3) {
    var u = e3 / (r3.hierNode.i - l3.hierNode.i);
    r3.hierNode.change -= u, r3.hierNode.shift += e3, r3.hierNode.modifier += e3, r3.hierNode.prelim += e3, l3.hierNode.change += u;
  }
  function Bmn(l3, r3) {
    return l3.parentNode === r3.parentNode ? 1 : 2;
  }
  var zmn = function() {
    function l3() {
      this.parentPoint = [], this.childPoints = [];
    }
    return l3;
  }(), jmn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new zmn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.childPoints, v4 = h.length, m3 = u.parentPoint, x3 = h[0], C = h[v4 - 1];
      if (v4 === 1) {
        e3.moveTo(m3[0], m3[1]), e3.lineTo(x3[0], x3[1]);
        return;
      }
      var A2 = u.orient, D = A2 === "TB" || A2 === "BT" ? 0 : 1, P = 1 - D, N = za(u.forkPosition, 1), j = [];
      j[D] = m3[D], j[P] = m3[P] + (C[P] - m3[P]) * N, e3.moveTo(m3[0], m3[1]), e3.lineTo(j[0], j[1]), e3.moveTo(x3[0], x3[1]), j[D] = x3[D], e3.lineTo(j[0], j[1]), j[D] = C[D], e3.lineTo(j[0], j[1]), e3.lineTo(C[0], C[1]);
      for (var W = 1; W < v4 - 1; W++) {
        var K = h[W];
        e3.moveTo(K[0], K[1]), j[D] = K[D], e3.lineTo(j[0], j[1]);
      }
    }, r3;
  }(Nl), Gmn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._mainGroup = new Cs(), e3;
    }
    return r3.prototype.init = function(e3, u) {
      this._controller = new XJ(u.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
    }, r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = e3.layoutInfo, x3 = this._mainGroup, C = e3.get("layout");
      C === "radial" ? (x3.x = m3.x + m3.width / 2, x3.y = m3.y + m3.height / 2) : (x3.x = m3.x, x3.y = m3.y), this._updateViewCoordSys(e3), this._updateController(e3, u, h);
      var A2 = this._data;
      v4.diff(A2).add(function(D) {
        Qit(v4, D) && eat(v4, D, null, x3, e3);
      }).update(function(D, P) {
        var N = A2.getItemGraphicEl(P);
        if (!Qit(v4, D)) {
          N && nat(A2, P, N, x3, e3);
          return;
        }
        eat(v4, D, N, x3, e3);
      }).remove(function(D) {
        var P = A2.getItemGraphicEl(D);
        P && nat(A2, D, P, x3, e3);
      }).execute(), this._nodeScaleRatio = e3.get("nodeScaleRatio"), this._updateNodeAndLinkScale(e3), e3.get("expandAndCollapse") === true && v4.eachItemGraphicEl(function(D, P) {
        D.off("click").on("click", function() {
          h.dispatchAction({ type: "treeExpandAndCollapse", seriesId: e3.id, dataIndex: P });
        });
      }), this._data = v4;
    }, r3.prototype._updateViewCoordSys = function(e3) {
      var u = e3.getData(), h = [];
      u.each(function(D) {
        var P = u.getItemLayout(D);
        P && !isNaN(P.x) && !isNaN(P.y) && h.push([+P.x, +P.y]);
      });
      var v4 = [], m3 = [];
      qhe(h, v4, m3);
      var x3 = this._min, C = this._max;
      m3[0] - v4[0] === 0 && (v4[0] = x3 ? x3[0] : v4[0] - 1, m3[0] = C ? C[0] : m3[0] + 1), m3[1] - v4[1] === 0 && (v4[1] = x3 ? x3[1] : v4[1] - 1, m3[1] = C ? C[1] : m3[1] + 1);
      var A2 = e3.coordinateSystem = new YJ();
      A2.zoomLimit = e3.get("scaleLimit"), A2.setBoundingRect(v4[0], v4[1], m3[0] - v4[0], m3[1] - v4[1]), A2.setCenter(e3.get("center")), A2.setZoom(e3.get("zoom")), this.group.attr({ x: A2.x, y: A2.y, scaleX: A2.scaleX, scaleY: A2.scaleY }), this._min = v4, this._max = m3;
    }, r3.prototype._updateController = function(e3, u, h) {
      var v4 = this, m3 = this._controller, x3 = this._controllerHost, C = this.group;
      m3.setPointerChecker(function(A2, D, P) {
        var N = C.getBoundingRect();
        return N.applyTransform(C.transform), N.contain(D, P) && !gpe(A2, h, e3);
      }), m3.enable(e3.get("roam")), x3.zoomLimit = e3.get("scaleLimit"), x3.zoom = e3.coordinateSystem.getZoom(), m3.off("pan").off("zoom").on("pan", function(A2) {
        ROe(x3, A2.dx, A2.dy), h.dispatchAction({ seriesId: e3.id, type: "treeRoam", dx: A2.dx, dy: A2.dy });
      }).on("zoom", function(A2) {
        NOe(x3, A2.scale, A2.originX, A2.originY), h.dispatchAction({ seriesId: e3.id, type: "treeRoam", zoom: A2.scale, originX: A2.originX, originY: A2.originY }), v4._updateNodeAndLinkScale(e3), h.updateLabelLayout();
      });
    }, r3.prototype._updateNodeAndLinkScale = function(e3) {
      var u = e3.getData(), h = this._getNodeGlobalScale(e3);
      u.eachItemGraphicEl(function(v4, m3) {
        v4.setSymbolScale(h);
      });
    }, r3.prototype._getNodeGlobalScale = function(e3) {
      var u = e3.coordinateSystem;
      if (u.type !== "view")
        return 1;
      var h = this._nodeScaleRatio, v4 = u.scaleX || 1, m3 = u.getZoom(), x3 = (m3 - 1) * h + 1;
      return x3 / v4;
    }, r3.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, r3.prototype.remove = function() {
      this._mainGroup.removeAll(), this._data = null;
    }, r3.type = "tree", r3;
  }(zh);
  function Qit(l3, r3) {
    var e3 = l3.getItemLayout(r3);
    return e3 && !isNaN(e3.x) && !isNaN(e3.y);
  }
  function eat(l3, r3, e3, u, h) {
    var v4 = !e3, m3 = l3.tree.getNodeByDataIndex(r3), x3 = m3.getModel(), C = m3.getVisual("style").fill, A2 = m3.isExpand === false && m3.children.length !== 0 ? C : "#fff", D = l3.tree.root, P = m3.parentNode === D ? m3 : m3.parentNode || m3, N = l3.getItemGraphicEl(P.dataIndex), j = P.getLayout(), W = N ? { x: N.__oldX, y: N.__oldY, rawX: N.__radialOldRawX, rawY: N.__radialOldRawY } : j, K = m3.getLayout();
    v4 ? (e3 = new HJ(l3, r3, null, { symbolInnerColor: A2, useNameLabel: true }), e3.x = W.x, e3.y = W.y) : e3.updateData(l3, r3, null, { symbolInnerColor: A2, useNameLabel: true }), e3.__radialOldRawX = e3.__radialRawX, e3.__radialOldRawY = e3.__radialRawY, e3.__radialRawX = K.rawX, e3.__radialRawY = K.rawY, u.add(e3), l3.setItemGraphicEl(r3, e3), e3.__oldX = e3.x, e3.__oldY = e3.y, hc(e3, { x: K.x, y: K.y }, h);
    var te = e3.getSymbolPath();
    if (h.get("layout") === "radial") {
      var ne = D.children[0], ce = ne.getLayout(), me = ne.children.length, ve = void 0, Be = void 0;
      if (K.x === ce.x && m3.isExpand === true) {
        var Oe = { x: (ne.children[0].getLayout().x + ne.children[me - 1].getLayout().x) / 2, y: (ne.children[0].getLayout().y + ne.children[me - 1].getLayout().y) / 2 };
        ve = Math.atan2(Oe.y - ce.y, Oe.x - ce.x), ve < 0 && (ve = Math.PI * 2 + ve), Be = Oe.x < ce.x, Be && (ve = ve - Math.PI);
      } else
        ve = Math.atan2(K.y - ce.y, K.x - ce.x), ve < 0 && (ve = Math.PI * 2 + ve), m3.children.length === 0 || m3.children.length !== 0 && m3.isExpand === false ? (Be = K.x < ce.x, Be && (ve = ve - Math.PI)) : (Be = K.x > ce.x, Be || (ve = ve - Math.PI));
      var We = Be ? "left" : "right", Ue = x3.getModel("label"), qe = Ue.get("rotate"), Ze = qe * (Math.PI / 180), ct = te.getTextContent();
      ct && (te.setTextConfig({ position: Ue.get("position") || We, rotation: qe == null ? -ve : Ze, origin: "center" }), ct.setStyle("verticalAlign", "middle"));
    }
    var _t = x3.get(["emphasis", "focus"]), pt = _t === "ancestor" ? m3.getAncestorsIndices() : _t === "descendant" ? m3.getDescendantIndices() : null;
    pt && (Ps(e3).focus = pt), Hmn(h, m3, D, e3, W, j, K, u), e3.__edge && (e3.onHoverStateChange = function(zt) {
      if (zt !== "blur") {
        var Zt = m3.parentNode && l3.getItemGraphicEl(m3.parentNode.dataIndex);
        Zt && Zt.hoverState === OJ || $fe(e3.__edge, zt);
      }
    });
  }
  function Hmn(l3, r3, e3, u, h, v4, m3, x3) {
    var C = r3.getModel(), A2 = l3.get("edgeShape"), D = l3.get("layout"), P = l3.getOrient(), N = l3.get(["lineStyle", "curveness"]), j = l3.get("edgeForkPosition"), W = C.getModel("lineStyle").getLineStyle(), K = u.__edge;
    if (A2 === "curve")
      r3.parentNode && r3.parentNode !== e3 && (K || (K = u.__edge = new Khe({ shape: Ake(D, P, N, h, h) })), hc(K, { shape: Ake(D, P, N, v4, m3) }, l3));
    else if (A2 === "polyline" && D === "orthogonal" && r3 !== e3 && r3.children && r3.children.length !== 0 && r3.isExpand === true) {
      for (var te = r3.children, ne = [], ce = 0; ce < te.length; ce++) {
        var me = te[ce].getLayout();
        ne.push([me.x, me.y]);
      }
      K || (K = u.__edge = new jmn({ shape: { parentPoint: [m3.x, m3.y], childPoints: [[m3.x, m3.y]], orient: P, forkPosition: j } })), hc(K, { shape: { parentPoint: [m3.x, m3.y], childPoints: ne } }, l3);
    }
    K && (K.useStyle(ns({ strokeNoScale: true, fill: null }, W)), sm(K, C, "lineStyle"), qN(K), x3.add(K));
  }
  function tat(l3, r3, e3, u, h) {
    var v4 = r3.tree.root, m3 = Dpt(v4, l3), x3 = m3.source, C = m3.sourceLayout, A2 = r3.getItemGraphicEl(l3.dataIndex);
    if (!!A2) {
      var D = r3.getItemGraphicEl(x3.dataIndex), P = D.__edge, N = A2.__edge || (x3.isExpand === false || x3.children.length === 1 ? P : void 0), j = u.get("edgeShape"), W = u.get("layout"), K = u.get("orient"), te = u.get(["lineStyle", "curveness"]);
      N && (j === "curve" ? JO(N, { shape: Ake(W, K, te, C, C), style: { opacity: 0 } }, u, { cb: function() {
        e3.remove(N);
      }, removeOpt: h }) : j === "polyline" && u.get("layout") === "orthogonal" && JO(N, { shape: { parentPoint: [C.x, C.y], childPoints: [[C.x, C.y]] }, style: { opacity: 0 } }, u, { cb: function() {
        e3.remove(N);
      }, removeOpt: h }));
    }
  }
  function Dpt(l3, r3) {
    for (var e3 = r3.parentNode === l3 ? r3 : r3.parentNode || r3, u; u = e3.getLayout(), u == null; )
      e3 = e3.parentNode === l3 ? e3 : e3.parentNode || e3;
    return { source: e3, sourceLayout: u };
  }
  function nat(l3, r3, e3, u, h) {
    var v4 = l3.tree.getNodeByDataIndex(r3), m3 = l3.tree.root, x3 = Dpt(m3, v4).sourceLayout, C = { duration: h.get("animationDurationUpdate"), easing: h.get("animationEasingUpdate") };
    JO(e3, { x: x3.x + 1, y: x3.y + 1 }, h, { cb: function() {
      u.remove(e3), l3.setItemGraphicEl(r3, null);
    }, removeOpt: C }), e3.fadeOut(null, l3.hostModel, { fadeLabel: true, animation: C }), v4.children.forEach(function(A2) {
      tat(A2, l3, u, h, C);
    }), tat(v4, l3, u, h, C);
  }
  function Ake(l3, r3, e3, u, h) {
    var v4, m3, x3, C, A2, D, P, N;
    if (l3 === "radial") {
      A2 = u.rawX, P = u.rawY, D = h.rawX, N = h.rawY;
      var j = AZ(A2, P), W = AZ(A2, P + (N - P) * e3), K = AZ(D, N + (P - N) * e3), te = AZ(D, N);
      return { x1: j.x || 0, y1: j.y || 0, x2: te.x || 0, y2: te.y || 0, cpx1: W.x || 0, cpy1: W.y || 0, cpx2: K.x || 0, cpy2: K.y || 0 };
    } else
      A2 = u.x, P = u.y, D = h.x, N = h.y, (r3 === "LR" || r3 === "RL") && (v4 = A2 + (D - A2) * e3, m3 = P, x3 = D + (A2 - D) * e3, C = N), (r3 === "TB" || r3 === "BT") && (v4 = A2, m3 = P + (N - P) * e3, x3 = D, C = N + (P - N) * e3);
    return { x1: A2, y1: P, x2: D, y2: N, cpx1: v4, cpy1: m3, cpx2: x3, cpy2: C };
  }
  var Wmn = Gmn, y2 = pc();
  function kpt(l3) {
    var r3 = l3.mainData, e3 = l3.datas;
    e3 || (e3 = { main: r3 }, l3.datasAttr = { main: "data" }), l3.datas = l3.mainData = null, Opt(r3, e3, l3), mt(e3, function(u) {
      mt(r3.TRANSFERABLE_METHODS, function(h) {
        u.wrapMethod(h, Fs(Umn, l3));
      });
    }), r3.wrapMethod("cloneShallow", Fs($mn, l3)), mt(r3.CHANGABLE_METHODS, function(u) {
      r3.wrapMethod(u, Fs(qmn, l3));
    }), mb(e3[r3.dataType] === r3);
  }
  function Umn(l3, r3) {
    if (Kmn(this)) {
      var e3 = fi({}, y2(this).datas);
      e3[this.dataType] = r3, Opt(r3, e3, l3);
    } else
      BOe(r3, this.dataType, y2(this).mainData, l3);
    return r3;
  }
  function qmn(l3, r3) {
    return l3.struct && l3.struct.update(), r3;
  }
  function $mn(l3, r3) {
    return mt(y2(r3).datas, function(e3, u) {
      e3 !== r3 && BOe(e3.cloneShallow(), u, r3, l3);
    }), r3;
  }
  function Xmn(l3) {
    var r3 = y2(this).mainData;
    return l3 == null || r3 == null ? r3 : y2(r3).datas[l3];
  }
  function Ymn() {
    var l3 = y2(this).mainData;
    return l3 == null ? [{ data: l3 }] : Bi(yu(y2(l3).datas), function(r3) {
      return { type: r3, data: y2(l3).datas[r3] };
    });
  }
  function Kmn(l3) {
    return y2(l3).mainData === l3;
  }
  function Opt(l3, r3, e3) {
    y2(l3).datas = {}, mt(r3, function(u, h) {
      BOe(u, h, l3, e3);
    });
  }
  function BOe(l3, r3, e3, u) {
    y2(e3).datas[r3] = l3, y2(l3).mainData = e3, l3.dataType = r3, u.struct && (l3[u.structAttr] = u.struct, u.struct[u.datasAttr[r3]] = l3), l3.getLinkedData = Xmn, l3.getLinkedDataAll = Ymn;
  }
  var Zmn = function() {
    function l3(r3, e3) {
      this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = r3 || "", this.hostTree = e3;
    }
    return l3.prototype.isRemoved = function() {
      return this.dataIndex < 0;
    }, l3.prototype.eachNode = function(r3, e3, u) {
      Xo(r3) && (u = e3, e3 = r3, r3 = null), r3 = r3 || {}, qa(r3) && (r3 = { order: r3 });
      var h = r3.order || "preorder", v4 = this[r3.attr || "children"], m3;
      h === "preorder" && (m3 = e3.call(u, this));
      for (var x3 = 0; !m3 && x3 < v4.length; x3++)
        v4[x3].eachNode(r3, e3, u);
      h === "postorder" && e3.call(u, this);
    }, l3.prototype.updateDepthAndHeight = function(r3) {
      var e3 = 0;
      this.depth = r3;
      for (var u = 0; u < this.children.length; u++) {
        var h = this.children[u];
        h.updateDepthAndHeight(r3 + 1), h.height > e3 && (e3 = h.height);
      }
      this.height = e3 + 1;
    }, l3.prototype.getNodeById = function(r3) {
      if (this.getId() === r3)
        return this;
      for (var e3 = 0, u = this.children, h = u.length; e3 < h; e3++) {
        var v4 = u[e3].getNodeById(r3);
        if (v4)
          return v4;
      }
    }, l3.prototype.contains = function(r3) {
      if (r3 === this)
        return true;
      for (var e3 = 0, u = this.children, h = u.length; e3 < h; e3++) {
        var v4 = u[e3].contains(r3);
        if (v4)
          return v4;
      }
    }, l3.prototype.getAncestors = function(r3) {
      for (var e3 = [], u = r3 ? this : this.parentNode; u; )
        e3.push(u), u = u.parentNode;
      return e3.reverse(), e3;
    }, l3.prototype.getAncestorsIndices = function() {
      for (var r3 = [], e3 = this; e3; )
        r3.push(e3.dataIndex), e3 = e3.parentNode;
      return r3.reverse(), r3;
    }, l3.prototype.getDescendantIndices = function() {
      var r3 = [];
      return this.eachNode(function(e3) {
        r3.push(e3.dataIndex);
      }), r3;
    }, l3.prototype.getValue = function(r3) {
      var e3 = this.hostTree.data;
      return e3.getStore().get(e3.getDimensionIndex(r3 || "value"), this.dataIndex);
    }, l3.prototype.setLayout = function(r3, e3) {
      this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, r3, e3);
    }, l3.prototype.getLayout = function() {
      return this.hostTree.data.getItemLayout(this.dataIndex);
    }, l3.prototype.getModel = function(r3) {
      if (!(this.dataIndex < 0)) {
        var e3 = this.hostTree, u = e3.data.getItemModel(this.dataIndex);
        return u.getModel(r3);
      }
    }, l3.prototype.getLevelModel = function() {
      return (this.hostTree.levelModels || [])[this.depth];
    }, l3.prototype.setVisual = function(r3, e3) {
      this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, r3, e3);
    }, l3.prototype.getVisual = function(r3) {
      return this.hostTree.data.getItemVisual(this.dataIndex, r3);
    }, l3.prototype.getRawIndex = function() {
      return this.hostTree.data.getRawIndex(this.dataIndex);
    }, l3.prototype.getId = function() {
      return this.hostTree.data.getId(this.dataIndex);
    }, l3.prototype.getChildIndex = function() {
      if (this.parentNode) {
        for (var r3 = this.parentNode.children, e3 = 0; e3 < r3.length; ++e3)
          if (r3[e3] === this)
            return e3;
        return -1;
      }
      return -1;
    }, l3.prototype.isAncestorOf = function(r3) {
      for (var e3 = r3.parentNode; e3; ) {
        if (e3 === this)
          return true;
        e3 = e3.parentNode;
      }
      return false;
    }, l3.prototype.isDescendantOf = function(r3) {
      return r3 !== this && r3.isAncestorOf(this);
    }, l3;
  }(), Jmn = function() {
    function l3(r3) {
      this.type = "tree", this._nodes = [], this.hostModel = r3;
    }
    return l3.prototype.eachNode = function(r3, e3, u) {
      this.root.eachNode(r3, e3, u);
    }, l3.prototype.getNodeByDataIndex = function(r3) {
      var e3 = this.data.getRawIndex(r3);
      return this._nodes[e3];
    }, l3.prototype.getNodeById = function(r3) {
      return this.root.getNodeById(r3);
    }, l3.prototype.update = function() {
      for (var r3 = this.data, e3 = this._nodes, u = 0, h = e3.length; u < h; u++)
        e3[u].dataIndex = -1;
      for (var u = 0, h = r3.count(); u < h; u++)
        e3[r3.getRawIndex(u)].dataIndex = u;
    }, l3.prototype.clearLayouts = function() {
      this.data.clearItemLayouts();
    }, l3.createTree = function(r3, e3, u) {
      var h = new l3(e3), v4 = [], m3 = 1;
      x3(r3);
      function x3(D, P) {
        var N = D.value;
        m3 = Math.max(m3, Ni(N) ? N.length : 1), v4.push(D);
        var j = new Zmn(pg(D.name, ""), h);
        P ? Qmn(j, P) : h.root = j, h._nodes.push(j);
        var W = D.children;
        if (W)
          for (var K = 0; K < W.length; K++)
            x3(W[K], j);
      }
      h.root.updateDepthAndHeight(0);
      var C = zJ(v4, { coordDimensions: ["value"], dimensionsCount: m3 }).dimensions, A2 = new yb(C, e3);
      return A2.initData(v4), u && u(A2), kpt({ mainData: A2, struct: h, structAttr: "tree" }), h.update(), h;
    }, l3;
  }();
  function Qmn(l3, r3) {
    var e3 = r3.children;
    l3.parentNode !== r3 && (e3.push(l3), l3.parentNode = r3);
  }
  var zOe = Jmn;
  function mJ(l3, r3, e3) {
    if (l3 && Cl(r3, l3.type) >= 0) {
      var u = e3.getData().tree.root, h = l3.targetNode;
      if (qa(h) && (h = u.getNodeById(h)), h && u.contains(h))
        return { node: h };
      var v4 = l3.targetNodeId;
      if (v4 != null && (h = u.getNodeById(v4)))
        return { node: h };
    }
  }
  function Ppt(l3) {
    for (var r3 = []; l3; )
      l3 = l3.parentNode, l3 && r3.push(l3);
    return r3.reverse();
  }
  function jOe(l3, r3) {
    var e3 = Ppt(l3);
    return Cl(e3, r3) >= 0;
  }
  function mpe(l3, r3) {
    for (var e3 = []; l3; ) {
      var u = l3.dataIndex;
      e3.push({ name: l3.name, dataIndex: u, value: r3.getRawValue(u) }), l3 = l3.parentNode;
    }
    return e3.reverse(), e3;
  }
  var e1n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.hasSymbolVisual = true, e3.ignoreStyleOnData = true, e3;
    }
    return r3.prototype.getInitialData = function(e3) {
      var u = { name: e3.name, children: e3.data }, h = e3.leaves || {}, v4 = new Bh(h, this, this.ecModel), m3 = zOe.createTree(u, this, x3);
      function x3(P) {
        P.wrapMethod("getItemModel", function(N, j) {
          var W = m3.getNodeByDataIndex(j);
          return W && W.children.length && W.isExpand || (N.parentModel = v4), N;
        });
      }
      var C = 0;
      m3.eachNode("preorder", function(P) {
        P.depth > C && (C = P.depth);
      });
      var A2 = e3.expandAndCollapse, D = A2 && e3.initialTreeDepth >= 0 ? e3.initialTreeDepth : C;
      return m3.root.eachNode("preorder", function(P) {
        var N = P.hostTree.data.getRawDataItem(P.dataIndex);
        P.isExpand = N && N.collapsed != null ? !N.collapsed : P.depth <= D;
      }), m3.data;
    }, r3.prototype.getOrient = function() {
      var e3 = this.get("orient");
      return e3 === "horizontal" ? e3 = "LR" : e3 === "vertical" && (e3 = "TB"), e3;
    }, r3.prototype.setZoom = function(e3) {
      this.option.zoom = e3;
    }, r3.prototype.setCenter = function(e3) {
      this.option.center = e3;
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      for (var v4 = this.getData().tree, m3 = v4.root.children[0], x3 = v4.getNodeByDataIndex(e3), C = x3.getValue(), A2 = x3.name; x3 && x3 !== m3; )
        A2 = x3.parentNode.name + "." + A2, x3 = x3.parentNode;
      return o0("nameValue", { name: A2, value: C, noValue: isNaN(C) || C == null });
    }, r3.prototype.getDataParams = function(e3) {
      var u = l3.prototype.getDataParams.apply(this, arguments), h = this.getData().tree.getNodeByDataIndex(e3);
      return u.treeAncestors = mpe(h, this), u;
    }, r3.type = "series.tree", r3.layoutMode = "box", r3.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, r3;
  }(Fp), t1n = e1n;
  function n1n(l3, r3, e3) {
    for (var u = [l3], h = [], v4; v4 = u.pop(); )
      if (h.push(v4), v4.isExpand) {
        var m3 = v4.children;
        if (m3.length)
          for (var x3 = 0; x3 < m3.length; x3++)
            u.push(m3[x3]);
      }
    for (; v4 = h.pop(); )
      r3(v4, e3);
  }
  function lZ(l3, r3) {
    for (var e3 = [l3], u; u = e3.pop(); )
      if (r3(u), u.isExpand) {
        var h = u.children;
        if (h.length)
          for (var v4 = h.length - 1; v4 >= 0; v4--)
            e3.push(h[v4]);
      }
  }
  function r1n(l3, r3) {
    l3.eachSeriesByType("tree", function(e3) {
      i1n(e3, r3);
    });
  }
  function i1n(l3, r3) {
    var e3 = Lmn(l3, r3);
    l3.layoutInfo = e3;
    var u = l3.get("layout"), h = 0, v4 = 0, m3 = null;
    u === "radial" ? (h = 2 * Math.PI, v4 = Math.min(e3.height, e3.width) / 2, m3 = Jit(function(me, ve) {
      return (me.parentNode === ve.parentNode ? 1 : 2) / me.depth;
    })) : (h = e3.width, v4 = e3.height, m3 = Jit());
    var x3 = l3.getData().tree.root, C = x3.children[0];
    if (C) {
      kmn(x3), n1n(C, Omn, m3), x3.hierNode.modifier = -C.hierNode.prelim, lZ(C, Pmn);
      var A2 = C, D = C, P = C;
      lZ(C, function(me) {
        var ve = me.getLayout().x;
        ve < A2.getLayout().x && (A2 = me), ve > D.getLayout().x && (D = me), me.depth > P.depth && (P = me);
      });
      var N = A2 === D ? 1 : m3(A2, D) / 2, j = N - A2.getLayout().x, W = 0, K = 0, te = 0, ne = 0;
      if (u === "radial")
        W = h / (D.getLayout().x + N + j), K = v4 / (P.depth - 1 || 1), lZ(C, function(me) {
          te = (me.getLayout().x + j) * W, ne = (me.depth - 1) * K;
          var ve = AZ(te, ne);
          me.setLayout({ x: ve.x, y: ve.y, rawX: te, rawY: ne }, true);
        });
      else {
        var ce = l3.getOrient();
        ce === "RL" || ce === "LR" ? (K = v4 / (D.getLayout().x + N + j), W = h / (P.depth - 1 || 1), lZ(C, function(me) {
          ne = (me.getLayout().x + j) * K, te = ce === "LR" ? (me.depth - 1) * W : h - (me.depth - 1) * W, me.setLayout({ x: te, y: ne }, true);
        })) : (ce === "TB" || ce === "BT") && (W = h / (D.getLayout().x + N + j), K = v4 / (P.depth - 1 || 1), lZ(C, function(me) {
          te = (me.getLayout().x + j) * W, ne = ce === "TB" ? (me.depth - 1) * K : v4 - (me.depth - 1) * K, me.setLayout({ x: te, y: ne }, true);
        }));
      }
    }
  }
  function a1n(l3) {
    l3.eachSeriesByType("tree", function(r3) {
      var e3 = r3.getData(), u = e3.tree;
      u.eachNode(function(h) {
        var v4 = h.getModel(), m3 = v4.getModel("itemStyle").getItemStyle(), x3 = e3.ensureUniqueItemVisual(h.dataIndex, "style");
        fi(x3, m3);
      });
    });
  }
  function o1n(l3) {
    l3.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(r3, e3) {
      e3.eachComponent({ mainType: "series", subType: "tree", query: r3 }, function(u) {
        var h = r3.dataIndex, v4 = u.getData().tree, m3 = v4.getNodeByDataIndex(h);
        m3.isExpand = !m3.isExpand;
      });
    }), l3.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(r3, e3) {
      e3.eachComponent({ mainType: "series", subType: "tree", query: r3 }, function(u) {
        var h = u.coordinateSystem, v4 = VOe(h, r3);
        u.setCenter && u.setCenter(v4.center), u.setZoom && u.setZoom(v4.zoom);
      });
    });
  }
  function s1n(l3) {
    l3.registerChartView(Wmn), l3.registerSeriesModel(t1n), l3.registerLayout(r1n), l3.registerVisual(a1n), o1n(l3);
  }
  var rat = ["treemapZoomToNode", "treemapRender", "treemapMove"];
  function l1n(l3) {
    for (var r3 = 0; r3 < rat.length; r3++)
      l3.registerAction({ type: rat[r3], update: "updateView" }, Rv);
    l3.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(e3, u) {
      u.eachComponent({ mainType: "series", subType: "treemap", query: e3 }, h);
      function h(v4, m3) {
        var x3 = ["treemapZoomToNode", "treemapRootToNode"], C = mJ(e3, x3, v4);
        if (C) {
          var A2 = v4.getViewRoot();
          A2 && (e3.direction = jOe(A2, C.node) ? "rollUp" : "drillDown"), v4.resetViewRoot(C.node);
        }
      }
    });
  }
  function Lpt(l3) {
    var r3 = l3.getData(), e3 = r3.tree, u = {};
    e3.eachNode(function(h) {
      for (var v4 = h; v4 && v4.depth > 1; )
        v4 = v4.parentNode;
      var m3 = nke(l3.ecModel, v4.name || v4.dataIndex + "", u);
      h.setVisual("decal", m3);
    });
  }
  var u1n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.preventUsingHoverLayer = true, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      var h = { name: e3.name, children: e3.data };
      Rpt(h);
      var v4 = e3.levels || [], m3 = this.designatedVisualItemStyle = {}, x3 = new Bh({ itemStyle: m3 }, this, u);
      v4 = e3.levels = c1n(v4, u);
      var C = Bi(v4 || [], function(P) {
        return new Bh(P, x3, u);
      }, this), A2 = zOe.createTree(h, this, D);
      function D(P) {
        P.wrapMethod("getItemModel", function(N, j) {
          var W = A2.getNodeByDataIndex(j), K = W ? C[W.depth] : null;
          return N.parentModel = K || x3, N;
        });
      }
      return A2.data;
    }, r3.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      var v4 = this.getData(), m3 = this.getRawValue(e3), x3 = v4.getName(e3);
      return o0("nameValue", { name: x3, value: m3 });
    }, r3.prototype.getDataParams = function(e3) {
      var u = l3.prototype.getDataParams.apply(this, arguments), h = this.getData().tree.getNodeByDataIndex(e3);
      return u.treeAncestors = mpe(h, this), u.treePathInfo = u.treeAncestors, u;
    }, r3.prototype.setLayoutInfo = function(e3) {
      this.layoutInfo = this.layoutInfo || {}, fi(this.layoutInfo, e3);
    }, r3.prototype.mapIdToIndex = function(e3) {
      var u = this._idIndexMap;
      u || (u = this._idIndexMap = Ho(), this._idIndexMapCount = 0);
      var h = u.get(e3);
      return h == null && u.set(e3, h = this._idIndexMapCount++), h;
    }, r3.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, r3.prototype.resetViewRoot = function(e3) {
      e3 ? this._viewRoot = e3 : e3 = this._viewRoot;
      var u = this.getRawData().tree.root;
      (!e3 || e3 !== u && !u.contains(e3)) && (this._viewRoot = u);
    }, r3.prototype.enableAriaDecal = function() {
      Lpt(this);
    }, r3.type = "series.treemap", r3.layoutMode = "box", r3.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, r3;
  }(Fp);
  function Rpt(l3) {
    var r3 = 0;
    mt(l3.children, function(u) {
      Rpt(u);
      var h = u.value;
      Ni(h) && (h = h[0]), r3 += h;
    });
    var e3 = l3.value;
    Ni(e3) && (e3 = e3[0]), (e3 == null || isNaN(e3)) && (e3 = r3), e3 < 0 && (e3 = 0), Ni(l3.value) ? l3.value[0] = e3 : l3.value = e3;
  }
  function c1n(l3, r3) {
    var e3 = Gf(r3.get("color")), u = Gf(r3.get(["aria", "decal", "decals"]));
    if (!!e3) {
      l3 = l3 || [];
      var h, v4;
      mt(l3, function(x3) {
        var C = new Bh(x3), A2 = C.get("color"), D = C.get("decal");
        (C.get(["itemStyle", "color"]) || A2 && A2 !== "none") && (h = true), (C.get(["itemStyle", "decal"]) || D && D !== "none") && (v4 = true);
      });
      var m3 = l3[0] || (l3[0] = {});
      return h || (m3.color = e3.slice()), !v4 && u && (m3.decal = u.slice()), l3;
    }
  }
  var f1n = u1n, h1n = 8, iat = 8, fDe = 5, p1n = function() {
    function l3(r3) {
      this.group = new Cs(), r3.add(this.group);
    }
    return l3.prototype.render = function(r3, e3, u, h) {
      var v4 = r3.getModel("breadcrumb"), m3 = this.group;
      if (m3.removeAll(), !(!v4.get("show") || !u)) {
        var x3 = v4.getModel("itemStyle"), C = x3.getModel("textStyle"), A2 = { pos: { left: v4.get("left"), right: v4.get("right"), top: v4.get("top"), bottom: v4.get("bottom") }, box: { width: e3.getWidth(), height: e3.getHeight() }, emptyItemWidth: v4.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
        this._prepare(u, A2, C), this._renderContent(r3, A2, x3, C, h), ape(m3, A2.pos, A2.box);
      }
    }, l3.prototype._prepare = function(r3, e3, u) {
      for (var h = r3; h; h = h.parentNode) {
        var v4 = pg(h.getModel().get("name"), ""), m3 = u.getTextRect(v4), x3 = Math.max(m3.width + h1n * 2, e3.emptyItemWidth);
        e3.totalWidth += x3 + iat, e3.renderList.push({ node: h, text: v4, width: x3 });
      }
    }, l3.prototype._renderContent = function(r3, e3, u, h, v4) {
      for (var m3 = 0, x3 = e3.emptyItemWidth, C = r3.get(["breadcrumb", "height"]), A2 = wfn(e3.pos, e3.box), D = e3.totalWidth, P = e3.renderList, N = P.length - 1; N >= 0; N--) {
        var j = P[N], W = j.node, K = j.width, te = j.text;
        D > A2.width && (D -= K - x3, K = x3, te = null);
        var ne = new C_({ shape: { points: d1n(m3, 0, K, C, N === P.length - 1, N === 0) }, style: ns(u.getItemStyle(), { lineJoin: "bevel" }), textContent: new Ec({ style: { text: te, fill: h.getTextColor(), font: h.getFont() } }), textConfig: { position: "inside" }, z2: wj * 1e4, onclick: Fs(v4, W) });
        ne.disableLabelAnimation = true, this.group.add(ne), v1n(ne, r3, W), m3 += K + iat;
      }
    }, l3.prototype.remove = function() {
      this.group.removeAll();
    }, l3;
  }();
  function d1n(l3, r3, e3, u, h, v4) {
    var m3 = [[h ? l3 : l3 - fDe, r3], [l3 + e3, r3], [l3 + e3, r3 + u], [h ? l3 : l3 - fDe, r3 + u]];
    return !v4 && m3.splice(2, 0, [l3 + e3 + fDe, r3 + u / 2]), !h && m3.push([l3, r3 + u / 2]), m3;
  }
  function v1n(l3, r3, e3) {
    Ps(l3).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: r3.componentIndex, seriesIndex: r3.seriesIndex, seriesName: r3.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: e3 && e3.dataIndex, name: e3 && e3.name }, treePathInfo: e3 && mpe(e3, r3) };
  }
  var g1n = p1n, y1n = function() {
    function l3() {
      this._storage = [], this._elExistsMap = {};
    }
    return l3.prototype.add = function(r3, e3, u, h, v4) {
      return this._elExistsMap[r3.id] ? false : (this._elExistsMap[r3.id] = true, this._storage.push({ el: r3, target: e3, duration: u, delay: h, easing: v4 }), true);
    }, l3.prototype.finished = function(r3) {
      return this._finishedCallback = r3, this;
    }, l3.prototype.start = function() {
      for (var r3 = this, e3 = this._storage.length, u = function() {
        e3--, e3 <= 0 && (r3._storage.length = 0, r3._elExistsMap = {}, r3._finishedCallback && r3._finishedCallback());
      }, h = 0, v4 = this._storage.length; h < v4; h++) {
        var m3 = this._storage[h];
        m3.el.animateTo(m3.target, { duration: m3.duration, delay: m3.delay, easing: m3.easing, setToFinal: true, done: u, aborted: u });
      }
      return this;
    }, l3;
  }();
  function m1n() {
    return new y1n();
  }
  var Ike = Cs, aat = Ju, oat = 3, sat = "label", lat = "upperLabel", b1n = wj * 10, _1n = wj * 2, x1n = wj * 3, bN = UN([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), uat = function(l3) {
    var r3 = bN(l3);
    return r3.stroke = r3.fill = r3.lineWidth = null, r3;
  }, ghe = pc(), w1n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._state = "ready", e3._storage = uZ(), e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      var m3 = u.findComponents({ mainType: "series", subType: "treemap", query: v4 });
      if (!(Cl(m3, e3) < 0)) {
        this.seriesModel = e3, this.api = h, this.ecModel = u;
        var x3 = ["treemapZoomToNode", "treemapRootToNode"], C = mJ(v4, x3, e3), A2 = v4 && v4.type, D = e3.layoutInfo, P = !this._oldTree, N = this._storage, j = A2 === "treemapRootToNode" && C && N ? { rootNodeGroup: N.nodeGroup[C.node.getRawIndex()], direction: v4.direction } : null, W = this._giveContainerGroup(D), K = e3.get("animation"), te = this._doRender(W, e3, j);
        K && !P && (!A2 || A2 === "treemapZoomToNode" || A2 === "treemapRootToNode") ? this._doAnimation(W, te, e3, j) : te.renderFinally(), this._resetController(h), this._renderBreadcrumb(e3, h, C);
      }
    }, r3.prototype._giveContainerGroup = function(e3) {
      var u = this._containerGroup;
      return u || (u = this._containerGroup = new Ike(), this._initEvents(u), this.group.add(u)), u.x = e3.x, u.y = e3.y, u;
    }, r3.prototype._doRender = function(e3, u, h) {
      var v4 = u.getData().tree, m3 = this._oldTree, x3 = uZ(), C = uZ(), A2 = this._storage, D = [];
      function P(te, ne, ce, me) {
        return S1n(u, C, A2, h, x3, D, te, ne, ce, me);
      }
      j(v4.root ? [v4.root] : [], m3 && m3.root ? [m3.root] : [], e3, v4 === m3 || !m3, 0);
      var N = W(A2);
      return this._oldTree = v4, this._storage = C, { lastsForAnimation: x3, willDeleteEls: N, renderFinally: K };
      function j(te, ne, ce, me, ve) {
        me ? (ne = te, mt(te, function(We, Ue) {
          !We.isRemoved() && Oe(Ue, Ue);
        })) : new f5(ne, te, Be, Be).add(Oe).update(Oe).remove(Fs(Oe, null)).execute();
        function Be(We) {
          return We.getId();
        }
        function Oe(We, Ue) {
          var qe = We != null ? te[We] : null, Ze = Ue != null ? ne[Ue] : null, ct = P(qe, Ze, ce, ve);
          ct && j(qe && qe.viewChildren || [], Ze && Ze.viewChildren || [], ct, me, ve + 1);
        }
      }
      function W(te) {
        var ne = uZ();
        return te && mt(te, function(ce, me) {
          var ve = ne[me];
          mt(ce, function(Be) {
            Be && (ve.push(Be), ghe(Be).willDelete = true);
          });
        }), ne;
      }
      function K() {
        mt(N, function(te) {
          mt(te, function(ne) {
            ne.parent && ne.parent.remove(ne);
          });
        }), mt(D, function(te) {
          te.invisible = true, te.dirty();
        });
      }
    }, r3.prototype._doAnimation = function(e3, u, h, v4) {
      var m3 = h.get("animationDurationUpdate"), x3 = h.get("animationEasing"), C = (Xo(m3) ? 0 : m3) || 0, A2 = (Xo(x3) ? null : x3) || "cubicOut", D = m1n();
      mt(u.willDeleteEls, function(P, N) {
        mt(P, function(j, W) {
          if (!j.invisible) {
            var K = j.parent, te, ne = ghe(K);
            if (v4 && v4.direction === "drillDown")
              te = K === v4.rootNodeGroup ? { shape: { x: 0, y: 0, width: ne.nodeWidth, height: ne.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
            else {
              var ce = 0, me = 0;
              ne.willDelete || (ce = ne.nodeWidth / 2, me = ne.nodeHeight / 2), te = N === "nodeGroup" ? { x: ce, y: me, style: { opacity: 0 } } : { shape: { x: ce, y: me, width: 0, height: 0 }, style: { opacity: 0 } };
            }
            te && D.add(j, te, C, 0, A2);
          }
        });
      }), mt(this._storage, function(P, N) {
        mt(P, function(j, W) {
          var K = u.lastsForAnimation[N][W], te = {};
          !K || (j instanceof Cs ? K.oldX != null && (te.x = j.x, te.y = j.y, j.x = K.oldX, j.y = K.oldY) : (K.oldShape && (te.shape = fi({}, j.shape), j.setShape(K.oldShape)), K.fadein ? (j.setStyle("opacity", 0), te.style = { opacity: 1 }) : j.style.opacity !== 1 && (te.style = { opacity: 1 })), D.add(j, te, C, 0, A2));
        });
      }, this), this._state = "animating", D.finished(no(function() {
        this._state = "ready", u.renderFinally();
      }, this)).start();
    }, r3.prototype._resetController = function(e3) {
      var u = this._controller;
      u || (u = this._controller = new XJ(e3.getZr()), u.enable(this.seriesModel.get("roam")), u.on("pan", no(this._onPan, this)), u.on("zoom", no(this._onZoom, this)));
      var h = new Ml(0, 0, e3.getWidth(), e3.getHeight());
      u.setPointerChecker(function(v4, m3, x3) {
        return h.contain(m3, x3);
      });
    }, r3.prototype._clearController = function() {
      var e3 = this._controller;
      e3 && (e3.dispose(), e3 = null);
    }, r3.prototype._onPan = function(e3) {
      if (this._state !== "animating" && (Math.abs(e3.dx) > oat || Math.abs(e3.dy) > oat)) {
        var u = this.seriesModel.getData().tree.root;
        if (!u)
          return;
        var h = u.getLayout();
        if (!h)
          return;
        this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: h.x + e3.dx, y: h.y + e3.dy, width: h.width, height: h.height } });
      }
    }, r3.prototype._onZoom = function(e3) {
      var u = e3.originX, h = e3.originY;
      if (this._state !== "animating") {
        var v4 = this.seriesModel.getData().tree.root;
        if (!v4)
          return;
        var m3 = v4.getLayout();
        if (!m3)
          return;
        var x3 = new Ml(m3.x, m3.y, m3.width, m3.height), C = this.seriesModel.layoutInfo;
        u -= C.x, h -= C.y;
        var A2 = _2();
        UA(A2, A2, [-u, -h]), P3e(A2, A2, [e3.scale, e3.scale]), UA(A2, A2, [u, h]), x3.applyTransform(A2), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: x3.x, y: x3.y, width: x3.width, height: x3.height } });
      }
    }, r3.prototype._initEvents = function(e3) {
      var u = this;
      e3.on("click", function(h) {
        if (u._state === "ready") {
          var v4 = u.seriesModel.get("nodeClick", true);
          if (!!v4) {
            var m3 = u.findTarget(h.offsetX, h.offsetY);
            if (!!m3) {
              var x3 = m3.node;
              if (x3.getLayout().isLeafRoot)
                u._rootToNode(m3);
              else if (v4 === "zoomToNode")
                u._zoomToNode(m3);
              else if (v4 === "link") {
                var C = x3.hostTree.data.getItemModel(x3.dataIndex), A2 = C.get("link", true), D = C.get("target", true) || "blank";
                A2 && Qfe(A2, D);
              }
            }
          }
        }
      }, this);
    }, r3.prototype._renderBreadcrumb = function(e3, u, h) {
      var v4 = this;
      h || (h = e3.get("leafDepth", true) != null ? { node: e3.getViewRoot() } : this.findTarget(u.getWidth() / 2, u.getHeight() / 2), h || (h = { node: e3.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new g1n(this.group))).render(e3, u, h.node, function(m3) {
        v4._state !== "animating" && (jOe(e3.getViewRoot(), m3) ? v4._rootToNode({ node: m3 }) : v4._zoomToNode({ node: m3 }));
      });
    }, r3.prototype.remove = function() {
      this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = uZ(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
    }, r3.prototype.dispose = function() {
      this._clearController();
    }, r3.prototype._zoomToNode = function(e3) {
      this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e3.node });
    }, r3.prototype._rootToNode = function(e3) {
      this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: e3.node });
    }, r3.prototype.findTarget = function(e3, u) {
      var h, v4 = this.seriesModel.getViewRoot();
      return v4.eachNode({ attr: "viewChildren", order: "preorder" }, function(m3) {
        var x3 = this._storage.background[m3.getRawIndex()];
        if (x3) {
          var C = x3.transformCoordToLocal(e3, u), A2 = x3.shape;
          if (A2.x <= C[0] && C[0] <= A2.x + A2.width && A2.y <= C[1] && C[1] <= A2.y + A2.height)
            h = { node: m3, offsetX: C[0], offsetY: C[1] };
          else
            return false;
        }
      }, this), h;
    }, r3.type = "treemap", r3;
  }(zh);
  function uZ() {
    return { nodeGroup: [], background: [], content: [] };
  }
  function S1n(l3, r3, e3, u, h, v4, m3, x3, C, A2) {
    if (!m3)
      return;
    var D = m3.getLayout(), P = l3.getData(), N = m3.getModel();
    if (P.setItemGraphicEl(m3.dataIndex, null), !D || !D.isInView)
      return;
    var j = D.width, W = D.height, K = D.borderWidth, te = D.invisible, ne = m3.getRawIndex(), ce = x3 && x3.getRawIndex(), me = m3.viewChildren, ve = D.upperHeight, Be = me && me.length, Oe = N.getModel("itemStyle"), We = N.getModel(["emphasis", "itemStyle"]), Ue = N.getModel(["blur", "itemStyle"]), qe = N.getModel(["select", "itemStyle"]), Ze = Oe.get("borderRadius") || 0, ct = Ba("nodeGroup", Ike);
    if (!ct)
      return;
    if (C.add(ct), ct.x = D.x || 0, ct.y = D.y || 0, ct.markRedraw(), ghe(ct).nodeWidth = j, ghe(ct).nodeHeight = W, D.isAboveViewRoot)
      return ct;
    var _t = Ba("background", aat, A2, _1n);
    _t && xn(ct, _t, Be && D.upperLabelHeight);
    var pt = N.getModel("emphasis"), zt = pt.get("focus"), Zt = pt.get("blurScope"), Ft = pt.get("disabled"), Kn = zt === "ancestor" ? m3.getAncestorsIndices() : zt === "descendant" ? m3.getDescendantIndices() : zt;
    if (Be)
      iJ(ct) && DN(ct, false), _t && (DN(_t, !Ft), P.setItemGraphicEl(m3.dataIndex, _t), X5e(_t, Kn, Zt));
    else {
      var hn = Ba("content", aat, A2, x1n);
      hn && zn(ct, hn), _t.disableMorphing = true, _t && iJ(_t) && DN(_t, false), DN(ct, !Ft), P.setItemGraphicEl(m3.dataIndex, ct), X5e(ct, Kn, Zt);
    }
    return ct;
    function xn(oo, Pa, fo) {
      var Co = Ps(Pa);
      if (Co.dataIndex = m3.dataIndex, Co.seriesIndex = l3.seriesIndex, Pa.setShape({ x: 0, y: 0, width: j, height: W, r: Ze }), te)
        or(Pa);
      else {
        Pa.invisible = false;
        var $a = m3.getVisual("style"), Yo = $a.stroke, Qu = uat(Oe);
        Qu.fill = Yo;
        var ds = bN(We);
        ds.fill = We.get("borderColor");
        var Lu = bN(Ue);
        Lu.fill = Ue.get("borderColor");
        var dc = bN(qe);
        if (dc.fill = qe.get("borderColor"), fo) {
          var Kc = j - 2 * K;
          vr(Pa, Yo, $a.opacity, { x: K, y: 0, width: Kc, height: ve });
        } else
          Pa.removeTextContent();
        Pa.setStyle(Qu), Pa.ensureState("emphasis").style = ds, Pa.ensureState("blur").style = Lu, Pa.ensureState("select").style = dc, qN(Pa);
      }
      oo.add(Pa);
    }
    function zn(oo, Pa) {
      var fo = Ps(Pa);
      fo.dataIndex = m3.dataIndex, fo.seriesIndex = l3.seriesIndex;
      var Co = Math.max(j - 2 * K, 0), $a = Math.max(W - 2 * K, 0);
      if (Pa.culling = true, Pa.setShape({ x: K, y: K, width: Co, height: $a, r: Ze }), te)
        or(Pa);
      else {
        Pa.invisible = false;
        var Yo = m3.getVisual("style"), Qu = Yo.fill, ds = uat(Oe);
        ds.fill = Qu, ds.decal = Yo.decal;
        var Lu = bN(We), dc = bN(Ue), Kc = bN(qe);
        vr(Pa, Qu, Yo.opacity, null), Pa.setStyle(ds), Pa.ensureState("emphasis").style = Lu, Pa.ensureState("blur").style = dc, Pa.ensureState("select").style = Kc, qN(Pa);
      }
      oo.add(Pa);
    }
    function or(oo) {
      !oo.invisible && v4.push(oo);
    }
    function vr(oo, Pa, fo, Co) {
      var $a = N.getModel(Co ? lat : sat), Yo = pg(N.get("name"), null), Qu = $a.getShallow("show");
      _1(oo, ny(N, Co ? lat : sat), { defaultText: Qu ? Yo : null, inheritColor: Pa, defaultOpacity: fo, labelFetcher: l3, labelDataIndex: m3.dataIndex });
      var ds = oo.getTextContent();
      if (!!ds) {
        var Lu = ds.style, dc = I3e(Lu.padding || 0);
        Co && (oo.setTextConfig({ layoutRect: Co }), ds.disableLabelLayout = true), ds.beforeUpdate = function() {
          var sv = Math.max((Co ? Co.width : oo.shape.width) - dc[1] - dc[3], 0), Hf = Math.max((Co ? Co.height : oo.shape.height) - dc[0] - dc[2], 0);
          (Lu.width !== sv || Lu.height !== Hf) && ds.setStyle({ width: sv, height: Hf });
        }, Lu.truncateMinChar = 2, Lu.lineOverflow = "truncate", la(Lu, Co, D);
        var Kc = ds.getState("emphasis");
        la(Kc ? Kc.style : null, Co, D);
      }
    }
    function la(oo, Pa, fo) {
      var Co = oo ? oo.text : null;
      if (!Pa && fo.isLeafRoot && Co != null) {
        var $a = l3.get("drillDownIcon", true);
        oo.text = $a ? $a + " " + Co : Co;
      }
    }
    function Ba(oo, Pa, fo, Co) {
      var $a = ce != null && e3[oo][ce], Yo = h[oo];
      return $a ? (e3[oo][ce] = null, Lo(Yo, $a)) : te || ($a = new Pa(), $a instanceof x2 && ($a.z2 = C1n(fo, Co)), Ao(Yo, $a)), r3[oo][ne] = $a;
    }
    function Lo(oo, Pa) {
      var fo = oo[ne] = {};
      Pa instanceof Ike ? (fo.oldX = Pa.x, fo.oldY = Pa.y) : fo.oldShape = fi({}, Pa.shape);
    }
    function Ao(oo, Pa) {
      var fo = oo[ne] = {}, Co = m3.parentNode, $a = Pa instanceof Cs;
      if (Co && (!u || u.direction === "drillDown")) {
        var Yo = 0, Qu = 0, ds = h.background[Co.getRawIndex()];
        !u && ds && ds.oldShape && (Yo = ds.oldShape.width, Qu = ds.oldShape.height), $a ? (fo.oldX = 0, fo.oldY = Qu) : fo.oldShape = { x: Yo, y: Qu, width: 0, height: 0 };
      }
      fo.fadein = !$a;
    }
  }
  function C1n(l3, r3) {
    return l3 * b1n + r3;
  }
  var M1n = w1n, bJ = mt, T1n = ls, yhe = -1, GOe = function() {
    function l3(r3) {
      var e3 = r3.mappingMethod, u = r3.type, h = this.option = bs(r3);
      this.type = u, this.mappingMethod = e3, this._normalizeData = E1n[e3];
      var v4 = l3.visualHandlers[u];
      this.applyVisual = v4.applyVisual, this.getColorMapper = v4.getColorMapper, this._normalizedToVisual = v4._normalizedToVisual[e3], e3 === "piecewise" ? (hDe(h), A1n(h)) : e3 === "category" ? h.categories ? I1n(h) : hDe(h, true) : (mb(e3 !== "linear" || h.dataExtent), hDe(h));
    }
    return l3.prototype.mapValueToVisual = function(r3) {
      var e3 = this._normalizeData(r3);
      return this._normalizedToVisual(e3, r3);
    }, l3.prototype.getNormalizer = function() {
      return no(this._normalizeData, this);
    }, l3.listVisualTypes = function() {
      return yu(l3.visualHandlers);
    }, l3.isValidType = function(r3) {
      return l3.visualHandlers.hasOwnProperty(r3);
    }, l3.eachVisual = function(r3, e3, u) {
      ls(r3) ? mt(r3, e3, u) : e3.call(u, r3);
    }, l3.mapVisual = function(r3, e3, u) {
      var h, v4 = Ni(r3) ? [] : ls(r3) ? {} : (h = true, null);
      return l3.eachVisual(r3, function(m3, x3) {
        var C = e3.call(u, m3, x3);
        h ? v4 = C : v4[x3] = C;
      }), v4;
    }, l3.retrieveVisuals = function(r3) {
      var e3 = {}, u;
      return r3 && bJ(l3.visualHandlers, function(h, v4) {
        r3.hasOwnProperty(v4) && (e3[v4] = r3[v4], u = true);
      }), u ? e3 : null;
    }, l3.prepareVisualTypes = function(r3) {
      if (Ni(r3))
        r3 = r3.slice();
      else if (T1n(r3)) {
        var e3 = [];
        bJ(r3, function(u, h) {
          e3.push(h);
        }), r3 = e3;
      } else
        return [];
      return r3.sort(function(u, h) {
        return h === "color" && u !== "color" && u.indexOf("color") === 0 ? 1 : -1;
      }), r3;
    }, l3.dependsOn = function(r3, e3) {
      return e3 === "color" ? !!(r3 && r3.indexOf(e3) === 0) : r3 === e3;
    }, l3.findPieceIndex = function(r3, e3, u) {
      for (var h, v4 = 1 / 0, m3 = 0, x3 = e3.length; m3 < x3; m3++) {
        var C = e3[m3].value;
        if (C != null) {
          if (C === r3 || qa(C) && C === r3 + "")
            return m3;
          u && N(C, m3);
        }
      }
      for (var m3 = 0, x3 = e3.length; m3 < x3; m3++) {
        var A2 = e3[m3], D = A2.interval, P = A2.close;
        if (D) {
          if (D[0] === -1 / 0) {
            if (Yce(P[1], r3, D[1]))
              return m3;
          } else if (D[1] === 1 / 0) {
            if (Yce(P[0], D[0], r3))
              return m3;
          } else if (Yce(P[0], D[0], r3) && Yce(P[1], r3, D[1]))
            return m3;
          u && N(D[0], m3), u && N(D[1], m3);
        }
      }
      if (u)
        return r3 === 1 / 0 ? e3.length - 1 : r3 === -1 / 0 ? 0 : h;
      function N(j, W) {
        var K = Math.abs(j - r3);
        K < v4 && (v4 = K, h = W);
      }
    }, l3.visualHandlers = { color: { applyVisual: cZ("color"), getColorMapper: function() {
      var r3 = this.option;
      return no(r3.mappingMethod === "category" ? function(e3, u) {
        return !u && (e3 = this._normalizeData(e3)), IZ.call(this, e3);
      } : function(e3, u, h) {
        var v4 = !!h;
        return !u && (e3 = this._normalizeData(e3)), h = $Ie(e3, r3.parsedVisual, h), v4 ? h : r5(h, "rgba");
      }, this);
    }, _normalizedToVisual: { linear: function(r3) {
      return r5($Ie(r3, this.option.parsedVisual), "rgba");
    }, category: IZ, piecewise: function(r3, e3) {
      var u = Dke.call(this, e3);
      return u == null && (u = r5($Ie(r3, this.option.parsedVisual), "rgba")), u;
    }, fixed: _N } }, colorHue: Xce(function(r3, e3) {
      return PZ(r3, e3);
    }), colorSaturation: Xce(function(r3, e3) {
      return PZ(r3, null, e3);
    }), colorLightness: Xce(function(r3, e3) {
      return PZ(r3, null, null, e3);
    }), colorAlpha: Xce(function(r3, e3) {
      return zfe(r3, e3);
    }), decal: { applyVisual: cZ("decal"), _normalizedToVisual: { linear: null, category: IZ, piecewise: null, fixed: null } }, opacity: { applyVisual: cZ("opacity"), _normalizedToVisual: Eke([0, 1]) }, liftZ: { applyVisual: cZ("liftZ"), _normalizedToVisual: { linear: _N, category: _N, piecewise: _N, fixed: _N } }, symbol: { applyVisual: function(r3, e3, u) {
      var h = this.mapValueToVisual(r3);
      u("symbol", h);
    }, _normalizedToVisual: { linear: cat, category: IZ, piecewise: function(r3, e3) {
      var u = Dke.call(this, e3);
      return u == null && (u = cat.call(this, r3)), u;
    }, fixed: _N } }, symbolSize: { applyVisual: cZ("symbolSize"), _normalizedToVisual: Eke([0, 1]) } }, l3;
  }();
  function A1n(l3) {
    var r3 = l3.pieceList;
    l3.hasSpecialVisual = false, mt(r3, function(e3, u) {
      e3.originIndex = u, e3.visual != null && (l3.hasSpecialVisual = true);
    });
  }
  function I1n(l3) {
    var r3 = l3.categories, e3 = l3.categoryMap = {}, u = l3.visual;
    if (bJ(r3, function(m3, x3) {
      e3[m3] = x3;
    }), !Ni(u)) {
      var h = [];
      ls(u) ? bJ(u, function(m3, x3) {
        var C = e3[x3];
        h[C != null ? C : yhe] = m3;
      }) : h[yhe] = u, u = Npt(l3, h);
    }
    for (var v4 = r3.length - 1; v4 >= 0; v4--)
      u[v4] == null && (delete e3[r3[v4]], r3.pop());
  }
  function hDe(l3, r3) {
    var e3 = l3.visual, u = [];
    ls(e3) ? bJ(e3, function(v4) {
      u.push(v4);
    }) : e3 != null && u.push(e3);
    var h = { color: 1, symbol: 1 };
    !r3 && u.length === 1 && !h.hasOwnProperty(l3.type) && (u[1] = u[0]), Npt(l3, u);
  }
  function Xce(l3) {
    return { applyVisual: function(r3, e3, u) {
      var h = this.mapValueToVisual(r3);
      u("color", l3(e3("color"), h));
    }, _normalizedToVisual: Eke([0, 1]) };
  }
  function cat(l3) {
    var r3 = this.option.visual;
    return r3[Math.round(_f(l3, [0, 1], [0, r3.length - 1], true))] || {};
  }
  function cZ(l3) {
    return function(r3, e3, u) {
      u(l3, this.mapValueToVisual(r3));
    };
  }
  function IZ(l3) {
    var r3 = this.option.visual;
    return r3[this.option.loop && l3 !== yhe ? l3 % r3.length : l3];
  }
  function _N() {
    return this.option.visual[0];
  }
  function Eke(l3) {
    return { linear: function(r3) {
      return _f(r3, l3, this.option.visual, true);
    }, category: IZ, piecewise: function(r3, e3) {
      var u = Dke.call(this, e3);
      return u == null && (u = _f(r3, l3, this.option.visual, true)), u;
    }, fixed: _N };
  }
  function Dke(l3) {
    var r3 = this.option, e3 = r3.pieceList;
    if (r3.hasSpecialVisual) {
      var u = GOe.findPieceIndex(l3, e3), h = e3[u];
      if (h && h.visual)
        return h.visual[this.type];
    }
  }
  function Npt(l3, r3) {
    return l3.visual = r3, l3.type === "color" && (l3.parsedVisual = Bi(r3, function(e3) {
      return Jx(e3);
    })), r3;
  }
  var E1n = { linear: function(l3) {
    return _f(l3, this.option.dataExtent, [0, 1], true);
  }, piecewise: function(l3) {
    var r3 = this.option.pieceList, e3 = GOe.findPieceIndex(l3, r3, true);
    if (e3 != null)
      return _f(e3, [0, r3.length - 1], [0, 1], true);
  }, category: function(l3) {
    var r3 = this.option.categories ? this.option.categoryMap[l3] : l3;
    return r3 == null ? yhe : r3;
  }, fixed: Rv };
  function Yce(l3, r3, e3) {
    return l3 ? r3 <= e3 : r3 < e3;
  }
  var om = GOe, D1n = "itemStyle", Fpt = pc(), k1n = { seriesType: "treemap", reset: function(l3) {
    var r3 = l3.getData().tree, e3 = r3.root;
    e3.isRemoved() || Vpt(e3, {}, l3.getViewRoot().getAncestors(), l3);
  } };
  function Vpt(l3, r3, e3, u) {
    var h = l3.getModel(), v4 = l3.getLayout(), m3 = l3.hostTree.data;
    if (!(!v4 || v4.invisible || !v4.isInView)) {
      var x3 = h.getModel(D1n), C = O1n(x3, r3, u), A2 = m3.ensureUniqueItemVisual(l3.dataIndex, "style"), D = x3.get("borderColor"), P = x3.get("borderColorSaturation"), N;
      P != null && (N = fat(C), D = P1n(P, N)), A2.stroke = D;
      var j = l3.viewChildren;
      if (!j || !j.length)
        N = fat(C), A2.fill = N;
      else {
        var W = L1n(l3, h, v4, x3, C, j);
        mt(j, function(K, te) {
          if (K.depth >= e3.length || K === e3[K.depth]) {
            var ne = R1n(h, C, K, te, W, u);
            Vpt(K, ne, e3, u);
          }
        });
      }
    }
  }
  function O1n(l3, r3, e3) {
    var u = fi({}, r3), h = e3.designatedVisualItemStyle;
    return mt(["color", "colorAlpha", "colorSaturation"], function(v4) {
      h[v4] = r3[v4];
      var m3 = l3.get(v4);
      h[v4] = null, m3 != null && (u[v4] = m3);
    }), u;
  }
  function fat(l3) {
    var r3 = pDe(l3, "color");
    if (r3) {
      var e3 = pDe(l3, "colorAlpha"), u = pDe(l3, "colorSaturation");
      return u && (r3 = PZ(r3, null, null, u)), e3 && (r3 = zfe(r3, e3)), r3;
    }
  }
  function P1n(l3, r3) {
    return r3 != null ? PZ(r3, null, null, l3) : null;
  }
  function pDe(l3, r3) {
    var e3 = l3[r3];
    if (e3 != null && e3 !== "none")
      return e3;
  }
  function L1n(l3, r3, e3, u, h, v4) {
    if (!(!v4 || !v4.length)) {
      var m3 = dDe(r3, "color") || h.color != null && h.color !== "none" && (dDe(r3, "colorAlpha") || dDe(r3, "colorSaturation"));
      if (!!m3) {
        var x3 = r3.get("visualMin"), C = r3.get("visualMax"), A2 = e3.dataExtent.slice();
        x3 != null && x3 < A2[0] && (A2[0] = x3), C != null && C > A2[1] && (A2[1] = C);
        var D = r3.get("colorMappingBy"), P = { type: m3.name, dataExtent: A2, visual: m3.range };
        P.type === "color" && (D === "index" || D === "id") ? (P.mappingMethod = "category", P.loop = true) : P.mappingMethod = "linear";
        var N = new om(P);
        return Fpt(N).drColorMappingBy = D, N;
      }
    }
  }
  function dDe(l3, r3) {
    var e3 = l3.get(r3);
    return Ni(e3) && e3.length ? { name: r3, range: e3 } : null;
  }
  function R1n(l3, r3, e3, u, h, v4) {
    var m3 = fi({}, r3);
    if (h) {
      var x3 = h.type, C = x3 === "color" && Fpt(h).drColorMappingBy, A2 = C === "index" ? u : C === "id" ? v4.mapIdToIndex(e3.getId()) : e3.getValue(l3.get("visualDimension"));
      m3[x3] = h.mapValueToVisual(A2);
    }
    return m3;
  }
  var _J = Math.max, mhe = Math.min, hat = ey, HOe = mt, Bpt = ["itemStyle", "borderWidth"], N1n = ["itemStyle", "gapWidth"], F1n = ["upperLabel", "show"], V1n = ["upperLabel", "height"], B1n = { seriesType: "treemap", reset: function(l3, r3, e3, u) {
    var h = e3.getWidth(), v4 = e3.getHeight(), m3 = l3.option, x3 = dg(l3.getBoxLayoutParams(), { width: e3.getWidth(), height: e3.getHeight() }), C = m3.size || [], A2 = za(hat(x3.width, C[0]), h), D = za(hat(x3.height, C[1]), v4), P = u && u.type, N = ["treemapZoomToNode", "treemapRootToNode"], j = mJ(u, N, l3), W = P === "treemapRender" || P === "treemapMove" ? u.rootRect : null, K = l3.getViewRoot(), te = Ppt(K);
    if (P !== "treemapMove") {
      var ne = P === "treemapZoomToNode" ? U1n(l3, j, K, A2, D) : W ? [W.width, W.height] : [A2, D], ce = m3.sort;
      ce && ce !== "asc" && ce !== "desc" && (ce = "desc");
      var me = { squareRatio: m3.squareRatio, sort: ce, leafDepth: m3.leafDepth };
      K.hostTree.clearLayouts();
      var ve = { x: 0, y: 0, width: ne[0], height: ne[1], area: ne[0] * ne[1] };
      K.setLayout(ve), zpt(K, me, false, 0), ve = K.getLayout(), HOe(te, function(Oe, We) {
        var Ue = (te[We + 1] || K).getValue();
        Oe.setLayout(fi({ dataExtent: [Ue, Ue], borderWidth: 0, upperHeight: 0 }, ve));
      });
    }
    var Be = l3.getData().tree.root;
    Be.setLayout(q1n(x3, W, j), true), l3.setLayoutInfo(x3), jpt(Be, new Ml(-x3.x, -x3.y, h, v4), te, K, 0);
  } };
  function zpt(l3, r3, e3, u) {
    var h, v4;
    if (!l3.isRemoved()) {
      var m3 = l3.getLayout();
      h = m3.width, v4 = m3.height;
      var x3 = l3.getModel(), C = x3.get(Bpt), A2 = x3.get(N1n) / 2, D = Gpt(x3), P = Math.max(C, D), N = C - A2, j = P - A2;
      l3.setLayout({ borderWidth: C, upperHeight: P, upperLabelHeight: D }, true), h = _J(h - 2 * N, 0), v4 = _J(v4 - N - j, 0);
      var W = h * v4, K = z1n(l3, x3, W, r3, e3, u);
      if (!!K.length) {
        var te = { x: N, y: j, width: h, height: v4 }, ne = mhe(h, v4), ce = 1 / 0, me = [];
        me.area = 0;
        for (var ve = 0, Be = K.length; ve < Be; ) {
          var Oe = K[ve];
          me.push(Oe), me.area += Oe.getLayout().area;
          var We = W1n(me, ne, r3.squareRatio);
          We <= ce ? (ve++, ce = We) : (me.area -= me.pop().getLayout().area, pat(me, ne, te, A2, false), ne = mhe(te.width, te.height), me.length = me.area = 0, ce = 1 / 0);
        }
        if (me.length && pat(me, ne, te, A2, true), !e3) {
          var Ue = x3.get("childrenVisibleMin");
          Ue != null && W < Ue && (e3 = true);
        }
        for (var ve = 0, Be = K.length; ve < Be; ve++)
          zpt(K[ve], r3, e3, u + 1);
      }
    }
  }
  function z1n(l3, r3, e3, u, h, v4) {
    var m3 = l3.children || [], x3 = u.sort;
    x3 !== "asc" && x3 !== "desc" && (x3 = null);
    var C = u.leafDepth != null && u.leafDepth <= v4;
    if (h && !C)
      return l3.viewChildren = [];
    m3 = jf(m3, function(j) {
      return !j.isRemoved();
    }), G1n(m3, x3);
    var A2 = H1n(r3, m3, x3);
    if (A2.sum === 0)
      return l3.viewChildren = [];
    if (A2.sum = j1n(r3, e3, A2.sum, x3, m3), A2.sum === 0)
      return l3.viewChildren = [];
    for (var D = 0, P = m3.length; D < P; D++) {
      var N = m3[D].getValue() / A2.sum * e3;
      m3[D].setLayout({ area: N });
    }
    return C && (m3.length && l3.setLayout({ isLeafRoot: true }, true), m3.length = 0), l3.viewChildren = m3, l3.setLayout({ dataExtent: A2.dataExtent }, true), m3;
  }
  function j1n(l3, r3, e3, u, h) {
    if (!u)
      return e3;
    for (var v4 = l3.get("visibleMin"), m3 = h.length, x3 = m3, C = m3 - 1; C >= 0; C--) {
      var A2 = h[u === "asc" ? m3 - C - 1 : C].getValue();
      A2 / e3 * r3 < v4 && (x3 = C, e3 -= A2);
    }
    return u === "asc" ? h.splice(0, m3 - x3) : h.splice(x3, m3 - x3), e3;
  }
  function G1n(l3, r3) {
    return r3 && l3.sort(function(e3, u) {
      var h = r3 === "asc" ? e3.getValue() - u.getValue() : u.getValue() - e3.getValue();
      return h === 0 ? r3 === "asc" ? e3.dataIndex - u.dataIndex : u.dataIndex - e3.dataIndex : h;
    }), l3;
  }
  function H1n(l3, r3, e3) {
    for (var u = 0, h = 0, v4 = r3.length; h < v4; h++)
      u += r3[h].getValue();
    var m3 = l3.get("visualDimension"), x3;
    return !r3 || !r3.length ? x3 = [NaN, NaN] : m3 === "value" && e3 ? (x3 = [r3[r3.length - 1].getValue(), r3[0].getValue()], e3 === "asc" && x3.reverse()) : (x3 = [1 / 0, -1 / 0], HOe(r3, function(C) {
      var A2 = C.getValue(m3);
      A2 < x3[0] && (x3[0] = A2), A2 > x3[1] && (x3[1] = A2);
    })), { sum: u, dataExtent: x3 };
  }
  function W1n(l3, r3, e3) {
    for (var u = 0, h = 1 / 0, v4 = 0, m3 = void 0, x3 = l3.length; v4 < x3; v4++)
      m3 = l3[v4].getLayout().area, m3 && (m3 < h && (h = m3), m3 > u && (u = m3));
    var C = l3.area * l3.area, A2 = r3 * r3 * e3;
    return C ? _J(A2 * u / C, C / (A2 * h)) : 1 / 0;
  }
  function pat(l3, r3, e3, u, h) {
    var v4 = r3 === e3.width ? 0 : 1, m3 = 1 - v4, x3 = ["x", "y"], C = ["width", "height"], A2 = e3[x3[v4]], D = r3 ? l3.area / r3 : 0;
    (h || D > e3[C[m3]]) && (D = e3[C[m3]]);
    for (var P = 0, N = l3.length; P < N; P++) {
      var j = l3[P], W = {}, K = D ? j.getLayout().area / D : 0, te = W[C[m3]] = _J(D - 2 * u, 0), ne = e3[x3[v4]] + e3[C[v4]] - A2, ce = P === N - 1 || ne < K ? ne : K, me = W[C[v4]] = _J(ce - 2 * u, 0);
      W[x3[m3]] = e3[x3[m3]] + mhe(u, te / 2), W[x3[v4]] = A2 + mhe(u, me / 2), A2 += ce, j.setLayout(W, true);
    }
    e3[x3[m3]] += D, e3[C[m3]] -= D;
  }
  function U1n(l3, r3, e3, u, h) {
    var v4 = (r3 || {}).node, m3 = [u, h];
    if (!v4 || v4 === e3)
      return m3;
    for (var x3, C = u * h, A2 = C * l3.option.zoomToNodeRatio; x3 = v4.parentNode; ) {
      for (var D = 0, P = x3.children, N = 0, j = P.length; N < j; N++)
        D += P[N].getValue();
      var W = v4.getValue();
      if (W === 0)
        return m3;
      A2 *= D / W;
      var K = x3.getModel(), te = K.get(Bpt), ne = Math.max(te, Gpt(K));
      A2 += 4 * te * te + (3 * te + ne) * Math.pow(A2, 0.5), A2 > Ctt && (A2 = Ctt), v4 = x3;
    }
    A2 < C && (A2 = C);
    var ce = Math.pow(A2 / C, 0.5);
    return [u * ce, h * ce];
  }
  function q1n(l3, r3, e3) {
    if (r3)
      return { x: r3.x, y: r3.y };
    var u = { x: 0, y: 0 };
    if (!e3)
      return u;
    var h = e3.node, v4 = h.getLayout();
    if (!v4)
      return u;
    for (var m3 = [v4.width / 2, v4.height / 2], x3 = h; x3; ) {
      var C = x3.getLayout();
      m3[0] += C.x, m3[1] += C.y, x3 = x3.parentNode;
    }
    return { x: l3.width / 2 - m3[0], y: l3.height / 2 - m3[1] };
  }
  function jpt(l3, r3, e3, u, h) {
    var v4 = l3.getLayout(), m3 = e3[h], x3 = m3 && m3 === l3;
    if (!(m3 && !x3 || h === e3.length && l3 !== u)) {
      l3.setLayout({ isInView: true, invisible: !x3 && !r3.intersect(v4), isAboveViewRoot: x3 }, true);
      var C = new Ml(r3.x - v4.x, r3.y - v4.y, r3.width, r3.height);
      HOe(l3.viewChildren || [], function(A2) {
        jpt(A2, C, e3, u, h + 1);
      });
    }
  }
  function Gpt(l3) {
    return l3.get(F1n) ? l3.get(V1n) : 0;
  }
  function $1n(l3) {
    l3.registerSeriesModel(f1n), l3.registerChartView(M1n), l3.registerVisual(k1n), l3.registerLayout(B1n), l1n(l3);
  }
  function X1n(l3) {
    var r3 = l3.findComponents({ mainType: "legend" });
    !r3 || !r3.length || l3.eachSeriesByType("graph", function(e3) {
      var u = e3.getCategoriesData(), h = e3.getGraph(), v4 = h.data, m3 = u.mapArray(u.getName);
      v4.filterSelf(function(x3) {
        var C = v4.getItemModel(x3), A2 = C.getShallow("category");
        if (A2 != null) {
          Vc(A2) && (A2 = m3[A2]);
          for (var D = 0; D < r3.length; D++)
            if (!r3[D].isSelected(A2))
              return false;
        }
        return true;
      });
    });
  }
  function Y1n(l3) {
    var r3 = {};
    l3.eachSeriesByType("graph", function(e3) {
      var u = e3.getCategoriesData(), h = e3.getData(), v4 = {};
      u.each(function(m3) {
        var x3 = u.getName(m3);
        v4["ec-" + x3] = m3;
        var C = u.getItemModel(m3), A2 = C.getModel("itemStyle").getItemStyle();
        A2.fill || (A2.fill = e3.getColorFromPalette(x3, r3)), u.setItemVisual(m3, "style", A2);
        for (var D = ["symbol", "symbolSize", "symbolKeepAspect"], P = 0; P < D.length; P++) {
          var N = C.getShallow(D[P], true);
          N != null && u.setItemVisual(m3, D[P], N);
        }
      }), u.count() && h.each(function(m3) {
        var x3 = h.getItemModel(m3), C = x3.getShallow("category");
        if (C != null) {
          qa(C) && (C = v4["ec-" + C]);
          var A2 = u.getItemVisual(C, "style"), D = h.ensureUniqueItemVisual(m3, "style");
          fi(D, A2);
          for (var P = ["symbol", "symbolSize", "symbolKeepAspect"], N = 0; N < P.length; N++)
            h.setItemVisual(m3, P[N], u.getItemVisual(C, P[N]));
        }
      });
    });
  }
  function Kce(l3) {
    return l3 instanceof Array || (l3 = [l3, l3]), l3;
  }
  function K1n(l3) {
    l3.eachSeriesByType("graph", function(r3) {
      var e3 = r3.getGraph(), u = r3.getEdgeData(), h = Kce(r3.get("edgeSymbol")), v4 = Kce(r3.get("edgeSymbolSize"));
      u.setVisual("fromSymbol", h && h[0]), u.setVisual("toSymbol", h && h[1]), u.setVisual("fromSymbolSize", v4 && v4[0]), u.setVisual("toSymbolSize", v4 && v4[1]), u.setVisual("style", r3.getModel("lineStyle").getLineStyle()), u.each(function(m3) {
        var x3 = u.getItemModel(m3), C = e3.getEdgeByIndex(m3), A2 = Kce(x3.getShallow("symbol", true)), D = Kce(x3.getShallow("symbolSize", true)), P = x3.getModel("lineStyle").getLineStyle(), N = u.ensureUniqueItemVisual(m3, "style");
        switch (fi(N, P), N.stroke) {
          case "source": {
            var j = C.node1.getVisual("style");
            N.stroke = j && j.fill;
            break;
          }
          case "target": {
            var j = C.node2.getVisual("style");
            N.stroke = j && j.fill;
            break;
          }
        }
        A2[0] && C.setVisual("fromSymbol", A2[0]), A2[1] && C.setVisual("toSymbol", A2[1]), D[0] && C.setVisual("fromSymbolSize", D[0]), D[1] && C.setVisual("toSymbolSize", D[1]);
      });
    });
  }
  var kke = "-->", bpe = function(l3) {
    return l3.get("autoCurveness") || null;
  }, Hpt = function(l3, r3) {
    var e3 = bpe(l3), u = 20, h = [];
    if (Vc(e3))
      u = e3;
    else if (Ni(e3)) {
      l3.__curvenessList = e3;
      return;
    }
    r3 > u && (u = r3);
    var v4 = u % 2 ? u + 2 : u + 3;
    h = [];
    for (var m3 = 0; m3 < v4; m3++)
      h.push((m3 % 2 ? m3 + 1 : m3) / 10 * (m3 % 2 ? -1 : 1));
    l3.__curvenessList = h;
  }, xJ = function(l3, r3, e3) {
    var u = [l3.id, l3.dataIndex].join("."), h = [r3.id, r3.dataIndex].join(".");
    return [e3.uid, u, h].join(kke);
  }, Wpt = function(l3) {
    var r3 = l3.split(kke);
    return [r3[0], r3[2], r3[1]].join(kke);
  }, Z1n = function(l3, r3) {
    var e3 = xJ(l3.node1, l3.node2, r3);
    return r3.__edgeMap[e3];
  }, J1n = function(l3, r3) {
    var e3 = Oke(xJ(l3.node1, l3.node2, r3), r3), u = Oke(xJ(l3.node2, l3.node1, r3), r3);
    return e3 + u;
  }, Oke = function(l3, r3) {
    var e3 = r3.__edgeMap;
    return e3[l3] ? e3[l3].length : 0;
  };
  function Q1n(l3) {
    !bpe(l3) || (l3.__curvenessList = [], l3.__edgeMap = {}, Hpt(l3));
  }
  function ebn(l3, r3, e3, u) {
    if (!!bpe(e3)) {
      var h = xJ(l3, r3, e3), v4 = e3.__edgeMap, m3 = v4[Wpt(h)];
      v4[h] && !m3 ? v4[h].isForward = true : m3 && v4[h] && (m3.isForward = true, v4[h].isForward = false), v4[h] = v4[h] || [], v4[h].push(u);
    }
  }
  function WOe(l3, r3, e3, u) {
    var h = bpe(r3), v4 = Ni(h);
    if (!h)
      return null;
    var m3 = Z1n(l3, r3);
    if (!m3)
      return null;
    for (var x3 = -1, C = 0; C < m3.length; C++)
      if (m3[C] === e3) {
        x3 = C;
        break;
      }
    var A2 = J1n(l3, r3);
    Hpt(r3, A2), l3.lineStyle = l3.lineStyle || {};
    var D = xJ(l3.node1, l3.node2, r3), P = r3.__curvenessList, N = v4 || A2 % 2 ? 0 : 1;
    if (m3.isForward)
      return P[N + x3];
    var j = Wpt(D), W = Oke(j, r3), K = P[x3 + W + N];
    return u ? v4 ? h && h[0] === 0 ? (W + N) % 2 ? K : -K : ((W % 2 ? 0 : 1) + N) % 2 ? K : -K : (W + N) % 2 ? K : -K : P[x3 + W + N];
  }
  function Upt(l3) {
    var r3 = l3.coordinateSystem;
    if (!(r3 && r3.type !== "view")) {
      var e3 = l3.getGraph();
      e3.eachNode(function(u) {
        var h = u.getModel();
        u.setLayout([+h.get("x"), +h.get("y")]);
      }), qpt(e3, l3);
    }
  }
  function qpt(l3, r3) {
    l3.eachEdge(function(e3, u) {
      var h = t5(e3.getModel().get(["lineStyle", "curveness"]), -WOe(e3, r3, u, true), 0), v4 = n5(e3.node1.getLayout()), m3 = n5(e3.node2.getLayout()), x3 = [v4, m3];
      +h && x3.push([(v4[0] + m3[0]) / 2 - (v4[1] - m3[1]) * h, (v4[1] + m3[1]) / 2 - (m3[0] - v4[0]) * h]), e3.setLayout(x3);
    });
  }
  function tbn(l3, r3) {
    l3.eachSeriesByType("graph", function(e3) {
      var u = e3.get("layout"), h = e3.coordinateSystem;
      if (h && h.type !== "view") {
        var v4 = e3.getData(), m3 = [];
        mt(h.dimensions, function(N) {
          m3 = m3.concat(v4.mapDimensionsAll(N));
        });
        for (var x3 = 0; x3 < v4.count(); x3++) {
          for (var C = [], A2 = false, D = 0; D < m3.length; D++) {
            var P = v4.get(m3[D], x3);
            isNaN(P) || (A2 = true), C.push(P);
          }
          A2 ? v4.setItemLayout(x3, h.dataToPoint(C)) : v4.setItemLayout(x3, [NaN, NaN]);
        }
        qpt(v4.graph, e3);
      } else
        (!u || u === "none") && Upt(e3);
    });
  }
  function EZ(l3) {
    var r3 = l3.coordinateSystem;
    if (r3.type !== "view")
      return 1;
    var e3 = l3.option.nodeScaleRatio, u = r3.scaleX, h = r3.getZoom(), v4 = (h - 1) * e3 + 1;
    return v4 / u;
  }
  function DZ(l3) {
    var r3 = l3.getVisual("symbolSize");
    return r3 instanceof Array && (r3 = (r3[0] + r3[1]) / 2), +r3;
  }
  var dat = Math.PI, vDe = [];
  function $pt(l3, r3) {
    var e3 = l3.coordinateSystem;
    if (!(e3 && e3.type !== "view")) {
      var u = e3.getBoundingRect(), h = l3.getData(), v4 = h.graph, m3 = u.width / 2 + u.x, x3 = u.height / 2 + u.y, C = Math.min(u.width, u.height) / 2, A2 = h.count();
      h.setLayout({ cx: m3, cy: x3 }), A2 && (nbn[r3](l3, v4, h, C, m3, x3, A2), v4.eachEdge(function(D, P) {
        var N = t5(D.getModel().get(["lineStyle", "curveness"]), WOe(D, l3, P), 0), j = n5(D.node1.getLayout()), W = n5(D.node2.getLayout()), K, te = (j[0] + W[0]) / 2, ne = (j[1] + W[1]) / 2;
        +N && (N *= 3, K = [m3 * N + te * (1 - N), x3 * N + ne * (1 - N)]), D.setLayout([j, W, K]);
      }));
    }
  }
  var nbn = { value: function(l3, r3, e3, u, h, v4, m3) {
    var x3 = 0, C = e3.getSum("value"), A2 = Math.PI * 2 / (C || m3);
    r3.eachNode(function(D) {
      var P = D.getValue("value"), N = A2 * (C ? P : 1) / 2;
      x3 += N, D.setLayout([u * Math.cos(x3) + h, u * Math.sin(x3) + v4]), x3 += N;
    });
  }, symbolSize: function(l3, r3, e3, u, h, v4, m3) {
    var x3 = 0;
    vDe.length = m3;
    var C = EZ(l3);
    r3.eachNode(function(P) {
      var N = DZ(P);
      isNaN(N) && (N = 2), N < 0 && (N = 0), N *= C;
      var j = Math.asin(N / 2 / u);
      isNaN(j) && (j = dat / 2), vDe[P.dataIndex] = j, x3 += j * 2;
    });
    var A2 = (2 * dat - x3) / m3 / 2, D = 0;
    r3.eachNode(function(P) {
      var N = A2 + vDe[P.dataIndex];
      D += N, P.setLayout([u * Math.cos(D) + h, u * Math.sin(D) + v4]), D += N;
    });
  } };
  function rbn(l3) {
    l3.eachSeriesByType("graph", function(r3) {
      r3.get("layout") === "circular" && $pt(r3, "symbolSize");
    });
  }
  var Lz = _5e;
  function ibn(l3, r3, e3) {
    for (var u = l3, h = r3, v4 = e3.rect, m3 = v4.width, x3 = v4.height, C = [v4.x + m3 / 2, v4.y + x3 / 2], A2 = e3.gravity == null ? 0.1 : e3.gravity, D = 0; D < u.length; D++) {
      var P = u[D];
      P.p || (P.p = KN(m3 * (Math.random() - 0.5) + C[0], x3 * (Math.random() - 0.5) + C[1])), P.pp = n5(P.p), P.edges = null;
    }
    var N = e3.friction == null ? 0.6 : e3.friction, j = N, W, K;
    return { warmUp: function() {
      j = N * 0.8;
    }, setFixed: function(te) {
      u[te].fixed = true;
    }, setUnfixed: function(te) {
      u[te].fixed = false;
    }, beforeStep: function(te) {
      W = te;
    }, afterStep: function(te) {
      K = te;
    }, step: function(te) {
      W && W(u, h);
      for (var ne = [], ce = u.length, me = 0; me < h.length; me++) {
        var ve = h[me];
        if (!ve.ignoreForceLayout) {
          var Be = ve.n1, Oe = ve.n2;
          IN(ne, Oe.p, Be.p);
          var We = x5e(ne) - ve.d, Ue = Oe.w / (Be.w + Oe.w);
          isNaN(Ue) && (Ue = 0), IJ(ne, ne), !Be.fixed && Lz(Be.p, Be.p, ne, Ue * We * j), !Oe.fixed && Lz(Oe.p, Oe.p, ne, -(1 - Ue) * We * j);
        }
      }
      for (var me = 0; me < ce; me++) {
        var qe = u[me];
        qe.fixed || (IN(ne, C, qe.p), Lz(qe.p, qe.p, ne, A2 * j));
      }
      for (var me = 0; me < ce; me++)
        for (var Be = u[me], Ze = me + 1; Ze < ce; Ze++) {
          var Oe = u[Ze];
          IN(ne, Oe.p, Be.p);
          var We = x5e(ne);
          We === 0 && (lsn(ne, Math.random() - 0.5, Math.random() - 0.5), We = 1);
          var ct = (Be.rep + Oe.rep) / We / We;
          !Be.fixed && Lz(Be.pp, Be.pp, ne, ct), !Oe.fixed && Lz(Oe.pp, Oe.pp, ne, -ct);
        }
      for (var _t = [], me = 0; me < ce; me++) {
        var qe = u[me];
        qe.fixed || (IN(_t, qe.p, qe.pp), Lz(qe.p, qe.p, _t, j), db(qe.pp, qe.p));
      }
      j = j * 0.992;
      var pt = j < 0.01;
      K && K(u, h, pt), te && te(pt);
    } };
  }
  function abn(l3) {
    l3.eachSeriesByType("graph", function(r3) {
      var e3 = r3.coordinateSystem;
      if (!(e3 && e3.type !== "view"))
        if (r3.get("layout") === "force") {
          var u = r3.preservedPoints || {}, h = r3.getGraph(), v4 = h.data, m3 = h.edgeData, x3 = r3.getModel("force"), C = x3.get("initLayout");
          r3.preservedPoints ? v4.each(function(me) {
            var ve = v4.getId(me);
            v4.setItemLayout(me, u[ve] || [NaN, NaN]);
          }) : !C || C === "none" ? Upt(r3) : C === "circular" && $pt(r3, "value");
          var A2 = v4.getDataExtent("value"), D = m3.getDataExtent("value"), P = x3.get("repulsion"), N = x3.get("edgeLength"), j = Ni(P) ? P : [P, P], W = Ni(N) ? N : [N, N];
          W = [W[1], W[0]];
          var K = v4.mapArray("value", function(me, ve) {
            var Be = v4.getItemLayout(ve), Oe = _f(me, A2, j);
            return isNaN(Oe) && (Oe = (j[0] + j[1]) / 2), { w: Oe, rep: Oe, fixed: v4.getItemModel(ve).get("fixed"), p: !Be || isNaN(Be[0]) || isNaN(Be[1]) ? null : Be };
          }), te = m3.mapArray("value", function(me, ve) {
            var Be = h.getEdgeByIndex(ve), Oe = _f(me, D, W);
            isNaN(Oe) && (Oe = (W[0] + W[1]) / 2);
            var We = Be.getModel(), Ue = t5(Be.getModel().get(["lineStyle", "curveness"]), -WOe(Be, r3, ve, true), 0);
            return { n1: K[Be.node1.dataIndex], n2: K[Be.node2.dataIndex], d: Oe, curveness: Ue, ignoreForceLayout: We.get("ignoreForceLayout") };
          }), ne = e3.getBoundingRect(), ce = ibn(K, te, { rect: ne, gravity: x3.get("gravity"), friction: x3.get("friction") });
          ce.beforeStep(function(me, ve) {
            for (var Be = 0, Oe = me.length; Be < Oe; Be++)
              me[Be].fixed && db(me[Be].p, h.getNodeByIndex(Be).getLayout());
          }), ce.afterStep(function(me, ve, Be) {
            for (var Oe = 0, We = me.length; Oe < We; Oe++)
              me[Oe].fixed || h.getNodeByIndex(Oe).setLayout(me[Oe].p), u[v4.getId(Oe)] = me[Oe].p;
            for (var Oe = 0, We = ve.length; Oe < We; Oe++) {
              var Ue = ve[Oe], qe = h.getEdgeByIndex(Oe), Ze = Ue.n1.p, ct = Ue.n2.p, _t = qe.getLayout();
              _t = _t ? _t.slice() : [], _t[0] = _t[0] || [], _t[1] = _t[1] || [], db(_t[0], Ze), db(_t[1], ct), +Ue.curveness && (_t[2] = [(Ze[0] + ct[0]) / 2 - (Ze[1] - ct[1]) * Ue.curveness, (Ze[1] + ct[1]) / 2 - (ct[0] - Ze[0]) * Ue.curveness]), qe.setLayout(_t);
            }
          }), r3.forceLayout = ce, r3.preservedPoints = u, ce.step();
        } else
          r3.forceLayout = null;
    });
  }
  function obn(l3, r3, e3) {
    var u = fi(l3.getBoxLayoutParams(), { aspect: e3 });
    return dg(u, { width: r3.getWidth(), height: r3.getHeight() });
  }
  function sbn(l3, r3) {
    var e3 = [];
    return l3.eachSeriesByType("graph", function(u) {
      var h = u.get("coordinateSystem");
      if (!h || h === "view") {
        var v4 = u.getData(), m3 = v4.mapArray(function(te) {
          var ne = v4.getItemModel(te);
          return [+ne.get("x"), +ne.get("y")];
        }), x3 = [], C = [];
        qhe(m3, x3, C), C[0] - x3[0] === 0 && (C[0] += 1, x3[0] -= 1), C[1] - x3[1] === 0 && (C[1] += 1, x3[1] -= 1);
        var A2 = (C[0] - x3[0]) / (C[1] - x3[1]), D = obn(u, r3, A2);
        isNaN(A2) && (x3 = [D.x, D.y], C = [D.x + D.width, D.y + D.height]);
        var P = C[0] - x3[0], N = C[1] - x3[1], j = D.width, W = D.height, K = u.coordinateSystem = new YJ();
        K.zoomLimit = u.get("scaleLimit"), K.setBoundingRect(x3[0], x3[1], P, N), K.setViewRect(D.x, D.y, j, W), K.setCenter(u.get("center")), K.setZoom(u.get("zoom")), e3.push(K);
      }
    }), e3;
  }
  var vat = ty.prototype, gDe = Khe.prototype, Xpt = function() {
    function l3() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
    }
    return l3;
  }();
  (function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3;
  })(Xpt);
  function yDe(l3) {
    return isNaN(+l3.cpx1) || isNaN(+l3.cpy1);
  }
  var lbn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "ec-line", u;
    }
    return r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new Xpt();
    }, r3.prototype.buildPath = function(e3, u) {
      yDe(u) ? vat.buildPath.call(this, e3, u) : gDe.buildPath.call(this, e3, u);
    }, r3.prototype.pointAt = function(e3) {
      return yDe(this.shape) ? vat.pointAt.call(this, e3) : gDe.pointAt.call(this, e3);
    }, r3.prototype.tangentAt = function(e3) {
      var u = this.shape, h = yDe(u) ? [u.x2 - u.x1, u.y2 - u.y1] : gDe.tangentAt.call(this, e3);
      return IJ(h, h);
    }, r3;
  }(Nl), ubn = lbn, mDe = ["fromSymbol", "toSymbol"];
  function gat(l3) {
    return "_" + l3 + "Type";
  }
  function yat(l3, r3, e3) {
    var u = r3.getItemVisual(e3, l3);
    if (!(!u || u === "none")) {
      var h = r3.getItemVisual(e3, l3 + "Size"), v4 = r3.getItemVisual(e3, l3 + "Rotate"), m3 = r3.getItemVisual(e3, l3 + "Offset"), x3 = r3.getItemVisual(e3, l3 + "KeepAspect"), C = BJ(h), A2 = Pj(m3 || 0, C), D = Nv(u, -C[0] / 2 + A2[0], -C[1] / 2 + A2[1], C[0], C[1], null, x3);
      return D.__specifiedRotation = v4 == null || isNaN(v4) ? void 0 : +v4 * Math.PI / 180 || 0, D.name = l3, D;
    }
  }
  function cbn(l3) {
    var r3 = new ubn({ name: "line", subPixelOptimize: true });
    return Pke(r3.shape, l3), r3;
  }
  function Pke(l3, r3) {
    l3.x1 = r3[0][0], l3.y1 = r3[0][1], l3.x2 = r3[1][0], l3.y2 = r3[1][1], l3.percent = 1;
    var e3 = r3[2];
    e3 ? (l3.cpx1 = e3[0], l3.cpy1 = e3[1]) : (l3.cpx1 = NaN, l3.cpy1 = NaN);
  }
  var fbn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this) || this;
      return v4._createLine(e3, u, h), v4;
    }
    return r3.prototype._createLine = function(e3, u, h) {
      var v4 = e3.hostModel, m3 = e3.getItemLayout(u), x3 = cbn(m3);
      x3.shape.percent = 0, Np(x3, { shape: { percent: 1 } }, v4, u), this.add(x3), mt(mDe, function(C) {
        var A2 = yat(C, e3, u);
        this.add(A2), this[gat(C)] = e3.getItemVisual(u, C);
      }, this), this._updateCommonStl(e3, u, h);
    }, r3.prototype.updateData = function(e3, u, h) {
      var v4 = e3.hostModel, m3 = this.childOfName("line"), x3 = e3.getItemLayout(u), C = { shape: {} };
      Pke(C.shape, x3), hc(m3, C, v4, u), mt(mDe, function(A2) {
        var D = e3.getItemVisual(u, A2), P = gat(A2);
        if (this[P] !== D) {
          this.remove(this.childOfName(A2));
          var N = yat(A2, e3, u);
          this.add(N);
        }
        this[P] = D;
      }, this), this._updateCommonStl(e3, u, h);
    }, r3.prototype.getLinePath = function() {
      return this.childAt(0);
    }, r3.prototype._updateCommonStl = function(e3, u, h) {
      var v4 = e3.hostModel, m3 = this.childOfName("line"), x3 = h && h.emphasisLineStyle, C = h && h.blurLineStyle, A2 = h && h.selectLineStyle, D = h && h.labelStatesModels, P = h && h.emphasisDisabled, N = h && h.focus, j = h && h.blurScope;
      if (!h || e3.hasItemOption) {
        var W = e3.getItemModel(u), K = W.getModel("emphasis");
        x3 = K.getModel("lineStyle").getLineStyle(), C = W.getModel(["blur", "lineStyle"]).getLineStyle(), A2 = W.getModel(["select", "lineStyle"]).getLineStyle(), P = K.get("disabled"), N = K.get("focus"), j = K.get("blurScope"), D = ny(W);
      }
      var te = e3.getItemVisual(u, "style"), ne = te.stroke;
      m3.useStyle(te), m3.style.fill = null, m3.style.strokeNoScale = true, m3.ensureState("emphasis").style = x3, m3.ensureState("blur").style = C, m3.ensureState("select").style = A2, mt(mDe, function(Oe) {
        var We = this.childOfName(Oe);
        if (We) {
          We.setColor(ne), We.style.opacity = te.opacity;
          for (var Ue = 0; Ue < bb.length; Ue++) {
            var qe = bb[Ue], Ze = m3.getState(qe);
            if (Ze) {
              var ct = Ze.style || {}, _t = We.ensureState(qe), pt = _t.style || (_t.style = {});
              ct.stroke != null && (pt[We.__isEmptyBrush ? "stroke" : "fill"] = ct.stroke), ct.opacity != null && (pt.opacity = ct.opacity);
            }
          }
          We.markRedraw();
        }
      }, this);
      var ce = v4.getRawValue(u);
      _1(this, D, { labelDataIndex: u, labelFetcher: { getFormattedLabel: function(Oe, We) {
        return v4.getFormattedLabel(Oe, We, e3.dataType);
      } }, inheritColor: ne || "#000", defaultOpacity: te.opacity, defaultText: (ce == null ? e3.getName(u) : isFinite(ce) ? jd(ce) : ce) + "" });
      var me = this.getTextContent();
      if (me) {
        var ve = D.normal;
        me.__align = me.style.align, me.__verticalAlign = me.style.verticalAlign, me.__position = ve.get("position") || "middle";
        var Be = ve.get("distance");
        Ni(Be) || (Be = [Be, Be]), me.__labelDistance = Be;
      }
      this.setTextConfig({ position: null, local: true, inside: false }), Gd(this, N, j, P);
    }, r3.prototype.highlight = function() {
      zA(this);
    }, r3.prototype.downplay = function() {
      jA(this);
    }, r3.prototype.updateLayout = function(e3, u) {
      this.setLinePoints(e3.getItemLayout(u));
    }, r3.prototype.setLinePoints = function(e3) {
      var u = this.childOfName("line");
      Pke(u.shape, e3), u.dirty();
    }, r3.prototype.beforeUpdate = function() {
      var e3 = this, u = e3.childOfName("fromSymbol"), h = e3.childOfName("toSymbol"), v4 = e3.getTextContent();
      if (!u && !h && (!v4 || v4.ignore))
        return;
      for (var m3 = 1, x3 = this.parent; x3; )
        x3.scaleX && (m3 /= x3.scaleX), x3 = x3.parent;
      var C = e3.childOfName("line");
      if (!this.__dirty && !C.__dirty)
        return;
      var A2 = C.shape.percent, D = C.pointAt(0), P = C.pointAt(A2), N = IN([], P, D);
      IJ(N, N);
      function j(Ze, ct) {
        var _t = Ze.__specifiedRotation;
        if (_t == null) {
          var pt = C.tangentAt(ct);
          Ze.attr("rotation", (ct === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(pt[1], pt[0]));
        } else
          Ze.attr("rotation", _t);
      }
      if (u && (u.setPosition(D), j(u, 0), u.scaleX = u.scaleY = m3 * A2, u.markRedraw()), h && (h.setPosition(P), j(h, 1), h.scaleX = h.scaleY = m3 * A2, h.markRedraw()), v4 && !v4.ignore) {
        v4.x = v4.y = 0, v4.originX = v4.originY = 0;
        var W = void 0, K = void 0, te = v4.__labelDistance, ne = te[0] * m3, ce = te[1] * m3, me = A2 / 2, ve = C.tangentAt(me), Be = [ve[1], -ve[0]], Oe = C.pointAt(me);
        Be[1] > 0 && (Be[0] = -Be[0], Be[1] = -Be[1]);
        var We = ve[0] < 0 ? -1 : 1;
        if (v4.__position !== "start" && v4.__position !== "end") {
          var Ue = -Math.atan2(ve[1], ve[0]);
          P[0] < D[0] && (Ue = Math.PI + Ue), v4.rotation = Ue;
        }
        var qe = void 0;
        switch (v4.__position) {
          case "insideStartTop":
          case "insideMiddleTop":
          case "insideEndTop":
          case "middle":
            qe = -ce, K = "bottom";
            break;
          case "insideStartBottom":
          case "insideMiddleBottom":
          case "insideEndBottom":
            qe = ce, K = "top";
            break;
          default:
            qe = 0, K = "middle";
        }
        switch (v4.__position) {
          case "end":
            v4.x = N[0] * ne + P[0], v4.y = N[1] * ce + P[1], W = N[0] > 0.8 ? "left" : N[0] < -0.8 ? "right" : "center", K = N[1] > 0.8 ? "top" : N[1] < -0.8 ? "bottom" : "middle";
            break;
          case "start":
            v4.x = -N[0] * ne + D[0], v4.y = -N[1] * ce + D[1], W = N[0] > 0.8 ? "right" : N[0] < -0.8 ? "left" : "center", K = N[1] > 0.8 ? "bottom" : N[1] < -0.8 ? "top" : "middle";
            break;
          case "insideStartTop":
          case "insideStart":
          case "insideStartBottom":
            v4.x = ne * We + D[0], v4.y = D[1] + qe, W = ve[0] < 0 ? "right" : "left", v4.originX = -ne * We, v4.originY = -qe;
            break;
          case "insideMiddleTop":
          case "insideMiddle":
          case "insideMiddleBottom":
          case "middle":
            v4.x = Oe[0], v4.y = Oe[1] + qe, W = "center", v4.originY = -qe;
            break;
          case "insideEndTop":
          case "insideEnd":
          case "insideEndBottom":
            v4.x = -ne * We + P[0], v4.y = P[1] + qe, W = ve[0] >= 0 ? "right" : "left", v4.originX = ne * We, v4.originY = -qe;
            break;
        }
        v4.scaleX = v4.scaleY = m3, v4.setStyle({ verticalAlign: v4.__verticalAlign || K, align: v4.__align || W });
      }
    }, r3;
  }(Cs), UOe = fbn, hbn = function() {
    function l3(r3) {
      this.group = new Cs(), this._LineCtor = r3 || UOe;
    }
    return l3.prototype.updateData = function(r3) {
      var e3 = this;
      this._progressiveEls = null;
      var u = this, h = u.group, v4 = u._lineData;
      u._lineData = r3, v4 || h.removeAll();
      var m3 = mat(r3);
      r3.diff(v4).add(function(x3) {
        e3._doAdd(r3, x3, m3);
      }).update(function(x3, C) {
        e3._doUpdate(v4, r3, C, x3, m3);
      }).remove(function(x3) {
        h.remove(v4.getItemGraphicEl(x3));
      }).execute();
    }, l3.prototype.updateLayout = function() {
      var r3 = this._lineData;
      !r3 || r3.eachItemGraphicEl(function(e3, u) {
        e3.updateLayout(r3, u);
      }, this);
    }, l3.prototype.incrementalPrepareUpdate = function(r3) {
      this._seriesScope = mat(r3), this._lineData = null, this.group.removeAll();
    }, l3.prototype.incrementalUpdate = function(r3, e3) {
      this._progressiveEls = [];
      function u(x3) {
        !x3.isGroup && !pbn(x3) && (x3.incremental = true, x3.ensureState("emphasis").hoverLayer = true);
      }
      for (var h = r3.start; h < r3.end; h++) {
        var v4 = e3.getItemLayout(h);
        if (bDe(v4)) {
          var m3 = new this._LineCtor(e3, h, this._seriesScope);
          m3.traverse(u), this.group.add(m3), e3.setItemGraphicEl(h, m3), this._progressiveEls.push(m3);
        }
      }
    }, l3.prototype.remove = function() {
      this.group.removeAll();
    }, l3.prototype.eachRendered = function(r3) {
      oP(this._progressiveEls || this.group, r3);
    }, l3.prototype._doAdd = function(r3, e3, u) {
      var h = r3.getItemLayout(e3);
      if (!!bDe(h)) {
        var v4 = new this._LineCtor(r3, e3, u);
        r3.setItemGraphicEl(e3, v4), this.group.add(v4);
      }
    }, l3.prototype._doUpdate = function(r3, e3, u, h, v4) {
      var m3 = r3.getItemGraphicEl(u);
      if (!bDe(e3.getItemLayout(h))) {
        this.group.remove(m3);
        return;
      }
      m3 ? m3.updateData(e3, h, v4) : m3 = new this._LineCtor(e3, h, v4), e3.setItemGraphicEl(h, m3), this.group.add(m3);
    }, l3;
  }();
  function pbn(l3) {
    return l3.animators && l3.animators.length > 0;
  }
  function mat(l3) {
    var r3 = l3.hostModel, e3 = r3.getModel("emphasis");
    return { lineStyle: r3.getModel("lineStyle").getLineStyle(), emphasisLineStyle: e3.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: r3.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: r3.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: e3.get("disabled"), blurScope: e3.get("blurScope"), focus: e3.get("focus"), labelStatesModels: ny(r3) };
  }
  function bat(l3) {
    return isNaN(l3[0]) || isNaN(l3[1]);
  }
  function bDe(l3) {
    return l3 && !bat(l3[0]) && !bat(l3[1]);
  }
  var qOe = hbn, _De = [], xDe = [], wDe = [], Rz = Q0, SDe = LN, _at = Math.abs;
  function xat(l3, r3, e3) {
    for (var u = l3[0], h = l3[1], v4 = l3[2], m3 = 1 / 0, x3, C = e3 * e3, A2 = 0.1, D = 0.1; D <= 0.9; D += 0.1) {
      _De[0] = Rz(u[0], h[0], v4[0], D), _De[1] = Rz(u[1], h[1], v4[1], D);
      var P = _at(SDe(_De, r3) - C);
      P < m3 && (m3 = P, x3 = D);
    }
    for (var N = 0; N < 32; N++) {
      var j = x3 + A2;
      xDe[0] = Rz(u[0], h[0], v4[0], x3), xDe[1] = Rz(u[1], h[1], v4[1], x3), wDe[0] = Rz(u[0], h[0], v4[0], j), wDe[1] = Rz(u[1], h[1], v4[1], j);
      var P = SDe(xDe, r3) - C;
      if (_at(P) < 0.01)
        break;
      var W = SDe(wDe, r3) - C;
      A2 /= 2, P < 0 ? W >= 0 ? x3 = x3 + A2 : x3 = x3 - A2 : W >= 0 ? x3 = x3 - A2 : x3 = x3 + A2;
    }
    return x3;
  }
  function CDe(l3, r3) {
    var e3 = [], u = QZ, h = [[], [], []], v4 = [[], []], m3 = [];
    r3 /= 2, l3.eachEdge(function(x3, C) {
      var A2 = x3.getLayout(), D = x3.getVisual("fromSymbol"), P = x3.getVisual("toSymbol");
      A2.__original || (A2.__original = [n5(A2[0]), n5(A2[1])], A2[2] && A2.__original.push(n5(A2[2])));
      var N = A2.__original;
      if (A2[2] != null) {
        if (db(h[0], N[0]), db(h[1], N[2]), db(h[2], N[1]), D && D !== "none") {
          var j = DZ(x3.node1), W = xat(h, N[0], j * r3);
          u(h[0][0], h[1][0], h[2][0], W, e3), h[0][0] = e3[3], h[1][0] = e3[4], u(h[0][1], h[1][1], h[2][1], W, e3), h[0][1] = e3[3], h[1][1] = e3[4];
        }
        if (P && P !== "none") {
          var j = DZ(x3.node2), W = xat(h, N[1], j * r3);
          u(h[0][0], h[1][0], h[2][0], W, e3), h[1][0] = e3[1], h[2][0] = e3[2], u(h[0][1], h[1][1], h[2][1], W, e3), h[1][1] = e3[1], h[2][1] = e3[2];
        }
        db(A2[0], h[0]), db(A2[1], h[2]), db(A2[2], h[1]);
      } else {
        if (db(v4[0], N[0]), db(v4[1], N[1]), IN(m3, v4[1], v4[0]), IJ(m3, m3), D && D !== "none") {
          var j = DZ(x3.node1);
          _5e(v4[0], v4[0], m3, j * r3);
        }
        if (P && P !== "none") {
          var j = DZ(x3.node2);
          _5e(v4[1], v4[1], m3, -j * r3);
        }
        db(A2[0], v4[0]), db(A2[1], v4[1]);
      }
    });
  }
  function wat(l3) {
    return l3.type === "view";
  }
  var dbn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u) {
      var h = new WJ(), v4 = new qOe(), m3 = this.group;
      this._controller = new XJ(u.getZr()), this._controllerHost = { target: m3 }, m3.add(h.group), m3.add(v4.group), this._symbolDraw = h, this._lineDraw = v4, this._firstRender = true;
    }, r3.prototype.render = function(e3, u, h) {
      var v4 = this, m3 = e3.coordinateSystem;
      this._model = e3;
      var x3 = this._symbolDraw, C = this._lineDraw, A2 = this.group;
      if (wat(m3)) {
        var D = { x: m3.x, y: m3.y, scaleX: m3.scaleX, scaleY: m3.scaleY };
        this._firstRender ? A2.attr(D) : hc(A2, D, e3);
      }
      CDe(e3.getGraph(), EZ(e3));
      var P = e3.getData();
      x3.updateData(P);
      var N = e3.getEdgeData();
      C.updateData(N), this._updateNodeAndLinkScale(), this._updateController(e3, u, h), clearTimeout(this._layoutTimeout);
      var j = e3.forceLayout, W = e3.get(["force", "layoutAnimation"]);
      j && this._startForceLayoutIteration(j, W), P.graph.eachNode(function(ce) {
        var me = ce.dataIndex, ve = ce.getGraphicEl(), Be = ce.getModel();
        if (!!ve) {
          ve.off("drag").off("dragend");
          var Oe = Be.get("draggable");
          Oe && ve.on("drag", function() {
            j && (j.warmUp(), !v4._layouting && v4._startForceLayoutIteration(j, W), j.setFixed(me), P.setItemLayout(me, [ve.x, ve.y]));
          }).on("dragend", function() {
            j && j.setUnfixed(me);
          }), ve.setDraggable(Oe && !!j);
          var We = Be.get(["emphasis", "focus"]);
          We === "adjacency" && (Ps(ve).focus = ce.getAdjacentDataIndices());
        }
      }), P.graph.eachEdge(function(ce) {
        var me = ce.getGraphicEl(), ve = ce.getModel().get(["emphasis", "focus"]);
        !me || ve === "adjacency" && (Ps(me).focus = { edge: [ce.dataIndex], node: [ce.node1.dataIndex, ce.node2.dataIndex] });
      });
      var K = e3.get("layout") === "circular" && e3.get(["circular", "rotateLabel"]), te = P.getLayout("cx"), ne = P.getLayout("cy");
      P.eachItemGraphicEl(function(ce, me) {
        var ve = P.getItemModel(me), Be = ve.get(["label", "rotate"]) || 0, Oe = ce.getSymbolPath();
        if (K) {
          var We = P.getItemLayout(me), Ue = Math.atan2(We[1] - ne, We[0] - te);
          Ue < 0 && (Ue = Math.PI * 2 + Ue);
          var qe = We[0] < te;
          qe && (Ue = Ue - Math.PI);
          var Ze = qe ? "left" : "right";
          Oe.setTextConfig({ rotation: -Ue, position: Ze, origin: "center" });
          var ct = Oe.ensureState("emphasis");
          fi(ct.textConfig || (ct.textConfig = {}), { position: Ze });
        } else
          Oe.setTextConfig({ rotation: Be *= Math.PI / 180 });
      }), this._firstRender = false;
    }, r3.prototype.dispose = function() {
      this._controller && this._controller.dispose(), this._controllerHost = null;
    }, r3.prototype._startForceLayoutIteration = function(e3, u) {
      var h = this;
      (function v4() {
        e3.step(function(m3) {
          h.updateLayout(h._model), (h._layouting = !m3) && (u ? h._layoutTimeout = setTimeout(v4, 16) : v4());
        });
      })();
    }, r3.prototype._updateController = function(e3, u, h) {
      var v4 = this, m3 = this._controller, x3 = this._controllerHost, C = this.group;
      if (m3.setPointerChecker(function(A2, D, P) {
        var N = C.getBoundingRect();
        return N.applyTransform(C.transform), N.contain(D, P) && !gpe(A2, h, e3);
      }), !wat(e3.coordinateSystem)) {
        m3.disable();
        return;
      }
      m3.enable(e3.get("roam")), x3.zoomLimit = e3.get("scaleLimit"), x3.zoom = e3.coordinateSystem.getZoom(), m3.off("pan").off("zoom").on("pan", function(A2) {
        ROe(x3, A2.dx, A2.dy), h.dispatchAction({ seriesId: e3.id, type: "graphRoam", dx: A2.dx, dy: A2.dy });
      }).on("zoom", function(A2) {
        NOe(x3, A2.scale, A2.originX, A2.originY), h.dispatchAction({ seriesId: e3.id, type: "graphRoam", zoom: A2.scale, originX: A2.originX, originY: A2.originY }), v4._updateNodeAndLinkScale(), CDe(e3.getGraph(), EZ(e3)), v4._lineDraw.updateLayout(), h.updateLabelLayout();
      });
    }, r3.prototype._updateNodeAndLinkScale = function() {
      var e3 = this._model, u = e3.getData(), h = EZ(e3);
      u.eachItemGraphicEl(function(v4, m3) {
        v4 && v4.setSymbolScale(h);
      });
    }, r3.prototype.updateLayout = function(e3) {
      CDe(e3.getGraph(), EZ(e3)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
    }, r3.prototype.remove = function(e3, u) {
      this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
    }, r3.type = "graph", r3;
  }(zh), vbn = dbn;
  function Nz(l3) {
    return "_EC_" + l3;
  }
  var gbn = function() {
    function l3(r3) {
      this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = r3 || false;
    }
    return l3.prototype.isDirected = function() {
      return this._directed;
    }, l3.prototype.addNode = function(r3, e3) {
      r3 = r3 == null ? "" + e3 : "" + r3;
      var u = this._nodesMap;
      if (!u[Nz(r3)]) {
        var h = new xN(r3, e3);
        return h.hostGraph = this, this.nodes.push(h), u[Nz(r3)] = h, h;
      }
    }, l3.prototype.getNodeByIndex = function(r3) {
      var e3 = this.data.getRawIndex(r3);
      return this.nodes[e3];
    }, l3.prototype.getNodeById = function(r3) {
      return this._nodesMap[Nz(r3)];
    }, l3.prototype.addEdge = function(r3, e3, u) {
      var h = this._nodesMap, v4 = this._edgesMap;
      if (Vc(r3) && (r3 = this.nodes[r3]), Vc(e3) && (e3 = this.nodes[e3]), r3 instanceof xN || (r3 = h[Nz(r3)]), e3 instanceof xN || (e3 = h[Nz(e3)]), !(!r3 || !e3)) {
        var m3 = r3.id + "-" + e3.id, x3 = new Ypt(r3, e3, u);
        return x3.hostGraph = this, this._directed && (r3.outEdges.push(x3), e3.inEdges.push(x3)), r3.edges.push(x3), r3 !== e3 && e3.edges.push(x3), this.edges.push(x3), v4[m3] = x3, x3;
      }
    }, l3.prototype.getEdgeByIndex = function(r3) {
      var e3 = this.edgeData.getRawIndex(r3);
      return this.edges[e3];
    }, l3.prototype.getEdge = function(r3, e3) {
      r3 instanceof xN && (r3 = r3.id), e3 instanceof xN && (e3 = e3.id);
      var u = this._edgesMap;
      return this._directed ? u[r3 + "-" + e3] : u[r3 + "-" + e3] || u[e3 + "-" + r3];
    }, l3.prototype.eachNode = function(r3, e3) {
      for (var u = this.nodes, h = u.length, v4 = 0; v4 < h; v4++)
        u[v4].dataIndex >= 0 && r3.call(e3, u[v4], v4);
    }, l3.prototype.eachEdge = function(r3, e3) {
      for (var u = this.edges, h = u.length, v4 = 0; v4 < h; v4++)
        u[v4].dataIndex >= 0 && u[v4].node1.dataIndex >= 0 && u[v4].node2.dataIndex >= 0 && r3.call(e3, u[v4], v4);
    }, l3.prototype.breadthFirstTraverse = function(r3, e3, u, h) {
      if (e3 instanceof xN || (e3 = this._nodesMap[Nz(e3)]), !!e3) {
        for (var v4 = u === "out" ? "outEdges" : u === "in" ? "inEdges" : "edges", m3 = 0; m3 < this.nodes.length; m3++)
          this.nodes[m3].__visited = false;
        if (!r3.call(h, e3, null))
          for (var x3 = [e3]; x3.length; )
            for (var C = x3.shift(), A2 = C[v4], m3 = 0; m3 < A2.length; m3++) {
              var D = A2[m3], P = D.node1 === C ? D.node2 : D.node1;
              if (!P.__visited) {
                if (r3.call(h, P, C))
                  return;
                x3.push(P), P.__visited = true;
              }
            }
      }
    }, l3.prototype.update = function() {
      for (var r3 = this.data, e3 = this.edgeData, u = this.nodes, h = this.edges, v4 = 0, m3 = u.length; v4 < m3; v4++)
        u[v4].dataIndex = -1;
      for (var v4 = 0, m3 = r3.count(); v4 < m3; v4++)
        u[r3.getRawIndex(v4)].dataIndex = v4;
      e3.filterSelf(function(x3) {
        var C = h[e3.getRawIndex(x3)];
        return C.node1.dataIndex >= 0 && C.node2.dataIndex >= 0;
      });
      for (var v4 = 0, m3 = h.length; v4 < m3; v4++)
        h[v4].dataIndex = -1;
      for (var v4 = 0, m3 = e3.count(); v4 < m3; v4++)
        h[e3.getRawIndex(v4)].dataIndex = v4;
    }, l3.prototype.clone = function() {
      for (var r3 = new l3(this._directed), e3 = this.nodes, u = this.edges, h = 0; h < e3.length; h++)
        r3.addNode(e3[h].id, e3[h].dataIndex);
      for (var h = 0; h < u.length; h++) {
        var v4 = u[h];
        r3.addEdge(v4.node1.id, v4.node2.id, v4.dataIndex);
      }
      return r3;
    }, l3;
  }(), xN = function() {
    function l3(r3, e3) {
      this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = r3 == null ? "" : r3, this.dataIndex = e3 == null ? -1 : e3;
    }
    return l3.prototype.degree = function() {
      return this.edges.length;
    }, l3.prototype.inDegree = function() {
      return this.inEdges.length;
    }, l3.prototype.outDegree = function() {
      return this.outEdges.length;
    }, l3.prototype.getModel = function(r3) {
      if (!(this.dataIndex < 0)) {
        var e3 = this.hostGraph, u = e3.data.getItemModel(this.dataIndex);
        return u.getModel(r3);
      }
    }, l3.prototype.getAdjacentDataIndices = function() {
      for (var r3 = { edge: [], node: [] }, e3 = 0; e3 < this.edges.length; e3++) {
        var u = this.edges[e3];
        u.dataIndex < 0 || (r3.edge.push(u.dataIndex), r3.node.push(u.node1.dataIndex, u.node2.dataIndex));
      }
      return r3;
    }, l3;
  }(), Ypt = function() {
    function l3(r3, e3, u) {
      this.dataIndex = -1, this.node1 = r3, this.node2 = e3, this.dataIndex = u == null ? -1 : u;
    }
    return l3.prototype.getModel = function(r3) {
      if (!(this.dataIndex < 0)) {
        var e3 = this.hostGraph, u = e3.edgeData.getItemModel(this.dataIndex);
        return u.getModel(r3);
      }
    }, l3.prototype.getAdjacentDataIndices = function() {
      return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
    }, l3;
  }();
  function Kpt(l3, r3) {
    return { getValue: function(e3) {
      var u = this[l3][r3];
      return u.getStore().get(u.getDimensionIndex(e3 || "value"), this.dataIndex);
    }, setVisual: function(e3, u) {
      this.dataIndex >= 0 && this[l3][r3].setItemVisual(this.dataIndex, e3, u);
    }, getVisual: function(e3) {
      return this[l3][r3].getItemVisual(this.dataIndex, e3);
    }, setLayout: function(e3, u) {
      this.dataIndex >= 0 && this[l3][r3].setItemLayout(this.dataIndex, e3, u);
    }, getLayout: function() {
      return this[l3][r3].getItemLayout(this.dataIndex);
    }, getGraphicEl: function() {
      return this[l3][r3].getItemGraphicEl(this.dataIndex);
    }, getRawIndex: function() {
      return this[l3][r3].getRawIndex(this.dataIndex);
    } };
  }
  Fv(xN, Kpt("hostGraph", "data"));
  Fv(Ypt, Kpt("hostGraph", "edgeData"));
  var ybn = gbn;
  function Zpt(l3, r3, e3, u, h) {
    for (var v4 = new ybn(u), m3 = 0; m3 < l3.length; m3++)
      v4.addNode(ey(l3[m3].id, l3[m3].name, m3), m3);
    for (var x3 = [], C = [], A2 = 0, m3 = 0; m3 < r3.length; m3++) {
      var D = r3[m3], P = D.source, N = D.target;
      v4.addEdge(P, N, A2) && (C.push(D), x3.push(ey(pg(D.id, null), P + " > " + N)), A2++);
    }
    var j = e3.get("coordinateSystem"), W;
    if (j === "cartesian2d" || j === "polar")
      W = v5(l3, e3);
    else {
      var K = FJ.get(j), te = K ? K.dimensions || [] : [];
      Cl(te, "value") < 0 && te.concat(["value"]);
      var ne = zJ(l3, { coordDimensions: te, encodeDefine: e3.getEncode() }).dimensions;
      W = new yb(ne, e3), W.initData(l3);
    }
    var ce = new yb(["value"], e3);
    return ce.initData(C, x3), h && h(W, ce), kpt({ mainData: W, struct: v4, structAttr: "graph", datas: { node: W, edge: ce }, datasAttr: { node: "data", edge: "edgeData" } }), v4.update(), v4;
  }
  var mbn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.hasSymbolVisual = true, e3;
    }
    return r3.prototype.init = function(e3) {
      l3.prototype.init.apply(this, arguments);
      var u = this;
      function h() {
        return u._categoriesData;
      }
      this.legendVisualProvider = new $J(h, h), this.fillDataTextStyle(e3.edges || e3.links), this._updateCategoriesData();
    }, r3.prototype.mergeOption = function(e3) {
      l3.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(e3.edges || e3.links), this._updateCategoriesData();
    }, r3.prototype.mergeDefaultAndTheme = function(e3) {
      l3.prototype.mergeDefaultAndTheme.apply(this, arguments), HN(e3, "edgeLabel", ["show"]);
    }, r3.prototype.getInitialData = function(e3, u) {
      var h = e3.edges || e3.links || [], v4 = e3.data || e3.nodes || [], m3 = this;
      if (v4 && h) {
        Q1n(this);
        var x3 = Zpt(v4, h, this, true, C);
        return mt(x3.edges, function(A2) {
          ebn(A2.node1, A2.node2, this, A2.dataIndex);
        }, this), x3.data;
      }
      function C(A2, D) {
        A2.wrapMethod("getItemModel", function(W) {
          var K = m3._categoriesModels, te = W.getShallow("category"), ne = K[te];
          return ne && (ne.parentModel = W.parentModel, W.parentModel = ne), W;
        });
        var P = Bh.prototype.getModel;
        function N(W, K) {
          var te = P.call(this, W, K);
          return te.resolveParentPath = j, te;
        }
        D.wrapMethod("getItemModel", function(W) {
          return W.resolveParentPath = j, W.getModel = N, W;
        });
        function j(W) {
          if (W && (W[0] === "label" || W[1] === "label")) {
            var K = W.slice();
            return W[0] === "label" ? K[0] = "edgeLabel" : W[1] === "label" && (K[1] = "edgeLabel"), K;
          }
          return W;
        }
      }
    }, r3.prototype.getGraph = function() {
      return this.getData().graph;
    }, r3.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, r3.prototype.getCategoriesData = function() {
      return this._categoriesData;
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      if (h === "edge") {
        var v4 = this.getData(), m3 = this.getDataParams(e3, h), x3 = v4.graph.getEdgeByIndex(e3), C = v4.getName(x3.node1.dataIndex), A2 = v4.getName(x3.node2.dataIndex), D = [];
        return C != null && D.push(C), A2 != null && D.push(A2), o0("nameValue", { name: D.join(" > "), value: m3.value, noValue: m3.value == null });
      }
      var P = bft({ series: this, dataIndex: e3, multipleSeries: u });
      return P;
    }, r3.prototype._updateCategoriesData = function() {
      var e3 = Bi(this.option.categories || [], function(h) {
        return h.value != null ? h : fi({ value: 0 }, h);
      }), u = new yb(["value"], this);
      u.initData(e3), this._categoriesData = u, this._categoriesModels = u.mapArray(function(h) {
        return u.getItemModel(h);
      });
    }, r3.prototype.setZoom = function(e3) {
      this.option.zoom = e3;
    }, r3.prototype.setCenter = function(e3) {
      this.option.center = e3;
    }, r3.prototype.isAnimationEnabled = function() {
      return l3.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
    }, r3.type = "series.graph", r3.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], r3.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, r3;
  }(Fp), bbn = mbn, _bn = { type: "graphRoam", event: "graphRoam", update: "none" };
  function xbn(l3) {
    l3.registerChartView(vbn), l3.registerSeriesModel(bbn), l3.registerProcessor(X1n), l3.registerVisual(Y1n), l3.registerVisual(K1n), l3.registerLayout(tbn), l3.registerLayout(l3.PRIORITY.VISUAL.POST_CHART_LAYOUT, rbn), l3.registerLayout(abn), l3.registerCoordinateSystem("graphView", { dimensions: YJ.dimensions, create: sbn }), l3.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, Rv), l3.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, Rv), l3.registerAction(_bn, function(r3, e3) {
      e3.eachComponent({ mainType: "series", query: r3 }, function(u) {
        var h = u.coordinateSystem, v4 = VOe(h, r3);
        u.setCenter && u.setCenter(v4.center), u.setZoom && u.setZoom(v4.zoom);
      });
    });
  }
  var wbn = function() {
    function l3() {
      this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
    }
    return l3;
  }(), Sbn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "pointer", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new wbn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = Math.cos, v4 = Math.sin, m3 = u.r, x3 = u.width, C = u.angle, A2 = u.x - h(C) * x3 * (x3 >= m3 / 3 ? 1 : 2), D = u.y - v4(C) * x3 * (x3 >= m3 / 3 ? 1 : 2);
      C = u.angle - Math.PI / 2, e3.moveTo(A2, D), e3.lineTo(u.x + h(C) * x3, u.y + v4(C) * x3), e3.lineTo(u.x + h(u.angle) * m3, u.y + v4(u.angle) * m3), e3.lineTo(u.x - h(C) * x3, u.y - v4(C) * x3), e3.lineTo(A2, D);
    }, r3;
  }(Nl), Cbn = Sbn;
  function Mbn(l3, r3) {
    var e3 = l3.get("center"), u = r3.getWidth(), h = r3.getHeight(), v4 = Math.min(u, h), m3 = za(e3[0], r3.getWidth()), x3 = za(e3[1], r3.getHeight()), C = za(l3.get("radius"), v4 / 2);
    return { cx: m3, cy: x3, r: C };
  }
  function Zce(l3, r3) {
    var e3 = l3 == null ? "" : l3 + "";
    return r3 && (qa(r3) ? e3 = r3.replace("{value}", e3) : Xo(r3) && (e3 = r3(l3))), e3;
  }
  var MDe = Math.PI * 2, Tbn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      this.group.removeAll();
      var v4 = e3.get(["axisLine", "lineStyle", "color"]), m3 = Mbn(e3, h);
      this._renderMain(e3, u, h, v4, m3), this._data = e3.getData();
    }, r3.prototype.dispose = function() {
    }, r3.prototype._renderMain = function(e3, u, h, v4, m3) {
      for (var x3 = this.group, C = e3.get("clockwise"), A2 = -e3.get("startAngle") / 180 * Math.PI, D = -e3.get("endAngle") / 180 * Math.PI, P = e3.getModel("axisLine"), N = P.get("roundCap"), j = N ? phe : S_, W = P.get("show"), K = P.getModel("lineStyle"), te = K.get("width"), ne = !((D - A2) % MDe) && D !== A2 ? MDe : (D - A2) % MDe, ce = A2, me = 0; W && me < v4.length; me++) {
        var ve = Math.min(Math.max(v4[me][0], 0), 1);
        D = A2 + ne * ve;
        var Be = new j({ shape: { startAngle: ce, endAngle: D, cx: m3.cx, cy: m3.cy, clockwise: C, r0: m3.r - te, r: m3.r }, silent: true });
        Be.setStyle({ fill: v4[me][1] }), Be.setStyle(K.getLineStyle(["color", "width"])), x3.add(Be), ce = D;
      }
      var Oe = function(Ue) {
        if (Ue <= 0)
          return v4[0][1];
        var qe;
        for (qe = 0; qe < v4.length; qe++)
          if (v4[qe][0] >= Ue && (qe === 0 ? 0 : v4[qe - 1][0]) < Ue)
            return v4[qe][1];
        return v4[qe - 1][1];
      };
      if (!C) {
        var We = A2;
        A2 = D, D = We;
      }
      this._renderTicks(e3, u, h, Oe, m3, A2, D, C, te), this._renderTitleAndDetail(e3, u, h, Oe, m3), this._renderAnchor(e3, m3), this._renderPointer(e3, u, h, Oe, m3, A2, D, C, te);
    }, r3.prototype._renderTicks = function(e3, u, h, v4, m3, x3, C, A2, D) {
      for (var P = this.group, N = m3.cx, j = m3.cy, W = m3.r, K = +e3.get("min"), te = +e3.get("max"), ne = e3.getModel("splitLine"), ce = e3.getModel("axisTick"), me = e3.getModel("axisLabel"), ve = e3.get("splitNumber"), Be = ce.get("splitNumber"), Oe = za(ne.get("length"), W), We = za(ce.get("length"), W), Ue = x3, qe = (C - x3) / ve, Ze = qe / Be, ct = ne.getModel("lineStyle").getLineStyle(), _t = ce.getModel("lineStyle").getLineStyle(), pt = ne.get("distance"), zt, Zt, Ft = 0; Ft <= ve; Ft++) {
        if (zt = Math.cos(Ue), Zt = Math.sin(Ue), ne.get("show")) {
          var Kn = pt ? pt + D : D, hn = new ty({ shape: { x1: zt * (W - Kn) + N, y1: Zt * (W - Kn) + j, x2: zt * (W - Oe - Kn) + N, y2: Zt * (W - Oe - Kn) + j }, style: ct, silent: true });
          ct.stroke === "auto" && hn.setStyle({ stroke: v4(Ft / ve) }), P.add(hn);
        }
        if (me.get("show")) {
          var Kn = me.get("distance") + pt, xn = Zce(jd(Ft / ve * (te - K) + K), me.get("formatter")), zn = v4(Ft / ve);
          P.add(new Ec({ style: ov(me, { text: xn, x: zt * (W - Oe - Kn) + N, y: Zt * (W - Oe - Kn) + j, verticalAlign: Zt < -0.8 ? "top" : Zt > 0.8 ? "bottom" : "middle", align: zt < -0.4 ? "left" : zt > 0.4 ? "right" : "center" }, { inheritColor: zn }), silent: true }));
        }
        if (ce.get("show") && Ft !== ve) {
          var Kn = ce.get("distance");
          Kn = Kn ? Kn + D : D;
          for (var or = 0; or <= Be; or++) {
            zt = Math.cos(Ue), Zt = Math.sin(Ue);
            var vr = new ty({ shape: { x1: zt * (W - Kn) + N, y1: Zt * (W - Kn) + j, x2: zt * (W - We - Kn) + N, y2: Zt * (W - We - Kn) + j }, silent: true, style: _t });
            _t.stroke === "auto" && vr.setStyle({ stroke: v4((Ft + or / Be) / ve) }), P.add(vr), Ue += Ze;
          }
          Ue -= Ze;
        } else
          Ue += qe;
      }
    }, r3.prototype._renderPointer = function(e3, u, h, v4, m3, x3, C, A2, D) {
      var P = this.group, N = this._data, j = this._progressEls, W = [], K = e3.get(["pointer", "show"]), te = e3.getModel("progress"), ne = te.get("show"), ce = e3.getData(), me = ce.mapDimension("value"), ve = +e3.get("min"), Be = +e3.get("max"), Oe = [ve, Be], We = [x3, C];
      function Ue(Ze, ct) {
        var _t = ce.getItemModel(Ze), pt = _t.getModel("pointer"), zt = za(pt.get("width"), m3.r), Zt = za(pt.get("length"), m3.r), Ft = e3.get(["pointer", "icon"]), Kn = pt.get("offsetCenter"), hn = za(Kn[0], m3.r), xn = za(Kn[1], m3.r), zn = pt.get("keepAspect"), or;
        return Ft ? or = Nv(Ft, hn - zt / 2, xn - Zt, zt, Zt, null, zn) : or = new Cbn({ shape: { angle: -Math.PI / 2, width: zt, r: Zt, x: hn, y: xn } }), or.rotation = -(ct + Math.PI / 2), or.x = m3.cx, or.y = m3.cy, or;
      }
      function qe(Ze, ct) {
        var _t = te.get("roundCap"), pt = _t ? phe : S_, zt = te.get("overlap"), Zt = zt ? te.get("width") : D / ce.count(), Ft = zt ? m3.r - Zt : m3.r - (Ze + 1) * Zt, Kn = zt ? m3.r : m3.r - Ze * Zt, hn = new pt({ shape: { startAngle: x3, endAngle: ct, cx: m3.cx, cy: m3.cy, clockwise: A2, r0: Ft, r: Kn } });
        return zt && (hn.z2 = Be - ce.get(me, Ze) % Be), hn;
      }
      (ne || K) && (ce.diff(N).add(function(Ze) {
        var ct = ce.get(me, Ze);
        if (K) {
          var _t = Ue(Ze, x3);
          Np(_t, { rotation: -((isNaN(+ct) ? We[0] : _f(ct, Oe, We, true)) + Math.PI / 2) }, e3), P.add(_t), ce.setItemGraphicEl(Ze, _t);
        }
        if (ne) {
          var pt = qe(Ze, x3), zt = te.get("clip");
          Np(pt, { shape: { endAngle: _f(ct, Oe, We, zt) } }, e3), P.add(pt), U5e(e3.seriesIndex, ce.dataType, Ze, pt), W[Ze] = pt;
        }
      }).update(function(Ze, ct) {
        var _t = ce.get(me, Ze);
        if (K) {
          var pt = N.getItemGraphicEl(ct), zt = pt ? pt.rotation : x3, Zt = Ue(Ze, zt);
          Zt.rotation = zt, hc(Zt, { rotation: -((isNaN(+_t) ? We[0] : _f(_t, Oe, We, true)) + Math.PI / 2) }, e3), P.add(Zt), ce.setItemGraphicEl(Ze, Zt);
        }
        if (ne) {
          var Ft = j[ct], Kn = Ft ? Ft.shape.endAngle : x3, hn = qe(Ze, Kn), xn = te.get("clip");
          hc(hn, { shape: { endAngle: _f(_t, Oe, We, xn) } }, e3), P.add(hn), U5e(e3.seriesIndex, ce.dataType, Ze, hn), W[Ze] = hn;
        }
      }).execute(), ce.each(function(Ze) {
        var ct = ce.getItemModel(Ze), _t = ct.getModel("emphasis"), pt = _t.get("focus"), zt = _t.get("blurScope"), Zt = _t.get("disabled");
        if (K) {
          var Ft = ce.getItemGraphicEl(Ze), Kn = ce.getItemVisual(Ze, "style"), hn = Kn.fill;
          if (Ft instanceof lm) {
            var xn = Ft.style;
            Ft.useStyle(fi({ image: xn.image, x: xn.x, y: xn.y, width: xn.width, height: xn.height }, Kn));
          } else
            Ft.useStyle(Kn), Ft.type !== "pointer" && Ft.setColor(hn);
          Ft.setStyle(ct.getModel(["pointer", "itemStyle"]).getItemStyle()), Ft.style.fill === "auto" && Ft.setStyle("fill", v4(_f(ce.get(me, Ze), Oe, [0, 1], true))), Ft.z2EmphasisLift = 0, sm(Ft, ct), Gd(Ft, pt, zt, Zt);
        }
        if (ne) {
          var zn = W[Ze];
          zn.useStyle(ce.getItemVisual(Ze, "style")), zn.setStyle(ct.getModel(["progress", "itemStyle"]).getItemStyle()), zn.z2EmphasisLift = 0, sm(zn, ct), Gd(zn, pt, zt, Zt);
        }
      }), this._progressEls = W);
    }, r3.prototype._renderAnchor = function(e3, u) {
      var h = e3.getModel("anchor"), v4 = h.get("show");
      if (v4) {
        var m3 = h.get("size"), x3 = h.get("icon"), C = h.get("offsetCenter"), A2 = h.get("keepAspect"), D = Nv(x3, u.cx - m3 / 2 + za(C[0], u.r), u.cy - m3 / 2 + za(C[1], u.r), m3, m3, null, A2);
        D.z2 = h.get("showAbove") ? 1 : 0, D.setStyle(h.getModel("itemStyle").getItemStyle()), this.group.add(D);
      }
    }, r3.prototype._renderTitleAndDetail = function(e3, u, h, v4, m3) {
      var x3 = this, C = e3.getData(), A2 = C.mapDimension("value"), D = +e3.get("min"), P = +e3.get("max"), N = new Cs(), j = [], W = [], K = e3.isAnimationEnabled(), te = e3.get(["pointer", "showAbove"]);
      C.diff(this._data).add(function(ne) {
        j[ne] = new Ec({ silent: true }), W[ne] = new Ec({ silent: true });
      }).update(function(ne, ce) {
        j[ne] = x3._titleEls[ce], W[ne] = x3._detailEls[ce];
      }).execute(), C.each(function(ne) {
        var ce = C.getItemModel(ne), me = C.get(A2, ne), ve = new Cs(), Be = v4(_f(me, [D, P], [0, 1], true)), Oe = ce.getModel("title");
        if (Oe.get("show")) {
          var We = Oe.get("offsetCenter"), Ue = m3.cx + za(We[0], m3.r), qe = m3.cy + za(We[1], m3.r), Ze = j[ne];
          Ze.attr({ z2: te ? 0 : 2, style: ov(Oe, { x: Ue, y: qe, text: C.getName(ne), align: "center", verticalAlign: "middle" }, { inheritColor: Be }) }), ve.add(Ze);
        }
        var ct = ce.getModel("detail");
        if (ct.get("show")) {
          var _t = ct.get("offsetCenter"), pt = m3.cx + za(_t[0], m3.r), zt = m3.cy + za(_t[1], m3.r), Zt = za(ct.get("width"), m3.r), Ft = za(ct.get("height"), m3.r), Kn = e3.get(["progress", "show"]) ? C.getItemVisual(ne, "style").fill : Be, Ze = W[ne], hn = ct.get("formatter");
          Ze.attr({ z2: te ? 0 : 2, style: ov(ct, { x: pt, y: zt, text: Zce(me, hn), width: isNaN(Zt) ? null : Zt, height: isNaN(Ft) ? null : Ft, align: "center", verticalAlign: "middle" }, { inheritColor: Kn }) }), xct(Ze, { normal: ct }, me, function(zn) {
            return Zce(zn, hn);
          }), K && wct(Ze, ne, C, e3, { getFormattedLabel: function(zn, or, vr, la, Ba, Lo) {
            return Zce(Lo ? Lo.interpolatedValue : me, hn);
          } }), ve.add(Ze);
        }
        N.add(ve);
      }), this.group.add(N), this._titleEls = j, this._detailEls = W;
    }, r3.type = "gauge", r3;
  }(zh), Abn = Tbn, Ibn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.visualStyleAccessPath = "itemStyle", e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      return Lj(this, ["value"]);
    }, r3.type = "series.gauge", r3.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, r3;
  }(Fp), Ebn = Ibn;
  function Dbn(l3) {
    l3.registerChartView(Abn), l3.registerSeriesModel(Ebn);
  }
  var kbn = ["itemStyle", "opacity"], Obn = function(l3) {
    ar(r3, l3);
    function r3(e3, u) {
      var h = l3.call(this) || this, v4 = h, m3 = new M_(), x3 = new Ec();
      return v4.setTextContent(x3), h.setTextGuideLine(m3), h.updateData(e3, u, true), h;
    }
    return r3.prototype.updateData = function(e3, u, h) {
      var v4 = this, m3 = e3.hostModel, x3 = e3.getItemModel(u), C = e3.getItemLayout(u), A2 = x3.getModel("emphasis"), D = x3.get(kbn);
      D = D == null ? 1 : D, h || yM(v4), v4.useStyle(e3.getItemVisual(u, "style")), v4.style.lineJoin = "round", h ? (v4.setShape({ points: C.points }), v4.style.opacity = 0, Np(v4, { style: { opacity: D } }, m3, u)) : hc(v4, { style: { opacity: D }, shape: { points: C.points } }, m3, u), sm(v4, x3), this._updateLabel(e3, u), Gd(this, A2.get("focus"), A2.get("blurScope"), A2.get("disabled"));
    }, r3.prototype._updateLabel = function(e3, u) {
      var h = this, v4 = this.getTextGuideLine(), m3 = h.getTextContent(), x3 = e3.hostModel, C = e3.getItemModel(u), A2 = e3.getItemLayout(u), D = A2.label, P = e3.getItemVisual(u, "style"), N = P.fill;
      _1(m3, ny(C), { labelFetcher: e3.hostModel, labelDataIndex: u, defaultOpacity: P.opacity, defaultText: e3.getName(u) }, { normal: { align: D.textAlign, verticalAlign: D.verticalAlign } }), h.setTextConfig({ local: true, inside: !!D.inside, insideStroke: N, outsideFill: N });
      var j = D.linePoints;
      v4.setShape({ points: j }), h.textGuideLineConfig = { anchor: j ? new nl(j[0][0], j[0][1]) : null }, hc(m3, { style: { x: D.x, y: D.y } }, x3, u), m3.attr({ rotation: D.rotation, originX: D.x, originY: D.y, z2: 10 }), TOe(h, AOe(C), { stroke: N });
    }, r3;
  }(C_), Pbn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.ignoreLabelLineUpdate = true, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this._data, x3 = this.group;
      v4.diff(m3).add(function(C) {
        var A2 = new Obn(v4, C);
        v4.setItemGraphicEl(C, A2), x3.add(A2);
      }).update(function(C, A2) {
        var D = m3.getItemGraphicEl(A2);
        D.updateData(v4, C), x3.add(D), v4.setItemGraphicEl(C, D);
      }).remove(function(C) {
        var A2 = m3.getItemGraphicEl(C);
        aJ(A2, e3, C);
      }).execute(), this._data = v4;
    }, r3.prototype.remove = function() {
      this.group.removeAll(), this._data = null;
    }, r3.prototype.dispose = function() {
    }, r3.type = "funnel", r3;
  }(zh), Lbn = Pbn, Rbn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3) {
      l3.prototype.init.apply(this, arguments), this.legendVisualProvider = new $J(no(this.getData, this), no(this.getRawData, this)), this._defaultLabelLine(e3);
    }, r3.prototype.getInitialData = function(e3, u) {
      return Lj(this, { coordDimensions: ["value"], encodeDefaulter: Fs(nOe, this) });
    }, r3.prototype._defaultLabelLine = function(e3) {
      HN(e3, "labelLine", ["show"]);
      var u = e3.labelLine, h = e3.emphasis.labelLine;
      u.show = u.show && e3.label.show, h.show = h.show && e3.emphasis.label.show;
    }, r3.prototype.getDataParams = function(e3) {
      var u = this.getData(), h = l3.prototype.getDataParams.call(this, e3), v4 = u.mapDimension("value"), m3 = u.getSum(v4);
      return h.percent = m3 ? +(u.get(v4, e3) / m3 * 100).toFixed(2) : 0, h.$vars.push("percent"), h;
    }, r3.type = "series.funnel", r3.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, r3;
  }(Fp), Nbn = Rbn;
  function Fbn(l3, r3) {
    return dg(l3.getBoxLayoutParams(), { width: r3.getWidth(), height: r3.getHeight() });
  }
  function Vbn(l3, r3) {
    for (var e3 = l3.mapDimension("value"), u = l3.mapArray(e3, function(C) {
      return C;
    }), h = [], v4 = r3 === "ascending", m3 = 0, x3 = l3.count(); m3 < x3; m3++)
      h[m3] = m3;
    return Xo(r3) ? h.sort(r3) : r3 !== "none" && h.sort(function(C, A2) {
      return v4 ? u[C] - u[A2] : u[A2] - u[C];
    }), h;
  }
  function Bbn(l3) {
    var r3 = l3.hostModel, e3 = r3.get("orient");
    l3.each(function(u) {
      var h = l3.getItemModel(u), v4 = h.getModel("label"), m3 = v4.get("position"), x3 = h.getModel("labelLine"), C = l3.getItemLayout(u), A2 = C.points, D = m3 === "inner" || m3 === "inside" || m3 === "center" || m3 === "insideLeft" || m3 === "insideRight", P, N, j, W;
      if (D)
        m3 === "insideLeft" ? (N = (A2[0][0] + A2[3][0]) / 2 + 5, j = (A2[0][1] + A2[3][1]) / 2, P = "left") : m3 === "insideRight" ? (N = (A2[1][0] + A2[2][0]) / 2 - 5, j = (A2[1][1] + A2[2][1]) / 2, P = "right") : (N = (A2[0][0] + A2[1][0] + A2[2][0] + A2[3][0]) / 4, j = (A2[0][1] + A2[1][1] + A2[2][1] + A2[3][1]) / 4, P = "center"), W = [[N, j], [N, j]];
      else {
        var K = void 0, te = void 0, ne = void 0, ce = void 0, me = x3.get("length");
        m3 === "left" ? (K = (A2[3][0] + A2[0][0]) / 2, te = (A2[3][1] + A2[0][1]) / 2, ne = K - me, N = ne - 5, P = "right") : m3 === "right" ? (K = (A2[1][0] + A2[2][0]) / 2, te = (A2[1][1] + A2[2][1]) / 2, ne = K + me, N = ne + 5, P = "left") : m3 === "top" ? (K = (A2[3][0] + A2[0][0]) / 2, te = (A2[3][1] + A2[0][1]) / 2, ce = te - me, j = ce - 5, P = "center") : m3 === "bottom" ? (K = (A2[1][0] + A2[2][0]) / 2, te = (A2[1][1] + A2[2][1]) / 2, ce = te + me, j = ce + 5, P = "center") : m3 === "rightTop" ? (K = e3 === "horizontal" ? A2[3][0] : A2[1][0], te = e3 === "horizontal" ? A2[3][1] : A2[1][1], e3 === "horizontal" ? (ce = te - me, j = ce - 5, P = "center") : (ne = K + me, N = ne + 5, P = "top")) : m3 === "rightBottom" ? (K = A2[2][0], te = A2[2][1], e3 === "horizontal" ? (ce = te + me, j = ce + 5, P = "center") : (ne = K + me, N = ne + 5, P = "bottom")) : m3 === "leftTop" ? (K = A2[0][0], te = e3 === "horizontal" ? A2[0][1] : A2[1][1], e3 === "horizontal" ? (ce = te - me, j = ce - 5, P = "center") : (ne = K - me, N = ne - 5, P = "right")) : m3 === "leftBottom" ? (K = e3 === "horizontal" ? A2[1][0] : A2[3][0], te = e3 === "horizontal" ? A2[1][1] : A2[2][1], e3 === "horizontal" ? (ce = te + me, j = ce + 5, P = "center") : (ne = K - me, N = ne - 5, P = "right")) : (K = (A2[1][0] + A2[2][0]) / 2, te = (A2[1][1] + A2[2][1]) / 2, e3 === "horizontal" ? (ce = te + me, j = ce + 5, P = "center") : (ne = K + me, N = ne + 5, P = "left")), e3 === "horizontal" ? (ne = K, N = ne) : (ce = te, j = ce), W = [[K, te], [ne, ce]];
      }
      C.label = { linePoints: W, x: N, y: j, verticalAlign: "middle", textAlign: P, inside: D };
    });
  }
  function zbn(l3, r3) {
    l3.eachSeriesByType("funnel", function(e3) {
      var u = e3.getData(), h = u.mapDimension("value"), v4 = e3.get("sort"), m3 = Fbn(e3, r3), x3 = e3.get("orient"), C = m3.width, A2 = m3.height, D = Vbn(u, v4), P = m3.x, N = m3.y, j = x3 === "horizontal" ? [za(e3.get("minSize"), A2), za(e3.get("maxSize"), A2)] : [za(e3.get("minSize"), C), za(e3.get("maxSize"), C)], W = u.getDataExtent(h), K = e3.get("min"), te = e3.get("max");
      K == null && (K = Math.min(W[0], 0)), te == null && (te = W[1]);
      var ne = e3.get("funnelAlign"), ce = e3.get("gap"), me = x3 === "horizontal" ? C : A2, ve = (me - ce * (u.count() - 1)) / u.count(), Be = function(zt, Zt) {
        if (x3 === "horizontal") {
          var Ft = u.get(h, zt) || 0, Kn = _f(Ft, [K, te], j, true), hn = void 0;
          switch (ne) {
            case "top":
              hn = N;
              break;
            case "center":
              hn = N + (A2 - Kn) / 2;
              break;
            case "bottom":
              hn = N + (A2 - Kn);
              break;
          }
          return [[Zt, hn], [Zt, hn + Kn]];
        }
        var xn = u.get(h, zt) || 0, zn = _f(xn, [K, te], j, true), or;
        switch (ne) {
          case "left":
            or = P;
            break;
          case "center":
            or = P + (C - zn) / 2;
            break;
          case "right":
            or = P + C - zn;
            break;
        }
        return [[or, Zt], [or + zn, Zt]];
      };
      v4 === "ascending" && (ve = -ve, ce = -ce, x3 === "horizontal" ? P += C : N += A2, D = D.reverse());
      for (var Oe = 0; Oe < D.length; Oe++) {
        var We = D[Oe], Ue = D[Oe + 1], qe = u.getItemModel(We);
        if (x3 === "horizontal") {
          var Ze = qe.get(["itemStyle", "width"]);
          Ze == null ? Ze = ve : (Ze = za(Ze, C), v4 === "ascending" && (Ze = -Ze));
          var ct = Be(We, P), _t = Be(Ue, P + Ze);
          P += Ze + ce, u.setItemLayout(We, { points: ct.concat(_t.slice().reverse()) });
        } else {
          var pt = qe.get(["itemStyle", "height"]);
          pt == null ? pt = ve : (pt = za(pt, A2), v4 === "ascending" && (pt = -pt));
          var ct = Be(We, N), _t = Be(Ue, N + pt);
          N += pt + ce, u.setItemLayout(We, { points: ct.concat(_t.slice().reverse()) });
        }
      }
      Bbn(u);
    });
  }
  function jbn(l3) {
    l3.registerChartView(Lbn), l3.registerSeriesModel(Nbn), l3.registerLayout(zbn), l3.registerProcessor(qJ("funnel"));
  }
  var Gbn = 0.3, Hbn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._dataGroup = new Cs(), e3._initialized = false, e3;
    }
    return r3.prototype.init = function() {
      this.group.add(this._dataGroup);
    }, r3.prototype.render = function(e3, u, h, v4) {
      this._progressiveEls = null;
      var m3 = this._dataGroup, x3 = e3.getData(), C = this._data, A2 = e3.coordinateSystem, D = A2.dimensions, P = Cat(e3);
      x3.diff(C).add(N).update(j).remove(W).execute();
      function N(te) {
        var ne = Sat(x3, m3, te, D, A2);
        TDe(ne, x3, te, P);
      }
      function j(te, ne) {
        var ce = C.getItemGraphicEl(ne), me = Jpt(x3, te, D, A2);
        x3.setItemGraphicEl(te, ce), hc(ce, { shape: { points: me } }, e3, te), yM(ce), TDe(ce, x3, te, P);
      }
      function W(te) {
        var ne = C.getItemGraphicEl(te);
        m3.remove(ne);
      }
      if (!this._initialized) {
        this._initialized = true;
        var K = Wbn(A2, e3, function() {
          setTimeout(function() {
            m3.removeClipPath();
          });
        });
        m3.setClipPath(K);
      }
      this._data = x3;
    }, r3.prototype.incrementalPrepareRender = function(e3, u, h) {
      this._initialized = true, this._data = null, this._dataGroup.removeAll();
    }, r3.prototype.incrementalRender = function(e3, u, h) {
      for (var v4 = u.getData(), m3 = u.coordinateSystem, x3 = m3.dimensions, C = Cat(u), A2 = this._progressiveEls = [], D = e3.start; D < e3.end; D++) {
        var P = Sat(v4, this._dataGroup, D, x3, m3);
        P.incremental = true, TDe(P, v4, D, C), A2.push(P);
      }
    }, r3.prototype.remove = function() {
      this._dataGroup && this._dataGroup.removeAll(), this._data = null;
    }, r3.type = "parallel", r3;
  }(zh);
  function Wbn(l3, r3, e3) {
    var u = l3.model, h = l3.getRect(), v4 = new Ju({ shape: { x: h.x, y: h.y, width: h.width, height: h.height } }), m3 = u.get("layout") === "horizontal" ? "width" : "height";
    return v4.setShape(m3, 0), Np(v4, { shape: { width: h.width, height: h.height } }, r3, e3), v4;
  }
  function Jpt(l3, r3, e3, u) {
    for (var h = [], v4 = 0; v4 < e3.length; v4++) {
      var m3 = e3[v4], x3 = l3.get(l3.mapDimension(m3), r3);
      Ubn(x3, u.getAxis(m3).type) || h.push(u.dataToPoint(x3, m3));
    }
    return h;
  }
  function Sat(l3, r3, e3, u, h) {
    var v4 = Jpt(l3, e3, u, h), m3 = new M_({ shape: { points: v4 }, z2: 10 });
    return r3.add(m3), l3.setItemGraphicEl(e3, m3), m3;
  }
  function Cat(l3) {
    var r3 = l3.get("smooth", true);
    return r3 === true && (r3 = Gbn), r3 = c5(r3), JZ(r3) && (r3 = 0), { smooth: r3 };
  }
  function TDe(l3, r3, e3, u) {
    l3.useStyle(r3.getItemVisual(e3, "style")), l3.style.fill = null, l3.setShape("smooth", u.smooth);
    var h = r3.getItemModel(e3), v4 = h.getModel("emphasis");
    sm(l3, h, "lineStyle"), Gd(l3, v4.get("focus"), v4.get("blurScope"), v4.get("disabled"));
  }
  function Ubn(l3, r3) {
    return r3 === "category" ? l3 == null : l3 == null || isNaN(l3);
  }
  var qbn = Hbn, $bn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.visualStyleAccessPath = "lineStyle", e3.visualDrawType = "stroke", e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      return v5(null, this, { useEncodeDefaulter: no(Xbn, null, this) });
    }, r3.prototype.getRawIndicesByActiveState = function(e3) {
      var u = this.coordinateSystem, h = this.getData(), v4 = [];
      return u.eachActiveState(h, function(m3, x3) {
        e3 === m3 && v4.push(h.getRawIndex(x3));
      }), v4;
    }, r3.type = "series.parallel", r3.dependencies = ["parallel"], r3.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, r3;
  }(Fp);
  function Xbn(l3) {
    var r3 = l3.ecModel.getComponent("parallel", l3.get("parallelIndex"));
    if (!!r3) {
      var e3 = {};
      return mt(r3.dimensions, function(u) {
        var h = Ybn(u);
        e3[u] = h;
      }), e3;
    }
  }
  function Ybn(l3) {
    return +l3.replace("dim", "");
  }
  var Kbn = $bn, Zbn = ["lineStyle", "opacity"], Jbn = { seriesType: "parallel", reset: function(l3, r3) {
    var e3 = l3.coordinateSystem, u = { normal: l3.get(["lineStyle", "opacity"]), active: l3.get("activeOpacity"), inactive: l3.get("inactiveOpacity") };
    return { progress: function(h, v4) {
      e3.eachActiveState(v4, function(m3, x3) {
        var C = u[m3];
        if (m3 === "normal" && v4.hasItemOption) {
          var A2 = v4.getItemModel(x3).get(Zbn, true);
          A2 != null && (C = A2);
        }
        var D = v4.ensureUniqueItemVisual(x3, "style");
        D.opacity = C;
      }, h.start, h.end);
    } };
  } }, Qbn = Jbn;
  function e_n(l3) {
    t_n(l3), n_n(l3);
  }
  function t_n(l3) {
    if (!l3.parallel) {
      var r3 = false;
      mt(l3.series, function(e3) {
        e3 && e3.type === "parallel" && (r3 = true);
      }), r3 && (l3.parallel = [{}]);
    }
  }
  function n_n(l3) {
    var r3 = Gf(l3.parallelAxis);
    mt(r3, function(e3) {
      if (!!ls(e3)) {
        var u = e3.parallelIndex || 0, h = Gf(l3.parallel)[u];
        h && h.parallelAxisDefault && ol(e3, h.parallelAxisDefault, false);
      }
    });
  }
  var r_n = 5, i_n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      this._model = e3, this._api = h, this._handlers || (this._handlers = {}, mt(a_n, function(v4, m3) {
        h.getZr().on(m3, this._handlers[m3] = no(v4, this));
      }, this)), Oj(this, "_throttledDispatchExpand", e3.get("axisExpandRate"), "fixRate");
    }, r3.prototype.dispose = function(e3, u) {
      cJ(this, "_throttledDispatchExpand"), mt(this._handlers, function(h, v4) {
        u.getZr().off(v4, h);
      }), this._handlers = null;
    }, r3.prototype._throttledDispatchExpand = function(e3) {
      this._dispatchExpand(e3);
    }, r3.prototype._dispatchExpand = function(e3) {
      e3 && this._api.dispatchAction(fi({ type: "parallelAxisExpand" }, e3));
    }, r3.type = "parallel", r3;
  }(yd), a_n = { mousedown: function(l3) {
    ADe(this, "click") && (this._mouseDownPoint = [l3.offsetX, l3.offsetY]);
  }, mouseup: function(l3) {
    var r3 = this._mouseDownPoint;
    if (ADe(this, "click") && r3) {
      var e3 = [l3.offsetX, l3.offsetY], u = Math.pow(r3[0] - e3[0], 2) + Math.pow(r3[1] - e3[1], 2);
      if (u > r_n)
        return;
      var h = this._model.coordinateSystem.getSlidedAxisExpandWindow([l3.offsetX, l3.offsetY]);
      h.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: h.axisExpandWindow });
    }
    this._mouseDownPoint = null;
  }, mousemove: function(l3) {
    if (!(this._mouseDownPoint || !ADe(this, "mousemove"))) {
      var r3 = this._model, e3 = r3.coordinateSystem.getSlidedAxisExpandWindow([l3.offsetX, l3.offsetY]), u = e3.behavior;
      u === "jump" && this._throttledDispatchExpand.debounceNextCall(r3.get("axisExpandDebounce")), this._throttledDispatchExpand(u === "none" ? null : { axisExpandWindow: e3.axisExpandWindow, animation: u === "jump" ? null : { duration: 0 } });
    }
  } };
  function ADe(l3, r3) {
    var e3 = l3._model;
    return e3.get("axisExpandable") && e3.get("axisExpandTriggerOn") === r3;
  }
  var o_n = i_n, s_n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function() {
      l3.prototype.init.apply(this, arguments), this.mergeOption({});
    }, r3.prototype.mergeOption = function(e3) {
      var u = this.option;
      e3 && ol(u, e3, true), this._initDimensions();
    }, r3.prototype.contains = function(e3, u) {
      var h = e3.get("parallelIndex");
      return h != null && u.getComponent("parallel", h) === this;
    }, r3.prototype.setAxisExpand = function(e3) {
      mt(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(u) {
        e3.hasOwnProperty(u) && (this.option[u] = e3[u]);
      }, this);
    }, r3.prototype._initDimensions = function() {
      var e3 = this.dimensions = [], u = this.parallelAxisIndex = [], h = jf(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(v4) {
        return (v4.get("parallelIndex") || 0) === this.componentIndex;
      }, this);
      mt(h, function(v4) {
        e3.push("dim" + v4.get("dim")), u.push(v4.componentIndex);
      });
    }, r3.type = "parallel", r3.dependencies = ["parallelAxis"], r3.layoutMode = "box", r3.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, r3;
  }(fc), l_n = s_n, u_n = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4, m3) {
      var x3 = l3.call(this, e3, u, h) || this;
      return x3.type = v4 || "value", x3.axisIndex = m3, x3;
    }
    return r3.prototype.isHorizontal = function() {
      return this.coordinateSystem.getModel().get("layout") !== "horizontal";
    }, r3;
  }(bM), c_n = u_n;
  function tF(l3, r3, e3, u, h, v4) {
    l3 = l3 || 0;
    var m3 = e3[1] - e3[0];
    if (h != null && (h = Fz(h, [0, m3])), v4 != null && (v4 = Math.max(v4, h != null ? h : 0)), u === "all") {
      var x3 = Math.abs(r3[1] - r3[0]);
      x3 = Fz(x3, [0, m3]), h = v4 = Fz(x3, [h, v4]), u = 0;
    }
    r3[0] = Fz(r3[0], e3), r3[1] = Fz(r3[1], e3);
    var C = IDe(r3, u);
    r3[u] += l3;
    var A2 = h || 0, D = e3.slice();
    C.sign < 0 ? D[0] += A2 : D[1] -= A2, r3[u] = Fz(r3[u], D);
    var P;
    return P = IDe(r3, u), h != null && (P.sign !== C.sign || P.span < h) && (r3[1 - u] = r3[u] + C.sign * h), P = IDe(r3, u), v4 != null && P.span > v4 && (r3[1 - u] = r3[u] + P.sign * v4), r3;
  }
  function IDe(l3, r3) {
    var e3 = l3[r3] - l3[1 - r3];
    return { span: Math.abs(e3), sign: e3 > 0 ? -1 : e3 < 0 ? 1 : r3 ? -1 : 1 };
  }
  function Fz(l3, r3) {
    return Math.min(r3[1] != null ? r3[1] : 1 / 0, Math.max(r3[0] != null ? r3[0] : -1 / 0, l3));
  }
  var EDe = mt, Qpt = Math.min, edt = Math.max, Mat = Math.floor, f_n = Math.ceil, Tat = jd, h_n = Math.PI, p_n = function() {
    function l3(r3, e3, u) {
      this.type = "parallel", this._axesMap = Ho(), this._axesLayout = {}, this.dimensions = r3.dimensions, this._model = r3, this._init(r3, e3, u);
    }
    return l3.prototype._init = function(r3, e3, u) {
      var h = r3.dimensions, v4 = r3.parallelAxisIndex;
      EDe(h, function(m3, x3) {
        var C = v4[x3], A2 = e3.getComponent("parallelAxis", C), D = this._axesMap.set(m3, new c_n(m3, ppe(A2), [0, 0], A2.get("type"), C)), P = D.type === "category";
        D.onBand = P && A2.get("boundaryGap"), D.inverse = A2.get("inverse"), A2.axis = D, D.model = A2, D.coordinateSystem = A2.coordinateSystem = this;
      }, this);
    }, l3.prototype.update = function(r3, e3) {
      this._updateAxesFromSeries(this._model, r3);
    }, l3.prototype.containPoint = function(r3) {
      var e3 = this._makeLayoutInfo(), u = e3.axisBase, h = e3.layoutBase, v4 = e3.pixelDimIndex, m3 = r3[1 - v4], x3 = r3[v4];
      return m3 >= u && m3 <= u + e3.axisLength && x3 >= h && x3 <= h + e3.layoutLength;
    }, l3.prototype.getModel = function() {
      return this._model;
    }, l3.prototype._updateAxesFromSeries = function(r3, e3) {
      e3.eachSeries(function(u) {
        if (!!r3.contains(u, e3)) {
          var h = u.getData();
          EDe(this.dimensions, function(v4) {
            var m3 = this._axesMap.get(v4);
            m3.scale.unionExtentFromData(h, h.mapDimension(v4)), pj(m3.scale, m3.model);
          }, this);
        }
      }, this);
    }, l3.prototype.resize = function(r3, e3) {
      this._rect = dg(r3.getBoxLayoutParams(), { width: e3.getWidth(), height: e3.getHeight() }), this._layoutAxes();
    }, l3.prototype.getRect = function() {
      return this._rect;
    }, l3.prototype._makeLayoutInfo = function() {
      var r3 = this._model, e3 = this._rect, u = ["x", "y"], h = ["width", "height"], v4 = r3.get("layout"), m3 = v4 === "horizontal" ? 0 : 1, x3 = e3[h[m3]], C = [0, x3], A2 = this.dimensions.length, D = Jce(r3.get("axisExpandWidth"), C), P = Jce(r3.get("axisExpandCount") || 0, [0, A2]), N = r3.get("axisExpandable") && A2 > 3 && A2 > P && P > 1 && D > 0 && x3 > 0, j = r3.get("axisExpandWindow"), W;
      if (j)
        W = Jce(j[1] - j[0], C), j[1] = j[0] + W;
      else {
        W = Jce(D * (P - 1), C);
        var K = r3.get("axisExpandCenter") || Mat(A2 / 2);
        j = [D * K - W / 2], j[1] = j[0] + W;
      }
      var te = (x3 - W) / (A2 - P);
      te < 3 && (te = 0);
      var ne = [Mat(Tat(j[0] / D, 1)) + 1, f_n(Tat(j[1] / D, 1)) - 1], ce = te / D * j[0];
      return { layout: v4, pixelDimIndex: m3, layoutBase: e3[u[m3]], layoutLength: x3, axisBase: e3[u[1 - m3]], axisLength: e3[h[1 - m3]], axisExpandable: N, axisExpandWidth: D, axisCollapseWidth: te, axisExpandWindow: j, axisCount: A2, winInnerIndices: ne, axisExpandWindow0Pos: ce };
    }, l3.prototype._layoutAxes = function() {
      var r3 = this._rect, e3 = this._axesMap, u = this.dimensions, h = this._makeLayoutInfo(), v4 = h.layout;
      e3.each(function(m3) {
        var x3 = [0, h.axisLength], C = m3.inverse ? 1 : 0;
        m3.setExtent(x3[C], x3[1 - C]);
      }), EDe(u, function(m3, x3) {
        var C = (h.axisExpandable ? v_n : d_n)(x3, h), A2 = { horizontal: { x: C.position, y: h.axisLength }, vertical: { x: 0, y: C.position } }, D = { horizontal: h_n / 2, vertical: 0 }, P = [A2[v4].x + r3.x, A2[v4].y + r3.y], N = D[v4], j = _2();
        ZN(j, j, N), UA(j, j, P), this._axesLayout[m3] = { position: P, rotation: N, transform: j, axisNameAvailableWidth: C.axisNameAvailableWidth, axisLabelShow: C.axisLabelShow, nameTruncateMaxWidth: C.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
      }, this);
    }, l3.prototype.getAxis = function(r3) {
      return this._axesMap.get(r3);
    }, l3.prototype.dataToPoint = function(r3, e3) {
      return this.axisCoordToPoint(this._axesMap.get(e3).dataToCoord(r3), e3);
    }, l3.prototype.eachActiveState = function(r3, e3, u, h) {
      u == null && (u = 0), h == null && (h = r3.count());
      var v4 = this._axesMap, m3 = this.dimensions, x3 = [], C = [];
      mt(m3, function(te) {
        x3.push(r3.mapDimension(te)), C.push(v4.get(te).model);
      });
      for (var A2 = this.hasAxisBrushed(), D = u; D < h; D++) {
        var P = void 0;
        if (!A2)
          P = "normal";
        else {
          P = "active";
          for (var N = r3.getValues(x3, D), j = 0, W = m3.length; j < W; j++) {
            var K = C[j].getActiveState(N[j]);
            if (K === "inactive") {
              P = "inactive";
              break;
            }
          }
        }
        e3(P, D);
      }
    }, l3.prototype.hasAxisBrushed = function() {
      for (var r3 = this.dimensions, e3 = this._axesMap, u = false, h = 0, v4 = r3.length; h < v4; h++)
        e3.get(r3[h]).model.getActiveState() !== "normal" && (u = true);
      return u;
    }, l3.prototype.axisCoordToPoint = function(r3, e3) {
      var u = this._axesLayout[e3];
      return vM([r3, 0], u.transform);
    }, l3.prototype.getAxisLayout = function(r3) {
      return bs(this._axesLayout[r3]);
    }, l3.prototype.getSlidedAxisExpandWindow = function(r3) {
      var e3 = this._makeLayoutInfo(), u = e3.pixelDimIndex, h = e3.axisExpandWindow.slice(), v4 = h[1] - h[0], m3 = [0, e3.axisExpandWidth * (e3.axisCount - 1)];
      if (!this.containPoint(r3))
        return { behavior: "none", axisExpandWindow: h };
      var x3 = r3[u] - e3.layoutBase - e3.axisExpandWindow0Pos, C, A2 = "slide", D = e3.axisCollapseWidth, P = this._model.get("axisExpandSlideTriggerArea"), N = P[0] != null;
      if (D)
        N && D && x3 < v4 * P[0] ? (A2 = "jump", C = x3 - v4 * P[2]) : N && D && x3 > v4 * (1 - P[0]) ? (A2 = "jump", C = x3 - v4 * (1 - P[2])) : (C = x3 - v4 * P[1]) >= 0 && (C = x3 - v4 * (1 - P[1])) <= 0 && (C = 0), C *= e3.axisExpandWidth / D, C ? tF(C, h, m3, "all") : A2 = "none";
      else {
        var j = h[1] - h[0], W = m3[1] * x3 / j;
        h = [edt(0, W - j / 2)], h[1] = Qpt(m3[1], h[0] + j), h[0] = h[1] - j;
      }
      return { axisExpandWindow: h, behavior: A2 };
    }, l3;
  }();
  function Jce(l3, r3) {
    return Qpt(edt(l3, r3[0]), r3[1]);
  }
  function d_n(l3, r3) {
    var e3 = r3.layoutLength / (r3.axisCount - 1);
    return { position: e3 * l3, axisNameAvailableWidth: e3, axisLabelShow: true };
  }
  function v_n(l3, r3) {
    var e3 = r3.layoutLength, u = r3.axisExpandWidth, h = r3.axisCount, v4 = r3.axisCollapseWidth, m3 = r3.winInnerIndices, x3, C = v4, A2 = false, D;
    return l3 < m3[0] ? (x3 = l3 * v4, D = v4) : l3 <= m3[1] ? (x3 = r3.axisExpandWindow0Pos + l3 * u - r3.axisExpandWindow[0], C = u, A2 = true) : (x3 = e3 - (h - 1 - l3) * v4, D = v4), { position: x3, axisNameAvailableWidth: C, axisLabelShow: A2, nameTruncateMaxWidth: D };
  }
  var g_n = p_n;
  function y_n(l3, r3) {
    var e3 = [];
    return l3.eachComponent("parallel", function(u, h) {
      var v4 = new g_n(u, l3, r3);
      v4.name = "parallel_" + h, v4.resize(u, r3), u.coordinateSystem = v4, v4.model = u, e3.push(v4);
    }), l3.eachSeries(function(u) {
      if (u.get("coordinateSystem") === "parallel") {
        var h = u.getReferringComponents("parallel", Lv).models[0];
        u.coordinateSystem = h.coordinateSystem;
      }
    }), e3;
  }
  var m_n = { create: y_n }, b_n = m_n, tdt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.activeIntervals = [], e3;
    }
    return r3.prototype.getAreaSelectStyle = function() {
      return UN([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
    }, r3.prototype.setActiveIntervals = function(e3) {
      var u = this.activeIntervals = bs(e3);
      if (u)
        for (var h = u.length - 1; h >= 0; h--)
          g2(u[h]);
    }, r3.prototype.getActiveState = function(e3) {
      var u = this.activeIntervals;
      if (!u.length)
        return "normal";
      if (e3 == null || isNaN(+e3))
        return "inactive";
      if (u.length === 1) {
        var h = u[0];
        if (h[0] <= e3 && e3 <= h[1])
          return "active";
      } else
        for (var v4 = 0, m3 = u.length; v4 < m3; v4++)
          if (u[v4][0] <= e3 && e3 <= u[v4][1])
            return "active";
      return "inactive";
    }, r3;
  }(fc);
  Fv(tdt, GJ);
  var Aat = tdt, XN = true, wJ = Math.min, gj = Math.max, __n = Math.pow, x_n = 1e4, w_n = 6, S_n = 6, Iat = "globalPan", C_n = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, M_n = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, Eat = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, T_n = 0, A_n = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this) || this;
      return u._track = [], u._covers = [], u._handlers = {}, u._zr = e3, u.group = new Cs(), u._uid = "brushController_" + T_n++, mt(L_n, function(h, v4) {
        this._handlers[v4] = no(h, this);
      }, u), u;
    }
    return r3.prototype.enableBrush = function(e3) {
      return this._brushType && this._doDisableBrush(), e3.brushType && this._doEnableBrush(e3), this;
    }, r3.prototype._doEnableBrush = function(e3) {
      var u = this._zr;
      this._enableGlobalPan || Fyn(u, Iat, this._uid), mt(this._handlers, function(h, v4) {
        u.on(v4, h);
      }), this._brushType = e3.brushType, this._brushOption = ol(bs(Eat), e3, true);
    }, r3.prototype._doDisableBrush = function() {
      var e3 = this._zr;
      Vyn(e3, Iat, this._uid), mt(this._handlers, function(u, h) {
        e3.off(h, u);
      }), this._brushType = this._brushOption = null;
    }, r3.prototype.setPanels = function(e3) {
      if (e3 && e3.length) {
        var u = this._panels = {};
        mt(e3, function(h) {
          u[h.panelId] = bs(h);
        });
      } else
        this._panels = null;
      return this;
    }, r3.prototype.mount = function(e3) {
      e3 = e3 || {}, this._enableGlobalPan = e3.enableGlobalPan;
      var u = this.group;
      return this._zr.add(u), u.attr({ x: e3.x || 0, y: e3.y || 0, rotation: e3.rotation || 0, scaleX: e3.scaleX || 1, scaleY: e3.scaleY || 1 }), this._transform = u.getLocalTransform(), this;
    }, r3.prototype.updateCovers = function(e3) {
      e3 = Bi(e3, function(N) {
        return ol(bs(Eat), N, true);
      });
      var u = "\0-brush-index-", h = this._covers, v4 = this._covers = [], m3 = this, x3 = this._creatingCover;
      return new f5(h, e3, A2, C).add(D).update(D).remove(P).execute(), this;
      function C(N, j) {
        return (N.id != null ? N.id : u + j) + "-" + N.brushType;
      }
      function A2(N, j) {
        return C(N.__brushOption, j);
      }
      function D(N, j) {
        var W = e3[N];
        if (j != null && h[j] === x3)
          v4[N] = h[j];
        else {
          var K = v4[N] = j != null ? (h[j].__brushOption = W, h[j]) : rdt(m3, ndt(m3, W));
          $Oe(m3, K);
        }
      }
      function P(N) {
        h[N] !== x3 && m3.group.remove(h[N]);
      }
    }, r3.prototype.unmount = function() {
      return this.enableBrush(false), Lke(this), this._zr.remove(this.group), this;
    }, r3.prototype.dispose = function() {
      this.unmount(), this.off();
    }, r3;
  }(w2);
  function ndt(l3, r3) {
    var e3 = _pe[r3.brushType].createCover(l3, r3);
    return e3.__brushOption = r3, adt(e3, r3), l3.group.add(e3), e3;
  }
  function rdt(l3, r3) {
    var e3 = XOe(r3);
    return e3.endCreating && (e3.endCreating(l3, r3), adt(r3, r3.__brushOption)), r3;
  }
  function idt(l3, r3) {
    var e3 = r3.__brushOption;
    XOe(r3).updateCoverShape(l3, r3, e3.range, e3);
  }
  function adt(l3, r3) {
    var e3 = r3.z;
    e3 == null && (e3 = x_n), l3.traverse(function(u) {
      u.z = e3, u.z2 = e3;
    });
  }
  function $Oe(l3, r3) {
    XOe(r3).updateCommon(l3, r3), idt(l3, r3);
  }
  function XOe(l3) {
    return _pe[l3.__brushOption.brushType];
  }
  function YOe(l3, r3, e3) {
    var u = l3._panels;
    if (!u)
      return XN;
    var h, v4 = l3._transform;
    return mt(u, function(m3) {
      m3.isTargetByCursor(r3, e3, v4) && (h = m3);
    }), h;
  }
  function odt(l3, r3) {
    var e3 = l3._panels;
    if (!e3)
      return XN;
    var u = r3.__brushOption.panelId;
    return u != null ? e3[u] : XN;
  }
  function Lke(l3) {
    var r3 = l3._covers, e3 = r3.length;
    return mt(r3, function(u) {
      l3.group.remove(u);
    }, l3), r3.length = 0, !!e3;
  }
  function YN(l3, r3) {
    var e3 = Bi(l3._covers, function(u) {
      var h = u.__brushOption, v4 = bs(h.range);
      return { brushType: h.brushType, panelId: h.panelId, range: v4 };
    });
    l3.trigger("brush", { areas: e3, isEnd: !!r3.isEnd, removeOnClick: !!r3.removeOnClick });
  }
  function I_n(l3) {
    var r3 = l3._track;
    if (!r3.length)
      return false;
    var e3 = r3[r3.length - 1], u = r3[0], h = e3[0] - u[0], v4 = e3[1] - u[1], m3 = __n(h * h + v4 * v4, 0.5);
    return m3 > w_n;
  }
  function sdt(l3) {
    var r3 = l3.length - 1;
    return r3 < 0 && (r3 = 0), [l3[0], l3[r3]];
  }
  function ldt(l3, r3, e3, u) {
    var h = new Cs();
    return h.add(new Ju({ name: "main", style: KOe(e3), silent: true, draggable: true, cursor: "move", drift: Fs(Dat, l3, r3, h, ["n", "s", "w", "e"]), ondragend: Fs(YN, r3, { isEnd: true }) })), mt(u, function(v4) {
      h.add(new Ju({ name: v4.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: Fs(Dat, l3, r3, h, v4), ondragend: Fs(YN, r3, { isEnd: true }) }));
    }), h;
  }
  function udt(l3, r3, e3, u) {
    var h = u.brushStyle.lineWidth || 0, v4 = gj(h, S_n), m3 = e3[0][0], x3 = e3[1][0], C = m3 - h / 2, A2 = x3 - h / 2, D = e3[0][1], P = e3[1][1], N = D - v4 + h / 2, j = P - v4 + h / 2, W = D - m3, K = P - x3, te = W + h, ne = K + h;
    YD(l3, r3, "main", m3, x3, W, K), u.transformable && (YD(l3, r3, "w", C, A2, v4, ne), YD(l3, r3, "e", N, A2, v4, ne), YD(l3, r3, "n", C, A2, te, v4), YD(l3, r3, "s", C, j, te, v4), YD(l3, r3, "nw", C, A2, v4, v4), YD(l3, r3, "ne", N, A2, v4, v4), YD(l3, r3, "sw", C, j, v4, v4), YD(l3, r3, "se", N, j, v4, v4));
  }
  function Rke(l3, r3) {
    var e3 = r3.__brushOption, u = e3.transformable, h = r3.childAt(0);
    h.useStyle(KOe(e3)), h.attr({ silent: !u, cursor: u ? "move" : "default" }), mt([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(v4) {
      var m3 = r3.childOfName(v4.join("")), x3 = v4.length === 1 ? Nke(l3, v4[0]) : D_n(l3, v4);
      m3 && m3.attr({ silent: !u, invisible: !u, cursor: u ? M_n[x3] + "-resize" : null });
    });
  }
  function YD(l3, r3, e3, u, h, v4, m3) {
    var x3 = r3.childOfName(e3);
    x3 && x3.setShape(O_n(ZOe(l3, r3, [[u, h], [u + v4, h + m3]])));
  }
  function KOe(l3) {
    return ns({ strokeNoScale: true }, l3.brushStyle);
  }
  function cdt(l3, r3, e3, u) {
    var h = [wJ(l3, e3), wJ(r3, u)], v4 = [gj(l3, e3), gj(r3, u)];
    return [[h[0], v4[0]], [h[1], v4[1]]];
  }
  function E_n(l3) {
    return VN(l3.group);
  }
  function Nke(l3, r3) {
    var e3 = { w: "left", e: "right", n: "top", s: "bottom" }, u = { left: "w", right: "e", top: "n", bottom: "s" }, h = Jhe(e3[r3], E_n(l3));
    return u[h];
  }
  function D_n(l3, r3) {
    var e3 = [Nke(l3, r3[0]), Nke(l3, r3[1])];
    return (e3[0] === "e" || e3[0] === "w") && e3.reverse(), e3.join("");
  }
  function Dat(l3, r3, e3, u, h, v4) {
    var m3 = e3.__brushOption, x3 = l3.toRectRange(m3.range), C = fdt(r3, h, v4);
    mt(u, function(A2) {
      var D = C_n[A2];
      x3[D[0]][D[1]] += C[D[0]];
    }), m3.range = l3.fromRectRange(cdt(x3[0][0], x3[1][0], x3[0][1], x3[1][1])), $Oe(r3, e3), YN(r3, { isEnd: false });
  }
  function k_n(l3, r3, e3, u) {
    var h = r3.__brushOption.range, v4 = fdt(l3, e3, u);
    mt(h, function(m3) {
      m3[0] += v4[0], m3[1] += v4[1];
    }), $Oe(l3, r3), YN(l3, { isEnd: false });
  }
  function fdt(l3, r3, e3) {
    var u = l3.group, h = u.transformCoordToLocal(r3, e3), v4 = u.transformCoordToLocal(0, 0);
    return [h[0] - v4[0], h[1] - v4[1]];
  }
  function ZOe(l3, r3, e3) {
    var u = odt(l3, r3);
    return u && u !== XN ? u.clipPath(e3, l3._transform) : bs(e3);
  }
  function O_n(l3) {
    var r3 = wJ(l3[0][0], l3[1][0]), e3 = wJ(l3[0][1], l3[1][1]), u = gj(l3[0][0], l3[1][0]), h = gj(l3[0][1], l3[1][1]);
    return { x: r3, y: e3, width: u - r3, height: h - e3 };
  }
  function P_n(l3, r3, e3) {
    if (!(!l3._brushType || R_n(l3, r3.offsetX, r3.offsetY))) {
      var u = l3._zr, h = l3._covers, v4 = YOe(l3, r3, e3);
      if (!l3._dragging)
        for (var m3 = 0; m3 < h.length; m3++) {
          var x3 = h[m3].__brushOption;
          if (v4 && (v4 === XN || x3.panelId === v4.panelId) && _pe[x3.brushType].contain(h[m3], e3[0], e3[1]))
            return;
        }
      v4 && u.setCursorStyle("crosshair");
    }
  }
  function Fke(l3) {
    var r3 = l3.event;
    r3.preventDefault && r3.preventDefault();
  }
  function Vke(l3, r3, e3) {
    return l3.childOfName("main").contain(r3, e3);
  }
  function hdt(l3, r3, e3, u) {
    var h = l3._creatingCover, v4 = l3._creatingPanel, m3 = l3._brushOption, x3;
    if (l3._track.push(e3.slice()), I_n(l3) || h) {
      if (v4 && !h) {
        m3.brushMode === "single" && Lke(l3);
        var C = bs(m3);
        C.brushType = kat(C.brushType, v4), C.panelId = v4 === XN ? null : v4.panelId, h = l3._creatingCover = ndt(l3, C), l3._covers.push(h);
      }
      if (h) {
        var A2 = _pe[kat(l3._brushType, v4)], D = h.__brushOption;
        D.range = A2.getCreatingRange(ZOe(l3, h, l3._track)), u && (rdt(l3, h), A2.updateCommon(l3, h)), idt(l3, h), x3 = { isEnd: u };
      }
    } else
      u && m3.brushMode === "single" && m3.removeOnClick && YOe(l3, r3, e3) && Lke(l3) && (x3 = { isEnd: u, removeOnClick: true });
    return x3;
  }
  function kat(l3, r3) {
    return l3 === "auto" ? r3.defaultBrushType : l3;
  }
  var L_n = { mousedown: function(l3) {
    if (this._dragging)
      Oat(this, l3);
    else if (!l3.target || !l3.target.draggable) {
      Fke(l3);
      var r3 = this.group.transformCoordToLocal(l3.offsetX, l3.offsetY);
      this._creatingCover = null;
      var e3 = this._creatingPanel = YOe(this, l3, r3);
      e3 && (this._dragging = true, this._track = [r3.slice()]);
    }
  }, mousemove: function(l3) {
    var r3 = l3.offsetX, e3 = l3.offsetY, u = this.group.transformCoordToLocal(r3, e3);
    if (P_n(this, l3, u), this._dragging) {
      Fke(l3);
      var h = hdt(this, l3, u, false);
      h && YN(this, h);
    }
  }, mouseup: function(l3) {
    Oat(this, l3);
  } };
  function Oat(l3, r3) {
    if (l3._dragging) {
      Fke(r3);
      var e3 = r3.offsetX, u = r3.offsetY, h = l3.group.transformCoordToLocal(e3, u), v4 = hdt(l3, r3, h, true);
      l3._dragging = false, l3._track = [], l3._creatingCover = null, v4 && YN(l3, v4);
    }
  }
  function R_n(l3, r3, e3) {
    var u = l3._zr;
    return r3 < 0 || r3 > u.getWidth() || e3 < 0 || e3 > u.getHeight();
  }
  var _pe = { lineX: Pat(0), lineY: Pat(1), rect: { createCover: function(l3, r3) {
    function e3(u) {
      return u;
    }
    return ldt({ toRectRange: e3, fromRectRange: e3 }, l3, r3, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
  }, getCreatingRange: function(l3) {
    var r3 = sdt(l3);
    return cdt(r3[1][0], r3[1][1], r3[0][0], r3[0][1]);
  }, updateCoverShape: function(l3, r3, e3, u) {
    udt(l3, r3, e3, u);
  }, updateCommon: Rke, contain: Vke }, polygon: { createCover: function(l3, r3) {
    var e3 = new Cs();
    return e3.add(new M_({ name: "main", style: KOe(r3), silent: true })), e3;
  }, getCreatingRange: function(l3) {
    return l3;
  }, endCreating: function(l3, r3) {
    r3.remove(r3.childAt(0)), r3.add(new C_({ name: "main", draggable: true, drift: Fs(k_n, l3, r3), ondragend: Fs(YN, l3, { isEnd: true }) }));
  }, updateCoverShape: function(l3, r3, e3, u) {
    r3.childAt(0).setShape({ points: ZOe(l3, r3, e3) });
  }, updateCommon: Rke, contain: Vke } };
  function Pat(l3) {
    return { createCover: function(r3, e3) {
      return ldt({ toRectRange: function(u) {
        var h = [u, [0, 100]];
        return l3 && h.reverse(), h;
      }, fromRectRange: function(u) {
        return u[l3];
      } }, r3, e3, [[["w"], ["e"]], [["n"], ["s"]]][l3]);
    }, getCreatingRange: function(r3) {
      var e3 = sdt(r3), u = wJ(e3[0][l3], e3[1][l3]), h = gj(e3[0][l3], e3[1][l3]);
      return [u, h];
    }, updateCoverShape: function(r3, e3, u, h) {
      var v4, m3 = odt(r3, e3);
      if (m3 !== XN && m3.getLinearBrushOtherExtent)
        v4 = m3.getLinearBrushOtherExtent(l3);
      else {
        var x3 = r3._zr;
        v4 = [0, [x3.getWidth(), x3.getHeight()][1 - l3]];
      }
      var C = [u, v4];
      l3 && C.reverse(), udt(r3, e3, C, h);
    }, updateCommon: Rke, contain: Vke };
  }
  var JOe = A_n;
  function pdt(l3) {
    return l3 = QOe(l3), function(r3) {
      return yct(r3, l3);
    };
  }
  function ddt(l3, r3) {
    return l3 = QOe(l3), function(e3) {
      var u = r3 != null ? r3 : e3, h = u ? l3.width : l3.height, v4 = u ? l3.x : l3.y;
      return [v4, v4 + (h || 0)];
    };
  }
  function vdt(l3, r3, e3) {
    var u = QOe(l3);
    return function(h, v4) {
      return u.contain(v4[0], v4[1]) && !gpe(h, r3, e3);
    };
  }
  function QOe(l3) {
    return Ml.create(l3);
  }
  var N_n = ["axisLine", "axisTickLabel", "axisName"], F_n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u) {
      l3.prototype.init.apply(this, arguments), (this._brushController = new JOe(u.getZr())).on("brush", no(this._onBrush, this));
    }, r3.prototype.render = function(e3, u, h, v4) {
      if (!V_n(e3, u, v4)) {
        this.axisModel = e3, this.api = h, this.group.removeAll();
        var m3 = this._axisGroup;
        if (this._axisGroup = new Cs(), this.group.add(this._axisGroup), !!e3.get("show")) {
          var x3 = z_n(e3, u), C = x3.coordinateSystem, A2 = e3.getAreaSelectStyle(), D = A2.width, P = e3.axis.dim, N = C.getAxisLayout(P), j = fi({ strokeContainThreshold: D }, N), W = new h5(e3, j);
          mt(N_n, W.add, W), this._axisGroup.add(W.getGroup()), this._refreshBrushController(j, A2, e3, x3, D, h), LJ(m3, this._axisGroup, e3);
        }
      }
    }, r3.prototype._refreshBrushController = function(e3, u, h, v4, m3, x3) {
      var C = h.axis.getExtent(), A2 = C[1] - C[0], D = Math.min(30, Math.abs(A2) * 0.1), P = Ml.create({ x: C[0], y: -m3 / 2, width: A2, height: m3 });
      P.x -= D, P.width += 2 * D, this._brushController.mount({ enableGlobalPan: true, rotation: e3.rotation, x: e3.position[0], y: e3.position[1] }).setPanels([{ panelId: "pl", clipPath: pdt(P), isTargetByCursor: vdt(P, x3, v4), getLinearBrushOtherExtent: ddt(P, 0) }]).enableBrush({ brushType: "lineX", brushStyle: u, removeOnClick: true }).updateCovers(B_n(h));
    }, r3.prototype._onBrush = function(e3) {
      var u = e3.areas, h = this.axisModel, v4 = h.axis, m3 = Bi(u, function(x3) {
        return [v4.coordToData(x3.range[0], true), v4.coordToData(x3.range[1], true)];
      });
      (!h.option.realtime === e3.isEnd || e3.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: h.id, intervals: m3 });
    }, r3.prototype.dispose = function() {
      this._brushController.dispose();
    }, r3.type = "parallelAxis", r3;
  }(yd);
  function V_n(l3, r3, e3) {
    return e3 && e3.type === "axisAreaSelect" && r3.findComponents({ mainType: "parallelAxis", query: e3 })[0] === l3;
  }
  function B_n(l3) {
    var r3 = l3.axis;
    return Bi(l3.activeIntervals, function(e3) {
      return { brushType: "lineX", panelId: "pl", range: [r3.dataToCoord(e3[0], true), r3.dataToCoord(e3[1], true)] };
    });
  }
  function z_n(l3, r3) {
    return r3.getComponent("parallel", l3.get("parallelIndex"));
  }
  var j_n = F_n, G_n = { type: "axisAreaSelect", event: "axisAreaSelected" };
  function H_n(l3) {
    l3.registerAction(G_n, function(r3, e3) {
      e3.eachComponent({ mainType: "parallelAxis", query: r3 }, function(u) {
        u.axis.model.setActiveIntervals(r3.intervals);
      });
    }), l3.registerAction("parallelAxisExpand", function(r3, e3) {
      e3.eachComponent({ mainType: "parallel", query: r3 }, function(u) {
        u.setAxisExpand(r3);
      });
    });
  }
  var W_n = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
  function gdt(l3) {
    l3.registerComponentView(o_n), l3.registerComponentModel(l_n), l3.registerCoordinateSystem("parallel", b_n), l3.registerPreprocessor(e_n), l3.registerComponentModel(Aat), l3.registerComponentView(j_n), vj(l3, "parallel", Aat, W_n), H_n(l3);
  }
  function U_n(l3) {
    kl(gdt), l3.registerChartView(qbn), l3.registerSeriesModel(Kbn), l3.registerVisual(l3.PRIORITY.VISUAL.BRUSH, Qbn);
  }
  var q_n = function() {
    function l3() {
      this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
    }
    return l3;
  }(), $_n = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      return l3.call(this, e3) || this;
    }
    return r3.prototype.getDefaultShape = function() {
      return new q_n();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.extent;
      e3.moveTo(u.x1, u.y1), e3.bezierCurveTo(u.cpx1, u.cpy1, u.cpx2, u.cpy2, u.x2, u.y2), u.orient === "vertical" ? (e3.lineTo(u.x2 + h, u.y2), e3.bezierCurveTo(u.cpx2 + h, u.cpy2, u.cpx1 + h, u.cpy1, u.x1 + h, u.y1)) : (e3.lineTo(u.x2, u.y2 + h), e3.bezierCurveTo(u.cpx2, u.cpy2 + h, u.cpx1, u.cpy1 + h, u.x1, u.y1 + h)), e3.closePath();
    }, r3.prototype.highlight = function() {
      zA(this);
    }, r3.prototype.downplay = function() {
      jA(this);
    }, r3;
  }(Nl), X_n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._focusAdjacencyDisabled = false, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = this, m3 = e3.getGraph(), x3 = this.group, C = e3.layoutInfo, A2 = C.width, D = C.height, P = e3.getData(), N = e3.getData("edge"), j = e3.get("orient");
      this._model = e3, x3.removeAll(), x3.x = C.x, x3.y = C.y, m3.eachEdge(function(W) {
        var K = new $_n(), te = Ps(K);
        te.dataIndex = W.dataIndex, te.seriesIndex = e3.seriesIndex, te.dataType = "edge";
        var ne = W.getModel(), ce = ne.getModel("lineStyle"), me = ce.get("curveness"), ve = W.node1.getLayout(), Be = W.node1.getModel(), Oe = Be.get("localX"), We = Be.get("localY"), Ue = W.node2.getLayout(), qe = W.node2.getModel(), Ze = qe.get("localX"), ct = qe.get("localY"), _t = W.getLayout(), pt, zt, Zt, Ft, Kn, hn, xn, zn;
        switch (K.shape.extent = Math.max(1, _t.dy), K.shape.orient = j, j === "vertical" ? (pt = (Oe != null ? Oe * A2 : ve.x) + _t.sy, zt = (We != null ? We * D : ve.y) + ve.dy, Zt = (Ze != null ? Ze * A2 : Ue.x) + _t.ty, Ft = ct != null ? ct * D : Ue.y, Kn = pt, hn = zt * (1 - me) + Ft * me, xn = Zt, zn = zt * me + Ft * (1 - me)) : (pt = (Oe != null ? Oe * A2 : ve.x) + ve.dx, zt = (We != null ? We * D : ve.y) + _t.sy, Zt = Ze != null ? Ze * A2 : Ue.x, Ft = (ct != null ? ct * D : Ue.y) + _t.ty, Kn = pt * (1 - me) + Zt * me, hn = zt, xn = pt * me + Zt * (1 - me), zn = Ft), K.setShape({ x1: pt, y1: zt, x2: Zt, y2: Ft, cpx1: Kn, cpy1: hn, cpx2: xn, cpy2: zn }), K.useStyle(ce.getItemStyle()), K.style.fill) {
          case "source":
            K.style.fill = W.node1.getVisual("color"), K.style.decal = W.node1.getVisual("style").decal;
            break;
          case "target":
            K.style.fill = W.node2.getVisual("color"), K.style.decal = W.node2.getVisual("style").decal;
            break;
          case "gradient":
            var or = W.node1.getVisual("color"), vr = W.node2.getVisual("color");
            qa(or) && qa(vr) && (K.style.fill = new PJ(0, 0, +(j === "horizontal"), +(j === "vertical"), [{ color: or, offset: 0 }, { color: vr, offset: 1 }]));
        }
        var la = ne.getModel("emphasis");
        sm(K, ne, "lineStyle", function(Lo) {
          return Lo.getItemStyle();
        }), x3.add(K), N.setItemGraphicEl(W.dataIndex, K);
        var Ba = la.get("focus");
        Gd(K, Ba === "adjacency" ? W.getAdjacentDataIndices() : Ba, la.get("blurScope"), la.get("disabled")), Ps(K).dataType = "edge";
      }), m3.eachNode(function(W) {
        var K = W.getLayout(), te = W.getModel(), ne = te.get("localX"), ce = te.get("localY"), me = te.getModel("emphasis"), ve = new Ju({ shape: { x: ne != null ? ne * A2 : K.x, y: ce != null ? ce * D : K.y, width: K.dx, height: K.dy }, style: te.getModel("itemStyle").getItemStyle(), z2: 10 });
        _1(ve, ny(te), { labelFetcher: e3, labelDataIndex: W.dataIndex, defaultText: W.id }), ve.disableLabelAnimation = true, ve.setStyle("fill", W.getVisual("color")), ve.setStyle("decal", W.getVisual("style").decal), sm(ve, te), x3.add(ve), P.setItemGraphicEl(W.dataIndex, ve), Ps(ve).dataType = "node";
        var Be = me.get("focus");
        Gd(ve, Be === "adjacency" ? W.getAdjacentDataIndices() : Be, me.get("blurScope"), me.get("disabled"));
      }), P.eachItemGraphicEl(function(W, K) {
        var te = P.getItemModel(K);
        te.get("draggable") && (W.drift = function(ne, ce) {
          v4._focusAdjacencyDisabled = true, this.shape.x += ne, this.shape.y += ce, this.dirty(), h.dispatchAction({ type: "dragNode", seriesId: e3.id, dataIndex: P.getRawIndex(K), localX: this.shape.x / A2, localY: this.shape.y / D });
        }, W.ondragend = function() {
          v4._focusAdjacencyDisabled = false;
        }, W.draggable = true, W.cursor = "move");
      }), !this._data && e3.isAnimationEnabled() && x3.setClipPath(Y_n(x3.getBoundingRect(), e3, function() {
        x3.removeClipPath();
      })), this._data = e3.getData();
    }, r3.prototype.dispose = function() {
    }, r3.type = "sankey", r3;
  }(zh);
  function Y_n(l3, r3, e3) {
    var u = new Ju({ shape: { x: l3.x - 10, y: l3.y - 10, width: 0, height: l3.height + 20 } });
    return Np(u, { shape: { width: l3.width + 20 } }, r3, e3), u;
  }
  var K_n = X_n, Z_n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      var h = e3.edges || e3.links, v4 = e3.data || e3.nodes, m3 = e3.levels;
      this.levelModels = [];
      for (var x3 = this.levelModels, C = 0; C < m3.length; C++)
        m3[C].depth != null && m3[C].depth >= 0 && (x3[m3[C].depth] = new Bh(m3[C], this, u));
      if (v4 && h) {
        var A2 = Zpt(v4, h, this, true, D);
        return A2.data;
      }
      function D(P, N) {
        P.wrapMethod("getItemModel", function(j, W) {
          var K = j.parentModel, te = K.getData().getItemLayout(W);
          if (te) {
            var ne = te.depth, ce = K.levelModels[ne];
            ce && (j.parentModel = ce);
          }
          return j;
        }), N.wrapMethod("getItemModel", function(j, W) {
          var K = j.parentModel, te = K.getGraph().getEdgeByIndex(W), ne = te.node1.getLayout();
          if (ne) {
            var ce = ne.depth, me = K.levelModels[ce];
            me && (j.parentModel = me);
          }
          return j;
        });
      }
    }, r3.prototype.setNodePosition = function(e3, u) {
      var h = this.option.data || this.option.nodes, v4 = h[e3];
      v4.localX = u[0], v4.localY = u[1];
    }, r3.prototype.getGraph = function() {
      return this.getData().graph;
    }, r3.prototype.getEdgeData = function() {
      return this.getGraph().edgeData;
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      function v4(j) {
        return isNaN(j) || j == null;
      }
      if (h === "edge") {
        var m3 = this.getDataParams(e3, h), x3 = m3.data, C = m3.value, A2 = x3.source + " -- " + x3.target;
        return o0("nameValue", { name: A2, value: C, noValue: v4(C) });
      } else {
        var D = this.getGraph().getNodeByIndex(e3), P = D.getLayout().value, N = this.getDataParams(e3, h).data.name;
        return o0("nameValue", { name: N != null ? N + "" : null, value: P, noValue: v4(P) });
      }
    }, r3.prototype.optionUpdated = function() {
    }, r3.prototype.getDataParams = function(e3, u) {
      var h = l3.prototype.getDataParams.call(this, e3, u);
      if (h.value == null && u === "node") {
        var v4 = this.getGraph().getNodeByIndex(e3), m3 = v4.getLayout().value;
        h.value = m3;
      }
      return h;
    }, r3.type = "series.sankey", r3.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, r3;
  }(Fp), J_n = Z_n;
  function Q_n(l3, r3) {
    l3.eachSeriesByType("sankey", function(e3) {
      var u = e3.get("nodeWidth"), h = e3.get("nodeGap"), v4 = exn(e3, r3);
      e3.layoutInfo = v4;
      var m3 = v4.width, x3 = v4.height, C = e3.getGraph(), A2 = C.nodes, D = C.edges;
      nxn(A2);
      var P = jf(A2, function(K) {
        return K.getLayout().value === 0;
      }), N = P.length !== 0 ? 0 : e3.get("layoutIterations"), j = e3.get("orient"), W = e3.get("nodeAlign");
      txn(A2, D, u, h, m3, x3, N, j, W);
    });
  }
  function exn(l3, r3) {
    return dg(l3.getBoxLayoutParams(), { width: r3.getWidth(), height: r3.getHeight() });
  }
  function txn(l3, r3, e3, u, h, v4, m3, x3, C) {
    rxn(l3, r3, e3, h, v4, x3, C), sxn(l3, r3, v4, h, u, m3, x3), gxn(l3, x3);
  }
  function nxn(l3) {
    mt(l3, function(r3) {
      var e3 = YO(r3.outEdges, bhe), u = YO(r3.inEdges, bhe), h = r3.getValue() || 0, v4 = Math.max(e3, u, h);
      r3.setLayout({ value: v4 }, true);
    });
  }
  function rxn(l3, r3, e3, u, h, v4, m3) {
    for (var x3 = [], C = [], A2 = [], D = [], P = 0, N = 0; N < r3.length; N++)
      x3[N] = 1;
    for (var N = 0; N < l3.length; N++)
      C[N] = l3[N].inEdges.length, C[N] === 0 && A2.push(l3[N]);
    for (var j = -1; A2.length; ) {
      for (var W = 0; W < A2.length; W++) {
        var K = A2[W], te = K.hostGraph.data.getRawDataItem(K.dataIndex), ne = te.depth != null && te.depth >= 0;
        ne && te.depth > j && (j = te.depth), K.setLayout({ depth: ne ? te.depth : P }, true), v4 === "vertical" ? K.setLayout({ dy: e3 }, true) : K.setLayout({ dx: e3 }, true);
        for (var ce = 0; ce < K.outEdges.length; ce++) {
          var me = K.outEdges[ce], ve = r3.indexOf(me);
          x3[ve] = 0;
          var Be = me.node2, Oe = l3.indexOf(Be);
          --C[Oe] === 0 && D.indexOf(Be) < 0 && D.push(Be);
        }
      }
      ++P, A2 = D, D = [];
    }
    for (var N = 0; N < x3.length; N++)
      if (x3[N] === 1)
        throw new Error("Sankey is a DAG, the original data has cycle!");
    var We = j > P - 1 ? j : P - 1;
    m3 && m3 !== "left" && ixn(l3, m3, v4, We);
    var Ue = v4 === "vertical" ? (h - e3) / We : (u - e3) / We;
    oxn(l3, Ue, v4);
  }
  function ydt(l3) {
    var r3 = l3.hostGraph.data.getRawDataItem(l3.dataIndex);
    return r3.depth != null && r3.depth >= 0;
  }
  function ixn(l3, r3, e3, u) {
    if (r3 === "right") {
      for (var h = [], v4 = l3, m3 = 0; v4.length; ) {
        for (var x3 = 0; x3 < v4.length; x3++) {
          var C = v4[x3];
          C.setLayout({ skNodeHeight: m3 }, true);
          for (var A2 = 0; A2 < C.inEdges.length; A2++) {
            var D = C.inEdges[A2];
            h.indexOf(D.node1) < 0 && h.push(D.node1);
          }
        }
        v4 = h, h = [], ++m3;
      }
      mt(l3, function(P) {
        ydt(P) || P.setLayout({ depth: Math.max(0, u - P.getLayout().skNodeHeight) }, true);
      });
    } else
      r3 === "justify" && axn(l3, u);
  }
  function axn(l3, r3) {
    mt(l3, function(e3) {
      !ydt(e3) && !e3.outEdges.length && e3.setLayout({ depth: r3 }, true);
    });
  }
  function oxn(l3, r3, e3) {
    mt(l3, function(u) {
      var h = u.getLayout().depth * r3;
      e3 === "vertical" ? u.setLayout({ y: h }, true) : u.setLayout({ x: h }, true);
    });
  }
  function sxn(l3, r3, e3, u, h, v4, m3) {
    var x3 = lxn(l3, m3);
    uxn(x3, r3, e3, u, h, m3), DDe(x3, h, e3, u, m3);
    for (var C = 1; v4 > 0; v4--)
      C *= 0.99, cxn(x3, C, m3), DDe(x3, h, e3, u, m3), vxn(x3, C, m3), DDe(x3, h, e3, u, m3);
  }
  function lxn(l3, r3) {
    var e3 = [], u = r3 === "vertical" ? "y" : "x", h = j5e(l3, function(v4) {
      return v4.getLayout()[u];
    });
    return h.keys.sort(function(v4, m3) {
      return v4 - m3;
    }), mt(h.keys, function(v4) {
      e3.push(h.buckets.get(v4));
    }), e3;
  }
  function uxn(l3, r3, e3, u, h, v4) {
    var m3 = 1 / 0;
    mt(l3, function(x3) {
      var C = x3.length, A2 = 0;
      mt(x3, function(P) {
        A2 += P.getLayout().value;
      });
      var D = v4 === "vertical" ? (u - (C - 1) * h) / A2 : (e3 - (C - 1) * h) / A2;
      D < m3 && (m3 = D);
    }), mt(l3, function(x3) {
      mt(x3, function(C, A2) {
        var D = C.getLayout().value * m3;
        v4 === "vertical" ? (C.setLayout({ x: A2 }, true), C.setLayout({ dx: D }, true)) : (C.setLayout({ y: A2 }, true), C.setLayout({ dy: D }, true));
      });
    }), mt(r3, function(x3) {
      var C = +x3.getValue() * m3;
      x3.setLayout({ dy: C }, true);
    });
  }
  function DDe(l3, r3, e3, u, h) {
    var v4 = h === "vertical" ? "x" : "y";
    mt(l3, function(m3) {
      m3.sort(function(K, te) {
        return K.getLayout()[v4] - te.getLayout()[v4];
      });
      for (var x3, C, A2, D = 0, P = m3.length, N = h === "vertical" ? "dx" : "dy", j = 0; j < P; j++)
        C = m3[j], A2 = D - C.getLayout()[v4], A2 > 0 && (x3 = C.getLayout()[v4] + A2, h === "vertical" ? C.setLayout({ x: x3 }, true) : C.setLayout({ y: x3 }, true)), D = C.getLayout()[v4] + C.getLayout()[N] + r3;
      var W = h === "vertical" ? u : e3;
      if (A2 = D - r3 - W, A2 > 0) {
        x3 = C.getLayout()[v4] - A2, h === "vertical" ? C.setLayout({ x: x3 }, true) : C.setLayout({ y: x3 }, true), D = x3;
        for (var j = P - 2; j >= 0; --j)
          C = m3[j], A2 = C.getLayout()[v4] + C.getLayout()[N] + r3 - D, A2 > 0 && (x3 = C.getLayout()[v4] - A2, h === "vertical" ? C.setLayout({ x: x3 }, true) : C.setLayout({ y: x3 }, true)), D = C.getLayout()[v4];
      }
    });
  }
  function cxn(l3, r3, e3) {
    mt(l3.slice().reverse(), function(u) {
      mt(u, function(h) {
        if (h.outEdges.length) {
          var v4 = YO(h.outEdges, fxn, e3) / YO(h.outEdges, bhe);
          if (isNaN(v4)) {
            var m3 = h.outEdges.length;
            v4 = m3 ? YO(h.outEdges, hxn, e3) / m3 : 0;
          }
          if (e3 === "vertical") {
            var x3 = h.getLayout().x + (v4 - nP(h, e3)) * r3;
            h.setLayout({ x: x3 }, true);
          } else {
            var C = h.getLayout().y + (v4 - nP(h, e3)) * r3;
            h.setLayout({ y: C }, true);
          }
        }
      });
    });
  }
  function fxn(l3, r3) {
    return nP(l3.node2, r3) * l3.getValue();
  }
  function hxn(l3, r3) {
    return nP(l3.node2, r3);
  }
  function pxn(l3, r3) {
    return nP(l3.node1, r3) * l3.getValue();
  }
  function dxn(l3, r3) {
    return nP(l3.node1, r3);
  }
  function nP(l3, r3) {
    return r3 === "vertical" ? l3.getLayout().x + l3.getLayout().dx / 2 : l3.getLayout().y + l3.getLayout().dy / 2;
  }
  function bhe(l3) {
    return l3.getValue();
  }
  function YO(l3, r3, e3) {
    for (var u = 0, h = l3.length, v4 = -1; ++v4 < h; ) {
      var m3 = +r3(l3[v4], e3);
      isNaN(m3) || (u += m3);
    }
    return u;
  }
  function vxn(l3, r3, e3) {
    mt(l3, function(u) {
      mt(u, function(h) {
        if (h.inEdges.length) {
          var v4 = YO(h.inEdges, pxn, e3) / YO(h.inEdges, bhe);
          if (isNaN(v4)) {
            var m3 = h.inEdges.length;
            v4 = m3 ? YO(h.inEdges, dxn, e3) / m3 : 0;
          }
          if (e3 === "vertical") {
            var x3 = h.getLayout().x + (v4 - nP(h, e3)) * r3;
            h.setLayout({ x: x3 }, true);
          } else {
            var C = h.getLayout().y + (v4 - nP(h, e3)) * r3;
            h.setLayout({ y: C }, true);
          }
        }
      });
    });
  }
  function gxn(l3, r3) {
    var e3 = r3 === "vertical" ? "x" : "y";
    mt(l3, function(u) {
      u.outEdges.sort(function(h, v4) {
        return h.node2.getLayout()[e3] - v4.node2.getLayout()[e3];
      }), u.inEdges.sort(function(h, v4) {
        return h.node1.getLayout()[e3] - v4.node1.getLayout()[e3];
      });
    }), mt(l3, function(u) {
      var h = 0, v4 = 0;
      mt(u.outEdges, function(m3) {
        m3.setLayout({ sy: h }, true), h += m3.getLayout().dy;
      }), mt(u.inEdges, function(m3) {
        m3.setLayout({ ty: v4 }, true), v4 += m3.getLayout().dy;
      });
    });
  }
  function yxn(l3) {
    l3.eachSeriesByType("sankey", function(r3) {
      var e3 = r3.getGraph(), u = e3.nodes;
      if (u.length) {
        var h = 1 / 0, v4 = -1 / 0;
        mt(u, function(m3) {
          var x3 = m3.getLayout().value;
          x3 < h && (h = x3), x3 > v4 && (v4 = x3);
        }), mt(u, function(m3) {
          var x3 = new om({ type: "color", mappingMethod: "linear", dataExtent: [h, v4], visual: r3.get("color") }), C = x3.mapValueToVisual(m3.getLayout().value), A2 = m3.getModel().get(["itemStyle", "color"]);
          A2 != null ? (m3.setVisual("color", A2), m3.setVisual("style", { fill: A2 })) : (m3.setVisual("color", C), m3.setVisual("style", { fill: C }));
        });
      }
    });
  }
  function mxn(l3) {
    l3.registerChartView(K_n), l3.registerSeriesModel(J_n), l3.registerLayout(Q_n), l3.registerVisual(yxn), l3.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(r3, e3) {
      e3.eachComponent({ mainType: "series", subType: "sankey", query: r3 }, function(u) {
        u.setNodePosition(r3.dataIndex, [r3.localX, r3.localY]);
      });
    });
  }
  var mdt = function() {
    function l3() {
    }
    return l3.prototype.getInitialData = function(r3, e3) {
      var u, h = e3.getComponent("xAxis", this.get("xAxisIndex")), v4 = e3.getComponent("yAxis", this.get("yAxisIndex")), m3 = h.get("type"), x3 = v4.get("type"), C;
      m3 === "category" ? (r3.layout = "horizontal", u = h.getOrdinalMeta(), C = true) : x3 === "category" ? (r3.layout = "vertical", u = v4.getOrdinalMeta(), C = true) : r3.layout = r3.layout || "horizontal";
      var A2 = ["x", "y"], D = r3.layout === "horizontal" ? 0 : 1, P = this._baseAxisDim = A2[D], N = A2[1 - D], j = [h, v4], W = j[D].get("type"), K = j[1 - D].get("type"), te = r3.data;
      if (te && C) {
        var ne = [];
        mt(te, function(ve, Be) {
          var Oe;
          Ni(ve) ? (Oe = ve.slice(), ve.unshift(Be)) : Ni(ve.value) ? (Oe = fi({}, ve), Oe.value = Oe.value.slice(), ve.value.unshift(Be)) : Oe = ve, ne.push(Oe);
        }), r3.data = ne;
      }
      var ce = this.defaultValueDimensions, me = [{ name: P, type: she(W), ordinalMeta: u, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: N, type: she(K), dimsDef: ce.slice() }];
      return Lj(this, { coordDimensions: me, dimensionsCount: ce.length + 1, encodeDefaulter: Fs(Wct, me, this) });
    }, l3.prototype.getBaseAxis = function() {
      var r3 = this._baseAxisDim;
      return this.ecModel.getComponent(r3 + "Axis", this.get(r3 + "AxisIndex")).axis;
    }, l3;
  }(), bdt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], e3.visualDrawType = "stroke", e3;
    }
    return r3.type = "series.boxplot", r3.dependencies = ["xAxis", "yAxis", "grid"], r3.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, r3;
  }(Fp);
  Fv(bdt, mdt, true);
  var bxn = bdt, _xn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this.group, x3 = this._data;
      this._data || m3.removeAll();
      var C = e3.get("layout") === "horizontal" ? 1 : 0;
      v4.diff(x3).add(function(A2) {
        if (v4.hasValue(A2)) {
          var D = v4.getItemLayout(A2), P = Lat(D, v4, A2, C, true);
          v4.setItemGraphicEl(A2, P), m3.add(P);
        }
      }).update(function(A2, D) {
        var P = x3.getItemGraphicEl(D);
        if (!v4.hasValue(A2)) {
          m3.remove(P);
          return;
        }
        var N = v4.getItemLayout(A2);
        P ? (yM(P), _dt(N, P, v4, A2)) : P = Lat(N, v4, A2, C), m3.add(P), v4.setItemGraphicEl(A2, P);
      }).remove(function(A2) {
        var D = x3.getItemGraphicEl(A2);
        D && m3.remove(D);
      }).execute(), this._data = v4;
    }, r3.prototype.remove = function(e3) {
      var u = this.group, h = this._data;
      this._data = null, h && h.eachItemGraphicEl(function(v4) {
        v4 && u.remove(v4);
      });
    }, r3.type = "boxplot", r3;
  }(zh), xxn = function() {
    function l3() {
    }
    return l3;
  }(), wxn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "boxplotBoxPath", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new xxn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.points, v4 = 0;
      for (e3.moveTo(h[v4][0], h[v4][1]), v4++; v4 < 4; v4++)
        e3.lineTo(h[v4][0], h[v4][1]);
      for (e3.closePath(); v4 < h.length; v4++)
        e3.moveTo(h[v4][0], h[v4][1]), v4++, e3.lineTo(h[v4][0], h[v4][1]);
    }, r3;
  }(Nl);
  function Lat(l3, r3, e3, u, h) {
    var v4 = l3.ends, m3 = new wxn({ shape: { points: h ? Sxn(v4, u, l3) : v4 } });
    return _dt(l3, m3, r3, e3, h), m3;
  }
  function _dt(l3, r3, e3, u, h) {
    var v4 = e3.hostModel, m3 = NJ[h ? "initProps" : "updateProps"];
    m3(r3, { shape: { points: l3.ends } }, v4, u), r3.useStyle(e3.getItemVisual(u, "style")), r3.style.strokeNoScale = true, r3.z2 = 100;
    var x3 = e3.getItemModel(u), C = x3.getModel("emphasis");
    sm(r3, x3), Gd(r3, C.get("focus"), C.get("blurScope"), C.get("disabled"));
  }
  function Sxn(l3, r3, e3) {
    return Bi(l3, function(u) {
      return u = u.slice(), u[r3] = e3.initBaseline, u;
    });
  }
  var Cxn = _xn;
  function Mxn(l3, r3) {
  }
  var qZ = mt;
  function Txn(l3) {
    var r3 = Axn(l3);
    qZ(r3, function(e3) {
      var u = e3.seriesModels;
      !u.length || (Ixn(e3), qZ(u, function(h, v4) {
        Exn(h, e3.boxOffsetList[v4], e3.boxWidthList[v4]);
      }));
    });
  }
  function Axn(l3) {
    var r3 = [], e3 = [];
    return l3.eachSeriesByType("boxplot", function(u) {
      var h = u.getBaseAxis(), v4 = Cl(e3, h);
      v4 < 0 && (v4 = e3.length, e3[v4] = h, r3[v4] = { axis: h, seriesModels: [] }), r3[v4].seriesModels.push(u);
    }), r3;
  }
  function Ixn(l3) {
    var r3 = l3.axis, e3 = l3.seriesModels, u = e3.length, h = l3.boxWidthList = [], v4 = l3.boxOffsetList = [], m3 = [], x3;
    if (r3.type === "category")
      x3 = r3.getBandWidth();
    else {
      var C = 0;
      qZ(e3, function(W) {
        C = Math.max(C, W.getData().count());
      });
      var A2 = r3.getExtent();
      x3 = Math.abs(A2[1] - A2[0]) / C;
    }
    qZ(e3, function(W) {
      var K = W.get("boxWidth");
      Ni(K) || (K = [K, K]), m3.push([za(K[0], x3) || 0, za(K[1], x3) || 0]);
    });
    var D = x3 * 0.8 - 2, P = D / u * 0.3, N = (D - P * (u - 1)) / u, j = N / 2 - D / 2;
    qZ(e3, function(W, K) {
      v4.push(j), j += P + N, h.push(Math.min(Math.max(N, m3[K][0]), m3[K][1]));
    });
  }
  function Exn(l3, r3, e3) {
    var u = l3.coordinateSystem, h = l3.getData(), v4 = e3 / 2, m3 = l3.get("layout") === "horizontal" ? 0 : 1, x3 = 1 - m3, C = ["x", "y"], A2 = h.mapDimension(C[m3]), D = h.mapDimensionsAll(C[x3]);
    if (A2 == null || D.length < 5)
      return;
    for (var P = 0; P < h.count(); P++) {
      var N = h.get(A2, P), j = me(N, D[2], P), W = me(N, D[0], P), K = me(N, D[1], P), te = me(N, D[3], P), ne = me(N, D[4], P), ce = [];
      ve(ce, K, false), ve(ce, te, true), ce.push(W, K, ne, te), Be(ce, W), Be(ce, ne), Be(ce, j), h.setItemLayout(P, { initBaseline: j[x3], ends: ce });
    }
    function me(Oe, We, Ue) {
      var qe = h.get(We, Ue), Ze = [];
      Ze[m3] = Oe, Ze[x3] = qe;
      var ct;
      return isNaN(Oe) || isNaN(qe) ? ct = [NaN, NaN] : (ct = u.dataToPoint(Ze), ct[m3] += r3), ct;
    }
    function ve(Oe, We, Ue) {
      var qe = We.slice(), Ze = We.slice();
      qe[m3] += v4, Ze[m3] -= v4, Ue ? Oe.push(qe, Ze) : Oe.push(Ze, qe);
    }
    function Be(Oe, We) {
      var Ue = We.slice(), qe = We.slice();
      Ue[m3] -= v4, qe[m3] += v4, Oe.push(Ue, qe);
    }
  }
  function Dxn(l3, r3) {
    r3 = r3 || {};
    for (var e3 = [], u = [], h = r3.boundIQR, v4 = h === "none" || h === 0, m3 = 0; m3 < l3.length; m3++) {
      var x3 = g2(l3[m3].slice()), C = aEe(x3, 0.25), A2 = aEe(x3, 0.5), D = aEe(x3, 0.75), P = x3[0], N = x3[x3.length - 1], j = (h == null ? 1.5 : h) * (D - C), W = v4 ? P : Math.max(P, C - j), K = v4 ? N : Math.min(N, D + j), te = r3.itemNameFormatter, ne = Xo(te) ? te({ value: m3 }) : qa(te) ? te.replace("{value}", m3 + "") : m3 + "";
      e3.push([ne, W, C, A2, D, K]);
      for (var ce = 0; ce < x3.length; ce++) {
        var me = x3[ce];
        if (me < W || me > K) {
          var ve = [ne, me];
          u.push(ve);
        }
      }
    }
    return { boxData: e3, outliers: u };
  }
  var kxn = { type: "echarts:boxplot", transform: function(r3) {
    var e3 = r3.upstream;
    if (e3.sourceFormat !== b1) {
      var u = "";
      Xc(u);
    }
    var h = Dxn(e3.getRawData(), r3.config);
    return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: h.boxData }, { data: h.outliers }];
  } };
  function Oxn(l3) {
    l3.registerSeriesModel(bxn), l3.registerChartView(Cxn), l3.registerVisual(Mxn), l3.registerLayout(Txn), l3.registerTransform(kxn);
  }
  var Pxn = ["color", "borderColor"], Lxn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(e3), this._isLargeDraw ? this._renderLarge(e3) : this._renderNormal(e3);
    }, r3.prototype.incrementalPrepareRender = function(e3, u, h) {
      this._clear(), this._updateDrawMode(e3);
    }, r3.prototype.incrementalRender = function(e3, u, h, v4) {
      this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(e3, u) : this._incrementalRenderNormal(e3, u);
    }, r3.prototype.eachRendered = function(e3) {
      oP(this._progressiveEls || this.group, e3);
    }, r3.prototype._updateDrawMode = function(e3) {
      var u = e3.pipelineContext.large;
      (this._isLargeDraw == null || u !== this._isLargeDraw) && (this._isLargeDraw = u, this._clear());
    }, r3.prototype._renderNormal = function(e3) {
      var u = e3.getData(), h = this._data, v4 = this.group, m3 = u.getLayout("isSimpleBox"), x3 = e3.get("clip", true), C = e3.coordinateSystem, A2 = C.getArea && C.getArea();
      this._data || v4.removeAll(), u.diff(h).add(function(D) {
        if (u.hasValue(D)) {
          var P = u.getItemLayout(D);
          if (x3 && Rat(A2, P))
            return;
          var N = kDe(P, D, true);
          Np(N, { shape: { points: P.ends } }, e3, D), ODe(N, u, D, m3), v4.add(N), u.setItemGraphicEl(D, N);
        }
      }).update(function(D, P) {
        var N = h.getItemGraphicEl(P);
        if (!u.hasValue(D)) {
          v4.remove(N);
          return;
        }
        var j = u.getItemLayout(D);
        if (x3 && Rat(A2, j)) {
          v4.remove(N);
          return;
        }
        N ? (hc(N, { shape: { points: j.ends } }, e3, D), yM(N)) : N = kDe(j), ODe(N, u, D, m3), v4.add(N), u.setItemGraphicEl(D, N);
      }).remove(function(D) {
        var P = h.getItemGraphicEl(D);
        P && v4.remove(P);
      }).execute(), this._data = u;
    }, r3.prototype._renderLarge = function(e3) {
      this._clear(), Fat(e3, this.group);
      var u = e3.get("clip", true) ? vpe(e3.coordinateSystem, false, e3) : null;
      u ? this.group.setClipPath(u) : this.group.removeClipPath();
    }, r3.prototype._incrementalRenderNormal = function(e3, u) {
      for (var h = u.getData(), v4 = h.getLayout("isSimpleBox"), m3; (m3 = e3.next()) != null; ) {
        var x3 = h.getItemLayout(m3), C = kDe(x3);
        ODe(C, h, m3, v4), C.incremental = true, this.group.add(C), this._progressiveEls.push(C);
      }
    }, r3.prototype._incrementalRenderLarge = function(e3, u) {
      Fat(u, this.group, this._progressiveEls, true);
    }, r3.prototype.remove = function(e3) {
      this._clear();
    }, r3.prototype._clear = function() {
      this.group.removeAll(), this._data = null;
    }, r3.type = "candlestick", r3;
  }(zh), Rxn = function() {
    function l3() {
    }
    return l3;
  }(), Nxn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "normalCandlestickBox", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new Rxn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.points;
      this.__simpleBox ? (e3.moveTo(h[4][0], h[4][1]), e3.lineTo(h[6][0], h[6][1])) : (e3.moveTo(h[0][0], h[0][1]), e3.lineTo(h[1][0], h[1][1]), e3.lineTo(h[2][0], h[2][1]), e3.lineTo(h[3][0], h[3][1]), e3.closePath(), e3.moveTo(h[4][0], h[4][1]), e3.lineTo(h[5][0], h[5][1]), e3.moveTo(h[6][0], h[6][1]), e3.lineTo(h[7][0], h[7][1]));
    }, r3;
  }(Nl);
  function kDe(l3, r3, e3) {
    var u = l3.ends;
    return new Nxn({ shape: { points: e3 ? Fxn(u, l3) : u }, z2: 100 });
  }
  function Rat(l3, r3) {
    for (var e3 = true, u = 0; u < r3.ends.length; u++)
      if (l3.contain(r3.ends[u][0], r3.ends[u][1])) {
        e3 = false;
        break;
      }
    return e3;
  }
  function ODe(l3, r3, e3, u) {
    var h = r3.getItemModel(e3);
    l3.useStyle(r3.getItemVisual(e3, "style")), l3.style.strokeNoScale = true, l3.__simpleBox = u, sm(l3, h);
  }
  function Fxn(l3, r3) {
    return Bi(l3, function(e3) {
      return e3 = e3.slice(), e3[1] = r3.initBaseline, e3;
    });
  }
  var Vxn = function() {
    function l3() {
    }
    return l3;
  }(), Nat = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u.type = "largeCandlestickBox", u;
    }
    return r3.prototype.getDefaultShape = function() {
      return new Vxn();
    }, r3.prototype.buildPath = function(e3, u) {
      for (var h = u.points, v4 = 0; v4 < h.length; )
        if (this.__sign === h[v4++]) {
          var m3 = h[v4++];
          e3.moveTo(m3, h[v4++]), e3.lineTo(m3, h[v4++]);
        } else
          v4 += 3;
    }, r3;
  }(Nl);
  function Fat(l3, r3, e3, u) {
    var h = l3.getData(), v4 = h.getLayout("largePoints"), m3 = new Nat({ shape: { points: v4 }, __sign: 1 });
    r3.add(m3);
    var x3 = new Nat({ shape: { points: v4 }, __sign: -1 });
    r3.add(x3), Vat(1, m3, l3), Vat(-1, x3, l3), u && (m3.incremental = true, x3.incremental = true), e3 && e3.push(m3, x3);
  }
  function Vat(l3, r3, e3, u) {
    var h = e3.get(["itemStyle", l3 > 0 ? "borderColor" : "borderColor0"]) || e3.get(["itemStyle", l3 > 0 ? "color" : "color0"]), v4 = e3.getModel("itemStyle").getItemStyle(Pxn);
    r3.useStyle(v4), r3.style.fill = null, r3.style.stroke = h;
  }
  var Bxn = Lxn, xdt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], e3;
    }
    return r3.prototype.getShadowDim = function() {
      return "open";
    }, r3.prototype.brushSelector = function(e3, u, h) {
      var v4 = u.getItemLayout(e3);
      return v4 && h.rect(v4.brushRect);
    }, r3.type = "series.candlestick", r3.dependencies = ["xAxis", "yAxis", "grid"], r3.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, r3;
  }(Fp);
  Fv(xdt, mdt, true);
  var zxn = xdt;
  function jxn(l3) {
    !l3 || !Ni(l3.series) || mt(l3.series, function(r3) {
      ls(r3) && r3.type === "k" && (r3.type = "candlestick");
    });
  }
  var Gxn = ["itemStyle", "borderColor"], Hxn = ["itemStyle", "borderColor0"], Wxn = ["itemStyle", "color"], Uxn = ["itemStyle", "color0"], qxn = { seriesType: "candlestick", plan: kj(), performRawSeries: true, reset: function(l3, r3) {
    function e3(v4, m3) {
      return m3.get(v4 > 0 ? Wxn : Uxn);
    }
    function u(v4, m3) {
      return m3.get(v4 > 0 ? Gxn : Hxn);
    }
    if (!r3.isSeriesFiltered(l3)) {
      var h = l3.pipelineContext.large;
      return !h && { progress: function(v4, m3) {
        for (var x3; (x3 = v4.next()) != null; ) {
          var C = m3.getItemModel(x3), A2 = m3.getItemLayout(x3).sign, D = C.getItemStyle();
          D.fill = e3(A2, C), D.stroke = u(A2, C) || D.fill;
          var P = m3.ensureUniqueItemVisual(x3, "style");
          fi(P, D);
        }
      } };
    }
  } }, $xn = qxn, Xxn = { seriesType: "candlestick", plan: kj(), reset: function(l3) {
    var r3 = l3.coordinateSystem, e3 = l3.getData(), u = Yxn(l3, e3), h = 0, v4 = 1, m3 = ["x", "y"], x3 = e3.getDimensionIndex(e3.mapDimension(m3[h])), C = Bi(e3.mapDimensionsAll(m3[v4]), e3.getDimensionIndex, e3), A2 = C[0], D = C[1], P = C[2], N = C[3];
    if (e3.setLayout({ candleWidth: u, isSimpleBox: u <= 1.3 }), x3 < 0 || C.length < 4)
      return;
    return { progress: l3.pipelineContext.large ? W : j };
    function j(K, te) {
      for (var ne, ce = te.getStore(); (ne = K.next()) != null; ) {
        var me = ce.get(x3, ne), ve = ce.get(A2, ne), Be = ce.get(D, ne), Oe = ce.get(P, ne), We = ce.get(N, ne), Ue = Math.min(ve, Be), qe = Math.max(ve, Be), Ze = Zt(Ue, me), ct = Zt(qe, me), _t = Zt(Oe, me), pt = Zt(We, me), zt = [];
        Ft(zt, ct, 0), Ft(zt, Ze, 1), zt.push(hn(pt), hn(ct), hn(_t), hn(Ze)), te.setItemLayout(ne, { sign: Bat(ce, ne, ve, Be, D), initBaseline: ve > Be ? ct[v4] : Ze[v4], ends: zt, brushRect: Kn(Oe, We, me) });
      }
      function Zt(xn, zn) {
        var or = [];
        return or[h] = zn, or[v4] = xn, isNaN(zn) || isNaN(xn) ? [NaN, NaN] : r3.dataToPoint(or);
      }
      function Ft(xn, zn, or) {
        var vr = zn.slice(), la = zn.slice();
        vr[h] = Mfe(vr[h] + u / 2, 1, false), la[h] = Mfe(la[h] - u / 2, 1, true), or ? xn.push(vr, la) : xn.push(la, vr);
      }
      function Kn(xn, zn, or) {
        var vr = Zt(xn, or), la = Zt(zn, or);
        return vr[h] -= u / 2, la[h] -= u / 2, { x: vr[0], y: vr[1], width: u, height: la[1] - vr[1] };
      }
      function hn(xn) {
        return xn[h] = Mfe(xn[h], 1), xn;
      }
    }
    function W(K, te) {
      for (var ne = VA(K.count * 4), ce = 0, me, ve = [], Be = [], Oe, We = te.getStore(); (Oe = K.next()) != null; ) {
        var Ue = We.get(x3, Oe), qe = We.get(A2, Oe), Ze = We.get(D, Oe), ct = We.get(P, Oe), _t = We.get(N, Oe);
        if (isNaN(Ue) || isNaN(ct) || isNaN(_t)) {
          ne[ce++] = NaN, ce += 3;
          continue;
        }
        ne[ce++] = Bat(We, Oe, qe, Ze, D), ve[h] = Ue, ve[v4] = ct, me = r3.dataToPoint(ve, null, Be), ne[ce++] = me ? me[0] : NaN, ne[ce++] = me ? me[1] : NaN, ve[v4] = _t, me = r3.dataToPoint(ve, null, Be), ne[ce++] = me ? me[1] : NaN;
      }
      te.setLayout("largePoints", ne);
    }
  } };
  function Bat(l3, r3, e3, u, h) {
    var v4;
    return e3 > u ? v4 = -1 : e3 < u ? v4 = 1 : v4 = r3 > 0 ? l3.get(h, r3 - 1) <= u ? 1 : -1 : 1, v4;
  }
  function Yxn(l3, r3) {
    var e3 = l3.getBaseAxis(), u, h = e3.type === "category" ? e3.getBandWidth() : (u = e3.getExtent(), Math.abs(u[1] - u[0]) / r3.count()), v4 = za(dl(l3.get("barMaxWidth"), h), h), m3 = za(dl(l3.get("barMinWidth"), 1), h), x3 = l3.get("barWidth");
    return x3 != null ? za(x3, h) : Math.max(Math.min(h / 2, v4), m3);
  }
  var Kxn = Xxn;
  function Zxn(l3) {
    l3.registerChartView(Bxn), l3.registerSeriesModel(zxn), l3.registerPreprocessor(jxn), l3.registerVisual($xn), l3.registerLayout(Kxn);
  }
  function zat(l3, r3) {
    var e3 = r3.rippleEffectColor || r3.color;
    l3.eachChild(function(u) {
      u.attr({ z: r3.z, zlevel: r3.zlevel, style: { stroke: r3.brushType === "stroke" ? e3 : null, fill: r3.brushType === "fill" ? e3 : null } });
    });
  }
  var Jxn = function(l3) {
    ar(r3, l3);
    function r3(e3, u) {
      var h = l3.call(this) || this, v4 = new HJ(e3, u), m3 = new Cs();
      return h.add(v4), h.add(m3), h.updateData(e3, u), h;
    }
    return r3.prototype.stopEffectAnimation = function() {
      this.childAt(1).removeAll();
    }, r3.prototype.startEffectAnimation = function(e3) {
      for (var u = e3.symbolType, h = e3.color, v4 = e3.rippleNumber, m3 = this.childAt(1), x3 = 0; x3 < v4; x3++) {
        var C = Nv(u, -1, -1, 2, 2, h);
        C.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
        var A2 = -x3 / v4 * e3.period + e3.effectOffset;
        C.animate("", true).when(e3.period, { scaleX: e3.rippleScale / 2, scaleY: e3.rippleScale / 2 }).delay(A2).start(), C.animateStyle(true).when(e3.period, { opacity: 0 }).delay(A2).start(), m3.add(C);
      }
      zat(m3, e3);
    }, r3.prototype.updateEffectAnimation = function(e3) {
      for (var u = this._effectCfg, h = this.childAt(1), v4 = ["symbolType", "period", "rippleScale", "rippleNumber"], m3 = 0; m3 < v4.length; m3++) {
        var x3 = v4[m3];
        if (u[x3] !== e3[x3]) {
          this.stopEffectAnimation(), this.startEffectAnimation(e3);
          return;
        }
      }
      zat(h, e3);
    }, r3.prototype.highlight = function() {
      zA(this);
    }, r3.prototype.downplay = function() {
      jA(this);
    }, r3.prototype.getSymbolType = function() {
      var e3 = this.childAt(0);
      return e3 && e3.getSymbolType();
    }, r3.prototype.updateData = function(e3, u) {
      var h = this, v4 = e3.hostModel;
      this.childAt(0).updateData(e3, u);
      var m3 = this.childAt(1), x3 = e3.getItemModel(u), C = e3.getItemVisual(u, "symbol"), A2 = BJ(e3.getItemVisual(u, "symbolSize")), D = e3.getItemVisual(u, "style"), P = D && D.fill, N = x3.getModel("emphasis");
      m3.setScale(A2), m3.traverse(function(te) {
        te.setStyle("fill", P);
      });
      var j = Pj(e3.getItemVisual(u, "symbolOffset"), A2);
      j && (m3.x = j[0], m3.y = j[1]);
      var W = e3.getItemVisual(u, "symbolRotate");
      m3.rotation = (W || 0) * Math.PI / 180 || 0;
      var K = {};
      K.showEffectOn = v4.get("showEffectOn"), K.rippleScale = x3.get(["rippleEffect", "scale"]), K.brushType = x3.get(["rippleEffect", "brushType"]), K.period = x3.get(["rippleEffect", "period"]) * 1e3, K.effectOffset = u / e3.count(), K.z = v4.getShallow("z") || 0, K.zlevel = v4.getShallow("zlevel") || 0, K.symbolType = C, K.color = P, K.rippleEffectColor = x3.get(["rippleEffect", "color"]), K.rippleNumber = x3.get(["rippleEffect", "number"]), K.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(K) : this.startEffectAnimation(K), this._effectCfg = K) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(te) {
        te === "emphasis" ? K.showEffectOn !== "render" && h.startEffectAnimation(K) : te === "normal" && K.showEffectOn !== "render" && h.stopEffectAnimation();
      }), this._effectCfg = K, Gd(this, N.get("focus"), N.get("blurScope"), N.get("disabled"));
    }, r3.prototype.fadeOut = function(e3) {
      e3 && e3();
    }, r3;
  }(Cs), Qxn = Jxn, ewn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function() {
      this._symbolDraw = new WJ(Qxn);
    }, r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this._symbolDraw;
      m3.updateData(v4, { clipShape: this._getClipShape(e3) }), this.group.add(m3.group);
    }, r3.prototype._getClipShape = function(e3) {
      var u = e3.coordinateSystem, h = u && u.getArea && u.getArea();
      return e3.get("clip", true) ? h : null;
    }, r3.prototype.updateTransform = function(e3, u, h) {
      var v4 = e3.getData();
      this.group.dirty();
      var m3 = UJ("").reset(e3, u, h);
      m3.progress && m3.progress({ start: 0, end: v4.count(), count: v4.count() }, v4), this._symbolDraw.updateLayout();
    }, r3.prototype._updateGroupTransform = function(e3) {
      var u = e3.coordinateSystem;
      u && u.getRoamTransform && (this.group.transform = yln(u.getRoamTransform()), this.group.decomposeTransform());
    }, r3.prototype.remove = function(e3, u) {
      this._symbolDraw && this._symbolDraw.remove(true);
    }, r3.type = "effectScatter", r3;
  }(zh), twn = ewn, nwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.hasSymbolVisual = true, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      return v5(null, this, { useEncodeDefaulter: true });
    }, r3.prototype.brushSelector = function(e3, u, h) {
      return h.point(u.getItemLayout(e3));
    }, r3.type = "series.effectScatter", r3.dependencies = ["grid", "polar"], r3.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, r3;
  }(Fp), rwn = nwn;
  function iwn(l3) {
    l3.registerChartView(twn), l3.registerSeriesModel(rwn), l3.registerLayout(UJ("effectScatter"));
  }
  var awn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this) || this;
      return v4.add(v4.createLine(e3, u, h)), v4._updateEffectSymbol(e3, u), v4;
    }
    return r3.prototype.createLine = function(e3, u, h) {
      return new UOe(e3, u, h);
    }, r3.prototype._updateEffectSymbol = function(e3, u) {
      var h = e3.getItemModel(u), v4 = h.getModel("effect"), m3 = v4.get("symbolSize"), x3 = v4.get("symbol");
      Ni(m3) || (m3 = [m3, m3]);
      var C = e3.getItemVisual(u, "style"), A2 = v4.get("color") || C && C.stroke, D = this.childAt(1);
      this._symbolType !== x3 && (this.remove(D), D = Nv(x3, -0.5, -0.5, 1, 1, A2), D.z2 = 100, D.culling = true, this.add(D)), D && (D.setStyle("shadowColor", A2), D.setStyle(v4.getItemStyle(["color"])), D.scaleX = m3[0], D.scaleY = m3[1], D.setColor(A2), this._symbolType = x3, this._symbolScale = m3, this._updateEffectAnimation(e3, v4, u));
    }, r3.prototype._updateEffectAnimation = function(e3, u, h) {
      var v4 = this.childAt(1);
      if (!!v4) {
        var m3 = e3.getItemLayout(h), x3 = u.get("period") * 1e3, C = u.get("loop"), A2 = u.get("constantSpeed"), D = ey(u.get("delay"), function(N) {
          return N / e3.count() * x3 / 3;
        });
        if (v4.ignore = true, this._updateAnimationPoints(v4, m3), A2 > 0 && (x3 = this._getLineLength(v4) / A2 * 1e3), x3 !== this._period || C !== this._loop) {
          v4.stopAnimation();
          var P = void 0;
          Xo(D) ? P = D(h) : P = D, v4.__t > 0 && (P = -x3 * v4.__t), this._animateSymbol(v4, x3, P, C);
        }
        this._period = x3, this._loop = C;
      }
    }, r3.prototype._animateSymbol = function(e3, u, h, v4) {
      if (u > 0) {
        e3.__t = 0;
        var m3 = this, x3 = e3.animate("", v4).when(u, { __t: 1 }).delay(h).during(function() {
          m3._updateSymbolPosition(e3);
        });
        v4 || x3.done(function() {
          m3.remove(e3);
        }), x3.start();
      }
    }, r3.prototype._getLineLength = function(e3) {
      return RO(e3.__p1, e3.__cp1) + RO(e3.__cp1, e3.__p2);
    }, r3.prototype._updateAnimationPoints = function(e3, u) {
      e3.__p1 = u[0], e3.__p2 = u[1], e3.__cp1 = u[2] || [(u[0][0] + u[1][0]) / 2, (u[0][1] + u[1][1]) / 2];
    }, r3.prototype.updateData = function(e3, u, h) {
      this.childAt(0).updateData(e3, u, h), this._updateEffectSymbol(e3, u);
    }, r3.prototype._updateSymbolPosition = function(e3) {
      var u = e3.__p1, h = e3.__p2, v4 = e3.__cp1, m3 = e3.__t, x3 = [e3.x, e3.y], C = x3.slice(), A2 = Q0, D = I5e;
      x3[0] = A2(u[0], v4[0], h[0], m3), x3[1] = A2(u[1], v4[1], h[1], m3);
      var P = D(u[0], v4[0], h[0], m3), N = D(u[1], v4[1], h[1], m3);
      e3.rotation = -Math.atan2(N, P) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (e3.__lastT !== void 0 && e3.__lastT < e3.__t ? (e3.scaleY = RO(C, x3) * 1.05, m3 === 1 && (x3[0] = C[0] + (x3[0] - C[0]) / 2, x3[1] = C[1] + (x3[1] - C[1]) / 2)) : e3.__lastT === 1 ? e3.scaleY = 2 * RO(u, x3) : e3.scaleY = this._symbolScale[1]), e3.__lastT = e3.__t, e3.ignore = false, e3.x = x3[0], e3.y = x3[1];
    }, r3.prototype.updateLayout = function(e3, u) {
      this.childAt(0).updateLayout(e3, u);
      var h = e3.getItemModel(u).getModel("effect");
      this._updateEffectAnimation(e3, h, u);
    }, r3;
  }(Cs), wdt = awn, own = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h) {
      var v4 = l3.call(this) || this;
      return v4._createPolyline(e3, u, h), v4;
    }
    return r3.prototype._createPolyline = function(e3, u, h) {
      var v4 = e3.getItemLayout(u), m3 = new M_({ shape: { points: v4 } });
      this.add(m3), this._updateCommonStl(e3, u, h);
    }, r3.prototype.updateData = function(e3, u, h) {
      var v4 = e3.hostModel, m3 = this.childAt(0), x3 = { shape: { points: e3.getItemLayout(u) } };
      hc(m3, x3, v4, u), this._updateCommonStl(e3, u, h);
    }, r3.prototype._updateCommonStl = function(e3, u, h) {
      var v4 = this.childAt(0), m3 = e3.getItemModel(u), x3 = h && h.emphasisLineStyle, C = h && h.focus, A2 = h && h.blurScope, D = h && h.emphasisDisabled;
      if (!h || e3.hasItemOption) {
        var P = m3.getModel("emphasis");
        x3 = P.getModel("lineStyle").getLineStyle(), D = P.get("disabled"), C = P.get("focus"), A2 = P.get("blurScope");
      }
      v4.useStyle(e3.getItemVisual(u, "style")), v4.style.fill = null, v4.style.strokeNoScale = true;
      var N = v4.ensureState("emphasis");
      N.style = x3, Gd(this, C, A2, D);
    }, r3.prototype.updateLayout = function(e3, u) {
      var h = this.childAt(0);
      h.setShape("points", e3.getItemLayout(u));
    }, r3;
  }(Cs), Sdt = own, swn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3._lastFrame = 0, e3._lastFramePercent = 0, e3;
    }
    return r3.prototype.createLine = function(e3, u, h) {
      return new Sdt(e3, u, h);
    }, r3.prototype._updateAnimationPoints = function(e3, u) {
      this._points = u;
      for (var h = [0], v4 = 0, m3 = 1; m3 < u.length; m3++) {
        var x3 = u[m3 - 1], C = u[m3];
        v4 += RO(x3, C), h.push(v4);
      }
      if (v4 === 0) {
        this._length = 0;
        return;
      }
      for (var m3 = 0; m3 < h.length; m3++)
        h[m3] /= v4;
      this._offsets = h, this._length = v4;
    }, r3.prototype._getLineLength = function() {
      return this._length;
    }, r3.prototype._updateSymbolPosition = function(e3) {
      var u = e3.__t, h = this._points, v4 = this._offsets, m3 = h.length;
      if (!!v4) {
        var x3 = this._lastFrame, C;
        if (u < this._lastFramePercent) {
          var A2 = Math.min(x3 + 1, m3 - 1);
          for (C = A2; C >= 0 && !(v4[C] <= u); C--)
            ;
          C = Math.min(C, m3 - 2);
        } else {
          for (C = x3; C < m3 && !(v4[C] > u); C++)
            ;
          C = Math.min(C - 1, m3 - 2);
        }
        var D = (u - v4[C]) / (v4[C + 1] - v4[C]), P = h[C], N = h[C + 1];
        e3.x = P[0] * (1 - D) + D * N[0], e3.y = P[1] * (1 - D) + D * N[1];
        var j = N[0] - P[0], W = N[1] - P[1];
        e3.rotation = -Math.atan2(W, j) - Math.PI / 2, this._lastFrame = C, this._lastFramePercent = u, e3.ignore = false;
      }
    }, r3;
  }(wdt), lwn = swn, uwn = function() {
    function l3() {
      this.polyline = false, this.curveness = 0, this.segs = [];
    }
    return l3;
  }(), cwn = function(l3) {
    ar(r3, l3);
    function r3(e3) {
      var u = l3.call(this, e3) || this;
      return u._off = 0, u.hoverDataIdx = -1, u;
    }
    return r3.prototype.reset = function() {
      this.notClear = false, this._off = 0;
    }, r3.prototype.getDefaultStyle = function() {
      return { stroke: "#000", fill: null };
    }, r3.prototype.getDefaultShape = function() {
      return new uwn();
    }, r3.prototype.buildPath = function(e3, u) {
      var h = u.segs, v4 = u.curveness, m3;
      if (u.polyline)
        for (m3 = this._off; m3 < h.length; ) {
          var x3 = h[m3++];
          if (x3 > 0) {
            e3.moveTo(h[m3++], h[m3++]);
            for (var C = 1; C < x3; C++)
              e3.lineTo(h[m3++], h[m3++]);
          }
        }
      else
        for (m3 = this._off; m3 < h.length; ) {
          var A2 = h[m3++], D = h[m3++], P = h[m3++], N = h[m3++];
          if (e3.moveTo(A2, D), v4 > 0) {
            var j = (A2 + P) / 2 - (D - N) * v4, W = (D + N) / 2 - (P - A2) * v4;
            e3.quadraticCurveTo(j, W, P, N);
          } else
            e3.lineTo(P, N);
        }
      this.incremental && (this._off = m3, this.notClear = true);
    }, r3.prototype.findDataIndex = function(e3, u) {
      var h = this.shape, v4 = h.segs, m3 = h.curveness, x3 = this.style.lineWidth;
      if (h.polyline)
        for (var C = 0, A2 = 0; A2 < v4.length; ) {
          var D = v4[A2++];
          if (D > 0)
            for (var P = v4[A2++], N = v4[A2++], j = 1; j < D; j++) {
              var W = v4[A2++], K = v4[A2++];
              if (PO(P, N, W, K, x3, e3, u))
                return C;
            }
          C++;
        }
      else
        for (var C = 0, A2 = 0; A2 < v4.length; ) {
          var P = v4[A2++], N = v4[A2++], W = v4[A2++], K = v4[A2++];
          if (m3 > 0) {
            var te = (P + W) / 2 - (N - K) * m3, ne = (N + K) / 2 - (W - P) * m3;
            if (Eut(P, N, te, ne, W, K, x3, e3, u))
              return C;
          } else if (PO(P, N, W, K, x3, e3, u))
            return C;
          C++;
        }
      return -1;
    }, r3.prototype.contain = function(e3, u) {
      var h = this.transformCoordToLocal(e3, u), v4 = this.getBoundingRect();
      if (e3 = h[0], u = h[1], v4.contain(e3, u)) {
        var m3 = this.hoverDataIdx = this.findDataIndex(e3, u);
        return m3 >= 0;
      }
      return this.hoverDataIdx = -1, false;
    }, r3.prototype.getBoundingRect = function() {
      var e3 = this._rect;
      if (!e3) {
        for (var u = this.shape, h = u.segs, v4 = 1 / 0, m3 = 1 / 0, x3 = -1 / 0, C = -1 / 0, A2 = 0; A2 < h.length; ) {
          var D = h[A2++], P = h[A2++];
          v4 = Math.min(D, v4), x3 = Math.max(D, x3), m3 = Math.min(P, m3), C = Math.max(P, C);
        }
        e3 = this._rect = new Ml(v4, m3, x3, C);
      }
      return e3;
    }, r3;
  }(Nl), fwn = function() {
    function l3() {
      this.group = new Cs();
    }
    return l3.prototype.updateData = function(r3) {
      this._clear();
      var e3 = this._create();
      e3.setShape({ segs: r3.getLayout("linesPoints") }), this._setCommon(e3, r3);
    }, l3.prototype.incrementalPrepareUpdate = function(r3) {
      this.group.removeAll(), this._clear();
    }, l3.prototype.incrementalUpdate = function(r3, e3) {
      var u = this._newAdded[0], h = e3.getLayout("linesPoints"), v4 = u && u.shape.segs;
      if (v4 && v4.length < 2e4) {
        var m3 = v4.length, x3 = new Float32Array(m3 + h.length);
        x3.set(v4), x3.set(h, m3), u.setShape({ segs: x3 });
      } else {
        this._newAdded = [];
        var C = this._create();
        C.incremental = true, C.setShape({ segs: h }), this._setCommon(C, e3), C.__startIndex = r3.start;
      }
    }, l3.prototype.remove = function() {
      this._clear();
    }, l3.prototype.eachRendered = function(r3) {
      this._newAdded[0] && r3(this._newAdded[0]);
    }, l3.prototype._create = function() {
      var r3 = new cwn({ cursor: "default" });
      return this._newAdded.push(r3), this.group.add(r3), r3;
    }, l3.prototype._setCommon = function(r3, e3, u) {
      var h = e3.hostModel;
      r3.setShape({ polyline: h.get("polyline"), curveness: h.get(["lineStyle", "curveness"]) }), r3.useStyle(h.getModel("lineStyle").getLineStyle()), r3.style.strokeNoScale = true;
      var v4 = e3.getVisual("style");
      v4 && v4.stroke && r3.setStyle("stroke", v4.stroke), r3.setStyle("fill", null);
      var m3 = Ps(r3);
      m3.seriesIndex = h.seriesIndex, r3.on("mousemove", function(x3) {
        m3.dataIndex = null;
        var C = r3.hoverDataIdx;
        C > 0 && (m3.dataIndex = C + r3.__startIndex);
      });
    }, l3.prototype._clear = function() {
      this._newAdded = [], this.group.removeAll();
    }, l3;
  }(), hwn = fwn, pwn = { seriesType: "lines", plan: kj(), reset: function(l3) {
    var r3 = l3.coordinateSystem;
    if (!!r3) {
      var e3 = l3.get("polyline"), u = l3.pipelineContext.large;
      return { progress: function(h, v4) {
        var m3 = [];
        if (u) {
          var x3 = void 0, C = h.end - h.start;
          if (e3) {
            for (var A2 = 0, D = h.start; D < h.end; D++)
              A2 += l3.getLineCoordsCount(D);
            x3 = new Float32Array(C + A2 * 2);
          } else
            x3 = new Float32Array(C * 4);
          for (var P = 0, N = [], D = h.start; D < h.end; D++) {
            var j = l3.getLineCoords(D, m3);
            e3 && (x3[P++] = j);
            for (var W = 0; W < j; W++)
              N = r3.dataToPoint(m3[W], false, N), x3[P++] = N[0], x3[P++] = N[1];
          }
          v4.setLayout("linesPoints", x3);
        } else
          for (var D = h.start; D < h.end; D++) {
            var K = v4.getItemModel(D), j = l3.getLineCoords(D, m3), te = [];
            if (e3)
              for (var ne = 0; ne < j; ne++)
                te.push(r3.dataToPoint(m3[ne]));
            else {
              te[0] = r3.dataToPoint(m3[0]), te[1] = r3.dataToPoint(m3[1]);
              var ce = K.get(["lineStyle", "curveness"]);
              +ce && (te[2] = [(te[0][0] + te[1][0]) / 2 - (te[0][1] - te[1][1]) * ce, (te[0][1] + te[1][1]) / 2 - (te[1][0] - te[0][0]) * ce]);
            }
            v4.setItemLayout(D, te);
          }
      } };
    }
  } }, Cdt = pwn, dwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this._updateLineDraw(v4, e3), x3 = e3.get("zlevel"), C = e3.get(["effect", "trailLength"]), A2 = h.getZr(), D = A2.painter.getType() === "svg";
      D || A2.painter.getLayer(x3).clear(true), this._lastZlevel != null && !D && A2.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(e3) && C > 0 && (D || A2.configLayer(x3, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(C / 10 + 0.9, 1), 0) })), m3.updateData(v4);
      var P = e3.get("clip", true) && vpe(e3.coordinateSystem, false, e3);
      P ? this.group.setClipPath(P) : this.group.removeClipPath(), this._lastZlevel = x3, this._finished = true;
    }, r3.prototype.incrementalPrepareRender = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this._updateLineDraw(v4, e3);
      m3.incrementalPrepareUpdate(v4), this._clearLayer(h), this._finished = false;
    }, r3.prototype.incrementalRender = function(e3, u, h) {
      this._lineDraw.incrementalUpdate(e3, u.getData()), this._finished = e3.end === u.getData().count();
    }, r3.prototype.eachRendered = function(e3) {
      this._lineDraw && this._lineDraw.eachRendered(e3);
    }, r3.prototype.updateTransform = function(e3, u, h) {
      var v4 = e3.getData(), m3 = e3.pipelineContext;
      if (!this._finished || m3.large || m3.progressiveRender)
        return { update: true };
      var x3 = Cdt.reset(e3, u, h);
      x3.progress && x3.progress({ start: 0, end: v4.count(), count: v4.count() }, v4), this._lineDraw.updateLayout(), this._clearLayer(h);
    }, r3.prototype._updateLineDraw = function(e3, u) {
      var h = this._lineDraw, v4 = this._showEffect(u), m3 = !!u.get("polyline"), x3 = u.pipelineContext, C = x3.large;
      return (!h || v4 !== this._hasEffet || m3 !== this._isPolyline || C !== this._isLargeDraw) && (h && h.remove(), h = this._lineDraw = C ? new hwn() : new qOe(m3 ? v4 ? lwn : Sdt : v4 ? wdt : UOe), this._hasEffet = v4, this._isPolyline = m3, this._isLargeDraw = C), this.group.add(h.group), h;
    }, r3.prototype._showEffect = function(e3) {
      return !!e3.get(["effect", "show"]);
    }, r3.prototype._clearLayer = function(e3) {
      var u = e3.getZr(), h = u.painter.getType() === "svg";
      !h && this._lastZlevel != null && u.painter.getLayer(this._lastZlevel).clear(true);
    }, r3.prototype.remove = function(e3, u) {
      this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(u);
    }, r3.prototype.dispose = function(e3, u) {
      this.remove(e3, u);
    }, r3.type = "lines", r3;
  }(zh), vwn = dwn, gwn = typeof Uint32Array == "undefined" ? Array : Uint32Array, ywn = typeof Float64Array == "undefined" ? Array : Float64Array;
  function jat(l3) {
    var r3 = l3.data;
    r3 && r3[0] && r3[0][0] && r3[0][0].coord && (l3.data = Bi(r3, function(e3) {
      var u = [e3[0].coord, e3[1].coord], h = { coords: u };
      return e3[0].name && (h.fromName = e3[0].name), e3[1].name && (h.toName = e3[1].name), T3e([h, e3[0], e3[1]]);
    }));
  }
  var mwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.visualStyleAccessPath = "lineStyle", e3.visualDrawType = "stroke", e3;
    }
    return r3.prototype.init = function(e3) {
      e3.data = e3.data || [], jat(e3);
      var u = this._processFlatCoordsArray(e3.data);
      this._flatCoords = u.flatCoords, this._flatCoordsOffset = u.flatCoordsOffset, u.flatCoords && (e3.data = new Float32Array(u.count)), l3.prototype.init.apply(this, arguments);
    }, r3.prototype.mergeOption = function(e3) {
      if (jat(e3), e3.data) {
        var u = this._processFlatCoordsArray(e3.data);
        this._flatCoords = u.flatCoords, this._flatCoordsOffset = u.flatCoordsOffset, u.flatCoords && (e3.data = new Float32Array(u.count));
      }
      l3.prototype.mergeOption.apply(this, arguments);
    }, r3.prototype.appendData = function(e3) {
      var u = this._processFlatCoordsArray(e3.data);
      u.flatCoords && (this._flatCoords ? (this._flatCoords = b5e(this._flatCoords, u.flatCoords), this._flatCoordsOffset = b5e(this._flatCoordsOffset, u.flatCoordsOffset)) : (this._flatCoords = u.flatCoords, this._flatCoordsOffset = u.flatCoordsOffset), e3.data = new Float32Array(u.count)), this.getRawData().appendData(e3.data);
    }, r3.prototype._getCoordsFromItemModel = function(e3) {
      var u = this.getData().getItemModel(e3), h = u.option instanceof Array ? u.option : u.getShallow("coords");
      return h;
    }, r3.prototype.getLineCoordsCount = function(e3) {
      return this._flatCoordsOffset ? this._flatCoordsOffset[e3 * 2 + 1] : this._getCoordsFromItemModel(e3).length;
    }, r3.prototype.getLineCoords = function(e3, u) {
      if (this._flatCoordsOffset) {
        for (var h = this._flatCoordsOffset[e3 * 2], v4 = this._flatCoordsOffset[e3 * 2 + 1], m3 = 0; m3 < v4; m3++)
          u[m3] = u[m3] || [], u[m3][0] = this._flatCoords[h + m3 * 2], u[m3][1] = this._flatCoords[h + m3 * 2 + 1];
        return v4;
      } else {
        for (var x3 = this._getCoordsFromItemModel(e3), m3 = 0; m3 < x3.length; m3++)
          u[m3] = u[m3] || [], u[m3][0] = x3[m3][0], u[m3][1] = x3[m3][1];
        return x3.length;
      }
    }, r3.prototype._processFlatCoordsArray = function(e3) {
      var u = 0;
      if (this._flatCoords && (u = this._flatCoords.length), Vc(e3[0])) {
        for (var h = e3.length, v4 = new gwn(h), m3 = new ywn(h), x3 = 0, C = 0, A2 = 0, D = 0; D < h; ) {
          A2++;
          var P = e3[D++];
          v4[C++] = x3 + u, v4[C++] = P;
          for (var N = 0; N < P; N++) {
            var j = e3[D++], W = e3[D++];
            m3[x3++] = j, m3[x3++] = W;
          }
        }
        return { flatCoordsOffset: new Uint32Array(v4.buffer, 0, C), flatCoords: m3, count: A2 };
      }
      return { flatCoordsOffset: null, flatCoords: null, count: e3.length };
    }, r3.prototype.getInitialData = function(e3, u) {
      var h = new yb(["value"], this);
      return h.hasItemOption = false, h.initData(e3.data, [], function(v4, m3, x3, C) {
        if (v4 instanceof Array)
          return NaN;
        h.hasItemOption = true;
        var A2 = v4.value;
        if (A2 != null)
          return A2 instanceof Array ? A2[C] : A2;
      }), h;
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      var v4 = this.getData(), m3 = v4.getItemModel(e3), x3 = m3.get("name");
      if (x3)
        return x3;
      var C = m3.get("fromName"), A2 = m3.get("toName"), D = [];
      return C != null && D.push(C), A2 != null && D.push(A2), o0("nameValue", { name: D.join(" > ") });
    }, r3.prototype.preventIncremental = function() {
      return !!this.get(["effect", "show"]);
    }, r3.prototype.getProgressive = function() {
      var e3 = this.option.progressive;
      return e3 == null ? this.option.large ? 1e4 : this.get("progressive") : e3;
    }, r3.prototype.getProgressiveThreshold = function() {
      var e3 = this.option.progressiveThreshold;
      return e3 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : e3;
    }, r3.prototype.getZLevelKey = function() {
      var e3 = this.getModel("effect"), u = e3.get("trailLength");
      return this.getData().count() > this.getProgressiveThreshold() ? this.id : e3.get("show") && u > 0 ? u + "" : "";
    }, r3.type = "series.lines", r3.dependencies = ["grid", "polar", "geo", "calendar"], r3.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, r3;
  }(Fp), bwn = mwn;
  function Qce(l3) {
    return l3 instanceof Array || (l3 = [l3, l3]), l3;
  }
  var _wn = { seriesType: "lines", reset: function(l3) {
    var r3 = Qce(l3.get("symbol")), e3 = Qce(l3.get("symbolSize")), u = l3.getData();
    u.setVisual("fromSymbol", r3 && r3[0]), u.setVisual("toSymbol", r3 && r3[1]), u.setVisual("fromSymbolSize", e3 && e3[0]), u.setVisual("toSymbolSize", e3 && e3[1]);
    function h(v4, m3) {
      var x3 = v4.getItemModel(m3), C = Qce(x3.getShallow("symbol", true)), A2 = Qce(x3.getShallow("symbolSize", true));
      C[0] && v4.setItemVisual(m3, "fromSymbol", C[0]), C[1] && v4.setItemVisual(m3, "toSymbol", C[1]), A2[0] && v4.setItemVisual(m3, "fromSymbolSize", A2[0]), A2[1] && v4.setItemVisual(m3, "toSymbolSize", A2[1]);
    }
    return { dataEach: u.hasItemOption ? h : null };
  } }, xwn = _wn;
  function wwn(l3) {
    l3.registerChartView(vwn), l3.registerSeriesModel(bwn), l3.registerLayout(Cdt), l3.registerVisual(xwn);
  }
  var Swn = 256, Cwn = function() {
    function l3() {
      this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
      var r3 = l5.createCanvas();
      this.canvas = r3;
    }
    return l3.prototype.update = function(r3, e3, u, h, v4, m3) {
      var x3 = this._getBrush(), C = this._getGradient(v4, "inRange"), A2 = this._getGradient(v4, "outOfRange"), D = this.pointSize + this.blurSize, P = this.canvas, N = P.getContext("2d"), j = r3.length;
      P.width = e3, P.height = u;
      for (var W = 0; W < j; ++W) {
        var K = r3[W], te = K[0], ne = K[1], ce = K[2], me = h(ce);
        N.globalAlpha = me, N.drawImage(x3, te - D, ne - D);
      }
      if (!P.width || !P.height)
        return P;
      for (var ve = N.getImageData(0, 0, P.width, P.height), Be = ve.data, Oe = 0, We = Be.length, Ue = this.minOpacity, qe = this.maxOpacity, Ze = qe - Ue; Oe < We; ) {
        var me = Be[Oe + 3] / 256, ct = Math.floor(me * (Swn - 1)) * 4;
        if (me > 0) {
          var _t = m3(me) ? C : A2;
          me > 0 && (me = me * Ze + Ue), Be[Oe++] = _t[ct], Be[Oe++] = _t[ct + 1], Be[Oe++] = _t[ct + 2], Be[Oe++] = _t[ct + 3] * me * 256;
        } else
          Oe += 4;
      }
      return N.putImageData(ve, 0, 0), P;
    }, l3.prototype._getBrush = function() {
      var r3 = this._brushCanvas || (this._brushCanvas = l5.createCanvas()), e3 = this.pointSize + this.blurSize, u = e3 * 2;
      r3.width = u, r3.height = u;
      var h = r3.getContext("2d");
      return h.clearRect(0, 0, u, u), h.shadowOffsetX = u, h.shadowBlur = this.blurSize, h.shadowColor = "#000", h.beginPath(), h.arc(-e3, e3, this.pointSize, 0, Math.PI * 2, true), h.closePath(), h.fill(), r3;
    }, l3.prototype._getGradient = function(r3, e3) {
      for (var u = this._gradientPixels, h = u[e3] || (u[e3] = new Uint8ClampedArray(256 * 4)), v4 = [0, 0, 0, 0], m3 = 0, x3 = 0; x3 < 256; x3++)
        r3[e3](x3 / 255, true, v4), h[m3++] = v4[0], h[m3++] = v4[1], h[m3++] = v4[2], h[m3++] = v4[3];
      return h;
    }, l3;
  }(), Mwn = Cwn;
  function Twn(l3, r3, e3) {
    var u = l3[1] - l3[0];
    r3 = Bi(r3, function(m3) {
      return { interval: [(m3.interval[0] - l3[0]) / u, (m3.interval[1] - l3[0]) / u] };
    });
    var h = r3.length, v4 = 0;
    return function(m3) {
      var x3;
      for (x3 = v4; x3 < h; x3++) {
        var C = r3[x3].interval;
        if (C[0] <= m3 && m3 <= C[1]) {
          v4 = x3;
          break;
        }
      }
      if (x3 === h)
        for (x3 = v4 - 1; x3 >= 0; x3--) {
          var C = r3[x3].interval;
          if (C[0] <= m3 && m3 <= C[1]) {
            v4 = x3;
            break;
          }
        }
      return x3 >= 0 && x3 < h && e3[x3];
    };
  }
  function Awn(l3, r3) {
    var e3 = l3[1] - l3[0];
    return r3 = [(r3[0] - l3[0]) / e3, (r3[1] - l3[0]) / e3], function(u) {
      return u >= r3[0] && u <= r3[1];
    };
  }
  function Gat(l3) {
    var r3 = l3.dimensions;
    return r3[0] === "lng" && r3[1] === "lat";
  }
  var Iwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4;
      u.eachComponent("visualMap", function(x3) {
        x3.eachTargetSeries(function(C) {
          C === e3 && (v4 = x3);
        });
      }), this._progressiveEls = null, this.group.removeAll();
      var m3 = e3.coordinateSystem;
      m3.type === "cartesian2d" || m3.type === "calendar" ? this._renderOnCartesianAndCalendar(e3, h, 0, e3.getData().count()) : Gat(m3) && this._renderOnGeo(m3, e3, v4, h);
    }, r3.prototype.incrementalPrepareRender = function(e3, u, h) {
      this.group.removeAll();
    }, r3.prototype.incrementalRender = function(e3, u, h, v4) {
      var m3 = u.coordinateSystem;
      m3 && (Gat(m3) ? this.render(u, h, v4) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(u, v4, e3.start, e3.end, true)));
    }, r3.prototype.eachRendered = function(e3) {
      oP(this._progressiveEls || this.group, e3);
    }, r3.prototype._renderOnCartesianAndCalendar = function(e3, u, h, v4, m3) {
      var x3 = e3.coordinateSystem, C, A2, D, P;
      if (a5(x3, "cartesian2d")) {
        var N = x3.getAxis("x"), j = x3.getAxis("y");
        C = N.getBandWidth(), A2 = j.getBandWidth(), D = N.scale.getExtent(), P = j.scale.getExtent();
      }
      for (var W = this.group, K = e3.getData(), te = e3.getModel(["emphasis", "itemStyle"]).getItemStyle(), ne = e3.getModel(["blur", "itemStyle"]).getItemStyle(), ce = e3.getModel(["select", "itemStyle"]).getItemStyle(), me = e3.get(["itemStyle", "borderRadius"]), ve = ny(e3), Be = e3.getModel("emphasis"), Oe = Be.get("focus"), We = Be.get("blurScope"), Ue = Be.get("disabled"), qe = a5(x3, "cartesian2d") ? [K.mapDimension("x"), K.mapDimension("y"), K.mapDimension("value")] : [K.mapDimension("time"), K.mapDimension("value")], Ze = h; Ze < v4; Ze++) {
        var ct = void 0, _t = K.getItemVisual(Ze, "style");
        if (a5(x3, "cartesian2d")) {
          var pt = K.get(qe[0], Ze), zt = K.get(qe[1], Ze);
          if (isNaN(K.get(qe[2], Ze)) || pt < D[0] || pt > D[1] || zt < P[0] || zt > P[1])
            continue;
          var Zt = x3.dataToPoint([pt, zt]);
          ct = new Ju({ shape: { x: Math.floor(Math.round(Zt[0]) - C / 2), y: Math.floor(Math.round(Zt[1]) - A2 / 2), width: Math.ceil(C), height: Math.ceil(A2) }, style: _t });
        } else {
          if (isNaN(K.get(qe[1], Ze)))
            continue;
          ct = new Ju({ z2: 1, shape: x3.dataToRect([K.get(qe[0], Ze)]).contentShape, style: _t });
        }
        if (K.hasItemOption) {
          var Ft = K.getItemModel(Ze), Kn = Ft.getModel("emphasis");
          te = Kn.getModel("itemStyle").getItemStyle(), ne = Ft.getModel(["blur", "itemStyle"]).getItemStyle(), ce = Ft.getModel(["select", "itemStyle"]).getItemStyle(), me = Ft.get(["itemStyle", "borderRadius"]), Oe = Kn.get("focus"), We = Kn.get("blurScope"), Ue = Kn.get("disabled"), ve = ny(Ft);
        }
        ct.shape.r = me;
        var hn = e3.getRawValue(Ze), xn = "-";
        hn && hn[2] != null && (xn = hn[2] + ""), _1(ct, ve, { labelFetcher: e3, labelDataIndex: Ze, defaultOpacity: _t.opacity, defaultText: xn }), ct.ensureState("emphasis").style = te, ct.ensureState("blur").style = ne, ct.ensureState("select").style = ce, Gd(ct, Oe, We, Ue), ct.incremental = m3, m3 && (ct.states.emphasis.hoverLayer = true), W.add(ct), K.setItemGraphicEl(Ze, ct), this._progressiveEls && this._progressiveEls.push(ct);
      }
    }, r3.prototype._renderOnGeo = function(e3, u, h, v4) {
      var m3 = h.targetVisuals.inRange, x3 = h.targetVisuals.outOfRange, C = u.getData(), A2 = this._hmLayer || this._hmLayer || new Mwn();
      A2.blurSize = u.get("blurSize"), A2.pointSize = u.get("pointSize"), A2.minOpacity = u.get("minOpacity"), A2.maxOpacity = u.get("maxOpacity");
      var D = e3.getViewRect().clone(), P = e3.getRoamTransform();
      D.applyTransform(P);
      var N = Math.max(D.x, 0), j = Math.max(D.y, 0), W = Math.min(D.width + D.x, v4.getWidth()), K = Math.min(D.height + D.y, v4.getHeight()), te = W - N, ne = K - j, ce = [C.mapDimension("lng"), C.mapDimension("lat"), C.mapDimension("value")], me = C.mapArray(ce, function(We, Ue, qe) {
        var Ze = e3.dataToPoint([We, Ue]);
        return Ze[0] -= N, Ze[1] -= j, Ze.push(qe), Ze;
      }), ve = h.getExtent(), Be = h.type === "visualMap.continuous" ? Awn(ve, h.option.range) : Twn(ve, h.getPieceList(), h.option.selected);
      A2.update(me, te, ne, m3.color.getNormalizer(), { inRange: m3.color.getColorMapper(), outOfRange: x3.color.getColorMapper() }, Be);
      var Oe = new lm({ style: { width: te, height: ne, x: N, y: j, image: A2.canvas }, silent: true });
      this.group.add(Oe);
    }, r3.type = "heatmap", r3;
  }(zh), Ewn = Iwn, Dwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      return v5(null, this, { generateCoord: "value" });
    }, r3.prototype.preventIncremental = function() {
      var e3 = FJ.get(this.get("coordinateSystem"));
      if (e3 && e3.dimensions)
        return e3.dimensions[0] === "lng" && e3.dimensions[1] === "lat";
    }, r3.type = "series.heatmap", r3.dependencies = ["grid", "geo", "calendar"], r3.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, r3;
  }(Fp), kwn = Dwn;
  function Own(l3) {
    l3.registerChartView(Ewn), l3.registerSeriesModel(kwn);
  }
  var Pwn = ["itemStyle", "borderWidth"], Hat = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], PDe = new YA(), Lwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = this.group, m3 = e3.getData(), x3 = this._data, C = e3.coordinateSystem, A2 = C.getBaseAxis(), D = A2.isHorizontal(), P = C.master.getRect(), N = { ecSize: { width: h.getWidth(), height: h.getHeight() }, seriesModel: e3, coordSys: C, coordSysExtent: [[P.x, P.x + P.width], [P.y, P.y + P.height]], isHorizontal: D, valueDim: Hat[+D], categoryDim: Hat[1 - +D] };
      return m3.diff(x3).add(function(j) {
        if (!!m3.hasValue(j)) {
          var W = Uat(m3, j), K = Wat(m3, j, W, N), te = qat(m3, N, K);
          m3.setItemGraphicEl(j, te), v4.add(te), Xat(te, N, K);
        }
      }).update(function(j, W) {
        var K = x3.getItemGraphicEl(W);
        if (!m3.hasValue(j)) {
          v4.remove(K);
          return;
        }
        var te = Uat(m3, j), ne = Wat(m3, j, te, N), ce = Ddt(m3, ne);
        K && ce !== K.__pictorialShapeStr && (v4.remove(K), m3.setItemGraphicEl(j, null), K = null), K ? jwn(K, N, ne) : K = qat(m3, N, ne, true), m3.setItemGraphicEl(j, K), K.__pictorialSymbolMeta = ne, v4.add(K), Xat(K, N, ne);
      }).remove(function(j) {
        var W = x3.getItemGraphicEl(j);
        W && $at(x3, j, W.__pictorialSymbolMeta.animationModel, W);
      }).execute(), this._data = m3, this.group;
    }, r3.prototype.remove = function(e3, u) {
      var h = this.group, v4 = this._data;
      e3.get("animation") ? v4 && v4.eachItemGraphicEl(function(m3) {
        $at(v4, Ps(m3).dataIndex, e3, m3);
      }) : h.removeAll();
    }, r3.type = "pictorialBar", r3;
  }(zh);
  function Wat(l3, r3, e3, u) {
    var h = l3.getItemLayout(r3), v4 = e3.get("symbolRepeat"), m3 = e3.get("symbolClip"), x3 = e3.get("symbolPosition") || "start", C = e3.get("symbolRotate"), A2 = (C || 0) * Math.PI / 180 || 0, D = e3.get("symbolPatternSize") || 2, P = e3.isAnimationEnabled(), N = { dataIndex: r3, layout: h, itemModel: e3, symbolType: l3.getItemVisual(r3, "symbol") || "circle", style: l3.getItemVisual(r3, "style"), symbolClip: m3, symbolRepeat: v4, symbolRepeatDirection: e3.get("symbolRepeatDirection"), symbolPatternSize: D, rotation: A2, animationModel: P ? e3 : null, hoverScale: P && e3.get(["emphasis", "scale"]), z2: e3.getShallow("z", true) || 0 };
    Rwn(e3, v4, h, u, N), Nwn(l3, r3, h, v4, m3, N.boundingLength, N.pxSign, D, u, N), Fwn(e3, N.symbolScale, A2, u, N);
    var j = N.symbolSize, W = Pj(e3.get("symbolOffset"), j);
    return Vwn(e3, j, h, v4, m3, W, x3, N.valueLineWidth, N.boundingLength, N.repeatCutLength, u, N), N;
  }
  function Rwn(l3, r3, e3, u, h) {
    var v4 = u.valueDim, m3 = l3.get("symbolBoundingData"), x3 = u.coordSys.getOtherAxis(u.coordSys.getBaseAxis()), C = x3.toGlobalCoord(x3.dataToCoord(0)), A2 = 1 - +(e3[v4.wh] <= 0), D;
    if (Ni(m3)) {
      var P = [LDe(x3, m3[0]) - C, LDe(x3, m3[1]) - C];
      P[1] < P[0] && P.reverse(), D = P[A2];
    } else
      m3 != null ? D = LDe(x3, m3) - C : r3 ? D = u.coordSysExtent[v4.index][A2] - C : D = e3[v4.wh];
    h.boundingLength = D, r3 && (h.repeatCutLength = e3[v4.wh]), h.pxSign = D > 0 ? 1 : -1;
  }
  function LDe(l3, r3) {
    return l3.toGlobalCoord(l3.dataToCoord(l3.scale.parse(r3)));
  }
  function Nwn(l3, r3, e3, u, h, v4, m3, x3, C, A2) {
    var D = C.valueDim, P = C.categoryDim, N = Math.abs(e3[P.wh]), j = l3.getItemVisual(r3, "symbolSize"), W;
    Ni(j) ? W = j.slice() : j == null ? W = ["100%", "100%"] : W = [j, j], W[P.index] = za(W[P.index], N), W[D.index] = za(W[D.index], u ? N : Math.abs(v4)), A2.symbolSize = W;
    var K = A2.symbolScale = [W[0] / x3, W[1] / x3];
    K[D.index] *= (C.isHorizontal ? -1 : 1) * m3;
  }
  function Fwn(l3, r3, e3, u, h) {
    var v4 = l3.get(Pwn) || 0;
    v4 && (PDe.attr({ scaleX: r3[0], scaleY: r3[1], rotation: e3 }), PDe.updateTransform(), v4 /= PDe.getLineScale(), v4 *= r3[u.valueDim.index]), h.valueLineWidth = v4 || 0;
  }
  function Vwn(l3, r3, e3, u, h, v4, m3, x3, C, A2, D, P) {
    var N = D.categoryDim, j = D.valueDim, W = P.pxSign, K = Math.max(r3[j.index] + x3, 0), te = K;
    if (u) {
      var ne = Math.abs(C), ce = ey(l3.get("symbolMargin"), "15%") + "", me = false;
      ce.lastIndexOf("!") === ce.length - 1 && (me = true, ce = ce.slice(0, ce.length - 1));
      var ve = za(ce, r3[j.index]), Be = Math.max(K + ve * 2, 0), Oe = me ? 0 : ve * 2, We = vut(u), Ue = We ? u : Yat((ne + Oe) / Be), qe = ne - Ue * K;
      ve = qe / 2 / (me ? Ue : Math.max(Ue - 1, 1)), Be = K + ve * 2, Oe = me ? 0 : ve * 2, !We && u !== "fixed" && (Ue = A2 ? Yat((Math.abs(A2) + Oe) / Be) : 0), te = Ue * Be - Oe, P.repeatTimes = Ue, P.symbolMargin = ve;
    }
    var Ze = W * (te / 2), ct = P.pathPosition = [];
    ct[N.index] = e3[N.wh] / 2, ct[j.index] = m3 === "start" ? Ze : m3 === "end" ? C - Ze : C / 2, v4 && (ct[0] += v4[0], ct[1] += v4[1]);
    var _t = P.bundlePosition = [];
    _t[N.index] = e3[N.xy], _t[j.index] = e3[j.xy];
    var pt = P.barRectShape = fi({}, e3);
    pt[j.wh] = W * Math.max(Math.abs(e3[j.wh]), Math.abs(ct[j.index] + Ze)), pt[N.wh] = e3[N.wh];
    var zt = P.clipShape = {};
    zt[N.xy] = -e3[N.xy], zt[N.wh] = D.ecSize[N.wh], zt[j.xy] = 0, zt[j.wh] = e3[j.wh];
  }
  function Mdt(l3) {
    var r3 = l3.symbolPatternSize, e3 = Nv(l3.symbolType, -r3 / 2, -r3 / 2, r3, r3);
    return e3.attr({ culling: true }), e3.type !== "image" && e3.setStyle({ strokeNoScale: true }), e3;
  }
  function Tdt(l3, r3, e3, u) {
    var h = l3.__pictorialBundle, v4 = e3.symbolSize, m3 = e3.valueLineWidth, x3 = e3.pathPosition, C = r3.valueDim, A2 = e3.repeatTimes || 0, D = 0, P = v4[r3.valueDim.index] + m3 + e3.symbolMargin * 2;
    for (ePe(l3, function(K) {
      K.__pictorialAnimationIndex = D, K.__pictorialRepeatTimes = A2, D < A2 ? sj(K, null, W(D), e3, u) : sj(K, null, { scaleX: 0, scaleY: 0 }, e3, u, function() {
        h.remove(K);
      }), D++;
    }); D < A2; D++) {
      var N = Mdt(e3);
      N.__pictorialAnimationIndex = D, N.__pictorialRepeatTimes = A2, h.add(N);
      var j = W(D);
      sj(N, { x: j.x, y: j.y, scaleX: 0, scaleY: 0 }, { scaleX: j.scaleX, scaleY: j.scaleY, rotation: j.rotation }, e3, u);
    }
    function W(K) {
      var te = x3.slice(), ne = e3.pxSign, ce = K;
      return (e3.symbolRepeatDirection === "start" ? ne > 0 : ne < 0) && (ce = A2 - 1 - K), te[C.index] = P * (ce - A2 / 2 + 0.5) + x3[C.index], { x: te[0], y: te[1], scaleX: e3.symbolScale[0], scaleY: e3.symbolScale[1], rotation: e3.rotation };
    }
  }
  function Adt(l3, r3, e3, u) {
    var h = l3.__pictorialBundle, v4 = l3.__pictorialMainPath;
    v4 ? sj(v4, null, { x: e3.pathPosition[0], y: e3.pathPosition[1], scaleX: e3.symbolScale[0], scaleY: e3.symbolScale[1], rotation: e3.rotation }, e3, u) : (v4 = l3.__pictorialMainPath = Mdt(e3), h.add(v4), sj(v4, { x: e3.pathPosition[0], y: e3.pathPosition[1], scaleX: 0, scaleY: 0, rotation: e3.rotation }, { scaleX: e3.symbolScale[0], scaleY: e3.symbolScale[1] }, e3, u));
  }
  function Idt(l3, r3, e3) {
    var u = fi({}, r3.barRectShape), h = l3.__pictorialBarRect;
    h ? sj(h, null, { shape: u }, r3, e3) : (h = l3.__pictorialBarRect = new Ju({ z2: 2, shape: u, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), h.disableMorphing = true, l3.add(h));
  }
  function Edt(l3, r3, e3, u) {
    if (e3.symbolClip) {
      var h = l3.__pictorialClipPath, v4 = fi({}, e3.clipShape), m3 = r3.valueDim, x3 = e3.animationModel, C = e3.dataIndex;
      if (h)
        hc(h, { shape: v4 }, x3, C);
      else {
        v4[m3.wh] = 0, h = new Ju({ shape: v4 }), l3.__pictorialBundle.setClipPath(h), l3.__pictorialClipPath = h;
        var A2 = {};
        A2[m3.wh] = e3.clipShape[m3.wh], NJ[u ? "updateProps" : "initProps"](h, { shape: A2 }, x3, C);
      }
    }
  }
  function Uat(l3, r3) {
    var e3 = l3.getItemModel(r3);
    return e3.getAnimationDelayParams = Bwn, e3.isAnimationEnabled = zwn, e3;
  }
  function Bwn(l3) {
    return { index: l3.__pictorialAnimationIndex, count: l3.__pictorialRepeatTimes };
  }
  function zwn() {
    return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
  }
  function qat(l3, r3, e3, u) {
    var h = new Cs(), v4 = new Cs();
    return h.add(v4), h.__pictorialBundle = v4, v4.x = e3.bundlePosition[0], v4.y = e3.bundlePosition[1], e3.symbolRepeat ? Tdt(h, r3, e3) : Adt(h, r3, e3), Idt(h, e3, u), Edt(h, r3, e3, u), h.__pictorialShapeStr = Ddt(l3, e3), h.__pictorialSymbolMeta = e3, h;
  }
  function jwn(l3, r3, e3) {
    var u = e3.animationModel, h = e3.dataIndex, v4 = l3.__pictorialBundle;
    hc(v4, { x: e3.bundlePosition[0], y: e3.bundlePosition[1] }, u, h), e3.symbolRepeat ? Tdt(l3, r3, e3, true) : Adt(l3, r3, e3, true), Idt(l3, e3, true), Edt(l3, r3, e3, true);
  }
  function $at(l3, r3, e3, u) {
    var h = u.__pictorialBarRect;
    h && h.removeTextContent();
    var v4 = [];
    ePe(u, function(m3) {
      v4.push(m3);
    }), u.__pictorialMainPath && v4.push(u.__pictorialMainPath), u.__pictorialClipPath && (e3 = null), mt(v4, function(m3) {
      JO(m3, { scaleX: 0, scaleY: 0 }, e3, r3, function() {
        u.parent && u.parent.remove(u);
      });
    }), l3.setItemGraphicEl(r3, null);
  }
  function Ddt(l3, r3) {
    return [l3.getItemVisual(r3.dataIndex, "symbol") || "none", !!r3.symbolRepeat, !!r3.symbolClip].join(":");
  }
  function ePe(l3, r3, e3) {
    mt(l3.__pictorialBundle.children(), function(u) {
      u !== l3.__pictorialBarRect && r3.call(e3, u);
    });
  }
  function sj(l3, r3, e3, u, h, v4) {
    r3 && l3.attr(r3), u.symbolClip && !h ? e3 && l3.attr(e3) : e3 && NJ[h ? "updateProps" : "initProps"](l3, e3, u.animationModel, u.dataIndex, v4);
  }
  function Xat(l3, r3, e3) {
    var u = e3.dataIndex, h = e3.itemModel, v4 = h.getModel("emphasis"), m3 = v4.getModel("itemStyle").getItemStyle(), x3 = h.getModel(["blur", "itemStyle"]).getItemStyle(), C = h.getModel(["select", "itemStyle"]).getItemStyle(), A2 = h.getShallow("cursor"), D = v4.get("focus"), P = v4.get("blurScope"), N = v4.get("scale");
    ePe(l3, function(K) {
      if (K instanceof lm) {
        var te = K.style;
        K.useStyle(fi({ image: te.image, x: te.x, y: te.y, width: te.width, height: te.height }, e3.style));
      } else
        K.useStyle(e3.style);
      var ne = K.ensureState("emphasis");
      ne.style = m3, N && (ne.scaleX = K.scaleX * 1.1, ne.scaleY = K.scaleY * 1.1), K.ensureState("blur").style = x3, K.ensureState("select").style = C, A2 && (K.cursor = A2), K.z2 = e3.z2;
    });
    var j = r3.valueDim.posDesc[+(e3.boundingLength > 0)], W = l3.__pictorialBarRect;
    _1(W, ny(h), { labelFetcher: r3.seriesModel, labelDataIndex: u, defaultText: dj(r3.seriesModel.getData(), u), inheritColor: e3.style.fill, defaultOpacity: e3.style.opacity, defaultOutsidePosition: j }), Gd(l3, D, P, v4.get("disabled"));
  }
  function Yat(l3) {
    var r3 = Math.round(l3);
    return Math.abs(l3 - r3) < 1e-4 ? r3 : Math.ceil(l3);
  }
  var Gwn = Lwn, Hwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.hasSymbolVisual = true, e3.defaultSymbol = "roundRect", e3;
    }
    return r3.prototype.getInitialData = function(e3) {
      return e3.stack = null, l3.prototype.getInitialData.apply(this, arguments);
    }, r3.type = "series.pictorialBar", r3.dependencies = ["grid"], r3.defaultOption = sP(hhe.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), r3;
  }(hhe), Wwn = Hwn;
  function Uwn(l3) {
    l3.registerChartView(Gwn), l3.registerSeriesModel(Wwn), l3.registerLayout(l3.PRIORITY.VISUAL.LAYOUT, Fs(hht, "pictorialBar")), l3.registerLayout(l3.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, pht("pictorialBar"));
  }
  var qwn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._layers = [], e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = e3.getData(), m3 = this, x3 = this.group, C = e3.getLayerSeries(), A2 = v4.getLayout("layoutInfo"), D = A2.rect, P = A2.boundaryGap;
      x3.x = 0, x3.y = D.y + P[0];
      function N(te) {
        return te.name;
      }
      var j = new f5(this._layersSeries || [], C, N, N), W = [];
      j.add(no(K, this, "add")).update(no(K, this, "update")).remove(no(K, this, "remove")).execute();
      function K(te, ne, ce) {
        var me = m3._layers;
        if (te === "remove") {
          x3.remove(me[ne]);
          return;
        }
        for (var ve = [], Be = [], Oe, We = C[ne].indices, Ue = 0; Ue < We.length; Ue++) {
          var qe = v4.getItemLayout(We[Ue]), Ze = qe.x, ct = qe.y0, _t = qe.y;
          ve.push(Ze, ct), Be.push(Ze, ct + _t), Oe = v4.getItemVisual(We[Ue], "style");
        }
        var pt, zt = v4.getItemLayout(We[0]), Zt = e3.getModel("label"), Ft = Zt.get("margin"), Kn = e3.getModel("emphasis");
        if (te === "add") {
          var hn = W[ne] = new Cs();
          pt = new Qht({ shape: { points: ve, stackedOnPoints: Be, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), hn.add(pt), x3.add(hn), e3.isAnimationEnabled() && pt.setClipPath($wn(pt.getBoundingRect(), e3, function() {
            pt.removeClipPath();
          }));
        } else {
          var hn = me[ce];
          pt = hn.childAt(0), x3.add(hn), W[ne] = hn, hc(pt, { shape: { points: ve, stackedOnPoints: Be } }, e3), yM(pt);
        }
        _1(pt, ny(e3), { labelDataIndex: We[Ue - 1], defaultText: v4.getName(We[Ue - 1]), inheritColor: Oe.fill }, { normal: { verticalAlign: "middle" } }), pt.setTextConfig({ position: null, local: true });
        var xn = pt.getTextContent();
        xn && (xn.x = zt.x - Ft, xn.y = zt.y0 + zt.y / 2), pt.useStyle(Oe), v4.setItemGraphicEl(ne, pt), sm(pt, e3), Gd(pt, Kn.get("focus"), Kn.get("blurScope"), Kn.get("disabled"));
      }
      this._layersSeries = C, this._layers = W;
    }, r3.type = "themeRiver", r3;
  }(zh);
  function $wn(l3, r3, e3) {
    var u = new Ju({ shape: { x: l3.x - 10, y: l3.y - 10, width: 0, height: l3.height + 20 } });
    return Np(u, { shape: { x: l3.x - 50, width: l3.width + 100, height: l3.height + 20 } }, r3, e3), u;
  }
  var Xwn = qwn, RDe = 2, Ywn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3) {
      l3.prototype.init.apply(this, arguments), this.legendVisualProvider = new $J(no(this.getData, this), no(this.getRawData, this));
    }, r3.prototype.fixData = function(e3) {
      var u = e3.length, h = {}, v4 = j5e(e3, function(N) {
        return h.hasOwnProperty(N[0] + "") || (h[N[0] + ""] = -1), N[2];
      }), m3 = [];
      v4.buckets.each(function(N, j) {
        m3.push({ name: j, dataList: N });
      });
      for (var x3 = m3.length, C = 0; C < x3; ++C) {
        for (var A2 = m3[C].name, D = 0; D < m3[C].dataList.length; ++D) {
          var P = m3[C].dataList[D][0] + "";
          h[P] = C;
        }
        for (var P in h)
          h.hasOwnProperty(P) && h[P] !== C && (h[P] = C, e3[u] = [P, 0, A2], u++);
      }
      return e3;
    }, r3.prototype.getInitialData = function(e3, u) {
      for (var h = this.getReferringComponents("singleAxis", Lv).models[0], v4 = h.get("type"), m3 = jf(e3.data, function(W) {
        return W[2] !== void 0;
      }), x3 = this.fixData(m3 || []), C = [], A2 = this.nameMap = Ho(), D = 0, P = 0; P < x3.length; ++P)
        C.push(x3[P][RDe]), A2.get(x3[P][RDe]) || (A2.set(x3[P][RDe], D), D++);
      var N = zJ(x3, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: she(v4) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, j = new yb(N, this);
      return j.initData(x3), j;
    }, r3.prototype.getLayerSeries = function() {
      for (var e3 = this.getData(), u = e3.count(), h = [], v4 = 0; v4 < u; ++v4)
        h[v4] = v4;
      var m3 = e3.mapDimension("single"), x3 = j5e(h, function(A2) {
        return e3.get("name", A2);
      }), C = [];
      return x3.buckets.each(function(A2, D) {
        A2.sort(function(P, N) {
          return e3.get(m3, P) - e3.get(m3, N);
        }), C.push({ name: D, indices: A2 });
      }), C;
    }, r3.prototype.getAxisTooltipData = function(e3, u, h) {
      Ni(e3) || (e3 = e3 ? [e3] : []);
      for (var v4 = this.getData(), m3 = this.getLayerSeries(), x3 = [], C = m3.length, A2, D = 0; D < C; ++D) {
        for (var P = Number.MAX_VALUE, N = -1, j = m3[D].indices.length, W = 0; W < j; ++W) {
          var K = v4.get(e3[0], m3[D].indices[W]), te = Math.abs(K - u);
          te <= P && (A2 = K, P = te, N = m3[D].indices[W]);
        }
        x3.push(N);
      }
      return { dataIndices: x3, nestestValue: A2 };
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      var v4 = this.getData(), m3 = v4.getName(e3), x3 = v4.get(v4.mapDimension("value"), e3);
      return o0("nameValue", { name: m3, value: x3 });
    }, r3.type = "series.themeRiver", r3.dependencies = ["singleAxis"], r3.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, r3;
  }(Fp), Kwn = Ywn;
  function Zwn(l3, r3) {
    l3.eachSeriesByType("themeRiver", function(e3) {
      var u = e3.getData(), h = e3.coordinateSystem, v4 = {}, m3 = h.getRect();
      v4.rect = m3;
      var x3 = e3.get("boundaryGap"), C = h.getAxis();
      if (v4.boundaryGap = x3, C.orient === "horizontal") {
        x3[0] = za(x3[0], m3.height), x3[1] = za(x3[1], m3.height);
        var A2 = m3.height - x3[0] - x3[1];
        Kat(u, e3, A2);
      } else {
        x3[0] = za(x3[0], m3.width), x3[1] = za(x3[1], m3.width);
        var D = m3.width - x3[0] - x3[1];
        Kat(u, e3, D);
      }
      u.setLayout("layoutInfo", v4);
    });
  }
  function Kat(l3, r3, e3) {
    if (!!l3.count())
      for (var u = r3.coordinateSystem, h = r3.getLayerSeries(), v4 = l3.mapDimension("single"), m3 = l3.mapDimension("value"), x3 = Bi(h, function(te) {
        return Bi(te.indices, function(ne) {
          var ce = u.dataToPoint(l3.get(v4, ne));
          return ce[1] = l3.get(m3, ne), ce;
        });
      }), C = Jwn(x3), A2 = C.y0, D = e3 / C.max, P = h.length, N = h[0].indices.length, j, W = 0; W < N; ++W) {
        j = A2[W] * D, l3.setItemLayout(h[0].indices[W], { layerIndex: 0, x: x3[0][W][0], y0: j, y: x3[0][W][1] * D });
        for (var K = 1; K < P; ++K)
          j += x3[K - 1][W][1] * D, l3.setItemLayout(h[K].indices[W], { layerIndex: K, x: x3[K][W][0], y0: j, y: x3[K][W][1] * D });
      }
  }
  function Jwn(l3) {
    for (var r3 = l3.length, e3 = l3[0].length, u = [], h = [], v4 = 0, m3 = 0; m3 < e3; ++m3) {
      for (var x3 = 0, C = 0; C < r3; ++C)
        x3 += l3[C][m3][1];
      x3 > v4 && (v4 = x3), u.push(x3);
    }
    for (var A2 = 0; A2 < e3; ++A2)
      h[A2] = (v4 - u[A2]) / 2;
    v4 = 0;
    for (var D = 0; D < e3; ++D) {
      var P = u[D] + h[D];
      P > v4 && (v4 = P);
    }
    return { y0: h, max: v4 };
  }
  function Qwn(l3) {
    l3.registerChartView(Xwn), l3.registerSeriesModel(Kwn), l3.registerLayout(Zwn), l3.registerProcessor(qJ("themeRiver"));
  }
  var eSn = 2, tSn = 4, nSn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4) {
      var m3 = l3.call(this) || this;
      m3.z2 = eSn, m3.textConfig = { inside: true }, Ps(m3).seriesIndex = u.seriesIndex;
      var x3 = new Ec({ z2: tSn, silent: e3.getModel().get(["label", "silent"]) });
      return m3.setTextContent(x3), m3.updateData(true, e3, u, h, v4), m3;
    }
    return r3.prototype.updateData = function(e3, u, h, v4, m3) {
      this.node = u, u.piece = this, h = h || this._seriesModel, v4 = v4 || this._ecModel;
      var x3 = this;
      Ps(x3).dataIndex = u.dataIndex;
      var C = u.getModel(), A2 = C.getModel("emphasis"), D = u.getLayout(), P = fi({}, D);
      P.label = null;
      var N = u.getVisual("style");
      N.lineJoin = "bevel";
      var j = u.getVisual("decal");
      j && (N.decal = pJ(j, m3));
      var W = Qz(C.getModel("itemStyle"), P, true);
      fi(P, W), mt(bb, function(ce) {
        var me = x3.ensureState(ce), ve = C.getModel([ce, "itemStyle"]);
        me.style = ve.getItemStyle();
        var Be = Qz(ve, P);
        Be && (me.shape = Be);
      }), e3 ? (x3.setShape(P), x3.shape.r = D.r0, hc(x3, { shape: { r: D.r } }, h, u.dataIndex)) : (hc(x3, { shape: P }, h), yM(x3)), x3.useStyle(N), this._updateLabel(h);
      var K = C.getShallow("cursor");
      K && x3.attr("cursor", K), this._seriesModel = h || this._seriesModel, this._ecModel = v4 || this._ecModel;
      var te = A2.get("focus"), ne = te === "ancestor" ? u.getAncestorsIndices() : te === "descendant" ? u.getDescendantIndices() : te;
      Gd(this, ne, A2.get("blurScope"), A2.get("disabled"));
    }, r3.prototype._updateLabel = function(e3) {
      var u = this, h = this.node.getModel(), v4 = h.getModel("label"), m3 = this.node.getLayout(), x3 = m3.endAngle - m3.startAngle, C = (m3.startAngle + m3.endAngle) / 2, A2 = Math.cos(C), D = Math.sin(C), P = this, N = P.getTextContent(), j = this.node.dataIndex, W = v4.get("minAngle") / 180 * Math.PI, K = v4.get("show") && !(W != null && Math.abs(x3) < W);
      N.ignore = !K, mt(rJ, function(ne) {
        var ce = ne === "normal" ? h.getModel("label") : h.getModel([ne, "label"]), me = ne === "normal", ve = me ? N : N.ensureState(ne), Be = e3.getFormattedLabel(j, ne);
        me && (Be = Be || u.node.name), ve.style = ov(ce, {}, null, ne !== "normal", true), Be && (ve.style.text = Be);
        var Oe = ce.get("show");
        Oe != null && !me && (ve.ignore = !Oe);
        var We = te(ce, "position"), Ue = me ? P : P.states[ne], qe = Ue.style.fill;
        Ue.textConfig = { outsideFill: ce.get("color") === "inherit" ? qe : null, inside: We !== "outside" };
        var Ze, ct = te(ce, "distance") || 0, _t = te(ce, "align");
        We === "outside" ? (Ze = m3.r + ct, _t = C > Math.PI / 2 ? "right" : "left") : !_t || _t === "center" ? (x3 === 2 * Math.PI && m3.r0 === 0 ? Ze = 0 : Ze = (m3.r + m3.r0) / 2, _t = "center") : _t === "left" ? (Ze = m3.r0 + ct, C > Math.PI / 2 && (_t = "right")) : _t === "right" && (Ze = m3.r - ct, C > Math.PI / 2 && (_t = "left")), ve.style.align = _t, ve.style.verticalAlign = te(ce, "verticalAlign") || "middle", ve.x = Ze * A2 + m3.cx, ve.y = Ze * D + m3.cy;
        var pt = te(ce, "rotate"), zt = 0;
        pt === "radial" ? (zt = -C, zt < -Math.PI / 2 && (zt += Math.PI)) : pt === "tangential" ? (zt = Math.PI / 2 - C, zt > Math.PI / 2 ? zt -= Math.PI : zt < -Math.PI / 2 && (zt += Math.PI)) : Vc(pt) && (zt = pt * Math.PI / 180), ve.rotation = zt;
      });
      function te(ne, ce) {
        var me = ne.get(ce);
        return me == null ? v4.get(ce) : me;
      }
      N.dirtyStyle();
    }, r3;
  }(S_), Zat = nSn, Bke = "sunburstRootToNode", Jat = "sunburstHighlight", rSn = "sunburstUnhighlight";
  function iSn(l3) {
    l3.registerAction({ type: Bke, update: "updateView" }, function(r3, e3) {
      e3.eachComponent({ mainType: "series", subType: "sunburst", query: r3 }, u);
      function u(h, v4) {
        var m3 = mJ(r3, [Bke], h);
        if (m3) {
          var x3 = h.getViewRoot();
          x3 && (r3.direction = jOe(x3, m3.node) ? "rollUp" : "drillDown"), h.resetViewRoot(m3.node);
        }
      }
    }), l3.registerAction({ type: Jat, update: "none" }, function(r3, e3, u) {
      r3 = fi({}, r3), e3.eachComponent({ mainType: "series", subType: "sunburst", query: r3 }, h);
      function h(v4) {
        var m3 = mJ(r3, [Jat], v4);
        m3 && (r3.dataIndex = m3.node.dataIndex);
      }
      u.dispatchAction(fi(r3, { type: "highlight" }));
    }), l3.registerAction({ type: rSn, update: "updateView" }, function(r3, e3, u) {
      r3 = fi({}, r3), u.dispatchAction(fi(r3, { type: "downplay" }));
    });
  }
  var aSn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      var m3 = this;
      this.seriesModel = e3, this.api = h, this.ecModel = u;
      var x3 = e3.getData(), C = x3.tree.root, A2 = e3.getViewRoot(), D = this.group, P = e3.get("renderLabelForZeroData"), N = [];
      A2.eachNode(function(ce) {
        N.push(ce);
      });
      var j = this._oldChildren || [];
      W(N, j), ne(C, A2), this._initEvents(), this._oldChildren = N;
      function W(ce, me) {
        if (ce.length === 0 && me.length === 0)
          return;
        new f5(me, ce, ve, ve).add(Be).update(Be).remove(Fs(Be, null)).execute();
        function ve(Oe) {
          return Oe.getId();
        }
        function Be(Oe, We) {
          var Ue = Oe == null ? null : ce[Oe], qe = We == null ? null : me[We];
          K(Ue, qe);
        }
      }
      function K(ce, me) {
        if (!P && ce && !ce.getValue() && (ce = null), ce !== C && me !== C) {
          if (me && me.piece)
            ce ? (me.piece.updateData(false, ce, e3, u, h), x3.setItemGraphicEl(ce.dataIndex, me.piece)) : te(me);
          else if (ce) {
            var ve = new Zat(ce, e3, u, h);
            D.add(ve), x3.setItemGraphicEl(ce.dataIndex, ve);
          }
        }
      }
      function te(ce) {
        !ce || ce.piece && (D.remove(ce.piece), ce.piece = null);
      }
      function ne(ce, me) {
        me.depth > 0 ? (m3.virtualPiece ? m3.virtualPiece.updateData(false, ce, e3, u, h) : (m3.virtualPiece = new Zat(ce, e3, u, h), D.add(m3.virtualPiece)), me.piece.off("click"), m3.virtualPiece.on("click", function(ve) {
          m3._rootToNode(me.parentNode);
        })) : m3.virtualPiece && (D.remove(m3.virtualPiece), m3.virtualPiece = null);
      }
    }, r3.prototype._initEvents = function() {
      var e3 = this;
      this.group.off("click"), this.group.on("click", function(u) {
        var h = false, v4 = e3.seriesModel.getViewRoot();
        v4.eachNode(function(m3) {
          if (!h && m3.piece && m3.piece === u.target) {
            var x3 = m3.getModel().get("nodeClick");
            if (x3 === "rootToNode")
              e3._rootToNode(m3);
            else if (x3 === "link") {
              var C = m3.getModel(), A2 = C.get("link");
              if (A2) {
                var D = C.get("target", true) || "_blank";
                Qfe(A2, D);
              }
            }
            h = true;
          }
        });
      });
    }, r3.prototype._rootToNode = function(e3) {
      e3 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: Bke, from: this.uid, seriesId: this.seriesModel.id, targetNode: e3 });
    }, r3.prototype.containPoint = function(e3, u) {
      var h = u.getData(), v4 = h.getItemLayout(0);
      if (v4) {
        var m3 = e3[0] - v4.cx, x3 = e3[1] - v4.cy, C = Math.sqrt(m3 * m3 + x3 * x3);
        return C <= v4.r && C >= v4.r0;
      }
    }, r3.type = "sunburst", r3;
  }(zh), oSn = aSn, sSn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.ignoreStyleOnData = true, e3;
    }
    return r3.prototype.getInitialData = function(e3, u) {
      var h = { name: e3.name, children: e3.data };
      kdt(h);
      var v4 = this._levelModels = Bi(e3.levels || [], function(C) {
        return new Bh(C, this, u);
      }, this), m3 = zOe.createTree(h, this, x3);
      function x3(C) {
        C.wrapMethod("getItemModel", function(A2, D) {
          var P = m3.getNodeByDataIndex(D), N = v4[P.depth];
          return N && (A2.parentModel = N), A2;
        });
      }
      return m3.data;
    }, r3.prototype.optionUpdated = function() {
      this.resetViewRoot();
    }, r3.prototype.getDataParams = function(e3) {
      var u = l3.prototype.getDataParams.apply(this, arguments), h = this.getData().tree.getNodeByDataIndex(e3);
      return u.treePathInfo = mpe(h, this), u;
    }, r3.prototype.getLevelModel = function(e3) {
      return this._levelModels && this._levelModels[e3.depth];
    }, r3.prototype.getViewRoot = function() {
      return this._viewRoot;
    }, r3.prototype.resetViewRoot = function(e3) {
      e3 ? this._viewRoot = e3 : e3 = this._viewRoot;
      var u = this.getRawData().tree.root;
      (!e3 || e3 !== u && !u.contains(e3)) && (this._viewRoot = u);
    }, r3.prototype.enableAriaDecal = function() {
      Lpt(this);
    }, r3.type = "series.sunburst", r3.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, r3;
  }(Fp);
  function kdt(l3) {
    var r3 = 0;
    mt(l3.children, function(u) {
      kdt(u);
      var h = u.value;
      Ni(h) && (h = h[0]), r3 += h;
    });
    var e3 = l3.value;
    Ni(e3) && (e3 = e3[0]), (e3 == null || isNaN(e3)) && (e3 = r3), e3 < 0 && (e3 = 0), Ni(l3.value) ? l3.value[0] = e3 : l3.value = e3;
  }
  var lSn = sSn, Qat = Math.PI / 180;
  function uSn(l3, r3, e3) {
    r3.eachSeriesByType(l3, function(u) {
      var h = u.get("center"), v4 = u.get("radius");
      Ni(v4) || (v4 = [0, v4]), Ni(h) || (h = [h, h]);
      var m3 = e3.getWidth(), x3 = e3.getHeight(), C = Math.min(m3, x3), A2 = za(h[0], m3), D = za(h[1], x3), P = za(v4[0], C / 2), N = za(v4[1], C / 2), j = -u.get("startAngle") * Qat, W = u.get("minAngle") * Qat, K = u.getData().tree.root, te = u.getViewRoot(), ne = te.depth, ce = u.get("sort");
      ce != null && Odt(te, ce);
      var me = 0;
      mt(te.children, function(Ft) {
        !isNaN(Ft.getValue()) && me++;
      });
      var ve = te.getValue(), Be = Math.PI / (ve || me) * 2, Oe = te.depth > 0, We = te.height - (Oe ? -1 : 1), Ue = (N - P) / (We || 1), qe = u.get("clockwise"), Ze = u.get("stillShowZeroSum"), ct = qe ? 1 : -1, _t = function(Ft, Kn) {
        if (!!Ft) {
          var hn = Kn;
          if (Ft !== K) {
            var xn = Ft.getValue(), zn = ve === 0 && Ze ? Be : xn * Be;
            zn < W && (zn = W), hn = Kn + ct * zn;
            var or = Ft.depth - ne - (Oe ? -1 : 1), vr = P + Ue * or, la = P + Ue * (or + 1), Ba = u.getLevelModel(Ft);
            if (Ba) {
              var Lo = Ba.get("r0", true), Ao = Ba.get("r", true), oo = Ba.get("radius", true);
              oo != null && (Lo = oo[0], Ao = oo[1]), Lo != null && (vr = za(Lo, C / 2)), Ao != null && (la = za(Ao, C / 2));
            }
            Ft.setLayout({ angle: zn, startAngle: Kn, endAngle: hn, clockwise: qe, cx: A2, cy: D, r0: vr, r: la });
          }
          if (Ft.children && Ft.children.length) {
            var Pa = 0;
            mt(Ft.children, function(fo) {
              Pa += _t(fo, Kn + Pa);
            });
          }
          return hn - Kn;
        }
      };
      if (Oe) {
        var pt = P, zt = P + Ue, Zt = Math.PI * 2;
        K.setLayout({ angle: Zt, startAngle: j, endAngle: j + Zt, clockwise: qe, cx: A2, cy: D, r0: pt, r: zt });
      }
      _t(te, j);
    });
  }
  function Odt(l3, r3) {
    var e3 = l3.children || [];
    l3.children = cSn(e3, r3), e3.length && mt(l3.children, function(u) {
      Odt(u, r3);
    });
  }
  function cSn(l3, r3) {
    if (Xo(r3)) {
      var e3 = Bi(l3, function(h, v4) {
        var m3 = h.getValue();
        return { params: { depth: h.depth, height: h.height, dataIndex: h.dataIndex, getValue: function() {
          return m3;
        } }, index: v4 };
      });
      return e3.sort(function(h, v4) {
        return r3(h.params, v4.params);
      }), Bi(e3, function(h) {
        return l3[h.index];
      });
    } else {
      var u = r3 === "asc";
      return l3.sort(function(h, v4) {
        var m3 = (h.getValue() - v4.getValue()) * (u ? 1 : -1);
        return m3 === 0 ? (h.dataIndex - v4.dataIndex) * (u ? -1 : 1) : m3;
      });
    }
  }
  function fSn(l3) {
    var r3 = {};
    function e3(u, h, v4) {
      for (var m3 = u; m3 && m3.depth > 1; )
        m3 = m3.parentNode;
      var x3 = h.getColorFromPalette(m3.name || m3.dataIndex + "", r3);
      return u.depth > 1 && qa(x3) && (x3 = k5e(x3, (u.depth - 1) / (v4 - 1) * 0.5)), x3;
    }
    l3.eachSeriesByType("sunburst", function(u) {
      var h = u.getData(), v4 = h.tree;
      v4.eachNode(function(m3) {
        var x3 = m3.getModel(), C = x3.getModel("itemStyle").getItemStyle();
        C.fill || (C.fill = e3(m3, u, v4.root.height));
        var A2 = h.ensureUniqueItemVisual(m3.dataIndex, "style");
        fi(A2, C);
      });
    });
  }
  function hSn(l3) {
    l3.registerChartView(oSn), l3.registerSeriesModel(lSn), l3.registerLayout(Fs(uSn, "sunburst")), l3.registerProcessor(Fs(qJ, "sunburst")), l3.registerVisual(fSn), iSn(l3);
  }
  var eot = { color: "fill", borderColor: "stroke" }, pSn = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, o5 = pc(), dSn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.optionUpdated = function() {
      this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
    }, r3.prototype.getInitialData = function(e3, u) {
      return v5(null, this);
    }, r3.prototype.getDataParams = function(e3, u, h) {
      var v4 = l3.prototype.getDataParams.call(this, e3, u);
      return h && (v4.info = o5(h).info), v4;
    }, r3.type = "series.custom", r3.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], r3.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, r3;
  }(Fp), vSn = dSn;
  function gSn(l3, r3) {
    return r3 = r3 || [0, 0], Bi(["x", "y"], function(e3, u) {
      var h = this.getAxis(e3), v4 = r3[u], m3 = l3[u] / 2;
      return h.type === "category" ? h.getBandWidth() : Math.abs(h.dataToCoord(v4 - m3) - h.dataToCoord(v4 + m3));
    }, this);
  }
  function ySn(l3) {
    var r3 = l3.master.getRect();
    return { coordSys: { type: "cartesian2d", x: r3.x, y: r3.y, width: r3.width, height: r3.height }, api: { coord: function(e3) {
      return l3.dataToPoint(e3);
    }, size: no(gSn, l3) } };
  }
  function mSn(l3, r3) {
    return r3 = r3 || [0, 0], Bi([0, 1], function(e3) {
      var u = r3[e3], h = l3[e3] / 2, v4 = [], m3 = [];
      return v4[e3] = u - h, m3[e3] = u + h, v4[1 - e3] = m3[1 - e3] = r3[1 - e3], Math.abs(this.dataToPoint(v4)[e3] - this.dataToPoint(m3)[e3]);
    }, this);
  }
  function bSn(l3) {
    var r3 = l3.getBoundingRect();
    return { coordSys: { type: "geo", x: r3.x, y: r3.y, width: r3.width, height: r3.height, zoom: l3.getZoom() }, api: { coord: function(e3) {
      return l3.dataToPoint(e3);
    }, size: no(mSn, l3) } };
  }
  function _Sn(l3, r3) {
    var e3 = this.getAxis(), u = r3 instanceof Array ? r3[0] : r3, h = (l3 instanceof Array ? l3[0] : l3) / 2;
    return e3.type === "category" ? e3.getBandWidth() : Math.abs(e3.dataToCoord(u - h) - e3.dataToCoord(u + h));
  }
  function xSn(l3) {
    var r3 = l3.getRect();
    return { coordSys: { type: "singleAxis", x: r3.x, y: r3.y, width: r3.width, height: r3.height }, api: { coord: function(e3) {
      return l3.dataToPoint(e3);
    }, size: no(_Sn, l3) } };
  }
  function wSn(l3, r3) {
    return r3 = r3 || [0, 0], Bi(["Radius", "Angle"], function(e3, u) {
      var h = "get" + e3 + "Axis", v4 = this[h](), m3 = r3[u], x3 = l3[u] / 2, C = v4.type === "category" ? v4.getBandWidth() : Math.abs(v4.dataToCoord(m3 - x3) - v4.dataToCoord(m3 + x3));
      return e3 === "Angle" && (C = C * Math.PI / 180), C;
    }, this);
  }
  function SSn(l3) {
    var r3 = l3.getRadiusAxis(), e3 = l3.getAngleAxis(), u = r3.getExtent();
    return u[0] > u[1] && u.reverse(), { coordSys: { type: "polar", cx: l3.cx, cy: l3.cy, r: u[1], r0: u[0] }, api: { coord: function(h) {
      var v4 = r3.dataToRadius(h[0]), m3 = e3.dataToAngle(h[1]), x3 = l3.coordToPoint([v4, m3]);
      return x3.push(v4, m3 * Math.PI / 180), x3;
    }, size: no(wSn, l3) } };
  }
  function CSn(l3) {
    var r3 = l3.getRect(), e3 = l3.getRangeInfo();
    return { coordSys: { type: "calendar", x: r3.x, y: r3.y, width: r3.width, height: r3.height, cellWidth: l3.getCellWidth(), cellHeight: l3.getCellHeight(), rangeInfo: { start: e3.start, end: e3.end, weeks: e3.weeks, dayCount: e3.allDay } }, api: { coord: function(u, h) {
      return l3.dataToPoint(u, h);
    } } };
  }
  function Pdt(l3, r3, e3, u) {
    return l3 && (l3.legacy || l3.legacy !== false && !e3 && !u && r3 !== "tspan" && (r3 === "text" || vo(l3, "text")));
  }
  function Ldt(l3, r3, e3) {
    var u = l3, h, v4, m3;
    if (r3 === "text")
      m3 = u;
    else {
      m3 = {}, vo(u, "text") && (m3.text = u.text), vo(u, "rich") && (m3.rich = u.rich), vo(u, "textFill") && (m3.fill = u.textFill), vo(u, "textStroke") && (m3.stroke = u.textStroke), vo(u, "fontFamily") && (m3.fontFamily = u.fontFamily), vo(u, "fontSize") && (m3.fontSize = u.fontSize), vo(u, "fontStyle") && (m3.fontStyle = u.fontStyle), vo(u, "fontWeight") && (m3.fontWeight = u.fontWeight), v4 = { type: "text", style: m3, silent: true }, h = {};
      var x3 = vo(u, "textPosition");
      e3 ? h.position = x3 ? u.textPosition : "inside" : x3 && (h.position = u.textPosition), vo(u, "textPosition") && (h.position = u.textPosition), vo(u, "textOffset") && (h.offset = u.textOffset), vo(u, "textRotation") && (h.rotation = u.textRotation), vo(u, "textDistance") && (h.distance = u.textDistance);
    }
    return tot(m3, l3), mt(m3.rich, function(C) {
      tot(C, C);
    }), { textConfig: h, textContent: v4 };
  }
  function tot(l3, r3) {
    !r3 || (r3.font = r3.textFont || r3.font, vo(r3, "textStrokeWidth") && (l3.lineWidth = r3.textStrokeWidth), vo(r3, "textAlign") && (l3.align = r3.textAlign), vo(r3, "textVerticalAlign") && (l3.verticalAlign = r3.textVerticalAlign), vo(r3, "textLineHeight") && (l3.lineHeight = r3.textLineHeight), vo(r3, "textWidth") && (l3.width = r3.textWidth), vo(r3, "textHeight") && (l3.height = r3.textHeight), vo(r3, "textBackgroundColor") && (l3.backgroundColor = r3.textBackgroundColor), vo(r3, "textPadding") && (l3.padding = r3.textPadding), vo(r3, "textBorderColor") && (l3.borderColor = r3.textBorderColor), vo(r3, "textBorderWidth") && (l3.borderWidth = r3.textBorderWidth), vo(r3, "textBorderRadius") && (l3.borderRadius = r3.textBorderRadius), vo(r3, "textBoxShadowColor") && (l3.shadowColor = r3.textBoxShadowColor), vo(r3, "textBoxShadowBlur") && (l3.shadowBlur = r3.textBoxShadowBlur), vo(r3, "textBoxShadowOffsetX") && (l3.shadowOffsetX = r3.textBoxShadowOffsetX), vo(r3, "textBoxShadowOffsetY") && (l3.shadowOffsetY = r3.textBoxShadowOffsetY));
  }
  function not(l3, r3, e3) {
    var u = l3;
    u.textPosition = u.textPosition || e3.position || "inside", e3.offset != null && (u.textOffset = e3.offset), e3.rotation != null && (u.textRotation = e3.rotation), e3.distance != null && (u.textDistance = e3.distance);
    var h = u.textPosition.indexOf("inside") >= 0, v4 = l3.fill || "#000";
    rot(u, r3);
    var m3 = u.textFill == null;
    return h ? m3 && (u.textFill = e3.insideFill || "#fff", !u.textStroke && e3.insideStroke && (u.textStroke = e3.insideStroke), !u.textStroke && (u.textStroke = v4), u.textStrokeWidth == null && (u.textStrokeWidth = 2)) : (m3 && (u.textFill = l3.fill || e3.outsideFill || "#000"), !u.textStroke && e3.outsideStroke && (u.textStroke = e3.outsideStroke)), u.text = r3.text, u.rich = r3.rich, mt(r3.rich, function(x3) {
      rot(x3, x3);
    }), u;
  }
  function rot(l3, r3) {
    !r3 || (vo(r3, "fill") && (l3.textFill = r3.fill), vo(r3, "stroke") && (l3.textStroke = r3.fill), vo(r3, "lineWidth") && (l3.textStrokeWidth = r3.lineWidth), vo(r3, "font") && (l3.font = r3.font), vo(r3, "fontStyle") && (l3.fontStyle = r3.fontStyle), vo(r3, "fontWeight") && (l3.fontWeight = r3.fontWeight), vo(r3, "fontSize") && (l3.fontSize = r3.fontSize), vo(r3, "fontFamily") && (l3.fontFamily = r3.fontFamily), vo(r3, "align") && (l3.textAlign = r3.align), vo(r3, "verticalAlign") && (l3.textVerticalAlign = r3.verticalAlign), vo(r3, "lineHeight") && (l3.textLineHeight = r3.lineHeight), vo(r3, "width") && (l3.textWidth = r3.width), vo(r3, "height") && (l3.textHeight = r3.height), vo(r3, "backgroundColor") && (l3.textBackgroundColor = r3.backgroundColor), vo(r3, "padding") && (l3.textPadding = r3.padding), vo(r3, "borderColor") && (l3.textBorderColor = r3.borderColor), vo(r3, "borderWidth") && (l3.textBorderWidth = r3.borderWidth), vo(r3, "borderRadius") && (l3.textBorderRadius = r3.borderRadius), vo(r3, "shadowColor") && (l3.textBoxShadowColor = r3.shadowColor), vo(r3, "shadowBlur") && (l3.textBoxShadowBlur = r3.shadowBlur), vo(r3, "shadowOffsetX") && (l3.textBoxShadowOffsetX = r3.shadowOffsetX), vo(r3, "shadowOffsetY") && (l3.textBoxShadowOffsetY = r3.shadowOffsetY), vo(r3, "textShadowColor") && (l3.textShadowColor = r3.textShadowColor), vo(r3, "textShadowBlur") && (l3.textShadowBlur = r3.textShadowBlur), vo(r3, "textShadowOffsetX") && (l3.textShadowOffsetX = r3.textShadowOffsetX), vo(r3, "textShadowOffsetY") && (l3.textShadowOffsetY = r3.textShadowOffsetY));
  }
  var Rdt = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, iot = yu(Rdt);
  WA(qA, function(l3, r3) {
    return l3[r3] = 1, l3;
  }, {});
  qA.join(", ");
  var _he = ["", "style", "shape", "extra"], yj = pc();
  function tPe(l3, r3, e3, u, h) {
    var v4 = l3 + "Animation", m3 = Sj(l3, u, h) || {}, x3 = yj(r3).userDuring;
    return m3.duration > 0 && (m3.during = x3 ? no(ESn, { el: r3, userDuring: x3 }) : null, m3.setToFinal = true, m3.scope = l3), fi(m3, e3[v4]), m3;
  }
  function kfe(l3, r3, e3, u) {
    u = u || {};
    var h = u.dataIndex, v4 = u.isInit, m3 = u.clearStyle, x3 = e3.isAnimationEnabled(), C = yj(l3), A2 = r3.style;
    C.userDuring = r3.during;
    var D = {}, P = {};
    if (kSn(l3, r3, P), oot("shape", r3, P), oot("extra", r3, P), !v4 && x3 && (DSn(l3, r3, D), aot("shape", l3, r3, D), aot("extra", l3, r3, D), OSn(l3, r3, A2, D)), P.style = A2, MSn(l3, P, m3), ASn(l3, r3), x3)
      if (v4) {
        var N = {};
        mt(_he, function(W) {
          var K = W ? r3[W] : r3;
          K && K.enterFrom && (W && (N[W] = N[W] || {}), fi(W ? N[W] : N, K.enterFrom));
        });
        var j = tPe("enter", l3, r3, e3, h);
        j.duration > 0 && l3.animateFrom(N, j);
      } else
        TSn(l3, r3, h || 0, e3, D);
    Ndt(l3, r3), A2 ? l3.dirty() : l3.markRedraw();
  }
  function Ndt(l3, r3) {
    for (var e3 = yj(l3).leaveToProps, u = 0; u < _he.length; u++) {
      var h = _he[u], v4 = h ? r3[h] : r3;
      v4 && v4.leaveTo && (e3 || (e3 = yj(l3).leaveToProps = {}), h && (e3[h] = e3[h] || {}), fi(h ? e3[h] : e3, v4.leaveTo));
    }
  }
  function xpe(l3, r3, e3, u) {
    if (l3) {
      var h = l3.parent, v4 = yj(l3).leaveToProps;
      if (v4) {
        var m3 = tPe("update", l3, r3, e3, 0);
        m3.done = function() {
          h.remove(l3), u && u();
        }, l3.animateTo(v4, m3);
      } else
        h.remove(l3), u && u();
    }
  }
  function GN(l3) {
    return l3 === "all";
  }
  function MSn(l3, r3, e3) {
    var u = r3.style;
    if (!l3.isGroup && u) {
      if (e3) {
        l3.useStyle({});
        for (var h = l3.animators, v4 = 0; v4 < h.length; v4++) {
          var m3 = h[v4];
          m3.targetName === "style" && m3.changeTarget(l3.style);
        }
      }
      l3.setStyle(u);
    }
    r3 && (r3.style = null, r3 && l3.attr(r3), r3.style = u);
  }
  function TSn(l3, r3, e3, u, h) {
    if (h) {
      var v4 = tPe("update", l3, r3, u, e3);
      v4.duration > 0 && l3.animateFrom(h, v4);
    }
  }
  function ASn(l3, r3) {
    vo(r3, "silent") && (l3.silent = r3.silent), vo(r3, "ignore") && (l3.ignore = r3.ignore), l3 instanceof x2 && vo(r3, "invisible") && (l3.invisible = r3.invisible), l3 instanceof Nl && vo(r3, "autoBatch") && (l3.autoBatch = r3.autoBatch);
  }
  var kA = {}, ISn = { setTransform: function(l3, r3) {
    return kA.el[l3] = r3, this;
  }, getTransform: function(l3) {
    return kA.el[l3];
  }, setShape: function(l3, r3) {
    var e3 = kA.el, u = e3.shape || (e3.shape = {});
    return u[l3] = r3, e3.dirtyShape && e3.dirtyShape(), this;
  }, getShape: function(l3) {
    var r3 = kA.el.shape;
    if (r3)
      return r3[l3];
  }, setStyle: function(l3, r3) {
    var e3 = kA.el, u = e3.style;
    return u && (u[l3] = r3, e3.dirtyStyle && e3.dirtyStyle()), this;
  }, getStyle: function(l3) {
    var r3 = kA.el.style;
    if (r3)
      return r3[l3];
  }, setExtra: function(l3, r3) {
    var e3 = kA.el.extra || (kA.el.extra = {});
    return e3[l3] = r3, this;
  }, getExtra: function(l3) {
    var r3 = kA.el.extra;
    if (r3)
      return r3[l3];
  } };
  function ESn() {
    var l3 = this, r3 = l3.el;
    if (!!r3) {
      var e3 = yj(r3).userDuring, u = l3.userDuring;
      if (e3 !== u) {
        l3.el = l3.userDuring = null;
        return;
      }
      kA.el = r3, u(ISn);
    }
  }
  function aot(l3, r3, e3, u) {
    var h = e3[l3];
    if (!!h) {
      var v4 = r3[l3], m3;
      if (v4) {
        var x3 = e3.transition, C = h.transition;
        if (C)
          if (!m3 && (m3 = u[l3] = {}), GN(C))
            fi(m3, v4);
          else
            for (var A2 = Gf(C), D = 0; D < A2.length; D++) {
              var P = A2[D], N = v4[P];
              m3[P] = N;
            }
        else if (GN(x3) || Cl(x3, l3) >= 0) {
          !m3 && (m3 = u[l3] = {});
          for (var j = yu(v4), D = 0; D < j.length; D++) {
            var P = j[D], N = v4[P];
            PSn(h[P], N) && (m3[P] = N);
          }
        }
      }
    }
  }
  function oot(l3, r3, e3) {
    var u = r3[l3];
    if (!!u)
      for (var h = e3[l3] = {}, v4 = yu(u), m3 = 0; m3 < v4.length; m3++) {
        var x3 = v4[m3];
        h[x3] = LZ(u[x3]);
      }
  }
  function DSn(l3, r3, e3) {
    for (var u = r3.transition, h = GN(u) ? qA : Gf(u || []), v4 = 0; v4 < h.length; v4++) {
      var m3 = h[v4];
      if (!(m3 === "style" || m3 === "shape" || m3 === "extra")) {
        var x3 = l3[m3];
        e3[m3] = x3;
      }
    }
  }
  function kSn(l3, r3, e3) {
    for (var u = 0; u < iot.length; u++) {
      var h = iot[u], v4 = Rdt[h], m3 = r3[h];
      m3 && (e3[v4[0]] = m3[0], e3[v4[1]] = m3[1]);
    }
    for (var u = 0; u < qA.length; u++) {
      var x3 = qA[u];
      r3[x3] != null && (e3[x3] = r3[x3]);
    }
  }
  function OSn(l3, r3, e3, u) {
    if (!!e3) {
      var h = l3.style, v4;
      if (h) {
        var m3 = e3.transition, x3 = r3.transition;
        if (m3 && !GN(m3)) {
          var C = Gf(m3);
          !v4 && (v4 = u.style = {});
          for (var A2 = 0; A2 < C.length; A2++) {
            var D = C[A2], P = h[D];
            v4[D] = P;
          }
        } else if (l3.getAnimationStyleProps && (GN(x3) || GN(m3) || Cl(x3, "style") >= 0)) {
          var N = l3.getAnimationStyleProps(), j = N ? N.style : null;
          if (j) {
            !v4 && (v4 = u.style = {});
            for (var W = yu(e3), A2 = 0; A2 < W.length; A2++) {
              var D = W[A2];
              if (j[D]) {
                var P = h[D];
                v4[D] = P;
              }
            }
          }
        }
      }
    }
  }
  function PSn(l3, r3) {
    return m1(l3) ? l3 !== r3 : l3 != null && isFinite(l3);
  }
  var Fdt = pc(), LSn = ["percent", "easing", "shape", "style", "extra"];
  function Vdt(l3) {
    l3.stopAnimation("keyframe"), l3.attr(Fdt(l3));
  }
  function xhe(l3, r3, e3) {
    if (!(!e3.isAnimationEnabled() || !r3)) {
      if (Ni(r3)) {
        mt(r3, function(x3) {
          xhe(l3, x3, e3);
        });
        return;
      }
      var u = r3.keyframes, h = r3.duration;
      if (e3 && h == null) {
        var v4 = Sj("enter", e3, 0);
        h = v4 && v4.duration;
      }
      if (!(!u || !h)) {
        var m3 = Fdt(l3);
        mt(_he, function(x3) {
          if (!(x3 && !l3[x3])) {
            var C;
            u.sort(function(A2, D) {
              return A2.percent - D.percent;
            }), mt(u, function(A2) {
              var D = l3.animators, P = x3 ? A2[x3] : A2;
              if (!!P) {
                var N = yu(P);
                if (x3 || (N = jf(N, function(K) {
                  return Cl(LSn, K) < 0;
                })), !!N.length) {
                  C || (C = l3.animate(x3, r3.loop, true), C.scope = "keyframe");
                  for (var j = 0; j < D.length; j++)
                    D[j] !== C && D[j].targetName === C.targetName && D[j].stopTracks(N);
                  x3 && (m3[x3] = m3[x3] || {});
                  var W = x3 ? m3[x3] : m3;
                  mt(N, function(K) {
                    W[K] = ((x3 ? l3[x3] : l3) || {})[K];
                  }), C.whenWithKeys(h * A2.percent, P, N, A2.easing);
                }
              }
            }), C && C.delay(r3.delay || 0).duration(h).start(r3.easing);
          }
        });
      }
    }
  }
  var s5 = "emphasis", HO = "normal", nPe = "blur", rPe = "select", rP = [HO, s5, nPe, rPe], NDe = { normal: ["itemStyle"], emphasis: [s5, "itemStyle"], blur: [nPe, "itemStyle"], select: [rPe, "itemStyle"] }, FDe = { normal: ["label"], emphasis: [s5, "label"], blur: [nPe, "label"], select: [rPe, "label"] }, RSn = ["x", "y"], NSn = "e\0\0", i2 = { normal: {}, emphasis: {}, blur: {}, select: {} }, FSn = { cartesian2d: ySn, geo: bSn, singleAxis: xSn, polar: SSn, calendar: CSn };
  function zke(l3) {
    return l3 instanceof Nl;
  }
  function jke(l3) {
    return l3 instanceof x2;
  }
  function VSn(l3, r3) {
    r3.copyTransform(l3), jke(r3) && jke(l3) && (r3.setStyle(l3.style), r3.z = l3.z, r3.z2 = l3.z2, r3.zlevel = l3.zlevel, r3.invisible = l3.invisible, r3.ignore = l3.ignore, zke(r3) && zke(l3) && r3.setShape(l3.shape));
  }
  var BSn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      this._progressiveEls = null;
      var m3 = this._data, x3 = e3.getData(), C = this.group, A2 = sot(e3, x3, u, h);
      m3 || C.removeAll(), x3.diff(m3).add(function(P) {
        VDe(h, null, P, A2(P, v4), e3, C, x3);
      }).remove(function(P) {
        var N = m3.getItemGraphicEl(P);
        xpe(N, o5(N).option, e3);
      }).update(function(P, N) {
        var j = m3.getItemGraphicEl(N);
        VDe(h, j, P, A2(P, v4), e3, C, x3);
      }).execute();
      var D = e3.get("clip", true) ? vpe(e3.coordinateSystem, false, e3) : null;
      D ? C.setClipPath(D) : C.removeClipPath(), this._data = x3;
    }, r3.prototype.incrementalPrepareRender = function(e3, u, h) {
      this.group.removeAll(), this._data = null;
    }, r3.prototype.incrementalRender = function(e3, u, h, v4, m3) {
      var x3 = u.getData(), C = sot(u, x3, h, v4), A2 = this._progressiveEls = [];
      function D(j) {
        j.isGroup || (j.incremental = true, j.ensureState("emphasis").hoverLayer = true);
      }
      for (var P = e3.start; P < e3.end; P++) {
        var N = VDe(null, null, P, C(P, m3), u, this.group, x3);
        N && (N.traverse(D), A2.push(N));
      }
    }, r3.prototype.eachRendered = function(e3) {
      oP(this._progressiveEls || this.group, e3);
    }, r3.prototype.filterForExposedEvent = function(e3, u, h, v4) {
      var m3 = u.element;
      if (m3 == null || h.name === m3)
        return true;
      for (; (h = h.__hostTarget || h.parent) && h !== this.group; )
        if (h.name === m3)
          return true;
      return false;
    }, r3.type = "custom", r3;
  }(zh), zSn = BSn;
  function iPe(l3) {
    var r3 = l3.type, e3;
    if (r3 === "path") {
      var u = l3.shape, h = u.width != null && u.height != null ? { x: u.x || 0, y: u.y || 0, width: u.width, height: u.height } : null, v4 = jdt(u);
      e3 = Zhe(v4, null, h, u.layout || "center"), o5(e3).customPathData = v4;
    } else if (r3 === "image")
      e3 = new lm({}), o5(e3).customImagePath = l3.style.image;
    else if (r3 === "text")
      e3 = new Ec({});
    else if (r3 === "group")
      e3 = new Cs();
    else {
      if (r3 === "compoundPath")
        throw new Error('"compoundPath" is not supported yet.');
      var m3 = Y3e(r3);
      if (!m3) {
        var x3 = "";
        Xc(x3);
      }
      e3 = new m3();
    }
    return o5(e3).customGraphicType = r3, e3.name = l3.name, e3.z2EmphasisLift = 1, e3.z2SelectLift = 1, e3;
  }
  function aPe(l3, r3, e3, u, h, v4, m3) {
    Vdt(r3);
    var x3 = h && h.normal.cfg;
    x3 && r3.setTextConfig(x3), u && u.transition == null && (u.transition = RSn);
    var C = u && u.style;
    if (C) {
      if (r3.type === "text") {
        var A2 = C;
        vo(A2, "textFill") && (A2.fill = A2.textFill), vo(A2, "textStroke") && (A2.stroke = A2.textStroke);
      }
      var D = void 0, P = zke(r3) ? C.decal : null;
      l3 && P && (P.dirty = true, D = pJ(P, l3)), C.__decalPattern = D;
    }
    if (jke(r3) && C) {
      var D = C.__decalPattern;
      D && (C.decal = D);
    }
    kfe(r3, u, v4, { dataIndex: e3, isInit: m3, clearStyle: true }), xhe(r3, u.keyframeAnimation, v4);
  }
  function Bdt(l3, r3, e3, u, h) {
    var v4 = r3.isGroup ? null : r3, m3 = h && h[l3].cfg;
    if (v4) {
      var x3 = v4.ensureState(l3);
      if (u === false) {
        var C = v4.getState(l3);
        C && (C.style = null);
      } else
        x3.style = u || null;
      m3 && (x3.textConfig = m3), qN(v4);
    }
  }
  function jSn(l3, r3, e3) {
    if (!l3.isGroup) {
      var u = l3, h = e3.currentZ, v4 = e3.currentZLevel;
      u.z = h, u.zlevel = v4;
      var m3 = r3.z2;
      m3 != null && (u.z2 = m3 || 0);
      for (var x3 = 0; x3 < rP.length; x3++)
        GSn(u, r3, rP[x3]);
    }
  }
  function GSn(l3, r3, e3) {
    var u = e3 === HO, h = u ? r3 : whe(r3, e3), v4 = h ? h.z2 : null, m3;
    v4 != null && (m3 = u ? l3 : l3.ensureState(e3), m3.z2 = v4 || 0);
  }
  function sot(l3, r3, e3, u) {
    var h = l3.get("renderItem"), v4 = l3.coordinateSystem, m3 = {};
    v4 && (m3 = v4.prepareCustoms ? v4.prepareCustoms(v4) : FSn[v4.type](v4));
    for (var x3 = ns({ getWidth: u.getWidth, getHeight: u.getHeight, getZr: u.getZr, getDevicePixelRatio: u.getDevicePixelRatio, value: ve, style: Oe, ordinalRawValue: Be, styleEmphasis: We, visual: Ze, barLayout: ct, currentSeriesIndices: _t, font: pt }, m3.api || {}), C = { context: {}, seriesId: l3.id, seriesName: l3.name, seriesIndex: l3.seriesIndex, coordSys: m3.coordSys, dataInsideLength: r3.count(), encode: HSn(l3.getData()) }, A2, D, P = {}, N = {}, j = {}, W = {}, K = 0; K < rP.length; K++) {
      var te = rP[K];
      j[te] = l3.getModel(NDe[te]), W[te] = l3.getModel(FDe[te]);
    }
    function ne(zt) {
      return zt === A2 ? D || (D = r3.getItemModel(zt)) : r3.getItemModel(zt);
    }
    function ce(zt, Zt) {
      return r3.hasItemOption ? zt === A2 ? P[Zt] || (P[Zt] = ne(zt).getModel(NDe[Zt])) : ne(zt).getModel(NDe[Zt]) : j[Zt];
    }
    function me(zt, Zt) {
      return r3.hasItemOption ? zt === A2 ? N[Zt] || (N[Zt] = ne(zt).getModel(FDe[Zt])) : ne(zt).getModel(FDe[Zt]) : W[Zt];
    }
    return function(zt, Zt) {
      return A2 = zt, D = null, P = {}, N = {}, h && h(ns({ dataIndexInside: zt, dataIndex: r3.getRawIndex(zt), actionType: Zt ? Zt.type : null }, C), x3);
    };
    function ve(zt, Zt) {
      return Zt == null && (Zt = A2), r3.getStore().get(r3.getDimensionIndex(zt || 0), Zt);
    }
    function Be(zt, Zt) {
      Zt == null && (Zt = A2), zt = zt || 0;
      var Ft = r3.getDimensionInfo(zt);
      if (!Ft) {
        var Kn = r3.getDimensionIndex(zt);
        return Kn >= 0 ? r3.getStore().get(Kn, Zt) : void 0;
      }
      var hn = r3.get(Ft.name, Zt), xn = Ft && Ft.ordinalMeta;
      return xn ? xn.categories[hn] : hn;
    }
    function Oe(zt, Zt) {
      Zt == null && (Zt = A2);
      var Ft = r3.getItemVisual(Zt, "style"), Kn = Ft && Ft.fill, hn = Ft && Ft.opacity, xn = ce(Zt, HO).getItemStyle();
      Kn != null && (xn.fill = Kn), hn != null && (xn.opacity = hn);
      var zn = { inheritColor: qa(Kn) ? Kn : "#000" }, or = me(Zt, HO), vr = ov(or, null, zn, false, true);
      vr.text = or.getShallow("show") ? dl(l3.getFormattedLabel(Zt, HO), dj(r3, Zt)) : null;
      var la = Zfe(or, zn, false);
      return qe(zt, xn), xn = not(xn, vr, la), zt && Ue(xn, zt), xn.legacy = true, xn;
    }
    function We(zt, Zt) {
      Zt == null && (Zt = A2);
      var Ft = ce(Zt, s5).getItemStyle(), Kn = me(Zt, s5), hn = ov(Kn, null, null, true, true);
      hn.text = Kn.getShallow("show") ? t5(l3.getFormattedLabel(Zt, s5), l3.getFormattedLabel(Zt, HO), dj(r3, Zt)) : null;
      var xn = Zfe(Kn, null, true);
      return qe(zt, Ft), Ft = not(Ft, hn, xn), zt && Ue(Ft, zt), Ft.legacy = true, Ft;
    }
    function Ue(zt, Zt) {
      for (var Ft in Zt)
        vo(Zt, Ft) && (zt[Ft] = Zt[Ft]);
    }
    function qe(zt, Zt) {
      zt && (zt.textFill && (Zt.textFill = zt.textFill), zt.textPosition && (Zt.textPosition = zt.textPosition));
    }
    function Ze(zt, Zt) {
      if (Zt == null && (Zt = A2), vo(eot, zt)) {
        var Ft = r3.getItemVisual(Zt, "style");
        return Ft ? Ft[eot[zt]] : null;
      }
      if (vo(pSn, zt))
        return r3.getItemVisual(Zt, zt);
    }
    function ct(zt) {
      if (v4.type === "cartesian2d") {
        var Zt = v4.getBaseAxis();
        return Wdn(ns({ axis: Zt }, zt));
      }
    }
    function _t() {
      return e3.getCurrentSeriesIndices();
    }
    function pt(zt) {
      return _ct(zt, e3);
    }
  }
  function HSn(l3) {
    var r3 = {};
    return mt(l3.dimensions, function(e3) {
      var u = l3.getDimensionInfo(e3);
      if (!u.isExtraCoord) {
        var h = u.coordDim, v4 = r3[h] = r3[h] || [];
        v4[u.coordDimIndex] = l3.getDimensionIndex(e3);
      }
    }), r3;
  }
  function VDe(l3, r3, e3, u, h, v4, m3) {
    if (!u) {
      v4.remove(r3);
      return;
    }
    var x3 = oPe(l3, r3, e3, u, h, v4);
    return x3 && m3.setItemGraphicEl(e3, x3), x3 && Gd(x3, u.focus, u.blurScope, u.emphasisDisabled), x3;
  }
  function oPe(l3, r3, e3, u, h, v4) {
    var m3 = -1, x3 = r3;
    r3 && zdt(r3, u, h) && (m3 = Cl(v4.childrenRef(), r3), r3 = null);
    var C = !r3, A2 = r3;
    A2 ? A2.clearStates() : (A2 = iPe(u), x3 && VSn(x3, A2)), u.morph === false ? A2.disableMorphing = true : A2.disableMorphing && (A2.disableMorphing = false), i2.normal.cfg = i2.normal.conOpt = i2.emphasis.cfg = i2.emphasis.conOpt = i2.blur.cfg = i2.blur.conOpt = i2.select.cfg = i2.select.conOpt = null, i2.isLegacy = false, USn(A2, e3, u, h, C, i2), WSn(A2, e3, u, h, C), aPe(l3, A2, e3, u, i2, h, C), vo(u, "info") && (o5(A2).info = u.info);
    for (var D = 0; D < rP.length; D++) {
      var P = rP[D];
      if (P !== HO) {
        var N = whe(u, P), j = sPe(u, N, P);
        Bdt(P, A2, N, j, i2);
      }
    }
    return jSn(A2, u, h), u.type === "group" && qSn(l3, A2, e3, u, h), m3 >= 0 ? v4.replaceAt(A2, m3) : v4.add(A2), A2;
  }
  function zdt(l3, r3, e3) {
    var u = o5(l3), h = r3.type, v4 = r3.shape, m3 = r3.style;
    return e3.isUniversalTransitionEnabled() || h != null && h !== u.customGraphicType || h === "path" && YSn(v4) && jdt(v4) !== u.customPathData || h === "image" && vo(m3, "image") && m3.image !== u.customImagePath;
  }
  function WSn(l3, r3, e3, u, h) {
    var v4 = e3.clipPath;
    if (v4 === false)
      l3 && l3.getClipPath() && l3.removeClipPath();
    else if (v4) {
      var m3 = l3.getClipPath();
      m3 && zdt(m3, v4, u) && (m3 = null), m3 || (m3 = iPe(v4), l3.setClipPath(m3)), aPe(null, m3, r3, v4, null, u, h);
    }
  }
  function USn(l3, r3, e3, u, h, v4) {
    if (!l3.isGroup) {
      lot(e3, null, v4), lot(e3, s5, v4);
      var m3 = v4.normal.conOpt, x3 = v4.emphasis.conOpt, C = v4.blur.conOpt, A2 = v4.select.conOpt;
      if (m3 != null || x3 != null || A2 != null || C != null) {
        var D = l3.getTextContent();
        if (m3 === false)
          D && l3.removeTextContent();
        else {
          m3 = v4.normal.conOpt = m3 || { type: "text" }, D ? D.clearStates() : (D = iPe(m3), l3.setTextContent(D)), aPe(null, D, r3, m3, null, u, h);
          for (var P = m3 && m3.style, N = 0; N < rP.length; N++) {
            var j = rP[N];
            if (j !== HO) {
              var W = v4[j].conOpt;
              Bdt(j, D, W, sPe(m3, W, j), null);
            }
          }
          P ? D.dirty() : D.markRedraw();
        }
      }
    }
  }
  function lot(l3, r3, e3) {
    var u = r3 ? whe(l3, r3) : l3, h = r3 ? sPe(l3, u, s5) : l3.style, v4 = l3.type, m3 = u ? u.textConfig : null, x3 = l3.textContent, C = x3 ? r3 ? whe(x3, r3) : x3 : null;
    if (h && (e3.isLegacy || Pdt(h, v4, !!m3, !!C))) {
      e3.isLegacy = true;
      var A2 = Ldt(h, v4, !r3);
      !m3 && A2.textConfig && (m3 = A2.textConfig), !C && A2.textContent && (C = A2.textContent);
    }
    if (!r3 && C) {
      var D = C;
      !D.type && (D.type = "text");
    }
    var P = r3 ? e3[r3] : e3.normal;
    P.cfg = m3, P.conOpt = C;
  }
  function whe(l3, r3) {
    return r3 ? l3 ? l3[r3] : null : l3;
  }
  function sPe(l3, r3, e3) {
    var u = r3 && r3.style;
    return u == null && e3 === s5 && l3 && (u = l3.styleEmphasis), u;
  }
  function qSn(l3, r3, e3, u, h) {
    var v4 = u.children, m3 = v4 ? v4.length : 0, x3 = u.$mergeChildren, C = x3 === "byName" || u.diffChildrenByName, A2 = x3 === false;
    if (!(!m3 && !C && !A2)) {
      if (C) {
        $Sn({ api: l3, oldChildren: r3.children() || [], newChildren: v4 || [], dataIndex: e3, seriesModel: h, group: r3 });
        return;
      }
      A2 && r3.removeAll();
      for (var D = 0; D < m3; D++)
        v4[D] && oPe(l3, r3.childAt(D), e3, v4[D], h, r3);
      for (var P = r3.childCount() - 1; P >= D; P--) {
        var N = r3.childAt(P);
        xpe(N, o5(r3).option, h);
      }
    }
  }
  function $Sn(l3) {
    new f5(l3.oldChildren, l3.newChildren, uot, uot, l3).add(cot).update(cot).remove(XSn).execute();
  }
  function uot(l3, r3) {
    var e3 = l3 && l3.name;
    return e3 != null ? e3 : NSn + r3;
  }
  function cot(l3, r3) {
    var e3 = this.context, u = l3 != null ? e3.newChildren[l3] : null, h = r3 != null ? e3.oldChildren[r3] : null;
    oPe(e3.api, h, e3.dataIndex, u, e3.seriesModel, e3.group);
  }
  function XSn(l3) {
    var r3 = this.context, e3 = r3.oldChildren[l3];
    xpe(e3, o5(e3).option, r3.seriesModel);
  }
  function jdt(l3) {
    return l3 && (l3.pathData || l3.d);
  }
  function YSn(l3) {
    return l3 && (vo(l3, "pathData") || vo(l3, "d"));
  }
  function KSn(l3) {
    l3.registerChartView(zSn), l3.registerSeriesModel(vSn);
  }
  var TN = pc(), fot = bs, BDe = no, ZSn = function() {
    function l3() {
      this._dragging = false, this.animationThreshold = 15;
    }
    return l3.prototype.render = function(r3, e3, u, h) {
      var v4 = e3.get("value"), m3 = e3.get("status");
      if (this._axisModel = r3, this._axisPointerModel = e3, this._api = u, !(!h && this._lastValue === v4 && this._lastStatus === m3)) {
        this._lastValue = v4, this._lastStatus = m3;
        var x3 = this._group, C = this._handle;
        if (!m3 || m3 === "hide") {
          x3 && x3.hide(), C && C.hide();
          return;
        }
        x3 && x3.show(), C && C.show();
        var A2 = {};
        this.makeElOption(A2, v4, r3, e3, u);
        var D = A2.graphicKey;
        D !== this._lastGraphicKey && this.clear(u), this._lastGraphicKey = D;
        var P = this._moveAnimation = this.determineAnimation(r3, e3);
        if (!x3)
          x3 = this._group = new Cs(), this.createPointerEl(x3, A2, r3, e3), this.createLabelEl(x3, A2, r3, e3), u.getZr().add(x3);
        else {
          var N = Fs(hot, e3, P);
          this.updatePointerEl(x3, A2, N), this.updateLabelEl(x3, A2, N, e3);
        }
        dot(x3, e3, true), this._renderHandle(v4);
      }
    }, l3.prototype.remove = function(r3) {
      this.clear(r3);
    }, l3.prototype.dispose = function(r3) {
      this.clear(r3);
    }, l3.prototype.determineAnimation = function(r3, e3) {
      var u = e3.get("animation"), h = r3.axis, v4 = h.type === "category", m3 = e3.get("snap");
      if (!m3 && !v4)
        return false;
      if (u === "auto" || u == null) {
        var x3 = this.animationThreshold;
        if (v4 && h.getBandWidth() > x3)
          return true;
        if (m3) {
          var C = POe(r3).seriesDataCount, A2 = h.getExtent();
          return Math.abs(A2[0] - A2[1]) / C > x3;
        }
        return false;
      }
      return u === true;
    }, l3.prototype.makeElOption = function(r3, e3, u, h, v4) {
    }, l3.prototype.createPointerEl = function(r3, e3, u, h) {
      var v4 = e3.pointer;
      if (v4) {
        var m3 = TN(r3).pointerEl = new NJ[v4.type](fot(e3.pointer));
        r3.add(m3);
      }
    }, l3.prototype.createLabelEl = function(r3, e3, u, h) {
      if (e3.label) {
        var v4 = TN(r3).labelEl = new Ec(fot(e3.label));
        r3.add(v4), pot(v4, h);
      }
    }, l3.prototype.updatePointerEl = function(r3, e3, u) {
      var h = TN(r3).pointerEl;
      h && e3.pointer && (h.setStyle(e3.pointer.style), u(h, { shape: e3.pointer.shape }));
    }, l3.prototype.updateLabelEl = function(r3, e3, u, h) {
      var v4 = TN(r3).labelEl;
      v4 && (v4.setStyle(e3.label.style), u(v4, { x: e3.label.x, y: e3.label.y }), pot(v4, h));
    }, l3.prototype._renderHandle = function(r3) {
      if (!(this._dragging || !this.updateHandleTransform)) {
        var e3 = this._axisPointerModel, u = this._api.getZr(), h = this._handle, v4 = e3.getModel("handle"), m3 = e3.get("status");
        if (!v4.get("show") || !m3 || m3 === "hide") {
          h && u.remove(h), this._handle = null;
          return;
        }
        var x3;
        this._handle || (x3 = true, h = this._handle = RJ(v4.get("icon"), { cursor: "move", draggable: true, onmousemove: function(A2) {
          u5(A2.event);
        }, onmousedown: BDe(this._onHandleDragMove, this, 0, 0), drift: BDe(this._onHandleDragMove, this), ondragend: BDe(this._onHandleDragEnd, this) }), u.add(h)), dot(h, e3, false), h.setStyle(v4.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
        var C = v4.get("size");
        Ni(C) || (C = [C, C]), h.scaleX = C[0] / 2, h.scaleY = C[1] / 2, Oj(this, "_doDispatchAxisPointer", v4.get("throttle") || 0, "fixRate"), this._moveHandleToValue(r3, x3);
      }
    }, l3.prototype._moveHandleToValue = function(r3, e3) {
      hot(this._axisPointerModel, !e3 && this._moveAnimation, this._handle, zDe(this.getHandleTransform(r3, this._axisModel, this._axisPointerModel)));
    }, l3.prototype._onHandleDragMove = function(r3, e3) {
      var u = this._handle;
      if (!!u) {
        this._dragging = true;
        var h = this.updateHandleTransform(zDe(u), [r3, e3], this._axisModel, this._axisPointerModel);
        this._payloadInfo = h, u.stopAnimation(), u.attr(zDe(h)), TN(u).lastProp = null, this._doDispatchAxisPointer();
      }
    }, l3.prototype._doDispatchAxisPointer = function() {
      var r3 = this._handle;
      if (!!r3) {
        var e3 = this._payloadInfo, u = this._axisModel;
        this._api.dispatchAction({ type: "updateAxisPointer", x: e3.cursorPoint[0], y: e3.cursorPoint[1], tooltipOption: e3.tooltipOption, axesInfo: [{ axisDim: u.axis.dim, axisIndex: u.componentIndex }] });
      }
    }, l3.prototype._onHandleDragEnd = function() {
      this._dragging = false;
      var r3 = this._handle;
      if (!!r3) {
        var e3 = this._axisPointerModel.get("value");
        this._moveHandleToValue(e3), this._api.dispatchAction({ type: "hideTip" });
      }
    }, l3.prototype.clear = function(r3) {
      this._lastValue = null, this._lastStatus = null;
      var e3 = r3.getZr(), u = this._group, h = this._handle;
      e3 && u && (this._lastGraphicKey = null, u && e3.remove(u), h && e3.remove(h), this._group = null, this._handle = null, this._payloadInfo = null), cJ(this, "_doDispatchAxisPointer");
    }, l3.prototype.doClear = function() {
    }, l3.prototype.buildLabel = function(r3, e3, u) {
      return u = u || 0, { x: r3[u], y: r3[1 - u], width: e3[u], height: e3[1 - u] };
    }, l3;
  }();
  function hot(l3, r3, e3, u) {
    Gdt(TN(e3).lastProp, u) || (TN(e3).lastProp = u, r3 ? hc(e3, u, l3) : (e3.stopAnimation(), e3.attr(u)));
  }
  function Gdt(l3, r3) {
    if (ls(l3) && ls(r3)) {
      var e3 = true;
      return mt(r3, function(u, h) {
        e3 = e3 && Gdt(l3[h], u);
      }), !!e3;
    } else
      return l3 === r3;
  }
  function pot(l3, r3) {
    l3[r3.get(["label", "show"]) ? "show" : "hide"]();
  }
  function zDe(l3) {
    return { x: l3.x || 0, y: l3.y || 0, rotation: l3.rotation || 0 };
  }
  function dot(l3, r3, e3) {
    var u = r3.get("z"), h = r3.get("zlevel");
    l3 && l3.traverse(function(v4) {
      v4.type !== "group" && (u != null && (v4.z = u), h != null && (v4.zlevel = h), v4.silent = e3);
    });
  }
  var lPe = ZSn;
  function uPe(l3) {
    var r3 = l3.get("type"), e3 = l3.getModel(r3 + "Style"), u;
    return r3 === "line" ? (u = e3.getLineStyle(), u.fill = null) : r3 === "shadow" && (u = e3.getAreaStyle(), u.stroke = null), u;
  }
  function Hdt(l3, r3, e3, u, h) {
    var v4 = e3.get("value"), m3 = Wdt(v4, r3.axis, r3.ecModel, e3.get("seriesDataIndices"), { precision: e3.get(["label", "precision"]), formatter: e3.get(["label", "formatter"]) }), x3 = e3.getModel("label"), C = Aj(x3.get("padding") || 0), A2 = x3.getFont(), D = DJ(m3, A2), P = h.position, N = D.width + C[1] + C[3], j = D.height + C[0] + C[2], W = h.align;
    W === "right" && (P[0] -= N), W === "center" && (P[0] -= N / 2);
    var K = h.verticalAlign;
    K === "bottom" && (P[1] -= j), K === "middle" && (P[1] -= j / 2), JSn(P, N, j, u);
    var te = x3.get("backgroundColor");
    (!te || te === "auto") && (te = r3.get(["axisLine", "lineStyle", "color"])), l3.label = { x: P[0], y: P[1], style: ov(x3, { text: m3, font: A2, fill: x3.getTextColor(), padding: C, backgroundColor: te }), z2: 10 };
  }
  function JSn(l3, r3, e3, u) {
    var h = u.getWidth(), v4 = u.getHeight();
    l3[0] = Math.min(l3[0] + r3, h) - r3, l3[1] = Math.min(l3[1] + e3, v4) - e3, l3[0] = Math.max(l3[0], 0), l3[1] = Math.max(l3[1], 0);
  }
  function Wdt(l3, r3, e3, u, h) {
    l3 = r3.scale.parse(l3);
    var v4 = r3.scale.getLabel({ value: l3 }, { precision: h.precision }), m3 = h.formatter;
    if (m3) {
      var x3 = { value: COe(r3, { value: l3 }), axisDimension: r3.dim, axisIndex: r3.index, seriesData: [] };
      mt(u, function(C) {
        var A2 = e3.getSeriesByIndex(C.seriesIndex), D = C.dataIndexInside, P = A2 && A2.getDataParams(D);
        P && x3.seriesData.push(P);
      }), qa(m3) ? v4 = m3.replace("{value}", v4) : Xo(m3) && (v4 = m3(x3));
    }
    return v4;
  }
  function cPe(l3, r3, e3) {
    var u = _2();
    return ZN(u, u, e3.rotation), UA(u, u, e3.position), vM([l3.dataToCoord(r3), (e3.labelOffset || 0) + (e3.labelDirection || 1) * (e3.labelMargin || 0)], u);
  }
  function Udt(l3, r3, e3, u, h, v4) {
    var m3 = h5.innerTextLayout(e3.rotation, 0, e3.labelDirection);
    e3.labelMargin = h.get(["label", "margin"]), Hdt(r3, u, h, v4, { position: cPe(u.axis, l3, e3), align: m3.textAlign, verticalAlign: m3.textVerticalAlign });
  }
  function fPe(l3, r3, e3) {
    return e3 = e3 || 0, { x1: l3[e3], y1: l3[1 - e3], x2: r3[e3], y2: r3[1 - e3] };
  }
  function qdt(l3, r3, e3) {
    return e3 = e3 || 0, { x: l3[e3], y: l3[1 - e3], width: r3[e3], height: r3[1 - e3] };
  }
  function vot(l3, r3, e3, u, h, v4) {
    return { cx: l3, cy: r3, r0: e3, r: u, startAngle: h, endAngle: v4, clockwise: true };
  }
  var QSn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.makeElOption = function(e3, u, h, v4, m3) {
      var x3 = h.axis, C = x3.grid, A2 = v4.get("type"), D = got(C, x3).getOtherAxis(x3).getGlobalExtent(), P = x3.toGlobalCoord(x3.dataToCoord(u, true));
      if (A2 && A2 !== "none") {
        var N = uPe(v4), j = e2n[A2](x3, P, D);
        j.style = N, e3.graphicKey = j.type, e3.pointer = j;
      }
      var W = Ske(C.model, h);
      Udt(u, e3, W, h, v4, m3);
    }, r3.prototype.getHandleTransform = function(e3, u, h) {
      var v4 = Ske(u.axis.grid.model, u, { labelInside: false });
      v4.labelMargin = h.get(["handle", "margin"]);
      var m3 = cPe(u.axis, e3, v4);
      return { x: m3[0], y: m3[1], rotation: v4.rotation + (v4.labelDirection < 0 ? Math.PI : 0) };
    }, r3.prototype.updateHandleTransform = function(e3, u, h, v4) {
      var m3 = h.axis, x3 = m3.grid, C = m3.getGlobalExtent(true), A2 = got(x3, m3).getOtherAxis(m3).getGlobalExtent(), D = m3.dim === "x" ? 0 : 1, P = [e3.x, e3.y];
      P[D] += u[D], P[D] = Math.min(C[1], P[D]), P[D] = Math.max(C[0], P[D]);
      var N = (A2[1] + A2[0]) / 2, j = [N, N];
      j[D] = P[D];
      var W = [{ verticalAlign: "middle" }, { align: "center" }];
      return { x: P[0], y: P[1], rotation: e3.rotation, cursorPoint: j, tooltipOption: W[D] };
    }, r3;
  }(lPe);
  function got(l3, r3) {
    var e3 = {};
    return e3[r3.dim + "AxisIndex"] = r3.index, l3.getCartesian(e3);
  }
  var e2n = { line: function(l3, r3, e3) {
    var u = fPe([r3, e3[0]], [r3, e3[1]], yot(l3));
    return { type: "Line", subPixelOptimize: true, shape: u };
  }, shadow: function(l3, r3, e3) {
    var u = Math.max(1, l3.getBandWidth()), h = e3[1] - e3[0];
    return { type: "Rect", shape: qdt([r3 - u / 2, e3[0]], [u, h], yot(l3)) };
  } };
  function yot(l3) {
    return l3.dim === "x" ? 0 : 1;
  }
  var t2n = QSn, n2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "axisPointer", r3.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, r3;
  }(fc), r2n = n2n, e5 = pc(), i2n = mt;
  function $dt(l3, r3, e3) {
    if (!Fc.node) {
      var u = r3.getZr();
      e5(u).records || (e5(u).records = {}), a2n(u, r3);
      var h = e5(u).records[l3] || (e5(u).records[l3] = {});
      h.handler = e3;
    }
  }
  function a2n(l3, r3) {
    if (e5(l3).initialized)
      return;
    e5(l3).initialized = true, e3("click", Fs(mot, "click")), e3("mousemove", Fs(mot, "mousemove")), e3("globalout", s2n);
    function e3(u, h) {
      l3.on(u, function(v4) {
        var m3 = l2n(r3);
        i2n(e5(l3).records, function(x3) {
          x3 && h(x3, v4, m3.dispatchAction);
        }), o2n(m3.pendings, r3);
      });
    }
  }
  function o2n(l3, r3) {
    var e3 = l3.showTip.length, u = l3.hideTip.length, h;
    e3 ? h = l3.showTip[e3 - 1] : u && (h = l3.hideTip[u - 1]), h && (h.dispatchAction = null, r3.dispatchAction(h));
  }
  function s2n(l3, r3, e3) {
    l3.handler("leave", null, e3);
  }
  function mot(l3, r3, e3, u) {
    r3.handler(l3, e3, u);
  }
  function l2n(l3) {
    var r3 = { showTip: [], hideTip: [] }, e3 = function(u) {
      var h = r3[u.type];
      h ? h.push(u) : (u.dispatchAction = e3, l3.dispatchAction(u));
    };
    return { dispatchAction: e3, pendings: r3 };
  }
  function Gke(l3, r3) {
    if (!Fc.node) {
      var e3 = r3.getZr(), u = (e5(e3).records || {})[l3];
      u && (e5(e3).records[l3] = null);
    }
  }
  var u2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = u.getComponent("tooltip"), m3 = e3.get("triggerOn") || v4 && v4.get("triggerOn") || "mousemove|click";
      $dt("axisPointer", h, function(x3, C, A2) {
        m3 !== "none" && (x3 === "leave" || m3.indexOf(x3) >= 0) && A2({ type: "updateAxisPointer", currTrigger: x3, x: C && C.offsetX, y: C && C.offsetY });
      });
    }, r3.prototype.remove = function(e3, u) {
      Gke("axisPointer", u);
    }, r3.prototype.dispose = function(e3, u) {
      Gke("axisPointer", u);
    }, r3.type = "axisPointer", r3;
  }(yd), c2n = u2n;
  function Xdt(l3, r3) {
    var e3 = [], u = l3.seriesIndex, h;
    if (u == null || !(h = r3.getSeriesByIndex(u)))
      return { point: [] };
    var v4 = h.getData(), m3 = WN(v4, l3);
    if (m3 == null || m3 < 0 || Ni(m3))
      return { point: [] };
    var x3 = v4.getItemGraphicEl(m3), C = h.coordinateSystem;
    if (h.getTooltipPosition)
      e3 = h.getTooltipPosition(m3) || [];
    else if (C && C.dataToPoint)
      if (l3.isStacked) {
        var A2 = C.getBaseAxis(), D = C.getOtherAxis(A2), P = D.dim, N = A2.dim, j = P === "x" || P === "radius" ? 1 : 0, W = v4.mapDimension(N), K = [];
        K[j] = v4.get(W, m3), K[1 - j] = v4.get(v4.getCalculationInfo("stackResultDimension"), m3), e3 = C.dataToPoint(K) || [];
      } else
        e3 = C.dataToPoint(v4.getValues(Bi(C.dimensions, function(ne) {
          return v4.mapDimension(ne);
        }), m3)) || [];
    else if (x3) {
      var te = x3.getBoundingRect().clone();
      te.applyTransform(x3.transform), e3 = [te.x + te.width / 2, te.y + te.height / 2];
    }
    return { point: e3, el: x3 };
  }
  var bot = pc();
  function f2n(l3, r3, e3) {
    var u = l3.currTrigger, h = [l3.x, l3.y], v4 = l3, m3 = l3.dispatchAction || no(e3.dispatchAction, e3), x3 = r3.getComponent("axisPointer").coordSysAxesInfo;
    if (!!x3) {
      Ofe(h) && (h = Xdt({ seriesIndex: v4.seriesIndex, dataIndex: v4.dataIndex }, r3).point);
      var C = Ofe(h), A2 = v4.axesInfo, D = x3.axesInfo, P = u === "leave" || Ofe(h), N = {}, j = {}, W = { list: [], map: {} }, K = { showPointer: Fs(p2n, j), showTooltip: Fs(d2n, W) };
      mt(x3.coordSysMap, function(ne, ce) {
        var me = C || ne.containPoint(h);
        mt(x3.coordSysAxesInfo[ce], function(ve, Be) {
          var Oe = ve.axis, We = m2n(A2, ve);
          if (!P && me && (!A2 || We)) {
            var Ue = We && We.value;
            Ue == null && !C && (Ue = Oe.pointToData(h)), Ue != null && _ot(ve, Ue, K, false, N);
          }
        });
      });
      var te = {};
      return mt(D, function(ne, ce) {
        var me = ne.linkGroup;
        me && !j[ce] && mt(me.axesInfo, function(ve, Be) {
          var Oe = j[Be];
          if (ve !== ne && Oe) {
            var We = Oe.value;
            me.mapper && (We = ne.axis.scale.parse(me.mapper(We, xot(ve), xot(ne)))), te[ne.key] = We;
          }
        });
      }), mt(te, function(ne, ce) {
        _ot(D[ce], ne, K, true, N);
      }), v2n(j, D, N), g2n(W, h, l3, m3), y2n(D, m3, e3), N;
    }
  }
  function _ot(l3, r3, e3, u, h) {
    var v4 = l3.axis;
    if (!(v4.scale.isBlank() || !v4.containData(r3))) {
      if (!l3.involveSeries) {
        e3.showPointer(l3, r3);
        return;
      }
      var m3 = h2n(r3, l3), x3 = m3.payloadBatch, C = m3.snapToValue;
      x3[0] && h.seriesIndex == null && fi(h, x3[0]), !u && l3.snap && v4.containData(C) && C != null && (r3 = C), e3.showPointer(l3, r3, x3), e3.showTooltip(l3, m3, C);
    }
  }
  function h2n(l3, r3) {
    var e3 = r3.axis, u = e3.dim, h = l3, v4 = [], m3 = Number.MAX_VALUE, x3 = -1;
    return mt(r3.seriesModels, function(C, A2) {
      var D = C.getData().mapDimensionsAll(u), P, N;
      if (C.getAxisTooltipData) {
        var j = C.getAxisTooltipData(D, l3, e3);
        N = j.dataIndices, P = j.nestestValue;
      } else {
        if (N = C.getData().indicesOfNearest(D[0], l3, e3.type === "category" ? 0.5 : null), !N.length)
          return;
        P = C.getData().get(D[0], N[0]);
      }
      if (!(P == null || !isFinite(P))) {
        var W = l3 - P, K = Math.abs(W);
        K <= m3 && ((K < m3 || W >= 0 && x3 < 0) && (m3 = K, x3 = W, h = P, v4.length = 0), mt(N, function(te) {
          v4.push({ seriesIndex: C.seriesIndex, dataIndexInside: te, dataIndex: C.getData().getRawIndex(te) });
        }));
      }
    }), { payloadBatch: v4, snapToValue: h };
  }
  function p2n(l3, r3, e3, u) {
    l3[r3.key] = { value: e3, payloadBatch: u };
  }
  function d2n(l3, r3, e3, u) {
    var h = e3.payloadBatch, v4 = r3.axis, m3 = v4.model, x3 = r3.axisPointerModel;
    if (!(!r3.triggerTooltip || !h.length)) {
      var C = r3.coordSys.model, A2 = yJ(C), D = l3.map[A2];
      D || (D = l3.map[A2] = { coordSysId: C.id, coordSysIndex: C.componentIndex, coordSysType: C.type, coordSysMainType: C.mainType, dataByAxis: [] }, l3.list.push(D)), D.dataByAxis.push({ axisDim: v4.dim, axisIndex: m3.componentIndex, axisType: m3.type, axisId: m3.id, value: u, valueLabelOpt: { precision: x3.get(["label", "precision"]), formatter: x3.get(["label", "formatter"]) }, seriesDataIndices: h.slice() });
    }
  }
  function v2n(l3, r3, e3) {
    var u = e3.axesInfo = [];
    mt(r3, function(h, v4) {
      var m3 = h.axisPointerModel.option, x3 = l3[v4];
      x3 ? (!h.useHandle && (m3.status = "show"), m3.value = x3.value, m3.seriesDataIndices = (x3.payloadBatch || []).slice()) : !h.useHandle && (m3.status = "hide"), m3.status === "show" && u.push({ axisDim: h.axis.dim, axisIndex: h.axis.model.componentIndex, value: m3.value });
    });
  }
  function g2n(l3, r3, e3, u) {
    if (Ofe(r3) || !l3.list.length) {
      u({ type: "hideTip" });
      return;
    }
    var h = ((l3.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
    u({ type: "showTip", escapeConnect: true, x: r3[0], y: r3[1], tooltipOption: e3.tooltipOption, position: e3.position, dataIndexInside: h.dataIndexInside, dataIndex: h.dataIndex, seriesIndex: h.seriesIndex, dataByCoordSys: l3.list });
  }
  function y2n(l3, r3, e3) {
    var u = e3.getZr(), h = "axisPointerLastHighlights", v4 = bot(u)[h] || {}, m3 = bot(u)[h] = {};
    mt(l3, function(A2, D) {
      var P = A2.axisPointerModel.option;
      P.status === "show" && mt(P.seriesDataIndices, function(N) {
        var j = N.seriesIndex + " | " + N.dataIndex;
        m3[j] = N;
      });
    });
    var x3 = [], C = [];
    mt(v4, function(A2, D) {
      !m3[D] && C.push(A2);
    }), mt(m3, function(A2, D) {
      !v4[D] && x3.push(A2);
    }), C.length && e3.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: C }), x3.length && e3.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: x3 });
  }
  function m2n(l3, r3) {
    for (var e3 = 0; e3 < (l3 || []).length; e3++) {
      var u = l3[e3];
      if (r3.axis.dim === u.axisDim && r3.axis.model.componentIndex === u.axisIndex)
        return u;
    }
  }
  function xot(l3) {
    var r3 = l3.axis.model, e3 = {}, u = e3.axisDim = l3.axis.dim;
    return e3.axisIndex = e3[u + "AxisIndex"] = r3.componentIndex, e3.axisName = e3[u + "AxisName"] = r3.name, e3.axisId = e3[u + "AxisId"] = r3.id, e3;
  }
  function Ofe(l3) {
    return !l3 || l3[0] == null || isNaN(l3[0]) || l3[1] == null || isNaN(l3[1]);
  }
  function KJ(l3) {
    eF.registerAxisPointerClass("CartesianAxisPointer", t2n), l3.registerComponentModel(r2n), l3.registerComponentView(c2n), l3.registerPreprocessor(function(r3) {
      if (r3) {
        (!r3.axisPointer || r3.axisPointer.length === 0) && (r3.axisPointer = {});
        var e3 = r3.axisPointer.link;
        e3 && !Ni(e3) && (r3.axisPointer.link = [e3]);
      }
    }), l3.registerProcessor(l3.PRIORITY.PROCESSOR.STATISTIC, function(r3, e3) {
      r3.getComponent("axisPointer").coordSysAxesInfo = oyn(r3, e3);
    }), l3.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, f2n);
  }
  function b2n(l3) {
    kl(bpt), kl(KJ);
  }
  var _2n = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.makeElOption = function(e3, u, h, v4, m3) {
      var x3 = h.axis;
      x3.dim === "angle" && (this.animationThreshold = Math.PI / 18);
      var C = x3.polar, A2 = C.getOtherAxis(x3), D = A2.getExtent(), P = x3.dataToCoord(u), N = v4.get("type");
      if (N && N !== "none") {
        var j = uPe(v4), W = w2n[N](x3, C, P, D);
        W.style = j, e3.graphicKey = W.type, e3.pointer = W;
      }
      var K = v4.get(["label", "margin"]), te = x2n(u, h, v4, C, K);
      Hdt(e3, h, v4, m3, te);
    }, r3;
  }(lPe);
  function x2n(l3, r3, e3, u, h) {
    var v4 = r3.axis, m3 = v4.dataToCoord(l3), x3 = u.getAngleAxis().getExtent()[0];
    x3 = x3 / 180 * Math.PI;
    var C = u.getRadiusAxis().getExtent(), A2, D, P;
    if (v4.dim === "radius") {
      var N = _2();
      ZN(N, N, x3), UA(N, N, [u.cx, u.cy]), A2 = vM([m3, -h], N);
      var j = r3.getModel("axisLabel").get("rotate") || 0, W = h5.innerTextLayout(x3, j * Math.PI / 180, -1);
      D = W.textAlign, P = W.textVerticalAlign;
    } else {
      var K = C[1];
      A2 = u.coordToPoint([K + h, m3]);
      var te = u.cx, ne = u.cy;
      D = Math.abs(A2[0] - te) / K < 0.3 ? "center" : A2[0] > te ? "left" : "right", P = Math.abs(A2[1] - ne) / K < 0.3 ? "middle" : A2[1] > ne ? "top" : "bottom";
    }
    return { position: A2, align: D, verticalAlign: P };
  }
  var w2n = { line: function(l3, r3, e3, u) {
    return l3.dim === "angle" ? { type: "Line", shape: fPe(r3.coordToPoint([u[0], e3]), r3.coordToPoint([u[1], e3])) } : { type: "Circle", shape: { cx: r3.cx, cy: r3.cy, r: e3 } };
  }, shadow: function(l3, r3, e3, u) {
    var h = Math.max(1, l3.getBandWidth()), v4 = Math.PI / 180;
    return l3.dim === "angle" ? { type: "Sector", shape: vot(r3.cx, r3.cy, u[0], u[1], (-e3 - h / 2) * v4, (-e3 + h / 2) * v4) } : { type: "Sector", shape: vot(r3.cx, r3.cy, e3 - h / 2, e3 + h / 2, 0, Math.PI * 2) };
  } }, S2n = _2n, C2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.findAxisModel = function(e3) {
      var u, h = this.ecModel;
      return h.eachComponent(e3, function(v4) {
        v4.getCoordSysModel() === this && (u = v4);
      }, this), u;
    }, r3.type = "polar", r3.dependencies = ["radiusAxis", "angleAxis"], r3.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, r3;
  }(fc), M2n = C2n, hPe = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.getCoordSysModel = function() {
      return this.getReferringComponents("polar", Lv).models[0];
    }, r3.type = "polarAxis", r3;
  }(fc);
  Fv(hPe, GJ);
  var T2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "angleAxis", r3;
  }(hPe), A2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "radiusAxis", r3;
  }(hPe), pPe = function(l3) {
    ar(r3, l3);
    function r3(e3, u) {
      return l3.call(this, "radius", e3, u) || this;
    }
    return r3.prototype.pointToData = function(e3, u) {
      return this.polar.pointToData(e3, u)[this.dim === "radius" ? 0 : 1];
    }, r3;
  }(bM);
  pPe.prototype.dataToRadius = bM.prototype.dataToCoord;
  pPe.prototype.radiusToData = bM.prototype.coordToData;
  var I2n = pPe, E2n = pc(), dPe = function(l3) {
    ar(r3, l3);
    function r3(e3, u) {
      return l3.call(this, "angle", e3, u || [0, 360]) || this;
    }
    return r3.prototype.pointToData = function(e3, u) {
      return this.polar.pointToData(e3, u)[this.dim === "radius" ? 0 : 1];
    }, r3.prototype.calculateCategoryInterval = function() {
      var e3 = this, u = e3.getLabelModel(), h = e3.scale, v4 = h.getExtent(), m3 = h.count();
      if (v4[1] - v4[0] < 1)
        return 0;
      var x3 = v4[0], C = e3.dataToCoord(x3 + 1) - e3.dataToCoord(x3), A2 = Math.abs(C), D = DJ(x3 == null ? "" : x3 + "", u.getFont(), "center", "top"), P = Math.max(D.height, 7), N = P / A2;
      isNaN(N) && (N = 1 / 0);
      var j = Math.max(0, Math.floor(N)), W = E2n(e3.model), K = W.lastAutoInterval, te = W.lastTickCount;
      return K != null && te != null && Math.abs(K - j) <= 1 && Math.abs(te - m3) <= 1 && K > j ? j = K : (W.lastTickCount = m3, W.lastAutoInterval = j), j;
    }, r3;
  }(bM);
  dPe.prototype.dataToAngle = bM.prototype.dataToCoord;
  dPe.prototype.angleToData = bM.prototype.coordToData;
  var D2n = dPe, Ydt = ["radius", "angle"], k2n = function() {
    function l3(r3) {
      this.dimensions = Ydt, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new I2n(), this._angleAxis = new D2n(), this.axisPointerEnabled = true, this.name = r3 || "", this._radiusAxis.polar = this._angleAxis.polar = this;
    }
    return l3.prototype.containPoint = function(r3) {
      var e3 = this.pointToCoord(r3);
      return this._radiusAxis.contain(e3[0]) && this._angleAxis.contain(e3[1]);
    }, l3.prototype.containData = function(r3) {
      return this._radiusAxis.containData(r3[0]) && this._angleAxis.containData(r3[1]);
    }, l3.prototype.getAxis = function(r3) {
      var e3 = "_" + r3 + "Axis";
      return this[e3];
    }, l3.prototype.getAxes = function() {
      return [this._radiusAxis, this._angleAxis];
    }, l3.prototype.getAxesByScale = function(r3) {
      var e3 = [], u = this._angleAxis, h = this._radiusAxis;
      return u.scale.type === r3 && e3.push(u), h.scale.type === r3 && e3.push(h), e3;
    }, l3.prototype.getAngleAxis = function() {
      return this._angleAxis;
    }, l3.prototype.getRadiusAxis = function() {
      return this._radiusAxis;
    }, l3.prototype.getOtherAxis = function(r3) {
      var e3 = this._angleAxis;
      return r3 === e3 ? this._radiusAxis : e3;
    }, l3.prototype.getBaseAxis = function() {
      return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
    }, l3.prototype.getTooltipAxes = function(r3) {
      var e3 = r3 != null && r3 !== "auto" ? this.getAxis(r3) : this.getBaseAxis();
      return { baseAxes: [e3], otherAxes: [this.getOtherAxis(e3)] };
    }, l3.prototype.dataToPoint = function(r3, e3) {
      return this.coordToPoint([this._radiusAxis.dataToRadius(r3[0], e3), this._angleAxis.dataToAngle(r3[1], e3)]);
    }, l3.prototype.pointToData = function(r3, e3) {
      var u = this.pointToCoord(r3);
      return [this._radiusAxis.radiusToData(u[0], e3), this._angleAxis.angleToData(u[1], e3)];
    }, l3.prototype.pointToCoord = function(r3) {
      var e3 = r3[0] - this.cx, u = r3[1] - this.cy, h = this.getAngleAxis(), v4 = h.getExtent(), m3 = Math.min(v4[0], v4[1]), x3 = Math.max(v4[0], v4[1]);
      h.inverse ? m3 = x3 - 360 : x3 = m3 + 360;
      var C = Math.sqrt(e3 * e3 + u * u);
      e3 /= C, u /= C;
      for (var A2 = Math.atan2(-u, e3) / Math.PI * 180, D = A2 < m3 ? 1 : -1; A2 < m3 || A2 > x3; )
        A2 += D * 360;
      return [C, A2];
    }, l3.prototype.coordToPoint = function(r3) {
      var e3 = r3[0], u = r3[1] / 180 * Math.PI, h = Math.cos(u) * e3 + this.cx, v4 = -Math.sin(u) * e3 + this.cy;
      return [h, v4];
    }, l3.prototype.getArea = function() {
      var r3 = this.getAngleAxis(), e3 = this.getRadiusAxis(), u = e3.getExtent().slice();
      u[0] > u[1] && u.reverse();
      var h = r3.getExtent(), v4 = Math.PI / 180;
      return { cx: this.cx, cy: this.cy, r0: u[0], r: u[1], startAngle: -h[0] * v4, endAngle: -h[1] * v4, clockwise: r3.inverse, contain: function(m3, x3) {
        var C = m3 - this.cx, A2 = x3 - this.cy, D = C * C + A2 * A2 - 1e-4, P = this.r, N = this.r0;
        return D <= P * P && D >= N * N;
      } };
    }, l3.prototype.convertToPixel = function(r3, e3, u) {
      var h = wot(e3);
      return h === this ? this.dataToPoint(u) : null;
    }, l3.prototype.convertFromPixel = function(r3, e3, u) {
      var h = wot(e3);
      return h === this ? this.pointToData(u) : null;
    }, l3;
  }();
  function wot(l3) {
    var r3 = l3.seriesModel, e3 = l3.polarModel;
    return e3 && e3.coordinateSystem || r3 && r3.coordinateSystem;
  }
  var O2n = k2n;
  function P2n(l3, r3, e3) {
    var u = r3.get("center"), h = e3.getWidth(), v4 = e3.getHeight();
    l3.cx = za(u[0], h), l3.cy = za(u[1], v4);
    var m3 = l3.getRadiusAxis(), x3 = Math.min(h, v4) / 2, C = r3.get("radius");
    C == null ? C = [0, "100%"] : Ni(C) || (C = [0, C]);
    var A2 = [za(C[0], x3), za(C[1], x3)];
    m3.inverse ? m3.setExtent(A2[1], A2[0]) : m3.setExtent(A2[0], A2[1]);
  }
  function L2n(l3, r3) {
    var e3 = this, u = e3.getAngleAxis(), h = e3.getRadiusAxis();
    if (u.scale.setExtent(1 / 0, -1 / 0), h.scale.setExtent(1 / 0, -1 / 0), l3.eachSeries(function(x3) {
      if (x3.coordinateSystem === e3) {
        var C = x3.getData();
        mt(lhe(C, "radius"), function(A2) {
          h.scale.unionExtentFromData(C, A2);
        }), mt(lhe(C, "angle"), function(A2) {
          u.scale.unionExtentFromData(C, A2);
        });
      }
    }), pj(u.scale, u.model), pj(h.scale, h.model), u.type === "category" && !u.onBand) {
      var v4 = u.getExtent(), m3 = 360 / u.scale.count();
      u.inverse ? v4[1] += m3 : v4[1] -= m3, u.setExtent(v4[0], v4[1]);
    }
  }
  function R2n(l3) {
    return l3.mainType === "angleAxis";
  }
  function Sot(l3, r3) {
    if (l3.type = r3.get("type"), l3.scale = ppe(r3), l3.onBand = r3.get("boundaryGap") && l3.type === "category", l3.inverse = r3.get("inverse"), R2n(r3)) {
      l3.inverse = l3.inverse !== r3.get("clockwise");
      var e3 = r3.get("startAngle");
      l3.setExtent(e3, e3 + (l3.inverse ? -360 : 360));
    }
    r3.axis = l3, l3.model = r3;
  }
  var N2n = { dimensions: Ydt, create: function(l3, r3) {
    var e3 = [];
    return l3.eachComponent("polar", function(u, h) {
      var v4 = new O2n(h + "");
      v4.update = L2n;
      var m3 = v4.getRadiusAxis(), x3 = v4.getAngleAxis(), C = u.findAxisModel("radiusAxis"), A2 = u.findAxisModel("angleAxis");
      Sot(m3, C), Sot(x3, A2), P2n(v4, u, r3), e3.push(v4), u.coordinateSystem = v4, v4.model = u;
    }), l3.eachSeries(function(u) {
      if (u.get("coordinateSystem") === "polar") {
        var h = u.getReferringComponents("polar", Lv).models[0];
        u.coordinateSystem = h.coordinateSystem;
      }
    }), e3;
  } }, F2n = N2n, V2n = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
  function efe(l3, r3, e3) {
    r3[1] > r3[0] && (r3 = r3.slice().reverse());
    var u = l3.coordToPoint([r3[0], e3]), h = l3.coordToPoint([r3[1], e3]);
    return { x1: u[0], y1: u[1], x2: h[0], y2: h[1] };
  }
  function tfe(l3) {
    var r3 = l3.getRadiusAxis();
    return r3.inverse ? 0 : 1;
  }
  function Cot(l3) {
    var r3 = l3[0], e3 = l3[l3.length - 1];
    r3 && e3 && Math.abs(Math.abs(r3.coord - e3.coord) - 360) < 1e-4 && l3.pop();
  }
  var B2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.axisPointerClass = "PolarAxisPointer", e3;
    }
    return r3.prototype.render = function(e3, u) {
      if (this.group.removeAll(), !!e3.get("show")) {
        var h = e3.axis, v4 = h.polar, m3 = v4.getRadiusAxis().getExtent(), x3 = h.getTicksCoords(), C = h.getMinorTicksCoords(), A2 = Bi(h.getViewLabels(), function(D) {
          D = bs(D);
          var P = h.scale, N = P.type === "ordinal" ? P.getRawOrdinalNumber(D.tickValue) : D.tickValue;
          return D.coord = h.dataToCoord(N), D;
        });
        Cot(A2), Cot(x3), mt(V2n, function(D) {
          e3.get([D, "show"]) && (!h.scale.isBlank() || D === "axisLine") && z2n[D](this.group, e3, v4, x3, C, m3, A2);
        }, this);
      }
    }, r3.type = "angleAxis", r3;
  }(eF), z2n = { axisLine: function(l3, r3, e3, u, h, v4) {
    var m3 = r3.getModel(["axisLine", "lineStyle"]), x3 = tfe(e3), C = x3 ? 0 : 1, A2;
    v4[C] === 0 ? A2 = new YA({ shape: { cx: e3.cx, cy: e3.cy, r: v4[x3] }, style: m3.getLineStyle(), z2: 1, silent: true }) : A2 = new Yhe({ shape: { cx: e3.cx, cy: e3.cy, r: v4[x3], r0: v4[C] }, style: m3.getLineStyle(), z2: 1, silent: true }), A2.style.fill = null, l3.add(A2);
  }, axisTick: function(l3, r3, e3, u, h, v4) {
    var m3 = r3.getModel("axisTick"), x3 = (m3.get("inside") ? -1 : 1) * m3.get("length"), C = v4[tfe(e3)], A2 = Bi(u, function(D) {
      return new ty({ shape: efe(e3, [C, C + x3], D.coord) });
    });
    l3.add(d2(A2, { style: ns(m3.getModel("lineStyle").getLineStyle(), { stroke: r3.get(["axisLine", "lineStyle", "color"]) }) }));
  }, minorTick: function(l3, r3, e3, u, h, v4) {
    if (!!h.length) {
      for (var m3 = r3.getModel("axisTick"), x3 = r3.getModel("minorTick"), C = (m3.get("inside") ? -1 : 1) * x3.get("length"), A2 = v4[tfe(e3)], D = [], P = 0; P < h.length; P++)
        for (var N = 0; N < h[P].length; N++)
          D.push(new ty({ shape: efe(e3, [A2, A2 + C], h[P][N].coord) }));
      l3.add(d2(D, { style: ns(x3.getModel("lineStyle").getLineStyle(), ns(m3.getLineStyle(), { stroke: r3.get(["axisLine", "lineStyle", "color"]) })) }));
    }
  }, axisLabel: function(l3, r3, e3, u, h, v4, m3) {
    var x3 = r3.getCategories(true), C = r3.getModel("axisLabel"), A2 = C.get("margin"), D = r3.get("triggerEvent");
    mt(m3, function(P, N) {
      var j = C, W = P.tickValue, K = v4[tfe(e3)], te = e3.coordToPoint([K + A2, P.coord]), ne = e3.cx, ce = e3.cy, me = Math.abs(te[0] - ne) / K < 0.3 ? "center" : te[0] > ne ? "left" : "right", ve = Math.abs(te[1] - ce) / K < 0.3 ? "middle" : te[1] > ce ? "top" : "bottom";
      if (x3 && x3[W]) {
        var Be = x3[W];
        ls(Be) && Be.textStyle && (j = new Bh(Be.textStyle, C, C.ecModel));
      }
      var Oe = new Ec({ silent: h5.isLabelSilent(r3), style: ov(j, { x: te[0], y: te[1], fill: j.getTextColor() || r3.get(["axisLine", "lineStyle", "color"]), text: P.formattedLabel, align: me, verticalAlign: ve }) });
      if (l3.add(Oe), D) {
        var We = h5.makeAxisEventDataBase(r3);
        We.targetType = "axisLabel", We.value = P.rawLabel, Ps(Oe).eventData = We;
      }
    }, this);
  }, splitLine: function(l3, r3, e3, u, h, v4) {
    var m3 = r3.getModel("splitLine"), x3 = m3.getModel("lineStyle"), C = x3.get("color"), A2 = 0;
    C = C instanceof Array ? C : [C];
    for (var D = [], P = 0; P < u.length; P++) {
      var N = A2++ % C.length;
      D[N] = D[N] || [], D[N].push(new ty({ shape: efe(e3, v4, u[P].coord) }));
    }
    for (var P = 0; P < D.length; P++)
      l3.add(d2(D[P], { style: ns({ stroke: C[P % C.length] }, x3.getLineStyle()), silent: true, z: r3.get("z") }));
  }, minorSplitLine: function(l3, r3, e3, u, h, v4) {
    if (!!h.length) {
      for (var m3 = r3.getModel("minorSplitLine"), x3 = m3.getModel("lineStyle"), C = [], A2 = 0; A2 < h.length; A2++)
        for (var D = 0; D < h[A2].length; D++)
          C.push(new ty({ shape: efe(e3, v4, h[A2][D].coord) }));
      l3.add(d2(C, { style: x3.getLineStyle(), silent: true, z: r3.get("z") }));
    }
  }, splitArea: function(l3, r3, e3, u, h, v4) {
    if (!!u.length) {
      var m3 = r3.getModel("splitArea"), x3 = m3.getModel("areaStyle"), C = x3.get("color"), A2 = 0;
      C = C instanceof Array ? C : [C];
      for (var D = [], P = Math.PI / 180, N = -u[0].coord * P, j = Math.min(v4[0], v4[1]), W = Math.max(v4[0], v4[1]), K = r3.get("clockwise"), te = 1, ne = u.length; te <= ne; te++) {
        var ce = te === ne ? u[0].coord : u[te].coord, me = A2++ % C.length;
        D[me] = D[me] || [], D[me].push(new S_({ shape: { cx: e3.cx, cy: e3.cy, r0: j, r: W, startAngle: N, endAngle: -ce * P, clockwise: K }, silent: true })), N = -ce * P;
      }
      for (var te = 0; te < D.length; te++)
        l3.add(d2(D[te], { style: ns({ fill: C[te % C.length] }, x3.getAreaStyle()), silent: true }));
    }
  } }, j2n = B2n, G2n = ["axisLine", "axisTickLabel", "axisName"], H2n = ["splitLine", "splitArea", "minorSplitLine"], W2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.axisPointerClass = "PolarAxisPointer", e3;
    }
    return r3.prototype.render = function(e3, u) {
      if (this.group.removeAll(), !!e3.get("show")) {
        var h = this._axisGroup, v4 = this._axisGroup = new Cs();
        this.group.add(v4);
        var m3 = e3.axis, x3 = m3.polar, C = x3.getAngleAxis(), A2 = m3.getTicksCoords(), D = m3.getMinorTicksCoords(), P = C.getExtent()[0], N = m3.getExtent(), j = q2n(x3, e3, P), W = new h5(e3, j);
        mt(G2n, W.add, W), v4.add(W.getGroup()), LJ(h, v4, e3), mt(H2n, function(K) {
          e3.get([K, "show"]) && !m3.scale.isBlank() && U2n[K](this.group, e3, x3, P, N, A2, D);
        }, this);
      }
    }, r3.type = "radiusAxis", r3;
  }(eF), U2n = { splitLine: function(l3, r3, e3, u, h, v4) {
    var m3 = r3.getModel("splitLine"), x3 = m3.getModel("lineStyle"), C = x3.get("color"), A2 = 0;
    C = C instanceof Array ? C : [C];
    for (var D = [], P = 0; P < v4.length; P++) {
      var N = A2++ % C.length;
      D[N] = D[N] || [], D[N].push(new YA({ shape: { cx: e3.cx, cy: e3.cy, r: v4[P].coord } }));
    }
    for (var P = 0; P < D.length; P++)
      l3.add(d2(D[P], { style: ns({ stroke: C[P % C.length], fill: null }, x3.getLineStyle()), silent: true }));
  }, minorSplitLine: function(l3, r3, e3, u, h, v4, m3) {
    if (!!m3.length) {
      for (var x3 = r3.getModel("minorSplitLine"), C = x3.getModel("lineStyle"), A2 = [], D = 0; D < m3.length; D++)
        for (var P = 0; P < m3[D].length; P++)
          A2.push(new YA({ shape: { cx: e3.cx, cy: e3.cy, r: m3[D][P].coord } }));
      l3.add(d2(A2, { style: ns({ fill: null }, C.getLineStyle()), silent: true }));
    }
  }, splitArea: function(l3, r3, e3, u, h, v4) {
    if (!!v4.length) {
      var m3 = r3.getModel("splitArea"), x3 = m3.getModel("areaStyle"), C = x3.get("color"), A2 = 0;
      C = C instanceof Array ? C : [C];
      for (var D = [], P = v4[0].coord, N = 1; N < v4.length; N++) {
        var j = A2++ % C.length;
        D[j] = D[j] || [], D[j].push(new S_({ shape: { cx: e3.cx, cy: e3.cy, r0: P, r: v4[N].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), P = v4[N].coord;
      }
      for (var N = 0; N < D.length; N++)
        l3.add(d2(D[N], { style: ns({ fill: C[N % C.length] }, x3.getAreaStyle()), silent: true }));
    }
  } };
  function q2n(l3, r3, e3) {
    return { position: [l3.cx, l3.cy], rotation: e3 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: r3.getModel("axisLabel").get("rotate"), z2: 1 };
  }
  var $2n = W2n;
  function Kdt(l3) {
    return l3.get("stack") || "__ec_stack_" + l3.seriesIndex;
  }
  function Zdt(l3, r3) {
    return r3.dim + l3.model.componentIndex;
  }
  function X2n(l3, r3, e3) {
    var u = {}, h = Y2n(jf(r3.getSeriesByType(l3), function(v4) {
      return !r3.isSeriesFiltered(v4) && v4.coordinateSystem && v4.coordinateSystem.type === "polar";
    }));
    r3.eachSeriesByType(l3, function(v4) {
      if (v4.coordinateSystem.type === "polar") {
        var m3 = v4.getData(), x3 = v4.coordinateSystem, C = x3.getBaseAxis(), A2 = Zdt(x3, C), D = Kdt(v4), P = h[A2][D], N = P.offset, j = P.width, W = x3.getOtherAxis(C), K = v4.coordinateSystem.cx, te = v4.coordinateSystem.cy, ne = v4.get("barMinHeight") || 0, ce = v4.get("barMinAngle") || 0;
        u[D] = u[D] || [];
        for (var me = m3.mapDimension(W.dim), ve = m3.mapDimension(C.dim), Be = eP(m3, me), Oe = C.dim !== "radius" || !v4.get("roundCap", true), We = W.dataToCoord(0), Ue = 0, qe = m3.count(); Ue < qe; Ue++) {
          var Ze = m3.get(me, Ue), ct = m3.get(ve, Ue), _t = Ze >= 0 ? "p" : "n", pt = We;
          Be && (u[D][ct] || (u[D][ct] = { p: We, n: We }), pt = u[D][ct][_t]);
          var zt = void 0, Zt = void 0, Ft = void 0, Kn = void 0;
          if (W.dim === "radius") {
            var hn = W.dataToCoord(Ze) - We, xn = C.dataToCoord(ct);
            Math.abs(hn) < ne && (hn = (hn < 0 ? -1 : 1) * ne), zt = pt, Zt = pt + hn, Ft = xn - N, Kn = Ft - j, Be && (u[D][ct][_t] = Zt);
          } else {
            var zn = W.dataToCoord(Ze, Oe) - We, or = C.dataToCoord(ct);
            Math.abs(zn) < ce && (zn = (zn < 0 ? -1 : 1) * ce), zt = or + N, Zt = zt + j, Ft = pt, Kn = pt + zn, Be && (u[D][ct][_t] = Kn);
          }
          m3.setItemLayout(Ue, { cx: K, cy: te, r0: zt, r: Zt, startAngle: -Ft * Math.PI / 180, endAngle: -Kn * Math.PI / 180, clockwise: Ft >= Kn });
        }
      }
    });
  }
  function Y2n(l3) {
    var r3 = {};
    mt(l3, function(u, h) {
      var v4 = u.getData(), m3 = u.coordinateSystem, x3 = m3.getBaseAxis(), C = Zdt(m3, x3), A2 = x3.getExtent(), D = x3.type === "category" ? x3.getBandWidth() : Math.abs(A2[1] - A2[0]) / v4.count(), P = r3[C] || { bandWidth: D, remainedWidth: D, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, N = P.stacks;
      r3[C] = P;
      var j = Kdt(u);
      N[j] || P.autoWidthCount++, N[j] = N[j] || { width: 0, maxWidth: 0 };
      var W = za(u.get("barWidth"), D), K = za(u.get("barMaxWidth"), D), te = u.get("barGap"), ne = u.get("barCategoryGap");
      W && !N[j].width && (W = Math.min(P.remainedWidth, W), N[j].width = W, P.remainedWidth -= W), K && (N[j].maxWidth = K), te != null && (P.gap = te), ne != null && (P.categoryGap = ne);
    });
    var e3 = {};
    return mt(r3, function(u, h) {
      e3[h] = {};
      var v4 = u.stacks, m3 = u.bandWidth, x3 = za(u.categoryGap, m3), C = za(u.gap, 1), A2 = u.remainedWidth, D = u.autoWidthCount, P = (A2 - x3) / (D + (D - 1) * C);
      P = Math.max(P, 0), mt(v4, function(K, te) {
        var ne = K.maxWidth;
        ne && ne < P && (ne = Math.min(ne, A2), K.width && (ne = Math.min(ne, K.width)), A2 -= ne, K.width = ne, D--);
      }), P = (A2 - x3) / (D + (D - 1) * C), P = Math.max(P, 0);
      var N = 0, j;
      mt(v4, function(K, te) {
        K.width || (K.width = P), j = K, N += K.width * (1 + C);
      }), j && (N -= j.width * C);
      var W = -N / 2;
      mt(v4, function(K, te) {
        e3[h][te] = e3[h][te] || { offset: W, width: K.width }, W += K.width * (1 + C);
      });
    }), e3;
  }
  var K2n = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, Z2n = { splitNumber: 5 }, J2n = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "polar", r3;
  }(yd);
  function Q2n(l3) {
    kl(KJ), eF.registerAxisPointerClass("PolarAxisPointer", S2n), l3.registerCoordinateSystem("polar", F2n), l3.registerComponentModel(M2n), l3.registerComponentView(J2n), vj(l3, "angle", T2n, K2n), vj(l3, "radius", A2n, Z2n), l3.registerComponentView(j2n), l3.registerComponentView($2n), l3.registerLayout(Fs(X2n, "bar"));
  }
  function Hke(l3, r3) {
    r3 = r3 || {};
    var e3 = l3.coordinateSystem, u = l3.axis, h = {}, v4 = u.position, m3 = u.orient, x3 = e3.getRect(), C = [x3.x, x3.x + x3.width, x3.y, x3.y + x3.height], A2 = { horizontal: { top: C[2], bottom: C[3] }, vertical: { left: C[0], right: C[1] } };
    h.position = [m3 === "vertical" ? A2.vertical[v4] : C[0], m3 === "horizontal" ? A2.horizontal[v4] : C[3]];
    var D = { horizontal: 0, vertical: 1 };
    h.rotation = Math.PI / 2 * D[m3];
    var P = { top: -1, bottom: 1, right: 1, left: -1 };
    h.labelDirection = h.tickDirection = h.nameDirection = P[v4], l3.get(["axisTick", "inside"]) && (h.tickDirection = -h.tickDirection), ey(r3.labelInside, l3.get(["axisLabel", "inside"])) && (h.labelDirection = -h.labelDirection);
    var N = r3.rotate;
    return N == null && (N = l3.get(["axisLabel", "rotate"])), h.labelRotation = v4 === "top" ? -N : N, h.z2 = 1, h;
  }
  var eCn = ["axisLine", "axisTickLabel", "axisName"], tCn = ["splitArea", "splitLine"], nCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.axisPointerClass = "SingleAxisPointer", e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      var m3 = this.group;
      m3.removeAll();
      var x3 = this._axisGroup;
      this._axisGroup = new Cs();
      var C = Hke(e3), A2 = new h5(e3, C);
      mt(eCn, A2.add, A2), m3.add(this._axisGroup), m3.add(A2.getGroup()), mt(tCn, function(D) {
        e3.get([D, "show"]) && rCn[D](this, this.group, this._axisGroup, e3);
      }, this), LJ(x3, this._axisGroup, e3), l3.prototype.render.call(this, e3, u, h, v4);
    }, r3.prototype.remove = function() {
      gpt(this);
    }, r3.type = "singleAxis", r3;
  }(eF), rCn = { splitLine: function(l3, r3, e3, u) {
    var h = u.axis;
    if (!h.scale.isBlank()) {
      var v4 = u.getModel("splitLine"), m3 = v4.getModel("lineStyle"), x3 = m3.get("color");
      x3 = x3 instanceof Array ? x3 : [x3];
      for (var C = u.coordinateSystem.getRect(), A2 = h.isHorizontal(), D = [], P = 0, N = h.getTicksCoords({ tickModel: v4 }), j = [], W = [], K = 0; K < N.length; ++K) {
        var te = h.toGlobalCoord(N[K].coord);
        A2 ? (j[0] = te, j[1] = C.y, W[0] = te, W[1] = C.y + C.height) : (j[0] = C.x, j[1] = te, W[0] = C.x + C.width, W[1] = te);
        var ne = P++ % x3.length;
        D[ne] = D[ne] || [], D[ne].push(new ty({ subPixelOptimize: true, shape: { x1: j[0], y1: j[1], x2: W[0], y2: W[1] }, silent: true }));
      }
      for (var ce = m3.getLineStyle(["color"]), K = 0; K < D.length; ++K)
        r3.add(d2(D[K], { style: ns({ stroke: x3[K % x3.length] }, ce), silent: true }));
    }
  }, splitArea: function(l3, r3, e3, u) {
    vpt(l3, e3, u, u);
  } }, iCn = nCn, Jdt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.getCoordSysModel = function() {
      return this;
    }, r3.type = "singleAxis", r3.layoutMode = "box", r3.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, r3;
  }(fc);
  Fv(Jdt, GJ.prototype);
  var jDe = Jdt, aCn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4, m3) {
      var x3 = l3.call(this, e3, u, h) || this;
      return x3.type = v4 || "value", x3.position = m3 || "bottom", x3;
    }
    return r3.prototype.isHorizontal = function() {
      var e3 = this.position;
      return e3 === "top" || e3 === "bottom";
    }, r3.prototype.pointToData = function(e3, u) {
      return this.coordinateSystem.pointToData(e3)[0];
    }, r3;
  }(bM), oCn = aCn, Qdt = ["single"], sCn = function() {
    function l3(r3, e3, u) {
      this.type = "single", this.dimension = "single", this.dimensions = Qdt, this.axisPointerEnabled = true, this.model = r3, this._init(r3, e3, u);
    }
    return l3.prototype._init = function(r3, e3, u) {
      var h = this.dimension, v4 = new oCn(h, ppe(r3), [0, 0], r3.get("type"), r3.get("position")), m3 = v4.type === "category";
      v4.onBand = m3 && r3.get("boundaryGap"), v4.inverse = r3.get("inverse"), v4.orient = r3.get("orient"), r3.axis = v4, v4.model = r3, v4.coordinateSystem = this, this._axis = v4;
    }, l3.prototype.update = function(r3, e3) {
      r3.eachSeries(function(u) {
        if (u.coordinateSystem === this) {
          var h = u.getData();
          mt(h.mapDimensionsAll(this.dimension), function(v4) {
            this._axis.scale.unionExtentFromData(h, v4);
          }, this), pj(this._axis.scale, this._axis.model);
        }
      }, this);
    }, l3.prototype.resize = function(r3, e3) {
      this._rect = dg({ left: r3.get("left"), top: r3.get("top"), right: r3.get("right"), bottom: r3.get("bottom"), width: r3.get("width"), height: r3.get("height") }, { width: e3.getWidth(), height: e3.getHeight() }), this._adjustAxis();
    }, l3.prototype.getRect = function() {
      return this._rect;
    }, l3.prototype._adjustAxis = function() {
      var r3 = this._rect, e3 = this._axis, u = e3.isHorizontal(), h = u ? [0, r3.width] : [0, r3.height], v4 = e3.reverse ? 1 : 0;
      e3.setExtent(h[v4], h[1 - v4]), this._updateAxisTransform(e3, u ? r3.x : r3.y);
    }, l3.prototype._updateAxisTransform = function(r3, e3) {
      var u = r3.getExtent(), h = u[0] + u[1], v4 = r3.isHorizontal();
      r3.toGlobalCoord = v4 ? function(m3) {
        return m3 + e3;
      } : function(m3) {
        return h - m3 + e3;
      }, r3.toLocalCoord = v4 ? function(m3) {
        return m3 - e3;
      } : function(m3) {
        return h - m3 + e3;
      };
    }, l3.prototype.getAxis = function() {
      return this._axis;
    }, l3.prototype.getBaseAxis = function() {
      return this._axis;
    }, l3.prototype.getAxes = function() {
      return [this._axis];
    }, l3.prototype.getTooltipAxes = function() {
      return { baseAxes: [this.getAxis()], otherAxes: [] };
    }, l3.prototype.containPoint = function(r3) {
      var e3 = this.getRect(), u = this.getAxis(), h = u.orient;
      return h === "horizontal" ? u.contain(u.toLocalCoord(r3[0])) && r3[1] >= e3.y && r3[1] <= e3.y + e3.height : u.contain(u.toLocalCoord(r3[1])) && r3[0] >= e3.y && r3[0] <= e3.y + e3.height;
    }, l3.prototype.pointToData = function(r3) {
      var e3 = this.getAxis();
      return [e3.coordToData(e3.toLocalCoord(r3[e3.orient === "horizontal" ? 0 : 1]))];
    }, l3.prototype.dataToPoint = function(r3) {
      var e3 = this.getAxis(), u = this.getRect(), h = [], v4 = e3.orient === "horizontal" ? 0 : 1;
      return r3 instanceof Array && (r3 = r3[0]), h[v4] = e3.toGlobalCoord(e3.dataToCoord(+r3)), h[1 - v4] = v4 === 0 ? u.y + u.height / 2 : u.x + u.width / 2, h;
    }, l3.prototype.convertToPixel = function(r3, e3, u) {
      var h = Mot(e3);
      return h === this ? this.dataToPoint(u) : null;
    }, l3.prototype.convertFromPixel = function(r3, e3, u) {
      var h = Mot(e3);
      return h === this ? this.pointToData(u) : null;
    }, l3;
  }();
  function Mot(l3) {
    var r3 = l3.seriesModel, e3 = l3.singleAxisModel;
    return e3 && e3.coordinateSystem || r3 && r3.coordinateSystem;
  }
  function lCn(l3, r3) {
    var e3 = [];
    return l3.eachComponent("singleAxis", function(u, h) {
      var v4 = new sCn(u, l3, r3);
      v4.name = "single_" + h, v4.resize(u, r3), u.coordinateSystem = v4, e3.push(v4);
    }), l3.eachSeries(function(u) {
      if (u.get("coordinateSystem") === "singleAxis") {
        var h = u.getReferringComponents("singleAxis", Lv).models[0];
        u.coordinateSystem = h && h.coordinateSystem;
      }
    }), e3;
  }
  var uCn = { create: lCn, dimensions: Qdt }, cCn = uCn, Tot = ["x", "y"], fCn = ["width", "height"], hCn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.makeElOption = function(e3, u, h, v4, m3) {
      var x3 = h.axis, C = x3.coordinateSystem, A2 = GDe(C, 1 - She(x3)), D = C.dataToPoint(u)[0], P = v4.get("type");
      if (P && P !== "none") {
        var N = uPe(v4), j = pCn[P](x3, D, A2);
        j.style = N, e3.graphicKey = j.type, e3.pointer = j;
      }
      var W = Hke(h);
      Udt(u, e3, W, h, v4, m3);
    }, r3.prototype.getHandleTransform = function(e3, u, h) {
      var v4 = Hke(u, { labelInside: false });
      v4.labelMargin = h.get(["handle", "margin"]);
      var m3 = cPe(u.axis, e3, v4);
      return { x: m3[0], y: m3[1], rotation: v4.rotation + (v4.labelDirection < 0 ? Math.PI : 0) };
    }, r3.prototype.updateHandleTransform = function(e3, u, h, v4) {
      var m3 = h.axis, x3 = m3.coordinateSystem, C = She(m3), A2 = GDe(x3, C), D = [e3.x, e3.y];
      D[C] += u[C], D[C] = Math.min(A2[1], D[C]), D[C] = Math.max(A2[0], D[C]);
      var P = GDe(x3, 1 - C), N = (P[1] + P[0]) / 2, j = [N, N];
      return j[C] = D[C], { x: D[0], y: D[1], rotation: e3.rotation, cursorPoint: j, tooltipOption: { verticalAlign: "middle" } };
    }, r3;
  }(lPe), pCn = { line: function(l3, r3, e3) {
    var u = fPe([r3, e3[0]], [r3, e3[1]], She(l3));
    return { type: "Line", subPixelOptimize: true, shape: u };
  }, shadow: function(l3, r3, e3) {
    var u = l3.getBandWidth(), h = e3[1] - e3[0];
    return { type: "Rect", shape: qdt([r3 - u / 2, e3[0]], [u, h], She(l3)) };
  } };
  function She(l3) {
    return l3.isHorizontal() ? 0 : 1;
  }
  function GDe(l3, r3) {
    var e3 = l3.getRect();
    return [e3[Tot[r3]], e3[Tot[r3]] + e3[fCn[r3]]];
  }
  var dCn = hCn, vCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "single", r3;
  }(yd);
  function gCn(l3) {
    kl(KJ), eF.registerAxisPointerClass("SingleAxisPointer", dCn), l3.registerComponentView(vCn), l3.registerComponentView(iCn), l3.registerComponentModel(jDe), vj(l3, "single", jDe, jDe.defaultOption), l3.registerCoordinateSystem("single", cCn);
  }
  var yCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      var v4 = Ij(e3);
      l3.prototype.init.apply(this, arguments), Aot(e3, v4);
    }, r3.prototype.mergeOption = function(e3) {
      l3.prototype.mergeOption.apply(this, arguments), Aot(this.option, e3);
    }, r3.prototype.getCellSize = function() {
      return this.option.cellSize;
    }, r3.type = "calendar", r3.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, r3;
  }(fc);
  function Aot(l3, r3) {
    var e3 = l3.cellSize, u;
    Ni(e3) ? u = e3 : u = l3.cellSize = [e3, e3], u.length === 1 && (u[1] = u[0]);
    var h = Bi([0, 1], function(v4) {
      return Sfn(r3, v4) && (u[v4] = "auto"), u[v4] != null && u[v4] !== "auto";
    });
    QO(l3, r3, { type: "box", ignoreSize: h });
  }
  var mCn = yCn, bCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4 = this.group;
      v4.removeAll();
      var m3 = e3.coordinateSystem, x3 = m3.getRangeInfo(), C = m3.getOrient(), A2 = u.getLocaleModel();
      this._renderDayRect(e3, x3, v4), this._renderLines(e3, x3, C, v4), this._renderYearText(e3, x3, C, v4), this._renderMonthText(e3, A2, C, v4), this._renderWeekText(e3, A2, x3, C, v4);
    }, r3.prototype._renderDayRect = function(e3, u, h) {
      for (var v4 = e3.coordinateSystem, m3 = e3.getModel("itemStyle").getItemStyle(), x3 = v4.getCellWidth(), C = v4.getCellHeight(), A2 = u.start.time; A2 <= u.end.time; A2 = v4.getNextNDay(A2, 1).time) {
        var D = v4.dataToRect([A2], false).tl, P = new Ju({ shape: { x: D[0], y: D[1], width: x3, height: C }, cursor: "default", style: m3 });
        h.add(P);
      }
    }, r3.prototype._renderLines = function(e3, u, h, v4) {
      var m3 = this, x3 = e3.coordinateSystem, C = e3.getModel(["splitLine", "lineStyle"]).getLineStyle(), A2 = e3.get(["splitLine", "show"]), D = C.lineWidth;
      this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
      for (var P = u.start, N = 0; P.time <= u.end.time; N++) {
        W(P.formatedDate), N === 0 && (P = x3.getDateInfo(u.start.y + "-" + u.start.m));
        var j = P.date;
        j.setMonth(j.getMonth() + 1), P = x3.getDateInfo(j);
      }
      W(x3.getNextNDay(u.end.time, 1).formatedDate);
      function W(K) {
        m3._firstDayOfMonth.push(x3.getDateInfo(K)), m3._firstDayPoints.push(x3.dataToRect([K], false).tl);
        var te = m3._getLinePointsOfOneWeek(e3, K, h);
        m3._tlpoints.push(te[0]), m3._blpoints.push(te[te.length - 1]), A2 && m3._drawSplitline(te, C, v4);
      }
      A2 && this._drawSplitline(m3._getEdgesPoints(m3._tlpoints, D, h), C, v4), A2 && this._drawSplitline(m3._getEdgesPoints(m3._blpoints, D, h), C, v4);
    }, r3.prototype._getEdgesPoints = function(e3, u, h) {
      var v4 = [e3[0].slice(), e3[e3.length - 1].slice()], m3 = h === "horizontal" ? 0 : 1;
      return v4[0][m3] = v4[0][m3] - u / 2, v4[1][m3] = v4[1][m3] + u / 2, v4;
    }, r3.prototype._drawSplitline = function(e3, u, h) {
      var v4 = new M_({ z2: 20, shape: { points: e3 }, style: u });
      h.add(v4);
    }, r3.prototype._getLinePointsOfOneWeek = function(e3, u, h) {
      for (var v4 = e3.coordinateSystem, m3 = v4.getDateInfo(u), x3 = [], C = 0; C < 7; C++) {
        var A2 = v4.getNextNDay(m3.time, C), D = v4.dataToRect([A2.time], false);
        x3[2 * A2.day] = D.tl, x3[2 * A2.day + 1] = D[h === "horizontal" ? "bl" : "tr"];
      }
      return x3;
    }, r3.prototype._formatterLabel = function(e3, u) {
      return qa(e3) && e3 ? _fn(e3, u) : Xo(e3) ? e3(u) : u.nameMap;
    }, r3.prototype._yearTextPositionControl = function(e3, u, h, v4, m3) {
      var x3 = u[0], C = u[1], A2 = ["center", "bottom"];
      v4 === "bottom" ? (C += m3, A2 = ["center", "top"]) : v4 === "left" ? x3 -= m3 : v4 === "right" ? (x3 += m3, A2 = ["center", "top"]) : C -= m3;
      var D = 0;
      return (v4 === "left" || v4 === "right") && (D = Math.PI / 2), { rotation: D, x: x3, y: C, style: { align: A2[0], verticalAlign: A2[1] } };
    }, r3.prototype._renderYearText = function(e3, u, h, v4) {
      var m3 = e3.getModel("yearLabel");
      if (!!m3.get("show")) {
        var x3 = m3.get("margin"), C = m3.get("position");
        C || (C = h !== "horizontal" ? "top" : "left");
        var A2 = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], D = (A2[0][0] + A2[1][0]) / 2, P = (A2[0][1] + A2[1][1]) / 2, N = h === "horizontal" ? 0 : 1, j = { top: [D, A2[N][1]], bottom: [D, A2[1 - N][1]], left: [A2[1 - N][0], P], right: [A2[N][0], P] }, W = u.start.y;
        +u.end.y > +u.start.y && (W = W + "-" + u.end.y);
        var K = m3.get("formatter"), te = { start: u.start.y, end: u.end.y, nameMap: W }, ne = this._formatterLabel(K, te), ce = new Ec({ z2: 30, style: ov(m3, { text: ne }) });
        ce.attr(this._yearTextPositionControl(ce, j[C], h, C, x3)), v4.add(ce);
      }
    }, r3.prototype._monthTextPositionControl = function(e3, u, h, v4, m3) {
      var x3 = "left", C = "top", A2 = e3[0], D = e3[1];
      return h === "horizontal" ? (D = D + m3, u && (x3 = "center"), v4 === "start" && (C = "bottom")) : (A2 = A2 + m3, u && (C = "middle"), v4 === "start" && (x3 = "right")), { x: A2, y: D, align: x3, verticalAlign: C };
    }, r3.prototype._renderMonthText = function(e3, u, h, v4) {
      var m3 = e3.getModel("monthLabel");
      if (!!m3.get("show")) {
        var x3 = m3.get("nameMap"), C = m3.get("margin"), A2 = m3.get("position"), D = m3.get("align"), P = [this._tlpoints, this._blpoints];
        (!x3 || qa(x3)) && (x3 && (u = Q5e(x3) || u), x3 = u.get(["time", "monthAbbr"]) || []);
        var N = A2 === "start" ? 0 : 1, j = h === "horizontal" ? 0 : 1;
        C = A2 === "start" ? -C : C;
        for (var W = D === "center", K = 0; K < P[N].length - 1; K++) {
          var te = P[N][K].slice(), ne = this._firstDayOfMonth[K];
          if (W) {
            var ce = this._firstDayPoints[K];
            te[j] = (ce[j] + P[0][K + 1][j]) / 2;
          }
          var me = m3.get("formatter"), ve = x3[+ne.m - 1], Be = { yyyy: ne.y, yy: (ne.y + "").slice(2), MM: ne.m, M: +ne.m, nameMap: ve }, Oe = this._formatterLabel(me, Be), We = new Ec({ z2: 30, style: fi(ov(m3, { text: Oe }), this._monthTextPositionControl(te, W, h, A2, C)) });
          v4.add(We);
        }
      }
    }, r3.prototype._weekTextPositionControl = function(e3, u, h, v4, m3) {
      var x3 = "center", C = "middle", A2 = e3[0], D = e3[1], P = h === "start";
      return u === "horizontal" ? (A2 = A2 + v4 + (P ? 1 : -1) * m3[0] / 2, x3 = P ? "right" : "left") : (D = D + v4 + (P ? 1 : -1) * m3[1] / 2, C = P ? "bottom" : "top"), { x: A2, y: D, align: x3, verticalAlign: C };
    }, r3.prototype._renderWeekText = function(e3, u, h, v4, m3) {
      var x3 = e3.getModel("dayLabel");
      if (!!x3.get("show")) {
        var C = e3.coordinateSystem, A2 = x3.get("position"), D = x3.get("nameMap"), P = x3.get("margin"), N = C.getFirstDayOfWeek();
        if (!D || qa(D)) {
          D && (u = Q5e(D) || u);
          var j = u.get(["time", "dayOfWeekShort"]);
          D = j || Bi(u.get(["time", "dayOfWeekAbbr"]), function(Be) {
            return Be[0];
          });
        }
        var W = C.getNextNDay(h.end.time, 7 - h.lweek).time, K = [C.getCellWidth(), C.getCellHeight()];
        P = za(P, Math.min(K[1], K[0])), A2 === "start" && (W = C.getNextNDay(h.start.time, -(7 + h.fweek)).time, P = -P);
        for (var te = 0; te < 7; te++) {
          var ne = C.getNextNDay(W, te), ce = C.dataToRect([ne.time], false).center, me = te;
          me = Math.abs((te + N) % 7);
          var ve = new Ec({ z2: 30, style: fi(ov(x3, { text: D[me] }), this._weekTextPositionControl(ce, v4, A2, P, K)) });
          m3.add(ve);
        }
      }
    }, r3.type = "calendar", r3;
  }(yd), _Cn = bCn, HDe = 864e5, xCn = function() {
    function l3(r3, e3, u) {
      this.type = "calendar", this.dimensions = l3.dimensions, this.getDimensionsInfo = l3.getDimensionsInfo, this._model = r3;
    }
    return l3.getDimensionsInfo = function() {
      return [{ name: "time", type: "time" }, "value"];
    }, l3.prototype.getRangeInfo = function() {
      return this._rangeInfo;
    }, l3.prototype.getModel = function() {
      return this._model;
    }, l3.prototype.getRect = function() {
      return this._rect;
    }, l3.prototype.getCellWidth = function() {
      return this._sw;
    }, l3.prototype.getCellHeight = function() {
      return this._sh;
    }, l3.prototype.getOrient = function() {
      return this._orient;
    }, l3.prototype.getFirstDayOfWeek = function() {
      return this._firstDayOfWeek;
    }, l3.prototype.getDateInfo = function(r3) {
      r3 = $A(r3);
      var e3 = r3.getFullYear(), u = r3.getMonth() + 1, h = u < 10 ? "0" + u : "" + u, v4 = r3.getDate(), m3 = v4 < 10 ? "0" + v4 : "" + v4, x3 = r3.getDay();
      return x3 = Math.abs((x3 + 7 - this.getFirstDayOfWeek()) % 7), { y: e3 + "", m: h, d: m3, day: x3, time: r3.getTime(), formatedDate: e3 + "-" + h + "-" + m3, date: r3 };
    }, l3.prototype.getNextNDay = function(r3, e3) {
      return e3 = e3 || 0, e3 === 0 ? this.getDateInfo(r3) : (r3 = new Date(this.getDateInfo(r3).time), r3.setDate(r3.getDate() + e3), this.getDateInfo(r3));
    }, l3.prototype.update = function(r3, e3) {
      this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
      var u = this._rangeInfo.weeks || 1, h = ["width", "height"], v4 = this._model.getCellSize().slice(), m3 = this._model.getBoxLayoutParams(), x3 = this._orient === "horizontal" ? [u, 7] : [7, u];
      mt([0, 1], function(P) {
        D(v4, P) && (m3[h[P]] = v4[P] * x3[P]);
      });
      var C = { width: e3.getWidth(), height: e3.getHeight() }, A2 = this._rect = dg(m3, C);
      mt([0, 1], function(P) {
        D(v4, P) || (v4[P] = A2[h[P]] / x3[P]);
      });
      function D(P, N) {
        return P[N] != null && P[N] !== "auto";
      }
      this._sw = v4[0], this._sh = v4[1];
    }, l3.prototype.dataToPoint = function(r3, e3) {
      Ni(r3) && (r3 = r3[0]), e3 == null && (e3 = true);
      var u = this.getDateInfo(r3), h = this._rangeInfo, v4 = u.formatedDate;
      if (e3 && !(u.time >= h.start.time && u.time < h.end.time + HDe))
        return [NaN, NaN];
      var m3 = u.day, x3 = this._getRangeInfo([h.start.time, v4]).nthWeek;
      return this._orient === "vertical" ? [this._rect.x + m3 * this._sw + this._sw / 2, this._rect.y + x3 * this._sh + this._sh / 2] : [this._rect.x + x3 * this._sw + this._sw / 2, this._rect.y + m3 * this._sh + this._sh / 2];
    }, l3.prototype.pointToData = function(r3) {
      var e3 = this.pointToDate(r3);
      return e3 && e3.time;
    }, l3.prototype.dataToRect = function(r3, e3) {
      var u = this.dataToPoint(r3, e3);
      return { contentShape: { x: u[0] - (this._sw - this._lineWidth) / 2, y: u[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: u, tl: [u[0] - this._sw / 2, u[1] - this._sh / 2], tr: [u[0] + this._sw / 2, u[1] - this._sh / 2], br: [u[0] + this._sw / 2, u[1] + this._sh / 2], bl: [u[0] - this._sw / 2, u[1] + this._sh / 2] };
    }, l3.prototype.pointToDate = function(r3) {
      var e3 = Math.floor((r3[0] - this._rect.x) / this._sw) + 1, u = Math.floor((r3[1] - this._rect.y) / this._sh) + 1, h = this._rangeInfo.range;
      return this._orient === "vertical" ? this._getDateByWeeksAndDay(u, e3 - 1, h) : this._getDateByWeeksAndDay(e3, u - 1, h);
    }, l3.prototype.convertToPixel = function(r3, e3, u) {
      var h = Iot(e3);
      return h === this ? h.dataToPoint(u) : null;
    }, l3.prototype.convertFromPixel = function(r3, e3, u) {
      var h = Iot(e3);
      return h === this ? h.pointToData(u) : null;
    }, l3.prototype.containPoint = function(r3) {
      return console.warn("Not implemented."), false;
    }, l3.prototype._initRangeOption = function() {
      var r3 = this._model.get("range"), e3;
      if (Ni(r3) && r3.length === 1 && (r3 = r3[0]), Ni(r3))
        e3 = r3;
      else {
        var u = r3.toString();
        if (/^\d{4}$/.test(u) && (e3 = [u + "-01-01", u + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(u)) {
          var h = this.getDateInfo(u), v4 = h.date;
          v4.setMonth(v4.getMonth() + 1);
          var m3 = this.getNextNDay(v4, -1);
          e3 = [h.formatedDate, m3.formatedDate];
        }
        /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(u) && (e3 = [u, u]);
      }
      if (!e3)
        return r3;
      var x3 = this._getRangeInfo(e3);
      return x3.start.time > x3.end.time && e3.reverse(), e3;
    }, l3.prototype._getRangeInfo = function(r3) {
      var e3 = [this.getDateInfo(r3[0]), this.getDateInfo(r3[1])], u;
      e3[0].time > e3[1].time && (u = true, e3.reverse());
      var h = Math.floor(e3[1].time / HDe) - Math.floor(e3[0].time / HDe) + 1, v4 = new Date(e3[0].time), m3 = v4.getDate(), x3 = e3[1].date.getDate();
      v4.setDate(m3 + h - 1);
      var C = v4.getDate();
      if (C !== x3)
        for (var A2 = v4.getTime() - e3[1].time > 0 ? 1 : -1; (C = v4.getDate()) !== x3 && (v4.getTime() - e3[1].time) * A2 > 0; )
          h -= A2, v4.setDate(C - A2);
      var D = Math.floor((h + e3[0].day + 6) / 7), P = u ? -D + 1 : D - 1;
      return u && e3.reverse(), { range: [e3[0].formatedDate, e3[1].formatedDate], start: e3[0], end: e3[1], allDay: h, weeks: D, nthWeek: P, fweek: e3[0].day, lweek: e3[1].day };
    }, l3.prototype._getDateByWeeksAndDay = function(r3, e3, u) {
      var h = this._getRangeInfo(u);
      if (r3 > h.weeks || r3 === 0 && e3 < h.fweek || r3 === h.weeks && e3 > h.lweek)
        return null;
      var v4 = (r3 - 1) * 7 - h.fweek + e3, m3 = new Date(h.start.time);
      return m3.setDate(+h.start.d + v4), this.getDateInfo(m3);
    }, l3.create = function(r3, e3) {
      var u = [];
      return r3.eachComponent("calendar", function(h) {
        var v4 = new l3(h, r3, e3);
        u.push(v4), h.coordinateSystem = v4;
      }), r3.eachSeries(function(h) {
        h.get("coordinateSystem") === "calendar" && (h.coordinateSystem = u[h.get("calendarIndex") || 0]);
      }), u;
    }, l3.dimensions = ["time", "value"], l3;
  }();
  function Iot(l3) {
    var r3 = l3.calendarModel, e3 = l3.seriesModel, u = r3 ? r3.coordinateSystem : e3 ? e3.coordinateSystem : null;
    return u;
  }
  var wCn = xCn;
  function SCn(l3) {
    l3.registerComponentModel(mCn), l3.registerComponentView(_Cn), l3.registerCoordinateSystem("calendar", wCn);
  }
  function CCn(l3, r3) {
    var e3 = l3.existing;
    if (r3.id = l3.keyInfo.id, !r3.type && e3 && (r3.type = e3.type), r3.parentId == null) {
      var u = r3.parentOption;
      u ? r3.parentId = u.id : e3 && (r3.parentId = e3.parentId);
    }
    r3.parentOption = null;
  }
  function Eot(l3, r3) {
    var e3;
    return mt(r3, function(u) {
      l3[u] != null && l3[u] !== "auto" && (e3 = true);
    }), e3;
  }
  function MCn(l3, r3, e3) {
    var u = fi({}, e3), h = l3[r3], v4 = e3.$action || "merge";
    v4 === "merge" ? h ? (ol(h, u, true), QO(h, u, { ignoreSize: true }), Bct(e3, h), nfe(e3, h), nfe(e3, h, "shape"), nfe(e3, h, "style"), nfe(e3, h, "extra"), e3.clipPath = h.clipPath) : l3[r3] = u : v4 === "replace" ? l3[r3] = u : v4 === "remove" && h && (l3[r3] = null);
  }
  var evt = ["transition", "enterFrom", "leaveTo"], TCn = evt.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
  function nfe(l3, r3, e3) {
    if (e3 && (!l3[e3] && r3[e3] && (l3[e3] = {}), l3 = l3[e3], r3 = r3[e3]), !(!l3 || !r3))
      for (var u = e3 ? evt : TCn, h = 0; h < u.length; h++) {
        var v4 = u[h];
        l3[v4] == null && r3[v4] != null && (l3[v4] = r3[v4]);
      }
  }
  function ACn(l3, r3) {
    if (!!l3 && (l3.hv = r3.hv = [Eot(r3, ["left", "right"]), Eot(r3, ["top", "bottom"])], l3.type === "group")) {
      var e3 = l3, u = r3;
      e3.width == null && (e3.width = u.width = 0), e3.height == null && (e3.height = u.height = 0);
    }
  }
  var ICn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.preventAutoZ = true, e3;
    }
    return r3.prototype.mergeOption = function(e3, u) {
      var h = this.option.elements;
      this.option.elements = null, l3.prototype.mergeOption.call(this, e3, u), this.option.elements = h;
    }, r3.prototype.optionUpdated = function(e3, u) {
      var h = this.option, v4 = (u ? h : e3).elements, m3 = h.elements = u ? [] : h.elements, x3 = [];
      this._flatten(v4, x3, null);
      var C = _ut(m3, x3, "normalMerge"), A2 = this._elOptionsToUpdate = [];
      mt(C, function(D, P) {
        var N = D.newOption;
        !N || (A2.push(N), CCn(D, N), MCn(m3, P, N), ACn(m3[P], N));
      }, this), h.elements = jf(m3, function(D) {
        return D && delete D.$action, D != null;
      });
    }, r3.prototype._flatten = function(e3, u, h) {
      mt(e3, function(v4) {
        if (!!v4) {
          h && (v4.parentOption = h), u.push(v4);
          var m3 = v4.children;
          v4.type === "group" && m3 && this._flatten(m3, u, v4), delete v4.children;
        }
      }, this);
    }, r3.prototype.useElOptionsToUpdate = function() {
      var e3 = this._elOptionsToUpdate;
      return this._elOptionsToUpdate = null, e3;
    }, r3.type = "graphic", r3.defaultOption = { elements: [] }, r3;
  }(fc), Dot = { path: null, compoundPath: null, group: Cs, image: lm, text: Ec }, c2 = pc(), ECn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function() {
      this._elMap = Ho();
    }, r3.prototype.render = function(e3, u, h) {
      e3 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = e3, this._updateElements(e3), this._relocate(e3, h);
    }, r3.prototype._updateElements = function(e3) {
      var u = e3.useElOptionsToUpdate();
      if (!!u) {
        var h = this._elMap, v4 = this.group, m3 = e3.get("z"), x3 = e3.get("zlevel");
        mt(u, function(C) {
          var A2 = pg(C.id, null), D = A2 != null ? h.get(A2) : null, P = pg(C.parentId, null), N = P != null ? h.get(P) : v4, j = C.type, W = C.style;
          j === "text" && W && C.hv && C.hv[1] && (W.textVerticalAlign = W.textBaseline = W.verticalAlign = W.align = null);
          var K = C.textContent, te = C.textConfig;
          if (W && Pdt(W, j, !!te, !!K)) {
            var ne = Ldt(W, j, true);
            !te && ne.textConfig && (te = C.textConfig = ne.textConfig), !K && ne.textContent && (K = ne.textContent);
          }
          var ce = DCn(C), me = C.$action || "merge", ve = me === "merge", Be = me === "replace";
          if (ve) {
            var Oe = !D, We = D;
            Oe ? We = kot(A2, N, C.type, h) : (We && (c2(We).isNew = false), Vdt(We)), We && (kfe(We, ce, e3, { isInit: Oe }), Oot(We, C, m3, x3));
          } else if (Be) {
            Pfe(D, C, h, e3);
            var Ue = kot(A2, N, C.type, h);
            Ue && (kfe(Ue, ce, e3, { isInit: true }), Oot(Ue, C, m3, x3));
          } else
            me === "remove" && (Ndt(D, C), Pfe(D, C, h, e3));
          var qe = h.get(A2);
          if (qe && K)
            if (ve) {
              var Ze = qe.getTextContent();
              Ze ? Ze.attr(K) : qe.setTextContent(new Ec(K));
            } else
              Be && qe.setTextContent(new Ec(K));
          if (qe) {
            var ct = C.clipPath;
            if (ct) {
              var _t = ct.type, pt = void 0, Oe = false;
              if (ve) {
                var zt = qe.getClipPath();
                Oe = !zt || c2(zt).type !== _t, pt = Oe ? Wke(_t) : zt;
              } else
                Be && (Oe = true, pt = Wke(_t));
              qe.setClipPath(pt), kfe(pt, ct, e3, { isInit: Oe }), xhe(pt, ct.keyframeAnimation, e3);
            }
            var Zt = c2(qe);
            qe.setTextConfig(te), Zt.option = C, kCn(qe, e3, C), Cj({ el: qe, componentModel: e3, itemName: qe.name, itemTooltipOption: C.tooltip }), xhe(qe, C.keyframeAnimation, e3);
          }
        });
      }
    }, r3.prototype._relocate = function(e3, u) {
      for (var h = e3.option.elements, v4 = this.group, m3 = this._elMap, x3 = u.getWidth(), C = u.getHeight(), A2 = ["x", "y"], D = 0; D < h.length; D++) {
        var P = h[D], N = pg(P.id, null), j = N != null ? m3.get(N) : null;
        if (!(!j || !j.isGroup)) {
          var W = j.parent, K = W === v4, te = c2(j), ne = c2(W);
          te.width = za(te.option.width, K ? x3 : ne.width) || 0, te.height = za(te.option.height, K ? C : ne.height) || 0;
        }
      }
      for (var D = h.length - 1; D >= 0; D--) {
        var P = h[D], N = pg(P.id, null), j = N != null ? m3.get(N) : null;
        if (!!j) {
          var W = j.parent, ne = c2(W), ce = W === v4 ? { width: x3, height: C } : { width: ne.width, height: ne.height }, me = {}, ve = ape(j, P, ce, null, { hv: P.hv, boundingMode: P.bounding }, me);
          if (!c2(j).isNew && ve) {
            for (var Be = P.transition, Oe = {}, We = 0; We < A2.length; We++) {
              var Ue = A2[We], qe = me[Ue];
              Be && (GN(Be) || Cl(Be, Ue) >= 0) ? Oe[Ue] = qe : j[Ue] = qe;
            }
            hc(j, Oe, e3, 0);
          } else
            j.attr(me);
        }
      }
    }, r3.prototype._clear = function() {
      var e3 = this, u = this._elMap;
      u.each(function(h) {
        Pfe(h, c2(h).option, u, e3._lastGraphicModel);
      }), this._elMap = Ho();
    }, r3.prototype.dispose = function() {
      this._clear();
    }, r3.type = "graphic", r3;
  }(yd);
  function Wke(l3) {
    var r3 = vo(Dot, l3) ? Dot[l3] : Y3e(l3), e3 = new r3({});
    return c2(e3).type = l3, e3;
  }
  function kot(l3, r3, e3, u) {
    var h = Wke(e3);
    return r3.add(h), u.set(l3, h), c2(h).id = l3, c2(h).isNew = true, h;
  }
  function Pfe(l3, r3, e3, u) {
    var h = l3 && l3.parent;
    h && (l3.type === "group" && l3.traverse(function(v4) {
      Pfe(v4, r3, e3, u);
    }), xpe(l3, r3, u), e3.removeKey(c2(l3).id));
  }
  function Oot(l3, r3, e3, u) {
    if (!l3.isGroup) {
      var h = l3;
      h.cursor = dl(r3.cursor, x2.prototype.cursor), h.z = dl(r3.z, e3 || 0), h.zlevel = dl(r3.zlevel, u || 0);
      var v4 = r3.z2;
      v4 != null && (h.z2 = v4 || 0);
    }
    mt(yu(r3), function(m3) {
      var x3 = r3[m3];
      m3.indexOf("on") === 0 && Xo(x3) && (l3[m3] = x3);
    }), l3.draggable = r3.draggable, r3.name != null && (l3.name = r3.name), r3.id != null && (l3.id = r3.id);
  }
  function DCn(l3) {
    return l3 = fi({}, l3), mt(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(Vct), function(r3) {
      delete l3[r3];
    }), l3;
  }
  function kCn(l3, r3, e3) {
    var u = Ps(l3).eventData;
    !l3.silent && !l3.ignore && !u && (u = Ps(l3).eventData = { componentType: "graphic", componentIndex: r3.componentIndex, name: l3.name }), u && (u.info = e3.info);
  }
  function OCn(l3) {
    l3.registerComponentModel(ICn), l3.registerComponentView(ECn), l3.registerPreprocessor(function(r3) {
      var e3 = r3.graphic;
      Ni(e3) ? !e3[0] || !e3[0].elements ? r3.graphic = [{ elements: e3 }] : r3.graphic = [r3.graphic[0]] : e3 && !e3.elements && (r3.graphic = [{ elements: [e3] }]);
    });
  }
  var Pot = ["x", "y", "radius", "angle", "single"], PCn = ["cartesian2d", "polar", "singleAxis"];
  function LCn(l3) {
    var r3 = l3.get("coordinateSystem");
    return Cl(PCn, r3) >= 0;
  }
  function WO(l3) {
    return l3 + "Axis";
  }
  function RCn(l3, r3) {
    var e3 = Ho(), u = [], h = Ho();
    l3.eachComponent({ mainType: "dataZoom", query: r3 }, function(D) {
      h.get(D.uid) || x3(D);
    });
    var v4;
    do
      v4 = false, l3.eachComponent("dataZoom", m3);
    while (v4);
    function m3(D) {
      !h.get(D.uid) && C(D) && (x3(D), v4 = true);
    }
    function x3(D) {
      h.set(D.uid, true), u.push(D), A2(D);
    }
    function C(D) {
      var P = false;
      return D.eachTargetAxis(function(N, j) {
        var W = e3.get(N);
        W && W[j] && (P = true);
      }), P;
    }
    function A2(D) {
      D.eachTargetAxis(function(P, N) {
        (e3.get(P) || e3.set(P, []))[N] = true;
      });
    }
    return u;
  }
  function tvt(l3) {
    var r3 = l3.ecModel, e3 = { infoList: [], infoMap: Ho() };
    return l3.eachTargetAxis(function(u, h) {
      var v4 = r3.getComponent(WO(u), h);
      if (!!v4) {
        var m3 = v4.getCoordSysModel();
        if (!!m3) {
          var x3 = m3.uid, C = e3.infoMap.get(x3);
          C || (C = { model: m3, axisModels: [] }, e3.infoList.push(C), e3.infoMap.set(x3, C)), C.axisModels.push(v4);
        }
      }
    }), e3;
  }
  var WDe = function() {
    function l3() {
      this.indexList = [], this.indexMap = [];
    }
    return l3.prototype.add = function(r3) {
      this.indexMap[r3] || (this.indexList.push(r3), this.indexMap[r3] = true);
    }, l3;
  }(), NCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._autoThrottle = true, e3._noTarget = true, e3._rangePropMode = ["percent", "percent"], e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      var v4 = Lot(e3);
      this.settledOption = v4, this.mergeDefaultAndTheme(e3, h), this._doInit(v4);
    }, r3.prototype.mergeOption = function(e3) {
      var u = Lot(e3);
      ol(this.option, e3, true), ol(this.settledOption, u, true), this._doInit(u);
    }, r3.prototype._doInit = function(e3) {
      var u = this.option;
      this._setDefaultThrottle(e3), this._updateRangeUse(e3);
      var h = this.settledOption;
      mt([["start", "startValue"], ["end", "endValue"]], function(v4, m3) {
        this._rangePropMode[m3] === "value" && (u[v4[0]] = h[v4[0]] = null);
      }, this), this._resetTarget();
    }, r3.prototype._resetTarget = function() {
      var e3 = this.get("orient", true), u = this._targetAxisInfoMap = Ho(), h = this._fillSpecifiedTargetAxis(u);
      h ? this._orient = e3 || this._makeAutoOrientByTargetAxis() : (this._orient = e3 || "horizontal", this._fillAutoTargetAxisByOrient(u, this._orient)), this._noTarget = true, u.each(function(v4) {
        v4.indexList.length && (this._noTarget = false);
      }, this);
    }, r3.prototype._fillSpecifiedTargetAxis = function(e3) {
      var u = false;
      return mt(Pot, function(h) {
        var v4 = this.getReferringComponents(WO(h), Yln);
        if (!!v4.specified) {
          u = true;
          var m3 = new WDe();
          mt(v4.models, function(x3) {
            m3.add(x3.componentIndex);
          }), e3.set(h, m3);
        }
      }, this), u;
    }, r3.prototype._fillAutoTargetAxisByOrient = function(e3, u) {
      var h = this.ecModel, v4 = true;
      if (v4) {
        var m3 = u === "vertical" ? "y" : "x", x3 = h.findComponents({ mainType: m3 + "Axis" });
        C(x3, m3);
      }
      if (v4) {
        var x3 = h.findComponents({ mainType: "singleAxis", filter: function(D) {
          return D.get("orient", true) === u;
        } });
        C(x3, "single");
      }
      function C(A2, D) {
        var P = A2[0];
        if (!!P) {
          var N = new WDe();
          if (N.add(P.componentIndex), e3.set(D, N), v4 = false, D === "x" || D === "y") {
            var j = P.getReferringComponents("grid", Lv).models[0];
            j && mt(A2, function(W) {
              P.componentIndex !== W.componentIndex && j === W.getReferringComponents("grid", Lv).models[0] && N.add(W.componentIndex);
            });
          }
        }
      }
      v4 && mt(Pot, function(A2) {
        if (!!v4) {
          var D = h.findComponents({ mainType: WO(A2), filter: function(N) {
            return N.get("type", true) === "category";
          } });
          if (D[0]) {
            var P = new WDe();
            P.add(D[0].componentIndex), e3.set(A2, P), v4 = false;
          }
        }
      }, this);
    }, r3.prototype._makeAutoOrientByTargetAxis = function() {
      var e3;
      return this.eachTargetAxis(function(u) {
        !e3 && (e3 = u);
      }, this), e3 === "y" ? "vertical" : "horizontal";
    }, r3.prototype._setDefaultThrottle = function(e3) {
      if (e3.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
        var u = this.ecModel.option;
        this.option.throttle = u.animation && u.animationDurationUpdate > 0 ? 100 : 20;
      }
    }, r3.prototype._updateRangeUse = function(e3) {
      var u = this._rangePropMode, h = this.get("rangeMode");
      mt([["start", "startValue"], ["end", "endValue"]], function(v4, m3) {
        var x3 = e3[v4[0]] != null, C = e3[v4[1]] != null;
        x3 && !C ? u[m3] = "percent" : !x3 && C ? u[m3] = "value" : h ? u[m3] = h[m3] : x3 && (u[m3] = "percent");
      });
    }, r3.prototype.noTarget = function() {
      return this._noTarget;
    }, r3.prototype.getFirstTargetAxisModel = function() {
      var e3;
      return this.eachTargetAxis(function(u, h) {
        e3 == null && (e3 = this.ecModel.getComponent(WO(u), h));
      }, this), e3;
    }, r3.prototype.eachTargetAxis = function(e3, u) {
      this._targetAxisInfoMap.each(function(h, v4) {
        mt(h.indexList, function(m3) {
          e3.call(u, v4, m3);
        });
      });
    }, r3.prototype.getAxisProxy = function(e3, u) {
      var h = this.getAxisModel(e3, u);
      if (h)
        return h.__dzAxisProxy;
    }, r3.prototype.getAxisModel = function(e3, u) {
      var h = this._targetAxisInfoMap.get(e3);
      if (h && h.indexMap[u])
        return this.ecModel.getComponent(WO(e3), u);
    }, r3.prototype.setRawRange = function(e3) {
      var u = this.option, h = this.settledOption;
      mt([["start", "startValue"], ["end", "endValue"]], function(v4) {
        (e3[v4[0]] != null || e3[v4[1]] != null) && (u[v4[0]] = h[v4[0]] = e3[v4[0]], u[v4[1]] = h[v4[1]] = e3[v4[1]]);
      }, this), this._updateRangeUse(e3);
    }, r3.prototype.setCalculatedRange = function(e3) {
      var u = this.option;
      mt(["start", "startValue", "end", "endValue"], function(h) {
        u[h] = e3[h];
      });
    }, r3.prototype.getPercentRange = function() {
      var e3 = this.findRepresentativeAxisProxy();
      if (e3)
        return e3.getDataPercentWindow();
    }, r3.prototype.getValueRange = function(e3, u) {
      if (e3 == null && u == null) {
        var h = this.findRepresentativeAxisProxy();
        if (h)
          return h.getDataValueWindow();
      } else
        return this.getAxisProxy(e3, u).getDataValueWindow();
    }, r3.prototype.findRepresentativeAxisProxy = function(e3) {
      if (e3)
        return e3.__dzAxisProxy;
      for (var u, h = this._targetAxisInfoMap.keys(), v4 = 0; v4 < h.length; v4++)
        for (var m3 = h[v4], x3 = this._targetAxisInfoMap.get(m3), C = 0; C < x3.indexList.length; C++) {
          var A2 = this.getAxisProxy(m3, x3.indexList[C]);
          if (A2.hostedBy(this))
            return A2;
          u || (u = A2);
        }
      return u;
    }, r3.prototype.getRangePropMode = function() {
      return this._rangePropMode.slice();
    }, r3.prototype.getOrient = function() {
      return this._orient;
    }, r3.type = "dataZoom", r3.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], r3.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, r3;
  }(fc);
  function Lot(l3) {
    var r3 = {};
    return mt(["start", "end", "startValue", "endValue", "throttle"], function(e3) {
      l3.hasOwnProperty(e3) && (r3[e3] = l3[e3]);
    }), r3;
  }
  var SJ = NCn, FCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "dataZoom.select", r3;
  }(SJ), VCn = FCn, BCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      this.dataZoomModel = e3, this.ecModel = u, this.api = h;
    }, r3.type = "dataZoom", r3;
  }(yd), vPe = BCn, zCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "dataZoom.select", r3;
  }(vPe), jCn = zCn, qz = mt, Rot = g2, GCn = function() {
    function l3(r3, e3, u, h) {
      this._dimName = r3, this._axisIndex = e3, this.ecModel = h, this._dataZoomModel = u;
    }
    return l3.prototype.hostedBy = function(r3) {
      return this._dataZoomModel === r3;
    }, l3.prototype.getDataValueWindow = function() {
      return this._valueWindow.slice();
    }, l3.prototype.getDataPercentWindow = function() {
      return this._percentWindow.slice();
    }, l3.prototype.getTargetSeriesModels = function() {
      var r3 = [];
      return this.ecModel.eachSeries(function(e3) {
        if (LCn(e3)) {
          var u = WO(this._dimName), h = e3.getReferringComponents(u, Lv).models[0];
          h && this._axisIndex === h.componentIndex && r3.push(e3);
        }
      }, this), r3;
    }, l3.prototype.getAxisModel = function() {
      return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
    }, l3.prototype.getMinMaxSpan = function() {
      return bs(this._minMaxSpan);
    }, l3.prototype.calculateDataWindow = function(r3) {
      var e3 = this._dataExtent, u = this.getAxisModel(), h = u.axis.scale, v4 = this._dataZoomModel.getRangePropMode(), m3 = [0, 100], x3 = [], C = [], A2;
      qz(["start", "end"], function(N, j) {
        var W = r3[N], K = r3[N + "Value"];
        v4[j] === "percent" ? (W == null && (W = m3[j]), K = h.parse(_f(W, m3, e3))) : (A2 = true, K = K == null ? e3[j] : h.parse(K), W = _f(K, e3, m3)), C[j] = K, x3[j] = W;
      }), Rot(C), Rot(x3);
      var D = this._minMaxSpan;
      A2 ? P(C, x3, e3, m3, false) : P(x3, C, m3, e3, true);
      function P(N, j, W, K, te) {
        var ne = te ? "Span" : "ValueSpan";
        tF(0, N, W, "all", D["min" + ne], D["max" + ne]);
        for (var ce = 0; ce < 2; ce++)
          j[ce] = _f(N[ce], W, K, true), te && (j[ce] = h.parse(j[ce]));
      }
      return { valueWindow: C, percentWindow: x3 };
    }, l3.prototype.reset = function(r3) {
      if (r3 === this._dataZoomModel) {
        var e3 = this.getTargetSeriesModels();
        this._dataExtent = HCn(this, this._dimName, e3), this._updateMinMaxSpan();
        var u = this.calculateDataWindow(r3.settledOption);
        this._valueWindow = u.valueWindow, this._percentWindow = u.percentWindow, this._setAxisModel();
      }
    }, l3.prototype.filterData = function(r3, e3) {
      if (r3 !== this._dataZoomModel)
        return;
      var u = this._dimName, h = this.getTargetSeriesModels(), v4 = r3.get("filterMode"), m3 = this._valueWindow;
      if (v4 === "none")
        return;
      qz(h, function(C) {
        var A2 = C.getData(), D = A2.mapDimensionsAll(u);
        if (!!D.length) {
          if (v4 === "weakFilter") {
            var P = A2.getStore(), N = Bi(D, function(j) {
              return A2.getDimensionIndex(j);
            }, A2);
            A2.filterSelf(function(j) {
              for (var W, K, te, ne = 0; ne < D.length; ne++) {
                var ce = P.get(N[ne], j), me = !isNaN(ce), ve = ce < m3[0], Be = ce > m3[1];
                if (me && !ve && !Be)
                  return true;
                me && (te = true), ve && (W = true), Be && (K = true);
              }
              return te && W && K;
            });
          } else
            qz(D, function(j) {
              if (v4 === "empty")
                C.setData(A2 = A2.map(j, function(K) {
                  return x3(K) ? K : NaN;
                }));
              else {
                var W = {};
                W[j] = m3, A2.selectRange(W);
              }
            });
          qz(D, function(j) {
            A2.setApproximateExtent(m3, j);
          });
        }
      });
      function x3(C) {
        return C >= m3[0] && C <= m3[1];
      }
    }, l3.prototype._updateMinMaxSpan = function() {
      var r3 = this._minMaxSpan = {}, e3 = this._dataZoomModel, u = this._dataExtent;
      qz(["min", "max"], function(h) {
        var v4 = e3.get(h + "Span"), m3 = e3.get(h + "ValueSpan");
        m3 != null && (m3 = this.getAxisModel().axis.scale.parse(m3)), m3 != null ? v4 = _f(u[0] + m3, u, [0, 100], true) : v4 != null && (m3 = _f(v4, [0, 100], u, true) - u[0]), r3[h + "Span"] = v4, r3[h + "ValueSpan"] = m3;
      }, this);
    }, l3.prototype._setAxisModel = function() {
      var r3 = this.getAxisModel(), e3 = this._percentWindow, u = this._valueWindow;
      if (!!e3) {
        var h = hut(u, [0, 500]);
        h = Math.min(h, 20);
        var v4 = r3.axis.scale.rawExtentInfo;
        e3[0] !== 0 && v4.setDeterminedMinMax("min", +u[0].toFixed(h)), e3[1] !== 100 && v4.setDeterminedMinMax("max", +u[1].toFixed(h)), v4.freeze();
      }
    }, l3;
  }();
  function HCn(l3, r3, e3) {
    var u = [1 / 0, -1 / 0];
    qz(e3, function(m3) {
      pvn(u, m3.getData(), r3);
    });
    var h = l3.getAxisModel(), v4 = bht(h.axis.scale, h, u).calculate();
    return [v4.min, v4.max];
  }
  var WCn = GCn, UCn = { getTargetSeries: function(l3) {
    function r3(h) {
      l3.eachComponent("dataZoom", function(v4) {
        v4.eachTargetAxis(function(m3, x3) {
          var C = l3.getComponent(WO(m3), x3);
          h(m3, x3, C, v4);
        });
      });
    }
    r3(function(h, v4, m3, x3) {
      m3.__dzAxisProxy = null;
    });
    var e3 = [];
    r3(function(h, v4, m3, x3) {
      m3.__dzAxisProxy || (m3.__dzAxisProxy = new WCn(h, v4, x3, l3), e3.push(m3.__dzAxisProxy));
    });
    var u = Ho();
    return mt(e3, function(h) {
      mt(h.getTargetSeriesModels(), function(v4) {
        u.set(v4.uid, v4);
      });
    }), u;
  }, overallReset: function(l3, r3) {
    l3.eachComponent("dataZoom", function(e3) {
      e3.eachTargetAxis(function(u, h) {
        e3.getAxisProxy(u, h).reset(e3);
      }), e3.eachTargetAxis(function(u, h) {
        e3.getAxisProxy(u, h).filterData(e3, r3);
      });
    }), l3.eachComponent("dataZoom", function(e3) {
      var u = e3.findRepresentativeAxisProxy();
      if (u) {
        var h = u.getDataPercentWindow(), v4 = u.getDataValueWindow();
        e3.setCalculatedRange({ start: h[0], end: h[1], startValue: v4[0], endValue: v4[1] });
      }
    });
  } }, qCn = UCn;
  function $Cn(l3) {
    l3.registerAction("dataZoom", function(r3, e3) {
      var u = RCn(e3, r3);
      mt(u, function(h) {
        h.setRawRange({ start: r3.start, end: r3.end, startValue: r3.startValue, endValue: r3.endValue });
      });
    });
  }
  var Not = false;
  function gPe(l3) {
    Not || (Not = true, l3.registerProcessor(l3.PRIORITY.PROCESSOR.FILTER, qCn), $Cn(l3), l3.registerSubTypeDefaulter("dataZoom", function() {
      return "slider";
    }));
  }
  function XCn(l3) {
    l3.registerComponentModel(VCn), l3.registerComponentView(jCn), gPe(l3);
  }
  var h2 = function() {
    function l3() {
    }
    return l3;
  }(), nvt = {};
  function $z(l3, r3) {
    nvt[l3] = r3;
  }
  function rvt(l3) {
    return nvt[l3];
  }
  var YCn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.optionUpdated = function() {
      l3.prototype.optionUpdated.apply(this, arguments);
      var e3 = this.ecModel;
      mt(this.option.feature, function(u, h) {
        var v4 = rvt(h);
        v4 && (v4.getDefaultOption && (v4.defaultOption = v4.getDefaultOption(e3)), ol(u, v4.defaultOption));
      });
    }, r3.type = "toolbox", r3.layoutMode = { type: "box", ignoreSize: true }, r3.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, r3;
  }(fc), KCn = YCn;
  function ZCn(l3, r3, e3) {
    var u = r3.getBoxLayoutParams(), h = r3.get("padding"), v4 = { width: e3.getWidth(), height: e3.getHeight() }, m3 = dg(u, v4, h);
    BN(r3.get("orient"), l3, r3.get("itemGap"), m3.width, m3.height), ape(l3, u, v4, h);
  }
  function ivt(l3, r3) {
    var e3 = Aj(r3.get("padding")), u = r3.getItemStyle(["color", "opacity"]);
    return u.fill = r3.get("backgroundColor"), l3 = new Ju({ shape: { x: l3.x - e3[3], y: l3.y - e3[0], width: l3.width + e3[1] + e3[3], height: l3.height + e3[0] + e3[2], r: r3.get("borderRadius") }, style: u, silent: true, z2: -1 }), l3;
  }
  var JCn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      var m3 = this.group;
      if (m3.removeAll(), !e3.get("show"))
        return;
      var x3 = +e3.get("itemSize"), C = e3.get("feature") || {}, A2 = this._features || (this._features = {}), D = [];
      mt(C, function(j, W) {
        D.push(W);
      }), new f5(this._featureNames || [], D).add(P).update(P).remove(Fs(P, null)).execute(), this._featureNames = D;
      function P(j, W) {
        var K = D[j], te = D[W], ne = C[K], ce = new Bh(ne, e3, e3.ecModel), me;
        if (v4 && v4.newTitle != null && v4.featureName === K && (ne.title = v4.newTitle), K && !te) {
          if (QCn(K))
            me = { onclick: ce.option.onclick, featureName: K };
          else {
            var ve = rvt(K);
            if (!ve)
              return;
            me = new ve();
          }
          A2[K] = me;
        } else if (me = A2[te], !me)
          return;
        me.uid = Tj("toolbox-feature"), me.model = ce, me.ecModel = u, me.api = h;
        var Be = me instanceof h2;
        if (!K && te) {
          Be && me.dispose && me.dispose(u, h);
          return;
        }
        if (!ce.get("show") || Be && me.unusable) {
          Be && me.remove && me.remove(u, h);
          return;
        }
        N(ce, me, K), ce.setIconStatus = function(Oe, We) {
          var Ue = this.option, qe = this.iconPaths;
          Ue.iconStatus = Ue.iconStatus || {}, Ue.iconStatus[Oe] = We, qe[Oe] && (We === "emphasis" ? zA : jA)(qe[Oe]);
        }, me instanceof h2 && me.render && me.render(ce, u, h, v4);
      }
      function N(j, W, K) {
        var te = j.getModel("iconStyle"), ne = j.getModel(["emphasis", "iconStyle"]), ce = W instanceof h2 && W.getIcons ? W.getIcons() : j.get("icon"), me = j.get("title") || {}, ve, Be;
        qa(ce) ? (ve = {}, ve[K] = ce) : ve = ce, qa(me) ? (Be = {}, Be[K] = me) : Be = me;
        var Oe = j.iconPaths = {};
        mt(ve, function(We, Ue) {
          var qe = RJ(We, {}, { x: -x3 / 2, y: -x3 / 2, width: x3, height: x3 });
          qe.setStyle(te.getItemStyle());
          var Ze = qe.ensureState("emphasis");
          Ze.style = ne.getItemStyle();
          var ct = new Ec({ style: { text: Be[Ue], align: ne.get("textAlign"), borderRadius: ne.get("textBorderRadius"), padding: ne.get("textPadding"), fill: null }, ignore: true });
          qe.setTextContent(ct), Cj({ el: qe, componentModel: e3, itemName: Ue, formatterParamsExtra: { title: Be[Ue] } }), qe.__title = Be[Ue], qe.on("mouseover", function() {
            var _t = ne.getItemStyle(), pt = e3.get("orient") === "vertical" ? e3.get("right") == null ? "right" : "left" : e3.get("bottom") == null ? "bottom" : "top";
            ct.setStyle({ fill: ne.get("textFill") || _t.fill || _t.stroke || "#000", backgroundColor: ne.get("textBackgroundColor") }), qe.setTextConfig({ position: ne.get("textPosition") || pt }), ct.ignore = !e3.get("showTitle"), zA(this);
          }).on("mouseout", function() {
            j.get(["iconStatus", Ue]) !== "emphasis" && jA(this), ct.hide();
          }), (j.get(["iconStatus", Ue]) === "emphasis" ? zA : jA)(qe), m3.add(qe), qe.on("click", no(W.onclick, W, u, h, Ue)), Oe[Ue] = qe;
        });
      }
      ZCn(m3, e3, h), m3.add(ivt(m3.getBoundingRect(), e3)), m3.eachChild(function(j) {
        var W = j.__title, K = j.ensureState("emphasis"), te = K.textConfig || (K.textConfig = {}), ne = j.getTextContent(), ce = ne && ne.states.emphasis;
        if (ce && !Xo(ce) && W) {
          var me = ce.style || (ce.style = {}), ve = DJ(W, Ec.makeFont(me)), Be = j.x + m3.x, Oe = j.y + m3.y + x3, We = false;
          Oe + ve.height > h.getHeight() && (te.position = "top", We = true);
          var Ue = We ? -5 - ve.height : x3 + 8;
          Be + ve.width / 2 > h.getWidth() ? (te.position = ["100%", Ue], me.align = "right") : Be - ve.width / 2 < 0 && (te.position = [0, Ue], me.align = "left");
        }
      });
    }, r3.prototype.updateView = function(e3, u, h, v4) {
      mt(this._features, function(m3) {
        m3 instanceof h2 && m3.updateView && m3.updateView(m3.model, u, h, v4);
      });
    }, r3.prototype.remove = function(e3, u) {
      mt(this._features, function(h) {
        h instanceof h2 && h.remove && h.remove(e3, u);
      }), this.group.removeAll();
    }, r3.prototype.dispose = function(e3, u) {
      mt(this._features, function(h) {
        h instanceof h2 && h.dispose && h.dispose(e3, u);
      });
    }, r3.type = "toolbox", r3;
  }(yd);
  function QCn(l3) {
    return l3.indexOf("my") === 0;
  }
  var eMn = JCn, tMn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.onclick = function(e3, u) {
      var h = this.model, v4 = h.get("name") || e3.get("title.0.text") || "echarts", m3 = u.getZr().painter.getType() === "svg", x3 = m3 ? "svg" : h.get("type", true) || "png", C = u.getConnectedDataURL({ type: x3, backgroundColor: h.get("backgroundColor", true) || e3.get("backgroundColor") || "#fff", connectedBackgroundColor: h.get("connectedBackgroundColor"), excludeComponents: h.get("excludeComponents"), pixelRatio: h.get("pixelRatio") }), A2 = Fc.browser;
      if (Xo(MouseEvent) && (A2.newEdge || !A2.ie && !A2.edge)) {
        var D = document.createElement("a");
        D.download = v4 + "." + x3, D.target = "_blank", D.href = C;
        var P = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
        D.dispatchEvent(P);
      } else if (window.navigator.msSaveOrOpenBlob || m3) {
        var N = C.split(","), j = N[0].indexOf("base64") > -1, W = m3 ? decodeURIComponent(N[1]) : N[1];
        j && (W = window.atob(W));
        var K = v4 + "." + x3;
        if (window.navigator.msSaveOrOpenBlob) {
          for (var te = W.length, ne = new Uint8Array(te); te--; )
            ne[te] = W.charCodeAt(te);
          var ce = new Blob([ne]);
          window.navigator.msSaveOrOpenBlob(ce, K);
        } else {
          var me = document.createElement("iframe");
          document.body.appendChild(me);
          var ve = me.contentWindow, Be = ve.document;
          Be.open("image/svg+xml", "replace"), Be.write(W), Be.close(), ve.focus(), Be.execCommand("SaveAs", true, K), document.body.removeChild(me);
        }
      } else {
        var Oe = h.get("lang"), We = '<body style="margin:0;"><img src="' + C + '" style="max-width:100%;" title="' + (Oe && Oe[0] || "") + '" /></body>', Ue = window.open();
        Ue.document.write(We), Ue.document.title = v4;
      }
    }, r3.getDefaultOption = function(e3) {
      var u = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: e3.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: e3.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
      return u;
    }, r3;
  }(h2), nMn = tMn, Fot = "__ec_magicType_stack__", rMn = [["line", "bar"], ["stack"]], iMn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.getIcons = function() {
      var e3 = this.model, u = e3.get("icon"), h = {};
      return mt(e3.get("type"), function(v4) {
        u[v4] && (h[v4] = u[v4]);
      }), h;
    }, r3.getDefaultOption = function(e3) {
      var u = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: e3.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
      return u;
    }, r3.prototype.onclick = function(e3, u, h) {
      var v4 = this.model, m3 = v4.get(["seriesIndex", h]);
      if (!!Vot[h]) {
        var x3 = { series: [] }, C = function(P) {
          var N = P.subType, j = P.id, W = Vot[h](N, j, P, v4);
          W && (ns(W, P.option), x3.series.push(W));
          var K = P.coordinateSystem;
          if (K && K.type === "cartesian2d" && (h === "line" || h === "bar")) {
            var te = K.getAxesByScale("ordinal")[0];
            if (te) {
              var ne = te.dim, ce = ne + "Axis", me = P.getReferringComponents(ce, Lv).models[0], ve = me.componentIndex;
              x3[ce] = x3[ce] || [];
              for (var Be = 0; Be <= ve; Be++)
                x3[ce][ve] = x3[ce][ve] || {};
              x3[ce][ve].boundaryGap = h === "bar";
            }
          }
        };
        mt(rMn, function(P) {
          Cl(P, h) >= 0 && mt(P, function(N) {
            v4.setIconStatus(N, "normal");
          });
        }), v4.setIconStatus(h, "emphasis"), e3.eachComponent({ mainType: "series", query: m3 == null ? null : { seriesIndex: m3 } }, C);
        var A2, D = h;
        h === "stack" && (A2 = ol({ stack: v4.option.title.tiled, tiled: v4.option.title.stack }, v4.option.title), v4.get(["iconStatus", h]) !== "emphasis" && (D = "tiled")), u.dispatchAction({ type: "changeMagicType", currentType: D, newOption: x3, newTitle: A2, featureName: "magicType" });
      }
    }, r3;
  }(h2), Vot = { line: function(l3, r3, e3, u) {
    if (l3 === "bar")
      return ol({ id: r3, type: "line", data: e3.get("data"), stack: e3.get("stack"), markPoint: e3.get("markPoint"), markLine: e3.get("markLine") }, u.get(["option", "line"]) || {}, true);
  }, bar: function(l3, r3, e3, u) {
    if (l3 === "line")
      return ol({ id: r3, type: "bar", data: e3.get("data"), stack: e3.get("stack"), markPoint: e3.get("markPoint"), markLine: e3.get("markLine") }, u.get(["option", "bar"]) || {}, true);
  }, stack: function(l3, r3, e3, u) {
    var h = e3.get("stack") === Fot;
    if (l3 === "line" || l3 === "bar")
      return u.setIconStatus("stack", h ? "normal" : "emphasis"), ol({ id: r3, stack: h ? "" : Fot }, u.get(["option", "stack"]) || {}, true);
  } };
  ZA({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(l3, r3) {
    r3.mergeOption(l3.newOption);
  });
  var aMn = iMn, wpe = new Array(60).join("-"), mj = "	";
  function oMn(l3) {
    var r3 = {}, e3 = [], u = [];
    return l3.eachRawSeries(function(h) {
      var v4 = h.coordinateSystem;
      if (v4 && (v4.type === "cartesian2d" || v4.type === "polar")) {
        var m3 = v4.getBaseAxis();
        if (m3.type === "category") {
          var x3 = m3.dim + "_" + m3.index;
          r3[x3] || (r3[x3] = { categoryAxis: m3, valueAxis: v4.getOtherAxis(m3), series: [] }, u.push({ axisDim: m3.dim, axisIndex: m3.index })), r3[x3].series.push(h);
        } else
          e3.push(h);
      } else
        e3.push(h);
    }), { seriesGroupByCategoryAxis: r3, other: e3, meta: u };
  }
  function sMn(l3) {
    var r3 = [];
    return mt(l3, function(e3, u) {
      var h = e3.categoryAxis, v4 = e3.valueAxis, m3 = v4.dim, x3 = [" "].concat(Bi(e3.series, function(j) {
        return j.name;
      })), C = [h.model.getCategories()];
      mt(e3.series, function(j) {
        var W = j.getRawData();
        C.push(j.getRawData().mapArray(W.mapDimension(m3), function(K) {
          return K;
        }));
      });
      for (var A2 = [x3.join(mj)], D = 0; D < C[0].length; D++) {
        for (var P = [], N = 0; N < C.length; N++)
          P.push(C[N][D]);
        A2.push(P.join(mj));
      }
      r3.push(A2.join(`
`));
    }), r3.join(`

` + wpe + `

`);
  }
  function lMn(l3) {
    return Bi(l3, function(r3) {
      var e3 = r3.getRawData(), u = [r3.name], h = [];
      return e3.each(e3.dimensions, function() {
        for (var v4 = arguments.length, m3 = arguments[v4 - 1], x3 = e3.getName(m3), C = 0; C < v4 - 1; C++)
          h[C] = arguments[C];
        u.push((x3 ? x3 + mj : "") + h.join(mj));
      }), u.join(`
`);
    }).join(`

` + wpe + `

`);
  }
  function uMn(l3) {
    var r3 = oMn(l3);
    return { value: jf([sMn(r3.seriesGroupByCategoryAxis), lMn(r3.other)], function(e3) {
      return !!e3.replace(/[\n\t\s]/g, "");
    }).join(`

` + wpe + `

`), meta: r3.meta };
  }
  function Che(l3) {
    return l3.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
  }
  function cMn(l3) {
    var r3 = l3.slice(0, l3.indexOf(`
`));
    if (r3.indexOf(mj) >= 0)
      return true;
  }
  var Uke = new RegExp("[" + mj + "]+", "g");
  function fMn(l3) {
    for (var r3 = l3.split(/\n+/g), e3 = Che(r3.shift()).split(Uke), u = [], h = Bi(e3, function(C) {
      return { name: C, data: [] };
    }), v4 = 0; v4 < r3.length; v4++) {
      var m3 = Che(r3[v4]).split(Uke);
      u.push(m3.shift());
      for (var x3 = 0; x3 < m3.length; x3++)
        h[x3] && (h[x3].data[v4] = m3[x3]);
    }
    return { series: h, categories: u };
  }
  function hMn(l3) {
    for (var r3 = l3.split(/\n+/g), e3 = Che(r3.shift()), u = [], h = 0; h < r3.length; h++) {
      var v4 = Che(r3[h]);
      if (!!v4) {
        var m3 = v4.split(Uke), x3 = "", C = void 0, A2 = false;
        isNaN(m3[0]) ? (A2 = true, x3 = m3[0], m3 = m3.slice(1), u[h] = { name: x3, value: [] }, C = u[h].value) : C = u[h] = [];
        for (var D = 0; D < m3.length; D++)
          C.push(+m3[D]);
        C.length === 1 && (A2 ? u[h].value = C[0] : u[h] = C[0]);
      }
    }
    return { name: e3, data: u };
  }
  function pMn(l3, r3) {
    var e3 = l3.split(new RegExp(`
*` + wpe + `
*`, "g")), u = { series: [] };
    return mt(e3, function(h, v4) {
      if (cMn(h)) {
        var m3 = fMn(h), x3 = r3[v4], C = x3.axisDim + "Axis";
        x3 && (u[C] = u[C] || [], u[C][x3.axisIndex] = { data: m3.categories }, u.series = u.series.concat(m3.series));
      } else {
        var m3 = hMn(h);
        u.series.push(m3);
      }
    }), u;
  }
  var dMn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.onclick = function(e3, u) {
      setTimeout(function() {
        u.dispatchAction({ type: "hideTip" });
      });
      var h = u.getDom(), v4 = this.model;
      this._dom && h.removeChild(this._dom);
      var m3 = document.createElement("div");
      m3.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", m3.style.backgroundColor = v4.get("backgroundColor") || "#fff";
      var x3 = document.createElement("h4"), C = v4.get("lang") || [];
      x3.innerHTML = C[0] || v4.get("title"), x3.style.cssText = "margin:10px 20px", x3.style.color = v4.get("textColor");
      var A2 = document.createElement("div"), D = document.createElement("textarea");
      A2.style.cssText = "overflow:auto";
      var P = v4.get("optionToContent"), N = v4.get("contentToOption"), j = uMn(e3);
      if (Xo(P)) {
        var W = P(u.getOption());
        qa(W) ? A2.innerHTML = W : ZZ(W) && A2.appendChild(W);
      } else {
        D.readOnly = v4.get("readOnly");
        var K = D.style;
        K.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", K.color = v4.get("textColor"), K.borderColor = v4.get("textareaBorderColor"), K.backgroundColor = v4.get("textareaColor"), D.value = j.value, A2.appendChild(D);
      }
      var te = j.meta, ne = document.createElement("div");
      ne.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
      var ce = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", me = document.createElement("div"), ve = document.createElement("div");
      ce += ";background-color:" + v4.get("buttonColor"), ce += ";color:" + v4.get("buttonTextColor");
      var Be = this;
      function Oe() {
        h.removeChild(m3), Be._dom = null;
      }
      T5e(me, "click", Oe), T5e(ve, "click", function() {
        if (N == null && P != null || N != null && P == null) {
          Oe();
          return;
        }
        var We;
        try {
          Xo(N) ? We = N(A2, u.getOption()) : We = pMn(D.value, te);
        } catch (Ue) {
          throw Oe(), new Error("Data view format error " + Ue);
        }
        We && u.dispatchAction({ type: "changeDataView", newOption: We }), Oe();
      }), me.innerHTML = C[1], ve.innerHTML = C[2], ve.style.cssText = me.style.cssText = ce, !v4.get("readOnly") && ne.appendChild(ve), ne.appendChild(me), m3.appendChild(x3), m3.appendChild(A2), m3.appendChild(ne), A2.style.height = h.clientHeight - 80 + "px", h.appendChild(m3), this._dom = m3;
    }, r3.prototype.remove = function(e3, u) {
      this._dom && u.getDom().removeChild(this._dom);
    }, r3.prototype.dispose = function(e3, u) {
      this.remove(e3, u);
    }, r3.getDefaultOption = function(e3) {
      var u = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: e3.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: e3.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
      return u;
    }, r3;
  }(h2);
  function vMn(l3, r3) {
    return Bi(l3, function(e3, u) {
      var h = r3 && r3[u];
      if (ls(h) && !Ni(h)) {
        var v4 = ls(e3) && !Ni(e3);
        v4 || (e3 = { value: e3 });
        var m3 = h.name != null && e3.name == null;
        return e3 = ns(e3, h), m3 && delete e3.name, e3;
      } else
        return e3;
    });
  }
  ZA({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(l3, r3) {
    var e3 = [];
    mt(l3.newOption.series, function(u) {
      var h = r3.getSeriesByName(u.name)[0];
      if (!h)
        e3.push(fi({ type: "scatter" }, u));
      else {
        var v4 = h.get("data");
        e3.push({ name: u.name, data: vMn(u.data, v4) });
      }
    }), r3.mergeOption(ns({ series: e3 }, l3.newOption));
  });
  var gMn = dMn, avt = mt, ovt = pc();
  function yMn(l3, r3) {
    var e3 = yPe(l3);
    avt(r3, function(u, h) {
      for (var v4 = e3.length - 1; v4 >= 0; v4--) {
        var m3 = e3[v4];
        if (m3[h])
          break;
      }
      if (v4 < 0) {
        var x3 = l3.queryComponents({ mainType: "dataZoom", subType: "select", id: h })[0];
        if (x3) {
          var C = x3.getPercentRange();
          e3[0][h] = { dataZoomId: h, start: C[0], end: C[1] };
        }
      }
    }), e3.push(r3);
  }
  function mMn(l3) {
    var r3 = yPe(l3), e3 = r3[r3.length - 1];
    r3.length > 1 && r3.pop();
    var u = {};
    return avt(e3, function(h, v4) {
      for (var m3 = r3.length - 1; m3 >= 0; m3--)
        if (h = r3[m3][v4], h) {
          u[v4] = h;
          break;
        }
    }), u;
  }
  function bMn(l3) {
    ovt(l3).snapshots = null;
  }
  function _Mn(l3) {
    return yPe(l3).length;
  }
  function yPe(l3) {
    var r3 = ovt(l3);
    return r3.snapshots || (r3.snapshots = [{}]), r3.snapshots;
  }
  var xMn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.onclick = function(e3, u) {
      bMn(e3), u.dispatchAction({ type: "restore", from: this.uid });
    }, r3.getDefaultOption = function(e3) {
      var u = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: e3.getLocaleModel().get(["toolbox", "restore", "title"]) };
      return u;
    }, r3;
  }(h2);
  ZA({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(l3, r3) {
    r3.resetOption("recreate");
  });
  var wMn = xMn, SMn = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], CMn = function() {
    function l3(r3, e3, u) {
      var h = this;
      this._targetInfoList = [];
      var v4 = Bot(e3, r3);
      mt(MMn, function(m3, x3) {
        (!u || !u.include || Cl(u.include, x3) >= 0) && m3(v4, h._targetInfoList);
      });
    }
    return l3.prototype.setOutputRanges = function(r3, e3) {
      return this.matchOutputRanges(r3, e3, function(u, h, v4) {
        if ((u.coordRanges || (u.coordRanges = [])).push(h), !u.coordRange) {
          u.coordRange = h;
          var m3 = UDe[u.brushType](0, v4, h);
          u.__rangeOffset = { offset: Hot[u.brushType](m3.values, u.range, [1, 1]), xyMinMax: m3.xyMinMax };
        }
      }), r3;
    }, l3.prototype.matchOutputRanges = function(r3, e3, u) {
      mt(r3, function(h) {
        var v4 = this.findTargetInfo(h, e3);
        v4 && v4 !== true && mt(v4.coordSyses, function(m3) {
          var x3 = UDe[h.brushType](1, m3, h.range, true);
          u(h, x3.values, m3, e3);
        });
      }, this);
    }, l3.prototype.setInputRanges = function(r3, e3) {
      mt(r3, function(u) {
        var h = this.findTargetInfo(u, e3);
        if (u.range = u.range || [], h && h !== true) {
          u.panelId = h.panelId;
          var v4 = UDe[u.brushType](0, h.coordSys, u.coordRange), m3 = u.__rangeOffset;
          u.range = m3 ? Hot[u.brushType](v4.values, m3.offset, TMn(v4.xyMinMax, m3.xyMinMax)) : v4.values;
        }
      }, this);
    }, l3.prototype.makePanelOpts = function(r3, e3) {
      return Bi(this._targetInfoList, function(u) {
        var h = u.getPanelRect();
        return { panelId: u.panelId, defaultBrushType: e3 ? e3(u) : null, clipPath: pdt(h), isTargetByCursor: vdt(h, r3, u.coordSysModel), getLinearBrushOtherExtent: ddt(h) };
      });
    }, l3.prototype.controlSeries = function(r3, e3, u) {
      var h = this.findTargetInfo(r3, u);
      return h === true || h && Cl(h.coordSyses, e3.coordinateSystem) >= 0;
    }, l3.prototype.findTargetInfo = function(r3, e3) {
      for (var u = this._targetInfoList, h = Bot(e3, r3), v4 = 0; v4 < u.length; v4++) {
        var m3 = u[v4], x3 = r3.panelId;
        if (x3) {
          if (m3.panelId === x3)
            return m3;
        } else
          for (var C = 0; C < zot.length; C++)
            if (zot[C](h, m3))
              return m3;
      }
      return true;
    }, l3;
  }();
  function qke(l3) {
    return l3[0] > l3[1] && l3.reverse(), l3;
  }
  function Bot(l3, r3) {
    return NZ(l3, r3, { includeMainTypes: SMn });
  }
  var MMn = { grid: function(l3, r3) {
    var e3 = l3.xAxisModels, u = l3.yAxisModels, h = l3.gridModels, v4 = Ho(), m3 = {}, x3 = {};
    !e3 && !u && !h || (mt(e3, function(C) {
      var A2 = C.axis.grid.model;
      v4.set(A2.id, A2), m3[A2.id] = true;
    }), mt(u, function(C) {
      var A2 = C.axis.grid.model;
      v4.set(A2.id, A2), x3[A2.id] = true;
    }), mt(h, function(C) {
      v4.set(C.id, C), m3[C.id] = true, x3[C.id] = true;
    }), v4.each(function(C) {
      var A2 = C.coordinateSystem, D = [];
      mt(A2.getCartesians(), function(P, N) {
        (Cl(e3, P.getAxis("x").model) >= 0 || Cl(u, P.getAxis("y").model) >= 0) && D.push(P);
      }), r3.push({ panelId: "grid--" + C.id, gridModel: C, coordSysModel: C, coordSys: D[0], coordSyses: D, getPanelRect: jot.grid, xAxisDeclared: m3[C.id], yAxisDeclared: x3[C.id] });
    }));
  }, geo: function(l3, r3) {
    mt(l3.geoModels, function(e3) {
      var u = e3.coordinateSystem;
      r3.push({ panelId: "geo--" + e3.id, geoModel: e3, coordSysModel: e3, coordSys: u, coordSyses: [u], getPanelRect: jot.geo });
    });
  } }, zot = [function(l3, r3) {
    var e3 = l3.xAxisModel, u = l3.yAxisModel, h = l3.gridModel;
    return !h && e3 && (h = e3.axis.grid.model), !h && u && (h = u.axis.grid.model), h && h === r3.gridModel;
  }, function(l3, r3) {
    var e3 = l3.geoModel;
    return e3 && e3 === r3.geoModel;
  }], jot = { grid: function() {
    return this.coordSys.master.getRect().clone();
  }, geo: function() {
    var l3 = this.coordSys, r3 = l3.getBoundingRect().clone();
    return r3.applyTransform(VN(l3)), r3;
  } }, UDe = { lineX: Fs(Got, 0), lineY: Fs(Got, 1), rect: function(l3, r3, e3, u) {
    var h = l3 ? r3.pointToData([e3[0][0], e3[1][0]], u) : r3.dataToPoint([e3[0][0], e3[1][0]], u), v4 = l3 ? r3.pointToData([e3[0][1], e3[1][1]], u) : r3.dataToPoint([e3[0][1], e3[1][1]], u), m3 = [qke([h[0], v4[0]]), qke([h[1], v4[1]])];
    return { values: m3, xyMinMax: m3 };
  }, polygon: function(l3, r3, e3, u) {
    var h = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], v4 = Bi(e3, function(m3) {
      var x3 = l3 ? r3.pointToData(m3, u) : r3.dataToPoint(m3, u);
      return h[0][0] = Math.min(h[0][0], x3[0]), h[1][0] = Math.min(h[1][0], x3[1]), h[0][1] = Math.max(h[0][1], x3[0]), h[1][1] = Math.max(h[1][1], x3[1]), x3;
    });
    return { values: v4, xyMinMax: h };
  } };
  function Got(l3, r3, e3, u) {
    var h = e3.getAxis(["x", "y"][l3]), v4 = qke(Bi([0, 1], function(x3) {
      return r3 ? h.coordToData(h.toLocalCoord(u[x3]), true) : h.toGlobalCoord(h.dataToCoord(u[x3]));
    })), m3 = [];
    return m3[l3] = v4, m3[1 - l3] = [NaN, NaN], { values: v4, xyMinMax: m3 };
  }
  var Hot = { lineX: Fs(Wot, 0), lineY: Fs(Wot, 1), rect: function(l3, r3, e3) {
    return [[l3[0][0] - e3[0] * r3[0][0], l3[0][1] - e3[0] * r3[0][1]], [l3[1][0] - e3[1] * r3[1][0], l3[1][1] - e3[1] * r3[1][1]]];
  }, polygon: function(l3, r3, e3) {
    return Bi(l3, function(u, h) {
      return [u[0] - e3[0] * r3[h][0], u[1] - e3[1] * r3[h][1]];
    });
  } };
  function Wot(l3, r3, e3, u) {
    return [r3[0] - u[l3] * e3[0], r3[1] - u[l3] * e3[1]];
  }
  function TMn(l3, r3) {
    var e3 = Uot(l3), u = Uot(r3), h = [e3[0] / u[0], e3[1] / u[1]];
    return isNaN(h[0]) && (h[0] = 1), isNaN(h[1]) && (h[1] = 1), h;
  }
  function Uot(l3) {
    return l3 ? [l3[0][1] - l3[0][0], l3[1][1] - l3[1][0]] : [NaN, NaN];
  }
  var mPe = CMn, $ke = mt, AMn = Wln("toolbox-dataZoom_"), IMn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.render = function(e3, u, h, v4) {
      this._brushController || (this._brushController = new JOe(h.getZr()), this._brushController.on("brush", no(this._onBrush, this)).mount()), kMn(e3, u, this, v4, h), DMn(e3, u);
    }, r3.prototype.onclick = function(e3, u, h) {
      EMn[h].call(this);
    }, r3.prototype.remove = function(e3, u) {
      this._brushController && this._brushController.unmount();
    }, r3.prototype.dispose = function(e3, u) {
      this._brushController && this._brushController.dispose();
    }, r3.prototype._onBrush = function(e3) {
      var u = e3.areas;
      if (!e3.isEnd || !u.length)
        return;
      var h = {}, v4 = this.ecModel;
      this._brushController.updateCovers([]);
      var m3 = new mPe(bPe(this.model), v4, { include: ["grid"] });
      m3.matchOutputRanges(u, v4, function(A2, D, P) {
        if (P.type === "cartesian2d") {
          var N = A2.brushType;
          N === "rect" ? (x3("x", P, D[0]), x3("y", P, D[1])) : x3({ lineX: "x", lineY: "y" }[N], P, D);
        }
      }), yMn(v4, h), this._dispatchZoomAction(h);
      function x3(A2, D, P) {
        var N = D.getAxis(A2), j = N.model, W = C(A2, j, v4), K = W.findRepresentativeAxisProxy(j).getMinMaxSpan();
        (K.minValueSpan != null || K.maxValueSpan != null) && (P = tF(0, P.slice(), N.scale.getExtent(), 0, K.minValueSpan, K.maxValueSpan)), W && (h[W.id] = { dataZoomId: W.id, startValue: P[0], endValue: P[1] });
      }
      function C(A2, D, P) {
        var N;
        return P.eachComponent({ mainType: "dataZoom", subType: "select" }, function(j) {
          var W = j.getAxisModel(A2, D.componentIndex);
          W && (N = j);
        }), N;
      }
    }, r3.prototype._dispatchZoomAction = function(e3) {
      var u = [];
      $ke(e3, function(h, v4) {
        u.push(bs(h));
      }), u.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: u });
    }, r3.getDefaultOption = function(e3) {
      var u = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: e3.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
      return u;
    }, r3;
  }(h2), EMn = { zoom: function() {
    var l3 = !this._isZoomActive;
    this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: l3 });
  }, back: function() {
    this._dispatchZoomAction(mMn(this.ecModel));
  } };
  function bPe(l3) {
    var r3 = { xAxisIndex: l3.get("xAxisIndex", true), yAxisIndex: l3.get("yAxisIndex", true), xAxisId: l3.get("xAxisId", true), yAxisId: l3.get("yAxisId", true) };
    return r3.xAxisIndex == null && r3.xAxisId == null && (r3.xAxisIndex = "all"), r3.yAxisIndex == null && r3.yAxisId == null && (r3.yAxisIndex = "all"), r3;
  }
  function DMn(l3, r3) {
    l3.setIconStatus("back", _Mn(r3) > 1 ? "emphasis" : "normal");
  }
  function kMn(l3, r3, e3, u, h) {
    var v4 = e3._isZoomActive;
    u && u.type === "takeGlobalCursor" && (v4 = u.key === "dataZoomSelect" ? u.dataZoomSelectActive : false), e3._isZoomActive = v4, l3.setIconStatus("zoom", v4 ? "emphasis" : "normal");
    var m3 = new mPe(bPe(l3), r3, { include: ["grid"] }), x3 = m3.makePanelOpts(h, function(C) {
      return C.xAxisDeclared && !C.yAxisDeclared ? "lineX" : !C.xAxisDeclared && C.yAxisDeclared ? "lineY" : "rect";
    });
    e3._brushController.setPanels(x3).enableBrush(v4 && x3.length ? { brushType: "auto", brushStyle: l3.getModel("brushStyle").getItemStyle() } : false);
  }
  Efn("dataZoom", function(l3) {
    var r3 = l3.getComponent("toolbox", 0), e3 = ["feature", "dataZoom"];
    if (!r3 || r3.get(e3) == null)
      return;
    var u = r3.getModel(e3), h = [], v4 = bPe(u), m3 = NZ(l3, v4);
    $ke(m3.xAxisModels, function(C) {
      return x3(C, "xAxis", "xAxisIndex");
    }), $ke(m3.yAxisModels, function(C) {
      return x3(C, "yAxis", "yAxisIndex");
    });
    function x3(C, A2, D) {
      var P = C.componentIndex, N = { type: "select", $fromToolbox: true, filterMode: u.get("filterMode", true) || "filter", id: AMn + A2 + P };
      N[D] = P, h.push(N);
    }
    return h;
  });
  var OMn = IMn;
  function PMn(l3) {
    l3.registerComponentModel(KCn), l3.registerComponentView(eMn), $z("saveAsImage", nMn), $z("magicType", aMn), $z("dataView", gMn), $z("dataZoom", OMn), $z("restore", wMn), kl(XCn);
  }
  var LMn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "tooltip", r3.dependencies = ["axisPointer"], r3.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, r3;
  }(fc), RMn = LMn;
  function svt(l3) {
    var r3 = l3.get("confine");
    return r3 != null ? !!r3 : l3.get("renderMode") === "richText";
  }
  function lvt(l3) {
    if (!!Fc.domSupported) {
      for (var r3 = document.documentElement.style, e3 = 0, u = l3.length; e3 < u; e3++)
        if (l3[e3] in r3)
          return l3[e3];
    }
  }
  var uvt = lvt(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), NMn = lvt(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
  function cvt(l3, r3) {
    if (!l3)
      return r3;
    r3 = Nct(r3, true);
    var e3 = l3.indexOf(r3);
    return l3 = e3 === -1 ? r3 : "-" + l3.slice(0, e3) + "-" + r3, l3.toLowerCase();
  }
  function FMn(l3, r3) {
    var e3 = l3.currentStyle || document.defaultView && document.defaultView.getComputedStyle(l3);
    return e3 ? r3 ? e3[r3] : e3 : null;
  }
  var VMn = cvt(NMn, "transition"), _Pe = cvt(uvt, "transform"), BMn = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (Fc.transform3dSupported ? "will-change:transform;" : "");
  function zMn(l3) {
    return l3 = l3 === "left" ? "right" : l3 === "right" ? "left" : l3 === "top" ? "bottom" : "top", l3;
  }
  function jMn(l3, r3, e3) {
    if (!qa(e3) || e3 === "inside")
      return "";
    var u = l3.get("backgroundColor"), h = l3.get("borderWidth");
    r3 = $N(r3);
    var v4 = zMn(e3), m3 = Math.max(Math.round(h) * 1.5, 6), x3 = "", C = _Pe + ":", A2;
    Cl(["left", "right"], v4) > -1 ? (x3 += "top:50%", C += "translateY(-50%) rotate(" + (A2 = v4 === "left" ? -225 : -45) + "deg)") : (x3 += "left:50%", C += "translateX(-50%) rotate(" + (A2 = v4 === "top" ? 225 : 45) + "deg)");
    var D = A2 * Math.PI / 180, P = m3 + h, N = P * Math.abs(Math.cos(D)) + P * Math.abs(Math.sin(D)), j = Math.round(((N - Math.SQRT2 * h) / 2 + Math.SQRT2 * h - (N - P) / 2) * 100) / 100;
    x3 += ";" + v4 + ":-" + j + "px";
    var W = r3 + " solid " + h + "px;", K = ["position:absolute;width:" + m3 + "px;height:" + m3 + "px;", x3 + ";" + C + ";", "border-bottom:" + W, "border-right:" + W, "background-color:" + u + ";"];
    return '<div style="' + K.join("") + '"></div>';
  }
  function GMn(l3, r3) {
    var e3 = "cubic-bezier(0.23,1,0.32,1)", u = " " + l3 / 2 + "s " + e3, h = "opacity" + u + ",visibility" + u;
    return r3 || (u = " " + l3 + "s " + e3, h += Fc.transformSupported ? "," + _Pe + u : ",left" + u + ",top" + u), VMn + ":" + h;
  }
  function qot(l3, r3, e3) {
    var u = l3.toFixed(0) + "px", h = r3.toFixed(0) + "px";
    if (!Fc.transformSupported)
      return e3 ? "top:" + h + ";left:" + u + ";" : [["top", h], ["left", u]];
    var v4 = Fc.transform3dSupported, m3 = "translate" + (v4 ? "3d" : "") + "(" + u + "," + h + (v4 ? ",0" : "") + ")";
    return e3 ? "top:0;left:0;" + _Pe + ":" + m3 + ";" : [["top", 0], ["left", 0], [uvt, m3]];
  }
  function HMn(l3) {
    var r3 = [], e3 = l3.get("fontSize"), u = l3.getTextColor();
    u && r3.push("color:" + u), r3.push("font:" + l3.getFont()), e3 && r3.push("line-height:" + Math.round(e3 * 3 / 2) + "px");
    var h = l3.get("textShadowColor"), v4 = l3.get("textShadowBlur") || 0, m3 = l3.get("textShadowOffsetX") || 0, x3 = l3.get("textShadowOffsetY") || 0;
    return h && v4 && r3.push("text-shadow:" + m3 + "px " + x3 + "px " + v4 + "px " + h), mt(["decoration", "align"], function(C) {
      var A2 = l3.get(C);
      A2 && r3.push("text-" + C + ":" + A2);
    }), r3.join(";");
  }
  function WMn(l3, r3, e3) {
    var u = [], h = l3.get("transitionDuration"), v4 = l3.get("backgroundColor"), m3 = l3.get("shadowBlur"), x3 = l3.get("shadowColor"), C = l3.get("shadowOffsetX"), A2 = l3.get("shadowOffsetY"), D = l3.getModel("textStyle"), P = mft(l3, "html"), N = C + "px " + A2 + "px " + m3 + "px " + x3;
    return u.push("box-shadow:" + N), r3 && h && u.push(GMn(h, e3)), v4 && u.push("background-color:" + v4), mt(["width", "color", "radius"], function(j) {
      var W = "border-" + j, K = Nct(W), te = l3.get(K);
      te != null && u.push(W + ":" + te + (j === "color" ? "" : "px"));
    }), u.push(HMn(D)), P != null && u.push("padding:" + Aj(P).join("px ") + "px"), u.join(";") + ";";
  }
  function $ot(l3, r3, e3, u, h) {
    var v4 = r3 && r3.painter;
    if (e3) {
      var m3 = v4 && v4.getViewportRoot();
      m3 && vsn(l3, m3, document.body, u, h);
    } else {
      l3[0] = u, l3[1] = h;
      var x3 = v4 && v4.getViewportRootOffset();
      x3 && (l3[0] += x3.offsetLeft, l3[1] += x3.offsetTop);
    }
    l3[2] = l3[0] / r3.getWidth(), l3[3] = l3[1] / r3.getHeight();
  }
  var UMn = function() {
    function l3(r3, e3, u) {
      if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, Fc.wxa)
        return null;
      var h = document.createElement("div");
      h.domBelongToZr = true, this.el = h;
      var v4 = this._zr = e3.getZr(), m3 = this._appendToBody = u && u.appendToBody;
      $ot(this._styleCoord, v4, m3, e3.getWidth() / 2, e3.getHeight() / 2), m3 ? document.body.appendChild(h) : r3.appendChild(h), this._container = r3;
      var x3 = this;
      h.onmouseenter = function() {
        x3._enterable && (clearTimeout(x3._hideTimeout), x3._show = true), x3._inContent = true;
      }, h.onmousemove = function(C) {
        if (C = C || window.event, !x3._enterable) {
          var A2 = v4.handler, D = v4.painter.getViewportRoot();
          s2(D, C, true), A2.dispatch("mousemove", C);
        }
      }, h.onmouseleave = function() {
        x3._inContent = false, x3._enterable && x3._show && x3.hideLater(x3._hideDelay);
      };
    }
    return l3.prototype.update = function(r3) {
      var e3 = this._container, u = FMn(e3, "position"), h = e3.style;
      h.position !== "absolute" && u !== "absolute" && (h.position = "relative");
      var v4 = r3.get("alwaysShowContent");
      v4 && this._moveIfResized(), this.el.className = r3.get("className") || "";
    }, l3.prototype.show = function(r3, e3) {
      clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
      var u = this.el, h = u.style, v4 = this._styleCoord;
      u.innerHTML ? h.cssText = BMn + WMn(r3, !this._firstShow, this._longHide) + qot(v4[0], v4[1], true) + ("border-color:" + $N(e3) + ";") + (r3.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : h.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
    }, l3.prototype.setContent = function(r3, e3, u, h, v4) {
      var m3 = this.el;
      if (r3 == null) {
        m3.innerHTML = "";
        return;
      }
      var x3 = "";
      if (qa(v4) && u.get("trigger") === "item" && !svt(u) && (x3 = jMn(u, h, v4)), qa(r3))
        m3.innerHTML = r3 + x3;
      else if (r3) {
        m3.innerHTML = "", Ni(r3) || (r3 = [r3]);
        for (var C = 0; C < r3.length; C++)
          ZZ(r3[C]) && r3[C].parentNode !== m3 && m3.appendChild(r3[C]);
        if (x3 && m3.childNodes.length) {
          var A2 = document.createElement("div");
          A2.innerHTML = x3, m3.appendChild(A2);
        }
      }
    }, l3.prototype.setEnterable = function(r3) {
      this._enterable = r3;
    }, l3.prototype.getSize = function() {
      var r3 = this.el;
      return [r3.offsetWidth, r3.offsetHeight];
    }, l3.prototype.moveTo = function(r3, e3) {
      var u = this._styleCoord;
      if ($ot(u, this._zr, this._appendToBody, r3, e3), u[0] != null && u[1] != null) {
        var h = this.el.style, v4 = qot(u[0], u[1]);
        mt(v4, function(m3) {
          h[m3[0]] = m3[1];
        });
      }
    }, l3.prototype._moveIfResized = function() {
      var r3 = this._styleCoord[2], e3 = this._styleCoord[3];
      this.moveTo(r3 * this._zr.getWidth(), e3 * this._zr.getHeight());
    }, l3.prototype.hide = function() {
      var r3 = this, e3 = this.el.style;
      e3.visibility = "hidden", e3.opacity = "0", Fc.transform3dSupported && (e3.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
        return r3._longHide = true;
      }, 500);
    }, l3.prototype.hideLater = function(r3) {
      this._show && !(this._inContent && this._enterable) && (r3 ? (this._hideDelay = r3, this._show = false, this._hideTimeout = setTimeout(no(this.hide, this), r3)) : this.hide());
    }, l3.prototype.isShow = function() {
      return this._show;
    }, l3.prototype.dispose = function() {
      this.el.parentNode.removeChild(this.el);
    }, l3;
  }(), qMn = UMn, $Mn = function() {
    function l3(r3) {
      this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = r3.getZr(), Yot(this._styleCoord, this._zr, r3.getWidth() / 2, r3.getHeight() / 2);
    }
    return l3.prototype.update = function(r3) {
      var e3 = r3.get("alwaysShowContent");
      e3 && this._moveIfResized();
    }, l3.prototype.show = function() {
      this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
    }, l3.prototype.setContent = function(r3, e3, u, h, v4) {
      var m3 = this;
      ls(r3) && Xc(""), this.el && this._zr.remove(this.el);
      var x3 = u.getModel("textStyle");
      this.el = new Ec({ style: { rich: e3.richTextStyles, text: r3, lineHeight: 22, borderWidth: 1, borderColor: h, textShadowColor: x3.get("textShadowColor"), fill: u.get(["textStyle", "color"]), padding: mft(u, "richText"), verticalAlign: "top", align: "left" }, z: u.get("z") }), mt(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(A2) {
        m3.el.style[A2] = u.get(A2);
      }), mt(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(A2) {
        m3.el.style[A2] = x3.get(A2) || 0;
      }), this._zr.add(this.el);
      var C = this;
      this.el.on("mouseover", function() {
        C._enterable && (clearTimeout(C._hideTimeout), C._show = true), C._inContent = true;
      }), this.el.on("mouseout", function() {
        C._enterable && C._show && C.hideLater(C._hideDelay), C._inContent = false;
      });
    }, l3.prototype.setEnterable = function(r3) {
      this._enterable = r3;
    }, l3.prototype.getSize = function() {
      var r3 = this.el, e3 = this.el.getBoundingRect(), u = Xot(r3.style);
      return [e3.width + u.left + u.right, e3.height + u.top + u.bottom];
    }, l3.prototype.moveTo = function(r3, e3) {
      var u = this.el;
      if (u) {
        var h = this._styleCoord;
        Yot(h, this._zr, r3, e3), r3 = h[0], e3 = h[1];
        var v4 = u.style, m3 = OO(v4.borderWidth || 0), x3 = Xot(v4);
        u.x = r3 + m3 + x3.left, u.y = e3 + m3 + x3.top, u.markRedraw();
      }
    }, l3.prototype._moveIfResized = function() {
      var r3 = this._styleCoord[2], e3 = this._styleCoord[3];
      this.moveTo(r3 * this._zr.getWidth(), e3 * this._zr.getHeight());
    }, l3.prototype.hide = function() {
      this.el && this.el.hide(), this._show = false;
    }, l3.prototype.hideLater = function(r3) {
      this._show && !(this._inContent && this._enterable) && (r3 ? (this._hideDelay = r3, this._show = false, this._hideTimeout = setTimeout(no(this.hide, this), r3)) : this.hide());
    }, l3.prototype.isShow = function() {
      return this._show;
    }, l3.prototype.dispose = function() {
      this._zr.remove(this.el);
    }, l3;
  }();
  function OO(l3) {
    return Math.max(0, l3);
  }
  function Xot(l3) {
    var r3 = OO(l3.shadowBlur || 0), e3 = OO(l3.shadowOffsetX || 0), u = OO(l3.shadowOffsetY || 0);
    return { left: OO(r3 - e3), right: OO(r3 + e3), top: OO(r3 - u), bottom: OO(r3 + u) };
  }
  function Yot(l3, r3, e3, u) {
    l3[0] = e3, l3[1] = u, l3[2] = l3[0] / r3.getWidth(), l3[3] = l3[1] / r3.getHeight();
  }
  var XMn = $Mn, YMn = new Ju({ shape: { x: -1, y: -1, width: 2, height: 2 } }), KMn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u) {
      if (!(Fc.node || !u.getDom())) {
        var h = e3.getComponent("tooltip"), v4 = this._renderMode = Zln(h.get("renderMode"));
        this._tooltipContent = v4 === "richText" ? new XMn(u) : new qMn(u.getDom(), u, { appendToBody: h.get("appendToBody", true) });
      }
    }, r3.prototype.render = function(e3, u, h) {
      if (!(Fc.node || !h.getDom())) {
        this.group.removeAll(), this._tooltipModel = e3, this._ecModel = u, this._api = h, this._alwaysShowContent = e3.get("alwaysShowContent");
        var v4 = this._tooltipContent;
        v4.update(e3), v4.setEnterable(e3.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && e3.get("transitionDuration") ? Oj(this, "_updatePosition", 50, "fixRate") : cJ(this, "_updatePosition");
      }
    }, r3.prototype._initGlobalListener = function() {
      var e3 = this._tooltipModel, u = e3.get("triggerOn");
      $dt("itemTooltip", this._api, no(function(h, v4, m3) {
        u !== "none" && (u.indexOf(h) >= 0 ? this._tryShow(v4, m3) : h === "leave" && this._hide(m3));
      }, this));
    }, r3.prototype._keepShow = function() {
      var e3 = this._tooltipModel, u = this._ecModel, h = this._api;
      if (this._lastX != null && this._lastY != null && e3.get("triggerOn") !== "none") {
        var v4 = this;
        clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
          !h.isDisposed() && v4.manuallyShowTip(e3, u, h, { x: v4._lastX, y: v4._lastY, dataByCoordSys: v4._lastDataByCoordSys });
        });
      }
    }, r3.prototype.manuallyShowTip = function(e3, u, h, v4) {
      if (!(v4.from === this.uid || Fc.node || !h.getDom())) {
        var m3 = Kot(v4, h);
        this._ticket = "";
        var x3 = v4.dataByCoordSys, C = eTn(v4, u, h);
        if (C) {
          var A2 = C.el.getBoundingRect().clone();
          A2.applyTransform(C.el.transform), this._tryShow({ offsetX: A2.x + A2.width / 2, offsetY: A2.y + A2.height / 2, target: C.el, position: v4.position, positionDefault: "bottom" }, m3);
        } else if (v4.tooltip && v4.x != null && v4.y != null) {
          var D = YMn;
          D.x = v4.x, D.y = v4.y, D.update(), Ps(D).tooltipConfig = { name: null, option: v4.tooltip }, this._tryShow({ offsetX: v4.x, offsetY: v4.y, target: D }, m3);
        } else if (x3)
          this._tryShow({ offsetX: v4.x, offsetY: v4.y, position: v4.position, dataByCoordSys: x3, tooltipOption: v4.tooltipOption }, m3);
        else if (v4.seriesIndex != null) {
          if (this._manuallyAxisShowTip(e3, u, h, v4))
            return;
          var P = Xdt(v4, u), N = P.point[0], j = P.point[1];
          N != null && j != null && this._tryShow({ offsetX: N, offsetY: j, target: P.el, position: v4.position, positionDefault: "bottom" }, m3);
        } else
          v4.x != null && v4.y != null && (h.dispatchAction({ type: "updateAxisPointer", x: v4.x, y: v4.y }), this._tryShow({ offsetX: v4.x, offsetY: v4.y, position: v4.position, target: h.getZr().findHover(v4.x, v4.y).target }, m3));
      }
    }, r3.prototype.manuallyHideTip = function(e3, u, h, v4) {
      var m3 = this._tooltipContent;
      !this._alwaysShowContent && this._tooltipModel && m3.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, v4.from !== this.uid && this._hide(Kot(v4, h));
    }, r3.prototype._manuallyAxisShowTip = function(e3, u, h, v4) {
      var m3 = v4.seriesIndex, x3 = v4.dataIndex, C = u.getComponent("axisPointer").coordSysAxesInfo;
      if (!(m3 == null || x3 == null || C == null)) {
        var A2 = u.getSeriesByIndex(m3);
        if (!!A2) {
          var D = A2.getData(), P = fZ([D.getItemModel(x3), A2, (A2.coordinateSystem || {}).model], this._tooltipModel);
          if (P.get("trigger") === "axis")
            return h.dispatchAction({ type: "updateAxisPointer", seriesIndex: m3, dataIndex: x3, position: v4.position }), true;
        }
      }
    }, r3.prototype._tryShow = function(e3, u) {
      var h = e3.target, v4 = this._tooltipModel;
      if (!!v4) {
        this._lastX = e3.offsetX, this._lastY = e3.offsetY;
        var m3 = e3.dataByCoordSys;
        if (m3 && m3.length)
          this._showAxisTooltip(m3, e3);
        else if (h) {
          this._lastDataByCoordSys = null;
          var x3, C;
          Zz(h, function(A2) {
            if (Ps(A2).dataIndex != null)
              return x3 = A2, true;
            if (Ps(A2).tooltipConfig != null)
              return C = A2, true;
          }, true), x3 ? this._showSeriesItemTooltip(e3, x3, u) : C ? this._showComponentItemTooltip(e3, C, u) : this._hide(u);
        } else
          this._lastDataByCoordSys = null, this._hide(u);
      }
    }, r3.prototype._showOrMove = function(e3, u) {
      var h = e3.get("showDelay");
      u = no(u, this), clearTimeout(this._showTimout), h > 0 ? this._showTimout = setTimeout(u, h) : u();
    }, r3.prototype._showAxisTooltip = function(e3, u) {
      var h = this._ecModel, v4 = this._tooltipModel, m3 = [u.offsetX, u.offsetY], x3 = fZ([u.tooltipOption], v4), C = this._renderMode, A2 = [], D = o0("section", { blocks: [], noHeader: true }), P = [], N = new kEe();
      mt(e3, function(ce) {
        mt(ce.dataByAxis, function(me) {
          var ve = h.getComponent(me.axisDim + "Axis", me.axisIndex), Be = me.value;
          if (!(!ve || Be == null)) {
            var Oe = Wdt(Be, ve.axis, h, me.seriesDataIndices, me.valueLabelOpt), We = o0("section", { header: Oe, noHeader: !hM(Oe), sortBlocks: true, blocks: [] });
            D.blocks.push(We), mt(me.seriesDataIndices, function(Ue) {
              var qe = h.getSeriesByIndex(Ue.seriesIndex), Ze = Ue.dataIndexInside, ct = qe.getDataParams(Ze);
              if (!(ct.dataIndex < 0)) {
                ct.axisDim = me.axisDim, ct.axisIndex = me.axisIndex, ct.axisType = me.axisType, ct.axisId = me.axisId, ct.axisValue = COe(ve.axis, { value: Be }), ct.axisValueLabel = Oe, ct.marker = N.makeTooltipMarker("item", $N(ct.color), C);
                var _t = Rnt(qe.formatTooltip(Ze, true, null)), pt = _t.frag;
                if (pt) {
                  var zt = fZ([qe], v4).get("valueFormatter");
                  We.blocks.push(zt ? fi({ valueFormatter: zt }, pt) : pt);
                }
                _t.text && P.push(_t.text), A2.push(ct);
              }
            });
          }
        });
      }), D.blocks.reverse(), P.reverse();
      var j = u.position, W = x3.get("order"), K = jnt(D, N, C, W, h.get("useUTC"), x3.get("textStyle"));
      K && P.unshift(K);
      var te = C === "richText" ? `

` : "<br/>", ne = P.join(te);
      this._showOrMove(x3, function() {
        this._updateContentNotChangedOnAxis(e3, A2) ? this._updatePosition(x3, j, m3[0], m3[1], this._tooltipContent, A2) : this._showTooltipContent(x3, ne, A2, Math.random() + "", m3[0], m3[1], j, null, N);
      });
    }, r3.prototype._showSeriesItemTooltip = function(e3, u, h) {
      var v4 = this._ecModel, m3 = Ps(u), x3 = m3.seriesIndex, C = v4.getSeriesByIndex(x3), A2 = m3.dataModel || C, D = m3.dataIndex, P = m3.dataType, N = A2.getData(P), j = this._renderMode, W = e3.positionDefault, K = fZ([N.getItemModel(D), A2, C && (C.coordinateSystem || {}).model], this._tooltipModel, W ? { position: W } : null), te = K.get("trigger");
      if (!(te != null && te !== "item")) {
        var ne = A2.getDataParams(D, P), ce = new kEe();
        ne.marker = ce.makeTooltipMarker("item", $N(ne.color), j);
        var me = Rnt(A2.formatTooltip(D, false, P)), ve = K.get("order"), Be = K.get("valueFormatter"), Oe = me.frag, We = Oe ? jnt(Be ? fi({ valueFormatter: Be }, Oe) : Oe, ce, j, ve, v4.get("useUTC"), K.get("textStyle")) : me.text, Ue = "item_" + A2.name + "_" + D;
        this._showOrMove(K, function() {
          this._showTooltipContent(K, We, ne, Ue, e3.offsetX, e3.offsetY, e3.position, e3.target, ce);
        }), h({ type: "showTip", dataIndexInside: D, dataIndex: N.getRawIndex(D), seriesIndex: x3, from: this.uid });
      }
    }, r3.prototype._showComponentItemTooltip = function(e3, u, h) {
      var v4 = Ps(u), m3 = v4.tooltipConfig, x3 = m3.option || {};
      if (qa(x3)) {
        var C = x3;
        x3 = { content: C, formatter: C };
      }
      var A2 = [x3], D = this._ecModel.getComponent(v4.componentMainType, v4.componentIndex);
      D && A2.push(D), A2.push({ formatter: x3.content });
      var P = e3.positionDefault, N = fZ(A2, this._tooltipModel, P ? { position: P } : null), j = N.get("content"), W = Math.random() + "", K = new kEe();
      this._showOrMove(N, function() {
        var te = bs(N.get("formatterParams") || {});
        this._showTooltipContent(N, j, te, W, e3.offsetX, e3.offsetY, e3.position, u, K);
      }), h({ type: "showTip", from: this.uid });
    }, r3.prototype._showTooltipContent = function(e3, u, h, v4, m3, x3, C, A2, D) {
      if (this._ticket = "", !(!e3.get("showContent") || !e3.get("show"))) {
        var P = this._tooltipContent;
        P.setEnterable(e3.get("enterable"));
        var N = e3.get("formatter");
        C = C || e3.get("position");
        var j = u, W = this._getNearestPoint([m3, x3], h, e3.get("trigger"), e3.get("borderColor")), K = W.color;
        if (N)
          if (qa(N)) {
            var te = e3.ecModel.get("useUTC"), ne = Ni(h) ? h[0] : h, ce = ne && ne.axisType && ne.axisType.indexOf("time") >= 0;
            j = N, ce && (j = epe(ne.axisValue, j, te)), j = Fct(j, h, true);
          } else if (Xo(N)) {
            var me = no(function(ve, Be) {
              ve === this._ticket && (P.setContent(Be, D, e3, K, C), this._updatePosition(e3, C, m3, x3, P, h, A2));
            }, this);
            this._ticket = v4, j = N(h, v4, me);
          } else
            j = N;
        P.setContent(j, D, e3, K, C), P.show(e3, K), this._updatePosition(e3, C, m3, x3, P, h, A2);
      }
    }, r3.prototype._getNearestPoint = function(e3, u, h, v4) {
      if (h === "axis" || Ni(u))
        return { color: v4 || (this._renderMode === "html" ? "#fff" : "none") };
      if (!Ni(u))
        return { color: v4 || u.color || u.borderColor };
    }, r3.prototype._updatePosition = function(e3, u, h, v4, m3, x3, C) {
      var A2 = this._api.getWidth(), D = this._api.getHeight();
      u = u || e3.get("position");
      var P = m3.getSize(), N = e3.get("align"), j = e3.get("verticalAlign"), W = C && C.getBoundingRect().clone();
      if (C && W.applyTransform(C.transform), Xo(u) && (u = u([h, v4], x3, m3.el, W, { viewSize: [A2, D], contentSize: P.slice() })), Ni(u))
        h = za(u[0], A2), v4 = za(u[1], D);
      else if (ls(u)) {
        var K = u;
        K.width = P[0], K.height = P[1];
        var te = dg(K, { width: A2, height: D });
        h = te.x, v4 = te.y, N = null, j = null;
      } else if (qa(u) && C) {
        var ne = QMn(u, W, P, e3.get("borderWidth"));
        h = ne[0], v4 = ne[1];
      } else {
        var ne = ZMn(h, v4, m3, A2, D, N ? null : 20, j ? null : 20);
        h = ne[0], v4 = ne[1];
      }
      if (N && (h -= Zot(N) ? P[0] / 2 : N === "right" ? P[0] : 0), j && (v4 -= Zot(j) ? P[1] / 2 : j === "bottom" ? P[1] : 0), svt(e3)) {
        var ne = JMn(h, v4, m3, A2, D);
        h = ne[0], v4 = ne[1];
      }
      m3.moveTo(h, v4);
    }, r3.prototype._updateContentNotChangedOnAxis = function(e3, u) {
      var h = this._lastDataByCoordSys, v4 = this._cbParamsList, m3 = !!h && h.length === e3.length;
      return m3 && mt(h, function(x3, C) {
        var A2 = x3.dataByAxis || [], D = e3[C] || {}, P = D.dataByAxis || [];
        m3 = m3 && A2.length === P.length, m3 && mt(A2, function(N, j) {
          var W = P[j] || {}, K = N.seriesDataIndices || [], te = W.seriesDataIndices || [];
          m3 = m3 && N.value === W.value && N.axisType === W.axisType && N.axisId === W.axisId && K.length === te.length, m3 && mt(K, function(ne, ce) {
            var me = te[ce];
            m3 = m3 && ne.seriesIndex === me.seriesIndex && ne.dataIndex === me.dataIndex;
          }), v4 && mt(N.seriesDataIndices, function(ne) {
            var ce = ne.seriesIndex, me = u[ce], ve = v4[ce];
            me && ve && ve.data !== me.data && (m3 = false);
          });
        });
      }), this._lastDataByCoordSys = e3, this._cbParamsList = u, !!m3;
    }, r3.prototype._hide = function(e3) {
      this._lastDataByCoordSys = null, e3({ type: "hideTip", from: this.uid });
    }, r3.prototype.dispose = function(e3, u) {
      Fc.node || !u.getDom() || (cJ(this, "_updatePosition"), this._tooltipContent.dispose(), Gke("itemTooltip", u));
    }, r3.type = "tooltip", r3;
  }(yd);
  function fZ(l3, r3, e3) {
    var u = r3.ecModel, h;
    e3 ? (h = new Bh(e3, u, u), h = new Bh(r3.option, h, u)) : h = r3;
    for (var v4 = l3.length - 1; v4 >= 0; v4--) {
      var m3 = l3[v4];
      m3 && (m3 instanceof Bh && (m3 = m3.get("tooltip", true)), qa(m3) && (m3 = { formatter: m3 }), m3 && (h = new Bh(m3, h, u)));
    }
    return h;
  }
  function Kot(l3, r3) {
    return l3.dispatchAction || no(r3.dispatchAction, r3);
  }
  function ZMn(l3, r3, e3, u, h, v4, m3) {
    var x3 = e3.getSize(), C = x3[0], A2 = x3[1];
    return v4 != null && (l3 + C + v4 + 2 > u ? l3 -= C + v4 : l3 += v4), m3 != null && (r3 + A2 + m3 > h ? r3 -= A2 + m3 : r3 += m3), [l3, r3];
  }
  function JMn(l3, r3, e3, u, h) {
    var v4 = e3.getSize(), m3 = v4[0], x3 = v4[1];
    return l3 = Math.min(l3 + m3, u) - m3, r3 = Math.min(r3 + x3, h) - x3, l3 = Math.max(l3, 0), r3 = Math.max(r3, 0), [l3, r3];
  }
  function QMn(l3, r3, e3, u) {
    var h = e3[0], v4 = e3[1], m3 = Math.ceil(Math.SQRT2 * u) + 8, x3 = 0, C = 0, A2 = r3.width, D = r3.height;
    switch (l3) {
      case "inside":
        x3 = r3.x + A2 / 2 - h / 2, C = r3.y + D / 2 - v4 / 2;
        break;
      case "top":
        x3 = r3.x + A2 / 2 - h / 2, C = r3.y - v4 - m3;
        break;
      case "bottom":
        x3 = r3.x + A2 / 2 - h / 2, C = r3.y + D + m3;
        break;
      case "left":
        x3 = r3.x - h - m3, C = r3.y + D / 2 - v4 / 2;
        break;
      case "right":
        x3 = r3.x + A2 + m3, C = r3.y + D / 2 - v4 / 2;
    }
    return [x3, C];
  }
  function Zot(l3) {
    return l3 === "center" || l3 === "middle";
  }
  function eTn(l3, r3, e3) {
    var u = F3e(l3).queryOptionMap, h = u.keys()[0];
    if (!(!h || h === "series")) {
      var v4 = kJ(r3, h, u.get(h), { useDefault: false, enableAll: false, enableNone: false }), m3 = v4.models[0];
      if (!!m3) {
        var x3 = e3.getViewOfComponentModel(m3), C;
        if (x3.group.traverse(function(A2) {
          var D = Ps(A2).tooltipConfig;
          if (D && D.name === l3.name)
            return C = A2, true;
        }), C)
          return { componentMainType: h, componentIndex: m3.componentIndex, el: C };
      }
    }
  }
  var tTn = KMn;
  function nTn(l3) {
    kl(KJ), l3.registerComponentModel(RMn), l3.registerComponentView(tTn), l3.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, Rv), l3.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, Rv);
  }
  var rTn = ["rect", "polygon", "keep", "clear"];
  function iTn(l3, r3) {
    var e3 = Gf(l3 ? l3.brush : []);
    if (!!e3.length) {
      var u = [];
      mt(e3, function(C) {
        var A2 = C.hasOwnProperty("toolbox") ? C.toolbox : [];
        A2 instanceof Array && (u = u.concat(A2));
      });
      var h = l3 && l3.toolbox;
      Ni(h) && (h = h[0]), h || (h = { feature: {} }, l3.toolbox = [h]);
      var v4 = h.feature || (h.feature = {}), m3 = v4.brush || (v4.brush = {}), x3 = m3.type || (m3.type = []);
      x3.push.apply(x3, u), aTn(x3), r3 && !x3.length && x3.push.apply(x3, rTn);
    }
  }
  function aTn(l3) {
    var r3 = {};
    mt(l3, function(e3) {
      r3[e3] = 1;
    }), l3.length = 0, mt(r3, function(e3, u) {
      l3.push(u);
    });
  }
  var Jot = mt;
  function Qot(l3) {
    if (l3) {
      for (var r3 in l3)
        if (l3.hasOwnProperty(r3))
          return true;
    }
  }
  function Xke(l3, r3, e3) {
    var u = {};
    return Jot(r3, function(v4) {
      var m3 = u[v4] = h();
      Jot(l3[v4], function(x3, C) {
        if (!!om.isValidType(C)) {
          var A2 = { type: C, visual: x3 };
          e3 && e3(A2, v4), m3[C] = new om(A2), C === "opacity" && (A2 = bs(A2), A2.type = "colorAlpha", m3.__hidden.__alphaForOpacity = new om(A2));
        }
      });
    }), u;
    function h() {
      var v4 = function() {
      };
      v4.prototype.__hidden = v4.prototype;
      var m3 = new v4();
      return m3;
    }
  }
  function fvt(l3, r3, e3) {
    var u;
    mt(e3, function(h) {
      r3.hasOwnProperty(h) && Qot(r3[h]) && (u = true);
    }), u && mt(e3, function(h) {
      r3.hasOwnProperty(h) && Qot(r3[h]) ? l3[h] = bs(r3[h]) : delete l3[h];
    });
  }
  function oTn(l3, r3, e3, u, h, v4) {
    var m3 = {};
    mt(l3, function(P) {
      var N = om.prepareVisualTypes(r3[P]);
      m3[P] = N;
    });
    var x3;
    function C(P) {
      return pOe(e3, x3, P);
    }
    function A2(P, N) {
      Ift(e3, x3, P, N);
    }
    v4 == null ? e3.each(D) : e3.each([v4], D);
    function D(P, N) {
      x3 = v4 == null ? P : N;
      var j = e3.getRawDataItem(x3);
      if (!(j && j.visualMap === false))
        for (var W = u.call(h, P), K = r3[W], te = m3[W], ne = 0, ce = te.length; ne < ce; ne++) {
          var me = te[ne];
          K[me] && K[me].applyVisual(P, C, A2);
        }
    }
  }
  function sTn(l3, r3, e3, u) {
    var h = {};
    return mt(l3, function(v4) {
      var m3 = om.prepareVisualTypes(r3[v4]);
      h[v4] = m3;
    }), { progress: function(m3, x3) {
      var C;
      u != null && (C = x3.getDimensionIndex(u));
      function A2(Be) {
        return pOe(x3, P, Be);
      }
      function D(Be, Oe) {
        Ift(x3, P, Be, Oe);
      }
      for (var P, N = x3.getStore(); (P = m3.next()) != null; ) {
        var j = x3.getRawDataItem(P);
        if (!(j && j.visualMap === false))
          for (var W = u != null ? N.get(C, P) : P, K = e3(W), te = r3[K], ne = h[K], ce = 0, me = ne.length; ce < me; ce++) {
            var ve = ne[ce];
            te[ve] && te[ve].applyVisual(W, A2, D);
          }
      }
    } };
  }
  function lTn(l3) {
    var r3 = l3.brushType, e3 = { point: function(u) {
      return est[r3].point(u, e3, l3);
    }, rect: function(u) {
      return est[r3].rect(u, e3, l3);
    } };
    return e3;
  }
  var est = { lineX: tst(0), lineY: tst(1), rect: { point: function(l3, r3, e3) {
    return l3 && e3.boundingRect.contain(l3[0], l3[1]);
  }, rect: function(l3, r3, e3) {
    return l3 && e3.boundingRect.intersect(l3);
  } }, polygon: { point: function(l3, r3, e3) {
    return l3 && e3.boundingRect.contain(l3[0], l3[1]) && CN(e3.range, l3[0], l3[1]);
  }, rect: function(l3, r3, e3) {
    var u = e3.range;
    if (!l3 || u.length <= 1)
      return false;
    var h = l3.x, v4 = l3.y, m3 = l3.width, x3 = l3.height, C = u[0];
    if (CN(u, h, v4) || CN(u, h + m3, v4) || CN(u, h, v4 + x3) || CN(u, h + m3, v4 + x3) || Ml.create(l3).contain(C[0], C[1]) || SZ(h, v4, h + m3, v4, u) || SZ(h, v4, h, v4 + x3, u) || SZ(h + m3, v4, h + m3, v4 + x3, u) || SZ(h, v4 + x3, h + m3, v4 + x3, u))
      return true;
  } } };
  function tst(l3) {
    var r3 = ["x", "y"], e3 = ["width", "height"];
    return { point: function(u, h, v4) {
      if (u) {
        var m3 = v4.range, x3 = u[l3];
        return hZ(x3, m3);
      }
    }, rect: function(u, h, v4) {
      if (u) {
        var m3 = v4.range, x3 = [u[r3[l3]], u[r3[l3]] + u[e3[l3]]];
        return x3[1] < x3[0] && x3.reverse(), hZ(x3[0], m3) || hZ(x3[1], m3) || hZ(m3[0], x3) || hZ(m3[1], x3);
      }
    } };
  }
  function hZ(l3, r3) {
    return r3[0] <= l3 && l3 <= r3[1];
  }
  var nst = ["inBrush", "outOfBrush"], qDe = "__ecBrushSelect", Yke = "__ecInBrushSelectEvent";
  function hvt(l3) {
    l3.eachComponent({ mainType: "brush" }, function(r3) {
      var e3 = r3.brushTargetManager = new mPe(r3.option, l3);
      e3.setInputRanges(r3.areas, l3);
    });
  }
  function uTn(l3, r3, e3) {
    var u = [], h, v4;
    l3.eachComponent({ mainType: "brush" }, function(m3) {
      e3 && e3.type === "takeGlobalCursor" && m3.setBrushOption(e3.key === "brush" ? e3.brushOption : { brushType: false });
    }), hvt(l3), l3.eachComponent({ mainType: "brush" }, function(m3, x3) {
      var C = { brushId: m3.id, brushIndex: x3, brushName: m3.name, areas: bs(m3.areas), selected: [] };
      u.push(C);
      var A2 = m3.option, D = A2.brushLink, P = [], N = [], j = [], W = false;
      x3 || (h = A2.throttleType, v4 = A2.throttleDelay);
      var K = Bi(m3.areas, function(Be) {
        var Oe = pTn[Be.brushType], We = ns({ boundingRect: Oe ? Oe(Be) : void 0 }, Be);
        return We.selectors = lTn(We), We;
      }), te = Xke(m3.option, nst, function(Be) {
        Be.mappingMethod = "fixed";
      });
      Ni(D) && mt(D, function(Be) {
        P[Be] = 1;
      });
      function ne(Be) {
        return D === "all" || !!P[Be];
      }
      function ce(Be) {
        return !!Be.length;
      }
      l3.eachSeries(function(Be, Oe) {
        var We = j[Oe] = [];
        Be.subType === "parallel" ? me(Be, Oe) : ve(Be, Oe, We);
      });
      function me(Be, Oe) {
        var We = Be.coordinateSystem;
        W = W || We.hasAxisBrushed(), ne(Oe) && We.eachActiveState(Be.getData(), function(Ue, qe) {
          Ue === "active" && (N[qe] = 1);
        });
      }
      function ve(Be, Oe, We) {
        if (!(!Be.brushSelector || hTn(m3, Oe)) && (mt(K, function(qe) {
          m3.brushTargetManager.controlSeries(qe, Be, l3) && We.push(qe), W = W || ce(We);
        }), ne(Oe) && ce(We))) {
          var Ue = Be.getData();
          Ue.each(function(qe) {
            rst(Be, We, Ue, qe) && (N[qe] = 1);
          });
        }
      }
      l3.eachSeries(function(Be, Oe) {
        var We = { seriesId: Be.id, seriesIndex: Oe, seriesName: Be.name, dataIndex: [] };
        C.selected.push(We);
        var Ue = j[Oe], qe = Be.getData(), Ze = ne(Oe) ? function(ct) {
          return N[ct] ? (We.dataIndex.push(qe.getRawIndex(ct)), "inBrush") : "outOfBrush";
        } : function(ct) {
          return rst(Be, Ue, qe, ct) ? (We.dataIndex.push(qe.getRawIndex(ct)), "inBrush") : "outOfBrush";
        };
        (ne(Oe) ? W : ce(Ue)) && oTn(nst, te, qe, Ze);
      });
    }), cTn(r3, h, v4, u, e3);
  }
  function cTn(l3, r3, e3, u, h) {
    if (!!h) {
      var v4 = l3.getZr();
      if (!v4[Yke]) {
        v4[qDe] || (v4[qDe] = fTn);
        var m3 = Oj(v4, qDe, e3, r3);
        m3(l3, u);
      }
    }
  }
  function fTn(l3, r3) {
    if (!l3.isDisposed()) {
      var e3 = l3.getZr();
      e3[Yke] = true, l3.dispatchAction({ type: "brushSelect", batch: r3 }), e3[Yke] = false;
    }
  }
  function rst(l3, r3, e3, u) {
    for (var h = 0, v4 = r3.length; h < v4; h++) {
      var m3 = r3[h];
      if (l3.brushSelector(u, e3, m3.selectors, m3))
        return true;
    }
  }
  function hTn(l3, r3) {
    var e3 = l3.option.seriesIndex;
    return e3 != null && e3 !== "all" && (Ni(e3) ? Cl(e3, r3) < 0 : r3 !== e3);
  }
  var pTn = { rect: function(l3) {
    return ist(l3.range);
  }, polygon: function(l3) {
    for (var r3, e3 = l3.range, u = 0, h = e3.length; u < h; u++) {
      r3 = r3 || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
      var v4 = e3[u];
      v4[0] < r3[0][0] && (r3[0][0] = v4[0]), v4[0] > r3[0][1] && (r3[0][1] = v4[0]), v4[1] < r3[1][0] && (r3[1][0] = v4[1]), v4[1] > r3[1][1] && (r3[1][1] = v4[1]);
    }
    return r3 && ist(r3);
  } };
  function ist(l3) {
    return new Ml(l3[0][0], l3[1][0], l3[0][1] - l3[0][0], l3[1][1] - l3[1][0]);
  }
  var dTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u) {
      this.ecModel = e3, this.api = u, this.model, (this._brushController = new JOe(u.getZr())).on("brush", no(this._onBrush, this)).mount();
    }, r3.prototype.render = function(e3, u, h, v4) {
      this.model = e3, this._updateController(e3, u, h, v4);
    }, r3.prototype.updateTransform = function(e3, u, h, v4) {
      hvt(u), this._updateController(e3, u, h, v4);
    }, r3.prototype.updateVisual = function(e3, u, h, v4) {
      this.updateTransform(e3, u, h, v4);
    }, r3.prototype.updateView = function(e3, u, h, v4) {
      this._updateController(e3, u, h, v4);
    }, r3.prototype._updateController = function(e3, u, h, v4) {
      (!v4 || v4.$from !== e3.id) && this._brushController.setPanels(e3.brushTargetManager.makePanelOpts(h)).enableBrush(e3.brushOption).updateCovers(e3.areas.slice());
    }, r3.prototype.dispose = function() {
      this._brushController.dispose();
    }, r3.prototype._onBrush = function(e3) {
      var u = this.model.id, h = this.model.brushTargetManager.setOutputRanges(e3.areas, this.ecModel);
      (!e3.isEnd || e3.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: u, areas: bs(h), $from: u }), e3.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: u, areas: bs(h), $from: u });
    }, r3.type = "brush", r3;
  }(yd), vTn = dTn, gTn = "#ddd", yTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.areas = [], e3.brushOption = {}, e3;
    }
    return r3.prototype.optionUpdated = function(e3, u) {
      var h = this.option;
      !u && fvt(h, e3, ["inBrush", "outOfBrush"]);
      var v4 = h.inBrush = h.inBrush || {};
      h.outOfBrush = h.outOfBrush || { color: gTn }, v4.hasOwnProperty("liftZ") || (v4.liftZ = 5);
    }, r3.prototype.setAreas = function(e3) {
      !e3 || (this.areas = Bi(e3, function(u) {
        return ast(this.option, u);
      }, this));
    }, r3.prototype.setBrushOption = function(e3) {
      this.brushOption = ast(this.option, e3), this.brushType = this.brushOption.brushType;
    }, r3.type = "brush", r3.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], r3.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, r3;
  }(fc);
  function ast(l3, r3) {
    return ol({ brushType: l3.brushType, brushMode: l3.brushMode, transformable: l3.transformable, brushStyle: new Bh(l3.brushStyle).getItemStyle(), removeOnClick: l3.removeOnClick, z: l3.z }, r3, true);
  }
  var mTn = yTn, bTn = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], _Tn = function(l3) {
    ar(r3, l3);
    function r3() {
      return l3 !== null && l3.apply(this, arguments) || this;
    }
    return r3.prototype.render = function(e3, u, h) {
      var v4, m3, x3;
      u.eachComponent({ mainType: "brush" }, function(C) {
        v4 = C.brushType, m3 = C.brushOption.brushMode || "single", x3 = x3 || !!C.areas.length;
      }), this._brushType = v4, this._brushMode = m3, mt(e3.get("type", true), function(C) {
        e3.setIconStatus(C, (C === "keep" ? m3 === "multiple" : C === "clear" ? x3 : C === v4) ? "emphasis" : "normal");
      });
    }, r3.prototype.updateView = function(e3, u, h) {
      this.render(e3, u, h);
    }, r3.prototype.getIcons = function() {
      var e3 = this.model, u = e3.get("icon", true), h = {};
      return mt(e3.get("type", true), function(v4) {
        u[v4] && (h[v4] = u[v4]);
      }), h;
    }, r3.prototype.onclick = function(e3, u, h) {
      var v4 = this._brushType, m3 = this._brushMode;
      h === "clear" ? (u.dispatchAction({ type: "axisAreaSelect", intervals: [] }), u.dispatchAction({ type: "brush", command: "clear", areas: [] })) : u.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: h === "keep" ? v4 : v4 === h ? false : h, brushMode: h === "keep" ? m3 === "multiple" ? "single" : "multiple" : m3 } });
    }, r3.getDefaultOption = function(e3) {
      var u = { show: true, type: bTn.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: e3.getLocaleModel().get(["toolbox", "brush", "title"]) };
      return u;
    }, r3;
  }(h2), xTn = _Tn;
  function wTn(l3) {
    l3.registerComponentView(vTn), l3.registerComponentModel(mTn), l3.registerPreprocessor(iTn), l3.registerVisual(l3.PRIORITY.VISUAL.BRUSH, uTn), l3.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(r3, e3) {
      e3.eachComponent({ mainType: "brush", query: r3 }, function(u) {
        u.setAreas(r3.areas);
      });
    }), l3.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, Rv), l3.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, Rv), $z("brush", xTn);
  }
  var STn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.layoutMode = { type: "box", ignoreSize: true }, e3;
    }
    return r3.type = "title", r3.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, r3;
  }(fc), CTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      if (this.group.removeAll(), !!e3.get("show")) {
        var v4 = this.group, m3 = e3.getModel("textStyle"), x3 = e3.getModel("subtextStyle"), C = e3.get("textAlign"), A2 = dl(e3.get("textBaseline"), e3.get("textVerticalAlign")), D = new Ec({ style: ov(m3, { text: e3.get("text"), fill: m3.getTextColor() }, { disableBox: true }), z2: 10 }), P = D.getBoundingRect(), N = e3.get("subtext"), j = new Ec({ style: ov(x3, { text: N, fill: x3.getTextColor(), y: P.height + e3.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), W = e3.get("link"), K = e3.get("sublink"), te = e3.get("triggerEvent", true);
        D.silent = !W && !te, j.silent = !K && !te, W && D.on("click", function() {
          Qfe(W, "_" + e3.get("target"));
        }), K && j.on("click", function() {
          Qfe(K, "_" + e3.get("subtarget"));
        }), Ps(D).eventData = Ps(j).eventData = te ? { componentType: "title", componentIndex: e3.componentIndex } : null, v4.add(D), N && v4.add(j);
        var ne = v4.getBoundingRect(), ce = e3.getBoxLayoutParams();
        ce.width = ne.width, ce.height = ne.height;
        var me = dg(ce, { width: h.getWidth(), height: h.getHeight() }, e3.get("padding"));
        C || (C = e3.get("left") || e3.get("right"), C === "middle" && (C = "center"), C === "right" ? me.x += me.width : C === "center" && (me.x += me.width / 2)), A2 || (A2 = e3.get("top") || e3.get("bottom"), A2 === "center" && (A2 = "middle"), A2 === "bottom" ? me.y += me.height : A2 === "middle" && (me.y += me.height / 2), A2 = A2 || "top"), v4.x = me.x, v4.y = me.y, v4.markRedraw();
        var ve = { align: C, verticalAlign: A2 };
        D.setStyle(ve), j.setStyle(ve), ne = v4.getBoundingRect();
        var Be = me.margin, Oe = e3.getItemStyle(["color", "opacity"]);
        Oe.fill = e3.get("backgroundColor");
        var We = new Ju({ shape: { x: ne.x - Be[3], y: ne.y - Be[0], width: ne.width + Be[1] + Be[3], height: ne.height + Be[0] + Be[2], r: e3.get("borderRadius") }, style: Oe, subPixelOptimize: true, silent: true });
        v4.add(We);
      }
    }, r3.type = "title", r3;
  }(yd);
  function MTn(l3) {
    l3.registerComponentModel(STn), l3.registerComponentView(CTn);
  }
  var TTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.layoutMode = "box", e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      this.mergeDefaultAndTheme(e3, h), this._initData();
    }, r3.prototype.mergeOption = function(e3) {
      l3.prototype.mergeOption.apply(this, arguments), this._initData();
    }, r3.prototype.setCurrentIndex = function(e3) {
      e3 == null && (e3 = this.option.currentIndex);
      var u = this._data.count();
      this.option.loop ? e3 = (e3 % u + u) % u : (e3 >= u && (e3 = u - 1), e3 < 0 && (e3 = 0)), this.option.currentIndex = e3;
    }, r3.prototype.getCurrentIndex = function() {
      return this.option.currentIndex;
    }, r3.prototype.isIndexMax = function() {
      return this.getCurrentIndex() >= this._data.count() - 1;
    }, r3.prototype.setPlayState = function(e3) {
      this.option.autoPlay = !!e3;
    }, r3.prototype.getPlayState = function() {
      return !!this.option.autoPlay;
    }, r3.prototype._initData = function() {
      var e3 = this.option, u = e3.data || [], h = e3.axisType, v4 = this._names = [], m3;
      h === "category" ? (m3 = [], mt(u, function(A2, D) {
        var P = pg(xj(A2), ""), N;
        ls(A2) ? (N = bs(A2), N.value = D) : N = D, m3.push(N), v4.push(P);
      })) : m3 = u;
      var x3 = { category: "ordinal", time: "time", value: "number" }[h] || "number", C = this._data = new yb([{ name: "value", type: x3 }], this);
      C.initData(m3, v4);
    }, r3.prototype.getData = function() {
      return this._data;
    }, r3.prototype.getCategories = function() {
      if (this.get("axisType") === "category")
        return this._names.slice();
    }, r3.type = "timeline", r3.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, r3;
  }(fc), ost = TTn, pvt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "timeline.slider", r3.defaultOption = sP(ost.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), r3;
  }(ost);
  Fv(pvt, lOe.prototype);
  var ATn = pvt, ITn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "timeline", r3;
  }(yd), ETn = ITn, DTn = function(l3) {
    ar(r3, l3);
    function r3(e3, u, h, v4) {
      var m3 = l3.call(this, e3, u, h) || this;
      return m3.type = v4 || "value", m3;
    }
    return r3.prototype.getLabelModel = function() {
      return this.model.getModel("label");
    }, r3.prototype.isHorizontal = function() {
      return this.model.get("orient") === "horizontal";
    }, r3;
  }(bM), kTn = DTn, $De = Math.PI, sst = pc(), OTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function(e3, u) {
      this.api = u;
    }, r3.prototype.render = function(e3, u, h) {
      if (this.model = e3, this.api = h, this.ecModel = u, this.group.removeAll(), e3.get("show", true)) {
        var v4 = this._layout(e3, h), m3 = this._createGroup("_mainGroup"), x3 = this._createGroup("_labelGroup"), C = this._axis = this._createAxis(v4, e3);
        e3.formatTooltip = function(A2) {
          var D = C.scale.getLabel({ value: A2 });
          return o0("nameValue", { noName: true, value: D });
        }, mt(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(A2) {
          this["_render" + A2](v4, m3, C, e3);
        }, this), this._renderAxisLabel(v4, x3, C, e3), this._position(v4, e3);
      }
      this._doPlayStop(), this._updateTicksStatus();
    }, r3.prototype.remove = function() {
      this._clearTimer(), this.group.removeAll();
    }, r3.prototype.dispose = function() {
      this._clearTimer();
    }, r3.prototype._layout = function(e3, u) {
      var h = e3.get(["label", "position"]), v4 = e3.get("orient"), m3 = LTn(e3, u), x3;
      h == null || h === "auto" ? x3 = v4 === "horizontal" ? m3.y + m3.height / 2 < u.getHeight() / 2 ? "-" : "+" : m3.x + m3.width / 2 < u.getWidth() / 2 ? "+" : "-" : qa(h) ? x3 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[v4][h] : x3 = h;
      var C = { horizontal: "center", vertical: x3 >= 0 || x3 === "+" ? "left" : "right" }, A2 = { horizontal: x3 >= 0 || x3 === "+" ? "top" : "bottom", vertical: "middle" }, D = { horizontal: 0, vertical: $De / 2 }, P = v4 === "vertical" ? m3.height : m3.width, N = e3.getModel("controlStyle"), j = N.get("show", true), W = j ? N.get("itemSize") : 0, K = j ? N.get("itemGap") : 0, te = W + K, ne = e3.get(["label", "rotate"]) || 0;
      ne = ne * $De / 180;
      var ce, me, ve, Be = N.get("position", true), Oe = j && N.get("showPlayBtn", true), We = j && N.get("showPrevBtn", true), Ue = j && N.get("showNextBtn", true), qe = 0, Ze = P;
      Be === "left" || Be === "bottom" ? (Oe && (ce = [0, 0], qe += te), We && (me = [qe, 0], qe += te), Ue && (ve = [Ze - W, 0], Ze -= te)) : (Oe && (ce = [Ze - W, 0], Ze -= te), We && (me = [0, 0], qe += te), Ue && (ve = [Ze - W, 0], Ze -= te));
      var ct = [qe, Ze];
      return e3.get("inverse") && ct.reverse(), { viewRect: m3, mainLength: P, orient: v4, rotation: D[v4], labelRotation: ne, labelPosOpt: x3, labelAlign: e3.get(["label", "align"]) || C[v4], labelBaseline: e3.get(["label", "verticalAlign"]) || e3.get(["label", "baseline"]) || A2[v4], playPosition: ce, prevBtnPosition: me, nextBtnPosition: ve, axisExtent: ct, controlSize: W, controlGap: K };
    }, r3.prototype._position = function(e3, u) {
      var h = this._mainGroup, v4 = this._labelGroup, m3 = e3.viewRect;
      if (e3.orient === "vertical") {
        var x3 = _2(), C = m3.x, A2 = m3.y + m3.height;
        UA(x3, x3, [-C, -A2]), ZN(x3, x3, -$De / 2), UA(x3, x3, [C, A2]), m3 = m3.clone(), m3.applyTransform(x3);
      }
      var D = ce(m3), P = ce(h.getBoundingRect()), N = ce(v4.getBoundingRect()), j = [h.x, h.y], W = [v4.x, v4.y];
      W[0] = j[0] = D[0][0];
      var K = e3.labelPosOpt;
      if (K == null || qa(K)) {
        var te = K === "+" ? 0 : 1;
        me(j, P, D, 1, te), me(W, N, D, 1, 1 - te);
      } else {
        var te = K >= 0 ? 0 : 1;
        me(j, P, D, 1, te), W[1] = j[1] + K;
      }
      h.setPosition(j), v4.setPosition(W), h.rotation = v4.rotation = e3.rotation, ne(h), ne(v4);
      function ne(ve) {
        ve.originX = D[0][0] - ve.x, ve.originY = D[1][0] - ve.y;
      }
      function ce(ve) {
        return [[ve.x, ve.x + ve.width], [ve.y, ve.y + ve.height]];
      }
      function me(ve, Be, Oe, We, Ue) {
        ve[We] += Oe[We][Ue] - Be[We][Ue];
      }
    }, r3.prototype._createAxis = function(e3, u) {
      var h = u.getData(), v4 = u.get("axisType"), m3 = PTn(u, v4);
      m3.getTicks = function() {
        return h.mapArray(["value"], function(A2) {
          return { value: A2 };
        });
      };
      var x3 = h.getDataExtent("value");
      m3.setExtent(x3[0], x3[1]), m3.calcNiceTicks();
      var C = new kTn("value", m3, e3.axisExtent, v4);
      return C.model = u, C;
    }, r3.prototype._createGroup = function(e3) {
      var u = this[e3] = new Cs();
      return this.group.add(u), u;
    }, r3.prototype._renderAxisLine = function(e3, u, h, v4) {
      var m3 = h.getExtent();
      if (!!v4.get(["lineStyle", "show"])) {
        var x3 = new ty({ shape: { x1: m3[0], y1: 0, x2: m3[1], y2: 0 }, style: fi({ lineCap: "round" }, v4.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
        u.add(x3);
        var C = this._progressLine = new ty({ shape: { x1: m3[0], x2: this._currentPointer ? this._currentPointer.x : m3[0], y1: 0, y2: 0 }, style: ns({ lineCap: "round", lineWidth: x3.style.lineWidth }, v4.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
        u.add(C);
      }
    }, r3.prototype._renderAxisTick = function(e3, u, h, v4) {
      var m3 = this, x3 = v4.getData(), C = h.scale.getTicks();
      this._tickSymbols = [], mt(C, function(A2) {
        var D = h.dataToCoord(A2.value), P = x3.getItemModel(A2.value), N = P.getModel("itemStyle"), j = P.getModel(["emphasis", "itemStyle"]), W = P.getModel(["progress", "itemStyle"]), K = { x: D, y: 0, onclick: no(m3._changeTimeline, m3, A2.value) }, te = lst(P, N, u, K);
        te.ensureState("emphasis").style = j.getItemStyle(), te.ensureState("progress").style = W.getItemStyle(), FN(te);
        var ne = Ps(te);
        P.get("tooltip") ? (ne.dataIndex = A2.value, ne.dataModel = v4) : ne.dataIndex = ne.dataModel = null, m3._tickSymbols.push(te);
      });
    }, r3.prototype._renderAxisLabel = function(e3, u, h, v4) {
      var m3 = this, x3 = h.getLabelModel();
      if (!!x3.get("show")) {
        var C = v4.getData(), A2 = h.getViewLabels();
        this._tickLabels = [], mt(A2, function(D) {
          var P = D.tickValue, N = C.getItemModel(P), j = N.getModel("label"), W = N.getModel(["emphasis", "label"]), K = N.getModel(["progress", "label"]), te = h.dataToCoord(D.tickValue), ne = new Ec({ x: te, y: 0, rotation: e3.labelRotation - e3.rotation, onclick: no(m3._changeTimeline, m3, P), silent: false, style: ov(j, { text: D.formattedLabel, align: e3.labelAlign, verticalAlign: e3.labelBaseline }) });
          ne.ensureState("emphasis").style = ov(W), ne.ensureState("progress").style = ov(K), u.add(ne), FN(ne), sst(ne).dataIndex = P, m3._tickLabels.push(ne);
        });
      }
    }, r3.prototype._renderControl = function(e3, u, h, v4) {
      var m3 = e3.controlSize, x3 = e3.rotation, C = v4.getModel("controlStyle").getItemStyle(), A2 = v4.getModel(["emphasis", "controlStyle"]).getItemStyle(), D = v4.getPlayState(), P = v4.get("inverse", true);
      N(e3.nextBtnPosition, "next", no(this._changeTimeline, this, P ? "-" : "+")), N(e3.prevBtnPosition, "prev", no(this._changeTimeline, this, P ? "+" : "-")), N(e3.playPosition, D ? "stop" : "play", no(this._handlePlayClick, this, !D), true);
      function N(j, W, K, te) {
        if (!!j) {
          var ne = gM(dl(v4.get(["controlStyle", W + "BtnSize"]), m3), m3), ce = [0, -ne / 2, ne, ne], me = RTn(v4, W + "Icon", ce, { x: j[0], y: j[1], originX: m3 / 2, originY: 0, rotation: te ? -x3 : 0, rectHover: true, style: C, onclick: K });
          me.ensureState("emphasis").style = A2, u.add(me), FN(me);
        }
      }
    }, r3.prototype._renderCurrentPointer = function(e3, u, h, v4) {
      var m3 = v4.getData(), x3 = v4.getCurrentIndex(), C = m3.getItemModel(x3).getModel("checkpointStyle"), A2 = this, D = { onCreate: function(P) {
        P.draggable = true, P.drift = no(A2._handlePointerDrag, A2), P.ondragend = no(A2._handlePointerDragend, A2), ust(P, A2._progressLine, x3, h, v4, true);
      }, onUpdate: function(P) {
        ust(P, A2._progressLine, x3, h, v4);
      } };
      this._currentPointer = lst(C, C, this._mainGroup, {}, this._currentPointer, D);
    }, r3.prototype._handlePlayClick = function(e3) {
      this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: e3, from: this.uid });
    }, r3.prototype._handlePointerDrag = function(e3, u, h) {
      this._clearTimer(), this._pointerChangeTimeline([h.offsetX, h.offsetY]);
    }, r3.prototype._handlePointerDragend = function(e3) {
      this._pointerChangeTimeline([e3.offsetX, e3.offsetY], true);
    }, r3.prototype._pointerChangeTimeline = function(e3, u) {
      var h = this._toAxisCoord(e3)[0], v4 = this._axis, m3 = g2(v4.getExtent().slice());
      h > m3[1] && (h = m3[1]), h < m3[0] && (h = m3[0]), this._currentPointer.x = h, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = h, this._progressLine.dirty();
      var x3 = this._findNearestTick(h), C = this.model;
      (u || x3 !== C.getCurrentIndex() && C.get("realtime")) && this._changeTimeline(x3);
    }, r3.prototype._doPlayStop = function() {
      var e3 = this;
      this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
        var u = e3.model;
        e3._changeTimeline(u.getCurrentIndex() + (u.get("rewind", true) ? -1 : 1));
      }, this.model.get("playInterval")));
    }, r3.prototype._toAxisCoord = function(e3) {
      var u = this._mainGroup.getLocalTransform();
      return vM(e3, u, true);
    }, r3.prototype._findNearestTick = function(e3) {
      var u = this.model.getData(), h = 1 / 0, v4, m3 = this._axis;
      return u.each(["value"], function(x3, C) {
        var A2 = m3.dataToCoord(x3), D = Math.abs(A2 - e3);
        D < h && (h = D, v4 = C);
      }), v4;
    }, r3.prototype._clearTimer = function() {
      this._timer && (clearTimeout(this._timer), this._timer = null);
    }, r3.prototype._changeTimeline = function(e3) {
      var u = this.model.getCurrentIndex();
      e3 === "+" ? e3 = u + 1 : e3 === "-" && (e3 = u - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: e3, from: this.uid });
    }, r3.prototype._updateTicksStatus = function() {
      var e3 = this.model.getCurrentIndex(), u = this._tickSymbols, h = this._tickLabels;
      if (u)
        for (var v4 = 0; v4 < u.length; v4++)
          u && u[v4] && u[v4].toggleState("progress", v4 < e3);
      if (h)
        for (var v4 = 0; v4 < h.length; v4++)
          h && h[v4] && h[v4].toggleState("progress", sst(h[v4]).dataIndex <= e3);
    }, r3.type = "timeline.slider", r3;
  }(ETn);
  function PTn(l3, r3) {
    if (r3 = r3 || l3.get("type"), r3)
      switch (r3) {
        case "category":
          return new _Oe({ ordinalMeta: l3.getCategories(), extent: [1 / 0, -1 / 0] });
        case "time":
          return new yht({ locale: l3.ecModel.getLocaleModel(), useUTC: l3.ecModel.get("useUTC") });
        default:
          return new tP();
      }
  }
  function LTn(l3, r3) {
    return dg(l3.getBoxLayoutParams(), { width: r3.getWidth(), height: r3.getHeight() }, l3.get("padding"));
  }
  function RTn(l3, r3, e3, u) {
    var h = u.style, v4 = RJ(l3.get(["controlStyle", r3]), u || {}, new Ml(e3[0], e3[1], e3[2], e3[3]));
    return h && v4.setStyle(h), v4;
  }
  function lst(l3, r3, e3, u, h, v4) {
    var m3 = r3.get("color");
    if (h)
      h.setColor(m3), e3.add(h), v4 && v4.onUpdate(h);
    else {
      var x3 = l3.get("symbol");
      h = Nv(x3, -1, -1, 2, 2, m3), h.setStyle("strokeNoScale", true), e3.add(h), v4 && v4.onCreate(h);
    }
    var C = r3.getItemStyle(["color"]);
    h.setStyle(C), u = ol({ rectHover: true, z2: 100 }, u, true);
    var A2 = BJ(l3.get("symbolSize"));
    u.scaleX = A2[0] / 2, u.scaleY = A2[1] / 2;
    var D = Pj(l3.get("symbolOffset"), A2);
    D && (u.x = (u.x || 0) + D[0], u.y = (u.y || 0) + D[1]);
    var P = l3.get("symbolRotate");
    return u.rotation = (P || 0) * Math.PI / 180 || 0, h.attr(u), h.updateTransform(), h;
  }
  function ust(l3, r3, e3, u, h, v4) {
    if (!l3.dragging) {
      var m3 = h.getModel("checkpointStyle"), x3 = u.dataToCoord(h.getData().get("value", e3));
      if (v4 || !m3.get("animation", true))
        l3.attr({ x: x3, y: 0 }), r3 && r3.attr({ shape: { x2: x3 } });
      else {
        var C = { duration: m3.get("animationDuration", true), easing: m3.get("animationEasing", true) };
        l3.stopAnimation(null, true), l3.animateTo({ x: x3, y: 0 }, C), r3 && r3.animateTo({ shape: { x2: x3 } }, C);
      }
    }
  }
  var NTn = OTn;
  function FTn(l3) {
    l3.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(r3, e3, u) {
      var h = e3.getComponent("timeline");
      return h && r3.currentIndex != null && (h.setCurrentIndex(r3.currentIndex), !h.get("loop", true) && h.isIndexMax() && h.getPlayState() && (h.setPlayState(false), u.dispatchAction({ type: "timelinePlayChange", playState: false, from: r3.from }))), e3.resetOption("timeline", { replaceMerge: h.get("replaceMerge", true) }), ns({ currentIndex: h.option.currentIndex }, r3);
    }), l3.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(r3, e3) {
      var u = e3.getComponent("timeline");
      u && r3.playState != null && u.setPlayState(r3.playState);
    });
  }
  function VTn(l3) {
    var r3 = l3 && l3.timeline;
    Ni(r3) || (r3 = r3 ? [r3] : []), mt(r3, function(e3) {
      !e3 || BTn(e3);
    });
  }
  function BTn(l3) {
    var r3 = l3.type, e3 = { number: "value", time: "time" };
    if (e3[r3] && (l3.axisType = e3[r3], delete l3.type), cst(l3), AN(l3, "controlPosition")) {
      var u = l3.controlStyle || (l3.controlStyle = {});
      AN(u, "position") || (u.position = l3.controlPosition), u.position === "none" && !AN(u, "show") && (u.show = false, delete u.position), delete l3.controlPosition;
    }
    mt(l3.data || [], function(h) {
      ls(h) && !Ni(h) && (!AN(h, "value") && AN(h, "name") && (h.value = h.name), cst(h));
    });
  }
  function cst(l3) {
    var r3 = l3.itemStyle || (l3.itemStyle = {}), e3 = r3.emphasis || (r3.emphasis = {}), u = l3.label || l3.label || {}, h = u.normal || (u.normal = {}), v4 = { normal: 1, emphasis: 1 };
    mt(u, function(m3, x3) {
      !v4[x3] && !AN(h, x3) && (h[x3] = m3);
    }), e3.label && !AN(u, "emphasis") && (u.emphasis = e3.label, delete e3.label);
  }
  function AN(l3, r3) {
    return l3.hasOwnProperty(r3);
  }
  function zTn(l3) {
    l3.registerComponentModel(ATn), l3.registerComponentView(NTn), l3.registerSubTypeDefaulter("timeline", function() {
      return "slider";
    }), FTn(l3), l3.registerPreprocessor(VTn);
  }
  function xPe(l3, r3) {
    if (!l3)
      return false;
    for (var e3 = Ni(l3) ? l3 : [l3], u = 0; u < e3.length; u++)
      if (e3[u] && e3[u][r3])
        return true;
    return false;
  }
  function rfe(l3) {
    HN(l3, "label", ["show"]);
  }
  var ife = pc(), dvt = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.createdBySelf = false, e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      this.mergeDefaultAndTheme(e3, h), this._mergeOption(e3, h, false, true);
    }, r3.prototype.isAnimationEnabled = function() {
      if (Fc.node)
        return false;
      var e3 = this.__hostSeries;
      return this.getShallow("animation") && e3 && e3.isAnimationEnabled();
    }, r3.prototype.mergeOption = function(e3, u) {
      this._mergeOption(e3, u, false, false);
    }, r3.prototype._mergeOption = function(e3, u, h, v4) {
      var m3 = this.mainType;
      h || u.eachSeries(function(x3) {
        var C = x3.get(this.mainType, true), A2 = ife(x3)[m3];
        if (!C || !C.data) {
          ife(x3)[m3] = null;
          return;
        }
        A2 ? A2._mergeOption(C, u, true) : (v4 && rfe(C), mt(C.data, function(D) {
          D instanceof Array ? (rfe(D[0]), rfe(D[1])) : rfe(D);
        }), A2 = this.createMarkerModelFromSeries(C, this, u), fi(A2, { mainType: this.mainType, seriesIndex: x3.seriesIndex, name: x3.name, createdBySelf: true }), A2.__hostSeries = x3), ife(x3)[m3] = A2;
      }, this);
    }, r3.prototype.formatTooltip = function(e3, u, h) {
      var v4 = this.getData(), m3 = this.getRawValue(e3), x3 = v4.getName(e3);
      return o0("section", { header: this.name, blocks: [o0("nameValue", { name: x3, value: m3, noName: !x3, noValue: m3 == null })] });
    }, r3.prototype.getData = function() {
      return this._data;
    }, r3.prototype.setData = function(e3) {
      this._data = e3;
    }, r3.getMarkerModelFromSeries = function(e3, u) {
      return ife(e3)[u];
    }, r3.type = "marker", r3.dependencies = ["series", "grid", "polar", "geo"], r3;
  }(fc);
  Fv(dvt, lOe.prototype);
  var iP = dvt, jTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.createMarkerModelFromSeries = function(e3, u, h) {
      return new r3(e3, u, h);
    }, r3.type = "markPoint", r3.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, r3;
  }(iP), GTn = jTn;
  function HTn(l3) {
    return !(isNaN(parseFloat(l3.x)) && isNaN(parseFloat(l3.y)));
  }
  function WTn(l3) {
    return !isNaN(parseFloat(l3.x)) && !isNaN(parseFloat(l3.y));
  }
  function afe(l3, r3, e3, u, h, v4) {
    var m3 = [], x3 = eP(r3, u), C = x3 ? r3.getCalculationInfo("stackResultDimension") : u, A2 = wPe(r3, C, l3), D = r3.indicesOfNearest(C, A2)[0];
    m3[h] = r3.get(e3, D), m3[v4] = r3.get(C, D);
    var P = r3.get(u, D), N = NA(r3.get(u, D));
    return N = Math.min(N, 20), N >= 0 && (m3[v4] = +m3[v4].toFixed(N)), [m3, P];
  }
  var XDe = { min: Fs(afe, "min"), max: Fs(afe, "max"), average: Fs(afe, "average"), median: Fs(afe, "median") };
  function CJ(l3, r3) {
    var e3 = l3.getData(), u = l3.coordinateSystem;
    if (r3 && !WTn(r3) && !Ni(r3.coord) && u) {
      var h = u.dimensions, v4 = vvt(r3, e3, u, l3);
      if (r3 = bs(r3), r3.type && XDe[r3.type] && v4.baseAxis && v4.valueAxis) {
        var m3 = Cl(h, v4.baseAxis.dim), x3 = Cl(h, v4.valueAxis.dim), C = XDe[r3.type](e3, v4.baseDataDim, v4.valueDataDim, m3, x3);
        r3.coord = C[0], r3.value = C[1];
      } else {
        for (var A2 = [r3.xAxis != null ? r3.xAxis : r3.radiusAxis, r3.yAxis != null ? r3.yAxis : r3.angleAxis], D = 0; D < 2; D++)
          XDe[A2[D]] && (A2[D] = wPe(e3, e3.mapDimension(h[D]), A2[D]));
        r3.coord = A2;
      }
    }
    return r3;
  }
  function vvt(l3, r3, e3, u) {
    var h = {};
    return l3.valueIndex != null || l3.valueDim != null ? (h.valueDataDim = l3.valueIndex != null ? r3.getDimension(l3.valueIndex) : l3.valueDim, h.valueAxis = e3.getAxis(UTn(u, h.valueDataDim)), h.baseAxis = e3.getOtherAxis(h.valueAxis), h.baseDataDim = r3.mapDimension(h.baseAxis.dim)) : (h.baseAxis = u.getBaseAxis(), h.valueAxis = e3.getOtherAxis(h.baseAxis), h.baseDataDim = r3.mapDimension(h.baseAxis.dim), h.valueDataDim = r3.mapDimension(h.valueAxis.dim)), h;
  }
  function UTn(l3, r3) {
    var e3 = l3.getData().getDimensionInfo(r3);
    return e3 && e3.coordDim;
  }
  function MJ(l3, r3) {
    return l3 && l3.containData && r3.coord && !HTn(r3) ? l3.containData(r3.coord) : true;
  }
  function gvt(l3, r3) {
    return l3 ? function(e3, u, h, v4) {
      var m3 = v4 < 2 ? e3.coord && e3.coord[v4] : e3.value;
      return XO(m3, r3[v4]);
    } : function(e3, u, h, v4) {
      return XO(e3.value, r3[v4]);
    };
  }
  function wPe(l3, r3, e3) {
    if (e3 === "average") {
      var u = 0, h = 0;
      return l3.each(r3, function(v4, m3) {
        isNaN(v4) || (u += v4, h++);
      }), u / h;
    } else
      return e3 === "median" ? l3.getMedian(r3) : l3.getDataExtent(r3)[e3 === "max" ? 1 : 0];
  }
  var YDe = pc(), qTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.init = function() {
      this.markerGroupMap = Ho();
    }, r3.prototype.render = function(e3, u, h) {
      var v4 = this, m3 = this.markerGroupMap;
      m3.each(function(x3) {
        YDe(x3).keep = false;
      }), u.eachSeries(function(x3) {
        var C = iP.getMarkerModelFromSeries(x3, v4.type);
        C && v4.renderSeries(x3, C, u, h);
      }), m3.each(function(x3) {
        !YDe(x3).keep && v4.group.remove(x3.group);
      });
    }, r3.prototype.markKeep = function(e3) {
      YDe(e3).keep = true;
    }, r3.prototype.blurSeries = function(e3) {
      var u = this;
      mt(e3, function(h) {
        var v4 = iP.getMarkerModelFromSeries(h, u.type);
        if (v4) {
          var m3 = v4.getData();
          m3.eachItemGraphicEl(function(x3) {
            x3 && Hut(x3);
          });
        }
      });
    }, r3.type = "marker", r3;
  }(yd), SPe = qTn;
  function fst(l3, r3, e3) {
    var u = r3.coordinateSystem;
    l3.each(function(h) {
      var v4 = l3.getItemModel(h), m3, x3 = za(v4.get("x"), e3.getWidth()), C = za(v4.get("y"), e3.getHeight());
      if (!isNaN(x3) && !isNaN(C))
        m3 = [x3, C];
      else if (r3.getMarkerPosition)
        m3 = r3.getMarkerPosition(l3.getValues(l3.dimensions, h));
      else if (u) {
        var A2 = l3.get(u.dimensions[0], h), D = l3.get(u.dimensions[1], h);
        m3 = u.dataToPoint([A2, D]);
      }
      isNaN(x3) || (m3[0] = x3), isNaN(C) || (m3[1] = C), l3.setItemLayout(h, m3);
    });
  }
  var $Tn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.updateTransform = function(e3, u, h) {
      u.eachSeries(function(v4) {
        var m3 = iP.getMarkerModelFromSeries(v4, "markPoint");
        m3 && (fst(m3.getData(), v4, h), this.markerGroupMap.get(v4.id).updateLayout());
      }, this);
    }, r3.prototype.renderSeries = function(e3, u, h, v4) {
      var m3 = e3.coordinateSystem, x3 = e3.id, C = e3.getData(), A2 = this.markerGroupMap, D = A2.get(x3) || A2.set(x3, new WJ()), P = XTn(m3, e3, u);
      u.setData(P), fst(u.getData(), e3, v4), P.each(function(N) {
        var j = P.getItemModel(N), W = j.getShallow("symbol"), K = j.getShallow("symbolSize"), te = j.getShallow("symbolRotate"), ne = j.getShallow("symbolOffset"), ce = j.getShallow("symbolKeepAspect");
        if (Xo(W) || Xo(K) || Xo(te) || Xo(ne)) {
          var me = u.getRawValue(N), ve = u.getDataParams(N);
          Xo(W) && (W = W(me, ve)), Xo(K) && (K = K(me, ve)), Xo(te) && (te = te(me, ve)), Xo(ne) && (ne = ne(me, ve));
        }
        var Be = j.getModel("itemStyle").getItemStyle(), Oe = VJ(C, "color");
        Be.fill || (Be.fill = Oe), P.setItemVisual(N, { symbol: W, symbolSize: K, symbolRotate: te, symbolOffset: ne, symbolKeepAspect: ce, style: Be });
      }), D.updateData(P), this.group.add(D.group), P.eachItemGraphicEl(function(N) {
        N.traverse(function(j) {
          Ps(j).dataModel = u;
        });
      }), this.markKeep(D), D.group.silent = u.get("silent") || e3.get("silent");
    }, r3.type = "markPoint", r3;
  }(SPe);
  function XTn(l3, r3, e3) {
    var u;
    l3 ? u = Bi(l3 && l3.dimensions, function(x3) {
      var C = r3.getData().getDimensionInfo(r3.getData().mapDimension(x3)) || {};
      return fi(fi({}, C), { name: x3, ordinalMeta: null });
    }) : u = [{ name: "value", type: "float" }];
    var h = new yb(u, e3), v4 = Bi(e3.get("data"), Fs(CJ, r3));
    l3 && (v4 = jf(v4, Fs(MJ, l3)));
    var m3 = gvt(!!l3, u);
    return h.initData(v4, null, m3), h;
  }
  var YTn = $Tn;
  function KTn(l3) {
    l3.registerComponentModel(GTn), l3.registerComponentView(YTn), l3.registerPreprocessor(function(r3) {
      xPe(r3.series, "markPoint") && (r3.markPoint = r3.markPoint || {});
    });
  }
  var ZTn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.createMarkerModelFromSeries = function(e3, u, h) {
      return new r3(e3, u, h);
    }, r3.type = "markLine", r3.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, r3;
  }(iP), JTn = ZTn, ofe = pc(), QTn = function(l3, r3, e3, u) {
    var h = l3.getData(), v4;
    if (Ni(u))
      v4 = u;
    else {
      var m3 = u.type;
      if (m3 === "min" || m3 === "max" || m3 === "average" || m3 === "median" || u.xAxis != null || u.yAxis != null) {
        var x3 = void 0, C = void 0;
        if (u.yAxis != null || u.xAxis != null)
          x3 = r3.getAxis(u.yAxis != null ? "y" : "x"), C = ey(u.yAxis, u.xAxis);
        else {
          var A2 = vvt(u, h, r3, l3);
          x3 = A2.valueAxis;
          var D = rht(h, A2.valueDataDim);
          C = wPe(h, D, m3);
        }
        var P = x3.dim === "x" ? 0 : 1, N = 1 - P, j = bs(u), W = { coord: [] };
        j.type = null, j.coord = [], j.coord[N] = -1 / 0, W.coord[N] = 1 / 0;
        var K = e3.get("precision");
        K >= 0 && Vc(C) && (C = +C.toFixed(Math.min(K, 20))), j.coord[P] = W.coord[P] = C, v4 = [j, W, { type: m3, valueIndex: u.valueIndex, value: C }];
      } else
        v4 = [];
    }
    var te = [CJ(l3, v4[0]), CJ(l3, v4[1]), fi({}, v4[2])];
    return te[2].type = te[2].type || null, ol(te[2], te[0]), ol(te[2], te[1]), te;
  };
  function Mhe(l3) {
    return !isNaN(l3) && !isFinite(l3);
  }
  function hst(l3, r3, e3, u) {
    var h = 1 - l3, v4 = u.dimensions[l3];
    return Mhe(r3[h]) && Mhe(e3[h]) && r3[l3] === e3[l3] && u.getAxis(v4).containData(r3[l3]);
  }
  function eAn(l3, r3) {
    if (l3.type === "cartesian2d") {
      var e3 = r3[0].coord, u = r3[1].coord;
      if (e3 && u && (hst(1, e3, u, l3) || hst(0, e3, u, l3)))
        return true;
    }
    return MJ(l3, r3[0]) && MJ(l3, r3[1]);
  }
  function KDe(l3, r3, e3, u, h) {
    var v4 = u.coordinateSystem, m3 = l3.getItemModel(r3), x3, C = za(m3.get("x"), h.getWidth()), A2 = za(m3.get("y"), h.getHeight());
    if (!isNaN(C) && !isNaN(A2))
      x3 = [C, A2];
    else {
      if (u.getMarkerPosition)
        x3 = u.getMarkerPosition(l3.getValues(l3.dimensions, r3));
      else {
        var D = v4.dimensions, P = l3.get(D[0], r3), N = l3.get(D[1], r3);
        x3 = v4.dataToPoint([P, N]);
      }
      if (a5(v4, "cartesian2d")) {
        var j = v4.getAxis("x"), W = v4.getAxis("y"), D = v4.dimensions;
        Mhe(l3.get(D[0], r3)) ? x3[0] = j.toGlobalCoord(j.getExtent()[e3 ? 0 : 1]) : Mhe(l3.get(D[1], r3)) && (x3[1] = W.toGlobalCoord(W.getExtent()[e3 ? 0 : 1]));
      }
      isNaN(C) || (x3[0] = C), isNaN(A2) || (x3[1] = A2);
    }
    l3.setItemLayout(r3, x3);
  }
  var tAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.updateTransform = function(e3, u, h) {
      u.eachSeries(function(v4) {
        var m3 = iP.getMarkerModelFromSeries(v4, "markLine");
        if (m3) {
          var x3 = m3.getData(), C = ofe(m3).from, A2 = ofe(m3).to;
          C.each(function(D) {
            KDe(C, D, true, v4, h), KDe(A2, D, false, v4, h);
          }), x3.each(function(D) {
            x3.setItemLayout(D, [C.getItemLayout(D), A2.getItemLayout(D)]);
          }), this.markerGroupMap.get(v4.id).updateLayout();
        }
      }, this);
    }, r3.prototype.renderSeries = function(e3, u, h, v4) {
      var m3 = e3.coordinateSystem, x3 = e3.id, C = e3.getData(), A2 = this.markerGroupMap, D = A2.get(x3) || A2.set(x3, new qOe());
      this.group.add(D.group);
      var P = nAn(m3, e3, u), N = P.from, j = P.to, W = P.line;
      ofe(u).from = N, ofe(u).to = j, u.setData(W);
      var K = u.get("symbol"), te = u.get("symbolSize"), ne = u.get("symbolRotate"), ce = u.get("symbolOffset");
      Ni(K) || (K = [K, K]), Ni(te) || (te = [te, te]), Ni(ne) || (ne = [ne, ne]), Ni(ce) || (ce = [ce, ce]), P.from.each(function(ve) {
        me(N, ve, true), me(j, ve, false);
      }), W.each(function(ve) {
        var Be = W.getItemModel(ve).getModel("lineStyle").getLineStyle();
        W.setItemLayout(ve, [N.getItemLayout(ve), j.getItemLayout(ve)]), Be.stroke == null && (Be.stroke = N.getItemVisual(ve, "style").fill), W.setItemVisual(ve, { fromSymbolKeepAspect: N.getItemVisual(ve, "symbolKeepAspect"), fromSymbolOffset: N.getItemVisual(ve, "symbolOffset"), fromSymbolRotate: N.getItemVisual(ve, "symbolRotate"), fromSymbolSize: N.getItemVisual(ve, "symbolSize"), fromSymbol: N.getItemVisual(ve, "symbol"), toSymbolKeepAspect: j.getItemVisual(ve, "symbolKeepAspect"), toSymbolOffset: j.getItemVisual(ve, "symbolOffset"), toSymbolRotate: j.getItemVisual(ve, "symbolRotate"), toSymbolSize: j.getItemVisual(ve, "symbolSize"), toSymbol: j.getItemVisual(ve, "symbol"), style: Be });
      }), D.updateData(W), P.line.eachItemGraphicEl(function(ve, Be) {
        ve.traverse(function(Oe) {
          Ps(Oe).dataModel = u;
        });
      });
      function me(ve, Be, Oe) {
        var We = ve.getItemModel(Be);
        KDe(ve, Be, Oe, e3, v4);
        var Ue = We.getModel("itemStyle").getItemStyle();
        Ue.fill == null && (Ue.fill = VJ(C, "color")), ve.setItemVisual(Be, { symbolKeepAspect: We.get("symbolKeepAspect"), symbolOffset: dl(We.get("symbolOffset", true), ce[Oe ? 0 : 1]), symbolRotate: dl(We.get("symbolRotate", true), ne[Oe ? 0 : 1]), symbolSize: dl(We.get("symbolSize"), te[Oe ? 0 : 1]), symbol: dl(We.get("symbol", true), K[Oe ? 0 : 1]), style: Ue });
      }
      this.markKeep(D), D.group.silent = u.get("silent") || e3.get("silent");
    }, r3.type = "markLine", r3;
  }(SPe);
  function nAn(l3, r3, e3) {
    var u;
    l3 ? u = Bi(l3 && l3.dimensions, function(A2) {
      var D = r3.getData().getDimensionInfo(r3.getData().mapDimension(A2)) || {};
      return fi(fi({}, D), { name: A2, ordinalMeta: null });
    }) : u = [{ name: "value", type: "float" }];
    var h = new yb(u, e3), v4 = new yb(u, e3), m3 = new yb([], e3), x3 = Bi(e3.get("data"), Fs(QTn, r3, l3, e3));
    l3 && (x3 = jf(x3, Fs(eAn, l3)));
    var C = gvt(!!l3, u);
    return h.initData(Bi(x3, function(A2) {
      return A2[0];
    }), null, C), v4.initData(Bi(x3, function(A2) {
      return A2[1];
    }), null, C), m3.initData(Bi(x3, function(A2) {
      return A2[2];
    })), m3.hasItemOption = true, { from: h, to: v4, line: m3 };
  }
  var rAn = tAn;
  function iAn(l3) {
    l3.registerComponentModel(JTn), l3.registerComponentView(rAn), l3.registerPreprocessor(function(r3) {
      xPe(r3.series, "markLine") && (r3.markLine = r3.markLine || {});
    });
  }
  var aAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.createMarkerModelFromSeries = function(e3, u, h) {
      return new r3(e3, u, h);
    }, r3.type = "markArea", r3.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, r3;
  }(iP), oAn = aAn, sfe = pc(), sAn = function(l3, r3, e3, u) {
    var h = CJ(l3, u[0]), v4 = CJ(l3, u[1]), m3 = h.coord, x3 = v4.coord;
    m3[0] = ey(m3[0], -1 / 0), m3[1] = ey(m3[1], -1 / 0), x3[0] = ey(x3[0], 1 / 0), x3[1] = ey(x3[1], 1 / 0);
    var C = T3e([{}, h, v4]);
    return C.coord = [h.coord, v4.coord], C.x0 = h.x, C.y0 = h.y, C.x1 = v4.x, C.y1 = v4.y, C;
  };
  function The(l3) {
    return !isNaN(l3) && !isFinite(l3);
  }
  function pst(l3, r3, e3, u) {
    var h = 1 - l3;
    return The(r3[h]) && The(e3[h]);
  }
  function lAn(l3, r3) {
    var e3 = r3.coord[0], u = r3.coord[1];
    return a5(l3, "cartesian2d") && e3 && u && (pst(1, e3, u) || pst(0, e3, u)) ? true : MJ(l3, { coord: e3, x: r3.x0, y: r3.y0 }) || MJ(l3, { coord: u, x: r3.x1, y: r3.y1 });
  }
  function dst(l3, r3, e3, u, h) {
    var v4 = u.coordinateSystem, m3 = l3.getItemModel(r3), x3, C = za(m3.get(e3[0]), h.getWidth()), A2 = za(m3.get(e3[1]), h.getHeight());
    if (!isNaN(C) && !isNaN(A2))
      x3 = [C, A2];
    else {
      if (u.getMarkerPosition)
        x3 = u.getMarkerPosition(l3.getValues(e3, r3));
      else {
        var D = l3.get(e3[0], r3), P = l3.get(e3[1], r3), N = [D, P];
        v4.clampData && v4.clampData(N, N), x3 = v4.dataToPoint(N, true);
      }
      if (a5(v4, "cartesian2d")) {
        var j = v4.getAxis("x"), W = v4.getAxis("y"), D = l3.get(e3[0], r3), P = l3.get(e3[1], r3);
        The(D) ? x3[0] = j.toGlobalCoord(j.getExtent()[e3[0] === "x0" ? 0 : 1]) : The(P) && (x3[1] = W.toGlobalCoord(W.getExtent()[e3[1] === "y0" ? 0 : 1]));
      }
      isNaN(C) || (x3[0] = C), isNaN(A2) || (x3[1] = A2);
    }
    return x3;
  }
  var vst = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], uAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.updateTransform = function(e3, u, h) {
      u.eachSeries(function(v4) {
        var m3 = iP.getMarkerModelFromSeries(v4, "markArea");
        if (m3) {
          var x3 = m3.getData();
          x3.each(function(C) {
            var A2 = Bi(vst, function(P) {
              return dst(x3, C, P, v4, h);
            });
            x3.setItemLayout(C, A2);
            var D = x3.getItemGraphicEl(C);
            D.setShape("points", A2);
          });
        }
      }, this);
    }, r3.prototype.renderSeries = function(e3, u, h, v4) {
      var m3 = e3.coordinateSystem, x3 = e3.id, C = e3.getData(), A2 = this.markerGroupMap, D = A2.get(x3) || A2.set(x3, { group: new Cs() });
      this.group.add(D.group), this.markKeep(D);
      var P = cAn(m3, e3, u);
      u.setData(P), P.each(function(N) {
        var j = Bi(vst, function(Ue) {
          return dst(P, N, Ue, e3, v4);
        }), W = m3.getAxis("x").scale, K = m3.getAxis("y").scale, te = W.getExtent(), ne = K.getExtent(), ce = [W.parse(P.get("x0", N)), W.parse(P.get("x1", N))], me = [K.parse(P.get("y0", N)), K.parse(P.get("y1", N))];
        g2(ce), g2(me);
        var ve = !(te[0] > ce[1] || te[1] < ce[0] || ne[0] > me[1] || ne[1] < me[0]), Be = !ve;
        P.setItemLayout(N, { points: j, allClipped: Be });
        var Oe = P.getItemModel(N).getModel("itemStyle").getItemStyle(), We = VJ(C, "color");
        Oe.fill || (Oe.fill = We, qa(Oe.fill) && (Oe.fill = zfe(Oe.fill, 0.4))), Oe.stroke || (Oe.stroke = We), P.setItemVisual(N, "style", Oe);
      }), P.diff(sfe(D).data).add(function(N) {
        var j = P.getItemLayout(N);
        if (!j.allClipped) {
          var W = new C_({ shape: { points: j.points } });
          P.setItemGraphicEl(N, W), D.group.add(W);
        }
      }).update(function(N, j) {
        var W = sfe(D).data.getItemGraphicEl(j), K = P.getItemLayout(N);
        K.allClipped ? W && D.group.remove(W) : (W ? hc(W, { shape: { points: K.points } }, u, N) : W = new C_({ shape: { points: K.points } }), P.setItemGraphicEl(N, W), D.group.add(W));
      }).remove(function(N) {
        var j = sfe(D).data.getItemGraphicEl(N);
        D.group.remove(j);
      }).execute(), P.eachItemGraphicEl(function(N, j) {
        var W = P.getItemModel(j), K = P.getItemVisual(j, "style");
        N.useStyle(P.getItemVisual(j, "style")), _1(N, ny(W), { labelFetcher: u, labelDataIndex: j, defaultText: P.getName(j) || "", inheritColor: qa(K.fill) ? zfe(K.fill, 1) : "#000" }), sm(N, W), Gd(N, null, null, W.get(["emphasis", "disabled"])), Ps(N).dataModel = u;
      }), sfe(D).data = P, D.group.silent = u.get("silent") || e3.get("silent");
    }, r3.type = "markArea", r3;
  }(SPe);
  function cAn(l3, r3, e3) {
    var u, h, v4 = ["x0", "y0", "x1", "y1"];
    if (l3) {
      var m3 = Bi(l3 && l3.dimensions, function(A2) {
        var D = r3.getData(), P = D.getDimensionInfo(D.mapDimension(A2)) || {};
        return fi(fi({}, P), { name: A2, ordinalMeta: null });
      });
      h = Bi(v4, function(A2, D) {
        return { name: A2, type: m3[D % 2].type };
      }), u = new yb(h, e3);
    } else
      h = [{ name: "value", type: "float" }], u = new yb(h, e3);
    var x3 = Bi(e3.get("data"), Fs(sAn, r3, l3, e3));
    l3 && (x3 = jf(x3, Fs(lAn, l3)));
    var C = l3 ? function(A2, D, P, N) {
      var j = A2.coord[Math.floor(N / 2)][N % 2];
      return XO(j, h[N]);
    } : function(A2, D, P, N) {
      return XO(A2.value, h[N]);
    };
    return u.initData(x3, null, C), u.hasItemOption = true, u;
  }
  var fAn = uAn;
  function hAn(l3) {
    l3.registerComponentModel(oAn), l3.registerComponentView(fAn), l3.registerPreprocessor(function(r3) {
      xPe(r3.series, "markArea") && (r3.markArea = r3.markArea || {});
    });
  }
  var pAn = function(l3, r3) {
    if (r3 === "all")
      return { type: "all", title: l3.getLocaleModel().get(["legend", "selector", "all"]) };
    if (r3 === "inverse")
      return { type: "inverse", title: l3.getLocaleModel().get(["legend", "selector", "inverse"]) };
  }, dAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.layoutMode = { type: "box", ignoreSize: true }, e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      this.mergeDefaultAndTheme(e3, h), e3.selected = e3.selected || {}, this._updateSelector(e3);
    }, r3.prototype.mergeOption = function(e3, u) {
      l3.prototype.mergeOption.call(this, e3, u), this._updateSelector(e3);
    }, r3.prototype._updateSelector = function(e3) {
      var u = e3.selector, h = this.ecModel;
      u === true && (u = e3.selector = ["all", "inverse"]), Ni(u) && mt(u, function(v4, m3) {
        qa(v4) && (v4 = { type: v4 }), u[m3] = ol(v4, pAn(h, v4.type));
      });
    }, r3.prototype.optionUpdated = function() {
      this._updateData(this.ecModel);
      var e3 = this._data;
      if (e3[0] && this.get("selectedMode") === "single") {
        for (var u = false, h = 0; h < e3.length; h++) {
          var v4 = e3[h].get("name");
          if (this.isSelected(v4)) {
            this.select(v4), u = true;
            break;
          }
        }
        !u && this.select(e3[0].get("name"));
      }
    }, r3.prototype._updateData = function(e3) {
      var u = [], h = [];
      e3.eachRawSeries(function(x3) {
        var C = x3.name;
        h.push(C);
        var A2;
        if (x3.legendVisualProvider) {
          var D = x3.legendVisualProvider, P = D.getAllNames();
          e3.isSeriesFiltered(x3) || (h = h.concat(P)), P.length ? u = u.concat(P) : A2 = true;
        } else
          A2 = true;
        A2 && N3e(x3) && u.push(x3.name);
      }), this._availableNames = h;
      var v4 = this.get("data") || u, m3 = Bi(v4, function(x3) {
        return (qa(x3) || Vc(x3)) && (x3 = { name: x3 }), new Bh(x3, this, this.ecModel);
      }, this);
      this._data = m3;
    }, r3.prototype.getData = function() {
      return this._data;
    }, r3.prototype.select = function(e3) {
      var u = this.option.selected, h = this.get("selectedMode");
      if (h === "single") {
        var v4 = this._data;
        mt(v4, function(m3) {
          u[m3.get("name")] = false;
        });
      }
      u[e3] = true;
    }, r3.prototype.unSelect = function(e3) {
      this.get("selectedMode") !== "single" && (this.option.selected[e3] = false);
    }, r3.prototype.toggleSelected = function(e3) {
      var u = this.option.selected;
      u.hasOwnProperty(e3) || (u[e3] = true), this[u[e3] ? "unSelect" : "select"](e3);
    }, r3.prototype.allSelect = function() {
      var e3 = this._data, u = this.option.selected;
      mt(e3, function(h) {
        u[h.get("name", true)] = true;
      });
    }, r3.prototype.inverseSelect = function() {
      var e3 = this._data, u = this.option.selected;
      mt(e3, function(h) {
        var v4 = h.get("name", true);
        u.hasOwnProperty(v4) || (u[v4] = true), u[v4] = !u[v4];
      });
    }, r3.prototype.isSelected = function(e3) {
      var u = this.option.selected;
      return !(u.hasOwnProperty(e3) && !u[e3]) && Cl(this._availableNames, e3) >= 0;
    }, r3.prototype.getOrient = function() {
      return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
    }, r3.type = "legend.plain", r3.dependencies = ["series"], r3.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, r3;
  }(fc), Kke = dAn, Vz = Fs, Zke = mt, lfe = Cs, vAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.newlineDisabled = false, e3;
    }
    return r3.prototype.init = function() {
      this.group.add(this._contentGroup = new lfe()), this.group.add(this._selectorGroup = new lfe()), this._isFirstRender = true;
    }, r3.prototype.getContentGroup = function() {
      return this._contentGroup;
    }, r3.prototype.getSelectorGroup = function() {
      return this._selectorGroup;
    }, r3.prototype.render = function(e3, u, h) {
      var v4 = this._isFirstRender;
      if (this._isFirstRender = false, this.resetInner(), !!e3.get("show", true)) {
        var m3 = e3.get("align"), x3 = e3.get("orient");
        (!m3 || m3 === "auto") && (m3 = e3.get("left") === "right" && x3 === "vertical" ? "right" : "left");
        var C = e3.get("selector", true), A2 = e3.get("selectorPosition", true);
        C && (!A2 || A2 === "auto") && (A2 = x3 === "horizontal" ? "end" : "start"), this.renderInner(m3, e3, u, h, C, x3, A2);
        var D = e3.getBoxLayoutParams(), P = { width: h.getWidth(), height: h.getHeight() }, N = e3.get("padding"), j = dg(D, P, N), W = this.layoutInner(e3, m3, j, v4, C, A2), K = dg(ns({ width: W.width, height: W.height }, D), P, N);
        this.group.x = K.x - W.x, this.group.y = K.y - W.y, this.group.markRedraw(), this.group.add(this._backgroundEl = ivt(W, e3));
      }
    }, r3.prototype.resetInner = function() {
      this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
    }, r3.prototype.renderInner = function(e3, u, h, v4, m3, x3, C) {
      var A2 = this.getContentGroup(), D = Ho(), P = u.get("selectedMode"), N = [];
      h.eachRawSeries(function(j) {
        !j.get("legendHoverLink") && N.push(j.id);
      }), Zke(u.getData(), function(j, W) {
        var K = j.get("name");
        if (!this.newlineDisabled && (K === "" || K === `
`)) {
          var te = new lfe();
          te.newline = true, A2.add(te);
          return;
        }
        var ne = h.getSeriesByName(K)[0];
        if (!D.get(K))
          if (ne) {
            var ce = ne.getData(), me = ce.getVisual("legendLineStyle") || {}, ve = ce.getVisual("legendIcon"), Be = ce.getVisual("style"), Oe = this._createItem(ne, K, W, j, u, e3, me, Be, ve, P);
            Oe.on("click", Vz(gst, K, null, v4, N)).on("mouseover", Vz(Jke, ne.name, null, v4, N)).on("mouseout", Vz(Qke, ne.name, null, v4, N)), D.set(K, true);
          } else
            h.eachRawSeries(function(We) {
              if (!D.get(K) && We.legendVisualProvider) {
                var Ue = We.legendVisualProvider;
                if (!Ue.containName(K))
                  return;
                var qe = Ue.indexOfName(K), Ze = Ue.getItemVisual(qe, "style"), ct = Ue.getItemVisual(qe, "legendIcon"), _t = Jx(Ze.fill);
                _t && _t[3] === 0 && (_t[3] = 0.2, Ze = fi(fi({}, Ze), { fill: r5(_t, "rgba") }));
                var pt = this._createItem(We, K, W, j, u, e3, {}, Ze, ct, P);
                pt.on("click", Vz(gst, null, K, v4, N)).on("mouseover", Vz(Jke, null, K, v4, N)).on("mouseout", Vz(Qke, null, K, v4, N)), D.set(K, true);
              }
            }, this);
      }, this), m3 && this._createSelector(m3, u, v4, x3, C);
    }, r3.prototype._createSelector = function(e3, u, h, v4, m3) {
      var x3 = this.getSelectorGroup();
      Zke(e3, function(A2) {
        var D = A2.type, P = new Ec({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
          h.dispatchAction({ type: D === "all" ? "legendAllSelect" : "legendInverseSelect" });
        } });
        x3.add(P);
        var N = u.getModel("selectorLabel"), j = u.getModel(["emphasis", "selectorLabel"]);
        _1(P, { normal: N, emphasis: j }, { defaultText: A2.title }), FN(P);
      });
    }, r3.prototype._createItem = function(e3, u, h, v4, m3, x3, C, A2, D, P) {
      var N = e3.visualDrawType, j = m3.get("itemWidth"), W = m3.get("itemHeight"), K = m3.isSelected(u), te = v4.get("symbolRotate"), ne = v4.get("symbolKeepAspect"), ce = v4.get("icon");
      D = ce || D || "roundRect";
      var me = gAn(D, v4, C, A2, N, K), ve = new lfe(), Be = v4.getModel("textStyle");
      if (Xo(e3.getLegendIcon) && (!ce || ce === "inherit"))
        ve.add(e3.getLegendIcon({ itemWidth: j, itemHeight: W, icon: D, iconRotate: te, itemStyle: me.itemStyle, lineStyle: me.lineStyle, symbolKeepAspect: ne }));
      else {
        var Oe = ce === "inherit" && e3.getData().getVisual("symbol") ? te === "inherit" ? e3.getData().getVisual("symbolRotate") : te : 0;
        ve.add(yAn({ itemWidth: j, itemHeight: W, icon: D, iconRotate: Oe, itemStyle: me.itemStyle, lineStyle: me.lineStyle, symbolKeepAspect: ne }));
      }
      var We = x3 === "left" ? j + 5 : -5, Ue = x3, qe = m3.get("formatter"), Ze = u;
      qa(qe) && qe ? Ze = qe.replace("{name}", u != null ? u : "") : Xo(qe) && (Ze = qe(u));
      var ct = v4.get("inactiveColor");
      ve.add(new Ec({ style: ov(Be, { text: Ze, x: We, y: W / 2, fill: K ? Be.getTextColor() : ct, align: Ue, verticalAlign: "middle" }) }));
      var _t = new Ju({ shape: ve.getBoundingRect(), invisible: true }), pt = v4.getModel("tooltip");
      return pt.get("show") && Cj({ el: _t, componentModel: m3, itemName: u, itemTooltipOption: pt.option }), ve.add(_t), ve.eachChild(function(zt) {
        zt.silent = true;
      }), _t.silent = !P, this.getContentGroup().add(ve), FN(ve), ve.__legendDataIndex = h, ve;
    }, r3.prototype.layoutInner = function(e3, u, h, v4, m3, x3) {
      var C = this.getContentGroup(), A2 = this.getSelectorGroup();
      BN(e3.get("orient"), C, e3.get("itemGap"), h.width, h.height);
      var D = C.getBoundingRect(), P = [-D.x, -D.y];
      if (A2.markRedraw(), C.markRedraw(), m3) {
        BN("horizontal", A2, e3.get("selectorItemGap", true));
        var N = A2.getBoundingRect(), j = [-N.x, -N.y], W = e3.get("selectorButtonGap", true), K = e3.getOrient().index, te = K === 0 ? "width" : "height", ne = K === 0 ? "height" : "width", ce = K === 0 ? "y" : "x";
        x3 === "end" ? j[K] += D[te] + W : P[K] += N[te] + W, j[1 - K] += D[ne] / 2 - N[ne] / 2, A2.x = j[0], A2.y = j[1], C.x = P[0], C.y = P[1];
        var me = { x: 0, y: 0 };
        return me[te] = D[te] + W + N[te], me[ne] = Math.max(D[ne], N[ne]), me[ce] = Math.min(0, N[ce] + j[1 - K]), me;
      } else
        return C.x = P[0], C.y = P[1], this.group.getBoundingRect();
    }, r3.prototype.remove = function() {
      this.getContentGroup().removeAll(), this._isFirstRender = true;
    }, r3.type = "legend.plain", r3;
  }(yd);
  function gAn(l3, r3, e3, u, h, v4) {
    function m3(W, K) {
      W.lineWidth === "auto" && (W.lineWidth = K.lineWidth > 0 ? 2 : 0), Zke(W, function(te, ne) {
        W[ne] === "inherit" && (W[ne] = K[ne]);
      });
    }
    var x3 = r3.getModel("itemStyle"), C = x3.getItemStyle(), A2 = l3.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
    C.decal = u.decal, C.fill === "inherit" && (C.fill = u[h]), C.stroke === "inherit" && (C.stroke = u[A2]), C.opacity === "inherit" && (C.opacity = (h === "fill" ? u : e3).opacity), m3(C, u);
    var D = r3.getModel("lineStyle"), P = D.getLineStyle();
    if (m3(P, e3), C.fill === "auto" && (C.fill = u.fill), C.stroke === "auto" && (C.stroke = u.fill), P.stroke === "auto" && (P.stroke = u.fill), !v4) {
      var N = r3.get("inactiveBorderWidth"), j = C[A2];
      C.lineWidth = N === "auto" ? u.lineWidth > 0 && j ? 2 : 0 : C.lineWidth, C.fill = r3.get("inactiveColor"), C.stroke = r3.get("inactiveBorderColor"), P.stroke = D.get("inactiveColor"), P.lineWidth = D.get("inactiveWidth");
    }
    return { itemStyle: C, lineStyle: P };
  }
  function yAn(l3) {
    var r3 = l3.icon || "roundRect", e3 = Nv(r3, 0, 0, l3.itemWidth, l3.itemHeight, l3.itemStyle.fill, l3.symbolKeepAspect);
    return e3.setStyle(l3.itemStyle), e3.rotation = (l3.iconRotate || 0) * Math.PI / 180, e3.setOrigin([l3.itemWidth / 2, l3.itemHeight / 2]), r3.indexOf("empty") > -1 && (e3.style.stroke = e3.style.fill, e3.style.fill = "#fff", e3.style.lineWidth = 2), e3;
  }
  function gst(l3, r3, e3, u) {
    Qke(l3, r3, e3, u), e3.dispatchAction({ type: "legendToggleSelect", name: l3 != null ? l3 : r3 }), Jke(l3, r3, e3, u);
  }
  function yvt(l3) {
    for (var r3 = l3.getZr().storage.getDisplayList(), e3, u = 0, h = r3.length; u < h && !(e3 = r3[u].states.emphasis); )
      u++;
    return e3 && e3.hoverLayer;
  }
  function Jke(l3, r3, e3, u) {
    yvt(e3) || e3.dispatchAction({ type: "highlight", seriesName: l3, name: r3, excludeSeriesId: u });
  }
  function Qke(l3, r3, e3, u) {
    yvt(e3) || e3.dispatchAction({ type: "downplay", seriesName: l3, name: r3, excludeSeriesId: u });
  }
  var mvt = vAn;
  function mAn(l3) {
    var r3 = l3.findComponents({ mainType: "legend" });
    r3 && r3.length && l3.filterSeries(function(e3) {
      for (var u = 0; u < r3.length; u++)
        if (!r3[u].isSelected(e3.name))
          return false;
      return true;
    });
  }
  function pZ(l3, r3, e3) {
    var u = {}, h = l3 === "toggleSelected", v4;
    return e3.eachComponent("legend", function(m3) {
      h && v4 != null ? m3[v4 ? "select" : "unSelect"](r3.name) : l3 === "allSelect" || l3 === "inverseSelect" ? m3[l3]() : (m3[l3](r3.name), v4 = m3.isSelected(r3.name));
      var x3 = m3.getData();
      mt(x3, function(C) {
        var A2 = C.get("name");
        if (!(A2 === `
` || A2 === "")) {
          var D = m3.isSelected(A2);
          u.hasOwnProperty(A2) ? u[A2] = u[A2] && D : u[A2] = D;
        }
      });
    }), l3 === "allSelect" || l3 === "inverseSelect" ? { selected: u } : { name: r3.name, selected: u };
  }
  function bAn(l3) {
    l3.registerAction("legendToggleSelect", "legendselectchanged", Fs(pZ, "toggleSelected")), l3.registerAction("legendAllSelect", "legendselectall", Fs(pZ, "allSelect")), l3.registerAction("legendInverseSelect", "legendinverseselect", Fs(pZ, "inverseSelect")), l3.registerAction("legendSelect", "legendselected", Fs(pZ, "select")), l3.registerAction("legendUnSelect", "legendunselected", Fs(pZ, "unSelect"));
  }
  function bvt(l3) {
    l3.registerComponentModel(Kke), l3.registerComponentView(mvt), l3.registerProcessor(l3.PRIORITY.PROCESSOR.SERIES_FILTER, mAn), l3.registerSubTypeDefaulter("legend", function() {
      return "plain";
    }), bAn(l3);
  }
  var _An = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.setScrollDataIndex = function(e3) {
      this.option.scrollDataIndex = e3;
    }, r3.prototype.init = function(e3, u, h) {
      var v4 = Ij(e3);
      l3.prototype.init.call(this, e3, u, h), yst(this, e3, v4);
    }, r3.prototype.mergeOption = function(e3, u) {
      l3.prototype.mergeOption.call(this, e3, u), yst(this, this.option, e3);
    }, r3.type = "legend.scroll", r3.defaultOption = sP(Kke.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), r3;
  }(Kke);
  function yst(l3, r3, e3) {
    var u = l3.getOrient(), h = [1, 1];
    h[u.index] = 0, QO(r3, e3, { type: "box", ignoreSize: !!h });
  }
  var xAn = _An, mst = Cs, ZDe = ["width", "height"], JDe = ["x", "y"], wAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.newlineDisabled = true, e3._currentIndex = 0, e3;
    }
    return r3.prototype.init = function() {
      l3.prototype.init.call(this), this.group.add(this._containerGroup = new mst()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new mst());
    }, r3.prototype.resetInner = function() {
      l3.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
    }, r3.prototype.renderInner = function(e3, u, h, v4, m3, x3, C) {
      var A2 = this;
      l3.prototype.renderInner.call(this, e3, u, h, v4, m3, x3, C);
      var D = this._controllerGroup, P = u.get("pageIconSize", true), N = Ni(P) ? P : [P, P];
      W("pagePrev", 0);
      var j = u.getModel("pageTextStyle");
      D.add(new Ec({ name: "pageText", style: { text: "xx/xx", fill: j.getTextColor(), font: j.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), W("pageNext", 1);
      function W(K, te) {
        var ne = K + "DataIndex", ce = RJ(u.get("pageIcons", true)[u.getOrient().name][te], { onclick: no(A2._pageGo, A2, ne, u, v4) }, { x: -N[0] / 2, y: -N[1] / 2, width: N[0], height: N[1] });
        ce.name = K, D.add(ce);
      }
    }, r3.prototype.layoutInner = function(e3, u, h, v4, m3, x3) {
      var C = this.getSelectorGroup(), A2 = e3.getOrient().index, D = ZDe[A2], P = JDe[A2], N = ZDe[1 - A2], j = JDe[1 - A2];
      m3 && BN("horizontal", C, e3.get("selectorItemGap", true));
      var W = e3.get("selectorButtonGap", true), K = C.getBoundingRect(), te = [-K.x, -K.y], ne = bs(h);
      m3 && (ne[D] = h[D] - K[D] - W);
      var ce = this._layoutContentAndController(e3, v4, ne, A2, D, N, j, P);
      if (m3) {
        if (x3 === "end")
          te[A2] += ce[D] + W;
        else {
          var me = K[D] + W;
          te[A2] -= me, ce[P] -= me;
        }
        ce[D] += K[D] + W, te[1 - A2] += ce[j] + ce[N] / 2 - K[N] / 2, ce[N] = Math.max(ce[N], K[N]), ce[j] = Math.min(ce[j], K[j] + te[1 - A2]), C.x = te[0], C.y = te[1], C.markRedraw();
      }
      return ce;
    }, r3.prototype._layoutContentAndController = function(e3, u, h, v4, m3, x3, C, A2) {
      var D = this.getContentGroup(), P = this._containerGroup, N = this._controllerGroup;
      BN(e3.get("orient"), D, e3.get("itemGap"), v4 ? h.width : null, v4 ? null : h.height), BN("horizontal", N, e3.get("pageButtonItemGap", true));
      var j = D.getBoundingRect(), W = N.getBoundingRect(), K = this._showController = j[m3] > h[m3], te = [-j.x, -j.y];
      u || (te[v4] = D[A2]);
      var ne = [0, 0], ce = [-W.x, -W.y], me = dl(e3.get("pageButtonGap", true), e3.get("itemGap", true));
      if (K) {
        var ve = e3.get("pageButtonPosition", true);
        ve === "end" ? ce[v4] += h[m3] - W[m3] : ne[v4] += W[m3] + me;
      }
      ce[1 - v4] += j[x3] / 2 - W[x3] / 2, D.setPosition(te), P.setPosition(ne), N.setPosition(ce);
      var Be = { x: 0, y: 0 };
      if (Be[m3] = K ? h[m3] : j[m3], Be[x3] = Math.max(j[x3], W[x3]), Be[C] = Math.min(0, W[C] + ce[1 - v4]), P.__rectSize = h[m3], K) {
        var Oe = { x: 0, y: 0 };
        Oe[m3] = Math.max(h[m3] - W[m3] - me, 0), Oe[x3] = Be[x3], P.setClipPath(new Ju({ shape: Oe })), P.__rectSize = Oe[m3];
      } else
        N.eachChild(function(Ue) {
          Ue.attr({ invisible: true, silent: true });
        });
      var We = this._getPageInfo(e3);
      return We.pageIndex != null && hc(D, { x: We.contentPosition[0], y: We.contentPosition[1] }, K ? e3 : null), this._updatePageInfoView(e3, We), Be;
    }, r3.prototype._pageGo = function(e3, u, h) {
      var v4 = this._getPageInfo(u)[e3];
      v4 != null && h.dispatchAction({ type: "legendScroll", scrollDataIndex: v4, legendId: u.id });
    }, r3.prototype._updatePageInfoView = function(e3, u) {
      var h = this._controllerGroup;
      mt(["pagePrev", "pageNext"], function(D) {
        var P = D + "DataIndex", N = u[P] != null, j = h.childOfName(D);
        j && (j.setStyle("fill", N ? e3.get("pageIconColor", true) : e3.get("pageIconInactiveColor", true)), j.cursor = N ? "pointer" : "default");
      });
      var v4 = h.childOfName("pageText"), m3 = e3.get("pageFormatter"), x3 = u.pageIndex, C = x3 != null ? x3 + 1 : 0, A2 = u.pageCount;
      v4 && m3 && v4.setStyle("text", qa(m3) ? m3.replace("{current}", C == null ? "" : C + "").replace("{total}", A2 == null ? "" : A2 + "") : m3({ current: C, total: A2 }));
    }, r3.prototype._getPageInfo = function(e3) {
      var u = e3.get("scrollDataIndex", true), h = this.getContentGroup(), v4 = this._containerGroup.__rectSize, m3 = e3.getOrient().index, x3 = ZDe[m3], C = JDe[m3], A2 = this._findTargetItemIndex(u), D = h.children(), P = D[A2], N = D.length, j = N ? 1 : 0, W = { contentPosition: [h.x, h.y], pageCount: j, pageIndex: j - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
      if (!P)
        return W;
      var K = ve(P);
      W.contentPosition[m3] = -K.s;
      for (var te = A2 + 1, ne = K, ce = K, me = null; te <= N; ++te)
        me = ve(D[te]), (!me && ce.e > ne.s + v4 || me && !Be(me, ne.s)) && (ce.i > ne.i ? ne = ce : ne = me, ne && (W.pageNextDataIndex == null && (W.pageNextDataIndex = ne.i), ++W.pageCount)), ce = me;
      for (var te = A2 - 1, ne = K, ce = K, me = null; te >= -1; --te)
        me = ve(D[te]), (!me || !Be(ce, me.s)) && ne.i < ce.i && (ce = ne, W.pagePrevDataIndex == null && (W.pagePrevDataIndex = ne.i), ++W.pageCount, ++W.pageIndex), ne = me;
      return W;
      function ve(Oe) {
        if (Oe) {
          var We = Oe.getBoundingRect(), Ue = We[C] + Oe[C];
          return { s: Ue, e: Ue + We[x3], i: Oe.__legendDataIndex };
        }
      }
      function Be(Oe, We) {
        return Oe.e >= We && Oe.s <= We + v4;
      }
    }, r3.prototype._findTargetItemIndex = function(e3) {
      if (!this._showController)
        return 0;
      var u, h = this.getContentGroup(), v4;
      return h.eachChild(function(m3, x3) {
        var C = m3.__legendDataIndex;
        v4 == null && C != null && (v4 = x3), C === e3 && (u = x3);
      }), u != null ? u : v4;
    }, r3.type = "legend.scroll", r3;
  }(mvt), SAn = wAn;
  function CAn(l3) {
    l3.registerAction("legendScroll", "legendscroll", function(r3, e3) {
      var u = r3.scrollDataIndex;
      u != null && e3.eachComponent({ mainType: "legend", subType: "scroll", query: r3 }, function(h) {
        h.setScrollDataIndex(u);
      });
    });
  }
  function MAn(l3) {
    kl(bvt), l3.registerComponentModel(xAn), l3.registerComponentView(SAn), CAn(l3);
  }
  function TAn(l3) {
    kl(bvt), kl(MAn);
  }
  var AAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "dataZoom.inside", r3.defaultOption = sP(SJ.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), r3;
  }(SJ), IAn = AAn, CPe = pc();
  function EAn(l3, r3, e3) {
    CPe(l3).coordSysRecordMap.each(function(u) {
      var h = u.dataZoomInfoMap.get(r3.uid);
      h && (h.getRange = e3);
    });
  }
  function DAn(l3, r3) {
    for (var e3 = CPe(l3).coordSysRecordMap, u = e3.keys(), h = 0; h < u.length; h++) {
      var v4 = u[h], m3 = e3.get(v4), x3 = m3.dataZoomInfoMap;
      if (x3) {
        var C = r3.uid, A2 = x3.get(C);
        A2 && (x3.removeKey(C), x3.keys().length || _vt(e3, m3));
      }
    }
  }
  function _vt(l3, r3) {
    if (r3) {
      l3.removeKey(r3.model.uid);
      var e3 = r3.controller;
      e3 && e3.dispose();
    }
  }
  function kAn(l3, r3) {
    var e3 = { model: r3, containsPoint: Fs(PAn, r3), dispatchAction: Fs(OAn, l3), dataZoomInfoMap: null, controller: null }, u = e3.controller = new XJ(l3.getZr());
    return mt(["pan", "zoom", "scrollMove"], function(h) {
      u.on(h, function(v4) {
        var m3 = [];
        e3.dataZoomInfoMap.each(function(x3) {
          if (!!v4.isAvailableBehavior(x3.model.option)) {
            var C = (x3.getRange || {})[h], A2 = C && C(x3.dzReferCoordSysInfo, e3.model.mainType, e3.controller, v4);
            !x3.model.get("disabled", true) && A2 && m3.push({ dataZoomId: x3.model.id, start: A2[0], end: A2[1] });
          }
        }), m3.length && e3.dispatchAction(m3);
      });
    }), e3;
  }
  function OAn(l3, r3) {
    l3.isDisposed() || l3.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: r3 });
  }
  function PAn(l3, r3, e3, u) {
    return l3.coordinateSystem.containPoint([e3, u]);
  }
  function LAn(l3) {
    var r3, e3 = "type_", u = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, h = true;
    return l3.each(function(v4) {
      var m3 = v4.model, x3 = m3.get("disabled", true) ? false : m3.get("zoomLock", true) ? "move" : true;
      u[e3 + x3] > u[e3 + r3] && (r3 = x3), h = h && m3.get("preventDefaultMouseMove", true);
    }), { controlType: r3, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!h } };
  }
  function RAn(l3) {
    l3.registerProcessor(l3.PRIORITY.PROCESSOR.FILTER, function(r3, e3) {
      var u = CPe(e3), h = u.coordSysRecordMap || (u.coordSysRecordMap = Ho());
      h.each(function(v4) {
        v4.dataZoomInfoMap = null;
      }), r3.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(v4) {
        var m3 = tvt(v4);
        mt(m3.infoList, function(x3) {
          var C = x3.model.uid, A2 = h.get(C) || h.set(C, kAn(e3, x3.model)), D = A2.dataZoomInfoMap || (A2.dataZoomInfoMap = Ho());
          D.set(v4.uid, { dzReferCoordSysInfo: x3, model: v4, getRange: null });
        });
      }), h.each(function(v4) {
        var m3 = v4.controller, x3, C = v4.dataZoomInfoMap;
        if (C) {
          var A2 = C.keys()[0];
          A2 != null && (x3 = C.get(A2));
        }
        if (!x3) {
          _vt(h, v4);
          return;
        }
        var D = LAn(C);
        m3.enable(D.controlType, D.opt), m3.setPointerChecker(v4.containsPoint), Oj(v4, "dispatchAction", x3.model.get("throttle", true), "fixRate");
      });
    });
  }
  var NAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "dataZoom.inside", e3;
    }
    return r3.prototype.render = function(e3, u, h) {
      if (l3.prototype.render.apply(this, arguments), e3.noTarget()) {
        this._clear();
        return;
      }
      this.range = e3.getPercentRange(), EAn(h, e3, { pan: no(QDe.pan, this), zoom: no(QDe.zoom, this), scrollMove: no(QDe.scrollMove, this) });
    }, r3.prototype.dispose = function() {
      this._clear(), l3.prototype.dispose.apply(this, arguments);
    }, r3.prototype._clear = function() {
      DAn(this.api, this.dataZoomModel), this.range = null;
    }, r3.type = "dataZoom.inside", r3;
  }(vPe), QDe = { zoom: function(l3, r3, e3, u) {
    var h = this.range, v4 = h.slice(), m3 = l3.axisModels[0];
    if (!!m3) {
      var x3 = e5e[r3](null, [u.originX, u.originY], m3, e3, l3), C = (x3.signal > 0 ? x3.pixelStart + x3.pixelLength - x3.pixel : x3.pixel - x3.pixelStart) / x3.pixelLength * (v4[1] - v4[0]) + v4[0], A2 = Math.max(1 / u.scale, 0);
      v4[0] = (v4[0] - C) * A2 + C, v4[1] = (v4[1] - C) * A2 + C;
      var D = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
      if (tF(0, v4, [0, 100], 0, D.minSpan, D.maxSpan), this.range = v4, h[0] !== v4[0] || h[1] !== v4[1])
        return v4;
    }
  }, pan: bst(function(l3, r3, e3, u, h, v4) {
    var m3 = e5e[u]([v4.oldX, v4.oldY], [v4.newX, v4.newY], r3, h, e3);
    return m3.signal * (l3[1] - l3[0]) * m3.pixel / m3.pixelLength;
  }), scrollMove: bst(function(l3, r3, e3, u, h, v4) {
    var m3 = e5e[u]([0, 0], [v4.scrollDelta, v4.scrollDelta], r3, h, e3);
    return m3.signal * (l3[1] - l3[0]) * v4.scrollDelta;
  }) };
  function bst(l3) {
    return function(r3, e3, u, h) {
      var v4 = this.range, m3 = v4.slice(), x3 = r3.axisModels[0];
      if (!!x3) {
        var C = l3(m3, x3, r3, e3, u, h);
        if (tF(C, m3, [0, 100], "all"), this.range = m3, v4[0] !== m3[0] || v4[1] !== m3[1])
          return m3;
      }
    };
  }
  var e5e = { grid: function(l3, r3, e3, u, h) {
    var v4 = e3.axis, m3 = {}, x3 = h.model.coordinateSystem.getRect();
    return l3 = l3 || [0, 0], v4.dim === "x" ? (m3.pixel = r3[0] - l3[0], m3.pixelLength = x3.width, m3.pixelStart = x3.x, m3.signal = v4.inverse ? 1 : -1) : (m3.pixel = r3[1] - l3[1], m3.pixelLength = x3.height, m3.pixelStart = x3.y, m3.signal = v4.inverse ? -1 : 1), m3;
  }, polar: function(l3, r3, e3, u, h) {
    var v4 = e3.axis, m3 = {}, x3 = h.model.coordinateSystem, C = x3.getRadiusAxis().getExtent(), A2 = x3.getAngleAxis().getExtent();
    return l3 = l3 ? x3.pointToCoord(l3) : [0, 0], r3 = x3.pointToCoord(r3), e3.mainType === "radiusAxis" ? (m3.pixel = r3[0] - l3[0], m3.pixelLength = C[1] - C[0], m3.pixelStart = C[0], m3.signal = v4.inverse ? 1 : -1) : (m3.pixel = r3[1] - l3[1], m3.pixelLength = A2[1] - A2[0], m3.pixelStart = A2[0], m3.signal = v4.inverse ? -1 : 1), m3;
  }, singleAxis: function(l3, r3, e3, u, h) {
    var v4 = e3.axis, m3 = h.model.coordinateSystem.getRect(), x3 = {};
    return l3 = l3 || [0, 0], v4.orient === "horizontal" ? (x3.pixel = r3[0] - l3[0], x3.pixelLength = m3.width, x3.pixelStart = m3.x, x3.signal = v4.inverse ? 1 : -1) : (x3.pixel = r3[1] - l3[1], x3.pixelLength = m3.height, x3.pixelStart = m3.y, x3.signal = v4.inverse ? -1 : 1), x3;
  } }, FAn = NAn;
  function xvt(l3) {
    gPe(l3), l3.registerComponentModel(IAn), l3.registerComponentView(FAn), RAn(l3);
  }
  var VAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.type = "dataZoom.slider", r3.layoutMode = "box", r3.defaultOption = sP(SJ.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), r3;
  }(SJ), BAn = VAn, dZ = Ju, _st = 7, zAn = 1, t5e = 30, jAn = 7, vZ = "horizontal", xst = "vertical", GAn = 5, HAn = ["line", "bar", "candlestick", "scatter"], WAn = { easing: "cubicOut", duration: 100, delay: 0 }, UAn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._displayables = {}, e3;
    }
    return r3.prototype.init = function(e3, u) {
      this.api = u, this._onBrush = no(this._onBrush, this), this._onBrushEnd = no(this._onBrushEnd, this);
    }, r3.prototype.render = function(e3, u, h, v4) {
      if (l3.prototype.render.apply(this, arguments), Oj(this, "_dispatchZoomAction", e3.get("throttle"), "fixRate"), this._orient = e3.getOrient(), e3.get("show") === false) {
        this.group.removeAll();
        return;
      }
      if (e3.noTarget()) {
        this._clear(), this.group.removeAll();
        return;
      }
      (!v4 || v4.type !== "dataZoom" || v4.from !== this.uid) && this._buildView(), this._updateView();
    }, r3.prototype.dispose = function() {
      this._clear(), l3.prototype.dispose.apply(this, arguments);
    }, r3.prototype._clear = function() {
      cJ(this, "_dispatchZoomAction");
      var e3 = this.api.getZr();
      e3.off("mousemove", this._onBrush), e3.off("mouseup", this._onBrushEnd);
    }, r3.prototype._buildView = function() {
      var e3 = this.group;
      e3.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
      var u = this._displayables.sliderGroup = new Cs();
      this._renderBackground(), this._renderHandle(), this._renderDataShadow(), e3.add(u), this._positionGroup();
    }, r3.prototype._resetLocation = function() {
      var e3 = this.dataZoomModel, u = this.api, h = e3.get("brushSelect"), v4 = h ? jAn : 0, m3 = this._findCoordRect(), x3 = { width: u.getWidth(), height: u.getHeight() }, C = this._orient === vZ ? { right: x3.width - m3.x - m3.width, top: x3.height - t5e - _st - v4, width: m3.width, height: t5e } : { right: _st, top: m3.y, width: t5e, height: m3.height }, A2 = Ij(e3.option);
      mt(["right", "top", "width", "height"], function(P) {
        A2[P] === "ph" && (A2[P] = C[P]);
      });
      var D = dg(A2, x3);
      this._location = { x: D.x, y: D.y }, this._size = [D.width, D.height], this._orient === xst && this._size.reverse();
    }, r3.prototype._positionGroup = function() {
      var e3 = this.group, u = this._location, h = this._orient, v4 = this.dataZoomModel.getFirstTargetAxisModel(), m3 = v4 && v4.get("inverse"), x3 = this._displayables.sliderGroup, C = (this._dataShadowInfo || {}).otherAxisInverse;
      x3.attr(h === vZ && !m3 ? { scaleY: C ? 1 : -1, scaleX: 1 } : h === vZ && m3 ? { scaleY: C ? 1 : -1, scaleX: -1 } : h === xst && !m3 ? { scaleY: C ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: C ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
      var A2 = e3.getBoundingRect([x3]);
      e3.x = u.x - A2.x, e3.y = u.y - A2.y, e3.markRedraw();
    }, r3.prototype._getViewExtent = function() {
      return [0, this._size[0]];
    }, r3.prototype._renderBackground = function() {
      var e3 = this.dataZoomModel, u = this._size, h = this._displayables.sliderGroup, v4 = e3.get("brushSelect");
      h.add(new dZ({ silent: true, shape: { x: 0, y: 0, width: u[0], height: u[1] }, style: { fill: e3.get("backgroundColor") }, z2: -40 }));
      var m3 = new dZ({ shape: { x: 0, y: 0, width: u[0], height: u[1] }, style: { fill: "transparent" }, z2: 0, onclick: no(this._onClickPanel, this) }), x3 = this.api.getZr();
      v4 ? (m3.on("mousedown", this._onBrushStart, this), m3.cursor = "crosshair", x3.on("mousemove", this._onBrush), x3.on("mouseup", this._onBrushEnd)) : (x3.off("mousemove", this._onBrush), x3.off("mouseup", this._onBrushEnd)), h.add(m3);
    }, r3.prototype._renderDataShadow = function() {
      var e3 = this._dataShadowInfo = this._prepareDataShadowInfo();
      if (this._displayables.dataShadowSegs = [], !e3)
        return;
      var u = this._size, h = this._shadowSize || [], v4 = e3.series, m3 = v4.getRawData(), x3 = v4.getShadowDim ? v4.getShadowDim() : e3.otherDim;
      if (x3 == null)
        return;
      var C = this._shadowPolygonPts, A2 = this._shadowPolylinePts;
      if (m3 !== this._shadowData || x3 !== this._shadowDim || u[0] !== h[0] || u[1] !== h[1]) {
        var D = m3.getDataExtent(x3), P = (D[1] - D[0]) * 0.3;
        D = [D[0] - P, D[1] + P];
        var N = [0, u[1]], j = [0, u[0]], W = [[u[0], 0], [0, 0]], K = [], te = j[1] / (m3.count() - 1), ne = 0, ce = Math.round(m3.count() / u[0]), me;
        m3.each([x3], function(Ue, qe) {
          if (ce > 0 && qe % ce) {
            ne += te;
            return;
          }
          var Ze = Ue == null || isNaN(Ue) || Ue === "", ct = Ze ? 0 : _f(Ue, D, N, true);
          Ze && !me && qe ? (W.push([W[W.length - 1][0], 0]), K.push([K[K.length - 1][0], 0])) : !Ze && me && (W.push([ne, 0]), K.push([ne, 0])), W.push([ne, ct]), K.push([ne, ct]), ne += te, me = Ze;
        }), C = this._shadowPolygonPts = W, A2 = this._shadowPolylinePts = K;
      }
      this._shadowData = m3, this._shadowDim = x3, this._shadowSize = [u[0], u[1]];
      var ve = this.dataZoomModel;
      function Be(Ue) {
        var qe = ve.getModel(Ue ? "selectedDataBackground" : "dataBackground"), Ze = new Cs(), ct = new C_({ shape: { points: C }, segmentIgnoreThreshold: 1, style: qe.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), _t = new M_({ shape: { points: A2 }, segmentIgnoreThreshold: 1, style: qe.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
        return Ze.add(ct), Ze.add(_t), Ze;
      }
      for (var Oe = 0; Oe < 3; Oe++) {
        var We = Be(Oe === 1);
        this._displayables.sliderGroup.add(We), this._displayables.dataShadowSegs.push(We);
      }
    }, r3.prototype._prepareDataShadowInfo = function() {
      var e3 = this.dataZoomModel, u = e3.get("showDataShadow");
      if (u !== false) {
        var h, v4 = this.ecModel;
        return e3.eachTargetAxis(function(m3, x3) {
          var C = e3.getAxisProxy(m3, x3).getTargetSeriesModels();
          mt(C, function(A2) {
            if (!h && !(u !== true && Cl(HAn, A2.get("type")) < 0)) {
              var D = v4.getComponent(WO(m3), x3).axis, P = qAn(m3), N, j = A2.coordinateSystem;
              P != null && j.getOtherAxis && (N = j.getOtherAxis(D).inverse), P = A2.getData().mapDimension(P), h = { thisAxis: D, series: A2, thisDim: m3, otherDim: P, otherAxisInverse: N };
            }
          }, this);
        }, this), h;
      }
    }, r3.prototype._renderHandle = function() {
      var e3 = this.group, u = this._displayables, h = u.handles = [null, null], v4 = u.handleLabels = [null, null], m3 = this._displayables.sliderGroup, x3 = this._size, C = this.dataZoomModel, A2 = this.api, D = C.get("borderRadius") || 0, P = C.get("brushSelect"), N = u.filler = new dZ({ silent: P, style: { fill: C.get("fillerColor") }, textConfig: { position: "inside" } });
      m3.add(N), m3.add(new dZ({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: x3[0], height: x3[1], r: D }, style: { stroke: C.get("dataBackgroundColor") || C.get("borderColor"), lineWidth: zAn, fill: "rgba(0,0,0,0)" } })), mt([0, 1], function(me) {
        var ve = C.get("handleIcon");
        !nhe[ve] && ve.indexOf("path://") < 0 && ve.indexOf("image://") < 0 && (ve = "path://" + ve);
        var Be = Nv(ve, -1, 0, 2, 2, null, true);
        Be.attr({ cursor: wst(this._orient), draggable: true, drift: no(this._onDragMove, this, me), ondragend: no(this._onDragEnd, this), onmouseover: no(this._showDataInfo, this, true), onmouseout: no(this._showDataInfo, this, false), z2: 5 });
        var Oe = Be.getBoundingRect(), We = C.get("handleSize");
        this._handleHeight = za(We, this._size[1]), this._handleWidth = Oe.width / Oe.height * this._handleHeight, Be.setStyle(C.getModel("handleStyle").getItemStyle()), Be.style.strokeNoScale = true, Be.rectHover = true, Be.ensureState("emphasis").style = C.getModel(["emphasis", "handleStyle"]).getItemStyle(), FN(Be);
        var Ue = C.get("handleColor");
        Ue != null && (Be.style.fill = Ue), m3.add(h[me] = Be);
        var qe = C.getModel("textStyle");
        e3.add(v4[me] = new Ec({ silent: true, invisible: true, style: ov(qe, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: qe.getTextColor(), font: qe.getFont() }), z2: 10 }));
      }, this);
      var j = N;
      if (P) {
        var W = za(C.get("moveHandleSize"), x3[1]), K = u.moveHandle = new Ju({ style: C.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: x3[1] - 0.5, height: W } }), te = W * 0.8, ne = u.moveHandleIcon = Nv(C.get("moveHandleIcon"), -te / 2, -te / 2, te, te, "#fff", true);
        ne.silent = true, ne.y = x3[1] + W / 2 - 0.5, K.ensureState("emphasis").style = C.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
        var ce = Math.min(x3[1] / 2, Math.max(W, 10));
        j = u.moveZone = new Ju({ invisible: true, shape: { y: x3[1] - ce, height: W + ce } }), j.on("mouseover", function() {
          A2.enterEmphasis(K);
        }).on("mouseout", function() {
          A2.leaveEmphasis(K);
        }), m3.add(K), m3.add(ne), m3.add(j);
      }
      j.attr({ draggable: true, cursor: wst(this._orient), drift: no(this._onDragMove, this, "all"), ondragstart: no(this._showDataInfo, this, true), ondragend: no(this._onDragEnd, this), onmouseover: no(this._showDataInfo, this, true), onmouseout: no(this._showDataInfo, this, false) });
    }, r3.prototype._resetInterval = function() {
      var e3 = this._range = this.dataZoomModel.getPercentRange(), u = this._getViewExtent();
      this._handleEnds = [_f(e3[0], [0, 100], u, true), _f(e3[1], [0, 100], u, true)];
    }, r3.prototype._updateInterval = function(e3, u) {
      var h = this.dataZoomModel, v4 = this._handleEnds, m3 = this._getViewExtent(), x3 = h.findRepresentativeAxisProxy().getMinMaxSpan(), C = [0, 100];
      tF(u, v4, m3, h.get("zoomLock") ? "all" : e3, x3.minSpan != null ? _f(x3.minSpan, C, m3, true) : null, x3.maxSpan != null ? _f(x3.maxSpan, C, m3, true) : null);
      var A2 = this._range, D = this._range = g2([_f(v4[0], m3, C, true), _f(v4[1], m3, C, true)]);
      return !A2 || A2[0] !== D[0] || A2[1] !== D[1];
    }, r3.prototype._updateView = function(e3) {
      var u = this._displayables, h = this._handleEnds, v4 = g2(h.slice()), m3 = this._size;
      mt([0, 1], function(j) {
        var W = u.handles[j], K = this._handleHeight;
        W.attr({ scaleX: K / 2, scaleY: K / 2, x: h[j] + (j ? -1 : 1), y: m3[1] / 2 - K / 2 });
      }, this), u.filler.setShape({ x: v4[0], y: 0, width: v4[1] - v4[0], height: m3[1] });
      var x3 = { x: v4[0], width: v4[1] - v4[0] };
      u.moveHandle && (u.moveHandle.setShape(x3), u.moveZone.setShape(x3), u.moveZone.getBoundingRect(), u.moveHandleIcon && u.moveHandleIcon.attr("x", x3.x + x3.width / 2));
      for (var C = u.dataShadowSegs, A2 = [0, v4[0], v4[1], m3[0]], D = 0; D < C.length; D++) {
        var P = C[D], N = P.getClipPath();
        N || (N = new Ju(), P.setClipPath(N)), N.setShape({ x: A2[D], y: 0, width: A2[D + 1] - A2[D], height: m3[1] });
      }
      this._updateDataInfo(e3);
    }, r3.prototype._updateDataInfo = function(e3) {
      var u = this.dataZoomModel, h = this._displayables, v4 = h.handleLabels, m3 = this._orient, x3 = ["", ""];
      if (u.get("showDetail")) {
        var C = u.findRepresentativeAxisProxy();
        if (C) {
          var A2 = C.getAxisModel().axis, D = this._range, P = e3 ? C.calculateDataWindow({ start: D[0], end: D[1] }).valueWindow : C.getDataValueWindow();
          x3 = [this._formatLabel(P[0], A2), this._formatLabel(P[1], A2)];
        }
      }
      var N = g2(this._handleEnds.slice());
      j.call(this, 0), j.call(this, 1);
      function j(W) {
        var K = VN(h.handles[W].parent, this.group), te = Jhe(W === 0 ? "right" : "left", K), ne = this._handleWidth / 2 + GAn, ce = vM([N[W] + (W === 0 ? -ne : ne), this._size[1] / 2], K);
        v4[W].setStyle({ x: ce[0], y: ce[1], verticalAlign: m3 === vZ ? "middle" : te, align: m3 === vZ ? te : "center", text: x3[W] });
      }
    }, r3.prototype._formatLabel = function(e3, u) {
      var h = this.dataZoomModel, v4 = h.get("labelFormatter"), m3 = h.get("labelPrecision");
      (m3 == null || m3 === "auto") && (m3 = u.getPixelPrecision());
      var x3 = e3 == null || isNaN(e3) ? "" : u.type === "category" || u.type === "time" ? u.scale.getLabel({ value: Math.round(e3) }) : e3.toFixed(Math.min(m3, 20));
      return Xo(v4) ? v4(e3, x3) : qa(v4) ? v4.replace("{value}", x3) : x3;
    }, r3.prototype._showDataInfo = function(e3) {
      e3 = this._dragging || e3;
      var u = this._displayables, h = u.handleLabels;
      h[0].attr("invisible", !e3), h[1].attr("invisible", !e3), u.moveHandle && this.api[e3 ? "enterEmphasis" : "leaveEmphasis"](u.moveHandle, 1);
    }, r3.prototype._onDragMove = function(e3, u, h, v4) {
      this._dragging = true, u5(v4.event);
      var m3 = this._displayables.sliderGroup.getLocalTransform(), x3 = vM([u, h], m3, true), C = this._updateInterval(e3, x3[0]), A2 = this.dataZoomModel.get("realtime");
      this._updateView(!A2), C && A2 && this._dispatchZoomAction(true);
    }, r3.prototype._onDragEnd = function() {
      this._dragging = false, this._showDataInfo(false);
      var e3 = this.dataZoomModel.get("realtime");
      !e3 && this._dispatchZoomAction(false);
    }, r3.prototype._onClickPanel = function(e3) {
      var u = this._size, h = this._displayables.sliderGroup.transformCoordToLocal(e3.offsetX, e3.offsetY);
      if (!(h[0] < 0 || h[0] > u[0] || h[1] < 0 || h[1] > u[1])) {
        var v4 = this._handleEnds, m3 = (v4[0] + v4[1]) / 2, x3 = this._updateInterval("all", h[0] - m3);
        this._updateView(), x3 && this._dispatchZoomAction(false);
      }
    }, r3.prototype._onBrushStart = function(e3) {
      var u = e3.offsetX, h = e3.offsetY;
      this._brushStart = new nl(u, h), this._brushing = true, this._brushStartTime = +new Date();
    }, r3.prototype._onBrushEnd = function(e3) {
      if (!!this._brushing) {
        var u = this._displayables.brushRect;
        if (this._brushing = false, !!u) {
          u.attr("ignore", true);
          var h = u.shape, v4 = +new Date();
          if (!(v4 - this._brushStartTime < 200 && Math.abs(h.width) < 5)) {
            var m3 = this._getViewExtent(), x3 = [0, 100];
            this._range = g2([_f(h.x, m3, x3, true), _f(h.x + h.width, m3, x3, true)]), this._handleEnds = [h.x, h.x + h.width], this._updateView(), this._dispatchZoomAction(false);
          }
        }
      }
    }, r3.prototype._onBrush = function(e3) {
      this._brushing && (u5(e3.event), this._updateBrushRect(e3.offsetX, e3.offsetY));
    }, r3.prototype._updateBrushRect = function(e3, u) {
      var h = this._displayables, v4 = this.dataZoomModel, m3 = h.brushRect;
      m3 || (m3 = h.brushRect = new dZ({ silent: true, style: v4.getModel("brushStyle").getItemStyle() }), h.sliderGroup.add(m3)), m3.attr("ignore", false);
      var x3 = this._brushStart, C = this._displayables.sliderGroup, A2 = C.transformCoordToLocal(e3, u), D = C.transformCoordToLocal(x3.x, x3.y), P = this._size;
      A2[0] = Math.max(Math.min(P[0], A2[0]), 0), m3.setShape({ x: D[0], y: 0, width: A2[0] - D[0], height: P[1] });
    }, r3.prototype._dispatchZoomAction = function(e3) {
      var u = this._range;
      this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: e3 ? WAn : null, start: u[0], end: u[1] });
    }, r3.prototype._findCoordRect = function() {
      var e3, u = tvt(this.dataZoomModel).infoList;
      if (!e3 && u.length) {
        var h = u[0].model.coordinateSystem;
        e3 = h.getRect && h.getRect();
      }
      if (!e3) {
        var v4 = this.api.getWidth(), m3 = this.api.getHeight();
        e3 = { x: v4 * 0.2, y: m3 * 0.2, width: v4 * 0.6, height: m3 * 0.6 };
      }
      return e3;
    }, r3.type = "dataZoom.slider", r3;
  }(vPe);
  function qAn(l3) {
    var r3 = { x: "y", y: "x", radius: "angle", angle: "radius" };
    return r3[l3];
  }
  function wst(l3) {
    return l3 === "vertical" ? "ns-resize" : "ew-resize";
  }
  var $An = UAn;
  function wvt(l3) {
    l3.registerComponentModel(BAn), l3.registerComponentView($An), gPe(l3);
  }
  function XAn(l3) {
    kl(xvt), kl(wvt);
  }
  var YAn = { get: function(l3, r3, e3) {
    var u = bs((KAn[l3] || {})[r3]);
    return e3 && Ni(u) ? u[u.length - 1] : u;
  } }, KAn = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, Svt = YAn, Sst = om.mapVisual, ZAn = om.eachVisual, JAn = Ni, Cst = mt, QAn = g2, eIn = _f, tIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.stateList = ["inRange", "outOfRange"], e3.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], e3.layoutMode = { type: "box", ignoreSize: true }, e3.dataBound = [-1 / 0, 1 / 0], e3.targetVisuals = {}, e3.controllerVisuals = {}, e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      this.mergeDefaultAndTheme(e3, h);
    }, r3.prototype.optionUpdated = function(e3, u) {
      var h = this.option;
      !u && fvt(h, e3, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
    }, r3.prototype.resetVisual = function(e3) {
      var u = this.stateList;
      e3 = no(e3, this), this.controllerVisuals = Xke(this.option.controller, u, e3), this.targetVisuals = Xke(this.option.target, u, e3);
    }, r3.prototype.getItemSymbol = function() {
      return null;
    }, r3.prototype.getTargetSeriesIndices = function() {
      var e3 = this.option.seriesIndex, u = [];
      return e3 == null || e3 === "all" ? this.ecModel.eachSeries(function(h, v4) {
        u.push(v4);
      }) : u = Gf(e3), u;
    }, r3.prototype.eachTargetSeries = function(e3, u) {
      mt(this.getTargetSeriesIndices(), function(h) {
        var v4 = this.ecModel.getSeriesByIndex(h);
        v4 && e3.call(u, v4);
      }, this);
    }, r3.prototype.isTargetSeries = function(e3) {
      var u = false;
      return this.eachTargetSeries(function(h) {
        h === e3 && (u = true);
      }), u;
    }, r3.prototype.formatValueText = function(e3, u, h) {
      var v4 = this.option, m3 = v4.precision, x3 = this.dataBound, C = v4.formatter, A2;
      h = h || ["<", ">"], Ni(e3) && (e3 = e3.slice(), A2 = true);
      var D = u ? e3 : A2 ? [P(e3[0]), P(e3[1])] : P(e3);
      if (qa(C))
        return C.replace("{value}", A2 ? D[0] : D).replace("{value2}", A2 ? D[1] : D);
      if (Xo(C))
        return A2 ? C(e3[0], e3[1]) : C(e3);
      if (A2)
        return e3[0] === x3[0] ? h[0] + " " + D[1] : e3[1] === x3[1] ? h[1] + " " + D[0] : D[0] + " - " + D[1];
      return D;
      function P(N) {
        return N === x3[0] ? "min" : N === x3[1] ? "max" : (+N).toFixed(Math.min(m3, 20));
      }
    }, r3.prototype.resetExtent = function() {
      var e3 = this.option, u = QAn([e3.min, e3.max]);
      this._dataExtent = u;
    }, r3.prototype.getDataDimensionIndex = function(e3) {
      var u = this.option.dimension;
      if (u != null)
        return e3.getDimensionIndex(u);
      for (var h = e3.dimensions, v4 = h.length - 1; v4 >= 0; v4--) {
        var m3 = h[v4], x3 = e3.getDimensionInfo(m3);
        if (!x3.isCalculationCoord)
          return x3.storeDimIndex;
      }
    }, r3.prototype.getExtent = function() {
      return this._dataExtent.slice();
    }, r3.prototype.completeVisualOption = function() {
      var e3 = this.ecModel, u = this.option, h = { inRange: u.inRange, outOfRange: u.outOfRange }, v4 = u.target || (u.target = {}), m3 = u.controller || (u.controller = {});
      ol(v4, h), ol(m3, h);
      var x3 = this.isCategory();
      C.call(this, v4), C.call(this, m3), A2.call(this, v4, "inRange", "outOfRange"), D.call(this, m3);
      function C(P) {
        JAn(u.color) && !P.inRange && (P.inRange = { color: u.color.slice().reverse() }), P.inRange = P.inRange || { color: e3.get("gradientColor") };
      }
      function A2(P, N, j) {
        var W = P[N], K = P[j];
        W && !K && (K = P[j] = {}, Cst(W, function(te, ne) {
          if (!!om.isValidType(ne)) {
            var ce = Svt.get(ne, "inactive", x3);
            ce != null && (K[ne] = ce, ne === "color" && !K.hasOwnProperty("opacity") && !K.hasOwnProperty("colorAlpha") && (K.opacity = [0, 0]));
          }
        }));
      }
      function D(P) {
        var N = (P.inRange || {}).symbol || (P.outOfRange || {}).symbol, j = (P.inRange || {}).symbolSize || (P.outOfRange || {}).symbolSize, W = this.get("inactiveColor"), K = this.getItemSymbol(), te = K || "roundRect";
        Cst(this.stateList, function(ne) {
          var ce = this.itemSize, me = P[ne];
          me || (me = P[ne] = { color: x3 ? W : [W] }), me.symbol == null && (me.symbol = N && bs(N) || (x3 ? te : [te])), me.symbolSize == null && (me.symbolSize = j && bs(j) || (x3 ? ce[0] : [ce[0], ce[0]])), me.symbol = Sst(me.symbol, function(Oe) {
            return Oe === "none" ? te : Oe;
          });
          var ve = me.symbolSize;
          if (ve != null) {
            var Be = -1 / 0;
            ZAn(ve, function(Oe) {
              Oe > Be && (Be = Oe);
            }), me.symbolSize = Sst(ve, function(Oe) {
              return eIn(Oe, [0, Be], [0, ce[0]], true);
            });
          }
        }, this);
      }
    }, r3.prototype.resetItemSize = function() {
      this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
    }, r3.prototype.isCategory = function() {
      return !!this.option.categories;
    }, r3.prototype.setSelected = function(e3) {
    }, r3.prototype.getSelected = function() {
      return null;
    }, r3.prototype.getValueState = function(e3) {
      return null;
    }, r3.prototype.getVisualMeta = function(e3) {
      return null;
    }, r3.type = "visualMap", r3.dependencies = ["series"], r3.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, r3;
  }(fc), Ahe = tIn, Mst = [20, 140], nIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.optionUpdated = function(e3, u) {
      l3.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(h) {
        h.mappingMethod = "linear", h.dataExtent = this.getExtent();
      }), this._resetRange();
    }, r3.prototype.resetItemSize = function() {
      l3.prototype.resetItemSize.apply(this, arguments);
      var e3 = this.itemSize;
      (e3[0] == null || isNaN(e3[0])) && (e3[0] = Mst[0]), (e3[1] == null || isNaN(e3[1])) && (e3[1] = Mst[1]);
    }, r3.prototype._resetRange = function() {
      var e3 = this.getExtent(), u = this.option.range;
      !u || u.auto ? (e3.auto = 1, this.option.range = e3) : Ni(u) && (u[0] > u[1] && u.reverse(), u[0] = Math.max(u[0], e3[0]), u[1] = Math.min(u[1], e3[1]));
    }, r3.prototype.completeVisualOption = function() {
      l3.prototype.completeVisualOption.apply(this, arguments), mt(this.stateList, function(e3) {
        var u = this.option.controller[e3].symbolSize;
        u && u[0] !== u[1] && (u[0] = u[1] / 3);
      }, this);
    }, r3.prototype.setSelected = function(e3) {
      this.option.range = e3.slice(), this._resetRange();
    }, r3.prototype.getSelected = function() {
      var e3 = this.getExtent(), u = g2((this.get("range") || []).slice());
      return u[0] > e3[1] && (u[0] = e3[1]), u[1] > e3[1] && (u[1] = e3[1]), u[0] < e3[0] && (u[0] = e3[0]), u[1] < e3[0] && (u[1] = e3[0]), u;
    }, r3.prototype.getValueState = function(e3) {
      var u = this.option.range, h = this.getExtent();
      return (u[0] <= h[0] || u[0] <= e3) && (u[1] >= h[1] || e3 <= u[1]) ? "inRange" : "outOfRange";
    }, r3.prototype.findTargetDataIndices = function(e3) {
      var u = [];
      return this.eachTargetSeries(function(h) {
        var v4 = [], m3 = h.getData();
        m3.each(this.getDataDimensionIndex(m3), function(x3, C) {
          e3[0] <= x3 && x3 <= e3[1] && v4.push(C);
        }, this), u.push({ seriesId: h.id, dataIndex: v4 });
      }, this), u;
    }, r3.prototype.getVisualMeta = function(e3) {
      var u = Tst(this, "outOfRange", this.getExtent()), h = Tst(this, "inRange", this.option.range.slice()), v4 = [];
      function m3(j, W) {
        v4.push({ value: j, color: e3(j, W) });
      }
      for (var x3 = 0, C = 0, A2 = h.length, D = u.length; C < D && (!h.length || u[C] <= h[0]); C++)
        u[C] < h[x3] && m3(u[C], "outOfRange");
      for (var P = 1; x3 < A2; x3++, P = 0)
        P && v4.length && m3(h[x3], "outOfRange"), m3(h[x3], "inRange");
      for (var P = 1; C < D; C++)
        (!h.length || h[h.length - 1] < u[C]) && (P && (v4.length && m3(v4[v4.length - 1].value, "outOfRange"), P = 0), m3(u[C], "outOfRange"));
      var N = v4.length;
      return { stops: v4, outerColors: [N ? v4[0].color : "transparent", N ? v4[N - 1].color : "transparent"] };
    }, r3.type = "visualMap.continuous", r3.defaultOption = sP(Ahe.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), r3;
  }(Ahe);
  function Tst(l3, r3, e3) {
    if (e3[0] === e3[1])
      return e3.slice();
    for (var u = 200, h = (e3[1] - e3[0]) / u, v4 = e3[0], m3 = [], x3 = 0; x3 <= u && v4 < e3[1]; x3++)
      m3.push(v4), v4 += h;
    return m3.push(e3[1]), m3;
  }
  var rIn = nIn, iIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, e3;
    }
    return r3.prototype.init = function(e3, u) {
      this.ecModel = e3, this.api = u;
    }, r3.prototype.render = function(e3, u, h, v4) {
      if (this.visualMapModel = e3, e3.get("show") === false) {
        this.group.removeAll();
        return;
      }
      this.doRender(e3, u, h, v4);
    }, r3.prototype.renderBackground = function(e3) {
      var u = this.visualMapModel, h = Aj(u.get("padding") || 0), v4 = e3.getBoundingRect();
      e3.add(new Ju({ z2: -1, silent: true, shape: { x: v4.x - h[3], y: v4.y - h[0], width: v4.width + h[3] + h[1], height: v4.height + h[0] + h[2] }, style: { fill: u.get("backgroundColor"), stroke: u.get("borderColor"), lineWidth: u.get("borderWidth") } }));
    }, r3.prototype.getControllerVisual = function(e3, u, h) {
      h = h || {};
      var v4 = h.forceState, m3 = this.visualMapModel, x3 = {};
      if (u === "color") {
        var C = m3.get("contentColor");
        x3.color = C;
      }
      function A2(j) {
        return x3[j];
      }
      function D(j, W) {
        x3[j] = W;
      }
      var P = m3.controllerVisuals[v4 || m3.getValueState(e3)], N = om.prepareVisualTypes(P);
      return mt(N, function(j) {
        var W = P[j];
        h.convertOpacityToAlpha && j === "opacity" && (j = "colorAlpha", W = P.__alphaForOpacity), om.dependsOn(j, u) && W && W.applyVisual(e3, A2, D);
      }), x3[u];
    }, r3.prototype.positionGroup = function(e3) {
      var u = this.visualMapModel, h = this.api;
      ape(e3, u.getBoxLayoutParams(), { width: h.getWidth(), height: h.getHeight() });
    }, r3.prototype.doRender = function(e3, u, h, v4) {
    }, r3.type = "visualMap", r3;
  }(yd), Cvt = iIn, Ast = [["left", "right", "width"], ["top", "bottom", "height"]];
  function Mvt(l3, r3, e3) {
    var u = l3.option, h = u.align;
    if (h != null && h !== "auto")
      return h;
    for (var v4 = { width: r3.getWidth(), height: r3.getHeight() }, m3 = u.orient === "horizontal" ? 1 : 0, x3 = Ast[m3], C = [0, null, 10], A2 = {}, D = 0; D < 3; D++)
      A2[Ast[1 - m3][D]] = C[D], A2[x3[D]] = D === 2 ? e3[0] : u[x3[D]];
    var P = [["x", "width", 3], ["y", "height", 0]][m3], N = dg(A2, v4, u.padding);
    return x3[(N.margin[P[2]] || 0) + N[P[0]] + N[P[1]] * 0.5 < v4[P[1]] * 0.5 ? 0 : 1];
  }
  function Lfe(l3, r3) {
    return mt(l3 || [], function(e3) {
      e3.dataIndex != null && (e3.dataIndexInside = e3.dataIndex, e3.dataIndex = null), e3.highlightKey = "visualMap" + (r3 ? r3.componentIndex : "");
    }), l3;
  }
  var OA = _f, aIn = mt, Ist = Math.min, n5e = Math.max, oIn = 12, sIn = 6, lIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._shapes = {}, e3._dataInterval = [], e3._handleEnds = [], e3._hoverLinkDataIndices = [], e3;
    }
    return r3.prototype.doRender = function(e3, u, h, v4) {
      this._api = h, (!v4 || v4.type !== "selectDataRange" || v4.from !== this.uid) && this._buildView();
    }, r3.prototype._buildView = function() {
      this.group.removeAll();
      var e3 = this.visualMapModel, u = this.group;
      this._orient = e3.get("orient"), this._useHandle = e3.get("calculable"), this._resetInterval(), this._renderBar(u);
      var h = e3.get("text");
      this._renderEndsText(u, h, 0), this._renderEndsText(u, h, 1), this._updateView(true), this.renderBackground(u), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(u);
    }, r3.prototype._renderEndsText = function(e3, u, h) {
      if (!!u) {
        var v4 = u[1 - h];
        v4 = v4 != null ? v4 + "" : "";
        var m3 = this.visualMapModel, x3 = m3.get("textGap"), C = m3.itemSize, A2 = this._shapes.mainGroup, D = this._applyTransform([C[0] / 2, h === 0 ? -x3 : C[1] + x3], A2), P = this._applyTransform(h === 0 ? "bottom" : "top", A2), N = this._orient, j = this.visualMapModel.textStyleModel;
        this.group.add(new Ec({ style: { x: D[0], y: D[1], verticalAlign: N === "horizontal" ? "middle" : P, align: N === "horizontal" ? P : "center", text: v4, font: j.getFont(), fill: j.getTextColor() } }));
      }
    }, r3.prototype._renderBar = function(e3) {
      var u = this.visualMapModel, h = this._shapes, v4 = u.itemSize, m3 = this._orient, x3 = this._useHandle, C = Mvt(u, this.api, v4), A2 = h.mainGroup = this._createBarGroup(C), D = new Cs();
      A2.add(D), D.add(h.outOfRange = Est()), D.add(h.inRange = Est(null, x3 ? kst(this._orient) : null, no(this._dragHandle, this, "all", false), no(this._dragHandle, this, "all", true))), D.setClipPath(new Ju({ shape: { x: 0, y: 0, width: v4[0], height: v4[1], r: 3 } }));
      var P = u.textStyleModel.getTextRect("\u56FD"), N = n5e(P.width, P.height);
      x3 && (h.handleThumbs = [], h.handleLabels = [], h.handleLabelPoints = [], this._createHandle(u, A2, 0, v4, N, m3), this._createHandle(u, A2, 1, v4, N, m3)), this._createIndicator(u, A2, v4, N, m3), e3.add(A2);
    }, r3.prototype._createHandle = function(e3, u, h, v4, m3, x3) {
      var C = no(this._dragHandle, this, h, false), A2 = no(this._dragHandle, this, h, true), D = gM(e3.get("handleSize"), v4[0]), P = Nv(e3.get("handleIcon"), -D / 2, -D / 2, D, D, null, true), N = kst(this._orient);
      P.attr({ cursor: N, draggable: true, drift: C, ondragend: A2, onmousemove: function(ne) {
        u5(ne.event);
      } }), P.x = v4[0] / 2, P.useStyle(e3.getModel("handleStyle").getItemStyle()), P.setStyle({ strokeNoScale: true, strokeFirst: true }), P.style.lineWidth *= 2, P.ensureState("emphasis").style = e3.getModel(["emphasis", "handleStyle"]).getItemStyle(), DN(P, true), u.add(P);
      var j = this.visualMapModel.textStyleModel, W = new Ec({ cursor: N, draggable: true, drift: C, onmousemove: function(ne) {
        u5(ne.event);
      }, ondragend: A2, style: { x: 0, y: 0, text: "", font: j.getFont(), fill: j.getTextColor() } });
      W.ensureState("blur").style = { opacity: 0.1 }, W.stateTransition = { duration: 200 }, this.group.add(W);
      var K = [D, 0], te = this._shapes;
      te.handleThumbs[h] = P, te.handleLabelPoints[h] = K, te.handleLabels[h] = W;
    }, r3.prototype._createIndicator = function(e3, u, h, v4, m3) {
      var x3 = gM(e3.get("indicatorSize"), h[0]), C = Nv(e3.get("indicatorIcon"), -x3 / 2, -x3 / 2, x3, x3, null, true);
      C.attr({ cursor: "move", invisible: true, silent: true, x: h[0] / 2 });
      var A2 = e3.getModel("indicatorStyle").getItemStyle();
      if (C instanceof lm) {
        var D = C.style;
        C.useStyle(fi({ image: D.image, x: D.x, y: D.y, width: D.width, height: D.height }, A2));
      } else
        C.useStyle(A2);
      u.add(C);
      var P = this.visualMapModel.textStyleModel, N = new Ec({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: P.getFont(), fill: P.getTextColor() } });
      this.group.add(N);
      var j = [(m3 === "horizontal" ? v4 / 2 : sIn) + h[0] / 2, 0], W = this._shapes;
      W.indicator = C, W.indicatorLabel = N, W.indicatorLabelPoint = j, this._firstShowIndicator = true;
    }, r3.prototype._dragHandle = function(e3, u, h, v4) {
      if (!!this._useHandle) {
        if (this._dragging = !u, !u) {
          var m3 = this._applyTransform([h, v4], this._shapes.mainGroup, true);
          this._updateInterval(e3, m3[1]), this._hideIndicator(), this._updateView();
        }
        u === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), u ? !this._hovering && this._clearHoverLinkToSeries() : Dst(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[e3], false);
      }
    }, r3.prototype._resetInterval = function() {
      var e3 = this.visualMapModel, u = this._dataInterval = e3.getSelected(), h = e3.getExtent(), v4 = [0, e3.itemSize[1]];
      this._handleEnds = [OA(u[0], h, v4, true), OA(u[1], h, v4, true)];
    }, r3.prototype._updateInterval = function(e3, u) {
      u = u || 0;
      var h = this.visualMapModel, v4 = this._handleEnds, m3 = [0, h.itemSize[1]];
      tF(u, v4, m3, e3, 0);
      var x3 = h.getExtent();
      this._dataInterval = [OA(v4[0], m3, x3, true), OA(v4[1], m3, x3, true)];
    }, r3.prototype._updateView = function(e3) {
      var u = this.visualMapModel, h = u.getExtent(), v4 = this._shapes, m3 = [0, u.itemSize[1]], x3 = e3 ? m3 : this._handleEnds, C = this._createBarVisual(this._dataInterval, h, x3, "inRange"), A2 = this._createBarVisual(h, h, m3, "outOfRange");
      v4.inRange.setStyle({ fill: C.barColor }).setShape("points", C.barPoints), v4.outOfRange.setStyle({ fill: A2.barColor }).setShape("points", A2.barPoints), this._updateHandle(x3, C);
    }, r3.prototype._createBarVisual = function(e3, u, h, v4) {
      var m3 = { forceState: v4, convertOpacityToAlpha: true }, x3 = this._makeColorGradient(e3, m3), C = [this.getControllerVisual(e3[0], "symbolSize", m3), this.getControllerVisual(e3[1], "symbolSize", m3)], A2 = this._createBarPoints(h, C);
      return { barColor: new PJ(0, 0, 0, 1, x3), barPoints: A2, handlesColor: [x3[0].color, x3[x3.length - 1].color] };
    }, r3.prototype._makeColorGradient = function(e3, u) {
      var h = 100, v4 = [], m3 = (e3[1] - e3[0]) / h;
      v4.push({ color: this.getControllerVisual(e3[0], "color", u), offset: 0 });
      for (var x3 = 1; x3 < h; x3++) {
        var C = e3[0] + m3 * x3;
        if (C > e3[1])
          break;
        v4.push({ color: this.getControllerVisual(C, "color", u), offset: x3 / h });
      }
      return v4.push({ color: this.getControllerVisual(e3[1], "color", u), offset: 1 }), v4;
    }, r3.prototype._createBarPoints = function(e3, u) {
      var h = this.visualMapModel.itemSize;
      return [[h[0] - u[0], e3[0]], [h[0], e3[0]], [h[0], e3[1]], [h[0] - u[1], e3[1]]];
    }, r3.prototype._createBarGroup = function(e3) {
      var u = this._orient, h = this.visualMapModel.get("inverse");
      return new Cs(u === "horizontal" && !h ? { scaleX: e3 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : u === "horizontal" && h ? { scaleX: e3 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : u === "vertical" && !h ? { scaleX: e3 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: e3 === "left" ? 1 : -1 });
    }, r3.prototype._updateHandle = function(e3, u) {
      if (!!this._useHandle) {
        var h = this._shapes, v4 = this.visualMapModel, m3 = h.handleThumbs, x3 = h.handleLabels, C = v4.itemSize, A2 = v4.getExtent();
        aIn([0, 1], function(D) {
          var P = m3[D];
          P.setStyle("fill", u.handlesColor[D]), P.y = e3[D];
          var N = OA(e3[D], [0, C[1]], A2, true), j = this.getControllerVisual(N, "symbolSize");
          P.scaleX = P.scaleY = j / C[0], P.x = C[0] - j / 2;
          var W = vM(h.handleLabelPoints[D], VN(P, this.group));
          x3[D].setStyle({ x: W[0], y: W[1], text: v4.formatValueText(this._dataInterval[D]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", h.mainGroup) : "center" });
        }, this);
      }
    }, r3.prototype._showIndicator = function(e3, u, h, v4) {
      var m3 = this.visualMapModel, x3 = m3.getExtent(), C = m3.itemSize, A2 = [0, C[1]], D = this._shapes, P = D.indicator;
      if (!!P) {
        P.attr("invisible", false);
        var N = { convertOpacityToAlpha: true }, j = this.getControllerVisual(e3, "color", N), W = this.getControllerVisual(e3, "symbolSize"), K = OA(e3, x3, A2, true), te = C[0] - W / 2, ne = { x: P.x, y: P.y };
        P.y = K, P.x = te;
        var ce = vM(D.indicatorLabelPoint, VN(P, this.group)), me = D.indicatorLabel;
        me.attr("invisible", false);
        var ve = this._applyTransform("left", D.mainGroup), Be = this._orient, Oe = Be === "horizontal";
        me.setStyle({ text: (h || "") + m3.formatValueText(u), verticalAlign: Oe ? ve : "middle", align: Oe ? "center" : ve });
        var We = { x: te, y: K, style: { fill: j } }, Ue = { style: { x: ce[0], y: ce[1] } };
        if (m3.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
          var qe = { duration: 100, easing: "cubicInOut", additive: true };
          P.x = ne.x, P.y = ne.y, P.animateTo(We, qe), me.animateTo(Ue, qe);
        } else
          P.attr(We), me.attr(Ue);
        this._firstShowIndicator = false;
        var Ze = this._shapes.handleLabels;
        if (Ze)
          for (var ct = 0; ct < Ze.length; ct++)
            this._api.enterBlur(Ze[ct]);
      }
    }, r3.prototype._enableHoverLinkToSeries = function() {
      var e3 = this;
      this._shapes.mainGroup.on("mousemove", function(u) {
        if (e3._hovering = true, !e3._dragging) {
          var h = e3.visualMapModel.itemSize, v4 = e3._applyTransform([u.offsetX, u.offsetY], e3._shapes.mainGroup, true, true);
          v4[1] = Ist(n5e(0, v4[1]), h[1]), e3._doHoverLinkToSeries(v4[1], 0 <= v4[0] && v4[0] <= h[0]);
        }
      }).on("mouseout", function() {
        e3._hovering = false, !e3._dragging && e3._clearHoverLinkToSeries();
      });
    }, r3.prototype._enableHoverLinkFromSeries = function() {
      var e3 = this.api.getZr();
      this.visualMapModel.option.hoverLink ? (e3.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), e3.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
    }, r3.prototype._doHoverLinkToSeries = function(e3, u) {
      var h = this.visualMapModel, v4 = h.itemSize;
      if (!!h.option.hoverLink) {
        var m3 = [0, v4[1]], x3 = h.getExtent();
        e3 = Ist(n5e(m3[0], e3), m3[1]);
        var C = uIn(h, x3, m3), A2 = [e3 - C, e3 + C], D = OA(e3, m3, x3, true), P = [OA(A2[0], m3, x3, true), OA(A2[1], m3, x3, true)];
        A2[0] < m3[0] && (P[0] = -1 / 0), A2[1] > m3[1] && (P[1] = 1 / 0), u && (P[0] === -1 / 0 ? this._showIndicator(D, P[1], "< ", C) : P[1] === 1 / 0 ? this._showIndicator(D, P[0], "> ", C) : this._showIndicator(D, D, "\u2248 ", C));
        var N = this._hoverLinkDataIndices, j = [];
        (u || Dst(h)) && (j = this._hoverLinkDataIndices = h.findTargetDataIndices(P));
        var W = $ln(N, j);
        this._dispatchHighDown("downplay", Lfe(W[0], h)), this._dispatchHighDown("highlight", Lfe(W[1], h));
      }
    }, r3.prototype._hoverLinkFromSeriesMouseOver = function(e3) {
      var u = e3.target, h = this.visualMapModel;
      if (!(!u || Ps(u).dataIndex == null)) {
        var v4 = Ps(u), m3 = this.ecModel.getSeriesByIndex(v4.seriesIndex);
        if (!!h.isTargetSeries(m3)) {
          var x3 = m3.getData(v4.dataType), C = x3.getStore().get(h.getDataDimensionIndex(x3), v4.dataIndex);
          isNaN(C) || this._showIndicator(C, C);
        }
      }
    }, r3.prototype._hideIndicator = function() {
      var e3 = this._shapes;
      e3.indicator && e3.indicator.attr("invisible", true), e3.indicatorLabel && e3.indicatorLabel.attr("invisible", true);
      var u = this._shapes.handleLabels;
      if (u)
        for (var h = 0; h < u.length; h++)
          this._api.leaveBlur(u[h]);
    }, r3.prototype._clearHoverLinkToSeries = function() {
      this._hideIndicator();
      var e3 = this._hoverLinkDataIndices;
      this._dispatchHighDown("downplay", Lfe(e3, this.visualMapModel)), e3.length = 0;
    }, r3.prototype._clearHoverLinkFromSeries = function() {
      this._hideIndicator();
      var e3 = this.api.getZr();
      e3.off("mouseover", this._hoverLinkFromSeriesMouseOver), e3.off("mouseout", this._hideIndicator);
    }, r3.prototype._applyTransform = function(e3, u, h, v4) {
      var m3 = VN(u, v4 ? null : this.group);
      return Ni(e3) ? vM(e3, m3, h) : Jhe(e3, m3, h);
    }, r3.prototype._dispatchHighDown = function(e3, u) {
      u && u.length && this.api.dispatchAction({ type: e3, batch: u });
    }, r3.prototype.dispose = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, r3.prototype.remove = function() {
      this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
    }, r3.type = "visualMap.continuous", r3;
  }(Cvt);
  function Est(l3, r3, e3, u) {
    return new C_({ shape: { points: l3 }, draggable: !!e3, cursor: r3, drift: e3, onmousemove: function(h) {
      u5(h.event);
    }, ondragend: u });
  }
  function uIn(l3, r3, e3) {
    var u = oIn / 2, h = l3.get("hoverLinkDataSize");
    return h && (u = OA(h, r3, e3, true) / 2), u;
  }
  function Dst(l3) {
    var r3 = l3.get("hoverLinkOnHandle");
    return !!(r3 == null ? l3.get("realtime") : r3);
  }
  function kst(l3) {
    return l3 === "vertical" ? "ns-resize" : "ew-resize";
  }
  var cIn = lIn, fIn = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, hIn = function(l3, r3) {
    r3.eachComponent({ mainType: "visualMap", query: l3 }, function(e3) {
      e3.setSelected(l3.selected);
    });
  }, pIn = [{ createOnAllSeries: true, reset: function(l3, r3) {
    var e3 = [];
    return r3.eachComponent("visualMap", function(u) {
      var h = l3.pipelineContext;
      !u.isTargetSeries(l3) || h && h.large || e3.push(sTn(u.stateList, u.targetVisuals, no(u.getValueState, u), u.getDataDimensionIndex(l3.getData())));
    }), e3;
  } }, { createOnAllSeries: true, reset: function(l3, r3) {
    var e3 = l3.getData(), u = [];
    r3.eachComponent("visualMap", function(h) {
      if (h.isTargetSeries(l3)) {
        var v4 = h.getVisualMeta(no(dIn, null, l3, h)) || { stops: [], outerColors: [] }, m3 = h.getDataDimensionIndex(e3);
        m3 >= 0 && (v4.dimension = m3, u.push(v4));
      }
    }), l3.getData().setVisual("visualMeta", u);
  } }];
  function dIn(l3, r3, e3, u) {
    for (var h = r3.targetVisuals[u], v4 = om.prepareVisualTypes(h), m3 = { color: VJ(l3.getData(), "color") }, x3 = 0, C = v4.length; x3 < C; x3++) {
      var A2 = v4[x3], D = h[A2 === "opacity" ? "__alphaForOpacity" : A2];
      D && D.applyVisual(e3, P, N);
    }
    return m3.color;
    function P(j) {
      return m3[j];
    }
    function N(j, W) {
      m3[j] = W;
    }
  }
  var Ost = mt;
  function vIn(l3) {
    var r3 = l3 && l3.visualMap;
    Ni(r3) || (r3 = r3 ? [r3] : []), Ost(r3, function(e3) {
      if (!!e3) {
        Bz(e3, "splitList") && !Bz(e3, "pieces") && (e3.pieces = e3.splitList, delete e3.splitList);
        var u = e3.pieces;
        u && Ni(u) && Ost(u, function(h) {
          ls(h) && (Bz(h, "start") && !Bz(h, "min") && (h.min = h.start), Bz(h, "end") && !Bz(h, "max") && (h.max = h.end));
        });
      }
    });
  }
  function Bz(l3, r3) {
    return l3 && l3.hasOwnProperty && l3.hasOwnProperty(r3);
  }
  var Pst = false;
  function Tvt(l3) {
    Pst || (Pst = true, l3.registerSubTypeDefaulter("visualMap", function(r3) {
      return !r3.categories && (!(r3.pieces ? r3.pieces.length > 0 : r3.splitNumber > 0) || r3.calculable) ? "continuous" : "piecewise";
    }), l3.registerAction(fIn, hIn), mt(pIn, function(r3) {
      l3.registerVisual(l3.PRIORITY.VISUAL.COMPONENT, r3);
    }), l3.registerPreprocessor(vIn));
  }
  function Avt(l3) {
    l3.registerComponentModel(rIn), l3.registerComponentView(cIn), Tvt(l3);
  }
  var gIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3._pieceList = [], e3;
    }
    return r3.prototype.optionUpdated = function(e3, u) {
      l3.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
      var h = this._mode = this._determineMode();
      this._pieceList = [], yIn[this._mode].call(this, this._pieceList), this._resetSelected(e3, u);
      var v4 = this.option.categories;
      this.resetVisual(function(m3, x3) {
        h === "categories" ? (m3.mappingMethod = "category", m3.categories = bs(v4)) : (m3.dataExtent = this.getExtent(), m3.mappingMethod = "piecewise", m3.pieceList = Bi(this._pieceList, function(C) {
          return C = bs(C), x3 !== "inRange" && (C.visual = null), C;
        }));
      });
    }, r3.prototype.completeVisualOption = function() {
      var e3 = this.option, u = {}, h = om.listVisualTypes(), v4 = this.isCategory();
      mt(e3.pieces, function(x3) {
        mt(h, function(C) {
          x3.hasOwnProperty(C) && (u[C] = 1);
        });
      }), mt(u, function(x3, C) {
        var A2 = false;
        mt(this.stateList, function(D) {
          A2 = A2 || m3(e3, D, C) || m3(e3.target, D, C);
        }, this), !A2 && mt(this.stateList, function(D) {
          (e3[D] || (e3[D] = {}))[C] = Svt.get(C, D === "inRange" ? "active" : "inactive", v4);
        });
      }, this);
      function m3(x3, C, A2) {
        return x3 && x3[C] && x3[C].hasOwnProperty(A2);
      }
      l3.prototype.completeVisualOption.apply(this, arguments);
    }, r3.prototype._resetSelected = function(e3, u) {
      var h = this.option, v4 = this._pieceList, m3 = (u ? h : e3).selected || {};
      if (h.selected = m3, mt(v4, function(C, A2) {
        var D = this.getSelectedMapKey(C);
        m3.hasOwnProperty(D) || (m3[D] = true);
      }, this), h.selectedMode === "single") {
        var x3 = false;
        mt(v4, function(C, A2) {
          var D = this.getSelectedMapKey(C);
          m3[D] && (x3 ? m3[D] = false : x3 = true);
        }, this);
      }
    }, r3.prototype.getItemSymbol = function() {
      return this.get("itemSymbol");
    }, r3.prototype.getSelectedMapKey = function(e3) {
      return this._mode === "categories" ? e3.value + "" : e3.index + "";
    }, r3.prototype.getPieceList = function() {
      return this._pieceList;
    }, r3.prototype._determineMode = function() {
      var e3 = this.option;
      return e3.pieces && e3.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
    }, r3.prototype.setSelected = function(e3) {
      this.option.selected = bs(e3);
    }, r3.prototype.getValueState = function(e3) {
      var u = om.findPieceIndex(e3, this._pieceList);
      return u != null && this.option.selected[this.getSelectedMapKey(this._pieceList[u])] ? "inRange" : "outOfRange";
    }, r3.prototype.findTargetDataIndices = function(e3) {
      var u = [], h = this._pieceList;
      return this.eachTargetSeries(function(v4) {
        var m3 = [], x3 = v4.getData();
        x3.each(this.getDataDimensionIndex(x3), function(C, A2) {
          var D = om.findPieceIndex(C, h);
          D === e3 && m3.push(A2);
        }, this), u.push({ seriesId: v4.id, dataIndex: m3 });
      }, this), u;
    }, r3.prototype.getRepresentValue = function(e3) {
      var u;
      if (this.isCategory())
        u = e3.value;
      else if (e3.value != null)
        u = e3.value;
      else {
        var h = e3.interval || [];
        u = h[0] === -1 / 0 && h[1] === 1 / 0 ? 0 : (h[0] + h[1]) / 2;
      }
      return u;
    }, r3.prototype.getVisualMeta = function(e3) {
      if (this.isCategory())
        return;
      var u = [], h = ["", ""], v4 = this;
      function m3(D, P) {
        var N = v4.getRepresentValue({ interval: D });
        P || (P = v4.getValueState(N));
        var j = e3(N, P);
        D[0] === -1 / 0 ? h[0] = j : D[1] === 1 / 0 ? h[1] = j : u.push({ value: D[0], color: j }, { value: D[1], color: j });
      }
      var x3 = this._pieceList.slice();
      if (!x3.length)
        x3.push({ interval: [-1 / 0, 1 / 0] });
      else {
        var C = x3[0].interval[0];
        C !== -1 / 0 && x3.unshift({ interval: [-1 / 0, C] }), C = x3[x3.length - 1].interval[1], C !== 1 / 0 && x3.push({ interval: [C, 1 / 0] });
      }
      var A2 = -1 / 0;
      return mt(x3, function(D) {
        var P = D.interval;
        P && (P[0] > A2 && m3([A2, P[0]], "outOfRange"), m3(P.slice()), A2 = P[1]);
      }, this), { stops: u, outerColors: h };
    }, r3.type = "visualMap.piecewise", r3.defaultOption = sP(Ahe.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), r3;
  }(Ahe), yIn = { splitNumber: function(l3) {
    var r3 = this.option, e3 = Math.min(r3.precision, 20), u = this.getExtent(), h = r3.splitNumber;
    h = Math.max(parseInt(h, 10), 1), r3.splitNumber = h;
    for (var v4 = (u[1] - u[0]) / h; +v4.toFixed(e3) !== v4 && e3 < 5; )
      e3++;
    r3.precision = e3, v4 = +v4.toFixed(e3), r3.minOpen && l3.push({ interval: [-1 / 0, u[0]], close: [0, 0] });
    for (var m3 = 0, x3 = u[0]; m3 < h; x3 += v4, m3++) {
      var C = m3 === h - 1 ? u[1] : x3 + v4;
      l3.push({ interval: [x3, C], close: [1, 1] });
    }
    r3.maxOpen && l3.push({ interval: [u[1], 1 / 0], close: [0, 0] }), Mtt(l3), mt(l3, function(A2, D) {
      A2.index = D, A2.text = this.formatValueText(A2.interval);
    }, this);
  }, categories: function(l3) {
    var r3 = this.option;
    mt(r3.categories, function(e3) {
      l3.push({ text: this.formatValueText(e3, true), value: e3 });
    }, this), Lst(r3, l3);
  }, pieces: function(l3) {
    var r3 = this.option;
    mt(r3.pieces, function(e3, u) {
      ls(e3) || (e3 = { value: e3 });
      var h = { text: "", index: u };
      if (e3.label != null && (h.text = e3.label), e3.hasOwnProperty("value")) {
        var v4 = h.value = e3.value;
        h.interval = [v4, v4], h.close = [1, 1];
      } else {
        for (var m3 = h.interval = [], x3 = h.close = [0, 0], C = [1, 0, 1], A2 = [-1 / 0, 1 / 0], D = [], P = 0; P < 2; P++) {
          for (var N = [["gte", "gt", "min"], ["lte", "lt", "max"]][P], j = 0; j < 3 && m3[P] == null; j++)
            m3[P] = e3[N[j]], x3[P] = C[j], D[P] = j === 2;
          m3[P] == null && (m3[P] = A2[P]);
        }
        D[0] && m3[1] === 1 / 0 && (x3[0] = 0), D[1] && m3[0] === -1 / 0 && (x3[1] = 0), m3[0] === m3[1] && x3[0] && x3[1] && (h.value = m3[0]);
      }
      h.visual = om.retrieveVisuals(e3), l3.push(h);
    }, this), Lst(r3, l3), Mtt(l3), mt(l3, function(e3) {
      var u = e3.close, h = [["<", "\u2264"][u[1]], [">", "\u2265"][u[0]]];
      e3.text = e3.text || this.formatValueText(e3.value != null ? e3.value : e3.interval, false, h);
    }, this);
  } };
  function Lst(l3, r3) {
    var e3 = l3.inverse;
    (l3.orient === "vertical" ? !e3 : e3) && r3.reverse();
  }
  var mIn = gIn, bIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = r3.type, e3;
    }
    return r3.prototype.doRender = function() {
      var e3 = this.group;
      e3.removeAll();
      var u = this.visualMapModel, h = u.get("textGap"), v4 = u.textStyleModel, m3 = v4.getFont(), x3 = v4.getTextColor(), C = this._getItemAlign(), A2 = u.itemSize, D = this._getViewData(), P = D.endsText, N = ey(u.get("showLabel", true), !P);
      P && this._renderEndsText(e3, P[0], A2, N, C), mt(D.viewPieceList, function(j) {
        var W = j.piece, K = new Cs();
        K.onclick = no(this._onItemClick, this, W), this._enableHoverLink(K, j.indexInModelPieceList);
        var te = u.getRepresentValue(W);
        if (this._createItemSymbol(K, te, [0, 0, A2[0], A2[1]]), N) {
          var ne = this.visualMapModel.getValueState(te);
          K.add(new Ec({ style: { x: C === "right" ? -h : A2[0] + h, y: A2[1] / 2, text: W.text, verticalAlign: "middle", align: C, font: m3, fill: x3, opacity: ne === "outOfRange" ? 0.5 : 1 } }));
        }
        e3.add(K);
      }, this), P && this._renderEndsText(e3, P[1], A2, N, C), BN(u.get("orient"), e3, u.get("itemGap")), this.renderBackground(e3), this.positionGroup(e3);
    }, r3.prototype._enableHoverLink = function(e3, u) {
      var h = this;
      e3.on("mouseover", function() {
        return v4("highlight");
      }).on("mouseout", function() {
        return v4("downplay");
      });
      var v4 = function(m3) {
        var x3 = h.visualMapModel;
        x3.option.hoverLink && h.api.dispatchAction({ type: m3, batch: Lfe(x3.findTargetDataIndices(u), x3) });
      };
    }, r3.prototype._getItemAlign = function() {
      var e3 = this.visualMapModel, u = e3.option;
      if (u.orient === "vertical")
        return Mvt(e3, this.api, e3.itemSize);
      var h = u.align;
      return (!h || h === "auto") && (h = "left"), h;
    }, r3.prototype._renderEndsText = function(e3, u, h, v4, m3) {
      if (!!u) {
        var x3 = new Cs(), C = this.visualMapModel.textStyleModel;
        x3.add(new Ec({ style: { x: v4 ? m3 === "right" ? h[0] : 0 : h[0] / 2, y: h[1] / 2, verticalAlign: "middle", align: v4 ? m3 : "center", text: u, font: C.getFont(), fill: C.getTextColor() } })), e3.add(x3);
      }
    }, r3.prototype._getViewData = function() {
      var e3 = this.visualMapModel, u = Bi(e3.getPieceList(), function(x3, C) {
        return { piece: x3, indexInModelPieceList: C };
      }), h = e3.get("text"), v4 = e3.get("orient"), m3 = e3.get("inverse");
      return (v4 === "horizontal" ? m3 : !m3) ? u.reverse() : h && (h = h.slice().reverse()), { viewPieceList: u, endsText: h };
    }, r3.prototype._createItemSymbol = function(e3, u, h) {
      e3.add(Nv(this.getControllerVisual(u, "symbol"), h[0], h[1], h[2], h[3], this.getControllerVisual(u, "color")));
    }, r3.prototype._onItemClick = function(e3) {
      var u = this.visualMapModel, h = u.option, v4 = bs(h.selected), m3 = u.getSelectedMapKey(e3);
      h.selectedMode === "single" ? (v4[m3] = true, mt(v4, function(x3, C) {
        v4[C] = C === m3;
      })) : v4[m3] = !v4[m3], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: v4 });
    }, r3.type = "visualMap.piecewise", r3;
  }(Cvt), _In = bIn;
  function Ivt(l3) {
    l3.registerComponentModel(mIn), l3.registerComponentView(_In), Tvt(l3);
  }
  function xIn(l3) {
    kl(Avt), kl(Ivt);
  }
  var wIn = { label: { enabled: true }, decal: { show: false } }, Rst = pc(), SIn = {};
  function CIn(l3, r3) {
    var e3 = l3.getModel("aria");
    if (!e3.get("enabled"))
      return;
    var u = bs(wIn);
    ol(u.label, l3.getLocaleModel().get("aria"), false), ol(e3.option, u, false), h(), v4();
    function h() {
      var A2 = e3.getModel("decal"), D = A2.get("show");
      if (D) {
        var P = Ho();
        l3.eachSeries(function(N) {
          if (!N.isColorBySeries()) {
            var j = P.get(N.type);
            j || (j = {}, P.set(N.type, j)), Rst(N).scope = j;
          }
        }), l3.eachRawSeries(function(N) {
          if (l3.isSeriesFiltered(N))
            return;
          if (Xo(N.enableAriaDecal)) {
            N.enableAriaDecal();
            return;
          }
          var j = N.getData();
          if (N.isColorBySeries()) {
            var ce = nke(N.ecModel, N.name, SIn, l3.getSeriesCount()), me = j.getVisual("decal");
            j.setVisual("decal", ve(me, ce));
          } else {
            var W = N.getRawData(), K = {}, te = Rst(N).scope;
            j.each(function(Be) {
              var Oe = j.getRawIndex(Be);
              K[Oe] = Be;
            });
            var ne = W.count();
            W.each(function(Be) {
              var Oe = K[Be], We = W.getName(Be) || Be + "", Ue = nke(N.ecModel, We, te, ne), qe = j.getItemVisual(Oe, "decal");
              j.setItemVisual(Oe, "decal", ve(qe, Ue));
            });
          }
          function ve(Be, Oe) {
            var We = Be ? fi(fi({}, Oe), Be) : Oe;
            return We.dirty = true, We;
          }
        });
      }
    }
    function v4() {
      var A2 = l3.getLocaleModel().get("aria"), D = e3.getModel("label");
      if (D.option = ns(D.option, A2), !!D.get("enabled")) {
        var P = r3.getZr().dom;
        if (D.get("description")) {
          P.setAttribute("aria-label", D.get("description"));
          return;
        }
        var N = l3.getSeriesCount(), j = D.get(["data", "maxCount"]) || 10, W = D.get(["series", "maxCount"]) || 10, K = Math.min(N, W), te;
        if (!(N < 1)) {
          var ne = x3();
          if (ne) {
            var ce = D.get(["general", "withTitle"]);
            te = m3(ce, { title: ne });
          } else
            te = D.get(["general", "withoutTitle"]);
          var me = [], ve = N > 1 ? D.get(["series", "multiple", "prefix"]) : D.get(["series", "single", "prefix"]);
          te += m3(ve, { seriesCount: N }), l3.eachSeries(function(Ue, qe) {
            if (qe < K) {
              var Ze = void 0, ct = Ue.get("name"), _t = ct ? "withName" : "withoutName";
              Ze = N > 1 ? D.get(["series", "multiple", _t]) : D.get(["series", "single", _t]), Ze = m3(Ze, { seriesId: Ue.seriesIndex, seriesName: Ue.get("name"), seriesType: C(Ue.subType) });
              var pt = Ue.getData();
              if (pt.count() > j) {
                var zt = D.get(["data", "partialData"]);
                Ze += m3(zt, { displayCnt: j });
              } else
                Ze += D.get(["data", "allData"]);
              for (var Zt = D.get(["data", "separator", "middle"]), Ft = D.get(["data", "separator", "end"]), Kn = [], hn = 0; hn < pt.count(); hn++)
                if (hn < j) {
                  var xn = pt.getName(hn), zn = pt.getValues(hn), or = D.get(["data", xn ? "withName" : "withoutName"]);
                  Kn.push(m3(or, { name: xn, value: zn.join(Zt) }));
                }
              Ze += Kn.join(Zt) + Ft, me.push(Ze);
            }
          });
          var Be = D.getModel(["series", "multiple", "separator"]), Oe = Be.get("middle"), We = Be.get("end");
          te += me.join(Oe) + We, P.setAttribute("aria-label", te);
        }
      }
    }
    function m3(A2, D) {
      if (!qa(A2))
        return A2;
      var P = A2;
      return mt(D, function(N, j) {
        P = P.replace(new RegExp("\\{\\s*" + j + "\\s*\\}", "g"), N);
      }), P;
    }
    function x3() {
      var A2 = l3.get("title");
      return A2 && A2.length && (A2 = A2[0]), A2 && A2.text;
    }
    function C(A2) {
      return l3.getLocaleModel().get(["series", "typeNames"])[A2] || "\u81EA\u5B9A\u4E49\u56FE";
    }
  }
  function MIn(l3) {
    if (!(!l3 || !l3.aria)) {
      var r3 = l3.aria;
      r3.show != null && (r3.enabled = r3.show), r3.label = r3.label || {}, mt(["description", "general", "series", "data"], function(e3) {
        r3[e3] != null && (r3.label[e3] = r3[e3]);
      });
    }
  }
  function TIn(l3) {
    l3.registerPreprocessor(MIn), l3.registerVisual(l3.PRIORITY.VISUAL.ARIA, CIn);
  }
  var Nst = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, AIn = function() {
    function l3(r3) {
      var e3 = this._condVal = qa(r3) ? new RegExp(r3) : osn(r3) ? r3 : null;
      if (e3 == null) {
        var u = "";
        Xc(u);
      }
    }
    return l3.prototype.evaluate = function(r3) {
      var e3 = typeof r3;
      return qa(e3) ? this._condVal.test(r3) : Vc(e3) ? this._condVal.test(r3 + "") : false;
    }, l3;
  }(), IIn = function() {
    function l3() {
    }
    return l3.prototype.evaluate = function() {
      return this.value;
    }, l3;
  }(), EIn = function() {
    function l3() {
    }
    return l3.prototype.evaluate = function() {
      for (var r3 = this.children, e3 = 0; e3 < r3.length; e3++)
        if (!r3[e3].evaluate())
          return false;
      return true;
    }, l3;
  }(), DIn = function() {
    function l3() {
    }
    return l3.prototype.evaluate = function() {
      for (var r3 = this.children, e3 = 0; e3 < r3.length; e3++)
        if (r3[e3].evaluate())
          return true;
      return false;
    }, l3;
  }(), kIn = function() {
    function l3() {
    }
    return l3.prototype.evaluate = function() {
      return !this.child.evaluate();
    }, l3;
  }(), OIn = function() {
    function l3() {
    }
    return l3.prototype.evaluate = function() {
      for (var r3 = !!this.valueParser, e3 = this.getValue, u = e3(this.valueGetterParam), h = r3 ? this.valueParser(u) : null, v4 = 0; v4 < this.subCondList.length; v4++)
        if (!this.subCondList[v4].evaluate(r3 ? h : u))
          return false;
      return true;
    }, l3;
  }();
  function MPe(l3, r3) {
    if (l3 === true || l3 === false) {
      var e3 = new IIn();
      return e3.value = l3, e3;
    }
    var u = "";
    return Evt(l3) || Xc(u), l3.and ? Fst("and", l3, r3) : l3.or ? Fst("or", l3, r3) : l3.not ? PIn(l3, r3) : LIn(l3, r3);
  }
  function Fst(l3, r3, e3) {
    var u = r3[l3], h = "";
    Ni(u) || Xc(h), u.length || Xc(h);
    var v4 = l3 === "and" ? new EIn() : new DIn();
    return v4.children = Bi(u, function(m3) {
      return MPe(m3, e3);
    }), v4.children.length || Xc(h), v4;
  }
  function PIn(l3, r3) {
    var e3 = l3.not, u = "";
    Evt(e3) || Xc(u);
    var h = new kIn();
    return h.child = MPe(e3, r3), h.child || Xc(u), h;
  }
  function LIn(l3, r3) {
    for (var e3 = "", u = r3.prepareGetValue(l3), h = [], v4 = yu(l3), m3 = l3.parser, x3 = m3 ? aft(m3) : null, C = 0; C < v4.length; C++) {
      var A2 = v4[C];
      if (!(A2 === "parser" || r3.valueGetterAttrMap.get(A2))) {
        var D = vo(Nst, A2) ? Nst[A2] : A2, P = l3[A2], N = x3 ? x3(P) : P, j = phn(D, N) || D === "reg" && new AIn(N);
        j || Xc(e3), h.push(j);
      }
    }
    h.length || Xc(e3);
    var W = new OIn();
    return W.valueGetterParam = u, W.valueParser = x3, W.getValue = r3.getValue, W.subCondList = h, W;
  }
  function Evt(l3) {
    return ls(l3) && !m1(l3);
  }
  var RIn = function() {
    function l3(r3, e3) {
      this._cond = MPe(r3, e3);
    }
    return l3.prototype.evaluate = function() {
      return this._cond.evaluate();
    }, l3;
  }();
  function NIn(l3, r3) {
    return new RIn(l3, r3);
  }
  var FIn = { type: "echarts:filter", transform: function(l3) {
    for (var r3 = l3.upstream, e3, u = NIn(l3.config, { valueGetterAttrMap: Ho({ dimension: true }), prepareGetValue: function(x3) {
      var C = "", A2 = x3.dimension;
      vo(x3, "dimension") || Xc(C);
      var D = r3.getDimensionInfo(A2);
      return D || Xc(C), { dimIdx: D.index };
    }, getValue: function(x3) {
      return r3.retrieveValueFromItem(e3, x3.dimIdx);
    } }), h = [], v4 = 0, m3 = r3.count(); v4 < m3; v4++)
      e3 = r3.getRawDataItem(v4), u.evaluate() && h.push(e3);
    return { data: h };
  } }, VIn = { type: "echarts:sort", transform: function(l3) {
    var r3 = l3.upstream, e3 = l3.config, u = "", h = Gf(e3);
    h.length || Xc(u);
    var v4 = [];
    mt(h, function(D) {
      var P = D.dimension, N = D.order, j = D.parser, W = D.incomparable;
      if (P == null && Xc(u), N !== "asc" && N !== "desc" && Xc(u), W && W !== "min" && W !== "max") {
        var K = "";
        Xc(K);
      }
      if (N !== "asc" && N !== "desc") {
        var te = "";
        Xc(te);
      }
      var ne = r3.getDimensionInfo(P);
      ne || Xc(u);
      var ce = j ? aft(j) : null;
      j && !ce && Xc(u), v4.push({ dimIdx: ne.index, parser: ce, comparator: new sft(N, W) });
    });
    var m3 = r3.sourceFormat;
    m3 !== b1 && m3 !== C2 && Xc(u);
    for (var x3 = [], C = 0, A2 = r3.count(); C < A2; C++)
      x3.push(r3.getRawDataItem(C));
    return x3.sort(function(D, P) {
      for (var N = 0; N < v4.length; N++) {
        var j = v4[N], W = r3.retrieveValueFromItem(D, j.dimIdx), K = r3.retrieveValueFromItem(P, j.dimIdx);
        j.parser && (W = j.parser(W), K = j.parser(K));
        var te = j.comparator.evaluate(W, K);
        if (te !== 0)
          return te;
      }
      return 0;
    }), { data: x3 };
  } };
  function BIn(l3) {
    l3.registerTransform(FIn), l3.registerTransform(VIn);
  }
  var zIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "dataset", e3;
    }
    return r3.prototype.init = function(e3, u, h) {
      l3.prototype.init.call(this, e3, u, h), this._sourceManager = new fft(this), Bnt(this);
    }, r3.prototype.mergeOption = function(e3, u) {
      l3.prototype.mergeOption.call(this, e3, u), Bnt(this);
    }, r3.prototype.optionUpdated = function() {
      this._sourceManager.dirty();
    }, r3.prototype.getSourceManager = function() {
      return this._sourceManager;
    }, r3.type = "dataset", r3.defaultOption = { seriesLayoutBy: GA }, r3;
  }(fc), jIn = function(l3) {
    ar(r3, l3);
    function r3() {
      var e3 = l3 !== null && l3.apply(this, arguments) || this;
      return e3.type = "dataset", e3;
    }
    return r3.type = "dataset", r3;
  }(yd);
  function GIn(l3) {
    l3.registerComponentModel(zIn), l3.registerComponentView(jIn);
  }
  var DA = XA.CMD;
  function ej(l3, r3) {
    return Math.abs(l3 - r3) < 1e-5;
  }
  function e3e(l3) {
    var r3 = l3.data, e3 = l3.len(), u = [], h, v4 = 0, m3 = 0, x3 = 0, C = 0;
    function A2(pt, zt) {
      h && h.length > 2 && u.push(h), h = [pt, zt];
    }
    function D(pt, zt, Zt, Ft) {
      ej(pt, Zt) && ej(zt, Ft) || h.push(pt, zt, Zt, Ft, Zt, Ft);
    }
    function P(pt, zt, Zt, Ft, Kn, hn) {
      var xn = Math.abs(zt - pt), zn = Math.tan(xn / 4) * 4 / 3, or = zt < pt ? -1 : 1, vr = Math.cos(pt), la = Math.sin(pt), Ba = Math.cos(zt), Lo = Math.sin(zt), Ao = vr * Kn + Zt, oo = la * hn + Ft, Pa = Ba * Kn + Zt, fo = Lo * hn + Ft, Co = Kn * zn * or, $a = hn * zn * or;
      h.push(Ao - Co * la, oo + $a * vr, Pa + Co * Lo, fo - $a * Ba, Pa, fo);
    }
    for (var N, j, W, K, te = 0; te < e3; ) {
      var ne = r3[te++], ce = te === 1;
      switch (ce && (v4 = r3[te], m3 = r3[te + 1], x3 = v4, C = m3, (ne === DA.L || ne === DA.C || ne === DA.Q) && (h = [x3, C])), ne) {
        case DA.M:
          v4 = x3 = r3[te++], m3 = C = r3[te++], A2(x3, C);
          break;
        case DA.L:
          N = r3[te++], j = r3[te++], D(v4, m3, N, j), v4 = N, m3 = j;
          break;
        case DA.C:
          h.push(r3[te++], r3[te++], r3[te++], r3[te++], v4 = r3[te++], m3 = r3[te++]);
          break;
        case DA.Q:
          N = r3[te++], j = r3[te++], W = r3[te++], K = r3[te++], h.push(v4 + 2 / 3 * (N - v4), m3 + 2 / 3 * (j - m3), W + 2 / 3 * (N - W), K + 2 / 3 * (j - K), W, K), v4 = W, m3 = K;
          break;
        case DA.A:
          var me = r3[te++], ve = r3[te++], Be = r3[te++], Oe = r3[te++], We = r3[te++], Ue = r3[te++] + We;
          te += 1;
          var qe = !r3[te++];
          N = Math.cos(We) * Be + me, j = Math.sin(We) * Oe + ve, ce ? (x3 = N, C = j, A2(x3, C)) : D(v4, m3, N, j), v4 = Math.cos(Ue) * Be + me, m3 = Math.sin(Ue) * Oe + ve;
          for (var Ze = (qe ? -1 : 1) * Math.PI / 2, ct = We; qe ? ct > Ue : ct < Ue; ct += Ze) {
            var _t = qe ? Math.max(ct + Ze, Ue) : Math.min(ct + Ze, Ue);
            P(ct, _t, me, ve, Be, Oe);
          }
          break;
        case DA.R:
          x3 = v4 = r3[te++], C = m3 = r3[te++], N = x3 + r3[te++], j = C + r3[te++], A2(N, C), D(N, C, N, j), D(N, j, x3, j), D(x3, j, x3, C), D(x3, C, N, C);
          break;
        case DA.Z:
          h && D(v4, m3, x3, C), v4 = x3, m3 = C;
          break;
      }
    }
    return h && h.length > 2 && u.push(h), u;
  }
  function t3e(l3, r3, e3, u, h, v4, m3, x3, C, A2) {
    if (ej(l3, e3) && ej(r3, u) && ej(h, m3) && ej(v4, x3)) {
      C.push(m3, x3);
      return;
    }
    var D = 2 / A2, P = D * D, N = m3 - l3, j = x3 - r3, W = Math.sqrt(N * N + j * j);
    N /= W, j /= W;
    var K = e3 - l3, te = u - r3, ne = h - m3, ce = v4 - x3, me = K * K + te * te, ve = ne * ne + ce * ce;
    if (me < P && ve < P) {
      C.push(m3, x3);
      return;
    }
    var Be = N * K + j * te, Oe = -N * ne - j * ce, We = me - Be * Be, Ue = ve - Oe * Oe;
    if (We < P && Be >= 0 && Ue < P && Oe >= 0) {
      C.push(m3, x3);
      return;
    }
    var qe = [], Ze = [];
    ZO(l3, e3, h, m3, 0.5, qe), ZO(r3, u, v4, x3, 0.5, Ze), t3e(qe[0], Ze[0], qe[1], Ze[1], qe[2], Ze[2], qe[3], Ze[3], C, A2), t3e(qe[4], Ze[4], qe[5], Ze[5], qe[6], Ze[6], qe[7], Ze[7], C, A2);
  }
  function HIn(l3, r3) {
    var e3 = e3e(l3), u = [];
    r3 = r3 || 1;
    for (var h = 0; h < e3.length; h++) {
      var v4 = e3[h], m3 = [], x3 = v4[0], C = v4[1];
      m3.push(x3, C);
      for (var A2 = 2; A2 < v4.length; ) {
        var D = v4[A2++], P = v4[A2++], N = v4[A2++], j = v4[A2++], W = v4[A2++], K = v4[A2++];
        t3e(x3, C, D, P, N, j, W, K, m3, r3), x3 = W, C = K;
      }
      u.push(m3);
    }
    return u;
  }
  function Dvt(l3, r3, e3) {
    var u = l3[r3], h = l3[1 - r3], v4 = Math.abs(u / h), m3 = Math.ceil(Math.sqrt(v4 * e3)), x3 = Math.floor(e3 / m3);
    x3 === 0 && (x3 = 1, m3 = e3);
    for (var C = [], A2 = 0; A2 < m3; A2++)
      C.push(x3);
    var D = m3 * x3, P = e3 - D;
    if (P > 0)
      for (var A2 = 0; A2 < P; A2++)
        C[A2 % m3] += 1;
    return C;
  }
  function Vst(l3, r3, e3) {
    for (var u = l3.r0, h = l3.r, v4 = l3.startAngle, m3 = l3.endAngle, x3 = Math.abs(m3 - v4), C = x3 * h, A2 = h - u, D = C > Math.abs(A2), P = Dvt([C, A2], D ? 0 : 1, r3), N = (D ? x3 : A2) / P.length, j = 0; j < P.length; j++)
      for (var W = (D ? A2 : x3) / P[j], K = 0; K < P[j]; K++) {
        var te = {};
        D ? (te.startAngle = v4 + N * j, te.endAngle = v4 + N * (j + 1), te.r0 = u + W * K, te.r = u + W * (K + 1)) : (te.startAngle = v4 + W * K, te.endAngle = v4 + W * (K + 1), te.r0 = u + N * j, te.r = u + N * (j + 1)), te.clockwise = l3.clockwise, te.cx = l3.cx, te.cy = l3.cy, e3.push(te);
      }
  }
  function WIn(l3, r3, e3) {
    for (var u = l3.width, h = l3.height, v4 = u > h, m3 = Dvt([u, h], v4 ? 0 : 1, r3), x3 = v4 ? "width" : "height", C = v4 ? "height" : "width", A2 = v4 ? "x" : "y", D = v4 ? "y" : "x", P = l3[x3] / m3.length, N = 0; N < m3.length; N++)
      for (var j = l3[C] / m3[N], W = 0; W < m3[N]; W++) {
        var K = {};
        K[A2] = N * P, K[D] = W * j, K[x3] = P, K[C] = j, K.x += l3.x, K.y += l3.y, e3.push(K);
      }
  }
  function Bst(l3, r3, e3, u) {
    return l3 * u - e3 * r3;
  }
  function UIn(l3, r3, e3, u, h, v4, m3, x3) {
    var C = e3 - l3, A2 = u - r3, D = m3 - h, P = x3 - v4, N = Bst(D, P, C, A2);
    if (Math.abs(N) < 1e-6)
      return null;
    var j = l3 - h, W = r3 - v4, K = Bst(j, W, D, P) / N;
    return K < 0 || K > 1 ? null : new nl(K * C + l3, K * A2 + r3);
  }
  function qIn(l3, r3, e3) {
    var u = new nl();
    nl.sub(u, e3, r3), u.normalize();
    var h = new nl();
    nl.sub(h, l3, r3);
    var v4 = h.dot(u);
    return v4;
  }
  function zz(l3, r3) {
    var e3 = l3[l3.length - 1];
    e3 && e3[0] === r3[0] && e3[1] === r3[1] || l3.push(r3);
  }
  function $In(l3, r3, e3) {
    for (var u = l3.length, h = [], v4 = 0; v4 < u; v4++) {
      var m3 = l3[v4], x3 = l3[(v4 + 1) % u], C = UIn(m3[0], m3[1], x3[0], x3[1], r3.x, r3.y, e3.x, e3.y);
      C && h.push({ projPt: qIn(C, r3, e3), pt: C, idx: v4 });
    }
    if (h.length < 2)
      return [{ points: l3 }, { points: l3 }];
    h.sort(function(te, ne) {
      return te.projPt - ne.projPt;
    });
    var A2 = h[0], D = h[h.length - 1];
    if (D.idx < A2.idx) {
      var P = A2;
      A2 = D, D = P;
    }
    for (var N = [A2.pt.x, A2.pt.y], j = [D.pt.x, D.pt.y], W = [N], K = [j], v4 = A2.idx + 1; v4 <= D.idx; v4++)
      zz(W, l3[v4].slice());
    zz(W, j), zz(W, N);
    for (var v4 = D.idx + 1; v4 <= A2.idx + u; v4++)
      zz(K, l3[v4 % u].slice());
    return zz(K, N), zz(K, j), [{ points: W }, { points: K }];
  }
  function zst(l3) {
    var r3 = l3.points, e3 = [], u = [];
    qhe(r3, e3, u);
    var h = new Ml(e3[0], e3[1], u[0] - e3[0], u[1] - e3[1]), v4 = h.width, m3 = h.height, x3 = h.x, C = h.y, A2 = new nl(), D = new nl();
    return v4 > m3 ? (A2.x = D.x = x3 + v4 / 2, A2.y = C, D.y = C + m3) : (A2.y = D.y = C + m3 / 2, A2.x = x3, D.x = x3 + v4), $In(r3, A2, D);
  }
  function Ihe(l3, r3, e3, u) {
    if (e3 === 1)
      u.push(r3);
    else {
      var h = Math.floor(e3 / 2), v4 = l3(r3);
      Ihe(l3, v4[0], h, u), Ihe(l3, v4[1], e3 - h, u);
    }
    return u;
  }
  function XIn(l3, r3) {
    for (var e3 = [], u = 0; u < r3; u++)
      e3.push(W3e(l3));
    return e3;
  }
  function YIn(l3, r3) {
    r3.setStyle(l3.style), r3.z = l3.z, r3.z2 = l3.z2, r3.zlevel = l3.zlevel;
  }
  function KIn(l3) {
    for (var r3 = [], e3 = 0; e3 < l3.length; )
      r3.push([l3[e3++], l3[e3++]]);
    return r3;
  }
  function ZIn(l3, r3) {
    var e3 = [], u = l3.shape, h;
    switch (l3.type) {
      case "rect":
        WIn(u, r3, e3), h = Ju;
        break;
      case "sector":
        Vst(u, r3, e3), h = S_;
        break;
      case "circle":
        Vst({ r0: 0, r: u.r, startAngle: 0, endAngle: Math.PI * 2, cx: u.cx, cy: u.cy }, r3, e3), h = S_;
        break;
      default:
        var v4 = l3.getComputedTransform(), m3 = v4 ? Math.sqrt(Math.max(v4[0] * v4[0] + v4[1] * v4[1], v4[2] * v4[2] + v4[3] * v4[3])) : 1, x3 = Bi(HIn(l3.getUpdatedPathProxy(), m3), function(ne) {
          return KIn(ne);
        }), C = x3.length;
        if (C === 0)
          Ihe(zst, { points: x3[0] }, r3, e3);
        else if (C === r3)
          for (var A2 = 0; A2 < C; A2++)
            e3.push({ points: x3[A2] });
        else {
          var D = 0, P = Bi(x3, function(ne) {
            var ce = [], me = [];
            qhe(ne, ce, me);
            var ve = (me[1] - ce[1]) * (me[0] - ce[0]);
            return D += ve, { poly: ne, area: ve };
          });
          P.sort(function(ne, ce) {
            return ce.area - ne.area;
          });
          for (var N = r3, A2 = 0; A2 < C; A2++) {
            var j = P[A2];
            if (N <= 0)
              break;
            var W = A2 === C - 1 ? N : Math.ceil(j.area / D * r3);
            W < 0 || (Ihe(zst, { points: j.poly }, W, e3), N -= W);
          }
        }
        h = C_;
        break;
    }
    if (!h)
      return XIn(l3, r3);
    for (var K = [], A2 = 0; A2 < e3.length; A2++) {
      var te = new h();
      te.setShape(e3[A2]), YIn(l3, te), K.push(te);
    }
    return K;
  }
  function JIn(l3, r3) {
    var e3 = l3.length, u = r3.length;
    if (e3 === u)
      return [l3, r3];
    for (var h = [], v4 = [], m3 = e3 < u ? l3 : r3, x3 = Math.min(e3, u), C = Math.abs(u - e3) / 6, A2 = (x3 - 2) / 6, D = Math.ceil(C / A2) + 1, P = [m3[0], m3[1]], N = C, j = 2; j < x3; ) {
      var W = m3[j - 2], K = m3[j - 1], te = m3[j++], ne = m3[j++], ce = m3[j++], me = m3[j++], ve = m3[j++], Be = m3[j++];
      if (N <= 0) {
        P.push(te, ne, ce, me, ve, Be);
        continue;
      }
      for (var Oe = Math.min(N, D - 1) + 1, We = 1; We <= Oe; We++) {
        var Ue = We / Oe;
        ZO(W, te, ce, ve, Ue, h), ZO(K, ne, me, Be, Ue, v4), W = h[3], K = v4[3], P.push(h[1], v4[1], h[2], v4[2], W, K), te = h[5], ne = v4[5], ce = h[6], me = v4[6];
      }
      N -= Oe - 1;
    }
    return m3 === l3 ? [P, r3] : [l3, P];
  }
  function jst(l3, r3) {
    for (var e3 = l3.length, u = l3[e3 - 2], h = l3[e3 - 1], v4 = [], m3 = 0; m3 < r3.length; )
      v4[m3++] = u, v4[m3++] = h;
    return v4;
  }
  function QIn(l3, r3) {
    for (var e3, u, h, v4 = [], m3 = [], x3 = 0; x3 < Math.max(l3.length, r3.length); x3++) {
      var C = l3[x3], A2 = r3[x3], D = void 0, P = void 0;
      C ? A2 ? (e3 = JIn(C, A2), D = e3[0], P = e3[1], u = D, h = P) : (P = jst(h || C, C), D = C) : (D = jst(u || A2, A2), P = A2), v4.push(D), m3.push(P);
    }
    return [v4, m3];
  }
  function Gst(l3) {
    for (var r3 = 0, e3 = 0, u = 0, h = l3.length, v4 = 0, m3 = h - 2; v4 < h; m3 = v4, v4 += 2) {
      var x3 = l3[m3], C = l3[m3 + 1], A2 = l3[v4], D = l3[v4 + 1], P = x3 * D - A2 * C;
      r3 += P, e3 += (x3 + A2) * P, u += (C + D) * P;
    }
    return r3 === 0 ? [l3[0] || 0, l3[1] || 0] : [e3 / r3 / 3, u / r3 / 3, r3];
  }
  function eEn(l3, r3, e3, u) {
    for (var h = (l3.length - 2) / 6, v4 = 1 / 0, m3 = 0, x3 = l3.length, C = x3 - 2, A2 = 0; A2 < h; A2++) {
      for (var D = A2 * 6, P = 0, N = 0; N < x3; N += 2) {
        var j = N === 0 ? D : (D + N - 2) % C + 2, W = l3[j] - e3[0], K = l3[j + 1] - e3[1], te = r3[N] - u[0], ne = r3[N + 1] - u[1], ce = te - W, me = ne - K;
        P += ce * ce + me * me;
      }
      P < v4 && (v4 = P, m3 = A2);
    }
    return m3;
  }
  function tEn(l3) {
    for (var r3 = [], e3 = l3.length, u = 0; u < e3; u += 2)
      r3[u] = l3[e3 - u - 2], r3[u + 1] = l3[e3 - u - 1];
    return r3;
  }
  function nEn(l3, r3, e3, u) {
    for (var h = [], v4, m3 = 0; m3 < l3.length; m3++) {
      var x3 = l3[m3], C = r3[m3], A2 = Gst(x3), D = Gst(C);
      v4 == null && (v4 = A2[2] < 0 != D[2] < 0);
      var P = [], N = [], j = 0, W = 1 / 0, K = [], te = x3.length;
      v4 && (x3 = tEn(x3));
      for (var ne = eEn(x3, C, A2, D) * 6, ce = te - 2, me = 0; me < ce; me += 2) {
        var ve = (ne + me) % ce + 2;
        P[me + 2] = x3[ve] - A2[0], P[me + 3] = x3[ve + 1] - A2[1];
      }
      if (P[0] = x3[ne] - A2[0], P[1] = x3[ne + 1] - A2[1], e3 > 0)
        for (var Be = u / e3, Oe = -u / 2; Oe <= u / 2; Oe += Be) {
          for (var We = Math.sin(Oe), Ue = Math.cos(Oe), qe = 0, me = 0; me < x3.length; me += 2) {
            var Ze = P[me], ct = P[me + 1], _t = C[me] - D[0], pt = C[me + 1] - D[1], zt = _t * Ue - pt * We, Zt = _t * We + pt * Ue;
            K[me] = zt, K[me + 1] = Zt;
            var Ft = zt - Ze, Kn = Zt - ct;
            qe += Ft * Ft + Kn * Kn;
          }
          if (qe < W) {
            W = qe, j = Oe;
            for (var hn = 0; hn < K.length; hn++)
              N[hn] = K[hn];
          }
        }
      else
        for (var xn = 0; xn < te; xn += 2)
          N[xn] = C[xn] - D[0], N[xn + 1] = C[xn + 1] - D[1];
      h.push({ from: P, to: N, fromCp: A2, toCp: D, rotation: -j });
    }
    return h;
  }
  function Ehe(l3) {
    return l3.__isCombineMorphing;
  }
  var kvt = "__mOriginal_";
  function Dhe(l3, r3, e3) {
    var u = kvt + r3, h = l3[u] || l3[r3];
    l3[u] || (l3[u] = l3[r3]);
    var v4 = e3.replace, m3 = e3.after, x3 = e3.before;
    l3[r3] = function() {
      var C = arguments, A2;
      return x3 && x3.apply(this, C), v4 ? A2 = v4.apply(this, C) : A2 = h.apply(this, C), m3 && m3.apply(this, C), A2;
    };
  }
  function $Z(l3, r3) {
    var e3 = kvt + r3;
    l3[e3] && (l3[r3] = l3[e3], l3[e3] = null);
  }
  function Hst(l3, r3) {
    for (var e3 = 0; e3 < l3.length; e3++)
      for (var u = l3[e3], h = 0; h < u.length; ) {
        var v4 = u[h], m3 = u[h + 1];
        u[h++] = r3[0] * v4 + r3[2] * m3 + r3[4], u[h++] = r3[1] * v4 + r3[3] * m3 + r3[5];
      }
  }
  function Ovt(l3, r3) {
    var e3 = l3.getUpdatedPathProxy(), u = r3.getUpdatedPathProxy(), h = QIn(e3e(e3), e3e(u)), v4 = h[0], m3 = h[1], x3 = l3.getComputedTransform(), C = r3.getComputedTransform();
    function A2() {
      this.transform = null;
    }
    x3 && Hst(v4, x3), C && Hst(m3, C), Dhe(r3, "updateTransform", { replace: A2 }), r3.transform = null;
    var D = nEn(v4, m3, 10, Math.PI), P = [];
    Dhe(r3, "buildPath", { replace: function(N) {
      for (var j = r3.__morphT, W = 1 - j, K = [], te = 0; te < D.length; te++) {
        var ne = D[te], ce = ne.from, me = ne.to, ve = ne.rotation * j, Be = ne.fromCp, Oe = ne.toCp, We = Math.sin(ve), Ue = Math.cos(ve);
        gfe(K, Be, Oe, j);
        for (var qe = 0; qe < ce.length; qe += 2) {
          var Ze = ce[qe], ct = ce[qe + 1], _t = me[qe], pt = me[qe + 1], zt = Ze * W + _t * j, Zt = ct * W + pt * j;
          P[qe] = zt * Ue - Zt * We + K[0], P[qe + 1] = zt * We + Zt * Ue + K[1];
        }
        var Ft = P[0], Kn = P[1];
        N.moveTo(Ft, Kn);
        for (var qe = 2; qe < ce.length; ) {
          var _t = P[qe++], pt = P[qe++], hn = P[qe++], xn = P[qe++], zn = P[qe++], or = P[qe++];
          Ft === _t && Kn === pt && hn === zn && xn === or ? N.lineTo(zn, or) : N.bezierCurveTo(_t, pt, hn, xn, zn, or), Ft = zn, Kn = or;
        }
      }
    } });
  }
  function TPe(l3, r3, e3) {
    if (!l3 || !r3)
      return r3;
    var u = e3.done, h = e3.during;
    Ovt(l3, r3), r3.__morphT = 0;
    function v4() {
      $Z(r3, "buildPath"), $Z(r3, "updateTransform"), r3.__morphT = -1, r3.createPathProxy(), r3.dirtyShape();
    }
    return r3.animateTo({ __morphT: 1 }, ns({ during: function(m3) {
      r3.dirtyShape(), h && h(m3);
    }, done: function() {
      v4(), u && u();
    } }, e3)), r3;
  }
  function rEn(l3, r3, e3, u, h, v4) {
    var m3 = 16;
    l3 = h === e3 ? 0 : Math.round(32767 * (l3 - e3) / (h - e3)), r3 = v4 === u ? 0 : Math.round(32767 * (r3 - u) / (v4 - u));
    for (var x3 = 0, C, A2 = (1 << m3) / 2; A2 > 0; A2 /= 2) {
      var D = 0, P = 0;
      (l3 & A2) > 0 && (D = 1), (r3 & A2) > 0 && (P = 1), x3 += A2 * A2 * (3 * D ^ P), P === 0 && (D === 1 && (l3 = A2 - 1 - l3, r3 = A2 - 1 - r3), C = l3, l3 = r3, r3 = C);
    }
    return x3;
  }
  function khe(l3) {
    var r3 = 1 / 0, e3 = 1 / 0, u = -1 / 0, h = -1 / 0, v4 = Bi(l3, function(x3) {
      var C = x3.getBoundingRect(), A2 = x3.getComputedTransform(), D = C.x + C.width / 2 + (A2 ? A2[4] : 0), P = C.y + C.height / 2 + (A2 ? A2[5] : 0);
      return r3 = Math.min(D, r3), e3 = Math.min(P, e3), u = Math.max(D, u), h = Math.max(P, h), [D, P];
    }), m3 = Bi(v4, function(x3, C) {
      return { cp: x3, z: rEn(x3[0], x3[1], r3, e3, u, h), path: l3[C] };
    });
    return m3.sort(function(x3, C) {
      return x3.z - C.z;
    }).map(function(x3) {
      return x3.path;
    });
  }
  function Pvt(l3) {
    return ZIn(l3.path, l3.count);
  }
  function n3e() {
    return { fromIndividuals: [], toIndividuals: [], count: 0 };
  }
  function iEn(l3, r3, e3) {
    var u = [];
    function h(Be) {
      for (var Oe = 0; Oe < Be.length; Oe++) {
        var We = Be[Oe];
        Ehe(We) ? h(We.childrenRef()) : We instanceof Nl && u.push(We);
      }
    }
    h(l3);
    var v4 = u.length;
    if (!v4)
      return n3e();
    var m3 = e3.dividePath || Pvt, x3 = m3({ path: r3, count: v4 });
    if (x3.length !== v4)
      return console.error("Invalid morphing: unmatched splitted path"), n3e();
    u = khe(u), x3 = khe(x3);
    for (var C = e3.done, A2 = e3.during, D = e3.individualDelay, P = new QD(), N = 0; N < v4; N++) {
      var j = u[N], W = x3[N];
      W.parent = r3, W.copyTransform(P), D || Ovt(j, W);
    }
    r3.__isCombineMorphing = true, r3.childrenRef = function() {
      return x3;
    };
    function K(Be) {
      for (var Oe = 0; Oe < x3.length; Oe++)
        x3[Oe].addSelfToZr(Be);
    }
    Dhe(r3, "addSelfToZr", { after: function(Be) {
      K(Be);
    } }), Dhe(r3, "removeSelfFromZr", { after: function(Be) {
      for (var Oe = 0; Oe < x3.length; Oe++)
        x3[Oe].removeSelfFromZr(Be);
    } });
    function te() {
      r3.__isCombineMorphing = false, r3.__morphT = -1, r3.childrenRef = null, $Z(r3, "addSelfToZr"), $Z(r3, "removeSelfFromZr");
    }
    var ne = x3.length;
    if (D)
      for (var ce = ne, me = function() {
        ce--, ce === 0 && (te(), C && C());
      }, N = 0; N < ne; N++) {
        var ve = D ? ns({ delay: (e3.delay || 0) + D(N, ne, u[N], x3[N]), done: me }, e3) : e3;
        TPe(u[N], x3[N], ve);
      }
    else
      r3.__morphT = 0, r3.animateTo({ __morphT: 1 }, ns({ during: function(Be) {
        for (var Oe = 0; Oe < ne; Oe++) {
          var We = x3[Oe];
          We.__morphT = r3.__morphT, We.dirtyShape();
        }
        A2 && A2(Be);
      }, done: function() {
        te();
        for (var Be = 0; Be < l3.length; Be++)
          $Z(l3[Be], "updateTransform");
        C && C();
      } }, e3));
    return r3.__zr && K(r3.__zr), { fromIndividuals: u, toIndividuals: x3, count: ne };
  }
  function aEn(l3, r3, e3) {
    var u = r3.length, h = [], v4 = e3.dividePath || Pvt;
    function m3(j) {
      for (var W = 0; W < j.length; W++) {
        var K = j[W];
        Ehe(K) ? m3(K.childrenRef()) : K instanceof Nl && h.push(K);
      }
    }
    if (Ehe(l3)) {
      m3(l3.childrenRef());
      var x3 = h.length;
      if (x3 < u)
        for (var C = 0, A2 = x3; A2 < u; A2++)
          h.push(W3e(h[C++ % x3]));
      h.length = u;
    } else {
      h = v4({ path: l3, count: u });
      for (var D = l3.getComputedTransform(), A2 = 0; A2 < h.length; A2++)
        h[A2].setLocalTransform(D);
      if (h.length !== u)
        return console.error("Invalid morphing: unmatched splitted path"), n3e();
    }
    h = khe(h), r3 = khe(r3);
    for (var P = e3.individualDelay, A2 = 0; A2 < u; A2++) {
      var N = P ? ns({ delay: (e3.delay || 0) + P(A2, u, h[A2], r3[A2]) }, e3) : e3;
      TPe(h[A2], r3[A2], N);
    }
    return { fromIndividuals: h, toIndividuals: r3, count: r3.length };
  }
  function Wst(l3) {
    return Ni(l3[0]);
  }
  function Ust(l3, r3) {
    for (var e3 = [], u = l3.length, h = 0; h < u; h++)
      e3.push({ one: l3[h], many: [] });
    for (var h = 0; h < r3.length; h++) {
      var v4 = r3[h].length, m3 = void 0;
      for (m3 = 0; m3 < v4; m3++)
        e3[m3 % u].many.push(r3[h][m3]);
    }
    for (var x3 = 0, h = u - 1; h >= 0; h--)
      if (!e3[h].many.length) {
        var C = e3[x3].many;
        if (C.length <= 1)
          if (x3)
            x3 = 0;
          else
            return e3;
        var v4 = C.length, A2 = Math.ceil(v4 / 2);
        e3[h].many = C.slice(A2, v4), e3[x3].many = C.slice(0, A2), x3++;
      }
    return e3;
  }
  var oEn = { clone: function(l3) {
    for (var r3 = [], e3 = 1 - Math.pow(1 - l3.path.style.opacity, 1 / l3.count), u = 0; u < l3.count; u++) {
      var h = W3e(l3.path);
      h.setStyle("opacity", e3), r3.push(h);
    }
    return r3;
  }, split: null };
  function r5e(l3, r3, e3, u, h, v4) {
    if (!l3.length || !r3.length)
      return;
    var m3 = Sj("update", u, h);
    if (!(m3 && m3.duration > 0))
      return;
    var x3 = u.getModel("universalTransition").get("delay"), C = Object.assign({ setToFinal: true }, m3), A2, D;
    Wst(l3) && (A2 = l3, D = r3), Wst(r3) && (A2 = r3, D = l3);
    function P(ne, ce, me, ve, Be) {
      var Oe = ne.many, We = ne.one;
      if (Oe.length === 1 && !Be) {
        var Ue = ce ? Oe[0] : We, qe = ce ? We : Oe[0];
        if (Ehe(Ue))
          P({ many: [Ue], one: qe }, true, me, ve, true);
        else {
          var Ze = x3 ? ns({ delay: x3(me, ve) }, C) : C;
          TPe(Ue, qe, Ze), v4(Ue, qe, Ue, qe, Ze);
        }
      } else
        for (var ct = ns({ dividePath: oEn[e3], individualDelay: x3 && function(Kn, hn, xn, zn) {
          return x3(Kn + me, ve);
        } }, C), _t = ce ? iEn(Oe, We, ct) : aEn(We, Oe, ct), pt = _t.fromIndividuals, zt = _t.toIndividuals, Zt = pt.length, Ft = 0; Ft < Zt; Ft++) {
          var Ze = x3 ? ns({ delay: x3(Ft, Zt) }, C) : C;
          v4(pt[Ft], zt[Ft], ce ? Oe[Ft] : ne.one, ce ? ne.one : Oe[Ft], Ze);
        }
    }
    for (var N = A2 ? A2 === l3 : l3.length > r3.length, j = A2 ? Ust(D, A2) : Ust(N ? r3 : l3, [N ? l3 : r3]), W = 0, K = 0; K < j.length; K++)
      W += j[K].many.length;
    for (var te = 0, K = 0; K < j.length; K++)
      P(j[K], N, te, W), te += j[K].many.length;
  }
  function wN(l3) {
    if (!l3)
      return [];
    if (Ni(l3)) {
      for (var r3 = [], e3 = 0; e3 < l3.length; e3++)
        r3.push(wN(l3[e3]));
      return r3;
    }
    var u = [];
    return l3.traverse(function(h) {
      h instanceof Nl && !h.disableMorphing && !h.invisible && !h.ignore && u.push(h);
    }), u;
  }
  var Lvt = 1e4, sEn = pc();
  function lEn(l3) {
    for (var r3 = l3.dimensions, e3 = 0; e3 < r3.length; e3++) {
      var u = l3.getDimensionInfo(r3[e3]);
      if (u && u.otherDims.itemGroupId === 0)
        return r3[e3];
    }
  }
  function qst(l3) {
    var r3 = [];
    return mt(l3, function(e3) {
      var u = e3.data;
      if (!(u.count() > Lvt))
        for (var h = u.getIndices(), v4 = lEn(u), m3 = 0; m3 < h.length; m3++)
          r3.push({ data: u, dim: e3.dim || v4, divide: e3.divide, dataIndex: m3 });
    }), r3;
  }
  function i5e(l3, r3, e3) {
    l3.traverse(function(u) {
      u instanceof Nl && Np(u, { style: { opacity: 0 } }, r3, { dataIndex: e3, isFrom: true });
    });
  }
  function a5e(l3) {
    if (l3.parent) {
      var r3 = l3.getComputedTransform();
      l3.setLocalTransform(r3), l3.parent.remove(l3);
    }
  }
  function jz(l3) {
    l3.stopAnimation(), l3.isGroup && l3.traverse(function(r3) {
      r3.stopAnimation();
    });
  }
  function uEn(l3, r3, e3) {
    var u = Sj("update", e3, r3);
    u && l3.traverse(function(h) {
      if (h instanceof x2) {
        var v4 = Hcn(h);
        v4 && h.animateFrom({ style: v4 }, u);
      }
    });
  }
  function cEn(l3, r3) {
    var e3 = l3.length;
    if (e3 !== r3.length)
      return false;
    for (var u = 0; u < e3; u++) {
      var h = l3[u], v4 = r3[u];
      if (h.data.getId(h.dataIndex) !== v4.data.getId(v4.dataIndex))
        return false;
    }
    return true;
  }
  function Rvt(l3, r3, e3) {
    var u = qst(l3), h = qst(r3);
    function v4(ne, ce, me, ve, Be) {
      (me || ne) && ce.animateFrom({ style: me && me !== ne ? fi(fi({}, me.style), ne.style) : ne.style }, Be);
    }
    function m3(ne) {
      for (var ce = 0; ce < ne.length; ce++)
        if (ne[ce].dim)
          return ne[ce].dim;
    }
    var x3 = m3(u), C = m3(h), A2 = false;
    function D(ne, ce) {
      return function(me) {
        var ve = me.data, Be = me.dataIndex;
        if (ce)
          return ve.getId(Be);
        var Oe = ve.hostModel && ve.hostModel.get("dataGroupId"), We = ne ? x3 || C : C || x3, Ue = We && ve.getDimensionInfo(We), qe = Ue && Ue.ordinalMeta;
        if (Ue) {
          var Ze = ve.get(Ue.name, Be);
          return qe && qe.categories[Ze] || Ze + "";
        }
        var ct = ve.getRawDataItem(Be);
        return ct && ct.groupId ? ct.groupId + "" : Oe || ve.getId(Be);
      };
    }
    var P = cEn(u, h), N = {};
    if (!P)
      for (var j = 0; j < h.length; j++) {
        var W = h[j], K = W.data.getItemGraphicEl(W.dataIndex);
        K && (N[K.id] = true);
      }
    function te(ne, ce) {
      var me = u[ce], ve = h[ne], Be = ve.data.hostModel, Oe = me.data.getItemGraphicEl(me.dataIndex), We = ve.data.getItemGraphicEl(ve.dataIndex);
      if (Oe === We) {
        We && uEn(We, ve.dataIndex, Be);
        return;
      }
      Oe && N[Oe.id] || We && (jz(We), Oe ? (jz(Oe), a5e(Oe), A2 = true, r5e(wN(Oe), wN(We), ve.divide, Be, ne, v4)) : i5e(We, Be, ne));
    }
    new f5(u, h, D(true, P), D(false, P), null, "multiple").update(te).updateManyToOne(function(ne, ce) {
      var me = h[ne], ve = me.data, Be = ve.hostModel, Oe = ve.getItemGraphicEl(me.dataIndex), We = jf(Bi(ce, function(Ue) {
        return u[Ue].data.getItemGraphicEl(u[Ue].dataIndex);
      }), function(Ue) {
        return Ue && Ue !== Oe && !N[Ue.id];
      });
      Oe && (jz(Oe), We.length ? (mt(We, function(Ue) {
        jz(Ue), a5e(Ue);
      }), A2 = true, r5e(wN(We), wN(Oe), me.divide, Be, ne, v4)) : i5e(Oe, Be, me.dataIndex));
    }).updateOneToMany(function(ne, ce) {
      var me = u[ce], ve = me.data.getItemGraphicEl(me.dataIndex);
      if (!(ve && N[ve.id])) {
        var Be = jf(Bi(ne, function(We) {
          return h[We].data.getItemGraphicEl(h[We].dataIndex);
        }), function(We) {
          return We && We !== ve;
        }), Oe = h[ne[0]].data.hostModel;
        Be.length && (mt(Be, function(We) {
          return jz(We);
        }), ve ? (jz(ve), a5e(ve), A2 = true, r5e(wN(ve), wN(Be), me.divide, Oe, ne[0], v4)) : mt(Be, function(We) {
          return i5e(We, Oe, ne[0]);
        }));
      }
    }).updateManyToMany(function(ne, ce) {
      new f5(ce, ne, function(me) {
        return u[me].data.getId(u[me].dataIndex);
      }, function(me) {
        return h[me].data.getId(h[me].dataIndex);
      }).update(function(me, ve) {
        te(ne[me], ce[ve]);
      }).execute();
    }).execute(), A2 && mt(r3, function(ne) {
      var ce = ne.data, me = ce.hostModel, ve = me && e3.getViewOfSeriesModel(me), Be = Sj("update", me, 0);
      ve && me.isAnimationEnabled() && Be && Be.duration > 0 && ve.group.traverse(function(Oe) {
        Oe instanceof Nl && !Oe.animators.length && Oe.animateFrom({ style: { opacity: 0 } }, Be);
      });
    });
  }
  function $st(l3) {
    var r3 = l3.getModel("universalTransition").get("seriesKey");
    return r3 || l3.id;
  }
  function Xst(l3) {
    return Ni(l3) ? l3.sort().join(",") : l3;
  }
  function LO(l3) {
    if (l3.hostModel)
      return l3.hostModel.getModel("universalTransition").get("divideShape");
  }
  function fEn(l3, r3) {
    var e3 = Ho(), u = Ho(), h = Ho();
    return mt(l3.oldSeries, function(v4, m3) {
      var x3 = l3.oldData[m3], C = $st(v4), A2 = Xst(C);
      u.set(A2, x3), Ni(C) && mt(C, function(D) {
        h.set(D, { data: x3, key: A2 });
      });
    }), mt(r3.updatedSeries, function(v4) {
      if (v4.isUniversalTransitionEnabled() && v4.isAnimationEnabled()) {
        var m3 = v4.getData(), x3 = $st(v4), C = Xst(x3), A2 = u.get(C);
        if (A2)
          e3.set(C, { oldSeries: [{ divide: LO(A2), data: A2 }], newSeries: [{ divide: LO(m3), data: m3 }] });
        else if (Ni(x3)) {
          var D = [];
          mt(x3, function(j) {
            var W = u.get(j);
            W && D.push({ divide: LO(W), data: W });
          }), D.length && e3.set(C, { oldSeries: D, newSeries: [{ data: m3, divide: LO(m3) }] });
        } else {
          var P = h.get(x3);
          if (P) {
            var N = e3.get(P.key);
            N || (N = { oldSeries: [{ data: P.data, divide: LO(P.data) }], newSeries: [] }, e3.set(P.key, N)), N.newSeries.push({ data: m3, divide: LO(m3) });
          }
        }
      }
    }), e3;
  }
  function Yst(l3, r3) {
    for (var e3 = 0; e3 < l3.length; e3++) {
      var u = r3.seriesIndex != null && r3.seriesIndex === l3[e3].seriesIndex || r3.seriesId != null && r3.seriesId === l3[e3].id;
      if (u)
        return e3;
    }
  }
  function hEn(l3, r3, e3, u) {
    var h = [], v4 = [];
    mt(Gf(l3.from), function(m3) {
      var x3 = Yst(r3.oldSeries, m3);
      x3 >= 0 && h.push({ data: r3.oldData[x3], divide: LO(r3.oldData[x3]), dim: m3.dimension });
    }), mt(Gf(l3.to), function(m3) {
      var x3 = Yst(e3.updatedSeries, m3);
      if (x3 >= 0) {
        var C = e3.updatedSeries[x3].getData();
        v4.push({ data: C, divide: LO(C), dim: m3.dimension });
      }
    }), h.length > 0 && v4.length > 0 && Rvt(h, v4, u);
  }
  function pEn(l3) {
    l3.registerUpdateLifecycle("series:beforeupdate", function(r3, e3, u) {
      mt(Gf(u.seriesTransition), function(h) {
        mt(Gf(h.to), function(v4) {
          for (var m3 = u.updatedSeries, x3 = 0; x3 < m3.length; x3++)
            (v4.seriesIndex != null && v4.seriesIndex === m3[x3].seriesIndex || v4.seriesId != null && v4.seriesId === m3[x3].id) && (m3[x3][Ife] = true);
        });
      });
    }), l3.registerUpdateLifecycle("series:transition", function(r3, e3, u) {
      var h = sEn(e3);
      if (h.oldSeries && u.updatedSeries && u.optionChanged) {
        var v4 = u.seriesTransition;
        if (v4)
          mt(Gf(v4), function(N) {
            hEn(N, h, u, e3);
          });
        else {
          var m3 = fEn(h, u);
          mt(m3.keys(), function(N) {
            var j = m3.get(N);
            Rvt(j.oldSeries, j.newSeries, e3);
          });
        }
        mt(u.updatedSeries, function(N) {
          N[Ife] && (N[Ife] = false);
        });
      }
      for (var x3 = r3.getSeries(), C = h.oldSeries = [], A2 = h.oldData = [], D = 0; D < x3.length; D++) {
        var P = x3[D].getData();
        P.count() < Lvt && (C.push(x3[D]), A2.push(P));
      }
    });
  }
  kl([kgn]);
  kl([Cgn]);
  kl([t0n, b0n, k0n, byn, Nyn, Dmn, s1n, $1n, xbn, Dbn, jbn, U_n, mxn, Oxn, Zxn, iwn, wwn, Own, Uwn, Qwn, hSn, KSn]);
  kl(b2n);
  kl(Q2n);
  kl(Ept);
  kl(gCn);
  kl(gdt);
  kl(SCn);
  kl(OCn);
  kl(PMn);
  kl(nTn);
  kl(KJ);
  kl(wTn);
  kl(MTn);
  kl(zTn);
  kl(KTn);
  kl(iAn);
  kl(hAn);
  kl(TAn);
  kl(XAn);
  kl(xvt);
  kl(wvt);
  kl(xIn);
  kl(Avt);
  kl(Ivt);
  kl(TIn);
  kl(BIn);
  kl(GIn);
  kl(pEn);
  kl(Hvn);
  function dEn(l3) {
    const { defaultOptions: r3 } = l3 != null ? l3 : {}, e3 = Nc.useRef(null), u = Nc.useRef(), h = Nc.useRef(r3);
    return Nc.useEffect(() => {
      if (!e3.current)
        return;
      const v4 = adn(e3.current);
      u.current = v4, h.current && v4.setOption(h.current);
    }, []), Nc.useEffect(() => () => {
      var v4, m3, x3, C;
      (m3 = (v4 = u.current) == null ? void 0 : v4.dispose) == null || m3.call(v4), (C = (x3 = u.current) == null ? void 0 : x3.off) == null || C.call(x3, "*"), u.current = void 0;
    }, []), Hon("resize", () => {
      requestAnimationFrame(() => {
        var v4, m3;
        (m3 = (v4 = u == null ? void 0 : u.current) == null ? void 0 : v4.resize) == null || m3.call(v4);
      });
    }), { chart: u, container: e3 };
  }
  class vEn {
    constructor() {
      y_(this, "chartsEmitters", /* @__PURE__ */ new Map());
      y_(this, "add", (r3, e3, u, h) => {
        e3 && u ? this.chartsEmitters.set(r3, { chart: e3, option: u, title: h }) : console.log("\u6DFB\u52A0\u5931\u8D25");
      });
      y_(this, "get", (r3) => this.chartsEmitters.get(r3));
      y_(this, "clear", () => {
        this.chartsEmitters.clear();
      });
      y_(this, "delete", (r3) => {
        this.chartsEmitters.delete(r3);
      });
      y_(this, "list", () => {
        var e3, u, h;
        const r3 = [];
        for (const v4 of this.chartsEmitters.keys())
          r3.push({ id: v4, chart: (e3 = this.chartsEmitters.get(v4)) == null ? void 0 : e3.chart, option: (u = this.chartsEmitters.get(v4)) == null ? void 0 : u.option, title: (h = this.chartsEmitters.get(v4)) == null ? void 0 : h.title });
        return r3;
      });
    }
  }
  const gEn = new vEn();
  var Ohe = { exports: {} };
  /**
  * @license
  * Lodash <https://lodash.com/>
  * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
  * Released under MIT license <https://lodash.com/license>
  * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
  * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
  */
  (function(l3, r3) {
    (function() {
      var e3, u = "4.17.21", h = 200, v4 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", m3 = "Expected a function", x3 = "Invalid `variable` option passed into `_.template`", C = "__lodash_hash_undefined__", A2 = 500, D = "__lodash_placeholder__", P = 1, N = 2, j = 4, W = 1, K = 2, te = 1, ne = 2, ce = 4, me = 8, ve = 16, Be = 32, Oe = 64, We = 128, Ue = 256, qe = 512, Ze = 30, ct = "...", _t = 800, pt = 16, zt = 1, Zt = 2, Ft = 3, Kn = 1 / 0, hn = 9007199254740991, xn = 17976931348623157e292, zn = 0 / 0, or = 4294967295, vr = or - 1, la = or >>> 1, Ba = [["ary", We], ["bind", te], ["bindKey", ne], ["curry", me], ["curryRight", ve], ["flip", qe], ["partial", Be], ["partialRight", Oe], ["rearg", Ue]], Lo = "[object Arguments]", Ao = "[object Array]", oo = "[object AsyncFunction]", Pa = "[object Boolean]", fo = "[object Date]", Co = "[object DOMException]", $a = "[object Error]", Yo = "[object Function]", Qu = "[object GeneratorFunction]", ds = "[object Map]", Lu = "[object Number]", dc = "[object Null]", Kc = "[object Object]", sv = "[object Promise]", Hf = "[object Proxy]", vg = "[object RegExp]", Ef = "[object Set]", md = "[object String]", Gh = "[object Symbol]", nw = "[object Undefined]", Ki = "[object WeakMap]", Zr = "[object WeakSet]", Ur = "[object ArrayBuffer]", Zi = "[object DataView]", uo = "[object Float32Array]", us = "[object Float64Array]", Jl = "[object Int8Array]", Ql = "[object Int16Array]", sf = "[object Int32Array]", ep = "[object Uint8Array]", hh = "[object Uint8ClampedArray]", bd = "[object Uint16Array]", ph = "[object Uint32Array]", l0 = /\b__p \+= '';/g, iy = /\b(__p \+=) '' \+/g, _b2 = /(__e\(.*?\)|\b__t\)) \+\n'';/g, ay = /&(?:amp|lt|gt|quot|#39);/g, Vp = /[&<>"']/g, vc = RegExp(ay.source), Hd = RegExp(Vp.source), gg = /<%-([\s\S]+?)%>/g, xb = /<%([\s\S]+?)%>/g, um = /<%=([\s\S]+?)%>/g, oy = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, x1 = /^\w*$/, _M = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, M2 = /[\\^$.*+?()[\]{}|]/g, uP = RegExp(M2.source), T2 = /^\s+/, Fj = /\s/, Vj = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Bj = /\{\n\/\* \[wrapped with (.+)\] \*/, zj = /,? & /, y5 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, An = /[()=,{}\[\]\/\s]/, Rn = /\\(\\)?/g, $t = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, bn = /\w*$/, Mn = /^[-+]0x[0-9a-f]+$/i, jr = /^0b[01]+$/i, zi = /^\[object .+?Constructor\]$/, xi = /^0o[0-7]+$/i, Sr = /^(?:0|[1-9]\d*)$/, cn = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, as = /($^)/, Eu = /['\n\r\u2028\u2029\\]/g, eu = "\\ud800-\\udfff", Df = "\\u0300-\\u036f", yo = "\\ufe20-\\ufe2f", lf = "\\u20d0-\\u20ff", tp = Df + yo + lf, Vs = "\\u2700-\\u27bf", _d = "a-z\\xdf-\\xf6\\xf8-\\xff", sy = "\\xac\\xb1\\xd7\\xf7", T_ = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", m5 = "\\u2000-\\u206f", A_ = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", cm = "A-Z\\xc0-\\xd6\\xd8-\\xde", rw = "\\ufe0e\\ufe0f", Wd = sy + T_ + m5 + A_, ly = "['\u2019]", iw = "[" + eu + "]", A22 = "[" + Wd + "]", JA = "[" + tp + "]", I2 = "\\d+", cP = "[" + Vs + "]", QA = "[" + _d + "]", E2 = "[^" + eu + Wd + I2 + Vs + _d + cm + "]", D2 = "\\ud83c[\\udffb-\\udfff]", xM = "(?:" + JA + "|" + D2 + ")", b5 = "[^" + eu + "]", fP = "(?:\\ud83c[\\udde6-\\uddff]){2}", Jo = "[\\ud800-\\udbff][\\udc00-\\udfff]", Es = "[" + cm + "]", nF = "\\u200d", ti = "(?:" + QA + "|" + E2 + ")", Uo = "(?:" + Es + "|" + E2 + ")", rl = "(?:" + ly + "(?:d|ll|m|re|s|t|ve))?", tQ = "(?:" + ly + "(?:D|LL|M|RE|S|T|VE))?", Kp = xM + "?", yg = "[" + rw + "]?", yt = "(?:" + nF + "(?:" + [b5, fP, Jo].join("|") + ")" + yg + Kp + ")*", Fi = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", aw = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Zc = yg + Kp + yt, Fpe = "(?:" + [cP, fP, Jo].join("|") + ")" + Zc, Gl = "(?:" + [b5 + JA + "?", JA, fP, Jo, iw].join("|") + ")", Vpe = RegExp(ly, "g"), Qa = RegExp(JA, "g"), As = RegExp(D2 + "(?=" + D2 + ")|" + Gl + Zc, "g"), Ei = RegExp([Es + "?" + QA + "+" + rl + "(?=" + [A22, Es, "$"].join("|") + ")", Uo + "+" + tQ + "(?=" + [A22, Es + ti, "$"].join("|") + ")", Es + "?" + ti + "+" + rl, Es + "+" + tQ, aw, Fi, I2, Fpe].join("|"), "g"), Vo = RegExp("[" + nF + eu + tp + rw + "]"), Ha = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, jj = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], ec = -1, Ua = {};
      Ua[uo] = Ua[us] = Ua[Jl] = Ua[Ql] = Ua[sf] = Ua[ep] = Ua[hh] = Ua[bd] = Ua[ph] = true, Ua[Lo] = Ua[Ao] = Ua[Ur] = Ua[Pa] = Ua[Zi] = Ua[fo] = Ua[$a] = Ua[Yo] = Ua[ds] = Ua[Lu] = Ua[Kc] = Ua[vg] = Ua[Ef] = Ua[md] = Ua[Ki] = false;
      var dh = {};
      dh[Lo] = dh[Ao] = dh[Ur] = dh[Zi] = dh[Pa] = dh[fo] = dh[uo] = dh[us] = dh[Jl] = dh[Ql] = dh[sf] = dh[ds] = dh[Lu] = dh[Kc] = dh[vg] = dh[Ef] = dh[md] = dh[Gh] = dh[ep] = dh[hh] = dh[bd] = dh[ph] = true, dh[$a] = dh[Yo] = dh[Ki] = false;
      var w1 = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, hP = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, rF = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, Bpe = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, zpe = parseFloat, pP = parseInt, lv = typeof p2 == "object" && p2 && p2.Object === Object && p2, Xs = typeof self == "object" && self && self.Object === Object && self, np = lv || Xs || Function("return this")(), dP = r3 && !r3.nodeType && r3, k2 = dP && true && l3 && !l3.nodeType && l3, u0 = k2 && k2.exports === dP, S1 = u0 && lv.process, C1 = function() {
        try {
          var hr = k2 && k2.require && k2.require("util").types;
          return hr || S1 && S1.binding && S1.binding("util");
        } catch {
        }
      }(), vP = C1 && C1.isArrayBuffer, _5 = C1 && C1.isDate, nQ = C1 && C1.isMap, Eo = C1 && C1.isRegExp, iF = C1 && C1.isSet, gP = C1 && C1.isTypedArray;
      function fm(hr, Wi, vi) {
        switch (vi.length) {
          case 0:
            return hr.call(Wi);
          case 1:
            return hr.call(Wi, vi[0]);
          case 2:
            return hr.call(Wi, vi[0], vi[1]);
          case 3:
            return hr.call(Wi, vi[0], vi[1], vi[2]);
        }
        return hr.apply(Wi, vi);
      }
      function so(hr, Wi, vi, Ko) {
        for (var Hl = -1, cf = hr == null ? 0 : hr.length; ++Hl < cf; ) {
          var Bp = hr[Hl];
          Wi(Ko, Bp, vi(Bp), hr);
        }
        return Ko;
      }
      function uf(hr, Wi) {
        for (var vi = -1, Ko = hr == null ? 0 : hr.length; ++vi < Ko && Wi(hr[vi], vi, hr) !== false; )
          ;
        return hr;
      }
      function aF(hr, Wi) {
        for (var vi = hr == null ? 0 : hr.length; vi-- && Wi(hr[vi], vi, hr) !== false; )
          ;
        return hr;
      }
      function wM(hr, Wi) {
        for (var vi = -1, Ko = hr == null ? 0 : hr.length; ++vi < Ko; )
          if (!Wi(hr[vi], vi, hr))
            return false;
        return true;
      }
      function Zp(hr, Wi) {
        for (var vi = -1, Ko = hr == null ? 0 : hr.length, Hl = 0, cf = []; ++vi < Ko; ) {
          var Bp = hr[vi];
          Wi(Bp, vi, hr) && (cf[Hl++] = Bp);
        }
        return cf;
      }
      function wb(hr, Wi) {
        var vi = hr == null ? 0 : hr.length;
        return !!vi && Sb(hr, Wi, 0) > -1;
      }
      function Gj(hr, Wi, vi) {
        for (var Ko = -1, Hl = hr == null ? 0 : hr.length; ++Ko < Hl; )
          if (vi(Wi, hr[Ko]))
            return true;
        return false;
      }
      function rp(hr, Wi) {
        for (var vi = -1, Ko = hr == null ? 0 : hr.length, Hl = Array(Ko); ++vi < Ko; )
          Hl[vi] = Wi(hr[vi], vi, hr);
        return Hl;
      }
      function ow(hr, Wi) {
        for (var vi = -1, Ko = Wi.length, Hl = hr.length; ++vi < Ko; )
          hr[Hl + vi] = Wi[vi];
        return hr;
      }
      function O2(hr, Wi, vi, Ko) {
        var Hl = -1, cf = hr == null ? 0 : hr.length;
        for (Ko && cf && (vi = hr[++Hl]); ++Hl < cf; )
          vi = Wi(vi, hr[Hl], Hl, hr);
        return vi;
      }
      function Hj(hr, Wi, vi, Ko) {
        var Hl = hr == null ? 0 : hr.length;
        for (Ko && Hl && (vi = hr[--Hl]); Hl--; )
          vi = Wi(vi, hr[Hl], Hl, hr);
        return vi;
      }
      function Wj(hr, Wi) {
        for (var vi = -1, Ko = hr == null ? 0 : hr.length; ++vi < Ko; )
          if (Wi(hr[vi], vi, hr))
            return true;
        return false;
      }
      var Uj = sw("length");
      function yP(hr) {
        return hr.split("");
      }
      function qj(hr) {
        return hr.match(y5) || [];
      }
      function P2(hr, Wi, vi) {
        var Ko;
        return vi(hr, function(Hl, cf, Bp) {
          if (Wi(Hl, cf, Bp))
            return Ko = cf, false;
        }), Ko;
      }
      function oF(hr, Wi, vi, Ko) {
        for (var Hl = hr.length, cf = vi + (Ko ? 1 : -1); Ko ? cf-- : ++cf < Hl; )
          if (Wi(hr[cf], cf, hr))
            return cf;
        return -1;
      }
      function Sb(hr, Wi, vi) {
        return Wi === Wi ? R2(hr, Wi, vi) : oF(hr, Vv, vi);
      }
      function sF(hr, Wi, vi, Ko) {
        for (var Hl = vi - 1, cf = hr.length; ++Hl < cf; )
          if (Ko(hr[Hl], Wi))
            return Hl;
        return -1;
      }
      function Vv(hr) {
        return hr !== hr;
      }
      function L2(hr, Wi) {
        var vi = hr == null ? 0 : hr.length;
        return vi ? $j(hr, Wi) / vi : zn;
      }
      function sw(hr) {
        return function(Wi) {
          return Wi == null ? e3 : Wi[hr];
        };
      }
      function SM(hr) {
        return function(Wi) {
          return hr == null ? e3 : hr[Wi];
        };
      }
      function rQ(hr, Wi, vi, Ko, Hl) {
        return Hl(hr, function(cf, Bp, vh) {
          vi = Ko ? (Ko = false, cf) : Wi(vi, cf, Bp, vh);
        }), vi;
      }
      function jpe(hr, Wi) {
        var vi = hr.length;
        for (hr.sort(Wi); vi--; )
          hr[vi] = hr[vi].value;
        return hr;
      }
      function $j(hr, Wi) {
        for (var vi, Ko = -1, Hl = hr.length; ++Ko < Hl; ) {
          var cf = Wi(hr[Ko]);
          cf !== e3 && (vi = vi === e3 ? cf : vi + cf);
        }
        return vi;
      }
      function hm(hr, Wi) {
        for (var vi = -1, Ko = Array(hr); ++vi < hr; )
          Ko[vi] = Wi(vi);
        return Ko;
      }
      function Gpe(hr, Wi) {
        return rp(Wi, function(vi) {
          return [vi, hr[vi]];
        });
      }
      function lF(hr) {
        return hr && hr.slice(0, lQ(hr) + 1).replace(T2, "");
      }
      function pm(hr) {
        return function(Wi) {
          return hr(Wi);
        };
      }
      function uF(hr, Wi) {
        return rp(Wi, function(vi) {
          return hr[vi];
        });
      }
      function eI(hr, Wi) {
        return hr.has(Wi);
      }
      function iQ(hr, Wi) {
        for (var vi = -1, Ko = hr.length; ++vi < Ko && Sb(Wi, hr[vi], 0) > -1; )
          ;
        return vi;
      }
      function cF(hr, Wi) {
        for (var vi = hr.length; vi-- && Sb(Wi, hr[vi], 0) > -1; )
          ;
        return vi;
      }
      function Hpe(hr, Wi) {
        for (var vi = hr.length, Ko = 0; vi--; )
          hr[vi] === Wi && ++Ko;
        return Ko;
      }
      var Wpe = SM(w1), aQ = SM(hP);
      function Upe(hr) {
        return "\\" + Bpe[hr];
      }
      function Xj(hr, Wi) {
        return hr == null ? e3 : hr[Wi];
      }
      function x5(hr) {
        return Vo.test(hr);
      }
      function Yj(hr) {
        return Ha.test(hr);
      }
      function oQ(hr) {
        for (var Wi, vi = []; !(Wi = hr.next()).done; )
          vi.push(Wi.value);
        return vi;
      }
      function mP(hr) {
        var Wi = -1, vi = Array(hr.size);
        return hr.forEach(function(Ko, Hl) {
          vi[++Wi] = [Hl, Ko];
        }), vi;
      }
      function M1(hr, Wi) {
        return function(vi) {
          return hr(Wi(vi));
        };
      }
      function CM(hr, Wi) {
        for (var vi = -1, Ko = hr.length, Hl = 0, cf = []; ++vi < Ko; ) {
          var Bp = hr[vi];
          (Bp === Wi || Bp === D) && (hr[vi] = D, cf[Hl++] = vi);
        }
        return cf;
      }
      function w5(hr) {
        var Wi = -1, vi = Array(hr.size);
        return hr.forEach(function(Ko) {
          vi[++Wi] = Ko;
        }), vi;
      }
      function qpe(hr) {
        var Wi = -1, vi = Array(hr.size);
        return hr.forEach(function(Ko) {
          vi[++Wi] = [Ko, Ko];
        }), vi;
      }
      function R2(hr, Wi, vi) {
        for (var Ko = vi - 1, Hl = hr.length; ++Ko < Hl; )
          if (hr[Ko] === Wi)
            return Ko;
        return -1;
      }
      function sQ(hr, Wi, vi) {
        for (var Ko = vi + 1; Ko--; )
          if (hr[Ko] === Wi)
            return Ko;
        return Ko;
      }
      function S5(hr) {
        return x5(hr) ? uQ(hr) : Uj(hr);
      }
      function Cb(hr) {
        return x5(hr) ? $pe(hr) : yP(hr);
      }
      function lQ(hr) {
        for (var Wi = hr.length; Wi-- && Fj.test(hr.charAt(Wi)); )
          ;
        return Wi;
      }
      var Kj = SM(rF);
      function uQ(hr) {
        for (var Wi = As.lastIndex = 0; As.test(hr); )
          ++Wi;
        return Wi;
      }
      function $pe(hr) {
        return hr.match(As) || [];
      }
      function Xpe(hr) {
        return hr.match(Ei) || [];
      }
      var Ype = function hr(Wi) {
        Wi = Wi == null ? np : lw.defaults(np.Object(), Wi, lw.pick(np, jj));
        var vi = Wi.Array, Ko = Wi.Date, Hl = Wi.Error, cf = Wi.Function, Bp = Wi.Math, vh = Wi.Object, fF = Wi.RegExp, Kpe = Wi.String, T1 = Wi.TypeError, C5 = vi.prototype, Zj = cf.prototype, M5 = vh.prototype, tI = Wi["__core-js_shared__"], c0 = Zj.toString, Jc = M5.hasOwnProperty, T5 = 0, Jj = function() {
          var $ = /[^.]+$/.exec(tI && tI.keys && tI.keys.IE_PROTO || "");
          return $ ? "Symbol(src)_1." + $ : "";
        }(), A5 = M5.toString, cQ = c0.call(vh), Zpe = np._, Jpe = fF("^" + c0.call(Jc).replace(M2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), bP = u0 ? Wi.Buffer : e3, uw = Wi.Symbol, nI = Wi.Uint8Array, Qj = bP ? bP.allocUnsafe : e3, rI = M1(vh.getPrototypeOf, vh), N2 = vh.create, _P = M5.propertyIsEnumerable, xP = C5.splice, eG = uw ? uw.isConcatSpreadable : e3, MM = uw ? uw.iterator : e3, f0 = uw ? uw.toStringTag : e3, uy = function() {
          try {
            var $ = O1(vh, "defineProperty");
            return $({}, "", {}), $;
          } catch {
          }
        }(), I5 = Wi.clearTimeout !== np.clearTimeout && Wi.clearTimeout, TM = Ko && Ko.now !== np.Date.now && Ko.now, fQ = Wi.setTimeout !== np.setTimeout && Wi.setTimeout, Jp = Bp.ceil, wP = Bp.floor, E5 = vh.getOwnPropertySymbols, hQ = bP ? bP.isBuffer : e3, F2 = Wi.isFinite, pQ = C5.join, Qpe = M1(vh.keys, vh), Dc = Bp.max, Bv = Bp.min, ede = Ko.now, dQ = Wi.parseInt, D5 = Bp.random, vQ = C5.reverse, tG = O1(Wi, "DataView"), SP = O1(Wi, "Map"), CP = O1(Wi, "Promise"), k5 = O1(Wi, "Set"), MP = O1(Wi, "WeakMap"), O5 = O1(vh, "create"), hF = MP && new MP(), P5 = {}, TP = H2(tG), gQ = H2(SP), I_ = H2(CP), tde = H2(k5), AP = H2(MP), L5 = uw ? uw.prototype : e3, cw = L5 ? L5.valueOf : e3, pF = L5 ? L5.toString : e3;
        function Ht($) {
          if (Wh($) && !La($) && !($ instanceof Ru)) {
            if ($ instanceof A1)
              return $;
            if (Jc.call($, "__wrapped__"))
              return DG($);
          }
          return new A1($);
        }
        var mg = function() {
          function $() {
          }
          return function(ie) {
            if (!Hh(ie))
              return {};
            if (N2)
              return N2(ie);
            $.prototype = ie;
            var De = new $();
            return $.prototype = e3, De;
          };
        }();
        function R5() {
        }
        function A1($, ie) {
          this.__wrapped__ = $, this.__actions__ = [], this.__chain__ = !!ie, this.__index__ = 0, this.__values__ = e3;
        }
        Ht.templateSettings = { escape: gg, evaluate: xb, interpolate: um, variable: "", imports: { _: Ht } }, Ht.prototype = R5.prototype, Ht.prototype.constructor = Ht, A1.prototype = mg(R5.prototype), A1.prototype.constructor = A1;
        function Ru($) {
          this.__wrapped__ = $, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = or, this.__views__ = [];
        }
        function N5() {
          var $ = new Ru(this.__wrapped__);
          return $.__actions__ = py(this.__actions__), $.__dir__ = this.__dir__, $.__filtered__ = this.__filtered__, $.__iteratees__ = py(this.__iteratees__), $.__takeCount__ = this.__takeCount__, $.__views__ = py(this.__views__), $;
        }
        function I1() {
          if (this.__filtered__) {
            var $ = new Ru(this);
            $.__dir__ = -1, $.__filtered__ = true;
          } else
            $ = this.clone(), $.__dir__ *= -1;
          return $;
        }
        function nG() {
          var $ = this.__wrapped__.value(), ie = this.__dir__, De = La($), tt = ie < 0, Mt = De ? $.length : 0, nn = _de(0, Mt, this.__views__), jn = nn.start, Zn = nn.end, Ir = Zn - jn, ji = tt ? Zn : jn - 1, ca = this.__iteratees__, ka = ca.length, Io = 0, gs = Bv(Ir, this.__takeCount__);
          if (!De || !tt && Mt == Ir && gs == Ir)
            return bG($, this.__actions__);
          var Ls = [];
          e:
            for (; Ir-- && Io < gs; ) {
              ji += ie;
              for (var ll = -1, Hs = $[ji]; ++ll < ka; ) {
                var tc = ca[ll], zc = tc.iteratee, Sg = tc.type, v0 = zc(Hs);
                if (Sg == Zt)
                  Hs = v0;
                else if (!v0) {
                  if (Sg == zt)
                    continue e;
                  break e;
                }
              }
              Ls[Io++] = Hs;
            }
          return Ls;
        }
        Ru.prototype = mg(R5.prototype), Ru.prototype.constructor = Ru;
        function iI($) {
          var ie = -1, De = $ == null ? 0 : $.length;
          for (this.clear(); ++ie < De; ) {
            var tt = $[ie];
            this.set(tt[0], tt[1]);
          }
        }
        function rG() {
          this.__data__ = O5 ? O5(null) : {}, this.size = 0;
        }
        function iG($) {
          var ie = this.has($) && delete this.__data__[$];
          return this.size -= ie ? 1 : 0, ie;
        }
        function nde($) {
          var ie = this.__data__;
          if (O5) {
            var De = ie[$];
            return De === C ? e3 : De;
          }
          return Jc.call(ie, $) ? ie[$] : e3;
        }
        function IP($) {
          var ie = this.__data__;
          return O5 ? ie[$] !== e3 : Jc.call(ie, $);
        }
        function dF($, ie) {
          var De = this.__data__;
          return this.size += this.has($) ? 0 : 1, De[$] = O5 && ie === e3 ? C : ie, this;
        }
        iI.prototype.clear = rG, iI.prototype.delete = iG, iI.prototype.get = nde, iI.prototype.has = IP, iI.prototype.set = dF;
        function bg($) {
          var ie = -1, De = $ == null ? 0 : $.length;
          for (this.clear(); ++ie < De; ) {
            var tt = $[ie];
            this.set(tt[0], tt[1]);
          }
        }
        function vF() {
          this.__data__ = [], this.size = 0;
        }
        function gF($) {
          var ie = this.__data__, De = oI(ie, $);
          if (De < 0)
            return false;
          var tt = ie.length - 1;
          return De == tt ? ie.pop() : xP.call(ie, De, 1), --this.size, true;
        }
        function F5($) {
          var ie = this.__data__, De = oI(ie, $);
          return De < 0 ? e3 : ie[De][1];
        }
        function yQ($) {
          return oI(this.__data__, $) > -1;
        }
        function AM($, ie) {
          var De = this.__data__, tt = oI(De, $);
          return tt < 0 ? (++this.size, De.push([$, ie])) : De[tt][1] = ie, this;
        }
        bg.prototype.clear = vF, bg.prototype.delete = gF, bg.prototype.get = F5, bg.prototype.has = yQ, bg.prototype.set = AM;
        function Mb($) {
          var ie = -1, De = $ == null ? 0 : $.length;
          for (this.clear(); ++ie < De; ) {
            var tt = $[ie];
            this.set(tt[0], tt[1]);
          }
        }
        function aG() {
          this.size = 0, this.__data__ = { hash: new iI(), map: new (SP || bg)(), string: new iI() };
        }
        function rde($) {
          var ie = NP(this, $).delete($);
          return this.size -= ie ? 1 : 0, ie;
        }
        function ide($) {
          return NP(this, $).get($);
        }
        function ade($) {
          return NP(this, $).has($);
        }
        function ode($, ie) {
          var De = NP(this, $), tt = De.size;
          return De.set($, ie), this.size += De.size == tt ? 0 : 1, this;
        }
        Mb.prototype.clear = aG, Mb.prototype.delete = rde, Mb.prototype.get = ide, Mb.prototype.has = ade, Mb.prototype.set = ode;
        function aI($) {
          var ie = -1, De = $ == null ? 0 : $.length;
          for (this.__data__ = new Mb(); ++ie < De; )
            this.add($[ie]);
        }
        function mQ($) {
          return this.__data__.set($, C), this;
        }
        function sde($) {
          return this.__data__.has($);
        }
        aI.prototype.add = aI.prototype.push = mQ, aI.prototype.has = sde;
        function E_($) {
          var ie = this.__data__ = new bg($);
          this.size = ie.size;
        }
        function bQ() {
          this.__data__ = new bg(), this.size = 0;
        }
        function _Q($) {
          var ie = this.__data__, De = ie.delete($);
          return this.size = ie.size, De;
        }
        function lde($) {
          return this.__data__.get($);
        }
        function yF($) {
          return this.__data__.has($);
        }
        function xQ($, ie) {
          var De = this.__data__;
          if (De instanceof bg) {
            var tt = De.__data__;
            if (!SP || tt.length < h - 1)
              return tt.push([$, ie]), this.size = ++De.size, this;
            De = this.__data__ = new Mb(tt);
          }
          return De.set($, ie), this.size = De.size, this;
        }
        E_.prototype.clear = bQ, E_.prototype.delete = _Q, E_.prototype.get = lde, E_.prototype.has = yF, E_.prototype.set = xQ;
        function oG($, ie) {
          var De = La($), tt = !De && Fl($), Mt = !De && !tt && Sw($), nn = !De && !tt && !Mt && Y5($), jn = De || tt || Mt || nn, Zn = jn ? hm($.length, Kpe) : [], Ir = Zn.length;
          for (var ji in $)
            (ie || Jc.call($, ji)) && !(jn && (ji == "length" || Mt && (ji == "offset" || ji == "parent") || nn && (ji == "buffer" || ji == "byteLength" || ji == "byteOffset") || Jf(ji, Ir))) && Zn.push(ji);
          return Zn;
        }
        function wQ($) {
          var ie = $.length;
          return ie ? $[kM(0, ie - 1)] : e3;
        }
        function sG($, ie) {
          return P1(py($), sI(ie, 0, $.length));
        }
        function V2($) {
          return P1(py($));
        }
        function EP($, ie, De) {
          (De !== e3 && !Eb($[ie], De) || De === e3 && !(ie in $)) && E1($, ie, De);
        }
        function DP($, ie, De) {
          var tt = $[ie];
          (!(Jc.call($, ie) && Eb(tt, De)) || De === e3 && !(ie in $)) && E1($, ie, De);
        }
        function oI($, ie) {
          for (var De = $.length; De--; )
            if (Eb($[De][0], ie))
              return De;
          return -1;
        }
        function SQ($, ie, De, tt) {
          return fw($, function(Mt, nn, jn) {
            ie(tt, Mt, De(Mt), jn);
          }), tt;
        }
        function CQ($, ie) {
          return $ && D_(ie, fv(ie), $);
        }
        function ude($, ie) {
          return $ && D_(ie, mm(ie), $);
        }
        function E1($, ie, De) {
          ie == "__proto__" && uy ? uy($, ie, { configurable: true, enumerable: true, value: De, writable: true }) : $[ie] = De;
        }
        function V5($, ie) {
          for (var De = -1, tt = ie.length, Mt = vi(tt), nn = $ == null; ++De < tt; )
            Mt[De] = nn ? e3 : cv($, ie[De]);
          return Mt;
        }
        function sI($, ie, De) {
          return $ === $ && (De !== e3 && ($ = $ <= De ? $ : De), ie !== e3 && ($ = $ >= ie ? $ : ie)), $;
        }
        function cy($, ie, De, tt, Mt, nn) {
          var jn, Zn = ie & P, Ir = ie & N, ji = ie & j;
          if (De && (jn = Mt ? De($, tt, Mt, nn) : De($)), jn !== e3)
            return jn;
          if (!Hh($))
            return $;
          var ca = La($);
          if (ca) {
            if (jn = wde($), !Zn)
              return py($, jn);
          } else {
            var ka = xg($), Io = ka == Yo || ka == Qu;
            if (Sw($))
              return LQ($, Zn);
            if (ka == Kc || ka == Lo || Io && !Mt) {
              if (jn = Ir || Io ? {} : JQ($), !Zn)
                return Ir ? vs($, ude(jn, $)) : VQ($, CQ(jn, $));
            } else {
              if (!dh[ka])
                return Mt ? $ : {};
              jn = Sde($, ka, Zn);
            }
          }
          nn || (nn = new E_());
          var gs = nn.get($);
          if (gs)
            return gs;
          nn.set($, jn), Cw($) ? $.forEach(function(Hs) {
            jn.add(cy(Hs, ie, De, Hs, $, nn));
          }) : MI($) && $.forEach(function(Hs, tc) {
            jn.set(tc, cy(Hs, ie, De, tc, $, nn));
          });
          var Ls = ji ? Ir ? NF : RF : Ir ? mm : fv, ll = ca ? e3 : Ls($);
          return uf(ll || $, function(Hs, tc) {
            ll && (tc = Hs, Hs = $[tc]), DP(jn, tc, cy(Hs, ie, De, tc, $, nn));
          }), jn;
        }
        function mF($) {
          var ie = fv($);
          return function(De) {
            return lG(De, $, ie);
          };
        }
        function lG($, ie, De) {
          var tt = De.length;
          if ($ == null)
            return !tt;
          for ($ = vh($); tt--; ) {
            var Mt = De[tt], nn = ie[Mt], jn = $[Mt];
            if (jn === e3 && !(Mt in $) || !nn(jn))
              return false;
          }
          return true;
        }
        function B5($, ie, De) {
          if (typeof $ != "function")
            throw new T1(m3);
          return $5(function() {
            $.apply(e3, De);
          }, ie);
        }
        function lI($, ie, De, tt) {
          var Mt = -1, nn = wb, jn = true, Zn = $.length, Ir = [], ji = ie.length;
          if (!Zn)
            return Ir;
          De && (ie = rp(ie, pm(De))), tt ? (nn = Gj, jn = false) : ie.length >= h && (nn = eI, jn = false, ie = new aI(ie));
          e:
            for (; ++Mt < Zn; ) {
              var ca = $[Mt], ka = De == null ? ca : De(ca);
              if (ca = tt || ca !== 0 ? ca : 0, jn && ka === ka) {
                for (var Io = ji; Io--; )
                  if (ie[Io] === ka)
                    continue e;
                Ir.push(ca);
              } else
                nn(ie, ka, tt) || Ir.push(ca);
            }
          return Ir;
        }
        var fw = BQ(hw), uG = BQ(cG, true);
        function MQ($, ie) {
          var De = true;
          return fw($, function(tt, Mt, nn) {
            return De = !!ie(tt, Mt, nn), De;
          }), De;
        }
        function uI($, ie, De) {
          for (var tt = -1, Mt = $.length; ++tt < Mt; ) {
            var nn = $[tt], jn = ie(nn);
            if (jn != null && (Zn === e3 ? jn === jn && !L1(jn) : De(jn, Zn)))
              var Zn = jn, Ir = nn;
          }
          return Ir;
        }
        function kP($, ie, De, tt) {
          var Mt = $.length;
          for (De = sl(De), De < 0 && (De = -De > Mt ? 0 : Mt + De), tt = tt === e3 || tt > Mt ? Mt : sl(tt), tt < 0 && (tt += Mt), tt = De > tt ? 0 : iH(tt); De < tt; )
            $[De++] = ie;
          return $;
        }
        function TQ($, ie) {
          var De = [];
          return fw($, function(tt, Mt, nn) {
            ie(tt, Mt, nn) && De.push(tt);
          }), De;
        }
        function uv($, ie, De, tt, Mt) {
          var nn = -1, jn = $.length;
          for (De || (De = FP), Mt || (Mt = []); ++nn < jn; ) {
            var Zn = $[nn];
            ie > 0 && De(Zn) ? ie > 1 ? uv(Zn, ie - 1, De, tt, Mt) : ow(Mt, Zn) : tt || (Mt[Mt.length] = Zn);
          }
          return Mt;
        }
        var IM = zQ(), AQ = zQ(true);
        function hw($, ie) {
          return $ && IM($, ie, fv);
        }
        function cG($, ie) {
          return $ && AQ($, ie, fv);
        }
        function z5($, ie) {
          return Zp(ie, function(De) {
            return my($[De]);
          });
        }
        function B2($, ie) {
          ie = zv(ie, $);
          for (var De = 0, tt = ie.length; $ != null && De < tt; )
            $ = $[mw(ie[De++])];
          return De && De == tt ? $ : e3;
        }
        function fG($, ie, De) {
          var tt = ie($);
          return La($) ? tt : ow(tt, De($));
        }
        function h0($) {
          return $ == null ? $ === e3 ? nw : dc : f0 && f0 in vh($) ? YQ($) : Ade($);
        }
        function OP($, ie) {
          return $ > ie;
        }
        function cde($, ie) {
          return $ != null && Jc.call($, ie);
        }
        function hG($, ie) {
          return $ != null && ie in vh($);
        }
        function fde($, ie, De) {
          return $ >= Bv(ie, De) && $ < Dc(ie, De);
        }
        function bF($, ie, De) {
          for (var tt = De ? Gj : wb, Mt = $[0].length, nn = $.length, jn = nn, Zn = vi(nn), Ir = 1 / 0, ji = []; jn--; ) {
            var ca = $[jn];
            jn && ie && (ca = rp(ca, pm(ie))), Ir = Bv(ca.length, Ir), Zn[jn] = !De && (ie || Mt >= 120 && ca.length >= 120) ? new aI(jn && ca) : e3;
          }
          ca = $[0];
          var ka = -1, Io = Zn[0];
          e:
            for (; ++ka < Mt && ji.length < Ir; ) {
              var gs = ca[ka], Ls = ie ? ie(gs) : gs;
              if (gs = De || gs !== 0 ? gs : 0, !(Io ? eI(Io, Ls) : tt(ji, Ls, De))) {
                for (jn = nn; --jn; ) {
                  var ll = Zn[jn];
                  if (!(ll ? eI(ll, Ls) : tt($[jn], Ls, De)))
                    continue e;
                }
                Io && Io.push(Ls), ji.push(gs);
              }
            }
          return ji;
        }
        function hde($, ie, De, tt) {
          return hw($, function(Mt, nn, jn) {
            ie(tt, De(Mt), nn, jn);
          }), tt;
        }
        function fy($, ie, De) {
          ie = zv(ie, $), $ = TG($, ie);
          var tt = $ == null ? $ : $[mw(vm(ie))];
          return tt == null ? e3 : fm(tt, $, De);
        }
        function _F($) {
          return Wh($) && h0($) == Lo;
        }
        function pde($) {
          return Wh($) && h0($) == Ur;
        }
        function dde($) {
          return Wh($) && h0($) == fo;
        }
        function EM($, ie, De, tt, Mt) {
          return $ === ie ? true : $ == null || ie == null || !Wh($) && !Wh(ie) ? $ !== $ && ie !== ie : pG($, ie, De, tt, EM, Mt);
        }
        function pG($, ie, De, tt, Mt, nn) {
          var jn = La($), Zn = La(ie), Ir = jn ? Ao : xg($), ji = Zn ? Ao : xg(ie);
          Ir = Ir == Lo ? Kc : Ir, ji = ji == Lo ? Kc : ji;
          var ca = Ir == Kc, ka = ji == Kc, Io = Ir == ji;
          if (Io && Sw($)) {
            if (!Sw(ie))
              return false;
            jn = true, ca = false;
          }
          if (Io && !ca)
            return nn || (nn = new E_()), jn || Y5($) ? LF($, ie, De, tt, Mt, nn) : XQ($, ie, Ir, De, tt, Mt, nn);
          if (!(De & W)) {
            var gs = ca && Jc.call($, "__wrapped__"), Ls = ka && Jc.call(ie, "__wrapped__");
            if (gs || Ls) {
              var ll = gs ? $.value() : $, Hs = Ls ? ie.value() : ie;
              return nn || (nn = new E_()), Mt(ll, Hs, De, tt, nn);
            }
          }
          return Io ? (nn || (nn = new E_()), G2($, ie, De, tt, Mt, nn)) : false;
        }
        function IQ($) {
          return Wh($) && xg($) == ds;
        }
        function dG($, ie, De, tt) {
          var Mt = De.length, nn = Mt, jn = !tt;
          if ($ == null)
            return !nn;
          for ($ = vh($); Mt--; ) {
            var Zn = De[Mt];
            if (jn && Zn[2] ? Zn[1] !== $[Zn[0]] : !(Zn[0] in $))
              return false;
          }
          for (; ++Mt < nn; ) {
            Zn = De[Mt];
            var Ir = Zn[0], ji = $[Ir], ca = Zn[1];
            if (jn && Zn[2]) {
              if (ji === e3 && !(Ir in $))
                return false;
            } else {
              var ka = new E_();
              if (tt)
                var Io = tt(ji, ca, Ir, $, ie, ka);
              if (!(Io === e3 ? EM(ca, ji, W | K, tt, ka) : Io))
                return false;
            }
          }
          return true;
        }
        function EQ($) {
          if (!Hh($) || Mde($))
            return false;
          var ie = my($) ? Jpe : zi;
          return ie.test(H2($));
        }
        function DQ($) {
          return Wh($) && h0($) == vg;
        }
        function xF($) {
          return Wh($) && xg($) == Ef;
        }
        function vG($) {
          return Wh($) && $M($.length) && !!Ua[h0($)];
        }
        function wF($) {
          return typeof $ == "function" ? $ : $ == null ? by : typeof $ == "object" ? La($) ? pw($[0], $[1]) : SF($) : xH($);
        }
        function PP($) {
          if (!k_($))
            return Qpe($);
          var ie = [];
          for (var De in vh($))
            Jc.call($, De) && De != "constructor" && ie.push(De);
          return ie;
        }
        function vde($) {
          if (!Hh($))
            return xd($);
          var ie = k_($), De = [];
          for (var tt in $)
            tt == "constructor" && (ie || !Jc.call($, tt)) || De.push(tt);
          return De;
        }
        function dm($, ie) {
          return $ < ie;
        }
        function LP($, ie) {
          var De = -1, tt = gy($) ? vi($.length) : [];
          return fw($, function(Mt, nn, jn) {
            tt[++De] = ie(Mt, nn, jn);
          }), tt;
        }
        function SF($) {
          var ie = Wc($);
          return ie.length == 1 && ie[0][2] ? eee(ie[0][0], ie[0][1]) : function(De) {
            return De === $ || dG(De, $, ie);
          };
        }
        function pw($, ie) {
          return yI($) && mu(ie) ? eee(mw($), ie) : function(De) {
            var tt = cv(De, $);
            return tt === e3 && tt === ie ? DI(De, $) : EM(ie, tt, W | K);
          };
        }
        function D1($, ie, De, tt, Mt) {
          $ !== ie && IM(ie, function(nn, jn) {
            if (Mt || (Mt = new E_()), Hh(nn))
              cI($, ie, jn, De, D1, tt, Mt);
            else {
              var Zn = tt ? tt(AG($, jn), nn, jn + "", $, ie, Mt) : e3;
              Zn === e3 && (Zn = nn), EP($, jn, Zn);
            }
          }, mm);
        }
        function cI($, ie, De, tt, Mt, nn, jn) {
          var Zn = AG($, De), Ir = AG(ie, De), ji = jn.get(Ir);
          if (ji) {
            EP($, De, ji);
            return;
          }
          var ca = nn ? nn(Zn, Ir, De + "", $, ie, jn) : e3, ka = ca === e3;
          if (ka) {
            var Io = La(Ir), gs = !Io && Sw(Ir), Ls = !Io && !gs && Y5(Ir);
            ca = Ir, Io || gs || Ls ? La(Zn) ? ca = Zn : Qp(Zn) ? ca = py(Zn) : gs ? (ka = false, ca = LQ(Ir, true)) : Ls ? (ka = false, ca = IF(Ir, true)) : ca = [] : $P(Ir) || Fl(Ir) ? (ca = Zn, Fl(Zn) ? ca = aH(Zn) : (!Hh(Zn) || my(Zn)) && (ca = JQ(Ir))) : ka = false;
          }
          ka && (jn.set(Ir, ca), Mt(ca, Ir, tt, nn, jn), jn.delete(Ir)), EP($, De, ca);
        }
        function CF($, ie) {
          var De = $.length;
          if (!!De)
            return ie += ie < 0 ? De : 0, Jf(ie, De) ? $[ie] : e3;
        }
        function fI($, ie, De) {
          ie.length ? ie = rp(ie, function(nn) {
            return La(nn) ? function(jn) {
              return B2(jn, nn.length === 1 ? nn[0] : nn);
            } : nn;
          }) : ie = [by];
          var tt = -1;
          ie = rp(ie, pm(Ks()));
          var Mt = LP($, function(nn, jn, Zn) {
            var Ir = rp(ie, function(ji) {
              return ji(nn);
            });
            return { criteria: Ir, index: ++tt, value: nn };
          });
          return jpe(Mt, function(nn, jn) {
            return mde(nn, jn, De);
          });
        }
        function gde($, ie) {
          return gG($, ie, function(De, tt) {
            return DI($, tt);
          });
        }
        function gG($, ie, De) {
          for (var tt = -1, Mt = ie.length, nn = {}; ++tt < Mt; ) {
            var jn = ie[tt], Zn = B2($, jn);
            De(Zn, jn) && k1(nn, zv(jn, $), Zn);
          }
          return nn;
        }
        function kQ($) {
          return function(ie) {
            return B2(ie, $);
          };
        }
        function z2($, ie, De, tt) {
          var Mt = tt ? sF : Sb, nn = -1, jn = ie.length, Zn = $;
          for ($ === ie && (ie = py(ie)), De && (Zn = rp($, pm(De))); ++nn < jn; )
            for (var Ir = 0, ji = ie[nn], ca = De ? De(ji) : ji; (Ir = Mt(Zn, ca, Ir, tt)) > -1; )
              Zn !== $ && xP.call(Zn, Ir, 1), xP.call($, Ir, 1);
          return $;
        }
        function DM($, ie) {
          for (var De = $ ? ie.length : 0, tt = De - 1; De--; ) {
            var Mt = ie[De];
            if (De == tt || Mt !== nn) {
              var nn = Mt;
              Jf(Mt) ? xP.call($, Mt, 1) : Ys($, Mt);
            }
          }
          return $;
        }
        function kM($, ie) {
          return $ + wP(D5() * (ie - $ + 1));
        }
        function yG($, ie, De, tt) {
          for (var Mt = -1, nn = Dc(Jp((ie - $) / (De || 1)), 0), jn = vi(nn); nn--; )
            jn[tt ? nn : ++Mt] = $, $ += De;
          return jn;
        }
        function RP($, ie) {
          var De = "";
          if (!$ || ie < 1 || ie > hn)
            return De;
          do
            ie % 2 && (De += $), ie = wP(ie / 2), ie && ($ += $);
          while (ie);
          return De;
        }
        function Nu($, ie) {
          return IG(q5($, ie, by), $ + "");
        }
        function dw($) {
          return wQ(kI($));
        }
        function OQ($, ie) {
          var De = kI($);
          return P1(De, sI(ie, 0, De.length));
        }
        function k1($, ie, De, tt) {
          if (!Hh($))
            return $;
          ie = zv(ie, $);
          for (var Mt = -1, nn = ie.length, jn = nn - 1, Zn = $; Zn != null && ++Mt < nn; ) {
            var Ir = mw(ie[Mt]), ji = De;
            if (Ir === "__proto__" || Ir === "constructor" || Ir === "prototype")
              return $;
            if (Mt != jn) {
              var ca = Zn[Ir];
              ji = tt ? tt(ca, Ir, Zn) : e3, ji === e3 && (ji = Hh(ca) ? ca : Jf(ie[Mt + 1]) ? [] : {});
            }
            DP(Zn, Ir, ji), Zn = Zn[Ir];
          }
          return $;
        }
        var PQ = hF ? function($, ie) {
          return hF.set($, ie), $;
        } : by, Bs = uy ? function($, ie) {
          return uy($, "toString", { configurable: true, enumerable: false, value: r8(ie), writable: true });
        } : by;
        function MF($) {
          return P1(kI($));
        }
        function hy($, ie, De) {
          var tt = -1, Mt = $.length;
          ie < 0 && (ie = -ie > Mt ? 0 : Mt + ie), De = De > Mt ? Mt : De, De < 0 && (De += Mt), Mt = ie > De ? 0 : De - ie >>> 0, ie >>>= 0;
          for (var nn = vi(Mt); ++tt < Mt; )
            nn[tt] = $[tt + ie];
          return nn;
        }
        function hI($, ie) {
          var De;
          return fw($, function(tt, Mt, nn) {
            return De = ie(tt, Mt, nn), !De;
          }), !!De;
        }
        function vw($, ie, De) {
          var tt = 0, Mt = $ == null ? tt : $.length;
          if (typeof ie == "number" && ie === ie && Mt <= la) {
            for (; tt < Mt; ) {
              var nn = tt + Mt >>> 1, jn = $[nn];
              jn !== null && !L1(jn) && (De ? jn <= ie : jn < ie) ? tt = nn + 1 : Mt = nn;
            }
            return Mt;
          }
          return j2($, ie, by, De);
        }
        function j2($, ie, De, tt) {
          var Mt = 0, nn = $ == null ? 0 : $.length;
          if (nn === 0)
            return 0;
          ie = De(ie);
          for (var jn = ie !== ie, Zn = ie === null, Ir = L1(ie), ji = ie === e3; Mt < nn; ) {
            var ca = wP((Mt + nn) / 2), ka = De($[ca]), Io = ka !== e3, gs = ka === null, Ls = ka === ka, ll = L1(ka);
            if (jn)
              var Hs = tt || Ls;
            else
              ji ? Hs = Ls && (tt || Io) : Zn ? Hs = Ls && Io && (tt || !gs) : Ir ? Hs = Ls && Io && !gs && (tt || !ll) : gs || ll ? Hs = false : Hs = tt ? ka <= ie : ka < ie;
            Hs ? Mt = ca + 1 : nn = ca;
          }
          return Bv(nn, vr);
        }
        function OM($, ie) {
          for (var De = -1, tt = $.length, Mt = 0, nn = []; ++De < tt; ) {
            var jn = $[De], Zn = ie ? ie(jn) : jn;
            if (!De || !Eb(Zn, Ir)) {
              var Ir = Zn;
              nn[Mt++] = jn === 0 ? 0 : jn;
            }
          }
          return nn;
        }
        function j5($) {
          return typeof $ == "number" ? $ : L1($) ? zn : +$;
        }
        function _g($) {
          if (typeof $ == "string")
            return $;
          if (La($))
            return rp($, _g) + "";
          if (L1($))
            return pF ? pF.call($) : "";
          var ie = $ + "";
          return ie == "0" && 1 / $ == -Kn ? "-0" : ie;
        }
        function PM($, ie, De) {
          var tt = -1, Mt = wb, nn = $.length, jn = true, Zn = [], Ir = Zn;
          if (De)
            jn = false, Mt = Gj;
          else if (nn >= h) {
            var ji = ie ? null : OF($);
            if (ji)
              return w5(ji);
            jn = false, Mt = eI, Ir = new aI();
          } else
            Ir = ie ? [] : Zn;
          e:
            for (; ++tt < nn; ) {
              var ca = $[tt], ka = ie ? ie(ca) : ca;
              if (ca = De || ca !== 0 ? ca : 0, jn && ka === ka) {
                for (var Io = Ir.length; Io--; )
                  if (Ir[Io] === ka)
                    continue e;
                ie && Ir.push(ka), Zn.push(ca);
              } else
                Mt(Ir, ka, De) || (Ir !== Zn && Ir.push(ka), Zn.push(ca));
            }
          return Zn;
        }
        function Ys($, ie) {
          return ie = zv(ie, $), $ = TG($, ie), $ == null || delete $[mw(vm(ie))];
        }
        function mG($, ie, De, tt) {
          return k1($, ie, De(B2($, ie)), tt);
        }
        function p0($, ie, De, tt) {
          for (var Mt = $.length, nn = tt ? Mt : -1; (tt ? nn-- : ++nn < Mt) && ie($[nn], nn, $); )
            ;
          return De ? hy($, tt ? 0 : nn, tt ? nn + 1 : Mt) : hy($, tt ? nn + 1 : 0, tt ? Mt : nn);
        }
        function bG($, ie) {
          var De = $;
          return De instanceof Ru && (De = De.value()), O2(ie, function(tt, Mt) {
            return Mt.func.apply(Mt.thisArg, ow([tt], Mt.args));
          }, De);
        }
        function pI($, ie, De) {
          var tt = $.length;
          if (tt < 2)
            return tt ? PM($[0]) : [];
          for (var Mt = -1, nn = vi(tt); ++Mt < tt; )
            for (var jn = $[Mt], Zn = -1; ++Zn < tt; )
              Zn != Mt && (nn[Mt] = lI(nn[Mt] || jn, $[Zn], ie, De));
          return PM(uv(nn, 1), ie, De);
        }
        function G5($, ie, De) {
          for (var tt = -1, Mt = $.length, nn = ie.length, jn = {}; ++tt < Mt; ) {
            var Zn = tt < nn ? ie[tt] : e3;
            De(jn, $[tt], Zn);
          }
          return jn;
        }
        function LM($) {
          return Qp($) ? $ : [];
        }
        function H5($) {
          return typeof $ == "function" ? $ : by;
        }
        function zv($, ie) {
          return La($) ? $ : yI($, ie) ? [$] : tee(xf($));
        }
        var TF = Nu;
        function gw($, ie, De) {
          var tt = $.length;
          return De = De === e3 ? tt : De, !ie && De >= tt ? $ : hy($, ie, De);
        }
        var AF = I5 || function($) {
          return np.clearTimeout($);
        };
        function LQ($, ie) {
          if (ie)
            return $.slice();
          var De = $.length, tt = Qj ? Qj(De) : new $.constructor(De);
          return $.copy(tt), tt;
        }
        function RM($) {
          var ie = new $.constructor($.byteLength);
          return new nI(ie).set(new nI($)), ie;
        }
        function yde($, ie) {
          var De = ie ? RM($.buffer) : $.buffer;
          return new $.constructor(De, $.byteOffset, $.byteLength);
        }
        function _G($) {
          var ie = new $.constructor($.source, bn.exec($));
          return ie.lastIndex = $.lastIndex, ie;
        }
        function xG($) {
          return cw ? vh(cw.call($)) : {};
        }
        function IF($, ie) {
          var De = ie ? RM($.buffer) : $.buffer;
          return new $.constructor(De, $.byteOffset, $.length);
        }
        function RQ($, ie) {
          if ($ !== ie) {
            var De = $ !== e3, tt = $ === null, Mt = $ === $, nn = L1($), jn = ie !== e3, Zn = ie === null, Ir = ie === ie, ji = L1(ie);
            if (!Zn && !ji && !nn && $ > ie || nn && jn && Ir && !Zn && !ji || tt && jn && Ir || !De && Ir || !Mt)
              return 1;
            if (!tt && !nn && !ji && $ < ie || ji && De && Mt && !tt && !nn || Zn && De && Mt || !jn && Mt || !Ir)
              return -1;
          }
          return 0;
        }
        function mde($, ie, De) {
          for (var tt = -1, Mt = $.criteria, nn = ie.criteria, jn = Mt.length, Zn = De.length; ++tt < jn; ) {
            var Ir = RQ(Mt[tt], nn[tt]);
            if (Ir) {
              if (tt >= Zn)
                return Ir;
              var ji = De[tt];
              return Ir * (ji == "desc" ? -1 : 1);
            }
          }
          return $.index - ie.index;
        }
        function NQ($, ie, De, tt) {
          for (var Mt = -1, nn = $.length, jn = De.length, Zn = -1, Ir = ie.length, ji = Dc(nn - jn, 0), ca = vi(Ir + ji), ka = !tt; ++Zn < Ir; )
            ca[Zn] = ie[Zn];
          for (; ++Mt < jn; )
            (ka || Mt < nn) && (ca[De[Mt]] = $[Mt]);
          for (; ji--; )
            ca[Zn++] = $[Mt++];
          return ca;
        }
        function FQ($, ie, De, tt) {
          for (var Mt = -1, nn = $.length, jn = -1, Zn = De.length, Ir = -1, ji = ie.length, ca = Dc(nn - Zn, 0), ka = vi(ca + ji), Io = !tt; ++Mt < ca; )
            ka[Mt] = $[Mt];
          for (var gs = Mt; ++Ir < ji; )
            ka[gs + Ir] = ie[Ir];
          for (; ++jn < Zn; )
            (Io || Mt < nn) && (ka[gs + De[jn]] = $[Mt++]);
          return ka;
        }
        function py($, ie) {
          var De = -1, tt = $.length;
          for (ie || (ie = vi(tt)); ++De < tt; )
            ie[De] = $[De];
          return ie;
        }
        function D_($, ie, De, tt) {
          var Mt = !De;
          De || (De = {});
          for (var nn = -1, jn = ie.length; ++nn < jn; ) {
            var Zn = ie[nn], Ir = tt ? tt(De[Zn], $[Zn], Zn, De, $) : e3;
            Ir === e3 && (Ir = $[Zn]), Mt ? E1(De, Zn, Ir) : DP(De, Zn, Ir);
          }
          return De;
        }
        function VQ($, ie) {
          return D_($, NM($), ie);
        }
        function vs($, ie) {
          return D_($, KQ($), ie);
        }
        function dI($, ie) {
          return function(De, tt) {
            var Mt = La(De) ? so : SQ, nn = ie ? ie() : {};
            return Mt(De, $, Ks(tt, 2), nn);
          };
        }
        function vI($) {
          return Nu(function(ie, De) {
            var tt = -1, Mt = De.length, nn = Mt > 1 ? De[Mt - 1] : e3, jn = Mt > 2 ? De[2] : e3;
            for (nn = $.length > 3 && typeof nn == "function" ? (Mt--, nn) : e3, jn && wg(De[0], De[1], jn) && (nn = Mt < 3 ? e3 : nn, Mt = 1), ie = vh(ie); ++tt < Mt; ) {
              var Zn = De[tt];
              Zn && $(ie, Zn, tt, nn);
            }
            return ie;
          });
        }
        function BQ($, ie) {
          return function(De, tt) {
            if (De == null)
              return De;
            if (!gy(De))
              return $(De, tt);
            for (var Mt = De.length, nn = ie ? Mt : -1, jn = vh(De); (ie ? nn-- : ++nn < Mt) && tt(jn[nn], nn, jn) !== false; )
              ;
            return De;
          };
        }
        function zQ($) {
          return function(ie, De, tt) {
            for (var Mt = -1, nn = vh(ie), jn = tt(ie), Zn = jn.length; Zn--; ) {
              var Ir = jn[$ ? Zn : ++Mt];
              if (De(nn[Ir], Ir, nn) === false)
                break;
            }
            return ie;
          };
        }
        function bde($, ie, De) {
          var tt = ie & te, Mt = U5($);
          function nn() {
            var jn = this && this !== np && this instanceof nn ? Mt : $;
            return jn.apply(tt ? De : this, arguments);
          }
          return nn;
        }
        function wG($) {
          return function(ie) {
            ie = xf(ie);
            var De = x5(ie) ? Cb(ie) : e3, tt = De ? De[0] : ie.charAt(0), Mt = De ? gw(De, 1).join("") : ie.slice(1);
            return tt[$]() + Mt;
          };
        }
        function W5($) {
          return function(ie) {
            return O2(mH(dH(ie).replace(Vpe, "")), $, "");
          };
        }
        function U5($) {
          return function() {
            var ie = arguments;
            switch (ie.length) {
              case 0:
                return new $();
              case 1:
                return new $(ie[0]);
              case 2:
                return new $(ie[0], ie[1]);
              case 3:
                return new $(ie[0], ie[1], ie[2]);
              case 4:
                return new $(ie[0], ie[1], ie[2], ie[3]);
              case 5:
                return new $(ie[0], ie[1], ie[2], ie[3], ie[4]);
              case 6:
                return new $(ie[0], ie[1], ie[2], ie[3], ie[4], ie[5]);
              case 7:
                return new $(ie[0], ie[1], ie[2], ie[3], ie[4], ie[5], ie[6]);
            }
            var De = mg($.prototype), tt = $.apply(De, ie);
            return Hh(tt) ? tt : De;
          };
        }
        function jQ($, ie, De) {
          var tt = U5($);
          function Mt() {
            for (var nn = arguments.length, jn = vi(nn), Zn = nn, Ir = gI(Mt); Zn--; )
              jn[Zn] = arguments[Zn];
            var ji = nn < 3 && jn[0] !== Ir && jn[nn - 1] !== Ir ? [] : CM(jn, Ir);
            if (nn -= ji.length, nn < De)
              return SG($, ie, Da, Mt.placeholder, e3, jn, ji, e3, e3, De - nn);
            var ca = this && this !== np && this instanceof Mt ? tt : $;
            return fm(ca, this, jn);
          }
          return Mt;
        }
        function GQ($) {
          return function(ie, De, tt) {
            var Mt = vh(ie);
            if (!gy(ie)) {
              var nn = Ks(De, 3);
              ie = fv(ie), De = function(Zn) {
                return nn(Mt[Zn], Zn, Mt);
              };
            }
            var jn = $(ie, De, tt);
            return jn > -1 ? Mt[nn ? ie[jn] : jn] : e3;
          };
        }
        function Bc($) {
          return yw(function(ie) {
            var De = ie.length, tt = De, Mt = A1.prototype.thru;
            for ($ && ie.reverse(); tt--; ) {
              var nn = ie[tt];
              if (typeof nn != "function")
                throw new T1(m3);
              if (Mt && !jn && Fu(nn) == "wrapper")
                var jn = new A1([], true);
            }
            for (tt = jn ? tt : De; ++tt < De; ) {
              nn = ie[tt];
              var Zn = Fu(nn), Ir = Zn == "wrapper" ? FF(nn) : e3;
              Ir && CG(Ir[0]) && Ir[1] == (We | me | Be | Ue) && !Ir[4].length && Ir[9] == 1 ? jn = jn[Fu(Ir[0])].apply(jn, Ir[3]) : jn = nn.length == 1 && CG(nn) ? jn[Zn]() : jn.thru(nn);
            }
            return function() {
              var ji = arguments, ca = ji[0];
              if (jn && ji.length == 1 && La(ca))
                return jn.plant(ca).value();
              for (var ka = 0, Io = De ? ie[ka].apply(this, ji) : ca; ++ka < De; )
                Io = ie[ka].call(this, Io);
              return Io;
            };
          });
        }
        function Da($, ie, De, tt, Mt, nn, jn, Zn, Ir, ji) {
          var ca = ie & We, ka = ie & te, Io = ie & ne, gs = ie & (me | ve), Ls = ie & qe, ll = Io ? e3 : U5($);
          function Hs() {
            for (var tc = arguments.length, zc = vi(tc), Sg = tc; Sg--; )
              zc[Sg] = arguments[Sg];
            if (gs)
              var v0 = gI(Hs), N1 = Hpe(zc, v0);
            if (tt && (zc = NQ(zc, tt, Mt, gs)), nn && (zc = FQ(zc, nn, jn, gs)), tc -= N1, gs && tc < ji) {
              var ip = CM(zc, v0);
              return SG($, ie, Da, Hs.placeholder, De, zc, ip, Zn, Ir, ji - tc);
            }
            var _y = ka ? De : this, Aw = Io ? _y[$] : $;
            return tc = zc.length, Zn ? zc = Ide(zc, Zn) : Ls && tc > 1 && zc.reverse(), ca && Ir < tc && (zc.length = Ir), this && this !== np && this instanceof Hs && (Aw = ll || U5(Aw)), Aw.apply(_y, zc);
          }
          return Hs;
        }
        function mp($, ie) {
          return function(De, tt) {
            return hde(De, $, ie(tt), {});
          };
        }
        function dy($, ie) {
          return function(De, tt) {
            var Mt;
            if (De === e3 && tt === e3)
              return ie;
            if (De !== e3 && (Mt = De), tt !== e3) {
              if (Mt === e3)
                return tt;
              typeof De == "string" || typeof tt == "string" ? (De = _g(De), tt = _g(tt)) : (De = j5(De), tt = j5(tt)), Mt = $(De, tt);
            }
            return Mt;
          };
        }
        function Tb($) {
          return yw(function(ie) {
            return ie = rp(ie, pm(Ks())), Nu(function(De) {
              var tt = this;
              return $(ie, function(Mt) {
                return fm(Mt, tt, De);
              });
            });
          });
        }
        function EF($, ie) {
          ie = ie === e3 ? " " : _g(ie);
          var De = ie.length;
          if (De < 2)
            return De ? RP(ie, $) : ie;
          var tt = RP(ie, Jp($ / S5(ie)));
          return x5(ie) ? gw(Cb(tt), 0, $).join("") : tt.slice(0, $);
        }
        function HQ($, ie, De, tt) {
          var Mt = ie & te, nn = U5($);
          function jn() {
            for (var Zn = -1, Ir = arguments.length, ji = -1, ca = tt.length, ka = vi(ca + Ir), Io = this && this !== np && this instanceof jn ? nn : $; ++ji < ca; )
              ka[ji] = tt[ji];
            for (; Ir--; )
              ka[ji++] = arguments[++Zn];
            return fm(Io, Mt ? De : this, ka);
          }
          return jn;
        }
        function WQ($) {
          return function(ie, De, tt) {
            return tt && typeof tt != "number" && wg(ie, De, tt) && (De = tt = e3), ie = Hv(ie), De === e3 ? (De = ie, ie = 0) : De = Hv(De), tt = tt === e3 ? ie < De ? 1 : -1 : Hv(tt), yG(ie, De, tt, $);
          };
        }
        function DF($) {
          return function(ie, De) {
            return typeof ie == "string" && typeof De == "string" || (ie = R1(ie), De = R1(De)), $(ie, De);
          };
        }
        function SG($, ie, De, tt, Mt, nn, jn, Zn, Ir, ji) {
          var ca = ie & me, ka = ca ? jn : e3, Io = ca ? e3 : jn, gs = ca ? nn : e3, Ls = ca ? e3 : nn;
          ie |= ca ? Be : Oe, ie &= ~(ca ? Oe : Be), ie & ce || (ie &= ~(te | ne));
          var ll = [$, ie, Mt, gs, ka, Ls, Io, Zn, Ir, ji], Hs = De.apply(e3, ll);
          return CG($) && VF(Hs, ll), Hs.placeholder = tt, FM(Hs, $, ie);
        }
        function kF($) {
          var ie = Bp[$];
          return function(De, tt) {
            if (De = R1(De), tt = tt == null ? 0 : Bv(sl(tt), 292), tt && F2(De)) {
              var Mt = (xf(De) + "e").split("e"), nn = ie(Mt[0] + "e" + (+Mt[1] + tt));
              return Mt = (xf(nn) + "e").split("e"), +(Mt[0] + "e" + (+Mt[1] - tt));
            }
            return ie(De);
          };
        }
        var OF = k5 && 1 / w5(new k5([, -0]))[1] == Kn ? function($) {
          return new k5($);
        } : i8;
        function UQ($) {
          return function(ie) {
            var De = xg(ie);
            return De == ds ? mP(ie) : De == Ef ? qpe(ie) : Gpe(ie, $(ie));
          };
        }
        function jv($, ie, De, tt, Mt, nn, jn, Zn) {
          var Ir = ie & ne;
          if (!Ir && typeof $ != "function")
            throw new T1(m3);
          var ji = tt ? tt.length : 0;
          if (ji || (ie &= ~(Be | Oe), tt = Mt = e3), jn = jn === e3 ? jn : Dc(sl(jn), 0), Zn = Zn === e3 ? Zn : sl(Zn), ji -= Mt ? Mt.length : 0, ie & Oe) {
            var ca = tt, ka = Mt;
            tt = Mt = e3;
          }
          var Io = Ir ? e3 : FF($), gs = [$, ie, De, tt, Mt, ca, ka, nn, jn, Zn];
          if (Io && MG(gs, Io), $ = gs[0], ie = gs[1], De = gs[2], tt = gs[3], Mt = gs[4], Zn = gs[9] = gs[9] === e3 ? Ir ? 0 : $.length : Dc(gs[9] - ji, 0), !Zn && ie & (me | ve) && (ie &= ~(me | ve)), !ie || ie == te)
            var Ls = bde($, ie, De);
          else
            ie == me || ie == ve ? Ls = jQ($, ie, Zn) : (ie == Be || ie == (te | Be)) && !Mt.length ? Ls = HQ($, ie, De, tt) : Ls = Da.apply(e3, gs);
          var ll = Io ? PQ : VF;
          return FM(ll(Ls, gs), $, ie);
        }
        function qQ($, ie, De, tt) {
          return $ === e3 || Eb($, M5[De]) && !Jc.call(tt, De) ? ie : $;
        }
        function PF($, ie, De, tt, Mt, nn) {
          return Hh($) && Hh(ie) && (nn.set(ie, $), D1($, ie, e3, PF, nn), nn.delete(ie)), $;
        }
        function $Q($) {
          return $P($) ? e3 : $;
        }
        function LF($, ie, De, tt, Mt, nn) {
          var jn = De & W, Zn = $.length, Ir = ie.length;
          if (Zn != Ir && !(jn && Ir > Zn))
            return false;
          var ji = nn.get($), ca = nn.get(ie);
          if (ji && ca)
            return ji == ie && ca == $;
          var ka = -1, Io = true, gs = De & K ? new aI() : e3;
          for (nn.set($, ie), nn.set(ie, $); ++ka < Zn; ) {
            var Ls = $[ka], ll = ie[ka];
            if (tt)
              var Hs = jn ? tt(ll, Ls, ka, ie, $, nn) : tt(Ls, ll, ka, $, ie, nn);
            if (Hs !== e3) {
              if (Hs)
                continue;
              Io = false;
              break;
            }
            if (gs) {
              if (!Wj(ie, function(tc, zc) {
                if (!eI(gs, zc) && (Ls === tc || Mt(Ls, tc, De, tt, nn)))
                  return gs.push(zc);
              })) {
                Io = false;
                break;
              }
            } else if (!(Ls === ll || Mt(Ls, ll, De, tt, nn))) {
              Io = false;
              break;
            }
          }
          return nn.delete($), nn.delete(ie), Io;
        }
        function XQ($, ie, De, tt, Mt, nn, jn) {
          switch (De) {
            case Zi:
              if ($.byteLength != ie.byteLength || $.byteOffset != ie.byteOffset)
                return false;
              $ = $.buffer, ie = ie.buffer;
            case Ur:
              return !($.byteLength != ie.byteLength || !nn(new nI($), new nI(ie)));
            case Pa:
            case fo:
            case Lu:
              return Eb(+$, +ie);
            case $a:
              return $.name == ie.name && $.message == ie.message;
            case vg:
            case md:
              return $ == ie + "";
            case ds:
              var Zn = mP;
            case Ef:
              var Ir = tt & W;
              if (Zn || (Zn = w5), $.size != ie.size && !Ir)
                return false;
              var ji = jn.get($);
              if (ji)
                return ji == ie;
              tt |= K, jn.set($, ie);
              var ca = LF(Zn($), Zn(ie), tt, Mt, nn, jn);
              return jn.delete($), ca;
            case Gh:
              if (cw)
                return cw.call($) == cw.call(ie);
          }
          return false;
        }
        function G2($, ie, De, tt, Mt, nn) {
          var jn = De & W, Zn = RF($), Ir = Zn.length, ji = RF(ie), ca = ji.length;
          if (Ir != ca && !jn)
            return false;
          for (var ka = Ir; ka--; ) {
            var Io = Zn[ka];
            if (!(jn ? Io in ie : Jc.call(ie, Io)))
              return false;
          }
          var gs = nn.get($), Ls = nn.get(ie);
          if (gs && Ls)
            return gs == ie && Ls == $;
          var ll = true;
          nn.set($, ie), nn.set(ie, $);
          for (var Hs = jn; ++ka < Ir; ) {
            Io = Zn[ka];
            var tc = $[Io], zc = ie[Io];
            if (tt)
              var Sg = jn ? tt(zc, tc, Io, ie, $, nn) : tt(tc, zc, Io, $, ie, nn);
            if (!(Sg === e3 ? tc === zc || Mt(tc, zc, De, tt, nn) : Sg)) {
              ll = false;
              break;
            }
            Hs || (Hs = Io == "constructor");
          }
          if (ll && !Hs) {
            var v0 = $.constructor, N1 = ie.constructor;
            v0 != N1 && "constructor" in $ && "constructor" in ie && !(typeof v0 == "function" && v0 instanceof v0 && typeof N1 == "function" && N1 instanceof N1) && (ll = false);
          }
          return nn.delete($), nn.delete(ie), ll;
        }
        function yw($) {
          return IG(q5($, e3, BP), $ + "");
        }
        function RF($) {
          return fG($, fv, NM);
        }
        function NF($) {
          return fG($, mm, KQ);
        }
        var FF = hF ? function($) {
          return hF.get($);
        } : i8;
        function Fu($) {
          for (var ie = $.name + "", De = P5[ie], tt = Jc.call(P5, ie) ? De.length : 0; tt--; ) {
            var Mt = De[tt], nn = Mt.func;
            if (nn == null || nn == $)
              return Mt.name;
          }
          return ie;
        }
        function gI($) {
          var ie = Jc.call(Ht, "placeholder") ? Ht : $;
          return ie.placeholder;
        }
        function Ks() {
          var $ = Ht.iteratee || Ud;
          return $ = $ === Ud ? wF : $, arguments.length ? $(arguments[0], arguments[1]) : $;
        }
        function NP($, ie) {
          var De = $.__data__;
          return Cde(ie) ? De[typeof ie == "string" ? "string" : "hash"] : De.map;
        }
        function Wc($) {
          for (var ie = fv($), De = ie.length; De--; ) {
            var tt = ie[De], Mt = $[tt];
            ie[De] = [tt, Mt, mu(Mt)];
          }
          return ie;
        }
        function O1($, ie) {
          var De = Xj($, ie);
          return EQ(De) ? De : e3;
        }
        function YQ($) {
          var ie = Jc.call($, f0), De = $[f0];
          try {
            $[f0] = e3;
            var tt = true;
          } catch {
          }
          var Mt = A5.call($);
          return tt && (ie ? $[f0] = De : delete $[f0]), Mt;
        }
        var NM = E5 ? function($) {
          return $ == null ? [] : ($ = vh($), Zp(E5($), function(ie) {
            return _P.call($, ie);
          }));
        } : a8, KQ = E5 ? function($) {
          for (var ie = []; $; )
            ow(ie, NM($)), $ = rI($);
          return ie;
        } : a8, xg = h0;
        (tG && xg(new tG(new ArrayBuffer(1))) != Zi || SP && xg(new SP()) != ds || CP && xg(CP.resolve()) != sv || k5 && xg(new k5()) != Ef || MP && xg(new MP()) != Ki) && (xg = function($) {
          var ie = h0($), De = ie == Kc ? $.constructor : e3, tt = De ? H2(De) : "";
          if (tt)
            switch (tt) {
              case TP:
                return Zi;
              case gQ:
                return ds;
              case I_:
                return sv;
              case tde:
                return Ef;
              case AP:
                return Ki;
            }
          return ie;
        });
        function _de($, ie, De) {
          for (var tt = -1, Mt = De.length; ++tt < Mt; ) {
            var nn = De[tt], jn = nn.size;
            switch (nn.type) {
              case "drop":
                $ += jn;
                break;
              case "dropRight":
                ie -= jn;
                break;
              case "take":
                ie = Bv(ie, $ + jn);
                break;
              case "takeRight":
                $ = Dc($, ie - jn);
                break;
            }
          }
          return { start: $, end: ie };
        }
        function xde($) {
          var ie = $.match(Bj);
          return ie ? ie[1].split(zj) : [];
        }
        function ZQ($, ie, De) {
          ie = zv(ie, $);
          for (var tt = -1, Mt = ie.length, nn = false; ++tt < Mt; ) {
            var jn = mw(ie[tt]);
            if (!(nn = $ != null && De($, jn)))
              break;
            $ = $[jn];
          }
          return nn || ++tt != Mt ? nn : (Mt = $ == null ? 0 : $.length, !!Mt && $M(Mt) && Jf(jn, Mt) && (La($) || Fl($)));
        }
        function wde($) {
          var ie = $.length, De = new $.constructor(ie);
          return ie && typeof $[0] == "string" && Jc.call($, "index") && (De.index = $.index, De.input = $.input), De;
        }
        function JQ($) {
          return typeof $.constructor == "function" && !k_($) ? mg(rI($)) : {};
        }
        function Sde($, ie, De) {
          var tt = $.constructor;
          switch (ie) {
            case Ur:
              return RM($);
            case Pa:
            case fo:
              return new tt(+$);
            case Zi:
              return yde($, De);
            case uo:
            case us:
            case Jl:
            case Ql:
            case sf:
            case ep:
            case hh:
            case bd:
            case ph:
              return IF($, De);
            case ds:
              return new tt();
            case Lu:
            case md:
              return new tt($);
            case vg:
              return _G($);
            case Ef:
              return new tt();
            case Gh:
              return xG($);
          }
        }
        function QQ($, ie) {
          var De = ie.length;
          if (!De)
            return $;
          var tt = De - 1;
          return ie[tt] = (De > 1 ? "& " : "") + ie[tt], ie = ie.join(De > 2 ? ", " : " "), $.replace(Vj, `{
/* [wrapped with ` + ie + `] */
`);
        }
        function FP($) {
          return La($) || Fl($) || !!(eG && $ && $[eG]);
        }
        function Jf($, ie) {
          var De = typeof $;
          return ie = ie == null ? hn : ie, !!ie && (De == "number" || De != "symbol" && Sr.test($)) && $ > -1 && $ % 1 == 0 && $ < ie;
        }
        function wg($, ie, De) {
          if (!Hh(De))
            return false;
          var tt = typeof ie;
          return (tt == "number" ? gy(De) && Jf(ie, De.length) : tt == "string" && ie in De) ? Eb(De[ie], $) : false;
        }
        function yI($, ie) {
          if (La($))
            return false;
          var De = typeof $;
          return De == "number" || De == "symbol" || De == "boolean" || $ == null || L1($) ? true : x1.test($) || !oy.test($) || ie != null && $ in vh(ie);
        }
        function Cde($) {
          var ie = typeof $;
          return ie == "string" || ie == "number" || ie == "symbol" || ie == "boolean" ? $ !== "__proto__" : $ === null;
        }
        function CG($) {
          var ie = Fu($), De = Ht[ie];
          if (typeof De != "function" || !(ie in Ru.prototype))
            return false;
          if ($ === De)
            return true;
          var tt = FF(De);
          return !!tt && $ === tt[0];
        }
        function Mde($) {
          return !!Jj && Jj in $;
        }
        var Tde = tI ? my : q2;
        function k_($) {
          var ie = $ && $.constructor, De = typeof ie == "function" && ie.prototype || M5;
          return $ === De;
        }
        function mu($) {
          return $ === $ && !Hh($);
        }
        function eee($, ie) {
          return function(De) {
            return De == null ? false : De[$] === ie && (ie !== e3 || $ in vh(De));
          };
        }
        function VP($) {
          var ie = XF($, function(tt) {
            return De.size === A2 && De.clear(), tt;
          }), De = ie.cache;
          return ie;
        }
        function MG($, ie) {
          var De = $[1], tt = ie[1], Mt = De | tt, nn = Mt < (te | ne | We), jn = tt == We && De == me || tt == We && De == Ue && $[7].length <= ie[8] || tt == (We | Ue) && ie[7].length <= ie[8] && De == me;
          if (!(nn || jn))
            return $;
          tt & te && ($[2] = ie[2], Mt |= De & te ? 0 : ce);
          var Zn = ie[3];
          if (Zn) {
            var Ir = $[3];
            $[3] = Ir ? NQ(Ir, Zn, ie[4]) : Zn, $[4] = Ir ? CM($[3], D) : ie[4];
          }
          return Zn = ie[5], Zn && (Ir = $[5], $[5] = Ir ? FQ(Ir, Zn, ie[6]) : Zn, $[6] = Ir ? CM($[5], D) : ie[6]), Zn = ie[7], Zn && ($[7] = Zn), tt & We && ($[8] = $[8] == null ? ie[8] : Bv($[8], ie[8])), $[9] == null && ($[9] = ie[9]), $[0] = ie[0], $[1] = Mt, $;
        }
        function xd($) {
          var ie = [];
          if ($ != null)
            for (var De in vh($))
              ie.push(De);
          return ie;
        }
        function Ade($) {
          return A5.call($);
        }
        function q5($, ie, De) {
          return ie = Dc(ie === e3 ? $.length - 1 : ie, 0), function() {
            for (var tt = arguments, Mt = -1, nn = Dc(tt.length - ie, 0), jn = vi(nn); ++Mt < nn; )
              jn[Mt] = tt[ie + Mt];
            Mt = -1;
            for (var Zn = vi(ie + 1); ++Mt < ie; )
              Zn[Mt] = tt[Mt];
            return Zn[ie] = De(jn), fm($, this, Zn);
          };
        }
        function TG($, ie) {
          return ie.length < 2 ? $ : B2($, hy(ie, 0, -1));
        }
        function Ide($, ie) {
          for (var De = $.length, tt = Bv(ie.length, De), Mt = py($); tt--; ) {
            var nn = ie[tt];
            $[tt] = Jf(nn, De) ? Mt[nn] : e3;
          }
          return $;
        }
        function AG($, ie) {
          if (!(ie === "constructor" && typeof $[ie] == "function") && ie != "__proto__")
            return $[ie];
        }
        var VF = EG(PQ), $5 = fQ || function($, ie) {
          return np.setTimeout($, ie);
        }, IG = EG(Bs);
        function FM($, ie, De) {
          var tt = ie + "";
          return IG($, QQ(tt, Ede(xde(tt), De)));
        }
        function EG($) {
          var ie = 0, De = 0;
          return function() {
            var tt = ede(), Mt = pt - (tt - De);
            if (De = tt, Mt > 0) {
              if (++ie >= _t)
                return arguments[0];
            } else
              ie = 0;
            return $.apply(e3, arguments);
          };
        }
        function P1($, ie) {
          var De = -1, tt = $.length, Mt = tt - 1;
          for (ie = ie === e3 ? tt : ie; ++De < ie; ) {
            var nn = kM(De, Mt), jn = $[nn];
            $[nn] = $[De], $[De] = jn;
          }
          return $.length = ie, $;
        }
        var tee = VP(function($) {
          var ie = [];
          return $.charCodeAt(0) === 46 && ie.push(""), $.replace(_M, function(De, tt, Mt, nn) {
            ie.push(Mt ? nn.replace(Rn, "$1") : tt || De);
          }), ie;
        });
        function mw($) {
          if (typeof $ == "string" || L1($))
            return $;
          var ie = $ + "";
          return ie == "0" && 1 / $ == -Kn ? "-0" : ie;
        }
        function H2($) {
          if ($ != null) {
            try {
              return c0.call($);
            } catch {
            }
            try {
              return $ + "";
            } catch {
            }
          }
          return "";
        }
        function Ede($, ie) {
          return uf(Ba, function(De) {
            var tt = "_." + De[0];
            ie & De[1] && !wb($, tt) && $.push(tt);
          }), $.sort();
        }
        function DG($) {
          if ($ instanceof Ru)
            return $.clone();
          var ie = new A1($.__wrapped__, $.__chain__);
          return ie.__actions__ = py($.__actions__), ie.__index__ = $.__index__, ie.__values__ = $.__values__, ie;
        }
        function Dde($, ie, De) {
          (De ? wg($, ie, De) : ie === e3) ? ie = 1 : ie = Dc(sl(ie), 0);
          var tt = $ == null ? 0 : $.length;
          if (!tt || ie < 1)
            return [];
          for (var Mt = 0, nn = 0, jn = vi(Jp(tt / ie)); Mt < tt; )
            jn[nn++] = hy($, Mt, Mt += ie);
          return jn;
        }
        function kde($) {
          for (var ie = -1, De = $ == null ? 0 : $.length, tt = 0, Mt = []; ++ie < De; ) {
            var nn = $[ie];
            nn && (Mt[tt++] = nn);
          }
          return Mt;
        }
        function Ode() {
          var $ = arguments.length;
          if (!$)
            return [];
          for (var ie = vi($ - 1), De = arguments[0], tt = $; tt--; )
            ie[tt - 1] = arguments[tt];
          return ow(La(De) ? py(De) : [De], uv(ie, 1));
        }
        var Pde = Nu(function($, ie) {
          return Qp($) ? lI($, uv(ie, 1, Qp, true)) : [];
        }), BF = Nu(function($, ie) {
          var De = vm(ie);
          return Qp(De) && (De = e3), Qp($) ? lI($, uv(ie, 1, Qp, true), Ks(De, 2)) : [];
        }), mI = Nu(function($, ie) {
          var De = vm(ie);
          return Qp(De) && (De = e3), Qp($) ? lI($, uv(ie, 1, Qp, true), e3, De) : [];
        });
        function Lde($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          return tt ? (ie = De || ie === e3 ? 1 : sl(ie), hy($, ie < 0 ? 0 : ie, tt)) : [];
        }
        function Rde($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          return tt ? (ie = De || ie === e3 ? 1 : sl(ie), ie = tt - ie, hy($, 0, ie < 0 ? 0 : ie)) : [];
        }
        function Nde($, ie) {
          return $ && $.length ? p0($, Ks(ie, 3), true, true) : [];
        }
        function kG($, ie) {
          return $ && $.length ? p0($, Ks(ie, 3), true) : [];
        }
        function Fde($, ie, De, tt) {
          var Mt = $ == null ? 0 : $.length;
          return Mt ? (De && typeof De != "number" && wg($, ie, De) && (De = 0, tt = Mt), kP($, ie, De, tt)) : [];
        }
        function zF($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          if (!tt)
            return -1;
          var Mt = De == null ? 0 : sl(De);
          return Mt < 0 && (Mt = Dc(tt + Mt, 0)), oF($, Ks(ie, 3), Mt);
        }
        function OG($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          if (!tt)
            return -1;
          var Mt = tt - 1;
          return De !== e3 && (Mt = sl(De), Mt = De < 0 ? Dc(tt + Mt, 0) : Bv(Mt, tt - 1)), oF($, Ks(ie, 3), Mt, true);
        }
        function BP($) {
          var ie = $ == null ? 0 : $.length;
          return ie ? uv($, 1) : [];
        }
        function PG($) {
          var ie = $ == null ? 0 : $.length;
          return ie ? uv($, Kn) : [];
        }
        function Vde($, ie) {
          var De = $ == null ? 0 : $.length;
          return De ? (ie = ie === e3 ? 1 : sl(ie), uv($, ie)) : [];
        }
        function nee($) {
          for (var ie = -1, De = $ == null ? 0 : $.length, tt = {}; ++ie < De; ) {
            var Mt = $[ie];
            tt[Mt[0]] = Mt[1];
          }
          return tt;
        }
        function LG($) {
          return $ && $.length ? $[0] : e3;
        }
        function Bde($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          if (!tt)
            return -1;
          var Mt = De == null ? 0 : sl(De);
          return Mt < 0 && (Mt = Dc(tt + Mt, 0)), Sb($, ie, Mt);
        }
        function zde($) {
          var ie = $ == null ? 0 : $.length;
          return ie ? hy($, 0, -1) : [];
        }
        var jde = Nu(function($) {
          var ie = rp($, LM);
          return ie.length && ie[0] === $[0] ? bF(ie) : [];
        }), ree = Nu(function($) {
          var ie = vm($), De = rp($, LM);
          return ie === vm(De) ? ie = e3 : De.pop(), De.length && De[0] === $[0] ? bF(De, Ks(ie, 2)) : [];
        }), Gde = Nu(function($) {
          var ie = vm($), De = rp($, LM);
          return ie = typeof ie == "function" ? ie : e3, ie && De.pop(), De.length && De[0] === $[0] ? bF(De, e3, ie) : [];
        });
        function Hde($, ie) {
          return $ == null ? "" : pQ.call($, ie);
        }
        function vm($) {
          var ie = $ == null ? 0 : $.length;
          return ie ? $[ie - 1] : e3;
        }
        function Wde($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          if (!tt)
            return -1;
          var Mt = tt;
          return De !== e3 && (Mt = sl(De), Mt = Mt < 0 ? Dc(tt + Mt, 0) : Bv(Mt, tt - 1)), ie === ie ? sQ($, ie, Mt) : oF($, Vv, Mt, true);
        }
        function Ude($, ie) {
          return $ && $.length ? CF($, sl(ie)) : e3;
        }
        var qde = Nu(RG);
        function RG($, ie) {
          return $ && $.length && ie && ie.length ? z2($, ie) : $;
        }
        function NG($, ie, De) {
          return $ && $.length && ie && ie.length ? z2($, ie, Ks(De, 2)) : $;
        }
        function bI($, ie, De) {
          return $ && $.length && ie && ie.length ? z2($, ie, e3, De) : $;
        }
        var jF = yw(function($, ie) {
          var De = $ == null ? 0 : $.length, tt = V5($, ie);
          return DM($, rp(ie, function(Mt) {
            return Jf(Mt, De) ? +Mt : Mt;
          }).sort(RQ)), tt;
        });
        function iee($, ie) {
          var De = [];
          if (!($ && $.length))
            return De;
          var tt = -1, Mt = [], nn = $.length;
          for (ie = Ks(ie, 3); ++tt < nn; ) {
            var jn = $[tt];
            ie(jn, tt, $) && (De.push(jn), Mt.push(tt));
          }
          return DM($, Mt), De;
        }
        function FG($) {
          return $ == null ? $ : vQ.call($);
        }
        function $de($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          return tt ? (De && typeof De != "number" && wg($, ie, De) ? (ie = 0, De = tt) : (ie = ie == null ? 0 : sl(ie), De = De === e3 ? tt : sl(De)), hy($, ie, De)) : [];
        }
        function VG($, ie) {
          return vw($, ie);
        }
        function BG($, ie, De) {
          return j2($, ie, Ks(De, 2));
        }
        function Xde($, ie) {
          var De = $ == null ? 0 : $.length;
          if (De) {
            var tt = vw($, ie);
            if (tt < De && Eb($[tt], ie))
              return tt;
          }
          return -1;
        }
        function Ab($, ie) {
          return vw($, ie, true);
        }
        function gm($, ie, De) {
          return j2($, ie, Ks(De, 2), true);
        }
        function ym($, ie) {
          var De = $ == null ? 0 : $.length;
          if (De) {
            var tt = vw($, ie, true) - 1;
            if (Eb($[tt], ie))
              return tt;
          }
          return -1;
        }
        function zG($) {
          return $ && $.length ? OM($) : [];
        }
        function jG($, ie) {
          return $ && $.length ? OM($, Ks(ie, 2)) : [];
        }
        function _I($) {
          var ie = $ == null ? 0 : $.length;
          return ie ? hy($, 1, ie) : [];
        }
        function GF($, ie, De) {
          return $ && $.length ? (ie = De || ie === e3 ? 1 : sl(ie), hy($, 0, ie < 0 ? 0 : ie)) : [];
        }
        function HF($, ie, De) {
          var tt = $ == null ? 0 : $.length;
          return tt ? (ie = De || ie === e3 ? 1 : sl(ie), ie = tt - ie, hy($, ie < 0 ? 0 : ie, tt)) : [];
        }
        function WF($, ie) {
          return $ && $.length ? p0($, Ks(ie, 3), false, true) : [];
        }
        function UF($, ie) {
          return $ && $.length ? p0($, Ks(ie, 3)) : [];
        }
        var aee = Nu(function($) {
          return PM(uv($, 1, Qp, true));
        }), oee = Nu(function($) {
          var ie = vm($);
          return Qp(ie) && (ie = e3), PM(uv($, 1, Qp, true), Ks(ie, 2));
        }), see = Nu(function($) {
          var ie = vm($);
          return ie = typeof ie == "function" ? ie : e3, PM(uv($, 1, Qp, true), e3, ie);
        });
        function Yde($) {
          return $ && $.length ? PM($) : [];
        }
        function Kde($, ie) {
          return $ && $.length ? PM($, Ks(ie, 2)) : [];
        }
        function Zde($, ie) {
          return ie = typeof ie == "function" ? ie : e3, $ && $.length ? PM($, e3, ie) : [];
        }
        function ff($) {
          if (!($ && $.length))
            return [];
          var ie = 0;
          return $ = Zp($, function(De) {
            if (Qp(De))
              return ie = Dc(De.length, ie), true;
          }), hm(ie, function(De) {
            return rp($, sw(De));
          });
        }
        function VM($, ie) {
          if (!($ && $.length))
            return [];
          var De = ff($);
          return ie == null ? De : rp(De, function(tt) {
            return fm(ie, e3, tt);
          });
        }
        var xI = Nu(function($, ie) {
          return Qp($) ? lI($, ie) : [];
        }), bw = Nu(function($) {
          return pI(Zp($, Qp));
        }), BM = Nu(function($) {
          var ie = vm($);
          return Qp(ie) && (ie = e3), pI(Zp($, Qp), Ks(ie, 2));
        }), _w = Nu(function($) {
          var ie = vm($);
          return ie = typeof ie == "function" ? ie : e3, pI(Zp($, Qp), e3, ie);
        }), xw = Nu(ff);
        function GG($, ie) {
          return G5($ || [], ie || [], DP);
        }
        function HG($, ie) {
          return G5($ || [], ie || [], k1);
        }
        var wI = Nu(function($) {
          var ie = $.length, De = ie > 1 ? $[ie - 1] : e3;
          return De = typeof De == "function" ? ($.pop(), De) : e3, VM($, De);
        });
        function zM($) {
          var ie = Ht($);
          return ie.__chain__ = true, ie;
        }
        function W2($, ie) {
          return ie($), $;
        }
        function X5($, ie) {
          return ie($);
        }
        var jM = yw(function($) {
          var ie = $.length, De = ie ? $[0] : 0, tt = this.__wrapped__, Mt = function(nn) {
            return V5(nn, $);
          };
          return ie > 1 || this.__actions__.length || !(tt instanceof Ru) || !Jf(De) ? this.thru(Mt) : (tt = tt.slice(De, +De + (ie ? 1 : 0)), tt.__actions__.push({ func: X5, args: [Mt], thisArg: e3 }), new A1(tt, this.__chain__).thru(function(nn) {
            return ie && !nn.length && nn.push(e3), nn;
          }));
        });
        function WG() {
          return zM(this);
        }
        function zP() {
          return new A1(this.value(), this.__chain__);
        }
        function UG() {
          this.__values__ === e3 && (this.__values__ = rH(this.value()));
          var $ = this.__index__ >= this.__values__.length, ie = $ ? e3 : this.__values__[this.__index__++];
          return { done: $, value: ie };
        }
        function Jde() {
          return this;
        }
        function Qde($) {
          for (var ie, De = this; De instanceof R5; ) {
            var tt = DG(De);
            tt.__index__ = 0, tt.__values__ = e3, ie ? Mt.__wrapped__ = tt : ie = tt;
            var Mt = tt;
            De = De.__wrapped__;
          }
          return Mt.__wrapped__ = $, ie;
        }
        function ww() {
          var $ = this.__wrapped__;
          if ($ instanceof Ru) {
            var ie = $;
            return this.__actions__.length && (ie = new Ru(this)), ie = ie.reverse(), ie.__actions__.push({ func: X5, args: [FG], thisArg: e3 }), new A1(ie, this.__chain__);
          }
          return this.thru(FG);
        }
        function GM() {
          return bG(this.__wrapped__, this.__actions__);
        }
        var eve = dI(function($, ie, De) {
          Jc.call($, De) ? ++$[De] : E1($, De, 1);
        });
        function lee($, ie, De) {
          var tt = La($) ? wM : MQ;
          return De && wg($, ie, De) && (ie = e3), tt($, Ks(ie, 3));
        }
        function uee($, ie) {
          var De = La($) ? Zp : TQ;
          return De($, Ks(ie, 3));
        }
        var HM = GQ(zF), jP = GQ(OG);
        function tve($, ie) {
          return uv(qF($, ie), 1);
        }
        function U2($, ie) {
          return uv(qF($, ie), Kn);
        }
        function WM($, ie, De) {
          return De = De === e3 ? 1 : sl(De), uv(qF($, ie), De);
        }
        function UM($, ie) {
          var De = La($) ? uf : fw;
          return De($, Ks(ie, 3));
        }
        function cee($, ie) {
          var De = La($) ? aF : uG;
          return De($, Ks(ie, 3));
        }
        var nve = dI(function($, ie, De) {
          Jc.call($, De) ? $[De].push(ie) : E1($, De, [ie]);
        });
        function vy($, ie, De, tt) {
          $ = gy($) ? $ : kI($), De = De && !tt ? sl(De) : 0;
          var Mt = $.length;
          return De < 0 && (De = Dc(Mt + De, 0)), TI($) ? De <= Mt && $.indexOf(ie, De) > -1 : !!Mt && Sb($, ie, De) > -1;
        }
        var Ib = Nu(function($, ie, De) {
          var tt = -1, Mt = typeof ie == "function", nn = gy($) ? vi($.length) : [];
          return fw($, function(jn) {
            nn[++tt] = Mt ? fm(ie, jn, De) : fy(jn, ie, De);
          }), nn;
        }), rve = dI(function($, ie, De) {
          E1($, De, ie);
        });
        function qF($, ie) {
          var De = La($) ? rp : LP;
          return De($, Ks(ie, 3));
        }
        function ive($, ie, De, tt) {
          return $ == null ? [] : (La(ie) || (ie = ie == null ? [] : [ie]), De = tt ? e3 : De, La(De) || (De = De == null ? [] : [De]), fI($, ie, De));
        }
        var ave = dI(function($, ie, De) {
          $[De ? 0 : 1].push(ie);
        }, function() {
          return [[], []];
        });
        function fee($, ie, De) {
          var tt = La($) ? O2 : rQ, Mt = arguments.length < 3;
          return tt($, Ks(ie, 4), De, Mt, fw);
        }
        function ove($, ie, De) {
          var tt = La($) ? Hj : rQ, Mt = arguments.length < 3;
          return tt($, Ks(ie, 4), De, Mt, uG);
        }
        function sve($, ie) {
          var De = La($) ? Zp : TQ;
          return De($, YF(Ks(ie, 3)));
        }
        function $F($) {
          var ie = La($) ? wQ : dw;
          return ie($);
        }
        function lve($, ie, De) {
          (De ? wg($, ie, De) : ie === e3) ? ie = 1 : ie = sl(ie);
          var tt = La($) ? sG : OQ;
          return tt($, ie);
        }
        function qG($) {
          var ie = La($) ? V2 : MF;
          return ie($);
        }
        function uve($) {
          if ($ == null)
            return 0;
          if (gy($))
            return TI($) ? S5($) : $.length;
          var ie = xg($);
          return ie == ds || ie == Ef ? $.size : PP($).length;
        }
        function gl($, ie, De) {
          var tt = La($) ? Wj : hI;
          return De && wg($, ie, De) && (ie = e3), tt($, Ks(ie, 3));
        }
        var cve = Nu(function($, ie) {
          if ($ == null)
            return [];
          var De = ie.length;
          return De > 1 && wg($, ie[0], ie[1]) ? ie = [] : De > 2 && wg(ie[0], ie[1], ie[2]) && (ie = [ie[0]]), fI($, uv(ie, 1), []);
        }), GP = TM || function() {
          return np.Date.now();
        };
        function HP($, ie) {
          if (typeof ie != "function")
            throw new T1(m3);
          return $ = sl($), function() {
            if (--$ < 1)
              return ie.apply(this, arguments);
          };
        }
        function hee($, ie, De) {
          return ie = De ? e3 : ie, ie = $ && ie == null ? $.length : ie, jv($, We, e3, e3, e3, e3, ie);
        }
        function pee($, ie) {
          var De;
          if (typeof ie != "function")
            throw new T1(m3);
          return $ = sl($), function() {
            return --$ > 0 && (De = ie.apply(this, arguments)), $ <= 1 && (ie = e3), De;
          };
        }
        var $G = Nu(function($, ie, De) {
          var tt = te;
          if (De.length) {
            var Mt = CM(De, gI($G));
            tt |= Be;
          }
          return jv($, tt, ie, De, Mt);
        }), XG = Nu(function($, ie, De) {
          var tt = te | ne;
          if (De.length) {
            var Mt = CM(De, gI(XG));
            tt |= Be;
          }
          return jv(ie, tt, $, De, Mt);
        });
        function Gv($, ie, De) {
          ie = De ? e3 : ie;
          var tt = jv($, me, e3, e3, e3, e3, e3, ie);
          return tt.placeholder = Gv.placeholder, tt;
        }
        function dee($, ie, De) {
          ie = De ? e3 : ie;
          var tt = jv($, ve, e3, e3, e3, e3, e3, ie);
          return tt.placeholder = dee.placeholder, tt;
        }
        function SI($, ie, De) {
          var tt, Mt, nn, jn, Zn, Ir, ji = 0, ca = false, ka = false, Io = true;
          if (typeof $ != "function")
            throw new T1(m3);
          ie = R1(ie) || 0, Hh(De) && (ca = !!De.leading, ka = "maxWait" in De, nn = ka ? Dc(R1(De.maxWait) || 0, ie) : nn, Io = "trailing" in De ? !!De.trailing : Io);
          function gs(ip) {
            var _y = tt, Aw = Mt;
            return tt = Mt = e3, ji = ip, jn = $.apply(Aw, _y), jn;
          }
          function Ls(ip) {
            return ji = ip, Zn = $5(tc, ie), ca ? gs(ip) : jn;
          }
          function ll(ip) {
            var _y = ip - Ir, Aw = ip - ji, f8 = ie - _y;
            return ka ? Bv(f8, nn - Aw) : f8;
          }
          function Hs(ip) {
            var _y = ip - Ir, Aw = ip - ji;
            return Ir === e3 || _y >= ie || _y < 0 || ka && Aw >= nn;
          }
          function tc() {
            var ip = GP();
            if (Hs(ip))
              return zc(ip);
            Zn = $5(tc, ll(ip));
          }
          function zc(ip) {
            return Zn = e3, Io && tt ? gs(ip) : (tt = Mt = e3, jn);
          }
          function Sg() {
            Zn !== e3 && AF(Zn), ji = 0, tt = Ir = Mt = Zn = e3;
          }
          function v0() {
            return Zn === e3 ? jn : zc(GP());
          }
          function N1() {
            var ip = GP(), _y = Hs(ip);
            if (tt = arguments, Mt = this, Ir = ip, _y) {
              if (Zn === e3)
                return Ls(Ir);
              if (ka)
                return AF(Zn), Zn = $5(tc, ie), gs(Ir);
            }
            return Zn === e3 && (Zn = $5(tc, ie)), jn;
          }
          return N1.cancel = Sg, N1.flush = v0, N1;
        }
        var vee = Nu(function($, ie) {
          return B5($, 1, ie);
        }), gee = Nu(function($, ie, De) {
          return B5($, R1(ie) || 0, De);
        });
        function CI($) {
          return jv($, qe);
        }
        function XF($, ie) {
          if (typeof $ != "function" || ie != null && typeof ie != "function")
            throw new T1(m3);
          var De = function() {
            var tt = arguments, Mt = ie ? ie.apply(this, tt) : tt[0], nn = De.cache;
            if (nn.has(Mt))
              return nn.get(Mt);
            var jn = $.apply(this, tt);
            return De.cache = nn.set(Mt, jn) || nn, jn;
          };
          return De.cache = new (XF.Cache || Mb)(), De;
        }
        XF.Cache = Mb;
        function YF($) {
          if (typeof $ != "function")
            throw new T1(m3);
          return function() {
            var ie = arguments;
            switch (ie.length) {
              case 0:
                return !$.call(this);
              case 1:
                return !$.call(this, ie[0]);
              case 2:
                return !$.call(this, ie[0], ie[1]);
              case 3:
                return !$.call(this, ie[0], ie[1], ie[2]);
            }
            return !$.apply(this, ie);
          };
        }
        function yee($) {
          return pee(2, $);
        }
        var bu = TF(function($, ie) {
          ie = ie.length == 1 && La(ie[0]) ? rp(ie[0], pm(Ks())) : rp(uv(ie, 1), pm(Ks()));
          var De = ie.length;
          return Nu(function(tt) {
            for (var Mt = -1, nn = Bv(tt.length, De); ++Mt < nn; )
              tt[Mt] = ie[Mt].call(this, tt[Mt]);
            return fm($, this, tt);
          });
        }), KF = Nu(function($, ie) {
          var De = CM(ie, gI(KF));
          return jv($, Be, e3, ie, De);
        }), YG = Nu(function($, ie) {
          var De = CM(ie, gI(YG));
          return jv($, Oe, e3, ie, De);
        }), fve = yw(function($, ie) {
          return jv($, Ue, e3, e3, e3, ie);
        });
        function mee($, ie) {
          if (typeof $ != "function")
            throw new T1(m3);
          return ie = ie === e3 ? ie : sl(ie), Nu($, ie);
        }
        function hve($, ie) {
          if (typeof $ != "function")
            throw new T1(m3);
          return ie = ie == null ? 0 : Dc(sl(ie), 0), Nu(function(De) {
            var tt = De[ie], Mt = gw(De, 0, ie);
            return tt && ow(Mt, tt), fm($, this, Mt);
          });
        }
        function pve($, ie, De) {
          var tt = true, Mt = true;
          if (typeof $ != "function")
            throw new T1(m3);
          return Hh(De) && (tt = "leading" in De ? !!De.leading : tt, Mt = "trailing" in De ? !!De.trailing : Mt), SI($, ie, { leading: tt, maxWait: ie, trailing: Mt });
        }
        function bee($) {
          return hee($, 1);
        }
        function _ee($, ie) {
          return KF(H5(ie), $);
        }
        function xee() {
          if (!arguments.length)
            return [];
          var $ = arguments[0];
          return La($) ? $ : [$];
        }
        function wee($) {
          return cy($, j);
        }
        function dve($, ie) {
          return ie = typeof ie == "function" ? ie : e3, cy($, j, ie);
        }
        function See($) {
          return cy($, P | j);
        }
        function Cee($, ie) {
          return ie = typeof ie == "function" ? ie : e3, cy($, P | j, ie);
        }
        function Mee($, ie) {
          return ie == null || lG($, ie, fv(ie));
        }
        function Eb($, ie) {
          return $ === ie || $ !== $ && ie !== ie;
        }
        var Tee = DF(OP), KG = DF(function($, ie) {
          return $ >= ie;
        }), Fl = _F(function() {
          return arguments;
        }()) ? _F : function($) {
          return Wh($) && Jc.call($, "callee") && !_P.call($, "callee");
        }, La = vi.isArray, ZG = vP ? pm(vP) : pde;
        function gy($) {
          return $ != null && $M($.length) && !my($);
        }
        function Qp($) {
          return Wh($) && gy($);
        }
        function Aee($) {
          return $ === true || $ === false || Wh($) && h0($) == Pa;
        }
        var Sw = hQ || q2, JG = _5 ? pm(_5) : dde;
        function WP($) {
          return Wh($) && $.nodeType === 1 && !$P($);
        }
        function ZF($) {
          if ($ == null)
            return true;
          if (gy($) && (La($) || typeof $ == "string" || typeof $.splice == "function" || Sw($) || Y5($) || Fl($)))
            return !$.length;
          var ie = xg($);
          if (ie == ds || ie == Ef)
            return !$.size;
          if (k_($))
            return !PP($).length;
          for (var De in $)
            if (Jc.call($, De))
              return false;
          return true;
        }
        function yy($, ie) {
          return EM($, ie);
        }
        function UP($, ie, De) {
          De = typeof De == "function" ? De : e3;
          var tt = De ? De($, ie) : e3;
          return tt === e3 ? EM($, ie, e3, De) : !!tt;
        }
        function qM($) {
          if (!Wh($))
            return false;
          var ie = h0($);
          return ie == $a || ie == Co || typeof $.message == "string" && typeof $.name == "string" && !$P($);
        }
        function vve($) {
          return typeof $ == "number" && F2($);
        }
        function my($) {
          if (!Hh($))
            return false;
          var ie = h0($);
          return ie == Yo || ie == Qu || ie == oo || ie == Hf;
        }
        function qP($) {
          return typeof $ == "number" && $ == sl($);
        }
        function $M($) {
          return typeof $ == "number" && $ > -1 && $ % 1 == 0 && $ <= hn;
        }
        function Hh($) {
          var ie = typeof $;
          return $ != null && (ie == "object" || ie == "function");
        }
        function Wh($) {
          return $ != null && typeof $ == "object";
        }
        var MI = nQ ? pm(nQ) : IQ;
        function Iee($, ie) {
          return $ === ie || dG($, ie, Wc(ie));
        }
        function Eee($, ie, De) {
          return De = typeof De == "function" ? De : e3, dG($, ie, Wc(ie), De);
        }
        function JF($) {
          return eH($) && $ != +$;
        }
        function Dee($) {
          if (Tde($))
            throw new Hl(v4);
          return EQ($);
        }
        function kee($) {
          return $ === null;
        }
        function QG($) {
          return $ == null;
        }
        function eH($) {
          return typeof $ == "number" || Wh($) && h0($) == Lu;
        }
        function $P($) {
          if (!Wh($) || h0($) != Kc)
            return false;
          var ie = rI($);
          if (ie === null)
            return true;
          var De = Jc.call(ie, "constructor") && ie.constructor;
          return typeof De == "function" && De instanceof De && c0.call(De) == cQ;
        }
        var tH = Eo ? pm(Eo) : DQ;
        function Oee($) {
          return qP($) && $ >= -hn && $ <= hn;
        }
        var Cw = iF ? pm(iF) : xF;
        function TI($) {
          return typeof $ == "string" || !La($) && Wh($) && h0($) == md;
        }
        function L1($) {
          return typeof $ == "symbol" || Wh($) && h0($) == Gh;
        }
        var Y5 = gP ? pm(gP) : vG;
        function gve($) {
          return $ === e3;
        }
        function yve($) {
          return Wh($) && xg($) == Ki;
        }
        function nH($) {
          return Wh($) && h0($) == Zr;
        }
        var AI = DF(dm), Pee = DF(function($, ie) {
          return $ <= ie;
        });
        function rH($) {
          if (!$)
            return [];
          if (gy($))
            return TI($) ? Cb($) : py($);
          if (MM && $[MM])
            return oQ($[MM]());
          var ie = xg($), De = ie == ds ? mP : ie == Ef ? w5 : kI;
          return De($);
        }
        function Hv($) {
          if (!$)
            return $ === 0 ? $ : 0;
          if ($ = R1($), $ === Kn || $ === -Kn) {
            var ie = $ < 0 ? -1 : 1;
            return ie * xn;
          }
          return $ === $ ? $ : 0;
        }
        function sl($) {
          var ie = Hv($), De = ie % 1;
          return ie === ie ? De ? ie - De : ie : 0;
        }
        function iH($) {
          return $ ? sI(sl($), 0, or) : 0;
        }
        function R1($) {
          if (typeof $ == "number")
            return $;
          if (L1($))
            return zn;
          if (Hh($)) {
            var ie = typeof $.valueOf == "function" ? $.valueOf() : $;
            $ = Hh(ie) ? ie + "" : ie;
          }
          if (typeof $ != "string")
            return $ === 0 ? $ : +$;
          $ = lF($);
          var De = jr.test($);
          return De || xi.test($) ? pP($.slice(2), De ? 2 : 8) : Mn.test($) ? zn : +$;
        }
        function aH($) {
          return D_($, mm($));
        }
        function Lee($) {
          return $ ? sI(sl($), -hn, hn) : $ === 0 ? $ : 0;
        }
        function xf($) {
          return $ == null ? "" : _g($);
        }
        var Ree = vI(function($, ie) {
          if (k_(ie) || gy(ie)) {
            D_(ie, fv(ie), $);
            return;
          }
          for (var De in ie)
            Jc.call(ie, De) && DP($, De, ie[De]);
        }), QF = vI(function($, ie) {
          D_(ie, mm(ie), $);
        }), K5 = vI(function($, ie, De, tt) {
          D_(ie, mm(ie), $, tt);
        }), mve = vI(function($, ie, De, tt) {
          D_(ie, fv(ie), $, tt);
        }), oH = yw(V5);
        function bve($, ie) {
          var De = mg($);
          return ie == null ? De : CQ(De, ie);
        }
        var _ve = Nu(function($, ie) {
          $ = vh($);
          var De = -1, tt = ie.length, Mt = tt > 2 ? ie[2] : e3;
          for (Mt && wg(ie[0], ie[1], Mt) && (tt = 1); ++De < tt; )
            for (var nn = ie[De], jn = mm(nn), Zn = -1, Ir = jn.length; ++Zn < Ir; ) {
              var ji = jn[Zn], ca = $[ji];
              (ca === e3 || Eb(ca, M5[ji]) && !Jc.call($, ji)) && ($[ji] = nn[ji]);
            }
          return $;
        }), xve = Nu(function($) {
          return $.push(e3, PF), fm(Bee, e3, $);
        });
        function Nee($, ie) {
          return P2($, Ks(ie, 3), hw);
        }
        function wve($, ie) {
          return P2($, Ks(ie, 3), cG);
        }
        function II($, ie) {
          return $ == null ? $ : IM($, Ks(ie, 3), mm);
        }
        function Sve($, ie) {
          return $ == null ? $ : AQ($, Ks(ie, 3), mm);
        }
        function zp($, ie) {
          return $ && hw($, Ks(ie, 3));
        }
        function sH($, ie) {
          return $ && cG($, Ks(ie, 3));
        }
        function Fee($) {
          return $ == null ? [] : z5($, fv($));
        }
        function Cve($) {
          return $ == null ? [] : z5($, mm($));
        }
        function cv($, ie, De) {
          var tt = $ == null ? e3 : B2($, ie);
          return tt === e3 ? De : tt;
        }
        function EI($, ie) {
          return $ != null && ZQ($, ie, cde);
        }
        function DI($, ie) {
          return $ != null && ZQ($, ie, hG);
        }
        var Mve = mp(function($, ie, De) {
          ie != null && typeof ie.toString != "function" && (ie = A5.call(ie)), $[ie] = De;
        }, r8(by)), Tve = mp(function($, ie, De) {
          ie != null && typeof ie.toString != "function" && (ie = A5.call(ie)), Jc.call($, ie) ? $[ie].push(De) : $[ie] = [De];
        }, Ks), lH = Nu(fy);
        function fv($) {
          return gy($) ? oG($) : PP($);
        }
        function mm($) {
          return gy($) ? oG($, true) : vde($);
        }
        function Z5($, ie) {
          var De = {};
          return ie = Ks(ie, 3), hw($, function(tt, Mt, nn) {
            E1(De, ie(tt, Mt, nn), tt);
          }), De;
        }
        function Ave($, ie) {
          var De = {};
          return ie = Ks(ie, 3), hw($, function(tt, Mt, nn) {
            E1(De, Mt, ie(tt, Mt, nn));
          }), De;
        }
        var Vee = vI(function($, ie, De) {
          D1($, ie, De);
        }), Bee = vI(function($, ie, De, tt) {
          D1($, ie, De, tt);
        }), zee = yw(function($, ie) {
          var De = {};
          if ($ == null)
            return De;
          var tt = false;
          ie = rp(ie, function(nn) {
            return nn = zv(nn, $), tt || (tt = nn.length > 1), nn;
          }), D_($, NF($), De), tt && (De = cy(De, P | N | j, $Q));
          for (var Mt = ie.length; Mt--; )
            Ys(De, ie[Mt]);
          return De;
        });
        function uH($, ie) {
          return XP($, YF(Ks(ie)));
        }
        var e8 = yw(function($, ie) {
          return $ == null ? {} : gde($, ie);
        });
        function XP($, ie) {
          if ($ == null)
            return {};
          var De = rp(NF($), function(tt) {
            return [tt];
          });
          return ie = Ks(ie), gG($, De, function(tt, Mt) {
            return ie(tt, Mt[0]);
          });
        }
        function YP($, ie, De) {
          ie = zv(ie, $);
          var tt = -1, Mt = ie.length;
          for (Mt || (Mt = 1, $ = e3); ++tt < Mt; ) {
            var nn = $ == null ? e3 : $[mw(ie[tt])];
            nn === e3 && (tt = Mt, nn = De), $ = my(nn) ? nn.call($) : nn;
          }
          return $;
        }
        function jee($, ie, De) {
          return $ == null ? $ : k1($, ie, De);
        }
        function cH($, ie, De, tt) {
          return tt = typeof tt == "function" ? tt : e3, $ == null ? $ : k1($, ie, De, tt);
        }
        var fH = UQ(fv), hH = UQ(mm);
        function Ive($, ie, De) {
          var tt = La($), Mt = tt || Sw($) || Y5($);
          if (ie = Ks(ie, 4), De == null) {
            var nn = $ && $.constructor;
            Mt ? De = tt ? new nn() : [] : Hh($) ? De = my(nn) ? mg(rI($)) : {} : De = {};
          }
          return (Mt ? uf : hw)($, function(jn, Zn, Ir) {
            return ie(De, jn, Zn, Ir);
          }), De;
        }
        function Eve($, ie) {
          return $ == null ? true : Ys($, ie);
        }
        function Dve($, ie, De) {
          return $ == null ? $ : mG($, ie, H5(De));
        }
        function Gee($, ie, De, tt) {
          return tt = typeof tt == "function" ? tt : e3, $ == null ? $ : mG($, ie, H5(De), tt);
        }
        function kI($) {
          return $ == null ? [] : uF($, fv($));
        }
        function Hee($) {
          return $ == null ? [] : uF($, mm($));
        }
        function Wee($, ie, De) {
          return De === e3 && (De = ie, ie = e3), De !== e3 && (De = R1(De), De = De === De ? De : 0), ie !== e3 && (ie = R1(ie), ie = ie === ie ? ie : 0), sI(R1($), ie, De);
        }
        function kve($, ie, De) {
          return ie = Hv(ie), De === e3 ? (De = ie, ie = 0) : De = Hv(De), $ = R1($), fde($, ie, De);
        }
        function Ove($, ie, De) {
          if (De && typeof De != "boolean" && wg($, ie, De) && (ie = De = e3), De === e3 && (typeof ie == "boolean" ? (De = ie, ie = e3) : typeof $ == "boolean" && (De = $, $ = e3)), $ === e3 && ie === e3 ? ($ = 0, ie = 1) : ($ = Hv($), ie === e3 ? (ie = $, $ = 0) : ie = Hv(ie)), $ > ie) {
            var tt = $;
            $ = ie, ie = tt;
          }
          if (De || $ % 1 || ie % 1) {
            var Mt = D5();
            return Bv($ + Mt * (ie - $ + zpe("1e-" + ((Mt + "").length - 1))), ie);
          }
          return kM($, ie);
        }
        var pH = W5(function($, ie, De) {
          return ie = ie.toLowerCase(), $ + (De ? Uee(ie) : ie);
        });
        function Uee($) {
          return yH(xf($).toLowerCase());
        }
        function dH($) {
          return $ = xf($), $ && $.replace(cn, Wpe).replace(Qa, "");
        }
        function Mw($, ie, De) {
          $ = xf($), ie = _g(ie);
          var tt = $.length;
          De = De === e3 ? tt : sI(sl(De), 0, tt);
          var Mt = De;
          return De -= ie.length, De >= 0 && $.slice(De, Mt) == ie;
        }
        function Pve($) {
          return $ = xf($), $ && Hd.test($) ? $.replace(Vp, aQ) : $;
        }
        function qee($) {
          return $ = xf($), $ && uP.test($) ? $.replace(M2, "\\$&") : $;
        }
        var vH = W5(function($, ie, De) {
          return $ + (De ? "-" : "") + ie.toLowerCase();
        }), $ee = W5(function($, ie, De) {
          return $ + (De ? " " : "") + ie.toLowerCase();
        }), gH = wG("toLowerCase");
        function OI($, ie, De) {
          $ = xf($), ie = sl(ie);
          var tt = ie ? S5($) : 0;
          if (!ie || tt >= ie)
            return $;
          var Mt = (ie - tt) / 2;
          return EF(wP(Mt), De) + $ + EF(Jp(Mt), De);
        }
        function J5($, ie, De) {
          $ = xf($), ie = sl(ie);
          var tt = ie ? S5($) : 0;
          return ie && tt < ie ? $ + EF(ie - tt, De) : $;
        }
        function Lve($, ie, De) {
          $ = xf($), ie = sl(ie);
          var tt = ie ? S5($) : 0;
          return ie && tt < ie ? EF(ie - tt, De) + $ : $;
        }
        function d0($, ie, De) {
          return De || ie == null ? ie = 0 : ie && (ie = +ie), dQ(xf($).replace(T2, ""), ie || 0);
        }
        function Xee($, ie, De) {
          return (De ? wg($, ie, De) : ie === e3) ? ie = 1 : ie = sl(ie), RP(xf($), ie);
        }
        function KP() {
          var $ = arguments, ie = xf($[0]);
          return $.length < 3 ? ie : ie.replace($[1], $[2]);
        }
        var ZP = W5(function($, ie, De) {
          return $ + (De ? "_" : "") + ie.toLowerCase();
        });
        function Tw($, ie, De) {
          return De && typeof De != "number" && wg($, ie, De) && (ie = De = e3), De = De === e3 ? or : De >>> 0, De ? ($ = xf($), $ && (typeof ie == "string" || ie != null && !tH(ie)) && (ie = _g(ie), !ie && x5($)) ? gw(Cb($), 0, De) : $.split(ie, De)) : [];
        }
        var O_ = W5(function($, ie, De) {
          return $ + (De ? " " : "") + yH(ie);
        });
        function Rve($, ie, De) {
          return $ = xf($), De = De == null ? 0 : sI(sl(De), 0, $.length), ie = _g(ie), $.slice(De, De + ie.length) == ie;
        }
        function t8($, ie, De) {
          var tt = Ht.templateSettings;
          De && wg($, ie, De) && (ie = e3), $ = xf($), ie = K5({}, ie, tt, qQ);
          var Mt = K5({}, ie.imports, tt.imports, qQ), nn = fv(Mt), jn = uF(Mt, nn), Zn, Ir, ji = 0, ca = ie.interpolate || as, ka = "__p += '", Io = fF((ie.escape || as).source + "|" + ca.source + "|" + (ca === um ? $t : as).source + "|" + (ie.evaluate || as).source + "|$", "g"), gs = "//# sourceURL=" + (Jc.call(ie, "sourceURL") ? (ie.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++ec + "]") + `
`;
          $.replace(Io, function(Hs, tc, zc, Sg, v0, N1) {
            return zc || (zc = Sg), ka += $.slice(ji, N1).replace(Eu, Upe), tc && (Zn = true, ka += `' +
__e(` + tc + `) +
'`), v0 && (Ir = true, ka += `';
` + v0 + `;
__p += '`), zc && (ka += `' +
((__t = (` + zc + `)) == null ? '' : __t) +
'`), ji = N1 + Hs.length, Hs;
          }), ka += `';
`;
          var Ls = Jc.call(ie, "variable") && ie.variable;
          if (!Ls)
            ka = `with (obj) {
` + ka + `
}
`;
          else if (An.test(Ls))
            throw new Hl(x3);
          ka = (Ir ? ka.replace(l0, "") : ka).replace(iy, "$1").replace(_b2, "$1;"), ka = "function(" + (Ls || "obj") + `) {
` + (Ls ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Zn ? ", __e = _.escape" : "") + (Ir ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + ka + `return __p
}`;
          var ll = Zee(function() {
            return cf(nn, gs + "return " + ka).apply(e3, jn);
          });
          if (ll.source = ka, qM(ll))
            throw ll;
          return ll;
        }
        function Nve($) {
          return xf($).toLowerCase();
        }
        function Fve($) {
          return xf($).toUpperCase();
        }
        function Vve($, ie, De) {
          if ($ = xf($), $ && (De || ie === e3))
            return lF($);
          if (!$ || !(ie = _g(ie)))
            return $;
          var tt = Cb($), Mt = Cb(ie), nn = iQ(tt, Mt), jn = cF(tt, Mt) + 1;
          return gw(tt, nn, jn).join("");
        }
        function Yee($, ie, De) {
          if ($ = xf($), $ && (De || ie === e3))
            return $.slice(0, lQ($) + 1);
          if (!$ || !(ie = _g(ie)))
            return $;
          var tt = Cb($), Mt = cF(tt, Cb(ie)) + 1;
          return gw(tt, 0, Mt).join("");
        }
        function bm($, ie, De) {
          if ($ = xf($), $ && (De || ie === e3))
            return $.replace(T2, "");
          if (!$ || !(ie = _g(ie)))
            return $;
          var tt = Cb($), Mt = iQ(tt, Cb(ie));
          return gw(tt, Mt).join("");
        }
        function Bve($, ie) {
          var De = Ze, tt = ct;
          if (Hh(ie)) {
            var Mt = "separator" in ie ? ie.separator : Mt;
            De = "length" in ie ? sl(ie.length) : De, tt = "omission" in ie ? _g(ie.omission) : tt;
          }
          $ = xf($);
          var nn = $.length;
          if (x5($)) {
            var jn = Cb($);
            nn = jn.length;
          }
          if (De >= nn)
            return $;
          var Zn = De - S5(tt);
          if (Zn < 1)
            return tt;
          var Ir = jn ? gw(jn, 0, Zn).join("") : $.slice(0, Zn);
          if (Mt === e3)
            return Ir + tt;
          if (jn && (Zn += Ir.length - Zn), tH(Mt)) {
            if ($.slice(Zn).search(Mt)) {
              var ji, ca = Ir;
              for (Mt.global || (Mt = fF(Mt.source, xf(bn.exec(Mt)) + "g")), Mt.lastIndex = 0; ji = Mt.exec(ca); )
                var ka = ji.index;
              Ir = Ir.slice(0, ka === e3 ? Zn : ka);
            }
          } else if ($.indexOf(_g(Mt), Zn) != Zn) {
            var Io = Ir.lastIndexOf(Mt);
            Io > -1 && (Ir = Ir.slice(0, Io));
          }
          return Ir + tt;
        }
        function Kee($) {
          return $ = xf($), $ && vc.test($) ? $.replace(ay, Kj) : $;
        }
        var n8 = W5(function($, ie, De) {
          return $ + (De ? " " : "") + ie.toUpperCase();
        }), yH = wG("toUpperCase");
        function mH($, ie, De) {
          return $ = xf($), ie = De ? e3 : ie, ie === e3 ? Yj($) ? Xpe($) : qj($) : $.match(ie) || [];
        }
        var Zee = Nu(function($, ie) {
          try {
            return fm($, e3, ie);
          } catch (De) {
            return qM(De) ? De : new Hl(De);
          }
        }), Jee = yw(function($, ie) {
          return uf(ie, function(De) {
            De = mw(De), E1($, De, $G($[De], $));
          }), $;
        });
        function _m($) {
          var ie = $ == null ? 0 : $.length, De = Ks();
          return $ = ie ? rp($, function(tt) {
            if (typeof tt[1] != "function")
              throw new T1(m3);
            return [De(tt[0]), tt[1]];
          }) : [], Nu(function(tt) {
            for (var Mt = -1; ++Mt < ie; ) {
              var nn = $[Mt];
              if (fm(nn[0], this, tt))
                return fm(nn[1], this, tt);
            }
          });
        }
        function zve($) {
          return mF(cy($, P));
        }
        function r8($) {
          return function() {
            return $;
          };
        }
        function xm($, ie) {
          return $ == null || $ !== $ ? ie : $;
        }
        var jve = Bc(), Gve = Bc(true);
        function by($) {
          return $;
        }
        function Ud($) {
          return wF(typeof $ == "function" ? $ : cy($, P));
        }
        function wm($) {
          return SF(cy($, P));
        }
        function Hve($, ie) {
          return pw($, cy(ie, P));
        }
        var Qee = Nu(function($, ie) {
          return function(De) {
            return fy(De, $, ie);
          };
        }), ete = Nu(function($, ie) {
          return function(De) {
            return fy($, De, ie);
          };
        });
        function Q5($, ie, De) {
          var tt = fv(ie), Mt = z5(ie, tt);
          De == null && !(Hh(ie) && (Mt.length || !tt.length)) && (De = ie, ie = $, $ = this, Mt = z5(ie, fv(ie)));
          var nn = !(Hh(De) && "chain" in De) || !!De.chain, jn = my($);
          return uf(Mt, function(Zn) {
            var Ir = ie[Zn];
            $[Zn] = Ir, jn && ($.prototype[Zn] = function() {
              var ji = this.__chain__;
              if (nn || ji) {
                var ca = $(this.__wrapped__), ka = ca.__actions__ = py(this.__actions__);
                return ka.push({ func: Ir, args: arguments, thisArg: $ }), ca.__chain__ = ji, ca;
              }
              return Ir.apply($, ow([this.value()], arguments));
            });
          }), $;
        }
        function Wve() {
          return np._ === this && (np._ = Zpe), this;
        }
        function i8() {
        }
        function bH($) {
          return $ = sl($), Nu(function(ie) {
            return CF(ie, $);
          });
        }
        var Uve = Tb(rp), _H = Tb(wM), qve = Tb(Wj);
        function xH($) {
          return yI($) ? sw(mw($)) : kQ($);
        }
        function $ve($) {
          return function(ie) {
            return $ == null ? e3 : B2($, ie);
          };
        }
        var JP = WQ(), Xve = WQ(true);
        function a8() {
          return [];
        }
        function q2() {
          return false;
        }
        function PI3() {
          return {};
        }
        function o8() {
          return "";
        }
        function s8() {
          return true;
        }
        function Yve($, ie) {
          if ($ = sl($), $ < 1 || $ > hn)
            return [];
          var De = or, tt = Bv($, or);
          ie = Ks(ie), $ -= or;
          for (var Mt = hm(tt, ie); ++De < $; )
            ie(De);
          return Mt;
        }
        function l8($) {
          return La($) ? rp($, mw) : L1($) ? [$] : py(tee(xf($)));
        }
        function Kve($) {
          var ie = ++T5;
          return xf($) + ie;
        }
        var Zve = dy(function($, ie) {
          return $ + ie;
        }, 0), Jve = kF("ceil"), tte = dy(function($, ie) {
          return $ / ie;
        }, 1), ek = kF("floor");
        function wH($) {
          return $ && $.length ? uI($, by, OP) : e3;
        }
        function Du($, ie) {
          return $ && $.length ? uI($, Ks(ie, 2), OP) : e3;
        }
        function Uh($) {
          return L2($, by);
        }
        function tk($, ie) {
          return L2($, Ks(ie, 2));
        }
        function XM($) {
          return $ && $.length ? uI($, by, dm) : e3;
        }
        function nte($, ie) {
          return $ && $.length ? uI($, Ks(ie, 2), dm) : e3;
        }
        var QP = dy(function($, ie) {
          return $ * ie;
        }, 1), P_ = kF("round"), Qve = dy(function($, ie) {
          return $ - ie;
        }, 0);
        function u8($) {
          return $ && $.length ? $j($, by) : 0;
        }
        function c8($, ie) {
          return $ && $.length ? $j($, Ks(ie, 2)) : 0;
        }
        return Ht.after = HP, Ht.ary = hee, Ht.assign = Ree, Ht.assignIn = QF, Ht.assignInWith = K5, Ht.assignWith = mve, Ht.at = oH, Ht.before = pee, Ht.bind = $G, Ht.bindAll = Jee, Ht.bindKey = XG, Ht.castArray = xee, Ht.chain = zM, Ht.chunk = Dde, Ht.compact = kde, Ht.concat = Ode, Ht.cond = _m, Ht.conforms = zve, Ht.constant = r8, Ht.countBy = eve, Ht.create = bve, Ht.curry = Gv, Ht.curryRight = dee, Ht.debounce = SI, Ht.defaults = _ve, Ht.defaultsDeep = xve, Ht.defer = vee, Ht.delay = gee, Ht.difference = Pde, Ht.differenceBy = BF, Ht.differenceWith = mI, Ht.drop = Lde, Ht.dropRight = Rde, Ht.dropRightWhile = Nde, Ht.dropWhile = kG, Ht.fill = Fde, Ht.filter = uee, Ht.flatMap = tve, Ht.flatMapDeep = U2, Ht.flatMapDepth = WM, Ht.flatten = BP, Ht.flattenDeep = PG, Ht.flattenDepth = Vde, Ht.flip = CI, Ht.flow = jve, Ht.flowRight = Gve, Ht.fromPairs = nee, Ht.functions = Fee, Ht.functionsIn = Cve, Ht.groupBy = nve, Ht.initial = zde, Ht.intersection = jde, Ht.intersectionBy = ree, Ht.intersectionWith = Gde, Ht.invert = Mve, Ht.invertBy = Tve, Ht.invokeMap = Ib, Ht.iteratee = Ud, Ht.keyBy = rve, Ht.keys = fv, Ht.keysIn = mm, Ht.map = qF, Ht.mapKeys = Z5, Ht.mapValues = Ave, Ht.matches = wm, Ht.matchesProperty = Hve, Ht.memoize = XF, Ht.merge = Vee, Ht.mergeWith = Bee, Ht.method = Qee, Ht.methodOf = ete, Ht.mixin = Q5, Ht.negate = YF, Ht.nthArg = bH, Ht.omit = zee, Ht.omitBy = uH, Ht.once = yee, Ht.orderBy = ive, Ht.over = Uve, Ht.overArgs = bu, Ht.overEvery = _H, Ht.overSome = qve, Ht.partial = KF, Ht.partialRight = YG, Ht.partition = ave, Ht.pick = e8, Ht.pickBy = XP, Ht.property = xH, Ht.propertyOf = $ve, Ht.pull = qde, Ht.pullAll = RG, Ht.pullAllBy = NG, Ht.pullAllWith = bI, Ht.pullAt = jF, Ht.range = JP, Ht.rangeRight = Xve, Ht.rearg = fve, Ht.reject = sve, Ht.remove = iee, Ht.rest = mee, Ht.reverse = FG, Ht.sampleSize = lve, Ht.set = jee, Ht.setWith = cH, Ht.shuffle = qG, Ht.slice = $de, Ht.sortBy = cve, Ht.sortedUniq = zG, Ht.sortedUniqBy = jG, Ht.split = Tw, Ht.spread = hve, Ht.tail = _I, Ht.take = GF, Ht.takeRight = HF, Ht.takeRightWhile = WF, Ht.takeWhile = UF, Ht.tap = W2, Ht.throttle = pve, Ht.thru = X5, Ht.toArray = rH, Ht.toPairs = fH, Ht.toPairsIn = hH, Ht.toPath = l8, Ht.toPlainObject = aH, Ht.transform = Ive, Ht.unary = bee, Ht.union = aee, Ht.unionBy = oee, Ht.unionWith = see, Ht.uniq = Yde, Ht.uniqBy = Kde, Ht.uniqWith = Zde, Ht.unset = Eve, Ht.unzip = ff, Ht.unzipWith = VM, Ht.update = Dve, Ht.updateWith = Gee, Ht.values = kI, Ht.valuesIn = Hee, Ht.without = xI, Ht.words = mH, Ht.wrap = _ee, Ht.xor = bw, Ht.xorBy = BM, Ht.xorWith = _w, Ht.zip = xw, Ht.zipObject = GG, Ht.zipObjectDeep = HG, Ht.zipWith = wI, Ht.entries = fH, Ht.entriesIn = hH, Ht.extend = QF, Ht.extendWith = K5, Q5(Ht, Ht), Ht.add = Zve, Ht.attempt = Zee, Ht.camelCase = pH, Ht.capitalize = Uee, Ht.ceil = Jve, Ht.clamp = Wee, Ht.clone = wee, Ht.cloneDeep = See, Ht.cloneDeepWith = Cee, Ht.cloneWith = dve, Ht.conformsTo = Mee, Ht.deburr = dH, Ht.defaultTo = xm, Ht.divide = tte, Ht.endsWith = Mw, Ht.eq = Eb, Ht.escape = Pve, Ht.escapeRegExp = qee, Ht.every = lee, Ht.find = HM, Ht.findIndex = zF, Ht.findKey = Nee, Ht.findLast = jP, Ht.findLastIndex = OG, Ht.findLastKey = wve, Ht.floor = ek, Ht.forEach = UM, Ht.forEachRight = cee, Ht.forIn = II, Ht.forInRight = Sve, Ht.forOwn = zp, Ht.forOwnRight = sH, Ht.get = cv, Ht.gt = Tee, Ht.gte = KG, Ht.has = EI, Ht.hasIn = DI, Ht.head = LG, Ht.identity = by, Ht.includes = vy, Ht.indexOf = Bde, Ht.inRange = kve, Ht.invoke = lH, Ht.isArguments = Fl, Ht.isArray = La, Ht.isArrayBuffer = ZG, Ht.isArrayLike = gy, Ht.isArrayLikeObject = Qp, Ht.isBoolean = Aee, Ht.isBuffer = Sw, Ht.isDate = JG, Ht.isElement = WP, Ht.isEmpty = ZF, Ht.isEqual = yy, Ht.isEqualWith = UP, Ht.isError = qM, Ht.isFinite = vve, Ht.isFunction = my, Ht.isInteger = qP, Ht.isLength = $M, Ht.isMap = MI, Ht.isMatch = Iee, Ht.isMatchWith = Eee, Ht.isNaN = JF, Ht.isNative = Dee, Ht.isNil = QG, Ht.isNull = kee, Ht.isNumber = eH, Ht.isObject = Hh, Ht.isObjectLike = Wh, Ht.isPlainObject = $P, Ht.isRegExp = tH, Ht.isSafeInteger = Oee, Ht.isSet = Cw, Ht.isString = TI, Ht.isSymbol = L1, Ht.isTypedArray = Y5, Ht.isUndefined = gve, Ht.isWeakMap = yve, Ht.isWeakSet = nH, Ht.join = Hde, Ht.kebabCase = vH, Ht.last = vm, Ht.lastIndexOf = Wde, Ht.lowerCase = $ee, Ht.lowerFirst = gH, Ht.lt = AI, Ht.lte = Pee, Ht.max = wH, Ht.maxBy = Du, Ht.mean = Uh, Ht.meanBy = tk, Ht.min = XM, Ht.minBy = nte, Ht.stubArray = a8, Ht.stubFalse = q2, Ht.stubObject = PI3, Ht.stubString = o8, Ht.stubTrue = s8, Ht.multiply = QP, Ht.nth = Ude, Ht.noConflict = Wve, Ht.noop = i8, Ht.now = GP, Ht.pad = OI, Ht.padEnd = J5, Ht.padStart = Lve, Ht.parseInt = d0, Ht.random = Ove, Ht.reduce = fee, Ht.reduceRight = ove, Ht.repeat = Xee, Ht.replace = KP, Ht.result = YP, Ht.round = P_, Ht.runInContext = hr, Ht.sample = $F, Ht.size = uve, Ht.snakeCase = ZP, Ht.some = gl, Ht.sortedIndex = VG, Ht.sortedIndexBy = BG, Ht.sortedIndexOf = Xde, Ht.sortedLastIndex = Ab, Ht.sortedLastIndexBy = gm, Ht.sortedLastIndexOf = ym, Ht.startCase = O_, Ht.startsWith = Rve, Ht.subtract = Qve, Ht.sum = u8, Ht.sumBy = c8, Ht.template = t8, Ht.times = Yve, Ht.toFinite = Hv, Ht.toInteger = sl, Ht.toLength = iH, Ht.toLower = Nve, Ht.toNumber = R1, Ht.toSafeInteger = Lee, Ht.toString = xf, Ht.toUpper = Fve, Ht.trim = Vve, Ht.trimEnd = Yee, Ht.trimStart = bm, Ht.truncate = Bve, Ht.unescape = Kee, Ht.uniqueId = Kve, Ht.upperCase = n8, Ht.upperFirst = yH, Ht.each = UM, Ht.eachRight = cee, Ht.first = LG, Q5(Ht, function() {
          var $ = {};
          return hw(Ht, function(ie, De) {
            Jc.call(Ht.prototype, De) || ($[De] = ie);
          }), $;
        }(), { chain: false }), Ht.VERSION = u, uf(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function($) {
          Ht[$].placeholder = Ht;
        }), uf(["drop", "take"], function($, ie) {
          Ru.prototype[$] = function(De) {
            De = De === e3 ? 1 : Dc(sl(De), 0);
            var tt = this.__filtered__ && !ie ? new Ru(this) : this.clone();
            return tt.__filtered__ ? tt.__takeCount__ = Bv(De, tt.__takeCount__) : tt.__views__.push({ size: Bv(De, or), type: $ + (tt.__dir__ < 0 ? "Right" : "") }), tt;
          }, Ru.prototype[$ + "Right"] = function(De) {
            return this.reverse()[$](De).reverse();
          };
        }), uf(["filter", "map", "takeWhile"], function($, ie) {
          var De = ie + 1, tt = De == zt || De == Ft;
          Ru.prototype[$] = function(Mt) {
            var nn = this.clone();
            return nn.__iteratees__.push({ iteratee: Ks(Mt, 3), type: De }), nn.__filtered__ = nn.__filtered__ || tt, nn;
          };
        }), uf(["head", "last"], function($, ie) {
          var De = "take" + (ie ? "Right" : "");
          Ru.prototype[$] = function() {
            return this[De](1).value()[0];
          };
        }), uf(["initial", "tail"], function($, ie) {
          var De = "drop" + (ie ? "" : "Right");
          Ru.prototype[$] = function() {
            return this.__filtered__ ? new Ru(this) : this[De](1);
          };
        }), Ru.prototype.compact = function() {
          return this.filter(by);
        }, Ru.prototype.find = function($) {
          return this.filter($).head();
        }, Ru.prototype.findLast = function($) {
          return this.reverse().find($);
        }, Ru.prototype.invokeMap = Nu(function($, ie) {
          return typeof $ == "function" ? new Ru(this) : this.map(function(De) {
            return fy(De, $, ie);
          });
        }), Ru.prototype.reject = function($) {
          return this.filter(YF(Ks($)));
        }, Ru.prototype.slice = function($, ie) {
          $ = sl($);
          var De = this;
          return De.__filtered__ && ($ > 0 || ie < 0) ? new Ru(De) : ($ < 0 ? De = De.takeRight(-$) : $ && (De = De.drop($)), ie !== e3 && (ie = sl(ie), De = ie < 0 ? De.dropRight(-ie) : De.take(ie - $)), De);
        }, Ru.prototype.takeRightWhile = function($) {
          return this.reverse().takeWhile($).reverse();
        }, Ru.prototype.toArray = function() {
          return this.take(or);
        }, hw(Ru.prototype, function($, ie) {
          var De = /^(?:filter|find|map|reject)|While$/.test(ie), tt = /^(?:head|last)$/.test(ie), Mt = Ht[tt ? "take" + (ie == "last" ? "Right" : "") : ie], nn = tt || /^find/.test(ie);
          !Mt || (Ht.prototype[ie] = function() {
            var jn = this.__wrapped__, Zn = tt ? [1] : arguments, Ir = jn instanceof Ru, ji = Zn[0], ca = Ir || La(jn), ka = function(tc) {
              var zc = Mt.apply(Ht, ow([tc], Zn));
              return tt && Io ? zc[0] : zc;
            };
            ca && De && typeof ji == "function" && ji.length != 1 && (Ir = ca = false);
            var Io = this.__chain__, gs = !!this.__actions__.length, Ls = nn && !Io, ll = Ir && !gs;
            if (!nn && ca) {
              jn = ll ? jn : new Ru(this);
              var Hs = $.apply(jn, Zn);
              return Hs.__actions__.push({ func: X5, args: [ka], thisArg: e3 }), new A1(Hs, Io);
            }
            return Ls && ll ? $.apply(this, Zn) : (Hs = this.thru(ka), Ls ? tt ? Hs.value()[0] : Hs.value() : Hs);
          });
        }), uf(["pop", "push", "shift", "sort", "splice", "unshift"], function($) {
          var ie = C5[$], De = /^(?:push|sort|unshift)$/.test($) ? "tap" : "thru", tt = /^(?:pop|shift)$/.test($);
          Ht.prototype[$] = function() {
            var Mt = arguments;
            if (tt && !this.__chain__) {
              var nn = this.value();
              return ie.apply(La(nn) ? nn : [], Mt);
            }
            return this[De](function(jn) {
              return ie.apply(La(jn) ? jn : [], Mt);
            });
          };
        }), hw(Ru.prototype, function($, ie) {
          var De = Ht[ie];
          if (De) {
            var tt = De.name + "";
            Jc.call(P5, tt) || (P5[tt] = []), P5[tt].push({ name: ie, func: De });
          }
        }), P5[Da(e3, ne).name] = [{ name: "wrapper", func: e3 }], Ru.prototype.clone = N5, Ru.prototype.reverse = I1, Ru.prototype.value = nG, Ht.prototype.at = jM, Ht.prototype.chain = WG, Ht.prototype.commit = zP, Ht.prototype.next = UG, Ht.prototype.plant = Qde, Ht.prototype.reverse = ww, Ht.prototype.toJSON = Ht.prototype.valueOf = Ht.prototype.value = GM, Ht.prototype.first = Ht.prototype.head, MM && (Ht.prototype[MM] = Jde), Ht;
      }, lw = Ype();
      k2 ? ((k2.exports = lw)._ = lw, dP._ = lw) : np._ = lw;
    }).call(p2);
  })(Ohe, Ohe.exports);
  class Nvt {
    constructor() {
      y_(this, "subscriptions", /* @__PURE__ */ new Map());
      y_(this, "emitEffectCache", /* @__PURE__ */ new Map());
      y_(this, "useSubscription", (r3, e3) => {
        const u = Nc.useRef();
        Nc.useEffect(() => {
          var m3, x3;
          u.current = e3;
          function h(C) {
            u.current && u.current(C);
          }
          const v4 = (x3 = (m3 = this.subscriptions) == null ? void 0 : m3.get(r3)) != null ? x3 : [];
          return v4.push(h), this.subscriptions.set(r3, v4), this.emitEffect(r3), () => {
            this.subscriptions.delete(r3);
          };
        }, []);
      });
      y_(this, "emit", (r3, ...e3) => {
        if (typeof r3 == "string" || typeof r3 == "number") {
          const u = this.subscriptions.get(r3);
          u == null || u.forEach((h) => {
            h == null || h({ params: Ohe.exports.cloneDeep(e3), event: r3 });
          }), this.emitEffectCache.set(r3, { params: Ohe.exports.cloneDeep(e3), event: r3 });
        } else
          throw new TypeError("event must be string or number !");
      });
      y_(this, "emitEffect", (r3) => {
        const e3 = this.emitEffectCache.get(r3), u = this.subscriptions.get(r3);
        e3 && (u == null || u.forEach((h) => {
          h == null || h(Get({}, e3));
        }));
      });
      y_(this, "removeListener", (r3) => {
        this.subscriptions.delete(r3);
      });
      y_(this, "clear", () => {
        this.subscriptions.clear();
      });
      this.clear();
    }
  }
  const yEn = new Nvt();
  function Fvt(l3) {
    const r3 = Nc.useRef(), e3 = Nc.useMemo(() => l3 != null ? l3 : { global: false }, [l3]);
    return r3.current || (r3.current = e3.global ? r3.current = yEn : r3.current = new Nvt()), Nc.useEffect(() => () => {
      var u;
      return (u = r3.current) == null ? void 0 : u.clear();
    }, []), r3.current;
  }
  const Vvt = ({ id: l3, title: r3, chart: e3, option: u }, h) => {
    const v4 = Nc.useRef(gEn), m3 = Fvt({ global: true });
    return Gon(() => {
      console.log("id", l3), console.log("chart", e3 == null ? void 0 : e3.current), v4.current && (e3 == null ? void 0 : e3.current) && l3 && u && (v4.current.add(l3, e3 == null ? void 0 : e3.current, u, r3), m3.emit("list"));
    }, h != null ? h : [], { wait: 100 }), { tool: v4.current };
  };
  var mEn = Nc.createContext({}), Bvt = mEn;
  function fh(l3, r3, e3) {
    return r3 in l3 ? Object.defineProperty(l3, r3, { value: e3, enumerable: true, configurable: true, writable: true }) : l3[r3] = e3, l3;
  }
  function Kst(l3, r3) {
    var e3 = Object.keys(l3);
    if (Object.getOwnPropertySymbols) {
      var u = Object.getOwnPropertySymbols(l3);
      r3 && (u = u.filter(function(h) {
        return Object.getOwnPropertyDescriptor(l3, h).enumerable;
      })), e3.push.apply(e3, u);
    }
    return e3;
  }
  function cu(l3) {
    for (var r3 = 1; r3 < arguments.length; r3++) {
      var e3 = arguments[r3] != null ? arguments[r3] : {};
      r3 % 2 ? Kst(Object(e3), true).forEach(function(u) {
        fh(l3, u, e3[u]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(l3, Object.getOwnPropertyDescriptors(e3)) : Kst(Object(e3)).forEach(function(u) {
        Object.defineProperty(l3, u, Object.getOwnPropertyDescriptor(e3, u));
      });
    }
    return l3;
  }
  function zvt(l3) {
    if (Array.isArray(l3))
      return l3;
  }
  function bEn(l3, r3) {
    var e3 = l3 == null ? null : typeof Symbol != "undefined" && l3[Symbol.iterator] || l3["@@iterator"];
    if (e3 != null) {
      var u = [], h = true, v4 = false, m3, x3;
      try {
        for (e3 = e3.call(l3); !(h = (m3 = e3.next()).done) && (u.push(m3.value), !(r3 && u.length === r3)); h = true)
          ;
      } catch (C) {
        v4 = true, x3 = C;
      } finally {
        try {
          !h && e3.return != null && e3.return();
        } finally {
          if (v4)
            throw x3;
        }
      }
      return u;
    }
  }
  function r3e(l3, r3) {
    (r3 == null || r3 > l3.length) && (r3 = l3.length);
    for (var e3 = 0, u = new Array(r3); e3 < r3; e3++)
      u[e3] = l3[e3];
    return u;
  }
  function APe(l3, r3) {
    if (!!l3) {
      if (typeof l3 == "string")
        return r3e(l3, r3);
      var e3 = Object.prototype.toString.call(l3).slice(8, -1);
      if (e3 === "Object" && l3.constructor && (e3 = l3.constructor.name), e3 === "Map" || e3 === "Set")
        return Array.from(l3);
      if (e3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(e3))
        return r3e(l3, r3);
    }
  }
  function jvt() {
    throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function m2(l3, r3) {
    return zvt(l3) || bEn(l3, r3) || APe(l3, r3) || jvt();
  }
  function _En(l3, r3) {
    if (l3 == null)
      return {};
    var e3 = {}, u = Object.keys(l3), h, v4;
    for (v4 = 0; v4 < u.length; v4++)
      h = u[v4], !(r3.indexOf(h) >= 0) && (e3[h] = l3[h]);
    return e3;
  }
  function Rj(l3, r3) {
    if (l3 == null)
      return {};
    var e3 = _En(l3, r3), u, h;
    if (Object.getOwnPropertySymbols) {
      var v4 = Object.getOwnPropertySymbols(l3);
      for (h = 0; h < v4.length; h++)
        u = v4[h], !(r3.indexOf(u) >= 0) && (!Object.prototype.propertyIsEnumerable.call(l3, u) || (e3[u] = l3[u]));
    }
    return e3;
  }
  var Gvt = { exports: {} };
  /*!
    Copyright (c) 2018 Jed Watson.
    Licensed under the MIT License (MIT), see
    http://jedwatson.github.io/classnames
  */
  (function(l3) {
    (function() {
      var r3 = {}.hasOwnProperty;
      function e3() {
        for (var u = [], h = 0; h < arguments.length; h++) {
          var v4 = arguments[h];
          if (!!v4) {
            var m3 = typeof v4;
            if (m3 === "string" || m3 === "number")
              u.push(v4);
            else if (Array.isArray(v4)) {
              if (v4.length) {
                var x3 = e3.apply(null, v4);
                x3 && u.push(x3);
              }
            } else if (m3 === "object")
              if (v4.toString === Object.prototype.toString)
                for (var C in v4)
                  r3.call(v4, C) && v4[C] && u.push(C);
              else
                u.push(v4.toString());
          }
        }
        return u.join(" ");
      }
      l3.exports ? (e3.default = e3, l3.exports = e3) : window.classNames = e3;
    })();
  })(Gvt);
  var Nj = Gvt.exports;
  function g1(l3) {
    return g1 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(r3) {
      return typeof r3;
    } : function(r3) {
      return r3 && typeof Symbol == "function" && r3.constructor === Symbol && r3 !== Symbol.prototype ? "symbol" : typeof r3;
    }, g1(l3);
  }
  function b2(l3, r3) {
    xEn(l3) && (l3 = "100%");
    var e3 = wEn(l3);
    return l3 = r3 === 360 ? l3 : Math.min(r3, Math.max(0, parseFloat(l3))), e3 && (l3 = parseInt(String(l3 * r3), 10) / 100), Math.abs(l3 - r3) < 1e-6 ? 1 : (r3 === 360 ? l3 = (l3 < 0 ? l3 % r3 + r3 : l3 % r3) / parseFloat(String(r3)) : l3 = l3 % r3 / parseFloat(String(r3)), l3);
  }
  function xEn(l3) {
    return typeof l3 == "string" && l3.indexOf(".") !== -1 && parseFloat(l3) === 1;
  }
  function wEn(l3) {
    return typeof l3 == "string" && l3.indexOf("%") !== -1;
  }
  function SEn(l3) {
    return l3 = parseFloat(l3), (isNaN(l3) || l3 < 0 || l3 > 1) && (l3 = 1), l3;
  }
  function ufe(l3) {
    return l3 <= 1 ? Number(l3) * 100 + "%" : l3;
  }
  function o5e(l3) {
    return l3.length === 1 ? "0" + l3 : String(l3);
  }
  function CEn(l3, r3, e3) {
    return { r: b2(l3, 255) * 255, g: b2(r3, 255) * 255, b: b2(e3, 255) * 255 };
  }
  function s5e(l3, r3, e3) {
    return e3 < 0 && (e3 += 1), e3 > 1 && (e3 -= 1), e3 < 1 / 6 ? l3 + (r3 - l3) * (6 * e3) : e3 < 1 / 2 ? r3 : e3 < 2 / 3 ? l3 + (r3 - l3) * (2 / 3 - e3) * 6 : l3;
  }
  function MEn(l3, r3, e3) {
    var u, h, v4;
    if (l3 = b2(l3, 360), r3 = b2(r3, 100), e3 = b2(e3, 100), r3 === 0)
      h = e3, v4 = e3, u = e3;
    else {
      var m3 = e3 < 0.5 ? e3 * (1 + r3) : e3 + r3 - e3 * r3, x3 = 2 * e3 - m3;
      u = s5e(x3, m3, l3 + 1 / 3), h = s5e(x3, m3, l3), v4 = s5e(x3, m3, l3 - 1 / 3);
    }
    return { r: u * 255, g: h * 255, b: v4 * 255 };
  }
  function TEn(l3, r3, e3) {
    l3 = b2(l3, 255), r3 = b2(r3, 255), e3 = b2(e3, 255);
    var u = Math.max(l3, r3, e3), h = Math.min(l3, r3, e3), v4 = 0, m3 = u, x3 = u - h, C = u === 0 ? 0 : x3 / u;
    if (u === h)
      v4 = 0;
    else {
      switch (u) {
        case l3:
          v4 = (r3 - e3) / x3 + (r3 < e3 ? 6 : 0);
          break;
        case r3:
          v4 = (e3 - l3) / x3 + 2;
          break;
        case e3:
          v4 = (l3 - r3) / x3 + 4;
          break;
      }
      v4 /= 6;
    }
    return { h: v4, s: C, v: m3 };
  }
  function AEn(l3, r3, e3) {
    l3 = b2(l3, 360) * 6, r3 = b2(r3, 100), e3 = b2(e3, 100);
    var u = Math.floor(l3), h = l3 - u, v4 = e3 * (1 - r3), m3 = e3 * (1 - h * r3), x3 = e3 * (1 - (1 - h) * r3), C = u % 6, A2 = [e3, m3, v4, v4, x3, e3][C], D = [x3, e3, e3, m3, v4, v4][C], P = [v4, v4, x3, e3, e3, m3][C];
    return { r: A2 * 255, g: D * 255, b: P * 255 };
  }
  function IEn(l3, r3, e3, u) {
    var h = [o5e(Math.round(l3).toString(16)), o5e(Math.round(r3).toString(16)), o5e(Math.round(e3).toString(16))];
    return u && h[0].startsWith(h[0].charAt(1)) && h[1].startsWith(h[1].charAt(1)) && h[2].startsWith(h[2].charAt(1)) ? h[0].charAt(0) + h[1].charAt(0) + h[2].charAt(0) : h.join("");
  }
  function Zst(l3) {
    return Xx(l3) / 255;
  }
  function Xx(l3) {
    return parseInt(l3, 16);
  }
  var Jst = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
  function gZ(l3) {
    var r3 = { r: 0, g: 0, b: 0 }, e3 = 1, u = null, h = null, v4 = null, m3 = false, x3 = false;
    return typeof l3 == "string" && (l3 = kEn(l3)), typeof l3 == "object" && (KD(l3.r) && KD(l3.g) && KD(l3.b) ? (r3 = CEn(l3.r, l3.g, l3.b), m3 = true, x3 = String(l3.r).substr(-1) === "%" ? "prgb" : "rgb") : KD(l3.h) && KD(l3.s) && KD(l3.v) ? (u = ufe(l3.s), h = ufe(l3.v), r3 = AEn(l3.h, u, h), m3 = true, x3 = "hsv") : KD(l3.h) && KD(l3.s) && KD(l3.l) && (u = ufe(l3.s), v4 = ufe(l3.l), r3 = MEn(l3.h, u, v4), m3 = true, x3 = "hsl"), Object.prototype.hasOwnProperty.call(l3, "a") && (e3 = l3.a)), e3 = SEn(e3), { ok: m3, format: l3.format || x3, r: Math.min(255, Math.max(r3.r, 0)), g: Math.min(255, Math.max(r3.g, 0)), b: Math.min(255, Math.max(r3.b, 0)), a: e3 };
  }
  var EEn = "[-\\+]?\\d+%?", DEn = "[-\\+]?\\d*\\.\\d+%?", UO = "(?:" + DEn + ")|(?:" + EEn + ")", l5e = "[\\s|\\(]+(" + UO + ")[,|\\s]+(" + UO + ")[,|\\s]+(" + UO + ")\\s*\\)?", u5e = "[\\s|\\(]+(" + UO + ")[,|\\s]+(" + UO + ")[,|\\s]+(" + UO + ")[,|\\s]+(" + UO + ")\\s*\\)?", lM = { CSS_UNIT: new RegExp(UO), rgb: new RegExp("rgb" + l5e), rgba: new RegExp("rgba" + u5e), hsl: new RegExp("hsl" + l5e), hsla: new RegExp("hsla" + u5e), hsv: new RegExp("hsv" + l5e), hsva: new RegExp("hsva" + u5e), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
  function kEn(l3) {
    if (l3 = l3.trim().toLowerCase(), l3.length === 0)
      return false;
    var r3 = false;
    if (Jst[l3])
      l3 = Jst[l3], r3 = true;
    else if (l3 === "transparent")
      return { r: 0, g: 0, b: 0, a: 0, format: "name" };
    var e3 = lM.rgb.exec(l3);
    return e3 ? { r: e3[1], g: e3[2], b: e3[3] } : (e3 = lM.rgba.exec(l3), e3 ? { r: e3[1], g: e3[2], b: e3[3], a: e3[4] } : (e3 = lM.hsl.exec(l3), e3 ? { h: e3[1], s: e3[2], l: e3[3] } : (e3 = lM.hsla.exec(l3), e3 ? { h: e3[1], s: e3[2], l: e3[3], a: e3[4] } : (e3 = lM.hsv.exec(l3), e3 ? { h: e3[1], s: e3[2], v: e3[3] } : (e3 = lM.hsva.exec(l3), e3 ? { h: e3[1], s: e3[2], v: e3[3], a: e3[4] } : (e3 = lM.hex8.exec(l3), e3 ? { r: Xx(e3[1]), g: Xx(e3[2]), b: Xx(e3[3]), a: Zst(e3[4]), format: r3 ? "name" : "hex8" } : (e3 = lM.hex6.exec(l3), e3 ? { r: Xx(e3[1]), g: Xx(e3[2]), b: Xx(e3[3]), format: r3 ? "name" : "hex" } : (e3 = lM.hex4.exec(l3), e3 ? { r: Xx(e3[1] + e3[1]), g: Xx(e3[2] + e3[2]), b: Xx(e3[3] + e3[3]), a: Zst(e3[4] + e3[4]), format: r3 ? "name" : "hex8" } : (e3 = lM.hex3.exec(l3), e3 ? { r: Xx(e3[1] + e3[1]), g: Xx(e3[2] + e3[2]), b: Xx(e3[3] + e3[3]), format: r3 ? "name" : "hex" } : false)))))))));
  }
  function KD(l3) {
    return Boolean(lM.CSS_UNIT.exec(String(l3)));
  }
  var cfe = 2, Qst = 0.16, OEn = 0.05, PEn = 0.05, LEn = 0.15, Hvt = 5, Wvt = 4, REn = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
  function elt(l3) {
    var r3 = l3.r, e3 = l3.g, u = l3.b, h = TEn(r3, e3, u);
    return { h: h.h * 360, s: h.s, v: h.v };
  }
  function ffe(l3) {
    var r3 = l3.r, e3 = l3.g, u = l3.b;
    return "#".concat(IEn(r3, e3, u, false));
  }
  function NEn(l3, r3, e3) {
    var u = e3 / 100, h = { r: (r3.r - l3.r) * u + l3.r, g: (r3.g - l3.g) * u + l3.g, b: (r3.b - l3.b) * u + l3.b };
    return h;
  }
  function tlt(l3, r3, e3) {
    var u;
    return Math.round(l3.h) >= 60 && Math.round(l3.h) <= 240 ? u = e3 ? Math.round(l3.h) - cfe * r3 : Math.round(l3.h) + cfe * r3 : u = e3 ? Math.round(l3.h) + cfe * r3 : Math.round(l3.h) - cfe * r3, u < 0 ? u += 360 : u >= 360 && (u -= 360), u;
  }
  function nlt(l3, r3, e3) {
    if (l3.h === 0 && l3.s === 0)
      return l3.s;
    var u;
    return e3 ? u = l3.s - Qst * r3 : r3 === Wvt ? u = l3.s + Qst : u = l3.s + OEn * r3, u > 1 && (u = 1), e3 && r3 === Hvt && u > 0.1 && (u = 0.1), u < 0.06 && (u = 0.06), Number(u.toFixed(2));
  }
  function rlt(l3, r3, e3) {
    var u;
    return e3 ? u = l3.v + PEn * r3 : u = l3.v - LEn * r3, u > 1 && (u = 1), Number(u.toFixed(2));
  }
  function i3e(l3) {
    for (var r3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e3 = [], u = gZ(l3), h = Hvt; h > 0; h -= 1) {
      var v4 = elt(u), m3 = ffe(gZ({ h: tlt(v4, h, true), s: nlt(v4, h, true), v: rlt(v4, h, true) }));
      e3.push(m3);
    }
    e3.push(ffe(u));
    for (var x3 = 1; x3 <= Wvt; x3 += 1) {
      var C = elt(u), A2 = ffe(gZ({ h: tlt(C, x3), s: nlt(C, x3), v: rlt(C, x3) }));
      e3.push(A2);
    }
    return r3.theme === "dark" ? REn.map(function(D) {
      var P = D.index, N = D.opacity, j = ffe(NEn(gZ(r3.backgroundColor || "#141414"), gZ(e3[P]), N * 100));
      return j;
    }) : e3;
  }
  var c5e = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, y1 = {}, f5e = {};
  Object.keys(c5e).forEach(function(l3) {
    y1[l3] = i3e(c5e[l3]), y1[l3].primary = y1[l3][5], f5e[l3] = i3e(c5e[l3], { theme: "dark", backgroundColor: "#141414" }), f5e[l3].primary = f5e[l3][5];
  });
  y1.red;
  y1.volcano;
  y1.gold;
  y1.orange;
  y1.yellow;
  y1.lime;
  y1.green;
  y1.cyan;
  y1.blue;
  y1.geekblue;
  y1.purple;
  y1.magenta;
  y1.grey;
  var ilt = {};
  function FEn(l3, r3) {
  }
  function VEn(l3, r3, e3) {
    !r3 && !ilt[e3] && (l3(false, e3), ilt[e3] = true);
  }
  function HA(l3, r3) {
    VEn(FEn, l3, r3);
  }
  function Uvt() {
    return !!(typeof window != "undefined" && window.document && window.document.createElement);
  }
  var BEn = "rc-util-key";
  function qvt() {
    var l3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, r3 = l3.mark;
    return r3 ? r3.startsWith("data-") ? r3 : "data-".concat(r3) : BEn;
  }
  function IPe(l3) {
    if (l3.attachTo)
      return l3.attachTo;
    var r3 = document.querySelector("head");
    return r3 || document.body;
  }
  function alt(l3) {
    var r3, e3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    if (!Uvt())
      return null;
    var u = document.createElement("style");
    if (!((r3 = e3.csp) === null || r3 === void 0) && r3.nonce) {
      var h;
      u.nonce = (h = e3.csp) === null || h === void 0 ? void 0 : h.nonce;
    }
    u.innerHTML = l3;
    var v4 = IPe(e3), m3 = v4.firstChild;
    return e3.prepend && v4.prepend ? v4.prepend(u) : e3.prepend && m3 ? v4.insertBefore(u, m3) : v4.appendChild(u), u;
  }
  var a3e = /* @__PURE__ */ new Map();
  function zEn(l3) {
    var r3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e3 = IPe(r3);
    return Array.from(a3e.get(e3).children).find(function(u) {
      return u.tagName === "STYLE" && u.getAttribute(qvt(r3)) === l3;
    });
  }
  function $vt(l3, r3) {
    var e3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, u = IPe(e3);
    if (!a3e.has(u)) {
      var h = alt("", e3), v4 = h.parentNode;
      a3e.set(u, v4), v4.removeChild(h);
    }
    var m3 = zEn(r3, e3);
    if (m3) {
      var x3, C;
      if (((x3 = e3.csp) === null || x3 === void 0 ? void 0 : x3.nonce) && m3.nonce !== ((C = e3.csp) === null || C === void 0 ? void 0 : C.nonce)) {
        var A2;
        m3.nonce = (A2 = e3.csp) === null || A2 === void 0 ? void 0 : A2.nonce;
      }
      return m3.innerHTML !== l3 && (m3.innerHTML = l3), m3;
    }
    var D = alt(l3, e3);
    return D.setAttribute(qvt(e3), r3), D;
  }
  function jEn(l3, r3) {
    HA(l3, "[@ant-design/icons] ".concat(r3));
  }
  function olt(l3) {
    return g1(l3) === "object" && typeof l3.name == "string" && typeof l3.theme == "string" && (g1(l3.icon) === "object" || typeof l3.icon == "function");
  }
  function slt() {
    var l3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    return Object.keys(l3).reduce(function(r3, e3) {
      var u = l3[e3];
      switch (e3) {
        case "class":
          r3.className = u, delete r3.class;
          break;
        default:
          r3[e3] = u;
      }
      return r3;
    }, {});
  }
  function o3e(l3, r3, e3) {
    return e3 ? uj.default.createElement(l3.tag, cu(cu({ key: r3 }, slt(l3.attrs)), e3), (l3.children || []).map(function(u, h) {
      return o3e(u, "".concat(r3, "-").concat(l3.tag, "-").concat(h));
    })) : uj.default.createElement(l3.tag, cu({ key: r3 }, slt(l3.attrs)), (l3.children || []).map(function(u, h) {
      return o3e(u, "".concat(r3, "-").concat(l3.tag, "-").concat(h));
    }));
  }
  function Xvt(l3) {
    return i3e(l3)[0];
  }
  function Yvt(l3) {
    return l3 ? Array.isArray(l3) ? l3 : [l3] : [];
  }
  var GEn = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, HEn = function() {
    var r3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : GEn, e3 = Nc.useContext(Bvt), u = e3.csp;
    Nc.useEffect(function() {
      $vt(r3, "@ant-design-icons", { prepend: true, csp: u });
    }, []);
  }, WEn = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], XZ = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
  function UEn(l3) {
    var r3 = l3.primaryColor, e3 = l3.secondaryColor;
    XZ.primaryColor = r3, XZ.secondaryColor = e3 || Xvt(r3), XZ.calculated = !!e3;
  }
  function qEn() {
    return cu({}, XZ);
  }
  var Spe = function(r3) {
    var e3 = r3.icon, u = r3.className, h = r3.onClick, v4 = r3.style, m3 = r3.primaryColor, x3 = r3.secondaryColor, C = Rj(r3, WEn), A2 = XZ;
    if (m3 && (A2 = { primaryColor: m3, secondaryColor: x3 || Xvt(m3) }), HEn(), jEn(olt(e3), "icon should be icon definiton, but got ".concat(e3)), !olt(e3))
      return null;
    var D = e3;
    return D && typeof D.icon == "function" && (D = cu(cu({}, D), {}, { icon: D.icon(A2.primaryColor, A2.secondaryColor) })), o3e(D.icon, "svg-".concat(D.name), cu({ className: u, onClick: h, style: v4, "data-icon": D.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, C));
  };
  Spe.displayName = "IconReact";
  Spe.getTwoToneColors = qEn;
  Spe.setTwoToneColors = UEn;
  var EPe = Spe;
  function Kvt(l3) {
    var r3 = Yvt(l3), e3 = m2(r3, 2), u = e3[0], h = e3[1];
    return EPe.setTwoToneColors({ primaryColor: u, secondaryColor: h });
  }
  function $En() {
    var l3 = EPe.getTwoToneColors();
    return l3.calculated ? [l3.primaryColor, l3.secondaryColor] : l3.primaryColor;
  }
  var XEn = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
  Kvt("#1890ff");
  var Cpe = ma.forwardRef(function(l3, r3) {
    var e3, u = l3.className, h = l3.icon, v4 = l3.spin, m3 = l3.rotate, x3 = l3.tabIndex, C = l3.onClick, A2 = l3.twoToneColor, D = Rj(l3, XEn), P = ma.useContext(Bvt), N = P.prefixCls, j = N === void 0 ? "anticon" : N, W = Nj(j, (e3 = {}, fh(e3, "".concat(j, "-").concat(h.name), !!h.name), fh(e3, "".concat(j, "-spin"), !!v4 || h.name === "loading"), e3), u), K = x3;
    K === void 0 && C && (K = -1);
    var te = m3 ? { msTransform: "rotate(".concat(m3, "deg)"), transform: "rotate(".concat(m3, "deg)") } : void 0, ne = Yvt(A2), ce = m2(ne, 2), me = ce[0], ve = ce[1];
    return ma.createElement("span", cu(cu({ role: "img", "aria-label": h.name }, D), {}, { ref: r3, tabIndex: K, onClick: C, className: W }), ma.createElement(EPe, { icon: h, primaryColor: me, secondaryColor: ve, style: te }));
  });
  Cpe.displayName = "AntdIcon";
  Cpe.getTwoToneColor = $En;
  Cpe.setTwoToneColor = Kvt;
  var YEn = Cpe, KEn = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, ZEn = KEn, Zvt = function(r3, e3) {
    return ma.createElement(YEn, cu(cu({}, r3), {}, { ref: e3, icon: ZEn }));
  };
  Zvt.displayName = "LoadingOutlined";
  var JEn = ma.forwardRef(Zvt);
  function hg() {
    return hg = Object.assign || function(l3) {
      for (var r3 = 1; r3 < arguments.length; r3++) {
        var e3 = arguments[r3];
        for (var u in e3)
          Object.prototype.hasOwnProperty.call(e3, u) && (l3[u] = e3[u]);
      }
      return l3;
    }, hg.apply(this, arguments);
  }
  function ZJ(l3, r3) {
    if (!(l3 instanceof r3))
      throw new TypeError("Cannot call a class as a function");
  }
  function llt(l3, r3) {
    for (var e3 = 0; e3 < r3.length; e3++) {
      var u = r3[e3];
      u.enumerable = u.enumerable || false, u.configurable = true, "value" in u && (u.writable = true), Object.defineProperty(l3, u.key, u);
    }
  }
  function JJ(l3, r3, e3) {
    return r3 && llt(l3.prototype, r3), e3 && llt(l3, e3), Object.defineProperty(l3, "prototype", { writable: false }), l3;
  }
  function s3e(l3, r3) {
    return s3e = Object.setPrototypeOf || function(u, h) {
      return u.__proto__ = h, u;
    }, s3e(l3, r3);
  }
  function DPe(l3, r3) {
    if (typeof r3 != "function" && r3 !== null)
      throw new TypeError("Super expression must either be null or a function");
    l3.prototype = Object.create(r3 && r3.prototype, { constructor: { value: l3, writable: true, configurable: true } }), Object.defineProperty(l3, "prototype", { writable: false }), r3 && s3e(l3, r3);
  }
  function Phe(l3) {
    return Phe = Object.setPrototypeOf ? Object.getPrototypeOf : function(e3) {
      return e3.__proto__ || Object.getPrototypeOf(e3);
    }, Phe(l3);
  }
  function QEn() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function kPe(l3) {
    if (l3 === void 0)
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    return l3;
  }
  function eDn(l3, r3) {
    if (r3 && (g1(r3) === "object" || typeof r3 == "function"))
      return r3;
    if (r3 !== void 0)
      throw new TypeError("Derived constructors may only return object or undefined");
    return kPe(l3);
  }
  function OPe(l3) {
    var r3 = QEn();
    return function() {
      var u = Phe(l3), h;
      if (r3) {
        var v4 = Phe(this).constructor;
        h = Reflect.construct(u, arguments, v4);
      } else
        h = u.apply(this, arguments);
      return eDn(this, h);
    };
  }
  var PPe = { exports: {} }, jh = {};
  /** @license React v16.13.1
  * react-is.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var ry = typeof Symbol == "function" && Symbol.for, LPe = ry ? Symbol.for("react.element") : 60103, RPe = ry ? Symbol.for("react.portal") : 60106, Mpe = ry ? Symbol.for("react.fragment") : 60107, Tpe = ry ? Symbol.for("react.strict_mode") : 60108, Ape = ry ? Symbol.for("react.profiler") : 60114, Ipe = ry ? Symbol.for("react.provider") : 60109, Epe = ry ? Symbol.for("react.context") : 60110, NPe = ry ? Symbol.for("react.async_mode") : 60111, Dpe = ry ? Symbol.for("react.concurrent_mode") : 60111, kpe = ry ? Symbol.for("react.forward_ref") : 60112, Ope = ry ? Symbol.for("react.suspense") : 60113, tDn = ry ? Symbol.for("react.suspense_list") : 60120, Ppe = ry ? Symbol.for("react.memo") : 60115, Lpe = ry ? Symbol.for("react.lazy") : 60116, nDn = ry ? Symbol.for("react.block") : 60121, rDn = ry ? Symbol.for("react.fundamental") : 60117, iDn = ry ? Symbol.for("react.responder") : 60118, aDn = ry ? Symbol.for("react.scope") : 60119;
  function tw(l3) {
    if (typeof l3 == "object" && l3 !== null) {
      var r3 = l3.$$typeof;
      switch (r3) {
        case LPe:
          switch (l3 = l3.type, l3) {
            case NPe:
            case Dpe:
            case Mpe:
            case Ape:
            case Tpe:
            case Ope:
              return l3;
            default:
              switch (l3 = l3 && l3.$$typeof, l3) {
                case Epe:
                case kpe:
                case Lpe:
                case Ppe:
                case Ipe:
                  return l3;
                default:
                  return r3;
              }
          }
        case RPe:
          return r3;
      }
    }
  }
  function Jvt(l3) {
    return tw(l3) === Dpe;
  }
  jh.AsyncMode = NPe;
  jh.ConcurrentMode = Dpe;
  jh.ContextConsumer = Epe;
  jh.ContextProvider = Ipe;
  jh.Element = LPe;
  jh.ForwardRef = kpe;
  jh.Fragment = Mpe;
  jh.Lazy = Lpe;
  jh.Memo = Ppe;
  jh.Portal = RPe;
  jh.Profiler = Ape;
  jh.StrictMode = Tpe;
  jh.Suspense = Ope;
  jh.isAsyncMode = function(l3) {
    return Jvt(l3) || tw(l3) === NPe;
  };
  jh.isConcurrentMode = Jvt;
  jh.isContextConsumer = function(l3) {
    return tw(l3) === Epe;
  };
  jh.isContextProvider = function(l3) {
    return tw(l3) === Ipe;
  };
  jh.isElement = function(l3) {
    return typeof l3 == "object" && l3 !== null && l3.$$typeof === LPe;
  };
  jh.isForwardRef = function(l3) {
    return tw(l3) === kpe;
  };
  jh.isFragment = function(l3) {
    return tw(l3) === Mpe;
  };
  jh.isLazy = function(l3) {
    return tw(l3) === Lpe;
  };
  jh.isMemo = function(l3) {
    return tw(l3) === Ppe;
  };
  jh.isPortal = function(l3) {
    return tw(l3) === RPe;
  };
  jh.isProfiler = function(l3) {
    return tw(l3) === Ape;
  };
  jh.isStrictMode = function(l3) {
    return tw(l3) === Tpe;
  };
  jh.isSuspense = function(l3) {
    return tw(l3) === Ope;
  };
  jh.isValidElementType = function(l3) {
    return typeof l3 == "string" || typeof l3 == "function" || l3 === Mpe || l3 === Dpe || l3 === Ape || l3 === Tpe || l3 === Ope || l3 === tDn || typeof l3 == "object" && l3 !== null && (l3.$$typeof === Lpe || l3.$$typeof === Ppe || l3.$$typeof === Ipe || l3.$$typeof === Epe || l3.$$typeof === kpe || l3.$$typeof === rDn || l3.$$typeof === iDn || l3.$$typeof === aDn || l3.$$typeof === nDn);
  };
  jh.typeOf = tw;
  PPe.exports = jh;
  function l3e(l3) {
    var r3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, e3 = [];
    return uj.default.Children.forEach(l3, function(u) {
      u == null && !r3.keepEmpty || (Array.isArray(u) ? e3 = e3.concat(l3e(u)) : PPe.exports.isFragment(u) && u.props ? e3 = e3.concat(l3e(u.props.children, r3)) : e3.push(u));
    }), e3;
  }
  function oDn(l3, r3) {
    typeof l3 == "function" ? l3(r3) : g1(l3) === "object" && l3 && "current" in l3 && (l3.current = r3);
  }
  function sDn() {
    for (var l3 = arguments.length, r3 = new Array(l3), e3 = 0; e3 < l3; e3++)
      r3[e3] = arguments[e3];
    var u = r3.filter(function(h) {
      return h;
    });
    return u.length <= 1 ? u[0] : function(h) {
      r3.forEach(function(v4) {
        oDn(v4, h);
      });
    };
  }
  function lDn(l3) {
    var r3, e3, u = PPe.exports.isMemo(l3) ? l3.type.type : l3.type;
    return !(typeof u == "function" && !(!((r3 = u.prototype) === null || r3 === void 0) && r3.render) || typeof l3 == "function" && !(!((e3 = l3.prototype) === null || e3 === void 0) && e3.render));
  }
  function hDn() {
    try {
      if (!Object.assign)
        return false;
      var l3 = new String("abc");
      if (l3[5] = "de", Object.getOwnPropertyNames(l3)[0] === "5")
        return false;
      for (var r3 = {}, e3 = 0; e3 < 10; e3++)
        r3["_" + String.fromCharCode(e3)] = e3;
      var u = Object.getOwnPropertyNames(r3).map(function(v4) {
        return r3[v4];
      });
      if (u.join("") !== "0123456789")
        return false;
      var h = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(v4) {
        h[v4] = v4;
      }), Object.keys(Object.assign({}, h)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return false;
    }
  }
  hDn();
  function pDn(l3) {
    if (Array.isArray(l3))
      return r3e(l3);
  }
  function Qvt(l3) {
    if (typeof Symbol != "undefined" && l3[Symbol.iterator] != null || l3["@@iterator"] != null)
      return Array.from(l3);
  }
  function dDn() {
    throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
  }
  function of(l3) {
    return pDn(l3) || Qvt(l3) || APe(l3) || dDn();
  }
  var tj = "RC_FORM_INTERNAL_HOOKS", Yp = function() {
    HA(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
  }, TJ = ma.createContext({ getFieldValue: Yp, getFieldsValue: Yp, getFieldError: Yp, getFieldWarning: Yp, getFieldsError: Yp, isFieldsTouched: Yp, isFieldTouched: Yp, isFieldValidating: Yp, isFieldsValidating: Yp, resetFields: Yp, setFields: Yp, setFieldsValue: Yp, validateFields: Yp, submit: Yp, getInternalHooks: function() {
    return Yp(), { dispatch: Yp, initEntityValue: Yp, registerField: Yp, useSubscribe: Yp, setInitialValues: Yp, setCallbacks: Yp, getFields: Yp, setValidateMessages: Yp, setPreserve: Yp, getInitialValue: Yp };
  } });
  function u3e(l3) {
    return l3 == null ? [] : Array.isArray(l3) ? l3 : [l3];
  }
  var egt = { exports: {} };
  (function(l3) {
    var r3 = function(e3) {
      var u = Object.prototype, h = u.hasOwnProperty, v4, m3 = typeof Symbol == "function" ? Symbol : {}, x3 = m3.iterator || "@@iterator", C = m3.asyncIterator || "@@asyncIterator", A2 = m3.toStringTag || "@@toStringTag";
      function D(hn, xn, zn) {
        return Object.defineProperty(hn, xn, { value: zn, enumerable: true, configurable: true, writable: true }), hn[xn];
      }
      try {
        D({}, "");
      } catch {
        D = function(xn, zn, or) {
          return xn[zn] = or;
        };
      }
      function P(hn, xn, zn, or) {
        var vr = xn && xn.prototype instanceof ce ? xn : ce, la = Object.create(vr.prototype), Ba = new Zt(or || []);
        return la._invoke = ct(hn, zn, Ba), la;
      }
      e3.wrap = P;
      function N(hn, xn, zn) {
        try {
          return { type: "normal", arg: hn.call(xn, zn) };
        } catch (or) {
          return { type: "throw", arg: or };
        }
      }
      var j = "suspendedStart", W = "suspendedYield", K = "executing", te = "completed", ne = {};
      function ce() {
      }
      function me() {
      }
      function ve() {
      }
      var Be = {};
      D(Be, x3, function() {
        return this;
      });
      var Oe = Object.getPrototypeOf, We = Oe && Oe(Oe(Ft([])));
      We && We !== u && h.call(We, x3) && (Be = We);
      var Ue = ve.prototype = ce.prototype = Object.create(Be);
      me.prototype = ve, D(Ue, "constructor", ve), D(ve, "constructor", me), me.displayName = D(ve, A2, "GeneratorFunction");
      function qe(hn) {
        ["next", "throw", "return"].forEach(function(xn) {
          D(hn, xn, function(zn) {
            return this._invoke(xn, zn);
          });
        });
      }
      e3.isGeneratorFunction = function(hn) {
        var xn = typeof hn == "function" && hn.constructor;
        return xn ? xn === me || (xn.displayName || xn.name) === "GeneratorFunction" : false;
      }, e3.mark = function(hn) {
        return Object.setPrototypeOf ? Object.setPrototypeOf(hn, ve) : (hn.__proto__ = ve, D(hn, A2, "GeneratorFunction")), hn.prototype = Object.create(Ue), hn;
      }, e3.awrap = function(hn) {
        return { __await: hn };
      };
      function Ze(hn, xn) {
        function zn(la, Ba, Lo, Ao) {
          var oo = N(hn[la], hn, Ba);
          if (oo.type === "throw")
            Ao(oo.arg);
          else {
            var Pa = oo.arg, fo = Pa.value;
            return fo && typeof fo == "object" && h.call(fo, "__await") ? xn.resolve(fo.__await).then(function(Co) {
              zn("next", Co, Lo, Ao);
            }, function(Co) {
              zn("throw", Co, Lo, Ao);
            }) : xn.resolve(fo).then(function(Co) {
              Pa.value = Co, Lo(Pa);
            }, function(Co) {
              return zn("throw", Co, Lo, Ao);
            });
          }
        }
        var or;
        function vr(la, Ba) {
          function Lo() {
            return new xn(function(Ao, oo) {
              zn(la, Ba, Ao, oo);
            });
          }
          return or = or ? or.then(Lo, Lo) : Lo();
        }
        this._invoke = vr;
      }
      qe(Ze.prototype), D(Ze.prototype, C, function() {
        return this;
      }), e3.AsyncIterator = Ze, e3.async = function(hn, xn, zn, or, vr) {
        vr === void 0 && (vr = Promise);
        var la = new Ze(P(hn, xn, zn, or), vr);
        return e3.isGeneratorFunction(xn) ? la : la.next().then(function(Ba) {
          return Ba.done ? Ba.value : la.next();
        });
      };
      function ct(hn, xn, zn) {
        var or = j;
        return function(la, Ba) {
          if (or === K)
            throw new Error("Generator is already running");
          if (or === te) {
            if (la === "throw")
              throw Ba;
            return Kn();
          }
          for (zn.method = la, zn.arg = Ba; ; ) {
            var Lo = zn.delegate;
            if (Lo) {
              var Ao = _t(Lo, zn);
              if (Ao) {
                if (Ao === ne)
                  continue;
                return Ao;
              }
            }
            if (zn.method === "next")
              zn.sent = zn._sent = zn.arg;
            else if (zn.method === "throw") {
              if (or === j)
                throw or = te, zn.arg;
              zn.dispatchException(zn.arg);
            } else
              zn.method === "return" && zn.abrupt("return", zn.arg);
            or = K;
            var oo = N(hn, xn, zn);
            if (oo.type === "normal") {
              if (or = zn.done ? te : W, oo.arg === ne)
                continue;
              return { value: oo.arg, done: zn.done };
            } else
              oo.type === "throw" && (or = te, zn.method = "throw", zn.arg = oo.arg);
          }
        };
      }
      function _t(hn, xn) {
        var zn = hn.iterator[xn.method];
        if (zn === v4) {
          if (xn.delegate = null, xn.method === "throw") {
            if (hn.iterator.return && (xn.method = "return", xn.arg = v4, _t(hn, xn), xn.method === "throw"))
              return ne;
            xn.method = "throw", xn.arg = new TypeError("The iterator does not provide a 'throw' method");
          }
          return ne;
        }
        var or = N(zn, hn.iterator, xn.arg);
        if (or.type === "throw")
          return xn.method = "throw", xn.arg = or.arg, xn.delegate = null, ne;
        var vr = or.arg;
        if (!vr)
          return xn.method = "throw", xn.arg = new TypeError("iterator result is not an object"), xn.delegate = null, ne;
        if (vr.done)
          xn[hn.resultName] = vr.value, xn.next = hn.nextLoc, xn.method !== "return" && (xn.method = "next", xn.arg = v4);
        else
          return vr;
        return xn.delegate = null, ne;
      }
      qe(Ue), D(Ue, A2, "Generator"), D(Ue, x3, function() {
        return this;
      }), D(Ue, "toString", function() {
        return "[object Generator]";
      });
      function pt(hn) {
        var xn = { tryLoc: hn[0] };
        1 in hn && (xn.catchLoc = hn[1]), 2 in hn && (xn.finallyLoc = hn[2], xn.afterLoc = hn[3]), this.tryEntries.push(xn);
      }
      function zt(hn) {
        var xn = hn.completion || {};
        xn.type = "normal", delete xn.arg, hn.completion = xn;
      }
      function Zt(hn) {
        this.tryEntries = [{ tryLoc: "root" }], hn.forEach(pt, this), this.reset(true);
      }
      e3.keys = function(hn) {
        var xn = [];
        for (var zn in hn)
          xn.push(zn);
        return xn.reverse(), function or() {
          for (; xn.length; ) {
            var vr = xn.pop();
            if (vr in hn)
              return or.value = vr, or.done = false, or;
          }
          return or.done = true, or;
        };
      };
      function Ft(hn) {
        if (hn) {
          var xn = hn[x3];
          if (xn)
            return xn.call(hn);
          if (typeof hn.next == "function")
            return hn;
          if (!isNaN(hn.length)) {
            var zn = -1, or = function vr() {
              for (; ++zn < hn.length; )
                if (h.call(hn, zn))
                  return vr.value = hn[zn], vr.done = false, vr;
              return vr.value = v4, vr.done = true, vr;
            };
            return or.next = or;
          }
        }
        return { next: Kn };
      }
      e3.values = Ft;
      function Kn() {
        return { value: v4, done: true };
      }
      return Zt.prototype = { constructor: Zt, reset: function(hn) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = v4, this.done = false, this.delegate = null, this.method = "next", this.arg = v4, this.tryEntries.forEach(zt), !hn)
          for (var xn in this)
            xn.charAt(0) === "t" && h.call(this, xn) && !isNaN(+xn.slice(1)) && (this[xn] = v4);
      }, stop: function() {
        this.done = true;
        var hn = this.tryEntries[0], xn = hn.completion;
        if (xn.type === "throw")
          throw xn.arg;
        return this.rval;
      }, dispatchException: function(hn) {
        if (this.done)
          throw hn;
        var xn = this;
        function zn(Ao, oo) {
          return la.type = "throw", la.arg = hn, xn.next = Ao, oo && (xn.method = "next", xn.arg = v4), !!oo;
        }
        for (var or = this.tryEntries.length - 1; or >= 0; --or) {
          var vr = this.tryEntries[or], la = vr.completion;
          if (vr.tryLoc === "root")
            return zn("end");
          if (vr.tryLoc <= this.prev) {
            var Ba = h.call(vr, "catchLoc"), Lo = h.call(vr, "finallyLoc");
            if (Ba && Lo) {
              if (this.prev < vr.catchLoc)
                return zn(vr.catchLoc, true);
              if (this.prev < vr.finallyLoc)
                return zn(vr.finallyLoc);
            } else if (Ba) {
              if (this.prev < vr.catchLoc)
                return zn(vr.catchLoc, true);
            } else if (Lo) {
              if (this.prev < vr.finallyLoc)
                return zn(vr.finallyLoc);
            } else
              throw new Error("try statement without catch or finally");
          }
        }
      }, abrupt: function(hn, xn) {
        for (var zn = this.tryEntries.length - 1; zn >= 0; --zn) {
          var or = this.tryEntries[zn];
          if (or.tryLoc <= this.prev && h.call(or, "finallyLoc") && this.prev < or.finallyLoc) {
            var vr = or;
            break;
          }
        }
        vr && (hn === "break" || hn === "continue") && vr.tryLoc <= xn && xn <= vr.finallyLoc && (vr = null);
        var la = vr ? vr.completion : {};
        return la.type = hn, la.arg = xn, vr ? (this.method = "next", this.next = vr.finallyLoc, ne) : this.complete(la);
      }, complete: function(hn, xn) {
        if (hn.type === "throw")
          throw hn.arg;
        return hn.type === "break" || hn.type === "continue" ? this.next = hn.arg : hn.type === "return" ? (this.rval = this.arg = hn.arg, this.method = "return", this.next = "end") : hn.type === "normal" && xn && (this.next = xn), ne;
      }, finish: function(hn) {
        for (var xn = this.tryEntries.length - 1; xn >= 0; --xn) {
          var zn = this.tryEntries[xn];
          if (zn.finallyLoc === hn)
            return this.complete(zn.completion, zn.afterLoc), zt(zn), ne;
        }
      }, catch: function(hn) {
        for (var xn = this.tryEntries.length - 1; xn >= 0; --xn) {
          var zn = this.tryEntries[xn];
          if (zn.tryLoc === hn) {
            var or = zn.completion;
            if (or.type === "throw") {
              var vr = or.arg;
              zt(zn);
            }
            return vr;
          }
        }
        throw new Error("illegal catch attempt");
      }, delegateYield: function(hn, xn, zn) {
        return this.delegate = { iterator: Ft(hn), resultName: xn, nextLoc: zn }, this.method === "next" && (this.arg = v4), ne;
      } }, e3;
    }(l3.exports);
    try {
      regeneratorRuntime = r3;
    } catch {
      typeof globalThis == "object" ? globalThis.regeneratorRuntime = r3 : Function("r", "regeneratorRuntime = r")(r3);
    }
  })(egt);
  var aP = egt.exports;
  function clt(l3, r3, e3, u, h, v4, m3) {
    try {
      var x3 = l3[v4](m3), C = x3.value;
    } catch (A2) {
      e3(A2);
      return;
    }
    x3.done ? r3(C) : Promise.resolve(C).then(u, h);
  }
  function Rpe(l3) {
    return function() {
      var r3 = this, e3 = arguments;
      return new Promise(function(u, h) {
        var v4 = l3.apply(r3, e3);
        function m3(C) {
          clt(v4, u, h, m3, x3, "next", C);
        }
        function x3(C) {
          clt(v4, u, h, m3, x3, "throw", C);
        }
        m3(void 0);
      });
    };
  }
  function PN() {
    return PN = Object.assign || function(l3) {
      for (var r3 = 1; r3 < arguments.length; r3++) {
        var e3 = arguments[r3];
        for (var u in e3)
          Object.prototype.hasOwnProperty.call(e3, u) && (l3[u] = e3[u]);
      }
      return l3;
    }, PN.apply(this, arguments);
  }
  function vDn(l3, r3) {
    l3.prototype = Object.create(r3.prototype), l3.prototype.constructor = l3, AJ(l3, r3);
  }
  function c3e(l3) {
    return c3e = Object.setPrototypeOf ? Object.getPrototypeOf : function(e3) {
      return e3.__proto__ || Object.getPrototypeOf(e3);
    }, c3e(l3);
  }
  function AJ(l3, r3) {
    return AJ = Object.setPrototypeOf || function(u, h) {
      return u.__proto__ = h, u;
    }, AJ(l3, r3);
  }
  function gDn() {
    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
      return false;
    if (typeof Proxy == "function")
      return true;
    try {
      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      })), true;
    } catch {
      return false;
    }
  }
  function Rfe(l3, r3, e3) {
    return gDn() ? Rfe = Reflect.construct : Rfe = function(h, v4, m3) {
      var x3 = [null];
      x3.push.apply(x3, v4);
      var C = Function.bind.apply(h, x3), A2 = new C();
      return m3 && AJ(A2, m3.prototype), A2;
    }, Rfe.apply(null, arguments);
  }
  function yDn(l3) {
    return Function.toString.call(l3).indexOf("[native code]") !== -1;
  }
  function f3e(l3) {
    var r3 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
    return f3e = function(u) {
      if (u === null || !yDn(u))
        return u;
      if (typeof u != "function")
        throw new TypeError("Super expression must either be null or a function");
      if (typeof r3 != "undefined") {
        if (r3.has(u))
          return r3.get(u);
        r3.set(u, h);
      }
      function h() {
        return Rfe(u, arguments, c3e(this).constructor);
      }
      return h.prototype = Object.create(u.prototype, { constructor: { value: h, enumerable: false, writable: true, configurable: true } }), AJ(h, u);
    }, f3e(l3);
  }
  var mDn = /%[sdj%]/g, bDn = function() {
  };
  typeof process != "undefined" && process.env;
  function h3e(l3) {
    if (!l3 || !l3.length)
      return null;
    var r3 = {};
    return l3.forEach(function(e3) {
      var u = e3.field;
      r3[u] = r3[u] || [], r3[u].push(e3);
    }), r3;
  }
  function Zx(l3) {
    for (var r3 = arguments.length, e3 = new Array(r3 > 1 ? r3 - 1 : 0), u = 1; u < r3; u++)
      e3[u - 1] = arguments[u];
    var h = 0, v4 = e3.length;
    if (typeof l3 == "function")
      return l3.apply(null, e3);
    if (typeof l3 == "string") {
      var m3 = l3.replace(mDn, function(x3) {
        if (x3 === "%%")
          return "%";
        if (h >= v4)
          return x3;
        switch (x3) {
          case "%s":
            return String(e3[h++]);
          case "%d":
            return Number(e3[h++]);
          case "%j":
            try {
              return JSON.stringify(e3[h++]);
            } catch {
              return "[Circular]";
            }
            break;
          default:
            return x3;
        }
      });
      return m3;
    }
    return l3;
  }
  function _Dn(l3) {
    return l3 === "string" || l3 === "url" || l3 === "hex" || l3 === "email" || l3 === "date" || l3 === "pattern";
  }
  function s0(l3, r3) {
    return !!(l3 == null || r3 === "array" && Array.isArray(l3) && !l3.length || _Dn(r3) && typeof l3 == "string" && !l3);
  }
  function xDn(l3, r3, e3) {
    var u = [], h = 0, v4 = l3.length;
    function m3(x3) {
      u.push.apply(u, x3 || []), h++, h === v4 && e3(u);
    }
    l3.forEach(function(x3) {
      r3(x3, m3);
    });
  }
  function flt(l3, r3, e3) {
    var u = 0, h = l3.length;
    function v4(m3) {
      if (m3 && m3.length) {
        e3(m3);
        return;
      }
      var x3 = u;
      u = u + 1, x3 < h ? r3(l3[x3], v4) : e3([]);
    }
    v4([]);
  }
  function wDn(l3) {
    var r3 = [];
    return Object.keys(l3).forEach(function(e3) {
      r3.push.apply(r3, l3[e3] || []);
    }), r3;
  }
  var hlt = function(l3) {
    vDn(r3, l3);
    function r3(e3, u) {
      var h;
      return h = l3.call(this, "Async Validation Error") || this, h.errors = e3, h.fields = u, h;
    }
    return r3;
  }(f3e(Error));
  function SDn(l3, r3, e3, u, h) {
    if (r3.first) {
      var v4 = new Promise(function(N, j) {
        var W = function(ne) {
          return u(ne), ne.length ? j(new hlt(ne, h3e(ne))) : N(h);
        }, K = wDn(l3);
        flt(K, e3, W);
      });
      return v4.catch(function(N) {
        return N;
      }), v4;
    }
    var m3 = r3.firstFields === true ? Object.keys(l3) : r3.firstFields || [], x3 = Object.keys(l3), C = x3.length, A2 = 0, D = [], P = new Promise(function(N, j) {
      var W = function(te) {
        if (D.push.apply(D, te), A2++, A2 === C)
          return u(D), D.length ? j(new hlt(D, h3e(D))) : N(h);
      };
      x3.length || (u(D), N(h)), x3.forEach(function(K) {
        var te = l3[K];
        m3.indexOf(K) !== -1 ? flt(te, e3, W) : xDn(te, e3, W);
      });
    });
    return P.catch(function(N) {
      return N;
    }), P;
  }
  function CDn(l3) {
    return !!(l3 && l3.message !== void 0);
  }
  function MDn(l3, r3) {
    for (var e3 = l3, u = 0; u < r3.length; u++) {
      if (e3 == null)
        return e3;
      e3 = e3[r3[u]];
    }
    return e3;
  }
  function plt(l3, r3) {
    return function(e3) {
      var u;
      return l3.fullFields ? u = MDn(r3, l3.fullFields) : u = r3[e3.field || l3.fullField], CDn(e3) ? (e3.field = e3.field || l3.fullField, e3.fieldValue = u, e3) : { message: typeof e3 == "function" ? e3() : e3, fieldValue: u, field: e3.field || l3.fullField };
    };
  }
  function dlt(l3, r3) {
    if (r3) {
      for (var e3 in r3)
        if (r3.hasOwnProperty(e3)) {
          var u = r3[e3];
          typeof u == "object" && typeof l3[e3] == "object" ? l3[e3] = PN({}, l3[e3], u) : l3[e3] = u;
        }
    }
    return l3;
  }
  var tgt = function(r3, e3, u, h, v4, m3) {
    r3.required && (!u.hasOwnProperty(r3.field) || s0(e3, m3 || r3.type)) && h.push(Zx(v4.messages.required, r3.fullField));
  }, TDn = function(r3, e3, u, h, v4) {
    (/^\s+$/.test(e3) || e3 === "") && h.push(Zx(v4.messages.whitespace, r3.fullField));
  }, h5e = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, kZ = { integer: function(r3) {
    return kZ.number(r3) && parseInt(r3, 10) === r3;
  }, float: function(r3) {
    return kZ.number(r3) && !kZ.integer(r3);
  }, array: function(r3) {
    return Array.isArray(r3);
  }, regexp: function(r3) {
    if (r3 instanceof RegExp)
      return true;
    try {
      return !!new RegExp(r3);
    } catch {
      return false;
    }
  }, date: function(r3) {
    return typeof r3.getTime == "function" && typeof r3.getMonth == "function" && typeof r3.getYear == "function" && !isNaN(r3.getTime());
  }, number: function(r3) {
    return isNaN(r3) ? false : typeof r3 == "number";
  }, object: function(r3) {
    return typeof r3 == "object" && !kZ.array(r3);
  }, method: function(r3) {
    return typeof r3 == "function";
  }, email: function(r3) {
    return typeof r3 == "string" && r3.length <= 320 && !!r3.match(h5e.email);
  }, url: function(r3) {
    return typeof r3 == "string" && r3.length <= 2048 && !!r3.match(h5e.url);
  }, hex: function(r3) {
    return typeof r3 == "string" && !!r3.match(h5e.hex);
  } }, ADn = function(r3, e3, u, h, v4) {
    if (r3.required && e3 === void 0) {
      tgt(r3, e3, u, h, v4);
      return;
    }
    var m3 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], x3 = r3.type;
    m3.indexOf(x3) > -1 ? kZ[x3](e3) || h.push(Zx(v4.messages.types[x3], r3.fullField, r3.type)) : x3 && typeof e3 !== r3.type && h.push(Zx(v4.messages.types[x3], r3.fullField, r3.type));
  }, IDn = function(r3, e3, u, h, v4) {
    var m3 = typeof r3.len == "number", x3 = typeof r3.min == "number", C = typeof r3.max == "number", A2 = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, D = e3, P = null, N = typeof e3 == "number", j = typeof e3 == "string", W = Array.isArray(e3);
    if (N ? P = "number" : j ? P = "string" : W && (P = "array"), !P)
      return false;
    W && (D = e3.length), j && (D = e3.replace(A2, "_").length), m3 ? D !== r3.len && h.push(Zx(v4.messages[P].len, r3.fullField, r3.len)) : x3 && !C && D < r3.min ? h.push(Zx(v4.messages[P].min, r3.fullField, r3.min)) : C && !x3 && D > r3.max ? h.push(Zx(v4.messages[P].max, r3.fullField, r3.max)) : x3 && C && (D < r3.min || D > r3.max) && h.push(Zx(v4.messages[P].range, r3.fullField, r3.min, r3.max));
  }, Gz = "enum", EDn = function(r3, e3, u, h, v4) {
    r3[Gz] = Array.isArray(r3[Gz]) ? r3[Gz] : [], r3[Gz].indexOf(e3) === -1 && h.push(Zx(v4.messages[Gz], r3.fullField, r3[Gz].join(", ")));
  }, DDn = function(r3, e3, u, h, v4) {
    if (r3.pattern) {
      if (r3.pattern instanceof RegExp)
        r3.pattern.lastIndex = 0, r3.pattern.test(e3) || h.push(Zx(v4.messages.pattern.mismatch, r3.fullField, e3, r3.pattern));
      else if (typeof r3.pattern == "string") {
        var m3 = new RegExp(r3.pattern);
        m3.test(e3) || h.push(Zx(v4.messages.pattern.mismatch, r3.fullField, e3, r3.pattern));
      }
    }
  }, Yc = { required: tgt, whitespace: TDn, type: ADn, range: IDn, enum: EDn, pattern: DDn }, kDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3, "string") && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4, "string"), s0(e3, "string") || (Yc.type(r3, e3, h, m3, v4), Yc.range(r3, e3, h, m3, v4), Yc.pattern(r3, e3, h, m3, v4), r3.whitespace === true && Yc.whitespace(r3, e3, h, m3, v4));
    }
    u(m3);
  }, ODn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && Yc.type(r3, e3, h, m3, v4);
    }
    u(m3);
  }, PDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (e3 === "" && (e3 = void 0), s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && (Yc.type(r3, e3, h, m3, v4), Yc.range(r3, e3, h, m3, v4));
    }
    u(m3);
  }, LDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && Yc.type(r3, e3, h, m3, v4);
    }
    u(m3);
  }, RDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), s0(e3) || Yc.type(r3, e3, h, m3, v4);
    }
    u(m3);
  }, NDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && (Yc.type(r3, e3, h, m3, v4), Yc.range(r3, e3, h, m3, v4));
    }
    u(m3);
  }, FDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && (Yc.type(r3, e3, h, m3, v4), Yc.range(r3, e3, h, m3, v4));
    }
    u(m3);
  }, VDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (e3 == null && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4, "array"), e3 != null && (Yc.type(r3, e3, h, m3, v4), Yc.range(r3, e3, h, m3, v4));
    }
    u(m3);
  }, BDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && Yc.type(r3, e3, h, m3, v4);
    }
    u(m3);
  }, zDn = "enum", jDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), e3 !== void 0 && Yc[zDn](r3, e3, h, m3, v4);
    }
    u(m3);
  }, GDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3, "string") && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4), s0(e3, "string") || Yc.pattern(r3, e3, h, m3, v4);
    }
    u(m3);
  }, HDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3, "date") && !r3.required)
        return u();
      if (Yc.required(r3, e3, h, m3, v4), !s0(e3, "date")) {
        var C;
        e3 instanceof Date ? C = e3 : C = new Date(e3), Yc.type(r3, C, h, m3, v4), C && Yc.range(r3, C.getTime(), h, m3, v4);
      }
    }
    u(m3);
  }, WDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = Array.isArray(e3) ? "array" : typeof e3;
    Yc.required(r3, e3, h, m3, v4, x3), u(m3);
  }, p5e = function(r3, e3, u, h, v4) {
    var m3 = r3.type, x3 = [], C = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (C) {
      if (s0(e3, m3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, x3, v4, m3), s0(e3, m3) || Yc.type(r3, e3, h, x3, v4);
    }
    u(x3);
  }, UDn = function(r3, e3, u, h, v4) {
    var m3 = [], x3 = r3.required || !r3.required && h.hasOwnProperty(r3.field);
    if (x3) {
      if (s0(e3) && !r3.required)
        return u();
      Yc.required(r3, e3, h, m3, v4);
    }
    u(m3);
  }, YZ = { string: kDn, method: ODn, number: PDn, boolean: LDn, regexp: RDn, integer: NDn, float: FDn, array: VDn, object: BDn, enum: jDn, pattern: GDn, date: HDn, url: p5e, hex: p5e, email: p5e, required: WDn, any: UDn };
  function p3e() {
    return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
      var r3 = JSON.parse(JSON.stringify(this));
      return r3.clone = this.clone, r3;
    } };
  }
  var d3e = p3e(), QJ = function() {
    function l3(e3) {
      this.rules = null, this._messages = d3e, this.define(e3);
    }
    var r3 = l3.prototype;
    return r3.define = function(u) {
      var h = this;
      if (!u)
        throw new Error("Cannot configure a schema with no rules");
      if (typeof u != "object" || Array.isArray(u))
        throw new Error("Rules must be an object");
      this.rules = {}, Object.keys(u).forEach(function(v4) {
        var m3 = u[v4];
        h.rules[v4] = Array.isArray(m3) ? m3 : [m3];
      });
    }, r3.messages = function(u) {
      return u && (this._messages = dlt(p3e(), u)), this._messages;
    }, r3.validate = function(u, h, v4) {
      var m3 = this;
      h === void 0 && (h = {}), v4 === void 0 && (v4 = function() {
      });
      var x3 = u, C = h, A2 = v4;
      if (typeof C == "function" && (A2 = C, C = {}), !this.rules || Object.keys(this.rules).length === 0)
        return A2 && A2(null, x3), Promise.resolve(x3);
      function D(K) {
        var te = [], ne = {};
        function ce(ve) {
          if (Array.isArray(ve)) {
            var Be;
            te = (Be = te).concat.apply(Be, ve);
          } else
            te.push(ve);
        }
        for (var me = 0; me < K.length; me++)
          ce(K[me]);
        te.length ? (ne = h3e(te), A2(te, ne)) : A2(null, x3);
      }
      if (C.messages) {
        var P = this.messages();
        P === d3e && (P = p3e()), dlt(P, C.messages), C.messages = P;
      } else
        C.messages = this.messages();
      var N = {}, j = C.keys || Object.keys(this.rules);
      j.forEach(function(K) {
        var te = m3.rules[K], ne = x3[K];
        te.forEach(function(ce) {
          var me = ce;
          typeof me.transform == "function" && (x3 === u && (x3 = PN({}, x3)), ne = x3[K] = me.transform(ne)), typeof me == "function" ? me = { validator: me } : me = PN({}, me), me.validator = m3.getValidationMethod(me), me.validator && (me.field = K, me.fullField = me.fullField || K, me.type = m3.getType(me), N[K] = N[K] || [], N[K].push({ rule: me, value: ne, source: x3, field: K }));
        });
      });
      var W = {};
      return SDn(N, C, function(K, te) {
        var ne = K.rule, ce = (ne.type === "object" || ne.type === "array") && (typeof ne.fields == "object" || typeof ne.defaultField == "object");
        ce = ce && (ne.required || !ne.required && K.value), ne.field = K.field;
        function me(Oe, We) {
          return PN({}, We, { fullField: ne.fullField + "." + Oe, fullFields: ne.fullFields ? [].concat(ne.fullFields, [Oe]) : [Oe] });
        }
        function ve(Oe) {
          Oe === void 0 && (Oe = []);
          var We = Array.isArray(Oe) ? Oe : [Oe];
          !C.suppressWarning && We.length && l3.warning("async-validator:", We), We.length && ne.message !== void 0 && (We = [].concat(ne.message));
          var Ue = We.map(plt(ne, x3));
          if (C.first && Ue.length)
            return W[ne.field] = 1, te(Ue);
          if (!ce)
            te(Ue);
          else {
            if (ne.required && !K.value)
              return ne.message !== void 0 ? Ue = [].concat(ne.message).map(plt(ne, x3)) : C.error && (Ue = [C.error(ne, Zx(C.messages.required, ne.field))]), te(Ue);
            var qe = {};
            ne.defaultField && Object.keys(K.value).map(function(_t) {
              qe[_t] = ne.defaultField;
            }), qe = PN({}, qe, K.rule.fields);
            var Ze = {};
            Object.keys(qe).forEach(function(_t) {
              var pt = qe[_t], zt = Array.isArray(pt) ? pt : [pt];
              Ze[_t] = zt.map(me.bind(null, _t));
            });
            var ct = new l3(Ze);
            ct.messages(C.messages), K.rule.options && (K.rule.options.messages = C.messages, K.rule.options.error = C.error), ct.validate(K.value, K.rule.options || C, function(_t) {
              var pt = [];
              Ue && Ue.length && pt.push.apply(pt, Ue), _t && _t.length && pt.push.apply(pt, _t), te(pt.length ? pt : null);
            });
          }
        }
        var Be;
        ne.asyncValidator ? Be = ne.asyncValidator(ne, K.value, ve, K.source, C) : ne.validator && (Be = ne.validator(ne, K.value, ve, K.source, C), Be === true ? ve() : Be === false ? ve(typeof ne.message == "function" ? ne.message(ne.fullField || ne.field) : ne.message || (ne.fullField || ne.field) + " fails") : Be instanceof Array ? ve(Be) : Be instanceof Error && ve(Be.message)), Be && Be.then && Be.then(function() {
          return ve();
        }, function(Oe) {
          return ve(Oe);
        });
      }, function(K) {
        D(K);
      }, x3);
    }, r3.getType = function(u) {
      if (u.type === void 0 && u.pattern instanceof RegExp && (u.type = "pattern"), typeof u.validator != "function" && u.type && !YZ.hasOwnProperty(u.type))
        throw new Error(Zx("Unknown rule type %s", u.type));
      return u.type || "string";
    }, r3.getValidationMethod = function(u) {
      if (typeof u.validator == "function")
        return u.validator;
      var h = Object.keys(u), v4 = h.indexOf("message");
      return v4 !== -1 && h.splice(v4, 1), h.length === 1 && h[0] === "required" ? YZ.required : YZ[this.getType(u)] || void 0;
    }, l3;
  }();
  QJ.register = function(r3, e3) {
    if (typeof e3 != "function")
      throw new Error("Cannot register a validator by type, validator is not a function");
    YZ[r3] = e3;
  };
  QJ.warning = bDn;
  QJ.messages = d3e;
  QJ.validators = YZ;
  var qx = "'${name}' is not a valid ${type}", ngt = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: qx, method: qx, array: qx, object: qx, number: qx, date: qx, boolean: qx, integer: qx, float: qx, regexp: qx, email: qx, url: qx, hex: qx }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
  function rgt(l3, r3) {
    for (var e3 = l3, u = 0; u < r3.length; u += 1) {
      if (e3 == null)
        return;
      e3 = e3[r3[u]];
    }
    return e3;
  }
  function qDn(l3) {
    return zvt(l3) || Qvt(l3) || APe(l3) || jvt();
  }
  function igt(l3, r3, e3, u) {
    if (!r3.length)
      return e3;
    var h = qDn(r3), v4 = h[0], m3 = h.slice(1), x3;
    return !l3 && typeof v4 == "number" ? x3 = [] : Array.isArray(l3) ? x3 = of(l3) : x3 = cu({}, l3), u && e3 === void 0 && m3.length === 1 ? delete x3[v4][m3[0]] : x3[v4] = igt(x3[v4], m3, e3, u), x3;
  }
  function $Dn(l3, r3, e3) {
    var u = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    return r3.length && u && e3 === void 0 && !rgt(l3, r3.slice(0, -1)) ? l3 : igt(l3, r3, e3, u);
  }
  function fg(l3) {
    return u3e(l3);
  }
  function nj(l3, r3) {
    var e3 = rgt(l3, r3);
    return e3;
  }
  function SN(l3, r3, e3) {
    var u = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, h = $Dn(l3, r3, e3, u);
    return h;
  }
  function vlt(l3, r3) {
    var e3 = {};
    return r3.forEach(function(u) {
      var h = nj(l3, u);
      e3 = SN(e3, u, h);
    }), e3;
  }
  function KZ(l3, r3) {
    return l3 && l3.some(function(e3) {
      return ogt(e3, r3);
    });
  }
  function glt(l3) {
    return g1(l3) === "object" && l3 !== null && Object.getPrototypeOf(l3) === Object.prototype;
  }
  function agt(l3, r3) {
    var e3 = Array.isArray(l3) ? of(l3) : cu({}, l3);
    return r3 && Object.keys(r3).forEach(function(u) {
      var h = e3[u], v4 = r3[u], m3 = glt(h) && glt(v4);
      e3[u] = m3 ? agt(h, v4 || {}) : v4;
    }), e3;
  }
  function Nfe(l3) {
    for (var r3 = arguments.length, e3 = new Array(r3 > 1 ? r3 - 1 : 0), u = 1; u < r3; u++)
      e3[u - 1] = arguments[u];
    return e3.reduce(function(h, v4) {
      return agt(h, v4);
    }, l3);
  }
  function ogt(l3, r3) {
    return !l3 || !r3 || l3.length !== r3.length ? false : l3.every(function(e3, u) {
      return r3[u] === e3;
    });
  }
  function XDn(l3, r3) {
    if (l3 === r3)
      return true;
    if (!l3 && r3 || l3 && !r3 || !l3 || !r3 || g1(l3) !== "object" || g1(r3) !== "object")
      return false;
    var e3 = Object.keys(l3), u = Object.keys(r3), h = new Set([].concat(of(e3), of(u)));
    return of(h).every(function(v4) {
      var m3 = l3[v4], x3 = r3[v4];
      return typeof m3 == "function" && typeof x3 == "function" ? true : m3 === x3;
    });
  }
  function YDn(l3) {
    var r3 = arguments.length <= 1 ? void 0 : arguments[1];
    return r3 && r3.target && g1(r3.target) === "object" && l3 in r3.target ? r3.target[l3] : r3;
  }
  function ylt(l3, r3, e3) {
    var u = l3.length;
    if (r3 < 0 || r3 >= u || e3 < 0 || e3 >= u)
      return l3;
    var h = l3[r3], v4 = r3 - e3;
    return v4 > 0 ? [].concat(of(l3.slice(0, e3)), [h], of(l3.slice(e3, r3)), of(l3.slice(r3 + 1, u))) : v4 < 0 ? [].concat(of(l3.slice(0, r3)), of(l3.slice(r3 + 1, e3 + 1)), [h], of(l3.slice(e3 + 1, u))) : l3;
  }
  var KDn = QJ;
  function ZDn(l3, r3) {
    return l3.replace(/\$\{\w+\}/g, function(e3) {
      var u = e3.slice(2, -1);
      return r3[u];
    });
  }
  function v3e(l3, r3, e3, u, h) {
    return g3e.apply(this, arguments);
  }
  function g3e() {
    return g3e = Rpe(aP.mark(function l3(r3, e3, u, h, v4) {
      var m3, x3, C, A2, D, P, N, j;
      return aP.wrap(function(K) {
        for (; ; )
          switch (K.prev = K.next) {
            case 0:
              return m3 = cu({}, u), delete m3.ruleIndex, x3 = null, m3 && m3.type === "array" && m3.defaultField && (x3 = m3.defaultField, delete m3.defaultField), C = new KDn(fh({}, r3, [m3])), A2 = Nfe({}, ngt, h.validateMessages), C.messages(A2), D = [], K.prev = 8, K.next = 11, Promise.resolve(C.validate(fh({}, r3, e3), cu({}, h)));
            case 11:
              K.next = 16;
              break;
            case 13:
              K.prev = 13, K.t0 = K.catch(8), K.t0.errors ? D = K.t0.errors.map(function(te, ne) {
                var ce = te.message;
                return ma.isValidElement(ce) ? ma.cloneElement(ce, { key: "error_".concat(ne) }) : ce;
              }) : (console.error(K.t0), D = [A2.default]);
            case 16:
              if (!(!D.length && x3)) {
                K.next = 21;
                break;
              }
              return K.next = 19, Promise.all(e3.map(function(te, ne) {
                return v3e("".concat(r3, ".").concat(ne), te, x3, h, v4);
              }));
            case 19:
              return P = K.sent, K.abrupt("return", P.reduce(function(te, ne) {
                return [].concat(of(te), of(ne));
              }, []));
            case 21:
              return N = cu(cu({}, u), {}, { name: r3, enum: (u.enum || []).join(", ") }, v4), j = D.map(function(te) {
                return typeof te == "string" ? ZDn(te, N) : te;
              }), K.abrupt("return", j);
            case 24:
            case "end":
              return K.stop();
          }
      }, l3, null, [[8, 13]]);
    })), g3e.apply(this, arguments);
  }
  function JDn(l3, r3, e3, u, h, v4) {
    var m3 = l3.join("."), x3 = e3.map(function(D, P) {
      var N = D.validator, j = cu(cu({}, D), {}, { ruleIndex: P });
      return N && (j.validator = function(W, K, te) {
        var ne = false, ce = function() {
          for (var Be = arguments.length, Oe = new Array(Be), We = 0; We < Be; We++)
            Oe[We] = arguments[We];
          Promise.resolve().then(function() {
            HA(!ne, "Your validator function has already return a promise. `callback` will be ignored."), ne || te.apply(void 0, Oe);
          });
        }, me = N(W, K, ce);
        ne = me && typeof me.then == "function" && typeof me.catch == "function", HA(ne, "`callback` is deprecated. Please return a promise instead."), ne && me.then(function() {
          te();
        }).catch(function(ve) {
          te(ve || " ");
        });
      }), j;
    }).sort(function(D, P) {
      var N = D.warningOnly, j = D.ruleIndex, W = P.warningOnly, K = P.ruleIndex;
      return !!N == !!W ? j - K : N ? 1 : -1;
    }), C;
    if (h === true)
      C = new Promise(function() {
        var D = Rpe(aP.mark(function P(N, j) {
          var W, K, te;
          return aP.wrap(function(ce) {
            for (; ; )
              switch (ce.prev = ce.next) {
                case 0:
                  W = 0;
                case 1:
                  if (!(W < x3.length)) {
                    ce.next = 12;
                    break;
                  }
                  return K = x3[W], ce.next = 5, v3e(m3, r3, K, u, v4);
                case 5:
                  if (te = ce.sent, !te.length) {
                    ce.next = 9;
                    break;
                  }
                  return j([{ errors: te, rule: K }]), ce.abrupt("return");
                case 9:
                  W += 1, ce.next = 1;
                  break;
                case 12:
                  N([]);
                case 13:
                case "end":
                  return ce.stop();
              }
          }, P);
        }));
        return function(P, N) {
          return D.apply(this, arguments);
        };
      }());
    else {
      var A2 = x3.map(function(D) {
        return v3e(m3, r3, D, u, v4).then(function(P) {
          return { errors: P, rule: D };
        });
      });
      C = (h ? e5n(A2) : QDn(A2)).then(function(D) {
        return Promise.reject(D);
      });
    }
    return C.catch(function(D) {
      return D;
    }), C;
  }
  function QDn(l3) {
    return y3e.apply(this, arguments);
  }
  function y3e() {
    return y3e = Rpe(aP.mark(function l3(r3) {
      return aP.wrap(function(u) {
        for (; ; )
          switch (u.prev = u.next) {
            case 0:
              return u.abrupt("return", Promise.all(r3).then(function(h) {
                var v4, m3 = (v4 = []).concat.apply(v4, of(h));
                return m3;
              }));
            case 1:
            case "end":
              return u.stop();
          }
      }, l3);
    })), y3e.apply(this, arguments);
  }
  function e5n(l3) {
    return m3e.apply(this, arguments);
  }
  function m3e() {
    return m3e = Rpe(aP.mark(function l3(r3) {
      var e3;
      return aP.wrap(function(h) {
        for (; ; )
          switch (h.prev = h.next) {
            case 0:
              return e3 = 0, h.abrupt("return", new Promise(function(v4) {
                r3.forEach(function(m3) {
                  m3.then(function(x3) {
                    x3.errors.length && v4([x3]), e3 += 1, e3 === r3.length && v4([]);
                  });
                });
              }));
            case 2:
            case "end":
              return h.stop();
          }
      }, l3);
    })), m3e.apply(this, arguments);
  }
  var t5n = ["name"], a2 = [];
  function mlt(l3, r3, e3, u, h, v4) {
    return typeof l3 == "function" ? l3(r3, e3, "source" in v4 ? { source: v4.source } : {}) : u !== h;
  }
  var FPe = function(l3) {
    DPe(e3, l3);
    var r3 = OPe(e3);
    function e3(u) {
      var h;
      if (ZJ(this, e3), h = r3.call(this, u), h.state = { resetCount: 0 }, h.cancelRegisterFunc = null, h.mounted = false, h.touched = false, h.dirty = false, h.validatePromise = null, h.prevValidating = void 0, h.errors = a2, h.warnings = a2, h.cancelRegister = function() {
        var C = h.props, A2 = C.preserve, D = C.isListField, P = C.name;
        h.cancelRegisterFunc && h.cancelRegisterFunc(D, A2, fg(P)), h.cancelRegisterFunc = null;
      }, h.getNamePath = function() {
        var C = h.props, A2 = C.name, D = C.fieldContext, P = D.prefixName, N = P === void 0 ? [] : P;
        return A2 !== void 0 ? [].concat(of(N), of(A2)) : [];
      }, h.getRules = function() {
        var C = h.props, A2 = C.rules, D = A2 === void 0 ? [] : A2, P = C.fieldContext;
        return D.map(function(N) {
          return typeof N == "function" ? N(P) : N;
        });
      }, h.refresh = function() {
        !h.mounted || h.setState(function(C) {
          var A2 = C.resetCount;
          return { resetCount: A2 + 1 };
        });
      }, h.triggerMetaEvent = function(C) {
        var A2 = h.props.onMetaChange;
        A2 == null || A2(cu(cu({}, h.getMeta()), {}, { destroy: C }));
      }, h.onStoreChange = function(C, A2, D) {
        var P = h.props, N = P.shouldUpdate, j = P.dependencies, W = j === void 0 ? [] : j, K = P.onReset, te = D.store, ne = h.getNamePath(), ce = h.getValue(C), me = h.getValue(te), ve = A2 && KZ(A2, ne);
        switch (D.type === "valueUpdate" && D.source === "external" && ce !== me && (h.touched = true, h.dirty = true, h.validatePromise = null, h.errors = a2, h.warnings = a2, h.triggerMetaEvent()), D.type) {
          case "reset":
            if (!A2 || ve) {
              h.touched = false, h.dirty = false, h.validatePromise = null, h.errors = a2, h.warnings = a2, h.triggerMetaEvent(), K == null || K(), h.refresh();
              return;
            }
            break;
          case "remove": {
            if (N) {
              h.reRender();
              return;
            }
            break;
          }
          case "setField": {
            if (ve) {
              var Be = D.data;
              "touched" in Be && (h.touched = Be.touched), "validating" in Be && !("originRCField" in Be) && (h.validatePromise = Be.validating ? Promise.resolve([]) : null), "errors" in Be && (h.errors = Be.errors || a2), "warnings" in Be && (h.warnings = Be.warnings || a2), h.dirty = true, h.triggerMetaEvent(), h.reRender();
              return;
            }
            if (N && !ne.length && mlt(N, C, te, ce, me, D)) {
              h.reRender();
              return;
            }
            break;
          }
          case "dependenciesUpdate": {
            var Oe = W.map(fg);
            if (Oe.some(function(We) {
              return KZ(D.relatedFields, We);
            })) {
              h.reRender();
              return;
            }
            break;
          }
          default:
            if (ve || (!W.length || ne.length || N) && mlt(N, C, te, ce, me, D)) {
              h.reRender();
              return;
            }
            break;
        }
        N === true && h.reRender();
      }, h.validateRules = function(C) {
        var A2 = h.getNamePath(), D = h.getValue(), P = Promise.resolve().then(function() {
          if (!h.mounted)
            return [];
          var N = h.props, j = N.validateFirst, W = j === void 0 ? false : j, K = N.messageVariables, te = C || {}, ne = te.triggerName, ce = h.getRules();
          ne && (ce = ce.filter(function(ve) {
            var Be = ve.validateTrigger;
            if (!Be)
              return true;
            var Oe = u3e(Be);
            return Oe.includes(ne);
          }));
          var me = JDn(A2, D, ce, C, W, K);
          return me.catch(function(ve) {
            return ve;
          }).then(function() {
            var ve = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : a2;
            if (h.validatePromise === P) {
              h.validatePromise = null;
              var Be = [], Oe = [];
              ve.forEach(function(We) {
                var Ue = We.rule.warningOnly, qe = We.errors, Ze = qe === void 0 ? a2 : qe;
                Ue ? Oe.push.apply(Oe, of(Ze)) : Be.push.apply(Be, of(Ze));
              }), h.errors = Be, h.warnings = Oe, h.triggerMetaEvent(), h.reRender();
            }
          }), me;
        });
        return h.validatePromise = P, h.dirty = true, h.errors = a2, h.warnings = a2, h.triggerMetaEvent(), h.reRender(), P;
      }, h.isFieldValidating = function() {
        return !!h.validatePromise;
      }, h.isFieldTouched = function() {
        return h.touched;
      }, h.isFieldDirty = function() {
        if (h.dirty || h.props.initialValue !== void 0)
          return true;
        var C = h.props.fieldContext, A2 = C.getInternalHooks(tj), D = A2.getInitialValue;
        return D(h.getNamePath()) !== void 0;
      }, h.getErrors = function() {
        return h.errors;
      }, h.getWarnings = function() {
        return h.warnings;
      }, h.isListField = function() {
        return h.props.isListField;
      }, h.isList = function() {
        return h.props.isList;
      }, h.isPreserve = function() {
        return h.props.preserve;
      }, h.getMeta = function() {
        h.prevValidating = h.isFieldValidating();
        var C = { touched: h.isFieldTouched(), validating: h.prevValidating, errors: h.errors, warnings: h.warnings, name: h.getNamePath() };
        return C;
      }, h.getOnlyChild = function(C) {
        if (typeof C == "function") {
          var A2 = h.getMeta();
          return cu(cu({}, h.getOnlyChild(C(h.getControlled(), A2, h.props.fieldContext))), {}, { isFunction: true });
        }
        var D = l3e(C);
        return D.length !== 1 || !ma.isValidElement(D[0]) ? { child: D, isFunction: false } : { child: D[0], isFunction: false };
      }, h.getValue = function(C) {
        var A2 = h.props.fieldContext.getFieldsValue, D = h.getNamePath();
        return nj(C || A2(true), D);
      }, h.getControlled = function() {
        var C = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, A2 = h.props, D = A2.trigger, P = A2.validateTrigger, N = A2.getValueFromEvent, j = A2.normalize, W = A2.valuePropName, K = A2.getValueProps, te = A2.fieldContext, ne = P !== void 0 ? P : te.validateTrigger, ce = h.getNamePath(), me = te.getInternalHooks, ve = te.getFieldsValue, Be = me(tj), Oe = Be.dispatch, We = h.getValue(), Ue = K || function(_t) {
          return fh({}, W, _t);
        }, qe = C[D], Ze = cu(cu({}, C), Ue(We));
        Ze[D] = function() {
          h.touched = true, h.dirty = true, h.triggerMetaEvent();
          for (var _t, pt = arguments.length, zt = new Array(pt), Zt = 0; Zt < pt; Zt++)
            zt[Zt] = arguments[Zt];
          N ? _t = N.apply(void 0, zt) : _t = YDn.apply(void 0, [W].concat(zt)), j && (_t = j(_t, We, ve(true))), Oe({ type: "updateValue", namePath: ce, value: _t }), qe && qe.apply(void 0, zt);
        };
        var ct = u3e(ne || []);
        return ct.forEach(function(_t) {
          var pt = Ze[_t];
          Ze[_t] = function() {
            pt && pt.apply(void 0, arguments);
            var zt = h.props.rules;
            zt && zt.length && Oe({ type: "validateField", namePath: ce, triggerName: _t });
          };
        }), Ze;
      }, u.fieldContext) {
        var v4 = u.fieldContext.getInternalHooks, m3 = v4(tj), x3 = m3.initEntityValue;
        x3(kPe(h));
      }
      return h;
    }
    return JJ(e3, [{ key: "componentDidMount", value: function() {
      var h = this.props, v4 = h.shouldUpdate, m3 = h.fieldContext;
      if (this.mounted = true, m3) {
        var x3 = m3.getInternalHooks, C = x3(tj), A2 = C.registerField;
        this.cancelRegisterFunc = A2(this);
      }
      v4 === true && this.reRender();
    } }, { key: "componentWillUnmount", value: function() {
      this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
    } }, { key: "reRender", value: function() {
      !this.mounted || this.forceUpdate();
    } }, { key: "render", value: function() {
      var h = this.state.resetCount, v4 = this.props.children, m3 = this.getOnlyChild(v4), x3 = m3.child, C = m3.isFunction, A2;
      return C ? A2 = x3 : ma.isValidElement(x3) ? A2 = ma.cloneElement(x3, this.getControlled(x3.props)) : (HA(!x3, "`children` of Field is not validate ReactElement."), A2 = x3), ma.createElement(ma.Fragment, { key: h }, A2);
    } }]), e3;
  }(ma.Component);
  FPe.contextType = TJ;
  FPe.defaultProps = { trigger: "onChange", valuePropName: "value" };
  function sgt(l3) {
    var r3 = l3.name, e3 = Rj(l3, t5n), u = ma.useContext(TJ), h = r3 !== void 0 ? fg(r3) : void 0, v4 = "keep";
    return e3.isListField || (v4 = "_".concat((h || []).join("_"))), ma.createElement(FPe, hg({ key: v4, name: h }, e3, { fieldContext: u }));
  }
  var n5n = ma.createContext(null), r5n = function(r3) {
    var e3 = r3.name, u = r3.initialValue, h = r3.children, v4 = r3.rules, m3 = r3.validateTrigger, x3 = ma.useContext(TJ), C = ma.useRef({ keys: [], id: 0 }), A2 = C.current, D = ma.useMemo(function() {
      var W = fg(x3.prefixName) || [];
      return [].concat(of(W), of(fg(e3)));
    }, [x3.prefixName, e3]), P = ma.useMemo(function() {
      return cu(cu({}, x3), {}, { prefixName: D });
    }, [x3, D]), N = ma.useMemo(function() {
      return { getKey: function(K) {
        var te = D.length, ne = K[te];
        return [A2.keys[ne], K.slice(te + 1)];
      } };
    }, [D]);
    if (typeof h != "function")
      return HA(false, "Form.List only accepts function as children."), null;
    var j = function(K, te, ne) {
      var ce = ne.source;
      return ce === "internal" ? false : K !== te;
    };
    return ma.createElement(n5n.Provider, { value: N }, ma.createElement(TJ.Provider, { value: P }, ma.createElement(sgt, { name: [], shouldUpdate: j, rules: v4, validateTrigger: m3, initialValue: u, isList: true }, function(W, K) {
      var te = W.value, ne = te === void 0 ? [] : te, ce = W.onChange, me = x3.getFieldValue, ve = function() {
        var Ue = me(D || []);
        return Ue || [];
      }, Be = { add: function(Ue, qe) {
        var Ze = ve();
        qe >= 0 && qe <= Ze.length ? (A2.keys = [].concat(of(A2.keys.slice(0, qe)), [A2.id], of(A2.keys.slice(qe))), ce([].concat(of(Ze.slice(0, qe)), [Ue], of(Ze.slice(qe))))) : (A2.keys = [].concat(of(A2.keys), [A2.id]), ce([].concat(of(Ze), [Ue]))), A2.id += 1;
      }, remove: function(Ue) {
        var qe = ve(), Ze = new Set(Array.isArray(Ue) ? Ue : [Ue]);
        Ze.size <= 0 || (A2.keys = A2.keys.filter(function(ct, _t) {
          return !Ze.has(_t);
        }), ce(qe.filter(function(ct, _t) {
          return !Ze.has(_t);
        })));
      }, move: function(Ue, qe) {
        if (Ue !== qe) {
          var Ze = ve();
          Ue < 0 || Ue >= Ze.length || qe < 0 || qe >= Ze.length || (A2.keys = ylt(A2.keys, Ue, qe), ce(ylt(Ze, Ue, qe)));
        }
      } }, Oe = ne || [];
      return Array.isArray(Oe) || (Oe = []), h(Oe.map(function(We, Ue) {
        var qe = A2.keys[Ue];
        return qe === void 0 && (A2.keys[Ue] = A2.id, qe = A2.keys[Ue], A2.id += 1), { name: Ue, key: qe, isListField: true };
      }), Be, K);
    })));
  };
  function i5n(l3) {
    var r3 = false, e3 = l3.length, u = [];
    return l3.length ? new Promise(function(h, v4) {
      l3.forEach(function(m3, x3) {
        m3.catch(function(C) {
          return r3 = true, C;
        }).then(function(C) {
          e3 -= 1, u[x3] = C, !(e3 > 0) && (r3 && v4(u), h(u));
        });
      });
    }) : Promise.resolve([]);
  }
  var lgt = "__@field_split__";
  function d5e(l3) {
    return l3.map(function(r3) {
      return "".concat(g1(r3), ":").concat(r3);
    }).join(lgt);
  }
  var yZ = function() {
    function l3() {
      ZJ(this, l3), this.kvs = /* @__PURE__ */ new Map();
    }
    return JJ(l3, [{ key: "set", value: function(e3, u) {
      this.kvs.set(d5e(e3), u);
    } }, { key: "get", value: function(e3) {
      return this.kvs.get(d5e(e3));
    } }, { key: "update", value: function(e3, u) {
      var h = this.get(e3), v4 = u(h);
      v4 ? this.set(e3, v4) : this.delete(e3);
    } }, { key: "delete", value: function(e3) {
      this.kvs.delete(d5e(e3));
    } }, { key: "map", value: function(e3) {
      return of(this.kvs.entries()).map(function(u) {
        var h = m2(u, 2), v4 = h[0], m3 = h[1], x3 = v4.split(lgt);
        return e3({ key: x3.map(function(C) {
          var A2 = C.match(/^([^:]*):(.*)$/), D = m2(A2, 3), P = D[1], N = D[2];
          return P === "number" ? Number(N) : N;
        }), value: m3 });
      });
    } }, { key: "toJSON", value: function() {
      var e3 = {};
      return this.map(function(u) {
        var h = u.key, v4 = u.value;
        return e3[h.join(".")] = v4, null;
      }), e3;
    } }]), l3;
  }(), a5n = ["name", "errors"], o5n = JJ(function l3(r3) {
    var e3 = this;
    ZJ(this, l3), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
      return { getFieldValue: e3.getFieldValue, getFieldsValue: e3.getFieldsValue, getFieldError: e3.getFieldError, getFieldWarning: e3.getFieldWarning, getFieldsError: e3.getFieldsError, isFieldsTouched: e3.isFieldsTouched, isFieldTouched: e3.isFieldTouched, isFieldValidating: e3.isFieldValidating, isFieldsValidating: e3.isFieldsValidating, resetFields: e3.resetFields, setFields: e3.setFields, setFieldsValue: e3.setFieldsValue, validateFields: e3.validateFields, submit: e3.submit, getInternalHooks: e3.getInternalHooks };
    }, this.getInternalHooks = function(u) {
      return u === tj ? (e3.formHooked = true, { dispatch: e3.dispatch, initEntityValue: e3.initEntityValue, registerField: e3.registerField, useSubscribe: e3.useSubscribe, setInitialValues: e3.setInitialValues, setCallbacks: e3.setCallbacks, setValidateMessages: e3.setValidateMessages, getFields: e3.getFields, setPreserve: e3.setPreserve, getInitialValue: e3.getInitialValue }) : (HA(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
    }, this.useSubscribe = function(u) {
      e3.subscribable = u;
    }, this.setInitialValues = function(u, h) {
      e3.initialValues = u || {}, h && (e3.store = Nfe({}, u, e3.store));
    }, this.getInitialValue = function(u) {
      return nj(e3.initialValues, u);
    }, this.setCallbacks = function(u) {
      e3.callbacks = u;
    }, this.setValidateMessages = function(u) {
      e3.validateMessages = u;
    }, this.setPreserve = function(u) {
      e3.preserve = u;
    }, this.timeoutId = null, this.warningUnhooked = function() {
    }, this.getFieldEntities = function() {
      var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
      return u ? e3.fieldEntities.filter(function(h) {
        return h.getNamePath().length;
      }) : e3.fieldEntities;
    }, this.getFieldsMap = function() {
      var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, h = new yZ();
      return e3.getFieldEntities(u).forEach(function(v4) {
        var m3 = v4.getNamePath();
        h.set(m3, v4);
      }), h;
    }, this.getFieldEntitiesForNamePathList = function(u) {
      if (!u)
        return e3.getFieldEntities(true);
      var h = e3.getFieldsMap(true);
      return u.map(function(v4) {
        var m3 = fg(v4);
        return h.get(m3) || { INVALIDATE_NAME_PATH: fg(v4) };
      });
    }, this.getFieldsValue = function(u, h) {
      if (e3.warningUnhooked(), u === true && !h)
        return e3.store;
      var v4 = e3.getFieldEntitiesForNamePathList(Array.isArray(u) ? u : null), m3 = [];
      return v4.forEach(function(x3) {
        var C, A2 = "INVALIDATE_NAME_PATH" in x3 ? x3.INVALIDATE_NAME_PATH : x3.getNamePath();
        if (!(!u && ((C = x3.isListField) === null || C === void 0 ? void 0 : C.call(x3))))
          if (!h)
            m3.push(A2);
          else {
            var D = "getMeta" in x3 ? x3.getMeta() : null;
            h(D) && m3.push(A2);
          }
      }), vlt(e3.store, m3.map(fg));
    }, this.getFieldValue = function(u) {
      e3.warningUnhooked();
      var h = fg(u);
      return nj(e3.store, h);
    }, this.getFieldsError = function(u) {
      e3.warningUnhooked();
      var h = e3.getFieldEntitiesForNamePathList(u);
      return h.map(function(v4, m3) {
        return v4 && !("INVALIDATE_NAME_PATH" in v4) ? { name: v4.getNamePath(), errors: v4.getErrors(), warnings: v4.getWarnings() } : { name: fg(u[m3]), errors: [], warnings: [] };
      });
    }, this.getFieldError = function(u) {
      e3.warningUnhooked();
      var h = fg(u), v4 = e3.getFieldsError([h])[0];
      return v4.errors;
    }, this.getFieldWarning = function(u) {
      e3.warningUnhooked();
      var h = fg(u), v4 = e3.getFieldsError([h])[0];
      return v4.warnings;
    }, this.isFieldsTouched = function() {
      e3.warningUnhooked();
      for (var u = arguments.length, h = new Array(u), v4 = 0; v4 < u; v4++)
        h[v4] = arguments[v4];
      var m3 = h[0], x3 = h[1], C, A2 = false;
      h.length === 0 ? C = null : h.length === 1 ? Array.isArray(m3) ? (C = m3.map(fg), A2 = false) : (C = null, A2 = m3) : (C = m3.map(fg), A2 = x3);
      var D = e3.getFieldEntities(true), P = function(te) {
        return te.isFieldTouched();
      };
      if (!C)
        return A2 ? D.every(P) : D.some(P);
      var N = new yZ();
      C.forEach(function(K) {
        N.set(K, []);
      }), D.forEach(function(K) {
        var te = K.getNamePath();
        C.forEach(function(ne) {
          ne.every(function(ce, me) {
            return te[me] === ce;
          }) && N.update(ne, function(ce) {
            return [].concat(of(ce), [K]);
          });
        });
      });
      var j = function(te) {
        return te.some(P);
      }, W = N.map(function(K) {
        var te = K.value;
        return te;
      });
      return A2 ? W.every(j) : W.some(j);
    }, this.isFieldTouched = function(u) {
      return e3.warningUnhooked(), e3.isFieldsTouched([u]);
    }, this.isFieldsValidating = function(u) {
      e3.warningUnhooked();
      var h = e3.getFieldEntities();
      if (!u)
        return h.some(function(m3) {
          return m3.isFieldValidating();
        });
      var v4 = u.map(fg);
      return h.some(function(m3) {
        var x3 = m3.getNamePath();
        return KZ(v4, x3) && m3.isFieldValidating();
      });
    }, this.isFieldValidating = function(u) {
      return e3.warningUnhooked(), e3.isFieldsValidating([u]);
    }, this.resetWithFieldInitialValue = function() {
      var u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, h = new yZ(), v4 = e3.getFieldEntities(true);
      v4.forEach(function(C) {
        var A2 = C.props.initialValue, D = C.getNamePath();
        if (A2 !== void 0) {
          var P = h.get(D) || /* @__PURE__ */ new Set();
          P.add({ entity: C, value: A2 }), h.set(D, P);
        }
      });
      var m3 = function(A2) {
        A2.forEach(function(D) {
          var P = D.props.initialValue;
          if (P !== void 0) {
            var N = D.getNamePath(), j = e3.getInitialValue(N);
            if (j !== void 0)
              HA(false, "Form already set 'initialValues' with path '".concat(N.join("."), "'. Field can not overwrite it."));
            else {
              var W = h.get(N);
              if (W && W.size > 1)
                HA(false, "Multiple Field with path '".concat(N.join("."), "' set 'initialValue'. Can not decide which one to pick."));
              else if (W) {
                var K = e3.getFieldValue(N);
                (!u.skipExist || K === void 0) && (e3.store = SN(e3.store, N, of(W)[0].value));
              }
            }
          }
        });
      }, x3;
      u.entities ? x3 = u.entities : u.namePathList ? (x3 = [], u.namePathList.forEach(function(C) {
        var A2 = h.get(C);
        if (A2) {
          var D;
          (D = x3).push.apply(D, of(of(A2).map(function(P) {
            return P.entity;
          })));
        }
      })) : x3 = v4, m3(x3);
    }, this.resetFields = function(u) {
      e3.warningUnhooked();
      var h = e3.store;
      if (!u) {
        e3.store = Nfe({}, e3.initialValues), e3.resetWithFieldInitialValue(), e3.notifyObservers(h, null, { type: "reset" });
        return;
      }
      var v4 = u.map(fg);
      v4.forEach(function(m3) {
        var x3 = e3.getInitialValue(m3);
        e3.store = SN(e3.store, m3, x3);
      }), e3.resetWithFieldInitialValue({ namePathList: v4 }), e3.notifyObservers(h, v4, { type: "reset" });
    }, this.setFields = function(u) {
      e3.warningUnhooked();
      var h = e3.store;
      u.forEach(function(v4) {
        var m3 = v4.name;
        v4.errors;
        var x3 = Rj(v4, a5n), C = fg(m3);
        "value" in x3 && (e3.store = SN(e3.store, C, x3.value)), e3.notifyObservers(h, [C], { type: "setField", data: v4 });
      });
    }, this.getFields = function() {
      var u = e3.getFieldEntities(true), h = u.map(function(v4) {
        var m3 = v4.getNamePath(), x3 = v4.getMeta(), C = cu(cu({}, x3), {}, { name: m3, value: e3.getFieldValue(m3) });
        return Object.defineProperty(C, "originRCField", { value: true }), C;
      });
      return h;
    }, this.initEntityValue = function(u) {
      var h = u.props.initialValue;
      if (h !== void 0) {
        var v4 = u.getNamePath(), m3 = nj(e3.store, v4);
        m3 === void 0 && (e3.store = SN(e3.store, v4, h));
      }
    }, this.registerField = function(u) {
      if (e3.fieldEntities.push(u), u.props.initialValue !== void 0) {
        var h = e3.store;
        e3.resetWithFieldInitialValue({ entities: [u], skipExist: true }), e3.notifyObservers(h, [u.getNamePath()], { type: "valueUpdate", source: "internal" });
      }
      return function(v4, m3) {
        var x3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
        e3.fieldEntities = e3.fieldEntities.filter(function(N) {
          return N !== u;
        });
        var C = m3 !== void 0 ? m3 : e3.preserve;
        if (C === false && (!v4 || x3.length > 1)) {
          var A2 = u.getNamePath(), D = v4 ? void 0 : nj(e3.initialValues, A2);
          if (A2.length && e3.getFieldValue(A2) !== D && e3.fieldEntities.every(function(N) {
            return !ogt(N.getNamePath(), A2);
          })) {
            var P = e3.store;
            e3.store = SN(P, A2, D, true), e3.notifyObservers(P, [A2], { type: "remove" }), e3.triggerDependenciesUpdate(P, A2);
          }
        }
      };
    }, this.dispatch = function(u) {
      switch (u.type) {
        case "updateValue": {
          var h = u.namePath, v4 = u.value;
          e3.updateValue(h, v4);
          break;
        }
        case "validateField": {
          var m3 = u.namePath, x3 = u.triggerName;
          e3.validateFields([m3], { triggerName: x3 });
          break;
        }
      }
    }, this.notifyObservers = function(u, h, v4) {
      if (e3.subscribable) {
        var m3 = cu(cu({}, v4), {}, { store: e3.getFieldsValue(true) });
        e3.getFieldEntities().forEach(function(x3) {
          var C = x3.onStoreChange;
          C(u, h, m3);
        });
      } else
        e3.forceRootUpdate();
    }, this.triggerDependenciesUpdate = function(u, h) {
      var v4 = e3.getDependencyChildrenFields(h);
      return v4.length && e3.validateFields(v4), e3.notifyObservers(u, v4, { type: "dependenciesUpdate", relatedFields: [h].concat(of(v4)) }), v4;
    }, this.updateValue = function(u, h) {
      var v4 = fg(u), m3 = e3.store;
      e3.store = SN(e3.store, v4, h), e3.notifyObservers(m3, [v4], { type: "valueUpdate", source: "internal" });
      var x3 = e3.triggerDependenciesUpdate(m3, v4), C = e3.callbacks.onValuesChange;
      if (C) {
        var A2 = vlt(e3.store, [v4]);
        C(A2, e3.getFieldsValue());
      }
      e3.triggerOnFieldsChange([v4].concat(of(x3)));
    }, this.setFieldsValue = function(u) {
      e3.warningUnhooked();
      var h = e3.store;
      u && (e3.store = Nfe(e3.store, u)), e3.notifyObservers(h, null, { type: "valueUpdate", source: "external" });
    }, this.getDependencyChildrenFields = function(u) {
      var h = /* @__PURE__ */ new Set(), v4 = [], m3 = new yZ();
      e3.getFieldEntities().forEach(function(C) {
        var A2 = C.props.dependencies;
        (A2 || []).forEach(function(D) {
          var P = fg(D);
          m3.update(P, function() {
            var N = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
            return N.add(C), N;
          });
        });
      });
      var x3 = function C(A2) {
        var D = m3.get(A2) || /* @__PURE__ */ new Set();
        D.forEach(function(P) {
          if (!h.has(P)) {
            h.add(P);
            var N = P.getNamePath();
            P.isFieldDirty() && N.length && (v4.push(N), C(N));
          }
        });
      };
      return x3(u), v4;
    }, this.triggerOnFieldsChange = function(u, h) {
      var v4 = e3.callbacks.onFieldsChange;
      if (v4) {
        var m3 = e3.getFields();
        if (h) {
          var x3 = new yZ();
          h.forEach(function(A2) {
            var D = A2.name, P = A2.errors;
            x3.set(D, P);
          }), m3.forEach(function(A2) {
            A2.errors = x3.get(A2.name) || A2.errors;
          });
        }
        var C = m3.filter(function(A2) {
          var D = A2.name;
          return KZ(u, D);
        });
        v4(C, m3);
      }
    }, this.validateFields = function(u, h) {
      e3.warningUnhooked();
      var v4 = !!u, m3 = v4 ? u.map(fg) : [], x3 = [];
      e3.getFieldEntities(true).forEach(function(D) {
        if (v4 || m3.push(D.getNamePath()), (h == null ? void 0 : h.recursive) && v4) {
          var P = D.getNamePath();
          P.every(function(W, K) {
            return u[K] === W || u[K] === void 0;
          }) && m3.push(P);
        }
        if (!(!D.props.rules || !D.props.rules.length)) {
          var N = D.getNamePath();
          if (!v4 || KZ(m3, N)) {
            var j = D.validateRules(cu({ validateMessages: cu(cu({}, ngt), e3.validateMessages) }, h));
            x3.push(j.then(function() {
              return { name: N, errors: [], warnings: [] };
            }).catch(function(W) {
              var K = [], te = [];
              return W.forEach(function(ne) {
                var ce = ne.rule.warningOnly, me = ne.errors;
                ce ? te.push.apply(te, of(me)) : K.push.apply(K, of(me));
              }), K.length ? Promise.reject({ name: N, errors: K, warnings: te }) : { name: N, errors: K, warnings: te };
            }));
          }
        }
      });
      var C = i5n(x3);
      e3.lastValidatePromise = C, C.catch(function(D) {
        return D;
      }).then(function(D) {
        var P = D.map(function(N) {
          var j = N.name;
          return j;
        });
        e3.notifyObservers(e3.store, P, { type: "validateFinish" }), e3.triggerOnFieldsChange(P, D);
      });
      var A2 = C.then(function() {
        return e3.lastValidatePromise === C ? Promise.resolve(e3.getFieldsValue(m3)) : Promise.reject([]);
      }).catch(function(D) {
        var P = D.filter(function(N) {
          return N && N.errors.length;
        });
        return Promise.reject({ values: e3.getFieldsValue(m3), errorFields: P, outOfDate: e3.lastValidatePromise !== C });
      });
      return A2.catch(function(D) {
        return D;
      }), A2;
    }, this.submit = function() {
      e3.warningUnhooked(), e3.validateFields().then(function(u) {
        var h = e3.callbacks.onFinish;
        if (h)
          try {
            h(u);
          } catch (v4) {
            console.error(v4);
          }
      }).catch(function(u) {
        var h = e3.callbacks.onFinishFailed;
        h && h(u);
      });
    }, this.forceRootUpdate = r3;
  });
  function ugt(l3) {
    var r3 = ma.useRef(), e3 = ma.useState({}), u = m2(e3, 2), h = u[1];
    if (!r3.current)
      if (l3)
        r3.current = l3;
      else {
        var v4 = function() {
          h({});
        }, m3 = new o5n(v4);
        r3.current = m3.getForm();
      }
    return [r3.current];
  }
  var b3e = ma.createContext({ triggerFormChange: function() {
  }, triggerFormFinish: function() {
  }, registerForm: function() {
  }, unregisterForm: function() {
  } }), s5n = function(r3) {
    var e3 = r3.validateMessages, u = r3.onFormChange, h = r3.onFormFinish, v4 = r3.children, m3 = ma.useContext(b3e), x3 = ma.useRef({});
    return ma.createElement(b3e.Provider, { value: cu(cu({}, m3), {}, { validateMessages: cu(cu({}, m3.validateMessages), e3), triggerFormChange: function(A2, D) {
      u && u(A2, { changedFields: D, forms: x3.current }), m3.triggerFormChange(A2, D);
    }, triggerFormFinish: function(A2, D) {
      h && h(A2, { values: D, forms: x3.current }), m3.triggerFormFinish(A2, D);
    }, registerForm: function(A2, D) {
      A2 && (x3.current = cu(cu({}, x3.current), {}, fh({}, A2, D))), m3.registerForm(A2, D);
    }, unregisterForm: function(A2) {
      var D = cu({}, x3.current);
      delete D[A2], x3.current = D, m3.unregisterForm(A2);
    } }) }, v4);
  }, l5n = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], u5n = function(r3, e3) {
    var u = r3.name, h = r3.initialValues, v4 = r3.fields, m3 = r3.form, x3 = r3.preserve, C = r3.children, A2 = r3.component, D = A2 === void 0 ? "form" : A2, P = r3.validateMessages, N = r3.validateTrigger, j = N === void 0 ? "onChange" : N, W = r3.onValuesChange, K = r3.onFieldsChange, te = r3.onFinish, ne = r3.onFinishFailed, ce = Rj(r3, l5n), me = ma.useContext(b3e), ve = ugt(m3), Be = m2(ve, 1), Oe = Be[0], We = Oe.getInternalHooks(tj), Ue = We.useSubscribe, qe = We.setInitialValues, Ze = We.setCallbacks, ct = We.setValidateMessages, _t = We.setPreserve;
    ma.useImperativeHandle(e3, function() {
      return Oe;
    }), ma.useEffect(function() {
      return me.registerForm(u, Oe), function() {
        me.unregisterForm(u);
      };
    }, [me, Oe, u]), ct(cu(cu({}, me.validateMessages), P)), Ze({ onValuesChange: W, onFieldsChange: function(or) {
      if (me.triggerFormChange(u, or), K) {
        for (var vr = arguments.length, la = new Array(vr > 1 ? vr - 1 : 0), Ba = 1; Ba < vr; Ba++)
          la[Ba - 1] = arguments[Ba];
        K.apply(void 0, [or].concat(la));
      }
    }, onFinish: function(or) {
      me.triggerFormFinish(u, or), te && te(or);
    }, onFinishFailed: ne }), _t(x3);
    var pt = ma.useRef(null);
    qe(h, !pt.current), pt.current || (pt.current = true);
    var zt = C, Zt = typeof C == "function";
    if (Zt) {
      var Ft = Oe.getFieldsValue(true);
      zt = C(Ft, Oe);
    }
    Ue(!Zt);
    var Kn = ma.useRef();
    ma.useEffect(function() {
      XDn(Kn.current || [], v4 || []) || Oe.setFields(v4 || []), Kn.current = v4;
    }, [v4, Oe]);
    var hn = ma.useMemo(function() {
      return cu(cu({}, Oe), {}, { validateTrigger: j });
    }, [Oe, j]), xn = ma.createElement(TJ.Provider, { value: hn }, zt);
    return D === false ? xn : ma.createElement(D, hg({}, ce, { onSubmit: function(or) {
      or.preventDefault(), or.stopPropagation(), Oe.submit();
    }, onReset: function(or) {
      var vr;
      or.preventDefault(), Oe.resetFields(), (vr = ce.onReset) === null || vr === void 0 || vr.call(ce, or);
    } }), xn);
  }, c5n = ma.forwardRef(u5n), Npe = c5n;
  Npe.FormProvider = s5n;
  Npe.Field = sgt;
  Npe.List = r5n;
  Npe.useForm = ugt;
  var f5n = function(l3, r3, e3) {
    HA(l3, "[antd: ".concat(r3, "] ").concat(e3));
  }, h5n = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, p5n = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, d5n = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, cgt = d5n, v5n = { lang: hg({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, p5n), timePickerLocale: hg({}, cgt) }, blt = v5n, $x = "${label} is not a valid ${type}", g5n = { locale: "en", Pagination: h5n, DatePicker: blt, TimePicker: cgt, Calendar: blt, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: $x, method: $x, array: $x, object: $x, number: $x, date: $x, boolean: $x, integer: $x, float: $x, regexp: $x, email: $x, url: $x, hex: $x }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, _lt = g5n, y5n = Nc.createContext(void 0), m5n = y5n, VPe = function(l3) {
    DPe(e3, l3);
    var r3 = OPe(e3);
    function e3() {
      return ZJ(this, e3), r3.apply(this, arguments);
    }
    return JJ(e3, [{ key: "getLocale", value: function() {
      var h = this.props, v4 = h.componentName, m3 = h.defaultLocale, x3 = m3 || _lt[v4 != null ? v4 : "global"], C = this.context, A2 = v4 && C ? C[v4] : {};
      return hg(hg({}, x3 instanceof Function ? x3() : x3), A2 || {});
    } }, { key: "getLocaleCode", value: function() {
      var h = this.context, v4 = h && h.locale;
      return h && h.exist && !v4 ? _lt.locale : v4;
    } }, { key: "render", value: function() {
      return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
    } }]), e3;
  }(ma.Component);
  VPe.defaultProps = { componentName: "global" };
  VPe.contextType = m5n;
  var b5n = function() {
    var r3 = ma.useContext(lP), e3 = r3.getPrefixCls, u = e3("empty-img-default");
    return ma.createElement("svg", { className: u, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, ma.createElement("g", { fill: "none", fillRule: "evenodd" }, ma.createElement("g", { transform: "translate(24 31.67)" }, ma.createElement("ellipse", { className: "".concat(u, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), ma.createElement("path", { className: "".concat(u, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), ma.createElement("path", { className: "".concat(u, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), ma.createElement("path", { className: "".concat(u, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), ma.createElement("path", { className: "".concat(u, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), ma.createElement("path", { className: "".concat(u, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), ma.createElement("g", { className: "".concat(u, "-g"), transform: "translate(149.65 15.383)" }, ma.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), ma.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
  }, _5n = b5n, x5n = function() {
    var r3 = ma.useContext(lP), e3 = r3.getPrefixCls, u = e3("empty-img-simple");
    return ma.createElement("svg", { className: u, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, ma.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, ma.createElement("ellipse", { className: "".concat(u, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), ma.createElement("g", { className: "".concat(u, "-g"), fillRule: "nonzero" }, ma.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), ma.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(u, "-path") }))));
  }, w5n = x5n, S5n = globalThis && globalThis.__rest || function(l3, r3) {
    var e3 = {};
    for (var u in l3)
      Object.prototype.hasOwnProperty.call(l3, u) && r3.indexOf(u) < 0 && (e3[u] = l3[u]);
    if (l3 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var h = 0, u = Object.getOwnPropertySymbols(l3); h < u.length; h++)
        r3.indexOf(u[h]) < 0 && Object.prototype.propertyIsEnumerable.call(l3, u[h]) && (e3[u[h]] = l3[u[h]]);
    return e3;
  }, fgt = ma.createElement(_5n, null), hgt = ma.createElement(w5n, null), BPe = function(r3) {
    var e3 = r3.className, u = r3.prefixCls, h = r3.image, v4 = h === void 0 ? fgt : h, m3 = r3.description, x3 = r3.children, C = r3.imageStyle, A2 = S5n(r3, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), D = ma.useContext(lP), P = D.getPrefixCls, N = D.direction;
    return ma.createElement(VPe, { componentName: "Empty" }, function(j) {
      var W, K = P("empty", u), te = typeof m3 != "undefined" ? m3 : j.description, ne = typeof te == "string" ? te : "empty", ce = null;
      return typeof v4 == "string" ? ce = ma.createElement("img", { alt: ne, src: v4 }) : ce = v4, ma.createElement("div", hg({ className: Nj(K, (W = {}, fh(W, "".concat(K, "-normal"), v4 === hgt), fh(W, "".concat(K, "-rtl"), N === "rtl"), W), e3) }, A2), ma.createElement("div", { className: "".concat(K, "-image"), style: C }, ce), te && ma.createElement("div", { className: "".concat(K, "-description") }, te), x3 && ma.createElement("div", { className: "".concat(K, "-footer") }, x3));
    });
  };
  BPe.PRESENTED_IMAGE_DEFAULT = fgt;
  BPe.PRESENTED_IMAGE_SIMPLE = hgt;
  var mZ = BPe, C5n = function(r3) {
    return ma.createElement(pgt, null, function(e3) {
      var u = e3.getPrefixCls, h = u("empty");
      switch (r3) {
        case "Table":
        case "List":
          return ma.createElement(mZ, { image: mZ.PRESENTED_IMAGE_SIMPLE });
        case "Select":
        case "TreeSelect":
        case "Cascader":
        case "Transfer":
        case "Mentions":
          return ma.createElement(mZ, { image: mZ.PRESENTED_IMAGE_SIMPLE, className: "".concat(h, "-small") });
        default:
          return ma.createElement(mZ, null);
      }
    });
  }, M5n = C5n, T5n = function(r3, e3) {
    return e3 || (r3 ? "ant-".concat(r3) : "ant");
  }, lP = ma.createContext({ getPrefixCls: T5n, renderEmpty: M5n }), pgt = lP.Consumer, A5n = ma.createContext(void 0), I5n = A5n, dgt = function(r3) {
    return +setTimeout(r3, 16);
  }, vgt = function(r3) {
    return clearTimeout(r3);
  };
  typeof window != "undefined" && "requestAnimationFrame" in window && (dgt = function(r3) {
    return window.requestAnimationFrame(r3);
  }, vgt = function(r3) {
    return window.cancelAnimationFrame(r3);
  });
  var xlt = 0, zPe = /* @__PURE__ */ new Map();
  function ggt(l3) {
    zPe.delete(l3);
  }
  function Lhe(l3) {
    var r3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
    xlt += 1;
    var e3 = xlt;
    function u(h) {
      if (h === 0)
        ggt(e3), l3();
      else {
        var v4 = dgt(function() {
          u(h - 1);
        });
        zPe.set(e3, v4);
      }
    }
    return u(r3), e3;
  }
  Lhe.cancel = function(l3) {
    var r3 = zPe.get(l3);
    return ggt(r3), vgt(r3);
  };
  function E5n(l3, r3) {
    var e3 = r3 || {}, u = e3.defaultValue, h = e3.value, v4 = e3.onChange, m3 = e3.postState, x3 = ma.useState(function() {
      return h !== void 0 ? h : u !== void 0 ? typeof u == "function" ? u() : u : typeof l3 == "function" ? l3() : l3;
    }), C = m2(x3, 2), A2 = C[0], D = C[1], P = h !== void 0 ? h : A2;
    m3 && (P = m3(P));
    var N = ma.useRef(v4);
    N.current = v4;
    var j = ma.useCallback(function(K) {
      D(K), P !== K && N.current && N.current(K, P);
    }, [P, N]), W = ma.useRef(true);
    return ma.useEffect(function() {
      if (W.current) {
        W.current = false;
        return;
      }
      h === void 0 && D(h);
    }, [h]), [P, j];
  }
  var Sl = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(r3) {
    var e3 = r3.keyCode;
    if (r3.altKey && !r3.ctrlKey || r3.metaKey || e3 >= Sl.F1 && e3 <= Sl.F12)
      return false;
    switch (e3) {
      case Sl.ALT:
      case Sl.CAPS_LOCK:
      case Sl.CONTEXT_MENU:
      case Sl.CTRL:
      case Sl.DOWN:
      case Sl.END:
      case Sl.ESC:
      case Sl.HOME:
      case Sl.INSERT:
      case Sl.LEFT:
      case Sl.MAC_FF_META:
      case Sl.META:
      case Sl.NUMLOCK:
      case Sl.NUM_CENTER:
      case Sl.PAGE_DOWN:
      case Sl.PAGE_UP:
      case Sl.PAUSE:
      case Sl.PRINT_SCREEN:
      case Sl.RIGHT:
      case Sl.SHIFT:
      case Sl.UP:
      case Sl.WIN_KEY:
      case Sl.WIN_KEY_RIGHT:
        return false;
      default:
        return true;
    }
  }, isCharacterKey: function(r3) {
    if (r3 >= Sl.ZERO && r3 <= Sl.NINE || r3 >= Sl.NUM_ZERO && r3 <= Sl.NUM_MULTIPLY || r3 >= Sl.A && r3 <= Sl.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && r3 === 0)
      return true;
    switch (r3) {
      case Sl.SPACE:
      case Sl.QUESTION_MARK:
      case Sl.NUM_PLUS:
      case Sl.NUM_MINUS:
      case Sl.NUM_PERIOD:
      case Sl.NUM_DIVISION:
      case Sl.SEMICOLON:
      case Sl.DASH:
      case Sl.EQUALS:
      case Sl.COMMA:
      case Sl.PERIOD:
      case Sl.SLASH:
      case Sl.APOSTROPHE:
      case Sl.SINGLE_QUOTE:
      case Sl.OPEN_SQUARE_BRACKET:
      case Sl.BACKSLASH:
      case Sl.CLOSE_SQUARE_BRACKET:
        return true;
      default:
        return false;
    }
  } }, ygt = function() {
    for (var r3 = arguments.length, e3 = new Array(r3), u = 0; u < r3; u++)
      e3[u] = arguments[u];
    return e3;
  }, D5n = ma.isValidElement;
  function k5n(l3, r3, e3) {
    return D5n(l3) ? ma.cloneElement(l3, typeof e3 == "function" ? e3(l3.props || {}) : e3) : r3;
  }
  function O5n(l3, r3) {
    return k5n(l3, l3, r3);
  }
  var wlt = ["xxl", "xl", "lg", "md", "sm", "xs"], hfe = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, vN = /* @__PURE__ */ new Map(), v5e = -1, pfe = {}, P5n = { matchHandlers: {}, dispatch: function(r3) {
    return pfe = r3, vN.forEach(function(e3) {
      return e3(pfe);
    }), vN.size >= 1;
  }, subscribe: function(r3) {
    return vN.size || this.register(), v5e += 1, vN.set(v5e, r3), r3(pfe), v5e;
  }, unsubscribe: function(r3) {
    vN.delete(r3), vN.size || this.unregister();
  }, unregister: function() {
    var r3 = this;
    Object.keys(hfe).forEach(function(e3) {
      var u = hfe[e3], h = r3.matchHandlers[u];
      h == null || h.mql.removeListener(h == null ? void 0 : h.listener);
    }), vN.clear();
  }, register: function() {
    var r3 = this;
    Object.keys(hfe).forEach(function(e3) {
      var u = hfe[e3], h = function(x3) {
        var C = x3.matches;
        r3.dispatch(hg(hg({}, pfe), fh({}, e3, C)));
      }, v4 = window.matchMedia(u);
      v4.addListener(h), r3.matchHandlers[u] = { mql: v4, listener: h }, h(v4);
    });
  } }, Slt = P5n, L5n = 0, lj = {};
  function Rhe(l3) {
    var r3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, e3 = L5n++, u = r3;
    function h() {
      u -= 1, u <= 0 ? (l3(), delete lj[e3]) : lj[e3] = Lhe(h);
    }
    return lj[e3] = Lhe(h), e3;
  }
  Rhe.cancel = function(r3) {
    r3 !== void 0 && (Lhe.cancel(lj[r3]), delete lj[r3]);
  };
  Rhe.ids = lj;
  var g5e;
  function Clt(l3) {
    return !l3 || l3.offsetParent === null || l3.hidden;
  }
  function R5n(l3) {
    var r3 = (l3 || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
    return r3 && r3[1] && r3[2] && r3[3] ? !(r3[1] === r3[2] && r3[2] === r3[3]) : true;
  }
  var mgt = function(l3) {
    DPe(e3, l3);
    var r3 = OPe(e3);
    function e3() {
      var u;
      return ZJ(this, e3), u = r3.apply(this, arguments), u.containerRef = ma.createRef(), u.animationStart = false, u.destroyed = false, u.onClick = function(h, v4) {
        var m3, x3, C = u.props, A2 = C.insertExtraNode, D = C.disabled;
        if (!(D || !h || Clt(h) || h.className.indexOf("-leave") >= 0)) {
          u.extraNode = document.createElement("div");
          var P = kPe(u), N = P.extraNode, j = u.context.getPrefixCls;
          N.className = "".concat(j(""), "-click-animating-node");
          var W = u.getAttributeName();
          if (h.setAttribute(W, "true"), v4 && v4 !== "#ffffff" && v4 !== "rgb(255, 255, 255)" && R5n(v4) && !/rgba\((?:\d*, ){3}0\)/.test(v4) && v4 !== "transparent") {
            N.style.borderColor = v4;
            var K = ((m3 = h.getRootNode) === null || m3 === void 0 ? void 0 : m3.call(h)) || h.ownerDocument, te = K instanceof Document ? K.body : (x3 = K.firstChild) !== null && x3 !== void 0 ? x3 : K;
            g5e = $vt(`
      [`.concat(j(""), "-click-animating-without-extra-node='true']::after, .").concat(j(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(v4, `;
      }`), "antd-wave", { csp: u.csp, attachTo: te });
          }
          A2 && h.appendChild(N), ["transition", "animation"].forEach(function(ne) {
            h.addEventListener("".concat(ne, "start"), u.onTransitionStart), h.addEventListener("".concat(ne, "end"), u.onTransitionEnd);
          });
        }
      }, u.onTransitionStart = function(h) {
        if (!u.destroyed) {
          var v4 = u.containerRef.current;
          !h || h.target !== v4 || u.animationStart || u.resetEffect(v4);
        }
      }, u.onTransitionEnd = function(h) {
        !h || h.animationName !== "fadeEffect" || u.resetEffect(h.target);
      }, u.bindAnimationEvent = function(h) {
        if (!(!h || !h.getAttribute || h.getAttribute("disabled") || h.className.indexOf("disabled") >= 0)) {
          var v4 = function(x3) {
            if (!(x3.target.tagName === "INPUT" || Clt(x3.target))) {
              u.resetEffect(h);
              var C = getComputedStyle(h).getPropertyValue("border-top-color") || getComputedStyle(h).getPropertyValue("border-color") || getComputedStyle(h).getPropertyValue("background-color");
              u.clickWaveTimeoutId = window.setTimeout(function() {
                return u.onClick(h, C);
              }, 0), Rhe.cancel(u.animationStartId), u.animationStart = true, u.animationStartId = Rhe(function() {
                u.animationStart = false;
              }, 10);
            }
          };
          return h.addEventListener("click", v4, true), { cancel: function() {
            h.removeEventListener("click", v4, true);
          } };
        }
      }, u.renderWave = function(h) {
        var v4 = h.csp, m3 = u.props.children;
        if (u.csp = v4, !ma.isValidElement(m3))
          return m3;
        var x3 = u.containerRef;
        return lDn(m3) && (x3 = sDn(m3.ref, u.containerRef)), O5n(m3, { ref: x3 });
      }, u;
    }
    return JJ(e3, [{ key: "componentDidMount", value: function() {
      var h = this.containerRef.current;
      !h || h.nodeType !== 1 || (this.instance = this.bindAnimationEvent(h));
    } }, { key: "componentWillUnmount", value: function() {
      this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
    } }, { key: "getAttributeName", value: function() {
      var h = this.context.getPrefixCls, v4 = this.props.insertExtraNode;
      return v4 ? "".concat(h(""), "-click-animating") : "".concat(h(""), "-click-animating-without-extra-node");
    } }, { key: "resetEffect", value: function(h) {
      var v4 = this;
      if (!(!h || h === this.extraNode || !(h instanceof Element))) {
        var m3 = this.props.insertExtraNode, x3 = this.getAttributeName();
        h.setAttribute(x3, "false"), g5e && (g5e.innerHTML = ""), m3 && this.extraNode && h.contains(this.extraNode) && h.removeChild(this.extraNode), ["transition", "animation"].forEach(function(C) {
          h.removeEventListener("".concat(C, "start"), v4.onTransitionStart), h.removeEventListener("".concat(C, "end"), v4.onTransitionEnd);
        });
      }
    } }, { key: "render", value: function() {
      return ma.createElement(pgt, null, this.renderWave);
    } }]), e3;
  }(ma.Component);
  mgt.contextType = lP;
  var jPe = { exports: {} }, eQ = {};
  /** @license React v17.0.2
  * react-jsx-runtime.production.min.js
  *
  * Copyright (c) Facebook, Inc. and its affiliates.
  *
  * This source code is licensed under the MIT license found in the
  * LICENSE file in the root directory of this source tree.
  */
  var N5n = uj.default, bgt = 60103;
  eQ.Fragment = 60107;
  if (typeof Symbol == "function" && Symbol.for) {
    var Mlt = Symbol.for;
    bgt = Mlt("react.element"), eQ.Fragment = Mlt("react.fragment");
  }
  var F5n = N5n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, V5n = Object.prototype.hasOwnProperty, B5n = { key: true, ref: true, __self: true, __source: true };
  function _gt(l3, r3, e3) {
    var u, h = {}, v4 = null, m3 = null;
    e3 !== void 0 && (v4 = "" + e3), r3.key !== void 0 && (v4 = "" + r3.key), r3.ref !== void 0 && (m3 = r3.ref);
    for (u in r3)
      V5n.call(r3, u) && !B5n.hasOwnProperty(u) && (h[u] = r3[u]);
    if (l3 && l3.defaultProps)
      for (u in r3 = l3.defaultProps, r3)
        h[u] === void 0 && (h[u] = r3[u]);
    return { $$typeof: bgt, type: l3, key: v4, ref: m3, props: h, _owner: F5n.current };
  }
  eQ.jsx = _gt;
  eQ.jsxs = _gt;
  jPe.exports = eQ;
  const Xz = jPe.exports.jsx, z5n = jPe.exports.jsxs;
  var j5n = Nc.createContext({}), xgt = j5n, G5n = function() {
    return Uvt() && window.document.documentElement;
  }, dfe, H5n = function() {
    if (!G5n())
      return false;
    if (dfe !== void 0)
      return dfe;
    var r3 = document.createElement("div");
    return r3.style.display = "flex", r3.style.flexDirection = "column", r3.style.rowGap = "1px", r3.appendChild(document.createElement("div")), r3.appendChild(document.createElement("div")), document.body.appendChild(r3), dfe = r3.scrollHeight === 1, document.body.removeChild(r3), dfe;
  }, W5n = function() {
    var l3 = ma.useState(false), r3 = m2(l3, 2), e3 = r3[0], u = r3[1];
    return ma.useEffect(function() {
      u(H5n());
    }, []), e3;
  }, U5n = globalThis && globalThis.__rest || function(l3, r3) {
    var e3 = {};
    for (var u in l3)
      Object.prototype.hasOwnProperty.call(l3, u) && r3.indexOf(u) < 0 && (e3[u] = l3[u]);
    if (l3 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var h = 0, u = Object.getOwnPropertySymbols(l3); h < u.length; h++)
        r3.indexOf(u[h]) < 0 && Object.prototype.propertyIsEnumerable.call(l3, u[h]) && (e3[u[h]] = l3[u[h]]);
    return e3;
  };
  ygt("top", "middle", "bottom", "stretch");
  ygt("start", "end", "center", "space-around", "space-between");
  var wgt = ma.forwardRef(function(l3, r3) {
    var e3, u = l3.prefixCls, h = l3.justify, v4 = l3.align, m3 = l3.className, x3 = l3.style, C = l3.children, A2 = l3.gutter, D = A2 === void 0 ? 0 : A2, P = l3.wrap, N = U5n(l3, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), j = ma.useContext(lP), W = j.getPrefixCls, K = j.direction, te = ma.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), ne = m2(te, 2), ce = ne[0], me = ne[1], ve = W5n(), Be = ma.useRef(D);
    ma.useEffect(function() {
      var hn = Slt.subscribe(function(xn) {
        var zn = Be.current || 0;
        (!Array.isArray(zn) && g1(zn) === "object" || Array.isArray(zn) && (g1(zn[0]) === "object" || g1(zn[1]) === "object")) && me(xn);
      });
      return function() {
        return Slt.unsubscribe(hn);
      };
    }, []);
    var Oe = function() {
      var xn = [0, 0], zn = Array.isArray(D) ? D : [D, 0];
      return zn.forEach(function(or, vr) {
        if (g1(or) === "object")
          for (var la = 0; la < wlt.length; la++) {
            var Ba = wlt[la];
            if (ce[Ba] && or[Ba] !== void 0) {
              xn[vr] = or[Ba];
              break;
            }
          }
        else
          xn[vr] = or || 0;
      }), xn;
    }, We = W("row", u), Ue = Oe(), qe = Nj(We, (e3 = {}, fh(e3, "".concat(We, "-no-wrap"), P === false), fh(e3, "".concat(We, "-").concat(h), h), fh(e3, "".concat(We, "-").concat(v4), v4), fh(e3, "".concat(We, "-rtl"), K === "rtl"), e3), m3), Ze = {}, ct = Ue[0] > 0 ? Ue[0] / -2 : void 0, _t = Ue[1] > 0 ? Ue[1] / -2 : void 0;
    if (ct && (Ze.marginLeft = ct, Ze.marginRight = ct), ve) {
      var pt = m2(Ue, 2);
      Ze.rowGap = pt[1];
    } else
      _t && (Ze.marginTop = _t, Ze.marginBottom = _t);
    var zt = m2(Ue, 2), Zt = zt[0], Ft = zt[1], Kn = ma.useMemo(function() {
      return { gutter: [Zt, Ft], wrap: P, supportFlexGap: ve };
    }, [Zt, Ft, P, ve]);
    return ma.createElement(xgt.Provider, { value: Kn }, ma.createElement("div", hg({}, N, { className: qe, style: hg(hg({}, Ze), x3), ref: r3 }), C));
  });
  wgt.displayName = "Row";
  var q5n = wgt, $5n = globalThis && globalThis.__rest || function(l3, r3) {
    var e3 = {};
    for (var u in l3)
      Object.prototype.hasOwnProperty.call(l3, u) && r3.indexOf(u) < 0 && (e3[u] = l3[u]);
    if (l3 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var h = 0, u = Object.getOwnPropertySymbols(l3); h < u.length; h++)
        r3.indexOf(u[h]) < 0 && Object.prototype.propertyIsEnumerable.call(l3, u[h]) && (e3[u[h]] = l3[u[h]]);
    return e3;
  };
  function X5n(l3) {
    return typeof l3 == "number" ? "".concat(l3, " ").concat(l3, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(l3) ? "0 0 ".concat(l3) : l3;
  }
  var Y5n = ["xs", "sm", "md", "lg", "xl", "xxl"], Sgt = ma.forwardRef(function(l3, r3) {
    var e3, u = ma.useContext(lP), h = u.getPrefixCls, v4 = u.direction, m3 = ma.useContext(xgt), x3 = m3.gutter, C = m3.wrap, A2 = m3.supportFlexGap, D = l3.prefixCls, P = l3.span, N = l3.order, j = l3.offset, W = l3.push, K = l3.pull, te = l3.className, ne = l3.children, ce = l3.flex, me = l3.style, ve = $5n(l3, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), Be = h("col", D), Oe = {};
    Y5n.forEach(function(ct) {
      var _t, pt = {}, zt = l3[ct];
      typeof zt == "number" ? pt.span = zt : g1(zt) === "object" && (pt = zt || {}), delete ve[ct], Oe = hg(hg({}, Oe), (_t = {}, fh(_t, "".concat(Be, "-").concat(ct, "-").concat(pt.span), pt.span !== void 0), fh(_t, "".concat(Be, "-").concat(ct, "-order-").concat(pt.order), pt.order || pt.order === 0), fh(_t, "".concat(Be, "-").concat(ct, "-offset-").concat(pt.offset), pt.offset || pt.offset === 0), fh(_t, "".concat(Be, "-").concat(ct, "-push-").concat(pt.push), pt.push || pt.push === 0), fh(_t, "".concat(Be, "-").concat(ct, "-pull-").concat(pt.pull), pt.pull || pt.pull === 0), fh(_t, "".concat(Be, "-rtl"), v4 === "rtl"), _t));
    });
    var We = Nj(Be, (e3 = {}, fh(e3, "".concat(Be, "-").concat(P), P !== void 0), fh(e3, "".concat(Be, "-order-").concat(N), N), fh(e3, "".concat(Be, "-offset-").concat(j), j), fh(e3, "".concat(Be, "-push-").concat(W), W), fh(e3, "".concat(Be, "-pull-").concat(K), K), e3), te, Oe), Ue = {};
    if (x3 && x3[0] > 0) {
      var qe = x3[0] / 2;
      Ue.paddingLeft = qe, Ue.paddingRight = qe;
    }
    if (x3 && x3[1] > 0 && !A2) {
      var Ze = x3[1] / 2;
      Ue.paddingTop = Ze, Ue.paddingBottom = Ze;
    }
    return ce && (Ue.flex = X5n(ce), C === false && !Ue.minWidth && (Ue.minWidth = 0)), ma.createElement("div", hg({}, ve, { style: hg(hg({}, Ue), me), className: We, ref: r3 }), ne);
  });
  Sgt.displayName = "Col";
  var K5n = Sgt, Cgt = ma.forwardRef(function(l3, r3) {
    var e3, u = l3.prefixCls, h = u === void 0 ? "rc-switch" : u, v4 = l3.className, m3 = l3.checked, x3 = l3.defaultChecked, C = l3.disabled, A2 = l3.loadingIcon, D = l3.checkedChildren, P = l3.unCheckedChildren, N = l3.onClick, j = l3.onChange, W = l3.onKeyDown, K = Rj(l3, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), te = E5n(false, { value: m3, defaultValue: x3 }), ne = m2(te, 2), ce = ne[0], me = ne[1];
    function ve(Ue, qe) {
      var Ze = ce;
      return C || (Ze = Ue, me(Ze), j == null || j(Ze, qe)), Ze;
    }
    function Be(Ue) {
      Ue.which === Sl.LEFT ? ve(false, Ue) : Ue.which === Sl.RIGHT && ve(true, Ue), W == null || W(Ue);
    }
    function Oe(Ue) {
      var qe = ve(!ce, Ue);
      N == null || N(qe, Ue);
    }
    var We = Nj(h, v4, (e3 = {}, fh(e3, "".concat(h, "-checked"), ce), fh(e3, "".concat(h, "-disabled"), C), e3));
    return ma.createElement("button", Object.assign({}, K, { type: "button", role: "switch", "aria-checked": ce, disabled: C, className: We, ref: r3, onKeyDown: Be, onClick: Oe }), A2, ma.createElement("span", { className: "".concat(h, "-inner") }, ce ? D : P));
  });
  Cgt.displayName = "Switch";
  var Z5n = globalThis && globalThis.__rest || function(l3, r3) {
    var e3 = {};
    for (var u in l3)
      Object.prototype.hasOwnProperty.call(l3, u) && r3.indexOf(u) < 0 && (e3[u] = l3[u]);
    if (l3 != null && typeof Object.getOwnPropertySymbols == "function")
      for (var h = 0, u = Object.getOwnPropertySymbols(l3); h < u.length; h++)
        r3.indexOf(u[h]) < 0 && Object.prototype.propertyIsEnumerable.call(l3, u[h]) && (e3[u[h]] = l3[u[h]]);
    return e3;
  }, GPe = ma.forwardRef(function(l3, r3) {
    var e3, u = l3.prefixCls, h = l3.size, v4 = l3.loading, m3 = l3.className, x3 = m3 === void 0 ? "" : m3, C = l3.disabled, A2 = Z5n(l3, ["prefixCls", "size", "loading", "className", "disabled"]);
    f5n("checked" in A2 || !("value" in A2), "Switch", "`value` is not a valid prop, do you mean `checked`?");
    var D = ma.useContext(lP), P = D.getPrefixCls, N = D.direction, j = ma.useContext(I5n), W = P("switch", u), K = ma.createElement("div", { className: "".concat(W, "-handle") }, v4 && ma.createElement(JEn, { className: "".concat(W, "-loading-icon") })), te = Nj((e3 = {}, fh(e3, "".concat(W, "-small"), (h || j) === "small"), fh(e3, "".concat(W, "-loading"), v4), fh(e3, "".concat(W, "-rtl"), N === "rtl"), e3), x3);
    return ma.createElement(mgt, { insertExtraNode: true }, ma.createElement(Cgt, hg({}, A2, { prefixCls: W, className: te, disabled: C || v4, ref: r3, loadingIcon: K })));
  });
  GPe.__ANT_SWITCH = true;
  GPe.displayName = "Switch";
  var J5n = GPe;
  const Q5n = "_container_oi76t_1";
  var ekn = { container: Q5n, function: "_function_oi76t_10" }, Nhe = {};
  (function(l3) {
    var r3 = Object.defineProperty, e3 = Object.getOwnPropertySymbols, u = Object.prototype.hasOwnProperty, h = Object.prototype.propertyIsEnumerable, v4 = (o, i, t3) => i in o ? r3(o, i, { enumerable: true, configurable: true, writable: true, value: t3 }) : o[i] = t3, m3 = (o, i) => {
      for (var t3 in i || (i = {}))
        u.call(i, t3) && v4(o, t3, i[t3]);
      if (e3)
        for (var t3 of e3(i))
          h.call(i, t3) && v4(o, t3, i[t3]);
      return o;
    }, x3 = (o, i, t3) => (v4(o, typeof i != "symbol" ? i + "" : i, t3), t3);
    Object.defineProperties(l3, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
    var C = uj.default;
    function A2(o) {
      return o && typeof o == "object" && "default" in o ? o : { default: o };
    }
    function D(o) {
      if (o && o.__esModule)
        return o;
      var i = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
      return o && Object.keys(o).forEach(function(t3) {
        if (t3 !== "default") {
          var c3 = Object.getOwnPropertyDescriptor(o, t3);
          Object.defineProperty(i, t3, c3.get ? c3 : { enumerable: true, get: function() {
            return o[t3];
          } });
        }
      }), i.default = o, Object.freeze(i);
    }
    var P = A2(C), N = D(C), j = globalThis && globalThis.__read || function(o, i) {
      var t3 = typeof Symbol == "function" && o[Symbol.iterator];
      if (!t3)
        return o;
      var c3 = t3.call(o), p3, g3 = [], b3;
      try {
        for (; (i === void 0 || i-- > 0) && !(p3 = c3.next()).done; )
          g3.push(p3.value);
      } catch (w3) {
        b3 = { error: w3 };
      } finally {
        try {
          p3 && !p3.done && (t3 = c3.return) && t3.call(c3);
        } finally {
          if (b3)
            throw b3.error;
        }
      }
      return g3;
    };
    function W(o, i) {
      o === void 0 && (o = false);
      var t3 = j(C.useState(o), 2), c3 = t3[0], p3 = t3[1], g3 = C.useMemo(function() {
        var b3 = i === void 0 ? !o : i, w3 = function() {
          return p3(function(L) {
            return L === o ? b3 : o;
          });
        }, M = function(L) {
          return p3(L);
        }, I = function() {
          return p3(o);
        }, k3 = function() {
          return p3(b3);
        };
        return { toggle: w3, set: M, setLeft: I, setRight: k3 };
      }, []);
      return [c3, g3];
    }
    var K = globalThis && globalThis.__read || function(o, i) {
      var t3 = typeof Symbol == "function" && o[Symbol.iterator];
      if (!t3)
        return o;
      var c3 = t3.call(o), p3, g3 = [], b3;
      try {
        for (; (i === void 0 || i-- > 0) && !(p3 = c3.next()).done; )
          g3.push(p3.value);
      } catch (w3) {
        b3 = { error: w3 };
      } finally {
        try {
          p3 && !p3.done && (t3 = c3.return) && t3.call(c3);
        } finally {
          if (b3)
            throw b3.error;
        }
      }
      return g3;
    };
    function te(o) {
      o === void 0 && (o = false);
      var i = K(W(o), 2), t3 = i[0], c3 = i[1], p3 = c3.toggle, g3 = c3.set, b3 = C.useMemo(function() {
        var w3 = function() {
          return g3(true);
        }, M = function() {
          return g3(false);
        };
        return { toggle: p3, set: function(I) {
          return g3(!!I);
        }, setTrue: w3, setFalse: M };
      }, []);
      return [t3, b3];
    }
    function ne(o) {
      var i = C.useRef(o);
      return i.current = o, i;
    }
    var ce = !!(typeof window != "undefined" && window.document && window.document.createElement), me = ce;
    function ve(o, i) {
      if (me) {
        if (!o)
          return i;
        var t3;
        return typeof o == "function" ? t3 = o() : "current" in o ? t3 = o.current : t3 = o, t3;
      }
    }
    var Be = function(o) {
      var i = ne(o);
      C.useEffect(function() {
        return function() {
          i.current();
        };
      }, []);
    }, Oe = Be;
    function We(o, i) {
      if (o === i)
        return true;
      for (var t3 = 0; t3 < o.length; t3++)
        if (!Object.is(o[t3], i[t3]))
          return false;
      return true;
    }
    var Ue = function(o) {
      var i = function(t3, c3, p3) {
        var g3 = C.useRef(false), b3 = C.useRef([]), w3 = C.useRef([]), M = C.useRef();
        o(function() {
          var I, k3 = Array.isArray(p3) ? p3 : [p3], L = k3.map(function(F) {
            return ve(F);
          });
          if (!g3.current) {
            g3.current = true, b3.current = L, w3.current = c3, M.current = t3();
            return;
          }
          (L.length !== b3.current.length || !We(L, b3.current) || !We(c3, w3.current)) && ((I = M.current) === null || I === void 0 || I.call(M), b3.current = L, w3.current = c3, M.current = t3());
        }), Oe(function() {
          var I;
          (I = M.current) === null || I === void 0 || I.call(M), g3.current = false;
        });
      };
      return i;
    }, qe = Ue, Ze = qe(C.useEffect), ct = Ze, _t = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof p2 != "undefined" ? p2 : typeof self != "undefined" ? self : {};
    function pt(o) {
      return o && o.__esModule && Object.prototype.hasOwnProperty.call(o, "default") ? o.default : o;
    }
    function zt(o) {
      var i = typeof o;
      return o != null && (i == "object" || i == "function");
    }
    var Zt = zt, Ft = typeof _t == "object" && _t && _t.Object === Object && _t, Kn = Ft, hn = Kn, xn = typeof self == "object" && self && self.Object === Object && self, zn = hn || xn || Function("return this")(), or = zn, vr = or, la = function() {
      return vr.Date.now();
    }, Ba = la, Lo = /\s/;
    function Ao(o) {
      for (var i = o.length; i-- && Lo.test(o.charAt(i)); )
        ;
      return i;
    }
    var oo = Ao, Pa = oo, fo = /^\s+/;
    function Co(o) {
      return o && o.slice(0, Pa(o) + 1).replace(fo, "");
    }
    var $a = Co, Yo = or, Qu = Yo.Symbol, ds = Qu, Lu = ds, dc = Object.prototype, Kc = dc.hasOwnProperty, sv = dc.toString, Hf = Lu ? Lu.toStringTag : void 0;
    function vg(o) {
      var i = Kc.call(o, Hf), t3 = o[Hf];
      try {
        o[Hf] = void 0;
        var c3 = true;
      } catch {
      }
      var p3 = sv.call(o);
      return c3 && (i ? o[Hf] = t3 : delete o[Hf]), p3;
    }
    var Ef = vg, md = Object.prototype, Gh = md.toString;
    function nw(o) {
      return Gh.call(o);
    }
    var Ki = nw, Zr = ds, Ur = Ef, Zi = Ki, uo = "[object Null]", us = "[object Undefined]", Jl = Zr ? Zr.toStringTag : void 0;
    function Ql(o) {
      return o == null ? o === void 0 ? us : uo : Jl && Jl in Object(o) ? Ur(o) : Zi(o);
    }
    var sf = Ql;
    function ep(o) {
      return o != null && typeof o == "object";
    }
    var hh = ep, bd = sf, ph = hh, l0 = "[object Symbol]";
    function iy(o) {
      return typeof o == "symbol" || ph(o) && bd(o) == l0;
    }
    var _b2 = iy, ay = $a, Vp = Zt, vc = _b2, Hd = 0 / 0, gg = /^[-+]0x[0-9a-f]+$/i, xb = /^0b[01]+$/i, um = /^0o[0-7]+$/i, oy = parseInt;
    function x1(o) {
      if (typeof o == "number")
        return o;
      if (vc(o))
        return Hd;
      if (Vp(o)) {
        var i = typeof o.valueOf == "function" ? o.valueOf() : o;
        o = Vp(i) ? i + "" : i;
      }
      if (typeof o != "string")
        return o === 0 ? o : +o;
      o = ay(o);
      var t3 = xb.test(o);
      return t3 || um.test(o) ? oy(o.slice(2), t3 ? 2 : 8) : gg.test(o) ? Hd : +o;
    }
    var _M = x1, M2 = Zt, uP = Ba, T2 = _M, Fj = "Expected a function", Vj = Math.max, Bj = Math.min;
    function zj(o, i, t3) {
      var c3, p3, g3, b3, w3, M, I = 0, k3 = false, L = false, F = true;
      if (typeof o != "function")
        throw new TypeError(Fj);
      i = T2(i) || 0, M2(t3) && (k3 = !!t3.leading, L = "maxWait" in t3, g3 = L ? Vj(T2(t3.maxWait) || 0, i) : g3, F = "trailing" in t3 ? !!t3.trailing : F);
      function B(Pe) {
        var ze = c3, $e = p3;
        return c3 = p3 = void 0, I = Pe, b3 = o.apply($e, ze), b3;
      }
      function G(Pe) {
        return I = Pe, w3 = setTimeout(se, i), k3 ? B(Pe) : b3;
      }
      function J(Pe) {
        var ze = Pe - M, $e = Pe - I, Ke = i - ze;
        return L ? Bj(Ke, g3 - $e) : Ke;
      }
      function Q(Pe) {
        var ze = Pe - M, $e = Pe - I;
        return M === void 0 || ze >= i || ze < 0 || L && $e >= g3;
      }
      function se() {
        var Pe = uP();
        if (Q(Pe))
          return he(Pe);
        w3 = setTimeout(se, J(Pe));
      }
      function he(Pe) {
        return w3 = void 0, F && c3 ? B(Pe) : (c3 = p3 = void 0, b3);
      }
      function be() {
        w3 !== void 0 && clearTimeout(w3), I = 0, c3 = M = p3 = w3 = void 0;
      }
      function de() {
        return w3 === void 0 ? b3 : he(uP());
      }
      function Fe() {
        var Pe = uP(), ze = Q(Pe);
        if (c3 = arguments, p3 = this, M = Pe, ze) {
          if (w3 === void 0)
            return G(M);
          if (L)
            return clearTimeout(w3), w3 = setTimeout(se, i), B(M);
        }
        return w3 === void 0 && (w3 = setTimeout(se, i)), b3;
      }
      return Fe.cancel = be, Fe.flush = de, Fe;
    }
    var y5 = zj, An = globalThis && globalThis.__read || function(o, i) {
      var t3 = typeof Symbol == "function" && o[Symbol.iterator];
      if (!t3)
        return o;
      var c3 = t3.call(o), p3, g3 = [], b3;
      try {
        for (; (i === void 0 || i-- > 0) && !(p3 = c3.next()).done; )
          g3.push(p3.value);
      } catch (w3) {
        b3 = { error: w3 };
      } finally {
        try {
          p3 && !p3.done && (t3 = c3.return) && t3.call(c3);
        } finally {
          if (b3)
            throw b3.error;
        }
      }
      return g3;
    }, Rn = globalThis && globalThis.__spread || function() {
      for (var o = [], i = 0; i < arguments.length; i++)
        o = o.concat(An(arguments[i]));
      return o;
    };
    function $t(o, i) {
      var t3, c3 = ne(o), p3 = (t3 = i == null ? void 0 : i.wait) !== null && t3 !== void 0 ? t3 : 1e3, g3 = C.useMemo(function() {
        return y5(function() {
          for (var b3 = [], w3 = 0; w3 < arguments.length; w3++)
            b3[w3] = arguments[w3];
          return c3.current.apply(c3, Rn(b3));
        }, p3, i);
      }, []);
      return Oe(function() {
        g3.cancel();
      }), { run: g3, cancel: g3.cancel, flush: g3.flush };
    }
    var bn = function(o) {
      return function(i, t3) {
        var c3 = C.useRef(false);
        o(function() {
          return function() {
            c3.current = false;
          };
        }, []), o(function() {
          if (!c3.current)
            c3.current = true;
          else
            return i();
        }, t3);
      };
    }, Mn = bn(C.useEffect), jr = globalThis && globalThis.__read || function(o, i) {
      var t3 = typeof Symbol == "function" && o[Symbol.iterator];
      if (!t3)
        return o;
      var c3 = t3.call(o), p3, g3 = [], b3;
      try {
        for (; (i === void 0 || i-- > 0) && !(p3 = c3.next()).done; )
          g3.push(p3.value);
      } catch (w3) {
        b3 = { error: w3 };
      } finally {
        try {
          p3 && !p3.done && (t3 = c3.return) && t3.call(c3);
        } finally {
          if (b3)
            throw b3.error;
        }
      }
      return g3;
    };
    function zi(o, i, t3) {
      var c3 = jr(C.useState({}), 2), p3 = c3[0], g3 = c3[1], b3 = $t(function() {
        g3({});
      }, t3), w3 = b3.run, M = b3.cancel;
      C.useEffect(function() {
        return w3();
      }, i), Oe(M), Mn(o, [p3]);
    }
    function xi(o, i, t3) {
      t3 === void 0 && (t3 = {});
      var c3 = ne(i);
      ct(function() {
        var p3 = ve(t3.target, window);
        if (p3 != null && p3.addEventListener) {
          var g3 = function(b3) {
            return c3.current(b3);
          };
          return p3.addEventListener(o, g3, { capture: t3.capture, once: t3.once, passive: t3.passive }), function() {
            p3.removeEventListener(o, g3, { capture: t3.capture });
          };
        }
      }, [o, t3.capture, t3.once, t3.passive], t3.target);
    }
    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.
    
    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.
    
    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    var Sr = function(o, i) {
      return Sr = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(t3, c3) {
        t3.__proto__ = c3;
      } || function(t3, c3) {
        for (var p3 in c3)
          Object.prototype.hasOwnProperty.call(c3, p3) && (t3[p3] = c3[p3]);
      }, Sr(o, i);
    };
    function cn(o, i) {
      if (typeof i != "function" && i !== null)
        throw new TypeError("Class extends value " + String(i) + " is not a constructor or null");
      Sr(o, i);
      function t3() {
        this.constructor = o;
      }
      o.prototype = i === null ? Object.create(i) : (t3.prototype = i.prototype, new t3());
    }
    var as = function() {
      function o() {
        this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
      }
      return o;
    }(), Eu = function() {
      function o() {
        this.browser = new as(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
      }
      return o;
    }(), eu = new Eu();
    typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (eu.wxa = true, eu.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? eu.worker = true : typeof navigator == "undefined" ? (eu.node = true, eu.svgSupported = true) : Df(navigator.userAgent, eu);
    function Df(o, i) {
      var t3 = i.browser, c3 = o.match(/Firefox\/([\d.]+)/), p3 = o.match(/MSIE\s([\d.]+)/) || o.match(/Trident\/.+?rv:(([\d.]+))/), g3 = o.match(/Edge?\/([\d.]+)/), b3 = /micromessenger/i.test(o);
      c3 && (t3.firefox = true, t3.version = c3[1]), p3 && (t3.ie = true, t3.version = p3[1]), g3 && (t3.edge = true, t3.version = g3[1], t3.newEdge = +g3[1].split(".")[0] > 18), b3 && (t3.weChat = true), i.svgSupported = typeof SVGRect != "undefined", i.touchEventsSupported = "ontouchstart" in window && !t3.ie && !t3.edge, i.pointerEventsSupported = "onpointerdown" in window && (t3.edge || t3.ie && +t3.version >= 11), i.domSupported = typeof document != "undefined";
      var w3 = document.documentElement.style;
      i.transform3dSupported = (t3.ie && "transition" in w3 || t3.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in w3) && !("OTransition" in w3), i.transformSupported = i.transform3dSupported || t3.ie && +t3.version >= 9;
    }
    var yo = eu, lf = 12, tp = "sans-serif", Vs = lf + "px " + tp, _d = 20, sy = 100, T_ = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
    function m5(o) {
      var i = {};
      if (typeof JSON == "undefined")
        return i;
      for (var t3 = 0; t3 < o.length; t3++) {
        var c3 = String.fromCharCode(t3 + 32), p3 = (o.charCodeAt(t3) - _d) / sy;
        i[c3] = p3;
      }
      return i;
    }
    var A_ = m5(T_), cm = { createCanvas: function() {
      return typeof document != "undefined" && document.createElement("canvas");
    }, measureText: function() {
      var o, i;
      return function(t3, c3) {
        if (!o) {
          var p3 = cm.createCanvas();
          o = p3 && p3.getContext("2d");
        }
        if (o)
          return i !== c3 && (i = o.font = c3 || Vs), o.measureText(t3);
        t3 = t3 || "", c3 = c3 || Vs;
        var g3 = /^([0-9]*?)px$/.exec(c3), b3 = +(g3 && g3[1]) || lf, w3 = 0;
        if (c3.indexOf("mono") >= 0)
          w3 = b3 * t3.length;
        else
          for (var M = 0; M < t3.length; M++) {
            var I = A_[t3[M]];
            w3 += I == null ? b3 : I * b3;
          }
        return { width: w3 };
      };
    }(), loadImage: function(o, i, t3) {
      var c3 = new Image();
      return c3.onload = i, c3.onerror = t3, c3.src = o, c3;
    } }, rw = aw(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(o, i) {
      return o["[object " + i + "]"] = true, o;
    }, {}), Wd = aw(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(o, i) {
      return o["[object " + i + "Array]"] = true, o;
    }, {}), ly = Object.prototype.toString, iw = Array.prototype, A22 = iw.forEach, JA = iw.filter, I2 = iw.slice, cP = iw.map, QA = function() {
    }.constructor, E2 = QA ? QA.prototype : null, D2 = "__proto__", xM = 2311;
    function b5() {
      return xM++;
    }
    function fP() {
      for (var o = [], i = 0; i < arguments.length; i++)
        o[i] = arguments[i];
      typeof console != "undefined" && console.error.apply(console, o);
    }
    function Jo(o) {
      if (o == null || typeof o != "object")
        return o;
      var i = o, t3 = ly.call(o);
      if (t3 === "[object Array]") {
        if (!_5(o)) {
          i = [];
          for (var c3 = 0, p3 = o.length; c3 < p3; c3++)
            i[c3] = Jo(o[c3]);
        }
      } else if (Wd[t3]) {
        if (!_5(o)) {
          var g3 = o.constructor;
          if (g3.from)
            i = g3.from(o);
          else {
            i = new g3(o.length);
            for (var c3 = 0, p3 = o.length; c3 < p3; c3++)
              i[c3] = o[c3];
          }
        }
      } else if (!rw[t3] && !_5(o) && !hP(o)) {
        i = {};
        for (var b3 in o)
          o.hasOwnProperty(b3) && b3 !== D2 && (i[b3] = Jo(o[b3]));
      }
      return i;
    }
    function Es(o, i, t3) {
      if (!Ua(i) || !Ua(o))
        return t3 ? Jo(i) : o;
      for (var c3 in i)
        if (i.hasOwnProperty(c3) && c3 !== D2) {
          var p3 = o[c3], g3 = i[c3];
          Ua(g3) && Ua(p3) && !Ei(g3) && !Ei(p3) && !hP(g3) && !hP(p3) && !dh(g3) && !dh(p3) && !_5(g3) && !_5(p3) ? Es(p3, g3, t3) : (t3 || !(c3 in o)) && (o[c3] = Jo(i[c3]));
        }
      return o;
    }
    function nF(o, i) {
      for (var t3 = o[0], c3 = 1, p3 = o.length; c3 < p3; c3++)
        t3 = Es(t3, o[c3], i);
      return t3;
    }
    function ti(o, i) {
      if (Object.assign)
        Object.assign(o, i);
      else
        for (var t3 in i)
          i.hasOwnProperty(t3) && t3 !== D2 && (o[t3] = i[t3]);
      return o;
    }
    function Uo(o, i, t3) {
      for (var c3 = Gl(i), p3 = 0; p3 < c3.length; p3++) {
        var g3 = c3[p3];
        (t3 ? i[g3] != null : o[g3] == null) && (o[g3] = i[g3]);
      }
      return o;
    }
    function rl(o, i) {
      if (o) {
        if (o.indexOf)
          return o.indexOf(i);
        for (var t3 = 0, c3 = o.length; t3 < c3; t3++)
          if (o[t3] === i)
            return t3;
      }
      return -1;
    }
    function tQ(o, i) {
      var t3 = o.prototype;
      function c3() {
      }
      c3.prototype = i.prototype, o.prototype = new c3();
      for (var p3 in t3)
        t3.hasOwnProperty(p3) && (o.prototype[p3] = t3[p3]);
      o.prototype.constructor = o, o.superClass = i;
    }
    function Kp(o, i, t3) {
      if (o = "prototype" in o ? o.prototype : o, i = "prototype" in i ? i.prototype : i, Object.getOwnPropertyNames)
        for (var c3 = Object.getOwnPropertyNames(i), p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          g3 !== "constructor" && (t3 ? i[g3] != null : o[g3] == null) && (o[g3] = i[g3]);
        }
      else
        Uo(o, i, t3);
    }
    function yg(o) {
      return !o || typeof o == "string" ? false : typeof o.length == "number";
    }
    function yt(o, i, t3) {
      if (o && i)
        if (o.forEach && o.forEach === A22)
          o.forEach(i, t3);
        else if (o.length === +o.length)
          for (var c3 = 0, p3 = o.length; c3 < p3; c3++)
            i.call(t3, o[c3], c3, o);
        else
          for (var g3 in o)
            o.hasOwnProperty(g3) && i.call(t3, o[g3], g3, o);
    }
    function Fi(o, i, t3) {
      if (!o)
        return [];
      if (!i)
        return dP(o);
      if (o.map && o.map === cP)
        return o.map(i, t3);
      for (var c3 = [], p3 = 0, g3 = o.length; p3 < g3; p3++)
        c3.push(i.call(t3, o[p3], p3, o));
      return c3;
    }
    function aw(o, i, t3, c3) {
      if (o && i) {
        for (var p3 = 0, g3 = o.length; p3 < g3; p3++)
          t3 = i.call(c3, t3, o[p3], p3, o);
        return t3;
      }
    }
    function Zc(o, i, t3) {
      if (!o)
        return [];
      if (!i)
        return dP(o);
      if (o.filter && o.filter === JA)
        return o.filter(i, t3);
      for (var c3 = [], p3 = 0, g3 = o.length; p3 < g3; p3++)
        i.call(t3, o[p3], p3, o) && c3.push(o[p3]);
      return c3;
    }
    function Fpe(o, i, t3) {
      if (o && i) {
        for (var c3 = 0, p3 = o.length; c3 < p3; c3++)
          if (i.call(t3, o[c3], c3, o))
            return o[c3];
      }
    }
    function Gl(o) {
      if (!o)
        return [];
      if (Object.keys)
        return Object.keys(o);
      var i = [];
      for (var t3 in o)
        o.hasOwnProperty(t3) && i.push(t3);
      return i;
    }
    function Vpe(o, i) {
      for (var t3 = [], c3 = 2; c3 < arguments.length; c3++)
        t3[c3 - 2] = arguments[c3];
      return function() {
        return o.apply(i, t3.concat(I2.call(arguments)));
      };
    }
    var Qa = E2 && Vo(E2.bind) ? E2.call.bind(E2.bind) : Vpe;
    function As(o) {
      for (var i = [], t3 = 1; t3 < arguments.length; t3++)
        i[t3 - 1] = arguments[t3];
      return function() {
        return o.apply(this, i.concat(I2.call(arguments)));
      };
    }
    function Ei(o) {
      return Array.isArray ? Array.isArray(o) : ly.call(o) === "[object Array]";
    }
    function Vo(o) {
      return typeof o == "function";
    }
    function Ha(o) {
      return typeof o == "string";
    }
    function jj(o) {
      return ly.call(o) === "[object String]";
    }
    function ec(o) {
      return typeof o == "number";
    }
    function Ua(o) {
      var i = typeof o;
      return i === "function" || !!o && i === "object";
    }
    function dh(o) {
      return !!rw[ly.call(o)];
    }
    function w1(o) {
      return !!Wd[ly.call(o)];
    }
    function hP(o) {
      return typeof o == "object" && typeof o.nodeType == "number" && typeof o.ownerDocument == "object";
    }
    function rF(o) {
      return o.colorStops != null;
    }
    function Bpe(o) {
      return o.image != null;
    }
    function zpe(o) {
      return ly.call(o) === "[object RegExp]";
    }
    function pP(o) {
      return o !== o;
    }
    function lv() {
      for (var o = [], i = 0; i < arguments.length; i++)
        o[i] = arguments[i];
      for (var t3 = 0, c3 = o.length; t3 < c3; t3++)
        if (o[t3] != null)
          return o[t3];
    }
    function Xs(o, i) {
      return o != null ? o : i;
    }
    function np(o, i, t3) {
      return o != null ? o : i != null ? i : t3;
    }
    function dP(o) {
      for (var i = [], t3 = 1; t3 < arguments.length; t3++)
        i[t3 - 1] = arguments[t3];
      return I2.apply(o, i);
    }
    function k2(o) {
      if (typeof o == "number")
        return [o, o, o, o];
      var i = o.length;
      return i === 2 ? [o[0], o[1], o[0], o[1]] : i === 3 ? [o[0], o[1], o[2], o[1]] : o;
    }
    function u0(o, i) {
      if (!o)
        throw new Error(i);
    }
    function S1(o) {
      return o == null ? null : typeof o.trim == "function" ? o.trim() : o.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
    }
    var C1 = "__ec_primitive__";
    function vP(o) {
      o[C1] = true;
    }
    function _5(o) {
      return o[C1];
    }
    var nQ = function() {
      function o(i) {
        this.data = {};
        var t3 = Ei(i);
        this.data = {};
        var c3 = this;
        i instanceof o ? i.each(p3) : i && yt(i, p3);
        function p3(g3, b3) {
          t3 ? c3.set(g3, b3) : c3.set(b3, g3);
        }
      }
      return o.prototype.get = function(i) {
        return this.data.hasOwnProperty(i) ? this.data[i] : null;
      }, o.prototype.set = function(i, t3) {
        return this.data[i] = t3;
      }, o.prototype.each = function(i, t3) {
        for (var c3 in this.data)
          this.data.hasOwnProperty(c3) && i.call(t3, this.data[c3], c3);
      }, o.prototype.keys = function() {
        return Gl(this.data);
      }, o.prototype.removeKey = function(i) {
        delete this.data[i];
      }, o;
    }();
    function Eo(o) {
      return new nQ(o);
    }
    function iF(o, i) {
      for (var t3 = new o.constructor(o.length + i.length), c3 = 0; c3 < o.length; c3++)
        t3[c3] = o[c3];
      for (var p3 = o.length, c3 = 0; c3 < i.length; c3++)
        t3[c3 + p3] = i[c3];
      return t3;
    }
    function gP(o, i) {
      var t3;
      if (Object.create)
        t3 = Object.create(o);
      else {
        var c3 = function() {
        };
        c3.prototype = o, t3 = new c3();
      }
      return i && ti(t3, i), t3;
    }
    function fm(o) {
      var i = o.style;
      i.webkitUserSelect = "none", i.userSelect = "none", i.webkitTapHighlightColor = "rgba(0,0,0,0)", i["-webkit-touch-callout"] = "none";
    }
    function so(o, i) {
      return o.hasOwnProperty(i);
    }
    function uf() {
    }
    var aF = 180 / Math.PI;
    function wM(o, i) {
      return o == null && (o = 0), i == null && (i = 0), [o, i];
    }
    function Zp(o, i) {
      return o[0] = i[0], o[1] = i[1], o;
    }
    function wb(o) {
      return [o[0], o[1]];
    }
    function Gj(o, i, t3) {
      return o[0] = i, o[1] = t3, o;
    }
    function rp(o, i, t3) {
      return o[0] = i[0] + t3[0], o[1] = i[1] + t3[1], o;
    }
    function ow(o, i, t3, c3) {
      return o[0] = i[0] + t3[0] * c3, o[1] = i[1] + t3[1] * c3, o;
    }
    function O2(o, i, t3) {
      return o[0] = i[0] - t3[0], o[1] = i[1] - t3[1], o;
    }
    function Hj(o) {
      return Math.sqrt(Wj(o));
    }
    function Wj(o) {
      return o[0] * o[0] + o[1] * o[1];
    }
    function Uj(o, i, t3) {
      return o[0] = i[0] * t3, o[1] = i[1] * t3, o;
    }
    function yP(o, i) {
      var t3 = Hj(i);
      return t3 === 0 ? (o[0] = 0, o[1] = 0) : (o[0] = i[0] / t3, o[1] = i[1] / t3), o;
    }
    function qj(o, i) {
      return Math.sqrt((o[0] - i[0]) * (o[0] - i[0]) + (o[1] - i[1]) * (o[1] - i[1]));
    }
    var P2 = qj;
    function oF(o, i) {
      return (o[0] - i[0]) * (o[0] - i[0]) + (o[1] - i[1]) * (o[1] - i[1]);
    }
    var Sb = oF;
    function sF(o, i, t3, c3) {
      return o[0] = i[0] + c3 * (t3[0] - i[0]), o[1] = i[1] + c3 * (t3[1] - i[1]), o;
    }
    function Vv(o, i, t3) {
      var c3 = i[0], p3 = i[1];
      return o[0] = t3[0] * c3 + t3[2] * p3 + t3[4], o[1] = t3[1] * c3 + t3[3] * p3 + t3[5], o;
    }
    function L2(o, i, t3) {
      return o[0] = Math.min(i[0], t3[0]), o[1] = Math.min(i[1], t3[1]), o;
    }
    function sw(o, i, t3) {
      return o[0] = Math.max(i[0], t3[0]), o[1] = Math.max(i[1], t3[1]), o;
    }
    var SM = function() {
      function o(i, t3) {
        this.target = i, this.topTarget = t3 && t3.topTarget;
      }
      return o;
    }(), rQ = function() {
      function o(i) {
        this.handler = i, i.on("mousedown", this._dragStart, this), i.on("mousemove", this._drag, this), i.on("mouseup", this._dragEnd, this);
      }
      return o.prototype._dragStart = function(i) {
        for (var t3 = i.target; t3 && !t3.draggable; )
          t3 = t3.parent || t3.__hostTarget;
        t3 && (this._draggingTarget = t3, t3.dragging = true, this._x = i.offsetX, this._y = i.offsetY, this.handler.dispatchToElement(new SM(t3, i), "dragstart", i.event));
      }, o.prototype._drag = function(i) {
        var t3 = this._draggingTarget;
        if (t3) {
          var c3 = i.offsetX, p3 = i.offsetY, g3 = c3 - this._x, b3 = p3 - this._y;
          this._x = c3, this._y = p3, t3.drift(g3, b3, i), this.handler.dispatchToElement(new SM(t3, i), "drag", i.event);
          var w3 = this.handler.findHover(c3, p3, t3).target, M = this._dropTarget;
          this._dropTarget = w3, t3 !== w3 && (M && w3 !== M && this.handler.dispatchToElement(new SM(M, i), "dragleave", i.event), w3 && w3 !== M && this.handler.dispatchToElement(new SM(w3, i), "dragenter", i.event));
        }
      }, o.prototype._dragEnd = function(i) {
        var t3 = this._draggingTarget;
        t3 && (t3.dragging = false), this.handler.dispatchToElement(new SM(t3, i), "dragend", i.event), this._dropTarget && this.handler.dispatchToElement(new SM(this._dropTarget, i), "drop", i.event), this._draggingTarget = null, this._dropTarget = null;
      }, o;
    }(), jpe = rQ, $j = function() {
      function o(i) {
        i && (this._$eventProcessor = i);
      }
      return o.prototype.on = function(i, t3, c3, p3) {
        this._$handlers || (this._$handlers = {});
        var g3 = this._$handlers;
        if (typeof t3 == "function" && (p3 = c3, c3 = t3, t3 = null), !c3 || !i)
          return this;
        var b3 = this._$eventProcessor;
        t3 != null && b3 && b3.normalizeQuery && (t3 = b3.normalizeQuery(t3)), g3[i] || (g3[i] = []);
        for (var w3 = 0; w3 < g3[i].length; w3++)
          if (g3[i][w3].h === c3)
            return this;
        var M = { h: c3, query: t3, ctx: p3 || this, callAtLast: c3.zrEventfulCallAtLast }, I = g3[i].length - 1, k3 = g3[i][I];
        return k3 && k3.callAtLast ? g3[i].splice(I, 0, M) : g3[i].push(M), this;
      }, o.prototype.isSilent = function(i) {
        var t3 = this._$handlers;
        return !t3 || !t3[i] || !t3[i].length;
      }, o.prototype.off = function(i, t3) {
        var c3 = this._$handlers;
        if (!c3)
          return this;
        if (!i)
          return this._$handlers = {}, this;
        if (t3) {
          if (c3[i]) {
            for (var p3 = [], g3 = 0, b3 = c3[i].length; g3 < b3; g3++)
              c3[i][g3].h !== t3 && p3.push(c3[i][g3]);
            c3[i] = p3;
          }
          c3[i] && c3[i].length === 0 && delete c3[i];
        } else
          delete c3[i];
        return this;
      }, o.prototype.trigger = function(i) {
        for (var t3 = [], c3 = 1; c3 < arguments.length; c3++)
          t3[c3 - 1] = arguments[c3];
        if (!this._$handlers)
          return this;
        var p3 = this._$handlers[i], g3 = this._$eventProcessor;
        if (p3)
          for (var b3 = t3.length, w3 = p3.length, M = 0; M < w3; M++) {
            var I = p3[M];
            if (!(g3 && g3.filter && I.query != null && !g3.filter(i, I.query)))
              switch (b3) {
                case 0:
                  I.h.call(I.ctx);
                  break;
                case 1:
                  I.h.call(I.ctx, t3[0]);
                  break;
                case 2:
                  I.h.call(I.ctx, t3[0], t3[1]);
                  break;
                default:
                  I.h.apply(I.ctx, t3);
                  break;
              }
          }
        return g3 && g3.afterTrigger && g3.afterTrigger(i), this;
      }, o.prototype.triggerWithContext = function(i) {
        for (var t3 = [], c3 = 1; c3 < arguments.length; c3++)
          t3[c3 - 1] = arguments[c3];
        if (!this._$handlers)
          return this;
        var p3 = this._$handlers[i], g3 = this._$eventProcessor;
        if (p3)
          for (var b3 = t3.length, w3 = t3[b3 - 1], M = p3.length, I = 0; I < M; I++) {
            var k3 = p3[I];
            if (!(g3 && g3.filter && k3.query != null && !g3.filter(i, k3.query)))
              switch (b3) {
                case 0:
                  k3.h.call(w3);
                  break;
                case 1:
                  k3.h.call(w3, t3[0]);
                  break;
                case 2:
                  k3.h.call(w3, t3[0], t3[1]);
                  break;
                default:
                  k3.h.apply(w3, t3.slice(1, b3 - 1));
                  break;
              }
          }
        return g3 && g3.afterTrigger && g3.afterTrigger(i), this;
      }, o;
    }(), hm = $j, Gpe = Math.log(2);
    function lF(o, i, t3, c3, p3, g3) {
      var b3 = c3 + "-" + p3, w3 = o.length;
      if (g3.hasOwnProperty(b3))
        return g3[b3];
      if (i === 1) {
        var M = Math.round(Math.log((1 << w3) - 1 & ~p3) / Gpe);
        return o[t3][M];
      }
      for (var I = c3 | 1 << t3, k3 = t3 + 1; c3 & 1 << k3; )
        k3++;
      for (var L = 0, F = 0, B = 0; F < w3; F++) {
        var G = 1 << F;
        G & p3 || (L += (B % 2 ? -1 : 1) * o[t3][F] * lF(o, i - 1, k3, I, p3 | G, g3), B++);
      }
      return g3[b3] = L, L;
    }
    function pm(o, i) {
      var t3 = [[o[0], o[1], 1, 0, 0, 0, -i[0] * o[0], -i[0] * o[1]], [0, 0, 0, o[0], o[1], 1, -i[1] * o[0], -i[1] * o[1]], [o[2], o[3], 1, 0, 0, 0, -i[2] * o[2], -i[2] * o[3]], [0, 0, 0, o[2], o[3], 1, -i[3] * o[2], -i[3] * o[3]], [o[4], o[5], 1, 0, 0, 0, -i[4] * o[4], -i[4] * o[5]], [0, 0, 0, o[4], o[5], 1, -i[5] * o[4], -i[5] * o[5]], [o[6], o[7], 1, 0, 0, 0, -i[6] * o[6], -i[6] * o[7]], [0, 0, 0, o[6], o[7], 1, -i[7] * o[6], -i[7] * o[7]]], c3 = {}, p3 = lF(t3, 8, 0, 0, 0, c3);
      if (p3 !== 0) {
        for (var g3 = [], b3 = 0; b3 < 8; b3++)
          for (var w3 = 0; w3 < 8; w3++)
            g3[w3] == null && (g3[w3] = 0), g3[w3] += ((b3 + w3) % 2 ? -1 : 1) * lF(t3, 7, b3 === 0 ? 1 : 0, 1 << b3, 1 << w3, c3) / p3 * i[b3];
        return function(M, I, k3) {
          var L = I * g3[6] + k3 * g3[7] + 1;
          M[0] = (I * g3[0] + k3 * g3[1] + g3[2]) / L, M[1] = (I * g3[3] + k3 * g3[4] + g3[5]) / L;
        };
      }
    }
    var uF = "___zrEVENTSAVED", eI = [];
    function iQ(o, i, t3, c3, p3) {
      return cF(eI, i, c3, p3, true) && cF(o, t3, eI[0], eI[1]);
    }
    function cF(o, i, t3, c3, p3) {
      if (i.getBoundingClientRect && yo.domSupported && !aQ(i)) {
        var g3 = i[uF] || (i[uF] = {}), b3 = Hpe(i, g3), w3 = Wpe(b3, g3, p3);
        if (w3)
          return w3(o, t3, c3), true;
      }
      return false;
    }
    function Hpe(o, i) {
      var t3 = i.markers;
      if (t3)
        return t3;
      t3 = i.markers = [];
      for (var c3 = ["left", "right"], p3 = ["top", "bottom"], g3 = 0; g3 < 4; g3++) {
        var b3 = document.createElement("div"), w3 = b3.style, M = g3 % 2, I = (g3 >> 1) % 2;
        w3.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", c3[M] + ":0", p3[I] + ":0", c3[1 - M] + ":auto", p3[1 - I] + ":auto", ""].join("!important;"), o.appendChild(b3), t3.push(b3);
      }
      return t3;
    }
    function Wpe(o, i, t3) {
      for (var c3 = t3 ? "invTrans" : "trans", p3 = i[c3], g3 = i.srcCoords, b3 = [], w3 = [], M = true, I = 0; I < 4; I++) {
        var k3 = o[I].getBoundingClientRect(), L = 2 * I, F = k3.left, B = k3.top;
        b3.push(F, B), M = M && g3 && F === g3[L] && B === g3[L + 1], w3.push(o[I].offsetLeft, o[I].offsetTop);
      }
      return M && p3 ? p3 : (i.srcCoords = b3, i[c3] = t3 ? pm(w3, b3) : pm(b3, w3));
    }
    function aQ(o) {
      return o.nodeName.toUpperCase() === "CANVAS";
    }
    var Upe = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, Xj = [], x5 = yo.browser.firefox && +yo.browser.version.split(".")[0] < 39;
    function Yj(o, i, t3, c3) {
      return t3 = t3 || {}, c3 ? oQ(o, i, t3) : x5 && i.layerX != null && i.layerX !== i.offsetX ? (t3.zrX = i.layerX, t3.zrY = i.layerY) : i.offsetX != null ? (t3.zrX = i.offsetX, t3.zrY = i.offsetY) : oQ(o, i, t3), t3;
    }
    function oQ(o, i, t3) {
      if (yo.domSupported && o.getBoundingClientRect) {
        var c3 = i.clientX, p3 = i.clientY;
        if (aQ(o)) {
          var g3 = o.getBoundingClientRect();
          t3.zrX = c3 - g3.left, t3.zrY = p3 - g3.top;
          return;
        } else if (cF(Xj, o, c3, p3)) {
          t3.zrX = Xj[0], t3.zrY = Xj[1];
          return;
        }
      }
      t3.zrX = t3.zrY = 0;
    }
    function mP(o) {
      return o || window.event;
    }
    function M1(o, i, t3) {
      if (i = mP(i), i.zrX != null)
        return i;
      var c3 = i.type, p3 = c3 && c3.indexOf("touch") >= 0;
      if (p3) {
        var g3 = c3 !== "touchend" ? i.targetTouches[0] : i.changedTouches[0];
        g3 && Yj(o, g3, i, t3);
      } else {
        Yj(o, i, i, t3);
        var b3 = CM(i);
        i.zrDelta = b3 ? b3 / 120 : -(i.detail || 0) / 3;
      }
      var w3 = i.button;
      return i.which == null && w3 !== void 0 && Upe.test(i.type) && (i.which = w3 & 1 ? 1 : w3 & 2 ? 3 : w3 & 4 ? 2 : 0), i;
    }
    function CM(o) {
      var i = o.wheelDelta;
      if (i)
        return i;
      var t3 = o.deltaX, c3 = o.deltaY;
      if (t3 == null || c3 == null)
        return i;
      var p3 = Math.abs(c3 !== 0 ? c3 : t3), g3 = c3 > 0 ? -1 : c3 < 0 ? 1 : t3 > 0 ? -1 : 1;
      return 3 * p3 * g3;
    }
    function w5(o, i, t3, c3) {
      o.addEventListener(i, t3, c3);
    }
    function qpe(o, i, t3, c3) {
      o.removeEventListener(i, t3, c3);
    }
    var R2 = function(o) {
      o.preventDefault(), o.stopPropagation(), o.cancelBubble = true;
    };
    function sQ(o) {
      return o.which === 2 || o.which === 3;
    }
    var S5 = function() {
      function o() {
        this._track = [];
      }
      return o.prototype.recognize = function(i, t3, c3) {
        return this._doTrack(i, t3, c3), this._recognize(i);
      }, o.prototype.clear = function() {
        return this._track.length = 0, this;
      }, o.prototype._doTrack = function(i, t3, c3) {
        var p3 = i.touches;
        if (p3) {
          for (var g3 = { points: [], touches: [], target: t3, event: i }, b3 = 0, w3 = p3.length; b3 < w3; b3++) {
            var M = p3[b3], I = Yj(c3, M, {});
            g3.points.push([I.zrX, I.zrY]), g3.touches.push(M);
          }
          this._track.push(g3);
        }
      }, o.prototype._recognize = function(i) {
        for (var t3 in Kj)
          if (Kj.hasOwnProperty(t3)) {
            var c3 = Kj[t3](this._track, i);
            if (c3)
              return c3;
          }
      }, o;
    }();
    function Cb(o) {
      var i = o[1][0] - o[0][0], t3 = o[1][1] - o[0][1];
      return Math.sqrt(i * i + t3 * t3);
    }
    function lQ(o) {
      return [(o[0][0] + o[1][0]) / 2, (o[0][1] + o[1][1]) / 2];
    }
    var Kj = { pinch: function(o, i) {
      var t3 = o.length;
      if (t3) {
        var c3 = (o[t3 - 1] || {}).points, p3 = (o[t3 - 2] || {}).points || c3;
        if (p3 && p3.length > 1 && c3 && c3.length > 1) {
          var g3 = Cb(c3) / Cb(p3);
          !isFinite(g3) && (g3 = 1), i.pinchScale = g3;
          var b3 = lQ(c3);
          return i.pinchX = b3[0], i.pinchY = b3[1], { type: "pinch", target: o[0].target, event: i };
        }
      }
    } }, uQ = "silent";
    function $pe(o, i, t3) {
      return { type: o, event: t3, target: i.target, topTarget: i.topTarget, cancelBubble: false, offsetX: t3.zrX, offsetY: t3.zrY, gestureEvent: t3.gestureEvent, pinchX: t3.pinchX, pinchY: t3.pinchY, pinchScale: t3.pinchScale, wheelDelta: t3.zrDelta, zrByTouch: t3.zrByTouch, which: t3.which, stop: Xpe };
    }
    function Xpe() {
      R2(this.event);
    }
    var Ype = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.handler = null, t3;
      }
      return i.prototype.dispose = function() {
      }, i.prototype.setCursor = function() {
      }, i;
    }(hm), lw = function() {
      function o(i, t3) {
        this.x = i, this.y = t3;
      }
      return o;
    }(), hr = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], Wi = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3) {
        var b3 = o.call(this) || this;
        return b3._hovered = new lw(0, 0), b3.storage = t3, b3.painter = c3, b3.painterRoot = g3, p3 = p3 || new Ype(), b3.proxy = null, b3.setHandlerProxy(p3), b3._draggingMgr = new jpe(b3), b3;
      }
      return i.prototype.setHandlerProxy = function(t3) {
        this.proxy && this.proxy.dispose(), t3 && (yt(hr, function(c3) {
          t3.on && t3.on(c3, this[c3], this);
        }, this), t3.handler = this), this.proxy = t3;
      }, i.prototype.mousemove = function(t3) {
        var c3 = t3.zrX, p3 = t3.zrY, g3 = Ko(this, c3, p3), b3 = this._hovered, w3 = b3.target;
        w3 && !w3.__zr && (b3 = this.findHover(b3.x, b3.y), w3 = b3.target);
        var M = this._hovered = g3 ? new lw(c3, p3) : this.findHover(c3, p3), I = M.target, k3 = this.proxy;
        k3.setCursor && k3.setCursor(I ? I.cursor : "default"), w3 && I !== w3 && this.dispatchToElement(b3, "mouseout", t3), this.dispatchToElement(M, "mousemove", t3), I && I !== w3 && this.dispatchToElement(M, "mouseover", t3);
      }, i.prototype.mouseout = function(t3) {
        var c3 = t3.zrEventControl;
        c3 !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", t3), c3 !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: t3 });
      }, i.prototype.resize = function() {
        this._hovered = new lw(0, 0);
      }, i.prototype.dispatch = function(t3, c3) {
        var p3 = this[t3];
        p3 && p3.call(this, c3);
      }, i.prototype.dispose = function() {
        this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
      }, i.prototype.setCursorStyle = function(t3) {
        var c3 = this.proxy;
        c3.setCursor && c3.setCursor(t3);
      }, i.prototype.dispatchToElement = function(t3, c3, p3) {
        t3 = t3 || {};
        var g3 = t3.target;
        if (!(g3 && g3.silent)) {
          for (var b3 = "on" + c3, w3 = $pe(c3, t3, p3); g3 && (g3[b3] && (w3.cancelBubble = !!g3[b3].call(g3, w3)), g3.trigger(c3, w3), g3 = g3.__hostTarget ? g3.__hostTarget : g3.parent, !w3.cancelBubble); )
            ;
          w3.cancelBubble || (this.trigger(c3, w3), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(M) {
            typeof M[b3] == "function" && M[b3].call(M, w3), M.trigger && M.trigger(c3, w3);
          }));
        }
      }, i.prototype.findHover = function(t3, c3, p3) {
        for (var g3 = this.storage.getDisplayList(), b3 = new lw(t3, c3), w3 = g3.length - 1; w3 >= 0; w3--) {
          var M = void 0;
          if (g3[w3] !== p3 && !g3[w3].ignore && (M = vi(g3[w3], t3, c3)) && (!b3.topTarget && (b3.topTarget = g3[w3]), M !== uQ)) {
            b3.target = g3[w3];
            break;
          }
        }
        return b3;
      }, i.prototype.processGesture = function(t3, c3) {
        this._gestureMgr || (this._gestureMgr = new S5());
        var p3 = this._gestureMgr;
        c3 === "start" && p3.clear();
        var g3 = p3.recognize(t3, this.findHover(t3.zrX, t3.zrY, null).target, this.proxy.dom);
        if (c3 === "end" && p3.clear(), g3) {
          var b3 = g3.type;
          t3.gestureEvent = b3;
          var w3 = new lw();
          w3.target = g3.target, this.dispatchToElement(w3, b3, g3.event);
        }
      }, i;
    }(hm);
    yt(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(o) {
      Wi.prototype[o] = function(i) {
        var t3 = i.zrX, c3 = i.zrY, p3 = Ko(this, t3, c3), g3, b3;
        if ((o !== "mouseup" || !p3) && (g3 = this.findHover(t3, c3), b3 = g3.target), o === "mousedown")
          this._downEl = b3, this._downPoint = [i.zrX, i.zrY], this._upEl = b3;
        else if (o === "mouseup")
          this._upEl = b3;
        else if (o === "click") {
          if (this._downEl !== this._upEl || !this._downPoint || P2(this._downPoint, [i.zrX, i.zrY]) > 4)
            return;
          this._downPoint = null;
        }
        this.dispatchToElement(g3, o, i);
      };
    });
    function vi(o, i, t3) {
      if (o[o.rectHover ? "rectContain" : "contain"](i, t3)) {
        for (var c3 = o, p3 = void 0, g3 = false; c3; ) {
          if (c3.ignoreClip && (g3 = true), !g3) {
            var b3 = c3.getClipPath();
            if (b3 && !b3.contain(i, t3))
              return false;
            c3.silent && (p3 = true);
          }
          var w3 = c3.__hostTarget;
          c3 = w3 || c3.parent;
        }
        return p3 ? uQ : true;
      }
      return false;
    }
    function Ko(o, i, t3) {
      var c3 = o.painter;
      return i < 0 || i > c3.getWidth() || t3 < 0 || t3 > c3.getHeight();
    }
    var Hl = Wi, cf = 32, Bp = 7;
    function vh(o) {
      for (var i = 0; o >= cf; )
        i |= o & 1, o >>= 1;
      return o + i;
    }
    function fF(o, i, t3, c3) {
      var p3 = i + 1;
      if (p3 === t3)
        return 1;
      if (c3(o[p3++], o[i]) < 0) {
        for (; p3 < t3 && c3(o[p3], o[p3 - 1]) < 0; )
          p3++;
        Kpe(o, i, p3);
      } else
        for (; p3 < t3 && c3(o[p3], o[p3 - 1]) >= 0; )
          p3++;
      return p3 - i;
    }
    function Kpe(o, i, t3) {
      for (t3--; i < t3; ) {
        var c3 = o[i];
        o[i++] = o[t3], o[t3--] = c3;
      }
    }
    function T1(o, i, t3, c3, p3) {
      for (c3 === i && c3++; c3 < t3; c3++) {
        for (var g3 = o[c3], b3 = i, w3 = c3, M; b3 < w3; )
          M = b3 + w3 >>> 1, p3(g3, o[M]) < 0 ? w3 = M : b3 = M + 1;
        var I = c3 - b3;
        switch (I) {
          case 3:
            o[b3 + 3] = o[b3 + 2];
          case 2:
            o[b3 + 2] = o[b3 + 1];
          case 1:
            o[b3 + 1] = o[b3];
            break;
          default:
            for (; I > 0; )
              o[b3 + I] = o[b3 + I - 1], I--;
        }
        o[b3] = g3;
      }
    }
    function C5(o, i, t3, c3, p3, g3) {
      var b3 = 0, w3 = 0, M = 1;
      if (g3(o, i[t3 + p3]) > 0) {
        for (w3 = c3 - p3; M < w3 && g3(o, i[t3 + p3 + M]) > 0; )
          b3 = M, M = (M << 1) + 1, M <= 0 && (M = w3);
        M > w3 && (M = w3), b3 += p3, M += p3;
      } else {
        for (w3 = p3 + 1; M < w3 && g3(o, i[t3 + p3 - M]) <= 0; )
          b3 = M, M = (M << 1) + 1, M <= 0 && (M = w3);
        M > w3 && (M = w3);
        var I = b3;
        b3 = p3 - M, M = p3 - I;
      }
      for (b3++; b3 < M; ) {
        var k3 = b3 + (M - b3 >>> 1);
        g3(o, i[t3 + k3]) > 0 ? b3 = k3 + 1 : M = k3;
      }
      return M;
    }
    function Zj(o, i, t3, c3, p3, g3) {
      var b3 = 0, w3 = 0, M = 1;
      if (g3(o, i[t3 + p3]) < 0) {
        for (w3 = p3 + 1; M < w3 && g3(o, i[t3 + p3 - M]) < 0; )
          b3 = M, M = (M << 1) + 1, M <= 0 && (M = w3);
        M > w3 && (M = w3);
        var I = b3;
        b3 = p3 - M, M = p3 - I;
      } else {
        for (w3 = c3 - p3; M < w3 && g3(o, i[t3 + p3 + M]) >= 0; )
          b3 = M, M = (M << 1) + 1, M <= 0 && (M = w3);
        M > w3 && (M = w3), b3 += p3, M += p3;
      }
      for (b3++; b3 < M; ) {
        var k3 = b3 + (M - b3 >>> 1);
        g3(o, i[t3 + k3]) < 0 ? M = k3 : b3 = k3 + 1;
      }
      return M;
    }
    function M5(o, i) {
      var t3 = Bp, c3, p3, g3 = 0, b3 = [];
      c3 = [], p3 = [];
      function w3(B, G) {
        c3[g3] = B, p3[g3] = G, g3 += 1;
      }
      function M() {
        for (; g3 > 1; ) {
          var B = g3 - 2;
          if (B >= 1 && p3[B - 1] <= p3[B] + p3[B + 1] || B >= 2 && p3[B - 2] <= p3[B] + p3[B - 1])
            p3[B - 1] < p3[B + 1] && B--;
          else if (p3[B] > p3[B + 1])
            break;
          k3(B);
        }
      }
      function I() {
        for (; g3 > 1; ) {
          var B = g3 - 2;
          B > 0 && p3[B - 1] < p3[B + 1] && B--, k3(B);
        }
      }
      function k3(B) {
        var G = c3[B], J = p3[B], Q = c3[B + 1], se = p3[B + 1];
        p3[B] = J + se, B === g3 - 3 && (c3[B + 1] = c3[B + 2], p3[B + 1] = p3[B + 2]), g3--;
        var he = Zj(o[Q], o, G, J, 0, i);
        G += he, J -= he, J !== 0 && (se = C5(o[G + J - 1], o, Q, se, se - 1, i), se !== 0 && (J <= se ? L(G, J, Q, se) : F(G, J, Q, se)));
      }
      function L(B, G, J, Q) {
        var se = 0;
        for (se = 0; se < G; se++)
          b3[se] = o[B + se];
        var he = 0, be = J, de = B;
        if (o[de++] = o[be++], --Q === 0) {
          for (se = 0; se < G; se++)
            o[de + se] = b3[he + se];
          return;
        }
        if (G === 1) {
          for (se = 0; se < Q; se++)
            o[de + se] = o[be + se];
          o[de + Q] = b3[he];
          return;
        }
        for (var Fe = t3, Pe, ze, $e; ; ) {
          Pe = 0, ze = 0, $e = false;
          do
            if (i(o[be], b3[he]) < 0) {
              if (o[de++] = o[be++], ze++, Pe = 0, --Q === 0) {
                $e = true;
                break;
              }
            } else if (o[de++] = b3[he++], Pe++, ze = 0, --G === 1) {
              $e = true;
              break;
            }
          while ((Pe | ze) < Fe);
          if ($e)
            break;
          do {
            if (Pe = Zj(o[be], b3, he, G, 0, i), Pe !== 0) {
              for (se = 0; se < Pe; se++)
                o[de + se] = b3[he + se];
              if (de += Pe, he += Pe, G -= Pe, G <= 1) {
                $e = true;
                break;
              }
            }
            if (o[de++] = o[be++], --Q === 0) {
              $e = true;
              break;
            }
            if (ze = C5(b3[he], o, be, Q, 0, i), ze !== 0) {
              for (se = 0; se < ze; se++)
                o[de + se] = o[be + se];
              if (de += ze, be += ze, Q -= ze, Q === 0) {
                $e = true;
                break;
              }
            }
            if (o[de++] = b3[he++], --G === 1) {
              $e = true;
              break;
            }
            Fe--;
          } while (Pe >= Bp || ze >= Bp);
          if ($e)
            break;
          Fe < 0 && (Fe = 0), Fe += 2;
        }
        if (t3 = Fe, t3 < 1 && (t3 = 1), G === 1) {
          for (se = 0; se < Q; se++)
            o[de + se] = o[be + se];
          o[de + Q] = b3[he];
        } else {
          if (G === 0)
            throw new Error();
          for (se = 0; se < G; se++)
            o[de + se] = b3[he + se];
        }
      }
      function F(B, G, J, Q) {
        var se = 0;
        for (se = 0; se < Q; se++)
          b3[se] = o[J + se];
        var he = B + G - 1, be = Q - 1, de = J + Q - 1, Fe = 0, Pe = 0;
        if (o[de--] = o[he--], --G === 0) {
          for (Fe = de - (Q - 1), se = 0; se < Q; se++)
            o[Fe + se] = b3[se];
          return;
        }
        if (Q === 1) {
          for (de -= G, he -= G, Pe = de + 1, Fe = he + 1, se = G - 1; se >= 0; se--)
            o[Pe + se] = o[Fe + se];
          o[de] = b3[be];
          return;
        }
        for (var ze = t3; ; ) {
          var $e = 0, Ke = 0, nt = false;
          do
            if (i(b3[be], o[he]) < 0) {
              if (o[de--] = o[he--], $e++, Ke = 0, --G === 0) {
                nt = true;
                break;
              }
            } else if (o[de--] = b3[be--], Ke++, $e = 0, --Q === 1) {
              nt = true;
              break;
            }
          while (($e | Ke) < ze);
          if (nt)
            break;
          do {
            if ($e = G - Zj(b3[be], o, B, G, G - 1, i), $e !== 0) {
              for (de -= $e, he -= $e, G -= $e, Pe = de + 1, Fe = he + 1, se = $e - 1; se >= 0; se--)
                o[Pe + se] = o[Fe + se];
              if (G === 0) {
                nt = true;
                break;
              }
            }
            if (o[de--] = b3[be--], --Q === 1) {
              nt = true;
              break;
            }
            if (Ke = Q - C5(o[he], b3, 0, Q, Q - 1, i), Ke !== 0) {
              for (de -= Ke, be -= Ke, Q -= Ke, Pe = de + 1, Fe = be + 1, se = 0; se < Ke; se++)
                o[Pe + se] = b3[Fe + se];
              if (Q <= 1) {
                nt = true;
                break;
              }
            }
            if (o[de--] = o[he--], --G === 0) {
              nt = true;
              break;
            }
            ze--;
          } while ($e >= Bp || Ke >= Bp);
          if (nt)
            break;
          ze < 0 && (ze = 0), ze += 2;
        }
        if (t3 = ze, t3 < 1 && (t3 = 1), Q === 1) {
          for (de -= G, he -= G, Pe = de + 1, Fe = he + 1, se = G - 1; se >= 0; se--)
            o[Pe + se] = o[Fe + se];
          o[de] = b3[be];
        } else {
          if (Q === 0)
            throw new Error();
          for (Fe = de - (Q - 1), se = 0; se < Q; se++)
            o[Fe + se] = b3[se];
        }
      }
      return { mergeRuns: M, forceMergeRuns: I, pushRun: w3 };
    }
    function tI(o, i, t3, c3) {
      t3 || (t3 = 0), c3 || (c3 = o.length);
      var p3 = c3 - t3;
      if (!(p3 < 2)) {
        var g3 = 0;
        if (p3 < cf) {
          g3 = fF(o, t3, c3, i), T1(o, t3, c3, t3 + g3, i);
          return;
        }
        var b3 = M5(o, i), w3 = vh(p3);
        do {
          if (g3 = fF(o, t3, c3, i), g3 < w3) {
            var M = p3;
            M > w3 && (M = w3), T1(o, t3, t3 + M, t3 + g3, i), g3 = M;
          }
          b3.pushRun(t3, g3), b3.mergeRuns(), p3 -= g3, t3 += g3;
        } while (p3 !== 0);
        b3.forceMergeRuns();
      }
    }
    var c0 = 1, Jc = 2, T5 = 4, Jj = false;
    function A5() {
      Jj || (Jj = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
    }
    function cQ(o, i) {
      return o.zlevel === i.zlevel ? o.z === i.z ? o.z2 - i.z2 : o.z - i.z : o.zlevel - i.zlevel;
    }
    var Zpe = function() {
      function o() {
        this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = cQ;
      }
      return o.prototype.traverse = function(i, t3) {
        for (var c3 = 0; c3 < this._roots.length; c3++)
          this._roots[c3].traverse(i, t3);
      }, o.prototype.getDisplayList = function(i, t3) {
        t3 = t3 || false;
        var c3 = this._displayList;
        return (i || !c3.length) && this.updateDisplayList(t3), c3;
      }, o.prototype.updateDisplayList = function(i) {
        this._displayListLen = 0;
        for (var t3 = this._roots, c3 = this._displayList, p3 = 0, g3 = t3.length; p3 < g3; p3++)
          this._updateAndAddDisplayable(t3[p3], null, i);
        c3.length = this._displayListLen, tI(c3, cQ);
      }, o.prototype._updateAndAddDisplayable = function(i, t3, c3) {
        if (!(i.ignore && !c3)) {
          i.beforeUpdate(), i.update(), i.afterUpdate();
          var p3 = i.getClipPath();
          if (i.ignoreClip)
            t3 = null;
          else if (p3) {
            t3 ? t3 = t3.slice() : t3 = [];
            for (var g3 = p3, b3 = i; g3; )
              g3.parent = b3, g3.updateTransform(), t3.push(g3), b3 = g3, g3 = g3.getClipPath();
          }
          if (i.childrenRef) {
            for (var w3 = i.childrenRef(), M = 0; M < w3.length; M++) {
              var I = w3[M];
              i.__dirty && (I.__dirty |= c0), this._updateAndAddDisplayable(I, t3, c3);
            }
            i.__dirty = 0;
          } else {
            var k3 = i;
            t3 && t3.length ? k3.__clipPaths = t3 : k3.__clipPaths && k3.__clipPaths.length > 0 && (k3.__clipPaths = []), isNaN(k3.z) && (A5(), k3.z = 0), isNaN(k3.z2) && (A5(), k3.z2 = 0), isNaN(k3.zlevel) && (A5(), k3.zlevel = 0), this._displayList[this._displayListLen++] = k3;
          }
          var L = i.getDecalElement && i.getDecalElement();
          L && this._updateAndAddDisplayable(L, t3, c3);
          var F = i.getTextGuideLine();
          F && this._updateAndAddDisplayable(F, t3, c3);
          var B = i.getTextContent();
          B && this._updateAndAddDisplayable(B, t3, c3);
        }
      }, o.prototype.addRoot = function(i) {
        i.__zr && i.__zr.storage === this || this._roots.push(i);
      }, o.prototype.delRoot = function(i) {
        if (i instanceof Array) {
          for (var t3 = 0, c3 = i.length; t3 < c3; t3++)
            this.delRoot(i[t3]);
          return;
        }
        var p3 = rl(this._roots, i);
        p3 >= 0 && this._roots.splice(p3, 1);
      }, o.prototype.delAllRoots = function() {
        this._roots = [], this._displayList = [], this._displayListLen = 0;
      }, o.prototype.getRoots = function() {
        return this._roots;
      }, o.prototype.dispose = function() {
        this._displayList = null, this._roots = null;
      }, o;
    }(), Jpe = Zpe, bP;
    bP = yo.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(o) {
      return setTimeout(o, 16);
    };
    var uw = bP, nI = { linear: function(o) {
      return o;
    }, quadraticIn: function(o) {
      return o * o;
    }, quadraticOut: function(o) {
      return o * (2 - o);
    }, quadraticInOut: function(o) {
      return (o *= 2) < 1 ? 0.5 * o * o : -0.5 * (--o * (o - 2) - 1);
    }, cubicIn: function(o) {
      return o * o * o;
    }, cubicOut: function(o) {
      return --o * o * o + 1;
    }, cubicInOut: function(o) {
      return (o *= 2) < 1 ? 0.5 * o * o * o : 0.5 * ((o -= 2) * o * o + 2);
    }, quarticIn: function(o) {
      return o * o * o * o;
    }, quarticOut: function(o) {
      return 1 - --o * o * o * o;
    }, quarticInOut: function(o) {
      return (o *= 2) < 1 ? 0.5 * o * o * o * o : -0.5 * ((o -= 2) * o * o * o - 2);
    }, quinticIn: function(o) {
      return o * o * o * o * o;
    }, quinticOut: function(o) {
      return --o * o * o * o * o + 1;
    }, quinticInOut: function(o) {
      return (o *= 2) < 1 ? 0.5 * o * o * o * o * o : 0.5 * ((o -= 2) * o * o * o * o + 2);
    }, sinusoidalIn: function(o) {
      return 1 - Math.cos(o * Math.PI / 2);
    }, sinusoidalOut: function(o) {
      return Math.sin(o * Math.PI / 2);
    }, sinusoidalInOut: function(o) {
      return 0.5 * (1 - Math.cos(Math.PI * o));
    }, exponentialIn: function(o) {
      return o === 0 ? 0 : Math.pow(1024, o - 1);
    }, exponentialOut: function(o) {
      return o === 1 ? 1 : 1 - Math.pow(2, -10 * o);
    }, exponentialInOut: function(o) {
      return o === 0 ? 0 : o === 1 ? 1 : (o *= 2) < 1 ? 0.5 * Math.pow(1024, o - 1) : 0.5 * (-Math.pow(2, -10 * (o - 1)) + 2);
    }, circularIn: function(o) {
      return 1 - Math.sqrt(1 - o * o);
    }, circularOut: function(o) {
      return Math.sqrt(1 - --o * o);
    }, circularInOut: function(o) {
      return (o *= 2) < 1 ? -0.5 * (Math.sqrt(1 - o * o) - 1) : 0.5 * (Math.sqrt(1 - (o -= 2) * o) + 1);
    }, elasticIn: function(o) {
      var i, t3 = 0.1, c3 = 0.4;
      return o === 0 ? 0 : o === 1 ? 1 : (!t3 || t3 < 1 ? (t3 = 1, i = c3 / 4) : i = c3 * Math.asin(1 / t3) / (2 * Math.PI), -(t3 * Math.pow(2, 10 * (o -= 1)) * Math.sin((o - i) * (2 * Math.PI) / c3)));
    }, elasticOut: function(o) {
      var i, t3 = 0.1, c3 = 0.4;
      return o === 0 ? 0 : o === 1 ? 1 : (!t3 || t3 < 1 ? (t3 = 1, i = c3 / 4) : i = c3 * Math.asin(1 / t3) / (2 * Math.PI), t3 * Math.pow(2, -10 * o) * Math.sin((o - i) * (2 * Math.PI) / c3) + 1);
    }, elasticInOut: function(o) {
      var i, t3 = 0.1, c3 = 0.4;
      return o === 0 ? 0 : o === 1 ? 1 : (!t3 || t3 < 1 ? (t3 = 1, i = c3 / 4) : i = c3 * Math.asin(1 / t3) / (2 * Math.PI), (o *= 2) < 1 ? -0.5 * (t3 * Math.pow(2, 10 * (o -= 1)) * Math.sin((o - i) * (2 * Math.PI) / c3)) : t3 * Math.pow(2, -10 * (o -= 1)) * Math.sin((o - i) * (2 * Math.PI) / c3) * 0.5 + 1);
    }, backIn: function(o) {
      var i = 1.70158;
      return o * o * ((i + 1) * o - i);
    }, backOut: function(o) {
      var i = 1.70158;
      return --o * o * ((i + 1) * o + i) + 1;
    }, backInOut: function(o) {
      var i = 2.5949095;
      return (o *= 2) < 1 ? 0.5 * (o * o * ((i + 1) * o - i)) : 0.5 * ((o -= 2) * o * ((i + 1) * o + i) + 2);
    }, bounceIn: function(o) {
      return 1 - nI.bounceOut(1 - o);
    }, bounceOut: function(o) {
      return o < 1 / 2.75 ? 7.5625 * o * o : o < 2 / 2.75 ? 7.5625 * (o -= 1.5 / 2.75) * o + 0.75 : o < 2.5 / 2.75 ? 7.5625 * (o -= 2.25 / 2.75) * o + 0.9375 : 7.5625 * (o -= 2.625 / 2.75) * o + 0.984375;
    }, bounceInOut: function(o) {
      return o < 0.5 ? nI.bounceIn(o * 2) * 0.5 : nI.bounceOut(o * 2 - 1) * 0.5 + 0.5;
    } }, Qj = nI, rI = Math.pow, N2 = Math.sqrt, _P = 1e-8, xP = 1e-4, eG = N2(3), MM = 1 / 3, f0 = wM(), uy = wM(), I5 = wM();
    function TM(o) {
      return o > -_P && o < _P;
    }
    function fQ(o) {
      return o > _P || o < -_P;
    }
    function Jp(o, i, t3, c3, p3) {
      var g3 = 1 - p3;
      return g3 * g3 * (g3 * o + 3 * p3 * i) + p3 * p3 * (p3 * c3 + 3 * g3 * t3);
    }
    function wP(o, i, t3, c3, p3) {
      var g3 = 1 - p3;
      return 3 * (((i - o) * g3 + 2 * (t3 - i) * p3) * g3 + (c3 - t3) * p3 * p3);
    }
    function E5(o, i, t3, c3, p3, g3) {
      var b3 = c3 + 3 * (i - t3) - o, w3 = 3 * (t3 - i * 2 + o), M = 3 * (i - o), I = o - p3, k3 = w3 * w3 - 3 * b3 * M, L = w3 * M - 9 * b3 * I, F = M * M - 3 * w3 * I, B = 0;
      if (TM(k3) && TM(L))
        if (TM(w3))
          g3[0] = 0;
        else {
          var G = -M / w3;
          G >= 0 && G <= 1 && (g3[B++] = G);
        }
      else {
        var J = L * L - 4 * k3 * F;
        if (TM(J)) {
          var Q = L / k3, G = -w3 / b3 + Q, se = -Q / 2;
          G >= 0 && G <= 1 && (g3[B++] = G), se >= 0 && se <= 1 && (g3[B++] = se);
        } else if (J > 0) {
          var he = N2(J), be = k3 * w3 + 1.5 * b3 * (-L + he), de = k3 * w3 + 1.5 * b3 * (-L - he);
          be < 0 ? be = -rI(-be, MM) : be = rI(be, MM), de < 0 ? de = -rI(-de, MM) : de = rI(de, MM);
          var G = (-w3 - (be + de)) / (3 * b3);
          G >= 0 && G <= 1 && (g3[B++] = G);
        } else {
          var Fe = (2 * k3 * w3 - 3 * b3 * L) / (2 * N2(k3 * k3 * k3)), Pe = Math.acos(Fe) / 3, ze = N2(k3), $e = Math.cos(Pe), G = (-w3 - 2 * ze * $e) / (3 * b3), se = (-w3 + ze * ($e + eG * Math.sin(Pe))) / (3 * b3), Ke = (-w3 + ze * ($e - eG * Math.sin(Pe))) / (3 * b3);
          G >= 0 && G <= 1 && (g3[B++] = G), se >= 0 && se <= 1 && (g3[B++] = se), Ke >= 0 && Ke <= 1 && (g3[B++] = Ke);
        }
      }
      return B;
    }
    function hQ(o, i, t3, c3, p3) {
      var g3 = 6 * t3 - 12 * i + 6 * o, b3 = 9 * i + 3 * c3 - 3 * o - 9 * t3, w3 = 3 * i - 3 * o, M = 0;
      if (TM(b3)) {
        if (fQ(g3)) {
          var I = -w3 / g3;
          I >= 0 && I <= 1 && (p3[M++] = I);
        }
      } else {
        var k3 = g3 * g3 - 4 * b3 * w3;
        if (TM(k3))
          p3[0] = -g3 / (2 * b3);
        else if (k3 > 0) {
          var L = N2(k3), I = (-g3 + L) / (2 * b3), F = (-g3 - L) / (2 * b3);
          I >= 0 && I <= 1 && (p3[M++] = I), F >= 0 && F <= 1 && (p3[M++] = F);
        }
      }
      return M;
    }
    function F2(o, i, t3, c3, p3, g3) {
      var b3 = (i - o) * p3 + o, w3 = (t3 - i) * p3 + i, M = (c3 - t3) * p3 + t3, I = (w3 - b3) * p3 + b3, k3 = (M - w3) * p3 + w3, L = (k3 - I) * p3 + I;
      g3[0] = o, g3[1] = b3, g3[2] = I, g3[3] = L, g3[4] = L, g3[5] = k3, g3[6] = M, g3[7] = c3;
    }
    function pQ(o, i, t3, c3, p3, g3, b3, w3, M, I, k3) {
      var L, F = 5e-3, B = 1 / 0, G, J, Q, se;
      f0[0] = M, f0[1] = I;
      for (var he = 0; he < 1; he += 0.05)
        uy[0] = Jp(o, t3, p3, b3, he), uy[1] = Jp(i, c3, g3, w3, he), Q = Sb(f0, uy), Q < B && (L = he, B = Q);
      B = 1 / 0;
      for (var be = 0; be < 32 && !(F < xP); be++)
        G = L - F, J = L + F, uy[0] = Jp(o, t3, p3, b3, G), uy[1] = Jp(i, c3, g3, w3, G), Q = Sb(uy, f0), G >= 0 && Q < B ? (L = G, B = Q) : (I5[0] = Jp(o, t3, p3, b3, J), I5[1] = Jp(i, c3, g3, w3, J), se = Sb(I5, f0), J <= 1 && se < B ? (L = J, B = se) : F *= 0.5);
      return k3 && (k3[0] = Jp(o, t3, p3, b3, L), k3[1] = Jp(i, c3, g3, w3, L)), N2(B);
    }
    function Qpe(o, i, t3, c3, p3, g3, b3, w3, M) {
      for (var I = o, k3 = i, L = 0, F = 1 / M, B = 1; B <= M; B++) {
        var G = B * F, J = Jp(o, t3, p3, b3, G), Q = Jp(i, c3, g3, w3, G), se = J - I, he = Q - k3;
        L += Math.sqrt(se * se + he * he), I = J, k3 = Q;
      }
      return L;
    }
    function Dc(o, i, t3, c3) {
      var p3 = 1 - c3;
      return p3 * (p3 * o + 2 * c3 * i) + c3 * c3 * t3;
    }
    function Bv(o, i, t3, c3) {
      return 2 * ((1 - c3) * (i - o) + c3 * (t3 - i));
    }
    function ede(o, i, t3, c3, p3) {
      var g3 = o - 2 * i + t3, b3 = 2 * (i - o), w3 = o - c3, M = 0;
      if (TM(g3)) {
        if (fQ(b3)) {
          var I = -w3 / b3;
          I >= 0 && I <= 1 && (p3[M++] = I);
        }
      } else {
        var k3 = b3 * b3 - 4 * g3 * w3;
        if (TM(k3)) {
          var I = -b3 / (2 * g3);
          I >= 0 && I <= 1 && (p3[M++] = I);
        } else if (k3 > 0) {
          var L = N2(k3), I = (-b3 + L) / (2 * g3), F = (-b3 - L) / (2 * g3);
          I >= 0 && I <= 1 && (p3[M++] = I), F >= 0 && F <= 1 && (p3[M++] = F);
        }
      }
      return M;
    }
    function dQ(o, i, t3) {
      var c3 = o + t3 - 2 * i;
      return c3 === 0 ? 0.5 : (o - i) / c3;
    }
    function D5(o, i, t3, c3, p3) {
      var g3 = (i - o) * c3 + o, b3 = (t3 - i) * c3 + i, w3 = (b3 - g3) * c3 + g3;
      p3[0] = o, p3[1] = g3, p3[2] = w3, p3[3] = w3, p3[4] = b3, p3[5] = t3;
    }
    function vQ(o, i, t3, c3, p3, g3, b3, w3, M) {
      var I, k3 = 5e-3, L = 1 / 0;
      f0[0] = b3, f0[1] = w3;
      for (var F = 0; F < 1; F += 0.05) {
        uy[0] = Dc(o, t3, p3, F), uy[1] = Dc(i, c3, g3, F);
        var B = Sb(f0, uy);
        B < L && (I = F, L = B);
      }
      L = 1 / 0;
      for (var G = 0; G < 32 && !(k3 < xP); G++) {
        var J = I - k3, Q = I + k3;
        uy[0] = Dc(o, t3, p3, J), uy[1] = Dc(i, c3, g3, J);
        var B = Sb(uy, f0);
        if (J >= 0 && B < L)
          I = J, L = B;
        else {
          I5[0] = Dc(o, t3, p3, Q), I5[1] = Dc(i, c3, g3, Q);
          var se = Sb(I5, f0);
          Q <= 1 && se < L ? (I = Q, L = se) : k3 *= 0.5;
        }
      }
      return M && (M[0] = Dc(o, t3, p3, I), M[1] = Dc(i, c3, g3, I)), N2(L);
    }
    function tG(o, i, t3, c3, p3, g3, b3) {
      for (var w3 = o, M = i, I = 0, k3 = 1 / b3, L = 1; L <= b3; L++) {
        var F = L * k3, B = Dc(o, t3, p3, F), G = Dc(i, c3, g3, F), J = B - w3, Q = G - M;
        I += Math.sqrt(J * J + Q * Q), w3 = B, M = G;
      }
      return I;
    }
    var SP = /cubic-bezier\(([0-9,\.e ]+)\)/;
    function CP(o) {
      var i = o && SP.exec(o);
      if (i) {
        var t3 = i[1].split(","), c3 = +S1(t3[0]), p3 = +S1(t3[1]), g3 = +S1(t3[2]), b3 = +S1(t3[3]);
        if (isNaN(c3 + p3 + g3 + b3))
          return;
        var w3 = [];
        return function(M) {
          return M <= 0 ? 0 : M >= 1 ? 1 : E5(0, c3, g3, 1, M, w3) && Jp(0, p3, b3, 1, w3[0]);
        };
      }
    }
    var k5 = function() {
      function o(i) {
        this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = i.life || 1e3, this._delay = i.delay || 0, this.loop = i.loop || false, this.onframe = i.onframe || uf, this.ondestroy = i.ondestroy || uf, this.onrestart = i.onrestart || uf, i.easing && this.setEasing(i.easing);
      }
      return o.prototype.step = function(i, t3) {
        if (this._inited || (this._startTime = i + this._delay, this._inited = true), this._paused) {
          this._pausedTime += t3;
          return;
        }
        var c3 = this._life, p3 = i - this._startTime - this._pausedTime, g3 = p3 / c3;
        g3 < 0 && (g3 = 0), g3 = Math.min(g3, 1);
        var b3 = this.easingFunc, w3 = b3 ? b3(g3) : g3;
        if (this.onframe(w3), g3 === 1)
          if (this.loop) {
            var M = p3 % c3;
            this._startTime = i - M, this._pausedTime = 0, this.onrestart();
          } else
            return true;
        return false;
      }, o.prototype.pause = function() {
        this._paused = true;
      }, o.prototype.resume = function() {
        this._paused = false;
      }, o.prototype.setEasing = function(i) {
        this.easing = i, this.easingFunc = Vo(i) ? i : Qj[i] || CP(i);
      }, o;
    }(), MP = k5, O5 = function() {
      function o(i) {
        this.value = i;
      }
      return o;
    }(), hF = function() {
      function o() {
        this._len = 0;
      }
      return o.prototype.insert = function(i) {
        var t3 = new O5(i);
        return this.insertEntry(t3), t3;
      }, o.prototype.insertEntry = function(i) {
        this.head ? (this.tail.next = i, i.prev = this.tail, i.next = null, this.tail = i) : this.head = this.tail = i, this._len++;
      }, o.prototype.remove = function(i) {
        var t3 = i.prev, c3 = i.next;
        t3 ? t3.next = c3 : this.head = c3, c3 ? c3.prev = t3 : this.tail = t3, i.next = i.prev = null, this._len--;
      }, o.prototype.len = function() {
        return this._len;
      }, o.prototype.clear = function() {
        this.head = this.tail = null, this._len = 0;
      }, o;
    }(), P5 = function() {
      function o(i) {
        this._list = new hF(), this._maxSize = 10, this._map = {}, this._maxSize = i;
      }
      return o.prototype.put = function(i, t3) {
        var c3 = this._list, p3 = this._map, g3 = null;
        if (p3[i] == null) {
          var b3 = c3.len(), w3 = this._lastRemovedEntry;
          if (b3 >= this._maxSize && b3 > 0) {
            var M = c3.head;
            c3.remove(M), delete p3[M.key], g3 = M.value, this._lastRemovedEntry = M;
          }
          w3 ? w3.value = t3 : w3 = new O5(t3), w3.key = i, c3.insertEntry(w3), p3[i] = w3;
        }
        return g3;
      }, o.prototype.get = function(i) {
        var t3 = this._map[i], c3 = this._list;
        if (t3 != null)
          return t3 !== c3.tail && (c3.remove(t3), c3.insertEntry(t3)), t3.value;
      }, o.prototype.clear = function() {
        this._list.clear(), this._map = {};
      }, o.prototype.len = function() {
        return this._list.len();
      }, o;
    }(), TP = P5, gQ = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
    function I_(o) {
      return o = Math.round(o), o < 0 ? 0 : o > 255 ? 255 : o;
    }
    function tde(o) {
      return o = Math.round(o), o < 0 ? 0 : o > 360 ? 360 : o;
    }
    function AP(o) {
      return o < 0 ? 0 : o > 1 ? 1 : o;
    }
    function L5(o) {
      var i = o;
      return i.length && i.charAt(i.length - 1) === "%" ? I_(parseFloat(i) / 100 * 255) : I_(parseInt(i, 10));
    }
    function cw(o) {
      var i = o;
      return i.length && i.charAt(i.length - 1) === "%" ? AP(parseFloat(i) / 100) : AP(parseFloat(i));
    }
    function pF(o, i, t3) {
      return t3 < 0 ? t3 += 1 : t3 > 1 && (t3 -= 1), t3 * 6 < 1 ? o + (i - o) * t3 * 6 : t3 * 2 < 1 ? i : t3 * 3 < 2 ? o + (i - o) * (2 / 3 - t3) * 6 : o;
    }
    function Ht(o, i, t3) {
      return o + (i - o) * t3;
    }
    function mg(o, i, t3, c3, p3) {
      return o[0] = i, o[1] = t3, o[2] = c3, o[3] = p3, o;
    }
    function R5(o, i) {
      return o[0] = i[0], o[1] = i[1], o[2] = i[2], o[3] = i[3], o;
    }
    var A1 = new TP(20), Ru = null;
    function N5(o, i) {
      Ru && R5(Ru, i), Ru = A1.put(o, Ru || i.slice());
    }
    function I1(o, i) {
      if (o) {
        i = i || [];
        var t3 = A1.get(o);
        if (t3)
          return R5(i, t3);
        o = o + "";
        var c3 = o.replace(/ /g, "").toLowerCase();
        if (c3 in gQ)
          return R5(i, gQ[c3]), N5(o, i), i;
        var p3 = c3.length;
        if (c3.charAt(0) === "#") {
          if (p3 === 4 || p3 === 5) {
            var g3 = parseInt(c3.slice(1, 4), 16);
            if (!(g3 >= 0 && g3 <= 4095)) {
              mg(i, 0, 0, 0, 1);
              return;
            }
            return mg(i, (g3 & 3840) >> 4 | (g3 & 3840) >> 8, g3 & 240 | (g3 & 240) >> 4, g3 & 15 | (g3 & 15) << 4, p3 === 5 ? parseInt(c3.slice(4), 16) / 15 : 1), N5(o, i), i;
          } else if (p3 === 7 || p3 === 9) {
            var g3 = parseInt(c3.slice(1, 7), 16);
            if (!(g3 >= 0 && g3 <= 16777215)) {
              mg(i, 0, 0, 0, 1);
              return;
            }
            return mg(i, (g3 & 16711680) >> 16, (g3 & 65280) >> 8, g3 & 255, p3 === 9 ? parseInt(c3.slice(7), 16) / 255 : 1), N5(o, i), i;
          }
          return;
        }
        var b3 = c3.indexOf("("), w3 = c3.indexOf(")");
        if (b3 !== -1 && w3 + 1 === p3) {
          var M = c3.substr(0, b3), I = c3.substr(b3 + 1, w3 - (b3 + 1)).split(","), k3 = 1;
          switch (M) {
            case "rgba":
              if (I.length !== 4)
                return I.length === 3 ? mg(i, +I[0], +I[1], +I[2], 1) : mg(i, 0, 0, 0, 1);
              k3 = cw(I.pop());
            case "rgb":
              if (I.length !== 3) {
                mg(i, 0, 0, 0, 1);
                return;
              }
              return mg(i, L5(I[0]), L5(I[1]), L5(I[2]), k3), N5(o, i), i;
            case "hsla":
              if (I.length !== 4) {
                mg(i, 0, 0, 0, 1);
                return;
              }
              return I[3] = cw(I[3]), nG(I, i), N5(o, i), i;
            case "hsl":
              if (I.length !== 3) {
                mg(i, 0, 0, 0, 1);
                return;
              }
              return nG(I, i), N5(o, i), i;
            default:
              return;
          }
        }
        mg(i, 0, 0, 0, 1);
      }
    }
    function nG(o, i) {
      var t3 = (parseFloat(o[0]) % 360 + 360) % 360 / 360, c3 = cw(o[1]), p3 = cw(o[2]), g3 = p3 <= 0.5 ? p3 * (c3 + 1) : p3 + c3 - p3 * c3, b3 = p3 * 2 - g3;
      return i = i || [], mg(i, I_(pF(b3, g3, t3 + 1 / 3) * 255), I_(pF(b3, g3, t3) * 255), I_(pF(b3, g3, t3 - 1 / 3) * 255), 1), o.length === 4 && (i[3] = o[3]), i;
    }
    function iI(o) {
      if (o) {
        var i = o[0] / 255, t3 = o[1] / 255, c3 = o[2] / 255, p3 = Math.min(i, t3, c3), g3 = Math.max(i, t3, c3), b3 = g3 - p3, w3 = (g3 + p3) / 2, M, I;
        if (b3 === 0)
          M = 0, I = 0;
        else {
          w3 < 0.5 ? I = b3 / (g3 + p3) : I = b3 / (2 - g3 - p3);
          var k3 = ((g3 - i) / 6 + b3 / 2) / b3, L = ((g3 - t3) / 6 + b3 / 2) / b3, F = ((g3 - c3) / 6 + b3 / 2) / b3;
          i === g3 ? M = F - L : t3 === g3 ? M = 1 / 3 + k3 - F : c3 === g3 && (M = 2 / 3 + L - k3), M < 0 && (M += 1), M > 1 && (M -= 1);
        }
        var B = [M * 360, I, w3];
        return o[3] != null && B.push(o[3]), B;
      }
    }
    function rG(o, i) {
      var t3 = I1(o);
      if (t3) {
        for (var c3 = 0; c3 < 3; c3++)
          i < 0 ? t3[c3] = t3[c3] * (1 - i) | 0 : t3[c3] = (255 - t3[c3]) * i + t3[c3] | 0, t3[c3] > 255 ? t3[c3] = 255 : t3[c3] < 0 && (t3[c3] = 0);
        return bg(t3, t3.length === 4 ? "rgba" : "rgb");
      }
    }
    function iG(o, i, t3) {
      if (!(!(i && i.length) || !(o >= 0 && o <= 1))) {
        t3 = t3 || [];
        var c3 = o * (i.length - 1), p3 = Math.floor(c3), g3 = Math.ceil(c3), b3 = i[p3], w3 = i[g3], M = c3 - p3;
        return t3[0] = I_(Ht(b3[0], w3[0], M)), t3[1] = I_(Ht(b3[1], w3[1], M)), t3[2] = I_(Ht(b3[2], w3[2], M)), t3[3] = AP(Ht(b3[3], w3[3], M)), t3;
      }
    }
    function nde(o, i, t3) {
      if (!(!(i && i.length) || !(o >= 0 && o <= 1))) {
        var c3 = o * (i.length - 1), p3 = Math.floor(c3), g3 = Math.ceil(c3), b3 = I1(i[p3]), w3 = I1(i[g3]), M = c3 - p3, I = bg([I_(Ht(b3[0], w3[0], M)), I_(Ht(b3[1], w3[1], M)), I_(Ht(b3[2], w3[2], M)), AP(Ht(b3[3], w3[3], M))], "rgba");
        return t3 ? { color: I, leftIndex: p3, rightIndex: g3, value: c3 } : I;
      }
    }
    function IP(o, i, t3, c3) {
      var p3 = I1(o);
      if (o)
        return p3 = iI(p3), i != null && (p3[0] = tde(i)), t3 != null && (p3[1] = cw(t3)), c3 != null && (p3[2] = cw(c3)), bg(nG(p3), "rgba");
    }
    function dF(o, i) {
      var t3 = I1(o);
      if (t3 && i != null)
        return t3[3] = AP(i), bg(t3, "rgba");
    }
    function bg(o, i) {
      if (!(!o || !o.length)) {
        var t3 = o[0] + "," + o[1] + "," + o[2];
        return (i === "rgba" || i === "hsva" || i === "hsla") && (t3 += "," + o[3]), i + "(" + t3 + ")";
      }
    }
    function vF(o, i) {
      var t3 = I1(o);
      return t3 ? (0.299 * t3[0] + 0.587 * t3[1] + 0.114 * t3[2]) * t3[3] / 255 + (1 - t3[3]) * i : 0;
    }
    var gF = Math.round;
    function F5(o) {
      var i;
      if (!o || o === "transparent")
        o = "none";
      else if (typeof o == "string" && o.indexOf("rgba") > -1) {
        var t3 = I1(o);
        t3 && (o = "rgb(" + t3[0] + "," + t3[1] + "," + t3[2] + ")", i = t3[3]);
      }
      return { color: o, opacity: i == null ? 1 : i };
    }
    var yQ = 1e-4;
    function AM(o) {
      return o < yQ && o > -yQ;
    }
    function Mb(o) {
      return gF(o * 1e3) / 1e3;
    }
    function aG(o) {
      return gF(o * 1e4) / 1e4;
    }
    function rde(o) {
      return "matrix(" + Mb(o[0]) + "," + Mb(o[1]) + "," + Mb(o[2]) + "," + Mb(o[3]) + "," + aG(o[4]) + "," + aG(o[5]) + ")";
    }
    var ide = { left: "start", right: "end", center: "middle", middle: "middle" };
    function ade(o, i, t3) {
      return t3 === "top" ? o += i / 2 : t3 === "bottom" && (o -= i / 2), o;
    }
    function ode(o) {
      return o && (o.shadowBlur || o.shadowOffsetX || o.shadowOffsetY);
    }
    function aI(o) {
      var i = o.style, t3 = o.getGlobalScale();
      return [i.shadowColor, (i.shadowBlur || 0).toFixed(2), (i.shadowOffsetX || 0).toFixed(2), (i.shadowOffsetY || 0).toFixed(2), t3[0], t3[1]].join(",");
    }
    function mQ(o) {
      return o && !!o.image;
    }
    function sde(o) {
      return o && !!o.svgElement;
    }
    function E_(o) {
      return mQ(o) || sde(o);
    }
    function bQ(o) {
      return o.type === "linear";
    }
    function _Q(o) {
      return o.type === "radial";
    }
    function lde(o) {
      return o && (o.type === "linear" || o.type === "radial");
    }
    function yF(o) {
      return "url(#" + o + ")";
    }
    function xQ(o) {
      var i = o.getGlobalScale(), t3 = Math.max(i[0], i[1]);
      return Math.max(Math.ceil(Math.log(t3) / Math.log(10)), 1);
    }
    function oG(o) {
      var i = o.x || 0, t3 = o.y || 0, c3 = (o.rotation || 0) * aF, p3 = Xs(o.scaleX, 1), g3 = Xs(o.scaleY, 1), b3 = o.skewX || 0, w3 = o.skewY || 0, M = [];
      return (i || t3) && M.push("translate(" + i + "px," + t3 + "px)"), c3 && M.push("rotate(" + c3 + ")"), (p3 !== 1 || g3 !== 1) && M.push("scale(" + p3 + "," + g3 + ")"), (b3 || w3) && M.push("skew(" + gF(b3 * aF) + "deg, " + gF(w3 * aF) + "deg)"), M.join(" ");
    }
    var wQ = function() {
      return yo.hasGlobalWindow && Vo(window.btoa) ? function(o) {
        return window.btoa(unescape(o));
      } : typeof Buffer != "undefined" ? function(o) {
        return Buffer.from(o).toString("base64");
      } : function(o) {
        return null;
      };
    }(), sG = Array.prototype.slice;
    function V2(o, i, t3) {
      return (i - o) * t3 + o;
    }
    function EP(o, i, t3, c3) {
      for (var p3 = i.length, g3 = 0; g3 < p3; g3++)
        o[g3] = V2(i[g3], t3[g3], c3);
      return o;
    }
    function DP(o, i, t3, c3) {
      for (var p3 = i.length, g3 = p3 && i[0].length, b3 = 0; b3 < p3; b3++) {
        o[b3] || (o[b3] = []);
        for (var w3 = 0; w3 < g3; w3++)
          o[b3][w3] = V2(i[b3][w3], t3[b3][w3], c3);
      }
      return o;
    }
    function oI(o, i, t3, c3) {
      for (var p3 = i.length, g3 = 0; g3 < p3; g3++)
        o[g3] = i[g3] + t3[g3] * c3;
      return o;
    }
    function SQ(o, i, t3, c3) {
      for (var p3 = i.length, g3 = p3 && i[0].length, b3 = 0; b3 < p3; b3++) {
        o[b3] || (o[b3] = []);
        for (var w3 = 0; w3 < g3; w3++)
          o[b3][w3] = i[b3][w3] + t3[b3][w3] * c3;
      }
      return o;
    }
    function CQ(o, i) {
      for (var t3 = o.length, c3 = i.length, p3 = t3 > c3 ? i : o, g3 = Math.min(t3, c3), b3 = p3[g3 - 1] || { color: [0, 0, 0, 0], offset: 0 }, w3 = g3; w3 < Math.max(t3, c3); w3++)
        p3.push({ offset: b3.offset, color: b3.color.slice() });
    }
    function ude(o, i, t3) {
      var c3 = o, p3 = i;
      if (!(!c3.push || !p3.push)) {
        var g3 = c3.length, b3 = p3.length;
        if (g3 !== b3) {
          var w3 = g3 > b3;
          if (w3)
            c3.length = b3;
          else
            for (var M = g3; M < b3; M++)
              c3.push(t3 === 1 ? p3[M] : sG.call(p3[M]));
        }
        for (var I = c3[0] && c3[0].length, M = 0; M < c3.length; M++)
          if (t3 === 1)
            isNaN(c3[M]) && (c3[M] = p3[M]);
          else
            for (var k3 = 0; k3 < I; k3++)
              isNaN(c3[M][k3]) && (c3[M][k3] = p3[M][k3]);
      }
    }
    function E1(o) {
      if (yg(o)) {
        var i = o.length;
        if (yg(o[0])) {
          for (var t3 = [], c3 = 0; c3 < i; c3++)
            t3.push(sG.call(o[c3]));
          return t3;
        }
        return sG.call(o);
      }
      return o;
    }
    function V5(o) {
      return o[0] = Math.floor(o[0]) || 0, o[1] = Math.floor(o[1]) || 0, o[2] = Math.floor(o[2]) || 0, o[3] = o[3] == null ? 1 : o[3], "rgba(" + o.join(",") + ")";
    }
    function sI(o) {
      return yg(o && o[0]) ? 2 : 1;
    }
    var cy = 0, mF = 1, lG = 2, B5 = 3, lI = 4, fw = 5, uG = 6;
    function MQ(o) {
      return o === lI || o === fw;
    }
    function uI(o) {
      return o === mF || o === lG;
    }
    var kP = [0, 0, 0, 0], TQ = function() {
      function o(i) {
        this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = i;
      }
      return o.prototype.isFinished = function() {
        return this._finished;
      }, o.prototype.setFinished = function() {
        this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
      }, o.prototype.needsAnimate = function() {
        return this.keyframes.length >= 1;
      }, o.prototype.getAdditiveTrack = function() {
        return this._additiveTrack;
      }, o.prototype.addKeyframe = function(i, t3, c3) {
        this._needsSort = true;
        var p3 = this.keyframes, g3 = p3.length, b3 = false, w3 = uG, M = t3;
        if (yg(t3)) {
          var I = sI(t3);
          w3 = I, (I === 1 && !ec(t3[0]) || I === 2 && !ec(t3[0][0])) && (b3 = true);
        } else if (ec(t3) && !pP(t3))
          w3 = cy;
        else if (Ha(t3))
          if (!isNaN(+t3))
            w3 = cy;
          else {
            var k3 = I1(t3);
            k3 && (M = k3, w3 = B5);
          }
        else if (rF(t3)) {
          var L = ti({}, M);
          L.colorStops = Fi(t3.colorStops, function(B) {
            return { offset: B.offset, color: I1(B.color) };
          }), bQ(t3) ? w3 = lI : _Q(t3) && (w3 = fw), M = L;
        }
        g3 === 0 ? this.valType = w3 : (w3 !== this.valType || w3 === uG) && (b3 = true), this.discrete = this.discrete || b3;
        var F = { time: i, value: M, rawValue: t3, percent: 0 };
        return c3 && (F.easing = c3, F.easingFunc = Vo(c3) ? c3 : Qj[c3] || CP(c3)), p3.push(F), F;
      }, o.prototype.prepare = function(i, t3) {
        var c3 = this.keyframes;
        this._needsSort && c3.sort(function(J, Q) {
          return J.time - Q.time;
        });
        for (var p3 = this.valType, g3 = c3.length, b3 = c3[g3 - 1], w3 = this.discrete, M = uI(p3), I = MQ(p3), k3 = 0; k3 < g3; k3++) {
          var L = c3[k3], F = L.value, B = b3.value;
          L.percent = L.time / i, w3 || (M && k3 !== g3 - 1 ? ude(F, B, p3) : I && CQ(F.colorStops, B.colorStops));
        }
        if (!w3 && p3 !== fw && t3 && this.needsAnimate() && t3.needsAnimate() && p3 === t3.valType && !t3._finished) {
          this._additiveTrack = t3;
          for (var G = c3[0].value, k3 = 0; k3 < g3; k3++)
            p3 === cy ? c3[k3].additiveValue = c3[k3].value - G : p3 === B5 ? c3[k3].additiveValue = oI([], c3[k3].value, G, -1) : uI(p3) && (c3[k3].additiveValue = p3 === mF ? oI([], c3[k3].value, G, -1) : SQ([], c3[k3].value, G, -1));
        }
      }, o.prototype.step = function(i, t3) {
        if (!this._finished) {
          this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
          var c3 = this._additiveTrack != null, p3 = c3 ? "additiveValue" : "value", g3 = this.valType, b3 = this.keyframes, w3 = b3.length, M = this.propName, I = g3 === B5, k3, L = this._lastFr, F = Math.min, B, G;
          if (w3 === 1)
            B = G = b3[0];
          else {
            if (t3 < 0)
              k3 = 0;
            else if (t3 < this._lastFrP) {
              var J = F(L + 1, w3 - 1);
              for (k3 = J; k3 >= 0 && !(b3[k3].percent <= t3); k3--)
                ;
              k3 = F(k3, w3 - 2);
            } else {
              for (k3 = L; k3 < w3 && !(b3[k3].percent > t3); k3++)
                ;
              k3 = F(k3 - 1, w3 - 2);
            }
            G = b3[k3 + 1], B = b3[k3];
          }
          if (B && G) {
            this._lastFr = k3, this._lastFrP = t3;
            var Q = G.percent - B.percent, se = Q === 0 ? 1 : F((t3 - B.percent) / Q, 1);
            G.easingFunc && (se = G.easingFunc(se));
            var he = c3 ? this._additiveValue : I ? kP : i[M];
            if ((uI(g3) || I) && !he && (he = this._additiveValue = []), this.discrete)
              i[M] = se < 1 ? B.rawValue : G.rawValue;
            else if (uI(g3))
              g3 === mF ? EP(he, B[p3], G[p3], se) : DP(he, B[p3], G[p3], se);
            else if (MQ(g3)) {
              var be = B[p3], de = G[p3], Fe = g3 === lI;
              i[M] = { type: Fe ? "linear" : "radial", x: V2(be.x, de.x, se), y: V2(be.y, de.y, se), colorStops: Fi(be.colorStops, function(ze, $e) {
                var Ke = de.colorStops[$e];
                return { offset: V2(ze.offset, Ke.offset, se), color: V5(EP([], ze.color, Ke.color, se)) };
              }), global: de.global }, Fe ? (i[M].x2 = V2(be.x2, de.x2, se), i[M].y2 = V2(be.y2, de.y2, se)) : i[M].r = V2(be.r, de.r, se);
            } else if (I)
              EP(he, B[p3], G[p3], se), c3 || (i[M] = V5(he));
            else {
              var Pe = V2(B[p3], G[p3], se);
              c3 ? this._additiveValue = Pe : i[M] = Pe;
            }
            c3 && this._addToTarget(i);
          }
        }
      }, o.prototype._addToTarget = function(i) {
        var t3 = this.valType, c3 = this.propName, p3 = this._additiveValue;
        t3 === cy ? i[c3] = i[c3] + p3 : t3 === B5 ? (I1(i[c3], kP), oI(kP, kP, p3, 1), i[c3] = V5(kP)) : t3 === mF ? oI(i[c3], i[c3], p3, 1) : t3 === lG && SQ(i[c3], i[c3], p3, 1);
      }, o;
    }(), uv = function() {
      function o(i, t3, c3, p3) {
        if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = i, this._loop = t3, t3 && p3) {
          fP("Can' use additive animation on looped animation.");
          return;
        }
        this._additiveAnimators = p3, this._allowDiscrete = c3;
      }
      return o.prototype.getMaxTime = function() {
        return this._maxTime;
      }, o.prototype.getDelay = function() {
        return this._delay;
      }, o.prototype.getLoop = function() {
        return this._loop;
      }, o.prototype.getTarget = function() {
        return this._target;
      }, o.prototype.changeTarget = function(i) {
        this._target = i;
      }, o.prototype.when = function(i, t3, c3) {
        return this.whenWithKeys(i, t3, Gl(t3), c3);
      }, o.prototype.whenWithKeys = function(i, t3, c3, p3) {
        for (var g3 = this._tracks, b3 = 0; b3 < c3.length; b3++) {
          var w3 = c3[b3], M = g3[w3];
          if (!M) {
            M = g3[w3] = new TQ(w3);
            var I = void 0, k3 = this._getAdditiveTrack(w3);
            if (k3) {
              var L = k3.keyframes, F = L[L.length - 1];
              I = F && F.value, k3.valType === B5 && I && (I = V5(I));
            } else
              I = this._target[w3];
            if (I == null)
              continue;
            i > 0 && M.addKeyframe(0, E1(I), p3), this._trackKeys.push(w3);
          }
          M.addKeyframe(i, E1(t3[w3]), p3);
        }
        return this._maxTime = Math.max(this._maxTime, i), this;
      }, o.prototype.pause = function() {
        this._clip.pause(), this._paused = true;
      }, o.prototype.resume = function() {
        this._clip.resume(), this._paused = false;
      }, o.prototype.isPaused = function() {
        return !!this._paused;
      }, o.prototype.duration = function(i) {
        return this._maxTime = i, this._force = true, this;
      }, o.prototype._doneCallback = function() {
        this._setTracksFinished(), this._clip = null;
        var i = this._doneCbs;
        if (i)
          for (var t3 = i.length, c3 = 0; c3 < t3; c3++)
            i[c3].call(this);
      }, o.prototype._abortedCallback = function() {
        this._setTracksFinished();
        var i = this.animation, t3 = this._abortedCbs;
        if (i && i.removeClip(this._clip), this._clip = null, t3)
          for (var c3 = 0; c3 < t3.length; c3++)
            t3[c3].call(this);
      }, o.prototype._setTracksFinished = function() {
        for (var i = this._tracks, t3 = this._trackKeys, c3 = 0; c3 < t3.length; c3++)
          i[t3[c3]].setFinished();
      }, o.prototype._getAdditiveTrack = function(i) {
        var t3, c3 = this._additiveAnimators;
        if (c3)
          for (var p3 = 0; p3 < c3.length; p3++) {
            var g3 = c3[p3].getTrack(i);
            g3 && (t3 = g3);
          }
        return t3;
      }, o.prototype.start = function(i) {
        if (!(this._started > 0)) {
          this._started = 1;
          for (var t3 = this, c3 = [], p3 = this._maxTime || 0, g3 = 0; g3 < this._trackKeys.length; g3++) {
            var b3 = this._trackKeys[g3], w3 = this._tracks[b3], M = this._getAdditiveTrack(b3), I = w3.keyframes, k3 = I.length;
            if (w3.prepare(p3, M), w3.needsAnimate())
              if (!this._allowDiscrete && w3.discrete) {
                var L = I[k3 - 1];
                L && (t3._target[w3.propName] = L.rawValue), w3.setFinished();
              } else
                c3.push(w3);
          }
          if (c3.length || this._force) {
            var F = new MP({ life: p3, loop: this._loop, delay: this._delay || 0, onframe: function(B) {
              t3._started = 2;
              var G = t3._additiveAnimators;
              if (G) {
                for (var J = false, Q = 0; Q < G.length; Q++)
                  if (G[Q]._clip) {
                    J = true;
                    break;
                  }
                J || (t3._additiveAnimators = null);
              }
              for (var Q = 0; Q < c3.length; Q++)
                c3[Q].step(t3._target, B);
              var se = t3._onframeCbs;
              if (se)
                for (var Q = 0; Q < se.length; Q++)
                  se[Q](t3._target, B);
            }, ondestroy: function() {
              t3._doneCallback();
            } });
            this._clip = F, this.animation && this.animation.addClip(F), i && F.setEasing(i);
          } else
            this._doneCallback();
          return this;
        }
      }, o.prototype.stop = function(i) {
        if (this._clip) {
          var t3 = this._clip;
          i && t3.onframe(1), this._abortedCallback();
        }
      }, o.prototype.delay = function(i) {
        return this._delay = i, this;
      }, o.prototype.during = function(i) {
        return i && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(i)), this;
      }, o.prototype.done = function(i) {
        return i && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(i)), this;
      }, o.prototype.aborted = function(i) {
        return i && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(i)), this;
      }, o.prototype.getClip = function() {
        return this._clip;
      }, o.prototype.getTrack = function(i) {
        return this._tracks[i];
      }, o.prototype.getTracks = function() {
        var i = this;
        return Fi(this._trackKeys, function(t3) {
          return i._tracks[t3];
        });
      }, o.prototype.stopTracks = function(i, t3) {
        if (!i.length || !this._clip)
          return true;
        for (var c3 = this._tracks, p3 = this._trackKeys, g3 = 0; g3 < i.length; g3++) {
          var b3 = c3[i[g3]];
          b3 && !b3.isFinished() && (t3 ? b3.step(this._target, 1) : this._started === 1 && b3.step(this._target, 0), b3.setFinished());
        }
        for (var w3 = true, g3 = 0; g3 < p3.length; g3++)
          if (!c3[p3[g3]].isFinished()) {
            w3 = false;
            break;
          }
        return w3 && this._abortedCallback(), w3;
      }, o.prototype.saveTo = function(i, t3, c3) {
        if (i) {
          t3 = t3 || this._trackKeys;
          for (var p3 = 0; p3 < t3.length; p3++) {
            var g3 = t3[p3], b3 = this._tracks[g3];
            if (!(!b3 || b3.isFinished())) {
              var w3 = b3.keyframes, M = w3[c3 ? 0 : w3.length - 1];
              M && (i[g3] = E1(M.rawValue));
            }
          }
        }
      }, o.prototype.__changeFinalValue = function(i, t3) {
        t3 = t3 || Gl(i);
        for (var c3 = 0; c3 < t3.length; c3++) {
          var p3 = t3[c3], g3 = this._tracks[p3];
          if (g3) {
            var b3 = g3.keyframes;
            if (b3.length > 1) {
              var w3 = b3.pop();
              g3.addKeyframe(w3.time, i[p3]), g3.prepare(this._maxTime, g3.getAdditiveTrack());
            }
          }
        }
      }, o;
    }();
    function IM() {
      return new Date().getTime();
    }
    var AQ = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this) || this;
        return c3._running = false, c3._time = 0, c3._pausedTime = 0, c3._pauseStart = 0, c3._paused = false, t3 = t3 || {}, c3.stage = t3.stage || {}, c3;
      }
      return i.prototype.addClip = function(t3) {
        t3.animation && this.removeClip(t3), this._head ? (this._tail.next = t3, t3.prev = this._tail, t3.next = null, this._tail = t3) : this._head = this._tail = t3, t3.animation = this;
      }, i.prototype.addAnimator = function(t3) {
        t3.animation = this;
        var c3 = t3.getClip();
        c3 && this.addClip(c3);
      }, i.prototype.removeClip = function(t3) {
        if (t3.animation) {
          var c3 = t3.prev, p3 = t3.next;
          c3 ? c3.next = p3 : this._head = p3, p3 ? p3.prev = c3 : this._tail = c3, t3.next = t3.prev = t3.animation = null;
        }
      }, i.prototype.removeAnimator = function(t3) {
        var c3 = t3.getClip();
        c3 && this.removeClip(c3), t3.animation = null;
      }, i.prototype.update = function(t3) {
        for (var c3 = IM() - this._pausedTime, p3 = c3 - this._time, g3 = this._head; g3; ) {
          var b3 = g3.next, w3 = g3.step(c3, p3);
          w3 && (g3.ondestroy(), this.removeClip(g3)), g3 = b3;
        }
        this._time = c3, t3 || (this.trigger("frame", p3), this.stage.update && this.stage.update());
      }, i.prototype._startLoop = function() {
        var t3 = this;
        this._running = true;
        function c3() {
          t3._running && (uw(c3), !t3._paused && t3.update());
        }
        uw(c3);
      }, i.prototype.start = function() {
        this._running || (this._time = IM(), this._pausedTime = 0, this._startLoop());
      }, i.prototype.stop = function() {
        this._running = false;
      }, i.prototype.pause = function() {
        this._paused || (this._pauseStart = IM(), this._paused = true);
      }, i.prototype.resume = function() {
        this._paused && (this._pausedTime += IM() - this._pauseStart, this._paused = false);
      }, i.prototype.clear = function() {
        for (var t3 = this._head; t3; ) {
          var c3 = t3.next;
          t3.prev = t3.next = t3.animation = null, t3 = c3;
        }
        this._head = this._tail = null;
      }, i.prototype.isFinished = function() {
        return this._head == null;
      }, i.prototype.animate = function(t3, c3) {
        c3 = c3 || {}, this.start();
        var p3 = new uv(t3, c3.loop);
        return this.addAnimator(p3), p3;
      }, i;
    }(hm), hw = AQ, cG = 300, z5 = yo.domSupported, B2 = function() {
      var o = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], i = ["touchstart", "touchend", "touchmove"], t3 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, c3 = Fi(o, function(p3) {
        var g3 = p3.replace("mouse", "pointer");
        return t3.hasOwnProperty(g3) ? g3 : p3;
      });
      return { mouse: o, touch: i, pointer: c3 };
    }(), fG = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, h0 = false;
    function OP(o) {
      var i = o.pointerType;
      return i === "pen" || i === "touch";
    }
    function cde(o) {
      o.touching = true, o.touchTimer != null && (clearTimeout(o.touchTimer), o.touchTimer = null), o.touchTimer = setTimeout(function() {
        o.touching = false, o.touchTimer = null;
      }, 700);
    }
    function hG(o) {
      o && (o.zrByTouch = true);
    }
    function fde(o, i) {
      return M1(o.dom, new hde(o, i), true);
    }
    function bF(o, i) {
      for (var t3 = i, c3 = false; t3 && t3.nodeType !== 9 && !(c3 = t3.domBelongToZr || t3 !== i && t3 === o.painterRoot); )
        t3 = t3.parentNode;
      return c3;
    }
    var hde = function() {
      function o(i, t3) {
        this.stopPropagation = uf, this.stopImmediatePropagation = uf, this.preventDefault = uf, this.type = t3.type, this.target = this.currentTarget = i.dom, this.pointerType = t3.pointerType, this.clientX = t3.clientX, this.clientY = t3.clientY;
      }
      return o;
    }(), fy = { mousedown: function(o) {
      o = M1(this.dom, o), this.__mayPointerCapture = [o.zrX, o.zrY], this.trigger("mousedown", o);
    }, mousemove: function(o) {
      o = M1(this.dom, o);
      var i = this.__mayPointerCapture;
      i && (o.zrX !== i[0] || o.zrY !== i[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", o);
    }, mouseup: function(o) {
      o = M1(this.dom, o), this.__togglePointerCapture(false), this.trigger("mouseup", o);
    }, mouseout: function(o) {
      o = M1(this.dom, o);
      var i = o.toElement || o.relatedTarget;
      bF(this, i) || (this.__pointerCapturing && (o.zrEventControl = "no_globalout"), this.trigger("mouseout", o));
    }, wheel: function(o) {
      h0 = true, o = M1(this.dom, o), this.trigger("mousewheel", o);
    }, mousewheel: function(o) {
      h0 || (o = M1(this.dom, o), this.trigger("mousewheel", o));
    }, touchstart: function(o) {
      o = M1(this.dom, o), hG(o), this.__lastTouchMoment = new Date(), this.handler.processGesture(o, "start"), fy.mousemove.call(this, o), fy.mousedown.call(this, o);
    }, touchmove: function(o) {
      o = M1(this.dom, o), hG(o), this.handler.processGesture(o, "change"), fy.mousemove.call(this, o);
    }, touchend: function(o) {
      o = M1(this.dom, o), hG(o), this.handler.processGesture(o, "end"), fy.mouseup.call(this, o), +new Date() - +this.__lastTouchMoment < cG && fy.click.call(this, o);
    }, pointerdown: function(o) {
      fy.mousedown.call(this, o);
    }, pointermove: function(o) {
      OP(o) || fy.mousemove.call(this, o);
    }, pointerup: function(o) {
      fy.mouseup.call(this, o);
    }, pointerout: function(o) {
      OP(o) || fy.mouseout.call(this, o);
    } };
    yt(["click", "dblclick", "contextmenu"], function(o) {
      fy[o] = function(i) {
        i = M1(this.dom, i), this.trigger(o, i);
      };
    });
    var _F = { pointermove: function(o) {
      OP(o) || _F.mousemove.call(this, o);
    }, pointerup: function(o) {
      _F.mouseup.call(this, o);
    }, mousemove: function(o) {
      this.trigger("mousemove", o);
    }, mouseup: function(o) {
      var i = this.__pointerCapturing;
      this.__togglePointerCapture(false), this.trigger("mouseup", o), i && (o.zrEventControl = "only_globalout", this.trigger("mouseout", o));
    } };
    function pde(o, i) {
      var t3 = i.domHandlers;
      yo.pointerEventsSupported ? yt(B2.pointer, function(c3) {
        EM(i, c3, function(p3) {
          t3[c3].call(o, p3);
        });
      }) : (yo.touchEventsSupported && yt(B2.touch, function(c3) {
        EM(i, c3, function(p3) {
          t3[c3].call(o, p3), cde(i);
        });
      }), yt(B2.mouse, function(c3) {
        EM(i, c3, function(p3) {
          p3 = mP(p3), i.touching || t3[c3].call(o, p3);
        });
      }));
    }
    function dde(o, i) {
      yo.pointerEventsSupported ? yt(fG.pointer, t3) : yo.touchEventsSupported || yt(fG.mouse, t3);
      function t3(c3) {
        function p3(g3) {
          g3 = mP(g3), bF(o, g3.target) || (g3 = fde(o, g3), i.domHandlers[c3].call(o, g3));
        }
        EM(i, c3, p3, { capture: true });
      }
    }
    function EM(o, i, t3, c3) {
      o.mounted[i] = t3, o.listenerOpts[i] = c3, w5(o.domTarget, i, t3, c3);
    }
    function pG(o) {
      var i = o.mounted;
      for (var t3 in i)
        i.hasOwnProperty(t3) && qpe(o.domTarget, t3, i[t3], o.listenerOpts[t3]);
      o.mounted = {};
    }
    var IQ = function() {
      function o(i, t3) {
        this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = i, this.domHandlers = t3;
      }
      return o;
    }(), dG = function(o) {
      cn(i, o);
      function i(t3, c3) {
        var p3 = o.call(this) || this;
        return p3.__pointerCapturing = false, p3.dom = t3, p3.painterRoot = c3, p3._localHandlerScope = new IQ(t3, fy), z5 && (p3._globalHandlerScope = new IQ(document, _F)), pde(p3, p3._localHandlerScope), p3;
      }
      return i.prototype.dispose = function() {
        pG(this._localHandlerScope), z5 && pG(this._globalHandlerScope);
      }, i.prototype.setCursor = function(t3) {
        this.dom.style && (this.dom.style.cursor = t3 || "default");
      }, i.prototype.__togglePointerCapture = function(t3) {
        if (this.__mayPointerCapture = null, z5 && +this.__pointerCapturing ^ +t3) {
          this.__pointerCapturing = t3;
          var c3 = this._globalHandlerScope;
          t3 ? dde(this, c3) : pG(c3);
        }
      }, i;
    }(hm), EQ = dG, DQ = 1;
    yo.hasGlobalWindow && (DQ = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
    var xF = DQ, vG = 0.4, wF = "#333", PP = "#ccc", vde = "#eee";
    function dm() {
      return [1, 0, 0, 1, 0, 0];
    }
    function LP(o) {
      return o[0] = 1, o[1] = 0, o[2] = 0, o[3] = 1, o[4] = 0, o[5] = 0, o;
    }
    function SF(o, i) {
      return o[0] = i[0], o[1] = i[1], o[2] = i[2], o[3] = i[3], o[4] = i[4], o[5] = i[5], o;
    }
    function pw(o, i, t3) {
      var c3 = i[0] * t3[0] + i[2] * t3[1], p3 = i[1] * t3[0] + i[3] * t3[1], g3 = i[0] * t3[2] + i[2] * t3[3], b3 = i[1] * t3[2] + i[3] * t3[3], w3 = i[0] * t3[4] + i[2] * t3[5] + i[4], M = i[1] * t3[4] + i[3] * t3[5] + i[5];
      return o[0] = c3, o[1] = p3, o[2] = g3, o[3] = b3, o[4] = w3, o[5] = M, o;
    }
    function D1(o, i, t3) {
      return o[0] = i[0], o[1] = i[1], o[2] = i[2], o[3] = i[3], o[4] = i[4] + t3[0], o[5] = i[5] + t3[1], o;
    }
    function cI(o, i, t3) {
      var c3 = i[0], p3 = i[2], g3 = i[4], b3 = i[1], w3 = i[3], M = i[5], I = Math.sin(t3), k3 = Math.cos(t3);
      return o[0] = c3 * k3 + b3 * I, o[1] = -c3 * I + b3 * k3, o[2] = p3 * k3 + w3 * I, o[3] = -p3 * I + k3 * w3, o[4] = k3 * g3 + I * M, o[5] = k3 * M - I * g3, o;
    }
    function CF(o, i, t3) {
      var c3 = t3[0], p3 = t3[1];
      return o[0] = i[0] * c3, o[1] = i[1] * p3, o[2] = i[2] * c3, o[3] = i[3] * p3, o[4] = i[4] * c3, o[5] = i[5] * p3, o;
    }
    function fI(o, i) {
      var t3 = i[0], c3 = i[2], p3 = i[4], g3 = i[1], b3 = i[3], w3 = i[5], M = t3 * b3 - g3 * c3;
      return M ? (M = 1 / M, o[0] = b3 * M, o[1] = -g3 * M, o[2] = -c3 * M, o[3] = t3 * M, o[4] = (c3 * w3 - b3 * p3) * M, o[5] = (g3 * p3 - t3 * w3) * M, o) : null;
    }
    function gde(o) {
      var i = dm();
      return SF(i, o), i;
    }
    var gG = LP, kQ = 5e-5;
    function z2(o) {
      return o > kQ || o < -kQ;
    }
    var DM = [], kM = [], yG = dm(), RP = Math.abs, Nu = function() {
      function o() {
      }
      return o.prototype.getLocalTransform = function(i) {
        return o.getLocalTransform(this, i);
      }, o.prototype.setPosition = function(i) {
        this.x = i[0], this.y = i[1];
      }, o.prototype.setScale = function(i) {
        this.scaleX = i[0], this.scaleY = i[1];
      }, o.prototype.setSkew = function(i) {
        this.skewX = i[0], this.skewY = i[1];
      }, o.prototype.setOrigin = function(i) {
        this.originX = i[0], this.originY = i[1];
      }, o.prototype.needLocalTransform = function() {
        return z2(this.rotation) || z2(this.x) || z2(this.y) || z2(this.scaleX - 1) || z2(this.scaleY - 1) || z2(this.skewX) || z2(this.skewY);
      }, o.prototype.updateTransform = function() {
        var i = this.parent && this.parent.transform, t3 = this.needLocalTransform(), c3 = this.transform;
        if (!(t3 || i)) {
          c3 && gG(c3);
          return;
        }
        c3 = c3 || dm(), t3 ? this.getLocalTransform(c3) : gG(c3), i && (t3 ? pw(c3, i, c3) : SF(c3, i)), this.transform = c3, this._resolveGlobalScaleRatio(c3);
      }, o.prototype._resolveGlobalScaleRatio = function(i) {
        var t3 = this.globalScaleRatio;
        if (t3 != null && t3 !== 1) {
          this.getGlobalScale(DM);
          var c3 = DM[0] < 0 ? -1 : 1, p3 = DM[1] < 0 ? -1 : 1, g3 = ((DM[0] - c3) * t3 + c3) / DM[0] || 0, b3 = ((DM[1] - p3) * t3 + p3) / DM[1] || 0;
          i[0] *= g3, i[1] *= g3, i[2] *= b3, i[3] *= b3;
        }
        this.invTransform = this.invTransform || dm(), fI(this.invTransform, i);
      }, o.prototype.getComputedTransform = function() {
        for (var i = this, t3 = []; i; )
          t3.push(i), i = i.parent;
        for (; i = t3.pop(); )
          i.updateTransform();
        return this.transform;
      }, o.prototype.setLocalTransform = function(i) {
        if (i) {
          var t3 = i[0] * i[0] + i[1] * i[1], c3 = i[2] * i[2] + i[3] * i[3], p3 = Math.atan2(i[1], i[0]), g3 = Math.PI / 2 + p3 - Math.atan2(i[3], i[2]);
          c3 = Math.sqrt(c3) * Math.cos(g3), t3 = Math.sqrt(t3), this.skewX = g3, this.skewY = 0, this.rotation = -p3, this.x = +i[4], this.y = +i[5], this.scaleX = t3, this.scaleY = c3, this.originX = 0, this.originY = 0;
        }
      }, o.prototype.decomposeTransform = function() {
        if (this.transform) {
          var i = this.parent, t3 = this.transform;
          i && i.transform && (pw(kM, i.invTransform, t3), t3 = kM);
          var c3 = this.originX, p3 = this.originY;
          (c3 || p3) && (yG[4] = c3, yG[5] = p3, pw(kM, t3, yG), kM[4] -= c3, kM[5] -= p3, t3 = kM), this.setLocalTransform(t3);
        }
      }, o.prototype.getGlobalScale = function(i) {
        var t3 = this.transform;
        return i = i || [], t3 ? (i[0] = Math.sqrt(t3[0] * t3[0] + t3[1] * t3[1]), i[1] = Math.sqrt(t3[2] * t3[2] + t3[3] * t3[3]), t3[0] < 0 && (i[0] = -i[0]), t3[3] < 0 && (i[1] = -i[1]), i) : (i[0] = 1, i[1] = 1, i);
      }, o.prototype.transformCoordToLocal = function(i, t3) {
        var c3 = [i, t3], p3 = this.invTransform;
        return p3 && Vv(c3, c3, p3), c3;
      }, o.prototype.transformCoordToGlobal = function(i, t3) {
        var c3 = [i, t3], p3 = this.transform;
        return p3 && Vv(c3, c3, p3), c3;
      }, o.prototype.getLineScale = function() {
        var i = this.transform;
        return i && RP(i[0] - 1) > 1e-10 && RP(i[3] - 1) > 1e-10 ? Math.sqrt(RP(i[0] * i[3] - i[2] * i[1])) : 1;
      }, o.prototype.copyTransform = function(i) {
        OQ(this, i);
      }, o.getLocalTransform = function(i, t3) {
        t3 = t3 || [];
        var c3 = i.originX || 0, p3 = i.originY || 0, g3 = i.scaleX, b3 = i.scaleY, w3 = i.anchorX, M = i.anchorY, I = i.rotation || 0, k3 = i.x, L = i.y, F = i.skewX ? Math.tan(i.skewX) : 0, B = i.skewY ? Math.tan(-i.skewY) : 0;
        if (c3 || p3 || w3 || M) {
          var G = c3 + w3, J = p3 + M;
          t3[4] = -G * g3 - F * J * b3, t3[5] = -J * b3 - B * G * g3;
        } else
          t3[4] = t3[5] = 0;
        return t3[0] = g3, t3[3] = b3, t3[1] = B * g3, t3[2] = F * b3, I && cI(t3, t3, I), t3[4] += c3 + k3, t3[5] += p3 + L, t3;
      }, o.initDefaultProps = function() {
        var i = o.prototype;
        i.scaleX = i.scaleY = i.globalScaleRatio = 1, i.x = i.y = i.originX = i.originY = i.skewX = i.skewY = i.rotation = i.anchorX = i.anchorY = 0;
      }(), o;
    }(), dw = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
    function OQ(o, i) {
      for (var t3 = 0; t3 < dw.length; t3++) {
        var c3 = dw[t3];
        o[c3] = i[c3];
      }
    }
    var k1 = Nu, PQ = function() {
      function o(i, t3) {
        this.x = i || 0, this.y = t3 || 0;
      }
      return o.prototype.copy = function(i) {
        return this.x = i.x, this.y = i.y, this;
      }, o.prototype.clone = function() {
        return new o(this.x, this.y);
      }, o.prototype.set = function(i, t3) {
        return this.x = i, this.y = t3, this;
      }, o.prototype.equal = function(i) {
        return i.x === this.x && i.y === this.y;
      }, o.prototype.add = function(i) {
        return this.x += i.x, this.y += i.y, this;
      }, o.prototype.scale = function(i) {
        this.x *= i, this.y *= i;
      }, o.prototype.scaleAndAdd = function(i, t3) {
        this.x += i.x * t3, this.y += i.y * t3;
      }, o.prototype.sub = function(i) {
        return this.x -= i.x, this.y -= i.y, this;
      }, o.prototype.dot = function(i) {
        return this.x * i.x + this.y * i.y;
      }, o.prototype.len = function() {
        return Math.sqrt(this.x * this.x + this.y * this.y);
      }, o.prototype.lenSquare = function() {
        return this.x * this.x + this.y * this.y;
      }, o.prototype.normalize = function() {
        var i = this.len();
        return this.x /= i, this.y /= i, this;
      }, o.prototype.distance = function(i) {
        var t3 = this.x - i.x, c3 = this.y - i.y;
        return Math.sqrt(t3 * t3 + c3 * c3);
      }, o.prototype.distanceSquare = function(i) {
        var t3 = this.x - i.x, c3 = this.y - i.y;
        return t3 * t3 + c3 * c3;
      }, o.prototype.negate = function() {
        return this.x = -this.x, this.y = -this.y, this;
      }, o.prototype.transform = function(i) {
        if (i) {
          var t3 = this.x, c3 = this.y;
          return this.x = i[0] * t3 + i[2] * c3 + i[4], this.y = i[1] * t3 + i[3] * c3 + i[5], this;
        }
      }, o.prototype.toArray = function(i) {
        return i[0] = this.x, i[1] = this.y, i;
      }, o.prototype.fromArray = function(i) {
        this.x = i[0], this.y = i[1];
      }, o.set = function(i, t3, c3) {
        i.x = t3, i.y = c3;
      }, o.copy = function(i, t3) {
        i.x = t3.x, i.y = t3.y;
      }, o.len = function(i) {
        return Math.sqrt(i.x * i.x + i.y * i.y);
      }, o.lenSquare = function(i) {
        return i.x * i.x + i.y * i.y;
      }, o.dot = function(i, t3) {
        return i.x * t3.x + i.y * t3.y;
      }, o.add = function(i, t3, c3) {
        i.x = t3.x + c3.x, i.y = t3.y + c3.y;
      }, o.sub = function(i, t3, c3) {
        i.x = t3.x - c3.x, i.y = t3.y - c3.y;
      }, o.scale = function(i, t3, c3) {
        i.x = t3.x * c3, i.y = t3.y * c3;
      }, o.scaleAndAdd = function(i, t3, c3, p3) {
        i.x = t3.x + c3.x * p3, i.y = t3.y + c3.y * p3;
      }, o.lerp = function(i, t3, c3, p3) {
        var g3 = 1 - p3;
        i.x = g3 * t3.x + p3 * c3.x, i.y = g3 * t3.y + p3 * c3.y;
      }, o;
    }(), Bs = PQ, MF = Math.min, hy = Math.max, hI = new Bs(), vw = new Bs(), j2 = new Bs(), OM = new Bs(), j5 = new Bs(), _g = new Bs(), PM = function() {
      function o(i, t3, c3, p3) {
        c3 < 0 && (i = i + c3, c3 = -c3), p3 < 0 && (t3 = t3 + p3, p3 = -p3), this.x = i, this.y = t3, this.width = c3, this.height = p3;
      }
      return o.prototype.union = function(i) {
        var t3 = MF(i.x, this.x), c3 = MF(i.y, this.y);
        isFinite(this.x) && isFinite(this.width) ? this.width = hy(i.x + i.width, this.x + this.width) - t3 : this.width = i.width, isFinite(this.y) && isFinite(this.height) ? this.height = hy(i.y + i.height, this.y + this.height) - c3 : this.height = i.height, this.x = t3, this.y = c3;
      }, o.prototype.applyTransform = function(i) {
        o.applyTransform(this, this, i);
      }, o.prototype.calculateTransform = function(i) {
        var t3 = this, c3 = i.width / t3.width, p3 = i.height / t3.height, g3 = dm();
        return D1(g3, g3, [-t3.x, -t3.y]), CF(g3, g3, [c3, p3]), D1(g3, g3, [i.x, i.y]), g3;
      }, o.prototype.intersect = function(i, t3) {
        if (!i)
          return false;
        i instanceof o || (i = o.create(i));
        var c3 = this, p3 = c3.x, g3 = c3.x + c3.width, b3 = c3.y, w3 = c3.y + c3.height, M = i.x, I = i.x + i.width, k3 = i.y, L = i.y + i.height, F = !(g3 < M || I < p3 || w3 < k3 || L < b3);
        if (t3) {
          var B = 1 / 0, G = 0, J = Math.abs(g3 - M), Q = Math.abs(I - p3), se = Math.abs(w3 - k3), he = Math.abs(L - b3), be = Math.min(J, Q), de = Math.min(se, he);
          g3 < M || I < p3 ? be > G && (G = be, J < Q ? Bs.set(_g, -J, 0) : Bs.set(_g, Q, 0)) : be < B && (B = be, J < Q ? Bs.set(j5, J, 0) : Bs.set(j5, -Q, 0)), w3 < k3 || L < b3 ? de > G && (G = de, se < he ? Bs.set(_g, 0, -se) : Bs.set(_g, 0, he)) : be < B && (B = be, se < he ? Bs.set(j5, 0, se) : Bs.set(j5, 0, -he));
        }
        return t3 && Bs.copy(t3, F ? j5 : _g), F;
      }, o.prototype.contain = function(i, t3) {
        var c3 = this;
        return i >= c3.x && i <= c3.x + c3.width && t3 >= c3.y && t3 <= c3.y + c3.height;
      }, o.prototype.clone = function() {
        return new o(this.x, this.y, this.width, this.height);
      }, o.prototype.copy = function(i) {
        o.copy(this, i);
      }, o.prototype.plain = function() {
        return { x: this.x, y: this.y, width: this.width, height: this.height };
      }, o.prototype.isFinite = function() {
        return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
      }, o.prototype.isZero = function() {
        return this.width === 0 || this.height === 0;
      }, o.create = function(i) {
        return new o(i.x, i.y, i.width, i.height);
      }, o.copy = function(i, t3) {
        i.x = t3.x, i.y = t3.y, i.width = t3.width, i.height = t3.height;
      }, o.applyTransform = function(i, t3, c3) {
        if (!c3) {
          i !== t3 && o.copy(i, t3);
          return;
        }
        if (c3[1] < 1e-5 && c3[1] > -1e-5 && c3[2] < 1e-5 && c3[2] > -1e-5) {
          var p3 = c3[0], g3 = c3[3], b3 = c3[4], w3 = c3[5];
          i.x = t3.x * p3 + b3, i.y = t3.y * g3 + w3, i.width = t3.width * p3, i.height = t3.height * g3, i.width < 0 && (i.x += i.width, i.width = -i.width), i.height < 0 && (i.y += i.height, i.height = -i.height);
          return;
        }
        hI.x = j2.x = t3.x, hI.y = OM.y = t3.y, vw.x = OM.x = t3.x + t3.width, vw.y = j2.y = t3.y + t3.height, hI.transform(c3), OM.transform(c3), vw.transform(c3), j2.transform(c3), i.x = MF(hI.x, vw.x, j2.x, OM.x), i.y = MF(hI.y, vw.y, j2.y, OM.y);
        var M = hy(hI.x, vw.x, j2.x, OM.x), I = hy(hI.y, vw.y, j2.y, OM.y);
        i.width = M - i.x, i.height = I - i.y;
      }, o;
    }(), Ys = PM, mG = {};
    function p0(o, i) {
      i = i || Vs;
      var t3 = mG[i];
      t3 || (t3 = mG[i] = new TP(500));
      var c3 = t3.get(o);
      return c3 == null && (c3 = cm.measureText(o, i).width, t3.put(o, c3)), c3;
    }
    function bG(o, i, t3, c3) {
      var p3 = p0(o, i), g3 = H5(i), b3 = G5(0, p3, t3), w3 = LM(0, g3, c3), M = new Ys(b3, w3, p3, g3);
      return M;
    }
    function pI(o, i, t3, c3) {
      var p3 = ((o || "") + "").split(`
`), g3 = p3.length;
      if (g3 === 1)
        return bG(p3[0], i, t3, c3);
      for (var b3 = new Ys(0, 0, 0, 0), w3 = 0; w3 < p3.length; w3++) {
        var M = bG(p3[w3], i, t3, c3);
        w3 === 0 ? b3.copy(M) : b3.union(M);
      }
      return b3;
    }
    function G5(o, i, t3) {
      return t3 === "right" ? o -= i : t3 === "center" && (o -= i / 2), o;
    }
    function LM(o, i, t3) {
      return t3 === "middle" ? o -= i / 2 : t3 === "bottom" && (o -= i), o;
    }
    function H5(o) {
      return p0("\u56FD", o);
    }
    function zv(o, i) {
      return typeof o == "string" ? o.lastIndexOf("%") >= 0 ? parseFloat(o) / 100 * i : parseFloat(o) : o;
    }
    function TF(o, i, t3) {
      var c3 = i.position || "inside", p3 = i.distance != null ? i.distance : 5, g3 = t3.height, b3 = t3.width, w3 = g3 / 2, M = t3.x, I = t3.y, k3 = "left", L = "top";
      if (c3 instanceof Array)
        M += zv(c3[0], t3.width), I += zv(c3[1], t3.height), k3 = null, L = null;
      else
        switch (c3) {
          case "left":
            M -= p3, I += w3, k3 = "right", L = "middle";
            break;
          case "right":
            M += p3 + b3, I += w3, L = "middle";
            break;
          case "top":
            M += b3 / 2, I -= p3, k3 = "center", L = "bottom";
            break;
          case "bottom":
            M += b3 / 2, I += g3 + p3, k3 = "center";
            break;
          case "inside":
            M += b3 / 2, I += w3, k3 = "center", L = "middle";
            break;
          case "insideLeft":
            M += p3, I += w3, L = "middle";
            break;
          case "insideRight":
            M += b3 - p3, I += w3, k3 = "right", L = "middle";
            break;
          case "insideTop":
            M += b3 / 2, I += p3, k3 = "center";
            break;
          case "insideBottom":
            M += b3 / 2, I += g3 - p3, k3 = "center", L = "bottom";
            break;
          case "insideTopLeft":
            M += p3, I += p3;
            break;
          case "insideTopRight":
            M += b3 - p3, I += p3, k3 = "right";
            break;
          case "insideBottomLeft":
            M += p3, I += g3 - p3, L = "bottom";
            break;
          case "insideBottomRight":
            M += b3 - p3, I += g3 - p3, k3 = "right", L = "bottom";
            break;
        }
      return o = o || {}, o.x = M, o.y = I, o.align = k3, o.verticalAlign = L, o;
    }
    var gw = "__zr_normal__", AF = dw.concat(["ignore"]), LQ = aw(dw, function(o, i) {
      return o[i] = true, o;
    }, { ignore: false }), RM = {}, yde = new Ys(0, 0, 0, 0), _G = function() {
      function o(i) {
        this.id = b5(), this.animators = [], this.currentStates = [], this.states = {}, this._init(i);
      }
      return o.prototype._init = function(i) {
        this.attr(i);
      }, o.prototype.drift = function(i, t3, c3) {
        switch (this.draggable) {
          case "horizontal":
            t3 = 0;
            break;
          case "vertical":
            i = 0;
            break;
        }
        var p3 = this.transform;
        p3 || (p3 = this.transform = [1, 0, 0, 1, 0, 0]), p3[4] += i, p3[5] += t3, this.decomposeTransform(), this.markRedraw();
      }, o.prototype.beforeUpdate = function() {
      }, o.prototype.afterUpdate = function() {
      }, o.prototype.update = function() {
        this.updateTransform(), this.__dirty && this.updateInnerText();
      }, o.prototype.updateInnerText = function(i) {
        var t3 = this._textContent;
        if (t3 && (!t3.ignore || i)) {
          this.textConfig || (this.textConfig = {});
          var c3 = this.textConfig, p3 = c3.local, g3 = t3.innerTransformable, b3 = void 0, w3 = void 0, M = false;
          g3.parent = p3 ? this : null;
          var I = false;
          if (g3.copyTransform(t3), c3.position != null) {
            var k3 = yde;
            c3.layoutRect ? k3.copy(c3.layoutRect) : k3.copy(this.getBoundingRect()), p3 || k3.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(RM, c3, k3) : TF(RM, c3, k3), g3.x = RM.x, g3.y = RM.y, b3 = RM.align, w3 = RM.verticalAlign;
            var L = c3.origin;
            if (L && c3.rotation != null) {
              var F = void 0, B = void 0;
              L === "center" ? (F = k3.width * 0.5, B = k3.height * 0.5) : (F = zv(L[0], k3.width), B = zv(L[1], k3.height)), I = true, g3.originX = -g3.x + F + (p3 ? 0 : k3.x), g3.originY = -g3.y + B + (p3 ? 0 : k3.y);
            }
          }
          c3.rotation != null && (g3.rotation = c3.rotation);
          var G = c3.offset;
          G && (g3.x += G[0], g3.y += G[1], I || (g3.originX = -G[0], g3.originY = -G[1]));
          var J = c3.inside == null ? typeof c3.position == "string" && c3.position.indexOf("inside") >= 0 : c3.inside, Q = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), se = void 0, he = void 0, be = void 0;
          J && this.canBeInsideText() ? (se = c3.insideFill, he = c3.insideStroke, (se == null || se === "auto") && (se = this.getInsideTextFill()), (he == null || he === "auto") && (he = this.getInsideTextStroke(se), be = true)) : (se = c3.outsideFill, he = c3.outsideStroke, (se == null || se === "auto") && (se = this.getOutsideFill()), (he == null || he === "auto") && (he = this.getOutsideStroke(se), be = true)), se = se || "#000", (se !== Q.fill || he !== Q.stroke || be !== Q.autoStroke || b3 !== Q.align || w3 !== Q.verticalAlign) && (M = true, Q.fill = se, Q.stroke = he, Q.autoStroke = be, Q.align = b3, Q.verticalAlign = w3, t3.setDefaultTextStyle(Q)), t3.__dirty |= c0, M && t3.dirtyStyle(true);
        }
      }, o.prototype.canBeInsideText = function() {
        return true;
      }, o.prototype.getInsideTextFill = function() {
        return "#fff";
      }, o.prototype.getInsideTextStroke = function(i) {
        return "#000";
      }, o.prototype.getOutsideFill = function() {
        return this.__zr && this.__zr.isDarkMode() ? PP : wF;
      }, o.prototype.getOutsideStroke = function(i) {
        var t3 = this.__zr && this.__zr.getBackgroundColor(), c3 = typeof t3 == "string" && I1(t3);
        c3 || (c3 = [255, 255, 255, 1]);
        for (var p3 = c3[3], g3 = this.__zr.isDarkMode(), b3 = 0; b3 < 3; b3++)
          c3[b3] = c3[b3] * p3 + (g3 ? 0 : 255) * (1 - p3);
        return c3[3] = 1, bg(c3, "rgba");
      }, o.prototype.traverse = function(i, t3) {
      }, o.prototype.attrKV = function(i, t3) {
        i === "textConfig" ? this.setTextConfig(t3) : i === "textContent" ? this.setTextContent(t3) : i === "clipPath" ? this.setClipPath(t3) : i === "extra" ? (this.extra = this.extra || {}, ti(this.extra, t3)) : this[i] = t3;
      }, o.prototype.hide = function() {
        this.ignore = true, this.markRedraw();
      }, o.prototype.show = function() {
        this.ignore = false, this.markRedraw();
      }, o.prototype.attr = function(i, t3) {
        if (typeof i == "string")
          this.attrKV(i, t3);
        else if (Ua(i))
          for (var c3 = i, p3 = Gl(c3), g3 = 0; g3 < p3.length; g3++) {
            var b3 = p3[g3];
            this.attrKV(b3, i[b3]);
          }
        return this.markRedraw(), this;
      }, o.prototype.saveCurrentToNormalState = function(i) {
        this._innerSaveToNormal(i);
        for (var t3 = this._normalState, c3 = 0; c3 < this.animators.length; c3++) {
          var p3 = this.animators[c3], g3 = p3.__fromStateTransition;
          if (!(p3.getLoop() || g3 && g3 !== gw)) {
            var b3 = p3.targetName, w3 = b3 ? t3[b3] : t3;
            p3.saveTo(w3);
          }
        }
      }, o.prototype._innerSaveToNormal = function(i) {
        var t3 = this._normalState;
        t3 || (t3 = this._normalState = {}), i.textConfig && !t3.textConfig && (t3.textConfig = this.textConfig), this._savePrimaryToNormal(i, t3, AF);
      }, o.prototype._savePrimaryToNormal = function(i, t3, c3) {
        for (var p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          i[g3] != null && !(g3 in t3) && (t3[g3] = this[g3]);
        }
      }, o.prototype.hasState = function() {
        return this.currentStates.length > 0;
      }, o.prototype.getState = function(i) {
        return this.states[i];
      }, o.prototype.ensureState = function(i) {
        var t3 = this.states;
        return t3[i] || (t3[i] = {}), t3[i];
      }, o.prototype.clearStates = function(i) {
        this.useState(gw, false, i);
      }, o.prototype.useState = function(i, t3, c3, p3) {
        var g3 = i === gw, b3 = this.hasState();
        if (!(!b3 && g3)) {
          var w3 = this.currentStates, M = this.stateTransition;
          if (!(rl(w3, i) >= 0 && (t3 || w3.length === 1))) {
            var I;
            if (this.stateProxy && !g3 && (I = this.stateProxy(i)), I || (I = this.states && this.states[i]), !I && !g3) {
              fP("State " + i + " not exists.");
              return;
            }
            g3 || this.saveCurrentToNormalState(I);
            var k3 = !!(I && I.hoverLayer || p3);
            k3 && this._toggleHoverLayerFlag(true), this._applyStateObj(i, I, this._normalState, t3, !c3 && !this.__inHover && M && M.duration > 0, M);
            var L = this._textContent, F = this._textGuide;
            return L && L.useState(i, t3, c3, k3), F && F.useState(i, t3, c3, k3), g3 ? (this.currentStates = [], this._normalState = {}) : t3 ? this.currentStates.push(i) : this.currentStates = [i], this._updateAnimationTargets(), this.markRedraw(), !k3 && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~c0), I;
          }
        }
      }, o.prototype.useStates = function(i, t3, c3) {
        if (!i.length)
          this.clearStates();
        else {
          var p3 = [], g3 = this.currentStates, b3 = i.length, w3 = b3 === g3.length;
          if (w3) {
            for (var M = 0; M < b3; M++)
              if (i[M] !== g3[M]) {
                w3 = false;
                break;
              }
          }
          if (w3)
            return;
          for (var M = 0; M < b3; M++) {
            var I = i[M], k3 = void 0;
            this.stateProxy && (k3 = this.stateProxy(I, i)), k3 || (k3 = this.states[I]), k3 && p3.push(k3);
          }
          var L = p3[b3 - 1], F = !!(L && L.hoverLayer || c3);
          F && this._toggleHoverLayerFlag(true);
          var B = this._mergeStates(p3), G = this.stateTransition;
          this.saveCurrentToNormalState(B), this._applyStateObj(i.join(","), B, this._normalState, false, !t3 && !this.__inHover && G && G.duration > 0, G);
          var J = this._textContent, Q = this._textGuide;
          J && J.useStates(i, t3, F), Q && Q.useStates(i, t3, F), this._updateAnimationTargets(), this.currentStates = i.slice(), this.markRedraw(), !F && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~c0);
        }
      }, o.prototype._updateAnimationTargets = function() {
        for (var i = 0; i < this.animators.length; i++) {
          var t3 = this.animators[i];
          t3.targetName && t3.changeTarget(this[t3.targetName]);
        }
      }, o.prototype.removeState = function(i) {
        var t3 = rl(this.currentStates, i);
        if (t3 >= 0) {
          var c3 = this.currentStates.slice();
          c3.splice(t3, 1), this.useStates(c3);
        }
      }, o.prototype.replaceState = function(i, t3, c3) {
        var p3 = this.currentStates.slice(), g3 = rl(p3, i), b3 = rl(p3, t3) >= 0;
        g3 >= 0 ? b3 ? p3.splice(g3, 1) : p3[g3] = t3 : c3 && !b3 && p3.push(t3), this.useStates(p3);
      }, o.prototype.toggleState = function(i, t3) {
        t3 ? this.useState(i, true) : this.removeState(i);
      }, o.prototype._mergeStates = function(i) {
        for (var t3 = {}, c3, p3 = 0; p3 < i.length; p3++) {
          var g3 = i[p3];
          ti(t3, g3), g3.textConfig && (c3 = c3 || {}, ti(c3, g3.textConfig));
        }
        return c3 && (t3.textConfig = c3), t3;
      }, o.prototype._applyStateObj = function(i, t3, c3, p3, g3, b3) {
        var w3 = !(t3 && p3);
        t3 && t3.textConfig ? (this.textConfig = ti({}, p3 ? this.textConfig : c3.textConfig), ti(this.textConfig, t3.textConfig)) : w3 && c3.textConfig && (this.textConfig = c3.textConfig);
        for (var M = {}, I = false, k3 = 0; k3 < AF.length; k3++) {
          var L = AF[k3], F = g3 && LQ[L];
          t3 && t3[L] != null ? F ? (I = true, M[L] = t3[L]) : this[L] = t3[L] : w3 && c3[L] != null && (F ? (I = true, M[L] = c3[L]) : this[L] = c3[L]);
        }
        if (!g3)
          for (var k3 = 0; k3 < this.animators.length; k3++) {
            var B = this.animators[k3], G = B.targetName;
            B.getLoop() || B.__changeFinalValue(G ? (t3 || c3)[G] : t3 || c3);
          }
        I && this._transitionState(i, M, b3);
      }, o.prototype._attachComponent = function(i) {
        if (!(i.__zr && !i.__hostTarget) && i !== this) {
          var t3 = this.__zr;
          t3 && i.addSelfToZr(t3), i.__zr = t3, i.__hostTarget = this;
        }
      }, o.prototype._detachComponent = function(i) {
        i.__zr && i.removeSelfFromZr(i.__zr), i.__zr = null, i.__hostTarget = null;
      }, o.prototype.getClipPath = function() {
        return this._clipPath;
      }, o.prototype.setClipPath = function(i) {
        this._clipPath && this._clipPath !== i && this.removeClipPath(), this._attachComponent(i), this._clipPath = i, this.markRedraw();
      }, o.prototype.removeClipPath = function() {
        var i = this._clipPath;
        i && (this._detachComponent(i), this._clipPath = null, this.markRedraw());
      }, o.prototype.getTextContent = function() {
        return this._textContent;
      }, o.prototype.setTextContent = function(i) {
        var t3 = this._textContent;
        t3 !== i && (t3 && t3 !== i && this.removeTextContent(), i.innerTransformable = new k1(), this._attachComponent(i), this._textContent = i, this.markRedraw());
      }, o.prototype.setTextConfig = function(i) {
        this.textConfig || (this.textConfig = {}), ti(this.textConfig, i), this.markRedraw();
      }, o.prototype.removeTextConfig = function() {
        this.textConfig = null, this.markRedraw();
      }, o.prototype.removeTextContent = function() {
        var i = this._textContent;
        i && (i.innerTransformable = null, this._detachComponent(i), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
      }, o.prototype.getTextGuideLine = function() {
        return this._textGuide;
      }, o.prototype.setTextGuideLine = function(i) {
        this._textGuide && this._textGuide !== i && this.removeTextGuideLine(), this._attachComponent(i), this._textGuide = i, this.markRedraw();
      }, o.prototype.removeTextGuideLine = function() {
        var i = this._textGuide;
        i && (this._detachComponent(i), this._textGuide = null, this.markRedraw());
      }, o.prototype.markRedraw = function() {
        this.__dirty |= c0;
        var i = this.__zr;
        i && (this.__inHover ? i.refreshHover() : i.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
      }, o.prototype.dirty = function() {
        this.markRedraw();
      }, o.prototype._toggleHoverLayerFlag = function(i) {
        this.__inHover = i;
        var t3 = this._textContent, c3 = this._textGuide;
        t3 && (t3.__inHover = i), c3 && (c3.__inHover = i);
      }, o.prototype.addSelfToZr = function(i) {
        if (this.__zr !== i) {
          this.__zr = i;
          var t3 = this.animators;
          if (t3)
            for (var c3 = 0; c3 < t3.length; c3++)
              i.animation.addAnimator(t3[c3]);
          this._clipPath && this._clipPath.addSelfToZr(i), this._textContent && this._textContent.addSelfToZr(i), this._textGuide && this._textGuide.addSelfToZr(i);
        }
      }, o.prototype.removeSelfFromZr = function(i) {
        if (this.__zr) {
          this.__zr = null;
          var t3 = this.animators;
          if (t3)
            for (var c3 = 0; c3 < t3.length; c3++)
              i.animation.removeAnimator(t3[c3]);
          this._clipPath && this._clipPath.removeSelfFromZr(i), this._textContent && this._textContent.removeSelfFromZr(i), this._textGuide && this._textGuide.removeSelfFromZr(i);
        }
      }, o.prototype.animate = function(i, t3, c3) {
        var p3 = i ? this[i] : this, g3 = new uv(p3, t3, c3);
        return i && (g3.targetName = i), this.addAnimator(g3, i), g3;
      }, o.prototype.addAnimator = function(i, t3) {
        var c3 = this.__zr, p3 = this;
        i.during(function() {
          p3.updateDuringAnimation(t3);
        }).done(function() {
          var g3 = p3.animators, b3 = rl(g3, i);
          b3 >= 0 && g3.splice(b3, 1);
        }), this.animators.push(i), c3 && c3.animation.addAnimator(i), c3 && c3.wakeUp();
      }, o.prototype.updateDuringAnimation = function(i) {
        this.markRedraw();
      }, o.prototype.stopAnimation = function(i, t3) {
        for (var c3 = this.animators, p3 = c3.length, g3 = [], b3 = 0; b3 < p3; b3++) {
          var w3 = c3[b3];
          !i || i === w3.scope ? w3.stop(t3) : g3.push(w3);
        }
        return this.animators = g3, this;
      }, o.prototype.animateTo = function(i, t3, c3) {
        xG(this, i, t3, c3);
      }, o.prototype.animateFrom = function(i, t3, c3) {
        xG(this, i, t3, c3, true);
      }, o.prototype._transitionState = function(i, t3, c3, p3) {
        for (var g3 = xG(this, t3, c3, p3), b3 = 0; b3 < g3.length; b3++)
          g3[b3].__fromStateTransition = i;
      }, o.prototype.getBoundingRect = function() {
        return null;
      }, o.prototype.getPaintRect = function() {
        return null;
      }, o.initDefaultProps = function() {
        var i = o.prototype;
        i.type = "element", i.name = "", i.ignore = i.silent = i.isGroup = i.draggable = i.dragging = i.ignoreClip = i.__inHover = false, i.__dirty = c0;
        function t3(c3, p3, g3, b3) {
          Object.defineProperty(i, c3, { get: function() {
            if (!this[p3]) {
              var M = this[p3] = [];
              w3(this, M);
            }
            return this[p3];
          }, set: function(M) {
            this[g3] = M[0], this[b3] = M[1], this[p3] = M, w3(this, M);
          } });
          function w3(M, I) {
            Object.defineProperty(I, 0, { get: function() {
              return M[g3];
            }, set: function(k3) {
              M[g3] = k3;
            } }), Object.defineProperty(I, 1, { get: function() {
              return M[b3];
            }, set: function(k3) {
              M[b3] = k3;
            } });
          }
        }
        Object.defineProperty && (t3("position", "_legacyPos", "x", "y"), t3("scale", "_legacyScale", "scaleX", "scaleY"), t3("origin", "_legacyOrigin", "originX", "originY"));
      }(), o;
    }();
    Kp(_G, hm), Kp(_G, k1);
    function xG(o, i, t3, c3, p3) {
      t3 = t3 || {};
      var g3 = [];
      py(o, "", o, i, t3, c3, g3, p3);
      var b3 = g3.length, w3 = false, M = t3.done, I = t3.aborted, k3 = function() {
        w3 = true, b3--, b3 <= 0 && (w3 ? M && M() : I && I());
      }, L = function() {
        b3--, b3 <= 0 && (w3 ? M && M() : I && I());
      };
      b3 || M && M(), g3.length > 0 && t3.during && g3[0].during(function(G, J) {
        t3.during(J);
      });
      for (var F = 0; F < g3.length; F++) {
        var B = g3[F];
        k3 && B.done(k3), L && B.aborted(L), t3.force && B.duration(t3.duration), B.start(t3.easing);
      }
      return g3;
    }
    function IF(o, i, t3) {
      for (var c3 = 0; c3 < t3; c3++)
        o[c3] = i[c3];
    }
    function RQ(o) {
      return yg(o[0]);
    }
    function mde(o, i, t3) {
      if (yg(i[t3]))
        if (yg(o[t3]) || (o[t3] = []), w1(i[t3])) {
          var c3 = i[t3].length;
          o[t3].length !== c3 && (o[t3] = new i[t3].constructor(c3), IF(o[t3], i[t3], c3));
        } else {
          var p3 = i[t3], g3 = o[t3], b3 = p3.length;
          if (RQ(p3))
            for (var w3 = p3[0].length, M = 0; M < b3; M++)
              g3[M] ? IF(g3[M], p3[M], w3) : g3[M] = Array.prototype.slice.call(p3[M]);
          else
            IF(g3, p3, b3);
          g3.length = p3.length;
        }
      else
        o[t3] = i[t3];
    }
    function NQ(o, i) {
      return o === i || yg(o) && yg(i) && FQ(o, i);
    }
    function FQ(o, i) {
      var t3 = o.length;
      if (t3 !== i.length)
        return false;
      for (var c3 = 0; c3 < t3; c3++)
        if (o[c3] !== i[c3])
          return false;
      return true;
    }
    function py(o, i, t3, c3, p3, g3, b3, w3) {
      for (var M = Gl(c3), I = p3.duration, k3 = p3.delay, L = p3.additive, F = p3.setToFinal, B = !Ua(g3), G = o.animators, J = [], Q = 0; Q < M.length; Q++) {
        var se = M[Q], he = c3[se];
        if (he != null && t3[se] != null && (B || g3[se]))
          if (Ua(he) && !yg(he) && !rF(he)) {
            if (i) {
              w3 || (t3[se] = he, o.updateDuringAnimation(i));
              continue;
            }
            py(o, se, t3[se], he, p3, g3 && g3[se], b3, w3);
          } else
            J.push(se);
        else
          w3 || (t3[se] = he, o.updateDuringAnimation(i), J.push(se));
      }
      var be = J.length;
      if (!L && be)
        for (var de = 0; de < G.length; de++) {
          var Fe = G[de];
          if (Fe.targetName === i) {
            var Pe = Fe.stopTracks(J);
            if (Pe) {
              var ze = rl(G, Fe);
              G.splice(ze, 1);
            }
          }
        }
      if (p3.force || (J = Zc(J, function(lt2) {
        return !NQ(c3[lt2], t3[lt2]);
      }), be = J.length), be > 0 || p3.force && !b3.length) {
        var $e = void 0, Ke = void 0, nt = void 0;
        if (w3) {
          Ke = {}, F && ($e = {});
          for (var de = 0; de < be; de++) {
            var se = J[de];
            Ke[se] = t3[se], F ? $e[se] = c3[se] : t3[se] = c3[se];
          }
        } else if (F) {
          nt = {};
          for (var de = 0; de < be; de++) {
            var se = J[de];
            nt[se] = E1(t3[se]), mde(t3, c3, se);
          }
        }
        var Fe = new uv(t3, false, false, L ? Zc(G, function(bt) {
          return bt.targetName === i;
        }) : null);
        Fe.targetName = i, p3.scope && (Fe.scope = p3.scope), F && $e && Fe.whenWithKeys(0, $e, J), nt && Fe.whenWithKeys(0, nt, J), Fe.whenWithKeys(I == null ? 500 : I, w3 ? Ke : c3, J).delay(k3 || 0), o.addAnimator(Fe, i), b3.push(Fe);
      }
    }
    var D_ = _G, VQ = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this) || this;
        return c3.isGroup = true, c3._children = [], c3.attr(t3), c3;
      }
      return i.prototype.childrenRef = function() {
        return this._children;
      }, i.prototype.children = function() {
        return this._children.slice();
      }, i.prototype.childAt = function(t3) {
        return this._children[t3];
      }, i.prototype.childOfName = function(t3) {
        for (var c3 = this._children, p3 = 0; p3 < c3.length; p3++)
          if (c3[p3].name === t3)
            return c3[p3];
      }, i.prototype.childCount = function() {
        return this._children.length;
      }, i.prototype.add = function(t3) {
        return t3 && t3 !== this && t3.parent !== this && (this._children.push(t3), this._doAdd(t3)), this;
      }, i.prototype.addBefore = function(t3, c3) {
        if (t3 && t3 !== this && t3.parent !== this && c3 && c3.parent === this) {
          var p3 = this._children, g3 = p3.indexOf(c3);
          g3 >= 0 && (p3.splice(g3, 0, t3), this._doAdd(t3));
        }
        return this;
      }, i.prototype.replace = function(t3, c3) {
        var p3 = rl(this._children, t3);
        return p3 >= 0 && this.replaceAt(c3, p3), this;
      }, i.prototype.replaceAt = function(t3, c3) {
        var p3 = this._children, g3 = p3[c3];
        if (t3 && t3 !== this && t3.parent !== this && t3 !== g3) {
          p3[c3] = t3, g3.parent = null;
          var b3 = this.__zr;
          b3 && g3.removeSelfFromZr(b3), this._doAdd(t3);
        }
        return this;
      }, i.prototype._doAdd = function(t3) {
        t3.parent && t3.parent.remove(t3), t3.parent = this;
        var c3 = this.__zr;
        c3 && c3 !== t3.__zr && t3.addSelfToZr(c3), c3 && c3.refresh();
      }, i.prototype.remove = function(t3) {
        var c3 = this.__zr, p3 = this._children, g3 = rl(p3, t3);
        return g3 < 0 ? this : (p3.splice(g3, 1), t3.parent = null, c3 && t3.removeSelfFromZr(c3), c3 && c3.refresh(), this);
      }, i.prototype.removeAll = function() {
        for (var t3 = this._children, c3 = this.__zr, p3 = 0; p3 < t3.length; p3++) {
          var g3 = t3[p3];
          c3 && g3.removeSelfFromZr(c3), g3.parent = null;
        }
        return t3.length = 0, this;
      }, i.prototype.eachChild = function(t3, c3) {
        for (var p3 = this._children, g3 = 0; g3 < p3.length; g3++) {
          var b3 = p3[g3];
          t3.call(c3, b3, g3);
        }
        return this;
      }, i.prototype.traverse = function(t3, c3) {
        for (var p3 = 0; p3 < this._children.length; p3++) {
          var g3 = this._children[p3], b3 = t3.call(c3, g3);
          g3.isGroup && !b3 && g3.traverse(t3, c3);
        }
        return this;
      }, i.prototype.addSelfToZr = function(t3) {
        o.prototype.addSelfToZr.call(this, t3);
        for (var c3 = 0; c3 < this._children.length; c3++) {
          var p3 = this._children[c3];
          p3.addSelfToZr(t3);
        }
      }, i.prototype.removeSelfFromZr = function(t3) {
        o.prototype.removeSelfFromZr.call(this, t3);
        for (var c3 = 0; c3 < this._children.length; c3++) {
          var p3 = this._children[c3];
          p3.removeSelfFromZr(t3);
        }
      }, i.prototype.getBoundingRect = function(t3) {
        for (var c3 = new Ys(0, 0, 0, 0), p3 = t3 || this._children, g3 = [], b3 = null, w3 = 0; w3 < p3.length; w3++) {
          var M = p3[w3];
          if (!(M.ignore || M.invisible)) {
            var I = M.getBoundingRect(), k3 = M.getLocalTransform(g3);
            k3 ? (Ys.applyTransform(c3, I, k3), b3 = b3 || c3.clone(), b3.union(c3)) : (b3 = b3 || I.clone(), b3.union(I));
          }
        }
        return b3 || c3;
      }, i;
    }(D_);
    VQ.prototype.type = "group";
    var vs = VQ;
    /*!
    * ZRender, a high performance 2d drawing library.
    *
    * Copyright (c) 2013, Baidu Inc.
    * All rights reserved.
    *
    * LICENSE
    * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
    */
    var dI = {}, vI = {};
    function BQ(o) {
      delete vI[o];
    }
    function zQ(o) {
      if (!o)
        return false;
      if (typeof o == "string")
        return vF(o, 1) < vG;
      if (o.colorStops) {
        for (var i = o.colorStops, t3 = 0, c3 = i.length, p3 = 0; p3 < c3; p3++)
          t3 += vF(i[p3].color, 1);
        return t3 /= c3, t3 < vG;
      }
      return false;
    }
    var bde = function() {
      function o(i, t3, c3) {
        var p3 = this;
        this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, c3 = c3 || {}, this.dom = t3, this.id = i;
        var g3 = new Jpe(), b3 = c3.renderer || "canvas";
        dI[b3] || (b3 = Gl(dI)[0]), c3.useDirtyRect = c3.useDirtyRect == null ? false : c3.useDirtyRect;
        var w3 = new dI[b3](t3, g3, c3, i), M = c3.ssr || w3.ssrOnly;
        this.storage = g3, this.painter = w3;
        var I = !yo.node && !yo.worker && !M ? new EQ(w3.getViewportRoot(), w3.root) : null;
        this.handler = new Hl(g3, w3, I, w3.root), this.animation = new hw({ stage: { update: M ? null : function() {
          return p3._flush(true);
        } } }), M || this.animation.start();
      }
      return o.prototype.add = function(i) {
        !i || (this.storage.addRoot(i), i.addSelfToZr(this), this.refresh());
      }, o.prototype.remove = function(i) {
        !i || (this.storage.delRoot(i), i.removeSelfFromZr(this), this.refresh());
      }, o.prototype.configLayer = function(i, t3) {
        this.painter.configLayer && this.painter.configLayer(i, t3), this.refresh();
      }, o.prototype.setBackgroundColor = function(i) {
        this.painter.setBackgroundColor && this.painter.setBackgroundColor(i), this.refresh(), this._backgroundColor = i, this._darkMode = zQ(i);
      }, o.prototype.getBackgroundColor = function() {
        return this._backgroundColor;
      }, o.prototype.setDarkMode = function(i) {
        this._darkMode = i;
      }, o.prototype.isDarkMode = function() {
        return this._darkMode;
      }, o.prototype.refreshImmediately = function(i) {
        i || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
      }, o.prototype.refresh = function() {
        this._needsRefresh = true, this.animation.start();
      }, o.prototype.flush = function() {
        this._flush(false);
      }, o.prototype._flush = function(i) {
        var t3, c3 = IM();
        this._needsRefresh && (t3 = true, this.refreshImmediately(i)), this._needsRefreshHover && (t3 = true, this.refreshHoverImmediately());
        var p3 = IM();
        t3 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: p3 - c3 })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
      }, o.prototype.setSleepAfterStill = function(i) {
        this._sleepAfterStill = i;
      }, o.prototype.wakeUp = function() {
        this.animation.start(), this._stillFrameAccum = 0;
      }, o.prototype.refreshHover = function() {
        this._needsRefreshHover = true;
      }, o.prototype.refreshHoverImmediately = function() {
        this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
      }, o.prototype.resize = function(i) {
        i = i || {}, this.painter.resize(i.width, i.height), this.handler.resize();
      }, o.prototype.clearAnimation = function() {
        this.animation.clear();
      }, o.prototype.getWidth = function() {
        return this.painter.getWidth();
      }, o.prototype.getHeight = function() {
        return this.painter.getHeight();
      }, o.prototype.setCursorStyle = function(i) {
        this.handler.setCursorStyle(i);
      }, o.prototype.findHover = function(i, t3) {
        return this.handler.findHover(i, t3);
      }, o.prototype.on = function(i, t3, c3) {
        return this.handler.on(i, t3, c3), this;
      }, o.prototype.off = function(i, t3) {
        this.handler.off(i, t3);
      }, o.prototype.trigger = function(i, t3) {
        this.handler.trigger(i, t3);
      }, o.prototype.clear = function() {
        for (var i = this.storage.getRoots(), t3 = 0; t3 < i.length; t3++)
          i[t3] instanceof vs && i[t3].removeSelfFromZr(this);
        this.storage.delAllRoots(), this.painter.clear();
      }, o.prototype.dispose = function() {
        this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, BQ(this.id);
      }, o;
    }();
    function wG(o, i) {
      var t3 = new bde(b5(), o, i);
      return vI[t3.id] = t3, t3;
    }
    function W5(o, i) {
      dI[o] = i;
    }
    var U5 = 1e-4, jQ = 20;
    function GQ(o) {
      return o.replace(/^\s+|\s+$/g, "");
    }
    function Bc(o, i, t3, c3) {
      var p3 = i[0], g3 = i[1], b3 = t3[0], w3 = t3[1], M = g3 - p3, I = w3 - b3;
      if (M === 0)
        return I === 0 ? b3 : (b3 + w3) / 2;
      if (c3)
        if (M > 0) {
          if (o <= p3)
            return b3;
          if (o >= g3)
            return w3;
        } else {
          if (o >= p3)
            return b3;
          if (o <= g3)
            return w3;
        }
      else {
        if (o === p3)
          return b3;
        if (o === g3)
          return w3;
      }
      return (o - p3) / M * I + b3;
    }
    function Da(o, i) {
      switch (o) {
        case "center":
        case "middle":
          o = "50%";
          break;
        case "left":
        case "top":
          o = "0%";
          break;
        case "right":
        case "bottom":
          o = "100%";
          break;
      }
      return Ha(o) ? GQ(o).match(/%$/) ? parseFloat(o) / 100 * i : parseFloat(o) : o == null ? NaN : +o;
    }
    function mp(o, i, t3) {
      return i == null && (i = 10), i = Math.min(Math.max(0, i), jQ), o = (+o).toFixed(i), t3 ? o : +o;
    }
    function dy(o) {
      return o.sort(function(i, t3) {
        return i - t3;
      }), o;
    }
    function Tb(o) {
      if (o = +o, isNaN(o))
        return 0;
      if (o > 1e-14) {
        for (var i = 1, t3 = 0; t3 < 15; t3++, i *= 10)
          if (Math.round(o * i) / i === o)
            return t3;
      }
      return EF(o);
    }
    function EF(o) {
      var i = o.toString().toLowerCase(), t3 = i.indexOf("e"), c3 = t3 > 0 ? +i.slice(t3 + 1) : 0, p3 = t3 > 0 ? t3 : i.length, g3 = i.indexOf("."), b3 = g3 < 0 ? 0 : p3 - 1 - g3;
      return Math.max(0, b3 - c3);
    }
    function HQ(o, i) {
      var t3 = Math.log, c3 = Math.LN10, p3 = Math.floor(t3(o[1] - o[0]) / c3), g3 = Math.round(t3(Math.abs(i[1] - i[0])) / c3), b3 = Math.min(Math.max(-p3 + g3, 0), 20);
      return isFinite(b3) ? b3 : 20;
    }
    function WQ(o, i, t3) {
      if (!o[i])
        return 0;
      var c3 = aw(o, function(G, J) {
        return G + (isNaN(J) ? 0 : J);
      }, 0);
      if (c3 === 0)
        return 0;
      for (var p3 = Math.pow(10, t3), g3 = Fi(o, function(G) {
        return (isNaN(G) ? 0 : G) / c3 * p3 * 100;
      }), b3 = p3 * 100, w3 = Fi(g3, function(G) {
        return Math.floor(G);
      }), M = aw(w3, function(G, J) {
        return G + J;
      }, 0), I = Fi(g3, function(G, J) {
        return G - w3[J];
      }); M < b3; ) {
        for (var k3 = Number.NEGATIVE_INFINITY, L = null, F = 0, B = I.length; F < B; ++F)
          I[F] > k3 && (k3 = I[F], L = F);
        ++w3[L], I[L] = 0, ++M;
      }
      return w3[i] / p3;
    }
    function DF(o, i) {
      var t3 = Math.max(Tb(o), Tb(i)), c3 = o + i;
      return t3 > jQ ? c3 : mp(c3, t3);
    }
    var SG = 9007199254740991;
    function kF(o) {
      var i = Math.PI * 2;
      return (o % i + i) % i;
    }
    function OF(o) {
      return o > -U5 && o < U5;
    }
    var UQ = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
    function jv(o) {
      if (o instanceof Date)
        return o;
      if (Ha(o)) {
        var i = UQ.exec(o);
        if (!i)
          return new Date(NaN);
        if (i[8]) {
          var t3 = +i[4] || 0;
          return i[8].toUpperCase() !== "Z" && (t3 -= +i[8].slice(0, 3)), new Date(Date.UTC(+i[1], +(i[2] || 1) - 1, +i[3] || 1, t3, +(i[5] || 0), +i[6] || 0, i[7] ? +i[7].substring(0, 3) : 0));
        } else
          return new Date(+i[1], +(i[2] || 1) - 1, +i[3] || 1, +i[4] || 0, +(i[5] || 0), +i[6] || 0, i[7] ? +i[7].substring(0, 3) : 0);
      } else if (o == null)
        return new Date(NaN);
      return new Date(Math.round(o));
    }
    function qQ(o) {
      return Math.pow(10, PF(o));
    }
    function PF(o) {
      if (o === 0)
        return 0;
      var i = Math.floor(Math.log(o) / Math.LN10);
      return o / Math.pow(10, i) >= 10 && i++, i;
    }
    function $Q(o, i) {
      var t3 = PF(o), c3 = Math.pow(10, t3), p3 = o / c3, g3;
      return i ? p3 < 1.5 ? g3 = 1 : p3 < 2.5 ? g3 = 2 : p3 < 4 ? g3 = 3 : p3 < 7 ? g3 = 5 : g3 = 10 : p3 < 1 ? g3 = 1 : p3 < 2 ? g3 = 2 : p3 < 3 ? g3 = 3 : p3 < 5 ? g3 = 5 : g3 = 10, o = g3 * c3, t3 >= -20 ? +o.toFixed(t3 < 0 ? -t3 : 0) : o;
    }
    function LF(o, i) {
      var t3 = (o.length - 1) * i + 1, c3 = Math.floor(t3), p3 = +o[c3 - 1], g3 = t3 - c3;
      return g3 ? p3 + g3 * (o[c3] - p3) : p3;
    }
    function XQ(o) {
      o.sort(function(M, I) {
        return w3(M, I, 0) ? -1 : 1;
      });
      for (var i = -1 / 0, t3 = 1, c3 = 0; c3 < o.length; ) {
        for (var p3 = o[c3].interval, g3 = o[c3].close, b3 = 0; b3 < 2; b3++)
          p3[b3] <= i && (p3[b3] = i, g3[b3] = b3 ? 1 : 1 - t3), i = p3[b3], t3 = g3[b3];
        p3[0] === p3[1] && g3[0] * g3[1] !== 1 ? o.splice(c3, 1) : c3++;
      }
      return o;
      function w3(M, I, k3) {
        return M.interval[k3] < I.interval[k3] || M.interval[k3] === I.interval[k3] && (M.close[k3] - I.close[k3] === (k3 ? -1 : 1) || !k3 && w3(M, I, 1));
      }
    }
    function G2(o) {
      var i = parseFloat(o);
      return i == o && (i !== 0 || !Ha(o) || o.indexOf("x") <= 0) ? i : NaN;
    }
    function yw(o) {
      return !isNaN(G2(o));
    }
    function RF() {
      return Math.round(Math.random() * 9);
    }
    function NF(o, i) {
      return i === 0 ? o : NF(i, o % i);
    }
    function FF(o, i) {
      return o == null ? i : i == null ? o : o * i / NF(o, i);
    }
    function Fu(o) {
      throw new Error(o);
    }
    function gI(o, i, t3) {
      return (i - o) * t3 + o;
    }
    var Ks = "series\0", NP = "\0_ec_\0";
    function Wc(o) {
      return o instanceof Array ? o : o == null ? [] : [o];
    }
    function O1(o, i, t3) {
      if (o) {
        o[i] = o[i] || {}, o.emphasis = o.emphasis || {}, o.emphasis[i] = o.emphasis[i] || {};
        for (var c3 = 0, p3 = t3.length; c3 < p3; c3++) {
          var g3 = t3[c3];
          !o.emphasis[i].hasOwnProperty(g3) && o[i].hasOwnProperty(g3) && (o.emphasis[i][g3] = o[i][g3]);
        }
      }
    }
    var YQ = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
    function NM(o) {
      return Ua(o) && !Ei(o) && !(o instanceof Date) ? o.value : o;
    }
    function KQ(o) {
      return Ua(o) && !(o instanceof Array);
    }
    function xg(o, i, t3) {
      var c3 = t3 === "normalMerge", p3 = t3 === "replaceMerge", g3 = t3 === "replaceAll";
      o = o || [], i = (i || []).slice();
      var b3 = Eo();
      yt(i, function(M, I) {
        if (!Ua(M)) {
          i[I] = null;
          return;
        }
      });
      var w3 = _de(o, b3, t3);
      return (c3 || p3) && xde(w3, o, b3, i), c3 && ZQ(w3, i), c3 || p3 ? wde(w3, i, p3) : g3 && JQ(w3, i), Sde(w3), w3;
    }
    function _de(o, i, t3) {
      var c3 = [];
      if (t3 === "replaceAll")
        return c3;
      for (var p3 = 0; p3 < o.length; p3++) {
        var g3 = o[p3];
        g3 && g3.id != null && i.set(g3.id, p3), c3.push({ existing: t3 === "replaceMerge" || yI(g3) ? null : g3, newOption: null, keyInfo: null, brandNew: null });
      }
      return c3;
    }
    function xde(o, i, t3, c3) {
      yt(c3, function(p3, g3) {
        if (!(!p3 || p3.id == null)) {
          var b3 = FP(p3.id), w3 = t3.get(b3);
          if (w3 != null) {
            var M = o[w3];
            u0(!M.newOption, 'Duplicated option on id "' + b3 + '".'), M.newOption = p3, M.existing = i[w3], c3[g3] = null;
          }
        }
      });
    }
    function ZQ(o, i) {
      yt(i, function(t3, c3) {
        if (!(!t3 || t3.name == null))
          for (var p3 = 0; p3 < o.length; p3++) {
            var g3 = o[p3].existing;
            if (!o[p3].newOption && g3 && (g3.id == null || t3.id == null) && !yI(t3) && !yI(g3) && QQ("name", g3, t3)) {
              o[p3].newOption = t3, i[c3] = null;
              return;
            }
          }
      });
    }
    function wde(o, i, t3) {
      yt(i, function(c3) {
        if (c3) {
          for (var p3, g3 = 0; (p3 = o[g3]) && (p3.newOption || yI(p3.existing) || p3.existing && c3.id != null && !QQ("id", c3, p3.existing)); )
            g3++;
          p3 ? (p3.newOption = c3, p3.brandNew = t3) : o.push({ newOption: c3, brandNew: t3, existing: null, keyInfo: null }), g3++;
        }
      });
    }
    function JQ(o, i) {
      yt(i, function(t3) {
        o.push({ newOption: t3, brandNew: true, existing: null, keyInfo: null });
      });
    }
    function Sde(o) {
      var i = Eo();
      yt(o, function(t3) {
        var c3 = t3.existing;
        c3 && i.set(c3.id, t3);
      }), yt(o, function(t3) {
        var c3 = t3.newOption;
        u0(!c3 || c3.id == null || !i.get(c3.id) || i.get(c3.id) === t3, "id duplicates: " + (c3 && c3.id)), c3 && c3.id != null && i.set(c3.id, t3), !t3.keyInfo && (t3.keyInfo = {});
      }), yt(o, function(t3, c3) {
        var p3 = t3.existing, g3 = t3.newOption, b3 = t3.keyInfo;
        if (Ua(g3)) {
          if (b3.name = g3.name != null ? FP(g3.name) : p3 ? p3.name : Ks + c3, p3)
            b3.id = FP(p3.id);
          else if (g3.id != null)
            b3.id = FP(g3.id);
          else {
            var w3 = 0;
            do
              b3.id = "\0" + b3.name + "\0" + w3++;
            while (i.get(b3.id));
          }
          i.set(b3.id, t3);
        }
      });
    }
    function QQ(o, i, t3) {
      var c3 = Jf(i[o], null), p3 = Jf(t3[o], null);
      return c3 != null && p3 != null && c3 === p3;
    }
    function FP(o) {
      return Jf(o, "");
    }
    function Jf(o, i) {
      return o == null ? i : Ha(o) ? o : ec(o) || jj(o) ? o + "" : i;
    }
    function wg(o) {
      var i = o.name;
      return !!(i && i.indexOf(Ks));
    }
    function yI(o) {
      return o && o.id != null && FP(o.id).indexOf(NP) === 0;
    }
    function Cde(o) {
      return NP + o;
    }
    function CG(o, i, t3) {
      yt(o, function(c3) {
        var p3 = c3.newOption;
        Ua(p3) && (c3.keyInfo.mainType = i, c3.keyInfo.subType = Mde(i, p3, c3.existing, t3));
      });
    }
    function Mde(o, i, t3, c3) {
      var p3 = i.type ? i.type : t3 ? t3.subType : c3.determineSubType(o, i);
      return p3;
    }
    function Tde(o, i) {
      var t3 = {}, c3 = {};
      return p3(o || [], t3), p3(i || [], c3, t3), [g3(t3), g3(c3)];
      function p3(b3, w3, M) {
        for (var I = 0, k3 = b3.length; I < k3; I++) {
          var L = Jf(b3[I].seriesId, null);
          if (L == null)
            return;
          for (var F = Wc(b3[I].dataIndex), B = M && M[L], G = 0, J = F.length; G < J; G++) {
            var Q = F[G];
            B && B[Q] ? B[Q] = null : (w3[L] || (w3[L] = {}))[Q] = 1;
          }
        }
      }
      function g3(b3, w3) {
        var M = [];
        for (var I in b3)
          if (b3.hasOwnProperty(I) && b3[I] != null)
            if (w3)
              M.push(+I);
            else {
              var k3 = g3(b3[I], true);
              k3.length && M.push({ seriesId: I, dataIndex: k3 });
            }
        return M;
      }
    }
    function k_(o, i) {
      if (i.dataIndexInside != null)
        return i.dataIndexInside;
      if (i.dataIndex != null)
        return Ei(i.dataIndex) ? Fi(i.dataIndex, function(t3) {
          return o.indexOfRawIndex(t3);
        }) : o.indexOfRawIndex(i.dataIndex);
      if (i.name != null)
        return Ei(i.name) ? Fi(i.name, function(t3) {
          return o.indexOfName(t3);
        }) : o.indexOfName(i.name);
    }
    function mu() {
      var o = "__ec_inner_" + eee++;
      return function(i) {
        return i[o] || (i[o] = {});
      };
    }
    var eee = RF();
    function VP(o, i, t3) {
      var c3 = MG(i, t3), p3 = c3.mainTypeSpecified, g3 = c3.queryOptionMap, b3 = c3.others, w3 = b3, M = t3 ? t3.defaultMainType : null;
      return !p3 && M && g3.set(M, {}), g3.each(function(I, k3) {
        var L = q5(o, k3, I, { useDefault: M === k3, enableAll: t3 && t3.enableAll != null ? t3.enableAll : true, enableNone: t3 && t3.enableNone != null ? t3.enableNone : true });
        w3[k3 + "Models"] = L.models, w3[k3 + "Model"] = L.models[0];
      }), w3;
    }
    function MG(o, i) {
      var t3;
      if (Ha(o)) {
        var c3 = {};
        c3[o + "Index"] = 0, t3 = c3;
      } else
        t3 = o;
      var p3 = Eo(), g3 = {}, b3 = false;
      return yt(t3, function(w3, M) {
        if (M === "dataIndex" || M === "dataIndexInside") {
          g3[M] = w3;
          return;
        }
        var I = M.match(/^(\w+)(Index|Id|Name)$/) || [], k3 = I[1], L = (I[2] || "").toLowerCase();
        if (!(!k3 || !L || i && i.includeMainTypes && rl(i.includeMainTypes, k3) < 0)) {
          b3 = b3 || !!k3;
          var F = p3.get(k3) || p3.set(k3, {});
          F[L] = w3;
        }
      }), { mainTypeSpecified: b3, queryOptionMap: p3, others: g3 };
    }
    var xd = { useDefault: true, enableAll: false, enableNone: false }, Ade = { useDefault: false, enableAll: true, enableNone: true };
    function q5(o, i, t3, c3) {
      c3 = c3 || xd;
      var p3 = t3.index, g3 = t3.id, b3 = t3.name, w3 = { models: null, specified: p3 != null || g3 != null || b3 != null };
      if (!w3.specified) {
        var M = void 0;
        return w3.models = c3.useDefault && (M = o.getComponent(i)) ? [M] : [], w3;
      }
      return p3 === "none" || p3 === false ? (u0(c3.enableNone, '`"none"` or `false` is not a valid value on index option.'), w3.models = [], w3) : (p3 === "all" && (u0(c3.enableAll, '`"all"` is not a valid value on index option.'), p3 = g3 = b3 = null), w3.models = o.queryComponents({ mainType: i, index: p3, id: g3, name: b3 }), w3);
    }
    function TG(o, i, t3) {
      o.setAttribute ? o.setAttribute(i, t3) : o[i] = t3;
    }
    function Ide(o, i) {
      return o.getAttribute ? o.getAttribute(i) : o[i];
    }
    function AG(o) {
      return o === "auto" ? yo.domSupported ? "html" : "richText" : o || "html";
    }
    function VF(o, i) {
      var t3 = Eo(), c3 = [];
      return yt(o, function(p3) {
        var g3 = i(p3);
        (t3.get(g3) || (c3.push(g3), t3.set(g3, []))).push(p3);
      }), { keys: c3, buckets: t3 };
    }
    function $5(o, i, t3, c3, p3) {
      var g3 = i == null || i === "auto";
      if (c3 == null)
        return c3;
      if (ec(c3)) {
        var b3 = gI(t3 || 0, c3, p3);
        return mp(b3, g3 ? Math.max(Tb(t3 || 0), Tb(c3)) : i);
      } else {
        if (Ha(c3))
          return p3 < 1 ? t3 : c3;
        for (var w3 = [], M = t3, I = c3, k3 = Math.max(M ? M.length : 0, I.length), L = 0; L < k3; ++L) {
          var F = o.getDimensionInfo(L);
          if (F && F.type === "ordinal")
            w3[L] = (p3 < 1 && M ? M : I)[L];
          else {
            var B = M && M[L] ? M[L] : 0, G = I[L], b3 = gI(B, G, p3);
            w3[L] = mp(b3, g3 ? Math.max(Tb(B), Tb(G)) : i);
          }
        }
        return w3;
      }
    }
    var IG = ".", FM = "___EC__COMPONENT__CONTAINER___", EG = "___EC__EXTENDED_CLASS___";
    function P1(o) {
      var i = { main: "", sub: "" };
      if (o) {
        var t3 = o.split(IG);
        i.main = t3[0] || "", i.sub = t3[1] || "";
      }
      return i;
    }
    function tee(o) {
      u0(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(o), 'componentType "' + o + '" illegal');
    }
    function mw(o) {
      return !!(o && o[EG]);
    }
    function H2(o, i) {
      o.$constructor = o, o.extend = function(t3) {
        var c3 = this, p3;
        return Ede(c3) ? p3 = function(g3) {
          cn(b3, g3);
          function b3() {
            return g3.apply(this, arguments) || this;
          }
          return b3;
        }(c3) : (p3 = function() {
          (t3.$constructor || c3).apply(this, arguments);
        }, tQ(p3, this)), ti(p3.prototype, t3), p3[EG] = true, p3.extend = this.extend, p3.superCall = Ode, p3.superApply = Pde, p3.superClass = c3, p3;
      };
    }
    function Ede(o) {
      return Vo(o) && /^class\s/.test(Function.prototype.toString.call(o));
    }
    function DG(o, i) {
      o.extend = i.extend;
    }
    var Dde = Math.round(Math.random() * 10);
    function kde(o) {
      var i = ["__\0is_clz", Dde++].join("_");
      o.prototype[i] = true, o.isInstance = function(t3) {
        return !!(t3 && t3[i]);
      };
    }
    function Ode(o, i) {
      for (var t3 = [], c3 = 2; c3 < arguments.length; c3++)
        t3[c3 - 2] = arguments[c3];
      return this.superClass.prototype[i].apply(o, t3);
    }
    function Pde(o, i, t3) {
      return this.superClass.prototype[i].apply(o, t3);
    }
    function BF(o) {
      var i = {};
      o.registerClass = function(c3) {
        var p3 = c3.type || c3.prototype.type;
        if (p3) {
          tee(p3), c3.prototype.type = p3;
          var g3 = P1(p3);
          if (!g3.sub)
            i[g3.main] = c3;
          else if (g3.sub !== FM) {
            var b3 = t3(g3);
            b3[g3.sub] = c3;
          }
        }
        return c3;
      }, o.getClass = function(c3, p3, g3) {
        var b3 = i[c3];
        if (b3 && b3[FM] && (b3 = p3 ? b3[p3] : null), g3 && !b3)
          throw new Error(p3 ? "Component " + c3 + "." + (p3 || "") + " is used but not imported." : c3 + ".type should be specified.");
        return b3;
      }, o.getClassesByMainType = function(c3) {
        var p3 = P1(c3), g3 = [], b3 = i[p3.main];
        return b3 && b3[FM] ? yt(b3, function(w3, M) {
          M !== FM && g3.push(w3);
        }) : g3.push(b3), g3;
      }, o.hasClass = function(c3) {
        var p3 = P1(c3);
        return !!i[p3.main];
      }, o.getAllClassMainTypes = function() {
        var c3 = [];
        return yt(i, function(p3, g3) {
          c3.push(g3);
        }), c3;
      }, o.hasSubTypes = function(c3) {
        var p3 = P1(c3), g3 = i[p3.main];
        return g3 && g3[FM];
      };
      function t3(c3) {
        var p3 = i[c3.main];
        return (!p3 || !p3[FM]) && (p3 = i[c3.main] = {}, p3[FM] = true), p3;
      }
    }
    function mI(o, i) {
      for (var t3 = 0; t3 < o.length; t3++)
        o[t3][1] || (o[t3][1] = o[t3][0]);
      return i = i || false, function(c3, p3, g3) {
        for (var b3 = {}, w3 = 0; w3 < o.length; w3++) {
          var M = o[w3][1];
          if (!(p3 && rl(p3, M) >= 0 || g3 && rl(g3, M) < 0)) {
            var I = c3.getShallow(M, i);
            I != null && (b3[o[w3][0]] = I);
          }
        }
        return b3;
      };
    }
    var Lde = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], Rde = mI(Lde), Nde = function() {
      function o() {
      }
      return o.prototype.getAreaStyle = function(i, t3) {
        return Rde(this, i, t3);
      }, o;
    }(), kG = new TP(50);
    function Fde(o) {
      if (typeof o == "string") {
        var i = kG.get(o);
        return i && i.image;
      } else
        return o;
    }
    function zF(o, i, t3, c3, p3) {
      if (o)
        if (typeof o == "string") {
          if (i && i.__zrImageSrc === o || !t3)
            return i;
          var g3 = kG.get(o), b3 = { hostEl: t3, cb: c3, cbPayload: p3 };
          if (g3)
            i = g3.image, !BP(i) && g3.pending.push(b3);
          else {
            var w3 = cm.loadImage(o, OG, OG);
            w3.__zrImageSrc = o, kG.put(o, w3.__cachedImgObj = { image: w3, pending: [b3] });
          }
          return i;
        } else
          return o;
      else
        return i;
    }
    function OG() {
      var o = this.__cachedImgObj;
      this.onload = this.onerror = this.__cachedImgObj = null;
      for (var i = 0; i < o.pending.length; i++) {
        var t3 = o.pending[i], c3 = t3.cb;
        c3 && c3(this, t3.cbPayload), t3.hostEl.dirty();
      }
      o.pending.length = 0;
    }
    function BP(o) {
      return o && o.width && o.height;
    }
    var PG = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
    function Vde(o, i, t3, c3, p3) {
      if (!i)
        return "";
      var g3 = (o + "").split(`
`);
      p3 = nee(i, t3, c3, p3);
      for (var b3 = 0, w3 = g3.length; b3 < w3; b3++)
        g3[b3] = LG(g3[b3], p3);
      return g3.join(`
`);
    }
    function nee(o, i, t3, c3) {
      c3 = c3 || {};
      var p3 = ti({}, c3);
      p3.font = i, t3 = Xs(t3, "..."), p3.maxIterations = Xs(c3.maxIterations, 2);
      var g3 = p3.minChar = Xs(c3.minChar, 0);
      p3.cnCharWidth = p0("\u56FD", i);
      var b3 = p3.ascCharWidth = p0("a", i);
      p3.placeholder = Xs(c3.placeholder, "");
      for (var w3 = o = Math.max(0, o - 1), M = 0; M < g3 && w3 >= b3; M++)
        w3 -= b3;
      var I = p0(t3, i);
      return I > w3 && (t3 = "", I = 0), w3 = o - I, p3.ellipsis = t3, p3.ellipsisWidth = I, p3.contentWidth = w3, p3.containerWidth = o, p3;
    }
    function LG(o, i) {
      var t3 = i.containerWidth, c3 = i.font, p3 = i.contentWidth;
      if (!t3)
        return "";
      var g3 = p0(o, c3);
      if (g3 <= t3)
        return o;
      for (var b3 = 0; ; b3++) {
        if (g3 <= p3 || b3 >= i.maxIterations) {
          o += i.ellipsis;
          break;
        }
        var w3 = b3 === 0 ? Bde(o, p3, i.ascCharWidth, i.cnCharWidth) : g3 > 0 ? Math.floor(o.length * p3 / g3) : 0;
        o = o.substr(0, w3), g3 = p0(o, c3);
      }
      return o === "" && (o = i.placeholder), o;
    }
    function Bde(o, i, t3, c3) {
      for (var p3 = 0, g3 = 0, b3 = o.length; g3 < b3 && p3 < i; g3++) {
        var w3 = o.charCodeAt(g3);
        p3 += 0 <= w3 && w3 <= 127 ? t3 : c3;
      }
      return g3;
    }
    function zde(o, i) {
      o != null && (o += "");
      var t3 = i.overflow, c3 = i.padding, p3 = i.font, g3 = t3 === "truncate", b3 = H5(p3), w3 = Xs(i.lineHeight, b3), M = !!i.backgroundColor, I = i.lineOverflow === "truncate", k3 = i.width, L;
      k3 != null && (t3 === "break" || t3 === "breakAll") ? L = o ? RG(o, i.font, k3, t3 === "breakAll", 0).lines : [] : L = o ? o.split(`
`) : [];
      var F = L.length * w3, B = Xs(i.height, F);
      if (F > B && I) {
        var G = Math.floor(B / w3);
        L = L.slice(0, G);
      }
      if (o && g3 && k3 != null)
        for (var J = nee(k3, p3, i.ellipsis, { minChar: i.truncateMinChar, placeholder: i.placeholder }), Q = 0; Q < L.length; Q++)
          L[Q] = LG(L[Q], J);
      for (var se = B, he = 0, Q = 0; Q < L.length; Q++)
        he = Math.max(p0(L[Q], p3), he);
      k3 == null && (k3 = he);
      var be = he;
      return c3 && (se += c3[0] + c3[2], be += c3[1] + c3[3], k3 += c3[1] + c3[3]), M && (be = k3), { lines: L, height: B, outerWidth: be, outerHeight: se, lineHeight: w3, calculatedLineHeight: b3, contentWidth: he, contentHeight: F, width: k3 };
    }
    var jde = function() {
      function o() {
      }
      return o;
    }(), ree = function() {
      function o(i) {
        this.tokens = [], i && (this.tokens = i);
      }
      return o;
    }(), Gde = function() {
      function o() {
        this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
      }
      return o;
    }();
    function Hde(o, i) {
      var t3 = new Gde();
      if (o != null && (o += ""), !o)
        return t3;
      for (var c3 = i.width, p3 = i.height, g3 = i.overflow, b3 = (g3 === "break" || g3 === "breakAll") && c3 != null ? { width: c3, accumWidth: 0, breakAll: g3 === "breakAll" } : null, w3 = PG.lastIndex = 0, M; (M = PG.exec(o)) != null; ) {
        var I = M.index;
        I > w3 && vm(t3, o.substring(w3, I), i, b3), vm(t3, M[2], i, b3, M[1]), w3 = PG.lastIndex;
      }
      w3 < o.length && vm(t3, o.substring(w3, o.length), i, b3);
      var k3 = [], L = 0, F = 0, B = i.padding, G = g3 === "truncate", J = i.lineOverflow === "truncate";
      function Q(ln, vn, kn) {
        ln.width = vn, ln.lineHeight = kn, L += kn, F = Math.max(F, vn);
      }
      e:
        for (var se = 0; se < t3.lines.length; se++) {
          for (var he = t3.lines[se], be = 0, de = 0, Fe = 0; Fe < he.tokens.length; Fe++) {
            var Pe = he.tokens[Fe], ze = Pe.styleName && i.rich[Pe.styleName] || {}, $e = Pe.textPadding = ze.padding, Ke = $e ? $e[1] + $e[3] : 0, nt = Pe.font = ze.font || i.font;
            Pe.contentHeight = H5(nt);
            var lt2 = Xs(ze.height, Pe.contentHeight);
            if (Pe.innerHeight = lt2, $e && (lt2 += $e[0] + $e[2]), Pe.height = lt2, Pe.lineHeight = np(ze.lineHeight, i.lineHeight, lt2), Pe.align = ze && ze.align || i.align, Pe.verticalAlign = ze && ze.verticalAlign || "middle", J && p3 != null && L + Pe.lineHeight > p3) {
              Fe > 0 ? (he.tokens = he.tokens.slice(0, Fe), Q(he, de, be), t3.lines = t3.lines.slice(0, se + 1)) : t3.lines = t3.lines.slice(0, se);
              break e;
            }
            var bt = ze.width, vt = bt == null || bt === "auto";
            if (typeof bt == "string" && bt.charAt(bt.length - 1) === "%")
              Pe.percentWidth = bt, k3.push(Pe), Pe.contentWidth = p0(Pe.text, nt);
            else {
              if (vt) {
                var jt = ze.backgroundColor, Jt = jt && jt.image;
                Jt && (Jt = Fde(Jt), BP(Jt) && (Pe.width = Math.max(Pe.width, Jt.width * lt2 / Jt.height)));
              }
              var Rt = G && c3 != null ? c3 - de : null;
              Rt != null && Rt < Pe.width ? !vt || Rt < Ke ? (Pe.text = "", Pe.width = Pe.contentWidth = 0) : (Pe.text = Vde(Pe.text, Rt - Ke, nt, i.ellipsis, { minChar: i.truncateMinChar }), Pe.width = Pe.contentWidth = p0(Pe.text, nt)) : Pe.contentWidth = p0(Pe.text, nt);
            }
            Pe.width += Ke, de += Pe.width, ze && (be = Math.max(be, Pe.lineHeight));
          }
          Q(he, de, be);
        }
      t3.outerWidth = t3.width = Xs(c3, F), t3.outerHeight = t3.height = Xs(p3, L), t3.contentHeight = L, t3.contentWidth = F, B && (t3.outerWidth += B[1] + B[3], t3.outerHeight += B[0] + B[2]);
      for (var se = 0; se < k3.length; se++) {
        var Pe = k3[se], Jn = Pe.percentWidth;
        Pe.width = parseInt(Jn, 10) / 100 * t3.width;
      }
      return t3;
    }
    function vm(o, i, t3, c3, p3) {
      var g3 = i === "", b3 = p3 && t3.rich[p3] || {}, w3 = o.lines, M = b3.font || t3.font, I = false, k3, L;
      if (c3) {
        var F = b3.padding, B = F ? F[1] + F[3] : 0;
        if (b3.width != null && b3.width !== "auto") {
          var G = zv(b3.width, c3.width) + B;
          w3.length > 0 && G + c3.accumWidth > c3.width && (k3 = i.split(`
`), I = true), c3.accumWidth = G;
        } else {
          var J = RG(i, M, c3.width, c3.breakAll, c3.accumWidth);
          c3.accumWidth = J.accumWidth + B, L = J.linesWidths, k3 = J.lines;
        }
      } else
        k3 = i.split(`
`);
      for (var Q = 0; Q < k3.length; Q++) {
        var se = k3[Q], he = new jde();
        if (he.styleName = p3, he.text = se, he.isLineHolder = !se && !g3, typeof b3.width == "number" ? he.width = b3.width : he.width = L ? L[Q] : p0(se, M), !Q && !I) {
          var be = (w3[w3.length - 1] || (w3[0] = new ree())).tokens, de = be.length;
          de === 1 && be[0].isLineHolder ? be[0] = he : (se || !de || g3) && be.push(he);
        } else
          w3.push(new ree([he]));
      }
    }
    function Wde(o) {
      var i = o.charCodeAt(0);
      return i >= 33 && i <= 383;
    }
    var Ude = aw(",&?/;] ".split(""), function(o, i) {
      return o[i] = true, o;
    }, {});
    function qde(o) {
      return Wde(o) ? !!Ude[o] : true;
    }
    function RG(o, i, t3, c3, p3) {
      for (var g3 = [], b3 = [], w3 = "", M = "", I = 0, k3 = 0, L = 0; L < o.length; L++) {
        var F = o.charAt(L);
        if (F === `
`) {
          M && (w3 += M, k3 += I), g3.push(w3), b3.push(k3), w3 = "", M = "", I = 0, k3 = 0;
          continue;
        }
        var B = p0(F, i), G = c3 ? false : !qde(F);
        if (g3.length ? k3 + B > t3 : p3 + k3 + B > t3) {
          k3 ? (w3 || M) && (G ? (w3 || (w3 = M, M = "", I = 0, k3 = I), g3.push(w3), b3.push(k3 - I), M += F, I += B, w3 = "", k3 = I) : (M && (w3 += M, M = "", I = 0), g3.push(w3), b3.push(k3), w3 = F, k3 = B)) : G ? (g3.push(M), b3.push(I), M = F, I = B) : (g3.push(F), b3.push(B));
          continue;
        }
        k3 += B, G ? (M += F, I += B) : (M && (w3 += M, M = "", I = 0), w3 += F);
      }
      return !g3.length && !w3 && (w3 = o, M = "", I = 0), M && (w3 += M), w3 && (g3.push(w3), b3.push(k3)), g3.length === 1 && (k3 += p3), { accumWidth: k3, lines: g3, linesWidths: b3 };
    }
    var NG = "__zr_style_" + Math.round(Math.random() * 10), bI = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, jF = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
    bI[NG] = true;
    var iee = ["z", "z2", "invisible"], FG = ["invisible"], $de = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype._init = function(t3) {
        for (var c3 = Gl(t3), p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          g3 === "style" ? this.useStyle(t3[g3]) : o.prototype.attrKV.call(this, g3, t3[g3]);
        }
        this.style || this.useStyle({});
      }, i.prototype.beforeBrush = function() {
      }, i.prototype.afterBrush = function() {
      }, i.prototype.innerBeforeBrush = function() {
      }, i.prototype.innerAfterBrush = function() {
      }, i.prototype.shouldBePainted = function(t3, c3, p3, g3) {
        var b3 = this.transform;
        if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && Xde(this, t3, c3) || b3 && !b3[0] && !b3[3])
          return false;
        if (p3 && this.__clipPaths) {
          for (var w3 = 0; w3 < this.__clipPaths.length; ++w3)
            if (this.__clipPaths[w3].isZeroArea())
              return false;
        }
        if (g3 && this.parent)
          for (var M = this.parent; M; ) {
            if (M.ignore)
              return false;
            M = M.parent;
          }
        return true;
      }, i.prototype.contain = function(t3, c3) {
        return this.rectContain(t3, c3);
      }, i.prototype.traverse = function(t3, c3) {
        t3.call(c3, this);
      }, i.prototype.rectContain = function(t3, c3) {
        var p3 = this.transformCoordToLocal(t3, c3), g3 = this.getBoundingRect();
        return g3.contain(p3[0], p3[1]);
      }, i.prototype.getPaintRect = function() {
        var t3 = this._paintRect;
        if (!this._paintRect || this.__dirty) {
          var c3 = this.transform, p3 = this.getBoundingRect(), g3 = this.style, b3 = g3.shadowBlur || 0, w3 = g3.shadowOffsetX || 0, M = g3.shadowOffsetY || 0;
          t3 = this._paintRect || (this._paintRect = new Ys(0, 0, 0, 0)), c3 ? Ys.applyTransform(t3, p3, c3) : t3.copy(p3), (b3 || w3 || M) && (t3.width += b3 * 2 + Math.abs(w3), t3.height += b3 * 2 + Math.abs(M), t3.x = Math.min(t3.x, t3.x + w3 - b3), t3.y = Math.min(t3.y, t3.y + M - b3));
          var I = this.dirtyRectTolerance;
          t3.isZero() || (t3.x = Math.floor(t3.x - I), t3.y = Math.floor(t3.y - I), t3.width = Math.ceil(t3.width + 1 + I * 2), t3.height = Math.ceil(t3.height + 1 + I * 2));
        }
        return t3;
      }, i.prototype.setPrevPaintRect = function(t3) {
        t3 ? (this._prevPaintRect = this._prevPaintRect || new Ys(0, 0, 0, 0), this._prevPaintRect.copy(t3)) : this._prevPaintRect = null;
      }, i.prototype.getPrevPaintRect = function() {
        return this._prevPaintRect;
      }, i.prototype.animateStyle = function(t3) {
        return this.animate("style", t3);
      }, i.prototype.updateDuringAnimation = function(t3) {
        t3 === "style" ? this.dirtyStyle() : this.markRedraw();
      }, i.prototype.attrKV = function(t3, c3) {
        t3 !== "style" ? o.prototype.attrKV.call(this, t3, c3) : this.style ? this.setStyle(c3) : this.useStyle(c3);
      }, i.prototype.setStyle = function(t3, c3) {
        return typeof t3 == "string" ? this.style[t3] = c3 : ti(this.style, t3), this.dirtyStyle(), this;
      }, i.prototype.dirtyStyle = function(t3) {
        t3 || this.markRedraw(), this.__dirty |= Jc, this._rect && (this._rect = null);
      }, i.prototype.dirty = function() {
        this.dirtyStyle();
      }, i.prototype.styleChanged = function() {
        return !!(this.__dirty & Jc);
      }, i.prototype.styleUpdated = function() {
        this.__dirty &= ~Jc;
      }, i.prototype.createStyle = function(t3) {
        return gP(bI, t3);
      }, i.prototype.useStyle = function(t3) {
        t3[NG] || (t3 = this.createStyle(t3)), this.__inHover ? this.__hoverStyle = t3 : this.style = t3, this.dirtyStyle();
      }, i.prototype.isStyleObject = function(t3) {
        return t3[NG];
      }, i.prototype._innerSaveToNormal = function(t3) {
        o.prototype._innerSaveToNormal.call(this, t3);
        var c3 = this._normalState;
        t3.style && !c3.style && (c3.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(t3, c3, iee);
      }, i.prototype._applyStateObj = function(t3, c3, p3, g3, b3, w3) {
        o.prototype._applyStateObj.call(this, t3, c3, p3, g3, b3, w3);
        var M = !(c3 && g3), I;
        if (c3 && c3.style ? b3 ? g3 ? I = c3.style : (I = this._mergeStyle(this.createStyle(), p3.style), this._mergeStyle(I, c3.style)) : (I = this._mergeStyle(this.createStyle(), g3 ? this.style : p3.style), this._mergeStyle(I, c3.style)) : M && (I = p3.style), I)
          if (b3) {
            var k3 = this.style;
            if (this.style = this.createStyle(M ? {} : k3), M)
              for (var L = Gl(k3), F = 0; F < L.length; F++) {
                var B = L[F];
                B in I && (I[B] = I[B], this.style[B] = k3[B]);
              }
            for (var G = Gl(I), F = 0; F < G.length; F++) {
              var B = G[F];
              this.style[B] = this.style[B];
            }
            this._transitionState(t3, { style: I }, w3, this.getAnimationStyleProps());
          } else
            this.useStyle(I);
        for (var J = this.__inHover ? FG : iee, F = 0; F < J.length; F++) {
          var B = J[F];
          c3 && c3[B] != null ? this[B] = c3[B] : M && p3[B] != null && (this[B] = p3[B]);
        }
      }, i.prototype._mergeStates = function(t3) {
        for (var c3 = o.prototype._mergeStates.call(this, t3), p3, g3 = 0; g3 < t3.length; g3++) {
          var b3 = t3[g3];
          b3.style && (p3 = p3 || {}, this._mergeStyle(p3, b3.style));
        }
        return p3 && (c3.style = p3), c3;
      }, i.prototype._mergeStyle = function(t3, c3) {
        return ti(t3, c3), t3;
      }, i.prototype.getAnimationStyleProps = function() {
        return jF;
      }, i.initDefaultProps = function() {
        var t3 = i.prototype;
        t3.type = "displayable", t3.invisible = false, t3.z = 0, t3.z2 = 0, t3.zlevel = 0, t3.culling = false, t3.cursor = "pointer", t3.rectHover = false, t3.incremental = false, t3._rect = null, t3.dirtyRectTolerance = 0, t3.__dirty = c0 | Jc;
      }(), i;
    }(D_), VG = new Ys(0, 0, 0, 0), BG = new Ys(0, 0, 0, 0);
    function Xde(o, i, t3) {
      return VG.copy(o.getBoundingRect()), o.transform && VG.applyTransform(o.transform), BG.width = i, BG.height = t3, !VG.intersect(BG);
    }
    var Ab = $de, gm = Math.min, ym = Math.max, zG = Math.sin, jG = Math.cos, _I = Math.PI * 2, GF = wM(), HF = wM(), WF = wM();
    function UF(o, i, t3) {
      if (o.length !== 0) {
        for (var c3 = o[0], p3 = c3[0], g3 = c3[0], b3 = c3[1], w3 = c3[1], M = 1; M < o.length; M++)
          c3 = o[M], p3 = gm(p3, c3[0]), g3 = ym(g3, c3[0]), b3 = gm(b3, c3[1]), w3 = ym(w3, c3[1]);
        i[0] = p3, i[1] = b3, t3[0] = g3, t3[1] = w3;
      }
    }
    function aee(o, i, t3, c3, p3, g3) {
      p3[0] = gm(o, t3), p3[1] = gm(i, c3), g3[0] = ym(o, t3), g3[1] = ym(i, c3);
    }
    var oee = [], see = [];
    function Yde(o, i, t3, c3, p3, g3, b3, w3, M, I) {
      var k3 = hQ, L = Jp, F = k3(o, t3, p3, b3, oee);
      M[0] = 1 / 0, M[1] = 1 / 0, I[0] = -1 / 0, I[1] = -1 / 0;
      for (var B = 0; B < F; B++) {
        var G = L(o, t3, p3, b3, oee[B]);
        M[0] = gm(G, M[0]), I[0] = ym(G, I[0]);
      }
      F = k3(i, c3, g3, w3, see);
      for (var B = 0; B < F; B++) {
        var J = L(i, c3, g3, w3, see[B]);
        M[1] = gm(J, M[1]), I[1] = ym(J, I[1]);
      }
      M[0] = gm(o, M[0]), I[0] = ym(o, I[0]), M[0] = gm(b3, M[0]), I[0] = ym(b3, I[0]), M[1] = gm(i, M[1]), I[1] = ym(i, I[1]), M[1] = gm(w3, M[1]), I[1] = ym(w3, I[1]);
    }
    function Kde(o, i, t3, c3, p3, g3, b3, w3) {
      var M = dQ, I = Dc, k3 = ym(gm(M(o, t3, p3), 1), 0), L = ym(gm(M(i, c3, g3), 1), 0), F = I(o, t3, p3, k3), B = I(i, c3, g3, L);
      b3[0] = gm(o, p3, F), b3[1] = gm(i, g3, B), w3[0] = ym(o, p3, F), w3[1] = ym(i, g3, B);
    }
    function Zde(o, i, t3, c3, p3, g3, b3, w3, M) {
      var I = L2, k3 = sw, L = Math.abs(p3 - g3);
      if (L % _I < 1e-4 && L > 1e-4) {
        w3[0] = o - t3, w3[1] = i - c3, M[0] = o + t3, M[1] = i + c3;
        return;
      }
      if (GF[0] = jG(p3) * t3 + o, GF[1] = zG(p3) * c3 + i, HF[0] = jG(g3) * t3 + o, HF[1] = zG(g3) * c3 + i, I(w3, GF, HF), k3(M, GF, HF), p3 = p3 % _I, p3 < 0 && (p3 = p3 + _I), g3 = g3 % _I, g3 < 0 && (g3 = g3 + _I), p3 > g3 && !b3 ? g3 += _I : p3 < g3 && b3 && (p3 += _I), b3) {
        var F = g3;
        g3 = p3, p3 = F;
      }
      for (var B = 0; B < g3; B += Math.PI / 2)
        B > p3 && (WF[0] = jG(B) * t3 + o, WF[1] = zG(B) * c3 + i, I(w3, WF, w3), k3(M, WF, M));
    }
    var ff = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, VM = [], xI = [], bw = [], BM = [], _w = [], xw = [], GG = Math.min, HG = Math.max, wI = Math.cos, zM = Math.sin, W2 = Math.abs, X5 = Math.PI, jM = X5 * 2, WG = typeof Float32Array != "undefined", zP = [];
    function UG(o) {
      var i = Math.round(o / X5 * 1e8) / 1e8;
      return i % 2 * X5;
    }
    function Jde(o, i) {
      var t3 = UG(o[0]);
      t3 < 0 && (t3 += jM);
      var c3 = t3 - o[0], p3 = o[1];
      p3 += c3, !i && p3 - t3 >= jM ? p3 = t3 + jM : i && t3 - p3 >= jM ? p3 = t3 - jM : !i && t3 > p3 ? p3 = t3 + (jM - UG(t3 - p3)) : i && t3 < p3 && (p3 = t3 - (jM - UG(p3 - t3))), o[0] = t3, o[1] = p3;
    }
    var Qde = function() {
      function o(i) {
        this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, i && (this._saveData = false), this._saveData && (this.data = []);
      }
      return o.prototype.increaseVersion = function() {
        this._version++;
      }, o.prototype.getVersion = function() {
        return this._version;
      }, o.prototype.setScale = function(i, t3, c3) {
        c3 = c3 || 0, c3 > 0 && (this._ux = W2(c3 / xF / i) || 0, this._uy = W2(c3 / xF / t3) || 0);
      }, o.prototype.setDPR = function(i) {
        this.dpr = i;
      }, o.prototype.setContext = function(i) {
        this._ctx = i;
      }, o.prototype.getContext = function() {
        return this._ctx;
      }, o.prototype.beginPath = function() {
        return this._ctx && this._ctx.beginPath(), this.reset(), this;
      }, o.prototype.reset = function() {
        this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
      }, o.prototype.moveTo = function(i, t3) {
        return this._drawPendingPt(), this.addData(ff.M, i, t3), this._ctx && this._ctx.moveTo(i, t3), this._x0 = i, this._y0 = t3, this._xi = i, this._yi = t3, this;
      }, o.prototype.lineTo = function(i, t3) {
        var c3 = W2(i - this._xi), p3 = W2(t3 - this._yi), g3 = c3 > this._ux || p3 > this._uy;
        if (this.addData(ff.L, i, t3), this._ctx && g3 && this._ctx.lineTo(i, t3), g3)
          this._xi = i, this._yi = t3, this._pendingPtDist = 0;
        else {
          var b3 = c3 * c3 + p3 * p3;
          b3 > this._pendingPtDist && (this._pendingPtX = i, this._pendingPtY = t3, this._pendingPtDist = b3);
        }
        return this;
      }, o.prototype.bezierCurveTo = function(i, t3, c3, p3, g3, b3) {
        return this._drawPendingPt(), this.addData(ff.C, i, t3, c3, p3, g3, b3), this._ctx && this._ctx.bezierCurveTo(i, t3, c3, p3, g3, b3), this._xi = g3, this._yi = b3, this;
      }, o.prototype.quadraticCurveTo = function(i, t3, c3, p3) {
        return this._drawPendingPt(), this.addData(ff.Q, i, t3, c3, p3), this._ctx && this._ctx.quadraticCurveTo(i, t3, c3, p3), this._xi = c3, this._yi = p3, this;
      }, o.prototype.arc = function(i, t3, c3, p3, g3, b3) {
        this._drawPendingPt(), zP[0] = p3, zP[1] = g3, Jde(zP, b3), p3 = zP[0], g3 = zP[1];
        var w3 = g3 - p3;
        return this.addData(ff.A, i, t3, c3, c3, p3, w3, 0, b3 ? 0 : 1), this._ctx && this._ctx.arc(i, t3, c3, p3, g3, b3), this._xi = wI(g3) * c3 + i, this._yi = zM(g3) * c3 + t3, this;
      }, o.prototype.arcTo = function(i, t3, c3, p3, g3) {
        return this._drawPendingPt(), this._ctx && this._ctx.arcTo(i, t3, c3, p3, g3), this;
      }, o.prototype.rect = function(i, t3, c3, p3) {
        return this._drawPendingPt(), this._ctx && this._ctx.rect(i, t3, c3, p3), this.addData(ff.R, i, t3, c3, p3), this;
      }, o.prototype.closePath = function() {
        this._drawPendingPt(), this.addData(ff.Z);
        var i = this._ctx, t3 = this._x0, c3 = this._y0;
        return i && i.closePath(), this._xi = t3, this._yi = c3, this;
      }, o.prototype.fill = function(i) {
        i && i.fill(), this.toStatic();
      }, o.prototype.stroke = function(i) {
        i && i.stroke(), this.toStatic();
      }, o.prototype.len = function() {
        return this._len;
      }, o.prototype.setData = function(i) {
        var t3 = i.length;
        !(this.data && this.data.length === t3) && WG && (this.data = new Float32Array(t3));
        for (var c3 = 0; c3 < t3; c3++)
          this.data[c3] = i[c3];
        this._len = t3;
      }, o.prototype.appendPath = function(i) {
        i instanceof Array || (i = [i]);
        for (var t3 = i.length, c3 = 0, p3 = this._len, g3 = 0; g3 < t3; g3++)
          c3 += i[g3].len();
        WG && this.data instanceof Float32Array && (this.data = new Float32Array(p3 + c3));
        for (var g3 = 0; g3 < t3; g3++)
          for (var b3 = i[g3].data, w3 = 0; w3 < b3.length; w3++)
            this.data[p3++] = b3[w3];
        this._len = p3;
      }, o.prototype.addData = function(i, t3, c3, p3, g3, b3, w3, M, I) {
        if (this._saveData) {
          var k3 = this.data;
          this._len + arguments.length > k3.length && (this._expandData(), k3 = this.data);
          for (var L = 0; L < arguments.length; L++)
            k3[this._len++] = arguments[L];
        }
      }, o.prototype._drawPendingPt = function() {
        this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
      }, o.prototype._expandData = function() {
        if (!(this.data instanceof Array)) {
          for (var i = [], t3 = 0; t3 < this._len; t3++)
            i[t3] = this.data[t3];
          this.data = i;
        }
      }, o.prototype.toStatic = function() {
        if (this._saveData) {
          this._drawPendingPt();
          var i = this.data;
          i instanceof Array && (i.length = this._len, WG && this._len > 11 && (this.data = new Float32Array(i)));
        }
      }, o.prototype.getBoundingRect = function() {
        bw[0] = bw[1] = _w[0] = _w[1] = Number.MAX_VALUE, BM[0] = BM[1] = xw[0] = xw[1] = -Number.MAX_VALUE;
        var i = this.data, t3 = 0, c3 = 0, p3 = 0, g3 = 0, b3;
        for (b3 = 0; b3 < this._len; ) {
          var w3 = i[b3++], M = b3 === 1;
          switch (M && (t3 = i[b3], c3 = i[b3 + 1], p3 = t3, g3 = c3), w3) {
            case ff.M:
              t3 = p3 = i[b3++], c3 = g3 = i[b3++], _w[0] = p3, _w[1] = g3, xw[0] = p3, xw[1] = g3;
              break;
            case ff.L:
              aee(t3, c3, i[b3], i[b3 + 1], _w, xw), t3 = i[b3++], c3 = i[b3++];
              break;
            case ff.C:
              Yde(t3, c3, i[b3++], i[b3++], i[b3++], i[b3++], i[b3], i[b3 + 1], _w, xw), t3 = i[b3++], c3 = i[b3++];
              break;
            case ff.Q:
              Kde(t3, c3, i[b3++], i[b3++], i[b3], i[b3 + 1], _w, xw), t3 = i[b3++], c3 = i[b3++];
              break;
            case ff.A:
              var I = i[b3++], k3 = i[b3++], L = i[b3++], F = i[b3++], B = i[b3++], G = i[b3++] + B;
              b3 += 1;
              var J = !i[b3++];
              M && (p3 = wI(B) * L + I, g3 = zM(B) * F + k3), Zde(I, k3, L, F, B, G, J, _w, xw), t3 = wI(G) * L + I, c3 = zM(G) * F + k3;
              break;
            case ff.R:
              p3 = t3 = i[b3++], g3 = c3 = i[b3++];
              var Q = i[b3++], se = i[b3++];
              aee(p3, g3, p3 + Q, g3 + se, _w, xw);
              break;
            case ff.Z:
              t3 = p3, c3 = g3;
              break;
          }
          L2(bw, bw, _w), sw(BM, BM, xw);
        }
        return b3 === 0 && (bw[0] = bw[1] = BM[0] = BM[1] = 0), new Ys(bw[0], bw[1], BM[0] - bw[0], BM[1] - bw[1]);
      }, o.prototype._calculateLength = function() {
        var i = this.data, t3 = this._len, c3 = this._ux, p3 = this._uy, g3 = 0, b3 = 0, w3 = 0, M = 0;
        this._pathSegLen || (this._pathSegLen = []);
        for (var I = this._pathSegLen, k3 = 0, L = 0, F = 0; F < t3; ) {
          var B = i[F++], G = F === 1;
          G && (g3 = i[F], b3 = i[F + 1], w3 = g3, M = b3);
          var J = -1;
          switch (B) {
            case ff.M:
              g3 = w3 = i[F++], b3 = M = i[F++];
              break;
            case ff.L: {
              var Q = i[F++], se = i[F++], he = Q - g3, be = se - b3;
              (W2(he) > c3 || W2(be) > p3 || F === t3 - 1) && (J = Math.sqrt(he * he + be * be), g3 = Q, b3 = se);
              break;
            }
            case ff.C: {
              var de = i[F++], Fe = i[F++], Q = i[F++], se = i[F++], Pe = i[F++], ze = i[F++];
              J = Qpe(g3, b3, de, Fe, Q, se, Pe, ze, 10), g3 = Pe, b3 = ze;
              break;
            }
            case ff.Q: {
              var de = i[F++], Fe = i[F++], Q = i[F++], se = i[F++];
              J = tG(g3, b3, de, Fe, Q, se, 10), g3 = Q, b3 = se;
              break;
            }
            case ff.A:
              var $e = i[F++], Ke = i[F++], nt = i[F++], lt2 = i[F++], bt = i[F++], vt = i[F++], jt = vt + bt;
              F += 1, i[F++], G && (w3 = wI(bt) * nt + $e, M = zM(bt) * lt2 + Ke), J = HG(nt, lt2) * GG(jM, Math.abs(vt)), g3 = wI(jt) * nt + $e, b3 = zM(jt) * lt2 + Ke;
              break;
            case ff.R: {
              w3 = g3 = i[F++], M = b3 = i[F++];
              var Jt = i[F++], Rt = i[F++];
              J = Jt * 2 + Rt * 2;
              break;
            }
            case ff.Z: {
              var he = w3 - g3, be = M - b3;
              J = Math.sqrt(he * he + be * be), g3 = w3, b3 = M;
              break;
            }
          }
          J >= 0 && (I[L++] = J, k3 += J);
        }
        return this._pathLen = k3, k3;
      }, o.prototype.rebuildPath = function(i, t3) {
        var c3 = this.data, p3 = this._ux, g3 = this._uy, b3 = this._len, w3, M, I, k3, L, F, B = t3 < 1, G, J, Q = 0, se = 0, he, be = 0, de, Fe;
        if (B && (this._pathSegLen || this._calculateLength(), G = this._pathSegLen, J = this._pathLen, he = t3 * J, !he))
          return;
        e:
          for (var Pe = 0; Pe < b3; ) {
            var ze = c3[Pe++], $e = Pe === 1;
            switch ($e && (I = c3[Pe], k3 = c3[Pe + 1], w3 = I, M = k3), ze !== ff.L && be > 0 && (i.lineTo(de, Fe), be = 0), ze) {
              case ff.M:
                w3 = I = c3[Pe++], M = k3 = c3[Pe++], i.moveTo(I, k3);
                break;
              case ff.L: {
                L = c3[Pe++], F = c3[Pe++];
                var Ke = W2(L - I), nt = W2(F - k3);
                if (Ke > p3 || nt > g3) {
                  if (B) {
                    var lt2 = G[se++];
                    if (Q + lt2 > he) {
                      var bt = (he - Q) / lt2;
                      i.lineTo(I * (1 - bt) + L * bt, k3 * (1 - bt) + F * bt);
                      break e;
                    }
                    Q += lt2;
                  }
                  i.lineTo(L, F), I = L, k3 = F, be = 0;
                } else {
                  var vt = Ke * Ke + nt * nt;
                  vt > be && (de = L, Fe = F, be = vt);
                }
                break;
              }
              case ff.C: {
                var jt = c3[Pe++], Jt = c3[Pe++], Rt = c3[Pe++], Jn = c3[Pe++], ln = c3[Pe++], vn = c3[Pe++];
                if (B) {
                  var lt2 = G[se++];
                  if (Q + lt2 > he) {
                    var bt = (he - Q) / lt2;
                    F2(I, jt, Rt, ln, bt, VM), F2(k3, Jt, Jn, vn, bt, xI), i.bezierCurveTo(VM[1], xI[1], VM[2], xI[2], VM[3], xI[3]);
                    break e;
                  }
                  Q += lt2;
                }
                i.bezierCurveTo(jt, Jt, Rt, Jn, ln, vn), I = ln, k3 = vn;
                break;
              }
              case ff.Q: {
                var jt = c3[Pe++], Jt = c3[Pe++], Rt = c3[Pe++], Jn = c3[Pe++];
                if (B) {
                  var lt2 = G[se++];
                  if (Q + lt2 > he) {
                    var bt = (he - Q) / lt2;
                    D5(I, jt, Rt, bt, VM), D5(k3, Jt, Jn, bt, xI), i.quadraticCurveTo(VM[1], xI[1], VM[2], xI[2]);
                    break e;
                  }
                  Q += lt2;
                }
                i.quadraticCurveTo(jt, Jt, Rt, Jn), I = Rt, k3 = Jn;
                break;
              }
              case ff.A:
                var kn = c3[Pe++], cr = c3[Pe++], gr = c3[Pe++], ha = c3[Pe++], Ka = c3[Pe++], Do = c3[Pe++], _o = c3[Pe++], xo = !c3[Pe++], Ra = gr > ha ? gr : ha, ho = W2(gr - ha) > 1e-3, Mo = Ka + Do, Xa = false;
                if (B) {
                  var lt2 = G[se++];
                  Q + lt2 > he && (Mo = Ka + Do * (he - Q) / lt2, Xa = true), Q += lt2;
                }
                if (ho && i.ellipse ? i.ellipse(kn, cr, gr, ha, _o, Ka, Mo, xo) : i.arc(kn, cr, Ra, Ka, Mo, xo), Xa)
                  break e;
                $e && (w3 = wI(Ka) * gr + kn, M = zM(Ka) * ha + cr), I = wI(Mo) * gr + kn, k3 = zM(Mo) * ha + cr;
                break;
              case ff.R:
                w3 = I = c3[Pe], M = k3 = c3[Pe + 1], L = c3[Pe++], F = c3[Pe++];
                var Zo = c3[Pe++], rc = c3[Pe++];
                if (B) {
                  var lt2 = G[se++];
                  if (Q + lt2 > he) {
                    var ys = he - Q;
                    i.moveTo(L, F), i.lineTo(L + GG(ys, Zo), F), ys -= Zo, ys > 0 && i.lineTo(L + Zo, F + GG(ys, rc)), ys -= rc, ys > 0 && i.lineTo(L + HG(Zo - ys, 0), F + rc), ys -= Zo, ys > 0 && i.lineTo(L, F + HG(rc - ys, 0));
                    break e;
                  }
                  Q += lt2;
                }
                i.rect(L, F, Zo, rc);
                break;
              case ff.Z:
                if (B) {
                  var lt2 = G[se++];
                  if (Q + lt2 > he) {
                    var bt = (he - Q) / lt2;
                    i.lineTo(I * (1 - bt) + w3 * bt, k3 * (1 - bt) + M * bt);
                    break e;
                  }
                  Q += lt2;
                }
                i.closePath(), I = w3, k3 = M;
            }
          }
      }, o.prototype.clone = function() {
        var i = new o(), t3 = this.data;
        return i.data = t3.slice ? t3.slice() : Array.prototype.slice.call(t3), i._len = this._len, i;
      }, o.CMD = ff, o.initDefaultProps = function() {
        var i = o.prototype;
        i._saveData = true, i._ux = 0, i._uy = 0, i._pendingPtDist = 0, i._version = 0;
      }(), o;
    }(), ww = Qde;
    function GM(o, i, t3, c3, p3, g3, b3) {
      if (p3 === 0)
        return false;
      var w3 = p3, M = 0, I = o;
      if (b3 > i + w3 && b3 > c3 + w3 || b3 < i - w3 && b3 < c3 - w3 || g3 > o + w3 && g3 > t3 + w3 || g3 < o - w3 && g3 < t3 - w3)
        return false;
      if (o !== t3)
        M = (i - c3) / (o - t3), I = (o * c3 - t3 * i) / (o - t3);
      else
        return Math.abs(g3 - o) <= w3 / 2;
      var k3 = M * g3 - b3 + I, L = k3 * k3 / (M * M + 1);
      return L <= w3 / 2 * w3 / 2;
    }
    function eve(o, i, t3, c3, p3, g3, b3, w3, M, I, k3) {
      if (M === 0)
        return false;
      var L = M;
      if (k3 > i + L && k3 > c3 + L && k3 > g3 + L && k3 > w3 + L || k3 < i - L && k3 < c3 - L && k3 < g3 - L && k3 < w3 - L || I > o + L && I > t3 + L && I > p3 + L && I > b3 + L || I < o - L && I < t3 - L && I < p3 - L && I < b3 - L)
        return false;
      var F = pQ(o, i, t3, c3, p3, g3, b3, w3, I, k3, null);
      return F <= L / 2;
    }
    function lee(o, i, t3, c3, p3, g3, b3, w3, M) {
      if (b3 === 0)
        return false;
      var I = b3;
      if (M > i + I && M > c3 + I && M > g3 + I || M < i - I && M < c3 - I && M < g3 - I || w3 > o + I && w3 > t3 + I && w3 > p3 + I || w3 < o - I && w3 < t3 - I && w3 < p3 - I)
        return false;
      var k3 = vQ(o, i, t3, c3, p3, g3, w3, M, null);
      return k3 <= I / 2;
    }
    var uee = Math.PI * 2;
    function HM(o) {
      return o %= uee, o < 0 && (o += uee), o;
    }
    var jP = Math.PI * 2;
    function tve(o, i, t3, c3, p3, g3, b3, w3, M) {
      if (b3 === 0)
        return false;
      var I = b3;
      w3 -= o, M -= i;
      var k3 = Math.sqrt(w3 * w3 + M * M);
      if (k3 - I > t3 || k3 + I < t3)
        return false;
      if (Math.abs(c3 - p3) % jP < 1e-4)
        return true;
      if (g3) {
        var L = c3;
        c3 = HM(p3), p3 = HM(L);
      } else
        c3 = HM(c3), p3 = HM(p3);
      c3 > p3 && (p3 += jP);
      var F = Math.atan2(M, w3);
      return F < 0 && (F += jP), F >= c3 && F <= p3 || F + jP >= c3 && F + jP <= p3;
    }
    function U2(o, i, t3, c3, p3, g3) {
      if (g3 > i && g3 > c3 || g3 < i && g3 < c3 || c3 === i)
        return 0;
      var b3 = (g3 - i) / (c3 - i), w3 = c3 < i ? 1 : -1;
      (b3 === 1 || b3 === 0) && (w3 = c3 < i ? 0.5 : -0.5);
      var M = b3 * (t3 - o) + o;
      return M === p3 ? 1 / 0 : M > p3 ? w3 : 0;
    }
    var WM = ww.CMD, UM = Math.PI * 2, cee = 1e-4;
    function nve(o, i) {
      return Math.abs(o - i) < cee;
    }
    var vy = [-1, -1, -1], Ib = [-1, -1];
    function rve() {
      var o = Ib[0];
      Ib[0] = Ib[1], Ib[1] = o;
    }
    function qF(o, i, t3, c3, p3, g3, b3, w3, M, I) {
      if (I > i && I > c3 && I > g3 && I > w3 || I < i && I < c3 && I < g3 && I < w3)
        return 0;
      var k3 = E5(i, c3, g3, w3, I, vy);
      if (k3 === 0)
        return 0;
      for (var L = 0, F = -1, B = void 0, G = void 0, J = 0; J < k3; J++) {
        var Q = vy[J], se = Q === 0 || Q === 1 ? 0.5 : 1, he = Jp(o, t3, p3, b3, Q);
        he < M || (F < 0 && (F = hQ(i, c3, g3, w3, Ib), Ib[1] < Ib[0] && F > 1 && rve(), B = Jp(i, c3, g3, w3, Ib[0]), F > 1 && (G = Jp(i, c3, g3, w3, Ib[1]))), F === 2 ? Q < Ib[0] ? L += B < i ? se : -se : Q < Ib[1] ? L += G < B ? se : -se : L += w3 < G ? se : -se : Q < Ib[0] ? L += B < i ? se : -se : L += w3 < B ? se : -se);
      }
      return L;
    }
    function ive(o, i, t3, c3, p3, g3, b3, w3) {
      if (w3 > i && w3 > c3 && w3 > g3 || w3 < i && w3 < c3 && w3 < g3)
        return 0;
      var M = ede(i, c3, g3, w3, vy);
      if (M === 0)
        return 0;
      var I = dQ(i, c3, g3);
      if (I >= 0 && I <= 1) {
        for (var k3 = 0, L = Dc(i, c3, g3, I), F = 0; F < M; F++) {
          var B = vy[F] === 0 || vy[F] === 1 ? 0.5 : 1, G = Dc(o, t3, p3, vy[F]);
          G < b3 || (vy[F] < I ? k3 += L < i ? B : -B : k3 += g3 < L ? B : -B);
        }
        return k3;
      } else {
        var B = vy[0] === 0 || vy[0] === 1 ? 0.5 : 1, G = Dc(o, t3, p3, vy[0]);
        return G < b3 ? 0 : g3 < i ? B : -B;
      }
    }
    function ave(o, i, t3, c3, p3, g3, b3, w3) {
      if (w3 -= i, w3 > t3 || w3 < -t3)
        return 0;
      var M = Math.sqrt(t3 * t3 - w3 * w3);
      vy[0] = -M, vy[1] = M;
      var I = Math.abs(c3 - p3);
      if (I < 1e-4)
        return 0;
      if (I >= UM - 1e-4) {
        c3 = 0, p3 = UM;
        var k3 = g3 ? 1 : -1;
        return b3 >= vy[0] + o && b3 <= vy[1] + o ? k3 : 0;
      }
      if (c3 > p3) {
        var L = c3;
        c3 = p3, p3 = L;
      }
      c3 < 0 && (c3 += UM, p3 += UM);
      for (var F = 0, B = 0; B < 2; B++) {
        var G = vy[B];
        if (G + o > b3) {
          var J = Math.atan2(w3, G), k3 = g3 ? 1 : -1;
          J < 0 && (J = UM + J), (J >= c3 && J <= p3 || J + UM >= c3 && J + UM <= p3) && (J > Math.PI / 2 && J < Math.PI * 1.5 && (k3 = -k3), F += k3);
        }
      }
      return F;
    }
    function fee(o, i, t3, c3, p3) {
      for (var g3 = o.data, b3 = o.len(), w3 = 0, M = 0, I = 0, k3 = 0, L = 0, F, B, G = 0; G < b3; ) {
        var J = g3[G++], Q = G === 1;
        switch (J === WM.M && G > 1 && (t3 || (w3 += U2(M, I, k3, L, c3, p3))), Q && (M = g3[G], I = g3[G + 1], k3 = M, L = I), J) {
          case WM.M:
            k3 = g3[G++], L = g3[G++], M = k3, I = L;
            break;
          case WM.L:
            if (t3) {
              if (GM(M, I, g3[G], g3[G + 1], i, c3, p3))
                return true;
            } else
              w3 += U2(M, I, g3[G], g3[G + 1], c3, p3) || 0;
            M = g3[G++], I = g3[G++];
            break;
          case WM.C:
            if (t3) {
              if (eve(M, I, g3[G++], g3[G++], g3[G++], g3[G++], g3[G], g3[G + 1], i, c3, p3))
                return true;
            } else
              w3 += qF(M, I, g3[G++], g3[G++], g3[G++], g3[G++], g3[G], g3[G + 1], c3, p3) || 0;
            M = g3[G++], I = g3[G++];
            break;
          case WM.Q:
            if (t3) {
              if (lee(M, I, g3[G++], g3[G++], g3[G], g3[G + 1], i, c3, p3))
                return true;
            } else
              w3 += ive(M, I, g3[G++], g3[G++], g3[G], g3[G + 1], c3, p3) || 0;
            M = g3[G++], I = g3[G++];
            break;
          case WM.A:
            var se = g3[G++], he = g3[G++], be = g3[G++], de = g3[G++], Fe = g3[G++], Pe = g3[G++];
            G += 1;
            var ze = !!(1 - g3[G++]);
            F = Math.cos(Fe) * be + se, B = Math.sin(Fe) * de + he, Q ? (k3 = F, L = B) : w3 += U2(M, I, F, B, c3, p3);
            var $e = (c3 - se) * de / be + se;
            if (t3) {
              if (tve(se, he, de, Fe, Fe + Pe, ze, i, $e, p3))
                return true;
            } else
              w3 += ave(se, he, de, Fe, Fe + Pe, ze, $e, p3);
            M = Math.cos(Fe + Pe) * be + se, I = Math.sin(Fe + Pe) * de + he;
            break;
          case WM.R:
            k3 = M = g3[G++], L = I = g3[G++];
            var Ke = g3[G++], nt = g3[G++];
            if (F = k3 + Ke, B = L + nt, t3) {
              if (GM(k3, L, F, L, i, c3, p3) || GM(F, L, F, B, i, c3, p3) || GM(F, B, k3, B, i, c3, p3) || GM(k3, B, k3, L, i, c3, p3))
                return true;
            } else
              w3 += U2(F, L, F, B, c3, p3), w3 += U2(k3, B, k3, L, c3, p3);
            break;
          case WM.Z:
            if (t3) {
              if (GM(M, I, k3, L, i, c3, p3))
                return true;
            } else
              w3 += U2(M, I, k3, L, c3, p3);
            M = k3, I = L;
            break;
        }
      }
      return !t3 && !nve(I, L) && (w3 += U2(M, I, k3, L, c3, p3) || 0), w3 !== 0;
    }
    function ove(o, i, t3) {
      return fee(o, 0, false, i, t3);
    }
    function sve(o, i, t3, c3) {
      return fee(o, i, true, t3, c3);
    }
    var $F = Uo({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, bI), lve = { style: Uo({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, jF.style) }, qG = dw.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), uve = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.update = function() {
        var t3 = this;
        o.prototype.update.call(this);
        var c3 = this.style;
        if (c3.decal) {
          var p3 = this._decalEl = this._decalEl || new i();
          p3.buildPath === i.prototype.buildPath && (p3.buildPath = function(M) {
            t3.buildPath(M, t3.shape);
          }), p3.silent = true;
          var g3 = p3.style;
          for (var b3 in c3)
            g3[b3] !== c3[b3] && (g3[b3] = c3[b3]);
          g3.fill = c3.fill ? c3.decal : null, g3.decal = null, g3.shadowColor = null, c3.strokeFirst && (g3.stroke = null);
          for (var w3 = 0; w3 < qG.length; ++w3)
            p3[qG[w3]] = this[qG[w3]];
          p3.__dirty |= c0;
        } else
          this._decalEl && (this._decalEl = null);
      }, i.prototype.getDecalElement = function() {
        return this._decalEl;
      }, i.prototype._init = function(t3) {
        var c3 = Gl(t3);
        this.shape = this.getDefaultShape();
        var p3 = this.getDefaultStyle();
        p3 && this.useStyle(p3);
        for (var g3 = 0; g3 < c3.length; g3++) {
          var b3 = c3[g3], w3 = t3[b3];
          b3 === "style" ? this.style ? ti(this.style, w3) : this.useStyle(w3) : b3 === "shape" ? ti(this.shape, w3) : o.prototype.attrKV.call(this, b3, w3);
        }
        this.style || this.useStyle({});
      }, i.prototype.getDefaultStyle = function() {
        return null;
      }, i.prototype.getDefaultShape = function() {
        return {};
      }, i.prototype.canBeInsideText = function() {
        return this.hasFill();
      }, i.prototype.getInsideTextFill = function() {
        var t3 = this.style.fill;
        if (t3 !== "none") {
          if (Ha(t3)) {
            var c3 = vF(t3, 0);
            return c3 > 0.5 ? wF : c3 > 0.2 ? vde : PP;
          } else if (t3)
            return PP;
        }
        return wF;
      }, i.prototype.getInsideTextStroke = function(t3) {
        var c3 = this.style.fill;
        if (Ha(c3)) {
          var p3 = this.__zr, g3 = !!(p3 && p3.isDarkMode()), b3 = vF(t3, 0) < vG;
          if (g3 === b3)
            return c3;
        }
      }, i.prototype.buildPath = function(t3, c3, p3) {
      }, i.prototype.pathUpdated = function() {
        this.__dirty &= ~T5;
      }, i.prototype.getUpdatedPathProxy = function(t3) {
        return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, t3), this.path;
      }, i.prototype.createPathProxy = function() {
        this.path = new ww(false);
      }, i.prototype.hasStroke = function() {
        var t3 = this.style, c3 = t3.stroke;
        return !(c3 == null || c3 === "none" || !(t3.lineWidth > 0));
      }, i.prototype.hasFill = function() {
        var t3 = this.style, c3 = t3.fill;
        return c3 != null && c3 !== "none";
      }, i.prototype.getBoundingRect = function() {
        var t3 = this._rect, c3 = this.style, p3 = !t3;
        if (p3) {
          var g3 = false;
          this.path || (g3 = true, this.createPathProxy());
          var b3 = this.path;
          (g3 || this.__dirty & T5) && (b3.beginPath(), this.buildPath(b3, this.shape, false), this.pathUpdated()), t3 = b3.getBoundingRect();
        }
        if (this._rect = t3, this.hasStroke() && this.path && this.path.len() > 0) {
          var w3 = this._rectStroke || (this._rectStroke = t3.clone());
          if (this.__dirty || p3) {
            w3.copy(t3);
            var M = c3.strokeNoScale ? this.getLineScale() : 1, I = c3.lineWidth;
            if (!this.hasFill()) {
              var k3 = this.strokeContainThreshold;
              I = Math.max(I, k3 == null ? 4 : k3);
            }
            M > 1e-10 && (w3.width += I / M, w3.height += I / M, w3.x -= I / M / 2, w3.y -= I / M / 2);
          }
          return w3;
        }
        return t3;
      }, i.prototype.contain = function(t3, c3) {
        var p3 = this.transformCoordToLocal(t3, c3), g3 = this.getBoundingRect(), b3 = this.style;
        if (t3 = p3[0], c3 = p3[1], g3.contain(t3, c3)) {
          var w3 = this.path;
          if (this.hasStroke()) {
            var M = b3.lineWidth, I = b3.strokeNoScale ? this.getLineScale() : 1;
            if (I > 1e-10 && (this.hasFill() || (M = Math.max(M, this.strokeContainThreshold)), sve(w3, M / I, t3, c3)))
              return true;
          }
          if (this.hasFill())
            return ove(w3, t3, c3);
        }
        return false;
      }, i.prototype.dirtyShape = function() {
        this.__dirty |= T5, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
      }, i.prototype.dirty = function() {
        this.dirtyStyle(), this.dirtyShape();
      }, i.prototype.animateShape = function(t3) {
        return this.animate("shape", t3);
      }, i.prototype.updateDuringAnimation = function(t3) {
        t3 === "style" ? this.dirtyStyle() : t3 === "shape" ? this.dirtyShape() : this.markRedraw();
      }, i.prototype.attrKV = function(t3, c3) {
        t3 === "shape" ? this.setShape(c3) : o.prototype.attrKV.call(this, t3, c3);
      }, i.prototype.setShape = function(t3, c3) {
        var p3 = this.shape;
        return p3 || (p3 = this.shape = {}), typeof t3 == "string" ? p3[t3] = c3 : ti(p3, t3), this.dirtyShape(), this;
      }, i.prototype.shapeChanged = function() {
        return !!(this.__dirty & T5);
      }, i.prototype.createStyle = function(t3) {
        return gP($F, t3);
      }, i.prototype._innerSaveToNormal = function(t3) {
        o.prototype._innerSaveToNormal.call(this, t3);
        var c3 = this._normalState;
        t3.shape && !c3.shape && (c3.shape = ti({}, this.shape));
      }, i.prototype._applyStateObj = function(t3, c3, p3, g3, b3, w3) {
        o.prototype._applyStateObj.call(this, t3, c3, p3, g3, b3, w3);
        var M = !(c3 && g3), I;
        if (c3 && c3.shape ? b3 ? g3 ? I = c3.shape : (I = ti({}, p3.shape), ti(I, c3.shape)) : (I = ti({}, g3 ? this.shape : p3.shape), ti(I, c3.shape)) : M && (I = p3.shape), I)
          if (b3) {
            this.shape = ti({}, this.shape);
            for (var k3 = {}, L = Gl(I), F = 0; F < L.length; F++) {
              var B = L[F];
              typeof I[B] == "object" ? this.shape[B] = I[B] : k3[B] = I[B];
            }
            this._transitionState(t3, { shape: k3 }, w3);
          } else
            this.shape = I, this.dirtyShape();
      }, i.prototype._mergeStates = function(t3) {
        for (var c3 = o.prototype._mergeStates.call(this, t3), p3, g3 = 0; g3 < t3.length; g3++) {
          var b3 = t3[g3];
          b3.shape && (p3 = p3 || {}, this._mergeStyle(p3, b3.shape));
        }
        return p3 && (c3.shape = p3), c3;
      }, i.prototype.getAnimationStyleProps = function() {
        return lve;
      }, i.prototype.isZeroArea = function() {
        return false;
      }, i.extend = function(t3) {
        var c3 = function(g3) {
          cn(b3, g3);
          function b3(w3) {
            var M = g3.call(this, w3) || this;
            return t3.init && t3.init.call(M, w3), M;
          }
          return b3.prototype.getDefaultStyle = function() {
            return Jo(t3.style);
          }, b3.prototype.getDefaultShape = function() {
            return Jo(t3.shape);
          }, b3;
        }(i);
        for (var p3 in t3)
          typeof t3[p3] == "function" && (c3.prototype[p3] = t3[p3]);
        return c3;
      }, i.initDefaultProps = function() {
        var t3 = i.prototype;
        t3.type = "path", t3.strokeContainThreshold = 5, t3.segmentIgnoreThreshold = 0, t3.subPixelOptimize = false, t3.autoBatch = false, t3.__dirty = c0 | Jc | T5;
      }(), i;
    }(Ab), gl = uve, cve = Uo({ strokeFirst: true, font: Vs, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, $F), GP = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.hasStroke = function() {
        var t3 = this.style, c3 = t3.stroke;
        return c3 != null && c3 !== "none" && t3.lineWidth > 0;
      }, i.prototype.hasFill = function() {
        var t3 = this.style, c3 = t3.fill;
        return c3 != null && c3 !== "none";
      }, i.prototype.createStyle = function(t3) {
        return gP(cve, t3);
      }, i.prototype.setBoundingRect = function(t3) {
        this._rect = t3;
      }, i.prototype.getBoundingRect = function() {
        var t3 = this.style;
        if (!this._rect) {
          var c3 = t3.text;
          c3 != null ? c3 += "" : c3 = "";
          var p3 = pI(c3, t3.font, t3.textAlign, t3.textBaseline);
          if (p3.x += t3.x || 0, p3.y += t3.y || 0, this.hasStroke()) {
            var g3 = t3.lineWidth;
            p3.x -= g3 / 2, p3.y -= g3 / 2, p3.width += g3, p3.height += g3;
          }
          this._rect = p3;
        }
        return this._rect;
      }, i.initDefaultProps = function() {
        var t3 = i.prototype;
        t3.dirtyRectTolerance = 10;
      }(), i;
    }(Ab);
    GP.prototype.type = "tspan";
    var HP = GP, hee = Uo({ x: 0, y: 0 }, bI), pee = { style: Uo({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, jF.style) };
    function $G(o) {
      return !!(o && typeof o != "string" && o.width && o.height);
    }
    var XG = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.createStyle = function(t3) {
        return gP(hee, t3);
      }, i.prototype._getSize = function(t3) {
        var c3 = this.style, p3 = c3[t3];
        if (p3 != null)
          return p3;
        var g3 = $G(c3.image) ? c3.image : this.__image;
        if (!g3)
          return 0;
        var b3 = t3 === "width" ? "height" : "width", w3 = c3[b3];
        return w3 == null ? g3[t3] : g3[t3] / g3[b3] * w3;
      }, i.prototype.getWidth = function() {
        return this._getSize("width");
      }, i.prototype.getHeight = function() {
        return this._getSize("height");
      }, i.prototype.getAnimationStyleProps = function() {
        return pee;
      }, i.prototype.getBoundingRect = function() {
        var t3 = this.style;
        return this._rect || (this._rect = new Ys(t3.x || 0, t3.y || 0, this.getWidth(), this.getHeight())), this._rect;
      }, i;
    }(Ab);
    XG.prototype.type = "image";
    var Gv = XG;
    function dee(o, i) {
      var t3 = i.x, c3 = i.y, p3 = i.width, g3 = i.height, b3 = i.r, w3, M, I, k3;
      p3 < 0 && (t3 = t3 + p3, p3 = -p3), g3 < 0 && (c3 = c3 + g3, g3 = -g3), typeof b3 == "number" ? w3 = M = I = k3 = b3 : b3 instanceof Array ? b3.length === 1 ? w3 = M = I = k3 = b3[0] : b3.length === 2 ? (w3 = I = b3[0], M = k3 = b3[1]) : b3.length === 3 ? (w3 = b3[0], M = k3 = b3[1], I = b3[2]) : (w3 = b3[0], M = b3[1], I = b3[2], k3 = b3[3]) : w3 = M = I = k3 = 0;
      var L;
      w3 + M > p3 && (L = w3 + M, w3 *= p3 / L, M *= p3 / L), I + k3 > p3 && (L = I + k3, I *= p3 / L, k3 *= p3 / L), M + I > g3 && (L = M + I, M *= g3 / L, I *= g3 / L), w3 + k3 > g3 && (L = w3 + k3, w3 *= g3 / L, k3 *= g3 / L), o.moveTo(t3 + w3, c3), o.lineTo(t3 + p3 - M, c3), M !== 0 && o.arc(t3 + p3 - M, c3 + M, M, -Math.PI / 2, 0), o.lineTo(t3 + p3, c3 + g3 - I), I !== 0 && o.arc(t3 + p3 - I, c3 + g3 - I, I, 0, Math.PI / 2), o.lineTo(t3 + k3, c3 + g3), k3 !== 0 && o.arc(t3 + k3, c3 + g3 - k3, k3, Math.PI / 2, Math.PI), o.lineTo(t3, c3 + w3), w3 !== 0 && o.arc(t3 + w3, c3 + w3, w3, Math.PI, Math.PI * 1.5);
    }
    var SI = Math.round;
    function vee(o, i, t3) {
      if (i) {
        var c3 = i.x1, p3 = i.x2, g3 = i.y1, b3 = i.y2;
        o.x1 = c3, o.x2 = p3, o.y1 = g3, o.y2 = b3;
        var w3 = t3 && t3.lineWidth;
        return w3 && (SI(c3 * 2) === SI(p3 * 2) && (o.x1 = o.x2 = CI(c3, w3, true)), SI(g3 * 2) === SI(b3 * 2) && (o.y1 = o.y2 = CI(g3, w3, true))), o;
      }
    }
    function gee(o, i, t3) {
      if (i) {
        var c3 = i.x, p3 = i.y, g3 = i.width, b3 = i.height;
        o.x = c3, o.y = p3, o.width = g3, o.height = b3;
        var w3 = t3 && t3.lineWidth;
        return w3 && (o.x = CI(c3, w3, true), o.y = CI(p3, w3, true), o.width = Math.max(CI(c3 + g3, w3, false) - o.x, g3 === 0 ? 0 : 1), o.height = Math.max(CI(p3 + b3, w3, false) - o.y, b3 === 0 ? 0 : 1)), o;
      }
    }
    function CI(o, i, t3) {
      if (!i)
        return o;
      var c3 = SI(o * 2);
      return (c3 + SI(i)) % 2 === 0 ? c3 / 2 : (c3 + (t3 ? 1 : -1)) / 2;
    }
    var XF = function() {
      function o() {
        this.x = 0, this.y = 0, this.width = 0, this.height = 0;
      }
      return o;
    }(), YF = {}, yee = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new XF();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3, g3, b3, w3;
        if (this.subPixelOptimize) {
          var M = gee(YF, c3, this.style);
          p3 = M.x, g3 = M.y, b3 = M.width, w3 = M.height, M.r = c3.r, c3 = M;
        } else
          p3 = c3.x, g3 = c3.y, b3 = c3.width, w3 = c3.height;
        c3.r ? dee(t3, c3) : t3.rect(p3, g3, b3, w3);
      }, i.prototype.isZeroArea = function() {
        return !this.shape.width || !this.shape.height;
      }, i;
    }(gl);
    yee.prototype.type = "rect";
    var bu = yee, KF = { fill: "#000" }, YG = 2, fve = { style: Uo({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, jF.style) }, mee = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this) || this;
        return c3.type = "text", c3._children = [], c3._defaultStyle = KF, c3.attr(t3), c3;
      }
      return i.prototype.childrenRef = function() {
        return this._children;
      }, i.prototype.update = function() {
        o.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
        for (var t3 = 0; t3 < this._children.length; t3++) {
          var c3 = this._children[t3];
          c3.zlevel = this.zlevel, c3.z = this.z, c3.z2 = this.z2, c3.culling = this.culling, c3.cursor = this.cursor, c3.invisible = this.invisible;
        }
      }, i.prototype.updateTransform = function() {
        var t3 = this.innerTransformable;
        t3 ? (t3.updateTransform(), t3.transform && (this.transform = t3.transform)) : o.prototype.updateTransform.call(this);
      }, i.prototype.getLocalTransform = function(t3) {
        var c3 = this.innerTransformable;
        return c3 ? c3.getLocalTransform(t3) : o.prototype.getLocalTransform.call(this, t3);
      }, i.prototype.getComputedTransform = function() {
        return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), o.prototype.getComputedTransform.call(this);
      }, i.prototype._updateSubTexts = function() {
        this._childCursor = 0, dve(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
      }, i.prototype.addSelfToZr = function(t3) {
        o.prototype.addSelfToZr.call(this, t3);
        for (var c3 = 0; c3 < this._children.length; c3++)
          this._children[c3].__zr = t3;
      }, i.prototype.removeSelfFromZr = function(t3) {
        o.prototype.removeSelfFromZr.call(this, t3);
        for (var c3 = 0; c3 < this._children.length; c3++)
          this._children[c3].__zr = null;
      }, i.prototype.getBoundingRect = function() {
        if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
          for (var t3 = new Ys(0, 0, 0, 0), c3 = this._children, p3 = [], g3 = null, b3 = 0; b3 < c3.length; b3++) {
            var w3 = c3[b3], M = w3.getBoundingRect(), I = w3.getLocalTransform(p3);
            I ? (t3.copy(M), t3.applyTransform(I), g3 = g3 || t3.clone(), g3.union(t3)) : (g3 = g3 || M.clone(), g3.union(M));
          }
          this._rect = g3 || t3;
        }
        return this._rect;
      }, i.prototype.setDefaultTextStyle = function(t3) {
        this._defaultStyle = t3 || KF;
      }, i.prototype.setTextContent = function(t3) {
      }, i.prototype._mergeStyle = function(t3, c3) {
        if (!c3)
          return t3;
        var p3 = c3.rich, g3 = t3.rich || p3 && {};
        return ti(t3, c3), p3 && g3 ? (this._mergeRich(g3, p3), t3.rich = g3) : g3 && (t3.rich = g3), t3;
      }, i.prototype._mergeRich = function(t3, c3) {
        for (var p3 = Gl(c3), g3 = 0; g3 < p3.length; g3++) {
          var b3 = p3[g3];
          t3[b3] = t3[b3] || {}, ti(t3[b3], c3[b3]);
        }
      }, i.prototype.getAnimationStyleProps = function() {
        return fve;
      }, i.prototype._getOrCreateChild = function(t3) {
        var c3 = this._children[this._childCursor];
        return (!c3 || !(c3 instanceof t3)) && (c3 = new t3()), this._children[this._childCursor++] = c3, c3.__zr = this.__zr, c3.parent = this, c3;
      }, i.prototype._updatePlainTexts = function() {
        var t3 = this.style, c3 = t3.font || Vs, p3 = t3.padding, g3 = Tee(t3), b3 = zde(g3, t3), w3 = KG(t3), M = !!t3.backgroundColor, I = b3.outerHeight, k3 = b3.outerWidth, L = b3.contentWidth, F = b3.lines, B = b3.lineHeight, G = this._defaultStyle, J = t3.x || 0, Q = t3.y || 0, se = t3.align || G.align || "left", he = t3.verticalAlign || G.verticalAlign || "top", be = J, de = LM(Q, b3.contentHeight, he);
        if (w3 || p3) {
          var Fe = G5(J, k3, se), Pe = LM(Q, I, he);
          w3 && this._renderBackground(t3, t3, Fe, Pe, k3, I);
        }
        de += B / 2, p3 && (be = Eb(J, se, p3), he === "top" ? de += p3[0] : he === "bottom" && (de -= p3[2]));
        for (var ze = 0, $e = false, Ke = Mee("fill" in t3 ? t3.fill : ($e = true, G.fill)), nt = Cee("stroke" in t3 ? t3.stroke : !M && (!G.autoStroke || $e) ? (ze = YG, G.stroke) : null), lt2 = t3.textShadowBlur > 0, bt = t3.width != null && (t3.overflow === "truncate" || t3.overflow === "break" || t3.overflow === "breakAll"), vt = b3.calculatedLineHeight, jt = 0; jt < F.length; jt++) {
          var Jt = this._getOrCreateChild(HP), Rt = Jt.createStyle();
          Jt.useStyle(Rt), Rt.text = F[jt], Rt.x = be, Rt.y = de, se && (Rt.textAlign = se), Rt.textBaseline = "middle", Rt.opacity = t3.opacity, Rt.strokeFirst = true, lt2 && (Rt.shadowBlur = t3.textShadowBlur || 0, Rt.shadowColor = t3.textShadowColor || "transparent", Rt.shadowOffsetX = t3.textShadowOffsetX || 0, Rt.shadowOffsetY = t3.textShadowOffsetY || 0), Rt.stroke = nt, Rt.fill = Ke, nt && (Rt.lineWidth = t3.lineWidth || ze, Rt.lineDash = t3.lineDash, Rt.lineDashOffset = t3.lineDashOffset || 0), Rt.font = c3, xee(Rt, t3), de += B, bt && Jt.setBoundingRect(new Ys(G5(Rt.x, t3.width, Rt.textAlign), LM(Rt.y, vt, Rt.textBaseline), L, vt));
        }
      }, i.prototype._updateRichTexts = function() {
        var t3 = this.style, c3 = Tee(t3), p3 = Hde(c3, t3), g3 = p3.width, b3 = p3.outerWidth, w3 = p3.outerHeight, M = t3.padding, I = t3.x || 0, k3 = t3.y || 0, L = this._defaultStyle, F = t3.align || L.align, B = t3.verticalAlign || L.verticalAlign, G = G5(I, b3, F), J = LM(k3, w3, B), Q = G, se = J;
        M && (Q += M[3], se += M[0]);
        var he = Q + g3;
        KG(t3) && this._renderBackground(t3, t3, G, J, b3, w3);
        for (var be = !!t3.backgroundColor, de = 0; de < p3.lines.length; de++) {
          for (var Fe = p3.lines[de], Pe = Fe.tokens, ze = Pe.length, $e = Fe.lineHeight, Ke = Fe.width, nt = 0, lt2 = Q, bt = he, vt = ze - 1, jt = void 0; nt < ze && (jt = Pe[nt], !jt.align || jt.align === "left"); )
            this._placeToken(jt, t3, $e, se, lt2, "left", be), Ke -= jt.width, lt2 += jt.width, nt++;
          for (; vt >= 0 && (jt = Pe[vt], jt.align === "right"); )
            this._placeToken(jt, t3, $e, se, bt, "right", be), Ke -= jt.width, bt -= jt.width, vt--;
          for (lt2 += (g3 - (lt2 - Q) - (he - bt) - Ke) / 2; nt <= vt; )
            jt = Pe[nt], this._placeToken(jt, t3, $e, se, lt2 + jt.width / 2, "center", be), lt2 += jt.width, nt++;
          se += $e;
        }
      }, i.prototype._placeToken = function(t3, c3, p3, g3, b3, w3, M) {
        var I = c3.rich[t3.styleName] || {};
        I.text = t3.text;
        var k3 = t3.verticalAlign, L = g3 + p3 / 2;
        k3 === "top" ? L = g3 + t3.height / 2 : k3 === "bottom" && (L = g3 + p3 - t3.height / 2);
        var F = !t3.isLineHolder && KG(I);
        F && this._renderBackground(I, c3, w3 === "right" ? b3 - t3.width : w3 === "center" ? b3 - t3.width / 2 : b3, L - t3.height / 2, t3.width, t3.height);
        var B = !!I.backgroundColor, G = t3.textPadding;
        G && (b3 = Eb(b3, w3, G), L -= t3.height / 2 - G[0] - t3.innerHeight / 2);
        var J = this._getOrCreateChild(HP), Q = J.createStyle();
        J.useStyle(Q);
        var se = this._defaultStyle, he = false, be = 0, de = Mee("fill" in I ? I.fill : "fill" in c3 ? c3.fill : (he = true, se.fill)), Fe = Cee("stroke" in I ? I.stroke : "stroke" in c3 ? c3.stroke : !B && !M && (!se.autoStroke || he) ? (be = YG, se.stroke) : null), Pe = I.textShadowBlur > 0 || c3.textShadowBlur > 0;
        Q.text = t3.text, Q.x = b3, Q.y = L, Pe && (Q.shadowBlur = I.textShadowBlur || c3.textShadowBlur || 0, Q.shadowColor = I.textShadowColor || c3.textShadowColor || "transparent", Q.shadowOffsetX = I.textShadowOffsetX || c3.textShadowOffsetX || 0, Q.shadowOffsetY = I.textShadowOffsetY || c3.textShadowOffsetY || 0), Q.textAlign = w3, Q.textBaseline = "middle", Q.font = t3.font || Vs, Q.opacity = np(I.opacity, c3.opacity, 1), xee(Q, I), Fe && (Q.lineWidth = np(I.lineWidth, c3.lineWidth, be), Q.lineDash = Xs(I.lineDash, c3.lineDash), Q.lineDashOffset = c3.lineDashOffset || 0, Q.stroke = Fe), de && (Q.fill = de);
        var ze = t3.contentWidth, $e = t3.contentHeight;
        J.setBoundingRect(new Ys(G5(Q.x, ze, Q.textAlign), LM(Q.y, $e, Q.textBaseline), ze, $e));
      }, i.prototype._renderBackground = function(t3, c3, p3, g3, b3, w3) {
        var M = t3.backgroundColor, I = t3.borderWidth, k3 = t3.borderColor, L = M && M.image, F = M && !L, B = t3.borderRadius, G = this, J, Q;
        if (F || t3.lineHeight || I && k3) {
          J = this._getOrCreateChild(bu), J.useStyle(J.createStyle()), J.style.fill = null;
          var se = J.shape;
          se.x = p3, se.y = g3, se.width = b3, se.height = w3, se.r = B, J.dirtyShape();
        }
        if (F) {
          var he = J.style;
          he.fill = M || null, he.fillOpacity = Xs(t3.fillOpacity, 1);
        } else if (L) {
          Q = this._getOrCreateChild(Gv), Q.onload = function() {
            G.dirtyStyle();
          };
          var be = Q.style;
          be.image = M.image, be.x = p3, be.y = g3, be.width = b3, be.height = w3;
        }
        if (I && k3) {
          var he = J.style;
          he.lineWidth = I, he.stroke = k3, he.strokeOpacity = Xs(t3.strokeOpacity, 1), he.lineDash = t3.borderDash, he.lineDashOffset = t3.borderDashOffset || 0, J.strokeContainThreshold = 0, J.hasFill() && J.hasStroke() && (he.strokeFirst = true, he.lineWidth *= 2);
        }
        var de = (J || Q).style;
        de.shadowBlur = t3.shadowBlur || 0, de.shadowColor = t3.shadowColor || "transparent", de.shadowOffsetX = t3.shadowOffsetX || 0, de.shadowOffsetY = t3.shadowOffsetY || 0, de.opacity = np(t3.opacity, c3.opacity, 1);
      }, i.makeFont = function(t3) {
        var c3 = "";
        return wee(t3) && (c3 = [t3.fontStyle, t3.fontWeight, _ee(t3.fontSize), t3.fontFamily || "sans-serif"].join(" ")), c3 && S1(c3) || t3.textFont || t3.font;
      }, i;
    }(Ab), hve = { left: true, right: 1, center: 1 }, pve = { top: 1, bottom: 1, middle: 1 }, bee = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
    function _ee(o) {
      return typeof o == "string" && (o.indexOf("px") !== -1 || o.indexOf("rem") !== -1 || o.indexOf("em") !== -1) ? o : isNaN(+o) ? lf + "px" : o + "px";
    }
    function xee(o, i) {
      for (var t3 = 0; t3 < bee.length; t3++) {
        var c3 = bee[t3], p3 = i[c3];
        p3 != null && (o[c3] = p3);
      }
    }
    function wee(o) {
      return o.fontSize != null || o.fontFamily || o.fontWeight;
    }
    function dve(o) {
      return See(o), yt(o.rich, See), o;
    }
    function See(o) {
      if (o) {
        o.font = mee.makeFont(o);
        var i = o.align;
        i === "middle" && (i = "center"), o.align = i == null || hve[i] ? i : "left";
        var t3 = o.verticalAlign;
        t3 === "center" && (t3 = "middle"), o.verticalAlign = t3 == null || pve[t3] ? t3 : "top";
        var c3 = o.padding;
        c3 && (o.padding = k2(o.padding));
      }
    }
    function Cee(o, i) {
      return o == null || i <= 0 || o === "transparent" || o === "none" ? null : o.image || o.colorStops ? "#000" : o;
    }
    function Mee(o) {
      return o == null || o === "none" ? null : o.image || o.colorStops ? "#000" : o;
    }
    function Eb(o, i, t3) {
      return i === "right" ? o - t3[1] : i === "center" ? o + t3[3] / 2 - t3[1] / 2 : o + t3[3];
    }
    function Tee(o) {
      var i = o.text;
      return i != null && (i += ""), i;
    }
    function KG(o) {
      return !!(o.backgroundColor || o.lineHeight || o.borderWidth && o.borderColor);
    }
    var Fl = mee, La = mu(), ZG = function(o, i, t3, c3) {
      if (c3) {
        var p3 = La(c3);
        p3.dataIndex = t3, p3.dataType = i, p3.seriesIndex = o, c3.type === "group" && c3.traverse(function(g3) {
          var b3 = La(g3);
          b3.seriesIndex = o, b3.dataIndex = t3, b3.dataType = i;
        });
      }
    }, gy = 1, Qp = {}, Aee = mu(), Sw = mu(), JG = 0, WP = 1, ZF = 2, yy = ["emphasis", "blur", "select"], UP = ["normal", "emphasis", "blur", "select"], qM = 10, vve = 9, my = "highlight", qP = "downplay", $M = "select", Hh = "unselect", Wh = "toggleSelect";
    function MI(o) {
      return o != null && o !== "none";
    }
    var Iee = new TP(100);
    function Eee(o) {
      if (Ha(o)) {
        var i = Iee.get(o);
        return i || (i = rG(o, -0.1), Iee.put(o, i)), i;
      } else if (rF(o)) {
        var t3 = ti({}, o);
        return t3.colorStops = Fi(o.colorStops, function(c3) {
          return { offset: c3.offset, color: rG(c3.color, -0.1) };
        }), t3;
      }
      return o;
    }
    function JF(o, i, t3) {
      o.onHoverStateChange && (o.hoverState || 0) !== t3 && o.onHoverStateChange(i), o.hoverState = t3;
    }
    function Dee(o) {
      JF(o, "emphasis", ZF);
    }
    function kee(o) {
      o.hoverState === ZF && JF(o, "normal", JG);
    }
    function QG(o) {
      JF(o, "blur", WP);
    }
    function eH(o) {
      o.hoverState === WP && JF(o, "normal", JG);
    }
    function $P(o) {
      o.selected = true;
    }
    function tH(o) {
      o.selected = false;
    }
    function Oee(o, i, t3) {
      i(o, t3);
    }
    function Cw(o, i, t3) {
      Oee(o, i, t3), o.isGroup && o.traverse(function(c3) {
        Oee(c3, i, t3);
      });
    }
    function TI(o, i) {
      switch (i) {
        case "emphasis":
          o.hoverState = ZF;
          break;
        case "normal":
          o.hoverState = JG;
          break;
        case "blur":
          o.hoverState = WP;
          break;
        case "select":
          o.selected = true;
      }
    }
    function L1(o, i, t3, c3) {
      for (var p3 = o.style, g3 = {}, b3 = 0; b3 < i.length; b3++) {
        var w3 = i[b3], M = p3[w3];
        g3[w3] = M == null ? c3 && c3[w3] : M;
      }
      for (var b3 = 0; b3 < o.animators.length; b3++) {
        var I = o.animators[b3];
        I.__fromStateTransition && I.__fromStateTransition.indexOf(t3) < 0 && I.targetName === "style" && I.saveTo(g3, i);
      }
      return g3;
    }
    function Y5(o, i, t3, c3) {
      var p3 = t3 && rl(t3, "select") >= 0, g3 = false;
      if (o instanceof gl) {
        var b3 = Aee(o), w3 = p3 && b3.selectFill || b3.normalFill, M = p3 && b3.selectStroke || b3.normalStroke;
        if (MI(w3) || MI(M)) {
          c3 = c3 || {};
          var I = c3.style || {};
          I.fill === "inherit" ? (g3 = true, c3 = ti({}, c3), I = ti({}, I), I.fill = w3) : !MI(I.fill) && MI(w3) ? (g3 = true, c3 = ti({}, c3), I = ti({}, I), I.fill = Eee(w3)) : !MI(I.stroke) && MI(M) && (g3 || (c3 = ti({}, c3), I = ti({}, I)), I.stroke = Eee(M)), c3.style = I;
        }
      }
      if (c3 && c3.z2 == null) {
        g3 || (c3 = ti({}, c3));
        var k3 = o.z2EmphasisLift;
        c3.z2 = o.z2 + (k3 != null ? k3 : qM);
      }
      return c3;
    }
    function gve(o, i, t3) {
      if (t3 && t3.z2 == null) {
        t3 = ti({}, t3);
        var c3 = o.z2SelectLift;
        t3.z2 = o.z2 + (c3 != null ? c3 : vve);
      }
      return t3;
    }
    function yve(o, i, t3) {
      var c3 = rl(o.currentStates, i) >= 0, p3 = o.style.opacity, g3 = c3 ? null : L1(o, ["opacity"], i, { opacity: 1 });
      t3 = t3 || {};
      var b3 = t3.style || {};
      return b3.opacity == null && (t3 = ti({}, t3), b3 = ti({ opacity: c3 ? p3 : g3.opacity * 0.1 }, b3), t3.style = b3), t3;
    }
    function nH(o, i) {
      var t3 = this.states[o];
      if (this.style) {
        if (o === "emphasis")
          return Y5(this, o, i, t3);
        if (o === "blur")
          return yve(this, o, t3);
        if (o === "select")
          return gve(this, o, t3);
      }
      return t3;
    }
    function AI(o) {
      o.stateProxy = nH;
      var i = o.getTextContent(), t3 = o.getTextGuideLine();
      i && (i.stateProxy = nH), t3 && (t3.stateProxy = nH);
    }
    function Pee(o, i) {
      !xf(o, i) && !o.__highByOuter && Cw(o, Dee);
    }
    function rH(o, i) {
      !xf(o, i) && !o.__highByOuter && Cw(o, kee);
    }
    function Hv(o, i) {
      o.__highByOuter |= 1 << (i || 0), Cw(o, Dee);
    }
    function sl(o, i) {
      !(o.__highByOuter &= ~(1 << (i || 0))) && Cw(o, kee);
    }
    function iH(o) {
      Cw(o, QG);
    }
    function R1(o) {
      Cw(o, eH);
    }
    function aH(o) {
      Cw(o, $P);
    }
    function Lee(o) {
      Cw(o, tH);
    }
    function xf(o, i) {
      return o.__highDownSilentOnTouch && i.zrByTouch;
    }
    function Ree(o) {
      var i = o.getModel();
      i.eachComponent(function(t3, c3) {
        var p3 = Sw(c3);
        if (p3.isBlured) {
          var g3 = t3 === "series" ? o.getViewOfSeriesModel(c3) : o.getViewOfComponentModel(c3);
          g3.group.traverse(function(b3) {
            eH(b3);
          });
        }
        p3.isBlured = false;
      });
    }
    function QF(o, i, t3, c3) {
      var p3 = c3.getModel();
      t3 = t3 || "coordinateSystem";
      function g3(I, k3) {
        for (var L = 0; L < k3.length; L++) {
          var F = I.getItemGraphicEl(k3[L]);
          F && R1(F);
        }
      }
      if (o != null && !(!i || i === "none")) {
        var b3 = p3.getSeriesByIndex(o), w3 = b3.coordinateSystem;
        w3 && w3.master && (w3 = w3.master);
        var M = [];
        p3.eachSeries(function(I) {
          var k3 = b3 === I, L = I.coordinateSystem;
          L && L.master && (L = L.master);
          var F = L && w3 ? L === w3 : k3;
          if (!(t3 === "series" && !k3 || t3 === "coordinateSystem" && !F || i === "series" && k3)) {
            var B = c3.getViewOfSeriesModel(I);
            if (B.group.traverse(function(Q) {
              QG(Q);
            }), yg(i))
              g3(I.getData(), i);
            else if (Ua(i))
              for (var G = Gl(i), J = 0; J < G.length; J++)
                g3(I.getData(G[J]), i[G[J]]);
            M.push(I), Sw(I).isBlured = true;
          }
        }), p3.eachComponent(function(I, k3) {
          if (I !== "series") {
            var L = c3.getViewOfComponentModel(k3);
            L && L.blurSeries && L.blurSeries(M, p3);
          }
        });
      }
    }
    function K5(o, i, t3) {
      if (!(o == null || i == null)) {
        var c3 = t3.getModel().getComponent(o, i);
        if (c3) {
          Sw(c3).isBlured = true;
          var p3 = t3.getViewOfComponentModel(c3);
          !p3 || !p3.focusBlurEnabled || p3.group.traverse(function(g3) {
            QG(g3);
          });
        }
      }
    }
    function mve(o, i, t3) {
      var c3 = o.seriesIndex, p3 = o.getData(i.dataType);
      if (p3) {
        var g3 = k_(p3, i);
        g3 = (Ei(g3) ? g3[0] : g3) || 0;
        var b3 = p3.getItemGraphicEl(g3);
        if (!b3)
          for (var w3 = p3.count(), M = 0; !b3 && M < w3; )
            b3 = p3.getItemGraphicEl(M++);
        if (b3) {
          var I = La(b3);
          QF(c3, I.focus, I.blurScope, t3);
        } else {
          var k3 = o.get(["emphasis", "focus"]), L = o.get(["emphasis", "blurScope"]);
          k3 != null && QF(c3, k3, L, t3);
        }
      }
    }
    function oH(o, i, t3, c3) {
      var p3 = { focusSelf: false, dispatchers: null };
      if (o == null || o === "series" || i == null || t3 == null)
        return p3;
      var g3 = c3.getModel().getComponent(o, i);
      if (!g3)
        return p3;
      var b3 = c3.getViewOfComponentModel(g3);
      if (!b3 || !b3.findHighDownDispatchers)
        return p3;
      for (var w3 = b3.findHighDownDispatchers(t3), M, I = 0; I < w3.length; I++)
        if (La(w3[I]).focus === "self") {
          M = true;
          break;
        }
      return { focusSelf: M, dispatchers: w3 };
    }
    function bve(o, i, t3) {
      var c3 = La(o), p3 = oH(c3.componentMainType, c3.componentIndex, c3.componentHighDownName, t3), g3 = p3.dispatchers, b3 = p3.focusSelf;
      g3 ? (b3 && K5(c3.componentMainType, c3.componentIndex, t3), yt(g3, function(w3) {
        return Pee(w3, i);
      })) : (QF(c3.seriesIndex, c3.focus, c3.blurScope, t3), c3.focus === "self" && K5(c3.componentMainType, c3.componentIndex, t3), Pee(o, i));
    }
    function _ve(o, i, t3) {
      Ree(t3);
      var c3 = La(o), p3 = oH(c3.componentMainType, c3.componentIndex, c3.componentHighDownName, t3).dispatchers;
      p3 ? yt(p3, function(g3) {
        return rH(g3, i);
      }) : rH(o, i);
    }
    function xve(o, i, t3) {
      if (lH(i)) {
        var c3 = i.dataType, p3 = o.getData(c3), g3 = k_(p3, i);
        Ei(g3) || (g3 = [g3]), o[i.type === Wh ? "toggleSelect" : i.type === $M ? "select" : "unselect"](g3, c3);
      }
    }
    function Nee(o) {
      var i = o.getAllData();
      yt(i, function(t3) {
        var c3 = t3.data, p3 = t3.type;
        c3.eachItemGraphicEl(function(g3, b3) {
          o.isSelected(b3, p3) ? aH(g3) : Lee(g3);
        });
      });
    }
    function wve(o) {
      var i = [];
      return o.eachSeries(function(t3) {
        var c3 = t3.getAllData();
        yt(c3, function(p3) {
          p3.data;
          var g3 = p3.type, b3 = t3.getSelectedDataIndices();
          if (b3.length > 0) {
            var w3 = { dataIndex: b3, seriesIndex: t3.seriesIndex };
            g3 != null && (w3.dataType = g3), i.push(w3);
          }
        });
      }), i;
    }
    function II(o, i, t3) {
      EI(o, true), Cw(o, AI), sH(o, i, t3);
    }
    function Sve(o) {
      EI(o, false);
    }
    function zp(o, i, t3, c3) {
      c3 ? Sve(o) : II(o, i, t3);
    }
    function sH(o, i, t3) {
      var c3 = La(o);
      i != null ? (c3.focus = i, c3.blurScope = t3) : c3.focus && (c3.focus = null);
    }
    var Fee = ["emphasis", "blur", "select"], Cve = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
    function cv(o, i, t3, c3) {
      t3 = t3 || "itemStyle";
      for (var p3 = 0; p3 < Fee.length; p3++) {
        var g3 = Fee[p3], b3 = i.getModel([g3, t3]), w3 = o.ensureState(g3);
        w3.style = c3 ? c3(b3) : b3[Cve[t3]]();
      }
    }
    function EI(o, i) {
      var t3 = i === false, c3 = o;
      o.highDownSilentOnTouch && (c3.__highDownSilentOnTouch = o.highDownSilentOnTouch), (!t3 || c3.__highDownDispatcher) && (c3.__highByOuter = c3.__highByOuter || 0, c3.__highDownDispatcher = !t3);
    }
    function DI(o) {
      return !!(o && o.__highDownDispatcher);
    }
    function Mve(o, i, t3) {
      var c3 = La(o);
      c3.componentMainType = i.mainType, c3.componentIndex = i.componentIndex, c3.componentHighDownName = t3;
    }
    function Tve(o) {
      var i = Qp[o];
      return i == null && gy <= 32 && (i = Qp[o] = gy++), i;
    }
    function lH(o) {
      var i = o.type;
      return i === $M || i === Hh || i === Wh;
    }
    function fv(o) {
      var i = o.type;
      return i === my || i === qP;
    }
    function mm(o) {
      var i = Aee(o);
      i.normalFill = o.style.fill, i.normalStroke = o.style.stroke;
      var t3 = o.states.select || {};
      i.selectFill = t3.style && t3.style.fill || null, i.selectStroke = t3.style && t3.style.stroke || null;
    }
    var Z5 = ww.CMD, Ave = [[], [], []], Vee = Math.sqrt, Bee = Math.atan2;
    function zee(o, i) {
      if (i) {
        var t3 = o.data, c3 = o.len(), p3, g3, b3, w3, M, I, k3 = Z5.M, L = Z5.C, F = Z5.L, B = Z5.R, G = Z5.A, J = Z5.Q;
        for (b3 = 0, w3 = 0; b3 < c3; ) {
          switch (p3 = t3[b3++], w3 = b3, g3 = 0, p3) {
            case k3:
              g3 = 1;
              break;
            case F:
              g3 = 1;
              break;
            case L:
              g3 = 3;
              break;
            case J:
              g3 = 2;
              break;
            case G:
              var Q = i[4], se = i[5], he = Vee(i[0] * i[0] + i[1] * i[1]), be = Vee(i[2] * i[2] + i[3] * i[3]), de = Bee(-i[1] / be, i[0] / he);
              t3[b3] *= he, t3[b3++] += Q, t3[b3] *= be, t3[b3++] += se, t3[b3++] *= he, t3[b3++] *= be, t3[b3++] += de, t3[b3++] += de, b3 += 2, w3 = b3;
              break;
            case B:
              I[0] = t3[b3++], I[1] = t3[b3++], Vv(I, I, i), t3[w3++] = I[0], t3[w3++] = I[1], I[0] += t3[b3++], I[1] += t3[b3++], Vv(I, I, i), t3[w3++] = I[0], t3[w3++] = I[1];
          }
          for (M = 0; M < g3; M++) {
            var Fe = Ave[M];
            Fe[0] = t3[b3++], Fe[1] = t3[b3++], Vv(Fe, Fe, i), t3[w3++] = Fe[0], t3[w3++] = Fe[1];
          }
        }
        o.increaseVersion();
      }
    }
    var uH = Math.sqrt, e8 = Math.sin, XP = Math.cos, YP = Math.PI;
    function jee(o) {
      return Math.sqrt(o[0] * o[0] + o[1] * o[1]);
    }
    function cH(o, i) {
      return (o[0] * i[0] + o[1] * i[1]) / (jee(o) * jee(i));
    }
    function fH(o, i) {
      return (o[0] * i[1] < o[1] * i[0] ? -1 : 1) * Math.acos(cH(o, i));
    }
    function hH(o, i, t3, c3, p3, g3, b3, w3, M, I, k3) {
      var L = M * (YP / 180), F = XP(L) * (o - t3) / 2 + e8(L) * (i - c3) / 2, B = -1 * e8(L) * (o - t3) / 2 + XP(L) * (i - c3) / 2, G = F * F / (b3 * b3) + B * B / (w3 * w3);
      G > 1 && (b3 *= uH(G), w3 *= uH(G));
      var J = (p3 === g3 ? -1 : 1) * uH((b3 * b3 * (w3 * w3) - b3 * b3 * (B * B) - w3 * w3 * (F * F)) / (b3 * b3 * (B * B) + w3 * w3 * (F * F))) || 0, Q = J * b3 * B / w3, se = J * -w3 * F / b3, he = (o + t3) / 2 + XP(L) * Q - e8(L) * se, be = (i + c3) / 2 + e8(L) * Q + XP(L) * se, de = fH([1, 0], [(F - Q) / b3, (B - se) / w3]), Fe = [(F - Q) / b3, (B - se) / w3], Pe = [(-1 * F - Q) / b3, (-1 * B - se) / w3], ze = fH(Fe, Pe);
      if (cH(Fe, Pe) <= -1 && (ze = YP), cH(Fe, Pe) >= 1 && (ze = 0), ze < 0) {
        var $e = Math.round(ze / YP * 1e6) / 1e6;
        ze = YP * 2 + $e % 2 * YP;
      }
      k3.addData(I, he, be, b3, w3, de, ze, L, g3);
    }
    var Ive = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, Eve = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
    function Dve(o) {
      var i = new ww();
      if (!o)
        return i;
      var t3 = 0, c3 = 0, p3 = t3, g3 = c3, b3, w3 = ww.CMD, M = o.match(Ive);
      if (!M)
        return i;
      for (var I = 0; I < M.length; I++) {
        for (var k3 = M[I], L = k3.charAt(0), F = void 0, B = k3.match(Eve) || [], G = B.length, J = 0; J < G; J++)
          B[J] = parseFloat(B[J]);
        for (var Q = 0; Q < G; ) {
          var se = void 0, he = void 0, be = void 0, de = void 0, Fe = void 0, Pe = void 0, ze = void 0, $e = t3, Ke = c3, nt = void 0, lt2 = void 0;
          switch (L) {
            case "l":
              t3 += B[Q++], c3 += B[Q++], F = w3.L, i.addData(F, t3, c3);
              break;
            case "L":
              t3 = B[Q++], c3 = B[Q++], F = w3.L, i.addData(F, t3, c3);
              break;
            case "m":
              t3 += B[Q++], c3 += B[Q++], F = w3.M, i.addData(F, t3, c3), p3 = t3, g3 = c3, L = "l";
              break;
            case "M":
              t3 = B[Q++], c3 = B[Q++], F = w3.M, i.addData(F, t3, c3), p3 = t3, g3 = c3, L = "L";
              break;
            case "h":
              t3 += B[Q++], F = w3.L, i.addData(F, t3, c3);
              break;
            case "H":
              t3 = B[Q++], F = w3.L, i.addData(F, t3, c3);
              break;
            case "v":
              c3 += B[Q++], F = w3.L, i.addData(F, t3, c3);
              break;
            case "V":
              c3 = B[Q++], F = w3.L, i.addData(F, t3, c3);
              break;
            case "C":
              F = w3.C, i.addData(F, B[Q++], B[Q++], B[Q++], B[Q++], B[Q++], B[Q++]), t3 = B[Q - 2], c3 = B[Q - 1];
              break;
            case "c":
              F = w3.C, i.addData(F, B[Q++] + t3, B[Q++] + c3, B[Q++] + t3, B[Q++] + c3, B[Q++] + t3, B[Q++] + c3), t3 += B[Q - 2], c3 += B[Q - 1];
              break;
            case "S":
              se = t3, he = c3, nt = i.len(), lt2 = i.data, b3 === w3.C && (se += t3 - lt2[nt - 4], he += c3 - lt2[nt - 3]), F = w3.C, $e = B[Q++], Ke = B[Q++], t3 = B[Q++], c3 = B[Q++], i.addData(F, se, he, $e, Ke, t3, c3);
              break;
            case "s":
              se = t3, he = c3, nt = i.len(), lt2 = i.data, b3 === w3.C && (se += t3 - lt2[nt - 4], he += c3 - lt2[nt - 3]), F = w3.C, $e = t3 + B[Q++], Ke = c3 + B[Q++], t3 += B[Q++], c3 += B[Q++], i.addData(F, se, he, $e, Ke, t3, c3);
              break;
            case "Q":
              $e = B[Q++], Ke = B[Q++], t3 = B[Q++], c3 = B[Q++], F = w3.Q, i.addData(F, $e, Ke, t3, c3);
              break;
            case "q":
              $e = B[Q++] + t3, Ke = B[Q++] + c3, t3 += B[Q++], c3 += B[Q++], F = w3.Q, i.addData(F, $e, Ke, t3, c3);
              break;
            case "T":
              se = t3, he = c3, nt = i.len(), lt2 = i.data, b3 === w3.Q && (se += t3 - lt2[nt - 4], he += c3 - lt2[nt - 3]), t3 = B[Q++], c3 = B[Q++], F = w3.Q, i.addData(F, se, he, t3, c3);
              break;
            case "t":
              se = t3, he = c3, nt = i.len(), lt2 = i.data, b3 === w3.Q && (se += t3 - lt2[nt - 4], he += c3 - lt2[nt - 3]), t3 += B[Q++], c3 += B[Q++], F = w3.Q, i.addData(F, se, he, t3, c3);
              break;
            case "A":
              be = B[Q++], de = B[Q++], Fe = B[Q++], Pe = B[Q++], ze = B[Q++], $e = t3, Ke = c3, t3 = B[Q++], c3 = B[Q++], F = w3.A, hH($e, Ke, t3, c3, Pe, ze, be, de, Fe, F, i);
              break;
            case "a":
              be = B[Q++], de = B[Q++], Fe = B[Q++], Pe = B[Q++], ze = B[Q++], $e = t3, Ke = c3, t3 += B[Q++], c3 += B[Q++], F = w3.A, hH($e, Ke, t3, c3, Pe, ze, be, de, Fe, F, i);
              break;
          }
        }
        (L === "z" || L === "Z") && (F = w3.Z, i.addData(F), t3 = p3, c3 = g3), b3 = F;
      }
      return i.toStatic(), i;
    }
    var Gee = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.applyTransform = function(t3) {
      }, i;
    }(gl);
    function kI(o) {
      return o.setData != null;
    }
    function Hee(o, i) {
      var t3 = Dve(o), c3 = ti({}, i);
      return c3.buildPath = function(p3) {
        if (kI(p3)) {
          p3.setData(t3.data);
          var g3 = p3.getContext();
          g3 && p3.rebuildPath(g3, 1);
        } else {
          var g3 = p3;
          t3.rebuildPath(g3, 1);
        }
      }, c3.applyTransform = function(p3) {
        zee(t3, p3), this.dirtyShape();
      }, c3;
    }
    function Wee(o, i) {
      return new Gee(Hee(o, i));
    }
    function kve(o, i) {
      var t3 = Hee(o, i), c3 = function(p3) {
        cn(g3, p3);
        function g3(b3) {
          var w3 = p3.call(this, b3) || this;
          return w3.applyTransform = t3.applyTransform, w3.buildPath = t3.buildPath, w3;
        }
        return g3;
      }(Gee);
      return c3;
    }
    function Ove(o, i) {
      for (var t3 = [], c3 = o.length, p3 = 0; p3 < c3; p3++) {
        var g3 = o[p3];
        t3.push(g3.getUpdatedPathProxy(true));
      }
      var b3 = new gl(i);
      return b3.createPathProxy(), b3.buildPath = function(w3) {
        if (kI(w3)) {
          w3.appendPath(t3);
          var M = w3.getContext();
          M && w3.rebuildPath(M, 1);
        }
      }, b3;
    }
    function pH(o, i) {
      i = i || {};
      var t3 = new gl();
      return o.shape && t3.setShape(o.shape), t3.setStyle(o.style), i.bakeTransform ? zee(t3.path, o.getComputedTransform()) : i.toLocal ? t3.setLocalTransform(o.getComputedTransform()) : t3.copyTransform(o), t3.buildPath = o.buildPath, t3.applyTransform = t3.applyTransform, t3.z = o.z, t3.z2 = o.z2, t3.zlevel = o.zlevel, t3;
    }
    var Uee = function() {
      function o() {
        this.cx = 0, this.cy = 0, this.r = 0;
      }
      return o;
    }(), dH = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new Uee();
      }, i.prototype.buildPath = function(t3, c3) {
        t3.moveTo(c3.cx + c3.r, c3.cy), t3.arc(c3.cx, c3.cy, c3.r, 0, Math.PI * 2);
      }, i;
    }(gl);
    dH.prototype.type = "circle";
    var Mw = dH, Pve = function() {
      function o() {
        this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
      }
      return o;
    }(), qee = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new Pve();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = 0.5522848, g3 = c3.cx, b3 = c3.cy, w3 = c3.rx, M = c3.ry, I = w3 * p3, k3 = M * p3;
        t3.moveTo(g3 - w3, b3), t3.bezierCurveTo(g3 - w3, b3 - k3, g3 - I, b3 - M, g3, b3 - M), t3.bezierCurveTo(g3 + I, b3 - M, g3 + w3, b3 - k3, g3 + w3, b3), t3.bezierCurveTo(g3 + w3, b3 + k3, g3 + I, b3 + M, g3, b3 + M), t3.bezierCurveTo(g3 - I, b3 + M, g3 - w3, b3 + k3, g3 - w3, b3), t3.closePath();
      }, i;
    }(gl);
    qee.prototype.type = "ellipse";
    var vH = qee, $ee = Math.PI, gH = $ee * 2, OI = Math.sin, J5 = Math.cos, Lve = Math.acos, d0 = Math.atan2, Xee = Math.abs, KP = Math.sqrt, ZP = Math.max, Tw = Math.min, O_ = 1e-4;
    function Rve(o, i, t3, c3, p3, g3, b3, w3) {
      var M = t3 - o, I = c3 - i, k3 = b3 - p3, L = w3 - g3, F = L * M - k3 * I;
      if (!(F * F < O_))
        return F = (k3 * (i - g3) - L * (o - p3)) / F, [o + F * M, i + F * I];
    }
    function t8(o, i, t3, c3, p3, g3, b3) {
      var w3 = o - t3, M = i - c3, I = (b3 ? g3 : -g3) / KP(w3 * w3 + M * M), k3 = I * M, L = -I * w3, F = o + k3, B = i + L, G = t3 + k3, J = c3 + L, Q = (F + G) / 2, se = (B + J) / 2, he = G - F, be = J - B, de = he * he + be * be, Fe = p3 - g3, Pe = F * J - G * B, ze = (be < 0 ? -1 : 1) * KP(ZP(0, Fe * Fe * de - Pe * Pe)), $e = (Pe * be - he * ze) / de, Ke = (-Pe * he - be * ze) / de, nt = (Pe * be + he * ze) / de, lt2 = (-Pe * he + be * ze) / de, bt = $e - Q, vt = Ke - se, jt = nt - Q, Jt = lt2 - se;
      return bt * bt + vt * vt > jt * jt + Jt * Jt && ($e = nt, Ke = lt2), { cx: $e, cy: Ke, x0: -k3, y0: -L, x1: $e * (p3 / Fe - 1), y1: Ke * (p3 / Fe - 1) };
    }
    function Nve(o) {
      var i;
      if (Ei(o)) {
        var t3 = o.length;
        if (!t3)
          return o;
        t3 === 1 ? i = [o[0], o[0], 0, 0] : t3 === 2 ? i = [o[0], o[0], o[1], o[1]] : t3 === 3 ? i = o.concat(o[2]) : i = o;
      } else
        i = [o, o, o, o];
      return i;
    }
    function Fve(o, i) {
      var t3, c3 = ZP(i.r, 0), p3 = ZP(i.r0 || 0, 0), g3 = c3 > 0, b3 = p3 > 0;
      if (!(!g3 && !b3)) {
        if (g3 || (c3 = p3, p3 = 0), p3 > c3) {
          var w3 = c3;
          c3 = p3, p3 = w3;
        }
        var M = i.startAngle, I = i.endAngle;
        if (!(isNaN(M) || isNaN(I))) {
          var k3 = i.cx, L = i.cy, F = !!i.clockwise, B = Xee(I - M), G = B > gH && B % gH;
          if (G > O_ && (B = G), !(c3 > O_))
            o.moveTo(k3, L);
          else if (B > gH - O_)
            o.moveTo(k3 + c3 * J5(M), L + c3 * OI(M)), o.arc(k3, L, c3, M, I, !F), p3 > O_ && (o.moveTo(k3 + p3 * J5(I), L + p3 * OI(I)), o.arc(k3, L, p3, I, M, F));
          else {
            var J = void 0, Q = void 0, se = void 0, he = void 0, be = void 0, de = void 0, Fe = void 0, Pe = void 0, ze = void 0, $e = void 0, Ke = void 0, nt = void 0, lt2 = void 0, bt = void 0, vt = void 0, jt = void 0, Jt = c3 * J5(M), Rt = c3 * OI(M), Jn = p3 * J5(I), ln = p3 * OI(I), vn = B > O_;
            if (vn) {
              var kn = i.cornerRadius;
              kn && (t3 = Nve(kn), J = t3[0], Q = t3[1], se = t3[2], he = t3[3]);
              var cr = Xee(c3 - p3) / 2;
              if (be = Tw(cr, se), de = Tw(cr, he), Fe = Tw(cr, J), Pe = Tw(cr, Q), Ke = ze = ZP(be, de), nt = $e = ZP(Fe, Pe), (ze > O_ || $e > O_) && (lt2 = c3 * J5(I), bt = c3 * OI(I), vt = p3 * J5(M), jt = p3 * OI(M), B < $ee)) {
                var gr = Rve(Jt, Rt, vt, jt, lt2, bt, Jn, ln);
                if (gr) {
                  var ha = Jt - gr[0], Ka = Rt - gr[1], Do = lt2 - gr[0], _o = bt - gr[1], xo = 1 / OI(Lve((ha * Do + Ka * _o) / (KP(ha * ha + Ka * Ka) * KP(Do * Do + _o * _o))) / 2), Ra = KP(gr[0] * gr[0] + gr[1] * gr[1]);
                  Ke = Tw(ze, (c3 - Ra) / (xo + 1)), nt = Tw($e, (p3 - Ra) / (xo - 1));
                }
              }
            }
            if (!vn)
              o.moveTo(k3 + Jt, L + Rt);
            else if (Ke > O_) {
              var ho = Tw(se, Ke), Mo = Tw(he, Ke), Xa = t8(vt, jt, Jt, Rt, c3, ho, F), Zo = t8(lt2, bt, Jn, ln, c3, Mo, F);
              o.moveTo(k3 + Xa.cx + Xa.x0, L + Xa.cy + Xa.y0), Ke < ze && ho === Mo ? o.arc(k3 + Xa.cx, L + Xa.cy, Ke, d0(Xa.y0, Xa.x0), d0(Zo.y0, Zo.x0), !F) : (ho > 0 && o.arc(k3 + Xa.cx, L + Xa.cy, ho, d0(Xa.y0, Xa.x0), d0(Xa.y1, Xa.x1), !F), o.arc(k3, L, c3, d0(Xa.cy + Xa.y1, Xa.cx + Xa.x1), d0(Zo.cy + Zo.y1, Zo.cx + Zo.x1), !F), Mo > 0 && o.arc(k3 + Zo.cx, L + Zo.cy, Mo, d0(Zo.y1, Zo.x1), d0(Zo.y0, Zo.x0), !F));
            } else
              o.moveTo(k3 + Jt, L + Rt), o.arc(k3, L, c3, M, I, !F);
            if (!(p3 > O_) || !vn)
              o.lineTo(k3 + Jn, L + ln);
            else if (nt > O_) {
              var ho = Tw(J, nt), Mo = Tw(Q, nt), Xa = t8(Jn, ln, lt2, bt, p3, -Mo, F), Zo = t8(Jt, Rt, vt, jt, p3, -ho, F);
              o.lineTo(k3 + Xa.cx + Xa.x0, L + Xa.cy + Xa.y0), nt < $e && ho === Mo ? o.arc(k3 + Xa.cx, L + Xa.cy, nt, d0(Xa.y0, Xa.x0), d0(Zo.y0, Zo.x0), !F) : (Mo > 0 && o.arc(k3 + Xa.cx, L + Xa.cy, Mo, d0(Xa.y0, Xa.x0), d0(Xa.y1, Xa.x1), !F), o.arc(k3, L, p3, d0(Xa.cy + Xa.y1, Xa.cx + Xa.x1), d0(Zo.cy + Zo.y1, Zo.cx + Zo.x1), F), ho > 0 && o.arc(k3 + Zo.cx, L + Zo.cy, ho, d0(Zo.y1, Zo.x1), d0(Zo.y0, Zo.x0), !F));
            } else
              o.lineTo(k3 + Jn, L + ln), o.arc(k3, L, p3, I, M, F);
          }
          o.closePath();
        }
      }
    }
    var Vve = function() {
      function o() {
        this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
      }
      return o;
    }(), Yee = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new Vve();
      }, i.prototype.buildPath = function(t3, c3) {
        Fve(t3, c3);
      }, i.prototype.isZeroArea = function() {
        return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
      }, i;
    }(gl);
    Yee.prototype.type = "sector";
    var bm = Yee, Bve = function() {
      function o() {
        this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
      }
      return o;
    }(), Kee = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new Bve();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.cx, g3 = c3.cy, b3 = Math.PI * 2;
        t3.moveTo(p3 + c3.r, g3), t3.arc(p3, g3, c3.r, 0, b3, false), t3.moveTo(p3 + c3.r0, g3), t3.arc(p3, g3, c3.r0, 0, b3, true);
      }, i;
    }(gl);
    Kee.prototype.type = "ring";
    var n8 = Kee;
    function yH(o, i, t3, c3) {
      var p3 = [], g3 = [], b3 = [], w3 = [], M, I, k3, L;
      if (c3) {
        k3 = [1 / 0, 1 / 0], L = [-1 / 0, -1 / 0];
        for (var F = 0, B = o.length; F < B; F++)
          L2(k3, k3, o[F]), sw(L, L, o[F]);
        L2(k3, k3, c3[0]), sw(L, L, c3[1]);
      }
      for (var F = 0, B = o.length; F < B; F++) {
        var G = o[F];
        if (t3)
          M = o[F ? F - 1 : B - 1], I = o[(F + 1) % B];
        else if (F === 0 || F === B - 1) {
          p3.push(wb(o[F]));
          continue;
        } else
          M = o[F - 1], I = o[F + 1];
        O2(g3, I, M), Uj(g3, g3, i);
        var J = qj(G, M), Q = qj(G, I), se = J + Q;
        se !== 0 && (J /= se, Q /= se), Uj(b3, g3, -J), Uj(w3, g3, Q);
        var he = rp([], G, b3), be = rp([], G, w3);
        c3 && (sw(he, he, k3), L2(he, he, L), sw(be, be, k3), L2(be, be, L)), p3.push(he), p3.push(be);
      }
      return t3 && p3.push(p3.shift()), p3;
    }
    function mH(o, i, t3) {
      var c3 = i.smooth, p3 = i.points;
      if (p3 && p3.length >= 2) {
        if (c3) {
          var g3 = yH(p3, c3, t3, i.smoothConstraint);
          o.moveTo(p3[0][0], p3[0][1]);
          for (var b3 = p3.length, w3 = 0; w3 < (t3 ? b3 : b3 - 1); w3++) {
            var M = g3[w3 * 2], I = g3[w3 * 2 + 1], k3 = p3[(w3 + 1) % b3];
            o.bezierCurveTo(M[0], M[1], I[0], I[1], k3[0], k3[1]);
          }
        } else {
          o.moveTo(p3[0][0], p3[0][1]);
          for (var w3 = 1, L = p3.length; w3 < L; w3++)
            o.lineTo(p3[w3][0], p3[w3][1]);
        }
        t3 && o.closePath();
      }
    }
    var Zee = function() {
      function o() {
        this.points = null, this.smooth = 0, this.smoothConstraint = null;
      }
      return o;
    }(), Jee = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new Zee();
      }, i.prototype.buildPath = function(t3, c3) {
        mH(t3, c3, true);
      }, i;
    }(gl);
    Jee.prototype.type = "polygon";
    var _m = Jee, zve = function() {
      function o() {
        this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
      }
      return o;
    }(), r8 = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new zve();
      }, i.prototype.buildPath = function(t3, c3) {
        mH(t3, c3, false);
      }, i;
    }(gl);
    r8.prototype.type = "polyline";
    var xm = r8, jve = {}, Gve = function() {
      function o() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
      }
      return o;
    }(), by = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new Gve();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3, g3, b3, w3;
        if (this.subPixelOptimize) {
          var M = vee(jve, c3, this.style);
          p3 = M.x1, g3 = M.y1, b3 = M.x2, w3 = M.y2;
        } else
          p3 = c3.x1, g3 = c3.y1, b3 = c3.x2, w3 = c3.y2;
        var I = c3.percent;
        I !== 0 && (t3.moveTo(p3, g3), I < 1 && (b3 = p3 * (1 - I) + b3 * I, w3 = g3 * (1 - I) + w3 * I), t3.lineTo(b3, w3));
      }, i.prototype.pointAt = function(t3) {
        var c3 = this.shape;
        return [c3.x1 * (1 - t3) + c3.x2 * t3, c3.y1 * (1 - t3) + c3.y2 * t3];
      }, i;
    }(gl);
    by.prototype.type = "line";
    var Ud = by, wm = [], Hve = function() {
      function o() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
      }
      return o;
    }();
    function Qee(o, i, t3) {
      var c3 = o.cpx2, p3 = o.cpy2;
      return c3 != null || p3 != null ? [(t3 ? wP : Jp)(o.x1, o.cpx1, o.cpx2, o.x2, i), (t3 ? wP : Jp)(o.y1, o.cpy1, o.cpy2, o.y2, i)] : [(t3 ? Bv : Dc)(o.x1, o.cpx1, o.x2, i), (t3 ? Bv : Dc)(o.y1, o.cpy1, o.y2, i)];
    }
    var ete = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new Hve();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.x1, g3 = c3.y1, b3 = c3.x2, w3 = c3.y2, M = c3.cpx1, I = c3.cpy1, k3 = c3.cpx2, L = c3.cpy2, F = c3.percent;
        F !== 0 && (t3.moveTo(p3, g3), k3 == null || L == null ? (F < 1 && (D5(p3, M, b3, F, wm), M = wm[1], b3 = wm[2], D5(g3, I, w3, F, wm), I = wm[1], w3 = wm[2]), t3.quadraticCurveTo(M, I, b3, w3)) : (F < 1 && (F2(p3, M, k3, b3, F, wm), M = wm[1], k3 = wm[2], b3 = wm[3], F2(g3, I, L, w3, F, wm), I = wm[1], L = wm[2], w3 = wm[3]), t3.bezierCurveTo(M, I, k3, L, b3, w3)));
      }, i.prototype.pointAt = function(t3) {
        return Qee(this.shape, t3, false);
      }, i.prototype.tangentAt = function(t3) {
        var c3 = Qee(this.shape, t3, true);
        return yP(c3, c3);
      }, i;
    }(gl);
    ete.prototype.type = "bezier-curve";
    var Q5 = ete, Wve = function() {
      function o() {
        this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
      }
      return o;
    }(), i8 = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new Wve();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.cx, g3 = c3.cy, b3 = Math.max(c3.r, 0), w3 = c3.startAngle, M = c3.endAngle, I = c3.clockwise, k3 = Math.cos(w3), L = Math.sin(w3);
        t3.moveTo(k3 * b3 + p3, L * b3 + g3), t3.arc(p3, g3, b3, w3, M, !I);
      }, i;
    }(gl);
    i8.prototype.type = "arc";
    var bH = i8, Uve = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "compound", t3;
      }
      return i.prototype._updatePathDirty = function() {
        for (var t3 = this.shape.paths, c3 = this.shapeChanged(), p3 = 0; p3 < t3.length; p3++)
          c3 = c3 || t3[p3].shapeChanged();
        c3 && this.dirtyShape();
      }, i.prototype.beforeBrush = function() {
        this._updatePathDirty();
        for (var t3 = this.shape.paths || [], c3 = this.getGlobalScale(), p3 = 0; p3 < t3.length; p3++)
          t3[p3].path || t3[p3].createPathProxy(), t3[p3].path.setScale(c3[0], c3[1], t3[p3].segmentIgnoreThreshold);
      }, i.prototype.buildPath = function(t3, c3) {
        for (var p3 = c3.paths || [], g3 = 0; g3 < p3.length; g3++)
          p3[g3].buildPath(t3, p3[g3].shape, true);
      }, i.prototype.afterBrush = function() {
        for (var t3 = this.shape.paths || [], c3 = 0; c3 < t3.length; c3++)
          t3[c3].pathUpdated();
      }, i.prototype.getBoundingRect = function() {
        return this._updatePathDirty.call(this), gl.prototype.getBoundingRect.call(this);
      }, i;
    }(gl), _H = Uve, qve = function() {
      function o(i) {
        this.colorStops = i || [];
      }
      return o.prototype.addColorStop = function(i, t3) {
        this.colorStops.push({ offset: i, color: t3 });
      }, o;
    }(), xH = qve, $ve = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3, b3, w3) {
        var M = o.call(this, b3) || this;
        return M.x = t3 == null ? 0 : t3, M.y = c3 == null ? 0 : c3, M.x2 = p3 == null ? 1 : p3, M.y2 = g3 == null ? 0 : g3, M.type = "linear", M.global = w3 || false, M;
      }
      return i;
    }(xH), JP = $ve, Xve = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3, b3) {
        var w3 = o.call(this, g3) || this;
        return w3.x = t3 == null ? 0.5 : t3, w3.y = c3 == null ? 0.5 : c3, w3.r = p3 == null ? 0.5 : p3, w3.type = "radial", w3.global = b3 || false, w3;
      }
      return i;
    }(xH), a8 = Xve, q2 = [0, 0], PI3 = [0, 0], o8 = new Bs(), s8 = new Bs(), Yve = function() {
      function o(i, t3) {
        this._corners = [], this._axes = [], this._origin = [0, 0];
        for (var c3 = 0; c3 < 4; c3++)
          this._corners[c3] = new Bs();
        for (var c3 = 0; c3 < 2; c3++)
          this._axes[c3] = new Bs();
        i && this.fromBoundingRect(i, t3);
      }
      return o.prototype.fromBoundingRect = function(i, t3) {
        var c3 = this._corners, p3 = this._axes, g3 = i.x, b3 = i.y, w3 = g3 + i.width, M = b3 + i.height;
        if (c3[0].set(g3, b3), c3[1].set(w3, b3), c3[2].set(w3, M), c3[3].set(g3, M), t3)
          for (var I = 0; I < 4; I++)
            c3[I].transform(t3);
        Bs.sub(p3[0], c3[1], c3[0]), Bs.sub(p3[1], c3[3], c3[0]), p3[0].normalize(), p3[1].normalize();
        for (var I = 0; I < 2; I++)
          this._origin[I] = p3[I].dot(c3[0]);
      }, o.prototype.intersect = function(i, t3) {
        var c3 = true, p3 = !t3;
        return o8.set(1 / 0, 1 / 0), s8.set(0, 0), !this._intersectCheckOneSide(this, i, o8, s8, p3, 1) && (c3 = false, p3) || !this._intersectCheckOneSide(i, this, o8, s8, p3, -1) && (c3 = false, p3) || p3 || Bs.copy(t3, c3 ? o8 : s8), c3;
      }, o.prototype._intersectCheckOneSide = function(i, t3, c3, p3, g3, b3) {
        for (var w3 = true, M = 0; M < 2; M++) {
          var I = this._axes[M];
          if (this._getProjMinMaxOnAxis(M, i._corners, q2), this._getProjMinMaxOnAxis(M, t3._corners, PI3), q2[1] < PI3[0] || q2[0] > PI3[1]) {
            if (w3 = false, g3)
              return w3;
            var k3 = Math.abs(PI3[0] - q2[1]), L = Math.abs(q2[0] - PI3[1]);
            Math.min(k3, L) > p3.len() && (k3 < L ? Bs.scale(p3, I, -k3 * b3) : Bs.scale(p3, I, L * b3));
          } else if (c3) {
            var k3 = Math.abs(PI3[0] - q2[1]), L = Math.abs(q2[0] - PI3[1]);
            Math.min(k3, L) < c3.len() && (k3 < L ? Bs.scale(c3, I, k3 * b3) : Bs.scale(c3, I, -L * b3));
          }
        }
        return w3;
      }, o.prototype._getProjMinMaxOnAxis = function(i, t3, c3) {
        for (var p3 = this._axes[i], g3 = this._origin, b3 = t3[0].dot(p3) + g3[i], w3 = b3, M = b3, I = 1; I < t3.length; I++) {
          var k3 = t3[I].dot(p3) + g3[i];
          w3 = Math.min(k3, w3), M = Math.max(k3, M);
        }
        c3[0] = w3, c3[1] = M;
      }, o;
    }(), l8 = Yve, Kve = [], Zve = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.notClear = true, t3.incremental = true, t3._displayables = [], t3._temporaryDisplayables = [], t3._cursor = 0, t3;
      }
      return i.prototype.traverse = function(t3, c3) {
        t3.call(c3, this);
      }, i.prototype.useStyle = function() {
        this.style = {};
      }, i.prototype.getCursor = function() {
        return this._cursor;
      }, i.prototype.innerAfterBrush = function() {
        this._cursor = this._displayables.length;
      }, i.prototype.clearDisplaybles = function() {
        this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
      }, i.prototype.clearTemporalDisplayables = function() {
        this._temporaryDisplayables = [];
      }, i.prototype.addDisplayable = function(t3, c3) {
        c3 ? this._temporaryDisplayables.push(t3) : this._displayables.push(t3), this.markRedraw();
      }, i.prototype.addDisplayables = function(t3, c3) {
        c3 = c3 || false;
        for (var p3 = 0; p3 < t3.length; p3++)
          this.addDisplayable(t3[p3], c3);
      }, i.prototype.getDisplayables = function() {
        return this._displayables;
      }, i.prototype.getTemporalDisplayables = function() {
        return this._temporaryDisplayables;
      }, i.prototype.eachPendingDisplayable = function(t3) {
        for (var c3 = this._cursor; c3 < this._displayables.length; c3++)
          t3 && t3(this._displayables[c3]);
        for (var c3 = 0; c3 < this._temporaryDisplayables.length; c3++)
          t3 && t3(this._temporaryDisplayables[c3]);
      }, i.prototype.update = function() {
        this.updateTransform();
        for (var t3 = this._cursor; t3 < this._displayables.length; t3++) {
          var c3 = this._displayables[t3];
          c3.parent = this, c3.update(), c3.parent = null;
        }
        for (var t3 = 0; t3 < this._temporaryDisplayables.length; t3++) {
          var c3 = this._temporaryDisplayables[t3];
          c3.parent = this, c3.update(), c3.parent = null;
        }
      }, i.prototype.getBoundingRect = function() {
        if (!this._rect) {
          for (var t3 = new Ys(1 / 0, 1 / 0, -1 / 0, -1 / 0), c3 = 0; c3 < this._displayables.length; c3++) {
            var p3 = this._displayables[c3], g3 = p3.getBoundingRect().clone();
            p3.needLocalTransform() && g3.applyTransform(p3.getLocalTransform(Kve)), t3.union(g3);
          }
          this._rect = t3;
        }
        return this._rect;
      }, i.prototype.contain = function(t3, c3) {
        var p3 = this.transformCoordToLocal(t3, c3), g3 = this.getBoundingRect();
        if (g3.contain(p3[0], p3[1]))
          for (var b3 = 0; b3 < this._displayables.length; b3++) {
            var w3 = this._displayables[b3];
            if (w3.contain(t3, c3))
              return true;
          }
        return false;
      }, i;
    }(Ab), Jve = Zve, tte = mu();
    function ek(o, i, t3, c3, p3) {
      var g3;
      if (i && i.ecModel) {
        var b3 = i.ecModel.getUpdatePayload();
        g3 = b3 && b3.animation;
      }
      var w3 = i && i.isAnimationEnabled(), M = o === "update";
      if (w3) {
        var I = void 0, k3 = void 0, L = void 0;
        c3 ? (I = Xs(c3.duration, 200), k3 = Xs(c3.easing, "cubicOut"), L = 0) : (I = i.getShallow(M ? "animationDurationUpdate" : "animationDuration"), k3 = i.getShallow(M ? "animationEasingUpdate" : "animationEasing"), L = i.getShallow(M ? "animationDelayUpdate" : "animationDelay")), g3 && (g3.duration != null && (I = g3.duration), g3.easing != null && (k3 = g3.easing), g3.delay != null && (L = g3.delay)), Vo(L) && (L = L(t3, p3)), Vo(I) && (I = I(t3));
        var F = { duration: I || 0, delay: L, easing: k3 };
        return F;
      } else
        return null;
    }
    function wH(o, i, t3, c3, p3, g3, b3) {
      var w3 = false, M;
      Vo(p3) ? (b3 = g3, g3 = p3, p3 = null) : Ua(p3) && (g3 = p3.cb, b3 = p3.during, w3 = p3.isFrom, M = p3.removeOpt, p3 = p3.dataIndex);
      var I = o === "leave";
      I || i.stopAnimation("leave");
      var k3 = ek(o, c3, p3, I ? M || {} : null, c3 && c3.getAnimationDelayParams ? c3.getAnimationDelayParams(i, p3) : null);
      if (k3 && k3.duration > 0) {
        var L = k3.duration, F = k3.delay, B = k3.easing, G = { duration: L, delay: F || 0, easing: B, done: g3, force: !!g3 || !!b3, setToFinal: !I, scope: o, during: b3 };
        w3 ? i.animateFrom(t3, G) : i.animateTo(t3, G);
      } else
        i.stopAnimation(), !w3 && i.attr(t3), b3 && b3(1), g3 && g3();
    }
    function Du(o, i, t3, c3, p3, g3) {
      wH("update", o, i, t3, c3, p3, g3);
    }
    function Uh(o, i, t3, c3, p3, g3) {
      wH("enter", o, i, t3, c3, p3, g3);
    }
    function tk(o) {
      if (!o.__zr)
        return true;
      for (var i = 0; i < o.animators.length; i++) {
        var t3 = o.animators[i];
        if (t3.scope === "leave")
          return true;
      }
      return false;
    }
    function XM(o, i, t3, c3, p3, g3) {
      tk(o) || wH("leave", o, i, t3, c3, p3, g3);
    }
    function nte(o, i, t3, c3) {
      o.removeTextContent(), o.removeTextGuideLine(), XM(o, { style: { opacity: 0 } }, i, t3, c3);
    }
    function QP(o, i, t3) {
      function c3() {
        o.parent && o.parent.remove(o);
      }
      o.isGroup ? o.traverse(function(p3) {
        p3.isGroup || nte(p3, i, t3, c3);
      }) : nte(o, i, t3, c3);
    }
    function P_(o) {
      tte(o).oldStyle = o.style;
    }
    function Qve(o) {
      return tte(o).oldStyle;
    }
    var u8 = Math.max, c8 = Math.min, $ = {};
    function ie(o) {
      return gl.extend(o);
    }
    var De = kve;
    function tt(o, i) {
      return De(o, i);
    }
    function Mt(o, i) {
      $[o] = i;
    }
    function nn(o) {
      if ($.hasOwnProperty(o))
        return $[o];
    }
    function jn(o, i, t3, c3) {
      var p3 = Wee(o, i);
      return t3 && (c3 === "center" && (t3 = Ir(t3, p3.getBoundingRect())), ca(p3, t3)), p3;
    }
    function Zn(o, i, t3) {
      var c3 = new Gv({ style: { image: o, x: i.x, y: i.y, width: i.width, height: i.height }, onload: function(p3) {
        if (t3 === "center") {
          var g3 = { width: p3.width, height: p3.height };
          c3.setStyle(Ir(i, g3));
        }
      } });
      return c3;
    }
    function Ir(o, i) {
      var t3 = i.width / i.height, c3 = o.height * t3, p3;
      c3 <= o.width ? p3 = o.height : (c3 = o.width, p3 = c3 / t3);
      var g3 = o.x + o.width / 2, b3 = o.y + o.height / 2;
      return { x: g3 - c3 / 2, y: b3 - p3 / 2, width: c3, height: p3 };
    }
    var ji = Ove;
    function ca(o, i) {
      if (o.applyTransform) {
        var t3 = o.getBoundingRect(), c3 = t3.calculateTransform(i);
        o.applyTransform(c3);
      }
    }
    function ka(o) {
      return vee(o.shape, o.shape, o.style), o;
    }
    function Io(o) {
      return gee(o.shape, o.shape, o.style), o;
    }
    var gs = CI;
    function Ls(o, i) {
      for (var t3 = LP([]); o && o !== i; )
        pw(t3, o.getLocalTransform(), t3), o = o.parent;
      return t3;
    }
    function ll(o, i, t3) {
      return i && !yg(i) && (i = k1.getLocalTransform(i)), t3 && (i = fI([], i)), Vv([], o, i);
    }
    function Hs(o, i, t3) {
      var c3 = i[4] === 0 || i[5] === 0 || i[0] === 0 ? 1 : Math.abs(2 * i[4] / i[0]), p3 = i[4] === 0 || i[5] === 0 || i[2] === 0 ? 1 : Math.abs(2 * i[4] / i[2]), g3 = [o === "left" ? -c3 : o === "right" ? c3 : 0, o === "top" ? -p3 : o === "bottom" ? p3 : 0];
      return g3 = ll(g3, i, t3), Math.abs(g3[0]) > Math.abs(g3[1]) ? g3[0] > 0 ? "right" : "left" : g3[1] > 0 ? "bottom" : "top";
    }
    function tc(o) {
      return !o.isGroup;
    }
    function zc(o) {
      return o.shape != null;
    }
    function Sg(o, i, t3) {
      if (!o || !i)
        return;
      function c3(b3) {
        var w3 = {};
        return b3.traverse(function(M) {
          tc(M) && M.anid && (w3[M.anid] = M);
        }), w3;
      }
      function p3(b3) {
        var w3 = { x: b3.x, y: b3.y, rotation: b3.rotation };
        return zc(b3) && (w3.shape = ti({}, b3.shape)), w3;
      }
      var g3 = c3(o);
      i.traverse(function(b3) {
        if (tc(b3) && b3.anid) {
          var w3 = g3[b3.anid];
          if (w3) {
            var M = p3(b3);
            b3.attr(p3(w3)), Du(b3, M, t3, La(b3).dataIndex);
          }
        }
      });
    }
    function v0(o, i) {
      return Fi(o, function(t3) {
        var c3 = t3[0];
        c3 = u8(c3, i.x), c3 = c8(c3, i.x + i.width);
        var p3 = t3[1];
        return p3 = u8(p3, i.y), p3 = c8(p3, i.y + i.height), [c3, p3];
      });
    }
    function N1(o, i) {
      var t3 = u8(o.x, i.x), c3 = c8(o.x + o.width, i.x + i.width), p3 = u8(o.y, i.y), g3 = c8(o.y + o.height, i.y + i.height);
      if (c3 >= t3 && g3 >= p3)
        return { x: t3, y: p3, width: c3 - t3, height: g3 - p3 };
    }
    function ip(o, i, t3) {
      var c3 = ti({ rectHover: true }, i), p3 = c3.style = { strokeNoScale: true };
      if (t3 = t3 || { x: -1, y: -1, width: 2, height: 2 }, o)
        return o.indexOf("image://") === 0 ? (p3.image = o.slice(8), Uo(p3, t3), new Gv(c3)) : jn(o.replace("path://", ""), c3, t3, "center");
    }
    function _y(o, i, t3, c3, p3) {
      for (var g3 = 0, b3 = p3[p3.length - 1]; g3 < p3.length; g3++) {
        var w3 = p3[g3];
        if (Aw(o, i, t3, c3, w3[0], w3[1], b3[0], b3[1]))
          return true;
        b3 = w3;
      }
    }
    function Aw(o, i, t3, c3, p3, g3, b3, w3) {
      var M = t3 - o, I = c3 - i, k3 = b3 - p3, L = w3 - g3, F = f8(k3, L, M, I);
      if (Tgt(F))
        return false;
      var B = o - p3, G = i - g3, J = f8(B, G, M, I) / F;
      if (J < 0 || J > 1)
        return false;
      var Q = f8(B, G, k3, L) / F;
      return !(Q < 0 || Q > 1);
    }
    function f8(o, i, t3, c3) {
      return o * c3 - t3 * i;
    }
    function Tgt(o) {
      return o <= 1e-6 && o >= -1e-6;
    }
    function h8(o) {
      var i = o.itemTooltipOption, t3 = o.componentModel, c3 = o.itemName, p3 = Ha(i) ? { formatter: i } : i, g3 = t3.mainType, b3 = t3.componentIndex, w3 = { componentType: g3, name: c3, $vars: ["name"] };
      w3[g3 + "Index"] = b3;
      var M = o.formatterParamsExtra;
      M && yt(Gl(M), function(k3) {
        so(w3, k3) || (w3[k3] = M[k3], w3.$vars.push(k3));
      });
      var I = La(o.el);
      I.componentMainType = g3, I.componentIndex = b3, I.tooltipConfig = { name: c3, option: Uo({ content: c3, formatterParams: w3 }, p3) };
    }
    function HPe(o, i) {
      var t3;
      o.isGroup && (t3 = i(o)), t3 || o.traverse(i);
    }
    function nk(o, i) {
      if (o)
        if (Ei(o))
          for (var t3 = 0; t3 < o.length; t3++)
            HPe(o[t3], i);
        else
          HPe(o, i);
    }
    Mt("circle", Mw), Mt("ellipse", vH), Mt("sector", bm), Mt("ring", n8), Mt("polygon", _m), Mt("polyline", xm), Mt("rect", bu), Mt("line", Ud), Mt("bezierCurve", Q5), Mt("arc", bH);
    var SH = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: Du, initProps: Uh, removeElement: XM, removeElementWithFadeOut: QP, isElementRemoved: tk, extendShape: ie, extendPath: tt, registerShape: Mt, getShapeClass: nn, makePath: jn, makeImage: Zn, mergePath: ji, resizePath: ca, subPixelOptimizeLine: ka, subPixelOptimizeRect: Io, subPixelOptimize: gs, getTransform: Ls, applyTransform: ll, transformDirection: Hs, groupTransition: Sg, clipPointsByRect: v0, clipRectByRect: N1, createIcon: ip, linePolygonIntersect: _y, lineLineIntersect: Aw, setTooltipConfig: h8, traverseElements: nk, Group: vs, Image: Gv, Text: Fl, Circle: Mw, Ellipse: vH, Sector: bm, Ring: n8, Polygon: _m, Polyline: xm, Rect: bu, Line: Ud, BezierCurve: Q5, Arc: bH, IncrementalDisplayable: Jve, CompoundPath: _H, LinearGradient: JP, RadialGradient: a8, BoundingRect: Ys, OrientedBoundingRect: l8, Point: Bs, Path: gl }, Symbol.toStringTag, { value: "Module" })), rte = {};
    function WPe(o, i) {
      for (var t3 = 0; t3 < yy.length; t3++) {
        var c3 = yy[t3], p3 = i[c3], g3 = o.ensureState(c3);
        g3.style = g3.style || {}, g3.style.text = p3;
      }
      var b3 = o.currentStates.slice();
      o.clearStates(true), o.setStyle({ text: i.normal }), o.useStates(b3, true);
    }
    function ege(o, i, t3) {
      var c3 = o.labelFetcher, p3 = o.labelDataIndex, g3 = o.labelDimIndex, b3 = i.normal, w3;
      c3 && (w3 = c3.getFormattedLabel(p3, "normal", null, g3, b3 && b3.get("formatter"), t3 != null ? { interpolatedValue: t3 } : null)), w3 == null && (w3 = Vo(o.defaultText) ? o.defaultText(p3, o, t3) : o.defaultText);
      for (var M = { normal: w3 }, I = 0; I < yy.length; I++) {
        var k3 = yy[I], L = i[k3];
        M[k3] = Xs(c3 ? c3.getFormattedLabel(p3, k3, null, g3, L && L.get("formatter")) : null, w3);
      }
      return M;
    }
    function Sm(o, i, t3, c3) {
      t3 = t3 || rte;
      for (var p3 = o instanceof Fl, g3 = false, b3 = 0; b3 < UP.length; b3++) {
        var w3 = i[UP[b3]];
        if (w3 && w3.getShallow("show")) {
          g3 = true;
          break;
        }
      }
      var M = p3 ? o : o.getTextContent();
      if (g3) {
        p3 || (M || (M = new Fl(), o.setTextContent(M)), o.stateProxy && (M.stateProxy = o.stateProxy));
        var I = ege(t3, i), k3 = i.normal, L = !!k3.getShallow("show"), F = qd(k3, c3 && c3.normal, t3, false, !p3);
        F.text = I.normal, p3 || o.setTextConfig(ite(k3, t3, false));
        for (var b3 = 0; b3 < yy.length; b3++) {
          var B = yy[b3], w3 = i[B];
          if (w3) {
            var G = M.ensureState(B), J = !!Xs(w3.getShallow("show"), L);
            if (J !== L && (G.ignore = !J), G.style = qd(w3, c3 && c3[B], t3, true, !p3), G.style.text = I[B], !p3) {
              var Q = o.ensureState(B);
              Q.textConfig = ite(w3, t3, true);
            }
          }
        }
        M.silent = !!k3.getShallow("silent"), M.style.x != null && (F.x = M.style.x), M.style.y != null && (F.y = M.style.y), M.ignore = !L, M.useStyle(F), M.dirty(), t3.enableTextSetter && (p8(M).setLabelText = function(se) {
          var he = ege(t3, i, se);
          WPe(M, he);
        });
      } else
        M && (M.ignore = true);
      o.dirty();
    }
    function g0(o, i) {
      i = i || "label";
      for (var t3 = { normal: o.getModel(i) }, c3 = 0; c3 < yy.length; c3++) {
        var p3 = yy[c3];
        t3[p3] = o.getModel([p3, i]);
      }
      return t3;
    }
    function qd(o, i, t3, c3, p3) {
      var g3 = {};
      return Agt(g3, o, t3, c3, p3), i && ti(g3, i), g3;
    }
    function ite(o, i, t3) {
      i = i || {};
      var c3 = {}, p3, g3 = o.getShallow("rotate"), b3 = Xs(o.getShallow("distance"), t3 ? null : 5), w3 = o.getShallow("offset");
      return p3 = o.getShallow("position") || (t3 ? null : "inside"), p3 === "outside" && (p3 = i.defaultOutsidePosition || "top"), p3 != null && (c3.position = p3), w3 != null && (c3.offset = w3), g3 != null && (g3 *= Math.PI / 180, c3.rotation = g3), b3 != null && (c3.distance = b3), c3.outsideFill = o.get("color") === "inherit" ? i.inheritColor || null : "auto", c3;
    }
    function Agt(o, i, t3, c3, p3) {
      t3 = t3 || rte;
      var g3 = i.ecModel, b3 = g3 && g3.option.textStyle, w3 = Igt(i), M;
      if (w3) {
        M = {};
        for (var I in w3)
          if (w3.hasOwnProperty(I)) {
            var k3 = i.getModel(["rich", I]);
            XPe(M[I] = {}, k3, b3, t3, c3, p3, false, true);
          }
      }
      M && (o.rich = M);
      var L = i.get("overflow");
      L && (o.overflow = L);
      var F = i.get("minMargin");
      F != null && (o.margin = F), XPe(o, i, b3, t3, c3, p3, true, false);
    }
    function Igt(o) {
      for (var i; o && o !== o.ecModel; ) {
        var t3 = (o.option || rte).rich;
        if (t3) {
          i = i || {};
          for (var c3 = Gl(t3), p3 = 0; p3 < c3.length; p3++) {
            var g3 = c3[p3];
            i[g3] = 1;
          }
        }
        o = o.parentModel;
      }
      return i;
    }
    var UPe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], qPe = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], $Pe = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
    function XPe(o, i, t3, c3, p3, g3, b3, w3) {
      t3 = !p3 && t3 || rte;
      var M = c3 && c3.inheritColor, I = i.getShallow("color"), k3 = i.getShallow("textBorderColor"), L = Xs(i.getShallow("opacity"), t3.opacity);
      (I === "inherit" || I === "auto") && (M ? I = M : I = null), (k3 === "inherit" || k3 === "auto") && (M ? k3 = M : k3 = null), g3 || (I = I || t3.color, k3 = k3 || t3.textBorderColor), I != null && (o.fill = I), k3 != null && (o.stroke = k3);
      var F = Xs(i.getShallow("textBorderWidth"), t3.textBorderWidth);
      F != null && (o.lineWidth = F);
      var B = Xs(i.getShallow("textBorderType"), t3.textBorderType);
      B != null && (o.lineDash = B);
      var G = Xs(i.getShallow("textBorderDashOffset"), t3.textBorderDashOffset);
      G != null && (o.lineDashOffset = G), !p3 && L == null && !w3 && (L = c3 && c3.defaultOpacity), L != null && (o.opacity = L), !p3 && !g3 && o.fill == null && c3.inheritColor && (o.fill = c3.inheritColor);
      for (var J = 0; J < UPe.length; J++) {
        var Q = UPe[J], se = Xs(i.getShallow(Q), t3[Q]);
        se != null && (o[Q] = se);
      }
      for (var J = 0; J < qPe.length; J++) {
        var Q = qPe[J], se = i.getShallow(Q);
        se != null && (o[Q] = se);
      }
      if (o.verticalAlign == null) {
        var he = i.getShallow("baseline");
        he != null && (o.verticalAlign = he);
      }
      if (!b3 || !c3.disableBox) {
        for (var J = 0; J < $Pe.length; J++) {
          var Q = $Pe[J], se = i.getShallow(Q);
          se != null && (o[Q] = se);
        }
        var be = i.getShallow("borderType");
        be != null && (o.borderDash = be), (o.backgroundColor === "auto" || o.backgroundColor === "inherit") && M && (o.backgroundColor = M), (o.borderColor === "auto" || o.borderColor === "inherit") && M && (o.borderColor = M);
      }
    }
    function YPe(o, i) {
      var t3 = i && i.getModel("textStyle");
      return S1([o.fontStyle || t3 && t3.getShallow("fontStyle") || "", o.fontWeight || t3 && t3.getShallow("fontWeight") || "", (o.fontSize || t3 && t3.getShallow("fontSize") || 12) + "px", o.fontFamily || t3 && t3.getShallow("fontFamily") || "sans-serif"].join(" "));
    }
    var p8 = mu();
    function KPe(o, i, t3, c3) {
      if (o) {
        var p3 = p8(o);
        p3.prevValue = p3.value, p3.value = t3;
        var g3 = i.normal;
        p3.valueAnimation = g3.get("valueAnimation"), p3.valueAnimation && (p3.precision = g3.get("precision"), p3.defaultInterpolatedText = c3, p3.statesModels = i);
      }
    }
    function ZPe(o, i, t3, c3, p3) {
      var g3 = p8(o);
      if (!g3.valueAnimation || g3.prevValue === g3.value)
        return;
      var b3 = g3.defaultInterpolatedText, w3 = Xs(g3.interpolatedValue, g3.prevValue), M = g3.value;
      function I(k3) {
        var L = $5(t3, g3.precision, w3, M, k3);
        g3.interpolatedValue = k3 === 1 ? null : L;
        var F = ege({ labelDataIndex: i, labelFetcher: p3, defaultText: b3 ? b3(L) : L + "" }, g3.statesModels, L);
        WPe(o, F);
      }
      o.percent = 0, (g3.prevValue == null ? Uh : Du)(o, { percent: 1 }, c3, i, null, I);
    }
    var Egt = ["textStyle", "color"], tge = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], nge = new Fl(), Dgt = function() {
      function o() {
      }
      return o.prototype.getTextColor = function(i) {
        var t3 = this.ecModel;
        return this.getShallow("color") || (!i && t3 ? t3.get(Egt) : null);
      }, o.prototype.getFont = function() {
        return YPe({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
      }, o.prototype.getTextRect = function(i) {
        for (var t3 = { text: i, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, c3 = 0; c3 < tge.length; c3++)
          t3[tge[c3]] = this.getShallow(tge[c3]);
        return nge.useStyle(t3), nge.update(), nge.getBoundingRect();
      }, o;
    }(), kgt = Dgt, JPe = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], Ogt = mI(JPe), Pgt = function() {
      function o() {
      }
      return o.prototype.getLineStyle = function(i) {
        return Ogt(this, i);
      }, o;
    }(), QPe = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], Lgt = mI(QPe), Rgt = function() {
      function o() {
      }
      return o.prototype.getItemStyle = function(i, t3) {
        return Lgt(this, i, t3);
      }, o;
    }(), eL = function() {
      function o(i, t3, c3) {
        this.parentModel = t3, this.ecModel = c3, this.option = i;
      }
      return o.prototype.init = function(i, t3, c3) {
        for (var p3 = [], g3 = 3; g3 < arguments.length; g3++)
          p3[g3 - 3] = arguments[g3];
      }, o.prototype.mergeOption = function(i, t3) {
        Es(this.option, i, true);
      }, o.prototype.get = function(i, t3) {
        return i == null ? this.option : this._doGet(this.parsePath(i), !t3 && this.parentModel);
      }, o.prototype.getShallow = function(i, t3) {
        var c3 = this.option, p3 = c3 == null ? c3 : c3[i];
        if (p3 == null && !t3) {
          var g3 = this.parentModel;
          g3 && (p3 = g3.getShallow(i));
        }
        return p3;
      }, o.prototype.getModel = function(i, t3) {
        var c3 = i != null, p3 = c3 ? this.parsePath(i) : null, g3 = c3 ? this._doGet(p3) : this.option;
        return t3 = t3 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(p3)), new o(g3, t3, this.ecModel);
      }, o.prototype.isEmpty = function() {
        return this.option == null;
      }, o.prototype.restoreData = function() {
      }, o.prototype.clone = function() {
        var i = this.constructor;
        return new i(Jo(this.option));
      }, o.prototype.parsePath = function(i) {
        return typeof i == "string" ? i.split(".") : i;
      }, o.prototype.resolveParentPath = function(i) {
        return i;
      }, o.prototype.isAnimationEnabled = function() {
        if (!yo.node && this.option) {
          if (this.option.animation != null)
            return !!this.option.animation;
          if (this.parentModel)
            return this.parentModel.isAnimationEnabled();
        }
      }, o.prototype._doGet = function(i, t3) {
        var c3 = this.option;
        if (!i)
          return c3;
        for (var p3 = 0; p3 < i.length && !(!!i[p3] && (c3 = c3 && typeof c3 == "object" ? c3[i[p3]] : null, c3 == null)); p3++)
          ;
        return c3 == null && t3 && (c3 = t3._doGet(this.resolveParentPath(i), t3.parentModel)), c3;
      }, o;
    }();
    H2(eL), kde(eL), Kp(eL, Pgt), Kp(eL, Rgt), Kp(eL, Nde), Kp(eL, kgt);
    var gh = eL, Ngt = Math.round(Math.random() * 10);
    function d8(o) {
      return [o || "", Ngt++].join("_");
    }
    function Fgt(o) {
      var i = {};
      o.registerSubTypeDefaulter = function(t3, c3) {
        var p3 = P1(t3);
        i[p3.main] = c3;
      }, o.determineSubType = function(t3, c3) {
        var p3 = c3.type;
        if (!p3) {
          var g3 = P1(t3).main;
          o.hasSubTypes(t3) && i[g3] && (p3 = i[g3](c3));
        }
        return p3;
      };
    }
    function Vgt(o, i) {
      o.topologicalTravel = function(g3, b3, w3, M) {
        if (!g3.length)
          return;
        var I = t3(b3), k3 = I.graph, L = I.noEntryList, F = {};
        for (yt(g3, function(he) {
          F[he] = true;
        }); L.length; ) {
          var B = L.pop(), G = k3[B], J = !!F[B];
          J && (w3.call(M, B, G.originalDeps.slice()), delete F[B]), yt(G.successor, J ? se : Q);
        }
        yt(F, function() {
          var he = "";
          throw new Error(he);
        });
        function Q(he) {
          k3[he].entryCount--, k3[he].entryCount === 0 && L.push(he);
        }
        function se(he) {
          F[he] = true, Q(he);
        }
      };
      function t3(g3) {
        var b3 = {}, w3 = [];
        return yt(g3, function(M) {
          var I = c3(b3, M), k3 = I.originalDeps = i(M), L = p3(k3, g3);
          I.entryCount = L.length, I.entryCount === 0 && w3.push(M), yt(L, function(F) {
            rl(I.predecessor, F) < 0 && I.predecessor.push(F);
            var B = c3(b3, F);
            rl(B.successor, F) < 0 && B.successor.push(M);
          });
        }), { graph: b3, noEntryList: w3 };
      }
      function c3(g3, b3) {
        return g3[b3] || (g3[b3] = { predecessor: [], successor: [] }), g3[b3];
      }
      function p3(g3, b3) {
        var w3 = [];
        return yt(g3, function(M) {
          rl(b3, M) >= 0 && w3.push(M);
        }), w3;
      }
    }
    function rk(o, i) {
      return Es(Es({}, o, true), i, true);
    }
    var Bgt = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, zgt = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, ate = "ZH", rge = "EN", CH = rge, ote = {}, ige = {}, eLe = yo.domSupported ? function() {
      var o = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
      return o.indexOf(ate) > -1 ? ate : CH;
    }() : CH;
    function tLe(o, i) {
      o = o.toUpperCase(), ige[o] = new gh(i), ote[o] = i;
    }
    function jgt(o) {
      if (Ha(o)) {
        var i = ote[o.toUpperCase()] || {};
        return o === ate || o === rge ? Jo(i) : Es(Jo(i), Jo(ote[CH]), false);
      } else
        return Es(Jo(o), Jo(ote[CH]), false);
    }
    function age(o) {
      return ige[o];
    }
    function Ggt() {
      return ige[CH];
    }
    tLe(rge, Bgt), tLe(ate, zgt);
    var oge = 1e3, sge = oge * 60, MH = sge * 60, Iw = MH * 24, nLe = Iw * 365, TH = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, ste = "{yyyy}-{MM}-{dd}", rLe = { year: "{yyyy}", month: "{yyyy}-{MM}", day: ste, hour: ste + " " + TH.hour, minute: ste + " " + TH.minute, second: ste + " " + TH.second, millisecond: TH.none }, lge = ["year", "month", "day", "hour", "minute", "second", "millisecond"], iLe = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
    function tL(o, i) {
      return o += "", "0000".substr(0, i - o.length) + o;
    }
    function v8(o) {
      switch (o) {
        case "half-year":
        case "quarter":
          return "month";
        case "week":
        case "half-week":
          return "day";
        case "half-day":
        case "quarter-day":
          return "hour";
        default:
          return o;
      }
    }
    function Hgt(o) {
      return o === v8(o);
    }
    function Wgt(o) {
      switch (o) {
        case "year":
        case "month":
          return "day";
        case "millisecond":
          return "millisecond";
        default:
          return "second";
      }
    }
    function lte(o, i, t3, c3) {
      var p3 = jv(o), g3 = p3[uge(t3)](), b3 = p3[g8(t3)]() + 1, w3 = Math.floor((b3 - 1) / 4) + 1, M = p3[ute(t3)](), I = p3["get" + (t3 ? "UTC" : "") + "Day"](), k3 = p3[AH(t3)](), L = (k3 - 1) % 12 + 1, F = p3[cte(t3)](), B = p3[fte(t3)](), G = p3[hte(t3)](), J = c3 instanceof gh ? c3 : age(c3 || eLe) || Ggt(), Q = J.getModel("time"), se = Q.get("month"), he = Q.get("monthAbbr"), be = Q.get("dayOfWeek"), de = Q.get("dayOfWeekAbbr");
      return (i || "").replace(/{yyyy}/g, g3 + "").replace(/{yy}/g, g3 % 100 + "").replace(/{Q}/g, w3 + "").replace(/{MMMM}/g, se[b3 - 1]).replace(/{MMM}/g, he[b3 - 1]).replace(/{MM}/g, tL(b3, 2)).replace(/{M}/g, b3 + "").replace(/{dd}/g, tL(M, 2)).replace(/{d}/g, M + "").replace(/{eeee}/g, be[I]).replace(/{ee}/g, de[I]).replace(/{e}/g, I + "").replace(/{HH}/g, tL(k3, 2)).replace(/{H}/g, k3 + "").replace(/{hh}/g, tL(L + "", 2)).replace(/{h}/g, L + "").replace(/{mm}/g, tL(F, 2)).replace(/{m}/g, F + "").replace(/{ss}/g, tL(B, 2)).replace(/{s}/g, B + "").replace(/{SSS}/g, tL(G, 3)).replace(/{S}/g, G + "");
    }
    function Ugt(o, i, t3, c3, p3) {
      var g3 = null;
      if (Ha(t3))
        g3 = t3;
      else if (Vo(t3))
        g3 = t3(o.value, i, { level: o.level });
      else {
        var b3 = ti({}, TH);
        if (o.level > 0)
          for (var w3 = 0; w3 < lge.length; ++w3)
            b3[lge[w3]] = "{primary|" + b3[lge[w3]] + "}";
        var M = t3 ? t3.inherit === false ? t3 : Uo(t3, b3) : b3, I = aLe(o.value, p3);
        if (M[I])
          g3 = M[I];
        else if (M.inherit) {
          for (var k3 = iLe.indexOf(I), w3 = k3 - 1; w3 >= 0; --w3)
            if (M[I]) {
              g3 = M[I];
              break;
            }
          g3 = g3 || b3.none;
        }
        if (Ei(g3)) {
          var L = o.level == null ? 0 : o.level >= 0 ? o.level : g3.length + o.level;
          L = Math.min(L, g3.length - 1), g3 = g3[L];
        }
      }
      return lte(new Date(o.value), g3, p3, c3);
    }
    function aLe(o, i) {
      var t3 = jv(o), c3 = t3[g8(i)]() + 1, p3 = t3[ute(i)](), g3 = t3[AH(i)](), b3 = t3[cte(i)](), w3 = t3[fte(i)](), M = t3[hte(i)](), I = M === 0, k3 = I && w3 === 0, L = k3 && b3 === 0, F = L && g3 === 0, B = F && p3 === 1, G = B && c3 === 1;
      return G ? "year" : B ? "month" : F ? "day" : L ? "hour" : k3 ? "minute" : I ? "second" : "millisecond";
    }
    function oLe(o, i, t3) {
      var c3 = ec(o) ? jv(o) : o;
      switch (i = i || aLe(o, t3), i) {
        case "year":
          return c3[uge(t3)]();
        case "half-year":
          return c3[g8(t3)]() >= 6 ? 1 : 0;
        case "quarter":
          return Math.floor((c3[g8(t3)]() + 1) / 4);
        case "month":
          return c3[g8(t3)]();
        case "day":
          return c3[ute(t3)]();
        case "half-day":
          return c3[AH(t3)]() / 24;
        case "hour":
          return c3[AH(t3)]();
        case "minute":
          return c3[cte(t3)]();
        case "second":
          return c3[fte(t3)]();
        case "millisecond":
          return c3[hte(t3)]();
      }
    }
    function uge(o) {
      return o ? "getUTCFullYear" : "getFullYear";
    }
    function g8(o) {
      return o ? "getUTCMonth" : "getMonth";
    }
    function ute(o) {
      return o ? "getUTCDate" : "getDate";
    }
    function AH(o) {
      return o ? "getUTCHours" : "getHours";
    }
    function cte(o) {
      return o ? "getUTCMinutes" : "getMinutes";
    }
    function fte(o) {
      return o ? "getUTCSeconds" : "getSeconds";
    }
    function hte(o) {
      return o ? "getUTCMilliseconds" : "getMilliseconds";
    }
    function qgt(o) {
      return o ? "setUTCFullYear" : "setFullYear";
    }
    function sLe(o) {
      return o ? "setUTCMonth" : "setMonth";
    }
    function lLe(o) {
      return o ? "setUTCDate" : "setDate";
    }
    function uLe(o) {
      return o ? "setUTCHours" : "setHours";
    }
    function cLe(o) {
      return o ? "setUTCMinutes" : "setMinutes";
    }
    function fLe(o) {
      return o ? "setUTCSeconds" : "setSeconds";
    }
    function hLe(o) {
      return o ? "setUTCMilliseconds" : "setMilliseconds";
    }
    function pLe(o) {
      if (!yw(o))
        return Ha(o) ? o : "-";
      var i = (o + "").split(".");
      return i[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (i.length > 1 ? "." + i[1] : "");
    }
    function dLe(o, i) {
      return o = (o || "").toLowerCase().replace(/-(.)/g, function(t3, c3) {
        return c3.toUpperCase();
      }), i && o && (o = o.charAt(0).toUpperCase() + o.slice(1)), o;
    }
    var y8 = k2, $gt = /([&<>"'])/g, Xgt = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
    function L_(o) {
      return o == null ? "" : (o + "").replace($gt, function(i, t3) {
        return Xgt[t3];
      });
    }
    function cge(o, i, t3) {
      var c3 = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
      function p3(k3) {
        return k3 && S1(k3) ? k3 : "-";
      }
      function g3(k3) {
        return !!(k3 != null && !isNaN(k3) && isFinite(k3));
      }
      var b3 = i === "time", w3 = o instanceof Date;
      if (b3 || w3) {
        var M = b3 ? jv(o) : o;
        if (isNaN(+M)) {
          if (w3)
            return "-";
        } else
          return lte(M, c3, t3);
      }
      if (i === "ordinal")
        return jj(o) ? p3(o) : ec(o) && g3(o) ? o + "" : "-";
      var I = G2(o);
      return g3(I) ? pLe(I) : jj(o) ? p3(o) : typeof o == "boolean" ? o + "" : "-";
    }
    var vLe = ["a", "b", "c", "d", "e", "f", "g"], fge = function(o, i) {
      return "{" + o + (i == null ? "" : i) + "}";
    };
    function gLe(o, i, t3) {
      Ei(i) || (i = [i]);
      var c3 = i.length;
      if (!c3)
        return "";
      for (var p3 = i[0].$vars || [], g3 = 0; g3 < p3.length; g3++) {
        var b3 = vLe[g3];
        o = o.replace(fge(b3), fge(b3, 0));
      }
      for (var w3 = 0; w3 < c3; w3++)
        for (var M = 0; M < p3.length; M++) {
          var I = i[w3][p3[M]];
          o = o.replace(fge(vLe[M], w3), t3 ? L_(I) : I);
        }
      return o;
    }
    function Ygt(o, i, t3) {
      return yt(i, function(c3, p3) {
        o = o.replace("{" + p3 + "}", t3 ? L_(c3) : c3);
      }), o;
    }
    function Kgt(o, i) {
      var t3 = Ha(o) ? { color: o, extraCssText: i } : o || {}, c3 = t3.color, p3 = t3.type;
      i = t3.extraCssText;
      var g3 = t3.renderMode || "html";
      if (!c3)
        return "";
      if (g3 === "html")
        return p3 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + L_(c3) + ";" + (i || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + L_(c3) + ";" + (i || "") + '"></span>';
      var b3 = t3.markerId || "markerX";
      return { renderMode: g3, content: "{" + b3 + "|}  ", style: p3 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: c3 } : { width: 10, height: 10, borderRadius: 5, backgroundColor: c3 } };
    }
    function nL(o, i) {
      return i = i || "transparent", Ha(o) ? o : Ua(o) && o.colorStops && (o.colorStops[0] || {}).color || i;
    }
    function pte(o, i) {
      if (i === "_blank" || i === "blank") {
        var t3 = window.open();
        t3.opener = null, t3.location.href = o;
      } else
        window.open(o, i);
    }
    var dte = yt, yLe = ["left", "right", "top", "bottom", "width", "height"], rL = [["width", "left", "right"], ["height", "top", "bottom"]];
    function hge(o, i, t3, c3, p3) {
      var g3 = 0, b3 = 0;
      c3 == null && (c3 = 1 / 0), p3 == null && (p3 = 1 / 0);
      var w3 = 0;
      i.eachChild(function(M, I) {
        var k3 = M.getBoundingRect(), L = i.childAt(I + 1), F = L && L.getBoundingRect(), B, G;
        if (o === "horizontal") {
          var J = k3.width + (F ? -F.x + k3.x : 0);
          B = g3 + J, B > c3 || M.newline ? (g3 = 0, B = J, b3 += w3 + t3, w3 = k3.height) : w3 = Math.max(w3, k3.height);
        } else {
          var Q = k3.height + (F ? -F.y + k3.y : 0);
          G = b3 + Q, G > p3 || M.newline ? (g3 += w3 + t3, b3 = 0, G = Q, w3 = k3.width) : w3 = Math.max(w3, k3.width);
        }
        M.newline || (M.x = g3, M.y = b3, M.markRedraw(), o === "horizontal" ? g3 = B + t3 : b3 = G + t3);
      });
    }
    var iL = hge;
    As(hge, "vertical"), As(hge, "horizontal");
    function Zgt(o, i, t3) {
      var c3 = i.width, p3 = i.height, g3 = Da(o.left, c3), b3 = Da(o.top, p3), w3 = Da(o.right, c3), M = Da(o.bottom, p3);
      return (isNaN(g3) || isNaN(parseFloat(o.left))) && (g3 = 0), (isNaN(w3) || isNaN(parseFloat(o.right))) && (w3 = c3), (isNaN(b3) || isNaN(parseFloat(o.top))) && (b3 = 0), (isNaN(M) || isNaN(parseFloat(o.bottom))) && (M = p3), t3 = y8(t3 || 0), { width: Math.max(w3 - g3 - t3[1] - t3[3], 0), height: Math.max(M - b3 - t3[0] - t3[2], 0) };
    }
    function Wv(o, i, t3) {
      t3 = y8(t3 || 0);
      var c3 = i.width, p3 = i.height, g3 = Da(o.left, c3), b3 = Da(o.top, p3), w3 = Da(o.right, c3), M = Da(o.bottom, p3), I = Da(o.width, c3), k3 = Da(o.height, p3), L = t3[2] + t3[0], F = t3[1] + t3[3], B = o.aspect;
      switch (isNaN(I) && (I = c3 - w3 - F - g3), isNaN(k3) && (k3 = p3 - M - L - b3), B != null && (isNaN(I) && isNaN(k3) && (B > c3 / p3 ? I = c3 * 0.8 : k3 = p3 * 0.8), isNaN(I) && (I = B * k3), isNaN(k3) && (k3 = I / B)), isNaN(g3) && (g3 = c3 - w3 - I - F), isNaN(b3) && (b3 = p3 - M - k3 - L), o.left || o.right) {
        case "center":
          g3 = c3 / 2 - I / 2 - t3[3];
          break;
        case "right":
          g3 = c3 - I - F;
          break;
      }
      switch (o.top || o.bottom) {
        case "middle":
        case "center":
          b3 = p3 / 2 - k3 / 2 - t3[0];
          break;
        case "bottom":
          b3 = p3 - k3 - L;
          break;
      }
      g3 = g3 || 0, b3 = b3 || 0, isNaN(I) && (I = c3 - F - g3 - (w3 || 0)), isNaN(k3) && (k3 = p3 - L - b3 - (M || 0));
      var G = new Ys(g3 + t3[3], b3 + t3[0], I, k3);
      return G.margin = t3, G;
    }
    function vte(o, i, t3, c3, p3, g3) {
      var b3 = !p3 || !p3.hv || p3.hv[0], w3 = !p3 || !p3.hv || p3.hv[1], M = p3 && p3.boundingMode || "all";
      if (g3 = g3 || o, g3.x = o.x, g3.y = o.y, !b3 && !w3)
        return false;
      var I;
      if (M === "raw")
        I = o.type === "group" ? new Ys(0, 0, +i.width || 0, +i.height || 0) : o.getBoundingRect();
      else if (I = o.getBoundingRect(), o.needLocalTransform()) {
        var k3 = o.getLocalTransform();
        I = I.clone(), I.applyTransform(k3);
      }
      var L = Wv(Uo({ width: I.width, height: I.height }, i), t3, c3), F = b3 ? L.x - I.x : 0, B = w3 ? L.y - I.y : 0;
      return M === "raw" ? (g3.x = F, g3.y = B) : (g3.x += F, g3.y += B), g3 === o && o.markRedraw(), true;
    }
    function Jgt(o, i) {
      return o[rL[i][0]] != null || o[rL[i][1]] != null && o[rL[i][2]] != null;
    }
    function IH(o) {
      var i = o.layoutMode || o.constructor.layoutMode;
      return Ua(i) ? i : i ? { type: i } : null;
    }
    function ik(o, i, t3) {
      var c3 = t3 && t3.ignoreSize;
      !Ei(c3) && (c3 = [c3, c3]);
      var p3 = b3(rL[0], 0), g3 = b3(rL[1], 1);
      I(rL[0], o, p3), I(rL[1], o, g3);
      function b3(k3, L) {
        var F = {}, B = 0, G = {}, J = 0, Q = 2;
        if (dte(k3, function(be) {
          G[be] = o[be];
        }), dte(k3, function(be) {
          w3(i, be) && (F[be] = G[be] = i[be]), M(F, be) && B++, M(G, be) && J++;
        }), c3[L])
          return M(i, k3[1]) ? G[k3[2]] = null : M(i, k3[2]) && (G[k3[1]] = null), G;
        if (J === Q || !B)
          return G;
        if (B >= Q)
          return F;
        for (var se = 0; se < k3.length; se++) {
          var he = k3[se];
          if (!w3(F, he) && w3(o, he)) {
            F[he] = o[he];
            break;
          }
        }
        return F;
      }
      function w3(k3, L) {
        return k3.hasOwnProperty(L);
      }
      function M(k3, L) {
        return k3[L] != null && k3[L] !== "auto";
      }
      function I(k3, L, F) {
        dte(k3, function(B) {
          L[B] = F[B];
        });
      }
    }
    function m8(o) {
      return mLe({}, o);
    }
    function mLe(o, i) {
      return i && o && dte(yLe, function(t3) {
        i.hasOwnProperty(t3) && (o[t3] = i[t3]);
      }), o;
    }
    var Qgt = mu(), b8 = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this, t3, c3, p3) || this;
        return g3.uid = d8("ec_cpt_model"), g3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        this.mergeDefaultAndTheme(t3, p3);
      }, i.prototype.mergeDefaultAndTheme = function(t3, c3) {
        var p3 = IH(this), g3 = p3 ? m8(t3) : {}, b3 = c3.getTheme();
        Es(t3, b3.get(this.mainType)), Es(t3, this.getDefaultOption()), p3 && ik(t3, g3, p3);
      }, i.prototype.mergeOption = function(t3, c3) {
        Es(this.option, t3, true);
        var p3 = IH(this);
        p3 && ik(this.option, t3, p3);
      }, i.prototype.optionUpdated = function(t3, c3) {
      }, i.prototype.getDefaultOption = function() {
        var t3 = this.constructor;
        if (!mw(t3))
          return t3.defaultOption;
        var c3 = Qgt(this);
        if (!c3.defaultOption) {
          for (var p3 = [], g3 = t3; g3; ) {
            var b3 = g3.prototype.defaultOption;
            b3 && p3.push(b3), g3 = g3.superClass;
          }
          for (var w3 = {}, M = p3.length - 1; M >= 0; M--)
            w3 = Es(w3, p3[M], true);
          c3.defaultOption = w3;
        }
        return c3.defaultOption;
      }, i.prototype.getReferringComponents = function(t3, c3) {
        var p3 = t3 + "Index", g3 = t3 + "Id";
        return q5(this.ecModel, t3, { index: this.get(p3, true), id: this.get(g3, true) }, c3);
      }, i.prototype.getBoxLayoutParams = function() {
        var t3 = this;
        return { left: t3.get("left"), top: t3.get("top"), right: t3.get("right"), bottom: t3.get("bottom"), width: t3.get("width"), height: t3.get("height") };
      }, i.prototype.getZLevelKey = function() {
        return "";
      }, i.prototype.setZLevel = function(t3) {
        this.option.zlevel = t3;
      }, i.protoInitialize = function() {
        var t3 = i.prototype;
        t3.type = "component", t3.id = "", t3.name = "", t3.mainType = "", t3.subType = "", t3.componentIndex = 0;
      }(), i;
    }(gh);
    DG(b8, gh), BF(b8), Fgt(b8), Vgt(b8, e0t);
    function e0t(o) {
      var i = [];
      return yt(b8.getClassesByMainType(o), function(t3) {
        i = i.concat(t3.dependencies || t3.prototype.dependencies || []);
      }), i = Fi(i, function(t3) {
        return P1(t3).main;
      }), o !== "dataset" && rl(i, "dataset") <= 0 && i.unshift("dataset"), i;
    }
    var nc = b8, bLe = "";
    typeof navigator != "undefined" && (bLe = navigator.platform || "");
    var _8 = "rgba(0, 0, 0, 0.2)", t0t = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: _8, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: _8, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: _8, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: _8, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: _8, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: _8, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: bLe.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, _Le = Eo(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), Ew = "original", Cm = "arrayRows", Dw = "objectRows", YM = "keyedColumns", ak = "typedArray", xLe = "unknown", KM = "column", x8 = "row", xy = { Must: 1, Might: 2, Not: 3 }, wLe = mu();
    function n0t(o) {
      wLe(o).datasetMap = Eo();
    }
    function SLe(o, i, t3) {
      var c3 = {}, p3 = dge(i);
      if (!p3 || !o)
        return c3;
      var g3 = [], b3 = [], w3 = i.ecModel, M = wLe(w3).datasetMap, I = p3.uid + "_" + t3.seriesLayoutBy, k3, L;
      o = o.slice(), yt(o, function(J, Q) {
        var se = Ua(J) ? J : o[Q] = { name: J };
        se.type === "ordinal" && k3 == null && (k3 = Q, L = G(se)), c3[se.name] = [];
      });
      var F = M.get(I) || M.set(I, { categoryWayDim: L, valueWayDim: 0 });
      yt(o, function(J, Q) {
        var se = J.name, he = G(J);
        if (k3 == null) {
          var be = F.valueWayDim;
          B(c3[se], be, he), B(b3, be, he), F.valueWayDim += he;
        } else if (k3 === Q)
          B(c3[se], 0, he), B(g3, 0, he);
        else {
          var be = F.categoryWayDim;
          B(c3[se], be, he), B(b3, be, he), F.categoryWayDim += he;
        }
      });
      function B(J, Q, se) {
        for (var he = 0; he < se; he++)
          J.push(Q + he);
      }
      function G(J) {
        var Q = J.dimsDef;
        return Q ? Q.length : 1;
      }
      return g3.length && (c3.itemName = g3), b3.length && (c3.seriesName = b3), c3;
    }
    function pge(o, i, t3) {
      var c3 = {}, p3 = dge(o);
      if (!p3)
        return c3;
      var g3 = i.sourceFormat, b3 = i.dimensionsDefine, w3;
      (g3 === Dw || g3 === YM) && yt(b3, function(k3, L) {
        (Ua(k3) ? k3.name : k3) === "name" && (w3 = L);
      });
      var M = function() {
        for (var k3 = {}, L = {}, F = [], B = 0, G = Math.min(5, t3); B < G; B++) {
          var J = MLe(i.data, g3, i.seriesLayoutBy, b3, i.startIndex, B);
          F.push(J);
          var Q = J === xy.Not;
          if (Q && k3.v == null && B !== w3 && (k3.v = B), (k3.n == null || k3.n === k3.v || !Q && F[k3.n] === xy.Not) && (k3.n = B), se(k3) && F[k3.n] !== xy.Not)
            return k3;
          Q || (J === xy.Might && L.v == null && B !== w3 && (L.v = B), (L.n == null || L.n === L.v) && (L.n = B));
        }
        function se(he) {
          return he.v != null && he.n != null;
        }
        return se(k3) ? k3 : se(L) ? L : null;
      }();
      if (M) {
        c3.value = [M.v];
        var I = w3 != null ? w3 : M.n;
        c3.itemName = [I], c3.seriesName = [I];
      }
      return c3;
    }
    function dge(o) {
      var i = o.get("data", true);
      if (!i)
        return q5(o.ecModel, "dataset", { index: o.get("datasetIndex", true), id: o.get("datasetId", true) }, xd).models[0];
    }
    function r0t(o) {
      return !o.get("transform", true) && !o.get("fromTransformResult", true) ? [] : q5(o.ecModel, "dataset", { index: o.get("fromDatasetIndex", true), id: o.get("fromDatasetId", true) }, xd).models;
    }
    function CLe(o, i) {
      return MLe(o.data, o.sourceFormat, o.seriesLayoutBy, o.dimensionsDefine, o.startIndex, i);
    }
    function MLe(o, i, t3, c3, p3, g3) {
      var b3, w3 = 5;
      if (w1(o))
        return xy.Not;
      var M, I;
      if (c3) {
        var k3 = c3[g3];
        Ua(k3) ? (M = k3.name, I = k3.type) : Ha(k3) && (M = k3);
      }
      if (I != null)
        return I === "ordinal" ? xy.Must : xy.Not;
      if (i === Cm) {
        var L = o;
        if (t3 === x8) {
          for (var F = L[g3], B = 0; B < (F || []).length && B < w3; B++)
            if ((b3 = de(F[p3 + B])) != null)
              return b3;
        } else
          for (var B = 0; B < L.length && B < w3; B++) {
            var G = L[p3 + B];
            if (G && (b3 = de(G[g3])) != null)
              return b3;
          }
      } else if (i === Dw) {
        var J = o;
        if (!M)
          return xy.Not;
        for (var B = 0; B < J.length && B < w3; B++) {
          var Q = J[B];
          if (Q && (b3 = de(Q[M])) != null)
            return b3;
        }
      } else if (i === YM) {
        var se = o;
        if (!M)
          return xy.Not;
        var F = se[M];
        if (!F || w1(F))
          return xy.Not;
        for (var B = 0; B < F.length && B < w3; B++)
          if ((b3 = de(F[B])) != null)
            return b3;
      } else if (i === Ew)
        for (var he = o, B = 0; B < he.length && B < w3; B++) {
          var Q = he[B], be = NM(Q);
          if (!Ei(be))
            return xy.Not;
          if ((b3 = de(be[g3])) != null)
            return b3;
        }
      function de(Fe) {
        var Pe = Ha(Fe);
        if (Fe != null && isFinite(Fe) && Fe !== "")
          return Pe ? xy.Might : xy.Not;
        if (Pe && Fe !== "-")
          return xy.Must;
      }
      return xy.Not;
    }
    var vge = Eo();
    function i0t(o, i) {
      u0(vge.get(o) == null && i), vge.set(o, i);
    }
    function a0t(o, i, t3) {
      var c3 = vge.get(i);
      if (!c3)
        return t3;
      var p3 = c3(o);
      return p3 ? t3.concat(p3) : t3;
    }
    var TLe = mu(), o0t = mu(), gge = function() {
      function o() {
      }
      return o.prototype.getColorFromPalette = function(i, t3, c3) {
        var p3 = Wc(this.get("color", true)), g3 = this.get("colorLayer", true);
        return ALe(this, TLe, p3, g3, i, t3, c3);
      }, o.prototype.clearColorPalette = function() {
        l0t(this, TLe);
      }, o;
    }();
    function yge(o, i, t3, c3) {
      var p3 = Wc(o.get(["aria", "decal", "decals"]));
      return ALe(o, o0t, p3, null, i, t3, c3);
    }
    function s0t(o, i) {
      for (var t3 = o.length, c3 = 0; c3 < t3; c3++)
        if (o[c3].length > i)
          return o[c3];
      return o[t3 - 1];
    }
    function ALe(o, i, t3, c3, p3, g3, b3) {
      g3 = g3 || o;
      var w3 = i(g3), M = w3.paletteIdx || 0, I = w3.paletteNameMap = w3.paletteNameMap || {};
      if (I.hasOwnProperty(p3))
        return I[p3];
      var k3 = b3 == null || !c3 ? t3 : s0t(c3, b3);
      if (k3 = k3 || t3, !(!k3 || !k3.length)) {
        var L = k3[M];
        return p3 && (I[p3] = L), w3.paletteIdx = (M + 1) % k3.length, L;
      }
    }
    function l0t(o, i) {
      i(o).paletteIdx = 0, i(o).paletteNameMap = {};
    }
    var gte, EH, ILe, ELe = "\0_ec_inner", u0t = 1, DLe = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.init = function(t3, c3, p3, g3, b3, w3) {
        g3 = g3 || {}, this.option = null, this._theme = new gh(g3), this._locale = new gh(b3), this._optionManager = w3;
      }, i.prototype.setOption = function(t3, c3, p3) {
        var g3 = PLe(c3);
        this._optionManager.setOption(t3, p3, g3), this._resetOption(null, g3);
      }, i.prototype.resetOption = function(t3, c3) {
        return this._resetOption(t3, PLe(c3));
      }, i.prototype._resetOption = function(t3, c3) {
        var p3 = false, g3 = this._optionManager;
        if (!t3 || t3 === "recreate") {
          var b3 = g3.mountOption(t3 === "recreate");
          !this.option || t3 === "recreate" ? ILe(this, b3) : (this.restoreData(), this._mergeOption(b3, c3)), p3 = true;
        }
        if ((t3 === "timeline" || t3 === "media") && this.restoreData(), !t3 || t3 === "recreate" || t3 === "timeline") {
          var w3 = g3.getTimelineOption(this);
          w3 && (p3 = true, this._mergeOption(w3, c3));
        }
        if (!t3 || t3 === "recreate" || t3 === "media") {
          var M = g3.getMediaOption(this);
          M.length && yt(M, function(I) {
            p3 = true, this._mergeOption(I, c3);
          }, this);
        }
        return p3;
      }, i.prototype.mergeOption = function(t3) {
        this._mergeOption(t3, null);
      }, i.prototype._mergeOption = function(t3, c3) {
        var p3 = this.option, g3 = this._componentsMap, b3 = this._componentsCount, w3 = [], M = Eo(), I = c3 && c3.replaceMergeMainTypeMap;
        n0t(this), yt(t3, function(L, F) {
          L != null && (nc.hasClass(F) ? F && (w3.push(F), M.set(F, true)) : p3[F] = p3[F] == null ? Jo(L) : Es(p3[F], L, true));
        }), I && I.each(function(L, F) {
          nc.hasClass(F) && !M.get(F) && (w3.push(F), M.set(F, true));
        }), nc.topologicalTravel(w3, nc.getAllClassMainTypes(), k3, this);
        function k3(L) {
          var F = a0t(this, L, Wc(t3[L])), B = g3.get(L), G = B ? I && I.get(L) ? "replaceMerge" : "normalMerge" : "replaceAll", J = xg(B, F, G);
          CG(J, L, nc), p3[L] = null, g3.set(L, null), b3.set(L, 0);
          var Q = [], se = [], he = 0, be;
          yt(J, function(de, Fe) {
            var Pe = de.existing, ze = de.newOption;
            if (!ze)
              Pe && (Pe.mergeOption({}, this), Pe.optionUpdated({}, false));
            else {
              var $e = L === "series", Ke = nc.getClass(L, de.keyInfo.subType, !$e);
              if (!Ke)
                return;
              if (L === "tooltip") {
                if (be)
                  return;
                be = true;
              }
              if (Pe && Pe.constructor === Ke)
                Pe.name = de.keyInfo.name, Pe.mergeOption(ze, this), Pe.optionUpdated(ze, false);
              else {
                var nt = ti({ componentIndex: Fe }, de.keyInfo);
                Pe = new Ke(ze, this, this, nt), ti(Pe, nt), de.brandNew && (Pe.__requireNewView = true), Pe.init(ze, this, this), Pe.optionUpdated(null, true);
              }
            }
            Pe ? (Q.push(Pe.option), se.push(Pe), he++) : (Q.push(void 0), se.push(void 0));
          }, this), p3[L] = Q, g3.set(L, se), b3.set(L, he), L === "series" && gte(this);
        }
        this._seriesIndices || gte(this);
      }, i.prototype.getOption = function() {
        var t3 = Jo(this.option);
        return yt(t3, function(c3, p3) {
          if (nc.hasClass(p3)) {
            for (var g3 = Wc(c3), b3 = g3.length, w3 = false, M = b3 - 1; M >= 0; M--)
              g3[M] && !yI(g3[M]) ? w3 = true : (g3[M] = null, !w3 && b3--);
            g3.length = b3, t3[p3] = g3;
          }
        }), delete t3[ELe], t3;
      }, i.prototype.getTheme = function() {
        return this._theme;
      }, i.prototype.getLocaleModel = function() {
        return this._locale;
      }, i.prototype.setUpdatePayload = function(t3) {
        this._payload = t3;
      }, i.prototype.getUpdatePayload = function() {
        return this._payload;
      }, i.prototype.getComponent = function(t3, c3) {
        var p3 = this._componentsMap.get(t3);
        if (p3) {
          var g3 = p3[c3 || 0];
          if (g3)
            return g3;
          if (c3 == null) {
            for (var b3 = 0; b3 < p3.length; b3++)
              if (p3[b3])
                return p3[b3];
          }
        }
      }, i.prototype.queryComponents = function(t3) {
        var c3 = t3.mainType;
        if (!c3)
          return [];
        var p3 = t3.index, g3 = t3.id, b3 = t3.name, w3 = this._componentsMap.get(c3);
        if (!w3 || !w3.length)
          return [];
        var M;
        return p3 != null ? (M = [], yt(Wc(p3), function(I) {
          w3[I] && M.push(w3[I]);
        })) : g3 != null ? M = kLe("id", g3, w3) : b3 != null ? M = kLe("name", b3, w3) : M = Zc(w3, function(I) {
          return !!I;
        }), OLe(M, t3);
      }, i.prototype.findComponents = function(t3) {
        var c3 = t3.query, p3 = t3.mainType, g3 = w3(c3), b3 = g3 ? this.queryComponents(g3) : Zc(this._componentsMap.get(p3), function(I) {
          return !!I;
        });
        return M(OLe(b3, t3));
        function w3(I) {
          var k3 = p3 + "Index", L = p3 + "Id", F = p3 + "Name";
          return I && (I[k3] != null || I[L] != null || I[F] != null) ? { mainType: p3, index: I[k3], id: I[L], name: I[F] } : null;
        }
        function M(I) {
          return t3.filter ? Zc(I, t3.filter) : I;
        }
      }, i.prototype.eachComponent = function(t3, c3, p3) {
        var g3 = this._componentsMap;
        if (Vo(t3)) {
          var b3 = c3, w3 = t3;
          g3.each(function(L, F) {
            for (var B = 0; L && B < L.length; B++) {
              var G = L[B];
              G && w3.call(b3, F, G, G.componentIndex);
            }
          });
        } else
          for (var M = Ha(t3) ? g3.get(t3) : Ua(t3) ? this.findComponents(t3) : null, I = 0; M && I < M.length; I++) {
            var k3 = M[I];
            k3 && c3.call(p3, k3, k3.componentIndex);
          }
      }, i.prototype.getSeriesByName = function(t3) {
        var c3 = Jf(t3, null);
        return Zc(this._componentsMap.get("series"), function(p3) {
          return !!p3 && c3 != null && p3.name === c3;
        });
      }, i.prototype.getSeriesByIndex = function(t3) {
        return this._componentsMap.get("series")[t3];
      }, i.prototype.getSeriesByType = function(t3) {
        return Zc(this._componentsMap.get("series"), function(c3) {
          return !!c3 && c3.subType === t3;
        });
      }, i.prototype.getSeries = function() {
        return Zc(this._componentsMap.get("series"), function(t3) {
          return !!t3;
        });
      }, i.prototype.getSeriesCount = function() {
        return this._componentsCount.get("series");
      }, i.prototype.eachSeries = function(t3, c3) {
        EH(this), yt(this._seriesIndices, function(p3) {
          var g3 = this._componentsMap.get("series")[p3];
          t3.call(c3, g3, p3);
        }, this);
      }, i.prototype.eachRawSeries = function(t3, c3) {
        yt(this._componentsMap.get("series"), function(p3) {
          p3 && t3.call(c3, p3, p3.componentIndex);
        });
      }, i.prototype.eachSeriesByType = function(t3, c3, p3) {
        EH(this), yt(this._seriesIndices, function(g3) {
          var b3 = this._componentsMap.get("series")[g3];
          b3.subType === t3 && c3.call(p3, b3, g3);
        }, this);
      }, i.prototype.eachRawSeriesByType = function(t3, c3, p3) {
        return yt(this.getSeriesByType(t3), c3, p3);
      }, i.prototype.isSeriesFiltered = function(t3) {
        return EH(this), this._seriesIndicesMap.get(t3.componentIndex) == null;
      }, i.prototype.getCurrentSeriesIndices = function() {
        return (this._seriesIndices || []).slice();
      }, i.prototype.filterSeries = function(t3, c3) {
        EH(this);
        var p3 = [];
        yt(this._seriesIndices, function(g3) {
          var b3 = this._componentsMap.get("series")[g3];
          t3.call(c3, b3, g3) && p3.push(g3);
        }, this), this._seriesIndices = p3, this._seriesIndicesMap = Eo(p3);
      }, i.prototype.restoreData = function(t3) {
        gte(this);
        var c3 = this._componentsMap, p3 = [];
        c3.each(function(g3, b3) {
          nc.hasClass(b3) && p3.push(b3);
        }), nc.topologicalTravel(p3, nc.getAllClassMainTypes(), function(g3) {
          yt(c3.get(g3), function(b3) {
            b3 && (g3 !== "series" || !c0t(b3, t3)) && b3.restoreData();
          });
        });
      }, i.internalField = function() {
        gte = function(t3) {
          var c3 = t3._seriesIndices = [];
          yt(t3._componentsMap.get("series"), function(p3) {
            p3 && c3.push(p3.componentIndex);
          }), t3._seriesIndicesMap = Eo(c3);
        }, EH = function(t3) {
        }, ILe = function(t3, c3) {
          t3.option = {}, t3.option[ELe] = u0t, t3._componentsMap = Eo({ series: [] }), t3._componentsCount = Eo();
          var p3 = c3.aria;
          Ua(p3) && p3.enabled == null && (p3.enabled = true), f0t(c3, t3._theme.option), Es(c3, t0t, false), t3._mergeOption(c3, null);
        };
      }(), i;
    }(gh);
    function c0t(o, i) {
      if (i) {
        var t3 = i.seriesIndex, c3 = i.seriesId, p3 = i.seriesName;
        return t3 != null && o.componentIndex !== t3 || c3 != null && o.id !== c3 || p3 != null && o.name !== p3;
      }
    }
    function f0t(o, i) {
      var t3 = o.color && !o.colorLayer;
      yt(i, function(c3, p3) {
        p3 === "colorLayer" && t3 || nc.hasClass(p3) || (typeof c3 == "object" ? o[p3] = o[p3] ? Es(o[p3], c3, false) : Jo(c3) : o[p3] == null && (o[p3] = c3));
      });
    }
    function kLe(o, i, t3) {
      if (Ei(i)) {
        var c3 = Eo();
        return yt(i, function(g3) {
          if (g3 != null) {
            var b3 = Jf(g3, null);
            b3 != null && c3.set(g3, true);
          }
        }), Zc(t3, function(g3) {
          return g3 && c3.get(g3[o]);
        });
      } else {
        var p3 = Jf(i, null);
        return Zc(t3, function(g3) {
          return g3 && p3 != null && g3[o] === p3;
        });
      }
    }
    function OLe(o, i) {
      return i.hasOwnProperty("subType") ? Zc(o, function(t3) {
        return t3 && t3.subType === i.subType;
      }) : o;
    }
    function PLe(o) {
      var i = Eo();
      return o && yt(Wc(o.replaceMerge), function(t3) {
        i.set(t3, true);
      }), { replaceMergeMainTypeMap: i };
    }
    Kp(DLe, gge);
    var LLe = DLe, h0t = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], p0t = function() {
      function o(i) {
        yt(h0t, function(t3) {
          this[t3] = Qa(i[t3], i);
        }, this);
      }
      return o;
    }(), RLe = p0t, mge = {}, d0t = function() {
      function o() {
        this._coordinateSystems = [];
      }
      return o.prototype.create = function(i, t3) {
        var c3 = [];
        yt(mge, function(p3, g3) {
          var b3 = p3.create(i, t3);
          c3 = c3.concat(b3 || []);
        }), this._coordinateSystems = c3;
      }, o.prototype.update = function(i, t3) {
        yt(this._coordinateSystems, function(c3) {
          c3.update && c3.update(i, t3);
        });
      }, o.prototype.getCoordinateSystems = function() {
        return this._coordinateSystems.slice();
      }, o.register = function(i, t3) {
        mge[i] = t3;
      }, o.get = function(i) {
        return mge[i];
      }, o;
    }(), DH = d0t, v0t = /^(min|max)?(.+)$/, g0t = function() {
      function o(i) {
        this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = i;
      }
      return o.prototype.setOption = function(i, t3, c3) {
        i && (yt(Wc(i.series), function(b3) {
          b3 && b3.data && w1(b3.data) && vP(b3.data);
        }), yt(Wc(i.dataset), function(b3) {
          b3 && b3.source && w1(b3.source) && vP(b3.source);
        })), i = Jo(i);
        var p3 = this._optionBackup, g3 = y0t(i, t3, !p3);
        this._newBaseOption = g3.baseOption, p3 ? (g3.timelineOptions.length && (p3.timelineOptions = g3.timelineOptions), g3.mediaList.length && (p3.mediaList = g3.mediaList), g3.mediaDefault && (p3.mediaDefault = g3.mediaDefault)) : this._optionBackup = g3;
      }, o.prototype.mountOption = function(i) {
        var t3 = this._optionBackup;
        return this._timelineOptions = t3.timelineOptions, this._mediaList = t3.mediaList, this._mediaDefault = t3.mediaDefault, this._currentMediaIndices = [], Jo(i ? t3.baseOption : this._newBaseOption);
      }, o.prototype.getTimelineOption = function(i) {
        var t3, c3 = this._timelineOptions;
        if (c3.length) {
          var p3 = i.getComponent("timeline");
          p3 && (t3 = Jo(c3[p3.getCurrentIndex()]));
        }
        return t3;
      }, o.prototype.getMediaOption = function(i) {
        var t3 = this._api.getWidth(), c3 = this._api.getHeight(), p3 = this._mediaList, g3 = this._mediaDefault, b3 = [], w3 = [];
        if (!p3.length && !g3)
          return w3;
        for (var M = 0, I = p3.length; M < I; M++)
          m0t(p3[M].query, t3, c3) && b3.push(M);
        return !b3.length && g3 && (b3 = [-1]), b3.length && !_0t(b3, this._currentMediaIndices) && (w3 = Fi(b3, function(k3) {
          return Jo(k3 === -1 ? g3.option : p3[k3].option);
        })), this._currentMediaIndices = b3, w3;
      }, o;
    }();
    function y0t(o, i, t3) {
      var c3 = [], p3, g3, b3 = o.baseOption, w3 = o.timeline, M = o.options, I = o.media, k3 = !!o.media, L = !!(M || w3 || b3 && b3.timeline);
      b3 ? (g3 = b3, g3.timeline || (g3.timeline = w3)) : ((L || k3) && (o.options = o.media = null), g3 = o), k3 && Ei(I) && yt(I, function(B) {
        B && B.option && (B.query ? c3.push(B) : p3 || (p3 = B));
      }), F(g3), yt(M, function(B) {
        return F(B);
      }), yt(c3, function(B) {
        return F(B.option);
      });
      function F(B) {
        yt(i, function(G) {
          G(B, t3);
        });
      }
      return { baseOption: g3, timelineOptions: M || [], mediaDefault: p3, mediaList: c3 };
    }
    function m0t(o, i, t3) {
      var c3 = { width: i, height: t3, aspectratio: i / t3 }, p3 = true;
      return yt(o, function(g3, b3) {
        var w3 = b3.match(v0t);
        if (!(!w3 || !w3[1] || !w3[2])) {
          var M = w3[1], I = w3[2].toLowerCase();
          b0t(c3[I], g3, M) || (p3 = false);
        }
      }), p3;
    }
    function b0t(o, i, t3) {
      return t3 === "min" ? o >= i : t3 === "max" ? o <= i : o === i;
    }
    function _0t(o, i) {
      return o.join(",") === i.join(",");
    }
    var x0t = g0t, $2 = yt, kH = Ua, NLe = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
    function bge(o) {
      var i = o && o.itemStyle;
      if (i)
        for (var t3 = 0, c3 = NLe.length; t3 < c3; t3++) {
          var p3 = NLe[t3], g3 = i.normal, b3 = i.emphasis;
          g3 && g3[p3] && (o[p3] = o[p3] || {}, o[p3].normal ? Es(o[p3].normal, g3[p3]) : o[p3].normal = g3[p3], g3[p3] = null), b3 && b3[p3] && (o[p3] = o[p3] || {}, o[p3].emphasis ? Es(o[p3].emphasis, b3[p3]) : o[p3].emphasis = b3[p3], b3[p3] = null);
        }
    }
    function Mm(o, i, t3) {
      if (o && o[i] && (o[i].normal || o[i].emphasis)) {
        var c3 = o[i].normal, p3 = o[i].emphasis;
        c3 && (t3 ? (o[i].normal = o[i].emphasis = null, Uo(o[i], c3)) : o[i] = c3), p3 && (o.emphasis = o.emphasis || {}, o.emphasis[i] = p3, p3.focus && (o.emphasis.focus = p3.focus), p3.blurScope && (o.emphasis.blurScope = p3.blurScope));
      }
    }
    function OH(o) {
      Mm(o, "itemStyle"), Mm(o, "lineStyle"), Mm(o, "areaStyle"), Mm(o, "label"), Mm(o, "labelLine"), Mm(o, "upperLabel"), Mm(o, "edgeLabel");
    }
    function hv(o, i) {
      var t3 = kH(o) && o[i], c3 = kH(t3) && t3.textStyle;
      if (c3)
        for (var p3 = 0, g3 = YQ.length; p3 < g3; p3++) {
          var b3 = YQ[p3];
          c3.hasOwnProperty(b3) && (t3[b3] = c3[b3]);
        }
    }
    function kw(o) {
      o && (OH(o), hv(o, "label"), o.emphasis && hv(o.emphasis, "label"));
    }
    function w0t(o) {
      if (kH(o)) {
        bge(o), OH(o), hv(o, "label"), hv(o, "upperLabel"), hv(o, "edgeLabel"), o.emphasis && (hv(o.emphasis, "label"), hv(o.emphasis, "upperLabel"), hv(o.emphasis, "edgeLabel"));
        var i = o.markPoint;
        i && (bge(i), kw(i));
        var t3 = o.markLine;
        t3 && (bge(t3), kw(t3));
        var c3 = o.markArea;
        c3 && kw(c3);
        var p3 = o.data;
        if (o.type === "graph") {
          p3 = p3 || o.nodes;
          var g3 = o.links || o.edges;
          if (g3 && !w1(g3))
            for (var b3 = 0; b3 < g3.length; b3++)
              kw(g3[b3]);
          yt(o.categories, function(I) {
            OH(I);
          });
        }
        if (p3 && !w1(p3))
          for (var b3 = 0; b3 < p3.length; b3++)
            kw(p3[b3]);
        if (i = o.markPoint, i && i.data)
          for (var w3 = i.data, b3 = 0; b3 < w3.length; b3++)
            kw(w3[b3]);
        if (t3 = o.markLine, t3 && t3.data)
          for (var M = t3.data, b3 = 0; b3 < M.length; b3++)
            Ei(M[b3]) ? (kw(M[b3][0]), kw(M[b3][1])) : kw(M[b3]);
        o.type === "gauge" ? (hv(o, "axisLabel"), hv(o, "title"), hv(o, "detail")) : o.type === "treemap" ? (Mm(o.breadcrumb, "itemStyle"), yt(o.levels, function(I) {
          OH(I);
        })) : o.type === "tree" && OH(o.leaves);
      }
    }
    function LI(o) {
      return Ei(o) ? o : o ? [o] : [];
    }
    function FLe(o) {
      return (Ei(o) ? o[0] : o) || {};
    }
    function S0t(o, i) {
      $2(LI(o.series), function(c3) {
        kH(c3) && w0t(c3);
      });
      var t3 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
      i && t3.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), $2(t3, function(c3) {
        $2(LI(o[c3]), function(p3) {
          p3 && (hv(p3, "axisLabel"), hv(p3.axisPointer, "label"));
        });
      }), $2(LI(o.parallel), function(c3) {
        var p3 = c3 && c3.parallelAxisDefault;
        hv(p3, "axisLabel"), hv(p3 && p3.axisPointer, "label");
      }), $2(LI(o.calendar), function(c3) {
        Mm(c3, "itemStyle"), hv(c3, "dayLabel"), hv(c3, "monthLabel"), hv(c3, "yearLabel");
      }), $2(LI(o.radar), function(c3) {
        hv(c3, "name"), c3.name && c3.axisName == null && (c3.axisName = c3.name, delete c3.name), c3.nameGap != null && c3.axisNameGap == null && (c3.axisNameGap = c3.nameGap, delete c3.nameGap);
      }), $2(LI(o.geo), function(c3) {
        kH(c3) && (kw(c3), $2(LI(c3.regions), function(p3) {
          kw(p3);
        }));
      }), $2(LI(o.timeline), function(c3) {
        kw(c3), Mm(c3, "label"), Mm(c3, "itemStyle"), Mm(c3, "controlStyle", true);
        var p3 = c3.data;
        Ei(p3) && yt(p3, function(g3) {
          Ua(g3) && (Mm(g3, "label"), Mm(g3, "itemStyle"));
        });
      }), $2(LI(o.toolbox), function(c3) {
        Mm(c3, "iconStyle"), $2(c3.feature, function(p3) {
          Mm(p3, "iconStyle");
        });
      }), hv(FLe(o.axisPointer), "label"), hv(FLe(o.tooltip).axisPointer, "label");
    }
    function C0t(o, i) {
      for (var t3 = i.split(","), c3 = o, p3 = 0; p3 < t3.length && (c3 = c3 && c3[t3[p3]], c3 != null); p3++)
        ;
      return c3;
    }
    function M0t(o, i, t3, c3) {
      for (var p3 = i.split(","), g3 = o, b3, w3 = 0; w3 < p3.length - 1; w3++)
        b3 = p3[w3], g3[b3] == null && (g3[b3] = {}), g3 = g3[b3];
      (c3 || g3[p3[w3]] == null) && (g3[p3[w3]] = t3);
    }
    function VLe(o) {
      o && yt(T0t, function(i) {
        i[0] in o && !(i[1] in o) && (o[i[1]] = o[i[0]]);
      });
    }
    var T0t = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], A0t = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], _ge = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
    function PH(o) {
      var i = o && o.itemStyle;
      if (i)
        for (var t3 = 0; t3 < _ge.length; t3++) {
          var c3 = _ge[t3][1], p3 = _ge[t3][0];
          i[c3] != null && (i[p3] = i[c3]);
        }
    }
    function BLe(o) {
      !o || o.alignTo === "edge" && o.margin != null && o.edgeDistance == null && (o.edgeDistance = o.margin);
    }
    function zLe(o) {
      !o || o.downplay && !o.blur && (o.blur = o.downplay);
    }
    function I0t(o) {
      !o || o.focusNodeAdjacency != null && (o.emphasis = o.emphasis || {}, o.emphasis.focus == null && (o.emphasis.focus = "adjacency"));
    }
    function jLe(o, i) {
      if (o)
        for (var t3 = 0; t3 < o.length; t3++)
          i(o[t3]), o[t3] && jLe(o[t3].children, i);
    }
    function GLe(o, i) {
      S0t(o, i), o.series = Wc(o.series), yt(o.series, function(t3) {
        if (Ua(t3)) {
          var c3 = t3.type;
          if (c3 === "line")
            t3.clipOverflow != null && (t3.clip = t3.clipOverflow);
          else if (c3 === "pie" || c3 === "gauge") {
            t3.clockWise != null && (t3.clockwise = t3.clockWise), BLe(t3.label);
            var p3 = t3.data;
            if (p3 && !w1(p3))
              for (var g3 = 0; g3 < p3.length; g3++)
                BLe(p3[g3]);
            t3.hoverOffset != null && (t3.emphasis = t3.emphasis || {}, (t3.emphasis.scaleSize = null) && (t3.emphasis.scaleSize = t3.hoverOffset));
          } else if (c3 === "gauge") {
            var b3 = C0t(t3, "pointer.color");
            b3 != null && M0t(t3, "itemStyle.color", b3);
          } else if (c3 === "bar") {
            PH(t3), PH(t3.backgroundStyle), PH(t3.emphasis);
            var p3 = t3.data;
            if (p3 && !w1(p3))
              for (var g3 = 0; g3 < p3.length; g3++)
                typeof p3[g3] == "object" && (PH(p3[g3]), PH(p3[g3] && p3[g3].emphasis));
          } else if (c3 === "sunburst") {
            var w3 = t3.highlightPolicy;
            w3 && (t3.emphasis = t3.emphasis || {}, t3.emphasis.focus || (t3.emphasis.focus = w3)), zLe(t3), jLe(t3.data, zLe);
          } else
            c3 === "graph" || c3 === "sankey" ? I0t(t3) : c3 === "map" && (t3.mapType && !t3.map && (t3.map = t3.mapType), t3.mapLocation && Uo(t3, t3.mapLocation));
          t3.hoverAnimation != null && (t3.emphasis = t3.emphasis || {}, t3.emphasis && t3.emphasis.scale == null && (t3.emphasis.scale = t3.hoverAnimation)), VLe(t3);
        }
      }), o.dataRange && (o.visualMap = o.dataRange), yt(A0t, function(t3) {
        var c3 = o[t3];
        c3 && (Ei(c3) || (c3 = [c3]), yt(c3, function(p3) {
          VLe(p3);
        }));
      });
    }
    function E0t(o) {
      var i = Eo();
      o.eachSeries(function(t3) {
        var c3 = t3.get("stack");
        if (c3) {
          var p3 = i.get(c3) || i.set(c3, []), g3 = t3.getData(), b3 = { stackResultDimension: g3.getCalculationInfo("stackResultDimension"), stackedOverDimension: g3.getCalculationInfo("stackedOverDimension"), stackedDimension: g3.getCalculationInfo("stackedDimension"), stackedByDimension: g3.getCalculationInfo("stackedByDimension"), isStackedByIndex: g3.getCalculationInfo("isStackedByIndex"), data: g3, seriesModel: t3 };
          if (!b3.stackedDimension || !(b3.isStackedByIndex || b3.stackedByDimension))
            return;
          p3.length && g3.setCalculationInfo("stackedOnSeries", p3[p3.length - 1].seriesModel), p3.push(b3);
        }
      }), i.each(D0t);
    }
    function D0t(o) {
      yt(o, function(i, t3) {
        var c3 = [], p3 = [NaN, NaN], g3 = [i.stackResultDimension, i.stackedOverDimension], b3 = i.data, w3 = i.isStackedByIndex;
        b3.modify(g3, function(M, I, k3) {
          var L = b3.get(i.stackedDimension, k3);
          if (isNaN(L))
            return p3;
          var F, B;
          w3 ? B = b3.getRawIndex(k3) : F = b3.get(i.stackedByDimension, k3);
          for (var G = NaN, J = t3 - 1; J >= 0; J--) {
            var Q = o[J];
            if (w3 || (B = Q.data.rawIndexOf(Q.stackedByDimension, F)), B >= 0) {
              var se = Q.data.getByRawIndex(Q.stackResultDimension, B);
              if (L >= 0 && se > 0 || L <= 0 && se < 0) {
                L = DF(L, se), G = se;
                break;
              }
            }
          }
          return c3[0] = L, c3[1] = G, c3;
        });
      });
    }
    var yte = function() {
      function o(i) {
        this.data = i.data || (i.sourceFormat === YM ? {} : []), this.sourceFormat = i.sourceFormat || xLe, this.seriesLayoutBy = i.seriesLayoutBy || KM, this.startIndex = i.startIndex || 0, this.dimensionsDetectedCount = i.dimensionsDetectedCount, this.metaRawOption = i.metaRawOption;
        var t3 = this.dimensionsDefine = i.dimensionsDefine;
        if (t3)
          for (var c3 = 0; c3 < t3.length; c3++) {
            var p3 = t3[c3];
            p3.type == null && CLe(this, c3) === xy.Must && (p3.type = "ordinal");
          }
      }
      return o;
    }();
    function xge(o) {
      return o instanceof yte;
    }
    function wge(o, i, t3) {
      t3 = t3 || HLe(o);
      var c3 = i.seriesLayoutBy, p3 = O0t(o, t3, c3, i.sourceHeader, i.dimensions), g3 = new yte({ data: o, sourceFormat: t3, seriesLayoutBy: c3, dimensionsDefine: p3.dimensionsDefine, startIndex: p3.startIndex, dimensionsDetectedCount: p3.dimensionsDetectedCount, metaRawOption: Jo(i) });
      return g3;
    }
    function Sge(o) {
      return new yte({ data: o, sourceFormat: w1(o) ? ak : Ew });
    }
    function k0t(o) {
      return new yte({ data: o.data, sourceFormat: o.sourceFormat, seriesLayoutBy: o.seriesLayoutBy, dimensionsDefine: Jo(o.dimensionsDefine), startIndex: o.startIndex, dimensionsDetectedCount: o.dimensionsDetectedCount });
    }
    function HLe(o) {
      var i = xLe;
      if (w1(o))
        i = ak;
      else if (Ei(o)) {
        o.length === 0 && (i = Cm);
        for (var t3 = 0, c3 = o.length; t3 < c3; t3++) {
          var p3 = o[t3];
          if (p3 != null) {
            if (Ei(p3)) {
              i = Cm;
              break;
            } else if (Ua(p3)) {
              i = Dw;
              break;
            }
          }
        }
      } else if (Ua(o)) {
        for (var g3 in o)
          if (so(o, g3) && yg(o[g3])) {
            i = YM;
            break;
          }
      }
      return i;
    }
    function O0t(o, i, t3, c3, p3) {
      var g3, b3;
      if (!o)
        return { dimensionsDefine: WLe(p3), startIndex: b3, dimensionsDetectedCount: g3 };
      if (i === Cm) {
        var w3 = o;
        c3 === "auto" || c3 == null ? ULe(function(I) {
          I != null && I !== "-" && (Ha(I) ? b3 == null && (b3 = 1) : b3 = 0);
        }, t3, w3, 10) : b3 = ec(c3) ? c3 : c3 ? 1 : 0, !p3 && b3 === 1 && (p3 = [], ULe(function(I, k3) {
          p3[k3] = I != null ? I + "" : "";
        }, t3, w3, 1 / 0)), g3 = p3 ? p3.length : t3 === x8 ? w3.length : w3[0] ? w3[0].length : null;
      } else if (i === Dw)
        p3 || (p3 = P0t(o));
      else if (i === YM)
        p3 || (p3 = [], yt(o, function(I, k3) {
          p3.push(k3);
        }));
      else if (i === Ew) {
        var M = NM(o[0]);
        g3 = Ei(M) && M.length || 1;
      }
      return { startIndex: b3, dimensionsDefine: WLe(p3), dimensionsDetectedCount: g3 };
    }
    function P0t(o) {
      for (var i = 0, t3; i < o.length && !(t3 = o[i++]); )
        ;
      if (t3) {
        var c3 = [];
        return yt(t3, function(p3, g3) {
          c3.push(g3);
        }), c3;
      }
    }
    function WLe(o) {
      if (o) {
        var i = Eo();
        return Fi(o, function(t3, c3) {
          t3 = Ua(t3) ? t3 : { name: t3 };
          var p3 = { name: t3.name, displayName: t3.displayName, type: t3.type };
          if (p3.name == null)
            return p3;
          p3.name += "", p3.displayName == null && (p3.displayName = p3.name);
          var g3 = i.get(p3.name);
          return g3 ? p3.name += "-" + g3.count++ : i.set(p3.name, { count: 1 }), p3;
        });
      }
    }
    function ULe(o, i, t3, c3) {
      if (i === x8)
        for (var p3 = 0; p3 < t3.length && p3 < c3; p3++)
          o(t3[p3] ? t3[p3][0] : null, p3);
      else
        for (var g3 = t3[0] || [], p3 = 0; p3 < g3.length && p3 < c3; p3++)
          o(g3[p3], p3);
    }
    function qLe(o) {
      var i = o.sourceFormat;
      return i === Dw || i === YM;
    }
    var aL, oL, sL, $Le, XLe, YLe = function() {
      function o(i, t3) {
        var c3 = xge(i) ? i : Sge(i);
        this._source = c3;
        var p3 = this._data = c3.data;
        c3.sourceFormat === ak && (this._offset = 0, this._dimSize = t3, this._data = p3), XLe(this, p3, c3);
      }
      return o.prototype.getSource = function() {
        return this._source;
      }, o.prototype.count = function() {
        return 0;
      }, o.prototype.getItem = function(i, t3) {
      }, o.prototype.appendData = function(i) {
      }, o.prototype.clean = function() {
      }, o.protoInitialize = function() {
        var i = o.prototype;
        i.pure = false, i.persistent = true;
      }(), o.internalField = function() {
        var i;
        XLe = function(b3, w3, M) {
          var I = M.sourceFormat, k3 = M.seriesLayoutBy, L = M.startIndex, F = M.dimensionsDefine, B = $Le[Mge(I, k3)];
          if (ti(b3, B), I === ak)
            b3.getItem = t3, b3.count = p3, b3.fillStorage = c3;
          else {
            var G = ZLe(I, k3);
            b3.getItem = Qa(G, null, w3, L, F);
            var J = QLe(I, k3);
            b3.count = Qa(J, null, w3, L, F);
          }
        };
        var t3 = function(b3, w3) {
          b3 = b3 - this._offset, w3 = w3 || [];
          for (var M = this._data, I = this._dimSize, k3 = I * b3, L = 0; L < I; L++)
            w3[L] = M[k3 + L];
          return w3;
        }, c3 = function(b3, w3, M, I) {
          for (var k3 = this._data, L = this._dimSize, F = 0; F < L; F++) {
            for (var B = I[F], G = B[0] == null ? 1 / 0 : B[0], J = B[1] == null ? -1 / 0 : B[1], Q = w3 - b3, se = M[F], he = 0; he < Q; he++) {
              var be = k3[he * L + F];
              se[b3 + he] = be, be < G && (G = be), be > J && (J = be);
            }
            B[0] = G, B[1] = J;
          }
        }, p3 = function() {
          return this._data ? this._data.length / this._dimSize : 0;
        };
        $Le = (i = {}, i[Cm + "_" + KM] = { pure: true, appendData: g3 }, i[Cm + "_" + x8] = { pure: true, appendData: function() {
          throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
        } }, i[Dw] = { pure: true, appendData: g3 }, i[YM] = { pure: true, appendData: function(b3) {
          var w3 = this._data;
          yt(b3, function(M, I) {
            for (var k3 = w3[I] || (w3[I] = []), L = 0; L < (M || []).length; L++)
              k3.push(M[L]);
          });
        } }, i[Ew] = { appendData: g3 }, i[ak] = { persistent: false, pure: true, appendData: function(b3) {
          this._data = b3;
        }, clean: function() {
          this._offset += this.count(), this._data = null;
        } }, i);
        function g3(b3) {
          for (var w3 = 0; w3 < b3.length; w3++)
            this._data.push(b3[w3]);
        }
      }(), o;
    }(), KLe = function(o, i, t3, c3) {
      return o[c3];
    }, L0t = (aL = {}, aL[Cm + "_" + KM] = function(o, i, t3, c3) {
      return o[c3 + i];
    }, aL[Cm + "_" + x8] = function(o, i, t3, c3, p3) {
      c3 += i;
      for (var g3 = p3 || [], b3 = o, w3 = 0; w3 < b3.length; w3++) {
        var M = b3[w3];
        g3[w3] = M ? M[c3] : null;
      }
      return g3;
    }, aL[Dw] = KLe, aL[YM] = function(o, i, t3, c3, p3) {
      for (var g3 = p3 || [], b3 = 0; b3 < t3.length; b3++) {
        var w3 = t3[b3].name, M = o[w3];
        g3[b3] = M ? M[c3] : null;
      }
      return g3;
    }, aL[Ew] = KLe, aL);
    function ZLe(o, i) {
      var t3 = L0t[Mge(o, i)];
      return t3;
    }
    var JLe = function(o, i, t3) {
      return o.length;
    }, R0t = (oL = {}, oL[Cm + "_" + KM] = function(o, i, t3) {
      return Math.max(0, o.length - i);
    }, oL[Cm + "_" + x8] = function(o, i, t3) {
      var c3 = o[0];
      return c3 ? Math.max(0, c3.length - i) : 0;
    }, oL[Dw] = JLe, oL[YM] = function(o, i, t3) {
      var c3 = t3[0].name, p3 = o[c3];
      return p3 ? p3.length : 0;
    }, oL[Ew] = JLe, oL);
    function QLe(o, i) {
      var t3 = R0t[Mge(o, i)];
      return t3;
    }
    var Cge = function(o, i, t3) {
      return o[i];
    }, N0t = (sL = {}, sL[Cm] = Cge, sL[Dw] = function(o, i, t3) {
      return o[t3];
    }, sL[YM] = Cge, sL[Ew] = function(o, i, t3) {
      var c3 = NM(o);
      return c3 instanceof Array ? c3[i] : c3;
    }, sL[ak] = Cge, sL);
    function eRe(o) {
      var i = N0t[o];
      return i;
    }
    function Mge(o, i) {
      return o === Cm ? o + "_" + i : o;
    }
    function w8(o, i, t3) {
      if (o) {
        var c3 = o.getRawDataItem(i);
        if (c3 != null) {
          var p3 = o.getStore(), g3 = p3.getSource().sourceFormat;
          if (t3 != null) {
            var b3 = o.getDimensionIndex(t3), w3 = p3.getDimensionProperty(b3);
            return eRe(g3)(c3, b3, w3);
          } else {
            var M = c3;
            return g3 === Ew && (M = NM(c3)), M;
          }
        }
      }
    }
    var F0t = /\{@(.+?)\}/g, Tge = function() {
      function o() {
      }
      return o.prototype.getDataParams = function(i, t3) {
        var c3 = this.getData(t3), p3 = this.getRawValue(i, t3), g3 = c3.getRawIndex(i), b3 = c3.getName(i), w3 = c3.getRawDataItem(i), M = c3.getItemVisual(i, "style"), I = M && M[c3.getItemVisual(i, "drawType") || "fill"], k3 = M && M.stroke, L = this.mainType, F = L === "series", B = c3.userOutput && c3.userOutput.get();
        return { componentType: L, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: F ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: F ? this.id : null, seriesName: F ? this.name : null, name: b3, dataIndex: g3, data: w3, dataType: t3, value: p3, color: I, borderColor: k3, dimensionNames: B ? B.fullDimensions : null, encode: B ? B.encode : null, $vars: ["seriesName", "name", "value"] };
      }, o.prototype.getFormattedLabel = function(i, t3, c3, p3, g3, b3) {
        t3 = t3 || "normal";
        var w3 = this.getData(c3), M = this.getDataParams(i, c3);
        if (b3 && (M.value = b3.interpolatedValue), p3 != null && Ei(M.value) && (M.value = M.value[p3]), !g3) {
          var I = w3.getItemModel(i);
          g3 = I.get(t3 === "normal" ? ["label", "formatter"] : [t3, "label", "formatter"]);
        }
        if (Vo(g3))
          return M.status = t3, M.dimensionIndex = p3, g3(M);
        if (Ha(g3)) {
          var k3 = gLe(g3, M);
          return k3.replace(F0t, function(L, F) {
            var B = F.length, G = F;
            G.charAt(0) === "[" && G.charAt(B - 1) === "]" && (G = +G.slice(1, B - 1));
            var J = w8(w3, i, G);
            if (b3 && Ei(b3.interpolatedValue)) {
              var Q = w3.getDimensionIndex(G);
              Q >= 0 && (J = b3.interpolatedValue[Q]);
            }
            return J != null ? J + "" : "";
          });
        }
      }, o.prototype.getRawValue = function(i, t3) {
        return w8(this.getData(t3), i);
      }, o.prototype.formatTooltip = function(i, t3, c3) {
      }, o;
    }();
    function tRe(o) {
      var i, t3;
      return Ua(o) ? o.type && (t3 = o) : i = o, { text: i, frag: t3 };
    }
    function LH(o) {
      return new V0t(o);
    }
    var V0t = function() {
      function o(i) {
        i = i || {}, this._reset = i.reset, this._plan = i.plan, this._count = i.count, this._onDirty = i.onDirty, this._dirty = true;
      }
      return o.prototype.perform = function(i) {
        var t3 = this._upstream, c3 = i && i.skip;
        if (this._dirty && t3) {
          var p3 = this.context;
          p3.data = p3.outputData = t3.context.outputData;
        }
        this.__pipeline && (this.__pipeline.currentTask = this);
        var g3;
        this._plan && !c3 && (g3 = this._plan(this.context));
        var b3 = k3(this._modBy), w3 = this._modDataCount || 0, M = k3(i && i.modBy), I = i && i.modDataCount || 0;
        (b3 !== M || w3 !== I) && (g3 = "reset");
        function k3(he) {
          return !(he >= 1) && (he = 1), he;
        }
        var L;
        (this._dirty || g3 === "reset") && (this._dirty = false, L = this._doReset(c3)), this._modBy = M, this._modDataCount = I;
        var F = i && i.step;
        if (t3 ? this._dueEnd = t3._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
          var B = this._dueIndex, G = Math.min(F != null ? this._dueIndex + F : 1 / 0, this._dueEnd);
          if (!c3 && (L || B < G)) {
            var J = this._progress;
            if (Ei(J))
              for (var Q = 0; Q < J.length; Q++)
                this._doProgress(J[Q], B, G, M, I);
            else
              this._doProgress(J, B, G, M, I);
          }
          this._dueIndex = G;
          var se = this._settedOutputEnd != null ? this._settedOutputEnd : G;
          this._outputDueEnd = se;
        } else
          this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
        return this.unfinished();
      }, o.prototype.dirty = function() {
        this._dirty = true, this._onDirty && this._onDirty(this.context);
      }, o.prototype._doProgress = function(i, t3, c3, p3, g3) {
        nRe.reset(t3, c3, p3, g3), this._callingProgress = i, this._callingProgress({ start: t3, end: c3, count: c3 - t3, next: nRe.next }, this.context);
      }, o.prototype._doReset = function(i) {
        this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
        var t3, c3;
        !i && this._reset && (t3 = this._reset(this.context), t3 && t3.progress && (c3 = t3.forceFirstProgress, t3 = t3.progress), Ei(t3) && !t3.length && (t3 = null)), this._progress = t3, this._modBy = this._modDataCount = null;
        var p3 = this._downstream;
        return p3 && p3.dirty(), c3;
      }, o.prototype.unfinished = function() {
        return this._progress && this._dueIndex < this._dueEnd;
      }, o.prototype.pipe = function(i) {
        (this._downstream !== i || this._dirty) && (this._downstream = i, i._upstream = this, i.dirty());
      }, o.prototype.dispose = function() {
        this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
      }, o.prototype.getUpstream = function() {
        return this._upstream;
      }, o.prototype.getDownstream = function() {
        return this._downstream;
      }, o.prototype.setOutputEnd = function(i) {
        this._outputDueEnd = this._settedOutputEnd = i;
      }, o;
    }(), nRe = function() {
      var o, i, t3, c3, p3, g3 = { reset: function(M, I, k3, L) {
        i = M, o = I, t3 = k3, c3 = L, p3 = Math.ceil(c3 / t3), g3.next = t3 > 1 && c3 > 0 ? w3 : b3;
      } };
      return g3;
      function b3() {
        return i < o ? i++ : null;
      }
      function w3() {
        var M = i % p3 * t3 + Math.ceil(i / p3), I = i >= o ? null : M < c3 ? M : i;
        return i++, I;
      }
    }();
    function ok(o, i) {
      var t3 = i && i.type;
      return t3 === "ordinal" ? o : (t3 === "time" && !ec(o) && o != null && o !== "-" && (o = +jv(o)), o == null || o === "" ? NaN : +o);
    }
    var B0t = Eo({ number: function(o) {
      return parseFloat(o);
    }, time: function(o) {
      return +jv(o);
    }, trim: function(o) {
      return Ha(o) ? S1(o) : o;
    } });
    function rRe(o) {
      return B0t.get(o);
    }
    var iRe = { lt: function(o, i) {
      return o < i;
    }, lte: function(o, i) {
      return o <= i;
    }, gt: function(o, i) {
      return o > i;
    }, gte: function(o, i) {
      return o >= i;
    } }, z0t = function() {
      function o(i, t3) {
        if (!ec(t3)) {
          var c3 = "";
          Fu(c3);
        }
        this._opFn = iRe[i], this._rvalFloat = G2(t3);
      }
      return o.prototype.evaluate = function(i) {
        return ec(i) ? this._opFn(i, this._rvalFloat) : this._opFn(G2(i), this._rvalFloat);
      }, o;
    }(), aRe = function() {
      function o(i, t3) {
        var c3 = i === "desc";
        this._resultLT = c3 ? 1 : -1, t3 == null && (t3 = c3 ? "min" : "max"), this._incomparable = t3 === "min" ? -1 / 0 : 1 / 0;
      }
      return o.prototype.evaluate = function(i, t3) {
        var c3 = ec(i) ? i : G2(i), p3 = ec(t3) ? t3 : G2(t3), g3 = isNaN(c3), b3 = isNaN(p3);
        if (g3 && (c3 = this._incomparable), b3 && (p3 = this._incomparable), g3 && b3) {
          var w3 = Ha(i), M = Ha(t3);
          w3 && (c3 = M ? i : 0), M && (p3 = w3 ? t3 : 0);
        }
        return c3 < p3 ? this._resultLT : c3 > p3 ? -this._resultLT : 0;
      }, o;
    }(), j0t = function() {
      function o(i, t3) {
        this._rval = t3, this._isEQ = i, this._rvalTypeof = typeof t3, this._rvalFloat = G2(t3);
      }
      return o.prototype.evaluate = function(i) {
        var t3 = i === this._rval;
        if (!t3) {
          var c3 = typeof i;
          c3 !== this._rvalTypeof && (c3 === "number" || this._rvalTypeof === "number") && (t3 = G2(i) === this._rvalFloat);
        }
        return this._isEQ ? t3 : !t3;
      }, o;
    }();
    function G0t(o, i) {
      return o === "eq" || o === "ne" ? new j0t(o === "eq", i) : so(iRe, o) ? new z0t(o, i) : null;
    }
    var H0t = function() {
      function o() {
      }
      return o.prototype.getRawData = function() {
        throw new Error("not supported");
      }, o.prototype.getRawDataItem = function(i) {
        throw new Error("not supported");
      }, o.prototype.cloneRawData = function() {
      }, o.prototype.getDimensionInfo = function(i) {
      }, o.prototype.cloneAllDimensionInfo = function() {
      }, o.prototype.count = function() {
      }, o.prototype.retrieveValue = function(i, t3) {
      }, o.prototype.retrieveValueFromItem = function(i, t3) {
      }, o.prototype.convertValue = function(i, t3) {
        return ok(i, t3);
      }, o;
    }();
    function W0t(o, i) {
      var t3 = new H0t(), c3 = o.data, p3 = t3.sourceFormat = o.sourceFormat, g3 = o.startIndex, b3 = "";
      o.seriesLayoutBy !== KM && Fu(b3);
      var w3 = [], M = {}, I = o.dimensionsDefine;
      if (I)
        yt(I, function(J, Q) {
          var se = J.name, he = { index: Q, name: se, displayName: J.displayName };
          if (w3.push(he), se != null) {
            var be = "";
            so(M, se) && Fu(be), M[se] = he;
          }
        });
      else
        for (var k3 = 0; k3 < o.dimensionsDetectedCount; k3++)
          w3.push({ index: k3 });
      var L = ZLe(p3, KM);
      i.__isBuiltIn && (t3.getRawDataItem = function(J) {
        return L(c3, g3, w3, J);
      }, t3.getRawData = Qa(U0t, null, o)), t3.cloneRawData = Qa(q0t, null, o);
      var F = QLe(p3, KM);
      t3.count = Qa(F, null, c3, g3, w3);
      var B = eRe(p3);
      t3.retrieveValue = function(J, Q) {
        var se = L(c3, g3, w3, J);
        return G(se, Q);
      };
      var G = t3.retrieveValueFromItem = function(J, Q) {
        if (J != null) {
          var se = w3[Q];
          if (se)
            return B(J, Q, se.name);
        }
      };
      return t3.getDimensionInfo = Qa($0t, null, w3, M), t3.cloneAllDimensionInfo = Qa(X0t, null, w3), t3;
    }
    function U0t(o) {
      var i = o.sourceFormat;
      if (!Age(i)) {
        var t3 = "";
        Fu(t3);
      }
      return o.data;
    }
    function q0t(o) {
      var i = o.sourceFormat, t3 = o.data;
      if (!Age(i)) {
        var c3 = "";
        Fu(c3);
      }
      if (i === Cm) {
        for (var p3 = [], g3 = 0, b3 = t3.length; g3 < b3; g3++)
          p3.push(t3[g3].slice());
        return p3;
      } else if (i === Dw) {
        for (var p3 = [], g3 = 0, b3 = t3.length; g3 < b3; g3++)
          p3.push(ti({}, t3[g3]));
        return p3;
      }
    }
    function $0t(o, i, t3) {
      if (t3 != null) {
        if (ec(t3) || !isNaN(t3) && !so(i, t3))
          return o[t3];
        if (so(i, t3))
          return i[t3];
      }
    }
    function X0t(o) {
      return Jo(o);
    }
    var oRe = Eo();
    function Y0t(o) {
      o = Jo(o);
      var i = o.type, t3 = "";
      i || Fu(t3);
      var c3 = i.split(":");
      c3.length !== 2 && Fu(t3);
      var p3 = false;
      c3[0] === "echarts" && (i = c3[1], p3 = true), o.__isBuiltIn = p3, oRe.set(i, o);
    }
    function K0t(o, i, t3) {
      var c3 = Wc(o), p3 = c3.length, g3 = "";
      p3 || Fu(g3);
      for (var b3 = 0, w3 = p3; b3 < w3; b3++) {
        var M = c3[b3];
        i = Z0t(M, i), b3 !== w3 - 1 && (i.length = Math.max(i.length, 1));
      }
      return i;
    }
    function Z0t(o, i, t3, c3) {
      var p3 = "";
      i.length || Fu(p3), Ua(o) || Fu(p3);
      var g3 = o.type, b3 = oRe.get(g3);
      b3 || Fu(p3);
      var w3 = Fi(i, function(I) {
        return W0t(I, b3);
      }), M = Wc(b3.transform({ upstream: w3[0], upstreamList: w3, config: Jo(o.config) }));
      return Fi(M, function(I, k3) {
        var L = "";
        Ua(I) || Fu(L), I.data || Fu(L);
        var F = HLe(I.data);
        Age(F) || Fu(L);
        var B, G = i[0];
        if (G && k3 === 0 && !I.dimensions) {
          var J = G.startIndex;
          J && (I.data = G.data.slice(0, J).concat(I.data)), B = { seriesLayoutBy: KM, sourceHeader: J, dimensions: G.metaRawOption.dimensions };
        } else
          B = { seriesLayoutBy: KM, sourceHeader: 0, dimensions: I.dimensions };
        return wge(I.data, B, null);
      });
    }
    function Age(o) {
      return o === Cm || o === Dw;
    }
    var mte = "undefined", J0t = typeof Uint32Array === mte ? Array : Uint32Array, Q0t = typeof Uint16Array === mte ? Array : Uint16Array, sRe = typeof Int32Array === mte ? Array : Int32Array, lRe = typeof Float64Array === mte ? Array : Float64Array, uRe = { float: lRe, int: sRe, ordinal: Array, number: Array, time: lRe }, Ige;
    function RH(o) {
      return o > 65535 ? J0t : Q0t;
    }
    function S8() {
      return [1 / 0, -1 / 0];
    }
    function eyt(o) {
      var i = o.constructor;
      return i === Array ? o.slice() : new i(o);
    }
    function cRe(o, i, t3, c3, p3) {
      var g3 = uRe[t3 || "float"];
      if (p3) {
        var b3 = o[i], w3 = b3 && b3.length;
        if (w3 !== c3) {
          for (var M = new g3(c3), I = 0; I < w3; I++)
            M[I] = b3[I];
          o[i] = M;
        }
      } else
        o[i] = new g3(c3);
    }
    var Ege = function() {
      function o() {
        this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = Eo();
      }
      return o.prototype.initData = function(i, t3, c3) {
        this._provider = i, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
        var p3 = i.getSource(), g3 = this.defaultDimValueGetter = Ige[p3.sourceFormat];
        this._dimValueGetter = c3 || g3, this._rawExtent = [], qLe(p3), this._dimensions = Fi(t3, function(b3) {
          return { type: b3.type, property: b3.property };
        }), this._initDataFromProvider(0, i.count());
      }, o.prototype.getProvider = function() {
        return this._provider;
      }, o.prototype.getSource = function() {
        return this._provider.getSource();
      }, o.prototype.ensureCalculationDimension = function(i, t3) {
        var c3 = this._calcDimNameToIdx, p3 = this._dimensions, g3 = c3.get(i);
        if (g3 != null) {
          if (p3[g3].type === t3)
            return g3;
        } else
          g3 = p3.length;
        return p3[g3] = { type: t3 }, c3.set(i, g3), this._chunks[g3] = new uRe[t3 || "float"](this._rawCount), this._rawExtent[g3] = S8(), g3;
      }, o.prototype.collectOrdinalMeta = function(i, t3) {
        var c3 = this._chunks[i], p3 = this._dimensions[i], g3 = this._rawExtent, b3 = p3.ordinalOffset || 0, w3 = c3.length;
        b3 === 0 && (g3[i] = S8());
        for (var M = g3[i], I = b3; I < w3; I++) {
          var k3 = c3[I] = t3.parseAndCollect(c3[I]);
          M[0] = Math.min(k3, M[0]), M[1] = Math.max(k3, M[1]);
        }
        p3.ordinalMeta = t3, p3.ordinalOffset = w3, p3.type = "ordinal";
      }, o.prototype.getOrdinalMeta = function(i) {
        var t3 = this._dimensions[i], c3 = t3.ordinalMeta;
        return c3;
      }, o.prototype.getDimensionProperty = function(i) {
        var t3 = this._dimensions[i];
        return t3 && t3.property;
      }, o.prototype.appendData = function(i) {
        var t3 = this._provider, c3 = this.count();
        t3.appendData(i);
        var p3 = t3.count();
        return t3.persistent || (p3 += c3), c3 < p3 && this._initDataFromProvider(c3, p3, true), [c3, p3];
      }, o.prototype.appendValues = function(i, t3) {
        for (var c3 = this._chunks, p3 = this._dimensions, g3 = p3.length, b3 = this._rawExtent, w3 = this.count(), M = w3 + Math.max(i.length, t3 || 0), I = 0; I < g3; I++) {
          var k3 = p3[I];
          cRe(c3, I, k3.type, M, true);
        }
        for (var L = [], F = w3; F < M; F++)
          for (var B = F - w3, G = 0; G < g3; G++) {
            var k3 = p3[G], J = Ige.arrayRows.call(this, i[B] || L, k3.property, B, G);
            c3[G][F] = J;
            var Q = b3[G];
            J < Q[0] && (Q[0] = J), J > Q[1] && (Q[1] = J);
          }
        return this._rawCount = this._count = M, { start: w3, end: M };
      }, o.prototype._initDataFromProvider = function(i, t3, c3) {
        for (var p3 = this._provider, g3 = this._chunks, b3 = this._dimensions, w3 = b3.length, M = this._rawExtent, I = Fi(b3, function(he) {
          return he.property;
        }), k3 = 0; k3 < w3; k3++) {
          var L = b3[k3];
          M[k3] || (M[k3] = S8()), cRe(g3, k3, L.type, t3, c3);
        }
        if (p3.fillStorage)
          p3.fillStorage(i, t3, g3, M);
        else
          for (var F = [], B = i; B < t3; B++) {
            F = p3.getItem(B, F);
            for (var G = 0; G < w3; G++) {
              var J = g3[G], Q = this._dimValueGetter(F, I[G], B, G);
              J[B] = Q;
              var se = M[G];
              Q < se[0] && (se[0] = Q), Q > se[1] && (se[1] = Q);
            }
          }
        !p3.persistent && p3.clean && p3.clean(), this._rawCount = this._count = t3, this._extent = [];
      }, o.prototype.count = function() {
        return this._count;
      }, o.prototype.get = function(i, t3) {
        if (!(t3 >= 0 && t3 < this._count))
          return NaN;
        var c3 = this._chunks[i];
        return c3 ? c3[this.getRawIndex(t3)] : NaN;
      }, o.prototype.getValues = function(i, t3) {
        var c3 = [], p3 = [];
        if (t3 == null) {
          t3 = i, i = [];
          for (var g3 = 0; g3 < this._dimensions.length; g3++)
            p3.push(g3);
        } else
          p3 = i;
        for (var g3 = 0, b3 = p3.length; g3 < b3; g3++)
          c3.push(this.get(p3[g3], t3));
        return c3;
      }, o.prototype.getByRawIndex = function(i, t3) {
        if (!(t3 >= 0 && t3 < this._rawCount))
          return NaN;
        var c3 = this._chunks[i];
        return c3 ? c3[t3] : NaN;
      }, o.prototype.getSum = function(i) {
        var t3 = this._chunks[i], c3 = 0;
        if (t3)
          for (var p3 = 0, g3 = this.count(); p3 < g3; p3++) {
            var b3 = this.get(i, p3);
            isNaN(b3) || (c3 += b3);
          }
        return c3;
      }, o.prototype.getMedian = function(i) {
        var t3 = [];
        this.each([i], function(g3) {
          isNaN(g3) || t3.push(g3);
        });
        var c3 = t3.sort(function(g3, b3) {
          return g3 - b3;
        }), p3 = this.count();
        return p3 === 0 ? 0 : p3 % 2 === 1 ? c3[(p3 - 1) / 2] : (c3[p3 / 2] + c3[p3 / 2 - 1]) / 2;
      }, o.prototype.indexOfRawIndex = function(i) {
        if (i >= this._rawCount || i < 0)
          return -1;
        if (!this._indices)
          return i;
        var t3 = this._indices, c3 = t3[i];
        if (c3 != null && c3 < this._count && c3 === i)
          return i;
        for (var p3 = 0, g3 = this._count - 1; p3 <= g3; ) {
          var b3 = (p3 + g3) / 2 | 0;
          if (t3[b3] < i)
            p3 = b3 + 1;
          else if (t3[b3] > i)
            g3 = b3 - 1;
          else
            return b3;
        }
        return -1;
      }, o.prototype.indicesOfNearest = function(i, t3, c3) {
        var p3 = this._chunks, g3 = p3[i], b3 = [];
        if (!g3)
          return b3;
        c3 == null && (c3 = 1 / 0);
        for (var w3 = 1 / 0, M = -1, I = 0, k3 = 0, L = this.count(); k3 < L; k3++) {
          var F = this.getRawIndex(k3), B = t3 - g3[F], G = Math.abs(B);
          G <= c3 && ((G < w3 || G === w3 && B >= 0 && M < 0) && (w3 = G, M = B, I = 0), B === M && (b3[I++] = k3));
        }
        return b3.length = I, b3;
      }, o.prototype.getIndices = function() {
        var i, t3 = this._indices;
        if (t3) {
          var c3 = t3.constructor, p3 = this._count;
          if (c3 === Array) {
            i = new c3(p3);
            for (var g3 = 0; g3 < p3; g3++)
              i[g3] = t3[g3];
          } else
            i = new c3(t3.buffer, 0, p3);
        } else {
          var c3 = RH(this._rawCount);
          i = new c3(this.count());
          for (var g3 = 0; g3 < i.length; g3++)
            i[g3] = g3;
        }
        return i;
      }, o.prototype.filter = function(i, t3) {
        if (!this._count)
          return this;
        for (var c3 = this.clone(), p3 = c3.count(), g3 = RH(c3._rawCount), b3 = new g3(p3), w3 = [], M = i.length, I = 0, k3 = i[0], L = c3._chunks, F = 0; F < p3; F++) {
          var B = void 0, G = c3.getRawIndex(F);
          if (M === 0)
            B = t3(F);
          else if (M === 1) {
            var J = L[k3][G];
            B = t3(J, F);
          } else {
            for (var Q = 0; Q < M; Q++)
              w3[Q] = L[i[Q]][G];
            w3[Q] = F, B = t3.apply(null, w3);
          }
          B && (b3[I++] = G);
        }
        return I < p3 && (c3._indices = b3), c3._count = I, c3._extent = [], c3._updateGetRawIdx(), c3;
      }, o.prototype.selectRange = function(i) {
        var t3 = this.clone(), c3 = t3._count;
        if (!c3)
          return this;
        var p3 = Gl(i), g3 = p3.length;
        if (!g3)
          return this;
        var b3 = t3.count(), w3 = RH(t3._rawCount), M = new w3(b3), I = 0, k3 = p3[0], L = i[k3][0], F = i[k3][1], B = t3._chunks, G = false;
        if (!t3._indices) {
          var J = 0;
          if (g3 === 1) {
            for (var Q = B[p3[0]], se = 0; se < c3; se++) {
              var he = Q[se];
              (he >= L && he <= F || isNaN(he)) && (M[I++] = J), J++;
            }
            G = true;
          } else if (g3 === 2) {
            for (var Q = B[p3[0]], be = B[p3[1]], de = i[p3[1]][0], Fe = i[p3[1]][1], se = 0; se < c3; se++) {
              var he = Q[se], Pe = be[se];
              (he >= L && he <= F || isNaN(he)) && (Pe >= de && Pe <= Fe || isNaN(Pe)) && (M[I++] = J), J++;
            }
            G = true;
          }
        }
        if (!G)
          if (g3 === 1)
            for (var se = 0; se < b3; se++) {
              var ze = t3.getRawIndex(se), he = B[p3[0]][ze];
              (he >= L && he <= F || isNaN(he)) && (M[I++] = ze);
            }
          else
            for (var se = 0; se < b3; se++) {
              for (var $e = true, ze = t3.getRawIndex(se), Ke = 0; Ke < g3; Ke++) {
                var nt = p3[Ke], he = B[nt][ze];
                (he < i[nt][0] || he > i[nt][1]) && ($e = false);
              }
              $e && (M[I++] = t3.getRawIndex(se));
            }
        return I < b3 && (t3._indices = M), t3._count = I, t3._extent = [], t3._updateGetRawIdx(), t3;
      }, o.prototype.map = function(i, t3) {
        var c3 = this.clone(i);
        return this._updateDims(c3, i, t3), c3;
      }, o.prototype.modify = function(i, t3) {
        this._updateDims(this, i, t3);
      }, o.prototype._updateDims = function(i, t3, c3) {
        for (var p3 = i._chunks, g3 = [], b3 = t3.length, w3 = i.count(), M = [], I = i._rawExtent, k3 = 0; k3 < t3.length; k3++)
          I[t3[k3]] = S8();
        for (var L = 0; L < w3; L++) {
          for (var F = i.getRawIndex(L), B = 0; B < b3; B++)
            M[B] = p3[t3[B]][F];
          M[b3] = L;
          var G = c3 && c3.apply(null, M);
          if (G != null) {
            typeof G != "object" && (g3[0] = G, G = g3);
            for (var k3 = 0; k3 < G.length; k3++) {
              var J = t3[k3], Q = G[k3], se = I[J], he = p3[J];
              he && (he[F] = Q), Q < se[0] && (se[0] = Q), Q > se[1] && (se[1] = Q);
            }
          }
        }
      }, o.prototype.lttbDownSample = function(i, t3) {
        var c3 = this.clone([i], true), p3 = c3._chunks, g3 = p3[i], b3 = this.count(), w3 = 0, M = Math.floor(1 / t3), I = this.getRawIndex(0), k3, L, F, B = new (RH(this._rawCount))(Math.min((Math.ceil(b3 / M) + 2) * 2, b3));
        B[w3++] = I;
        for (var G = 1; G < b3 - 1; G += M) {
          for (var J = Math.min(G + M, b3 - 1), Q = Math.min(G + M * 2, b3), se = (Q + J) / 2, he = 0, be = J; be < Q; be++) {
            var de = this.getRawIndex(be), Fe = g3[de];
            isNaN(Fe) || (he += Fe);
          }
          he /= Q - J;
          var Pe = G, ze = Math.min(G + M, b3), $e = G - 1, Ke = g3[I];
          k3 = -1, F = Pe;
          for (var nt = -1, lt2 = 0, be = Pe; be < ze; be++) {
            var de = this.getRawIndex(be), Fe = g3[de];
            if (isNaN(Fe)) {
              lt2++, nt < 0 && (nt = de);
              continue;
            }
            L = Math.abs(($e - se) * (Fe - Ke) - ($e - be) * (he - Ke)), L > k3 && (k3 = L, F = de);
          }
          lt2 > 0 && lt2 < ze - Pe && (B[w3++] = Math.min(nt, F), F = Math.max(nt, F)), B[w3++] = F, I = F;
        }
        return B[w3++] = this.getRawIndex(b3 - 1), c3._count = w3, c3._indices = B, c3.getRawIndex = this._getRawIdx, c3;
      }, o.prototype.downSample = function(i, t3, c3, p3) {
        for (var g3 = this.clone([i], true), b3 = g3._chunks, w3 = [], M = Math.floor(1 / t3), I = b3[i], k3 = this.count(), L = g3._rawExtent[i] = S8(), F = new (RH(this._rawCount))(Math.ceil(k3 / M)), B = 0, G = 0; G < k3; G += M) {
          M > k3 - G && (M = k3 - G, w3.length = M);
          for (var J = 0; J < M; J++) {
            var Q = this.getRawIndex(G + J);
            w3[J] = I[Q];
          }
          var se = c3(w3), he = this.getRawIndex(Math.min(G + p3(w3, se) || 0, k3 - 1));
          I[he] = se, se < L[0] && (L[0] = se), se > L[1] && (L[1] = se), F[B++] = he;
        }
        return g3._count = B, g3._indices = F, g3._updateGetRawIdx(), g3;
      }, o.prototype.each = function(i, t3) {
        if (this._count)
          for (var c3 = i.length, p3 = this._chunks, g3 = 0, b3 = this.count(); g3 < b3; g3++) {
            var w3 = this.getRawIndex(g3);
            switch (c3) {
              case 0:
                t3(g3);
                break;
              case 1:
                t3(p3[i[0]][w3], g3);
                break;
              case 2:
                t3(p3[i[0]][w3], p3[i[1]][w3], g3);
                break;
              default:
                for (var M = 0, I = []; M < c3; M++)
                  I[M] = p3[i[M]][w3];
                I[M] = g3, t3.apply(null, I);
            }
          }
      }, o.prototype.getDataExtent = function(i) {
        var t3 = this._chunks[i], c3 = S8();
        if (!t3)
          return c3;
        var p3 = this.count(), g3 = !this._indices, b3;
        if (g3)
          return this._rawExtent[i].slice();
        if (b3 = this._extent[i], b3)
          return b3.slice();
        b3 = c3;
        for (var w3 = b3[0], M = b3[1], I = 0; I < p3; I++) {
          var k3 = this.getRawIndex(I), L = t3[k3];
          L < w3 && (w3 = L), L > M && (M = L);
        }
        return b3 = [w3, M], this._extent[i] = b3, b3;
      }, o.prototype.getRawDataItem = function(i) {
        var t3 = this.getRawIndex(i);
        if (this._provider.persistent)
          return this._provider.getItem(t3);
        for (var c3 = [], p3 = this._chunks, g3 = 0; g3 < p3.length; g3++)
          c3.push(p3[g3][t3]);
        return c3;
      }, o.prototype.clone = function(i, t3) {
        var c3 = new o(), p3 = this._chunks, g3 = i && aw(i, function(w3, M) {
          return w3[M] = true, w3;
        }, {});
        if (g3)
          for (var b3 = 0; b3 < p3.length; b3++)
            c3._chunks[b3] = g3[b3] ? eyt(p3[b3]) : p3[b3];
        else
          c3._chunks = p3;
        return this._copyCommonProps(c3), t3 || (c3._indices = this._cloneIndices()), c3._updateGetRawIdx(), c3;
      }, o.prototype._copyCommonProps = function(i) {
        i._count = this._count, i._rawCount = this._rawCount, i._provider = this._provider, i._dimensions = this._dimensions, i._extent = Jo(this._extent), i._rawExtent = Jo(this._rawExtent);
      }, o.prototype._cloneIndices = function() {
        if (this._indices) {
          var i = this._indices.constructor, t3 = void 0;
          if (i === Array) {
            var c3 = this._indices.length;
            t3 = new i(c3);
            for (var p3 = 0; p3 < c3; p3++)
              t3[p3] = this._indices[p3];
          } else
            t3 = new i(this._indices);
          return t3;
        }
        return null;
      }, o.prototype._getRawIdxIdentity = function(i) {
        return i;
      }, o.prototype._getRawIdx = function(i) {
        return i < this._count && i >= 0 ? this._indices[i] : -1;
      }, o.prototype._updateGetRawIdx = function() {
        this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
      }, o.internalField = function() {
        function i(t3, c3, p3, g3) {
          return ok(t3[g3], this._dimensions[g3]);
        }
        Ige = { arrayRows: i, objectRows: function(t3, c3, p3, g3) {
          return ok(t3[c3], this._dimensions[g3]);
        }, keyedColumns: i, original: function(t3, c3, p3, g3) {
          var b3 = t3 && (t3.value == null ? t3 : t3.value);
          return ok(b3 instanceof Array ? b3[g3] : b3, this._dimensions[g3]);
        }, typedArray: function(t3, c3, p3, g3) {
          return t3[g3];
        } };
      }(), o;
    }(), fRe = function() {
      function o(i) {
        this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = i;
      }
      return o.prototype.dirty = function() {
        this._setLocalSource([], []), this._storeList = [], this._dirty = true;
      }, o.prototype._setLocalSource = function(i, t3) {
        this._sourceList = i, this._upstreamSignList = t3, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
      }, o.prototype._getVersionSign = function() {
        return this._sourceHost.uid + "_" + this._versionSignBase;
      }, o.prototype.prepareSource = function() {
        this._isDirty() && (this._createSource(), this._dirty = false);
      }, o.prototype._createSource = function() {
        this._setLocalSource([], []);
        var i = this._sourceHost, t3 = this._getUpstreamSourceManagers(), c3 = !!t3.length, p3, g3;
        if (bte(i)) {
          var b3 = i, w3 = void 0, M = void 0, I = void 0;
          if (c3) {
            var k3 = t3[0];
            k3.prepareSource(), I = k3.getSource(), w3 = I.data, M = I.sourceFormat, g3 = [k3._getVersionSign()];
          } else
            w3 = b3.get("data", true), M = w1(w3) ? ak : Ew, g3 = [];
          var L = this._getSourceMetaRawOption() || {}, F = I && I.metaRawOption || {}, B = Xs(L.seriesLayoutBy, F.seriesLayoutBy) || null, G = Xs(L.sourceHeader, F.sourceHeader), J = Xs(L.dimensions, F.dimensions), Q = B !== F.seriesLayoutBy || !!G != !!F.sourceHeader || J;
          p3 = Q ? [wge(w3, { seriesLayoutBy: B, sourceHeader: G, dimensions: J }, M)] : [];
        } else {
          var se = i;
          if (c3) {
            var he = this._applyTransform(t3);
            p3 = he.sourceList, g3 = he.upstreamSignList;
          } else {
            var be = se.get("source", true);
            p3 = [wge(be, this._getSourceMetaRawOption(), null)], g3 = [];
          }
        }
        this._setLocalSource(p3, g3);
      }, o.prototype._applyTransform = function(i) {
        var t3 = this._sourceHost, c3 = t3.get("transform", true), p3 = t3.get("fromTransformResult", true);
        if (p3 != null) {
          var g3 = "";
          i.length !== 1 && pRe(g3);
        }
        var b3, w3 = [], M = [];
        return yt(i, function(I) {
          I.prepareSource();
          var k3 = I.getSource(p3 || 0), L = "";
          p3 != null && !k3 && pRe(L), w3.push(k3), M.push(I._getVersionSign());
        }), c3 ? b3 = K0t(c3, w3, { datasetIndex: t3.componentIndex }) : p3 != null && (b3 = [k0t(w3[0])]), { sourceList: b3, upstreamSignList: M };
      }, o.prototype._isDirty = function() {
        if (this._dirty)
          return true;
        for (var i = this._getUpstreamSourceManagers(), t3 = 0; t3 < i.length; t3++) {
          var c3 = i[t3];
          if (c3._isDirty() || this._upstreamSignList[t3] !== c3._getVersionSign())
            return true;
        }
      }, o.prototype.getSource = function(i) {
        i = i || 0;
        var t3 = this._sourceList[i];
        if (!t3) {
          var c3 = this._getUpstreamSourceManagers();
          return c3[0] && c3[0].getSource(i);
        }
        return t3;
      }, o.prototype.getSharedDataStore = function(i) {
        var t3 = i.makeStoreSchema();
        return this._innerGetDataStore(t3.dimensions, i.source, t3.hash);
      }, o.prototype._innerGetDataStore = function(i, t3, c3) {
        var p3 = 0, g3 = this._storeList, b3 = g3[p3];
        b3 || (b3 = g3[p3] = {});
        var w3 = b3[c3];
        if (!w3) {
          var M = this._getUpstreamSourceManagers()[0];
          bte(this._sourceHost) && M ? w3 = M._innerGetDataStore(i, t3, c3) : (w3 = new Ege(), w3.initData(new YLe(t3, i.length), i)), b3[c3] = w3;
        }
        return w3;
      }, o.prototype._getUpstreamSourceManagers = function() {
        var i = this._sourceHost;
        if (bte(i)) {
          var t3 = dge(i);
          return t3 ? [t3.getSourceManager()] : [];
        } else
          return Fi(r0t(i), function(c3) {
            return c3.getSourceManager();
          });
      }, o.prototype._getSourceMetaRawOption = function() {
        var i = this._sourceHost, t3, c3, p3;
        if (bte(i))
          t3 = i.get("seriesLayoutBy", true), c3 = i.get("sourceHeader", true), p3 = i.get("dimensions", true);
        else if (!this._getUpstreamSourceManagers().length) {
          var g3 = i;
          t3 = g3.get("seriesLayoutBy", true), c3 = g3.get("sourceHeader", true), p3 = g3.get("dimensions", true);
        }
        return { seriesLayoutBy: t3, sourceHeader: c3, dimensions: p3 };
      }, o;
    }();
    function hRe(o) {
      var i = o.option.transform;
      i && vP(o.option.transform);
    }
    function bte(o) {
      return o.mainType === "series";
    }
    function pRe(o) {
      throw new Error(o);
    }
    var dRe = "line-height:1";
    function vRe(o, i) {
      var t3 = o.color || "#6e7079", c3 = o.fontSize || 12, p3 = o.fontWeight || "400", g3 = o.color || "#464646", b3 = o.fontSize || 14, w3 = o.fontWeight || "900";
      return i === "html" ? { nameStyle: "font-size:" + L_(c3 + "") + "px;color:" + L_(t3) + ";font-weight:" + L_(p3 + ""), valueStyle: "font-size:" + L_(b3 + "") + "px;color:" + L_(g3) + ";font-weight:" + L_(w3 + "") } : { nameStyle: { fontSize: c3, fill: t3, fontWeight: p3 }, valueStyle: { fontSize: b3, fill: g3, fontWeight: w3 } };
    }
    var tyt = [0, 10, 20, 30], nyt = ["", `
`, `

`, `


`];
    function Cg(o, i) {
      return i.type = o, i;
    }
    function Dge(o) {
      return o.type === "section";
    }
    function gRe(o) {
      return Dge(o) ? ryt : iyt;
    }
    function yRe(o) {
      if (Dge(o)) {
        var i = 0, t3 = o.blocks.length, c3 = t3 > 1 || t3 > 0 && !o.noHeader;
        return yt(o.blocks, function(p3) {
          var g3 = yRe(p3);
          g3 >= i && (i = g3 + +(c3 && (!g3 || Dge(p3) && !p3.noHeader)));
        }), i;
      }
      return 0;
    }
    function ryt(o, i, t3, c3) {
      var p3 = i.noHeader, g3 = ayt(yRe(i)), b3 = [], w3 = i.blocks || [];
      u0(!w3 || Ei(w3)), w3 = w3 || [];
      var M = o.orderMode;
      if (i.sortBlocks && M) {
        w3 = w3.slice();
        var I = { valueAsc: "asc", valueDesc: "desc" };
        if (so(I, M)) {
          var k3 = new aRe(I[M], null);
          w3.sort(function(G, J) {
            return k3.evaluate(G.sortParam, J.sortParam);
          });
        } else
          M === "seriesDesc" && w3.reverse();
      }
      yt(w3, function(G, J) {
        var Q = i.valueFormatter, se = gRe(G)(Q ? ti(ti({}, o), { valueFormatter: Q }) : o, G, J > 0 ? g3.html : 0, c3);
        se != null && b3.push(se);
      });
      var L = o.renderMode === "richText" ? b3.join(g3.richText) : kge(b3.join(""), p3 ? t3 : g3.html);
      if (p3)
        return L;
      var F = cge(i.header, "ordinal", o.useUTC), B = vRe(c3, o.renderMode).nameStyle;
      return o.renderMode === "richText" ? bRe(o, F, B) + g3.richText + L : kge('<div style="' + B + ";" + dRe + ';">' + L_(F) + "</div>" + L, t3);
    }
    function iyt(o, i, t3, c3) {
      var p3 = o.renderMode, g3 = i.noName, b3 = i.noValue, w3 = !i.markerType, M = i.name, I = o.useUTC, k3 = i.valueFormatter || o.valueFormatter || function(de) {
        return de = Ei(de) ? de : [de], Fi(de, function(Fe, Pe) {
          return cge(Fe, Ei(B) ? B[Pe] : B, I);
        });
      };
      if (!(g3 && b3)) {
        var L = w3 ? "" : o.markupStyleCreator.makeTooltipMarker(i.markerType, i.markerColor || "#333", p3), F = g3 ? "" : cge(M, "ordinal", I), B = i.valueType, G = b3 ? [] : k3(i.value), J = !w3 || !g3, Q = !w3 && g3, se = vRe(c3, p3), he = se.nameStyle, be = se.valueStyle;
        return p3 === "richText" ? (w3 ? "" : L) + (g3 ? "" : bRe(o, F, he)) + (b3 ? "" : lyt(o, G, J, Q, be)) : kge((w3 ? "" : L) + (g3 ? "" : oyt(F, !w3, he)) + (b3 ? "" : syt(G, J, Q, be)), t3);
      }
    }
    function mRe(o, i, t3, c3, p3, g3) {
      if (o) {
        var b3 = gRe(o), w3 = { useUTC: p3, renderMode: t3, orderMode: c3, markupStyleCreator: i, valueFormatter: o.valueFormatter };
        return b3(w3, o, 0, g3);
      }
    }
    function ayt(o) {
      return { html: tyt[o], richText: nyt[o] };
    }
    function kge(o, i) {
      var t3 = '<div style="clear:both"></div>', c3 = "margin: " + i + "px 0 0";
      return '<div style="' + c3 + ";" + dRe + ';">' + o + t3 + "</div>";
    }
    function oyt(o, i, t3) {
      var c3 = i ? "margin-left:2px" : "";
      return '<span style="' + t3 + ";" + c3 + '">' + L_(o) + "</span>";
    }
    function syt(o, i, t3, c3) {
      var p3 = t3 ? "10px" : "20px", g3 = i ? "float:right;margin-left:" + p3 : "";
      return o = Ei(o) ? o : [o], '<span style="' + g3 + ";" + c3 + '">' + Fi(o, function(b3) {
        return L_(b3);
      }).join("&nbsp;&nbsp;") + "</span>";
    }
    function bRe(o, i, t3) {
      return o.markupStyleCreator.wrapRichTextStyle(i, t3);
    }
    function lyt(o, i, t3, c3, p3) {
      var g3 = [p3], b3 = c3 ? 10 : 20;
      return t3 && g3.push({ padding: [0, 0, 0, b3], align: "right" }), o.markupStyleCreator.wrapRichTextStyle(Ei(i) ? i.join("  ") : i, g3);
    }
    function _Re(o, i) {
      var t3 = o.getData().getItemVisual(i, "style"), c3 = t3[o.visualDrawType];
      return nL(c3);
    }
    function xRe(o, i) {
      var t3 = o.get("padding");
      return t3 != null ? t3 : i === "richText" ? [8, 10] : 10;
    }
    var Oge = function() {
      function o() {
        this.richTextStyles = {}, this._nextStyleNameId = RF();
      }
      return o.prototype._generateStyleName = function() {
        return "__EC_aUTo_" + this._nextStyleNameId++;
      }, o.prototype.makeTooltipMarker = function(i, t3, c3) {
        var p3 = c3 === "richText" ? this._generateStyleName() : null, g3 = Kgt({ color: t3, type: i, renderMode: c3, markerId: p3 });
        return Ha(g3) ? g3 : (this.richTextStyles[p3] = g3.style, g3.content);
      }, o.prototype.wrapRichTextStyle = function(i, t3) {
        var c3 = {};
        Ei(t3) ? yt(t3, function(g3) {
          return ti(c3, g3);
        }) : ti(c3, t3);
        var p3 = this._generateStyleName();
        return this.richTextStyles[p3] = c3, "{" + p3 + "|" + i + "}";
      }, o;
    }();
    function wRe(o) {
      var i = o.series, t3 = o.dataIndex, c3 = o.multipleSeries, p3 = i.getData(), g3 = p3.mapDimensionsAll("defaultedTooltip"), b3 = g3.length, w3 = i.getRawValue(t3), M = Ei(w3), I = _Re(i, t3), k3, L, F, B;
      if (b3 > 1 || M && !b3) {
        var G = uyt(w3, i, t3, g3, I);
        k3 = G.inlineValues, L = G.inlineValueTypes, F = G.blocks, B = G.inlineValues[0];
      } else if (b3) {
        var J = p3.getDimensionInfo(g3[0]);
        B = k3 = w8(p3, t3, g3[0]), L = J.type;
      } else
        B = k3 = M ? w3[0] : w3;
      var Q = wg(i), se = Q && i.name || "", he = p3.getName(t3), be = c3 ? se : he;
      return Cg("section", { header: se, noHeader: c3 || !Q, sortParam: B, blocks: [Cg("nameValue", { markerType: "item", markerColor: I, name: be, noName: !S1(be), value: k3, valueType: L })].concat(F || []) });
    }
    function uyt(o, i, t3, c3, p3) {
      var g3 = i.getData(), b3 = aw(o, function(L, F, B) {
        var G = g3.getDimensionInfo(B);
        return L = L || G && G.tooltip !== false && G.displayName != null;
      }, false), w3 = [], M = [], I = [];
      c3.length ? yt(c3, function(L) {
        k3(w8(g3, t3, L), L);
      }) : yt(o, k3);
      function k3(L, F) {
        var B = g3.getDimensionInfo(F);
        !B || B.otherDims.tooltip === false || (b3 ? I.push(Cg("nameValue", { markerType: "subItem", markerColor: p3, name: B.displayName, value: L, valueType: B.type })) : (w3.push(L), M.push(B.type)));
      }
      return { inlineValues: w3, inlineValueTypes: M, blocks: I };
    }
    var sk = mu();
    function _te(o, i) {
      return o.getName(i) || o.getId(i);
    }
    var xte = "__universalTransitionEnabled", wte = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3._selectedDataIndicesMap = {}, t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        this.seriesIndex = this.componentIndex, this.dataTask = LH({ count: fyt, reset: hyt }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(t3, p3);
        var g3 = sk(this).sourceManager = new fRe(this);
        g3.prepareSource();
        var b3 = this.getInitialData(t3, p3);
        CRe(b3, this), this.dataTask.context.data = b3, sk(this).dataBeforeProcessed = b3, SRe(this), this._initSelectedMapFromData(b3);
      }, i.prototype.mergeDefaultAndTheme = function(t3, c3) {
        var p3 = IH(this), g3 = p3 ? m8(t3) : {}, b3 = this.subType;
        nc.hasClass(b3) && (b3 += "Series"), Es(t3, c3.getTheme().get(this.subType)), Es(t3, this.getDefaultOption()), O1(t3, "label", ["show"]), this.fillDataTextStyle(t3.data), p3 && ik(t3, g3, p3);
      }, i.prototype.mergeOption = function(t3, c3) {
        t3 = Es(this.option, t3, true), this.fillDataTextStyle(t3.data);
        var p3 = IH(this);
        p3 && ik(this.option, t3, p3);
        var g3 = sk(this).sourceManager;
        g3.dirty(), g3.prepareSource();
        var b3 = this.getInitialData(t3, c3);
        CRe(b3, this), this.dataTask.dirty(), this.dataTask.context.data = b3, sk(this).dataBeforeProcessed = b3, SRe(this), this._initSelectedMapFromData(b3);
      }, i.prototype.fillDataTextStyle = function(t3) {
        if (t3 && !w1(t3))
          for (var c3 = ["show"], p3 = 0; p3 < t3.length; p3++)
            t3[p3] && t3[p3].label && O1(t3[p3], "label", c3);
      }, i.prototype.getInitialData = function(t3, c3) {
      }, i.prototype.appendData = function(t3) {
        var c3 = this.getRawData();
        c3.appendData(t3.data);
      }, i.prototype.getData = function(t3) {
        var c3 = Pge(this);
        if (c3) {
          var p3 = c3.context.data;
          return t3 == null ? p3 : p3.getLinkedData(t3);
        } else
          return sk(this).data;
      }, i.prototype.getAllData = function() {
        var t3 = this.getData();
        return t3 && t3.getLinkedDataAll ? t3.getLinkedDataAll() : [{ data: t3 }];
      }, i.prototype.setData = function(t3) {
        var c3 = Pge(this);
        if (c3) {
          var p3 = c3.context;
          p3.outputData = t3, c3 !== this.dataTask && (p3.data = t3);
        }
        sk(this).data = t3;
      }, i.prototype.getEncode = function() {
        var t3 = this.get("encode", true);
        if (t3)
          return Eo(t3);
      }, i.prototype.getSourceManager = function() {
        return sk(this).sourceManager;
      }, i.prototype.getSource = function() {
        return this.getSourceManager().getSource();
      }, i.prototype.getRawData = function() {
        return sk(this).dataBeforeProcessed;
      }, i.prototype.getColorBy = function() {
        var t3 = this.get("colorBy");
        return t3 || "series";
      }, i.prototype.isColorBySeries = function() {
        return this.getColorBy() === "series";
      }, i.prototype.getBaseAxis = function() {
        var t3 = this.coordinateSystem;
        return t3 && t3.getBaseAxis && t3.getBaseAxis();
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        return wRe({ series: this, dataIndex: t3, multipleSeries: c3 });
      }, i.prototype.isAnimationEnabled = function() {
        var t3 = this.ecModel;
        if (yo.node && !(t3 && t3.ssr))
          return false;
        var c3 = this.getShallow("animation");
        return c3 && this.getData().count() > this.getShallow("animationThreshold") && (c3 = false), !!c3;
      }, i.prototype.restoreData = function() {
        this.dataTask.dirty();
      }, i.prototype.getColorFromPalette = function(t3, c3, p3) {
        var g3 = this.ecModel, b3 = gge.prototype.getColorFromPalette.call(this, t3, c3, p3);
        return b3 || (b3 = g3.getColorFromPalette(t3, c3, p3)), b3;
      }, i.prototype.coordDimToDataDim = function(t3) {
        return this.getRawData().mapDimensionsAll(t3);
      }, i.prototype.getProgressive = function() {
        return this.get("progressive");
      }, i.prototype.getProgressiveThreshold = function() {
        return this.get("progressiveThreshold");
      }, i.prototype.select = function(t3, c3) {
        this._innerSelect(this.getData(c3), t3);
      }, i.prototype.unselect = function(t3, c3) {
        var p3 = this.option.selectedMap;
        if (p3) {
          var g3 = this.option.selectedMode, b3 = this.getData(c3);
          if (g3 === "series" || p3 === "all") {
            this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
            return;
          }
          for (var w3 = 0; w3 < t3.length; w3++) {
            var M = t3[w3], I = _te(b3, M);
            p3[I] = false, this._selectedDataIndicesMap[I] = -1;
          }
        }
      }, i.prototype.toggleSelect = function(t3, c3) {
        for (var p3 = [], g3 = 0; g3 < t3.length; g3++)
          p3[0] = t3[g3], this.isSelected(t3[g3], c3) ? this.unselect(p3, c3) : this.select(p3, c3);
      }, i.prototype.getSelectedDataIndices = function() {
        if (this.option.selectedMap === "all")
          return [].slice.call(this.getData().getIndices());
        for (var t3 = this._selectedDataIndicesMap, c3 = Gl(t3), p3 = [], g3 = 0; g3 < c3.length; g3++) {
          var b3 = t3[c3[g3]];
          b3 >= 0 && p3.push(b3);
        }
        return p3;
      }, i.prototype.isSelected = function(t3, c3) {
        var p3 = this.option.selectedMap;
        if (!p3)
          return false;
        var g3 = this.getData(c3);
        return (p3 === "all" || p3[_te(g3, t3)]) && !g3.getItemModel(t3).get(["select", "disabled"]);
      }, i.prototype.isUniversalTransitionEnabled = function() {
        if (this[xte])
          return true;
        var t3 = this.option.universalTransition;
        return t3 ? t3 === true ? true : t3 && t3.enabled : false;
      }, i.prototype._innerSelect = function(t3, c3) {
        var p3, g3, b3 = this.option, w3 = b3.selectedMode, M = c3.length;
        if (!(!w3 || !M)) {
          if (w3 === "series")
            b3.selectedMap = "all";
          else if (w3 === "multiple") {
            Ua(b3.selectedMap) || (b3.selectedMap = {});
            for (var I = b3.selectedMap, k3 = 0; k3 < M; k3++) {
              var L = c3[k3], F = _te(t3, L);
              I[F] = true, this._selectedDataIndicesMap[F] = t3.getRawIndex(L);
            }
          } else if (w3 === "single" || w3 === true) {
            var B = c3[M - 1], F = _te(t3, B);
            b3.selectedMap = (p3 = {}, p3[F] = true, p3), this._selectedDataIndicesMap = (g3 = {}, g3[F] = t3.getRawIndex(B), g3);
          }
        }
      }, i.prototype._initSelectedMapFromData = function(t3) {
        if (!this.option.selectedMap) {
          var c3 = [];
          t3.hasItemOption && t3.each(function(p3) {
            var g3 = t3.getRawDataItem(p3);
            g3 && g3.selected && c3.push(p3);
          }), c3.length > 0 && this._innerSelect(t3, c3);
        }
      }, i.registerClass = function(t3) {
        return nc.registerClass(t3);
      }, i.protoInitialize = function() {
        var t3 = i.prototype;
        t3.type = "series.__base__", t3.seriesIndex = 0, t3.ignoreStyleOnData = false, t3.hasSymbolVisual = false, t3.defaultSymbol = "circle", t3.visualStyleAccessPath = "itemStyle", t3.visualDrawType = "fill";
      }(), i;
    }(nc);
    Kp(wte, Tge), Kp(wte, gge), DG(wte, nc);
    function SRe(o) {
      var i = o.name;
      wg(o) || (o.name = cyt(o) || i);
    }
    function cyt(o) {
      var i = o.getRawData(), t3 = i.mapDimensionsAll("seriesName"), c3 = [];
      return yt(t3, function(p3) {
        var g3 = i.getDimensionInfo(p3);
        g3.displayName && c3.push(g3.displayName);
      }), c3.join(" ");
    }
    function fyt(o) {
      return o.model.getRawData().count();
    }
    function hyt(o) {
      var i = o.model;
      return i.setData(i.getRawData().cloneShallow()), pyt;
    }
    function pyt(o, i) {
      i.outputData && o.end > i.outputData.count() && i.model.getRawData().cloneShallow(i.outputData);
    }
    function CRe(o, i) {
      yt(iF(o.CHANGABLE_METHODS, o.DOWNSAMPLE_METHODS), function(t3) {
        o.wrapMethod(t3, As(dyt, i));
      });
    }
    function dyt(o, i) {
      var t3 = Pge(o);
      return t3 && t3.setOutputEnd((i || this).count()), i;
    }
    function Pge(o) {
      var i = (o.ecModel || {}).scheduler, t3 = i && i.getPipeline(o.uid);
      if (t3) {
        var c3 = t3.currentTask;
        if (c3) {
          var p3 = c3.agentStubMap;
          p3 && (c3 = p3.get(o.uid));
        }
        return c3;
      }
    }
    var bp = wte, Lge = function() {
      function o() {
        this.group = new vs(), this.uid = d8("viewComponent");
      }
      return o.prototype.init = function(i, t3) {
      }, o.prototype.render = function(i, t3, c3, p3) {
      }, o.prototype.dispose = function(i, t3) {
      }, o.prototype.updateView = function(i, t3, c3, p3) {
      }, o.prototype.updateLayout = function(i, t3, c3, p3) {
      }, o.prototype.updateVisual = function(i, t3, c3, p3) {
      }, o.prototype.blurSeries = function(i, t3) {
      }, o.prototype.eachRendered = function(i) {
        var t3 = this.group;
        t3 && t3.traverse(i);
      }, o;
    }();
    H2(Lge), BF(Lge);
    var ed = Lge;
    function C8() {
      var o = mu();
      return function(i) {
        var t3 = o(i), c3 = i.pipelineContext, p3 = !!t3.large, g3 = !!t3.progressiveRender, b3 = t3.large = !!(c3 && c3.large), w3 = t3.progressiveRender = !!(c3 && c3.progressiveRender);
        return (p3 !== b3 || g3 !== w3) && "reset";
      };
    }
    var MRe = mu(), vyt = C8(), Rge = function() {
      function o() {
        this.group = new vs(), this.uid = d8("viewChart"), this.renderTask = LH({ plan: gyt, reset: yyt }), this.renderTask.context = { view: this };
      }
      return o.prototype.init = function(i, t3) {
      }, o.prototype.render = function(i, t3, c3, p3) {
      }, o.prototype.highlight = function(i, t3, c3, p3) {
        var g3 = i.getData(p3 && p3.dataType);
        !g3 || ARe(g3, p3, "emphasis");
      }, o.prototype.downplay = function(i, t3, c3, p3) {
        var g3 = i.getData(p3 && p3.dataType);
        !g3 || ARe(g3, p3, "normal");
      }, o.prototype.remove = function(i, t3) {
        this.group.removeAll();
      }, o.prototype.dispose = function(i, t3) {
      }, o.prototype.updateView = function(i, t3, c3, p3) {
        this.render(i, t3, c3, p3);
      }, o.prototype.updateLayout = function(i, t3, c3, p3) {
        this.render(i, t3, c3, p3);
      }, o.prototype.updateVisual = function(i, t3, c3, p3) {
        this.render(i, t3, c3, p3);
      }, o.prototype.eachRendered = function(i) {
        nk(this.group, i);
      }, o.markUpdateMethod = function(i, t3) {
        MRe(i).updateMethod = t3;
      }, o.protoInitialize = function() {
        var i = o.prototype;
        i.type = "chart";
      }(), o;
    }();
    function TRe(o, i, t3) {
      o && DI(o) && (i === "emphasis" ? Hv : sl)(o, t3);
    }
    function ARe(o, i, t3) {
      var c3 = k_(o, i), p3 = i && i.highlightKey != null ? Tve(i.highlightKey) : null;
      c3 != null ? yt(Wc(c3), function(g3) {
        TRe(o.getItemGraphicEl(g3), t3, p3);
      }) : o.eachItemGraphicEl(function(g3) {
        TRe(g3, t3, p3);
      });
    }
    H2(Rge), BF(Rge);
    function gyt(o) {
      return vyt(o.model);
    }
    function yyt(o) {
      var i = o.model, t3 = o.ecModel, c3 = o.api, p3 = o.payload, g3 = i.pipelineContext.progressiveRender, b3 = o.view, w3 = p3 && MRe(p3).updateMethod, M = g3 ? "incrementalPrepareRender" : w3 && b3[w3] ? w3 : "render";
      return M !== "render" && b3[M](i, t3, c3, p3), myt[M];
    }
    var myt = { incrementalPrepareRender: { progress: function(o, i) {
      i.view.incrementalRender(o, i.model, i.ecModel, i.api, i.payload);
    } }, render: { forceFirstProgress: true, progress: function(o, i) {
      i.view.render(i.model, i.ecModel, i.api, i.payload);
    } } }, yh = Rge, Ste = "\0__throttleOriginMethod", IRe = "\0__throttleRate", ERe = "\0__throttleType";
    function Nge(o, i, t3) {
      var c3, p3 = 0, g3 = 0, b3 = null, w3, M, I, k3;
      i = i || 0;
      function L() {
        g3 = new Date().getTime(), b3 = null, o.apply(M, I || []);
      }
      var F = function() {
        for (var B = [], G = 0; G < arguments.length; G++)
          B[G] = arguments[G];
        c3 = new Date().getTime(), M = this, I = B;
        var J = k3 || i, Q = k3 || t3;
        k3 = null, w3 = c3 - (Q ? p3 : g3) - J, clearTimeout(b3), Q ? b3 = setTimeout(L, J) : w3 >= 0 ? L() : b3 = setTimeout(L, -w3), p3 = c3;
      };
      return F.clear = function() {
        b3 && (clearTimeout(b3), b3 = null);
      }, F.debounceNextCall = function(B) {
        k3 = B;
      }, F;
    }
    function M8(o, i, t3, c3) {
      var p3 = o[i];
      if (p3) {
        var g3 = p3[Ste] || p3, b3 = p3[ERe], w3 = p3[IRe];
        if (w3 !== t3 || b3 !== c3) {
          if (t3 == null || !c3)
            return o[i] = g3;
          p3 = o[i] = Nge(g3, t3, c3 === "debounce"), p3[Ste] = g3, p3[ERe] = c3, p3[IRe] = t3;
        }
        return p3;
      }
    }
    function NH(o, i) {
      var t3 = o[i];
      t3 && t3[Ste] && (t3.clear && t3.clear(), o[i] = t3[Ste]);
    }
    var DRe = mu(), kRe = { itemStyle: mI(QPe, true), lineStyle: mI(JPe, true) }, byt = { lineStyle: "stroke", itemStyle: "fill" };
    function ORe(o, i) {
      var t3 = o.visualStyleMapper || kRe[i];
      return t3 || (console.warn("Unkown style type '" + i + "'."), kRe.itemStyle);
    }
    function PRe(o, i) {
      var t3 = o.visualDrawType || byt[i];
      return t3 || (console.warn("Unkown style type '" + i + "'."), "fill");
    }
    var _yt = { createOnAllSeries: true, performRawSeries: true, reset: function(o, i) {
      var t3 = o.getData(), c3 = o.visualStyleAccessPath || "itemStyle", p3 = o.getModel(c3), g3 = ORe(o, c3), b3 = g3(p3), w3 = p3.getShallow("decal");
      w3 && (t3.setVisual("decal", w3), w3.dirty = true);
      var M = PRe(o, c3), I = b3[M], k3 = Vo(I) ? I : null, L = b3.fill === "auto" || b3.stroke === "auto";
      if (!b3[M] || k3 || L) {
        var F = o.getColorFromPalette(o.name, null, i.getSeriesCount());
        b3[M] || (b3[M] = F, t3.setVisual("colorFromPalette", true)), b3.fill = b3.fill === "auto" || Vo(b3.fill) ? F : b3.fill, b3.stroke = b3.stroke === "auto" || Vo(b3.stroke) ? F : b3.stroke;
      }
      if (t3.setVisual("style", b3), t3.setVisual("drawType", M), !i.isSeriesFiltered(o) && k3)
        return t3.setVisual("colorFromPalette", false), { dataEach: function(B, G) {
          var J = o.getDataParams(G), Q = ti({}, b3);
          Q[M] = k3(J), B.setItemVisual(G, "style", Q);
        } };
    } }, FH = new gh(), xyt = { createOnAllSeries: true, performRawSeries: true, reset: function(o, i) {
      if (!(o.ignoreStyleOnData || i.isSeriesFiltered(o))) {
        var t3 = o.getData(), c3 = o.visualStyleAccessPath || "itemStyle", p3 = ORe(o, c3), g3 = t3.getVisual("drawType");
        return { dataEach: t3.hasItemOption ? function(b3, w3) {
          var M = b3.getRawDataItem(w3);
          if (M && M[c3]) {
            FH.option = M[c3];
            var I = p3(FH), k3 = b3.ensureUniqueItemVisual(w3, "style");
            ti(k3, I), FH.option.decal && (b3.setItemVisual(w3, "decal", FH.option.decal), FH.option.decal.dirty = true), g3 in I && b3.setItemVisual(w3, "colorFromPalette", false);
          }
        } : null };
      }
    } }, wyt = { performRawSeries: true, overallReset: function(o) {
      var i = Eo();
      o.eachSeries(function(t3) {
        var c3 = t3.getColorBy();
        if (!t3.isColorBySeries()) {
          var p3 = t3.type + "-" + c3, g3 = i.get(p3);
          g3 || (g3 = {}, i.set(p3, g3)), DRe(t3).scope = g3;
        }
      }), o.eachSeries(function(t3) {
        if (!(t3.isColorBySeries() || o.isSeriesFiltered(t3))) {
          var c3 = t3.getRawData(), p3 = {}, g3 = t3.getData(), b3 = DRe(t3).scope, w3 = t3.visualStyleAccessPath || "itemStyle", M = PRe(t3, w3);
          g3.each(function(I) {
            var k3 = g3.getRawIndex(I);
            p3[k3] = I;
          }), c3.each(function(I) {
            var k3 = p3[I], L = g3.getItemVisual(k3, "colorFromPalette");
            if (L) {
              var F = g3.ensureUniqueItemVisual(k3, "style"), B = c3.getName(I) || I + "", G = c3.count();
              F[M] = t3.getColorFromPalette(B, b3, G);
            }
          });
        }
      });
    } }, Cte = Math.PI;
    function Syt(o, i) {
      i = i || {}, Uo(i, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
      var t3 = new vs(), c3 = new bu({ style: { fill: i.maskColor }, zlevel: i.zlevel, z: 1e4 });
      t3.add(c3);
      var p3 = new Fl({ style: { text: i.text, fill: i.textColor, fontSize: i.fontSize, fontWeight: i.fontWeight, fontStyle: i.fontStyle, fontFamily: i.fontFamily }, zlevel: i.zlevel, z: 10001 }), g3 = new bu({ style: { fill: "none" }, textContent: p3, textConfig: { position: "right", distance: 10 }, zlevel: i.zlevel, z: 10001 });
      t3.add(g3);
      var b3;
      return i.showSpinner && (b3 = new bH({ shape: { startAngle: -Cte / 2, endAngle: -Cte / 2 + 0.1, r: i.spinnerRadius }, style: { stroke: i.color, lineCap: "round", lineWidth: i.lineWidth }, zlevel: i.zlevel, z: 10001 }), b3.animateShape(true).when(1e3, { endAngle: Cte * 3 / 2 }).start("circularInOut"), b3.animateShape(true).when(1e3, { startAngle: Cte * 3 / 2 }).delay(300).start("circularInOut"), t3.add(b3)), t3.resize = function() {
        var w3 = p3.getBoundingRect().width, M = i.showSpinner ? i.spinnerRadius : 0, I = (o.getWidth() - M * 2 - (i.showSpinner && w3 ? 10 : 0) - w3) / 2 - (i.showSpinner && w3 ? 0 : 5 + w3 / 2) + (i.showSpinner ? 0 : w3 / 2) + (w3 ? 0 : M), k3 = o.getHeight() / 2;
        i.showSpinner && b3.setShape({ cx: I, cy: k3 }), g3.setShape({ x: I - M, y: k3 - M, width: M * 2, height: M * 2 }), c3.setShape({ x: 0, y: 0, width: o.getWidth(), height: o.getHeight() });
      }, t3.resize(), t3;
    }
    var Cyt = function() {
      function o(i, t3, c3, p3) {
        this._stageTaskMap = Eo(), this.ecInstance = i, this.api = t3, c3 = this._dataProcessorHandlers = c3.slice(), p3 = this._visualHandlers = p3.slice(), this._allHandlers = c3.concat(p3);
      }
      return o.prototype.restoreData = function(i, t3) {
        i.restoreData(t3), this._stageTaskMap.each(function(c3) {
          var p3 = c3.overallTask;
          p3 && p3.dirty();
        });
      }, o.prototype.getPerformArgs = function(i, t3) {
        if (i.__pipeline) {
          var c3 = this._pipelineMap.get(i.__pipeline.id), p3 = c3.context, g3 = !t3 && c3.progressiveEnabled && (!p3 || p3.progressiveRender) && i.__idxInPipeline > c3.blockIndex, b3 = g3 ? c3.step : null, w3 = p3 && p3.modDataCount, M = w3 != null ? Math.ceil(w3 / b3) : null;
          return { step: b3, modBy: M, modDataCount: w3 };
        }
      }, o.prototype.getPipeline = function(i) {
        return this._pipelineMap.get(i);
      }, o.prototype.updateStreamModes = function(i, t3) {
        var c3 = this._pipelineMap.get(i.uid), p3 = i.getData(), g3 = p3.count(), b3 = c3.progressiveEnabled && t3.incrementalPrepareRender && g3 >= c3.threshold, w3 = i.get("large") && g3 >= i.get("largeThreshold"), M = i.get("progressiveChunkMode") === "mod" ? g3 : null;
        i.pipelineContext = c3.context = { progressiveRender: b3, modDataCount: M, large: w3 };
      }, o.prototype.restorePipelines = function(i) {
        var t3 = this, c3 = t3._pipelineMap = Eo();
        i.eachSeries(function(p3) {
          var g3 = p3.getProgressive(), b3 = p3.uid;
          c3.set(b3, { id: b3, head: null, tail: null, threshold: p3.getProgressiveThreshold(), progressiveEnabled: g3 && !(p3.preventIncremental && p3.preventIncremental()), blockIndex: -1, step: Math.round(g3 || 700), count: 0 }), t3._pipe(p3, p3.dataTask);
        });
      }, o.prototype.prepareStageTasks = function() {
        var i = this._stageTaskMap, t3 = this.api.getModel(), c3 = this.api;
        yt(this._allHandlers, function(p3) {
          var g3 = i.get(p3.uid) || i.set(p3.uid, {}), b3 = "";
          u0(!(p3.reset && p3.overallReset), b3), p3.reset && this._createSeriesStageTask(p3, g3, t3, c3), p3.overallReset && this._createOverallStageTask(p3, g3, t3, c3);
        }, this);
      }, o.prototype.prepareView = function(i, t3, c3, p3) {
        var g3 = i.renderTask, b3 = g3.context;
        b3.model = t3, b3.ecModel = c3, b3.api = p3, g3.__block = !i.incrementalPrepareRender, this._pipe(t3, g3);
      }, o.prototype.performDataProcessorTasks = function(i, t3) {
        this._performStageTasks(this._dataProcessorHandlers, i, t3, { block: true });
      }, o.prototype.performVisualTasks = function(i, t3, c3) {
        this._performStageTasks(this._visualHandlers, i, t3, c3);
      }, o.prototype._performStageTasks = function(i, t3, c3, p3) {
        p3 = p3 || {};
        var g3 = false, b3 = this;
        yt(i, function(M, I) {
          if (!(p3.visualType && p3.visualType !== M.visualType)) {
            var k3 = b3._stageTaskMap.get(M.uid), L = k3.seriesTaskMap, F = k3.overallTask;
            if (F) {
              var B, G = F.agentStubMap;
              G.each(function(Q) {
                w3(p3, Q) && (Q.dirty(), B = true);
              }), B && F.dirty(), b3.updatePayload(F, c3);
              var J = b3.getPerformArgs(F, p3.block);
              G.each(function(Q) {
                Q.perform(J);
              }), F.perform(J) && (g3 = true);
            } else
              L && L.each(function(Q, se) {
                w3(p3, Q) && Q.dirty();
                var he = b3.getPerformArgs(Q, p3.block);
                he.skip = !M.performRawSeries && t3.isSeriesFiltered(Q.context.model), b3.updatePayload(Q, c3), Q.perform(he) && (g3 = true);
              });
          }
        });
        function w3(M, I) {
          return M.setDirty && (!M.dirtyMap || M.dirtyMap.get(I.__pipeline.id));
        }
        this.unfinished = g3 || this.unfinished;
      }, o.prototype.performSeriesTasks = function(i) {
        var t3;
        i.eachSeries(function(c3) {
          t3 = c3.dataTask.perform() || t3;
        }), this.unfinished = t3 || this.unfinished;
      }, o.prototype.plan = function() {
        this._pipelineMap.each(function(i) {
          var t3 = i.tail;
          do {
            if (t3.__block) {
              i.blockIndex = t3.__idxInPipeline;
              break;
            }
            t3 = t3.getUpstream();
          } while (t3);
        });
      }, o.prototype.updatePayload = function(i, t3) {
        t3 !== "remain" && (i.context.payload = t3);
      }, o.prototype._createSeriesStageTask = function(i, t3, c3, p3) {
        var g3 = this, b3 = t3.seriesTaskMap, w3 = t3.seriesTaskMap = Eo(), M = i.seriesType, I = i.getTargetSeries;
        i.createOnAllSeries ? c3.eachRawSeries(k3) : M ? c3.eachRawSeriesByType(M, k3) : I && I(c3, p3).each(k3);
        function k3(L) {
          var F = L.uid, B = w3.set(F, b3 && b3.get(F) || LH({ plan: Eyt, reset: Dyt, count: Oyt }));
          B.context = { model: L, ecModel: c3, api: p3, useClearVisual: i.isVisual && !i.isLayout, plan: i.plan, reset: i.reset, scheduler: g3 }, g3._pipe(L, B);
        }
      }, o.prototype._createOverallStageTask = function(i, t3, c3, p3) {
        var g3 = this, b3 = t3.overallTask = t3.overallTask || LH({ reset: Myt });
        b3.context = { ecModel: c3, api: p3, overallReset: i.overallReset, scheduler: g3 };
        var w3 = b3.agentStubMap, M = b3.agentStubMap = Eo(), I = i.seriesType, k3 = i.getTargetSeries, L = true, F = false, B = "";
        u0(!i.createOnAllSeries, B), I ? c3.eachRawSeriesByType(I, G) : k3 ? k3(c3, p3).each(G) : (L = false, yt(c3.getSeries(), G));
        function G(J) {
          var Q = J.uid, se = M.set(Q, w3 && w3.get(Q) || (F = true, LH({ reset: Tyt, onDirty: Iyt })));
          se.context = { model: J, overallProgress: L }, se.agent = b3, se.__block = L, g3._pipe(J, se);
        }
        F && b3.dirty();
      }, o.prototype._pipe = function(i, t3) {
        var c3 = i.uid, p3 = this._pipelineMap.get(c3);
        !p3.head && (p3.head = t3), p3.tail && p3.tail.pipe(t3), p3.tail = t3, t3.__idxInPipeline = p3.count++, t3.__pipeline = p3;
      }, o.wrapStageHandler = function(i, t3) {
        return Vo(i) && (i = { overallReset: i, seriesType: Pyt(i) }), i.uid = d8("stageHandler"), t3 && (i.visualType = t3), i;
      }, o;
    }();
    function Myt(o) {
      o.overallReset(o.ecModel, o.api, o.payload);
    }
    function Tyt(o) {
      return o.overallProgress && Ayt;
    }
    function Ayt() {
      this.agent.dirty(), this.getDownstream().dirty();
    }
    function Iyt() {
      this.agent && this.agent.dirty();
    }
    function Eyt(o) {
      return o.plan ? o.plan(o.model, o.ecModel, o.api, o.payload) : null;
    }
    function Dyt(o) {
      o.useClearVisual && o.data.clearAllVisual();
      var i = o.resetDefines = Wc(o.reset(o.model, o.ecModel, o.api, o.payload));
      return i.length > 1 ? Fi(i, function(t3, c3) {
        return LRe(c3);
      }) : kyt;
    }
    var kyt = LRe(0);
    function LRe(o) {
      return function(i, t3) {
        var c3 = t3.data, p3 = t3.resetDefines[o];
        if (p3 && p3.dataEach)
          for (var g3 = i.start; g3 < i.end; g3++)
            p3.dataEach(c3, g3);
        else
          p3 && p3.progress && p3.progress(i, c3);
      };
    }
    function Oyt(o) {
      return o.data.count();
    }
    function Pyt(o) {
      Mte = null;
      try {
        o(VH, RRe);
      } catch {
      }
      return Mte;
    }
    var VH = {}, RRe = {}, Mte;
    NRe(VH, LLe), NRe(RRe, RLe), VH.eachSeriesByType = VH.eachRawSeriesByType = function(o) {
      Mte = o;
    }, VH.eachComponent = function(o) {
      o.mainType === "series" && o.subType && (Mte = o.subType);
    };
    function NRe(o, i) {
      for (var t3 in i.prototype)
        o[t3] = uf;
    }
    var FRe = Cyt, VRe = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], Lyt = { color: VRe, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], VRe] }, F1 = "#B9B8CE", BRe = "#100C2A", Tte = function() {
      return { axisLine: { lineStyle: { color: F1 } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
    }, zRe = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], jRe = { darkMode: true, color: zRe, backgroundColor: BRe, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: F1 } }, textStyle: { color: F1 }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: F1 } }, dataZoom: { borderColor: "#71708A", textStyle: { color: F1 }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: F1 } }, timeline: { lineStyle: { color: F1 }, label: { color: F1 }, controlStyle: { color: F1, borderColor: F1 } }, calendar: { itemStyle: { color: BRe }, dayLabel: { color: F1 }, monthLabel: { color: F1 }, yearLabel: { color: F1 } }, timeAxis: Tte(), logAxis: Tte(), valueAxis: Tte(), categoryAxis: Tte(), line: { symbol: "circle" }, graph: { color: zRe }, gauge: { title: { color: F1 }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: F1 }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
    jRe.categoryAxis.splitLine.show = false;
    var Ryt = jRe, Nyt = function() {
      function o() {
      }
      return o.prototype.normalizeQuery = function(i) {
        var t3 = {}, c3 = {}, p3 = {};
        if (Ha(i)) {
          var g3 = P1(i);
          t3.mainType = g3.main || null, t3.subType = g3.sub || null;
        } else {
          var b3 = ["Index", "Name", "Id"], w3 = { name: 1, dataIndex: 1, dataType: 1 };
          yt(i, function(M, I) {
            for (var k3 = false, L = 0; L < b3.length; L++) {
              var F = b3[L], B = I.lastIndexOf(F);
              if (B > 0 && B === I.length - F.length) {
                var G = I.slice(0, B);
                G !== "data" && (t3.mainType = G, t3[F.toLowerCase()] = M, k3 = true);
              }
            }
            w3.hasOwnProperty(I) && (c3[I] = M, k3 = true), k3 || (p3[I] = M);
          });
        }
        return { cptQuery: t3, dataQuery: c3, otherQuery: p3 };
      }, o.prototype.filter = function(i, t3) {
        var c3 = this.eventInfo;
        if (!c3)
          return true;
        var p3 = c3.targetEl, g3 = c3.packedEvent, b3 = c3.model, w3 = c3.view;
        if (!b3 || !w3)
          return true;
        var M = t3.cptQuery, I = t3.dataQuery;
        return k3(M, b3, "mainType") && k3(M, b3, "subType") && k3(M, b3, "index", "componentIndex") && k3(M, b3, "name") && k3(M, b3, "id") && k3(I, g3, "name") && k3(I, g3, "dataIndex") && k3(I, g3, "dataType") && (!w3.filterForExposedEvent || w3.filterForExposedEvent(i, t3.otherQuery, p3, g3));
        function k3(L, F, B, G) {
          return L[B] == null || F[G || B] === L[B];
        }
      }, o.prototype.afterTrigger = function() {
        this.eventInfo = null;
      }, o;
    }(), Fge = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], GRe = Fge.concat(["symbolKeepAspect"]), Fyt = { createOnAllSeries: true, performRawSeries: true, reset: function(o, i) {
      var t3 = o.getData();
      if (o.legendIcon && t3.setVisual("legendIcon", o.legendIcon), !o.hasSymbolVisual)
        return;
      for (var c3 = {}, p3 = {}, g3 = false, b3 = 0; b3 < Fge.length; b3++) {
        var w3 = Fge[b3], M = o.get(w3);
        Vo(M) ? (g3 = true, p3[w3] = M) : c3[w3] = M;
      }
      if (c3.symbol = c3.symbol || o.defaultSymbol, t3.setVisual(ti({ legendIcon: o.legendIcon || c3.symbol, symbolKeepAspect: o.get("symbolKeepAspect") }, c3)), i.isSeriesFiltered(o))
        return;
      var I = Gl(p3);
      function k3(L, F) {
        for (var B = o.getRawValue(F), G = o.getDataParams(F), J = 0; J < I.length; J++) {
          var Q = I[J];
          L.setItemVisual(F, Q, p3[Q](B, G));
        }
      }
      return { dataEach: g3 ? k3 : null };
    } }, Vyt = { createOnAllSeries: true, performRawSeries: true, reset: function(o, i) {
      if (!o.hasSymbolVisual || i.isSeriesFiltered(o))
        return;
      var t3 = o.getData();
      function c3(p3, g3) {
        for (var b3 = p3.getItemModel(g3), w3 = 0; w3 < GRe.length; w3++) {
          var M = GRe[w3], I = b3.getShallow(M, true);
          I != null && p3.setItemVisual(g3, M, I);
        }
      }
      return { dataEach: t3.hasItemOption ? c3 : null };
    } };
    function Vge(o, i, t3) {
      switch (t3) {
        case "color":
          var c3 = o.getItemVisual(i, "style");
          return c3[o.getVisual("drawType")];
        case "opacity":
          return o.getItemVisual(i, "style").opacity;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          return o.getItemVisual(i, t3);
      }
    }
    function BH(o, i) {
      switch (i) {
        case "color":
          var t3 = o.getVisual("style");
          return t3[o.getVisual("drawType")];
        case "opacity":
          return o.getVisual("style").opacity;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          return o.getVisual(i);
      }
    }
    function HRe(o, i, t3, c3) {
      switch (t3) {
        case "color":
          var p3 = o.ensureUniqueItemVisual(i, "style");
          p3[o.getVisual("drawType")] = c3, o.setItemVisual(i, "colorFromPalette", false);
          break;
        case "opacity":
          o.ensureUniqueItemVisual(i, "style").opacity = c3;
          break;
        case "symbol":
        case "symbolSize":
        case "liftZ":
          o.setItemVisual(i, t3, c3);
          break;
      }
    }
    function WRe(o, i) {
      function t3(c3, p3) {
        var g3 = [];
        return c3.eachComponent({ mainType: "series", subType: o, query: p3 }, function(b3) {
          g3.push(b3.seriesIndex);
        }), g3;
      }
      yt([[o + "ToggleSelect", "toggleSelect"], [o + "Select", "select"], [o + "UnSelect", "unselect"]], function(c3) {
        i(c3[0], function(p3, g3, b3) {
          p3 = ti({}, p3), b3.dispatchAction(ti(p3, { type: c3[1], seriesIndex: t3(g3, p3) }));
        });
      });
    }
    function T8(o, i, t3, c3, p3) {
      var g3 = o + i;
      t3.isSilent(g3) || c3.eachComponent({ mainType: "series", subType: "pie" }, function(b3) {
        for (var w3 = b3.seriesIndex, M = b3.option.selectedMap, I = p3.selected, k3 = 0; k3 < I.length; k3++)
          if (I[k3].seriesIndex === w3) {
            var L = b3.getData(), F = k_(L, p3.fromActionPayload);
            t3.trigger(g3, { type: g3, seriesId: b3.id, name: Ei(F) ? L.getName(F[0]) : L.getName(F), selected: Ha(M) ? M : ti({}, M) });
          }
      });
    }
    function Byt(o, i, t3) {
      o.on("selectchanged", function(c3) {
        var p3 = t3.getModel();
        c3.isFromClick ? (T8("map", "selectchanged", i, p3, c3), T8("pie", "selectchanged", i, p3, c3)) : c3.fromAction === "select" ? (T8("map", "selected", i, p3, c3), T8("pie", "selected", i, p3, c3)) : c3.fromAction === "unselect" && (T8("map", "unselected", i, p3, c3), T8("pie", "unselected", i, p3, c3));
      });
    }
    function A8(o, i, t3) {
      for (var c3; o && !(i(o) && (c3 = o, t3)); )
        o = o.__hostTarget || o.parent;
      return c3;
    }
    var zyt = Math.round(Math.random() * 9), jyt = typeof Object.defineProperty == "function", Gyt = function() {
      function o() {
        this._id = "__ec_inner_" + zyt++;
      }
      return o.prototype.get = function(i) {
        return this._guard(i)[this._id];
      }, o.prototype.set = function(i, t3) {
        var c3 = this._guard(i);
        return jyt ? Object.defineProperty(c3, this._id, { value: t3, enumerable: false, configurable: true }) : c3[this._id] = t3, this;
      }, o.prototype.delete = function(i) {
        return this.has(i) ? (delete this._guard(i)[this._id], true) : false;
      }, o.prototype.has = function(i) {
        return !!this._guard(i)[this._id];
      }, o.prototype._guard = function(i) {
        if (i !== Object(i))
          throw TypeError("Value of WeakMap is not a non-null object.");
        return i;
      }, o;
    }(), Hyt = Gyt, Wyt = gl.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(o, i) {
      var t3 = i.cx, c3 = i.cy, p3 = i.width / 2, g3 = i.height / 2;
      o.moveTo(t3, c3 - g3), o.lineTo(t3 + p3, c3 + g3), o.lineTo(t3 - p3, c3 + g3), o.closePath();
    } }), Uyt = gl.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(o, i) {
      var t3 = i.cx, c3 = i.cy, p3 = i.width / 2, g3 = i.height / 2;
      o.moveTo(t3, c3 - g3), o.lineTo(t3 + p3, c3), o.lineTo(t3, c3 + g3), o.lineTo(t3 - p3, c3), o.closePath();
    } }), qyt = gl.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(o, i) {
      var t3 = i.x, c3 = i.y, p3 = i.width / 5 * 3, g3 = Math.max(p3, i.height), b3 = p3 / 2, w3 = b3 * b3 / (g3 - b3), M = c3 - g3 + b3 + w3, I = Math.asin(w3 / b3), k3 = Math.cos(I) * b3, L = Math.sin(I), F = Math.cos(I), B = b3 * 0.6, G = b3 * 0.7;
      o.moveTo(t3 - k3, M + w3), o.arc(t3, M, b3, Math.PI - I, Math.PI * 2 + I), o.bezierCurveTo(t3 + k3 - L * B, M + w3 + F * B, t3, c3 - G, t3, c3), o.bezierCurveTo(t3, c3 - G, t3 - k3 + L * B, M + w3 + F * B, t3 - k3, M + w3), o.closePath();
    } }), $yt = gl.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(o, i) {
      var t3 = i.height, c3 = i.width, p3 = i.x, g3 = i.y, b3 = c3 / 3 * 2;
      o.moveTo(p3, g3), o.lineTo(p3 + b3, g3 + t3), o.lineTo(p3, g3 + t3 / 4 * 3), o.lineTo(p3 - b3, g3 + t3), o.lineTo(p3, g3), o.closePath();
    } }), Xyt = { line: Ud, rect: bu, roundRect: bu, square: bu, circle: Mw, diamond: Uyt, pin: qyt, arrow: $yt, triangle: Wyt }, Yyt = { line: function(o, i, t3, c3, p3) {
      p3.x1 = o, p3.y1 = i + c3 / 2, p3.x2 = o + t3, p3.y2 = i + c3 / 2;
    }, rect: function(o, i, t3, c3, p3) {
      p3.x = o, p3.y = i, p3.width = t3, p3.height = c3;
    }, roundRect: function(o, i, t3, c3, p3) {
      p3.x = o, p3.y = i, p3.width = t3, p3.height = c3, p3.r = Math.min(t3, c3) / 4;
    }, square: function(o, i, t3, c3, p3) {
      var g3 = Math.min(t3, c3);
      p3.x = o, p3.y = i, p3.width = g3, p3.height = g3;
    }, circle: function(o, i, t3, c3, p3) {
      p3.cx = o + t3 / 2, p3.cy = i + c3 / 2, p3.r = Math.min(t3, c3) / 2;
    }, diamond: function(o, i, t3, c3, p3) {
      p3.cx = o + t3 / 2, p3.cy = i + c3 / 2, p3.width = t3, p3.height = c3;
    }, pin: function(o, i, t3, c3, p3) {
      p3.x = o + t3 / 2, p3.y = i + c3 / 2, p3.width = t3, p3.height = c3;
    }, arrow: function(o, i, t3, c3, p3) {
      p3.x = o + t3 / 2, p3.y = i + c3 / 2, p3.width = t3, p3.height = c3;
    }, triangle: function(o, i, t3, c3, p3) {
      p3.cx = o + t3 / 2, p3.cy = i + c3 / 2, p3.width = t3, p3.height = c3;
    } }, Ate = {};
    yt(Xyt, function(o, i) {
      Ate[i] = new o();
    });
    var Kyt = gl.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(o, i, t3) {
      var c3 = TF(o, i, t3), p3 = this.shape;
      return p3 && p3.symbolType === "pin" && i.position === "inside" && (c3.y = t3.y + t3.height * 0.4), c3;
    }, buildPath: function(o, i, t3) {
      var c3 = i.symbolType;
      if (c3 !== "none") {
        var p3 = Ate[c3];
        p3 || (c3 = "rect", p3 = Ate[c3]), Yyt[c3](i.x, i.y, i.width, i.height, p3.shape), p3.buildPath(o, p3.shape, t3);
      }
    } });
    function Zyt(o, i) {
      if (this.type !== "image") {
        var t3 = this.style;
        this.__isEmptyBrush ? (t3.stroke = o, t3.fill = i || "#fff", t3.lineWidth = 2) : this.shape.symbolType === "line" ? t3.stroke = o : t3.fill = o, this.markRedraw();
      }
    }
    function pv(o, i, t3, c3, p3, g3, b3) {
      var w3 = o.indexOf("empty") === 0;
      w3 && (o = o.substr(5, 1).toLowerCase() + o.substr(6));
      var M;
      return o.indexOf("image://") === 0 ? M = Zn(o.slice(8), new Ys(i, t3, c3, p3), b3 ? "center" : "cover") : o.indexOf("path://") === 0 ? M = jn(o.slice(7), {}, new Ys(i, t3, c3, p3), b3 ? "center" : "cover") : M = new Kyt({ shape: { symbolType: o, x: i, y: t3, width: c3, height: p3 } }), M.__isEmptyBrush = w3, M.setColor = Zyt, g3 && M.setColor(g3), M;
    }
    function zH(o) {
      return Ei(o) || (o = [+o, +o]), [o[0] || 0, o[1] || 0];
    }
    function I8(o, i) {
      if (o != null)
        return Ei(o) || (o = [o, o]), [Da(o[0], i[0]) || 0, Da(Xs(o[1], o[0]), i[1]) || 0];
    }
    function Jyt(o, i, t3) {
      var c3 = i.x == null ? 0 : i.x, p3 = i.x2 == null ? 1 : i.x2, g3 = i.y == null ? 0 : i.y, b3 = i.y2 == null ? 0 : i.y2;
      i.global || (c3 = c3 * t3.width + t3.x, p3 = p3 * t3.width + t3.x, g3 = g3 * t3.height + t3.y, b3 = b3 * t3.height + t3.y), c3 = isNaN(c3) ? 0 : c3, p3 = isNaN(p3) ? 1 : p3, g3 = isNaN(g3) ? 0 : g3, b3 = isNaN(b3) ? 0 : b3;
      var w3 = o.createLinearGradient(c3, g3, p3, b3);
      return w3;
    }
    function Qyt(o, i, t3) {
      var c3 = t3.width, p3 = t3.height, g3 = Math.min(c3, p3), b3 = i.x == null ? 0.5 : i.x, w3 = i.y == null ? 0.5 : i.y, M = i.r == null ? 0.5 : i.r;
      i.global || (b3 = b3 * c3 + t3.x, w3 = w3 * p3 + t3.y, M = M * g3);
      var I = o.createRadialGradient(b3, w3, 0, b3, w3, M);
      return I;
    }
    function Bge(o, i, t3) {
      for (var c3 = i.type === "radial" ? Qyt(o, i, t3) : Jyt(o, i, t3), p3 = i.colorStops, g3 = 0; g3 < p3.length; g3++)
        c3.addColorStop(p3[g3].offset, p3[g3].color);
      return c3;
    }
    function emt(o, i) {
      if (o === i || !o && !i)
        return false;
      if (!o || !i || o.length !== i.length)
        return true;
      for (var t3 = 0; t3 < o.length; t3++)
        if (o[t3] !== i[t3])
          return true;
      return false;
    }
    function Ite(o) {
      return parseInt(o, 10);
    }
    function E8(o, i, t3) {
      var c3 = ["width", "height"][i], p3 = ["clientWidth", "clientHeight"][i], g3 = ["paddingLeft", "paddingTop"][i], b3 = ["paddingRight", "paddingBottom"][i];
      if (t3[c3] != null && t3[c3] !== "auto")
        return parseFloat(t3[c3]);
      var w3 = document.defaultView.getComputedStyle(o);
      return (o[p3] || Ite(w3[c3]) || Ite(o.style[c3])) - (Ite(w3[g3]) || 0) - (Ite(w3[b3]) || 0) | 0;
    }
    function tmt(o, i) {
      return !o || o === "solid" || !(i > 0) ? null : o === "dashed" ? [4 * i, 2 * i] : o === "dotted" ? [i] : ec(o) ? [o] : Ei(o) ? o : null;
    }
    function zge(o) {
      var i = o.style, t3 = i.lineDash && i.lineWidth > 0 && tmt(i.lineDash, i.lineWidth), c3 = i.lineDashOffset;
      if (t3) {
        var p3 = i.strokeNoScale && o.getLineScale ? o.getLineScale() : 1;
        p3 && p3 !== 1 && (t3 = Fi(t3, function(g3) {
          return g3 / p3;
        }), c3 /= p3);
      }
      return [t3, c3];
    }
    var nmt = new ww(true);
    function Ete(o) {
      var i = o.stroke;
      return !(i == null || i === "none" || !(o.lineWidth > 0));
    }
    function URe(o) {
      return typeof o == "string" && o !== "none";
    }
    function Dte(o) {
      var i = o.fill;
      return i != null && i !== "none";
    }
    function qRe(o, i) {
      if (i.fillOpacity != null && i.fillOpacity !== 1) {
        var t3 = o.globalAlpha;
        o.globalAlpha = i.fillOpacity * i.opacity, o.fill(), o.globalAlpha = t3;
      } else
        o.fill();
    }
    function $Re(o, i) {
      if (i.strokeOpacity != null && i.strokeOpacity !== 1) {
        var t3 = o.globalAlpha;
        o.globalAlpha = i.strokeOpacity * i.opacity, o.stroke(), o.globalAlpha = t3;
      } else
        o.stroke();
    }
    function jge(o, i, t3) {
      var c3 = zF(i.image, i.__image, t3);
      if (BP(c3)) {
        var p3 = o.createPattern(c3, i.repeat || "repeat");
        if (typeof DOMMatrix == "function" && p3 && p3.setTransform) {
          var g3 = new DOMMatrix();
          g3.translateSelf(i.x || 0, i.y || 0), g3.rotateSelf(0, 0, (i.rotation || 0) * aF), g3.scaleSelf(i.scaleX || 1, i.scaleY || 1), p3.setTransform(g3);
        }
        return p3;
      }
    }
    function rmt(o, i, t3, c3) {
      var p3, g3 = Ete(t3), b3 = Dte(t3), w3 = t3.strokePercent, M = w3 < 1, I = !i.path;
      (!i.silent || M) && I && i.createPathProxy();
      var k3 = i.path || nmt, L = i.__dirty;
      if (!c3) {
        var F = t3.fill, B = t3.stroke, G = b3 && !!F.colorStops, J = g3 && !!B.colorStops, Q = b3 && !!F.image, se = g3 && !!B.image, he = void 0, be = void 0, de = void 0, Fe = void 0, Pe = void 0;
        (G || J) && (Pe = i.getBoundingRect()), G && (he = L ? Bge(o, F, Pe) : i.__canvasFillGradient, i.__canvasFillGradient = he), J && (be = L ? Bge(o, B, Pe) : i.__canvasStrokeGradient, i.__canvasStrokeGradient = be), Q && (de = L || !i.__canvasFillPattern ? jge(o, F, i) : i.__canvasFillPattern, i.__canvasFillPattern = de), se && (Fe = L || !i.__canvasStrokePattern ? jge(o, B, i) : i.__canvasStrokePattern, i.__canvasStrokePattern = de), G ? o.fillStyle = he : Q && (de ? o.fillStyle = de : b3 = false), J ? o.strokeStyle = be : se && (Fe ? o.strokeStyle = Fe : g3 = false);
      }
      var ze = i.getGlobalScale();
      k3.setScale(ze[0], ze[1], i.segmentIgnoreThreshold);
      var $e, Ke;
      o.setLineDash && t3.lineDash && (p3 = zge(i), $e = p3[0], Ke = p3[1]);
      var nt = true;
      (I || L & T5) && (k3.setDPR(o.dpr), M ? k3.setContext(null) : (k3.setContext(o), nt = false), k3.reset(), i.buildPath(k3, i.shape, c3), k3.toStatic(), i.pathUpdated()), nt && k3.rebuildPath(o, M ? w3 : 1), $e && (o.setLineDash($e), o.lineDashOffset = Ke), c3 || (t3.strokeFirst ? (g3 && $Re(o, t3), b3 && qRe(o, t3)) : (b3 && qRe(o, t3), g3 && $Re(o, t3))), $e && o.setLineDash([]);
    }
    function imt(o, i, t3) {
      var c3 = i.__image = zF(t3.image, i.__image, i, i.onload);
      if (!(!c3 || !BP(c3))) {
        var p3 = t3.x || 0, g3 = t3.y || 0, b3 = i.getWidth(), w3 = i.getHeight(), M = c3.width / c3.height;
        if (b3 == null && w3 != null ? b3 = w3 * M : w3 == null && b3 != null ? w3 = b3 / M : b3 == null && w3 == null && (b3 = c3.width, w3 = c3.height), t3.sWidth && t3.sHeight) {
          var I = t3.sx || 0, k3 = t3.sy || 0;
          o.drawImage(c3, I, k3, t3.sWidth, t3.sHeight, p3, g3, b3, w3);
        } else if (t3.sx && t3.sy) {
          var I = t3.sx, k3 = t3.sy, L = b3 - I, F = w3 - k3;
          o.drawImage(c3, I, k3, L, F, p3, g3, b3, w3);
        } else
          o.drawImage(c3, p3, g3, b3, w3);
      }
    }
    function amt(o, i, t3) {
      var c3, p3 = t3.text;
      if (p3 != null && (p3 += ""), p3) {
        o.font = t3.font || Vs, o.textAlign = t3.textAlign, o.textBaseline = t3.textBaseline;
        var g3 = void 0, b3 = void 0;
        o.setLineDash && t3.lineDash && (c3 = zge(i), g3 = c3[0], b3 = c3[1]), g3 && (o.setLineDash(g3), o.lineDashOffset = b3), t3.strokeFirst ? (Ete(t3) && o.strokeText(p3, t3.x, t3.y), Dte(t3) && o.fillText(p3, t3.x, t3.y)) : (Dte(t3) && o.fillText(p3, t3.x, t3.y), Ete(t3) && o.strokeText(p3, t3.x, t3.y)), g3 && o.setLineDash([]);
      }
    }
    var XRe = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], YRe = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
    function KRe(o, i, t3, c3, p3) {
      var g3 = false;
      if (!c3 && (t3 = t3 || {}, i === t3))
        return false;
      if (c3 || i.opacity !== t3.opacity) {
        Db(o, p3), g3 = true;
        var b3 = Math.max(Math.min(i.opacity, 1), 0);
        o.globalAlpha = isNaN(b3) ? bI.opacity : b3;
      }
      (c3 || i.blend !== t3.blend) && (g3 || (Db(o, p3), g3 = true), o.globalCompositeOperation = i.blend || bI.blend);
      for (var w3 = 0; w3 < XRe.length; w3++) {
        var M = XRe[w3];
        (c3 || i[M] !== t3[M]) && (g3 || (Db(o, p3), g3 = true), o[M] = o.dpr * (i[M] || 0));
      }
      return (c3 || i.shadowColor !== t3.shadowColor) && (g3 || (Db(o, p3), g3 = true), o.shadowColor = i.shadowColor || bI.shadowColor), g3;
    }
    function ZRe(o, i, t3, c3, p3) {
      var g3 = jH(i, p3.inHover), b3 = c3 ? null : t3 && jH(t3, p3.inHover) || {};
      if (g3 === b3)
        return false;
      var w3 = KRe(o, g3, b3, c3, p3);
      if ((c3 || g3.fill !== b3.fill) && (w3 || (Db(o, p3), w3 = true), URe(g3.fill) && (o.fillStyle = g3.fill)), (c3 || g3.stroke !== b3.stroke) && (w3 || (Db(o, p3), w3 = true), URe(g3.stroke) && (o.strokeStyle = g3.stroke)), (c3 || g3.opacity !== b3.opacity) && (w3 || (Db(o, p3), w3 = true), o.globalAlpha = g3.opacity == null ? 1 : g3.opacity), i.hasStroke()) {
        var M = g3.lineWidth, I = M / (g3.strokeNoScale && i.getLineScale ? i.getLineScale() : 1);
        o.lineWidth !== I && (w3 || (Db(o, p3), w3 = true), o.lineWidth = I);
      }
      for (var k3 = 0; k3 < YRe.length; k3++) {
        var L = YRe[k3], F = L[0];
        (c3 || g3[F] !== b3[F]) && (w3 || (Db(o, p3), w3 = true), o[F] = g3[F] || L[1]);
      }
      return w3;
    }
    function omt(o, i, t3, c3, p3) {
      return KRe(o, jH(i, p3.inHover), t3 && jH(t3, p3.inHover), c3, p3);
    }
    function JRe(o, i) {
      var t3 = i.transform, c3 = o.dpr || 1;
      t3 ? o.setTransform(c3 * t3[0], c3 * t3[1], c3 * t3[2], c3 * t3[3], c3 * t3[4], c3 * t3[5]) : o.setTransform(c3, 0, 0, c3, 0, 0);
    }
    function smt(o, i, t3) {
      for (var c3 = false, p3 = 0; p3 < o.length; p3++) {
        var g3 = o[p3];
        c3 = c3 || g3.isZeroArea(), JRe(i, g3), i.beginPath(), g3.buildPath(i, g3.shape), i.clip();
      }
      t3.allClipped = c3;
    }
    function lmt(o, i) {
      return o && i ? o[0] !== i[0] || o[1] !== i[1] || o[2] !== i[2] || o[3] !== i[3] || o[4] !== i[4] || o[5] !== i[5] : !(!o && !i);
    }
    var QRe = 1, e4e = 2, t4e = 3, n4e = 4;
    function umt(o) {
      var i = Dte(o), t3 = Ete(o);
      return !(o.lineDash || !(+i ^ +t3) || i && typeof o.fill != "string" || t3 && typeof o.stroke != "string" || o.strokePercent < 1 || o.strokeOpacity < 1 || o.fillOpacity < 1);
    }
    function Db(o, i) {
      i.batchFill && o.fill(), i.batchStroke && o.stroke(), i.batchFill = "", i.batchStroke = "";
    }
    function jH(o, i) {
      return i && o.__hoverStyle || o.style;
    }
    function r4e(o, i) {
      lL(o, i, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
    }
    function lL(o, i, t3, c3) {
      var p3 = i.transform;
      if (!i.shouldBePainted(t3.viewWidth, t3.viewHeight, false, false)) {
        i.__dirty &= ~c0, i.__isRendered = false;
        return;
      }
      var g3 = i.__clipPaths, b3 = t3.prevElClipPaths, w3 = false, M = false;
      if ((!b3 || emt(g3, b3)) && (b3 && b3.length && (Db(o, t3), o.restore(), M = w3 = true, t3.prevElClipPaths = null, t3.allClipped = false, t3.prevEl = null), g3 && g3.length && (Db(o, t3), o.save(), smt(g3, o, t3), w3 = true), t3.prevElClipPaths = g3), t3.allClipped) {
        i.__isRendered = false;
        return;
      }
      i.beforeBrush && i.beforeBrush(), i.innerBeforeBrush();
      var I = t3.prevEl;
      I || (M = w3 = true);
      var k3 = i instanceof gl && i.autoBatch && umt(i.style);
      w3 || lmt(p3, I.transform) ? (Db(o, t3), JRe(o, i)) : k3 || Db(o, t3);
      var L = jH(i, t3.inHover);
      i instanceof gl ? (t3.lastDrawType !== QRe && (M = true, t3.lastDrawType = QRe), ZRe(o, i, I, M, t3), (!k3 || !t3.batchFill && !t3.batchStroke) && o.beginPath(), rmt(o, i, L, k3), k3 && (t3.batchFill = L.fill || "", t3.batchStroke = L.stroke || "")) : i instanceof HP ? (t3.lastDrawType !== t4e && (M = true, t3.lastDrawType = t4e), ZRe(o, i, I, M, t3), amt(o, i, L)) : i instanceof Gv ? (t3.lastDrawType !== e4e && (M = true, t3.lastDrawType = e4e), omt(o, i, I, M, t3), imt(o, i, L)) : i.getTemporalDisplayables && (t3.lastDrawType !== n4e && (M = true, t3.lastDrawType = n4e), cmt(o, i, t3)), k3 && c3 && Db(o, t3), i.innerAfterBrush(), i.afterBrush && i.afterBrush(), t3.prevEl = i, i.__dirty = 0, i.__isRendered = true;
    }
    function cmt(o, i, t3) {
      var c3 = i.getDisplayables(), p3 = i.getTemporalDisplayables();
      o.save();
      var g3 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: t3.viewWidth, viewHeight: t3.viewHeight, inHover: t3.inHover }, b3, w3;
      for (b3 = i.getCursor(), w3 = c3.length; b3 < w3; b3++) {
        var M = c3[b3];
        M.beforeBrush && M.beforeBrush(), M.innerBeforeBrush(), lL(o, M, g3, b3 === w3 - 1), M.innerAfterBrush(), M.afterBrush && M.afterBrush(), g3.prevEl = M;
      }
      for (var I = 0, k3 = p3.length; I < k3; I++) {
        var M = p3[I];
        M.beforeBrush && M.beforeBrush(), M.innerBeforeBrush(), lL(o, M, g3, I === k3 - 1), M.innerAfterBrush(), M.afterBrush && M.afterBrush(), g3.prevEl = M;
      }
      i.clearTemporalDisplayables(), i.notClear = true, o.restore();
    }
    var Gge = new Hyt(), i4e = new TP(100), a4e = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
    function GH(o, i) {
      if (o === "none")
        return null;
      var t3 = i.getDevicePixelRatio(), c3 = i.getZr(), p3 = c3.painter.type === "svg";
      o.dirty && Gge.delete(o);
      var g3 = Gge.get(o);
      if (g3)
        return g3;
      var b3 = Uo(o, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
      b3.backgroundColor === "none" && (b3.backgroundColor = null);
      var w3 = { repeat: "repeat" };
      return M(w3), w3.rotation = b3.rotation, w3.scaleX = w3.scaleY = p3 ? 1 : 1 / t3, Gge.set(o, w3), o.dirty = false, w3;
      function M(I) {
        for (var k3 = [t3], L = true, F = 0; F < a4e.length; ++F) {
          var B = b3[a4e[F]];
          if (B != null && !Ei(B) && !Ha(B) && !ec(B) && typeof B != "boolean") {
            L = false;
            break;
          }
          k3.push(B);
        }
        var G;
        if (L) {
          G = k3.join(",") + (p3 ? "-svg" : "");
          var J = i4e.get(G);
          J && (p3 ? I.svgElement = J : I.image = J);
        }
        var Q = s4e(b3.dashArrayX), se = fmt(b3.dashArrayY), he = o4e(b3.symbol), be = hmt(Q), de = l4e(se), Fe = !p3 && cm.createCanvas(), Pe = p3 && { tag: "g", attrs: {}, key: "dcl", children: [] }, ze = Ke(), $e;
        Fe && (Fe.width = ze.width * t3, Fe.height = ze.height * t3, $e = Fe.getContext("2d")), nt(), L && i4e.put(G, Fe || Pe), I.image = Fe, I.svgElement = Pe, I.svgWidth = ze.width, I.svgHeight = ze.height;
        function Ke() {
          for (var lt2 = 1, bt = 0, vt = be.length; bt < vt; ++bt)
            lt2 = FF(lt2, be[bt]);
          for (var jt = 1, bt = 0, vt = he.length; bt < vt; ++bt)
            jt = FF(jt, he[bt].length);
          lt2 *= jt;
          var Jt = de * be.length * he.length;
          return { width: Math.max(1, Math.min(lt2, b3.maxTileWidth)), height: Math.max(1, Math.min(Jt, b3.maxTileHeight)) };
        }
        function nt() {
          $e && ($e.clearRect(0, 0, Fe.width, Fe.height), b3.backgroundColor && ($e.fillStyle = b3.backgroundColor, $e.fillRect(0, 0, Fe.width, Fe.height)));
          for (var lt2 = 0, bt = 0; bt < se.length; ++bt)
            lt2 += se[bt];
          if (lt2 <= 0)
            return;
          for (var vt = -de, jt = 0, Jt = 0, Rt = 0; vt < ze.height; ) {
            if (jt % 2 === 0) {
              for (var Jn = Jt / 2 % he.length, ln = 0, vn = 0, kn = 0; ln < ze.width * 2; ) {
                for (var cr = 0, bt = 0; bt < Q[Rt].length; ++bt)
                  cr += Q[Rt][bt];
                if (cr <= 0)
                  break;
                if (vn % 2 === 0) {
                  var gr = (1 - b3.symbolSize) * 0.5, ha = ln + Q[Rt][vn] * gr, Ka = vt + se[jt] * gr, Do = Q[Rt][vn] * b3.symbolSize, _o = se[jt] * b3.symbolSize, xo = kn / 2 % he[Jn].length;
                  Ra(ha, Ka, Do, _o, he[Jn][xo]);
                }
                ln += Q[Rt][vn], ++kn, ++vn, vn === Q[Rt].length && (vn = 0);
              }
              ++Rt, Rt === Q.length && (Rt = 0);
            }
            vt += se[jt], ++Jt, ++jt, jt === se.length && (jt = 0);
          }
          function Ra(ho, Mo, Xa, Zo, rc) {
            var ys = p3 ? 1 : t3, Vu = pv(rc, ho * ys, Mo * ys, Xa * ys, Zo * ys, b3.color, b3.symbolKeepAspect);
            if (p3) {
              var gc = c3.painter.renderOneToVNode(Vu);
              gc && Pe.children.push(gc);
            } else
              r4e($e, Vu);
          }
        }
      }
    }
    function o4e(o) {
      if (!o || o.length === 0)
        return [["rect"]];
      if (Ha(o))
        return [[o]];
      for (var i = true, t3 = 0; t3 < o.length; ++t3)
        if (!Ha(o[t3])) {
          i = false;
          break;
        }
      if (i)
        return o4e([o]);
      for (var c3 = [], t3 = 0; t3 < o.length; ++t3)
        Ha(o[t3]) ? c3.push([o[t3]]) : c3.push(o[t3]);
      return c3;
    }
    function s4e(o) {
      if (!o || o.length === 0)
        return [[0, 0]];
      if (ec(o)) {
        var i = Math.ceil(o);
        return [[i, i]];
      }
      for (var t3 = true, c3 = 0; c3 < o.length; ++c3)
        if (!ec(o[c3])) {
          t3 = false;
          break;
        }
      if (t3)
        return s4e([o]);
      for (var p3 = [], c3 = 0; c3 < o.length; ++c3)
        if (ec(o[c3])) {
          var i = Math.ceil(o[c3]);
          p3.push([i, i]);
        } else {
          var i = Fi(o[c3], function(w3) {
            return Math.ceil(w3);
          });
          i.length % 2 === 1 ? p3.push(i.concat(i)) : p3.push(i);
        }
      return p3;
    }
    function fmt(o) {
      if (!o || typeof o == "object" && o.length === 0)
        return [0, 0];
      if (ec(o)) {
        var i = Math.ceil(o);
        return [i, i];
      }
      var t3 = Fi(o, function(c3) {
        return Math.ceil(c3);
      });
      return o.length % 2 ? t3.concat(t3) : t3;
    }
    function hmt(o) {
      return Fi(o, function(i) {
        return l4e(i);
      });
    }
    function l4e(o) {
      for (var i = 0, t3 = 0; t3 < o.length; ++t3)
        i += o[t3];
      return o.length % 2 === 1 ? i * 2 : i;
    }
    function pmt(o, i) {
      o.eachRawSeries(function(t3) {
        if (!o.isSeriesFiltered(t3)) {
          var c3 = t3.getData();
          c3.hasItemVisual() && c3.each(function(b3) {
            var w3 = c3.getItemVisual(b3, "decal");
            if (w3) {
              var M = c3.ensureUniqueItemVisual(b3, "style");
              M.decal = GH(w3, i);
            }
          });
          var p3 = c3.getVisual("decal");
          if (p3) {
            var g3 = c3.getVisual("style");
            g3.decal = GH(p3, i);
          }
        }
      });
    }
    var dmt = new hm(), X2 = dmt, u4e = {};
    function vmt(o, i) {
      u4e[o] = i;
    }
    function gmt(o) {
      return u4e[o];
    }
    var ymt = typeof window != "undefined", mmt = 1, bmt = 800, _mt = 900, xmt = 1e3, wmt = 2e3, Smt = 5e3, c4e = 1e3, Cmt = 1100, Hge = 2e3, f4e = 3e3, Mmt = 4e3, kte = 4500, Tmt = 4600, Amt = 5e3, Imt = 6e3, h4e = 7e3, Emt = { PROCESSOR: { FILTER: xmt, SERIES_FILTER: bmt, STATISTIC: Smt }, VISUAL: { LAYOUT: c4e, PROGRESSIVE_LAYOUT: Cmt, GLOBAL: Hge, CHART: f4e, POST_CHART_LAYOUT: Tmt, COMPONENT: Mmt, BRUSH: Amt, CHART_ITEM: kte, ARIA: Imt, DECAL: h4e } }, Tm = "__flagInMainProcess", kb = "__pendingUpdate", Wge = "__needsUpdateStatus", p4e = /^[a-zA-Z0-9_]+$/, Uge = "__connectUpdateStatus", d4e = 0, Dmt = 1, kmt = 2;
    function v4e(o) {
      return function() {
        for (var i = [], t3 = 0; t3 < arguments.length; t3++)
          i[t3] = arguments[t3];
        if (this.isDisposed()) {
          this.id;
          return;
        }
        return y4e(this, o, i);
      };
    }
    function g4e(o) {
      return function() {
        for (var i = [], t3 = 0; t3 < arguments.length; t3++)
          i[t3] = arguments[t3];
        return y4e(this, o, i);
      };
    }
    function y4e(o, i, t3) {
      return t3[0] = t3[0] && t3[0].toLowerCase(), hm.prototype[i].apply(o, t3);
    }
    var m4e = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i;
    }(hm), b4e = m4e.prototype;
    b4e.on = g4e("on"), b4e.off = g4e("off");
    var D8, qge, Ote, lk, $ge, Xge, Yge, HH, WH2, _4e, x4e, Kge, w4e, Pte, S4e, C4e, Ow, M4e, T4e = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this, new Nyt()) || this;
        g3._chartsViews = [], g3._chartsMap = {}, g3._componentsViews = [], g3._componentsMap = {}, g3._pendingActions = [], p3 = p3 || {}, Ha(c3) && (c3 = A4e[c3]), g3._dom = t3;
        var b3 = "canvas", w3 = false, M = g3._zr = wG(t3, { renderer: p3.renderer || b3, devicePixelRatio: p3.devicePixelRatio, width: p3.width, height: p3.height, ssr: p3.ssr, useDirtyRect: p3.useDirtyRect == null ? w3 : p3.useDirtyRect });
        g3._ssr = p3.ssr, g3._throttledZrFlush = Nge(Qa(M.flush, M), 17), c3 = Jo(c3), c3 && GLe(c3, true), g3._theme = c3, g3._locale = jgt(p3.locale || eLe), g3._coordSysMgr = new DH();
        var I = g3._api = S4e(g3);
        function k3(L, F) {
          return L.__prio - F.__prio;
        }
        return tI(Rte, k3), tI(Jge, k3), g3._scheduler = new FRe(g3, I, Jge, Rte), g3._messageCenter = new m4e(), g3._initEvents(), g3.resize = Qa(g3.resize, g3), M.animation.on("frame", g3._onframe, g3), _4e(M, g3), x4e(M, g3), vP(g3), g3;
      }
      return i.prototype._onframe = function() {
        if (!this._disposed) {
          M4e(this);
          var t3 = this._scheduler;
          if (this[kb]) {
            var c3 = this[kb].silent;
            this[Tm] = true;
            try {
              D8(this), lk.update.call(this, null, this[kb].updateParams);
            } catch (M) {
              throw this[Tm] = false, this[kb] = null, M;
            }
            this._zr.flush(), this[Tm] = false, this[kb] = null, HH.call(this, c3), WH2.call(this, c3);
          } else if (t3.unfinished) {
            var p3 = mmt, g3 = this._model, b3 = this._api;
            t3.unfinished = false;
            do {
              var w3 = +new Date();
              t3.performSeriesTasks(g3), t3.performDataProcessorTasks(g3), Xge(this, g3), t3.performVisualTasks(g3), Pte(this, this._model, b3, "remain", {}), p3 -= +new Date() - w3;
            } while (p3 > 0 && t3.unfinished);
            t3.unfinished || this._zr.flush();
          }
        }
      }, i.prototype.getDom = function() {
        return this._dom;
      }, i.prototype.getId = function() {
        return this.id;
      }, i.prototype.getZr = function() {
        return this._zr;
      }, i.prototype.isSSR = function() {
        return this._ssr;
      }, i.prototype.setOption = function(t3, c3, p3) {
        if (!this[Tm]) {
          if (this._disposed) {
            this.id;
            return;
          }
          var g3, b3, w3;
          if (Ua(c3) && (p3 = c3.lazyUpdate, g3 = c3.silent, b3 = c3.replaceMerge, w3 = c3.transition, c3 = c3.notMerge), this[Tm] = true, !this._model || c3) {
            var M = new x0t(this._api), I = this._theme, k3 = this._model = new LLe();
            k3.scheduler = this._scheduler, k3.ssr = this._ssr, k3.init(null, null, null, I, this._locale, M);
          }
          this._model.setOption(t3, { replaceMerge: b3 }, Qge);
          var L = { seriesTransition: w3, optionChanged: true };
          if (p3)
            this[kb] = { silent: g3, updateParams: L }, this[Tm] = false, this.getZr().wakeUp();
          else {
            try {
              D8(this), lk.update.call(this, null, L);
            } catch (F) {
              throw this[kb] = null, this[Tm] = false, F;
            }
            this._ssr || this._zr.flush(), this[kb] = null, this[Tm] = false, HH.call(this, g3), WH2.call(this, g3);
          }
        }
      }, i.prototype.setTheme = function() {
      }, i.prototype.getModel = function() {
        return this._model;
      }, i.prototype.getOption = function() {
        return this._model && this._model.getOption();
      }, i.prototype.getWidth = function() {
        return this._zr.getWidth();
      }, i.prototype.getHeight = function() {
        return this._zr.getHeight();
      }, i.prototype.getDevicePixelRatio = function() {
        return this._zr.painter.dpr || ymt && window.devicePixelRatio || 1;
      }, i.prototype.getRenderedCanvas = function(t3) {
        return this.renderToCanvas(t3);
      }, i.prototype.renderToCanvas = function(t3) {
        t3 = t3 || {};
        var c3 = this._zr.painter;
        return c3.getRenderedCanvas({ backgroundColor: t3.backgroundColor || this._model.get("backgroundColor"), pixelRatio: t3.pixelRatio || this.getDevicePixelRatio() });
      }, i.prototype.renderToSVGString = function(t3) {
        t3 = t3 || {};
        var c3 = this._zr.painter;
        return c3.renderToString({ useViewBox: t3.useViewBox });
      }, i.prototype.getSvgDataURL = function() {
        if (yo.svgSupported) {
          var t3 = this._zr, c3 = t3.storage.getDisplayList();
          return yt(c3, function(p3) {
            p3.stopAnimation(null, true);
          }), t3.painter.toDataURL();
        }
      }, i.prototype.getDataURL = function(t3) {
        if (this._disposed) {
          this.id;
          return;
        }
        t3 = t3 || {};
        var c3 = t3.excludeComponents, p3 = this._model, g3 = [], b3 = this;
        yt(c3, function(M) {
          p3.eachComponent({ mainType: M }, function(I) {
            var k3 = b3._componentsMap[I.__viewId];
            k3.group.ignore || (g3.push(k3), k3.group.ignore = true);
          });
        });
        var w3 = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(t3).toDataURL("image/" + (t3 && t3.type || "png"));
        return yt(g3, function(M) {
          M.group.ignore = false;
        }), w3;
      }, i.prototype.getConnectedDataURL = function(t3) {
        if (this._disposed) {
          this.id;
          return;
        }
        var c3 = t3.type === "svg", p3 = this.group, g3 = Math.min, b3 = Math.max, w3 = 1 / 0;
        if (I4e[p3]) {
          var M = w3, I = w3, k3 = -w3, L = -w3, F = [], B = t3 && t3.pixelRatio || this.getDevicePixelRatio();
          yt(qH, function(be, de) {
            if (be.group === p3) {
              var Fe = c3 ? be.getZr().painter.getSvgDom().innerHTML : be.renderToCanvas(Jo(t3)), Pe = be.getDom().getBoundingClientRect();
              M = g3(Pe.left, M), I = g3(Pe.top, I), k3 = b3(Pe.right, k3), L = b3(Pe.bottom, L), F.push({ dom: Fe, left: Pe.left, top: Pe.top });
            }
          }), M *= B, I *= B, k3 *= B, L *= B;
          var G = k3 - M, J = L - I, Q = cm.createCanvas(), se = wG(Q, { renderer: c3 ? "svg" : "canvas" });
          if (se.resize({ width: G, height: J }), c3) {
            var he = "";
            return yt(F, function(be) {
              var de = be.left - M, Fe = be.top - I;
              he += '<g transform="translate(' + de + "," + Fe + ')">' + be.dom + "</g>";
            }), se.painter.getSvgRoot().innerHTML = he, t3.connectedBackgroundColor && se.painter.setBackgroundColor(t3.connectedBackgroundColor), se.refreshImmediately(), se.painter.toDataURL();
          } else
            return t3.connectedBackgroundColor && se.add(new bu({ shape: { x: 0, y: 0, width: G, height: J }, style: { fill: t3.connectedBackgroundColor } })), yt(F, function(be) {
              var de = new Gv({ style: { x: be.left * B - M, y: be.top * B - I, image: be.dom } });
              se.add(de);
            }), se.refreshImmediately(), Q.toDataURL("image/" + (t3 && t3.type || "png"));
        } else
          return this.getDataURL(t3);
      }, i.prototype.convertToPixel = function(t3, c3) {
        return $ge(this, "convertToPixel", t3, c3);
      }, i.prototype.convertFromPixel = function(t3, c3) {
        return $ge(this, "convertFromPixel", t3, c3);
      }, i.prototype.containPixel = function(t3, c3) {
        if (this._disposed) {
          this.id;
          return;
        }
        var p3 = this._model, g3, b3 = VP(p3, t3);
        return yt(b3, function(w3, M) {
          M.indexOf("Models") >= 0 && yt(w3, function(I) {
            var k3 = I.coordinateSystem;
            if (k3 && k3.containPoint)
              g3 = g3 || !!k3.containPoint(c3);
            else if (M === "seriesModels") {
              var L = this._chartsMap[I.__viewId];
              L && L.containPoint && (g3 = g3 || L.containPoint(c3, I));
            }
          }, this);
        }, this), !!g3;
      }, i.prototype.getVisual = function(t3, c3) {
        var p3 = this._model, g3 = VP(p3, t3, { defaultMainType: "series" }), b3 = g3.seriesModel, w3 = b3.getData(), M = g3.hasOwnProperty("dataIndexInside") ? g3.dataIndexInside : g3.hasOwnProperty("dataIndex") ? w3.indexOfRawIndex(g3.dataIndex) : null;
        return M != null ? Vge(w3, M, c3) : BH(w3, c3);
      }, i.prototype.getViewOfComponentModel = function(t3) {
        return this._componentsMap[t3.__viewId];
      }, i.prototype.getViewOfSeriesModel = function(t3) {
        return this._chartsMap[t3.__viewId];
      }, i.prototype._initEvents = function() {
        var t3 = this;
        yt(Omt, function(c3) {
          var p3 = function(g3) {
            var b3 = t3.getModel(), w3 = g3.target, M, I = c3 === "globalout";
            if (I ? M = {} : w3 && A8(w3, function(G) {
              var J = La(G);
              if (J && J.dataIndex != null) {
                var Q = J.dataModel || b3.getSeriesByIndex(J.seriesIndex);
                return M = Q && Q.getDataParams(J.dataIndex, J.dataType) || {}, true;
              } else if (J.eventData)
                return M = ti({}, J.eventData), true;
            }, true), M) {
              var k3 = M.componentType, L = M.componentIndex;
              (k3 === "markLine" || k3 === "markPoint" || k3 === "markArea") && (k3 = "series", L = M.seriesIndex);
              var F = k3 && L != null && b3.getComponent(k3, L), B = F && t3[F.mainType === "series" ? "_chartsMap" : "_componentsMap"][F.__viewId];
              M.event = g3, M.type = c3, t3._$eventProcessor.eventInfo = { targetEl: w3, packedEvent: M, model: F, view: B }, t3.trigger(c3, M);
            }
          };
          p3.zrEventfulCallAtLast = true, t3._zr.on(c3, p3, t3);
        }), yt(UH, function(c3, p3) {
          t3._messageCenter.on(p3, function(g3) {
            this.trigger(p3, g3);
          }, t3);
        }), yt(["selectchanged"], function(c3) {
          t3._messageCenter.on(c3, function(p3) {
            this.trigger(c3, p3);
          }, t3);
        }), Byt(this._messageCenter, this, this._api);
      }, i.prototype.isDisposed = function() {
        return this._disposed;
      }, i.prototype.clear = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this.setOption({ series: [] }, true);
      }, i.prototype.dispose = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this._disposed = true;
        var t3 = this.getDom();
        t3 && TG(this.getDom(), t0e, "");
        var c3 = this, p3 = c3._api, g3 = c3._model;
        yt(c3._componentsViews, function(b3) {
          b3.dispose(g3, p3);
        }), yt(c3._chartsViews, function(b3) {
          b3.dispose(g3, p3);
        }), c3._zr.dispose(), c3._dom = c3._model = c3._chartsMap = c3._componentsMap = c3._chartsViews = c3._componentsViews = c3._scheduler = c3._api = c3._zr = c3._throttledZrFlush = c3._theme = c3._coordSysMgr = c3._messageCenter = null, delete qH[c3.id];
      }, i.prototype.resize = function(t3) {
        if (!this[Tm]) {
          if (this._disposed) {
            this.id;
            return;
          }
          this._zr.resize(t3);
          var c3 = this._model;
          if (this._loadingFX && this._loadingFX.resize(), !!c3) {
            var p3 = c3.resetOption("media"), g3 = t3 && t3.silent;
            this[kb] && (g3 == null && (g3 = this[kb].silent), p3 = true, this[kb] = null), this[Tm] = true;
            try {
              p3 && D8(this), lk.update.call(this, { type: "resize", animation: ti({ duration: 0 }, t3 && t3.animation) });
            } catch (b3) {
              throw this[Tm] = false, b3;
            }
            this[Tm] = false, HH.call(this, g3), WH2.call(this, g3);
          }
        }
      }, i.prototype.showLoading = function(t3, c3) {
        if (this._disposed) {
          this.id;
          return;
        }
        if (Ua(t3) && (c3 = t3, t3 = ""), t3 = t3 || "default", this.hideLoading(), !!e0e[t3]) {
          var p3 = e0e[t3](this._api, c3), g3 = this._zr;
          this._loadingFX = p3, g3.add(p3);
        }
      }, i.prototype.hideLoading = function() {
        if (this._disposed) {
          this.id;
          return;
        }
        this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
      }, i.prototype.makeActionFromEvent = function(t3) {
        var c3 = ti({}, t3);
        return c3.type = UH[t3.type], c3;
      }, i.prototype.dispatchAction = function(t3, c3) {
        if (this._disposed) {
          this.id;
          return;
        }
        if (Ua(c3) || (c3 = { silent: !!c3 }), !!Lte[t3.type] && !!this._model) {
          if (this[Tm]) {
            this._pendingActions.push(t3);
            return;
          }
          var p3 = c3.silent;
          Yge.call(this, t3, p3);
          var g3 = c3.flush;
          g3 ? this._zr.flush() : g3 !== false && yo.browser.weChat && this._throttledZrFlush(), HH.call(this, p3), WH2.call(this, p3);
        }
      }, i.prototype.updateLabelLayout = function() {
        X2.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
      }, i.prototype.appendData = function(t3) {
        if (this._disposed) {
          this.id;
          return;
        }
        var c3 = t3.seriesIndex, p3 = this.getModel(), g3 = p3.getSeriesByIndex(c3);
        g3.appendData(t3), this._scheduler.unfinished = true, this.getZr().wakeUp();
      }, i.internalField = function() {
        D8 = function(L) {
          var F = L._scheduler;
          F.restorePipelines(L._model), F.prepareStageTasks(), qge(L, true), qge(L, false), F.plan();
        }, qge = function(L, F) {
          for (var B = L._model, G = L._scheduler, J = F ? L._componentsViews : L._chartsViews, Q = F ? L._componentsMap : L._chartsMap, se = L._zr, he = L._api, be = 0; be < J.length; be++)
            J[be].__alive = false;
          F ? B.eachComponent(function(Pe, ze) {
            Pe !== "series" && de(ze);
          }) : B.eachSeries(de);
          function de(Pe) {
            var ze = Pe.__requireNewView;
            Pe.__requireNewView = false;
            var $e = "_ec_" + Pe.id + "_" + Pe.type, Ke = !ze && Q[$e];
            if (!Ke) {
              var nt = P1(Pe.type), lt2 = F ? ed.getClass(nt.main, nt.sub) : yh.getClass(nt.sub);
              Ke = new lt2(), Ke.init(B, he), Q[$e] = Ke, J.push(Ke), se.add(Ke.group);
            }
            Pe.__viewId = Ke.__id = $e, Ke.__alive = true, Ke.__model = Pe, Ke.group.__ecComponentInfo = { mainType: Pe.mainType, index: Pe.componentIndex }, !F && G.prepareView(Ke, Pe, B, he);
          }
          for (var be = 0; be < J.length; ) {
            var Fe = J[be];
            Fe.__alive ? be++ : (!F && Fe.renderTask.dispose(), se.remove(Fe.group), Fe.dispose(B, he), J.splice(be, 1), Q[Fe.__id] === Fe && delete Q[Fe.__id], Fe.__id = Fe.group.__ecComponentInfo = null);
          }
        }, Ote = function(L, F, B, G, J) {
          var Q = L._model;
          if (Q.setUpdatePayload(B), !G) {
            yt([].concat(L._componentsViews).concat(L._chartsViews), Fe);
            return;
          }
          var se = {};
          se[G + "Id"] = B[G + "Id"], se[G + "Index"] = B[G + "Index"], se[G + "Name"] = B[G + "Name"];
          var he = { mainType: G, query: se };
          J && (he.subType = J);
          var be = B.excludeSeriesId, de;
          be != null && (de = Eo(), yt(Wc(be), function(Pe) {
            var ze = Jf(Pe, null);
            ze != null && de.set(ze, true);
          })), Q && Q.eachComponent(he, function(Pe) {
            var ze = de && de.get(Pe.id) !== null;
            if (!ze)
              if (fv(B))
                if (Pe instanceof bp)
                  B.type === my && !B.notBlur && !Pe.get(["emphasis", "disabled"]) && mve(Pe, B, L._api);
                else {
                  var $e = oH(Pe.mainType, Pe.componentIndex, B.name, L._api), Ke = $e.focusSelf, nt = $e.dispatchers;
                  B.type === my && Ke && !B.notBlur && K5(Pe.mainType, Pe.componentIndex, L._api), nt && yt(nt, function(lt2) {
                    B.type === my ? Hv(lt2) : sl(lt2);
                  });
                }
              else
                lH(B) && Pe instanceof bp && (xve(Pe, B, L._api), Nee(Pe), Ow(L));
          }, L), Q && Q.eachComponent(he, function(Pe) {
            var ze = de && de.get(Pe.id) !== null;
            ze || Fe(L[G === "series" ? "_chartsMap" : "_componentsMap"][Pe.__viewId]);
          }, L);
          function Fe(Pe) {
            Pe && Pe.__alive && Pe[F] && Pe[F](Pe.__model, Q, L._api, B);
          }
        }, lk = { prepareAndUpdate: function(L) {
          D8(this), lk.update.call(this, L, { optionChanged: L.newOption != null });
        }, update: function(L, F) {
          var B = this._model, G = this._api, J = this._zr, Q = this._coordSysMgr, se = this._scheduler;
          if (B) {
            B.setUpdatePayload(L), se.restoreData(B, L), se.performSeriesTasks(B), Q.create(B, G), se.performDataProcessorTasks(B, L), Xge(this, B), Q.update(B, G), t3(B), se.performVisualTasks(B, L), Kge(this, B, G, L, F);
            var he = B.get("backgroundColor") || "transparent", be = B.get("darkMode");
            J.setBackgroundColor(he), be != null && be !== "auto" && J.setDarkMode(be), X2.trigger("afterupdate", B, G);
          }
        }, updateTransform: function(L) {
          var F = this, B = this._model, G = this._api;
          if (B) {
            B.setUpdatePayload(L);
            var J = [];
            B.eachComponent(function(se, he) {
              if (se !== "series") {
                var be = F.getViewOfComponentModel(he);
                if (be && be.__alive)
                  if (be.updateTransform) {
                    var de = be.updateTransform(he, B, G, L);
                    de && de.update && J.push(be);
                  } else
                    J.push(be);
              }
            });
            var Q = Eo();
            B.eachSeries(function(se) {
              var he = F._chartsMap[se.__viewId];
              if (he.updateTransform) {
                var be = he.updateTransform(se, B, G, L);
                be && be.update && Q.set(se.uid, 1);
              } else
                Q.set(se.uid, 1);
            }), t3(B), this._scheduler.performVisualTasks(B, L, { setDirty: true, dirtyMap: Q }), Pte(this, B, G, L, {}, Q), X2.trigger("afterupdate", B, G);
          }
        }, updateView: function(L) {
          var F = this._model;
          !F || (F.setUpdatePayload(L), yh.markUpdateMethod(L, "updateView"), t3(F), this._scheduler.performVisualTasks(F, L, { setDirty: true }), Kge(this, F, this._api, L, {}), X2.trigger("afterupdate", F, this._api));
        }, updateVisual: function(L) {
          var F = this, B = this._model;
          !B || (B.setUpdatePayload(L), B.eachSeries(function(G) {
            G.getData().clearAllVisual();
          }), yh.markUpdateMethod(L, "updateVisual"), t3(B), this._scheduler.performVisualTasks(B, L, { visualType: "visual", setDirty: true }), B.eachComponent(function(G, J) {
            if (G !== "series") {
              var Q = F.getViewOfComponentModel(J);
              Q && Q.__alive && Q.updateVisual(J, B, F._api, L);
            }
          }), B.eachSeries(function(G) {
            var J = F._chartsMap[G.__viewId];
            J.updateVisual(G, B, F._api, L);
          }), X2.trigger("afterupdate", B, this._api));
        }, updateLayout: function(L) {
          lk.update.call(this, L);
        } }, $ge = function(L, F, B, G) {
          if (L._disposed) {
            L.id;
            return;
          }
          for (var J = L._model, Q = L._coordSysMgr.getCoordinateSystems(), se, he = VP(J, B), be = 0; be < Q.length; be++) {
            var de = Q[be];
            if (de[F] && (se = de[F](J, he, G)) != null)
              return se;
          }
        }, Xge = function(L, F) {
          var B = L._chartsMap, G = L._scheduler;
          F.eachSeries(function(J) {
            G.updateStreamModes(J, B[J.__viewId]);
          });
        }, Yge = function(L, F) {
          var B = this, G = this.getModel(), J = L.type, Q = L.escapeConnect, se = Lte[J], he = se.actionInfo, be = (he.update || "update").split(":"), de = be.pop(), Fe = be[0] != null && P1(be[0]);
          this[Tm] = true;
          var Pe = [L], ze = false;
          L.batch && (ze = true, Pe = Fi(L.batch, function(jt) {
            return jt = Uo(ti({}, jt), L), jt.batch = null, jt;
          }));
          var $e = [], Ke, nt = lH(L), lt2 = fv(L);
          if (lt2 && Ree(this._api), yt(Pe, function(jt) {
            if (Ke = se.action(jt, B._model, B._api), Ke = Ke || ti({}, jt), Ke.type = he.event || Ke.type, $e.push(Ke), lt2) {
              var Jt = MG(L), Rt = Jt.queryOptionMap, Jn = Jt.mainTypeSpecified, ln = Jn ? Rt.keys()[0] : "series";
              Ote(B, de, jt, ln), Ow(B);
            } else
              nt ? (Ote(B, de, jt, "series"), Ow(B)) : Fe && Ote(B, de, jt, Fe.main, Fe.sub);
          }), de !== "none" && !lt2 && !nt && !Fe)
            try {
              this[kb] ? (D8(this), lk.update.call(this, L), this[kb] = null) : lk[de].call(this, L);
            } catch (jt) {
              throw this[Tm] = false, jt;
            }
          if (ze ? Ke = { type: he.event || J, escapeConnect: Q, batch: $e } : Ke = $e[0], this[Tm] = false, !F) {
            var bt = this._messageCenter;
            if (bt.trigger(Ke.type, Ke), nt) {
              var vt = { type: "selectchanged", escapeConnect: Q, selected: wve(G), isFromClick: L.isFromClick || false, fromAction: L.type, fromActionPayload: L };
              bt.trigger(vt.type, vt);
            }
          }
        }, HH = function(L) {
          for (var F = this._pendingActions; F.length; ) {
            var B = F.shift();
            Yge.call(this, B, L);
          }
        }, WH2 = function(L) {
          !L && this.trigger("updated");
        }, _4e = function(L, F) {
          L.on("rendered", function(B) {
            F.trigger("rendered", B), L.animation.isFinished() && !F[kb] && !F._scheduler.unfinished && !F._pendingActions.length && F.trigger("finished");
          });
        }, x4e = function(L, F) {
          L.on("mouseover", function(B) {
            var G = B.target, J = A8(G, DI);
            J && (bve(J, B, F._api), Ow(F));
          }).on("mouseout", function(B) {
            var G = B.target, J = A8(G, DI);
            J && (_ve(J, B, F._api), Ow(F));
          }).on("click", function(B) {
            var G = B.target, J = A8(G, function(he) {
              return La(he).dataIndex != null;
            }, true);
            if (J) {
              var Q = J.selected ? "unselect" : "select", se = La(J);
              F._api.dispatchAction({ type: Q, dataType: se.dataType, dataIndexInside: se.dataIndex, seriesIndex: se.seriesIndex, isFromClick: true });
            }
          });
        };
        function t3(L) {
          L.clearColorPalette(), L.eachSeries(function(F) {
            F.clearColorPalette();
          });
        }
        function c3(L) {
          var F = [], B = [], G = false;
          if (L.eachComponent(function(he, be) {
            var de = be.get("zlevel") || 0, Fe = be.get("z") || 0, Pe = be.getZLevelKey();
            G = G || !!Pe, (he === "series" ? B : F).push({ zlevel: de, z: Fe, idx: be.componentIndex, type: he, key: Pe });
          }), G) {
            var J = F.concat(B), Q, se;
            tI(J, function(he, be) {
              return he.zlevel === be.zlevel ? he.z - be.z : he.zlevel - be.zlevel;
            }), yt(J, function(he) {
              var be = L.getComponent(he.type, he.idx), de = he.zlevel, Fe = he.key;
              Q != null && (de = Math.max(Q, de)), Fe ? (de === Q && Fe !== se && de++, se = Fe) : se && (de === Q && de++, se = ""), Q = de, be.setZLevel(de);
            });
          }
        }
        Kge = function(L, F, B, G, J) {
          c3(F), w4e(L, F, B, G, J), yt(L._chartsViews, function(Q) {
            Q.__alive = false;
          }), Pte(L, F, B, G, J), yt(L._chartsViews, function(Q) {
            Q.__alive || Q.remove(F, B);
          });
        }, w4e = function(L, F, B, G, J, Q) {
          yt(Q || L._componentsViews, function(se) {
            var he = se.__model;
            I(he, se), se.render(he, F, B, G), w3(he, se), k3(he, se);
          });
        }, Pte = function(L, F, B, G, J, Q) {
          var se = L._scheduler;
          J = ti(J || {}, { updatedSeries: F.getSeries() }), X2.trigger("series:beforeupdate", F, B, J);
          var he = false;
          F.eachSeries(function(be) {
            var de = L._chartsMap[be.__viewId];
            de.__alive = true;
            var Fe = de.renderTask;
            se.updatePayload(Fe, G), I(be, de), Q && Q.get(be.uid) && Fe.dirty(), Fe.perform(se.getPerformArgs(Fe)) && (he = true), de.group.silent = !!be.get("silent"), b3(be, de), Nee(be);
          }), se.unfinished = he || se.unfinished, X2.trigger("series:layoutlabels", F, B, J), X2.trigger("series:transition", F, B, J), F.eachSeries(function(be) {
            var de = L._chartsMap[be.__viewId];
            w3(be, de), k3(be, de);
          }), g3(L, F), X2.trigger("series:afterupdate", F, B, J);
        }, Ow = function(L) {
          L[Wge] = true, L.getZr().wakeUp();
        }, M4e = function(L) {
          !L[Wge] || (L.getZr().storage.traverse(function(F) {
            tk(F) || p3(F);
          }), L[Wge] = false);
        };
        function p3(L) {
          for (var F = [], B = L.currentStates, G = 0; G < B.length; G++) {
            var J = B[G];
            J === "emphasis" || J === "blur" || J === "select" || F.push(J);
          }
          L.selected && L.states.select && F.push("select"), L.hoverState === ZF && L.states.emphasis ? F.push("emphasis") : L.hoverState === WP && L.states.blur && F.push("blur"), L.useStates(F);
        }
        function g3(L, F) {
          var B = L._zr, G = B.storage, J = 0;
          G.traverse(function(Q) {
            Q.isGroup || J++;
          }), J > F.get("hoverLayerThreshold") && !yo.node && !yo.worker && F.eachSeries(function(Q) {
            if (!Q.preventUsingHoverLayer) {
              var se = L._chartsMap[Q.__viewId];
              se.__alive && se.eachRendered(function(he) {
                he.states.emphasis && (he.states.emphasis.hoverLayer = true);
              });
            }
          });
        }
        function b3(L, F) {
          var B = L.get("blendMode") || null;
          F.eachRendered(function(G) {
            G.isGroup || (G.style.blend = B);
          });
        }
        function w3(L, F) {
          if (!L.preventAutoZ) {
            var B = L.get("z") || 0, G = L.get("zlevel") || 0;
            F.eachRendered(function(J) {
              return M(J, B, G, -1 / 0), true;
            });
          }
        }
        function M(L, F, B, G) {
          var J = L.getTextContent(), Q = L.getTextGuideLine(), se = L.isGroup;
          if (se)
            for (var he = L.childrenRef(), be = 0; be < he.length; be++)
              G = Math.max(M(he[be], F, B, G), G);
          else
            L.z = F, L.zlevel = B, G = Math.max(L.z2, G);
          if (J && (J.z = F, J.zlevel = B, isFinite(G) && (J.z2 = G + 2)), Q) {
            var de = L.textGuideLineConfig;
            Q.z = F, Q.zlevel = B, isFinite(G) && (Q.z2 = G + (de && de.showAbove ? 1 : -1));
          }
          return G;
        }
        function I(L, F) {
          F.eachRendered(function(B) {
            if (!tk(B)) {
              var G = B.getTextContent(), J = B.getTextGuideLine();
              B.stateTransition && (B.stateTransition = null), G && G.stateTransition && (G.stateTransition = null), J && J.stateTransition && (J.stateTransition = null), B.hasState() ? (B.prevStates = B.currentStates, B.clearStates()) : B.prevStates && (B.prevStates = null);
            }
          });
        }
        function k3(L, F) {
          var B = L.getModel("stateAnimation"), G = L.isAnimationEnabled(), J = B.get("duration"), Q = J > 0 ? { duration: J, delay: B.get("delay"), easing: B.get("easing") } : null;
          F.eachRendered(function(se) {
            if (se.states && se.states.emphasis) {
              if (tk(se))
                return;
              if (se instanceof gl && mm(se), se.__dirty) {
                var he = se.prevStates;
                he && se.useStates(he);
              }
              if (G) {
                se.stateTransition = Q;
                var be = se.getTextContent(), de = se.getTextGuideLine();
                be && (be.stateTransition = Q), de && (de.stateTransition = Q);
              }
              se.__dirty && p3(se);
            }
          });
        }
        S4e = function(L) {
          return new (function(F) {
            cn(B, F);
            function B() {
              return F !== null && F.apply(this, arguments) || this;
            }
            return B.prototype.getCoordinateSystems = function() {
              return L._coordSysMgr.getCoordinateSystems();
            }, B.prototype.getComponentByElement = function(G) {
              for (; G; ) {
                var J = G.__ecComponentInfo;
                if (J != null)
                  return L._model.getComponent(J.mainType, J.index);
                G = G.parent;
              }
            }, B.prototype.enterEmphasis = function(G, J) {
              Hv(G, J), Ow(L);
            }, B.prototype.leaveEmphasis = function(G, J) {
              sl(G, J), Ow(L);
            }, B.prototype.enterBlur = function(G) {
              iH(G), Ow(L);
            }, B.prototype.leaveBlur = function(G) {
              R1(G), Ow(L);
            }, B.prototype.enterSelect = function(G) {
              aH(G), Ow(L);
            }, B.prototype.leaveSelect = function(G) {
              Lee(G), Ow(L);
            }, B.prototype.getModel = function() {
              return L.getModel();
            }, B.prototype.getViewOfComponentModel = function(G) {
              return L.getViewOfComponentModel(G);
            }, B.prototype.getViewOfSeriesModel = function(G) {
              return L.getViewOfSeriesModel(G);
            }, B;
          }(RLe))(L);
        }, C4e = function(L) {
          function F(B, G) {
            for (var J = 0; J < B.length; J++) {
              var Q = B[J];
              Q[Uge] = G;
            }
          }
          yt(UH, function(B, G) {
            L._messageCenter.on(G, function(J) {
              if (I4e[L.group] && L[Uge] !== d4e) {
                if (J && J.escapeConnect)
                  return;
                var Q = L.makeActionFromEvent(J), se = [];
                yt(qH, function(he) {
                  he !== L && he.group === L.group && se.push(he);
                }), F(se, d4e), yt(se, function(he) {
                  he[Uge] !== Dmt && he.dispatchAction(Q);
                }), F(se, kmt);
              }
            });
          });
        };
      }(), i;
    }(hm), Zge = T4e.prototype;
    Zge.on = v4e("on"), Zge.off = v4e("off"), Zge.one = function(o, i, t3) {
      var c3 = this;
      function p3() {
        for (var g3 = [], b3 = 0; b3 < arguments.length; b3++)
          g3[b3] = arguments[b3];
        i && i.apply && i.apply(this, g3), c3.off(o, p3);
      }
      this.on.call(this, o, p3, t3);
    };
    var Omt = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"], Lte = {}, UH = {}, Jge = [], Qge = [], Rte = [], A4e = {}, e0e = {}, qH = {}, I4e = {}, Pmt = +new Date() - 0, t0e = "_echarts_instance_";
    function Lmt(o, i, t3) {
      var c3 = !(t3 && t3.ssr);
      if (c3) {
        var p3 = Rmt(o);
        if (p3)
          return p3;
      }
      var g3 = new T4e(o, i, t3);
      return g3.id = "ec_" + Pmt++, qH[g3.id] = g3, c3 && TG(o, t0e, g3.id), C4e(g3), X2.trigger("afterinit", g3), g3;
    }
    function Rmt(o) {
      return qH[Ide(o, t0e)];
    }
    function E4e(o, i) {
      A4e[o] = i;
    }
    function D4e(o) {
      rl(Qge, o) < 0 && Qge.push(o);
    }
    function k4e(o, i) {
      r0e(Jge, o, i, wmt);
    }
    function Nmt(o) {
      n0e("afterinit", o);
    }
    function Fmt(o) {
      n0e("afterupdate", o);
    }
    function n0e(o, i) {
      X2.on(o, i);
    }
    function ZM(o, i, t3) {
      Vo(i) && (t3 = i, i = "");
      var c3 = Ua(o) ? o.type : [o, o = { event: i }][0];
      o.event = (o.event || c3).toLowerCase(), i = o.event, !UH[i] && (u0(p4e.test(c3) && p4e.test(i)), Lte[c3] || (Lte[c3] = { action: t3, actionInfo: o }), UH[i] = c3);
    }
    function Vmt(o, i) {
      DH.register(o, i);
    }
    function Bmt(o, i) {
      r0e(Rte, o, i, c4e, "layout");
    }
    function uL(o, i) {
      r0e(Rte, o, i, f4e, "visual");
    }
    var O4e = [];
    function r0e(o, i, t3, c3, p3) {
      if ((Vo(i) || Ua(i)) && (t3 = i, i = c3), !(rl(O4e, t3) >= 0)) {
        O4e.push(t3);
        var g3 = FRe.wrapStageHandler(t3, p3);
        g3.__prio = i, g3.__raw = t3, o.push(g3);
      }
    }
    function P4e(o, i) {
      e0e[o] = i;
    }
    function zmt(o, i, t3) {
      var c3 = gmt("registerMap");
      c3 && c3(o, i, t3);
    }
    var jmt = Y0t;
    uL(Hge, _yt), uL(kte, xyt), uL(kte, wyt), uL(Hge, Fyt), uL(kte, Vyt), uL(h4e, pmt), D4e(GLe), k4e(_mt, E0t), P4e("default", Syt), ZM({ type: my, event: my, update: my }, uf), ZM({ type: qP, event: qP, update: qP }, uf), ZM({ type: $M, event: $M, update: $M }, uf), ZM({ type: Hh, event: Hh, update: Hh }, uf), ZM({ type: Wh, event: Wh, update: Wh }, uf), E4e("light", Lyt), E4e("dark", Ryt);
    var L4e = [], Gmt = { registerPreprocessor: D4e, registerProcessor: k4e, registerPostInit: Nmt, registerPostUpdate: Fmt, registerUpdateLifecycle: n0e, registerAction: ZM, registerCoordinateSystem: Vmt, registerLayout: Bmt, registerVisual: uL, registerTransform: jmt, registerLoading: P4e, registerMap: zmt, registerImpl: vmt, PRIORITY: Emt, ComponentModel: nc, ComponentView: ed, SeriesModel: bp, ChartView: yh, registerComponentModel: function(o) {
      nc.registerClass(o);
    }, registerComponentView: function(o) {
      ed.registerClass(o);
    }, registerSeriesModel: function(o) {
      bp.registerClass(o);
    }, registerChartView: function(o) {
      yh.registerClass(o);
    }, registerSubTypeDefaulter: function(o, i) {
      nc.registerSubTypeDefaulter(o, i);
    }, registerPainter: function(o, i) {
      W5(o, i);
    } };
    function Tl(o) {
      if (Ei(o)) {
        yt(o, function(i) {
          Tl(i);
        });
        return;
      }
      rl(L4e, o) >= 0 || (L4e.push(o), Vo(o) && (o = { install: o }), o.install(Gmt));
    }
    function $H(o) {
      return o == null ? 0 : o.length || 1;
    }
    function R4e(o) {
      return o;
    }
    var Hmt = function() {
      function o(i, t3, c3, p3, g3, b3) {
        this._old = i, this._new = t3, this._oldKeyGetter = c3 || R4e, this._newKeyGetter = p3 || R4e, this.context = g3, this._diffModeMultiple = b3 === "multiple";
      }
      return o.prototype.add = function(i) {
        return this._add = i, this;
      }, o.prototype.update = function(i) {
        return this._update = i, this;
      }, o.prototype.updateManyToOne = function(i) {
        return this._updateManyToOne = i, this;
      }, o.prototype.updateOneToMany = function(i) {
        return this._updateOneToMany = i, this;
      }, o.prototype.updateManyToMany = function(i) {
        return this._updateManyToMany = i, this;
      }, o.prototype.remove = function(i) {
        return this._remove = i, this;
      }, o.prototype.execute = function() {
        this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
      }, o.prototype._executeOneToOne = function() {
        var i = this._old, t3 = this._new, c3 = {}, p3 = new Array(i.length), g3 = new Array(t3.length);
        this._initIndexMap(i, null, p3, "_oldKeyGetter"), this._initIndexMap(t3, c3, g3, "_newKeyGetter");
        for (var b3 = 0; b3 < i.length; b3++) {
          var w3 = p3[b3], M = c3[w3], I = $H(M);
          if (I > 1) {
            var k3 = M.shift();
            M.length === 1 && (c3[w3] = M[0]), this._update && this._update(k3, b3);
          } else
            I === 1 ? (c3[w3] = null, this._update && this._update(M, b3)) : this._remove && this._remove(b3);
        }
        this._performRestAdd(g3, c3);
      }, o.prototype._executeMultiple = function() {
        var i = this._old, t3 = this._new, c3 = {}, p3 = {}, g3 = [], b3 = [];
        this._initIndexMap(i, c3, g3, "_oldKeyGetter"), this._initIndexMap(t3, p3, b3, "_newKeyGetter");
        for (var w3 = 0; w3 < g3.length; w3++) {
          var M = g3[w3], I = c3[M], k3 = p3[M], L = $H(I), F = $H(k3);
          if (L > 1 && F === 1)
            this._updateManyToOne && this._updateManyToOne(k3, I), p3[M] = null;
          else if (L === 1 && F > 1)
            this._updateOneToMany && this._updateOneToMany(k3, I), p3[M] = null;
          else if (L === 1 && F === 1)
            this._update && this._update(k3, I), p3[M] = null;
          else if (L > 1 && F > 1)
            this._updateManyToMany && this._updateManyToMany(k3, I), p3[M] = null;
          else if (L > 1)
            for (var B = 0; B < L; B++)
              this._remove && this._remove(I[B]);
          else
            this._remove && this._remove(I);
        }
        this._performRestAdd(b3, p3);
      }, o.prototype._performRestAdd = function(i, t3) {
        for (var c3 = 0; c3 < i.length; c3++) {
          var p3 = i[c3], g3 = t3[p3], b3 = $H(g3);
          if (b3 > 1)
            for (var w3 = 0; w3 < b3; w3++)
              this._add && this._add(g3[w3]);
          else
            b3 === 1 && this._add && this._add(g3);
          t3[p3] = null;
        }
      }, o.prototype._initIndexMap = function(i, t3, c3, p3) {
        for (var g3 = this._diffModeMultiple, b3 = 0; b3 < i.length; b3++) {
          var w3 = "_ec_" + this[p3](i[b3], b3);
          if (g3 || (c3[b3] = w3), !!t3) {
            var M = t3[w3], I = $H(M);
            I === 0 ? (t3[w3] = b3, g3 && c3.push(w3)) : I === 1 ? t3[w3] = [M, b3] : M.push(b3);
          }
        }
      }, o;
    }(), RI = Hmt, Wmt = function() {
      function o(i, t3) {
        this._encode = i, this._schema = t3;
      }
      return o.prototype.get = function() {
        return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
      }, o.prototype._getFullDimensionNames = function() {
        return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
      }, o;
    }();
    function Umt(o, i) {
      var t3 = {}, c3 = t3.encode = {}, p3 = Eo(), g3 = [], b3 = [], w3 = {};
      yt(o.dimensions, function(F) {
        var B = o.getDimensionInfo(F), G = B.coordDim;
        if (G) {
          var J = B.coordDimIndex;
          i0e(c3, G)[J] = F, B.isExtraCoord || (p3.set(G, 1), qmt(B.type) && (g3[0] = F), i0e(w3, G)[J] = o.getDimensionIndex(B.name)), B.defaultTooltip && b3.push(F);
        }
        _Le.each(function(Q, se) {
          var he = i0e(c3, se), be = B.otherDims[se];
          be != null && be !== false && (he[be] = B.name);
        });
      });
      var M = [], I = {};
      p3.each(function(F, B) {
        var G = c3[B];
        I[B] = G[0], M = M.concat(G);
      }), t3.dataDimsOnCoord = M, t3.dataDimIndicesOnCoord = Fi(M, function(F) {
        return o.getDimensionInfo(F).storeDimIndex;
      }), t3.encodeFirstDimNotExtra = I;
      var k3 = c3.label;
      k3 && k3.length && (g3 = k3.slice());
      var L = c3.tooltip;
      return L && L.length ? b3 = L.slice() : b3.length || (b3 = g3.slice()), c3.defaultedLabel = g3, c3.defaultedTooltip = b3, t3.userOutput = new Wmt(w3, i), t3;
    }
    function i0e(o, i) {
      return o.hasOwnProperty(i) || (o[i] = []), o[i];
    }
    function Nte(o) {
      return o === "category" ? "ordinal" : o === "time" ? "time" : "float";
    }
    function qmt(o) {
      return !(o === "ordinal" || o === "time");
    }
    var $mt = function() {
      function o(i) {
        this.otherDims = {}, i != null && ti(this, i);
      }
      return o;
    }(), Fte = $mt, Xmt = mu(), Ymt = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, N4e = function() {
      function o(i) {
        this.dimensions = i.dimensions, this._dimOmitted = i.dimensionOmitted, this.source = i.source, this._fullDimCount = i.fullDimensionCount, this._updateDimOmitted(i.dimensionOmitted);
      }
      return o.prototype.isDimensionOmitted = function() {
        return this._dimOmitted;
      }, o.prototype._updateDimOmitted = function(i) {
        this._dimOmitted = i, i && (this._dimNameMap || (this._dimNameMap = B4e(this.source)));
      }, o.prototype.getSourceDimensionIndex = function(i) {
        return Xs(this._dimNameMap.get(i), -1);
      }, o.prototype.getSourceDimension = function(i) {
        var t3 = this.source.dimensionsDefine;
        if (t3)
          return t3[i];
      }, o.prototype.makeStoreSchema = function() {
        for (var i = this._fullDimCount, t3 = qLe(this.source), c3 = !z4e(i), p3 = "", g3 = [], b3 = 0, w3 = 0; b3 < i; b3++) {
          var M = void 0, I = void 0, k3 = void 0, L = this.dimensions[w3];
          if (L && L.storeDimIndex === b3)
            M = t3 ? L.name : null, I = L.type, k3 = L.ordinalMeta, w3++;
          else {
            var F = this.getSourceDimension(b3);
            F && (M = t3 ? F.name : null, I = F.type);
          }
          g3.push({ property: M, type: I, ordinalMeta: k3 }), t3 && M != null && (!L || !L.isCalculationCoord) && (p3 += c3 ? M.replace(/\`/g, "`1").replace(/\$/g, "`2") : M), p3 += "$", p3 += Ymt[I] || "f", k3 && (p3 += k3.uid), p3 += "$";
        }
        var B = this.source, G = [B.seriesLayoutBy, B.startIndex, p3].join("$$");
        return { dimensions: g3, hash: G };
      }, o.prototype.makeOutputDimensionNames = function() {
        for (var i = [], t3 = 0, c3 = 0; t3 < this._fullDimCount; t3++) {
          var p3 = void 0, g3 = this.dimensions[c3];
          if (g3 && g3.storeDimIndex === t3)
            g3.isCalculationCoord || (p3 = g3.name), c3++;
          else {
            var b3 = this.getSourceDimension(t3);
            b3 && (p3 = b3.name);
          }
          i.push(p3);
        }
        return i;
      }, o.prototype.appendCalculationDimension = function(i) {
        this.dimensions.push(i), i.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
      }, o;
    }();
    function F4e(o) {
      return o instanceof N4e;
    }
    function V4e(o) {
      for (var i = Eo(), t3 = 0; t3 < (o || []).length; t3++) {
        var c3 = o[t3], p3 = Ua(c3) ? c3.name : c3;
        p3 != null && i.get(p3) == null && i.set(p3, t3);
      }
      return i;
    }
    function B4e(o) {
      var i = Xmt(o);
      return i.dimNameMap || (i.dimNameMap = V4e(o.dimensionsDefine));
    }
    function z4e(o) {
      return o > 30;
    }
    var XH = Ua, uk = Fi, Kmt = typeof Int32Array == "undefined" ? Array : Int32Array, Zmt = "e\0\0", j4e = -1, Jmt = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], Qmt = ["_approximateExtent"], G4e, Vte, YH, KH, a0e, Bte, o0e, e1t = function() {
      function o(i, t3) {
        this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
        var c3, p3 = false;
        F4e(i) ? (c3 = i.dimensions, this._dimOmitted = i.isDimensionOmitted(), this._schema = i) : (p3 = true, c3 = i), c3 = c3 || ["x", "y"];
        for (var g3 = {}, b3 = [], w3 = {}, M = false, I = {}, k3 = 0; k3 < c3.length; k3++) {
          var L = c3[k3], F = Ha(L) ? new Fte({ name: L }) : L instanceof Fte ? L : new Fte(L), B = F.name;
          F.type = F.type || "float", F.coordDim || (F.coordDim = B, F.coordDimIndex = 0);
          var G = F.otherDims = F.otherDims || {};
          b3.push(B), g3[B] = F, I[B] != null && (M = true), F.createInvertedIndices && (w3[B] = []), G.itemName === 0 && (this._nameDimIdx = k3), G.itemId === 0 && (this._idDimIdx = k3), p3 && (F.storeDimIndex = k3);
        }
        if (this.dimensions = b3, this._dimInfos = g3, this._initGetDimensionInfo(M), this.hostModel = t3, this._invertedIndicesMap = w3, this._dimOmitted) {
          var J = this._dimIdxToName = Eo();
          yt(b3, function(Q) {
            J.set(g3[Q].storeDimIndex, Q);
          });
        }
      }
      return o.prototype.getDimension = function(i) {
        var t3 = this._recognizeDimIndex(i);
        if (t3 == null)
          return i;
        if (t3 = i, !this._dimOmitted)
          return this.dimensions[t3];
        var c3 = this._dimIdxToName.get(t3);
        if (c3 != null)
          return c3;
        var p3 = this._schema.getSourceDimension(t3);
        if (p3)
          return p3.name;
      }, o.prototype.getDimensionIndex = function(i) {
        var t3 = this._recognizeDimIndex(i);
        if (t3 != null)
          return t3;
        if (i == null)
          return -1;
        var c3 = this._getDimInfo(i);
        return c3 ? c3.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(i) : -1;
      }, o.prototype._recognizeDimIndex = function(i) {
        if (ec(i) || i != null && !isNaN(i) && !this._getDimInfo(i) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(i) < 0))
          return +i;
      }, o.prototype._getStoreDimIndex = function(i) {
        var t3 = this.getDimensionIndex(i);
        return t3;
      }, o.prototype.getDimensionInfo = function(i) {
        return this._getDimInfo(this.getDimension(i));
      }, o.prototype._initGetDimensionInfo = function(i) {
        var t3 = this._dimInfos;
        this._getDimInfo = i ? function(c3) {
          return t3.hasOwnProperty(c3) ? t3[c3] : void 0;
        } : function(c3) {
          return t3[c3];
        };
      }, o.prototype.getDimensionsOnCoord = function() {
        return this._dimSummary.dataDimsOnCoord.slice();
      }, o.prototype.mapDimension = function(i, t3) {
        var c3 = this._dimSummary;
        if (t3 == null)
          return c3.encodeFirstDimNotExtra[i];
        var p3 = c3.encode[i];
        return p3 ? p3[t3] : null;
      }, o.prototype.mapDimensionsAll = function(i) {
        var t3 = this._dimSummary, c3 = t3.encode[i];
        return (c3 || []).slice();
      }, o.prototype.getStore = function() {
        return this._store;
      }, o.prototype.initData = function(i, t3, c3) {
        var p3 = this, g3;
        if (i instanceof Ege && (g3 = i), !g3) {
          var b3 = this.dimensions, w3 = xge(i) || yg(i) ? new YLe(i, b3.length) : i;
          g3 = new Ege();
          var M = uk(b3, function(I) {
            return { type: p3._dimInfos[I].type, property: I };
          });
          g3.initData(w3, M, c3);
        }
        this._store = g3, this._nameList = (t3 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, g3.count()), this._dimSummary = Umt(this, this._schema), this.userOutput = this._dimSummary.userOutput;
      }, o.prototype.appendData = function(i) {
        var t3 = this._store.appendData(i);
        this._doInit(t3[0], t3[1]);
      }, o.prototype.appendValues = function(i, t3) {
        var c3 = this._store.appendValues(i, t3.length), p3 = c3.start, g3 = c3.end, b3 = this._shouldMakeIdFromName();
        if (this._updateOrdinalMeta(), t3)
          for (var w3 = p3; w3 < g3; w3++) {
            var M = w3 - p3;
            this._nameList[w3] = t3[M], b3 && o0e(this, w3);
          }
      }, o.prototype._updateOrdinalMeta = function() {
        for (var i = this._store, t3 = this.dimensions, c3 = 0; c3 < t3.length; c3++) {
          var p3 = this._dimInfos[t3[c3]];
          p3.ordinalMeta && i.collectOrdinalMeta(p3.storeDimIndex, p3.ordinalMeta);
        }
      }, o.prototype._shouldMakeIdFromName = function() {
        var i = this._store.getProvider();
        return this._idDimIdx == null && i.getSource().sourceFormat !== ak && !i.fillStorage;
      }, o.prototype._doInit = function(i, t3) {
        if (!(i >= t3)) {
          var c3 = this._store, p3 = c3.getProvider();
          this._updateOrdinalMeta();
          var g3 = this._nameList, b3 = this._idList, w3 = p3.getSource().sourceFormat, M = w3 === Ew;
          if (M && !p3.pure)
            for (var I = [], k3 = i; k3 < t3; k3++) {
              var L = p3.getItem(k3, I);
              if (!this.hasItemOption && KQ(L) && (this.hasItemOption = true), L) {
                var F = L.name;
                g3[k3] == null && F != null && (g3[k3] = Jf(F, null));
                var B = L.id;
                b3[k3] == null && B != null && (b3[k3] = Jf(B, null));
              }
            }
          if (this._shouldMakeIdFromName())
            for (var k3 = i; k3 < t3; k3++)
              o0e(this, k3);
          G4e(this);
        }
      }, o.prototype.getApproximateExtent = function(i) {
        return this._approximateExtent[i] || this._store.getDataExtent(this._getStoreDimIndex(i));
      }, o.prototype.setApproximateExtent = function(i, t3) {
        t3 = this.getDimension(t3), this._approximateExtent[t3] = i.slice();
      }, o.prototype.getCalculationInfo = function(i) {
        return this._calculationInfo[i];
      }, o.prototype.setCalculationInfo = function(i, t3) {
        XH(i) ? ti(this._calculationInfo, i) : this._calculationInfo[i] = t3;
      }, o.prototype.getName = function(i) {
        var t3 = this.getRawIndex(i), c3 = this._nameList[t3];
        return c3 == null && this._nameDimIdx != null && (c3 = YH(this, this._nameDimIdx, t3)), c3 == null && (c3 = ""), c3;
      }, o.prototype._getCategory = function(i, t3) {
        var c3 = this._store.get(i, t3), p3 = this._store.getOrdinalMeta(i);
        return p3 ? p3.categories[c3] : c3;
      }, o.prototype.getId = function(i) {
        return Vte(this, this.getRawIndex(i));
      }, o.prototype.count = function() {
        return this._store.count();
      }, o.prototype.get = function(i, t3) {
        var c3 = this._store, p3 = this._dimInfos[i];
        if (p3)
          return c3.get(p3.storeDimIndex, t3);
      }, o.prototype.getByRawIndex = function(i, t3) {
        var c3 = this._store, p3 = this._dimInfos[i];
        if (p3)
          return c3.getByRawIndex(p3.storeDimIndex, t3);
      }, o.prototype.getIndices = function() {
        return this._store.getIndices();
      }, o.prototype.getDataExtent = function(i) {
        return this._store.getDataExtent(this._getStoreDimIndex(i));
      }, o.prototype.getSum = function(i) {
        return this._store.getSum(this._getStoreDimIndex(i));
      }, o.prototype.getMedian = function(i) {
        return this._store.getMedian(this._getStoreDimIndex(i));
      }, o.prototype.getValues = function(i, t3) {
        var c3 = this, p3 = this._store;
        return Ei(i) ? p3.getValues(uk(i, function(g3) {
          return c3._getStoreDimIndex(g3);
        }), t3) : p3.getValues(i);
      }, o.prototype.hasValue = function(i) {
        for (var t3 = this._dimSummary.dataDimIndicesOnCoord, c3 = 0, p3 = t3.length; c3 < p3; c3++)
          if (isNaN(this._store.get(t3[c3], i)))
            return false;
        return true;
      }, o.prototype.indexOfName = function(i) {
        for (var t3 = 0, c3 = this._store.count(); t3 < c3; t3++)
          if (this.getName(t3) === i)
            return t3;
        return -1;
      }, o.prototype.getRawIndex = function(i) {
        return this._store.getRawIndex(i);
      }, o.prototype.indexOfRawIndex = function(i) {
        return this._store.indexOfRawIndex(i);
      }, o.prototype.rawIndexOf = function(i, t3) {
        var c3 = i && this._invertedIndicesMap[i], p3 = c3[t3];
        return p3 == null || isNaN(p3) ? j4e : p3;
      }, o.prototype.indicesOfNearest = function(i, t3, c3) {
        return this._store.indicesOfNearest(this._getStoreDimIndex(i), t3, c3);
      }, o.prototype.each = function(i, t3, c3) {
        Vo(i) && (c3 = t3, t3 = i, i = []);
        var p3 = c3 || this, g3 = uk(KH(i), this._getStoreDimIndex, this);
        this._store.each(g3, p3 ? Qa(t3, p3) : t3);
      }, o.prototype.filterSelf = function(i, t3, c3) {
        Vo(i) && (c3 = t3, t3 = i, i = []);
        var p3 = c3 || this, g3 = uk(KH(i), this._getStoreDimIndex, this);
        return this._store = this._store.filter(g3, p3 ? Qa(t3, p3) : t3), this;
      }, o.prototype.selectRange = function(i) {
        var t3 = this, c3 = {}, p3 = Gl(i);
        return yt(p3, function(g3) {
          var b3 = t3._getStoreDimIndex(g3);
          c3[b3] = i[g3];
        }), this._store = this._store.selectRange(c3), this;
      }, o.prototype.mapArray = function(i, t3, c3) {
        Vo(i) && (c3 = t3, t3 = i, i = []), c3 = c3 || this;
        var p3 = [];
        return this.each(i, function() {
          p3.push(t3 && t3.apply(this, arguments));
        }, c3), p3;
      }, o.prototype.map = function(i, t3, c3, p3) {
        var g3 = c3 || p3 || this, b3 = uk(KH(i), this._getStoreDimIndex, this), w3 = Bte(this);
        return w3._store = this._store.map(b3, g3 ? Qa(t3, g3) : t3), w3;
      }, o.prototype.modify = function(i, t3, c3, p3) {
        var g3 = c3 || p3 || this, b3 = uk(KH(i), this._getStoreDimIndex, this);
        this._store.modify(b3, g3 ? Qa(t3, g3) : t3);
      }, o.prototype.downSample = function(i, t3, c3, p3) {
        var g3 = Bte(this);
        return g3._store = this._store.downSample(this._getStoreDimIndex(i), t3, c3, p3), g3;
      }, o.prototype.lttbDownSample = function(i, t3) {
        var c3 = Bte(this);
        return c3._store = this._store.lttbDownSample(this._getStoreDimIndex(i), t3), c3;
      }, o.prototype.getRawDataItem = function(i) {
        return this._store.getRawDataItem(i);
      }, o.prototype.getItemModel = function(i) {
        var t3 = this.hostModel, c3 = this.getRawDataItem(i);
        return new gh(c3, t3, t3 && t3.ecModel);
      }, o.prototype.diff = function(i) {
        var t3 = this;
        return new RI(i ? i.getStore().getIndices() : [], this.getStore().getIndices(), function(c3) {
          return Vte(i, c3);
        }, function(c3) {
          return Vte(t3, c3);
        });
      }, o.prototype.getVisual = function(i) {
        var t3 = this._visual;
        return t3 && t3[i];
      }, o.prototype.setVisual = function(i, t3) {
        this._visual = this._visual || {}, XH(i) ? ti(this._visual, i) : this._visual[i] = t3;
      }, o.prototype.getItemVisual = function(i, t3) {
        var c3 = this._itemVisuals[i], p3 = c3 && c3[t3];
        return p3 == null ? this.getVisual(t3) : p3;
      }, o.prototype.hasItemVisual = function() {
        return this._itemVisuals.length > 0;
      }, o.prototype.ensureUniqueItemVisual = function(i, t3) {
        var c3 = this._itemVisuals, p3 = c3[i];
        p3 || (p3 = c3[i] = {});
        var g3 = p3[t3];
        return g3 == null && (g3 = this.getVisual(t3), Ei(g3) ? g3 = g3.slice() : XH(g3) && (g3 = ti({}, g3)), p3[t3] = g3), g3;
      }, o.prototype.setItemVisual = function(i, t3, c3) {
        var p3 = this._itemVisuals[i] || {};
        this._itemVisuals[i] = p3, XH(t3) ? ti(p3, t3) : p3[t3] = c3;
      }, o.prototype.clearAllVisual = function() {
        this._visual = {}, this._itemVisuals = [];
      }, o.prototype.setLayout = function(i, t3) {
        XH(i) ? ti(this._layout, i) : this._layout[i] = t3;
      }, o.prototype.getLayout = function(i) {
        return this._layout[i];
      }, o.prototype.getItemLayout = function(i) {
        return this._itemLayouts[i];
      }, o.prototype.setItemLayout = function(i, t3, c3) {
        this._itemLayouts[i] = c3 ? ti(this._itemLayouts[i] || {}, t3) : t3;
      }, o.prototype.clearItemLayouts = function() {
        this._itemLayouts.length = 0;
      }, o.prototype.setItemGraphicEl = function(i, t3) {
        var c3 = this.hostModel && this.hostModel.seriesIndex;
        ZG(c3, this.dataType, i, t3), this._graphicEls[i] = t3;
      }, o.prototype.getItemGraphicEl = function(i) {
        return this._graphicEls[i];
      }, o.prototype.eachItemGraphicEl = function(i, t3) {
        yt(this._graphicEls, function(c3, p3) {
          c3 && i && i.call(t3, c3, p3);
        });
      }, o.prototype.cloneShallow = function(i) {
        return i || (i = new o(this._schema ? this._schema : uk(this.dimensions, this._getDimInfo, this), this.hostModel)), a0e(i, this), i._store = this._store, i;
      }, o.prototype.wrapMethod = function(i, t3) {
        var c3 = this[i];
        !Vo(c3) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(i), this[i] = function() {
          var p3 = c3.apply(this, arguments);
          return t3.apply(this, [p3].concat(dP(arguments)));
        });
      }, o.internalField = function() {
        G4e = function(i) {
          var t3 = i._invertedIndicesMap;
          yt(t3, function(c3, p3) {
            var g3 = i._dimInfos[p3], b3 = g3.ordinalMeta, w3 = i._store;
            if (b3) {
              c3 = t3[p3] = new Kmt(b3.categories.length);
              for (var M = 0; M < c3.length; M++)
                c3[M] = j4e;
              for (var M = 0; M < w3.count(); M++)
                c3[w3.get(g3.storeDimIndex, M)] = M;
            }
          });
        }, YH = function(i, t3, c3) {
          return Jf(i._getCategory(t3, c3), null);
        }, Vte = function(i, t3) {
          var c3 = i._idList[t3];
          return c3 == null && i._idDimIdx != null && (c3 = YH(i, i._idDimIdx, t3)), c3 == null && (c3 = Zmt + t3), c3;
        }, KH = function(i) {
          return Ei(i) || (i = i != null ? [i] : []), i;
        }, Bte = function(i) {
          var t3 = new o(i._schema ? i._schema : uk(i.dimensions, i._getDimInfo, i), i.hostModel);
          return a0e(t3, i), t3;
        }, a0e = function(i, t3) {
          yt(Jmt.concat(t3.__wrappedMethods || []), function(c3) {
            t3.hasOwnProperty(c3) && (i[c3] = t3[c3]);
          }), i.__wrappedMethods = t3.__wrappedMethods, yt(Qmt, function(c3) {
            i[c3] = Jo(t3[c3]);
          }), i._calculationInfo = ti({}, t3._calculationInfo);
        }, o0e = function(i, t3) {
          var c3 = i._nameList, p3 = i._idList, g3 = i._nameDimIdx, b3 = i._idDimIdx, w3 = c3[t3], M = p3[t3];
          if (w3 == null && g3 != null && (c3[t3] = w3 = YH(i, g3, t3)), M == null && b3 != null && (p3[t3] = M = YH(i, b3, t3)), M == null && w3 != null) {
            var I = i._nameRepeatCount, k3 = I[w3] = (I[w3] || 0) + 1;
            M = w3, k3 > 1 && (M += "__ec__" + k3), p3[t3] = M;
          }
        };
      }(), o;
    }(), V1 = e1t;
    function ZH(o, i) {
      xge(o) || (o = Sge(o)), i = i || {};
      var t3 = i.coordDimensions || [], c3 = i.dimensionsDefine || o.dimensionsDefine || [], p3 = Eo(), g3 = [], b3 = n1t(o, t3, c3, i.dimensionsCount), w3 = i.canOmitUnusedDimensions && z4e(b3), M = c3 === o.dimensionsDefine, I = M ? B4e(o) : V4e(c3), k3 = i.encodeDefine;
      !k3 && i.encodeDefaulter && (k3 = i.encodeDefaulter(o, b3));
      for (var L = Eo(k3), F = new sRe(b3), B = 0; B < F.length; B++)
        F[B] = -1;
      function G(Ke) {
        var nt = F[Ke];
        if (nt < 0) {
          var lt2 = c3[Ke], bt = Ua(lt2) ? lt2 : { name: lt2 }, vt = new Fte(), jt = bt.name;
          jt != null && I.get(jt) != null && (vt.name = vt.displayName = jt), bt.type != null && (vt.type = bt.type), bt.displayName != null && (vt.displayName = bt.displayName);
          var Jt = g3.length;
          return F[Ke] = Jt, vt.storeDimIndex = Ke, g3.push(vt), vt;
        }
        return g3[nt];
      }
      if (!w3)
        for (var B = 0; B < b3; B++)
          G(B);
      L.each(function(Ke, nt) {
        var lt2 = Wc(Ke).slice();
        if (lt2.length === 1 && !Ha(lt2[0]) && lt2[0] < 0) {
          L.set(nt, false);
          return;
        }
        var bt = L.set(nt, []);
        yt(lt2, function(vt, jt) {
          var Jt = Ha(vt) ? I.get(vt) : vt;
          Jt != null && Jt < b3 && (bt[jt] = Jt, Q(G(Jt), nt, jt));
        });
      });
      var J = 0;
      yt(t3, function(Ke) {
        var nt, lt2, bt, vt;
        if (Ha(Ke))
          nt = Ke, vt = {};
        else {
          vt = Ke, nt = vt.name;
          var jt = vt.ordinalMeta;
          vt.ordinalMeta = null, vt = ti({}, vt), vt.ordinalMeta = jt, lt2 = vt.dimsDef, bt = vt.otherDims, vt.name = vt.coordDim = vt.coordDimIndex = vt.dimsDef = vt.otherDims = null;
        }
        var Jt = L.get(nt);
        if (Jt !== false) {
          if (Jt = Wc(Jt), !Jt.length)
            for (var Rt = 0; Rt < (lt2 && lt2.length || 1); Rt++) {
              for (; J < b3 && G(J).coordDim != null; )
                J++;
              J < b3 && Jt.push(J++);
            }
          yt(Jt, function(Jn, ln) {
            var vn = G(Jn);
            if (M && vt.type != null && (vn.type = vt.type), Q(Uo(vn, vt), nt, ln), vn.name == null && lt2) {
              var kn = lt2[ln];
              !Ua(kn) && (kn = { name: kn }), vn.name = vn.displayName = kn.name, vn.defaultTooltip = kn.defaultTooltip;
            }
            bt && Uo(vn.otherDims, bt);
          });
        }
      });
      function Q(Ke, nt, lt2) {
        _Le.get(nt) != null ? Ke.otherDims[nt] = lt2 : (Ke.coordDim = nt, Ke.coordDimIndex = lt2, p3.set(nt, true));
      }
      var se = i.generateCoord, he = i.generateCoordCount, be = he != null;
      he = se ? he || 1 : 0;
      var de = se || "value";
      function Fe(Ke) {
        Ke.name == null && (Ke.name = Ke.coordDim);
      }
      if (w3)
        yt(g3, function(Ke) {
          Fe(Ke);
        }), g3.sort(function(Ke, nt) {
          return Ke.storeDimIndex - nt.storeDimIndex;
        });
      else
        for (var Pe = 0; Pe < b3; Pe++) {
          var ze = G(Pe), $e = ze.coordDim;
          $e == null && (ze.coordDim = r1t(de, p3, be), ze.coordDimIndex = 0, (!se || he <= 0) && (ze.isExtraCoord = true), he--), Fe(ze), ze.type == null && (CLe(o, Pe) === xy.Must || ze.isExtraCoord && (ze.otherDims.itemName != null || ze.otherDims.seriesName != null)) && (ze.type = "ordinal");
        }
      return t1t(g3), new N4e({ source: o, dimensions: g3, fullDimensionCount: b3, dimensionOmitted: w3 });
    }
    function t1t(o) {
      for (var i = Eo(), t3 = 0; t3 < o.length; t3++) {
        var c3 = o[t3], p3 = c3.name, g3 = i.get(p3) || 0;
        g3 > 0 && (c3.name = p3 + (g3 - 1)), g3++, i.set(p3, g3);
      }
    }
    function n1t(o, i, t3, c3) {
      var p3 = Math.max(o.dimensionsDetectedCount || 1, i.length, t3.length, c3 || 0);
      return yt(i, function(g3) {
        var b3;
        Ua(g3) && (b3 = g3.dimsDef) && (p3 = Math.max(p3, b3.length));
      }), p3;
    }
    function r1t(o, i, t3) {
      var c3 = i.data;
      if (t3 || c3.hasOwnProperty(o)) {
        for (var p3 = 0; c3.hasOwnProperty(o + p3); )
          p3++;
        o += p3;
      }
      return i.set(o, true), o;
    }
    var i1t = function() {
      function o(i) {
        this.coordSysDims = [], this.axisMap = Eo(), this.categoryAxisMap = Eo(), this.coordSysName = i;
      }
      return o;
    }();
    function a1t(o) {
      var i = o.get("coordinateSystem"), t3 = new i1t(i), c3 = o1t[i];
      if (c3)
        return c3(o, t3, t3.axisMap, t3.categoryAxisMap), t3;
    }
    var o1t = { cartesian2d: function(o, i, t3, c3) {
      var p3 = o.getReferringComponents("xAxis", xd).models[0], g3 = o.getReferringComponents("yAxis", xd).models[0];
      i.coordSysDims = ["x", "y"], t3.set("x", p3), t3.set("y", g3), k8(p3) && (c3.set("x", p3), i.firstCategoryDimIndex = 0), k8(g3) && (c3.set("y", g3), i.firstCategoryDimIndex == null && (i.firstCategoryDimIndex = 1));
    }, singleAxis: function(o, i, t3, c3) {
      var p3 = o.getReferringComponents("singleAxis", xd).models[0];
      i.coordSysDims = ["single"], t3.set("single", p3), k8(p3) && (c3.set("single", p3), i.firstCategoryDimIndex = 0);
    }, polar: function(o, i, t3, c3) {
      var p3 = o.getReferringComponents("polar", xd).models[0], g3 = p3.findAxisModel("radiusAxis"), b3 = p3.findAxisModel("angleAxis");
      i.coordSysDims = ["radius", "angle"], t3.set("radius", g3), t3.set("angle", b3), k8(g3) && (c3.set("radius", g3), i.firstCategoryDimIndex = 0), k8(b3) && (c3.set("angle", b3), i.firstCategoryDimIndex == null && (i.firstCategoryDimIndex = 1));
    }, geo: function(o, i, t3, c3) {
      i.coordSysDims = ["lng", "lat"];
    }, parallel: function(o, i, t3, c3) {
      var p3 = o.ecModel, g3 = p3.getComponent("parallel", o.get("parallelIndex")), b3 = i.coordSysDims = g3.dimensions.slice();
      yt(g3.parallelAxisIndex, function(w3, M) {
        var I = p3.getComponent("parallelAxis", w3), k3 = b3[M];
        t3.set(k3, I), k8(I) && (c3.set(k3, I), i.firstCategoryDimIndex == null && (i.firstCategoryDimIndex = M));
      });
    } };
    function k8(o) {
      return o.get("type") === "category";
    }
    function s1t(o, i, t3) {
      t3 = t3 || {};
      var c3 = t3.byIndex, p3 = t3.stackedCoordDimension, g3, b3, w3;
      l1t(i) ? g3 = i : (b3 = i.schema, g3 = b3.dimensions, w3 = i.store);
      var M = !!(o && o.get("stack")), I, k3, L, F;
      if (yt(g3, function(he, be) {
        Ha(he) && (g3[be] = he = { name: he }), M && !he.isExtraCoord && (!c3 && !I && he.ordinalMeta && (I = he), !k3 && he.type !== "ordinal" && he.type !== "time" && (!p3 || p3 === he.coordDim) && (k3 = he));
      }), k3 && !c3 && !I && (c3 = true), k3) {
        L = "__\0ecstackresult_" + o.id, F = "__\0ecstackedover_" + o.id, I && (I.createInvertedIndices = true);
        var B = k3.coordDim, G = k3.type, J = 0;
        yt(g3, function(he) {
          he.coordDim === B && J++;
        });
        var Q = { name: L, coordDim: B, coordDimIndex: J, type: G, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: g3.length }, se = { name: F, coordDim: F, coordDimIndex: J + 1, type: G, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: g3.length + 1 };
        b3 ? (w3 && (Q.storeDimIndex = w3.ensureCalculationDimension(F, G), se.storeDimIndex = w3.ensureCalculationDimension(L, G)), b3.appendCalculationDimension(Q), b3.appendCalculationDimension(se)) : (g3.push(Q), g3.push(se));
      }
      return { stackedDimension: k3 && k3.name, stackedByDimension: I && I.name, isStackedByIndex: c3, stackedOverDimension: F, stackResultDimension: L };
    }
    function l1t(o) {
      return !F4e(o.schema);
    }
    function ck(o, i) {
      return !!i && i === o.getCalculationInfo("stackedDimension");
    }
    function H4e(o, i) {
      return ck(o, i) ? o.getCalculationInfo("stackResultDimension") : i;
    }
    function u1t(o, i) {
      var t3 = o.get("coordinateSystem"), c3 = DH.get(t3), p3;
      return i && i.coordSysDims && (p3 = Fi(i.coordSysDims, function(g3) {
        var b3 = { name: g3 }, w3 = i.axisMap.get(g3);
        if (w3) {
          var M = w3.get("type");
          b3.type = Nte(M);
        }
        return b3;
      })), p3 || (p3 = c3 && (c3.getDimensionsInfo ? c3.getDimensionsInfo() : c3.dimensions.slice()) || ["x", "y"]), p3;
    }
    function c1t(o, i, t3) {
      var c3, p3;
      return t3 && yt(o, function(g3, b3) {
        var w3 = g3.coordDim, M = t3.categoryAxisMap.get(w3);
        M && (c3 == null && (c3 = b3), g3.ordinalMeta = M.getOrdinalMeta(), i && (g3.createInvertedIndices = true)), g3.otherDims.itemName != null && (p3 = true);
      }), !p3 && c3 != null && (o[c3].otherDims.itemName = 0), c3;
    }
    function NI(o, i, t3) {
      t3 = t3 || {};
      var c3 = i.getSourceManager(), p3, g3 = false;
      o ? (g3 = true, p3 = Sge(o)) : (p3 = c3.getSource(), g3 = p3.sourceFormat === Ew);
      var b3 = a1t(i), w3 = u1t(i, b3), M = t3.useEncodeDefaulter, I = Vo(M) ? M : M ? As(SLe, w3, i) : null, k3 = { coordDimensions: w3, generateCoord: t3.generateCoord, encodeDefine: i.getEncode(), encodeDefaulter: I, canOmitUnusedDimensions: !g3 }, L = ZH(p3, k3), F = c1t(L.dimensions, t3.createInvertedIndices, b3), B = g3 ? null : c3.getSharedDataStore(L), G = s1t(i, { schema: L, store: B }), J = new V1(L, i);
      J.setCalculationInfo(G);
      var Q = F != null && f1t(p3) ? function(se, he, be, de) {
        return de === F ? be : this.defaultDimValueGetter(se, he, be, de);
      } : null;
      return J.hasItemOption = false, J.initData(g3 ? p3 : B, null, Q), J;
    }
    function f1t(o) {
      if (o.sourceFormat === Ew) {
        var i = h1t(o.data || []);
        return !Ei(NM(i));
      }
    }
    function h1t(o) {
      for (var i = 0; i < o.length && o[i] == null; )
        i++;
      return o[i];
    }
    var W4e = function() {
      function o(i) {
        this._setting = i || {}, this._extent = [1 / 0, -1 / 0];
      }
      return o.prototype.getSetting = function(i) {
        return this._setting[i];
      }, o.prototype.unionExtent = function(i) {
        var t3 = this._extent;
        i[0] < t3[0] && (t3[0] = i[0]), i[1] > t3[1] && (t3[1] = i[1]);
      }, o.prototype.unionExtentFromData = function(i, t3) {
        this.unionExtent(i.getApproximateExtent(t3));
      }, o.prototype.getExtent = function() {
        return this._extent.slice();
      }, o.prototype.setExtent = function(i, t3) {
        var c3 = this._extent;
        isNaN(i) || (c3[0] = i), isNaN(t3) || (c3[1] = t3);
      }, o.prototype.isInExtentRange = function(i) {
        return this._extent[0] <= i && this._extent[1] >= i;
      }, o.prototype.isBlank = function() {
        return this._isBlank;
      }, o.prototype.setBlank = function(i) {
        this._isBlank = i;
      }, o;
    }();
    BF(W4e);
    var FI = W4e, p1t = 0, d1t = function() {
      function o(i) {
        this.categories = i.categories || [], this._needCollect = i.needCollect, this._deduplication = i.deduplication, this.uid = ++p1t;
      }
      return o.createByAxisModel = function(i) {
        var t3 = i.option, c3 = t3.data, p3 = c3 && Fi(c3, v1t);
        return new o({ categories: p3, needCollect: !p3, deduplication: t3.dedplication !== false });
      }, o.prototype.getOrdinal = function(i) {
        return this._getOrCreateMap().get(i);
      }, o.prototype.parseAndCollect = function(i) {
        var t3, c3 = this._needCollect;
        if (!Ha(i) && !c3)
          return i;
        if (c3 && !this._deduplication)
          return t3 = this.categories.length, this.categories[t3] = i, t3;
        var p3 = this._getOrCreateMap();
        return t3 = p3.get(i), t3 == null && (c3 ? (t3 = this.categories.length, this.categories[t3] = i, p3.set(i, t3)) : t3 = NaN), t3;
      }, o.prototype._getOrCreateMap = function() {
        return this._map || (this._map = Eo(this.categories));
      }, o;
    }();
    function v1t(o) {
      return Ua(o) && o.value != null ? o.value : o + "";
    }
    var s0e = d1t;
    function l0e(o) {
      return o.type === "interval" || o.type === "log";
    }
    function g1t(o, i, t3, c3) {
      var p3 = {}, g3 = o[1] - o[0], b3 = p3.interval = $Q(g3 / i, true);
      t3 != null && b3 < t3 && (b3 = p3.interval = t3), c3 != null && b3 > c3 && (b3 = p3.interval = c3);
      var w3 = p3.intervalPrecision = U4e(b3), M = p3.niceTickExtent = [mp(Math.ceil(o[0] / b3) * b3, w3), mp(Math.floor(o[1] / b3) * b3, w3)];
      return y1t(M, o), p3;
    }
    function u0e(o) {
      var i = Math.pow(10, PF(o)), t3 = o / i;
      return t3 ? t3 === 2 ? t3 = 3 : t3 === 3 ? t3 = 5 : t3 *= 2 : t3 = 1, mp(t3 * i);
    }
    function U4e(o) {
      return Tb(o) + 2;
    }
    function q4e(o, i, t3) {
      o[i] = Math.max(Math.min(o[i], t3[1]), t3[0]);
    }
    function y1t(o, i) {
      !isFinite(o[0]) && (o[0] = i[0]), !isFinite(o[1]) && (o[1] = i[1]), q4e(o, 0, i), q4e(o, 1, i), o[0] > o[1] && (o[0] = o[1]);
    }
    function zte(o, i) {
      return o >= i[0] && o <= i[1];
    }
    function jte(o, i) {
      return i[1] === i[0] ? 0.5 : (o - i[0]) / (i[1] - i[0]);
    }
    function Gte(o, i) {
      return o * (i[1] - i[0]) + i[0];
    }
    var $4e = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        c3.type = "ordinal";
        var p3 = c3.getSetting("ordinalMeta");
        return p3 || (p3 = new s0e({})), Ei(p3) && (p3 = new s0e({ categories: Fi(p3, function(g3) {
          return Ua(g3) ? g3.value : g3;
        }) })), c3._ordinalMeta = p3, c3._extent = c3.getSetting("extent") || [0, p3.categories.length - 1], c3;
      }
      return i.prototype.parse = function(t3) {
        return Ha(t3) ? this._ordinalMeta.getOrdinal(t3) : Math.round(t3);
      }, i.prototype.contain = function(t3) {
        return t3 = this.parse(t3), zte(t3, this._extent) && this._ordinalMeta.categories[t3] != null;
      }, i.prototype.normalize = function(t3) {
        return t3 = this._getTickNumber(this.parse(t3)), jte(t3, this._extent);
      }, i.prototype.scale = function(t3) {
        return t3 = Math.round(Gte(t3, this._extent)), this.getRawOrdinalNumber(t3);
      }, i.prototype.getTicks = function() {
        for (var t3 = [], c3 = this._extent, p3 = c3[0]; p3 <= c3[1]; )
          t3.push({ value: p3 }), p3++;
        return t3;
      }, i.prototype.getMinorTicks = function(t3) {
      }, i.prototype.setSortInfo = function(t3) {
        if (t3 == null) {
          this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
          return;
        }
        for (var c3 = t3.ordinalNumbers, p3 = this._ordinalNumbersByTick = [], g3 = this._ticksByOrdinalNumber = [], b3 = 0, w3 = this._ordinalMeta.categories.length, M = Math.min(w3, c3.length); b3 < M; ++b3) {
          var I = c3[b3];
          p3[b3] = I, g3[I] = b3;
        }
        for (var k3 = 0; b3 < w3; ++b3) {
          for (; g3[k3] != null; )
            k3++;
          p3.push(k3), g3[k3] = b3;
        }
      }, i.prototype._getTickNumber = function(t3) {
        var c3 = this._ticksByOrdinalNumber;
        return c3 && t3 >= 0 && t3 < c3.length ? c3[t3] : t3;
      }, i.prototype.getRawOrdinalNumber = function(t3) {
        var c3 = this._ordinalNumbersByTick;
        return c3 && t3 >= 0 && t3 < c3.length ? c3[t3] : t3;
      }, i.prototype.getLabel = function(t3) {
        if (!this.isBlank()) {
          var c3 = this.getRawOrdinalNumber(t3.value), p3 = this._ordinalMeta.categories[c3];
          return p3 == null ? "" : p3 + "";
        }
      }, i.prototype.count = function() {
        return this._extent[1] - this._extent[0] + 1;
      }, i.prototype.unionExtentFromData = function(t3, c3) {
        this.unionExtent(t3.getApproximateExtent(c3));
      }, i.prototype.isInExtentRange = function(t3) {
        return t3 = this._getTickNumber(t3), this._extent[0] <= t3 && this._extent[1] >= t3;
      }, i.prototype.getOrdinalMeta = function() {
        return this._ordinalMeta;
      }, i.prototype.calcNiceTicks = function() {
      }, i.prototype.calcNiceExtent = function() {
      }, i.type = "ordinal", i;
    }(FI);
    FI.registerClass($4e);
    var c0e = $4e, cL = mp, X4e = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "interval", t3._interval = 0, t3._intervalPrecision = 2, t3;
      }
      return i.prototype.parse = function(t3) {
        return t3;
      }, i.prototype.contain = function(t3) {
        return zte(t3, this._extent);
      }, i.prototype.normalize = function(t3) {
        return jte(t3, this._extent);
      }, i.prototype.scale = function(t3) {
        return Gte(t3, this._extent);
      }, i.prototype.setExtent = function(t3, c3) {
        var p3 = this._extent;
        isNaN(t3) || (p3[0] = parseFloat(t3)), isNaN(c3) || (p3[1] = parseFloat(c3));
      }, i.prototype.unionExtent = function(t3) {
        var c3 = this._extent;
        t3[0] < c3[0] && (c3[0] = t3[0]), t3[1] > c3[1] && (c3[1] = t3[1]), this.setExtent(c3[0], c3[1]);
      }, i.prototype.getInterval = function() {
        return this._interval;
      }, i.prototype.setInterval = function(t3) {
        this._interval = t3, this._niceExtent = this._extent.slice(), this._intervalPrecision = U4e(t3);
      }, i.prototype.getTicks = function(t3) {
        var c3 = this._interval, p3 = this._extent, g3 = this._niceExtent, b3 = this._intervalPrecision, w3 = [];
        if (!c3)
          return w3;
        var M = 1e4;
        p3[0] < g3[0] && (t3 ? w3.push({ value: cL(g3[0] - c3, b3) }) : w3.push({ value: p3[0] }));
        for (var I = g3[0]; I <= g3[1] && (w3.push({ value: I }), I = cL(I + c3, b3), I !== w3[w3.length - 1].value); )
          if (w3.length > M)
            return [];
        var k3 = w3.length ? w3[w3.length - 1].value : g3[1];
        return p3[1] > k3 && (t3 ? w3.push({ value: cL(k3 + c3, b3) }) : w3.push({ value: p3[1] })), w3;
      }, i.prototype.getMinorTicks = function(t3) {
        for (var c3 = this.getTicks(true), p3 = [], g3 = this.getExtent(), b3 = 1; b3 < c3.length; b3++) {
          for (var w3 = c3[b3], M = c3[b3 - 1], I = 0, k3 = [], L = w3.value - M.value, F = L / t3; I < t3 - 1; ) {
            var B = cL(M.value + (I + 1) * F);
            B > g3[0] && B < g3[1] && k3.push(B), I++;
          }
          p3.push(k3);
        }
        return p3;
      }, i.prototype.getLabel = function(t3, c3) {
        if (t3 == null)
          return "";
        var p3 = c3 && c3.precision;
        p3 == null ? p3 = Tb(t3.value) || 0 : p3 === "auto" && (p3 = this._intervalPrecision);
        var g3 = cL(t3.value, p3, true);
        return pLe(g3);
      }, i.prototype.calcNiceTicks = function(t3, c3, p3) {
        t3 = t3 || 5;
        var g3 = this._extent, b3 = g3[1] - g3[0];
        if (isFinite(b3)) {
          b3 < 0 && (b3 = -b3, g3.reverse());
          var w3 = g1t(g3, t3, c3, p3);
          this._intervalPrecision = w3.intervalPrecision, this._interval = w3.interval, this._niceExtent = w3.niceTickExtent;
        }
      }, i.prototype.calcNiceExtent = function(t3) {
        var c3 = this._extent;
        if (c3[0] === c3[1])
          if (c3[0] !== 0) {
            var p3 = c3[0];
            t3.fixMax || (c3[1] += p3 / 2), c3[0] -= p3 / 2;
          } else
            c3[1] = 1;
        var g3 = c3[1] - c3[0];
        isFinite(g3) || (c3[0] = 0, c3[1] = 1), this.calcNiceTicks(t3.splitNumber, t3.minInterval, t3.maxInterval);
        var b3 = this._interval;
        t3.fixMin || (c3[0] = cL(Math.floor(c3[0] / b3) * b3)), t3.fixMax || (c3[1] = cL(Math.ceil(c3[1] / b3) * b3));
      }, i.prototype.setNiceExtent = function(t3, c3) {
        this._niceExtent = [t3, c3];
      }, i.type = "interval", i;
    }(FI);
    FI.registerClass(X4e);
    var fk = X4e, Y4e = typeof Float32Array != "undefined", m1t = Y4e ? Float32Array : Array;
    function JM(o) {
      return Ei(o) ? Y4e ? new Float32Array(o) : o : new m1t(o);
    }
    var f0e = "__ec_stack_";
    function h0e(o) {
      return o.get("stack") || f0e + o.seriesIndex;
    }
    function p0e(o) {
      return o.dim + o.index;
    }
    function b1t(o) {
      var i = [], t3 = o.axis, c3 = "axis0";
      if (t3.type === "category") {
        for (var p3 = t3.getBandWidth(), g3 = 0; g3 < o.count; g3++)
          i.push(Uo({ bandWidth: p3, axisKey: c3, stackId: f0e + g3 }, o));
        for (var b3 = J4e(i), w3 = [], g3 = 0; g3 < o.count; g3++) {
          var M = b3[c3][f0e + g3];
          M.offsetCenter = M.offset + M.width / 2, w3.push(M);
        }
        return w3;
      }
    }
    function K4e(o, i) {
      var t3 = [];
      return i.eachSeriesByType(o, function(c3) {
        t6e(c3) && t3.push(c3);
      }), t3;
    }
    function _1t(o) {
      var i = {};
      yt(o, function(M) {
        var I = M.coordinateSystem, k3 = I.getBaseAxis();
        if (!(k3.type !== "time" && k3.type !== "value"))
          for (var L = M.getData(), F = k3.dim + "_" + k3.index, B = L.getDimensionIndex(L.mapDimension(k3.dim)), G = L.getStore(), J = 0, Q = G.count(); J < Q; ++J) {
            var se = G.get(B, J);
            i[F] ? i[F].push(se) : i[F] = [se];
          }
      });
      var t3 = {};
      for (var c3 in i)
        if (i.hasOwnProperty(c3)) {
          var p3 = i[c3];
          if (p3) {
            p3.sort(function(M, I) {
              return M - I;
            });
            for (var g3 = null, b3 = 1; b3 < p3.length; ++b3) {
              var w3 = p3[b3] - p3[b3 - 1];
              w3 > 0 && (g3 = g3 === null ? w3 : Math.min(g3, w3));
            }
            t3[c3] = g3;
          }
        }
      return t3;
    }
    function Z4e(o) {
      var i = _1t(o), t3 = [];
      return yt(o, function(c3) {
        var p3 = c3.coordinateSystem, g3 = p3.getBaseAxis(), b3 = g3.getExtent(), w3;
        if (g3.type === "category")
          w3 = g3.getBandWidth();
        else if (g3.type === "value" || g3.type === "time") {
          var M = g3.dim + "_" + g3.index, I = i[M], k3 = Math.abs(b3[1] - b3[0]), L = g3.scale.getExtent(), F = Math.abs(L[1] - L[0]);
          w3 = I ? k3 / F * I : k3;
        } else {
          var B = c3.getData();
          w3 = Math.abs(b3[1] - b3[0]) / B.count();
        }
        var G = Da(c3.get("barWidth"), w3), J = Da(c3.get("barMaxWidth"), w3), Q = Da(c3.get("barMinWidth") || (n6e(c3) ? 0.5 : 1), w3), se = c3.get("barGap"), he = c3.get("barCategoryGap");
        t3.push({ bandWidth: w3, barWidth: G, barMaxWidth: J, barMinWidth: Q, barGap: se, barCategoryGap: he, axisKey: p0e(g3), stackId: h0e(c3) });
      }), J4e(t3);
    }
    function J4e(o) {
      var i = {};
      yt(o, function(c3, p3) {
        var g3 = c3.axisKey, b3 = c3.bandWidth, w3 = i[g3] || { bandWidth: b3, remainedWidth: b3, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, M = w3.stacks;
        i[g3] = w3;
        var I = c3.stackId;
        M[I] || w3.autoWidthCount++, M[I] = M[I] || { width: 0, maxWidth: 0 };
        var k3 = c3.barWidth;
        k3 && !M[I].width && (M[I].width = k3, k3 = Math.min(w3.remainedWidth, k3), w3.remainedWidth -= k3);
        var L = c3.barMaxWidth;
        L && (M[I].maxWidth = L);
        var F = c3.barMinWidth;
        F && (M[I].minWidth = F);
        var B = c3.barGap;
        B != null && (w3.gap = B);
        var G = c3.barCategoryGap;
        G != null && (w3.categoryGap = G);
      });
      var t3 = {};
      return yt(i, function(c3, p3) {
        t3[p3] = {};
        var g3 = c3.stacks, b3 = c3.bandWidth, w3 = c3.categoryGap;
        if (w3 == null) {
          var M = Gl(g3).length;
          w3 = Math.max(35 - M * 4, 15) + "%";
        }
        var I = Da(w3, b3), k3 = Da(c3.gap, 1), L = c3.remainedWidth, F = c3.autoWidthCount, B = (L - I) / (F + (F - 1) * k3);
        B = Math.max(B, 0), yt(g3, function(se) {
          var he = se.maxWidth, be = se.minWidth;
          if (se.width) {
            var de = se.width;
            he && (de = Math.min(de, he)), be && (de = Math.max(de, be)), se.width = de, L -= de + k3 * de, F--;
          } else {
            var de = B;
            he && he < de && (de = Math.min(he, L)), be && be > de && (de = be), de !== B && (se.width = de, L -= de + k3 * de, F--);
          }
        }), B = (L - I) / (F + (F - 1) * k3), B = Math.max(B, 0);
        var G = 0, J;
        yt(g3, function(se, he) {
          se.width || (se.width = B), J = se, G += se.width * (1 + k3);
        }), J && (G -= J.width * k3);
        var Q = -G / 2;
        yt(g3, function(se, he) {
          t3[p3][he] = t3[p3][he] || { bandWidth: b3, offset: Q, width: se.width }, Q += se.width * (1 + k3);
        });
      }), t3;
    }
    function x1t(o, i, t3) {
      if (o && i) {
        var c3 = o[p0e(i)];
        return c3 != null && t3 != null ? c3[h0e(t3)] : c3;
      }
    }
    function Q4e(o, i) {
      var t3 = K4e(o, i), c3 = Z4e(t3);
      yt(t3, function(p3) {
        var g3 = p3.getData(), b3 = p3.coordinateSystem, w3 = b3.getBaseAxis(), M = h0e(p3), I = c3[p0e(w3)][M], k3 = I.offset, L = I.width;
        g3.setLayout({ bandWidth: I.bandWidth, offset: k3, size: L });
      });
    }
    function e6e(o) {
      return { seriesType: o, plan: C8(), reset: function(i) {
        if (t6e(i)) {
          var t3 = i.getData(), c3 = i.coordinateSystem, p3 = c3.getBaseAxis(), g3 = c3.getOtherAxis(p3), b3 = t3.getDimensionIndex(t3.mapDimension(g3.dim)), w3 = t3.getDimensionIndex(t3.mapDimension(p3.dim)), M = i.get("showBackground", true), I = t3.mapDimension(g3.dim), k3 = t3.getCalculationInfo("stackResultDimension"), L = ck(t3, I) && !!t3.getCalculationInfo("stackedOnSeries"), F = g3.isHorizontal(), B = w1t(p3, g3), G = n6e(i), J = i.get("barMinHeight") || 0, Q = k3 && t3.getDimensionIndex(k3), se = t3.getLayout("size"), he = t3.getLayout("offset");
          return { progress: function(be, de) {
            for (var Fe = be.count, Pe = G && JM(Fe * 3), ze = G && M && JM(Fe * 3), $e = G && JM(Fe), Ke = c3.master.getRect(), nt = F ? Ke.width : Ke.height, lt2, bt = de.getStore(), vt = 0; (lt2 = be.next()) != null; ) {
              var jt = bt.get(L ? Q : b3, lt2), Jt = bt.get(w3, lt2), Rt = B, Jn = void 0;
              L && (Jn = +jt - bt.get(b3, lt2));
              var ln = void 0, vn = void 0, kn = void 0, cr = void 0;
              if (F) {
                var gr = c3.dataToPoint([jt, Jt]);
                if (L) {
                  var ha = c3.dataToPoint([Jn, Jt]);
                  Rt = ha[0];
                }
                ln = Rt, vn = gr[1] + he, kn = gr[0] - Rt, cr = se, Math.abs(kn) < J && (kn = (kn < 0 ? -1 : 1) * J);
              } else {
                var gr = c3.dataToPoint([Jt, jt]);
                if (L) {
                  var ha = c3.dataToPoint([Jt, Jn]);
                  Rt = ha[1];
                }
                ln = gr[0] + he, vn = Rt, kn = se, cr = gr[1] - Rt, Math.abs(cr) < J && (cr = (cr <= 0 ? -1 : 1) * J);
              }
              G ? (Pe[vt] = ln, Pe[vt + 1] = vn, Pe[vt + 2] = F ? kn : cr, ze && (ze[vt] = F ? Ke.x : ln, ze[vt + 1] = F ? vn : Ke.y, ze[vt + 2] = nt), $e[lt2] = lt2) : de.setItemLayout(lt2, { x: ln, y: vn, width: kn, height: cr }), vt += 3;
            }
            G && de.setLayout({ largePoints: Pe, largeDataIndices: $e, largeBackgroundPoints: ze, valueAxisHorizontal: F });
          } };
        }
      } };
    }
    function t6e(o) {
      return o.coordinateSystem && o.coordinateSystem.type === "cartesian2d";
    }
    function n6e(o) {
      return o.pipelineContext && o.pipelineContext.large;
    }
    function w1t(o, i) {
      return i.toGlobalCoord(i.dataToCoord(i.type === "log" ? 1 : 0));
    }
    var S1t = function(o, i, t3, c3) {
      for (; t3 < c3; ) {
        var p3 = t3 + c3 >>> 1;
        o[p3][1] < i ? t3 = p3 + 1 : c3 = p3;
      }
      return t3;
    }, r6e = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "time", c3;
      }
      return i.prototype.getLabel = function(t3) {
        var c3 = this.getSetting("useUTC");
        return lte(t3.value, rLe[Wgt(v8(this._minLevelUnit))] || rLe.second, c3, this.getSetting("locale"));
      }, i.prototype.getFormattedLabel = function(t3, c3, p3) {
        var g3 = this.getSetting("useUTC"), b3 = this.getSetting("locale");
        return Ugt(t3, c3, p3, b3, g3);
      }, i.prototype.getTicks = function() {
        var t3 = this._interval, c3 = this._extent, p3 = [];
        if (!t3)
          return p3;
        p3.push({ value: c3[0], level: 0 });
        var g3 = this.getSetting("useUTC"), b3 = D1t(this._minLevelUnit, this._approxInterval, g3, c3);
        return p3 = p3.concat(b3), p3.push({ value: c3[1], level: 0 }), p3;
      }, i.prototype.calcNiceExtent = function(t3) {
        var c3 = this._extent;
        if (c3[0] === c3[1] && (c3[0] -= Iw, c3[1] += Iw), c3[1] === -1 / 0 && c3[0] === 1 / 0) {
          var p3 = new Date();
          c3[1] = +new Date(p3.getFullYear(), p3.getMonth(), p3.getDate()), c3[0] = c3[1] - Iw;
        }
        this.calcNiceTicks(t3.splitNumber, t3.minInterval, t3.maxInterval);
      }, i.prototype.calcNiceTicks = function(t3, c3, p3) {
        t3 = t3 || 10;
        var g3 = this._extent, b3 = g3[1] - g3[0];
        this._approxInterval = b3 / t3, c3 != null && this._approxInterval < c3 && (this._approxInterval = c3), p3 != null && this._approxInterval > p3 && (this._approxInterval = p3);
        var w3 = Hte.length, M = Math.min(S1t(Hte, this._approxInterval, 0, w3), w3 - 1);
        this._interval = Hte[M][1], this._minLevelUnit = Hte[Math.max(M - 1, 0)][0];
      }, i.prototype.parse = function(t3) {
        return ec(t3) ? t3 : +jv(t3);
      }, i.prototype.contain = function(t3) {
        return zte(this.parse(t3), this._extent);
      }, i.prototype.normalize = function(t3) {
        return jte(this.parse(t3), this._extent);
      }, i.prototype.scale = function(t3) {
        return Gte(t3, this._extent);
      }, i.type = "time", i;
    }(fk), Hte = [["second", oge], ["minute", sge], ["hour", MH], ["quarter-day", MH * 6], ["half-day", MH * 12], ["day", Iw * 1.2], ["half-week", Iw * 3.5], ["week", Iw * 7], ["month", Iw * 31], ["quarter", Iw * 95], ["half-year", nLe / 2], ["year", nLe]];
    function C1t(o, i, t3, c3) {
      var p3 = jv(i), g3 = jv(t3), b3 = function(G) {
        return oLe(p3, G, c3) === oLe(g3, G, c3);
      }, w3 = function() {
        return b3("year");
      }, M = function() {
        return w3() && b3("month");
      }, I = function() {
        return M() && b3("day");
      }, k3 = function() {
        return I() && b3("hour");
      }, L = function() {
        return k3() && b3("minute");
      }, F = function() {
        return L() && b3("second");
      }, B = function() {
        return F() && b3("millisecond");
      };
      switch (o) {
        case "year":
          return w3();
        case "month":
          return M();
        case "day":
          return I();
        case "hour":
          return k3();
        case "minute":
          return L();
        case "second":
          return F();
        case "millisecond":
          return B();
      }
    }
    function M1t(o, i) {
      return o /= Iw, o > 16 ? 16 : o > 7.5 ? 7 : o > 3.5 ? 4 : o > 1.5 ? 2 : 1;
    }
    function T1t(o) {
      var i = 30 * Iw;
      return o /= i, o > 6 ? 6 : o > 3 ? 3 : o > 2 ? 2 : 1;
    }
    function A1t(o) {
      return o /= MH, o > 12 ? 12 : o > 6 ? 6 : o > 3.5 ? 4 : o > 2 ? 2 : 1;
    }
    function i6e(o, i) {
      return o /= i ? sge : oge, o > 30 ? 30 : o > 20 ? 20 : o > 15 ? 15 : o > 10 ? 10 : o > 5 ? 5 : o > 2 ? 2 : 1;
    }
    function I1t(o) {
      return $Q(o, true);
    }
    function E1t(o, i, t3) {
      var c3 = new Date(o);
      switch (v8(i)) {
        case "year":
        case "month":
          c3[sLe(t3)](0);
        case "day":
          c3[lLe(t3)](1);
        case "hour":
          c3[uLe(t3)](0);
        case "minute":
          c3[cLe(t3)](0);
        case "second":
          c3[fLe(t3)](0), c3[hLe(t3)](0);
      }
      return c3.getTime();
    }
    function D1t(o, i, t3, c3) {
      var p3 = 1e4, g3 = iLe, b3 = 0;
      function w3(nt, lt2, bt, vt, jt, Jt, Rt) {
        for (var Jn = new Date(lt2), ln = lt2, vn = Jn[vt](); ln < bt && ln <= c3[1]; )
          Rt.push({ value: ln }), vn += nt, Jn[jt](vn), ln = Jn.getTime();
        Rt.push({ value: ln, notAdd: true });
      }
      function M(nt, lt2, bt) {
        var vt = [], jt = !lt2.length;
        if (!C1t(v8(nt), c3[0], c3[1], t3)) {
          jt && (lt2 = [{ value: E1t(new Date(c3[0]), nt, t3) }, { value: c3[1] }]);
          for (var Jt = 0; Jt < lt2.length - 1; Jt++) {
            var Rt = lt2[Jt].value, Jn = lt2[Jt + 1].value;
            if (Rt !== Jn) {
              var ln = void 0, vn = void 0, kn = void 0, cr = false;
              switch (nt) {
                case "year":
                  ln = Math.max(1, Math.round(i / Iw / 365)), vn = uge(t3), kn = qgt(t3);
                  break;
                case "half-year":
                case "quarter":
                case "month":
                  ln = T1t(i), vn = g8(t3), kn = sLe(t3);
                  break;
                case "week":
                case "half-week":
                case "day":
                  ln = M1t(i), vn = ute(t3), kn = lLe(t3), cr = true;
                  break;
                case "half-day":
                case "quarter-day":
                case "hour":
                  ln = A1t(i), vn = AH(t3), kn = uLe(t3);
                  break;
                case "minute":
                  ln = i6e(i, true), vn = cte(t3), kn = cLe(t3);
                  break;
                case "second":
                  ln = i6e(i, false), vn = fte(t3), kn = fLe(t3);
                  break;
                case "millisecond":
                  ln = I1t(i), vn = hte(t3), kn = hLe(t3);
                  break;
              }
              w3(ln, Rt, Jn, vn, kn, cr, vt), nt === "year" && bt.length > 1 && Jt === 0 && bt.unshift({ value: bt[0].value - ln });
            }
          }
          for (var Jt = 0; Jt < vt.length; Jt++)
            bt.push(vt[Jt]);
          return vt;
        }
      }
      for (var I = [], k3 = [], L = 0, F = 0, B = 0; B < g3.length && b3++ < p3; ++B) {
        var G = v8(g3[B]);
        if (Hgt(g3[B])) {
          M(g3[B], I[I.length - 1] || [], k3);
          var J = g3[B + 1] ? v8(g3[B + 1]) : null;
          if (G !== J) {
            if (k3.length) {
              F = L, k3.sort(function(nt, lt2) {
                return nt.value - lt2.value;
              });
              for (var Q = [], se = 0; se < k3.length; ++se) {
                var he = k3[se].value;
                (se === 0 || k3[se - 1].value !== he) && (Q.push(k3[se]), he >= c3[0] && he <= c3[1] && L++);
              }
              var be = (c3[1] - c3[0]) / i;
              if (L > be * 1.5 && F > be / 1.5 || (I.push(Q), L > be || o === g3[B]))
                break;
            }
            k3 = [];
          }
        }
      }
      for (var de = Zc(Fi(I, function(lt2) {
        return Zc(lt2, function(bt) {
          return bt.value >= c3[0] && bt.value <= c3[1] && !bt.notAdd;
        });
      }), function(lt2) {
        return lt2.length > 0;
      }), Fe = [], Pe = de.length - 1, B = 0; B < de.length; ++B)
        for (var ze = de[B], $e = 0; $e < ze.length; ++$e)
          Fe.push({ value: ze[$e].value, level: Pe - B });
      Fe.sort(function(nt, lt2) {
        return nt.value - lt2.value;
      });
      for (var Ke = [], B = 0; B < Fe.length; ++B)
        (B === 0 || Fe[B].value !== Fe[B - 1].value) && Ke.push(Fe[B]);
      return Ke;
    }
    FI.registerClass(r6e);
    var a6e = r6e, o6e = FI.prototype, JH = fk.prototype, k1t = mp, O1t = Math.floor, P1t = Math.ceil, Wte = Math.pow, Pw = Math.log, d0e = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "log", t3.base = 10, t3._originalScale = new fk(), t3._interval = 0, t3;
      }
      return i.prototype.getTicks = function(t3) {
        var c3 = this._originalScale, p3 = this._extent, g3 = c3.getExtent(), b3 = JH.getTicks.call(this, t3);
        return Fi(b3, function(w3) {
          var M = w3.value, I = mp(Wte(this.base, M));
          return I = M === p3[0] && this._fixMin ? Ute(I, g3[0]) : I, I = M === p3[1] && this._fixMax ? Ute(I, g3[1]) : I, { value: I };
        }, this);
      }, i.prototype.setExtent = function(t3, c3) {
        var p3 = this.base;
        t3 = Pw(t3) / Pw(p3), c3 = Pw(c3) / Pw(p3), JH.setExtent.call(this, t3, c3);
      }, i.prototype.getExtent = function() {
        var t3 = this.base, c3 = o6e.getExtent.call(this);
        c3[0] = Wte(t3, c3[0]), c3[1] = Wte(t3, c3[1]);
        var p3 = this._originalScale, g3 = p3.getExtent();
        return this._fixMin && (c3[0] = Ute(c3[0], g3[0])), this._fixMax && (c3[1] = Ute(c3[1], g3[1])), c3;
      }, i.prototype.unionExtent = function(t3) {
        this._originalScale.unionExtent(t3);
        var c3 = this.base;
        t3[0] = Pw(t3[0]) / Pw(c3), t3[1] = Pw(t3[1]) / Pw(c3), o6e.unionExtent.call(this, t3);
      }, i.prototype.unionExtentFromData = function(t3, c3) {
        this.unionExtent(t3.getApproximateExtent(c3));
      }, i.prototype.calcNiceTicks = function(t3) {
        t3 = t3 || 10;
        var c3 = this._extent, p3 = c3[1] - c3[0];
        if (!(p3 === 1 / 0 || p3 <= 0)) {
          var g3 = qQ(p3), b3 = t3 / p3 * g3;
          for (b3 <= 0.5 && (g3 *= 10); !isNaN(g3) && Math.abs(g3) < 1 && Math.abs(g3) > 0; )
            g3 *= 10;
          var w3 = [mp(P1t(c3[0] / g3) * g3), mp(O1t(c3[1] / g3) * g3)];
          this._interval = g3, this._niceExtent = w3;
        }
      }, i.prototype.calcNiceExtent = function(t3) {
        JH.calcNiceExtent.call(this, t3), this._fixMin = t3.fixMin, this._fixMax = t3.fixMax;
      }, i.prototype.parse = function(t3) {
        return t3;
      }, i.prototype.contain = function(t3) {
        return t3 = Pw(t3) / Pw(this.base), zte(t3, this._extent);
      }, i.prototype.normalize = function(t3) {
        return t3 = Pw(t3) / Pw(this.base), jte(t3, this._extent);
      }, i.prototype.scale = function(t3) {
        return t3 = Gte(t3, this._extent), Wte(this.base, t3);
      }, i.type = "log", i;
    }(FI), s6e = d0e.prototype;
    s6e.getMinorTicks = JH.getMinorTicks, s6e.getLabel = JH.getLabel;
    function Ute(o, i) {
      return k1t(o, Tb(i));
    }
    FI.registerClass(d0e);
    var L1t = d0e, R1t = function() {
      function o(i, t3, c3) {
        this._prepareParams(i, t3, c3);
      }
      return o.prototype._prepareParams = function(i, t3, c3) {
        c3[1] < c3[0] && (c3 = [NaN, NaN]), this._dataMin = c3[0], this._dataMax = c3[1];
        var p3 = this._isOrdinal = i.type === "ordinal";
        this._needCrossZero = i.type === "interval" && t3.getNeedCrossZero && t3.getNeedCrossZero();
        var g3 = this._modelMinRaw = t3.get("min", true);
        Vo(g3) ? this._modelMinNum = qte(i, g3({ min: c3[0], max: c3[1] })) : g3 !== "dataMin" && (this._modelMinNum = qte(i, g3));
        var b3 = this._modelMaxRaw = t3.get("max", true);
        if (Vo(b3) ? this._modelMaxNum = qte(i, b3({ min: c3[0], max: c3[1] })) : b3 !== "dataMax" && (this._modelMaxNum = qte(i, b3)), p3)
          this._axisDataLen = t3.getCategories().length;
        else {
          var w3 = t3.get("boundaryGap"), M = Ei(w3) ? w3 : [w3 || 0, w3 || 0];
          typeof M[0] == "boolean" || typeof M[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [zv(M[0], 1), zv(M[1], 1)];
        }
      }, o.prototype.calculate = function() {
        var i = this._isOrdinal, t3 = this._dataMin, c3 = this._dataMax, p3 = this._axisDataLen, g3 = this._boundaryGapInner, b3 = i ? null : c3 - t3 || Math.abs(t3), w3 = this._modelMinRaw === "dataMin" ? t3 : this._modelMinNum, M = this._modelMaxRaw === "dataMax" ? c3 : this._modelMaxNum, I = w3 != null, k3 = M != null;
        w3 == null && (w3 = i ? p3 ? 0 : NaN : t3 - g3[0] * b3), M == null && (M = i ? p3 ? p3 - 1 : NaN : c3 + g3[1] * b3), (w3 == null || !isFinite(w3)) && (w3 = NaN), (M == null || !isFinite(M)) && (M = NaN);
        var L = pP(w3) || pP(M) || i && !p3;
        this._needCrossZero && (w3 > 0 && M > 0 && !I && (w3 = 0), w3 < 0 && M < 0 && !k3 && (M = 0));
        var F = this._determinedMin, B = this._determinedMax;
        return F != null && (w3 = F, I = true), B != null && (M = B, k3 = true), { min: w3, max: M, minFixed: I, maxFixed: k3, isBlank: L };
      }, o.prototype.modifyDataMinMax = function(i, t3) {
        this[F1t[i]] = t3;
      }, o.prototype.setDeterminedMinMax = function(i, t3) {
        var c3 = N1t[i];
        this[c3] = t3;
      }, o.prototype.freeze = function() {
        this.frozen = true;
      }, o;
    }(), N1t = { min: "_determinedMin", max: "_determinedMax" }, F1t = { min: "_dataMin", max: "_dataMax" };
    function l6e(o, i, t3) {
      var c3 = o.rawExtentInfo;
      return c3 || (c3 = new R1t(o, i, t3), o.rawExtentInfo = c3, c3);
    }
    function qte(o, i) {
      return i == null ? null : pP(i) ? NaN : o.parse(i);
    }
    function u6e(o, i) {
      var t3 = o.type, c3 = l6e(o, i, o.getExtent()).calculate();
      o.setBlank(c3.isBlank);
      var p3 = c3.min, g3 = c3.max, b3 = i.ecModel;
      if (b3 && t3 === "time") {
        var w3 = K4e("bar", b3), M = false;
        if (yt(w3, function(L) {
          M = M || L.getBaseAxis() === i.axis;
        }), M) {
          var I = Z4e(w3), k3 = V1t(p3, g3, i, I);
          p3 = k3.min, g3 = k3.max;
        }
      }
      return { extent: [p3, g3], fixMin: c3.minFixed, fixMax: c3.maxFixed };
    }
    function V1t(o, i, t3, c3) {
      var p3 = t3.axis.getExtent(), g3 = p3[1] - p3[0], b3 = x1t(c3, t3.axis);
      if (b3 === void 0)
        return { min: o, max: i };
      var w3 = 1 / 0;
      yt(b3, function(B) {
        w3 = Math.min(B.offset, w3);
      });
      var M = -1 / 0;
      yt(b3, function(B) {
        M = Math.max(B.offset + B.width, M);
      }), w3 = Math.abs(w3), M = Math.abs(M);
      var I = w3 + M, k3 = i - o, L = 1 - (w3 + M) / g3, F = k3 / L - k3;
      return i += F * (M / I), o -= F * (w3 / I), { min: o, max: i };
    }
    function O8(o, i) {
      var t3 = i, c3 = u6e(o, t3), p3 = c3.extent, g3 = t3.get("splitNumber");
      o instanceof L1t && (o.base = t3.get("logBase"));
      var b3 = o.type, w3 = t3.get("interval"), M = b3 === "interval" || b3 === "time";
      o.setExtent(p3[0], p3[1]), o.calcNiceExtent({ splitNumber: g3, fixMin: c3.fixMin, fixMax: c3.fixMax, minInterval: M ? t3.get("minInterval") : null, maxInterval: M ? t3.get("maxInterval") : null }), w3 != null && o.setInterval && o.setInterval(w3);
    }
    function $te(o, i) {
      if (i = i || o.get("type"), i)
        switch (i) {
          case "category":
            return new c0e({ ordinalMeta: o.getOrdinalMeta ? o.getOrdinalMeta() : o.getCategories(), extent: [1 / 0, -1 / 0] });
          case "time":
            return new a6e({ locale: o.ecModel.getLocaleModel(), useUTC: o.ecModel.get("useUTC") });
          default:
            return new (FI.getClass(i) || fk)();
        }
    }
    function B1t(o) {
      var i = o.scale.getExtent(), t3 = i[0], c3 = i[1];
      return !(t3 > 0 && c3 > 0 || t3 < 0 && c3 < 0);
    }
    function QH(o) {
      var i = o.getLabelModel().get("formatter"), t3 = o.type === "category" ? o.scale.getExtent()[0] : null;
      return o.scale.type === "time" ? function(c3) {
        return function(p3, g3) {
          return o.scale.getFormattedLabel(p3, g3, c3);
        };
      }(i) : Ha(i) ? function(c3) {
        return function(p3) {
          var g3 = o.scale.getLabel(p3), b3 = c3.replace("{value}", g3 != null ? g3 : "");
          return b3;
        };
      }(i) : Vo(i) ? function(c3) {
        return function(p3, g3) {
          return t3 != null && (g3 = p3.value - t3), c3(v0e(o, p3), g3, p3.level != null ? { level: p3.level } : null);
        };
      }(i) : function(c3) {
        return o.scale.getLabel(c3);
      };
    }
    function v0e(o, i) {
      return o.type === "category" ? o.scale.getLabel(i) : i.value;
    }
    function z1t(o) {
      var i = o.model, t3 = o.scale;
      if (!(!i.get(["axisLabel", "show"]) || t3.isBlank())) {
        var c3, p3, g3 = t3.getExtent();
        t3 instanceof c0e ? p3 = t3.count() : (c3 = t3.getTicks(), p3 = c3.length);
        var b3 = o.getLabelModel(), w3 = QH(o), M, I = 1;
        p3 > 40 && (I = Math.ceil(p3 / 40));
        for (var k3 = 0; k3 < p3; k3 += I) {
          var L = c3 ? c3[k3] : { value: g3[0] + k3 }, F = w3(L, k3), B = b3.getTextRect(F), G = j1t(B, b3.get("rotate") || 0);
          M ? M.union(G) : M = G;
        }
        return M;
      }
    }
    function j1t(o, i) {
      var t3 = i * Math.PI / 180, c3 = o.width, p3 = o.height, g3 = c3 * Math.abs(Math.cos(t3)) + Math.abs(p3 * Math.sin(t3)), b3 = c3 * Math.abs(Math.sin(t3)) + Math.abs(p3 * Math.cos(t3)), w3 = new Ys(o.x, o.y, g3, b3);
      return w3;
    }
    function g0e(o) {
      var i = o.get("interval");
      return i == null ? "auto" : i;
    }
    function c6e(o) {
      return o.type === "category" && g0e(o.getLabelModel()) === 0;
    }
    function Xte(o, i) {
      var t3 = {};
      return yt(o.mapDimensionsAll(i), function(c3) {
        t3[H4e(o, c3)] = true;
      }), Gl(t3);
    }
    function G1t(o, i, t3) {
      i && yt(Xte(i, t3), function(c3) {
        var p3 = i.getApproximateExtent(c3);
        p3[0] < o[0] && (o[0] = p3[0]), p3[1] > o[1] && (o[1] = p3[1]);
      });
    }
    var eW = function() {
      function o() {
      }
      return o.prototype.getNeedCrossZero = function() {
        var i = this.option;
        return !i.scale;
      }, o.prototype.getCoordSysModel = function() {
      }, o;
    }(), H1t = 1e-8;
    function f6e(o, i) {
      return Math.abs(o - i) < H1t;
    }
    function fL(o, i, t3) {
      var c3 = 0, p3 = o[0];
      if (!p3)
        return false;
      for (var g3 = 1; g3 < o.length; g3++) {
        var b3 = o[g3];
        c3 += U2(p3[0], p3[1], b3[0], b3[1], i, t3), p3 = b3;
      }
      var w3 = o[0];
      return (!f6e(p3[0], w3[0]) || !f6e(p3[1], w3[1])) && (c3 += U2(p3[0], p3[1], w3[0], w3[1], i, t3)), c3 !== 0;
    }
    var W1t = [];
    function y0e(o, i) {
      for (var t3 = 0; t3 < o.length; t3++)
        Vv(o[t3], o[t3], i);
    }
    function h6e(o, i, t3, c3) {
      for (var p3 = 0; p3 < o.length; p3++) {
        var g3 = o[p3];
        c3 && (g3 = c3.project(g3)), g3 && isFinite(g3[0]) && isFinite(g3[1]) && (L2(i, i, g3), sw(t3, t3, g3));
      }
    }
    function U1t(o) {
      for (var i = 0, t3 = 0, c3 = 0, p3 = o.length, g3 = o[p3 - 1][0], b3 = o[p3 - 1][1], w3 = 0; w3 < p3; w3++) {
        var M = o[w3][0], I = o[w3][1], k3 = g3 * I - M * b3;
        i += k3, t3 += (g3 + M) * k3, c3 += (b3 + I) * k3, g3 = M, b3 = I;
      }
      return i ? [t3 / i / 3, c3 / i / 3, i] : [o[0][0] || 0, o[0][1] || 0];
    }
    var p6e = function() {
      function o(i) {
        this.name = i;
      }
      return o.prototype.setCenter = function(i) {
        this._center = i;
      }, o.prototype.getCenter = function() {
        var i = this._center;
        return i || (i = this._center = this.calcCenter()), i;
      }, o;
    }(), d6e = function() {
      function o(i, t3) {
        this.type = "polygon", this.exterior = i, this.interiors = t3;
      }
      return o;
    }(), v6e = function() {
      function o(i) {
        this.type = "linestring", this.points = i;
      }
      return o;
    }(), g6e = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this, t3) || this;
        return g3.type = "geoJSON", g3.geometries = c3, g3._center = p3 && [p3[0], p3[1]], g3;
      }
      return i.prototype.calcCenter = function() {
        for (var t3 = this.geometries, c3, p3 = 0, g3 = 0; g3 < t3.length; g3++) {
          var b3 = t3[g3], w3 = b3.exterior, M = w3 && w3.length;
          M > p3 && (c3 = b3, p3 = M);
        }
        if (c3)
          return U1t(c3.exterior);
        var I = this.getBoundingRect();
        return [I.x + I.width / 2, I.y + I.height / 2];
      }, i.prototype.getBoundingRect = function(t3) {
        var c3 = this._rect;
        if (c3 && !t3)
          return c3;
        var p3 = [1 / 0, 1 / 0], g3 = [-1 / 0, -1 / 0], b3 = this.geometries;
        return yt(b3, function(w3) {
          w3.type === "polygon" ? h6e(w3.exterior, p3, g3, t3) : yt(w3.points, function(M) {
            h6e(M, p3, g3, t3);
          });
        }), isFinite(p3[0]) && isFinite(p3[1]) && isFinite(g3[0]) && isFinite(g3[1]) || (p3[0] = p3[1] = g3[0] = g3[1] = 0), c3 = new Ys(p3[0], p3[1], g3[0] - p3[0], g3[1] - p3[1]), t3 || (this._rect = c3), c3;
      }, i.prototype.contain = function(t3) {
        var c3 = this.getBoundingRect(), p3 = this.geometries;
        if (!c3.contain(t3[0], t3[1]))
          return false;
        e:
          for (var g3 = 0, b3 = p3.length; g3 < b3; g3++) {
            var w3 = p3[g3];
            if (w3.type === "polygon") {
              var M = w3.exterior, I = w3.interiors;
              if (fL(M, t3[0], t3[1])) {
                for (var k3 = 0; k3 < (I ? I.length : 0); k3++)
                  if (fL(I[k3], t3[0], t3[1]))
                    continue e;
                return true;
              }
            }
          }
        return false;
      }, i.prototype.transformTo = function(t3, c3, p3, g3) {
        var b3 = this.getBoundingRect(), w3 = b3.width / b3.height;
        p3 ? g3 || (g3 = p3 / w3) : p3 = w3 * g3;
        for (var M = new Ys(t3, c3, p3, g3), I = b3.calculateTransform(M), k3 = this.geometries, L = 0; L < k3.length; L++) {
          var F = k3[L];
          F.type === "polygon" ? (y0e(F.exterior, I), yt(F.interiors, function(B) {
            y0e(B, I);
          })) : yt(F.points, function(B) {
            y0e(B, I);
          });
        }
        b3 = this._rect, b3.copy(M), this._center = [b3.x + b3.width / 2, b3.y + b3.height / 2];
      }, i.prototype.cloneShallow = function(t3) {
        t3 == null && (t3 = this.name);
        var c3 = new i(t3, this.geometries, this._center);
        return c3._rect = this._rect, c3.transformTo = null, c3;
      }, i;
    }(p6e), q1t = function(o) {
      cn(i, o);
      function i(t3, c3) {
        var p3 = o.call(this, t3) || this;
        return p3.type = "geoSVG", p3._elOnlyForCalculate = c3, p3;
      }
      return i.prototype.calcCenter = function() {
        for (var t3 = this._elOnlyForCalculate, c3 = t3.getBoundingRect(), p3 = [c3.x + c3.width / 2, c3.y + c3.height / 2], g3 = LP(W1t), b3 = t3; b3 && !b3.isGeoSVGGraphicRoot; )
          pw(g3, b3.getLocalTransform(), g3), b3 = b3.parent;
        return fI(g3, g3), Vv(p3, p3, g3), p3;
      }, i;
    }(p6e);
    function $1t(o) {
      if (!o.UTF8Encoding)
        return o;
      var i = o, t3 = i.UTF8Scale;
      t3 == null && (t3 = 1024);
      var c3 = i.features;
      return yt(c3, function(p3) {
        var g3 = p3.geometry, b3 = g3.encodeOffsets, w3 = g3.coordinates;
        if (b3)
          switch (g3.type) {
            case "LineString":
              g3.coordinates = y6e(w3, b3, t3);
              break;
            case "Polygon":
              m0e(w3, b3, t3);
              break;
            case "MultiLineString":
              m0e(w3, b3, t3);
              break;
            case "MultiPolygon":
              yt(w3, function(M, I) {
                return m0e(M, b3[I], t3);
              });
          }
      }), i.UTF8Encoding = false, i;
    }
    function m0e(o, i, t3) {
      for (var c3 = 0; c3 < o.length; c3++)
        o[c3] = y6e(o[c3], i[c3], t3);
    }
    function y6e(o, i, t3) {
      for (var c3 = [], p3 = i[0], g3 = i[1], b3 = 0; b3 < o.length; b3 += 2) {
        var w3 = o.charCodeAt(b3) - 64, M = o.charCodeAt(b3 + 1) - 64;
        w3 = w3 >> 1 ^ -(w3 & 1), M = M >> 1 ^ -(M & 1), w3 += p3, M += g3, p3 = w3, g3 = M, c3.push([w3 / t3, M / t3]);
      }
      return c3;
    }
    function X1t(o, i) {
      return o = $1t(o), Fi(Zc(o.features, function(t3) {
        return t3.geometry && t3.properties && t3.geometry.coordinates.length > 0;
      }), function(t3) {
        var c3 = t3.properties, p3 = t3.geometry, g3 = [];
        switch (p3.type) {
          case "Polygon":
            var b3 = p3.coordinates;
            g3.push(new d6e(b3[0], b3.slice(1)));
            break;
          case "MultiPolygon":
            yt(p3.coordinates, function(M) {
              M[0] && g3.push(new d6e(M[0], M.slice(1)));
            });
            break;
          case "LineString":
            g3.push(new v6e([p3.coordinates]));
            break;
          case "MultiLineString":
            g3.push(new v6e(p3.coordinates));
        }
        var w3 = new g6e(c3[i || "name"], g3, c3.cp);
        return w3.properties = c3, w3;
      });
    }
    var tW = mu();
    function Y1t(o) {
      return o.type === "category" ? Z1t(o) : Q1t(o);
    }
    function K1t(o, i) {
      return o.type === "category" ? J1t(o, i) : { ticks: Fi(o.scale.getTicks(), function(t3) {
        return t3.value;
      }) };
    }
    function Z1t(o) {
      var i = o.getLabelModel(), t3 = m6e(o, i);
      return !i.get("show") || o.scale.isBlank() ? { labels: [], labelCategoryInterval: t3.labelCategoryInterval } : t3;
    }
    function m6e(o, i) {
      var t3 = b6e(o, "labels"), c3 = g0e(i), p3 = _6e(t3, c3);
      if (p3)
        return p3;
      var g3, b3;
      return Vo(c3) ? g3 = S6e(o, c3) : (b3 = c3 === "auto" ? ebt(o) : c3, g3 = w6e(o, b3)), x6e(t3, c3, { labels: g3, labelCategoryInterval: b3 });
    }
    function J1t(o, i) {
      var t3 = b6e(o, "ticks"), c3 = g0e(i), p3 = _6e(t3, c3);
      if (p3)
        return p3;
      var g3, b3;
      if ((!i.get("show") || o.scale.isBlank()) && (g3 = []), Vo(c3))
        g3 = S6e(o, c3, true);
      else if (c3 === "auto") {
        var w3 = m6e(o, o.getLabelModel());
        b3 = w3.labelCategoryInterval, g3 = Fi(w3.labels, function(M) {
          return M.tickValue;
        });
      } else
        b3 = c3, g3 = w6e(o, b3, true);
      return x6e(t3, c3, { ticks: g3, tickCategoryInterval: b3 });
    }
    function Q1t(o) {
      var i = o.scale.getTicks(), t3 = QH(o);
      return { labels: Fi(i, function(c3, p3) {
        return { level: c3.level, formattedLabel: t3(c3, p3), rawLabel: o.scale.getLabel(c3), tickValue: c3.value };
      }) };
    }
    function b6e(o, i) {
      return tW(o)[i] || (tW(o)[i] = []);
    }
    function _6e(o, i) {
      for (var t3 = 0; t3 < o.length; t3++)
        if (o[t3].key === i)
          return o[t3].value;
    }
    function x6e(o, i, t3) {
      return o.push({ key: i, value: t3 }), t3;
    }
    function ebt(o) {
      var i = tW(o).autoInterval;
      return i != null ? i : tW(o).autoInterval = o.calculateCategoryInterval();
    }
    function tbt(o) {
      var i = nbt(o), t3 = QH(o), c3 = (i.axisRotate - i.labelRotate) / 180 * Math.PI, p3 = o.scale, g3 = p3.getExtent(), b3 = p3.count();
      if (g3[1] - g3[0] < 1)
        return 0;
      var w3 = 1;
      b3 > 40 && (w3 = Math.max(1, Math.floor(b3 / 40)));
      for (var M = g3[0], I = o.dataToCoord(M + 1) - o.dataToCoord(M), k3 = Math.abs(I * Math.cos(c3)), L = Math.abs(I * Math.sin(c3)), F = 0, B = 0; M <= g3[1]; M += w3) {
        var G = 0, J = 0, Q = pI(t3({ value: M }), i.font, "center", "top");
        G = Q.width * 1.3, J = Q.height * 1.3, F = Math.max(F, G, 7), B = Math.max(B, J, 7);
      }
      var se = F / k3, he = B / L;
      isNaN(se) && (se = 1 / 0), isNaN(he) && (he = 1 / 0);
      var be = Math.max(0, Math.floor(Math.min(se, he))), de = tW(o.model), Fe = o.getExtent(), Pe = de.lastAutoInterval, ze = de.lastTickCount;
      return Pe != null && ze != null && Math.abs(Pe - be) <= 1 && Math.abs(ze - b3) <= 1 && Pe > be && de.axisExtent0 === Fe[0] && de.axisExtent1 === Fe[1] ? be = Pe : (de.lastTickCount = b3, de.lastAutoInterval = be, de.axisExtent0 = Fe[0], de.axisExtent1 = Fe[1]), be;
    }
    function nbt(o) {
      var i = o.getLabelModel();
      return { axisRotate: o.getRotate ? o.getRotate() : o.isHorizontal && !o.isHorizontal() ? 90 : 0, labelRotate: i.get("rotate") || 0, font: i.getFont() };
    }
    function w6e(o, i, t3) {
      var c3 = QH(o), p3 = o.scale, g3 = p3.getExtent(), b3 = o.getLabelModel(), w3 = [], M = Math.max((i || 0) + 1, 1), I = g3[0], k3 = p3.count();
      I !== 0 && M > 1 && k3 / M > 2 && (I = Math.round(Math.ceil(I / M) * M));
      var L = c6e(o), F = b3.get("showMinLabel") || L, B = b3.get("showMaxLabel") || L;
      F && I !== g3[0] && J(g3[0]);
      for (var G = I; G <= g3[1]; G += M)
        J(G);
      B && G - M !== g3[1] && J(g3[1]);
      function J(Q) {
        var se = { value: Q };
        w3.push(t3 ? Q : { formattedLabel: c3(se), rawLabel: p3.getLabel(se), tickValue: Q });
      }
      return w3;
    }
    function S6e(o, i, t3) {
      var c3 = o.scale, p3 = QH(o), g3 = [];
      return yt(c3.getTicks(), function(b3) {
        var w3 = c3.getLabel(b3), M = b3.value;
        i(b3.value, w3) && g3.push(t3 ? M : { formattedLabel: p3(b3), rawLabel: w3, tickValue: M });
      }), g3;
    }
    var C6e = [0, 1], rbt = function() {
      function o(i, t3, c3) {
        this.onBand = false, this.inverse = false, this.dim = i, this.scale = t3, this._extent = c3 || [0, 0];
      }
      return o.prototype.contain = function(i) {
        var t3 = this._extent, c3 = Math.min(t3[0], t3[1]), p3 = Math.max(t3[0], t3[1]);
        return i >= c3 && i <= p3;
      }, o.prototype.containData = function(i) {
        return this.scale.contain(i);
      }, o.prototype.getExtent = function() {
        return this._extent.slice();
      }, o.prototype.getPixelPrecision = function(i) {
        return HQ(i || this.scale.getExtent(), this._extent);
      }, o.prototype.setExtent = function(i, t3) {
        var c3 = this._extent;
        c3[0] = i, c3[1] = t3;
      }, o.prototype.dataToCoord = function(i, t3) {
        var c3 = this._extent, p3 = this.scale;
        return i = p3.normalize(i), this.onBand && p3.type === "ordinal" && (c3 = c3.slice(), M6e(c3, p3.count())), Bc(i, C6e, c3, t3);
      }, o.prototype.coordToData = function(i, t3) {
        var c3 = this._extent, p3 = this.scale;
        this.onBand && p3.type === "ordinal" && (c3 = c3.slice(), M6e(c3, p3.count()));
        var g3 = Bc(i, c3, C6e, t3);
        return this.scale.scale(g3);
      }, o.prototype.pointToData = function(i, t3) {
      }, o.prototype.getTicksCoords = function(i) {
        i = i || {};
        var t3 = i.tickModel || this.getTickModel(), c3 = K1t(this, t3), p3 = c3.ticks, g3 = Fi(p3, function(w3) {
          return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(w3) : w3), tickValue: w3 };
        }, this), b3 = t3.get("alignWithLabel");
        return ibt(this, g3, b3, i.clamp), g3;
      }, o.prototype.getMinorTicksCoords = function() {
        if (this.scale.type === "ordinal")
          return [];
        var i = this.model.getModel("minorTick"), t3 = i.get("splitNumber");
        t3 > 0 && t3 < 100 || (t3 = 5);
        var c3 = this.scale.getMinorTicks(t3), p3 = Fi(c3, function(g3) {
          return Fi(g3, function(b3) {
            return { coord: this.dataToCoord(b3), tickValue: b3 };
          }, this);
        }, this);
        return p3;
      }, o.prototype.getViewLabels = function() {
        return Y1t(this).labels;
      }, o.prototype.getLabelModel = function() {
        return this.model.getModel("axisLabel");
      }, o.prototype.getTickModel = function() {
        return this.model.getModel("axisTick");
      }, o.prototype.getBandWidth = function() {
        var i = this._extent, t3 = this.scale.getExtent(), c3 = t3[1] - t3[0] + (this.onBand ? 1 : 0);
        c3 === 0 && (c3 = 1);
        var p3 = Math.abs(i[1] - i[0]);
        return Math.abs(p3) / c3;
      }, o.prototype.calculateCategoryInterval = function() {
        return tbt(this);
      }, o;
    }();
    function M6e(o, i) {
      var t3 = o[1] - o[0], c3 = i, p3 = t3 / c3 / 2;
      o[0] += p3, o[1] -= p3;
    }
    function ibt(o, i, t3, c3) {
      var p3 = i.length;
      if (!o.onBand || t3 || !p3)
        return;
      var g3 = o.getExtent(), b3, w3;
      if (p3 === 1)
        i[0].coord = g3[0], b3 = i[1] = { coord: g3[0] };
      else {
        var M = i[p3 - 1].tickValue - i[0].tickValue, I = (i[p3 - 1].coord - i[0].coord) / M;
        yt(i, function(B) {
          B.coord -= I / 2;
        });
        var k3 = o.scale.getExtent();
        w3 = 1 + k3[1] - i[p3 - 1].tickValue, b3 = { coord: i[p3 - 1].coord + I * w3 }, i.push(b3);
      }
      var L = g3[0] > g3[1];
      F(i[0].coord, g3[0]) && (c3 ? i[0].coord = g3[0] : i.shift()), c3 && F(g3[0], i[0].coord) && i.unshift({ coord: g3[0] }), F(g3[1], b3.coord) && (c3 ? b3.coord = g3[1] : i.pop()), c3 && F(b3.coord, g3[1]) && i.push({ coord: g3[1] });
      function F(B, G) {
        return B = mp(B), G = mp(G), L ? B > G : B < G;
      }
    }
    var Y2 = rbt, nW = Math.PI * 2, hL = ww.CMD, abt = ["top", "right", "bottom", "left"];
    function obt(o, i, t3, c3, p3) {
      var g3 = t3.width, b3 = t3.height;
      switch (o) {
        case "top":
          c3.set(t3.x + g3 / 2, t3.y - i), p3.set(0, -1);
          break;
        case "bottom":
          c3.set(t3.x + g3 / 2, t3.y + b3 + i), p3.set(0, 1);
          break;
        case "left":
          c3.set(t3.x - i, t3.y + b3 / 2), p3.set(-1, 0);
          break;
        case "right":
          c3.set(t3.x + g3 + i, t3.y + b3 / 2), p3.set(1, 0);
          break;
      }
    }
    function sbt(o, i, t3, c3, p3, g3, b3, w3, M) {
      b3 -= o, w3 -= i;
      var I = Math.sqrt(b3 * b3 + w3 * w3);
      b3 /= I, w3 /= I;
      var k3 = b3 * t3 + o, L = w3 * t3 + i;
      if (Math.abs(c3 - p3) % nW < 1e-4)
        return M[0] = k3, M[1] = L, I - t3;
      if (g3) {
        var F = c3;
        c3 = HM(p3), p3 = HM(F);
      } else
        c3 = HM(c3), p3 = HM(p3);
      c3 > p3 && (p3 += nW);
      var B = Math.atan2(w3, b3);
      if (B < 0 && (B += nW), B >= c3 && B <= p3 || B + nW >= c3 && B + nW <= p3)
        return M[0] = k3, M[1] = L, I - t3;
      var G = t3 * Math.cos(c3) + o, J = t3 * Math.sin(c3) + i, Q = t3 * Math.cos(p3) + o, se = t3 * Math.sin(p3) + i, he = (G - b3) * (G - b3) + (J - w3) * (J - w3), be = (Q - b3) * (Q - b3) + (se - w3) * (se - w3);
      return he < be ? (M[0] = G, M[1] = J, Math.sqrt(he)) : (M[0] = Q, M[1] = se, Math.sqrt(be));
    }
    function Yte(o, i, t3, c3, p3, g3, b3, w3) {
      var M = p3 - o, I = g3 - i, k3 = t3 - o, L = c3 - i, F = Math.sqrt(k3 * k3 + L * L);
      k3 /= F, L /= F;
      var B = M * k3 + I * L, G = B / F;
      w3 && (G = Math.min(Math.max(G, 0), 1)), G *= F;
      var J = b3[0] = o + G * k3, Q = b3[1] = i + G * L;
      return Math.sqrt((J - p3) * (J - p3) + (Q - g3) * (Q - g3));
    }
    function T6e(o, i, t3, c3, p3, g3, b3) {
      t3 < 0 && (o = o + t3, t3 = -t3), c3 < 0 && (i = i + c3, c3 = -c3);
      var w3 = o + t3, M = i + c3, I = b3[0] = Math.min(Math.max(p3, o), w3), k3 = b3[1] = Math.min(Math.max(g3, i), M);
      return Math.sqrt((I - p3) * (I - p3) + (k3 - g3) * (k3 - g3));
    }
    var K2 = [];
    function lbt(o, i, t3) {
      var c3 = T6e(i.x, i.y, i.width, i.height, o.x, o.y, K2);
      return t3.set(K2[0], K2[1]), c3;
    }
    function ubt(o, i, t3) {
      for (var c3 = 0, p3 = 0, g3 = 0, b3 = 0, w3, M, I = 1 / 0, k3 = i.data, L = o.x, F = o.y, B = 0; B < k3.length; ) {
        var G = k3[B++];
        B === 1 && (c3 = k3[B], p3 = k3[B + 1], g3 = c3, b3 = p3);
        var J = I;
        switch (G) {
          case hL.M:
            g3 = k3[B++], b3 = k3[B++], c3 = g3, p3 = b3;
            break;
          case hL.L:
            J = Yte(c3, p3, k3[B], k3[B + 1], L, F, K2, true), c3 = k3[B++], p3 = k3[B++];
            break;
          case hL.C:
            J = pQ(c3, p3, k3[B++], k3[B++], k3[B++], k3[B++], k3[B], k3[B + 1], L, F, K2), c3 = k3[B++], p3 = k3[B++];
            break;
          case hL.Q:
            J = vQ(c3, p3, k3[B++], k3[B++], k3[B], k3[B + 1], L, F, K2), c3 = k3[B++], p3 = k3[B++];
            break;
          case hL.A:
            var Q = k3[B++], se = k3[B++], he = k3[B++], be = k3[B++], de = k3[B++], Fe = k3[B++];
            B += 1;
            var Pe = !!(1 - k3[B++]);
            w3 = Math.cos(de) * he + Q, M = Math.sin(de) * be + se, B <= 1 && (g3 = w3, b3 = M);
            var ze = (L - Q) * be / he + Q;
            J = sbt(Q, se, be, de, de + Fe, Pe, ze, F, K2), c3 = Math.cos(de + Fe) * he + Q, p3 = Math.sin(de + Fe) * be + se;
            break;
          case hL.R:
            g3 = c3 = k3[B++], b3 = p3 = k3[B++];
            var $e = k3[B++], Ke = k3[B++];
            J = T6e(g3, b3, $e, Ke, L, F, K2);
            break;
          case hL.Z:
            J = Yte(c3, p3, g3, b3, L, F, K2, true), c3 = g3, p3 = b3;
            break;
        }
        J < I && (I = J, t3.set(K2[0], K2[1]));
      }
      return I;
    }
    var Z2 = new Bs(), mh = new Bs(), $d = new Bs(), QM = new Bs(), eT = new Bs();
    function A6e(o, i) {
      if (o) {
        var t3 = o.getTextGuideLine(), c3 = o.getTextContent();
        if (c3 && t3) {
          var p3 = o.textGuideLineConfig || {}, g3 = [[0, 0], [0, 0], [0, 0]], b3 = p3.candidates || abt, w3 = c3.getBoundingRect().clone();
          w3.applyTransform(c3.getComputedTransform());
          var M = 1 / 0, I = p3.anchor, k3 = o.getComputedTransform(), L = k3 && fI([], k3), F = i.get("length2") || 0;
          I && $d.copy(I);
          for (var B = 0; B < b3.length; B++) {
            var G = b3[B];
            obt(G, 0, w3, Z2, QM), Bs.scaleAndAdd(mh, Z2, QM, F), mh.transform(L);
            var J = o.getBoundingRect(), Q = I ? I.distance(mh) : o instanceof gl ? ubt(mh, o.path, $d) : lbt(mh, J, $d);
            Q < M && (M = Q, mh.transform(k3), $d.transform(k3), $d.toArray(g3[0]), mh.toArray(g3[1]), Z2.toArray(g3[2]));
          }
          I6e(g3, i.get("minTurnAngle")), t3.setShape({ points: g3 });
        }
      }
    }
    var Kte = [], B1 = new Bs();
    function I6e(o, i) {
      if (i <= 180 && i > 0) {
        i = i / 180 * Math.PI, Z2.fromArray(o[0]), mh.fromArray(o[1]), $d.fromArray(o[2]), Bs.sub(QM, Z2, mh), Bs.sub(eT, $d, mh);
        var t3 = QM.len(), c3 = eT.len();
        if (!(t3 < 1e-3 || c3 < 1e-3)) {
          QM.scale(1 / t3), eT.scale(1 / c3);
          var p3 = QM.dot(eT), g3 = Math.cos(i);
          if (g3 < p3) {
            var b3 = Yte(mh.x, mh.y, $d.x, $d.y, Z2.x, Z2.y, Kte, false);
            B1.fromArray(Kte), B1.scaleAndAdd(eT, b3 / Math.tan(Math.PI - i));
            var w3 = $d.x !== mh.x ? (B1.x - mh.x) / ($d.x - mh.x) : (B1.y - mh.y) / ($d.y - mh.y);
            if (isNaN(w3))
              return;
            w3 < 0 ? Bs.copy(B1, mh) : w3 > 1 && Bs.copy(B1, $d), B1.toArray(o[1]);
          }
        }
      }
    }
    function cbt(o, i, t3) {
      if (t3 <= 180 && t3 > 0) {
        t3 = t3 / 180 * Math.PI, Z2.fromArray(o[0]), mh.fromArray(o[1]), $d.fromArray(o[2]), Bs.sub(QM, mh, Z2), Bs.sub(eT, $d, mh);
        var c3 = QM.len(), p3 = eT.len();
        if (!(c3 < 1e-3 || p3 < 1e-3)) {
          QM.scale(1 / c3), eT.scale(1 / p3);
          var g3 = QM.dot(i), b3 = Math.cos(t3);
          if (g3 < b3) {
            var w3 = Yte(mh.x, mh.y, $d.x, $d.y, Z2.x, Z2.y, Kte, false);
            B1.fromArray(Kte);
            var M = Math.PI / 2, I = Math.acos(eT.dot(i)), k3 = M + I - t3;
            if (k3 >= M)
              Bs.copy(B1, $d);
            else {
              B1.scaleAndAdd(eT, w3 / Math.tan(Math.PI / 2 - k3));
              var L = $d.x !== mh.x ? (B1.x - mh.x) / ($d.x - mh.x) : (B1.y - mh.y) / ($d.y - mh.y);
              if (isNaN(L))
                return;
              L < 0 ? Bs.copy(B1, mh) : L > 1 && Bs.copy(B1, $d);
            }
            B1.toArray(o[1]);
          }
        }
      }
    }
    function E6e(o, i, t3, c3) {
      var p3 = t3 === "normal", g3 = p3 ? o : o.ensureState(t3);
      g3.ignore = i;
      var b3 = c3.get("smooth");
      b3 && b3 === true && (b3 = 0.3), g3.shape = g3.shape || {}, b3 > 0 && (g3.shape.smooth = b3);
      var w3 = c3.getModel("lineStyle").getLineStyle();
      p3 ? o.useStyle(w3) : g3.style = w3;
    }
    function fbt(o, i) {
      var t3 = i.smooth, c3 = i.points;
      if (c3)
        if (o.moveTo(c3[0][0], c3[0][1]), t3 > 0 && c3.length >= 3) {
          var p3 = P2(c3[0], c3[1]), g3 = P2(c3[1], c3[2]);
          if (!p3 || !g3) {
            o.lineTo(c3[1][0], c3[1][1]), o.lineTo(c3[2][0], c3[2][1]);
            return;
          }
          var b3 = Math.min(p3, g3) * t3, w3 = sF([], c3[1], c3[0], b3 / p3), M = sF([], c3[1], c3[2], b3 / g3), I = sF([], w3, M, 0.5);
          o.bezierCurveTo(w3[0], w3[1], w3[0], w3[1], I[0], I[1]), o.bezierCurveTo(M[0], M[1], M[0], M[1], c3[2][0], c3[2][1]);
        } else
          for (var k3 = 1; k3 < c3.length; k3++)
            o.lineTo(c3[k3][0], c3[k3][1]);
    }
    function b0e(o, i, t3) {
      var c3 = o.getTextGuideLine(), p3 = o.getTextContent();
      if (!p3) {
        c3 && o.removeTextGuideLine();
        return;
      }
      for (var g3 = i.normal, b3 = g3.get("show"), w3 = p3.ignore, M = 0; M < UP.length; M++) {
        var I = UP[M], k3 = i[I], L = I === "normal";
        if (k3) {
          var F = k3.get("show"), B = L ? w3 : Xs(p3.states[I] && p3.states[I].ignore, w3);
          if (B || !Xs(F, b3)) {
            var G = L ? c3 : c3 && c3.states.normal;
            G && (G.ignore = true);
            continue;
          }
          c3 || (c3 = new xm(), o.setTextGuideLine(c3), !L && (w3 || !b3) && E6e(c3, true, "normal", i.normal), o.stateProxy && (c3.stateProxy = o.stateProxy)), E6e(c3, false, I, k3);
        }
      }
      if (c3) {
        Uo(c3.style, t3), c3.style.fill = null;
        var J = g3.get("showAbove"), Q = o.textGuideLineConfig = o.textGuideLineConfig || {};
        Q.showAbove = J || false, c3.buildPath = fbt;
      }
    }
    function _0e(o, i) {
      i = i || "labelLine";
      for (var t3 = { normal: o.getModel(i) }, c3 = 0; c3 < yy.length; c3++) {
        var p3 = yy[c3];
        t3[p3] = o.getModel([p3, i]);
      }
      return t3;
    }
    function D6e(o) {
      for (var i = [], t3 = 0; t3 < o.length; t3++) {
        var c3 = o[t3];
        if (!c3.defaultAttr.ignore) {
          var p3 = c3.label, g3 = p3.getComputedTransform(), b3 = p3.getBoundingRect(), w3 = !g3 || g3[1] < 1e-5 && g3[2] < 1e-5, M = p3.style.margin || 0, I = b3.clone();
          I.applyTransform(g3), I.x -= M / 2, I.y -= M / 2, I.width += M, I.height += M;
          var k3 = w3 ? new l8(b3, g3) : null;
          i.push({ label: p3, labelLine: c3.labelLine, rect: I, localRect: b3, obb: k3, priority: c3.priority, defaultAttr: c3.defaultAttr, layoutOption: c3.computedLayoutOption, axisAligned: w3, transform: g3 });
        }
      }
      return i;
    }
    function k6e(o, i, t3, c3, p3, g3) {
      var b3 = o.length;
      if (b3 < 2)
        return;
      o.sort(function($e, Ke) {
        return $e.rect[i] - Ke.rect[i];
      });
      for (var w3 = 0, M, I = false, k3 = 0, L = 0; L < b3; L++) {
        var F = o[L], B = F.rect;
        M = B[i] - w3, M < 0 && (B[i] -= M, F.label[i] -= M, I = true);
        var G = Math.max(-M, 0);
        k3 += G, w3 = B[i] + B[t3];
      }
      k3 > 0 && g3 && Fe(-k3 / b3, 0, b3);
      var J = o[0], Q = o[b3 - 1], se, he;
      be(), se < 0 && Pe(-se, 0.8), he < 0 && Pe(he, 0.8), be(), de(se, he, 1), de(he, se, -1), be(), se < 0 && ze(-se), he < 0 && ze(he);
      function be() {
        se = J.rect[i] - c3, he = p3 - Q.rect[i] - Q.rect[t3];
      }
      function de($e, Ke, nt) {
        if ($e < 0) {
          var lt2 = Math.min(Ke, -$e);
          if (lt2 > 0) {
            Fe(lt2 * nt, 0, b3);
            var bt = lt2 + $e;
            bt < 0 && Pe(-bt * nt, 1);
          } else
            Pe(-$e * nt, 1);
        }
      }
      function Fe($e, Ke, nt) {
        $e !== 0 && (I = true);
        for (var lt2 = Ke; lt2 < nt; lt2++) {
          var bt = o[lt2], vt = bt.rect;
          vt[i] += $e, bt.label[i] += $e;
        }
      }
      function Pe($e, Ke) {
        for (var nt = [], lt2 = 0, bt = 1; bt < b3; bt++) {
          var vt = o[bt - 1].rect, jt = Math.max(o[bt].rect[i] - vt[i] - vt[t3], 0);
          nt.push(jt), lt2 += jt;
        }
        if (lt2) {
          var Jt = Math.min(Math.abs($e) / lt2, Ke);
          if ($e > 0)
            for (var bt = 0; bt < b3 - 1; bt++) {
              var Rt = nt[bt] * Jt;
              Fe(Rt, 0, bt + 1);
            }
          else
            for (var bt = b3 - 1; bt > 0; bt--) {
              var Rt = nt[bt - 1] * Jt;
              Fe(-Rt, bt, b3);
            }
        }
      }
      function ze($e) {
        var Ke = $e < 0 ? -1 : 1;
        $e = Math.abs($e);
        for (var nt = Math.ceil($e / (b3 - 1)), lt2 = 0; lt2 < b3 - 1; lt2++)
          if (Ke > 0 ? Fe(nt, 0, lt2 + 1) : Fe(-nt, b3 - lt2 - 1, b3), $e -= nt, $e <= 0)
            return;
      }
      return I;
    }
    function hbt(o, i, t3, c3) {
      return k6e(o, "x", "width", i, t3, c3);
    }
    function O6e(o, i, t3, c3) {
      return k6e(o, "y", "height", i, t3, c3);
    }
    function P6e(o) {
      var i = [];
      o.sort(function(J, Q) {
        return Q.priority - J.priority;
      });
      var t3 = new Ys(0, 0, 0, 0);
      function c3(J) {
        if (!J.ignore) {
          var Q = J.ensureState("emphasis");
          Q.ignore == null && (Q.ignore = false);
        }
        J.ignore = true;
      }
      for (var p3 = 0; p3 < o.length; p3++) {
        var g3 = o[p3], b3 = g3.axisAligned, w3 = g3.localRect, M = g3.transform, I = g3.label, k3 = g3.labelLine;
        t3.copy(g3.rect), t3.width -= 0.1, t3.height -= 0.1, t3.x += 0.05, t3.y += 0.05;
        for (var L = g3.obb, F = false, B = 0; B < i.length; B++) {
          var G = i[B];
          if (t3.intersect(G.rect)) {
            if (b3 && G.axisAligned) {
              F = true;
              break;
            }
            if (G.obb || (G.obb = new l8(G.localRect, G.transform)), L || (L = new l8(w3, M)), L.intersect(G.obb)) {
              F = true;
              break;
            }
          }
        }
        F ? (c3(I), k3 && c3(k3)) : (I.attr("ignore", g3.defaultAttr.ignore), k3 && k3.attr("ignore", g3.defaultAttr.labelGuideIgnore), i.push(g3));
      }
    }
    function pbt(o) {
      if (o) {
        for (var i = [], t3 = 0; t3 < o.length; t3++)
          i.push(o[t3].slice());
        return i;
      }
    }
    function dbt(o, i) {
      var t3 = o.label, c3 = i && i.getTextGuideLine();
      return { dataIndex: o.dataIndex, dataType: o.dataType, seriesIndex: o.seriesModel.seriesIndex, text: o.label.style.text, rect: o.hostRect, labelRect: o.rect, align: t3.style.align, verticalAlign: t3.style.verticalAlign, labelLinePoints: pbt(c3 && c3.shape.points) };
    }
    var L6e = ["align", "verticalAlign", "width", "height", "fontSize"], R_ = new k1(), x0e = mu(), vbt = mu();
    function Zte(o, i, t3) {
      for (var c3 = 0; c3 < t3.length; c3++) {
        var p3 = t3[c3];
        i[p3] != null && (o[p3] = i[p3]);
      }
    }
    var Jte = ["x", "y", "rotation"], gbt = function() {
      function o() {
        this._labelList = [], this._chartViewList = [];
      }
      return o.prototype.clearLabels = function() {
        this._labelList = [], this._chartViewList = [];
      }, o.prototype._addLabel = function(i, t3, c3, p3, g3) {
        var b3 = p3.style, w3 = p3.__hostTarget, M = w3.textConfig || {}, I = p3.getComputedTransform(), k3 = p3.getBoundingRect().plain();
        Ys.applyTransform(k3, k3, I), I ? R_.setLocalTransform(I) : (R_.x = R_.y = R_.rotation = R_.originX = R_.originY = 0, R_.scaleX = R_.scaleY = 1);
        var L = p3.__hostTarget, F;
        if (L) {
          F = L.getBoundingRect().plain();
          var B = L.getComputedTransform();
          Ys.applyTransform(F, F, B);
        }
        var G = F && L.getTextGuideLine();
        this._labelList.push({ label: p3, labelLine: G, seriesModel: c3, dataIndex: i, dataType: t3, layoutOption: g3, computedLayoutOption: null, rect: k3, hostRect: F, priority: F ? F.width * F.height : 0, defaultAttr: { ignore: p3.ignore, labelGuideIgnore: G && G.ignore, x: R_.x, y: R_.y, scaleX: R_.scaleX, scaleY: R_.scaleY, rotation: R_.rotation, style: { x: b3.x, y: b3.y, align: b3.align, verticalAlign: b3.verticalAlign, width: b3.width, height: b3.height, fontSize: b3.fontSize }, cursor: p3.cursor, attachedPos: M.position, attachedRot: M.rotation } });
      }, o.prototype.addLabelsOfSeries = function(i) {
        var t3 = this;
        this._chartViewList.push(i);
        var c3 = i.__model, p3 = c3.get("labelLayout");
        !(Vo(p3) || Gl(p3).length) || i.group.traverse(function(g3) {
          if (g3.ignore)
            return true;
          var b3 = g3.getTextContent(), w3 = La(g3);
          b3 && !b3.disableLabelLayout && t3._addLabel(w3.dataIndex, w3.dataType, c3, b3, p3);
        });
      }, o.prototype.updateLayoutConfig = function(i) {
        var t3 = i.getWidth(), c3 = i.getHeight();
        function p3(be, de) {
          return function() {
            A6e(be, de);
          };
        }
        for (var g3 = 0; g3 < this._labelList.length; g3++) {
          var b3 = this._labelList[g3], w3 = b3.label, M = w3.__hostTarget, I = b3.defaultAttr, k3 = void 0;
          Vo(b3.layoutOption) ? k3 = b3.layoutOption(dbt(b3, M)) : k3 = b3.layoutOption, k3 = k3 || {}, b3.computedLayoutOption = k3;
          var L = Math.PI / 180;
          M && M.setTextConfig({ local: false, position: k3.x != null || k3.y != null ? null : I.attachedPos, rotation: k3.rotate != null ? k3.rotate * L : I.attachedRot, offset: [k3.dx || 0, k3.dy || 0] });
          var F = false;
          if (k3.x != null ? (w3.x = Da(k3.x, t3), w3.setStyle("x", 0), F = true) : (w3.x = I.x, w3.setStyle("x", I.style.x)), k3.y != null ? (w3.y = Da(k3.y, c3), w3.setStyle("y", 0), F = true) : (w3.y = I.y, w3.setStyle("y", I.style.y)), k3.labelLinePoints) {
            var B = M.getTextGuideLine();
            B && (B.setShape({ points: k3.labelLinePoints }), F = false);
          }
          var G = x0e(w3);
          G.needsUpdateLabelLine = F, w3.rotation = k3.rotate != null ? k3.rotate * L : I.rotation, w3.scaleX = I.scaleX, w3.scaleY = I.scaleY;
          for (var J = 0; J < L6e.length; J++) {
            var Q = L6e[J];
            w3.setStyle(Q, k3[Q] != null ? k3[Q] : I.style[Q]);
          }
          if (k3.draggable) {
            if (w3.draggable = true, w3.cursor = "move", M) {
              var se = b3.seriesModel;
              if (b3.dataIndex != null) {
                var he = b3.seriesModel.getData(b3.dataType);
                se = he.getItemModel(b3.dataIndex);
              }
              w3.on("drag", p3(M, se.getModel("labelLine")));
            }
          } else
            w3.off("drag"), w3.cursor = I.cursor;
        }
      }, o.prototype.layout = function(i) {
        var t3 = i.getWidth(), c3 = i.getHeight(), p3 = D6e(this._labelList), g3 = Zc(p3, function(M) {
          return M.layoutOption.moveOverlap === "shiftX";
        }), b3 = Zc(p3, function(M) {
          return M.layoutOption.moveOverlap === "shiftY";
        });
        hbt(g3, 0, t3), O6e(b3, 0, c3);
        var w3 = Zc(p3, function(M) {
          return M.layoutOption.hideOverlap;
        });
        P6e(w3);
      }, o.prototype.processLabelsOverall = function() {
        var i = this;
        yt(this._chartViewList, function(t3) {
          var c3 = t3.__model, p3 = t3.ignoreLabelLineUpdate, g3 = c3.isAnimationEnabled();
          t3.group.traverse(function(b3) {
            if (b3.ignore && !b3.forceLabelAnimation)
              return true;
            var w3 = !p3, M = b3.getTextContent();
            !w3 && M && (w3 = x0e(M).needsUpdateLabelLine), w3 && i._updateLabelLine(b3, c3), g3 && i._animateLabels(b3, c3);
          });
        });
      }, o.prototype._updateLabelLine = function(i, t3) {
        var c3 = i.getTextContent(), p3 = La(i), g3 = p3.dataIndex;
        if (c3 && g3 != null) {
          var b3 = t3.getData(p3.dataType), w3 = b3.getItemModel(g3), M = {}, I = b3.getItemVisual(g3, "style"), k3 = b3.getVisual("drawType");
          M.stroke = I[k3];
          var L = w3.getModel("labelLine");
          b0e(i, _0e(w3), M), A6e(i, L);
        }
      }, o.prototype._animateLabels = function(i, t3) {
        var c3 = i.getTextContent(), p3 = i.getTextGuideLine();
        if (c3 && (i.forceLabelAnimation || !c3.ignore && !c3.invisible && !i.disableLabelAnimation && !tk(i))) {
          var g3 = x0e(c3), b3 = g3.oldLayout, w3 = La(i), M = w3.dataIndex, I = { x: c3.x, y: c3.y, rotation: c3.rotation }, k3 = t3.getData(w3.dataType);
          if (b3) {
            c3.attr(b3);
            var L = i.prevStates;
            L && (rl(L, "select") >= 0 && c3.attr(g3.oldLayoutSelect), rl(L, "emphasis") >= 0 && c3.attr(g3.oldLayoutEmphasis)), Du(c3, I, t3, M);
          } else if (c3.attr(I), !p8(c3).valueAnimation) {
            var F = Xs(c3.style.opacity, 1);
            c3.style.opacity = 0, Uh(c3, { style: { opacity: F } }, t3, M);
          }
          if (g3.oldLayout = I, c3.states.select) {
            var B = g3.oldLayoutSelect = {};
            Zte(B, I, Jte), Zte(B, c3.states.select, Jte);
          }
          if (c3.states.emphasis) {
            var G = g3.oldLayoutEmphasis = {};
            Zte(G, I, Jte), Zte(G, c3.states.emphasis, Jte);
          }
          ZPe(c3, M, k3, t3, t3);
        }
        if (p3 && !p3.ignore && !p3.invisible) {
          var g3 = vbt(p3), b3 = g3.oldLayout, J = { points: p3.shape.points };
          b3 ? (p3.attr({ shape: b3 }), Du(p3, { shape: J }, t3)) : (p3.setShape(J), p3.style.strokePercent = 0, Uh(p3, { style: { strokePercent: 1 } }, t3)), g3.oldLayout = J;
        }
      }, o;
    }(), ybt = gbt, w0e = mu();
    function mbt(o) {
      o.registerUpdateLifecycle("series:beforeupdate", function(i, t3, c3) {
        var p3 = w0e(t3).labelManager;
        p3 || (p3 = w0e(t3).labelManager = new ybt()), p3.clearLabels();
      }), o.registerUpdateLifecycle("series:layoutlabels", function(i, t3, c3) {
        var p3 = w0e(t3).labelManager;
        c3.updatedSeries.forEach(function(g3) {
          p3.addLabelsOfSeries(t3.getViewOfSeriesModel(g3));
        }), p3.updateLayoutConfig(t3), p3.layout(t3), p3.processLabelsOverall();
      });
    }
    var S0e = Math.sin, C0e = Math.cos, R6e = Math.PI, pL = Math.PI * 2, bbt = 180 / R6e, _bt = function() {
      function o() {
      }
      return o.prototype.reset = function(i) {
        this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, i || 4);
      }, o.prototype.moveTo = function(i, t3) {
        this._add("M", i, t3);
      }, o.prototype.lineTo = function(i, t3) {
        this._add("L", i, t3);
      }, o.prototype.bezierCurveTo = function(i, t3, c3, p3, g3, b3) {
        this._add("C", i, t3, c3, p3, g3, b3);
      }, o.prototype.quadraticCurveTo = function(i, t3, c3, p3) {
        this._add("Q", i, t3, c3, p3);
      }, o.prototype.arc = function(i, t3, c3, p3, g3, b3) {
        this.ellipse(i, t3, c3, c3, 0, p3, g3, b3);
      }, o.prototype.ellipse = function(i, t3, c3, p3, g3, b3, w3, M) {
        var I = w3 - b3, k3 = !M, L = Math.abs(I), F = AM(L - pL) || (k3 ? I >= pL : -I >= pL), B = I > 0 ? I % pL : I % pL + pL, G = false;
        F ? G = true : AM(L) ? G = false : G = B >= R6e == !!k3;
        var J = i + c3 * C0e(b3), Q = t3 + p3 * S0e(b3);
        this._start && this._add("M", J, Q);
        var se = Math.round(g3 * bbt);
        if (F) {
          var he = 1 / this._p, be = (k3 ? 1 : -1) * (pL - he);
          this._add("A", c3, p3, se, 1, +k3, i + c3 * C0e(b3 + be), t3 + p3 * S0e(b3 + be)), he > 0.01 && this._add("A", c3, p3, se, 0, +k3, J, Q);
        } else {
          var de = i + c3 * C0e(w3), Fe = t3 + p3 * S0e(w3);
          this._add("A", c3, p3, se, +G, +k3, de, Fe);
        }
      }, o.prototype.rect = function(i, t3, c3, p3) {
        this._add("M", i, t3), this._add("l", c3, 0), this._add("l", 0, p3), this._add("l", -c3, 0), this._add("Z");
      }, o.prototype.closePath = function() {
        this._d.length > 0 && this._add("Z");
      }, o.prototype._add = function(i, t3, c3, p3, g3, b3, w3, M, I) {
        for (var k3 = [], L = this._p, F = 1; F < arguments.length; F++) {
          var B = arguments[F];
          if (isNaN(B)) {
            this._invalid = true;
            return;
          }
          k3.push(Math.round(B * L) / L);
        }
        this._d.push(i + k3.join(" ")), this._start = i === "Z";
      }, o.prototype.generateStr = function() {
        this._str = this._invalid ? "" : this._d.join(""), this._d = [];
      }, o.prototype.getStr = function() {
        return this._str;
      }, o;
    }(), N6e = _bt, rW = "none", xbt = Math.round;
    function wbt(o) {
      var i = o.fill;
      return i != null && i !== rW;
    }
    function Sbt(o) {
      var i = o.stroke;
      return i != null && i !== rW;
    }
    var M0e = ["lineCap", "miterLimit", "lineJoin"], Cbt = Fi(M0e, function(o) {
      return "stroke-" + o.toLowerCase();
    });
    function Mbt(o, i, t3, c3) {
      var p3 = i.opacity == null ? 1 : i.opacity;
      if (t3 instanceof Gv) {
        o("opacity", p3);
        return;
      }
      if (wbt(i)) {
        var g3 = F5(i.fill);
        o("fill", g3.color);
        var b3 = i.fillOpacity != null ? i.fillOpacity * g3.opacity * p3 : g3.opacity * p3;
        (c3 || b3 < 1) && o("fill-opacity", b3);
      } else
        o("fill", rW);
      if (Sbt(i)) {
        var w3 = F5(i.stroke);
        o("stroke", w3.color);
        var M = i.strokeNoScale ? t3.getLineScale() : 1, I = M ? (i.lineWidth || 0) / M : 0, k3 = i.strokeOpacity != null ? i.strokeOpacity * w3.opacity * p3 : w3.opacity * p3, L = i.strokeFirst;
        if ((c3 || I !== 1) && o("stroke-width", I), (c3 || L) && o("paint-order", L ? "stroke" : "fill"), (c3 || k3 < 1) && o("stroke-opacity", k3), i.lineDash) {
          var F = zge(t3), B = F[0], G = F[1];
          B && (G = xbt(G || 0), o("stroke-dasharray", B.join(",")), (G || c3) && o("stroke-dashoffset", G));
        } else
          c3 && o("stroke-dasharray", rW);
        for (var J = 0; J < M0e.length; J++) {
          var Q = M0e[J];
          if (c3 || i[Q] !== $F[Q]) {
            var se = i[Q] || $F[Q];
            se && o(Cbt[J], se);
          }
        }
      } else
        c3 && o("stroke", rW);
    }
    var F6e = "http://www.w3.org/2000/svg", V6e = "http://www.w3.org/1999/xlink", Tbt = "http://www.w3.org/2000/xmlns/", Abt = "http://www.w3.org/XML/1998/namespace";
    function B6e(o) {
      return document.createElementNS(F6e, o);
    }
    function Mg(o, i, t3, c3, p3) {
      return { tag: o, attrs: t3 || {}, children: c3, text: p3, key: i };
    }
    function Ibt(o, i) {
      var t3 = [];
      if (i)
        for (var c3 in i) {
          var p3 = i[c3], g3 = c3;
          p3 !== false && (p3 !== true && p3 != null && (g3 += '="' + p3 + '"'), t3.push(g3));
        }
      return "<" + o + " " + t3.join(" ") + ">";
    }
    function Ebt(o) {
      return "</" + o + ">";
    }
    function T0e(o, i) {
      i = i || {};
      var t3 = i.newline ? `
` : "";
      function c3(p3) {
        var g3 = p3.children, b3 = p3.tag, w3 = p3.attrs;
        return Ibt(b3, w3) + (p3.text || "") + (g3 ? "" + t3 + Fi(g3, function(M) {
          return c3(M);
        }).join(t3) + t3 : "") + Ebt(b3);
      }
      return c3(o);
    }
    function Dbt(o, i, t3) {
      t3 = t3 || {};
      var c3 = t3.newline ? `
` : "", p3 = " {" + c3, g3 = c3 + "}", b3 = Fi(Gl(o), function(M) {
        return M + p3 + Fi(Gl(o[M]), function(I) {
          return I + ":" + o[M][I] + ";";
        }).join(c3) + g3;
      }).join(c3), w3 = Fi(Gl(i), function(M) {
        return "@keyframes " + M + p3 + Fi(Gl(i[M]), function(I) {
          return I + p3 + Fi(Gl(i[M][I]), function(k3) {
            var L = i[M][I][k3];
            return k3 === "d" && (L = 'path("' + L + '")'), k3 + ":" + L + ";";
          }).join(c3) + g3;
        }).join(c3) + g3;
      }).join(c3);
      return !b3 && !w3 ? "" : ["<![CDATA[", b3, w3, "]]>"].join(c3);
    }
    function A0e(o) {
      return { zrId: o, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
    }
    function z6e(o, i, t3, c3) {
      return Mg("svg", "root", { width: o, height: i, xmlns: F6e, "xmlns:xlink": V6e, version: "1.1", baseProfile: "full", viewBox: c3 ? "0 0 " + o + " " + i : false }, t3);
    }
    var j6e = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, dL = "transform-origin";
    function kbt(o, i, t3) {
      var c3 = ti({}, o.shape);
      ti(c3, i), o.buildPath(t3, c3);
      var p3 = new N6e();
      return p3.reset(xQ(o)), t3.rebuildPath(p3, 1), p3.generateStr(), p3.getStr();
    }
    function Obt(o, i) {
      var t3 = i.originX, c3 = i.originY;
      (t3 || c3) && (o[dL] = t3 + "px " + c3 + "px");
    }
    var Pbt = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
    function G6e(o, i) {
      var t3 = i.zrId + "-ani-" + i.cssAnimIdx++;
      return i.cssAnims[t3] = o, t3;
    }
    function Lbt(o, i, t3) {
      var c3 = o.shape.paths, p3 = {}, g3, b3;
      if (yt(c3, function(M) {
        var I = A0e(t3.zrId);
        I.animation = true, Qte(M, {}, I, true);
        var k3 = I.cssAnims, L = I.cssNodes, F = Gl(k3), B = F.length;
        if (B) {
          b3 = F[B - 1];
          var G = k3[b3];
          for (var J in G) {
            var Q = G[J];
            p3[J] = p3[J] || { d: "" }, p3[J].d += Q.d || "";
          }
          for (var se in L) {
            var he = L[se].animation;
            he.indexOf(b3) >= 0 && (g3 = he);
          }
        }
      }), !!g3) {
        i.d = false;
        var w3 = G6e(p3, t3);
        return g3.replace(b3, w3);
      }
    }
    function H6e(o) {
      return Ha(o) ? j6e[o] ? "cubic-bezier(" + j6e[o] + ")" : CP(o) ? o : "" : "";
    }
    function Qte(o, i, t3, c3) {
      var p3 = o.animators, g3 = p3.length, b3 = [];
      if (o instanceof _H) {
        var w3 = Lbt(o, i, t3);
        if (w3)
          b3.push(w3);
        else if (!g3)
          return;
      } else if (!g3)
        return;
      for (var M = {}, I = 0; I < g3; I++) {
        var k3 = p3[I], L = [k3.getMaxTime() / 1e3 + "s"], F = H6e(k3.getClip().easing), B = k3.getDelay();
        F ? L.push(F) : L.push("linear"), B && L.push(B / 1e3 + "s"), k3.getLoop() && L.push("infinite");
        var G = L.join(" ");
        M[G] = M[G] || [G, []], M[G][1].push(k3);
      }
      function J(he) {
        var be = he[1], de = be.length, Fe = {}, Pe = {}, ze = {}, $e = "animation-timing-function";
        function Ke(Ra, ho, Mo) {
          for (var Xa = Ra.getTracks(), Zo = Ra.getMaxTime(), rc = 0; rc < Xa.length; rc++) {
            var ys = Xa[rc];
            if (ys.needsAnimate()) {
              var Vu = ys.keyframes, gc = ys.propName;
              if (Mo && (gc = Mo(gc)), gc)
                for (var ef = 0; ef < Vu.length; ef++) {
                  var dv = Vu[ef], Wf = Math.round(dv.time / Zo * 100) + "%", Ag = H6e(dv.easing), eh = dv.rawValue;
                  (Ha(eh) || ec(eh)) && (ho[Wf] = ho[Wf] || {}, ho[Wf][gc] = dv.rawValue, Ag && (ho[Wf][$e] = Ag));
                }
            }
          }
        }
        for (var nt = 0; nt < de; nt++) {
          var lt2 = be[nt], bt = lt2.targetName;
          bt ? bt === "shape" && Ke(lt2, Pe) : !c3 && Ke(lt2, Fe);
        }
        for (var vt in Fe) {
          var jt = {};
          OQ(jt, o), ti(jt, Fe[vt]);
          var Jt = oG(jt), Rt = Fe[vt][$e];
          ze[vt] = Jt ? { transform: Jt } : {}, Obt(ze[vt], jt), Rt && (ze[vt][$e] = Rt);
        }
        var Jn, ln = true;
        for (var vt in Pe) {
          ze[vt] = ze[vt] || {};
          var vn = !Jn, Rt = Pe[vt][$e];
          vn && (Jn = new ww());
          var kn = Jn.len();
          Jn.reset(), ze[vt].d = kbt(o, Pe[vt], Jn);
          var cr = Jn.len();
          if (!vn && kn !== cr) {
            ln = false;
            break;
          }
          Rt && (ze[vt][$e] = Rt);
        }
        if (!ln)
          for (var vt in ze)
            delete ze[vt].d;
        if (!c3)
          for (var nt = 0; nt < de; nt++) {
            var lt2 = be[nt], bt = lt2.targetName;
            bt === "style" && Ke(lt2, ze, function(Xa) {
              return Pbt[Xa];
            });
          }
        for (var gr = Gl(ze), ha = true, Ka, nt = 1; nt < gr.length; nt++) {
          var Do = gr[nt - 1], _o = gr[nt];
          if (ze[Do][dL] !== ze[_o][dL]) {
            ha = false;
            break;
          }
          Ka = ze[Do][dL];
        }
        if (ha && Ka) {
          for (var vt in ze)
            ze[vt][dL] && delete ze[vt][dL];
          i[dL] = Ka;
        }
        if (Zc(gr, function(Ra) {
          return Gl(ze[Ra]).length > 0;
        }).length) {
          var xo = G6e(ze, t3);
          return xo + " " + he[0] + " both";
        }
      }
      for (var Q in M) {
        var w3 = J(M[Q]);
        w3 && b3.push(w3);
      }
      if (b3.length) {
        var se = t3.zrId + "-cls-" + t3.cssClassIdx++;
        t3.cssNodes["." + se] = { animation: b3.join(",") }, i.class = se;
      }
    }
    var iW = Math.round;
    function W6e(o) {
      return o && Ha(o.src);
    }
    function U6e(o) {
      return o && Vo(o.toDataURL);
    }
    function I0e(o, i, t3, c3) {
      Mbt(function(p3, g3) {
        var b3 = p3 === "fill" || p3 === "stroke";
        b3 && lde(g3) ? Gbt(i, o, p3, c3) : b3 && E_(g3) ? Hbt(t3, o, p3, c3) : o[p3] = g3;
      }, i, t3, false), jbt(t3, o, c3);
    }
    function q6e(o) {
      return AM(o[0] - 1) && AM(o[1]) && AM(o[2]) && AM(o[3] - 1);
    }
    function Rbt(o) {
      return AM(o[4]) && AM(o[5]);
    }
    function E0e(o, i, t3) {
      if (i && !(Rbt(i) && q6e(i))) {
        var c3 = t3 ? 10 : 1e4;
        o.transform = q6e(i) ? "translate(" + iW(i[4] * c3) / c3 + " " + iW(i[5] * c3) / c3 + ")" : rde(i);
      }
    }
    function $6e(o, i, t3) {
      for (var c3 = o.points, p3 = [], g3 = 0; g3 < c3.length; g3++)
        p3.push(iW(c3[g3][0] * t3) / t3), p3.push(iW(c3[g3][1] * t3) / t3);
      i.points = p3.join(" ");
    }
    function X6e(o) {
      return !o.smooth;
    }
    function Nbt(o) {
      var i = Fi(o, function(t3) {
        return typeof t3 == "string" ? [t3, t3] : t3;
      });
      return function(t3, c3, p3) {
        for (var g3 = 0; g3 < i.length; g3++) {
          var b3 = i[g3], w3 = t3[b3[0]];
          w3 != null && (c3[b3[1]] = iW(w3 * p3) / p3);
        }
      };
    }
    var Fbt = { circle: [Nbt(["cx", "cy", "r"])], polyline: [$6e, X6e], polygon: [$6e, X6e] };
    function Vbt(o) {
      for (var i = o.animators, t3 = 0; t3 < i.length; t3++)
        if (i[t3].targetName === "shape")
          return true;
      return false;
    }
    function Y6e(o, i) {
      var t3 = o.style, c3 = o.shape, p3 = Fbt[o.type], g3 = {}, b3 = i.animation, w3 = "path", M = o.style.strokePercent, I = i.compress && xQ(o) || 4;
      if (p3 && !i.willUpdate && !(p3[1] && !p3[1](c3)) && !(b3 && Vbt(o)) && !(M < 1)) {
        w3 = o.type;
        var k3 = Math.pow(10, I);
        p3[0](c3, g3, k3);
      } else {
        o.path || o.createPathProxy();
        var L = o.path;
        o.shapeChanged() && (L.beginPath(), o.buildPath(L, o.shape), o.pathUpdated());
        var F = L.getVersion(), B = o, G = B.__svgPathBuilder;
        (B.__svgPathVersion !== F || !G || M !== B.__svgPathStrokePercent) && (G || (G = B.__svgPathBuilder = new N6e()), G.reset(I), L.rebuildPath(G, M), G.generateStr(), B.__svgPathVersion = F, B.__svgPathStrokePercent = M), g3.d = G.getStr();
      }
      return E0e(g3, o.transform), I0e(g3, t3, o, i), i.animation && Qte(o, g3, i), Mg(w3, o.id + "", g3);
    }
    function Bbt(o, i) {
      var t3 = o.style, c3 = t3.image;
      if (c3 && !Ha(c3) && (W6e(c3) ? c3 = c3.src : U6e(c3) && (c3 = c3.toDataURL())), !!c3) {
        var p3 = t3.x || 0, g3 = t3.y || 0, b3 = t3.width, w3 = t3.height, M = { href: c3, width: b3, height: w3 };
        return p3 && (M.x = p3), g3 && (M.y = g3), E0e(M, o.transform), I0e(M, t3, o, i), i.animation && Qte(o, M, i), Mg("image", o.id + "", M);
      }
    }
    function zbt(o, i) {
      var t3 = o.style, c3 = t3.text;
      if (c3 != null && (c3 += ""), !(!c3 || isNaN(t3.x) || isNaN(t3.y))) {
        var p3 = t3.font || Vs, g3 = t3.x || 0, b3 = ade(t3.y || 0, H5(p3), t3.textBaseline), w3 = ide[t3.textAlign] || t3.textAlign, M = { "dominant-baseline": "central", "text-anchor": w3 };
        if (wee(t3)) {
          var I = "", k3 = t3.fontStyle, L = _ee(t3.fontSize);
          if (!parseFloat(L))
            return;
          var F = t3.fontFamily || tp, B = t3.fontWeight;
          I += "font-size:" + L + ";font-family:" + F + ";", k3 && k3 !== "normal" && (I += "font-style:" + k3 + ";"), B && B !== "normal" && (I += "font-weight:" + B + ";"), M.style = I;
        } else
          M.style = "font: " + p3;
        return c3.match(/\s/) && (M["xml:space"] = "preserve"), g3 && (M.x = g3), b3 && (M.y = b3), E0e(M, o.transform), I0e(M, t3, o, i), i.animation && Qte(o, M, i), Mg("text", o.id + "", M, void 0, c3);
      }
    }
    function K6e(o, i) {
      if (o instanceof gl)
        return Y6e(o, i);
      if (o instanceof Gv)
        return Bbt(o, i);
      if (o instanceof HP)
        return zbt(o, i);
    }
    function jbt(o, i, t3) {
      var c3 = o.style;
      if (ode(c3)) {
        var p3 = aI(o), g3 = t3.shadowCache, b3 = g3[p3];
        if (!b3) {
          var w3 = o.getGlobalScale(), M = w3[0], I = w3[1];
          if (!M || !I)
            return;
          var k3 = c3.shadowOffsetX || 0, L = c3.shadowOffsetY || 0, F = c3.shadowBlur, B = F5(c3.shadowColor), G = B.opacity, J = B.color, Q = F / 2 / M, se = F / 2 / I, he = Q + " " + se;
          b3 = t3.zrId + "-s" + t3.shadowIdx++, t3.defs[b3] = Mg("filter", b3, { id: b3, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [Mg("feDropShadow", "", { dx: k3 / M, dy: L / I, stdDeviation: he, "flood-color": J, "flood-opacity": G })]), g3[p3] = b3;
        }
        i.filter = yF(b3);
      }
    }
    function Gbt(o, i, t3, c3) {
      var p3 = o[t3], g3, b3 = { gradientUnits: p3.global ? "userSpaceOnUse" : "objectBoundingBox" };
      if (bQ(p3))
        g3 = "linearGradient", b3.x1 = p3.x, b3.y1 = p3.y, b3.x2 = p3.x2, b3.y2 = p3.y2;
      else if (_Q(p3))
        g3 = "radialGradient", b3.cx = Xs(p3.x, 0.5), b3.cy = Xs(p3.y, 0.5), b3.r = Xs(p3.r, 0.5);
      else
        return;
      for (var w3 = p3.colorStops, M = [], I = 0, k3 = w3.length; I < k3; ++I) {
        var L = aG(w3[I].offset) * 100 + "%", F = w3[I].color, B = F5(F), G = B.color, J = B.opacity, Q = { offset: L };
        Q["stop-color"] = G, J < 1 && (Q["stop-opacity"] = J), M.push(Mg("stop", I + "", Q));
      }
      var se = Mg(g3, "", b3, M), he = T0e(se), be = c3.gradientCache, de = be[he];
      de || (de = c3.zrId + "-g" + c3.gradientIdx++, be[he] = de, b3.id = de, c3.defs[de] = Mg(g3, de, b3, M)), i[t3] = yF(de);
    }
    function Hbt(o, i, t3, c3) {
      var p3 = o.style[t3], g3 = { patternUnits: "userSpaceOnUse" }, b3;
      if (mQ(p3)) {
        var w3 = p3.imageWidth, M = p3.imageHeight, I = void 0, k3 = p3.image;
        if (Ha(k3) ? I = k3 : W6e(k3) ? I = k3.src : U6e(k3) && (I = k3.toDataURL()), typeof Image == "undefined") {
          var L = "Image width/height must been given explictly in svg-ssr renderer.";
          u0(w3, L), u0(M, L);
        } else if (w3 == null || M == null) {
          var F = function(he, be) {
            if (he) {
              var de = he.elm, Fe = he.attrs.width = w3 || be.width, Pe = he.attrs.height = M || be.height;
              de && (de.setAttribute("width", Fe), de.setAttribute("height", Pe));
            }
          }, B = zF(I, null, o, function(he) {
            F(G, he), F(b3, he);
          });
          B && B.width && B.height && (w3 = w3 || B.width, M = M || B.height);
        }
        b3 = Mg("image", "img", { href: I, width: w3, height: M }), g3.width = w3, g3.height = M;
      } else
        p3.svgElement && (b3 = Jo(p3.svgElement), g3.width = p3.svgWidth, g3.height = p3.svgHeight);
      if (b3) {
        g3.patternTransform = oG(p3);
        var G = Mg("pattern", "", g3, [b3]), J = T0e(G), Q = c3.patternCache, se = Q[J];
        se || (se = c3.zrId + "-p" + c3.patternIdx++, Q[J] = se, g3.id = se, G = c3.defs[se] = Mg("pattern", se, g3, [b3])), i[t3] = yF(se);
      }
    }
    function Wbt(o, i, t3) {
      var c3 = t3.clipPathCache, p3 = t3.defs, g3 = c3[o.id];
      if (!g3) {
        g3 = t3.zrId + "-c" + t3.clipPathIdx++;
        var b3 = { id: g3 };
        c3[o.id] = g3, p3[g3] = Mg("clipPath", g3, b3, [Y6e(o, t3)]);
      }
      i["clip-path"] = yF(g3);
    }
    function Z6e(o) {
      return document.createTextNode(o);
    }
    function vL(o, i, t3) {
      o.insertBefore(i, t3);
    }
    function J6e(o, i) {
      o.removeChild(i);
    }
    function Q6e(o, i) {
      o.appendChild(i);
    }
    function eNe(o) {
      return o.parentNode;
    }
    function tNe(o) {
      return o.nextSibling;
    }
    function D0e(o, i) {
      o.textContent = i;
    }
    var nNe = 58, Ubt = 120, qbt = Mg("", "");
    function k0e(o) {
      return o === void 0;
    }
    function tT(o) {
      return o !== void 0;
    }
    function $bt(o, i, t3) {
      for (var c3 = {}, p3 = i; p3 <= t3; ++p3) {
        var g3 = o[p3].key;
        g3 !== void 0 && (c3[g3] = p3);
      }
      return c3;
    }
    function aW(o, i) {
      var t3 = o.key === i.key, c3 = o.tag === i.tag;
      return c3 && t3;
    }
    function oW(o) {
      var i, t3 = o.children, c3 = o.tag;
      if (tT(c3)) {
        var p3 = o.elm = B6e(c3);
        if (O0e(qbt, o), Ei(t3))
          for (i = 0; i < t3.length; ++i) {
            var g3 = t3[i];
            g3 != null && Q6e(p3, oW(g3));
          }
        else
          tT(o.text) && !Ua(o.text) && Q6e(p3, Z6e(o.text));
      } else
        o.elm = Z6e(o.text);
      return o.elm;
    }
    function rNe(o, i, t3, c3, p3) {
      for (; c3 <= p3; ++c3) {
        var g3 = t3[c3];
        g3 != null && vL(o, oW(g3), i);
      }
    }
    function ene(o, i, t3, c3) {
      for (; t3 <= c3; ++t3) {
        var p3 = i[t3];
        if (p3 != null)
          if (tT(p3.tag)) {
            var g3 = eNe(p3.elm);
            J6e(g3, p3.elm);
          } else
            J6e(o, p3.elm);
      }
    }
    function O0e(o, i) {
      var t3, c3 = i.elm, p3 = o && o.attrs || {}, g3 = i.attrs || {};
      if (p3 !== g3) {
        for (t3 in g3) {
          var b3 = g3[t3], w3 = p3[t3];
          w3 !== b3 && (b3 === true ? c3.setAttribute(t3, "") : b3 === false ? c3.removeAttribute(t3) : t3.charCodeAt(0) !== Ubt ? c3.setAttribute(t3, b3) : t3 === "xmlns:xlink" || t3 === "xmlns" ? c3.setAttributeNS(Tbt, t3, b3) : t3.charCodeAt(3) === nNe ? c3.setAttributeNS(Abt, t3, b3) : t3.charCodeAt(5) === nNe ? c3.setAttributeNS(V6e, t3, b3) : c3.setAttribute(t3, b3));
        }
        for (t3 in p3)
          t3 in g3 || c3.removeAttribute(t3);
      }
    }
    function Xbt(o, i, t3) {
      for (var c3 = 0, p3 = 0, g3 = i.length - 1, b3 = i[0], w3 = i[g3], M = t3.length - 1, I = t3[0], k3 = t3[M], L, F, B, G; c3 <= g3 && p3 <= M; )
        b3 == null ? b3 = i[++c3] : w3 == null ? w3 = i[--g3] : I == null ? I = t3[++p3] : k3 == null ? k3 = t3[--M] : aW(b3, I) ? (P8(b3, I), b3 = i[++c3], I = t3[++p3]) : aW(w3, k3) ? (P8(w3, k3), w3 = i[--g3], k3 = t3[--M]) : aW(b3, k3) ? (P8(b3, k3), vL(o, b3.elm, tNe(w3.elm)), b3 = i[++c3], k3 = t3[--M]) : aW(w3, I) ? (P8(w3, I), vL(o, w3.elm, b3.elm), w3 = i[--g3], I = t3[++p3]) : (k0e(L) && (L = $bt(i, c3, g3)), F = L[I.key], k0e(F) ? vL(o, oW(I), b3.elm) : (B = i[F], B.tag !== I.tag ? vL(o, oW(I), b3.elm) : (P8(B, I), i[F] = void 0, vL(o, B.elm, b3.elm))), I = t3[++p3]);
      (c3 <= g3 || p3 <= M) && (c3 > g3 ? (G = t3[M + 1] == null ? null : t3[M + 1].elm, rNe(o, G, t3, p3, M)) : ene(o, i, c3, g3));
    }
    function P8(o, i) {
      var t3 = i.elm = o.elm, c3 = o.children, p3 = i.children;
      o !== i && (O0e(o, i), k0e(i.text) ? tT(c3) && tT(p3) ? c3 !== p3 && Xbt(t3, c3, p3) : tT(p3) ? (tT(o.text) && D0e(t3, ""), rNe(t3, null, p3, 0, p3.length - 1)) : tT(c3) ? ene(t3, c3, 0, c3.length - 1) : tT(o.text) && D0e(t3, "") : o.text !== i.text && (tT(c3) && ene(t3, c3, 0, c3.length - 1), D0e(t3, i.text)));
    }
    function Ybt(o, i) {
      if (aW(o, i))
        P8(o, i);
      else {
        var t3 = o.elm, c3 = eNe(t3);
        oW(i), c3 !== null && (vL(c3, i.elm, tNe(t3)), ene(c3, [o], 0, 0));
      }
      return i;
    }
    var Kbt = 0, Zbt = function() {
      function o(i, t3, c3) {
        if (this.type = "svg", this.refreshHover = iNe(), this.configLayer = iNe(), this.storage = t3, this._opts = c3 = ti({}, c3), this.root = i, this._id = "zr" + Kbt++, this._oldVNode = z6e(c3.width, c3.height), i && !c3.ssr) {
          var p3 = this._viewport = document.createElement("div");
          p3.style.cssText = "position:relative;overflow:hidden";
          var g3 = this._svgDom = this._oldVNode.elm = B6e("svg");
          O0e(null, this._oldVNode), p3.appendChild(g3), i.appendChild(p3);
        }
        this.resize(c3.width, c3.height);
      }
      return o.prototype.getType = function() {
        return this.type;
      }, o.prototype.getViewportRoot = function() {
        return this._viewport;
      }, o.prototype.getViewportRootOffset = function() {
        var i = this.getViewportRoot();
        if (i)
          return { offsetLeft: i.offsetLeft || 0, offsetTop: i.offsetTop || 0 };
      }, o.prototype.getSvgDom = function() {
        return this._svgDom;
      }, o.prototype.refresh = function() {
        if (this.root) {
          var i = this.renderToVNode({ willUpdate: true });
          i.attrs.style = "position:absolute;left:0;top:0;user-select:none", Ybt(this._oldVNode, i), this._oldVNode = i;
        }
      }, o.prototype.renderOneToVNode = function(i) {
        return K6e(i, A0e(this._id));
      }, o.prototype.renderToVNode = function(i) {
        i = i || {};
        var t3 = this.storage.getDisplayList(true), c3 = this._backgroundColor, p3 = this._width, g3 = this._height, b3 = A0e(this._id);
        b3.animation = i.animation, b3.willUpdate = i.willUpdate, b3.compress = i.compress;
        var w3 = [];
        if (c3 && c3 !== "none") {
          var M = F5(c3), I = M.color, k3 = M.opacity;
          this._bgVNode = Mg("rect", "bg", { width: p3, height: g3, x: "0", y: "0", id: "0", fill: I, "fill-opacity": k3 }), w3.push(this._bgVNode);
        } else
          this._bgVNode = null;
        var L = i.compress ? null : this._mainVNode = Mg("g", "main", {}, []);
        this._paintList(t3, b3, L ? L.children : w3), L && w3.push(L);
        var F = Fi(Gl(b3.defs), function(J) {
          return b3.defs[J];
        });
        if (F.length && w3.push(Mg("defs", "defs", {}, F)), i.animation) {
          var B = Dbt(b3.cssNodes, b3.cssAnims, { newline: true });
          if (B) {
            var G = Mg("style", "stl", {}, [], B);
            w3.push(G);
          }
        }
        return z6e(p3, g3, w3, i.useViewBox);
      }, o.prototype.renderToString = function(i) {
        return i = i || {}, T0e(this.renderToVNode({ animation: Xs(i.cssAnimation, true), willUpdate: false, compress: true, useViewBox: Xs(i.useViewBox, true) }), { newline: true });
      }, o.prototype.setBackgroundColor = function(i) {
        this._backgroundColor = i;
        var t3 = this._bgVNode;
        if (t3 && t3.elm) {
          var c3 = F5(i), p3 = c3.color, g3 = c3.opacity;
          t3.elm.setAttribute("fill", p3), g3 < 1 && t3.elm.setAttribute("fill-opacity", g3);
        }
      }, o.prototype.getSvgRoot = function() {
        return this._mainVNode && this._mainVNode.elm;
      }, o.prototype._paintList = function(i, t3, c3) {
        for (var p3 = i.length, g3 = [], b3 = 0, w3, M, I = 0, k3 = 0; k3 < p3; k3++) {
          var L = i[k3];
          if (!L.invisible) {
            var F = L.__clipPaths, B = F && F.length || 0, G = M && M.length || 0, J = void 0;
            for (J = Math.max(B - 1, G - 1); J >= 0 && !(F && M && F[J] === M[J]); J--)
              ;
            for (var Q = G - 1; Q > J; Q--)
              b3--, w3 = g3[b3 - 1];
            for (var se = J + 1; se < B; se++) {
              var he = {};
              Wbt(F[se], he, t3);
              var be = Mg("g", "clip-g-" + I++, he, []);
              (w3 ? w3.children : c3).push(be), g3[b3++] = be, w3 = be;
            }
            M = F;
            var de = K6e(L, t3);
            de && (w3 ? w3.children : c3).push(de);
          }
        }
      }, o.prototype.resize = function(i, t3) {
        var c3 = this._opts, p3 = this.root, g3 = this._viewport;
        if (i != null && (c3.width = i), t3 != null && (c3.height = t3), p3 && g3 && (g3.style.display = "none", i = E8(p3, 0, c3), t3 = E8(p3, 1, c3), g3.style.display = ""), this._width !== i || this._height !== t3) {
          if (this._width = i, this._height = t3, g3) {
            var b3 = g3.style;
            b3.width = i + "px", b3.height = t3 + "px";
          }
          var w3 = this._svgDom;
          w3 && (w3.setAttribute("width", i), w3.setAttribute("height", t3));
        }
      }, o.prototype.getWidth = function() {
        return this._width;
      }, o.prototype.getHeight = function() {
        return this._height;
      }, o.prototype.dispose = function() {
        this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
      }, o.prototype.clear = function() {
        this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
      }, o.prototype.toDataURL = function(i) {
        var t3 = encodeURIComponent(this.renderToString()), c3 = "data:image/svg+xml;";
        return i ? (t3 = wQ(t3), t3 && c3 + "base64," + t3) : c3 + "charset=UTF-8," + t3;
      }, o;
    }();
    function iNe(o) {
      return function() {
      };
    }
    var Jbt = Zbt;
    function Qbt(o) {
      o.registerPainter("svg", Jbt);
    }
    function aNe(o, i, t3) {
      var c3 = cm.createCanvas(), p3 = i.getWidth(), g3 = i.getHeight(), b3 = c3.style;
      return b3 && (b3.position = "absolute", b3.left = "0", b3.top = "0", b3.width = p3 + "px", b3.height = g3 + "px", c3.setAttribute("data-zr-dom-id", o)), c3.width = p3 * t3, c3.height = g3 * t3, c3;
    }
    var e_t = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this) || this;
        g3.motionBlur = false, g3.lastFrameAlpha = 0.7, g3.dpr = 1, g3.virtual = false, g3.config = {}, g3.incremental = false, g3.zlevel = 0, g3.maxRepaintRectCount = 5, g3.__dirty = true, g3.__firstTimePaint = true, g3.__used = false, g3.__drawIndex = 0, g3.__startIndex = 0, g3.__endIndex = 0, g3.__prevStartIndex = null, g3.__prevEndIndex = null;
        var b3;
        p3 = p3 || xF, typeof t3 == "string" ? b3 = aNe(t3, c3, p3) : Ua(t3) && (b3 = t3, t3 = b3.id), g3.id = t3, g3.dom = b3;
        var w3 = b3.style;
        return w3 && (fm(b3), b3.onselectstart = function() {
          return false;
        }, w3.padding = "0", w3.margin = "0", w3.borderWidth = "0"), g3.painter = c3, g3.dpr = p3, g3;
      }
      return i.prototype.getElementCount = function() {
        return this.__endIndex - this.__startIndex;
      }, i.prototype.afterBrush = function() {
        this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
      }, i.prototype.initContext = function() {
        this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
      }, i.prototype.setUnpainted = function() {
        this.__firstTimePaint = true;
      }, i.prototype.createBackBuffer = function() {
        var t3 = this.dpr;
        this.domBack = aNe("back-" + this.id, this.painter, t3), this.ctxBack = this.domBack.getContext("2d"), t3 !== 1 && this.ctxBack.scale(t3, t3);
      }, i.prototype.createRepaintRects = function(t3, c3, p3, g3) {
        if (this.__firstTimePaint)
          return this.__firstTimePaint = false, null;
        var b3 = [], w3 = this.maxRepaintRectCount, M = false, I = new Ys(0, 0, 0, 0);
        function k3(he) {
          if (!(!he.isFinite() || he.isZero()))
            if (b3.length === 0) {
              var be = new Ys(0, 0, 0, 0);
              be.copy(he), b3.push(be);
            } else {
              for (var de = false, Fe = 1 / 0, Pe = 0, ze = 0; ze < b3.length; ++ze) {
                var $e = b3[ze];
                if ($e.intersect(he)) {
                  var Ke = new Ys(0, 0, 0, 0);
                  Ke.copy($e), Ke.union(he), b3[ze] = Ke, de = true;
                  break;
                } else if (M) {
                  I.copy(he), I.union($e);
                  var nt = he.width * he.height, lt2 = $e.width * $e.height, bt = I.width * I.height, vt = bt - nt - lt2;
                  vt < Fe && (Fe = vt, Pe = ze);
                }
              }
              if (M && (b3[Pe].union(he), de = true), !de) {
                var be = new Ys(0, 0, 0, 0);
                be.copy(he), b3.push(be);
              }
              M || (M = b3.length >= w3);
            }
        }
        for (var L = this.__startIndex; L < this.__endIndex; ++L) {
          var F = t3[L];
          if (F) {
            var B = F.shouldBePainted(p3, g3, true, true), G = F.__isRendered && (F.__dirty & c0 || !B) ? F.getPrevPaintRect() : null;
            G && k3(G);
            var J = B && (F.__dirty & c0 || !F.__isRendered) ? F.getPaintRect() : null;
            J && k3(J);
          }
        }
        for (var L = this.__prevStartIndex; L < this.__prevEndIndex; ++L) {
          var F = c3[L], B = F.shouldBePainted(p3, g3, true, true);
          if (F && (!B || !F.__zr) && F.__isRendered) {
            var G = F.getPrevPaintRect();
            G && k3(G);
          }
        }
        var Q;
        do {
          Q = false;
          for (var L = 0; L < b3.length; ) {
            if (b3[L].isZero()) {
              b3.splice(L, 1);
              continue;
            }
            for (var se = L + 1; se < b3.length; )
              b3[L].intersect(b3[se]) ? (Q = true, b3[L].union(b3[se]), b3.splice(se, 1)) : se++;
            L++;
          }
        } while (Q);
        return this._paintRects = b3, b3;
      }, i.prototype.debugGetPaintRects = function() {
        return (this._paintRects || []).slice();
      }, i.prototype.resize = function(t3, c3) {
        var p3 = this.dpr, g3 = this.dom, b3 = g3.style, w3 = this.domBack;
        b3 && (b3.width = t3 + "px", b3.height = c3 + "px"), g3.width = t3 * p3, g3.height = c3 * p3, w3 && (w3.width = t3 * p3, w3.height = c3 * p3, p3 !== 1 && this.ctxBack.scale(p3, p3));
      }, i.prototype.clear = function(t3, c3, p3) {
        var g3 = this.dom, b3 = this.ctx, w3 = g3.width, M = g3.height;
        c3 = c3 || this.clearColor;
        var I = this.motionBlur && !t3, k3 = this.lastFrameAlpha, L = this.dpr, F = this;
        I && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(g3, 0, 0, w3 / L, M / L));
        var B = this.domBack;
        function G(J, Q, se, he) {
          if (b3.clearRect(J, Q, se, he), c3 && c3 !== "transparent") {
            var be = void 0;
            rF(c3) ? (be = c3.__canvasGradient || Bge(b3, c3, { x: 0, y: 0, width: se, height: he }), c3.__canvasGradient = be) : Bpe(c3) && (be = jge(b3, c3, { dirty: function() {
              F.setUnpainted(), F.__painter.refresh();
            } })), b3.save(), b3.fillStyle = be || c3, b3.fillRect(J, Q, se, he), b3.restore();
          }
          I && (b3.save(), b3.globalAlpha = k3, b3.drawImage(B, J, Q, se, he), b3.restore());
        }
        !p3 || I ? G(0, 0, w3, M) : p3.length && yt(p3, function(J) {
          G(J.x * L, J.y * L, J.width * L, J.height * L);
        });
      }, i;
    }(hm), P0e = e_t, oNe = 1e5, gL = 314159, tne = 0.01, t_t = 1e-3;
    function n_t(o) {
      return o ? o.__builtin__ ? true : !(typeof o.resize != "function" || typeof o.refresh != "function") : false;
    }
    function r_t(o, i) {
      var t3 = document.createElement("div");
      return t3.style.cssText = ["position:relative", "width:" + o + "px", "height:" + i + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", t3;
    }
    var i_t = function() {
      function o(i, t3, c3, p3) {
        this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
        var g3 = !i.nodeName || i.nodeName.toUpperCase() === "CANVAS";
        this._opts = c3 = ti({}, c3 || {}), this.dpr = c3.devicePixelRatio || xF, this._singleCanvas = g3, this.root = i;
        var b3 = i.style;
        b3 && (fm(i), i.innerHTML = ""), this.storage = t3;
        var w3 = this._zlevelList;
        this._prevDisplayList = [];
        var M = this._layers;
        if (g3) {
          var I = i, k3 = I.width, L = I.height;
          c3.width != null && (k3 = c3.width), c3.height != null && (L = c3.height), this.dpr = c3.devicePixelRatio || 1, I.width = k3 * this.dpr, I.height = L * this.dpr, this._width = k3, this._height = L;
          var F = new P0e(I, this, this.dpr);
          F.__builtin__ = true, F.initContext(), M[gL] = F, F.zlevel = gL, w3.push(gL), this._domRoot = i;
        } else {
          this._width = E8(i, 0, c3), this._height = E8(i, 1, c3);
          var B = this._domRoot = r_t(this._width, this._height);
          i.appendChild(B);
        }
      }
      return o.prototype.getType = function() {
        return "canvas";
      }, o.prototype.isSingleCanvas = function() {
        return this._singleCanvas;
      }, o.prototype.getViewportRoot = function() {
        return this._domRoot;
      }, o.prototype.getViewportRootOffset = function() {
        var i = this.getViewportRoot();
        if (i)
          return { offsetLeft: i.offsetLeft || 0, offsetTop: i.offsetTop || 0 };
      }, o.prototype.refresh = function(i) {
        var t3 = this.storage.getDisplayList(true), c3 = this._prevDisplayList, p3 = this._zlevelList;
        this._redrawId = Math.random(), this._paintList(t3, c3, i, this._redrawId);
        for (var g3 = 0; g3 < p3.length; g3++) {
          var b3 = p3[g3], w3 = this._layers[b3];
          if (!w3.__builtin__ && w3.refresh) {
            var M = g3 === 0 ? this._backgroundColor : null;
            w3.refresh(M);
          }
        }
        return this._opts.useDirtyRect && (this._prevDisplayList = t3.slice()), this;
      }, o.prototype.refreshHover = function() {
        this._paintHoverList(this.storage.getDisplayList(false));
      }, o.prototype._paintHoverList = function(i) {
        var t3 = i.length, c3 = this._hoverlayer;
        if (c3 && c3.clear(), !!t3) {
          for (var p3 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, g3, b3 = 0; b3 < t3; b3++) {
            var w3 = i[b3];
            w3.__inHover && (c3 || (c3 = this._hoverlayer = this.getLayer(oNe)), g3 || (g3 = c3.ctx, g3.save()), lL(g3, w3, p3, b3 === t3 - 1));
          }
          g3 && g3.restore();
        }
      }, o.prototype.getHoverLayer = function() {
        return this.getLayer(oNe);
      }, o.prototype.paintOne = function(i, t3) {
        r4e(i, t3);
      }, o.prototype._paintList = function(i, t3, c3, p3) {
        if (this._redrawId === p3) {
          c3 = c3 || false, this._updateLayerStatus(i);
          var g3 = this._doPaintList(i, t3, c3), b3 = g3.finished, w3 = g3.needsRefreshHover;
          if (this._needsManuallyCompositing && this._compositeManually(), w3 && this._paintHoverList(i), b3)
            this.eachLayer(function(I) {
              I.afterBrush && I.afterBrush();
            });
          else {
            var M = this;
            uw(function() {
              M._paintList(i, t3, c3, p3);
            });
          }
        }
      }, o.prototype._compositeManually = function() {
        var i = this.getLayer(gL).ctx, t3 = this._domRoot.width, c3 = this._domRoot.height;
        i.clearRect(0, 0, t3, c3), this.eachBuiltinLayer(function(p3) {
          p3.virtual && i.drawImage(p3.dom, 0, 0, t3, c3);
        });
      }, o.prototype._doPaintList = function(i, t3, c3) {
        for (var p3 = this, g3 = [], b3 = this._opts.useDirtyRect, w3 = 0; w3 < this._zlevelList.length; w3++) {
          var M = this._zlevelList[w3], I = this._layers[M];
          I.__builtin__ && I !== this._hoverlayer && (I.__dirty || c3) && g3.push(I);
        }
        for (var k3 = true, L = false, F = function(J) {
          var Q = g3[J], se = Q.ctx, he = b3 && Q.createRepaintRects(i, t3, B._width, B._height), be = c3 ? Q.__startIndex : Q.__drawIndex, de = !c3 && Q.incremental && Date.now, Fe = de && Date.now(), Pe = Q.zlevel === B._zlevelList[0] ? B._backgroundColor : null;
          if (Q.__startIndex === Q.__endIndex)
            Q.clear(false, Pe, he);
          else if (be === Q.__startIndex) {
            var ze = i[be];
            (!ze.incremental || !ze.notClear || c3) && Q.clear(false, Pe, he);
          }
          be === -1 && (console.error("For some unknown reason. drawIndex is -1"), be = Q.__startIndex);
          var $e, Ke = function(vt) {
            var jt = { inHover: false, allClipped: false, prevEl: null, viewWidth: p3._width, viewHeight: p3._height };
            for ($e = be; $e < Q.__endIndex; $e++) {
              var Jt = i[$e];
              if (Jt.__inHover && (L = true), p3._doPaintEl(Jt, Q, b3, vt, jt, $e === Q.__endIndex - 1), de) {
                var Rt = Date.now() - Fe;
                if (Rt > 15)
                  break;
              }
            }
            jt.prevElClipPaths && se.restore();
          };
          if (he)
            if (he.length === 0)
              $e = Q.__endIndex;
            else
              for (var nt = B.dpr, lt2 = 0; lt2 < he.length; ++lt2) {
                var bt = he[lt2];
                se.save(), se.beginPath(), se.rect(bt.x * nt, bt.y * nt, bt.width * nt, bt.height * nt), se.clip(), Ke(bt), se.restore();
              }
          else
            se.save(), Ke(), se.restore();
          Q.__drawIndex = $e, Q.__drawIndex < Q.__endIndex && (k3 = false);
        }, B = this, G = 0; G < g3.length; G++)
          F(G);
        return yo.wxa && yt(this._layers, function(J) {
          J && J.ctx && J.ctx.draw && J.ctx.draw();
        }), { finished: k3, needsRefreshHover: L };
      }, o.prototype._doPaintEl = function(i, t3, c3, p3, g3, b3) {
        var w3 = t3.ctx;
        if (c3) {
          var M = i.getPaintRect();
          (!p3 || M && M.intersect(p3)) && (lL(w3, i, g3, b3), i.setPrevPaintRect(M));
        } else
          lL(w3, i, g3, b3);
      }, o.prototype.getLayer = function(i, t3) {
        this._singleCanvas && !this._needsManuallyCompositing && (i = gL);
        var c3 = this._layers[i];
        return c3 || (c3 = new P0e("zr_" + i, this, this.dpr), c3.zlevel = i, c3.__builtin__ = true, this._layerConfig[i] ? Es(c3, this._layerConfig[i], true) : this._layerConfig[i - tne] && Es(c3, this._layerConfig[i - tne], true), t3 && (c3.virtual = t3), this.insertLayer(i, c3), c3.initContext()), c3;
      }, o.prototype.insertLayer = function(i, t3) {
        var c3 = this._layers, p3 = this._zlevelList, g3 = p3.length, b3 = this._domRoot, w3 = null, M = -1;
        if (!c3[i] && !!n_t(t3)) {
          if (g3 > 0 && i > p3[0]) {
            for (M = 0; M < g3 - 1 && !(p3[M] < i && p3[M + 1] > i); M++)
              ;
            w3 = c3[p3[M]];
          }
          if (p3.splice(M + 1, 0, i), c3[i] = t3, !t3.virtual)
            if (w3) {
              var I = w3.dom;
              I.nextSibling ? b3.insertBefore(t3.dom, I.nextSibling) : b3.appendChild(t3.dom);
            } else
              b3.firstChild ? b3.insertBefore(t3.dom, b3.firstChild) : b3.appendChild(t3.dom);
          t3.__painter = this;
        }
      }, o.prototype.eachLayer = function(i, t3) {
        for (var c3 = this._zlevelList, p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          i.call(t3, this._layers[g3], g3);
        }
      }, o.prototype.eachBuiltinLayer = function(i, t3) {
        for (var c3 = this._zlevelList, p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3], b3 = this._layers[g3];
          b3.__builtin__ && i.call(t3, b3, g3);
        }
      }, o.prototype.eachOtherLayer = function(i, t3) {
        for (var c3 = this._zlevelList, p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3], b3 = this._layers[g3];
          b3.__builtin__ || i.call(t3, b3, g3);
        }
      }, o.prototype.getLayers = function() {
        return this._layers;
      }, o.prototype._updateLayerStatus = function(i) {
        this.eachBuiltinLayer(function(L, F) {
          L.__dirty = L.__used = false;
        });
        function t3(L) {
          g3 && (g3.__endIndex !== L && (g3.__dirty = true), g3.__endIndex = L);
        }
        if (this._singleCanvas)
          for (var c3 = 1; c3 < i.length; c3++) {
            var p3 = i[c3];
            if (p3.zlevel !== i[c3 - 1].zlevel || p3.incremental) {
              this._needsManuallyCompositing = true;
              break;
            }
          }
        var g3 = null, b3 = 0, w3, M;
        for (M = 0; M < i.length; M++) {
          var p3 = i[M], I = p3.zlevel, k3 = void 0;
          w3 !== I && (w3 = I, b3 = 0), p3.incremental ? (k3 = this.getLayer(I + t_t, this._needsManuallyCompositing), k3.incremental = true, b3 = 1) : k3 = this.getLayer(I + (b3 > 0 ? tne : 0), this._needsManuallyCompositing), k3.__builtin__ || fP("ZLevel " + I + " has been used by unkown layer " + k3.id), k3 !== g3 && (k3.__used = true, k3.__startIndex !== M && (k3.__dirty = true), k3.__startIndex = M, k3.incremental ? k3.__drawIndex = -1 : k3.__drawIndex = M, t3(M), g3 = k3), p3.__dirty & c0 && !p3.__inHover && (k3.__dirty = true, k3.incremental && k3.__drawIndex < 0 && (k3.__drawIndex = M));
        }
        t3(M), this.eachBuiltinLayer(function(L, F) {
          !L.__used && L.getElementCount() > 0 && (L.__dirty = true, L.__startIndex = L.__endIndex = L.__drawIndex = 0), L.__dirty && L.__drawIndex < 0 && (L.__drawIndex = L.__startIndex);
        });
      }, o.prototype.clear = function() {
        return this.eachBuiltinLayer(this._clearLayer), this;
      }, o.prototype._clearLayer = function(i) {
        i.clear();
      }, o.prototype.setBackgroundColor = function(i) {
        this._backgroundColor = i, yt(this._layers, function(t3) {
          t3.setUnpainted();
        });
      }, o.prototype.configLayer = function(i, t3) {
        if (t3) {
          var c3 = this._layerConfig;
          c3[i] ? Es(c3[i], t3, true) : c3[i] = t3;
          for (var p3 = 0; p3 < this._zlevelList.length; p3++) {
            var g3 = this._zlevelList[p3];
            if (g3 === i || g3 === i + tne) {
              var b3 = this._layers[g3];
              Es(b3, c3[i], true);
            }
          }
        }
      }, o.prototype.delLayer = function(i) {
        var t3 = this._layers, c3 = this._zlevelList, p3 = t3[i];
        !p3 || (p3.dom.parentNode.removeChild(p3.dom), delete t3[i], c3.splice(rl(c3, i), 1));
      }, o.prototype.resize = function(i, t3) {
        if (this._domRoot.style) {
          var c3 = this._domRoot;
          c3.style.display = "none";
          var p3 = this._opts, g3 = this.root;
          if (i != null && (p3.width = i), t3 != null && (p3.height = t3), i = E8(g3, 0, p3), t3 = E8(g3, 1, p3), c3.style.display = "", this._width !== i || t3 !== this._height) {
            c3.style.width = i + "px", c3.style.height = t3 + "px";
            for (var b3 in this._layers)
              this._layers.hasOwnProperty(b3) && this._layers[b3].resize(i, t3);
            this.refresh(true);
          }
          this._width = i, this._height = t3;
        } else {
          if (i == null || t3 == null)
            return;
          this._width = i, this._height = t3, this.getLayer(gL).resize(i, t3);
        }
        return this;
      }, o.prototype.clearLayer = function(i) {
        var t3 = this._layers[i];
        t3 && t3.clear();
      }, o.prototype.dispose = function() {
        this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
      }, o.prototype.getRenderedCanvas = function(i) {
        if (i = i || {}, this._singleCanvas && !this._compositeManually)
          return this._layers[gL].dom;
        var t3 = new P0e("image", this, i.pixelRatio || this.dpr);
        t3.initContext(), t3.clear(false, i.backgroundColor || this._backgroundColor);
        var c3 = t3.ctx;
        if (i.pixelRatio <= this.dpr) {
          this.refresh();
          var p3 = t3.dom.width, g3 = t3.dom.height;
          this.eachLayer(function(L) {
            L.__builtin__ ? c3.drawImage(L.dom, 0, 0, p3, g3) : L.renderToCanvas && (c3.save(), L.renderToCanvas(c3), c3.restore());
          });
        } else
          for (var b3 = { inHover: false, viewWidth: this._width, viewHeight: this._height }, w3 = this.storage.getDisplayList(true), M = 0, I = w3.length; M < I; M++) {
            var k3 = w3[M];
            lL(c3, k3, b3, M === I - 1);
          }
        return t3.dom;
      }, o.prototype.getWidth = function() {
        return this._width;
      }, o.prototype.getHeight = function() {
        return this._height;
      }, o;
    }(), a_t = i_t;
    function o_t(o) {
      o.registerPainter("canvas", a_t);
    }
    var s_t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.hasSymbolVisual = true, t3;
      }
      return i.prototype.getInitialData = function(t3) {
        return NI(null, this, { useEncodeDefaulter: true });
      }, i.prototype.getLegendIcon = function(t3) {
        var c3 = new vs(), p3 = pv("line", 0, t3.itemHeight / 2, t3.itemWidth, 0, t3.lineStyle.stroke, false);
        c3.add(p3), p3.setStyle(t3.lineStyle);
        var g3 = this.getData().getVisual("symbol"), b3 = this.getData().getVisual("symbolRotate"), w3 = g3 === "none" ? "circle" : g3, M = t3.itemHeight * 0.8, I = pv(w3, (t3.itemWidth - M) / 2, (t3.itemHeight - M) / 2, M, M, t3.itemStyle.fill);
        c3.add(I), I.setStyle(t3.itemStyle);
        var k3 = t3.iconRotate === "inherit" ? b3 : t3.iconRotate || 0;
        return I.rotation = k3 * Math.PI / 180, I.setOrigin([t3.itemWidth / 2, t3.itemHeight / 2]), w3.indexOf("empty") > -1 && (I.style.stroke = I.style.fill, I.style.fill = "#fff", I.style.lineWidth = 2), c3;
      }, i.type = "series.line", i.dependencies = ["grid", "polar"], i.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, i;
    }(bp), l_t = s_t;
    function L8(o, i) {
      var t3 = o.mapDimensionsAll("defaultedLabel"), c3 = t3.length;
      if (c3 === 1) {
        var p3 = w8(o, i, t3[0]);
        return p3 != null ? p3 + "" : null;
      } else if (c3) {
        for (var g3 = [], b3 = 0; b3 < t3.length; b3++)
          g3.push(w8(o, i, t3[b3]));
        return g3.join(" ");
      }
    }
    function sNe(o, i) {
      var t3 = o.mapDimensionsAll("defaultedLabel");
      if (!Ei(i))
        return i + "";
      for (var c3 = [], p3 = 0; p3 < t3.length; p3++) {
        var g3 = o.getDimensionIndex(t3[p3]);
        g3 >= 0 && c3.push(i[g3]);
      }
      return c3.join(" ");
    }
    var u_t = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3) {
        var b3 = o.call(this) || this;
        return b3.updateData(t3, c3, p3, g3), b3;
      }
      return i.prototype._createSymbol = function(t3, c3, p3, g3, b3) {
        this.removeAll();
        var w3 = pv(t3, -1, -1, 2, 2, null, b3);
        w3.attr({ z2: 100, culling: true, scaleX: g3[0] / 2, scaleY: g3[1] / 2 }), w3.drift = c_t, this._symbolType = t3, this.add(w3);
      }, i.prototype.stopSymbolAnimation = function(t3) {
        this.childAt(0).stopAnimation(null, t3);
      }, i.prototype.getSymbolType = function() {
        return this._symbolType;
      }, i.prototype.getSymbolPath = function() {
        return this.childAt(0);
      }, i.prototype.highlight = function() {
        Hv(this.childAt(0));
      }, i.prototype.downplay = function() {
        sl(this.childAt(0));
      }, i.prototype.setZ = function(t3, c3) {
        var p3 = this.childAt(0);
        p3.zlevel = t3, p3.z = c3;
      }, i.prototype.setDraggable = function(t3) {
        var c3 = this.childAt(0);
        c3.draggable = t3, c3.cursor = t3 ? "move" : c3.cursor;
      }, i.prototype.updateData = function(t3, c3, p3, g3) {
        this.silent = false;
        var b3 = t3.getItemVisual(c3, "symbol") || "circle", w3 = t3.hostModel, M = i.getSymbolSize(t3, c3), I = b3 !== this._symbolType, k3 = g3 && g3.disableAnimation;
        if (I) {
          var L = t3.getItemVisual(c3, "symbolKeepAspect");
          this._createSymbol(b3, t3, c3, M, L);
        } else {
          var F = this.childAt(0);
          F.silent = false;
          var B = { scaleX: M[0] / 2, scaleY: M[1] / 2 };
          k3 ? F.attr(B) : Du(F, B, w3, c3), P_(F);
        }
        if (this._updateCommon(t3, c3, M, p3, g3), I) {
          var F = this.childAt(0);
          if (!k3) {
            var B = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: F.style.opacity } };
            F.scaleX = F.scaleY = 0, F.style.opacity = 0, Uh(F, B, w3, c3);
          }
        }
        k3 && this.childAt(0).stopAnimation("leave");
      }, i.prototype._updateCommon = function(t3, c3, p3, g3, b3) {
        var w3 = this.childAt(0), M = t3.hostModel, I, k3, L, F, B, G, J, Q, se;
        if (g3 && (I = g3.emphasisItemStyle, k3 = g3.blurItemStyle, L = g3.selectItemStyle, F = g3.focus, B = g3.blurScope, J = g3.labelStatesModels, Q = g3.hoverScale, se = g3.cursorStyle, G = g3.emphasisDisabled), !g3 || t3.hasItemOption) {
          var he = g3 && g3.itemModel ? g3.itemModel : t3.getItemModel(c3), be = he.getModel("emphasis");
          I = be.getModel("itemStyle").getItemStyle(), L = he.getModel(["select", "itemStyle"]).getItemStyle(), k3 = he.getModel(["blur", "itemStyle"]).getItemStyle(), F = be.get("focus"), B = be.get("blurScope"), G = be.get("disabled"), J = g0(he), Q = be.getShallow("scale"), se = he.getShallow("cursor");
        }
        var de = t3.getItemVisual(c3, "symbolRotate");
        w3.attr("rotation", (de || 0) * Math.PI / 180 || 0);
        var Fe = I8(t3.getItemVisual(c3, "symbolOffset"), p3);
        Fe && (w3.x = Fe[0], w3.y = Fe[1]), se && w3.attr("cursor", se);
        var Pe = t3.getItemVisual(c3, "style"), ze = Pe.fill;
        if (w3 instanceof Gv) {
          var $e = w3.style;
          w3.useStyle(ti({ image: $e.image, x: $e.x, y: $e.y, width: $e.width, height: $e.height }, Pe));
        } else
          w3.__isEmptyBrush ? w3.useStyle(ti({}, Pe)) : w3.useStyle(Pe), w3.style.decal = null, w3.setColor(ze, b3 && b3.symbolInnerColor), w3.style.strokeNoScale = true;
        var Ke = t3.getItemVisual(c3, "liftZ"), nt = this._z2;
        Ke != null ? nt == null && (this._z2 = w3.z2, w3.z2 += Ke) : nt != null && (w3.z2 = nt, this._z2 = null);
        var lt2 = b3 && b3.useNameLabel;
        Sm(w3, J, { labelFetcher: M, labelDataIndex: c3, defaultText: bt, inheritColor: ze, defaultOpacity: Pe.opacity });
        function bt(Jt) {
          return lt2 ? t3.getName(Jt) : L8(t3, Jt);
        }
        this._sizeX = p3[0] / 2, this._sizeY = p3[1] / 2;
        var vt = w3.ensureState("emphasis");
        if (vt.style = I, w3.ensureState("select").style = L, w3.ensureState("blur").style = k3, Q) {
          var jt = Math.max(1.1, 3 / this._sizeY);
          vt.scaleX = this._sizeX * jt, vt.scaleY = this._sizeY * jt;
        }
        this.setSymbolScale(1), zp(this, F, B, G);
      }, i.prototype.setSymbolScale = function(t3) {
        this.scaleX = this.scaleY = t3;
      }, i.prototype.fadeOut = function(t3, c3, p3) {
        var g3 = this.childAt(0), b3 = La(this).dataIndex, w3 = p3 && p3.animation;
        if (this.silent = g3.silent = true, p3 && p3.fadeLabel) {
          var M = g3.getTextContent();
          M && XM(M, { style: { opacity: 0 } }, c3, { dataIndex: b3, removeOpt: w3, cb: function() {
            g3.removeTextContent();
          } });
        } else
          g3.removeTextContent();
        XM(g3, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, c3, { dataIndex: b3, cb: t3, removeOpt: w3 });
      }, i.getSymbolSize = function(t3, c3) {
        return zH(t3.getItemVisual(c3, "symbolSize"));
      }, i;
    }(vs);
    function c_t(o, i) {
      this.parent.drift(o, i);
    }
    var sW = u_t;
    function L0e(o, i, t3, c3) {
      return i && !isNaN(i[0]) && !isNaN(i[1]) && !(c3.isIgnore && c3.isIgnore(t3)) && !(c3.clipShape && !c3.clipShape.contain(i[0], i[1])) && o.getItemVisual(t3, "symbol") !== "none";
    }
    function lNe(o) {
      return o != null && !Ua(o) && (o = { isIgnore: o }), o || {};
    }
    function uNe(o) {
      var i = o.hostModel, t3 = i.getModel("emphasis");
      return { emphasisItemStyle: t3.getModel("itemStyle").getItemStyle(), blurItemStyle: i.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: i.getModel(["select", "itemStyle"]).getItemStyle(), focus: t3.get("focus"), blurScope: t3.get("blurScope"), emphasisDisabled: t3.get("disabled"), hoverScale: t3.get("scale"), labelStatesModels: g0(i), cursorStyle: i.get("cursor") };
    }
    var f_t = function() {
      function o(i) {
        this.group = new vs(), this._SymbolCtor = i || sW;
      }
      return o.prototype.updateData = function(i, t3) {
        this._progressiveEls = null, t3 = lNe(t3);
        var c3 = this.group, p3 = i.hostModel, g3 = this._data, b3 = this._SymbolCtor, w3 = t3.disableAnimation, M = uNe(i), I = { disableAnimation: w3 }, k3 = t3.getSymbolPoint || function(L) {
          return i.getItemLayout(L);
        };
        g3 || c3.removeAll(), i.diff(g3).add(function(L) {
          var F = k3(L);
          if (L0e(i, F, L, t3)) {
            var B = new b3(i, L, M, I);
            B.setPosition(F), i.setItemGraphicEl(L, B), c3.add(B);
          }
        }).update(function(L, F) {
          var B = g3.getItemGraphicEl(F), G = k3(L);
          if (!L0e(i, G, L, t3)) {
            c3.remove(B);
            return;
          }
          var J = i.getItemVisual(L, "symbol") || "circle", Q = B && B.getSymbolType && B.getSymbolType();
          if (!B || Q && Q !== J)
            c3.remove(B), B = new b3(i, L, M, I), B.setPosition(G);
          else {
            B.updateData(i, L, M, I);
            var se = { x: G[0], y: G[1] };
            w3 ? B.attr(se) : Du(B, se, p3);
          }
          c3.add(B), i.setItemGraphicEl(L, B);
        }).remove(function(L) {
          var F = g3.getItemGraphicEl(L);
          F && F.fadeOut(function() {
            c3.remove(F);
          }, p3);
        }).execute(), this._getSymbolPoint = k3, this._data = i;
      }, o.prototype.updateLayout = function() {
        var i = this, t3 = this._data;
        t3 && t3.eachItemGraphicEl(function(c3, p3) {
          var g3 = i._getSymbolPoint(p3);
          c3.setPosition(g3), c3.markRedraw();
        });
      }, o.prototype.incrementalPrepareUpdate = function(i) {
        this._seriesScope = uNe(i), this._data = null, this.group.removeAll();
      }, o.prototype.incrementalUpdate = function(i, t3, c3) {
        this._progressiveEls = [], c3 = lNe(c3);
        function p3(M) {
          M.isGroup || (M.incremental = true, M.ensureState("emphasis").hoverLayer = true);
        }
        for (var g3 = i.start; g3 < i.end; g3++) {
          var b3 = t3.getItemLayout(g3);
          if (L0e(t3, b3, g3, c3)) {
            var w3 = new this._SymbolCtor(t3, g3, this._seriesScope);
            w3.traverse(p3), w3.setPosition(b3), this.group.add(w3), t3.setItemGraphicEl(g3, w3), this._progressiveEls.push(w3);
          }
        }
      }, o.prototype.eachRendered = function(i) {
        nk(this._progressiveEls || this.group, i);
      }, o.prototype.remove = function(i) {
        var t3 = this.group, c3 = this._data;
        c3 && i ? c3.eachItemGraphicEl(function(p3) {
          p3.fadeOut(function() {
            t3.remove(p3);
          }, c3.hostModel);
        }) : t3.removeAll();
      }, o;
    }(), lW = f_t;
    function cNe(o, i, t3) {
      var c3 = o.getBaseAxis(), p3 = o.getOtherAxis(c3), g3 = h_t(p3, t3), b3 = c3.dim, w3 = p3.dim, M = i.mapDimension(w3), I = i.mapDimension(b3), k3 = w3 === "x" || w3 === "radius" ? 1 : 0, L = Fi(o.dimensions, function(G) {
        return i.mapDimension(G);
      }), F = false, B = i.getCalculationInfo("stackResultDimension");
      return ck(i, L[0]) && (F = true, L[0] = B), ck(i, L[1]) && (F = true, L[1] = B), { dataDimsForPoint: L, valueStart: g3, valueAxisDim: w3, baseAxisDim: b3, stacked: !!F, valueDim: M, baseDim: I, baseDataOffset: k3, stackedOverDimension: i.getCalculationInfo("stackedOverDimension") };
    }
    function h_t(o, i) {
      var t3 = 0, c3 = o.scale.getExtent();
      return i === "start" ? t3 = c3[0] : i === "end" ? t3 = c3[1] : c3[0] > 0 ? t3 = c3[0] : c3[1] < 0 && (t3 = c3[1]), t3;
    }
    function fNe(o, i, t3, c3) {
      var p3 = NaN;
      o.stacked && (p3 = t3.get(t3.getCalculationInfo("stackedOverDimension"), c3)), isNaN(p3) && (p3 = o.valueStart);
      var g3 = o.baseDataOffset, b3 = [];
      return b3[g3] = t3.get(o.baseDim, c3), b3[1 - g3] = p3, i.dataToPoint(b3);
    }
    function p_t(o, i) {
      var t3 = [];
      return i.diff(o).add(function(c3) {
        t3.push({ cmd: "+", idx: c3 });
      }).update(function(c3, p3) {
        t3.push({ cmd: "=", idx: p3, idx1: c3 });
      }).remove(function(c3) {
        t3.push({ cmd: "-", idx: c3 });
      }).execute(), t3;
    }
    function d_t(o, i, t3, c3, p3, g3, b3, w3) {
      for (var M = p_t(o, i), I = [], k3 = [], L = [], F = [], B = [], G = [], J = [], Q = cNe(p3, i, b3), se = o.getLayout("points") || [], he = i.getLayout("points") || [], be = 0; be < M.length; be++) {
        var de = M[be], Fe = true, Pe = void 0, ze = void 0;
        switch (de.cmd) {
          case "=":
            Pe = de.idx * 2, ze = de.idx1 * 2;
            var $e = se[Pe], Ke = se[Pe + 1], nt = he[ze], lt2 = he[ze + 1];
            (isNaN($e) || isNaN(Ke)) && ($e = nt, Ke = lt2), I.push($e, Ke), k3.push(nt, lt2), L.push(t3[Pe], t3[Pe + 1]), F.push(c3[ze], c3[ze + 1]), J.push(i.getRawIndex(de.idx1));
            break;
          case "+":
            var bt = de.idx, vt = Q.dataDimsForPoint, jt = p3.dataToPoint([i.get(vt[0], bt), i.get(vt[1], bt)]);
            ze = bt * 2, I.push(jt[0], jt[1]), k3.push(he[ze], he[ze + 1]);
            var Jt = fNe(Q, p3, i, bt);
            L.push(Jt[0], Jt[1]), F.push(c3[ze], c3[ze + 1]), J.push(i.getRawIndex(bt));
            break;
          case "-":
            Fe = false;
        }
        Fe && (B.push(de), G.push(G.length));
      }
      G.sort(function(Do, _o) {
        return J[Do] - J[_o];
      });
      for (var Rt = I.length, Jn = JM(Rt), ln = JM(Rt), vn = JM(Rt), kn = JM(Rt), cr = [], be = 0; be < G.length; be++) {
        var gr = G[be], ha = be * 2, Ka = gr * 2;
        Jn[ha] = I[Ka], Jn[ha + 1] = I[Ka + 1], ln[ha] = k3[Ka], ln[ha + 1] = k3[Ka + 1], vn[ha] = L[Ka], vn[ha + 1] = L[Ka + 1], kn[ha] = F[Ka], kn[ha + 1] = F[Ka + 1], cr[be] = B[gr];
      }
      return { current: Jn, next: ln, stackedOnCurrent: vn, stackedOnNext: kn, status: cr };
    }
    var hk = Math.min, pk = Math.max;
    function yL(o, i) {
      return isNaN(o) || isNaN(i);
    }
    function R0e(o, i, t3, c3, p3, g3, b3, w3, M) {
      for (var I, k3, L, F, B, G, J = t3, Q = 0; Q < c3; Q++) {
        var se = i[J * 2], he = i[J * 2 + 1];
        if (J >= p3 || J < 0)
          break;
        if (yL(se, he)) {
          if (M) {
            J += g3;
            continue;
          }
          break;
        }
        if (J === t3)
          o[g3 > 0 ? "moveTo" : "lineTo"](se, he), L = se, F = he;
        else {
          var be = se - I, de = he - k3;
          if (be * be + de * de < 0.5) {
            J += g3;
            continue;
          }
          if (b3 > 0) {
            for (var Fe = J + g3, Pe = i[Fe * 2], ze = i[Fe * 2 + 1]; Pe === se && ze === he && Q < c3; )
              Q++, Fe += g3, J += g3, Pe = i[Fe * 2], ze = i[Fe * 2 + 1], se = i[J * 2], he = i[J * 2 + 1], be = se - I, de = he - k3;
            var $e = Q + 1;
            if (M)
              for (; yL(Pe, ze) && $e < c3; )
                $e++, Fe += g3, Pe = i[Fe * 2], ze = i[Fe * 2 + 1];
            var Ke = 0.5, nt = 0, lt2 = 0, bt = void 0, vt = void 0;
            if ($e >= c3 || yL(Pe, ze))
              B = se, G = he;
            else {
              nt = Pe - I, lt2 = ze - k3;
              var jt = se - I, Jt = Pe - se, Rt = he - k3, Jn = ze - he, ln = void 0, vn = void 0;
              if (w3 === "x") {
                ln = Math.abs(jt), vn = Math.abs(Jt);
                var kn = nt > 0 ? 1 : -1;
                B = se - kn * ln * b3, G = he, bt = se + kn * vn * b3, vt = he;
              } else if (w3 === "y") {
                ln = Math.abs(Rt), vn = Math.abs(Jn);
                var cr = lt2 > 0 ? 1 : -1;
                B = se, G = he - cr * ln * b3, bt = se, vt = he + cr * vn * b3;
              } else
                ln = Math.sqrt(jt * jt + Rt * Rt), vn = Math.sqrt(Jt * Jt + Jn * Jn), Ke = vn / (vn + ln), B = se - nt * b3 * (1 - Ke), G = he - lt2 * b3 * (1 - Ke), bt = se + nt * b3 * Ke, vt = he + lt2 * b3 * Ke, bt = hk(bt, pk(Pe, se)), vt = hk(vt, pk(ze, he)), bt = pk(bt, hk(Pe, se)), vt = pk(vt, hk(ze, he)), nt = bt - se, lt2 = vt - he, B = se - nt * ln / vn, G = he - lt2 * ln / vn, B = hk(B, pk(I, se)), G = hk(G, pk(k3, he)), B = pk(B, hk(I, se)), G = pk(G, hk(k3, he)), nt = se - B, lt2 = he - G, bt = se + nt * vn / ln, vt = he + lt2 * vn / ln;
            }
            o.bezierCurveTo(L, F, B, G, se, he), L = bt, F = vt;
          } else
            o.lineTo(se, he);
        }
        I = se, k3 = he, J += g3;
      }
      return Q;
    }
    var hNe = function() {
      function o() {
        this.smooth = 0, this.smoothConstraint = true;
      }
      return o;
    }(), v_t = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "ec-polyline", c3;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new hNe();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.points, g3 = 0, b3 = p3.length / 2;
        if (c3.connectNulls) {
          for (; b3 > 0 && yL(p3[b3 * 2 - 2], p3[b3 * 2 - 1]); b3--)
            ;
          for (; g3 < b3 && yL(p3[g3 * 2], p3[g3 * 2 + 1]); g3++)
            ;
        }
        for (; g3 < b3; )
          g3 += R0e(t3, p3, g3, b3, b3, 1, c3.smooth, c3.smoothMonotone, c3.connectNulls) + 1;
      }, i.prototype.getPointOn = function(t3, c3) {
        this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
        for (var p3 = this.path, g3 = p3.data, b3 = ww.CMD, w3, M, I = c3 === "x", k3 = [], L = 0; L < g3.length; ) {
          var F = g3[L++], B = void 0, G = void 0, J = void 0, Q = void 0, se = void 0, he = void 0, be = void 0;
          switch (F) {
            case b3.M:
              w3 = g3[L++], M = g3[L++];
              break;
            case b3.L:
              if (B = g3[L++], G = g3[L++], be = I ? (t3 - w3) / (B - w3) : (t3 - M) / (G - M), be <= 1 && be >= 0) {
                var de = I ? (G - M) * be + M : (B - w3) * be + w3;
                return I ? [t3, de] : [de, t3];
              }
              w3 = B, M = G;
              break;
            case b3.C:
              B = g3[L++], G = g3[L++], J = g3[L++], Q = g3[L++], se = g3[L++], he = g3[L++];
              var Fe = I ? E5(w3, B, J, se, t3, k3) : E5(M, G, Q, he, t3, k3);
              if (Fe > 0)
                for (var Pe = 0; Pe < Fe; Pe++) {
                  var ze = k3[Pe];
                  if (ze <= 1 && ze >= 0) {
                    var de = I ? Jp(M, G, Q, he, ze) : Jp(w3, B, J, se, ze);
                    return I ? [t3, de] : [de, t3];
                  }
                }
              w3 = se, M = he;
              break;
          }
        }
      }, i;
    }(gl), g_t = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i;
    }(hNe), pNe = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "ec-polygon", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new g_t();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.points, g3 = c3.stackedOnPoints, b3 = 0, w3 = p3.length / 2, M = c3.smoothMonotone;
        if (c3.connectNulls) {
          for (; w3 > 0 && yL(p3[w3 * 2 - 2], p3[w3 * 2 - 1]); w3--)
            ;
          for (; b3 < w3 && yL(p3[b3 * 2], p3[b3 * 2 + 1]); b3++)
            ;
        }
        for (; b3 < w3; ) {
          var I = R0e(t3, p3, b3, w3, w3, 1, c3.smooth, M, c3.connectNulls);
          R0e(t3, g3, b3 + I - 1, I, w3, -1, c3.stackedOnSmooth, M, c3.connectNulls), b3 += I + 1, t3.closePath();
        }
      }, i;
    }(gl);
    function dNe(o, i, t3, c3, p3) {
      var g3 = o.getArea(), b3 = g3.x, w3 = g3.y, M = g3.width, I = g3.height, k3 = t3.get(["lineStyle", "width"]) || 2;
      b3 -= k3 / 2, w3 -= k3 / 2, M += k3, I += k3, b3 = Math.floor(b3), M = Math.round(M);
      var L = new bu({ shape: { x: b3, y: w3, width: M, height: I } });
      if (i) {
        var F = o.getBaseAxis(), B = F.isHorizontal(), G = F.inverse;
        B ? (G && (L.shape.x += M), L.shape.width = 0) : (G || (L.shape.y += I), L.shape.height = 0);
        var J = Vo(p3) ? function(Q) {
          p3(Q, L);
        } : null;
        Uh(L, { shape: { width: M, height: I, x: b3, y: w3 } }, t3, null, c3, J);
      }
      return L;
    }
    function vNe(o, i, t3) {
      var c3 = o.getArea(), p3 = mp(c3.r0, 1), g3 = mp(c3.r, 1), b3 = new bm({ shape: { cx: mp(o.cx, 1), cy: mp(o.cy, 1), r0: p3, r: g3, startAngle: c3.startAngle, endAngle: c3.endAngle, clockwise: c3.clockwise } });
      if (i) {
        var w3 = o.getBaseAxis().dim === "angle";
        w3 ? b3.shape.endAngle = c3.startAngle : b3.shape.r = p3, Uh(b3, { shape: { endAngle: c3.endAngle, r: g3 } }, t3);
      }
      return b3;
    }
    function nne(o, i, t3, c3, p3) {
      if (o) {
        if (o.type === "polar")
          return vNe(o, i, t3);
        if (o.type === "cartesian2d")
          return dNe(o, i, t3, c3, p3);
      } else
        return null;
      return null;
    }
    function VI(o, i) {
      return o.type === i;
    }
    function gNe(o, i) {
      if (o.length === i.length) {
        for (var t3 = 0; t3 < o.length; t3++)
          if (o[t3] !== i[t3])
            return;
        return true;
      }
    }
    function yNe(o) {
      for (var i = 1 / 0, t3 = 1 / 0, c3 = -1 / 0, p3 = -1 / 0, g3 = 0; g3 < o.length; ) {
        var b3 = o[g3++], w3 = o[g3++];
        isNaN(b3) || (i = Math.min(b3, i), c3 = Math.max(b3, c3)), isNaN(w3) || (t3 = Math.min(w3, t3), p3 = Math.max(w3, p3));
      }
      return [[i, t3], [c3, p3]];
    }
    function mNe(o, i) {
      var t3 = yNe(o), c3 = t3[0], p3 = t3[1], g3 = yNe(i), b3 = g3[0], w3 = g3[1];
      return Math.max(Math.abs(c3[0] - b3[0]), Math.abs(c3[1] - b3[1]), Math.abs(p3[0] - w3[0]), Math.abs(p3[1] - w3[1]));
    }
    function bNe(o) {
      return ec(o) ? o : o ? 0.5 : 0;
    }
    function y_t(o, i, t3) {
      if (!t3.valueDim)
        return [];
      for (var c3 = i.count(), p3 = JM(c3 * 2), g3 = 0; g3 < c3; g3++) {
        var b3 = fNe(t3, o, i, g3);
        p3[g3 * 2] = b3[0], p3[g3 * 2 + 1] = b3[1];
      }
      return p3;
    }
    function dk(o, i, t3, c3) {
      var p3 = i.getBaseAxis(), g3 = p3.dim === "x" || p3.dim === "radius" ? 0 : 1, b3 = [], w3 = 0, M = [], I = [], k3 = [], L = [];
      if (c3) {
        for (w3 = 0; w3 < o.length; w3 += 2)
          !isNaN(o[w3]) && !isNaN(o[w3 + 1]) && L.push(o[w3], o[w3 + 1]);
        o = L;
      }
      for (w3 = 0; w3 < o.length - 2; w3 += 2)
        switch (k3[0] = o[w3 + 2], k3[1] = o[w3 + 3], I[0] = o[w3], I[1] = o[w3 + 1], b3.push(I[0], I[1]), t3) {
          case "end":
            M[g3] = k3[g3], M[1 - g3] = I[1 - g3], b3.push(M[0], M[1]);
            break;
          case "middle":
            var F = (I[g3] + k3[g3]) / 2, B = [];
            M[g3] = B[g3] = F, M[1 - g3] = I[1 - g3], B[1 - g3] = k3[1 - g3], b3.push(M[0], M[1]), b3.push(B[0], B[1]);
            break;
          default:
            M[g3] = I[g3], M[1 - g3] = k3[1 - g3], b3.push(M[0], M[1]);
        }
      return b3.push(o[w3++], o[w3++]), b3;
    }
    function m_t(o, i) {
      var t3 = [], c3 = o.length, p3, g3;
      function b3(k3, L, F) {
        var B = k3.coord, G = (F - B) / (L.coord - B), J = nde(G, [k3.color, L.color]);
        return { coord: F, color: J };
      }
      for (var w3 = 0; w3 < c3; w3++) {
        var M = o[w3], I = M.coord;
        if (I < 0)
          p3 = M;
        else if (I > i) {
          g3 ? t3.push(b3(g3, M, i)) : p3 && t3.push(b3(p3, M, 0), b3(p3, M, i));
          break;
        } else
          p3 && (t3.push(b3(p3, M, 0)), p3 = null), t3.push(M), g3 = M;
      }
      return t3;
    }
    function b_t(o, i, t3) {
      var c3 = o.getVisual("visualMeta");
      if (!(!c3 || !c3.length || !o.count()) && i.type === "cartesian2d") {
        for (var p3, g3, b3 = c3.length - 1; b3 >= 0; b3--) {
          var w3 = o.getDimensionInfo(c3[b3].dimension);
          if (p3 = w3 && w3.coordDim, p3 === "x" || p3 === "y") {
            g3 = c3[b3];
            break;
          }
        }
        if (g3) {
          var M = i.getAxis(p3), I = Fi(g3.stops, function(be) {
            return { coord: M.toGlobalCoord(M.dataToCoord(be.value)), color: be.color };
          }), k3 = I.length, L = g3.outerColors.slice();
          k3 && I[0].coord > I[k3 - 1].coord && (I.reverse(), L.reverse());
          var F = m_t(I, p3 === "x" ? t3.getWidth() : t3.getHeight()), B = F.length;
          if (!B && k3)
            return I[0].coord < 0 ? L[1] ? L[1] : I[k3 - 1].color : L[0] ? L[0] : I[0].color;
          var G = 10, J = F[0].coord - G, Q = F[B - 1].coord + G, se = Q - J;
          if (se < 1e-3)
            return "transparent";
          yt(F, function(be) {
            be.offset = (be.coord - J) / se;
          }), F.push({ offset: B ? F[B - 1].offset : 0.5, color: L[1] || "transparent" }), F.unshift({ offset: B ? F[0].offset : 0.5, color: L[0] || "transparent" });
          var he = new JP(0, 0, 0, 0, F, true);
          return he[p3] = J, he[p3 + "2"] = Q, he;
        }
      }
    }
    function __t(o, i, t3) {
      var c3 = o.get("showAllSymbol"), p3 = c3 === "auto";
      if (!(c3 && !p3)) {
        var g3 = t3.getAxesByScale("ordinal")[0];
        if (!!g3 && !(p3 && x_t(g3, i))) {
          var b3 = i.mapDimension(g3.dim), w3 = {};
          return yt(g3.getViewLabels(), function(M) {
            var I = g3.scale.getRawOrdinalNumber(M.tickValue);
            w3[I] = 1;
          }), function(M) {
            return !w3.hasOwnProperty(i.get(b3, M));
          };
        }
      }
    }
    function x_t(o, i) {
      var t3 = o.getExtent(), c3 = Math.abs(t3[1] - t3[0]) / o.scale.count();
      isNaN(c3) && (c3 = 0);
      for (var p3 = i.count(), g3 = Math.max(1, Math.round(p3 / 5)), b3 = 0; b3 < p3; b3 += g3)
        if (sW.getSymbolSize(i, b3)[o.isHorizontal() ? 1 : 0] * 1.5 > c3)
          return false;
      return true;
    }
    function w_t(o, i) {
      return isNaN(o) || isNaN(i);
    }
    function S_t(o) {
      for (var i = o.length / 2; i > 0 && w_t(o[i * 2 - 2], o[i * 2 - 1]); i--)
        ;
      return i - 1;
    }
    function _Ne(o, i) {
      return [o[i * 2], o[i * 2 + 1]];
    }
    function C_t(o, i, t3) {
      for (var c3 = o.length / 2, p3 = t3 === "x" ? 0 : 1, g3, b3, w3 = 0, M = -1, I = 0; I < c3; I++)
        if (b3 = o[I * 2 + p3], !(isNaN(b3) || isNaN(o[I * 2 + 1 - p3]))) {
          if (I === 0) {
            g3 = b3;
            continue;
          }
          if (g3 <= i && b3 >= i || g3 >= i && b3 <= i) {
            M = I;
            break;
          }
          w3 = I, g3 = b3;
        }
      return { range: [w3, M], t: (i - g3) / (b3 - g3) };
    }
    function xNe(o) {
      if (o.get(["endLabel", "show"]))
        return true;
      for (var i = 0; i < yy.length; i++)
        if (o.get([yy[i], "endLabel", "show"]))
          return true;
      return false;
    }
    function N0e(o, i, t3, c3) {
      if (VI(i, "cartesian2d")) {
        var p3 = c3.getModel("endLabel"), g3 = p3.get("valueAnimation"), b3 = c3.getData(), w3 = { lastFrameIndex: 0 }, M = xNe(c3) ? function(B, G) {
          o._endLabelOnDuring(B, G, b3, w3, g3, p3, i);
        } : null, I = i.getBaseAxis().isHorizontal(), k3 = dNe(i, t3, c3, function() {
          var B = o._endLabel;
          B && t3 && w3.originalX != null && B.attr({ x: w3.originalX, y: w3.originalY });
        }, M);
        if (!c3.get("clip", true)) {
          var L = k3.shape, F = Math.max(L.width, L.height);
          I ? (L.y -= F, L.height += F * 2) : (L.x -= F, L.width += F * 2);
        }
        return M && M(1, k3), k3;
      } else
        return vNe(i, t3, c3);
    }
    function M_t(o, i) {
      var t3 = i.getBaseAxis(), c3 = t3.isHorizontal(), p3 = t3.inverse, g3 = c3 ? p3 ? "right" : "left" : "center", b3 = c3 ? "middle" : p3 ? "top" : "bottom";
      return { normal: { align: o.get("align") || g3, verticalAlign: o.get("verticalAlign") || b3 } };
    }
    var T_t = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.init = function() {
        var t3 = new vs(), c3 = new lW();
        this.group.add(c3.group), this._symbolDraw = c3, this._lineGroup = t3;
      }, i.prototype.render = function(t3, c3, p3) {
        var g3 = this, b3 = t3.coordinateSystem, w3 = this.group, M = t3.getData(), I = t3.getModel("lineStyle"), k3 = t3.getModel("areaStyle"), L = M.getLayout("points") || [], F = b3.type === "polar", B = this._coordSys, G = this._symbolDraw, J = this._polyline, Q = this._polygon, se = this._lineGroup, he = t3.get("animation"), be = !k3.isEmpty(), de = k3.get("origin"), Fe = cNe(b3, M, de), Pe = be && y_t(b3, M, Fe), ze = t3.get("showSymbol"), $e = t3.get("connectNulls"), Ke = ze && !F && __t(t3, M, b3), nt = this._data;
        nt && nt.eachItemGraphicEl(function(_o, xo) {
          _o.__temp && (w3.remove(_o), nt.setItemGraphicEl(xo, null));
        }), ze || G.remove(), w3.add(se);
        var lt2 = F ? false : t3.get("step"), bt;
        b3 && b3.getArea && t3.get("clip", true) && (bt = b3.getArea(), bt.width != null ? (bt.x -= 0.1, bt.y -= 0.1, bt.width += 0.2, bt.height += 0.2) : bt.r0 && (bt.r0 -= 0.5, bt.r += 0.5)), this._clipShapeForSymbol = bt;
        var vt = b_t(M, b3, p3) || M.getVisual("style")[M.getVisual("drawType")];
        if (!(J && B.type === b3.type && lt2 === this._step))
          ze && G.updateData(M, { isIgnore: Ke, clipShape: bt, disableAnimation: true, getSymbolPoint: function(_o) {
            return [L[_o * 2], L[_o * 2 + 1]];
          } }), he && this._initSymbolLabelAnimation(M, b3, bt), lt2 && (L = dk(L, b3, lt2, $e), Pe && (Pe = dk(Pe, b3, lt2, $e))), J = this._newPolyline(L), be && (Q = this._newPolygon(L, Pe)), F || this._initOrUpdateEndLabel(t3, b3, nL(vt)), se.setClipPath(N0e(this, b3, true, t3));
        else {
          be && !Q ? Q = this._newPolygon(L, Pe) : Q && !be && (se.remove(Q), Q = this._polygon = null), F || this._initOrUpdateEndLabel(t3, b3, nL(vt));
          var jt = se.getClipPath();
          if (jt) {
            var Jt = N0e(this, b3, false, t3);
            Uh(jt, { shape: Jt.shape }, t3);
          } else
            se.setClipPath(N0e(this, b3, true, t3));
          ze && G.updateData(M, { isIgnore: Ke, clipShape: bt, disableAnimation: true, getSymbolPoint: function(_o) {
            return [L[_o * 2], L[_o * 2 + 1]];
          } }), (!gNe(this._stackedOnPoints, Pe) || !gNe(this._points, L)) && (he ? this._doUpdateAnimation(M, Pe, b3, p3, lt2, de, $e) : (lt2 && (L = dk(L, b3, lt2, $e), Pe && (Pe = dk(Pe, b3, lt2, $e))), J.setShape({ points: L }), Q && Q.setShape({ points: L, stackedOnPoints: Pe })));
        }
        var Rt = t3.getModel("emphasis"), Jn = Rt.get("focus"), ln = Rt.get("blurScope"), vn = Rt.get("disabled");
        if (J.useStyle(Uo(I.getLineStyle(), { fill: "none", stroke: vt, lineJoin: "bevel" })), cv(J, t3, "lineStyle"), J.style.lineWidth > 0 && t3.get(["emphasis", "lineStyle", "width"]) === "bolder") {
          var kn = J.getState("emphasis").style;
          kn.lineWidth = +J.style.lineWidth + 1;
        }
        La(J).seriesIndex = t3.seriesIndex, zp(J, Jn, ln, vn);
        var cr = bNe(t3.get("smooth")), gr = t3.get("smoothMonotone");
        if (J.setShape({ smooth: cr, smoothMonotone: gr, connectNulls: $e }), Q) {
          var ha = M.getCalculationInfo("stackedOnSeries"), Ka = 0;
          Q.useStyle(Uo(k3.getAreaStyle(), { fill: vt, opacity: 0.7, lineJoin: "bevel", decal: M.getVisual("style").decal })), ha && (Ka = bNe(ha.get("smooth"))), Q.setShape({ smooth: cr, stackedOnSmooth: Ka, smoothMonotone: gr, connectNulls: $e }), cv(Q, t3, "areaStyle"), La(Q).seriesIndex = t3.seriesIndex, zp(Q, Jn, ln, vn);
        }
        var Do = function(_o) {
          g3._changePolyState(_o);
        };
        M.eachItemGraphicEl(function(_o) {
          _o && (_o.onHoverStateChange = Do);
        }), this._polyline.onHoverStateChange = Do, this._data = M, this._coordSys = b3, this._stackedOnPoints = Pe, this._points = L, this._step = lt2, this._valueOrigin = de, t3.get("triggerLineEvent") && (this.packEventData(t3, J), Q && this.packEventData(t3, Q));
      }, i.prototype.packEventData = function(t3, c3) {
        La(c3).eventData = { componentType: "series", componentSubType: "line", componentIndex: t3.componentIndex, seriesIndex: t3.seriesIndex, seriesName: t3.name, seriesType: "line" };
      }, i.prototype.highlight = function(t3, c3, p3, g3) {
        var b3 = t3.getData(), w3 = k_(b3, g3);
        if (this._changePolyState("emphasis"), !(w3 instanceof Array) && w3 != null && w3 >= 0) {
          var M = b3.getLayout("points"), I = b3.getItemGraphicEl(w3);
          if (!I) {
            var k3 = M[w3 * 2], L = M[w3 * 2 + 1];
            if (isNaN(k3) || isNaN(L) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(k3, L))
              return;
            var F = t3.get("zlevel"), B = t3.get("z");
            I = new sW(b3, w3), I.x = k3, I.y = L, I.setZ(F, B);
            var G = I.getSymbolPath().getTextContent();
            G && (G.zlevel = F, G.z = B, G.z2 = this._polyline.z2 + 1), I.__temp = true, b3.setItemGraphicEl(w3, I), I.stopSymbolAnimation(true), this.group.add(I);
          }
          I.highlight();
        } else
          yh.prototype.highlight.call(this, t3, c3, p3, g3);
      }, i.prototype.downplay = function(t3, c3, p3, g3) {
        var b3 = t3.getData(), w3 = k_(b3, g3);
        if (this._changePolyState("normal"), w3 != null && w3 >= 0) {
          var M = b3.getItemGraphicEl(w3);
          M && (M.__temp ? (b3.setItemGraphicEl(w3, null), this.group.remove(M)) : M.downplay());
        } else
          yh.prototype.downplay.call(this, t3, c3, p3, g3);
      }, i.prototype._changePolyState = function(t3) {
        var c3 = this._polygon;
        TI(this._polyline, t3), c3 && TI(c3, t3);
      }, i.prototype._newPolyline = function(t3) {
        var c3 = this._polyline;
        return c3 && this._lineGroup.remove(c3), c3 = new v_t({ shape: { points: t3 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(c3), this._polyline = c3, c3;
      }, i.prototype._newPolygon = function(t3, c3) {
        var p3 = this._polygon;
        return p3 && this._lineGroup.remove(p3), p3 = new pNe({ shape: { points: t3, stackedOnPoints: c3 }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(p3), this._polygon = p3, p3;
      }, i.prototype._initSymbolLabelAnimation = function(t3, c3, p3) {
        var g3, b3, w3 = c3.getBaseAxis(), M = w3.inverse;
        c3.type === "cartesian2d" ? (g3 = w3.isHorizontal(), b3 = false) : c3.type === "polar" && (g3 = w3.dim === "angle", b3 = true);
        var I = t3.hostModel, k3 = I.get("animationDuration");
        Vo(k3) && (k3 = k3(null));
        var L = I.get("animationDelay") || 0, F = Vo(L) ? L(null) : L;
        t3.eachItemGraphicEl(function(B, G) {
          var J = B;
          if (J) {
            var Q = [B.x, B.y], se = void 0, he = void 0, be = void 0;
            if (p3)
              if (b3) {
                var de = p3, Fe = c3.pointToCoord(Q);
                g3 ? (se = de.startAngle, he = de.endAngle, be = -Fe[1] / 180 * Math.PI) : (se = de.r0, he = de.r, be = Fe[0]);
              } else {
                var Pe = p3;
                g3 ? (se = Pe.x, he = Pe.x + Pe.width, be = B.x) : (se = Pe.y + Pe.height, he = Pe.y, be = B.y);
              }
            var ze = he === se ? 0 : (be - se) / (he - se);
            M && (ze = 1 - ze);
            var $e = Vo(L) ? L(G) : k3 * ze + F, Ke = J.getSymbolPath(), nt = Ke.getTextContent();
            J.attr({ scaleX: 0, scaleY: 0 }), J.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: $e }), nt && nt.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: $e }), Ke.disableLabelAnimation = true;
          }
        });
      }, i.prototype._initOrUpdateEndLabel = function(t3, c3, p3) {
        var g3 = t3.getModel("endLabel");
        if (xNe(t3)) {
          var b3 = t3.getData(), w3 = this._polyline, M = b3.getLayout("points");
          if (!M) {
            w3.removeTextContent(), this._endLabel = null;
            return;
          }
          var I = this._endLabel;
          I || (I = this._endLabel = new Fl({ z2: 200 }), I.ignoreClip = true, w3.setTextContent(this._endLabel), w3.disableLabelAnimation = true);
          var k3 = S_t(M);
          k3 >= 0 && (Sm(w3, g0(t3, "endLabel"), { inheritColor: p3, labelFetcher: t3, labelDataIndex: k3, defaultText: function(L, F, B) {
            return B != null ? sNe(b3, B) : L8(b3, L);
          }, enableTextSetter: true }, M_t(g3, c3)), w3.textConfig.position = null);
        } else
          this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
      }, i.prototype._endLabelOnDuring = function(t3, c3, p3, g3, b3, w3, M) {
        var I = this._endLabel, k3 = this._polyline;
        if (I) {
          t3 < 1 && g3.originalX == null && (g3.originalX = I.x, g3.originalY = I.y);
          var L = p3.getLayout("points"), F = p3.hostModel, B = F.get("connectNulls"), G = w3.get("precision"), J = w3.get("distance") || 0, Q = M.getBaseAxis(), se = Q.isHorizontal(), he = Q.inverse, be = c3.shape, de = he ? se ? be.x : be.y + be.height : se ? be.x + be.width : be.y, Fe = (se ? J : 0) * (he ? -1 : 1), Pe = (se ? 0 : -J) * (he ? -1 : 1), ze = se ? "x" : "y", $e = C_t(L, de, ze), Ke = $e.range, nt = Ke[1] - Ke[0], lt2 = void 0;
          if (nt >= 1) {
            if (nt > 1 && !B) {
              var bt = _Ne(L, Ke[0]);
              I.attr({ x: bt[0] + Fe, y: bt[1] + Pe }), b3 && (lt2 = F.getRawValue(Ke[0]));
            } else {
              var bt = k3.getPointOn(de, ze);
              bt && I.attr({ x: bt[0] + Fe, y: bt[1] + Pe });
              var vt = F.getRawValue(Ke[0]), jt = F.getRawValue(Ke[1]);
              b3 && (lt2 = $5(p3, G, vt, jt, $e.t));
            }
            g3.lastFrameIndex = Ke[0];
          } else {
            var Jt = t3 === 1 || g3.lastFrameIndex > 0 ? Ke[0] : 0, bt = _Ne(L, Jt);
            b3 && (lt2 = F.getRawValue(Jt)), I.attr({ x: bt[0] + Fe, y: bt[1] + Pe });
          }
          b3 && p8(I).setLabelText(lt2);
        }
      }, i.prototype._doUpdateAnimation = function(t3, c3, p3, g3, b3, w3, M) {
        var I = this._polyline, k3 = this._polygon, L = t3.hostModel, F = d_t(this._data, t3, this._stackedOnPoints, c3, this._coordSys, p3, this._valueOrigin), B = F.current, G = F.stackedOnCurrent, J = F.next, Q = F.stackedOnNext;
        if (b3 && (B = dk(F.current, p3, b3, M), G = dk(F.stackedOnCurrent, p3, b3, M), J = dk(F.next, p3, b3, M), Q = dk(F.stackedOnNext, p3, b3, M)), mNe(B, J) > 3e3 || k3 && mNe(G, Q) > 3e3) {
          I.stopAnimation(), I.setShape({ points: J }), k3 && (k3.stopAnimation(), k3.setShape({ points: J, stackedOnPoints: Q }));
          return;
        }
        I.shape.__points = F.current, I.shape.points = B;
        var se = { shape: { points: J } };
        F.current !== B && (se.shape.__points = F.next), I.stopAnimation(), Du(I, se, L), k3 && (k3.setShape({ points: B, stackedOnPoints: G }), k3.stopAnimation(), Du(k3, { shape: { stackedOnPoints: Q } }, L), I.shape.points !== k3.shape.points && (k3.shape.points = I.shape.points));
        for (var he = [], be = F.status, de = 0; de < be.length; de++) {
          var Fe = be[de].cmd;
          if (Fe === "=") {
            var Pe = t3.getItemGraphicEl(be[de].idx1);
            Pe && he.push({ el: Pe, ptIdx: de });
          }
        }
        I.animators && I.animators.length && I.animators[0].during(function() {
          k3 && k3.dirtyShape();
          for (var ze = I.shape.__points, $e = 0; $e < he.length; $e++) {
            var Ke = he[$e].el, nt = he[$e].ptIdx * 2;
            Ke.x = ze[nt], Ke.y = ze[nt + 1], Ke.markRedraw();
          }
        });
      }, i.prototype.remove = function(t3) {
        var c3 = this.group, p3 = this._data;
        this._lineGroup.removeAll(), this._symbolDraw.remove(true), p3 && p3.eachItemGraphicEl(function(g3, b3) {
          g3.__temp && (c3.remove(g3), p3.setItemGraphicEl(b3, null));
        }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
      }, i.type = "line", i;
    }(yh), A_t = T_t;
    function uW(o, i) {
      return { seriesType: o, plan: C8(), reset: function(t3) {
        var c3 = t3.getData(), p3 = t3.coordinateSystem, g3 = t3.pipelineContext, b3 = i || g3.large;
        if (p3) {
          var w3 = Fi(p3.dimensions, function(B) {
            return c3.mapDimension(B);
          }).slice(0, 2), M = w3.length, I = c3.getCalculationInfo("stackResultDimension");
          ck(c3, w3[0]) && (w3[0] = I), ck(c3, w3[1]) && (w3[1] = I);
          var k3 = c3.getStore(), L = c3.getDimensionIndex(w3[0]), F = c3.getDimensionIndex(w3[1]);
          return M && { progress: function(B, G) {
            for (var J = B.end - B.start, Q = b3 && JM(J * M), se = [], he = [], be = B.start, de = 0; be < B.end; be++) {
              var Fe = void 0;
              if (M === 1) {
                var Pe = k3.get(L, be);
                Fe = p3.dataToPoint(Pe, null, he);
              } else
                se[0] = k3.get(L, be), se[1] = k3.get(F, be), Fe = p3.dataToPoint(se, null, he);
              b3 ? (Q[de++] = Fe[0], Q[de++] = Fe[1]) : G.setItemLayout(be, Fe.slice());
            }
            b3 && G.setLayout("points", Q);
          } };
        }
      } };
    }
    var I_t = { average: function(o) {
      for (var i = 0, t3 = 0, c3 = 0; c3 < o.length; c3++)
        isNaN(o[c3]) || (i += o[c3], t3++);
      return t3 === 0 ? NaN : i / t3;
    }, sum: function(o) {
      for (var i = 0, t3 = 0; t3 < o.length; t3++)
        i += o[t3] || 0;
      return i;
    }, max: function(o) {
      for (var i = -1 / 0, t3 = 0; t3 < o.length; t3++)
        o[t3] > i && (i = o[t3]);
      return isFinite(i) ? i : NaN;
    }, min: function(o) {
      for (var i = 1 / 0, t3 = 0; t3 < o.length; t3++)
        o[t3] < i && (i = o[t3]);
      return isFinite(i) ? i : NaN;
    }, nearest: function(o) {
      return o[0];
    } }, E_t = function(o) {
      return Math.round(o.length / 2);
    };
    function wNe(o) {
      return { seriesType: o, reset: function(i, t3, c3) {
        var p3 = i.getData(), g3 = i.get("sampling"), b3 = i.coordinateSystem, w3 = p3.count();
        if (w3 > 10 && b3.type === "cartesian2d" && g3) {
          var M = b3.getBaseAxis(), I = b3.getOtherAxis(M), k3 = M.getExtent(), L = c3.getDevicePixelRatio(), F = Math.abs(k3[1] - k3[0]) * (L || 1), B = Math.round(w3 / F);
          if (isFinite(B) && B > 1) {
            g3 === "lttb" && i.setData(p3.lttbDownSample(p3.mapDimension(I.dim), 1 / B));
            var G = void 0;
            Ha(g3) ? G = I_t[g3] : Vo(g3) && (G = g3), G && i.setData(p3.downSample(p3.mapDimension(I.dim), 1 / B, G, E_t));
          }
        }
      } };
    }
    function D_t(o) {
      o.registerChartView(A_t), o.registerSeriesModel(l_t), o.registerLayout(uW("line", true)), o.registerVisual({ seriesType: "line", reset: function(i) {
        var t3 = i.getData(), c3 = i.getModel("lineStyle").getLineStyle();
        c3 && !c3.stroke && (c3.stroke = t3.getVisual("style").fill), t3.setVisual("legendLineStyle", c3);
      } }), o.registerProcessor(o.PRIORITY.PROCESSOR.STATISTIC, wNe("line"));
    }
    var SNe = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        return NI(null, this, { useEncodeDefaulter: true });
      }, i.prototype.getMarkerPosition = function(t3) {
        var c3 = this.coordinateSystem;
        if (c3 && c3.clampData) {
          var p3 = c3.dataToPoint(c3.clampData(t3)), g3 = this.getData(), b3 = g3.getLayout("offset"), w3 = g3.getLayout("size"), M = c3.getBaseAxis().isHorizontal() ? 0 : 1;
          return p3[M] += b3 + w3 / 2, p3;
        }
        return [NaN, NaN];
      }, i.type = "series.__base_bar__", i.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, i;
    }(bp);
    bp.registerClass(SNe);
    var rne = SNe, k_t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.getInitialData = function() {
        return NI(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
      }, i.prototype.getProgressive = function() {
        return this.get("large") ? this.get("progressive") : false;
      }, i.prototype.getProgressiveThreshold = function() {
        var t3 = this.get("progressiveThreshold"), c3 = this.get("largeThreshold");
        return c3 > t3 && (t3 = c3), t3;
      }, i.prototype.brushSelector = function(t3, c3, p3) {
        return p3.rect(c3.getItemLayout(t3));
      }, i.type = "series.bar", i.dependencies = ["grid", "polar"], i.defaultOption = rk(rne.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), i;
    }(rne), O_t = k_t, P_t = function() {
      function o() {
        this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
      }
      return o;
    }(), L_t = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "sausage", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new P_t();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.cx, g3 = c3.cy, b3 = Math.max(c3.r0 || 0, 0), w3 = Math.max(c3.r, 0), M = (w3 - b3) * 0.5, I = b3 + M, k3 = c3.startAngle, L = c3.endAngle, F = c3.clockwise, B = Math.PI * 2, G = F ? L - k3 < B : k3 - L < B;
        G || (k3 = L - (F ? B : -B));
        var J = Math.cos(k3), Q = Math.sin(k3), se = Math.cos(L), he = Math.sin(L);
        G ? (t3.moveTo(J * b3 + p3, Q * b3 + g3), t3.arc(J * I + p3, Q * I + g3, M, -Math.PI + k3, k3, !F)) : t3.moveTo(J * w3 + p3, Q * w3 + g3), t3.arc(p3, g3, w3, k3, L, !F), t3.arc(se * I + p3, he * I + g3, M, L - Math.PI * 2, L - Math.PI, !F), b3 !== 0 && t3.arc(p3, g3, b3, L, k3, F);
      }, i;
    }(gl), ine = L_t;
    function R_t(o, i) {
      i = i || {};
      var t3 = i.isRoundCap;
      return function(c3, p3, g3) {
        var b3 = p3.position;
        if (!b3 || b3 instanceof Array)
          return TF(c3, p3, g3);
        var w3 = o(b3), M = p3.distance != null ? p3.distance : 5, I = this.shape, k3 = I.cx, L = I.cy, F = I.r, B = I.r0, G = (F + B) / 2, J = I.startAngle, Q = I.endAngle, se = (J + Q) / 2, he = t3 ? Math.abs(F - B) / 2 : 0, be = Math.cos, de = Math.sin, Fe = k3 + F * be(J), Pe = L + F * de(J), ze = "left", $e = "top";
        switch (w3) {
          case "startArc":
            Fe = k3 + (B - M) * be(se), Pe = L + (B - M) * de(se), ze = "center", $e = "top";
            break;
          case "insideStartArc":
            Fe = k3 + (B + M) * be(se), Pe = L + (B + M) * de(se), ze = "center", $e = "bottom";
            break;
          case "startAngle":
            Fe = k3 + G * be(J) + ane(J, M + he, false), Pe = L + G * de(J) + one(J, M + he, false), ze = "right", $e = "middle";
            break;
          case "insideStartAngle":
            Fe = k3 + G * be(J) + ane(J, -M + he, false), Pe = L + G * de(J) + one(J, -M + he, false), ze = "left", $e = "middle";
            break;
          case "middle":
            Fe = k3 + G * be(se), Pe = L + G * de(se), ze = "center", $e = "middle";
            break;
          case "endArc":
            Fe = k3 + (F + M) * be(se), Pe = L + (F + M) * de(se), ze = "center", $e = "bottom";
            break;
          case "insideEndArc":
            Fe = k3 + (F - M) * be(se), Pe = L + (F - M) * de(se), ze = "center", $e = "top";
            break;
          case "endAngle":
            Fe = k3 + G * be(Q) + ane(Q, M + he, true), Pe = L + G * de(Q) + one(Q, M + he, true), ze = "left", $e = "middle";
            break;
          case "insideEndAngle":
            Fe = k3 + G * be(Q) + ane(Q, -M + he, true), Pe = L + G * de(Q) + one(Q, -M + he, true), ze = "right", $e = "middle";
            break;
          default:
            return TF(c3, p3, g3);
        }
        return c3 = c3 || {}, c3.x = Fe, c3.y = Pe, c3.align = ze, c3.verticalAlign = $e, c3;
      };
    }
    function N_t(o, i, t3, c3) {
      if (ec(c3)) {
        o.setTextConfig({ rotation: c3 });
        return;
      } else if (Ei(i)) {
        o.setTextConfig({ rotation: 0 });
        return;
      }
      var p3 = o.shape, g3 = p3.clockwise ? p3.startAngle : p3.endAngle, b3 = p3.clockwise ? p3.endAngle : p3.startAngle, w3 = (g3 + b3) / 2, M, I = t3(i);
      switch (I) {
        case "startArc":
        case "insideStartArc":
        case "middle":
        case "insideEndArc":
        case "endArc":
          M = w3;
          break;
        case "startAngle":
        case "insideStartAngle":
          M = g3;
          break;
        case "endAngle":
        case "insideEndAngle":
          M = b3;
          break;
        default:
          o.setTextConfig({ rotation: 0 });
          return;
      }
      var k3 = Math.PI * 1.5 - M;
      I === "middle" && k3 > Math.PI / 2 && k3 < Math.PI * 1.5 && (k3 -= Math.PI), o.setTextConfig({ rotation: k3 });
    }
    function ane(o, i, t3) {
      return i * Math.sin(o) * (t3 ? -1 : 1);
    }
    function one(o, i, t3) {
      return i * Math.cos(o) * (t3 ? 1 : -1);
    }
    var F0e = Math.max, V0e = Math.min;
    function F_t(o, i) {
      var t3 = o.getArea && o.getArea();
      if (VI(o, "cartesian2d")) {
        var c3 = o.getBaseAxis();
        if (c3.type !== "category" || !c3.onBand) {
          var p3 = i.getLayout("bandWidth");
          c3.isHorizontal() ? (t3.x -= p3, t3.width += p3 * 2) : (t3.y -= p3, t3.height += p3 * 2);
        }
      }
      return t3;
    }
    var V_t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o.call(this) || this;
        return t3.type = i.type, t3._isFirstFrame = true, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        this._model = t3, this._removeOnRenderedListener(p3), this._updateDrawMode(t3);
        var b3 = t3.get("coordinateSystem");
        (b3 === "cartesian2d" || b3 === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(t3, c3, p3) : this._renderNormal(t3, c3, p3, g3));
      }, i.prototype.incrementalPrepareRender = function(t3) {
        this._clear(), this._updateDrawMode(t3), this._updateLargeClip(t3);
      }, i.prototype.incrementalRender = function(t3, c3) {
        this._progressiveEls = [], this._incrementalRenderLarge(t3, c3);
      }, i.prototype.eachRendered = function(t3) {
        nk(this._progressiveEls || this.group, t3);
      }, i.prototype._updateDrawMode = function(t3) {
        var c3 = t3.pipelineContext.large;
        (this._isLargeDraw == null || c3 !== this._isLargeDraw) && (this._isLargeDraw = c3, this._clear());
      }, i.prototype._renderNormal = function(t3, c3, p3, g3) {
        var b3 = this.group, w3 = t3.getData(), M = this._data, I = t3.coordinateSystem, k3 = I.getBaseAxis(), L;
        I.type === "cartesian2d" ? L = k3.isHorizontal() : I.type === "polar" && (L = k3.dim === "angle");
        var F = t3.isAnimationEnabled() ? t3 : null, B = B_t(t3, I);
        B && this._enableRealtimeSort(B, w3, p3);
        var G = t3.get("clip", true) || B, J = F_t(I, w3);
        b3.removeClipPath();
        var Q = t3.get("roundCap", true), se = t3.get("showBackground", true), he = t3.getModel("backgroundStyle"), be = he.get("borderRadius") || 0, de = [], Fe = this._backgroundEls, Pe = g3 && g3.isInitSort, ze = g3 && g3.type === "changeAxisOrder";
        function $e(lt2) {
          var bt = sne[I.type](w3, lt2), vt = q_t(I, L, bt);
          return vt.useStyle(he.getItemStyle()), I.type === "cartesian2d" && vt.setShape("r", be), de[lt2] = vt, vt;
        }
        w3.diff(M).add(function(lt2) {
          var bt = w3.getItemModel(lt2), vt = sne[I.type](w3, lt2, bt);
          if (se && $e(lt2), !(!w3.hasValue(lt2) || !INe[I.type](vt))) {
            var jt = false;
            G && (jt = CNe[I.type](J, vt));
            var Jt = MNe[I.type](t3, w3, lt2, vt, L, F, k3.model, false, Q);
            B && (Jt.forceLabelAnimation = true), DNe(Jt, w3, lt2, bt, vt, t3, L, I.type === "polar"), Pe ? Jt.attr({ shape: vt }) : B ? TNe(B, F, Jt, vt, lt2, L, false, false) : Uh(Jt, { shape: vt }, t3, lt2), w3.setItemGraphicEl(lt2, Jt), b3.add(Jt), Jt.ignore = jt;
          }
        }).update(function(lt2, bt) {
          var vt = w3.getItemModel(lt2), jt = sne[I.type](w3, lt2, vt);
          if (se) {
            var Jt = void 0;
            Fe.length === 0 ? Jt = $e(bt) : (Jt = Fe[bt], Jt.useStyle(he.getItemStyle()), I.type === "cartesian2d" && Jt.setShape("r", be), de[lt2] = Jt);
            var Rt = sne[I.type](w3, lt2), Jn = LNe(L, Rt, I);
            Du(Jt, { shape: Jn }, F, lt2);
          }
          var ln = M.getItemGraphicEl(bt);
          if (!w3.hasValue(lt2) || !INe[I.type](jt)) {
            b3.remove(ln);
            return;
          }
          var vn = false;
          if (G && (vn = CNe[I.type](J, jt), vn && b3.remove(ln)), ln ? P_(ln) : ln = MNe[I.type](t3, w3, lt2, jt, L, F, k3.model, !!ln, Q), B && (ln.forceLabelAnimation = true), ze) {
            var kn = ln.getTextContent();
            if (kn) {
              var cr = p8(kn);
              cr.prevValue != null && (cr.prevValue = cr.value);
            }
          } else
            DNe(ln, w3, lt2, vt, jt, t3, L, I.type === "polar");
          Pe ? ln.attr({ shape: jt }) : B ? TNe(B, F, ln, jt, lt2, L, true, ze) : Du(ln, { shape: jt }, t3, lt2, null), w3.setItemGraphicEl(lt2, ln), ln.ignore = vn, b3.add(ln);
        }).remove(function(lt2) {
          var bt = M.getItemGraphicEl(lt2);
          bt && QP(bt, t3, lt2);
        }).execute();
        var Ke = this._backgroundGroup || (this._backgroundGroup = new vs());
        Ke.removeAll();
        for (var nt = 0; nt < de.length; ++nt)
          Ke.add(de[nt]);
        b3.add(Ke), this._backgroundEls = de, this._data = w3;
      }, i.prototype._renderLarge = function(t3, c3, p3) {
        this._clear(), ONe(t3, this.group), this._updateLargeClip(t3);
      }, i.prototype._incrementalRenderLarge = function(t3, c3) {
        this._removeBackground(), ONe(c3, this.group, this._progressiveEls, true);
      }, i.prototype._updateLargeClip = function(t3) {
        var c3 = t3.get("clip", true) && nne(t3.coordinateSystem, false, t3), p3 = this.group;
        c3 ? p3.setClipPath(c3) : p3.removeClipPath();
      }, i.prototype._enableRealtimeSort = function(t3, c3, p3) {
        var g3 = this;
        if (c3.count()) {
          var b3 = t3.baseAxis;
          if (this._isFirstFrame)
            this._dispatchInitSort(c3, t3, p3), this._isFirstFrame = false;
          else {
            var w3 = function(M) {
              var I = c3.getItemGraphicEl(M), k3 = I && I.shape;
              return k3 && Math.abs(b3.isHorizontal() ? k3.height : k3.width) || 0;
            };
            this._onRendered = function() {
              g3._updateSortWithinSameData(c3, w3, b3, p3);
            }, p3.getZr().on("rendered", this._onRendered);
          }
        }
      }, i.prototype._dataSort = function(t3, c3, p3) {
        var g3 = [];
        return t3.each(t3.mapDimension(c3.dim), function(b3, w3) {
          var M = p3(w3);
          M = M == null ? NaN : M, g3.push({ dataIndex: w3, mappedValue: M, ordinalNumber: b3 });
        }), g3.sort(function(b3, w3) {
          return w3.mappedValue - b3.mappedValue;
        }), { ordinalNumbers: Fi(g3, function(b3) {
          return b3.ordinalNumber;
        }) };
      }, i.prototype._isOrderChangedWithinSameData = function(t3, c3, p3) {
        for (var g3 = p3.scale, b3 = t3.mapDimension(p3.dim), w3 = Number.MAX_VALUE, M = 0, I = g3.getOrdinalMeta().categories.length; M < I; ++M) {
          var k3 = t3.rawIndexOf(b3, g3.getRawOrdinalNumber(M)), L = k3 < 0 ? Number.MIN_VALUE : c3(t3.indexOfRawIndex(k3));
          if (L > w3)
            return true;
          w3 = L;
        }
        return false;
      }, i.prototype._isOrderDifferentInView = function(t3, c3) {
        for (var p3 = c3.scale, g3 = p3.getExtent(), b3 = Math.max(0, g3[0]), w3 = Math.min(g3[1], p3.getOrdinalMeta().categories.length - 1); b3 <= w3; ++b3)
          if (t3.ordinalNumbers[b3] !== p3.getRawOrdinalNumber(b3))
            return true;
      }, i.prototype._updateSortWithinSameData = function(t3, c3, p3, g3) {
        if (this._isOrderChangedWithinSameData(t3, c3, p3)) {
          var b3 = this._dataSort(t3, p3, c3);
          this._isOrderDifferentInView(b3, p3) && (this._removeOnRenderedListener(g3), g3.dispatchAction({ type: "changeAxisOrder", componentType: p3.dim + "Axis", axisId: p3.index, sortInfo: b3 }));
        }
      }, i.prototype._dispatchInitSort = function(t3, c3, p3) {
        var g3 = c3.baseAxis, b3 = this._dataSort(t3, g3, function(w3) {
          return t3.get(t3.mapDimension(c3.otherAxis.dim), w3);
        });
        p3.dispatchAction({ type: "changeAxisOrder", componentType: g3.dim + "Axis", isInitSort: true, axisId: g3.index, sortInfo: b3 });
      }, i.prototype.remove = function(t3, c3) {
        this._clear(this._model), this._removeOnRenderedListener(c3);
      }, i.prototype.dispose = function(t3, c3) {
        this._removeOnRenderedListener(c3);
      }, i.prototype._removeOnRenderedListener = function(t3) {
        this._onRendered && (t3.getZr().off("rendered", this._onRendered), this._onRendered = null);
      }, i.prototype._clear = function(t3) {
        var c3 = this.group, p3 = this._data;
        t3 && t3.isAnimationEnabled() && p3 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], p3.eachItemGraphicEl(function(g3) {
          QP(g3, t3, La(g3).dataIndex);
        })) : c3.removeAll(), this._data = null, this._isFirstFrame = true;
      }, i.prototype._removeBackground = function() {
        this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
      }, i.type = "bar", i;
    }(yh), CNe = { cartesian2d: function(o, i) {
      var t3 = i.width < 0 ? -1 : 1, c3 = i.height < 0 ? -1 : 1;
      t3 < 0 && (i.x += i.width, i.width = -i.width), c3 < 0 && (i.y += i.height, i.height = -i.height);
      var p3 = o.x + o.width, g3 = o.y + o.height, b3 = F0e(i.x, o.x), w3 = V0e(i.x + i.width, p3), M = F0e(i.y, o.y), I = V0e(i.y + i.height, g3), k3 = w3 < b3, L = I < M;
      return i.x = k3 && b3 > p3 ? w3 : b3, i.y = L && M > g3 ? I : M, i.width = k3 ? 0 : w3 - b3, i.height = L ? 0 : I - M, t3 < 0 && (i.x += i.width, i.width = -i.width), c3 < 0 && (i.y += i.height, i.height = -i.height), k3 || L;
    }, polar: function(o, i) {
      var t3 = i.r0 <= i.r ? 1 : -1;
      if (t3 < 0) {
        var c3 = i.r;
        i.r = i.r0, i.r0 = c3;
      }
      var p3 = V0e(i.r, o.r), g3 = F0e(i.r0, o.r0);
      i.r = p3, i.r0 = g3;
      var b3 = p3 - g3 < 0;
      if (t3 < 0) {
        var c3 = i.r;
        i.r = i.r0, i.r0 = c3;
      }
      return b3;
    } }, MNe = { cartesian2d: function(o, i, t3, c3, p3, g3, b3, w3, M) {
      var I = new bu({ shape: ti({}, c3), z2: 1 });
      if (I.__dataIndex = t3, I.name = "item", g3) {
        var k3 = I.shape, L = p3 ? "height" : "width";
        k3[L] = 0;
      }
      return I;
    }, polar: function(o, i, t3, c3, p3, g3, b3, w3, M) {
      var I = !p3 && M ? ine : bm, k3 = new I({ shape: c3, z2: 1 });
      k3.name = "item";
      var L = ENe(p3);
      if (k3.calculateTextPosition = R_t(L, { isRoundCap: I === ine }), g3) {
        var F = k3.shape, B = p3 ? "r" : "endAngle", G = {};
        F[B] = p3 ? 0 : c3.startAngle, G[B] = c3[B], (w3 ? Du : Uh)(k3, { shape: G }, g3);
      }
      return k3;
    } };
    function B_t(o, i) {
      var t3 = o.get("realtimeSort", true), c3 = i.getBaseAxis();
      if (t3 && c3.type === "category" && i.type === "cartesian2d")
        return { baseAxis: c3, otherAxis: i.getOtherAxis(c3) };
    }
    function TNe(o, i, t3, c3, p3, g3, b3, w3) {
      var M, I;
      g3 ? (I = { x: c3.x, width: c3.width }, M = { y: c3.y, height: c3.height }) : (I = { y: c3.y, height: c3.height }, M = { x: c3.x, width: c3.width }), w3 || (b3 ? Du : Uh)(t3, { shape: M }, i, p3, null);
      var k3 = i ? o.baseAxis.model : null;
      (b3 ? Du : Uh)(t3, { shape: I }, k3, p3);
    }
    function ANe(o, i) {
      for (var t3 = 0; t3 < i.length; t3++)
        if (!isFinite(o[i[t3]]))
          return true;
      return false;
    }
    var z_t = ["x", "y", "width", "height"], j_t = ["cx", "cy", "r", "startAngle", "endAngle"], INe = { cartesian2d: function(o) {
      return !ANe(o, z_t);
    }, polar: function(o) {
      return !ANe(o, j_t);
    } }, sne = { cartesian2d: function(o, i, t3) {
      var c3 = o.getItemLayout(i), p3 = t3 ? H_t(t3, c3) : 0, g3 = c3.width > 0 ? 1 : -1, b3 = c3.height > 0 ? 1 : -1;
      return { x: c3.x + g3 * p3 / 2, y: c3.y + b3 * p3 / 2, width: c3.width - g3 * p3, height: c3.height - b3 * p3 };
    }, polar: function(o, i, t3) {
      var c3 = o.getItemLayout(i);
      return { cx: c3.cx, cy: c3.cy, r0: c3.r0, r: c3.r, startAngle: c3.startAngle, endAngle: c3.endAngle, clockwise: c3.clockwise };
    } };
    function G_t(o) {
      return o.startAngle != null && o.endAngle != null && o.startAngle === o.endAngle;
    }
    function ENe(o) {
      return function(i) {
        var t3 = i ? "Arc" : "Angle";
        return function(c3) {
          switch (c3) {
            case "start":
            case "insideStart":
            case "end":
            case "insideEnd":
              return c3 + t3;
            default:
              return c3;
          }
        };
      }(o);
    }
    function DNe(o, i, t3, c3, p3, g3, b3, w3) {
      var M = i.getItemVisual(t3, "style");
      w3 || o.setShape("r", c3.get(["itemStyle", "borderRadius"]) || 0), o.useStyle(M);
      var I = c3.getShallow("cursor");
      I && o.attr("cursor", I);
      var k3 = w3 ? b3 ? p3.r >= p3.r0 ? "endArc" : "startArc" : p3.endAngle >= p3.startAngle ? "endAngle" : "startAngle" : b3 ? p3.height >= 0 ? "bottom" : "top" : p3.width >= 0 ? "right" : "left", L = g0(c3);
      Sm(o, L, { labelFetcher: g3, labelDataIndex: t3, defaultText: L8(g3.getData(), t3), inheritColor: M.fill, defaultOpacity: M.opacity, defaultOutsidePosition: k3 });
      var F = o.getTextContent();
      if (w3 && F) {
        var B = c3.get(["label", "position"]);
        o.textConfig.inside = B === "middle" ? true : null, N_t(o, B === "outside" ? k3 : B, ENe(b3), c3.get(["label", "rotate"]));
      }
      KPe(F, L, g3.getRawValue(t3), function(J) {
        return sNe(i, J);
      });
      var G = c3.getModel(["emphasis"]);
      zp(o, G.get("focus"), G.get("blurScope"), G.get("disabled")), cv(o, c3), G_t(p3) && (o.style.fill = "none", o.style.stroke = "none", yt(o.states, function(J) {
        J.style && (J.style.fill = J.style.stroke = "none");
      }));
    }
    function H_t(o, i) {
      var t3 = o.get(["itemStyle", "borderColor"]);
      if (!t3 || t3 === "none")
        return 0;
      var c3 = o.get(["itemStyle", "borderWidth"]) || 0, p3 = isNaN(i.width) ? Number.MAX_VALUE : Math.abs(i.width), g3 = isNaN(i.height) ? Number.MAX_VALUE : Math.abs(i.height);
      return Math.min(c3, p3, g3);
    }
    var W_t = function() {
      function o() {
      }
      return o;
    }(), kNe = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "largeBar", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new W_t();
      }, i.prototype.buildPath = function(t3, c3) {
        for (var p3 = c3.points, g3 = this.baseDimIdx, b3 = 1 - this.baseDimIdx, w3 = [], M = [], I = this.barWidth, k3 = 0; k3 < p3.length; k3 += 3)
          M[g3] = I, M[b3] = p3[k3 + 2], w3[g3] = p3[k3 + g3], w3[b3] = p3[k3 + b3], t3.rect(w3[0], w3[1], M[0], M[1]);
      }, i;
    }(gl);
    function ONe(o, i, t3, c3) {
      var p3 = o.getData(), g3 = p3.getLayout("valueAxisHorizontal") ? 1 : 0, b3 = p3.getLayout("largeDataIndices"), w3 = p3.getLayout("size"), M = o.getModel("backgroundStyle"), I = p3.getLayout("largeBackgroundPoints");
      if (I) {
        var k3 = new kNe({ shape: { points: I }, incremental: !!c3, silent: true, z2: 0 });
        k3.baseDimIdx = g3, k3.largeDataIndices = b3, k3.barWidth = w3, k3.useStyle(M.getItemStyle()), i.add(k3), t3 && t3.push(k3);
      }
      var L = new kNe({ shape: { points: p3.getLayout("largePoints") }, incremental: !!c3, z2: 1 });
      L.baseDimIdx = g3, L.largeDataIndices = b3, L.barWidth = w3, i.add(L), L.useStyle(p3.getVisual("style")), La(L).seriesIndex = o.seriesIndex, o.get("silent") || (L.on("mousedown", PNe), L.on("mousemove", PNe)), t3 && t3.push(L);
    }
    var PNe = Nge(function(o) {
      var i = this, t3 = U_t(i, o.offsetX, o.offsetY);
      La(i).dataIndex = t3 >= 0 ? t3 : null;
    }, 30, false);
    function U_t(o, i, t3) {
      for (var c3 = o.baseDimIdx, p3 = 1 - c3, g3 = o.shape.points, b3 = o.largeDataIndices, w3 = [], M = [], I = o.barWidth, k3 = 0, L = g3.length / 3; k3 < L; k3++) {
        var F = k3 * 3;
        if (M[c3] = I, M[p3] = g3[F + 2], w3[c3] = g3[F + c3], w3[p3] = g3[F + p3], M[p3] < 0 && (w3[p3] += M[p3], M[p3] = -M[p3]), i >= w3[0] && i <= w3[0] + M[0] && t3 >= w3[1] && t3 <= w3[1] + M[1])
          return b3[k3];
      }
      return -1;
    }
    function LNe(o, i, t3) {
      if (VI(t3, "cartesian2d")) {
        var c3 = i, p3 = t3.getArea();
        return { x: o ? c3.x : p3.x, y: o ? p3.y : c3.y, width: o ? c3.width : p3.width, height: o ? p3.height : c3.height };
      } else {
        var p3 = t3.getArea(), g3 = i;
        return { cx: p3.cx, cy: p3.cy, r0: o ? p3.r0 : g3.r0, r: o ? p3.r : g3.r, startAngle: o ? g3.startAngle : 0, endAngle: o ? g3.endAngle : Math.PI * 2 };
      }
    }
    function q_t(o, i, t3) {
      var c3 = o.type === "polar" ? bm : bu;
      return new c3({ shape: LNe(i, t3, o), silent: true, z2: 0 });
    }
    var $_t = V_t;
    function X_t(o) {
      o.registerChartView($_t), o.registerSeriesModel(O_t), o.registerLayout(o.PRIORITY.VISUAL.LAYOUT, As(Q4e, "bar")), o.registerLayout(o.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, e6e("bar")), o.registerProcessor(o.PRIORITY.PROCESSOR.STATISTIC, wNe("bar")), o.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(i, t3) {
        var c3 = i.componentType || "series";
        t3.eachComponent({ mainType: c3, query: i }, function(p3) {
          i.sortInfo && p3.axis.setCategorySortInfo(i.sortInfo);
        });
      });
    }
    var lne = Math.PI * 2, RNe = Math.PI / 180;
    function NNe(o, i) {
      return Wv(o.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
    }
    function FNe(o, i) {
      var t3 = NNe(o, i), c3 = o.get("center"), p3 = o.get("radius");
      Ei(p3) || (p3 = [0, p3]), Ei(c3) || (c3 = [c3, c3]);
      var g3 = Da(t3.width, i.getWidth()), b3 = Da(t3.height, i.getHeight()), w3 = Math.min(g3, b3), M = Da(c3[0], g3) + t3.x, I = Da(c3[1], b3) + t3.y, k3 = Da(p3[0], w3 / 2), L = Da(p3[1], w3 / 2);
      return { cx: M, cy: I, r0: k3, r: L };
    }
    function Y_t(o, i, t3) {
      i.eachSeriesByType(o, function(c3) {
        var p3 = c3.getData(), g3 = p3.mapDimension("value"), b3 = NNe(c3, t3), w3 = FNe(c3, t3), M = w3.cx, I = w3.cy, k3 = w3.r, L = w3.r0, F = -c3.get("startAngle") * RNe, B = c3.get("minAngle") * RNe, G = 0;
        p3.each(g3, function(nt) {
          !isNaN(nt) && G++;
        });
        var J = p3.getSum(g3), Q = Math.PI / (J || G) * 2, se = c3.get("clockwise"), he = c3.get("roseType"), be = c3.get("stillShowZeroSum"), de = p3.getDataExtent(g3);
        de[0] = 0;
        var Fe = lne, Pe = 0, ze = F, $e = se ? 1 : -1;
        if (p3.setLayout({ viewRect: b3, r: k3 }), p3.each(g3, function(nt, lt2) {
          var bt;
          if (isNaN(nt)) {
            p3.setItemLayout(lt2, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: se, cx: M, cy: I, r0: L, r: he ? NaN : k3 });
            return;
          }
          he !== "area" ? bt = J === 0 && be ? Q : nt * Q : bt = lne / G, bt < B ? (bt = B, Fe -= B) : Pe += nt;
          var vt = ze + $e * bt;
          p3.setItemLayout(lt2, { angle: bt, startAngle: ze, endAngle: vt, clockwise: se, cx: M, cy: I, r0: L, r: he ? Bc(nt, de, [L, k3]) : k3 }), ze = vt;
        }), Fe < lne && G)
          if (Fe <= 1e-3) {
            var Ke = lne / G;
            p3.each(g3, function(nt, lt2) {
              if (!isNaN(nt)) {
                var bt = p3.getItemLayout(lt2);
                bt.angle = Ke, bt.startAngle = F + $e * lt2 * Ke, bt.endAngle = F + $e * (lt2 + 1) * Ke;
              }
            });
          } else
            Q = Fe / Pe, ze = F, p3.each(g3, function(nt, lt2) {
              if (!isNaN(nt)) {
                var bt = p3.getItemLayout(lt2), vt = bt.angle === B ? B : nt * Q;
                bt.startAngle = ze, bt.endAngle = ze + $e * vt, ze += $e * vt;
              }
            });
      });
    }
    function cW(o) {
      return { seriesType: o, reset: function(i, t3) {
        var c3 = t3.findComponents({ mainType: "legend" });
        if (!(!c3 || !c3.length)) {
          var p3 = i.getData();
          p3.filterSelf(function(g3) {
            for (var b3 = p3.getName(g3), w3 = 0; w3 < c3.length; w3++)
              if (!c3[w3].isSelected(b3))
                return false;
            return true;
          });
        }
      } };
    }
    var K_t = Math.PI / 180;
    function VNe(o, i, t3, c3, p3, g3, b3, w3, M, I) {
      if (o.length < 2)
        return;
      function k3(J) {
        for (var Q = J.rB, se = Q * Q, he = 0; he < J.list.length; he++) {
          var be = J.list[he], de = Math.abs(be.label.y - t3), Fe = c3 + be.len, Pe = Fe * Fe, ze = Math.sqrt((1 - Math.abs(de * de / se)) * Pe), $e = i + (ze + be.len2) * p3, Ke = $e - be.label.x, nt = be.targetTextWidth - Ke * p3;
          BNe(be, nt, true), be.label.x = $e;
        }
      }
      function L(J) {
        for (var Q = { list: [], maxY: 0 }, se = { list: [], maxY: 0 }, he = 0; he < J.length; he++)
          if (J[he].labelAlignTo === "none") {
            var be = J[he], de = be.label.y > t3 ? se : Q, Fe = Math.abs(be.label.y - t3);
            if (Fe >= de.maxY) {
              var Pe = be.label.x - i - be.len2 * p3, ze = c3 + be.len, $e = Math.abs(Pe) < ze ? Math.sqrt(Fe * Fe / (1 - Pe * Pe / ze / ze)) : ze;
              de.rB = $e, de.maxY = Fe;
            }
            de.list.push(be);
          }
        k3(Q), k3(se);
      }
      for (var F = o.length, B = 0; B < F; B++)
        if (o[B].position === "outer" && o[B].labelAlignTo === "labelLine") {
          var G = o[B].label.x - I;
          o[B].linePoints[1][0] += G, o[B].label.x = I;
        }
      O6e(o, M, M + b3) && L(o);
    }
    function Z_t(o, i, t3, c3, p3, g3, b3, w3) {
      for (var M = [], I = [], k3 = Number.MAX_VALUE, L = -Number.MAX_VALUE, F = 0; F < o.length; F++) {
        var B = o[F].label;
        B0e(o[F]) || (B.x < i ? (k3 = Math.min(k3, B.x), M.push(o[F])) : (L = Math.max(L, B.x), I.push(o[F])));
      }
      for (var F = 0; F < o.length; F++) {
        var G = o[F];
        if (!B0e(G) && G.linePoints) {
          if (G.labelStyleWidth != null)
            continue;
          var B = G.label, J = G.linePoints, Q = void 0;
          G.labelAlignTo === "edge" ? B.x < i ? Q = J[2][0] - G.labelDistance - b3 - G.edgeDistance : Q = b3 + p3 - G.edgeDistance - J[2][0] - G.labelDistance : G.labelAlignTo === "labelLine" ? B.x < i ? Q = k3 - b3 - G.bleedMargin : Q = b3 + p3 - L - G.bleedMargin : B.x < i ? Q = B.x - b3 - G.bleedMargin : Q = b3 + p3 - B.x - G.bleedMargin, G.targetTextWidth = Q, BNe(G, Q);
        }
      }
      VNe(I, i, t3, c3, 1, p3, g3, b3, w3, L), VNe(M, i, t3, c3, -1, p3, g3, b3, w3, k3);
      for (var F = 0; F < o.length; F++) {
        var G = o[F];
        if (!B0e(G) && G.linePoints) {
          var B = G.label, J = G.linePoints, se = G.labelAlignTo === "edge", he = B.style.padding, be = he ? he[1] + he[3] : 0, de = B.style.backgroundColor ? 0 : be, Fe = G.rect.width + de, Pe = J[1][0] - J[2][0];
          se ? B.x < i ? J[2][0] = b3 + G.edgeDistance + Fe + G.labelDistance : J[2][0] = b3 + p3 - G.edgeDistance - Fe - G.labelDistance : (B.x < i ? J[2][0] = B.x + G.labelDistance : J[2][0] = B.x - G.labelDistance, J[1][0] = J[2][0] + Pe), J[1][1] = J[2][1] = B.y;
        }
      }
    }
    function BNe(o, i, t3) {
      if (t3 === void 0 && (t3 = false), o.labelStyleWidth == null) {
        var c3 = o.label, p3 = c3.style, g3 = o.rect, b3 = p3.backgroundColor, w3 = p3.padding, M = w3 ? w3[1] + w3[3] : 0, I = p3.overflow, k3 = g3.width + (b3 ? 0 : M);
        if (i < k3 || t3) {
          var L = g3.height;
          if (I && I.match("break")) {
            c3.setStyle("backgroundColor", null), c3.setStyle("width", i - M);
            var F = c3.getBoundingRect();
            c3.setStyle("width", Math.ceil(F.width)), c3.setStyle("backgroundColor", b3);
          } else {
            var B = i - M, G = i < k3 ? B : t3 ? B > o.unconstrainedWidth ? null : B : null;
            c3.setStyle("width", G);
          }
          var J = c3.getBoundingRect();
          g3.width = J.width;
          var Q = (c3.style.margin || 0) + 2.1;
          g3.height = J.height + Q, g3.y -= (g3.height - L) / 2;
        }
      }
    }
    function B0e(o) {
      return o.position === "center";
    }
    function J_t(o) {
      var i = o.getData(), t3 = [], c3, p3, g3 = false, b3 = (o.get("minShowLabelAngle") || 0) * K_t, w3 = i.getLayout("viewRect"), M = i.getLayout("r"), I = w3.width, k3 = w3.x, L = w3.y, F = w3.height;
      function B(Pe) {
        Pe.ignore = true;
      }
      function G(Pe) {
        if (!Pe.ignore)
          return true;
        for (var ze in Pe.states)
          if (Pe.states[ze].ignore === false)
            return true;
        return false;
      }
      i.each(function(Pe) {
        var ze = i.getItemGraphicEl(Pe), $e = ze.shape, Ke = ze.getTextContent(), nt = ze.getTextGuideLine(), lt2 = i.getItemModel(Pe), bt = lt2.getModel("label"), vt = bt.get("position") || lt2.get(["emphasis", "label", "position"]), jt = bt.get("distanceToLabelLine"), Jt = bt.get("alignTo"), Rt = Da(bt.get("edgeDistance"), I), Jn = bt.get("bleedMargin"), ln = lt2.getModel("labelLine"), vn = ln.get("length");
        vn = Da(vn, I);
        var kn = ln.get("length2");
        if (kn = Da(kn, I), Math.abs($e.endAngle - $e.startAngle) < b3) {
          yt(Ke.states, B), Ke.ignore = true;
          return;
        }
        if (G(Ke)) {
          var cr = ($e.startAngle + $e.endAngle) / 2, gr = Math.cos(cr), ha = Math.sin(cr), Ka, Do, _o, xo;
          c3 = $e.cx, p3 = $e.cy;
          var Ra = vt === "inside" || vt === "inner";
          if (vt === "center")
            Ka = $e.cx, Do = $e.cy, xo = "center";
          else {
            var ho = (Ra ? ($e.r + $e.r0) / 2 * gr : $e.r * gr) + c3, Mo = (Ra ? ($e.r + $e.r0) / 2 * ha : $e.r * ha) + p3;
            if (Ka = ho + gr * 3, Do = Mo + ha * 3, !Ra) {
              var Xa = ho + gr * (vn + M - $e.r), Zo = Mo + ha * (vn + M - $e.r), rc = Xa + (gr < 0 ? -1 : 1) * kn, ys = Zo;
              Jt === "edge" ? Ka = gr < 0 ? k3 + Rt : k3 + I - Rt : Ka = rc + (gr < 0 ? -jt : jt), Do = ys, _o = [[ho, Mo], [Xa, Zo], [rc, ys]];
            }
            xo = Ra ? "center" : Jt === "edge" ? gr > 0 ? "right" : "left" : gr > 0 ? "left" : "right";
          }
          var Vu = Math.PI, gc = 0, ef = bt.get("rotate");
          if (ec(ef))
            gc = ef * (Vu / 180);
          else if (vt === "center")
            gc = 0;
          else if (ef === "radial" || ef === true) {
            var dv = gr < 0 ? -cr + Vu : -cr;
            gc = dv;
          } else if (ef === "tangential" && vt !== "outside" && vt !== "outer") {
            var Wf = Math.atan2(gr, ha);
            Wf < 0 && (Wf = Vu * 2 + Wf);
            var Ag = ha > 0;
            Ag && (Wf = Vu + Wf), gc = Wf - Vu;
          }
          if (g3 = !!gc, Ke.x = Ka, Ke.y = Do, Ke.rotation = gc, Ke.setStyle({ verticalAlign: "middle" }), Ra) {
            Ke.setStyle({ align: xo });
            var eh = Ke.states.select;
            eh && (eh.x += Ke.x, eh.y += Ke.y);
          } else {
            var _p = Ke.getBoundingRect().clone();
            _p.applyTransform(Ke.getComputedTransform());
            var ap = (Ke.style.margin || 0) + 2.1;
            _p.y -= ap / 2, _p.height += ap, t3.push({ label: Ke, labelLine: nt, position: vt, len: vn, len2: kn, minTurnAngle: ln.get("minTurnAngle"), maxSurfaceAngle: ln.get("maxSurfaceAngle"), surfaceNormal: new Bs(gr, ha), linePoints: _o, textAlign: xo, labelDistance: jt, labelAlignTo: Jt, edgeDistance: Rt, bleedMargin: Jn, rect: _p, unconstrainedWidth: _p.width, labelStyleWidth: Ke.style.width });
          }
          ze.setTextConfig({ inside: Ra });
        }
      }), !g3 && o.get("avoidLabelOverlap") && Z_t(t3, c3, p3, M, I, F, k3, L);
      for (var J = 0; J < t3.length; J++) {
        var Q = t3[J], se = Q.label, he = Q.labelLine, be = isNaN(se.x) || isNaN(se.y);
        if (se) {
          se.setStyle({ align: Q.textAlign }), be && (yt(se.states, B), se.ignore = true);
          var de = se.states.select;
          de && (de.x += se.x, de.y += se.y);
        }
        if (he) {
          var Fe = Q.linePoints;
          be || !Fe ? (yt(he.states, B), he.ignore = true) : (I6e(Fe, Q.minTurnAngle), cbt(Fe, Q.surfaceNormal, Q.maxSurfaceAngle), he.setShape({ points: Fe }), se.__hostTarget.textGuideLineConfig = { anchor: new Bs(Fe[0][0], Fe[0][1]) });
        }
      }
    }
    function R8(o, i, t3) {
      var c3 = o.get("borderRadius");
      if (c3 == null)
        return t3 ? { cornerRadius: 0 } : null;
      Ei(c3) || (c3 = [c3, c3, c3, c3]);
      var p3 = Math.abs(i.r || 0 - i.r0 || 0);
      return { cornerRadius: Fi(c3, function(g3) {
        return zv(g3, p3);
      }) };
    }
    var Q_t = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this) || this;
        g3.z2 = 2;
        var b3 = new Fl();
        return g3.setTextContent(b3), g3.updateData(t3, c3, p3, true), g3;
      }
      return i.prototype.updateData = function(t3, c3, p3, g3) {
        var b3 = this, w3 = t3.hostModel, M = t3.getItemModel(c3), I = M.getModel("emphasis"), k3 = t3.getItemLayout(c3), L = ti(R8(M.getModel("itemStyle"), k3, true), k3);
        if (isNaN(L.startAngle)) {
          b3.setShape(L);
          return;
        }
        if (g3) {
          b3.setShape(L);
          var F = w3.getShallow("animationType");
          w3.ecModel.ssr ? (Uh(b3, { scaleX: 0, scaleY: 0 }, w3, { dataIndex: c3, isFrom: true }), b3.originX = L.cx, b3.originY = L.cy) : F === "scale" ? (b3.shape.r = k3.r0, Uh(b3, { shape: { r: k3.r } }, w3, c3)) : p3 != null ? (b3.setShape({ startAngle: p3, endAngle: p3 }), Uh(b3, { shape: { startAngle: k3.startAngle, endAngle: k3.endAngle } }, w3, c3)) : (b3.shape.endAngle = k3.startAngle, Du(b3, { shape: { endAngle: k3.endAngle } }, w3, c3));
        } else
          P_(b3), Du(b3, { shape: L }, w3, c3);
        b3.useStyle(t3.getItemVisual(c3, "style")), cv(b3, M);
        var B = (k3.startAngle + k3.endAngle) / 2, G = w3.get("selectedOffset"), J = Math.cos(B) * G, Q = Math.sin(B) * G, se = M.getShallow("cursor");
        se && b3.attr("cursor", se), this._updateLabel(w3, t3, c3), b3.ensureState("emphasis").shape = ti({ r: k3.r + (I.get("scale") && I.get("scaleSize") || 0) }, R8(I.getModel("itemStyle"), k3)), ti(b3.ensureState("select"), { x: J, y: Q, shape: R8(M.getModel(["select", "itemStyle"]), k3) }), ti(b3.ensureState("blur"), { shape: R8(M.getModel(["blur", "itemStyle"]), k3) });
        var he = b3.getTextGuideLine(), be = b3.getTextContent();
        he && ti(he.ensureState("select"), { x: J, y: Q }), ti(be.ensureState("select"), { x: J, y: Q }), zp(this, I.get("focus"), I.get("blurScope"), I.get("disabled"));
      }, i.prototype._updateLabel = function(t3, c3, p3) {
        var g3 = this, b3 = c3.getItemModel(p3), w3 = b3.getModel("labelLine"), M = c3.getItemVisual(p3, "style"), I = M && M.fill, k3 = M && M.opacity;
        Sm(g3, g0(b3), { labelFetcher: c3.hostModel, labelDataIndex: p3, inheritColor: I, defaultOpacity: k3, defaultText: t3.getFormattedLabel(p3, "normal") || c3.getName(p3) });
        var L = g3.getTextContent();
        g3.setTextConfig({ position: null, rotation: null }), L.attr({ z2: 10 });
        var F = t3.get(["label", "position"]);
        if (F !== "outside" && F !== "outer")
          g3.removeTextGuideLine();
        else {
          var B = this.getTextGuideLine();
          B || (B = new xm(), this.setTextGuideLine(B)), b0e(this, _0e(b3), { stroke: I, opacity: np(w3.get(["lineStyle", "opacity"]), k3, 1) });
        }
      }, i;
    }(bm), ext = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.ignoreLabelLineUpdate = true, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        var b3 = t3.getData(), w3 = this._data, M = this.group, I;
        if (!w3 && b3.count() > 0) {
          for (var k3 = b3.getItemLayout(0), L = 1; isNaN(k3 && k3.startAngle) && L < b3.count(); ++L)
            k3 = b3.getItemLayout(L);
          k3 && (I = k3.startAngle);
        }
        if (this._emptyCircleSector && M.remove(this._emptyCircleSector), b3.count() === 0 && t3.get("showEmptyCircle")) {
          var F = new bm({ shape: FNe(t3, p3) });
          F.useStyle(t3.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = F, M.add(F);
        }
        b3.diff(w3).add(function(B) {
          var G = new Q_t(b3, B, I);
          b3.setItemGraphicEl(B, G), M.add(G);
        }).update(function(B, G) {
          var J = w3.getItemGraphicEl(G);
          J.updateData(b3, B, I), J.off("click"), M.add(J), b3.setItemGraphicEl(B, J);
        }).remove(function(B) {
          var G = w3.getItemGraphicEl(B);
          QP(G, t3, B);
        }).execute(), J_t(t3), t3.get("animationTypeUpdate") !== "expansion" && (this._data = b3);
      }, i.prototype.dispose = function() {
      }, i.prototype.containPoint = function(t3, c3) {
        var p3 = c3.getData(), g3 = p3.getItemLayout(0);
        if (g3) {
          var b3 = t3[0] - g3.cx, w3 = t3[1] - g3.cy, M = Math.sqrt(b3 * b3 + w3 * w3);
          return M <= g3.r && M >= g3.r0;
        }
      }, i.type = "pie", i;
    }(yh), txt = ext;
    function N8(o, i, t3) {
      i = Ei(i) && { coordDimensions: i } || ti({ encodeDefine: o.getEncode() }, i);
      var c3 = o.getSource(), p3 = ZH(c3, i).dimensions, g3 = new V1(p3, o);
      return g3.initData(c3, t3), g3;
    }
    var nxt = function() {
      function o(i, t3) {
        this._getDataWithEncodedVisual = i, this._getRawData = t3;
      }
      return o.prototype.getAllNames = function() {
        var i = this._getRawData();
        return i.mapArray(i.getName);
      }, o.prototype.containName = function(i) {
        var t3 = this._getRawData();
        return t3.indexOfName(i) >= 0;
      }, o.prototype.indexOfName = function(i) {
        var t3 = this._getDataWithEncodedVisual();
        return t3.indexOfName(i);
      }, o.prototype.getItemVisual = function(i, t3) {
        var c3 = this._getDataWithEncodedVisual();
        return c3.getItemVisual(i, t3);
      }, o;
    }(), fW = nxt, rxt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.init = function(t3) {
        o.prototype.init.apply(this, arguments), this.legendVisualProvider = new fW(Qa(this.getData, this), Qa(this.getRawData, this)), this._defaultLabelLine(t3);
      }, i.prototype.mergeOption = function() {
        o.prototype.mergeOption.apply(this, arguments);
      }, i.prototype.getInitialData = function() {
        return N8(this, { coordDimensions: ["value"], encodeDefaulter: As(pge, this) });
      }, i.prototype.getDataParams = function(t3) {
        var c3 = this.getData(), p3 = o.prototype.getDataParams.call(this, t3), g3 = [];
        return c3.each(c3.mapDimension("value"), function(b3) {
          g3.push(b3);
        }), p3.percent = WQ(g3, t3, c3.hostModel.get("percentPrecision")), p3.$vars.push("percent"), p3;
      }, i.prototype._defaultLabelLine = function(t3) {
        O1(t3, "labelLine", ["show"]);
        var c3 = t3.labelLine, p3 = t3.emphasis.labelLine;
        c3.show = c3.show && t3.label.show, p3.show = p3.show && t3.emphasis.label.show;
      }, i.type = "series.pie", i.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, i;
    }(bp), ixt = rxt;
    function axt(o) {
      return { seriesType: o, reset: function(i, t3) {
        var c3 = i.getData();
        c3.filterSelf(function(p3) {
          var g3 = c3.mapDimension("value"), b3 = c3.get(g3, p3);
          return !(ec(b3) && !isNaN(b3) && b3 < 0);
        });
      } };
    }
    function oxt(o) {
      o.registerChartView(txt), o.registerSeriesModel(ixt), WRe("pie", o.registerAction), o.registerLayout(As(Y_t, "pie")), o.registerProcessor(cW("pie")), o.registerProcessor(axt("pie"));
    }
    var sxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.hasSymbolVisual = true, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        return NI(null, this, { useEncodeDefaulter: true });
      }, i.prototype.getProgressive = function() {
        var t3 = this.option.progressive;
        return t3 == null ? this.option.large ? 5e3 : this.get("progressive") : t3;
      }, i.prototype.getProgressiveThreshold = function() {
        var t3 = this.option.progressiveThreshold;
        return t3 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : t3;
      }, i.prototype.brushSelector = function(t3, c3, p3) {
        return p3.point(c3.getItemLayout(t3));
      }, i.prototype.getZLevelKey = function() {
        return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
      }, i.type = "series.scatter", i.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, i;
    }(bp), lxt = sxt, zNe = 4, uxt = function() {
      function o() {
      }
      return o;
    }(), cxt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3._off = 0, c3.hoverDataIdx = -1, c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new uxt();
      }, i.prototype.reset = function() {
        this.notClear = false, this._off = 0;
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.points, g3 = c3.size, b3 = this.symbolProxy, w3 = b3.shape, M = t3.getContext ? t3.getContext() : t3, I = M && g3[0] < zNe, k3 = this.softClipShape, L;
        if (I) {
          this._ctx = M;
          return;
        }
        for (this._ctx = null, L = this._off; L < p3.length; ) {
          var F = p3[L++], B = p3[L++];
          isNaN(F) || isNaN(B) || k3 && !k3.contain(F, B) || (w3.x = F - g3[0] / 2, w3.y = B - g3[1] / 2, w3.width = g3[0], w3.height = g3[1], b3.buildPath(t3, w3, true));
        }
        this.incremental && (this._off = L, this.notClear = true);
      }, i.prototype.afterBrush = function() {
        var t3 = this.shape, c3 = t3.points, p3 = t3.size, g3 = this._ctx, b3 = this.softClipShape, w3;
        if (g3) {
          for (w3 = this._off; w3 < c3.length; ) {
            var M = c3[w3++], I = c3[w3++];
            isNaN(M) || isNaN(I) || b3 && !b3.contain(M, I) || g3.fillRect(M - p3[0] / 2, I - p3[1] / 2, p3[0], p3[1]);
          }
          this.incremental && (this._off = w3, this.notClear = true);
        }
      }, i.prototype.findDataIndex = function(t3, c3) {
        for (var p3 = this.shape, g3 = p3.points, b3 = p3.size, w3 = Math.max(b3[0], 4), M = Math.max(b3[1], 4), I = g3.length / 2 - 1; I >= 0; I--) {
          var k3 = I * 2, L = g3[k3] - w3 / 2, F = g3[k3 + 1] - M / 2;
          if (t3 >= L && c3 >= F && t3 <= L + w3 && c3 <= F + M)
            return I;
        }
        return -1;
      }, i.prototype.contain = function(t3, c3) {
        var p3 = this.transformCoordToLocal(t3, c3), g3 = this.getBoundingRect();
        if (t3 = p3[0], c3 = p3[1], g3.contain(t3, c3)) {
          var b3 = this.hoverDataIdx = this.findDataIndex(t3, c3);
          return b3 >= 0;
        }
        return this.hoverDataIdx = -1, false;
      }, i.prototype.getBoundingRect = function() {
        var t3 = this._rect;
        if (!t3) {
          for (var c3 = this.shape, p3 = c3.points, g3 = c3.size, b3 = g3[0], w3 = g3[1], M = 1 / 0, I = 1 / 0, k3 = -1 / 0, L = -1 / 0, F = 0; F < p3.length; ) {
            var B = p3[F++], G = p3[F++];
            M = Math.min(B, M), k3 = Math.max(B, k3), I = Math.min(G, I), L = Math.max(G, L);
          }
          t3 = this._rect = new Ys(M - b3 / 2, I - w3 / 2, k3 - M + b3, L - I + w3);
        }
        return t3;
      }, i;
    }(gl), fxt = function() {
      function o() {
        this.group = new vs();
      }
      return o.prototype.updateData = function(i, t3) {
        this._clear();
        var c3 = this._create();
        c3.setShape({ points: i.getLayout("points") }), this._setCommon(c3, i, t3);
      }, o.prototype.updateLayout = function(i) {
        var t3 = i.getLayout("points");
        this.group.eachChild(function(c3) {
          if (c3.startIndex != null) {
            var p3 = (c3.endIndex - c3.startIndex) * 2, g3 = c3.startIndex * 4 * 2;
            t3 = new Float32Array(t3.buffer, g3, p3);
          }
          c3.setShape("points", t3), c3.reset();
        });
      }, o.prototype.incrementalPrepareUpdate = function(i) {
        this._clear();
      }, o.prototype.incrementalUpdate = function(i, t3, c3) {
        var p3 = this._newAdded[0], g3 = t3.getLayout("points"), b3 = p3 && p3.shape.points;
        if (b3 && b3.length < 2e4) {
          var w3 = b3.length, M = new Float32Array(w3 + g3.length);
          M.set(b3), M.set(g3, w3), p3.endIndex = i.end, p3.setShape({ points: M });
        } else {
          this._newAdded = [];
          var I = this._create();
          I.startIndex = i.start, I.endIndex = i.end, I.incremental = true, I.setShape({ points: g3 }), this._setCommon(I, t3, c3);
        }
      }, o.prototype.eachRendered = function(i) {
        this._newAdded[0] && i(this._newAdded[0]);
      }, o.prototype._create = function() {
        var i = new cxt({ cursor: "default" });
        return this.group.add(i), this._newAdded.push(i), i;
      }, o.prototype._setCommon = function(i, t3, c3) {
        var p3 = t3.hostModel;
        c3 = c3 || {};
        var g3 = t3.getVisual("symbolSize");
        i.setShape("size", g3 instanceof Array ? g3 : [g3, g3]), i.softClipShape = c3.clipShape || null, i.symbolProxy = pv(t3.getVisual("symbol"), 0, 0, 0, 0), i.setColor = i.symbolProxy.setColor;
        var b3 = i.shape.size[0] < zNe;
        i.useStyle(p3.getModel("itemStyle").getItemStyle(b3 ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
        var w3 = t3.getVisual("style"), M = w3 && w3.fill;
        M && i.setColor(M);
        var I = La(i);
        I.seriesIndex = p3.seriesIndex, i.on("mousemove", function(k3) {
          I.dataIndex = null;
          var L = i.hoverDataIdx;
          L >= 0 && (I.dataIndex = L + (i.startIndex || 0));
        });
      }, o.prototype.remove = function() {
        this._clear();
      }, o.prototype._clear = function() {
        this._newAdded = [], this.group.removeAll();
      }, o;
    }(), hxt = fxt, pxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this._updateSymbolDraw(g3, t3);
        b3.updateData(g3, { clipShape: this._getClipShape(t3) }), this._finished = true;
      }, i.prototype.incrementalPrepareRender = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this._updateSymbolDraw(g3, t3);
        b3.incrementalPrepareUpdate(g3), this._finished = false;
      }, i.prototype.incrementalRender = function(t3, c3, p3) {
        this._symbolDraw.incrementalUpdate(t3, c3.getData(), { clipShape: this._getClipShape(c3) }), this._finished = t3.end === c3.getData().count();
      }, i.prototype.updateTransform = function(t3, c3, p3) {
        var g3 = t3.getData();
        if (this.group.dirty(), !this._finished || g3.count() > 1e4)
          return { update: true };
        var b3 = uW("").reset(t3, c3, p3);
        b3.progress && b3.progress({ start: 0, end: g3.count(), count: g3.count() }, g3), this._symbolDraw.updateLayout(g3);
      }, i.prototype.eachRendered = function(t3) {
        this._symbolDraw && this._symbolDraw.eachRendered(t3);
      }, i.prototype._getClipShape = function(t3) {
        var c3 = t3.coordinateSystem, p3 = c3 && c3.getArea && c3.getArea();
        return t3.get("clip", true) ? p3 : null;
      }, i.prototype._updateSymbolDraw = function(t3, c3) {
        var p3 = this._symbolDraw, g3 = c3.pipelineContext, b3 = g3.large;
        return (!p3 || b3 !== this._isLargeDraw) && (p3 && p3.remove(), p3 = this._symbolDraw = b3 ? new hxt() : new lW(), this._isLargeDraw = b3, this.group.removeAll()), this.group.add(p3.group), p3;
      }, i.prototype.remove = function(t3, c3) {
        this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
      }, i.prototype.dispose = function() {
      }, i.type = "scatter", i;
    }(yh), dxt = pxt, vxt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.type = "grid", i.dependencies = ["xAxis", "yAxis"], i.layoutMode = "box", i.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, i;
    }(nc), gxt = vxt, z0e = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.getCoordSysModel = function() {
        return this.getReferringComponents("grid", xd).models[0];
      }, i.type = "cartesian2dAxis", i;
    }(nc);
    Kp(z0e, eW);
    var jNe = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, yxt = Es({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, jNe), j0e = Es({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, jNe), mxt = Es({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, j0e), bxt = Uo({ logBase: 10 }, j0e), GNe = { category: yxt, value: j0e, time: mxt, log: bxt }, _xt = { value: 1, category: 1, time: 1, log: 1 };
    function F8(o, i, t3, c3) {
      yt(_xt, function(p3, g3) {
        var b3 = Es(Es({}, GNe[g3], true), c3, true), w3 = function(M) {
          cn(I, M);
          function I() {
            var k3 = M !== null && M.apply(this, arguments) || this;
            return k3.type = i + "Axis." + g3, k3;
          }
          return I.prototype.mergeDefaultAndTheme = function(k3, L) {
            var F = IH(this), B = F ? m8(k3) : {}, G = L.getTheme();
            Es(k3, G.get(g3 + "Axis")), Es(k3, this.getDefaultOption()), k3.type = HNe(k3), F && ik(k3, B, F);
          }, I.prototype.optionUpdated = function() {
            var k3 = this.option;
            k3.type === "category" && (this.__ordinalMeta = s0e.createByAxisModel(this));
          }, I.prototype.getCategories = function(k3) {
            var L = this.option;
            if (L.type === "category")
              return k3 ? L.data : this.__ordinalMeta.categories;
          }, I.prototype.getOrdinalMeta = function() {
            return this.__ordinalMeta;
          }, I.type = i + "Axis." + g3, I.defaultOption = b3, I;
        }(t3);
        o.registerComponentModel(w3);
      }), o.registerSubTypeDefaulter(i + "Axis", HNe);
    }
    function HNe(o) {
      return o.type || (o.data ? "category" : "value");
    }
    var xxt = function() {
      function o(i) {
        this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = i || "";
      }
      return o.prototype.getAxis = function(i) {
        return this._axes[i];
      }, o.prototype.getAxes = function() {
        return Fi(this._dimList, function(i) {
          return this._axes[i];
        }, this);
      }, o.prototype.getAxesByScale = function(i) {
        return i = i.toLowerCase(), Zc(this.getAxes(), function(t3) {
          return t3.scale.type === i;
        });
      }, o.prototype.addAxis = function(i) {
        var t3 = i.dim;
        this._axes[t3] = i, this._dimList.push(t3);
      }, o;
    }(), wxt = xxt, G0e = ["x", "y"];
    function WNe(o) {
      return o.type === "interval" || o.type === "time";
    }
    var Sxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "cartesian2d", t3.dimensions = G0e, t3;
      }
      return i.prototype.calcAffineTransform = function() {
        this._transform = this._invTransform = null;
        var t3 = this.getAxis("x").scale, c3 = this.getAxis("y").scale;
        if (!(!WNe(t3) || !WNe(c3))) {
          var p3 = t3.getExtent(), g3 = c3.getExtent(), b3 = this.dataToPoint([p3[0], g3[0]]), w3 = this.dataToPoint([p3[1], g3[1]]), M = p3[1] - p3[0], I = g3[1] - g3[0];
          if (!(!M || !I)) {
            var k3 = (w3[0] - b3[0]) / M, L = (w3[1] - b3[1]) / I, F = b3[0] - p3[0] * k3, B = b3[1] - g3[0] * L, G = this._transform = [k3, 0, 0, L, F, B];
            this._invTransform = fI([], G);
          }
        }
      }, i.prototype.getBaseAxis = function() {
        return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
      }, i.prototype.containPoint = function(t3) {
        var c3 = this.getAxis("x"), p3 = this.getAxis("y");
        return c3.contain(c3.toLocalCoord(t3[0])) && p3.contain(p3.toLocalCoord(t3[1]));
      }, i.prototype.containData = function(t3) {
        return this.getAxis("x").containData(t3[0]) && this.getAxis("y").containData(t3[1]);
      }, i.prototype.dataToPoint = function(t3, c3, p3) {
        p3 = p3 || [];
        var g3 = t3[0], b3 = t3[1];
        if (this._transform && g3 != null && isFinite(g3) && b3 != null && isFinite(b3))
          return Vv(p3, t3, this._transform);
        var w3 = this.getAxis("x"), M = this.getAxis("y");
        return p3[0] = w3.toGlobalCoord(w3.dataToCoord(g3, c3)), p3[1] = M.toGlobalCoord(M.dataToCoord(b3, c3)), p3;
      }, i.prototype.clampData = function(t3, c3) {
        var p3 = this.getAxis("x").scale, g3 = this.getAxis("y").scale, b3 = p3.getExtent(), w3 = g3.getExtent(), M = p3.parse(t3[0]), I = g3.parse(t3[1]);
        return c3 = c3 || [], c3[0] = Math.min(Math.max(Math.min(b3[0], b3[1]), M), Math.max(b3[0], b3[1])), c3[1] = Math.min(Math.max(Math.min(w3[0], w3[1]), I), Math.max(w3[0], w3[1])), c3;
      }, i.prototype.pointToData = function(t3, c3) {
        var p3 = [];
        if (this._invTransform)
          return Vv(p3, t3, this._invTransform);
        var g3 = this.getAxis("x"), b3 = this.getAxis("y");
        return p3[0] = g3.coordToData(g3.toLocalCoord(t3[0]), c3), p3[1] = b3.coordToData(b3.toLocalCoord(t3[1]), c3), p3;
      }, i.prototype.getOtherAxis = function(t3) {
        return this.getAxis(t3.dim === "x" ? "y" : "x");
      }, i.prototype.getArea = function() {
        var t3 = this.getAxis("x").getGlobalExtent(), c3 = this.getAxis("y").getGlobalExtent(), p3 = Math.min(t3[0], t3[1]), g3 = Math.min(c3[0], c3[1]), b3 = Math.max(t3[0], t3[1]) - p3, w3 = Math.max(c3[0], c3[1]) - g3;
        return new Ys(p3, g3, b3, w3);
      }, i;
    }(wxt), Cxt = Sxt, Mxt = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3, b3) {
        var w3 = o.call(this, t3, c3, p3) || this;
        return w3.index = 0, w3.type = g3 || "value", w3.position = b3 || "bottom", w3;
      }
      return i.prototype.isHorizontal = function() {
        var t3 = this.position;
        return t3 === "top" || t3 === "bottom";
      }, i.prototype.getGlobalExtent = function(t3) {
        var c3 = this.getExtent();
        return c3[0] = this.toGlobalCoord(c3[0]), c3[1] = this.toGlobalCoord(c3[1]), t3 && c3[0] > c3[1] && c3.reverse(), c3;
      }, i.prototype.pointToData = function(t3, c3) {
        return this.coordToData(this.toLocalCoord(t3[this.dim === "x" ? 0 : 1]), c3);
      }, i.prototype.setCategorySortInfo = function(t3) {
        if (this.type !== "category")
          return false;
        this.model.option.categorySortInfo = t3, this.scale.setSortInfo(t3);
      }, i;
    }(Y2), Txt = Mxt;
    function H0e(o, i, t3) {
      t3 = t3 || {};
      var c3 = o.coordinateSystem, p3 = i.axis, g3 = {}, b3 = p3.getAxesOnZeroOf()[0], w3 = p3.position, M = b3 ? "onZero" : w3, I = p3.dim, k3 = c3.getRect(), L = [k3.x, k3.x + k3.width, k3.y, k3.y + k3.height], F = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, B = i.get("offset") || 0, G = I === "x" ? [L[2] - B, L[3] + B] : [L[0] - B, L[1] + B];
      if (b3) {
        var J = b3.toGlobalCoord(b3.dataToCoord(0));
        G[F.onZero] = Math.max(Math.min(J, G[1]), G[0]);
      }
      g3.position = [I === "y" ? G[F[M]] : L[0], I === "x" ? G[F[M]] : L[3]], g3.rotation = Math.PI / 2 * (I === "x" ? 0 : 1);
      var Q = { top: -1, bottom: 1, left: -1, right: 1 };
      g3.labelDirection = g3.tickDirection = g3.nameDirection = Q[w3], g3.labelOffset = b3 ? G[F[w3]] - G[F.onZero] : 0, i.get(["axisTick", "inside"]) && (g3.tickDirection = -g3.tickDirection), lv(t3.labelInside, i.get(["axisLabel", "inside"])) && (g3.labelDirection = -g3.labelDirection);
      var se = i.get(["axisLabel", "rotate"]);
      return g3.labelRotate = M === "top" ? -se : se, g3.z2 = 1, g3;
    }
    function UNe(o) {
      return o.get("coordinateSystem") === "cartesian2d";
    }
    function qNe(o) {
      var i = { xAxisModel: null, yAxisModel: null };
      return yt(i, function(t3, c3) {
        var p3 = c3.replace(/Model$/, ""), g3 = o.getReferringComponents(p3, xd).models[0];
        i[c3] = g3;
      }), i;
    }
    var W0e = Math.log;
    function $Ne(o, i, t3) {
      var c3 = fk.prototype, p3 = c3.getTicks.call(t3), g3 = c3.getTicks.call(t3, true), b3 = p3.length - 1, w3 = c3.getInterval.call(t3), M = u6e(o, i), I = M.extent, k3 = M.fixMin, L = M.fixMax;
      if (o.type === "log") {
        var F = W0e(o.base);
        I = [W0e(I[0]) / F, W0e(I[1]) / F];
      }
      o.setExtent(I[0], I[1]), o.calcNiceExtent({ splitNumber: b3, fixMin: k3, fixMax: L });
      var B = c3.getExtent.call(o);
      k3 && (I[0] = B[0]), L && (I[1] = B[1]);
      var G = c3.getInterval.call(o), J = I[0], Q = I[1];
      if (k3 && L)
        G = (Q - J) / b3;
      else if (k3)
        for (Q = I[0] + G * b3; Q < I[1] && isFinite(Q) && isFinite(I[1]); )
          G = u0e(G), Q = I[0] + G * b3;
      else if (L)
        for (J = I[1] - G * b3; J > I[0] && isFinite(J) && isFinite(I[0]); )
          G = u0e(G), J = I[1] - G * b3;
      else {
        var se = o.getTicks().length - 1;
        se > b3 && (G = u0e(G));
        var he = G * b3;
        Q = Math.ceil(I[1] / G) * G, J = mp(Q - he), J < 0 && I[0] >= 0 ? (J = 0, Q = mp(he)) : Q > 0 && I[1] <= 0 && (Q = 0, J = -mp(he));
      }
      var be = (p3[0].value - g3[0].value) / w3, de = (p3[b3].value - g3[b3].value) / w3;
      c3.setExtent.call(o, J + G * be, Q + G * de), c3.setInterval.call(o, G), (be || de) && c3.setNiceExtent.call(o, J + G, Q - G);
    }
    var Axt = function() {
      function o(i, t3, c3) {
        this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = G0e, this._initCartesian(i, t3, c3), this.model = i;
      }
      return o.prototype.getRect = function() {
        return this._rect;
      }, o.prototype.update = function(i, t3) {
        var c3 = this._axesMap;
        this._updateScale(i, this.model);
        function p3(b3) {
          var w3, M = Gl(b3), I = M.length;
          if (I) {
            for (var k3 = [], L = I - 1; L >= 0; L--) {
              var F = +M[L], B = b3[F], G = B.model, J = B.scale;
              l0e(J) && G.get("alignTicks") && G.get("interval") == null ? k3.push(B) : (O8(J, G), l0e(J) && (w3 = B));
            }
            k3.length && (w3 || (w3 = k3.pop(), O8(w3.scale, w3.model)), yt(k3, function(Q) {
              $Ne(Q.scale, Q.model, w3.scale);
            }));
          }
        }
        p3(c3.x), p3(c3.y);
        var g3 = {};
        yt(c3.x, function(b3) {
          XNe(c3, "y", b3, g3);
        }), yt(c3.y, function(b3) {
          XNe(c3, "x", b3, g3);
        }), this.resize(this.model, t3);
      }, o.prototype.resize = function(i, t3, c3) {
        var p3 = i.getBoxLayoutParams(), g3 = !c3 && i.get("containLabel"), b3 = Wv(p3, { width: t3.getWidth(), height: t3.getHeight() });
        this._rect = b3;
        var w3 = this._axesList;
        M(), g3 && (yt(w3, function(I) {
          if (!I.model.get(["axisLabel", "inside"])) {
            var k3 = z1t(I);
            if (k3) {
              var L = I.isHorizontal() ? "height" : "width", F = I.model.get(["axisLabel", "margin"]);
              b3[L] -= k3[L] + F, I.position === "top" ? b3.y += k3.height + F : I.position === "left" && (b3.x += k3.width + F);
            }
          }
        }), M()), yt(this._coordsList, function(I) {
          I.calcAffineTransform();
        });
        function M() {
          yt(w3, function(I) {
            var k3 = I.isHorizontal(), L = k3 ? [0, b3.width] : [0, b3.height], F = I.inverse ? 1 : 0;
            I.setExtent(L[F], L[1 - F]), Ixt(I, k3 ? b3.x : b3.y);
          });
        }
      }, o.prototype.getAxis = function(i, t3) {
        var c3 = this._axesMap[i];
        if (c3 != null)
          return c3[t3 || 0];
      }, o.prototype.getAxes = function() {
        return this._axesList.slice();
      }, o.prototype.getCartesian = function(i, t3) {
        if (i != null && t3 != null) {
          var c3 = "x" + i + "y" + t3;
          return this._coordsMap[c3];
        }
        Ua(i) && (t3 = i.yAxisIndex, i = i.xAxisIndex);
        for (var p3 = 0, g3 = this._coordsList; p3 < g3.length; p3++)
          if (g3[p3].getAxis("x").index === i || g3[p3].getAxis("y").index === t3)
            return g3[p3];
      }, o.prototype.getCartesians = function() {
        return this._coordsList.slice();
      }, o.prototype.convertToPixel = function(i, t3, c3) {
        var p3 = this._findConvertTarget(t3);
        return p3.cartesian ? p3.cartesian.dataToPoint(c3) : p3.axis ? p3.axis.toGlobalCoord(p3.axis.dataToCoord(c3)) : null;
      }, o.prototype.convertFromPixel = function(i, t3, c3) {
        var p3 = this._findConvertTarget(t3);
        return p3.cartesian ? p3.cartesian.pointToData(c3) : p3.axis ? p3.axis.coordToData(p3.axis.toLocalCoord(c3)) : null;
      }, o.prototype._findConvertTarget = function(i) {
        var t3 = i.seriesModel, c3 = i.xAxisModel || t3 && t3.getReferringComponents("xAxis", xd).models[0], p3 = i.yAxisModel || t3 && t3.getReferringComponents("yAxis", xd).models[0], g3 = i.gridModel, b3 = this._coordsList, w3, M;
        if (t3)
          w3 = t3.coordinateSystem, rl(b3, w3) < 0 && (w3 = null);
        else if (c3 && p3)
          w3 = this.getCartesian(c3.componentIndex, p3.componentIndex);
        else if (c3)
          M = this.getAxis("x", c3.componentIndex);
        else if (p3)
          M = this.getAxis("y", p3.componentIndex);
        else if (g3) {
          var I = g3.coordinateSystem;
          I === this && (w3 = this._coordsList[0]);
        }
        return { cartesian: w3, axis: M };
      }, o.prototype.containPoint = function(i) {
        var t3 = this._coordsList[0];
        if (t3)
          return t3.containPoint(i);
      }, o.prototype._initCartesian = function(i, t3, c3) {
        var p3 = this, g3 = this, b3 = { left: false, right: false, top: false, bottom: false }, w3 = { x: {}, y: {} }, M = { x: 0, y: 0 };
        if (t3.eachComponent("xAxis", I("x"), this), t3.eachComponent("yAxis", I("y"), this), !M.x || !M.y) {
          this._axesMap = {}, this._axesList = [];
          return;
        }
        this._axesMap = w3, yt(w3.x, function(k3, L) {
          yt(w3.y, function(F, B) {
            var G = "x" + L + "y" + B, J = new Cxt(G);
            J.master = p3, J.model = i, p3._coordsMap[G] = J, p3._coordsList.push(J), J.addAxis(k3), J.addAxis(F);
          });
        });
        function I(k3) {
          return function(L, F) {
            if (U0e(L, i)) {
              var B = L.get("position");
              k3 === "x" ? B !== "top" && B !== "bottom" && (B = b3.bottom ? "top" : "bottom") : B !== "left" && B !== "right" && (B = b3.left ? "right" : "left"), b3[B] = true;
              var G = new Txt(k3, $te(L), [0, 0], L.get("type"), B), J = G.type === "category";
              G.onBand = J && L.get("boundaryGap"), G.inverse = L.get("inverse"), L.axis = G, G.model = L, G.grid = g3, G.index = F, g3._axesList.push(G), w3[k3][F] = G, M[k3]++;
            }
          };
        }
      }, o.prototype._updateScale = function(i, t3) {
        yt(this._axesList, function(p3) {
          if (p3.scale.setExtent(1 / 0, -1 / 0), p3.type === "category") {
            var g3 = p3.model.get("categorySortInfo");
            p3.scale.setSortInfo(g3);
          }
        }), i.eachSeries(function(p3) {
          if (UNe(p3)) {
            var g3 = qNe(p3), b3 = g3.xAxisModel, w3 = g3.yAxisModel;
            if (!U0e(b3, t3) || !U0e(w3, t3))
              return;
            var M = this.getCartesian(b3.componentIndex, w3.componentIndex), I = p3.getData(), k3 = M.getAxis("x"), L = M.getAxis("y");
            c3(I, k3), c3(I, L);
          }
        }, this);
        function c3(p3, g3) {
          yt(Xte(p3, g3.dim), function(b3) {
            g3.scale.unionExtentFromData(p3, b3);
          });
        }
      }, o.prototype.getTooltipAxes = function(i) {
        var t3 = [], c3 = [];
        return yt(this.getCartesians(), function(p3) {
          var g3 = i != null && i !== "auto" ? p3.getAxis(i) : p3.getBaseAxis(), b3 = p3.getOtherAxis(g3);
          rl(t3, g3) < 0 && t3.push(g3), rl(c3, b3) < 0 && c3.push(b3);
        }), { baseAxes: t3, otherAxes: c3 };
      }, o.create = function(i, t3) {
        var c3 = [];
        return i.eachComponent("grid", function(p3, g3) {
          var b3 = new o(p3, i, t3);
          b3.name = "grid_" + g3, b3.resize(p3, t3, true), p3.coordinateSystem = b3, c3.push(b3);
        }), i.eachSeries(function(p3) {
          if (UNe(p3)) {
            var g3 = qNe(p3), b3 = g3.xAxisModel, w3 = g3.yAxisModel, M = b3.getCoordSysModel(), I = M.coordinateSystem;
            p3.coordinateSystem = I.getCartesian(b3.componentIndex, w3.componentIndex);
          }
        }), c3;
      }, o.dimensions = G0e, o;
    }();
    function U0e(o, i) {
      return o.getCoordSysModel() === i;
    }
    function XNe(o, i, t3, c3) {
      t3.getAxesOnZeroOf = function() {
        return g3 ? [g3] : [];
      };
      var p3 = o[i], g3, b3 = t3.model, w3 = b3.get(["axisLine", "onZero"]), M = b3.get(["axisLine", "onZeroAxisIndex"]);
      if (!w3)
        return;
      if (M != null)
        YNe(p3[M]) && (g3 = p3[M]);
      else
        for (var I in p3)
          if (p3.hasOwnProperty(I) && YNe(p3[I]) && !c3[k3(p3[I])]) {
            g3 = p3[I];
            break;
          }
      g3 && (c3[k3(g3)] = true);
      function k3(L) {
        return L.dim + "_" + L.index;
      }
    }
    function YNe(o) {
      return o && o.type !== "category" && o.type !== "time" && B1t(o);
    }
    function Ixt(o, i) {
      var t3 = o.getExtent(), c3 = t3[0] + t3[1];
      o.toGlobalCoord = o.dim === "x" ? function(p3) {
        return p3 + i;
      } : function(p3) {
        return c3 - p3 + i;
      }, o.toLocalCoord = o.dim === "x" ? function(p3) {
        return p3 - i;
      } : function(p3) {
        return c3 - p3 + i;
      };
    }
    var Ext = Axt, vk = Math.PI, mL = function() {
      function o(i, t3) {
        this.group = new vs(), this.opt = t3, this.axisModel = i, Uo(t3, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
          return true;
        } });
        var c3 = new vs({ x: t3.position[0], y: t3.position[1], rotation: t3.rotation });
        c3.updateTransform(), this._transformGroup = c3;
      }
      return o.prototype.hasBuilder = function(i) {
        return !!KNe[i];
      }, o.prototype.add = function(i) {
        KNe[i](this.opt, this.axisModel, this.group, this._transformGroup);
      }, o.prototype.getGroup = function() {
        return this.group;
      }, o.innerTextLayout = function(i, t3, c3) {
        var p3 = kF(t3 - i), g3, b3;
        return OF(p3) ? (b3 = c3 > 0 ? "top" : "bottom", g3 = "center") : OF(p3 - vk) ? (b3 = c3 > 0 ? "bottom" : "top", g3 = "center") : (b3 = "middle", p3 > 0 && p3 < vk ? g3 = c3 > 0 ? "right" : "left" : g3 = c3 > 0 ? "left" : "right"), { rotation: p3, textAlign: g3, textVerticalAlign: b3 };
      }, o.makeAxisEventDataBase = function(i) {
        var t3 = { componentType: i.mainType, componentIndex: i.componentIndex };
        return t3[i.mainType + "Index"] = i.componentIndex, t3;
      }, o.isLabelSilent = function(i) {
        var t3 = i.get("tooltip");
        return i.get("silent") || !(i.get("triggerEvent") || t3 && t3.show);
      }, o;
    }(), KNe = { axisLine: function(o, i, t3, c3) {
      var p3 = i.get(["axisLine", "show"]);
      if (p3 === "auto" && o.handleAutoShown && (p3 = o.handleAutoShown("axisLine")), !!p3) {
        var g3 = i.axis.getExtent(), b3 = c3.transform, w3 = [g3[0], 0], M = [g3[1], 0];
        b3 && (Vv(w3, w3, b3), Vv(M, M, b3));
        var I = ti({ lineCap: "round" }, i.getModel(["axisLine", "lineStyle"]).getLineStyle()), k3 = new Ud({ subPixelOptimize: true, shape: { x1: w3[0], y1: w3[1], x2: M[0], y2: M[1] }, style: I, strokeContainThreshold: o.strokeContainThreshold || 5, silent: true, z2: 1 });
        k3.anid = "line", t3.add(k3);
        var L = i.get(["axisLine", "symbol"]);
        if (L != null) {
          var F = i.get(["axisLine", "symbolSize"]);
          Ha(L) && (L = [L, L]), (Ha(F) || ec(F)) && (F = [F, F]);
          var B = I8(i.get(["axisLine", "symbolOffset"]) || 0, F), G = F[0], J = F[1];
          yt([{ rotate: o.rotation + Math.PI / 2, offset: B[0], r: 0 }, { rotate: o.rotation - Math.PI / 2, offset: B[1], r: Math.sqrt((w3[0] - M[0]) * (w3[0] - M[0]) + (w3[1] - M[1]) * (w3[1] - M[1])) }], function(Q, se) {
            if (L[se] !== "none" && L[se] != null) {
              var he = pv(L[se], -G / 2, -J / 2, G, J, I.stroke, true), be = Q.r + Q.offset;
              he.attr({ rotation: Q.rotate, x: w3[0] + be * Math.cos(o.rotation), y: w3[1] - be * Math.sin(o.rotation), silent: true, z2: 11 }), t3.add(he);
            }
          });
        }
      }
    }, axisTickLabel: function(o, i, t3, c3) {
      var p3 = Oxt(t3, c3, i, o), g3 = Lxt(t3, c3, i, o);
      if (kxt(i, g3, p3), Pxt(t3, c3, i, o.tickDirection), i.get(["axisLabel", "hideOverlap"])) {
        var b3 = D6e(Fi(g3, function(w3) {
          return { label: w3, priority: w3.z2, defaultAttr: { ignore: w3.ignore } };
        }));
        P6e(b3);
      }
    }, axisName: function(o, i, t3, c3) {
      var p3 = lv(o.axisName, i.get("name"));
      if (p3) {
        var g3 = i.get("nameLocation"), b3 = o.nameDirection, w3 = i.getModel("nameTextStyle"), M = i.get("nameGap") || 0, I = i.axis.getExtent(), k3 = I[0] > I[1] ? -1 : 1, L = [g3 === "start" ? I[0] - k3 * M : g3 === "end" ? I[1] + k3 * M : (I[0] + I[1]) / 2, JNe(g3) ? o.labelOffset + b3 * M : 0], F, B = i.get("nameRotate");
        B != null && (B = B * vk / 180);
        var G;
        JNe(g3) ? F = mL.innerTextLayout(o.rotation, B != null ? B : o.rotation, b3) : (F = Dxt(o.rotation, g3, B || 0, I), G = o.axisNameAvailableWidth, G != null && (G = Math.abs(G / Math.sin(F.rotation)), !isFinite(G) && (G = null)));
        var J = w3.getFont(), Q = i.get("nameTruncate", true) || {}, se = Q.ellipsis, he = lv(o.nameTruncateMaxWidth, Q.maxWidth, G), be = new Fl({ x: L[0], y: L[1], rotation: F.rotation, silent: mL.isLabelSilent(i), style: qd(w3, { text: p3, font: J, overflow: "truncate", width: he, ellipsis: se, fill: w3.getTextColor() || i.get(["axisLine", "lineStyle", "color"]), align: w3.get("align") || F.textAlign, verticalAlign: w3.get("verticalAlign") || F.textVerticalAlign }), z2: 1 });
        if (h8({ el: be, componentModel: i, itemName: p3 }), be.__fullText = p3, be.anid = "name", i.get("triggerEvent")) {
          var de = mL.makeAxisEventDataBase(i);
          de.targetType = "axisName", de.name = p3, La(be).eventData = de;
        }
        c3.add(be), be.updateTransform(), t3.add(be), be.decomposeTransform();
      }
    } };
    function Dxt(o, i, t3, c3) {
      var p3 = kF(t3 - o), g3, b3, w3 = c3[0] > c3[1], M = i === "start" && !w3 || i !== "start" && w3;
      return OF(p3 - vk / 2) ? (b3 = M ? "bottom" : "top", g3 = "center") : OF(p3 - vk * 1.5) ? (b3 = M ? "top" : "bottom", g3 = "center") : (b3 = "middle", p3 < vk * 1.5 && p3 > vk / 2 ? g3 = M ? "left" : "right" : g3 = M ? "right" : "left"), { rotation: p3, textAlign: g3, textVerticalAlign: b3 };
    }
    function kxt(o, i, t3) {
      if (!c6e(o.axis)) {
        var c3 = o.get(["axisLabel", "showMinLabel"]), p3 = o.get(["axisLabel", "showMaxLabel"]);
        i = i || [], t3 = t3 || [];
        var g3 = i[0], b3 = i[1], w3 = i[i.length - 1], M = i[i.length - 2], I = t3[0], k3 = t3[1], L = t3[t3.length - 1], F = t3[t3.length - 2];
        c3 === false ? (Lw(g3), Lw(I)) : ZNe(g3, b3) && (c3 ? (Lw(b3), Lw(k3)) : (Lw(g3), Lw(I))), p3 === false ? (Lw(w3), Lw(L)) : ZNe(M, w3) && (p3 ? (Lw(M), Lw(F)) : (Lw(w3), Lw(L)));
      }
    }
    function Lw(o) {
      o && (o.ignore = true);
    }
    function ZNe(o, i) {
      var t3 = o && o.getBoundingRect().clone(), c3 = i && i.getBoundingRect().clone();
      if (!(!t3 || !c3)) {
        var p3 = LP([]);
        return cI(p3, p3, -o.rotation), t3.applyTransform(pw([], p3, o.getLocalTransform())), c3.applyTransform(pw([], p3, i.getLocalTransform())), t3.intersect(c3);
      }
    }
    function JNe(o) {
      return o === "middle" || o === "center";
    }
    function QNe(o, i, t3, c3, p3) {
      for (var g3 = [], b3 = [], w3 = [], M = 0; M < o.length; M++) {
        var I = o[M].coord;
        b3[0] = I, b3[1] = 0, w3[0] = I, w3[1] = t3, i && (Vv(b3, b3, i), Vv(w3, w3, i));
        var k3 = new Ud({ subPixelOptimize: true, shape: { x1: b3[0], y1: b3[1], x2: w3[0], y2: w3[1] }, style: c3, z2: 2, autoBatch: true, silent: true });
        k3.anid = p3 + "_" + o[M].tickValue, g3.push(k3);
      }
      return g3;
    }
    function Oxt(o, i, t3, c3) {
      var p3 = t3.axis, g3 = t3.getModel("axisTick"), b3 = g3.get("show");
      if (b3 === "auto" && c3.handleAutoShown && (b3 = c3.handleAutoShown("axisTick")), !(!b3 || p3.scale.isBlank())) {
        for (var w3 = g3.getModel("lineStyle"), M = c3.tickDirection * g3.get("length"), I = p3.getTicksCoords(), k3 = QNe(I, i.transform, M, Uo(w3.getLineStyle(), { stroke: t3.get(["axisLine", "lineStyle", "color"]) }), "ticks"), L = 0; L < k3.length; L++)
          o.add(k3[L]);
        return k3;
      }
    }
    function Pxt(o, i, t3, c3) {
      var p3 = t3.axis, g3 = t3.getModel("minorTick");
      if (!(!g3.get("show") || p3.scale.isBlank())) {
        var b3 = p3.getMinorTicksCoords();
        if (b3.length)
          for (var w3 = g3.getModel("lineStyle"), M = c3 * g3.get("length"), I = Uo(w3.getLineStyle(), Uo(t3.getModel("axisTick").getLineStyle(), { stroke: t3.get(["axisLine", "lineStyle", "color"]) })), k3 = 0; k3 < b3.length; k3++)
            for (var L = QNe(b3[k3], i.transform, M, I, "minorticks_" + k3), F = 0; F < L.length; F++)
              o.add(L[F]);
      }
    }
    function Lxt(o, i, t3, c3) {
      var p3 = t3.axis, g3 = lv(c3.axisLabelShow, t3.get(["axisLabel", "show"]));
      if (!(!g3 || p3.scale.isBlank())) {
        var b3 = t3.getModel("axisLabel"), w3 = b3.get("margin"), M = p3.getViewLabels(), I = (lv(c3.labelRotate, b3.get("rotate")) || 0) * vk / 180, k3 = mL.innerTextLayout(c3.rotation, I, c3.labelDirection), L = t3.getCategories && t3.getCategories(true), F = [], B = mL.isLabelSilent(t3), G = t3.get("triggerEvent");
        return yt(M, function(J, Q) {
          var se = p3.scale.type === "ordinal" ? p3.scale.getRawOrdinalNumber(J.tickValue) : J.tickValue, he = J.formattedLabel, be = J.rawLabel, de = b3;
          if (L && L[se]) {
            var Fe = L[se];
            Ua(Fe) && Fe.textStyle && (de = new gh(Fe.textStyle, b3, t3.ecModel));
          }
          var Pe = de.getTextColor() || t3.get(["axisLine", "lineStyle", "color"]), ze = p3.dataToCoord(se), $e = new Fl({ x: ze, y: c3.labelOffset + c3.labelDirection * w3, rotation: k3.rotation, silent: B, z2: 10 + (J.level || 0), style: qd(de, { text: he, align: de.getShallow("align", true) || k3.textAlign, verticalAlign: de.getShallow("verticalAlign", true) || de.getShallow("baseline", true) || k3.textVerticalAlign, fill: Vo(Pe) ? Pe(p3.type === "category" ? be : p3.type === "value" ? se + "" : se, Q) : Pe }) });
          if ($e.anid = "label_" + se, G) {
            var Ke = mL.makeAxisEventDataBase(t3);
            Ke.targetType = "axisLabel", Ke.value = be, Ke.tickIndex = Q, p3.type === "category" && (Ke.dataIndex = se), La($e).eventData = Ke;
          }
          i.add($e), $e.updateTransform(), F.push($e), o.add($e), $e.decomposeTransform();
        }), F;
      }
    }
    var BI = mL;
    function Rxt(o, i) {
      var t3 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
      return Nxt(t3, o, i), t3.seriesInvolved && Vxt(t3, o), t3;
    }
    function Nxt(o, i, t3) {
      var c3 = i.getComponent("tooltip"), p3 = i.getComponent("axisPointer"), g3 = p3.get("link", true) || [], b3 = [];
      yt(t3.getCoordinateSystems(), function(w3) {
        if (!w3.axisPointerEnabled)
          return;
        var M = hW(w3.model), I = o.coordSysAxesInfo[M] = {};
        o.coordSysMap[M] = w3;
        var k3 = w3.model, L = k3.getModel("tooltip", c3);
        if (yt(w3.getAxes(), As(J, false, null)), w3.getTooltipAxes && c3 && L.get("show")) {
          var F = L.get("trigger") === "axis", B = L.get(["axisPointer", "type"]) === "cross", G = w3.getTooltipAxes(L.get(["axisPointer", "axis"]));
          (F || B) && yt(G.baseAxes, As(J, B ? "cross" : true, F)), B && yt(G.otherAxes, As(J, "cross", false));
        }
        function J(Q, se, he) {
          var be = he.model.getModel("axisPointer", p3), de = be.get("show");
          if (!(!de || de === "auto" && !Q && !X0e(be))) {
            se == null && (se = be.get("triggerTooltip")), be = Q ? Fxt(he, L, p3, i, Q, se) : be;
            var Fe = be.get("snap"), Pe = hW(he.model), ze = se || Fe || he.type === "category", $e = o.axesInfo[Pe] = { key: Pe, axis: he, coordSys: w3, axisPointerModel: be, triggerTooltip: se, involveSeries: ze, snap: Fe, useHandle: X0e(be), seriesModels: [], linkGroup: null };
            I[Pe] = $e, o.seriesInvolved = o.seriesInvolved || ze;
            var Ke = Bxt(g3, he);
            if (Ke != null) {
              var nt = b3[Ke] || (b3[Ke] = { axesInfo: {} });
              nt.axesInfo[Pe] = $e, nt.mapper = g3[Ke].mapper, $e.linkGroup = nt;
            }
          }
        }
      });
    }
    function Fxt(o, i, t3, c3, p3, g3) {
      var b3 = i.getModel("axisPointer"), w3 = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], M = {};
      yt(w3, function(F) {
        M[F] = Jo(b3.get(F));
      }), M.snap = o.type !== "category" && !!g3, b3.get("type") === "cross" && (M.type = "line");
      var I = M.label || (M.label = {});
      if (I.show == null && (I.show = false), p3 === "cross") {
        var k3 = b3.get(["label", "show"]);
        if (I.show = k3 != null ? k3 : true, !g3) {
          var L = M.lineStyle = b3.get("crossStyle");
          L && Uo(I, L.textStyle);
        }
      }
      return o.model.getModel("axisPointer", new gh(M, t3, c3));
    }
    function Vxt(o, i) {
      i.eachSeries(function(t3) {
        var c3 = t3.coordinateSystem, p3 = t3.get(["tooltip", "trigger"], true), g3 = t3.get(["tooltip", "show"], true);
        !c3 || p3 === "none" || p3 === false || p3 === "item" || g3 === false || t3.get(["axisPointer", "show"], true) === false || yt(o.coordSysAxesInfo[hW(c3.model)], function(b3) {
          var w3 = b3.axis;
          c3.getAxis(w3.dim) === w3 && (b3.seriesModels.push(t3), b3.seriesDataCount == null && (b3.seriesDataCount = 0), b3.seriesDataCount += t3.getData().count());
        });
      });
    }
    function Bxt(o, i) {
      for (var t3 = i.model, c3 = i.dim, p3 = 0; p3 < o.length; p3++) {
        var g3 = o[p3] || {};
        if (q0e(g3[c3 + "AxisId"], t3.id) || q0e(g3[c3 + "AxisIndex"], t3.componentIndex) || q0e(g3[c3 + "AxisName"], t3.name))
          return p3;
      }
    }
    function q0e(o, i) {
      return o === "all" || Ei(o) && rl(o, i) >= 0 || o === i;
    }
    function zxt(o) {
      var i = $0e(o);
      if (i) {
        var t3 = i.axisPointerModel, c3 = i.axis.scale, p3 = t3.option, g3 = t3.get("status"), b3 = t3.get("value");
        b3 != null && (b3 = c3.parse(b3));
        var w3 = X0e(t3);
        g3 == null && (p3.status = w3 ? "show" : "hide");
        var M = c3.getExtent().slice();
        M[0] > M[1] && M.reverse(), (b3 == null || b3 > M[1]) && (b3 = M[1]), b3 < M[0] && (b3 = M[0]), p3.value = b3, w3 && (p3.status = i.axis.scale.isBlank() ? "hide" : "show");
      }
    }
    function $0e(o) {
      var i = (o.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
      return i && i.axesInfo[hW(o)];
    }
    function jxt(o) {
      var i = $0e(o);
      return i && i.axisPointerModel;
    }
    function X0e(o) {
      return !!o.get(["handle", "show"]);
    }
    function hW(o) {
      return o.type + "||" + o.id;
    }
    var eFe = {}, Gxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        this.axisPointerClass && zxt(t3), o.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(t3, p3, true);
      }, i.prototype.updateAxisPointer = function(t3, c3, p3, g3) {
        this._doUpdateAxisPointerClass(t3, p3, false);
      }, i.prototype.remove = function(t3, c3) {
        var p3 = this._axisPointer;
        p3 && p3.remove(c3);
      }, i.prototype.dispose = function(t3, c3) {
        this._disposeAxisPointer(c3), o.prototype.dispose.apply(this, arguments);
      }, i.prototype._doUpdateAxisPointerClass = function(t3, c3, p3) {
        var g3 = i.getAxisPointerClass(this.axisPointerClass);
        if (g3) {
          var b3 = jxt(t3);
          b3 ? (this._axisPointer || (this._axisPointer = new g3())).render(t3, b3, c3, p3) : this._disposeAxisPointer(c3);
        }
      }, i.prototype._disposeAxisPointer = function(t3) {
        this._axisPointer && this._axisPointer.dispose(t3), this._axisPointer = null;
      }, i.registerAxisPointerClass = function(t3, c3) {
        eFe[t3] = c3;
      }, i.getAxisPointerClass = function(t3) {
        return t3 && eFe[t3];
      }, i.type = "axis", i;
    }(ed), bL = Gxt, Y0e = mu();
    function tFe(o, i, t3, c3) {
      var p3 = t3.axis;
      if (!p3.scale.isBlank()) {
        var g3 = t3.getModel("splitArea"), b3 = g3.getModel("areaStyle"), w3 = b3.get("color"), M = c3.coordinateSystem.getRect(), I = p3.getTicksCoords({ tickModel: g3, clamp: true });
        if (I.length) {
          var k3 = w3.length, L = Y0e(o).splitAreaColors, F = Eo(), B = 0;
          if (L)
            for (var G = 0; G < I.length; G++) {
              var J = L.get(I[G].tickValue);
              if (J != null) {
                B = (J + (k3 - 1) * G) % k3;
                break;
              }
            }
          var Q = p3.toGlobalCoord(I[0].coord), se = b3.getAreaStyle();
          w3 = Ei(w3) ? w3 : [w3];
          for (var G = 1; G < I.length; G++) {
            var he = p3.toGlobalCoord(I[G].coord), be = void 0, de = void 0, Fe = void 0, Pe = void 0;
            p3.isHorizontal() ? (be = Q, de = M.y, Fe = he - be, Pe = M.height, Q = be + Fe) : (be = M.x, de = Q, Fe = M.width, Pe = he - de, Q = de + Pe);
            var ze = I[G - 1].tickValue;
            ze != null && F.set(ze, B), i.add(new bu({ anid: ze != null ? "area_" + ze : null, shape: { x: be, y: de, width: Fe, height: Pe }, style: Uo({ fill: w3[B] }, se), autoBatch: true, silent: true })), B = (B + 1) % k3;
          }
          Y0e(o).splitAreaColors = F;
        }
      }
    }
    function nFe(o) {
      Y0e(o).splitAreaColors = null;
    }
    var Hxt = ["axisLine", "axisTickLabel", "axisName"], Wxt = ["splitArea", "splitLine", "minorSplitLine"], rFe = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.axisPointerClass = "CartesianAxisPointer", t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        this.group.removeAll();
        var b3 = this._axisGroup;
        if (this._axisGroup = new vs(), this.group.add(this._axisGroup), !!t3.get("show")) {
          var w3 = t3.getCoordSysModel(), M = H0e(w3, t3), I = new BI(t3, ti({ handleAutoShown: function(L) {
            for (var F = w3.coordinateSystem.getCartesians(), B = 0; B < F.length; B++)
              if (l0e(F[B].getOtherAxis(t3.axis).scale))
                return true;
            return false;
          } }, M));
          yt(Hxt, I.add, I), this._axisGroup.add(I.getGroup()), yt(Wxt, function(L) {
            t3.get([L, "show"]) && Uxt[L](this, this._axisGroup, t3, w3);
          }, this);
          var k3 = g3 && g3.type === "changeAxisOrder" && g3.isInitSort;
          k3 || Sg(b3, this._axisGroup, t3), o.prototype.render.call(this, t3, c3, p3, g3);
        }
      }, i.prototype.remove = function() {
        nFe(this);
      }, i.type = "cartesianAxis", i;
    }(bL), Uxt = { splitLine: function(o, i, t3, c3) {
      var p3 = t3.axis;
      if (!p3.scale.isBlank()) {
        var g3 = t3.getModel("splitLine"), b3 = g3.getModel("lineStyle"), w3 = b3.get("color");
        w3 = Ei(w3) ? w3 : [w3];
        for (var M = c3.coordinateSystem.getRect(), I = p3.isHorizontal(), k3 = 0, L = p3.getTicksCoords({ tickModel: g3 }), F = [], B = [], G = b3.getLineStyle(), J = 0; J < L.length; J++) {
          var Q = p3.toGlobalCoord(L[J].coord);
          I ? (F[0] = Q, F[1] = M.y, B[0] = Q, B[1] = M.y + M.height) : (F[0] = M.x, F[1] = Q, B[0] = M.x + M.width, B[1] = Q);
          var se = k3++ % w3.length, he = L[J].tickValue;
          i.add(new Ud({ anid: he != null ? "line_" + L[J].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: F[0], y1: F[1], x2: B[0], y2: B[1] }, style: Uo({ stroke: w3[se] }, G), silent: true }));
        }
      }
    }, minorSplitLine: function(o, i, t3, c3) {
      var p3 = t3.axis, g3 = t3.getModel("minorSplitLine"), b3 = g3.getModel("lineStyle"), w3 = c3.coordinateSystem.getRect(), M = p3.isHorizontal(), I = p3.getMinorTicksCoords();
      if (I.length)
        for (var k3 = [], L = [], F = b3.getLineStyle(), B = 0; B < I.length; B++)
          for (var G = 0; G < I[B].length; G++) {
            var J = p3.toGlobalCoord(I[B][G].coord);
            M ? (k3[0] = J, k3[1] = w3.y, L[0] = J, L[1] = w3.y + w3.height) : (k3[0] = w3.x, k3[1] = J, L[0] = w3.x + w3.width, L[1] = J), i.add(new Ud({ anid: "minor_line_" + I[B][G].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: k3[0], y1: k3[1], x2: L[0], y2: L[1] }, style: F, silent: true }));
          }
    }, splitArea: function(o, i, t3, c3) {
      tFe(o, i, t3, c3);
    } }, iFe = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "xAxis", i;
    }(rFe), qxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = iFe.type, t3;
      }
      return i.type = "yAxis", i;
    }(rFe), $xt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "grid", t3;
      }
      return i.prototype.render = function(t3, c3) {
        this.group.removeAll(), t3.get("show") && this.group.add(new bu({ shape: t3.coordinateSystem.getRect(), style: Uo({ fill: t3.get("backgroundColor") }, t3.getItemStyle()), silent: true, z2: -1 }));
      }, i.type = "grid", i;
    }(ed), aFe = { offset: 0 };
    function oFe(o) {
      o.registerComponentView($xt), o.registerComponentModel(gxt), o.registerCoordinateSystem("cartesian2d", Ext), F8(o, "x", z0e, aFe), F8(o, "y", z0e, aFe), o.registerComponentView(iFe), o.registerComponentView(qxt), o.registerPreprocessor(function(i) {
        i.xAxis && i.yAxis && !i.grid && (i.grid = {});
      });
    }
    function Xxt(o) {
      Tl(oFe), o.registerSeriesModel(lxt), o.registerChartView(dxt), o.registerLayout(uW("scatter"));
    }
    function Yxt(o) {
      o.eachSeriesByType("radar", function(i) {
        var t3 = i.getData(), c3 = [], p3 = i.coordinateSystem;
        if (p3) {
          var g3 = p3.getIndicatorAxes();
          yt(g3, function(b3, w3) {
            t3.each(t3.mapDimension(g3[w3].dim), function(M, I) {
              c3[I] = c3[I] || [];
              var k3 = p3.dataToPoint(M, w3);
              c3[I][w3] = sFe(k3) ? k3 : lFe(p3);
            });
          }), t3.each(function(b3) {
            var w3 = Fpe(c3[b3], function(M) {
              return sFe(M);
            }) || lFe(p3);
            c3[b3].push(w3.slice()), t3.setItemLayout(b3, c3[b3]);
          });
        }
      });
    }
    function sFe(o) {
      return !isNaN(o[0]) && !isNaN(o[1]);
    }
    function lFe(o) {
      return [o.cx, o.cy];
    }
    function Kxt(o) {
      var i = o.polar;
      if (i) {
        Ei(i) || (i = [i]);
        var t3 = [];
        yt(i, function(c3, p3) {
          c3.indicator ? (c3.type && !c3.shape && (c3.shape = c3.type), o.radar = o.radar || [], Ei(o.radar) || (o.radar = [o.radar]), o.radar.push(c3)) : t3.push(c3);
        }), o.polar = t3;
      }
      yt(o.series, function(c3) {
        c3 && c3.type === "radar" && c3.polarIndex && (c3.radarIndex = c3.polarIndex);
      });
    }
    var Zxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.coordinateSystem, b3 = this.group, w3 = t3.getData(), M = this._data;
        function I(F, B) {
          var G = F.getItemVisual(B, "symbol") || "circle";
          if (G !== "none") {
            var J = zH(F.getItemVisual(B, "symbolSize")), Q = pv(G, -1, -1, 2, 2), se = F.getItemVisual(B, "symbolRotate") || 0;
            return Q.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: J[0] / 2, scaleY: J[1] / 2, rotation: se * Math.PI / 180 || 0 }), Q;
          }
        }
        function k3(F, B, G, J, Q, se) {
          G.removeAll();
          for (var he = 0; he < B.length - 1; he++) {
            var be = I(J, Q);
            be && (be.__dimIdx = he, F[he] ? (be.setPosition(F[he]), SH[se ? "initProps" : "updateProps"](be, { x: B[he][0], y: B[he][1] }, t3, Q)) : be.setPosition(B[he]), G.add(be));
          }
        }
        function L(F) {
          return Fi(F, function(B) {
            return [g3.cx, g3.cy];
          });
        }
        w3.diff(M).add(function(F) {
          var B = w3.getItemLayout(F);
          if (B) {
            var G = new _m(), J = new xm(), Q = { shape: { points: B } };
            G.shape.points = L(B), J.shape.points = L(B), Uh(G, Q, t3, F), Uh(J, Q, t3, F);
            var se = new vs(), he = new vs();
            se.add(J), se.add(G), se.add(he), k3(J.shape.points, B, he, w3, F, true), w3.setItemGraphicEl(F, se);
          }
        }).update(function(F, B) {
          var G = M.getItemGraphicEl(B), J = G.childAt(0), Q = G.childAt(1), se = G.childAt(2), he = { shape: { points: w3.getItemLayout(F) } };
          !he.shape.points || (k3(J.shape.points, he.shape.points, se, w3, F, false), P_(Q), P_(J), Du(J, he, t3), Du(Q, he, t3), w3.setItemGraphicEl(F, G));
        }).remove(function(F) {
          b3.remove(M.getItemGraphicEl(F));
        }).execute(), w3.eachItemGraphicEl(function(F, B) {
          var G = w3.getItemModel(B), J = F.childAt(0), Q = F.childAt(1), se = F.childAt(2), he = w3.getItemVisual(B, "style"), be = he.fill;
          b3.add(F), J.useStyle(Uo(G.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: be })), cv(J, G, "lineStyle"), cv(Q, G, "areaStyle");
          var de = G.getModel("areaStyle"), Fe = de.isEmpty() && de.parentModel.isEmpty();
          Q.ignore = Fe, yt(["emphasis", "select", "blur"], function($e) {
            var Ke = G.getModel([$e, "areaStyle"]), nt = Ke.isEmpty() && Ke.parentModel.isEmpty();
            Q.ensureState($e).ignore = nt && Fe;
          }), Q.useStyle(Uo(de.getAreaStyle(), { fill: be, opacity: 0.7, decal: he.decal }));
          var Pe = G.getModel("emphasis"), ze = Pe.getModel("itemStyle").getItemStyle();
          se.eachChild(function($e) {
            if ($e instanceof Gv) {
              var Ke = $e.style;
              $e.useStyle(ti({ image: Ke.image, x: Ke.x, y: Ke.y, width: Ke.width, height: Ke.height }, he));
            } else
              $e.useStyle(he), $e.setColor(be), $e.style.strokeNoScale = true;
            var nt = $e.ensureState("emphasis");
            nt.style = Jo(ze);
            var lt2 = w3.getStore().get(w3.getDimensionIndex($e.__dimIdx), B);
            (lt2 == null || isNaN(lt2)) && (lt2 = ""), Sm($e, g0(G), { labelFetcher: w3.hostModel, labelDataIndex: B, labelDimIndex: $e.__dimIdx, defaultText: lt2, inheritColor: be, defaultOpacity: he.opacity });
          }), zp(F, Pe.get("focus"), Pe.get("blurScope"), Pe.get("disabled"));
        }), this._data = w3;
      }, i.prototype.remove = function() {
        this.group.removeAll(), this._data = null;
      }, i.type = "radar", i;
    }(yh), Jxt = Zxt, Qxt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.hasSymbolVisual = true, t3;
      }
      return i.prototype.init = function(t3) {
        o.prototype.init.apply(this, arguments), this.legendVisualProvider = new fW(Qa(this.getData, this), Qa(this.getRawData, this));
      }, i.prototype.getInitialData = function(t3, c3) {
        return N8(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        var g3 = this.getData(), b3 = this.coordinateSystem, w3 = b3.getIndicatorAxes(), M = this.getData().getName(t3), I = M === "" ? this.name : M, k3 = _Re(this, t3);
        return Cg("section", { header: I, sortBlocks: true, blocks: Fi(w3, function(L) {
          var F = g3.get(g3.mapDimension(L.dim), t3);
          return Cg("nameValue", { markerType: "subItem", markerColor: k3, name: L.name, value: F, sortParam: F });
        }) });
      }, i.prototype.getTooltipPosition = function(t3) {
        if (t3 != null) {
          for (var c3 = this.getData(), p3 = this.coordinateSystem, g3 = c3.getValues(Fi(p3.dimensions, function(I) {
            return c3.mapDimension(I);
          }), t3), b3 = 0, w3 = g3.length; b3 < w3; b3++)
            if (!isNaN(g3[b3])) {
              var M = p3.getIndicatorAxes();
              return p3.coordToPoint(M[b3].dataToCoord(g3[b3]), b3);
            }
        }
      }, i.type = "series.radar", i.dependencies = ["radar"], i.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, i;
    }(bp), ewt = Qxt, pW = GNe.value;
    function une(o, i) {
      return Uo({ show: i }, o);
    }
    var twt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.optionUpdated = function() {
        var t3 = this.get("boundaryGap"), c3 = this.get("splitNumber"), p3 = this.get("scale"), g3 = this.get("axisLine"), b3 = this.get("axisTick"), w3 = this.get("axisLabel"), M = this.get("axisName"), I = this.get(["axisName", "show"]), k3 = this.get(["axisName", "formatter"]), L = this.get("axisNameGap"), F = this.get("triggerEvent"), B = Fi(this.get("indicator") || [], function(G) {
          G.max != null && G.max > 0 && !G.min ? G.min = 0 : G.min != null && G.min < 0 && !G.max && (G.max = 0);
          var J = M;
          G.color != null && (J = Uo({ color: G.color }, M));
          var Q = Es(Jo(G), { boundaryGap: t3, splitNumber: c3, scale: p3, axisLine: g3, axisTick: b3, axisLabel: w3, name: G.text, showName: I, nameLocation: "end", nameGap: L, nameTextStyle: J, triggerEvent: F }, false);
          if (I || (Q.name = ""), Ha(k3)) {
            var se = Q.name;
            Q.name = k3.replace("{value}", se != null ? se : "");
          } else
            Vo(k3) && (Q.name = k3(Q.name, Q));
          var he = new gh(Q, null, this.ecModel);
          return Kp(he, eW.prototype), he.mainType = "radar", he.componentIndex = this.componentIndex, he;
        }, this);
        this._indicatorModels = B;
      }, i.prototype.getIndicatorModels = function() {
        return this._indicatorModels;
      }, i.type = "radar", i.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: Es({ lineStyle: { color: "#bbb" } }, pW.axisLine), axisLabel: une(pW.axisLabel, false), axisTick: une(pW.axisTick, false), splitLine: une(pW.splitLine, true), splitArea: une(pW.splitArea, true), indicator: [] }, i;
    }(nc), nwt = twt, rwt = ["axisLine", "axisTickLabel", "axisName"], iwt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = this.group;
        g3.removeAll(), this._buildAxes(t3), this._buildSplitLineAndArea(t3);
      }, i.prototype._buildAxes = function(t3) {
        var c3 = t3.coordinateSystem, p3 = c3.getIndicatorAxes(), g3 = Fi(p3, function(b3) {
          var w3 = b3.model.get("showName") ? b3.name : "", M = new BI(b3.model, { axisName: w3, position: [c3.cx, c3.cy], rotation: b3.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
          return M;
        });
        yt(g3, function(b3) {
          yt(rwt, b3.add, b3), this.group.add(b3.getGroup());
        }, this);
      }, i.prototype._buildSplitLineAndArea = function(t3) {
        var c3 = t3.coordinateSystem, p3 = c3.getIndicatorAxes();
        if (!p3.length)
          return;
        var g3 = t3.get("shape"), b3 = t3.getModel("splitLine"), w3 = t3.getModel("splitArea"), M = b3.getModel("lineStyle"), I = w3.getModel("areaStyle"), k3 = b3.get("show"), L = w3.get("show"), F = M.get("color"), B = I.get("color"), G = Ei(F) ? F : [F], J = Ei(B) ? B : [B], Q = [], se = [];
        function he(Jt, Rt, Jn) {
          var ln = Jn % Rt.length;
          return Jt[ln] = Jt[ln] || [], ln;
        }
        if (g3 === "circle")
          for (var be = p3[0].getTicksCoords(), de = c3.cx, Fe = c3.cy, Pe = 0; Pe < be.length; Pe++) {
            if (k3) {
              var ze = he(Q, G, Pe);
              Q[ze].push(new Mw({ shape: { cx: de, cy: Fe, r: be[Pe].coord } }));
            }
            if (L && Pe < be.length - 1) {
              var ze = he(se, J, Pe);
              se[ze].push(new n8({ shape: { cx: de, cy: Fe, r0: be[Pe].coord, r: be[Pe + 1].coord } }));
            }
          }
        else
          for (var $e, Ke = Fi(p3, function(Rt, Jn) {
            var ln = Rt.getTicksCoords();
            return $e = $e == null ? ln.length - 1 : Math.min(ln.length - 1, $e), Fi(ln, function(vn) {
              return c3.coordToPoint(vn.coord, Jn);
            });
          }), nt = [], Pe = 0; Pe <= $e; Pe++) {
            for (var lt2 = [], bt = 0; bt < p3.length; bt++)
              lt2.push(Ke[bt][Pe]);
            if (lt2[0] && lt2.push(lt2[0].slice()), k3) {
              var ze = he(Q, G, Pe);
              Q[ze].push(new xm({ shape: { points: lt2 } }));
            }
            if (L && nt) {
              var ze = he(se, J, Pe - 1);
              se[ze].push(new _m({ shape: { points: lt2.concat(nt) } }));
            }
            nt = lt2.slice().reverse();
          }
        var vt = M.getLineStyle(), jt = I.getAreaStyle();
        yt(se, function(Jt, Rt) {
          this.group.add(ji(Jt, { style: Uo({ stroke: "none", fill: J[Rt % J.length] }, jt), silent: true }));
        }, this), yt(Q, function(Jt, Rt) {
          this.group.add(ji(Jt, { style: Uo({ fill: "none", stroke: G[Rt % G.length] }, vt), silent: true }));
        }, this);
      }, i.type = "radar", i;
    }(ed), awt = iwt, owt = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this, t3, c3, p3) || this;
        return g3.type = "value", g3.angle = 0, g3.name = "", g3;
      }
      return i;
    }(Y2), swt = owt, lwt = function() {
      function o(i, t3, c3) {
        this.dimensions = [], this._model = i, this._indicatorAxes = Fi(i.getIndicatorModels(), function(p3, g3) {
          var b3 = "indicator_" + g3, w3 = new swt(b3, new fk());
          return w3.name = p3.get("name"), w3.model = p3, p3.axis = w3, this.dimensions.push(b3), w3;
        }, this), this.resize(i, c3);
      }
      return o.prototype.getIndicatorAxes = function() {
        return this._indicatorAxes;
      }, o.prototype.dataToPoint = function(i, t3) {
        var c3 = this._indicatorAxes[t3];
        return this.coordToPoint(c3.dataToCoord(i), t3);
      }, o.prototype.coordToPoint = function(i, t3) {
        var c3 = this._indicatorAxes[t3], p3 = c3.angle, g3 = this.cx + i * Math.cos(p3), b3 = this.cy - i * Math.sin(p3);
        return [g3, b3];
      }, o.prototype.pointToData = function(i) {
        var t3 = i[0] - this.cx, c3 = i[1] - this.cy, p3 = Math.sqrt(t3 * t3 + c3 * c3);
        t3 /= p3, c3 /= p3;
        for (var g3 = Math.atan2(-c3, t3), b3 = 1 / 0, w3, M = -1, I = 0; I < this._indicatorAxes.length; I++) {
          var k3 = this._indicatorAxes[I], L = Math.abs(g3 - k3.angle);
          L < b3 && (w3 = k3, M = I, b3 = L);
        }
        return [M, +(w3 && w3.coordToData(p3))];
      }, o.prototype.resize = function(i, t3) {
        var c3 = i.get("center"), p3 = t3.getWidth(), g3 = t3.getHeight(), b3 = Math.min(p3, g3) / 2;
        this.cx = Da(c3[0], p3), this.cy = Da(c3[1], g3), this.startAngle = i.get("startAngle") * Math.PI / 180;
        var w3 = i.get("radius");
        (Ha(w3) || ec(w3)) && (w3 = [0, w3]), this.r0 = Da(w3[0], b3), this.r = Da(w3[1], b3), yt(this._indicatorAxes, function(M, I) {
          M.setExtent(this.r0, this.r);
          var k3 = this.startAngle + I * Math.PI * 2 / this._indicatorAxes.length;
          k3 = Math.atan2(Math.sin(k3), Math.cos(k3)), M.angle = k3;
        }, this);
      }, o.prototype.update = function(i, t3) {
        var c3 = this._indicatorAxes, p3 = this._model;
        yt(c3, function(w3) {
          w3.scale.setExtent(1 / 0, -1 / 0);
        }), i.eachSeriesByType("radar", function(w3, M) {
          if (!(w3.get("coordinateSystem") !== "radar" || i.getComponent("radar", w3.get("radarIndex")) !== p3)) {
            var I = w3.getData();
            yt(c3, function(k3) {
              k3.scale.unionExtentFromData(I, I.mapDimension(k3.dim));
            });
          }
        }, this);
        var g3 = p3.get("splitNumber"), b3 = new fk();
        b3.setExtent(0, g3), b3.setInterval(1), yt(c3, function(w3, M) {
          $Ne(w3.scale, w3.model, b3);
        });
      }, o.prototype.convertToPixel = function(i, t3, c3) {
        return console.warn("Not implemented."), null;
      }, o.prototype.convertFromPixel = function(i, t3, c3) {
        return console.warn("Not implemented."), null;
      }, o.prototype.containPoint = function(i) {
        return console.warn("Not implemented."), false;
      }, o.create = function(i, t3) {
        var c3 = [];
        return i.eachComponent("radar", function(p3) {
          var g3 = new o(p3, i, t3);
          c3.push(g3), p3.coordinateSystem = g3;
        }), i.eachSeriesByType("radar", function(p3) {
          p3.get("coordinateSystem") === "radar" && (p3.coordinateSystem = c3[p3.get("radarIndex") || 0]);
        }), c3;
      }, o.dimensions = [], o;
    }(), uwt = lwt;
    function cwt(o) {
      o.registerCoordinateSystem("radar", uwt), o.registerComponentModel(nwt), o.registerComponentView(awt), o.registerVisual({ seriesType: "radar", reset: function(i) {
        var t3 = i.getData();
        t3.each(function(c3) {
          t3.setItemVisual(c3, "legendIcon", "roundRect");
        }), t3.setVisual("legendIcon", "roundRect");
      } });
    }
    function fwt(o) {
      Tl(cwt), o.registerChartView(Jxt), o.registerSeriesModel(ewt), o.registerLayout(Yxt), o.registerProcessor(cW("radar")), o.registerPreprocessor(Kxt);
    }
    var uFe = "\0_ec_interaction_mutex";
    function hwt(o, i, t3) {
      var c3 = K0e(o);
      c3[i] = t3;
    }
    function pwt(o, i, t3) {
      var c3 = K0e(o), p3 = c3[i];
      p3 === t3 && (c3[i] = null);
    }
    function cFe(o, i) {
      return !!K0e(o)[i];
    }
    function K0e(o) {
      return o[uFe] || (o[uFe] = {});
    }
    ZM({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, uf);
    var dwt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this) || this;
        c3._zr = t3;
        var p3 = Qa(c3._mousedownHandler, c3), g3 = Qa(c3._mousemoveHandler, c3), b3 = Qa(c3._mouseupHandler, c3), w3 = Qa(c3._mousewheelHandler, c3), M = Qa(c3._pinchHandler, c3);
        return c3.enable = function(I, k3) {
          this.disable(), this._opt = Uo(Jo(k3) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), I == null && (I = true), (I === true || I === "move" || I === "pan") && (t3.on("mousedown", p3), t3.on("mousemove", g3), t3.on("mouseup", b3)), (I === true || I === "scale" || I === "zoom") && (t3.on("mousewheel", w3), t3.on("pinch", M));
        }, c3.disable = function() {
          t3.off("mousedown", p3), t3.off("mousemove", g3), t3.off("mouseup", b3), t3.off("mousewheel", w3), t3.off("pinch", M);
        }, c3;
      }
      return i.prototype.isDragging = function() {
        return this._dragging;
      }, i.prototype.isPinching = function() {
        return this._pinching;
      }, i.prototype.setPointerChecker = function(t3) {
        this.pointerChecker = t3;
      }, i.prototype.dispose = function() {
        this.disable();
      }, i.prototype._mousedownHandler = function(t3) {
        if (!(sQ(t3) || t3.target && t3.target.draggable)) {
          var c3 = t3.offsetX, p3 = t3.offsetY;
          this.pointerChecker && this.pointerChecker(t3, c3, p3) && (this._x = c3, this._y = p3, this._dragging = true);
        }
      }, i.prototype._mousemoveHandler = function(t3) {
        if (!(!this._dragging || !cne("moveOnMouseMove", t3, this._opt) || t3.gestureEvent === "pinch" || cFe(this._zr, "globalPan"))) {
          var c3 = t3.offsetX, p3 = t3.offsetY, g3 = this._x, b3 = this._y, w3 = c3 - g3, M = p3 - b3;
          this._x = c3, this._y = p3, this._opt.preventDefaultMouseMove && R2(t3.event), fFe(this, "pan", "moveOnMouseMove", t3, { dx: w3, dy: M, oldX: g3, oldY: b3, newX: c3, newY: p3, isAvailableBehavior: null });
        }
      }, i.prototype._mouseupHandler = function(t3) {
        sQ(t3) || (this._dragging = false);
      }, i.prototype._mousewheelHandler = function(t3) {
        var c3 = cne("zoomOnMouseWheel", t3, this._opt), p3 = cne("moveOnMouseWheel", t3, this._opt), g3 = t3.wheelDelta, b3 = Math.abs(g3), w3 = t3.offsetX, M = t3.offsetY;
        if (!(g3 === 0 || !c3 && !p3)) {
          if (c3) {
            var I = b3 > 3 ? 1.4 : b3 > 1 ? 1.2 : 1.1, k3 = g3 > 0 ? I : 1 / I;
            Z0e(this, "zoom", "zoomOnMouseWheel", t3, { scale: k3, originX: w3, originY: M, isAvailableBehavior: null });
          }
          if (p3) {
            var L = Math.abs(g3), F = (g3 > 0 ? 1 : -1) * (L > 3 ? 0.4 : L > 1 ? 0.15 : 0.05);
            Z0e(this, "scrollMove", "moveOnMouseWheel", t3, { scrollDelta: F, originX: w3, originY: M, isAvailableBehavior: null });
          }
        }
      }, i.prototype._pinchHandler = function(t3) {
        if (!cFe(this._zr, "globalPan")) {
          var c3 = t3.pinchScale > 1 ? 1.1 : 0.9090909090909091;
          Z0e(this, "zoom", null, t3, { scale: c3, originX: t3.pinchX, originY: t3.pinchY, isAvailableBehavior: null });
        }
      }, i;
    }(hm);
    function Z0e(o, i, t3, c3, p3) {
      o.pointerChecker && o.pointerChecker(c3, p3.originX, p3.originY) && (R2(c3.event), fFe(o, i, t3, c3, p3));
    }
    function fFe(o, i, t3, c3, p3) {
      p3.isAvailableBehavior = Qa(cne, null, t3, c3), o.trigger(i, p3);
    }
    function cne(o, i, t3) {
      var c3 = t3[o];
      return !o || c3 && (!Ha(c3) || i.event[c3 + "Key"]);
    }
    var dW = dwt;
    function J0e(o, i, t3) {
      var c3 = o.target;
      c3.x += i, c3.y += t3, c3.dirty();
    }
    function Q0e(o, i, t3, c3) {
      var p3 = o.target, g3 = o.zoomLimit, b3 = o.zoom = o.zoom || 1;
      if (b3 *= i, g3) {
        var w3 = g3.min || 0, M = g3.max || 1 / 0;
        b3 = Math.max(Math.min(M, b3), w3);
      }
      var I = b3 / o.zoom;
      o.zoom = b3, p3.x -= (t3 - p3.x) * (I - 1), p3.y -= (c3 - p3.y) * (I - 1), p3.scaleX *= I, p3.scaleY *= I, p3.dirty();
    }
    var vwt = { axisPointer: 1, tooltip: 1, brush: 1 };
    function fne(o, i, t3) {
      var c3 = i.getComponentByElement(o.topTarget), p3 = c3 && c3.coordinateSystem;
      return c3 && c3 !== t3 && !vwt.hasOwnProperty(c3.mainType) && p3 && p3.model !== t3;
    }
    function hFe(o) {
      if (Ha(o)) {
        var i = new DOMParser();
        o = i.parseFromString(o, "text/xml");
      }
      var t3 = o;
      for (t3.nodeType === 9 && (t3 = t3.firstChild); t3.nodeName.toLowerCase() !== "svg" || t3.nodeType !== 1; )
        t3 = t3.nextSibling;
      return t3;
    }
    var eye, hne = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, pFe = Gl(hne), pne = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, dFe = Gl(pne), gwt = function() {
      function o() {
        this._defs = {}, this._root = null;
      }
      return o.prototype.parse = function(i, t3) {
        t3 = t3 || {};
        var c3 = hFe(i);
        this._defsUsePending = [];
        var p3 = new vs();
        this._root = p3;
        var g3 = [], b3 = c3.getAttribute("viewBox") || "", w3 = parseFloat(c3.getAttribute("width") || t3.width), M = parseFloat(c3.getAttribute("height") || t3.height);
        isNaN(w3) && (w3 = null), isNaN(M) && (M = null), N_(c3, p3, null, true, false);
        for (var I = c3.firstChild; I; )
          this._parseNode(I, p3, g3, null, false, false), I = I.nextSibling;
        bwt(this._defs, this._defsUsePending), this._defsUsePending = [];
        var k3, L;
        if (b3) {
          var F = dne(b3);
          F.length >= 4 && (k3 = { x: parseFloat(F[0] || 0), y: parseFloat(F[1] || 0), width: parseFloat(F[2]), height: parseFloat(F[3]) });
        }
        if (k3 && w3 != null && M != null && (L = wFe(k3, { x: 0, y: 0, width: w3, height: M }), !t3.ignoreViewBox)) {
          var B = p3;
          p3 = new vs(), p3.add(B), B.scaleX = B.scaleY = L.scale, B.x = L.x, B.y = L.y;
        }
        return !t3.ignoreRootClip && w3 != null && M != null && p3.setClipPath(new bu({ shape: { x: 0, y: 0, width: w3, height: M } })), { root: p3, width: w3, height: M, viewBoxRect: k3, viewBoxTransform: L, named: g3 };
      }, o.prototype._parseNode = function(i, t3, c3, p3, g3, b3) {
        var w3 = i.nodeName.toLowerCase(), M, I = p3;
        if (w3 === "defs" && (g3 = true), w3 === "text" && (b3 = true), w3 === "defs" || w3 === "switch")
          M = t3;
        else {
          if (!g3) {
            var k3 = eye[w3];
            if (k3 && so(eye, w3)) {
              M = k3.call(this, i, t3);
              var L = i.getAttribute("name");
              if (L) {
                var F = { name: L, namedFrom: null, svgNodeTagLower: w3, el: M };
                c3.push(F), w3 === "g" && (I = F);
              } else
                p3 && c3.push({ name: p3.name, namedFrom: p3, svgNodeTagLower: w3, el: M });
              t3.add(M);
            }
          }
          var B = vFe[w3];
          if (B && so(vFe, w3)) {
            var G = B.call(this, i), J = i.getAttribute("id");
            J && (this._defs[J] = G);
          }
        }
        if (M && M.isGroup)
          for (var Q = i.firstChild; Q; )
            Q.nodeType === 1 ? this._parseNode(Q, M, c3, I, g3, b3) : Q.nodeType === 3 && b3 && this._parseText(Q, M), Q = Q.nextSibling;
      }, o.prototype._parseText = function(i, t3) {
        var c3 = new HP({ style: { text: i.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
        Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), ywt(c3, t3);
        var p3 = c3.style, g3 = p3.fontSize;
        g3 && g3 < 9 && (p3.fontSize = 9, c3.scaleX *= g3 / 9, c3.scaleY *= g3 / 9);
        var b3 = (p3.fontSize || p3.fontFamily) && [p3.fontStyle, p3.fontWeight, (p3.fontSize || 12) + "px", p3.fontFamily || "sans-serif"].join(" ");
        p3.font = b3;
        var w3 = c3.getBoundingRect();
        return this._textX += w3.width, t3.add(c3), c3;
      }, o.internalField = function() {
        eye = { g: function(i, t3) {
          var c3 = new vs();
          return Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), c3;
        }, rect: function(i, t3) {
          var c3 = new bu();
          return Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), c3.setShape({ x: parseFloat(i.getAttribute("x") || "0"), y: parseFloat(i.getAttribute("y") || "0"), width: parseFloat(i.getAttribute("width") || "0"), height: parseFloat(i.getAttribute("height") || "0") }), c3.silent = true, c3;
        }, circle: function(i, t3) {
          var c3 = new Mw();
          return Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), c3.setShape({ cx: parseFloat(i.getAttribute("cx") || "0"), cy: parseFloat(i.getAttribute("cy") || "0"), r: parseFloat(i.getAttribute("r") || "0") }), c3.silent = true, c3;
        }, line: function(i, t3) {
          var c3 = new Ud();
          return Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), c3.setShape({ x1: parseFloat(i.getAttribute("x1") || "0"), y1: parseFloat(i.getAttribute("y1") || "0"), x2: parseFloat(i.getAttribute("x2") || "0"), y2: parseFloat(i.getAttribute("y2") || "0") }), c3.silent = true, c3;
        }, ellipse: function(i, t3) {
          var c3 = new vH();
          return Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), c3.setShape({ cx: parseFloat(i.getAttribute("cx") || "0"), cy: parseFloat(i.getAttribute("cy") || "0"), rx: parseFloat(i.getAttribute("rx") || "0"), ry: parseFloat(i.getAttribute("ry") || "0") }), c3.silent = true, c3;
        }, polygon: function(i, t3) {
          var c3 = i.getAttribute("points"), p3;
          c3 && (p3 = mFe(c3));
          var g3 = new _m({ shape: { points: p3 || [] }, silent: true });
          return Rw(t3, g3), N_(i, g3, this._defsUsePending, false, false), g3;
        }, polyline: function(i, t3) {
          var c3 = i.getAttribute("points"), p3;
          c3 && (p3 = mFe(c3));
          var g3 = new xm({ shape: { points: p3 || [] }, silent: true });
          return Rw(t3, g3), N_(i, g3, this._defsUsePending, false, false), g3;
        }, image: function(i, t3) {
          var c3 = new Gv();
          return Rw(t3, c3), N_(i, c3, this._defsUsePending, false, false), c3.setStyle({ image: i.getAttribute("xlink:href") || i.getAttribute("href"), x: +i.getAttribute("x"), y: +i.getAttribute("y"), width: +i.getAttribute("width"), height: +i.getAttribute("height") }), c3.silent = true, c3;
        }, text: function(i, t3) {
          var c3 = i.getAttribute("x") || "0", p3 = i.getAttribute("y") || "0", g3 = i.getAttribute("dx") || "0", b3 = i.getAttribute("dy") || "0";
          this._textX = parseFloat(c3) + parseFloat(g3), this._textY = parseFloat(p3) + parseFloat(b3);
          var w3 = new vs();
          return Rw(t3, w3), N_(i, w3, this._defsUsePending, false, true), w3;
        }, tspan: function(i, t3) {
          var c3 = i.getAttribute("x"), p3 = i.getAttribute("y");
          c3 != null && (this._textX = parseFloat(c3)), p3 != null && (this._textY = parseFloat(p3));
          var g3 = i.getAttribute("dx") || "0", b3 = i.getAttribute("dy") || "0", w3 = new vs();
          return Rw(t3, w3), N_(i, w3, this._defsUsePending, false, true), this._textX += parseFloat(g3), this._textY += parseFloat(b3), w3;
        }, path: function(i, t3) {
          var c3 = i.getAttribute("d") || "", p3 = Wee(c3);
          return Rw(t3, p3), N_(i, p3, this._defsUsePending, false, false), p3.silent = true, p3;
        } };
      }(), o;
    }(), vFe = { lineargradient: function(o) {
      var i = parseInt(o.getAttribute("x1") || "0", 10), t3 = parseInt(o.getAttribute("y1") || "0", 10), c3 = parseInt(o.getAttribute("x2") || "10", 10), p3 = parseInt(o.getAttribute("y2") || "0", 10), g3 = new JP(i, t3, c3, p3);
      return gFe(o, g3), yFe(o, g3), g3;
    }, radialgradient: function(o) {
      var i = parseInt(o.getAttribute("cx") || "0", 10), t3 = parseInt(o.getAttribute("cy") || "0", 10), c3 = parseInt(o.getAttribute("r") || "0", 10), p3 = new a8(i, t3, c3);
      return gFe(o, p3), yFe(o, p3), p3;
    } };
    function gFe(o, i) {
      var t3 = o.getAttribute("gradientUnits");
      t3 === "userSpaceOnUse" && (i.global = true);
    }
    function yFe(o, i) {
      for (var t3 = o.firstChild; t3; ) {
        if (t3.nodeType === 1 && t3.nodeName.toLocaleLowerCase() === "stop") {
          var c3 = t3.getAttribute("offset"), p3 = void 0;
          c3 && c3.indexOf("%") > 0 ? p3 = parseInt(c3, 10) / 100 : c3 ? p3 = parseFloat(c3) : p3 = 0;
          var g3 = {};
          xFe(t3, g3, g3);
          var b3 = g3.stopColor || t3.getAttribute("stop-color") || "#000000";
          i.colorStops.push({ offset: p3, color: b3 });
        }
        t3 = t3.nextSibling;
      }
    }
    function Rw(o, i) {
      o && o.__inheritedStyle && (i.__inheritedStyle || (i.__inheritedStyle = {}), Uo(i.__inheritedStyle, o.__inheritedStyle));
    }
    function mFe(o) {
      for (var i = dne(o), t3 = [], c3 = 0; c3 < i.length; c3 += 2) {
        var p3 = parseFloat(i[c3]), g3 = parseFloat(i[c3 + 1]);
        t3.push([p3, g3]);
      }
      return t3;
    }
    function N_(o, i, t3, c3, p3) {
      var g3 = i, b3 = g3.__inheritedStyle = g3.__inheritedStyle || {}, w3 = {};
      o.nodeType === 1 && (wwt(o, i), xFe(o, b3, w3), c3 || Swt(o, b3, w3)), g3.style = g3.style || {}, b3.fill != null && (g3.style.fill = bFe(g3, "fill", b3.fill, t3)), b3.stroke != null && (g3.style.stroke = bFe(g3, "stroke", b3.stroke, t3)), yt(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(M) {
        b3[M] != null && (g3.style[M] = parseFloat(b3[M]));
      }), yt(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(M) {
        b3[M] != null && (g3.style[M] = b3[M]);
      }), p3 && (g3.__selfStyle = w3), b3.lineDash && (g3.style.lineDash = Fi(dne(b3.lineDash), function(M) {
        return parseFloat(M);
      })), (b3.visibility === "hidden" || b3.visibility === "collapse") && (g3.invisible = true), b3.display === "none" && (g3.ignore = true);
    }
    function ywt(o, i) {
      var t3 = i.__selfStyle;
      if (t3) {
        var c3 = t3.textBaseline, p3 = c3;
        !c3 || c3 === "auto" || c3 === "baseline" ? p3 = "alphabetic" : c3 === "before-edge" || c3 === "text-before-edge" ? p3 = "top" : c3 === "after-edge" || c3 === "text-after-edge" ? p3 = "bottom" : (c3 === "central" || c3 === "mathematical") && (p3 = "middle"), o.style.textBaseline = p3;
      }
      var g3 = i.__inheritedStyle;
      if (g3) {
        var b3 = g3.textAlign, w3 = b3;
        b3 && (b3 === "middle" && (w3 = "center"), o.style.textAlign = w3);
      }
    }
    var mwt = /^url\(\s*#(.*?)\)/;
    function bFe(o, i, t3, c3) {
      var p3 = t3 && t3.match(mwt);
      if (p3) {
        var g3 = S1(p3[1]);
        c3.push([o, i, g3]);
        return;
      }
      return t3 === "none" && (t3 = null), t3;
    }
    function bwt(o, i) {
      for (var t3 = 0; t3 < i.length; t3++) {
        var c3 = i[t3];
        c3[0].style[c3[1]] = o[c3[2]];
      }
    }
    var _wt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
    function dne(o) {
      return o.match(_wt) || [];
    }
    var xwt = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, tye = Math.PI / 180;
    function wwt(o, i) {
      var t3 = o.getAttribute("transform");
      if (t3) {
        t3 = t3.replace(/,/g, " ");
        var c3 = [], p3 = null;
        t3.replace(xwt, function(L, F, B) {
          return c3.push(F, B), "";
        });
        for (var g3 = c3.length - 1; g3 > 0; g3 -= 2) {
          var b3 = c3[g3], w3 = c3[g3 - 1], M = dne(b3);
          switch (p3 = p3 || dm(), w3) {
            case "translate":
              D1(p3, p3, [parseFloat(M[0]), parseFloat(M[1] || "0")]);
              break;
            case "scale":
              CF(p3, p3, [parseFloat(M[0]), parseFloat(M[1] || M[0])]);
              break;
            case "rotate":
              cI(p3, p3, -parseFloat(M[0]) * tye);
              break;
            case "skewX":
              var I = Math.tan(parseFloat(M[0]) * tye);
              pw(p3, [1, 0, I, 1, 0, 0], p3);
              break;
            case "skewY":
              var k3 = Math.tan(parseFloat(M[0]) * tye);
              pw(p3, [1, k3, 0, 1, 0, 0], p3);
              break;
            case "matrix":
              p3[0] = parseFloat(M[0]), p3[1] = parseFloat(M[1]), p3[2] = parseFloat(M[2]), p3[3] = parseFloat(M[3]), p3[4] = parseFloat(M[4]), p3[5] = parseFloat(M[5]);
              break;
          }
        }
        i.setLocalTransform(p3);
      }
    }
    var _Fe = /([^\s:;]+)\s*:\s*([^:;]+)/g;
    function xFe(o, i, t3) {
      var c3 = o.getAttribute("style");
      if (c3) {
        _Fe.lastIndex = 0;
        for (var p3; (p3 = _Fe.exec(c3)) != null; ) {
          var g3 = p3[1], b3 = so(hne, g3) ? hne[g3] : null;
          b3 && (i[b3] = p3[2]);
          var w3 = so(pne, g3) ? pne[g3] : null;
          w3 && (t3[w3] = p3[2]);
        }
      }
    }
    function Swt(o, i, t3) {
      for (var c3 = 0; c3 < pFe.length; c3++) {
        var p3 = pFe[c3], g3 = o.getAttribute(p3);
        g3 != null && (i[hne[p3]] = g3);
      }
      for (var c3 = 0; c3 < dFe.length; c3++) {
        var p3 = dFe[c3], g3 = o.getAttribute(p3);
        g3 != null && (t3[pne[p3]] = g3);
      }
    }
    function wFe(o, i) {
      var t3 = i.width / o.width, c3 = i.height / o.height, p3 = Math.min(t3, c3);
      return { scale: p3, x: -(o.x + o.width / 2) * p3 + (i.x + i.width / 2), y: -(o.y + o.height / 2) * p3 + (i.y + i.height / 2) };
    }
    function Cwt(o, i) {
      var t3 = new gwt();
      return t3.parse(o, i);
    }
    var Mwt = Eo(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), Twt = function() {
      function o(i, t3) {
        this.type = "geoSVG", this._usedGraphicMap = Eo(), this._freedGraphics = [], this._mapName = i, this._parsedXML = hFe(t3);
      }
      return o.prototype.load = function() {
        var i = this._firstGraphic;
        if (!i) {
          i = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(i), this._boundingRect = this._firstGraphic.boundingRect.clone();
          var t3 = Iwt(i.named), c3 = t3.regions, p3 = t3.regionsMap;
          this._regions = c3, this._regionsMap = p3;
        }
        return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
      }, o.prototype._buildGraphic = function(i) {
        var t3, c3;
        try {
          t3 = i && Cwt(i, { ignoreViewBox: true, ignoreRootClip: true }) || {}, c3 = t3.root, u0(c3 != null);
        } catch (Q) {
          throw new Error(`Invalid svg format
` + Q.message);
        }
        var p3 = new vs();
        p3.add(c3), p3.isGeoSVGGraphicRoot = true;
        var g3 = t3.width, b3 = t3.height, w3 = t3.viewBoxRect, M = this._boundingRect;
        if (!M) {
          var I = void 0, k3 = void 0, L = void 0, F = void 0;
          if (g3 != null ? (I = 0, L = g3) : w3 && (I = w3.x, L = w3.width), b3 != null ? (k3 = 0, F = b3) : w3 && (k3 = w3.y, F = w3.height), I == null || k3 == null) {
            var B = c3.getBoundingRect();
            I == null && (I = B.x, L = B.width), k3 == null && (k3 = B.y, F = B.height);
          }
          M = this._boundingRect = new Ys(I, k3, L, F);
        }
        if (w3) {
          var G = wFe(w3, M);
          c3.scaleX = c3.scaleY = G.scale, c3.x = G.x, c3.y = G.y;
        }
        p3.setClipPath(new bu({ shape: M.plain() }));
        var J = [];
        return yt(t3.named, function(Q) {
          Mwt.get(Q.svgNodeTagLower) != null && (J.push(Q), Awt(Q.el));
        }), { root: p3, boundingRect: M, named: J };
      }, o.prototype.useGraphic = function(i) {
        var t3 = this._usedGraphicMap, c3 = t3.get(i);
        return c3 || (c3 = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), t3.set(i, c3), c3);
      }, o.prototype.freeGraphic = function(i) {
        var t3 = this._usedGraphicMap, c3 = t3.get(i);
        c3 && (t3.removeKey(i), this._freedGraphics.push(c3));
      }, o;
    }();
    function Awt(o) {
      o.silent = false, o.isGroup && o.traverse(function(i) {
        i.silent = false;
      });
    }
    function Iwt(o) {
      var i = [], t3 = Eo();
      return yt(o, function(c3) {
        if (c3.namedFrom == null) {
          var p3 = new q1t(c3.name, c3.el);
          i.push(p3), t3.set(c3.name, p3);
        }
      }), { regions: i, regionsMap: t3 };
    }
    for (var nye = [126, 25], SFe = "\u5357\u6D77\u8BF8\u5C9B", _L = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]], xL = 0; xL < _L.length; xL++)
      for (var V8 = 0; V8 < _L[xL].length; V8++)
        _L[xL][V8][0] /= 10.5, _L[xL][V8][1] /= -10.5 / 0.75, _L[xL][V8][0] += nye[0], _L[xL][V8][1] += nye[1];
    function Ewt(o, i) {
      if (o === "china") {
        for (var t3 = 0; t3 < i.length; t3++)
          if (i[t3].name === SFe)
            return;
        i.push(new g6e(SFe, Fi(_L, function(c3) {
          return { type: "polygon", exterior: c3 };
        }), nye));
      }
    }
    var Dwt = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
    function kwt(o, i) {
      if (o === "china") {
        var t3 = Dwt[i.name];
        if (t3) {
          var c3 = i.getCenter();
          c3[0] += t3[0] / 10.5, c3[1] += -t3[1] / (10.5 / 0.75), i.setCenter(c3);
        }
      }
    }
    var Owt = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
    function Pwt(o, i) {
      o === "china" && i.name === "\u53F0\u6E7E" && i.geometries.push({ type: "polygon", exterior: Owt[0] });
    }
    var Lwt = "name", Rwt = function() {
      function o(i, t3, c3) {
        this.type = "geoJSON", this._parsedMap = Eo(), this._mapName = i, this._specialAreas = c3, this._geoJSON = Fwt(t3);
      }
      return o.prototype.load = function(i, t3) {
        t3 = t3 || Lwt;
        var c3 = this._parsedMap.get(t3);
        if (!c3) {
          var p3 = this._parseToRegions(t3);
          c3 = this._parsedMap.set(t3, { regions: p3, boundingRect: Nwt(p3) });
        }
        var g3 = Eo(), b3 = [];
        return yt(c3.regions, function(w3) {
          var M = w3.name;
          i && so(i, M) && (w3 = w3.cloneShallow(M = i[M])), b3.push(w3), g3.set(M, w3);
        }), { regions: b3, boundingRect: c3.boundingRect || new Ys(0, 0, 0, 0), regionsMap: g3 };
      }, o.prototype._parseToRegions = function(i) {
        var t3 = this._mapName, c3 = this._geoJSON, p3;
        try {
          p3 = c3 ? X1t(c3, i) : [];
        } catch (g3) {
          throw new Error(`Invalid geoJson format
` + g3.message);
        }
        return Ewt(t3, p3), yt(p3, function(g3) {
          var b3 = g3.name;
          kwt(t3, g3), Pwt(t3, g3);
          var w3 = this._specialAreas && this._specialAreas[b3];
          w3 && g3.transformTo(w3.left, w3.top, w3.width, w3.height);
        }, this), p3;
      }, o.prototype.getMapForUser = function() {
        return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
      }, o;
    }();
    function Nwt(o) {
      for (var i, t3 = 0; t3 < o.length; t3++) {
        var c3 = o[t3].getBoundingRect();
        i = i || c3.clone(), i.union(c3);
      }
      return i;
    }
    function Fwt(o) {
      return Ha(o) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(o) : new Function("return (" + o + ");")() : o;
    }
    var vW = Eo(), zI = { registerMap: function(o, i, t3) {
      if (i.svg) {
        var c3 = new Twt(o, i.svg);
        vW.set(o, c3);
      } else {
        var p3 = i.geoJson || i.geoJSON;
        p3 && !i.features ? t3 = i.specialAreas : p3 = i;
        var c3 = new Rwt(o, p3, t3);
        vW.set(o, c3);
      }
    }, getGeoResource: function(o) {
      return vW.get(o);
    }, getMapForUser: function(o) {
      var i = vW.get(o);
      return i && i.type === "geoJSON" && i.getMapForUser();
    }, load: function(o, i, t3) {
      var c3 = vW.get(o);
      if (c3)
        return c3.load(i, t3);
    } }, rye = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], Vwt = Eo(rye), Bwt = Eo(rye.concat(["g"])), zwt = Eo(rye.concat(["g"])), CFe = mu();
    function vne(o) {
      var i = o.getItemStyle(), t3 = o.get("areaColor");
      return t3 != null && (i.fill = t3), i;
    }
    function MFe(o) {
      var i = o.style;
      i && (i.stroke = i.stroke || i.fill, i.fill = null);
    }
    var jwt = function() {
      function o(i) {
        var t3 = new vs();
        this.uid = d8("ec_map_draw"), this._controller = new dW(i.getZr()), this._controllerHost = { target: t3 }, this.group = t3, t3.add(this._regionsGroup = new vs()), t3.add(this._svgGroup = new vs());
      }
      return o.prototype.draw = function(i, t3, c3, p3, g3) {
        var b3 = i.mainType === "geo", w3 = i.getData && i.getData();
        b3 && t3.eachComponent({ mainType: "series", subType: "map" }, function(se) {
          !w3 && se.getHostGeoModel() === i && (w3 = se.getData());
        });
        var M = i.coordinateSystem, I = this._regionsGroup, k3 = this.group, L = M.getTransformInfo(), F = L.raw, B = L.roam, G = !I.childAt(0) || g3;
        G ? (k3.x = B.x, k3.y = B.y, k3.scaleX = B.scaleX, k3.scaleY = B.scaleY, k3.dirty()) : Du(k3, B, i);
        var J = w3 && w3.getVisual("visualMeta") && w3.getVisual("visualMeta").length > 0, Q = { api: c3, geo: M, mapOrGeoModel: i, data: w3, isVisualEncodedByVisualMap: J, isGeo: b3, transformInfoRaw: F };
        M.resourceType === "geoJSON" ? this._buildGeoJSON(Q) : M.resourceType === "geoSVG" && this._buildSVG(Q), this._updateController(i, t3, c3), this._updateMapSelectHandler(i, I, c3, p3);
      }, o.prototype._buildGeoJSON = function(i) {
        var t3 = this._regionsGroupByName = Eo(), c3 = Eo(), p3 = this._regionsGroup, g3 = i.transformInfoRaw, b3 = i.mapOrGeoModel, w3 = i.data, M = i.geo.projection, I = M && M.stream;
        function k3(B, G) {
          return G && (B = G(B)), B && [B[0] * g3.scaleX + g3.x, B[1] * g3.scaleY + g3.y];
        }
        function L(B) {
          for (var G = [], J = !I && M && M.project, Q = 0; Q < B.length; ++Q) {
            var se = k3(B[Q], J);
            se && G.push(se);
          }
          return G;
        }
        function F(B) {
          return { shape: { points: L(B) } };
        }
        p3.removeAll(), yt(i.geo.regions, function(B) {
          var G = B.name, J = t3.get(G), Q = c3.get(G) || {}, se = Q.dataIdx, he = Q.regionModel;
          J || (J = t3.set(G, new vs()), p3.add(J), se = w3 ? w3.indexOfName(G) : null, he = i.isGeo ? b3.getRegionModel(G) : w3 ? w3.getItemModel(se) : null, c3.set(G, { dataIdx: se, regionModel: he }));
          var be = [], de = [];
          yt(B.geometries, function(ze) {
            if (ze.type === "polygon") {
              var $e = [ze.exterior].concat(ze.interiors || []);
              I && ($e = kFe($e, I)), yt($e, function(nt) {
                be.push(new _m(F(nt)));
              });
            } else {
              var Ke = ze.points;
              I && (Ke = kFe(Ke, I, true)), yt(Ke, function(nt) {
                de.push(new xm(F(nt)));
              });
            }
          });
          var Fe = k3(B.getCenter(), M && M.project);
          function Pe(ze, $e) {
            if (ze.length) {
              var Ke = new _H({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: ze } });
              J.add(Ke), TFe(i, Ke, se, he), AFe(i, Ke, G, he, b3, se, Fe), $e && (MFe(Ke), yt(Ke.states, MFe));
            }
          }
          Pe(be), Pe(de, true);
        }), t3.each(function(B, G) {
          var J = c3.get(G), Q = J.dataIdx, se = J.regionModel;
          IFe(i, B, G, se, b3, Q), EFe(i, B, G, se, b3), DFe(i, B, G, se, b3);
        }, this);
      }, o.prototype._buildSVG = function(i) {
        var t3 = i.geo.map, c3 = i.transformInfoRaw;
        this._svgGroup.x = c3.x, this._svgGroup.y = c3.y, this._svgGroup.scaleX = c3.scaleX, this._svgGroup.scaleY = c3.scaleY, this._svgResourceChanged(t3) && (this._freeSVG(), this._useSVG(t3));
        var p3 = this._svgDispatcherMap = Eo(), g3 = false;
        yt(this._svgGraphicRecord.named, function(b3) {
          var w3 = b3.name, M = i.mapOrGeoModel, I = i.data, k3 = b3.svgNodeTagLower, L = b3.el, F = I ? I.indexOfName(w3) : null, B = M.getRegionModel(w3);
          if (Vwt.get(k3) != null && L instanceof Ab && TFe(i, L, F, B), L instanceof Ab && (L.culling = true), L.z2EmphasisLift = 0, !b3.namedFrom && (zwt.get(k3) != null && AFe(i, L, w3, B, M, F, null), IFe(i, L, w3, B, M, F), EFe(i, L, w3, B, M), Bwt.get(k3) != null)) {
            var G = DFe(i, L, w3, B, M);
            G === "self" && (g3 = true);
            var J = p3.get(w3) || p3.set(w3, []);
            J.push(L);
          }
        }, this), this._enableBlurEntireSVG(g3, i);
      }, o.prototype._enableBlurEntireSVG = function(i, t3) {
        if (i && t3.isGeo) {
          var c3 = t3.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), p3 = c3.opacity;
          this._svgGraphicRecord.root.traverse(function(g3) {
            if (!g3.isGroup) {
              AI(g3);
              var b3 = g3.ensureState("blur").style || {};
              b3.opacity == null && p3 != null && (b3.opacity = p3), g3.ensureState("emphasis");
            }
          });
        }
      }, o.prototype.remove = function() {
        this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
      }, o.prototype.findHighDownDispatchers = function(i, t3) {
        if (i == null)
          return [];
        var c3 = t3.coordinateSystem;
        if (c3.resourceType === "geoJSON") {
          var p3 = this._regionsGroupByName;
          if (p3) {
            var g3 = p3.get(i);
            return g3 ? [g3] : [];
          }
        } else if (c3.resourceType === "geoSVG")
          return this._svgDispatcherMap && this._svgDispatcherMap.get(i) || [];
      }, o.prototype._svgResourceChanged = function(i) {
        return this._svgMapName !== i;
      }, o.prototype._useSVG = function(i) {
        var t3 = zI.getGeoResource(i);
        if (t3 && t3.type === "geoSVG") {
          var c3 = t3.useGraphic(this.uid);
          this._svgGroup.add(c3.root), this._svgGraphicRecord = c3, this._svgMapName = i;
        }
      }, o.prototype._freeSVG = function() {
        var i = this._svgMapName;
        if (i != null) {
          var t3 = zI.getGeoResource(i);
          t3 && t3.type === "geoSVG" && t3.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
        }
      }, o.prototype._updateController = function(i, t3, c3) {
        var p3 = i.coordinateSystem, g3 = this._controller, b3 = this._controllerHost;
        b3.zoomLimit = i.get("scaleLimit"), b3.zoom = p3.getZoom(), g3.enable(i.get("roam") || false);
        var w3 = i.mainType;
        function M() {
          var I = { type: "geoRoam", componentType: w3 };
          return I[w3 + "Id"] = i.id, I;
        }
        g3.off("pan").on("pan", function(I) {
          this._mouseDownFlag = false, J0e(b3, I.dx, I.dy), c3.dispatchAction(ti(M(), { dx: I.dx, dy: I.dy, animation: { duration: 0 } }));
        }, this), g3.off("zoom").on("zoom", function(I) {
          this._mouseDownFlag = false, Q0e(b3, I.scale, I.originX, I.originY), c3.dispatchAction(ti(M(), { zoom: I.scale, originX: I.originX, originY: I.originY, animation: { duration: 0 } }));
        }, this), g3.setPointerChecker(function(I, k3, L) {
          return p3.containPoint([k3, L]) && !fne(I, c3, i);
        });
      }, o.prototype.resetForLabelLayout = function() {
        this.group.traverse(function(i) {
          var t3 = i.getTextContent();
          t3 && (t3.ignore = CFe(t3).ignore);
        });
      }, o.prototype._updateMapSelectHandler = function(i, t3, c3, p3) {
        var g3 = this;
        t3.off("mousedown"), t3.off("click"), i.get("selectedMode") && (t3.on("mousedown", function() {
          g3._mouseDownFlag = true;
        }), t3.on("click", function(b3) {
          !g3._mouseDownFlag || (g3._mouseDownFlag = false);
        }));
      }, o;
    }();
    function TFe(o, i, t3, c3) {
      var p3 = c3.getModel("itemStyle"), g3 = c3.getModel(["emphasis", "itemStyle"]), b3 = c3.getModel(["blur", "itemStyle"]), w3 = c3.getModel(["select", "itemStyle"]), M = vne(p3), I = vne(g3), k3 = vne(w3), L = vne(b3), F = o.data;
      if (F) {
        var B = F.getItemVisual(t3, "style"), G = F.getItemVisual(t3, "decal");
        o.isVisualEncodedByVisualMap && B.fill && (M.fill = B.fill), G && (M.decal = GH(G, o.api));
      }
      i.setStyle(M), i.style.strokeNoScale = true, i.ensureState("emphasis").style = I, i.ensureState("select").style = k3, i.ensureState("blur").style = L, AI(i);
    }
    function AFe(o, i, t3, c3, p3, g3, b3) {
      var w3 = o.data, M = o.isGeo, I = w3 && isNaN(w3.get(w3.mapDimension("value"), g3)), k3 = w3 && w3.getItemLayout(g3);
      if (M || I || k3 && k3.showLabel) {
        var L = M ? t3 : g3, F = void 0;
        (!w3 || g3 >= 0) && (F = p3);
        var B = b3 ? { normal: { align: "center", verticalAlign: "middle" } } : null;
        Sm(i, g0(c3), { labelFetcher: F, labelDataIndex: L, defaultText: t3 }, B);
        var G = i.getTextContent();
        if (G && (CFe(G).ignore = G.ignore, i.textConfig && b3)) {
          var J = i.getBoundingRect().clone();
          i.textConfig.layoutRect = J, i.textConfig.position = [(b3[0] - J.x) / J.width * 100 + "%", (b3[1] - J.y) / J.height * 100 + "%"];
        }
        i.disableLabelAnimation = true;
      } else
        i.removeTextContent(), i.removeTextConfig(), i.disableLabelAnimation = null;
    }
    function IFe(o, i, t3, c3, p3, g3) {
      o.data ? o.data.setItemGraphicEl(g3, i) : La(i).eventData = { componentType: "geo", componentIndex: p3.componentIndex, geoIndex: p3.componentIndex, name: t3, region: c3 && c3.option || {} };
    }
    function EFe(o, i, t3, c3, p3) {
      o.data || h8({ el: i, componentModel: p3, itemName: t3, itemTooltipOption: c3.get("tooltip") });
    }
    function DFe(o, i, t3, c3, p3) {
      i.highDownSilentOnTouch = !!p3.get("selectedMode");
      var g3 = c3.getModel("emphasis"), b3 = g3.get("focus");
      return zp(i, b3, g3.get("blurScope"), g3.get("disabled")), o.isGeo && Mve(i, p3, t3), b3;
    }
    function kFe(o, i, t3) {
      var c3 = [], p3;
      function g3() {
        p3 = [];
      }
      function b3() {
        p3.length && (c3.push(p3), p3 = []);
      }
      var w3 = i({ polygonStart: g3, polygonEnd: b3, lineStart: g3, lineEnd: b3, point: function(M, I) {
        isFinite(M) && isFinite(I) && p3.push([M, I]);
      }, sphere: function() {
      } });
      return !t3 && w3.polygonStart(), yt(o, function(M) {
        w3.lineStart();
        for (var I = 0; I < M.length; I++)
          w3.point(M[I][0], M[I][1]);
        w3.lineEnd();
      }), !t3 && w3.polygonEnd(), c3;
    }
    var OFe = jwt, Gwt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        if (!(g3 && g3.type === "mapToggleSelect" && g3.from === this.uid)) {
          var b3 = this.group;
          if (b3.removeAll(), !t3.getHostGeoModel()) {
            if (this._mapDraw && g3 && g3.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), g3 && g3.type === "geoRoam" && g3.componentType === "series" && g3.seriesId === t3.id) {
              var w3 = this._mapDraw;
              w3 && b3.add(w3.group);
            } else if (t3.needsDrawMap) {
              var w3 = this._mapDraw || new OFe(p3);
              b3.add(w3.group), w3.draw(t3, c3, p3, this, g3), this._mapDraw = w3;
            } else
              this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
            t3.get("showLegendSymbol") && c3.getComponent("legend") && this._renderSymbols(t3, c3, p3);
          }
        }
      }, i.prototype.remove = function() {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
      }, i.prototype.dispose = function() {
        this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
      }, i.prototype._renderSymbols = function(t3, c3, p3) {
        var g3 = t3.originalData, b3 = this.group;
        g3.each(g3.mapDimension("value"), function(w3, M) {
          if (!isNaN(w3)) {
            var I = g3.getItemLayout(M);
            if (!(!I || !I.point)) {
              var k3 = I.point, L = I.offset, F = new Mw({ style: { fill: t3.getData().getVisual("style").fill }, shape: { cx: k3[0] + L * 9, cy: k3[1], r: 3 }, silent: true, z2: 8 + (L ? 0 : qM + 1) });
              if (!L) {
                var B = t3.mainSeries.getData(), G = g3.getName(M), J = B.indexOfName(G), Q = g3.getItemModel(M), se = Q.getModel("label"), he = B.getItemGraphicEl(J);
                Sm(F, g0(Q), { labelFetcher: { getFormattedLabel: function(be, de) {
                  return t3.getFormattedLabel(J, de);
                } }, defaultText: G }), F.disableLabelAnimation = true, se.get("position") || F.setTextConfig({ position: "bottom" }), he.onHoverStateChange = function(be) {
                  TI(F, be);
                };
              }
              b3.add(F);
            }
          }
        });
      }, i.type = "map", i;
    }(yh), Hwt = Gwt, Wwt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.needsDrawMap = false, t3.seriesGroup = [], t3.getTooltipPosition = function(c3) {
          if (c3 != null) {
            var p3 = this.getData().getName(c3), g3 = this.coordinateSystem, b3 = g3.getRegion(p3);
            return b3 && g3.dataToPoint(b3.getCenter());
          }
        }, t3;
      }
      return i.prototype.getInitialData = function(t3) {
        for (var c3 = N8(this, { coordDimensions: ["value"], encodeDefaulter: As(pge, this) }), p3 = Eo(), g3 = [], b3 = 0, w3 = c3.count(); b3 < w3; b3++) {
          var M = c3.getName(b3);
          p3.set(M, true);
        }
        var I = zI.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
        return yt(I.regions, function(k3) {
          var L = k3.name;
          p3.get(L) || g3.push(L);
        }), c3.appendValues([], g3), c3;
      }, i.prototype.getHostGeoModel = function() {
        var t3 = this.option.geoIndex;
        return t3 != null ? this.ecModel.getComponent("geo", t3) : null;
      }, i.prototype.getMapType = function() {
        return (this.getHostGeoModel() || this).option.map;
      }, i.prototype.getRawValue = function(t3) {
        var c3 = this.getData();
        return c3.get(c3.mapDimension("value"), t3);
      }, i.prototype.getRegionModel = function(t3) {
        var c3 = this.getData();
        return c3.getItemModel(c3.indexOfName(t3));
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        for (var g3 = this.getData(), b3 = this.getRawValue(t3), w3 = g3.getName(t3), M = this.seriesGroup, I = [], k3 = 0; k3 < M.length; k3++) {
          var L = M[k3].originalData.indexOfName(w3), F = g3.mapDimension("value");
          isNaN(M[k3].originalData.get(F, L)) || I.push(M[k3].name);
        }
        return Cg("section", { header: I.join(", "), noHeader: !I.length, blocks: [Cg("nameValue", { name: w3, value: b3 })] });
      }, i.prototype.setZoom = function(t3) {
        this.option.zoom = t3;
      }, i.prototype.setCenter = function(t3) {
        this.option.center = t3;
      }, i.prototype.getLegendIcon = function(t3) {
        var c3 = t3.icon || "roundRect", p3 = pv(c3, 0, 0, t3.itemWidth, t3.itemHeight, t3.itemStyle.fill);
        return p3.setStyle(t3.itemStyle), p3.style.stroke = "none", c3.indexOf("empty") > -1 && (p3.style.stroke = p3.style.fill, p3.style.fill = "#fff", p3.style.lineWidth = 2), p3;
      }, i.type = "series.map", i.dependencies = ["geo"], i.layoutMode = "box", i.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, i;
    }(bp), Uwt = Wwt;
    function qwt(o, i) {
      var t3 = {};
      return yt(o, function(c3) {
        c3.each(c3.mapDimension("value"), function(p3, g3) {
          var b3 = "ec-" + c3.getName(g3);
          t3[b3] = t3[b3] || [], isNaN(p3) || t3[b3].push(p3);
        });
      }), o[0].map(o[0].mapDimension("value"), function(c3, p3) {
        for (var g3 = "ec-" + o[0].getName(p3), b3 = 0, w3 = 1 / 0, M = -1 / 0, I = t3[g3].length, k3 = 0; k3 < I; k3++)
          w3 = Math.min(w3, t3[g3][k3]), M = Math.max(M, t3[g3][k3]), b3 += t3[g3][k3];
        var L;
        return i === "min" ? L = w3 : i === "max" ? L = M : i === "average" ? L = b3 / I : L = b3, I === 0 ? NaN : L;
      });
    }
    function $wt(o) {
      var i = {};
      o.eachSeriesByType("map", function(t3) {
        var c3 = t3.getHostGeoModel(), p3 = c3 ? "o" + c3.id : "i" + t3.getMapType();
        (i[p3] = i[p3] || []).push(t3);
      }), yt(i, function(t3, c3) {
        for (var p3 = qwt(Fi(t3, function(b3) {
          return b3.getData();
        }), t3[0].get("mapValueCalculation")), g3 = 0; g3 < t3.length; g3++)
          t3[g3].originalData = t3[g3].getData();
        for (var g3 = 0; g3 < t3.length; g3++)
          t3[g3].seriesGroup = t3, t3[g3].needsDrawMap = g3 === 0 && !t3[g3].getHostGeoModel(), t3[g3].setData(p3.cloneShallow()), t3[g3].mainSeries = t3[0];
      });
    }
    function Xwt(o) {
      var i = {};
      o.eachSeriesByType("map", function(t3) {
        var c3 = t3.getMapType();
        if (!(t3.getHostGeoModel() || i[c3])) {
          var p3 = {};
          yt(t3.seriesGroup, function(b3) {
            var w3 = b3.coordinateSystem, M = b3.originalData;
            b3.get("showLegendSymbol") && o.getComponent("legend") && M.each(M.mapDimension("value"), function(I, k3) {
              var L = M.getName(k3), F = w3.getRegion(L);
              if (!(!F || isNaN(I))) {
                var B = p3[L] || 0, G = w3.dataToPoint(F.getCenter());
                p3[L] = B + 1, M.setItemLayout(k3, { point: G, offset: B });
              }
            });
          });
          var g3 = t3.getData();
          g3.each(function(b3) {
            var w3 = g3.getName(b3), M = g3.getItemLayout(b3) || {};
            M.showLabel = !p3[w3], g3.setItemLayout(b3, M);
          }), i[c3] = true;
        }
      });
    }
    var PFe = Vv, Ywt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this) || this;
        return c3.type = "view", c3.dimensions = ["x", "y"], c3._roamTransformable = new k1(), c3._rawTransformable = new k1(), c3.name = t3, c3;
      }
      return i.prototype.setBoundingRect = function(t3, c3, p3, g3) {
        return this._rect = new Ys(t3, c3, p3, g3), this._rect;
      }, i.prototype.getBoundingRect = function() {
        return this._rect;
      }, i.prototype.setViewRect = function(t3, c3, p3, g3) {
        this._transformTo(t3, c3, p3, g3), this._viewRect = new Ys(t3, c3, p3, g3);
      }, i.prototype._transformTo = function(t3, c3, p3, g3) {
        var b3 = this.getBoundingRect(), w3 = this._rawTransformable;
        w3.transform = b3.calculateTransform(new Ys(t3, c3, p3, g3));
        var M = w3.parent;
        w3.parent = null, w3.decomposeTransform(), w3.parent = M, this._updateTransform();
      }, i.prototype.setCenter = function(t3) {
        !t3 || (this._center = t3, this._updateCenterAndZoom());
      }, i.prototype.setZoom = function(t3) {
        t3 = t3 || 1;
        var c3 = this.zoomLimit;
        c3 && (c3.max != null && (t3 = Math.min(c3.max, t3)), c3.min != null && (t3 = Math.max(c3.min, t3))), this._zoom = t3, this._updateCenterAndZoom();
      }, i.prototype.getDefaultCenter = function() {
        var t3 = this.getBoundingRect(), c3 = t3.x + t3.width / 2, p3 = t3.y + t3.height / 2;
        return [c3, p3];
      }, i.prototype.getCenter = function() {
        return this._center || this.getDefaultCenter();
      }, i.prototype.getZoom = function() {
        return this._zoom || 1;
      }, i.prototype.getRoamTransform = function() {
        return this._roamTransformable.getLocalTransform();
      }, i.prototype._updateCenterAndZoom = function() {
        var t3 = this._rawTransformable.getLocalTransform(), c3 = this._roamTransformable, p3 = this.getDefaultCenter(), g3 = this.getCenter(), b3 = this.getZoom();
        g3 = Vv([], g3, t3), p3 = Vv([], p3, t3), c3.originX = g3[0], c3.originY = g3[1], c3.x = p3[0] - g3[0], c3.y = p3[1] - g3[1], c3.scaleX = c3.scaleY = b3, this._updateTransform();
      }, i.prototype._updateTransform = function() {
        var t3 = this._roamTransformable, c3 = this._rawTransformable;
        c3.parent = t3, t3.updateTransform(), c3.updateTransform(), SF(this.transform || (this.transform = []), c3.transform || dm()), this._rawTransform = c3.getLocalTransform(), this.invTransform = this.invTransform || [], fI(this.invTransform, this.transform), this.decomposeTransform();
      }, i.prototype.getTransformInfo = function() {
        var t3 = this._rawTransformable, c3 = this._roamTransformable, p3 = new k1();
        return p3.transform = c3.transform, p3.decomposeTransform(), { roam: { x: p3.x, y: p3.y, scaleX: p3.scaleX, scaleY: p3.scaleY }, raw: { x: t3.x, y: t3.y, scaleX: t3.scaleX, scaleY: t3.scaleY } };
      }, i.prototype.getViewRect = function() {
        return this._viewRect;
      }, i.prototype.getViewRectAfterRoam = function() {
        var t3 = this.getBoundingRect().clone();
        return t3.applyTransform(this.transform), t3;
      }, i.prototype.dataToPoint = function(t3, c3, p3) {
        var g3 = c3 ? this._rawTransform : this.transform;
        return p3 = p3 || [], g3 ? PFe(p3, t3, g3) : Zp(p3, t3);
      }, i.prototype.pointToData = function(t3) {
        var c3 = this.invTransform;
        return c3 ? PFe([], t3, c3) : [t3[0], t3[1]];
      }, i.prototype.convertToPixel = function(t3, c3, p3) {
        var g3 = LFe(c3);
        return g3 === this ? g3.dataToPoint(p3) : null;
      }, i.prototype.convertFromPixel = function(t3, c3, p3) {
        var g3 = LFe(c3);
        return g3 === this ? g3.pointToData(p3) : null;
      }, i.prototype.containPoint = function(t3) {
        return this.getViewRectAfterRoam().contain(t3[0], t3[1]);
      }, i.dimensions = ["x", "y"], i;
    }(k1);
    function LFe(o) {
      var i = o.seriesModel;
      return i ? i.coordinateSystem : null;
    }
    var gW = Ywt, Kwt = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, RFe = ["lng", "lat"], NFe = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this, t3) || this;
        g3.dimensions = RFe, g3.type = "geo", g3._nameCoordMap = Eo(), g3.map = c3;
        var b3 = p3.projection, w3 = zI.load(c3, p3.nameMap, p3.nameProperty), M = zI.getGeoResource(c3);
        g3.resourceType = M ? M.type : null;
        var I = g3.regions = w3.regions, k3 = Kwt[M.type];
        g3._regionsMap = w3.regionsMap, g3.regions = w3.regions, g3.projection = b3;
        var L;
        if (b3)
          for (var F = 0; F < I.length; F++) {
            var B = I[F].getBoundingRect(b3);
            L = L || B.clone(), L.union(B);
          }
        else
          L = w3.boundingRect;
        return g3.setBoundingRect(L.x, L.y, L.width, L.height), g3.aspectScale = b3 ? 1 : Xs(p3.aspectScale, k3.aspectScale), g3._invertLongitute = b3 ? false : k3.invertLongitute, g3;
      }
      return i.prototype._transformTo = function(t3, c3, p3, g3) {
        var b3 = this.getBoundingRect(), w3 = this._invertLongitute;
        b3 = b3.clone(), w3 && (b3.y = -b3.y - b3.height);
        var M = this._rawTransformable;
        M.transform = b3.calculateTransform(new Ys(t3, c3, p3, g3));
        var I = M.parent;
        M.parent = null, M.decomposeTransform(), M.parent = I, w3 && (M.scaleY = -M.scaleY), this._updateTransform();
      }, i.prototype.getRegion = function(t3) {
        return this._regionsMap.get(t3);
      }, i.prototype.getRegionByCoord = function(t3) {
        for (var c3 = this.regions, p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          if (g3.type === "geoJSON" && g3.contain(t3))
            return c3[p3];
        }
      }, i.prototype.addGeoCoord = function(t3, c3) {
        this._nameCoordMap.set(t3, c3);
      }, i.prototype.getGeoCoord = function(t3) {
        var c3 = this._regionsMap.get(t3);
        return this._nameCoordMap.get(t3) || c3 && c3.getCenter();
      }, i.prototype.dataToPoint = function(t3, c3, p3) {
        if (Ha(t3) && (t3 = this.getGeoCoord(t3)), t3) {
          var g3 = this.projection;
          return g3 && (t3 = g3.project(t3)), t3 && this.projectedToPoint(t3);
        }
      }, i.prototype.pointToData = function(t3) {
        var c3 = this.projection;
        return c3 && (t3 = c3.unproject(t3)), t3 && this.pointToProjected(t3);
      }, i.prototype.pointToProjected = function(t3) {
        return o.prototype.pointToData.call(this, t3);
      }, i.prototype.projectedToPoint = function(t3, c3, p3) {
        return o.prototype.dataToPoint.call(this, t3, c3, p3);
      }, i.prototype.convertToPixel = function(t3, c3, p3) {
        var g3 = FFe(c3);
        return g3 === this ? g3.dataToPoint(p3) : null;
      }, i.prototype.convertFromPixel = function(t3, c3, p3) {
        var g3 = FFe(c3);
        return g3 === this ? g3.pointToData(p3) : null;
      }, i;
    }(gW);
    Kp(NFe, gW);
    function FFe(o) {
      var i = o.geoModel, t3 = o.seriesModel;
      return i ? i.coordinateSystem : t3 ? t3.coordinateSystem || (t3.getReferringComponents("geo", xd).models[0] || {}).coordinateSystem : null;
    }
    var VFe = NFe;
    function BFe(o, i) {
      var t3 = o.get("boundingCoords");
      if (t3 != null) {
        var c3 = t3[0], p3 = t3[1];
        if (isFinite(c3[0]) && isFinite(c3[1]) && isFinite(p3[0]) && isFinite(p3[1])) {
          var g3 = this.projection;
          if (g3) {
            var b3 = c3[0], w3 = c3[1], M = p3[0], I = p3[1];
            c3 = [1 / 0, 1 / 0], p3 = [-1 / 0, -1 / 0];
            var k3 = function(Pe, ze, $e, Ke) {
              for (var nt = $e - Pe, lt2 = Ke - ze, bt = 0; bt <= 100; bt++) {
                var vt = bt / 100, jt = g3.project([Pe + nt * vt, ze + lt2 * vt]);
                L2(c3, c3, jt), sw(p3, p3, jt);
              }
            };
            k3(b3, w3, M, w3), k3(M, w3, M, I), k3(M, I, b3, I), k3(b3, I, M, w3);
          }
          this.setBoundingRect(c3[0], c3[1], p3[0] - c3[0], p3[1] - c3[1]);
        }
      }
      var L = this.getBoundingRect(), F = o.get("layoutCenter"), B = o.get("layoutSize"), G = i.getWidth(), J = i.getHeight(), Q = L.width / L.height * this.aspectScale, se = false, he, be;
      F && B && (he = [Da(F[0], G), Da(F[1], J)], be = Da(B, Math.min(G, J)), !isNaN(he[0]) && !isNaN(he[1]) && !isNaN(be) && (se = true));
      var de;
      if (se)
        de = {}, Q > 1 ? (de.width = be, de.height = be / Q) : (de.height = be, de.width = be * Q), de.y = he[1] - de.height / 2, de.x = he[0] - de.width / 2;
      else {
        var Fe = o.getBoxLayoutParams();
        Fe.aspect = Q, de = Wv(Fe, { width: G, height: J });
      }
      this.setViewRect(de.x, de.y, de.width, de.height), this.setCenter(o.get("center")), this.setZoom(o.get("zoom"));
    }
    function Zwt(o, i) {
      yt(i.get("geoCoord"), function(t3, c3) {
        o.addGeoCoord(c3, t3);
      });
    }
    var Jwt = function() {
      function o() {
        this.dimensions = RFe;
      }
      return o.prototype.create = function(i, t3) {
        var c3 = [];
        function p3(b3) {
          return { nameProperty: b3.get("nameProperty"), aspectScale: b3.get("aspectScale"), projection: b3.get("projection") };
        }
        i.eachComponent("geo", function(b3, w3) {
          var M = b3.get("map"), I = new VFe(M + w3, M, ti({ nameMap: b3.get("nameMap") }, p3(b3)));
          I.zoomLimit = b3.get("scaleLimit"), c3.push(I), b3.coordinateSystem = I, I.model = b3, I.resize = BFe, I.resize(b3, t3);
        }), i.eachSeries(function(b3) {
          var w3 = b3.get("coordinateSystem");
          if (w3 === "geo") {
            var M = b3.get("geoIndex") || 0;
            b3.coordinateSystem = c3[M];
          }
        });
        var g3 = {};
        return i.eachSeriesByType("map", function(b3) {
          if (!b3.getHostGeoModel()) {
            var w3 = b3.getMapType();
            g3[w3] = g3[w3] || [], g3[w3].push(b3);
          }
        }), yt(g3, function(b3, w3) {
          var M = Fi(b3, function(k3) {
            return k3.get("nameMap");
          }), I = new VFe(w3, w3, ti({ nameMap: nF(M) }, p3(b3[0])));
          I.zoomLimit = lv.apply(null, Fi(b3, function(k3) {
            return k3.get("scaleLimit");
          })), c3.push(I), I.resize = BFe, I.resize(b3[0], t3), yt(b3, function(k3) {
            k3.coordinateSystem = I, Zwt(I, k3);
          });
        }), c3;
      }, o.prototype.getFilledRegions = function(i, t3, c3, p3) {
        for (var g3 = (i || []).slice(), b3 = Eo(), w3 = 0; w3 < g3.length; w3++)
          b3.set(g3[w3].name, g3[w3]);
        var M = zI.load(t3, c3, p3);
        return yt(M.regions, function(I) {
          var k3 = I.name;
          !b3.get(k3) && g3.push({ name: k3 });
        }), g3;
      }, o;
    }(), Qwt = new Jwt(), zFe = Qwt, eSt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        var g3 = zI.getGeoResource(t3.map);
        if (g3 && g3.type === "geoJSON") {
          var b3 = t3.itemStyle = t3.itemStyle || {};
          "color" in b3 || (b3.color = "#eee");
        }
        this.mergeDefaultAndTheme(t3, p3), O1(t3, "label", ["show"]);
      }, i.prototype.optionUpdated = function() {
        var t3 = this, c3 = this.option;
        c3.regions = zFe.getFilledRegions(c3.regions, c3.map, c3.nameMap, c3.nameProperty);
        var p3 = {};
        this._optionModelMap = aw(c3.regions || [], function(g3, b3) {
          var w3 = b3.name;
          return w3 && (g3.set(w3, new gh(b3, t3, t3.ecModel)), b3.selected && (p3[w3] = true)), g3;
        }, Eo()), c3.selectedMap || (c3.selectedMap = p3);
      }, i.prototype.getRegionModel = function(t3) {
        return this._optionModelMap.get(t3) || new gh(null, this, this.ecModel);
      }, i.prototype.getFormattedLabel = function(t3, c3) {
        var p3 = this.getRegionModel(t3), g3 = c3 === "normal" ? p3.get(["label", "formatter"]) : p3.get(["emphasis", "label", "formatter"]), b3 = { name: t3 };
        if (Vo(g3))
          return b3.status = c3, g3(b3);
        if (Ha(g3))
          return g3.replace("{a}", t3 != null ? t3 : "");
      }, i.prototype.setZoom = function(t3) {
        this.option.zoom = t3;
      }, i.prototype.setCenter = function(t3) {
        this.option.center = t3;
      }, i.prototype.select = function(t3) {
        var c3 = this.option, p3 = c3.selectedMode;
        if (p3) {
          p3 !== "multiple" && (c3.selectedMap = null);
          var g3 = c3.selectedMap || (c3.selectedMap = {});
          g3[t3] = true;
        }
      }, i.prototype.unSelect = function(t3) {
        var c3 = this.option.selectedMap;
        c3 && (c3[t3] = false);
      }, i.prototype.toggleSelected = function(t3) {
        this[this.isSelected(t3) ? "unSelect" : "select"](t3);
      }, i.prototype.isSelected = function(t3) {
        var c3 = this.option.selectedMap;
        return !!(c3 && c3[t3]);
      }, i.type = "geo", i.layoutMode = "box", i.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, i;
    }(nc), tSt = eSt;
    function jFe(o, i) {
      return o.pointToProjected ? o.pointToProjected(i) : o.pointToData(i);
    }
    function iye(o, i, t3) {
      var c3 = o.getZoom(), p3 = o.getCenter(), g3 = i.zoom, b3 = o.projectedToPoint ? o.projectedToPoint(p3) : o.dataToPoint(p3);
      if (i.dx != null && i.dy != null && (b3[0] -= i.dx, b3[1] -= i.dy, o.setCenter(jFe(o, b3))), g3 != null) {
        if (t3) {
          var w3 = t3.min || 0, M = t3.max || 1 / 0;
          g3 = Math.max(Math.min(c3 * g3, M), w3) / c3;
        }
        o.scaleX *= g3, o.scaleY *= g3;
        var I = (i.originX - o.x) * (g3 - 1), k3 = (i.originY - o.y) * (g3 - 1);
        o.x -= I, o.y -= k3, o.updateTransform(), o.setCenter(jFe(o, b3)), o.setZoom(g3 * c3);
      }
      return { center: o.getCenter(), zoom: o.getZoom() };
    }
    var nSt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.focusBlurEnabled = true, t3;
      }
      return i.prototype.init = function(t3, c3) {
        this._api = c3;
      }, i.prototype.render = function(t3, c3, p3, g3) {
        if (this._model = t3, !t3.get("show")) {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
          return;
        }
        this._mapDraw || (this._mapDraw = new OFe(p3));
        var b3 = this._mapDraw;
        b3.draw(t3, c3, p3, this, g3), b3.group.on("click", this._handleRegionClick, this), b3.group.silent = t3.get("silent"), this.group.add(b3.group), this.updateSelectStatus(t3, c3, p3);
      }, i.prototype._handleRegionClick = function(t3) {
        var c3;
        A8(t3.target, function(p3) {
          return (c3 = La(p3).eventData) != null;
        }, true), c3 && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: c3.name });
      }, i.prototype.updateSelectStatus = function(t3, c3, p3) {
        var g3 = this;
        this._mapDraw.group.traverse(function(b3) {
          var w3 = La(b3).eventData;
          if (w3)
            return g3._model.isSelected(w3.name) ? p3.enterSelect(b3) : p3.leaveSelect(b3), true;
        });
      }, i.prototype.findHighDownDispatchers = function(t3) {
        return this._mapDraw && this._mapDraw.findHighDownDispatchers(t3, this._model);
      }, i.prototype.dispose = function() {
        this._mapDraw && this._mapDraw.remove();
      }, i.type = "geo", i;
    }(ed), rSt = nSt;
    function iSt(o, i, t3) {
      zI.registerMap(o, i, t3);
    }
    function GFe(o) {
      o.registerCoordinateSystem("geo", zFe), o.registerComponentModel(tSt), o.registerComponentView(rSt), o.registerImpl("registerMap", iSt), o.registerImpl("getMap", function(t3) {
        return zI.getMapForUser(t3);
      });
      function i(t3, c3) {
        c3.update = "geo:updateSelectStatus", o.registerAction(c3, function(p3, g3) {
          var b3 = {}, w3 = [];
          return g3.eachComponent({ mainType: "geo", query: p3 }, function(M) {
            M[t3](p3.name);
            var I = M.coordinateSystem;
            yt(I.regions, function(L) {
              b3[L.name] = M.isSelected(L.name) || false;
            });
            var k3 = [];
            yt(b3, function(L, F) {
              b3[F] && k3.push(F);
            }), w3.push({ geoIndex: M.componentIndex, name: k3 });
          }), { selected: b3, allSelected: w3, name: p3.name };
        });
      }
      i("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), i("select", { type: "geoSelect", event: "geoselected" }), i("unSelect", { type: "geoUnSelect", event: "geounselected" }), o.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(t3, c3) {
        var p3 = t3.componentType || "series";
        c3.eachComponent({ mainType: p3, query: t3 }, function(g3) {
          var b3 = g3.coordinateSystem;
          if (b3.type === "geo") {
            var w3 = iye(b3, t3, g3.get("scaleLimit"));
            g3.setCenter && g3.setCenter(w3.center), g3.setZoom && g3.setZoom(w3.zoom), p3 === "series" && yt(g3.seriesGroup, function(M) {
              M.setCenter(w3.center), M.setZoom(w3.zoom);
            });
          }
        });
      });
    }
    function aSt(o) {
      Tl(GFe), o.registerChartView(Hwt), o.registerSeriesModel(Uwt), o.registerLayout(Xwt), o.registerProcessor(o.PRIORITY.PROCESSOR.STATISTIC, $wt), WRe("map", o.registerAction);
    }
    function oSt(o) {
      var i = o;
      i.hierNode = { defaultAncestor: null, ancestor: i, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
      for (var t3 = [i], c3, p3; c3 = t3.pop(); )
        if (p3 = c3.children, c3.isExpand && p3.length)
          for (var g3 = p3.length, b3 = g3 - 1; b3 >= 0; b3--) {
            var w3 = p3[b3];
            w3.hierNode = { defaultAncestor: null, ancestor: w3, prelim: 0, modifier: 0, change: 0, shift: 0, i: b3, thread: null }, t3.push(w3);
          }
    }
    function sSt(o, i) {
      var t3 = o.isExpand ? o.children : [], c3 = o.parentNode.children, p3 = o.hierNode.i ? c3[o.hierNode.i - 1] : null;
      if (t3.length) {
        cSt(o);
        var g3 = (t3[0].hierNode.prelim + t3[t3.length - 1].hierNode.prelim) / 2;
        p3 ? (o.hierNode.prelim = p3.hierNode.prelim + i(o, p3), o.hierNode.modifier = o.hierNode.prelim - g3) : o.hierNode.prelim = g3;
      } else
        p3 && (o.hierNode.prelim = p3.hierNode.prelim + i(o, p3));
      o.parentNode.hierNode.defaultAncestor = fSt(o, p3, o.parentNode.hierNode.defaultAncestor || c3[0], i);
    }
    function lSt(o) {
      var i = o.hierNode.prelim + o.parentNode.hierNode.modifier;
      o.setLayout({ x: i }, true), o.hierNode.modifier += o.parentNode.hierNode.modifier;
    }
    function HFe(o) {
      return arguments.length ? o : dSt;
    }
    function yW(o, i) {
      return o -= Math.PI / 2, { x: i * Math.cos(o), y: i * Math.sin(o) };
    }
    function uSt(o, i) {
      return Wv(o.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
    }
    function cSt(o) {
      for (var i = o.children, t3 = i.length, c3 = 0, p3 = 0; --t3 >= 0; ) {
        var g3 = i[t3];
        g3.hierNode.prelim += c3, g3.hierNode.modifier += c3, p3 += g3.hierNode.change, c3 += g3.hierNode.shift + p3;
      }
    }
    function fSt(o, i, t3, c3) {
      if (i) {
        for (var p3 = o, g3 = o, b3 = g3.parentNode.children[0], w3 = i, M = p3.hierNode.modifier, I = g3.hierNode.modifier, k3 = b3.hierNode.modifier, L = w3.hierNode.modifier; w3 = aye(w3), g3 = oye(g3), w3 && g3; ) {
          p3 = aye(p3), b3 = oye(b3), p3.hierNode.ancestor = o;
          var F = w3.hierNode.prelim + L - g3.hierNode.prelim - I + c3(w3, g3);
          F > 0 && (pSt(hSt(w3, o, t3), o, F), I += F, M += F), L += w3.hierNode.modifier, I += g3.hierNode.modifier, M += p3.hierNode.modifier, k3 += b3.hierNode.modifier;
        }
        w3 && !aye(p3) && (p3.hierNode.thread = w3, p3.hierNode.modifier += L - M), g3 && !oye(b3) && (b3.hierNode.thread = g3, b3.hierNode.modifier += I - k3, t3 = o);
      }
      return t3;
    }
    function aye(o) {
      var i = o.children;
      return i.length && o.isExpand ? i[i.length - 1] : o.hierNode.thread;
    }
    function oye(o) {
      var i = o.children;
      return i.length && o.isExpand ? i[0] : o.hierNode.thread;
    }
    function hSt(o, i, t3) {
      return o.hierNode.ancestor.parentNode === i.parentNode ? o.hierNode.ancestor : t3;
    }
    function pSt(o, i, t3) {
      var c3 = t3 / (i.hierNode.i - o.hierNode.i);
      i.hierNode.change -= c3, i.hierNode.shift += t3, i.hierNode.modifier += t3, i.hierNode.prelim += t3, o.hierNode.change += c3;
    }
    function dSt(o, i) {
      return o.parentNode === i.parentNode ? 1 : 2;
    }
    var vSt = function() {
      function o() {
        this.parentPoint = [], this.childPoints = [];
      }
      return o;
    }(), gSt = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new vSt();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.childPoints, g3 = p3.length, b3 = c3.parentPoint, w3 = p3[0], M = p3[g3 - 1];
        if (g3 === 1) {
          t3.moveTo(b3[0], b3[1]), t3.lineTo(w3[0], w3[1]);
          return;
        }
        var I = c3.orient, k3 = I === "TB" || I === "BT" ? 0 : 1, L = 1 - k3, F = Da(c3.forkPosition, 1), B = [];
        B[k3] = b3[k3], B[L] = b3[L] + (M[L] - b3[L]) * F, t3.moveTo(b3[0], b3[1]), t3.lineTo(B[0], B[1]), t3.moveTo(w3[0], w3[1]), B[k3] = w3[k3], t3.lineTo(B[0], B[1]), B[k3] = M[k3], t3.lineTo(B[0], B[1]), t3.lineTo(M[0], M[1]);
        for (var G = 1; G < g3 - 1; G++) {
          var J = p3[G];
          t3.moveTo(J[0], J[1]), B[k3] = J[k3], t3.lineTo(B[0], B[1]);
        }
      }, i;
    }(gl), ySt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._mainGroup = new vs(), t3;
      }
      return i.prototype.init = function(t3, c3) {
        this._controller = new dW(c3.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
      }, i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = t3.layoutInfo, w3 = this._mainGroup, M = t3.get("layout");
        M === "radial" ? (w3.x = b3.x + b3.width / 2, w3.y = b3.y + b3.height / 2) : (w3.x = b3.x, w3.y = b3.y), this._updateViewCoordSys(t3), this._updateController(t3, c3, p3);
        var I = this._data;
        g3.diff(I).add(function(k3) {
          WFe(g3, k3) && UFe(g3, k3, null, w3, t3);
        }).update(function(k3, L) {
          var F = I.getItemGraphicEl(L);
          if (!WFe(g3, k3)) {
            F && XFe(I, L, F, w3, t3);
            return;
          }
          UFe(g3, k3, F, w3, t3);
        }).remove(function(k3) {
          var L = I.getItemGraphicEl(k3);
          L && XFe(I, k3, L, w3, t3);
        }).execute(), this._nodeScaleRatio = t3.get("nodeScaleRatio"), this._updateNodeAndLinkScale(t3), t3.get("expandAndCollapse") === true && g3.eachItemGraphicEl(function(k3, L) {
          k3.off("click").on("click", function() {
            p3.dispatchAction({ type: "treeExpandAndCollapse", seriesId: t3.id, dataIndex: L });
          });
        }), this._data = g3;
      }, i.prototype._updateViewCoordSys = function(t3) {
        var c3 = t3.getData(), p3 = [];
        c3.each(function(k3) {
          var L = c3.getItemLayout(k3);
          L && !isNaN(L.x) && !isNaN(L.y) && p3.push([+L.x, +L.y]);
        });
        var g3 = [], b3 = [];
        UF(p3, g3, b3);
        var w3 = this._min, M = this._max;
        b3[0] - g3[0] === 0 && (g3[0] = w3 ? w3[0] : g3[0] - 1, b3[0] = M ? M[0] : b3[0] + 1), b3[1] - g3[1] === 0 && (g3[1] = w3 ? w3[1] : g3[1] - 1, b3[1] = M ? M[1] : b3[1] + 1);
        var I = t3.coordinateSystem = new gW();
        I.zoomLimit = t3.get("scaleLimit"), I.setBoundingRect(g3[0], g3[1], b3[0] - g3[0], b3[1] - g3[1]), I.setCenter(t3.get("center")), I.setZoom(t3.get("zoom")), this.group.attr({ x: I.x, y: I.y, scaleX: I.scaleX, scaleY: I.scaleY }), this._min = g3, this._max = b3;
      }, i.prototype._updateController = function(t3, c3, p3) {
        var g3 = this, b3 = this._controller, w3 = this._controllerHost, M = this.group;
        b3.setPointerChecker(function(I, k3, L) {
          var F = M.getBoundingRect();
          return F.applyTransform(M.transform), F.contain(k3, L) && !fne(I, p3, t3);
        }), b3.enable(t3.get("roam")), w3.zoomLimit = t3.get("scaleLimit"), w3.zoom = t3.coordinateSystem.getZoom(), b3.off("pan").off("zoom").on("pan", function(I) {
          J0e(w3, I.dx, I.dy), p3.dispatchAction({ seriesId: t3.id, type: "treeRoam", dx: I.dx, dy: I.dy });
        }).on("zoom", function(I) {
          Q0e(w3, I.scale, I.originX, I.originY), p3.dispatchAction({ seriesId: t3.id, type: "treeRoam", zoom: I.scale, originX: I.originX, originY: I.originY }), g3._updateNodeAndLinkScale(t3), p3.updateLabelLayout();
        });
      }, i.prototype._updateNodeAndLinkScale = function(t3) {
        var c3 = t3.getData(), p3 = this._getNodeGlobalScale(t3);
        c3.eachItemGraphicEl(function(g3, b3) {
          g3.setSymbolScale(p3);
        });
      }, i.prototype._getNodeGlobalScale = function(t3) {
        var c3 = t3.coordinateSystem;
        if (c3.type !== "view")
          return 1;
        var p3 = this._nodeScaleRatio, g3 = c3.scaleX || 1, b3 = c3.getZoom(), w3 = (b3 - 1) * p3 + 1;
        return w3 / g3;
      }, i.prototype.dispose = function() {
        this._controller && this._controller.dispose(), this._controllerHost = null;
      }, i.prototype.remove = function() {
        this._mainGroup.removeAll(), this._data = null;
      }, i.type = "tree", i;
    }(yh);
    function WFe(o, i) {
      var t3 = o.getItemLayout(i);
      return t3 && !isNaN(t3.x) && !isNaN(t3.y);
    }
    function UFe(o, i, t3, c3, p3) {
      var g3 = !t3, b3 = o.tree.getNodeByDataIndex(i), w3 = b3.getModel(), M = b3.getVisual("style").fill, I = b3.isExpand === false && b3.children.length !== 0 ? M : "#fff", k3 = o.tree.root, L = b3.parentNode === k3 ? b3 : b3.parentNode || b3, F = o.getItemGraphicEl(L.dataIndex), B = L.getLayout(), G = F ? { x: F.__oldX, y: F.__oldY, rawX: F.__radialOldRawX, rawY: F.__radialOldRawY } : B, J = b3.getLayout();
      g3 ? (t3 = new sW(o, i, null, { symbolInnerColor: I, useNameLabel: true }), t3.x = G.x, t3.y = G.y) : t3.updateData(o, i, null, { symbolInnerColor: I, useNameLabel: true }), t3.__radialOldRawX = t3.__radialRawX, t3.__radialOldRawY = t3.__radialRawY, t3.__radialRawX = J.rawX, t3.__radialRawY = J.rawY, c3.add(t3), o.setItemGraphicEl(i, t3), t3.__oldX = t3.x, t3.__oldY = t3.y, Du(t3, { x: J.x, y: J.y }, p3);
      var Q = t3.getSymbolPath();
      if (p3.get("layout") === "radial") {
        var se = k3.children[0], he = se.getLayout(), be = se.children.length, de = void 0, Fe = void 0;
        if (J.x === he.x && b3.isExpand === true) {
          var Pe = { x: (se.children[0].getLayout().x + se.children[be - 1].getLayout().x) / 2, y: (se.children[0].getLayout().y + se.children[be - 1].getLayout().y) / 2 };
          de = Math.atan2(Pe.y - he.y, Pe.x - he.x), de < 0 && (de = Math.PI * 2 + de), Fe = Pe.x < he.x, Fe && (de = de - Math.PI);
        } else
          de = Math.atan2(J.y - he.y, J.x - he.x), de < 0 && (de = Math.PI * 2 + de), b3.children.length === 0 || b3.children.length !== 0 && b3.isExpand === false ? (Fe = J.x < he.x, Fe && (de = de - Math.PI)) : (Fe = J.x > he.x, Fe || (de = de - Math.PI));
        var ze = Fe ? "left" : "right", $e = w3.getModel("label"), Ke = $e.get("rotate"), nt = Ke * (Math.PI / 180), lt2 = Q.getTextContent();
        lt2 && (Q.setTextConfig({ position: $e.get("position") || ze, rotation: Ke == null ? -de : nt, origin: "center" }), lt2.setStyle("verticalAlign", "middle"));
      }
      var bt = w3.get(["emphasis", "focus"]), vt = bt === "ancestor" ? b3.getAncestorsIndices() : bt === "descendant" ? b3.getDescendantIndices() : null;
      vt && (La(t3).focus = vt), mSt(p3, b3, k3, t3, G, B, J, c3), t3.__edge && (t3.onHoverStateChange = function(jt) {
        if (jt !== "blur") {
          var Jt = b3.parentNode && o.getItemGraphicEl(b3.parentNode.dataIndex);
          Jt && Jt.hoverState === WP || TI(t3.__edge, jt);
        }
      });
    }
    function mSt(o, i, t3, c3, p3, g3, b3, w3) {
      var M = i.getModel(), I = o.get("edgeShape"), k3 = o.get("layout"), L = o.getOrient(), F = o.get(["lineStyle", "curveness"]), B = o.get("edgeForkPosition"), G = M.getModel("lineStyle").getLineStyle(), J = c3.__edge;
      if (I === "curve")
        i.parentNode && i.parentNode !== t3 && (J || (J = c3.__edge = new Q5({ shape: sye(k3, L, F, p3, p3) })), Du(J, { shape: sye(k3, L, F, g3, b3) }, o));
      else if (I === "polyline" && k3 === "orthogonal" && i !== t3 && i.children && i.children.length !== 0 && i.isExpand === true) {
        for (var Q = i.children, se = [], he = 0; he < Q.length; he++) {
          var be = Q[he].getLayout();
          se.push([be.x, be.y]);
        }
        J || (J = c3.__edge = new gSt({ shape: { parentPoint: [b3.x, b3.y], childPoints: [[b3.x, b3.y]], orient: L, forkPosition: B } })), Du(J, { shape: { parentPoint: [b3.x, b3.y], childPoints: se } }, o);
      }
      J && (J.useStyle(Uo({ strokeNoScale: true, fill: null }, G)), cv(J, M, "lineStyle"), AI(J), w3.add(J));
    }
    function qFe(o, i, t3, c3, p3) {
      var g3 = i.tree.root, b3 = $Fe(g3, o), w3 = b3.source, M = b3.sourceLayout, I = i.getItemGraphicEl(o.dataIndex);
      if (I) {
        var k3 = i.getItemGraphicEl(w3.dataIndex), L = k3.__edge, F = I.__edge || (w3.isExpand === false || w3.children.length === 1 ? L : void 0), B = c3.get("edgeShape"), G = c3.get("layout"), J = c3.get("orient"), Q = c3.get(["lineStyle", "curveness"]);
        F && (B === "curve" ? XM(F, { shape: sye(G, J, Q, M, M), style: { opacity: 0 } }, c3, { cb: function() {
          t3.remove(F);
        }, removeOpt: p3 }) : B === "polyline" && c3.get("layout") === "orthogonal" && XM(F, { shape: { parentPoint: [M.x, M.y], childPoints: [[M.x, M.y]] }, style: { opacity: 0 } }, c3, { cb: function() {
          t3.remove(F);
        }, removeOpt: p3 }));
      }
    }
    function $Fe(o, i) {
      for (var t3 = i.parentNode === o ? i : i.parentNode || i, c3; c3 = t3.getLayout(), c3 == null; )
        t3 = t3.parentNode === o ? t3 : t3.parentNode || t3;
      return { source: t3, sourceLayout: c3 };
    }
    function XFe(o, i, t3, c3, p3) {
      var g3 = o.tree.getNodeByDataIndex(i), b3 = o.tree.root, w3 = $Fe(b3, g3).sourceLayout, M = { duration: p3.get("animationDurationUpdate"), easing: p3.get("animationEasingUpdate") };
      XM(t3, { x: w3.x + 1, y: w3.y + 1 }, p3, { cb: function() {
        c3.remove(t3), o.setItemGraphicEl(i, null);
      }, removeOpt: M }), t3.fadeOut(null, o.hostModel, { fadeLabel: true, animation: M }), g3.children.forEach(function(I) {
        qFe(I, o, c3, p3, M);
      }), qFe(g3, o, c3, p3, M);
    }
    function sye(o, i, t3, c3, p3) {
      var g3, b3, w3, M, I, k3, L, F;
      if (o === "radial") {
        I = c3.rawX, L = c3.rawY, k3 = p3.rawX, F = p3.rawY;
        var B = yW(I, L), G = yW(I, L + (F - L) * t3), J = yW(k3, F + (L - F) * t3), Q = yW(k3, F);
        return { x1: B.x || 0, y1: B.y || 0, x2: Q.x || 0, y2: Q.y || 0, cpx1: G.x || 0, cpy1: G.y || 0, cpx2: J.x || 0, cpy2: J.y || 0 };
      } else
        I = c3.x, L = c3.y, k3 = p3.x, F = p3.y, (i === "LR" || i === "RL") && (g3 = I + (k3 - I) * t3, b3 = L, w3 = k3 + (I - k3) * t3, M = F), (i === "TB" || i === "BT") && (g3 = I, b3 = L + (F - L) * t3, w3 = k3, M = F + (L - F) * t3);
      return { x1: I, y1: L, x2: k3, y2: F, cpx1: g3, cpy1: b3, cpx2: w3, cpy2: M };
    }
    var bSt = ySt, Nw = mu();
    function YFe(o) {
      var i = o.mainData, t3 = o.datas;
      t3 || (t3 = { main: i }, o.datasAttr = { main: "data" }), o.datas = o.mainData = null, KFe(i, t3, o), yt(t3, function(c3) {
        yt(i.TRANSFERABLE_METHODS, function(p3) {
          c3.wrapMethod(p3, As(_St, o));
        });
      }), i.wrapMethod("cloneShallow", As(wSt, o)), yt(i.CHANGABLE_METHODS, function(c3) {
        i.wrapMethod(c3, As(xSt, o));
      }), u0(t3[i.dataType] === i);
    }
    function _St(o, i) {
      if (MSt(this)) {
        var t3 = ti({}, Nw(this).datas);
        t3[this.dataType] = i, KFe(i, t3, o);
      } else
        lye(i, this.dataType, Nw(this).mainData, o);
      return i;
    }
    function xSt(o, i) {
      return o.struct && o.struct.update(), i;
    }
    function wSt(o, i) {
      return yt(Nw(i).datas, function(t3, c3) {
        t3 !== i && lye(t3.cloneShallow(), c3, i, o);
      }), i;
    }
    function SSt(o) {
      var i = Nw(this).mainData;
      return o == null || i == null ? i : Nw(i).datas[o];
    }
    function CSt() {
      var o = Nw(this).mainData;
      return o == null ? [{ data: o }] : Fi(Gl(Nw(o).datas), function(i) {
        return { type: i, data: Nw(o).datas[i] };
      });
    }
    function MSt(o) {
      return Nw(o).mainData === o;
    }
    function KFe(o, i, t3) {
      Nw(o).datas = {}, yt(i, function(c3, p3) {
        lye(c3, p3, o, t3);
      });
    }
    function lye(o, i, t3, c3) {
      Nw(t3).datas[i] = o, Nw(o).mainData = t3, o.dataType = i, c3.struct && (o[c3.structAttr] = c3.struct, c3.struct[c3.datasAttr[i]] = o), o.getLinkedData = SSt, o.getLinkedDataAll = CSt;
    }
    var TSt = function() {
      function o(i, t3) {
        this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = i || "", this.hostTree = t3;
      }
      return o.prototype.isRemoved = function() {
        return this.dataIndex < 0;
      }, o.prototype.eachNode = function(i, t3, c3) {
        Vo(i) && (c3 = t3, t3 = i, i = null), i = i || {}, Ha(i) && (i = { order: i });
        var p3 = i.order || "preorder", g3 = this[i.attr || "children"], b3;
        p3 === "preorder" && (b3 = t3.call(c3, this));
        for (var w3 = 0; !b3 && w3 < g3.length; w3++)
          g3[w3].eachNode(i, t3, c3);
        p3 === "postorder" && t3.call(c3, this);
      }, o.prototype.updateDepthAndHeight = function(i) {
        var t3 = 0;
        this.depth = i;
        for (var c3 = 0; c3 < this.children.length; c3++) {
          var p3 = this.children[c3];
          p3.updateDepthAndHeight(i + 1), p3.height > t3 && (t3 = p3.height);
        }
        this.height = t3 + 1;
      }, o.prototype.getNodeById = function(i) {
        if (this.getId() === i)
          return this;
        for (var t3 = 0, c3 = this.children, p3 = c3.length; t3 < p3; t3++) {
          var g3 = c3[t3].getNodeById(i);
          if (g3)
            return g3;
        }
      }, o.prototype.contains = function(i) {
        if (i === this)
          return true;
        for (var t3 = 0, c3 = this.children, p3 = c3.length; t3 < p3; t3++) {
          var g3 = c3[t3].contains(i);
          if (g3)
            return g3;
        }
      }, o.prototype.getAncestors = function(i) {
        for (var t3 = [], c3 = i ? this : this.parentNode; c3; )
          t3.push(c3), c3 = c3.parentNode;
        return t3.reverse(), t3;
      }, o.prototype.getAncestorsIndices = function() {
        for (var i = [], t3 = this; t3; )
          i.push(t3.dataIndex), t3 = t3.parentNode;
        return i.reverse(), i;
      }, o.prototype.getDescendantIndices = function() {
        var i = [];
        return this.eachNode(function(t3) {
          i.push(t3.dataIndex);
        }), i;
      }, o.prototype.getValue = function(i) {
        var t3 = this.hostTree.data;
        return t3.getStore().get(t3.getDimensionIndex(i || "value"), this.dataIndex);
      }, o.prototype.setLayout = function(i, t3) {
        this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, i, t3);
      }, o.prototype.getLayout = function() {
        return this.hostTree.data.getItemLayout(this.dataIndex);
      }, o.prototype.getModel = function(i) {
        if (!(this.dataIndex < 0)) {
          var t3 = this.hostTree, c3 = t3.data.getItemModel(this.dataIndex);
          return c3.getModel(i);
        }
      }, o.prototype.getLevelModel = function() {
        return (this.hostTree.levelModels || [])[this.depth];
      }, o.prototype.setVisual = function(i, t3) {
        this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, i, t3);
      }, o.prototype.getVisual = function(i) {
        return this.hostTree.data.getItemVisual(this.dataIndex, i);
      }, o.prototype.getRawIndex = function() {
        return this.hostTree.data.getRawIndex(this.dataIndex);
      }, o.prototype.getId = function() {
        return this.hostTree.data.getId(this.dataIndex);
      }, o.prototype.getChildIndex = function() {
        if (this.parentNode) {
          for (var i = this.parentNode.children, t3 = 0; t3 < i.length; ++t3)
            if (i[t3] === this)
              return t3;
          return -1;
        }
        return -1;
      }, o.prototype.isAncestorOf = function(i) {
        for (var t3 = i.parentNode; t3; ) {
          if (t3 === this)
            return true;
          t3 = t3.parentNode;
        }
        return false;
      }, o.prototype.isDescendantOf = function(i) {
        return i !== this && i.isAncestorOf(this);
      }, o;
    }(), ASt = function() {
      function o(i) {
        this.type = "tree", this._nodes = [], this.hostModel = i;
      }
      return o.prototype.eachNode = function(i, t3, c3) {
        this.root.eachNode(i, t3, c3);
      }, o.prototype.getNodeByDataIndex = function(i) {
        var t3 = this.data.getRawIndex(i);
        return this._nodes[t3];
      }, o.prototype.getNodeById = function(i) {
        return this.root.getNodeById(i);
      }, o.prototype.update = function() {
        for (var i = this.data, t3 = this._nodes, c3 = 0, p3 = t3.length; c3 < p3; c3++)
          t3[c3].dataIndex = -1;
        for (var c3 = 0, p3 = i.count(); c3 < p3; c3++)
          t3[i.getRawIndex(c3)].dataIndex = c3;
      }, o.prototype.clearLayouts = function() {
        this.data.clearItemLayouts();
      }, o.createTree = function(i, t3, c3) {
        var p3 = new o(t3), g3 = [], b3 = 1;
        w3(i);
        function w3(k3, L) {
          var F = k3.value;
          b3 = Math.max(b3, Ei(F) ? F.length : 1), g3.push(k3);
          var B = new TSt(Jf(k3.name, ""), p3);
          L ? ISt(B, L) : p3.root = B, p3._nodes.push(B);
          var G = k3.children;
          if (G)
            for (var J = 0; J < G.length; J++)
              w3(G[J], B);
        }
        p3.root.updateDepthAndHeight(0);
        var M = ZH(g3, { coordDimensions: ["value"], dimensionsCount: b3 }).dimensions, I = new V1(M, t3);
        return I.initData(g3), c3 && c3(I), YFe({ mainData: I, struct: p3, structAttr: "tree" }), p3.update(), p3;
      }, o;
    }();
    function ISt(o, i) {
      var t3 = i.children;
      o.parentNode !== i && (t3.push(o), o.parentNode = i);
    }
    var uye = ASt;
    function mW(o, i, t3) {
      if (o && rl(i, o.type) >= 0) {
        var c3 = t3.getData().tree.root, p3 = o.targetNode;
        if (Ha(p3) && (p3 = c3.getNodeById(p3)), p3 && c3.contains(p3))
          return { node: p3 };
        var g3 = o.targetNodeId;
        if (g3 != null && (p3 = c3.getNodeById(g3)))
          return { node: p3 };
      }
    }
    function ZFe(o) {
      for (var i = []; o; )
        o = o.parentNode, o && i.push(o);
      return i.reverse();
    }
    function cye(o, i) {
      var t3 = ZFe(o);
      return rl(t3, i) >= 0;
    }
    function gne(o, i) {
      for (var t3 = []; o; ) {
        var c3 = o.dataIndex;
        t3.push({ name: o.name, dataIndex: c3, value: i.getRawValue(c3) }), o = o.parentNode;
      }
      return t3.reverse(), t3;
    }
    var ESt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.hasSymbolVisual = true, t3.ignoreStyleOnData = true, t3;
      }
      return i.prototype.getInitialData = function(t3) {
        var c3 = { name: t3.name, children: t3.data }, p3 = t3.leaves || {}, g3 = new gh(p3, this, this.ecModel), b3 = uye.createTree(c3, this, w3);
        function w3(L) {
          L.wrapMethod("getItemModel", function(F, B) {
            var G = b3.getNodeByDataIndex(B);
            return G && G.children.length && G.isExpand || (F.parentModel = g3), F;
          });
        }
        var M = 0;
        b3.eachNode("preorder", function(L) {
          L.depth > M && (M = L.depth);
        });
        var I = t3.expandAndCollapse, k3 = I && t3.initialTreeDepth >= 0 ? t3.initialTreeDepth : M;
        return b3.root.eachNode("preorder", function(L) {
          var F = L.hostTree.data.getRawDataItem(L.dataIndex);
          L.isExpand = F && F.collapsed != null ? !F.collapsed : L.depth <= k3;
        }), b3.data;
      }, i.prototype.getOrient = function() {
        var t3 = this.get("orient");
        return t3 === "horizontal" ? t3 = "LR" : t3 === "vertical" && (t3 = "TB"), t3;
      }, i.prototype.setZoom = function(t3) {
        this.option.zoom = t3;
      }, i.prototype.setCenter = function(t3) {
        this.option.center = t3;
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        for (var g3 = this.getData().tree, b3 = g3.root.children[0], w3 = g3.getNodeByDataIndex(t3), M = w3.getValue(), I = w3.name; w3 && w3 !== b3; )
          I = w3.parentNode.name + "." + I, w3 = w3.parentNode;
        return Cg("nameValue", { name: I, value: M, noValue: isNaN(M) || M == null });
      }, i.prototype.getDataParams = function(t3) {
        var c3 = o.prototype.getDataParams.apply(this, arguments), p3 = this.getData().tree.getNodeByDataIndex(t3);
        return c3.treeAncestors = gne(p3, this), c3;
      }, i.type = "series.tree", i.layoutMode = "box", i.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, i;
    }(bp), DSt = ESt;
    function kSt(o, i, t3) {
      for (var c3 = [o], p3 = [], g3; g3 = c3.pop(); )
        if (p3.push(g3), g3.isExpand) {
          var b3 = g3.children;
          if (b3.length)
            for (var w3 = 0; w3 < b3.length; w3++)
              c3.push(b3[w3]);
        }
      for (; g3 = p3.pop(); )
        i(g3, t3);
    }
    function bW(o, i) {
      for (var t3 = [o], c3; c3 = t3.pop(); )
        if (i(c3), c3.isExpand) {
          var p3 = c3.children;
          if (p3.length)
            for (var g3 = p3.length - 1; g3 >= 0; g3--)
              t3.push(p3[g3]);
        }
    }
    function OSt(o, i) {
      o.eachSeriesByType("tree", function(t3) {
        PSt(t3, i);
      });
    }
    function PSt(o, i) {
      var t3 = uSt(o, i);
      o.layoutInfo = t3;
      var c3 = o.get("layout"), p3 = 0, g3 = 0, b3 = null;
      c3 === "radial" ? (p3 = 2 * Math.PI, g3 = Math.min(t3.height, t3.width) / 2, b3 = HFe(function(be, de) {
        return (be.parentNode === de.parentNode ? 1 : 2) / be.depth;
      })) : (p3 = t3.width, g3 = t3.height, b3 = HFe());
      var w3 = o.getData().tree.root, M = w3.children[0];
      if (M) {
        oSt(w3), kSt(M, sSt, b3), w3.hierNode.modifier = -M.hierNode.prelim, bW(M, lSt);
        var I = M, k3 = M, L = M;
        bW(M, function(be) {
          var de = be.getLayout().x;
          de < I.getLayout().x && (I = be), de > k3.getLayout().x && (k3 = be), be.depth > L.depth && (L = be);
        });
        var F = I === k3 ? 1 : b3(I, k3) / 2, B = F - I.getLayout().x, G = 0, J = 0, Q = 0, se = 0;
        if (c3 === "radial")
          G = p3 / (k3.getLayout().x + F + B), J = g3 / (L.depth - 1 || 1), bW(M, function(be) {
            Q = (be.getLayout().x + B) * G, se = (be.depth - 1) * J;
            var de = yW(Q, se);
            be.setLayout({ x: de.x, y: de.y, rawX: Q, rawY: se }, true);
          });
        else {
          var he = o.getOrient();
          he === "RL" || he === "LR" ? (J = g3 / (k3.getLayout().x + F + B), G = p3 / (L.depth - 1 || 1), bW(M, function(be) {
            se = (be.getLayout().x + B) * J, Q = he === "LR" ? (be.depth - 1) * G : p3 - (be.depth - 1) * G, be.setLayout({ x: Q, y: se }, true);
          })) : (he === "TB" || he === "BT") && (G = p3 / (k3.getLayout().x + F + B), J = g3 / (L.depth - 1 || 1), bW(M, function(be) {
            Q = (be.getLayout().x + B) * G, se = he === "TB" ? (be.depth - 1) * J : g3 - (be.depth - 1) * J, be.setLayout({ x: Q, y: se }, true);
          }));
        }
      }
    }
    function LSt(o) {
      o.eachSeriesByType("tree", function(i) {
        var t3 = i.getData(), c3 = t3.tree;
        c3.eachNode(function(p3) {
          var g3 = p3.getModel(), b3 = g3.getModel("itemStyle").getItemStyle(), w3 = t3.ensureUniqueItemVisual(p3.dataIndex, "style");
          ti(w3, b3);
        });
      });
    }
    function RSt(o) {
      o.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(i, t3) {
        t3.eachComponent({ mainType: "series", subType: "tree", query: i }, function(c3) {
          var p3 = i.dataIndex, g3 = c3.getData().tree, b3 = g3.getNodeByDataIndex(p3);
          b3.isExpand = !b3.isExpand;
        });
      }), o.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(i, t3) {
        t3.eachComponent({ mainType: "series", subType: "tree", query: i }, function(c3) {
          var p3 = c3.coordinateSystem, g3 = iye(p3, i);
          c3.setCenter && c3.setCenter(g3.center), c3.setZoom && c3.setZoom(g3.zoom);
        });
      });
    }
    function NSt(o) {
      o.registerChartView(bSt), o.registerSeriesModel(DSt), o.registerLayout(OSt), o.registerVisual(LSt), RSt(o);
    }
    var JFe = ["treemapZoomToNode", "treemapRender", "treemapMove"];
    function FSt(o) {
      for (var i = 0; i < JFe.length; i++)
        o.registerAction({ type: JFe[i], update: "updateView" }, uf);
      o.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(t3, c3) {
        c3.eachComponent({ mainType: "series", subType: "treemap", query: t3 }, p3);
        function p3(g3, b3) {
          var w3 = ["treemapZoomToNode", "treemapRootToNode"], M = mW(t3, w3, g3);
          if (M) {
            var I = g3.getViewRoot();
            I && (t3.direction = cye(I, M.node) ? "rollUp" : "drillDown"), g3.resetViewRoot(M.node);
          }
        }
      });
    }
    function QFe(o) {
      var i = o.getData(), t3 = i.tree, c3 = {};
      t3.eachNode(function(p3) {
        for (var g3 = p3; g3 && g3.depth > 1; )
          g3 = g3.parentNode;
        var b3 = yge(o.ecModel, g3.name || g3.dataIndex + "", c3);
        p3.setVisual("decal", b3);
      });
    }
    var VSt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.preventUsingHoverLayer = true, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        var p3 = { name: t3.name, children: t3.data };
        e8e(p3);
        var g3 = t3.levels || [], b3 = this.designatedVisualItemStyle = {}, w3 = new gh({ itemStyle: b3 }, this, c3);
        g3 = t3.levels = BSt(g3, c3);
        var M = Fi(g3 || [], function(L) {
          return new gh(L, w3, c3);
        }, this), I = uye.createTree(p3, this, k3);
        function k3(L) {
          L.wrapMethod("getItemModel", function(F, B) {
            var G = I.getNodeByDataIndex(B), J = G ? M[G.depth] : null;
            return F.parentModel = J || w3, F;
          });
        }
        return I.data;
      }, i.prototype.optionUpdated = function() {
        this.resetViewRoot();
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        var g3 = this.getData(), b3 = this.getRawValue(t3), w3 = g3.getName(t3);
        return Cg("nameValue", { name: w3, value: b3 });
      }, i.prototype.getDataParams = function(t3) {
        var c3 = o.prototype.getDataParams.apply(this, arguments), p3 = this.getData().tree.getNodeByDataIndex(t3);
        return c3.treeAncestors = gne(p3, this), c3.treePathInfo = c3.treeAncestors, c3;
      }, i.prototype.setLayoutInfo = function(t3) {
        this.layoutInfo = this.layoutInfo || {}, ti(this.layoutInfo, t3);
      }, i.prototype.mapIdToIndex = function(t3) {
        var c3 = this._idIndexMap;
        c3 || (c3 = this._idIndexMap = Eo(), this._idIndexMapCount = 0);
        var p3 = c3.get(t3);
        return p3 == null && c3.set(t3, p3 = this._idIndexMapCount++), p3;
      }, i.prototype.getViewRoot = function() {
        return this._viewRoot;
      }, i.prototype.resetViewRoot = function(t3) {
        t3 ? this._viewRoot = t3 : t3 = this._viewRoot;
        var c3 = this.getRawData().tree.root;
        (!t3 || t3 !== c3 && !c3.contains(t3)) && (this._viewRoot = c3);
      }, i.prototype.enableAriaDecal = function() {
        QFe(this);
      }, i.type = "series.treemap", i.layoutMode = "box", i.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, i;
    }(bp);
    function e8e(o) {
      var i = 0;
      yt(o.children, function(c3) {
        e8e(c3);
        var p3 = c3.value;
        Ei(p3) && (p3 = p3[0]), i += p3;
      });
      var t3 = o.value;
      Ei(t3) && (t3 = t3[0]), (t3 == null || isNaN(t3)) && (t3 = i), t3 < 0 && (t3 = 0), Ei(o.value) ? o.value[0] = t3 : o.value = t3;
    }
    function BSt(o, i) {
      var t3 = Wc(i.get("color")), c3 = Wc(i.get(["aria", "decal", "decals"]));
      if (t3) {
        o = o || [];
        var p3, g3;
        yt(o, function(w3) {
          var M = new gh(w3), I = M.get("color"), k3 = M.get("decal");
          (M.get(["itemStyle", "color"]) || I && I !== "none") && (p3 = true), (M.get(["itemStyle", "decal"]) || k3 && k3 !== "none") && (g3 = true);
        });
        var b3 = o[0] || (o[0] = {});
        return p3 || (b3.color = t3.slice()), !g3 && c3 && (b3.decal = c3.slice()), o;
      }
    }
    var zSt = VSt, jSt = 8, t8e = 8, fye = 5, GSt = function() {
      function o(i) {
        this.group = new vs(), i.add(this.group);
      }
      return o.prototype.render = function(i, t3, c3, p3) {
        var g3 = i.getModel("breadcrumb"), b3 = this.group;
        if (b3.removeAll(), !(!g3.get("show") || !c3)) {
          var w3 = g3.getModel("itemStyle"), M = w3.getModel("textStyle"), I = { pos: { left: g3.get("left"), right: g3.get("right"), top: g3.get("top"), bottom: g3.get("bottom") }, box: { width: t3.getWidth(), height: t3.getHeight() }, emptyItemWidth: g3.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
          this._prepare(c3, I, M), this._renderContent(i, I, w3, M, p3), vte(b3, I.pos, I.box);
        }
      }, o.prototype._prepare = function(i, t3, c3) {
        for (var p3 = i; p3; p3 = p3.parentNode) {
          var g3 = Jf(p3.getModel().get("name"), ""), b3 = c3.getTextRect(g3), w3 = Math.max(b3.width + jSt * 2, t3.emptyItemWidth);
          t3.totalWidth += w3 + t8e, t3.renderList.push({ node: p3, text: g3, width: w3 });
        }
      }, o.prototype._renderContent = function(i, t3, c3, p3, g3) {
        for (var b3 = 0, w3 = t3.emptyItemWidth, M = i.get(["breadcrumb", "height"]), I = Zgt(t3.pos, t3.box), k3 = t3.totalWidth, L = t3.renderList, F = L.length - 1; F >= 0; F--) {
          var B = L[F], G = B.node, J = B.width, Q = B.text;
          k3 > I.width && (k3 -= J - w3, J = w3, Q = null);
          var se = new _m({ shape: { points: HSt(b3, 0, J, M, F === L.length - 1, F === 0) }, style: Uo(c3.getItemStyle(), { lineJoin: "bevel" }), textContent: new Fl({ style: { text: Q, fill: p3.getTextColor(), font: p3.getFont() } }), textConfig: { position: "inside" }, z2: qM * 1e4, onclick: As(g3, G) });
          se.disableLabelAnimation = true, this.group.add(se), WSt(se, i, G), b3 += J + t8e;
        }
      }, o.prototype.remove = function() {
        this.group.removeAll();
      }, o;
    }();
    function HSt(o, i, t3, c3, p3, g3) {
      var b3 = [[p3 ? o : o - fye, i], [o + t3, i], [o + t3, i + c3], [p3 ? o : o - fye, i + c3]];
      return !g3 && b3.splice(2, 0, [o + t3 + fye, i + c3 / 2]), !p3 && b3.push([o, i + c3 / 2]), b3;
    }
    function WSt(o, i, t3) {
      La(o).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: i.componentIndex, seriesIndex: i.seriesIndex, seriesName: i.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: t3 && t3.dataIndex, name: t3 && t3.name }, treePathInfo: t3 && gne(t3, i) };
    }
    var USt = GSt, qSt = function() {
      function o() {
        this._storage = [], this._elExistsMap = {};
      }
      return o.prototype.add = function(i, t3, c3, p3, g3) {
        return this._elExistsMap[i.id] ? false : (this._elExistsMap[i.id] = true, this._storage.push({ el: i, target: t3, duration: c3, delay: p3, easing: g3 }), true);
      }, o.prototype.finished = function(i) {
        return this._finishedCallback = i, this;
      }, o.prototype.start = function() {
        for (var i = this, t3 = this._storage.length, c3 = function() {
          t3--, t3 <= 0 && (i._storage.length = 0, i._elExistsMap = {}, i._finishedCallback && i._finishedCallback());
        }, p3 = 0, g3 = this._storage.length; p3 < g3; p3++) {
          var b3 = this._storage[p3];
          b3.el.animateTo(b3.target, { duration: b3.duration, delay: b3.delay, easing: b3.easing, setToFinal: true, done: c3, aborted: c3 });
        }
        return this;
      }, o;
    }();
    function $St() {
      return new qSt();
    }
    var hye = vs, n8e = bu, r8e = 3, i8e = "label", a8e = "upperLabel", XSt = qM * 10, YSt = qM * 2, KSt = qM * 3, wL = mI([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), o8e = function(o) {
      var i = wL(o);
      return i.stroke = i.fill = i.lineWidth = null, i;
    }, yne = mu(), ZSt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._state = "ready", t3._storage = _W(), t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        var b3 = c3.findComponents({ mainType: "series", subType: "treemap", query: g3 });
        if (!(rl(b3, t3) < 0)) {
          this.seriesModel = t3, this.api = p3, this.ecModel = c3;
          var w3 = ["treemapZoomToNode", "treemapRootToNode"], M = mW(g3, w3, t3), I = g3 && g3.type, k3 = t3.layoutInfo, L = !this._oldTree, F = this._storage, B = I === "treemapRootToNode" && M && F ? { rootNodeGroup: F.nodeGroup[M.node.getRawIndex()], direction: g3.direction } : null, G = this._giveContainerGroup(k3), J = t3.get("animation"), Q = this._doRender(G, t3, B);
          J && !L && (!I || I === "treemapZoomToNode" || I === "treemapRootToNode") ? this._doAnimation(G, Q, t3, B) : Q.renderFinally(), this._resetController(p3), this._renderBreadcrumb(t3, p3, M);
        }
      }, i.prototype._giveContainerGroup = function(t3) {
        var c3 = this._containerGroup;
        return c3 || (c3 = this._containerGroup = new hye(), this._initEvents(c3), this.group.add(c3)), c3.x = t3.x, c3.y = t3.y, c3;
      }, i.prototype._doRender = function(t3, c3, p3) {
        var g3 = c3.getData().tree, b3 = this._oldTree, w3 = _W(), M = _W(), I = this._storage, k3 = [];
        function L(Q, se, he, be) {
          return JSt(c3, M, I, p3, w3, k3, Q, se, he, be);
        }
        B(g3.root ? [g3.root] : [], b3 && b3.root ? [b3.root] : [], t3, g3 === b3 || !b3, 0);
        var F = G(I);
        return this._oldTree = g3, this._storage = M, { lastsForAnimation: w3, willDeleteEls: F, renderFinally: J };
        function B(Q, se, he, be, de) {
          be ? (se = Q, yt(Q, function(ze, $e) {
            !ze.isRemoved() && Pe($e, $e);
          })) : new RI(se, Q, Fe, Fe).add(Pe).update(Pe).remove(As(Pe, null)).execute();
          function Fe(ze) {
            return ze.getId();
          }
          function Pe(ze, $e) {
            var Ke = ze != null ? Q[ze] : null, nt = $e != null ? se[$e] : null, lt2 = L(Ke, nt, he, de);
            lt2 && B(Ke && Ke.viewChildren || [], nt && nt.viewChildren || [], lt2, be, de + 1);
          }
        }
        function G(Q) {
          var se = _W();
          return Q && yt(Q, function(he, be) {
            var de = se[be];
            yt(he, function(Fe) {
              Fe && (de.push(Fe), yne(Fe).willDelete = true);
            });
          }), se;
        }
        function J() {
          yt(F, function(Q) {
            yt(Q, function(se) {
              se.parent && se.parent.remove(se);
            });
          }), yt(k3, function(Q) {
            Q.invisible = true, Q.dirty();
          });
        }
      }, i.prototype._doAnimation = function(t3, c3, p3, g3) {
        var b3 = p3.get("animationDurationUpdate"), w3 = p3.get("animationEasing"), M = (Vo(b3) ? 0 : b3) || 0, I = (Vo(w3) ? null : w3) || "cubicOut", k3 = $St();
        yt(c3.willDeleteEls, function(L, F) {
          yt(L, function(B, G) {
            if (!B.invisible) {
              var J = B.parent, Q, se = yne(J);
              if (g3 && g3.direction === "drillDown")
                Q = J === g3.rootNodeGroup ? { shape: { x: 0, y: 0, width: se.nodeWidth, height: se.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
              else {
                var he = 0, be = 0;
                se.willDelete || (he = se.nodeWidth / 2, be = se.nodeHeight / 2), Q = F === "nodeGroup" ? { x: he, y: be, style: { opacity: 0 } } : { shape: { x: he, y: be, width: 0, height: 0 }, style: { opacity: 0 } };
              }
              Q && k3.add(B, Q, M, 0, I);
            }
          });
        }), yt(this._storage, function(L, F) {
          yt(L, function(B, G) {
            var J = c3.lastsForAnimation[F][G], Q = {};
            !J || (B instanceof vs ? J.oldX != null && (Q.x = B.x, Q.y = B.y, B.x = J.oldX, B.y = J.oldY) : (J.oldShape && (Q.shape = ti({}, B.shape), B.setShape(J.oldShape)), J.fadein ? (B.setStyle("opacity", 0), Q.style = { opacity: 1 }) : B.style.opacity !== 1 && (Q.style = { opacity: 1 })), k3.add(B, Q, M, 0, I));
          });
        }, this), this._state = "animating", k3.finished(Qa(function() {
          this._state = "ready", c3.renderFinally();
        }, this)).start();
      }, i.prototype._resetController = function(t3) {
        var c3 = this._controller;
        c3 || (c3 = this._controller = new dW(t3.getZr()), c3.enable(this.seriesModel.get("roam")), c3.on("pan", Qa(this._onPan, this)), c3.on("zoom", Qa(this._onZoom, this)));
        var p3 = new Ys(0, 0, t3.getWidth(), t3.getHeight());
        c3.setPointerChecker(function(g3, b3, w3) {
          return p3.contain(b3, w3);
        });
      }, i.prototype._clearController = function() {
        var t3 = this._controller;
        t3 && (t3.dispose(), t3 = null);
      }, i.prototype._onPan = function(t3) {
        if (this._state !== "animating" && (Math.abs(t3.dx) > r8e || Math.abs(t3.dy) > r8e)) {
          var c3 = this.seriesModel.getData().tree.root;
          if (!c3)
            return;
          var p3 = c3.getLayout();
          if (!p3)
            return;
          this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: p3.x + t3.dx, y: p3.y + t3.dy, width: p3.width, height: p3.height } });
        }
      }, i.prototype._onZoom = function(t3) {
        var c3 = t3.originX, p3 = t3.originY;
        if (this._state !== "animating") {
          var g3 = this.seriesModel.getData().tree.root;
          if (!g3)
            return;
          var b3 = g3.getLayout();
          if (!b3)
            return;
          var w3 = new Ys(b3.x, b3.y, b3.width, b3.height), M = this.seriesModel.layoutInfo;
          c3 -= M.x, p3 -= M.y;
          var I = dm();
          D1(I, I, [-c3, -p3]), CF(I, I, [t3.scale, t3.scale]), D1(I, I, [c3, p3]), w3.applyTransform(I), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: w3.x, y: w3.y, width: w3.width, height: w3.height } });
        }
      }, i.prototype._initEvents = function(t3) {
        var c3 = this;
        t3.on("click", function(p3) {
          if (c3._state === "ready") {
            var g3 = c3.seriesModel.get("nodeClick", true);
            if (g3) {
              var b3 = c3.findTarget(p3.offsetX, p3.offsetY);
              if (b3) {
                var w3 = b3.node;
                if (w3.getLayout().isLeafRoot)
                  c3._rootToNode(b3);
                else if (g3 === "zoomToNode")
                  c3._zoomToNode(b3);
                else if (g3 === "link") {
                  var M = w3.hostTree.data.getItemModel(w3.dataIndex), I = M.get("link", true), k3 = M.get("target", true) || "blank";
                  I && pte(I, k3);
                }
              }
            }
          }
        }, this);
      }, i.prototype._renderBreadcrumb = function(t3, c3, p3) {
        var g3 = this;
        p3 || (p3 = t3.get("leafDepth", true) != null ? { node: t3.getViewRoot() } : this.findTarget(c3.getWidth() / 2, c3.getHeight() / 2), p3 || (p3 = { node: t3.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new USt(this.group))).render(t3, c3, p3.node, function(b3) {
          g3._state !== "animating" && (cye(t3.getViewRoot(), b3) ? g3._rootToNode({ node: b3 }) : g3._zoomToNode({ node: b3 }));
        });
      }, i.prototype.remove = function() {
        this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = _W(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
      }, i.prototype.dispose = function() {
        this._clearController();
      }, i.prototype._zoomToNode = function(t3) {
        this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: t3.node });
      }, i.prototype._rootToNode = function(t3) {
        this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: t3.node });
      }, i.prototype.findTarget = function(t3, c3) {
        var p3, g3 = this.seriesModel.getViewRoot();
        return g3.eachNode({ attr: "viewChildren", order: "preorder" }, function(b3) {
          var w3 = this._storage.background[b3.getRawIndex()];
          if (w3) {
            var M = w3.transformCoordToLocal(t3, c3), I = w3.shape;
            if (I.x <= M[0] && M[0] <= I.x + I.width && I.y <= M[1] && M[1] <= I.y + I.height)
              p3 = { node: b3, offsetX: M[0], offsetY: M[1] };
            else
              return false;
          }
        }, this), p3;
      }, i.type = "treemap", i;
    }(yh);
    function _W() {
      return { nodeGroup: [], background: [], content: [] };
    }
    function JSt(o, i, t3, c3, p3, g3, b3, w3, M, I) {
      if (!b3)
        return;
      var k3 = b3.getLayout(), L = o.getData(), F = b3.getModel();
      if (L.setItemGraphicEl(b3.dataIndex, null), !k3 || !k3.isInView)
        return;
      var B = k3.width, G = k3.height, J = k3.borderWidth, Q = k3.invisible, se = b3.getRawIndex(), he = w3 && w3.getRawIndex(), be = b3.viewChildren, de = k3.upperHeight, Fe = be && be.length, Pe = F.getModel("itemStyle"), ze = F.getModel(["emphasis", "itemStyle"]), $e = F.getModel(["blur", "itemStyle"]), Ke = F.getModel(["select", "itemStyle"]), nt = Pe.get("borderRadius") || 0, lt2 = Ka("nodeGroup", hye);
      if (!lt2)
        return;
      if (M.add(lt2), lt2.x = k3.x || 0, lt2.y = k3.y || 0, lt2.markRedraw(), yne(lt2).nodeWidth = B, yne(lt2).nodeHeight = G, k3.isAboveViewRoot)
        return lt2;
      var bt = Ka("background", n8e, I, YSt);
      bt && vn(lt2, bt, Fe && k3.upperLabelHeight);
      var vt = F.getModel("emphasis"), jt = vt.get("focus"), Jt = vt.get("blurScope"), Rt = vt.get("disabled"), Jn = jt === "ancestor" ? b3.getAncestorsIndices() : jt === "descendant" ? b3.getDescendantIndices() : jt;
      if (Fe)
        DI(lt2) && EI(lt2, false), bt && (EI(bt, !Rt), L.setItemGraphicEl(b3.dataIndex, bt), sH(bt, Jn, Jt));
      else {
        var ln = Ka("content", n8e, I, KSt);
        ln && kn(lt2, ln), bt.disableMorphing = true, bt && DI(bt) && EI(bt, false), EI(lt2, !Rt), L.setItemGraphicEl(b3.dataIndex, lt2), sH(lt2, Jn, Jt);
      }
      return lt2;
      function vn(xo, Ra, ho) {
        var Mo = La(Ra);
        if (Mo.dataIndex = b3.dataIndex, Mo.seriesIndex = o.seriesIndex, Ra.setShape({ x: 0, y: 0, width: B, height: G, r: nt }), Q)
          cr(Ra);
        else {
          Ra.invisible = false;
          var Xa = b3.getVisual("style"), Zo = Xa.stroke, rc = o8e(Pe);
          rc.fill = Zo;
          var ys = wL(ze);
          ys.fill = ze.get("borderColor");
          var Vu = wL($e);
          Vu.fill = $e.get("borderColor");
          var gc = wL(Ke);
          if (gc.fill = Ke.get("borderColor"), ho) {
            var ef = B - 2 * J;
            gr(Ra, Zo, Xa.opacity, { x: J, y: 0, width: ef, height: de });
          } else
            Ra.removeTextContent();
          Ra.setStyle(rc), Ra.ensureState("emphasis").style = ys, Ra.ensureState("blur").style = Vu, Ra.ensureState("select").style = gc, AI(Ra);
        }
        xo.add(Ra);
      }
      function kn(xo, Ra) {
        var ho = La(Ra);
        ho.dataIndex = b3.dataIndex, ho.seriesIndex = o.seriesIndex;
        var Mo = Math.max(B - 2 * J, 0), Xa = Math.max(G - 2 * J, 0);
        if (Ra.culling = true, Ra.setShape({ x: J, y: J, width: Mo, height: Xa, r: nt }), Q)
          cr(Ra);
        else {
          Ra.invisible = false;
          var Zo = b3.getVisual("style"), rc = Zo.fill, ys = o8e(Pe);
          ys.fill = rc, ys.decal = Zo.decal;
          var Vu = wL(ze), gc = wL($e), ef = wL(Ke);
          gr(Ra, rc, Zo.opacity, null), Ra.setStyle(ys), Ra.ensureState("emphasis").style = Vu, Ra.ensureState("blur").style = gc, Ra.ensureState("select").style = ef, AI(Ra);
        }
        xo.add(Ra);
      }
      function cr(xo) {
        !xo.invisible && g3.push(xo);
      }
      function gr(xo, Ra, ho, Mo) {
        var Xa = F.getModel(Mo ? a8e : i8e), Zo = Jf(F.get("name"), null), rc = Xa.getShallow("show");
        Sm(xo, g0(F, Mo ? a8e : i8e), { defaultText: rc ? Zo : null, inheritColor: Ra, defaultOpacity: ho, labelFetcher: o, labelDataIndex: b3.dataIndex });
        var ys = xo.getTextContent();
        if (ys) {
          var Vu = ys.style, gc = k2(Vu.padding || 0);
          Mo && (xo.setTextConfig({ layoutRect: Mo }), ys.disableLabelLayout = true), ys.beforeUpdate = function() {
            var dv = Math.max((Mo ? Mo.width : xo.shape.width) - gc[1] - gc[3], 0), Wf = Math.max((Mo ? Mo.height : xo.shape.height) - gc[0] - gc[2], 0);
            (Vu.width !== dv || Vu.height !== Wf) && ys.setStyle({ width: dv, height: Wf });
          }, Vu.truncateMinChar = 2, Vu.lineOverflow = "truncate", ha(Vu, Mo, k3);
          var ef = ys.getState("emphasis");
          ha(ef ? ef.style : null, Mo, k3);
        }
      }
      function ha(xo, Ra, ho) {
        var Mo = xo ? xo.text : null;
        if (!Ra && ho.isLeafRoot && Mo != null) {
          var Xa = o.get("drillDownIcon", true);
          xo.text = Xa ? Xa + " " + Mo : Mo;
        }
      }
      function Ka(xo, Ra, ho, Mo) {
        var Xa = he != null && t3[xo][he], Zo = p3[xo];
        return Xa ? (t3[xo][he] = null, Do(Zo, Xa)) : Q || (Xa = new Ra(), Xa instanceof Ab && (Xa.z2 = QSt(ho, Mo)), _o(Zo, Xa)), i[xo][se] = Xa;
      }
      function Do(xo, Ra) {
        var ho = xo[se] = {};
        Ra instanceof hye ? (ho.oldX = Ra.x, ho.oldY = Ra.y) : ho.oldShape = ti({}, Ra.shape);
      }
      function _o(xo, Ra) {
        var ho = xo[se] = {}, Mo = b3.parentNode, Xa = Ra instanceof vs;
        if (Mo && (!c3 || c3.direction === "drillDown")) {
          var Zo = 0, rc = 0, ys = p3.background[Mo.getRawIndex()];
          !c3 && ys && ys.oldShape && (Zo = ys.oldShape.width, rc = ys.oldShape.height), Xa ? (ho.oldX = 0, ho.oldY = rc) : ho.oldShape = { x: Zo, y: rc, width: 0, height: 0 };
        }
        ho.fadein = !Xa;
      }
    }
    function QSt(o, i) {
      return o * XSt + i;
    }
    var e2t = ZSt, xW = yt, t2t = Ua, mne = -1, pye = function() {
      function o(i) {
        var t3 = i.mappingMethod, c3 = i.type, p3 = this.option = Jo(i);
        this.type = c3, this.mappingMethod = t3, this._normalizeData = i2t[t3];
        var g3 = o.visualHandlers[c3];
        this.applyVisual = g3.applyVisual, this.getColorMapper = g3.getColorMapper, this._normalizedToVisual = g3._normalizedToVisual[t3], t3 === "piecewise" ? (dye(p3), n2t(p3)) : t3 === "category" ? p3.categories ? r2t(p3) : dye(p3, true) : (u0(t3 !== "linear" || p3.dataExtent), dye(p3));
      }
      return o.prototype.mapValueToVisual = function(i) {
        var t3 = this._normalizeData(i);
        return this._normalizedToVisual(t3, i);
      }, o.prototype.getNormalizer = function() {
        return Qa(this._normalizeData, this);
      }, o.listVisualTypes = function() {
        return Gl(o.visualHandlers);
      }, o.isValidType = function(i) {
        return o.visualHandlers.hasOwnProperty(i);
      }, o.eachVisual = function(i, t3, c3) {
        Ua(i) ? yt(i, t3, c3) : t3.call(c3, i);
      }, o.mapVisual = function(i, t3, c3) {
        var p3, g3 = Ei(i) ? [] : Ua(i) ? {} : (p3 = true, null);
        return o.eachVisual(i, function(b3, w3) {
          var M = t3.call(c3, b3, w3);
          p3 ? g3 = M : g3[w3] = M;
        }), g3;
      }, o.retrieveVisuals = function(i) {
        var t3 = {}, c3;
        return i && xW(o.visualHandlers, function(p3, g3) {
          i.hasOwnProperty(g3) && (t3[g3] = i[g3], c3 = true);
        }), c3 ? t3 : null;
      }, o.prepareVisualTypes = function(i) {
        if (Ei(i))
          i = i.slice();
        else if (t2t(i)) {
          var t3 = [];
          xW(i, function(c3, p3) {
            t3.push(p3);
          }), i = t3;
        } else
          return [];
        return i.sort(function(c3, p3) {
          return p3 === "color" && c3 !== "color" && c3.indexOf("color") === 0 ? 1 : -1;
        }), i;
      }, o.dependsOn = function(i, t3) {
        return t3 === "color" ? !!(i && i.indexOf(t3) === 0) : i === t3;
      }, o.findPieceIndex = function(i, t3, c3) {
        for (var p3, g3 = 1 / 0, b3 = 0, w3 = t3.length; b3 < w3; b3++) {
          var M = t3[b3].value;
          if (M != null) {
            if (M === i || Ha(M) && M === i + "")
              return b3;
            c3 && F(M, b3);
          }
        }
        for (var b3 = 0, w3 = t3.length; b3 < w3; b3++) {
          var I = t3[b3], k3 = I.interval, L = I.close;
          if (k3) {
            if (k3[0] === -1 / 0) {
              if (_ne(L[1], i, k3[1]))
                return b3;
            } else if (k3[1] === 1 / 0) {
              if (_ne(L[0], k3[0], i))
                return b3;
            } else if (_ne(L[0], k3[0], i) && _ne(L[1], i, k3[1]))
              return b3;
            c3 && F(k3[0], b3), c3 && F(k3[1], b3);
          }
        }
        if (c3)
          return i === 1 / 0 ? t3.length - 1 : i === -1 / 0 ? 0 : p3;
        function F(B, G) {
          var J = Math.abs(B - i);
          J < g3 && (g3 = J, p3 = G);
        }
      }, o.visualHandlers = { color: { applyVisual: wW("color"), getColorMapper: function() {
        var i = this.option;
        return Qa(i.mappingMethod === "category" ? function(t3, c3) {
          return !c3 && (t3 = this._normalizeData(t3)), SW.call(this, t3);
        } : function(t3, c3, p3) {
          var g3 = !!p3;
          return !c3 && (t3 = this._normalizeData(t3)), p3 = iG(t3, i.parsedVisual, p3), g3 ? p3 : bg(p3, "rgba");
        }, this);
      }, _normalizedToVisual: { linear: function(i) {
        return bg(iG(i, this.option.parsedVisual), "rgba");
      }, category: SW, piecewise: function(i, t3) {
        var c3 = gye.call(this, t3);
        return c3 == null && (c3 = bg(iG(i, this.option.parsedVisual), "rgba")), c3;
      }, fixed: SL } }, colorHue: bne(function(i, t3) {
        return IP(i, t3);
      }), colorSaturation: bne(function(i, t3) {
        return IP(i, null, t3);
      }), colorLightness: bne(function(i, t3) {
        return IP(i, null, null, t3);
      }), colorAlpha: bne(function(i, t3) {
        return dF(i, t3);
      }), decal: { applyVisual: wW("decal"), _normalizedToVisual: { linear: null, category: SW, piecewise: null, fixed: null } }, opacity: { applyVisual: wW("opacity"), _normalizedToVisual: vye([0, 1]) }, liftZ: { applyVisual: wW("liftZ"), _normalizedToVisual: { linear: SL, category: SL, piecewise: SL, fixed: SL } }, symbol: { applyVisual: function(i, t3, c3) {
        var p3 = this.mapValueToVisual(i);
        c3("symbol", p3);
      }, _normalizedToVisual: { linear: s8e, category: SW, piecewise: function(i, t3) {
        var c3 = gye.call(this, t3);
        return c3 == null && (c3 = s8e.call(this, i)), c3;
      }, fixed: SL } }, symbolSize: { applyVisual: wW("symbolSize"), _normalizedToVisual: vye([0, 1]) } }, o;
    }();
    function n2t(o) {
      var i = o.pieceList;
      o.hasSpecialVisual = false, yt(i, function(t3, c3) {
        t3.originIndex = c3, t3.visual != null && (o.hasSpecialVisual = true);
      });
    }
    function r2t(o) {
      var i = o.categories, t3 = o.categoryMap = {}, c3 = o.visual;
      if (xW(i, function(b3, w3) {
        t3[b3] = w3;
      }), !Ei(c3)) {
        var p3 = [];
        Ua(c3) ? xW(c3, function(b3, w3) {
          var M = t3[w3];
          p3[M != null ? M : mne] = b3;
        }) : p3[mne] = c3, c3 = l8e(o, p3);
      }
      for (var g3 = i.length - 1; g3 >= 0; g3--)
        c3[g3] == null && (delete t3[i[g3]], i.pop());
    }
    function dye(o, i) {
      var t3 = o.visual, c3 = [];
      Ua(t3) ? xW(t3, function(g3) {
        c3.push(g3);
      }) : t3 != null && c3.push(t3);
      var p3 = { color: 1, symbol: 1 };
      !i && c3.length === 1 && !p3.hasOwnProperty(o.type) && (c3[1] = c3[0]), l8e(o, c3);
    }
    function bne(o) {
      return { applyVisual: function(i, t3, c3) {
        var p3 = this.mapValueToVisual(i);
        c3("color", o(t3("color"), p3));
      }, _normalizedToVisual: vye([0, 1]) };
    }
    function s8e(o) {
      var i = this.option.visual;
      return i[Math.round(Bc(o, [0, 1], [0, i.length - 1], true))] || {};
    }
    function wW(o) {
      return function(i, t3, c3) {
        c3(o, this.mapValueToVisual(i));
      };
    }
    function SW(o) {
      var i = this.option.visual;
      return i[this.option.loop && o !== mne ? o % i.length : o];
    }
    function SL() {
      return this.option.visual[0];
    }
    function vye(o) {
      return { linear: function(i) {
        return Bc(i, o, this.option.visual, true);
      }, category: SW, piecewise: function(i, t3) {
        var c3 = gye.call(this, t3);
        return c3 == null && (c3 = Bc(i, o, this.option.visual, true)), c3;
      }, fixed: SL };
    }
    function gye(o) {
      var i = this.option, t3 = i.pieceList;
      if (i.hasSpecialVisual) {
        var c3 = pye.findPieceIndex(o, t3), p3 = t3[c3];
        if (p3 && p3.visual)
          return p3.visual[this.type];
      }
    }
    function l8e(o, i) {
      return o.visual = i, o.type === "color" && (o.parsedVisual = Fi(i, function(t3) {
        return I1(t3);
      })), i;
    }
    var i2t = { linear: function(o) {
      return Bc(o, this.option.dataExtent, [0, 1], true);
    }, piecewise: function(o) {
      var i = this.option.pieceList, t3 = pye.findPieceIndex(o, i, true);
      if (t3 != null)
        return Bc(t3, [0, i.length - 1], [0, 1], true);
    }, category: function(o) {
      var i = this.option.categories ? this.option.categoryMap[o] : o;
      return i == null ? mne : i;
    }, fixed: uf };
    function _ne(o, i, t3) {
      return o ? i <= t3 : i < t3;
    }
    var wy = pye, a2t = "itemStyle", u8e = mu(), o2t = { seriesType: "treemap", reset: function(o) {
      var i = o.getData().tree, t3 = i.root;
      t3.isRemoved() || c8e(t3, {}, o.getViewRoot().getAncestors(), o);
    } };
    function c8e(o, i, t3, c3) {
      var p3 = o.getModel(), g3 = o.getLayout(), b3 = o.hostTree.data;
      if (!(!g3 || g3.invisible || !g3.isInView)) {
        var w3 = p3.getModel(a2t), M = s2t(w3, i, c3), I = b3.ensureUniqueItemVisual(o.dataIndex, "style"), k3 = w3.get("borderColor"), L = w3.get("borderColorSaturation"), F;
        L != null && (F = f8e(M), k3 = l2t(L, F)), I.stroke = k3;
        var B = o.viewChildren;
        if (!B || !B.length)
          F = f8e(M), I.fill = F;
        else {
          var G = u2t(o, p3, g3, w3, M, B);
          yt(B, function(J, Q) {
            if (J.depth >= t3.length || J === t3[J.depth]) {
              var se = c2t(p3, M, J, Q, G, c3);
              c8e(J, se, t3, c3);
            }
          });
        }
      }
    }
    function s2t(o, i, t3) {
      var c3 = ti({}, i), p3 = t3.designatedVisualItemStyle;
      return yt(["color", "colorAlpha", "colorSaturation"], function(g3) {
        p3[g3] = i[g3];
        var b3 = o.get(g3);
        p3[g3] = null, b3 != null && (c3[g3] = b3);
      }), c3;
    }
    function f8e(o) {
      var i = yye(o, "color");
      if (i) {
        var t3 = yye(o, "colorAlpha"), c3 = yye(o, "colorSaturation");
        return c3 && (i = IP(i, null, null, c3)), t3 && (i = dF(i, t3)), i;
      }
    }
    function l2t(o, i) {
      return i != null ? IP(i, null, null, o) : null;
    }
    function yye(o, i) {
      var t3 = o[i];
      if (t3 != null && t3 !== "none")
        return t3;
    }
    function u2t(o, i, t3, c3, p3, g3) {
      if (!(!g3 || !g3.length)) {
        var b3 = mye(i, "color") || p3.color != null && p3.color !== "none" && (mye(i, "colorAlpha") || mye(i, "colorSaturation"));
        if (b3) {
          var w3 = i.get("visualMin"), M = i.get("visualMax"), I = t3.dataExtent.slice();
          w3 != null && w3 < I[0] && (I[0] = w3), M != null && M > I[1] && (I[1] = M);
          var k3 = i.get("colorMappingBy"), L = { type: b3.name, dataExtent: I, visual: b3.range };
          L.type === "color" && (k3 === "index" || k3 === "id") ? (L.mappingMethod = "category", L.loop = true) : L.mappingMethod = "linear";
          var F = new wy(L);
          return u8e(F).drColorMappingBy = k3, F;
        }
      }
    }
    function mye(o, i) {
      var t3 = o.get(i);
      return Ei(t3) && t3.length ? { name: i, range: t3 } : null;
    }
    function c2t(o, i, t3, c3, p3, g3) {
      var b3 = ti({}, i);
      if (p3) {
        var w3 = p3.type, M = w3 === "color" && u8e(p3).drColorMappingBy, I = M === "index" ? c3 : M === "id" ? g3.mapIdToIndex(t3.getId()) : t3.getValue(o.get("visualDimension"));
        b3[w3] = p3.mapValueToVisual(I);
      }
      return b3;
    }
    var CW = Math.max, xne = Math.min, h8e = lv, bye = yt, p8e = ["itemStyle", "borderWidth"], f2t = ["itemStyle", "gapWidth"], h2t = ["upperLabel", "show"], p2t = ["upperLabel", "height"], d2t = { seriesType: "treemap", reset: function(o, i, t3, c3) {
      var p3 = t3.getWidth(), g3 = t3.getHeight(), b3 = o.option, w3 = Wv(o.getBoxLayoutParams(), { width: t3.getWidth(), height: t3.getHeight() }), M = b3.size || [], I = Da(h8e(w3.width, M[0]), p3), k3 = Da(h8e(w3.height, M[1]), g3), L = c3 && c3.type, F = ["treemapZoomToNode", "treemapRootToNode"], B = mW(c3, F, o), G = L === "treemapRender" || L === "treemapMove" ? c3.rootRect : null, J = o.getViewRoot(), Q = ZFe(J);
      if (L !== "treemapMove") {
        var se = L === "treemapZoomToNode" ? _2t(o, B, J, I, k3) : G ? [G.width, G.height] : [I, k3], he = b3.sort;
        he && he !== "asc" && he !== "desc" && (he = "desc");
        var be = { squareRatio: b3.squareRatio, sort: he, leafDepth: b3.leafDepth };
        J.hostTree.clearLayouts();
        var de = { x: 0, y: 0, width: se[0], height: se[1], area: se[0] * se[1] };
        J.setLayout(de), d8e(J, be, false, 0), de = J.getLayout(), bye(Q, function(Pe, ze) {
          var $e = (Q[ze + 1] || J).getValue();
          Pe.setLayout(ti({ dataExtent: [$e, $e], borderWidth: 0, upperHeight: 0 }, de));
        });
      }
      var Fe = o.getData().tree.root;
      Fe.setLayout(x2t(w3, G, B), true), o.setLayoutInfo(w3), g8e(Fe, new Ys(-w3.x, -w3.y, p3, g3), Q, J, 0);
    } };
    function d8e(o, i, t3, c3) {
      var p3, g3;
      if (!o.isRemoved()) {
        var b3 = o.getLayout();
        p3 = b3.width, g3 = b3.height;
        var w3 = o.getModel(), M = w3.get(p8e), I = w3.get(f2t) / 2, k3 = y8e(w3), L = Math.max(M, k3), F = M - I, B = L - I;
        o.setLayout({ borderWidth: M, upperHeight: L, upperLabelHeight: k3 }, true), p3 = CW(p3 - 2 * F, 0), g3 = CW(g3 - F - B, 0);
        var G = p3 * g3, J = v2t(o, w3, G, i, t3, c3);
        if (J.length) {
          var Q = { x: F, y: B, width: p3, height: g3 }, se = xne(p3, g3), he = 1 / 0, be = [];
          be.area = 0;
          for (var de = 0, Fe = J.length; de < Fe; ) {
            var Pe = J[de];
            be.push(Pe), be.area += Pe.getLayout().area;
            var ze = b2t(be, se, i.squareRatio);
            ze <= he ? (de++, he = ze) : (be.area -= be.pop().getLayout().area, v8e(be, se, Q, I, false), se = xne(Q.width, Q.height), be.length = be.area = 0, he = 1 / 0);
          }
          if (be.length && v8e(be, se, Q, I, true), !t3) {
            var $e = w3.get("childrenVisibleMin");
            $e != null && G < $e && (t3 = true);
          }
          for (var de = 0, Fe = J.length; de < Fe; de++)
            d8e(J[de], i, t3, c3 + 1);
        }
      }
    }
    function v2t(o, i, t3, c3, p3, g3) {
      var b3 = o.children || [], w3 = c3.sort;
      w3 !== "asc" && w3 !== "desc" && (w3 = null);
      var M = c3.leafDepth != null && c3.leafDepth <= g3;
      if (p3 && !M)
        return o.viewChildren = [];
      b3 = Zc(b3, function(B) {
        return !B.isRemoved();
      }), y2t(b3, w3);
      var I = m2t(i, b3, w3);
      if (I.sum === 0)
        return o.viewChildren = [];
      if (I.sum = g2t(i, t3, I.sum, w3, b3), I.sum === 0)
        return o.viewChildren = [];
      for (var k3 = 0, L = b3.length; k3 < L; k3++) {
        var F = b3[k3].getValue() / I.sum * t3;
        b3[k3].setLayout({ area: F });
      }
      return M && (b3.length && o.setLayout({ isLeafRoot: true }, true), b3.length = 0), o.viewChildren = b3, o.setLayout({ dataExtent: I.dataExtent }, true), b3;
    }
    function g2t(o, i, t3, c3, p3) {
      if (!c3)
        return t3;
      for (var g3 = o.get("visibleMin"), b3 = p3.length, w3 = b3, M = b3 - 1; M >= 0; M--) {
        var I = p3[c3 === "asc" ? b3 - M - 1 : M].getValue();
        I / t3 * i < g3 && (w3 = M, t3 -= I);
      }
      return c3 === "asc" ? p3.splice(0, b3 - w3) : p3.splice(w3, b3 - w3), t3;
    }
    function y2t(o, i) {
      return i && o.sort(function(t3, c3) {
        var p3 = i === "asc" ? t3.getValue() - c3.getValue() : c3.getValue() - t3.getValue();
        return p3 === 0 ? i === "asc" ? t3.dataIndex - c3.dataIndex : c3.dataIndex - t3.dataIndex : p3;
      }), o;
    }
    function m2t(o, i, t3) {
      for (var c3 = 0, p3 = 0, g3 = i.length; p3 < g3; p3++)
        c3 += i[p3].getValue();
      var b3 = o.get("visualDimension"), w3;
      return !i || !i.length ? w3 = [NaN, NaN] : b3 === "value" && t3 ? (w3 = [i[i.length - 1].getValue(), i[0].getValue()], t3 === "asc" && w3.reverse()) : (w3 = [1 / 0, -1 / 0], bye(i, function(M) {
        var I = M.getValue(b3);
        I < w3[0] && (w3[0] = I), I > w3[1] && (w3[1] = I);
      })), { sum: c3, dataExtent: w3 };
    }
    function b2t(o, i, t3) {
      for (var c3 = 0, p3 = 1 / 0, g3 = 0, b3 = void 0, w3 = o.length; g3 < w3; g3++)
        b3 = o[g3].getLayout().area, b3 && (b3 < p3 && (p3 = b3), b3 > c3 && (c3 = b3));
      var M = o.area * o.area, I = i * i * t3;
      return M ? CW(I * c3 / M, M / (I * p3)) : 1 / 0;
    }
    function v8e(o, i, t3, c3, p3) {
      var g3 = i === t3.width ? 0 : 1, b3 = 1 - g3, w3 = ["x", "y"], M = ["width", "height"], I = t3[w3[g3]], k3 = i ? o.area / i : 0;
      (p3 || k3 > t3[M[b3]]) && (k3 = t3[M[b3]]);
      for (var L = 0, F = o.length; L < F; L++) {
        var B = o[L], G = {}, J = k3 ? B.getLayout().area / k3 : 0, Q = G[M[b3]] = CW(k3 - 2 * c3, 0), se = t3[w3[g3]] + t3[M[g3]] - I, he = L === F - 1 || se < J ? se : J, be = G[M[g3]] = CW(he - 2 * c3, 0);
        G[w3[b3]] = t3[w3[b3]] + xne(c3, Q / 2), G[w3[g3]] = I + xne(c3, be / 2), I += he, B.setLayout(G, true);
      }
      t3[w3[b3]] += k3, t3[M[b3]] -= k3;
    }
    function _2t(o, i, t3, c3, p3) {
      var g3 = (i || {}).node, b3 = [c3, p3];
      if (!g3 || g3 === t3)
        return b3;
      for (var w3, M = c3 * p3, I = M * o.option.zoomToNodeRatio; w3 = g3.parentNode; ) {
        for (var k3 = 0, L = w3.children, F = 0, B = L.length; F < B; F++)
          k3 += L[F].getValue();
        var G = g3.getValue();
        if (G === 0)
          return b3;
        I *= k3 / G;
        var J = w3.getModel(), Q = J.get(p8e), se = Math.max(Q, y8e(J));
        I += 4 * Q * Q + (3 * Q + se) * Math.pow(I, 0.5), I > SG && (I = SG), g3 = w3;
      }
      I < M && (I = M);
      var he = Math.pow(I / M, 0.5);
      return [c3 * he, p3 * he];
    }
    function x2t(o, i, t3) {
      if (i)
        return { x: i.x, y: i.y };
      var c3 = { x: 0, y: 0 };
      if (!t3)
        return c3;
      var p3 = t3.node, g3 = p3.getLayout();
      if (!g3)
        return c3;
      for (var b3 = [g3.width / 2, g3.height / 2], w3 = p3; w3; ) {
        var M = w3.getLayout();
        b3[0] += M.x, b3[1] += M.y, w3 = w3.parentNode;
      }
      return { x: o.width / 2 - b3[0], y: o.height / 2 - b3[1] };
    }
    function g8e(o, i, t3, c3, p3) {
      var g3 = o.getLayout(), b3 = t3[p3], w3 = b3 && b3 === o;
      if (!(b3 && !w3 || p3 === t3.length && o !== c3)) {
        o.setLayout({ isInView: true, invisible: !w3 && !i.intersect(g3), isAboveViewRoot: w3 }, true);
        var M = new Ys(i.x - g3.x, i.y - g3.y, i.width, i.height);
        bye(o.viewChildren || [], function(I) {
          g8e(I, M, t3, c3, p3 + 1);
        });
      }
    }
    function y8e(o) {
      return o.get(h2t) ? o.get(p2t) : 0;
    }
    function w2t(o) {
      o.registerSeriesModel(zSt), o.registerChartView(e2t), o.registerVisual(o2t), o.registerLayout(d2t), FSt(o);
    }
    function S2t(o) {
      var i = o.findComponents({ mainType: "legend" });
      !i || !i.length || o.eachSeriesByType("graph", function(t3) {
        var c3 = t3.getCategoriesData(), p3 = t3.getGraph(), g3 = p3.data, b3 = c3.mapArray(c3.getName);
        g3.filterSelf(function(w3) {
          var M = g3.getItemModel(w3), I = M.getShallow("category");
          if (I != null) {
            ec(I) && (I = b3[I]);
            for (var k3 = 0; k3 < i.length; k3++)
              if (!i[k3].isSelected(I))
                return false;
          }
          return true;
        });
      });
    }
    function C2t(o) {
      var i = {};
      o.eachSeriesByType("graph", function(t3) {
        var c3 = t3.getCategoriesData(), p3 = t3.getData(), g3 = {};
        c3.each(function(b3) {
          var w3 = c3.getName(b3);
          g3["ec-" + w3] = b3;
          var M = c3.getItemModel(b3), I = M.getModel("itemStyle").getItemStyle();
          I.fill || (I.fill = t3.getColorFromPalette(w3, i)), c3.setItemVisual(b3, "style", I);
          for (var k3 = ["symbol", "symbolSize", "symbolKeepAspect"], L = 0; L < k3.length; L++) {
            var F = M.getShallow(k3[L], true);
            F != null && c3.setItemVisual(b3, k3[L], F);
          }
        }), c3.count() && p3.each(function(b3) {
          var w3 = p3.getItemModel(b3), M = w3.getShallow("category");
          if (M != null) {
            Ha(M) && (M = g3["ec-" + M]);
            var I = c3.getItemVisual(M, "style"), k3 = p3.ensureUniqueItemVisual(b3, "style");
            ti(k3, I);
            for (var L = ["symbol", "symbolSize", "symbolKeepAspect"], F = 0; F < L.length; F++)
              p3.setItemVisual(b3, L[F], c3.getItemVisual(M, L[F]));
          }
        });
      });
    }
    function wne(o) {
      return o instanceof Array || (o = [o, o]), o;
    }
    function M2t(o) {
      o.eachSeriesByType("graph", function(i) {
        var t3 = i.getGraph(), c3 = i.getEdgeData(), p3 = wne(i.get("edgeSymbol")), g3 = wne(i.get("edgeSymbolSize"));
        c3.setVisual("fromSymbol", p3 && p3[0]), c3.setVisual("toSymbol", p3 && p3[1]), c3.setVisual("fromSymbolSize", g3 && g3[0]), c3.setVisual("toSymbolSize", g3 && g3[1]), c3.setVisual("style", i.getModel("lineStyle").getLineStyle()), c3.each(function(b3) {
          var w3 = c3.getItemModel(b3), M = t3.getEdgeByIndex(b3), I = wne(w3.getShallow("symbol", true)), k3 = wne(w3.getShallow("symbolSize", true)), L = w3.getModel("lineStyle").getLineStyle(), F = c3.ensureUniqueItemVisual(b3, "style");
          switch (ti(F, L), F.stroke) {
            case "source": {
              var B = M.node1.getVisual("style");
              F.stroke = B && B.fill;
              break;
            }
            case "target": {
              var B = M.node2.getVisual("style");
              F.stroke = B && B.fill;
              break;
            }
          }
          I[0] && M.setVisual("fromSymbol", I[0]), I[1] && M.setVisual("toSymbol", I[1]), k3[0] && M.setVisual("fromSymbolSize", k3[0]), k3[1] && M.setVisual("toSymbolSize", k3[1]);
        });
      });
    }
    var _ye = "-->", Sne = function(o) {
      return o.get("autoCurveness") || null;
    }, m8e = function(o, i) {
      var t3 = Sne(o), c3 = 20, p3 = [];
      if (ec(t3))
        c3 = t3;
      else if (Ei(t3)) {
        o.__curvenessList = t3;
        return;
      }
      i > c3 && (c3 = i);
      var g3 = c3 % 2 ? c3 + 2 : c3 + 3;
      p3 = [];
      for (var b3 = 0; b3 < g3; b3++)
        p3.push((b3 % 2 ? b3 + 1 : b3) / 10 * (b3 % 2 ? -1 : 1));
      o.__curvenessList = p3;
    }, MW = function(o, i, t3) {
      var c3 = [o.id, o.dataIndex].join("."), p3 = [i.id, i.dataIndex].join(".");
      return [t3.uid, c3, p3].join(_ye);
    }, b8e = function(o) {
      var i = o.split(_ye);
      return [i[0], i[2], i[1]].join(_ye);
    }, T2t = function(o, i) {
      var t3 = MW(o.node1, o.node2, i);
      return i.__edgeMap[t3];
    }, A2t = function(o, i) {
      var t3 = xye(MW(o.node1, o.node2, i), i), c3 = xye(MW(o.node2, o.node1, i), i);
      return t3 + c3;
    }, xye = function(o, i) {
      var t3 = i.__edgeMap;
      return t3[o] ? t3[o].length : 0;
    };
    function I2t(o) {
      !Sne(o) || (o.__curvenessList = [], o.__edgeMap = {}, m8e(o));
    }
    function E2t(o, i, t3, c3) {
      if (Sne(t3)) {
        var p3 = MW(o, i, t3), g3 = t3.__edgeMap, b3 = g3[b8e(p3)];
        g3[p3] && !b3 ? g3[p3].isForward = true : b3 && g3[p3] && (b3.isForward = true, g3[p3].isForward = false), g3[p3] = g3[p3] || [], g3[p3].push(c3);
      }
    }
    function wye(o, i, t3, c3) {
      var p3 = Sne(i), g3 = Ei(p3);
      if (!p3)
        return null;
      var b3 = T2t(o, i);
      if (!b3)
        return null;
      for (var w3 = -1, M = 0; M < b3.length; M++)
        if (b3[M] === t3) {
          w3 = M;
          break;
        }
      var I = A2t(o, i);
      m8e(i, I), o.lineStyle = o.lineStyle || {};
      var k3 = MW(o.node1, o.node2, i), L = i.__curvenessList, F = g3 || I % 2 ? 0 : 1;
      if (b3.isForward)
        return L[F + w3];
      var B = b8e(k3), G = xye(B, i), J = L[w3 + G + F];
      return c3 ? g3 ? p3 && p3[0] === 0 ? (G + F) % 2 ? J : -J : ((G % 2 ? 0 : 1) + F) % 2 ? J : -J : (G + F) % 2 ? J : -J : L[w3 + G + F];
    }
    function _8e(o) {
      var i = o.coordinateSystem;
      if (!(i && i.type !== "view")) {
        var t3 = o.getGraph();
        t3.eachNode(function(c3) {
          var p3 = c3.getModel();
          c3.setLayout([+p3.get("x"), +p3.get("y")]);
        }), x8e(t3, o);
      }
    }
    function x8e(o, i) {
      o.eachEdge(function(t3, c3) {
        var p3 = np(t3.getModel().get(["lineStyle", "curveness"]), -wye(t3, i, c3, true), 0), g3 = wb(t3.node1.getLayout()), b3 = wb(t3.node2.getLayout()), w3 = [g3, b3];
        +p3 && w3.push([(g3[0] + b3[0]) / 2 - (g3[1] - b3[1]) * p3, (g3[1] + b3[1]) / 2 - (b3[0] - g3[0]) * p3]), t3.setLayout(w3);
      });
    }
    function D2t(o, i) {
      o.eachSeriesByType("graph", function(t3) {
        var c3 = t3.get("layout"), p3 = t3.coordinateSystem;
        if (p3 && p3.type !== "view") {
          var g3 = t3.getData(), b3 = [];
          yt(p3.dimensions, function(F) {
            b3 = b3.concat(g3.mapDimensionsAll(F));
          });
          for (var w3 = 0; w3 < g3.count(); w3++) {
            for (var M = [], I = false, k3 = 0; k3 < b3.length; k3++) {
              var L = g3.get(b3[k3], w3);
              isNaN(L) || (I = true), M.push(L);
            }
            I ? g3.setItemLayout(w3, p3.dataToPoint(M)) : g3.setItemLayout(w3, [NaN, NaN]);
          }
          x8e(g3.graph, t3);
        } else
          (!c3 || c3 === "none") && _8e(t3);
      });
    }
    function TW(o) {
      var i = o.coordinateSystem;
      if (i.type !== "view")
        return 1;
      var t3 = o.option.nodeScaleRatio, c3 = i.scaleX, p3 = i.getZoom(), g3 = (p3 - 1) * t3 + 1;
      return g3 / c3;
    }
    function AW(o) {
      var i = o.getVisual("symbolSize");
      return i instanceof Array && (i = (i[0] + i[1]) / 2), +i;
    }
    var w8e = Math.PI, Sye = [];
    function S8e(o, i) {
      var t3 = o.coordinateSystem;
      if (!(t3 && t3.type !== "view")) {
        var c3 = t3.getBoundingRect(), p3 = o.getData(), g3 = p3.graph, b3 = c3.width / 2 + c3.x, w3 = c3.height / 2 + c3.y, M = Math.min(c3.width, c3.height) / 2, I = p3.count();
        p3.setLayout({ cx: b3, cy: w3 }), I && (k2t[i](o, g3, p3, M, b3, w3, I), g3.eachEdge(function(k3, L) {
          var F = np(k3.getModel().get(["lineStyle", "curveness"]), wye(k3, o, L), 0), B = wb(k3.node1.getLayout()), G = wb(k3.node2.getLayout()), J, Q = (B[0] + G[0]) / 2, se = (B[1] + G[1]) / 2;
          +F && (F *= 3, J = [b3 * F + Q * (1 - F), w3 * F + se * (1 - F)]), k3.setLayout([B, G, J]);
        }));
      }
    }
    var k2t = { value: function(o, i, t3, c3, p3, g3, b3) {
      var w3 = 0, M = t3.getSum("value"), I = Math.PI * 2 / (M || b3);
      i.eachNode(function(k3) {
        var L = k3.getValue("value"), F = I * (M ? L : 1) / 2;
        w3 += F, k3.setLayout([c3 * Math.cos(w3) + p3, c3 * Math.sin(w3) + g3]), w3 += F;
      });
    }, symbolSize: function(o, i, t3, c3, p3, g3, b3) {
      var w3 = 0;
      Sye.length = b3;
      var M = TW(o);
      i.eachNode(function(L) {
        var F = AW(L);
        isNaN(F) && (F = 2), F < 0 && (F = 0), F *= M;
        var B = Math.asin(F / 2 / c3);
        isNaN(B) && (B = w8e / 2), Sye[L.dataIndex] = B, w3 += B * 2;
      });
      var I = (2 * w8e - w3) / b3 / 2, k3 = 0;
      i.eachNode(function(L) {
        var F = I + Sye[L.dataIndex];
        k3 += F, L.setLayout([c3 * Math.cos(k3) + p3, c3 * Math.sin(k3) + g3]), k3 += F;
      });
    } };
    function O2t(o) {
      o.eachSeriesByType("graph", function(i) {
        i.get("layout") === "circular" && S8e(i, "symbolSize");
      });
    }
    var B8 = ow;
    function P2t(o, i, t3) {
      for (var c3 = o, p3 = i, g3 = t3.rect, b3 = g3.width, w3 = g3.height, M = [g3.x + b3 / 2, g3.y + w3 / 2], I = t3.gravity == null ? 0.1 : t3.gravity, k3 = 0; k3 < c3.length; k3++) {
        var L = c3[k3];
        L.p || (L.p = wM(b3 * (Math.random() - 0.5) + M[0], w3 * (Math.random() - 0.5) + M[1])), L.pp = wb(L.p), L.edges = null;
      }
      var F = t3.friction == null ? 0.6 : t3.friction, B = F, G, J;
      return { warmUp: function() {
        B = F * 0.8;
      }, setFixed: function(Q) {
        c3[Q].fixed = true;
      }, setUnfixed: function(Q) {
        c3[Q].fixed = false;
      }, beforeStep: function(Q) {
        G = Q;
      }, afterStep: function(Q) {
        J = Q;
      }, step: function(Q) {
        G && G(c3, p3);
        for (var se = [], he = c3.length, be = 0; be < p3.length; be++) {
          var de = p3[be];
          if (!de.ignoreForceLayout) {
            var Fe = de.n1, Pe = de.n2;
            O2(se, Pe.p, Fe.p);
            var ze = Hj(se) - de.d, $e = Pe.w / (Fe.w + Pe.w);
            isNaN($e) && ($e = 0), yP(se, se), !Fe.fixed && B8(Fe.p, Fe.p, se, $e * ze * B), !Pe.fixed && B8(Pe.p, Pe.p, se, -(1 - $e) * ze * B);
          }
        }
        for (var be = 0; be < he; be++) {
          var Ke = c3[be];
          Ke.fixed || (O2(se, M, Ke.p), B8(Ke.p, Ke.p, se, I * B));
        }
        for (var be = 0; be < he; be++)
          for (var Fe = c3[be], nt = be + 1; nt < he; nt++) {
            var Pe = c3[nt];
            O2(se, Pe.p, Fe.p);
            var ze = Hj(se);
            ze === 0 && (Gj(se, Math.random() - 0.5, Math.random() - 0.5), ze = 1);
            var lt2 = (Fe.rep + Pe.rep) / ze / ze;
            !Fe.fixed && B8(Fe.pp, Fe.pp, se, lt2), !Pe.fixed && B8(Pe.pp, Pe.pp, se, -lt2);
          }
        for (var bt = [], be = 0; be < he; be++) {
          var Ke = c3[be];
          Ke.fixed || (O2(bt, Ke.p, Ke.pp), B8(Ke.p, Ke.p, bt, B), Zp(Ke.pp, Ke.p));
        }
        B = B * 0.992;
        var vt = B < 0.01;
        J && J(c3, p3, vt), Q && Q(vt);
      } };
    }
    function L2t(o) {
      o.eachSeriesByType("graph", function(i) {
        var t3 = i.coordinateSystem;
        if (!(t3 && t3.type !== "view"))
          if (i.get("layout") === "force") {
            var c3 = i.preservedPoints || {}, p3 = i.getGraph(), g3 = p3.data, b3 = p3.edgeData, w3 = i.getModel("force"), M = w3.get("initLayout");
            i.preservedPoints ? g3.each(function(be) {
              var de = g3.getId(be);
              g3.setItemLayout(be, c3[de] || [NaN, NaN]);
            }) : !M || M === "none" ? _8e(i) : M === "circular" && S8e(i, "value");
            var I = g3.getDataExtent("value"), k3 = b3.getDataExtent("value"), L = w3.get("repulsion"), F = w3.get("edgeLength"), B = Ei(L) ? L : [L, L], G = Ei(F) ? F : [F, F];
            G = [G[1], G[0]];
            var J = g3.mapArray("value", function(be, de) {
              var Fe = g3.getItemLayout(de), Pe = Bc(be, I, B);
              return isNaN(Pe) && (Pe = (B[0] + B[1]) / 2), { w: Pe, rep: Pe, fixed: g3.getItemModel(de).get("fixed"), p: !Fe || isNaN(Fe[0]) || isNaN(Fe[1]) ? null : Fe };
            }), Q = b3.mapArray("value", function(be, de) {
              var Fe = p3.getEdgeByIndex(de), Pe = Bc(be, k3, G);
              isNaN(Pe) && (Pe = (G[0] + G[1]) / 2);
              var ze = Fe.getModel(), $e = np(Fe.getModel().get(["lineStyle", "curveness"]), -wye(Fe, i, de, true), 0);
              return { n1: J[Fe.node1.dataIndex], n2: J[Fe.node2.dataIndex], d: Pe, curveness: $e, ignoreForceLayout: ze.get("ignoreForceLayout") };
            }), se = t3.getBoundingRect(), he = P2t(J, Q, { rect: se, gravity: w3.get("gravity"), friction: w3.get("friction") });
            he.beforeStep(function(be, de) {
              for (var Fe = 0, Pe = be.length; Fe < Pe; Fe++)
                be[Fe].fixed && Zp(be[Fe].p, p3.getNodeByIndex(Fe).getLayout());
            }), he.afterStep(function(be, de, Fe) {
              for (var Pe = 0, ze = be.length; Pe < ze; Pe++)
                be[Pe].fixed || p3.getNodeByIndex(Pe).setLayout(be[Pe].p), c3[g3.getId(Pe)] = be[Pe].p;
              for (var Pe = 0, ze = de.length; Pe < ze; Pe++) {
                var $e = de[Pe], Ke = p3.getEdgeByIndex(Pe), nt = $e.n1.p, lt2 = $e.n2.p, bt = Ke.getLayout();
                bt = bt ? bt.slice() : [], bt[0] = bt[0] || [], bt[1] = bt[1] || [], Zp(bt[0], nt), Zp(bt[1], lt2), +$e.curveness && (bt[2] = [(nt[0] + lt2[0]) / 2 - (nt[1] - lt2[1]) * $e.curveness, (nt[1] + lt2[1]) / 2 - (lt2[0] - nt[0]) * $e.curveness]), Ke.setLayout(bt);
              }
            }), i.forceLayout = he, i.preservedPoints = c3, he.step();
          } else
            i.forceLayout = null;
      });
    }
    function R2t(o, i, t3) {
      var c3 = ti(o.getBoxLayoutParams(), { aspect: t3 });
      return Wv(c3, { width: i.getWidth(), height: i.getHeight() });
    }
    function N2t(o, i) {
      var t3 = [];
      return o.eachSeriesByType("graph", function(c3) {
        var p3 = c3.get("coordinateSystem");
        if (!p3 || p3 === "view") {
          var g3 = c3.getData(), b3 = g3.mapArray(function(Q) {
            var se = g3.getItemModel(Q);
            return [+se.get("x"), +se.get("y")];
          }), w3 = [], M = [];
          UF(b3, w3, M), M[0] - w3[0] === 0 && (M[0] += 1, w3[0] -= 1), M[1] - w3[1] === 0 && (M[1] += 1, w3[1] -= 1);
          var I = (M[0] - w3[0]) / (M[1] - w3[1]), k3 = R2t(c3, i, I);
          isNaN(I) && (w3 = [k3.x, k3.y], M = [k3.x + k3.width, k3.y + k3.height]);
          var L = M[0] - w3[0], F = M[1] - w3[1], B = k3.width, G = k3.height, J = c3.coordinateSystem = new gW();
          J.zoomLimit = c3.get("scaleLimit"), J.setBoundingRect(w3[0], w3[1], L, F), J.setViewRect(k3.x, k3.y, B, G), J.setCenter(c3.get("center")), J.setZoom(c3.get("zoom")), t3.push(J);
        }
      }), t3;
    }
    var C8e = Ud.prototype, Cye = Q5.prototype, M8e = function() {
      function o() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
      }
      return o;
    }();
    (function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i;
    })(M8e);
    function Mye(o) {
      return isNaN(+o.cpx1) || isNaN(+o.cpy1);
    }
    var F2t = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "ec-line", c3;
      }
      return i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new M8e();
      }, i.prototype.buildPath = function(t3, c3) {
        Mye(c3) ? C8e.buildPath.call(this, t3, c3) : Cye.buildPath.call(this, t3, c3);
      }, i.prototype.pointAt = function(t3) {
        return Mye(this.shape) ? C8e.pointAt.call(this, t3) : Cye.pointAt.call(this, t3);
      }, i.prototype.tangentAt = function(t3) {
        var c3 = this.shape, p3 = Mye(c3) ? [c3.x2 - c3.x1, c3.y2 - c3.y1] : Cye.tangentAt.call(this, t3);
        return yP(p3, p3);
      }, i;
    }(gl), V2t = F2t, Tye = ["fromSymbol", "toSymbol"];
    function T8e(o) {
      return "_" + o + "Type";
    }
    function A8e(o, i, t3) {
      var c3 = i.getItemVisual(t3, o);
      if (!(!c3 || c3 === "none")) {
        var p3 = i.getItemVisual(t3, o + "Size"), g3 = i.getItemVisual(t3, o + "Rotate"), b3 = i.getItemVisual(t3, o + "Offset"), w3 = i.getItemVisual(t3, o + "KeepAspect"), M = zH(p3), I = I8(b3 || 0, M), k3 = pv(c3, -M[0] / 2 + I[0], -M[1] / 2 + I[1], M[0], M[1], null, w3);
        return k3.__specifiedRotation = g3 == null || isNaN(g3) ? void 0 : +g3 * Math.PI / 180 || 0, k3.name = o, k3;
      }
    }
    function B2t(o) {
      var i = new V2t({ name: "line", subPixelOptimize: true });
      return Aye(i.shape, o), i;
    }
    function Aye(o, i) {
      o.x1 = i[0][0], o.y1 = i[0][1], o.x2 = i[1][0], o.y2 = i[1][1], o.percent = 1;
      var t3 = i[2];
      t3 ? (o.cpx1 = t3[0], o.cpy1 = t3[1]) : (o.cpx1 = NaN, o.cpy1 = NaN);
    }
    var z2t = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this) || this;
        return g3._createLine(t3, c3, p3), g3;
      }
      return i.prototype._createLine = function(t3, c3, p3) {
        var g3 = t3.hostModel, b3 = t3.getItemLayout(c3), w3 = B2t(b3);
        w3.shape.percent = 0, Uh(w3, { shape: { percent: 1 } }, g3, c3), this.add(w3), yt(Tye, function(M) {
          var I = A8e(M, t3, c3);
          this.add(I), this[T8e(M)] = t3.getItemVisual(c3, M);
        }, this), this._updateCommonStl(t3, c3, p3);
      }, i.prototype.updateData = function(t3, c3, p3) {
        var g3 = t3.hostModel, b3 = this.childOfName("line"), w3 = t3.getItemLayout(c3), M = { shape: {} };
        Aye(M.shape, w3), Du(b3, M, g3, c3), yt(Tye, function(I) {
          var k3 = t3.getItemVisual(c3, I), L = T8e(I);
          if (this[L] !== k3) {
            this.remove(this.childOfName(I));
            var F = A8e(I, t3, c3);
            this.add(F);
          }
          this[L] = k3;
        }, this), this._updateCommonStl(t3, c3, p3);
      }, i.prototype.getLinePath = function() {
        return this.childAt(0);
      }, i.prototype._updateCommonStl = function(t3, c3, p3) {
        var g3 = t3.hostModel, b3 = this.childOfName("line"), w3 = p3 && p3.emphasisLineStyle, M = p3 && p3.blurLineStyle, I = p3 && p3.selectLineStyle, k3 = p3 && p3.labelStatesModels, L = p3 && p3.emphasisDisabled, F = p3 && p3.focus, B = p3 && p3.blurScope;
        if (!p3 || t3.hasItemOption) {
          var G = t3.getItemModel(c3), J = G.getModel("emphasis");
          w3 = J.getModel("lineStyle").getLineStyle(), M = G.getModel(["blur", "lineStyle"]).getLineStyle(), I = G.getModel(["select", "lineStyle"]).getLineStyle(), L = J.get("disabled"), F = J.get("focus"), B = J.get("blurScope"), k3 = g0(G);
        }
        var Q = t3.getItemVisual(c3, "style"), se = Q.stroke;
        b3.useStyle(Q), b3.style.fill = null, b3.style.strokeNoScale = true, b3.ensureState("emphasis").style = w3, b3.ensureState("blur").style = M, b3.ensureState("select").style = I, yt(Tye, function(Pe) {
          var ze = this.childOfName(Pe);
          if (ze) {
            ze.setColor(se), ze.style.opacity = Q.opacity;
            for (var $e = 0; $e < yy.length; $e++) {
              var Ke = yy[$e], nt = b3.getState(Ke);
              if (nt) {
                var lt2 = nt.style || {}, bt = ze.ensureState(Ke), vt = bt.style || (bt.style = {});
                lt2.stroke != null && (vt[ze.__isEmptyBrush ? "stroke" : "fill"] = lt2.stroke), lt2.opacity != null && (vt.opacity = lt2.opacity);
              }
            }
            ze.markRedraw();
          }
        }, this);
        var he = g3.getRawValue(c3);
        Sm(this, k3, { labelDataIndex: c3, labelFetcher: { getFormattedLabel: function(Pe, ze) {
          return g3.getFormattedLabel(Pe, ze, t3.dataType);
        } }, inheritColor: se || "#000", defaultOpacity: Q.opacity, defaultText: (he == null ? t3.getName(c3) : isFinite(he) ? mp(he) : he) + "" });
        var be = this.getTextContent();
        if (be) {
          var de = k3.normal;
          be.__align = be.style.align, be.__verticalAlign = be.style.verticalAlign, be.__position = de.get("position") || "middle";
          var Fe = de.get("distance");
          Ei(Fe) || (Fe = [Fe, Fe]), be.__labelDistance = Fe;
        }
        this.setTextConfig({ position: null, local: true, inside: false }), zp(this, F, B, L);
      }, i.prototype.highlight = function() {
        Hv(this);
      }, i.prototype.downplay = function() {
        sl(this);
      }, i.prototype.updateLayout = function(t3, c3) {
        this.setLinePoints(t3.getItemLayout(c3));
      }, i.prototype.setLinePoints = function(t3) {
        var c3 = this.childOfName("line");
        Aye(c3.shape, t3), c3.dirty();
      }, i.prototype.beforeUpdate = function() {
        var t3 = this, c3 = t3.childOfName("fromSymbol"), p3 = t3.childOfName("toSymbol"), g3 = t3.getTextContent();
        if (!c3 && !p3 && (!g3 || g3.ignore))
          return;
        for (var b3 = 1, w3 = this.parent; w3; )
          w3.scaleX && (b3 /= w3.scaleX), w3 = w3.parent;
        var M = t3.childOfName("line");
        if (!this.__dirty && !M.__dirty)
          return;
        var I = M.shape.percent, k3 = M.pointAt(0), L = M.pointAt(I), F = O2([], L, k3);
        yP(F, F);
        function B(nt, lt2) {
          var bt = nt.__specifiedRotation;
          if (bt == null) {
            var vt = M.tangentAt(lt2);
            nt.attr("rotation", (lt2 === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(vt[1], vt[0]));
          } else
            nt.attr("rotation", bt);
        }
        if (c3 && (c3.setPosition(k3), B(c3, 0), c3.scaleX = c3.scaleY = b3 * I, c3.markRedraw()), p3 && (p3.setPosition(L), B(p3, 1), p3.scaleX = p3.scaleY = b3 * I, p3.markRedraw()), g3 && !g3.ignore) {
          g3.x = g3.y = 0, g3.originX = g3.originY = 0;
          var G = void 0, J = void 0, Q = g3.__labelDistance, se = Q[0] * b3, he = Q[1] * b3, be = I / 2, de = M.tangentAt(be), Fe = [de[1], -de[0]], Pe = M.pointAt(be);
          Fe[1] > 0 && (Fe[0] = -Fe[0], Fe[1] = -Fe[1]);
          var ze = de[0] < 0 ? -1 : 1;
          if (g3.__position !== "start" && g3.__position !== "end") {
            var $e = -Math.atan2(de[1], de[0]);
            L[0] < k3[0] && ($e = Math.PI + $e), g3.rotation = $e;
          }
          var Ke = void 0;
          switch (g3.__position) {
            case "insideStartTop":
            case "insideMiddleTop":
            case "insideEndTop":
            case "middle":
              Ke = -he, J = "bottom";
              break;
            case "insideStartBottom":
            case "insideMiddleBottom":
            case "insideEndBottom":
              Ke = he, J = "top";
              break;
            default:
              Ke = 0, J = "middle";
          }
          switch (g3.__position) {
            case "end":
              g3.x = F[0] * se + L[0], g3.y = F[1] * he + L[1], G = F[0] > 0.8 ? "left" : F[0] < -0.8 ? "right" : "center", J = F[1] > 0.8 ? "top" : F[1] < -0.8 ? "bottom" : "middle";
              break;
            case "start":
              g3.x = -F[0] * se + k3[0], g3.y = -F[1] * he + k3[1], G = F[0] > 0.8 ? "right" : F[0] < -0.8 ? "left" : "center", J = F[1] > 0.8 ? "bottom" : F[1] < -0.8 ? "top" : "middle";
              break;
            case "insideStartTop":
            case "insideStart":
            case "insideStartBottom":
              g3.x = se * ze + k3[0], g3.y = k3[1] + Ke, G = de[0] < 0 ? "right" : "left", g3.originX = -se * ze, g3.originY = -Ke;
              break;
            case "insideMiddleTop":
            case "insideMiddle":
            case "insideMiddleBottom":
            case "middle":
              g3.x = Pe[0], g3.y = Pe[1] + Ke, G = "center", g3.originY = -Ke;
              break;
            case "insideEndTop":
            case "insideEnd":
            case "insideEndBottom":
              g3.x = -se * ze + L[0], g3.y = L[1] + Ke, G = de[0] >= 0 ? "right" : "left", g3.originX = se * ze, g3.originY = -Ke;
              break;
          }
          g3.scaleX = g3.scaleY = b3, g3.setStyle({ verticalAlign: g3.__verticalAlign || J, align: g3.__align || G });
        }
      }, i;
    }(vs), Iye = z2t, j2t = function() {
      function o(i) {
        this.group = new vs(), this._LineCtor = i || Iye;
      }
      return o.prototype.updateData = function(i) {
        var t3 = this;
        this._progressiveEls = null;
        var c3 = this, p3 = c3.group, g3 = c3._lineData;
        c3._lineData = i, g3 || p3.removeAll();
        var b3 = I8e(i);
        i.diff(g3).add(function(w3) {
          t3._doAdd(i, w3, b3);
        }).update(function(w3, M) {
          t3._doUpdate(g3, i, M, w3, b3);
        }).remove(function(w3) {
          p3.remove(g3.getItemGraphicEl(w3));
        }).execute();
      }, o.prototype.updateLayout = function() {
        var i = this._lineData;
        !i || i.eachItemGraphicEl(function(t3, c3) {
          t3.updateLayout(i, c3);
        }, this);
      }, o.prototype.incrementalPrepareUpdate = function(i) {
        this._seriesScope = I8e(i), this._lineData = null, this.group.removeAll();
      }, o.prototype.incrementalUpdate = function(i, t3) {
        this._progressiveEls = [];
        function c3(w3) {
          !w3.isGroup && !G2t(w3) && (w3.incremental = true, w3.ensureState("emphasis").hoverLayer = true);
        }
        for (var p3 = i.start; p3 < i.end; p3++) {
          var g3 = t3.getItemLayout(p3);
          if (Eye(g3)) {
            var b3 = new this._LineCtor(t3, p3, this._seriesScope);
            b3.traverse(c3), this.group.add(b3), t3.setItemGraphicEl(p3, b3), this._progressiveEls.push(b3);
          }
        }
      }, o.prototype.remove = function() {
        this.group.removeAll();
      }, o.prototype.eachRendered = function(i) {
        nk(this._progressiveEls || this.group, i);
      }, o.prototype._doAdd = function(i, t3, c3) {
        var p3 = i.getItemLayout(t3);
        if (Eye(p3)) {
          var g3 = new this._LineCtor(i, t3, c3);
          i.setItemGraphicEl(t3, g3), this.group.add(g3);
        }
      }, o.prototype._doUpdate = function(i, t3, c3, p3, g3) {
        var b3 = i.getItemGraphicEl(c3);
        if (!Eye(t3.getItemLayout(p3))) {
          this.group.remove(b3);
          return;
        }
        b3 ? b3.updateData(t3, p3, g3) : b3 = new this._LineCtor(t3, p3, g3), t3.setItemGraphicEl(p3, b3), this.group.add(b3);
      }, o;
    }();
    function G2t(o) {
      return o.animators && o.animators.length > 0;
    }
    function I8e(o) {
      var i = o.hostModel, t3 = i.getModel("emphasis");
      return { lineStyle: i.getModel("lineStyle").getLineStyle(), emphasisLineStyle: t3.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: i.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: i.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: t3.get("disabled"), blurScope: t3.get("blurScope"), focus: t3.get("focus"), labelStatesModels: g0(i) };
    }
    function E8e(o) {
      return isNaN(o[0]) || isNaN(o[1]);
    }
    function Eye(o) {
      return o && !E8e(o[0]) && !E8e(o[1]);
    }
    var Dye = j2t, kye = [], Oye = [], Pye = [], z8 = Dc, Lye = Sb, D8e = Math.abs;
    function k8e(o, i, t3) {
      for (var c3 = o[0], p3 = o[1], g3 = o[2], b3 = 1 / 0, w3, M = t3 * t3, I = 0.1, k3 = 0.1; k3 <= 0.9; k3 += 0.1) {
        kye[0] = z8(c3[0], p3[0], g3[0], k3), kye[1] = z8(c3[1], p3[1], g3[1], k3);
        var L = D8e(Lye(kye, i) - M);
        L < b3 && (b3 = L, w3 = k3);
      }
      for (var F = 0; F < 32; F++) {
        var B = w3 + I;
        Oye[0] = z8(c3[0], p3[0], g3[0], w3), Oye[1] = z8(c3[1], p3[1], g3[1], w3), Pye[0] = z8(c3[0], p3[0], g3[0], B), Pye[1] = z8(c3[1], p3[1], g3[1], B);
        var L = Lye(Oye, i) - M;
        if (D8e(L) < 0.01)
          break;
        var G = Lye(Pye, i) - M;
        I /= 2, L < 0 ? G >= 0 ? w3 = w3 + I : w3 = w3 - I : G >= 0 ? w3 = w3 - I : w3 = w3 + I;
      }
      return w3;
    }
    function Rye(o, i) {
      var t3 = [], c3 = D5, p3 = [[], [], []], g3 = [[], []], b3 = [];
      i /= 2, o.eachEdge(function(w3, M) {
        var I = w3.getLayout(), k3 = w3.getVisual("fromSymbol"), L = w3.getVisual("toSymbol");
        I.__original || (I.__original = [wb(I[0]), wb(I[1])], I[2] && I.__original.push(wb(I[2])));
        var F = I.__original;
        if (I[2] != null) {
          if (Zp(p3[0], F[0]), Zp(p3[1], F[2]), Zp(p3[2], F[1]), k3 && k3 !== "none") {
            var B = AW(w3.node1), G = k8e(p3, F[0], B * i);
            c3(p3[0][0], p3[1][0], p3[2][0], G, t3), p3[0][0] = t3[3], p3[1][0] = t3[4], c3(p3[0][1], p3[1][1], p3[2][1], G, t3), p3[0][1] = t3[3], p3[1][1] = t3[4];
          }
          if (L && L !== "none") {
            var B = AW(w3.node2), G = k8e(p3, F[1], B * i);
            c3(p3[0][0], p3[1][0], p3[2][0], G, t3), p3[1][0] = t3[1], p3[2][0] = t3[2], c3(p3[0][1], p3[1][1], p3[2][1], G, t3), p3[1][1] = t3[1], p3[2][1] = t3[2];
          }
          Zp(I[0], p3[0]), Zp(I[1], p3[2]), Zp(I[2], p3[1]);
        } else {
          if (Zp(g3[0], F[0]), Zp(g3[1], F[1]), O2(b3, g3[1], g3[0]), yP(b3, b3), k3 && k3 !== "none") {
            var B = AW(w3.node1);
            ow(g3[0], g3[0], b3, B * i);
          }
          if (L && L !== "none") {
            var B = AW(w3.node2);
            ow(g3[1], g3[1], b3, -B * i);
          }
          Zp(I[0], g3[0]), Zp(I[1], g3[1]);
        }
      });
    }
    function O8e(o) {
      return o.type === "view";
    }
    var H2t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3) {
        var p3 = new lW(), g3 = new Dye(), b3 = this.group;
        this._controller = new dW(c3.getZr()), this._controllerHost = { target: b3 }, b3.add(p3.group), b3.add(g3.group), this._symbolDraw = p3, this._lineDraw = g3, this._firstRender = true;
      }, i.prototype.render = function(t3, c3, p3) {
        var g3 = this, b3 = t3.coordinateSystem;
        this._model = t3;
        var w3 = this._symbolDraw, M = this._lineDraw, I = this.group;
        if (O8e(b3)) {
          var k3 = { x: b3.x, y: b3.y, scaleX: b3.scaleX, scaleY: b3.scaleY };
          this._firstRender ? I.attr(k3) : Du(I, k3, t3);
        }
        Rye(t3.getGraph(), TW(t3));
        var L = t3.getData();
        w3.updateData(L);
        var F = t3.getEdgeData();
        M.updateData(F), this._updateNodeAndLinkScale(), this._updateController(t3, c3, p3), clearTimeout(this._layoutTimeout);
        var B = t3.forceLayout, G = t3.get(["force", "layoutAnimation"]);
        B && this._startForceLayoutIteration(B, G), L.graph.eachNode(function(he) {
          var be = he.dataIndex, de = he.getGraphicEl(), Fe = he.getModel();
          if (de) {
            de.off("drag").off("dragend");
            var Pe = Fe.get("draggable");
            Pe && de.on("drag", function() {
              B && (B.warmUp(), !g3._layouting && g3._startForceLayoutIteration(B, G), B.setFixed(be), L.setItemLayout(be, [de.x, de.y]));
            }).on("dragend", function() {
              B && B.setUnfixed(be);
            }), de.setDraggable(Pe && !!B);
            var ze = Fe.get(["emphasis", "focus"]);
            ze === "adjacency" && (La(de).focus = he.getAdjacentDataIndices());
          }
        }), L.graph.eachEdge(function(he) {
          var be = he.getGraphicEl(), de = he.getModel().get(["emphasis", "focus"]);
          !be || de === "adjacency" && (La(be).focus = { edge: [he.dataIndex], node: [he.node1.dataIndex, he.node2.dataIndex] });
        });
        var J = t3.get("layout") === "circular" && t3.get(["circular", "rotateLabel"]), Q = L.getLayout("cx"), se = L.getLayout("cy");
        L.eachItemGraphicEl(function(he, be) {
          var de = L.getItemModel(be), Fe = de.get(["label", "rotate"]) || 0, Pe = he.getSymbolPath();
          if (J) {
            var ze = L.getItemLayout(be), $e = Math.atan2(ze[1] - se, ze[0] - Q);
            $e < 0 && ($e = Math.PI * 2 + $e);
            var Ke = ze[0] < Q;
            Ke && ($e = $e - Math.PI);
            var nt = Ke ? "left" : "right";
            Pe.setTextConfig({ rotation: -$e, position: nt, origin: "center" });
            var lt2 = Pe.ensureState("emphasis");
            ti(lt2.textConfig || (lt2.textConfig = {}), { position: nt });
          } else
            Pe.setTextConfig({ rotation: Fe *= Math.PI / 180 });
        }), this._firstRender = false;
      }, i.prototype.dispose = function() {
        this._controller && this._controller.dispose(), this._controllerHost = null;
      }, i.prototype._startForceLayoutIteration = function(t3, c3) {
        var p3 = this;
        (function g3() {
          t3.step(function(b3) {
            p3.updateLayout(p3._model), (p3._layouting = !b3) && (c3 ? p3._layoutTimeout = setTimeout(g3, 16) : g3());
          });
        })();
      }, i.prototype._updateController = function(t3, c3, p3) {
        var g3 = this, b3 = this._controller, w3 = this._controllerHost, M = this.group;
        if (b3.setPointerChecker(function(I, k3, L) {
          var F = M.getBoundingRect();
          return F.applyTransform(M.transform), F.contain(k3, L) && !fne(I, p3, t3);
        }), !O8e(t3.coordinateSystem)) {
          b3.disable();
          return;
        }
        b3.enable(t3.get("roam")), w3.zoomLimit = t3.get("scaleLimit"), w3.zoom = t3.coordinateSystem.getZoom(), b3.off("pan").off("zoom").on("pan", function(I) {
          J0e(w3, I.dx, I.dy), p3.dispatchAction({ seriesId: t3.id, type: "graphRoam", dx: I.dx, dy: I.dy });
        }).on("zoom", function(I) {
          Q0e(w3, I.scale, I.originX, I.originY), p3.dispatchAction({ seriesId: t3.id, type: "graphRoam", zoom: I.scale, originX: I.originX, originY: I.originY }), g3._updateNodeAndLinkScale(), Rye(t3.getGraph(), TW(t3)), g3._lineDraw.updateLayout(), p3.updateLabelLayout();
        });
      }, i.prototype._updateNodeAndLinkScale = function() {
        var t3 = this._model, c3 = t3.getData(), p3 = TW(t3);
        c3.eachItemGraphicEl(function(g3, b3) {
          g3 && g3.setSymbolScale(p3);
        });
      }, i.prototype.updateLayout = function(t3) {
        Rye(t3.getGraph(), TW(t3)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
      }, i.prototype.remove = function(t3, c3) {
        this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
      }, i.type = "graph", i;
    }(yh), W2t = H2t;
    function j8(o) {
      return "_EC_" + o;
    }
    var U2t = function() {
      function o(i) {
        this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = i || false;
      }
      return o.prototype.isDirected = function() {
        return this._directed;
      }, o.prototype.addNode = function(i, t3) {
        i = i == null ? "" + t3 : "" + i;
        var c3 = this._nodesMap;
        if (!c3[j8(i)]) {
          var p3 = new CL(i, t3);
          return p3.hostGraph = this, this.nodes.push(p3), c3[j8(i)] = p3, p3;
        }
      }, o.prototype.getNodeByIndex = function(i) {
        var t3 = this.data.getRawIndex(i);
        return this.nodes[t3];
      }, o.prototype.getNodeById = function(i) {
        return this._nodesMap[j8(i)];
      }, o.prototype.addEdge = function(i, t3, c3) {
        var p3 = this._nodesMap, g3 = this._edgesMap;
        if (ec(i) && (i = this.nodes[i]), ec(t3) && (t3 = this.nodes[t3]), i instanceof CL || (i = p3[j8(i)]), t3 instanceof CL || (t3 = p3[j8(t3)]), !(!i || !t3)) {
          var b3 = i.id + "-" + t3.id, w3 = new P8e(i, t3, c3);
          return w3.hostGraph = this, this._directed && (i.outEdges.push(w3), t3.inEdges.push(w3)), i.edges.push(w3), i !== t3 && t3.edges.push(w3), this.edges.push(w3), g3[b3] = w3, w3;
        }
      }, o.prototype.getEdgeByIndex = function(i) {
        var t3 = this.edgeData.getRawIndex(i);
        return this.edges[t3];
      }, o.prototype.getEdge = function(i, t3) {
        i instanceof CL && (i = i.id), t3 instanceof CL && (t3 = t3.id);
        var c3 = this._edgesMap;
        return this._directed ? c3[i + "-" + t3] : c3[i + "-" + t3] || c3[t3 + "-" + i];
      }, o.prototype.eachNode = function(i, t3) {
        for (var c3 = this.nodes, p3 = c3.length, g3 = 0; g3 < p3; g3++)
          c3[g3].dataIndex >= 0 && i.call(t3, c3[g3], g3);
      }, o.prototype.eachEdge = function(i, t3) {
        for (var c3 = this.edges, p3 = c3.length, g3 = 0; g3 < p3; g3++)
          c3[g3].dataIndex >= 0 && c3[g3].node1.dataIndex >= 0 && c3[g3].node2.dataIndex >= 0 && i.call(t3, c3[g3], g3);
      }, o.prototype.breadthFirstTraverse = function(i, t3, c3, p3) {
        if (t3 instanceof CL || (t3 = this._nodesMap[j8(t3)]), !!t3) {
          for (var g3 = c3 === "out" ? "outEdges" : c3 === "in" ? "inEdges" : "edges", b3 = 0; b3 < this.nodes.length; b3++)
            this.nodes[b3].__visited = false;
          if (!i.call(p3, t3, null))
            for (var w3 = [t3]; w3.length; )
              for (var M = w3.shift(), I = M[g3], b3 = 0; b3 < I.length; b3++) {
                var k3 = I[b3], L = k3.node1 === M ? k3.node2 : k3.node1;
                if (!L.__visited) {
                  if (i.call(p3, L, M))
                    return;
                  w3.push(L), L.__visited = true;
                }
              }
        }
      }, o.prototype.update = function() {
        for (var i = this.data, t3 = this.edgeData, c3 = this.nodes, p3 = this.edges, g3 = 0, b3 = c3.length; g3 < b3; g3++)
          c3[g3].dataIndex = -1;
        for (var g3 = 0, b3 = i.count(); g3 < b3; g3++)
          c3[i.getRawIndex(g3)].dataIndex = g3;
        t3.filterSelf(function(w3) {
          var M = p3[t3.getRawIndex(w3)];
          return M.node1.dataIndex >= 0 && M.node2.dataIndex >= 0;
        });
        for (var g3 = 0, b3 = p3.length; g3 < b3; g3++)
          p3[g3].dataIndex = -1;
        for (var g3 = 0, b3 = t3.count(); g3 < b3; g3++)
          p3[t3.getRawIndex(g3)].dataIndex = g3;
      }, o.prototype.clone = function() {
        for (var i = new o(this._directed), t3 = this.nodes, c3 = this.edges, p3 = 0; p3 < t3.length; p3++)
          i.addNode(t3[p3].id, t3[p3].dataIndex);
        for (var p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          i.addEdge(g3.node1.id, g3.node2.id, g3.dataIndex);
        }
        return i;
      }, o;
    }(), CL = function() {
      function o(i, t3) {
        this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = i == null ? "" : i, this.dataIndex = t3 == null ? -1 : t3;
      }
      return o.prototype.degree = function() {
        return this.edges.length;
      }, o.prototype.inDegree = function() {
        return this.inEdges.length;
      }, o.prototype.outDegree = function() {
        return this.outEdges.length;
      }, o.prototype.getModel = function(i) {
        if (!(this.dataIndex < 0)) {
          var t3 = this.hostGraph, c3 = t3.data.getItemModel(this.dataIndex);
          return c3.getModel(i);
        }
      }, o.prototype.getAdjacentDataIndices = function() {
        for (var i = { edge: [], node: [] }, t3 = 0; t3 < this.edges.length; t3++) {
          var c3 = this.edges[t3];
          c3.dataIndex < 0 || (i.edge.push(c3.dataIndex), i.node.push(c3.node1.dataIndex, c3.node2.dataIndex));
        }
        return i;
      }, o;
    }(), P8e = function() {
      function o(i, t3, c3) {
        this.dataIndex = -1, this.node1 = i, this.node2 = t3, this.dataIndex = c3 == null ? -1 : c3;
      }
      return o.prototype.getModel = function(i) {
        if (!(this.dataIndex < 0)) {
          var t3 = this.hostGraph, c3 = t3.edgeData.getItemModel(this.dataIndex);
          return c3.getModel(i);
        }
      }, o.prototype.getAdjacentDataIndices = function() {
        return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
      }, o;
    }();
    function L8e(o, i) {
      return { getValue: function(t3) {
        var c3 = this[o][i];
        return c3.getStore().get(c3.getDimensionIndex(t3 || "value"), this.dataIndex);
      }, setVisual: function(t3, c3) {
        this.dataIndex >= 0 && this[o][i].setItemVisual(this.dataIndex, t3, c3);
      }, getVisual: function(t3) {
        return this[o][i].getItemVisual(this.dataIndex, t3);
      }, setLayout: function(t3, c3) {
        this.dataIndex >= 0 && this[o][i].setItemLayout(this.dataIndex, t3, c3);
      }, getLayout: function() {
        return this[o][i].getItemLayout(this.dataIndex);
      }, getGraphicEl: function() {
        return this[o][i].getItemGraphicEl(this.dataIndex);
      }, getRawIndex: function() {
        return this[o][i].getRawIndex(this.dataIndex);
      } };
    }
    Kp(CL, L8e("hostGraph", "data")), Kp(P8e, L8e("hostGraph", "edgeData"));
    var q2t = U2t;
    function R8e(o, i, t3, c3, p3) {
      for (var g3 = new q2t(c3), b3 = 0; b3 < o.length; b3++)
        g3.addNode(lv(o[b3].id, o[b3].name, b3), b3);
      for (var w3 = [], M = [], I = 0, b3 = 0; b3 < i.length; b3++) {
        var k3 = i[b3], L = k3.source, F = k3.target;
        g3.addEdge(L, F, I) && (M.push(k3), w3.push(lv(Jf(k3.id, null), L + " > " + F)), I++);
      }
      var B = t3.get("coordinateSystem"), G;
      if (B === "cartesian2d" || B === "polar")
        G = NI(o, t3);
      else {
        var J = DH.get(B), Q = J ? J.dimensions || [] : [];
        rl(Q, "value") < 0 && Q.concat(["value"]);
        var se = ZH(o, { coordDimensions: Q, encodeDefine: t3.getEncode() }).dimensions;
        G = new V1(se, t3), G.initData(o);
      }
      var he = new V1(["value"], t3);
      return he.initData(M, w3), p3 && p3(G, he), YFe({ mainData: G, struct: g3, structAttr: "graph", datas: { node: G, edge: he }, datasAttr: { node: "data", edge: "edgeData" } }), g3.update(), g3;
    }
    var $2t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.hasSymbolVisual = true, t3;
      }
      return i.prototype.init = function(t3) {
        o.prototype.init.apply(this, arguments);
        var c3 = this;
        function p3() {
          return c3._categoriesData;
        }
        this.legendVisualProvider = new fW(p3, p3), this.fillDataTextStyle(t3.edges || t3.links), this._updateCategoriesData();
      }, i.prototype.mergeOption = function(t3) {
        o.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(t3.edges || t3.links), this._updateCategoriesData();
      }, i.prototype.mergeDefaultAndTheme = function(t3) {
        o.prototype.mergeDefaultAndTheme.apply(this, arguments), O1(t3, "edgeLabel", ["show"]);
      }, i.prototype.getInitialData = function(t3, c3) {
        var p3 = t3.edges || t3.links || [], g3 = t3.data || t3.nodes || [], b3 = this;
        if (g3 && p3) {
          I2t(this);
          var w3 = R8e(g3, p3, this, true, M);
          return yt(w3.edges, function(I) {
            E2t(I.node1, I.node2, this, I.dataIndex);
          }, this), w3.data;
        }
        function M(I, k3) {
          I.wrapMethod("getItemModel", function(G) {
            var J = b3._categoriesModels, Q = G.getShallow("category"), se = J[Q];
            return se && (se.parentModel = G.parentModel, G.parentModel = se), G;
          });
          var L = gh.prototype.getModel;
          function F(G, J) {
            var Q = L.call(this, G, J);
            return Q.resolveParentPath = B, Q;
          }
          k3.wrapMethod("getItemModel", function(G) {
            return G.resolveParentPath = B, G.getModel = F, G;
          });
          function B(G) {
            if (G && (G[0] === "label" || G[1] === "label")) {
              var J = G.slice();
              return G[0] === "label" ? J[0] = "edgeLabel" : G[1] === "label" && (J[1] = "edgeLabel"), J;
            }
            return G;
          }
        }
      }, i.prototype.getGraph = function() {
        return this.getData().graph;
      }, i.prototype.getEdgeData = function() {
        return this.getGraph().edgeData;
      }, i.prototype.getCategoriesData = function() {
        return this._categoriesData;
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        if (p3 === "edge") {
          var g3 = this.getData(), b3 = this.getDataParams(t3, p3), w3 = g3.graph.getEdgeByIndex(t3), M = g3.getName(w3.node1.dataIndex), I = g3.getName(w3.node2.dataIndex), k3 = [];
          return M != null && k3.push(M), I != null && k3.push(I), Cg("nameValue", { name: k3.join(" > "), value: b3.value, noValue: b3.value == null });
        }
        var L = wRe({ series: this, dataIndex: t3, multipleSeries: c3 });
        return L;
      }, i.prototype._updateCategoriesData = function() {
        var t3 = Fi(this.option.categories || [], function(p3) {
          return p3.value != null ? p3 : ti({ value: 0 }, p3);
        }), c3 = new V1(["value"], this);
        c3.initData(t3), this._categoriesData = c3, this._categoriesModels = c3.mapArray(function(p3) {
          return c3.getItemModel(p3);
        });
      }, i.prototype.setZoom = function(t3) {
        this.option.zoom = t3;
      }, i.prototype.setCenter = function(t3) {
        this.option.center = t3;
      }, i.prototype.isAnimationEnabled = function() {
        return o.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
      }, i.type = "series.graph", i.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], i.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, i;
    }(bp), X2t = $2t, Y2t = { type: "graphRoam", event: "graphRoam", update: "none" };
    function K2t(o) {
      o.registerChartView(W2t), o.registerSeriesModel(X2t), o.registerProcessor(S2t), o.registerVisual(C2t), o.registerVisual(M2t), o.registerLayout(D2t), o.registerLayout(o.PRIORITY.VISUAL.POST_CHART_LAYOUT, O2t), o.registerLayout(L2t), o.registerCoordinateSystem("graphView", { dimensions: gW.dimensions, create: N2t }), o.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, uf), o.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, uf), o.registerAction(Y2t, function(i, t3) {
        t3.eachComponent({ mainType: "series", query: i }, function(c3) {
          var p3 = c3.coordinateSystem, g3 = iye(p3, i);
          c3.setCenter && c3.setCenter(g3.center), c3.setZoom && c3.setZoom(g3.zoom);
        });
      });
    }
    var Z2t = function() {
      function o() {
        this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
      }
      return o;
    }(), J2t = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "pointer", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new Z2t();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = Math.cos, g3 = Math.sin, b3 = c3.r, w3 = c3.width, M = c3.angle, I = c3.x - p3(M) * w3 * (w3 >= b3 / 3 ? 1 : 2), k3 = c3.y - g3(M) * w3 * (w3 >= b3 / 3 ? 1 : 2);
        M = c3.angle - Math.PI / 2, t3.moveTo(I, k3), t3.lineTo(c3.x + p3(M) * w3, c3.y + g3(M) * w3), t3.lineTo(c3.x + p3(c3.angle) * b3, c3.y + g3(c3.angle) * b3), t3.lineTo(c3.x - p3(M) * w3, c3.y - g3(M) * w3), t3.lineTo(I, k3);
      }, i;
    }(gl), Q2t = J2t;
    function eCt(o, i) {
      var t3 = o.get("center"), c3 = i.getWidth(), p3 = i.getHeight(), g3 = Math.min(c3, p3), b3 = Da(t3[0], i.getWidth()), w3 = Da(t3[1], i.getHeight()), M = Da(o.get("radius"), g3 / 2);
      return { cx: b3, cy: w3, r: M };
    }
    function Cne(o, i) {
      var t3 = o == null ? "" : o + "";
      return i && (Ha(i) ? t3 = i.replace("{value}", t3) : Vo(i) && (t3 = i(o))), t3;
    }
    var Nye = Math.PI * 2, tCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        this.group.removeAll();
        var g3 = t3.get(["axisLine", "lineStyle", "color"]), b3 = eCt(t3, p3);
        this._renderMain(t3, c3, p3, g3, b3), this._data = t3.getData();
      }, i.prototype.dispose = function() {
      }, i.prototype._renderMain = function(t3, c3, p3, g3, b3) {
        for (var w3 = this.group, M = t3.get("clockwise"), I = -t3.get("startAngle") / 180 * Math.PI, k3 = -t3.get("endAngle") / 180 * Math.PI, L = t3.getModel("axisLine"), F = L.get("roundCap"), B = F ? ine : bm, G = L.get("show"), J = L.getModel("lineStyle"), Q = J.get("width"), se = !((k3 - I) % Nye) && k3 !== I ? Nye : (k3 - I) % Nye, he = I, be = 0; G && be < g3.length; be++) {
          var de = Math.min(Math.max(g3[be][0], 0), 1);
          k3 = I + se * de;
          var Fe = new B({ shape: { startAngle: he, endAngle: k3, cx: b3.cx, cy: b3.cy, clockwise: M, r0: b3.r - Q, r: b3.r }, silent: true });
          Fe.setStyle({ fill: g3[be][1] }), Fe.setStyle(J.getLineStyle(["color", "width"])), w3.add(Fe), he = k3;
        }
        var Pe = function($e) {
          if ($e <= 0)
            return g3[0][1];
          var Ke;
          for (Ke = 0; Ke < g3.length; Ke++)
            if (g3[Ke][0] >= $e && (Ke === 0 ? 0 : g3[Ke - 1][0]) < $e)
              return g3[Ke][1];
          return g3[Ke - 1][1];
        };
        if (!M) {
          var ze = I;
          I = k3, k3 = ze;
        }
        this._renderTicks(t3, c3, p3, Pe, b3, I, k3, M, Q), this._renderTitleAndDetail(t3, c3, p3, Pe, b3), this._renderAnchor(t3, b3), this._renderPointer(t3, c3, p3, Pe, b3, I, k3, M, Q);
      }, i.prototype._renderTicks = function(t3, c3, p3, g3, b3, w3, M, I, k3) {
        for (var L = this.group, F = b3.cx, B = b3.cy, G = b3.r, J = +t3.get("min"), Q = +t3.get("max"), se = t3.getModel("splitLine"), he = t3.getModel("axisTick"), be = t3.getModel("axisLabel"), de = t3.get("splitNumber"), Fe = he.get("splitNumber"), Pe = Da(se.get("length"), G), ze = Da(he.get("length"), G), $e = w3, Ke = (M - w3) / de, nt = Ke / Fe, lt2 = se.getModel("lineStyle").getLineStyle(), bt = he.getModel("lineStyle").getLineStyle(), vt = se.get("distance"), jt, Jt, Rt = 0; Rt <= de; Rt++) {
          if (jt = Math.cos($e), Jt = Math.sin($e), se.get("show")) {
            var Jn = vt ? vt + k3 : k3, ln = new Ud({ shape: { x1: jt * (G - Jn) + F, y1: Jt * (G - Jn) + B, x2: jt * (G - Pe - Jn) + F, y2: Jt * (G - Pe - Jn) + B }, style: lt2, silent: true });
            lt2.stroke === "auto" && ln.setStyle({ stroke: g3(Rt / de) }), L.add(ln);
          }
          if (be.get("show")) {
            var Jn = be.get("distance") + vt, vn = Cne(mp(Rt / de * (Q - J) + J), be.get("formatter")), kn = g3(Rt / de);
            L.add(new Fl({ style: qd(be, { text: vn, x: jt * (G - Pe - Jn) + F, y: Jt * (G - Pe - Jn) + B, verticalAlign: Jt < -0.8 ? "top" : Jt > 0.8 ? "bottom" : "middle", align: jt < -0.4 ? "left" : jt > 0.4 ? "right" : "center" }, { inheritColor: kn }), silent: true }));
          }
          if (he.get("show") && Rt !== de) {
            var Jn = he.get("distance");
            Jn = Jn ? Jn + k3 : k3;
            for (var cr = 0; cr <= Fe; cr++) {
              jt = Math.cos($e), Jt = Math.sin($e);
              var gr = new Ud({ shape: { x1: jt * (G - Jn) + F, y1: Jt * (G - Jn) + B, x2: jt * (G - ze - Jn) + F, y2: Jt * (G - ze - Jn) + B }, silent: true, style: bt });
              bt.stroke === "auto" && gr.setStyle({ stroke: g3((Rt + cr / Fe) / de) }), L.add(gr), $e += nt;
            }
            $e -= nt;
          } else
            $e += Ke;
        }
      }, i.prototype._renderPointer = function(t3, c3, p3, g3, b3, w3, M, I, k3) {
        var L = this.group, F = this._data, B = this._progressEls, G = [], J = t3.get(["pointer", "show"]), Q = t3.getModel("progress"), se = Q.get("show"), he = t3.getData(), be = he.mapDimension("value"), de = +t3.get("min"), Fe = +t3.get("max"), Pe = [de, Fe], ze = [w3, M];
        function $e(nt, lt2) {
          var bt = he.getItemModel(nt), vt = bt.getModel("pointer"), jt = Da(vt.get("width"), b3.r), Jt = Da(vt.get("length"), b3.r), Rt = t3.get(["pointer", "icon"]), Jn = vt.get("offsetCenter"), ln = Da(Jn[0], b3.r), vn = Da(Jn[1], b3.r), kn = vt.get("keepAspect"), cr;
          return Rt ? cr = pv(Rt, ln - jt / 2, vn - Jt, jt, Jt, null, kn) : cr = new Q2t({ shape: { angle: -Math.PI / 2, width: jt, r: Jt, x: ln, y: vn } }), cr.rotation = -(lt2 + Math.PI / 2), cr.x = b3.cx, cr.y = b3.cy, cr;
        }
        function Ke(nt, lt2) {
          var bt = Q.get("roundCap"), vt = bt ? ine : bm, jt = Q.get("overlap"), Jt = jt ? Q.get("width") : k3 / he.count(), Rt = jt ? b3.r - Jt : b3.r - (nt + 1) * Jt, Jn = jt ? b3.r : b3.r - nt * Jt, ln = new vt({ shape: { startAngle: w3, endAngle: lt2, cx: b3.cx, cy: b3.cy, clockwise: I, r0: Rt, r: Jn } });
          return jt && (ln.z2 = Fe - he.get(be, nt) % Fe), ln;
        }
        (se || J) && (he.diff(F).add(function(nt) {
          var lt2 = he.get(be, nt);
          if (J) {
            var bt = $e(nt, w3);
            Uh(bt, { rotation: -((isNaN(+lt2) ? ze[0] : Bc(lt2, Pe, ze, true)) + Math.PI / 2) }, t3), L.add(bt), he.setItemGraphicEl(nt, bt);
          }
          if (se) {
            var vt = Ke(nt, w3), jt = Q.get("clip");
            Uh(vt, { shape: { endAngle: Bc(lt2, Pe, ze, jt) } }, t3), L.add(vt), ZG(t3.seriesIndex, he.dataType, nt, vt), G[nt] = vt;
          }
        }).update(function(nt, lt2) {
          var bt = he.get(be, nt);
          if (J) {
            var vt = F.getItemGraphicEl(lt2), jt = vt ? vt.rotation : w3, Jt = $e(nt, jt);
            Jt.rotation = jt, Du(Jt, { rotation: -((isNaN(+bt) ? ze[0] : Bc(bt, Pe, ze, true)) + Math.PI / 2) }, t3), L.add(Jt), he.setItemGraphicEl(nt, Jt);
          }
          if (se) {
            var Rt = B[lt2], Jn = Rt ? Rt.shape.endAngle : w3, ln = Ke(nt, Jn), vn = Q.get("clip");
            Du(ln, { shape: { endAngle: Bc(bt, Pe, ze, vn) } }, t3), L.add(ln), ZG(t3.seriesIndex, he.dataType, nt, ln), G[nt] = ln;
          }
        }).execute(), he.each(function(nt) {
          var lt2 = he.getItemModel(nt), bt = lt2.getModel("emphasis"), vt = bt.get("focus"), jt = bt.get("blurScope"), Jt = bt.get("disabled");
          if (J) {
            var Rt = he.getItemGraphicEl(nt), Jn = he.getItemVisual(nt, "style"), ln = Jn.fill;
            if (Rt instanceof Gv) {
              var vn = Rt.style;
              Rt.useStyle(ti({ image: vn.image, x: vn.x, y: vn.y, width: vn.width, height: vn.height }, Jn));
            } else
              Rt.useStyle(Jn), Rt.type !== "pointer" && Rt.setColor(ln);
            Rt.setStyle(lt2.getModel(["pointer", "itemStyle"]).getItemStyle()), Rt.style.fill === "auto" && Rt.setStyle("fill", g3(Bc(he.get(be, nt), Pe, [0, 1], true))), Rt.z2EmphasisLift = 0, cv(Rt, lt2), zp(Rt, vt, jt, Jt);
          }
          if (se) {
            var kn = G[nt];
            kn.useStyle(he.getItemVisual(nt, "style")), kn.setStyle(lt2.getModel(["progress", "itemStyle"]).getItemStyle()), kn.z2EmphasisLift = 0, cv(kn, lt2), zp(kn, vt, jt, Jt);
          }
        }), this._progressEls = G);
      }, i.prototype._renderAnchor = function(t3, c3) {
        var p3 = t3.getModel("anchor"), g3 = p3.get("show");
        if (g3) {
          var b3 = p3.get("size"), w3 = p3.get("icon"), M = p3.get("offsetCenter"), I = p3.get("keepAspect"), k3 = pv(w3, c3.cx - b3 / 2 + Da(M[0], c3.r), c3.cy - b3 / 2 + Da(M[1], c3.r), b3, b3, null, I);
          k3.z2 = p3.get("showAbove") ? 1 : 0, k3.setStyle(p3.getModel("itemStyle").getItemStyle()), this.group.add(k3);
        }
      }, i.prototype._renderTitleAndDetail = function(t3, c3, p3, g3, b3) {
        var w3 = this, M = t3.getData(), I = M.mapDimension("value"), k3 = +t3.get("min"), L = +t3.get("max"), F = new vs(), B = [], G = [], J = t3.isAnimationEnabled(), Q = t3.get(["pointer", "showAbove"]);
        M.diff(this._data).add(function(se) {
          B[se] = new Fl({ silent: true }), G[se] = new Fl({ silent: true });
        }).update(function(se, he) {
          B[se] = w3._titleEls[he], G[se] = w3._detailEls[he];
        }).execute(), M.each(function(se) {
          var he = M.getItemModel(se), be = M.get(I, se), de = new vs(), Fe = g3(Bc(be, [k3, L], [0, 1], true)), Pe = he.getModel("title");
          if (Pe.get("show")) {
            var ze = Pe.get("offsetCenter"), $e = b3.cx + Da(ze[0], b3.r), Ke = b3.cy + Da(ze[1], b3.r), nt = B[se];
            nt.attr({ z2: Q ? 0 : 2, style: qd(Pe, { x: $e, y: Ke, text: M.getName(se), align: "center", verticalAlign: "middle" }, { inheritColor: Fe }) }), de.add(nt);
          }
          var lt2 = he.getModel("detail");
          if (lt2.get("show")) {
            var bt = lt2.get("offsetCenter"), vt = b3.cx + Da(bt[0], b3.r), jt = b3.cy + Da(bt[1], b3.r), Jt = Da(lt2.get("width"), b3.r), Rt = Da(lt2.get("height"), b3.r), Jn = t3.get(["progress", "show"]) ? M.getItemVisual(se, "style").fill : Fe, nt = G[se], ln = lt2.get("formatter");
            nt.attr({ z2: Q ? 0 : 2, style: qd(lt2, { x: vt, y: jt, text: Cne(be, ln), width: isNaN(Jt) ? null : Jt, height: isNaN(Rt) ? null : Rt, align: "center", verticalAlign: "middle" }, { inheritColor: Jn }) }), KPe(nt, { normal: lt2 }, be, function(kn) {
              return Cne(kn, ln);
            }), J && ZPe(nt, se, M, t3, { getFormattedLabel: function(kn, cr, gr, ha, Ka, Do) {
              return Cne(Do ? Do.interpolatedValue : be, ln);
            } }), de.add(nt);
          }
          F.add(de);
        }), this.group.add(F), this._titleEls = B, this._detailEls = G;
      }, i.type = "gauge", i;
    }(yh), nCt = tCt, rCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.visualStyleAccessPath = "itemStyle", t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        return N8(this, ["value"]);
      }, i.type = "series.gauge", i.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, i;
    }(bp), iCt = rCt;
    function aCt(o) {
      o.registerChartView(nCt), o.registerSeriesModel(iCt);
    }
    var oCt = ["itemStyle", "opacity"], sCt = function(o) {
      cn(i, o);
      function i(t3, c3) {
        var p3 = o.call(this) || this, g3 = p3, b3 = new xm(), w3 = new Fl();
        return g3.setTextContent(w3), p3.setTextGuideLine(b3), p3.updateData(t3, c3, true), p3;
      }
      return i.prototype.updateData = function(t3, c3, p3) {
        var g3 = this, b3 = t3.hostModel, w3 = t3.getItemModel(c3), M = t3.getItemLayout(c3), I = w3.getModel("emphasis"), k3 = w3.get(oCt);
        k3 = k3 == null ? 1 : k3, p3 || P_(g3), g3.useStyle(t3.getItemVisual(c3, "style")), g3.style.lineJoin = "round", p3 ? (g3.setShape({ points: M.points }), g3.style.opacity = 0, Uh(g3, { style: { opacity: k3 } }, b3, c3)) : Du(g3, { style: { opacity: k3 }, shape: { points: M.points } }, b3, c3), cv(g3, w3), this._updateLabel(t3, c3), zp(this, I.get("focus"), I.get("blurScope"), I.get("disabled"));
      }, i.prototype._updateLabel = function(t3, c3) {
        var p3 = this, g3 = this.getTextGuideLine(), b3 = p3.getTextContent(), w3 = t3.hostModel, M = t3.getItemModel(c3), I = t3.getItemLayout(c3), k3 = I.label, L = t3.getItemVisual(c3, "style"), F = L.fill;
        Sm(b3, g0(M), { labelFetcher: t3.hostModel, labelDataIndex: c3, defaultOpacity: L.opacity, defaultText: t3.getName(c3) }, { normal: { align: k3.textAlign, verticalAlign: k3.verticalAlign } }), p3.setTextConfig({ local: true, inside: !!k3.inside, insideStroke: F, outsideFill: F });
        var B = k3.linePoints;
        g3.setShape({ points: B }), p3.textGuideLineConfig = { anchor: B ? new Bs(B[0][0], B[0][1]) : null }, Du(b3, { style: { x: k3.x, y: k3.y } }, w3, c3), b3.attr({ rotation: k3.rotation, originX: k3.x, originY: k3.y, z2: 10 }), b0e(p3, _0e(M), { stroke: F });
      }, i;
    }(_m), lCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.ignoreLabelLineUpdate = true, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this._data, w3 = this.group;
        g3.diff(b3).add(function(M) {
          var I = new sCt(g3, M);
          g3.setItemGraphicEl(M, I), w3.add(I);
        }).update(function(M, I) {
          var k3 = b3.getItemGraphicEl(I);
          k3.updateData(g3, M), w3.add(k3), g3.setItemGraphicEl(M, k3);
        }).remove(function(M) {
          var I = b3.getItemGraphicEl(M);
          QP(I, t3, M);
        }).execute(), this._data = g3;
      }, i.prototype.remove = function() {
        this.group.removeAll(), this._data = null;
      }, i.prototype.dispose = function() {
      }, i.type = "funnel", i;
    }(yh), uCt = lCt, cCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3) {
        o.prototype.init.apply(this, arguments), this.legendVisualProvider = new fW(Qa(this.getData, this), Qa(this.getRawData, this)), this._defaultLabelLine(t3);
      }, i.prototype.getInitialData = function(t3, c3) {
        return N8(this, { coordDimensions: ["value"], encodeDefaulter: As(pge, this) });
      }, i.prototype._defaultLabelLine = function(t3) {
        O1(t3, "labelLine", ["show"]);
        var c3 = t3.labelLine, p3 = t3.emphasis.labelLine;
        c3.show = c3.show && t3.label.show, p3.show = p3.show && t3.emphasis.label.show;
      }, i.prototype.getDataParams = function(t3) {
        var c3 = this.getData(), p3 = o.prototype.getDataParams.call(this, t3), g3 = c3.mapDimension("value"), b3 = c3.getSum(g3);
        return p3.percent = b3 ? +(c3.get(g3, t3) / b3 * 100).toFixed(2) : 0, p3.$vars.push("percent"), p3;
      }, i.type = "series.funnel", i.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, i;
    }(bp), fCt = cCt;
    function hCt(o, i) {
      return Wv(o.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
    }
    function pCt(o, i) {
      for (var t3 = o.mapDimension("value"), c3 = o.mapArray(t3, function(M) {
        return M;
      }), p3 = [], g3 = i === "ascending", b3 = 0, w3 = o.count(); b3 < w3; b3++)
        p3[b3] = b3;
      return Vo(i) ? p3.sort(i) : i !== "none" && p3.sort(function(M, I) {
        return g3 ? c3[M] - c3[I] : c3[I] - c3[M];
      }), p3;
    }
    function dCt(o) {
      var i = o.hostModel, t3 = i.get("orient");
      o.each(function(c3) {
        var p3 = o.getItemModel(c3), g3 = p3.getModel("label"), b3 = g3.get("position"), w3 = p3.getModel("labelLine"), M = o.getItemLayout(c3), I = M.points, k3 = b3 === "inner" || b3 === "inside" || b3 === "center" || b3 === "insideLeft" || b3 === "insideRight", L, F, B, G;
        if (k3)
          b3 === "insideLeft" ? (F = (I[0][0] + I[3][0]) / 2 + 5, B = (I[0][1] + I[3][1]) / 2, L = "left") : b3 === "insideRight" ? (F = (I[1][0] + I[2][0]) / 2 - 5, B = (I[1][1] + I[2][1]) / 2, L = "right") : (F = (I[0][0] + I[1][0] + I[2][0] + I[3][0]) / 4, B = (I[0][1] + I[1][1] + I[2][1] + I[3][1]) / 4, L = "center"), G = [[F, B], [F, B]];
        else {
          var J = void 0, Q = void 0, se = void 0, he = void 0, be = w3.get("length");
          b3 === "left" ? (J = (I[3][0] + I[0][0]) / 2, Q = (I[3][1] + I[0][1]) / 2, se = J - be, F = se - 5, L = "right") : b3 === "right" ? (J = (I[1][0] + I[2][0]) / 2, Q = (I[1][1] + I[2][1]) / 2, se = J + be, F = se + 5, L = "left") : b3 === "top" ? (J = (I[3][0] + I[0][0]) / 2, Q = (I[3][1] + I[0][1]) / 2, he = Q - be, B = he - 5, L = "center") : b3 === "bottom" ? (J = (I[1][0] + I[2][0]) / 2, Q = (I[1][1] + I[2][1]) / 2, he = Q + be, B = he + 5, L = "center") : b3 === "rightTop" ? (J = t3 === "horizontal" ? I[3][0] : I[1][0], Q = t3 === "horizontal" ? I[3][1] : I[1][1], t3 === "horizontal" ? (he = Q - be, B = he - 5, L = "center") : (se = J + be, F = se + 5, L = "top")) : b3 === "rightBottom" ? (J = I[2][0], Q = I[2][1], t3 === "horizontal" ? (he = Q + be, B = he + 5, L = "center") : (se = J + be, F = se + 5, L = "bottom")) : b3 === "leftTop" ? (J = I[0][0], Q = t3 === "horizontal" ? I[0][1] : I[1][1], t3 === "horizontal" ? (he = Q - be, B = he - 5, L = "center") : (se = J - be, F = se - 5, L = "right")) : b3 === "leftBottom" ? (J = t3 === "horizontal" ? I[1][0] : I[3][0], Q = t3 === "horizontal" ? I[1][1] : I[2][1], t3 === "horizontal" ? (he = Q + be, B = he + 5, L = "center") : (se = J - be, F = se - 5, L = "right")) : (J = (I[1][0] + I[2][0]) / 2, Q = (I[1][1] + I[2][1]) / 2, t3 === "horizontal" ? (he = Q + be, B = he + 5, L = "center") : (se = J + be, F = se + 5, L = "left")), t3 === "horizontal" ? (se = J, F = se) : (he = Q, B = he), G = [[J, Q], [se, he]];
        }
        M.label = { linePoints: G, x: F, y: B, verticalAlign: "middle", textAlign: L, inside: k3 };
      });
    }
    function vCt(o, i) {
      o.eachSeriesByType("funnel", function(t3) {
        var c3 = t3.getData(), p3 = c3.mapDimension("value"), g3 = t3.get("sort"), b3 = hCt(t3, i), w3 = t3.get("orient"), M = b3.width, I = b3.height, k3 = pCt(c3, g3), L = b3.x, F = b3.y, B = w3 === "horizontal" ? [Da(t3.get("minSize"), I), Da(t3.get("maxSize"), I)] : [Da(t3.get("minSize"), M), Da(t3.get("maxSize"), M)], G = c3.getDataExtent(p3), J = t3.get("min"), Q = t3.get("max");
        J == null && (J = Math.min(G[0], 0)), Q == null && (Q = G[1]);
        var se = t3.get("funnelAlign"), he = t3.get("gap"), be = w3 === "horizontal" ? M : I, de = (be - he * (c3.count() - 1)) / c3.count(), Fe = function(jt, Jt) {
          if (w3 === "horizontal") {
            var Rt = c3.get(p3, jt) || 0, Jn = Bc(Rt, [J, Q], B, true), ln = void 0;
            switch (se) {
              case "top":
                ln = F;
                break;
              case "center":
                ln = F + (I - Jn) / 2;
                break;
              case "bottom":
                ln = F + (I - Jn);
                break;
            }
            return [[Jt, ln], [Jt, ln + Jn]];
          }
          var vn = c3.get(p3, jt) || 0, kn = Bc(vn, [J, Q], B, true), cr;
          switch (se) {
            case "left":
              cr = L;
              break;
            case "center":
              cr = L + (M - kn) / 2;
              break;
            case "right":
              cr = L + M - kn;
              break;
          }
          return [[cr, Jt], [cr + kn, Jt]];
        };
        g3 === "ascending" && (de = -de, he = -he, w3 === "horizontal" ? L += M : F += I, k3 = k3.reverse());
        for (var Pe = 0; Pe < k3.length; Pe++) {
          var ze = k3[Pe], $e = k3[Pe + 1], Ke = c3.getItemModel(ze);
          if (w3 === "horizontal") {
            var nt = Ke.get(["itemStyle", "width"]);
            nt == null ? nt = de : (nt = Da(nt, M), g3 === "ascending" && (nt = -nt));
            var lt2 = Fe(ze, L), bt = Fe($e, L + nt);
            L += nt + he, c3.setItemLayout(ze, { points: lt2.concat(bt.slice().reverse()) });
          } else {
            var vt = Ke.get(["itemStyle", "height"]);
            vt == null ? vt = de : (vt = Da(vt, I), g3 === "ascending" && (vt = -vt));
            var lt2 = Fe(ze, F), bt = Fe($e, F + vt);
            F += vt + he, c3.setItemLayout(ze, { points: lt2.concat(bt.slice().reverse()) });
          }
        }
        dCt(c3);
      });
    }
    function gCt(o) {
      o.registerChartView(uCt), o.registerSeriesModel(fCt), o.registerLayout(vCt), o.registerProcessor(cW("funnel"));
    }
    var yCt = 0.3, mCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._dataGroup = new vs(), t3._initialized = false, t3;
      }
      return i.prototype.init = function() {
        this.group.add(this._dataGroup);
      }, i.prototype.render = function(t3, c3, p3, g3) {
        this._progressiveEls = null;
        var b3 = this._dataGroup, w3 = t3.getData(), M = this._data, I = t3.coordinateSystem, k3 = I.dimensions, L = V8e(t3);
        w3.diff(M).add(F).update(B).remove(G).execute();
        function F(Q) {
          var se = F8e(w3, b3, Q, k3, I);
          Fye(se, w3, Q, L);
        }
        function B(Q, se) {
          var he = M.getItemGraphicEl(se), be = N8e(w3, Q, k3, I);
          w3.setItemGraphicEl(Q, he), Du(he, { shape: { points: be } }, t3, Q), P_(he), Fye(he, w3, Q, L);
        }
        function G(Q) {
          var se = M.getItemGraphicEl(Q);
          b3.remove(se);
        }
        if (!this._initialized) {
          this._initialized = true;
          var J = bCt(I, t3, function() {
            setTimeout(function() {
              b3.removeClipPath();
            });
          });
          b3.setClipPath(J);
        }
        this._data = w3;
      }, i.prototype.incrementalPrepareRender = function(t3, c3, p3) {
        this._initialized = true, this._data = null, this._dataGroup.removeAll();
      }, i.prototype.incrementalRender = function(t3, c3, p3) {
        for (var g3 = c3.getData(), b3 = c3.coordinateSystem, w3 = b3.dimensions, M = V8e(c3), I = this._progressiveEls = [], k3 = t3.start; k3 < t3.end; k3++) {
          var L = F8e(g3, this._dataGroup, k3, w3, b3);
          L.incremental = true, Fye(L, g3, k3, M), I.push(L);
        }
      }, i.prototype.remove = function() {
        this._dataGroup && this._dataGroup.removeAll(), this._data = null;
      }, i.type = "parallel", i;
    }(yh);
    function bCt(o, i, t3) {
      var c3 = o.model, p3 = o.getRect(), g3 = new bu({ shape: { x: p3.x, y: p3.y, width: p3.width, height: p3.height } }), b3 = c3.get("layout") === "horizontal" ? "width" : "height";
      return g3.setShape(b3, 0), Uh(g3, { shape: { width: p3.width, height: p3.height } }, i, t3), g3;
    }
    function N8e(o, i, t3, c3) {
      for (var p3 = [], g3 = 0; g3 < t3.length; g3++) {
        var b3 = t3[g3], w3 = o.get(o.mapDimension(b3), i);
        _Ct(w3, c3.getAxis(b3).type) || p3.push(c3.dataToPoint(w3, b3));
      }
      return p3;
    }
    function F8e(o, i, t3, c3, p3) {
      var g3 = N8e(o, t3, c3, p3), b3 = new xm({ shape: { points: g3 }, z2: 10 });
      return i.add(b3), o.setItemGraphicEl(t3, b3), b3;
    }
    function V8e(o) {
      var i = o.get("smooth", true);
      return i === true && (i = yCt), i = G2(i), pP(i) && (i = 0), { smooth: i };
    }
    function Fye(o, i, t3, c3) {
      o.useStyle(i.getItemVisual(t3, "style")), o.style.fill = null, o.setShape("smooth", c3.smooth);
      var p3 = i.getItemModel(t3), g3 = p3.getModel("emphasis");
      cv(o, p3, "lineStyle"), zp(o, g3.get("focus"), g3.get("blurScope"), g3.get("disabled"));
    }
    function _Ct(o, i) {
      return i === "category" ? o == null : o == null || isNaN(o);
    }
    var xCt = mCt, wCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.visualStyleAccessPath = "lineStyle", t3.visualDrawType = "stroke", t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        return NI(null, this, { useEncodeDefaulter: Qa(SCt, null, this) });
      }, i.prototype.getRawIndicesByActiveState = function(t3) {
        var c3 = this.coordinateSystem, p3 = this.getData(), g3 = [];
        return c3.eachActiveState(p3, function(b3, w3) {
          t3 === b3 && g3.push(p3.getRawIndex(w3));
        }), g3;
      }, i.type = "series.parallel", i.dependencies = ["parallel"], i.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, i;
    }(bp);
    function SCt(o) {
      var i = o.ecModel.getComponent("parallel", o.get("parallelIndex"));
      if (i) {
        var t3 = {};
        return yt(i.dimensions, function(c3) {
          var p3 = CCt(c3);
          t3[c3] = p3;
        }), t3;
      }
    }
    function CCt(o) {
      return +o.replace("dim", "");
    }
    var MCt = wCt, TCt = ["lineStyle", "opacity"], ACt = { seriesType: "parallel", reset: function(o, i) {
      var t3 = o.coordinateSystem, c3 = { normal: o.get(["lineStyle", "opacity"]), active: o.get("activeOpacity"), inactive: o.get("inactiveOpacity") };
      return { progress: function(p3, g3) {
        t3.eachActiveState(g3, function(b3, w3) {
          var M = c3[b3];
          if (b3 === "normal" && g3.hasItemOption) {
            var I = g3.getItemModel(w3).get(TCt, true);
            I != null && (M = I);
          }
          var k3 = g3.ensureUniqueItemVisual(w3, "style");
          k3.opacity = M;
        }, p3.start, p3.end);
      } };
    } }, ICt = ACt;
    function ECt(o) {
      DCt(o), kCt(o);
    }
    function DCt(o) {
      if (!o.parallel) {
        var i = false;
        yt(o.series, function(t3) {
          t3 && t3.type === "parallel" && (i = true);
        }), i && (o.parallel = [{}]);
      }
    }
    function kCt(o) {
      var i = Wc(o.parallelAxis);
      yt(i, function(t3) {
        if (Ua(t3)) {
          var c3 = t3.parallelIndex || 0, p3 = Wc(o.parallel)[c3];
          p3 && p3.parallelAxisDefault && Es(t3, p3.parallelAxisDefault, false);
        }
      });
    }
    var OCt = 5, PCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        this._model = t3, this._api = p3, this._handlers || (this._handlers = {}, yt(LCt, function(g3, b3) {
          p3.getZr().on(b3, this._handlers[b3] = Qa(g3, this));
        }, this)), M8(this, "_throttledDispatchExpand", t3.get("axisExpandRate"), "fixRate");
      }, i.prototype.dispose = function(t3, c3) {
        NH(this, "_throttledDispatchExpand"), yt(this._handlers, function(p3, g3) {
          c3.getZr().off(g3, p3);
        }), this._handlers = null;
      }, i.prototype._throttledDispatchExpand = function(t3) {
        this._dispatchExpand(t3);
      }, i.prototype._dispatchExpand = function(t3) {
        t3 && this._api.dispatchAction(ti({ type: "parallelAxisExpand" }, t3));
      }, i.type = "parallel", i;
    }(ed), LCt = { mousedown: function(o) {
      Vye(this, "click") && (this._mouseDownPoint = [o.offsetX, o.offsetY]);
    }, mouseup: function(o) {
      var i = this._mouseDownPoint;
      if (Vye(this, "click") && i) {
        var t3 = [o.offsetX, o.offsetY], c3 = Math.pow(i[0] - t3[0], 2) + Math.pow(i[1] - t3[1], 2);
        if (c3 > OCt)
          return;
        var p3 = this._model.coordinateSystem.getSlidedAxisExpandWindow([o.offsetX, o.offsetY]);
        p3.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: p3.axisExpandWindow });
      }
      this._mouseDownPoint = null;
    }, mousemove: function(o) {
      if (!(this._mouseDownPoint || !Vye(this, "mousemove"))) {
        var i = this._model, t3 = i.coordinateSystem.getSlidedAxisExpandWindow([o.offsetX, o.offsetY]), c3 = t3.behavior;
        c3 === "jump" && this._throttledDispatchExpand.debounceNextCall(i.get("axisExpandDebounce")), this._throttledDispatchExpand(c3 === "none" ? null : { axisExpandWindow: t3.axisExpandWindow, animation: c3 === "jump" ? null : { duration: 0 } });
      }
    } };
    function Vye(o, i) {
      var t3 = o._model;
      return t3.get("axisExpandable") && t3.get("axisExpandTriggerOn") === i;
    }
    var RCt = PCt, NCt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function() {
        o.prototype.init.apply(this, arguments), this.mergeOption({});
      }, i.prototype.mergeOption = function(t3) {
        var c3 = this.option;
        t3 && Es(c3, t3, true), this._initDimensions();
      }, i.prototype.contains = function(t3, c3) {
        var p3 = t3.get("parallelIndex");
        return p3 != null && c3.getComponent("parallel", p3) === this;
      }, i.prototype.setAxisExpand = function(t3) {
        yt(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(c3) {
          t3.hasOwnProperty(c3) && (this.option[c3] = t3[c3]);
        }, this);
      }, i.prototype._initDimensions = function() {
        var t3 = this.dimensions = [], c3 = this.parallelAxisIndex = [], p3 = Zc(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(g3) {
          return (g3.get("parallelIndex") || 0) === this.componentIndex;
        }, this);
        yt(p3, function(g3) {
          t3.push("dim" + g3.get("dim")), c3.push(g3.componentIndex);
        });
      }, i.type = "parallel", i.dependencies = ["parallelAxis"], i.layoutMode = "box", i.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, i;
    }(nc), FCt = NCt, VCt = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3, b3) {
        var w3 = o.call(this, t3, c3, p3) || this;
        return w3.type = g3 || "value", w3.axisIndex = b3, w3;
      }
      return i.prototype.isHorizontal = function() {
        return this.coordinateSystem.getModel().get("layout") !== "horizontal";
      }, i;
    }(Y2), BCt = VCt;
    function ML(o, i, t3, c3, p3, g3) {
      o = o || 0;
      var b3 = t3[1] - t3[0];
      if (p3 != null && (p3 = G8(p3, [0, b3])), g3 != null && (g3 = Math.max(g3, p3 != null ? p3 : 0)), c3 === "all") {
        var w3 = Math.abs(i[1] - i[0]);
        w3 = G8(w3, [0, b3]), p3 = g3 = G8(w3, [p3, g3]), c3 = 0;
      }
      i[0] = G8(i[0], t3), i[1] = G8(i[1], t3);
      var M = Bye(i, c3);
      i[c3] += o;
      var I = p3 || 0, k3 = t3.slice();
      M.sign < 0 ? k3[0] += I : k3[1] -= I, i[c3] = G8(i[c3], k3);
      var L;
      return L = Bye(i, c3), p3 != null && (L.sign !== M.sign || L.span < p3) && (i[1 - c3] = i[c3] + M.sign * p3), L = Bye(i, c3), g3 != null && L.span > g3 && (i[1 - c3] = i[c3] + L.sign * g3), i;
    }
    function Bye(o, i) {
      var t3 = o[i] - o[1 - i];
      return { span: Math.abs(t3), sign: t3 > 0 ? -1 : t3 < 0 ? 1 : i ? -1 : 1 };
    }
    function G8(o, i) {
      return Math.min(i[1] != null ? i[1] : 1 / 0, Math.max(i[0] != null ? i[0] : -1 / 0, o));
    }
    var zye = yt, B8e = Math.min, z8e = Math.max, j8e = Math.floor, zCt = Math.ceil, G8e = mp, jCt = Math.PI, GCt = function() {
      function o(i, t3, c3) {
        this.type = "parallel", this._axesMap = Eo(), this._axesLayout = {}, this.dimensions = i.dimensions, this._model = i, this._init(i, t3, c3);
      }
      return o.prototype._init = function(i, t3, c3) {
        var p3 = i.dimensions, g3 = i.parallelAxisIndex;
        zye(p3, function(b3, w3) {
          var M = g3[w3], I = t3.getComponent("parallelAxis", M), k3 = this._axesMap.set(b3, new BCt(b3, $te(I), [0, 0], I.get("type"), M)), L = k3.type === "category";
          k3.onBand = L && I.get("boundaryGap"), k3.inverse = I.get("inverse"), I.axis = k3, k3.model = I, k3.coordinateSystem = I.coordinateSystem = this;
        }, this);
      }, o.prototype.update = function(i, t3) {
        this._updateAxesFromSeries(this._model, i);
      }, o.prototype.containPoint = function(i) {
        var t3 = this._makeLayoutInfo(), c3 = t3.axisBase, p3 = t3.layoutBase, g3 = t3.pixelDimIndex, b3 = i[1 - g3], w3 = i[g3];
        return b3 >= c3 && b3 <= c3 + t3.axisLength && w3 >= p3 && w3 <= p3 + t3.layoutLength;
      }, o.prototype.getModel = function() {
        return this._model;
      }, o.prototype._updateAxesFromSeries = function(i, t3) {
        t3.eachSeries(function(c3) {
          if (i.contains(c3, t3)) {
            var p3 = c3.getData();
            zye(this.dimensions, function(g3) {
              var b3 = this._axesMap.get(g3);
              b3.scale.unionExtentFromData(p3, p3.mapDimension(g3)), O8(b3.scale, b3.model);
            }, this);
          }
        }, this);
      }, o.prototype.resize = function(i, t3) {
        this._rect = Wv(i.getBoxLayoutParams(), { width: t3.getWidth(), height: t3.getHeight() }), this._layoutAxes();
      }, o.prototype.getRect = function() {
        return this._rect;
      }, o.prototype._makeLayoutInfo = function() {
        var i = this._model, t3 = this._rect, c3 = ["x", "y"], p3 = ["width", "height"], g3 = i.get("layout"), b3 = g3 === "horizontal" ? 0 : 1, w3 = t3[p3[b3]], M = [0, w3], I = this.dimensions.length, k3 = Mne(i.get("axisExpandWidth"), M), L = Mne(i.get("axisExpandCount") || 0, [0, I]), F = i.get("axisExpandable") && I > 3 && I > L && L > 1 && k3 > 0 && w3 > 0, B = i.get("axisExpandWindow"), G;
        if (B)
          G = Mne(B[1] - B[0], M), B[1] = B[0] + G;
        else {
          G = Mne(k3 * (L - 1), M);
          var J = i.get("axisExpandCenter") || j8e(I / 2);
          B = [k3 * J - G / 2], B[1] = B[0] + G;
        }
        var Q = (w3 - G) / (I - L);
        Q < 3 && (Q = 0);
        var se = [j8e(G8e(B[0] / k3, 1)) + 1, zCt(G8e(B[1] / k3, 1)) - 1], he = Q / k3 * B[0];
        return { layout: g3, pixelDimIndex: b3, layoutBase: t3[c3[b3]], layoutLength: w3, axisBase: t3[c3[1 - b3]], axisLength: t3[p3[1 - b3]], axisExpandable: F, axisExpandWidth: k3, axisCollapseWidth: Q, axisExpandWindow: B, axisCount: I, winInnerIndices: se, axisExpandWindow0Pos: he };
      }, o.prototype._layoutAxes = function() {
        var i = this._rect, t3 = this._axesMap, c3 = this.dimensions, p3 = this._makeLayoutInfo(), g3 = p3.layout;
        t3.each(function(b3) {
          var w3 = [0, p3.axisLength], M = b3.inverse ? 1 : 0;
          b3.setExtent(w3[M], w3[1 - M]);
        }), zye(c3, function(b3, w3) {
          var M = (p3.axisExpandable ? WCt : HCt)(w3, p3), I = { horizontal: { x: M.position, y: p3.axisLength }, vertical: { x: 0, y: M.position } }, k3 = { horizontal: jCt / 2, vertical: 0 }, L = [I[g3].x + i.x, I[g3].y + i.y], F = k3[g3], B = dm();
          cI(B, B, F), D1(B, B, L), this._axesLayout[b3] = { position: L, rotation: F, transform: B, axisNameAvailableWidth: M.axisNameAvailableWidth, axisLabelShow: M.axisLabelShow, nameTruncateMaxWidth: M.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
        }, this);
      }, o.prototype.getAxis = function(i) {
        return this._axesMap.get(i);
      }, o.prototype.dataToPoint = function(i, t3) {
        return this.axisCoordToPoint(this._axesMap.get(t3).dataToCoord(i), t3);
      }, o.prototype.eachActiveState = function(i, t3, c3, p3) {
        c3 == null && (c3 = 0), p3 == null && (p3 = i.count());
        var g3 = this._axesMap, b3 = this.dimensions, w3 = [], M = [];
        yt(b3, function(Q) {
          w3.push(i.mapDimension(Q)), M.push(g3.get(Q).model);
        });
        for (var I = this.hasAxisBrushed(), k3 = c3; k3 < p3; k3++) {
          var L = void 0;
          if (!I)
            L = "normal";
          else {
            L = "active";
            for (var F = i.getValues(w3, k3), B = 0, G = b3.length; B < G; B++) {
              var J = M[B].getActiveState(F[B]);
              if (J === "inactive") {
                L = "inactive";
                break;
              }
            }
          }
          t3(L, k3);
        }
      }, o.prototype.hasAxisBrushed = function() {
        for (var i = this.dimensions, t3 = this._axesMap, c3 = false, p3 = 0, g3 = i.length; p3 < g3; p3++)
          t3.get(i[p3]).model.getActiveState() !== "normal" && (c3 = true);
        return c3;
      }, o.prototype.axisCoordToPoint = function(i, t3) {
        var c3 = this._axesLayout[t3];
        return ll([i, 0], c3.transform);
      }, o.prototype.getAxisLayout = function(i) {
        return Jo(this._axesLayout[i]);
      }, o.prototype.getSlidedAxisExpandWindow = function(i) {
        var t3 = this._makeLayoutInfo(), c3 = t3.pixelDimIndex, p3 = t3.axisExpandWindow.slice(), g3 = p3[1] - p3[0], b3 = [0, t3.axisExpandWidth * (t3.axisCount - 1)];
        if (!this.containPoint(i))
          return { behavior: "none", axisExpandWindow: p3 };
        var w3 = i[c3] - t3.layoutBase - t3.axisExpandWindow0Pos, M, I = "slide", k3 = t3.axisCollapseWidth, L = this._model.get("axisExpandSlideTriggerArea"), F = L[0] != null;
        if (k3)
          F && k3 && w3 < g3 * L[0] ? (I = "jump", M = w3 - g3 * L[2]) : F && k3 && w3 > g3 * (1 - L[0]) ? (I = "jump", M = w3 - g3 * (1 - L[2])) : (M = w3 - g3 * L[1]) >= 0 && (M = w3 - g3 * (1 - L[1])) <= 0 && (M = 0), M *= t3.axisExpandWidth / k3, M ? ML(M, p3, b3, "all") : I = "none";
        else {
          var B = p3[1] - p3[0], G = b3[1] * w3 / B;
          p3 = [z8e(0, G - B / 2)], p3[1] = B8e(b3[1], p3[0] + B), p3[0] = p3[1] - B;
        }
        return { axisExpandWindow: p3, behavior: I };
      }, o;
    }();
    function Mne(o, i) {
      return B8e(z8e(o, i[0]), i[1]);
    }
    function HCt(o, i) {
      var t3 = i.layoutLength / (i.axisCount - 1);
      return { position: t3 * o, axisNameAvailableWidth: t3, axisLabelShow: true };
    }
    function WCt(o, i) {
      var t3 = i.layoutLength, c3 = i.axisExpandWidth, p3 = i.axisCount, g3 = i.axisCollapseWidth, b3 = i.winInnerIndices, w3, M = g3, I = false, k3;
      return o < b3[0] ? (w3 = o * g3, k3 = g3) : o <= b3[1] ? (w3 = i.axisExpandWindow0Pos + o * c3 - i.axisExpandWindow[0], M = c3, I = true) : (w3 = t3 - (p3 - 1 - o) * g3, k3 = g3), { position: w3, axisNameAvailableWidth: M, axisLabelShow: I, nameTruncateMaxWidth: k3 };
    }
    var UCt = GCt;
    function qCt(o, i) {
      var t3 = [];
      return o.eachComponent("parallel", function(c3, p3) {
        var g3 = new UCt(c3, o, i);
        g3.name = "parallel_" + p3, g3.resize(c3, i), c3.coordinateSystem = g3, g3.model = c3, t3.push(g3);
      }), o.eachSeries(function(c3) {
        if (c3.get("coordinateSystem") === "parallel") {
          var p3 = c3.getReferringComponents("parallel", xd).models[0];
          c3.coordinateSystem = p3.coordinateSystem;
        }
      }), t3;
    }
    var $Ct = { create: qCt }, XCt = $Ct, H8e = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.activeIntervals = [], t3;
      }
      return i.prototype.getAreaSelectStyle = function() {
        return mI([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
      }, i.prototype.setActiveIntervals = function(t3) {
        var c3 = this.activeIntervals = Jo(t3);
        if (c3)
          for (var p3 = c3.length - 1; p3 >= 0; p3--)
            dy(c3[p3]);
      }, i.prototype.getActiveState = function(t3) {
        var c3 = this.activeIntervals;
        if (!c3.length)
          return "normal";
        if (t3 == null || isNaN(+t3))
          return "inactive";
        if (c3.length === 1) {
          var p3 = c3[0];
          if (p3[0] <= t3 && t3 <= p3[1])
            return "active";
        } else
          for (var g3 = 0, b3 = c3.length; g3 < b3; g3++)
            if (c3[g3][0] <= t3 && t3 <= c3[g3][1])
              return "active";
        return "inactive";
      }, i;
    }(nc);
    Kp(H8e, eW);
    var W8e = H8e, TL = true, IW = Math.min, H8 = Math.max, YCt = Math.pow, KCt = 1e4, ZCt = 6, JCt = 6, U8e = "globalPan", QCt = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, eMt = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, q8e = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, tMt = 0, nMt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this) || this;
        return c3._track = [], c3._covers = [], c3._handlers = {}, c3._zr = t3, c3.group = new vs(), c3._uid = "brushController_" + tMt++, yt(uMt, function(p3, g3) {
          this._handlers[g3] = Qa(p3, this);
        }, c3), c3;
      }
      return i.prototype.enableBrush = function(t3) {
        return this._brushType && this._doDisableBrush(), t3.brushType && this._doEnableBrush(t3), this;
      }, i.prototype._doEnableBrush = function(t3) {
        var c3 = this._zr;
        this._enableGlobalPan || hwt(c3, U8e, this._uid), yt(this._handlers, function(p3, g3) {
          c3.on(g3, p3);
        }), this._brushType = t3.brushType, this._brushOption = Es(Jo(q8e), t3, true);
      }, i.prototype._doDisableBrush = function() {
        var t3 = this._zr;
        pwt(t3, U8e, this._uid), yt(this._handlers, function(c3, p3) {
          t3.off(p3, c3);
        }), this._brushType = this._brushOption = null;
      }, i.prototype.setPanels = function(t3) {
        if (t3 && t3.length) {
          var c3 = this._panels = {};
          yt(t3, function(p3) {
            c3[p3.panelId] = Jo(p3);
          });
        } else
          this._panels = null;
        return this;
      }, i.prototype.mount = function(t3) {
        t3 = t3 || {}, this._enableGlobalPan = t3.enableGlobalPan;
        var c3 = this.group;
        return this._zr.add(c3), c3.attr({ x: t3.x || 0, y: t3.y || 0, rotation: t3.rotation || 0, scaleX: t3.scaleX || 1, scaleY: t3.scaleY || 1 }), this._transform = c3.getLocalTransform(), this;
      }, i.prototype.updateCovers = function(t3) {
        t3 = Fi(t3, function(F) {
          return Es(Jo(q8e), F, true);
        });
        var c3 = "\0-brush-index-", p3 = this._covers, g3 = this._covers = [], b3 = this, w3 = this._creatingCover;
        return new RI(p3, t3, I, M).add(k3).update(k3).remove(L).execute(), this;
        function M(F, B) {
          return (F.id != null ? F.id : c3 + B) + "-" + F.brushType;
        }
        function I(F, B) {
          return M(F.__brushOption, B);
        }
        function k3(F, B) {
          var G = t3[F];
          if (B != null && p3[B] === w3)
            g3[F] = p3[B];
          else {
            var J = g3[F] = B != null ? (p3[B].__brushOption = G, p3[B]) : X8e(b3, $8e(b3, G));
            jye(b3, J);
          }
        }
        function L(F) {
          p3[F] !== w3 && b3.group.remove(p3[F]);
        }
      }, i.prototype.unmount = function() {
        return this.enableBrush(false), Wye(this), this._zr.remove(this.group), this;
      }, i.prototype.dispose = function() {
        this.unmount(), this.off();
      }, i;
    }(hm);
    function $8e(o, i) {
      var t3 = Tne[i.brushType].createCover(o, i);
      return t3.__brushOption = i, K8e(t3, i), o.group.add(t3), t3;
    }
    function X8e(o, i) {
      var t3 = Gye(i);
      return t3.endCreating && (t3.endCreating(o, i), K8e(i, i.__brushOption)), i;
    }
    function Y8e(o, i) {
      var t3 = i.__brushOption;
      Gye(i).updateCoverShape(o, i, t3.range, t3);
    }
    function K8e(o, i) {
      var t3 = i.z;
      t3 == null && (t3 = KCt), o.traverse(function(c3) {
        c3.z = t3, c3.z2 = t3;
      });
    }
    function jye(o, i) {
      Gye(i).updateCommon(o, i), Y8e(o, i);
    }
    function Gye(o) {
      return Tne[o.__brushOption.brushType];
    }
    function Hye(o, i, t3) {
      var c3 = o._panels;
      if (!c3)
        return TL;
      var p3, g3 = o._transform;
      return yt(c3, function(b3) {
        b3.isTargetByCursor(i, t3, g3) && (p3 = b3);
      }), p3;
    }
    function Z8e(o, i) {
      var t3 = o._panels;
      if (!t3)
        return TL;
      var c3 = i.__brushOption.panelId;
      return c3 != null ? t3[c3] : TL;
    }
    function Wye(o) {
      var i = o._covers, t3 = i.length;
      return yt(i, function(c3) {
        o.group.remove(c3);
      }, o), i.length = 0, !!t3;
    }
    function AL(o, i) {
      var t3 = Fi(o._covers, function(c3) {
        var p3 = c3.__brushOption, g3 = Jo(p3.range);
        return { brushType: p3.brushType, panelId: p3.panelId, range: g3 };
      });
      o.trigger("brush", { areas: t3, isEnd: !!i.isEnd, removeOnClick: !!i.removeOnClick });
    }
    function rMt(o) {
      var i = o._track;
      if (!i.length)
        return false;
      var t3 = i[i.length - 1], c3 = i[0], p3 = t3[0] - c3[0], g3 = t3[1] - c3[1], b3 = YCt(p3 * p3 + g3 * g3, 0.5);
      return b3 > ZCt;
    }
    function J8e(o) {
      var i = o.length - 1;
      return i < 0 && (i = 0), [o[0], o[i]];
    }
    function Q8e(o, i, t3, c3) {
      var p3 = new vs();
      return p3.add(new bu({ name: "main", style: qye(t3), silent: true, draggable: true, cursor: "move", drift: As(n9e, o, i, p3, ["n", "s", "w", "e"]), ondragend: As(AL, i, { isEnd: true }) })), yt(c3, function(g3) {
        p3.add(new bu({ name: g3.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: As(n9e, o, i, p3, g3), ondragend: As(AL, i, { isEnd: true }) }));
      }), p3;
    }
    function e9e(o, i, t3, c3) {
      var p3 = c3.brushStyle.lineWidth || 0, g3 = H8(p3, JCt), b3 = t3[0][0], w3 = t3[1][0], M = b3 - p3 / 2, I = w3 - p3 / 2, k3 = t3[0][1], L = t3[1][1], F = k3 - g3 + p3 / 2, B = L - g3 + p3 / 2, G = k3 - b3, J = L - w3, Q = G + p3, se = J + p3;
      jI(o, i, "main", b3, w3, G, J), c3.transformable && (jI(o, i, "w", M, I, g3, se), jI(o, i, "e", F, I, g3, se), jI(o, i, "n", M, I, Q, g3), jI(o, i, "s", M, B, Q, g3), jI(o, i, "nw", M, I, g3, g3), jI(o, i, "ne", F, I, g3, g3), jI(o, i, "sw", M, B, g3, g3), jI(o, i, "se", F, B, g3, g3));
    }
    function Uye(o, i) {
      var t3 = i.__brushOption, c3 = t3.transformable, p3 = i.childAt(0);
      p3.useStyle(qye(t3)), p3.attr({ silent: !c3, cursor: c3 ? "move" : "default" }), yt([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(g3) {
        var b3 = i.childOfName(g3.join("")), w3 = g3.length === 1 ? $ye(o, g3[0]) : aMt(o, g3);
        b3 && b3.attr({ silent: !c3, invisible: !c3, cursor: c3 ? eMt[w3] + "-resize" : null });
      });
    }
    function jI(o, i, t3, c3, p3, g3, b3) {
      var w3 = i.childOfName(t3);
      w3 && w3.setShape(sMt(Xye(o, i, [[c3, p3], [c3 + g3, p3 + b3]])));
    }
    function qye(o) {
      return Uo({ strokeNoScale: true }, o.brushStyle);
    }
    function t9e(o, i, t3, c3) {
      var p3 = [IW(o, t3), IW(i, c3)], g3 = [H8(o, t3), H8(i, c3)];
      return [[p3[0], g3[0]], [p3[1], g3[1]]];
    }
    function iMt(o) {
      return Ls(o.group);
    }
    function $ye(o, i) {
      var t3 = { w: "left", e: "right", n: "top", s: "bottom" }, c3 = { left: "w", right: "e", top: "n", bottom: "s" }, p3 = Hs(t3[i], iMt(o));
      return c3[p3];
    }
    function aMt(o, i) {
      var t3 = [$ye(o, i[0]), $ye(o, i[1])];
      return (t3[0] === "e" || t3[0] === "w") && t3.reverse(), t3.join("");
    }
    function n9e(o, i, t3, c3, p3, g3) {
      var b3 = t3.__brushOption, w3 = o.toRectRange(b3.range), M = r9e(i, p3, g3);
      yt(c3, function(I) {
        var k3 = QCt[I];
        w3[k3[0]][k3[1]] += M[k3[0]];
      }), b3.range = o.fromRectRange(t9e(w3[0][0], w3[1][0], w3[0][1], w3[1][1])), jye(i, t3), AL(i, { isEnd: false });
    }
    function oMt(o, i, t3, c3) {
      var p3 = i.__brushOption.range, g3 = r9e(o, t3, c3);
      yt(p3, function(b3) {
        b3[0] += g3[0], b3[1] += g3[1];
      }), jye(o, i), AL(o, { isEnd: false });
    }
    function r9e(o, i, t3) {
      var c3 = o.group, p3 = c3.transformCoordToLocal(i, t3), g3 = c3.transformCoordToLocal(0, 0);
      return [p3[0] - g3[0], p3[1] - g3[1]];
    }
    function Xye(o, i, t3) {
      var c3 = Z8e(o, i);
      return c3 && c3 !== TL ? c3.clipPath(t3, o._transform) : Jo(t3);
    }
    function sMt(o) {
      var i = IW(o[0][0], o[1][0]), t3 = IW(o[0][1], o[1][1]), c3 = H8(o[0][0], o[1][0]), p3 = H8(o[0][1], o[1][1]);
      return { x: i, y: t3, width: c3 - i, height: p3 - t3 };
    }
    function lMt(o, i, t3) {
      if (!(!o._brushType || cMt(o, i.offsetX, i.offsetY))) {
        var c3 = o._zr, p3 = o._covers, g3 = Hye(o, i, t3);
        if (!o._dragging)
          for (var b3 = 0; b3 < p3.length; b3++) {
            var w3 = p3[b3].__brushOption;
            if (g3 && (g3 === TL || w3.panelId === g3.panelId) && Tne[w3.brushType].contain(p3[b3], t3[0], t3[1]))
              return;
          }
        g3 && c3.setCursorStyle("crosshair");
      }
    }
    function Yye(o) {
      var i = o.event;
      i.preventDefault && i.preventDefault();
    }
    function Kye(o, i, t3) {
      return o.childOfName("main").contain(i, t3);
    }
    function i9e(o, i, t3, c3) {
      var p3 = o._creatingCover, g3 = o._creatingPanel, b3 = o._brushOption, w3;
      if (o._track.push(t3.slice()), rMt(o) || p3) {
        if (g3 && !p3) {
          b3.brushMode === "single" && Wye(o);
          var M = Jo(b3);
          M.brushType = a9e(M.brushType, g3), M.panelId = g3 === TL ? null : g3.panelId, p3 = o._creatingCover = $8e(o, M), o._covers.push(p3);
        }
        if (p3) {
          var I = Tne[a9e(o._brushType, g3)], k3 = p3.__brushOption;
          k3.range = I.getCreatingRange(Xye(o, p3, o._track)), c3 && (X8e(o, p3), I.updateCommon(o, p3)), Y8e(o, p3), w3 = { isEnd: c3 };
        }
      } else
        c3 && b3.brushMode === "single" && b3.removeOnClick && Hye(o, i, t3) && Wye(o) && (w3 = { isEnd: c3, removeOnClick: true });
      return w3;
    }
    function a9e(o, i) {
      return o === "auto" ? i.defaultBrushType : o;
    }
    var uMt = { mousedown: function(o) {
      if (this._dragging)
        o9e(this, o);
      else if (!o.target || !o.target.draggable) {
        Yye(o);
        var i = this.group.transformCoordToLocal(o.offsetX, o.offsetY);
        this._creatingCover = null;
        var t3 = this._creatingPanel = Hye(this, o, i);
        t3 && (this._dragging = true, this._track = [i.slice()]);
      }
    }, mousemove: function(o) {
      var i = o.offsetX, t3 = o.offsetY, c3 = this.group.transformCoordToLocal(i, t3);
      if (lMt(this, o, c3), this._dragging) {
        Yye(o);
        var p3 = i9e(this, o, c3, false);
        p3 && AL(this, p3);
      }
    }, mouseup: function(o) {
      o9e(this, o);
    } };
    function o9e(o, i) {
      if (o._dragging) {
        Yye(i);
        var t3 = i.offsetX, c3 = i.offsetY, p3 = o.group.transformCoordToLocal(t3, c3), g3 = i9e(o, i, p3, true);
        o._dragging = false, o._track = [], o._creatingCover = null, g3 && AL(o, g3);
      }
    }
    function cMt(o, i, t3) {
      var c3 = o._zr;
      return i < 0 || i > c3.getWidth() || t3 < 0 || t3 > c3.getHeight();
    }
    var Tne = { lineX: s9e(0), lineY: s9e(1), rect: { createCover: function(o, i) {
      function t3(c3) {
        return c3;
      }
      return Q8e({ toRectRange: t3, fromRectRange: t3 }, o, i, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
    }, getCreatingRange: function(o) {
      var i = J8e(o);
      return t9e(i[1][0], i[1][1], i[0][0], i[0][1]);
    }, updateCoverShape: function(o, i, t3, c3) {
      e9e(o, i, t3, c3);
    }, updateCommon: Uye, contain: Kye }, polygon: { createCover: function(o, i) {
      var t3 = new vs();
      return t3.add(new xm({ name: "main", style: qye(i), silent: true })), t3;
    }, getCreatingRange: function(o) {
      return o;
    }, endCreating: function(o, i) {
      i.remove(i.childAt(0)), i.add(new _m({ name: "main", draggable: true, drift: As(oMt, o, i), ondragend: As(AL, o, { isEnd: true }) }));
    }, updateCoverShape: function(o, i, t3, c3) {
      i.childAt(0).setShape({ points: Xye(o, i, t3) });
    }, updateCommon: Uye, contain: Kye } };
    function s9e(o) {
      return { createCover: function(i, t3) {
        return Q8e({ toRectRange: function(c3) {
          var p3 = [c3, [0, 100]];
          return o && p3.reverse(), p3;
        }, fromRectRange: function(c3) {
          return c3[o];
        } }, i, t3, [[["w"], ["e"]], [["n"], ["s"]]][o]);
      }, getCreatingRange: function(i) {
        var t3 = J8e(i), c3 = IW(t3[0][o], t3[1][o]), p3 = H8(t3[0][o], t3[1][o]);
        return [c3, p3];
      }, updateCoverShape: function(i, t3, c3, p3) {
        var g3, b3 = Z8e(i, t3);
        if (b3 !== TL && b3.getLinearBrushOtherExtent)
          g3 = b3.getLinearBrushOtherExtent(o);
        else {
          var w3 = i._zr;
          g3 = [0, [w3.getWidth(), w3.getHeight()][1 - o]];
        }
        var M = [c3, g3];
        o && M.reverse(), e9e(i, t3, M, p3);
      }, updateCommon: Uye, contain: Kye };
    }
    var Zye = nMt;
    function l9e(o) {
      return o = Jye(o), function(i) {
        return v0(i, o);
      };
    }
    function u9e(o, i) {
      return o = Jye(o), function(t3) {
        var c3 = i != null ? i : t3, p3 = c3 ? o.width : o.height, g3 = c3 ? o.x : o.y;
        return [g3, g3 + (p3 || 0)];
      };
    }
    function c9e(o, i, t3) {
      var c3 = Jye(o);
      return function(p3, g3) {
        return c3.contain(g3[0], g3[1]) && !fne(p3, i, t3);
      };
    }
    function Jye(o) {
      return Ys.create(o);
    }
    var fMt = ["axisLine", "axisTickLabel", "axisName"], hMt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3) {
        o.prototype.init.apply(this, arguments), (this._brushController = new Zye(c3.getZr())).on("brush", Qa(this._onBrush, this));
      }, i.prototype.render = function(t3, c3, p3, g3) {
        if (!pMt(t3, c3, g3)) {
          this.axisModel = t3, this.api = p3, this.group.removeAll();
          var b3 = this._axisGroup;
          if (this._axisGroup = new vs(), this.group.add(this._axisGroup), !!t3.get("show")) {
            var w3 = vMt(t3, c3), M = w3.coordinateSystem, I = t3.getAreaSelectStyle(), k3 = I.width, L = t3.axis.dim, F = M.getAxisLayout(L), B = ti({ strokeContainThreshold: k3 }, F), G = new BI(t3, B);
            yt(fMt, G.add, G), this._axisGroup.add(G.getGroup()), this._refreshBrushController(B, I, t3, w3, k3, p3), Sg(b3, this._axisGroup, t3);
          }
        }
      }, i.prototype._refreshBrushController = function(t3, c3, p3, g3, b3, w3) {
        var M = p3.axis.getExtent(), I = M[1] - M[0], k3 = Math.min(30, Math.abs(I) * 0.1), L = Ys.create({ x: M[0], y: -b3 / 2, width: I, height: b3 });
        L.x -= k3, L.width += 2 * k3, this._brushController.mount({ enableGlobalPan: true, rotation: t3.rotation, x: t3.position[0], y: t3.position[1] }).setPanels([{ panelId: "pl", clipPath: l9e(L), isTargetByCursor: c9e(L, w3, g3), getLinearBrushOtherExtent: u9e(L, 0) }]).enableBrush({ brushType: "lineX", brushStyle: c3, removeOnClick: true }).updateCovers(dMt(p3));
      }, i.prototype._onBrush = function(t3) {
        var c3 = t3.areas, p3 = this.axisModel, g3 = p3.axis, b3 = Fi(c3, function(w3) {
          return [g3.coordToData(w3.range[0], true), g3.coordToData(w3.range[1], true)];
        });
        (!p3.option.realtime === t3.isEnd || t3.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: p3.id, intervals: b3 });
      }, i.prototype.dispose = function() {
        this._brushController.dispose();
      }, i.type = "parallelAxis", i;
    }(ed);
    function pMt(o, i, t3) {
      return t3 && t3.type === "axisAreaSelect" && i.findComponents({ mainType: "parallelAxis", query: t3 })[0] === o;
    }
    function dMt(o) {
      var i = o.axis;
      return Fi(o.activeIntervals, function(t3) {
        return { brushType: "lineX", panelId: "pl", range: [i.dataToCoord(t3[0], true), i.dataToCoord(t3[1], true)] };
      });
    }
    function vMt(o, i) {
      return i.getComponent("parallel", o.get("parallelIndex"));
    }
    var gMt = hMt, yMt = { type: "axisAreaSelect", event: "axisAreaSelected" };
    function mMt(o) {
      o.registerAction(yMt, function(i, t3) {
        t3.eachComponent({ mainType: "parallelAxis", query: i }, function(c3) {
          c3.axis.model.setActiveIntervals(i.intervals);
        });
      }), o.registerAction("parallelAxisExpand", function(i, t3) {
        t3.eachComponent({ mainType: "parallel", query: i }, function(c3) {
          c3.setAxisExpand(i);
        });
      });
    }
    var bMt = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
    function f9e(o) {
      o.registerComponentView(RCt), o.registerComponentModel(FCt), o.registerCoordinateSystem("parallel", XCt), o.registerPreprocessor(ECt), o.registerComponentModel(W8e), o.registerComponentView(gMt), F8(o, "parallel", W8e, bMt), mMt(o);
    }
    function _Mt(o) {
      Tl(f9e), o.registerChartView(xCt), o.registerSeriesModel(MCt), o.registerVisual(o.PRIORITY.VISUAL.BRUSH, ICt);
    }
    var xMt = function() {
      function o() {
        this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
      }
      return o;
    }(), wMt = function(o) {
      cn(i, o);
      function i(t3) {
        return o.call(this, t3) || this;
      }
      return i.prototype.getDefaultShape = function() {
        return new xMt();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.extent;
        t3.moveTo(c3.x1, c3.y1), t3.bezierCurveTo(c3.cpx1, c3.cpy1, c3.cpx2, c3.cpy2, c3.x2, c3.y2), c3.orient === "vertical" ? (t3.lineTo(c3.x2 + p3, c3.y2), t3.bezierCurveTo(c3.cpx2 + p3, c3.cpy2, c3.cpx1 + p3, c3.cpy1, c3.x1 + p3, c3.y1)) : (t3.lineTo(c3.x2, c3.y2 + p3), t3.bezierCurveTo(c3.cpx2, c3.cpy2 + p3, c3.cpx1, c3.cpy1 + p3, c3.x1, c3.y1 + p3)), t3.closePath();
      }, i.prototype.highlight = function() {
        Hv(this);
      }, i.prototype.downplay = function() {
        sl(this);
      }, i;
    }(gl), SMt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._focusAdjacencyDisabled = false, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = this, b3 = t3.getGraph(), w3 = this.group, M = t3.layoutInfo, I = M.width, k3 = M.height, L = t3.getData(), F = t3.getData("edge"), B = t3.get("orient");
        this._model = t3, w3.removeAll(), w3.x = M.x, w3.y = M.y, b3.eachEdge(function(G) {
          var J = new wMt(), Q = La(J);
          Q.dataIndex = G.dataIndex, Q.seriesIndex = t3.seriesIndex, Q.dataType = "edge";
          var se = G.getModel(), he = se.getModel("lineStyle"), be = he.get("curveness"), de = G.node1.getLayout(), Fe = G.node1.getModel(), Pe = Fe.get("localX"), ze = Fe.get("localY"), $e = G.node2.getLayout(), Ke = G.node2.getModel(), nt = Ke.get("localX"), lt2 = Ke.get("localY"), bt = G.getLayout(), vt, jt, Jt, Rt, Jn, ln, vn, kn;
          switch (J.shape.extent = Math.max(1, bt.dy), J.shape.orient = B, B === "vertical" ? (vt = (Pe != null ? Pe * I : de.x) + bt.sy, jt = (ze != null ? ze * k3 : de.y) + de.dy, Jt = (nt != null ? nt * I : $e.x) + bt.ty, Rt = lt2 != null ? lt2 * k3 : $e.y, Jn = vt, ln = jt * (1 - be) + Rt * be, vn = Jt, kn = jt * be + Rt * (1 - be)) : (vt = (Pe != null ? Pe * I : de.x) + de.dx, jt = (ze != null ? ze * k3 : de.y) + bt.sy, Jt = nt != null ? nt * I : $e.x, Rt = (lt2 != null ? lt2 * k3 : $e.y) + bt.ty, Jn = vt * (1 - be) + Jt * be, ln = jt, vn = vt * be + Jt * (1 - be), kn = Rt), J.setShape({ x1: vt, y1: jt, x2: Jt, y2: Rt, cpx1: Jn, cpy1: ln, cpx2: vn, cpy2: kn }), J.useStyle(he.getItemStyle()), J.style.fill) {
            case "source":
              J.style.fill = G.node1.getVisual("color"), J.style.decal = G.node1.getVisual("style").decal;
              break;
            case "target":
              J.style.fill = G.node2.getVisual("color"), J.style.decal = G.node2.getVisual("style").decal;
              break;
            case "gradient":
              var cr = G.node1.getVisual("color"), gr = G.node2.getVisual("color");
              Ha(cr) && Ha(gr) && (J.style.fill = new JP(0, 0, +(B === "horizontal"), +(B === "vertical"), [{ color: cr, offset: 0 }, { color: gr, offset: 1 }]));
          }
          var ha = se.getModel("emphasis");
          cv(J, se, "lineStyle", function(Do) {
            return Do.getItemStyle();
          }), w3.add(J), F.setItemGraphicEl(G.dataIndex, J);
          var Ka = ha.get("focus");
          zp(J, Ka === "adjacency" ? G.getAdjacentDataIndices() : Ka, ha.get("blurScope"), ha.get("disabled")), La(J).dataType = "edge";
        }), b3.eachNode(function(G) {
          var J = G.getLayout(), Q = G.getModel(), se = Q.get("localX"), he = Q.get("localY"), be = Q.getModel("emphasis"), de = new bu({ shape: { x: se != null ? se * I : J.x, y: he != null ? he * k3 : J.y, width: J.dx, height: J.dy }, style: Q.getModel("itemStyle").getItemStyle(), z2: 10 });
          Sm(de, g0(Q), { labelFetcher: t3, labelDataIndex: G.dataIndex, defaultText: G.id }), de.disableLabelAnimation = true, de.setStyle("fill", G.getVisual("color")), de.setStyle("decal", G.getVisual("style").decal), cv(de, Q), w3.add(de), L.setItemGraphicEl(G.dataIndex, de), La(de).dataType = "node";
          var Fe = be.get("focus");
          zp(de, Fe === "adjacency" ? G.getAdjacentDataIndices() : Fe, be.get("blurScope"), be.get("disabled"));
        }), L.eachItemGraphicEl(function(G, J) {
          var Q = L.getItemModel(J);
          Q.get("draggable") && (G.drift = function(se, he) {
            g3._focusAdjacencyDisabled = true, this.shape.x += se, this.shape.y += he, this.dirty(), p3.dispatchAction({ type: "dragNode", seriesId: t3.id, dataIndex: L.getRawIndex(J), localX: this.shape.x / I, localY: this.shape.y / k3 });
          }, G.ondragend = function() {
            g3._focusAdjacencyDisabled = false;
          }, G.draggable = true, G.cursor = "move");
        }), !this._data && t3.isAnimationEnabled() && w3.setClipPath(CMt(w3.getBoundingRect(), t3, function() {
          w3.removeClipPath();
        })), this._data = t3.getData();
      }, i.prototype.dispose = function() {
      }, i.type = "sankey", i;
    }(yh);
    function CMt(o, i, t3) {
      var c3 = new bu({ shape: { x: o.x - 10, y: o.y - 10, width: 0, height: o.height + 20 } });
      return Uh(c3, { shape: { width: o.width + 20 } }, i, t3), c3;
    }
    var MMt = SMt, TMt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        var p3 = t3.edges || t3.links, g3 = t3.data || t3.nodes, b3 = t3.levels;
        this.levelModels = [];
        for (var w3 = this.levelModels, M = 0; M < b3.length; M++)
          b3[M].depth != null && b3[M].depth >= 0 && (w3[b3[M].depth] = new gh(b3[M], this, c3));
        if (g3 && p3) {
          var I = R8e(g3, p3, this, true, k3);
          return I.data;
        }
        function k3(L, F) {
          L.wrapMethod("getItemModel", function(B, G) {
            var J = B.parentModel, Q = J.getData().getItemLayout(G);
            if (Q) {
              var se = Q.depth, he = J.levelModels[se];
              he && (B.parentModel = he);
            }
            return B;
          }), F.wrapMethod("getItemModel", function(B, G) {
            var J = B.parentModel, Q = J.getGraph().getEdgeByIndex(G), se = Q.node1.getLayout();
            if (se) {
              var he = se.depth, be = J.levelModels[he];
              be && (B.parentModel = be);
            }
            return B;
          });
        }
      }, i.prototype.setNodePosition = function(t3, c3) {
        var p3 = this.option.data || this.option.nodes, g3 = p3[t3];
        g3.localX = c3[0], g3.localY = c3[1];
      }, i.prototype.getGraph = function() {
        return this.getData().graph;
      }, i.prototype.getEdgeData = function() {
        return this.getGraph().edgeData;
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        function g3(B) {
          return isNaN(B) || B == null;
        }
        if (p3 === "edge") {
          var b3 = this.getDataParams(t3, p3), w3 = b3.data, M = b3.value, I = w3.source + " -- " + w3.target;
          return Cg("nameValue", { name: I, value: M, noValue: g3(M) });
        } else {
          var k3 = this.getGraph().getNodeByIndex(t3), L = k3.getLayout().value, F = this.getDataParams(t3, p3).data.name;
          return Cg("nameValue", { name: F != null ? F + "" : null, value: L, noValue: g3(L) });
        }
      }, i.prototype.optionUpdated = function() {
      }, i.prototype.getDataParams = function(t3, c3) {
        var p3 = o.prototype.getDataParams.call(this, t3, c3);
        if (p3.value == null && c3 === "node") {
          var g3 = this.getGraph().getNodeByIndex(t3), b3 = g3.getLayout().value;
          p3.value = b3;
        }
        return p3;
      }, i.type = "series.sankey", i.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, i;
    }(bp), AMt = TMt;
    function IMt(o, i) {
      o.eachSeriesByType("sankey", function(t3) {
        var c3 = t3.get("nodeWidth"), p3 = t3.get("nodeGap"), g3 = EMt(t3, i);
        t3.layoutInfo = g3;
        var b3 = g3.width, w3 = g3.height, M = t3.getGraph(), I = M.nodes, k3 = M.edges;
        kMt(I);
        var L = Zc(I, function(J) {
          return J.getLayout().value === 0;
        }), F = L.length !== 0 ? 0 : t3.get("layoutIterations"), B = t3.get("orient"), G = t3.get("nodeAlign");
        DMt(I, k3, c3, p3, b3, w3, F, B, G);
      });
    }
    function EMt(o, i) {
      return Wv(o.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() });
    }
    function DMt(o, i, t3, c3, p3, g3, b3, w3, M) {
      OMt(o, i, t3, p3, g3, w3, M), NMt(o, i, g3, p3, c3, b3, w3), UMt(o, w3);
    }
    function kMt(o) {
      yt(o, function(i) {
        var t3 = yk(i.outEdges, Ane), c3 = yk(i.inEdges, Ane), p3 = i.getValue() || 0, g3 = Math.max(t3, c3, p3);
        i.setLayout({ value: g3 }, true);
      });
    }
    function OMt(o, i, t3, c3, p3, g3, b3) {
      for (var w3 = [], M = [], I = [], k3 = [], L = 0, F = 0; F < i.length; F++)
        w3[F] = 1;
      for (var F = 0; F < o.length; F++)
        M[F] = o[F].inEdges.length, M[F] === 0 && I.push(o[F]);
      for (var B = -1; I.length; ) {
        for (var G = 0; G < I.length; G++) {
          var J = I[G], Q = J.hostGraph.data.getRawDataItem(J.dataIndex), se = Q.depth != null && Q.depth >= 0;
          se && Q.depth > B && (B = Q.depth), J.setLayout({ depth: se ? Q.depth : L }, true), g3 === "vertical" ? J.setLayout({ dy: t3 }, true) : J.setLayout({ dx: t3 }, true);
          for (var he = 0; he < J.outEdges.length; he++) {
            var be = J.outEdges[he], de = i.indexOf(be);
            w3[de] = 0;
            var Fe = be.node2, Pe = o.indexOf(Fe);
            --M[Pe] === 0 && k3.indexOf(Fe) < 0 && k3.push(Fe);
          }
        }
        ++L, I = k3, k3 = [];
      }
      for (var F = 0; F < w3.length; F++)
        if (w3[F] === 1)
          throw new Error("Sankey is a DAG, the original data has cycle!");
      var ze = B > L - 1 ? B : L - 1;
      b3 && b3 !== "left" && PMt(o, b3, g3, ze);
      var $e = g3 === "vertical" ? (p3 - t3) / ze : (c3 - t3) / ze;
      RMt(o, $e, g3);
    }
    function h9e(o) {
      var i = o.hostGraph.data.getRawDataItem(o.dataIndex);
      return i.depth != null && i.depth >= 0;
    }
    function PMt(o, i, t3, c3) {
      if (i === "right") {
        for (var p3 = [], g3 = o, b3 = 0; g3.length; ) {
          for (var w3 = 0; w3 < g3.length; w3++) {
            var M = g3[w3];
            M.setLayout({ skNodeHeight: b3 }, true);
            for (var I = 0; I < M.inEdges.length; I++) {
              var k3 = M.inEdges[I];
              p3.indexOf(k3.node1) < 0 && p3.push(k3.node1);
            }
          }
          g3 = p3, p3 = [], ++b3;
        }
        yt(o, function(L) {
          h9e(L) || L.setLayout({ depth: Math.max(0, c3 - L.getLayout().skNodeHeight) }, true);
        });
      } else
        i === "justify" && LMt(o, c3);
    }
    function LMt(o, i) {
      yt(o, function(t3) {
        !h9e(t3) && !t3.outEdges.length && t3.setLayout({ depth: i }, true);
      });
    }
    function RMt(o, i, t3) {
      yt(o, function(c3) {
        var p3 = c3.getLayout().depth * i;
        t3 === "vertical" ? c3.setLayout({ y: p3 }, true) : c3.setLayout({ x: p3 }, true);
      });
    }
    function NMt(o, i, t3, c3, p3, g3, b3) {
      var w3 = FMt(o, b3);
      VMt(w3, i, t3, c3, p3, b3), Qye(w3, p3, t3, c3, b3);
      for (var M = 1; g3 > 0; g3--)
        M *= 0.99, BMt(w3, M, b3), Qye(w3, p3, t3, c3, b3), WMt(w3, M, b3), Qye(w3, p3, t3, c3, b3);
    }
    function FMt(o, i) {
      var t3 = [], c3 = i === "vertical" ? "y" : "x", p3 = VF(o, function(g3) {
        return g3.getLayout()[c3];
      });
      return p3.keys.sort(function(g3, b3) {
        return g3 - b3;
      }), yt(p3.keys, function(g3) {
        t3.push(p3.buckets.get(g3));
      }), t3;
    }
    function VMt(o, i, t3, c3, p3, g3) {
      var b3 = 1 / 0;
      yt(o, function(w3) {
        var M = w3.length, I = 0;
        yt(w3, function(L) {
          I += L.getLayout().value;
        });
        var k3 = g3 === "vertical" ? (c3 - (M - 1) * p3) / I : (t3 - (M - 1) * p3) / I;
        k3 < b3 && (b3 = k3);
      }), yt(o, function(w3) {
        yt(w3, function(M, I) {
          var k3 = M.getLayout().value * b3;
          g3 === "vertical" ? (M.setLayout({ x: I }, true), M.setLayout({ dx: k3 }, true)) : (M.setLayout({ y: I }, true), M.setLayout({ dy: k3 }, true));
        });
      }), yt(i, function(w3) {
        var M = +w3.getValue() * b3;
        w3.setLayout({ dy: M }, true);
      });
    }
    function Qye(o, i, t3, c3, p3) {
      var g3 = p3 === "vertical" ? "x" : "y";
      yt(o, function(b3) {
        b3.sort(function(J, Q) {
          return J.getLayout()[g3] - Q.getLayout()[g3];
        });
        for (var w3, M, I, k3 = 0, L = b3.length, F = p3 === "vertical" ? "dx" : "dy", B = 0; B < L; B++)
          M = b3[B], I = k3 - M.getLayout()[g3], I > 0 && (w3 = M.getLayout()[g3] + I, p3 === "vertical" ? M.setLayout({ x: w3 }, true) : M.setLayout({ y: w3 }, true)), k3 = M.getLayout()[g3] + M.getLayout()[F] + i;
        var G = p3 === "vertical" ? c3 : t3;
        if (I = k3 - i - G, I > 0) {
          w3 = M.getLayout()[g3] - I, p3 === "vertical" ? M.setLayout({ x: w3 }, true) : M.setLayout({ y: w3 }, true), k3 = w3;
          for (var B = L - 2; B >= 0; --B)
            M = b3[B], I = M.getLayout()[g3] + M.getLayout()[F] + i - k3, I > 0 && (w3 = M.getLayout()[g3] - I, p3 === "vertical" ? M.setLayout({ x: w3 }, true) : M.setLayout({ y: w3 }, true)), k3 = M.getLayout()[g3];
        }
      });
    }
    function BMt(o, i, t3) {
      yt(o.slice().reverse(), function(c3) {
        yt(c3, function(p3) {
          if (p3.outEdges.length) {
            var g3 = yk(p3.outEdges, zMt, t3) / yk(p3.outEdges, Ane);
            if (isNaN(g3)) {
              var b3 = p3.outEdges.length;
              g3 = b3 ? yk(p3.outEdges, jMt, t3) / b3 : 0;
            }
            if (t3 === "vertical") {
              var w3 = p3.getLayout().x + (g3 - gk(p3, t3)) * i;
              p3.setLayout({ x: w3 }, true);
            } else {
              var M = p3.getLayout().y + (g3 - gk(p3, t3)) * i;
              p3.setLayout({ y: M }, true);
            }
          }
        });
      });
    }
    function zMt(o, i) {
      return gk(o.node2, i) * o.getValue();
    }
    function jMt(o, i) {
      return gk(o.node2, i);
    }
    function GMt(o, i) {
      return gk(o.node1, i) * o.getValue();
    }
    function HMt(o, i) {
      return gk(o.node1, i);
    }
    function gk(o, i) {
      return i === "vertical" ? o.getLayout().x + o.getLayout().dx / 2 : o.getLayout().y + o.getLayout().dy / 2;
    }
    function Ane(o) {
      return o.getValue();
    }
    function yk(o, i, t3) {
      for (var c3 = 0, p3 = o.length, g3 = -1; ++g3 < p3; ) {
        var b3 = +i(o[g3], t3);
        isNaN(b3) || (c3 += b3);
      }
      return c3;
    }
    function WMt(o, i, t3) {
      yt(o, function(c3) {
        yt(c3, function(p3) {
          if (p3.inEdges.length) {
            var g3 = yk(p3.inEdges, GMt, t3) / yk(p3.inEdges, Ane);
            if (isNaN(g3)) {
              var b3 = p3.inEdges.length;
              g3 = b3 ? yk(p3.inEdges, HMt, t3) / b3 : 0;
            }
            if (t3 === "vertical") {
              var w3 = p3.getLayout().x + (g3 - gk(p3, t3)) * i;
              p3.setLayout({ x: w3 }, true);
            } else {
              var M = p3.getLayout().y + (g3 - gk(p3, t3)) * i;
              p3.setLayout({ y: M }, true);
            }
          }
        });
      });
    }
    function UMt(o, i) {
      var t3 = i === "vertical" ? "x" : "y";
      yt(o, function(c3) {
        c3.outEdges.sort(function(p3, g3) {
          return p3.node2.getLayout()[t3] - g3.node2.getLayout()[t3];
        }), c3.inEdges.sort(function(p3, g3) {
          return p3.node1.getLayout()[t3] - g3.node1.getLayout()[t3];
        });
      }), yt(o, function(c3) {
        var p3 = 0, g3 = 0;
        yt(c3.outEdges, function(b3) {
          b3.setLayout({ sy: p3 }, true), p3 += b3.getLayout().dy;
        }), yt(c3.inEdges, function(b3) {
          b3.setLayout({ ty: g3 }, true), g3 += b3.getLayout().dy;
        });
      });
    }
    function qMt(o) {
      o.eachSeriesByType("sankey", function(i) {
        var t3 = i.getGraph(), c3 = t3.nodes;
        if (c3.length) {
          var p3 = 1 / 0, g3 = -1 / 0;
          yt(c3, function(b3) {
            var w3 = b3.getLayout().value;
            w3 < p3 && (p3 = w3), w3 > g3 && (g3 = w3);
          }), yt(c3, function(b3) {
            var w3 = new wy({ type: "color", mappingMethod: "linear", dataExtent: [p3, g3], visual: i.get("color") }), M = w3.mapValueToVisual(b3.getLayout().value), I = b3.getModel().get(["itemStyle", "color"]);
            I != null ? (b3.setVisual("color", I), b3.setVisual("style", { fill: I })) : (b3.setVisual("color", M), b3.setVisual("style", { fill: M }));
          });
        }
      });
    }
    function $Mt(o) {
      o.registerChartView(MMt), o.registerSeriesModel(AMt), o.registerLayout(IMt), o.registerVisual(qMt), o.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(i, t3) {
        t3.eachComponent({ mainType: "series", subType: "sankey", query: i }, function(c3) {
          c3.setNodePosition(i.dataIndex, [i.localX, i.localY]);
        });
      });
    }
    var p9e = function() {
      function o() {
      }
      return o.prototype.getInitialData = function(i, t3) {
        var c3, p3 = t3.getComponent("xAxis", this.get("xAxisIndex")), g3 = t3.getComponent("yAxis", this.get("yAxisIndex")), b3 = p3.get("type"), w3 = g3.get("type"), M;
        b3 === "category" ? (i.layout = "horizontal", c3 = p3.getOrdinalMeta(), M = true) : w3 === "category" ? (i.layout = "vertical", c3 = g3.getOrdinalMeta(), M = true) : i.layout = i.layout || "horizontal";
        var I = ["x", "y"], k3 = i.layout === "horizontal" ? 0 : 1, L = this._baseAxisDim = I[k3], F = I[1 - k3], B = [p3, g3], G = B[k3].get("type"), J = B[1 - k3].get("type"), Q = i.data;
        if (Q && M) {
          var se = [];
          yt(Q, function(de, Fe) {
            var Pe;
            Ei(de) ? (Pe = de.slice(), de.unshift(Fe)) : Ei(de.value) ? (Pe = ti({}, de), Pe.value = Pe.value.slice(), de.value.unshift(Fe)) : Pe = de, se.push(Pe);
          }), i.data = se;
        }
        var he = this.defaultValueDimensions, be = [{ name: L, type: Nte(G), ordinalMeta: c3, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: F, type: Nte(J), dimsDef: he.slice() }];
        return N8(this, { coordDimensions: be, dimensionsCount: he.length + 1, encodeDefaulter: As(SLe, be, this) });
      }, o.prototype.getBaseAxis = function() {
        var i = this._baseAxisDim;
        return this.ecModel.getComponent(i + "Axis", this.get(i + "AxisIndex")).axis;
      }, o;
    }(), d9e = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], t3.visualDrawType = "stroke", t3;
      }
      return i.type = "series.boxplot", i.dependencies = ["xAxis", "yAxis", "grid"], i.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, i;
    }(bp);
    Kp(d9e, p9e, true);
    var XMt = d9e, YMt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this.group, w3 = this._data;
        this._data || b3.removeAll();
        var M = t3.get("layout") === "horizontal" ? 1 : 0;
        g3.diff(w3).add(function(I) {
          if (g3.hasValue(I)) {
            var k3 = g3.getItemLayout(I), L = v9e(k3, g3, I, M, true);
            g3.setItemGraphicEl(I, L), b3.add(L);
          }
        }).update(function(I, k3) {
          var L = w3.getItemGraphicEl(k3);
          if (!g3.hasValue(I)) {
            b3.remove(L);
            return;
          }
          var F = g3.getItemLayout(I);
          L ? (P_(L), g9e(F, L, g3, I)) : L = v9e(F, g3, I, M), b3.add(L), g3.setItemGraphicEl(I, L);
        }).remove(function(I) {
          var k3 = w3.getItemGraphicEl(I);
          k3 && b3.remove(k3);
        }).execute(), this._data = g3;
      }, i.prototype.remove = function(t3) {
        var c3 = this.group, p3 = this._data;
        this._data = null, p3 && p3.eachItemGraphicEl(function(g3) {
          g3 && c3.remove(g3);
        });
      }, i.type = "boxplot", i;
    }(yh), KMt = function() {
      function o() {
      }
      return o;
    }(), ZMt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "boxplotBoxPath", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new KMt();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.points, g3 = 0;
        for (t3.moveTo(p3[g3][0], p3[g3][1]), g3++; g3 < 4; g3++)
          t3.lineTo(p3[g3][0], p3[g3][1]);
        for (t3.closePath(); g3 < p3.length; g3++)
          t3.moveTo(p3[g3][0], p3[g3][1]), g3++, t3.lineTo(p3[g3][0], p3[g3][1]);
      }, i;
    }(gl);
    function v9e(o, i, t3, c3, p3) {
      var g3 = o.ends, b3 = new ZMt({ shape: { points: p3 ? JMt(g3, c3, o) : g3 } });
      return g9e(o, b3, i, t3, p3), b3;
    }
    function g9e(o, i, t3, c3, p3) {
      var g3 = t3.hostModel, b3 = SH[p3 ? "initProps" : "updateProps"];
      b3(i, { shape: { points: o.ends } }, g3, c3), i.useStyle(t3.getItemVisual(c3, "style")), i.style.strokeNoScale = true, i.z2 = 100;
      var w3 = t3.getItemModel(c3), M = w3.getModel("emphasis");
      cv(i, w3), zp(i, M.get("focus"), M.get("blurScope"), M.get("disabled"));
    }
    function JMt(o, i, t3) {
      return Fi(o, function(c3) {
        return c3 = c3.slice(), c3[i] = t3.initBaseline, c3;
      });
    }
    var QMt = YMt;
    function eTt(o, i) {
    }
    var EW = yt;
    function tTt(o) {
      var i = nTt(o);
      EW(i, function(t3) {
        var c3 = t3.seriesModels;
        !c3.length || (rTt(t3), EW(c3, function(p3, g3) {
          iTt(p3, t3.boxOffsetList[g3], t3.boxWidthList[g3]);
        }));
      });
    }
    function nTt(o) {
      var i = [], t3 = [];
      return o.eachSeriesByType("boxplot", function(c3) {
        var p3 = c3.getBaseAxis(), g3 = rl(t3, p3);
        g3 < 0 && (g3 = t3.length, t3[g3] = p3, i[g3] = { axis: p3, seriesModels: [] }), i[g3].seriesModels.push(c3);
      }), i;
    }
    function rTt(o) {
      var i = o.axis, t3 = o.seriesModels, c3 = t3.length, p3 = o.boxWidthList = [], g3 = o.boxOffsetList = [], b3 = [], w3;
      if (i.type === "category")
        w3 = i.getBandWidth();
      else {
        var M = 0;
        EW(t3, function(G) {
          M = Math.max(M, G.getData().count());
        });
        var I = i.getExtent();
        w3 = Math.abs(I[1] - I[0]) / M;
      }
      EW(t3, function(G) {
        var J = G.get("boxWidth");
        Ei(J) || (J = [J, J]), b3.push([Da(J[0], w3) || 0, Da(J[1], w3) || 0]);
      });
      var k3 = w3 * 0.8 - 2, L = k3 / c3 * 0.3, F = (k3 - L * (c3 - 1)) / c3, B = F / 2 - k3 / 2;
      EW(t3, function(G, J) {
        g3.push(B), B += L + F, p3.push(Math.min(Math.max(F, b3[J][0]), b3[J][1]));
      });
    }
    function iTt(o, i, t3) {
      var c3 = o.coordinateSystem, p3 = o.getData(), g3 = t3 / 2, b3 = o.get("layout") === "horizontal" ? 0 : 1, w3 = 1 - b3, M = ["x", "y"], I = p3.mapDimension(M[b3]), k3 = p3.mapDimensionsAll(M[w3]);
      if (I == null || k3.length < 5)
        return;
      for (var L = 0; L < p3.count(); L++) {
        var F = p3.get(I, L), B = be(F, k3[2], L), G = be(F, k3[0], L), J = be(F, k3[1], L), Q = be(F, k3[3], L), se = be(F, k3[4], L), he = [];
        de(he, J, false), de(he, Q, true), he.push(G, J, se, Q), Fe(he, G), Fe(he, se), Fe(he, B), p3.setItemLayout(L, { initBaseline: B[w3], ends: he });
      }
      function be(Pe, ze, $e) {
        var Ke = p3.get(ze, $e), nt = [];
        nt[b3] = Pe, nt[w3] = Ke;
        var lt2;
        return isNaN(Pe) || isNaN(Ke) ? lt2 = [NaN, NaN] : (lt2 = c3.dataToPoint(nt), lt2[b3] += i), lt2;
      }
      function de(Pe, ze, $e) {
        var Ke = ze.slice(), nt = ze.slice();
        Ke[b3] += g3, nt[b3] -= g3, $e ? Pe.push(Ke, nt) : Pe.push(nt, Ke);
      }
      function Fe(Pe, ze) {
        var $e = ze.slice(), Ke = ze.slice();
        $e[b3] -= g3, Ke[b3] += g3, Pe.push($e, Ke);
      }
    }
    function aTt(o, i) {
      i = i || {};
      for (var t3 = [], c3 = [], p3 = i.boundIQR, g3 = p3 === "none" || p3 === 0, b3 = 0; b3 < o.length; b3++) {
        var w3 = dy(o[b3].slice()), M = LF(w3, 0.25), I = LF(w3, 0.5), k3 = LF(w3, 0.75), L = w3[0], F = w3[w3.length - 1], B = (p3 == null ? 1.5 : p3) * (k3 - M), G = g3 ? L : Math.max(L, M - B), J = g3 ? F : Math.min(F, k3 + B), Q = i.itemNameFormatter, se = Vo(Q) ? Q({ value: b3 }) : Ha(Q) ? Q.replace("{value}", b3 + "") : b3 + "";
        t3.push([se, G, M, I, k3, J]);
        for (var he = 0; he < w3.length; he++) {
          var be = w3[he];
          if (be < G || be > J) {
            var de = [se, be];
            c3.push(de);
          }
        }
      }
      return { boxData: t3, outliers: c3 };
    }
    var oTt = { type: "echarts:boxplot", transform: function(o) {
      var i = o.upstream;
      if (i.sourceFormat !== Cm) {
        var t3 = "";
        Fu(t3);
      }
      var c3 = aTt(i.getRawData(), o.config);
      return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: c3.boxData }, { data: c3.outliers }];
    } };
    function sTt(o) {
      o.registerSeriesModel(XMt), o.registerChartView(QMt), o.registerVisual(eTt), o.registerLayout(tTt), o.registerTransform(oTt);
    }
    var lTt = ["color", "borderColor"], uTt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(t3), this._isLargeDraw ? this._renderLarge(t3) : this._renderNormal(t3);
      }, i.prototype.incrementalPrepareRender = function(t3, c3, p3) {
        this._clear(), this._updateDrawMode(t3);
      }, i.prototype.incrementalRender = function(t3, c3, p3, g3) {
        this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(t3, c3) : this._incrementalRenderNormal(t3, c3);
      }, i.prototype.eachRendered = function(t3) {
        nk(this._progressiveEls || this.group, t3);
      }, i.prototype._updateDrawMode = function(t3) {
        var c3 = t3.pipelineContext.large;
        (this._isLargeDraw == null || c3 !== this._isLargeDraw) && (this._isLargeDraw = c3, this._clear());
      }, i.prototype._renderNormal = function(t3) {
        var c3 = t3.getData(), p3 = this._data, g3 = this.group, b3 = c3.getLayout("isSimpleBox"), w3 = t3.get("clip", true), M = t3.coordinateSystem, I = M.getArea && M.getArea();
        this._data || g3.removeAll(), c3.diff(p3).add(function(k3) {
          if (c3.hasValue(k3)) {
            var L = c3.getItemLayout(k3);
            if (w3 && y9e(I, L))
              return;
            var F = eme(L, k3, true);
            Uh(F, { shape: { points: L.ends } }, t3, k3), tme(F, c3, k3, b3), g3.add(F), c3.setItemGraphicEl(k3, F);
          }
        }).update(function(k3, L) {
          var F = p3.getItemGraphicEl(L);
          if (!c3.hasValue(k3)) {
            g3.remove(F);
            return;
          }
          var B = c3.getItemLayout(k3);
          if (w3 && y9e(I, B)) {
            g3.remove(F);
            return;
          }
          F ? (Du(F, { shape: { points: B.ends } }, t3, k3), P_(F)) : F = eme(B), tme(F, c3, k3, b3), g3.add(F), c3.setItemGraphicEl(k3, F);
        }).remove(function(k3) {
          var L = p3.getItemGraphicEl(k3);
          L && g3.remove(L);
        }).execute(), this._data = c3;
      }, i.prototype._renderLarge = function(t3) {
        this._clear(), b9e(t3, this.group);
        var c3 = t3.get("clip", true) ? nne(t3.coordinateSystem, false, t3) : null;
        c3 ? this.group.setClipPath(c3) : this.group.removeClipPath();
      }, i.prototype._incrementalRenderNormal = function(t3, c3) {
        for (var p3 = c3.getData(), g3 = p3.getLayout("isSimpleBox"), b3; (b3 = t3.next()) != null; ) {
          var w3 = p3.getItemLayout(b3), M = eme(w3);
          tme(M, p3, b3, g3), M.incremental = true, this.group.add(M), this._progressiveEls.push(M);
        }
      }, i.prototype._incrementalRenderLarge = function(t3, c3) {
        b9e(c3, this.group, this._progressiveEls, true);
      }, i.prototype.remove = function(t3) {
        this._clear();
      }, i.prototype._clear = function() {
        this.group.removeAll(), this._data = null;
      }, i.type = "candlestick", i;
    }(yh), cTt = function() {
      function o() {
      }
      return o;
    }(), fTt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "normalCandlestickBox", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new cTt();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.points;
        this.__simpleBox ? (t3.moveTo(p3[4][0], p3[4][1]), t3.lineTo(p3[6][0], p3[6][1])) : (t3.moveTo(p3[0][0], p3[0][1]), t3.lineTo(p3[1][0], p3[1][1]), t3.lineTo(p3[2][0], p3[2][1]), t3.lineTo(p3[3][0], p3[3][1]), t3.closePath(), t3.moveTo(p3[4][0], p3[4][1]), t3.lineTo(p3[5][0], p3[5][1]), t3.moveTo(p3[6][0], p3[6][1]), t3.lineTo(p3[7][0], p3[7][1]));
      }, i;
    }(gl);
    function eme(o, i, t3) {
      var c3 = o.ends;
      return new fTt({ shape: { points: t3 ? hTt(c3, o) : c3 }, z2: 100 });
    }
    function y9e(o, i) {
      for (var t3 = true, c3 = 0; c3 < i.ends.length; c3++)
        if (o.contain(i.ends[c3][0], i.ends[c3][1])) {
          t3 = false;
          break;
        }
      return t3;
    }
    function tme(o, i, t3, c3) {
      var p3 = i.getItemModel(t3);
      o.useStyle(i.getItemVisual(t3, "style")), o.style.strokeNoScale = true, o.__simpleBox = c3, cv(o, p3);
    }
    function hTt(o, i) {
      return Fi(o, function(t3) {
        return t3 = t3.slice(), t3[1] = i.initBaseline, t3;
      });
    }
    var pTt = function() {
      function o() {
      }
      return o;
    }(), m9e = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3.type = "largeCandlestickBox", c3;
      }
      return i.prototype.getDefaultShape = function() {
        return new pTt();
      }, i.prototype.buildPath = function(t3, c3) {
        for (var p3 = c3.points, g3 = 0; g3 < p3.length; )
          if (this.__sign === p3[g3++]) {
            var b3 = p3[g3++];
            t3.moveTo(b3, p3[g3++]), t3.lineTo(b3, p3[g3++]);
          } else
            g3 += 3;
      }, i;
    }(gl);
    function b9e(o, i, t3, c3) {
      var p3 = o.getData(), g3 = p3.getLayout("largePoints"), b3 = new m9e({ shape: { points: g3 }, __sign: 1 });
      i.add(b3);
      var w3 = new m9e({ shape: { points: g3 }, __sign: -1 });
      i.add(w3), _9e(1, b3, o), _9e(-1, w3, o), c3 && (b3.incremental = true, w3.incremental = true), t3 && t3.push(b3, w3);
    }
    function _9e(o, i, t3, c3) {
      var p3 = t3.get(["itemStyle", o > 0 ? "borderColor" : "borderColor0"]) || t3.get(["itemStyle", o > 0 ? "color" : "color0"]), g3 = t3.getModel("itemStyle").getItemStyle(lTt);
      i.useStyle(g3), i.style.fill = null, i.style.stroke = p3;
    }
    var dTt = uTt, x9e = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], t3;
      }
      return i.prototype.getShadowDim = function() {
        return "open";
      }, i.prototype.brushSelector = function(t3, c3, p3) {
        var g3 = c3.getItemLayout(t3);
        return g3 && p3.rect(g3.brushRect);
      }, i.type = "series.candlestick", i.dependencies = ["xAxis", "yAxis", "grid"], i.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, i;
    }(bp);
    Kp(x9e, p9e, true);
    var vTt = x9e;
    function gTt(o) {
      !o || !Ei(o.series) || yt(o.series, function(i) {
        Ua(i) && i.type === "k" && (i.type = "candlestick");
      });
    }
    var yTt = ["itemStyle", "borderColor"], mTt = ["itemStyle", "borderColor0"], bTt = ["itemStyle", "color"], _Tt = ["itemStyle", "color0"], xTt = { seriesType: "candlestick", plan: C8(), performRawSeries: true, reset: function(o, i) {
      function t3(g3, b3) {
        return b3.get(g3 > 0 ? bTt : _Tt);
      }
      function c3(g3, b3) {
        return b3.get(g3 > 0 ? yTt : mTt);
      }
      if (!i.isSeriesFiltered(o)) {
        var p3 = o.pipelineContext.large;
        return !p3 && { progress: function(g3, b3) {
          for (var w3; (w3 = g3.next()) != null; ) {
            var M = b3.getItemModel(w3), I = b3.getItemLayout(w3).sign, k3 = M.getItemStyle();
            k3.fill = t3(I, M), k3.stroke = c3(I, M) || k3.fill;
            var L = b3.ensureUniqueItemVisual(w3, "style");
            ti(L, k3);
          }
        } };
      }
    } }, wTt = xTt, STt = { seriesType: "candlestick", plan: C8(), reset: function(o) {
      var i = o.coordinateSystem, t3 = o.getData(), c3 = CTt(o, t3), p3 = 0, g3 = 1, b3 = ["x", "y"], w3 = t3.getDimensionIndex(t3.mapDimension(b3[p3])), M = Fi(t3.mapDimensionsAll(b3[g3]), t3.getDimensionIndex, t3), I = M[0], k3 = M[1], L = M[2], F = M[3];
      if (t3.setLayout({ candleWidth: c3, isSimpleBox: c3 <= 1.3 }), w3 < 0 || M.length < 4)
        return;
      return { progress: o.pipelineContext.large ? G : B };
      function B(J, Q) {
        for (var se, he = Q.getStore(); (se = J.next()) != null; ) {
          var be = he.get(w3, se), de = he.get(I, se), Fe = he.get(k3, se), Pe = he.get(L, se), ze = he.get(F, se), $e = Math.min(de, Fe), Ke = Math.max(de, Fe), nt = Jt($e, be), lt2 = Jt(Ke, be), bt = Jt(Pe, be), vt = Jt(ze, be), jt = [];
          Rt(jt, lt2, 0), Rt(jt, nt, 1), jt.push(ln(vt), ln(lt2), ln(bt), ln(nt)), Q.setItemLayout(se, { sign: w9e(he, se, de, Fe, k3), initBaseline: de > Fe ? lt2[g3] : nt[g3], ends: jt, brushRect: Jn(Pe, ze, be) });
        }
        function Jt(vn, kn) {
          var cr = [];
          return cr[p3] = kn, cr[g3] = vn, isNaN(kn) || isNaN(vn) ? [NaN, NaN] : i.dataToPoint(cr);
        }
        function Rt(vn, kn, cr) {
          var gr = kn.slice(), ha = kn.slice();
          gr[p3] = gs(gr[p3] + c3 / 2, 1, false), ha[p3] = gs(ha[p3] - c3 / 2, 1, true), cr ? vn.push(gr, ha) : vn.push(ha, gr);
        }
        function Jn(vn, kn, cr) {
          var gr = Jt(vn, cr), ha = Jt(kn, cr);
          return gr[p3] -= c3 / 2, ha[p3] -= c3 / 2, { x: gr[0], y: gr[1], width: c3, height: ha[1] - gr[1] };
        }
        function ln(vn) {
          return vn[p3] = gs(vn[p3], 1), vn;
        }
      }
      function G(J, Q) {
        for (var se = JM(J.count * 4), he = 0, be, de = [], Fe = [], Pe, ze = Q.getStore(); (Pe = J.next()) != null; ) {
          var $e = ze.get(w3, Pe), Ke = ze.get(I, Pe), nt = ze.get(k3, Pe), lt2 = ze.get(L, Pe), bt = ze.get(F, Pe);
          if (isNaN($e) || isNaN(lt2) || isNaN(bt)) {
            se[he++] = NaN, he += 3;
            continue;
          }
          se[he++] = w9e(ze, Pe, Ke, nt, k3), de[p3] = $e, de[g3] = lt2, be = i.dataToPoint(de, null, Fe), se[he++] = be ? be[0] : NaN, se[he++] = be ? be[1] : NaN, de[g3] = bt, be = i.dataToPoint(de, null, Fe), se[he++] = be ? be[1] : NaN;
        }
        Q.setLayout("largePoints", se);
      }
    } };
    function w9e(o, i, t3, c3, p3) {
      var g3;
      return t3 > c3 ? g3 = -1 : t3 < c3 ? g3 = 1 : g3 = i > 0 ? o.get(p3, i - 1) <= c3 ? 1 : -1 : 1, g3;
    }
    function CTt(o, i) {
      var t3 = o.getBaseAxis(), c3, p3 = t3.type === "category" ? t3.getBandWidth() : (c3 = t3.getExtent(), Math.abs(c3[1] - c3[0]) / i.count()), g3 = Da(Xs(o.get("barMaxWidth"), p3), p3), b3 = Da(Xs(o.get("barMinWidth"), 1), p3), w3 = o.get("barWidth");
      return w3 != null ? Da(w3, p3) : Math.max(Math.min(p3 / 2, g3), b3);
    }
    var MTt = STt;
    function TTt(o) {
      o.registerChartView(dTt), o.registerSeriesModel(vTt), o.registerPreprocessor(gTt), o.registerVisual(wTt), o.registerLayout(MTt);
    }
    function S9e(o, i) {
      var t3 = i.rippleEffectColor || i.color;
      o.eachChild(function(c3) {
        c3.attr({ z: i.z, zlevel: i.zlevel, style: { stroke: i.brushType === "stroke" ? t3 : null, fill: i.brushType === "fill" ? t3 : null } });
      });
    }
    var ATt = function(o) {
      cn(i, o);
      function i(t3, c3) {
        var p3 = o.call(this) || this, g3 = new sW(t3, c3), b3 = new vs();
        return p3.add(g3), p3.add(b3), p3.updateData(t3, c3), p3;
      }
      return i.prototype.stopEffectAnimation = function() {
        this.childAt(1).removeAll();
      }, i.prototype.startEffectAnimation = function(t3) {
        for (var c3 = t3.symbolType, p3 = t3.color, g3 = t3.rippleNumber, b3 = this.childAt(1), w3 = 0; w3 < g3; w3++) {
          var M = pv(c3, -1, -1, 2, 2, p3);
          M.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
          var I = -w3 / g3 * t3.period + t3.effectOffset;
          M.animate("", true).when(t3.period, { scaleX: t3.rippleScale / 2, scaleY: t3.rippleScale / 2 }).delay(I).start(), M.animateStyle(true).when(t3.period, { opacity: 0 }).delay(I).start(), b3.add(M);
        }
        S9e(b3, t3);
      }, i.prototype.updateEffectAnimation = function(t3) {
        for (var c3 = this._effectCfg, p3 = this.childAt(1), g3 = ["symbolType", "period", "rippleScale", "rippleNumber"], b3 = 0; b3 < g3.length; b3++) {
          var w3 = g3[b3];
          if (c3[w3] !== t3[w3]) {
            this.stopEffectAnimation(), this.startEffectAnimation(t3);
            return;
          }
        }
        S9e(p3, t3);
      }, i.prototype.highlight = function() {
        Hv(this);
      }, i.prototype.downplay = function() {
        sl(this);
      }, i.prototype.getSymbolType = function() {
        var t3 = this.childAt(0);
        return t3 && t3.getSymbolType();
      }, i.prototype.updateData = function(t3, c3) {
        var p3 = this, g3 = t3.hostModel;
        this.childAt(0).updateData(t3, c3);
        var b3 = this.childAt(1), w3 = t3.getItemModel(c3), M = t3.getItemVisual(c3, "symbol"), I = zH(t3.getItemVisual(c3, "symbolSize")), k3 = t3.getItemVisual(c3, "style"), L = k3 && k3.fill, F = w3.getModel("emphasis");
        b3.setScale(I), b3.traverse(function(Q) {
          Q.setStyle("fill", L);
        });
        var B = I8(t3.getItemVisual(c3, "symbolOffset"), I);
        B && (b3.x = B[0], b3.y = B[1]);
        var G = t3.getItemVisual(c3, "symbolRotate");
        b3.rotation = (G || 0) * Math.PI / 180 || 0;
        var J = {};
        J.showEffectOn = g3.get("showEffectOn"), J.rippleScale = w3.get(["rippleEffect", "scale"]), J.brushType = w3.get(["rippleEffect", "brushType"]), J.period = w3.get(["rippleEffect", "period"]) * 1e3, J.effectOffset = c3 / t3.count(), J.z = g3.getShallow("z") || 0, J.zlevel = g3.getShallow("zlevel") || 0, J.symbolType = M, J.color = L, J.rippleEffectColor = w3.get(["rippleEffect", "color"]), J.rippleNumber = w3.get(["rippleEffect", "number"]), J.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(J) : this.startEffectAnimation(J), this._effectCfg = J) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(Q) {
          Q === "emphasis" ? J.showEffectOn !== "render" && p3.startEffectAnimation(J) : Q === "normal" && J.showEffectOn !== "render" && p3.stopEffectAnimation();
        }), this._effectCfg = J, zp(this, F.get("focus"), F.get("blurScope"), F.get("disabled"));
      }, i.prototype.fadeOut = function(t3) {
        t3 && t3();
      }, i;
    }(vs), ITt = ATt, ETt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function() {
        this._symbolDraw = new lW(ITt);
      }, i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this._symbolDraw;
        b3.updateData(g3, { clipShape: this._getClipShape(t3) }), this.group.add(b3.group);
      }, i.prototype._getClipShape = function(t3) {
        var c3 = t3.coordinateSystem, p3 = c3 && c3.getArea && c3.getArea();
        return t3.get("clip", true) ? p3 : null;
      }, i.prototype.updateTransform = function(t3, c3, p3) {
        var g3 = t3.getData();
        this.group.dirty();
        var b3 = uW("").reset(t3, c3, p3);
        b3.progress && b3.progress({ start: 0, end: g3.count(), count: g3.count() }, g3), this._symbolDraw.updateLayout();
      }, i.prototype._updateGroupTransform = function(t3) {
        var c3 = t3.coordinateSystem;
        c3 && c3.getRoamTransform && (this.group.transform = gde(c3.getRoamTransform()), this.group.decomposeTransform());
      }, i.prototype.remove = function(t3, c3) {
        this._symbolDraw && this._symbolDraw.remove(true);
      }, i.type = "effectScatter", i;
    }(yh), DTt = ETt, kTt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.hasSymbolVisual = true, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        return NI(null, this, { useEncodeDefaulter: true });
      }, i.prototype.brushSelector = function(t3, c3, p3) {
        return p3.point(c3.getItemLayout(t3));
      }, i.type = "series.effectScatter", i.dependencies = ["grid", "polar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, i;
    }(bp), OTt = kTt;
    function PTt(o) {
      o.registerChartView(DTt), o.registerSeriesModel(OTt), o.registerLayout(uW("effectScatter"));
    }
    var LTt = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this) || this;
        return g3.add(g3.createLine(t3, c3, p3)), g3._updateEffectSymbol(t3, c3), g3;
      }
      return i.prototype.createLine = function(t3, c3, p3) {
        return new Iye(t3, c3, p3);
      }, i.prototype._updateEffectSymbol = function(t3, c3) {
        var p3 = t3.getItemModel(c3), g3 = p3.getModel("effect"), b3 = g3.get("symbolSize"), w3 = g3.get("symbol");
        Ei(b3) || (b3 = [b3, b3]);
        var M = t3.getItemVisual(c3, "style"), I = g3.get("color") || M && M.stroke, k3 = this.childAt(1);
        this._symbolType !== w3 && (this.remove(k3), k3 = pv(w3, -0.5, -0.5, 1, 1, I), k3.z2 = 100, k3.culling = true, this.add(k3)), k3 && (k3.setStyle("shadowColor", I), k3.setStyle(g3.getItemStyle(["color"])), k3.scaleX = b3[0], k3.scaleY = b3[1], k3.setColor(I), this._symbolType = w3, this._symbolScale = b3, this._updateEffectAnimation(t3, g3, c3));
      }, i.prototype._updateEffectAnimation = function(t3, c3, p3) {
        var g3 = this.childAt(1);
        if (g3) {
          var b3 = t3.getItemLayout(p3), w3 = c3.get("period") * 1e3, M = c3.get("loop"), I = c3.get("constantSpeed"), k3 = lv(c3.get("delay"), function(F) {
            return F / t3.count() * w3 / 3;
          });
          if (g3.ignore = true, this._updateAnimationPoints(g3, b3), I > 0 && (w3 = this._getLineLength(g3) / I * 1e3), w3 !== this._period || M !== this._loop) {
            g3.stopAnimation();
            var L = void 0;
            Vo(k3) ? L = k3(p3) : L = k3, g3.__t > 0 && (L = -w3 * g3.__t), this._animateSymbol(g3, w3, L, M);
          }
          this._period = w3, this._loop = M;
        }
      }, i.prototype._animateSymbol = function(t3, c3, p3, g3) {
        if (c3 > 0) {
          t3.__t = 0;
          var b3 = this, w3 = t3.animate("", g3).when(c3, { __t: 1 }).delay(p3).during(function() {
            b3._updateSymbolPosition(t3);
          });
          g3 || w3.done(function() {
            b3.remove(t3);
          }), w3.start();
        }
      }, i.prototype._getLineLength = function(t3) {
        return P2(t3.__p1, t3.__cp1) + P2(t3.__cp1, t3.__p2);
      }, i.prototype._updateAnimationPoints = function(t3, c3) {
        t3.__p1 = c3[0], t3.__p2 = c3[1], t3.__cp1 = c3[2] || [(c3[0][0] + c3[1][0]) / 2, (c3[0][1] + c3[1][1]) / 2];
      }, i.prototype.updateData = function(t3, c3, p3) {
        this.childAt(0).updateData(t3, c3, p3), this._updateEffectSymbol(t3, c3);
      }, i.prototype._updateSymbolPosition = function(t3) {
        var c3 = t3.__p1, p3 = t3.__p2, g3 = t3.__cp1, b3 = t3.__t, w3 = [t3.x, t3.y], M = w3.slice(), I = Dc, k3 = Bv;
        w3[0] = I(c3[0], g3[0], p3[0], b3), w3[1] = I(c3[1], g3[1], p3[1], b3);
        var L = k3(c3[0], g3[0], p3[0], b3), F = k3(c3[1], g3[1], p3[1], b3);
        t3.rotation = -Math.atan2(F, L) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (t3.__lastT !== void 0 && t3.__lastT < t3.__t ? (t3.scaleY = P2(M, w3) * 1.05, b3 === 1 && (w3[0] = M[0] + (w3[0] - M[0]) / 2, w3[1] = M[1] + (w3[1] - M[1]) / 2)) : t3.__lastT === 1 ? t3.scaleY = 2 * P2(c3, w3) : t3.scaleY = this._symbolScale[1]), t3.__lastT = t3.__t, t3.ignore = false, t3.x = w3[0], t3.y = w3[1];
      }, i.prototype.updateLayout = function(t3, c3) {
        this.childAt(0).updateLayout(t3, c3);
        var p3 = t3.getItemModel(c3).getModel("effect");
        this._updateEffectAnimation(t3, p3, c3);
      }, i;
    }(vs), C9e = LTt, RTt = function(o) {
      cn(i, o);
      function i(t3, c3, p3) {
        var g3 = o.call(this) || this;
        return g3._createPolyline(t3, c3, p3), g3;
      }
      return i.prototype._createPolyline = function(t3, c3, p3) {
        var g3 = t3.getItemLayout(c3), b3 = new xm({ shape: { points: g3 } });
        this.add(b3), this._updateCommonStl(t3, c3, p3);
      }, i.prototype.updateData = function(t3, c3, p3) {
        var g3 = t3.hostModel, b3 = this.childAt(0), w3 = { shape: { points: t3.getItemLayout(c3) } };
        Du(b3, w3, g3, c3), this._updateCommonStl(t3, c3, p3);
      }, i.prototype._updateCommonStl = function(t3, c3, p3) {
        var g3 = this.childAt(0), b3 = t3.getItemModel(c3), w3 = p3 && p3.emphasisLineStyle, M = p3 && p3.focus, I = p3 && p3.blurScope, k3 = p3 && p3.emphasisDisabled;
        if (!p3 || t3.hasItemOption) {
          var L = b3.getModel("emphasis");
          w3 = L.getModel("lineStyle").getLineStyle(), k3 = L.get("disabled"), M = L.get("focus"), I = L.get("blurScope");
        }
        g3.useStyle(t3.getItemVisual(c3, "style")), g3.style.fill = null, g3.style.strokeNoScale = true;
        var F = g3.ensureState("emphasis");
        F.style = w3, zp(this, M, I, k3);
      }, i.prototype.updateLayout = function(t3, c3) {
        var p3 = this.childAt(0);
        p3.setShape("points", t3.getItemLayout(c3));
      }, i;
    }(vs), M9e = RTt, NTt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3._lastFrame = 0, t3._lastFramePercent = 0, t3;
      }
      return i.prototype.createLine = function(t3, c3, p3) {
        return new M9e(t3, c3, p3);
      }, i.prototype._updateAnimationPoints = function(t3, c3) {
        this._points = c3;
        for (var p3 = [0], g3 = 0, b3 = 1; b3 < c3.length; b3++) {
          var w3 = c3[b3 - 1], M = c3[b3];
          g3 += P2(w3, M), p3.push(g3);
        }
        if (g3 === 0) {
          this._length = 0;
          return;
        }
        for (var b3 = 0; b3 < p3.length; b3++)
          p3[b3] /= g3;
        this._offsets = p3, this._length = g3;
      }, i.prototype._getLineLength = function() {
        return this._length;
      }, i.prototype._updateSymbolPosition = function(t3) {
        var c3 = t3.__t, p3 = this._points, g3 = this._offsets, b3 = p3.length;
        if (g3) {
          var w3 = this._lastFrame, M;
          if (c3 < this._lastFramePercent) {
            var I = Math.min(w3 + 1, b3 - 1);
            for (M = I; M >= 0 && !(g3[M] <= c3); M--)
              ;
            M = Math.min(M, b3 - 2);
          } else {
            for (M = w3; M < b3 && !(g3[M] > c3); M++)
              ;
            M = Math.min(M - 1, b3 - 2);
          }
          var k3 = (c3 - g3[M]) / (g3[M + 1] - g3[M]), L = p3[M], F = p3[M + 1];
          t3.x = L[0] * (1 - k3) + k3 * F[0], t3.y = L[1] * (1 - k3) + k3 * F[1];
          var B = F[0] - L[0], G = F[1] - L[1];
          t3.rotation = -Math.atan2(G, B) - Math.PI / 2, this._lastFrame = M, this._lastFramePercent = c3, t3.ignore = false;
        }
      }, i;
    }(C9e), FTt = NTt, VTt = function() {
      function o() {
        this.polyline = false, this.curveness = 0, this.segs = [];
      }
      return o;
    }(), BTt = function(o) {
      cn(i, o);
      function i(t3) {
        var c3 = o.call(this, t3) || this;
        return c3._off = 0, c3.hoverDataIdx = -1, c3;
      }
      return i.prototype.reset = function() {
        this.notClear = false, this._off = 0;
      }, i.prototype.getDefaultStyle = function() {
        return { stroke: "#000", fill: null };
      }, i.prototype.getDefaultShape = function() {
        return new VTt();
      }, i.prototype.buildPath = function(t3, c3) {
        var p3 = c3.segs, g3 = c3.curveness, b3;
        if (c3.polyline)
          for (b3 = this._off; b3 < p3.length; ) {
            var w3 = p3[b3++];
            if (w3 > 0) {
              t3.moveTo(p3[b3++], p3[b3++]);
              for (var M = 1; M < w3; M++)
                t3.lineTo(p3[b3++], p3[b3++]);
            }
          }
        else
          for (b3 = this._off; b3 < p3.length; ) {
            var I = p3[b3++], k3 = p3[b3++], L = p3[b3++], F = p3[b3++];
            if (t3.moveTo(I, k3), g3 > 0) {
              var B = (I + L) / 2 - (k3 - F) * g3, G = (k3 + F) / 2 - (L - I) * g3;
              t3.quadraticCurveTo(B, G, L, F);
            } else
              t3.lineTo(L, F);
          }
        this.incremental && (this._off = b3, this.notClear = true);
      }, i.prototype.findDataIndex = function(t3, c3) {
        var p3 = this.shape, g3 = p3.segs, b3 = p3.curveness, w3 = this.style.lineWidth;
        if (p3.polyline)
          for (var M = 0, I = 0; I < g3.length; ) {
            var k3 = g3[I++];
            if (k3 > 0)
              for (var L = g3[I++], F = g3[I++], B = 1; B < k3; B++) {
                var G = g3[I++], J = g3[I++];
                if (GM(L, F, G, J, w3, t3, c3))
                  return M;
              }
            M++;
          }
        else
          for (var M = 0, I = 0; I < g3.length; ) {
            var L = g3[I++], F = g3[I++], G = g3[I++], J = g3[I++];
            if (b3 > 0) {
              var Q = (L + G) / 2 - (F - J) * b3, se = (F + J) / 2 - (G - L) * b3;
              if (lee(L, F, Q, se, G, J, w3, t3, c3))
                return M;
            } else if (GM(L, F, G, J, w3, t3, c3))
              return M;
            M++;
          }
        return -1;
      }, i.prototype.contain = function(t3, c3) {
        var p3 = this.transformCoordToLocal(t3, c3), g3 = this.getBoundingRect();
        if (t3 = p3[0], c3 = p3[1], g3.contain(t3, c3)) {
          var b3 = this.hoverDataIdx = this.findDataIndex(t3, c3);
          return b3 >= 0;
        }
        return this.hoverDataIdx = -1, false;
      }, i.prototype.getBoundingRect = function() {
        var t3 = this._rect;
        if (!t3) {
          for (var c3 = this.shape, p3 = c3.segs, g3 = 1 / 0, b3 = 1 / 0, w3 = -1 / 0, M = -1 / 0, I = 0; I < p3.length; ) {
            var k3 = p3[I++], L = p3[I++];
            g3 = Math.min(k3, g3), w3 = Math.max(k3, w3), b3 = Math.min(L, b3), M = Math.max(L, M);
          }
          t3 = this._rect = new Ys(g3, b3, w3, M);
        }
        return t3;
      }, i;
    }(gl), zTt = function() {
      function o() {
        this.group = new vs();
      }
      return o.prototype.updateData = function(i) {
        this._clear();
        var t3 = this._create();
        t3.setShape({ segs: i.getLayout("linesPoints") }), this._setCommon(t3, i);
      }, o.prototype.incrementalPrepareUpdate = function(i) {
        this.group.removeAll(), this._clear();
      }, o.prototype.incrementalUpdate = function(i, t3) {
        var c3 = this._newAdded[0], p3 = t3.getLayout("linesPoints"), g3 = c3 && c3.shape.segs;
        if (g3 && g3.length < 2e4) {
          var b3 = g3.length, w3 = new Float32Array(b3 + p3.length);
          w3.set(g3), w3.set(p3, b3), c3.setShape({ segs: w3 });
        } else {
          this._newAdded = [];
          var M = this._create();
          M.incremental = true, M.setShape({ segs: p3 }), this._setCommon(M, t3), M.__startIndex = i.start;
        }
      }, o.prototype.remove = function() {
        this._clear();
      }, o.prototype.eachRendered = function(i) {
        this._newAdded[0] && i(this._newAdded[0]);
      }, o.prototype._create = function() {
        var i = new BTt({ cursor: "default" });
        return this._newAdded.push(i), this.group.add(i), i;
      }, o.prototype._setCommon = function(i, t3, c3) {
        var p3 = t3.hostModel;
        i.setShape({ polyline: p3.get("polyline"), curveness: p3.get(["lineStyle", "curveness"]) }), i.useStyle(p3.getModel("lineStyle").getLineStyle()), i.style.strokeNoScale = true;
        var g3 = t3.getVisual("style");
        g3 && g3.stroke && i.setStyle("stroke", g3.stroke), i.setStyle("fill", null);
        var b3 = La(i);
        b3.seriesIndex = p3.seriesIndex, i.on("mousemove", function(w3) {
          b3.dataIndex = null;
          var M = i.hoverDataIdx;
          M > 0 && (b3.dataIndex = M + i.__startIndex);
        });
      }, o.prototype._clear = function() {
        this._newAdded = [], this.group.removeAll();
      }, o;
    }(), jTt = zTt, GTt = { seriesType: "lines", plan: C8(), reset: function(o) {
      var i = o.coordinateSystem;
      if (i) {
        var t3 = o.get("polyline"), c3 = o.pipelineContext.large;
        return { progress: function(p3, g3) {
          var b3 = [];
          if (c3) {
            var w3 = void 0, M = p3.end - p3.start;
            if (t3) {
              for (var I = 0, k3 = p3.start; k3 < p3.end; k3++)
                I += o.getLineCoordsCount(k3);
              w3 = new Float32Array(M + I * 2);
            } else
              w3 = new Float32Array(M * 4);
            for (var L = 0, F = [], k3 = p3.start; k3 < p3.end; k3++) {
              var B = o.getLineCoords(k3, b3);
              t3 && (w3[L++] = B);
              for (var G = 0; G < B; G++)
                F = i.dataToPoint(b3[G], false, F), w3[L++] = F[0], w3[L++] = F[1];
            }
            g3.setLayout("linesPoints", w3);
          } else
            for (var k3 = p3.start; k3 < p3.end; k3++) {
              var J = g3.getItemModel(k3), B = o.getLineCoords(k3, b3), Q = [];
              if (t3)
                for (var se = 0; se < B; se++)
                  Q.push(i.dataToPoint(b3[se]));
              else {
                Q[0] = i.dataToPoint(b3[0]), Q[1] = i.dataToPoint(b3[1]);
                var he = J.get(["lineStyle", "curveness"]);
                +he && (Q[2] = [(Q[0][0] + Q[1][0]) / 2 - (Q[0][1] - Q[1][1]) * he, (Q[0][1] + Q[1][1]) / 2 - (Q[1][0] - Q[0][0]) * he]);
              }
              g3.setItemLayout(k3, Q);
            }
        } };
      }
    } }, T9e = GTt, HTt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this._updateLineDraw(g3, t3), w3 = t3.get("zlevel"), M = t3.get(["effect", "trailLength"]), I = p3.getZr(), k3 = I.painter.getType() === "svg";
        k3 || I.painter.getLayer(w3).clear(true), this._lastZlevel != null && !k3 && I.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(t3) && M > 0 && (k3 || I.configLayer(w3, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(M / 10 + 0.9, 1), 0) })), b3.updateData(g3);
        var L = t3.get("clip", true) && nne(t3.coordinateSystem, false, t3);
        L ? this.group.setClipPath(L) : this.group.removeClipPath(), this._lastZlevel = w3, this._finished = true;
      }, i.prototype.incrementalPrepareRender = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this._updateLineDraw(g3, t3);
        b3.incrementalPrepareUpdate(g3), this._clearLayer(p3), this._finished = false;
      }, i.prototype.incrementalRender = function(t3, c3, p3) {
        this._lineDraw.incrementalUpdate(t3, c3.getData()), this._finished = t3.end === c3.getData().count();
      }, i.prototype.eachRendered = function(t3) {
        this._lineDraw && this._lineDraw.eachRendered(t3);
      }, i.prototype.updateTransform = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = t3.pipelineContext;
        if (!this._finished || b3.large || b3.progressiveRender)
          return { update: true };
        var w3 = T9e.reset(t3, c3, p3);
        w3.progress && w3.progress({ start: 0, end: g3.count(), count: g3.count() }, g3), this._lineDraw.updateLayout(), this._clearLayer(p3);
      }, i.prototype._updateLineDraw = function(t3, c3) {
        var p3 = this._lineDraw, g3 = this._showEffect(c3), b3 = !!c3.get("polyline"), w3 = c3.pipelineContext, M = w3.large;
        return (!p3 || g3 !== this._hasEffet || b3 !== this._isPolyline || M !== this._isLargeDraw) && (p3 && p3.remove(), p3 = this._lineDraw = M ? new jTt() : new Dye(b3 ? g3 ? FTt : M9e : g3 ? C9e : Iye), this._hasEffet = g3, this._isPolyline = b3, this._isLargeDraw = M), this.group.add(p3.group), p3;
      }, i.prototype._showEffect = function(t3) {
        return !!t3.get(["effect", "show"]);
      }, i.prototype._clearLayer = function(t3) {
        var c3 = t3.getZr(), p3 = c3.painter.getType() === "svg";
        !p3 && this._lastZlevel != null && c3.painter.getLayer(this._lastZlevel).clear(true);
      }, i.prototype.remove = function(t3, c3) {
        this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(c3);
      }, i.prototype.dispose = function(t3, c3) {
        this.remove(t3, c3);
      }, i.type = "lines", i;
    }(yh), WTt = HTt, UTt = typeof Uint32Array == "undefined" ? Array : Uint32Array, qTt = typeof Float64Array == "undefined" ? Array : Float64Array;
    function A9e(o) {
      var i = o.data;
      i && i[0] && i[0][0] && i[0][0].coord && (o.data = Fi(i, function(t3) {
        var c3 = [t3[0].coord, t3[1].coord], p3 = { coords: c3 };
        return t3[0].name && (p3.fromName = t3[0].name), t3[1].name && (p3.toName = t3[1].name), nF([p3, t3[0], t3[1]]);
      }));
    }
    var $Tt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.visualStyleAccessPath = "lineStyle", t3.visualDrawType = "stroke", t3;
      }
      return i.prototype.init = function(t3) {
        t3.data = t3.data || [], A9e(t3);
        var c3 = this._processFlatCoordsArray(t3.data);
        this._flatCoords = c3.flatCoords, this._flatCoordsOffset = c3.flatCoordsOffset, c3.flatCoords && (t3.data = new Float32Array(c3.count)), o.prototype.init.apply(this, arguments);
      }, i.prototype.mergeOption = function(t3) {
        if (A9e(t3), t3.data) {
          var c3 = this._processFlatCoordsArray(t3.data);
          this._flatCoords = c3.flatCoords, this._flatCoordsOffset = c3.flatCoordsOffset, c3.flatCoords && (t3.data = new Float32Array(c3.count));
        }
        o.prototype.mergeOption.apply(this, arguments);
      }, i.prototype.appendData = function(t3) {
        var c3 = this._processFlatCoordsArray(t3.data);
        c3.flatCoords && (this._flatCoords ? (this._flatCoords = iF(this._flatCoords, c3.flatCoords), this._flatCoordsOffset = iF(this._flatCoordsOffset, c3.flatCoordsOffset)) : (this._flatCoords = c3.flatCoords, this._flatCoordsOffset = c3.flatCoordsOffset), t3.data = new Float32Array(c3.count)), this.getRawData().appendData(t3.data);
      }, i.prototype._getCoordsFromItemModel = function(t3) {
        var c3 = this.getData().getItemModel(t3), p3 = c3.option instanceof Array ? c3.option : c3.getShallow("coords");
        return p3;
      }, i.prototype.getLineCoordsCount = function(t3) {
        return this._flatCoordsOffset ? this._flatCoordsOffset[t3 * 2 + 1] : this._getCoordsFromItemModel(t3).length;
      }, i.prototype.getLineCoords = function(t3, c3) {
        if (this._flatCoordsOffset) {
          for (var p3 = this._flatCoordsOffset[t3 * 2], g3 = this._flatCoordsOffset[t3 * 2 + 1], b3 = 0; b3 < g3; b3++)
            c3[b3] = c3[b3] || [], c3[b3][0] = this._flatCoords[p3 + b3 * 2], c3[b3][1] = this._flatCoords[p3 + b3 * 2 + 1];
          return g3;
        } else {
          for (var w3 = this._getCoordsFromItemModel(t3), b3 = 0; b3 < w3.length; b3++)
            c3[b3] = c3[b3] || [], c3[b3][0] = w3[b3][0], c3[b3][1] = w3[b3][1];
          return w3.length;
        }
      }, i.prototype._processFlatCoordsArray = function(t3) {
        var c3 = 0;
        if (this._flatCoords && (c3 = this._flatCoords.length), ec(t3[0])) {
          for (var p3 = t3.length, g3 = new UTt(p3), b3 = new qTt(p3), w3 = 0, M = 0, I = 0, k3 = 0; k3 < p3; ) {
            I++;
            var L = t3[k3++];
            g3[M++] = w3 + c3, g3[M++] = L;
            for (var F = 0; F < L; F++) {
              var B = t3[k3++], G = t3[k3++];
              b3[w3++] = B, b3[w3++] = G;
            }
          }
          return { flatCoordsOffset: new Uint32Array(g3.buffer, 0, M), flatCoords: b3, count: I };
        }
        return { flatCoordsOffset: null, flatCoords: null, count: t3.length };
      }, i.prototype.getInitialData = function(t3, c3) {
        var p3 = new V1(["value"], this);
        return p3.hasItemOption = false, p3.initData(t3.data, [], function(g3, b3, w3, M) {
          if (g3 instanceof Array)
            return NaN;
          p3.hasItemOption = true;
          var I = g3.value;
          if (I != null)
            return I instanceof Array ? I[M] : I;
        }), p3;
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        var g3 = this.getData(), b3 = g3.getItemModel(t3), w3 = b3.get("name");
        if (w3)
          return w3;
        var M = b3.get("fromName"), I = b3.get("toName"), k3 = [];
        return M != null && k3.push(M), I != null && k3.push(I), Cg("nameValue", { name: k3.join(" > ") });
      }, i.prototype.preventIncremental = function() {
        return !!this.get(["effect", "show"]);
      }, i.prototype.getProgressive = function() {
        var t3 = this.option.progressive;
        return t3 == null ? this.option.large ? 1e4 : this.get("progressive") : t3;
      }, i.prototype.getProgressiveThreshold = function() {
        var t3 = this.option.progressiveThreshold;
        return t3 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : t3;
      }, i.prototype.getZLevelKey = function() {
        var t3 = this.getModel("effect"), c3 = t3.get("trailLength");
        return this.getData().count() > this.getProgressiveThreshold() ? this.id : t3.get("show") && c3 > 0 ? c3 + "" : "";
      }, i.type = "series.lines", i.dependencies = ["grid", "polar", "geo", "calendar"], i.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, i;
    }(bp), XTt = $Tt;
    function Ine(o) {
      return o instanceof Array || (o = [o, o]), o;
    }
    var YTt = { seriesType: "lines", reset: function(o) {
      var i = Ine(o.get("symbol")), t3 = Ine(o.get("symbolSize")), c3 = o.getData();
      c3.setVisual("fromSymbol", i && i[0]), c3.setVisual("toSymbol", i && i[1]), c3.setVisual("fromSymbolSize", t3 && t3[0]), c3.setVisual("toSymbolSize", t3 && t3[1]);
      function p3(g3, b3) {
        var w3 = g3.getItemModel(b3), M = Ine(w3.getShallow("symbol", true)), I = Ine(w3.getShallow("symbolSize", true));
        M[0] && g3.setItemVisual(b3, "fromSymbol", M[0]), M[1] && g3.setItemVisual(b3, "toSymbol", M[1]), I[0] && g3.setItemVisual(b3, "fromSymbolSize", I[0]), I[1] && g3.setItemVisual(b3, "toSymbolSize", I[1]);
      }
      return { dataEach: c3.hasItemOption ? p3 : null };
    } }, KTt = YTt;
    function ZTt(o) {
      o.registerChartView(WTt), o.registerSeriesModel(XTt), o.registerLayout(T9e), o.registerVisual(KTt);
    }
    var JTt = 256, QTt = function() {
      function o() {
        this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
        var i = cm.createCanvas();
        this.canvas = i;
      }
      return o.prototype.update = function(i, t3, c3, p3, g3, b3) {
        var w3 = this._getBrush(), M = this._getGradient(g3, "inRange"), I = this._getGradient(g3, "outOfRange"), k3 = this.pointSize + this.blurSize, L = this.canvas, F = L.getContext("2d"), B = i.length;
        L.width = t3, L.height = c3;
        for (var G = 0; G < B; ++G) {
          var J = i[G], Q = J[0], se = J[1], he = J[2], be = p3(he);
          F.globalAlpha = be, F.drawImage(w3, Q - k3, se - k3);
        }
        if (!L.width || !L.height)
          return L;
        for (var de = F.getImageData(0, 0, L.width, L.height), Fe = de.data, Pe = 0, ze = Fe.length, $e = this.minOpacity, Ke = this.maxOpacity, nt = Ke - $e; Pe < ze; ) {
          var be = Fe[Pe + 3] / 256, lt2 = Math.floor(be * (JTt - 1)) * 4;
          if (be > 0) {
            var bt = b3(be) ? M : I;
            be > 0 && (be = be * nt + $e), Fe[Pe++] = bt[lt2], Fe[Pe++] = bt[lt2 + 1], Fe[Pe++] = bt[lt2 + 2], Fe[Pe++] = bt[lt2 + 3] * be * 256;
          } else
            Pe += 4;
        }
        return F.putImageData(de, 0, 0), L;
      }, o.prototype._getBrush = function() {
        var i = this._brushCanvas || (this._brushCanvas = cm.createCanvas()), t3 = this.pointSize + this.blurSize, c3 = t3 * 2;
        i.width = c3, i.height = c3;
        var p3 = i.getContext("2d");
        return p3.clearRect(0, 0, c3, c3), p3.shadowOffsetX = c3, p3.shadowBlur = this.blurSize, p3.shadowColor = "#000", p3.beginPath(), p3.arc(-t3, t3, this.pointSize, 0, Math.PI * 2, true), p3.closePath(), p3.fill(), i;
      }, o.prototype._getGradient = function(i, t3) {
        for (var c3 = this._gradientPixels, p3 = c3[t3] || (c3[t3] = new Uint8ClampedArray(256 * 4)), g3 = [0, 0, 0, 0], b3 = 0, w3 = 0; w3 < 256; w3++)
          i[t3](w3 / 255, true, g3), p3[b3++] = g3[0], p3[b3++] = g3[1], p3[b3++] = g3[2], p3[b3++] = g3[3];
        return p3;
      }, o;
    }(), eAt = QTt;
    function tAt(o, i, t3) {
      var c3 = o[1] - o[0];
      i = Fi(i, function(b3) {
        return { interval: [(b3.interval[0] - o[0]) / c3, (b3.interval[1] - o[0]) / c3] };
      });
      var p3 = i.length, g3 = 0;
      return function(b3) {
        var w3;
        for (w3 = g3; w3 < p3; w3++) {
          var M = i[w3].interval;
          if (M[0] <= b3 && b3 <= M[1]) {
            g3 = w3;
            break;
          }
        }
        if (w3 === p3)
          for (w3 = g3 - 1; w3 >= 0; w3--) {
            var M = i[w3].interval;
            if (M[0] <= b3 && b3 <= M[1]) {
              g3 = w3;
              break;
            }
          }
        return w3 >= 0 && w3 < p3 && t3[w3];
      };
    }
    function nAt(o, i) {
      var t3 = o[1] - o[0];
      return i = [(i[0] - o[0]) / t3, (i[1] - o[0]) / t3], function(c3) {
        return c3 >= i[0] && c3 <= i[1];
      };
    }
    function I9e(o) {
      var i = o.dimensions;
      return i[0] === "lng" && i[1] === "lat";
    }
    var rAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3;
        c3.eachComponent("visualMap", function(w3) {
          w3.eachTargetSeries(function(M) {
            M === t3 && (g3 = w3);
          });
        }), this._progressiveEls = null, this.group.removeAll();
        var b3 = t3.coordinateSystem;
        b3.type === "cartesian2d" || b3.type === "calendar" ? this._renderOnCartesianAndCalendar(t3, p3, 0, t3.getData().count()) : I9e(b3) && this._renderOnGeo(b3, t3, g3, p3);
      }, i.prototype.incrementalPrepareRender = function(t3, c3, p3) {
        this.group.removeAll();
      }, i.prototype.incrementalRender = function(t3, c3, p3, g3) {
        var b3 = c3.coordinateSystem;
        b3 && (I9e(b3) ? this.render(c3, p3, g3) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(c3, g3, t3.start, t3.end, true)));
      }, i.prototype.eachRendered = function(t3) {
        nk(this._progressiveEls || this.group, t3);
      }, i.prototype._renderOnCartesianAndCalendar = function(t3, c3, p3, g3, b3) {
        var w3 = t3.coordinateSystem, M, I, k3, L;
        if (VI(w3, "cartesian2d")) {
          var F = w3.getAxis("x"), B = w3.getAxis("y");
          M = F.getBandWidth(), I = B.getBandWidth(), k3 = F.scale.getExtent(), L = B.scale.getExtent();
        }
        for (var G = this.group, J = t3.getData(), Q = t3.getModel(["emphasis", "itemStyle"]).getItemStyle(), se = t3.getModel(["blur", "itemStyle"]).getItemStyle(), he = t3.getModel(["select", "itemStyle"]).getItemStyle(), be = t3.get(["itemStyle", "borderRadius"]), de = g0(t3), Fe = t3.getModel("emphasis"), Pe = Fe.get("focus"), ze = Fe.get("blurScope"), $e = Fe.get("disabled"), Ke = VI(w3, "cartesian2d") ? [J.mapDimension("x"), J.mapDimension("y"), J.mapDimension("value")] : [J.mapDimension("time"), J.mapDimension("value")], nt = p3; nt < g3; nt++) {
          var lt2 = void 0, bt = J.getItemVisual(nt, "style");
          if (VI(w3, "cartesian2d")) {
            var vt = J.get(Ke[0], nt), jt = J.get(Ke[1], nt);
            if (isNaN(J.get(Ke[2], nt)) || vt < k3[0] || vt > k3[1] || jt < L[0] || jt > L[1])
              continue;
            var Jt = w3.dataToPoint([vt, jt]);
            lt2 = new bu({ shape: { x: Math.floor(Math.round(Jt[0]) - M / 2), y: Math.floor(Math.round(Jt[1]) - I / 2), width: Math.ceil(M), height: Math.ceil(I) }, style: bt });
          } else {
            if (isNaN(J.get(Ke[1], nt)))
              continue;
            lt2 = new bu({ z2: 1, shape: w3.dataToRect([J.get(Ke[0], nt)]).contentShape, style: bt });
          }
          if (J.hasItemOption) {
            var Rt = J.getItemModel(nt), Jn = Rt.getModel("emphasis");
            Q = Jn.getModel("itemStyle").getItemStyle(), se = Rt.getModel(["blur", "itemStyle"]).getItemStyle(), he = Rt.getModel(["select", "itemStyle"]).getItemStyle(), be = Rt.get(["itemStyle", "borderRadius"]), Pe = Jn.get("focus"), ze = Jn.get("blurScope"), $e = Jn.get("disabled"), de = g0(Rt);
          }
          lt2.shape.r = be;
          var ln = t3.getRawValue(nt), vn = "-";
          ln && ln[2] != null && (vn = ln[2] + ""), Sm(lt2, de, { labelFetcher: t3, labelDataIndex: nt, defaultOpacity: bt.opacity, defaultText: vn }), lt2.ensureState("emphasis").style = Q, lt2.ensureState("blur").style = se, lt2.ensureState("select").style = he, zp(lt2, Pe, ze, $e), lt2.incremental = b3, b3 && (lt2.states.emphasis.hoverLayer = true), G.add(lt2), J.setItemGraphicEl(nt, lt2), this._progressiveEls && this._progressiveEls.push(lt2);
        }
      }, i.prototype._renderOnGeo = function(t3, c3, p3, g3) {
        var b3 = p3.targetVisuals.inRange, w3 = p3.targetVisuals.outOfRange, M = c3.getData(), I = this._hmLayer || this._hmLayer || new eAt();
        I.blurSize = c3.get("blurSize"), I.pointSize = c3.get("pointSize"), I.minOpacity = c3.get("minOpacity"), I.maxOpacity = c3.get("maxOpacity");
        var k3 = t3.getViewRect().clone(), L = t3.getRoamTransform();
        k3.applyTransform(L);
        var F = Math.max(k3.x, 0), B = Math.max(k3.y, 0), G = Math.min(k3.width + k3.x, g3.getWidth()), J = Math.min(k3.height + k3.y, g3.getHeight()), Q = G - F, se = J - B, he = [M.mapDimension("lng"), M.mapDimension("lat"), M.mapDimension("value")], be = M.mapArray(he, function(ze, $e, Ke) {
          var nt = t3.dataToPoint([ze, $e]);
          return nt[0] -= F, nt[1] -= B, nt.push(Ke), nt;
        }), de = p3.getExtent(), Fe = p3.type === "visualMap.continuous" ? nAt(de, p3.option.range) : tAt(de, p3.getPieceList(), p3.option.selected);
        I.update(be, Q, se, b3.color.getNormalizer(), { inRange: b3.color.getColorMapper(), outOfRange: w3.color.getColorMapper() }, Fe);
        var Pe = new Gv({ style: { width: Q, height: se, x: F, y: B, image: I.canvas }, silent: true });
        this.group.add(Pe);
      }, i.type = "heatmap", i;
    }(yh), iAt = rAt, aAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        return NI(null, this, { generateCoord: "value" });
      }, i.prototype.preventIncremental = function() {
        var t3 = DH.get(this.get("coordinateSystem"));
        if (t3 && t3.dimensions)
          return t3.dimensions[0] === "lng" && t3.dimensions[1] === "lat";
      }, i.type = "series.heatmap", i.dependencies = ["grid", "geo", "calendar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, i;
    }(bp), oAt = aAt;
    function sAt(o) {
      o.registerChartView(iAt), o.registerSeriesModel(oAt);
    }
    var lAt = ["itemStyle", "borderWidth"], E9e = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], nme = new Mw(), uAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = this.group, b3 = t3.getData(), w3 = this._data, M = t3.coordinateSystem, I = M.getBaseAxis(), k3 = I.isHorizontal(), L = M.master.getRect(), F = { ecSize: { width: p3.getWidth(), height: p3.getHeight() }, seriesModel: t3, coordSys: M, coordSysExtent: [[L.x, L.x + L.width], [L.y, L.y + L.height]], isHorizontal: k3, valueDim: E9e[+k3], categoryDim: E9e[1 - +k3] };
        return b3.diff(w3).add(function(B) {
          if (b3.hasValue(B)) {
            var G = N9e(b3, B), J = D9e(b3, B, G, F), Q = F9e(b3, F, J);
            b3.setItemGraphicEl(B, Q), g3.add(Q), z9e(Q, F, J);
          }
        }).update(function(B, G) {
          var J = w3.getItemGraphicEl(G);
          if (!b3.hasValue(B)) {
            g3.remove(J);
            return;
          }
          var Q = N9e(b3, B), se = D9e(b3, B, Q, F), he = B9e(b3, se);
          J && he !== J.__pictorialShapeStr && (g3.remove(J), b3.setItemGraphicEl(B, null), J = null), J ? gAt(J, F, se) : J = F9e(b3, F, se, true), b3.setItemGraphicEl(B, J), J.__pictorialSymbolMeta = se, g3.add(J), z9e(J, F, se);
        }).remove(function(B) {
          var G = w3.getItemGraphicEl(B);
          G && V9e(w3, B, G.__pictorialSymbolMeta.animationModel, G);
        }).execute(), this._data = b3, this.group;
      }, i.prototype.remove = function(t3, c3) {
        var p3 = this.group, g3 = this._data;
        t3.get("animation") ? g3 && g3.eachItemGraphicEl(function(b3) {
          V9e(g3, La(b3).dataIndex, t3, b3);
        }) : p3.removeAll();
      }, i.type = "pictorialBar", i;
    }(yh);
    function D9e(o, i, t3, c3) {
      var p3 = o.getItemLayout(i), g3 = t3.get("symbolRepeat"), b3 = t3.get("symbolClip"), w3 = t3.get("symbolPosition") || "start", M = t3.get("symbolRotate"), I = (M || 0) * Math.PI / 180 || 0, k3 = t3.get("symbolPatternSize") || 2, L = t3.isAnimationEnabled(), F = { dataIndex: i, layout: p3, itemModel: t3, symbolType: o.getItemVisual(i, "symbol") || "circle", style: o.getItemVisual(i, "style"), symbolClip: b3, symbolRepeat: g3, symbolRepeatDirection: t3.get("symbolRepeatDirection"), symbolPatternSize: k3, rotation: I, animationModel: L ? t3 : null, hoverScale: L && t3.get(["emphasis", "scale"]), z2: t3.getShallow("z", true) || 0 };
      cAt(t3, g3, p3, c3, F), fAt(o, i, p3, g3, b3, F.boundingLength, F.pxSign, k3, c3, F), hAt(t3, F.symbolScale, I, c3, F);
      var B = F.symbolSize, G = I8(t3.get("symbolOffset"), B);
      return pAt(t3, B, p3, g3, b3, G, w3, F.valueLineWidth, F.boundingLength, F.repeatCutLength, c3, F), F;
    }
    function cAt(o, i, t3, c3, p3) {
      var g3 = c3.valueDim, b3 = o.get("symbolBoundingData"), w3 = c3.coordSys.getOtherAxis(c3.coordSys.getBaseAxis()), M = w3.toGlobalCoord(w3.dataToCoord(0)), I = 1 - +(t3[g3.wh] <= 0), k3;
      if (Ei(b3)) {
        var L = [rme(w3, b3[0]) - M, rme(w3, b3[1]) - M];
        L[1] < L[0] && L.reverse(), k3 = L[I];
      } else
        b3 != null ? k3 = rme(w3, b3) - M : i ? k3 = c3.coordSysExtent[g3.index][I] - M : k3 = t3[g3.wh];
      p3.boundingLength = k3, i && (p3.repeatCutLength = t3[g3.wh]), p3.pxSign = k3 > 0 ? 1 : -1;
    }
    function rme(o, i) {
      return o.toGlobalCoord(o.dataToCoord(o.scale.parse(i)));
    }
    function fAt(o, i, t3, c3, p3, g3, b3, w3, M, I) {
      var k3 = M.valueDim, L = M.categoryDim, F = Math.abs(t3[L.wh]), B = o.getItemVisual(i, "symbolSize"), G;
      Ei(B) ? G = B.slice() : B == null ? G = ["100%", "100%"] : G = [B, B], G[L.index] = Da(G[L.index], F), G[k3.index] = Da(G[k3.index], c3 ? F : Math.abs(g3)), I.symbolSize = G;
      var J = I.symbolScale = [G[0] / w3, G[1] / w3];
      J[k3.index] *= (M.isHorizontal ? -1 : 1) * b3;
    }
    function hAt(o, i, t3, c3, p3) {
      var g3 = o.get(lAt) || 0;
      g3 && (nme.attr({ scaleX: i[0], scaleY: i[1], rotation: t3 }), nme.updateTransform(), g3 /= nme.getLineScale(), g3 *= i[c3.valueDim.index]), p3.valueLineWidth = g3 || 0;
    }
    function pAt(o, i, t3, c3, p3, g3, b3, w3, M, I, k3, L) {
      var F = k3.categoryDim, B = k3.valueDim, G = L.pxSign, J = Math.max(i[B.index] + w3, 0), Q = J;
      if (c3) {
        var se = Math.abs(M), he = lv(o.get("symbolMargin"), "15%") + "", be = false;
        he.lastIndexOf("!") === he.length - 1 && (be = true, he = he.slice(0, he.length - 1));
        var de = Da(he, i[B.index]), Fe = Math.max(J + de * 2, 0), Pe = be ? 0 : de * 2, ze = yw(c3), $e = ze ? c3 : j9e((se + Pe) / Fe), Ke = se - $e * J;
        de = Ke / 2 / (be ? $e : Math.max($e - 1, 1)), Fe = J + de * 2, Pe = be ? 0 : de * 2, !ze && c3 !== "fixed" && ($e = I ? j9e((Math.abs(I) + Pe) / Fe) : 0), Q = $e * Fe - Pe, L.repeatTimes = $e, L.symbolMargin = de;
      }
      var nt = G * (Q / 2), lt2 = L.pathPosition = [];
      lt2[F.index] = t3[F.wh] / 2, lt2[B.index] = b3 === "start" ? nt : b3 === "end" ? M - nt : M / 2, g3 && (lt2[0] += g3[0], lt2[1] += g3[1]);
      var bt = L.bundlePosition = [];
      bt[F.index] = t3[F.xy], bt[B.index] = t3[B.xy];
      var vt = L.barRectShape = ti({}, t3);
      vt[B.wh] = G * Math.max(Math.abs(t3[B.wh]), Math.abs(lt2[B.index] + nt)), vt[F.wh] = t3[F.wh];
      var jt = L.clipShape = {};
      jt[F.xy] = -t3[F.xy], jt[F.wh] = k3.ecSize[F.wh], jt[B.xy] = 0, jt[B.wh] = t3[B.wh];
    }
    function k9e(o) {
      var i = o.symbolPatternSize, t3 = pv(o.symbolType, -i / 2, -i / 2, i, i);
      return t3.attr({ culling: true }), t3.type !== "image" && t3.setStyle({ strokeNoScale: true }), t3;
    }
    function O9e(o, i, t3, c3) {
      var p3 = o.__pictorialBundle, g3 = t3.symbolSize, b3 = t3.valueLineWidth, w3 = t3.pathPosition, M = i.valueDim, I = t3.repeatTimes || 0, k3 = 0, L = g3[i.valueDim.index] + b3 + t3.symbolMargin * 2;
      for (ime(o, function(J) {
        J.__pictorialAnimationIndex = k3, J.__pictorialRepeatTimes = I, k3 < I ? W8(J, null, G(k3), t3, c3) : W8(J, null, { scaleX: 0, scaleY: 0 }, t3, c3, function() {
          p3.remove(J);
        }), k3++;
      }); k3 < I; k3++) {
        var F = k9e(t3);
        F.__pictorialAnimationIndex = k3, F.__pictorialRepeatTimes = I, p3.add(F);
        var B = G(k3);
        W8(F, { x: B.x, y: B.y, scaleX: 0, scaleY: 0 }, { scaleX: B.scaleX, scaleY: B.scaleY, rotation: B.rotation }, t3, c3);
      }
      function G(J) {
        var Q = w3.slice(), se = t3.pxSign, he = J;
        return (t3.symbolRepeatDirection === "start" ? se > 0 : se < 0) && (he = I - 1 - J), Q[M.index] = L * (he - I / 2 + 0.5) + w3[M.index], { x: Q[0], y: Q[1], scaleX: t3.symbolScale[0], scaleY: t3.symbolScale[1], rotation: t3.rotation };
      }
    }
    function P9e(o, i, t3, c3) {
      var p3 = o.__pictorialBundle, g3 = o.__pictorialMainPath;
      g3 ? W8(g3, null, { x: t3.pathPosition[0], y: t3.pathPosition[1], scaleX: t3.symbolScale[0], scaleY: t3.symbolScale[1], rotation: t3.rotation }, t3, c3) : (g3 = o.__pictorialMainPath = k9e(t3), p3.add(g3), W8(g3, { x: t3.pathPosition[0], y: t3.pathPosition[1], scaleX: 0, scaleY: 0, rotation: t3.rotation }, { scaleX: t3.symbolScale[0], scaleY: t3.symbolScale[1] }, t3, c3));
    }
    function L9e(o, i, t3) {
      var c3 = ti({}, i.barRectShape), p3 = o.__pictorialBarRect;
      p3 ? W8(p3, null, { shape: c3 }, i, t3) : (p3 = o.__pictorialBarRect = new bu({ z2: 2, shape: c3, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), p3.disableMorphing = true, o.add(p3));
    }
    function R9e(o, i, t3, c3) {
      if (t3.symbolClip) {
        var p3 = o.__pictorialClipPath, g3 = ti({}, t3.clipShape), b3 = i.valueDim, w3 = t3.animationModel, M = t3.dataIndex;
        if (p3)
          Du(p3, { shape: g3 }, w3, M);
        else {
          g3[b3.wh] = 0, p3 = new bu({ shape: g3 }), o.__pictorialBundle.setClipPath(p3), o.__pictorialClipPath = p3;
          var I = {};
          I[b3.wh] = t3.clipShape[b3.wh], SH[c3 ? "updateProps" : "initProps"](p3, { shape: I }, w3, M);
        }
      }
    }
    function N9e(o, i) {
      var t3 = o.getItemModel(i);
      return t3.getAnimationDelayParams = dAt, t3.isAnimationEnabled = vAt, t3;
    }
    function dAt(o) {
      return { index: o.__pictorialAnimationIndex, count: o.__pictorialRepeatTimes };
    }
    function vAt() {
      return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
    }
    function F9e(o, i, t3, c3) {
      var p3 = new vs(), g3 = new vs();
      return p3.add(g3), p3.__pictorialBundle = g3, g3.x = t3.bundlePosition[0], g3.y = t3.bundlePosition[1], t3.symbolRepeat ? O9e(p3, i, t3) : P9e(p3, i, t3), L9e(p3, t3, c3), R9e(p3, i, t3, c3), p3.__pictorialShapeStr = B9e(o, t3), p3.__pictorialSymbolMeta = t3, p3;
    }
    function gAt(o, i, t3) {
      var c3 = t3.animationModel, p3 = t3.dataIndex, g3 = o.__pictorialBundle;
      Du(g3, { x: t3.bundlePosition[0], y: t3.bundlePosition[1] }, c3, p3), t3.symbolRepeat ? O9e(o, i, t3, true) : P9e(o, i, t3, true), L9e(o, t3, true), R9e(o, i, t3, true);
    }
    function V9e(o, i, t3, c3) {
      var p3 = c3.__pictorialBarRect;
      p3 && p3.removeTextContent();
      var g3 = [];
      ime(c3, function(b3) {
        g3.push(b3);
      }), c3.__pictorialMainPath && g3.push(c3.__pictorialMainPath), c3.__pictorialClipPath && (t3 = null), yt(g3, function(b3) {
        XM(b3, { scaleX: 0, scaleY: 0 }, t3, i, function() {
          c3.parent && c3.parent.remove(c3);
        });
      }), o.setItemGraphicEl(i, null);
    }
    function B9e(o, i) {
      return [o.getItemVisual(i.dataIndex, "symbol") || "none", !!i.symbolRepeat, !!i.symbolClip].join(":");
    }
    function ime(o, i, t3) {
      yt(o.__pictorialBundle.children(), function(c3) {
        c3 !== o.__pictorialBarRect && i.call(t3, c3);
      });
    }
    function W8(o, i, t3, c3, p3, g3) {
      i && o.attr(i), c3.symbolClip && !p3 ? t3 && o.attr(t3) : t3 && SH[p3 ? "updateProps" : "initProps"](o, t3, c3.animationModel, c3.dataIndex, g3);
    }
    function z9e(o, i, t3) {
      var c3 = t3.dataIndex, p3 = t3.itemModel, g3 = p3.getModel("emphasis"), b3 = g3.getModel("itemStyle").getItemStyle(), w3 = p3.getModel(["blur", "itemStyle"]).getItemStyle(), M = p3.getModel(["select", "itemStyle"]).getItemStyle(), I = p3.getShallow("cursor"), k3 = g3.get("focus"), L = g3.get("blurScope"), F = g3.get("scale");
      ime(o, function(J) {
        if (J instanceof Gv) {
          var Q = J.style;
          J.useStyle(ti({ image: Q.image, x: Q.x, y: Q.y, width: Q.width, height: Q.height }, t3.style));
        } else
          J.useStyle(t3.style);
        var se = J.ensureState("emphasis");
        se.style = b3, F && (se.scaleX = J.scaleX * 1.1, se.scaleY = J.scaleY * 1.1), J.ensureState("blur").style = w3, J.ensureState("select").style = M, I && (J.cursor = I), J.z2 = t3.z2;
      });
      var B = i.valueDim.posDesc[+(t3.boundingLength > 0)], G = o.__pictorialBarRect;
      Sm(G, g0(p3), { labelFetcher: i.seriesModel, labelDataIndex: c3, defaultText: L8(i.seriesModel.getData(), c3), inheritColor: t3.style.fill, defaultOpacity: t3.style.opacity, defaultOutsidePosition: B }), zp(o, k3, L, g3.get("disabled"));
    }
    function j9e(o) {
      var i = Math.round(o);
      return Math.abs(o - i) < 1e-4 ? i : Math.ceil(o);
    }
    var yAt = uAt, mAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.hasSymbolVisual = true, t3.defaultSymbol = "roundRect", t3;
      }
      return i.prototype.getInitialData = function(t3) {
        return t3.stack = null, o.prototype.getInitialData.apply(this, arguments);
      }, i.type = "series.pictorialBar", i.dependencies = ["grid"], i.defaultOption = rk(rne.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), i;
    }(rne), bAt = mAt;
    function _At(o) {
      o.registerChartView(yAt), o.registerSeriesModel(bAt), o.registerLayout(o.PRIORITY.VISUAL.LAYOUT, As(Q4e, "pictorialBar")), o.registerLayout(o.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, e6e("pictorialBar"));
    }
    var xAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._layers = [], t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = t3.getData(), b3 = this, w3 = this.group, M = t3.getLayerSeries(), I = g3.getLayout("layoutInfo"), k3 = I.rect, L = I.boundaryGap;
        w3.x = 0, w3.y = k3.y + L[0];
        function F(Q) {
          return Q.name;
        }
        var B = new RI(this._layersSeries || [], M, F, F), G = [];
        B.add(Qa(J, this, "add")).update(Qa(J, this, "update")).remove(Qa(J, this, "remove")).execute();
        function J(Q, se, he) {
          var be = b3._layers;
          if (Q === "remove") {
            w3.remove(be[se]);
            return;
          }
          for (var de = [], Fe = [], Pe, ze = M[se].indices, $e = 0; $e < ze.length; $e++) {
            var Ke = g3.getItemLayout(ze[$e]), nt = Ke.x, lt2 = Ke.y0, bt = Ke.y;
            de.push(nt, lt2), Fe.push(nt, lt2 + bt), Pe = g3.getItemVisual(ze[$e], "style");
          }
          var vt, jt = g3.getItemLayout(ze[0]), Jt = t3.getModel("label"), Rt = Jt.get("margin"), Jn = t3.getModel("emphasis");
          if (Q === "add") {
            var ln = G[se] = new vs();
            vt = new pNe({ shape: { points: de, stackedOnPoints: Fe, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), ln.add(vt), w3.add(ln), t3.isAnimationEnabled() && vt.setClipPath(wAt(vt.getBoundingRect(), t3, function() {
              vt.removeClipPath();
            }));
          } else {
            var ln = be[he];
            vt = ln.childAt(0), w3.add(ln), G[se] = ln, Du(vt, { shape: { points: de, stackedOnPoints: Fe } }, t3), P_(vt);
          }
          Sm(vt, g0(t3), { labelDataIndex: ze[$e - 1], defaultText: g3.getName(ze[$e - 1]), inheritColor: Pe.fill }, { normal: { verticalAlign: "middle" } }), vt.setTextConfig({ position: null, local: true });
          var vn = vt.getTextContent();
          vn && (vn.x = jt.x - Rt, vn.y = jt.y0 + jt.y / 2), vt.useStyle(Pe), g3.setItemGraphicEl(se, vt), cv(vt, t3), zp(vt, Jn.get("focus"), Jn.get("blurScope"), Jn.get("disabled"));
        }
        this._layersSeries = M, this._layers = G;
      }, i.type = "themeRiver", i;
    }(yh);
    function wAt(o, i, t3) {
      var c3 = new bu({ shape: { x: o.x - 10, y: o.y - 10, width: 0, height: o.height + 20 } });
      return Uh(c3, { shape: { x: o.x - 50, width: o.width + 100, height: o.height + 20 } }, i, t3), c3;
    }
    var SAt = xAt, ame = 2, CAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3) {
        o.prototype.init.apply(this, arguments), this.legendVisualProvider = new fW(Qa(this.getData, this), Qa(this.getRawData, this));
      }, i.prototype.fixData = function(t3) {
        var c3 = t3.length, p3 = {}, g3 = VF(t3, function(F) {
          return p3.hasOwnProperty(F[0] + "") || (p3[F[0] + ""] = -1), F[2];
        }), b3 = [];
        g3.buckets.each(function(F, B) {
          b3.push({ name: B, dataList: F });
        });
        for (var w3 = b3.length, M = 0; M < w3; ++M) {
          for (var I = b3[M].name, k3 = 0; k3 < b3[M].dataList.length; ++k3) {
            var L = b3[M].dataList[k3][0] + "";
            p3[L] = M;
          }
          for (var L in p3)
            p3.hasOwnProperty(L) && p3[L] !== M && (p3[L] = M, t3[c3] = [L, 0, I], c3++);
        }
        return t3;
      }, i.prototype.getInitialData = function(t3, c3) {
        for (var p3 = this.getReferringComponents("singleAxis", xd).models[0], g3 = p3.get("type"), b3 = Zc(t3.data, function(G) {
          return G[2] !== void 0;
        }), w3 = this.fixData(b3 || []), M = [], I = this.nameMap = Eo(), k3 = 0, L = 0; L < w3.length; ++L)
          M.push(w3[L][ame]), I.get(w3[L][ame]) || (I.set(w3[L][ame], k3), k3++);
        var F = ZH(w3, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: Nte(g3) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, B = new V1(F, this);
        return B.initData(w3), B;
      }, i.prototype.getLayerSeries = function() {
        for (var t3 = this.getData(), c3 = t3.count(), p3 = [], g3 = 0; g3 < c3; ++g3)
          p3[g3] = g3;
        var b3 = t3.mapDimension("single"), w3 = VF(p3, function(I) {
          return t3.get("name", I);
        }), M = [];
        return w3.buckets.each(function(I, k3) {
          I.sort(function(L, F) {
            return t3.get(b3, L) - t3.get(b3, F);
          }), M.push({ name: k3, indices: I });
        }), M;
      }, i.prototype.getAxisTooltipData = function(t3, c3, p3) {
        Ei(t3) || (t3 = t3 ? [t3] : []);
        for (var g3 = this.getData(), b3 = this.getLayerSeries(), w3 = [], M = b3.length, I, k3 = 0; k3 < M; ++k3) {
          for (var L = Number.MAX_VALUE, F = -1, B = b3[k3].indices.length, G = 0; G < B; ++G) {
            var J = g3.get(t3[0], b3[k3].indices[G]), Q = Math.abs(J - c3);
            Q <= L && (I = J, L = Q, F = b3[k3].indices[G]);
          }
          w3.push(F);
        }
        return { dataIndices: w3, nestestValue: I };
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        var g3 = this.getData(), b3 = g3.getName(t3), w3 = g3.get(g3.mapDimension("value"), t3);
        return Cg("nameValue", { name: b3, value: w3 });
      }, i.type = "series.themeRiver", i.dependencies = ["singleAxis"], i.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, i;
    }(bp), MAt = CAt;
    function TAt(o, i) {
      o.eachSeriesByType("themeRiver", function(t3) {
        var c3 = t3.getData(), p3 = t3.coordinateSystem, g3 = {}, b3 = p3.getRect();
        g3.rect = b3;
        var w3 = t3.get("boundaryGap"), M = p3.getAxis();
        if (g3.boundaryGap = w3, M.orient === "horizontal") {
          w3[0] = Da(w3[0], b3.height), w3[1] = Da(w3[1], b3.height);
          var I = b3.height - w3[0] - w3[1];
          G9e(c3, t3, I);
        } else {
          w3[0] = Da(w3[0], b3.width), w3[1] = Da(w3[1], b3.width);
          var k3 = b3.width - w3[0] - w3[1];
          G9e(c3, t3, k3);
        }
        c3.setLayout("layoutInfo", g3);
      });
    }
    function G9e(o, i, t3) {
      if (o.count())
        for (var c3 = i.coordinateSystem, p3 = i.getLayerSeries(), g3 = o.mapDimension("single"), b3 = o.mapDimension("value"), w3 = Fi(p3, function(Q) {
          return Fi(Q.indices, function(se) {
            var he = c3.dataToPoint(o.get(g3, se));
            return he[1] = o.get(b3, se), he;
          });
        }), M = AAt(w3), I = M.y0, k3 = t3 / M.max, L = p3.length, F = p3[0].indices.length, B, G = 0; G < F; ++G) {
          B = I[G] * k3, o.setItemLayout(p3[0].indices[G], { layerIndex: 0, x: w3[0][G][0], y0: B, y: w3[0][G][1] * k3 });
          for (var J = 1; J < L; ++J)
            B += w3[J - 1][G][1] * k3, o.setItemLayout(p3[J].indices[G], { layerIndex: J, x: w3[J][G][0], y0: B, y: w3[J][G][1] * k3 });
        }
    }
    function AAt(o) {
      for (var i = o.length, t3 = o[0].length, c3 = [], p3 = [], g3 = 0, b3 = 0; b3 < t3; ++b3) {
        for (var w3 = 0, M = 0; M < i; ++M)
          w3 += o[M][b3][1];
        w3 > g3 && (g3 = w3), c3.push(w3);
      }
      for (var I = 0; I < t3; ++I)
        p3[I] = (g3 - c3[I]) / 2;
      g3 = 0;
      for (var k3 = 0; k3 < t3; ++k3) {
        var L = c3[k3] + p3[k3];
        L > g3 && (g3 = L);
      }
      return { y0: p3, max: g3 };
    }
    function IAt(o) {
      o.registerChartView(SAt), o.registerSeriesModel(MAt), o.registerLayout(TAt), o.registerProcessor(cW("themeRiver"));
    }
    var EAt = 2, DAt = 4, kAt = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3) {
        var b3 = o.call(this) || this;
        b3.z2 = EAt, b3.textConfig = { inside: true }, La(b3).seriesIndex = c3.seriesIndex;
        var w3 = new Fl({ z2: DAt, silent: t3.getModel().get(["label", "silent"]) });
        return b3.setTextContent(w3), b3.updateData(true, t3, c3, p3, g3), b3;
      }
      return i.prototype.updateData = function(t3, c3, p3, g3, b3) {
        this.node = c3, c3.piece = this, p3 = p3 || this._seriesModel, g3 = g3 || this._ecModel;
        var w3 = this;
        La(w3).dataIndex = c3.dataIndex;
        var M = c3.getModel(), I = M.getModel("emphasis"), k3 = c3.getLayout(), L = ti({}, k3);
        L.label = null;
        var F = c3.getVisual("style");
        F.lineJoin = "bevel";
        var B = c3.getVisual("decal");
        B && (F.decal = GH(B, b3));
        var G = R8(M.getModel("itemStyle"), L, true);
        ti(L, G), yt(yy, function(he) {
          var be = w3.ensureState(he), de = M.getModel([he, "itemStyle"]);
          be.style = de.getItemStyle();
          var Fe = R8(de, L);
          Fe && (be.shape = Fe);
        }), t3 ? (w3.setShape(L), w3.shape.r = k3.r0, Du(w3, { shape: { r: k3.r } }, p3, c3.dataIndex)) : (Du(w3, { shape: L }, p3), P_(w3)), w3.useStyle(F), this._updateLabel(p3);
        var J = M.getShallow("cursor");
        J && w3.attr("cursor", J), this._seriesModel = p3 || this._seriesModel, this._ecModel = g3 || this._ecModel;
        var Q = I.get("focus"), se = Q === "ancestor" ? c3.getAncestorsIndices() : Q === "descendant" ? c3.getDescendantIndices() : Q;
        zp(this, se, I.get("blurScope"), I.get("disabled"));
      }, i.prototype._updateLabel = function(t3) {
        var c3 = this, p3 = this.node.getModel(), g3 = p3.getModel("label"), b3 = this.node.getLayout(), w3 = b3.endAngle - b3.startAngle, M = (b3.startAngle + b3.endAngle) / 2, I = Math.cos(M), k3 = Math.sin(M), L = this, F = L.getTextContent(), B = this.node.dataIndex, G = g3.get("minAngle") / 180 * Math.PI, J = g3.get("show") && !(G != null && Math.abs(w3) < G);
        F.ignore = !J, yt(UP, function(se) {
          var he = se === "normal" ? p3.getModel("label") : p3.getModel([se, "label"]), be = se === "normal", de = be ? F : F.ensureState(se), Fe = t3.getFormattedLabel(B, se);
          be && (Fe = Fe || c3.node.name), de.style = qd(he, {}, null, se !== "normal", true), Fe && (de.style.text = Fe);
          var Pe = he.get("show");
          Pe != null && !be && (de.ignore = !Pe);
          var ze = Q(he, "position"), $e = be ? L : L.states[se], Ke = $e.style.fill;
          $e.textConfig = { outsideFill: he.get("color") === "inherit" ? Ke : null, inside: ze !== "outside" };
          var nt, lt2 = Q(he, "distance") || 0, bt = Q(he, "align");
          ze === "outside" ? (nt = b3.r + lt2, bt = M > Math.PI / 2 ? "right" : "left") : !bt || bt === "center" ? (w3 === 2 * Math.PI && b3.r0 === 0 ? nt = 0 : nt = (b3.r + b3.r0) / 2, bt = "center") : bt === "left" ? (nt = b3.r0 + lt2, M > Math.PI / 2 && (bt = "right")) : bt === "right" && (nt = b3.r - lt2, M > Math.PI / 2 && (bt = "left")), de.style.align = bt, de.style.verticalAlign = Q(he, "verticalAlign") || "middle", de.x = nt * I + b3.cx, de.y = nt * k3 + b3.cy;
          var vt = Q(he, "rotate"), jt = 0;
          vt === "radial" ? (jt = -M, jt < -Math.PI / 2 && (jt += Math.PI)) : vt === "tangential" ? (jt = Math.PI / 2 - M, jt > Math.PI / 2 ? jt -= Math.PI : jt < -Math.PI / 2 && (jt += Math.PI)) : ec(vt) && (jt = vt * Math.PI / 180), de.rotation = jt;
        });
        function Q(se, he) {
          var be = se.get(he);
          return be == null ? g3.get(he) : be;
        }
        F.dirtyStyle();
      }, i;
    }(bm), H9e = kAt, ome = "sunburstRootToNode", W9e = "sunburstHighlight", OAt = "sunburstUnhighlight";
    function PAt(o) {
      o.registerAction({ type: ome, update: "updateView" }, function(i, t3) {
        t3.eachComponent({ mainType: "series", subType: "sunburst", query: i }, c3);
        function c3(p3, g3) {
          var b3 = mW(i, [ome], p3);
          if (b3) {
            var w3 = p3.getViewRoot();
            w3 && (i.direction = cye(w3, b3.node) ? "rollUp" : "drillDown"), p3.resetViewRoot(b3.node);
          }
        }
      }), o.registerAction({ type: W9e, update: "none" }, function(i, t3, c3) {
        i = ti({}, i), t3.eachComponent({ mainType: "series", subType: "sunburst", query: i }, p3);
        function p3(g3) {
          var b3 = mW(i, [W9e], g3);
          b3 && (i.dataIndex = b3.node.dataIndex);
        }
        c3.dispatchAction(ti(i, { type: "highlight" }));
      }), o.registerAction({ type: OAt, update: "updateView" }, function(i, t3, c3) {
        i = ti({}, i), c3.dispatchAction(ti(i, { type: "downplay" }));
      });
    }
    var LAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        var b3 = this;
        this.seriesModel = t3, this.api = p3, this.ecModel = c3;
        var w3 = t3.getData(), M = w3.tree.root, I = t3.getViewRoot(), k3 = this.group, L = t3.get("renderLabelForZeroData"), F = [];
        I.eachNode(function(he) {
          F.push(he);
        });
        var B = this._oldChildren || [];
        G(F, B), se(M, I), this._initEvents(), this._oldChildren = F;
        function G(he, be) {
          if (he.length === 0 && be.length === 0)
            return;
          new RI(be, he, de, de).add(Fe).update(Fe).remove(As(Fe, null)).execute();
          function de(Pe) {
            return Pe.getId();
          }
          function Fe(Pe, ze) {
            var $e = Pe == null ? null : he[Pe], Ke = ze == null ? null : be[ze];
            J($e, Ke);
          }
        }
        function J(he, be) {
          if (!L && he && !he.getValue() && (he = null), he !== M && be !== M) {
            if (be && be.piece)
              he ? (be.piece.updateData(false, he, t3, c3, p3), w3.setItemGraphicEl(he.dataIndex, be.piece)) : Q(be);
            else if (he) {
              var de = new H9e(he, t3, c3, p3);
              k3.add(de), w3.setItemGraphicEl(he.dataIndex, de);
            }
          }
        }
        function Q(he) {
          !he || he.piece && (k3.remove(he.piece), he.piece = null);
        }
        function se(he, be) {
          be.depth > 0 ? (b3.virtualPiece ? b3.virtualPiece.updateData(false, he, t3, c3, p3) : (b3.virtualPiece = new H9e(he, t3, c3, p3), k3.add(b3.virtualPiece)), be.piece.off("click"), b3.virtualPiece.on("click", function(de) {
            b3._rootToNode(be.parentNode);
          })) : b3.virtualPiece && (k3.remove(b3.virtualPiece), b3.virtualPiece = null);
        }
      }, i.prototype._initEvents = function() {
        var t3 = this;
        this.group.off("click"), this.group.on("click", function(c3) {
          var p3 = false, g3 = t3.seriesModel.getViewRoot();
          g3.eachNode(function(b3) {
            if (!p3 && b3.piece && b3.piece === c3.target) {
              var w3 = b3.getModel().get("nodeClick");
              if (w3 === "rootToNode")
                t3._rootToNode(b3);
              else if (w3 === "link") {
                var M = b3.getModel(), I = M.get("link");
                if (I) {
                  var k3 = M.get("target", true) || "_blank";
                  pte(I, k3);
                }
              }
              p3 = true;
            }
          });
        });
      }, i.prototype._rootToNode = function(t3) {
        t3 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: ome, from: this.uid, seriesId: this.seriesModel.id, targetNode: t3 });
      }, i.prototype.containPoint = function(t3, c3) {
        var p3 = c3.getData(), g3 = p3.getItemLayout(0);
        if (g3) {
          var b3 = t3[0] - g3.cx, w3 = t3[1] - g3.cy, M = Math.sqrt(b3 * b3 + w3 * w3);
          return M <= g3.r && M >= g3.r0;
        }
      }, i.type = "sunburst", i;
    }(yh), RAt = LAt, NAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.ignoreStyleOnData = true, t3;
      }
      return i.prototype.getInitialData = function(t3, c3) {
        var p3 = { name: t3.name, children: t3.data };
        U9e(p3);
        var g3 = this._levelModels = Fi(t3.levels || [], function(M) {
          return new gh(M, this, c3);
        }, this), b3 = uye.createTree(p3, this, w3);
        function w3(M) {
          M.wrapMethod("getItemModel", function(I, k3) {
            var L = b3.getNodeByDataIndex(k3), F = g3[L.depth];
            return F && (I.parentModel = F), I;
          });
        }
        return b3.data;
      }, i.prototype.optionUpdated = function() {
        this.resetViewRoot();
      }, i.prototype.getDataParams = function(t3) {
        var c3 = o.prototype.getDataParams.apply(this, arguments), p3 = this.getData().tree.getNodeByDataIndex(t3);
        return c3.treePathInfo = gne(p3, this), c3;
      }, i.prototype.getLevelModel = function(t3) {
        return this._levelModels && this._levelModels[t3.depth];
      }, i.prototype.getViewRoot = function() {
        return this._viewRoot;
      }, i.prototype.resetViewRoot = function(t3) {
        t3 ? this._viewRoot = t3 : t3 = this._viewRoot;
        var c3 = this.getRawData().tree.root;
        (!t3 || t3 !== c3 && !c3.contains(t3)) && (this._viewRoot = c3);
      }, i.prototype.enableAriaDecal = function() {
        QFe(this);
      }, i.type = "series.sunburst", i.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, i;
    }(bp);
    function U9e(o) {
      var i = 0;
      yt(o.children, function(c3) {
        U9e(c3);
        var p3 = c3.value;
        Ei(p3) && (p3 = p3[0]), i += p3;
      });
      var t3 = o.value;
      Ei(t3) && (t3 = t3[0]), (t3 == null || isNaN(t3)) && (t3 = i), t3 < 0 && (t3 = 0), Ei(o.value) ? o.value[0] = t3 : o.value = t3;
    }
    var FAt = NAt, q9e = Math.PI / 180;
    function VAt(o, i, t3) {
      i.eachSeriesByType(o, function(c3) {
        var p3 = c3.get("center"), g3 = c3.get("radius");
        Ei(g3) || (g3 = [0, g3]), Ei(p3) || (p3 = [p3, p3]);
        var b3 = t3.getWidth(), w3 = t3.getHeight(), M = Math.min(b3, w3), I = Da(p3[0], b3), k3 = Da(p3[1], w3), L = Da(g3[0], M / 2), F = Da(g3[1], M / 2), B = -c3.get("startAngle") * q9e, G = c3.get("minAngle") * q9e, J = c3.getData().tree.root, Q = c3.getViewRoot(), se = Q.depth, he = c3.get("sort");
        he != null && $9e(Q, he);
        var be = 0;
        yt(Q.children, function(Rt) {
          !isNaN(Rt.getValue()) && be++;
        });
        var de = Q.getValue(), Fe = Math.PI / (de || be) * 2, Pe = Q.depth > 0, ze = Q.height - (Pe ? -1 : 1), $e = (F - L) / (ze || 1), Ke = c3.get("clockwise"), nt = c3.get("stillShowZeroSum"), lt2 = Ke ? 1 : -1, bt = function(Rt, Jn) {
          if (Rt) {
            var ln = Jn;
            if (Rt !== J) {
              var vn = Rt.getValue(), kn = de === 0 && nt ? Fe : vn * Fe;
              kn < G && (kn = G), ln = Jn + lt2 * kn;
              var cr = Rt.depth - se - (Pe ? -1 : 1), gr = L + $e * cr, ha = L + $e * (cr + 1), Ka = c3.getLevelModel(Rt);
              if (Ka) {
                var Do = Ka.get("r0", true), _o = Ka.get("r", true), xo = Ka.get("radius", true);
                xo != null && (Do = xo[0], _o = xo[1]), Do != null && (gr = Da(Do, M / 2)), _o != null && (ha = Da(_o, M / 2));
              }
              Rt.setLayout({ angle: kn, startAngle: Jn, endAngle: ln, clockwise: Ke, cx: I, cy: k3, r0: gr, r: ha });
            }
            if (Rt.children && Rt.children.length) {
              var Ra = 0;
              yt(Rt.children, function(ho) {
                Ra += bt(ho, Jn + Ra);
              });
            }
            return ln - Jn;
          }
        };
        if (Pe) {
          var vt = L, jt = L + $e, Jt = Math.PI * 2;
          J.setLayout({ angle: Jt, startAngle: B, endAngle: B + Jt, clockwise: Ke, cx: I, cy: k3, r0: vt, r: jt });
        }
        bt(Q, B);
      });
    }
    function $9e(o, i) {
      var t3 = o.children || [];
      o.children = BAt(t3, i), t3.length && yt(o.children, function(c3) {
        $9e(c3, i);
      });
    }
    function BAt(o, i) {
      if (Vo(i)) {
        var t3 = Fi(o, function(p3, g3) {
          var b3 = p3.getValue();
          return { params: { depth: p3.depth, height: p3.height, dataIndex: p3.dataIndex, getValue: function() {
            return b3;
          } }, index: g3 };
        });
        return t3.sort(function(p3, g3) {
          return i(p3.params, g3.params);
        }), Fi(t3, function(p3) {
          return o[p3.index];
        });
      } else {
        var c3 = i === "asc";
        return o.sort(function(p3, g3) {
          var b3 = (p3.getValue() - g3.getValue()) * (c3 ? 1 : -1);
          return b3 === 0 ? (p3.dataIndex - g3.dataIndex) * (c3 ? -1 : 1) : b3;
        });
      }
    }
    function zAt(o) {
      var i = {};
      function t3(c3, p3, g3) {
        for (var b3 = c3; b3 && b3.depth > 1; )
          b3 = b3.parentNode;
        var w3 = p3.getColorFromPalette(b3.name || b3.dataIndex + "", i);
        return c3.depth > 1 && Ha(w3) && (w3 = rG(w3, (c3.depth - 1) / (g3 - 1) * 0.5)), w3;
      }
      o.eachSeriesByType("sunburst", function(c3) {
        var p3 = c3.getData(), g3 = p3.tree;
        g3.eachNode(function(b3) {
          var w3 = b3.getModel(), M = w3.getModel("itemStyle").getItemStyle();
          M.fill || (M.fill = t3(b3, c3, g3.root.height));
          var I = p3.ensureUniqueItemVisual(b3.dataIndex, "style");
          ti(I, M);
        });
      });
    }
    function jAt(o) {
      o.registerChartView(RAt), o.registerSeriesModel(FAt), o.registerLayout(As(VAt, "sunburst")), o.registerProcessor(As(cW, "sunburst")), o.registerVisual(zAt), PAt(o);
    }
    var X9e = { color: "fill", borderColor: "stroke" }, GAt = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, GI = mu(), HAt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.optionUpdated = function() {
        this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
      }, i.prototype.getInitialData = function(t3, c3) {
        return NI(null, this);
      }, i.prototype.getDataParams = function(t3, c3, p3) {
        var g3 = o.prototype.getDataParams.call(this, t3, c3);
        return p3 && (g3.info = GI(p3).info), g3;
      }, i.type = "series.custom", i.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], i.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, i;
    }(bp), WAt = HAt;
    function UAt(o, i) {
      return i = i || [0, 0], Fi(["x", "y"], function(t3, c3) {
        var p3 = this.getAxis(t3), g3 = i[c3], b3 = o[c3] / 2;
        return p3.type === "category" ? p3.getBandWidth() : Math.abs(p3.dataToCoord(g3 - b3) - p3.dataToCoord(g3 + b3));
      }, this);
    }
    function qAt(o) {
      var i = o.master.getRect();
      return { coordSys: { type: "cartesian2d", x: i.x, y: i.y, width: i.width, height: i.height }, api: { coord: function(t3) {
        return o.dataToPoint(t3);
      }, size: Qa(UAt, o) } };
    }
    function $At(o, i) {
      return i = i || [0, 0], Fi([0, 1], function(t3) {
        var c3 = i[t3], p3 = o[t3] / 2, g3 = [], b3 = [];
        return g3[t3] = c3 - p3, b3[t3] = c3 + p3, g3[1 - t3] = b3[1 - t3] = i[1 - t3], Math.abs(this.dataToPoint(g3)[t3] - this.dataToPoint(b3)[t3]);
      }, this);
    }
    function XAt(o) {
      var i = o.getBoundingRect();
      return { coordSys: { type: "geo", x: i.x, y: i.y, width: i.width, height: i.height, zoom: o.getZoom() }, api: { coord: function(t3) {
        return o.dataToPoint(t3);
      }, size: Qa($At, o) } };
    }
    function YAt(o, i) {
      var t3 = this.getAxis(), c3 = i instanceof Array ? i[0] : i, p3 = (o instanceof Array ? o[0] : o) / 2;
      return t3.type === "category" ? t3.getBandWidth() : Math.abs(t3.dataToCoord(c3 - p3) - t3.dataToCoord(c3 + p3));
    }
    function KAt(o) {
      var i = o.getRect();
      return { coordSys: { type: "singleAxis", x: i.x, y: i.y, width: i.width, height: i.height }, api: { coord: function(t3) {
        return o.dataToPoint(t3);
      }, size: Qa(YAt, o) } };
    }
    function ZAt(o, i) {
      return i = i || [0, 0], Fi(["Radius", "Angle"], function(t3, c3) {
        var p3 = "get" + t3 + "Axis", g3 = this[p3](), b3 = i[c3], w3 = o[c3] / 2, M = g3.type === "category" ? g3.getBandWidth() : Math.abs(g3.dataToCoord(b3 - w3) - g3.dataToCoord(b3 + w3));
        return t3 === "Angle" && (M = M * Math.PI / 180), M;
      }, this);
    }
    function JAt(o) {
      var i = o.getRadiusAxis(), t3 = o.getAngleAxis(), c3 = i.getExtent();
      return c3[0] > c3[1] && c3.reverse(), { coordSys: { type: "polar", cx: o.cx, cy: o.cy, r: c3[1], r0: c3[0] }, api: { coord: function(p3) {
        var g3 = i.dataToRadius(p3[0]), b3 = t3.dataToAngle(p3[1]), w3 = o.coordToPoint([g3, b3]);
        return w3.push(g3, b3 * Math.PI / 180), w3;
      }, size: Qa(ZAt, o) } };
    }
    function QAt(o) {
      var i = o.getRect(), t3 = o.getRangeInfo();
      return { coordSys: { type: "calendar", x: i.x, y: i.y, width: i.width, height: i.height, cellWidth: o.getCellWidth(), cellHeight: o.getCellHeight(), rangeInfo: { start: t3.start, end: t3.end, weeks: t3.weeks, dayCount: t3.allDay } }, api: { coord: function(c3, p3) {
        return o.dataToPoint(c3, p3);
      } } };
    }
    function Y9e(o, i, t3, c3) {
      return o && (o.legacy || o.legacy !== false && !t3 && !c3 && i !== "tspan" && (i === "text" || so(o, "text")));
    }
    function K9e(o, i, t3) {
      var c3 = o, p3, g3, b3;
      if (i === "text")
        b3 = c3;
      else {
        b3 = {}, so(c3, "text") && (b3.text = c3.text), so(c3, "rich") && (b3.rich = c3.rich), so(c3, "textFill") && (b3.fill = c3.textFill), so(c3, "textStroke") && (b3.stroke = c3.textStroke), so(c3, "fontFamily") && (b3.fontFamily = c3.fontFamily), so(c3, "fontSize") && (b3.fontSize = c3.fontSize), so(c3, "fontStyle") && (b3.fontStyle = c3.fontStyle), so(c3, "fontWeight") && (b3.fontWeight = c3.fontWeight), g3 = { type: "text", style: b3, silent: true }, p3 = {};
        var w3 = so(c3, "textPosition");
        t3 ? p3.position = w3 ? c3.textPosition : "inside" : w3 && (p3.position = c3.textPosition), so(c3, "textPosition") && (p3.position = c3.textPosition), so(c3, "textOffset") && (p3.offset = c3.textOffset), so(c3, "textRotation") && (p3.rotation = c3.textRotation), so(c3, "textDistance") && (p3.distance = c3.textDistance);
      }
      return Z9e(b3, o), yt(b3.rich, function(M) {
        Z9e(M, M);
      }), { textConfig: p3, textContent: g3 };
    }
    function Z9e(o, i) {
      !i || (i.font = i.textFont || i.font, so(i, "textStrokeWidth") && (o.lineWidth = i.textStrokeWidth), so(i, "textAlign") && (o.align = i.textAlign), so(i, "textVerticalAlign") && (o.verticalAlign = i.textVerticalAlign), so(i, "textLineHeight") && (o.lineHeight = i.textLineHeight), so(i, "textWidth") && (o.width = i.textWidth), so(i, "textHeight") && (o.height = i.textHeight), so(i, "textBackgroundColor") && (o.backgroundColor = i.textBackgroundColor), so(i, "textPadding") && (o.padding = i.textPadding), so(i, "textBorderColor") && (o.borderColor = i.textBorderColor), so(i, "textBorderWidth") && (o.borderWidth = i.textBorderWidth), so(i, "textBorderRadius") && (o.borderRadius = i.textBorderRadius), so(i, "textBoxShadowColor") && (o.shadowColor = i.textBoxShadowColor), so(i, "textBoxShadowBlur") && (o.shadowBlur = i.textBoxShadowBlur), so(i, "textBoxShadowOffsetX") && (o.shadowOffsetX = i.textBoxShadowOffsetX), so(i, "textBoxShadowOffsetY") && (o.shadowOffsetY = i.textBoxShadowOffsetY));
    }
    function J9e(o, i, t3) {
      var c3 = o;
      c3.textPosition = c3.textPosition || t3.position || "inside", t3.offset != null && (c3.textOffset = t3.offset), t3.rotation != null && (c3.textRotation = t3.rotation), t3.distance != null && (c3.textDistance = t3.distance);
      var p3 = c3.textPosition.indexOf("inside") >= 0, g3 = o.fill || "#000";
      Q9e(c3, i);
      var b3 = c3.textFill == null;
      return p3 ? b3 && (c3.textFill = t3.insideFill || "#fff", !c3.textStroke && t3.insideStroke && (c3.textStroke = t3.insideStroke), !c3.textStroke && (c3.textStroke = g3), c3.textStrokeWidth == null && (c3.textStrokeWidth = 2)) : (b3 && (c3.textFill = o.fill || t3.outsideFill || "#000"), !c3.textStroke && t3.outsideStroke && (c3.textStroke = t3.outsideStroke)), c3.text = i.text, c3.rich = i.rich, yt(i.rich, function(w3) {
        Q9e(w3, w3);
      }), c3;
    }
    function Q9e(o, i) {
      !i || (so(i, "fill") && (o.textFill = i.fill), so(i, "stroke") && (o.textStroke = i.fill), so(i, "lineWidth") && (o.textStrokeWidth = i.lineWidth), so(i, "font") && (o.font = i.font), so(i, "fontStyle") && (o.fontStyle = i.fontStyle), so(i, "fontWeight") && (o.fontWeight = i.fontWeight), so(i, "fontSize") && (o.fontSize = i.fontSize), so(i, "fontFamily") && (o.fontFamily = i.fontFamily), so(i, "align") && (o.textAlign = i.align), so(i, "verticalAlign") && (o.textVerticalAlign = i.verticalAlign), so(i, "lineHeight") && (o.textLineHeight = i.lineHeight), so(i, "width") && (o.textWidth = i.width), so(i, "height") && (o.textHeight = i.height), so(i, "backgroundColor") && (o.textBackgroundColor = i.backgroundColor), so(i, "padding") && (o.textPadding = i.padding), so(i, "borderColor") && (o.textBorderColor = i.borderColor), so(i, "borderWidth") && (o.textBorderWidth = i.borderWidth), so(i, "borderRadius") && (o.textBorderRadius = i.borderRadius), so(i, "shadowColor") && (o.textBoxShadowColor = i.shadowColor), so(i, "shadowBlur") && (o.textBoxShadowBlur = i.shadowBlur), so(i, "shadowOffsetX") && (o.textBoxShadowOffsetX = i.shadowOffsetX), so(i, "shadowOffsetY") && (o.textBoxShadowOffsetY = i.shadowOffsetY), so(i, "textShadowColor") && (o.textShadowColor = i.textShadowColor), so(i, "textShadowBlur") && (o.textShadowBlur = i.textShadowBlur), so(i, "textShadowOffsetX") && (o.textShadowOffsetX = i.textShadowOffsetX), so(i, "textShadowOffsetY") && (o.textShadowOffsetY = i.textShadowOffsetY));
    }
    var e7e = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, t7e = Gl(e7e);
    aw(dw, function(o, i) {
      return o[i] = 1, o;
    }, {}), dw.join(", ");
    var Ene = ["", "style", "shape", "extra"], U8 = mu();
    function sme(o, i, t3, c3, p3) {
      var g3 = o + "Animation", b3 = ek(o, c3, p3) || {}, w3 = U8(i).userDuring;
      return b3.duration > 0 && (b3.during = w3 ? Qa(iIt, { el: i, userDuring: w3 }) : null, b3.setToFinal = true, b3.scope = o), ti(b3, t3[g3]), b3;
    }
    function Dne(o, i, t3, c3) {
      c3 = c3 || {};
      var p3 = c3.dataIndex, g3 = c3.isInit, b3 = c3.clearStyle, w3 = t3.isAnimationEnabled(), M = U8(o), I = i.style;
      M.userDuring = i.during;
      var k3 = {}, L = {};
      if (oIt(o, i, L), i7e("shape", i, L), i7e("extra", i, L), !g3 && w3 && (aIt(o, i, k3), r7e("shape", o, i, k3), r7e("extra", o, i, k3), sIt(o, i, I, k3)), L.style = I, eIt(o, L, b3), nIt(o, i), w3)
        if (g3) {
          var F = {};
          yt(Ene, function(G) {
            var J = G ? i[G] : i;
            J && J.enterFrom && (G && (F[G] = F[G] || {}), ti(G ? F[G] : F, J.enterFrom));
          });
          var B = sme("enter", o, i, t3, p3);
          B.duration > 0 && o.animateFrom(F, B);
        } else
          tIt(o, i, p3 || 0, t3, k3);
      n7e(o, i), I ? o.dirty() : o.markRedraw();
    }
    function n7e(o, i) {
      for (var t3 = U8(o).leaveToProps, c3 = 0; c3 < Ene.length; c3++) {
        var p3 = Ene[c3], g3 = p3 ? i[p3] : i;
        g3 && g3.leaveTo && (t3 || (t3 = U8(o).leaveToProps = {}), p3 && (t3[p3] = t3[p3] || {}), ti(p3 ? t3[p3] : t3, g3.leaveTo));
      }
    }
    function kne(o, i, t3, c3) {
      if (o) {
        var p3 = o.parent, g3 = U8(o).leaveToProps;
        if (g3) {
          var b3 = sme("update", o, i, t3, 0);
          b3.done = function() {
            p3.remove(o), c3 && c3();
          }, o.animateTo(g3, b3);
        } else
          p3.remove(o), c3 && c3();
      }
    }
    function IL(o) {
      return o === "all";
    }
    function eIt(o, i, t3) {
      var c3 = i.style;
      if (!o.isGroup && c3) {
        if (t3) {
          o.useStyle({});
          for (var p3 = o.animators, g3 = 0; g3 < p3.length; g3++) {
            var b3 = p3[g3];
            b3.targetName === "style" && b3.changeTarget(o.style);
          }
        }
        o.setStyle(c3);
      }
      i && (i.style = null, i && o.attr(i), i.style = c3);
    }
    function tIt(o, i, t3, c3, p3) {
      if (p3) {
        var g3 = sme("update", o, i, c3, t3);
        g3.duration > 0 && o.animateFrom(p3, g3);
      }
    }
    function nIt(o, i) {
      so(i, "silent") && (o.silent = i.silent), so(i, "ignore") && (o.ignore = i.ignore), o instanceof Ab && so(i, "invisible") && (o.invisible = i.invisible), o instanceof gl && so(i, "autoBatch") && (o.autoBatch = i.autoBatch);
    }
    var nT = {}, rIt = { setTransform: function(o, i) {
      return nT.el[o] = i, this;
    }, getTransform: function(o) {
      return nT.el[o];
    }, setShape: function(o, i) {
      var t3 = nT.el, c3 = t3.shape || (t3.shape = {});
      return c3[o] = i, t3.dirtyShape && t3.dirtyShape(), this;
    }, getShape: function(o) {
      var i = nT.el.shape;
      if (i)
        return i[o];
    }, setStyle: function(o, i) {
      var t3 = nT.el, c3 = t3.style;
      return c3 && (c3[o] = i, t3.dirtyStyle && t3.dirtyStyle()), this;
    }, getStyle: function(o) {
      var i = nT.el.style;
      if (i)
        return i[o];
    }, setExtra: function(o, i) {
      var t3 = nT.el.extra || (nT.el.extra = {});
      return t3[o] = i, this;
    }, getExtra: function(o) {
      var i = nT.el.extra;
      if (i)
        return i[o];
    } };
    function iIt() {
      var o = this, i = o.el;
      if (i) {
        var t3 = U8(i).userDuring, c3 = o.userDuring;
        if (t3 !== c3) {
          o.el = o.userDuring = null;
          return;
        }
        nT.el = i, c3(rIt);
      }
    }
    function r7e(o, i, t3, c3) {
      var p3 = t3[o];
      if (p3) {
        var g3 = i[o], b3;
        if (g3) {
          var w3 = t3.transition, M = p3.transition;
          if (M)
            if (!b3 && (b3 = c3[o] = {}), IL(M))
              ti(b3, g3);
            else
              for (var I = Wc(M), k3 = 0; k3 < I.length; k3++) {
                var L = I[k3], F = g3[L];
                b3[L] = F;
              }
          else if (IL(w3) || rl(w3, o) >= 0) {
            !b3 && (b3 = c3[o] = {});
            for (var B = Gl(g3), k3 = 0; k3 < B.length; k3++) {
              var L = B[k3], F = g3[L];
              lIt(p3[L], F) && (b3[L] = F);
            }
          }
        }
      }
    }
    function i7e(o, i, t3) {
      var c3 = i[o];
      if (c3)
        for (var p3 = t3[o] = {}, g3 = Gl(c3), b3 = 0; b3 < g3.length; b3++) {
          var w3 = g3[b3];
          p3[w3] = E1(c3[w3]);
        }
    }
    function aIt(o, i, t3) {
      for (var c3 = i.transition, p3 = IL(c3) ? dw : Wc(c3 || []), g3 = 0; g3 < p3.length; g3++) {
        var b3 = p3[g3];
        if (!(b3 === "style" || b3 === "shape" || b3 === "extra")) {
          var w3 = o[b3];
          t3[b3] = w3;
        }
      }
    }
    function oIt(o, i, t3) {
      for (var c3 = 0; c3 < t7e.length; c3++) {
        var p3 = t7e[c3], g3 = e7e[p3], b3 = i[p3];
        b3 && (t3[g3[0]] = b3[0], t3[g3[1]] = b3[1]);
      }
      for (var c3 = 0; c3 < dw.length; c3++) {
        var w3 = dw[c3];
        i[w3] != null && (t3[w3] = i[w3]);
      }
    }
    function sIt(o, i, t3, c3) {
      if (t3) {
        var p3 = o.style, g3;
        if (p3) {
          var b3 = t3.transition, w3 = i.transition;
          if (b3 && !IL(b3)) {
            var M = Wc(b3);
            !g3 && (g3 = c3.style = {});
            for (var I = 0; I < M.length; I++) {
              var k3 = M[I], L = p3[k3];
              g3[k3] = L;
            }
          } else if (o.getAnimationStyleProps && (IL(w3) || IL(b3) || rl(w3, "style") >= 0)) {
            var F = o.getAnimationStyleProps(), B = F ? F.style : null;
            if (B) {
              !g3 && (g3 = c3.style = {});
              for (var G = Gl(t3), I = 0; I < G.length; I++) {
                var k3 = G[I];
                if (B[k3]) {
                  var L = p3[k3];
                  g3[k3] = L;
                }
              }
            }
          }
        }
      }
    }
    function lIt(o, i) {
      return yg(o) ? o !== i : o != null && isFinite(o);
    }
    var a7e = mu(), uIt = ["percent", "easing", "shape", "style", "extra"];
    function o7e(o) {
      o.stopAnimation("keyframe"), o.attr(a7e(o));
    }
    function One(o, i, t3) {
      if (!(!t3.isAnimationEnabled() || !i)) {
        if (Ei(i)) {
          yt(i, function(w3) {
            One(o, w3, t3);
          });
          return;
        }
        var c3 = i.keyframes, p3 = i.duration;
        if (t3 && p3 == null) {
          var g3 = ek("enter", t3, 0);
          p3 = g3 && g3.duration;
        }
        if (!(!c3 || !p3)) {
          var b3 = a7e(o);
          yt(Ene, function(w3) {
            if (!(w3 && !o[w3])) {
              var M;
              c3.sort(function(I, k3) {
                return I.percent - k3.percent;
              }), yt(c3, function(I) {
                var k3 = o.animators, L = w3 ? I[w3] : I;
                if (L) {
                  var F = Gl(L);
                  if (w3 || (F = Zc(F, function(J) {
                    return rl(uIt, J) < 0;
                  })), !!F.length) {
                    M || (M = o.animate(w3, i.loop, true), M.scope = "keyframe");
                    for (var B = 0; B < k3.length; B++)
                      k3[B] !== M && k3[B].targetName === M.targetName && k3[B].stopTracks(F);
                    w3 && (b3[w3] = b3[w3] || {});
                    var G = w3 ? b3[w3] : b3;
                    yt(F, function(J) {
                      G[J] = ((w3 ? o[w3] : o) || {})[J];
                    }), M.whenWithKeys(p3 * I.percent, L, F, I.easing);
                  }
                }
              }), M && M.delay(i.delay || 0).duration(p3).start(i.easing);
            }
          });
        }
      }
    }
    var HI = "emphasis", mk = "normal", lme = "blur", ume = "select", bk = [mk, HI, lme, ume], cme = { normal: ["itemStyle"], emphasis: [HI, "itemStyle"], blur: [lme, "itemStyle"], select: [ume, "itemStyle"] }, fme = { normal: ["label"], emphasis: [HI, "label"], blur: [lme, "label"], select: [ume, "label"] }, cIt = ["x", "y"], fIt = "e\0\0", Fw = { normal: {}, emphasis: {}, blur: {}, select: {} }, hIt = { cartesian2d: qAt, geo: XAt, singleAxis: KAt, polar: JAt, calendar: QAt };
    function hme(o) {
      return o instanceof gl;
    }
    function pme(o) {
      return o instanceof Ab;
    }
    function pIt(o, i) {
      i.copyTransform(o), pme(i) && pme(o) && (i.setStyle(o.style), i.z = o.z, i.z2 = o.z2, i.zlevel = o.zlevel, i.invisible = o.invisible, i.ignore = o.ignore, hme(i) && hme(o) && i.setShape(o.shape));
    }
    var dIt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        this._progressiveEls = null;
        var b3 = this._data, w3 = t3.getData(), M = this.group, I = l7e(t3, w3, c3, p3);
        b3 || M.removeAll(), w3.diff(b3).add(function(L) {
          gme(p3, null, L, I(L, g3), t3, M, w3);
        }).remove(function(L) {
          var F = b3.getItemGraphicEl(L);
          kne(F, GI(F).option, t3);
        }).update(function(L, F) {
          var B = b3.getItemGraphicEl(F);
          gme(p3, B, L, I(L, g3), t3, M, w3);
        }).execute();
        var k3 = t3.get("clip", true) ? nne(t3.coordinateSystem, false, t3) : null;
        k3 ? M.setClipPath(k3) : M.removeClipPath(), this._data = w3;
      }, i.prototype.incrementalPrepareRender = function(t3, c3, p3) {
        this.group.removeAll(), this._data = null;
      }, i.prototype.incrementalRender = function(t3, c3, p3, g3, b3) {
        var w3 = c3.getData(), M = l7e(c3, w3, p3, g3), I = this._progressiveEls = [];
        function k3(B) {
          B.isGroup || (B.incremental = true, B.ensureState("emphasis").hoverLayer = true);
        }
        for (var L = t3.start; L < t3.end; L++) {
          var F = gme(null, null, L, M(L, b3), c3, this.group, w3);
          F && (F.traverse(k3), I.push(F));
        }
      }, i.prototype.eachRendered = function(t3) {
        nk(this._progressiveEls || this.group, t3);
      }, i.prototype.filterForExposedEvent = function(t3, c3, p3, g3) {
        var b3 = c3.element;
        if (b3 == null || p3.name === b3)
          return true;
        for (; (p3 = p3.__hostTarget || p3.parent) && p3 !== this.group; )
          if (p3.name === b3)
            return true;
        return false;
      }, i.type = "custom", i;
    }(yh), vIt = dIt;
    function dme(o) {
      var i = o.type, t3;
      if (i === "path") {
        var c3 = o.shape, p3 = c3.width != null && c3.height != null ? { x: c3.x || 0, y: c3.y || 0, width: c3.width, height: c3.height } : null, g3 = p7e(c3);
        t3 = jn(g3, null, p3, c3.layout || "center"), GI(t3).customPathData = g3;
      } else if (i === "image")
        t3 = new Gv({}), GI(t3).customImagePath = o.style.image;
      else if (i === "text")
        t3 = new Fl({});
      else if (i === "group")
        t3 = new vs();
      else {
        if (i === "compoundPath")
          throw new Error('"compoundPath" is not supported yet.');
        var b3 = nn(i);
        if (!b3) {
          var w3 = "";
          Fu(w3);
        }
        t3 = new b3();
      }
      return GI(t3).customGraphicType = i, t3.name = o.name, t3.z2EmphasisLift = 1, t3.z2SelectLift = 1, t3;
    }
    function vme(o, i, t3, c3, p3, g3, b3) {
      o7e(i);
      var w3 = p3 && p3.normal.cfg;
      w3 && i.setTextConfig(w3), c3 && c3.transition == null && (c3.transition = cIt);
      var M = c3 && c3.style;
      if (M) {
        if (i.type === "text") {
          var I = M;
          so(I, "textFill") && (I.fill = I.textFill), so(I, "textStroke") && (I.stroke = I.textStroke);
        }
        var k3 = void 0, L = hme(i) ? M.decal : null;
        o && L && (L.dirty = true, k3 = GH(L, o)), M.__decalPattern = k3;
      }
      if (pme(i) && M) {
        var k3 = M.__decalPattern;
        k3 && (M.decal = k3);
      }
      Dne(i, c3, g3, { dataIndex: t3, isInit: b3, clearStyle: true }), One(i, c3.keyframeAnimation, g3);
    }
    function s7e(o, i, t3, c3, p3) {
      var g3 = i.isGroup ? null : i, b3 = p3 && p3[o].cfg;
      if (g3) {
        var w3 = g3.ensureState(o);
        if (c3 === false) {
          var M = g3.getState(o);
          M && (M.style = null);
        } else
          w3.style = c3 || null;
        b3 && (w3.textConfig = b3), AI(g3);
      }
    }
    function gIt(o, i, t3) {
      if (!o.isGroup) {
        var c3 = o, p3 = t3.currentZ, g3 = t3.currentZLevel;
        c3.z = p3, c3.zlevel = g3;
        var b3 = i.z2;
        b3 != null && (c3.z2 = b3 || 0);
        for (var w3 = 0; w3 < bk.length; w3++)
          yIt(c3, i, bk[w3]);
      }
    }
    function yIt(o, i, t3) {
      var c3 = t3 === mk, p3 = c3 ? i : Pne(i, t3), g3 = p3 ? p3.z2 : null, b3;
      g3 != null && (b3 = c3 ? o : o.ensureState(t3), b3.z2 = g3 || 0);
    }
    function l7e(o, i, t3, c3) {
      var p3 = o.get("renderItem"), g3 = o.coordinateSystem, b3 = {};
      g3 && (b3 = g3.prepareCustoms ? g3.prepareCustoms(g3) : hIt[g3.type](g3));
      for (var w3 = Uo({ getWidth: c3.getWidth, getHeight: c3.getHeight, getZr: c3.getZr, getDevicePixelRatio: c3.getDevicePixelRatio, value: de, style: Pe, ordinalRawValue: Fe, styleEmphasis: ze, visual: nt, barLayout: lt2, currentSeriesIndices: bt, font: vt }, b3.api || {}), M = { context: {}, seriesId: o.id, seriesName: o.name, seriesIndex: o.seriesIndex, coordSys: b3.coordSys, dataInsideLength: i.count(), encode: mIt(o.getData()) }, I, k3, L = {}, F = {}, B = {}, G = {}, J = 0; J < bk.length; J++) {
        var Q = bk[J];
        B[Q] = o.getModel(cme[Q]), G[Q] = o.getModel(fme[Q]);
      }
      function se(jt) {
        return jt === I ? k3 || (k3 = i.getItemModel(jt)) : i.getItemModel(jt);
      }
      function he(jt, Jt) {
        return i.hasItemOption ? jt === I ? L[Jt] || (L[Jt] = se(jt).getModel(cme[Jt])) : se(jt).getModel(cme[Jt]) : B[Jt];
      }
      function be(jt, Jt) {
        return i.hasItemOption ? jt === I ? F[Jt] || (F[Jt] = se(jt).getModel(fme[Jt])) : se(jt).getModel(fme[Jt]) : G[Jt];
      }
      return function(jt, Jt) {
        return I = jt, k3 = null, L = {}, F = {}, p3 && p3(Uo({ dataIndexInside: jt, dataIndex: i.getRawIndex(jt), actionType: Jt ? Jt.type : null }, M), w3);
      };
      function de(jt, Jt) {
        return Jt == null && (Jt = I), i.getStore().get(i.getDimensionIndex(jt || 0), Jt);
      }
      function Fe(jt, Jt) {
        Jt == null && (Jt = I), jt = jt || 0;
        var Rt = i.getDimensionInfo(jt);
        if (!Rt) {
          var Jn = i.getDimensionIndex(jt);
          return Jn >= 0 ? i.getStore().get(Jn, Jt) : void 0;
        }
        var ln = i.get(Rt.name, Jt), vn = Rt && Rt.ordinalMeta;
        return vn ? vn.categories[ln] : ln;
      }
      function Pe(jt, Jt) {
        Jt == null && (Jt = I);
        var Rt = i.getItemVisual(Jt, "style"), Jn = Rt && Rt.fill, ln = Rt && Rt.opacity, vn = he(Jt, mk).getItemStyle();
        Jn != null && (vn.fill = Jn), ln != null && (vn.opacity = ln);
        var kn = { inheritColor: Ha(Jn) ? Jn : "#000" }, cr = be(Jt, mk), gr = qd(cr, null, kn, false, true);
        gr.text = cr.getShallow("show") ? Xs(o.getFormattedLabel(Jt, mk), L8(i, Jt)) : null;
        var ha = ite(cr, kn, false);
        return Ke(jt, vn), vn = J9e(vn, gr, ha), jt && $e(vn, jt), vn.legacy = true, vn;
      }
      function ze(jt, Jt) {
        Jt == null && (Jt = I);
        var Rt = he(Jt, HI).getItemStyle(), Jn = be(Jt, HI), ln = qd(Jn, null, null, true, true);
        ln.text = Jn.getShallow("show") ? np(o.getFormattedLabel(Jt, HI), o.getFormattedLabel(Jt, mk), L8(i, Jt)) : null;
        var vn = ite(Jn, null, true);
        return Ke(jt, Rt), Rt = J9e(Rt, ln, vn), jt && $e(Rt, jt), Rt.legacy = true, Rt;
      }
      function $e(jt, Jt) {
        for (var Rt in Jt)
          so(Jt, Rt) && (jt[Rt] = Jt[Rt]);
      }
      function Ke(jt, Jt) {
        jt && (jt.textFill && (Jt.textFill = jt.textFill), jt.textPosition && (Jt.textPosition = jt.textPosition));
      }
      function nt(jt, Jt) {
        if (Jt == null && (Jt = I), so(X9e, jt)) {
          var Rt = i.getItemVisual(Jt, "style");
          return Rt ? Rt[X9e[jt]] : null;
        }
        if (so(GAt, jt))
          return i.getItemVisual(Jt, jt);
      }
      function lt2(jt) {
        if (g3.type === "cartesian2d") {
          var Jt = g3.getBaseAxis();
          return b1t(Uo({ axis: Jt }, jt));
        }
      }
      function bt() {
        return t3.getCurrentSeriesIndices();
      }
      function vt(jt) {
        return YPe(jt, t3);
      }
    }
    function mIt(o) {
      var i = {};
      return yt(o.dimensions, function(t3) {
        var c3 = o.getDimensionInfo(t3);
        if (!c3.isExtraCoord) {
          var p3 = c3.coordDim, g3 = i[p3] = i[p3] || [];
          g3[c3.coordDimIndex] = o.getDimensionIndex(t3);
        }
      }), i;
    }
    function gme(o, i, t3, c3, p3, g3, b3) {
      if (!c3) {
        g3.remove(i);
        return;
      }
      var w3 = yme(o, i, t3, c3, p3, g3);
      return w3 && b3.setItemGraphicEl(t3, w3), w3 && zp(w3, c3.focus, c3.blurScope, c3.emphasisDisabled), w3;
    }
    function yme(o, i, t3, c3, p3, g3) {
      var b3 = -1, w3 = i;
      i && u7e(i, c3, p3) && (b3 = rl(g3.childrenRef(), i), i = null);
      var M = !i, I = i;
      I ? I.clearStates() : (I = dme(c3), w3 && pIt(w3, I)), c3.morph === false ? I.disableMorphing = true : I.disableMorphing && (I.disableMorphing = false), Fw.normal.cfg = Fw.normal.conOpt = Fw.emphasis.cfg = Fw.emphasis.conOpt = Fw.blur.cfg = Fw.blur.conOpt = Fw.select.cfg = Fw.select.conOpt = null, Fw.isLegacy = false, _It(I, t3, c3, p3, M, Fw), bIt(I, t3, c3, p3, M), vme(o, I, t3, c3, Fw, p3, M), so(c3, "info") && (GI(I).info = c3.info);
      for (var k3 = 0; k3 < bk.length; k3++) {
        var L = bk[k3];
        if (L !== mk) {
          var F = Pne(c3, L), B = mme(c3, F, L);
          s7e(L, I, F, B, Fw);
        }
      }
      return gIt(I, c3, p3), c3.type === "group" && xIt(o, I, t3, c3, p3), b3 >= 0 ? g3.replaceAt(I, b3) : g3.add(I), I;
    }
    function u7e(o, i, t3) {
      var c3 = GI(o), p3 = i.type, g3 = i.shape, b3 = i.style;
      return t3.isUniversalTransitionEnabled() || p3 != null && p3 !== c3.customGraphicType || p3 === "path" && CIt(g3) && p7e(g3) !== c3.customPathData || p3 === "image" && so(b3, "image") && b3.image !== c3.customImagePath;
    }
    function bIt(o, i, t3, c3, p3) {
      var g3 = t3.clipPath;
      if (g3 === false)
        o && o.getClipPath() && o.removeClipPath();
      else if (g3) {
        var b3 = o.getClipPath();
        b3 && u7e(b3, g3, c3) && (b3 = null), b3 || (b3 = dme(g3), o.setClipPath(b3)), vme(null, b3, i, g3, null, c3, p3);
      }
    }
    function _It(o, i, t3, c3, p3, g3) {
      if (!o.isGroup) {
        c7e(t3, null, g3), c7e(t3, HI, g3);
        var b3 = g3.normal.conOpt, w3 = g3.emphasis.conOpt, M = g3.blur.conOpt, I = g3.select.conOpt;
        if (b3 != null || w3 != null || I != null || M != null) {
          var k3 = o.getTextContent();
          if (b3 === false)
            k3 && o.removeTextContent();
          else {
            b3 = g3.normal.conOpt = b3 || { type: "text" }, k3 ? k3.clearStates() : (k3 = dme(b3), o.setTextContent(k3)), vme(null, k3, i, b3, null, c3, p3);
            for (var L = b3 && b3.style, F = 0; F < bk.length; F++) {
              var B = bk[F];
              if (B !== mk) {
                var G = g3[B].conOpt;
                s7e(B, k3, G, mme(b3, G, B), null);
              }
            }
            L ? k3.dirty() : k3.markRedraw();
          }
        }
      }
    }
    function c7e(o, i, t3) {
      var c3 = i ? Pne(o, i) : o, p3 = i ? mme(o, c3, HI) : o.style, g3 = o.type, b3 = c3 ? c3.textConfig : null, w3 = o.textContent, M = w3 ? i ? Pne(w3, i) : w3 : null;
      if (p3 && (t3.isLegacy || Y9e(p3, g3, !!b3, !!M))) {
        t3.isLegacy = true;
        var I = K9e(p3, g3, !i);
        !b3 && I.textConfig && (b3 = I.textConfig), !M && I.textContent && (M = I.textContent);
      }
      if (!i && M) {
        var k3 = M;
        !k3.type && (k3.type = "text");
      }
      var L = i ? t3[i] : t3.normal;
      L.cfg = b3, L.conOpt = M;
    }
    function Pne(o, i) {
      return i ? o ? o[i] : null : o;
    }
    function mme(o, i, t3) {
      var c3 = i && i.style;
      return c3 == null && t3 === HI && o && (c3 = o.styleEmphasis), c3;
    }
    function xIt(o, i, t3, c3, p3) {
      var g3 = c3.children, b3 = g3 ? g3.length : 0, w3 = c3.$mergeChildren, M = w3 === "byName" || c3.diffChildrenByName, I = w3 === false;
      if (!(!b3 && !M && !I)) {
        if (M) {
          wIt({ api: o, oldChildren: i.children() || [], newChildren: g3 || [], dataIndex: t3, seriesModel: p3, group: i });
          return;
        }
        I && i.removeAll();
        for (var k3 = 0; k3 < b3; k3++)
          g3[k3] && yme(o, i.childAt(k3), t3, g3[k3], p3, i);
        for (var L = i.childCount() - 1; L >= k3; L--) {
          var F = i.childAt(L);
          kne(F, GI(i).option, p3);
        }
      }
    }
    function wIt(o) {
      new RI(o.oldChildren, o.newChildren, f7e, f7e, o).add(h7e).update(h7e).remove(SIt).execute();
    }
    function f7e(o, i) {
      var t3 = o && o.name;
      return t3 != null ? t3 : fIt + i;
    }
    function h7e(o, i) {
      var t3 = this.context, c3 = o != null ? t3.newChildren[o] : null, p3 = i != null ? t3.oldChildren[i] : null;
      yme(t3.api, p3, t3.dataIndex, c3, t3.seriesModel, t3.group);
    }
    function SIt(o) {
      var i = this.context, t3 = i.oldChildren[o];
      kne(t3, GI(t3).option, i.seriesModel);
    }
    function p7e(o) {
      return o && (o.pathData || o.d);
    }
    function CIt(o) {
      return o && (so(o, "pathData") || so(o, "d"));
    }
    function MIt(o) {
      o.registerChartView(vIt), o.registerSeriesModel(WAt);
    }
    var EL = mu(), d7e = Jo, bme = Qa, TIt = function() {
      function o() {
        this._dragging = false, this.animationThreshold = 15;
      }
      return o.prototype.render = function(i, t3, c3, p3) {
        var g3 = t3.get("value"), b3 = t3.get("status");
        if (this._axisModel = i, this._axisPointerModel = t3, this._api = c3, !(!p3 && this._lastValue === g3 && this._lastStatus === b3)) {
          this._lastValue = g3, this._lastStatus = b3;
          var w3 = this._group, M = this._handle;
          if (!b3 || b3 === "hide") {
            w3 && w3.hide(), M && M.hide();
            return;
          }
          w3 && w3.show(), M && M.show();
          var I = {};
          this.makeElOption(I, g3, i, t3, c3);
          var k3 = I.graphicKey;
          k3 !== this._lastGraphicKey && this.clear(c3), this._lastGraphicKey = k3;
          var L = this._moveAnimation = this.determineAnimation(i, t3);
          if (!w3)
            w3 = this._group = new vs(), this.createPointerEl(w3, I, i, t3), this.createLabelEl(w3, I, i, t3), c3.getZr().add(w3);
          else {
            var F = As(v7e, t3, L);
            this.updatePointerEl(w3, I, F), this.updateLabelEl(w3, I, F, t3);
          }
          m7e(w3, t3, true), this._renderHandle(g3);
        }
      }, o.prototype.remove = function(i) {
        this.clear(i);
      }, o.prototype.dispose = function(i) {
        this.clear(i);
      }, o.prototype.determineAnimation = function(i, t3) {
        var c3 = t3.get("animation"), p3 = i.axis, g3 = p3.type === "category", b3 = t3.get("snap");
        if (!b3 && !g3)
          return false;
        if (c3 === "auto" || c3 == null) {
          var w3 = this.animationThreshold;
          if (g3 && p3.getBandWidth() > w3)
            return true;
          if (b3) {
            var M = $0e(i).seriesDataCount, I = p3.getExtent();
            return Math.abs(I[0] - I[1]) / M > w3;
          }
          return false;
        }
        return c3 === true;
      }, o.prototype.makeElOption = function(i, t3, c3, p3, g3) {
      }, o.prototype.createPointerEl = function(i, t3, c3, p3) {
        var g3 = t3.pointer;
        if (g3) {
          var b3 = EL(i).pointerEl = new SH[g3.type](d7e(t3.pointer));
          i.add(b3);
        }
      }, o.prototype.createLabelEl = function(i, t3, c3, p3) {
        if (t3.label) {
          var g3 = EL(i).labelEl = new Fl(d7e(t3.label));
          i.add(g3), y7e(g3, p3);
        }
      }, o.prototype.updatePointerEl = function(i, t3, c3) {
        var p3 = EL(i).pointerEl;
        p3 && t3.pointer && (p3.setStyle(t3.pointer.style), c3(p3, { shape: t3.pointer.shape }));
      }, o.prototype.updateLabelEl = function(i, t3, c3, p3) {
        var g3 = EL(i).labelEl;
        g3 && (g3.setStyle(t3.label.style), c3(g3, { x: t3.label.x, y: t3.label.y }), y7e(g3, p3));
      }, o.prototype._renderHandle = function(i) {
        if (!(this._dragging || !this.updateHandleTransform)) {
          var t3 = this._axisPointerModel, c3 = this._api.getZr(), p3 = this._handle, g3 = t3.getModel("handle"), b3 = t3.get("status");
          if (!g3.get("show") || !b3 || b3 === "hide") {
            p3 && c3.remove(p3), this._handle = null;
            return;
          }
          var w3;
          this._handle || (w3 = true, p3 = this._handle = ip(g3.get("icon"), { cursor: "move", draggable: true, onmousemove: function(I) {
            R2(I.event);
          }, onmousedown: bme(this._onHandleDragMove, this, 0, 0), drift: bme(this._onHandleDragMove, this), ondragend: bme(this._onHandleDragEnd, this) }), c3.add(p3)), m7e(p3, t3, false), p3.setStyle(g3.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
          var M = g3.get("size");
          Ei(M) || (M = [M, M]), p3.scaleX = M[0] / 2, p3.scaleY = M[1] / 2, M8(this, "_doDispatchAxisPointer", g3.get("throttle") || 0, "fixRate"), this._moveHandleToValue(i, w3);
        }
      }, o.prototype._moveHandleToValue = function(i, t3) {
        v7e(this._axisPointerModel, !t3 && this._moveAnimation, this._handle, _me(this.getHandleTransform(i, this._axisModel, this._axisPointerModel)));
      }, o.prototype._onHandleDragMove = function(i, t3) {
        var c3 = this._handle;
        if (c3) {
          this._dragging = true;
          var p3 = this.updateHandleTransform(_me(c3), [i, t3], this._axisModel, this._axisPointerModel);
          this._payloadInfo = p3, c3.stopAnimation(), c3.attr(_me(p3)), EL(c3).lastProp = null, this._doDispatchAxisPointer();
        }
      }, o.prototype._doDispatchAxisPointer = function() {
        var i = this._handle;
        if (i) {
          var t3 = this._payloadInfo, c3 = this._axisModel;
          this._api.dispatchAction({ type: "updateAxisPointer", x: t3.cursorPoint[0], y: t3.cursorPoint[1], tooltipOption: t3.tooltipOption, axesInfo: [{ axisDim: c3.axis.dim, axisIndex: c3.componentIndex }] });
        }
      }, o.prototype._onHandleDragEnd = function() {
        this._dragging = false;
        var i = this._handle;
        if (i) {
          var t3 = this._axisPointerModel.get("value");
          this._moveHandleToValue(t3), this._api.dispatchAction({ type: "hideTip" });
        }
      }, o.prototype.clear = function(i) {
        this._lastValue = null, this._lastStatus = null;
        var t3 = i.getZr(), c3 = this._group, p3 = this._handle;
        t3 && c3 && (this._lastGraphicKey = null, c3 && t3.remove(c3), p3 && t3.remove(p3), this._group = null, this._handle = null, this._payloadInfo = null), NH(this, "_doDispatchAxisPointer");
      }, o.prototype.doClear = function() {
      }, o.prototype.buildLabel = function(i, t3, c3) {
        return c3 = c3 || 0, { x: i[c3], y: i[1 - c3], width: t3[c3], height: t3[1 - c3] };
      }, o;
    }();
    function v7e(o, i, t3, c3) {
      g7e(EL(t3).lastProp, c3) || (EL(t3).lastProp = c3, i ? Du(t3, c3, o) : (t3.stopAnimation(), t3.attr(c3)));
    }
    function g7e(o, i) {
      if (Ua(o) && Ua(i)) {
        var t3 = true;
        return yt(i, function(c3, p3) {
          t3 = t3 && g7e(o[p3], c3);
        }), !!t3;
      } else
        return o === i;
    }
    function y7e(o, i) {
      o[i.get(["label", "show"]) ? "show" : "hide"]();
    }
    function _me(o) {
      return { x: o.x || 0, y: o.y || 0, rotation: o.rotation || 0 };
    }
    function m7e(o, i, t3) {
      var c3 = i.get("z"), p3 = i.get("zlevel");
      o && o.traverse(function(g3) {
        g3.type !== "group" && (c3 != null && (g3.z = c3), p3 != null && (g3.zlevel = p3), g3.silent = t3);
      });
    }
    var xme = TIt;
    function wme(o) {
      var i = o.get("type"), t3 = o.getModel(i + "Style"), c3;
      return i === "line" ? (c3 = t3.getLineStyle(), c3.fill = null) : i === "shadow" && (c3 = t3.getAreaStyle(), c3.stroke = null), c3;
    }
    function b7e(o, i, t3, c3, p3) {
      var g3 = t3.get("value"), b3 = _7e(g3, i.axis, i.ecModel, t3.get("seriesDataIndices"), { precision: t3.get(["label", "precision"]), formatter: t3.get(["label", "formatter"]) }), w3 = t3.getModel("label"), M = y8(w3.get("padding") || 0), I = w3.getFont(), k3 = pI(b3, I), L = p3.position, F = k3.width + M[1] + M[3], B = k3.height + M[0] + M[2], G = p3.align;
      G === "right" && (L[0] -= F), G === "center" && (L[0] -= F / 2);
      var J = p3.verticalAlign;
      J === "bottom" && (L[1] -= B), J === "middle" && (L[1] -= B / 2), AIt(L, F, B, c3);
      var Q = w3.get("backgroundColor");
      (!Q || Q === "auto") && (Q = i.get(["axisLine", "lineStyle", "color"])), o.label = { x: L[0], y: L[1], style: qd(w3, { text: b3, font: I, fill: w3.getTextColor(), padding: M, backgroundColor: Q }), z2: 10 };
    }
    function AIt(o, i, t3, c3) {
      var p3 = c3.getWidth(), g3 = c3.getHeight();
      o[0] = Math.min(o[0] + i, p3) - i, o[1] = Math.min(o[1] + t3, g3) - t3, o[0] = Math.max(o[0], 0), o[1] = Math.max(o[1], 0);
    }
    function _7e(o, i, t3, c3, p3) {
      o = i.scale.parse(o);
      var g3 = i.scale.getLabel({ value: o }, { precision: p3.precision }), b3 = p3.formatter;
      if (b3) {
        var w3 = { value: v0e(i, { value: o }), axisDimension: i.dim, axisIndex: i.index, seriesData: [] };
        yt(c3, function(M) {
          var I = t3.getSeriesByIndex(M.seriesIndex), k3 = M.dataIndexInside, L = I && I.getDataParams(k3);
          L && w3.seriesData.push(L);
        }), Ha(b3) ? g3 = b3.replace("{value}", g3) : Vo(b3) && (g3 = b3(w3));
      }
      return g3;
    }
    function Sme(o, i, t3) {
      var c3 = dm();
      return cI(c3, c3, t3.rotation), D1(c3, c3, t3.position), ll([o.dataToCoord(i), (t3.labelOffset || 0) + (t3.labelDirection || 1) * (t3.labelMargin || 0)], c3);
    }
    function x7e(o, i, t3, c3, p3, g3) {
      var b3 = BI.innerTextLayout(t3.rotation, 0, t3.labelDirection);
      t3.labelMargin = p3.get(["label", "margin"]), b7e(i, c3, p3, g3, { position: Sme(c3.axis, o, t3), align: b3.textAlign, verticalAlign: b3.textVerticalAlign });
    }
    function Cme(o, i, t3) {
      return t3 = t3 || 0, { x1: o[t3], y1: o[1 - t3], x2: i[t3], y2: i[1 - t3] };
    }
    function w7e(o, i, t3) {
      return t3 = t3 || 0, { x: o[t3], y: o[1 - t3], width: i[t3], height: i[1 - t3] };
    }
    function S7e(o, i, t3, c3, p3, g3) {
      return { cx: o, cy: i, r0: t3, r: c3, startAngle: p3, endAngle: g3, clockwise: true };
    }
    var IIt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.makeElOption = function(t3, c3, p3, g3, b3) {
        var w3 = p3.axis, M = w3.grid, I = g3.get("type"), k3 = C7e(M, w3).getOtherAxis(w3).getGlobalExtent(), L = w3.toGlobalCoord(w3.dataToCoord(c3, true));
        if (I && I !== "none") {
          var F = wme(g3), B = EIt[I](w3, L, k3);
          B.style = F, t3.graphicKey = B.type, t3.pointer = B;
        }
        var G = H0e(M.model, p3);
        x7e(c3, t3, G, p3, g3, b3);
      }, i.prototype.getHandleTransform = function(t3, c3, p3) {
        var g3 = H0e(c3.axis.grid.model, c3, { labelInside: false });
        g3.labelMargin = p3.get(["handle", "margin"]);
        var b3 = Sme(c3.axis, t3, g3);
        return { x: b3[0], y: b3[1], rotation: g3.rotation + (g3.labelDirection < 0 ? Math.PI : 0) };
      }, i.prototype.updateHandleTransform = function(t3, c3, p3, g3) {
        var b3 = p3.axis, w3 = b3.grid, M = b3.getGlobalExtent(true), I = C7e(w3, b3).getOtherAxis(b3).getGlobalExtent(), k3 = b3.dim === "x" ? 0 : 1, L = [t3.x, t3.y];
        L[k3] += c3[k3], L[k3] = Math.min(M[1], L[k3]), L[k3] = Math.max(M[0], L[k3]);
        var F = (I[1] + I[0]) / 2, B = [F, F];
        B[k3] = L[k3];
        var G = [{ verticalAlign: "middle" }, { align: "center" }];
        return { x: L[0], y: L[1], rotation: t3.rotation, cursorPoint: B, tooltipOption: G[k3] };
      }, i;
    }(xme);
    function C7e(o, i) {
      var t3 = {};
      return t3[i.dim + "AxisIndex"] = i.index, o.getCartesian(t3);
    }
    var EIt = { line: function(o, i, t3) {
      var c3 = Cme([i, t3[0]], [i, t3[1]], M7e(o));
      return { type: "Line", subPixelOptimize: true, shape: c3 };
    }, shadow: function(o, i, t3) {
      var c3 = Math.max(1, o.getBandWidth()), p3 = t3[1] - t3[0];
      return { type: "Rect", shape: w7e([i - c3 / 2, t3[0]], [c3, p3], M7e(o)) };
    } };
    function M7e(o) {
      return o.dim === "x" ? 0 : 1;
    }
    var DIt = IIt, kIt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "axisPointer", i.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, i;
    }(nc), OIt = kIt, WI = mu(), PIt = yt;
    function T7e(o, i, t3) {
      if (!yo.node) {
        var c3 = i.getZr();
        WI(c3).records || (WI(c3).records = {}), LIt(c3, i);
        var p3 = WI(c3).records[o] || (WI(c3).records[o] = {});
        p3.handler = t3;
      }
    }
    function LIt(o, i) {
      if (WI(o).initialized)
        return;
      WI(o).initialized = true, t3("click", As(A7e, "click")), t3("mousemove", As(A7e, "mousemove")), t3("globalout", NIt);
      function t3(c3, p3) {
        o.on(c3, function(g3) {
          var b3 = FIt(i);
          PIt(WI(o).records, function(w3) {
            w3 && p3(w3, g3, b3.dispatchAction);
          }), RIt(b3.pendings, i);
        });
      }
    }
    function RIt(o, i) {
      var t3 = o.showTip.length, c3 = o.hideTip.length, p3;
      t3 ? p3 = o.showTip[t3 - 1] : c3 && (p3 = o.hideTip[c3 - 1]), p3 && (p3.dispatchAction = null, i.dispatchAction(p3));
    }
    function NIt(o, i, t3) {
      o.handler("leave", null, t3);
    }
    function A7e(o, i, t3, c3) {
      i.handler(o, t3, c3);
    }
    function FIt(o) {
      var i = { showTip: [], hideTip: [] }, t3 = function(c3) {
        var p3 = i[c3.type];
        p3 ? p3.push(c3) : (c3.dispatchAction = t3, o.dispatchAction(c3));
      };
      return { dispatchAction: t3, pendings: i };
    }
    function Mme(o, i) {
      if (!yo.node) {
        var t3 = i.getZr(), c3 = (WI(t3).records || {})[o];
        c3 && (WI(t3).records[o] = null);
      }
    }
    var VIt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = c3.getComponent("tooltip"), b3 = t3.get("triggerOn") || g3 && g3.get("triggerOn") || "mousemove|click";
        T7e("axisPointer", p3, function(w3, M, I) {
          b3 !== "none" && (w3 === "leave" || b3.indexOf(w3) >= 0) && I({ type: "updateAxisPointer", currTrigger: w3, x: M && M.offsetX, y: M && M.offsetY });
        });
      }, i.prototype.remove = function(t3, c3) {
        Mme("axisPointer", c3);
      }, i.prototype.dispose = function(t3, c3) {
        Mme("axisPointer", c3);
      }, i.type = "axisPointer", i;
    }(ed), BIt = VIt;
    function I7e(o, i) {
      var t3 = [], c3 = o.seriesIndex, p3;
      if (c3 == null || !(p3 = i.getSeriesByIndex(c3)))
        return { point: [] };
      var g3 = p3.getData(), b3 = k_(g3, o);
      if (b3 == null || b3 < 0 || Ei(b3))
        return { point: [] };
      var w3 = g3.getItemGraphicEl(b3), M = p3.coordinateSystem;
      if (p3.getTooltipPosition)
        t3 = p3.getTooltipPosition(b3) || [];
      else if (M && M.dataToPoint)
        if (o.isStacked) {
          var I = M.getBaseAxis(), k3 = M.getOtherAxis(I), L = k3.dim, F = I.dim, B = L === "x" || L === "radius" ? 1 : 0, G = g3.mapDimension(F), J = [];
          J[B] = g3.get(G, b3), J[1 - B] = g3.get(g3.getCalculationInfo("stackResultDimension"), b3), t3 = M.dataToPoint(J) || [];
        } else
          t3 = M.dataToPoint(g3.getValues(Fi(M.dimensions, function(se) {
            return g3.mapDimension(se);
          }), b3)) || [];
      else if (w3) {
        var Q = w3.getBoundingRect().clone();
        Q.applyTransform(w3.transform), t3 = [Q.x + Q.width / 2, Q.y + Q.height / 2];
      }
      return { point: t3, el: w3 };
    }
    var E7e = mu();
    function zIt(o, i, t3) {
      var c3 = o.currTrigger, p3 = [o.x, o.y], g3 = o, b3 = o.dispatchAction || Qa(t3.dispatchAction, t3), w3 = i.getComponent("axisPointer").coordSysAxesInfo;
      if (w3) {
        Lne(p3) && (p3 = I7e({ seriesIndex: g3.seriesIndex, dataIndex: g3.dataIndex }, i).point);
        var M = Lne(p3), I = g3.axesInfo, k3 = w3.axesInfo, L = c3 === "leave" || Lne(p3), F = {}, B = {}, G = { list: [], map: {} }, J = { showPointer: As(GIt, B), showTooltip: As(HIt, G) };
        yt(w3.coordSysMap, function(se, he) {
          var be = M || se.containPoint(p3);
          yt(w3.coordSysAxesInfo[he], function(de, Fe) {
            var Pe = de.axis, ze = $It(I, de);
            if (!L && be && (!I || ze)) {
              var $e = ze && ze.value;
              $e == null && !M && ($e = Pe.pointToData(p3)), $e != null && D7e(de, $e, J, false, F);
            }
          });
        });
        var Q = {};
        return yt(k3, function(se, he) {
          var be = se.linkGroup;
          be && !B[he] && yt(be.axesInfo, function(de, Fe) {
            var Pe = B[Fe];
            if (de !== se && Pe) {
              var ze = Pe.value;
              be.mapper && (ze = se.axis.scale.parse(be.mapper(ze, k7e(de), k7e(se)))), Q[se.key] = ze;
            }
          });
        }), yt(Q, function(se, he) {
          D7e(k3[he], se, J, true, F);
        }), WIt(B, k3, F), UIt(G, p3, o, b3), qIt(k3, b3, t3), F;
      }
    }
    function D7e(o, i, t3, c3, p3) {
      var g3 = o.axis;
      if (!(g3.scale.isBlank() || !g3.containData(i))) {
        if (!o.involveSeries) {
          t3.showPointer(o, i);
          return;
        }
        var b3 = jIt(i, o), w3 = b3.payloadBatch, M = b3.snapToValue;
        w3[0] && p3.seriesIndex == null && ti(p3, w3[0]), !c3 && o.snap && g3.containData(M) && M != null && (i = M), t3.showPointer(o, i, w3), t3.showTooltip(o, b3, M);
      }
    }
    function jIt(o, i) {
      var t3 = i.axis, c3 = t3.dim, p3 = o, g3 = [], b3 = Number.MAX_VALUE, w3 = -1;
      return yt(i.seriesModels, function(M, I) {
        var k3 = M.getData().mapDimensionsAll(c3), L, F;
        if (M.getAxisTooltipData) {
          var B = M.getAxisTooltipData(k3, o, t3);
          F = B.dataIndices, L = B.nestestValue;
        } else {
          if (F = M.getData().indicesOfNearest(k3[0], o, t3.type === "category" ? 0.5 : null), !F.length)
            return;
          L = M.getData().get(k3[0], F[0]);
        }
        if (!(L == null || !isFinite(L))) {
          var G = o - L, J = Math.abs(G);
          J <= b3 && ((J < b3 || G >= 0 && w3 < 0) && (b3 = J, w3 = G, p3 = L, g3.length = 0), yt(F, function(Q) {
            g3.push({ seriesIndex: M.seriesIndex, dataIndexInside: Q, dataIndex: M.getData().getRawIndex(Q) });
          }));
        }
      }), { payloadBatch: g3, snapToValue: p3 };
    }
    function GIt(o, i, t3, c3) {
      o[i.key] = { value: t3, payloadBatch: c3 };
    }
    function HIt(o, i, t3, c3) {
      var p3 = t3.payloadBatch, g3 = i.axis, b3 = g3.model, w3 = i.axisPointerModel;
      if (!(!i.triggerTooltip || !p3.length)) {
        var M = i.coordSys.model, I = hW(M), k3 = o.map[I];
        k3 || (k3 = o.map[I] = { coordSysId: M.id, coordSysIndex: M.componentIndex, coordSysType: M.type, coordSysMainType: M.mainType, dataByAxis: [] }, o.list.push(k3)), k3.dataByAxis.push({ axisDim: g3.dim, axisIndex: b3.componentIndex, axisType: b3.type, axisId: b3.id, value: c3, valueLabelOpt: { precision: w3.get(["label", "precision"]), formatter: w3.get(["label", "formatter"]) }, seriesDataIndices: p3.slice() });
      }
    }
    function WIt(o, i, t3) {
      var c3 = t3.axesInfo = [];
      yt(i, function(p3, g3) {
        var b3 = p3.axisPointerModel.option, w3 = o[g3];
        w3 ? (!p3.useHandle && (b3.status = "show"), b3.value = w3.value, b3.seriesDataIndices = (w3.payloadBatch || []).slice()) : !p3.useHandle && (b3.status = "hide"), b3.status === "show" && c3.push({ axisDim: p3.axis.dim, axisIndex: p3.axis.model.componentIndex, value: b3.value });
      });
    }
    function UIt(o, i, t3, c3) {
      if (Lne(i) || !o.list.length) {
        c3({ type: "hideTip" });
        return;
      }
      var p3 = ((o.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
      c3({ type: "showTip", escapeConnect: true, x: i[0], y: i[1], tooltipOption: t3.tooltipOption, position: t3.position, dataIndexInside: p3.dataIndexInside, dataIndex: p3.dataIndex, seriesIndex: p3.seriesIndex, dataByCoordSys: o.list });
    }
    function qIt(o, i, t3) {
      var c3 = t3.getZr(), p3 = "axisPointerLastHighlights", g3 = E7e(c3)[p3] || {}, b3 = E7e(c3)[p3] = {};
      yt(o, function(I, k3) {
        var L = I.axisPointerModel.option;
        L.status === "show" && yt(L.seriesDataIndices, function(F) {
          var B = F.seriesIndex + " | " + F.dataIndex;
          b3[B] = F;
        });
      });
      var w3 = [], M = [];
      yt(g3, function(I, k3) {
        !b3[k3] && M.push(I);
      }), yt(b3, function(I, k3) {
        !g3[k3] && w3.push(I);
      }), M.length && t3.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: M }), w3.length && t3.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: w3 });
    }
    function $It(o, i) {
      for (var t3 = 0; t3 < (o || []).length; t3++) {
        var c3 = o[t3];
        if (i.axis.dim === c3.axisDim && i.axis.model.componentIndex === c3.axisIndex)
          return c3;
      }
    }
    function k7e(o) {
      var i = o.axis.model, t3 = {}, c3 = t3.axisDim = o.axis.dim;
      return t3.axisIndex = t3[c3 + "AxisIndex"] = i.componentIndex, t3.axisName = t3[c3 + "AxisName"] = i.name, t3.axisId = t3[c3 + "AxisId"] = i.id, t3;
    }
    function Lne(o) {
      return !o || o[0] == null || isNaN(o[0]) || o[1] == null || isNaN(o[1]);
    }
    function DW(o) {
      bL.registerAxisPointerClass("CartesianAxisPointer", DIt), o.registerComponentModel(OIt), o.registerComponentView(BIt), o.registerPreprocessor(function(i) {
        if (i) {
          (!i.axisPointer || i.axisPointer.length === 0) && (i.axisPointer = {});
          var t3 = i.axisPointer.link;
          t3 && !Ei(t3) && (i.axisPointer.link = [t3]);
        }
      }), o.registerProcessor(o.PRIORITY.PROCESSOR.STATISTIC, function(i, t3) {
        i.getComponent("axisPointer").coordSysAxesInfo = Rxt(i, t3);
      }), o.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, zIt);
    }
    function XIt(o) {
      Tl(oFe), Tl(DW);
    }
    var YIt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.makeElOption = function(t3, c3, p3, g3, b3) {
        var w3 = p3.axis;
        w3.dim === "angle" && (this.animationThreshold = Math.PI / 18);
        var M = w3.polar, I = M.getOtherAxis(w3), k3 = I.getExtent(), L = w3.dataToCoord(c3), F = g3.get("type");
        if (F && F !== "none") {
          var B = wme(g3), G = ZIt[F](w3, M, L, k3);
          G.style = B, t3.graphicKey = G.type, t3.pointer = G;
        }
        var J = g3.get(["label", "margin"]), Q = KIt(c3, p3, g3, M, J);
        b7e(t3, p3, g3, b3, Q);
      }, i;
    }(xme);
    function KIt(o, i, t3, c3, p3) {
      var g3 = i.axis, b3 = g3.dataToCoord(o), w3 = c3.getAngleAxis().getExtent()[0];
      w3 = w3 / 180 * Math.PI;
      var M = c3.getRadiusAxis().getExtent(), I, k3, L;
      if (g3.dim === "radius") {
        var F = dm();
        cI(F, F, w3), D1(F, F, [c3.cx, c3.cy]), I = ll([b3, -p3], F);
        var B = i.getModel("axisLabel").get("rotate") || 0, G = BI.innerTextLayout(w3, B * Math.PI / 180, -1);
        k3 = G.textAlign, L = G.textVerticalAlign;
      } else {
        var J = M[1];
        I = c3.coordToPoint([J + p3, b3]);
        var Q = c3.cx, se = c3.cy;
        k3 = Math.abs(I[0] - Q) / J < 0.3 ? "center" : I[0] > Q ? "left" : "right", L = Math.abs(I[1] - se) / J < 0.3 ? "middle" : I[1] > se ? "top" : "bottom";
      }
      return { position: I, align: k3, verticalAlign: L };
    }
    var ZIt = { line: function(o, i, t3, c3) {
      return o.dim === "angle" ? { type: "Line", shape: Cme(i.coordToPoint([c3[0], t3]), i.coordToPoint([c3[1], t3])) } : { type: "Circle", shape: { cx: i.cx, cy: i.cy, r: t3 } };
    }, shadow: function(o, i, t3, c3) {
      var p3 = Math.max(1, o.getBandWidth()), g3 = Math.PI / 180;
      return o.dim === "angle" ? { type: "Sector", shape: S7e(i.cx, i.cy, c3[0], c3[1], (-t3 - p3 / 2) * g3, (-t3 + p3 / 2) * g3) } : { type: "Sector", shape: S7e(i.cx, i.cy, t3 - p3 / 2, t3 + p3 / 2, 0, Math.PI * 2) };
    } }, JIt = YIt, QIt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.findAxisModel = function(t3) {
        var c3, p3 = this.ecModel;
        return p3.eachComponent(t3, function(g3) {
          g3.getCoordSysModel() === this && (c3 = g3);
        }, this), c3;
      }, i.type = "polar", i.dependencies = ["radiusAxis", "angleAxis"], i.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, i;
    }(nc), eEt = QIt, Tme = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.getCoordSysModel = function() {
        return this.getReferringComponents("polar", xd).models[0];
      }, i.type = "polarAxis", i;
    }(nc);
    Kp(Tme, eW);
    var tEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "angleAxis", i;
    }(Tme), nEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "radiusAxis", i;
    }(Tme), Ame = function(o) {
      cn(i, o);
      function i(t3, c3) {
        return o.call(this, "radius", t3, c3) || this;
      }
      return i.prototype.pointToData = function(t3, c3) {
        return this.polar.pointToData(t3, c3)[this.dim === "radius" ? 0 : 1];
      }, i;
    }(Y2);
    Ame.prototype.dataToRadius = Y2.prototype.dataToCoord, Ame.prototype.radiusToData = Y2.prototype.coordToData;
    var rEt = Ame, iEt = mu(), Ime = function(o) {
      cn(i, o);
      function i(t3, c3) {
        return o.call(this, "angle", t3, c3 || [0, 360]) || this;
      }
      return i.prototype.pointToData = function(t3, c3) {
        return this.polar.pointToData(t3, c3)[this.dim === "radius" ? 0 : 1];
      }, i.prototype.calculateCategoryInterval = function() {
        var t3 = this, c3 = t3.getLabelModel(), p3 = t3.scale, g3 = p3.getExtent(), b3 = p3.count();
        if (g3[1] - g3[0] < 1)
          return 0;
        var w3 = g3[0], M = t3.dataToCoord(w3 + 1) - t3.dataToCoord(w3), I = Math.abs(M), k3 = pI(w3 == null ? "" : w3 + "", c3.getFont(), "center", "top"), L = Math.max(k3.height, 7), F = L / I;
        isNaN(F) && (F = 1 / 0);
        var B = Math.max(0, Math.floor(F)), G = iEt(t3.model), J = G.lastAutoInterval, Q = G.lastTickCount;
        return J != null && Q != null && Math.abs(J - B) <= 1 && Math.abs(Q - b3) <= 1 && J > B ? B = J : (G.lastTickCount = b3, G.lastAutoInterval = B), B;
      }, i;
    }(Y2);
    Ime.prototype.dataToAngle = Y2.prototype.dataToCoord, Ime.prototype.angleToData = Y2.prototype.coordToData;
    var aEt = Ime, O7e = ["radius", "angle"], oEt = function() {
      function o(i) {
        this.dimensions = O7e, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new rEt(), this._angleAxis = new aEt(), this.axisPointerEnabled = true, this.name = i || "", this._radiusAxis.polar = this._angleAxis.polar = this;
      }
      return o.prototype.containPoint = function(i) {
        var t3 = this.pointToCoord(i);
        return this._radiusAxis.contain(t3[0]) && this._angleAxis.contain(t3[1]);
      }, o.prototype.containData = function(i) {
        return this._radiusAxis.containData(i[0]) && this._angleAxis.containData(i[1]);
      }, o.prototype.getAxis = function(i) {
        var t3 = "_" + i + "Axis";
        return this[t3];
      }, o.prototype.getAxes = function() {
        return [this._radiusAxis, this._angleAxis];
      }, o.prototype.getAxesByScale = function(i) {
        var t3 = [], c3 = this._angleAxis, p3 = this._radiusAxis;
        return c3.scale.type === i && t3.push(c3), p3.scale.type === i && t3.push(p3), t3;
      }, o.prototype.getAngleAxis = function() {
        return this._angleAxis;
      }, o.prototype.getRadiusAxis = function() {
        return this._radiusAxis;
      }, o.prototype.getOtherAxis = function(i) {
        var t3 = this._angleAxis;
        return i === t3 ? this._radiusAxis : t3;
      }, o.prototype.getBaseAxis = function() {
        return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
      }, o.prototype.getTooltipAxes = function(i) {
        var t3 = i != null && i !== "auto" ? this.getAxis(i) : this.getBaseAxis();
        return { baseAxes: [t3], otherAxes: [this.getOtherAxis(t3)] };
      }, o.prototype.dataToPoint = function(i, t3) {
        return this.coordToPoint([this._radiusAxis.dataToRadius(i[0], t3), this._angleAxis.dataToAngle(i[1], t3)]);
      }, o.prototype.pointToData = function(i, t3) {
        var c3 = this.pointToCoord(i);
        return [this._radiusAxis.radiusToData(c3[0], t3), this._angleAxis.angleToData(c3[1], t3)];
      }, o.prototype.pointToCoord = function(i) {
        var t3 = i[0] - this.cx, c3 = i[1] - this.cy, p3 = this.getAngleAxis(), g3 = p3.getExtent(), b3 = Math.min(g3[0], g3[1]), w3 = Math.max(g3[0], g3[1]);
        p3.inverse ? b3 = w3 - 360 : w3 = b3 + 360;
        var M = Math.sqrt(t3 * t3 + c3 * c3);
        t3 /= M, c3 /= M;
        for (var I = Math.atan2(-c3, t3) / Math.PI * 180, k3 = I < b3 ? 1 : -1; I < b3 || I > w3; )
          I += k3 * 360;
        return [M, I];
      }, o.prototype.coordToPoint = function(i) {
        var t3 = i[0], c3 = i[1] / 180 * Math.PI, p3 = Math.cos(c3) * t3 + this.cx, g3 = -Math.sin(c3) * t3 + this.cy;
        return [p3, g3];
      }, o.prototype.getArea = function() {
        var i = this.getAngleAxis(), t3 = this.getRadiusAxis(), c3 = t3.getExtent().slice();
        c3[0] > c3[1] && c3.reverse();
        var p3 = i.getExtent(), g3 = Math.PI / 180;
        return { cx: this.cx, cy: this.cy, r0: c3[0], r: c3[1], startAngle: -p3[0] * g3, endAngle: -p3[1] * g3, clockwise: i.inverse, contain: function(b3, w3) {
          var M = b3 - this.cx, I = w3 - this.cy, k3 = M * M + I * I - 1e-4, L = this.r, F = this.r0;
          return k3 <= L * L && k3 >= F * F;
        } };
      }, o.prototype.convertToPixel = function(i, t3, c3) {
        var p3 = P7e(t3);
        return p3 === this ? this.dataToPoint(c3) : null;
      }, o.prototype.convertFromPixel = function(i, t3, c3) {
        var p3 = P7e(t3);
        return p3 === this ? this.pointToData(c3) : null;
      }, o;
    }();
    function P7e(o) {
      var i = o.seriesModel, t3 = o.polarModel;
      return t3 && t3.coordinateSystem || i && i.coordinateSystem;
    }
    var sEt = oEt;
    function lEt(o, i, t3) {
      var c3 = i.get("center"), p3 = t3.getWidth(), g3 = t3.getHeight();
      o.cx = Da(c3[0], p3), o.cy = Da(c3[1], g3);
      var b3 = o.getRadiusAxis(), w3 = Math.min(p3, g3) / 2, M = i.get("radius");
      M == null ? M = [0, "100%"] : Ei(M) || (M = [0, M]);
      var I = [Da(M[0], w3), Da(M[1], w3)];
      b3.inverse ? b3.setExtent(I[1], I[0]) : b3.setExtent(I[0], I[1]);
    }
    function uEt(o, i) {
      var t3 = this, c3 = t3.getAngleAxis(), p3 = t3.getRadiusAxis();
      if (c3.scale.setExtent(1 / 0, -1 / 0), p3.scale.setExtent(1 / 0, -1 / 0), o.eachSeries(function(w3) {
        if (w3.coordinateSystem === t3) {
          var M = w3.getData();
          yt(Xte(M, "radius"), function(I) {
            p3.scale.unionExtentFromData(M, I);
          }), yt(Xte(M, "angle"), function(I) {
            c3.scale.unionExtentFromData(M, I);
          });
        }
      }), O8(c3.scale, c3.model), O8(p3.scale, p3.model), c3.type === "category" && !c3.onBand) {
        var g3 = c3.getExtent(), b3 = 360 / c3.scale.count();
        c3.inverse ? g3[1] += b3 : g3[1] -= b3, c3.setExtent(g3[0], g3[1]);
      }
    }
    function cEt(o) {
      return o.mainType === "angleAxis";
    }
    function L7e(o, i) {
      if (o.type = i.get("type"), o.scale = $te(i), o.onBand = i.get("boundaryGap") && o.type === "category", o.inverse = i.get("inverse"), cEt(i)) {
        o.inverse = o.inverse !== i.get("clockwise");
        var t3 = i.get("startAngle");
        o.setExtent(t3, t3 + (o.inverse ? -360 : 360));
      }
      i.axis = o, o.model = i;
    }
    var fEt = { dimensions: O7e, create: function(o, i) {
      var t3 = [];
      return o.eachComponent("polar", function(c3, p3) {
        var g3 = new sEt(p3 + "");
        g3.update = uEt;
        var b3 = g3.getRadiusAxis(), w3 = g3.getAngleAxis(), M = c3.findAxisModel("radiusAxis"), I = c3.findAxisModel("angleAxis");
        L7e(b3, M), L7e(w3, I), lEt(g3, c3, i), t3.push(g3), c3.coordinateSystem = g3, g3.model = c3;
      }), o.eachSeries(function(c3) {
        if (c3.get("coordinateSystem") === "polar") {
          var p3 = c3.getReferringComponents("polar", xd).models[0];
          c3.coordinateSystem = p3.coordinateSystem;
        }
      }), t3;
    } }, hEt = fEt, pEt = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
    function Rne(o, i, t3) {
      i[1] > i[0] && (i = i.slice().reverse());
      var c3 = o.coordToPoint([i[0], t3]), p3 = o.coordToPoint([i[1], t3]);
      return { x1: c3[0], y1: c3[1], x2: p3[0], y2: p3[1] };
    }
    function Nne(o) {
      var i = o.getRadiusAxis();
      return i.inverse ? 0 : 1;
    }
    function R7e(o) {
      var i = o[0], t3 = o[o.length - 1];
      i && t3 && Math.abs(Math.abs(i.coord - t3.coord) - 360) < 1e-4 && o.pop();
    }
    var dEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.axisPointerClass = "PolarAxisPointer", t3;
      }
      return i.prototype.render = function(t3, c3) {
        if (this.group.removeAll(), !!t3.get("show")) {
          var p3 = t3.axis, g3 = p3.polar, b3 = g3.getRadiusAxis().getExtent(), w3 = p3.getTicksCoords(), M = p3.getMinorTicksCoords(), I = Fi(p3.getViewLabels(), function(k3) {
            k3 = Jo(k3);
            var L = p3.scale, F = L.type === "ordinal" ? L.getRawOrdinalNumber(k3.tickValue) : k3.tickValue;
            return k3.coord = p3.dataToCoord(F), k3;
          });
          R7e(I), R7e(w3), yt(pEt, function(k3) {
            t3.get([k3, "show"]) && (!p3.scale.isBlank() || k3 === "axisLine") && vEt[k3](this.group, t3, g3, w3, M, b3, I);
          }, this);
        }
      }, i.type = "angleAxis", i;
    }(bL), vEt = { axisLine: function(o, i, t3, c3, p3, g3) {
      var b3 = i.getModel(["axisLine", "lineStyle"]), w3 = Nne(t3), M = w3 ? 0 : 1, I;
      g3[M] === 0 ? I = new Mw({ shape: { cx: t3.cx, cy: t3.cy, r: g3[w3] }, style: b3.getLineStyle(), z2: 1, silent: true }) : I = new n8({ shape: { cx: t3.cx, cy: t3.cy, r: g3[w3], r0: g3[M] }, style: b3.getLineStyle(), z2: 1, silent: true }), I.style.fill = null, o.add(I);
    }, axisTick: function(o, i, t3, c3, p3, g3) {
      var b3 = i.getModel("axisTick"), w3 = (b3.get("inside") ? -1 : 1) * b3.get("length"), M = g3[Nne(t3)], I = Fi(c3, function(k3) {
        return new Ud({ shape: Rne(t3, [M, M + w3], k3.coord) });
      });
      o.add(ji(I, { style: Uo(b3.getModel("lineStyle").getLineStyle(), { stroke: i.get(["axisLine", "lineStyle", "color"]) }) }));
    }, minorTick: function(o, i, t3, c3, p3, g3) {
      if (p3.length) {
        for (var b3 = i.getModel("axisTick"), w3 = i.getModel("minorTick"), M = (b3.get("inside") ? -1 : 1) * w3.get("length"), I = g3[Nne(t3)], k3 = [], L = 0; L < p3.length; L++)
          for (var F = 0; F < p3[L].length; F++)
            k3.push(new Ud({ shape: Rne(t3, [I, I + M], p3[L][F].coord) }));
        o.add(ji(k3, { style: Uo(w3.getModel("lineStyle").getLineStyle(), Uo(b3.getLineStyle(), { stroke: i.get(["axisLine", "lineStyle", "color"]) })) }));
      }
    }, axisLabel: function(o, i, t3, c3, p3, g3, b3) {
      var w3 = i.getCategories(true), M = i.getModel("axisLabel"), I = M.get("margin"), k3 = i.get("triggerEvent");
      yt(b3, function(L, F) {
        var B = M, G = L.tickValue, J = g3[Nne(t3)], Q = t3.coordToPoint([J + I, L.coord]), se = t3.cx, he = t3.cy, be = Math.abs(Q[0] - se) / J < 0.3 ? "center" : Q[0] > se ? "left" : "right", de = Math.abs(Q[1] - he) / J < 0.3 ? "middle" : Q[1] > he ? "top" : "bottom";
        if (w3 && w3[G]) {
          var Fe = w3[G];
          Ua(Fe) && Fe.textStyle && (B = new gh(Fe.textStyle, M, M.ecModel));
        }
        var Pe = new Fl({ silent: BI.isLabelSilent(i), style: qd(B, { x: Q[0], y: Q[1], fill: B.getTextColor() || i.get(["axisLine", "lineStyle", "color"]), text: L.formattedLabel, align: be, verticalAlign: de }) });
        if (o.add(Pe), k3) {
          var ze = BI.makeAxisEventDataBase(i);
          ze.targetType = "axisLabel", ze.value = L.rawLabel, La(Pe).eventData = ze;
        }
      }, this);
    }, splitLine: function(o, i, t3, c3, p3, g3) {
      var b3 = i.getModel("splitLine"), w3 = b3.getModel("lineStyle"), M = w3.get("color"), I = 0;
      M = M instanceof Array ? M : [M];
      for (var k3 = [], L = 0; L < c3.length; L++) {
        var F = I++ % M.length;
        k3[F] = k3[F] || [], k3[F].push(new Ud({ shape: Rne(t3, g3, c3[L].coord) }));
      }
      for (var L = 0; L < k3.length; L++)
        o.add(ji(k3[L], { style: Uo({ stroke: M[L % M.length] }, w3.getLineStyle()), silent: true, z: i.get("z") }));
    }, minorSplitLine: function(o, i, t3, c3, p3, g3) {
      if (p3.length) {
        for (var b3 = i.getModel("minorSplitLine"), w3 = b3.getModel("lineStyle"), M = [], I = 0; I < p3.length; I++)
          for (var k3 = 0; k3 < p3[I].length; k3++)
            M.push(new Ud({ shape: Rne(t3, g3, p3[I][k3].coord) }));
        o.add(ji(M, { style: w3.getLineStyle(), silent: true, z: i.get("z") }));
      }
    }, splitArea: function(o, i, t3, c3, p3, g3) {
      if (c3.length) {
        var b3 = i.getModel("splitArea"), w3 = b3.getModel("areaStyle"), M = w3.get("color"), I = 0;
        M = M instanceof Array ? M : [M];
        for (var k3 = [], L = Math.PI / 180, F = -c3[0].coord * L, B = Math.min(g3[0], g3[1]), G = Math.max(g3[0], g3[1]), J = i.get("clockwise"), Q = 1, se = c3.length; Q <= se; Q++) {
          var he = Q === se ? c3[0].coord : c3[Q].coord, be = I++ % M.length;
          k3[be] = k3[be] || [], k3[be].push(new bm({ shape: { cx: t3.cx, cy: t3.cy, r0: B, r: G, startAngle: F, endAngle: -he * L, clockwise: J }, silent: true })), F = -he * L;
        }
        for (var Q = 0; Q < k3.length; Q++)
          o.add(ji(k3[Q], { style: Uo({ fill: M[Q % M.length] }, w3.getAreaStyle()), silent: true }));
      }
    } }, gEt = dEt, yEt = ["axisLine", "axisTickLabel", "axisName"], mEt = ["splitLine", "splitArea", "minorSplitLine"], bEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.axisPointerClass = "PolarAxisPointer", t3;
      }
      return i.prototype.render = function(t3, c3) {
        if (this.group.removeAll(), !!t3.get("show")) {
          var p3 = this._axisGroup, g3 = this._axisGroup = new vs();
          this.group.add(g3);
          var b3 = t3.axis, w3 = b3.polar, M = w3.getAngleAxis(), I = b3.getTicksCoords(), k3 = b3.getMinorTicksCoords(), L = M.getExtent()[0], F = b3.getExtent(), B = xEt(w3, t3, L), G = new BI(t3, B);
          yt(yEt, G.add, G), g3.add(G.getGroup()), Sg(p3, g3, t3), yt(mEt, function(J) {
            t3.get([J, "show"]) && !b3.scale.isBlank() && _Et[J](this.group, t3, w3, L, F, I, k3);
          }, this);
        }
      }, i.type = "radiusAxis", i;
    }(bL), _Et = { splitLine: function(o, i, t3, c3, p3, g3) {
      var b3 = i.getModel("splitLine"), w3 = b3.getModel("lineStyle"), M = w3.get("color"), I = 0;
      M = M instanceof Array ? M : [M];
      for (var k3 = [], L = 0; L < g3.length; L++) {
        var F = I++ % M.length;
        k3[F] = k3[F] || [], k3[F].push(new Mw({ shape: { cx: t3.cx, cy: t3.cy, r: g3[L].coord } }));
      }
      for (var L = 0; L < k3.length; L++)
        o.add(ji(k3[L], { style: Uo({ stroke: M[L % M.length], fill: null }, w3.getLineStyle()), silent: true }));
    }, minorSplitLine: function(o, i, t3, c3, p3, g3, b3) {
      if (b3.length) {
        for (var w3 = i.getModel("minorSplitLine"), M = w3.getModel("lineStyle"), I = [], k3 = 0; k3 < b3.length; k3++)
          for (var L = 0; L < b3[k3].length; L++)
            I.push(new Mw({ shape: { cx: t3.cx, cy: t3.cy, r: b3[k3][L].coord } }));
        o.add(ji(I, { style: Uo({ fill: null }, M.getLineStyle()), silent: true }));
      }
    }, splitArea: function(o, i, t3, c3, p3, g3) {
      if (g3.length) {
        var b3 = i.getModel("splitArea"), w3 = b3.getModel("areaStyle"), M = w3.get("color"), I = 0;
        M = M instanceof Array ? M : [M];
        for (var k3 = [], L = g3[0].coord, F = 1; F < g3.length; F++) {
          var B = I++ % M.length;
          k3[B] = k3[B] || [], k3[B].push(new bm({ shape: { cx: t3.cx, cy: t3.cy, r0: L, r: g3[F].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), L = g3[F].coord;
        }
        for (var F = 0; F < k3.length; F++)
          o.add(ji(k3[F], { style: Uo({ fill: M[F % M.length] }, w3.getAreaStyle()), silent: true }));
      }
    } };
    function xEt(o, i, t3) {
      return { position: [o.cx, o.cy], rotation: t3 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: i.getModel("axisLabel").get("rotate"), z2: 1 };
    }
    var wEt = bEt;
    function N7e(o) {
      return o.get("stack") || "__ec_stack_" + o.seriesIndex;
    }
    function F7e(o, i) {
      return i.dim + o.model.componentIndex;
    }
    function SEt(o, i, t3) {
      var c3 = {}, p3 = CEt(Zc(i.getSeriesByType(o), function(g3) {
        return !i.isSeriesFiltered(g3) && g3.coordinateSystem && g3.coordinateSystem.type === "polar";
      }));
      i.eachSeriesByType(o, function(g3) {
        if (g3.coordinateSystem.type === "polar") {
          var b3 = g3.getData(), w3 = g3.coordinateSystem, M = w3.getBaseAxis(), I = F7e(w3, M), k3 = N7e(g3), L = p3[I][k3], F = L.offset, B = L.width, G = w3.getOtherAxis(M), J = g3.coordinateSystem.cx, Q = g3.coordinateSystem.cy, se = g3.get("barMinHeight") || 0, he = g3.get("barMinAngle") || 0;
          c3[k3] = c3[k3] || [];
          for (var be = b3.mapDimension(G.dim), de = b3.mapDimension(M.dim), Fe = ck(b3, be), Pe = M.dim !== "radius" || !g3.get("roundCap", true), ze = G.dataToCoord(0), $e = 0, Ke = b3.count(); $e < Ke; $e++) {
            var nt = b3.get(be, $e), lt2 = b3.get(de, $e), bt = nt >= 0 ? "p" : "n", vt = ze;
            Fe && (c3[k3][lt2] || (c3[k3][lt2] = { p: ze, n: ze }), vt = c3[k3][lt2][bt]);
            var jt = void 0, Jt = void 0, Rt = void 0, Jn = void 0;
            if (G.dim === "radius") {
              var ln = G.dataToCoord(nt) - ze, vn = M.dataToCoord(lt2);
              Math.abs(ln) < se && (ln = (ln < 0 ? -1 : 1) * se), jt = vt, Jt = vt + ln, Rt = vn - F, Jn = Rt - B, Fe && (c3[k3][lt2][bt] = Jt);
            } else {
              var kn = G.dataToCoord(nt, Pe) - ze, cr = M.dataToCoord(lt2);
              Math.abs(kn) < he && (kn = (kn < 0 ? -1 : 1) * he), jt = cr + F, Jt = jt + B, Rt = vt, Jn = vt + kn, Fe && (c3[k3][lt2][bt] = Jn);
            }
            b3.setItemLayout($e, { cx: J, cy: Q, r0: jt, r: Jt, startAngle: -Rt * Math.PI / 180, endAngle: -Jn * Math.PI / 180, clockwise: Rt >= Jn });
          }
        }
      });
    }
    function CEt(o) {
      var i = {};
      yt(o, function(c3, p3) {
        var g3 = c3.getData(), b3 = c3.coordinateSystem, w3 = b3.getBaseAxis(), M = F7e(b3, w3), I = w3.getExtent(), k3 = w3.type === "category" ? w3.getBandWidth() : Math.abs(I[1] - I[0]) / g3.count(), L = i[M] || { bandWidth: k3, remainedWidth: k3, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, F = L.stacks;
        i[M] = L;
        var B = N7e(c3);
        F[B] || L.autoWidthCount++, F[B] = F[B] || { width: 0, maxWidth: 0 };
        var G = Da(c3.get("barWidth"), k3), J = Da(c3.get("barMaxWidth"), k3), Q = c3.get("barGap"), se = c3.get("barCategoryGap");
        G && !F[B].width && (G = Math.min(L.remainedWidth, G), F[B].width = G, L.remainedWidth -= G), J && (F[B].maxWidth = J), Q != null && (L.gap = Q), se != null && (L.categoryGap = se);
      });
      var t3 = {};
      return yt(i, function(c3, p3) {
        t3[p3] = {};
        var g3 = c3.stacks, b3 = c3.bandWidth, w3 = Da(c3.categoryGap, b3), M = Da(c3.gap, 1), I = c3.remainedWidth, k3 = c3.autoWidthCount, L = (I - w3) / (k3 + (k3 - 1) * M);
        L = Math.max(L, 0), yt(g3, function(J, Q) {
          var se = J.maxWidth;
          se && se < L && (se = Math.min(se, I), J.width && (se = Math.min(se, J.width)), I -= se, J.width = se, k3--);
        }), L = (I - w3) / (k3 + (k3 - 1) * M), L = Math.max(L, 0);
        var F = 0, B;
        yt(g3, function(J, Q) {
          J.width || (J.width = L), B = J, F += J.width * (1 + M);
        }), B && (F -= B.width * M);
        var G = -F / 2;
        yt(g3, function(J, Q) {
          t3[p3][Q] = t3[p3][Q] || { offset: G, width: J.width }, G += J.width * (1 + M);
        });
      }), t3;
    }
    var MEt = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, TEt = { splitNumber: 5 }, AEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "polar", i;
    }(ed);
    function IEt(o) {
      Tl(DW), bL.registerAxisPointerClass("PolarAxisPointer", JIt), o.registerCoordinateSystem("polar", hEt), o.registerComponentModel(eEt), o.registerComponentView(AEt), F8(o, "angle", tEt, MEt), F8(o, "radius", nEt, TEt), o.registerComponentView(gEt), o.registerComponentView(wEt), o.registerLayout(As(SEt, "bar"));
    }
    function Eme(o, i) {
      i = i || {};
      var t3 = o.coordinateSystem, c3 = o.axis, p3 = {}, g3 = c3.position, b3 = c3.orient, w3 = t3.getRect(), M = [w3.x, w3.x + w3.width, w3.y, w3.y + w3.height], I = { horizontal: { top: M[2], bottom: M[3] }, vertical: { left: M[0], right: M[1] } };
      p3.position = [b3 === "vertical" ? I.vertical[g3] : M[0], b3 === "horizontal" ? I.horizontal[g3] : M[3]];
      var k3 = { horizontal: 0, vertical: 1 };
      p3.rotation = Math.PI / 2 * k3[b3];
      var L = { top: -1, bottom: 1, right: 1, left: -1 };
      p3.labelDirection = p3.tickDirection = p3.nameDirection = L[g3], o.get(["axisTick", "inside"]) && (p3.tickDirection = -p3.tickDirection), lv(i.labelInside, o.get(["axisLabel", "inside"])) && (p3.labelDirection = -p3.labelDirection);
      var F = i.rotate;
      return F == null && (F = o.get(["axisLabel", "rotate"])), p3.labelRotation = g3 === "top" ? -F : F, p3.z2 = 1, p3;
    }
    var EEt = ["axisLine", "axisTickLabel", "axisName"], DEt = ["splitArea", "splitLine"], kEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.axisPointerClass = "SingleAxisPointer", t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        var b3 = this.group;
        b3.removeAll();
        var w3 = this._axisGroup;
        this._axisGroup = new vs();
        var M = Eme(t3), I = new BI(t3, M);
        yt(EEt, I.add, I), b3.add(this._axisGroup), b3.add(I.getGroup()), yt(DEt, function(k3) {
          t3.get([k3, "show"]) && OEt[k3](this, this.group, this._axisGroup, t3);
        }, this), Sg(w3, this._axisGroup, t3), o.prototype.render.call(this, t3, c3, p3, g3);
      }, i.prototype.remove = function() {
        nFe(this);
      }, i.type = "singleAxis", i;
    }(bL), OEt = { splitLine: function(o, i, t3, c3) {
      var p3 = c3.axis;
      if (!p3.scale.isBlank()) {
        var g3 = c3.getModel("splitLine"), b3 = g3.getModel("lineStyle"), w3 = b3.get("color");
        w3 = w3 instanceof Array ? w3 : [w3];
        for (var M = c3.coordinateSystem.getRect(), I = p3.isHorizontal(), k3 = [], L = 0, F = p3.getTicksCoords({ tickModel: g3 }), B = [], G = [], J = 0; J < F.length; ++J) {
          var Q = p3.toGlobalCoord(F[J].coord);
          I ? (B[0] = Q, B[1] = M.y, G[0] = Q, G[1] = M.y + M.height) : (B[0] = M.x, B[1] = Q, G[0] = M.x + M.width, G[1] = Q);
          var se = L++ % w3.length;
          k3[se] = k3[se] || [], k3[se].push(new Ud({ subPixelOptimize: true, shape: { x1: B[0], y1: B[1], x2: G[0], y2: G[1] }, silent: true }));
        }
        for (var he = b3.getLineStyle(["color"]), J = 0; J < k3.length; ++J)
          i.add(ji(k3[J], { style: Uo({ stroke: w3[J % w3.length] }, he), silent: true }));
      }
    }, splitArea: function(o, i, t3, c3) {
      tFe(o, t3, c3, c3);
    } }, PEt = kEt, V7e = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.getCoordSysModel = function() {
        return this;
      }, i.type = "singleAxis", i.layoutMode = "box", i.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, i;
    }(nc);
    Kp(V7e, eW.prototype);
    var Dme = V7e, LEt = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3, b3) {
        var w3 = o.call(this, t3, c3, p3) || this;
        return w3.type = g3 || "value", w3.position = b3 || "bottom", w3;
      }
      return i.prototype.isHorizontal = function() {
        var t3 = this.position;
        return t3 === "top" || t3 === "bottom";
      }, i.prototype.pointToData = function(t3, c3) {
        return this.coordinateSystem.pointToData(t3)[0];
      }, i;
    }(Y2), REt = LEt, B7e = ["single"], NEt = function() {
      function o(i, t3, c3) {
        this.type = "single", this.dimension = "single", this.dimensions = B7e, this.axisPointerEnabled = true, this.model = i, this._init(i, t3, c3);
      }
      return o.prototype._init = function(i, t3, c3) {
        var p3 = this.dimension, g3 = new REt(p3, $te(i), [0, 0], i.get("type"), i.get("position")), b3 = g3.type === "category";
        g3.onBand = b3 && i.get("boundaryGap"), g3.inverse = i.get("inverse"), g3.orient = i.get("orient"), i.axis = g3, g3.model = i, g3.coordinateSystem = this, this._axis = g3;
      }, o.prototype.update = function(i, t3) {
        i.eachSeries(function(c3) {
          if (c3.coordinateSystem === this) {
            var p3 = c3.getData();
            yt(p3.mapDimensionsAll(this.dimension), function(g3) {
              this._axis.scale.unionExtentFromData(p3, g3);
            }, this), O8(this._axis.scale, this._axis.model);
          }
        }, this);
      }, o.prototype.resize = function(i, t3) {
        this._rect = Wv({ left: i.get("left"), top: i.get("top"), right: i.get("right"), bottom: i.get("bottom"), width: i.get("width"), height: i.get("height") }, { width: t3.getWidth(), height: t3.getHeight() }), this._adjustAxis();
      }, o.prototype.getRect = function() {
        return this._rect;
      }, o.prototype._adjustAxis = function() {
        var i = this._rect, t3 = this._axis, c3 = t3.isHorizontal(), p3 = c3 ? [0, i.width] : [0, i.height], g3 = t3.reverse ? 1 : 0;
        t3.setExtent(p3[g3], p3[1 - g3]), this._updateAxisTransform(t3, c3 ? i.x : i.y);
      }, o.prototype._updateAxisTransform = function(i, t3) {
        var c3 = i.getExtent(), p3 = c3[0] + c3[1], g3 = i.isHorizontal();
        i.toGlobalCoord = g3 ? function(b3) {
          return b3 + t3;
        } : function(b3) {
          return p3 - b3 + t3;
        }, i.toLocalCoord = g3 ? function(b3) {
          return b3 - t3;
        } : function(b3) {
          return p3 - b3 + t3;
        };
      }, o.prototype.getAxis = function() {
        return this._axis;
      }, o.prototype.getBaseAxis = function() {
        return this._axis;
      }, o.prototype.getAxes = function() {
        return [this._axis];
      }, o.prototype.getTooltipAxes = function() {
        return { baseAxes: [this.getAxis()], otherAxes: [] };
      }, o.prototype.containPoint = function(i) {
        var t3 = this.getRect(), c3 = this.getAxis(), p3 = c3.orient;
        return p3 === "horizontal" ? c3.contain(c3.toLocalCoord(i[0])) && i[1] >= t3.y && i[1] <= t3.y + t3.height : c3.contain(c3.toLocalCoord(i[1])) && i[0] >= t3.y && i[0] <= t3.y + t3.height;
      }, o.prototype.pointToData = function(i) {
        var t3 = this.getAxis();
        return [t3.coordToData(t3.toLocalCoord(i[t3.orient === "horizontal" ? 0 : 1]))];
      }, o.prototype.dataToPoint = function(i) {
        var t3 = this.getAxis(), c3 = this.getRect(), p3 = [], g3 = t3.orient === "horizontal" ? 0 : 1;
        return i instanceof Array && (i = i[0]), p3[g3] = t3.toGlobalCoord(t3.dataToCoord(+i)), p3[1 - g3] = g3 === 0 ? c3.y + c3.height / 2 : c3.x + c3.width / 2, p3;
      }, o.prototype.convertToPixel = function(i, t3, c3) {
        var p3 = z7e(t3);
        return p3 === this ? this.dataToPoint(c3) : null;
      }, o.prototype.convertFromPixel = function(i, t3, c3) {
        var p3 = z7e(t3);
        return p3 === this ? this.pointToData(c3) : null;
      }, o;
    }();
    function z7e(o) {
      var i = o.seriesModel, t3 = o.singleAxisModel;
      return t3 && t3.coordinateSystem || i && i.coordinateSystem;
    }
    function FEt(o, i) {
      var t3 = [];
      return o.eachComponent("singleAxis", function(c3, p3) {
        var g3 = new NEt(c3, o, i);
        g3.name = "single_" + p3, g3.resize(c3, i), c3.coordinateSystem = g3, t3.push(g3);
      }), o.eachSeries(function(c3) {
        if (c3.get("coordinateSystem") === "singleAxis") {
          var p3 = c3.getReferringComponents("singleAxis", xd).models[0];
          c3.coordinateSystem = p3 && p3.coordinateSystem;
        }
      }), t3;
    }
    var VEt = { create: FEt, dimensions: B7e }, BEt = VEt, j7e = ["x", "y"], zEt = ["width", "height"], jEt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.makeElOption = function(t3, c3, p3, g3, b3) {
        var w3 = p3.axis, M = w3.coordinateSystem, I = kme(M, 1 - Fne(w3)), k3 = M.dataToPoint(c3)[0], L = g3.get("type");
        if (L && L !== "none") {
          var F = wme(g3), B = GEt[L](w3, k3, I);
          B.style = F, t3.graphicKey = B.type, t3.pointer = B;
        }
        var G = Eme(p3);
        x7e(c3, t3, G, p3, g3, b3);
      }, i.prototype.getHandleTransform = function(t3, c3, p3) {
        var g3 = Eme(c3, { labelInside: false });
        g3.labelMargin = p3.get(["handle", "margin"]);
        var b3 = Sme(c3.axis, t3, g3);
        return { x: b3[0], y: b3[1], rotation: g3.rotation + (g3.labelDirection < 0 ? Math.PI : 0) };
      }, i.prototype.updateHandleTransform = function(t3, c3, p3, g3) {
        var b3 = p3.axis, w3 = b3.coordinateSystem, M = Fne(b3), I = kme(w3, M), k3 = [t3.x, t3.y];
        k3[M] += c3[M], k3[M] = Math.min(I[1], k3[M]), k3[M] = Math.max(I[0], k3[M]);
        var L = kme(w3, 1 - M), F = (L[1] + L[0]) / 2, B = [F, F];
        return B[M] = k3[M], { x: k3[0], y: k3[1], rotation: t3.rotation, cursorPoint: B, tooltipOption: { verticalAlign: "middle" } };
      }, i;
    }(xme), GEt = { line: function(o, i, t3) {
      var c3 = Cme([i, t3[0]], [i, t3[1]], Fne(o));
      return { type: "Line", subPixelOptimize: true, shape: c3 };
    }, shadow: function(o, i, t3) {
      var c3 = o.getBandWidth(), p3 = t3[1] - t3[0];
      return { type: "Rect", shape: w7e([i - c3 / 2, t3[0]], [c3, p3], Fne(o)) };
    } };
    function Fne(o) {
      return o.isHorizontal() ? 0 : 1;
    }
    function kme(o, i) {
      var t3 = o.getRect();
      return [t3[j7e[i]], t3[j7e[i]] + t3[zEt[i]]];
    }
    var HEt = jEt, WEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "single", i;
    }(ed);
    function UEt(o) {
      Tl(DW), bL.registerAxisPointerClass("SingleAxisPointer", HEt), o.registerComponentView(WEt), o.registerComponentView(PEt), o.registerComponentModel(Dme), F8(o, "single", Dme, Dme.defaultOption), o.registerCoordinateSystem("single", BEt);
    }
    var qEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        var g3 = m8(t3);
        o.prototype.init.apply(this, arguments), G7e(t3, g3);
      }, i.prototype.mergeOption = function(t3) {
        o.prototype.mergeOption.apply(this, arguments), G7e(this.option, t3);
      }, i.prototype.getCellSize = function() {
        return this.option.cellSize;
      }, i.type = "calendar", i.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, i;
    }(nc);
    function G7e(o, i) {
      var t3 = o.cellSize, c3;
      Ei(t3) ? c3 = t3 : c3 = o.cellSize = [t3, t3], c3.length === 1 && (c3[1] = c3[0]);
      var p3 = Fi([0, 1], function(g3) {
        return Jgt(i, g3) && (c3[g3] = "auto"), c3[g3] != null && c3[g3] !== "auto";
      });
      ik(o, i, { type: "box", ignoreSize: p3 });
    }
    var $Et = qEt, XEt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3 = this.group;
        g3.removeAll();
        var b3 = t3.coordinateSystem, w3 = b3.getRangeInfo(), M = b3.getOrient(), I = c3.getLocaleModel();
        this._renderDayRect(t3, w3, g3), this._renderLines(t3, w3, M, g3), this._renderYearText(t3, w3, M, g3), this._renderMonthText(t3, I, M, g3), this._renderWeekText(t3, I, w3, M, g3);
      }, i.prototype._renderDayRect = function(t3, c3, p3) {
        for (var g3 = t3.coordinateSystem, b3 = t3.getModel("itemStyle").getItemStyle(), w3 = g3.getCellWidth(), M = g3.getCellHeight(), I = c3.start.time; I <= c3.end.time; I = g3.getNextNDay(I, 1).time) {
          var k3 = g3.dataToRect([I], false).tl, L = new bu({ shape: { x: k3[0], y: k3[1], width: w3, height: M }, cursor: "default", style: b3 });
          p3.add(L);
        }
      }, i.prototype._renderLines = function(t3, c3, p3, g3) {
        var b3 = this, w3 = t3.coordinateSystem, M = t3.getModel(["splitLine", "lineStyle"]).getLineStyle(), I = t3.get(["splitLine", "show"]), k3 = M.lineWidth;
        this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
        for (var L = c3.start, F = 0; L.time <= c3.end.time; F++) {
          G(L.formatedDate), F === 0 && (L = w3.getDateInfo(c3.start.y + "-" + c3.start.m));
          var B = L.date;
          B.setMonth(B.getMonth() + 1), L = w3.getDateInfo(B);
        }
        G(w3.getNextNDay(c3.end.time, 1).formatedDate);
        function G(J) {
          b3._firstDayOfMonth.push(w3.getDateInfo(J)), b3._firstDayPoints.push(w3.dataToRect([J], false).tl);
          var Q = b3._getLinePointsOfOneWeek(t3, J, p3);
          b3._tlpoints.push(Q[0]), b3._blpoints.push(Q[Q.length - 1]), I && b3._drawSplitline(Q, M, g3);
        }
        I && this._drawSplitline(b3._getEdgesPoints(b3._tlpoints, k3, p3), M, g3), I && this._drawSplitline(b3._getEdgesPoints(b3._blpoints, k3, p3), M, g3);
      }, i.prototype._getEdgesPoints = function(t3, c3, p3) {
        var g3 = [t3[0].slice(), t3[t3.length - 1].slice()], b3 = p3 === "horizontal" ? 0 : 1;
        return g3[0][b3] = g3[0][b3] - c3 / 2, g3[1][b3] = g3[1][b3] + c3 / 2, g3;
      }, i.prototype._drawSplitline = function(t3, c3, p3) {
        var g3 = new xm({ z2: 20, shape: { points: t3 }, style: c3 });
        p3.add(g3);
      }, i.prototype._getLinePointsOfOneWeek = function(t3, c3, p3) {
        for (var g3 = t3.coordinateSystem, b3 = g3.getDateInfo(c3), w3 = [], M = 0; M < 7; M++) {
          var I = g3.getNextNDay(b3.time, M), k3 = g3.dataToRect([I.time], false);
          w3[2 * I.day] = k3.tl, w3[2 * I.day + 1] = k3[p3 === "horizontal" ? "bl" : "tr"];
        }
        return w3;
      }, i.prototype._formatterLabel = function(t3, c3) {
        return Ha(t3) && t3 ? Ygt(t3, c3) : Vo(t3) ? t3(c3) : c3.nameMap;
      }, i.prototype._yearTextPositionControl = function(t3, c3, p3, g3, b3) {
        var w3 = c3[0], M = c3[1], I = ["center", "bottom"];
        g3 === "bottom" ? (M += b3, I = ["center", "top"]) : g3 === "left" ? w3 -= b3 : g3 === "right" ? (w3 += b3, I = ["center", "top"]) : M -= b3;
        var k3 = 0;
        return (g3 === "left" || g3 === "right") && (k3 = Math.PI / 2), { rotation: k3, x: w3, y: M, style: { align: I[0], verticalAlign: I[1] } };
      }, i.prototype._renderYearText = function(t3, c3, p3, g3) {
        var b3 = t3.getModel("yearLabel");
        if (b3.get("show")) {
          var w3 = b3.get("margin"), M = b3.get("position");
          M || (M = p3 !== "horizontal" ? "top" : "left");
          var I = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], k3 = (I[0][0] + I[1][0]) / 2, L = (I[0][1] + I[1][1]) / 2, F = p3 === "horizontal" ? 0 : 1, B = { top: [k3, I[F][1]], bottom: [k3, I[1 - F][1]], left: [I[1 - F][0], L], right: [I[F][0], L] }, G = c3.start.y;
          +c3.end.y > +c3.start.y && (G = G + "-" + c3.end.y);
          var J = b3.get("formatter"), Q = { start: c3.start.y, end: c3.end.y, nameMap: G }, se = this._formatterLabel(J, Q), he = new Fl({ z2: 30, style: qd(b3, { text: se }) });
          he.attr(this._yearTextPositionControl(he, B[M], p3, M, w3)), g3.add(he);
        }
      }, i.prototype._monthTextPositionControl = function(t3, c3, p3, g3, b3) {
        var w3 = "left", M = "top", I = t3[0], k3 = t3[1];
        return p3 === "horizontal" ? (k3 = k3 + b3, c3 && (w3 = "center"), g3 === "start" && (M = "bottom")) : (I = I + b3, c3 && (M = "middle"), g3 === "start" && (w3 = "right")), { x: I, y: k3, align: w3, verticalAlign: M };
      }, i.prototype._renderMonthText = function(t3, c3, p3, g3) {
        var b3 = t3.getModel("monthLabel");
        if (b3.get("show")) {
          var w3 = b3.get("nameMap"), M = b3.get("margin"), I = b3.get("position"), k3 = b3.get("align"), L = [this._tlpoints, this._blpoints];
          (!w3 || Ha(w3)) && (w3 && (c3 = age(w3) || c3), w3 = c3.get(["time", "monthAbbr"]) || []);
          var F = I === "start" ? 0 : 1, B = p3 === "horizontal" ? 0 : 1;
          M = I === "start" ? -M : M;
          for (var G = k3 === "center", J = 0; J < L[F].length - 1; J++) {
            var Q = L[F][J].slice(), se = this._firstDayOfMonth[J];
            if (G) {
              var he = this._firstDayPoints[J];
              Q[B] = (he[B] + L[0][J + 1][B]) / 2;
            }
            var be = b3.get("formatter"), de = w3[+se.m - 1], Fe = { yyyy: se.y, yy: (se.y + "").slice(2), MM: se.m, M: +se.m, nameMap: de }, Pe = this._formatterLabel(be, Fe), ze = new Fl({ z2: 30, style: ti(qd(b3, { text: Pe }), this._monthTextPositionControl(Q, G, p3, I, M)) });
            g3.add(ze);
          }
        }
      }, i.prototype._weekTextPositionControl = function(t3, c3, p3, g3, b3) {
        var w3 = "center", M = "middle", I = t3[0], k3 = t3[1], L = p3 === "start";
        return c3 === "horizontal" ? (I = I + g3 + (L ? 1 : -1) * b3[0] / 2, w3 = L ? "right" : "left") : (k3 = k3 + g3 + (L ? 1 : -1) * b3[1] / 2, M = L ? "bottom" : "top"), { x: I, y: k3, align: w3, verticalAlign: M };
      }, i.prototype._renderWeekText = function(t3, c3, p3, g3, b3) {
        var w3 = t3.getModel("dayLabel");
        if (w3.get("show")) {
          var M = t3.coordinateSystem, I = w3.get("position"), k3 = w3.get("nameMap"), L = w3.get("margin"), F = M.getFirstDayOfWeek();
          if (!k3 || Ha(k3)) {
            k3 && (c3 = age(k3) || c3);
            var B = c3.get(["time", "dayOfWeekShort"]);
            k3 = B || Fi(c3.get(["time", "dayOfWeekAbbr"]), function(Fe) {
              return Fe[0];
            });
          }
          var G = M.getNextNDay(p3.end.time, 7 - p3.lweek).time, J = [M.getCellWidth(), M.getCellHeight()];
          L = Da(L, Math.min(J[1], J[0])), I === "start" && (G = M.getNextNDay(p3.start.time, -(7 + p3.fweek)).time, L = -L);
          for (var Q = 0; Q < 7; Q++) {
            var se = M.getNextNDay(G, Q), he = M.dataToRect([se.time], false).center, be = Q;
            be = Math.abs((Q + F) % 7);
            var de = new Fl({ z2: 30, style: ti(qd(w3, { text: k3[be] }), this._weekTextPositionControl(he, g3, I, L, J)) });
            b3.add(de);
          }
        }
      }, i.type = "calendar", i;
    }(ed), YEt = XEt, Ome = 864e5, KEt = function() {
      function o(i, t3, c3) {
        this.type = "calendar", this.dimensions = o.dimensions, this.getDimensionsInfo = o.getDimensionsInfo, this._model = i;
      }
      return o.getDimensionsInfo = function() {
        return [{ name: "time", type: "time" }, "value"];
      }, o.prototype.getRangeInfo = function() {
        return this._rangeInfo;
      }, o.prototype.getModel = function() {
        return this._model;
      }, o.prototype.getRect = function() {
        return this._rect;
      }, o.prototype.getCellWidth = function() {
        return this._sw;
      }, o.prototype.getCellHeight = function() {
        return this._sh;
      }, o.prototype.getOrient = function() {
        return this._orient;
      }, o.prototype.getFirstDayOfWeek = function() {
        return this._firstDayOfWeek;
      }, o.prototype.getDateInfo = function(i) {
        i = jv(i);
        var t3 = i.getFullYear(), c3 = i.getMonth() + 1, p3 = c3 < 10 ? "0" + c3 : "" + c3, g3 = i.getDate(), b3 = g3 < 10 ? "0" + g3 : "" + g3, w3 = i.getDay();
        return w3 = Math.abs((w3 + 7 - this.getFirstDayOfWeek()) % 7), { y: t3 + "", m: p3, d: b3, day: w3, time: i.getTime(), formatedDate: t3 + "-" + p3 + "-" + b3, date: i };
      }, o.prototype.getNextNDay = function(i, t3) {
        return t3 = t3 || 0, t3 === 0 ? this.getDateInfo(i) : (i = new Date(this.getDateInfo(i).time), i.setDate(i.getDate() + t3), this.getDateInfo(i));
      }, o.prototype.update = function(i, t3) {
        this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
        var c3 = this._rangeInfo.weeks || 1, p3 = ["width", "height"], g3 = this._model.getCellSize().slice(), b3 = this._model.getBoxLayoutParams(), w3 = this._orient === "horizontal" ? [c3, 7] : [7, c3];
        yt([0, 1], function(L) {
          k3(g3, L) && (b3[p3[L]] = g3[L] * w3[L]);
        });
        var M = { width: t3.getWidth(), height: t3.getHeight() }, I = this._rect = Wv(b3, M);
        yt([0, 1], function(L) {
          k3(g3, L) || (g3[L] = I[p3[L]] / w3[L]);
        });
        function k3(L, F) {
          return L[F] != null && L[F] !== "auto";
        }
        this._sw = g3[0], this._sh = g3[1];
      }, o.prototype.dataToPoint = function(i, t3) {
        Ei(i) && (i = i[0]), t3 == null && (t3 = true);
        var c3 = this.getDateInfo(i), p3 = this._rangeInfo, g3 = c3.formatedDate;
        if (t3 && !(c3.time >= p3.start.time && c3.time < p3.end.time + Ome))
          return [NaN, NaN];
        var b3 = c3.day, w3 = this._getRangeInfo([p3.start.time, g3]).nthWeek;
        return this._orient === "vertical" ? [this._rect.x + b3 * this._sw + this._sw / 2, this._rect.y + w3 * this._sh + this._sh / 2] : [this._rect.x + w3 * this._sw + this._sw / 2, this._rect.y + b3 * this._sh + this._sh / 2];
      }, o.prototype.pointToData = function(i) {
        var t3 = this.pointToDate(i);
        return t3 && t3.time;
      }, o.prototype.dataToRect = function(i, t3) {
        var c3 = this.dataToPoint(i, t3);
        return { contentShape: { x: c3[0] - (this._sw - this._lineWidth) / 2, y: c3[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: c3, tl: [c3[0] - this._sw / 2, c3[1] - this._sh / 2], tr: [c3[0] + this._sw / 2, c3[1] - this._sh / 2], br: [c3[0] + this._sw / 2, c3[1] + this._sh / 2], bl: [c3[0] - this._sw / 2, c3[1] + this._sh / 2] };
      }, o.prototype.pointToDate = function(i) {
        var t3 = Math.floor((i[0] - this._rect.x) / this._sw) + 1, c3 = Math.floor((i[1] - this._rect.y) / this._sh) + 1, p3 = this._rangeInfo.range;
        return this._orient === "vertical" ? this._getDateByWeeksAndDay(c3, t3 - 1, p3) : this._getDateByWeeksAndDay(t3, c3 - 1, p3);
      }, o.prototype.convertToPixel = function(i, t3, c3) {
        var p3 = H7e(t3);
        return p3 === this ? p3.dataToPoint(c3) : null;
      }, o.prototype.convertFromPixel = function(i, t3, c3) {
        var p3 = H7e(t3);
        return p3 === this ? p3.pointToData(c3) : null;
      }, o.prototype.containPoint = function(i) {
        return console.warn("Not implemented."), false;
      }, o.prototype._initRangeOption = function() {
        var i = this._model.get("range"), t3;
        if (Ei(i) && i.length === 1 && (i = i[0]), Ei(i))
          t3 = i;
        else {
          var c3 = i.toString();
          if (/^\d{4}$/.test(c3) && (t3 = [c3 + "-01-01", c3 + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(c3)) {
            var p3 = this.getDateInfo(c3), g3 = p3.date;
            g3.setMonth(g3.getMonth() + 1);
            var b3 = this.getNextNDay(g3, -1);
            t3 = [p3.formatedDate, b3.formatedDate];
          }
          /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(c3) && (t3 = [c3, c3]);
        }
        if (!t3)
          return i;
        var w3 = this._getRangeInfo(t3);
        return w3.start.time > w3.end.time && t3.reverse(), t3;
      }, o.prototype._getRangeInfo = function(i) {
        var t3 = [this.getDateInfo(i[0]), this.getDateInfo(i[1])], c3;
        t3[0].time > t3[1].time && (c3 = true, t3.reverse());
        var p3 = Math.floor(t3[1].time / Ome) - Math.floor(t3[0].time / Ome) + 1, g3 = new Date(t3[0].time), b3 = g3.getDate(), w3 = t3[1].date.getDate();
        g3.setDate(b3 + p3 - 1);
        var M = g3.getDate();
        if (M !== w3)
          for (var I = g3.getTime() - t3[1].time > 0 ? 1 : -1; (M = g3.getDate()) !== w3 && (g3.getTime() - t3[1].time) * I > 0; )
            p3 -= I, g3.setDate(M - I);
        var k3 = Math.floor((p3 + t3[0].day + 6) / 7), L = c3 ? -k3 + 1 : k3 - 1;
        return c3 && t3.reverse(), { range: [t3[0].formatedDate, t3[1].formatedDate], start: t3[0], end: t3[1], allDay: p3, weeks: k3, nthWeek: L, fweek: t3[0].day, lweek: t3[1].day };
      }, o.prototype._getDateByWeeksAndDay = function(i, t3, c3) {
        var p3 = this._getRangeInfo(c3);
        if (i > p3.weeks || i === 0 && t3 < p3.fweek || i === p3.weeks && t3 > p3.lweek)
          return null;
        var g3 = (i - 1) * 7 - p3.fweek + t3, b3 = new Date(p3.start.time);
        return b3.setDate(+p3.start.d + g3), this.getDateInfo(b3);
      }, o.create = function(i, t3) {
        var c3 = [];
        return i.eachComponent("calendar", function(p3) {
          var g3 = new o(p3, i, t3);
          c3.push(g3), p3.coordinateSystem = g3;
        }), i.eachSeries(function(p3) {
          p3.get("coordinateSystem") === "calendar" && (p3.coordinateSystem = c3[p3.get("calendarIndex") || 0]);
        }), c3;
      }, o.dimensions = ["time", "value"], o;
    }();
    function H7e(o) {
      var i = o.calendarModel, t3 = o.seriesModel, c3 = i ? i.coordinateSystem : t3 ? t3.coordinateSystem : null;
      return c3;
    }
    var ZEt = KEt;
    function JEt(o) {
      o.registerComponentModel($Et), o.registerComponentView(YEt), o.registerCoordinateSystem("calendar", ZEt);
    }
    function QEt(o, i) {
      var t3 = o.existing;
      if (i.id = o.keyInfo.id, !i.type && t3 && (i.type = t3.type), i.parentId == null) {
        var c3 = i.parentOption;
        c3 ? i.parentId = c3.id : t3 && (i.parentId = t3.parentId);
      }
      i.parentOption = null;
    }
    function W7e(o, i) {
      var t3;
      return yt(i, function(c3) {
        o[c3] != null && o[c3] !== "auto" && (t3 = true);
      }), t3;
    }
    function eDt(o, i, t3) {
      var c3 = ti({}, t3), p3 = o[i], g3 = t3.$action || "merge";
      g3 === "merge" ? p3 ? (Es(p3, c3, true), ik(p3, c3, { ignoreSize: true }), mLe(t3, p3), Vne(t3, p3), Vne(t3, p3, "shape"), Vne(t3, p3, "style"), Vne(t3, p3, "extra"), t3.clipPath = p3.clipPath) : o[i] = c3 : g3 === "replace" ? o[i] = c3 : g3 === "remove" && p3 && (o[i] = null);
    }
    var U7e = ["transition", "enterFrom", "leaveTo"], tDt = U7e.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
    function Vne(o, i, t3) {
      if (t3 && (!o[t3] && i[t3] && (o[t3] = {}), o = o[t3], i = i[t3]), !(!o || !i))
        for (var c3 = t3 ? U7e : tDt, p3 = 0; p3 < c3.length; p3++) {
          var g3 = c3[p3];
          o[g3] == null && i[g3] != null && (o[g3] = i[g3]);
        }
    }
    function nDt(o, i) {
      if (!!o && (o.hv = i.hv = [W7e(i, ["left", "right"]), W7e(i, ["top", "bottom"])], o.type === "group")) {
        var t3 = o, c3 = i;
        t3.width == null && (t3.width = c3.width = 0), t3.height == null && (t3.height = c3.height = 0);
      }
    }
    var rDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.preventAutoZ = true, t3;
      }
      return i.prototype.mergeOption = function(t3, c3) {
        var p3 = this.option.elements;
        this.option.elements = null, o.prototype.mergeOption.call(this, t3, c3), this.option.elements = p3;
      }, i.prototype.optionUpdated = function(t3, c3) {
        var p3 = this.option, g3 = (c3 ? p3 : t3).elements, b3 = p3.elements = c3 ? [] : p3.elements, w3 = [];
        this._flatten(g3, w3, null);
        var M = xg(b3, w3, "normalMerge"), I = this._elOptionsToUpdate = [];
        yt(M, function(k3, L) {
          var F = k3.newOption;
          !F || (I.push(F), QEt(k3, F), eDt(b3, L, F), nDt(b3[L], F));
        }, this), p3.elements = Zc(b3, function(k3) {
          return k3 && delete k3.$action, k3 != null;
        });
      }, i.prototype._flatten = function(t3, c3, p3) {
        yt(t3, function(g3) {
          if (g3) {
            p3 && (g3.parentOption = p3), c3.push(g3);
            var b3 = g3.children;
            g3.type === "group" && b3 && this._flatten(b3, c3, g3), delete g3.children;
          }
        }, this);
      }, i.prototype.useElOptionsToUpdate = function() {
        var t3 = this._elOptionsToUpdate;
        return this._elOptionsToUpdate = null, t3;
      }, i.type = "graphic", i.defaultOption = { elements: [] }, i;
    }(nc), q7e = { path: null, compoundPath: null, group: vs, image: Gv, text: Fl }, Vw = mu(), iDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function() {
        this._elMap = Eo();
      }, i.prototype.render = function(t3, c3, p3) {
        t3 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = t3, this._updateElements(t3), this._relocate(t3, p3);
      }, i.prototype._updateElements = function(t3) {
        var c3 = t3.useElOptionsToUpdate();
        if (c3) {
          var p3 = this._elMap, g3 = this.group, b3 = t3.get("z"), w3 = t3.get("zlevel");
          yt(c3, function(M) {
            var I = Jf(M.id, null), k3 = I != null ? p3.get(I) : null, L = Jf(M.parentId, null), F = L != null ? p3.get(L) : g3, B = M.type, G = M.style;
            B === "text" && G && M.hv && M.hv[1] && (G.textVerticalAlign = G.textBaseline = G.verticalAlign = G.align = null);
            var J = M.textContent, Q = M.textConfig;
            if (G && Y9e(G, B, !!Q, !!J)) {
              var se = K9e(G, B, true);
              !Q && se.textConfig && (Q = M.textConfig = se.textConfig), !J && se.textContent && (J = se.textContent);
            }
            var he = aDt(M), be = M.$action || "merge", de = be === "merge", Fe = be === "replace";
            if (de) {
              var Pe = !k3, ze = k3;
              Pe ? ze = $7e(I, F, M.type, p3) : (ze && (Vw(ze).isNew = false), o7e(ze)), ze && (Dne(ze, he, t3, { isInit: Pe }), X7e(ze, M, b3, w3));
            } else if (Fe) {
              Bne(k3, M, p3, t3);
              var $e = $7e(I, F, M.type, p3);
              $e && (Dne($e, he, t3, { isInit: true }), X7e($e, M, b3, w3));
            } else
              be === "remove" && (n7e(k3, M), Bne(k3, M, p3, t3));
            var Ke = p3.get(I);
            if (Ke && J)
              if (de) {
                var nt = Ke.getTextContent();
                nt ? nt.attr(J) : Ke.setTextContent(new Fl(J));
              } else
                Fe && Ke.setTextContent(new Fl(J));
            if (Ke) {
              var lt2 = M.clipPath;
              if (lt2) {
                var bt = lt2.type, vt = void 0, Pe = false;
                if (de) {
                  var jt = Ke.getClipPath();
                  Pe = !jt || Vw(jt).type !== bt, vt = Pe ? Pme(bt) : jt;
                } else
                  Fe && (Pe = true, vt = Pme(bt));
                Ke.setClipPath(vt), Dne(vt, lt2, t3, { isInit: Pe }), One(vt, lt2.keyframeAnimation, t3);
              }
              var Jt = Vw(Ke);
              Ke.setTextConfig(Q), Jt.option = M, oDt(Ke, t3, M), h8({ el: Ke, componentModel: t3, itemName: Ke.name, itemTooltipOption: M.tooltip }), One(Ke, M.keyframeAnimation, t3);
            }
          });
        }
      }, i.prototype._relocate = function(t3, c3) {
        for (var p3 = t3.option.elements, g3 = this.group, b3 = this._elMap, w3 = c3.getWidth(), M = c3.getHeight(), I = ["x", "y"], k3 = 0; k3 < p3.length; k3++) {
          var L = p3[k3], F = Jf(L.id, null), B = F != null ? b3.get(F) : null;
          if (!(!B || !B.isGroup)) {
            var G = B.parent, J = G === g3, Q = Vw(B), se = Vw(G);
            Q.width = Da(Q.option.width, J ? w3 : se.width) || 0, Q.height = Da(Q.option.height, J ? M : se.height) || 0;
          }
        }
        for (var k3 = p3.length - 1; k3 >= 0; k3--) {
          var L = p3[k3], F = Jf(L.id, null), B = F != null ? b3.get(F) : null;
          if (B) {
            var G = B.parent, se = Vw(G), he = G === g3 ? { width: w3, height: M } : { width: se.width, height: se.height }, be = {}, de = vte(B, L, he, null, { hv: L.hv, boundingMode: L.bounding }, be);
            if (!Vw(B).isNew && de) {
              for (var Fe = L.transition, Pe = {}, ze = 0; ze < I.length; ze++) {
                var $e = I[ze], Ke = be[$e];
                Fe && (IL(Fe) || rl(Fe, $e) >= 0) ? Pe[$e] = Ke : B[$e] = Ke;
              }
              Du(B, Pe, t3, 0);
            } else
              B.attr(be);
          }
        }
      }, i.prototype._clear = function() {
        var t3 = this, c3 = this._elMap;
        c3.each(function(p3) {
          Bne(p3, Vw(p3).option, c3, t3._lastGraphicModel);
        }), this._elMap = Eo();
      }, i.prototype.dispose = function() {
        this._clear();
      }, i.type = "graphic", i;
    }(ed);
    function Pme(o) {
      var i = so(q7e, o) ? q7e[o] : nn(o), t3 = new i({});
      return Vw(t3).type = o, t3;
    }
    function $7e(o, i, t3, c3) {
      var p3 = Pme(t3);
      return i.add(p3), c3.set(o, p3), Vw(p3).id = o, Vw(p3).isNew = true, p3;
    }
    function Bne(o, i, t3, c3) {
      var p3 = o && o.parent;
      p3 && (o.type === "group" && o.traverse(function(g3) {
        Bne(g3, i, t3, c3);
      }), kne(o, i, c3), t3.removeKey(Vw(o).id));
    }
    function X7e(o, i, t3, c3) {
      if (!o.isGroup) {
        var p3 = o;
        p3.cursor = Xs(i.cursor, Ab.prototype.cursor), p3.z = Xs(i.z, t3 || 0), p3.zlevel = Xs(i.zlevel, c3 || 0);
        var g3 = i.z2;
        g3 != null && (p3.z2 = g3 || 0);
      }
      yt(Gl(i), function(b3) {
        var w3 = i[b3];
        b3.indexOf("on") === 0 && Vo(w3) && (o[b3] = w3);
      }), o.draggable = i.draggable, i.name != null && (o.name = i.name), i.id != null && (o.id = i.id);
    }
    function aDt(o) {
      return o = ti({}, o), yt(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(yLe), function(i) {
        delete o[i];
      }), o;
    }
    function oDt(o, i, t3) {
      var c3 = La(o).eventData;
      !o.silent && !o.ignore && !c3 && (c3 = La(o).eventData = { componentType: "graphic", componentIndex: i.componentIndex, name: o.name }), c3 && (c3.info = t3.info);
    }
    function sDt(o) {
      o.registerComponentModel(rDt), o.registerComponentView(iDt), o.registerPreprocessor(function(i) {
        var t3 = i.graphic;
        Ei(t3) ? !t3[0] || !t3[0].elements ? i.graphic = [{ elements: t3 }] : i.graphic = [i.graphic[0]] : t3 && !t3.elements && (i.graphic = [{ elements: [t3] }]);
      });
    }
    var Y7e = ["x", "y", "radius", "angle", "single"], lDt = ["cartesian2d", "polar", "singleAxis"];
    function uDt(o) {
      var i = o.get("coordinateSystem");
      return rl(lDt, i) >= 0;
    }
    function _k(o) {
      return o + "Axis";
    }
    function cDt(o, i) {
      var t3 = Eo(), c3 = [], p3 = Eo();
      o.eachComponent({ mainType: "dataZoom", query: i }, function(k3) {
        p3.get(k3.uid) || w3(k3);
      });
      var g3;
      do
        g3 = false, o.eachComponent("dataZoom", b3);
      while (g3);
      function b3(k3) {
        !p3.get(k3.uid) && M(k3) && (w3(k3), g3 = true);
      }
      function w3(k3) {
        p3.set(k3.uid, true), c3.push(k3), I(k3);
      }
      function M(k3) {
        var L = false;
        return k3.eachTargetAxis(function(F, B) {
          var G = t3.get(F);
          G && G[B] && (L = true);
        }), L;
      }
      function I(k3) {
        k3.eachTargetAxis(function(L, F) {
          (t3.get(L) || t3.set(L, []))[F] = true;
        });
      }
      return c3;
    }
    function K7e(o) {
      var i = o.ecModel, t3 = { infoList: [], infoMap: Eo() };
      return o.eachTargetAxis(function(c3, p3) {
        var g3 = i.getComponent(_k(c3), p3);
        if (g3) {
          var b3 = g3.getCoordSysModel();
          if (b3) {
            var w3 = b3.uid, M = t3.infoMap.get(w3);
            M || (M = { model: b3, axisModels: [] }, t3.infoList.push(M), t3.infoMap.set(w3, M)), M.axisModels.push(g3);
          }
        }
      }), t3;
    }
    var Lme = function() {
      function o() {
        this.indexList = [], this.indexMap = [];
      }
      return o.prototype.add = function(i) {
        this.indexMap[i] || (this.indexList.push(i), this.indexMap[i] = true);
      }, o;
    }(), fDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._autoThrottle = true, t3._noTarget = true, t3._rangePropMode = ["percent", "percent"], t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        var g3 = Z7e(t3);
        this.settledOption = g3, this.mergeDefaultAndTheme(t3, p3), this._doInit(g3);
      }, i.prototype.mergeOption = function(t3) {
        var c3 = Z7e(t3);
        Es(this.option, t3, true), Es(this.settledOption, c3, true), this._doInit(c3);
      }, i.prototype._doInit = function(t3) {
        var c3 = this.option;
        this._setDefaultThrottle(t3), this._updateRangeUse(t3);
        var p3 = this.settledOption;
        yt([["start", "startValue"], ["end", "endValue"]], function(g3, b3) {
          this._rangePropMode[b3] === "value" && (c3[g3[0]] = p3[g3[0]] = null);
        }, this), this._resetTarget();
      }, i.prototype._resetTarget = function() {
        var t3 = this.get("orient", true), c3 = this._targetAxisInfoMap = Eo(), p3 = this._fillSpecifiedTargetAxis(c3);
        p3 ? this._orient = t3 || this._makeAutoOrientByTargetAxis() : (this._orient = t3 || "horizontal", this._fillAutoTargetAxisByOrient(c3, this._orient)), this._noTarget = true, c3.each(function(g3) {
          g3.indexList.length && (this._noTarget = false);
        }, this);
      }, i.prototype._fillSpecifiedTargetAxis = function(t3) {
        var c3 = false;
        return yt(Y7e, function(p3) {
          var g3 = this.getReferringComponents(_k(p3), Ade);
          if (g3.specified) {
            c3 = true;
            var b3 = new Lme();
            yt(g3.models, function(w3) {
              b3.add(w3.componentIndex);
            }), t3.set(p3, b3);
          }
        }, this), c3;
      }, i.prototype._fillAutoTargetAxisByOrient = function(t3, c3) {
        var p3 = this.ecModel, g3 = true;
        if (g3) {
          var b3 = c3 === "vertical" ? "y" : "x", w3 = p3.findComponents({ mainType: b3 + "Axis" });
          M(w3, b3);
        }
        if (g3) {
          var w3 = p3.findComponents({ mainType: "singleAxis", filter: function(k3) {
            return k3.get("orient", true) === c3;
          } });
          M(w3, "single");
        }
        function M(I, k3) {
          var L = I[0];
          if (L) {
            var F = new Lme();
            if (F.add(L.componentIndex), t3.set(k3, F), g3 = false, k3 === "x" || k3 === "y") {
              var B = L.getReferringComponents("grid", xd).models[0];
              B && yt(I, function(G) {
                L.componentIndex !== G.componentIndex && B === G.getReferringComponents("grid", xd).models[0] && F.add(G.componentIndex);
              });
            }
          }
        }
        g3 && yt(Y7e, function(I) {
          if (g3) {
            var k3 = p3.findComponents({ mainType: _k(I), filter: function(F) {
              return F.get("type", true) === "category";
            } });
            if (k3[0]) {
              var L = new Lme();
              L.add(k3[0].componentIndex), t3.set(I, L), g3 = false;
            }
          }
        }, this);
      }, i.prototype._makeAutoOrientByTargetAxis = function() {
        var t3;
        return this.eachTargetAxis(function(c3) {
          !t3 && (t3 = c3);
        }, this), t3 === "y" ? "vertical" : "horizontal";
      }, i.prototype._setDefaultThrottle = function(t3) {
        if (t3.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
          var c3 = this.ecModel.option;
          this.option.throttle = c3.animation && c3.animationDurationUpdate > 0 ? 100 : 20;
        }
      }, i.prototype._updateRangeUse = function(t3) {
        var c3 = this._rangePropMode, p3 = this.get("rangeMode");
        yt([["start", "startValue"], ["end", "endValue"]], function(g3, b3) {
          var w3 = t3[g3[0]] != null, M = t3[g3[1]] != null;
          w3 && !M ? c3[b3] = "percent" : !w3 && M ? c3[b3] = "value" : p3 ? c3[b3] = p3[b3] : w3 && (c3[b3] = "percent");
        });
      }, i.prototype.noTarget = function() {
        return this._noTarget;
      }, i.prototype.getFirstTargetAxisModel = function() {
        var t3;
        return this.eachTargetAxis(function(c3, p3) {
          t3 == null && (t3 = this.ecModel.getComponent(_k(c3), p3));
        }, this), t3;
      }, i.prototype.eachTargetAxis = function(t3, c3) {
        this._targetAxisInfoMap.each(function(p3, g3) {
          yt(p3.indexList, function(b3) {
            t3.call(c3, g3, b3);
          });
        });
      }, i.prototype.getAxisProxy = function(t3, c3) {
        var p3 = this.getAxisModel(t3, c3);
        if (p3)
          return p3.__dzAxisProxy;
      }, i.prototype.getAxisModel = function(t3, c3) {
        var p3 = this._targetAxisInfoMap.get(t3);
        if (p3 && p3.indexMap[c3])
          return this.ecModel.getComponent(_k(t3), c3);
      }, i.prototype.setRawRange = function(t3) {
        var c3 = this.option, p3 = this.settledOption;
        yt([["start", "startValue"], ["end", "endValue"]], function(g3) {
          (t3[g3[0]] != null || t3[g3[1]] != null) && (c3[g3[0]] = p3[g3[0]] = t3[g3[0]], c3[g3[1]] = p3[g3[1]] = t3[g3[1]]);
        }, this), this._updateRangeUse(t3);
      }, i.prototype.setCalculatedRange = function(t3) {
        var c3 = this.option;
        yt(["start", "startValue", "end", "endValue"], function(p3) {
          c3[p3] = t3[p3];
        });
      }, i.prototype.getPercentRange = function() {
        var t3 = this.findRepresentativeAxisProxy();
        if (t3)
          return t3.getDataPercentWindow();
      }, i.prototype.getValueRange = function(t3, c3) {
        if (t3 == null && c3 == null) {
          var p3 = this.findRepresentativeAxisProxy();
          if (p3)
            return p3.getDataValueWindow();
        } else
          return this.getAxisProxy(t3, c3).getDataValueWindow();
      }, i.prototype.findRepresentativeAxisProxy = function(t3) {
        if (t3)
          return t3.__dzAxisProxy;
        for (var c3, p3 = this._targetAxisInfoMap.keys(), g3 = 0; g3 < p3.length; g3++)
          for (var b3 = p3[g3], w3 = this._targetAxisInfoMap.get(b3), M = 0; M < w3.indexList.length; M++) {
            var I = this.getAxisProxy(b3, w3.indexList[M]);
            if (I.hostedBy(this))
              return I;
            c3 || (c3 = I);
          }
        return c3;
      }, i.prototype.getRangePropMode = function() {
        return this._rangePropMode.slice();
      }, i.prototype.getOrient = function() {
        return this._orient;
      }, i.type = "dataZoom", i.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], i.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, i;
    }(nc);
    function Z7e(o) {
      var i = {};
      return yt(["start", "end", "startValue", "endValue", "throttle"], function(t3) {
        o.hasOwnProperty(t3) && (i[t3] = o[t3]);
      }), i;
    }
    var kW = fDt, hDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "dataZoom.select", i;
    }(kW), pDt = hDt, dDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        this.dataZoomModel = t3, this.ecModel = c3, this.api = p3;
      }, i.type = "dataZoom", i;
    }(ed), Rme = dDt, vDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "dataZoom.select", i;
    }(Rme), gDt = vDt, q8 = yt, J7e = dy, yDt = function() {
      function o(i, t3, c3, p3) {
        this._dimName = i, this._axisIndex = t3, this.ecModel = p3, this._dataZoomModel = c3;
      }
      return o.prototype.hostedBy = function(i) {
        return this._dataZoomModel === i;
      }, o.prototype.getDataValueWindow = function() {
        return this._valueWindow.slice();
      }, o.prototype.getDataPercentWindow = function() {
        return this._percentWindow.slice();
      }, o.prototype.getTargetSeriesModels = function() {
        var i = [];
        return this.ecModel.eachSeries(function(t3) {
          if (uDt(t3)) {
            var c3 = _k(this._dimName), p3 = t3.getReferringComponents(c3, xd).models[0];
            p3 && this._axisIndex === p3.componentIndex && i.push(t3);
          }
        }, this), i;
      }, o.prototype.getAxisModel = function() {
        return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
      }, o.prototype.getMinMaxSpan = function() {
        return Jo(this._minMaxSpan);
      }, o.prototype.calculateDataWindow = function(i) {
        var t3 = this._dataExtent, c3 = this.getAxisModel(), p3 = c3.axis.scale, g3 = this._dataZoomModel.getRangePropMode(), b3 = [0, 100], w3 = [], M = [], I;
        q8(["start", "end"], function(F, B) {
          var G = i[F], J = i[F + "Value"];
          g3[B] === "percent" ? (G == null && (G = b3[B]), J = p3.parse(Bc(G, b3, t3))) : (I = true, J = J == null ? t3[B] : p3.parse(J), G = Bc(J, t3, b3)), M[B] = J, w3[B] = G;
        }), J7e(M), J7e(w3);
        var k3 = this._minMaxSpan;
        I ? L(M, w3, t3, b3, false) : L(w3, M, b3, t3, true);
        function L(F, B, G, J, Q) {
          var se = Q ? "Span" : "ValueSpan";
          ML(0, F, G, "all", k3["min" + se], k3["max" + se]);
          for (var he = 0; he < 2; he++)
            B[he] = Bc(F[he], G, J, true), Q && (B[he] = p3.parse(B[he]));
        }
        return { valueWindow: M, percentWindow: w3 };
      }, o.prototype.reset = function(i) {
        if (i === this._dataZoomModel) {
          var t3 = this.getTargetSeriesModels();
          this._dataExtent = mDt(this, this._dimName, t3), this._updateMinMaxSpan();
          var c3 = this.calculateDataWindow(i.settledOption);
          this._valueWindow = c3.valueWindow, this._percentWindow = c3.percentWindow, this._setAxisModel();
        }
      }, o.prototype.filterData = function(i, t3) {
        if (i !== this._dataZoomModel)
          return;
        var c3 = this._dimName, p3 = this.getTargetSeriesModels(), g3 = i.get("filterMode"), b3 = this._valueWindow;
        if (g3 === "none")
          return;
        q8(p3, function(M) {
          var I = M.getData(), k3 = I.mapDimensionsAll(c3);
          if (k3.length) {
            if (g3 === "weakFilter") {
              var L = I.getStore(), F = Fi(k3, function(B) {
                return I.getDimensionIndex(B);
              }, I);
              I.filterSelf(function(B) {
                for (var G, J, Q, se = 0; se < k3.length; se++) {
                  var he = L.get(F[se], B), be = !isNaN(he), de = he < b3[0], Fe = he > b3[1];
                  if (be && !de && !Fe)
                    return true;
                  be && (Q = true), de && (G = true), Fe && (J = true);
                }
                return Q && G && J;
              });
            } else
              q8(k3, function(B) {
                if (g3 === "empty")
                  M.setData(I = I.map(B, function(J) {
                    return w3(J) ? J : NaN;
                  }));
                else {
                  var G = {};
                  G[B] = b3, I.selectRange(G);
                }
              });
            q8(k3, function(B) {
              I.setApproximateExtent(b3, B);
            });
          }
        });
        function w3(M) {
          return M >= b3[0] && M <= b3[1];
        }
      }, o.prototype._updateMinMaxSpan = function() {
        var i = this._minMaxSpan = {}, t3 = this._dataZoomModel, c3 = this._dataExtent;
        q8(["min", "max"], function(p3) {
          var g3 = t3.get(p3 + "Span"), b3 = t3.get(p3 + "ValueSpan");
          b3 != null && (b3 = this.getAxisModel().axis.scale.parse(b3)), b3 != null ? g3 = Bc(c3[0] + b3, c3, [0, 100], true) : g3 != null && (b3 = Bc(g3, [0, 100], c3, true) - c3[0]), i[p3 + "Span"] = g3, i[p3 + "ValueSpan"] = b3;
        }, this);
      }, o.prototype._setAxisModel = function() {
        var i = this.getAxisModel(), t3 = this._percentWindow, c3 = this._valueWindow;
        if (t3) {
          var p3 = HQ(c3, [0, 500]);
          p3 = Math.min(p3, 20);
          var g3 = i.axis.scale.rawExtentInfo;
          t3[0] !== 0 && g3.setDeterminedMinMax("min", +c3[0].toFixed(p3)), t3[1] !== 100 && g3.setDeterminedMinMax("max", +c3[1].toFixed(p3)), g3.freeze();
        }
      }, o;
    }();
    function mDt(o, i, t3) {
      var c3 = [1 / 0, -1 / 0];
      q8(t3, function(b3) {
        G1t(c3, b3.getData(), i);
      });
      var p3 = o.getAxisModel(), g3 = l6e(p3.axis.scale, p3, c3).calculate();
      return [g3.min, g3.max];
    }
    var bDt = yDt, _Dt = { getTargetSeries: function(o) {
      function i(p3) {
        o.eachComponent("dataZoom", function(g3) {
          g3.eachTargetAxis(function(b3, w3) {
            var M = o.getComponent(_k(b3), w3);
            p3(b3, w3, M, g3);
          });
        });
      }
      i(function(p3, g3, b3, w3) {
        b3.__dzAxisProxy = null;
      });
      var t3 = [];
      i(function(p3, g3, b3, w3) {
        b3.__dzAxisProxy || (b3.__dzAxisProxy = new bDt(p3, g3, w3, o), t3.push(b3.__dzAxisProxy));
      });
      var c3 = Eo();
      return yt(t3, function(p3) {
        yt(p3.getTargetSeriesModels(), function(g3) {
          c3.set(g3.uid, g3);
        });
      }), c3;
    }, overallReset: function(o, i) {
      o.eachComponent("dataZoom", function(t3) {
        t3.eachTargetAxis(function(c3, p3) {
          t3.getAxisProxy(c3, p3).reset(t3);
        }), t3.eachTargetAxis(function(c3, p3) {
          t3.getAxisProxy(c3, p3).filterData(t3, i);
        });
      }), o.eachComponent("dataZoom", function(t3) {
        var c3 = t3.findRepresentativeAxisProxy();
        if (c3) {
          var p3 = c3.getDataPercentWindow(), g3 = c3.getDataValueWindow();
          t3.setCalculatedRange({ start: p3[0], end: p3[1], startValue: g3[0], endValue: g3[1] });
        }
      });
    } }, xDt = _Dt;
    function wDt(o) {
      o.registerAction("dataZoom", function(i, t3) {
        var c3 = cDt(t3, i);
        yt(c3, function(p3) {
          p3.setRawRange({ start: i.start, end: i.end, startValue: i.startValue, endValue: i.endValue });
        });
      });
    }
    var Q7e = false;
    function Nme(o) {
      Q7e || (Q7e = true, o.registerProcessor(o.PRIORITY.PROCESSOR.FILTER, xDt), wDt(o), o.registerSubTypeDefaulter("dataZoom", function() {
        return "slider";
      }));
    }
    function SDt(o) {
      o.registerComponentModel(pDt), o.registerComponentView(gDt), Nme(o);
    }
    var Bw = function() {
      function o() {
      }
      return o;
    }(), eVe = {};
    function $8(o, i) {
      eVe[o] = i;
    }
    function tVe(o) {
      return eVe[o];
    }
    var CDt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.optionUpdated = function() {
        o.prototype.optionUpdated.apply(this, arguments);
        var t3 = this.ecModel;
        yt(this.option.feature, function(c3, p3) {
          var g3 = tVe(p3);
          g3 && (g3.getDefaultOption && (g3.defaultOption = g3.getDefaultOption(t3)), Es(c3, g3.defaultOption));
        });
      }, i.type = "toolbox", i.layoutMode = { type: "box", ignoreSize: true }, i.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, i;
    }(nc), MDt = CDt;
    function TDt(o, i, t3) {
      var c3 = i.getBoxLayoutParams(), p3 = i.get("padding"), g3 = { width: t3.getWidth(), height: t3.getHeight() }, b3 = Wv(c3, g3, p3);
      iL(i.get("orient"), o, i.get("itemGap"), b3.width, b3.height), vte(o, c3, g3, p3);
    }
    function nVe(o, i) {
      var t3 = y8(i.get("padding")), c3 = i.getItemStyle(["color", "opacity"]);
      return c3.fill = i.get("backgroundColor"), o = new bu({ shape: { x: o.x - t3[3], y: o.y - t3[0], width: o.width + t3[1] + t3[3], height: o.height + t3[0] + t3[2], r: i.get("borderRadius") }, style: c3, silent: true, z2: -1 }), o;
    }
    var ADt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        var b3 = this.group;
        if (b3.removeAll(), !t3.get("show"))
          return;
        var w3 = +t3.get("itemSize"), M = t3.get("feature") || {}, I = this._features || (this._features = {}), k3 = [];
        yt(M, function(B, G) {
          k3.push(G);
        }), new RI(this._featureNames || [], k3).add(L).update(L).remove(As(L, null)).execute(), this._featureNames = k3;
        function L(B, G) {
          var J = k3[B], Q = k3[G], se = M[J], he = new gh(se, t3, t3.ecModel), be;
          if (g3 && g3.newTitle != null && g3.featureName === J && (se.title = g3.newTitle), J && !Q) {
            if (IDt(J))
              be = { onclick: he.option.onclick, featureName: J };
            else {
              var de = tVe(J);
              if (!de)
                return;
              be = new de();
            }
            I[J] = be;
          } else if (be = I[Q], !be)
            return;
          be.uid = d8("toolbox-feature"), be.model = he, be.ecModel = c3, be.api = p3;
          var Fe = be instanceof Bw;
          if (!J && Q) {
            Fe && be.dispose && be.dispose(c3, p3);
            return;
          }
          if (!he.get("show") || Fe && be.unusable) {
            Fe && be.remove && be.remove(c3, p3);
            return;
          }
          F(he, be, J), he.setIconStatus = function(Pe, ze) {
            var $e = this.option, Ke = this.iconPaths;
            $e.iconStatus = $e.iconStatus || {}, $e.iconStatus[Pe] = ze, Ke[Pe] && (ze === "emphasis" ? Hv : sl)(Ke[Pe]);
          }, be instanceof Bw && be.render && be.render(he, c3, p3, g3);
        }
        function F(B, G, J) {
          var Q = B.getModel("iconStyle"), se = B.getModel(["emphasis", "iconStyle"]), he = G instanceof Bw && G.getIcons ? G.getIcons() : B.get("icon"), be = B.get("title") || {}, de, Fe;
          Ha(he) ? (de = {}, de[J] = he) : de = he, Ha(be) ? (Fe = {}, Fe[J] = be) : Fe = be;
          var Pe = B.iconPaths = {};
          yt(de, function(ze, $e) {
            var Ke = ip(ze, {}, { x: -w3 / 2, y: -w3 / 2, width: w3, height: w3 });
            Ke.setStyle(Q.getItemStyle());
            var nt = Ke.ensureState("emphasis");
            nt.style = se.getItemStyle();
            var lt2 = new Fl({ style: { text: Fe[$e], align: se.get("textAlign"), borderRadius: se.get("textBorderRadius"), padding: se.get("textPadding"), fill: null }, ignore: true });
            Ke.setTextContent(lt2), h8({ el: Ke, componentModel: t3, itemName: $e, formatterParamsExtra: { title: Fe[$e] } }), Ke.__title = Fe[$e], Ke.on("mouseover", function() {
              var bt = se.getItemStyle(), vt = t3.get("orient") === "vertical" ? t3.get("right") == null ? "right" : "left" : t3.get("bottom") == null ? "bottom" : "top";
              lt2.setStyle({ fill: se.get("textFill") || bt.fill || bt.stroke || "#000", backgroundColor: se.get("textBackgroundColor") }), Ke.setTextConfig({ position: se.get("textPosition") || vt }), lt2.ignore = !t3.get("showTitle"), Hv(this);
            }).on("mouseout", function() {
              B.get(["iconStatus", $e]) !== "emphasis" && sl(this), lt2.hide();
            }), (B.get(["iconStatus", $e]) === "emphasis" ? Hv : sl)(Ke), b3.add(Ke), Ke.on("click", Qa(G.onclick, G, c3, p3, $e)), Pe[$e] = Ke;
          });
        }
        TDt(b3, t3, p3), b3.add(nVe(b3.getBoundingRect(), t3)), b3.eachChild(function(B) {
          var G = B.__title, J = B.ensureState("emphasis"), Q = J.textConfig || (J.textConfig = {}), se = B.getTextContent(), he = se && se.states.emphasis;
          if (he && !Vo(he) && G) {
            var be = he.style || (he.style = {}), de = pI(G, Fl.makeFont(be)), Fe = B.x + b3.x, Pe = B.y + b3.y + w3, ze = false;
            Pe + de.height > p3.getHeight() && (Q.position = "top", ze = true);
            var $e = ze ? -5 - de.height : w3 + 8;
            Fe + de.width / 2 > p3.getWidth() ? (Q.position = ["100%", $e], be.align = "right") : Fe - de.width / 2 < 0 && (Q.position = [0, $e], be.align = "left");
          }
        });
      }, i.prototype.updateView = function(t3, c3, p3, g3) {
        yt(this._features, function(b3) {
          b3 instanceof Bw && b3.updateView && b3.updateView(b3.model, c3, p3, g3);
        });
      }, i.prototype.remove = function(t3, c3) {
        yt(this._features, function(p3) {
          p3 instanceof Bw && p3.remove && p3.remove(t3, c3);
        }), this.group.removeAll();
      }, i.prototype.dispose = function(t3, c3) {
        yt(this._features, function(p3) {
          p3 instanceof Bw && p3.dispose && p3.dispose(t3, c3);
        });
      }, i.type = "toolbox", i;
    }(ed);
    function IDt(o) {
      return o.indexOf("my") === 0;
    }
    var EDt = ADt, DDt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.onclick = function(t3, c3) {
        var p3 = this.model, g3 = p3.get("name") || t3.get("title.0.text") || "echarts", b3 = c3.getZr().painter.getType() === "svg", w3 = b3 ? "svg" : p3.get("type", true) || "png", M = c3.getConnectedDataURL({ type: w3, backgroundColor: p3.get("backgroundColor", true) || t3.get("backgroundColor") || "#fff", connectedBackgroundColor: p3.get("connectedBackgroundColor"), excludeComponents: p3.get("excludeComponents"), pixelRatio: p3.get("pixelRatio") }), I = yo.browser;
        if (Vo(MouseEvent) && (I.newEdge || !I.ie && !I.edge)) {
          var k3 = document.createElement("a");
          k3.download = g3 + "." + w3, k3.target = "_blank", k3.href = M;
          var L = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
          k3.dispatchEvent(L);
        } else if (window.navigator.msSaveOrOpenBlob || b3) {
          var F = M.split(","), B = F[0].indexOf("base64") > -1, G = b3 ? decodeURIComponent(F[1]) : F[1];
          B && (G = window.atob(G));
          var J = g3 + "." + w3;
          if (window.navigator.msSaveOrOpenBlob) {
            for (var Q = G.length, se = new Uint8Array(Q); Q--; )
              se[Q] = G.charCodeAt(Q);
            var he = new Blob([se]);
            window.navigator.msSaveOrOpenBlob(he, J);
          } else {
            var be = document.createElement("iframe");
            document.body.appendChild(be);
            var de = be.contentWindow, Fe = de.document;
            Fe.open("image/svg+xml", "replace"), Fe.write(G), Fe.close(), de.focus(), Fe.execCommand("SaveAs", true, J), document.body.removeChild(be);
          }
        } else {
          var Pe = p3.get("lang"), ze = '<body style="margin:0;"><img src="' + M + '" style="max-width:100%;" title="' + (Pe && Pe[0] || "") + '" /></body>', $e = window.open();
          $e.document.write(ze), $e.document.title = g3;
        }
      }, i.getDefaultOption = function(t3) {
        var c3 = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: t3.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: t3.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
        return c3;
      }, i;
    }(Bw), kDt = DDt, rVe = "__ec_magicType_stack__", ODt = [["line", "bar"], ["stack"]], PDt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.getIcons = function() {
        var t3 = this.model, c3 = t3.get("icon"), p3 = {};
        return yt(t3.get("type"), function(g3) {
          c3[g3] && (p3[g3] = c3[g3]);
        }), p3;
      }, i.getDefaultOption = function(t3) {
        var c3 = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: t3.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
        return c3;
      }, i.prototype.onclick = function(t3, c3, p3) {
        var g3 = this.model, b3 = g3.get(["seriesIndex", p3]);
        if (iVe[p3]) {
          var w3 = { series: [] }, M = function(L) {
            var F = L.subType, B = L.id, G = iVe[p3](F, B, L, g3);
            G && (Uo(G, L.option), w3.series.push(G));
            var J = L.coordinateSystem;
            if (J && J.type === "cartesian2d" && (p3 === "line" || p3 === "bar")) {
              var Q = J.getAxesByScale("ordinal")[0];
              if (Q) {
                var se = Q.dim, he = se + "Axis", be = L.getReferringComponents(he, xd).models[0], de = be.componentIndex;
                w3[he] = w3[he] || [];
                for (var Fe = 0; Fe <= de; Fe++)
                  w3[he][de] = w3[he][de] || {};
                w3[he][de].boundaryGap = p3 === "bar";
              }
            }
          };
          yt(ODt, function(L) {
            rl(L, p3) >= 0 && yt(L, function(F) {
              g3.setIconStatus(F, "normal");
            });
          }), g3.setIconStatus(p3, "emphasis"), t3.eachComponent({ mainType: "series", query: b3 == null ? null : { seriesIndex: b3 } }, M);
          var I, k3 = p3;
          p3 === "stack" && (I = Es({ stack: g3.option.title.tiled, tiled: g3.option.title.stack }, g3.option.title), g3.get(["iconStatus", p3]) !== "emphasis" && (k3 = "tiled")), c3.dispatchAction({ type: "changeMagicType", currentType: k3, newOption: w3, newTitle: I, featureName: "magicType" });
        }
      }, i;
    }(Bw), iVe = { line: function(o, i, t3, c3) {
      if (o === "bar")
        return Es({ id: i, type: "line", data: t3.get("data"), stack: t3.get("stack"), markPoint: t3.get("markPoint"), markLine: t3.get("markLine") }, c3.get(["option", "line"]) || {}, true);
    }, bar: function(o, i, t3, c3) {
      if (o === "line")
        return Es({ id: i, type: "bar", data: t3.get("data"), stack: t3.get("stack"), markPoint: t3.get("markPoint"), markLine: t3.get("markLine") }, c3.get(["option", "bar"]) || {}, true);
    }, stack: function(o, i, t3, c3) {
      var p3 = t3.get("stack") === rVe;
      if (o === "line" || o === "bar")
        return c3.setIconStatus("stack", p3 ? "normal" : "emphasis"), Es({ id: i, stack: p3 ? "" : rVe }, c3.get(["option", "stack"]) || {}, true);
    } };
    ZM({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(o, i) {
      i.mergeOption(o.newOption);
    });
    var LDt = PDt, zne = new Array(60).join("-"), X8 = "	";
    function RDt(o) {
      var i = {}, t3 = [], c3 = [];
      return o.eachRawSeries(function(p3) {
        var g3 = p3.coordinateSystem;
        if (g3 && (g3.type === "cartesian2d" || g3.type === "polar")) {
          var b3 = g3.getBaseAxis();
          if (b3.type === "category") {
            var w3 = b3.dim + "_" + b3.index;
            i[w3] || (i[w3] = { categoryAxis: b3, valueAxis: g3.getOtherAxis(b3), series: [] }, c3.push({ axisDim: b3.dim, axisIndex: b3.index })), i[w3].series.push(p3);
          } else
            t3.push(p3);
        } else
          t3.push(p3);
      }), { seriesGroupByCategoryAxis: i, other: t3, meta: c3 };
    }
    function NDt(o) {
      var i = [];
      return yt(o, function(t3, c3) {
        var p3 = t3.categoryAxis, g3 = t3.valueAxis, b3 = g3.dim, w3 = [" "].concat(Fi(t3.series, function(B) {
          return B.name;
        })), M = [p3.model.getCategories()];
        yt(t3.series, function(B) {
          var G = B.getRawData();
          M.push(B.getRawData().mapArray(G.mapDimension(b3), function(J) {
            return J;
          }));
        });
        for (var I = [w3.join(X8)], k3 = 0; k3 < M[0].length; k3++) {
          for (var L = [], F = 0; F < M.length; F++)
            L.push(M[F][k3]);
          I.push(L.join(X8));
        }
        i.push(I.join(`
`));
      }), i.join(`

` + zne + `

`);
    }
    function FDt(o) {
      return Fi(o, function(i) {
        var t3 = i.getRawData(), c3 = [i.name], p3 = [];
        return t3.each(t3.dimensions, function() {
          for (var g3 = arguments.length, b3 = arguments[g3 - 1], w3 = t3.getName(b3), M = 0; M < g3 - 1; M++)
            p3[M] = arguments[M];
          c3.push((w3 ? w3 + X8 : "") + p3.join(X8));
        }), c3.join(`
`);
      }).join(`

` + zne + `

`);
    }
    function VDt(o) {
      var i = RDt(o);
      return { value: Zc([NDt(i.seriesGroupByCategoryAxis), FDt(i.other)], function(t3) {
        return !!t3.replace(/[\n\t\s]/g, "");
      }).join(`

` + zne + `

`), meta: i.meta };
    }
    function jne(o) {
      return o.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
    }
    function BDt(o) {
      var i = o.slice(0, o.indexOf(`
`));
      if (i.indexOf(X8) >= 0)
        return true;
    }
    var Fme = new RegExp("[" + X8 + "]+", "g");
    function zDt(o) {
      for (var i = o.split(/\n+/g), t3 = jne(i.shift()).split(Fme), c3 = [], p3 = Fi(t3, function(M) {
        return { name: M, data: [] };
      }), g3 = 0; g3 < i.length; g3++) {
        var b3 = jne(i[g3]).split(Fme);
        c3.push(b3.shift());
        for (var w3 = 0; w3 < b3.length; w3++)
          p3[w3] && (p3[w3].data[g3] = b3[w3]);
      }
      return { series: p3, categories: c3 };
    }
    function jDt(o) {
      for (var i = o.split(/\n+/g), t3 = jne(i.shift()), c3 = [], p3 = 0; p3 < i.length; p3++) {
        var g3 = jne(i[p3]);
        if (g3) {
          var b3 = g3.split(Fme), w3 = "", M = void 0, I = false;
          isNaN(b3[0]) ? (I = true, w3 = b3[0], b3 = b3.slice(1), c3[p3] = { name: w3, value: [] }, M = c3[p3].value) : M = c3[p3] = [];
          for (var k3 = 0; k3 < b3.length; k3++)
            M.push(+b3[k3]);
          M.length === 1 && (I ? c3[p3].value = M[0] : c3[p3] = M[0]);
        }
      }
      return { name: t3, data: c3 };
    }
    function GDt(o, i) {
      var t3 = o.split(new RegExp(`
*` + zne + `
*`, "g")), c3 = { series: [] };
      return yt(t3, function(p3, g3) {
        if (BDt(p3)) {
          var b3 = zDt(p3), w3 = i[g3], M = w3.axisDim + "Axis";
          w3 && (c3[M] = c3[M] || [], c3[M][w3.axisIndex] = { data: b3.categories }, c3.series = c3.series.concat(b3.series));
        } else {
          var b3 = jDt(p3);
          c3.series.push(b3);
        }
      }), c3;
    }
    var HDt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.onclick = function(t3, c3) {
        setTimeout(function() {
          c3.dispatchAction({ type: "hideTip" });
        });
        var p3 = c3.getDom(), g3 = this.model;
        this._dom && p3.removeChild(this._dom);
        var b3 = document.createElement("div");
        b3.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", b3.style.backgroundColor = g3.get("backgroundColor") || "#fff";
        var w3 = document.createElement("h4"), M = g3.get("lang") || [];
        w3.innerHTML = M[0] || g3.get("title"), w3.style.cssText = "margin:10px 20px", w3.style.color = g3.get("textColor");
        var I = document.createElement("div"), k3 = document.createElement("textarea");
        I.style.cssText = "overflow:auto";
        var L = g3.get("optionToContent"), F = g3.get("contentToOption"), B = VDt(t3);
        if (Vo(L)) {
          var G = L(c3.getOption());
          Ha(G) ? I.innerHTML = G : hP(G) && I.appendChild(G);
        } else {
          k3.readOnly = g3.get("readOnly");
          var J = k3.style;
          J.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", J.color = g3.get("textColor"), J.borderColor = g3.get("textareaBorderColor"), J.backgroundColor = g3.get("textareaColor"), k3.value = B.value, I.appendChild(k3);
        }
        var Q = B.meta, se = document.createElement("div");
        se.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
        var he = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", be = document.createElement("div"), de = document.createElement("div");
        he += ";background-color:" + g3.get("buttonColor"), he += ";color:" + g3.get("buttonTextColor");
        var Fe = this;
        function Pe() {
          p3.removeChild(b3), Fe._dom = null;
        }
        w5(be, "click", Pe), w5(de, "click", function() {
          if (F == null && L != null || F != null && L == null) {
            Pe();
            return;
          }
          var ze;
          try {
            Vo(F) ? ze = F(I, c3.getOption()) : ze = GDt(k3.value, Q);
          } catch ($e) {
            throw Pe(), new Error("Data view format error " + $e);
          }
          ze && c3.dispatchAction({ type: "changeDataView", newOption: ze }), Pe();
        }), be.innerHTML = M[1], de.innerHTML = M[2], de.style.cssText = be.style.cssText = he, !g3.get("readOnly") && se.appendChild(de), se.appendChild(be), b3.appendChild(w3), b3.appendChild(I), b3.appendChild(se), I.style.height = p3.clientHeight - 80 + "px", p3.appendChild(b3), this._dom = b3;
      }, i.prototype.remove = function(t3, c3) {
        this._dom && c3.getDom().removeChild(this._dom);
      }, i.prototype.dispose = function(t3, c3) {
        this.remove(t3, c3);
      }, i.getDefaultOption = function(t3) {
        var c3 = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: t3.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: t3.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
        return c3;
      }, i;
    }(Bw);
    function WDt(o, i) {
      return Fi(o, function(t3, c3) {
        var p3 = i && i[c3];
        if (Ua(p3) && !Ei(p3)) {
          var g3 = Ua(t3) && !Ei(t3);
          g3 || (t3 = { value: t3 });
          var b3 = p3.name != null && t3.name == null;
          return t3 = Uo(t3, p3), b3 && delete t3.name, t3;
        } else
          return t3;
      });
    }
    ZM({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(o, i) {
      var t3 = [];
      yt(o.newOption.series, function(c3) {
        var p3 = i.getSeriesByName(c3.name)[0];
        if (!p3)
          t3.push(ti({ type: "scatter" }, c3));
        else {
          var g3 = p3.get("data");
          t3.push({ name: c3.name, data: WDt(c3.data, g3) });
        }
      }), i.mergeOption(Uo({ series: t3 }, o.newOption));
    });
    var UDt = HDt, aVe = yt, oVe = mu();
    function qDt(o, i) {
      var t3 = Vme(o);
      aVe(i, function(c3, p3) {
        for (var g3 = t3.length - 1; g3 >= 0; g3--) {
          var b3 = t3[g3];
          if (b3[p3])
            break;
        }
        if (g3 < 0) {
          var w3 = o.queryComponents({ mainType: "dataZoom", subType: "select", id: p3 })[0];
          if (w3) {
            var M = w3.getPercentRange();
            t3[0][p3] = { dataZoomId: p3, start: M[0], end: M[1] };
          }
        }
      }), t3.push(i);
    }
    function $Dt(o) {
      var i = Vme(o), t3 = i[i.length - 1];
      i.length > 1 && i.pop();
      var c3 = {};
      return aVe(t3, function(p3, g3) {
        for (var b3 = i.length - 1; b3 >= 0; b3--)
          if (p3 = i[b3][g3], p3) {
            c3[g3] = p3;
            break;
          }
      }), c3;
    }
    function XDt(o) {
      oVe(o).snapshots = null;
    }
    function YDt(o) {
      return Vme(o).length;
    }
    function Vme(o) {
      var i = oVe(o);
      return i.snapshots || (i.snapshots = [{}]), i.snapshots;
    }
    var KDt = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.onclick = function(t3, c3) {
        XDt(t3), c3.dispatchAction({ type: "restore", from: this.uid });
      }, i.getDefaultOption = function(t3) {
        var c3 = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: t3.getLocaleModel().get(["toolbox", "restore", "title"]) };
        return c3;
      }, i;
    }(Bw);
    ZM({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(o, i) {
      i.resetOption("recreate");
    });
    var ZDt = KDt, JDt = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], QDt = function() {
      function o(i, t3, c3) {
        var p3 = this;
        this._targetInfoList = [];
        var g3 = sVe(t3, i);
        yt(e5t, function(b3, w3) {
          (!c3 || !c3.include || rl(c3.include, w3) >= 0) && b3(g3, p3._targetInfoList);
        });
      }
      return o.prototype.setOutputRanges = function(i, t3) {
        return this.matchOutputRanges(i, t3, function(c3, p3, g3) {
          if ((c3.coordRanges || (c3.coordRanges = [])).push(p3), !c3.coordRange) {
            c3.coordRange = p3;
            var b3 = zme[c3.brushType](0, g3, p3);
            c3.__rangeOffset = { offset: fVe[c3.brushType](b3.values, c3.range, [1, 1]), xyMinMax: b3.xyMinMax };
          }
        }), i;
      }, o.prototype.matchOutputRanges = function(i, t3, c3) {
        yt(i, function(p3) {
          var g3 = this.findTargetInfo(p3, t3);
          g3 && g3 !== true && yt(g3.coordSyses, function(b3) {
            var w3 = zme[p3.brushType](1, b3, p3.range, true);
            c3(p3, w3.values, b3, t3);
          });
        }, this);
      }, o.prototype.setInputRanges = function(i, t3) {
        yt(i, function(c3) {
          var p3 = this.findTargetInfo(c3, t3);
          if (c3.range = c3.range || [], p3 && p3 !== true) {
            c3.panelId = p3.panelId;
            var g3 = zme[c3.brushType](0, p3.coordSys, c3.coordRange), b3 = c3.__rangeOffset;
            c3.range = b3 ? fVe[c3.brushType](g3.values, b3.offset, t5t(g3.xyMinMax, b3.xyMinMax)) : g3.values;
          }
        }, this);
      }, o.prototype.makePanelOpts = function(i, t3) {
        return Fi(this._targetInfoList, function(c3) {
          var p3 = c3.getPanelRect();
          return { panelId: c3.panelId, defaultBrushType: t3 ? t3(c3) : null, clipPath: l9e(p3), isTargetByCursor: c9e(p3, i, c3.coordSysModel), getLinearBrushOtherExtent: u9e(p3) };
        });
      }, o.prototype.controlSeries = function(i, t3, c3) {
        var p3 = this.findTargetInfo(i, c3);
        return p3 === true || p3 && rl(p3.coordSyses, t3.coordinateSystem) >= 0;
      }, o.prototype.findTargetInfo = function(i, t3) {
        for (var c3 = this._targetInfoList, p3 = sVe(t3, i), g3 = 0; g3 < c3.length; g3++) {
          var b3 = c3[g3], w3 = i.panelId;
          if (w3) {
            if (b3.panelId === w3)
              return b3;
          } else
            for (var M = 0; M < lVe.length; M++)
              if (lVe[M](p3, b3))
                return b3;
        }
        return true;
      }, o;
    }();
    function Bme(o) {
      return o[0] > o[1] && o.reverse(), o;
    }
    function sVe(o, i) {
      return VP(o, i, { includeMainTypes: JDt });
    }
    var e5t = { grid: function(o, i) {
      var t3 = o.xAxisModels, c3 = o.yAxisModels, p3 = o.gridModels, g3 = Eo(), b3 = {}, w3 = {};
      !t3 && !c3 && !p3 || (yt(t3, function(M) {
        var I = M.axis.grid.model;
        g3.set(I.id, I), b3[I.id] = true;
      }), yt(c3, function(M) {
        var I = M.axis.grid.model;
        g3.set(I.id, I), w3[I.id] = true;
      }), yt(p3, function(M) {
        g3.set(M.id, M), b3[M.id] = true, w3[M.id] = true;
      }), g3.each(function(M) {
        var I = M.coordinateSystem, k3 = [];
        yt(I.getCartesians(), function(L, F) {
          (rl(t3, L.getAxis("x").model) >= 0 || rl(c3, L.getAxis("y").model) >= 0) && k3.push(L);
        }), i.push({ panelId: "grid--" + M.id, gridModel: M, coordSysModel: M, coordSys: k3[0], coordSyses: k3, getPanelRect: uVe.grid, xAxisDeclared: b3[M.id], yAxisDeclared: w3[M.id] });
      }));
    }, geo: function(o, i) {
      yt(o.geoModels, function(t3) {
        var c3 = t3.coordinateSystem;
        i.push({ panelId: "geo--" + t3.id, geoModel: t3, coordSysModel: t3, coordSys: c3, coordSyses: [c3], getPanelRect: uVe.geo });
      });
    } }, lVe = [function(o, i) {
      var t3 = o.xAxisModel, c3 = o.yAxisModel, p3 = o.gridModel;
      return !p3 && t3 && (p3 = t3.axis.grid.model), !p3 && c3 && (p3 = c3.axis.grid.model), p3 && p3 === i.gridModel;
    }, function(o, i) {
      var t3 = o.geoModel;
      return t3 && t3 === i.geoModel;
    }], uVe = { grid: function() {
      return this.coordSys.master.getRect().clone();
    }, geo: function() {
      var o = this.coordSys, i = o.getBoundingRect().clone();
      return i.applyTransform(Ls(o)), i;
    } }, zme = { lineX: As(cVe, 0), lineY: As(cVe, 1), rect: function(o, i, t3, c3) {
      var p3 = o ? i.pointToData([t3[0][0], t3[1][0]], c3) : i.dataToPoint([t3[0][0], t3[1][0]], c3), g3 = o ? i.pointToData([t3[0][1], t3[1][1]], c3) : i.dataToPoint([t3[0][1], t3[1][1]], c3), b3 = [Bme([p3[0], g3[0]]), Bme([p3[1], g3[1]])];
      return { values: b3, xyMinMax: b3 };
    }, polygon: function(o, i, t3, c3) {
      var p3 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], g3 = Fi(t3, function(b3) {
        var w3 = o ? i.pointToData(b3, c3) : i.dataToPoint(b3, c3);
        return p3[0][0] = Math.min(p3[0][0], w3[0]), p3[1][0] = Math.min(p3[1][0], w3[1]), p3[0][1] = Math.max(p3[0][1], w3[0]), p3[1][1] = Math.max(p3[1][1], w3[1]), w3;
      });
      return { values: g3, xyMinMax: p3 };
    } };
    function cVe(o, i, t3, c3) {
      var p3 = t3.getAxis(["x", "y"][o]), g3 = Bme(Fi([0, 1], function(w3) {
        return i ? p3.coordToData(p3.toLocalCoord(c3[w3]), true) : p3.toGlobalCoord(p3.dataToCoord(c3[w3]));
      })), b3 = [];
      return b3[o] = g3, b3[1 - o] = [NaN, NaN], { values: g3, xyMinMax: b3 };
    }
    var fVe = { lineX: As(hVe, 0), lineY: As(hVe, 1), rect: function(o, i, t3) {
      return [[o[0][0] - t3[0] * i[0][0], o[0][1] - t3[0] * i[0][1]], [o[1][0] - t3[1] * i[1][0], o[1][1] - t3[1] * i[1][1]]];
    }, polygon: function(o, i, t3) {
      return Fi(o, function(c3, p3) {
        return [c3[0] - t3[0] * i[p3][0], c3[1] - t3[1] * i[p3][1]];
      });
    } };
    function hVe(o, i, t3, c3) {
      return [i[0] - c3[o] * t3[0], i[1] - c3[o] * t3[1]];
    }
    function t5t(o, i) {
      var t3 = pVe(o), c3 = pVe(i), p3 = [t3[0] / c3[0], t3[1] / c3[1]];
      return isNaN(p3[0]) && (p3[0] = 1), isNaN(p3[1]) && (p3[1] = 1), p3;
    }
    function pVe(o) {
      return o ? [o[0][1] - o[0][0], o[1][1] - o[1][0]] : [NaN, NaN];
    }
    var jme = QDt, Gme = yt, n5t = Cde("toolbox-dataZoom_"), r5t = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.render = function(t3, c3, p3, g3) {
        this._brushController || (this._brushController = new Zye(p3.getZr()), this._brushController.on("brush", Qa(this._onBrush, this)).mount()), o5t(t3, c3, this, g3, p3), a5t(t3, c3);
      }, i.prototype.onclick = function(t3, c3, p3) {
        i5t[p3].call(this);
      }, i.prototype.remove = function(t3, c3) {
        this._brushController && this._brushController.unmount();
      }, i.prototype.dispose = function(t3, c3) {
        this._brushController && this._brushController.dispose();
      }, i.prototype._onBrush = function(t3) {
        var c3 = t3.areas;
        if (!t3.isEnd || !c3.length)
          return;
        var p3 = {}, g3 = this.ecModel;
        this._brushController.updateCovers([]);
        var b3 = new jme(Hme(this.model), g3, { include: ["grid"] });
        b3.matchOutputRanges(c3, g3, function(I, k3, L) {
          if (L.type === "cartesian2d") {
            var F = I.brushType;
            F === "rect" ? (w3("x", L, k3[0]), w3("y", L, k3[1])) : w3({ lineX: "x", lineY: "y" }[F], L, k3);
          }
        }), qDt(g3, p3), this._dispatchZoomAction(p3);
        function w3(I, k3, L) {
          var F = k3.getAxis(I), B = F.model, G = M(I, B, g3), J = G.findRepresentativeAxisProxy(B).getMinMaxSpan();
          (J.minValueSpan != null || J.maxValueSpan != null) && (L = ML(0, L.slice(), F.scale.getExtent(), 0, J.minValueSpan, J.maxValueSpan)), G && (p3[G.id] = { dataZoomId: G.id, startValue: L[0], endValue: L[1] });
        }
        function M(I, k3, L) {
          var F;
          return L.eachComponent({ mainType: "dataZoom", subType: "select" }, function(B) {
            var G = B.getAxisModel(I, k3.componentIndex);
            G && (F = B);
          }), F;
        }
      }, i.prototype._dispatchZoomAction = function(t3) {
        var c3 = [];
        Gme(t3, function(p3, g3) {
          c3.push(Jo(p3));
        }), c3.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: c3 });
      }, i.getDefaultOption = function(t3) {
        var c3 = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: t3.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
        return c3;
      }, i;
    }(Bw), i5t = { zoom: function() {
      var o = !this._isZoomActive;
      this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: o });
    }, back: function() {
      this._dispatchZoomAction($Dt(this.ecModel));
    } };
    function Hme(o) {
      var i = { xAxisIndex: o.get("xAxisIndex", true), yAxisIndex: o.get("yAxisIndex", true), xAxisId: o.get("xAxisId", true), yAxisId: o.get("yAxisId", true) };
      return i.xAxisIndex == null && i.xAxisId == null && (i.xAxisIndex = "all"), i.yAxisIndex == null && i.yAxisId == null && (i.yAxisIndex = "all"), i;
    }
    function a5t(o, i) {
      o.setIconStatus("back", YDt(i) > 1 ? "emphasis" : "normal");
    }
    function o5t(o, i, t3, c3, p3) {
      var g3 = t3._isZoomActive;
      c3 && c3.type === "takeGlobalCursor" && (g3 = c3.key === "dataZoomSelect" ? c3.dataZoomSelectActive : false), t3._isZoomActive = g3, o.setIconStatus("zoom", g3 ? "emphasis" : "normal");
      var b3 = new jme(Hme(o), i, { include: ["grid"] }), w3 = b3.makePanelOpts(p3, function(M) {
        return M.xAxisDeclared && !M.yAxisDeclared ? "lineX" : !M.xAxisDeclared && M.yAxisDeclared ? "lineY" : "rect";
      });
      t3._brushController.setPanels(w3).enableBrush(g3 && w3.length ? { brushType: "auto", brushStyle: o.getModel("brushStyle").getItemStyle() } : false);
    }
    i0t("dataZoom", function(o) {
      var i = o.getComponent("toolbox", 0), t3 = ["feature", "dataZoom"];
      if (!i || i.get(t3) == null)
        return;
      var c3 = i.getModel(t3), p3 = [], g3 = Hme(c3), b3 = VP(o, g3);
      Gme(b3.xAxisModels, function(M) {
        return w3(M, "xAxis", "xAxisIndex");
      }), Gme(b3.yAxisModels, function(M) {
        return w3(M, "yAxis", "yAxisIndex");
      });
      function w3(M, I, k3) {
        var L = M.componentIndex, F = { type: "select", $fromToolbox: true, filterMode: c3.get("filterMode", true) || "filter", id: n5t + I + L };
        F[k3] = L, p3.push(F);
      }
      return p3;
    });
    var s5t = r5t;
    function l5t(o) {
      o.registerComponentModel(MDt), o.registerComponentView(EDt), $8("saveAsImage", kDt), $8("magicType", LDt), $8("dataView", UDt), $8("dataZoom", s5t), $8("restore", ZDt), Tl(SDt);
    }
    var u5t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "tooltip", i.dependencies = ["axisPointer"], i.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, i;
    }(nc), c5t = u5t;
    function dVe(o) {
      var i = o.get("confine");
      return i != null ? !!i : o.get("renderMode") === "richText";
    }
    function vVe(o) {
      if (yo.domSupported) {
        for (var i = document.documentElement.style, t3 = 0, c3 = o.length; t3 < c3; t3++)
          if (o[t3] in i)
            return o[t3];
      }
    }
    var gVe = vVe(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), f5t = vVe(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
    function yVe(o, i) {
      if (!o)
        return i;
      i = dLe(i, true);
      var t3 = o.indexOf(i);
      return o = t3 === -1 ? i : "-" + o.slice(0, t3) + "-" + i, o.toLowerCase();
    }
    function h5t(o, i) {
      var t3 = o.currentStyle || document.defaultView && document.defaultView.getComputedStyle(o);
      return t3 ? i ? t3[i] : t3 : null;
    }
    var p5t = yVe(f5t, "transition"), Wme = yVe(gVe, "transform"), d5t = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (yo.transform3dSupported ? "will-change:transform;" : "");
    function v5t(o) {
      return o = o === "left" ? "right" : o === "right" ? "left" : o === "top" ? "bottom" : "top", o;
    }
    function g5t(o, i, t3) {
      if (!Ha(t3) || t3 === "inside")
        return "";
      var c3 = o.get("backgroundColor"), p3 = o.get("borderWidth");
      i = nL(i);
      var g3 = v5t(t3), b3 = Math.max(Math.round(p3) * 1.5, 6), w3 = "", M = Wme + ":", I;
      rl(["left", "right"], g3) > -1 ? (w3 += "top:50%", M += "translateY(-50%) rotate(" + (I = g3 === "left" ? -225 : -45) + "deg)") : (w3 += "left:50%", M += "translateX(-50%) rotate(" + (I = g3 === "top" ? 225 : 45) + "deg)");
      var k3 = I * Math.PI / 180, L = b3 + p3, F = L * Math.abs(Math.cos(k3)) + L * Math.abs(Math.sin(k3)), B = Math.round(((F - Math.SQRT2 * p3) / 2 + Math.SQRT2 * p3 - (F - L) / 2) * 100) / 100;
      w3 += ";" + g3 + ":-" + B + "px";
      var G = i + " solid " + p3 + "px;", J = ["position:absolute;width:" + b3 + "px;height:" + b3 + "px;", w3 + ";" + M + ";", "border-bottom:" + G, "border-right:" + G, "background-color:" + c3 + ";"];
      return '<div style="' + J.join("") + '"></div>';
    }
    function y5t(o, i) {
      var t3 = "cubic-bezier(0.23,1,0.32,1)", c3 = " " + o / 2 + "s " + t3, p3 = "opacity" + c3 + ",visibility" + c3;
      return i || (c3 = " " + o + "s " + t3, p3 += yo.transformSupported ? "," + Wme + c3 : ",left" + c3 + ",top" + c3), p5t + ":" + p3;
    }
    function mVe(o, i, t3) {
      var c3 = o.toFixed(0) + "px", p3 = i.toFixed(0) + "px";
      if (!yo.transformSupported)
        return t3 ? "top:" + p3 + ";left:" + c3 + ";" : [["top", p3], ["left", c3]];
      var g3 = yo.transform3dSupported, b3 = "translate" + (g3 ? "3d" : "") + "(" + c3 + "," + p3 + (g3 ? ",0" : "") + ")";
      return t3 ? "top:0;left:0;" + Wme + ":" + b3 + ";" : [["top", 0], ["left", 0], [gVe, b3]];
    }
    function m5t(o) {
      var i = [], t3 = o.get("fontSize"), c3 = o.getTextColor();
      c3 && i.push("color:" + c3), i.push("font:" + o.getFont()), t3 && i.push("line-height:" + Math.round(t3 * 3 / 2) + "px");
      var p3 = o.get("textShadowColor"), g3 = o.get("textShadowBlur") || 0, b3 = o.get("textShadowOffsetX") || 0, w3 = o.get("textShadowOffsetY") || 0;
      return p3 && g3 && i.push("text-shadow:" + b3 + "px " + w3 + "px " + g3 + "px " + p3), yt(["decoration", "align"], function(M) {
        var I = o.get(M);
        I && i.push("text-" + M + ":" + I);
      }), i.join(";");
    }
    function b5t(o, i, t3) {
      var c3 = [], p3 = o.get("transitionDuration"), g3 = o.get("backgroundColor"), b3 = o.get("shadowBlur"), w3 = o.get("shadowColor"), M = o.get("shadowOffsetX"), I = o.get("shadowOffsetY"), k3 = o.getModel("textStyle"), L = xRe(o, "html"), F = M + "px " + I + "px " + b3 + "px " + w3;
      return c3.push("box-shadow:" + F), i && p3 && c3.push(y5t(p3, t3)), g3 && c3.push("background-color:" + g3), yt(["width", "color", "radius"], function(B) {
        var G = "border-" + B, J = dLe(G), Q = o.get(J);
        Q != null && c3.push(G + ":" + Q + (B === "color" ? "" : "px"));
      }), c3.push(m5t(k3)), L != null && c3.push("padding:" + y8(L).join("px ") + "px"), c3.join(";") + ";";
    }
    function bVe(o, i, t3, c3, p3) {
      var g3 = i && i.painter;
      if (t3) {
        var b3 = g3 && g3.getViewportRoot();
        b3 && iQ(o, b3, document.body, c3, p3);
      } else {
        o[0] = c3, o[1] = p3;
        var w3 = g3 && g3.getViewportRootOffset();
        w3 && (o[0] += w3.offsetLeft, o[1] += w3.offsetTop);
      }
      o[2] = o[0] / i.getWidth(), o[3] = o[1] / i.getHeight();
    }
    var _5t = function() {
      function o(i, t3, c3) {
        if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, yo.wxa)
          return null;
        var p3 = document.createElement("div");
        p3.domBelongToZr = true, this.el = p3;
        var g3 = this._zr = t3.getZr(), b3 = this._appendToBody = c3 && c3.appendToBody;
        bVe(this._styleCoord, g3, b3, t3.getWidth() / 2, t3.getHeight() / 2), b3 ? document.body.appendChild(p3) : i.appendChild(p3), this._container = i;
        var w3 = this;
        p3.onmouseenter = function() {
          w3._enterable && (clearTimeout(w3._hideTimeout), w3._show = true), w3._inContent = true;
        }, p3.onmousemove = function(M) {
          if (M = M || window.event, !w3._enterable) {
            var I = g3.handler, k3 = g3.painter.getViewportRoot();
            M1(k3, M, true), I.dispatch("mousemove", M);
          }
        }, p3.onmouseleave = function() {
          w3._inContent = false, w3._enterable && w3._show && w3.hideLater(w3._hideDelay);
        };
      }
      return o.prototype.update = function(i) {
        var t3 = this._container, c3 = h5t(t3, "position"), p3 = t3.style;
        p3.position !== "absolute" && c3 !== "absolute" && (p3.position = "relative");
        var g3 = i.get("alwaysShowContent");
        g3 && this._moveIfResized(), this.el.className = i.get("className") || "";
      }, o.prototype.show = function(i, t3) {
        clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
        var c3 = this.el, p3 = c3.style, g3 = this._styleCoord;
        c3.innerHTML ? p3.cssText = d5t + b5t(i, !this._firstShow, this._longHide) + mVe(g3[0], g3[1], true) + ("border-color:" + nL(t3) + ";") + (i.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : p3.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
      }, o.prototype.setContent = function(i, t3, c3, p3, g3) {
        var b3 = this.el;
        if (i == null) {
          b3.innerHTML = "";
          return;
        }
        var w3 = "";
        if (Ha(g3) && c3.get("trigger") === "item" && !dVe(c3) && (w3 = g5t(c3, p3, g3)), Ha(i))
          b3.innerHTML = i + w3;
        else if (i) {
          b3.innerHTML = "", Ei(i) || (i = [i]);
          for (var M = 0; M < i.length; M++)
            hP(i[M]) && i[M].parentNode !== b3 && b3.appendChild(i[M]);
          if (w3 && b3.childNodes.length) {
            var I = document.createElement("div");
            I.innerHTML = w3, b3.appendChild(I);
          }
        }
      }, o.prototype.setEnterable = function(i) {
        this._enterable = i;
      }, o.prototype.getSize = function() {
        var i = this.el;
        return [i.offsetWidth, i.offsetHeight];
      }, o.prototype.moveTo = function(i, t3) {
        var c3 = this._styleCoord;
        if (bVe(c3, this._zr, this._appendToBody, i, t3), c3[0] != null && c3[1] != null) {
          var p3 = this.el.style, g3 = mVe(c3[0], c3[1]);
          yt(g3, function(b3) {
            p3[b3[0]] = b3[1];
          });
        }
      }, o.prototype._moveIfResized = function() {
        var i = this._styleCoord[2], t3 = this._styleCoord[3];
        this.moveTo(i * this._zr.getWidth(), t3 * this._zr.getHeight());
      }, o.prototype.hide = function() {
        var i = this, t3 = this.el.style;
        t3.visibility = "hidden", t3.opacity = "0", yo.transform3dSupported && (t3.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
          return i._longHide = true;
        }, 500);
      }, o.prototype.hideLater = function(i) {
        this._show && !(this._inContent && this._enterable) && (i ? (this._hideDelay = i, this._show = false, this._hideTimeout = setTimeout(Qa(this.hide, this), i)) : this.hide());
      }, o.prototype.isShow = function() {
        return this._show;
      }, o.prototype.dispose = function() {
        this.el.parentNode.removeChild(this.el);
      }, o;
    }(), x5t = _5t, w5t = function() {
      function o(i) {
        this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = i.getZr(), xVe(this._styleCoord, this._zr, i.getWidth() / 2, i.getHeight() / 2);
      }
      return o.prototype.update = function(i) {
        var t3 = i.get("alwaysShowContent");
        t3 && this._moveIfResized();
      }, o.prototype.show = function() {
        this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
      }, o.prototype.setContent = function(i, t3, c3, p3, g3) {
        var b3 = this;
        Ua(i) && Fu(""), this.el && this._zr.remove(this.el);
        var w3 = c3.getModel("textStyle");
        this.el = new Fl({ style: { rich: t3.richTextStyles, text: i, lineHeight: 22, borderWidth: 1, borderColor: p3, textShadowColor: w3.get("textShadowColor"), fill: c3.get(["textStyle", "color"]), padding: xRe(c3, "richText"), verticalAlign: "top", align: "left" }, z: c3.get("z") }), yt(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(I) {
          b3.el.style[I] = c3.get(I);
        }), yt(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(I) {
          b3.el.style[I] = w3.get(I) || 0;
        }), this._zr.add(this.el);
        var M = this;
        this.el.on("mouseover", function() {
          M._enterable && (clearTimeout(M._hideTimeout), M._show = true), M._inContent = true;
        }), this.el.on("mouseout", function() {
          M._enterable && M._show && M.hideLater(M._hideDelay), M._inContent = false;
        });
      }, o.prototype.setEnterable = function(i) {
        this._enterable = i;
      }, o.prototype.getSize = function() {
        var i = this.el, t3 = this.el.getBoundingRect(), c3 = _Ve(i.style);
        return [t3.width + c3.left + c3.right, t3.height + c3.top + c3.bottom];
      }, o.prototype.moveTo = function(i, t3) {
        var c3 = this.el;
        if (c3) {
          var p3 = this._styleCoord;
          xVe(p3, this._zr, i, t3), i = p3[0], t3 = p3[1];
          var g3 = c3.style, b3 = xk(g3.borderWidth || 0), w3 = _Ve(g3);
          c3.x = i + b3 + w3.left, c3.y = t3 + b3 + w3.top, c3.markRedraw();
        }
      }, o.prototype._moveIfResized = function() {
        var i = this._styleCoord[2], t3 = this._styleCoord[3];
        this.moveTo(i * this._zr.getWidth(), t3 * this._zr.getHeight());
      }, o.prototype.hide = function() {
        this.el && this.el.hide(), this._show = false;
      }, o.prototype.hideLater = function(i) {
        this._show && !(this._inContent && this._enterable) && (i ? (this._hideDelay = i, this._show = false, this._hideTimeout = setTimeout(Qa(this.hide, this), i)) : this.hide());
      }, o.prototype.isShow = function() {
        return this._show;
      }, o.prototype.dispose = function() {
        this._zr.remove(this.el);
      }, o;
    }();
    function xk(o) {
      return Math.max(0, o);
    }
    function _Ve(o) {
      var i = xk(o.shadowBlur || 0), t3 = xk(o.shadowOffsetX || 0), c3 = xk(o.shadowOffsetY || 0);
      return { left: xk(i - t3), right: xk(i + t3), top: xk(i - c3), bottom: xk(i + c3) };
    }
    function xVe(o, i, t3, c3) {
      o[0] = t3, o[1] = c3, o[2] = o[0] / i.getWidth(), o[3] = o[1] / i.getHeight();
    }
    var S5t = w5t, C5t = new bu({ shape: { x: -1, y: -1, width: 2, height: 2 } }), M5t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3) {
        if (!(yo.node || !c3.getDom())) {
          var p3 = t3.getComponent("tooltip"), g3 = this._renderMode = AG(p3.get("renderMode"));
          this._tooltipContent = g3 === "richText" ? new S5t(c3) : new x5t(c3.getDom(), c3, { appendToBody: p3.get("appendToBody", true) });
        }
      }, i.prototype.render = function(t3, c3, p3) {
        if (!(yo.node || !p3.getDom())) {
          this.group.removeAll(), this._tooltipModel = t3, this._ecModel = c3, this._api = p3, this._alwaysShowContent = t3.get("alwaysShowContent");
          var g3 = this._tooltipContent;
          g3.update(t3), g3.setEnterable(t3.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && t3.get("transitionDuration") ? M8(this, "_updatePosition", 50, "fixRate") : NH(this, "_updatePosition");
        }
      }, i.prototype._initGlobalListener = function() {
        var t3 = this._tooltipModel, c3 = t3.get("triggerOn");
        T7e("itemTooltip", this._api, Qa(function(p3, g3, b3) {
          c3 !== "none" && (c3.indexOf(p3) >= 0 ? this._tryShow(g3, b3) : p3 === "leave" && this._hide(b3));
        }, this));
      }, i.prototype._keepShow = function() {
        var t3 = this._tooltipModel, c3 = this._ecModel, p3 = this._api;
        if (this._lastX != null && this._lastY != null && t3.get("triggerOn") !== "none") {
          var g3 = this;
          clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
            !p3.isDisposed() && g3.manuallyShowTip(t3, c3, p3, { x: g3._lastX, y: g3._lastY, dataByCoordSys: g3._lastDataByCoordSys });
          });
        }
      }, i.prototype.manuallyShowTip = function(t3, c3, p3, g3) {
        if (!(g3.from === this.uid || yo.node || !p3.getDom())) {
          var b3 = wVe(g3, p3);
          this._ticket = "";
          var w3 = g3.dataByCoordSys, M = E5t(g3, c3, p3);
          if (M) {
            var I = M.el.getBoundingRect().clone();
            I.applyTransform(M.el.transform), this._tryShow({ offsetX: I.x + I.width / 2, offsetY: I.y + I.height / 2, target: M.el, position: g3.position, positionDefault: "bottom" }, b3);
          } else if (g3.tooltip && g3.x != null && g3.y != null) {
            var k3 = C5t;
            k3.x = g3.x, k3.y = g3.y, k3.update(), La(k3).tooltipConfig = { name: null, option: g3.tooltip }, this._tryShow({ offsetX: g3.x, offsetY: g3.y, target: k3 }, b3);
          } else if (w3)
            this._tryShow({ offsetX: g3.x, offsetY: g3.y, position: g3.position, dataByCoordSys: w3, tooltipOption: g3.tooltipOption }, b3);
          else if (g3.seriesIndex != null) {
            if (this._manuallyAxisShowTip(t3, c3, p3, g3))
              return;
            var L = I7e(g3, c3), F = L.point[0], B = L.point[1];
            F != null && B != null && this._tryShow({ offsetX: F, offsetY: B, target: L.el, position: g3.position, positionDefault: "bottom" }, b3);
          } else
            g3.x != null && g3.y != null && (p3.dispatchAction({ type: "updateAxisPointer", x: g3.x, y: g3.y }), this._tryShow({ offsetX: g3.x, offsetY: g3.y, position: g3.position, target: p3.getZr().findHover(g3.x, g3.y).target }, b3));
        }
      }, i.prototype.manuallyHideTip = function(t3, c3, p3, g3) {
        var b3 = this._tooltipContent;
        !this._alwaysShowContent && this._tooltipModel && b3.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, g3.from !== this.uid && this._hide(wVe(g3, p3));
      }, i.prototype._manuallyAxisShowTip = function(t3, c3, p3, g3) {
        var b3 = g3.seriesIndex, w3 = g3.dataIndex, M = c3.getComponent("axisPointer").coordSysAxesInfo;
        if (!(b3 == null || w3 == null || M == null)) {
          var I = c3.getSeriesByIndex(b3);
          if (I) {
            var k3 = I.getData(), L = OW([k3.getItemModel(w3), I, (I.coordinateSystem || {}).model], this._tooltipModel);
            if (L.get("trigger") === "axis")
              return p3.dispatchAction({ type: "updateAxisPointer", seriesIndex: b3, dataIndex: w3, position: g3.position }), true;
          }
        }
      }, i.prototype._tryShow = function(t3, c3) {
        var p3 = t3.target, g3 = this._tooltipModel;
        if (g3) {
          this._lastX = t3.offsetX, this._lastY = t3.offsetY;
          var b3 = t3.dataByCoordSys;
          if (b3 && b3.length)
            this._showAxisTooltip(b3, t3);
          else if (p3) {
            this._lastDataByCoordSys = null;
            var w3, M;
            A8(p3, function(I) {
              if (La(I).dataIndex != null)
                return w3 = I, true;
              if (La(I).tooltipConfig != null)
                return M = I, true;
            }, true), w3 ? this._showSeriesItemTooltip(t3, w3, c3) : M ? this._showComponentItemTooltip(t3, M, c3) : this._hide(c3);
          } else
            this._lastDataByCoordSys = null, this._hide(c3);
        }
      }, i.prototype._showOrMove = function(t3, c3) {
        var p3 = t3.get("showDelay");
        c3 = Qa(c3, this), clearTimeout(this._showTimout), p3 > 0 ? this._showTimout = setTimeout(c3, p3) : c3();
      }, i.prototype._showAxisTooltip = function(t3, c3) {
        var p3 = this._ecModel, g3 = this._tooltipModel, b3 = [c3.offsetX, c3.offsetY], w3 = OW([c3.tooltipOption], g3), M = this._renderMode, I = [], k3 = Cg("section", { blocks: [], noHeader: true }), L = [], F = new Oge();
        yt(t3, function(he) {
          yt(he.dataByAxis, function(be) {
            var de = p3.getComponent(be.axisDim + "Axis", be.axisIndex), Fe = be.value;
            if (!(!de || Fe == null)) {
              var Pe = _7e(Fe, de.axis, p3, be.seriesDataIndices, be.valueLabelOpt), ze = Cg("section", { header: Pe, noHeader: !S1(Pe), sortBlocks: true, blocks: [] });
              k3.blocks.push(ze), yt(be.seriesDataIndices, function($e) {
                var Ke = p3.getSeriesByIndex($e.seriesIndex), nt = $e.dataIndexInside, lt2 = Ke.getDataParams(nt);
                if (!(lt2.dataIndex < 0)) {
                  lt2.axisDim = be.axisDim, lt2.axisIndex = be.axisIndex, lt2.axisType = be.axisType, lt2.axisId = be.axisId, lt2.axisValue = v0e(de.axis, { value: Fe }), lt2.axisValueLabel = Pe, lt2.marker = F.makeTooltipMarker("item", nL(lt2.color), M);
                  var bt = tRe(Ke.formatTooltip(nt, true, null)), vt = bt.frag;
                  if (vt) {
                    var jt = OW([Ke], g3).get("valueFormatter");
                    ze.blocks.push(jt ? ti({ valueFormatter: jt }, vt) : vt);
                  }
                  bt.text && L.push(bt.text), I.push(lt2);
                }
              });
            }
          });
        }), k3.blocks.reverse(), L.reverse();
        var B = c3.position, G = w3.get("order"), J = mRe(k3, F, M, G, p3.get("useUTC"), w3.get("textStyle"));
        J && L.unshift(J);
        var Q = M === "richText" ? `

` : "<br/>", se = L.join(Q);
        this._showOrMove(w3, function() {
          this._updateContentNotChangedOnAxis(t3, I) ? this._updatePosition(w3, B, b3[0], b3[1], this._tooltipContent, I) : this._showTooltipContent(w3, se, I, Math.random() + "", b3[0], b3[1], B, null, F);
        });
      }, i.prototype._showSeriesItemTooltip = function(t3, c3, p3) {
        var g3 = this._ecModel, b3 = La(c3), w3 = b3.seriesIndex, M = g3.getSeriesByIndex(w3), I = b3.dataModel || M, k3 = b3.dataIndex, L = b3.dataType, F = I.getData(L), B = this._renderMode, G = t3.positionDefault, J = OW([F.getItemModel(k3), I, M && (M.coordinateSystem || {}).model], this._tooltipModel, G ? { position: G } : null), Q = J.get("trigger");
        if (!(Q != null && Q !== "item")) {
          var se = I.getDataParams(k3, L), he = new Oge();
          se.marker = he.makeTooltipMarker("item", nL(se.color), B);
          var be = tRe(I.formatTooltip(k3, false, L)), de = J.get("order"), Fe = J.get("valueFormatter"), Pe = be.frag, ze = Pe ? mRe(Fe ? ti({ valueFormatter: Fe }, Pe) : Pe, he, B, de, g3.get("useUTC"), J.get("textStyle")) : be.text, $e = "item_" + I.name + "_" + k3;
          this._showOrMove(J, function() {
            this._showTooltipContent(J, ze, se, $e, t3.offsetX, t3.offsetY, t3.position, t3.target, he);
          }), p3({ type: "showTip", dataIndexInside: k3, dataIndex: F.getRawIndex(k3), seriesIndex: w3, from: this.uid });
        }
      }, i.prototype._showComponentItemTooltip = function(t3, c3, p3) {
        var g3 = La(c3), b3 = g3.tooltipConfig, w3 = b3.option || {};
        if (Ha(w3)) {
          var M = w3;
          w3 = { content: M, formatter: M };
        }
        var I = [w3], k3 = this._ecModel.getComponent(g3.componentMainType, g3.componentIndex);
        k3 && I.push(k3), I.push({ formatter: w3.content });
        var L = t3.positionDefault, F = OW(I, this._tooltipModel, L ? { position: L } : null), B = F.get("content"), G = Math.random() + "", J = new Oge();
        this._showOrMove(F, function() {
          var Q = Jo(F.get("formatterParams") || {});
          this._showTooltipContent(F, B, Q, G, t3.offsetX, t3.offsetY, t3.position, c3, J);
        }), p3({ type: "showTip", from: this.uid });
      }, i.prototype._showTooltipContent = function(t3, c3, p3, g3, b3, w3, M, I, k3) {
        if (this._ticket = "", !(!t3.get("showContent") || !t3.get("show"))) {
          var L = this._tooltipContent;
          L.setEnterable(t3.get("enterable"));
          var F = t3.get("formatter");
          M = M || t3.get("position");
          var B = c3, G = this._getNearestPoint([b3, w3], p3, t3.get("trigger"), t3.get("borderColor")), J = G.color;
          if (F)
            if (Ha(F)) {
              var Q = t3.ecModel.get("useUTC"), se = Ei(p3) ? p3[0] : p3, he = se && se.axisType && se.axisType.indexOf("time") >= 0;
              B = F, he && (B = lte(se.axisValue, B, Q)), B = gLe(B, p3, true);
            } else if (Vo(F)) {
              var be = Qa(function(de, Fe) {
                de === this._ticket && (L.setContent(Fe, k3, t3, J, M), this._updatePosition(t3, M, b3, w3, L, p3, I));
              }, this);
              this._ticket = g3, B = F(p3, g3, be);
            } else
              B = F;
          L.setContent(B, k3, t3, J, M), L.show(t3, J), this._updatePosition(t3, M, b3, w3, L, p3, I);
        }
      }, i.prototype._getNearestPoint = function(t3, c3, p3, g3) {
        if (p3 === "axis" || Ei(c3))
          return { color: g3 || (this._renderMode === "html" ? "#fff" : "none") };
        if (!Ei(c3))
          return { color: g3 || c3.color || c3.borderColor };
      }, i.prototype._updatePosition = function(t3, c3, p3, g3, b3, w3, M) {
        var I = this._api.getWidth(), k3 = this._api.getHeight();
        c3 = c3 || t3.get("position");
        var L = b3.getSize(), F = t3.get("align"), B = t3.get("verticalAlign"), G = M && M.getBoundingRect().clone();
        if (M && G.applyTransform(M.transform), Vo(c3) && (c3 = c3([p3, g3], w3, b3.el, G, { viewSize: [I, k3], contentSize: L.slice() })), Ei(c3))
          p3 = Da(c3[0], I), g3 = Da(c3[1], k3);
        else if (Ua(c3)) {
          var J = c3;
          J.width = L[0], J.height = L[1];
          var Q = Wv(J, { width: I, height: k3 });
          p3 = Q.x, g3 = Q.y, F = null, B = null;
        } else if (Ha(c3) && M) {
          var se = I5t(c3, G, L, t3.get("borderWidth"));
          p3 = se[0], g3 = se[1];
        } else {
          var se = T5t(p3, g3, b3, I, k3, F ? null : 20, B ? null : 20);
          p3 = se[0], g3 = se[1];
        }
        if (F && (p3 -= SVe(F) ? L[0] / 2 : F === "right" ? L[0] : 0), B && (g3 -= SVe(B) ? L[1] / 2 : B === "bottom" ? L[1] : 0), dVe(t3)) {
          var se = A5t(p3, g3, b3, I, k3);
          p3 = se[0], g3 = se[1];
        }
        b3.moveTo(p3, g3);
      }, i.prototype._updateContentNotChangedOnAxis = function(t3, c3) {
        var p3 = this._lastDataByCoordSys, g3 = this._cbParamsList, b3 = !!p3 && p3.length === t3.length;
        return b3 && yt(p3, function(w3, M) {
          var I = w3.dataByAxis || [], k3 = t3[M] || {}, L = k3.dataByAxis || [];
          b3 = b3 && I.length === L.length, b3 && yt(I, function(F, B) {
            var G = L[B] || {}, J = F.seriesDataIndices || [], Q = G.seriesDataIndices || [];
            b3 = b3 && F.value === G.value && F.axisType === G.axisType && F.axisId === G.axisId && J.length === Q.length, b3 && yt(J, function(se, he) {
              var be = Q[he];
              b3 = b3 && se.seriesIndex === be.seriesIndex && se.dataIndex === be.dataIndex;
            }), g3 && yt(F.seriesDataIndices, function(se) {
              var he = se.seriesIndex, be = c3[he], de = g3[he];
              be && de && de.data !== be.data && (b3 = false);
            });
          });
        }), this._lastDataByCoordSys = t3, this._cbParamsList = c3, !!b3;
      }, i.prototype._hide = function(t3) {
        this._lastDataByCoordSys = null, t3({ type: "hideTip", from: this.uid });
      }, i.prototype.dispose = function(t3, c3) {
        yo.node || !c3.getDom() || (NH(this, "_updatePosition"), this._tooltipContent.dispose(), Mme("itemTooltip", c3));
      }, i.type = "tooltip", i;
    }(ed);
    function OW(o, i, t3) {
      var c3 = i.ecModel, p3;
      t3 ? (p3 = new gh(t3, c3, c3), p3 = new gh(i.option, p3, c3)) : p3 = i;
      for (var g3 = o.length - 1; g3 >= 0; g3--) {
        var b3 = o[g3];
        b3 && (b3 instanceof gh && (b3 = b3.get("tooltip", true)), Ha(b3) && (b3 = { formatter: b3 }), b3 && (p3 = new gh(b3, p3, c3)));
      }
      return p3;
    }
    function wVe(o, i) {
      return o.dispatchAction || Qa(i.dispatchAction, i);
    }
    function T5t(o, i, t3, c3, p3, g3, b3) {
      var w3 = t3.getSize(), M = w3[0], I = w3[1];
      return g3 != null && (o + M + g3 + 2 > c3 ? o -= M + g3 : o += g3), b3 != null && (i + I + b3 > p3 ? i -= I + b3 : i += b3), [o, i];
    }
    function A5t(o, i, t3, c3, p3) {
      var g3 = t3.getSize(), b3 = g3[0], w3 = g3[1];
      return o = Math.min(o + b3, c3) - b3, i = Math.min(i + w3, p3) - w3, o = Math.max(o, 0), i = Math.max(i, 0), [o, i];
    }
    function I5t(o, i, t3, c3) {
      var p3 = t3[0], g3 = t3[1], b3 = Math.ceil(Math.SQRT2 * c3) + 8, w3 = 0, M = 0, I = i.width, k3 = i.height;
      switch (o) {
        case "inside":
          w3 = i.x + I / 2 - p3 / 2, M = i.y + k3 / 2 - g3 / 2;
          break;
        case "top":
          w3 = i.x + I / 2 - p3 / 2, M = i.y - g3 - b3;
          break;
        case "bottom":
          w3 = i.x + I / 2 - p3 / 2, M = i.y + k3 + b3;
          break;
        case "left":
          w3 = i.x - p3 - b3, M = i.y + k3 / 2 - g3 / 2;
          break;
        case "right":
          w3 = i.x + I + b3, M = i.y + k3 / 2 - g3 / 2;
      }
      return [w3, M];
    }
    function SVe(o) {
      return o === "center" || o === "middle";
    }
    function E5t(o, i, t3) {
      var c3 = MG(o).queryOptionMap, p3 = c3.keys()[0];
      if (!(!p3 || p3 === "series")) {
        var g3 = q5(i, p3, c3.get(p3), { useDefault: false, enableAll: false, enableNone: false }), b3 = g3.models[0];
        if (b3) {
          var w3 = t3.getViewOfComponentModel(b3), M;
          if (w3.group.traverse(function(I) {
            var k3 = La(I).tooltipConfig;
            if (k3 && k3.name === o.name)
              return M = I, true;
          }), M)
            return { componentMainType: p3, componentIndex: b3.componentIndex, el: M };
        }
      }
    }
    var D5t = M5t;
    function k5t(o) {
      Tl(DW), o.registerComponentModel(c5t), o.registerComponentView(D5t), o.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, uf), o.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, uf);
    }
    var O5t = ["rect", "polygon", "keep", "clear"];
    function P5t(o, i) {
      var t3 = Wc(o ? o.brush : []);
      if (t3.length) {
        var c3 = [];
        yt(t3, function(M) {
          var I = M.hasOwnProperty("toolbox") ? M.toolbox : [];
          I instanceof Array && (c3 = c3.concat(I));
        });
        var p3 = o && o.toolbox;
        Ei(p3) && (p3 = p3[0]), p3 || (p3 = { feature: {} }, o.toolbox = [p3]);
        var g3 = p3.feature || (p3.feature = {}), b3 = g3.brush || (g3.brush = {}), w3 = b3.type || (b3.type = []);
        w3.push.apply(w3, c3), L5t(w3), i && !w3.length && w3.push.apply(w3, O5t);
      }
    }
    function L5t(o) {
      var i = {};
      yt(o, function(t3) {
        i[t3] = 1;
      }), o.length = 0, yt(i, function(t3, c3) {
        o.push(c3);
      });
    }
    var CVe = yt;
    function MVe(o) {
      if (o) {
        for (var i in o)
          if (o.hasOwnProperty(i))
            return true;
      }
    }
    function Ume(o, i, t3) {
      var c3 = {};
      return CVe(i, function(g3) {
        var b3 = c3[g3] = p3();
        CVe(o[g3], function(w3, M) {
          if (wy.isValidType(M)) {
            var I = { type: M, visual: w3 };
            t3 && t3(I, g3), b3[M] = new wy(I), M === "opacity" && (I = Jo(I), I.type = "colorAlpha", b3.__hidden.__alphaForOpacity = new wy(I));
          }
        });
      }), c3;
      function p3() {
        var g3 = function() {
        };
        g3.prototype.__hidden = g3.prototype;
        var b3 = new g3();
        return b3;
      }
    }
    function TVe(o, i, t3) {
      var c3;
      yt(t3, function(p3) {
        i.hasOwnProperty(p3) && MVe(i[p3]) && (c3 = true);
      }), c3 && yt(t3, function(p3) {
        i.hasOwnProperty(p3) && MVe(i[p3]) ? o[p3] = Jo(i[p3]) : delete o[p3];
      });
    }
    function R5t(o, i, t3, c3, p3, g3) {
      var b3 = {};
      yt(o, function(L) {
        var F = wy.prepareVisualTypes(i[L]);
        b3[L] = F;
      });
      var w3;
      function M(L) {
        return Vge(t3, w3, L);
      }
      function I(L, F) {
        HRe(t3, w3, L, F);
      }
      g3 == null ? t3.each(k3) : t3.each([g3], k3);
      function k3(L, F) {
        w3 = g3 == null ? L : F;
        var B = t3.getRawDataItem(w3);
        if (!(B && B.visualMap === false))
          for (var G = c3.call(p3, L), J = i[G], Q = b3[G], se = 0, he = Q.length; se < he; se++) {
            var be = Q[se];
            J[be] && J[be].applyVisual(L, M, I);
          }
      }
    }
    function N5t(o, i, t3, c3) {
      var p3 = {};
      return yt(o, function(g3) {
        var b3 = wy.prepareVisualTypes(i[g3]);
        p3[g3] = b3;
      }), { progress: function(g3, b3) {
        var w3;
        c3 != null && (w3 = b3.getDimensionIndex(c3));
        function M(de) {
          return Vge(b3, k3, de);
        }
        function I(de, Fe) {
          HRe(b3, k3, de, Fe);
        }
        for (var k3, L = b3.getStore(); (k3 = g3.next()) != null; ) {
          var F = b3.getRawDataItem(k3);
          if (!(F && F.visualMap === false))
            for (var B = c3 != null ? L.get(w3, k3) : k3, G = t3(B), J = i[G], Q = p3[G], se = 0, he = Q.length; se < he; se++) {
              var be = Q[se];
              J[be] && J[be].applyVisual(B, M, I);
            }
        }
      } };
    }
    function F5t(o) {
      var i = o.brushType, t3 = { point: function(c3) {
        return AVe[i].point(c3, t3, o);
      }, rect: function(c3) {
        return AVe[i].rect(c3, t3, o);
      } };
      return t3;
    }
    var AVe = { lineX: IVe(0), lineY: IVe(1), rect: { point: function(o, i, t3) {
      return o && t3.boundingRect.contain(o[0], o[1]);
    }, rect: function(o, i, t3) {
      return o && t3.boundingRect.intersect(o);
    } }, polygon: { point: function(o, i, t3) {
      return o && t3.boundingRect.contain(o[0], o[1]) && fL(t3.range, o[0], o[1]);
    }, rect: function(o, i, t3) {
      var c3 = t3.range;
      if (!o || c3.length <= 1)
        return false;
      var p3 = o.x, g3 = o.y, b3 = o.width, w3 = o.height, M = c3[0];
      if (fL(c3, p3, g3) || fL(c3, p3 + b3, g3) || fL(c3, p3, g3 + w3) || fL(c3, p3 + b3, g3 + w3) || Ys.create(o).contain(M[0], M[1]) || _y(p3, g3, p3 + b3, g3, c3) || _y(p3, g3, p3, g3 + w3, c3) || _y(p3 + b3, g3, p3 + b3, g3 + w3, c3) || _y(p3, g3 + w3, p3 + b3, g3 + w3, c3))
        return true;
    } } };
    function IVe(o) {
      var i = ["x", "y"], t3 = ["width", "height"];
      return { point: function(c3, p3, g3) {
        if (c3) {
          var b3 = g3.range, w3 = c3[o];
          return PW(w3, b3);
        }
      }, rect: function(c3, p3, g3) {
        if (c3) {
          var b3 = g3.range, w3 = [c3[i[o]], c3[i[o]] + c3[t3[o]]];
          return w3[1] < w3[0] && w3.reverse(), PW(w3[0], b3) || PW(w3[1], b3) || PW(b3[0], w3) || PW(b3[1], w3);
        }
      } };
    }
    function PW(o, i) {
      return i[0] <= o && o <= i[1];
    }
    var EVe = ["inBrush", "outOfBrush"], qme = "__ecBrushSelect", $me = "__ecInBrushSelectEvent";
    function DVe(o) {
      o.eachComponent({ mainType: "brush" }, function(i) {
        var t3 = i.brushTargetManager = new jme(i.option, o);
        t3.setInputRanges(i.areas, o);
      });
    }
    function V5t(o, i, t3) {
      var c3 = [], p3, g3;
      o.eachComponent({ mainType: "brush" }, function(b3) {
        t3 && t3.type === "takeGlobalCursor" && b3.setBrushOption(t3.key === "brush" ? t3.brushOption : { brushType: false });
      }), DVe(o), o.eachComponent({ mainType: "brush" }, function(b3, w3) {
        var M = { brushId: b3.id, brushIndex: w3, brushName: b3.name, areas: Jo(b3.areas), selected: [] };
        c3.push(M);
        var I = b3.option, k3 = I.brushLink, L = [], F = [], B = [], G = false;
        w3 || (p3 = I.throttleType, g3 = I.throttleDelay);
        var J = Fi(b3.areas, function(Fe) {
          var Pe = G5t[Fe.brushType], ze = Uo({ boundingRect: Pe ? Pe(Fe) : void 0 }, Fe);
          return ze.selectors = F5t(ze), ze;
        }), Q = Ume(b3.option, EVe, function(Fe) {
          Fe.mappingMethod = "fixed";
        });
        Ei(k3) && yt(k3, function(Fe) {
          L[Fe] = 1;
        });
        function se(Fe) {
          return k3 === "all" || !!L[Fe];
        }
        function he(Fe) {
          return !!Fe.length;
        }
        o.eachSeries(function(Fe, Pe) {
          var ze = B[Pe] = [];
          Fe.subType === "parallel" ? be(Fe, Pe) : de(Fe, Pe, ze);
        });
        function be(Fe, Pe) {
          var ze = Fe.coordinateSystem;
          G = G || ze.hasAxisBrushed(), se(Pe) && ze.eachActiveState(Fe.getData(), function($e, Ke) {
            $e === "active" && (F[Ke] = 1);
          });
        }
        function de(Fe, Pe, ze) {
          if (!(!Fe.brushSelector || j5t(b3, Pe)) && (yt(J, function(Ke) {
            b3.brushTargetManager.controlSeries(Ke, Fe, o) && ze.push(Ke), G = G || he(ze);
          }), se(Pe) && he(ze))) {
            var $e = Fe.getData();
            $e.each(function(Ke) {
              kVe(Fe, ze, $e, Ke) && (F[Ke] = 1);
            });
          }
        }
        o.eachSeries(function(Fe, Pe) {
          var ze = { seriesId: Fe.id, seriesIndex: Pe, seriesName: Fe.name, dataIndex: [] };
          M.selected.push(ze);
          var $e = B[Pe], Ke = Fe.getData(), nt = se(Pe) ? function(lt2) {
            return F[lt2] ? (ze.dataIndex.push(Ke.getRawIndex(lt2)), "inBrush") : "outOfBrush";
          } : function(lt2) {
            return kVe(Fe, $e, Ke, lt2) ? (ze.dataIndex.push(Ke.getRawIndex(lt2)), "inBrush") : "outOfBrush";
          };
          (se(Pe) ? G : he($e)) && R5t(EVe, Q, Ke, nt);
        });
      }), B5t(i, p3, g3, c3, t3);
    }
    function B5t(o, i, t3, c3, p3) {
      if (p3) {
        var g3 = o.getZr();
        if (!g3[$me]) {
          g3[qme] || (g3[qme] = z5t);
          var b3 = M8(g3, qme, t3, i);
          b3(o, c3);
        }
      }
    }
    function z5t(o, i) {
      if (!o.isDisposed()) {
        var t3 = o.getZr();
        t3[$me] = true, o.dispatchAction({ type: "brushSelect", batch: i }), t3[$me] = false;
      }
    }
    function kVe(o, i, t3, c3) {
      for (var p3 = 0, g3 = i.length; p3 < g3; p3++) {
        var b3 = i[p3];
        if (o.brushSelector(c3, t3, b3.selectors, b3))
          return true;
      }
    }
    function j5t(o, i) {
      var t3 = o.option.seriesIndex;
      return t3 != null && t3 !== "all" && (Ei(t3) ? rl(t3, i) < 0 : i !== t3);
    }
    var G5t = { rect: function(o) {
      return OVe(o.range);
    }, polygon: function(o) {
      for (var i, t3 = o.range, c3 = 0, p3 = t3.length; c3 < p3; c3++) {
        i = i || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
        var g3 = t3[c3];
        g3[0] < i[0][0] && (i[0][0] = g3[0]), g3[0] > i[0][1] && (i[0][1] = g3[0]), g3[1] < i[1][0] && (i[1][0] = g3[1]), g3[1] > i[1][1] && (i[1][1] = g3[1]);
      }
      return i && OVe(i);
    } };
    function OVe(o) {
      return new Ys(o[0][0], o[1][0], o[0][1] - o[0][0], o[1][1] - o[1][0]);
    }
    var H5t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3) {
        this.ecModel = t3, this.api = c3, this.model, (this._brushController = new Zye(c3.getZr())).on("brush", Qa(this._onBrush, this)).mount();
      }, i.prototype.render = function(t3, c3, p3, g3) {
        this.model = t3, this._updateController(t3, c3, p3, g3);
      }, i.prototype.updateTransform = function(t3, c3, p3, g3) {
        DVe(c3), this._updateController(t3, c3, p3, g3);
      }, i.prototype.updateVisual = function(t3, c3, p3, g3) {
        this.updateTransform(t3, c3, p3, g3);
      }, i.prototype.updateView = function(t3, c3, p3, g3) {
        this._updateController(t3, c3, p3, g3);
      }, i.prototype._updateController = function(t3, c3, p3, g3) {
        (!g3 || g3.$from !== t3.id) && this._brushController.setPanels(t3.brushTargetManager.makePanelOpts(p3)).enableBrush(t3.brushOption).updateCovers(t3.areas.slice());
      }, i.prototype.dispose = function() {
        this._brushController.dispose();
      }, i.prototype._onBrush = function(t3) {
        var c3 = this.model.id, p3 = this.model.brushTargetManager.setOutputRanges(t3.areas, this.ecModel);
        (!t3.isEnd || t3.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: c3, areas: Jo(p3), $from: c3 }), t3.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: c3, areas: Jo(p3), $from: c3 });
      }, i.type = "brush", i;
    }(ed), W5t = H5t, U5t = "#ddd", q5t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.areas = [], t3.brushOption = {}, t3;
      }
      return i.prototype.optionUpdated = function(t3, c3) {
        var p3 = this.option;
        !c3 && TVe(p3, t3, ["inBrush", "outOfBrush"]);
        var g3 = p3.inBrush = p3.inBrush || {};
        p3.outOfBrush = p3.outOfBrush || { color: U5t }, g3.hasOwnProperty("liftZ") || (g3.liftZ = 5);
      }, i.prototype.setAreas = function(t3) {
        !t3 || (this.areas = Fi(t3, function(c3) {
          return PVe(this.option, c3);
        }, this));
      }, i.prototype.setBrushOption = function(t3) {
        this.brushOption = PVe(this.option, t3), this.brushType = this.brushOption.brushType;
      }, i.type = "brush", i.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], i.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, i;
    }(nc);
    function PVe(o, i) {
      return Es({ brushType: o.brushType, brushMode: o.brushMode, transformable: o.transformable, brushStyle: new gh(o.brushStyle).getItemStyle(), removeOnClick: o.removeOnClick, z: o.z }, i, true);
    }
    var $5t = q5t, X5t = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], Y5t = function(o) {
      cn(i, o);
      function i() {
        return o !== null && o.apply(this, arguments) || this;
      }
      return i.prototype.render = function(t3, c3, p3) {
        var g3, b3, w3;
        c3.eachComponent({ mainType: "brush" }, function(M) {
          g3 = M.brushType, b3 = M.brushOption.brushMode || "single", w3 = w3 || !!M.areas.length;
        }), this._brushType = g3, this._brushMode = b3, yt(t3.get("type", true), function(M) {
          t3.setIconStatus(M, (M === "keep" ? b3 === "multiple" : M === "clear" ? w3 : M === g3) ? "emphasis" : "normal");
        });
      }, i.prototype.updateView = function(t3, c3, p3) {
        this.render(t3, c3, p3);
      }, i.prototype.getIcons = function() {
        var t3 = this.model, c3 = t3.get("icon", true), p3 = {};
        return yt(t3.get("type", true), function(g3) {
          c3[g3] && (p3[g3] = c3[g3]);
        }), p3;
      }, i.prototype.onclick = function(t3, c3, p3) {
        var g3 = this._brushType, b3 = this._brushMode;
        p3 === "clear" ? (c3.dispatchAction({ type: "axisAreaSelect", intervals: [] }), c3.dispatchAction({ type: "brush", command: "clear", areas: [] })) : c3.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: p3 === "keep" ? g3 : g3 === p3 ? false : p3, brushMode: p3 === "keep" ? b3 === "multiple" ? "single" : "multiple" : b3 } });
      }, i.getDefaultOption = function(t3) {
        var c3 = { show: true, type: X5t.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: t3.getLocaleModel().get(["toolbox", "brush", "title"]) };
        return c3;
      }, i;
    }(Bw), K5t = Y5t;
    function Z5t(o) {
      o.registerComponentView(W5t), o.registerComponentModel($5t), o.registerPreprocessor(P5t), o.registerVisual(o.PRIORITY.VISUAL.BRUSH, V5t), o.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(i, t3) {
        t3.eachComponent({ mainType: "brush", query: i }, function(c3) {
          c3.setAreas(i.areas);
        });
      }), o.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, uf), o.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, uf), $8("brush", K5t);
    }
    var J5t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.layoutMode = { type: "box", ignoreSize: true }, t3;
      }
      return i.type = "title", i.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, i;
    }(nc), Q5t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        if (this.group.removeAll(), !!t3.get("show")) {
          var g3 = this.group, b3 = t3.getModel("textStyle"), w3 = t3.getModel("subtextStyle"), M = t3.get("textAlign"), I = Xs(t3.get("textBaseline"), t3.get("textVerticalAlign")), k3 = new Fl({ style: qd(b3, { text: t3.get("text"), fill: b3.getTextColor() }, { disableBox: true }), z2: 10 }), L = k3.getBoundingRect(), F = t3.get("subtext"), B = new Fl({ style: qd(w3, { text: F, fill: w3.getTextColor(), y: L.height + t3.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), G = t3.get("link"), J = t3.get("sublink"), Q = t3.get("triggerEvent", true);
          k3.silent = !G && !Q, B.silent = !J && !Q, G && k3.on("click", function() {
            pte(G, "_" + t3.get("target"));
          }), J && B.on("click", function() {
            pte(J, "_" + t3.get("subtarget"));
          }), La(k3).eventData = La(B).eventData = Q ? { componentType: "title", componentIndex: t3.componentIndex } : null, g3.add(k3), F && g3.add(B);
          var se = g3.getBoundingRect(), he = t3.getBoxLayoutParams();
          he.width = se.width, he.height = se.height;
          var be = Wv(he, { width: p3.getWidth(), height: p3.getHeight() }, t3.get("padding"));
          M || (M = t3.get("left") || t3.get("right"), M === "middle" && (M = "center"), M === "right" ? be.x += be.width : M === "center" && (be.x += be.width / 2)), I || (I = t3.get("top") || t3.get("bottom"), I === "center" && (I = "middle"), I === "bottom" ? be.y += be.height : I === "middle" && (be.y += be.height / 2), I = I || "top"), g3.x = be.x, g3.y = be.y, g3.markRedraw();
          var de = { align: M, verticalAlign: I };
          k3.setStyle(de), B.setStyle(de), se = g3.getBoundingRect();
          var Fe = be.margin, Pe = t3.getItemStyle(["color", "opacity"]);
          Pe.fill = t3.get("backgroundColor");
          var ze = new bu({ shape: { x: se.x - Fe[3], y: se.y - Fe[0], width: se.width + Fe[1] + Fe[3], height: se.height + Fe[0] + Fe[2], r: t3.get("borderRadius") }, style: Pe, subPixelOptimize: true, silent: true });
          g3.add(ze);
        }
      }, i.type = "title", i;
    }(ed);
    function ekt(o) {
      o.registerComponentModel(J5t), o.registerComponentView(Q5t);
    }
    var tkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.layoutMode = "box", t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        this.mergeDefaultAndTheme(t3, p3), this._initData();
      }, i.prototype.mergeOption = function(t3) {
        o.prototype.mergeOption.apply(this, arguments), this._initData();
      }, i.prototype.setCurrentIndex = function(t3) {
        t3 == null && (t3 = this.option.currentIndex);
        var c3 = this._data.count();
        this.option.loop ? t3 = (t3 % c3 + c3) % c3 : (t3 >= c3 && (t3 = c3 - 1), t3 < 0 && (t3 = 0)), this.option.currentIndex = t3;
      }, i.prototype.getCurrentIndex = function() {
        return this.option.currentIndex;
      }, i.prototype.isIndexMax = function() {
        return this.getCurrentIndex() >= this._data.count() - 1;
      }, i.prototype.setPlayState = function(t3) {
        this.option.autoPlay = !!t3;
      }, i.prototype.getPlayState = function() {
        return !!this.option.autoPlay;
      }, i.prototype._initData = function() {
        var t3 = this.option, c3 = t3.data || [], p3 = t3.axisType, g3 = this._names = [], b3;
        p3 === "category" ? (b3 = [], yt(c3, function(I, k3) {
          var L = Jf(NM(I), ""), F;
          Ua(I) ? (F = Jo(I), F.value = k3) : F = k3, b3.push(F), g3.push(L);
        })) : b3 = c3;
        var w3 = { category: "ordinal", time: "time", value: "number" }[p3] || "number", M = this._data = new V1([{ name: "value", type: w3 }], this);
        M.initData(b3, g3);
      }, i.prototype.getData = function() {
        return this._data;
      }, i.prototype.getCategories = function() {
        if (this.get("axisType") === "category")
          return this._names.slice();
      }, i.type = "timeline", i.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, i;
    }(nc), LVe = tkt, RVe = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "timeline.slider", i.defaultOption = rk(LVe.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), i;
    }(LVe);
    Kp(RVe, Tge.prototype);
    var nkt = RVe, rkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "timeline", i;
    }(ed), ikt = rkt, akt = function(o) {
      cn(i, o);
      function i(t3, c3, p3, g3) {
        var b3 = o.call(this, t3, c3, p3) || this;
        return b3.type = g3 || "value", b3;
      }
      return i.prototype.getLabelModel = function() {
        return this.model.getModel("label");
      }, i.prototype.isHorizontal = function() {
        return this.model.get("orient") === "horizontal";
      }, i;
    }(Y2), okt = akt, Xme = Math.PI, NVe = mu(), skt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function(t3, c3) {
        this.api = c3;
      }, i.prototype.render = function(t3, c3, p3) {
        if (this.model = t3, this.api = p3, this.ecModel = c3, this.group.removeAll(), t3.get("show", true)) {
          var g3 = this._layout(t3, p3), b3 = this._createGroup("_mainGroup"), w3 = this._createGroup("_labelGroup"), M = this._axis = this._createAxis(g3, t3);
          t3.formatTooltip = function(I) {
            var k3 = M.scale.getLabel({ value: I });
            return Cg("nameValue", { noName: true, value: k3 });
          }, yt(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(I) {
            this["_render" + I](g3, b3, M, t3);
          }, this), this._renderAxisLabel(g3, w3, M, t3), this._position(g3, t3);
        }
        this._doPlayStop(), this._updateTicksStatus();
      }, i.prototype.remove = function() {
        this._clearTimer(), this.group.removeAll();
      }, i.prototype.dispose = function() {
        this._clearTimer();
      }, i.prototype._layout = function(t3, c3) {
        var p3 = t3.get(["label", "position"]), g3 = t3.get("orient"), b3 = ukt(t3, c3), w3;
        p3 == null || p3 === "auto" ? w3 = g3 === "horizontal" ? b3.y + b3.height / 2 < c3.getHeight() / 2 ? "-" : "+" : b3.x + b3.width / 2 < c3.getWidth() / 2 ? "+" : "-" : Ha(p3) ? w3 = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[g3][p3] : w3 = p3;
        var M = { horizontal: "center", vertical: w3 >= 0 || w3 === "+" ? "left" : "right" }, I = { horizontal: w3 >= 0 || w3 === "+" ? "top" : "bottom", vertical: "middle" }, k3 = { horizontal: 0, vertical: Xme / 2 }, L = g3 === "vertical" ? b3.height : b3.width, F = t3.getModel("controlStyle"), B = F.get("show", true), G = B ? F.get("itemSize") : 0, J = B ? F.get("itemGap") : 0, Q = G + J, se = t3.get(["label", "rotate"]) || 0;
        se = se * Xme / 180;
        var he, be, de, Fe = F.get("position", true), Pe = B && F.get("showPlayBtn", true), ze = B && F.get("showPrevBtn", true), $e = B && F.get("showNextBtn", true), Ke = 0, nt = L;
        Fe === "left" || Fe === "bottom" ? (Pe && (he = [0, 0], Ke += Q), ze && (be = [Ke, 0], Ke += Q), $e && (de = [nt - G, 0], nt -= Q)) : (Pe && (he = [nt - G, 0], nt -= Q), ze && (be = [0, 0], Ke += Q), $e && (de = [nt - G, 0], nt -= Q));
        var lt2 = [Ke, nt];
        return t3.get("inverse") && lt2.reverse(), { viewRect: b3, mainLength: L, orient: g3, rotation: k3[g3], labelRotation: se, labelPosOpt: w3, labelAlign: t3.get(["label", "align"]) || M[g3], labelBaseline: t3.get(["label", "verticalAlign"]) || t3.get(["label", "baseline"]) || I[g3], playPosition: he, prevBtnPosition: be, nextBtnPosition: de, axisExtent: lt2, controlSize: G, controlGap: J };
      }, i.prototype._position = function(t3, c3) {
        var p3 = this._mainGroup, g3 = this._labelGroup, b3 = t3.viewRect;
        if (t3.orient === "vertical") {
          var w3 = dm(), M = b3.x, I = b3.y + b3.height;
          D1(w3, w3, [-M, -I]), cI(w3, w3, -Xme / 2), D1(w3, w3, [M, I]), b3 = b3.clone(), b3.applyTransform(w3);
        }
        var k3 = he(b3), L = he(p3.getBoundingRect()), F = he(g3.getBoundingRect()), B = [p3.x, p3.y], G = [g3.x, g3.y];
        G[0] = B[0] = k3[0][0];
        var J = t3.labelPosOpt;
        if (J == null || Ha(J)) {
          var Q = J === "+" ? 0 : 1;
          be(B, L, k3, 1, Q), be(G, F, k3, 1, 1 - Q);
        } else {
          var Q = J >= 0 ? 0 : 1;
          be(B, L, k3, 1, Q), G[1] = B[1] + J;
        }
        p3.setPosition(B), g3.setPosition(G), p3.rotation = g3.rotation = t3.rotation, se(p3), se(g3);
        function se(de) {
          de.originX = k3[0][0] - de.x, de.originY = k3[1][0] - de.y;
        }
        function he(de) {
          return [[de.x, de.x + de.width], [de.y, de.y + de.height]];
        }
        function be(de, Fe, Pe, ze, $e) {
          de[ze] += Pe[ze][$e] - Fe[ze][$e];
        }
      }, i.prototype._createAxis = function(t3, c3) {
        var p3 = c3.getData(), g3 = c3.get("axisType"), b3 = lkt(c3, g3);
        b3.getTicks = function() {
          return p3.mapArray(["value"], function(I) {
            return { value: I };
          });
        };
        var w3 = p3.getDataExtent("value");
        b3.setExtent(w3[0], w3[1]), b3.calcNiceTicks();
        var M = new okt("value", b3, t3.axisExtent, g3);
        return M.model = c3, M;
      }, i.prototype._createGroup = function(t3) {
        var c3 = this[t3] = new vs();
        return this.group.add(c3), c3;
      }, i.prototype._renderAxisLine = function(t3, c3, p3, g3) {
        var b3 = p3.getExtent();
        if (g3.get(["lineStyle", "show"])) {
          var w3 = new Ud({ shape: { x1: b3[0], y1: 0, x2: b3[1], y2: 0 }, style: ti({ lineCap: "round" }, g3.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
          c3.add(w3);
          var M = this._progressLine = new Ud({ shape: { x1: b3[0], x2: this._currentPointer ? this._currentPointer.x : b3[0], y1: 0, y2: 0 }, style: Uo({ lineCap: "round", lineWidth: w3.style.lineWidth }, g3.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
          c3.add(M);
        }
      }, i.prototype._renderAxisTick = function(t3, c3, p3, g3) {
        var b3 = this, w3 = g3.getData(), M = p3.scale.getTicks();
        this._tickSymbols = [], yt(M, function(I) {
          var k3 = p3.dataToCoord(I.value), L = w3.getItemModel(I.value), F = L.getModel("itemStyle"), B = L.getModel(["emphasis", "itemStyle"]), G = L.getModel(["progress", "itemStyle"]), J = { x: k3, y: 0, onclick: Qa(b3._changeTimeline, b3, I.value) }, Q = FVe(L, F, c3, J);
          Q.ensureState("emphasis").style = B.getItemStyle(), Q.ensureState("progress").style = G.getItemStyle(), II(Q);
          var se = La(Q);
          L.get("tooltip") ? (se.dataIndex = I.value, se.dataModel = g3) : se.dataIndex = se.dataModel = null, b3._tickSymbols.push(Q);
        });
      }, i.prototype._renderAxisLabel = function(t3, c3, p3, g3) {
        var b3 = this, w3 = p3.getLabelModel();
        if (w3.get("show")) {
          var M = g3.getData(), I = p3.getViewLabels();
          this._tickLabels = [], yt(I, function(k3) {
            var L = k3.tickValue, F = M.getItemModel(L), B = F.getModel("label"), G = F.getModel(["emphasis", "label"]), J = F.getModel(["progress", "label"]), Q = p3.dataToCoord(k3.tickValue), se = new Fl({ x: Q, y: 0, rotation: t3.labelRotation - t3.rotation, onclick: Qa(b3._changeTimeline, b3, L), silent: false, style: qd(B, { text: k3.formattedLabel, align: t3.labelAlign, verticalAlign: t3.labelBaseline }) });
            se.ensureState("emphasis").style = qd(G), se.ensureState("progress").style = qd(J), c3.add(se), II(se), NVe(se).dataIndex = L, b3._tickLabels.push(se);
          });
        }
      }, i.prototype._renderControl = function(t3, c3, p3, g3) {
        var b3 = t3.controlSize, w3 = t3.rotation, M = g3.getModel("controlStyle").getItemStyle(), I = g3.getModel(["emphasis", "controlStyle"]).getItemStyle(), k3 = g3.getPlayState(), L = g3.get("inverse", true);
        F(t3.nextBtnPosition, "next", Qa(this._changeTimeline, this, L ? "-" : "+")), F(t3.prevBtnPosition, "prev", Qa(this._changeTimeline, this, L ? "+" : "-")), F(t3.playPosition, k3 ? "stop" : "play", Qa(this._handlePlayClick, this, !k3), true);
        function F(B, G, J, Q) {
          if (B) {
            var se = zv(Xs(g3.get(["controlStyle", G + "BtnSize"]), b3), b3), he = [0, -se / 2, se, se], be = ckt(g3, G + "Icon", he, { x: B[0], y: B[1], originX: b3 / 2, originY: 0, rotation: Q ? -w3 : 0, rectHover: true, style: M, onclick: J });
            be.ensureState("emphasis").style = I, c3.add(be), II(be);
          }
        }
      }, i.prototype._renderCurrentPointer = function(t3, c3, p3, g3) {
        var b3 = g3.getData(), w3 = g3.getCurrentIndex(), M = b3.getItemModel(w3).getModel("checkpointStyle"), I = this, k3 = { onCreate: function(L) {
          L.draggable = true, L.drift = Qa(I._handlePointerDrag, I), L.ondragend = Qa(I._handlePointerDragend, I), VVe(L, I._progressLine, w3, p3, g3, true);
        }, onUpdate: function(L) {
          VVe(L, I._progressLine, w3, p3, g3);
        } };
        this._currentPointer = FVe(M, M, this._mainGroup, {}, this._currentPointer, k3);
      }, i.prototype._handlePlayClick = function(t3) {
        this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: t3, from: this.uid });
      }, i.prototype._handlePointerDrag = function(t3, c3, p3) {
        this._clearTimer(), this._pointerChangeTimeline([p3.offsetX, p3.offsetY]);
      }, i.prototype._handlePointerDragend = function(t3) {
        this._pointerChangeTimeline([t3.offsetX, t3.offsetY], true);
      }, i.prototype._pointerChangeTimeline = function(t3, c3) {
        var p3 = this._toAxisCoord(t3)[0], g3 = this._axis, b3 = dy(g3.getExtent().slice());
        p3 > b3[1] && (p3 = b3[1]), p3 < b3[0] && (p3 = b3[0]), this._currentPointer.x = p3, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = p3, this._progressLine.dirty();
        var w3 = this._findNearestTick(p3), M = this.model;
        (c3 || w3 !== M.getCurrentIndex() && M.get("realtime")) && this._changeTimeline(w3);
      }, i.prototype._doPlayStop = function() {
        var t3 = this;
        this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
          var c3 = t3.model;
          t3._changeTimeline(c3.getCurrentIndex() + (c3.get("rewind", true) ? -1 : 1));
        }, this.model.get("playInterval")));
      }, i.prototype._toAxisCoord = function(t3) {
        var c3 = this._mainGroup.getLocalTransform();
        return ll(t3, c3, true);
      }, i.prototype._findNearestTick = function(t3) {
        var c3 = this.model.getData(), p3 = 1 / 0, g3, b3 = this._axis;
        return c3.each(["value"], function(w3, M) {
          var I = b3.dataToCoord(w3), k3 = Math.abs(I - t3);
          k3 < p3 && (p3 = k3, g3 = M);
        }), g3;
      }, i.prototype._clearTimer = function() {
        this._timer && (clearTimeout(this._timer), this._timer = null);
      }, i.prototype._changeTimeline = function(t3) {
        var c3 = this.model.getCurrentIndex();
        t3 === "+" ? t3 = c3 + 1 : t3 === "-" && (t3 = c3 - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: t3, from: this.uid });
      }, i.prototype._updateTicksStatus = function() {
        var t3 = this.model.getCurrentIndex(), c3 = this._tickSymbols, p3 = this._tickLabels;
        if (c3)
          for (var g3 = 0; g3 < c3.length; g3++)
            c3 && c3[g3] && c3[g3].toggleState("progress", g3 < t3);
        if (p3)
          for (var g3 = 0; g3 < p3.length; g3++)
            p3 && p3[g3] && p3[g3].toggleState("progress", NVe(p3[g3]).dataIndex <= t3);
      }, i.type = "timeline.slider", i;
    }(ikt);
    function lkt(o, i) {
      if (i = i || o.get("type"), i)
        switch (i) {
          case "category":
            return new c0e({ ordinalMeta: o.getCategories(), extent: [1 / 0, -1 / 0] });
          case "time":
            return new a6e({ locale: o.ecModel.getLocaleModel(), useUTC: o.ecModel.get("useUTC") });
          default:
            return new fk();
        }
    }
    function ukt(o, i) {
      return Wv(o.getBoxLayoutParams(), { width: i.getWidth(), height: i.getHeight() }, o.get("padding"));
    }
    function ckt(o, i, t3, c3) {
      var p3 = c3.style, g3 = ip(o.get(["controlStyle", i]), c3 || {}, new Ys(t3[0], t3[1], t3[2], t3[3]));
      return p3 && g3.setStyle(p3), g3;
    }
    function FVe(o, i, t3, c3, p3, g3) {
      var b3 = i.get("color");
      if (p3)
        p3.setColor(b3), t3.add(p3), g3 && g3.onUpdate(p3);
      else {
        var w3 = o.get("symbol");
        p3 = pv(w3, -1, -1, 2, 2, b3), p3.setStyle("strokeNoScale", true), t3.add(p3), g3 && g3.onCreate(p3);
      }
      var M = i.getItemStyle(["color"]);
      p3.setStyle(M), c3 = Es({ rectHover: true, z2: 100 }, c3, true);
      var I = zH(o.get("symbolSize"));
      c3.scaleX = I[0] / 2, c3.scaleY = I[1] / 2;
      var k3 = I8(o.get("symbolOffset"), I);
      k3 && (c3.x = (c3.x || 0) + k3[0], c3.y = (c3.y || 0) + k3[1]);
      var L = o.get("symbolRotate");
      return c3.rotation = (L || 0) * Math.PI / 180 || 0, p3.attr(c3), p3.updateTransform(), p3;
    }
    function VVe(o, i, t3, c3, p3, g3) {
      if (!o.dragging) {
        var b3 = p3.getModel("checkpointStyle"), w3 = c3.dataToCoord(p3.getData().get("value", t3));
        if (g3 || !b3.get("animation", true))
          o.attr({ x: w3, y: 0 }), i && i.attr({ shape: { x2: w3 } });
        else {
          var M = { duration: b3.get("animationDuration", true), easing: b3.get("animationEasing", true) };
          o.stopAnimation(null, true), o.animateTo({ x: w3, y: 0 }, M), i && i.animateTo({ shape: { x2: w3 } }, M);
        }
      }
    }
    var fkt = skt;
    function hkt(o) {
      o.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(i, t3, c3) {
        var p3 = t3.getComponent("timeline");
        return p3 && i.currentIndex != null && (p3.setCurrentIndex(i.currentIndex), !p3.get("loop", true) && p3.isIndexMax() && p3.getPlayState() && (p3.setPlayState(false), c3.dispatchAction({ type: "timelinePlayChange", playState: false, from: i.from }))), t3.resetOption("timeline", { replaceMerge: p3.get("replaceMerge", true) }), Uo({ currentIndex: p3.option.currentIndex }, i);
      }), o.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(i, t3) {
        var c3 = t3.getComponent("timeline");
        c3 && i.playState != null && c3.setPlayState(i.playState);
      });
    }
    function pkt(o) {
      var i = o && o.timeline;
      Ei(i) || (i = i ? [i] : []), yt(i, function(t3) {
        !t3 || dkt(t3);
      });
    }
    function dkt(o) {
      var i = o.type, t3 = { number: "value", time: "time" };
      if (t3[i] && (o.axisType = t3[i], delete o.type), BVe(o), DL(o, "controlPosition")) {
        var c3 = o.controlStyle || (o.controlStyle = {});
        DL(c3, "position") || (c3.position = o.controlPosition), c3.position === "none" && !DL(c3, "show") && (c3.show = false, delete c3.position), delete o.controlPosition;
      }
      yt(o.data || [], function(p3) {
        Ua(p3) && !Ei(p3) && (!DL(p3, "value") && DL(p3, "name") && (p3.value = p3.name), BVe(p3));
      });
    }
    function BVe(o) {
      var i = o.itemStyle || (o.itemStyle = {}), t3 = i.emphasis || (i.emphasis = {}), c3 = o.label || o.label || {}, p3 = c3.normal || (c3.normal = {}), g3 = { normal: 1, emphasis: 1 };
      yt(c3, function(b3, w3) {
        !g3[w3] && !DL(p3, w3) && (p3[w3] = b3);
      }), t3.label && !DL(c3, "emphasis") && (c3.emphasis = t3.label, delete t3.label);
    }
    function DL(o, i) {
      return o.hasOwnProperty(i);
    }
    function vkt(o) {
      o.registerComponentModel(nkt), o.registerComponentView(fkt), o.registerSubTypeDefaulter("timeline", function() {
        return "slider";
      }), hkt(o), o.registerPreprocessor(pkt);
    }
    function Yme(o, i) {
      if (!o)
        return false;
      for (var t3 = Ei(o) ? o : [o], c3 = 0; c3 < t3.length; c3++)
        if (t3[c3] && t3[c3][i])
          return true;
      return false;
    }
    function Gne(o) {
      O1(o, "label", ["show"]);
    }
    var Hne = mu(), zVe = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.createdBySelf = false, t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        this.mergeDefaultAndTheme(t3, p3), this._mergeOption(t3, p3, false, true);
      }, i.prototype.isAnimationEnabled = function() {
        if (yo.node)
          return false;
        var t3 = this.__hostSeries;
        return this.getShallow("animation") && t3 && t3.isAnimationEnabled();
      }, i.prototype.mergeOption = function(t3, c3) {
        this._mergeOption(t3, c3, false, false);
      }, i.prototype._mergeOption = function(t3, c3, p3, g3) {
        var b3 = this.mainType;
        p3 || c3.eachSeries(function(w3) {
          var M = w3.get(this.mainType, true), I = Hne(w3)[b3];
          if (!M || !M.data) {
            Hne(w3)[b3] = null;
            return;
          }
          I ? I._mergeOption(M, c3, true) : (g3 && Gne(M), yt(M.data, function(k3) {
            k3 instanceof Array ? (Gne(k3[0]), Gne(k3[1])) : Gne(k3);
          }), I = this.createMarkerModelFromSeries(M, this, c3), ti(I, { mainType: this.mainType, seriesIndex: w3.seriesIndex, name: w3.name, createdBySelf: true }), I.__hostSeries = w3), Hne(w3)[b3] = I;
        }, this);
      }, i.prototype.formatTooltip = function(t3, c3, p3) {
        var g3 = this.getData(), b3 = this.getRawValue(t3), w3 = g3.getName(t3);
        return Cg("section", { header: this.name, blocks: [Cg("nameValue", { name: w3, value: b3, noName: !w3, noValue: b3 == null })] });
      }, i.prototype.getData = function() {
        return this._data;
      }, i.prototype.setData = function(t3) {
        this._data = t3;
      }, i.getMarkerModelFromSeries = function(t3, c3) {
        return Hne(t3)[c3];
      }, i.type = "marker", i.dependencies = ["series", "grid", "polar", "geo"], i;
    }(nc);
    Kp(zVe, Tge.prototype);
    var wk = zVe, gkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.createMarkerModelFromSeries = function(t3, c3, p3) {
        return new i(t3, c3, p3);
      }, i.type = "markPoint", i.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, i;
    }(wk), ykt = gkt;
    function mkt(o) {
      return !(isNaN(parseFloat(o.x)) && isNaN(parseFloat(o.y)));
    }
    function bkt(o) {
      return !isNaN(parseFloat(o.x)) && !isNaN(parseFloat(o.y));
    }
    function Wne(o, i, t3, c3, p3, g3) {
      var b3 = [], w3 = ck(i, c3), M = w3 ? i.getCalculationInfo("stackResultDimension") : c3, I = Zme(i, M, o), k3 = i.indicesOfNearest(M, I)[0];
      b3[p3] = i.get(t3, k3), b3[g3] = i.get(M, k3);
      var L = i.get(c3, k3), F = Tb(i.get(c3, k3));
      return F = Math.min(F, 20), F >= 0 && (b3[g3] = +b3[g3].toFixed(F)), [b3, L];
    }
    var Kme = { min: As(Wne, "min"), max: As(Wne, "max"), average: As(Wne, "average"), median: As(Wne, "median") };
    function LW(o, i) {
      var t3 = o.getData(), c3 = o.coordinateSystem;
      if (i && !bkt(i) && !Ei(i.coord) && c3) {
        var p3 = c3.dimensions, g3 = jVe(i, t3, c3, o);
        if (i = Jo(i), i.type && Kme[i.type] && g3.baseAxis && g3.valueAxis) {
          var b3 = rl(p3, g3.baseAxis.dim), w3 = rl(p3, g3.valueAxis.dim), M = Kme[i.type](t3, g3.baseDataDim, g3.valueDataDim, b3, w3);
          i.coord = M[0], i.value = M[1];
        } else {
          for (var I = [i.xAxis != null ? i.xAxis : i.radiusAxis, i.yAxis != null ? i.yAxis : i.angleAxis], k3 = 0; k3 < 2; k3++)
            Kme[I[k3]] && (I[k3] = Zme(t3, t3.mapDimension(p3[k3]), I[k3]));
          i.coord = I;
        }
      }
      return i;
    }
    function jVe(o, i, t3, c3) {
      var p3 = {};
      return o.valueIndex != null || o.valueDim != null ? (p3.valueDataDim = o.valueIndex != null ? i.getDimension(o.valueIndex) : o.valueDim, p3.valueAxis = t3.getAxis(_kt(c3, p3.valueDataDim)), p3.baseAxis = t3.getOtherAxis(p3.valueAxis), p3.baseDataDim = i.mapDimension(p3.baseAxis.dim)) : (p3.baseAxis = c3.getBaseAxis(), p3.valueAxis = t3.getOtherAxis(p3.baseAxis), p3.baseDataDim = i.mapDimension(p3.baseAxis.dim), p3.valueDataDim = i.mapDimension(p3.valueAxis.dim)), p3;
    }
    function _kt(o, i) {
      var t3 = o.getData().getDimensionInfo(i);
      return t3 && t3.coordDim;
    }
    function RW(o, i) {
      return o && o.containData && i.coord && !mkt(i) ? o.containData(i.coord) : true;
    }
    function GVe(o, i) {
      return o ? function(t3, c3, p3, g3) {
        var b3 = g3 < 2 ? t3.coord && t3.coord[g3] : t3.value;
        return ok(b3, i[g3]);
      } : function(t3, c3, p3, g3) {
        return ok(t3.value, i[g3]);
      };
    }
    function Zme(o, i, t3) {
      if (t3 === "average") {
        var c3 = 0, p3 = 0;
        return o.each(i, function(g3, b3) {
          isNaN(g3) || (c3 += g3, p3++);
        }), c3 / p3;
      } else
        return t3 === "median" ? o.getMedian(i) : o.getDataExtent(i)[t3 === "max" ? 1 : 0];
    }
    var Jme = mu(), xkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.init = function() {
        this.markerGroupMap = Eo();
      }, i.prototype.render = function(t3, c3, p3) {
        var g3 = this, b3 = this.markerGroupMap;
        b3.each(function(w3) {
          Jme(w3).keep = false;
        }), c3.eachSeries(function(w3) {
          var M = wk.getMarkerModelFromSeries(w3, g3.type);
          M && g3.renderSeries(w3, M, c3, p3);
        }), b3.each(function(w3) {
          !Jme(w3).keep && g3.group.remove(w3.group);
        });
      }, i.prototype.markKeep = function(t3) {
        Jme(t3).keep = true;
      }, i.prototype.blurSeries = function(t3) {
        var c3 = this;
        yt(t3, function(p3) {
          var g3 = wk.getMarkerModelFromSeries(p3, c3.type);
          if (g3) {
            var b3 = g3.getData();
            b3.eachItemGraphicEl(function(w3) {
              w3 && iH(w3);
            });
          }
        });
      }, i.type = "marker", i;
    }(ed), Qme = xkt;
    function HVe(o, i, t3) {
      var c3 = i.coordinateSystem;
      o.each(function(p3) {
        var g3 = o.getItemModel(p3), b3, w3 = Da(g3.get("x"), t3.getWidth()), M = Da(g3.get("y"), t3.getHeight());
        if (!isNaN(w3) && !isNaN(M))
          b3 = [w3, M];
        else if (i.getMarkerPosition)
          b3 = i.getMarkerPosition(o.getValues(o.dimensions, p3));
        else if (c3) {
          var I = o.get(c3.dimensions[0], p3), k3 = o.get(c3.dimensions[1], p3);
          b3 = c3.dataToPoint([I, k3]);
        }
        isNaN(w3) || (b3[0] = w3), isNaN(M) || (b3[1] = M), o.setItemLayout(p3, b3);
      });
    }
    var wkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.updateTransform = function(t3, c3, p3) {
        c3.eachSeries(function(g3) {
          var b3 = wk.getMarkerModelFromSeries(g3, "markPoint");
          b3 && (HVe(b3.getData(), g3, p3), this.markerGroupMap.get(g3.id).updateLayout());
        }, this);
      }, i.prototype.renderSeries = function(t3, c3, p3, g3) {
        var b3 = t3.coordinateSystem, w3 = t3.id, M = t3.getData(), I = this.markerGroupMap, k3 = I.get(w3) || I.set(w3, new lW()), L = Skt(b3, t3, c3);
        c3.setData(L), HVe(c3.getData(), t3, g3), L.each(function(F) {
          var B = L.getItemModel(F), G = B.getShallow("symbol"), J = B.getShallow("symbolSize"), Q = B.getShallow("symbolRotate"), se = B.getShallow("symbolOffset"), he = B.getShallow("symbolKeepAspect");
          if (Vo(G) || Vo(J) || Vo(Q) || Vo(se)) {
            var be = c3.getRawValue(F), de = c3.getDataParams(F);
            Vo(G) && (G = G(be, de)), Vo(J) && (J = J(be, de)), Vo(Q) && (Q = Q(be, de)), Vo(se) && (se = se(be, de));
          }
          var Fe = B.getModel("itemStyle").getItemStyle(), Pe = BH(M, "color");
          Fe.fill || (Fe.fill = Pe), L.setItemVisual(F, { symbol: G, symbolSize: J, symbolRotate: Q, symbolOffset: se, symbolKeepAspect: he, style: Fe });
        }), k3.updateData(L), this.group.add(k3.group), L.eachItemGraphicEl(function(F) {
          F.traverse(function(B) {
            La(B).dataModel = c3;
          });
        }), this.markKeep(k3), k3.group.silent = c3.get("silent") || t3.get("silent");
      }, i.type = "markPoint", i;
    }(Qme);
    function Skt(o, i, t3) {
      var c3;
      o ? c3 = Fi(o && o.dimensions, function(w3) {
        var M = i.getData().getDimensionInfo(i.getData().mapDimension(w3)) || {};
        return ti(ti({}, M), { name: w3, ordinalMeta: null });
      }) : c3 = [{ name: "value", type: "float" }];
      var p3 = new V1(c3, t3), g3 = Fi(t3.get("data"), As(LW, i));
      o && (g3 = Zc(g3, As(RW, o)));
      var b3 = GVe(!!o, c3);
      return p3.initData(g3, null, b3), p3;
    }
    var Ckt = wkt;
    function Mkt(o) {
      o.registerComponentModel(ykt), o.registerComponentView(Ckt), o.registerPreprocessor(function(i) {
        Yme(i.series, "markPoint") && (i.markPoint = i.markPoint || {});
      });
    }
    var Tkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.createMarkerModelFromSeries = function(t3, c3, p3) {
        return new i(t3, c3, p3);
      }, i.type = "markLine", i.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, i;
    }(wk), Akt = Tkt, Une = mu(), Ikt = function(o, i, t3, c3) {
      var p3 = o.getData(), g3;
      if (Ei(c3))
        g3 = c3;
      else {
        var b3 = c3.type;
        if (b3 === "min" || b3 === "max" || b3 === "average" || b3 === "median" || c3.xAxis != null || c3.yAxis != null) {
          var w3 = void 0, M = void 0;
          if (c3.yAxis != null || c3.xAxis != null)
            w3 = i.getAxis(c3.yAxis != null ? "y" : "x"), M = lv(c3.yAxis, c3.xAxis);
          else {
            var I = jVe(c3, p3, i, o);
            w3 = I.valueAxis;
            var k3 = H4e(p3, I.valueDataDim);
            M = Zme(p3, k3, b3);
          }
          var L = w3.dim === "x" ? 0 : 1, F = 1 - L, B = Jo(c3), G = { coord: [] };
          B.type = null, B.coord = [], B.coord[F] = -1 / 0, G.coord[F] = 1 / 0;
          var J = t3.get("precision");
          J >= 0 && ec(M) && (M = +M.toFixed(Math.min(J, 20))), B.coord[L] = G.coord[L] = M, g3 = [B, G, { type: b3, valueIndex: c3.valueIndex, value: M }];
        } else
          g3 = [];
      }
      var Q = [LW(o, g3[0]), LW(o, g3[1]), ti({}, g3[2])];
      return Q[2].type = Q[2].type || null, Es(Q[2], Q[0]), Es(Q[2], Q[1]), Q;
    };
    function qne(o) {
      return !isNaN(o) && !isFinite(o);
    }
    function WVe(o, i, t3, c3) {
      var p3 = 1 - o, g3 = c3.dimensions[o];
      return qne(i[p3]) && qne(t3[p3]) && i[o] === t3[o] && c3.getAxis(g3).containData(i[o]);
    }
    function Ekt(o, i) {
      if (o.type === "cartesian2d") {
        var t3 = i[0].coord, c3 = i[1].coord;
        if (t3 && c3 && (WVe(1, t3, c3, o) || WVe(0, t3, c3, o)))
          return true;
      }
      return RW(o, i[0]) && RW(o, i[1]);
    }
    function e1e(o, i, t3, c3, p3) {
      var g3 = c3.coordinateSystem, b3 = o.getItemModel(i), w3, M = Da(b3.get("x"), p3.getWidth()), I = Da(b3.get("y"), p3.getHeight());
      if (!isNaN(M) && !isNaN(I))
        w3 = [M, I];
      else {
        if (c3.getMarkerPosition)
          w3 = c3.getMarkerPosition(o.getValues(o.dimensions, i));
        else {
          var k3 = g3.dimensions, L = o.get(k3[0], i), F = o.get(k3[1], i);
          w3 = g3.dataToPoint([L, F]);
        }
        if (VI(g3, "cartesian2d")) {
          var B = g3.getAxis("x"), G = g3.getAxis("y"), k3 = g3.dimensions;
          qne(o.get(k3[0], i)) ? w3[0] = B.toGlobalCoord(B.getExtent()[t3 ? 0 : 1]) : qne(o.get(k3[1], i)) && (w3[1] = G.toGlobalCoord(G.getExtent()[t3 ? 0 : 1]));
        }
        isNaN(M) || (w3[0] = M), isNaN(I) || (w3[1] = I);
      }
      o.setItemLayout(i, w3);
    }
    var Dkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.updateTransform = function(t3, c3, p3) {
        c3.eachSeries(function(g3) {
          var b3 = wk.getMarkerModelFromSeries(g3, "markLine");
          if (b3) {
            var w3 = b3.getData(), M = Une(b3).from, I = Une(b3).to;
            M.each(function(k3) {
              e1e(M, k3, true, g3, p3), e1e(I, k3, false, g3, p3);
            }), w3.each(function(k3) {
              w3.setItemLayout(k3, [M.getItemLayout(k3), I.getItemLayout(k3)]);
            }), this.markerGroupMap.get(g3.id).updateLayout();
          }
        }, this);
      }, i.prototype.renderSeries = function(t3, c3, p3, g3) {
        var b3 = t3.coordinateSystem, w3 = t3.id, M = t3.getData(), I = this.markerGroupMap, k3 = I.get(w3) || I.set(w3, new Dye());
        this.group.add(k3.group);
        var L = kkt(b3, t3, c3), F = L.from, B = L.to, G = L.line;
        Une(c3).from = F, Une(c3).to = B, c3.setData(G);
        var J = c3.get("symbol"), Q = c3.get("symbolSize"), se = c3.get("symbolRotate"), he = c3.get("symbolOffset");
        Ei(J) || (J = [J, J]), Ei(Q) || (Q = [Q, Q]), Ei(se) || (se = [se, se]), Ei(he) || (he = [he, he]), L.from.each(function(de) {
          be(F, de, true), be(B, de, false);
        }), G.each(function(de) {
          var Fe = G.getItemModel(de).getModel("lineStyle").getLineStyle();
          G.setItemLayout(de, [F.getItemLayout(de), B.getItemLayout(de)]), Fe.stroke == null && (Fe.stroke = F.getItemVisual(de, "style").fill), G.setItemVisual(de, { fromSymbolKeepAspect: F.getItemVisual(de, "symbolKeepAspect"), fromSymbolOffset: F.getItemVisual(de, "symbolOffset"), fromSymbolRotate: F.getItemVisual(de, "symbolRotate"), fromSymbolSize: F.getItemVisual(de, "symbolSize"), fromSymbol: F.getItemVisual(de, "symbol"), toSymbolKeepAspect: B.getItemVisual(de, "symbolKeepAspect"), toSymbolOffset: B.getItemVisual(de, "symbolOffset"), toSymbolRotate: B.getItemVisual(de, "symbolRotate"), toSymbolSize: B.getItemVisual(de, "symbolSize"), toSymbol: B.getItemVisual(de, "symbol"), style: Fe });
        }), k3.updateData(G), L.line.eachItemGraphicEl(function(de, Fe) {
          de.traverse(function(Pe) {
            La(Pe).dataModel = c3;
          });
        });
        function be(de, Fe, Pe) {
          var ze = de.getItemModel(Fe);
          e1e(de, Fe, Pe, t3, g3);
          var $e = ze.getModel("itemStyle").getItemStyle();
          $e.fill == null && ($e.fill = BH(M, "color")), de.setItemVisual(Fe, { symbolKeepAspect: ze.get("symbolKeepAspect"), symbolOffset: Xs(ze.get("symbolOffset", true), he[Pe ? 0 : 1]), symbolRotate: Xs(ze.get("symbolRotate", true), se[Pe ? 0 : 1]), symbolSize: Xs(ze.get("symbolSize"), Q[Pe ? 0 : 1]), symbol: Xs(ze.get("symbol", true), J[Pe ? 0 : 1]), style: $e });
        }
        this.markKeep(k3), k3.group.silent = c3.get("silent") || t3.get("silent");
      }, i.type = "markLine", i;
    }(Qme);
    function kkt(o, i, t3) {
      var c3;
      o ? c3 = Fi(o && o.dimensions, function(I) {
        var k3 = i.getData().getDimensionInfo(i.getData().mapDimension(I)) || {};
        return ti(ti({}, k3), { name: I, ordinalMeta: null });
      }) : c3 = [{ name: "value", type: "float" }];
      var p3 = new V1(c3, t3), g3 = new V1(c3, t3), b3 = new V1([], t3), w3 = Fi(t3.get("data"), As(Ikt, i, o, t3));
      o && (w3 = Zc(w3, As(Ekt, o)));
      var M = GVe(!!o, c3);
      return p3.initData(Fi(w3, function(I) {
        return I[0];
      }), null, M), g3.initData(Fi(w3, function(I) {
        return I[1];
      }), null, M), b3.initData(Fi(w3, function(I) {
        return I[2];
      })), b3.hasItemOption = true, { from: p3, to: g3, line: b3 };
    }
    var Okt = Dkt;
    function Pkt(o) {
      o.registerComponentModel(Akt), o.registerComponentView(Okt), o.registerPreprocessor(function(i) {
        Yme(i.series, "markLine") && (i.markLine = i.markLine || {});
      });
    }
    var Lkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.createMarkerModelFromSeries = function(t3, c3, p3) {
        return new i(t3, c3, p3);
      }, i.type = "markArea", i.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, i;
    }(wk), Rkt = Lkt, $ne = mu(), Nkt = function(o, i, t3, c3) {
      var p3 = LW(o, c3[0]), g3 = LW(o, c3[1]), b3 = p3.coord, w3 = g3.coord;
      b3[0] = lv(b3[0], -1 / 0), b3[1] = lv(b3[1], -1 / 0), w3[0] = lv(w3[0], 1 / 0), w3[1] = lv(w3[1], 1 / 0);
      var M = nF([{}, p3, g3]);
      return M.coord = [p3.coord, g3.coord], M.x0 = p3.x, M.y0 = p3.y, M.x1 = g3.x, M.y1 = g3.y, M;
    };
    function Xne(o) {
      return !isNaN(o) && !isFinite(o);
    }
    function UVe(o, i, t3, c3) {
      var p3 = 1 - o;
      return Xne(i[p3]) && Xne(t3[p3]);
    }
    function Fkt(o, i) {
      var t3 = i.coord[0], c3 = i.coord[1];
      return VI(o, "cartesian2d") && t3 && c3 && (UVe(1, t3, c3) || UVe(0, t3, c3)) ? true : RW(o, { coord: t3, x: i.x0, y: i.y0 }) || RW(o, { coord: c3, x: i.x1, y: i.y1 });
    }
    function qVe(o, i, t3, c3, p3) {
      var g3 = c3.coordinateSystem, b3 = o.getItemModel(i), w3, M = Da(b3.get(t3[0]), p3.getWidth()), I = Da(b3.get(t3[1]), p3.getHeight());
      if (!isNaN(M) && !isNaN(I))
        w3 = [M, I];
      else {
        if (c3.getMarkerPosition)
          w3 = c3.getMarkerPosition(o.getValues(t3, i));
        else {
          var k3 = o.get(t3[0], i), L = o.get(t3[1], i), F = [k3, L];
          g3.clampData && g3.clampData(F, F), w3 = g3.dataToPoint(F, true);
        }
        if (VI(g3, "cartesian2d")) {
          var B = g3.getAxis("x"), G = g3.getAxis("y"), k3 = o.get(t3[0], i), L = o.get(t3[1], i);
          Xne(k3) ? w3[0] = B.toGlobalCoord(B.getExtent()[t3[0] === "x0" ? 0 : 1]) : Xne(L) && (w3[1] = G.toGlobalCoord(G.getExtent()[t3[1] === "y0" ? 0 : 1]));
        }
        isNaN(M) || (w3[0] = M), isNaN(I) || (w3[1] = I);
      }
      return w3;
    }
    var $Ve = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], Vkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.updateTransform = function(t3, c3, p3) {
        c3.eachSeries(function(g3) {
          var b3 = wk.getMarkerModelFromSeries(g3, "markArea");
          if (b3) {
            var w3 = b3.getData();
            w3.each(function(M) {
              var I = Fi($Ve, function(L) {
                return qVe(w3, M, L, g3, p3);
              });
              w3.setItemLayout(M, I);
              var k3 = w3.getItemGraphicEl(M);
              k3.setShape("points", I);
            });
          }
        }, this);
      }, i.prototype.renderSeries = function(t3, c3, p3, g3) {
        var b3 = t3.coordinateSystem, w3 = t3.id, M = t3.getData(), I = this.markerGroupMap, k3 = I.get(w3) || I.set(w3, { group: new vs() });
        this.group.add(k3.group), this.markKeep(k3);
        var L = Bkt(b3, t3, c3);
        c3.setData(L), L.each(function(F) {
          var B = Fi($Ve, function($e) {
            return qVe(L, F, $e, t3, g3);
          }), G = b3.getAxis("x").scale, J = b3.getAxis("y").scale, Q = G.getExtent(), se = J.getExtent(), he = [G.parse(L.get("x0", F)), G.parse(L.get("x1", F))], be = [J.parse(L.get("y0", F)), J.parse(L.get("y1", F))];
          dy(he), dy(be);
          var de = !(Q[0] > he[1] || Q[1] < he[0] || se[0] > be[1] || se[1] < be[0]), Fe = !de;
          L.setItemLayout(F, { points: B, allClipped: Fe });
          var Pe = L.getItemModel(F).getModel("itemStyle").getItemStyle(), ze = BH(M, "color");
          Pe.fill || (Pe.fill = ze, Ha(Pe.fill) && (Pe.fill = dF(Pe.fill, 0.4))), Pe.stroke || (Pe.stroke = ze), L.setItemVisual(F, "style", Pe);
        }), L.diff($ne(k3).data).add(function(F) {
          var B = L.getItemLayout(F);
          if (!B.allClipped) {
            var G = new _m({ shape: { points: B.points } });
            L.setItemGraphicEl(F, G), k3.group.add(G);
          }
        }).update(function(F, B) {
          var G = $ne(k3).data.getItemGraphicEl(B), J = L.getItemLayout(F);
          J.allClipped ? G && k3.group.remove(G) : (G ? Du(G, { shape: { points: J.points } }, c3, F) : G = new _m({ shape: { points: J.points } }), L.setItemGraphicEl(F, G), k3.group.add(G));
        }).remove(function(F) {
          var B = $ne(k3).data.getItemGraphicEl(F);
          k3.group.remove(B);
        }).execute(), L.eachItemGraphicEl(function(F, B) {
          var G = L.getItemModel(B), J = L.getItemVisual(B, "style");
          F.useStyle(L.getItemVisual(B, "style")), Sm(F, g0(G), { labelFetcher: c3, labelDataIndex: B, defaultText: L.getName(B) || "", inheritColor: Ha(J.fill) ? dF(J.fill, 1) : "#000" }), cv(F, G), zp(F, null, null, G.get(["emphasis", "disabled"])), La(F).dataModel = c3;
        }), $ne(k3).data = L, k3.group.silent = c3.get("silent") || t3.get("silent");
      }, i.type = "markArea", i;
    }(Qme);
    function Bkt(o, i, t3) {
      var c3, p3, g3 = ["x0", "y0", "x1", "y1"];
      if (o) {
        var b3 = Fi(o && o.dimensions, function(I) {
          var k3 = i.getData(), L = k3.getDimensionInfo(k3.mapDimension(I)) || {};
          return ti(ti({}, L), { name: I, ordinalMeta: null });
        });
        p3 = Fi(g3, function(I, k3) {
          return { name: I, type: b3[k3 % 2].type };
        }), c3 = new V1(p3, t3);
      } else
        p3 = [{ name: "value", type: "float" }], c3 = new V1(p3, t3);
      var w3 = Fi(t3.get("data"), As(Nkt, i, o, t3));
      o && (w3 = Zc(w3, As(Fkt, o)));
      var M = o ? function(I, k3, L, F) {
        var B = I.coord[Math.floor(F / 2)][F % 2];
        return ok(B, p3[F]);
      } : function(I, k3, L, F) {
        return ok(I.value, p3[F]);
      };
      return c3.initData(w3, null, M), c3.hasItemOption = true, c3;
    }
    var zkt = Vkt;
    function jkt(o) {
      o.registerComponentModel(Rkt), o.registerComponentView(zkt), o.registerPreprocessor(function(i) {
        Yme(i.series, "markArea") && (i.markArea = i.markArea || {});
      });
    }
    var Gkt = function(o, i) {
      if (i === "all")
        return { type: "all", title: o.getLocaleModel().get(["legend", "selector", "all"]) };
      if (i === "inverse")
        return { type: "inverse", title: o.getLocaleModel().get(["legend", "selector", "inverse"]) };
    }, Hkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.layoutMode = { type: "box", ignoreSize: true }, t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        this.mergeDefaultAndTheme(t3, p3), t3.selected = t3.selected || {}, this._updateSelector(t3);
      }, i.prototype.mergeOption = function(t3, c3) {
        o.prototype.mergeOption.call(this, t3, c3), this._updateSelector(t3);
      }, i.prototype._updateSelector = function(t3) {
        var c3 = t3.selector, p3 = this.ecModel;
        c3 === true && (c3 = t3.selector = ["all", "inverse"]), Ei(c3) && yt(c3, function(g3, b3) {
          Ha(g3) && (g3 = { type: g3 }), c3[b3] = Es(g3, Gkt(p3, g3.type));
        });
      }, i.prototype.optionUpdated = function() {
        this._updateData(this.ecModel);
        var t3 = this._data;
        if (t3[0] && this.get("selectedMode") === "single") {
          for (var c3 = false, p3 = 0; p3 < t3.length; p3++) {
            var g3 = t3[p3].get("name");
            if (this.isSelected(g3)) {
              this.select(g3), c3 = true;
              break;
            }
          }
          !c3 && this.select(t3[0].get("name"));
        }
      }, i.prototype._updateData = function(t3) {
        var c3 = [], p3 = [];
        t3.eachRawSeries(function(w3) {
          var M = w3.name;
          p3.push(M);
          var I;
          if (w3.legendVisualProvider) {
            var k3 = w3.legendVisualProvider, L = k3.getAllNames();
            t3.isSeriesFiltered(w3) || (p3 = p3.concat(L)), L.length ? c3 = c3.concat(L) : I = true;
          } else
            I = true;
          I && wg(w3) && c3.push(w3.name);
        }), this._availableNames = p3;
        var g3 = this.get("data") || c3, b3 = Fi(g3, function(w3) {
          return (Ha(w3) || ec(w3)) && (w3 = { name: w3 }), new gh(w3, this, this.ecModel);
        }, this);
        this._data = b3;
      }, i.prototype.getData = function() {
        return this._data;
      }, i.prototype.select = function(t3) {
        var c3 = this.option.selected, p3 = this.get("selectedMode");
        if (p3 === "single") {
          var g3 = this._data;
          yt(g3, function(b3) {
            c3[b3.get("name")] = false;
          });
        }
        c3[t3] = true;
      }, i.prototype.unSelect = function(t3) {
        this.get("selectedMode") !== "single" && (this.option.selected[t3] = false);
      }, i.prototype.toggleSelected = function(t3) {
        var c3 = this.option.selected;
        c3.hasOwnProperty(t3) || (c3[t3] = true), this[c3[t3] ? "unSelect" : "select"](t3);
      }, i.prototype.allSelect = function() {
        var t3 = this._data, c3 = this.option.selected;
        yt(t3, function(p3) {
          c3[p3.get("name", true)] = true;
        });
      }, i.prototype.inverseSelect = function() {
        var t3 = this._data, c3 = this.option.selected;
        yt(t3, function(p3) {
          var g3 = p3.get("name", true);
          c3.hasOwnProperty(g3) || (c3[g3] = true), c3[g3] = !c3[g3];
        });
      }, i.prototype.isSelected = function(t3) {
        var c3 = this.option.selected;
        return !(c3.hasOwnProperty(t3) && !c3[t3]) && rl(this._availableNames, t3) >= 0;
      }, i.prototype.getOrient = function() {
        return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
      }, i.type = "legend.plain", i.dependencies = ["series"], i.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, i;
    }(nc), t1e = Hkt, Y8 = As, n1e = yt, Yne = vs, Wkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.newlineDisabled = false, t3;
      }
      return i.prototype.init = function() {
        this.group.add(this._contentGroup = new Yne()), this.group.add(this._selectorGroup = new Yne()), this._isFirstRender = true;
      }, i.prototype.getContentGroup = function() {
        return this._contentGroup;
      }, i.prototype.getSelectorGroup = function() {
        return this._selectorGroup;
      }, i.prototype.render = function(t3, c3, p3) {
        var g3 = this._isFirstRender;
        if (this._isFirstRender = false, this.resetInner(), !!t3.get("show", true)) {
          var b3 = t3.get("align"), w3 = t3.get("orient");
          (!b3 || b3 === "auto") && (b3 = t3.get("left") === "right" && w3 === "vertical" ? "right" : "left");
          var M = t3.get("selector", true), I = t3.get("selectorPosition", true);
          M && (!I || I === "auto") && (I = w3 === "horizontal" ? "end" : "start"), this.renderInner(b3, t3, c3, p3, M, w3, I);
          var k3 = t3.getBoxLayoutParams(), L = { width: p3.getWidth(), height: p3.getHeight() }, F = t3.get("padding"), B = Wv(k3, L, F), G = this.layoutInner(t3, b3, B, g3, M, I), J = Wv(Uo({ width: G.width, height: G.height }, k3), L, F);
          this.group.x = J.x - G.x, this.group.y = J.y - G.y, this.group.markRedraw(), this.group.add(this._backgroundEl = nVe(G, t3));
        }
      }, i.prototype.resetInner = function() {
        this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
      }, i.prototype.renderInner = function(t3, c3, p3, g3, b3, w3, M) {
        var I = this.getContentGroup(), k3 = Eo(), L = c3.get("selectedMode"), F = [];
        p3.eachRawSeries(function(B) {
          !B.get("legendHoverLink") && F.push(B.id);
        }), n1e(c3.getData(), function(B, G) {
          var J = B.get("name");
          if (!this.newlineDisabled && (J === "" || J === `
`)) {
            var Q = new Yne();
            Q.newline = true, I.add(Q);
            return;
          }
          var se = p3.getSeriesByName(J)[0];
          if (!k3.get(J))
            if (se) {
              var he = se.getData(), be = he.getVisual("legendLineStyle") || {}, de = he.getVisual("legendIcon"), Fe = he.getVisual("style"), Pe = this._createItem(se, J, G, B, c3, t3, be, Fe, de, L);
              Pe.on("click", Y8(XVe, J, null, g3, F)).on("mouseover", Y8(r1e, se.name, null, g3, F)).on("mouseout", Y8(i1e, se.name, null, g3, F)), k3.set(J, true);
            } else
              p3.eachRawSeries(function(ze) {
                if (!k3.get(J) && ze.legendVisualProvider) {
                  var $e = ze.legendVisualProvider;
                  if (!$e.containName(J))
                    return;
                  var Ke = $e.indexOfName(J), nt = $e.getItemVisual(Ke, "style"), lt2 = $e.getItemVisual(Ke, "legendIcon"), bt = I1(nt.fill);
                  bt && bt[3] === 0 && (bt[3] = 0.2, nt = ti(ti({}, nt), { fill: bg(bt, "rgba") }));
                  var vt = this._createItem(ze, J, G, B, c3, t3, {}, nt, lt2, L);
                  vt.on("click", Y8(XVe, null, J, g3, F)).on("mouseover", Y8(r1e, null, J, g3, F)).on("mouseout", Y8(i1e, null, J, g3, F)), k3.set(J, true);
                }
              }, this);
        }, this), b3 && this._createSelector(b3, c3, g3, w3, M);
      }, i.prototype._createSelector = function(t3, c3, p3, g3, b3) {
        var w3 = this.getSelectorGroup();
        n1e(t3, function(M) {
          var I = M.type, k3 = new Fl({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
            p3.dispatchAction({ type: I === "all" ? "legendAllSelect" : "legendInverseSelect" });
          } });
          w3.add(k3);
          var L = c3.getModel("selectorLabel"), F = c3.getModel(["emphasis", "selectorLabel"]);
          Sm(k3, { normal: L, emphasis: F }, { defaultText: M.title }), II(k3);
        });
      }, i.prototype._createItem = function(t3, c3, p3, g3, b3, w3, M, I, k3, L) {
        var F = t3.visualDrawType, B = b3.get("itemWidth"), G = b3.get("itemHeight"), J = b3.isSelected(c3), Q = g3.get("symbolRotate"), se = g3.get("symbolKeepAspect"), he = g3.get("icon");
        k3 = he || k3 || "roundRect";
        var be = Ukt(k3, g3, M, I, F, J), de = new Yne(), Fe = g3.getModel("textStyle");
        if (Vo(t3.getLegendIcon) && (!he || he === "inherit"))
          de.add(t3.getLegendIcon({ itemWidth: B, itemHeight: G, icon: k3, iconRotate: Q, itemStyle: be.itemStyle, lineStyle: be.lineStyle, symbolKeepAspect: se }));
        else {
          var Pe = he === "inherit" && t3.getData().getVisual("symbol") ? Q === "inherit" ? t3.getData().getVisual("symbolRotate") : Q : 0;
          de.add(qkt({ itemWidth: B, itemHeight: G, icon: k3, iconRotate: Pe, itemStyle: be.itemStyle, lineStyle: be.lineStyle, symbolKeepAspect: se }));
        }
        var ze = w3 === "left" ? B + 5 : -5, $e = w3, Ke = b3.get("formatter"), nt = c3;
        Ha(Ke) && Ke ? nt = Ke.replace("{name}", c3 != null ? c3 : "") : Vo(Ke) && (nt = Ke(c3));
        var lt2 = g3.get("inactiveColor");
        de.add(new Fl({ style: qd(Fe, { text: nt, x: ze, y: G / 2, fill: J ? Fe.getTextColor() : lt2, align: $e, verticalAlign: "middle" }) }));
        var bt = new bu({ shape: de.getBoundingRect(), invisible: true }), vt = g3.getModel("tooltip");
        return vt.get("show") && h8({ el: bt, componentModel: b3, itemName: c3, itemTooltipOption: vt.option }), de.add(bt), de.eachChild(function(jt) {
          jt.silent = true;
        }), bt.silent = !L, this.getContentGroup().add(de), II(de), de.__legendDataIndex = p3, de;
      }, i.prototype.layoutInner = function(t3, c3, p3, g3, b3, w3) {
        var M = this.getContentGroup(), I = this.getSelectorGroup();
        iL(t3.get("orient"), M, t3.get("itemGap"), p3.width, p3.height);
        var k3 = M.getBoundingRect(), L = [-k3.x, -k3.y];
        if (I.markRedraw(), M.markRedraw(), b3) {
          iL("horizontal", I, t3.get("selectorItemGap", true));
          var F = I.getBoundingRect(), B = [-F.x, -F.y], G = t3.get("selectorButtonGap", true), J = t3.getOrient().index, Q = J === 0 ? "width" : "height", se = J === 0 ? "height" : "width", he = J === 0 ? "y" : "x";
          w3 === "end" ? B[J] += k3[Q] + G : L[J] += F[Q] + G, B[1 - J] += k3[se] / 2 - F[se] / 2, I.x = B[0], I.y = B[1], M.x = L[0], M.y = L[1];
          var be = { x: 0, y: 0 };
          return be[Q] = k3[Q] + G + F[Q], be[se] = Math.max(k3[se], F[se]), be[he] = Math.min(0, F[he] + B[1 - J]), be;
        } else
          return M.x = L[0], M.y = L[1], this.group.getBoundingRect();
      }, i.prototype.remove = function() {
        this.getContentGroup().removeAll(), this._isFirstRender = true;
      }, i.type = "legend.plain", i;
    }(ed);
    function Ukt(o, i, t3, c3, p3, g3) {
      function b3(G, J) {
        G.lineWidth === "auto" && (G.lineWidth = J.lineWidth > 0 ? 2 : 0), n1e(G, function(Q, se) {
          G[se] === "inherit" && (G[se] = J[se]);
        });
      }
      var w3 = i.getModel("itemStyle"), M = w3.getItemStyle(), I = o.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
      M.decal = c3.decal, M.fill === "inherit" && (M.fill = c3[p3]), M.stroke === "inherit" && (M.stroke = c3[I]), M.opacity === "inherit" && (M.opacity = (p3 === "fill" ? c3 : t3).opacity), b3(M, c3);
      var k3 = i.getModel("lineStyle"), L = k3.getLineStyle();
      if (b3(L, t3), M.fill === "auto" && (M.fill = c3.fill), M.stroke === "auto" && (M.stroke = c3.fill), L.stroke === "auto" && (L.stroke = c3.fill), !g3) {
        var F = i.get("inactiveBorderWidth"), B = M[I];
        M.lineWidth = F === "auto" ? c3.lineWidth > 0 && B ? 2 : 0 : M.lineWidth, M.fill = i.get("inactiveColor"), M.stroke = i.get("inactiveBorderColor"), L.stroke = k3.get("inactiveColor"), L.lineWidth = k3.get("inactiveWidth");
      }
      return { itemStyle: M, lineStyle: L };
    }
    function qkt(o) {
      var i = o.icon || "roundRect", t3 = pv(i, 0, 0, o.itemWidth, o.itemHeight, o.itemStyle.fill, o.symbolKeepAspect);
      return t3.setStyle(o.itemStyle), t3.rotation = (o.iconRotate || 0) * Math.PI / 180, t3.setOrigin([o.itemWidth / 2, o.itemHeight / 2]), i.indexOf("empty") > -1 && (t3.style.stroke = t3.style.fill, t3.style.fill = "#fff", t3.style.lineWidth = 2), t3;
    }
    function XVe(o, i, t3, c3) {
      i1e(o, i, t3, c3), t3.dispatchAction({ type: "legendToggleSelect", name: o != null ? o : i }), r1e(o, i, t3, c3);
    }
    function YVe(o) {
      for (var i = o.getZr().storage.getDisplayList(), t3, c3 = 0, p3 = i.length; c3 < p3 && !(t3 = i[c3].states.emphasis); )
        c3++;
      return t3 && t3.hoverLayer;
    }
    function r1e(o, i, t3, c3) {
      YVe(t3) || t3.dispatchAction({ type: "highlight", seriesName: o, name: i, excludeSeriesId: c3 });
    }
    function i1e(o, i, t3, c3) {
      YVe(t3) || t3.dispatchAction({ type: "downplay", seriesName: o, name: i, excludeSeriesId: c3 });
    }
    var KVe = Wkt;
    function $kt(o) {
      var i = o.findComponents({ mainType: "legend" });
      i && i.length && o.filterSeries(function(t3) {
        for (var c3 = 0; c3 < i.length; c3++)
          if (!i[c3].isSelected(t3.name))
            return false;
        return true;
      });
    }
    function NW(o, i, t3) {
      var c3 = {}, p3 = o === "toggleSelected", g3;
      return t3.eachComponent("legend", function(b3) {
        p3 && g3 != null ? b3[g3 ? "select" : "unSelect"](i.name) : o === "allSelect" || o === "inverseSelect" ? b3[o]() : (b3[o](i.name), g3 = b3.isSelected(i.name));
        var w3 = b3.getData();
        yt(w3, function(M) {
          var I = M.get("name");
          if (!(I === `
` || I === "")) {
            var k3 = b3.isSelected(I);
            c3.hasOwnProperty(I) ? c3[I] = c3[I] && k3 : c3[I] = k3;
          }
        });
      }), o === "allSelect" || o === "inverseSelect" ? { selected: c3 } : { name: i.name, selected: c3 };
    }
    function Xkt(o) {
      o.registerAction("legendToggleSelect", "legendselectchanged", As(NW, "toggleSelected")), o.registerAction("legendAllSelect", "legendselectall", As(NW, "allSelect")), o.registerAction("legendInverseSelect", "legendinverseselect", As(NW, "inverseSelect")), o.registerAction("legendSelect", "legendselected", As(NW, "select")), o.registerAction("legendUnSelect", "legendunselected", As(NW, "unSelect"));
    }
    function ZVe(o) {
      o.registerComponentModel(t1e), o.registerComponentView(KVe), o.registerProcessor(o.PRIORITY.PROCESSOR.SERIES_FILTER, $kt), o.registerSubTypeDefaulter("legend", function() {
        return "plain";
      }), Xkt(o);
    }
    var Ykt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.setScrollDataIndex = function(t3) {
        this.option.scrollDataIndex = t3;
      }, i.prototype.init = function(t3, c3, p3) {
        var g3 = m8(t3);
        o.prototype.init.call(this, t3, c3, p3), JVe(this, t3, g3);
      }, i.prototype.mergeOption = function(t3, c3) {
        o.prototype.mergeOption.call(this, t3, c3), JVe(this, this.option, t3);
      }, i.type = "legend.scroll", i.defaultOption = rk(t1e.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), i;
    }(t1e);
    function JVe(o, i, t3) {
      var c3 = o.getOrient(), p3 = [1, 1];
      p3[c3.index] = 0, ik(i, t3, { type: "box", ignoreSize: !!p3 });
    }
    var Kkt = Ykt, QVe = vs, a1e = ["width", "height"], o1e = ["x", "y"], Zkt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.newlineDisabled = true, t3._currentIndex = 0, t3;
      }
      return i.prototype.init = function() {
        o.prototype.init.call(this), this.group.add(this._containerGroup = new QVe()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new QVe());
      }, i.prototype.resetInner = function() {
        o.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
      }, i.prototype.renderInner = function(t3, c3, p3, g3, b3, w3, M) {
        var I = this;
        o.prototype.renderInner.call(this, t3, c3, p3, g3, b3, w3, M);
        var k3 = this._controllerGroup, L = c3.get("pageIconSize", true), F = Ei(L) ? L : [L, L];
        G("pagePrev", 0);
        var B = c3.getModel("pageTextStyle");
        k3.add(new Fl({ name: "pageText", style: { text: "xx/xx", fill: B.getTextColor(), font: B.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), G("pageNext", 1);
        function G(J, Q) {
          var se = J + "DataIndex", he = ip(c3.get("pageIcons", true)[c3.getOrient().name][Q], { onclick: Qa(I._pageGo, I, se, c3, g3) }, { x: -F[0] / 2, y: -F[1] / 2, width: F[0], height: F[1] });
          he.name = J, k3.add(he);
        }
      }, i.prototype.layoutInner = function(t3, c3, p3, g3, b3, w3) {
        var M = this.getSelectorGroup(), I = t3.getOrient().index, k3 = a1e[I], L = o1e[I], F = a1e[1 - I], B = o1e[1 - I];
        b3 && iL("horizontal", M, t3.get("selectorItemGap", true));
        var G = t3.get("selectorButtonGap", true), J = M.getBoundingRect(), Q = [-J.x, -J.y], se = Jo(p3);
        b3 && (se[k3] = p3[k3] - J[k3] - G);
        var he = this._layoutContentAndController(t3, g3, se, I, k3, F, B, L);
        if (b3) {
          if (w3 === "end")
            Q[I] += he[k3] + G;
          else {
            var be = J[k3] + G;
            Q[I] -= be, he[L] -= be;
          }
          he[k3] += J[k3] + G, Q[1 - I] += he[B] + he[F] / 2 - J[F] / 2, he[F] = Math.max(he[F], J[F]), he[B] = Math.min(he[B], J[B] + Q[1 - I]), M.x = Q[0], M.y = Q[1], M.markRedraw();
        }
        return he;
      }, i.prototype._layoutContentAndController = function(t3, c3, p3, g3, b3, w3, M, I) {
        var k3 = this.getContentGroup(), L = this._containerGroup, F = this._controllerGroup;
        iL(t3.get("orient"), k3, t3.get("itemGap"), g3 ? p3.width : null, g3 ? null : p3.height), iL("horizontal", F, t3.get("pageButtonItemGap", true));
        var B = k3.getBoundingRect(), G = F.getBoundingRect(), J = this._showController = B[b3] > p3[b3], Q = [-B.x, -B.y];
        c3 || (Q[g3] = k3[I]);
        var se = [0, 0], he = [-G.x, -G.y], be = Xs(t3.get("pageButtonGap", true), t3.get("itemGap", true));
        if (J) {
          var de = t3.get("pageButtonPosition", true);
          de === "end" ? he[g3] += p3[b3] - G[b3] : se[g3] += G[b3] + be;
        }
        he[1 - g3] += B[w3] / 2 - G[w3] / 2, k3.setPosition(Q), L.setPosition(se), F.setPosition(he);
        var Fe = { x: 0, y: 0 };
        if (Fe[b3] = J ? p3[b3] : B[b3], Fe[w3] = Math.max(B[w3], G[w3]), Fe[M] = Math.min(0, G[M] + he[1 - g3]), L.__rectSize = p3[b3], J) {
          var Pe = { x: 0, y: 0 };
          Pe[b3] = Math.max(p3[b3] - G[b3] - be, 0), Pe[w3] = Fe[w3], L.setClipPath(new bu({ shape: Pe })), L.__rectSize = Pe[b3];
        } else
          F.eachChild(function($e) {
            $e.attr({ invisible: true, silent: true });
          });
        var ze = this._getPageInfo(t3);
        return ze.pageIndex != null && Du(k3, { x: ze.contentPosition[0], y: ze.contentPosition[1] }, J ? t3 : null), this._updatePageInfoView(t3, ze), Fe;
      }, i.prototype._pageGo = function(t3, c3, p3) {
        var g3 = this._getPageInfo(c3)[t3];
        g3 != null && p3.dispatchAction({ type: "legendScroll", scrollDataIndex: g3, legendId: c3.id });
      }, i.prototype._updatePageInfoView = function(t3, c3) {
        var p3 = this._controllerGroup;
        yt(["pagePrev", "pageNext"], function(k3) {
          var L = k3 + "DataIndex", F = c3[L] != null, B = p3.childOfName(k3);
          B && (B.setStyle("fill", F ? t3.get("pageIconColor", true) : t3.get("pageIconInactiveColor", true)), B.cursor = F ? "pointer" : "default");
        });
        var g3 = p3.childOfName("pageText"), b3 = t3.get("pageFormatter"), w3 = c3.pageIndex, M = w3 != null ? w3 + 1 : 0, I = c3.pageCount;
        g3 && b3 && g3.setStyle("text", Ha(b3) ? b3.replace("{current}", M == null ? "" : M + "").replace("{total}", I == null ? "" : I + "") : b3({ current: M, total: I }));
      }, i.prototype._getPageInfo = function(t3) {
        var c3 = t3.get("scrollDataIndex", true), p3 = this.getContentGroup(), g3 = this._containerGroup.__rectSize, b3 = t3.getOrient().index, w3 = a1e[b3], M = o1e[b3], I = this._findTargetItemIndex(c3), k3 = p3.children(), L = k3[I], F = k3.length, B = F ? 1 : 0, G = { contentPosition: [p3.x, p3.y], pageCount: B, pageIndex: B - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
        if (!L)
          return G;
        var J = de(L);
        G.contentPosition[b3] = -J.s;
        for (var Q = I + 1, se = J, he = J, be = null; Q <= F; ++Q)
          be = de(k3[Q]), (!be && he.e > se.s + g3 || be && !Fe(be, se.s)) && (he.i > se.i ? se = he : se = be, se && (G.pageNextDataIndex == null && (G.pageNextDataIndex = se.i), ++G.pageCount)), he = be;
        for (var Q = I - 1, se = J, he = J, be = null; Q >= -1; --Q)
          be = de(k3[Q]), (!be || !Fe(he, be.s)) && se.i < he.i && (he = se, G.pagePrevDataIndex == null && (G.pagePrevDataIndex = se.i), ++G.pageCount, ++G.pageIndex), se = be;
        return G;
        function de(Pe) {
          if (Pe) {
            var ze = Pe.getBoundingRect(), $e = ze[M] + Pe[M];
            return { s: $e, e: $e + ze[w3], i: Pe.__legendDataIndex };
          }
        }
        function Fe(Pe, ze) {
          return Pe.e >= ze && Pe.s <= ze + g3;
        }
      }, i.prototype._findTargetItemIndex = function(t3) {
        if (!this._showController)
          return 0;
        var c3, p3 = this.getContentGroup(), g3;
        return p3.eachChild(function(b3, w3) {
          var M = b3.__legendDataIndex;
          g3 == null && M != null && (g3 = w3), M === t3 && (c3 = w3);
        }), c3 != null ? c3 : g3;
      }, i.type = "legend.scroll", i;
    }(KVe), Jkt = Zkt;
    function Qkt(o) {
      o.registerAction("legendScroll", "legendscroll", function(i, t3) {
        var c3 = i.scrollDataIndex;
        c3 != null && t3.eachComponent({ mainType: "legend", subType: "scroll", query: i }, function(p3) {
          p3.setScrollDataIndex(c3);
        });
      });
    }
    function e3t(o) {
      Tl(ZVe), o.registerComponentModel(Kkt), o.registerComponentView(Jkt), Qkt(o);
    }
    function t3t(o) {
      Tl(ZVe), Tl(e3t);
    }
    var n3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "dataZoom.inside", i.defaultOption = rk(kW.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), i;
    }(kW), r3t = n3t, s1e = mu();
    function i3t(o, i, t3) {
      s1e(o).coordSysRecordMap.each(function(c3) {
        var p3 = c3.dataZoomInfoMap.get(i.uid);
        p3 && (p3.getRange = t3);
      });
    }
    function a3t(o, i) {
      for (var t3 = s1e(o).coordSysRecordMap, c3 = t3.keys(), p3 = 0; p3 < c3.length; p3++) {
        var g3 = c3[p3], b3 = t3.get(g3), w3 = b3.dataZoomInfoMap;
        if (w3) {
          var M = i.uid, I = w3.get(M);
          I && (w3.removeKey(M), w3.keys().length || eBe(t3, b3));
        }
      }
    }
    function eBe(o, i) {
      if (i) {
        o.removeKey(i.model.uid);
        var t3 = i.controller;
        t3 && t3.dispose();
      }
    }
    function o3t(o, i) {
      var t3 = { model: i, containsPoint: As(l3t, i), dispatchAction: As(s3t, o), dataZoomInfoMap: null, controller: null }, c3 = t3.controller = new dW(o.getZr());
      return yt(["pan", "zoom", "scrollMove"], function(p3) {
        c3.on(p3, function(g3) {
          var b3 = [];
          t3.dataZoomInfoMap.each(function(w3) {
            if (g3.isAvailableBehavior(w3.model.option)) {
              var M = (w3.getRange || {})[p3], I = M && M(w3.dzReferCoordSysInfo, t3.model.mainType, t3.controller, g3);
              !w3.model.get("disabled", true) && I && b3.push({ dataZoomId: w3.model.id, start: I[0], end: I[1] });
            }
          }), b3.length && t3.dispatchAction(b3);
        });
      }), t3;
    }
    function s3t(o, i) {
      o.isDisposed() || o.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: i });
    }
    function l3t(o, i, t3, c3) {
      return o.coordinateSystem.containPoint([t3, c3]);
    }
    function u3t(o) {
      var i, t3 = "type_", c3 = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, p3 = true;
      return o.each(function(g3) {
        var b3 = g3.model, w3 = b3.get("disabled", true) ? false : b3.get("zoomLock", true) ? "move" : true;
        c3[t3 + w3] > c3[t3 + i] && (i = w3), p3 = p3 && b3.get("preventDefaultMouseMove", true);
      }), { controlType: i, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!p3 } };
    }
    function c3t(o) {
      o.registerProcessor(o.PRIORITY.PROCESSOR.FILTER, function(i, t3) {
        var c3 = s1e(t3), p3 = c3.coordSysRecordMap || (c3.coordSysRecordMap = Eo());
        p3.each(function(g3) {
          g3.dataZoomInfoMap = null;
        }), i.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(g3) {
          var b3 = K7e(g3);
          yt(b3.infoList, function(w3) {
            var M = w3.model.uid, I = p3.get(M) || p3.set(M, o3t(t3, w3.model)), k3 = I.dataZoomInfoMap || (I.dataZoomInfoMap = Eo());
            k3.set(g3.uid, { dzReferCoordSysInfo: w3, model: g3, getRange: null });
          });
        }), p3.each(function(g3) {
          var b3 = g3.controller, w3, M = g3.dataZoomInfoMap;
          if (M) {
            var I = M.keys()[0];
            I != null && (w3 = M.get(I));
          }
          if (!w3) {
            eBe(p3, g3);
            return;
          }
          var k3 = u3t(M);
          b3.enable(k3.controlType, k3.opt), b3.setPointerChecker(g3.containsPoint), M8(g3, "dispatchAction", w3.model.get("throttle", true), "fixRate");
        });
      });
    }
    var f3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "dataZoom.inside", t3;
      }
      return i.prototype.render = function(t3, c3, p3) {
        if (o.prototype.render.apply(this, arguments), t3.noTarget()) {
          this._clear();
          return;
        }
        this.range = t3.getPercentRange(), i3t(p3, t3, { pan: Qa(l1e.pan, this), zoom: Qa(l1e.zoom, this), scrollMove: Qa(l1e.scrollMove, this) });
      }, i.prototype.dispose = function() {
        this._clear(), o.prototype.dispose.apply(this, arguments);
      }, i.prototype._clear = function() {
        a3t(this.api, this.dataZoomModel), this.range = null;
      }, i.type = "dataZoom.inside", i;
    }(Rme), l1e = { zoom: function(o, i, t3, c3) {
      var p3 = this.range, g3 = p3.slice(), b3 = o.axisModels[0];
      if (b3) {
        var w3 = u1e[i](null, [c3.originX, c3.originY], b3, t3, o), M = (w3.signal > 0 ? w3.pixelStart + w3.pixelLength - w3.pixel : w3.pixel - w3.pixelStart) / w3.pixelLength * (g3[1] - g3[0]) + g3[0], I = Math.max(1 / c3.scale, 0);
        g3[0] = (g3[0] - M) * I + M, g3[1] = (g3[1] - M) * I + M;
        var k3 = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
        if (ML(0, g3, [0, 100], 0, k3.minSpan, k3.maxSpan), this.range = g3, p3[0] !== g3[0] || p3[1] !== g3[1])
          return g3;
      }
    }, pan: tBe(function(o, i, t3, c3, p3, g3) {
      var b3 = u1e[c3]([g3.oldX, g3.oldY], [g3.newX, g3.newY], i, p3, t3);
      return b3.signal * (o[1] - o[0]) * b3.pixel / b3.pixelLength;
    }), scrollMove: tBe(function(o, i, t3, c3, p3, g3) {
      var b3 = u1e[c3]([0, 0], [g3.scrollDelta, g3.scrollDelta], i, p3, t3);
      return b3.signal * (o[1] - o[0]) * g3.scrollDelta;
    }) };
    function tBe(o) {
      return function(i, t3, c3, p3) {
        var g3 = this.range, b3 = g3.slice(), w3 = i.axisModels[0];
        if (w3) {
          var M = o(b3, w3, i, t3, c3, p3);
          if (ML(M, b3, [0, 100], "all"), this.range = b3, g3[0] !== b3[0] || g3[1] !== b3[1])
            return b3;
        }
      };
    }
    var u1e = { grid: function(o, i, t3, c3, p3) {
      var g3 = t3.axis, b3 = {}, w3 = p3.model.coordinateSystem.getRect();
      return o = o || [0, 0], g3.dim === "x" ? (b3.pixel = i[0] - o[0], b3.pixelLength = w3.width, b3.pixelStart = w3.x, b3.signal = g3.inverse ? 1 : -1) : (b3.pixel = i[1] - o[1], b3.pixelLength = w3.height, b3.pixelStart = w3.y, b3.signal = g3.inverse ? -1 : 1), b3;
    }, polar: function(o, i, t3, c3, p3) {
      var g3 = t3.axis, b3 = {}, w3 = p3.model.coordinateSystem, M = w3.getRadiusAxis().getExtent(), I = w3.getAngleAxis().getExtent();
      return o = o ? w3.pointToCoord(o) : [0, 0], i = w3.pointToCoord(i), t3.mainType === "radiusAxis" ? (b3.pixel = i[0] - o[0], b3.pixelLength = M[1] - M[0], b3.pixelStart = M[0], b3.signal = g3.inverse ? 1 : -1) : (b3.pixel = i[1] - o[1], b3.pixelLength = I[1] - I[0], b3.pixelStart = I[0], b3.signal = g3.inverse ? -1 : 1), b3;
    }, singleAxis: function(o, i, t3, c3, p3) {
      var g3 = t3.axis, b3 = p3.model.coordinateSystem.getRect(), w3 = {};
      return o = o || [0, 0], g3.orient === "horizontal" ? (w3.pixel = i[0] - o[0], w3.pixelLength = b3.width, w3.pixelStart = b3.x, w3.signal = g3.inverse ? 1 : -1) : (w3.pixel = i[1] - o[1], w3.pixelLength = b3.height, w3.pixelStart = b3.y, w3.signal = g3.inverse ? -1 : 1), w3;
    } }, h3t = f3t;
    function nBe(o) {
      Nme(o), o.registerComponentModel(r3t), o.registerComponentView(h3t), c3t(o);
    }
    var p3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.type = "dataZoom.slider", i.layoutMode = "box", i.defaultOption = rk(kW.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), i;
    }(kW), d3t = p3t, FW = bu, rBe = 7, v3t = 1, c1e = 30, g3t = 7, VW = "horizontal", iBe = "vertical", y3t = 5, m3t = ["line", "bar", "candlestick", "scatter"], b3t = { easing: "cubicOut", duration: 100, delay: 0 }, _3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._displayables = {}, t3;
      }
      return i.prototype.init = function(t3, c3) {
        this.api = c3, this._onBrush = Qa(this._onBrush, this), this._onBrushEnd = Qa(this._onBrushEnd, this);
      }, i.prototype.render = function(t3, c3, p3, g3) {
        if (o.prototype.render.apply(this, arguments), M8(this, "_dispatchZoomAction", t3.get("throttle"), "fixRate"), this._orient = t3.getOrient(), t3.get("show") === false) {
          this.group.removeAll();
          return;
        }
        if (t3.noTarget()) {
          this._clear(), this.group.removeAll();
          return;
        }
        (!g3 || g3.type !== "dataZoom" || g3.from !== this.uid) && this._buildView(), this._updateView();
      }, i.prototype.dispose = function() {
        this._clear(), o.prototype.dispose.apply(this, arguments);
      }, i.prototype._clear = function() {
        NH(this, "_dispatchZoomAction");
        var t3 = this.api.getZr();
        t3.off("mousemove", this._onBrush), t3.off("mouseup", this._onBrushEnd);
      }, i.prototype._buildView = function() {
        var t3 = this.group;
        t3.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
        var c3 = this._displayables.sliderGroup = new vs();
        this._renderBackground(), this._renderHandle(), this._renderDataShadow(), t3.add(c3), this._positionGroup();
      }, i.prototype._resetLocation = function() {
        var t3 = this.dataZoomModel, c3 = this.api, p3 = t3.get("brushSelect"), g3 = p3 ? g3t : 0, b3 = this._findCoordRect(), w3 = { width: c3.getWidth(), height: c3.getHeight() }, M = this._orient === VW ? { right: w3.width - b3.x - b3.width, top: w3.height - c1e - rBe - g3, width: b3.width, height: c1e } : { right: rBe, top: b3.y, width: c1e, height: b3.height }, I = m8(t3.option);
        yt(["right", "top", "width", "height"], function(L) {
          I[L] === "ph" && (I[L] = M[L]);
        });
        var k3 = Wv(I, w3);
        this._location = { x: k3.x, y: k3.y }, this._size = [k3.width, k3.height], this._orient === iBe && this._size.reverse();
      }, i.prototype._positionGroup = function() {
        var t3 = this.group, c3 = this._location, p3 = this._orient, g3 = this.dataZoomModel.getFirstTargetAxisModel(), b3 = g3 && g3.get("inverse"), w3 = this._displayables.sliderGroup, M = (this._dataShadowInfo || {}).otherAxisInverse;
        w3.attr(p3 === VW && !b3 ? { scaleY: M ? 1 : -1, scaleX: 1 } : p3 === VW && b3 ? { scaleY: M ? 1 : -1, scaleX: -1 } : p3 === iBe && !b3 ? { scaleY: M ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: M ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
        var I = t3.getBoundingRect([w3]);
        t3.x = c3.x - I.x, t3.y = c3.y - I.y, t3.markRedraw();
      }, i.prototype._getViewExtent = function() {
        return [0, this._size[0]];
      }, i.prototype._renderBackground = function() {
        var t3 = this.dataZoomModel, c3 = this._size, p3 = this._displayables.sliderGroup, g3 = t3.get("brushSelect");
        p3.add(new FW({ silent: true, shape: { x: 0, y: 0, width: c3[0], height: c3[1] }, style: { fill: t3.get("backgroundColor") }, z2: -40 }));
        var b3 = new FW({ shape: { x: 0, y: 0, width: c3[0], height: c3[1] }, style: { fill: "transparent" }, z2: 0, onclick: Qa(this._onClickPanel, this) }), w3 = this.api.getZr();
        g3 ? (b3.on("mousedown", this._onBrushStart, this), b3.cursor = "crosshair", w3.on("mousemove", this._onBrush), w3.on("mouseup", this._onBrushEnd)) : (w3.off("mousemove", this._onBrush), w3.off("mouseup", this._onBrushEnd)), p3.add(b3);
      }, i.prototype._renderDataShadow = function() {
        var t3 = this._dataShadowInfo = this._prepareDataShadowInfo();
        if (this._displayables.dataShadowSegs = [], !t3)
          return;
        var c3 = this._size, p3 = this._shadowSize || [], g3 = t3.series, b3 = g3.getRawData(), w3 = g3.getShadowDim ? g3.getShadowDim() : t3.otherDim;
        if (w3 == null)
          return;
        var M = this._shadowPolygonPts, I = this._shadowPolylinePts;
        if (b3 !== this._shadowData || w3 !== this._shadowDim || c3[0] !== p3[0] || c3[1] !== p3[1]) {
          var k3 = b3.getDataExtent(w3), L = (k3[1] - k3[0]) * 0.3;
          k3 = [k3[0] - L, k3[1] + L];
          var F = [0, c3[1]], B = [0, c3[0]], G = [[c3[0], 0], [0, 0]], J = [], Q = B[1] / (b3.count() - 1), se = 0, he = Math.round(b3.count() / c3[0]), be;
          b3.each([w3], function($e, Ke) {
            if (he > 0 && Ke % he) {
              se += Q;
              return;
            }
            var nt = $e == null || isNaN($e) || $e === "", lt2 = nt ? 0 : Bc($e, k3, F, true);
            nt && !be && Ke ? (G.push([G[G.length - 1][0], 0]), J.push([J[J.length - 1][0], 0])) : !nt && be && (G.push([se, 0]), J.push([se, 0])), G.push([se, lt2]), J.push([se, lt2]), se += Q, be = nt;
          }), M = this._shadowPolygonPts = G, I = this._shadowPolylinePts = J;
        }
        this._shadowData = b3, this._shadowDim = w3, this._shadowSize = [c3[0], c3[1]];
        var de = this.dataZoomModel;
        function Fe($e) {
          var Ke = de.getModel($e ? "selectedDataBackground" : "dataBackground"), nt = new vs(), lt2 = new _m({ shape: { points: M }, segmentIgnoreThreshold: 1, style: Ke.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), bt = new xm({ shape: { points: I }, segmentIgnoreThreshold: 1, style: Ke.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
          return nt.add(lt2), nt.add(bt), nt;
        }
        for (var Pe = 0; Pe < 3; Pe++) {
          var ze = Fe(Pe === 1);
          this._displayables.sliderGroup.add(ze), this._displayables.dataShadowSegs.push(ze);
        }
      }, i.prototype._prepareDataShadowInfo = function() {
        var t3 = this.dataZoomModel, c3 = t3.get("showDataShadow");
        if (c3 !== false) {
          var p3, g3 = this.ecModel;
          return t3.eachTargetAxis(function(b3, w3) {
            var M = t3.getAxisProxy(b3, w3).getTargetSeriesModels();
            yt(M, function(I) {
              if (!p3 && !(c3 !== true && rl(m3t, I.get("type")) < 0)) {
                var k3 = g3.getComponent(_k(b3), w3).axis, L = x3t(b3), F, B = I.coordinateSystem;
                L != null && B.getOtherAxis && (F = B.getOtherAxis(k3).inverse), L = I.getData().mapDimension(L), p3 = { thisAxis: k3, series: I, thisDim: b3, otherDim: L, otherAxisInverse: F };
              }
            }, this);
          }, this), p3;
        }
      }, i.prototype._renderHandle = function() {
        var t3 = this.group, c3 = this._displayables, p3 = c3.handles = [null, null], g3 = c3.handleLabels = [null, null], b3 = this._displayables.sliderGroup, w3 = this._size, M = this.dataZoomModel, I = this.api, k3 = M.get("borderRadius") || 0, L = M.get("brushSelect"), F = c3.filler = new FW({ silent: L, style: { fill: M.get("fillerColor") }, textConfig: { position: "inside" } });
        b3.add(F), b3.add(new FW({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: w3[0], height: w3[1], r: k3 }, style: { stroke: M.get("dataBackgroundColor") || M.get("borderColor"), lineWidth: v3t, fill: "rgba(0,0,0,0)" } })), yt([0, 1], function(be) {
          var de = M.get("handleIcon");
          !Ate[de] && de.indexOf("path://") < 0 && de.indexOf("image://") < 0 && (de = "path://" + de);
          var Fe = pv(de, -1, 0, 2, 2, null, true);
          Fe.attr({ cursor: aBe(this._orient), draggable: true, drift: Qa(this._onDragMove, this, be), ondragend: Qa(this._onDragEnd, this), onmouseover: Qa(this._showDataInfo, this, true), onmouseout: Qa(this._showDataInfo, this, false), z2: 5 });
          var Pe = Fe.getBoundingRect(), ze = M.get("handleSize");
          this._handleHeight = Da(ze, this._size[1]), this._handleWidth = Pe.width / Pe.height * this._handleHeight, Fe.setStyle(M.getModel("handleStyle").getItemStyle()), Fe.style.strokeNoScale = true, Fe.rectHover = true, Fe.ensureState("emphasis").style = M.getModel(["emphasis", "handleStyle"]).getItemStyle(), II(Fe);
          var $e = M.get("handleColor");
          $e != null && (Fe.style.fill = $e), b3.add(p3[be] = Fe);
          var Ke = M.getModel("textStyle");
          t3.add(g3[be] = new Fl({ silent: true, invisible: true, style: qd(Ke, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: Ke.getTextColor(), font: Ke.getFont() }), z2: 10 }));
        }, this);
        var B = F;
        if (L) {
          var G = Da(M.get("moveHandleSize"), w3[1]), J = c3.moveHandle = new bu({ style: M.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: w3[1] - 0.5, height: G } }), Q = G * 0.8, se = c3.moveHandleIcon = pv(M.get("moveHandleIcon"), -Q / 2, -Q / 2, Q, Q, "#fff", true);
          se.silent = true, se.y = w3[1] + G / 2 - 0.5, J.ensureState("emphasis").style = M.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
          var he = Math.min(w3[1] / 2, Math.max(G, 10));
          B = c3.moveZone = new bu({ invisible: true, shape: { y: w3[1] - he, height: G + he } }), B.on("mouseover", function() {
            I.enterEmphasis(J);
          }).on("mouseout", function() {
            I.leaveEmphasis(J);
          }), b3.add(J), b3.add(se), b3.add(B);
        }
        B.attr({ draggable: true, cursor: aBe(this._orient), drift: Qa(this._onDragMove, this, "all"), ondragstart: Qa(this._showDataInfo, this, true), ondragend: Qa(this._onDragEnd, this), onmouseover: Qa(this._showDataInfo, this, true), onmouseout: Qa(this._showDataInfo, this, false) });
      }, i.prototype._resetInterval = function() {
        var t3 = this._range = this.dataZoomModel.getPercentRange(), c3 = this._getViewExtent();
        this._handleEnds = [Bc(t3[0], [0, 100], c3, true), Bc(t3[1], [0, 100], c3, true)];
      }, i.prototype._updateInterval = function(t3, c3) {
        var p3 = this.dataZoomModel, g3 = this._handleEnds, b3 = this._getViewExtent(), w3 = p3.findRepresentativeAxisProxy().getMinMaxSpan(), M = [0, 100];
        ML(c3, g3, b3, p3.get("zoomLock") ? "all" : t3, w3.minSpan != null ? Bc(w3.minSpan, M, b3, true) : null, w3.maxSpan != null ? Bc(w3.maxSpan, M, b3, true) : null);
        var I = this._range, k3 = this._range = dy([Bc(g3[0], b3, M, true), Bc(g3[1], b3, M, true)]);
        return !I || I[0] !== k3[0] || I[1] !== k3[1];
      }, i.prototype._updateView = function(t3) {
        var c3 = this._displayables, p3 = this._handleEnds, g3 = dy(p3.slice()), b3 = this._size;
        yt([0, 1], function(B) {
          var G = c3.handles[B], J = this._handleHeight;
          G.attr({ scaleX: J / 2, scaleY: J / 2, x: p3[B] + (B ? -1 : 1), y: b3[1] / 2 - J / 2 });
        }, this), c3.filler.setShape({ x: g3[0], y: 0, width: g3[1] - g3[0], height: b3[1] });
        var w3 = { x: g3[0], width: g3[1] - g3[0] };
        c3.moveHandle && (c3.moveHandle.setShape(w3), c3.moveZone.setShape(w3), c3.moveZone.getBoundingRect(), c3.moveHandleIcon && c3.moveHandleIcon.attr("x", w3.x + w3.width / 2));
        for (var M = c3.dataShadowSegs, I = [0, g3[0], g3[1], b3[0]], k3 = 0; k3 < M.length; k3++) {
          var L = M[k3], F = L.getClipPath();
          F || (F = new bu(), L.setClipPath(F)), F.setShape({ x: I[k3], y: 0, width: I[k3 + 1] - I[k3], height: b3[1] });
        }
        this._updateDataInfo(t3);
      }, i.prototype._updateDataInfo = function(t3) {
        var c3 = this.dataZoomModel, p3 = this._displayables, g3 = p3.handleLabels, b3 = this._orient, w3 = ["", ""];
        if (c3.get("showDetail")) {
          var M = c3.findRepresentativeAxisProxy();
          if (M) {
            var I = M.getAxisModel().axis, k3 = this._range, L = t3 ? M.calculateDataWindow({ start: k3[0], end: k3[1] }).valueWindow : M.getDataValueWindow();
            w3 = [this._formatLabel(L[0], I), this._formatLabel(L[1], I)];
          }
        }
        var F = dy(this._handleEnds.slice());
        B.call(this, 0), B.call(this, 1);
        function B(G) {
          var J = Ls(p3.handles[G].parent, this.group), Q = Hs(G === 0 ? "right" : "left", J), se = this._handleWidth / 2 + y3t, he = ll([F[G] + (G === 0 ? -se : se), this._size[1] / 2], J);
          g3[G].setStyle({ x: he[0], y: he[1], verticalAlign: b3 === VW ? "middle" : Q, align: b3 === VW ? Q : "center", text: w3[G] });
        }
      }, i.prototype._formatLabel = function(t3, c3) {
        var p3 = this.dataZoomModel, g3 = p3.get("labelFormatter"), b3 = p3.get("labelPrecision");
        (b3 == null || b3 === "auto") && (b3 = c3.getPixelPrecision());
        var w3 = t3 == null || isNaN(t3) ? "" : c3.type === "category" || c3.type === "time" ? c3.scale.getLabel({ value: Math.round(t3) }) : t3.toFixed(Math.min(b3, 20));
        return Vo(g3) ? g3(t3, w3) : Ha(g3) ? g3.replace("{value}", w3) : w3;
      }, i.prototype._showDataInfo = function(t3) {
        t3 = this._dragging || t3;
        var c3 = this._displayables, p3 = c3.handleLabels;
        p3[0].attr("invisible", !t3), p3[1].attr("invisible", !t3), c3.moveHandle && this.api[t3 ? "enterEmphasis" : "leaveEmphasis"](c3.moveHandle, 1);
      }, i.prototype._onDragMove = function(t3, c3, p3, g3) {
        this._dragging = true, R2(g3.event);
        var b3 = this._displayables.sliderGroup.getLocalTransform(), w3 = ll([c3, p3], b3, true), M = this._updateInterval(t3, w3[0]), I = this.dataZoomModel.get("realtime");
        this._updateView(!I), M && I && this._dispatchZoomAction(true);
      }, i.prototype._onDragEnd = function() {
        this._dragging = false, this._showDataInfo(false);
        var t3 = this.dataZoomModel.get("realtime");
        !t3 && this._dispatchZoomAction(false);
      }, i.prototype._onClickPanel = function(t3) {
        var c3 = this._size, p3 = this._displayables.sliderGroup.transformCoordToLocal(t3.offsetX, t3.offsetY);
        if (!(p3[0] < 0 || p3[0] > c3[0] || p3[1] < 0 || p3[1] > c3[1])) {
          var g3 = this._handleEnds, b3 = (g3[0] + g3[1]) / 2, w3 = this._updateInterval("all", p3[0] - b3);
          this._updateView(), w3 && this._dispatchZoomAction(false);
        }
      }, i.prototype._onBrushStart = function(t3) {
        var c3 = t3.offsetX, p3 = t3.offsetY;
        this._brushStart = new Bs(c3, p3), this._brushing = true, this._brushStartTime = +new Date();
      }, i.prototype._onBrushEnd = function(t3) {
        if (this._brushing) {
          var c3 = this._displayables.brushRect;
          if (this._brushing = false, !!c3) {
            c3.attr("ignore", true);
            var p3 = c3.shape, g3 = +new Date();
            if (!(g3 - this._brushStartTime < 200 && Math.abs(p3.width) < 5)) {
              var b3 = this._getViewExtent(), w3 = [0, 100];
              this._range = dy([Bc(p3.x, b3, w3, true), Bc(p3.x + p3.width, b3, w3, true)]), this._handleEnds = [p3.x, p3.x + p3.width], this._updateView(), this._dispatchZoomAction(false);
            }
          }
        }
      }, i.prototype._onBrush = function(t3) {
        this._brushing && (R2(t3.event), this._updateBrushRect(t3.offsetX, t3.offsetY));
      }, i.prototype._updateBrushRect = function(t3, c3) {
        var p3 = this._displayables, g3 = this.dataZoomModel, b3 = p3.brushRect;
        b3 || (b3 = p3.brushRect = new FW({ silent: true, style: g3.getModel("brushStyle").getItemStyle() }), p3.sliderGroup.add(b3)), b3.attr("ignore", false);
        var w3 = this._brushStart, M = this._displayables.sliderGroup, I = M.transformCoordToLocal(t3, c3), k3 = M.transformCoordToLocal(w3.x, w3.y), L = this._size;
        I[0] = Math.max(Math.min(L[0], I[0]), 0), b3.setShape({ x: k3[0], y: 0, width: I[0] - k3[0], height: L[1] });
      }, i.prototype._dispatchZoomAction = function(t3) {
        var c3 = this._range;
        this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: t3 ? b3t : null, start: c3[0], end: c3[1] });
      }, i.prototype._findCoordRect = function() {
        var t3, c3 = K7e(this.dataZoomModel).infoList;
        if (!t3 && c3.length) {
          var p3 = c3[0].model.coordinateSystem;
          t3 = p3.getRect && p3.getRect();
        }
        if (!t3) {
          var g3 = this.api.getWidth(), b3 = this.api.getHeight();
          t3 = { x: g3 * 0.2, y: b3 * 0.2, width: g3 * 0.6, height: b3 * 0.6 };
        }
        return t3;
      }, i.type = "dataZoom.slider", i;
    }(Rme);
    function x3t(o) {
      var i = { x: "y", y: "x", radius: "angle", angle: "radius" };
      return i[o];
    }
    function aBe(o) {
      return o === "vertical" ? "ns-resize" : "ew-resize";
    }
    var w3t = _3t;
    function oBe(o) {
      o.registerComponentModel(d3t), o.registerComponentView(w3t), Nme(o);
    }
    function S3t(o) {
      Tl(nBe), Tl(oBe);
    }
    var C3t = { get: function(o, i, t3) {
      var c3 = Jo((M3t[o] || {})[i]);
      return t3 && Ei(c3) ? c3[c3.length - 1] : c3;
    } }, M3t = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, sBe = C3t, lBe = wy.mapVisual, T3t = wy.eachVisual, A3t = Ei, uBe = yt, I3t = dy, E3t = Bc, D3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.stateList = ["inRange", "outOfRange"], t3.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], t3.layoutMode = { type: "box", ignoreSize: true }, t3.dataBound = [-1 / 0, 1 / 0], t3.targetVisuals = {}, t3.controllerVisuals = {}, t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        this.mergeDefaultAndTheme(t3, p3);
      }, i.prototype.optionUpdated = function(t3, c3) {
        var p3 = this.option;
        !c3 && TVe(p3, t3, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
      }, i.prototype.resetVisual = function(t3) {
        var c3 = this.stateList;
        t3 = Qa(t3, this), this.controllerVisuals = Ume(this.option.controller, c3, t3), this.targetVisuals = Ume(this.option.target, c3, t3);
      }, i.prototype.getItemSymbol = function() {
        return null;
      }, i.prototype.getTargetSeriesIndices = function() {
        var t3 = this.option.seriesIndex, c3 = [];
        return t3 == null || t3 === "all" ? this.ecModel.eachSeries(function(p3, g3) {
          c3.push(g3);
        }) : c3 = Wc(t3), c3;
      }, i.prototype.eachTargetSeries = function(t3, c3) {
        yt(this.getTargetSeriesIndices(), function(p3) {
          var g3 = this.ecModel.getSeriesByIndex(p3);
          g3 && t3.call(c3, g3);
        }, this);
      }, i.prototype.isTargetSeries = function(t3) {
        var c3 = false;
        return this.eachTargetSeries(function(p3) {
          p3 === t3 && (c3 = true);
        }), c3;
      }, i.prototype.formatValueText = function(t3, c3, p3) {
        var g3 = this.option, b3 = g3.precision, w3 = this.dataBound, M = g3.formatter, I;
        p3 = p3 || ["<", ">"], Ei(t3) && (t3 = t3.slice(), I = true);
        var k3 = c3 ? t3 : I ? [L(t3[0]), L(t3[1])] : L(t3);
        if (Ha(M))
          return M.replace("{value}", I ? k3[0] : k3).replace("{value2}", I ? k3[1] : k3);
        if (Vo(M))
          return I ? M(t3[0], t3[1]) : M(t3);
        if (I)
          return t3[0] === w3[0] ? p3[0] + " " + k3[1] : t3[1] === w3[1] ? p3[1] + " " + k3[0] : k3[0] + " - " + k3[1];
        return k3;
        function L(F) {
          return F === w3[0] ? "min" : F === w3[1] ? "max" : (+F).toFixed(Math.min(b3, 20));
        }
      }, i.prototype.resetExtent = function() {
        var t3 = this.option, c3 = I3t([t3.min, t3.max]);
        this._dataExtent = c3;
      }, i.prototype.getDataDimensionIndex = function(t3) {
        var c3 = this.option.dimension;
        if (c3 != null)
          return t3.getDimensionIndex(c3);
        for (var p3 = t3.dimensions, g3 = p3.length - 1; g3 >= 0; g3--) {
          var b3 = p3[g3], w3 = t3.getDimensionInfo(b3);
          if (!w3.isCalculationCoord)
            return w3.storeDimIndex;
        }
      }, i.prototype.getExtent = function() {
        return this._dataExtent.slice();
      }, i.prototype.completeVisualOption = function() {
        var t3 = this.ecModel, c3 = this.option, p3 = { inRange: c3.inRange, outOfRange: c3.outOfRange }, g3 = c3.target || (c3.target = {}), b3 = c3.controller || (c3.controller = {});
        Es(g3, p3), Es(b3, p3);
        var w3 = this.isCategory();
        M.call(this, g3), M.call(this, b3), I.call(this, g3, "inRange", "outOfRange"), k3.call(this, b3);
        function M(L) {
          A3t(c3.color) && !L.inRange && (L.inRange = { color: c3.color.slice().reverse() }), L.inRange = L.inRange || { color: t3.get("gradientColor") };
        }
        function I(L, F, B) {
          var G = L[F], J = L[B];
          G && !J && (J = L[B] = {}, uBe(G, function(Q, se) {
            if (wy.isValidType(se)) {
              var he = sBe.get(se, "inactive", w3);
              he != null && (J[se] = he, se === "color" && !J.hasOwnProperty("opacity") && !J.hasOwnProperty("colorAlpha") && (J.opacity = [0, 0]));
            }
          }));
        }
        function k3(L) {
          var F = (L.inRange || {}).symbol || (L.outOfRange || {}).symbol, B = (L.inRange || {}).symbolSize || (L.outOfRange || {}).symbolSize, G = this.get("inactiveColor"), J = this.getItemSymbol(), Q = J || "roundRect";
          uBe(this.stateList, function(se) {
            var he = this.itemSize, be = L[se];
            be || (be = L[se] = { color: w3 ? G : [G] }), be.symbol == null && (be.symbol = F && Jo(F) || (w3 ? Q : [Q])), be.symbolSize == null && (be.symbolSize = B && Jo(B) || (w3 ? he[0] : [he[0], he[0]])), be.symbol = lBe(be.symbol, function(Pe) {
              return Pe === "none" ? Q : Pe;
            });
            var de = be.symbolSize;
            if (de != null) {
              var Fe = -1 / 0;
              T3t(de, function(Pe) {
                Pe > Fe && (Fe = Pe);
              }), be.symbolSize = lBe(de, function(Pe) {
                return E3t(Pe, [0, Fe], [0, he[0]], true);
              });
            }
          }, this);
        }
      }, i.prototype.resetItemSize = function() {
        this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
      }, i.prototype.isCategory = function() {
        return !!this.option.categories;
      }, i.prototype.setSelected = function(t3) {
      }, i.prototype.getSelected = function() {
        return null;
      }, i.prototype.getValueState = function(t3) {
        return null;
      }, i.prototype.getVisualMeta = function(t3) {
        return null;
      }, i.type = "visualMap", i.dependencies = ["series"], i.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, i;
    }(nc), Kne = D3t, cBe = [20, 140], k3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.optionUpdated = function(t3, c3) {
        o.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(p3) {
          p3.mappingMethod = "linear", p3.dataExtent = this.getExtent();
        }), this._resetRange();
      }, i.prototype.resetItemSize = function() {
        o.prototype.resetItemSize.apply(this, arguments);
        var t3 = this.itemSize;
        (t3[0] == null || isNaN(t3[0])) && (t3[0] = cBe[0]), (t3[1] == null || isNaN(t3[1])) && (t3[1] = cBe[1]);
      }, i.prototype._resetRange = function() {
        var t3 = this.getExtent(), c3 = this.option.range;
        !c3 || c3.auto ? (t3.auto = 1, this.option.range = t3) : Ei(c3) && (c3[0] > c3[1] && c3.reverse(), c3[0] = Math.max(c3[0], t3[0]), c3[1] = Math.min(c3[1], t3[1]));
      }, i.prototype.completeVisualOption = function() {
        o.prototype.completeVisualOption.apply(this, arguments), yt(this.stateList, function(t3) {
          var c3 = this.option.controller[t3].symbolSize;
          c3 && c3[0] !== c3[1] && (c3[0] = c3[1] / 3);
        }, this);
      }, i.prototype.setSelected = function(t3) {
        this.option.range = t3.slice(), this._resetRange();
      }, i.prototype.getSelected = function() {
        var t3 = this.getExtent(), c3 = dy((this.get("range") || []).slice());
        return c3[0] > t3[1] && (c3[0] = t3[1]), c3[1] > t3[1] && (c3[1] = t3[1]), c3[0] < t3[0] && (c3[0] = t3[0]), c3[1] < t3[0] && (c3[1] = t3[0]), c3;
      }, i.prototype.getValueState = function(t3) {
        var c3 = this.option.range, p3 = this.getExtent();
        return (c3[0] <= p3[0] || c3[0] <= t3) && (c3[1] >= p3[1] || t3 <= c3[1]) ? "inRange" : "outOfRange";
      }, i.prototype.findTargetDataIndices = function(t3) {
        var c3 = [];
        return this.eachTargetSeries(function(p3) {
          var g3 = [], b3 = p3.getData();
          b3.each(this.getDataDimensionIndex(b3), function(w3, M) {
            t3[0] <= w3 && w3 <= t3[1] && g3.push(M);
          }, this), c3.push({ seriesId: p3.id, dataIndex: g3 });
        }, this), c3;
      }, i.prototype.getVisualMeta = function(t3) {
        var c3 = fBe(this, "outOfRange", this.getExtent()), p3 = fBe(this, "inRange", this.option.range.slice()), g3 = [];
        function b3(B, G) {
          g3.push({ value: B, color: t3(B, G) });
        }
        for (var w3 = 0, M = 0, I = p3.length, k3 = c3.length; M < k3 && (!p3.length || c3[M] <= p3[0]); M++)
          c3[M] < p3[w3] && b3(c3[M], "outOfRange");
        for (var L = 1; w3 < I; w3++, L = 0)
          L && g3.length && b3(p3[w3], "outOfRange"), b3(p3[w3], "inRange");
        for (var L = 1; M < k3; M++)
          (!p3.length || p3[p3.length - 1] < c3[M]) && (L && (g3.length && b3(g3[g3.length - 1].value, "outOfRange"), L = 0), b3(c3[M], "outOfRange"));
        var F = g3.length;
        return { stops: g3, outerColors: [F ? g3[0].color : "transparent", F ? g3[F - 1].color : "transparent"] };
      }, i.type = "visualMap.continuous", i.defaultOption = rk(Kne.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), i;
    }(Kne);
    function fBe(o, i, t3) {
      if (t3[0] === t3[1])
        return t3.slice();
      for (var c3 = 200, p3 = (t3[1] - t3[0]) / c3, g3 = t3[0], b3 = [], w3 = 0; w3 <= c3 && g3 < t3[1]; w3++)
        b3.push(g3), g3 += p3;
      return b3.push(t3[1]), b3;
    }
    var O3t = k3t, P3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, t3;
      }
      return i.prototype.init = function(t3, c3) {
        this.ecModel = t3, this.api = c3;
      }, i.prototype.render = function(t3, c3, p3, g3) {
        if (this.visualMapModel = t3, t3.get("show") === false) {
          this.group.removeAll();
          return;
        }
        this.doRender(t3, c3, p3, g3);
      }, i.prototype.renderBackground = function(t3) {
        var c3 = this.visualMapModel, p3 = y8(c3.get("padding") || 0), g3 = t3.getBoundingRect();
        t3.add(new bu({ z2: -1, silent: true, shape: { x: g3.x - p3[3], y: g3.y - p3[0], width: g3.width + p3[3] + p3[1], height: g3.height + p3[0] + p3[2] }, style: { fill: c3.get("backgroundColor"), stroke: c3.get("borderColor"), lineWidth: c3.get("borderWidth") } }));
      }, i.prototype.getControllerVisual = function(t3, c3, p3) {
        p3 = p3 || {};
        var g3 = p3.forceState, b3 = this.visualMapModel, w3 = {};
        if (c3 === "color") {
          var M = b3.get("contentColor");
          w3.color = M;
        }
        function I(B) {
          return w3[B];
        }
        function k3(B, G) {
          w3[B] = G;
        }
        var L = b3.controllerVisuals[g3 || b3.getValueState(t3)], F = wy.prepareVisualTypes(L);
        return yt(F, function(B) {
          var G = L[B];
          p3.convertOpacityToAlpha && B === "opacity" && (B = "colorAlpha", G = L.__alphaForOpacity), wy.dependsOn(B, c3) && G && G.applyVisual(t3, I, k3);
        }), w3[c3];
      }, i.prototype.positionGroup = function(t3) {
        var c3 = this.visualMapModel, p3 = this.api;
        vte(t3, c3.getBoxLayoutParams(), { width: p3.getWidth(), height: p3.getHeight() });
      }, i.prototype.doRender = function(t3, c3, p3, g3) {
      }, i.type = "visualMap", i;
    }(ed), hBe = P3t, pBe = [["left", "right", "width"], ["top", "bottom", "height"]];
    function dBe(o, i, t3) {
      var c3 = o.option, p3 = c3.align;
      if (p3 != null && p3 !== "auto")
        return p3;
      for (var g3 = { width: i.getWidth(), height: i.getHeight() }, b3 = c3.orient === "horizontal" ? 1 : 0, w3 = pBe[b3], M = [0, null, 10], I = {}, k3 = 0; k3 < 3; k3++)
        I[pBe[1 - b3][k3]] = M[k3], I[w3[k3]] = k3 === 2 ? t3[0] : c3[w3[k3]];
      var L = [["x", "width", 3], ["y", "height", 0]][b3], F = Wv(I, g3, c3.padding);
      return w3[(F.margin[L[2]] || 0) + F[L[0]] + F[L[1]] * 0.5 < g3[L[1]] * 0.5 ? 0 : 1];
    }
    function Zne(o, i) {
      return yt(o || [], function(t3) {
        t3.dataIndex != null && (t3.dataIndexInside = t3.dataIndex, t3.dataIndex = null), t3.highlightKey = "visualMap" + (i ? i.componentIndex : "");
      }), o;
    }
    var rT = Bc, L3t = yt, vBe = Math.min, f1e = Math.max, R3t = 12, N3t = 6, F3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._shapes = {}, t3._dataInterval = [], t3._handleEnds = [], t3._hoverLinkDataIndices = [], t3;
      }
      return i.prototype.doRender = function(t3, c3, p3, g3) {
        this._api = p3, (!g3 || g3.type !== "selectDataRange" || g3.from !== this.uid) && this._buildView();
      }, i.prototype._buildView = function() {
        this.group.removeAll();
        var t3 = this.visualMapModel, c3 = this.group;
        this._orient = t3.get("orient"), this._useHandle = t3.get("calculable"), this._resetInterval(), this._renderBar(c3);
        var p3 = t3.get("text");
        this._renderEndsText(c3, p3, 0), this._renderEndsText(c3, p3, 1), this._updateView(true), this.renderBackground(c3), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(c3);
      }, i.prototype._renderEndsText = function(t3, c3, p3) {
        if (c3) {
          var g3 = c3[1 - p3];
          g3 = g3 != null ? g3 + "" : "";
          var b3 = this.visualMapModel, w3 = b3.get("textGap"), M = b3.itemSize, I = this._shapes.mainGroup, k3 = this._applyTransform([M[0] / 2, p3 === 0 ? -w3 : M[1] + w3], I), L = this._applyTransform(p3 === 0 ? "bottom" : "top", I), F = this._orient, B = this.visualMapModel.textStyleModel;
          this.group.add(new Fl({ style: { x: k3[0], y: k3[1], verticalAlign: F === "horizontal" ? "middle" : L, align: F === "horizontal" ? L : "center", text: g3, font: B.getFont(), fill: B.getTextColor() } }));
        }
      }, i.prototype._renderBar = function(t3) {
        var c3 = this.visualMapModel, p3 = this._shapes, g3 = c3.itemSize, b3 = this._orient, w3 = this._useHandle, M = dBe(c3, this.api, g3), I = p3.mainGroup = this._createBarGroup(M), k3 = new vs();
        I.add(k3), k3.add(p3.outOfRange = gBe()), k3.add(p3.inRange = gBe(null, w3 ? mBe(this._orient) : null, Qa(this._dragHandle, this, "all", false), Qa(this._dragHandle, this, "all", true))), k3.setClipPath(new bu({ shape: { x: 0, y: 0, width: g3[0], height: g3[1], r: 3 } }));
        var L = c3.textStyleModel.getTextRect("\u56FD"), F = f1e(L.width, L.height);
        w3 && (p3.handleThumbs = [], p3.handleLabels = [], p3.handleLabelPoints = [], this._createHandle(c3, I, 0, g3, F, b3), this._createHandle(c3, I, 1, g3, F, b3)), this._createIndicator(c3, I, g3, F, b3), t3.add(I);
      }, i.prototype._createHandle = function(t3, c3, p3, g3, b3, w3) {
        var M = Qa(this._dragHandle, this, p3, false), I = Qa(this._dragHandle, this, p3, true), k3 = zv(t3.get("handleSize"), g3[0]), L = pv(t3.get("handleIcon"), -k3 / 2, -k3 / 2, k3, k3, null, true), F = mBe(this._orient);
        L.attr({ cursor: F, draggable: true, drift: M, ondragend: I, onmousemove: function(se) {
          R2(se.event);
        } }), L.x = g3[0] / 2, L.useStyle(t3.getModel("handleStyle").getItemStyle()), L.setStyle({ strokeNoScale: true, strokeFirst: true }), L.style.lineWidth *= 2, L.ensureState("emphasis").style = t3.getModel(["emphasis", "handleStyle"]).getItemStyle(), EI(L, true), c3.add(L);
        var B = this.visualMapModel.textStyleModel, G = new Fl({ cursor: F, draggable: true, drift: M, onmousemove: function(se) {
          R2(se.event);
        }, ondragend: I, style: { x: 0, y: 0, text: "", font: B.getFont(), fill: B.getTextColor() } });
        G.ensureState("blur").style = { opacity: 0.1 }, G.stateTransition = { duration: 200 }, this.group.add(G);
        var J = [k3, 0], Q = this._shapes;
        Q.handleThumbs[p3] = L, Q.handleLabelPoints[p3] = J, Q.handleLabels[p3] = G;
      }, i.prototype._createIndicator = function(t3, c3, p3, g3, b3) {
        var w3 = zv(t3.get("indicatorSize"), p3[0]), M = pv(t3.get("indicatorIcon"), -w3 / 2, -w3 / 2, w3, w3, null, true);
        M.attr({ cursor: "move", invisible: true, silent: true, x: p3[0] / 2 });
        var I = t3.getModel("indicatorStyle").getItemStyle();
        if (M instanceof Gv) {
          var k3 = M.style;
          M.useStyle(ti({ image: k3.image, x: k3.x, y: k3.y, width: k3.width, height: k3.height }, I));
        } else
          M.useStyle(I);
        c3.add(M);
        var L = this.visualMapModel.textStyleModel, F = new Fl({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: L.getFont(), fill: L.getTextColor() } });
        this.group.add(F);
        var B = [(b3 === "horizontal" ? g3 / 2 : N3t) + p3[0] / 2, 0], G = this._shapes;
        G.indicator = M, G.indicatorLabel = F, G.indicatorLabelPoint = B, this._firstShowIndicator = true;
      }, i.prototype._dragHandle = function(t3, c3, p3, g3) {
        if (this._useHandle) {
          if (this._dragging = !c3, !c3) {
            var b3 = this._applyTransform([p3, g3], this._shapes.mainGroup, true);
            this._updateInterval(t3, b3[1]), this._hideIndicator(), this._updateView();
          }
          c3 === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), c3 ? !this._hovering && this._clearHoverLinkToSeries() : yBe(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[t3], false);
        }
      }, i.prototype._resetInterval = function() {
        var t3 = this.visualMapModel, c3 = this._dataInterval = t3.getSelected(), p3 = t3.getExtent(), g3 = [0, t3.itemSize[1]];
        this._handleEnds = [rT(c3[0], p3, g3, true), rT(c3[1], p3, g3, true)];
      }, i.prototype._updateInterval = function(t3, c3) {
        c3 = c3 || 0;
        var p3 = this.visualMapModel, g3 = this._handleEnds, b3 = [0, p3.itemSize[1]];
        ML(c3, g3, b3, t3, 0);
        var w3 = p3.getExtent();
        this._dataInterval = [rT(g3[0], b3, w3, true), rT(g3[1], b3, w3, true)];
      }, i.prototype._updateView = function(t3) {
        var c3 = this.visualMapModel, p3 = c3.getExtent(), g3 = this._shapes, b3 = [0, c3.itemSize[1]], w3 = t3 ? b3 : this._handleEnds, M = this._createBarVisual(this._dataInterval, p3, w3, "inRange"), I = this._createBarVisual(p3, p3, b3, "outOfRange");
        g3.inRange.setStyle({ fill: M.barColor }).setShape("points", M.barPoints), g3.outOfRange.setStyle({ fill: I.barColor }).setShape("points", I.barPoints), this._updateHandle(w3, M);
      }, i.prototype._createBarVisual = function(t3, c3, p3, g3) {
        var b3 = { forceState: g3, convertOpacityToAlpha: true }, w3 = this._makeColorGradient(t3, b3), M = [this.getControllerVisual(t3[0], "symbolSize", b3), this.getControllerVisual(t3[1], "symbolSize", b3)], I = this._createBarPoints(p3, M);
        return { barColor: new JP(0, 0, 0, 1, w3), barPoints: I, handlesColor: [w3[0].color, w3[w3.length - 1].color] };
      }, i.prototype._makeColorGradient = function(t3, c3) {
        var p3 = 100, g3 = [], b3 = (t3[1] - t3[0]) / p3;
        g3.push({ color: this.getControllerVisual(t3[0], "color", c3), offset: 0 });
        for (var w3 = 1; w3 < p3; w3++) {
          var M = t3[0] + b3 * w3;
          if (M > t3[1])
            break;
          g3.push({ color: this.getControllerVisual(M, "color", c3), offset: w3 / p3 });
        }
        return g3.push({ color: this.getControllerVisual(t3[1], "color", c3), offset: 1 }), g3;
      }, i.prototype._createBarPoints = function(t3, c3) {
        var p3 = this.visualMapModel.itemSize;
        return [[p3[0] - c3[0], t3[0]], [p3[0], t3[0]], [p3[0], t3[1]], [p3[0] - c3[1], t3[1]]];
      }, i.prototype._createBarGroup = function(t3) {
        var c3 = this._orient, p3 = this.visualMapModel.get("inverse");
        return new vs(c3 === "horizontal" && !p3 ? { scaleX: t3 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : c3 === "horizontal" && p3 ? { scaleX: t3 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : c3 === "vertical" && !p3 ? { scaleX: t3 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: t3 === "left" ? 1 : -1 });
      }, i.prototype._updateHandle = function(t3, c3) {
        if (this._useHandle) {
          var p3 = this._shapes, g3 = this.visualMapModel, b3 = p3.handleThumbs, w3 = p3.handleLabels, M = g3.itemSize, I = g3.getExtent();
          L3t([0, 1], function(k3) {
            var L = b3[k3];
            L.setStyle("fill", c3.handlesColor[k3]), L.y = t3[k3];
            var F = rT(t3[k3], [0, M[1]], I, true), B = this.getControllerVisual(F, "symbolSize");
            L.scaleX = L.scaleY = B / M[0], L.x = M[0] - B / 2;
            var G = ll(p3.handleLabelPoints[k3], Ls(L, this.group));
            w3[k3].setStyle({ x: G[0], y: G[1], text: g3.formatValueText(this._dataInterval[k3]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", p3.mainGroup) : "center" });
          }, this);
        }
      }, i.prototype._showIndicator = function(t3, c3, p3, g3) {
        var b3 = this.visualMapModel, w3 = b3.getExtent(), M = b3.itemSize, I = [0, M[1]], k3 = this._shapes, L = k3.indicator;
        if (L) {
          L.attr("invisible", false);
          var F = { convertOpacityToAlpha: true }, B = this.getControllerVisual(t3, "color", F), G = this.getControllerVisual(t3, "symbolSize"), J = rT(t3, w3, I, true), Q = M[0] - G / 2, se = { x: L.x, y: L.y };
          L.y = J, L.x = Q;
          var he = ll(k3.indicatorLabelPoint, Ls(L, this.group)), be = k3.indicatorLabel;
          be.attr("invisible", false);
          var de = this._applyTransform("left", k3.mainGroup), Fe = this._orient, Pe = Fe === "horizontal";
          be.setStyle({ text: (p3 || "") + b3.formatValueText(c3), verticalAlign: Pe ? de : "middle", align: Pe ? "center" : de });
          var ze = { x: Q, y: J, style: { fill: B } }, $e = { style: { x: he[0], y: he[1] } };
          if (b3.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
            var Ke = { duration: 100, easing: "cubicInOut", additive: true };
            L.x = se.x, L.y = se.y, L.animateTo(ze, Ke), be.animateTo($e, Ke);
          } else
            L.attr(ze), be.attr($e);
          this._firstShowIndicator = false;
          var nt = this._shapes.handleLabels;
          if (nt)
            for (var lt2 = 0; lt2 < nt.length; lt2++)
              this._api.enterBlur(nt[lt2]);
        }
      }, i.prototype._enableHoverLinkToSeries = function() {
        var t3 = this;
        this._shapes.mainGroup.on("mousemove", function(c3) {
          if (t3._hovering = true, !t3._dragging) {
            var p3 = t3.visualMapModel.itemSize, g3 = t3._applyTransform([c3.offsetX, c3.offsetY], t3._shapes.mainGroup, true, true);
            g3[1] = vBe(f1e(0, g3[1]), p3[1]), t3._doHoverLinkToSeries(g3[1], 0 <= g3[0] && g3[0] <= p3[0]);
          }
        }).on("mouseout", function() {
          t3._hovering = false, !t3._dragging && t3._clearHoverLinkToSeries();
        });
      }, i.prototype._enableHoverLinkFromSeries = function() {
        var t3 = this.api.getZr();
        this.visualMapModel.option.hoverLink ? (t3.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), t3.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
      }, i.prototype._doHoverLinkToSeries = function(t3, c3) {
        var p3 = this.visualMapModel, g3 = p3.itemSize;
        if (p3.option.hoverLink) {
          var b3 = [0, g3[1]], w3 = p3.getExtent();
          t3 = vBe(f1e(b3[0], t3), b3[1]);
          var M = V3t(p3, w3, b3), I = [t3 - M, t3 + M], k3 = rT(t3, b3, w3, true), L = [rT(I[0], b3, w3, true), rT(I[1], b3, w3, true)];
          I[0] < b3[0] && (L[0] = -1 / 0), I[1] > b3[1] && (L[1] = 1 / 0), c3 && (L[0] === -1 / 0 ? this._showIndicator(k3, L[1], "< ", M) : L[1] === 1 / 0 ? this._showIndicator(k3, L[0], "> ", M) : this._showIndicator(k3, k3, "\u2248 ", M));
          var F = this._hoverLinkDataIndices, B = [];
          (c3 || yBe(p3)) && (B = this._hoverLinkDataIndices = p3.findTargetDataIndices(L));
          var G = Tde(F, B);
          this._dispatchHighDown("downplay", Zne(G[0], p3)), this._dispatchHighDown("highlight", Zne(G[1], p3));
        }
      }, i.prototype._hoverLinkFromSeriesMouseOver = function(t3) {
        var c3 = t3.target, p3 = this.visualMapModel;
        if (!(!c3 || La(c3).dataIndex == null)) {
          var g3 = La(c3), b3 = this.ecModel.getSeriesByIndex(g3.seriesIndex);
          if (p3.isTargetSeries(b3)) {
            var w3 = b3.getData(g3.dataType), M = w3.getStore().get(p3.getDataDimensionIndex(w3), g3.dataIndex);
            isNaN(M) || this._showIndicator(M, M);
          }
        }
      }, i.prototype._hideIndicator = function() {
        var t3 = this._shapes;
        t3.indicator && t3.indicator.attr("invisible", true), t3.indicatorLabel && t3.indicatorLabel.attr("invisible", true);
        var c3 = this._shapes.handleLabels;
        if (c3)
          for (var p3 = 0; p3 < c3.length; p3++)
            this._api.leaveBlur(c3[p3]);
      }, i.prototype._clearHoverLinkToSeries = function() {
        this._hideIndicator();
        var t3 = this._hoverLinkDataIndices;
        this._dispatchHighDown("downplay", Zne(t3, this.visualMapModel)), t3.length = 0;
      }, i.prototype._clearHoverLinkFromSeries = function() {
        this._hideIndicator();
        var t3 = this.api.getZr();
        t3.off("mouseover", this._hoverLinkFromSeriesMouseOver), t3.off("mouseout", this._hideIndicator);
      }, i.prototype._applyTransform = function(t3, c3, p3, g3) {
        var b3 = Ls(c3, g3 ? null : this.group);
        return Ei(t3) ? ll(t3, b3, p3) : Hs(t3, b3, p3);
      }, i.prototype._dispatchHighDown = function(t3, c3) {
        c3 && c3.length && this.api.dispatchAction({ type: t3, batch: c3 });
      }, i.prototype.dispose = function() {
        this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
      }, i.prototype.remove = function() {
        this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
      }, i.type = "visualMap.continuous", i;
    }(hBe);
    function gBe(o, i, t3, c3) {
      return new _m({ shape: { points: o }, draggable: !!t3, cursor: i, drift: t3, onmousemove: function(p3) {
        R2(p3.event);
      }, ondragend: c3 });
    }
    function V3t(o, i, t3) {
      var c3 = R3t / 2, p3 = o.get("hoverLinkDataSize");
      return p3 && (c3 = rT(p3, i, t3, true) / 2), c3;
    }
    function yBe(o) {
      var i = o.get("hoverLinkOnHandle");
      return !!(i == null ? o.get("realtime") : i);
    }
    function mBe(o) {
      return o === "vertical" ? "ns-resize" : "ew-resize";
    }
    var B3t = F3t, z3t = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, j3t = function(o, i) {
      i.eachComponent({ mainType: "visualMap", query: o }, function(t3) {
        t3.setSelected(o.selected);
      });
    }, G3t = [{ createOnAllSeries: true, reset: function(o, i) {
      var t3 = [];
      return i.eachComponent("visualMap", function(c3) {
        var p3 = o.pipelineContext;
        !c3.isTargetSeries(o) || p3 && p3.large || t3.push(N5t(c3.stateList, c3.targetVisuals, Qa(c3.getValueState, c3), c3.getDataDimensionIndex(o.getData())));
      }), t3;
    } }, { createOnAllSeries: true, reset: function(o, i) {
      var t3 = o.getData(), c3 = [];
      i.eachComponent("visualMap", function(p3) {
        if (p3.isTargetSeries(o)) {
          var g3 = p3.getVisualMeta(Qa(H3t, null, o, p3)) || { stops: [], outerColors: [] }, b3 = p3.getDataDimensionIndex(t3);
          b3 >= 0 && (g3.dimension = b3, c3.push(g3));
        }
      }), o.getData().setVisual("visualMeta", c3);
    } }];
    function H3t(o, i, t3, c3) {
      for (var p3 = i.targetVisuals[c3], g3 = wy.prepareVisualTypes(p3), b3 = { color: BH(o.getData(), "color") }, w3 = 0, M = g3.length; w3 < M; w3++) {
        var I = g3[w3], k3 = p3[I === "opacity" ? "__alphaForOpacity" : I];
        k3 && k3.applyVisual(t3, L, F);
      }
      return b3.color;
      function L(B) {
        return b3[B];
      }
      function F(B, G) {
        b3[B] = G;
      }
    }
    var bBe = yt;
    function W3t(o) {
      var i = o && o.visualMap;
      Ei(i) || (i = i ? [i] : []), bBe(i, function(t3) {
        if (t3) {
          K8(t3, "splitList") && !K8(t3, "pieces") && (t3.pieces = t3.splitList, delete t3.splitList);
          var c3 = t3.pieces;
          c3 && Ei(c3) && bBe(c3, function(p3) {
            Ua(p3) && (K8(p3, "start") && !K8(p3, "min") && (p3.min = p3.start), K8(p3, "end") && !K8(p3, "max") && (p3.max = p3.end));
          });
        }
      });
    }
    function K8(o, i) {
      return o && o.hasOwnProperty && o.hasOwnProperty(i);
    }
    var _Be = false;
    function xBe(o) {
      _Be || (_Be = true, o.registerSubTypeDefaulter("visualMap", function(i) {
        return !i.categories && (!(i.pieces ? i.pieces.length > 0 : i.splitNumber > 0) || i.calculable) ? "continuous" : "piecewise";
      }), o.registerAction(z3t, j3t), yt(G3t, function(i) {
        o.registerVisual(o.PRIORITY.VISUAL.COMPONENT, i);
      }), o.registerPreprocessor(W3t));
    }
    function wBe(o) {
      o.registerComponentModel(O3t), o.registerComponentView(B3t), xBe(o);
    }
    var U3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3._pieceList = [], t3;
      }
      return i.prototype.optionUpdated = function(t3, c3) {
        o.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
        var p3 = this._mode = this._determineMode();
        this._pieceList = [], q3t[this._mode].call(this, this._pieceList), this._resetSelected(t3, c3);
        var g3 = this.option.categories;
        this.resetVisual(function(b3, w3) {
          p3 === "categories" ? (b3.mappingMethod = "category", b3.categories = Jo(g3)) : (b3.dataExtent = this.getExtent(), b3.mappingMethod = "piecewise", b3.pieceList = Fi(this._pieceList, function(M) {
            return M = Jo(M), w3 !== "inRange" && (M.visual = null), M;
          }));
        });
      }, i.prototype.completeVisualOption = function() {
        var t3 = this.option, c3 = {}, p3 = wy.listVisualTypes(), g3 = this.isCategory();
        yt(t3.pieces, function(w3) {
          yt(p3, function(M) {
            w3.hasOwnProperty(M) && (c3[M] = 1);
          });
        }), yt(c3, function(w3, M) {
          var I = false;
          yt(this.stateList, function(k3) {
            I = I || b3(t3, k3, M) || b3(t3.target, k3, M);
          }, this), !I && yt(this.stateList, function(k3) {
            (t3[k3] || (t3[k3] = {}))[M] = sBe.get(M, k3 === "inRange" ? "active" : "inactive", g3);
          });
        }, this);
        function b3(w3, M, I) {
          return w3 && w3[M] && w3[M].hasOwnProperty(I);
        }
        o.prototype.completeVisualOption.apply(this, arguments);
      }, i.prototype._resetSelected = function(t3, c3) {
        var p3 = this.option, g3 = this._pieceList, b3 = (c3 ? p3 : t3).selected || {};
        if (p3.selected = b3, yt(g3, function(M, I) {
          var k3 = this.getSelectedMapKey(M);
          b3.hasOwnProperty(k3) || (b3[k3] = true);
        }, this), p3.selectedMode === "single") {
          var w3 = false;
          yt(g3, function(M, I) {
            var k3 = this.getSelectedMapKey(M);
            b3[k3] && (w3 ? b3[k3] = false : w3 = true);
          }, this);
        }
      }, i.prototype.getItemSymbol = function() {
        return this.get("itemSymbol");
      }, i.prototype.getSelectedMapKey = function(t3) {
        return this._mode === "categories" ? t3.value + "" : t3.index + "";
      }, i.prototype.getPieceList = function() {
        return this._pieceList;
      }, i.prototype._determineMode = function() {
        var t3 = this.option;
        return t3.pieces && t3.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
      }, i.prototype.setSelected = function(t3) {
        this.option.selected = Jo(t3);
      }, i.prototype.getValueState = function(t3) {
        var c3 = wy.findPieceIndex(t3, this._pieceList);
        return c3 != null && this.option.selected[this.getSelectedMapKey(this._pieceList[c3])] ? "inRange" : "outOfRange";
      }, i.prototype.findTargetDataIndices = function(t3) {
        var c3 = [], p3 = this._pieceList;
        return this.eachTargetSeries(function(g3) {
          var b3 = [], w3 = g3.getData();
          w3.each(this.getDataDimensionIndex(w3), function(M, I) {
            var k3 = wy.findPieceIndex(M, p3);
            k3 === t3 && b3.push(I);
          }, this), c3.push({ seriesId: g3.id, dataIndex: b3 });
        }, this), c3;
      }, i.prototype.getRepresentValue = function(t3) {
        var c3;
        if (this.isCategory())
          c3 = t3.value;
        else if (t3.value != null)
          c3 = t3.value;
        else {
          var p3 = t3.interval || [];
          c3 = p3[0] === -1 / 0 && p3[1] === 1 / 0 ? 0 : (p3[0] + p3[1]) / 2;
        }
        return c3;
      }, i.prototype.getVisualMeta = function(t3) {
        if (this.isCategory())
          return;
        var c3 = [], p3 = ["", ""], g3 = this;
        function b3(k3, L) {
          var F = g3.getRepresentValue({ interval: k3 });
          L || (L = g3.getValueState(F));
          var B = t3(F, L);
          k3[0] === -1 / 0 ? p3[0] = B : k3[1] === 1 / 0 ? p3[1] = B : c3.push({ value: k3[0], color: B }, { value: k3[1], color: B });
        }
        var w3 = this._pieceList.slice();
        if (!w3.length)
          w3.push({ interval: [-1 / 0, 1 / 0] });
        else {
          var M = w3[0].interval[0];
          M !== -1 / 0 && w3.unshift({ interval: [-1 / 0, M] }), M = w3[w3.length - 1].interval[1], M !== 1 / 0 && w3.push({ interval: [M, 1 / 0] });
        }
        var I = -1 / 0;
        return yt(w3, function(k3) {
          var L = k3.interval;
          L && (L[0] > I && b3([I, L[0]], "outOfRange"), b3(L.slice()), I = L[1]);
        }, this), { stops: c3, outerColors: p3 };
      }, i.type = "visualMap.piecewise", i.defaultOption = rk(Kne.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), i;
    }(Kne), q3t = { splitNumber: function(o) {
      var i = this.option, t3 = Math.min(i.precision, 20), c3 = this.getExtent(), p3 = i.splitNumber;
      p3 = Math.max(parseInt(p3, 10), 1), i.splitNumber = p3;
      for (var g3 = (c3[1] - c3[0]) / p3; +g3.toFixed(t3) !== g3 && t3 < 5; )
        t3++;
      i.precision = t3, g3 = +g3.toFixed(t3), i.minOpen && o.push({ interval: [-1 / 0, c3[0]], close: [0, 0] });
      for (var b3 = 0, w3 = c3[0]; b3 < p3; w3 += g3, b3++) {
        var M = b3 === p3 - 1 ? c3[1] : w3 + g3;
        o.push({ interval: [w3, M], close: [1, 1] });
      }
      i.maxOpen && o.push({ interval: [c3[1], 1 / 0], close: [0, 0] }), XQ(o), yt(o, function(I, k3) {
        I.index = k3, I.text = this.formatValueText(I.interval);
      }, this);
    }, categories: function(o) {
      var i = this.option;
      yt(i.categories, function(t3) {
        o.push({ text: this.formatValueText(t3, true), value: t3 });
      }, this), SBe(i, o);
    }, pieces: function(o) {
      var i = this.option;
      yt(i.pieces, function(t3, c3) {
        Ua(t3) || (t3 = { value: t3 });
        var p3 = { text: "", index: c3 };
        if (t3.label != null && (p3.text = t3.label), t3.hasOwnProperty("value")) {
          var g3 = p3.value = t3.value;
          p3.interval = [g3, g3], p3.close = [1, 1];
        } else {
          for (var b3 = p3.interval = [], w3 = p3.close = [0, 0], M = [1, 0, 1], I = [-1 / 0, 1 / 0], k3 = [], L = 0; L < 2; L++) {
            for (var F = [["gte", "gt", "min"], ["lte", "lt", "max"]][L], B = 0; B < 3 && b3[L] == null; B++)
              b3[L] = t3[F[B]], w3[L] = M[B], k3[L] = B === 2;
            b3[L] == null && (b3[L] = I[L]);
          }
          k3[0] && b3[1] === 1 / 0 && (w3[0] = 0), k3[1] && b3[0] === -1 / 0 && (w3[1] = 0), b3[0] === b3[1] && w3[0] && w3[1] && (p3.value = b3[0]);
        }
        p3.visual = wy.retrieveVisuals(t3), o.push(p3);
      }, this), SBe(i, o), XQ(o), yt(o, function(t3) {
        var c3 = t3.close, p3 = [["<", "\u2264"][c3[1]], [">", "\u2265"][c3[0]]];
        t3.text = t3.text || this.formatValueText(t3.value != null ? t3.value : t3.interval, false, p3);
      }, this);
    } };
    function SBe(o, i) {
      var t3 = o.inverse;
      (o.orient === "vertical" ? !t3 : t3) && i.reverse();
    }
    var $3t = U3t, X3t = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = i.type, t3;
      }
      return i.prototype.doRender = function() {
        var t3 = this.group;
        t3.removeAll();
        var c3 = this.visualMapModel, p3 = c3.get("textGap"), g3 = c3.textStyleModel, b3 = g3.getFont(), w3 = g3.getTextColor(), M = this._getItemAlign(), I = c3.itemSize, k3 = this._getViewData(), L = k3.endsText, F = lv(c3.get("showLabel", true), !L);
        L && this._renderEndsText(t3, L[0], I, F, M), yt(k3.viewPieceList, function(B) {
          var G = B.piece, J = new vs();
          J.onclick = Qa(this._onItemClick, this, G), this._enableHoverLink(J, B.indexInModelPieceList);
          var Q = c3.getRepresentValue(G);
          if (this._createItemSymbol(J, Q, [0, 0, I[0], I[1]]), F) {
            var se = this.visualMapModel.getValueState(Q);
            J.add(new Fl({ style: { x: M === "right" ? -p3 : I[0] + p3, y: I[1] / 2, text: G.text, verticalAlign: "middle", align: M, font: b3, fill: w3, opacity: se === "outOfRange" ? 0.5 : 1 } }));
          }
          t3.add(J);
        }, this), L && this._renderEndsText(t3, L[1], I, F, M), iL(c3.get("orient"), t3, c3.get("itemGap")), this.renderBackground(t3), this.positionGroup(t3);
      }, i.prototype._enableHoverLink = function(t3, c3) {
        var p3 = this;
        t3.on("mouseover", function() {
          return g3("highlight");
        }).on("mouseout", function() {
          return g3("downplay");
        });
        var g3 = function(b3) {
          var w3 = p3.visualMapModel;
          w3.option.hoverLink && p3.api.dispatchAction({ type: b3, batch: Zne(w3.findTargetDataIndices(c3), w3) });
        };
      }, i.prototype._getItemAlign = function() {
        var t3 = this.visualMapModel, c3 = t3.option;
        if (c3.orient === "vertical")
          return dBe(t3, this.api, t3.itemSize);
        var p3 = c3.align;
        return (!p3 || p3 === "auto") && (p3 = "left"), p3;
      }, i.prototype._renderEndsText = function(t3, c3, p3, g3, b3) {
        if (c3) {
          var w3 = new vs(), M = this.visualMapModel.textStyleModel;
          w3.add(new Fl({ style: { x: g3 ? b3 === "right" ? p3[0] : 0 : p3[0] / 2, y: p3[1] / 2, verticalAlign: "middle", align: g3 ? b3 : "center", text: c3, font: M.getFont(), fill: M.getTextColor() } })), t3.add(w3);
        }
      }, i.prototype._getViewData = function() {
        var t3 = this.visualMapModel, c3 = Fi(t3.getPieceList(), function(w3, M) {
          return { piece: w3, indexInModelPieceList: M };
        }), p3 = t3.get("text"), g3 = t3.get("orient"), b3 = t3.get("inverse");
        return (g3 === "horizontal" ? b3 : !b3) ? c3.reverse() : p3 && (p3 = p3.slice().reverse()), { viewPieceList: c3, endsText: p3 };
      }, i.prototype._createItemSymbol = function(t3, c3, p3) {
        t3.add(pv(this.getControllerVisual(c3, "symbol"), p3[0], p3[1], p3[2], p3[3], this.getControllerVisual(c3, "color")));
      }, i.prototype._onItemClick = function(t3) {
        var c3 = this.visualMapModel, p3 = c3.option, g3 = Jo(p3.selected), b3 = c3.getSelectedMapKey(t3);
        p3.selectedMode === "single" ? (g3[b3] = true, yt(g3, function(w3, M) {
          g3[M] = M === b3;
        })) : g3[b3] = !g3[b3], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: g3 });
      }, i.type = "visualMap.piecewise", i;
    }(hBe), Y3t = X3t;
    function CBe(o) {
      o.registerComponentModel($3t), o.registerComponentView(Y3t), xBe(o);
    }
    function K3t(o) {
      Tl(wBe), Tl(CBe);
    }
    var Z3t = { label: { enabled: true }, decal: { show: false } }, MBe = mu(), J3t = {};
    function Q3t(o, i) {
      var t3 = o.getModel("aria");
      if (!t3.get("enabled"))
        return;
      var c3 = Jo(Z3t);
      Es(c3.label, o.getLocaleModel().get("aria"), false), Es(t3.option, c3, false), p3(), g3();
      function p3() {
        var I = t3.getModel("decal"), k3 = I.get("show");
        if (k3) {
          var L = Eo();
          o.eachSeries(function(F) {
            if (!F.isColorBySeries()) {
              var B = L.get(F.type);
              B || (B = {}, L.set(F.type, B)), MBe(F).scope = B;
            }
          }), o.eachRawSeries(function(F) {
            if (o.isSeriesFiltered(F))
              return;
            if (Vo(F.enableAriaDecal)) {
              F.enableAriaDecal();
              return;
            }
            var B = F.getData();
            if (F.isColorBySeries()) {
              var G = yge(F.ecModel, F.name, J3t, o.getSeriesCount()), J = B.getVisual("decal");
              B.setVisual("decal", de(J, G));
            } else {
              var Q = F.getRawData(), se = {}, he = MBe(F).scope;
              B.each(function(Fe) {
                var Pe = B.getRawIndex(Fe);
                se[Pe] = Fe;
              });
              var be = Q.count();
              Q.each(function(Fe) {
                var Pe = se[Fe], ze = Q.getName(Fe) || Fe + "", $e = yge(F.ecModel, ze, he, be), Ke = B.getItemVisual(Pe, "decal");
                B.setItemVisual(Pe, "decal", de(Ke, $e));
              });
            }
            function de(Fe, Pe) {
              var ze = Fe ? ti(ti({}, Pe), Fe) : Pe;
              return ze.dirty = true, ze;
            }
          });
        }
      }
      function g3() {
        var I = o.getLocaleModel().get("aria"), k3 = t3.getModel("label");
        if (k3.option = Uo(k3.option, I), !!k3.get("enabled")) {
          var L = i.getZr().dom;
          if (k3.get("description")) {
            L.setAttribute("aria-label", k3.get("description"));
            return;
          }
          var F = o.getSeriesCount(), B = k3.get(["data", "maxCount"]) || 10, G = k3.get(["series", "maxCount"]) || 10, J = Math.min(F, G), Q;
          if (!(F < 1)) {
            var se = w3();
            if (se) {
              var he = k3.get(["general", "withTitle"]);
              Q = b3(he, { title: se });
            } else
              Q = k3.get(["general", "withoutTitle"]);
            var be = [], de = F > 1 ? k3.get(["series", "multiple", "prefix"]) : k3.get(["series", "single", "prefix"]);
            Q += b3(de, { seriesCount: F }), o.eachSeries(function($e, Ke) {
              if (Ke < J) {
                var nt = void 0, lt2 = $e.get("name"), bt = lt2 ? "withName" : "withoutName";
                nt = F > 1 ? k3.get(["series", "multiple", bt]) : k3.get(["series", "single", bt]), nt = b3(nt, { seriesId: $e.seriesIndex, seriesName: $e.get("name"), seriesType: M($e.subType) });
                var vt = $e.getData();
                if (vt.count() > B) {
                  var jt = k3.get(["data", "partialData"]);
                  nt += b3(jt, { displayCnt: B });
                } else
                  nt += k3.get(["data", "allData"]);
                for (var Jt = k3.get(["data", "separator", "middle"]), Rt = k3.get(["data", "separator", "end"]), Jn = [], ln = 0; ln < vt.count(); ln++)
                  if (ln < B) {
                    var vn = vt.getName(ln), kn = vt.getValues(ln), cr = k3.get(["data", vn ? "withName" : "withoutName"]);
                    Jn.push(b3(cr, { name: vn, value: kn.join(Jt) }));
                  }
                nt += Jn.join(Jt) + Rt, be.push(nt);
              }
            });
            var Fe = k3.getModel(["series", "multiple", "separator"]), Pe = Fe.get("middle"), ze = Fe.get("end");
            Q += be.join(Pe) + ze, L.setAttribute("aria-label", Q);
          }
        }
      }
      function b3(I, k3) {
        if (!Ha(I))
          return I;
        var L = I;
        return yt(k3, function(F, B) {
          L = L.replace(new RegExp("\\{\\s*" + B + "\\s*\\}", "g"), F);
        }), L;
      }
      function w3() {
        var I = o.get("title");
        return I && I.length && (I = I[0]), I && I.text;
      }
      function M(I) {
        return o.getLocaleModel().get(["series", "typeNames"])[I] || "\u81EA\u5B9A\u4E49\u56FE";
      }
    }
    function eOt(o) {
      if (!(!o || !o.aria)) {
        var i = o.aria;
        i.show != null && (i.enabled = i.show), i.label = i.label || {}, yt(["description", "general", "series", "data"], function(t3) {
          i[t3] != null && (i.label[t3] = i[t3]);
        });
      }
    }
    function tOt(o) {
      o.registerPreprocessor(eOt), o.registerVisual(o.PRIORITY.VISUAL.ARIA, Q3t);
    }
    var TBe = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, nOt = function() {
      function o(i) {
        var t3 = this._condVal = Ha(i) ? new RegExp(i) : zpe(i) ? i : null;
        if (t3 == null) {
          var c3 = "";
          Fu(c3);
        }
      }
      return o.prototype.evaluate = function(i) {
        var t3 = typeof i;
        return Ha(t3) ? this._condVal.test(i) : ec(t3) ? this._condVal.test(i + "") : false;
      }, o;
    }(), rOt = function() {
      function o() {
      }
      return o.prototype.evaluate = function() {
        return this.value;
      }, o;
    }(), iOt = function() {
      function o() {
      }
      return o.prototype.evaluate = function() {
        for (var i = this.children, t3 = 0; t3 < i.length; t3++)
          if (!i[t3].evaluate())
            return false;
        return true;
      }, o;
    }(), aOt = function() {
      function o() {
      }
      return o.prototype.evaluate = function() {
        for (var i = this.children, t3 = 0; t3 < i.length; t3++)
          if (i[t3].evaluate())
            return true;
        return false;
      }, o;
    }(), oOt = function() {
      function o() {
      }
      return o.prototype.evaluate = function() {
        return !this.child.evaluate();
      }, o;
    }(), sOt = function() {
      function o() {
      }
      return o.prototype.evaluate = function() {
        for (var i = !!this.valueParser, t3 = this.getValue, c3 = t3(this.valueGetterParam), p3 = i ? this.valueParser(c3) : null, g3 = 0; g3 < this.subCondList.length; g3++)
          if (!this.subCondList[g3].evaluate(i ? p3 : c3))
            return false;
        return true;
      }, o;
    }();
    function h1e(o, i) {
      if (o === true || o === false) {
        var t3 = new rOt();
        return t3.value = o, t3;
      }
      var c3 = "";
      return IBe(o) || Fu(c3), o.and ? ABe("and", o, i) : o.or ? ABe("or", o, i) : o.not ? lOt(o, i) : uOt(o, i);
    }
    function ABe(o, i, t3) {
      var c3 = i[o], p3 = "";
      Ei(c3) || Fu(p3), c3.length || Fu(p3);
      var g3 = o === "and" ? new iOt() : new aOt();
      return g3.children = Fi(c3, function(b3) {
        return h1e(b3, t3);
      }), g3.children.length || Fu(p3), g3;
    }
    function lOt(o, i) {
      var t3 = o.not, c3 = "";
      IBe(t3) || Fu(c3);
      var p3 = new oOt();
      return p3.child = h1e(t3, i), p3.child || Fu(c3), p3;
    }
    function uOt(o, i) {
      for (var t3 = "", c3 = i.prepareGetValue(o), p3 = [], g3 = Gl(o), b3 = o.parser, w3 = b3 ? rRe(b3) : null, M = 0; M < g3.length; M++) {
        var I = g3[M];
        if (!(I === "parser" || i.valueGetterAttrMap.get(I))) {
          var k3 = so(TBe, I) ? TBe[I] : I, L = o[I], F = w3 ? w3(L) : L, B = G0t(k3, F) || k3 === "reg" && new nOt(F);
          B || Fu(t3), p3.push(B);
        }
      }
      p3.length || Fu(t3);
      var G = new sOt();
      return G.valueGetterParam = c3, G.valueParser = w3, G.getValue = i.getValue, G.subCondList = p3, G;
    }
    function IBe(o) {
      return Ua(o) && !yg(o);
    }
    var cOt = function() {
      function o(i, t3) {
        this._cond = h1e(i, t3);
      }
      return o.prototype.evaluate = function() {
        return this._cond.evaluate();
      }, o;
    }();
    function fOt(o, i) {
      return new cOt(o, i);
    }
    var hOt = { type: "echarts:filter", transform: function(o) {
      for (var i = o.upstream, t3, c3 = fOt(o.config, { valueGetterAttrMap: Eo({ dimension: true }), prepareGetValue: function(w3) {
        var M = "", I = w3.dimension;
        so(w3, "dimension") || Fu(M);
        var k3 = i.getDimensionInfo(I);
        return k3 || Fu(M), { dimIdx: k3.index };
      }, getValue: function(w3) {
        return i.retrieveValueFromItem(t3, w3.dimIdx);
      } }), p3 = [], g3 = 0, b3 = i.count(); g3 < b3; g3++)
        t3 = i.getRawDataItem(g3), c3.evaluate() && p3.push(t3);
      return { data: p3 };
    } }, pOt = { type: "echarts:sort", transform: function(o) {
      var i = o.upstream, t3 = o.config, c3 = "", p3 = Wc(t3);
      p3.length || Fu(c3);
      var g3 = [];
      yt(p3, function(k3) {
        var L = k3.dimension, F = k3.order, B = k3.parser, G = k3.incomparable;
        if (L == null && Fu(c3), F !== "asc" && F !== "desc" && Fu(c3), G && G !== "min" && G !== "max") {
          var J = "";
          Fu(J);
        }
        if (F !== "asc" && F !== "desc") {
          var Q = "";
          Fu(Q);
        }
        var se = i.getDimensionInfo(L);
        se || Fu(c3);
        var he = B ? rRe(B) : null;
        B && !he && Fu(c3), g3.push({ dimIdx: se.index, parser: he, comparator: new aRe(F, G) });
      });
      var b3 = i.sourceFormat;
      b3 !== Cm && b3 !== Dw && Fu(c3);
      for (var w3 = [], M = 0, I = i.count(); M < I; M++)
        w3.push(i.getRawDataItem(M));
      return w3.sort(function(k3, L) {
        for (var F = 0; F < g3.length; F++) {
          var B = g3[F], G = i.retrieveValueFromItem(k3, B.dimIdx), J = i.retrieveValueFromItem(L, B.dimIdx);
          B.parser && (G = B.parser(G), J = B.parser(J));
          var Q = B.comparator.evaluate(G, J);
          if (Q !== 0)
            return Q;
        }
        return 0;
      }), { data: w3 };
    } };
    function dOt(o) {
      o.registerTransform(hOt), o.registerTransform(pOt);
    }
    var vOt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "dataset", t3;
      }
      return i.prototype.init = function(t3, c3, p3) {
        o.prototype.init.call(this, t3, c3, p3), this._sourceManager = new fRe(this), hRe(this);
      }, i.prototype.mergeOption = function(t3, c3) {
        o.prototype.mergeOption.call(this, t3, c3), hRe(this);
      }, i.prototype.optionUpdated = function() {
        this._sourceManager.dirty();
      }, i.prototype.getSourceManager = function() {
        return this._sourceManager;
      }, i.type = "dataset", i.defaultOption = { seriesLayoutBy: KM }, i;
    }(nc), gOt = function(o) {
      cn(i, o);
      function i() {
        var t3 = o !== null && o.apply(this, arguments) || this;
        return t3.type = "dataset", t3;
      }
      return i.type = "dataset", i;
    }(ed);
    function yOt(o) {
      o.registerComponentModel(vOt), o.registerComponentView(gOt);
    }
    var iT = ww.CMD;
    function Z8(o, i) {
      return Math.abs(o - i) < 1e-5;
    }
    function p1e(o) {
      var i = o.data, t3 = o.len(), c3 = [], p3, g3 = 0, b3 = 0, w3 = 0, M = 0;
      function I(vt, jt) {
        p3 && p3.length > 2 && c3.push(p3), p3 = [vt, jt];
      }
      function k3(vt, jt, Jt, Rt) {
        Z8(vt, Jt) && Z8(jt, Rt) || p3.push(vt, jt, Jt, Rt, Jt, Rt);
      }
      function L(vt, jt, Jt, Rt, Jn, ln) {
        var vn = Math.abs(jt - vt), kn = Math.tan(vn / 4) * 4 / 3, cr = jt < vt ? -1 : 1, gr = Math.cos(vt), ha = Math.sin(vt), Ka = Math.cos(jt), Do = Math.sin(jt), _o = gr * Jn + Jt, xo = ha * ln + Rt, Ra = Ka * Jn + Jt, ho = Do * ln + Rt, Mo = Jn * kn * cr, Xa = ln * kn * cr;
        p3.push(_o - Mo * ha, xo + Xa * gr, Ra + Mo * Do, ho - Xa * Ka, Ra, ho);
      }
      for (var F, B, G, J, Q = 0; Q < t3; ) {
        var se = i[Q++], he = Q === 1;
        switch (he && (g3 = i[Q], b3 = i[Q + 1], w3 = g3, M = b3, (se === iT.L || se === iT.C || se === iT.Q) && (p3 = [w3, M])), se) {
          case iT.M:
            g3 = w3 = i[Q++], b3 = M = i[Q++], I(w3, M);
            break;
          case iT.L:
            F = i[Q++], B = i[Q++], k3(g3, b3, F, B), g3 = F, b3 = B;
            break;
          case iT.C:
            p3.push(i[Q++], i[Q++], i[Q++], i[Q++], g3 = i[Q++], b3 = i[Q++]);
            break;
          case iT.Q:
            F = i[Q++], B = i[Q++], G = i[Q++], J = i[Q++], p3.push(g3 + 2 / 3 * (F - g3), b3 + 2 / 3 * (B - b3), G + 2 / 3 * (F - G), J + 2 / 3 * (B - J), G, J), g3 = G, b3 = J;
            break;
          case iT.A:
            var be = i[Q++], de = i[Q++], Fe = i[Q++], Pe = i[Q++], ze = i[Q++], $e = i[Q++] + ze;
            Q += 1;
            var Ke = !i[Q++];
            F = Math.cos(ze) * Fe + be, B = Math.sin(ze) * Pe + de, he ? (w3 = F, M = B, I(w3, M)) : k3(g3, b3, F, B), g3 = Math.cos($e) * Fe + be, b3 = Math.sin($e) * Pe + de;
            for (var nt = (Ke ? -1 : 1) * Math.PI / 2, lt2 = ze; Ke ? lt2 > $e : lt2 < $e; lt2 += nt) {
              var bt = Ke ? Math.max(lt2 + nt, $e) : Math.min(lt2 + nt, $e);
              L(lt2, bt, be, de, Fe, Pe);
            }
            break;
          case iT.R:
            w3 = g3 = i[Q++], M = b3 = i[Q++], F = w3 + i[Q++], B = M + i[Q++], I(F, M), k3(F, M, F, B), k3(F, B, w3, B), k3(w3, B, w3, M), k3(w3, M, F, M);
            break;
          case iT.Z:
            p3 && k3(g3, b3, w3, M), g3 = w3, b3 = M;
            break;
        }
      }
      return p3 && p3.length > 2 && c3.push(p3), c3;
    }
    function d1e(o, i, t3, c3, p3, g3, b3, w3, M, I) {
      if (Z8(o, t3) && Z8(i, c3) && Z8(p3, b3) && Z8(g3, w3)) {
        M.push(b3, w3);
        return;
      }
      var k3 = 2 / I, L = k3 * k3, F = b3 - o, B = w3 - i, G = Math.sqrt(F * F + B * B);
      F /= G, B /= G;
      var J = t3 - o, Q = c3 - i, se = p3 - b3, he = g3 - w3, be = J * J + Q * Q, de = se * se + he * he;
      if (be < L && de < L) {
        M.push(b3, w3);
        return;
      }
      var Fe = F * J + B * Q, Pe = -F * se - B * he, ze = be - Fe * Fe, $e = de - Pe * Pe;
      if (ze < L && Fe >= 0 && $e < L && Pe >= 0) {
        M.push(b3, w3);
        return;
      }
      var Ke = [], nt = [];
      F2(o, t3, p3, b3, 0.5, Ke), F2(i, c3, g3, w3, 0.5, nt), d1e(Ke[0], nt[0], Ke[1], nt[1], Ke[2], nt[2], Ke[3], nt[3], M, I), d1e(Ke[4], nt[4], Ke[5], nt[5], Ke[6], nt[6], Ke[7], nt[7], M, I);
    }
    function mOt(o, i) {
      var t3 = p1e(o), c3 = [];
      i = i || 1;
      for (var p3 = 0; p3 < t3.length; p3++) {
        var g3 = t3[p3], b3 = [], w3 = g3[0], M = g3[1];
        b3.push(w3, M);
        for (var I = 2; I < g3.length; ) {
          var k3 = g3[I++], L = g3[I++], F = g3[I++], B = g3[I++], G = g3[I++], J = g3[I++];
          d1e(w3, M, k3, L, F, B, G, J, b3, i), w3 = G, M = J;
        }
        c3.push(b3);
      }
      return c3;
    }
    function EBe(o, i, t3) {
      var c3 = o[i], p3 = o[1 - i], g3 = Math.abs(c3 / p3), b3 = Math.ceil(Math.sqrt(g3 * t3)), w3 = Math.floor(t3 / b3);
      w3 === 0 && (w3 = 1, b3 = t3);
      for (var M = [], I = 0; I < b3; I++)
        M.push(w3);
      var k3 = b3 * w3, L = t3 - k3;
      if (L > 0)
        for (var I = 0; I < L; I++)
          M[I % b3] += 1;
      return M;
    }
    function DBe(o, i, t3) {
      for (var c3 = o.r0, p3 = o.r, g3 = o.startAngle, b3 = o.endAngle, w3 = Math.abs(b3 - g3), M = w3 * p3, I = p3 - c3, k3 = M > Math.abs(I), L = EBe([M, I], k3 ? 0 : 1, i), F = (k3 ? w3 : I) / L.length, B = 0; B < L.length; B++)
        for (var G = (k3 ? I : w3) / L[B], J = 0; J < L[B]; J++) {
          var Q = {};
          k3 ? (Q.startAngle = g3 + F * B, Q.endAngle = g3 + F * (B + 1), Q.r0 = c3 + G * J, Q.r = c3 + G * (J + 1)) : (Q.startAngle = g3 + G * J, Q.endAngle = g3 + G * (J + 1), Q.r0 = c3 + F * B, Q.r = c3 + F * (B + 1)), Q.clockwise = o.clockwise, Q.cx = o.cx, Q.cy = o.cy, t3.push(Q);
        }
    }
    function bOt(o, i, t3) {
      for (var c3 = o.width, p3 = o.height, g3 = c3 > p3, b3 = EBe([c3, p3], g3 ? 0 : 1, i), w3 = g3 ? "width" : "height", M = g3 ? "height" : "width", I = g3 ? "x" : "y", k3 = g3 ? "y" : "x", L = o[w3] / b3.length, F = 0; F < b3.length; F++)
        for (var B = o[M] / b3[F], G = 0; G < b3[F]; G++) {
          var J = {};
          J[I] = F * L, J[k3] = G * B, J[w3] = L, J[M] = B, J.x += o.x, J.y += o.y, t3.push(J);
        }
    }
    function kBe(o, i, t3, c3) {
      return o * c3 - t3 * i;
    }
    function _Ot(o, i, t3, c3, p3, g3, b3, w3) {
      var M = t3 - o, I = c3 - i, k3 = b3 - p3, L = w3 - g3, F = kBe(k3, L, M, I);
      if (Math.abs(F) < 1e-6)
        return null;
      var B = o - p3, G = i - g3, J = kBe(B, G, k3, L) / F;
      return J < 0 || J > 1 ? null : new Bs(J * M + o, J * I + i);
    }
    function xOt(o, i, t3) {
      var c3 = new Bs();
      Bs.sub(c3, t3, i), c3.normalize();
      var p3 = new Bs();
      Bs.sub(p3, o, i);
      var g3 = p3.dot(c3);
      return g3;
    }
    function J8(o, i) {
      var t3 = o[o.length - 1];
      t3 && t3[0] === i[0] && t3[1] === i[1] || o.push(i);
    }
    function wOt(o, i, t3) {
      for (var c3 = o.length, p3 = [], g3 = 0; g3 < c3; g3++) {
        var b3 = o[g3], w3 = o[(g3 + 1) % c3], M = _Ot(b3[0], b3[1], w3[0], w3[1], i.x, i.y, t3.x, t3.y);
        M && p3.push({ projPt: xOt(M, i, t3), pt: M, idx: g3 });
      }
      if (p3.length < 2)
        return [{ points: o }, { points: o }];
      p3.sort(function(Q, se) {
        return Q.projPt - se.projPt;
      });
      var I = p3[0], k3 = p3[p3.length - 1];
      if (k3.idx < I.idx) {
        var L = I;
        I = k3, k3 = L;
      }
      for (var F = [I.pt.x, I.pt.y], B = [k3.pt.x, k3.pt.y], G = [F], J = [B], g3 = I.idx + 1; g3 <= k3.idx; g3++)
        J8(G, o[g3].slice());
      J8(G, B), J8(G, F);
      for (var g3 = k3.idx + 1; g3 <= I.idx + c3; g3++)
        J8(J, o[g3 % c3].slice());
      return J8(J, F), J8(J, B), [{ points: G }, { points: J }];
    }
    function OBe(o) {
      var i = o.points, t3 = [], c3 = [];
      UF(i, t3, c3);
      var p3 = new Ys(t3[0], t3[1], c3[0] - t3[0], c3[1] - t3[1]), g3 = p3.width, b3 = p3.height, w3 = p3.x, M = p3.y, I = new Bs(), k3 = new Bs();
      return g3 > b3 ? (I.x = k3.x = w3 + g3 / 2, I.y = M, k3.y = M + b3) : (I.y = k3.y = M + b3 / 2, I.x = w3, k3.x = w3 + g3), wOt(i, I, k3);
    }
    function Jne(o, i, t3, c3) {
      if (t3 === 1)
        c3.push(i);
      else {
        var p3 = Math.floor(t3 / 2), g3 = o(i);
        Jne(o, g3[0], p3, c3), Jne(o, g3[1], t3 - p3, c3);
      }
      return c3;
    }
    function SOt(o, i) {
      for (var t3 = [], c3 = 0; c3 < i; c3++)
        t3.push(pH(o));
      return t3;
    }
    function COt(o, i) {
      i.setStyle(o.style), i.z = o.z, i.z2 = o.z2, i.zlevel = o.zlevel;
    }
    function MOt(o) {
      for (var i = [], t3 = 0; t3 < o.length; )
        i.push([o[t3++], o[t3++]]);
      return i;
    }
    function TOt(o, i) {
      var t3 = [], c3 = o.shape, p3;
      switch (o.type) {
        case "rect":
          bOt(c3, i, t3), p3 = bu;
          break;
        case "sector":
          DBe(c3, i, t3), p3 = bm;
          break;
        case "circle":
          DBe({ r0: 0, r: c3.r, startAngle: 0, endAngle: Math.PI * 2, cx: c3.cx, cy: c3.cy }, i, t3), p3 = bm;
          break;
        default:
          var g3 = o.getComputedTransform(), b3 = g3 ? Math.sqrt(Math.max(g3[0] * g3[0] + g3[1] * g3[1], g3[2] * g3[2] + g3[3] * g3[3])) : 1, w3 = Fi(mOt(o.getUpdatedPathProxy(), b3), function(se) {
            return MOt(se);
          }), M = w3.length;
          if (M === 0)
            Jne(OBe, { points: w3[0] }, i, t3);
          else if (M === i)
            for (var I = 0; I < M; I++)
              t3.push({ points: w3[I] });
          else {
            var k3 = 0, L = Fi(w3, function(se) {
              var he = [], be = [];
              UF(se, he, be);
              var de = (be[1] - he[1]) * (be[0] - he[0]);
              return k3 += de, { poly: se, area: de };
            });
            L.sort(function(se, he) {
              return he.area - se.area;
            });
            for (var F = i, I = 0; I < M; I++) {
              var B = L[I];
              if (F <= 0)
                break;
              var G = I === M - 1 ? F : Math.ceil(B.area / k3 * i);
              G < 0 || (Jne(OBe, { points: B.poly }, G, t3), F -= G);
            }
          }
          p3 = _m;
          break;
      }
      if (!p3)
        return SOt(o, i);
      for (var J = [], I = 0; I < t3.length; I++) {
        var Q = new p3();
        Q.setShape(t3[I]), COt(o, Q), J.push(Q);
      }
      return J;
    }
    function AOt(o, i) {
      var t3 = o.length, c3 = i.length;
      if (t3 === c3)
        return [o, i];
      for (var p3 = [], g3 = [], b3 = t3 < c3 ? o : i, w3 = Math.min(t3, c3), M = Math.abs(c3 - t3) / 6, I = (w3 - 2) / 6, k3 = Math.ceil(M / I) + 1, L = [b3[0], b3[1]], F = M, B = 2; B < w3; ) {
        var G = b3[B - 2], J = b3[B - 1], Q = b3[B++], se = b3[B++], he = b3[B++], be = b3[B++], de = b3[B++], Fe = b3[B++];
        if (F <= 0) {
          L.push(Q, se, he, be, de, Fe);
          continue;
        }
        for (var Pe = Math.min(F, k3 - 1) + 1, ze = 1; ze <= Pe; ze++) {
          var $e = ze / Pe;
          F2(G, Q, he, de, $e, p3), F2(J, se, be, Fe, $e, g3), G = p3[3], J = g3[3], L.push(p3[1], g3[1], p3[2], g3[2], G, J), Q = p3[5], se = g3[5], he = p3[6], be = g3[6];
        }
        F -= Pe - 1;
      }
      return b3 === o ? [L, i] : [o, L];
    }
    function PBe(o, i) {
      for (var t3 = o.length, c3 = o[t3 - 2], p3 = o[t3 - 1], g3 = [], b3 = 0; b3 < i.length; )
        g3[b3++] = c3, g3[b3++] = p3;
      return g3;
    }
    function IOt(o, i) {
      for (var t3, c3, p3, g3 = [], b3 = [], w3 = 0; w3 < Math.max(o.length, i.length); w3++) {
        var M = o[w3], I = i[w3], k3 = void 0, L = void 0;
        M ? I ? (t3 = AOt(M, I), k3 = t3[0], L = t3[1], c3 = k3, p3 = L) : (L = PBe(p3 || M, M), k3 = M) : (k3 = PBe(c3 || I, I), L = I), g3.push(k3), b3.push(L);
      }
      return [g3, b3];
    }
    function LBe(o) {
      for (var i = 0, t3 = 0, c3 = 0, p3 = o.length, g3 = 0, b3 = p3 - 2; g3 < p3; b3 = g3, g3 += 2) {
        var w3 = o[b3], M = o[b3 + 1], I = o[g3], k3 = o[g3 + 1], L = w3 * k3 - I * M;
        i += L, t3 += (w3 + I) * L, c3 += (M + k3) * L;
      }
      return i === 0 ? [o[0] || 0, o[1] || 0] : [t3 / i / 3, c3 / i / 3, i];
    }
    function EOt(o, i, t3, c3) {
      for (var p3 = (o.length - 2) / 6, g3 = 1 / 0, b3 = 0, w3 = o.length, M = w3 - 2, I = 0; I < p3; I++) {
        for (var k3 = I * 6, L = 0, F = 0; F < w3; F += 2) {
          var B = F === 0 ? k3 : (k3 + F - 2) % M + 2, G = o[B] - t3[0], J = o[B + 1] - t3[1], Q = i[F] - c3[0], se = i[F + 1] - c3[1], he = Q - G, be = se - J;
          L += he * he + be * be;
        }
        L < g3 && (g3 = L, b3 = I);
      }
      return b3;
    }
    function DOt(o) {
      for (var i = [], t3 = o.length, c3 = 0; c3 < t3; c3 += 2)
        i[c3] = o[t3 - c3 - 2], i[c3 + 1] = o[t3 - c3 - 1];
      return i;
    }
    function kOt(o, i, t3, c3) {
      for (var p3 = [], g3, b3 = 0; b3 < o.length; b3++) {
        var w3 = o[b3], M = i[b3], I = LBe(w3), k3 = LBe(M);
        g3 == null && (g3 = I[2] < 0 != k3[2] < 0);
        var L = [], F = [], B = 0, G = 1 / 0, J = [], Q = w3.length;
        g3 && (w3 = DOt(w3));
        for (var se = EOt(w3, M, I, k3) * 6, he = Q - 2, be = 0; be < he; be += 2) {
          var de = (se + be) % he + 2;
          L[be + 2] = w3[de] - I[0], L[be + 3] = w3[de + 1] - I[1];
        }
        if (L[0] = w3[se] - I[0], L[1] = w3[se + 1] - I[1], t3 > 0)
          for (var Fe = c3 / t3, Pe = -c3 / 2; Pe <= c3 / 2; Pe += Fe) {
            for (var ze = Math.sin(Pe), $e = Math.cos(Pe), Ke = 0, be = 0; be < w3.length; be += 2) {
              var nt = L[be], lt2 = L[be + 1], bt = M[be] - k3[0], vt = M[be + 1] - k3[1], jt = bt * $e - vt * ze, Jt = bt * ze + vt * $e;
              J[be] = jt, J[be + 1] = Jt;
              var Rt = jt - nt, Jn = Jt - lt2;
              Ke += Rt * Rt + Jn * Jn;
            }
            if (Ke < G) {
              G = Ke, B = Pe;
              for (var ln = 0; ln < J.length; ln++)
                F[ln] = J[ln];
            }
          }
        else
          for (var vn = 0; vn < Q; vn += 2)
            F[vn] = M[vn] - k3[0], F[vn + 1] = M[vn + 1] - k3[1];
        p3.push({ from: L, to: F, fromCp: I, toCp: k3, rotation: -B });
      }
      return p3;
    }
    function Qne(o) {
      return o.__isCombineMorphing;
    }
    var RBe = "__mOriginal_";
    function ere(o, i, t3) {
      var c3 = RBe + i, p3 = o[c3] || o[i];
      o[c3] || (o[c3] = o[i]);
      var g3 = t3.replace, b3 = t3.after, w3 = t3.before;
      o[i] = function() {
        var M = arguments, I;
        return w3 && w3.apply(this, M), g3 ? I = g3.apply(this, M) : I = p3.apply(this, M), b3 && b3.apply(this, M), I;
      };
    }
    function BW(o, i) {
      var t3 = RBe + i;
      o[t3] && (o[i] = o[t3], o[t3] = null);
    }
    function NBe(o, i) {
      for (var t3 = 0; t3 < o.length; t3++)
        for (var c3 = o[t3], p3 = 0; p3 < c3.length; ) {
          var g3 = c3[p3], b3 = c3[p3 + 1];
          c3[p3++] = i[0] * g3 + i[2] * b3 + i[4], c3[p3++] = i[1] * g3 + i[3] * b3 + i[5];
        }
    }
    function FBe(o, i) {
      var t3 = o.getUpdatedPathProxy(), c3 = i.getUpdatedPathProxy(), p3 = IOt(p1e(t3), p1e(c3)), g3 = p3[0], b3 = p3[1], w3 = o.getComputedTransform(), M = i.getComputedTransform();
      function I() {
        this.transform = null;
      }
      w3 && NBe(g3, w3), M && NBe(b3, M), ere(i, "updateTransform", { replace: I }), i.transform = null;
      var k3 = kOt(g3, b3, 10, Math.PI), L = [];
      ere(i, "buildPath", { replace: function(F) {
        for (var B = i.__morphT, G = 1 - B, J = [], Q = 0; Q < k3.length; Q++) {
          var se = k3[Q], he = se.from, be = se.to, de = se.rotation * B, Fe = se.fromCp, Pe = se.toCp, ze = Math.sin(de), $e = Math.cos(de);
          sF(J, Fe, Pe, B);
          for (var Ke = 0; Ke < he.length; Ke += 2) {
            var nt = he[Ke], lt2 = he[Ke + 1], bt = be[Ke], vt = be[Ke + 1], jt = nt * G + bt * B, Jt = lt2 * G + vt * B;
            L[Ke] = jt * $e - Jt * ze + J[0], L[Ke + 1] = jt * ze + Jt * $e + J[1];
          }
          var Rt = L[0], Jn = L[1];
          F.moveTo(Rt, Jn);
          for (var Ke = 2; Ke < he.length; ) {
            var bt = L[Ke++], vt = L[Ke++], ln = L[Ke++], vn = L[Ke++], kn = L[Ke++], cr = L[Ke++];
            Rt === bt && Jn === vt && ln === kn && vn === cr ? F.lineTo(kn, cr) : F.bezierCurveTo(bt, vt, ln, vn, kn, cr), Rt = kn, Jn = cr;
          }
        }
      } });
    }
    function v1e(o, i, t3) {
      if (!o || !i)
        return i;
      var c3 = t3.done, p3 = t3.during;
      FBe(o, i), i.__morphT = 0;
      function g3() {
        BW(i, "buildPath"), BW(i, "updateTransform"), i.__morphT = -1, i.createPathProxy(), i.dirtyShape();
      }
      return i.animateTo({ __morphT: 1 }, Uo({ during: function(b3) {
        i.dirtyShape(), p3 && p3(b3);
      }, done: function() {
        g3(), c3 && c3();
      } }, t3)), i;
    }
    function OOt(o, i, t3, c3, p3, g3) {
      var b3 = 16;
      o = p3 === t3 ? 0 : Math.round(32767 * (o - t3) / (p3 - t3)), i = g3 === c3 ? 0 : Math.round(32767 * (i - c3) / (g3 - c3));
      for (var w3 = 0, M, I = (1 << b3) / 2; I > 0; I /= 2) {
        var k3 = 0, L = 0;
        (o & I) > 0 && (k3 = 1), (i & I) > 0 && (L = 1), w3 += I * I * (3 * k3 ^ L), L === 0 && (k3 === 1 && (o = I - 1 - o, i = I - 1 - i), M = o, o = i, i = M);
      }
      return w3;
    }
    function tre(o) {
      var i = 1 / 0, t3 = 1 / 0, c3 = -1 / 0, p3 = -1 / 0, g3 = Fi(o, function(w3) {
        var M = w3.getBoundingRect(), I = w3.getComputedTransform(), k3 = M.x + M.width / 2 + (I ? I[4] : 0), L = M.y + M.height / 2 + (I ? I[5] : 0);
        return i = Math.min(k3, i), t3 = Math.min(L, t3), c3 = Math.max(k3, c3), p3 = Math.max(L, p3), [k3, L];
      }), b3 = Fi(g3, function(w3, M) {
        return { cp: w3, z: OOt(w3[0], w3[1], i, t3, c3, p3), path: o[M] };
      });
      return b3.sort(function(w3, M) {
        return w3.z - M.z;
      }).map(function(w3) {
        return w3.path;
      });
    }
    function VBe(o) {
      return TOt(o.path, o.count);
    }
    function g1e() {
      return { fromIndividuals: [], toIndividuals: [], count: 0 };
    }
    function POt(o, i, t3) {
      var c3 = [];
      function p3(Fe) {
        for (var Pe = 0; Pe < Fe.length; Pe++) {
          var ze = Fe[Pe];
          Qne(ze) ? p3(ze.childrenRef()) : ze instanceof gl && c3.push(ze);
        }
      }
      p3(o);
      var g3 = c3.length;
      if (!g3)
        return g1e();
      var b3 = t3.dividePath || VBe, w3 = b3({ path: i, count: g3 });
      if (w3.length !== g3)
        return console.error("Invalid morphing: unmatched splitted path"), g1e();
      c3 = tre(c3), w3 = tre(w3);
      for (var M = t3.done, I = t3.during, k3 = t3.individualDelay, L = new k1(), F = 0; F < g3; F++) {
        var B = c3[F], G = w3[F];
        G.parent = i, G.copyTransform(L), k3 || FBe(B, G);
      }
      i.__isCombineMorphing = true, i.childrenRef = function() {
        return w3;
      };
      function J(Fe) {
        for (var Pe = 0; Pe < w3.length; Pe++)
          w3[Pe].addSelfToZr(Fe);
      }
      ere(i, "addSelfToZr", { after: function(Fe) {
        J(Fe);
      } }), ere(i, "removeSelfFromZr", { after: function(Fe) {
        for (var Pe = 0; Pe < w3.length; Pe++)
          w3[Pe].removeSelfFromZr(Fe);
      } });
      function Q() {
        i.__isCombineMorphing = false, i.__morphT = -1, i.childrenRef = null, BW(i, "addSelfToZr"), BW(i, "removeSelfFromZr");
      }
      var se = w3.length;
      if (k3)
        for (var he = se, be = function() {
          he--, he === 0 && (Q(), M && M());
        }, F = 0; F < se; F++) {
          var de = k3 ? Uo({ delay: (t3.delay || 0) + k3(F, se, c3[F], w3[F]), done: be }, t3) : t3;
          v1e(c3[F], w3[F], de);
        }
      else
        i.__morphT = 0, i.animateTo({ __morphT: 1 }, Uo({ during: function(Fe) {
          for (var Pe = 0; Pe < se; Pe++) {
            var ze = w3[Pe];
            ze.__morphT = i.__morphT, ze.dirtyShape();
          }
          I && I(Fe);
        }, done: function() {
          Q();
          for (var Fe = 0; Fe < o.length; Fe++)
            BW(o[Fe], "updateTransform");
          M && M();
        } }, t3));
      return i.__zr && J(i.__zr), { fromIndividuals: c3, toIndividuals: w3, count: se };
    }
    function LOt(o, i, t3) {
      var c3 = i.length, p3 = [], g3 = t3.dividePath || VBe;
      function b3(B) {
        for (var G = 0; G < B.length; G++) {
          var J = B[G];
          Qne(J) ? b3(J.childrenRef()) : J instanceof gl && p3.push(J);
        }
      }
      if (Qne(o)) {
        b3(o.childrenRef());
        var w3 = p3.length;
        if (w3 < c3)
          for (var M = 0, I = w3; I < c3; I++)
            p3.push(pH(p3[M++ % w3]));
        p3.length = c3;
      } else {
        p3 = g3({ path: o, count: c3 });
        for (var k3 = o.getComputedTransform(), I = 0; I < p3.length; I++)
          p3[I].setLocalTransform(k3);
        if (p3.length !== c3)
          return console.error("Invalid morphing: unmatched splitted path"), g1e();
      }
      p3 = tre(p3), i = tre(i);
      for (var L = t3.individualDelay, I = 0; I < c3; I++) {
        var F = L ? Uo({ delay: (t3.delay || 0) + L(I, c3, p3[I], i[I]) }, t3) : t3;
        v1e(p3[I], i[I], F);
      }
      return { fromIndividuals: p3, toIndividuals: i, count: i.length };
    }
    function BBe(o) {
      return Ei(o[0]);
    }
    function zBe(o, i) {
      for (var t3 = [], c3 = o.length, p3 = 0; p3 < c3; p3++)
        t3.push({ one: o[p3], many: [] });
      for (var p3 = 0; p3 < i.length; p3++) {
        var g3 = i[p3].length, b3 = void 0;
        for (b3 = 0; b3 < g3; b3++)
          t3[b3 % c3].many.push(i[p3][b3]);
      }
      for (var w3 = 0, p3 = c3 - 1; p3 >= 0; p3--)
        if (!t3[p3].many.length) {
          var M = t3[w3].many;
          if (M.length <= 1)
            if (w3)
              w3 = 0;
            else
              return t3;
          var g3 = M.length, I = Math.ceil(g3 / 2);
          t3[p3].many = M.slice(I, g3), t3[w3].many = M.slice(0, I), w3++;
        }
      return t3;
    }
    var ROt = { clone: function(o) {
      for (var i = [], t3 = 1 - Math.pow(1 - o.path.style.opacity, 1 / o.count), c3 = 0; c3 < o.count; c3++) {
        var p3 = pH(o.path);
        p3.setStyle("opacity", t3), i.push(p3);
      }
      return i;
    }, split: null };
    function y1e(o, i, t3, c3, p3, g3) {
      if (!o.length || !i.length)
        return;
      var b3 = ek("update", c3, p3);
      if (!(b3 && b3.duration > 0))
        return;
      var w3 = c3.getModel("universalTransition").get("delay"), M = Object.assign({ setToFinal: true }, b3), I, k3;
      BBe(o) && (I = o, k3 = i), BBe(i) && (I = i, k3 = o);
      function L(se, he, be, de, Fe) {
        var Pe = se.many, ze = se.one;
        if (Pe.length === 1 && !Fe) {
          var $e = he ? Pe[0] : ze, Ke = he ? ze : Pe[0];
          if (Qne($e))
            L({ many: [$e], one: Ke }, true, be, de, true);
          else {
            var nt = w3 ? Uo({ delay: w3(be, de) }, M) : M;
            v1e($e, Ke, nt), g3($e, Ke, $e, Ke, nt);
          }
        } else
          for (var lt2 = Uo({ dividePath: ROt[t3], individualDelay: w3 && function(Jn, ln, vn, kn) {
            return w3(Jn + be, de);
          } }, M), bt = he ? POt(Pe, ze, lt2) : LOt(ze, Pe, lt2), vt = bt.fromIndividuals, jt = bt.toIndividuals, Jt = vt.length, Rt = 0; Rt < Jt; Rt++) {
            var nt = w3 ? Uo({ delay: w3(Rt, Jt) }, M) : M;
            g3(vt[Rt], jt[Rt], he ? Pe[Rt] : se.one, he ? se.one : Pe[Rt], nt);
          }
      }
      for (var F = I ? I === o : o.length > i.length, B = I ? zBe(k3, I) : zBe(F ? i : o, [F ? o : i]), G = 0, J = 0; J < B.length; J++)
        G += B[J].many.length;
      for (var Q = 0, J = 0; J < B.length; J++)
        L(B[J], F, Q, G), Q += B[J].many.length;
    }
    function kL(o) {
      if (!o)
        return [];
      if (Ei(o)) {
        for (var i = [], t3 = 0; t3 < o.length; t3++)
          i.push(kL(o[t3]));
        return i;
      }
      var c3 = [];
      return o.traverse(function(p3) {
        p3 instanceof gl && !p3.disableMorphing && !p3.invisible && !p3.ignore && c3.push(p3);
      }), c3;
    }
    var jBe = 1e4, NOt = mu();
    function FOt(o) {
      for (var i = o.dimensions, t3 = 0; t3 < i.length; t3++) {
        var c3 = o.getDimensionInfo(i[t3]);
        if (c3 && c3.otherDims.itemGroupId === 0)
          return i[t3];
      }
    }
    function GBe(o) {
      var i = [];
      return yt(o, function(t3) {
        var c3 = t3.data;
        if (!(c3.count() > jBe))
          for (var p3 = c3.getIndices(), g3 = FOt(c3), b3 = 0; b3 < p3.length; b3++)
            i.push({ data: c3, dim: t3.dim || g3, divide: t3.divide, dataIndex: b3 });
      }), i;
    }
    function m1e(o, i, t3) {
      o.traverse(function(c3) {
        c3 instanceof gl && Uh(c3, { style: { opacity: 0 } }, i, { dataIndex: t3, isFrom: true });
      });
    }
    function b1e(o) {
      if (o.parent) {
        var i = o.getComputedTransform();
        o.setLocalTransform(i), o.parent.remove(o);
      }
    }
    function Q8(o) {
      o.stopAnimation(), o.isGroup && o.traverse(function(i) {
        i.stopAnimation();
      });
    }
    function VOt(o, i, t3) {
      var c3 = ek("update", t3, i);
      c3 && o.traverse(function(p3) {
        if (p3 instanceof Ab) {
          var g3 = Qve(p3);
          g3 && p3.animateFrom({ style: g3 }, c3);
        }
      });
    }
    function BOt(o, i) {
      var t3 = o.length;
      if (t3 !== i.length)
        return false;
      for (var c3 = 0; c3 < t3; c3++) {
        var p3 = o[c3], g3 = i[c3];
        if (p3.data.getId(p3.dataIndex) !== g3.data.getId(g3.dataIndex))
          return false;
      }
      return true;
    }
    function HBe(o, i, t3) {
      var c3 = GBe(o), p3 = GBe(i);
      function g3(se, he, be, de, Fe) {
        (be || se) && he.animateFrom({ style: be && be !== se ? ti(ti({}, be.style), se.style) : se.style }, Fe);
      }
      function b3(se) {
        for (var he = 0; he < se.length; he++)
          if (se[he].dim)
            return se[he].dim;
      }
      var w3 = b3(c3), M = b3(p3), I = false;
      function k3(se, he) {
        return function(be) {
          var de = be.data, Fe = be.dataIndex;
          if (he)
            return de.getId(Fe);
          var Pe = de.hostModel && de.hostModel.get("dataGroupId"), ze = se ? w3 || M : M || w3, $e = ze && de.getDimensionInfo(ze), Ke = $e && $e.ordinalMeta;
          if ($e) {
            var nt = de.get($e.name, Fe);
            return Ke && Ke.categories[nt] || nt + "";
          }
          var lt2 = de.getRawDataItem(Fe);
          return lt2 && lt2.groupId ? lt2.groupId + "" : Pe || de.getId(Fe);
        };
      }
      var L = BOt(c3, p3), F = {};
      if (!L)
        for (var B = 0; B < p3.length; B++) {
          var G = p3[B], J = G.data.getItemGraphicEl(G.dataIndex);
          J && (F[J.id] = true);
        }
      function Q(se, he) {
        var be = c3[he], de = p3[se], Fe = de.data.hostModel, Pe = be.data.getItemGraphicEl(be.dataIndex), ze = de.data.getItemGraphicEl(de.dataIndex);
        if (Pe === ze) {
          ze && VOt(ze, de.dataIndex, Fe);
          return;
        }
        Pe && F[Pe.id] || ze && (Q8(ze), Pe ? (Q8(Pe), b1e(Pe), I = true, y1e(kL(Pe), kL(ze), de.divide, Fe, se, g3)) : m1e(ze, Fe, se));
      }
      new RI(c3, p3, k3(true, L), k3(false, L), null, "multiple").update(Q).updateManyToOne(function(se, he) {
        var be = p3[se], de = be.data, Fe = de.hostModel, Pe = de.getItemGraphicEl(be.dataIndex), ze = Zc(Fi(he, function($e) {
          return c3[$e].data.getItemGraphicEl(c3[$e].dataIndex);
        }), function($e) {
          return $e && $e !== Pe && !F[$e.id];
        });
        Pe && (Q8(Pe), ze.length ? (yt(ze, function($e) {
          Q8($e), b1e($e);
        }), I = true, y1e(kL(ze), kL(Pe), be.divide, Fe, se, g3)) : m1e(Pe, Fe, be.dataIndex));
      }).updateOneToMany(function(se, he) {
        var be = c3[he], de = be.data.getItemGraphicEl(be.dataIndex);
        if (!(de && F[de.id])) {
          var Fe = Zc(Fi(se, function(ze) {
            return p3[ze].data.getItemGraphicEl(p3[ze].dataIndex);
          }), function(ze) {
            return ze && ze !== de;
          }), Pe = p3[se[0]].data.hostModel;
          Fe.length && (yt(Fe, function(ze) {
            return Q8(ze);
          }), de ? (Q8(de), b1e(de), I = true, y1e(kL(de), kL(Fe), be.divide, Pe, se[0], g3)) : yt(Fe, function(ze) {
            return m1e(ze, Pe, se[0]);
          }));
        }
      }).updateManyToMany(function(se, he) {
        new RI(he, se, function(be) {
          return c3[be].data.getId(c3[be].dataIndex);
        }, function(be) {
          return p3[be].data.getId(p3[be].dataIndex);
        }).update(function(be, de) {
          Q(se[be], he[de]);
        }).execute();
      }).execute(), I && yt(i, function(se) {
        var he = se.data, be = he.hostModel, de = be && t3.getViewOfSeriesModel(be), Fe = ek("update", be, 0);
        de && be.isAnimationEnabled() && Fe && Fe.duration > 0 && de.group.traverse(function(Pe) {
          Pe instanceof gl && !Pe.animators.length && Pe.animateFrom({ style: { opacity: 0 } }, Fe);
        });
      });
    }
    function WBe(o) {
      var i = o.getModel("universalTransition").get("seriesKey");
      return i || o.id;
    }
    function UBe(o) {
      return Ei(o) ? o.sort().join(",") : o;
    }
    function Sk(o) {
      if (o.hostModel)
        return o.hostModel.getModel("universalTransition").get("divideShape");
    }
    function zOt(o, i) {
      var t3 = Eo(), c3 = Eo(), p3 = Eo();
      return yt(o.oldSeries, function(g3, b3) {
        var w3 = o.oldData[b3], M = WBe(g3), I = UBe(M);
        c3.set(I, w3), Ei(M) && yt(M, function(k3) {
          p3.set(k3, { data: w3, key: I });
        });
      }), yt(i.updatedSeries, function(g3) {
        if (g3.isUniversalTransitionEnabled() && g3.isAnimationEnabled()) {
          var b3 = g3.getData(), w3 = WBe(g3), M = UBe(w3), I = c3.get(M);
          if (I)
            t3.set(M, { oldSeries: [{ divide: Sk(I), data: I }], newSeries: [{ divide: Sk(b3), data: b3 }] });
          else if (Ei(w3)) {
            var k3 = [];
            yt(w3, function(B) {
              var G = c3.get(B);
              G && k3.push({ divide: Sk(G), data: G });
            }), k3.length && t3.set(M, { oldSeries: k3, newSeries: [{ data: b3, divide: Sk(b3) }] });
          } else {
            var L = p3.get(w3);
            if (L) {
              var F = t3.get(L.key);
              F || (F = { oldSeries: [{ data: L.data, divide: Sk(L.data) }], newSeries: [] }, t3.set(L.key, F)), F.newSeries.push({ data: b3, divide: Sk(b3) });
            }
          }
        }
      }), t3;
    }
    function qBe(o, i) {
      for (var t3 = 0; t3 < o.length; t3++) {
        var c3 = i.seriesIndex != null && i.seriesIndex === o[t3].seriesIndex || i.seriesId != null && i.seriesId === o[t3].id;
        if (c3)
          return t3;
      }
    }
    function jOt(o, i, t3, c3) {
      var p3 = [], g3 = [];
      yt(Wc(o.from), function(b3) {
        var w3 = qBe(i.oldSeries, b3);
        w3 >= 0 && p3.push({ data: i.oldData[w3], divide: Sk(i.oldData[w3]), dim: b3.dimension });
      }), yt(Wc(o.to), function(b3) {
        var w3 = qBe(t3.updatedSeries, b3);
        if (w3 >= 0) {
          var M = t3.updatedSeries[w3].getData();
          g3.push({ data: M, divide: Sk(M), dim: b3.dimension });
        }
      }), p3.length > 0 && g3.length > 0 && HBe(p3, g3, c3);
    }
    function GOt(o) {
      o.registerUpdateLifecycle("series:beforeupdate", function(i, t3, c3) {
        yt(Wc(c3.seriesTransition), function(p3) {
          yt(Wc(p3.to), function(g3) {
            for (var b3 = c3.updatedSeries, w3 = 0; w3 < b3.length; w3++)
              (g3.seriesIndex != null && g3.seriesIndex === b3[w3].seriesIndex || g3.seriesId != null && g3.seriesId === b3[w3].id) && (b3[w3][xte] = true);
          });
        });
      }), o.registerUpdateLifecycle("series:transition", function(i, t3, c3) {
        var p3 = NOt(t3);
        if (p3.oldSeries && c3.updatedSeries && c3.optionChanged) {
          var g3 = c3.seriesTransition;
          if (g3)
            yt(Wc(g3), function(F) {
              jOt(F, p3, c3, t3);
            });
          else {
            var b3 = zOt(p3, c3);
            yt(b3.keys(), function(F) {
              var B = b3.get(F);
              HBe(B.oldSeries, B.newSeries, t3);
            });
          }
          yt(c3.updatedSeries, function(F) {
            F[xte] && (F[xte] = false);
          });
        }
        for (var w3 = i.getSeries(), M = p3.oldSeries = [], I = p3.oldData = [], k3 = 0; k3 < w3.length; k3++) {
          var L = w3[k3].getData();
          L.count() < jBe && (M.push(w3[k3]), I.push(L));
        }
      });
    }
    Tl([o_t]), Tl([Qbt]), Tl([D_t, X_t, oxt, Xxt, fwt, aSt, NSt, w2t, K2t, aCt, gCt, _Mt, $Mt, sTt, TTt, PTt, ZTt, sAt, _At, IAt, jAt, MIt]), Tl(XIt), Tl(IEt), Tl(GFe), Tl(UEt), Tl(f9e), Tl(JEt), Tl(sDt), Tl(l5t), Tl(k5t), Tl(DW), Tl(Z5t), Tl(ekt), Tl(vkt), Tl(Mkt), Tl(Pkt), Tl(jkt), Tl(t3t), Tl(S3t), Tl(nBe), Tl(oBe), Tl(K3t), Tl(wBe), Tl(CBe), Tl(tOt), Tl(dOt), Tl(yOt), Tl(GOt), Tl(mbt);
    function HOt(o) {
      const { defaultOptions: i } = o != null ? o : {}, t3 = C.useRef(null), c3 = C.useRef(), p3 = C.useRef(i);
      return C.useEffect(() => {
        if (!t3.current)
          return;
        const g3 = Lmt(t3.current);
        c3.current = g3, p3.current && g3.setOption(p3.current);
      }, []), C.useEffect(() => () => {
        var g3, b3, w3, M;
        (b3 = (g3 = c3.current) == null ? void 0 : g3.dispose) == null || b3.call(g3), (M = (w3 = c3.current) == null ? void 0 : w3.off) == null || M.call(w3, "*"), c3.current = void 0;
      }, []), xi("resize", () => {
        requestAnimationFrame(() => {
          var g3, b3;
          (b3 = (g3 = c3 == null ? void 0 : c3.current) == null ? void 0 : g3.resize) == null || b3.call(g3);
        });
      }), { chart: c3, container: t3 };
    }
    class WOt {
      constructor() {
        x3(this, "chartsEmitters", /* @__PURE__ */ new Map()), x3(this, "add", (i, t3, c3, p3) => {
          t3 && c3 ? this.chartsEmitters.set(i, { chart: t3, option: c3, title: p3 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
        }), x3(this, "get", (i) => this.chartsEmitters.get(i)), x3(this, "clear", () => {
          this.chartsEmitters.clear();
        }), x3(this, "delete", (i) => {
          this.chartsEmitters.delete(i);
        }), x3(this, "list", () => {
          var i, t3, c3;
          const p3 = [];
          for (const g3 of this.chartsEmitters.keys())
            p3.push({ id: g3, chart: (i = this.chartsEmitters.get(g3)) == null ? void 0 : i.chart, option: (t3 = this.chartsEmitters.get(g3)) == null ? void 0 : t3.option, title: (c3 = this.chartsEmitters.get(g3)) == null ? void 0 : c3.title });
          return p3;
        });
      }
    }
    const UOt = new WOt();
    var nre = { exports: {} };
    /**
    * @license
    * Lodash <https://lodash.com/>
    * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
    * Released under MIT license <https://lodash.com/license>
    * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
    * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
    */
    (function(o, i) {
      (function() {
        var t3, c3 = "4.17.21", p3 = 200, g3 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", b3 = "Expected a function", w3 = "Invalid `variable` option passed into `_.template`", M = "__lodash_hash_undefined__", I = 500, k3 = "__lodash_placeholder__", L = 1, F = 2, B = 4, G = 1, J = 2, Q = 1, se = 2, he = 4, be = 8, de = 16, Fe = 32, Pe = 64, ze = 128, $e = 256, Ke = 512, nt = 30, lt2 = "...", bt = 800, vt = 16, jt = 1, Jt = 2, Rt = 3, Jn = 1 / 0, ln = 9007199254740991, vn = 17976931348623157e292, kn = 0 / 0, cr = 4294967295, gr = cr - 1, ha = cr >>> 1, Ka = [["ary", ze], ["bind", Q], ["bindKey", se], ["curry", be], ["curryRight", de], ["flip", Ke], ["partial", Fe], ["partialRight", Pe], ["rearg", $e]], Do = "[object Arguments]", _o = "[object Array]", xo = "[object AsyncFunction]", Ra = "[object Boolean]", ho = "[object Date]", Mo = "[object DOMException]", Xa = "[object Error]", Zo = "[object Function]", rc = "[object GeneratorFunction]", ys = "[object Map]", Vu = "[object Number]", gc = "[object Null]", ef = "[object Object]", dv = "[object Promise]", Wf = "[object Proxy]", Ag = "[object RegExp]", eh = "[object Set]", _p = "[object String]", ap = "[object Symbol]", Hw = "[object Undefined]", Ji = "[object WeakMap]", Jr = "[object WeakSet]", Xr = "[object ArrayBuffer]", ta = "[object DataView]", co = "[object Float32Array]", cs = "[object Float64Array]", nu = "[object Int8Array]", ru = "[object Int16Array]", hf = "[object Int32Array]", op = "[object Uint8Array]", _h = "[object Uint8ClampedArray]", wd = "[object Uint16Array]", xh = "[object Uint32Array]", m0 = /\b__p \+= '';/g, Sy = /\b(__p \+=) '' \+/g, Ob = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Cy = /&(?:amp|lt|gt|quot|#39);/g, Gp = /[&<>"']/g, yc = RegExp(Cy.source), Xd = RegExp(Gp.source), Ig = /<%-([\s\S]+?)%>/g, Pb = /<%([\s\S]+?)%>/g, Em = /<%=([\s\S]+?)%>/g, My = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, z1 = /^\w*$/, oT = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, Q2 = /[\\^$.*+?()[\]{}|]/g, RL = RegExp(Q2.source), eC = /^\s+/, QW = /\s/, eU = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, tU = /\{\n\/\* \[wrapped with (.+)\] \*/, nU = /,? & /, Ak = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, In = /[()=,{}\[\]\/\s]/, Nn = /\\(\\)?/g, Yt = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, _n = /\w*$/, Cn = /^[-+]0x[0-9a-f]+$/i, Vt = /^0b[01]+$/i, Gi = /^\[object .+?Constructor\]$/, wi = /^0o[0-7]+$/i, pr = /^(?:0|[1-9]\d*)$/, Ma = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, Na = /($^)/, fu = /['\n\r\u2028\u2029\\]/g, ic = "\\ud800-\\udfff", mc = "\\u0300-\\u036f", _u = "\\ufe20-\\ufe2f", kf = "\\u20d0-\\u20ff", xp = mc + _u + kf, Al = "\\u2700-\\u27bf", Sd = "a-z\\xdf-\\xf6\\xf8-\\xff", td = "\\xac\\xb1\\xd7\\xf7", Lb = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", qI = "\\u2000-\\u206f", b0 = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", Ww = "A-Z\\xc0-\\xd6\\xd8-\\xde", tC = "\\ufe0e\\ufe0f", vv = td + Lb + qI + b0, Rb = "['\u2019]", $I = "[" + ic + "]", Uw = "[" + vv + "]", qw = "[" + xp + "]", nC = "\\d+", NL = "[" + Al + "]", XI = "[" + Sd + "]", sT = "[^" + ic + vv + nC + Al + Sd + Ww + "]", Bo = "\\ud83c[\\udffb-\\udfff]", Ms = "(?:" + qw + "|" + Bo + ")", YI = "[^" + ic + "]", ei = "(?:\\ud83c[\\udde6-\\uddff]){2}", zo = "[\\ud800-\\udbff][\\udc00-\\udfff]", Ns = "[" + Ww + "]", Ere = "\\u200d", nd = "(?:" + XI + "|" + sT + ")", _0 = "(?:" + Ns + "|" + sT + ")", gt = "(?:" + Rb + "(?:d|ll|m|re|s|t|ve))?", Pi = "(?:" + Rb + "(?:D|LL|M|RE|S|T|VE))?", G_ = Ms + "?", tf = "[" + tC + "]?", fbe = "(?:" + Ere + "(?:" + [YI, ei, zo].join("|") + ")" + tf + G_ + ")*", Wl = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", hbe = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", Za = tf + G_ + fbe, ks = "(?:" + [NL, ei, zo].join("|") + ")" + Za, Di = "(?:" + [YI + qw + "?", qw, ei, zo, $I].join("|") + ")", jo = RegExp(Rb, "g"), Wa = RegExp(qw, "g"), FL = RegExp(Bo + "(?=" + Bo + ")|" + Di + Za, "g"), ac = RegExp([Ns + "?" + XI + "+" + gt + "(?=" + [Uw, Ns, "$"].join("|") + ")", _0 + "+" + Pi + "(?=" + [Uw, Ns + nd, "$"].join("|") + ")", Ns + "?" + nd + "+" + gt, Ns + "+" + Pi, hbe, Wl, nC, ks].join("|"), "g"), Qo = RegExp("[" + Ere + ic + xp + tC + "]"), Dre = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, j1 = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], VL = -1, th = {};
        th[co] = th[cs] = th[nu] = th[ru] = th[hf] = th[op] = th[_h] = th[wd] = th[xh] = true, th[Do] = th[_o] = th[Xr] = th[Ra] = th[ta] = th[ho] = th[Xa] = th[Zo] = th[ys] = th[Vu] = th[ef] = th[Ag] = th[eh] = th[_p] = th[Ji] = false;
        var qh = {};
        qh[Do] = qh[_o] = qh[Xr] = qh[ta] = qh[Ra] = qh[ho] = qh[co] = qh[cs] = qh[nu] = qh[ru] = qh[hf] = qh[ys] = qh[Vu] = qh[ef] = qh[Ag] = qh[eh] = qh[_p] = qh[ap] = qh[op] = qh[_h] = qh[wd] = qh[xh] = true, qh[Xa] = qh[Zo] = qh[Ji] = false;
        var pbe = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, BL = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, $v = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, Zs = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, rC = parseFloat, rU = parseInt, s9 = typeof _t == "object" && _t && _t.Object === Object && _t, Ty = typeof self == "object" && self && self.Object === Object && self, wh = s9 || Ty || Function("return this")(), l9 = i && !i.nodeType && i, $w = l9 && true && o && !o.nodeType && o, Ik = $w && $w.exports === l9, iU = Ik && s9.process, ro = function() {
          try {
            var _r = $w && $w.require && $w.require("util").types;
            return _r || iU && iU.binding && iU.binding("util");
          } catch {
          }
        }(), u9 = ro && ro.isArrayBuffer, zL = ro && ro.isDate, aU = ro && ro.isMap, io = ro && ro.isRegExp, rd = ro && ro.isSet, jL = ro && ro.isTypedArray;
        function gv(_r, Ui, oi) {
          switch (oi.length) {
            case 0:
              return _r.call(Ui);
            case 1:
              return _r.call(Ui, oi[0]);
            case 2:
              return _r.call(Ui, oi[0], oi[1]);
            case 3:
              return _r.call(Ui, oi[0], oi[1], oi[2]);
          }
          return _r.apply(Ui, oi);
        }
        function Ay(_r, Ui, oi, es) {
          for (var Vl = -1, wf = _r == null ? 0 : _r.length; ++Vl < wf; ) {
            var Kd = _r[Vl];
            Ui(es, Kd, oi(Kd), _r);
          }
          return es;
        }
        function Yd(_r, Ui) {
          for (var oi = -1, es = _r == null ? 0 : _r.length; ++oi < es && Ui(_r[oi], oi, _r) !== false; )
            ;
          return _r;
        }
        function dbe(_r, Ui) {
          for (var oi = _r == null ? 0 : _r.length; oi-- && Ui(_r[oi], oi, _r) !== false; )
            ;
          return _r;
        }
        function oU(_r, Ui) {
          for (var oi = -1, es = _r == null ? 0 : _r.length; ++oi < es; )
            if (!Ui(_r[oi], oi, _r))
              return false;
          return true;
        }
        function Xw(_r, Ui) {
          for (var oi = -1, es = _r == null ? 0 : _r.length, Vl = 0, wf = []; ++oi < es; ) {
            var Kd = _r[oi];
            Ui(Kd, oi, _r) && (wf[Vl++] = Kd);
          }
          return wf;
        }
        function Yw(_r, Ui) {
          var oi = _r == null ? 0 : _r.length;
          return !!oi && G1(_r, Ui, 0) > -1;
        }
        function GL(_r, Ui, oi) {
          for (var es = -1, Vl = _r == null ? 0 : _r.length; ++es < Vl; )
            if (oi(Ui, _r[es]))
              return true;
          return false;
        }
        function wp(_r, Ui) {
          for (var oi = -1, es = _r == null ? 0 : _r.length, Vl = Array(es); ++oi < es; )
            Vl[oi] = Ui(_r[oi], oi, _r);
          return Vl;
        }
        function Kw(_r, Ui) {
          for (var oi = -1, es = Ui.length, Vl = _r.length; ++oi < es; )
            _r[Vl + oi] = Ui[oi];
          return _r;
        }
        function KI(_r, Ui, oi, es) {
          var Vl = -1, wf = _r == null ? 0 : _r.length;
          for (es && wf && (oi = _r[++Vl]); ++Vl < wf; )
            oi = Ui(oi, _r[Vl], Vl, _r);
          return oi;
        }
        function sU(_r, Ui, oi, es) {
          var Vl = _r == null ? 0 : _r.length;
          for (es && Vl && (oi = _r[--Vl]); Vl--; )
            oi = Ui(oi, _r[Vl], Vl, _r);
          return oi;
        }
        function Zw(_r, Ui) {
          for (var oi = -1, es = _r == null ? 0 : _r.length; ++oi < es; )
            if (Ui(_r[oi], oi, _r))
              return true;
          return false;
        }
        var vbe = lU("length");
        function ZI(_r) {
          return _r.split("");
        }
        function c9(_r) {
          return _r.match(Ak) || [];
        }
        function Xv(_r, Ui, oi) {
          var es;
          return oi(_r, function(Vl, wf, Kd) {
            if (Ui(Vl, wf, Kd))
              return es = wf, false;
          }), es;
        }
        function H_(_r, Ui, oi, es) {
          for (var Vl = _r.length, wf = oi + (es ? 1 : -1); es ? wf-- : ++wf < Vl; )
            if (Ui(_r[wf], wf, _r))
              return wf;
          return -1;
        }
        function G1(_r, Ui, oi) {
          return Ui === Ui ? mbe(_r, Ui, oi) : H_(_r, kre, oi);
        }
        function Ek(_r, Ui, oi, es) {
          for (var Vl = oi - 1, wf = _r.length; ++Vl < wf; )
            if (es(_r[Vl], Ui))
              return Vl;
          return -1;
        }
        function kre(_r) {
          return _r !== _r;
        }
        function Ore(_r, Ui) {
          var oi = _r == null ? 0 : _r.length;
          return oi ? f9(_r, Ui) / oi : kn;
        }
        function lU(_r) {
          return function(Ui) {
            return Ui == null ? t3 : Ui[_r];
          };
        }
        function Dm(_r) {
          return function(Ui) {
            return _r == null ? t3 : _r[Ui];
          };
        }
        function Pre(_r, Ui, oi, es, Vl) {
          return Vl(_r, function(wf, Kd, Uf) {
            oi = es ? (es = false, wf) : Ui(oi, wf, Kd, Uf);
          }), oi;
        }
        function uU(_r, Ui) {
          var oi = _r.length;
          for (_r.sort(Ui); oi--; )
            _r[oi] = _r[oi].value;
          return _r;
        }
        function f9(_r, Ui) {
          for (var oi, es = -1, Vl = _r.length; ++es < Vl; ) {
            var wf = Ui(_r[es]);
            wf !== t3 && (oi = oi === t3 ? wf : oi + wf);
          }
          return oi;
        }
        function h9(_r, Ui) {
          for (var oi = -1, es = Array(_r); ++oi < _r; )
            es[oi] = Ui(oi);
          return es;
        }
        function cU(_r, Ui) {
          return wp(Ui, function(oi) {
            return [oi, _r[oi]];
          });
        }
        function Lre(_r) {
          return _r && _r.slice(0, Vre(_r) + 1).replace(eC, "");
        }
        function Iy(_r) {
          return function(Ui) {
            return _r(Ui);
          };
        }
        function fU(_r, Ui) {
          return wp(Ui, function(oi) {
            return _r[oi];
          });
        }
        function HL(_r, Ui) {
          return _r.has(Ui);
        }
        function hU(_r, Ui) {
          for (var oi = -1, es = _r.length; ++oi < es && G1(Ui, _r[oi], 0) > -1; )
            ;
          return oi;
        }
        function Rre(_r, Ui) {
          for (var oi = _r.length; oi-- && G1(Ui, _r[oi], 0) > -1; )
            ;
          return oi;
        }
        function pU(_r, Ui) {
          for (var oi = _r.length, es = 0; oi--; )
            _r[oi] === Ui && ++es;
          return es;
        }
        var gbe = Dm(pbe), dU = Dm(BL);
        function Nre(_r) {
          return "\\" + Zs[_r];
        }
        function vU(_r, Ui) {
          return _r == null ? t3 : _r[Ui];
        }
        function Eg(_r) {
          return Qo.test(_r);
        }
        function ybe(_r) {
          return Dre.test(_r);
        }
        function gU(_r) {
          for (var Ui, oi = []; !(Ui = _r.next()).done; )
            oi.push(Ui.value);
          return oi;
        }
        function yU(_r) {
          var Ui = -1, oi = Array(_r.size);
          return _r.forEach(function(es, Vl) {
            oi[++Ui] = [Vl, es];
          }), oi;
        }
        function Jw(_r, Ui) {
          return function(oi) {
            return _r(Ui(oi));
          };
        }
        function iC(_r, Ui) {
          for (var oi = -1, es = _r.length, Vl = 0, wf = []; ++oi < es; ) {
            var Kd = _r[oi];
            (Kd === Ui || Kd === k3) && (_r[oi] = k3, wf[Vl++] = oi);
          }
          return wf;
        }
        function p9(_r) {
          var Ui = -1, oi = Array(_r.size);
          return _r.forEach(function(es) {
            oi[++Ui] = es;
          }), oi;
        }
        function Fre(_r) {
          var Ui = -1, oi = Array(_r.size);
          return _r.forEach(function(es) {
            oi[++Ui] = [es, es];
          }), oi;
        }
        function mbe(_r, Ui, oi) {
          for (var es = oi - 1, Vl = _r.length; ++es < Vl; )
            if (_r[es] === Ui)
              return es;
          return -1;
        }
        function mU(_r, Ui, oi) {
          for (var es = oi + 1; es--; )
            if (_r[es] === Ui)
              return es;
          return es;
        }
        function JI(_r) {
          return Eg(_r) ? WL(_r) : vbe(_r);
        }
        function W_(_r) {
          return Eg(_r) ? _be(_r) : ZI(_r);
        }
        function Vre(_r) {
          for (var Ui = _r.length; Ui-- && QW.test(_r.charAt(Ui)); )
            ;
          return Ui;
        }
        var bbe = Dm($v);
        function WL(_r) {
          for (var Ui = FL.lastIndex = 0; FL.test(_r); )
            ++Ui;
          return Ui;
        }
        function _be(_r) {
          return _r.match(FL) || [];
        }
        function Bre(_r) {
          return _r.match(ac) || [];
        }
        var xbe = function _r(Ui) {
          Ui = Ui == null ? wh : QI.defaults(wh.Object(), Ui, QI.pick(wh, j1));
          var oi = Ui.Array, es = Ui.Date, Vl = Ui.Error, wf = Ui.Function, Kd = Ui.Math, Uf = Ui.Object, UL = Ui.RegExp, wbe = Ui.String, Ey = Ui.TypeError, x0 = oi.prototype, qL = wf.prototype, U_ = Uf.prototype, $L = Ui["__core-js_shared__"], Dk = qL.toString, Of = U_.hasOwnProperty, Sbe = 0, zre = function() {
            var U = /[^.]+$/.exec($L && $L.keys && $L.keys.IE_PROTO || "");
            return U ? "Symbol(src)_1." + U : "";
          }(), XL = U_.toString, bU = Dk.call(Uf), d9 = wh._, jre = UL("^" + Dk.call(Of).replace(Q2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), eE = Ik ? Ui.Buffer : t3, Dy = Ui.Symbol, tE = Ui.Uint8Array, _U = eE ? eE.allocUnsafe : t3, YL = Jw(Uf.getPrototypeOf, Uf), KL = Uf.create, q_ = U_.propertyIsEnumerable, ky = x0.splice, nE = Dy ? Dy.isConcatSpreadable : t3, Nb = Dy ? Dy.iterator : t3, lT = Dy ? Dy.toStringTag : t3, id2 = function() {
            try {
              var U = wT(Uf, "defineProperty");
              return U({}, "", {}), U;
            } catch {
            }
          }(), Gre = Ui.clearTimeout !== wh.clearTimeout && Ui.clearTimeout, v9 = es && es.now !== wh.Date.now && es.now, Hre = Ui.setTimeout !== wh.setTimeout && Ui.setTimeout, $_ = Kd.ceil, ZL = Kd.floor, xU = Uf.getOwnPropertySymbols, Yv = eE ? eE.isBuffer : t3, g9 = Ui.isFinite, Cbe = x0.join, Wre = Jw(Uf.keys, Uf), Hp = Kd.max, Dg = Kd.min, Mbe = es.now, Tbe = Ui.parseInt, y9 = Kd.random, Abe = x0.reverse, wU = wT(Ui, "DataView"), kk = wT(Ui, "Map"), SU = wT(Ui, "Promise"), Ok = wT(Ui, "Set"), aC = wT(Ui, "WeakMap"), Pk = wT(Uf, "create"), km = aC && new aC(), Lk = {}, JL = dE(wU), CU = dE(kk), Rk = dE(SU), MU = dE(Ok), uT = dE(aC), Oy = Dy ? Dy.prototype : t3, rE = Oy ? Oy.valueOf : t3, TU = Oy ? Oy.toString : t3;
          function Ut(U) {
            if (up(U) && !ql(U) && !(U instanceof kc)) {
              if (U instanceof Om)
                return U;
              if (Of.call(U, "__wrapped__"))
                return mie(U);
            }
            return new Om(U);
          }
          var X_ = function() {
            function U() {
            }
            return function(ae) {
              if (!Sp(ae))
                return {};
              if (KL)
                return KL(ae);
              U.prototype = ae;
              var Ie = new U();
              return U.prototype = t3, Ie;
            };
          }();
          function w0() {
          }
          function Om(U, ae) {
            this.__wrapped__ = U, this.__actions__ = [], this.__chain__ = !!ae, this.__index__ = 0, this.__values__ = t3;
          }
          Ut.templateSettings = { escape: Ig, evaluate: Pb, interpolate: Em, variable: "", imports: { _: Ut } }, Ut.prototype = w0.prototype, Ut.prototype.constructor = Ut, Om.prototype = X_(w0.prototype), Om.prototype.constructor = Om;
          function kc(U) {
            this.__wrapped__ = U, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = cr, this.__views__ = [];
          }
          function AU() {
            var U = new kc(this.__wrapped__);
            return U.__actions__ = Og(this.__actions__), U.__dir__ = this.__dir__, U.__filtered__ = this.__filtered__, U.__iteratees__ = Og(this.__iteratees__), U.__takeCount__ = this.__takeCount__, U.__views__ = Og(this.__views__), U;
          }
          function IU() {
            if (this.__filtered__) {
              var U = new kc(this);
              U.__dir__ = -1, U.__filtered__ = true;
            } else
              U = this.clone(), U.__dir__ *= -1;
            return U;
          }
          function Ibe() {
            var U = this.__wrapped__.value(), ae = this.__dir__, Ie = ql(U), Qe = ae < 0, At = Ie ? U.length : 0, en = Xbe(0, At, this.__views__), Hn = en.start, Qn = en.end, Or = Qn - Hn, ia = Qe ? Qn : Hn - 1, Qi = this.__iteratees__, pa = Qi.length, mo = 0, Ss = Dg(Or, this.__takeCount__);
            if (!Ie || !Qe && At == Or && Ss == Or)
              return sR(U, this.__actions__);
            var ul = [];
            e:
              for (; Or-- && mo < Ss; ) {
                ia += ae;
                for (var $l = -1, al = U[ia]; ++$l < pa; ) {
                  var bc = Qi[$l], Gu = bc.iteratee, Lg = bc.type, A0 = Gu(al);
                  if (Lg == Jt)
                    al = A0;
                  else if (!A0) {
                    if (Lg == jt)
                      continue e;
                    break e;
                  }
                }
                ul[mo++] = al;
              }
            return ul;
          }
          kc.prototype = X_(w0.prototype), kc.prototype.constructor = kc;
          function Y_(U) {
            var ae = -1, Ie = U == null ? 0 : U.length;
            for (this.clear(); ++ae < Ie; ) {
              var Qe = U[ae];
              this.set(Qe[0], Qe[1]);
            }
          }
          function m9() {
            this.__data__ = Pk ? Pk(null) : {}, this.size = 0;
          }
          function oC(U) {
            var ae = this.has(U) && delete this.__data__[U];
            return this.size -= ae ? 1 : 0, ae;
          }
          function b9(U) {
            var ae = this.__data__;
            if (Pk) {
              var Ie = ae[U];
              return Ie === M ? t3 : Ie;
            }
            return Of.call(ae, U) ? ae[U] : t3;
          }
          function _9(U) {
            var ae = this.__data__;
            return Pk ? ae[U] !== t3 : Of.call(ae, U);
          }
          function Nk(U, ae) {
            var Ie = this.__data__;
            return this.size += this.has(U) ? 0 : 1, Ie[U] = Pk && ae === t3 ? M : ae, this;
          }
          Y_.prototype.clear = m9, Y_.prototype.delete = oC, Y_.prototype.get = b9, Y_.prototype.has = _9, Y_.prototype.set = Nk;
          function Qw(U) {
            var ae = -1, Ie = U == null ? 0 : U.length;
            for (this.clear(); ++ae < Ie; ) {
              var Qe = U[ae];
              this.set(Qe[0], Qe[1]);
            }
          }
          function cT() {
            this.__data__ = [], this.size = 0;
          }
          function x9(U) {
            var ae = this.__data__, Ie = hT(ae, U);
            if (Ie < 0)
              return false;
            var Qe = ae.length - 1;
            return Ie == Qe ? ae.pop() : ky.call(ae, Ie, 1), --this.size, true;
          }
          function EU(U) {
            var ae = this.__data__, Ie = hT(ae, U);
            return Ie < 0 ? t3 : ae[Ie][1];
          }
          function Ebe(U) {
            return hT(this.__data__, U) > -1;
          }
          function Dbe(U, ae) {
            var Ie = this.__data__, Qe = hT(Ie, U);
            return Qe < 0 ? (++this.size, Ie.push([U, ae])) : Ie[Qe][1] = ae, this;
          }
          Qw.prototype.clear = cT, Qw.prototype.delete = x9, Qw.prototype.get = EU, Qw.prototype.has = Ebe, Qw.prototype.set = Dbe;
          function sC(U) {
            var ae = -1, Ie = U == null ? 0 : U.length;
            for (this.clear(); ++ae < Ie; ) {
              var Qe = U[ae];
              this.set(Qe[0], Qe[1]);
            }
          }
          function kbe() {
            this.size = 0, this.__data__ = { hash: new Y_(), map: new (kk || Qw)(), string: new Y_() };
          }
          function Obe(U) {
            var ae = pC(this, U).delete(U);
            return this.size -= ae ? 1 : 0, ae;
          }
          function Ure(U) {
            return pC(this, U).get(U);
          }
          function Pbe(U) {
            return pC(this, U).has(U);
          }
          function Lbe(U, ae) {
            var Ie = pC(this, U), Qe = Ie.size;
            return Ie.set(U, ae), this.size += Ie.size == Qe ? 0 : 1, this;
          }
          sC.prototype.clear = kbe, sC.prototype.delete = Obe, sC.prototype.get = Ure, sC.prototype.has = Pbe, sC.prototype.set = Lbe;
          function fT(U) {
            var ae = -1, Ie = U == null ? 0 : U.length;
            for (this.__data__ = new sC(); ++ae < Ie; )
              this.add(U[ae]);
          }
          function qre(U) {
            return this.__data__.set(U, M), this;
          }
          function Rbe(U) {
            return this.__data__.has(U);
          }
          fT.prototype.add = fT.prototype.push = qre, fT.prototype.has = Rbe;
          function Pm(U) {
            var ae = this.__data__ = new Qw(U);
            this.size = ae.size;
          }
          function $re() {
            this.__data__ = new Qw(), this.size = 0;
          }
          function Xre(U) {
            var ae = this.__data__, Ie = ae.delete(U);
            return this.size = ae.size, Ie;
          }
          function Nbe(U) {
            return this.__data__.get(U);
          }
          function DU(U) {
            return this.__data__.has(U);
          }
          function lC(U, ae) {
            var Ie = this.__data__;
            if (Ie instanceof Qw) {
              var Qe = Ie.__data__;
              if (!kk || Qe.length < p3 - 1)
                return Qe.push([U, ae]), this.size = ++Ie.size, this;
              Ie = this.__data__ = new sC(Qe);
            }
            return Ie.set(U, ae), this.size = Ie.size, this;
          }
          Pm.prototype.clear = $re, Pm.prototype.delete = Xre, Pm.prototype.get = Nbe, Pm.prototype.has = DU, Pm.prototype.set = lC;
          function w9(U, ae) {
            var Ie = ql(U), Qe = !Ie && ET(U), At = !Ie && !Qe && od(U), en = !Ie && !Qe && !At && Wb(U), Hn = Ie || Qe || At || en, Qn = Hn ? h9(U.length, wbe) : [], Or = Qn.length;
            for (var ia in U)
              (ae || Of.call(U, ia)) && !(Hn && (ia == "length" || At && (ia == "offset" || ia == "parent") || en && (ia == "buffer" || ia == "byteLength" || ia == "byteOffset") || dC(ia, Or))) && Qn.push(ia);
            return Qn;
          }
          function Yre(U) {
            var ae = U.length;
            return ae ? U[jb(0, ae - 1)] : t3;
          }
          function S9(U, ae) {
            return X9(Og(U), K_(ae, 0, U.length));
          }
          function Kre(U) {
            return X9(Og(U));
          }
          function kU(U, ae, Ie) {
            (Ie !== t3 && !qo(U[ae], Ie) || Ie === t3 && !(ae in U)) && Fb(U, ae, Ie);
          }
          function QL(U, ae, Ie) {
            var Qe = U[ae];
            (!(Of.call(U, ae) && qo(Qe, Ie)) || Ie === t3 && !(ae in U)) && Fb(U, ae, Ie);
          }
          function hT(U, ae) {
            for (var Ie = U.length; Ie--; )
              if (qo(U[Ie][0], ae))
                return Ie;
            return -1;
          }
          function C9(U, ae, Ie, Qe) {
            return Vb(U, function(At, en, Hn) {
              ae(Qe, At, Ie(At), Hn);
            }), Qe;
          }
          function Zre(U, ae) {
            return U && ex(ae, yv(ae), U);
          }
          function M9(U, ae) {
            return U && ex(ae, Vm(ae), U);
          }
          function Fb(U, ae, Ie) {
            ae == "__proto__" && id2 ? id2(U, ae, { configurable: true, enumerable: true, value: Ie, writable: true }) : U[ae] = Ie;
          }
          function T9(U, ae) {
            for (var Ie = -1, Qe = ae.length, At = oi(Qe), en = U == null; ++Ie < Qe; )
              At[Ie] = en ? t3 : zq(U, ae[Ie]);
            return At;
          }
          function K_(U, ae, Ie) {
            return U === U && (Ie !== t3 && (U = U <= Ie ? U : Ie), ae !== t3 && (U = U >= ae ? U : ae)), U;
          }
          function Lm(U, ae, Ie, Qe, At, en) {
            var Hn, Qn = ae & L, Or = ae & F, ia = ae & B;
            if (Ie && (Hn = At ? Ie(U, Qe, At, en) : Ie(U)), Hn !== t3)
              return Hn;
            if (!Sp(U))
              return U;
            var Qi = ql(U);
            if (Qi) {
              if (Hn = dR(U), !Qn)
                return Og(U, Hn);
            } else {
              var pa = S0(U), mo = pa == Zo || pa == rc;
              if (od(U))
                return V9(U, Qn);
              if (pa == ef || pa == Do || mo && !At) {
                if (Hn = Or || mo ? {} : Cd(U), !Qn)
                  return Or ? qbe(U, M9(Hn, U)) : Ube(U, Zre(Hn, U));
              } else {
                if (!qh[pa])
                  return At ? U : {};
                Hn = nq(U, pa, Qn);
              }
            }
            en || (en = new Pm());
            var Ss = en.get(U);
            if (Ss)
              return Ss;
            en.set(U, Hn), Xie(U) ? U.forEach(function(al) {
              Hn.add(Lm(al, ae, Ie, al, U, en));
            }) : Oq(U) && U.forEach(function(al, bc) {
              Hn.set(bc, Lm(al, ae, Ie, bc, U, en));
            });
            var ul = ia ? Or ? W9 : H9 : Or ? Vm : yv, $l = Qi ? t3 : ul(U);
            return Yd($l || U, function(al, bc) {
              $l && (bc = al, al = U[bc]), QL(Hn, bc, Lm(al, ae, Ie, bc, U, en));
            }), Hn;
          }
          function OU(U) {
            var ae = yv(U);
            return function(Ie) {
              return PU(Ie, U, ae);
            };
          }
          function PU(U, ae, Ie) {
            var Qe = Ie.length;
            if (U == null)
              return !Qe;
            for (U = Uf(U); Qe--; ) {
              var At = Ie[Qe], en = ae[At], Hn = U[At];
              if (Hn === t3 && !(At in U) || !en(Hn))
                return false;
            }
            return true;
          }
          function LU(U, ae, Ie) {
            if (typeof U != "function")
              throw new Ey(b3);
            return Rm(function() {
              U.apply(t3, Ie);
            }, ae);
          }
          function pT(U, ae, Ie, Qe) {
            var At = -1, en = Yw, Hn = true, Qn = U.length, Or = [], ia = ae.length;
            if (!Qn)
              return Or;
            Ie && (ae = wp(ae, Iy(Ie))), Qe ? (en = GL, Hn = false) : ae.length >= p3 && (en = HL, Hn = false, ae = new fT(ae));
            e:
              for (; ++At < Qn; ) {
                var Qi = U[At], pa = Ie == null ? Qi : Ie(Qi);
                if (Qi = Qe || Qi !== 0 ? Qi : 0, Hn && pa === pa) {
                  for (var mo = ia; mo--; )
                    if (ae[mo] === pa)
                      continue e;
                  Or.push(Qi);
                } else
                  en(ae, pa, Qe) || Or.push(Qi);
              }
            return Or;
          }
          var Vb = sie(Z_), Jre = sie(I9, true);
          function RU(U, ae) {
            var Ie = true;
            return Vb(U, function(Qe, At, en) {
              return Ie = !!ae(Qe, At, en), Ie;
            }), Ie;
          }
          function uC(U, ae, Ie) {
            for (var Qe = -1, At = U.length; ++Qe < At; ) {
              var en = U[Qe], Hn = ae(en);
              if (Hn != null && (Qn === t3 ? Hn === Hn && !Ny(Hn) : Ie(Hn, Qn)))
                var Qn = Hn, Or = en;
            }
            return Or;
          }
          function Fbe(U, ae, Ie, Qe) {
            var At = U.length;
            for (Ie = pu(Ie), Ie < 0 && (Ie = -Ie > At ? 0 : At + Ie), Qe = Qe === t3 || Qe > At ? At : pu(Qe), Qe < 0 && (Qe += At), Qe = Ie > Qe ? 0 : Nq(Qe); Ie < Qe; )
              U[Ie++] = ae;
            return U;
          }
          function Qre(U, ae) {
            var Ie = [];
            return Vb(U, function(Qe, At, en) {
              ae(Qe, At, en) && Ie.push(Qe);
            }), Ie;
          }
          function kg(U, ae, Ie, Qe, At) {
            var en = -1, Hn = U.length;
            for (Ie || (Ie = Kbe), At || (At = []); ++en < Hn; ) {
              var Qn = U[en];
              ae > 0 && Ie(Qn) ? ae > 1 ? kg(Qn, ae - 1, Ie, Qe, At) : Kw(At, Qn) : Qe || (At[At.length] = Qn);
            }
            return At;
          }
          var eR = UU(), A9 = UU(true);
          function Z_(U, ae) {
            return U && eR(U, ae, yv);
          }
          function I9(U, ae) {
            return U && A9(U, ae, yv);
          }
          function Fk(U, ae) {
            return Xw(ae, function(Ie) {
              return $1(U[Ie]);
            });
          }
          function iE(U, ae) {
            ae = _T(ae, U);
            for (var Ie = 0, Qe = ae.length; U != null && Ie < Qe; )
              U = U[tS(ae[Ie++])];
            return Ie && Ie == Qe ? U : t3;
          }
          function E9(U, ae, Ie) {
            var Qe = ae(U);
            return ql(U) ? Qe : Kw(Qe, Ie(U));
          }
          function Py(U) {
            return U == null ? U === t3 ? Hw : gc : lT && lT in Uf(U) ? $be(U) : Qbe(U);
          }
          function D9(U, ae) {
            return U > ae;
          }
          function Vbe(U, ae) {
            return U != null && Of.call(U, ae);
          }
          function J_(U, ae) {
            return U != null && ae in Uf(U);
          }
          function NU(U, ae, Ie) {
            return U >= Dg(ae, Ie) && U < Hp(ae, Ie);
          }
          function FU(U, ae, Ie) {
            for (var Qe = Ie ? GL : Yw, At = U[0].length, en = U.length, Hn = en, Qn = oi(en), Or = 1 / 0, ia = []; Hn--; ) {
              var Qi = U[Hn];
              Hn && ae && (Qi = wp(Qi, Iy(ae))), Or = Dg(Qi.length, Or), Qn[Hn] = !Ie && (ae || At >= 120 && Qi.length >= 120) ? new fT(Hn && Qi) : t3;
            }
            Qi = U[0];
            var pa = -1, mo = Qn[0];
            e:
              for (; ++pa < At && ia.length < Or; ) {
                var Ss = Qi[pa], ul = ae ? ae(Ss) : Ss;
                if (Ss = Ie || Ss !== 0 ? Ss : 0, !(mo ? HL(mo, ul) : Qe(ia, ul, Ie))) {
                  for (Hn = en; --Hn; ) {
                    var $l = Qn[Hn];
                    if (!($l ? HL($l, ul) : Qe(U[Hn], ul, Ie)))
                      continue e;
                  }
                  mo && mo.push(ul), ia.push(Ss);
                }
              }
            return ia;
          }
          function Bbe(U, ae, Ie, Qe) {
            return Z_(U, function(At, en, Hn) {
              ae(Qe, Ie(At), en, Hn);
            }), Qe;
          }
          function dT(U, ae, Ie) {
            ae = _T(ae, U), U = iq(U, ae);
            var Qe = U == null ? U : U[tS(U1(ae))];
            return Qe == null ? t3 : gv(Qe, U, Ie);
          }
          function k9(U) {
            return up(U) && Py(U) == Do;
          }
          function eie(U) {
            return up(U) && Py(U) == Xr;
          }
          function zbe(U) {
            return up(U) && Py(U) == ho;
          }
          function tR(U, ae, Ie, Qe, At) {
            return U === ae ? true : U == null || ae == null || !up(U) && !up(ae) ? U !== U && ae !== ae : tie(U, ae, Ie, Qe, tR, At);
          }
          function tie(U, ae, Ie, Qe, At, en) {
            var Hn = ql(U), Qn = ql(ae), Or = Hn ? _o : S0(U), ia = Qn ? _o : S0(ae);
            Or = Or == Do ? ef : Or, ia = ia == Do ? ef : ia;
            var Qi = Or == ef, pa = ia == ef, mo = Or == ia;
            if (mo && od(U)) {
              if (!od(ae))
                return false;
              Hn = true, Qi = false;
            }
            if (mo && !Qi)
              return en || (en = new Pm()), Hn || Wb(U) ? JU(U, ae, Ie, Qe, At, en) : hie(U, ae, Or, Ie, Qe, At, en);
            if (!(Ie & G)) {
              var Ss = Qi && Of.call(U, "__wrapped__"), ul = pa && Of.call(ae, "__wrapped__");
              if (Ss || ul) {
                var $l = Ss ? U.value() : U, al = ul ? ae.value() : ae;
                return en || (en = new Pm()), At($l, al, Ie, Qe, en);
              }
            }
            return mo ? (en || (en = new Pm()), pie(U, ae, Ie, Qe, At, en)) : false;
          }
          function O9(U) {
            return up(U) && S0(U) == ys;
          }
          function nR(U, ae, Ie, Qe) {
            var At = Ie.length, en = At, Hn = !Qe;
            if (U == null)
              return !en;
            for (U = Uf(U); At--; ) {
              var Qn = Ie[At];
              if (Hn && Qn[2] ? Qn[1] !== U[Qn[0]] : !(Qn[0] in U))
                return false;
            }
            for (; ++At < en; ) {
              Qn = Ie[At];
              var Or = Qn[0], ia = U[Or], Qi = Qn[1];
              if (Hn && Qn[2]) {
                if (ia === t3 && !(Or in U))
                  return false;
              } else {
                var pa = new Pm();
                if (Qe)
                  var mo = Qe(ia, Qi, Or, U, ae, pa);
                if (!(mo === t3 ? tR(Qi, ia, G | J, Qe, pa) : mo))
                  return false;
              }
            }
            return true;
          }
          function P9(U) {
            if (!Sp(U) || Zbe(U))
              return false;
            var ae = $1(U) ? jre : Gi;
            return ae.test(dE(U));
          }
          function VU(U) {
            return up(U) && Py(U) == Ag;
          }
          function jbe(U) {
            return up(U) && S0(U) == eh;
          }
          function Bb(U) {
            return up(U) && CR(U.length) && !!th[Py(U)];
          }
          function rR(U) {
            return typeof U == "function" ? U : U == null ? Fy : typeof U == "object" ? ql(U) ? aE(U[0], U[1]) : L9(U) : e$(U);
          }
          function iR(U) {
            if (!pE(U))
              return Wre(U);
            var ae = [];
            for (var Ie in Uf(U))
              Of.call(U, Ie) && Ie != "constructor" && ae.push(Ie);
            return ae;
          }
          function cC(U) {
            if (!Sp(U))
              return Jbe(U);
            var ae = pE(U), Ie = [];
            for (var Qe in U)
              Qe == "constructor" && (ae || !Of.call(U, Qe)) || Ie.push(Qe);
            return Ie;
          }
          function zb(U, ae) {
            return U < ae;
          }
          function vT(U, ae) {
            var Ie = -1, Qe = C0(U) ? oi(U.length) : [];
            return Vb(U, function(At, en, Hn) {
              Qe[++Ie] = ae(At, en, Hn);
            }), Qe;
          }
          function L9(U) {
            var ae = QU(U);
            return ae.length == 1 && ae[0][2] ? vie(ae[0][0], ae[0][1]) : function(Ie) {
              return Ie === U || nR(Ie, U, ae);
            };
          }
          function aE(U, ae) {
            return rq(U) && ad(ae) ? vie(tS(U), ae) : function(Ie) {
              var Qe = zq(Ie, U);
              return Qe === t3 && Qe === ae ? h7(Ie, U) : tR(ae, Qe, G | J);
            };
          }
          function R9(U, ae, Ie, Qe, At) {
            U !== ae && eR(ae, function(en, Hn) {
              if (At || (At = new Pm()), Sp(en))
                nie(U, ae, Hn, Ie, R9, Qe, At);
              else {
                var Qn = Qe ? Qe(vC(U, Hn), en, Hn + "", U, ae, At) : t3;
                Qn === t3 && (Qn = en), kU(U, Hn, Qn);
              }
            }, Vm);
          }
          function nie(U, ae, Ie, Qe, At, en, Hn) {
            var Qn = vC(U, Ie), Or = vC(ae, Ie), ia = Hn.get(Or);
            if (ia) {
              kU(U, Ie, ia);
              return;
            }
            var Qi = en ? en(Qn, Or, Ie + "", U, ae, Hn) : t3, pa = Qi === t3;
            if (pa) {
              var mo = ql(Or), Ss = !mo && od(Or), ul = !mo && !Ss && Wb(Or);
              Qi = Or, mo || Ss || ul ? ql(Qn) ? Qi = Qn : lp(Qn) ? Qi = Og(Qn) : Ss ? (pa = false, Qi = V9(Or, true)) : ul ? (pa = false, Qi = aie(Or, true)) : Qi = [] : DT(Or) || ET(Or) ? (Qi = Qn, ET(Qn) ? Qi = c7(Qn) : (!Sp(Qn) || $1(Qn)) && (Qi = Cd(Or))) : pa = false;
            }
            pa && (Hn.set(Or, Qi), At(Qi, Or, Qe, en, Hn), Hn.delete(Or)), kU(U, Ie, Qi);
          }
          function BU(U, ae) {
            var Ie = U.length;
            if (Ie)
              return ae += ae < 0 ? Ie : 0, dC(ae, Ie) ? U[ae] : t3;
          }
          function gT(U, ae, Ie) {
            ae.length ? ae = wp(ae, function(en) {
              return ql(en) ? function(Hn) {
                return iE(Hn, en.length === 1 ? en[0] : en);
              } : en;
            }) : ae = [Fy];
            var Qe = -1;
            ae = wp(ae, Iy(Js()));
            var At = vT(U, function(en, Hn, Qn) {
              var Or = wp(ae, function(ia) {
                return ia(en);
              });
              return { criteria: Or, index: ++Qe, value: en };
            });
            return uU(At, function(en, Hn) {
              return oie(en, Hn, Ie);
            });
          }
          function oE(U, ae) {
            return sE(U, ae, function(Ie, Qe) {
              return h7(U, Qe);
            });
          }
          function sE(U, ae, Ie) {
            for (var Qe = -1, At = ae.length, en = {}; ++Qe < At; ) {
              var Hn = ae[Qe], Qn = iE(U, Hn);
              Ie(Qn, Hn) && yT(en, _T(Hn, U), Qn);
            }
            return en;
          }
          function zU(U) {
            return function(ae) {
              return iE(ae, U);
            };
          }
          function aR(U, ae, Ie, Qe) {
            var At = Qe ? Ek : G1, en = -1, Hn = ae.length, Qn = U;
            for (U === ae && (ae = Og(ae)), Ie && (Qn = wp(U, Iy(Ie))); ++en < Hn; )
              for (var Or = 0, ia = ae[en], Qi = Ie ? Ie(ia) : ia; (Or = At(Qn, Qi, Or, Qe)) > -1; )
                Qn !== U && ky.call(Qn, Or, 1), ky.call(U, Or, 1);
            return U;
          }
          function rie(U, ae) {
            for (var Ie = U ? ae.length : 0, Qe = Ie - 1; Ie--; ) {
              var At = ae[Ie];
              if (Ie == Qe || At !== en) {
                var en = At;
                dC(At) ? ky.call(U, At, 1) : cE(U, At);
              }
            }
            return U;
          }
          function jb(U, ae) {
            return U + ZL(y9() * (ae - U + 1));
          }
          function iie(U, ae, Ie, Qe) {
            for (var At = -1, en = Hp($_((ae - U) / (Ie || 1)), 0), Hn = oi(en); en--; )
              Hn[Qe ? en : ++At] = U, U += Ie;
            return Hn;
          }
          function Q_(U, ae) {
            var Ie = "";
            if (!U || ae < 1 || ae > ln)
              return Ie;
            do
              ae % 2 && (Ie += U), ae = ZL(ae / 2), ae && (U += U);
            while (ae);
            return Ie;
          }
          function Bu(U, ae) {
            return oq(q9(U, ae, Fy), U + "");
          }
          function zs(U) {
            return Yre(Hk(U));
          }
          function N9(U, ae) {
            var Ie = Hk(U);
            return X9(Ie, K_(ae, 0, Ie.length));
          }
          function yT(U, ae, Ie, Qe) {
            if (!Sp(U))
              return U;
            ae = _T(ae, U);
            for (var At = -1, en = ae.length, Hn = en - 1, Qn = U; Qn != null && ++At < en; ) {
              var Or = tS(ae[At]), ia = Ie;
              if (Or === "__proto__" || Or === "constructor" || Or === "prototype")
                return U;
              if (At != Hn) {
                var Qi = Qn[Or];
                ia = Qe ? Qe(Qi, Or, Qn) : t3, ia === t3 && (ia = Sp(Qi) ? Qi : dC(ae[At + 1]) ? [] : {});
              }
              QL(Qn, Or, ia), Qn = Qn[Or];
            }
            return U;
          }
          var mT = km ? function(U, ae) {
            return km.set(U, ae), U;
          } : Fy, lE = id2 ? function(U, ae) {
            return id2(U, "toString", { configurable: true, enumerable: false, value: y7(ae), writable: true });
          } : Fy;
          function uE(U) {
            return X9(Hk(U));
          }
          function Kv(U, ae, Ie) {
            var Qe = -1, At = U.length;
            ae < 0 && (ae = -ae > At ? 0 : At + ae), Ie = Ie > At ? At : Ie, Ie < 0 && (Ie += At), At = ae > Ie ? 0 : Ie - ae >>> 0, ae >>>= 0;
            for (var en = oi(At); ++Qe < At; )
              en[Qe] = U[Qe + ae];
            return en;
          }
          function oR(U, ae) {
            var Ie;
            return Vb(U, function(Qe, At, en) {
              return Ie = ae(Qe, At, en), !Ie;
            }), !!Ie;
          }
          function bT(U, ae, Ie) {
            var Qe = 0, At = U == null ? Qe : U.length;
            if (typeof ae == "number" && ae === ae && At <= ha) {
              for (; Qe < At; ) {
                var en = Qe + At >>> 1, Hn = U[en];
                Hn !== null && !Ny(Hn) && (Ie ? Hn <= ae : Hn < ae) ? Qe = en + 1 : At = en;
              }
              return At;
            }
            return jU(U, ae, Fy, Ie);
          }
          function jU(U, ae, Ie, Qe) {
            var At = 0, en = U == null ? 0 : U.length;
            if (en === 0)
              return 0;
            ae = Ie(ae);
            for (var Hn = ae !== ae, Qn = ae === null, Or = Ny(ae), ia = ae === t3; At < en; ) {
              var Qi = ZL((At + en) / 2), pa = Ie(U[Qi]), mo = pa !== t3, Ss = pa === null, ul = pa === pa, $l = Ny(pa);
              if (Hn)
                var al = Qe || ul;
              else
                ia ? al = ul && (Qe || mo) : Qn ? al = ul && mo && (Qe || !Ss) : Or ? al = ul && mo && !Ss && (Qe || !$l) : Ss || $l ? al = false : al = Qe ? pa <= ae : pa < ae;
              al ? At = Qi + 1 : en = Qi;
            }
            return Dg(en, gr);
          }
          function il(U, ae) {
            for (var Ie = -1, Qe = U.length, At = 0, en = []; ++Ie < Qe; ) {
              var Hn = U[Ie], Qn = ae ? ae(Hn) : Hn;
              if (!Ie || !qo(Qn, Or)) {
                var Or = Qn;
                en[At++] = Hn === 0 ? 0 : Hn;
              }
            }
            return en;
          }
          function GU(U) {
            return typeof U == "number" ? U : Ny(U) ? kn : +U;
          }
          function sp(U) {
            if (typeof U == "string")
              return U;
            if (ql(U))
              return wp(U, sp) + "";
            if (Ny(U))
              return TU ? TU.call(U) : "";
            var ae = U + "";
            return ae == "0" && 1 / U == -Jn ? "-0" : ae;
          }
          function fC(U, ae, Ie) {
            var Qe = -1, At = Yw, en = U.length, Hn = true, Qn = [], Or = Qn;
            if (Ie)
              Hn = false, At = GL;
            else if (en >= p3) {
              var ia = ae ? null : YU(U);
              if (ia)
                return p9(ia);
              Hn = false, At = HL, Or = new fT();
            } else
              Or = ae ? [] : Qn;
            e:
              for (; ++Qe < en; ) {
                var Qi = U[Qe], pa = ae ? ae(Qi) : Qi;
                if (Qi = Ie || Qi !== 0 ? Qi : 0, Hn && pa === pa) {
                  for (var mo = Or.length; mo--; )
                    if (Or[mo] === pa)
                      continue e;
                  ae && Or.push(pa), Qn.push(Qi);
                } else
                  At(Or, pa, Ie) || (Or !== Qn && Or.push(pa), Qn.push(Qi));
              }
            return Qn;
          }
          function cE(U, ae) {
            return ae = _T(ae, U), U = iq(U, ae), U == null || delete U[tS(U1(ae))];
          }
          function Vk(U, ae, Ie, Qe) {
            return yT(U, ae, Ie(iE(U, ae)), Qe);
          }
          function hC(U, ae, Ie, Qe) {
            for (var At = U.length, en = Qe ? At : -1; (Qe ? en-- : ++en < At) && ae(U[en], en, U); )
              ;
            return Ie ? Kv(U, Qe ? 0 : en, Qe ? en + 1 : At) : Kv(U, Qe ? en + 1 : 0, Qe ? At : en);
          }
          function sR(U, ae) {
            var Ie = U;
            return Ie instanceof kc && (Ie = Ie.value()), KI(ae, function(Qe, At) {
              return At.func.apply(At.thisArg, Kw([Qe], At.args));
            }, Ie);
          }
          function H1(U, ae, Ie) {
            var Qe = U.length;
            if (Qe < 2)
              return Qe ? fC(U[0]) : [];
            for (var At = -1, en = oi(Qe); ++At < Qe; )
              for (var Hn = U[At], Qn = -1; ++Qn < Qe; )
                Qn != At && (en[At] = pT(en[At] || Hn, U[Qn], ae, Ie));
            return fC(kg(en, 1), ae, Ie);
          }
          function lR(U, ae, Ie) {
            for (var Qe = -1, At = U.length, en = ae.length, Hn = {}; ++Qe < At; ) {
              var Qn = Qe < en ? ae[Qe] : t3;
              Ie(Hn, U[Qe], Qn);
            }
            return Hn;
          }
          function uR(U) {
            return lp(U) ? U : [];
          }
          function cR(U) {
            return typeof U == "function" ? U : Fy;
          }
          function _T(U, ae) {
            return ql(U) ? U : rq(U, ae) ? [U] : sq(Lf(U));
          }
          var Bk = Bu;
          function xT(U, ae, Ie) {
            var Qe = U.length;
            return Ie = Ie === t3 ? Qe : Ie, !ae && Ie >= Qe ? U : Kv(U, ae, Ie);
          }
          var F9 = Gre || function(U) {
            return wh.clearTimeout(U);
          };
          function V9(U, ae) {
            if (ae)
              return U.slice();
            var Ie = U.length, Qe = _U ? _U(Ie) : new U.constructor(Ie);
            return U.copy(Qe), Qe;
          }
          function fR(U) {
            var ae = new U.constructor(U.byteLength);
            return new tE(ae).set(new tE(U)), ae;
          }
          function Gbe(U, ae) {
            var Ie = ae ? fR(U.buffer) : U.buffer;
            return new U.constructor(Ie, U.byteOffset, U.byteLength);
          }
          function Hbe(U) {
            var ae = new U.constructor(U.source, _n.exec(U));
            return ae.lastIndex = U.lastIndex, ae;
          }
          function Wbe(U) {
            return rE ? Uf(rE.call(U)) : {};
          }
          function aie(U, ae) {
            var Ie = ae ? fR(U.buffer) : U.buffer;
            return new U.constructor(Ie, U.byteOffset, U.length);
          }
          function HU(U, ae) {
            if (U !== ae) {
              var Ie = U !== t3, Qe = U === null, At = U === U, en = Ny(U), Hn = ae !== t3, Qn = ae === null, Or = ae === ae, ia = Ny(ae);
              if (!Qn && !ia && !en && U > ae || en && Hn && Or && !Qn && !ia || Qe && Hn && Or || !Ie && Or || !At)
                return 1;
              if (!Qe && !en && !ia && U < ae || ia && Ie && At && !Qe && !en || Qn && Ie && At || !Hn && At || !Or)
                return -1;
            }
            return 0;
          }
          function oie(U, ae, Ie) {
            for (var Qe = -1, At = U.criteria, en = ae.criteria, Hn = At.length, Qn = Ie.length; ++Qe < Hn; ) {
              var Or = HU(At[Qe], en[Qe]);
              if (Or) {
                if (Qe >= Qn)
                  return Or;
                var ia = Ie[Qe];
                return Or * (ia == "desc" ? -1 : 1);
              }
            }
            return U.index - ae.index;
          }
          function WU(U, ae, Ie, Qe) {
            for (var At = -1, en = U.length, Hn = Ie.length, Qn = -1, Or = ae.length, ia = Hp(en - Hn, 0), Qi = oi(Or + ia), pa = !Qe; ++Qn < Or; )
              Qi[Qn] = ae[Qn];
            for (; ++At < Hn; )
              (pa || At < en) && (Qi[Ie[At]] = U[At]);
            for (; ia--; )
              Qi[Qn++] = U[At++];
            return Qi;
          }
          function fs(U, ae, Ie, Qe) {
            for (var At = -1, en = U.length, Hn = -1, Qn = Ie.length, Or = -1, ia = ae.length, Qi = Hp(en - Qn, 0), pa = oi(Qi + ia), mo = !Qe; ++At < Qi; )
              pa[At] = U[At];
            for (var Ss = At; ++Or < ia; )
              pa[Ss + Or] = ae[Or];
            for (; ++Hn < Qn; )
              (mo || At < en) && (pa[Ss + Ie[Hn]] = U[At++]);
            return pa;
          }
          function Og(U, ae) {
            var Ie = -1, Qe = U.length;
            for (ae || (ae = oi(Qe)); ++Ie < Qe; )
              ae[Ie] = U[Ie];
            return ae;
          }
          function ex(U, ae, Ie, Qe) {
            var At = !Ie;
            Ie || (Ie = {});
            for (var en = -1, Hn = ae.length; ++en < Hn; ) {
              var Qn = ae[en], Or = Qe ? Qe(Ie[Qn], U[Qn], Qn, Ie, U) : t3;
              Or === t3 && (Or = U[Qn]), At ? Fb(Ie, Qn, Or) : QL(Ie, Qn, Or);
            }
            return Ie;
          }
          function Ube(U, ae) {
            return ex(U, eq(U), ae);
          }
          function qbe(U, ae) {
            return ex(U, die(U), ae);
          }
          function B9(U, ae) {
            return function(Ie, Qe) {
              var At = ql(Ie) ? Ay : C9, en = ae ? ae() : {};
              return At(Ie, U, Js(Qe, 2), en);
            };
          }
          function fE(U) {
            return Bu(function(ae, Ie) {
              var Qe = -1, At = Ie.length, en = At > 1 ? Ie[At - 1] : t3, Hn = At > 2 ? Ie[2] : t3;
              for (en = U.length > 3 && typeof en == "function" ? (At--, en) : t3, Hn && Ly(Ie[0], Ie[1], Hn) && (en = At < 3 ? t3 : en, At = 1), ae = Uf(ae); ++Qe < At; ) {
                var Qn = Ie[Qe];
                Qn && U(ae, Qn, Qe, en);
              }
              return ae;
            });
          }
          function sie(U, ae) {
            return function(Ie, Qe) {
              if (Ie == null)
                return Ie;
              if (!C0(Ie))
                return U(Ie, Qe);
              for (var At = Ie.length, en = ae ? At : -1, Hn = Uf(Ie); (ae ? en-- : ++en < At) && Qe(Hn[en], en, Hn) !== false; )
                ;
              return Ie;
            };
          }
          function UU(U) {
            return function(ae, Ie, Qe) {
              for (var At = -1, en = Uf(ae), Hn = Qe(ae), Qn = Hn.length; Qn--; ) {
                var Or = Hn[U ? Qn : ++At];
                if (Ie(en[Or], Or, en) === false)
                  break;
              }
              return ae;
            };
          }
          function lie(U, ae, Ie) {
            var Qe = ae & Q, At = Ia(U);
            function en() {
              var Hn = this && this !== wh && this instanceof en ? At : U;
              return Hn.apply(Qe ? Ie : this, arguments);
            }
            return en;
          }
          function uie(U) {
            return function(ae) {
              ae = Lf(ae);
              var Ie = Eg(ae) ? W_(ae) : t3, Qe = Ie ? Ie[0] : ae.charAt(0), At = Ie ? xT(Ie, 1).join("") : ae.slice(1);
              return Qe[U]() + At;
            };
          }
          function zu(U) {
            return function(ae) {
              return KI(vae(d7(ae).replace(jo, "")), U, "");
            };
          }
          function Ia(U) {
            return function() {
              var ae = arguments;
              switch (ae.length) {
                case 0:
                  return new U();
                case 1:
                  return new U(ae[0]);
                case 2:
                  return new U(ae[0], ae[1]);
                case 3:
                  return new U(ae[0], ae[1], ae[2]);
                case 4:
                  return new U(ae[0], ae[1], ae[2], ae[3]);
                case 5:
                  return new U(ae[0], ae[1], ae[2], ae[3], ae[4]);
                case 6:
                  return new U(ae[0], ae[1], ae[2], ae[3], ae[4], ae[5]);
                case 7:
                  return new U(ae[0], ae[1], ae[2], ae[3], ae[4], ae[5], ae[6]);
              }
              var Ie = X_(U.prototype), Qe = U.apply(Ie, ae);
              return Sp(Qe) ? Qe : Ie;
            };
          }
          function Wp(U, ae, Ie) {
            var Qe = Ia(U);
            function At() {
              for (var en = arguments.length, Hn = oi(en), Qn = en, Or = Gb(At); Qn--; )
                Hn[Qn] = arguments[Qn];
              var ia = en < 3 && Hn[0] !== Or && Hn[en - 1] !== Or ? [] : iC(Hn, Or);
              if (en -= ia.length, en < Ie)
                return nx(U, ae, z9, At.placeholder, t3, Hn, ia, t3, t3, Ie - en);
              var Qi = this && this !== wh && this instanceof At ? Qe : U;
              return gv(Qi, this, Hn);
            }
            return At;
          }
          function W1(U) {
            return function(ae, Ie, Qe) {
              var At = Uf(ae);
              if (!C0(ae)) {
                var en = Js(Ie, 3);
                ae = yv(ae), Ie = function(Qn) {
                  return en(At[Qn], Qn, At);
                };
              }
              var Hn = U(ae, Ie, Qe);
              return Hn > -1 ? At[en ? ae[Hn] : Hn] : t3;
            };
          }
          function tx(U) {
            return Ul(function(ae) {
              var Ie = ae.length, Qe = Ie, At = Om.prototype.thru;
              for (U && ae.reverse(); Qe--; ) {
                var en = ae[Qe];
                if (typeof en != "function")
                  throw new Ey(b3);
                if (At && !Hn && jc(en) == "wrapper")
                  var Hn = new Om([], true);
              }
              for (Qe = Hn ? Qe : Ie; ++Qe < Ie; ) {
                en = ae[Qe];
                var Qn = jc(en), Or = Qn == "wrapper" ? U9(en) : t3;
                Or && hu(Or[0]) && Or[1] == (ze | be | Fe | $e) && !Or[4].length && Or[9] == 1 ? Hn = Hn[jc(Or[0])].apply(Hn, Or[3]) : Hn = en.length == 1 && hu(en) ? Hn[Qn]() : Hn.thru(en);
              }
              return function() {
                var ia = arguments, Qi = ia[0];
                if (Hn && ia.length == 1 && ql(Qi))
                  return Hn.plant(Qi).value();
                for (var pa = 0, mo = Ie ? ae[pa].apply(this, ia) : Qi; ++pa < Ie; )
                  mo = ae[pa].call(this, mo);
                return mo;
              };
            });
          }
          function z9(U, ae, Ie, Qe, At, en, Hn, Qn, Or, ia) {
            var Qi = ae & ze, pa = ae & Q, mo = ae & se, Ss = ae & (be | de), ul = ae & Ke, $l = mo ? t3 : Ia(U);
            function al() {
              for (var bc = arguments.length, Gu = oi(bc), Lg = bc; Lg--; )
                Gu[Lg] = arguments[Lg];
              if (Ss)
                var A0 = Gb(al), Vy = pU(Gu, A0);
              if (Qe && (Gu = WU(Gu, Qe, At, Ss)), en && (Gu = fs(Gu, en, Hn, Ss)), bc -= Vy, Ss && bc < ia) {
                var Md = iC(Gu, A0);
                return nx(U, ae, z9, al.placeholder, Ie, Gu, Md, Qn, Or, ia - bc);
              }
              var I0 = pa ? Ie : this, hS = mo ? I0[U] : U;
              return bc = Gu.length, Qn ? Gu = e_e(Gu, Qn) : ul && bc > 1 && Gu.reverse(), Qi && Or < bc && (Gu.length = Or), this && this !== wh && this instanceof al && (hS = $l || Ia(hS)), hS.apply(I0, Gu);
            }
            return al;
          }
          function qU(U, ae) {
            return function(Ie, Qe) {
              return Bbe(Ie, U, ae(Qe), {});
            };
          }
          function j9(U, ae) {
            return function(Ie, Qe) {
              var At;
              if (Ie === t3 && Qe === t3)
                return ae;
              if (Ie !== t3 && (At = Ie), Qe !== t3) {
                if (At === t3)
                  return Qe;
                typeof Ie == "string" || typeof Qe == "string" ? (Ie = sp(Ie), Qe = sp(Qe)) : (Ie = GU(Ie), Qe = GU(Qe)), At = U(Ie, Qe);
              }
              return At;
            };
          }
          function $U(U) {
            return Ul(function(ae) {
              return ae = wp(ae, Iy(Js())), Bu(function(Ie) {
                var Qe = this;
                return U(ae, function(At) {
                  return gv(At, Qe, Ie);
                });
              });
            });
          }
          function hR(U, ae) {
            ae = ae === t3 ? " " : sp(ae);
            var Ie = ae.length;
            if (Ie < 2)
              return Ie ? Q_(ae, U) : ae;
            var Qe = Q_(ae, $_(U / JI(ae)));
            return Eg(ae) ? xT(W_(Qe), 0, U).join("") : Qe.slice(0, U);
          }
          function cie(U, ae, Ie, Qe) {
            var At = ae & Q, en = Ia(U);
            function Hn() {
              for (var Qn = -1, Or = arguments.length, ia = -1, Qi = Qe.length, pa = oi(Qi + Or), mo = this && this !== wh && this instanceof Hn ? en : U; ++ia < Qi; )
                pa[ia] = Qe[ia];
              for (; Or--; )
                pa[ia++] = arguments[++Qn];
              return gv(mo, At ? Ie : this, pa);
            }
            return Hn;
          }
          function pR(U) {
            return function(ae, Ie, Qe) {
              return Qe && typeof Qe != "number" && Ly(ae, Ie, Qe) && (Ie = Qe = t3), ae = uS(ae), Ie === t3 ? (Ie = ae, ae = 0) : Ie = uS(Ie), Qe = Qe === t3 ? ae < Ie ? 1 : -1 : uS(Qe), iie(ae, Ie, Qe, U);
            };
          }
          function G9(U) {
            return function(ae, Ie) {
              return typeof ae == "string" && typeof Ie == "string" || (ae = X1(ae), Ie = X1(Ie)), U(ae, Ie);
            };
          }
          function nx(U, ae, Ie, Qe, At, en, Hn, Qn, Or, ia) {
            var Qi = ae & be, pa = Qi ? Hn : t3, mo = Qi ? t3 : Hn, Ss = Qi ? en : t3, ul = Qi ? t3 : en;
            ae |= Qi ? Fe : Pe, ae &= ~(Qi ? Pe : Fe), ae & he || (ae &= ~(Q | se));
            var $l = [U, ae, At, Ss, pa, ul, mo, Qn, Or, ia], al = Ie.apply(t3, $l);
            return hu(U) && aq(al, $l), al.placeholder = Qe, yie(al, U, ae);
          }
          function XU(U) {
            var ae = Kd[U];
            return function(Ie, Qe) {
              if (Ie = X1(Ie), Qe = Qe == null ? 0 : Dg(pu(Qe), 292), Qe && g9(Ie)) {
                var At = (Lf(Ie) + "e").split("e"), en = ae(At[0] + "e" + (+At[1] + Qe));
                return At = (Lf(en) + "e").split("e"), +(At[0] + "e" + (+At[1] - Qe));
              }
              return ae(Ie);
            };
          }
          var YU = Ok && 1 / p9(new Ok([, -0]))[1] == Jn ? function(U) {
            return new Ok(U);
          } : Qq;
          function KU(U) {
            return function(ae) {
              var Ie = S0(ae);
              return Ie == ys ? yU(ae) : Ie == eh ? Fre(ae) : cU(ae, U(ae));
            };
          }
          function rx(U, ae, Ie, Qe, At, en, Hn, Qn) {
            var Or = ae & se;
            if (!Or && typeof U != "function")
              throw new Ey(b3);
            var ia = Qe ? Qe.length : 0;
            if (ia || (ae &= ~(Fe | Pe), Qe = At = t3), Hn = Hn === t3 ? Hn : Hp(pu(Hn), 0), Qn = Qn === t3 ? Qn : pu(Qn), ia -= At ? At.length : 0, ae & Pe) {
              var Qi = Qe, pa = At;
              Qe = At = t3;
            }
            var mo = Or ? t3 : U9(U), Ss = [U, ae, Ie, Qe, At, Qi, pa, en, Hn, Qn];
            if (mo && gie(Ss, mo), U = Ss[0], ae = Ss[1], Ie = Ss[2], Qe = Ss[3], At = Ss[4], Qn = Ss[9] = Ss[9] === t3 ? Or ? 0 : U.length : Hp(Ss[9] - ia, 0), !Qn && ae & (be | de) && (ae &= ~(be | de)), !ae || ae == Q)
              var ul = lie(U, ae, Ie);
            else
              ae == be || ae == de ? ul = Wp(U, ae, Qn) : (ae == Fe || ae == (Q | Fe)) && !At.length ? ul = cie(U, ae, Ie, Qe) : ul = z9.apply(t3, Ss);
            var $l = mo ? mT : aq;
            return yie($l(ul, Ss), U, ae);
          }
          function ZU(U, ae, Ie, Qe) {
            return U === t3 || qo(U, U_[Ie]) && !Of.call(Qe, Ie) ? ae : U;
          }
          function eS(U, ae, Ie, Qe, At, en) {
            return Sp(U) && Sp(ae) && (en.set(ae, U), R9(U, ae, t3, eS, en), en.delete(ae)), U;
          }
          function fie(U) {
            return DT(U) ? t3 : U;
          }
          function JU(U, ae, Ie, Qe, At, en) {
            var Hn = Ie & G, Qn = U.length, Or = ae.length;
            if (Qn != Or && !(Hn && Or > Qn))
              return false;
            var ia = en.get(U), Qi = en.get(ae);
            if (ia && Qi)
              return ia == ae && Qi == U;
            var pa = -1, mo = true, Ss = Ie & J ? new fT() : t3;
            for (en.set(U, ae), en.set(ae, U); ++pa < Qn; ) {
              var ul = U[pa], $l = ae[pa];
              if (Qe)
                var al = Hn ? Qe($l, ul, pa, ae, U, en) : Qe(ul, $l, pa, U, ae, en);
              if (al !== t3) {
                if (al)
                  continue;
                mo = false;
                break;
              }
              if (Ss) {
                if (!Zw(ae, function(bc, Gu) {
                  if (!HL(Ss, Gu) && (ul === bc || At(ul, bc, Ie, Qe, en)))
                    return Ss.push(Gu);
                })) {
                  mo = false;
                  break;
                }
              } else if (!(ul === $l || At(ul, $l, Ie, Qe, en))) {
                mo = false;
                break;
              }
            }
            return en.delete(U), en.delete(ae), mo;
          }
          function hie(U, ae, Ie, Qe, At, en, Hn) {
            switch (Ie) {
              case ta:
                if (U.byteLength != ae.byteLength || U.byteOffset != ae.byteOffset)
                  return false;
                U = U.buffer, ae = ae.buffer;
              case Xr:
                return !(U.byteLength != ae.byteLength || !en(new tE(U), new tE(ae)));
              case Ra:
              case ho:
              case Vu:
                return qo(+U, +ae);
              case Xa:
                return U.name == ae.name && U.message == ae.message;
              case Ag:
              case _p:
                return U == ae + "";
              case ys:
                var Qn = yU;
              case eh:
                var Or = Qe & G;
                if (Qn || (Qn = p9), U.size != ae.size && !Or)
                  return false;
                var ia = Hn.get(U);
                if (ia)
                  return ia == ae;
                Qe |= J, Hn.set(U, ae);
                var Qi = JU(Qn(U), Qn(ae), Qe, At, en, Hn);
                return Hn.delete(U), Qi;
              case ap:
                if (rE)
                  return rE.call(U) == rE.call(ae);
            }
            return false;
          }
          function pie(U, ae, Ie, Qe, At, en) {
            var Hn = Ie & G, Qn = H9(U), Or = Qn.length, ia = H9(ae), Qi = ia.length;
            if (Or != Qi && !Hn)
              return false;
            for (var pa = Or; pa--; ) {
              var mo = Qn[pa];
              if (!(Hn ? mo in ae : Of.call(ae, mo)))
                return false;
            }
            var Ss = en.get(U), ul = en.get(ae);
            if (Ss && ul)
              return Ss == ae && ul == U;
            var $l = true;
            en.set(U, ae), en.set(ae, U);
            for (var al = Hn; ++pa < Or; ) {
              mo = Qn[pa];
              var bc = U[mo], Gu = ae[mo];
              if (Qe)
                var Lg = Hn ? Qe(Gu, bc, mo, ae, U, en) : Qe(bc, Gu, mo, U, ae, en);
              if (!(Lg === t3 ? bc === Gu || At(bc, Gu, Ie, Qe, en) : Lg)) {
                $l = false;
                break;
              }
              al || (al = mo == "constructor");
            }
            if ($l && !al) {
              var A0 = U.constructor, Vy = ae.constructor;
              A0 != Vy && "constructor" in U && "constructor" in ae && !(typeof A0 == "function" && A0 instanceof A0 && typeof Vy == "function" && Vy instanceof Vy) && ($l = false);
            }
            return en.delete(U), en.delete(ae), $l;
          }
          function Ul(U) {
            return oq(q9(U, t3, hq), U + "");
          }
          function H9(U) {
            return E9(U, yv, eq);
          }
          function W9(U) {
            return E9(U, Vm, die);
          }
          var U9 = km ? function(U) {
            return km.get(U);
          } : Qq;
          function jc(U) {
            for (var ae = U.name + "", Ie = Lk[ae], Qe = Of.call(Lk, ae) ? Ie.length : 0; Qe--; ) {
              var At = Ie[Qe], en = At.func;
              if (en == null || en == U)
                return At.name;
            }
            return ae;
          }
          function Gb(U) {
            var ae = Of.call(Ut, "placeholder") ? Ut : U;
            return ae.placeholder;
          }
          function Js() {
            var U = Ut.iteratee || m7;
            return U = U === m7 ? rR : U, arguments.length ? U(arguments[0], arguments[1]) : U;
          }
          function pC(U, ae) {
            var Ie = U.__data__;
            return hE(ae) ? Ie[typeof ae == "string" ? "string" : "hash"] : Ie.map;
          }
          function QU(U) {
            for (var ae = yv(U), Ie = ae.length; Ie--; ) {
              var Qe = ae[Ie], At = U[Qe];
              ae[Ie] = [Qe, At, ad(At)];
            }
            return ae;
          }
          function wT(U, ae) {
            var Ie = vU(U, ae);
            return P9(Ie) ? Ie : t3;
          }
          function $be(U) {
            var ae = Of.call(U, lT), Ie = U[lT];
            try {
              U[lT] = t3;
              var Qe = true;
            } catch {
            }
            var At = XL.call(U);
            return Qe && (ae ? U[lT] = Ie : delete U[lT]), At;
          }
          var eq = xU ? function(U) {
            return U == null ? [] : (U = Uf(U), Xw(xU(U), function(ae) {
              return q_.call(U, ae);
            }));
          } : Uk, die = xU ? function(U) {
            for (var ae = []; U; )
              Kw(ae, eq(U)), U = YL(U);
            return ae;
          } : Uk, S0 = Py;
          (wU && S0(new wU(new ArrayBuffer(1))) != ta || kk && S0(new kk()) != ys || SU && S0(SU.resolve()) != dv || Ok && S0(new Ok()) != eh || aC && S0(new aC()) != Ji) && (S0 = function(U) {
            var ae = Py(U), Ie = ae == ef ? U.constructor : t3, Qe = Ie ? dE(Ie) : "";
            if (Qe)
              switch (Qe) {
                case JL:
                  return ta;
                case CU:
                  return ys;
                case Rk:
                  return dv;
                case MU:
                  return eh;
                case uT:
                  return Ji;
              }
            return ae;
          });
          function Xbe(U, ae, Ie) {
            for (var Qe = -1, At = Ie.length; ++Qe < At; ) {
              var en = Ie[Qe], Hn = en.size;
              switch (en.type) {
                case "drop":
                  U += Hn;
                  break;
                case "dropRight":
                  ae -= Hn;
                  break;
                case "take":
                  ae = Dg(ae, U + Hn);
                  break;
                case "takeRight":
                  U = Hp(U, ae - Hn);
                  break;
              }
            }
            return { start: U, end: ae };
          }
          function Ybe(U) {
            var ae = U.match(tU);
            return ae ? ae[1].split(nU) : [];
          }
          function tq(U, ae, Ie) {
            ae = _T(ae, U);
            for (var Qe = -1, At = ae.length, en = false; ++Qe < At; ) {
              var Hn = tS(ae[Qe]);
              if (!(en = U != null && Ie(U, Hn)))
                break;
              U = U[Hn];
            }
            return en || ++Qe != At ? en : (At = U == null ? 0 : U.length, !!At && CR(At) && dC(Hn, At) && (ql(U) || ET(U)));
          }
          function dR(U) {
            var ae = U.length, Ie = new U.constructor(ae);
            return ae && typeof U[0] == "string" && Of.call(U, "index") && (Ie.index = U.index, Ie.input = U.input), Ie;
          }
          function Cd(U) {
            return typeof U.constructor == "function" && !pE(U) ? X_(YL(U)) : {};
          }
          function nq(U, ae, Ie) {
            var Qe = U.constructor;
            switch (ae) {
              case Xr:
                return fR(U);
              case Ra:
              case ho:
                return new Qe(+U);
              case ta:
                return Gbe(U, Ie);
              case co:
              case cs:
              case nu:
              case ru:
              case hf:
              case op:
              case _h:
              case wd:
              case xh:
                return aie(U, Ie);
              case ys:
                return new Qe();
              case Vu:
              case _p:
                return new Qe(U);
              case Ag:
                return Hbe(U);
              case eh:
                return new Qe();
              case ap:
                return Wbe(U);
            }
          }
          function vR(U, ae) {
            var Ie = ae.length;
            if (!Ie)
              return U;
            var Qe = Ie - 1;
            return ae[Qe] = (Ie > 1 ? "& " : "") + ae[Qe], ae = ae.join(Ie > 2 ? ", " : " "), U.replace(eU, `{
/* [wrapped with ` + ae + `] */
`);
          }
          function Kbe(U) {
            return ql(U) || ET(U) || !!(nE && U && U[nE]);
          }
          function dC(U, ae) {
            var Ie = typeof U;
            return ae = ae == null ? ln : ae, !!ae && (Ie == "number" || Ie != "symbol" && pr.test(U)) && U > -1 && U % 1 == 0 && U < ae;
          }
          function Ly(U, ae, Ie) {
            if (!Sp(Ie))
              return false;
            var Qe = typeof ae;
            return (Qe == "number" ? C0(Ie) && dC(ae, Ie.length) : Qe == "string" && ae in Ie) ? qo(Ie[ae], U) : false;
          }
          function rq(U, ae) {
            if (ql(U))
              return false;
            var Ie = typeof U;
            return Ie == "number" || Ie == "symbol" || Ie == "boolean" || U == null || Ny(U) ? true : z1.test(U) || !My.test(U) || ae != null && U in Uf(ae);
          }
          function hE(U) {
            var ae = typeof U;
            return ae == "string" || ae == "number" || ae == "symbol" || ae == "boolean" ? U !== "__proto__" : U === null;
          }
          function hu(U) {
            var ae = jc(U), Ie = Ut[ae];
            if (typeof Ie != "function" || !(ae in kc.prototype))
              return false;
            if (U === Ie)
              return true;
            var Qe = U9(Ie);
            return !!Qe && U === Qe[0];
          }
          function Zbe(U) {
            return !!zre && zre in U;
          }
          var gR = $L ? $1 : t$;
          function pE(U) {
            var ae = U && U.constructor, Ie = typeof ae == "function" && ae.prototype || U_;
            return U === Ie;
          }
          function ad(U) {
            return U === U && !Sp(U);
          }
          function vie(U, ae) {
            return function(Ie) {
              return Ie == null ? false : Ie[U] === ae && (ae !== t3 || U in Uf(Ie));
            };
          }
          function yR(U) {
            var ae = xR(U, function(Qe) {
              return Ie.size === I && Ie.clear(), Qe;
            }), Ie = ae.cache;
            return ae;
          }
          function gie(U, ae) {
            var Ie = U[1], Qe = ae[1], At = Ie | Qe, en = At < (Q | se | ze), Hn = Qe == ze && Ie == be || Qe == ze && Ie == $e && U[7].length <= ae[8] || Qe == (ze | $e) && ae[7].length <= ae[8] && Ie == be;
            if (!(en || Hn))
              return U;
            Qe & Q && (U[2] = ae[2], At |= Ie & Q ? 0 : he);
            var Qn = ae[3];
            if (Qn) {
              var Or = U[3];
              U[3] = Or ? WU(Or, Qn, ae[4]) : Qn, U[4] = Or ? iC(U[3], k3) : ae[4];
            }
            return Qn = ae[5], Qn && (Or = U[5], U[5] = Or ? fs(Or, Qn, ae[6]) : Qn, U[6] = Or ? iC(U[5], k3) : ae[6]), Qn = ae[7], Qn && (U[7] = Qn), Qe & ze && (U[8] = U[8] == null ? ae[8] : Dg(U[8], ae[8])), U[9] == null && (U[9] = ae[9]), U[0] = ae[0], U[1] = At, U;
          }
          function Jbe(U) {
            var ae = [];
            if (U != null)
              for (var Ie in Uf(U))
                ae.push(Ie);
            return ae;
          }
          function Qbe(U) {
            return XL.call(U);
          }
          function q9(U, ae, Ie) {
            return ae = Hp(ae === t3 ? U.length - 1 : ae, 0), function() {
              for (var Qe = arguments, At = -1, en = Hp(Qe.length - ae, 0), Hn = oi(en); ++At < en; )
                Hn[At] = Qe[ae + At];
              At = -1;
              for (var Qn = oi(ae + 1); ++At < ae; )
                Qn[At] = Qe[At];
              return Qn[ae] = Ie(Hn), gv(U, this, Qn);
            };
          }
          function iq(U, ae) {
            return ae.length < 2 ? U : iE(U, Kv(ae, 0, -1));
          }
          function e_e(U, ae) {
            for (var Ie = U.length, Qe = Dg(ae.length, Ie), At = Og(U); Qe--; ) {
              var en = ae[Qe];
              U[Qe] = dC(en, Ie) ? At[en] : t3;
            }
            return U;
          }
          function vC(U, ae) {
            if (!(ae === "constructor" && typeof U[ae] == "function") && ae != "__proto__")
              return U[ae];
          }
          var aq = $9(mT), Rm = Hre || function(U, ae) {
            return wh.setTimeout(U, ae);
          }, oq = $9(lE);
          function yie(U, ae, Ie) {
            var Qe = ae + "";
            return oq(U, vR(Qe, t_e(Ybe(Qe), Ie)));
          }
          function $9(U) {
            var ae = 0, Ie = 0;
            return function() {
              var Qe = Mbe(), At = vt - (Qe - Ie);
              if (Ie = Qe, At > 0) {
                if (++ae >= bt)
                  return arguments[0];
              } else
                ae = 0;
              return U.apply(t3, arguments);
            };
          }
          function X9(U, ae) {
            var Ie = -1, Qe = U.length, At = Qe - 1;
            for (ae = ae === t3 ? Qe : ae; ++Ie < ae; ) {
              var en = jb(Ie, At), Hn = U[en];
              U[en] = U[Ie], U[Ie] = Hn;
            }
            return U.length = ae, U;
          }
          var sq = yR(function(U) {
            var ae = [];
            return U.charCodeAt(0) === 46 && ae.push(""), U.replace(oT, function(Ie, Qe, At, en) {
              ae.push(At ? en.replace(Nn, "$1") : Qe || Ie);
            }), ae;
          });
          function tS(U) {
            if (typeof U == "string" || Ny(U))
              return U;
            var ae = U + "";
            return ae == "0" && 1 / U == -Jn ? "-0" : ae;
          }
          function dE(U) {
            if (U != null) {
              try {
                return Dk.call(U);
              } catch {
              }
              try {
                return U + "";
              } catch {
              }
            }
            return "";
          }
          function t_e(U, ae) {
            return Yd(Ka, function(Ie) {
              var Qe = "_." + Ie[0];
              ae & Ie[1] && !Yw(U, Qe) && U.push(Qe);
            }), U.sort();
          }
          function mie(U) {
            if (U instanceof kc)
              return U.clone();
            var ae = new Om(U.__wrapped__, U.__chain__);
            return ae.__actions__ = Og(U.__actions__), ae.__index__ = U.__index__, ae.__values__ = U.__values__, ae;
          }
          function Y9(U, ae, Ie) {
            (Ie ? Ly(U, ae, Ie) : ae === t3) ? ae = 1 : ae = Hp(pu(ae), 0);
            var Qe = U == null ? 0 : U.length;
            if (!Qe || ae < 1)
              return [];
            for (var At = 0, en = 0, Hn = oi($_(Qe / ae)); At < Qe; )
              Hn[en++] = Kv(U, At, At += ae);
            return Hn;
          }
          function vE(U) {
            for (var ae = -1, Ie = U == null ? 0 : U.length, Qe = 0, At = []; ++ae < Ie; ) {
              var en = U[ae];
              en && (At[Qe++] = en);
            }
            return At;
          }
          function n_e() {
            var U = arguments.length;
            if (!U)
              return [];
            for (var ae = oi(U - 1), Ie = arguments[0], Qe = U; Qe--; )
              ae[Qe - 1] = arguments[Qe];
            return Kw(ql(Ie) ? Og(Ie) : [Ie], kg(ae, 1));
          }
          var r_e = Bu(function(U, ae) {
            return lp(U) ? pT(U, kg(ae, 1, lp, true)) : [];
          }), i_e = Bu(function(U, ae) {
            var Ie = U1(ae);
            return lp(Ie) && (Ie = t3), lp(U) ? pT(U, kg(ae, 1, lp, true), Js(Ie, 2)) : [];
          }), lq = Bu(function(U, ae) {
            var Ie = U1(ae);
            return lp(Ie) && (Ie = t3), lp(U) ? pT(U, kg(ae, 1, lp, true), t3, Ie) : [];
          });
          function a_e(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            return Qe ? (ae = Ie || ae === t3 ? 1 : pu(ae), Kv(U, ae < 0 ? 0 : ae, Qe)) : [];
          }
          function uq(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            return Qe ? (ae = Ie || ae === t3 ? 1 : pu(ae), ae = Qe - ae, Kv(U, 0, ae < 0 ? 0 : ae)) : [];
          }
          function bie(U, ae) {
            return U && U.length ? hC(U, Js(ae, 3), true, true) : [];
          }
          function K9(U, ae) {
            return U && U.length ? hC(U, Js(ae, 3), true) : [];
          }
          function cq(U, ae, Ie, Qe) {
            var At = U == null ? 0 : U.length;
            return At ? (Ie && typeof Ie != "number" && Ly(U, ae, Ie) && (Ie = 0, Qe = At), Fbe(U, ae, Ie, Qe)) : [];
          }
          function _ie(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            if (!Qe)
              return -1;
            var At = Ie == null ? 0 : pu(Ie);
            return At < 0 && (At = Hp(Qe + At, 0)), H_(U, Js(ae, 3), At);
          }
          function fq(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            if (!Qe)
              return -1;
            var At = Qe - 1;
            return Ie !== t3 && (At = pu(Ie), At = Ie < 0 ? Hp(Qe + At, 0) : Dg(At, Qe - 1)), H_(U, Js(ae, 3), At, true);
          }
          function hq(U) {
            var ae = U == null ? 0 : U.length;
            return ae ? kg(U, 1) : [];
          }
          function o_e(U) {
            var ae = U == null ? 0 : U.length;
            return ae ? kg(U, Jn) : [];
          }
          function s_e(U, ae) {
            var Ie = U == null ? 0 : U.length;
            return Ie ? (ae = ae === t3 ? 1 : pu(ae), kg(U, ae)) : [];
          }
          function l_e(U) {
            for (var ae = -1, Ie = U == null ? 0 : U.length, Qe = {}; ++ae < Ie; ) {
              var At = U[ae];
              Qe[At[0]] = At[1];
            }
            return Qe;
          }
          function pq(U) {
            return U && U.length ? U[0] : t3;
          }
          function u_e(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            if (!Qe)
              return -1;
            var At = Ie == null ? 0 : pu(Ie);
            return At < 0 && (At = Hp(Qe + At, 0)), G1(U, ae, At);
          }
          function c_e(U) {
            var ae = U == null ? 0 : U.length;
            return ae ? Kv(U, 0, -1) : [];
          }
          var dq = Bu(function(U) {
            var ae = wp(U, uR);
            return ae.length && ae[0] === U[0] ? FU(ae) : [];
          }), f_e = Bu(function(U) {
            var ae = U1(U), Ie = wp(U, uR);
            return ae === U1(Ie) ? ae = t3 : Ie.pop(), Ie.length && Ie[0] === U[0] ? FU(Ie, Js(ae, 2)) : [];
          }), h_e = Bu(function(U) {
            var ae = U1(U), Ie = wp(U, uR);
            return ae = typeof ae == "function" ? ae : t3, ae && Ie.pop(), Ie.length && Ie[0] === U[0] ? FU(Ie, t3, ae) : [];
          });
          function p_e(U, ae) {
            return U == null ? "" : Cbe.call(U, ae);
          }
          function U1(U) {
            var ae = U == null ? 0 : U.length;
            return ae ? U[ae - 1] : t3;
          }
          function vq(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            if (!Qe)
              return -1;
            var At = Qe;
            return Ie !== t3 && (At = pu(Ie), At = At < 0 ? Hp(Qe + At, 0) : Dg(At, Qe - 1)), ae === ae ? mU(U, ae, At) : H_(U, kre, At, true);
          }
          function gE(U, ae) {
            return U && U.length ? BU(U, pu(ae)) : t3;
          }
          var Z9 = Bu(gq);
          function gq(U, ae) {
            return U && U.length && ae && ae.length ? aR(U, ae) : U;
          }
          function d_e(U, ae, Ie) {
            return U && U.length && ae && ae.length ? aR(U, ae, Js(Ie, 2)) : U;
          }
          function v_e(U, ae, Ie) {
            return U && U.length && ae && ae.length ? aR(U, ae, t3, Ie) : U;
          }
          var yq = Ul(function(U, ae) {
            var Ie = U == null ? 0 : U.length, Qe = T9(U, ae);
            return rie(U, wp(ae, function(At) {
              return dC(At, Ie) ? +At : At;
            }).sort(HU)), Qe;
          });
          function mq(U, ae) {
            var Ie = [];
            if (!(U && U.length))
              return Ie;
            var Qe = -1, At = [], en = U.length;
            for (ae = Js(ae, 3); ++Qe < en; ) {
              var Hn = U[Qe];
              ae(Hn, Qe, U) && (Ie.push(Hn), At.push(Qe));
            }
            return rie(U, At), Ie;
          }
          function bq(U) {
            return U == null ? U : Abe.call(U);
          }
          function Hb(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            return Qe ? (Ie && typeof Ie != "number" && Ly(U, ae, Ie) ? (ae = 0, Ie = Qe) : (ae = ae == null ? 0 : pu(ae), Ie = Ie === t3 ? Qe : pu(Ie)), Kv(U, ae, Ie)) : [];
          }
          function Nm(U, ae) {
            return bT(U, ae);
          }
          function Fm(U, ae, Ie) {
            return jU(U, ae, Js(Ie, 2));
          }
          function _q(U, ae) {
            var Ie = U == null ? 0 : U.length;
            if (Ie) {
              var Qe = bT(U, ae);
              if (Qe < Ie && qo(U[Qe], ae))
                return Qe;
            }
            return -1;
          }
          function xq(U, ae) {
            return bT(U, ae, true);
          }
          function yE(U, ae, Ie) {
            return jU(U, ae, Js(Ie, 2), true);
          }
          function J9(U, ae) {
            var Ie = U == null ? 0 : U.length;
            if (Ie) {
              var Qe = bT(U, ae, true) - 1;
              if (qo(U[Qe], ae))
                return Qe;
            }
            return -1;
          }
          function Q9(U) {
            return U && U.length ? il(U) : [];
          }
          function e7(U, ae) {
            return U && U.length ? il(U, Js(ae, 2)) : [];
          }
          function t7(U) {
            var ae = U == null ? 0 : U.length;
            return ae ? Kv(U, 1, ae) : [];
          }
          function xie(U, ae, Ie) {
            return U && U.length ? (ae = Ie || ae === t3 ? 1 : pu(ae), Kv(U, 0, ae < 0 ? 0 : ae)) : [];
          }
          function wie(U, ae, Ie) {
            var Qe = U == null ? 0 : U.length;
            return Qe ? (ae = Ie || ae === t3 ? 1 : pu(ae), ae = Qe - ae, Kv(U, ae < 0 ? 0 : ae, Qe)) : [];
          }
          function Sie(U, ae) {
            return U && U.length ? hC(U, Js(ae, 3), false, true) : [];
          }
          function g_e(U, ae) {
            return U && U.length ? hC(U, Js(ae, 3)) : [];
          }
          var y_e = Bu(function(U) {
            return fC(kg(U, 1, lp, true));
          }), m_e = Bu(function(U) {
            var ae = U1(U);
            return lp(ae) && (ae = t3), fC(kg(U, 1, lp, true), Js(ae, 2));
          }), Pf = Bu(function(U) {
            var ae = U1(U);
            return ae = typeof ae == "function" ? ae : t3, fC(kg(U, 1, lp, true), t3, ae);
          });
          function mE(U) {
            return U && U.length ? fC(U) : [];
          }
          function bE(U, ae) {
            return U && U.length ? fC(U, Js(ae, 2)) : [];
          }
          function nS(U, ae) {
            return ae = typeof ae == "function" ? ae : t3, U && U.length ? fC(U, t3, ae) : [];
          }
          function rS(U) {
            if (!(U && U.length))
              return [];
            var ae = 0;
            return U = Xw(U, function(Ie) {
              if (lp(Ie))
                return ae = Hp(Ie.length, ae), true;
            }), h9(ae, function(Ie) {
              return wp(U, lU(Ie));
            });
          }
          function ix(U, ae) {
            if (!(U && U.length))
              return [];
            var Ie = rS(U);
            return ae == null ? Ie : wp(Ie, function(Qe) {
              return gv(ae, t3, Qe);
            });
          }
          var iS = Bu(function(U, ae) {
            return lp(U) ? pT(U, ae) : [];
          }), wq = Bu(function(U) {
            return H1(Xw(U, lp));
          }), Sq = Bu(function(U) {
            var ae = U1(U);
            return lp(ae) && (ae = t3), H1(Xw(U, lp), Js(ae, 2));
          }), _E = Bu(function(U) {
            var ae = U1(U);
            return ae = typeof ae == "function" ? ae : t3, H1(Xw(U, lp), t3, ae);
          }), xE = Bu(rS);
          function gC(U, ae) {
            return lR(U || [], ae || [], QL);
          }
          function Cq(U, ae) {
            return lR(U || [], ae || [], yT);
          }
          var ST = Bu(function(U) {
            var ae = U.length, Ie = ae > 1 ? U[ae - 1] : t3;
            return Ie = typeof Ie == "function" ? (U.pop(), Ie) : t3, ix(U, Ie);
          });
          function n7(U) {
            var ae = Ut(U);
            return ae.__chain__ = true, ae;
          }
          function mR(U, ae) {
            return ae(U), U;
          }
          function zk(U, ae) {
            return ae(U);
          }
          var b_e = Ul(function(U) {
            var ae = U.length, Ie = ae ? U[0] : 0, Qe = this.__wrapped__, At = function(en) {
              return T9(en, U);
            };
            return ae > 1 || this.__actions__.length || !(Qe instanceof kc) || !dC(Ie) ? this.thru(At) : (Qe = Qe.slice(Ie, +Ie + (ae ? 1 : 0)), Qe.__actions__.push({ func: zk, args: [At], thisArg: t3 }), new Om(Qe, this.__chain__).thru(function(en) {
              return ae && !en.length && en.push(t3), en;
            }));
          });
          function x_e() {
            return n7(this);
          }
          function aS() {
            return new Om(this.value(), this.__chain__);
          }
          function CT() {
            this.__values__ === t3 && (this.__values__ = Rq(this.value()));
            var U = this.__index__ >= this.__values__.length, ae = U ? t3 : this.__values__[this.__index__++];
            return { done: U, value: ae };
          }
          function w_e() {
            return this;
          }
          function Cie(U) {
            for (var ae, Ie = this; Ie instanceof w0; ) {
              var Qe = mie(Ie);
              Qe.__index__ = 0, Qe.__values__ = t3, ae ? At.__wrapped__ = Qe : ae = Qe;
              var At = Qe;
              Ie = Ie.__wrapped__;
            }
            return At.__wrapped__ = U, ae;
          }
          function Mie() {
            var U = this.__wrapped__;
            if (U instanceof kc) {
              var ae = U;
              return this.__actions__.length && (ae = new kc(this)), ae = ae.reverse(), ae.__actions__.push({ func: zk, args: [bq], thisArg: t3 }), new Om(ae, this.__chain__);
            }
            return this.thru(bq);
          }
          function MT() {
            return sR(this.__wrapped__, this.__actions__);
          }
          var bR = B9(function(U, ae, Ie) {
            Of.call(U, Ie) ? ++U[Ie] : Fb(U, Ie, 1);
          });
          function S_e(U, ae, Ie) {
            var Qe = ql(U) ? oU : RU;
            return Ie && Ly(U, ae, Ie) && (ae = t3), Qe(U, Js(ae, 3));
          }
          function yC(U, ae) {
            var Ie = ql(U) ? Xw : Qre;
            return Ie(U, Js(ae, 3));
          }
          var TT = W1(_ie), wE = W1(fq);
          function C_e(U, ae) {
            return kg(r7(U, ae), 1);
          }
          function M_e(U, ae) {
            return kg(r7(U, ae), Jn);
          }
          function Ry(U, ae, Ie) {
            return Ie = Ie === t3 ? 1 : pu(Ie), kg(r7(U, ae), Ie);
          }
          function q1(U, ae) {
            var Ie = ql(U) ? Yd : Vb;
            return Ie(U, Js(ae, 3));
          }
          function Tie(U, ae) {
            var Ie = ql(U) ? dbe : Jre;
            return Ie(U, Js(ae, 3));
          }
          var T_e = B9(function(U, ae, Ie) {
            Of.call(U, Ie) ? U[Ie].push(ae) : Fb(U, Ie, [ae]);
          });
          function A_e(U, ae, Ie, Qe) {
            U = C0(U) ? U : Hk(U), Ie = Ie && !Qe ? pu(Ie) : 0;
            var At = U.length;
            return Ie < 0 && (Ie = Hp(At + Ie, 0)), u7(U) ? Ie <= At && U.indexOf(ae, Ie) > -1 : !!At && G1(U, ae, Ie) > -1;
          }
          var I_e = Bu(function(U, ae, Ie) {
            var Qe = -1, At = typeof ae == "function", en = C0(U) ? oi(U.length) : [];
            return Vb(U, function(Hn) {
              en[++Qe] = At ? gv(ae, Hn, Ie) : dT(Hn, ae, Ie);
            }), en;
          }), Aie = B9(function(U, ae, Ie) {
            Fb(U, Ie, ae);
          });
          function r7(U, ae) {
            var Ie = ql(U) ? wp : vT;
            return Ie(U, Js(ae, 3));
          }
          function E_e(U, ae, Ie, Qe) {
            return U == null ? [] : (ql(ae) || (ae = ae == null ? [] : [ae]), Ie = Qe ? t3 : Ie, ql(Ie) || (Ie = Ie == null ? [] : [Ie]), gT(U, ae, Ie));
          }
          var i7 = B9(function(U, ae, Ie) {
            U[Ie ? 0 : 1].push(ae);
          }, function() {
            return [[], []];
          });
          function D_e(U, ae, Ie) {
            var Qe = ql(U) ? KI : Pre, At = arguments.length < 3;
            return Qe(U, Js(ae, 4), Ie, At, Vb);
          }
          function Mq(U, ae, Ie) {
            var Qe = ql(U) ? sU : Pre, At = arguments.length < 3;
            return Qe(U, Js(ae, 4), Ie, At, Jre);
          }
          function k_e(U, ae) {
            var Ie = ql(U) ? Xw : Qre;
            return Ie(U, wR(Js(ae, 3)));
          }
          function ml(U) {
            var ae = ql(U) ? Yre : zs;
            return ae(U);
          }
          function O_e(U, ae, Ie) {
            (Ie ? Ly(U, ae, Ie) : ae === t3) ? ae = 1 : ae = pu(ae);
            var Qe = ql(U) ? S9 : N9;
            return Qe(U, ae);
          }
          function Iie(U) {
            var ae = ql(U) ? Kre : uE;
            return ae(U);
          }
          function _R(U) {
            if (U == null)
              return 0;
            if (C0(U))
              return u7(U) ? JI(U) : U.length;
            var ae = S0(U);
            return ae == ys || ae == eh ? U.size : iR(U).length;
          }
          function P_e(U, ae, Ie) {
            var Qe = ql(U) ? Zw : oR;
            return Ie && Ly(U, ae, Ie) && (ae = t3), Qe(U, Js(ae, 3));
          }
          var L_e = Bu(function(U, ae) {
            if (U == null)
              return [];
            var Ie = ae.length;
            return Ie > 1 && Ly(U, ae[0], ae[1]) ? ae = [] : Ie > 2 && Ly(ae[0], ae[1], ae[2]) && (ae = [ae[0]]), gT(U, kg(ae, 1), []);
          }), a7 = v9 || function() {
            return wh.Date.now();
          };
          function Eie(U, ae) {
            if (typeof ae != "function")
              throw new Ey(b3);
            return U = pu(U), function() {
              if (--U < 1)
                return ae.apply(this, arguments);
            };
          }
          function Zv(U, ae, Ie) {
            return ae = Ie ? t3 : ae, ae = U && ae == null ? U.length : ae, rx(U, ze, t3, t3, t3, t3, ae);
          }
          function Die(U, ae) {
            var Ie;
            if (typeof ae != "function")
              throw new Ey(b3);
            return U = pu(U), function() {
              return --U > 0 && (Ie = ae.apply(this, arguments)), U <= 1 && (ae = t3), Ie;
            };
          }
          var AT = Bu(function(U, ae, Ie) {
            var Qe = Q;
            if (Ie.length) {
              var At = iC(Ie, Gb(AT));
              Qe |= Fe;
            }
            return rx(U, Qe, ae, Ie, At);
          }), Tq = Bu(function(U, ae, Ie) {
            var Qe = Q | se;
            if (Ie.length) {
              var At = iC(Ie, Gb(Tq));
              Qe |= Fe;
            }
            return rx(ae, Qe, U, Ie, At);
          });
          function Aq(U, ae, Ie) {
            ae = Ie ? t3 : ae;
            var Qe = rx(U, be, t3, t3, t3, t3, t3, ae);
            return Qe.placeholder = Aq.placeholder, Qe;
          }
          function IT(U, ae, Ie) {
            ae = Ie ? t3 : ae;
            var Qe = rx(U, de, t3, t3, t3, t3, t3, ae);
            return Qe.placeholder = IT.placeholder, Qe;
          }
          function kie(U, ae, Ie) {
            var Qe, At, en, Hn, Qn, Or, ia = 0, Qi = false, pa = false, mo = true;
            if (typeof U != "function")
              throw new Ey(b3);
            ae = X1(ae) || 0, Sp(Ie) && (Qi = !!Ie.leading, pa = "maxWait" in Ie, en = pa ? Hp(X1(Ie.maxWait) || 0, ae) : en, mo = "trailing" in Ie ? !!Ie.trailing : mo);
            function Ss(Md) {
              var I0 = Qe, hS = At;
              return Qe = At = t3, ia = Md, Hn = U.apply(hS, I0), Hn;
            }
            function ul(Md) {
              return ia = Md, Qn = Rm(bc, ae), Qi ? Ss(Md) : Hn;
            }
            function $l(Md) {
              var I0 = Md - Or, hS = Md - ia, mC = ae - I0;
              return pa ? Dg(mC, en - hS) : mC;
            }
            function al(Md) {
              var I0 = Md - Or, hS = Md - ia;
              return Or === t3 || I0 >= ae || I0 < 0 || pa && hS >= en;
            }
            function bc() {
              var Md = a7();
              if (al(Md))
                return Gu(Md);
              Qn = Rm(bc, $l(Md));
            }
            function Gu(Md) {
              return Qn = t3, mo && Qe ? Ss(Md) : (Qe = At = t3, Hn);
            }
            function Lg() {
              Qn !== t3 && F9(Qn), ia = 0, Qe = Or = At = Qn = t3;
            }
            function A0() {
              return Qn === t3 ? Hn : Gu(a7());
            }
            function Vy() {
              var Md = a7(), I0 = al(Md);
              if (Qe = arguments, At = this, Or = Md, I0) {
                if (Qn === t3)
                  return ul(Or);
                if (pa)
                  return F9(Qn), Qn = Rm(bc, ae), Ss(Or);
              }
              return Qn === t3 && (Qn = Rm(bc, ae)), Hn;
            }
            return Vy.cancel = Lg, Vy.flush = A0, Vy;
          }
          var R_e = Bu(function(U, ae) {
            return LU(U, 1, ae);
          }), Oie = Bu(function(U, ae, Ie) {
            return LU(U, X1(ae) || 0, Ie);
          });
          function xu(U) {
            return rx(U, Ke);
          }
          function xR(U, ae) {
            if (typeof U != "function" || ae != null && typeof ae != "function")
              throw new Ey(b3);
            var Ie = function() {
              var Qe = arguments, At = ae ? ae.apply(this, Qe) : Qe[0], en = Ie.cache;
              if (en.has(At))
                return en.get(At);
              var Hn = U.apply(this, Qe);
              return Ie.cache = en.set(At, Hn) || en, Hn;
            };
            return Ie.cache = new (xR.Cache || sC)(), Ie;
          }
          xR.Cache = sC;
          function wR(U) {
            if (typeof U != "function")
              throw new Ey(b3);
            return function() {
              var ae = arguments;
              switch (ae.length) {
                case 0:
                  return !U.call(this);
                case 1:
                  return !U.call(this, ae[0]);
                case 2:
                  return !U.call(this, ae[0], ae[1]);
                case 3:
                  return !U.call(this, ae[0], ae[1], ae[2]);
              }
              return !U.apply(this, ae);
            };
          }
          function N_e(U) {
            return Die(2, U);
          }
          var Pie = Bk(function(U, ae) {
            ae = ae.length == 1 && ql(ae[0]) ? wp(ae[0], Iy(Js())) : wp(kg(ae, 1), Iy(Js()));
            var Ie = ae.length;
            return Bu(function(Qe) {
              for (var At = -1, en = Dg(Qe.length, Ie); ++At < en; )
                Qe[At] = ae[At].call(this, Qe[At]);
              return gv(U, this, Qe);
            });
          }), Iq = Bu(function(U, ae) {
            var Ie = iC(ae, Gb(Iq));
            return rx(U, Fe, t3, ae, Ie);
          }), Lie = Bu(function(U, ae) {
            var Ie = iC(ae, Gb(Lie));
            return rx(U, Pe, t3, ae, Ie);
          }), Rie = Ul(function(U, ae) {
            return rx(U, $e, t3, t3, t3, ae);
          });
          function Nie(U, ae) {
            if (typeof U != "function")
              throw new Ey(b3);
            return ae = ae === t3 ? ae : pu(ae), Bu(U, ae);
          }
          function Fie(U, ae) {
            if (typeof U != "function")
              throw new Ey(b3);
            return ae = ae == null ? 0 : Hp(pu(ae), 0), Bu(function(Ie) {
              var Qe = Ie[ae], At = xT(Ie, 0, ae);
              return Qe && Kw(At, Qe), gv(U, this, At);
            });
          }
          function Vie(U, ae, Ie) {
            var Qe = true, At = true;
            if (typeof U != "function")
              throw new Ey(b3);
            return Sp(Ie) && (Qe = "leading" in Ie ? !!Ie.leading : Qe, At = "trailing" in Ie ? !!Ie.trailing : At), kie(U, ae, { leading: Qe, maxWait: ae, trailing: At });
          }
          function F_e(U) {
            return Zv(U, 1);
          }
          function Bie(U, ae) {
            return Iq(cR(ae), U);
          }
          function zie() {
            if (!arguments.length)
              return [];
            var U = arguments[0];
            return ql(U) ? U : [U];
          }
          function jie(U) {
            return Lm(U, B);
          }
          function Gie(U, ae) {
            return ae = typeof ae == "function" ? ae : t3, Lm(U, B, ae);
          }
          function Hie(U) {
            return Lm(U, L | B);
          }
          function Eq(U, ae) {
            return ae = typeof ae == "function" ? ae : t3, Lm(U, L | B, ae);
          }
          function ju(U, ae) {
            return ae == null || PU(U, ae, yv(ae));
          }
          function qo(U, ae) {
            return U === ae || U !== U && ae !== ae;
          }
          var Dq = G9(D9), Wie = G9(function(U, ae) {
            return U >= ae;
          }), ET = k9(function() {
            return arguments;
          }()) ? k9 : function(U) {
            return up(U) && Of.call(U, "callee") && !q_.call(U, "callee");
          }, ql = oi.isArray, kq = u9 ? Iy(u9) : eie;
          function C0(U) {
            return U != null && CR(U.length) && !$1(U);
          }
          function lp(U) {
            return up(U) && C0(U);
          }
          function o7(U) {
            return U === true || U === false || up(U) && Py(U) == Ra;
          }
          var od = Yv || t$, SR = zL ? Iy(zL) : zbe;
          function jk(U) {
            return up(U) && U.nodeType === 1 && !DT(U);
          }
          function V_e(U) {
            if (U == null)
              return true;
            if (C0(U) && (ql(U) || typeof U == "string" || typeof U.splice == "function" || od(U) || Wb(U) || ET(U)))
              return !U.length;
            var ae = S0(U);
            if (ae == ys || ae == eh)
              return !U.size;
            if (pE(U))
              return !iR(U).length;
            for (var Ie in U)
              if (Of.call(U, Ie))
                return false;
            return true;
          }
          function SE(U, ae) {
            return tR(U, ae);
          }
          function s7(U, ae, Ie) {
            Ie = typeof Ie == "function" ? Ie : t3;
            var Qe = Ie ? Ie(U, ae) : t3;
            return Qe === t3 ? tR(U, ae, t3, Ie) : !!Qe;
          }
          function CE(U) {
            if (!up(U))
              return false;
            var ae = Py(U);
            return ae == Xa || ae == Mo || typeof U.message == "string" && typeof U.name == "string" && !DT(U);
          }
          function l7(U) {
            return typeof U == "number" && g9(U);
          }
          function $1(U) {
            if (!Sp(U))
              return false;
            var ae = Py(U);
            return ae == Zo || ae == rc || ae == xo || ae == Wf;
          }
          function ME(U) {
            return typeof U == "number" && U == pu(U);
          }
          function CR(U) {
            return typeof U == "number" && U > -1 && U % 1 == 0 && U <= ln;
          }
          function Sp(U) {
            var ae = typeof U;
            return U != null && (ae == "object" || ae == "function");
          }
          function up(U) {
            return U != null && typeof U == "object";
          }
          var Oq = aU ? Iy(aU) : O9;
          function Uie(U, ae) {
            return U === ae || nR(U, ae, QU(ae));
          }
          function Pq(U, ae, Ie) {
            return Ie = typeof Ie == "function" ? Ie : t3, nR(U, ae, QU(ae), Ie);
          }
          function qie(U) {
            return oS(U) && U != +U;
          }
          function B_e(U) {
            if (gR(U))
              throw new Vl(g3);
            return P9(U);
          }
          function z_e(U) {
            return U === null;
          }
          function $ie(U) {
            return U == null;
          }
          function oS(U) {
            return typeof U == "number" || up(U) && Py(U) == Vu;
          }
          function DT(U) {
            if (!up(U) || Py(U) != ef)
              return false;
            var ae = YL(U);
            if (ae === null)
              return true;
            var Ie = Of.call(ae, "constructor") && ae.constructor;
            return typeof Ie == "function" && Ie instanceof Ie && Dk.call(Ie) == bU;
          }
          var Lq = io ? Iy(io) : VU;
          function j_e(U) {
            return ME(U) && U >= -ln && U <= ln;
          }
          var Xie = rd ? Iy(rd) : jbe;
          function u7(U) {
            return typeof U == "string" || !ql(U) && up(U) && Py(U) == _p;
          }
          function Ny(U) {
            return typeof U == "symbol" || up(U) && Py(U) == ap;
          }
          var Wb = jL ? Iy(jL) : Bb;
          function Yie(U) {
            return U === t3;
          }
          function Kie(U) {
            return up(U) && S0(U) == Ji;
          }
          function sS(U) {
            return up(U) && Py(U) == Jr;
          }
          var lS = G9(zb), Zie = G9(function(U, ae) {
            return U <= ae;
          });
          function Rq(U) {
            if (!U)
              return [];
            if (C0(U))
              return u7(U) ? W_(U) : Og(U);
            if (Nb && U[Nb])
              return gU(U[Nb]());
            var ae = S0(U), Ie = ae == ys ? yU : ae == eh ? p9 : Hk;
            return Ie(U);
          }
          function uS(U) {
            if (!U)
              return U === 0 ? U : 0;
            if (U = X1(U), U === Jn || U === -Jn) {
              var ae = U < 0 ? -1 : 1;
              return ae * vn;
            }
            return U === U ? U : 0;
          }
          function pu(U) {
            var ae = uS(U), Ie = ae % 1;
            return ae === ae ? Ie ? ae - Ie : ae : 0;
          }
          function Nq(U) {
            return U ? K_(pu(U), 0, cr) : 0;
          }
          function X1(U) {
            if (typeof U == "number")
              return U;
            if (Ny(U))
              return kn;
            if (Sp(U)) {
              var ae = typeof U.valueOf == "function" ? U.valueOf() : U;
              U = Sp(ae) ? ae + "" : ae;
            }
            if (typeof U != "string")
              return U === 0 ? U : +U;
            U = Lre(U);
            var Ie = Vt.test(U);
            return Ie || wi.test(U) ? rU(U.slice(2), Ie ? 2 : 8) : Cn.test(U) ? kn : +U;
          }
          function c7(U) {
            return ex(U, Vm(U));
          }
          function Fq(U) {
            return U ? K_(pu(U), -ln, ln) : U === 0 ? U : 0;
          }
          function Lf(U) {
            return U == null ? "" : sp(U);
          }
          var Vq = fE(function(U, ae) {
            if (pE(ae) || C0(ae)) {
              ex(ae, yv(ae), U);
              return;
            }
            for (var Ie in ae)
              Of.call(ae, Ie) && QL(U, Ie, ae[Ie]);
          }), Jie = fE(function(U, ae) {
            ex(ae, Vm(ae), U);
          }), f7 = fE(function(U, ae, Ie, Qe) {
            ex(ae, Vm(ae), U, Qe);
          }), G_e = fE(function(U, ae, Ie, Qe) {
            ex(ae, yv(ae), U, Qe);
          }), Qie = Ul(T9);
          function H_e(U, ae) {
            var Ie = X_(U);
            return ae == null ? Ie : Zre(Ie, ae);
          }
          var TE = Bu(function(U, ae) {
            U = Uf(U);
            var Ie = -1, Qe = ae.length, At = Qe > 2 ? ae[2] : t3;
            for (At && Ly(ae[0], ae[1], At) && (Qe = 1); ++Ie < Qe; )
              for (var en = ae[Ie], Hn = Vm(en), Qn = -1, Or = Hn.length; ++Qn < Or; ) {
                var ia = Hn[Qn], Qi = U[ia];
                (Qi === t3 || qo(Qi, U_[ia]) && !Of.call(U, ia)) && (U[ia] = en[ia]);
              }
            return U;
          }), W_e = Bu(function(U) {
            return U.push(t3, eS), gv(TR, t3, U);
          });
          function Up(U, ae) {
            return Xv(U, Js(ae, 3), Z_);
          }
          function Bq(U, ae) {
            return Xv(U, Js(ae, 3), I9);
          }
          function eae(U, ae) {
            return U == null ? U : eR(U, Js(ae, 3), Vm);
          }
          function U_e(U, ae) {
            return U == null ? U : A9(U, Js(ae, 3), Vm);
          }
          function Pg(U, ae) {
            return U && Z_(U, Js(ae, 3));
          }
          function AE(U, ae) {
            return U && I9(U, Js(ae, 3));
          }
          function MR(U) {
            return U == null ? [] : Fk(U, yv(U));
          }
          function q_e(U) {
            return U == null ? [] : Fk(U, Vm(U));
          }
          function zq(U, ae, Ie) {
            var Qe = U == null ? t3 : iE(U, ae);
            return Qe === t3 ? Ie : Qe;
          }
          function jq(U, ae) {
            return U != null && tq(U, ae, Vbe);
          }
          function h7(U, ae) {
            return U != null && tq(U, ae, J_);
          }
          var $_e = qU(function(U, ae, Ie) {
            ae != null && typeof ae.toString != "function" && (ae = XL.call(ae)), U[ae] = Ie;
          }, y7(Fy)), Gk = qU(function(U, ae, Ie) {
            ae != null && typeof ae.toString != "function" && (ae = XL.call(ae)), Of.call(U, ae) ? U[ae].push(Ie) : U[ae] = [Ie];
          }, Js), X_e = Bu(dT);
          function yv(U) {
            return C0(U) ? w9(U) : iR(U);
          }
          function Vm(U) {
            return C0(U) ? w9(U, true) : cC(U);
          }
          function tae(U, ae) {
            var Ie = {};
            return ae = Js(ae, 3), Z_(U, function(Qe, At, en) {
              Fb(Ie, ae(Qe, At, en), Qe);
            }), Ie;
          }
          function Gq(U, ae) {
            var Ie = {};
            return ae = Js(ae, 3), Z_(U, function(Qe, At, en) {
              Fb(Ie, At, ae(Qe, At, en));
            }), Ie;
          }
          var p7 = fE(function(U, ae, Ie) {
            R9(U, ae, Ie);
          }), TR = fE(function(U, ae, Ie, Qe) {
            R9(U, ae, Ie, Qe);
          }), AR = Ul(function(U, ae) {
            var Ie = {};
            if (U == null)
              return Ie;
            var Qe = false;
            ae = wp(ae, function(en) {
              return en = _T(en, U), Qe || (Qe = en.length > 1), en;
            }), ex(U, W9(U), Ie), Qe && (Ie = Lm(Ie, L | F | B, fie));
            for (var At = ae.length; At--; )
              cE(Ie, ae[At]);
            return Ie;
          });
          function nae(U, ae) {
            return Wq(U, wR(Js(ae)));
          }
          var Hq = Ul(function(U, ae) {
            return U == null ? {} : oE(U, ae);
          });
          function Wq(U, ae) {
            if (U == null)
              return {};
            var Ie = wp(W9(U), function(Qe) {
              return [Qe];
            });
            return ae = Js(ae), sE(U, Ie, function(Qe, At) {
              return ae(Qe, At[0]);
            });
          }
          function rae(U, ae, Ie) {
            ae = _T(ae, U);
            var Qe = -1, At = ae.length;
            for (At || (At = 1, U = t3); ++Qe < At; ) {
              var en = U == null ? t3 : U[tS(ae[Qe])];
              en === t3 && (Qe = At, en = Ie), U = $1(en) ? en.call(U) : en;
            }
            return U;
          }
          function Y_e(U, ae, Ie) {
            return U == null ? U : yT(U, ae, Ie);
          }
          function K_e(U, ae, Ie, Qe) {
            return Qe = typeof Qe == "function" ? Qe : t3, U == null ? U : yT(U, ae, Ie, Qe);
          }
          var iae = KU(yv), Uq = KU(Vm);
          function aae(U, ae, Ie) {
            var Qe = ql(U), At = Qe || od(U) || Wb(U);
            if (ae = Js(ae, 4), Ie == null) {
              var en = U && U.constructor;
              At ? Ie = Qe ? new en() : [] : Sp(U) ? Ie = $1(en) ? X_(YL(U)) : {} : Ie = {};
            }
            return (At ? Yd : Z_)(U, function(Hn, Qn, Or) {
              return ae(Ie, Hn, Qn, Or);
            }), Ie;
          }
          function oae(U, ae) {
            return U == null ? true : cE(U, ae);
          }
          function sae(U, ae, Ie) {
            return U == null ? U : Vk(U, ae, cR(Ie));
          }
          function Z_e(U, ae, Ie, Qe) {
            return Qe = typeof Qe == "function" ? Qe : t3, U == null ? U : Vk(U, ae, cR(Ie), Qe);
          }
          function Hk(U) {
            return U == null ? [] : fU(U, yv(U));
          }
          function qq(U) {
            return U == null ? [] : fU(U, Vm(U));
          }
          function J_e(U, ae, Ie) {
            return Ie === t3 && (Ie = ae, ae = t3), Ie !== t3 && (Ie = X1(Ie), Ie = Ie === Ie ? Ie : 0), ae !== t3 && (ae = X1(ae), ae = ae === ae ? ae : 0), K_(X1(U), ae, Ie);
          }
          function lae(U, ae, Ie) {
            return ae = uS(ae), Ie === t3 ? (Ie = ae, ae = 0) : Ie = uS(Ie), U = X1(U), NU(U, ae, Ie);
          }
          function cS(U, ae, Ie) {
            if (Ie && typeof Ie != "boolean" && Ly(U, ae, Ie) && (ae = Ie = t3), Ie === t3 && (typeof ae == "boolean" ? (Ie = ae, ae = t3) : typeof U == "boolean" && (Ie = U, U = t3)), U === t3 && ae === t3 ? (U = 0, ae = 1) : (U = uS(U), ae === t3 ? (ae = U, U = 0) : ae = uS(ae)), U > ae) {
              var Qe = U;
              U = ae, ae = Qe;
            }
            if (Ie || U % 1 || ae % 1) {
              var At = y9();
              return Dg(U + At * (ae - U + rC("1e-" + ((At + "").length - 1))), ae);
            }
            return jb(U, ae);
          }
          var Q_e = zu(function(U, ae, Ie) {
            return ae = ae.toLowerCase(), U + (Ie ? $q(ae) : ae);
          });
          function $q(U) {
            return T0(Lf(U).toLowerCase());
          }
          function d7(U) {
            return U = Lf(U), U && U.replace(Ma, gbe).replace(Wa, "");
          }
          function uae(U, ae, Ie) {
            U = Lf(U), ae = sp(ae);
            var Qe = U.length;
            Ie = Ie === t3 ? Qe : K_(pu(Ie), 0, Qe);
            var At = Ie;
            return Ie -= ae.length, Ie >= 0 && U.slice(Ie, At) == ae;
          }
          function Xq(U) {
            return U = Lf(U), U && Xd.test(U) ? U.replace(Gp, dU) : U;
          }
          function IE(U) {
            return U = Lf(U), U && RL.test(U) ? U.replace(Q2, "\\$&") : U;
          }
          var Wk = zu(function(U, ae, Ie) {
            return U + (Ie ? "-" : "") + ae.toLowerCase();
          }), exe = zu(function(U, ae, Ie) {
            return U + (Ie ? " " : "") + ae.toLowerCase();
          }), M0 = uie("toLowerCase");
          function cae(U, ae, Ie) {
            U = Lf(U), ae = pu(ae);
            var Qe = ae ? JI(U) : 0;
            if (!ae || Qe >= ae)
              return U;
            var At = (ae - Qe) / 2;
            return hR(ZL(At), Ie) + U + hR($_(At), Ie);
          }
          function IR(U, ae, Ie) {
            U = Lf(U), ae = pu(ae);
            var Qe = ae ? JI(U) : 0;
            return ae && Qe < ae ? U + hR(ae - Qe, Ie) : U;
          }
          function ER(U, ae, Ie) {
            U = Lf(U), ae = pu(ae);
            var Qe = ae ? JI(U) : 0;
            return ae && Qe < ae ? hR(ae - Qe, Ie) + U : U;
          }
          function fS(U, ae, Ie) {
            return Ie || ae == null ? ae = 0 : ae && (ae = +ae), Tbe(Lf(U).replace(eC, ""), ae || 0);
          }
          function ax(U, ae, Ie) {
            return (Ie ? Ly(U, ae, Ie) : ae === t3) ? ae = 1 : ae = pu(ae), Q_(Lf(U), ae);
          }
          function txe() {
            var U = arguments, ae = Lf(U[0]);
            return U.length < 3 ? ae : ae.replace(U[1], U[2]);
          }
          var v7 = zu(function(U, ae, Ie) {
            return U + (Ie ? "_" : "") + ae.toLowerCase();
          });
          function nxe(U, ae, Ie) {
            return Ie && typeof Ie != "number" && Ly(U, ae, Ie) && (ae = Ie = t3), Ie = Ie === t3 ? cr : Ie >>> 0, Ie ? (U = Lf(U), U && (typeof ae == "string" || ae != null && !Lq(ae)) && (ae = sp(ae), !ae && Eg(U)) ? xT(W_(U), 0, Ie) : U.split(ae, Ie)) : [];
          }
          var rxe = zu(function(U, ae, Ie) {
            return U + (Ie ? " " : "") + T0(ae);
          });
          function ixe(U, ae, Ie) {
            return U = Lf(U), Ie = Ie == null ? 0 : K_(pu(Ie), 0, U.length), ae = sp(ae), U.slice(Ie, Ie + ae.length) == ae;
          }
          function fae(U, ae, Ie) {
            var Qe = Ut.templateSettings;
            Ie && Ly(U, ae, Ie) && (ae = t3), U = Lf(U), ae = f7({}, ae, Qe, ZU);
            var At = f7({}, ae.imports, Qe.imports, ZU), en = yv(At), Hn = fU(At, en), Qn, Or, ia = 0, Qi = ae.interpolate || Na, pa = "__p += '", mo = UL((ae.escape || Na).source + "|" + Qi.source + "|" + (Qi === Em ? Yt : Na).source + "|" + (ae.evaluate || Na).source + "|$", "g"), Ss = "//# sourceURL=" + (Of.call(ae, "sourceURL") ? (ae.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++VL + "]") + `
`;
            U.replace(mo, function(al, bc, Gu, Lg, A0, Vy) {
              return Gu || (Gu = Lg), pa += U.slice(ia, Vy).replace(fu, Nre), bc && (Qn = true, pa += `' +
__e(` + bc + `) +
'`), A0 && (Or = true, pa += `';
` + A0 + `;
__p += '`), Gu && (pa += `' +
((__t = (` + Gu + `)) == null ? '' : __t) +
'`), ia = Vy + al.length, al;
            }), pa += `';
`;
            var ul = Of.call(ae, "variable") && ae.variable;
            if (!ul)
              pa = `with (obj) {
` + pa + `
}
`;
            else if (In.test(ul))
              throw new Vl(w3);
            pa = (Or ? pa.replace(m0, "") : pa).replace(Sy, "$1").replace(Ob, "$1;"), pa = "function(" + (ul || "obj") + `) {
` + (ul ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Qn ? ", __e = _.escape" : "") + (Or ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + pa + `return __p
}`;
            var $l = Yq(function() {
              return wf(en, Ss + "return " + pa).apply(t3, Hn);
            });
            if ($l.source = pa, CE($l))
              throw $l;
            return $l;
          }
          function Bm(U) {
            return Lf(U).toLowerCase();
          }
          function axe(U) {
            return Lf(U).toUpperCase();
          }
          function hae(U, ae, Ie) {
            if (U = Lf(U), U && (Ie || ae === t3))
              return Lre(U);
            if (!U || !(ae = sp(ae)))
              return U;
            var Qe = W_(U), At = W_(ae), en = hU(Qe, At), Hn = Rre(Qe, At) + 1;
            return xT(Qe, en, Hn).join("");
          }
          function g7(U, ae, Ie) {
            if (U = Lf(U), U && (Ie || ae === t3))
              return U.slice(0, Vre(U) + 1);
            if (!U || !(ae = sp(ae)))
              return U;
            var Qe = W_(U), At = Rre(Qe, W_(ae)) + 1;
            return xT(Qe, 0, At).join("");
          }
          function oxe(U, ae, Ie) {
            if (U = Lf(U), U && (Ie || ae === t3))
              return U.replace(eC, "");
            if (!U || !(ae = sp(ae)))
              return U;
            var Qe = W_(U), At = hU(Qe, W_(ae));
            return xT(Qe, At).join("");
          }
          function pae(U, ae) {
            var Ie = nt, Qe = lt2;
            if (Sp(ae)) {
              var At = "separator" in ae ? ae.separator : At;
              Ie = "length" in ae ? pu(ae.length) : Ie, Qe = "omission" in ae ? sp(ae.omission) : Qe;
            }
            U = Lf(U);
            var en = U.length;
            if (Eg(U)) {
              var Hn = W_(U);
              en = Hn.length;
            }
            if (Ie >= en)
              return U;
            var Qn = Ie - JI(Qe);
            if (Qn < 1)
              return Qe;
            var Or = Hn ? xT(Hn, 0, Qn).join("") : U.slice(0, Qn);
            if (At === t3)
              return Or + Qe;
            if (Hn && (Qn += Or.length - Qn), Lq(At)) {
              if (U.slice(Qn).search(At)) {
                var ia, Qi = Or;
                for (At.global || (At = UL(At.source, Lf(_n.exec(At)) + "g")), At.lastIndex = 0; ia = At.exec(Qi); )
                  var pa = ia.index;
                Or = Or.slice(0, pa === t3 ? Qn : pa);
              }
            } else if (U.indexOf(sp(At), Qn) != Qn) {
              var mo = Or.lastIndexOf(At);
              mo > -1 && (Or = Or.slice(0, mo));
            }
            return Or + Qe;
          }
          function sxe(U) {
            return U = Lf(U), U && yc.test(U) ? U.replace(Cy, bbe) : U;
          }
          var dae = zu(function(U, ae, Ie) {
            return U + (Ie ? " " : "") + ae.toUpperCase();
          }), T0 = uie("toUpperCase");
          function vae(U, ae, Ie) {
            return U = Lf(U), ae = Ie ? t3 : ae, ae === t3 ? ybe(U) ? Bre(U) : c9(U) : U.match(ae) || [];
          }
          var Yq = Bu(function(U, ae) {
            try {
              return gv(U, t3, ae);
            } catch (Ie) {
              return CE(Ie) ? Ie : new Vl(Ie);
            }
          }), zm = Ul(function(U, ae) {
            return Yd(ae, function(Ie) {
              Ie = tS(Ie), Fb(U, Ie, AT(U[Ie], U));
            }), U;
          });
          function lxe(U) {
            var ae = U == null ? 0 : U.length, Ie = Js();
            return U = ae ? wp(U, function(Qe) {
              if (typeof Qe[1] != "function")
                throw new Ey(b3);
              return [Ie(Qe[0]), Qe[1]];
            }) : [], Bu(function(Qe) {
              for (var At = -1; ++At < ae; ) {
                var en = U[At];
                if (gv(en[0], this, Qe))
                  return gv(en[1], this, Qe);
              }
            });
          }
          function uxe(U) {
            return OU(Lm(U, L));
          }
          function y7(U) {
            return function() {
              return U;
            };
          }
          function Jv(U, ae) {
            return U == null || U !== U ? ae : U;
          }
          var jm = tx(), cxe = tx(true);
          function Fy(U) {
            return U;
          }
          function m7(U) {
            return rR(typeof U == "function" ? U : Lm(U, L));
          }
          function b7(U) {
            return L9(Lm(U, L));
          }
          function fxe(U, ae) {
            return aE(U, Lm(ae, L));
          }
          var gae = Bu(function(U, ae) {
            return function(Ie) {
              return dT(Ie, U, ae);
            };
          }), Kq = Bu(function(U, ae) {
            return function(Ie) {
              return dT(U, Ie, ae);
            };
          });
          function Zq(U, ae, Ie) {
            var Qe = yv(ae), At = Fk(ae, Qe);
            Ie == null && !(Sp(ae) && (At.length || !Qe.length)) && (Ie = ae, ae = U, U = this, At = Fk(ae, yv(ae)));
            var en = !(Sp(Ie) && "chain" in Ie) || !!Ie.chain, Hn = $1(U);
            return Yd(At, function(Qn) {
              var Or = ae[Qn];
              U[Qn] = Or, Hn && (U.prototype[Qn] = function() {
                var ia = this.__chain__;
                if (en || ia) {
                  var Qi = U(this.__wrapped__), pa = Qi.__actions__ = Og(this.__actions__);
                  return pa.push({ func: Or, args: arguments, thisArg: U }), Qi.__chain__ = ia, Qi;
                }
                return Or.apply(U, Kw([this.value()], arguments));
              });
            }), U;
          }
          function Jq() {
            return wh._ === this && (wh._ = d9), this;
          }
          function Qq() {
          }
          function yae(U) {
            return U = pu(U), Bu(function(ae) {
              return BU(ae, U);
            });
          }
          var hxe = $U(wp), DR = $U(oU), pxe = $U(Zw);
          function e$(U) {
            return rq(U) ? lU(tS(U)) : zU(U);
          }
          function EE(U) {
            return function(ae) {
              return U == null ? t3 : iE(U, ae);
            };
          }
          var DE = pR(), _7 = pR(true);
          function Uk() {
            return [];
          }
          function t$() {
            return false;
          }
          function x7() {
            return {};
          }
          function dxe() {
            return "";
          }
          function vxe() {
            return true;
          }
          function gxe(U, ae) {
            if (U = pu(U), U < 1 || U > ln)
              return [];
            var Ie = cr, Qe = Dg(U, cr);
            ae = Js(ae), U -= cr;
            for (var At = h9(Qe, ae); ++Ie < U; )
              ae(Ie);
            return At;
          }
          function mae(U) {
            return ql(U) ? wp(U, tS) : Ny(U) ? [U] : Og(sq(Lf(U)));
          }
          function qk(U) {
            var ae = ++Sbe;
            return Lf(U) + ae;
          }
          var n$ = j9(function(U, ae) {
            return U + ae;
          }, 0), ku = XU("ceil"), $h = j9(function(U, ae) {
            return U / ae;
          }, 1), $k = XU("floor");
          function kT(U) {
            return U && U.length ? uC(U, Fy, D9) : t3;
          }
          function bae(U, ae) {
            return U && U.length ? uC(U, Js(ae, 2), D9) : t3;
          }
          function kR(U) {
            return Ore(U, Fy);
          }
          function ox(U, ae) {
            return Ore(U, Js(ae, 2));
          }
          function yxe(U) {
            return U && U.length ? uC(U, Fy, zb) : t3;
          }
          function w7(U, ae) {
            return U && U.length ? uC(U, Js(ae, 2), zb) : t3;
          }
          var S7 = j9(function(U, ae) {
            return U * ae;
          }, 1), r$ = XU("round"), mxe = j9(function(U, ae) {
            return U - ae;
          }, 0);
          function bxe(U) {
            return U && U.length ? f9(U, Fy) : 0;
          }
          function _xe(U, ae) {
            return U && U.length ? f9(U, Js(ae, 2)) : 0;
          }
          return Ut.after = Eie, Ut.ary = Zv, Ut.assign = Vq, Ut.assignIn = Jie, Ut.assignInWith = f7, Ut.assignWith = G_e, Ut.at = Qie, Ut.before = Die, Ut.bind = AT, Ut.bindAll = zm, Ut.bindKey = Tq, Ut.castArray = zie, Ut.chain = n7, Ut.chunk = Y9, Ut.compact = vE, Ut.concat = n_e, Ut.cond = lxe, Ut.conforms = uxe, Ut.constant = y7, Ut.countBy = bR, Ut.create = H_e, Ut.curry = Aq, Ut.curryRight = IT, Ut.debounce = kie, Ut.defaults = TE, Ut.defaultsDeep = W_e, Ut.defer = R_e, Ut.delay = Oie, Ut.difference = r_e, Ut.differenceBy = i_e, Ut.differenceWith = lq, Ut.drop = a_e, Ut.dropRight = uq, Ut.dropRightWhile = bie, Ut.dropWhile = K9, Ut.fill = cq, Ut.filter = yC, Ut.flatMap = C_e, Ut.flatMapDeep = M_e, Ut.flatMapDepth = Ry, Ut.flatten = hq, Ut.flattenDeep = o_e, Ut.flattenDepth = s_e, Ut.flip = xu, Ut.flow = jm, Ut.flowRight = cxe, Ut.fromPairs = l_e, Ut.functions = MR, Ut.functionsIn = q_e, Ut.groupBy = T_e, Ut.initial = c_e, Ut.intersection = dq, Ut.intersectionBy = f_e, Ut.intersectionWith = h_e, Ut.invert = $_e, Ut.invertBy = Gk, Ut.invokeMap = I_e, Ut.iteratee = m7, Ut.keyBy = Aie, Ut.keys = yv, Ut.keysIn = Vm, Ut.map = r7, Ut.mapKeys = tae, Ut.mapValues = Gq, Ut.matches = b7, Ut.matchesProperty = fxe, Ut.memoize = xR, Ut.merge = p7, Ut.mergeWith = TR, Ut.method = gae, Ut.methodOf = Kq, Ut.mixin = Zq, Ut.negate = wR, Ut.nthArg = yae, Ut.omit = AR, Ut.omitBy = nae, Ut.once = N_e, Ut.orderBy = E_e, Ut.over = hxe, Ut.overArgs = Pie, Ut.overEvery = DR, Ut.overSome = pxe, Ut.partial = Iq, Ut.partialRight = Lie, Ut.partition = i7, Ut.pick = Hq, Ut.pickBy = Wq, Ut.property = e$, Ut.propertyOf = EE, Ut.pull = Z9, Ut.pullAll = gq, Ut.pullAllBy = d_e, Ut.pullAllWith = v_e, Ut.pullAt = yq, Ut.range = DE, Ut.rangeRight = _7, Ut.rearg = Rie, Ut.reject = k_e, Ut.remove = mq, Ut.rest = Nie, Ut.reverse = bq, Ut.sampleSize = O_e, Ut.set = Y_e, Ut.setWith = K_e, Ut.shuffle = Iie, Ut.slice = Hb, Ut.sortBy = L_e, Ut.sortedUniq = Q9, Ut.sortedUniqBy = e7, Ut.split = nxe, Ut.spread = Fie, Ut.tail = t7, Ut.take = xie, Ut.takeRight = wie, Ut.takeRightWhile = Sie, Ut.takeWhile = g_e, Ut.tap = mR, Ut.throttle = Vie, Ut.thru = zk, Ut.toArray = Rq, Ut.toPairs = iae, Ut.toPairsIn = Uq, Ut.toPath = mae, Ut.toPlainObject = c7, Ut.transform = aae, Ut.unary = F_e, Ut.union = y_e, Ut.unionBy = m_e, Ut.unionWith = Pf, Ut.uniq = mE, Ut.uniqBy = bE, Ut.uniqWith = nS, Ut.unset = oae, Ut.unzip = rS, Ut.unzipWith = ix, Ut.update = sae, Ut.updateWith = Z_e, Ut.values = Hk, Ut.valuesIn = qq, Ut.without = iS, Ut.words = vae, Ut.wrap = Bie, Ut.xor = wq, Ut.xorBy = Sq, Ut.xorWith = _E, Ut.zip = xE, Ut.zipObject = gC, Ut.zipObjectDeep = Cq, Ut.zipWith = ST, Ut.entries = iae, Ut.entriesIn = Uq, Ut.extend = Jie, Ut.extendWith = f7, Zq(Ut, Ut), Ut.add = n$, Ut.attempt = Yq, Ut.camelCase = Q_e, Ut.capitalize = $q, Ut.ceil = ku, Ut.clamp = J_e, Ut.clone = jie, Ut.cloneDeep = Hie, Ut.cloneDeepWith = Eq, Ut.cloneWith = Gie, Ut.conformsTo = ju, Ut.deburr = d7, Ut.defaultTo = Jv, Ut.divide = $h, Ut.endsWith = uae, Ut.eq = qo, Ut.escape = Xq, Ut.escapeRegExp = IE, Ut.every = S_e, Ut.find = TT, Ut.findIndex = _ie, Ut.findKey = Up, Ut.findLast = wE, Ut.findLastIndex = fq, Ut.findLastKey = Bq, Ut.floor = $k, Ut.forEach = q1, Ut.forEachRight = Tie, Ut.forIn = eae, Ut.forInRight = U_e, Ut.forOwn = Pg, Ut.forOwnRight = AE, Ut.get = zq, Ut.gt = Dq, Ut.gte = Wie, Ut.has = jq, Ut.hasIn = h7, Ut.head = pq, Ut.identity = Fy, Ut.includes = A_e, Ut.indexOf = u_e, Ut.inRange = lae, Ut.invoke = X_e, Ut.isArguments = ET, Ut.isArray = ql, Ut.isArrayBuffer = kq, Ut.isArrayLike = C0, Ut.isArrayLikeObject = lp, Ut.isBoolean = o7, Ut.isBuffer = od, Ut.isDate = SR, Ut.isElement = jk, Ut.isEmpty = V_e, Ut.isEqual = SE, Ut.isEqualWith = s7, Ut.isError = CE, Ut.isFinite = l7, Ut.isFunction = $1, Ut.isInteger = ME, Ut.isLength = CR, Ut.isMap = Oq, Ut.isMatch = Uie, Ut.isMatchWith = Pq, Ut.isNaN = qie, Ut.isNative = B_e, Ut.isNil = $ie, Ut.isNull = z_e, Ut.isNumber = oS, Ut.isObject = Sp, Ut.isObjectLike = up, Ut.isPlainObject = DT, Ut.isRegExp = Lq, Ut.isSafeInteger = j_e, Ut.isSet = Xie, Ut.isString = u7, Ut.isSymbol = Ny, Ut.isTypedArray = Wb, Ut.isUndefined = Yie, Ut.isWeakMap = Kie, Ut.isWeakSet = sS, Ut.join = p_e, Ut.kebabCase = Wk, Ut.last = U1, Ut.lastIndexOf = vq, Ut.lowerCase = exe, Ut.lowerFirst = M0, Ut.lt = lS, Ut.lte = Zie, Ut.max = kT, Ut.maxBy = bae, Ut.mean = kR, Ut.meanBy = ox, Ut.min = yxe, Ut.minBy = w7, Ut.stubArray = Uk, Ut.stubFalse = t$, Ut.stubObject = x7, Ut.stubString = dxe, Ut.stubTrue = vxe, Ut.multiply = S7, Ut.nth = gE, Ut.noConflict = Jq, Ut.noop = Qq, Ut.now = a7, Ut.pad = cae, Ut.padEnd = IR, Ut.padStart = ER, Ut.parseInt = fS, Ut.random = cS, Ut.reduce = D_e, Ut.reduceRight = Mq, Ut.repeat = ax, Ut.replace = txe, Ut.result = rae, Ut.round = r$, Ut.runInContext = _r, Ut.sample = ml, Ut.size = _R, Ut.snakeCase = v7, Ut.some = P_e, Ut.sortedIndex = Nm, Ut.sortedIndexBy = Fm, Ut.sortedIndexOf = _q, Ut.sortedLastIndex = xq, Ut.sortedLastIndexBy = yE, Ut.sortedLastIndexOf = J9, Ut.startCase = rxe, Ut.startsWith = ixe, Ut.subtract = mxe, Ut.sum = bxe, Ut.sumBy = _xe, Ut.template = fae, Ut.times = gxe, Ut.toFinite = uS, Ut.toInteger = pu, Ut.toLength = Nq, Ut.toLower = Bm, Ut.toNumber = X1, Ut.toSafeInteger = Fq, Ut.toString = Lf, Ut.toUpper = axe, Ut.trim = hae, Ut.trimEnd = g7, Ut.trimStart = oxe, Ut.truncate = pae, Ut.unescape = sxe, Ut.uniqueId = qk, Ut.upperCase = dae, Ut.upperFirst = T0, Ut.each = q1, Ut.eachRight = Tie, Ut.first = pq, Zq(Ut, function() {
            var U = {};
            return Z_(Ut, function(ae, Ie) {
              Of.call(Ut.prototype, Ie) || (U[Ie] = ae);
            }), U;
          }(), { chain: false }), Ut.VERSION = c3, Yd(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(U) {
            Ut[U].placeholder = Ut;
          }), Yd(["drop", "take"], function(U, ae) {
            kc.prototype[U] = function(Ie) {
              Ie = Ie === t3 ? 1 : Hp(pu(Ie), 0);
              var Qe = this.__filtered__ && !ae ? new kc(this) : this.clone();
              return Qe.__filtered__ ? Qe.__takeCount__ = Dg(Ie, Qe.__takeCount__) : Qe.__views__.push({ size: Dg(Ie, cr), type: U + (Qe.__dir__ < 0 ? "Right" : "") }), Qe;
            }, kc.prototype[U + "Right"] = function(Ie) {
              return this.reverse()[U](Ie).reverse();
            };
          }), Yd(["filter", "map", "takeWhile"], function(U, ae) {
            var Ie = ae + 1, Qe = Ie == jt || Ie == Rt;
            kc.prototype[U] = function(At) {
              var en = this.clone();
              return en.__iteratees__.push({ iteratee: Js(At, 3), type: Ie }), en.__filtered__ = en.__filtered__ || Qe, en;
            };
          }), Yd(["head", "last"], function(U, ae) {
            var Ie = "take" + (ae ? "Right" : "");
            kc.prototype[U] = function() {
              return this[Ie](1).value()[0];
            };
          }), Yd(["initial", "tail"], function(U, ae) {
            var Ie = "drop" + (ae ? "" : "Right");
            kc.prototype[U] = function() {
              return this.__filtered__ ? new kc(this) : this[Ie](1);
            };
          }), kc.prototype.compact = function() {
            return this.filter(Fy);
          }, kc.prototype.find = function(U) {
            return this.filter(U).head();
          }, kc.prototype.findLast = function(U) {
            return this.reverse().find(U);
          }, kc.prototype.invokeMap = Bu(function(U, ae) {
            return typeof U == "function" ? new kc(this) : this.map(function(Ie) {
              return dT(Ie, U, ae);
            });
          }), kc.prototype.reject = function(U) {
            return this.filter(wR(Js(U)));
          }, kc.prototype.slice = function(U, ae) {
            U = pu(U);
            var Ie = this;
            return Ie.__filtered__ && (U > 0 || ae < 0) ? new kc(Ie) : (U < 0 ? Ie = Ie.takeRight(-U) : U && (Ie = Ie.drop(U)), ae !== t3 && (ae = pu(ae), Ie = ae < 0 ? Ie.dropRight(-ae) : Ie.take(ae - U)), Ie);
          }, kc.prototype.takeRightWhile = function(U) {
            return this.reverse().takeWhile(U).reverse();
          }, kc.prototype.toArray = function() {
            return this.take(cr);
          }, Z_(kc.prototype, function(U, ae) {
            var Ie = /^(?:filter|find|map|reject)|While$/.test(ae), Qe = /^(?:head|last)$/.test(ae), At = Ut[Qe ? "take" + (ae == "last" ? "Right" : "") : ae], en = Qe || /^find/.test(ae);
            !At || (Ut.prototype[ae] = function() {
              var Hn = this.__wrapped__, Qn = Qe ? [1] : arguments, Or = Hn instanceof kc, ia = Qn[0], Qi = Or || ql(Hn), pa = function(bc) {
                var Gu = At.apply(Ut, Kw([bc], Qn));
                return Qe && mo ? Gu[0] : Gu;
              };
              Qi && Ie && typeof ia == "function" && ia.length != 1 && (Or = Qi = false);
              var mo = this.__chain__, Ss = !!this.__actions__.length, ul = en && !mo, $l = Or && !Ss;
              if (!en && Qi) {
                Hn = $l ? Hn : new kc(this);
                var al = U.apply(Hn, Qn);
                return al.__actions__.push({ func: zk, args: [pa], thisArg: t3 }), new Om(al, mo);
              }
              return ul && $l ? U.apply(this, Qn) : (al = this.thru(pa), ul ? Qe ? al.value()[0] : al.value() : al);
            });
          }), Yd(["pop", "push", "shift", "sort", "splice", "unshift"], function(U) {
            var ae = x0[U], Ie = /^(?:push|sort|unshift)$/.test(U) ? "tap" : "thru", Qe = /^(?:pop|shift)$/.test(U);
            Ut.prototype[U] = function() {
              var At = arguments;
              if (Qe && !this.__chain__) {
                var en = this.value();
                return ae.apply(ql(en) ? en : [], At);
              }
              return this[Ie](function(Hn) {
                return ae.apply(ql(Hn) ? Hn : [], At);
              });
            };
          }), Z_(kc.prototype, function(U, ae) {
            var Ie = Ut[ae];
            if (Ie) {
              var Qe = Ie.name + "";
              Of.call(Lk, Qe) || (Lk[Qe] = []), Lk[Qe].push({ name: ae, func: Ie });
            }
          }), Lk[z9(t3, se).name] = [{ name: "wrapper", func: t3 }], kc.prototype.clone = AU, kc.prototype.reverse = IU, kc.prototype.value = Ibe, Ut.prototype.at = b_e, Ut.prototype.chain = x_e, Ut.prototype.commit = aS, Ut.prototype.next = CT, Ut.prototype.plant = Cie, Ut.prototype.reverse = Mie, Ut.prototype.toJSON = Ut.prototype.valueOf = Ut.prototype.value = MT, Ut.prototype.first = Ut.prototype.head, Nb && (Ut.prototype[Nb] = w_e), Ut;
        }, QI = xbe();
        $w ? (($w.exports = QI)._ = QI, l9._ = QI) : wh._ = QI;
      }).call(_t);
    })(nre, nre.exports);
    class $Be {
      constructor() {
        x3(this, "subscriptions", /* @__PURE__ */ new Map()), x3(this, "emitEffectCache", /* @__PURE__ */ new Map()), x3(this, "useSubscription", (i, t3) => {
          const c3 = C.useRef();
          C.useEffect(() => {
            var p3, g3;
            c3.current = t3;
            function b3(M) {
              c3.current && c3.current(M);
            }
            const w3 = (g3 = (p3 = this.subscriptions) == null ? void 0 : p3.get(i)) != null ? g3 : [];
            return w3.push(b3), this.subscriptions.set(i, w3), this.emitEffect(i), () => {
              this.subscriptions.delete(i);
            };
          });
        }), x3(this, "emit", (i, ...t3) => {
          if (typeof i == "string" || typeof i == "number") {
            const c3 = this.subscriptions.get(i);
            c3 == null || c3.forEach((p3) => {
              p3 == null || p3({ params: nre.exports.cloneDeep(t3), event: i });
            }), this.emitEffectCache.set(i, { params: nre.exports.cloneDeep(t3), event: i });
          } else
            throw new TypeError("event must be string or number !");
        }), x3(this, "emitEffect", (i) => {
          const t3 = this.emitEffectCache.get(i), c3 = this.subscriptions.get(i);
          t3 && (c3 == null || c3.forEach((p3) => {
            p3 == null || p3(m3({}, t3));
          }));
        }), x3(this, "removeListener", (i) => {
          this.subscriptions.delete(i);
        }), x3(this, "clear", () => {
          this.subscriptions.clear();
        }), this.clear();
      }
    }
    const qOt = new $Be();
    function rre(o) {
      const i = C.useRef(), t3 = C.useMemo(() => o != null ? o : { global: false }, [o]);
      return i.current || (i.current = t3.global ? i.current = qOt : i.current = new $Be()), C.useEffect(() => () => {
        var c3;
        return (c3 = i.current) == null ? void 0 : c3.clear();
      }, []), i.current;
    }
    const _1e = ({ id: o, title: i, chart: t3, option: c3 }, p3) => {
      const g3 = C.useRef(UOt), b3 = rre({ global: true });
      return zi(() => {
        console.log("id", o), console.log("chart", t3 == null ? void 0 : t3.current), g3.current && (t3 == null ? void 0 : t3.current) && o && c3 && (g3.current.add(o, t3 == null ? void 0 : t3.current, c3, i), b3.emit("list"));
      }, p3 != null ? p3 : [], { wait: 100 }), { tool: g3.current };
    };
    var $Ot = C.createContext({}), XBe = $Ot;
    function Qf(o, i, t3) {
      return i in o ? Object.defineProperty(o, i, { value: t3, enumerable: true, configurable: true, writable: true }) : o[i] = t3, o;
    }
    function YBe(o, i) {
      var t3 = Object.keys(o);
      if (Object.getOwnPropertySymbols) {
        var c3 = Object.getOwnPropertySymbols(o);
        i && (c3 = c3.filter(function(p3) {
          return Object.getOwnPropertyDescriptor(o, p3).enumerable;
        })), t3.push.apply(t3, c3);
      }
      return t3;
    }
    function tu(o) {
      for (var i = 1; i < arguments.length; i++) {
        var t3 = arguments[i] != null ? arguments[i] : {};
        i % 2 ? YBe(Object(t3), true).forEach(function(c3) {
          Qf(o, c3, t3[c3]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(o, Object.getOwnPropertyDescriptors(t3)) : YBe(Object(t3)).forEach(function(c3) {
          Object.defineProperty(o, c3, Object.getOwnPropertyDescriptor(t3, c3));
        });
      }
      return o;
    }
    function KBe(o) {
      if (Array.isArray(o))
        return o;
    }
    function XOt(o, i) {
      var t3 = o == null ? null : typeof Symbol != "undefined" && o[Symbol.iterator] || o["@@iterator"];
      if (t3 != null) {
        var c3 = [], p3 = true, g3 = false, b3, w3;
        try {
          for (t3 = t3.call(o); !(p3 = (b3 = t3.next()).done) && (c3.push(b3.value), !(i && c3.length === i)); p3 = true)
            ;
        } catch (M) {
          g3 = true, w3 = M;
        } finally {
          try {
            !p3 && t3.return != null && t3.return();
          } finally {
            if (g3)
              throw w3;
          }
        }
        return c3;
      }
    }
    function x1e(o, i) {
      (i == null || i > o.length) && (i = o.length);
      for (var t3 = 0, c3 = new Array(i); t3 < i; t3++)
        c3[t3] = o[t3];
      return c3;
    }
    function w1e(o, i) {
      if (o) {
        if (typeof o == "string")
          return x1e(o, i);
        var t3 = Object.prototype.toString.call(o).slice(8, -1);
        if (t3 === "Object" && o.constructor && (t3 = o.constructor.name), t3 === "Map" || t3 === "Set")
          return Array.from(o);
        if (t3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t3))
          return x1e(o, i);
      }
    }
    function ZBe() {
      throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function zw(o, i) {
      return KBe(o) || XOt(o, i) || w1e(o, i) || ZBe();
    }
    function YOt(o, i) {
      if (o == null)
        return {};
      var t3 = {}, c3 = Object.keys(o), p3, g3;
      for (g3 = 0; g3 < c3.length; g3++)
        p3 = c3[g3], !(i.indexOf(p3) >= 0) && (t3[p3] = o[p3]);
      return t3;
    }
    function e9(o, i) {
      if (o == null)
        return {};
      var t3 = YOt(o, i), c3, p3;
      if (Object.getOwnPropertySymbols) {
        var g3 = Object.getOwnPropertySymbols(o);
        for (p3 = 0; p3 < g3.length; p3++)
          c3 = g3[p3], !(i.indexOf(c3) >= 0) && (!Object.prototype.propertyIsEnumerable.call(o, c3) || (t3[c3] = o[c3]));
      }
      return t3;
    }
    var JBe = { exports: {} };
    /*!
      Copyright (c) 2018 Jed Watson.
      Licensed under the MIT License (MIT), see
      http://jedwatson.github.io/classnames
    */
    (function(o) {
      (function() {
        var i = {}.hasOwnProperty;
        function t3() {
          for (var c3 = [], p3 = 0; p3 < arguments.length; p3++) {
            var g3 = arguments[p3];
            if (g3) {
              var b3 = typeof g3;
              if (b3 === "string" || b3 === "number")
                c3.push(g3);
              else if (Array.isArray(g3)) {
                if (g3.length) {
                  var w3 = t3.apply(null, g3);
                  w3 && c3.push(w3);
                }
              } else if (b3 === "object")
                if (g3.toString === Object.prototype.toString)
                  for (var M in g3)
                    i.call(g3, M) && g3[M] && c3.push(M);
                else
                  c3.push(g3.toString());
            }
          }
          return c3.join(" ");
        }
        o.exports ? (t3.default = t3, o.exports = t3) : window.classNames = t3;
      })();
    })(JBe);
    var t9 = JBe.exports;
    function Am(o) {
      return Am = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
        return typeof i;
      } : function(i) {
        return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
      }, Am(o);
    }
    function jw(o, i) {
      KOt(o) && (o = "100%");
      var t3 = ZOt(o);
      return o = i === 360 ? o : Math.min(i, Math.max(0, parseFloat(o))), t3 && (o = parseInt(String(o * i), 10) / 100), Math.abs(o - i) < 1e-6 ? 1 : (i === 360 ? o = (o < 0 ? o % i + i : o % i) / parseFloat(String(i)) : o = o % i / parseFloat(String(i)), o);
    }
    function KOt(o) {
      return typeof o == "string" && o.indexOf(".") !== -1 && parseFloat(o) === 1;
    }
    function ZOt(o) {
      return typeof o == "string" && o.indexOf("%") !== -1;
    }
    function JOt(o) {
      return o = parseFloat(o), (isNaN(o) || o < 0 || o > 1) && (o = 1), o;
    }
    function ire(o) {
      return o <= 1 ? Number(o) * 100 + "%" : o;
    }
    function S1e(o) {
      return o.length === 1 ? "0" + o : String(o);
    }
    function QOt(o, i, t3) {
      return { r: jw(o, 255) * 255, g: jw(i, 255) * 255, b: jw(t3, 255) * 255 };
    }
    function C1e(o, i, t3) {
      return t3 < 0 && (t3 += 1), t3 > 1 && (t3 -= 1), t3 < 1 / 6 ? o + (i - o) * (6 * t3) : t3 < 1 / 2 ? i : t3 < 2 / 3 ? o + (i - o) * (2 / 3 - t3) * 6 : o;
    }
    function ePt(o, i, t3) {
      var c3, p3, g3;
      if (o = jw(o, 360), i = jw(i, 100), t3 = jw(t3, 100), i === 0)
        p3 = t3, g3 = t3, c3 = t3;
      else {
        var b3 = t3 < 0.5 ? t3 * (1 + i) : t3 + i - t3 * i, w3 = 2 * t3 - b3;
        c3 = C1e(w3, b3, o + 1 / 3), p3 = C1e(w3, b3, o), g3 = C1e(w3, b3, o - 1 / 3);
      }
      return { r: c3 * 255, g: p3 * 255, b: g3 * 255 };
    }
    function tPt(o, i, t3) {
      o = jw(o, 255), i = jw(i, 255), t3 = jw(t3, 255);
      var c3 = Math.max(o, i, t3), p3 = Math.min(o, i, t3), g3 = 0, b3 = c3, w3 = c3 - p3, M = c3 === 0 ? 0 : w3 / c3;
      if (c3 === p3)
        g3 = 0;
      else {
        switch (c3) {
          case o:
            g3 = (i - t3) / w3 + (i < t3 ? 6 : 0);
            break;
          case i:
            g3 = (t3 - o) / w3 + 2;
            break;
          case t3:
            g3 = (o - i) / w3 + 4;
            break;
        }
        g3 /= 6;
      }
      return { h: g3, s: M, v: b3 };
    }
    function nPt(o, i, t3) {
      o = jw(o, 360) * 6, i = jw(i, 100), t3 = jw(t3, 100);
      var c3 = Math.floor(o), p3 = o - c3, g3 = t3 * (1 - i), b3 = t3 * (1 - p3 * i), w3 = t3 * (1 - (1 - p3) * i), M = c3 % 6, I = [t3, b3, g3, g3, w3, t3][M], k3 = [w3, t3, t3, b3, g3, g3][M], L = [g3, g3, w3, t3, t3, b3][M];
      return { r: I * 255, g: k3 * 255, b: L * 255 };
    }
    function rPt(o, i, t3, c3) {
      var p3 = [S1e(Math.round(o).toString(16)), S1e(Math.round(i).toString(16)), S1e(Math.round(t3).toString(16))];
      return c3 && p3[0].startsWith(p3[0].charAt(1)) && p3[1].startsWith(p3[1].charAt(1)) && p3[2].startsWith(p3[2].charAt(1)) ? p3[0].charAt(0) + p3[1].charAt(0) + p3[2].charAt(0) : p3.join("");
    }
    function QBe(o) {
      return F_(o) / 255;
    }
    function F_(o) {
      return parseInt(o, 16);
    }
    var eze = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
    function zW(o) {
      var i = { r: 0, g: 0, b: 0 }, t3 = 1, c3 = null, p3 = null, g3 = null, b3 = false, w3 = false;
      return typeof o == "string" && (o = oPt(o)), typeof o == "object" && (UI(o.r) && UI(o.g) && UI(o.b) ? (i = QOt(o.r, o.g, o.b), b3 = true, w3 = String(o.r).substr(-1) === "%" ? "prgb" : "rgb") : UI(o.h) && UI(o.s) && UI(o.v) ? (c3 = ire(o.s), p3 = ire(o.v), i = nPt(o.h, c3, p3), b3 = true, w3 = "hsv") : UI(o.h) && UI(o.s) && UI(o.l) && (c3 = ire(o.s), g3 = ire(o.l), i = ePt(o.h, c3, g3), b3 = true, w3 = "hsl"), Object.prototype.hasOwnProperty.call(o, "a") && (t3 = o.a)), t3 = JOt(t3), { ok: b3, format: o.format || w3, r: Math.min(255, Math.max(i.r, 0)), g: Math.min(255, Math.max(i.g, 0)), b: Math.min(255, Math.max(i.b, 0)), a: t3 };
    }
    var iPt = "[-\\+]?\\d+%?", aPt = "[-\\+]?\\d*\\.\\d+%?", Ck = "(?:" + aPt + ")|(?:" + iPt + ")", M1e = "[\\s|\\(]+(" + Ck + ")[,|\\s]+(" + Ck + ")[,|\\s]+(" + Ck + ")\\s*\\)?", T1e = "[\\s|\\(]+(" + Ck + ")[,|\\s]+(" + Ck + ")[,|\\s]+(" + Ck + ")[,|\\s]+(" + Ck + ")\\s*\\)?", J2 = { CSS_UNIT: new RegExp(Ck), rgb: new RegExp("rgb" + M1e), rgba: new RegExp("rgba" + T1e), hsl: new RegExp("hsl" + M1e), hsla: new RegExp("hsla" + T1e), hsv: new RegExp("hsv" + M1e), hsva: new RegExp("hsva" + T1e), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
    function oPt(o) {
      if (o = o.trim().toLowerCase(), o.length === 0)
        return false;
      var i = false;
      if (eze[o])
        o = eze[o], i = true;
      else if (o === "transparent")
        return { r: 0, g: 0, b: 0, a: 0, format: "name" };
      var t3 = J2.rgb.exec(o);
      return t3 ? { r: t3[1], g: t3[2], b: t3[3] } : (t3 = J2.rgba.exec(o), t3 ? { r: t3[1], g: t3[2], b: t3[3], a: t3[4] } : (t3 = J2.hsl.exec(o), t3 ? { h: t3[1], s: t3[2], l: t3[3] } : (t3 = J2.hsla.exec(o), t3 ? { h: t3[1], s: t3[2], l: t3[3], a: t3[4] } : (t3 = J2.hsv.exec(o), t3 ? { h: t3[1], s: t3[2], v: t3[3] } : (t3 = J2.hsva.exec(o), t3 ? { h: t3[1], s: t3[2], v: t3[3], a: t3[4] } : (t3 = J2.hex8.exec(o), t3 ? { r: F_(t3[1]), g: F_(t3[2]), b: F_(t3[3]), a: QBe(t3[4]), format: i ? "name" : "hex8" } : (t3 = J2.hex6.exec(o), t3 ? { r: F_(t3[1]), g: F_(t3[2]), b: F_(t3[3]), format: i ? "name" : "hex" } : (t3 = J2.hex4.exec(o), t3 ? { r: F_(t3[1] + t3[1]), g: F_(t3[2] + t3[2]), b: F_(t3[3] + t3[3]), a: QBe(t3[4] + t3[4]), format: i ? "name" : "hex8" } : (t3 = J2.hex3.exec(o), t3 ? { r: F_(t3[1] + t3[1]), g: F_(t3[2] + t3[2]), b: F_(t3[3] + t3[3]), format: i ? "name" : "hex" } : false)))))))));
    }
    function UI(o) {
      return Boolean(J2.CSS_UNIT.exec(String(o)));
    }
    var are = 2, tze = 0.16, sPt = 0.05, lPt = 0.05, uPt = 0.15, nze = 5, rze = 4, cPt = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
    function ize(o) {
      var i = o.r, t3 = o.g, c3 = o.b, p3 = tPt(i, t3, c3);
      return { h: p3.h * 360, s: p3.s, v: p3.v };
    }
    function ore(o) {
      var i = o.r, t3 = o.g, c3 = o.b;
      return "#".concat(rPt(i, t3, c3, false));
    }
    function fPt(o, i, t3) {
      var c3 = t3 / 100, p3 = { r: (i.r - o.r) * c3 + o.r, g: (i.g - o.g) * c3 + o.g, b: (i.b - o.b) * c3 + o.b };
      return p3;
    }
    function aze(o, i, t3) {
      var c3;
      return Math.round(o.h) >= 60 && Math.round(o.h) <= 240 ? c3 = t3 ? Math.round(o.h) - are * i : Math.round(o.h) + are * i : c3 = t3 ? Math.round(o.h) + are * i : Math.round(o.h) - are * i, c3 < 0 ? c3 += 360 : c3 >= 360 && (c3 -= 360), c3;
    }
    function oze(o, i, t3) {
      if (o.h === 0 && o.s === 0)
        return o.s;
      var c3;
      return t3 ? c3 = o.s - tze * i : i === rze ? c3 = o.s + tze : c3 = o.s + sPt * i, c3 > 1 && (c3 = 1), t3 && i === nze && c3 > 0.1 && (c3 = 0.1), c3 < 0.06 && (c3 = 0.06), Number(c3.toFixed(2));
    }
    function sze(o, i, t3) {
      var c3;
      return t3 ? c3 = o.v + lPt * i : c3 = o.v - uPt * i, c3 > 1 && (c3 = 1), Number(c3.toFixed(2));
    }
    function A1e(o) {
      for (var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t3 = [], c3 = zW(o), p3 = nze; p3 > 0; p3 -= 1) {
        var g3 = ize(c3), b3 = ore(zW({ h: aze(g3, p3, true), s: oze(g3, p3, true), v: sze(g3, p3, true) }));
        t3.push(b3);
      }
      t3.push(ore(c3));
      for (var w3 = 1; w3 <= rze; w3 += 1) {
        var M = ize(c3), I = ore(zW({ h: aze(M, w3), s: oze(M, w3), v: sze(M, w3) }));
        t3.push(I);
      }
      return i.theme === "dark" ? cPt.map(function(k3) {
        var L = k3.index, F = k3.opacity, B = ore(fPt(zW(i.backgroundColor || "#141414"), zW(t3[L]), F * 100));
        return B;
      }) : t3;
    }
    var I1e = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, Im = {}, E1e = {};
    Object.keys(I1e).forEach(function(o) {
      Im[o] = A1e(I1e[o]), Im[o].primary = Im[o][5], E1e[o] = A1e(I1e[o], { theme: "dark", backgroundColor: "#141414" }), E1e[o].primary = E1e[o][5];
    }), Im.red, Im.volcano, Im.gold, Im.orange, Im.yellow, Im.lime, Im.green, Im.cyan, Im.blue, Im.geekblue, Im.purple, Im.magenta, Im.grey;
    var lze = {};
    function hPt(o, i) {
    }
    function pPt(o, i, t3) {
      !i && !lze[t3] && (o(false, t3), lze[t3] = true);
    }
    function aT(o, i) {
      pPt(hPt, o, i);
    }
    function uze() {
      return !!(typeof window != "undefined" && window.document && window.document.createElement);
    }
    var dPt = "rc-util-key";
    function cze() {
      var o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, i = o.mark;
      return i ? i.startsWith("data-") ? i : "data-".concat(i) : dPt;
    }
    function D1e(o) {
      if (o.attachTo)
        return o.attachTo;
      var i = document.querySelector("head");
      return i || document.body;
    }
    function fze(o) {
      var i, t3 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
      if (!uze())
        return null;
      var c3 = document.createElement("style");
      if (!((i = t3.csp) === null || i === void 0) && i.nonce) {
        var p3;
        c3.nonce = (p3 = t3.csp) === null || p3 === void 0 ? void 0 : p3.nonce;
      }
      c3.innerHTML = o;
      var g3 = D1e(t3), b3 = g3.firstChild;
      return t3.prepend && g3.prepend ? g3.prepend(c3) : t3.prepend && b3 ? g3.insertBefore(c3, b3) : g3.appendChild(c3), c3;
    }
    var k1e = /* @__PURE__ */ new Map();
    function vPt(o) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t3 = D1e(i);
      return Array.from(k1e.get(t3).children).find(function(c3) {
        return c3.tagName === "STYLE" && c3.getAttribute(cze(i)) === o;
      });
    }
    function hze(o, i) {
      var t3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, c3 = D1e(t3);
      if (!k1e.has(c3)) {
        var p3 = fze("", t3), g3 = p3.parentNode;
        k1e.set(c3, g3), g3.removeChild(p3);
      }
      var b3 = vPt(i, t3);
      if (b3) {
        var w3, M;
        if (((w3 = t3.csp) === null || w3 === void 0 ? void 0 : w3.nonce) && b3.nonce !== ((M = t3.csp) === null || M === void 0 ? void 0 : M.nonce)) {
          var I;
          b3.nonce = (I = t3.csp) === null || I === void 0 ? void 0 : I.nonce;
        }
        return b3.innerHTML !== o && (b3.innerHTML = o), b3;
      }
      var k3 = fze(o, t3);
      return k3.setAttribute(cze(t3), i), k3;
    }
    function gPt(o, i) {
      aT(o, "[@ant-design/icons] ".concat(i));
    }
    function pze(o) {
      return Am(o) === "object" && typeof o.name == "string" && typeof o.theme == "string" && (Am(o.icon) === "object" || typeof o.icon == "function");
    }
    function dze() {
      var o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
      return Object.keys(o).reduce(function(i, t3) {
        var c3 = o[t3];
        switch (t3) {
          case "class":
            i.className = c3, delete i.class;
            break;
          default:
            i[t3] = c3;
        }
        return i;
      }, {});
    }
    function O1e(o, i, t3) {
      return t3 ? P.default.createElement(o.tag, tu(tu({ key: i }, dze(o.attrs)), t3), (o.children || []).map(function(c3, p3) {
        return O1e(c3, "".concat(i, "-").concat(o.tag, "-").concat(p3));
      })) : P.default.createElement(o.tag, tu({ key: i }, dze(o.attrs)), (o.children || []).map(function(c3, p3) {
        return O1e(c3, "".concat(i, "-").concat(o.tag, "-").concat(p3));
      }));
    }
    function vze(o) {
      return A1e(o)[0];
    }
    function gze(o) {
      return o ? Array.isArray(o) ? o : [o] : [];
    }
    var yPt = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, mPt = function() {
      var o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : yPt, i = C.useContext(XBe), t3 = i.csp;
      C.useEffect(function() {
        hze(o, "@ant-design-icons", { prepend: true, csp: t3 });
      }, []);
    }, bPt = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], jW = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
    function _Pt(o) {
      var i = o.primaryColor, t3 = o.secondaryColor;
      jW.primaryColor = i, jW.secondaryColor = t3 || vze(i), jW.calculated = !!t3;
    }
    function xPt() {
      return tu({}, jW);
    }
    var sre = function(o) {
      var i = o.icon, t3 = o.className, c3 = o.onClick, p3 = o.style, g3 = o.primaryColor, b3 = o.secondaryColor, w3 = e9(o, bPt), M = jW;
      if (g3 && (M = { primaryColor: g3, secondaryColor: b3 || vze(g3) }), mPt(), gPt(pze(i), "icon should be icon definiton, but got ".concat(i)), !pze(i))
        return null;
      var I = i;
      return I && typeof I.icon == "function" && (I = tu(tu({}, I), {}, { icon: I.icon(M.primaryColor, M.secondaryColor) })), O1e(I.icon, "svg-".concat(I.name), tu({ className: t3, onClick: c3, style: p3, "data-icon": I.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, w3));
    };
    sre.displayName = "IconReact", sre.getTwoToneColors = xPt, sre.setTwoToneColors = _Pt;
    var P1e = sre;
    function yze(o) {
      var i = gze(o), t3 = zw(i, 2), c3 = t3[0], p3 = t3[1];
      return P1e.setTwoToneColors({ primaryColor: c3, secondaryColor: p3 });
    }
    function wPt() {
      var o = P1e.getTwoToneColors();
      return o.calculated ? [o.primaryColor, o.secondaryColor] : o.primaryColor;
    }
    var SPt = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
    yze("#1890ff");
    var lre = N.forwardRef(function(o, i) {
      var t3, c3 = o.className, p3 = o.icon, g3 = o.spin, b3 = o.rotate, w3 = o.tabIndex, M = o.onClick, I = o.twoToneColor, k3 = e9(o, SPt), L = N.useContext(XBe), F = L.prefixCls, B = F === void 0 ? "anticon" : F, G = t9(B, (t3 = {}, Qf(t3, "".concat(B, "-").concat(p3.name), !!p3.name), Qf(t3, "".concat(B, "-spin"), !!g3 || p3.name === "loading"), t3), c3), J = w3;
      J === void 0 && M && (J = -1);
      var Q = b3 ? { msTransform: "rotate(".concat(b3, "deg)"), transform: "rotate(".concat(b3, "deg)") } : void 0, se = gze(I), he = zw(se, 2), be = he[0], de = he[1];
      return N.createElement("span", tu(tu({ role: "img", "aria-label": p3.name }, k3), {}, { ref: i, tabIndex: J, onClick: M, className: G }), N.createElement(P1e, { icon: p3, primaryColor: be, secondaryColor: de, style: Q }));
    });
    lre.displayName = "AntdIcon", lre.getTwoToneColor = wPt, lre.setTwoToneColor = yze;
    var CPt = lre, MPt = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, TPt = MPt, mze = function(o, i) {
      return N.createElement(CPt, tu(tu({}, o), {}, { ref: i, icon: TPt }));
    };
    mze.displayName = "LoadingOutlined";
    var APt = N.forwardRef(mze);
    function Uv() {
      return Uv = Object.assign || function(o) {
        for (var i = 1; i < arguments.length; i++) {
          var t3 = arguments[i];
          for (var c3 in t3)
            Object.prototype.hasOwnProperty.call(t3, c3) && (o[c3] = t3[c3]);
        }
        return o;
      }, Uv.apply(this, arguments);
    }
    function GW(o, i) {
      if (!(o instanceof i))
        throw new TypeError("Cannot call a class as a function");
    }
    function bze(o, i) {
      for (var t3 = 0; t3 < i.length; t3++) {
        var c3 = i[t3];
        c3.enumerable = c3.enumerable || false, c3.configurable = true, "value" in c3 && (c3.writable = true), Object.defineProperty(o, c3.key, c3);
      }
    }
    function HW(o, i, t3) {
      return i && bze(o.prototype, i), t3 && bze(o, t3), Object.defineProperty(o, "prototype", { writable: false }), o;
    }
    function L1e(o, i) {
      return L1e = Object.setPrototypeOf || function(t3, c3) {
        return t3.__proto__ = c3, t3;
      }, L1e(o, i);
    }
    function R1e(o, i) {
      if (typeof i != "function" && i !== null)
        throw new TypeError("Super expression must either be null or a function");
      o.prototype = Object.create(i && i.prototype, { constructor: { value: o, writable: true, configurable: true } }), Object.defineProperty(o, "prototype", { writable: false }), i && L1e(o, i);
    }
    function ure(o) {
      return ure = Object.setPrototypeOf ? Object.getPrototypeOf : function(i) {
        return i.__proto__ || Object.getPrototypeOf(i);
      }, ure(o);
    }
    function IPt() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function N1e(o) {
      if (o === void 0)
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      return o;
    }
    function EPt(o, i) {
      if (i && (Am(i) === "object" || typeof i == "function"))
        return i;
      if (i !== void 0)
        throw new TypeError("Derived constructors may only return object or undefined");
      return N1e(o);
    }
    function F1e(o) {
      var i = IPt();
      return function() {
        var t3 = ure(o), c3;
        if (i) {
          var p3 = ure(this).constructor;
          c3 = Reflect.construct(t3, arguments, p3);
        } else
          c3 = t3.apply(this, arguments);
        return EPt(this, c3);
      };
    }
    var V1e = { exports: {} }, bh = {};
    /** @license React v16.13.1
    * react-is.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var y0 = typeof Symbol == "function" && Symbol.for, B1e = y0 ? Symbol.for("react.element") : 60103, z1e = y0 ? Symbol.for("react.portal") : 60106, cre = y0 ? Symbol.for("react.fragment") : 60107, fre = y0 ? Symbol.for("react.strict_mode") : 60108, hre = y0 ? Symbol.for("react.profiler") : 60114, pre = y0 ? Symbol.for("react.provider") : 60109, dre = y0 ? Symbol.for("react.context") : 60110, j1e = y0 ? Symbol.for("react.async_mode") : 60111, vre = y0 ? Symbol.for("react.concurrent_mode") : 60111, gre = y0 ? Symbol.for("react.forward_ref") : 60112, yre = y0 ? Symbol.for("react.suspense") : 60113, DPt = y0 ? Symbol.for("react.suspense_list") : 60120, mre = y0 ? Symbol.for("react.memo") : 60115, bre = y0 ? Symbol.for("react.lazy") : 60116, kPt = y0 ? Symbol.for("react.block") : 60121, OPt = y0 ? Symbol.for("react.fundamental") : 60117, PPt = y0 ? Symbol.for("react.responder") : 60118, LPt = y0 ? Symbol.for("react.scope") : 60119;
    function V_(o) {
      if (typeof o == "object" && o !== null) {
        var i = o.$$typeof;
        switch (i) {
          case B1e:
            switch (o = o.type, o) {
              case j1e:
              case vre:
              case cre:
              case hre:
              case fre:
              case yre:
                return o;
              default:
                switch (o = o && o.$$typeof, o) {
                  case dre:
                  case gre:
                  case bre:
                  case mre:
                  case pre:
                    return o;
                  default:
                    return i;
                }
            }
          case z1e:
            return i;
        }
      }
    }
    function _ze(o) {
      return V_(o) === vre;
    }
    bh.AsyncMode = j1e, bh.ConcurrentMode = vre, bh.ContextConsumer = dre, bh.ContextProvider = pre, bh.Element = B1e, bh.ForwardRef = gre, bh.Fragment = cre, bh.Lazy = bre, bh.Memo = mre, bh.Portal = z1e, bh.Profiler = hre, bh.StrictMode = fre, bh.Suspense = yre, bh.isAsyncMode = function(o) {
      return _ze(o) || V_(o) === j1e;
    }, bh.isConcurrentMode = _ze, bh.isContextConsumer = function(o) {
      return V_(o) === dre;
    }, bh.isContextProvider = function(o) {
      return V_(o) === pre;
    }, bh.isElement = function(o) {
      return typeof o == "object" && o !== null && o.$$typeof === B1e;
    }, bh.isForwardRef = function(o) {
      return V_(o) === gre;
    }, bh.isFragment = function(o) {
      return V_(o) === cre;
    }, bh.isLazy = function(o) {
      return V_(o) === bre;
    }, bh.isMemo = function(o) {
      return V_(o) === mre;
    }, bh.isPortal = function(o) {
      return V_(o) === z1e;
    }, bh.isProfiler = function(o) {
      return V_(o) === hre;
    }, bh.isStrictMode = function(o) {
      return V_(o) === fre;
    }, bh.isSuspense = function(o) {
      return V_(o) === yre;
    }, bh.isValidElementType = function(o) {
      return typeof o == "string" || typeof o == "function" || o === cre || o === vre || o === hre || o === fre || o === yre || o === DPt || typeof o == "object" && o !== null && (o.$$typeof === bre || o.$$typeof === mre || o.$$typeof === pre || o.$$typeof === dre || o.$$typeof === gre || o.$$typeof === OPt || o.$$typeof === PPt || o.$$typeof === LPt || o.$$typeof === kPt);
    }, bh.typeOf = V_, V1e.exports = bh;
    function G1e(o) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, t3 = [];
      return P.default.Children.forEach(o, function(c3) {
        c3 == null && !i.keepEmpty || (Array.isArray(c3) ? t3 = t3.concat(G1e(c3)) : V1e.exports.isFragment(c3) && c3.props ? t3 = t3.concat(G1e(c3.props.children, i)) : t3.push(c3));
      }), t3;
    }
    function RPt(o, i) {
      typeof o == "function" ? o(i) : Am(o) === "object" && o && "current" in o && (o.current = i);
    }
    function NPt() {
      for (var o = arguments.length, i = new Array(o), t3 = 0; t3 < o; t3++)
        i[t3] = arguments[t3];
      var c3 = i.filter(function(p3) {
        return p3;
      });
      return c3.length <= 1 ? c3[0] : function(p3) {
        i.forEach(function(g3) {
          RPt(g3, p3);
        });
      };
    }
    function FPt(o) {
      var i, t3, c3 = V1e.exports.isMemo(o) ? o.type.type : o.type;
      return !(typeof c3 == "function" && !(!((i = c3.prototype) === null || i === void 0) && i.render) || typeof o == "function" && !(!((t3 = o.prototype) === null || t3 === void 0) && t3.render));
    }
    function VPt() {
      try {
        if (!Object.assign)
          return false;
        var o = new String("abc");
        if (o[5] = "de", Object.getOwnPropertyNames(o)[0] === "5")
          return false;
        for (var i = {}, t3 = 0; t3 < 10; t3++)
          i["_" + String.fromCharCode(t3)] = t3;
        var c3 = Object.getOwnPropertyNames(i).map(function(g3) {
          return i[g3];
        });
        if (c3.join("") !== "0123456789")
          return false;
        var p3 = {};
        return "abcdefghijklmnopqrst".split("").forEach(function(g3) {
          p3[g3] = g3;
        }), Object.keys(Object.assign({}, p3)).join("") === "abcdefghijklmnopqrst";
      } catch {
        return false;
      }
    }
    VPt();
    function BPt(o) {
      if (Array.isArray(o))
        return x1e(o);
    }
    function xze(o) {
      if (typeof Symbol != "undefined" && o[Symbol.iterator] != null || o["@@iterator"] != null)
        return Array.from(o);
    }
    function zPt() {
      throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    function Qc(o) {
      return BPt(o) || xze(o) || w1e(o) || zPt();
    }
    var n9 = "RC_FORM_INTERNAL_HOOKS", jp = function() {
      aT(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
    }, WW = N.createContext({ getFieldValue: jp, getFieldsValue: jp, getFieldError: jp, getFieldWarning: jp, getFieldsError: jp, isFieldsTouched: jp, isFieldTouched: jp, isFieldValidating: jp, isFieldsValidating: jp, resetFields: jp, setFields: jp, setFieldsValue: jp, validateFields: jp, submit: jp, getInternalHooks: function() {
      return jp(), { dispatch: jp, initEntityValue: jp, registerField: jp, useSubscribe: jp, setInitialValues: jp, setCallbacks: jp, getFields: jp, setValidateMessages: jp, setPreserve: jp, getInitialValue: jp };
    } });
    function H1e(o) {
      return o == null ? [] : Array.isArray(o) ? o : [o];
    }
    var wze = { exports: {} };
    (function(o) {
      var i = function(t3) {
        var c3 = Object.prototype, p3 = c3.hasOwnProperty, g3, b3 = typeof Symbol == "function" ? Symbol : {}, w3 = b3.iterator || "@@iterator", M = b3.asyncIterator || "@@asyncIterator", I = b3.toStringTag || "@@toStringTag";
        function k3(ln, vn, kn) {
          return Object.defineProperty(ln, vn, { value: kn, enumerable: true, configurable: true, writable: true }), ln[vn];
        }
        try {
          k3({}, "");
        } catch {
          k3 = function(ln, vn, kn) {
            return ln[vn] = kn;
          };
        }
        function L(ln, vn, kn, cr) {
          var gr = vn && vn.prototype instanceof he ? vn : he, ha = Object.create(gr.prototype), Ka = new Jt(cr || []);
          return ha._invoke = lt2(ln, kn, Ka), ha;
        }
        t3.wrap = L;
        function F(ln, vn, kn) {
          try {
            return { type: "normal", arg: ln.call(vn, kn) };
          } catch (cr) {
            return { type: "throw", arg: cr };
          }
        }
        var B = "suspendedStart", G = "suspendedYield", J = "executing", Q = "completed", se = {};
        function he() {
        }
        function be() {
        }
        function de() {
        }
        var Fe = {};
        k3(Fe, w3, function() {
          return this;
        });
        var Pe = Object.getPrototypeOf, ze = Pe && Pe(Pe(Rt([])));
        ze && ze !== c3 && p3.call(ze, w3) && (Fe = ze);
        var $e = de.prototype = he.prototype = Object.create(Fe);
        be.prototype = de, k3($e, "constructor", de), k3(de, "constructor", be), be.displayName = k3(de, I, "GeneratorFunction");
        function Ke(ln) {
          ["next", "throw", "return"].forEach(function(vn) {
            k3(ln, vn, function(kn) {
              return this._invoke(vn, kn);
            });
          });
        }
        t3.isGeneratorFunction = function(ln) {
          var vn = typeof ln == "function" && ln.constructor;
          return vn ? vn === be || (vn.displayName || vn.name) === "GeneratorFunction" : false;
        }, t3.mark = function(ln) {
          return Object.setPrototypeOf ? Object.setPrototypeOf(ln, de) : (ln.__proto__ = de, k3(ln, I, "GeneratorFunction")), ln.prototype = Object.create($e), ln;
        }, t3.awrap = function(ln) {
          return { __await: ln };
        };
        function nt(ln, vn) {
          function kn(ha, Ka, Do, _o) {
            var xo = F(ln[ha], ln, Ka);
            if (xo.type === "throw")
              _o(xo.arg);
            else {
              var Ra = xo.arg, ho = Ra.value;
              return ho && typeof ho == "object" && p3.call(ho, "__await") ? vn.resolve(ho.__await).then(function(Mo) {
                kn("next", Mo, Do, _o);
              }, function(Mo) {
                kn("throw", Mo, Do, _o);
              }) : vn.resolve(ho).then(function(Mo) {
                Ra.value = Mo, Do(Ra);
              }, function(Mo) {
                return kn("throw", Mo, Do, _o);
              });
            }
          }
          var cr;
          function gr(ha, Ka) {
            function Do() {
              return new vn(function(_o, xo) {
                kn(ha, Ka, _o, xo);
              });
            }
            return cr = cr ? cr.then(Do, Do) : Do();
          }
          this._invoke = gr;
        }
        Ke(nt.prototype), k3(nt.prototype, M, function() {
          return this;
        }), t3.AsyncIterator = nt, t3.async = function(ln, vn, kn, cr, gr) {
          gr === void 0 && (gr = Promise);
          var ha = new nt(L(ln, vn, kn, cr), gr);
          return t3.isGeneratorFunction(vn) ? ha : ha.next().then(function(Ka) {
            return Ka.done ? Ka.value : ha.next();
          });
        };
        function lt2(ln, vn, kn) {
          var cr = B;
          return function(gr, ha) {
            if (cr === J)
              throw new Error("Generator is already running");
            if (cr === Q) {
              if (gr === "throw")
                throw ha;
              return Jn();
            }
            for (kn.method = gr, kn.arg = ha; ; ) {
              var Ka = kn.delegate;
              if (Ka) {
                var Do = bt(Ka, kn);
                if (Do) {
                  if (Do === se)
                    continue;
                  return Do;
                }
              }
              if (kn.method === "next")
                kn.sent = kn._sent = kn.arg;
              else if (kn.method === "throw") {
                if (cr === B)
                  throw cr = Q, kn.arg;
                kn.dispatchException(kn.arg);
              } else
                kn.method === "return" && kn.abrupt("return", kn.arg);
              cr = J;
              var _o = F(ln, vn, kn);
              if (_o.type === "normal") {
                if (cr = kn.done ? Q : G, _o.arg === se)
                  continue;
                return { value: _o.arg, done: kn.done };
              } else
                _o.type === "throw" && (cr = Q, kn.method = "throw", kn.arg = _o.arg);
            }
          };
        }
        function bt(ln, vn) {
          var kn = ln.iterator[vn.method];
          if (kn === g3) {
            if (vn.delegate = null, vn.method === "throw") {
              if (ln.iterator.return && (vn.method = "return", vn.arg = g3, bt(ln, vn), vn.method === "throw"))
                return se;
              vn.method = "throw", vn.arg = new TypeError("The iterator does not provide a 'throw' method");
            }
            return se;
          }
          var cr = F(kn, ln.iterator, vn.arg);
          if (cr.type === "throw")
            return vn.method = "throw", vn.arg = cr.arg, vn.delegate = null, se;
          var gr = cr.arg;
          if (!gr)
            return vn.method = "throw", vn.arg = new TypeError("iterator result is not an object"), vn.delegate = null, se;
          if (gr.done)
            vn[ln.resultName] = gr.value, vn.next = ln.nextLoc, vn.method !== "return" && (vn.method = "next", vn.arg = g3);
          else
            return gr;
          return vn.delegate = null, se;
        }
        Ke($e), k3($e, I, "Generator"), k3($e, w3, function() {
          return this;
        }), k3($e, "toString", function() {
          return "[object Generator]";
        });
        function vt(ln) {
          var vn = { tryLoc: ln[0] };
          1 in ln && (vn.catchLoc = ln[1]), 2 in ln && (vn.finallyLoc = ln[2], vn.afterLoc = ln[3]), this.tryEntries.push(vn);
        }
        function jt(ln) {
          var vn = ln.completion || {};
          vn.type = "normal", delete vn.arg, ln.completion = vn;
        }
        function Jt(ln) {
          this.tryEntries = [{ tryLoc: "root" }], ln.forEach(vt, this), this.reset(true);
        }
        t3.keys = function(ln) {
          var vn = [];
          for (var kn in ln)
            vn.push(kn);
          return vn.reverse(), function cr() {
            for (; vn.length; ) {
              var gr = vn.pop();
              if (gr in ln)
                return cr.value = gr, cr.done = false, cr;
            }
            return cr.done = true, cr;
          };
        };
        function Rt(ln) {
          if (ln) {
            var vn = ln[w3];
            if (vn)
              return vn.call(ln);
            if (typeof ln.next == "function")
              return ln;
            if (!isNaN(ln.length)) {
              var kn = -1, cr = function gr() {
                for (; ++kn < ln.length; )
                  if (p3.call(ln, kn))
                    return gr.value = ln[kn], gr.done = false, gr;
                return gr.value = g3, gr.done = true, gr;
              };
              return cr.next = cr;
            }
          }
          return { next: Jn };
        }
        t3.values = Rt;
        function Jn() {
          return { value: g3, done: true };
        }
        return Jt.prototype = { constructor: Jt, reset: function(ln) {
          if (this.prev = 0, this.next = 0, this.sent = this._sent = g3, this.done = false, this.delegate = null, this.method = "next", this.arg = g3, this.tryEntries.forEach(jt), !ln)
            for (var vn in this)
              vn.charAt(0) === "t" && p3.call(this, vn) && !isNaN(+vn.slice(1)) && (this[vn] = g3);
        }, stop: function() {
          this.done = true;
          var ln = this.tryEntries[0], vn = ln.completion;
          if (vn.type === "throw")
            throw vn.arg;
          return this.rval;
        }, dispatchException: function(ln) {
          if (this.done)
            throw ln;
          var vn = this;
          function kn(_o, xo) {
            return ha.type = "throw", ha.arg = ln, vn.next = _o, xo && (vn.method = "next", vn.arg = g3), !!xo;
          }
          for (var cr = this.tryEntries.length - 1; cr >= 0; --cr) {
            var gr = this.tryEntries[cr], ha = gr.completion;
            if (gr.tryLoc === "root")
              return kn("end");
            if (gr.tryLoc <= this.prev) {
              var Ka = p3.call(gr, "catchLoc"), Do = p3.call(gr, "finallyLoc");
              if (Ka && Do) {
                if (this.prev < gr.catchLoc)
                  return kn(gr.catchLoc, true);
                if (this.prev < gr.finallyLoc)
                  return kn(gr.finallyLoc);
              } else if (Ka) {
                if (this.prev < gr.catchLoc)
                  return kn(gr.catchLoc, true);
              } else if (Do) {
                if (this.prev < gr.finallyLoc)
                  return kn(gr.finallyLoc);
              } else
                throw new Error("try statement without catch or finally");
            }
          }
        }, abrupt: function(ln, vn) {
          for (var kn = this.tryEntries.length - 1; kn >= 0; --kn) {
            var cr = this.tryEntries[kn];
            if (cr.tryLoc <= this.prev && p3.call(cr, "finallyLoc") && this.prev < cr.finallyLoc) {
              var gr = cr;
              break;
            }
          }
          gr && (ln === "break" || ln === "continue") && gr.tryLoc <= vn && vn <= gr.finallyLoc && (gr = null);
          var ha = gr ? gr.completion : {};
          return ha.type = ln, ha.arg = vn, gr ? (this.method = "next", this.next = gr.finallyLoc, se) : this.complete(ha);
        }, complete: function(ln, vn) {
          if (ln.type === "throw")
            throw ln.arg;
          return ln.type === "break" || ln.type === "continue" ? this.next = ln.arg : ln.type === "return" ? (this.rval = this.arg = ln.arg, this.method = "return", this.next = "end") : ln.type === "normal" && vn && (this.next = vn), se;
        }, finish: function(ln) {
          for (var vn = this.tryEntries.length - 1; vn >= 0; --vn) {
            var kn = this.tryEntries[vn];
            if (kn.finallyLoc === ln)
              return this.complete(kn.completion, kn.afterLoc), jt(kn), se;
          }
        }, catch: function(ln) {
          for (var vn = this.tryEntries.length - 1; vn >= 0; --vn) {
            var kn = this.tryEntries[vn];
            if (kn.tryLoc === ln) {
              var cr = kn.completion;
              if (cr.type === "throw") {
                var gr = cr.arg;
                jt(kn);
              }
              return gr;
            }
          }
          throw new Error("illegal catch attempt");
        }, delegateYield: function(ln, vn, kn) {
          return this.delegate = { iterator: Rt(ln), resultName: vn, nextLoc: kn }, this.method === "next" && (this.arg = g3), se;
        } }, t3;
      }(o.exports);
      try {
        regeneratorRuntime = i;
      } catch {
        typeof globalThis == "object" ? globalThis.regeneratorRuntime = i : Function("r", "regeneratorRuntime = r")(i);
      }
    })(wze);
    var Mk = wze.exports;
    function Sze(o, i, t3, c3, p3, g3, b3) {
      try {
        var w3 = o[g3](b3), M = w3.value;
      } catch (I) {
        t3(I);
        return;
      }
      w3.done ? i(M) : Promise.resolve(M).then(c3, p3);
    }
    function _re(o) {
      return function() {
        var i = this, t3 = arguments;
        return new Promise(function(c3, p3) {
          var g3 = o.apply(i, t3);
          function b3(M) {
            Sze(g3, c3, p3, b3, w3, "next", M);
          }
          function w3(M) {
            Sze(g3, c3, p3, b3, w3, "throw", M);
          }
          b3(void 0);
        });
      };
    }
    function OL() {
      return OL = Object.assign || function(o) {
        for (var i = 1; i < arguments.length; i++) {
          var t3 = arguments[i];
          for (var c3 in t3)
            Object.prototype.hasOwnProperty.call(t3, c3) && (o[c3] = t3[c3]);
        }
        return o;
      }, OL.apply(this, arguments);
    }
    function jPt(o, i) {
      o.prototype = Object.create(i.prototype), o.prototype.constructor = o, UW(o, i);
    }
    function W1e(o) {
      return W1e = Object.setPrototypeOf ? Object.getPrototypeOf : function(i) {
        return i.__proto__ || Object.getPrototypeOf(i);
      }, W1e(o);
    }
    function UW(o, i) {
      return UW = Object.setPrototypeOf || function(t3, c3) {
        return t3.__proto__ = c3, t3;
      }, UW(o, i);
    }
    function GPt() {
      if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
        return false;
      if (typeof Proxy == "function")
        return true;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), true;
      } catch {
        return false;
      }
    }
    function xre(o, i, t3) {
      return GPt() ? xre = Reflect.construct : xre = function(c3, p3, g3) {
        var b3 = [null];
        b3.push.apply(b3, p3);
        var w3 = Function.bind.apply(c3, b3), M = new w3();
        return g3 && UW(M, g3.prototype), M;
      }, xre.apply(null, arguments);
    }
    function HPt(o) {
      return Function.toString.call(o).indexOf("[native code]") !== -1;
    }
    function U1e(o) {
      var i = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
      return U1e = function(t3) {
        if (t3 === null || !HPt(t3))
          return t3;
        if (typeof t3 != "function")
          throw new TypeError("Super expression must either be null or a function");
        if (typeof i != "undefined") {
          if (i.has(t3))
            return i.get(t3);
          i.set(t3, c3);
        }
        function c3() {
          return xre(t3, arguments, W1e(this).constructor);
        }
        return c3.prototype = Object.create(t3.prototype, { constructor: { value: c3, enumerable: false, writable: true, configurable: true } }), UW(c3, t3);
      }, U1e(o);
    }
    var WPt = /%[sdj%]/g, UPt = function() {
    };
    typeof process != "undefined" && process.env;
    function q1e(o) {
      if (!o || !o.length)
        return null;
      var i = {};
      return o.forEach(function(t3) {
        var c3 = t3.field;
        i[c3] = i[c3] || [], i[c3].push(t3);
      }), i;
    }
    function B_(o) {
      for (var i = arguments.length, t3 = new Array(i > 1 ? i - 1 : 0), c3 = 1; c3 < i; c3++)
        t3[c3 - 1] = arguments[c3];
      var p3 = 0, g3 = t3.length;
      if (typeof o == "function")
        return o.apply(null, t3);
      if (typeof o == "string") {
        var b3 = o.replace(WPt, function(w3) {
          if (w3 === "%%")
            return "%";
          if (p3 >= g3)
            return w3;
          switch (w3) {
            case "%s":
              return String(t3[p3++]);
            case "%d":
              return Number(t3[p3++]);
            case "%j":
              try {
                return JSON.stringify(t3[p3++]);
              } catch {
                return "[Circular]";
              }
              break;
            default:
              return w3;
          }
        });
        return b3;
      }
      return o;
    }
    function qPt(o) {
      return o === "string" || o === "url" || o === "hex" || o === "email" || o === "date" || o === "pattern";
    }
    function Tg(o, i) {
      return !!(o == null || i === "array" && Array.isArray(o) && !o.length || qPt(i) && typeof o == "string" && !o);
    }
    function $Pt(o, i, t3) {
      var c3 = [], p3 = 0, g3 = o.length;
      function b3(w3) {
        c3.push.apply(c3, w3 || []), p3++, p3 === g3 && t3(c3);
      }
      o.forEach(function(w3) {
        i(w3, b3);
      });
    }
    function Cze(o, i, t3) {
      var c3 = 0, p3 = o.length;
      function g3(b3) {
        if (b3 && b3.length) {
          t3(b3);
          return;
        }
        var w3 = c3;
        c3 = c3 + 1, w3 < p3 ? i(o[w3], g3) : t3([]);
      }
      g3([]);
    }
    function XPt(o) {
      var i = [];
      return Object.keys(o).forEach(function(t3) {
        i.push.apply(i, o[t3] || []);
      }), i;
    }
    var Mze = function(o) {
      jPt(i, o);
      function i(t3, c3) {
        var p3;
        return p3 = o.call(this, "Async Validation Error") || this, p3.errors = t3, p3.fields = c3, p3;
      }
      return i;
    }(U1e(Error));
    function YPt(o, i, t3, c3, p3) {
      if (i.first) {
        var g3 = new Promise(function(F, B) {
          var G = function(Q) {
            return c3(Q), Q.length ? B(new Mze(Q, q1e(Q))) : F(p3);
          }, J = XPt(o);
          Cze(J, t3, G);
        });
        return g3.catch(function(F) {
          return F;
        }), g3;
      }
      var b3 = i.firstFields === true ? Object.keys(o) : i.firstFields || [], w3 = Object.keys(o), M = w3.length, I = 0, k3 = [], L = new Promise(function(F, B) {
        var G = function(J) {
          if (k3.push.apply(k3, J), I++, I === M)
            return c3(k3), k3.length ? B(new Mze(k3, q1e(k3))) : F(p3);
        };
        w3.length || (c3(k3), F(p3)), w3.forEach(function(J) {
          var Q = o[J];
          b3.indexOf(J) !== -1 ? Cze(Q, t3, G) : $Pt(Q, t3, G);
        });
      });
      return L.catch(function(F) {
        return F;
      }), L;
    }
    function KPt(o) {
      return !!(o && o.message !== void 0);
    }
    function ZPt(o, i) {
      for (var t3 = o, c3 = 0; c3 < i.length; c3++) {
        if (t3 == null)
          return t3;
        t3 = t3[i[c3]];
      }
      return t3;
    }
    function Tze(o, i) {
      return function(t3) {
        var c3;
        return o.fullFields ? c3 = ZPt(i, o.fullFields) : c3 = i[t3.field || o.fullField], KPt(t3) ? (t3.field = t3.field || o.fullField, t3.fieldValue = c3, t3) : { message: typeof t3 == "function" ? t3() : t3, fieldValue: c3, field: t3.field || o.fullField };
      };
    }
    function Aze(o, i) {
      if (i) {
        for (var t3 in i)
          if (i.hasOwnProperty(t3)) {
            var c3 = i[t3];
            typeof c3 == "object" && typeof o[t3] == "object" ? o[t3] = OL({}, o[t3], c3) : o[t3] = c3;
          }
      }
      return o;
    }
    var Ize = function(o, i, t3, c3, p3, g3) {
      o.required && (!t3.hasOwnProperty(o.field) || Tg(i, g3 || o.type)) && c3.push(B_(p3.messages.required, o.fullField));
    }, JPt = function(o, i, t3, c3, p3) {
      (/^\s+$/.test(i) || i === "") && c3.push(B_(p3.messages.whitespace, o.fullField));
    }, $1e = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, qW = { integer: function(o) {
      return qW.number(o) && parseInt(o, 10) === o;
    }, float: function(o) {
      return qW.number(o) && !qW.integer(o);
    }, array: function(o) {
      return Array.isArray(o);
    }, regexp: function(o) {
      if (o instanceof RegExp)
        return true;
      try {
        return !!new RegExp(o);
      } catch {
        return false;
      }
    }, date: function(o) {
      return typeof o.getTime == "function" && typeof o.getMonth == "function" && typeof o.getYear == "function" && !isNaN(o.getTime());
    }, number: function(o) {
      return isNaN(o) ? false : typeof o == "number";
    }, object: function(o) {
      return typeof o == "object" && !qW.array(o);
    }, method: function(o) {
      return typeof o == "function";
    }, email: function(o) {
      return typeof o == "string" && o.length <= 320 && !!o.match($1e.email);
    }, url: function(o) {
      return typeof o == "string" && o.length <= 2048 && !!o.match($1e.url);
    }, hex: function(o) {
      return typeof o == "string" && !!o.match($1e.hex);
    } }, QPt = function(o, i, t3, c3, p3) {
      if (o.required && i === void 0) {
        Ize(o, i, t3, c3, p3);
        return;
      }
      var g3 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], b3 = o.type;
      g3.indexOf(b3) > -1 ? qW[b3](i) || c3.push(B_(p3.messages.types[b3], o.fullField, o.type)) : b3 && typeof i !== o.type && c3.push(B_(p3.messages.types[b3], o.fullField, o.type));
    }, eLt = function(o, i, t3, c3, p3) {
      var g3 = typeof o.len == "number", b3 = typeof o.min == "number", w3 = typeof o.max == "number", M = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, I = i, k3 = null, L = typeof i == "number", F = typeof i == "string", B = Array.isArray(i);
      if (L ? k3 = "number" : F ? k3 = "string" : B && (k3 = "array"), !k3)
        return false;
      B && (I = i.length), F && (I = i.replace(M, "_").length), g3 ? I !== o.len && c3.push(B_(p3.messages[k3].len, o.fullField, o.len)) : b3 && !w3 && I < o.min ? c3.push(B_(p3.messages[k3].min, o.fullField, o.min)) : w3 && !b3 && I > o.max ? c3.push(B_(p3.messages[k3].max, o.fullField, o.max)) : b3 && w3 && (I < o.min || I > o.max) && c3.push(B_(p3.messages[k3].range, o.fullField, o.min, o.max));
    }, r9 = "enum", tLt = function(o, i, t3, c3, p3) {
      o[r9] = Array.isArray(o[r9]) ? o[r9] : [], o[r9].indexOf(i) === -1 && c3.push(B_(p3.messages[r9], o.fullField, o[r9].join(", ")));
    }, nLt = function(o, i, t3, c3, p3) {
      if (o.pattern) {
        if (o.pattern instanceof RegExp)
          o.pattern.lastIndex = 0, o.pattern.test(i) || c3.push(B_(p3.messages.pattern.mismatch, o.fullField, i, o.pattern));
        else if (typeof o.pattern == "string") {
          var g3 = new RegExp(o.pattern);
          g3.test(i) || c3.push(B_(p3.messages.pattern.mismatch, o.fullField, i, o.pattern));
        }
      }
    }, Uc = { required: Ize, whitespace: JPt, type: QPt, range: eLt, enum: tLt, pattern: nLt }, rLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i, "string") && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3, "string"), Tg(i, "string") || (Uc.type(o, i, c3, g3, p3), Uc.range(o, i, c3, g3, p3), Uc.pattern(o, i, c3, g3, p3), o.whitespace === true && Uc.whitespace(o, i, c3, g3, p3));
      }
      t3(g3);
    }, iLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && Uc.type(o, i, c3, g3, p3);
      }
      t3(g3);
    }, aLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (i === "" && (i = void 0), Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && (Uc.type(o, i, c3, g3, p3), Uc.range(o, i, c3, g3, p3));
      }
      t3(g3);
    }, oLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && Uc.type(o, i, c3, g3, p3);
      }
      t3(g3);
    }, sLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), Tg(i) || Uc.type(o, i, c3, g3, p3);
      }
      t3(g3);
    }, lLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && (Uc.type(o, i, c3, g3, p3), Uc.range(o, i, c3, g3, p3));
      }
      t3(g3);
    }, uLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && (Uc.type(o, i, c3, g3, p3), Uc.range(o, i, c3, g3, p3));
      }
      t3(g3);
    }, cLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (i == null && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3, "array"), i != null && (Uc.type(o, i, c3, g3, p3), Uc.range(o, i, c3, g3, p3));
      }
      t3(g3);
    }, fLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && Uc.type(o, i, c3, g3, p3);
      }
      t3(g3);
    }, hLt = "enum", pLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), i !== void 0 && Uc[hLt](o, i, c3, g3, p3);
      }
      t3(g3);
    }, dLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i, "string") && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3), Tg(i, "string") || Uc.pattern(o, i, c3, g3, p3);
      }
      t3(g3);
    }, vLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i, "date") && !o.required)
          return t3();
        if (Uc.required(o, i, c3, g3, p3), !Tg(i, "date")) {
          var w3;
          i instanceof Date ? w3 = i : w3 = new Date(i), Uc.type(o, w3, c3, g3, p3), w3 && Uc.range(o, w3.getTime(), c3, g3, p3);
        }
      }
      t3(g3);
    }, gLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = Array.isArray(i) ? "array" : typeof i;
      Uc.required(o, i, c3, g3, p3, b3), t3(g3);
    }, X1e = function(o, i, t3, c3, p3) {
      var g3 = o.type, b3 = [], w3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (w3) {
        if (Tg(i, g3) && !o.required)
          return t3();
        Uc.required(o, i, c3, b3, p3, g3), Tg(i, g3) || Uc.type(o, i, c3, b3, p3);
      }
      t3(b3);
    }, yLt = function(o, i, t3, c3, p3) {
      var g3 = [], b3 = o.required || !o.required && c3.hasOwnProperty(o.field);
      if (b3) {
        if (Tg(i) && !o.required)
          return t3();
        Uc.required(o, i, c3, g3, p3);
      }
      t3(g3);
    }, $W = { string: rLt, method: iLt, number: aLt, boolean: oLt, regexp: sLt, integer: lLt, float: uLt, array: cLt, object: fLt, enum: pLt, pattern: dLt, date: vLt, url: X1e, hex: X1e, email: X1e, required: gLt, any: yLt };
    function Y1e() {
      return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
        var o = JSON.parse(JSON.stringify(this));
        return o.clone = this.clone, o;
      } };
    }
    var K1e = Y1e(), XW = function() {
      function o(t3) {
        this.rules = null, this._messages = K1e, this.define(t3);
      }
      var i = o.prototype;
      return i.define = function(t3) {
        var c3 = this;
        if (!t3)
          throw new Error("Cannot configure a schema with no rules");
        if (typeof t3 != "object" || Array.isArray(t3))
          throw new Error("Rules must be an object");
        this.rules = {}, Object.keys(t3).forEach(function(p3) {
          var g3 = t3[p3];
          c3.rules[p3] = Array.isArray(g3) ? g3 : [g3];
        });
      }, i.messages = function(t3) {
        return t3 && (this._messages = Aze(Y1e(), t3)), this._messages;
      }, i.validate = function(t3, c3, p3) {
        var g3 = this;
        c3 === void 0 && (c3 = {}), p3 === void 0 && (p3 = function() {
        });
        var b3 = t3, w3 = c3, M = p3;
        if (typeof w3 == "function" && (M = w3, w3 = {}), !this.rules || Object.keys(this.rules).length === 0)
          return M && M(null, b3), Promise.resolve(b3);
        function I(G) {
          var J = [], Q = {};
          function se(be) {
            if (Array.isArray(be)) {
              var de;
              J = (de = J).concat.apply(de, be);
            } else
              J.push(be);
          }
          for (var he = 0; he < G.length; he++)
            se(G[he]);
          J.length ? (Q = q1e(J), M(J, Q)) : M(null, b3);
        }
        if (w3.messages) {
          var k3 = this.messages();
          k3 === K1e && (k3 = Y1e()), Aze(k3, w3.messages), w3.messages = k3;
        } else
          w3.messages = this.messages();
        var L = {}, F = w3.keys || Object.keys(this.rules);
        F.forEach(function(G) {
          var J = g3.rules[G], Q = b3[G];
          J.forEach(function(se) {
            var he = se;
            typeof he.transform == "function" && (b3 === t3 && (b3 = OL({}, b3)), Q = b3[G] = he.transform(Q)), typeof he == "function" ? he = { validator: he } : he = OL({}, he), he.validator = g3.getValidationMethod(he), he.validator && (he.field = G, he.fullField = he.fullField || G, he.type = g3.getType(he), L[G] = L[G] || [], L[G].push({ rule: he, value: Q, source: b3, field: G }));
          });
        });
        var B = {};
        return YPt(L, w3, function(G, J) {
          var Q = G.rule, se = (Q.type === "object" || Q.type === "array") && (typeof Q.fields == "object" || typeof Q.defaultField == "object");
          se = se && (Q.required || !Q.required && G.value), Q.field = G.field;
          function he(Fe, Pe) {
            return OL({}, Pe, { fullField: Q.fullField + "." + Fe, fullFields: Q.fullFields ? [].concat(Q.fullFields, [Fe]) : [Fe] });
          }
          function be(Fe) {
            Fe === void 0 && (Fe = []);
            var Pe = Array.isArray(Fe) ? Fe : [Fe];
            !w3.suppressWarning && Pe.length && o.warning("async-validator:", Pe), Pe.length && Q.message !== void 0 && (Pe = [].concat(Q.message));
            var ze = Pe.map(Tze(Q, b3));
            if (w3.first && ze.length)
              return B[Q.field] = 1, J(ze);
            if (!se)
              J(ze);
            else {
              if (Q.required && !G.value)
                return Q.message !== void 0 ? ze = [].concat(Q.message).map(Tze(Q, b3)) : w3.error && (ze = [w3.error(Q, B_(w3.messages.required, Q.field))]), J(ze);
              var $e = {};
              Q.defaultField && Object.keys(G.value).map(function(lt2) {
                $e[lt2] = Q.defaultField;
              }), $e = OL({}, $e, G.rule.fields);
              var Ke = {};
              Object.keys($e).forEach(function(lt2) {
                var bt = $e[lt2], vt = Array.isArray(bt) ? bt : [bt];
                Ke[lt2] = vt.map(he.bind(null, lt2));
              });
              var nt = new o(Ke);
              nt.messages(w3.messages), G.rule.options && (G.rule.options.messages = w3.messages, G.rule.options.error = w3.error), nt.validate(G.value, G.rule.options || w3, function(lt2) {
                var bt = [];
                ze && ze.length && bt.push.apply(bt, ze), lt2 && lt2.length && bt.push.apply(bt, lt2), J(bt.length ? bt : null);
              });
            }
          }
          var de;
          Q.asyncValidator ? de = Q.asyncValidator(Q, G.value, be, G.source, w3) : Q.validator && (de = Q.validator(Q, G.value, be, G.source, w3), de === true ? be() : de === false ? be(typeof Q.message == "function" ? Q.message(Q.fullField || Q.field) : Q.message || (Q.fullField || Q.field) + " fails") : de instanceof Array ? be(de) : de instanceof Error && be(de.message)), de && de.then && de.then(function() {
            return be();
          }, function(Fe) {
            return be(Fe);
          });
        }, function(G) {
          I(G);
        }, b3);
      }, i.getType = function(t3) {
        if (t3.type === void 0 && t3.pattern instanceof RegExp && (t3.type = "pattern"), typeof t3.validator != "function" && t3.type && !$W.hasOwnProperty(t3.type))
          throw new Error(B_("Unknown rule type %s", t3.type));
        return t3.type || "string";
      }, i.getValidationMethod = function(t3) {
        if (typeof t3.validator == "function")
          return t3.validator;
        var c3 = Object.keys(t3), p3 = c3.indexOf("message");
        return p3 !== -1 && c3.splice(p3, 1), c3.length === 1 && c3[0] === "required" ? $W.required : $W[this.getType(t3)] || void 0;
      }, o;
    }();
    XW.register = function(o, i) {
      if (typeof i != "function")
        throw new Error("Cannot register a validator by type, validator is not a function");
      $W[o] = i;
    }, XW.warning = UPt, XW.messages = K1e, XW.validators = $W;
    var z_ = "'${name}' is not a valid ${type}", Eze = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: z_, method: z_, array: z_, object: z_, number: z_, date: z_, boolean: z_, integer: z_, float: z_, regexp: z_, email: z_, url: z_, hex: z_ }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
    function Dze(o, i) {
      for (var t3 = o, c3 = 0; c3 < i.length; c3 += 1) {
        if (t3 == null)
          return;
        t3 = t3[i[c3]];
      }
      return t3;
    }
    function mLt(o) {
      return KBe(o) || xze(o) || w1e(o) || ZBe();
    }
    function kze(o, i, t3, c3) {
      if (!i.length)
        return t3;
      var p3 = mLt(i), g3 = p3[0], b3 = p3.slice(1), w3;
      return !o && typeof g3 == "number" ? w3 = [] : Array.isArray(o) ? w3 = Qc(o) : w3 = tu({}, o), c3 && t3 === void 0 && b3.length === 1 ? delete w3[g3][b3[0]] : w3[g3] = kze(w3[g3], b3, t3, c3), w3;
    }
    function bLt(o, i, t3) {
      var c3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
      return i.length && c3 && t3 === void 0 && !Dze(o, i.slice(0, -1)) ? o : kze(o, i, t3, c3);
    }
    function qv(o) {
      return H1e(o);
    }
    function i9(o, i) {
      var t3 = Dze(o, i);
      return t3;
    }
    function PL(o, i, t3) {
      var c3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, p3 = bLt(o, i, t3, c3);
      return p3;
    }
    function Oze(o, i) {
      var t3 = {};
      return i.forEach(function(c3) {
        var p3 = i9(o, c3);
        t3 = PL(t3, c3, p3);
      }), t3;
    }
    function YW(o, i) {
      return o && o.some(function(t3) {
        return Rze(t3, i);
      });
    }
    function Pze(o) {
      return Am(o) === "object" && o !== null && Object.getPrototypeOf(o) === Object.prototype;
    }
    function Lze(o, i) {
      var t3 = Array.isArray(o) ? Qc(o) : tu({}, o);
      return i && Object.keys(i).forEach(function(c3) {
        var p3 = t3[c3], g3 = i[c3], b3 = Pze(p3) && Pze(g3);
        t3[c3] = b3 ? Lze(p3, g3 || {}) : g3;
      }), t3;
    }
    function wre(o) {
      for (var i = arguments.length, t3 = new Array(i > 1 ? i - 1 : 0), c3 = 1; c3 < i; c3++)
        t3[c3 - 1] = arguments[c3];
      return t3.reduce(function(p3, g3) {
        return Lze(p3, g3);
      }, o);
    }
    function Rze(o, i) {
      return !o || !i || o.length !== i.length ? false : o.every(function(t3, c3) {
        return i[c3] === t3;
      });
    }
    function _Lt(o, i) {
      if (o === i)
        return true;
      if (!o && i || o && !i || !o || !i || Am(o) !== "object" || Am(i) !== "object")
        return false;
      var t3 = Object.keys(o), c3 = Object.keys(i), p3 = new Set([].concat(Qc(t3), Qc(c3)));
      return Qc(p3).every(function(g3) {
        var b3 = o[g3], w3 = i[g3];
        return typeof b3 == "function" && typeof w3 == "function" ? true : b3 === w3;
      });
    }
    function xLt(o) {
      var i = arguments.length <= 1 ? void 0 : arguments[1];
      return i && i.target && Am(i.target) === "object" && o in i.target ? i.target[o] : i;
    }
    function Nze(o, i, t3) {
      var c3 = o.length;
      if (i < 0 || i >= c3 || t3 < 0 || t3 >= c3)
        return o;
      var p3 = o[i], g3 = i - t3;
      return g3 > 0 ? [].concat(Qc(o.slice(0, t3)), [p3], Qc(o.slice(t3, i)), Qc(o.slice(i + 1, c3))) : g3 < 0 ? [].concat(Qc(o.slice(0, i)), Qc(o.slice(i + 1, t3 + 1)), [p3], Qc(o.slice(t3 + 1, c3))) : o;
    }
    var wLt = XW;
    function SLt(o, i) {
      return o.replace(/\$\{\w+\}/g, function(t3) {
        var c3 = t3.slice(2, -1);
        return i[c3];
      });
    }
    function Z1e(o, i, t3, c3, p3) {
      return J1e.apply(this, arguments);
    }
    function J1e() {
      return J1e = _re(Mk.mark(function o(i, t3, c3, p3, g3) {
        var b3, w3, M, I, k3, L, F, B;
        return Mk.wrap(function(G) {
          for (; ; )
            switch (G.prev = G.next) {
              case 0:
                return b3 = tu({}, c3), delete b3.ruleIndex, w3 = null, b3 && b3.type === "array" && b3.defaultField && (w3 = b3.defaultField, delete b3.defaultField), M = new wLt(Qf({}, i, [b3])), I = wre({}, Eze, p3.validateMessages), M.messages(I), k3 = [], G.prev = 8, G.next = 11, Promise.resolve(M.validate(Qf({}, i, t3), tu({}, p3)));
              case 11:
                G.next = 16;
                break;
              case 13:
                G.prev = 13, G.t0 = G.catch(8), G.t0.errors ? k3 = G.t0.errors.map(function(J, Q) {
                  var se = J.message;
                  return N.isValidElement(se) ? N.cloneElement(se, { key: "error_".concat(Q) }) : se;
                }) : (console.error(G.t0), k3 = [I.default]);
              case 16:
                if (!(!k3.length && w3)) {
                  G.next = 21;
                  break;
                }
                return G.next = 19, Promise.all(t3.map(function(J, Q) {
                  return Z1e("".concat(i, ".").concat(Q), J, w3, p3, g3);
                }));
              case 19:
                return L = G.sent, G.abrupt("return", L.reduce(function(J, Q) {
                  return [].concat(Qc(J), Qc(Q));
                }, []));
              case 21:
                return F = tu(tu({}, c3), {}, { name: i, enum: (c3.enum || []).join(", ") }, g3), B = k3.map(function(J) {
                  return typeof J == "string" ? SLt(J, F) : J;
                }), G.abrupt("return", B);
              case 24:
              case "end":
                return G.stop();
            }
        }, o, null, [[8, 13]]);
      })), J1e.apply(this, arguments);
    }
    function CLt(o, i, t3, c3, p3, g3) {
      var b3 = o.join("."), w3 = t3.map(function(k3, L) {
        var F = k3.validator, B = tu(tu({}, k3), {}, { ruleIndex: L });
        return F && (B.validator = function(G, J, Q) {
          var se = false, he = function() {
            for (var de = arguments.length, Fe = new Array(de), Pe = 0; Pe < de; Pe++)
              Fe[Pe] = arguments[Pe];
            Promise.resolve().then(function() {
              aT(!se, "Your validator function has already return a promise. `callback` will be ignored."), se || Q.apply(void 0, Fe);
            });
          }, be = F(G, J, he);
          se = be && typeof be.then == "function" && typeof be.catch == "function", aT(se, "`callback` is deprecated. Please return a promise instead."), se && be.then(function() {
            Q();
          }).catch(function(de) {
            Q(de || " ");
          });
        }), B;
      }).sort(function(k3, L) {
        var F = k3.warningOnly, B = k3.ruleIndex, G = L.warningOnly, J = L.ruleIndex;
        return !!F == !!G ? B - J : F ? 1 : -1;
      }), M;
      if (p3 === true)
        M = new Promise(function() {
          var k3 = _re(Mk.mark(function L(F, B) {
            var G, J, Q;
            return Mk.wrap(function(se) {
              for (; ; )
                switch (se.prev = se.next) {
                  case 0:
                    G = 0;
                  case 1:
                    if (!(G < w3.length)) {
                      se.next = 12;
                      break;
                    }
                    return J = w3[G], se.next = 5, Z1e(b3, i, J, c3, g3);
                  case 5:
                    if (Q = se.sent, !Q.length) {
                      se.next = 9;
                      break;
                    }
                    return B([{ errors: Q, rule: J }]), se.abrupt("return");
                  case 9:
                    G += 1, se.next = 1;
                    break;
                  case 12:
                    F([]);
                  case 13:
                  case "end":
                    return se.stop();
                }
            }, L);
          }));
          return function(L, F) {
            return k3.apply(this, arguments);
          };
        }());
      else {
        var I = w3.map(function(k3) {
          return Z1e(b3, i, k3, c3, g3).then(function(L) {
            return { errors: L, rule: k3 };
          });
        });
        M = (p3 ? TLt(I) : MLt(I)).then(function(k3) {
          return Promise.reject(k3);
        });
      }
      return M.catch(function(k3) {
        return k3;
      }), M;
    }
    function MLt(o) {
      return Q1e.apply(this, arguments);
    }
    function Q1e() {
      return Q1e = _re(Mk.mark(function o(i) {
        return Mk.wrap(function(t3) {
          for (; ; )
            switch (t3.prev = t3.next) {
              case 0:
                return t3.abrupt("return", Promise.all(i).then(function(c3) {
                  var p3, g3 = (p3 = []).concat.apply(p3, Qc(c3));
                  return g3;
                }));
              case 1:
              case "end":
                return t3.stop();
            }
        }, o);
      })), Q1e.apply(this, arguments);
    }
    function TLt(o) {
      return ebe.apply(this, arguments);
    }
    function ebe() {
      return ebe = _re(Mk.mark(function o(i) {
        var t3;
        return Mk.wrap(function(c3) {
          for (; ; )
            switch (c3.prev = c3.next) {
              case 0:
                return t3 = 0, c3.abrupt("return", new Promise(function(p3) {
                  i.forEach(function(g3) {
                    g3.then(function(b3) {
                      b3.errors.length && p3([b3]), t3 += 1, t3 === i.length && p3([]);
                    });
                  });
                }));
              case 2:
              case "end":
                return c3.stop();
            }
        }, o);
      })), ebe.apply(this, arguments);
    }
    var ALt = ["name"], Gw = [];
    function Fze(o, i, t3, c3, p3, g3) {
      return typeof o == "function" ? o(i, t3, "source" in g3 ? { source: g3.source } : {}) : c3 !== p3;
    }
    var tbe = function(o) {
      R1e(t3, o);
      var i = F1e(t3);
      function t3(c3) {
        var p3;
        if (GW(this, t3), p3 = i.call(this, c3), p3.state = { resetCount: 0 }, p3.cancelRegisterFunc = null, p3.mounted = false, p3.touched = false, p3.dirty = false, p3.validatePromise = null, p3.prevValidating = void 0, p3.errors = Gw, p3.warnings = Gw, p3.cancelRegister = function() {
          var M = p3.props, I = M.preserve, k3 = M.isListField, L = M.name;
          p3.cancelRegisterFunc && p3.cancelRegisterFunc(k3, I, qv(L)), p3.cancelRegisterFunc = null;
        }, p3.getNamePath = function() {
          var M = p3.props, I = M.name, k3 = M.fieldContext, L = k3.prefixName, F = L === void 0 ? [] : L;
          return I !== void 0 ? [].concat(Qc(F), Qc(I)) : [];
        }, p3.getRules = function() {
          var M = p3.props, I = M.rules, k3 = I === void 0 ? [] : I, L = M.fieldContext;
          return k3.map(function(F) {
            return typeof F == "function" ? F(L) : F;
          });
        }, p3.refresh = function() {
          !p3.mounted || p3.setState(function(M) {
            var I = M.resetCount;
            return { resetCount: I + 1 };
          });
        }, p3.triggerMetaEvent = function(M) {
          var I = p3.props.onMetaChange;
          I == null || I(tu(tu({}, p3.getMeta()), {}, { destroy: M }));
        }, p3.onStoreChange = function(M, I, k3) {
          var L = p3.props, F = L.shouldUpdate, B = L.dependencies, G = B === void 0 ? [] : B, J = L.onReset, Q = k3.store, se = p3.getNamePath(), he = p3.getValue(M), be = p3.getValue(Q), de = I && YW(I, se);
          switch (k3.type === "valueUpdate" && k3.source === "external" && he !== be && (p3.touched = true, p3.dirty = true, p3.validatePromise = null, p3.errors = Gw, p3.warnings = Gw, p3.triggerMetaEvent()), k3.type) {
            case "reset":
              if (!I || de) {
                p3.touched = false, p3.dirty = false, p3.validatePromise = null, p3.errors = Gw, p3.warnings = Gw, p3.triggerMetaEvent(), J == null || J(), p3.refresh();
                return;
              }
              break;
            case "remove": {
              if (F) {
                p3.reRender();
                return;
              }
              break;
            }
            case "setField": {
              if (de) {
                var Fe = k3.data;
                "touched" in Fe && (p3.touched = Fe.touched), "validating" in Fe && !("originRCField" in Fe) && (p3.validatePromise = Fe.validating ? Promise.resolve([]) : null), "errors" in Fe && (p3.errors = Fe.errors || Gw), "warnings" in Fe && (p3.warnings = Fe.warnings || Gw), p3.dirty = true, p3.triggerMetaEvent(), p3.reRender();
                return;
              }
              if (F && !se.length && Fze(F, M, Q, he, be, k3)) {
                p3.reRender();
                return;
              }
              break;
            }
            case "dependenciesUpdate": {
              var Pe = G.map(qv);
              if (Pe.some(function(ze) {
                return YW(k3.relatedFields, ze);
              })) {
                p3.reRender();
                return;
              }
              break;
            }
            default:
              if (de || (!G.length || se.length || F) && Fze(F, M, Q, he, be, k3)) {
                p3.reRender();
                return;
              }
              break;
          }
          F === true && p3.reRender();
        }, p3.validateRules = function(M) {
          var I = p3.getNamePath(), k3 = p3.getValue(), L = Promise.resolve().then(function() {
            if (!p3.mounted)
              return [];
            var F = p3.props, B = F.validateFirst, G = B === void 0 ? false : B, J = F.messageVariables, Q = M || {}, se = Q.triggerName, he = p3.getRules();
            se && (he = he.filter(function(de) {
              var Fe = de.validateTrigger;
              if (!Fe)
                return true;
              var Pe = H1e(Fe);
              return Pe.includes(se);
            }));
            var be = CLt(I, k3, he, M, G, J);
            return be.catch(function(de) {
              return de;
            }).then(function() {
              var de = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Gw;
              if (p3.validatePromise === L) {
                p3.validatePromise = null;
                var Fe = [], Pe = [];
                de.forEach(function(ze) {
                  var $e = ze.rule.warningOnly, Ke = ze.errors, nt = Ke === void 0 ? Gw : Ke;
                  $e ? Pe.push.apply(Pe, Qc(nt)) : Fe.push.apply(Fe, Qc(nt));
                }), p3.errors = Fe, p3.warnings = Pe, p3.triggerMetaEvent(), p3.reRender();
              }
            }), be;
          });
          return p3.validatePromise = L, p3.dirty = true, p3.errors = Gw, p3.warnings = Gw, p3.triggerMetaEvent(), p3.reRender(), L;
        }, p3.isFieldValidating = function() {
          return !!p3.validatePromise;
        }, p3.isFieldTouched = function() {
          return p3.touched;
        }, p3.isFieldDirty = function() {
          if (p3.dirty || p3.props.initialValue !== void 0)
            return true;
          var M = p3.props.fieldContext, I = M.getInternalHooks(n9), k3 = I.getInitialValue;
          return k3(p3.getNamePath()) !== void 0;
        }, p3.getErrors = function() {
          return p3.errors;
        }, p3.getWarnings = function() {
          return p3.warnings;
        }, p3.isListField = function() {
          return p3.props.isListField;
        }, p3.isList = function() {
          return p3.props.isList;
        }, p3.isPreserve = function() {
          return p3.props.preserve;
        }, p3.getMeta = function() {
          p3.prevValidating = p3.isFieldValidating();
          var M = { touched: p3.isFieldTouched(), validating: p3.prevValidating, errors: p3.errors, warnings: p3.warnings, name: p3.getNamePath() };
          return M;
        }, p3.getOnlyChild = function(M) {
          if (typeof M == "function") {
            var I = p3.getMeta();
            return tu(tu({}, p3.getOnlyChild(M(p3.getControlled(), I, p3.props.fieldContext))), {}, { isFunction: true });
          }
          var k3 = G1e(M);
          return k3.length !== 1 || !N.isValidElement(k3[0]) ? { child: k3, isFunction: false } : { child: k3[0], isFunction: false };
        }, p3.getValue = function(M) {
          var I = p3.props.fieldContext.getFieldsValue, k3 = p3.getNamePath();
          return i9(M || I(true), k3);
        }, p3.getControlled = function() {
          var M = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, I = p3.props, k3 = I.trigger, L = I.validateTrigger, F = I.getValueFromEvent, B = I.normalize, G = I.valuePropName, J = I.getValueProps, Q = I.fieldContext, se = L !== void 0 ? L : Q.validateTrigger, he = p3.getNamePath(), be = Q.getInternalHooks, de = Q.getFieldsValue, Fe = be(n9), Pe = Fe.dispatch, ze = p3.getValue(), $e = J || function(bt) {
            return Qf({}, G, bt);
          }, Ke = M[k3], nt = tu(tu({}, M), $e(ze));
          nt[k3] = function() {
            p3.touched = true, p3.dirty = true, p3.triggerMetaEvent();
            for (var bt, vt = arguments.length, jt = new Array(vt), Jt = 0; Jt < vt; Jt++)
              jt[Jt] = arguments[Jt];
            F ? bt = F.apply(void 0, jt) : bt = xLt.apply(void 0, [G].concat(jt)), B && (bt = B(bt, ze, de(true))), Pe({ type: "updateValue", namePath: he, value: bt }), Ke && Ke.apply(void 0, jt);
          };
          var lt2 = H1e(se || []);
          return lt2.forEach(function(bt) {
            var vt = nt[bt];
            nt[bt] = function() {
              vt && vt.apply(void 0, arguments);
              var jt = p3.props.rules;
              jt && jt.length && Pe({ type: "validateField", namePath: he, triggerName: bt });
            };
          }), nt;
        }, c3.fieldContext) {
          var g3 = c3.fieldContext.getInternalHooks, b3 = g3(n9), w3 = b3.initEntityValue;
          w3(N1e(p3));
        }
        return p3;
      }
      return HW(t3, [{ key: "componentDidMount", value: function() {
        var c3 = this.props, p3 = c3.shouldUpdate, g3 = c3.fieldContext;
        if (this.mounted = true, g3) {
          var b3 = g3.getInternalHooks, w3 = b3(n9), M = w3.registerField;
          this.cancelRegisterFunc = M(this);
        }
        p3 === true && this.reRender();
      } }, { key: "componentWillUnmount", value: function() {
        this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
      } }, { key: "reRender", value: function() {
        !this.mounted || this.forceUpdate();
      } }, { key: "render", value: function() {
        var c3 = this.state.resetCount, p3 = this.props.children, g3 = this.getOnlyChild(p3), b3 = g3.child, w3 = g3.isFunction, M;
        return w3 ? M = b3 : N.isValidElement(b3) ? M = N.cloneElement(b3, this.getControlled(b3.props)) : (aT(!b3, "`children` of Field is not validate ReactElement."), M = b3), N.createElement(N.Fragment, { key: c3 }, M);
      } }]), t3;
    }(N.Component);
    tbe.contextType = WW, tbe.defaultProps = { trigger: "onChange", valuePropName: "value" };
    function Vze(o) {
      var i = o.name, t3 = e9(o, ALt), c3 = N.useContext(WW), p3 = i !== void 0 ? qv(i) : void 0, g3 = "keep";
      return t3.isListField || (g3 = "_".concat((p3 || []).join("_"))), N.createElement(tbe, Uv({ key: g3, name: p3 }, t3, { fieldContext: c3 }));
    }
    var ILt = N.createContext(null), ELt = function(o) {
      var i = o.name, t3 = o.initialValue, c3 = o.children, p3 = o.rules, g3 = o.validateTrigger, b3 = N.useContext(WW), w3 = N.useRef({ keys: [], id: 0 }), M = w3.current, I = N.useMemo(function() {
        var B = qv(b3.prefixName) || [];
        return [].concat(Qc(B), Qc(qv(i)));
      }, [b3.prefixName, i]), k3 = N.useMemo(function() {
        return tu(tu({}, b3), {}, { prefixName: I });
      }, [b3, I]), L = N.useMemo(function() {
        return { getKey: function(B) {
          var G = I.length, J = B[G];
          return [M.keys[J], B.slice(G + 1)];
        } };
      }, [I]);
      if (typeof c3 != "function")
        return aT(false, "Form.List only accepts function as children."), null;
      var F = function(B, G, J) {
        var Q = J.source;
        return Q === "internal" ? false : B !== G;
      };
      return N.createElement(ILt.Provider, { value: L }, N.createElement(WW.Provider, { value: k3 }, N.createElement(Vze, { name: [], shouldUpdate: F, rules: p3, validateTrigger: g3, initialValue: t3, isList: true }, function(B, G) {
        var J = B.value, Q = J === void 0 ? [] : J, se = B.onChange, he = b3.getFieldValue, be = function() {
          var Pe = he(I || []);
          return Pe || [];
        }, de = { add: function(Pe, ze) {
          var $e = be();
          ze >= 0 && ze <= $e.length ? (M.keys = [].concat(Qc(M.keys.slice(0, ze)), [M.id], Qc(M.keys.slice(ze))), se([].concat(Qc($e.slice(0, ze)), [Pe], Qc($e.slice(ze))))) : (M.keys = [].concat(Qc(M.keys), [M.id]), se([].concat(Qc($e), [Pe]))), M.id += 1;
        }, remove: function(Pe) {
          var ze = be(), $e = new Set(Array.isArray(Pe) ? Pe : [Pe]);
          $e.size <= 0 || (M.keys = M.keys.filter(function(Ke, nt) {
            return !$e.has(nt);
          }), se(ze.filter(function(Ke, nt) {
            return !$e.has(nt);
          })));
        }, move: function(Pe, ze) {
          if (Pe !== ze) {
            var $e = be();
            Pe < 0 || Pe >= $e.length || ze < 0 || ze >= $e.length || (M.keys = Nze(M.keys, Pe, ze), se(Nze($e, Pe, ze)));
          }
        } }, Fe = Q || [];
        return Array.isArray(Fe) || (Fe = []), c3(Fe.map(function(Pe, ze) {
          var $e = M.keys[ze];
          return $e === void 0 && (M.keys[ze] = M.id, $e = M.keys[ze], M.id += 1), { name: ze, key: $e, isListField: true };
        }), de, G);
      })));
    };
    function DLt(o) {
      var i = false, t3 = o.length, c3 = [];
      return o.length ? new Promise(function(p3, g3) {
        o.forEach(function(b3, w3) {
          b3.catch(function(M) {
            return i = true, M;
          }).then(function(M) {
            t3 -= 1, c3[w3] = M, !(t3 > 0) && (i && g3(c3), p3(c3));
          });
        });
      }) : Promise.resolve([]);
    }
    var Bze = "__@field_split__";
    function nbe(o) {
      return o.map(function(i) {
        return "".concat(Am(i), ":").concat(i);
      }).join(Bze);
    }
    var KW = function() {
      function o() {
        GW(this, o), this.kvs = /* @__PURE__ */ new Map();
      }
      return HW(o, [{ key: "set", value: function(i, t3) {
        this.kvs.set(nbe(i), t3);
      } }, { key: "get", value: function(i) {
        return this.kvs.get(nbe(i));
      } }, { key: "update", value: function(i, t3) {
        var c3 = this.get(i), p3 = t3(c3);
        p3 ? this.set(i, p3) : this.delete(i);
      } }, { key: "delete", value: function(i) {
        this.kvs.delete(nbe(i));
      } }, { key: "map", value: function(i) {
        return Qc(this.kvs.entries()).map(function(t3) {
          var c3 = zw(t3, 2), p3 = c3[0], g3 = c3[1], b3 = p3.split(Bze);
          return i({ key: b3.map(function(w3) {
            var M = w3.match(/^([^:]*):(.*)$/), I = zw(M, 3), k3 = I[1], L = I[2];
            return k3 === "number" ? Number(L) : L;
          }), value: g3 });
        });
      } }, { key: "toJSON", value: function() {
        var i = {};
        return this.map(function(t3) {
          var c3 = t3.key, p3 = t3.value;
          return i[c3.join(".")] = p3, null;
        }), i;
      } }]), o;
    }(), kLt = ["name", "errors"], OLt = HW(function o(i) {
      var t3 = this;
      GW(this, o), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
        return { getFieldValue: t3.getFieldValue, getFieldsValue: t3.getFieldsValue, getFieldError: t3.getFieldError, getFieldWarning: t3.getFieldWarning, getFieldsError: t3.getFieldsError, isFieldsTouched: t3.isFieldsTouched, isFieldTouched: t3.isFieldTouched, isFieldValidating: t3.isFieldValidating, isFieldsValidating: t3.isFieldsValidating, resetFields: t3.resetFields, setFields: t3.setFields, setFieldsValue: t3.setFieldsValue, validateFields: t3.validateFields, submit: t3.submit, getInternalHooks: t3.getInternalHooks };
      }, this.getInternalHooks = function(c3) {
        return c3 === n9 ? (t3.formHooked = true, { dispatch: t3.dispatch, initEntityValue: t3.initEntityValue, registerField: t3.registerField, useSubscribe: t3.useSubscribe, setInitialValues: t3.setInitialValues, setCallbacks: t3.setCallbacks, setValidateMessages: t3.setValidateMessages, getFields: t3.getFields, setPreserve: t3.setPreserve, getInitialValue: t3.getInitialValue }) : (aT(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
      }, this.useSubscribe = function(c3) {
        t3.subscribable = c3;
      }, this.setInitialValues = function(c3, p3) {
        t3.initialValues = c3 || {}, p3 && (t3.store = wre({}, c3, t3.store));
      }, this.getInitialValue = function(c3) {
        return i9(t3.initialValues, c3);
      }, this.setCallbacks = function(c3) {
        t3.callbacks = c3;
      }, this.setValidateMessages = function(c3) {
        t3.validateMessages = c3;
      }, this.setPreserve = function(c3) {
        t3.preserve = c3;
      }, this.timeoutId = null, this.warningUnhooked = function() {
      }, this.getFieldEntities = function() {
        var c3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
        return c3 ? t3.fieldEntities.filter(function(p3) {
          return p3.getNamePath().length;
        }) : t3.fieldEntities;
      }, this.getFieldsMap = function() {
        var c3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, p3 = new KW();
        return t3.getFieldEntities(c3).forEach(function(g3) {
          var b3 = g3.getNamePath();
          p3.set(b3, g3);
        }), p3;
      }, this.getFieldEntitiesForNamePathList = function(c3) {
        if (!c3)
          return t3.getFieldEntities(true);
        var p3 = t3.getFieldsMap(true);
        return c3.map(function(g3) {
          var b3 = qv(g3);
          return p3.get(b3) || { INVALIDATE_NAME_PATH: qv(g3) };
        });
      }, this.getFieldsValue = function(c3, p3) {
        if (t3.warningUnhooked(), c3 === true && !p3)
          return t3.store;
        var g3 = t3.getFieldEntitiesForNamePathList(Array.isArray(c3) ? c3 : null), b3 = [];
        return g3.forEach(function(w3) {
          var M, I = "INVALIDATE_NAME_PATH" in w3 ? w3.INVALIDATE_NAME_PATH : w3.getNamePath();
          if (!(!c3 && ((M = w3.isListField) === null || M === void 0 ? void 0 : M.call(w3))))
            if (!p3)
              b3.push(I);
            else {
              var k3 = "getMeta" in w3 ? w3.getMeta() : null;
              p3(k3) && b3.push(I);
            }
        }), Oze(t3.store, b3.map(qv));
      }, this.getFieldValue = function(c3) {
        t3.warningUnhooked();
        var p3 = qv(c3);
        return i9(t3.store, p3);
      }, this.getFieldsError = function(c3) {
        t3.warningUnhooked();
        var p3 = t3.getFieldEntitiesForNamePathList(c3);
        return p3.map(function(g3, b3) {
          return g3 && !("INVALIDATE_NAME_PATH" in g3) ? { name: g3.getNamePath(), errors: g3.getErrors(), warnings: g3.getWarnings() } : { name: qv(c3[b3]), errors: [], warnings: [] };
        });
      }, this.getFieldError = function(c3) {
        t3.warningUnhooked();
        var p3 = qv(c3), g3 = t3.getFieldsError([p3])[0];
        return g3.errors;
      }, this.getFieldWarning = function(c3) {
        t3.warningUnhooked();
        var p3 = qv(c3), g3 = t3.getFieldsError([p3])[0];
        return g3.warnings;
      }, this.isFieldsTouched = function() {
        t3.warningUnhooked();
        for (var c3 = arguments.length, p3 = new Array(c3), g3 = 0; g3 < c3; g3++)
          p3[g3] = arguments[g3];
        var b3 = p3[0], w3 = p3[1], M, I = false;
        p3.length === 0 ? M = null : p3.length === 1 ? Array.isArray(b3) ? (M = b3.map(qv), I = false) : (M = null, I = b3) : (M = b3.map(qv), I = w3);
        var k3 = t3.getFieldEntities(true), L = function(J) {
          return J.isFieldTouched();
        };
        if (!M)
          return I ? k3.every(L) : k3.some(L);
        var F = new KW();
        M.forEach(function(J) {
          F.set(J, []);
        }), k3.forEach(function(J) {
          var Q = J.getNamePath();
          M.forEach(function(se) {
            se.every(function(he, be) {
              return Q[be] === he;
            }) && F.update(se, function(he) {
              return [].concat(Qc(he), [J]);
            });
          });
        });
        var B = function(J) {
          return J.some(L);
        }, G = F.map(function(J) {
          var Q = J.value;
          return Q;
        });
        return I ? G.every(B) : G.some(B);
      }, this.isFieldTouched = function(c3) {
        return t3.warningUnhooked(), t3.isFieldsTouched([c3]);
      }, this.isFieldsValidating = function(c3) {
        t3.warningUnhooked();
        var p3 = t3.getFieldEntities();
        if (!c3)
          return p3.some(function(b3) {
            return b3.isFieldValidating();
          });
        var g3 = c3.map(qv);
        return p3.some(function(b3) {
          var w3 = b3.getNamePath();
          return YW(g3, w3) && b3.isFieldValidating();
        });
      }, this.isFieldValidating = function(c3) {
        return t3.warningUnhooked(), t3.isFieldsValidating([c3]);
      }, this.resetWithFieldInitialValue = function() {
        var c3 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, p3 = new KW(), g3 = t3.getFieldEntities(true);
        g3.forEach(function(M) {
          var I = M.props.initialValue, k3 = M.getNamePath();
          if (I !== void 0) {
            var L = p3.get(k3) || /* @__PURE__ */ new Set();
            L.add({ entity: M, value: I }), p3.set(k3, L);
          }
        });
        var b3 = function(M) {
          M.forEach(function(I) {
            var k3 = I.props.initialValue;
            if (k3 !== void 0) {
              var L = I.getNamePath(), F = t3.getInitialValue(L);
              if (F !== void 0)
                aT(false, "Form already set 'initialValues' with path '".concat(L.join("."), "'. Field can not overwrite it."));
              else {
                var B = p3.get(L);
                if (B && B.size > 1)
                  aT(false, "Multiple Field with path '".concat(L.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                else if (B) {
                  var G = t3.getFieldValue(L);
                  (!c3.skipExist || G === void 0) && (t3.store = PL(t3.store, L, Qc(B)[0].value));
                }
              }
            }
          });
        }, w3;
        c3.entities ? w3 = c3.entities : c3.namePathList ? (w3 = [], c3.namePathList.forEach(function(M) {
          var I = p3.get(M);
          if (I) {
            var k3;
            (k3 = w3).push.apply(k3, Qc(Qc(I).map(function(L) {
              return L.entity;
            })));
          }
        })) : w3 = g3, b3(w3);
      }, this.resetFields = function(c3) {
        t3.warningUnhooked();
        var p3 = t3.store;
        if (!c3) {
          t3.store = wre({}, t3.initialValues), t3.resetWithFieldInitialValue(), t3.notifyObservers(p3, null, { type: "reset" });
          return;
        }
        var g3 = c3.map(qv);
        g3.forEach(function(b3) {
          var w3 = t3.getInitialValue(b3);
          t3.store = PL(t3.store, b3, w3);
        }), t3.resetWithFieldInitialValue({ namePathList: g3 }), t3.notifyObservers(p3, g3, { type: "reset" });
      }, this.setFields = function(c3) {
        t3.warningUnhooked();
        var p3 = t3.store;
        c3.forEach(function(g3) {
          var b3 = g3.name;
          g3.errors;
          var w3 = e9(g3, kLt), M = qv(b3);
          "value" in w3 && (t3.store = PL(t3.store, M, w3.value)), t3.notifyObservers(p3, [M], { type: "setField", data: g3 });
        });
      }, this.getFields = function() {
        var c3 = t3.getFieldEntities(true), p3 = c3.map(function(g3) {
          var b3 = g3.getNamePath(), w3 = g3.getMeta(), M = tu(tu({}, w3), {}, { name: b3, value: t3.getFieldValue(b3) });
          return Object.defineProperty(M, "originRCField", { value: true }), M;
        });
        return p3;
      }, this.initEntityValue = function(c3) {
        var p3 = c3.props.initialValue;
        if (p3 !== void 0) {
          var g3 = c3.getNamePath(), b3 = i9(t3.store, g3);
          b3 === void 0 && (t3.store = PL(t3.store, g3, p3));
        }
      }, this.registerField = function(c3) {
        if (t3.fieldEntities.push(c3), c3.props.initialValue !== void 0) {
          var p3 = t3.store;
          t3.resetWithFieldInitialValue({ entities: [c3], skipExist: true }), t3.notifyObservers(p3, [c3.getNamePath()], { type: "valueUpdate", source: "internal" });
        }
        return function(g3, b3) {
          var w3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
          t3.fieldEntities = t3.fieldEntities.filter(function(F) {
            return F !== c3;
          });
          var M = b3 !== void 0 ? b3 : t3.preserve;
          if (M === false && (!g3 || w3.length > 1)) {
            var I = c3.getNamePath(), k3 = g3 ? void 0 : i9(t3.initialValues, I);
            if (I.length && t3.getFieldValue(I) !== k3 && t3.fieldEntities.every(function(F) {
              return !Rze(F.getNamePath(), I);
            })) {
              var L = t3.store;
              t3.store = PL(L, I, k3, true), t3.notifyObservers(L, [I], { type: "remove" }), t3.triggerDependenciesUpdate(L, I);
            }
          }
        };
      }, this.dispatch = function(c3) {
        switch (c3.type) {
          case "updateValue": {
            var p3 = c3.namePath, g3 = c3.value;
            t3.updateValue(p3, g3);
            break;
          }
          case "validateField": {
            var b3 = c3.namePath, w3 = c3.triggerName;
            t3.validateFields([b3], { triggerName: w3 });
            break;
          }
        }
      }, this.notifyObservers = function(c3, p3, g3) {
        if (t3.subscribable) {
          var b3 = tu(tu({}, g3), {}, { store: t3.getFieldsValue(true) });
          t3.getFieldEntities().forEach(function(w3) {
            var M = w3.onStoreChange;
            M(c3, p3, b3);
          });
        } else
          t3.forceRootUpdate();
      }, this.triggerDependenciesUpdate = function(c3, p3) {
        var g3 = t3.getDependencyChildrenFields(p3);
        return g3.length && t3.validateFields(g3), t3.notifyObservers(c3, g3, { type: "dependenciesUpdate", relatedFields: [p3].concat(Qc(g3)) }), g3;
      }, this.updateValue = function(c3, p3) {
        var g3 = qv(c3), b3 = t3.store;
        t3.store = PL(t3.store, g3, p3), t3.notifyObservers(b3, [g3], { type: "valueUpdate", source: "internal" });
        var w3 = t3.triggerDependenciesUpdate(b3, g3), M = t3.callbacks.onValuesChange;
        if (M) {
          var I = Oze(t3.store, [g3]);
          M(I, t3.getFieldsValue());
        }
        t3.triggerOnFieldsChange([g3].concat(Qc(w3)));
      }, this.setFieldsValue = function(c3) {
        t3.warningUnhooked();
        var p3 = t3.store;
        c3 && (t3.store = wre(t3.store, c3)), t3.notifyObservers(p3, null, { type: "valueUpdate", source: "external" });
      }, this.getDependencyChildrenFields = function(c3) {
        var p3 = /* @__PURE__ */ new Set(), g3 = [], b3 = new KW();
        t3.getFieldEntities().forEach(function(M) {
          var I = M.props.dependencies;
          (I || []).forEach(function(k3) {
            var L = qv(k3);
            b3.update(L, function() {
              var F = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
              return F.add(M), F;
            });
          });
        });
        var w3 = function M(I) {
          var k3 = b3.get(I) || /* @__PURE__ */ new Set();
          k3.forEach(function(L) {
            if (!p3.has(L)) {
              p3.add(L);
              var F = L.getNamePath();
              L.isFieldDirty() && F.length && (g3.push(F), M(F));
            }
          });
        };
        return w3(c3), g3;
      }, this.triggerOnFieldsChange = function(c3, p3) {
        var g3 = t3.callbacks.onFieldsChange;
        if (g3) {
          var b3 = t3.getFields();
          if (p3) {
            var w3 = new KW();
            p3.forEach(function(I) {
              var k3 = I.name, L = I.errors;
              w3.set(k3, L);
            }), b3.forEach(function(I) {
              I.errors = w3.get(I.name) || I.errors;
            });
          }
          var M = b3.filter(function(I) {
            var k3 = I.name;
            return YW(c3, k3);
          });
          g3(M, b3);
        }
      }, this.validateFields = function(c3, p3) {
        t3.warningUnhooked();
        var g3 = !!c3, b3 = g3 ? c3.map(qv) : [], w3 = [];
        t3.getFieldEntities(true).forEach(function(k3) {
          if (g3 || b3.push(k3.getNamePath()), (p3 == null ? void 0 : p3.recursive) && g3) {
            var L = k3.getNamePath();
            L.every(function(G, J) {
              return c3[J] === G || c3[J] === void 0;
            }) && b3.push(L);
          }
          if (!(!k3.props.rules || !k3.props.rules.length)) {
            var F = k3.getNamePath();
            if (!g3 || YW(b3, F)) {
              var B = k3.validateRules(tu({ validateMessages: tu(tu({}, Eze), t3.validateMessages) }, p3));
              w3.push(B.then(function() {
                return { name: F, errors: [], warnings: [] };
              }).catch(function(G) {
                var J = [], Q = [];
                return G.forEach(function(se) {
                  var he = se.rule.warningOnly, be = se.errors;
                  he ? Q.push.apply(Q, Qc(be)) : J.push.apply(J, Qc(be));
                }), J.length ? Promise.reject({ name: F, errors: J, warnings: Q }) : { name: F, errors: J, warnings: Q };
              }));
            }
          }
        });
        var M = DLt(w3);
        t3.lastValidatePromise = M, M.catch(function(k3) {
          return k3;
        }).then(function(k3) {
          var L = k3.map(function(F) {
            var B = F.name;
            return B;
          });
          t3.notifyObservers(t3.store, L, { type: "validateFinish" }), t3.triggerOnFieldsChange(L, k3);
        });
        var I = M.then(function() {
          return t3.lastValidatePromise === M ? Promise.resolve(t3.getFieldsValue(b3)) : Promise.reject([]);
        }).catch(function(k3) {
          var L = k3.filter(function(F) {
            return F && F.errors.length;
          });
          return Promise.reject({ values: t3.getFieldsValue(b3), errorFields: L, outOfDate: t3.lastValidatePromise !== M });
        });
        return I.catch(function(k3) {
          return k3;
        }), I;
      }, this.submit = function() {
        t3.warningUnhooked(), t3.validateFields().then(function(c3) {
          var p3 = t3.callbacks.onFinish;
          if (p3)
            try {
              p3(c3);
            } catch (g3) {
              console.error(g3);
            }
        }).catch(function(c3) {
          var p3 = t3.callbacks.onFinishFailed;
          p3 && p3(c3);
        });
      }, this.forceRootUpdate = i;
    });
    function zze(o) {
      var i = N.useRef(), t3 = N.useState({}), c3 = zw(t3, 2), p3 = c3[1];
      if (!i.current)
        if (o)
          i.current = o;
        else {
          var g3 = function() {
            p3({});
          }, b3 = new OLt(g3);
          i.current = b3.getForm();
        }
      return [i.current];
    }
    var rbe = N.createContext({ triggerFormChange: function() {
    }, triggerFormFinish: function() {
    }, registerForm: function() {
    }, unregisterForm: function() {
    } }), PLt = function(o) {
      var i = o.validateMessages, t3 = o.onFormChange, c3 = o.onFormFinish, p3 = o.children, g3 = N.useContext(rbe), b3 = N.useRef({});
      return N.createElement(rbe.Provider, { value: tu(tu({}, g3), {}, { validateMessages: tu(tu({}, g3.validateMessages), i), triggerFormChange: function(w3, M) {
        t3 && t3(w3, { changedFields: M, forms: b3.current }), g3.triggerFormChange(w3, M);
      }, triggerFormFinish: function(w3, M) {
        c3 && c3(w3, { values: M, forms: b3.current }), g3.triggerFormFinish(w3, M);
      }, registerForm: function(w3, M) {
        w3 && (b3.current = tu(tu({}, b3.current), {}, Qf({}, w3, M))), g3.registerForm(w3, M);
      }, unregisterForm: function(w3) {
        var M = tu({}, b3.current);
        delete M[w3], b3.current = M, g3.unregisterForm(w3);
      } }) }, p3);
    }, LLt = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], RLt = function(o, i) {
      var t3 = o.name, c3 = o.initialValues, p3 = o.fields, g3 = o.form, b3 = o.preserve, w3 = o.children, M = o.component, I = M === void 0 ? "form" : M, k3 = o.validateMessages, L = o.validateTrigger, F = L === void 0 ? "onChange" : L, B = o.onValuesChange, G = o.onFieldsChange, J = o.onFinish, Q = o.onFinishFailed, se = e9(o, LLt), he = N.useContext(rbe), be = zze(g3), de = zw(be, 1), Fe = de[0], Pe = Fe.getInternalHooks(n9), ze = Pe.useSubscribe, $e = Pe.setInitialValues, Ke = Pe.setCallbacks, nt = Pe.setValidateMessages, lt2 = Pe.setPreserve;
      N.useImperativeHandle(i, function() {
        return Fe;
      }), N.useEffect(function() {
        return he.registerForm(t3, Fe), function() {
          he.unregisterForm(t3);
        };
      }, [he, Fe, t3]), nt(tu(tu({}, he.validateMessages), k3)), Ke({ onValuesChange: B, onFieldsChange: function(vn) {
        if (he.triggerFormChange(t3, vn), G) {
          for (var kn = arguments.length, cr = new Array(kn > 1 ? kn - 1 : 0), gr = 1; gr < kn; gr++)
            cr[gr - 1] = arguments[gr];
          G.apply(void 0, [vn].concat(cr));
        }
      }, onFinish: function(vn) {
        he.triggerFormFinish(t3, vn), J && J(vn);
      }, onFinishFailed: Q }), lt2(b3);
      var bt = N.useRef(null);
      $e(c3, !bt.current), bt.current || (bt.current = true);
      var vt = w3, jt = typeof w3 == "function";
      if (jt) {
        var Jt = Fe.getFieldsValue(true);
        vt = w3(Jt, Fe);
      }
      ze(!jt);
      var Rt = N.useRef();
      N.useEffect(function() {
        _Lt(Rt.current || [], p3 || []) || Fe.setFields(p3 || []), Rt.current = p3;
      }, [p3, Fe]);
      var Jn = N.useMemo(function() {
        return tu(tu({}, Fe), {}, { validateTrigger: F });
      }, [Fe, F]), ln = N.createElement(WW.Provider, { value: Jn }, vt);
      return I === false ? ln : N.createElement(I, Uv({}, se, { onSubmit: function(vn) {
        vn.preventDefault(), vn.stopPropagation(), Fe.submit();
      }, onReset: function(vn) {
        var kn;
        vn.preventDefault(), Fe.resetFields(), (kn = se.onReset) === null || kn === void 0 || kn.call(se, vn);
      } }), ln);
    }, NLt = N.forwardRef(RLt), Sre = NLt;
    Sre.FormProvider = PLt, Sre.Field = Vze, Sre.List = ELt, Sre.useForm = zze;
    var FLt = function(o, i, t3) {
      aT(o, "[antd: ".concat(i, "] ").concat(t3));
    }, VLt = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, BLt = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, zLt = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, jze = zLt, jLt = { lang: Uv({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, BLt), timePickerLocale: Uv({}, jze) }, Gze = jLt, j_ = "${label} is not a valid ${type}", GLt = { locale: "en", Pagination: VLt, DatePicker: Gze, TimePicker: jze, Calendar: Gze, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: j_, method: j_, array: j_, object: j_, number: j_, date: j_, boolean: j_, integer: j_, float: j_, regexp: j_, email: j_, url: j_, hex: j_ }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, Hze = GLt, HLt = C.createContext(void 0), WLt = HLt, ibe = function(o) {
      R1e(t3, o);
      var i = F1e(t3);
      function t3() {
        return GW(this, t3), i.apply(this, arguments);
      }
      return HW(t3, [{ key: "getLocale", value: function() {
        var c3 = this.props, p3 = c3.componentName, g3 = c3.defaultLocale, b3 = g3 || Hze[p3 != null ? p3 : "global"], w3 = this.context, M = p3 && w3 ? w3[p3] : {};
        return Uv(Uv({}, b3 instanceof Function ? b3() : b3), M || {});
      } }, { key: "getLocaleCode", value: function() {
        var c3 = this.context, p3 = c3 && c3.locale;
        return c3 && c3.exist && !p3 ? Hze.locale : p3;
      } }, { key: "render", value: function() {
        return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
      } }]), t3;
    }(N.Component);
    ibe.defaultProps = { componentName: "global" }, ibe.contextType = WLt;
    var ULt = function() {
      var o = N.useContext(Tk), i = o.getPrefixCls, t3 = i("empty-img-default");
      return N.createElement("svg", { className: t3, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, N.createElement("g", { fill: "none", fillRule: "evenodd" }, N.createElement("g", { transform: "translate(24 31.67)" }, N.createElement("ellipse", { className: "".concat(t3, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), N.createElement("path", { className: "".concat(t3, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), N.createElement("path", { className: "".concat(t3, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), N.createElement("path", { className: "".concat(t3, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), N.createElement("path", { className: "".concat(t3, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), N.createElement("path", { className: "".concat(t3, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), N.createElement("g", { className: "".concat(t3, "-g"), transform: "translate(149.65 15.383)" }, N.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), N.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
    }, qLt = ULt, $Lt = function() {
      var o = N.useContext(Tk), i = o.getPrefixCls, t3 = i("empty-img-simple");
      return N.createElement("svg", { className: t3, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, N.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, N.createElement("ellipse", { className: "".concat(t3, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), N.createElement("g", { className: "".concat(t3, "-g"), fillRule: "nonzero" }, N.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), N.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(t3, "-path") }))));
    }, XLt = $Lt, YLt = globalThis && globalThis.__rest || function(o, i) {
      var t3 = {};
      for (var c3 in o)
        Object.prototype.hasOwnProperty.call(o, c3) && i.indexOf(c3) < 0 && (t3[c3] = o[c3]);
      if (o != null && typeof Object.getOwnPropertySymbols == "function")
        for (var p3 = 0, c3 = Object.getOwnPropertySymbols(o); p3 < c3.length; p3++)
          i.indexOf(c3[p3]) < 0 && Object.prototype.propertyIsEnumerable.call(o, c3[p3]) && (t3[c3[p3]] = o[c3[p3]]);
      return t3;
    }, Wze = N.createElement(qLt, null), Uze = N.createElement(XLt, null), abe = function(o) {
      var i = o.className, t3 = o.prefixCls, c3 = o.image, p3 = c3 === void 0 ? Wze : c3, g3 = o.description, b3 = o.children, w3 = o.imageStyle, M = YLt(o, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), I = N.useContext(Tk), k3 = I.getPrefixCls, L = I.direction;
      return N.createElement(ibe, { componentName: "Empty" }, function(F) {
        var B, G = k3("empty", t3), J = typeof g3 != "undefined" ? g3 : F.description, Q = typeof J == "string" ? J : "empty", se = null;
        return typeof p3 == "string" ? se = N.createElement("img", { alt: Q, src: p3 }) : se = p3, N.createElement("div", Uv({ className: t9(G, (B = {}, Qf(B, "".concat(G, "-normal"), p3 === Uze), Qf(B, "".concat(G, "-rtl"), L === "rtl"), B), i) }, M), N.createElement("div", { className: "".concat(G, "-image"), style: w3 }, se), J && N.createElement("div", { className: "".concat(G, "-description") }, J), b3 && N.createElement("div", { className: "".concat(G, "-footer") }, b3));
      });
    };
    abe.PRESENTED_IMAGE_DEFAULT = Wze, abe.PRESENTED_IMAGE_SIMPLE = Uze;
    var ZW = abe, KLt = function(o) {
      return N.createElement(qze, null, function(i) {
        var t3 = i.getPrefixCls, c3 = t3("empty");
        switch (o) {
          case "Table":
          case "List":
            return N.createElement(ZW, { image: ZW.PRESENTED_IMAGE_SIMPLE });
          case "Select":
          case "TreeSelect":
          case "Cascader":
          case "Transfer":
          case "Mentions":
            return N.createElement(ZW, { image: ZW.PRESENTED_IMAGE_SIMPLE, className: "".concat(c3, "-small") });
          default:
            return N.createElement(ZW, null);
        }
      });
    }, ZLt = KLt, JLt = function(o, i) {
      return i || (o ? "ant-".concat(o) : "ant");
    }, Tk = N.createContext({ getPrefixCls: JLt, renderEmpty: ZLt }), qze = Tk.Consumer, QLt = N.createContext(void 0), eRt = QLt, $ze = function(o) {
      return +setTimeout(o, 16);
    }, Xze = function(o) {
      return clearTimeout(o);
    };
    typeof window != "undefined" && "requestAnimationFrame" in window && ($ze = function(o) {
      return window.requestAnimationFrame(o);
    }, Xze = function(o) {
      return window.cancelAnimationFrame(o);
    });
    var Yze = 0, obe = /* @__PURE__ */ new Map();
    function Kze(o) {
      obe.delete(o);
    }
    function Cre(o) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
      Yze += 1;
      var t3 = Yze;
      function c3(p3) {
        if (p3 === 0)
          Kze(t3), o();
        else {
          var g3 = $ze(function() {
            c3(p3 - 1);
          });
          obe.set(t3, g3);
        }
      }
      return c3(i), t3;
    }
    Cre.cancel = function(o) {
      var i = obe.get(o);
      return Kze(i), Xze(i);
    };
    function tRt(o, i) {
      var t3 = i || {}, c3 = t3.defaultValue, p3 = t3.value, g3 = t3.onChange, b3 = t3.postState, w3 = N.useState(function() {
        return p3 !== void 0 ? p3 : c3 !== void 0 ? typeof c3 == "function" ? c3() : c3 : typeof o == "function" ? o() : o;
      }), M = zw(w3, 2), I = M[0], k3 = M[1], L = p3 !== void 0 ? p3 : I;
      b3 && (L = b3(L));
      var F = N.useRef(g3);
      F.current = g3;
      var B = N.useCallback(function(J) {
        k3(J), L !== J && F.current && F.current(J, L);
      }, [L, F]), G = N.useRef(true);
      return N.useEffect(function() {
        if (G.current) {
          G.current = false;
          return;
        }
        p3 === void 0 && k3(p3);
      }, [p3]), [L, B];
    }
    var yl = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(o) {
      var i = o.keyCode;
      if (o.altKey && !o.ctrlKey || o.metaKey || i >= yl.F1 && i <= yl.F12)
        return false;
      switch (i) {
        case yl.ALT:
        case yl.CAPS_LOCK:
        case yl.CONTEXT_MENU:
        case yl.CTRL:
        case yl.DOWN:
        case yl.END:
        case yl.ESC:
        case yl.HOME:
        case yl.INSERT:
        case yl.LEFT:
        case yl.MAC_FF_META:
        case yl.META:
        case yl.NUMLOCK:
        case yl.NUM_CENTER:
        case yl.PAGE_DOWN:
        case yl.PAGE_UP:
        case yl.PAUSE:
        case yl.PRINT_SCREEN:
        case yl.RIGHT:
        case yl.SHIFT:
        case yl.UP:
        case yl.WIN_KEY:
        case yl.WIN_KEY_RIGHT:
          return false;
        default:
          return true;
      }
    }, isCharacterKey: function(o) {
      if (o >= yl.ZERO && o <= yl.NINE || o >= yl.NUM_ZERO && o <= yl.NUM_MULTIPLY || o >= yl.A && o <= yl.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && o === 0)
        return true;
      switch (o) {
        case yl.SPACE:
        case yl.QUESTION_MARK:
        case yl.NUM_PLUS:
        case yl.NUM_MINUS:
        case yl.NUM_PERIOD:
        case yl.NUM_DIVISION:
        case yl.SEMICOLON:
        case yl.DASH:
        case yl.EQUALS:
        case yl.COMMA:
        case yl.PERIOD:
        case yl.SLASH:
        case yl.APOSTROPHE:
        case yl.SINGLE_QUOTE:
        case yl.OPEN_SQUARE_BRACKET:
        case yl.BACKSLASH:
        case yl.CLOSE_SQUARE_BRACKET:
          return true;
        default:
          return false;
      }
    } }, Zze = function() {
      for (var o = arguments.length, i = new Array(o), t3 = 0; t3 < o; t3++)
        i[t3] = arguments[t3];
      return i;
    }, nRt = N.isValidElement;
    function rRt(o, i, t3) {
      return nRt(o) ? N.cloneElement(o, typeof t3 == "function" ? t3(o.props || {}) : t3) : i;
    }
    function iRt(o, i) {
      return rRt(o, o, i);
    }
    var Jze = ["xxl", "xl", "lg", "md", "sm", "xs"], Mre = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, LL = /* @__PURE__ */ new Map(), sbe = -1, Tre = {}, aRt = { matchHandlers: {}, dispatch: function(o) {
      return Tre = o, LL.forEach(function(i) {
        return i(Tre);
      }), LL.size >= 1;
    }, subscribe: function(o) {
      return LL.size || this.register(), sbe += 1, LL.set(sbe, o), o(Tre), sbe;
    }, unsubscribe: function(o) {
      LL.delete(o), LL.size || this.unregister();
    }, unregister: function() {
      var o = this;
      Object.keys(Mre).forEach(function(i) {
        var t3 = Mre[i], c3 = o.matchHandlers[t3];
        c3 == null || c3.mql.removeListener(c3 == null ? void 0 : c3.listener);
      }), LL.clear();
    }, register: function() {
      var o = this;
      Object.keys(Mre).forEach(function(i) {
        var t3 = Mre[i], c3 = function(g3) {
          var b3 = g3.matches;
          o.dispatch(Uv(Uv({}, Tre), Qf({}, i, b3)));
        }, p3 = window.matchMedia(t3);
        p3.addListener(c3), o.matchHandlers[t3] = { mql: p3, listener: c3 }, c3(p3);
      });
    } }, Qze = aRt, oRt = 0, a9 = {};
    function Are(o) {
      var i = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, t3 = oRt++, c3 = i;
      function p3() {
        c3 -= 1, c3 <= 0 ? (o(), delete a9[t3]) : a9[t3] = Cre(p3);
      }
      return a9[t3] = Cre(p3), t3;
    }
    Are.cancel = function(o) {
      o !== void 0 && (Cre.cancel(a9[o]), delete a9[o]);
    }, Are.ids = a9;
    var lbe;
    function eje(o) {
      return !o || o.offsetParent === null || o.hidden;
    }
    function sRt(o) {
      var i = (o || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
      return i && i[1] && i[2] && i[3] ? !(i[1] === i[2] && i[2] === i[3]) : true;
    }
    var tje = function(o) {
      R1e(t3, o);
      var i = F1e(t3);
      function t3() {
        var c3;
        return GW(this, t3), c3 = i.apply(this, arguments), c3.containerRef = N.createRef(), c3.animationStart = false, c3.destroyed = false, c3.onClick = function(p3, g3) {
          var b3, w3, M = c3.props, I = M.insertExtraNode, k3 = M.disabled;
          if (!(k3 || !p3 || eje(p3) || p3.className.indexOf("-leave") >= 0)) {
            c3.extraNode = document.createElement("div");
            var L = N1e(c3), F = L.extraNode, B = c3.context.getPrefixCls;
            F.className = "".concat(B(""), "-click-animating-node");
            var G = c3.getAttributeName();
            if (p3.setAttribute(G, "true"), g3 && g3 !== "#ffffff" && g3 !== "rgb(255, 255, 255)" && sRt(g3) && !/rgba\((?:\d*, ){3}0\)/.test(g3) && g3 !== "transparent") {
              F.style.borderColor = g3;
              var J = ((b3 = p3.getRootNode) === null || b3 === void 0 ? void 0 : b3.call(p3)) || p3.ownerDocument, Q = J instanceof Document ? J.body : (w3 = J.firstChild) !== null && w3 !== void 0 ? w3 : J;
              lbe = hze(`
      [`.concat(B(""), "-click-animating-without-extra-node='true']::after, .").concat(B(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(g3, `;
      }`), "antd-wave", { csp: c3.csp, attachTo: Q });
            }
            I && p3.appendChild(F), ["transition", "animation"].forEach(function(se) {
              p3.addEventListener("".concat(se, "start"), c3.onTransitionStart), p3.addEventListener("".concat(se, "end"), c3.onTransitionEnd);
            });
          }
        }, c3.onTransitionStart = function(p3) {
          if (!c3.destroyed) {
            var g3 = c3.containerRef.current;
            !p3 || p3.target !== g3 || c3.animationStart || c3.resetEffect(g3);
          }
        }, c3.onTransitionEnd = function(p3) {
          !p3 || p3.animationName !== "fadeEffect" || c3.resetEffect(p3.target);
        }, c3.bindAnimationEvent = function(p3) {
          if (!(!p3 || !p3.getAttribute || p3.getAttribute("disabled") || p3.className.indexOf("disabled") >= 0)) {
            var g3 = function(b3) {
              if (!(b3.target.tagName === "INPUT" || eje(b3.target))) {
                c3.resetEffect(p3);
                var w3 = getComputedStyle(p3).getPropertyValue("border-top-color") || getComputedStyle(p3).getPropertyValue("border-color") || getComputedStyle(p3).getPropertyValue("background-color");
                c3.clickWaveTimeoutId = window.setTimeout(function() {
                  return c3.onClick(p3, w3);
                }, 0), Are.cancel(c3.animationStartId), c3.animationStart = true, c3.animationStartId = Are(function() {
                  c3.animationStart = false;
                }, 10);
              }
            };
            return p3.addEventListener("click", g3, true), { cancel: function() {
              p3.removeEventListener("click", g3, true);
            } };
          }
        }, c3.renderWave = function(p3) {
          var g3 = p3.csp, b3 = c3.props.children;
          if (c3.csp = g3, !N.isValidElement(b3))
            return b3;
          var w3 = c3.containerRef;
          return FPt(b3) && (w3 = NPt(b3.ref, c3.containerRef)), iRt(b3, { ref: w3 });
        }, c3;
      }
      return HW(t3, [{ key: "componentDidMount", value: function() {
        var c3 = this.containerRef.current;
        !c3 || c3.nodeType !== 1 || (this.instance = this.bindAnimationEvent(c3));
      } }, { key: "componentWillUnmount", value: function() {
        this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
      } }, { key: "getAttributeName", value: function() {
        var c3 = this.context.getPrefixCls, p3 = this.props.insertExtraNode;
        return p3 ? "".concat(c3(""), "-click-animating") : "".concat(c3(""), "-click-animating-without-extra-node");
      } }, { key: "resetEffect", value: function(c3) {
        var p3 = this;
        if (!(!c3 || c3 === this.extraNode || !(c3 instanceof Element))) {
          var g3 = this.props.insertExtraNode, b3 = this.getAttributeName();
          c3.setAttribute(b3, "false"), lbe && (lbe.innerHTML = ""), g3 && this.extraNode && c3.contains(this.extraNode) && c3.removeChild(this.extraNode), ["transition", "animation"].forEach(function(w3) {
            c3.removeEventListener("".concat(w3, "start"), p3.onTransitionStart), c3.removeEventListener("".concat(w3, "end"), p3.onTransitionEnd);
          });
        }
      } }, { key: "render", value: function() {
        return N.createElement(qze, null, this.renderWave);
      } }]), t3;
    }(N.Component);
    tje.contextType = Tk;
    var ube = { exports: {} }, JW = {};
    /** @license React v17.0.2
    * react-jsx-runtime.production.min.js
    *
    * Copyright (c) Facebook, Inc. and its affiliates.
    *
    * This source code is licensed under the MIT license found in the
    * LICENSE file in the root directory of this source tree.
    */
    var lRt = P.default, nje = 60103;
    if (JW.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
      var rje = Symbol.for;
      nje = rje("react.element"), JW.Fragment = rje("react.fragment");
    }
    var uRt = lRt.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, cRt = Object.prototype.hasOwnProperty, fRt = { key: true, ref: true, __self: true, __source: true };
    function ije(o, i, t3) {
      var c3, p3 = {}, g3 = null, b3 = null;
      t3 !== void 0 && (g3 = "" + t3), i.key !== void 0 && (g3 = "" + i.key), i.ref !== void 0 && (b3 = i.ref);
      for (c3 in i)
        cRt.call(i, c3) && !fRt.hasOwnProperty(c3) && (p3[c3] = i[c3]);
      if (o && o.defaultProps)
        for (c3 in i = o.defaultProps, i)
          p3[c3] === void 0 && (p3[c3] = i[c3]);
      return { $$typeof: nje, type: o, key: g3, ref: b3, props: p3, _owner: uRt.current };
    }
    JW.jsx = ije, JW.jsxs = ije, ube.exports = JW;
    const o9 = ube.exports.jsx, hRt = ube.exports.jsxs;
    var pRt = C.createContext({}), aje = pRt, dRt = function() {
      return uze() && window.document.documentElement;
    }, Ire, vRt = function() {
      if (!dRt())
        return false;
      if (Ire !== void 0)
        return Ire;
      var o = document.createElement("div");
      return o.style.display = "flex", o.style.flexDirection = "column", o.style.rowGap = "1px", o.appendChild(document.createElement("div")), o.appendChild(document.createElement("div")), document.body.appendChild(o), Ire = o.scrollHeight === 1, document.body.removeChild(o), Ire;
    }, gRt = function() {
      var o = N.useState(false), i = zw(o, 2), t3 = i[0], c3 = i[1];
      return N.useEffect(function() {
        c3(vRt());
      }, []), t3;
    }, yRt = globalThis && globalThis.__rest || function(o, i) {
      var t3 = {};
      for (var c3 in o)
        Object.prototype.hasOwnProperty.call(o, c3) && i.indexOf(c3) < 0 && (t3[c3] = o[c3]);
      if (o != null && typeof Object.getOwnPropertySymbols == "function")
        for (var p3 = 0, c3 = Object.getOwnPropertySymbols(o); p3 < c3.length; p3++)
          i.indexOf(c3[p3]) < 0 && Object.prototype.propertyIsEnumerable.call(o, c3[p3]) && (t3[c3[p3]] = o[c3[p3]]);
      return t3;
    };
    Zze("top", "middle", "bottom", "stretch"), Zze("start", "end", "center", "space-around", "space-between");
    var oje = N.forwardRef(function(o, i) {
      var t3, c3 = o.prefixCls, p3 = o.justify, g3 = o.align, b3 = o.className, w3 = o.style, M = o.children, I = o.gutter, k3 = I === void 0 ? 0 : I, L = o.wrap, F = yRt(o, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), B = N.useContext(Tk), G = B.getPrefixCls, J = B.direction, Q = N.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), se = zw(Q, 2), he = se[0], be = se[1], de = gRt(), Fe = N.useRef(k3);
      N.useEffect(function() {
        var ln = Qze.subscribe(function(vn) {
          var kn = Fe.current || 0;
          (!Array.isArray(kn) && Am(kn) === "object" || Array.isArray(kn) && (Am(kn[0]) === "object" || Am(kn[1]) === "object")) && be(vn);
        });
        return function() {
          return Qze.unsubscribe(ln);
        };
      }, []);
      var Pe = function() {
        var ln = [0, 0], vn = Array.isArray(k3) ? k3 : [k3, 0];
        return vn.forEach(function(kn, cr) {
          if (Am(kn) === "object")
            for (var gr = 0; gr < Jze.length; gr++) {
              var ha = Jze[gr];
              if (he[ha] && kn[ha] !== void 0) {
                ln[cr] = kn[ha];
                break;
              }
            }
          else
            ln[cr] = kn || 0;
        }), ln;
      }, ze = G("row", c3), $e = Pe(), Ke = t9(ze, (t3 = {}, Qf(t3, "".concat(ze, "-no-wrap"), L === false), Qf(t3, "".concat(ze, "-").concat(p3), p3), Qf(t3, "".concat(ze, "-").concat(g3), g3), Qf(t3, "".concat(ze, "-rtl"), J === "rtl"), t3), b3), nt = {}, lt2 = $e[0] > 0 ? $e[0] / -2 : void 0, bt = $e[1] > 0 ? $e[1] / -2 : void 0;
      if (lt2 && (nt.marginLeft = lt2, nt.marginRight = lt2), de) {
        var vt = zw($e, 2);
        nt.rowGap = vt[1];
      } else
        bt && (nt.marginTop = bt, nt.marginBottom = bt);
      var jt = zw($e, 2), Jt = jt[0], Rt = jt[1], Jn = N.useMemo(function() {
        return { gutter: [Jt, Rt], wrap: L, supportFlexGap: de };
      }, [Jt, Rt, L, de]);
      return N.createElement(aje.Provider, { value: Jn }, N.createElement("div", Uv({}, F, { className: Ke, style: Uv(Uv({}, nt), w3), ref: i }), M));
    });
    oje.displayName = "Row";
    var mRt = oje, bRt = globalThis && globalThis.__rest || function(o, i) {
      var t3 = {};
      for (var c3 in o)
        Object.prototype.hasOwnProperty.call(o, c3) && i.indexOf(c3) < 0 && (t3[c3] = o[c3]);
      if (o != null && typeof Object.getOwnPropertySymbols == "function")
        for (var p3 = 0, c3 = Object.getOwnPropertySymbols(o); p3 < c3.length; p3++)
          i.indexOf(c3[p3]) < 0 && Object.prototype.propertyIsEnumerable.call(o, c3[p3]) && (t3[c3[p3]] = o[c3[p3]]);
      return t3;
    };
    function _Rt(o) {
      return typeof o == "number" ? "".concat(o, " ").concat(o, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(o) ? "0 0 ".concat(o) : o;
    }
    var xRt = ["xs", "sm", "md", "lg", "xl", "xxl"], sje = N.forwardRef(function(o, i) {
      var t3, c3 = N.useContext(Tk), p3 = c3.getPrefixCls, g3 = c3.direction, b3 = N.useContext(aje), w3 = b3.gutter, M = b3.wrap, I = b3.supportFlexGap, k3 = o.prefixCls, L = o.span, F = o.order, B = o.offset, G = o.push, J = o.pull, Q = o.className, se = o.children, he = o.flex, be = o.style, de = bRt(o, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), Fe = p3("col", k3), Pe = {};
      xRt.forEach(function(lt2) {
        var bt, vt = {}, jt = o[lt2];
        typeof jt == "number" ? vt.span = jt : Am(jt) === "object" && (vt = jt || {}), delete de[lt2], Pe = Uv(Uv({}, Pe), (bt = {}, Qf(bt, "".concat(Fe, "-").concat(lt2, "-").concat(vt.span), vt.span !== void 0), Qf(bt, "".concat(Fe, "-").concat(lt2, "-order-").concat(vt.order), vt.order || vt.order === 0), Qf(bt, "".concat(Fe, "-").concat(lt2, "-offset-").concat(vt.offset), vt.offset || vt.offset === 0), Qf(bt, "".concat(Fe, "-").concat(lt2, "-push-").concat(vt.push), vt.push || vt.push === 0), Qf(bt, "".concat(Fe, "-").concat(lt2, "-pull-").concat(vt.pull), vt.pull || vt.pull === 0), Qf(bt, "".concat(Fe, "-rtl"), g3 === "rtl"), bt));
      });
      var ze = t9(Fe, (t3 = {}, Qf(t3, "".concat(Fe, "-").concat(L), L !== void 0), Qf(t3, "".concat(Fe, "-order-").concat(F), F), Qf(t3, "".concat(Fe, "-offset-").concat(B), B), Qf(t3, "".concat(Fe, "-push-").concat(G), G), Qf(t3, "".concat(Fe, "-pull-").concat(J), J), t3), Q, Pe), $e = {};
      if (w3 && w3[0] > 0) {
        var Ke = w3[0] / 2;
        $e.paddingLeft = Ke, $e.paddingRight = Ke;
      }
      if (w3 && w3[1] > 0 && !I) {
        var nt = w3[1] / 2;
        $e.paddingTop = nt, $e.paddingBottom = nt;
      }
      return he && ($e.flex = _Rt(he), M === false && !$e.minWidth && ($e.minWidth = 0)), N.createElement("div", Uv({}, de, { style: Uv(Uv({}, $e), be), className: ze, ref: i }), se);
    });
    sje.displayName = "Col";
    var wRt = sje, lje = N.forwardRef(function(o, i) {
      var t3, c3 = o.prefixCls, p3 = c3 === void 0 ? "rc-switch" : c3, g3 = o.className, b3 = o.checked, w3 = o.defaultChecked, M = o.disabled, I = o.loadingIcon, k3 = o.checkedChildren, L = o.unCheckedChildren, F = o.onClick, B = o.onChange, G = o.onKeyDown, J = e9(o, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), Q = tRt(false, { value: b3, defaultValue: w3 }), se = zw(Q, 2), he = se[0], be = se[1];
      function de($e, Ke) {
        var nt = he;
        return M || (nt = $e, be(nt), B == null || B(nt, Ke)), nt;
      }
      function Fe($e) {
        $e.which === yl.LEFT ? de(false, $e) : $e.which === yl.RIGHT && de(true, $e), G == null || G($e);
      }
      function Pe($e) {
        var Ke = de(!he, $e);
        F == null || F(Ke, $e);
      }
      var ze = t9(p3, g3, (t3 = {}, Qf(t3, "".concat(p3, "-checked"), he), Qf(t3, "".concat(p3, "-disabled"), M), t3));
      return N.createElement("button", Object.assign({}, J, { type: "button", role: "switch", "aria-checked": he, disabled: M, className: ze, ref: i, onKeyDown: Fe, onClick: Pe }), I, N.createElement("span", { className: "".concat(p3, "-inner") }, he ? k3 : L));
    });
    lje.displayName = "Switch";
    var SRt = globalThis && globalThis.__rest || function(o, i) {
      var t3 = {};
      for (var c3 in o)
        Object.prototype.hasOwnProperty.call(o, c3) && i.indexOf(c3) < 0 && (t3[c3] = o[c3]);
      if (o != null && typeof Object.getOwnPropertySymbols == "function")
        for (var p3 = 0, c3 = Object.getOwnPropertySymbols(o); p3 < c3.length; p3++)
          i.indexOf(c3[p3]) < 0 && Object.prototype.propertyIsEnumerable.call(o, c3[p3]) && (t3[c3[p3]] = o[c3[p3]]);
      return t3;
    }, cbe = N.forwardRef(function(o, i) {
      var t3, c3 = o.prefixCls, p3 = o.size, g3 = o.loading, b3 = o.className, w3 = b3 === void 0 ? "" : b3, M = o.disabled, I = SRt(o, ["prefixCls", "size", "loading", "className", "disabled"]);
      FLt("checked" in I || !("value" in I), "Switch", "`value` is not a valid prop, do you mean `checked`?");
      var k3 = N.useContext(Tk), L = k3.getPrefixCls, F = k3.direction, B = N.useContext(eRt), G = L("switch", c3), J = N.createElement("div", { className: "".concat(G, "-handle") }, g3 && N.createElement(APt, { className: "".concat(G, "-loading-icon") })), Q = t9((t3 = {}, Qf(t3, "".concat(G, "-small"), (p3 || B) === "small"), Qf(t3, "".concat(G, "-loading"), g3), Qf(t3, "".concat(G, "-rtl"), F === "rtl"), t3), w3);
      return N.createElement(tje, { insertExtraNode: true }, N.createElement(lje, Uv({}, I, { prefixCls: G, className: Q, disabled: M || g3, ref: i, loadingIcon: J })));
    });
    cbe.__ANT_SWITCH = true, cbe.displayName = "Switch";
    var CRt = cbe, MRt = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, TRt = {};
    (function(o) {
      var i = Object.defineProperty, t3 = Object.getOwnPropertySymbols, c3 = Object.prototype.hasOwnProperty, p3 = Object.prototype.propertyIsEnumerable, g3 = (s, a, n6) => a in s ? i(s, a, { enumerable: true, configurable: true, writable: true, value: n6 }) : s[a] = n6, b3 = (s, a) => {
        for (var n6 in a || (a = {}))
          c3.call(a, n6) && g3(s, n6, a[n6]);
        if (t3)
          for (var n6 of t3(a))
            p3.call(a, n6) && g3(s, n6, a[n6]);
        return s;
      }, w3 = (s, a, n6) => (g3(s, typeof a != "symbol" ? a + "" : a, n6), n6);
      Object.defineProperties(o, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
      var M = P.default;
      function I(s) {
        return s && typeof s == "object" && "default" in s ? s : { default: s };
      }
      function k3(s) {
        if (s && s.__esModule)
          return s;
        var a = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
        return s && Object.keys(s).forEach(function(n6) {
          if (n6 !== "default") {
            var f6 = Object.getOwnPropertyDescriptor(s, n6);
            Object.defineProperty(a, n6, f6.get ? f6 : { enumerable: true, get: function() {
              return s[n6];
            } });
          }
        }), a.default = s, Object.freeze(a);
      }
      var L = I(M), F = k3(M), B = globalThis && globalThis.__read || function(s, a) {
        var n6 = typeof Symbol == "function" && s[Symbol.iterator];
        if (!n6)
          return s;
        var f6 = n6.call(s), d4, y4 = [], _;
        try {
          for (; (a === void 0 || a-- > 0) && !(d4 = f6.next()).done; )
            y4.push(d4.value);
        } catch (S) {
          _ = { error: S };
        } finally {
          try {
            d4 && !d4.done && (n6 = f6.return) && n6.call(f6);
          } finally {
            if (_)
              throw _.error;
          }
        }
        return y4;
      };
      function G(s, a) {
        s === void 0 && (s = false);
        var n6 = B(M.useState(s), 2), f6 = n6[0], d4 = n6[1], y4 = M.useMemo(function() {
          var _ = a === void 0 ? !s : a, S = function() {
            return d4(function(R) {
              return R === s ? _ : s;
            });
          }, T = function(R) {
            return d4(R);
          }, E = function() {
            return d4(s);
          }, O = function() {
            return d4(_);
          };
          return { toggle: S, set: T, setLeft: E, setRight: O };
        }, []);
        return [f6, y4];
      }
      var J = globalThis && globalThis.__read || function(s, a) {
        var n6 = typeof Symbol == "function" && s[Symbol.iterator];
        if (!n6)
          return s;
        var f6 = n6.call(s), d4, y4 = [], _;
        try {
          for (; (a === void 0 || a-- > 0) && !(d4 = f6.next()).done; )
            y4.push(d4.value);
        } catch (S) {
          _ = { error: S };
        } finally {
          try {
            d4 && !d4.done && (n6 = f6.return) && n6.call(f6);
          } finally {
            if (_)
              throw _.error;
          }
        }
        return y4;
      };
      function Q(s) {
        s === void 0 && (s = false);
        var a = J(G(s), 2), n6 = a[0], f6 = a[1], d4 = f6.toggle, y4 = f6.set, _ = M.useMemo(function() {
          var S = function() {
            return y4(true);
          }, T = function() {
            return y4(false);
          };
          return { toggle: d4, set: function(E) {
            return y4(!!E);
          }, setTrue: S, setFalse: T };
        }, []);
        return [n6, _];
      }
      function se(s) {
        var a = M.useRef(s);
        return a.current = s, a;
      }
      var he = !!(typeof window != "undefined" && window.document && window.document.createElement), be = he;
      function de(s, a) {
        if (be) {
          if (!s)
            return a;
          var n6;
          return typeof s == "function" ? n6 = s() : "current" in s ? n6 = s.current : n6 = s, n6;
        }
      }
      var Fe = function(s) {
        var a = se(s);
        M.useEffect(function() {
          return function() {
            a.current();
          };
        }, []);
      }, Pe = Fe;
      function ze(s, a) {
        if (s === a)
          return true;
        for (var n6 = 0; n6 < s.length; n6++)
          if (!Object.is(s[n6], a[n6]))
            return false;
        return true;
      }
      var $e = function(s) {
        var a = function(n6, f6, d4) {
          var y4 = M.useRef(false), _ = M.useRef([]), S = M.useRef([]), T = M.useRef();
          s(function() {
            var E, O = Array.isArray(d4) ? d4 : [d4], R = O.map(function(V) {
              return de(V);
            });
            if (!y4.current) {
              y4.current = true, _.current = R, S.current = f6, T.current = n6();
              return;
            }
            (R.length !== _.current.length || !ze(R, _.current) || !ze(f6, S.current)) && ((E = T.current) === null || E === void 0 || E.call(T), _.current = R, S.current = f6, T.current = n6());
          }), Pe(function() {
            var E;
            (E = T.current) === null || E === void 0 || E.call(T), y4.current = false;
          });
        };
        return a;
      }, Ke = $e, nt = Ke(M.useEffect), lt2 = nt, bt = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof _t != "undefined" ? _t : typeof self != "undefined" ? self : {};
      function vt(s) {
        return s && s.__esModule && Object.prototype.hasOwnProperty.call(s, "default") ? s.default : s;
      }
      function jt(s) {
        var a = typeof s;
        return s != null && (a == "object" || a == "function");
      }
      var Jt = jt, Rt = typeof bt == "object" && bt && bt.Object === Object && bt, Jn = Rt, ln = Jn, vn = typeof self == "object" && self && self.Object === Object && self, kn = ln || vn || Function("return this")(), cr = kn, gr = cr, ha = function() {
        return gr.Date.now();
      }, Ka = ha, Do = /\s/;
      function _o(s) {
        for (var a = s.length; a-- && Do.test(s.charAt(a)); )
          ;
        return a;
      }
      var xo = _o, Ra = xo, ho = /^\s+/;
      function Mo(s) {
        return s && s.slice(0, Ra(s) + 1).replace(ho, "");
      }
      var Xa = Mo, Zo = cr, rc = Zo.Symbol, ys = rc, Vu = ys, gc = Object.prototype, ef = gc.hasOwnProperty, dv = gc.toString, Wf = Vu ? Vu.toStringTag : void 0;
      function Ag(s) {
        var a = ef.call(s, Wf), n6 = s[Wf];
        try {
          s[Wf] = void 0;
          var f6 = true;
        } catch {
        }
        var d4 = dv.call(s);
        return f6 && (a ? s[Wf] = n6 : delete s[Wf]), d4;
      }
      var eh = Ag, _p = Object.prototype, ap = _p.toString;
      function Hw(s) {
        return ap.call(s);
      }
      var Ji = Hw, Jr = ys, Xr = eh, ta = Ji, co = "[object Null]", cs = "[object Undefined]", nu = Jr ? Jr.toStringTag : void 0;
      function ru(s) {
        return s == null ? s === void 0 ? cs : co : nu && nu in Object(s) ? Xr(s) : ta(s);
      }
      var hf = ru;
      function op(s) {
        return s != null && typeof s == "object";
      }
      var _h = op, wd = hf, xh = _h, m0 = "[object Symbol]";
      function Sy(s) {
        return typeof s == "symbol" || xh(s) && wd(s) == m0;
      }
      var Ob = Sy, Cy = Xa, Gp = Jt, yc = Ob, Xd = 0 / 0, Ig = /^[-+]0x[0-9a-f]+$/i, Pb = /^0b[01]+$/i, Em = /^0o[0-7]+$/i, My = parseInt;
      function z1(s) {
        if (typeof s == "number")
          return s;
        if (yc(s))
          return Xd;
        if (Gp(s)) {
          var a = typeof s.valueOf == "function" ? s.valueOf() : s;
          s = Gp(a) ? a + "" : a;
        }
        if (typeof s != "string")
          return s === 0 ? s : +s;
        s = Cy(s);
        var n6 = Pb.test(s);
        return n6 || Em.test(s) ? My(s.slice(2), n6 ? 2 : 8) : Ig.test(s) ? Xd : +s;
      }
      var oT = z1, Q2 = Jt, RL = Ka, eC = oT, QW = "Expected a function", eU = Math.max, tU = Math.min;
      function nU(s, a, n6) {
        var f6, d4, y4, _, S, T, E = 0, O = false, R = false, V = true;
        if (typeof s != "function")
          throw new TypeError(QW);
        a = eC(a) || 0, Q2(n6) && (O = !!n6.leading, R = "maxWait" in n6, y4 = R ? eU(eC(n6.maxWait) || 0, a) : y4, V = "trailing" in n6 ? !!n6.trailing : V);
        function z3(Le) {
          var je = f6, Xe = d4;
          return f6 = d4 = void 0, E = Le, _ = s.apply(Xe, je), _;
        }
        function H(Le) {
          return E = Le, S = setTimeout(oe, a), O ? z3(Le) : _;
        }
        function Z(Le) {
          var je = Le - T, Xe = Le - E, Ye = a - je;
          return R ? tU(Ye, y4 - Xe) : Ye;
        }
        function ee(Le) {
          var je = Le - T, Xe = Le - E;
          return T === void 0 || je >= a || je < 0 || R && Xe >= y4;
        }
        function oe() {
          var Le = RL();
          if (ee(Le))
            return fe(Le);
          S = setTimeout(oe, Z(Le));
        }
        function fe(Le) {
          return S = void 0, V && f6 ? z3(Le) : (f6 = d4 = void 0, _);
        }
        function _e() {
          S !== void 0 && clearTimeout(S), E = 0, f6 = T = d4 = S = void 0;
        }
        function pe() {
          return S === void 0 ? _ : fe(RL());
        }
        function Ve() {
          var Le = RL(), je = ee(Le);
          if (f6 = arguments, d4 = this, T = Le, je) {
            if (S === void 0)
              return H(T);
            if (R)
              return clearTimeout(S), S = setTimeout(oe, a), z3(T);
          }
          return S === void 0 && (S = setTimeout(oe, a)), _;
        }
        return Ve.cancel = _e, Ve.flush = pe, Ve;
      }
      var Ak = nU, In = globalThis && globalThis.__read || function(s, a) {
        var n6 = typeof Symbol == "function" && s[Symbol.iterator];
        if (!n6)
          return s;
        var f6 = n6.call(s), d4, y4 = [], _;
        try {
          for (; (a === void 0 || a-- > 0) && !(d4 = f6.next()).done; )
            y4.push(d4.value);
        } catch (S) {
          _ = { error: S };
        } finally {
          try {
            d4 && !d4.done && (n6 = f6.return) && n6.call(f6);
          } finally {
            if (_)
              throw _.error;
          }
        }
        return y4;
      }, Nn = globalThis && globalThis.__spread || function() {
        for (var s = [], a = 0; a < arguments.length; a++)
          s = s.concat(In(arguments[a]));
        return s;
      };
      function Yt(s, a) {
        var n6, f6 = se(s), d4 = (n6 = a == null ? void 0 : a.wait) !== null && n6 !== void 0 ? n6 : 1e3, y4 = M.useMemo(function() {
          return Ak(function() {
            for (var _ = [], S = 0; S < arguments.length; S++)
              _[S] = arguments[S];
            return f6.current.apply(f6, Nn(_));
          }, d4, a);
        }, []);
        return Pe(function() {
          y4.cancel();
        }), { run: y4, cancel: y4.cancel, flush: y4.flush };
      }
      function _n(s, a, n6) {
        n6 === void 0 && (n6 = {});
        var f6 = se(a);
        lt2(function() {
          var d4 = de(n6.target, window);
          if (d4 != null && d4.addEventListener) {
            var y4 = function(_) {
              return f6.current(_);
            };
            return d4.addEventListener(s, y4, { capture: n6.capture, once: n6.once, passive: n6.passive }), function() {
              d4.removeEventListener(s, y4, { capture: n6.capture });
            };
          }
        }, [s, n6.capture, n6.once, n6.passive], n6.target);
      }
      /*! *****************************************************************************
      Copyright (c) Microsoft Corporation.
      
      Permission to use, copy, modify, and/or distribute this software for any
      purpose with or without fee is hereby granted.
      
      THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
      REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
      AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
      INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
      LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
      OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
      PERFORMANCE OF THIS SOFTWARE.
      ***************************************************************************** */
      var Cn = function(s, a) {
        return Cn = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(n6, f6) {
          n6.__proto__ = f6;
        } || function(n6, f6) {
          for (var d4 in f6)
            Object.prototype.hasOwnProperty.call(f6, d4) && (n6[d4] = f6[d4]);
        }, Cn(s, a);
      };
      function Vt(s, a) {
        if (typeof a != "function" && a !== null)
          throw new TypeError("Class extends value " + String(a) + " is not a constructor or null");
        Cn(s, a);
        function n6() {
          this.constructor = s;
        }
        s.prototype = a === null ? Object.create(a) : (n6.prototype = a.prototype, new n6());
      }
      var Gi = function() {
        function s() {
          this.firefox = false, this.ie = false, this.edge = false, this.newEdge = false, this.weChat = false;
        }
        return s;
      }(), wi = function() {
        function s() {
          this.browser = new Gi(), this.node = false, this.wxa = false, this.worker = false, this.svgSupported = false, this.touchEventsSupported = false, this.pointerEventsSupported = false, this.domSupported = false, this.transformSupported = false, this.transform3dSupported = false, this.hasGlobalWindow = typeof window != "undefined";
        }
        return s;
      }(), pr = new wi();
      typeof wx == "object" && typeof wx.getSystemInfoSync == "function" ? (pr.wxa = true, pr.touchEventsSupported = true) : typeof document == "undefined" && typeof self != "undefined" ? pr.worker = true : typeof navigator == "undefined" ? (pr.node = true, pr.svgSupported = true) : Ma(navigator.userAgent, pr);
      function Ma(s, a) {
        var n6 = a.browser, f6 = s.match(/Firefox\/([\d.]+)/), d4 = s.match(/MSIE\s([\d.]+)/) || s.match(/Trident\/.+?rv:(([\d.]+))/), y4 = s.match(/Edge?\/([\d.]+)/), _ = /micromessenger/i.test(s);
        f6 && (n6.firefox = true, n6.version = f6[1]), d4 && (n6.ie = true, n6.version = d4[1]), y4 && (n6.edge = true, n6.version = y4[1], n6.newEdge = +y4[1].split(".")[0] > 18), _ && (n6.weChat = true), a.svgSupported = typeof SVGRect != "undefined", a.touchEventsSupported = "ontouchstart" in window && !n6.ie && !n6.edge, a.pointerEventsSupported = "onpointerdown" in window && (n6.edge || n6.ie && +n6.version >= 11), a.domSupported = typeof document != "undefined";
        var S = document.documentElement.style;
        a.transform3dSupported = (n6.ie && "transition" in S || n6.edge || "WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix() || "MozPerspective" in S) && !("OTransition" in S), a.transformSupported = a.transform3dSupported || n6.ie && +n6.version >= 9;
      }
      var Na = pr, fu = 12, ic = "sans-serif", mc = fu + "px " + ic, _u = 20, kf = 100, xp = "007LLmW'55;N0500LLLLLLLLLL00NNNLzWW\\\\WQb\\0FWLg\\bWb\\WQ\\WrWWQ000CL5LLFLL0LL**F*gLLLL5F0LF\\FFF5.5N";
      function Al(s) {
        var a = {};
        if (typeof JSON == "undefined")
          return a;
        for (var n6 = 0; n6 < s.length; n6++) {
          var f6 = String.fromCharCode(n6 + 32), d4 = (s.charCodeAt(n6) - _u) / kf;
          a[f6] = d4;
        }
        return a;
      }
      var Sd = Al(xp), td = { createCanvas: function() {
        return typeof document != "undefined" && document.createElement("canvas");
      }, measureText: function() {
        var s, a;
        return function(n6, f6) {
          if (!s) {
            var d4 = td.createCanvas();
            s = d4 && d4.getContext("2d");
          }
          if (s)
            return a !== f6 && (a = s.font = f6 || mc), s.measureText(n6);
          n6 = n6 || "", f6 = f6 || mc;
          var y4 = /^([0-9]*?)px$/.exec(f6), _ = +(y4 && y4[1]) || fu, S = 0;
          if (f6.indexOf("mono") >= 0)
            S = _ * n6.length;
          else
            for (var T = 0; T < n6.length; T++) {
              var E = Sd[n6[T]];
              S += E == null ? _ : E * _;
            }
          return { width: S };
        };
      }(), loadImage: function(s, a, n6) {
        var f6 = new Image();
        return f6.onload = a, f6.onerror = n6, f6.src = s, f6;
      } }, Lb = G_(["Function", "RegExp", "Date", "Error", "CanvasGradient", "CanvasPattern", "Image", "Canvas"], function(s, a) {
        return s["[object " + a + "]"] = true, s;
      }, {}), qI = G_(["Int8", "Uint8", "Uint8Clamped", "Int16", "Uint16", "Int32", "Uint32", "Float32", "Float64"], function(s, a) {
        return s["[object " + a + "Array]"] = true, s;
      }, {}), b0 = Object.prototype.toString, Ww = Array.prototype, tC = Ww.forEach, vv = Ww.filter, Rb = Ww.slice, $I = Ww.map, Uw = function() {
      }.constructor, qw = Uw ? Uw.prototype : null, nC = "__proto__", NL = 2311;
      function XI() {
        return NL++;
      }
      function sT() {
        for (var s = [], a = 0; a < arguments.length; a++)
          s[a] = arguments[a];
        typeof console != "undefined" && console.error.apply(console, s);
      }
      function Bo(s) {
        if (s == null || typeof s != "object")
          return s;
        var a = s, n6 = b0.call(s);
        if (n6 === "[object Array]") {
          if (!Ik(s)) {
            a = [];
            for (var f6 = 0, d4 = s.length; f6 < d4; f6++)
              a[f6] = Bo(s[f6]);
          }
        } else if (qI[n6]) {
          if (!Ik(s)) {
            var y4 = s.constructor;
            if (y4.from)
              a = y4.from(s);
            else {
              a = new y4(s.length);
              for (var f6 = 0, d4 = s.length; f6 < d4; f6++)
                a[f6] = s[f6];
            }
          }
        } else if (!Lb[n6] && !Ik(s) && !VL(s)) {
          a = {};
          for (var _ in s)
            s.hasOwnProperty(_) && _ !== nC && (a[_] = Bo(s[_]));
        }
        return a;
      }
      function Ms(s, a, n6) {
        if (!Qo(a) || !Qo(s))
          return n6 ? Bo(a) : s;
        for (var f6 in a)
          if (a.hasOwnProperty(f6) && f6 !== nC) {
            var d4 = s[f6], y4 = a[f6];
            Qo(y4) && Qo(d4) && !Di(y4) && !Di(d4) && !VL(y4) && !VL(d4) && !Dre(y4) && !Dre(d4) && !Ik(y4) && !Ik(d4) ? Ms(d4, y4, n6) : (n6 || !(f6 in s)) && (s[f6] = Bo(a[f6]));
          }
        return s;
      }
      function YI(s, a) {
        for (var n6 = s[0], f6 = 1, d4 = s.length; f6 < d4; f6++)
          n6 = Ms(n6, s[f6], a);
        return n6;
      }
      function ei(s, a) {
        if (Object.assign)
          Object.assign(s, a);
        else
          for (var n6 in a)
            a.hasOwnProperty(n6) && n6 !== nC && (s[n6] = a[n6]);
        return s;
      }
      function zo(s, a, n6) {
        for (var f6 = Wl(a), d4 = 0; d4 < f6.length; d4++) {
          var y4 = f6[d4];
          (n6 ? a[y4] != null : s[y4] == null) && (s[y4] = a[y4]);
        }
        return s;
      }
      function Ns(s, a) {
        if (s) {
          if (s.indexOf)
            return s.indexOf(a);
          for (var n6 = 0, f6 = s.length; n6 < f6; n6++)
            if (s[n6] === a)
              return n6;
        }
        return -1;
      }
      function Ere(s, a) {
        var n6 = s.prototype;
        function f6() {
        }
        f6.prototype = a.prototype, s.prototype = new f6();
        for (var d4 in n6)
          n6.hasOwnProperty(d4) && (s.prototype[d4] = n6[d4]);
        s.prototype.constructor = s, s.superClass = a;
      }
      function nd(s, a, n6) {
        if (s = "prototype" in s ? s.prototype : s, a = "prototype" in a ? a.prototype : a, Object.getOwnPropertyNames)
          for (var f6 = Object.getOwnPropertyNames(a), d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            y4 !== "constructor" && (n6 ? a[y4] != null : s[y4] == null) && (s[y4] = a[y4]);
          }
        else
          zo(s, a, n6);
      }
      function _0(s) {
        return !s || typeof s == "string" ? false : typeof s.length == "number";
      }
      function gt(s, a, n6) {
        if (s && a)
          if (s.forEach && s.forEach === tC)
            s.forEach(a, n6);
          else if (s.length === +s.length)
            for (var f6 = 0, d4 = s.length; f6 < d4; f6++)
              a.call(n6, s[f6], f6, s);
          else
            for (var y4 in s)
              s.hasOwnProperty(y4) && a.call(n6, s[y4], y4, s);
      }
      function Pi(s, a, n6) {
        if (!s)
          return [];
        if (!a)
          return rU(s);
        if (s.map && s.map === $I)
          return s.map(a, n6);
        for (var f6 = [], d4 = 0, y4 = s.length; d4 < y4; d4++)
          f6.push(a.call(n6, s[d4], d4, s));
        return f6;
      }
      function G_(s, a, n6, f6) {
        if (s && a) {
          for (var d4 = 0, y4 = s.length; d4 < y4; d4++)
            n6 = a.call(f6, n6, s[d4], d4, s);
          return n6;
        }
      }
      function tf(s, a, n6) {
        if (!s)
          return [];
        if (!a)
          return rU(s);
        if (s.filter && s.filter === vv)
          return s.filter(a, n6);
        for (var f6 = [], d4 = 0, y4 = s.length; d4 < y4; d4++)
          a.call(n6, s[d4], d4, s) && f6.push(s[d4]);
        return f6;
      }
      function fbe(s, a, n6) {
        if (s && a) {
          for (var f6 = 0, d4 = s.length; f6 < d4; f6++)
            if (a.call(n6, s[f6], f6, s))
              return s[f6];
        }
      }
      function Wl(s) {
        if (!s)
          return [];
        if (Object.keys)
          return Object.keys(s);
        var a = [];
        for (var n6 in s)
          s.hasOwnProperty(n6) && a.push(n6);
        return a;
      }
      function hbe(s, a) {
        for (var n6 = [], f6 = 2; f6 < arguments.length; f6++)
          n6[f6 - 2] = arguments[f6];
        return function() {
          return s.apply(a, n6.concat(Rb.call(arguments)));
        };
      }
      var Za = qw && jo(qw.bind) ? qw.call.bind(qw.bind) : hbe;
      function ks(s) {
        for (var a = [], n6 = 1; n6 < arguments.length; n6++)
          a[n6 - 1] = arguments[n6];
        return function() {
          return s.apply(this, a.concat(Rb.call(arguments)));
        };
      }
      function Di(s) {
        return Array.isArray ? Array.isArray(s) : b0.call(s) === "[object Array]";
      }
      function jo(s) {
        return typeof s == "function";
      }
      function Wa(s) {
        return typeof s == "string";
      }
      function FL(s) {
        return b0.call(s) === "[object String]";
      }
      function ac(s) {
        return typeof s == "number";
      }
      function Qo(s) {
        var a = typeof s;
        return a === "function" || !!s && a === "object";
      }
      function Dre(s) {
        return !!Lb[b0.call(s)];
      }
      function j1(s) {
        return !!qI[b0.call(s)];
      }
      function VL(s) {
        return typeof s == "object" && typeof s.nodeType == "number" && typeof s.ownerDocument == "object";
      }
      function th(s) {
        return s.colorStops != null;
      }
      function qh(s) {
        return s.image != null;
      }
      function pbe(s) {
        return b0.call(s) === "[object RegExp]";
      }
      function BL(s) {
        return s !== s;
      }
      function $v() {
        for (var s = [], a = 0; a < arguments.length; a++)
          s[a] = arguments[a];
        for (var n6 = 0, f6 = s.length; n6 < f6; n6++)
          if (s[n6] != null)
            return s[n6];
      }
      function Zs(s, a) {
        return s != null ? s : a;
      }
      function rC(s, a, n6) {
        return s != null ? s : a != null ? a : n6;
      }
      function rU(s) {
        for (var a = [], n6 = 1; n6 < arguments.length; n6++)
          a[n6 - 1] = arguments[n6];
        return Rb.apply(s, a);
      }
      function s9(s) {
        if (typeof s == "number")
          return [s, s, s, s];
        var a = s.length;
        return a === 2 ? [s[0], s[1], s[0], s[1]] : a === 3 ? [s[0], s[1], s[2], s[1]] : s;
      }
      function Ty(s, a) {
        if (!s)
          throw new Error(a);
      }
      function wh(s) {
        return s == null ? null : typeof s.trim == "function" ? s.trim() : s.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, "");
      }
      var l9 = "__ec_primitive__";
      function $w(s) {
        s[l9] = true;
      }
      function Ik(s) {
        return s[l9];
      }
      var iU = function() {
        function s(a) {
          this.data = {};
          var n6 = Di(a);
          this.data = {};
          var f6 = this;
          a instanceof s ? a.each(d4) : a && gt(a, d4);
          function d4(y4, _) {
            n6 ? f6.set(y4, _) : f6.set(_, y4);
          }
        }
        return s.prototype.get = function(a) {
          return this.data.hasOwnProperty(a) ? this.data[a] : null;
        }, s.prototype.set = function(a, n6) {
          return this.data[a] = n6;
        }, s.prototype.each = function(a, n6) {
          for (var f6 in this.data)
            this.data.hasOwnProperty(f6) && a.call(n6, this.data[f6], f6);
        }, s.prototype.keys = function() {
          return Wl(this.data);
        }, s.prototype.removeKey = function(a) {
          delete this.data[a];
        }, s;
      }();
      function ro(s) {
        return new iU(s);
      }
      function u9(s, a) {
        for (var n6 = new s.constructor(s.length + a.length), f6 = 0; f6 < s.length; f6++)
          n6[f6] = s[f6];
        for (var d4 = s.length, f6 = 0; f6 < a.length; f6++)
          n6[f6 + d4] = a[f6];
        return n6;
      }
      function zL(s, a) {
        var n6;
        if (Object.create)
          n6 = Object.create(s);
        else {
          var f6 = function() {
          };
          f6.prototype = s, n6 = new f6();
        }
        return a && ei(n6, a), n6;
      }
      function aU(s) {
        var a = s.style;
        a.webkitUserSelect = "none", a.userSelect = "none", a.webkitTapHighlightColor = "rgba(0,0,0,0)", a["-webkit-touch-callout"] = "none";
      }
      function io(s, a) {
        return s.hasOwnProperty(a);
      }
      function rd() {
      }
      var jL = 180 / Math.PI;
      function gv(s, a) {
        return s == null && (s = 0), a == null && (a = 0), [s, a];
      }
      function Ay(s, a) {
        return s[0] = a[0], s[1] = a[1], s;
      }
      function Yd(s) {
        return [s[0], s[1]];
      }
      function dbe(s, a, n6) {
        return s[0] = a, s[1] = n6, s;
      }
      function oU(s, a, n6) {
        return s[0] = a[0] + n6[0], s[1] = a[1] + n6[1], s;
      }
      function Xw(s, a, n6, f6) {
        return s[0] = a[0] + n6[0] * f6, s[1] = a[1] + n6[1] * f6, s;
      }
      function Yw(s, a, n6) {
        return s[0] = a[0] - n6[0], s[1] = a[1] - n6[1], s;
      }
      function GL(s) {
        return Math.sqrt(wp(s));
      }
      function wp(s) {
        return s[0] * s[0] + s[1] * s[1];
      }
      function Kw(s, a, n6) {
        return s[0] = a[0] * n6, s[1] = a[1] * n6, s;
      }
      function KI(s, a) {
        var n6 = GL(a);
        return n6 === 0 ? (s[0] = 0, s[1] = 0) : (s[0] = a[0] / n6, s[1] = a[1] / n6), s;
      }
      function sU(s, a) {
        return Math.sqrt((s[0] - a[0]) * (s[0] - a[0]) + (s[1] - a[1]) * (s[1] - a[1]));
      }
      var Zw = sU;
      function vbe(s, a) {
        return (s[0] - a[0]) * (s[0] - a[0]) + (s[1] - a[1]) * (s[1] - a[1]);
      }
      var ZI = vbe;
      function c9(s, a, n6, f6) {
        return s[0] = a[0] + f6 * (n6[0] - a[0]), s[1] = a[1] + f6 * (n6[1] - a[1]), s;
      }
      function Xv(s, a, n6) {
        var f6 = a[0], d4 = a[1];
        return s[0] = n6[0] * f6 + n6[2] * d4 + n6[4], s[1] = n6[1] * f6 + n6[3] * d4 + n6[5], s;
      }
      function H_(s, a, n6) {
        return s[0] = Math.min(a[0], n6[0]), s[1] = Math.min(a[1], n6[1]), s;
      }
      function G1(s, a, n6) {
        return s[0] = Math.max(a[0], n6[0]), s[1] = Math.max(a[1], n6[1]), s;
      }
      var Ek = function() {
        function s(a, n6) {
          this.target = a, this.topTarget = n6 && n6.topTarget;
        }
        return s;
      }(), kre = function() {
        function s(a) {
          this.handler = a, a.on("mousedown", this._dragStart, this), a.on("mousemove", this._drag, this), a.on("mouseup", this._dragEnd, this);
        }
        return s.prototype._dragStart = function(a) {
          for (var n6 = a.target; n6 && !n6.draggable; )
            n6 = n6.parent || n6.__hostTarget;
          n6 && (this._draggingTarget = n6, n6.dragging = true, this._x = a.offsetX, this._y = a.offsetY, this.handler.dispatchToElement(new Ek(n6, a), "dragstart", a.event));
        }, s.prototype._drag = function(a) {
          var n6 = this._draggingTarget;
          if (n6) {
            var f6 = a.offsetX, d4 = a.offsetY, y4 = f6 - this._x, _ = d4 - this._y;
            this._x = f6, this._y = d4, n6.drift(y4, _, a), this.handler.dispatchToElement(new Ek(n6, a), "drag", a.event);
            var S = this.handler.findHover(f6, d4, n6).target, T = this._dropTarget;
            this._dropTarget = S, n6 !== S && (T && S !== T && this.handler.dispatchToElement(new Ek(T, a), "dragleave", a.event), S && S !== T && this.handler.dispatchToElement(new Ek(S, a), "dragenter", a.event));
          }
        }, s.prototype._dragEnd = function(a) {
          var n6 = this._draggingTarget;
          n6 && (n6.dragging = false), this.handler.dispatchToElement(new Ek(n6, a), "dragend", a.event), this._dropTarget && this.handler.dispatchToElement(new Ek(this._dropTarget, a), "drop", a.event), this._draggingTarget = null, this._dropTarget = null;
        }, s;
      }(), Ore = kre, lU = function() {
        function s(a) {
          a && (this._$eventProcessor = a);
        }
        return s.prototype.on = function(a, n6, f6, d4) {
          this._$handlers || (this._$handlers = {});
          var y4 = this._$handlers;
          if (typeof n6 == "function" && (d4 = f6, f6 = n6, n6 = null), !f6 || !a)
            return this;
          var _ = this._$eventProcessor;
          n6 != null && _ && _.normalizeQuery && (n6 = _.normalizeQuery(n6)), y4[a] || (y4[a] = []);
          for (var S = 0; S < y4[a].length; S++)
            if (y4[a][S].h === f6)
              return this;
          var T = { h: f6, query: n6, ctx: d4 || this, callAtLast: f6.zrEventfulCallAtLast }, E = y4[a].length - 1, O = y4[a][E];
          return O && O.callAtLast ? y4[a].splice(E, 0, T) : y4[a].push(T), this;
        }, s.prototype.isSilent = function(a) {
          var n6 = this._$handlers;
          return !n6 || !n6[a] || !n6[a].length;
        }, s.prototype.off = function(a, n6) {
          var f6 = this._$handlers;
          if (!f6)
            return this;
          if (!a)
            return this._$handlers = {}, this;
          if (n6) {
            if (f6[a]) {
              for (var d4 = [], y4 = 0, _ = f6[a].length; y4 < _; y4++)
                f6[a][y4].h !== n6 && d4.push(f6[a][y4]);
              f6[a] = d4;
            }
            f6[a] && f6[a].length === 0 && delete f6[a];
          } else
            delete f6[a];
          return this;
        }, s.prototype.trigger = function(a) {
          for (var n6 = [], f6 = 1; f6 < arguments.length; f6++)
            n6[f6 - 1] = arguments[f6];
          if (!this._$handlers)
            return this;
          var d4 = this._$handlers[a], y4 = this._$eventProcessor;
          if (d4)
            for (var _ = n6.length, S = d4.length, T = 0; T < S; T++) {
              var E = d4[T];
              if (!(y4 && y4.filter && E.query != null && !y4.filter(a, E.query)))
                switch (_) {
                  case 0:
                    E.h.call(E.ctx);
                    break;
                  case 1:
                    E.h.call(E.ctx, n6[0]);
                    break;
                  case 2:
                    E.h.call(E.ctx, n6[0], n6[1]);
                    break;
                  default:
                    E.h.apply(E.ctx, n6);
                    break;
                }
            }
          return y4 && y4.afterTrigger && y4.afterTrigger(a), this;
        }, s.prototype.triggerWithContext = function(a) {
          for (var n6 = [], f6 = 1; f6 < arguments.length; f6++)
            n6[f6 - 1] = arguments[f6];
          if (!this._$handlers)
            return this;
          var d4 = this._$handlers[a], y4 = this._$eventProcessor;
          if (d4)
            for (var _ = n6.length, S = n6[_ - 1], T = d4.length, E = 0; E < T; E++) {
              var O = d4[E];
              if (!(y4 && y4.filter && O.query != null && !y4.filter(a, O.query)))
                switch (_) {
                  case 0:
                    O.h.call(S);
                    break;
                  case 1:
                    O.h.call(S, n6[0]);
                    break;
                  case 2:
                    O.h.call(S, n6[0], n6[1]);
                    break;
                  default:
                    O.h.apply(S, n6.slice(1, _ - 1));
                    break;
                }
            }
          return y4 && y4.afterTrigger && y4.afterTrigger(a), this;
        }, s;
      }(), Dm = lU, Pre = Math.log(2);
      function uU(s, a, n6, f6, d4, y4) {
        var _ = f6 + "-" + d4, S = s.length;
        if (y4.hasOwnProperty(_))
          return y4[_];
        if (a === 1) {
          var T = Math.round(Math.log((1 << S) - 1 & ~d4) / Pre);
          return s[n6][T];
        }
        for (var E = f6 | 1 << n6, O = n6 + 1; f6 & 1 << O; )
          O++;
        for (var R = 0, V = 0, z3 = 0; V < S; V++) {
          var H = 1 << V;
          H & d4 || (R += (z3 % 2 ? -1 : 1) * s[n6][V] * uU(s, a - 1, O, E, d4 | H, y4), z3++);
        }
        return y4[_] = R, R;
      }
      function f9(s, a) {
        var n6 = [[s[0], s[1], 1, 0, 0, 0, -a[0] * s[0], -a[0] * s[1]], [0, 0, 0, s[0], s[1], 1, -a[1] * s[0], -a[1] * s[1]], [s[2], s[3], 1, 0, 0, 0, -a[2] * s[2], -a[2] * s[3]], [0, 0, 0, s[2], s[3], 1, -a[3] * s[2], -a[3] * s[3]], [s[4], s[5], 1, 0, 0, 0, -a[4] * s[4], -a[4] * s[5]], [0, 0, 0, s[4], s[5], 1, -a[5] * s[4], -a[5] * s[5]], [s[6], s[7], 1, 0, 0, 0, -a[6] * s[6], -a[6] * s[7]], [0, 0, 0, s[6], s[7], 1, -a[7] * s[6], -a[7] * s[7]]], f6 = {}, d4 = uU(n6, 8, 0, 0, 0, f6);
        if (d4 !== 0) {
          for (var y4 = [], _ = 0; _ < 8; _++)
            for (var S = 0; S < 8; S++)
              y4[S] == null && (y4[S] = 0), y4[S] += ((_ + S) % 2 ? -1 : 1) * uU(n6, 7, _ === 0 ? 1 : 0, 1 << _, 1 << S, f6) / d4 * a[_];
          return function(T, E, O) {
            var R = E * y4[6] + O * y4[7] + 1;
            T[0] = (E * y4[0] + O * y4[1] + y4[2]) / R, T[1] = (E * y4[3] + O * y4[4] + y4[5]) / R;
          };
        }
      }
      var h9 = "___zrEVENTSAVED", cU = [];
      function Lre(s, a, n6, f6, d4) {
        return Iy(cU, a, f6, d4, true) && Iy(s, n6, cU[0], cU[1]);
      }
      function Iy(s, a, n6, f6, d4) {
        if (a.getBoundingClientRect && Na.domSupported && !hU(a)) {
          var y4 = a[h9] || (a[h9] = {}), _ = fU(a, y4), S = HL(_, y4, d4);
          if (S)
            return S(s, n6, f6), true;
        }
        return false;
      }
      function fU(s, a) {
        var n6 = a.markers;
        if (n6)
          return n6;
        n6 = a.markers = [];
        for (var f6 = ["left", "right"], d4 = ["top", "bottom"], y4 = 0; y4 < 4; y4++) {
          var _ = document.createElement("div"), S = _.style, T = y4 % 2, E = (y4 >> 1) % 2;
          S.cssText = ["position: absolute", "visibility: hidden", "padding: 0", "margin: 0", "border-width: 0", "user-select: none", "width:0", "height:0", f6[T] + ":0", d4[E] + ":0", f6[1 - T] + ":auto", d4[1 - E] + ":auto", ""].join("!important;"), s.appendChild(_), n6.push(_);
        }
        return n6;
      }
      function HL(s, a, n6) {
        for (var f6 = n6 ? "invTrans" : "trans", d4 = a[f6], y4 = a.srcCoords, _ = [], S = [], T = true, E = 0; E < 4; E++) {
          var O = s[E].getBoundingClientRect(), R = 2 * E, V = O.left, z3 = O.top;
          _.push(V, z3), T = T && y4 && V === y4[R] && z3 === y4[R + 1], S.push(s[E].offsetLeft, s[E].offsetTop);
        }
        return T && d4 ? d4 : (a.srcCoords = _, a[f6] = n6 ? f9(S, _) : f9(_, S));
      }
      function hU(s) {
        return s.nodeName.toUpperCase() === "CANVAS";
      }
      var Rre = /^(?:mouse|pointer|contextmenu|drag|drop)|click/, pU = [], gbe = Na.browser.firefox && +Na.browser.version.split(".")[0] < 39;
      function dU(s, a, n6, f6) {
        return n6 = n6 || {}, f6 ? Nre(s, a, n6) : gbe && a.layerX != null && a.layerX !== a.offsetX ? (n6.zrX = a.layerX, n6.zrY = a.layerY) : a.offsetX != null ? (n6.zrX = a.offsetX, n6.zrY = a.offsetY) : Nre(s, a, n6), n6;
      }
      function Nre(s, a, n6) {
        if (Na.domSupported && s.getBoundingClientRect) {
          var f6 = a.clientX, d4 = a.clientY;
          if (hU(s)) {
            var y4 = s.getBoundingClientRect();
            n6.zrX = f6 - y4.left, n6.zrY = d4 - y4.top;
            return;
          } else if (Iy(pU, s, f6, d4)) {
            n6.zrX = pU[0], n6.zrY = pU[1];
            return;
          }
        }
        n6.zrX = n6.zrY = 0;
      }
      function vU(s) {
        return s || window.event;
      }
      function Eg(s, a, n6) {
        if (a = vU(a), a.zrX != null)
          return a;
        var f6 = a.type, d4 = f6 && f6.indexOf("touch") >= 0;
        if (d4) {
          var y4 = f6 !== "touchend" ? a.targetTouches[0] : a.changedTouches[0];
          y4 && dU(s, y4, a, n6);
        } else {
          dU(s, a, a, n6);
          var _ = ybe(a);
          a.zrDelta = _ ? _ / 120 : -(a.detail || 0) / 3;
        }
        var S = a.button;
        return a.which == null && S !== void 0 && Rre.test(a.type) && (a.which = S & 1 ? 1 : S & 2 ? 3 : S & 4 ? 2 : 0), a;
      }
      function ybe(s) {
        var a = s.wheelDelta;
        if (a)
          return a;
        var n6 = s.deltaX, f6 = s.deltaY;
        if (n6 == null || f6 == null)
          return a;
        var d4 = Math.abs(f6 !== 0 ? f6 : n6), y4 = f6 > 0 ? -1 : f6 < 0 ? 1 : n6 > 0 ? -1 : 1;
        return 3 * d4 * y4;
      }
      function gU(s, a, n6, f6) {
        s.addEventListener(a, n6, f6);
      }
      function yU(s, a, n6, f6) {
        s.removeEventListener(a, n6, f6);
      }
      var Jw = function(s) {
        s.preventDefault(), s.stopPropagation(), s.cancelBubble = true;
      };
      function iC(s) {
        return s.which === 2 || s.which === 3;
      }
      var p9 = function() {
        function s() {
          this._track = [];
        }
        return s.prototype.recognize = function(a, n6, f6) {
          return this._doTrack(a, n6, f6), this._recognize(a);
        }, s.prototype.clear = function() {
          return this._track.length = 0, this;
        }, s.prototype._doTrack = function(a, n6, f6) {
          var d4 = a.touches;
          if (d4) {
            for (var y4 = { points: [], touches: [], target: n6, event: a }, _ = 0, S = d4.length; _ < S; _++) {
              var T = d4[_], E = dU(f6, T, {});
              y4.points.push([E.zrX, E.zrY]), y4.touches.push(T);
            }
            this._track.push(y4);
          }
        }, s.prototype._recognize = function(a) {
          for (var n6 in mU)
            if (mU.hasOwnProperty(n6)) {
              var f6 = mU[n6](this._track, a);
              if (f6)
                return f6;
            }
        }, s;
      }();
      function Fre(s) {
        var a = s[1][0] - s[0][0], n6 = s[1][1] - s[0][1];
        return Math.sqrt(a * a + n6 * n6);
      }
      function mbe(s) {
        return [(s[0][0] + s[1][0]) / 2, (s[0][1] + s[1][1]) / 2];
      }
      var mU = { pinch: function(s, a) {
        var n6 = s.length;
        if (n6) {
          var f6 = (s[n6 - 1] || {}).points, d4 = (s[n6 - 2] || {}).points || f6;
          if (d4 && d4.length > 1 && f6 && f6.length > 1) {
            var y4 = Fre(f6) / Fre(d4);
            !isFinite(y4) && (y4 = 1), a.pinchScale = y4;
            var _ = mbe(f6);
            return a.pinchX = _[0], a.pinchY = _[1], { type: "pinch", target: s[0].target, event: a };
          }
        }
      } }, JI = "silent";
      function W_(s, a, n6) {
        return { type: s, event: n6, target: a.target, topTarget: a.topTarget, cancelBubble: false, offsetX: n6.zrX, offsetY: n6.zrY, gestureEvent: n6.gestureEvent, pinchX: n6.pinchX, pinchY: n6.pinchY, pinchScale: n6.pinchScale, wheelDelta: n6.zrDelta, zrByTouch: n6.zrByTouch, which: n6.which, stop: Vre };
      }
      function Vre() {
        Jw(this.event);
      }
      var bbe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.handler = null, n6;
        }
        return a.prototype.dispose = function() {
        }, a.prototype.setCursor = function() {
        }, a;
      }(Dm), WL = function() {
        function s(a, n6) {
          this.x = a, this.y = n6;
        }
        return s;
      }(), _be = ["click", "dblclick", "mousewheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], Bre = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4) {
          var _ = s.call(this) || this;
          return _._hovered = new WL(0, 0), _.storage = n6, _.painter = f6, _.painterRoot = y4, d4 = d4 || new bbe(), _.proxy = null, _.setHandlerProxy(d4), _._draggingMgr = new Ore(_), _;
        }
        return a.prototype.setHandlerProxy = function(n6) {
          this.proxy && this.proxy.dispose(), n6 && (gt(_be, function(f6) {
            n6.on && n6.on(f6, this[f6], this);
          }, this), n6.handler = this), this.proxy = n6;
        }, a.prototype.mousemove = function(n6) {
          var f6 = n6.zrX, d4 = n6.zrY, y4 = QI(this, f6, d4), _ = this._hovered, S = _.target;
          S && !S.__zr && (_ = this.findHover(_.x, _.y), S = _.target);
          var T = this._hovered = y4 ? new WL(f6, d4) : this.findHover(f6, d4), E = T.target, O = this.proxy;
          O.setCursor && O.setCursor(E ? E.cursor : "default"), S && E !== S && this.dispatchToElement(_, "mouseout", n6), this.dispatchToElement(T, "mousemove", n6), E && E !== S && this.dispatchToElement(T, "mouseover", n6);
        }, a.prototype.mouseout = function(n6) {
          var f6 = n6.zrEventControl;
          f6 !== "only_globalout" && this.dispatchToElement(this._hovered, "mouseout", n6), f6 !== "no_globalout" && this.trigger("globalout", { type: "globalout", event: n6 });
        }, a.prototype.resize = function() {
          this._hovered = new WL(0, 0);
        }, a.prototype.dispatch = function(n6, f6) {
          var d4 = this[n6];
          d4 && d4.call(this, f6);
        }, a.prototype.dispose = function() {
          this.proxy.dispose(), this.storage = null, this.proxy = null, this.painter = null;
        }, a.prototype.setCursorStyle = function(n6) {
          var f6 = this.proxy;
          f6.setCursor && f6.setCursor(n6);
        }, a.prototype.dispatchToElement = function(n6, f6, d4) {
          n6 = n6 || {};
          var y4 = n6.target;
          if (!(y4 && y4.silent)) {
            for (var _ = "on" + f6, S = W_(f6, n6, d4); y4 && (y4[_] && (S.cancelBubble = !!y4[_].call(y4, S)), y4.trigger(f6, S), y4 = y4.__hostTarget ? y4.__hostTarget : y4.parent, !S.cancelBubble); )
              ;
            S.cancelBubble || (this.trigger(f6, S), this.painter && this.painter.eachOtherLayer && this.painter.eachOtherLayer(function(T) {
              typeof T[_] == "function" && T[_].call(T, S), T.trigger && T.trigger(f6, S);
            }));
          }
        }, a.prototype.findHover = function(n6, f6, d4) {
          for (var y4 = this.storage.getDisplayList(), _ = new WL(n6, f6), S = y4.length - 1; S >= 0; S--) {
            var T = void 0;
            if (y4[S] !== d4 && !y4[S].ignore && (T = xbe(y4[S], n6, f6)) && (!_.topTarget && (_.topTarget = y4[S]), T !== JI)) {
              _.target = y4[S];
              break;
            }
          }
          return _;
        }, a.prototype.processGesture = function(n6, f6) {
          this._gestureMgr || (this._gestureMgr = new p9());
          var d4 = this._gestureMgr;
          f6 === "start" && d4.clear();
          var y4 = d4.recognize(n6, this.findHover(n6.zrX, n6.zrY, null).target, this.proxy.dom);
          if (f6 === "end" && d4.clear(), y4) {
            var _ = y4.type;
            n6.gestureEvent = _;
            var S = new WL();
            S.target = y4.target, this.dispatchToElement(S, _, y4.event);
          }
        }, a;
      }(Dm);
      gt(["click", "mousedown", "mouseup", "mousewheel", "dblclick", "contextmenu"], function(s) {
        Bre.prototype[s] = function(a) {
          var n6 = a.zrX, f6 = a.zrY, d4 = QI(this, n6, f6), y4, _;
          if ((s !== "mouseup" || !d4) && (y4 = this.findHover(n6, f6), _ = y4.target), s === "mousedown")
            this._downEl = _, this._downPoint = [a.zrX, a.zrY], this._upEl = _;
          else if (s === "mouseup")
            this._upEl = _;
          else if (s === "click") {
            if (this._downEl !== this._upEl || !this._downPoint || Zw(this._downPoint, [a.zrX, a.zrY]) > 4)
              return;
            this._downPoint = null;
          }
          this.dispatchToElement(y4, s, a);
        };
      });
      function xbe(s, a, n6) {
        if (s[s.rectHover ? "rectContain" : "contain"](a, n6)) {
          for (var f6 = s, d4 = void 0, y4 = false; f6; ) {
            if (f6.ignoreClip && (y4 = true), !y4) {
              var _ = f6.getClipPath();
              if (_ && !_.contain(a, n6))
                return false;
              f6.silent && (d4 = true);
            }
            var S = f6.__hostTarget;
            f6 = S || f6.parent;
          }
          return d4 ? JI : true;
        }
        return false;
      }
      function QI(s, a, n6) {
        var f6 = s.painter;
        return a < 0 || a > f6.getWidth() || n6 < 0 || n6 > f6.getHeight();
      }
      var _r = Bre, Ui = 32, oi = 7;
      function es(s) {
        for (var a = 0; s >= Ui; )
          a |= s & 1, s >>= 1;
        return s + a;
      }
      function Vl(s, a, n6, f6) {
        var d4 = a + 1;
        if (d4 === n6)
          return 1;
        if (f6(s[d4++], s[a]) < 0) {
          for (; d4 < n6 && f6(s[d4], s[d4 - 1]) < 0; )
            d4++;
          wf(s, a, d4);
        } else
          for (; d4 < n6 && f6(s[d4], s[d4 - 1]) >= 0; )
            d4++;
        return d4 - a;
      }
      function wf(s, a, n6) {
        for (n6--; a < n6; ) {
          var f6 = s[a];
          s[a++] = s[n6], s[n6--] = f6;
        }
      }
      function Kd(s, a, n6, f6, d4) {
        for (f6 === a && f6++; f6 < n6; f6++) {
          for (var y4 = s[f6], _ = a, S = f6, T; _ < S; )
            T = _ + S >>> 1, d4(y4, s[T]) < 0 ? S = T : _ = T + 1;
          var E = f6 - _;
          switch (E) {
            case 3:
              s[_ + 3] = s[_ + 2];
            case 2:
              s[_ + 2] = s[_ + 1];
            case 1:
              s[_ + 1] = s[_];
              break;
            default:
              for (; E > 0; )
                s[_ + E] = s[_ + E - 1], E--;
          }
          s[_] = y4;
        }
      }
      function Uf(s, a, n6, f6, d4, y4) {
        var _ = 0, S = 0, T = 1;
        if (y4(s, a[n6 + d4]) > 0) {
          for (S = f6 - d4; T < S && y4(s, a[n6 + d4 + T]) > 0; )
            _ = T, T = (T << 1) + 1, T <= 0 && (T = S);
          T > S && (T = S), _ += d4, T += d4;
        } else {
          for (S = d4 + 1; T < S && y4(s, a[n6 + d4 - T]) <= 0; )
            _ = T, T = (T << 1) + 1, T <= 0 && (T = S);
          T > S && (T = S);
          var E = _;
          _ = d4 - T, T = d4 - E;
        }
        for (_++; _ < T; ) {
          var O = _ + (T - _ >>> 1);
          y4(s, a[n6 + O]) > 0 ? _ = O + 1 : T = O;
        }
        return T;
      }
      function UL(s, a, n6, f6, d4, y4) {
        var _ = 0, S = 0, T = 1;
        if (y4(s, a[n6 + d4]) < 0) {
          for (S = d4 + 1; T < S && y4(s, a[n6 + d4 - T]) < 0; )
            _ = T, T = (T << 1) + 1, T <= 0 && (T = S);
          T > S && (T = S);
          var E = _;
          _ = d4 - T, T = d4 - E;
        } else {
          for (S = f6 - d4; T < S && y4(s, a[n6 + d4 + T]) >= 0; )
            _ = T, T = (T << 1) + 1, T <= 0 && (T = S);
          T > S && (T = S), _ += d4, T += d4;
        }
        for (_++; _ < T; ) {
          var O = _ + (T - _ >>> 1);
          y4(s, a[n6 + O]) < 0 ? T = O : _ = O + 1;
        }
        return T;
      }
      function wbe(s, a) {
        var n6 = oi, f6, d4, y4 = 0, _ = [];
        f6 = [], d4 = [];
        function S(z3, H) {
          f6[y4] = z3, d4[y4] = H, y4 += 1;
        }
        function T() {
          for (; y4 > 1; ) {
            var z3 = y4 - 2;
            if (z3 >= 1 && d4[z3 - 1] <= d4[z3] + d4[z3 + 1] || z3 >= 2 && d4[z3 - 2] <= d4[z3] + d4[z3 - 1])
              d4[z3 - 1] < d4[z3 + 1] && z3--;
            else if (d4[z3] > d4[z3 + 1])
              break;
            O(z3);
          }
        }
        function E() {
          for (; y4 > 1; ) {
            var z3 = y4 - 2;
            z3 > 0 && d4[z3 - 1] < d4[z3 + 1] && z3--, O(z3);
          }
        }
        function O(z3) {
          var H = f6[z3], Z = d4[z3], ee = f6[z3 + 1], oe = d4[z3 + 1];
          d4[z3] = Z + oe, z3 === y4 - 3 && (f6[z3 + 1] = f6[z3 + 2], d4[z3 + 1] = d4[z3 + 2]), y4--;
          var fe = UL(s[ee], s, H, Z, 0, a);
          H += fe, Z -= fe, Z !== 0 && (oe = Uf(s[H + Z - 1], s, ee, oe, oe - 1, a), oe !== 0 && (Z <= oe ? R(H, Z, ee, oe) : V(H, Z, ee, oe)));
        }
        function R(z3, H, Z, ee) {
          var oe = 0;
          for (oe = 0; oe < H; oe++)
            _[oe] = s[z3 + oe];
          var fe = 0, _e = Z, pe = z3;
          if (s[pe++] = s[_e++], --ee === 0) {
            for (oe = 0; oe < H; oe++)
              s[pe + oe] = _[fe + oe];
            return;
          }
          if (H === 1) {
            for (oe = 0; oe < ee; oe++)
              s[pe + oe] = s[_e + oe];
            s[pe + ee] = _[fe];
            return;
          }
          for (var Ve = n6, Le, je, Xe; ; ) {
            Le = 0, je = 0, Xe = false;
            do
              if (a(s[_e], _[fe]) < 0) {
                if (s[pe++] = s[_e++], je++, Le = 0, --ee === 0) {
                  Xe = true;
                  break;
                }
              } else if (s[pe++] = _[fe++], Le++, je = 0, --H === 1) {
                Xe = true;
                break;
              }
            while ((Le | je) < Ve);
            if (Xe)
              break;
            do {
              if (Le = UL(s[_e], _, fe, H, 0, a), Le !== 0) {
                for (oe = 0; oe < Le; oe++)
                  s[pe + oe] = _[fe + oe];
                if (pe += Le, fe += Le, H -= Le, H <= 1) {
                  Xe = true;
                  break;
                }
              }
              if (s[pe++] = s[_e++], --ee === 0) {
                Xe = true;
                break;
              }
              if (je = Uf(_[fe], s, _e, ee, 0, a), je !== 0) {
                for (oe = 0; oe < je; oe++)
                  s[pe + oe] = s[_e + oe];
                if (pe += je, _e += je, ee -= je, ee === 0) {
                  Xe = true;
                  break;
                }
              }
              if (s[pe++] = _[fe++], --H === 1) {
                Xe = true;
                break;
              }
              Ve--;
            } while (Le >= oi || je >= oi);
            if (Xe)
              break;
            Ve < 0 && (Ve = 0), Ve += 2;
          }
          if (n6 = Ve, n6 < 1 && (n6 = 1), H === 1) {
            for (oe = 0; oe < ee; oe++)
              s[pe + oe] = s[_e + oe];
            s[pe + ee] = _[fe];
          } else {
            if (H === 0)
              throw new Error();
            for (oe = 0; oe < H; oe++)
              s[pe + oe] = _[fe + oe];
          }
        }
        function V(z3, H, Z, ee) {
          var oe = 0;
          for (oe = 0; oe < ee; oe++)
            _[oe] = s[Z + oe];
          var fe = z3 + H - 1, _e = ee - 1, pe = Z + ee - 1, Ve = 0, Le = 0;
          if (s[pe--] = s[fe--], --H === 0) {
            for (Ve = pe - (ee - 1), oe = 0; oe < ee; oe++)
              s[Ve + oe] = _[oe];
            return;
          }
          if (ee === 1) {
            for (pe -= H, fe -= H, Le = pe + 1, Ve = fe + 1, oe = H - 1; oe >= 0; oe--)
              s[Le + oe] = s[Ve + oe];
            s[pe] = _[_e];
            return;
          }
          for (var je = n6; ; ) {
            var Xe = 0, Ye = 0, rt2 = false;
            do
              if (a(_[_e], s[fe]) < 0) {
                if (s[pe--] = s[fe--], Xe++, Ye = 0, --H === 0) {
                  rt2 = true;
                  break;
                }
              } else if (s[pe--] = _[_e--], Ye++, Xe = 0, --ee === 1) {
                rt2 = true;
                break;
              }
            while ((Xe | Ye) < je);
            if (rt2)
              break;
            do {
              if (Xe = H - UL(_[_e], s, z3, H, H - 1, a), Xe !== 0) {
                for (pe -= Xe, fe -= Xe, H -= Xe, Le = pe + 1, Ve = fe + 1, oe = Xe - 1; oe >= 0; oe--)
                  s[Le + oe] = s[Ve + oe];
                if (H === 0) {
                  rt2 = true;
                  break;
                }
              }
              if (s[pe--] = _[_e--], --ee === 1) {
                rt2 = true;
                break;
              }
              if (Ye = ee - Uf(s[fe], _, 0, ee, ee - 1, a), Ye !== 0) {
                for (pe -= Ye, _e -= Ye, ee -= Ye, Le = pe + 1, Ve = _e + 1, oe = 0; oe < Ye; oe++)
                  s[Le + oe] = _[Ve + oe];
                if (ee <= 1) {
                  rt2 = true;
                  break;
                }
              }
              if (s[pe--] = s[fe--], --H === 0) {
                rt2 = true;
                break;
              }
              je--;
            } while (Xe >= oi || Ye >= oi);
            if (rt2)
              break;
            je < 0 && (je = 0), je += 2;
          }
          if (n6 = je, n6 < 1 && (n6 = 1), ee === 1) {
            for (pe -= H, fe -= H, Le = pe + 1, Ve = fe + 1, oe = H - 1; oe >= 0; oe--)
              s[Le + oe] = s[Ve + oe];
            s[pe] = _[_e];
          } else {
            if (ee === 0)
              throw new Error();
            for (Ve = pe - (ee - 1), oe = 0; oe < ee; oe++)
              s[Ve + oe] = _[oe];
          }
        }
        return { mergeRuns: T, forceMergeRuns: E, pushRun: S };
      }
      function Ey(s, a, n6, f6) {
        n6 || (n6 = 0), f6 || (f6 = s.length);
        var d4 = f6 - n6;
        if (!(d4 < 2)) {
          var y4 = 0;
          if (d4 < Ui) {
            y4 = Vl(s, n6, f6, a), Kd(s, n6, f6, n6 + y4, a);
            return;
          }
          var _ = wbe(s, a), S = es(d4);
          do {
            if (y4 = Vl(s, n6, f6, a), y4 < S) {
              var T = d4;
              T > S && (T = S), Kd(s, n6, n6 + T, n6 + y4, a), y4 = T;
            }
            _.pushRun(n6, y4), _.mergeRuns(), d4 -= y4, n6 += y4;
          } while (d4 !== 0);
          _.forceMergeRuns();
        }
      }
      var x0 = 1, qL = 2, U_ = 4, $L = false;
      function Dk() {
        $L || ($L = true, console.warn("z / z2 / zlevel of displayable is invalid, which may cause unexpected errors"));
      }
      function Of(s, a) {
        return s.zlevel === a.zlevel ? s.z === a.z ? s.z2 - a.z2 : s.z - a.z : s.zlevel - a.zlevel;
      }
      var Sbe = function() {
        function s() {
          this._roots = [], this._displayList = [], this._displayListLen = 0, this.displayableSortFunc = Of;
        }
        return s.prototype.traverse = function(a, n6) {
          for (var f6 = 0; f6 < this._roots.length; f6++)
            this._roots[f6].traverse(a, n6);
        }, s.prototype.getDisplayList = function(a, n6) {
          n6 = n6 || false;
          var f6 = this._displayList;
          return (a || !f6.length) && this.updateDisplayList(n6), f6;
        }, s.prototype.updateDisplayList = function(a) {
          this._displayListLen = 0;
          for (var n6 = this._roots, f6 = this._displayList, d4 = 0, y4 = n6.length; d4 < y4; d4++)
            this._updateAndAddDisplayable(n6[d4], null, a);
          f6.length = this._displayListLen, Ey(f6, Of);
        }, s.prototype._updateAndAddDisplayable = function(a, n6, f6) {
          if (!(a.ignore && !f6)) {
            a.beforeUpdate(), a.update(), a.afterUpdate();
            var d4 = a.getClipPath();
            if (a.ignoreClip)
              n6 = null;
            else if (d4) {
              n6 ? n6 = n6.slice() : n6 = [];
              for (var y4 = d4, _ = a; y4; )
                y4.parent = _, y4.updateTransform(), n6.push(y4), _ = y4, y4 = y4.getClipPath();
            }
            if (a.childrenRef) {
              for (var S = a.childrenRef(), T = 0; T < S.length; T++) {
                var E = S[T];
                a.__dirty && (E.__dirty |= x0), this._updateAndAddDisplayable(E, n6, f6);
              }
              a.__dirty = 0;
            } else {
              var O = a;
              n6 && n6.length ? O.__clipPaths = n6 : O.__clipPaths && O.__clipPaths.length > 0 && (O.__clipPaths = []), isNaN(O.z) && (Dk(), O.z = 0), isNaN(O.z2) && (Dk(), O.z2 = 0), isNaN(O.zlevel) && (Dk(), O.zlevel = 0), this._displayList[this._displayListLen++] = O;
            }
            var R = a.getDecalElement && a.getDecalElement();
            R && this._updateAndAddDisplayable(R, n6, f6);
            var V = a.getTextGuideLine();
            V && this._updateAndAddDisplayable(V, n6, f6);
            var z3 = a.getTextContent();
            z3 && this._updateAndAddDisplayable(z3, n6, f6);
          }
        }, s.prototype.addRoot = function(a) {
          a.__zr && a.__zr.storage === this || this._roots.push(a);
        }, s.prototype.delRoot = function(a) {
          if (a instanceof Array) {
            for (var n6 = 0, f6 = a.length; n6 < f6; n6++)
              this.delRoot(a[n6]);
            return;
          }
          var d4 = Ns(this._roots, a);
          d4 >= 0 && this._roots.splice(d4, 1);
        }, s.prototype.delAllRoots = function() {
          this._roots = [], this._displayList = [], this._displayListLen = 0;
        }, s.prototype.getRoots = function() {
          return this._roots;
        }, s.prototype.dispose = function() {
          this._displayList = null, this._roots = null;
        }, s;
      }(), zre = Sbe, XL;
      XL = Na.hasGlobalWindow && (window.requestAnimationFrame && window.requestAnimationFrame.bind(window) || window.msRequestAnimationFrame && window.msRequestAnimationFrame.bind(window) || window.mozRequestAnimationFrame || window.webkitRequestAnimationFrame) || function(s) {
        return setTimeout(s, 16);
      };
      var bU = XL, d9 = { linear: function(s) {
        return s;
      }, quadraticIn: function(s) {
        return s * s;
      }, quadraticOut: function(s) {
        return s * (2 - s);
      }, quadraticInOut: function(s) {
        return (s *= 2) < 1 ? 0.5 * s * s : -0.5 * (--s * (s - 2) - 1);
      }, cubicIn: function(s) {
        return s * s * s;
      }, cubicOut: function(s) {
        return --s * s * s + 1;
      }, cubicInOut: function(s) {
        return (s *= 2) < 1 ? 0.5 * s * s * s : 0.5 * ((s -= 2) * s * s + 2);
      }, quarticIn: function(s) {
        return s * s * s * s;
      }, quarticOut: function(s) {
        return 1 - --s * s * s * s;
      }, quarticInOut: function(s) {
        return (s *= 2) < 1 ? 0.5 * s * s * s * s : -0.5 * ((s -= 2) * s * s * s - 2);
      }, quinticIn: function(s) {
        return s * s * s * s * s;
      }, quinticOut: function(s) {
        return --s * s * s * s * s + 1;
      }, quinticInOut: function(s) {
        return (s *= 2) < 1 ? 0.5 * s * s * s * s * s : 0.5 * ((s -= 2) * s * s * s * s + 2);
      }, sinusoidalIn: function(s) {
        return 1 - Math.cos(s * Math.PI / 2);
      }, sinusoidalOut: function(s) {
        return Math.sin(s * Math.PI / 2);
      }, sinusoidalInOut: function(s) {
        return 0.5 * (1 - Math.cos(Math.PI * s));
      }, exponentialIn: function(s) {
        return s === 0 ? 0 : Math.pow(1024, s - 1);
      }, exponentialOut: function(s) {
        return s === 1 ? 1 : 1 - Math.pow(2, -10 * s);
      }, exponentialInOut: function(s) {
        return s === 0 ? 0 : s === 1 ? 1 : (s *= 2) < 1 ? 0.5 * Math.pow(1024, s - 1) : 0.5 * (-Math.pow(2, -10 * (s - 1)) + 2);
      }, circularIn: function(s) {
        return 1 - Math.sqrt(1 - s * s);
      }, circularOut: function(s) {
        return Math.sqrt(1 - --s * s);
      }, circularInOut: function(s) {
        return (s *= 2) < 1 ? -0.5 * (Math.sqrt(1 - s * s) - 1) : 0.5 * (Math.sqrt(1 - (s -= 2) * s) + 1);
      }, elasticIn: function(s) {
        var a, n6 = 0.1, f6 = 0.4;
        return s === 0 ? 0 : s === 1 ? 1 : (!n6 || n6 < 1 ? (n6 = 1, a = f6 / 4) : a = f6 * Math.asin(1 / n6) / (2 * Math.PI), -(n6 * Math.pow(2, 10 * (s -= 1)) * Math.sin((s - a) * (2 * Math.PI) / f6)));
      }, elasticOut: function(s) {
        var a, n6 = 0.1, f6 = 0.4;
        return s === 0 ? 0 : s === 1 ? 1 : (!n6 || n6 < 1 ? (n6 = 1, a = f6 / 4) : a = f6 * Math.asin(1 / n6) / (2 * Math.PI), n6 * Math.pow(2, -10 * s) * Math.sin((s - a) * (2 * Math.PI) / f6) + 1);
      }, elasticInOut: function(s) {
        var a, n6 = 0.1, f6 = 0.4;
        return s === 0 ? 0 : s === 1 ? 1 : (!n6 || n6 < 1 ? (n6 = 1, a = f6 / 4) : a = f6 * Math.asin(1 / n6) / (2 * Math.PI), (s *= 2) < 1 ? -0.5 * (n6 * Math.pow(2, 10 * (s -= 1)) * Math.sin((s - a) * (2 * Math.PI) / f6)) : n6 * Math.pow(2, -10 * (s -= 1)) * Math.sin((s - a) * (2 * Math.PI) / f6) * 0.5 + 1);
      }, backIn: function(s) {
        var a = 1.70158;
        return s * s * ((a + 1) * s - a);
      }, backOut: function(s) {
        var a = 1.70158;
        return --s * s * ((a + 1) * s + a) + 1;
      }, backInOut: function(s) {
        var a = 2.5949095;
        return (s *= 2) < 1 ? 0.5 * (s * s * ((a + 1) * s - a)) : 0.5 * ((s -= 2) * s * ((a + 1) * s + a) + 2);
      }, bounceIn: function(s) {
        return 1 - d9.bounceOut(1 - s);
      }, bounceOut: function(s) {
        return s < 1 / 2.75 ? 7.5625 * s * s : s < 2 / 2.75 ? 7.5625 * (s -= 1.5 / 2.75) * s + 0.75 : s < 2.5 / 2.75 ? 7.5625 * (s -= 2.25 / 2.75) * s + 0.9375 : 7.5625 * (s -= 2.625 / 2.75) * s + 0.984375;
      }, bounceInOut: function(s) {
        return s < 0.5 ? d9.bounceIn(s * 2) * 0.5 : d9.bounceOut(s * 2 - 1) * 0.5 + 0.5;
      } }, jre = d9, eE = Math.pow, Dy = Math.sqrt, tE = 1e-8, _U = 1e-4, YL = Dy(3), KL = 1 / 3, q_ = gv(), ky = gv(), nE = gv();
      function Nb(s) {
        return s > -tE && s < tE;
      }
      function lT(s) {
        return s > tE || s < -tE;
      }
      function id2(s, a, n6, f6, d4) {
        var y4 = 1 - d4;
        return y4 * y4 * (y4 * s + 3 * d4 * a) + d4 * d4 * (d4 * f6 + 3 * y4 * n6);
      }
      function Gre(s, a, n6, f6, d4) {
        var y4 = 1 - d4;
        return 3 * (((a - s) * y4 + 2 * (n6 - a) * d4) * y4 + (f6 - n6) * d4 * d4);
      }
      function v9(s, a, n6, f6, d4, y4) {
        var _ = f6 + 3 * (a - n6) - s, S = 3 * (n6 - a * 2 + s), T = 3 * (a - s), E = s - d4, O = S * S - 3 * _ * T, R = S * T - 9 * _ * E, V = T * T - 3 * S * E, z3 = 0;
        if (Nb(O) && Nb(R))
          if (Nb(S))
            y4[0] = 0;
          else {
            var H = -T / S;
            H >= 0 && H <= 1 && (y4[z3++] = H);
          }
        else {
          var Z = R * R - 4 * O * V;
          if (Nb(Z)) {
            var ee = R / O, H = -S / _ + ee, oe = -ee / 2;
            H >= 0 && H <= 1 && (y4[z3++] = H), oe >= 0 && oe <= 1 && (y4[z3++] = oe);
          } else if (Z > 0) {
            var fe = Dy(Z), _e = O * S + 1.5 * _ * (-R + fe), pe = O * S + 1.5 * _ * (-R - fe);
            _e < 0 ? _e = -eE(-_e, KL) : _e = eE(_e, KL), pe < 0 ? pe = -eE(-pe, KL) : pe = eE(pe, KL);
            var H = (-S - (_e + pe)) / (3 * _);
            H >= 0 && H <= 1 && (y4[z3++] = H);
          } else {
            var Ve = (2 * O * S - 3 * _ * R) / (2 * Dy(O * O * O)), Le = Math.acos(Ve) / 3, je = Dy(O), Xe = Math.cos(Le), H = (-S - 2 * je * Xe) / (3 * _), oe = (-S + je * (Xe + YL * Math.sin(Le))) / (3 * _), Ye = (-S + je * (Xe - YL * Math.sin(Le))) / (3 * _);
            H >= 0 && H <= 1 && (y4[z3++] = H), oe >= 0 && oe <= 1 && (y4[z3++] = oe), Ye >= 0 && Ye <= 1 && (y4[z3++] = Ye);
          }
        }
        return z3;
      }
      function Hre(s, a, n6, f6, d4) {
        var y4 = 6 * n6 - 12 * a + 6 * s, _ = 9 * a + 3 * f6 - 3 * s - 9 * n6, S = 3 * a - 3 * s, T = 0;
        if (Nb(_)) {
          if (lT(y4)) {
            var E = -S / y4;
            E >= 0 && E <= 1 && (d4[T++] = E);
          }
        } else {
          var O = y4 * y4 - 4 * _ * S;
          if (Nb(O))
            d4[0] = -y4 / (2 * _);
          else if (O > 0) {
            var R = Dy(O), E = (-y4 + R) / (2 * _), V = (-y4 - R) / (2 * _);
            E >= 0 && E <= 1 && (d4[T++] = E), V >= 0 && V <= 1 && (d4[T++] = V);
          }
        }
        return T;
      }
      function $_(s, a, n6, f6, d4, y4) {
        var _ = (a - s) * d4 + s, S = (n6 - a) * d4 + a, T = (f6 - n6) * d4 + n6, E = (S - _) * d4 + _, O = (T - S) * d4 + S, R = (O - E) * d4 + E;
        y4[0] = s, y4[1] = _, y4[2] = E, y4[3] = R, y4[4] = R, y4[5] = O, y4[6] = T, y4[7] = f6;
      }
      function ZL(s, a, n6, f6, d4, y4, _, S, T, E, O) {
        var R, V = 5e-3, z3 = 1 / 0, H, Z, ee, oe;
        q_[0] = T, q_[1] = E;
        for (var fe = 0; fe < 1; fe += 0.05)
          ky[0] = id2(s, n6, d4, _, fe), ky[1] = id2(a, f6, y4, S, fe), ee = ZI(q_, ky), ee < z3 && (R = fe, z3 = ee);
        z3 = 1 / 0;
        for (var _e = 0; _e < 32 && !(V < _U); _e++)
          H = R - V, Z = R + V, ky[0] = id2(s, n6, d4, _, H), ky[1] = id2(a, f6, y4, S, H), ee = ZI(ky, q_), H >= 0 && ee < z3 ? (R = H, z3 = ee) : (nE[0] = id2(s, n6, d4, _, Z), nE[1] = id2(a, f6, y4, S, Z), oe = ZI(nE, q_), Z <= 1 && oe < z3 ? (R = Z, z3 = oe) : V *= 0.5);
        return O && (O[0] = id2(s, n6, d4, _, R), O[1] = id2(a, f6, y4, S, R)), Dy(z3);
      }
      function xU(s, a, n6, f6, d4, y4, _, S, T) {
        for (var E = s, O = a, R = 0, V = 1 / T, z3 = 1; z3 <= T; z3++) {
          var H = z3 * V, Z = id2(s, n6, d4, _, H), ee = id2(a, f6, y4, S, H), oe = Z - E, fe = ee - O;
          R += Math.sqrt(oe * oe + fe * fe), E = Z, O = ee;
        }
        return R;
      }
      function Yv(s, a, n6, f6) {
        var d4 = 1 - f6;
        return d4 * (d4 * s + 2 * f6 * a) + f6 * f6 * n6;
      }
      function g9(s, a, n6, f6) {
        return 2 * ((1 - f6) * (a - s) + f6 * (n6 - a));
      }
      function Cbe(s, a, n6, f6, d4) {
        var y4 = s - 2 * a + n6, _ = 2 * (a - s), S = s - f6, T = 0;
        if (Nb(y4)) {
          if (lT(_)) {
            var E = -S / _;
            E >= 0 && E <= 1 && (d4[T++] = E);
          }
        } else {
          var O = _ * _ - 4 * y4 * S;
          if (Nb(O)) {
            var E = -_ / (2 * y4);
            E >= 0 && E <= 1 && (d4[T++] = E);
          } else if (O > 0) {
            var R = Dy(O), E = (-_ + R) / (2 * y4), V = (-_ - R) / (2 * y4);
            E >= 0 && E <= 1 && (d4[T++] = E), V >= 0 && V <= 1 && (d4[T++] = V);
          }
        }
        return T;
      }
      function Wre(s, a, n6) {
        var f6 = s + n6 - 2 * a;
        return f6 === 0 ? 0.5 : (s - a) / f6;
      }
      function Hp(s, a, n6, f6, d4) {
        var y4 = (a - s) * f6 + s, _ = (n6 - a) * f6 + a, S = (_ - y4) * f6 + y4;
        d4[0] = s, d4[1] = y4, d4[2] = S, d4[3] = S, d4[4] = _, d4[5] = n6;
      }
      function Dg(s, a, n6, f6, d4, y4, _, S, T) {
        var E, O = 5e-3, R = 1 / 0;
        q_[0] = _, q_[1] = S;
        for (var V = 0; V < 1; V += 0.05) {
          ky[0] = Yv(s, n6, d4, V), ky[1] = Yv(a, f6, y4, V);
          var z3 = ZI(q_, ky);
          z3 < R && (E = V, R = z3);
        }
        R = 1 / 0;
        for (var H = 0; H < 32 && !(O < _U); H++) {
          var Z = E - O, ee = E + O;
          ky[0] = Yv(s, n6, d4, Z), ky[1] = Yv(a, f6, y4, Z);
          var z3 = ZI(ky, q_);
          if (Z >= 0 && z3 < R)
            E = Z, R = z3;
          else {
            nE[0] = Yv(s, n6, d4, ee), nE[1] = Yv(a, f6, y4, ee);
            var oe = ZI(nE, q_);
            ee <= 1 && oe < R ? (E = ee, R = oe) : O *= 0.5;
          }
        }
        return T && (T[0] = Yv(s, n6, d4, E), T[1] = Yv(a, f6, y4, E)), Dy(R);
      }
      function Mbe(s, a, n6, f6, d4, y4, _) {
        for (var S = s, T = a, E = 0, O = 1 / _, R = 1; R <= _; R++) {
          var V = R * O, z3 = Yv(s, n6, d4, V), H = Yv(a, f6, y4, V), Z = z3 - S, ee = H - T;
          E += Math.sqrt(Z * Z + ee * ee), S = z3, T = H;
        }
        return E;
      }
      var Tbe = /cubic-bezier\(([0-9,\.e ]+)\)/;
      function y9(s) {
        var a = s && Tbe.exec(s);
        if (a) {
          var n6 = a[1].split(","), f6 = +wh(n6[0]), d4 = +wh(n6[1]), y4 = +wh(n6[2]), _ = +wh(n6[3]);
          if (isNaN(f6 + d4 + y4 + _))
            return;
          var S = [];
          return function(T) {
            return T <= 0 ? 0 : T >= 1 ? 1 : v9(0, f6, y4, 1, T, S) && id2(0, d4, _, 1, S[0]);
          };
        }
      }
      var Abe = function() {
        function s(a) {
          this._inited = false, this._startTime = 0, this._pausedTime = 0, this._paused = false, this._life = a.life || 1e3, this._delay = a.delay || 0, this.loop = a.loop || false, this.onframe = a.onframe || rd, this.ondestroy = a.ondestroy || rd, this.onrestart = a.onrestart || rd, a.easing && this.setEasing(a.easing);
        }
        return s.prototype.step = function(a, n6) {
          if (this._inited || (this._startTime = a + this._delay, this._inited = true), this._paused) {
            this._pausedTime += n6;
            return;
          }
          var f6 = this._life, d4 = a - this._startTime - this._pausedTime, y4 = d4 / f6;
          y4 < 0 && (y4 = 0), y4 = Math.min(y4, 1);
          var _ = this.easingFunc, S = _ ? _(y4) : y4;
          if (this.onframe(S), y4 === 1)
            if (this.loop) {
              var T = d4 % f6;
              this._startTime = a - T, this._pausedTime = 0, this.onrestart();
            } else
              return true;
          return false;
        }, s.prototype.pause = function() {
          this._paused = true;
        }, s.prototype.resume = function() {
          this._paused = false;
        }, s.prototype.setEasing = function(a) {
          this.easing = a, this.easingFunc = jo(a) ? a : jre[a] || y9(a);
        }, s;
      }(), wU = Abe, kk = function() {
        function s(a) {
          this.value = a;
        }
        return s;
      }(), SU = function() {
        function s() {
          this._len = 0;
        }
        return s.prototype.insert = function(a) {
          var n6 = new kk(a);
          return this.insertEntry(n6), n6;
        }, s.prototype.insertEntry = function(a) {
          this.head ? (this.tail.next = a, a.prev = this.tail, a.next = null, this.tail = a) : this.head = this.tail = a, this._len++;
        }, s.prototype.remove = function(a) {
          var n6 = a.prev, f6 = a.next;
          n6 ? n6.next = f6 : this.head = f6, f6 ? f6.prev = n6 : this.tail = n6, a.next = a.prev = null, this._len--;
        }, s.prototype.len = function() {
          return this._len;
        }, s.prototype.clear = function() {
          this.head = this.tail = null, this._len = 0;
        }, s;
      }(), Ok = function() {
        function s(a) {
          this._list = new SU(), this._maxSize = 10, this._map = {}, this._maxSize = a;
        }
        return s.prototype.put = function(a, n6) {
          var f6 = this._list, d4 = this._map, y4 = null;
          if (d4[a] == null) {
            var _ = f6.len(), S = this._lastRemovedEntry;
            if (_ >= this._maxSize && _ > 0) {
              var T = f6.head;
              f6.remove(T), delete d4[T.key], y4 = T.value, this._lastRemovedEntry = T;
            }
            S ? S.value = n6 : S = new kk(n6), S.key = a, f6.insertEntry(S), d4[a] = S;
          }
          return y4;
        }, s.prototype.get = function(a) {
          var n6 = this._map[a], f6 = this._list;
          if (n6 != null)
            return n6 !== f6.tail && (f6.remove(n6), f6.insertEntry(n6)), n6.value;
        }, s.prototype.clear = function() {
          this._list.clear(), this._map = {};
        }, s.prototype.len = function() {
          return this._list.len();
        }, s;
      }(), aC = Ok, Pk = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
      function km(s) {
        return s = Math.round(s), s < 0 ? 0 : s > 255 ? 255 : s;
      }
      function Lk(s) {
        return s = Math.round(s), s < 0 ? 0 : s > 360 ? 360 : s;
      }
      function JL(s) {
        return s < 0 ? 0 : s > 1 ? 1 : s;
      }
      function CU(s) {
        var a = s;
        return a.length && a.charAt(a.length - 1) === "%" ? km(parseFloat(a) / 100 * 255) : km(parseInt(a, 10));
      }
      function Rk(s) {
        var a = s;
        return a.length && a.charAt(a.length - 1) === "%" ? JL(parseFloat(a) / 100) : JL(parseFloat(a));
      }
      function MU(s, a, n6) {
        return n6 < 0 ? n6 += 1 : n6 > 1 && (n6 -= 1), n6 * 6 < 1 ? s + (a - s) * n6 * 6 : n6 * 2 < 1 ? a : n6 * 3 < 2 ? s + (a - s) * (2 / 3 - n6) * 6 : s;
      }
      function uT(s, a, n6) {
        return s + (a - s) * n6;
      }
      function Oy(s, a, n6, f6, d4) {
        return s[0] = a, s[1] = n6, s[2] = f6, s[3] = d4, s;
      }
      function rE(s, a) {
        return s[0] = a[0], s[1] = a[1], s[2] = a[2], s[3] = a[3], s;
      }
      var TU = new aC(20), Ut = null;
      function X_(s, a) {
        Ut && rE(Ut, a), Ut = TU.put(s, Ut || a.slice());
      }
      function w0(s, a) {
        if (s) {
          a = a || [];
          var n6 = TU.get(s);
          if (n6)
            return rE(a, n6);
          s = s + "";
          var f6 = s.replace(/ /g, "").toLowerCase();
          if (f6 in Pk)
            return rE(a, Pk[f6]), X_(s, a), a;
          var d4 = f6.length;
          if (f6.charAt(0) === "#") {
            if (d4 === 4 || d4 === 5) {
              var y4 = parseInt(f6.slice(1, 4), 16);
              if (!(y4 >= 0 && y4 <= 4095)) {
                Oy(a, 0, 0, 0, 1);
                return;
              }
              return Oy(a, (y4 & 3840) >> 4 | (y4 & 3840) >> 8, y4 & 240 | (y4 & 240) >> 4, y4 & 15 | (y4 & 15) << 4, d4 === 5 ? parseInt(f6.slice(4), 16) / 15 : 1), X_(s, a), a;
            } else if (d4 === 7 || d4 === 9) {
              var y4 = parseInt(f6.slice(1, 7), 16);
              if (!(y4 >= 0 && y4 <= 16777215)) {
                Oy(a, 0, 0, 0, 1);
                return;
              }
              return Oy(a, (y4 & 16711680) >> 16, (y4 & 65280) >> 8, y4 & 255, d4 === 9 ? parseInt(f6.slice(7), 16) / 255 : 1), X_(s, a), a;
            }
            return;
          }
          var _ = f6.indexOf("("), S = f6.indexOf(")");
          if (_ !== -1 && S + 1 === d4) {
            var T = f6.substr(0, _), E = f6.substr(_ + 1, S - (_ + 1)).split(","), O = 1;
            switch (T) {
              case "rgba":
                if (E.length !== 4)
                  return E.length === 3 ? Oy(a, +E[0], +E[1], +E[2], 1) : Oy(a, 0, 0, 0, 1);
                O = Rk(E.pop());
              case "rgb":
                if (E.length !== 3) {
                  Oy(a, 0, 0, 0, 1);
                  return;
                }
                return Oy(a, CU(E[0]), CU(E[1]), CU(E[2]), O), X_(s, a), a;
              case "hsla":
                if (E.length !== 4) {
                  Oy(a, 0, 0, 0, 1);
                  return;
                }
                return E[3] = Rk(E[3]), Om(E, a), X_(s, a), a;
              case "hsl":
                if (E.length !== 3) {
                  Oy(a, 0, 0, 0, 1);
                  return;
                }
                return Om(E, a), X_(s, a), a;
              default:
                return;
            }
          }
          Oy(a, 0, 0, 0, 1);
        }
      }
      function Om(s, a) {
        var n6 = (parseFloat(s[0]) % 360 + 360) % 360 / 360, f6 = Rk(s[1]), d4 = Rk(s[2]), y4 = d4 <= 0.5 ? d4 * (f6 + 1) : d4 + f6 - d4 * f6, _ = d4 * 2 - y4;
        return a = a || [], Oy(a, km(MU(_, y4, n6 + 1 / 3) * 255), km(MU(_, y4, n6) * 255), km(MU(_, y4, n6 - 1 / 3) * 255), 1), s.length === 4 && (a[3] = s[3]), a;
      }
      function kc(s) {
        if (s) {
          var a = s[0] / 255, n6 = s[1] / 255, f6 = s[2] / 255, d4 = Math.min(a, n6, f6), y4 = Math.max(a, n6, f6), _ = y4 - d4, S = (y4 + d4) / 2, T, E;
          if (_ === 0)
            T = 0, E = 0;
          else {
            S < 0.5 ? E = _ / (y4 + d4) : E = _ / (2 - y4 - d4);
            var O = ((y4 - a) / 6 + _ / 2) / _, R = ((y4 - n6) / 6 + _ / 2) / _, V = ((y4 - f6) / 6 + _ / 2) / _;
            a === y4 ? T = V - R : n6 === y4 ? T = 1 / 3 + O - V : f6 === y4 && (T = 2 / 3 + R - O), T < 0 && (T += 1), T > 1 && (T -= 1);
          }
          var z3 = [T * 360, E, S];
          return s[3] != null && z3.push(s[3]), z3;
        }
      }
      function AU(s, a) {
        var n6 = w0(s);
        if (n6) {
          for (var f6 = 0; f6 < 3; f6++)
            a < 0 ? n6[f6] = n6[f6] * (1 - a) | 0 : n6[f6] = (255 - n6[f6]) * a + n6[f6] | 0, n6[f6] > 255 ? n6[f6] = 255 : n6[f6] < 0 && (n6[f6] = 0);
          return oC(n6, n6.length === 4 ? "rgba" : "rgb");
        }
      }
      function IU(s, a, n6) {
        if (!(!(a && a.length) || !(s >= 0 && s <= 1))) {
          n6 = n6 || [];
          var f6 = s * (a.length - 1), d4 = Math.floor(f6), y4 = Math.ceil(f6), _ = a[d4], S = a[y4], T = f6 - d4;
          return n6[0] = km(uT(_[0], S[0], T)), n6[1] = km(uT(_[1], S[1], T)), n6[2] = km(uT(_[2], S[2], T)), n6[3] = JL(uT(_[3], S[3], T)), n6;
        }
      }
      function Ibe(s, a, n6) {
        if (!(!(a && a.length) || !(s >= 0 && s <= 1))) {
          var f6 = s * (a.length - 1), d4 = Math.floor(f6), y4 = Math.ceil(f6), _ = w0(a[d4]), S = w0(a[y4]), T = f6 - d4, E = oC([km(uT(_[0], S[0], T)), km(uT(_[1], S[1], T)), km(uT(_[2], S[2], T)), JL(uT(_[3], S[3], T))], "rgba");
          return n6 ? { color: E, leftIndex: d4, rightIndex: y4, value: f6 } : E;
        }
      }
      function Y_(s, a, n6, f6) {
        var d4 = w0(s);
        if (s)
          return d4 = kc(d4), a != null && (d4[0] = Lk(a)), n6 != null && (d4[1] = Rk(n6)), f6 != null && (d4[2] = Rk(f6)), oC(Om(d4), "rgba");
      }
      function m9(s, a) {
        var n6 = w0(s);
        if (n6 && a != null)
          return n6[3] = JL(a), oC(n6, "rgba");
      }
      function oC(s, a) {
        if (!(!s || !s.length)) {
          var n6 = s[0] + "," + s[1] + "," + s[2];
          return (a === "rgba" || a === "hsva" || a === "hsla") && (n6 += "," + s[3]), a + "(" + n6 + ")";
        }
      }
      function b9(s, a) {
        var n6 = w0(s);
        return n6 ? (0.299 * n6[0] + 0.587 * n6[1] + 0.114 * n6[2]) * n6[3] / 255 + (1 - n6[3]) * a : 0;
      }
      var _9 = Math.round;
      function Nk(s) {
        var a;
        if (!s || s === "transparent")
          s = "none";
        else if (typeof s == "string" && s.indexOf("rgba") > -1) {
          var n6 = w0(s);
          n6 && (s = "rgb(" + n6[0] + "," + n6[1] + "," + n6[2] + ")", a = n6[3]);
        }
        return { color: s, opacity: a == null ? 1 : a };
      }
      var Qw = 1e-4;
      function cT(s) {
        return s < Qw && s > -Qw;
      }
      function x9(s) {
        return _9(s * 1e3) / 1e3;
      }
      function EU(s) {
        return _9(s * 1e4) / 1e4;
      }
      function Ebe(s) {
        return "matrix(" + x9(s[0]) + "," + x9(s[1]) + "," + x9(s[2]) + "," + x9(s[3]) + "," + EU(s[4]) + "," + EU(s[5]) + ")";
      }
      var Dbe = { left: "start", right: "end", center: "middle", middle: "middle" };
      function sC(s, a, n6) {
        return n6 === "top" ? s += a / 2 : n6 === "bottom" && (s -= a / 2), s;
      }
      function kbe(s) {
        return s && (s.shadowBlur || s.shadowOffsetX || s.shadowOffsetY);
      }
      function Obe(s) {
        var a = s.style, n6 = s.getGlobalScale();
        return [a.shadowColor, (a.shadowBlur || 0).toFixed(2), (a.shadowOffsetX || 0).toFixed(2), (a.shadowOffsetY || 0).toFixed(2), n6[0], n6[1]].join(",");
      }
      function Ure(s) {
        return s && !!s.image;
      }
      function Pbe(s) {
        return s && !!s.svgElement;
      }
      function Lbe(s) {
        return Ure(s) || Pbe(s);
      }
      function fT(s) {
        return s.type === "linear";
      }
      function qre(s) {
        return s.type === "radial";
      }
      function Rbe(s) {
        return s && (s.type === "linear" || s.type === "radial");
      }
      function Pm(s) {
        return "url(#" + s + ")";
      }
      function $re(s) {
        var a = s.getGlobalScale(), n6 = Math.max(a[0], a[1]);
        return Math.max(Math.ceil(Math.log(n6) / Math.log(10)), 1);
      }
      function Xre(s) {
        var a = s.x || 0, n6 = s.y || 0, f6 = (s.rotation || 0) * jL, d4 = Zs(s.scaleX, 1), y4 = Zs(s.scaleY, 1), _ = s.skewX || 0, S = s.skewY || 0, T = [];
        return (a || n6) && T.push("translate(" + a + "px," + n6 + "px)"), f6 && T.push("rotate(" + f6 + ")"), (d4 !== 1 || y4 !== 1) && T.push("scale(" + d4 + "," + y4 + ")"), (_ || S) && T.push("skew(" + _9(_ * jL) + "deg, " + _9(S * jL) + "deg)"), T.join(" ");
      }
      var Nbe = function() {
        return Na.hasGlobalWindow && jo(window.btoa) ? function(s) {
          return window.btoa(unescape(s));
        } : typeof Buffer != "undefined" ? function(s) {
          return Buffer.from(s).toString("base64");
        } : function(s) {
          return null;
        };
      }(), DU = Array.prototype.slice;
      function lC(s, a, n6) {
        return (a - s) * n6 + s;
      }
      function w9(s, a, n6, f6) {
        for (var d4 = a.length, y4 = 0; y4 < d4; y4++)
          s[y4] = lC(a[y4], n6[y4], f6);
        return s;
      }
      function Yre(s, a, n6, f6) {
        for (var d4 = a.length, y4 = d4 && a[0].length, _ = 0; _ < d4; _++) {
          s[_] || (s[_] = []);
          for (var S = 0; S < y4; S++)
            s[_][S] = lC(a[_][S], n6[_][S], f6);
        }
        return s;
      }
      function S9(s, a, n6, f6) {
        for (var d4 = a.length, y4 = 0; y4 < d4; y4++)
          s[y4] = a[y4] + n6[y4] * f6;
        return s;
      }
      function Kre(s, a, n6, f6) {
        for (var d4 = a.length, y4 = d4 && a[0].length, _ = 0; _ < d4; _++) {
          s[_] || (s[_] = []);
          for (var S = 0; S < y4; S++)
            s[_][S] = a[_][S] + n6[_][S] * f6;
        }
        return s;
      }
      function kU(s, a) {
        for (var n6 = s.length, f6 = a.length, d4 = n6 > f6 ? a : s, y4 = Math.min(n6, f6), _ = d4[y4 - 1] || { color: [0, 0, 0, 0], offset: 0 }, S = y4; S < Math.max(n6, f6); S++)
          d4.push({ offset: _.offset, color: _.color.slice() });
      }
      function QL(s, a, n6) {
        var f6 = s, d4 = a;
        if (!(!f6.push || !d4.push)) {
          var y4 = f6.length, _ = d4.length;
          if (y4 !== _) {
            var S = y4 > _;
            if (S)
              f6.length = _;
            else
              for (var T = y4; T < _; T++)
                f6.push(n6 === 1 ? d4[T] : DU.call(d4[T]));
          }
          for (var E = f6[0] && f6[0].length, T = 0; T < f6.length; T++)
            if (n6 === 1)
              isNaN(f6[T]) && (f6[T] = d4[T]);
            else
              for (var O = 0; O < E; O++)
                isNaN(f6[T][O]) && (f6[T][O] = d4[T][O]);
        }
      }
      function hT(s) {
        if (_0(s)) {
          var a = s.length;
          if (_0(s[0])) {
            for (var n6 = [], f6 = 0; f6 < a; f6++)
              n6.push(DU.call(s[f6]));
            return n6;
          }
          return DU.call(s);
        }
        return s;
      }
      function C9(s) {
        return s[0] = Math.floor(s[0]) || 0, s[1] = Math.floor(s[1]) || 0, s[2] = Math.floor(s[2]) || 0, s[3] = s[3] == null ? 1 : s[3], "rgba(" + s.join(",") + ")";
      }
      function Zre(s) {
        return _0(s && s[0]) ? 2 : 1;
      }
      var M9 = 0, Fb = 1, T9 = 2, K_ = 3, Lm = 4, OU = 5, PU = 6;
      function LU(s) {
        return s === Lm || s === OU;
      }
      function pT(s) {
        return s === Fb || s === T9;
      }
      var Vb = [0, 0, 0, 0], Jre = function() {
        function s(a) {
          this.keyframes = [], this.discrete = false, this._invalid = false, this._needsSort = false, this._lastFr = 0, this._lastFrP = 0, this.propName = a;
        }
        return s.prototype.isFinished = function() {
          return this._finished;
        }, s.prototype.setFinished = function() {
          this._finished = true, this._additiveTrack && this._additiveTrack.setFinished();
        }, s.prototype.needsAnimate = function() {
          return this.keyframes.length >= 1;
        }, s.prototype.getAdditiveTrack = function() {
          return this._additiveTrack;
        }, s.prototype.addKeyframe = function(a, n6, f6) {
          this._needsSort = true;
          var d4 = this.keyframes, y4 = d4.length, _ = false, S = PU, T = n6;
          if (_0(n6)) {
            var E = Zre(n6);
            S = E, (E === 1 && !ac(n6[0]) || E === 2 && !ac(n6[0][0])) && (_ = true);
          } else if (ac(n6) && !BL(n6))
            S = M9;
          else if (Wa(n6))
            if (!isNaN(+n6))
              S = M9;
            else {
              var O = w0(n6);
              O && (T = O, S = K_);
            }
          else if (th(n6)) {
            var R = ei({}, T);
            R.colorStops = Pi(n6.colorStops, function(z3) {
              return { offset: z3.offset, color: w0(z3.color) };
            }), fT(n6) ? S = Lm : qre(n6) && (S = OU), T = R;
          }
          y4 === 0 ? this.valType = S : (S !== this.valType || S === PU) && (_ = true), this.discrete = this.discrete || _;
          var V = { time: a, value: T, rawValue: n6, percent: 0 };
          return f6 && (V.easing = f6, V.easingFunc = jo(f6) ? f6 : jre[f6] || y9(f6)), d4.push(V), V;
        }, s.prototype.prepare = function(a, n6) {
          var f6 = this.keyframes;
          this._needsSort && f6.sort(function(Z, ee) {
            return Z.time - ee.time;
          });
          for (var d4 = this.valType, y4 = f6.length, _ = f6[y4 - 1], S = this.discrete, T = pT(d4), E = LU(d4), O = 0; O < y4; O++) {
            var R = f6[O], V = R.value, z3 = _.value;
            R.percent = R.time / a, S || (T && O !== y4 - 1 ? QL(V, z3, d4) : E && kU(V.colorStops, z3.colorStops));
          }
          if (!S && d4 !== OU && n6 && this.needsAnimate() && n6.needsAnimate() && d4 === n6.valType && !n6._finished) {
            this._additiveTrack = n6;
            for (var H = f6[0].value, O = 0; O < y4; O++)
              d4 === M9 ? f6[O].additiveValue = f6[O].value - H : d4 === K_ ? f6[O].additiveValue = S9([], f6[O].value, H, -1) : pT(d4) && (f6[O].additiveValue = d4 === Fb ? S9([], f6[O].value, H, -1) : Kre([], f6[O].value, H, -1));
          }
        }, s.prototype.step = function(a, n6) {
          if (!this._finished) {
            this._additiveTrack && this._additiveTrack._finished && (this._additiveTrack = null);
            var f6 = this._additiveTrack != null, d4 = f6 ? "additiveValue" : "value", y4 = this.valType, _ = this.keyframes, S = _.length, T = this.propName, E = y4 === K_, O, R = this._lastFr, V = Math.min, z3, H;
            if (S === 1)
              z3 = H = _[0];
            else {
              if (n6 < 0)
                O = 0;
              else if (n6 < this._lastFrP) {
                var Z = V(R + 1, S - 1);
                for (O = Z; O >= 0 && !(_[O].percent <= n6); O--)
                  ;
                O = V(O, S - 2);
              } else {
                for (O = R; O < S && !(_[O].percent > n6); O++)
                  ;
                O = V(O - 1, S - 2);
              }
              H = _[O + 1], z3 = _[O];
            }
            if (z3 && H) {
              this._lastFr = O, this._lastFrP = n6;
              var ee = H.percent - z3.percent, oe = ee === 0 ? 1 : V((n6 - z3.percent) / ee, 1);
              H.easingFunc && (oe = H.easingFunc(oe));
              var fe = f6 ? this._additiveValue : E ? Vb : a[T];
              if ((pT(y4) || E) && !fe && (fe = this._additiveValue = []), this.discrete)
                a[T] = oe < 1 ? z3.rawValue : H.rawValue;
              else if (pT(y4))
                y4 === Fb ? w9(fe, z3[d4], H[d4], oe) : Yre(fe, z3[d4], H[d4], oe);
              else if (LU(y4)) {
                var _e = z3[d4], pe = H[d4], Ve = y4 === Lm;
                a[T] = { type: Ve ? "linear" : "radial", x: lC(_e.x, pe.x, oe), y: lC(_e.y, pe.y, oe), colorStops: Pi(_e.colorStops, function(je, Xe) {
                  var Ye = pe.colorStops[Xe];
                  return { offset: lC(je.offset, Ye.offset, oe), color: C9(w9([], je.color, Ye.color, oe)) };
                }), global: pe.global }, Ve ? (a[T].x2 = lC(_e.x2, pe.x2, oe), a[T].y2 = lC(_e.y2, pe.y2, oe)) : a[T].r = lC(_e.r, pe.r, oe);
              } else if (E)
                w9(fe, z3[d4], H[d4], oe), f6 || (a[T] = C9(fe));
              else {
                var Le = lC(z3[d4], H[d4], oe);
                f6 ? this._additiveValue = Le : a[T] = Le;
              }
              f6 && this._addToTarget(a);
            }
          }
        }, s.prototype._addToTarget = function(a) {
          var n6 = this.valType, f6 = this.propName, d4 = this._additiveValue;
          n6 === M9 ? a[f6] = a[f6] + d4 : n6 === K_ ? (w0(a[f6], Vb), S9(Vb, Vb, d4, 1), a[f6] = C9(Vb)) : n6 === Fb ? S9(a[f6], a[f6], d4, 1) : n6 === T9 && Kre(a[f6], a[f6], d4, 1);
        }, s;
      }(), RU = function() {
        function s(a, n6, f6, d4) {
          if (this._tracks = {}, this._trackKeys = [], this._maxTime = 0, this._started = 0, this._clip = null, this._target = a, this._loop = n6, n6 && d4) {
            sT("Can' use additive animation on looped animation.");
            return;
          }
          this._additiveAnimators = d4, this._allowDiscrete = f6;
        }
        return s.prototype.getMaxTime = function() {
          return this._maxTime;
        }, s.prototype.getDelay = function() {
          return this._delay;
        }, s.prototype.getLoop = function() {
          return this._loop;
        }, s.prototype.getTarget = function() {
          return this._target;
        }, s.prototype.changeTarget = function(a) {
          this._target = a;
        }, s.prototype.when = function(a, n6, f6) {
          return this.whenWithKeys(a, n6, Wl(n6), f6);
        }, s.prototype.whenWithKeys = function(a, n6, f6, d4) {
          for (var y4 = this._tracks, _ = 0; _ < f6.length; _++) {
            var S = f6[_], T = y4[S];
            if (!T) {
              T = y4[S] = new Jre(S);
              var E = void 0, O = this._getAdditiveTrack(S);
              if (O) {
                var R = O.keyframes, V = R[R.length - 1];
                E = V && V.value, O.valType === K_ && E && (E = C9(E));
              } else
                E = this._target[S];
              if (E == null)
                continue;
              a > 0 && T.addKeyframe(0, hT(E), d4), this._trackKeys.push(S);
            }
            T.addKeyframe(a, hT(n6[S]), d4);
          }
          return this._maxTime = Math.max(this._maxTime, a), this;
        }, s.prototype.pause = function() {
          this._clip.pause(), this._paused = true;
        }, s.prototype.resume = function() {
          this._clip.resume(), this._paused = false;
        }, s.prototype.isPaused = function() {
          return !!this._paused;
        }, s.prototype.duration = function(a) {
          return this._maxTime = a, this._force = true, this;
        }, s.prototype._doneCallback = function() {
          this._setTracksFinished(), this._clip = null;
          var a = this._doneCbs;
          if (a)
            for (var n6 = a.length, f6 = 0; f6 < n6; f6++)
              a[f6].call(this);
        }, s.prototype._abortedCallback = function() {
          this._setTracksFinished();
          var a = this.animation, n6 = this._abortedCbs;
          if (a && a.removeClip(this._clip), this._clip = null, n6)
            for (var f6 = 0; f6 < n6.length; f6++)
              n6[f6].call(this);
        }, s.prototype._setTracksFinished = function() {
          for (var a = this._tracks, n6 = this._trackKeys, f6 = 0; f6 < n6.length; f6++)
            a[n6[f6]].setFinished();
        }, s.prototype._getAdditiveTrack = function(a) {
          var n6, f6 = this._additiveAnimators;
          if (f6)
            for (var d4 = 0; d4 < f6.length; d4++) {
              var y4 = f6[d4].getTrack(a);
              y4 && (n6 = y4);
            }
          return n6;
        }, s.prototype.start = function(a) {
          if (!(this._started > 0)) {
            this._started = 1;
            for (var n6 = this, f6 = [], d4 = this._maxTime || 0, y4 = 0; y4 < this._trackKeys.length; y4++) {
              var _ = this._trackKeys[y4], S = this._tracks[_], T = this._getAdditiveTrack(_), E = S.keyframes, O = E.length;
              if (S.prepare(d4, T), S.needsAnimate())
                if (!this._allowDiscrete && S.discrete) {
                  var R = E[O - 1];
                  R && (n6._target[S.propName] = R.rawValue), S.setFinished();
                } else
                  f6.push(S);
            }
            if (f6.length || this._force) {
              var V = new wU({ life: d4, loop: this._loop, delay: this._delay || 0, onframe: function(z3) {
                n6._started = 2;
                var H = n6._additiveAnimators;
                if (H) {
                  for (var Z = false, ee = 0; ee < H.length; ee++)
                    if (H[ee]._clip) {
                      Z = true;
                      break;
                    }
                  Z || (n6._additiveAnimators = null);
                }
                for (var ee = 0; ee < f6.length; ee++)
                  f6[ee].step(n6._target, z3);
                var oe = n6._onframeCbs;
                if (oe)
                  for (var ee = 0; ee < oe.length; ee++)
                    oe[ee](n6._target, z3);
              }, ondestroy: function() {
                n6._doneCallback();
              } });
              this._clip = V, this.animation && this.animation.addClip(V), a && V.setEasing(a);
            } else
              this._doneCallback();
            return this;
          }
        }, s.prototype.stop = function(a) {
          if (this._clip) {
            var n6 = this._clip;
            a && n6.onframe(1), this._abortedCallback();
          }
        }, s.prototype.delay = function(a) {
          return this._delay = a, this;
        }, s.prototype.during = function(a) {
          return a && (this._onframeCbs || (this._onframeCbs = []), this._onframeCbs.push(a)), this;
        }, s.prototype.done = function(a) {
          return a && (this._doneCbs || (this._doneCbs = []), this._doneCbs.push(a)), this;
        }, s.prototype.aborted = function(a) {
          return a && (this._abortedCbs || (this._abortedCbs = []), this._abortedCbs.push(a)), this;
        }, s.prototype.getClip = function() {
          return this._clip;
        }, s.prototype.getTrack = function(a) {
          return this._tracks[a];
        }, s.prototype.getTracks = function() {
          var a = this;
          return Pi(this._trackKeys, function(n6) {
            return a._tracks[n6];
          });
        }, s.prototype.stopTracks = function(a, n6) {
          if (!a.length || !this._clip)
            return true;
          for (var f6 = this._tracks, d4 = this._trackKeys, y4 = 0; y4 < a.length; y4++) {
            var _ = f6[a[y4]];
            _ && !_.isFinished() && (n6 ? _.step(this._target, 1) : this._started === 1 && _.step(this._target, 0), _.setFinished());
          }
          for (var S = true, y4 = 0; y4 < d4.length; y4++)
            if (!f6[d4[y4]].isFinished()) {
              S = false;
              break;
            }
          return S && this._abortedCallback(), S;
        }, s.prototype.saveTo = function(a, n6, f6) {
          if (a) {
            n6 = n6 || this._trackKeys;
            for (var d4 = 0; d4 < n6.length; d4++) {
              var y4 = n6[d4], _ = this._tracks[y4];
              if (!(!_ || _.isFinished())) {
                var S = _.keyframes, T = S[f6 ? 0 : S.length - 1];
                T && (a[y4] = hT(T.rawValue));
              }
            }
          }
        }, s.prototype.__changeFinalValue = function(a, n6) {
          n6 = n6 || Wl(a);
          for (var f6 = 0; f6 < n6.length; f6++) {
            var d4 = n6[f6], y4 = this._tracks[d4];
            if (y4) {
              var _ = y4.keyframes;
              if (_.length > 1) {
                var S = _.pop();
                y4.addKeyframe(S.time, a[d4]), y4.prepare(this._maxTime, y4.getAdditiveTrack());
              }
            }
          }
        }, s;
      }();
      function uC() {
        return new Date().getTime();
      }
      var Fbe = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this) || this;
          return f6._running = false, f6._time = 0, f6._pausedTime = 0, f6._pauseStart = 0, f6._paused = false, n6 = n6 || {}, f6.stage = n6.stage || {}, f6;
        }
        return a.prototype.addClip = function(n6) {
          n6.animation && this.removeClip(n6), this._head ? (this._tail.next = n6, n6.prev = this._tail, n6.next = null, this._tail = n6) : this._head = this._tail = n6, n6.animation = this;
        }, a.prototype.addAnimator = function(n6) {
          n6.animation = this;
          var f6 = n6.getClip();
          f6 && this.addClip(f6);
        }, a.prototype.removeClip = function(n6) {
          if (n6.animation) {
            var f6 = n6.prev, d4 = n6.next;
            f6 ? f6.next = d4 : this._head = d4, d4 ? d4.prev = f6 : this._tail = f6, n6.next = n6.prev = n6.animation = null;
          }
        }, a.prototype.removeAnimator = function(n6) {
          var f6 = n6.getClip();
          f6 && this.removeClip(f6), n6.animation = null;
        }, a.prototype.update = function(n6) {
          for (var f6 = uC() - this._pausedTime, d4 = f6 - this._time, y4 = this._head; y4; ) {
            var _ = y4.next, S = y4.step(f6, d4);
            S && (y4.ondestroy(), this.removeClip(y4)), y4 = _;
          }
          this._time = f6, n6 || (this.trigger("frame", d4), this.stage.update && this.stage.update());
        }, a.prototype._startLoop = function() {
          var n6 = this;
          this._running = true;
          function f6() {
            n6._running && (bU(f6), !n6._paused && n6.update());
          }
          bU(f6);
        }, a.prototype.start = function() {
          this._running || (this._time = uC(), this._pausedTime = 0, this._startLoop());
        }, a.prototype.stop = function() {
          this._running = false;
        }, a.prototype.pause = function() {
          this._paused || (this._pauseStart = uC(), this._paused = true);
        }, a.prototype.resume = function() {
          this._paused && (this._pausedTime += uC() - this._pauseStart, this._paused = false);
        }, a.prototype.clear = function() {
          for (var n6 = this._head; n6; ) {
            var f6 = n6.next;
            n6.prev = n6.next = n6.animation = null, n6 = f6;
          }
          this._head = this._tail = null;
        }, a.prototype.isFinished = function() {
          return this._head == null;
        }, a.prototype.animate = function(n6, f6) {
          f6 = f6 || {}, this.start();
          var d4 = new RU(n6, f6.loop);
          return this.addAnimator(d4), d4;
        }, a;
      }(Dm), Qre = Fbe, kg = 300, eR = Na.domSupported, A9 = function() {
        var s = ["click", "dblclick", "mousewheel", "wheel", "mouseout", "mouseup", "mousedown", "mousemove", "contextmenu"], a = ["touchstart", "touchend", "touchmove"], n6 = { pointerdown: 1, pointerup: 1, pointermove: 1, pointerout: 1 }, f6 = Pi(s, function(d4) {
          var y4 = d4.replace("mouse", "pointer");
          return n6.hasOwnProperty(y4) ? y4 : d4;
        });
        return { mouse: s, touch: a, pointer: f6 };
      }(), Z_ = { mouse: ["mousemove", "mouseup"], pointer: ["pointermove", "pointerup"] }, I9 = false;
      function Fk(s) {
        var a = s.pointerType;
        return a === "pen" || a === "touch";
      }
      function iE(s) {
        s.touching = true, s.touchTimer != null && (clearTimeout(s.touchTimer), s.touchTimer = null), s.touchTimer = setTimeout(function() {
          s.touching = false, s.touchTimer = null;
        }, 700);
      }
      function E9(s) {
        s && (s.zrByTouch = true);
      }
      function Py(s, a) {
        return Eg(s.dom, new Vbe(s, a), true);
      }
      function D9(s, a) {
        for (var n6 = a, f6 = false; n6 && n6.nodeType !== 9 && !(f6 = n6.domBelongToZr || n6 !== a && n6 === s.painterRoot); )
          n6 = n6.parentNode;
        return f6;
      }
      var Vbe = function() {
        function s(a, n6) {
          this.stopPropagation = rd, this.stopImmediatePropagation = rd, this.preventDefault = rd, this.type = n6.type, this.target = this.currentTarget = a.dom, this.pointerType = n6.pointerType, this.clientX = n6.clientX, this.clientY = n6.clientY;
        }
        return s;
      }(), J_ = { mousedown: function(s) {
        s = Eg(this.dom, s), this.__mayPointerCapture = [s.zrX, s.zrY], this.trigger("mousedown", s);
      }, mousemove: function(s) {
        s = Eg(this.dom, s);
        var a = this.__mayPointerCapture;
        a && (s.zrX !== a[0] || s.zrY !== a[1]) && this.__togglePointerCapture(true), this.trigger("mousemove", s);
      }, mouseup: function(s) {
        s = Eg(this.dom, s), this.__togglePointerCapture(false), this.trigger("mouseup", s);
      }, mouseout: function(s) {
        s = Eg(this.dom, s);
        var a = s.toElement || s.relatedTarget;
        D9(this, a) || (this.__pointerCapturing && (s.zrEventControl = "no_globalout"), this.trigger("mouseout", s));
      }, wheel: function(s) {
        I9 = true, s = Eg(this.dom, s), this.trigger("mousewheel", s);
      }, mousewheel: function(s) {
        I9 || (s = Eg(this.dom, s), this.trigger("mousewheel", s));
      }, touchstart: function(s) {
        s = Eg(this.dom, s), E9(s), this.__lastTouchMoment = new Date(), this.handler.processGesture(s, "start"), J_.mousemove.call(this, s), J_.mousedown.call(this, s);
      }, touchmove: function(s) {
        s = Eg(this.dom, s), E9(s), this.handler.processGesture(s, "change"), J_.mousemove.call(this, s);
      }, touchend: function(s) {
        s = Eg(this.dom, s), E9(s), this.handler.processGesture(s, "end"), J_.mouseup.call(this, s), +new Date() - +this.__lastTouchMoment < kg && J_.click.call(this, s);
      }, pointerdown: function(s) {
        J_.mousedown.call(this, s);
      }, pointermove: function(s) {
        Fk(s) || J_.mousemove.call(this, s);
      }, pointerup: function(s) {
        J_.mouseup.call(this, s);
      }, pointerout: function(s) {
        Fk(s) || J_.mouseout.call(this, s);
      } };
      gt(["click", "dblclick", "contextmenu"], function(s) {
        J_[s] = function(a) {
          a = Eg(this.dom, a), this.trigger(s, a);
        };
      });
      var NU = { pointermove: function(s) {
        Fk(s) || NU.mousemove.call(this, s);
      }, pointerup: function(s) {
        NU.mouseup.call(this, s);
      }, mousemove: function(s) {
        this.trigger("mousemove", s);
      }, mouseup: function(s) {
        var a = this.__pointerCapturing;
        this.__togglePointerCapture(false), this.trigger("mouseup", s), a && (s.zrEventControl = "only_globalout", this.trigger("mouseout", s));
      } };
      function FU(s, a) {
        var n6 = a.domHandlers;
        Na.pointerEventsSupported ? gt(A9.pointer, function(f6) {
          dT(a, f6, function(d4) {
            n6[f6].call(s, d4);
          });
        }) : (Na.touchEventsSupported && gt(A9.touch, function(f6) {
          dT(a, f6, function(d4) {
            n6[f6].call(s, d4), iE(a);
          });
        }), gt(A9.mouse, function(f6) {
          dT(a, f6, function(d4) {
            d4 = vU(d4), a.touching || n6[f6].call(s, d4);
          });
        }));
      }
      function Bbe(s, a) {
        Na.pointerEventsSupported ? gt(Z_.pointer, n6) : Na.touchEventsSupported || gt(Z_.mouse, n6);
        function n6(f6) {
          function d4(y4) {
            y4 = vU(y4), D9(s, y4.target) || (y4 = Py(s, y4), a.domHandlers[f6].call(s, y4));
          }
          dT(a, f6, d4, { capture: true });
        }
      }
      function dT(s, a, n6, f6) {
        s.mounted[a] = n6, s.listenerOpts[a] = f6, gU(s.domTarget, a, n6, f6);
      }
      function k9(s) {
        var a = s.mounted;
        for (var n6 in a)
          a.hasOwnProperty(n6) && yU(s.domTarget, n6, a[n6], s.listenerOpts[n6]);
        s.mounted = {};
      }
      var eie = function() {
        function s(a, n6) {
          this.mounted = {}, this.listenerOpts = {}, this.touching = false, this.domTarget = a, this.domHandlers = n6;
        }
        return s;
      }(), zbe = function(s) {
        Vt(a, s);
        function a(n6, f6) {
          var d4 = s.call(this) || this;
          return d4.__pointerCapturing = false, d4.dom = n6, d4.painterRoot = f6, d4._localHandlerScope = new eie(n6, J_), eR && (d4._globalHandlerScope = new eie(document, NU)), FU(d4, d4._localHandlerScope), d4;
        }
        return a.prototype.dispose = function() {
          k9(this._localHandlerScope), eR && k9(this._globalHandlerScope);
        }, a.prototype.setCursor = function(n6) {
          this.dom.style && (this.dom.style.cursor = n6 || "default");
        }, a.prototype.__togglePointerCapture = function(n6) {
          if (this.__mayPointerCapture = null, eR && +this.__pointerCapturing ^ +n6) {
            this.__pointerCapturing = n6;
            var f6 = this._globalHandlerScope;
            n6 ? Bbe(this, f6) : k9(f6);
          }
        }, a;
      }(Dm), tR = zbe, tie = 1;
      Na.hasGlobalWindow && (tie = Math.max(window.devicePixelRatio || window.screen && window.screen.deviceXDPI / window.screen.logicalXDPI || 1, 1));
      var O9 = tie, nR = 0.4, P9 = "#333", VU = "#ccc", jbe = "#eee";
      function Bb() {
        return [1, 0, 0, 1, 0, 0];
      }
      function rR(s) {
        return s[0] = 1, s[1] = 0, s[2] = 0, s[3] = 1, s[4] = 0, s[5] = 0, s;
      }
      function iR(s, a) {
        return s[0] = a[0], s[1] = a[1], s[2] = a[2], s[3] = a[3], s[4] = a[4], s[5] = a[5], s;
      }
      function cC(s, a, n6) {
        var f6 = a[0] * n6[0] + a[2] * n6[1], d4 = a[1] * n6[0] + a[3] * n6[1], y4 = a[0] * n6[2] + a[2] * n6[3], _ = a[1] * n6[2] + a[3] * n6[3], S = a[0] * n6[4] + a[2] * n6[5] + a[4], T = a[1] * n6[4] + a[3] * n6[5] + a[5];
        return s[0] = f6, s[1] = d4, s[2] = y4, s[3] = _, s[4] = S, s[5] = T, s;
      }
      function zb(s, a, n6) {
        return s[0] = a[0], s[1] = a[1], s[2] = a[2], s[3] = a[3], s[4] = a[4] + n6[0], s[5] = a[5] + n6[1], s;
      }
      function vT(s, a, n6) {
        var f6 = a[0], d4 = a[2], y4 = a[4], _ = a[1], S = a[3], T = a[5], E = Math.sin(n6), O = Math.cos(n6);
        return s[0] = f6 * O + _ * E, s[1] = -f6 * E + _ * O, s[2] = d4 * O + S * E, s[3] = -d4 * E + O * S, s[4] = O * y4 + E * T, s[5] = O * T - E * y4, s;
      }
      function L9(s, a, n6) {
        var f6 = n6[0], d4 = n6[1];
        return s[0] = a[0] * f6, s[1] = a[1] * d4, s[2] = a[2] * f6, s[3] = a[3] * d4, s[4] = a[4] * f6, s[5] = a[5] * d4, s;
      }
      function aE(s, a) {
        var n6 = a[0], f6 = a[2], d4 = a[4], y4 = a[1], _ = a[3], S = a[5], T = n6 * _ - y4 * f6;
        return T ? (T = 1 / T, s[0] = _ * T, s[1] = -y4 * T, s[2] = -f6 * T, s[3] = n6 * T, s[4] = (f6 * S - _ * d4) * T, s[5] = (y4 * d4 - n6 * S) * T, s) : null;
      }
      function R9(s) {
        var a = Bb();
        return iR(a, s), a;
      }
      var nie = rR, BU = 5e-5;
      function gT(s) {
        return s > BU || s < -BU;
      }
      var oE = [], sE = [], zU = Bb(), aR = Math.abs, rie = function() {
        function s() {
        }
        return s.prototype.getLocalTransform = function(a) {
          return s.getLocalTransform(this, a);
        }, s.prototype.setPosition = function(a) {
          this.x = a[0], this.y = a[1];
        }, s.prototype.setScale = function(a) {
          this.scaleX = a[0], this.scaleY = a[1];
        }, s.prototype.setSkew = function(a) {
          this.skewX = a[0], this.skewY = a[1];
        }, s.prototype.setOrigin = function(a) {
          this.originX = a[0], this.originY = a[1];
        }, s.prototype.needLocalTransform = function() {
          return gT(this.rotation) || gT(this.x) || gT(this.y) || gT(this.scaleX - 1) || gT(this.scaleY - 1) || gT(this.skewX) || gT(this.skewY);
        }, s.prototype.updateTransform = function() {
          var a = this.parent && this.parent.transform, n6 = this.needLocalTransform(), f6 = this.transform;
          if (!(n6 || a)) {
            f6 && nie(f6);
            return;
          }
          f6 = f6 || Bb(), n6 ? this.getLocalTransform(f6) : nie(f6), a && (n6 ? cC(f6, a, f6) : iR(f6, a)), this.transform = f6, this._resolveGlobalScaleRatio(f6);
        }, s.prototype._resolveGlobalScaleRatio = function(a) {
          var n6 = this.globalScaleRatio;
          if (n6 != null && n6 !== 1) {
            this.getGlobalScale(oE);
            var f6 = oE[0] < 0 ? -1 : 1, d4 = oE[1] < 0 ? -1 : 1, y4 = ((oE[0] - f6) * n6 + f6) / oE[0] || 0, _ = ((oE[1] - d4) * n6 + d4) / oE[1] || 0;
            a[0] *= y4, a[1] *= y4, a[2] *= _, a[3] *= _;
          }
          this.invTransform = this.invTransform || Bb(), aE(this.invTransform, a);
        }, s.prototype.getComputedTransform = function() {
          for (var a = this, n6 = []; a; )
            n6.push(a), a = a.parent;
          for (; a = n6.pop(); )
            a.updateTransform();
          return this.transform;
        }, s.prototype.setLocalTransform = function(a) {
          if (a) {
            var n6 = a[0] * a[0] + a[1] * a[1], f6 = a[2] * a[2] + a[3] * a[3], d4 = Math.atan2(a[1], a[0]), y4 = Math.PI / 2 + d4 - Math.atan2(a[3], a[2]);
            f6 = Math.sqrt(f6) * Math.cos(y4), n6 = Math.sqrt(n6), this.skewX = y4, this.skewY = 0, this.rotation = -d4, this.x = +a[4], this.y = +a[5], this.scaleX = n6, this.scaleY = f6, this.originX = 0, this.originY = 0;
          }
        }, s.prototype.decomposeTransform = function() {
          if (this.transform) {
            var a = this.parent, n6 = this.transform;
            a && a.transform && (cC(sE, a.invTransform, n6), n6 = sE);
            var f6 = this.originX, d4 = this.originY;
            (f6 || d4) && (zU[4] = f6, zU[5] = d4, cC(sE, n6, zU), sE[4] -= f6, sE[5] -= d4, n6 = sE), this.setLocalTransform(n6);
          }
        }, s.prototype.getGlobalScale = function(a) {
          var n6 = this.transform;
          return a = a || [], n6 ? (a[0] = Math.sqrt(n6[0] * n6[0] + n6[1] * n6[1]), a[1] = Math.sqrt(n6[2] * n6[2] + n6[3] * n6[3]), n6[0] < 0 && (a[0] = -a[0]), n6[3] < 0 && (a[1] = -a[1]), a) : (a[0] = 1, a[1] = 1, a);
        }, s.prototype.transformCoordToLocal = function(a, n6) {
          var f6 = [a, n6], d4 = this.invTransform;
          return d4 && Xv(f6, f6, d4), f6;
        }, s.prototype.transformCoordToGlobal = function(a, n6) {
          var f6 = [a, n6], d4 = this.transform;
          return d4 && Xv(f6, f6, d4), f6;
        }, s.prototype.getLineScale = function() {
          var a = this.transform;
          return a && aR(a[0] - 1) > 1e-10 && aR(a[3] - 1) > 1e-10 ? Math.sqrt(aR(a[0] * a[3] - a[2] * a[1])) : 1;
        }, s.prototype.copyTransform = function(a) {
          iie(this, a);
        }, s.getLocalTransform = function(a, n6) {
          n6 = n6 || [];
          var f6 = a.originX || 0, d4 = a.originY || 0, y4 = a.scaleX, _ = a.scaleY, S = a.anchorX, T = a.anchorY, E = a.rotation || 0, O = a.x, R = a.y, V = a.skewX ? Math.tan(a.skewX) : 0, z3 = a.skewY ? Math.tan(-a.skewY) : 0;
          if (f6 || d4 || S || T) {
            var H = f6 + S, Z = d4 + T;
            n6[4] = -H * y4 - V * Z * _, n6[5] = -Z * _ - z3 * H * y4;
          } else
            n6[4] = n6[5] = 0;
          return n6[0] = y4, n6[3] = _, n6[1] = z3 * y4, n6[2] = V * _, E && vT(n6, n6, E), n6[4] += f6 + O, n6[5] += d4 + R, n6;
        }, s.initDefaultProps = function() {
          var a = s.prototype;
          a.scaleX = a.scaleY = a.globalScaleRatio = 1, a.x = a.y = a.originX = a.originY = a.skewX = a.skewY = a.rotation = a.anchorX = a.anchorY = 0;
        }(), s;
      }(), jb = ["x", "y", "originX", "originY", "anchorX", "anchorY", "rotation", "scaleX", "scaleY", "skewX", "skewY"];
      function iie(s, a) {
        for (var n6 = 0; n6 < jb.length; n6++) {
          var f6 = jb[n6];
          s[f6] = a[f6];
        }
      }
      var Q_ = rie, Bu = function() {
        function s(a, n6) {
          this.x = a || 0, this.y = n6 || 0;
        }
        return s.prototype.copy = function(a) {
          return this.x = a.x, this.y = a.y, this;
        }, s.prototype.clone = function() {
          return new s(this.x, this.y);
        }, s.prototype.set = function(a, n6) {
          return this.x = a, this.y = n6, this;
        }, s.prototype.equal = function(a) {
          return a.x === this.x && a.y === this.y;
        }, s.prototype.add = function(a) {
          return this.x += a.x, this.y += a.y, this;
        }, s.prototype.scale = function(a) {
          this.x *= a, this.y *= a;
        }, s.prototype.scaleAndAdd = function(a, n6) {
          this.x += a.x * n6, this.y += a.y * n6;
        }, s.prototype.sub = function(a) {
          return this.x -= a.x, this.y -= a.y, this;
        }, s.prototype.dot = function(a) {
          return this.x * a.x + this.y * a.y;
        }, s.prototype.len = function() {
          return Math.sqrt(this.x * this.x + this.y * this.y);
        }, s.prototype.lenSquare = function() {
          return this.x * this.x + this.y * this.y;
        }, s.prototype.normalize = function() {
          var a = this.len();
          return this.x /= a, this.y /= a, this;
        }, s.prototype.distance = function(a) {
          var n6 = this.x - a.x, f6 = this.y - a.y;
          return Math.sqrt(n6 * n6 + f6 * f6);
        }, s.prototype.distanceSquare = function(a) {
          var n6 = this.x - a.x, f6 = this.y - a.y;
          return n6 * n6 + f6 * f6;
        }, s.prototype.negate = function() {
          return this.x = -this.x, this.y = -this.y, this;
        }, s.prototype.transform = function(a) {
          if (a) {
            var n6 = this.x, f6 = this.y;
            return this.x = a[0] * n6 + a[2] * f6 + a[4], this.y = a[1] * n6 + a[3] * f6 + a[5], this;
          }
        }, s.prototype.toArray = function(a) {
          return a[0] = this.x, a[1] = this.y, a;
        }, s.prototype.fromArray = function(a) {
          this.x = a[0], this.y = a[1];
        }, s.set = function(a, n6, f6) {
          a.x = n6, a.y = f6;
        }, s.copy = function(a, n6) {
          a.x = n6.x, a.y = n6.y;
        }, s.len = function(a) {
          return Math.sqrt(a.x * a.x + a.y * a.y);
        }, s.lenSquare = function(a) {
          return a.x * a.x + a.y * a.y;
        }, s.dot = function(a, n6) {
          return a.x * n6.x + a.y * n6.y;
        }, s.add = function(a, n6, f6) {
          a.x = n6.x + f6.x, a.y = n6.y + f6.y;
        }, s.sub = function(a, n6, f6) {
          a.x = n6.x - f6.x, a.y = n6.y - f6.y;
        }, s.scale = function(a, n6, f6) {
          a.x = n6.x * f6, a.y = n6.y * f6;
        }, s.scaleAndAdd = function(a, n6, f6, d4) {
          a.x = n6.x + f6.x * d4, a.y = n6.y + f6.y * d4;
        }, s.lerp = function(a, n6, f6, d4) {
          var y4 = 1 - d4;
          a.x = y4 * n6.x + d4 * f6.x, a.y = y4 * n6.y + d4 * f6.y;
        }, s;
      }(), zs = Bu, N9 = Math.min, yT = Math.max, mT = new zs(), lE = new zs(), uE = new zs(), Kv = new zs(), oR = new zs(), bT = new zs(), jU = function() {
        function s(a, n6, f6, d4) {
          f6 < 0 && (a = a + f6, f6 = -f6), d4 < 0 && (n6 = n6 + d4, d4 = -d4), this.x = a, this.y = n6, this.width = f6, this.height = d4;
        }
        return s.prototype.union = function(a) {
          var n6 = N9(a.x, this.x), f6 = N9(a.y, this.y);
          isFinite(this.x) && isFinite(this.width) ? this.width = yT(a.x + a.width, this.x + this.width) - n6 : this.width = a.width, isFinite(this.y) && isFinite(this.height) ? this.height = yT(a.y + a.height, this.y + this.height) - f6 : this.height = a.height, this.x = n6, this.y = f6;
        }, s.prototype.applyTransform = function(a) {
          s.applyTransform(this, this, a);
        }, s.prototype.calculateTransform = function(a) {
          var n6 = this, f6 = a.width / n6.width, d4 = a.height / n6.height, y4 = Bb();
          return zb(y4, y4, [-n6.x, -n6.y]), L9(y4, y4, [f6, d4]), zb(y4, y4, [a.x, a.y]), y4;
        }, s.prototype.intersect = function(a, n6) {
          if (!a)
            return false;
          a instanceof s || (a = s.create(a));
          var f6 = this, d4 = f6.x, y4 = f6.x + f6.width, _ = f6.y, S = f6.y + f6.height, T = a.x, E = a.x + a.width, O = a.y, R = a.y + a.height, V = !(y4 < T || E < d4 || S < O || R < _);
          if (n6) {
            var z3 = 1 / 0, H = 0, Z = Math.abs(y4 - T), ee = Math.abs(E - d4), oe = Math.abs(S - O), fe = Math.abs(R - _), _e = Math.min(Z, ee), pe = Math.min(oe, fe);
            y4 < T || E < d4 ? _e > H && (H = _e, Z < ee ? zs.set(bT, -Z, 0) : zs.set(bT, ee, 0)) : _e < z3 && (z3 = _e, Z < ee ? zs.set(oR, Z, 0) : zs.set(oR, -ee, 0)), S < O || R < _ ? pe > H && (H = pe, oe < fe ? zs.set(bT, 0, -oe) : zs.set(bT, 0, fe)) : _e < z3 && (z3 = _e, oe < fe ? zs.set(oR, 0, oe) : zs.set(oR, 0, -fe));
          }
          return n6 && zs.copy(n6, V ? oR : bT), V;
        }, s.prototype.contain = function(a, n6) {
          var f6 = this;
          return a >= f6.x && a <= f6.x + f6.width && n6 >= f6.y && n6 <= f6.y + f6.height;
        }, s.prototype.clone = function() {
          return new s(this.x, this.y, this.width, this.height);
        }, s.prototype.copy = function(a) {
          s.copy(this, a);
        }, s.prototype.plain = function() {
          return { x: this.x, y: this.y, width: this.width, height: this.height };
        }, s.prototype.isFinite = function() {
          return isFinite(this.x) && isFinite(this.y) && isFinite(this.width) && isFinite(this.height);
        }, s.prototype.isZero = function() {
          return this.width === 0 || this.height === 0;
        }, s.create = function(a) {
          return new s(a.x, a.y, a.width, a.height);
        }, s.copy = function(a, n6) {
          a.x = n6.x, a.y = n6.y, a.width = n6.width, a.height = n6.height;
        }, s.applyTransform = function(a, n6, f6) {
          if (!f6) {
            a !== n6 && s.copy(a, n6);
            return;
          }
          if (f6[1] < 1e-5 && f6[1] > -1e-5 && f6[2] < 1e-5 && f6[2] > -1e-5) {
            var d4 = f6[0], y4 = f6[3], _ = f6[4], S = f6[5];
            a.x = n6.x * d4 + _, a.y = n6.y * y4 + S, a.width = n6.width * d4, a.height = n6.height * y4, a.width < 0 && (a.x += a.width, a.width = -a.width), a.height < 0 && (a.y += a.height, a.height = -a.height);
            return;
          }
          mT.x = uE.x = n6.x, mT.y = Kv.y = n6.y, lE.x = Kv.x = n6.x + n6.width, lE.y = uE.y = n6.y + n6.height, mT.transform(f6), Kv.transform(f6), lE.transform(f6), uE.transform(f6), a.x = N9(mT.x, lE.x, uE.x, Kv.x), a.y = N9(mT.y, lE.y, uE.y, Kv.y);
          var T = yT(mT.x, lE.x, uE.x, Kv.x), E = yT(mT.y, lE.y, uE.y, Kv.y);
          a.width = T - a.x, a.height = E - a.y;
        }, s;
      }(), il = jU, GU = {};
      function sp(s, a) {
        a = a || mc;
        var n6 = GU[a];
        n6 || (n6 = GU[a] = new aC(500));
        var f6 = n6.get(s);
        return f6 == null && (f6 = td.measureText(s, a).width, n6.put(s, f6)), f6;
      }
      function fC(s, a, n6, f6) {
        var d4 = sp(s, a), y4 = sR(a), _ = Vk(0, d4, n6), S = hC(0, y4, f6), T = new il(_, S, d4, y4);
        return T;
      }
      function cE(s, a, n6, f6) {
        var d4 = ((s || "") + "").split(`
`), y4 = d4.length;
        if (y4 === 1)
          return fC(d4[0], a, n6, f6);
        for (var _ = new il(0, 0, 0, 0), S = 0; S < d4.length; S++) {
          var T = fC(d4[S], a, n6, f6);
          S === 0 ? _.copy(T) : _.union(T);
        }
        return _;
      }
      function Vk(s, a, n6) {
        return n6 === "right" ? s -= a : n6 === "center" && (s -= a / 2), s;
      }
      function hC(s, a, n6) {
        return n6 === "middle" ? s -= a / 2 : n6 === "bottom" && (s -= a), s;
      }
      function sR(s) {
        return sp("\u56FD", s);
      }
      function H1(s, a) {
        return typeof s == "string" ? s.lastIndexOf("%") >= 0 ? parseFloat(s) / 100 * a : parseFloat(s) : s;
      }
      function lR(s, a, n6) {
        var f6 = a.position || "inside", d4 = a.distance != null ? a.distance : 5, y4 = n6.height, _ = n6.width, S = y4 / 2, T = n6.x, E = n6.y, O = "left", R = "top";
        if (f6 instanceof Array)
          T += H1(f6[0], n6.width), E += H1(f6[1], n6.height), O = null, R = null;
        else
          switch (f6) {
            case "left":
              T -= d4, E += S, O = "right", R = "middle";
              break;
            case "right":
              T += d4 + _, E += S, R = "middle";
              break;
            case "top":
              T += _ / 2, E -= d4, O = "center", R = "bottom";
              break;
            case "bottom":
              T += _ / 2, E += y4 + d4, O = "center";
              break;
            case "inside":
              T += _ / 2, E += S, O = "center", R = "middle";
              break;
            case "insideLeft":
              T += d4, E += S, R = "middle";
              break;
            case "insideRight":
              T += _ - d4, E += S, O = "right", R = "middle";
              break;
            case "insideTop":
              T += _ / 2, E += d4, O = "center";
              break;
            case "insideBottom":
              T += _ / 2, E += y4 - d4, O = "center", R = "bottom";
              break;
            case "insideTopLeft":
              T += d4, E += d4;
              break;
            case "insideTopRight":
              T += _ - d4, E += d4, O = "right";
              break;
            case "insideBottomLeft":
              T += d4, E += y4 - d4, R = "bottom";
              break;
            case "insideBottomRight":
              T += _ - d4, E += y4 - d4, O = "right", R = "bottom";
              break;
          }
        return s = s || {}, s.x = T, s.y = E, s.align = O, s.verticalAlign = R, s;
      }
      var uR = "__zr_normal__", cR = jb.concat(["ignore"]), _T = G_(jb, function(s, a) {
        return s[a] = true, s;
      }, { ignore: false }), Bk = {}, xT = new il(0, 0, 0, 0), F9 = function() {
        function s(a) {
          this.id = XI(), this.animators = [], this.currentStates = [], this.states = {}, this._init(a);
        }
        return s.prototype._init = function(a) {
          this.attr(a);
        }, s.prototype.drift = function(a, n6, f6) {
          switch (this.draggable) {
            case "horizontal":
              n6 = 0;
              break;
            case "vertical":
              a = 0;
              break;
          }
          var d4 = this.transform;
          d4 || (d4 = this.transform = [1, 0, 0, 1, 0, 0]), d4[4] += a, d4[5] += n6, this.decomposeTransform(), this.markRedraw();
        }, s.prototype.beforeUpdate = function() {
        }, s.prototype.afterUpdate = function() {
        }, s.prototype.update = function() {
          this.updateTransform(), this.__dirty && this.updateInnerText();
        }, s.prototype.updateInnerText = function(a) {
          var n6 = this._textContent;
          if (n6 && (!n6.ignore || a)) {
            this.textConfig || (this.textConfig = {});
            var f6 = this.textConfig, d4 = f6.local, y4 = n6.innerTransformable, _ = void 0, S = void 0, T = false;
            y4.parent = d4 ? this : null;
            var E = false;
            if (y4.copyTransform(n6), f6.position != null) {
              var O = xT;
              f6.layoutRect ? O.copy(f6.layoutRect) : O.copy(this.getBoundingRect()), d4 || O.applyTransform(this.transform), this.calculateTextPosition ? this.calculateTextPosition(Bk, f6, O) : lR(Bk, f6, O), y4.x = Bk.x, y4.y = Bk.y, _ = Bk.align, S = Bk.verticalAlign;
              var R = f6.origin;
              if (R && f6.rotation != null) {
                var V = void 0, z3 = void 0;
                R === "center" ? (V = O.width * 0.5, z3 = O.height * 0.5) : (V = H1(R[0], O.width), z3 = H1(R[1], O.height)), E = true, y4.originX = -y4.x + V + (d4 ? 0 : O.x), y4.originY = -y4.y + z3 + (d4 ? 0 : O.y);
              }
            }
            f6.rotation != null && (y4.rotation = f6.rotation);
            var H = f6.offset;
            H && (y4.x += H[0], y4.y += H[1], E || (y4.originX = -H[0], y4.originY = -H[1]));
            var Z = f6.inside == null ? typeof f6.position == "string" && f6.position.indexOf("inside") >= 0 : f6.inside, ee = this._innerTextDefaultStyle || (this._innerTextDefaultStyle = {}), oe = void 0, fe = void 0, _e = void 0;
            Z && this.canBeInsideText() ? (oe = f6.insideFill, fe = f6.insideStroke, (oe == null || oe === "auto") && (oe = this.getInsideTextFill()), (fe == null || fe === "auto") && (fe = this.getInsideTextStroke(oe), _e = true)) : (oe = f6.outsideFill, fe = f6.outsideStroke, (oe == null || oe === "auto") && (oe = this.getOutsideFill()), (fe == null || fe === "auto") && (fe = this.getOutsideStroke(oe), _e = true)), oe = oe || "#000", (oe !== ee.fill || fe !== ee.stroke || _e !== ee.autoStroke || _ !== ee.align || S !== ee.verticalAlign) && (T = true, ee.fill = oe, ee.stroke = fe, ee.autoStroke = _e, ee.align = _, ee.verticalAlign = S, n6.setDefaultTextStyle(ee)), n6.__dirty |= x0, T && n6.dirtyStyle(true);
          }
        }, s.prototype.canBeInsideText = function() {
          return true;
        }, s.prototype.getInsideTextFill = function() {
          return "#fff";
        }, s.prototype.getInsideTextStroke = function(a) {
          return "#000";
        }, s.prototype.getOutsideFill = function() {
          return this.__zr && this.__zr.isDarkMode() ? VU : P9;
        }, s.prototype.getOutsideStroke = function(a) {
          var n6 = this.__zr && this.__zr.getBackgroundColor(), f6 = typeof n6 == "string" && w0(n6);
          f6 || (f6 = [255, 255, 255, 1]);
          for (var d4 = f6[3], y4 = this.__zr.isDarkMode(), _ = 0; _ < 3; _++)
            f6[_] = f6[_] * d4 + (y4 ? 0 : 255) * (1 - d4);
          return f6[3] = 1, oC(f6, "rgba");
        }, s.prototype.traverse = function(a, n6) {
        }, s.prototype.attrKV = function(a, n6) {
          a === "textConfig" ? this.setTextConfig(n6) : a === "textContent" ? this.setTextContent(n6) : a === "clipPath" ? this.setClipPath(n6) : a === "extra" ? (this.extra = this.extra || {}, ei(this.extra, n6)) : this[a] = n6;
        }, s.prototype.hide = function() {
          this.ignore = true, this.markRedraw();
        }, s.prototype.show = function() {
          this.ignore = false, this.markRedraw();
        }, s.prototype.attr = function(a, n6) {
          if (typeof a == "string")
            this.attrKV(a, n6);
          else if (Qo(a))
            for (var f6 = a, d4 = Wl(f6), y4 = 0; y4 < d4.length; y4++) {
              var _ = d4[y4];
              this.attrKV(_, a[_]);
            }
          return this.markRedraw(), this;
        }, s.prototype.saveCurrentToNormalState = function(a) {
          this._innerSaveToNormal(a);
          for (var n6 = this._normalState, f6 = 0; f6 < this.animators.length; f6++) {
            var d4 = this.animators[f6], y4 = d4.__fromStateTransition;
            if (!(d4.getLoop() || y4 && y4 !== uR)) {
              var _ = d4.targetName, S = _ ? n6[_] : n6;
              d4.saveTo(S);
            }
          }
        }, s.prototype._innerSaveToNormal = function(a) {
          var n6 = this._normalState;
          n6 || (n6 = this._normalState = {}), a.textConfig && !n6.textConfig && (n6.textConfig = this.textConfig), this._savePrimaryToNormal(a, n6, cR);
        }, s.prototype._savePrimaryToNormal = function(a, n6, f6) {
          for (var d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            a[y4] != null && !(y4 in n6) && (n6[y4] = this[y4]);
          }
        }, s.prototype.hasState = function() {
          return this.currentStates.length > 0;
        }, s.prototype.getState = function(a) {
          return this.states[a];
        }, s.prototype.ensureState = function(a) {
          var n6 = this.states;
          return n6[a] || (n6[a] = {}), n6[a];
        }, s.prototype.clearStates = function(a) {
          this.useState(uR, false, a);
        }, s.prototype.useState = function(a, n6, f6, d4) {
          var y4 = a === uR, _ = this.hasState();
          if (!(!_ && y4)) {
            var S = this.currentStates, T = this.stateTransition;
            if (!(Ns(S, a) >= 0 && (n6 || S.length === 1))) {
              var E;
              if (this.stateProxy && !y4 && (E = this.stateProxy(a)), E || (E = this.states && this.states[a]), !E && !y4) {
                sT("State " + a + " not exists.");
                return;
              }
              y4 || this.saveCurrentToNormalState(E);
              var O = !!(E && E.hoverLayer || d4);
              O && this._toggleHoverLayerFlag(true), this._applyStateObj(a, E, this._normalState, n6, !f6 && !this.__inHover && T && T.duration > 0, T);
              var R = this._textContent, V = this._textGuide;
              return R && R.useState(a, n6, f6, O), V && V.useState(a, n6, f6, O), y4 ? (this.currentStates = [], this._normalState = {}) : n6 ? this.currentStates.push(a) : this.currentStates = [a], this._updateAnimationTargets(), this.markRedraw(), !O && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~x0), E;
            }
          }
        }, s.prototype.useStates = function(a, n6, f6) {
          if (!a.length)
            this.clearStates();
          else {
            var d4 = [], y4 = this.currentStates, _ = a.length, S = _ === y4.length;
            if (S) {
              for (var T = 0; T < _; T++)
                if (a[T] !== y4[T]) {
                  S = false;
                  break;
                }
            }
            if (S)
              return;
            for (var T = 0; T < _; T++) {
              var E = a[T], O = void 0;
              this.stateProxy && (O = this.stateProxy(E, a)), O || (O = this.states[E]), O && d4.push(O);
            }
            var R = d4[_ - 1], V = !!(R && R.hoverLayer || f6);
            V && this._toggleHoverLayerFlag(true);
            var z3 = this._mergeStates(d4), H = this.stateTransition;
            this.saveCurrentToNormalState(z3), this._applyStateObj(a.join(","), z3, this._normalState, false, !n6 && !this.__inHover && H && H.duration > 0, H);
            var Z = this._textContent, ee = this._textGuide;
            Z && Z.useStates(a, n6, V), ee && ee.useStates(a, n6, V), this._updateAnimationTargets(), this.currentStates = a.slice(), this.markRedraw(), !V && this.__inHover && (this._toggleHoverLayerFlag(false), this.__dirty &= ~x0);
          }
        }, s.prototype._updateAnimationTargets = function() {
          for (var a = 0; a < this.animators.length; a++) {
            var n6 = this.animators[a];
            n6.targetName && n6.changeTarget(this[n6.targetName]);
          }
        }, s.prototype.removeState = function(a) {
          var n6 = Ns(this.currentStates, a);
          if (n6 >= 0) {
            var f6 = this.currentStates.slice();
            f6.splice(n6, 1), this.useStates(f6);
          }
        }, s.prototype.replaceState = function(a, n6, f6) {
          var d4 = this.currentStates.slice(), y4 = Ns(d4, a), _ = Ns(d4, n6) >= 0;
          y4 >= 0 ? _ ? d4.splice(y4, 1) : d4[y4] = n6 : f6 && !_ && d4.push(n6), this.useStates(d4);
        }, s.prototype.toggleState = function(a, n6) {
          n6 ? this.useState(a, true) : this.removeState(a);
        }, s.prototype._mergeStates = function(a) {
          for (var n6 = {}, f6, d4 = 0; d4 < a.length; d4++) {
            var y4 = a[d4];
            ei(n6, y4), y4.textConfig && (f6 = f6 || {}, ei(f6, y4.textConfig));
          }
          return f6 && (n6.textConfig = f6), n6;
        }, s.prototype._applyStateObj = function(a, n6, f6, d4, y4, _) {
          var S = !(n6 && d4);
          n6 && n6.textConfig ? (this.textConfig = ei({}, d4 ? this.textConfig : f6.textConfig), ei(this.textConfig, n6.textConfig)) : S && f6.textConfig && (this.textConfig = f6.textConfig);
          for (var T = {}, E = false, O = 0; O < cR.length; O++) {
            var R = cR[O], V = y4 && _T[R];
            n6 && n6[R] != null ? V ? (E = true, T[R] = n6[R]) : this[R] = n6[R] : S && f6[R] != null && (V ? (E = true, T[R] = f6[R]) : this[R] = f6[R]);
          }
          if (!y4)
            for (var O = 0; O < this.animators.length; O++) {
              var z3 = this.animators[O], H = z3.targetName;
              z3.getLoop() || z3.__changeFinalValue(H ? (n6 || f6)[H] : n6 || f6);
            }
          E && this._transitionState(a, T, _);
        }, s.prototype._attachComponent = function(a) {
          if (!(a.__zr && !a.__hostTarget) && a !== this) {
            var n6 = this.__zr;
            n6 && a.addSelfToZr(n6), a.__zr = n6, a.__hostTarget = this;
          }
        }, s.prototype._detachComponent = function(a) {
          a.__zr && a.removeSelfFromZr(a.__zr), a.__zr = null, a.__hostTarget = null;
        }, s.prototype.getClipPath = function() {
          return this._clipPath;
        }, s.prototype.setClipPath = function(a) {
          this._clipPath && this._clipPath !== a && this.removeClipPath(), this._attachComponent(a), this._clipPath = a, this.markRedraw();
        }, s.prototype.removeClipPath = function() {
          var a = this._clipPath;
          a && (this._detachComponent(a), this._clipPath = null, this.markRedraw());
        }, s.prototype.getTextContent = function() {
          return this._textContent;
        }, s.prototype.setTextContent = function(a) {
          var n6 = this._textContent;
          n6 !== a && (n6 && n6 !== a && this.removeTextContent(), a.innerTransformable = new Q_(), this._attachComponent(a), this._textContent = a, this.markRedraw());
        }, s.prototype.setTextConfig = function(a) {
          this.textConfig || (this.textConfig = {}), ei(this.textConfig, a), this.markRedraw();
        }, s.prototype.removeTextConfig = function() {
          this.textConfig = null, this.markRedraw();
        }, s.prototype.removeTextContent = function() {
          var a = this._textContent;
          a && (a.innerTransformable = null, this._detachComponent(a), this._textContent = null, this._innerTextDefaultStyle = null, this.markRedraw());
        }, s.prototype.getTextGuideLine = function() {
          return this._textGuide;
        }, s.prototype.setTextGuideLine = function(a) {
          this._textGuide && this._textGuide !== a && this.removeTextGuideLine(), this._attachComponent(a), this._textGuide = a, this.markRedraw();
        }, s.prototype.removeTextGuideLine = function() {
          var a = this._textGuide;
          a && (this._detachComponent(a), this._textGuide = null, this.markRedraw());
        }, s.prototype.markRedraw = function() {
          this.__dirty |= x0;
          var a = this.__zr;
          a && (this.__inHover ? a.refreshHover() : a.refresh()), this.__hostTarget && this.__hostTarget.markRedraw();
        }, s.prototype.dirty = function() {
          this.markRedraw();
        }, s.prototype._toggleHoverLayerFlag = function(a) {
          this.__inHover = a;
          var n6 = this._textContent, f6 = this._textGuide;
          n6 && (n6.__inHover = a), f6 && (f6.__inHover = a);
        }, s.prototype.addSelfToZr = function(a) {
          if (this.__zr !== a) {
            this.__zr = a;
            var n6 = this.animators;
            if (n6)
              for (var f6 = 0; f6 < n6.length; f6++)
                a.animation.addAnimator(n6[f6]);
            this._clipPath && this._clipPath.addSelfToZr(a), this._textContent && this._textContent.addSelfToZr(a), this._textGuide && this._textGuide.addSelfToZr(a);
          }
        }, s.prototype.removeSelfFromZr = function(a) {
          if (this.__zr) {
            this.__zr = null;
            var n6 = this.animators;
            if (n6)
              for (var f6 = 0; f6 < n6.length; f6++)
                a.animation.removeAnimator(n6[f6]);
            this._clipPath && this._clipPath.removeSelfFromZr(a), this._textContent && this._textContent.removeSelfFromZr(a), this._textGuide && this._textGuide.removeSelfFromZr(a);
          }
        }, s.prototype.animate = function(a, n6, f6) {
          var d4 = a ? this[a] : this, y4 = new RU(d4, n6, f6);
          return a && (y4.targetName = a), this.addAnimator(y4, a), y4;
        }, s.prototype.addAnimator = function(a, n6) {
          var f6 = this.__zr, d4 = this;
          a.during(function() {
            d4.updateDuringAnimation(n6);
          }).done(function() {
            var y4 = d4.animators, _ = Ns(y4, a);
            _ >= 0 && y4.splice(_, 1);
          }), this.animators.push(a), f6 && f6.animation.addAnimator(a), f6 && f6.wakeUp();
        }, s.prototype.updateDuringAnimation = function(a) {
          this.markRedraw();
        }, s.prototype.stopAnimation = function(a, n6) {
          for (var f6 = this.animators, d4 = f6.length, y4 = [], _ = 0; _ < d4; _++) {
            var S = f6[_];
            !a || a === S.scope ? S.stop(n6) : y4.push(S);
          }
          return this.animators = y4, this;
        }, s.prototype.animateTo = function(a, n6, f6) {
          V9(this, a, n6, f6);
        }, s.prototype.animateFrom = function(a, n6, f6) {
          V9(this, a, n6, f6, true);
        }, s.prototype._transitionState = function(a, n6, f6, d4) {
          for (var y4 = V9(this, n6, f6, d4), _ = 0; _ < y4.length; _++)
            y4[_].__fromStateTransition = a;
        }, s.prototype.getBoundingRect = function() {
          return null;
        }, s.prototype.getPaintRect = function() {
          return null;
        }, s.initDefaultProps = function() {
          var a = s.prototype;
          a.type = "element", a.name = "", a.ignore = a.silent = a.isGroup = a.draggable = a.dragging = a.ignoreClip = a.__inHover = false, a.__dirty = x0;
          function n6(f6, d4, y4, _) {
            Object.defineProperty(a, f6, { get: function() {
              if (!this[d4]) {
                var T = this[d4] = [];
                S(this, T);
              }
              return this[d4];
            }, set: function(T) {
              this[y4] = T[0], this[_] = T[1], this[d4] = T, S(this, T);
            } });
            function S(T, E) {
              Object.defineProperty(E, 0, { get: function() {
                return T[y4];
              }, set: function(O) {
                T[y4] = O;
              } }), Object.defineProperty(E, 1, { get: function() {
                return T[_];
              }, set: function(O) {
                T[_] = O;
              } });
            }
          }
          Object.defineProperty && (n6("position", "_legacyPos", "x", "y"), n6("scale", "_legacyScale", "scaleX", "scaleY"), n6("origin", "_legacyOrigin", "originX", "originY"));
        }(), s;
      }();
      nd(F9, Dm), nd(F9, Q_);
      function V9(s, a, n6, f6, d4) {
        n6 = n6 || {};
        var y4 = [];
        HU(s, "", s, a, n6, f6, y4, d4);
        var _ = y4.length, S = false, T = n6.done, E = n6.aborted, O = function() {
          S = true, _--, _ <= 0 && (S ? T && T() : E && E());
        }, R = function() {
          _--, _ <= 0 && (S ? T && T() : E && E());
        };
        _ || T && T(), y4.length > 0 && n6.during && y4[0].during(function(H, Z) {
          n6.during(Z);
        });
        for (var V = 0; V < y4.length; V++) {
          var z3 = y4[V];
          O && z3.done(O), R && z3.aborted(R), n6.force && z3.duration(n6.duration), z3.start(n6.easing);
        }
        return y4;
      }
      function fR(s, a, n6) {
        for (var f6 = 0; f6 < n6; f6++)
          s[f6] = a[f6];
      }
      function Gbe(s) {
        return _0(s[0]);
      }
      function Hbe(s, a, n6) {
        if (_0(a[n6]))
          if (_0(s[n6]) || (s[n6] = []), j1(a[n6])) {
            var f6 = a[n6].length;
            s[n6].length !== f6 && (s[n6] = new a[n6].constructor(f6), fR(s[n6], a[n6], f6));
          } else {
            var d4 = a[n6], y4 = s[n6], _ = d4.length;
            if (Gbe(d4))
              for (var S = d4[0].length, T = 0; T < _; T++)
                y4[T] ? fR(y4[T], d4[T], S) : y4[T] = Array.prototype.slice.call(d4[T]);
            else
              fR(y4, d4, _);
            y4.length = d4.length;
          }
        else
          s[n6] = a[n6];
      }
      function Wbe(s, a) {
        return s === a || _0(s) && _0(a) && aie(s, a);
      }
      function aie(s, a) {
        var n6 = s.length;
        if (n6 !== a.length)
          return false;
        for (var f6 = 0; f6 < n6; f6++)
          if (s[f6] !== a[f6])
            return false;
        return true;
      }
      function HU(s, a, n6, f6, d4, y4, _, S) {
        for (var T = Wl(f6), E = d4.duration, O = d4.delay, R = d4.additive, V = d4.setToFinal, z3 = !Qo(y4), H = s.animators, Z = [], ee = 0; ee < T.length; ee++) {
          var oe = T[ee], fe = f6[oe];
          if (fe != null && n6[oe] != null && (z3 || y4[oe]))
            if (Qo(fe) && !_0(fe) && !th(fe)) {
              if (a) {
                S || (n6[oe] = fe, s.updateDuringAnimation(a));
                continue;
              }
              HU(s, oe, n6[oe], fe, d4, y4 && y4[oe], _, S);
            } else
              Z.push(oe);
          else
            S || (n6[oe] = fe, s.updateDuringAnimation(a), Z.push(oe));
        }
        var _e = Z.length;
        if (!R && _e)
          for (var pe = 0; pe < H.length; pe++) {
            var Ve = H[pe];
            if (Ve.targetName === a) {
              var Le = Ve.stopTracks(Z);
              if (Le) {
                var je = Ns(H, Ve);
                H.splice(je, 1);
              }
            }
          }
        if (d4.force || (Z = tf(Z, function(ut) {
          return !Wbe(f6[ut], n6[ut]);
        }), _e = Z.length), _e > 0 || d4.force && !_.length) {
          var Xe = void 0, Ye = void 0, rt2 = void 0;
          if (S) {
            Ye = {}, V && (Xe = {});
            for (var pe = 0; pe < _e; pe++) {
              var oe = Z[pe];
              Ye[oe] = n6[oe], V ? Xe[oe] = f6[oe] : n6[oe] = f6[oe];
            }
          } else if (V) {
            rt2 = {};
            for (var pe = 0; pe < _e; pe++) {
              var oe = Z[pe];
              rt2[oe] = hT(n6[oe]), Hbe(n6, f6, oe);
            }
          }
          var Ve = new RU(n6, false, false, R ? tf(H, function(wt) {
            return wt.targetName === a;
          }) : null);
          Ve.targetName = a, d4.scope && (Ve.scope = d4.scope), V && Xe && Ve.whenWithKeys(0, Xe, Z), rt2 && Ve.whenWithKeys(0, rt2, Z), Ve.whenWithKeys(E == null ? 500 : E, S ? Ye : f6, Z).delay(O || 0), s.addAnimator(Ve, a), _.push(Ve);
        }
      }
      var oie = F9, WU = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this) || this;
          return f6.isGroup = true, f6._children = [], f6.attr(n6), f6;
        }
        return a.prototype.childrenRef = function() {
          return this._children;
        }, a.prototype.children = function() {
          return this._children.slice();
        }, a.prototype.childAt = function(n6) {
          return this._children[n6];
        }, a.prototype.childOfName = function(n6) {
          for (var f6 = this._children, d4 = 0; d4 < f6.length; d4++)
            if (f6[d4].name === n6)
              return f6[d4];
        }, a.prototype.childCount = function() {
          return this._children.length;
        }, a.prototype.add = function(n6) {
          return n6 && n6 !== this && n6.parent !== this && (this._children.push(n6), this._doAdd(n6)), this;
        }, a.prototype.addBefore = function(n6, f6) {
          if (n6 && n6 !== this && n6.parent !== this && f6 && f6.parent === this) {
            var d4 = this._children, y4 = d4.indexOf(f6);
            y4 >= 0 && (d4.splice(y4, 0, n6), this._doAdd(n6));
          }
          return this;
        }, a.prototype.replace = function(n6, f6) {
          var d4 = Ns(this._children, n6);
          return d4 >= 0 && this.replaceAt(f6, d4), this;
        }, a.prototype.replaceAt = function(n6, f6) {
          var d4 = this._children, y4 = d4[f6];
          if (n6 && n6 !== this && n6.parent !== this && n6 !== y4) {
            d4[f6] = n6, y4.parent = null;
            var _ = this.__zr;
            _ && y4.removeSelfFromZr(_), this._doAdd(n6);
          }
          return this;
        }, a.prototype._doAdd = function(n6) {
          n6.parent && n6.parent.remove(n6), n6.parent = this;
          var f6 = this.__zr;
          f6 && f6 !== n6.__zr && n6.addSelfToZr(f6), f6 && f6.refresh();
        }, a.prototype.remove = function(n6) {
          var f6 = this.__zr, d4 = this._children, y4 = Ns(d4, n6);
          return y4 < 0 ? this : (d4.splice(y4, 1), n6.parent = null, f6 && n6.removeSelfFromZr(f6), f6 && f6.refresh(), this);
        }, a.prototype.removeAll = function() {
          for (var n6 = this._children, f6 = this.__zr, d4 = 0; d4 < n6.length; d4++) {
            var y4 = n6[d4];
            f6 && y4.removeSelfFromZr(f6), y4.parent = null;
          }
          return n6.length = 0, this;
        }, a.prototype.eachChild = function(n6, f6) {
          for (var d4 = this._children, y4 = 0; y4 < d4.length; y4++) {
            var _ = d4[y4];
            n6.call(f6, _, y4);
          }
          return this;
        }, a.prototype.traverse = function(n6, f6) {
          for (var d4 = 0; d4 < this._children.length; d4++) {
            var y4 = this._children[d4], _ = n6.call(f6, y4);
            y4.isGroup && !_ && y4.traverse(n6, f6);
          }
          return this;
        }, a.prototype.addSelfToZr = function(n6) {
          s.prototype.addSelfToZr.call(this, n6);
          for (var f6 = 0; f6 < this._children.length; f6++) {
            var d4 = this._children[f6];
            d4.addSelfToZr(n6);
          }
        }, a.prototype.removeSelfFromZr = function(n6) {
          s.prototype.removeSelfFromZr.call(this, n6);
          for (var f6 = 0; f6 < this._children.length; f6++) {
            var d4 = this._children[f6];
            d4.removeSelfFromZr(n6);
          }
        }, a.prototype.getBoundingRect = function(n6) {
          for (var f6 = new il(0, 0, 0, 0), d4 = n6 || this._children, y4 = [], _ = null, S = 0; S < d4.length; S++) {
            var T = d4[S];
            if (!(T.ignore || T.invisible)) {
              var E = T.getBoundingRect(), O = T.getLocalTransform(y4);
              O ? (il.applyTransform(f6, E, O), _ = _ || f6.clone(), _.union(f6)) : (_ = _ || E.clone(), _.union(E));
            }
          }
          return _ || f6;
        }, a;
      }(oie);
      WU.prototype.type = "group";
      var fs = WU;
      /*!
      * ZRender, a high performance 2d drawing library.
      *
      * Copyright (c) 2013, Baidu Inc.
      * All rights reserved.
      *
      * LICENSE
      * https://github.com/ecomfe/zrender/blob/master/LICENSE.txt
      */
      var Og = {}, ex = {};
      function Ube(s) {
        delete ex[s];
      }
      function qbe(s) {
        if (!s)
          return false;
        if (typeof s == "string")
          return b9(s, 1) < nR;
        if (s.colorStops) {
          for (var a = s.colorStops, n6 = 0, f6 = a.length, d4 = 0; d4 < f6; d4++)
            n6 += b9(a[d4].color, 1);
          return n6 /= f6, n6 < nR;
        }
        return false;
      }
      var B9 = function() {
        function s(a, n6, f6) {
          var d4 = this;
          this._sleepAfterStill = 10, this._stillFrameAccum = 0, this._needsRefresh = true, this._needsRefreshHover = true, this._darkMode = false, f6 = f6 || {}, this.dom = n6, this.id = a;
          var y4 = new zre(), _ = f6.renderer || "canvas";
          Og[_] || (_ = Wl(Og)[0]), f6.useDirtyRect = f6.useDirtyRect == null ? false : f6.useDirtyRect;
          var S = new Og[_](n6, y4, f6, a), T = f6.ssr || S.ssrOnly;
          this.storage = y4, this.painter = S;
          var E = !Na.node && !Na.worker && !T ? new tR(S.getViewportRoot(), S.root) : null;
          this.handler = new _r(y4, S, E, S.root), this.animation = new Qre({ stage: { update: T ? null : function() {
            return d4._flush(true);
          } } }), T || this.animation.start();
        }
        return s.prototype.add = function(a) {
          !a || (this.storage.addRoot(a), a.addSelfToZr(this), this.refresh());
        }, s.prototype.remove = function(a) {
          !a || (this.storage.delRoot(a), a.removeSelfFromZr(this), this.refresh());
        }, s.prototype.configLayer = function(a, n6) {
          this.painter.configLayer && this.painter.configLayer(a, n6), this.refresh();
        }, s.prototype.setBackgroundColor = function(a) {
          this.painter.setBackgroundColor && this.painter.setBackgroundColor(a), this.refresh(), this._backgroundColor = a, this._darkMode = qbe(a);
        }, s.prototype.getBackgroundColor = function() {
          return this._backgroundColor;
        }, s.prototype.setDarkMode = function(a) {
          this._darkMode = a;
        }, s.prototype.isDarkMode = function() {
          return this._darkMode;
        }, s.prototype.refreshImmediately = function(a) {
          a || this.animation.update(true), this._needsRefresh = false, this.painter.refresh(), this._needsRefresh = false;
        }, s.prototype.refresh = function() {
          this._needsRefresh = true, this.animation.start();
        }, s.prototype.flush = function() {
          this._flush(false);
        }, s.prototype._flush = function(a) {
          var n6, f6 = uC();
          this._needsRefresh && (n6 = true, this.refreshImmediately(a)), this._needsRefreshHover && (n6 = true, this.refreshHoverImmediately());
          var d4 = uC();
          n6 ? (this._stillFrameAccum = 0, this.trigger("rendered", { elapsedTime: d4 - f6 })) : this._sleepAfterStill > 0 && (this._stillFrameAccum++, this._stillFrameAccum > this._sleepAfterStill && this.animation.stop());
        }, s.prototype.setSleepAfterStill = function(a) {
          this._sleepAfterStill = a;
        }, s.prototype.wakeUp = function() {
          this.animation.start(), this._stillFrameAccum = 0;
        }, s.prototype.refreshHover = function() {
          this._needsRefreshHover = true;
        }, s.prototype.refreshHoverImmediately = function() {
          this._needsRefreshHover = false, this.painter.refreshHover && this.painter.getType() === "canvas" && this.painter.refreshHover();
        }, s.prototype.resize = function(a) {
          a = a || {}, this.painter.resize(a.width, a.height), this.handler.resize();
        }, s.prototype.clearAnimation = function() {
          this.animation.clear();
        }, s.prototype.getWidth = function() {
          return this.painter.getWidth();
        }, s.prototype.getHeight = function() {
          return this.painter.getHeight();
        }, s.prototype.setCursorStyle = function(a) {
          this.handler.setCursorStyle(a);
        }, s.prototype.findHover = function(a, n6) {
          return this.handler.findHover(a, n6);
        }, s.prototype.on = function(a, n6, f6) {
          return this.handler.on(a, n6, f6), this;
        }, s.prototype.off = function(a, n6) {
          this.handler.off(a, n6);
        }, s.prototype.trigger = function(a, n6) {
          this.handler.trigger(a, n6);
        }, s.prototype.clear = function() {
          for (var a = this.storage.getRoots(), n6 = 0; n6 < a.length; n6++)
            a[n6] instanceof fs && a[n6].removeSelfFromZr(this);
          this.storage.delAllRoots(), this.painter.clear();
        }, s.prototype.dispose = function() {
          this.animation.stop(), this.clear(), this.storage.dispose(), this.painter.dispose(), this.handler.dispose(), this.animation = this.storage = this.painter = this.handler = null, Ube(this.id);
        }, s;
      }();
      function fE(s, a) {
        var n6 = new B9(XI(), s, a);
        return ex[n6.id] = n6, n6;
      }
      function sie(s, a) {
        Og[s] = a;
      }
      var UU = 1e-4, lie = 20;
      function uie(s) {
        return s.replace(/^\s+|\s+$/g, "");
      }
      function zu(s, a, n6, f6) {
        var d4 = a[0], y4 = a[1], _ = n6[0], S = n6[1], T = y4 - d4, E = S - _;
        if (T === 0)
          return E === 0 ? _ : (_ + S) / 2;
        if (f6)
          if (T > 0) {
            if (s <= d4)
              return _;
            if (s >= y4)
              return S;
          } else {
            if (s >= d4)
              return _;
            if (s <= y4)
              return S;
          }
        else {
          if (s === d4)
            return _;
          if (s === y4)
            return S;
        }
        return (s - d4) / T * E + _;
      }
      function Ia(s, a) {
        switch (s) {
          case "center":
          case "middle":
            s = "50%";
            break;
          case "left":
          case "top":
            s = "0%";
            break;
          case "right":
          case "bottom":
            s = "100%";
            break;
        }
        return Wa(s) ? uie(s).match(/%$/) ? parseFloat(s) / 100 * a : parseFloat(s) : s == null ? NaN : +s;
      }
      function Wp(s, a, n6) {
        return a == null && (a = 10), a = Math.min(Math.max(0, a), lie), s = (+s).toFixed(a), n6 ? s : +s;
      }
      function W1(s) {
        return s.sort(function(a, n6) {
          return a - n6;
        }), s;
      }
      function tx(s) {
        if (s = +s, isNaN(s))
          return 0;
        if (s > 1e-14) {
          for (var a = 1, n6 = 0; n6 < 15; n6++, a *= 10)
            if (Math.round(s * a) / a === s)
              return n6;
        }
        return z9(s);
      }
      function z9(s) {
        var a = s.toString().toLowerCase(), n6 = a.indexOf("e"), f6 = n6 > 0 ? +a.slice(n6 + 1) : 0, d4 = n6 > 0 ? n6 : a.length, y4 = a.indexOf("."), _ = y4 < 0 ? 0 : d4 - 1 - y4;
        return Math.max(0, _ - f6);
      }
      function qU(s, a) {
        var n6 = Math.log, f6 = Math.LN10, d4 = Math.floor(n6(s[1] - s[0]) / f6), y4 = Math.round(n6(Math.abs(a[1] - a[0])) / f6), _ = Math.min(Math.max(-d4 + y4, 0), 20);
        return isFinite(_) ? _ : 20;
      }
      function j9(s, a, n6) {
        if (!s[a])
          return 0;
        var f6 = G_(s, function(H, Z) {
          return H + (isNaN(Z) ? 0 : Z);
        }, 0);
        if (f6 === 0)
          return 0;
        for (var d4 = Math.pow(10, n6), y4 = Pi(s, function(H) {
          return (isNaN(H) ? 0 : H) / f6 * d4 * 100;
        }), _ = d4 * 100, S = Pi(y4, function(H) {
          return Math.floor(H);
        }), T = G_(S, function(H, Z) {
          return H + Z;
        }, 0), E = Pi(y4, function(H, Z) {
          return H - S[Z];
        }); T < _; ) {
          for (var O = Number.NEGATIVE_INFINITY, R = null, V = 0, z3 = E.length; V < z3; ++V)
            E[V] > O && (O = E[V], R = V);
          ++S[R], E[R] = 0, ++T;
        }
        return S[a] / d4;
      }
      function $U(s, a) {
        var n6 = Math.max(tx(s), tx(a)), f6 = s + a;
        return n6 > lie ? f6 : Wp(f6, n6);
      }
      var hR = 9007199254740991;
      function cie(s) {
        var a = Math.PI * 2;
        return (s % a + a) % a;
      }
      function pR(s) {
        return s > -UU && s < UU;
      }
      var G9 = /^(?:(\d{4})(?:[-\/](\d{1,2})(?:[-\/](\d{1,2})(?:[T ](\d{1,2})(?::(\d{1,2})(?::(\d{1,2})(?:[.,](\d+))?)?)?(Z|[\+\-]\d\d:?\d\d)?)?)?)?)?$/;
      function nx(s) {
        if (s instanceof Date)
          return s;
        if (Wa(s)) {
          var a = G9.exec(s);
          if (!a)
            return new Date(NaN);
          if (a[8]) {
            var n6 = +a[4] || 0;
            return a[8].toUpperCase() !== "Z" && (n6 -= +a[8].slice(0, 3)), new Date(Date.UTC(+a[1], +(a[2] || 1) - 1, +a[3] || 1, n6, +(a[5] || 0), +a[6] || 0, a[7] ? +a[7].substring(0, 3) : 0));
          } else
            return new Date(+a[1], +(a[2] || 1) - 1, +a[3] || 1, +a[4] || 0, +(a[5] || 0), +a[6] || 0, a[7] ? +a[7].substring(0, 3) : 0);
        } else if (s == null)
          return new Date(NaN);
        return new Date(Math.round(s));
      }
      function XU(s) {
        return Math.pow(10, YU(s));
      }
      function YU(s) {
        if (s === 0)
          return 0;
        var a = Math.floor(Math.log(s) / Math.LN10);
        return s / Math.pow(10, a) >= 10 && a++, a;
      }
      function KU(s, a) {
        var n6 = YU(s), f6 = Math.pow(10, n6), d4 = s / f6, y4;
        return a ? d4 < 1.5 ? y4 = 1 : d4 < 2.5 ? y4 = 2 : d4 < 4 ? y4 = 3 : d4 < 7 ? y4 = 5 : y4 = 10 : d4 < 1 ? y4 = 1 : d4 < 2 ? y4 = 2 : d4 < 3 ? y4 = 3 : d4 < 5 ? y4 = 5 : y4 = 10, s = y4 * f6, n6 >= -20 ? +s.toFixed(n6 < 0 ? -n6 : 0) : s;
      }
      function rx(s, a) {
        var n6 = (s.length - 1) * a + 1, f6 = Math.floor(n6), d4 = +s[f6 - 1], y4 = n6 - f6;
        return y4 ? d4 + y4 * (s[f6] - d4) : d4;
      }
      function ZU(s) {
        s.sort(function(T, E) {
          return S(T, E, 0) ? -1 : 1;
        });
        for (var a = -1 / 0, n6 = 1, f6 = 0; f6 < s.length; ) {
          for (var d4 = s[f6].interval, y4 = s[f6].close, _ = 0; _ < 2; _++)
            d4[_] <= a && (d4[_] = a, y4[_] = _ ? 1 : 1 - n6), a = d4[_], n6 = y4[_];
          d4[0] === d4[1] && y4[0] * y4[1] !== 1 ? s.splice(f6, 1) : f6++;
        }
        return s;
        function S(T, E, O) {
          return T.interval[O] < E.interval[O] || T.interval[O] === E.interval[O] && (T.close[O] - E.close[O] === (O ? -1 : 1) || !O && S(T, E, 1));
        }
      }
      function eS(s) {
        var a = parseFloat(s);
        return a == s && (a !== 0 || !Wa(s) || s.indexOf("x") <= 0) ? a : NaN;
      }
      function fie(s) {
        return !isNaN(eS(s));
      }
      function JU() {
        return Math.round(Math.random() * 9);
      }
      function hie(s, a) {
        return a === 0 ? s : hie(a, s % a);
      }
      function pie(s, a) {
        return s == null ? a : a == null ? s : s * a / hie(s, a);
      }
      function Ul(s) {
        throw new Error(s);
      }
      function H9(s, a, n6) {
        return (a - s) * n6 + s;
      }
      var W9 = "series\0", U9 = "\0_ec_\0";
      function jc(s) {
        return s instanceof Array ? s : s == null ? [] : [s];
      }
      function Gb(s, a, n6) {
        if (s) {
          s[a] = s[a] || {}, s.emphasis = s.emphasis || {}, s.emphasis[a] = s.emphasis[a] || {};
          for (var f6 = 0, d4 = n6.length; f6 < d4; f6++) {
            var y4 = n6[f6];
            !s.emphasis[a].hasOwnProperty(y4) && s[a].hasOwnProperty(y4) && (s.emphasis[a][y4] = s[a][y4]);
          }
        }
      }
      var Js = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "rich", "tag", "color", "textBorderColor", "textBorderWidth", "width", "height", "lineHeight", "align", "verticalAlign", "baseline", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY", "backgroundColor", "borderColor", "borderWidth", "borderRadius", "padding"];
      function pC(s) {
        return Qo(s) && !Di(s) && !(s instanceof Date) ? s.value : s;
      }
      function QU(s) {
        return Qo(s) && !(s instanceof Array);
      }
      function wT(s, a, n6) {
        var f6 = n6 === "normalMerge", d4 = n6 === "replaceMerge", y4 = n6 === "replaceAll";
        s = s || [], a = (a || []).slice();
        var _ = ro();
        gt(a, function(T, E) {
          if (!Qo(T)) {
            a[E] = null;
            return;
          }
        });
        var S = $be(s, _, n6);
        return (f6 || d4) && eq(S, s, _, a), f6 && die(S, a), f6 || d4 ? S0(S, a, d4) : y4 && Xbe(S, a), Ybe(S), S;
      }
      function $be(s, a, n6) {
        var f6 = [];
        if (n6 === "replaceAll")
          return f6;
        for (var d4 = 0; d4 < s.length; d4++) {
          var y4 = s[d4];
          y4 && y4.id != null && a.set(y4.id, d4), f6.push({ existing: n6 === "replaceMerge" || vR(y4) ? null : y4, newOption: null, keyInfo: null, brandNew: null });
        }
        return f6;
      }
      function eq(s, a, n6, f6) {
        gt(f6, function(d4, y4) {
          if (!(!d4 || d4.id == null)) {
            var _ = dR(d4.id), S = n6.get(_);
            if (S != null) {
              var T = s[S];
              Ty(!T.newOption, 'Duplicated option on id "' + _ + '".'), T.newOption = d4, T.existing = a[S], f6[y4] = null;
            }
          }
        });
      }
      function die(s, a) {
        gt(a, function(n6, f6) {
          if (!(!n6 || n6.name == null))
            for (var d4 = 0; d4 < s.length; d4++) {
              var y4 = s[d4].existing;
              if (!s[d4].newOption && y4 && (y4.id == null || n6.id == null) && !vR(n6) && !vR(y4) && tq("name", y4, n6)) {
                s[d4].newOption = n6, a[f6] = null;
                return;
              }
            }
        });
      }
      function S0(s, a, n6) {
        gt(a, function(f6) {
          if (f6) {
            for (var d4, y4 = 0; (d4 = s[y4]) && (d4.newOption || vR(d4.existing) || d4.existing && f6.id != null && !tq("id", f6, d4.existing)); )
              y4++;
            d4 ? (d4.newOption = f6, d4.brandNew = n6) : s.push({ newOption: f6, brandNew: n6, existing: null, keyInfo: null }), y4++;
          }
        });
      }
      function Xbe(s, a) {
        gt(a, function(n6) {
          s.push({ newOption: n6, brandNew: true, existing: null, keyInfo: null });
        });
      }
      function Ybe(s) {
        var a = ro();
        gt(s, function(n6) {
          var f6 = n6.existing;
          f6 && a.set(f6.id, n6);
        }), gt(s, function(n6) {
          var f6 = n6.newOption;
          Ty(!f6 || f6.id == null || !a.get(f6.id) || a.get(f6.id) === n6, "id duplicates: " + (f6 && f6.id)), f6 && f6.id != null && a.set(f6.id, n6), !n6.keyInfo && (n6.keyInfo = {});
        }), gt(s, function(n6, f6) {
          var d4 = n6.existing, y4 = n6.newOption, _ = n6.keyInfo;
          if (Qo(y4)) {
            if (_.name = y4.name != null ? dR(y4.name) : d4 ? d4.name : W9 + f6, d4)
              _.id = dR(d4.id);
            else if (y4.id != null)
              _.id = dR(y4.id);
            else {
              var S = 0;
              do
                _.id = "\0" + _.name + "\0" + S++;
              while (a.get(_.id));
            }
            a.set(_.id, n6);
          }
        });
      }
      function tq(s, a, n6) {
        var f6 = Cd(a[s], null), d4 = Cd(n6[s], null);
        return f6 != null && d4 != null && f6 === d4;
      }
      function dR(s) {
        return Cd(s, "");
      }
      function Cd(s, a) {
        return s == null ? a : Wa(s) ? s : ac(s) || FL(s) ? s + "" : a;
      }
      function nq(s) {
        var a = s.name;
        return !!(a && a.indexOf(W9));
      }
      function vR(s) {
        return s && s.id != null && dR(s.id).indexOf(U9) === 0;
      }
      function Kbe(s) {
        return U9 + s;
      }
      function dC(s, a, n6) {
        gt(s, function(f6) {
          var d4 = f6.newOption;
          Qo(d4) && (f6.keyInfo.mainType = a, f6.keyInfo.subType = Ly(a, d4, f6.existing, n6));
        });
      }
      function Ly(s, a, n6, f6) {
        var d4 = a.type ? a.type : n6 ? n6.subType : f6.determineSubType(s, a);
        return d4;
      }
      function rq(s, a) {
        var n6 = {}, f6 = {};
        return d4(s || [], n6), d4(a || [], f6, n6), [y4(n6), y4(f6)];
        function d4(_, S, T) {
          for (var E = 0, O = _.length; E < O; E++) {
            var R = Cd(_[E].seriesId, null);
            if (R == null)
              return;
            for (var V = jc(_[E].dataIndex), z3 = T && T[R], H = 0, Z = V.length; H < Z; H++) {
              var ee = V[H];
              z3 && z3[ee] ? z3[ee] = null : (S[R] || (S[R] = {}))[ee] = 1;
            }
          }
        }
        function y4(_, S) {
          var T = [];
          for (var E in _)
            if (_.hasOwnProperty(E) && _[E] != null)
              if (S)
                T.push(+E);
              else {
                var O = y4(_[E], true);
                O.length && T.push({ seriesId: E, dataIndex: O });
              }
          return T;
        }
      }
      function hE(s, a) {
        if (a.dataIndexInside != null)
          return a.dataIndexInside;
        if (a.dataIndex != null)
          return Di(a.dataIndex) ? Pi(a.dataIndex, function(n6) {
            return s.indexOfRawIndex(n6);
          }) : s.indexOfRawIndex(a.dataIndex);
        if (a.name != null)
          return Di(a.name) ? Pi(a.name, function(n6) {
            return s.indexOfName(n6);
          }) : s.indexOfName(a.name);
      }
      function hu() {
        var s = "__ec_inner_" + Zbe++;
        return function(a) {
          return a[s] || (a[s] = {});
        };
      }
      var Zbe = JU();
      function gR(s, a, n6) {
        var f6 = pE(a, n6), d4 = f6.mainTypeSpecified, y4 = f6.queryOptionMap, _ = f6.others, S = _, T = n6 ? n6.defaultMainType : null;
        return !d4 && T && y4.set(T, {}), y4.each(function(E, O) {
          var R = yR(s, O, E, { useDefault: T === O, enableAll: n6 && n6.enableAll != null ? n6.enableAll : true, enableNone: n6 && n6.enableNone != null ? n6.enableNone : true });
          S[O + "Models"] = R.models, S[O + "Model"] = R.models[0];
        }), S;
      }
      function pE(s, a) {
        var n6;
        if (Wa(s)) {
          var f6 = {};
          f6[s + "Index"] = 0, n6 = f6;
        } else
          n6 = s;
        var d4 = ro(), y4 = {}, _ = false;
        return gt(n6, function(S, T) {
          if (T === "dataIndex" || T === "dataIndexInside") {
            y4[T] = S;
            return;
          }
          var E = T.match(/^(\w+)(Index|Id|Name)$/) || [], O = E[1], R = (E[2] || "").toLowerCase();
          if (!(!O || !R || a && a.includeMainTypes && Ns(a.includeMainTypes, O) < 0)) {
            _ = _ || !!O;
            var V = d4.get(O) || d4.set(O, {});
            V[R] = S;
          }
        }), { mainTypeSpecified: _, queryOptionMap: d4, others: y4 };
      }
      var ad = { useDefault: true, enableAll: false, enableNone: false }, vie = { useDefault: false, enableAll: true, enableNone: true };
      function yR(s, a, n6, f6) {
        f6 = f6 || ad;
        var d4 = n6.index, y4 = n6.id, _ = n6.name, S = { models: null, specified: d4 != null || y4 != null || _ != null };
        if (!S.specified) {
          var T = void 0;
          return S.models = f6.useDefault && (T = s.getComponent(a)) ? [T] : [], S;
        }
        return d4 === "none" || d4 === false ? (Ty(f6.enableNone, '`"none"` or `false` is not a valid value on index option.'), S.models = [], S) : (d4 === "all" && (Ty(f6.enableAll, '`"all"` is not a valid value on index option.'), d4 = y4 = _ = null), S.models = s.queryComponents({ mainType: a, index: d4, id: y4, name: _ }), S);
      }
      function gie(s, a, n6) {
        s.setAttribute ? s.setAttribute(a, n6) : s[a] = n6;
      }
      function Jbe(s, a) {
        return s.getAttribute ? s.getAttribute(a) : s[a];
      }
      function Qbe(s) {
        return s === "auto" ? Na.domSupported ? "html" : "richText" : s || "html";
      }
      function q9(s, a) {
        var n6 = ro(), f6 = [];
        return gt(s, function(d4) {
          var y4 = a(d4);
          (n6.get(y4) || (f6.push(y4), n6.set(y4, []))).push(d4);
        }), { keys: f6, buckets: n6 };
      }
      function iq(s, a, n6, f6, d4) {
        var y4 = a == null || a === "auto";
        if (f6 == null)
          return f6;
        if (ac(f6)) {
          var _ = H9(n6 || 0, f6, d4);
          return Wp(_, y4 ? Math.max(tx(n6 || 0), tx(f6)) : a);
        } else {
          if (Wa(f6))
            return d4 < 1 ? n6 : f6;
          for (var S = [], T = n6, E = f6, O = Math.max(T ? T.length : 0, E.length), R = 0; R < O; ++R) {
            var V = s.getDimensionInfo(R);
            if (V && V.type === "ordinal")
              S[R] = (d4 < 1 && T ? T : E)[R];
            else {
              var z3 = T && T[R] ? T[R] : 0, H = E[R], _ = H9(z3, H, d4);
              S[R] = Wp(_, y4 ? Math.max(tx(z3), tx(H)) : a);
            }
          }
          return S;
        }
      }
      var e_e = ".", vC = "___EC__COMPONENT__CONTAINER___", aq = "___EC__EXTENDED_CLASS___";
      function Rm(s) {
        var a = { main: "", sub: "" };
        if (s) {
          var n6 = s.split(e_e);
          a.main = n6[0] || "", a.sub = n6[1] || "";
        }
        return a;
      }
      function oq(s) {
        Ty(/^[a-zA-Z0-9_]+([.][a-zA-Z0-9_]+)?$/.test(s), 'componentType "' + s + '" illegal');
      }
      function yie(s) {
        return !!(s && s[aq]);
      }
      function $9(s, a) {
        s.$constructor = s, s.extend = function(n6) {
          var f6 = this, d4;
          return X9(f6) ? d4 = function(y4) {
            Vt(_, y4);
            function _() {
              return y4.apply(this, arguments) || this;
            }
            return _;
          }(f6) : (d4 = function() {
            (n6.$constructor || f6).apply(this, arguments);
          }, Ere(d4, this)), ei(d4.prototype, n6), d4[aq] = true, d4.extend = this.extend, d4.superCall = t_e, d4.superApply = mie, d4.superClass = f6, d4;
        };
      }
      function X9(s) {
        return jo(s) && /^class\s/.test(Function.prototype.toString.call(s));
      }
      function sq(s, a) {
        s.extend = a.extend;
      }
      var tS = Math.round(Math.random() * 10);
      function dE(s) {
        var a = ["__\0is_clz", tS++].join("_");
        s.prototype[a] = true, s.isInstance = function(n6) {
          return !!(n6 && n6[a]);
        };
      }
      function t_e(s, a) {
        for (var n6 = [], f6 = 2; f6 < arguments.length; f6++)
          n6[f6 - 2] = arguments[f6];
        return this.superClass.prototype[a].apply(s, n6);
      }
      function mie(s, a, n6) {
        return this.superClass.prototype[a].apply(s, n6);
      }
      function Y9(s) {
        var a = {};
        s.registerClass = function(f6) {
          var d4 = f6.type || f6.prototype.type;
          if (d4) {
            oq(d4), f6.prototype.type = d4;
            var y4 = Rm(d4);
            if (!y4.sub)
              a[y4.main] = f6;
            else if (y4.sub !== vC) {
              var _ = n6(y4);
              _[y4.sub] = f6;
            }
          }
          return f6;
        }, s.getClass = function(f6, d4, y4) {
          var _ = a[f6];
          if (_ && _[vC] && (_ = d4 ? _[d4] : null), y4 && !_)
            throw new Error(d4 ? "Component " + f6 + "." + (d4 || "") + " is used but not imported." : f6 + ".type should be specified.");
          return _;
        }, s.getClassesByMainType = function(f6) {
          var d4 = Rm(f6), y4 = [], _ = a[d4.main];
          return _ && _[vC] ? gt(_, function(S, T) {
            T !== vC && y4.push(S);
          }) : y4.push(_), y4;
        }, s.hasClass = function(f6) {
          var d4 = Rm(f6);
          return !!a[d4.main];
        }, s.getAllClassMainTypes = function() {
          var f6 = [];
          return gt(a, function(d4, y4) {
            f6.push(y4);
          }), f6;
        }, s.hasSubTypes = function(f6) {
          var d4 = Rm(f6), y4 = a[d4.main];
          return y4 && y4[vC];
        };
        function n6(f6) {
          var d4 = a[f6.main];
          return (!d4 || !d4[vC]) && (d4 = a[f6.main] = {}, d4[vC] = true), d4;
        }
      }
      function vE(s, a) {
        for (var n6 = 0; n6 < s.length; n6++)
          s[n6][1] || (s[n6][1] = s[n6][0]);
        return a = a || false, function(f6, d4, y4) {
          for (var _ = {}, S = 0; S < s.length; S++) {
            var T = s[S][1];
            if (!(d4 && Ns(d4, T) >= 0 || y4 && Ns(y4, T) < 0)) {
              var E = f6.getShallow(T, a);
              E != null && (_[s[S][0]] = E);
            }
          }
          return _;
        };
      }
      var n_e = [["fill", "color"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["opacity"], ["shadowColor"]], r_e = vE(n_e), i_e = function() {
        function s() {
        }
        return s.prototype.getAreaStyle = function(a, n6) {
          return r_e(this, a, n6);
        }, s;
      }(), lq = new aC(50);
      function a_e(s) {
        if (typeof s == "string") {
          var a = lq.get(s);
          return a && a.image;
        } else
          return s;
      }
      function uq(s, a, n6, f6, d4) {
        if (s)
          if (typeof s == "string") {
            if (a && a.__zrImageSrc === s || !n6)
              return a;
            var y4 = lq.get(s), _ = { hostEl: n6, cb: f6, cbPayload: d4 };
            if (y4)
              a = y4.image, !K9(a) && y4.pending.push(_);
            else {
              var S = td.loadImage(s, bie, bie);
              S.__zrImageSrc = s, lq.put(s, S.__cachedImgObj = { image: S, pending: [_] });
            }
            return a;
          } else
            return s;
        else
          return a;
      }
      function bie() {
        var s = this.__cachedImgObj;
        this.onload = this.onerror = this.__cachedImgObj = null;
        for (var a = 0; a < s.pending.length; a++) {
          var n6 = s.pending[a], f6 = n6.cb;
          f6 && f6(this, n6.cbPayload), n6.hostEl.dirty();
        }
        s.pending.length = 0;
      }
      function K9(s) {
        return s && s.width && s.height;
      }
      var cq = /\{([a-zA-Z0-9_]+)\|([^}]*)\}/g;
      function _ie(s, a, n6, f6, d4) {
        if (!a)
          return "";
        var y4 = (s + "").split(`
`);
        d4 = fq(a, n6, f6, d4);
        for (var _ = 0, S = y4.length; _ < S; _++)
          y4[_] = hq(y4[_], d4);
        return y4.join(`
`);
      }
      function fq(s, a, n6, f6) {
        f6 = f6 || {};
        var d4 = ei({}, f6);
        d4.font = a, n6 = Zs(n6, "..."), d4.maxIterations = Zs(f6.maxIterations, 2);
        var y4 = d4.minChar = Zs(f6.minChar, 0);
        d4.cnCharWidth = sp("\u56FD", a);
        var _ = d4.ascCharWidth = sp("a", a);
        d4.placeholder = Zs(f6.placeholder, "");
        for (var S = s = Math.max(0, s - 1), T = 0; T < y4 && S >= _; T++)
          S -= _;
        var E = sp(n6, a);
        return E > S && (n6 = "", E = 0), S = s - E, d4.ellipsis = n6, d4.ellipsisWidth = E, d4.contentWidth = S, d4.containerWidth = s, d4;
      }
      function hq(s, a) {
        var n6 = a.containerWidth, f6 = a.font, d4 = a.contentWidth;
        if (!n6)
          return "";
        var y4 = sp(s, f6);
        if (y4 <= n6)
          return s;
        for (var _ = 0; ; _++) {
          if (y4 <= d4 || _ >= a.maxIterations) {
            s += a.ellipsis;
            break;
          }
          var S = _ === 0 ? o_e(s, d4, a.ascCharWidth, a.cnCharWidth) : y4 > 0 ? Math.floor(s.length * d4 / y4) : 0;
          s = s.substr(0, S), y4 = sp(s, f6);
        }
        return s === "" && (s = a.placeholder), s;
      }
      function o_e(s, a, n6, f6) {
        for (var d4 = 0, y4 = 0, _ = s.length; y4 < _ && d4 < a; y4++) {
          var S = s.charCodeAt(y4);
          d4 += 0 <= S && S <= 127 ? n6 : f6;
        }
        return y4;
      }
      function s_e(s, a) {
        s != null && (s += "");
        var n6 = a.overflow, f6 = a.padding, d4 = a.font, y4 = n6 === "truncate", _ = sR(d4), S = Zs(a.lineHeight, _), T = !!a.backgroundColor, E = a.lineOverflow === "truncate", O = a.width, R;
        O != null && (n6 === "break" || n6 === "breakAll") ? R = s ? U1(s, a.font, O, n6 === "breakAll", 0).lines : [] : R = s ? s.split(`
`) : [];
        var V = R.length * S, z3 = Zs(a.height, V);
        if (V > z3 && E) {
          var H = Math.floor(z3 / S);
          R = R.slice(0, H);
        }
        if (s && y4 && O != null)
          for (var Z = fq(O, d4, a.ellipsis, { minChar: a.truncateMinChar, placeholder: a.placeholder }), ee = 0; ee < R.length; ee++)
            R[ee] = hq(R[ee], Z);
        for (var oe = z3, fe = 0, ee = 0; ee < R.length; ee++)
          fe = Math.max(sp(R[ee], d4), fe);
        O == null && (O = fe);
        var _e = fe;
        return f6 && (oe += f6[0] + f6[2], _e += f6[1] + f6[3], O += f6[1] + f6[3]), T && (_e = O), { lines: R, height: z3, outerWidth: _e, outerHeight: oe, lineHeight: S, calculatedLineHeight: _, contentWidth: fe, contentHeight: V, width: O };
      }
      var l_e = function() {
        function s() {
        }
        return s;
      }(), pq = function() {
        function s(a) {
          this.tokens = [], a && (this.tokens = a);
        }
        return s;
      }(), u_e = function() {
        function s() {
          this.width = 0, this.height = 0, this.contentWidth = 0, this.contentHeight = 0, this.outerWidth = 0, this.outerHeight = 0, this.lines = [];
        }
        return s;
      }();
      function c_e(s, a) {
        var n6 = new u_e();
        if (s != null && (s += ""), !s)
          return n6;
        for (var f6 = a.width, d4 = a.height, y4 = a.overflow, _ = (y4 === "break" || y4 === "breakAll") && f6 != null ? { width: f6, accumWidth: 0, breakAll: y4 === "breakAll" } : null, S = cq.lastIndex = 0, T; (T = cq.exec(s)) != null; ) {
          var E = T.index;
          E > S && dq(n6, s.substring(S, E), a, _), dq(n6, T[2], a, _, T[1]), S = cq.lastIndex;
        }
        S < s.length && dq(n6, s.substring(S, s.length), a, _);
        var O = [], R = 0, V = 0, z3 = a.padding, H = y4 === "truncate", Z = a.lineOverflow === "truncate";
        function ee(un, pn, On) {
          un.width = pn, un.lineHeight = On, R += On, V = Math.max(V, pn);
        }
        e:
          for (var oe = 0; oe < n6.lines.length; oe++) {
            for (var fe = n6.lines[oe], _e = 0, pe = 0, Ve = 0; Ve < fe.tokens.length; Ve++) {
              var Le = fe.tokens[Ve], je = Le.styleName && a.rich[Le.styleName] || {}, Xe = Le.textPadding = je.padding, Ye = Xe ? Xe[1] + Xe[3] : 0, rt2 = Le.font = je.font || a.font;
              Le.contentHeight = sR(rt2);
              var ut = Zs(je.height, Le.contentHeight);
              if (Le.innerHeight = ut, Xe && (ut += Xe[0] + Xe[2]), Le.height = ut, Le.lineHeight = rC(je.lineHeight, a.lineHeight, ut), Le.align = je && je.align || a.align, Le.verticalAlign = je && je.verticalAlign || "middle", Z && d4 != null && R + Le.lineHeight > d4) {
                Ve > 0 ? (fe.tokens = fe.tokens.slice(0, Ve), ee(fe, pe, _e), n6.lines = n6.lines.slice(0, oe + 1)) : n6.lines = n6.lines.slice(0, oe);
                break e;
              }
              var wt = je.width, dt = wt == null || wt === "auto";
              if (typeof wt == "string" && wt.charAt(wt.length - 1) === "%")
                Le.percentWidth = wt, O.push(Le), Le.contentWidth = sp(Le.text, rt2);
              else {
                if (dt) {
                  var Gt = je.backgroundColor, Qt = Gt && Gt.image;
                  Qt && (Qt = a_e(Qt), K9(Qt) && (Le.width = Math.max(Le.width, Qt.width * ut / Qt.height)));
                }
                var Nt = H && f6 != null ? f6 - pe : null;
                Nt != null && Nt < Le.width ? !dt || Nt < Ye ? (Le.text = "", Le.width = Le.contentWidth = 0) : (Le.text = _ie(Le.text, Nt - Ye, rt2, a.ellipsis, { minChar: a.truncateMinChar }), Le.width = Le.contentWidth = sp(Le.text, rt2)) : Le.contentWidth = sp(Le.text, rt2);
              }
              Le.width += Ye, pe += Le.width, je && (_e = Math.max(_e, Le.lineHeight));
            }
            ee(fe, pe, _e);
          }
        n6.outerWidth = n6.width = Zs(f6, V), n6.outerHeight = n6.height = Zs(d4, R), n6.contentHeight = R, n6.contentWidth = V, z3 && (n6.outerWidth += z3[1] + z3[3], n6.outerHeight += z3[0] + z3[2]);
        for (var oe = 0; oe < O.length; oe++) {
          var Le = O[oe], er = Le.percentWidth;
          Le.width = parseInt(er, 10) / 100 * n6.width;
        }
        return n6;
      }
      function dq(s, a, n6, f6, d4) {
        var y4 = a === "", _ = d4 && n6.rich[d4] || {}, S = s.lines, T = _.font || n6.font, E = false, O, R;
        if (f6) {
          var V = _.padding, z3 = V ? V[1] + V[3] : 0;
          if (_.width != null && _.width !== "auto") {
            var H = H1(_.width, f6.width) + z3;
            S.length > 0 && H + f6.accumWidth > f6.width && (O = a.split(`
`), E = true), f6.accumWidth = H;
          } else {
            var Z = U1(a, T, f6.width, f6.breakAll, f6.accumWidth);
            f6.accumWidth = Z.accumWidth + z3, R = Z.linesWidths, O = Z.lines;
          }
        } else
          O = a.split(`
`);
        for (var ee = 0; ee < O.length; ee++) {
          var oe = O[ee], fe = new l_e();
          if (fe.styleName = d4, fe.text = oe, fe.isLineHolder = !oe && !y4, typeof _.width == "number" ? fe.width = _.width : fe.width = R ? R[ee] : sp(oe, T), !ee && !E) {
            var _e = (S[S.length - 1] || (S[0] = new pq())).tokens, pe = _e.length;
            pe === 1 && _e[0].isLineHolder ? _e[0] = fe : (oe || !pe || y4) && _e.push(fe);
          } else
            S.push(new pq([fe]));
        }
      }
      function f_e(s) {
        var a = s.charCodeAt(0);
        return a >= 33 && a <= 383;
      }
      var h_e = G_(",&?/;] ".split(""), function(s, a) {
        return s[a] = true, s;
      }, {});
      function p_e(s) {
        return f_e(s) ? !!h_e[s] : true;
      }
      function U1(s, a, n6, f6, d4) {
        for (var y4 = [], _ = [], S = "", T = "", E = 0, O = 0, R = 0; R < s.length; R++) {
          var V = s.charAt(R);
          if (V === `
`) {
            T && (S += T, O += E), y4.push(S), _.push(O), S = "", T = "", E = 0, O = 0;
            continue;
          }
          var z3 = sp(V, a), H = f6 ? false : !p_e(V);
          if (y4.length ? O + z3 > n6 : d4 + O + z3 > n6) {
            O ? (S || T) && (H ? (S || (S = T, T = "", E = 0, O = E), y4.push(S), _.push(O - E), T += V, E += z3, S = "", O = E) : (T && (S += T, T = "", E = 0), y4.push(S), _.push(O), S = V, O = z3)) : H ? (y4.push(T), _.push(E), T = V, E = z3) : (y4.push(V), _.push(z3));
            continue;
          }
          O += z3, H ? (T += V, E += z3) : (T && (S += T, T = "", E = 0), S += V);
        }
        return !y4.length && !S && (S = s, T = "", E = 0), T && (S += T), S && (y4.push(S), _.push(O)), y4.length === 1 && (O += d4), { accumWidth: O, lines: y4, linesWidths: _ };
      }
      var vq = "__zr_style_" + Math.round(Math.random() * 10), gE = { shadowBlur: 0, shadowOffsetX: 0, shadowOffsetY: 0, shadowColor: "#000", opacity: 1, blend: "source-over" }, Z9 = { style: { shadowBlur: true, shadowOffsetX: true, shadowOffsetY: true, shadowColor: true, opacity: true } };
      gE[vq] = true;
      var gq = ["z", "z2", "invisible"], d_e = ["invisible"], v_e = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype._init = function(n6) {
          for (var f6 = Wl(n6), d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            y4 === "style" ? this.useStyle(n6[y4]) : s.prototype.attrKV.call(this, y4, n6[y4]);
          }
          this.style || this.useStyle({});
        }, a.prototype.beforeBrush = function() {
        }, a.prototype.afterBrush = function() {
        }, a.prototype.innerBeforeBrush = function() {
        }, a.prototype.innerAfterBrush = function() {
        }, a.prototype.shouldBePainted = function(n6, f6, d4, y4) {
          var _ = this.transform;
          if (this.ignore || this.invisible || this.style.opacity === 0 || this.culling && bq(this, n6, f6) || _ && !_[0] && !_[3])
            return false;
          if (d4 && this.__clipPaths) {
            for (var S = 0; S < this.__clipPaths.length; ++S)
              if (this.__clipPaths[S].isZeroArea())
                return false;
          }
          if (y4 && this.parent)
            for (var T = this.parent; T; ) {
              if (T.ignore)
                return false;
              T = T.parent;
            }
          return true;
        }, a.prototype.contain = function(n6, f6) {
          return this.rectContain(n6, f6);
        }, a.prototype.traverse = function(n6, f6) {
          n6.call(f6, this);
        }, a.prototype.rectContain = function(n6, f6) {
          var d4 = this.transformCoordToLocal(n6, f6), y4 = this.getBoundingRect();
          return y4.contain(d4[0], d4[1]);
        }, a.prototype.getPaintRect = function() {
          var n6 = this._paintRect;
          if (!this._paintRect || this.__dirty) {
            var f6 = this.transform, d4 = this.getBoundingRect(), y4 = this.style, _ = y4.shadowBlur || 0, S = y4.shadowOffsetX || 0, T = y4.shadowOffsetY || 0;
            n6 = this._paintRect || (this._paintRect = new il(0, 0, 0, 0)), f6 ? il.applyTransform(n6, d4, f6) : n6.copy(d4), (_ || S || T) && (n6.width += _ * 2 + Math.abs(S), n6.height += _ * 2 + Math.abs(T), n6.x = Math.min(n6.x, n6.x + S - _), n6.y = Math.min(n6.y, n6.y + T - _));
            var E = this.dirtyRectTolerance;
            n6.isZero() || (n6.x = Math.floor(n6.x - E), n6.y = Math.floor(n6.y - E), n6.width = Math.ceil(n6.width + 1 + E * 2), n6.height = Math.ceil(n6.height + 1 + E * 2));
          }
          return n6;
        }, a.prototype.setPrevPaintRect = function(n6) {
          n6 ? (this._prevPaintRect = this._prevPaintRect || new il(0, 0, 0, 0), this._prevPaintRect.copy(n6)) : this._prevPaintRect = null;
        }, a.prototype.getPrevPaintRect = function() {
          return this._prevPaintRect;
        }, a.prototype.animateStyle = function(n6) {
          return this.animate("style", n6);
        }, a.prototype.updateDuringAnimation = function(n6) {
          n6 === "style" ? this.dirtyStyle() : this.markRedraw();
        }, a.prototype.attrKV = function(n6, f6) {
          n6 !== "style" ? s.prototype.attrKV.call(this, n6, f6) : this.style ? this.setStyle(f6) : this.useStyle(f6);
        }, a.prototype.setStyle = function(n6, f6) {
          return typeof n6 == "string" ? this.style[n6] = f6 : ei(this.style, n6), this.dirtyStyle(), this;
        }, a.prototype.dirtyStyle = function(n6) {
          n6 || this.markRedraw(), this.__dirty |= qL, this._rect && (this._rect = null);
        }, a.prototype.dirty = function() {
          this.dirtyStyle();
        }, a.prototype.styleChanged = function() {
          return !!(this.__dirty & qL);
        }, a.prototype.styleUpdated = function() {
          this.__dirty &= ~qL;
        }, a.prototype.createStyle = function(n6) {
          return zL(gE, n6);
        }, a.prototype.useStyle = function(n6) {
          n6[vq] || (n6 = this.createStyle(n6)), this.__inHover ? this.__hoverStyle = n6 : this.style = n6, this.dirtyStyle();
        }, a.prototype.isStyleObject = function(n6) {
          return n6[vq];
        }, a.prototype._innerSaveToNormal = function(n6) {
          s.prototype._innerSaveToNormal.call(this, n6);
          var f6 = this._normalState;
          n6.style && !f6.style && (f6.style = this._mergeStyle(this.createStyle(), this.style)), this._savePrimaryToNormal(n6, f6, gq);
        }, a.prototype._applyStateObj = function(n6, f6, d4, y4, _, S) {
          s.prototype._applyStateObj.call(this, n6, f6, d4, y4, _, S);
          var T = !(f6 && y4), E;
          if (f6 && f6.style ? _ ? y4 ? E = f6.style : (E = this._mergeStyle(this.createStyle(), d4.style), this._mergeStyle(E, f6.style)) : (E = this._mergeStyle(this.createStyle(), y4 ? this.style : d4.style), this._mergeStyle(E, f6.style)) : T && (E = d4.style), E)
            if (_) {
              var O = this.style;
              if (this.style = this.createStyle(T ? {} : O), T)
                for (var R = Wl(O), V = 0; V < R.length; V++) {
                  var z3 = R[V];
                  z3 in E && (E[z3] = E[z3], this.style[z3] = O[z3]);
                }
              for (var H = Wl(E), V = 0; V < H.length; V++) {
                var z3 = H[V];
                this.style[z3] = this.style[z3];
              }
              this._transitionState(n6, { style: E }, S, this.getAnimationStyleProps());
            } else
              this.useStyle(E);
          for (var Z = this.__inHover ? d_e : gq, V = 0; V < Z.length; V++) {
            var z3 = Z[V];
            f6 && f6[z3] != null ? this[z3] = f6[z3] : T && d4[z3] != null && (this[z3] = d4[z3]);
          }
        }, a.prototype._mergeStates = function(n6) {
          for (var f6 = s.prototype._mergeStates.call(this, n6), d4, y4 = 0; y4 < n6.length; y4++) {
            var _ = n6[y4];
            _.style && (d4 = d4 || {}, this._mergeStyle(d4, _.style));
          }
          return d4 && (f6.style = d4), f6;
        }, a.prototype._mergeStyle = function(n6, f6) {
          return ei(n6, f6), n6;
        }, a.prototype.getAnimationStyleProps = function() {
          return Z9;
        }, a.initDefaultProps = function() {
          var n6 = a.prototype;
          n6.type = "displayable", n6.invisible = false, n6.z = 0, n6.z2 = 0, n6.zlevel = 0, n6.culling = false, n6.cursor = "pointer", n6.rectHover = false, n6.incremental = false, n6._rect = null, n6.dirtyRectTolerance = 0, n6.__dirty = x0 | qL;
        }(), a;
      }(oie), yq = new il(0, 0, 0, 0), mq = new il(0, 0, 0, 0);
      function bq(s, a, n6) {
        return yq.copy(s.getBoundingRect()), s.transform && yq.applyTransform(s.transform), mq.width = a, mq.height = n6, !yq.intersect(mq);
      }
      var Hb = v_e, Nm = Math.min, Fm = Math.max, _q = Math.sin, xq = Math.cos, yE = Math.PI * 2, J9 = gv(), Q9 = gv(), e7 = gv();
      function t7(s, a, n6) {
        if (s.length !== 0) {
          for (var f6 = s[0], d4 = f6[0], y4 = f6[0], _ = f6[1], S = f6[1], T = 1; T < s.length; T++)
            f6 = s[T], d4 = Nm(d4, f6[0]), y4 = Fm(y4, f6[0]), _ = Nm(_, f6[1]), S = Fm(S, f6[1]);
          a[0] = d4, a[1] = _, n6[0] = y4, n6[1] = S;
        }
      }
      function xie(s, a, n6, f6, d4, y4) {
        d4[0] = Nm(s, n6), d4[1] = Nm(a, f6), y4[0] = Fm(s, n6), y4[1] = Fm(a, f6);
      }
      var wie = [], Sie = [];
      function g_e(s, a, n6, f6, d4, y4, _, S, T, E) {
        var O = Hre, R = id2, V = O(s, n6, d4, _, wie);
        T[0] = 1 / 0, T[1] = 1 / 0, E[0] = -1 / 0, E[1] = -1 / 0;
        for (var z3 = 0; z3 < V; z3++) {
          var H = R(s, n6, d4, _, wie[z3]);
          T[0] = Nm(H, T[0]), E[0] = Fm(H, E[0]);
        }
        V = O(a, f6, y4, S, Sie);
        for (var z3 = 0; z3 < V; z3++) {
          var Z = R(a, f6, y4, S, Sie[z3]);
          T[1] = Nm(Z, T[1]), E[1] = Fm(Z, E[1]);
        }
        T[0] = Nm(s, T[0]), E[0] = Fm(s, E[0]), T[0] = Nm(_, T[0]), E[0] = Fm(_, E[0]), T[1] = Nm(a, T[1]), E[1] = Fm(a, E[1]), T[1] = Nm(S, T[1]), E[1] = Fm(S, E[1]);
      }
      function y_e(s, a, n6, f6, d4, y4, _, S) {
        var T = Wre, E = Yv, O = Fm(Nm(T(s, n6, d4), 1), 0), R = Fm(Nm(T(a, f6, y4), 1), 0), V = E(s, n6, d4, O), z3 = E(a, f6, y4, R);
        _[0] = Nm(s, d4, V), _[1] = Nm(a, y4, z3), S[0] = Fm(s, d4, V), S[1] = Fm(a, y4, z3);
      }
      function m_e(s, a, n6, f6, d4, y4, _, S, T) {
        var E = H_, O = G1, R = Math.abs(d4 - y4);
        if (R % yE < 1e-4 && R > 1e-4) {
          S[0] = s - n6, S[1] = a - f6, T[0] = s + n6, T[1] = a + f6;
          return;
        }
        if (J9[0] = xq(d4) * n6 + s, J9[1] = _q(d4) * f6 + a, Q9[0] = xq(y4) * n6 + s, Q9[1] = _q(y4) * f6 + a, E(S, J9, Q9), O(T, J9, Q9), d4 = d4 % yE, d4 < 0 && (d4 = d4 + yE), y4 = y4 % yE, y4 < 0 && (y4 = y4 + yE), d4 > y4 && !_ ? y4 += yE : d4 < y4 && _ && (d4 += yE), _) {
          var V = y4;
          y4 = d4, d4 = V;
        }
        for (var z3 = 0; z3 < y4; z3 += Math.PI / 2)
          z3 > d4 && (e7[0] = xq(z3) * n6 + s, e7[1] = _q(z3) * f6 + a, E(S, e7, S), O(T, e7, T));
      }
      var Pf = { M: 1, L: 2, C: 3, Q: 4, A: 5, Z: 6, R: 7 }, mE = [], bE = [], nS = [], rS = [], ix = [], iS = [], wq = Math.min, Sq = Math.max, _E = Math.cos, xE = Math.sin, gC = Math.abs, Cq = Math.PI, ST = Cq * 2, n7 = typeof Float32Array != "undefined", mR = [];
      function zk(s) {
        var a = Math.round(s / Cq * 1e8) / 1e8;
        return a % 2 * Cq;
      }
      function b_e(s, a) {
        var n6 = zk(s[0]);
        n6 < 0 && (n6 += ST);
        var f6 = n6 - s[0], d4 = s[1];
        d4 += f6, !a && d4 - n6 >= ST ? d4 = n6 + ST : a && n6 - d4 >= ST ? d4 = n6 - ST : !a && n6 > d4 ? d4 = n6 + (ST - zk(n6 - d4)) : a && n6 < d4 && (d4 = n6 - (ST - zk(d4 - n6))), s[0] = n6, s[1] = d4;
      }
      var x_e = function() {
        function s(a) {
          this.dpr = 1, this._xi = 0, this._yi = 0, this._x0 = 0, this._y0 = 0, this._len = 0, a && (this._saveData = false), this._saveData && (this.data = []);
        }
        return s.prototype.increaseVersion = function() {
          this._version++;
        }, s.prototype.getVersion = function() {
          return this._version;
        }, s.prototype.setScale = function(a, n6, f6) {
          f6 = f6 || 0, f6 > 0 && (this._ux = gC(f6 / O9 / a) || 0, this._uy = gC(f6 / O9 / n6) || 0);
        }, s.prototype.setDPR = function(a) {
          this.dpr = a;
        }, s.prototype.setContext = function(a) {
          this._ctx = a;
        }, s.prototype.getContext = function() {
          return this._ctx;
        }, s.prototype.beginPath = function() {
          return this._ctx && this._ctx.beginPath(), this.reset(), this;
        }, s.prototype.reset = function() {
          this._saveData && (this._len = 0), this._pathSegLen && (this._pathSegLen = null, this._pathLen = 0), this._version++;
        }, s.prototype.moveTo = function(a, n6) {
          return this._drawPendingPt(), this.addData(Pf.M, a, n6), this._ctx && this._ctx.moveTo(a, n6), this._x0 = a, this._y0 = n6, this._xi = a, this._yi = n6, this;
        }, s.prototype.lineTo = function(a, n6) {
          var f6 = gC(a - this._xi), d4 = gC(n6 - this._yi), y4 = f6 > this._ux || d4 > this._uy;
          if (this.addData(Pf.L, a, n6), this._ctx && y4 && this._ctx.lineTo(a, n6), y4)
            this._xi = a, this._yi = n6, this._pendingPtDist = 0;
          else {
            var _ = f6 * f6 + d4 * d4;
            _ > this._pendingPtDist && (this._pendingPtX = a, this._pendingPtY = n6, this._pendingPtDist = _);
          }
          return this;
        }, s.prototype.bezierCurveTo = function(a, n6, f6, d4, y4, _) {
          return this._drawPendingPt(), this.addData(Pf.C, a, n6, f6, d4, y4, _), this._ctx && this._ctx.bezierCurveTo(a, n6, f6, d4, y4, _), this._xi = y4, this._yi = _, this;
        }, s.prototype.quadraticCurveTo = function(a, n6, f6, d4) {
          return this._drawPendingPt(), this.addData(Pf.Q, a, n6, f6, d4), this._ctx && this._ctx.quadraticCurveTo(a, n6, f6, d4), this._xi = f6, this._yi = d4, this;
        }, s.prototype.arc = function(a, n6, f6, d4, y4, _) {
          this._drawPendingPt(), mR[0] = d4, mR[1] = y4, b_e(mR, _), d4 = mR[0], y4 = mR[1];
          var S = y4 - d4;
          return this.addData(Pf.A, a, n6, f6, f6, d4, S, 0, _ ? 0 : 1), this._ctx && this._ctx.arc(a, n6, f6, d4, y4, _), this._xi = _E(y4) * f6 + a, this._yi = xE(y4) * f6 + n6, this;
        }, s.prototype.arcTo = function(a, n6, f6, d4, y4) {
          return this._drawPendingPt(), this._ctx && this._ctx.arcTo(a, n6, f6, d4, y4), this;
        }, s.prototype.rect = function(a, n6, f6, d4) {
          return this._drawPendingPt(), this._ctx && this._ctx.rect(a, n6, f6, d4), this.addData(Pf.R, a, n6, f6, d4), this;
        }, s.prototype.closePath = function() {
          this._drawPendingPt(), this.addData(Pf.Z);
          var a = this._ctx, n6 = this._x0, f6 = this._y0;
          return a && a.closePath(), this._xi = n6, this._yi = f6, this;
        }, s.prototype.fill = function(a) {
          a && a.fill(), this.toStatic();
        }, s.prototype.stroke = function(a) {
          a && a.stroke(), this.toStatic();
        }, s.prototype.len = function() {
          return this._len;
        }, s.prototype.setData = function(a) {
          var n6 = a.length;
          !(this.data && this.data.length === n6) && n7 && (this.data = new Float32Array(n6));
          for (var f6 = 0; f6 < n6; f6++)
            this.data[f6] = a[f6];
          this._len = n6;
        }, s.prototype.appendPath = function(a) {
          a instanceof Array || (a = [a]);
          for (var n6 = a.length, f6 = 0, d4 = this._len, y4 = 0; y4 < n6; y4++)
            f6 += a[y4].len();
          n7 && this.data instanceof Float32Array && (this.data = new Float32Array(d4 + f6));
          for (var y4 = 0; y4 < n6; y4++)
            for (var _ = a[y4].data, S = 0; S < _.length; S++)
              this.data[d4++] = _[S];
          this._len = d4;
        }, s.prototype.addData = function(a, n6, f6, d4, y4, _, S, T, E) {
          if (this._saveData) {
            var O = this.data;
            this._len + arguments.length > O.length && (this._expandData(), O = this.data);
            for (var R = 0; R < arguments.length; R++)
              O[this._len++] = arguments[R];
          }
        }, s.prototype._drawPendingPt = function() {
          this._pendingPtDist > 0 && (this._ctx && this._ctx.lineTo(this._pendingPtX, this._pendingPtY), this._pendingPtDist = 0);
        }, s.prototype._expandData = function() {
          if (!(this.data instanceof Array)) {
            for (var a = [], n6 = 0; n6 < this._len; n6++)
              a[n6] = this.data[n6];
            this.data = a;
          }
        }, s.prototype.toStatic = function() {
          if (this._saveData) {
            this._drawPendingPt();
            var a = this.data;
            a instanceof Array && (a.length = this._len, n7 && this._len > 11 && (this.data = new Float32Array(a)));
          }
        }, s.prototype.getBoundingRect = function() {
          nS[0] = nS[1] = ix[0] = ix[1] = Number.MAX_VALUE, rS[0] = rS[1] = iS[0] = iS[1] = -Number.MAX_VALUE;
          var a = this.data, n6 = 0, f6 = 0, d4 = 0, y4 = 0, _;
          for (_ = 0; _ < this._len; ) {
            var S = a[_++], T = _ === 1;
            switch (T && (n6 = a[_], f6 = a[_ + 1], d4 = n6, y4 = f6), S) {
              case Pf.M:
                n6 = d4 = a[_++], f6 = y4 = a[_++], ix[0] = d4, ix[1] = y4, iS[0] = d4, iS[1] = y4;
                break;
              case Pf.L:
                xie(n6, f6, a[_], a[_ + 1], ix, iS), n6 = a[_++], f6 = a[_++];
                break;
              case Pf.C:
                g_e(n6, f6, a[_++], a[_++], a[_++], a[_++], a[_], a[_ + 1], ix, iS), n6 = a[_++], f6 = a[_++];
                break;
              case Pf.Q:
                y_e(n6, f6, a[_++], a[_++], a[_], a[_ + 1], ix, iS), n6 = a[_++], f6 = a[_++];
                break;
              case Pf.A:
                var E = a[_++], O = a[_++], R = a[_++], V = a[_++], z3 = a[_++], H = a[_++] + z3;
                _ += 1;
                var Z = !a[_++];
                T && (d4 = _E(z3) * R + E, y4 = xE(z3) * V + O), m_e(E, O, R, V, z3, H, Z, ix, iS), n6 = _E(H) * R + E, f6 = xE(H) * V + O;
                break;
              case Pf.R:
                d4 = n6 = a[_++], y4 = f6 = a[_++];
                var ee = a[_++], oe = a[_++];
                xie(d4, y4, d4 + ee, y4 + oe, ix, iS);
                break;
              case Pf.Z:
                n6 = d4, f6 = y4;
                break;
            }
            H_(nS, nS, ix), G1(rS, rS, iS);
          }
          return _ === 0 && (nS[0] = nS[1] = rS[0] = rS[1] = 0), new il(nS[0], nS[1], rS[0] - nS[0], rS[1] - nS[1]);
        }, s.prototype._calculateLength = function() {
          var a = this.data, n6 = this._len, f6 = this._ux, d4 = this._uy, y4 = 0, _ = 0, S = 0, T = 0;
          this._pathSegLen || (this._pathSegLen = []);
          for (var E = this._pathSegLen, O = 0, R = 0, V = 0; V < n6; ) {
            var z3 = a[V++], H = V === 1;
            H && (y4 = a[V], _ = a[V + 1], S = y4, T = _);
            var Z = -1;
            switch (z3) {
              case Pf.M:
                y4 = S = a[V++], _ = T = a[V++];
                break;
              case Pf.L: {
                var ee = a[V++], oe = a[V++], fe = ee - y4, _e = oe - _;
                (gC(fe) > f6 || gC(_e) > d4 || V === n6 - 1) && (Z = Math.sqrt(fe * fe + _e * _e), y4 = ee, _ = oe);
                break;
              }
              case Pf.C: {
                var pe = a[V++], Ve = a[V++], ee = a[V++], oe = a[V++], Le = a[V++], je = a[V++];
                Z = xU(y4, _, pe, Ve, ee, oe, Le, je, 10), y4 = Le, _ = je;
                break;
              }
              case Pf.Q: {
                var pe = a[V++], Ve = a[V++], ee = a[V++], oe = a[V++];
                Z = Mbe(y4, _, pe, Ve, ee, oe, 10), y4 = ee, _ = oe;
                break;
              }
              case Pf.A:
                var Xe = a[V++], Ye = a[V++], rt2 = a[V++], ut = a[V++], wt = a[V++], dt = a[V++], Gt = dt + wt;
                V += 1, a[V++], H && (S = _E(wt) * rt2 + Xe, T = xE(wt) * ut + Ye), Z = Sq(rt2, ut) * wq(ST, Math.abs(dt)), y4 = _E(Gt) * rt2 + Xe, _ = xE(Gt) * ut + Ye;
                break;
              case Pf.R: {
                S = y4 = a[V++], T = _ = a[V++];
                var Qt = a[V++], Nt = a[V++];
                Z = Qt * 2 + Nt * 2;
                break;
              }
              case Pf.Z: {
                var fe = S - y4, _e = T - _;
                Z = Math.sqrt(fe * fe + _e * _e), y4 = S, _ = T;
                break;
              }
            }
            Z >= 0 && (E[R++] = Z, O += Z);
          }
          return this._pathLen = O, O;
        }, s.prototype.rebuildPath = function(a, n6) {
          var f6 = this.data, d4 = this._ux, y4 = this._uy, _ = this._len, S, T, E, O, R, V, z3 = n6 < 1, H, Z, ee = 0, oe = 0, fe, _e = 0, pe, Ve;
          if (z3 && (this._pathSegLen || this._calculateLength(), H = this._pathSegLen, Z = this._pathLen, fe = n6 * Z, !fe))
            return;
          e:
            for (var Le = 0; Le < _; ) {
              var je = f6[Le++], Xe = Le === 1;
              switch (Xe && (E = f6[Le], O = f6[Le + 1], S = E, T = O), je !== Pf.L && _e > 0 && (a.lineTo(pe, Ve), _e = 0), je) {
                case Pf.M:
                  S = E = f6[Le++], T = O = f6[Le++], a.moveTo(E, O);
                  break;
                case Pf.L: {
                  R = f6[Le++], V = f6[Le++];
                  var Ye = gC(R - E), rt2 = gC(V - O);
                  if (Ye > d4 || rt2 > y4) {
                    if (z3) {
                      var ut = H[oe++];
                      if (ee + ut > fe) {
                        var wt = (fe - ee) / ut;
                        a.lineTo(E * (1 - wt) + R * wt, O * (1 - wt) + V * wt);
                        break e;
                      }
                      ee += ut;
                    }
                    a.lineTo(R, V), E = R, O = V, _e = 0;
                  } else {
                    var dt = Ye * Ye + rt2 * rt2;
                    dt > _e && (pe = R, Ve = V, _e = dt);
                  }
                  break;
                }
                case Pf.C: {
                  var Gt = f6[Le++], Qt = f6[Le++], Nt = f6[Le++], er = f6[Le++], un = f6[Le++], pn = f6[Le++];
                  if (z3) {
                    var ut = H[oe++];
                    if (ee + ut > fe) {
                      var wt = (fe - ee) / ut;
                      $_(E, Gt, Nt, un, wt, mE), $_(O, Qt, er, pn, wt, bE), a.bezierCurveTo(mE[1], bE[1], mE[2], bE[2], mE[3], bE[3]);
                      break e;
                    }
                    ee += ut;
                  }
                  a.bezierCurveTo(Gt, Qt, Nt, er, un, pn), E = un, O = pn;
                  break;
                }
                case Pf.Q: {
                  var Gt = f6[Le++], Qt = f6[Le++], Nt = f6[Le++], er = f6[Le++];
                  if (z3) {
                    var ut = H[oe++];
                    if (ee + ut > fe) {
                      var wt = (fe - ee) / ut;
                      Hp(E, Gt, Nt, wt, mE), Hp(O, Qt, er, wt, bE), a.quadraticCurveTo(mE[1], bE[1], mE[2], bE[2]);
                      break e;
                    }
                    ee += ut;
                  }
                  a.quadraticCurveTo(Gt, Qt, Nt, er), E = Nt, O = er;
                  break;
                }
                case Pf.A:
                  var On = f6[Le++], fr = f6[Le++], yr = f6[Le++], da = f6[Le++], Ja = f6[Le++], ko = f6[Le++], wo = f6[Le++], So = !f6[Le++], Fa = yr > da ? yr : da, po = gC(yr - da) > 1e-3, To = Ja + ko, Ya = false;
                  if (z3) {
                    var ut = H[oe++];
                    ee + ut > fe && (To = Ja + ko * (fe - ee) / ut, Ya = true), ee += ut;
                  }
                  if (po && a.ellipse ? a.ellipse(On, fr, yr, da, wo, Ja, To, So) : a.arc(On, fr, Fa, Ja, To, So), Ya)
                    break e;
                  Xe && (S = _E(Ja) * yr + On, T = xE(Ja) * da + fr), E = _E(To) * yr + On, O = xE(To) * da + fr;
                  break;
                case Pf.R:
                  S = E = f6[Le], T = O = f6[Le + 1], R = f6[Le++], V = f6[Le++];
                  var $o = f6[Le++], Hu = f6[Le++];
                  if (z3) {
                    var ut = H[oe++];
                    if (ee + ut > fe) {
                      var ms = fe - ee;
                      a.moveTo(R, V), a.lineTo(R + wq(ms, $o), V), ms -= $o, ms > 0 && a.lineTo(R + $o, V + wq(ms, Hu)), ms -= Hu, ms > 0 && a.lineTo(R + Sq($o - ms, 0), V + Hu), ms -= $o, ms > 0 && a.lineTo(R, V + Sq(Hu - ms, 0));
                      break e;
                    }
                    ee += ut;
                  }
                  a.rect(R, V, $o, Hu);
                  break;
                case Pf.Z:
                  if (z3) {
                    var ut = H[oe++];
                    if (ee + ut > fe) {
                      var wt = (fe - ee) / ut;
                      a.lineTo(E * (1 - wt) + S * wt, O * (1 - wt) + T * wt);
                      break e;
                    }
                    ee += ut;
                  }
                  a.closePath(), E = S, O = T;
              }
            }
        }, s.prototype.clone = function() {
          var a = new s(), n6 = this.data;
          return a.data = n6.slice ? n6.slice() : Array.prototype.slice.call(n6), a._len = this._len, a;
        }, s.CMD = Pf, s.initDefaultProps = function() {
          var a = s.prototype;
          a._saveData = true, a._ux = 0, a._uy = 0, a._pendingPtDist = 0, a._version = 0;
        }(), s;
      }(), aS = x_e;
      function CT(s, a, n6, f6, d4, y4, _) {
        if (d4 === 0)
          return false;
        var S = d4, T = 0, E = s;
        if (_ > a + S && _ > f6 + S || _ < a - S && _ < f6 - S || y4 > s + S && y4 > n6 + S || y4 < s - S && y4 < n6 - S)
          return false;
        if (s !== n6)
          T = (a - f6) / (s - n6), E = (s * f6 - n6 * a) / (s - n6);
        else
          return Math.abs(y4 - s) <= S / 2;
        var O = T * y4 - _ + E, R = O * O / (T * T + 1);
        return R <= S / 2 * S / 2;
      }
      function w_e(s, a, n6, f6, d4, y4, _, S, T, E, O) {
        if (T === 0)
          return false;
        var R = T;
        if (O > a + R && O > f6 + R && O > y4 + R && O > S + R || O < a - R && O < f6 - R && O < y4 - R && O < S - R || E > s + R && E > n6 + R && E > d4 + R && E > _ + R || E < s - R && E < n6 - R && E < d4 - R && E < _ - R)
          return false;
        var V = ZL(s, a, n6, f6, d4, y4, _, S, E, O, null);
        return V <= R / 2;
      }
      function Cie(s, a, n6, f6, d4, y4, _, S, T) {
        if (_ === 0)
          return false;
        var E = _;
        if (T > a + E && T > f6 + E && T > y4 + E || T < a - E && T < f6 - E && T < y4 - E || S > s + E && S > n6 + E && S > d4 + E || S < s - E && S < n6 - E && S < d4 - E)
          return false;
        var O = Dg(s, a, n6, f6, d4, y4, S, T, null);
        return O <= E / 2;
      }
      var Mie = Math.PI * 2;
      function MT(s) {
        return s %= Mie, s < 0 && (s += Mie), s;
      }
      var bR = Math.PI * 2;
      function S_e(s, a, n6, f6, d4, y4, _, S, T) {
        if (_ === 0)
          return false;
        var E = _;
        S -= s, T -= a;
        var O = Math.sqrt(S * S + T * T);
        if (O - E > n6 || O + E < n6)
          return false;
        if (Math.abs(f6 - d4) % bR < 1e-4)
          return true;
        if (y4) {
          var R = f6;
          f6 = MT(d4), d4 = MT(R);
        } else
          f6 = MT(f6), d4 = MT(d4);
        f6 > d4 && (d4 += bR);
        var V = Math.atan2(T, S);
        return V < 0 && (V += bR), V >= f6 && V <= d4 || V + bR >= f6 && V + bR <= d4;
      }
      function yC(s, a, n6, f6, d4, y4) {
        if (y4 > a && y4 > f6 || y4 < a && y4 < f6 || f6 === a)
          return 0;
        var _ = (y4 - a) / (f6 - a), S = f6 < a ? 1 : -1;
        (_ === 1 || _ === 0) && (S = f6 < a ? 0.5 : -0.5);
        var T = _ * (n6 - s) + s;
        return T === d4 ? 1 / 0 : T > d4 ? S : 0;
      }
      var TT = aS.CMD, wE = Math.PI * 2, C_e = 1e-4;
      function M_e(s, a) {
        return Math.abs(s - a) < C_e;
      }
      var Ry = [-1, -1, -1], q1 = [-1, -1];
      function Tie() {
        var s = q1[0];
        q1[0] = q1[1], q1[1] = s;
      }
      function T_e(s, a, n6, f6, d4, y4, _, S, T, E) {
        if (E > a && E > f6 && E > y4 && E > S || E < a && E < f6 && E < y4 && E < S)
          return 0;
        var O = v9(a, f6, y4, S, E, Ry);
        if (O === 0)
          return 0;
        for (var R = 0, V = -1, z3 = void 0, H = void 0, Z = 0; Z < O; Z++) {
          var ee = Ry[Z], oe = ee === 0 || ee === 1 ? 0.5 : 1, fe = id2(s, n6, d4, _, ee);
          fe < T || (V < 0 && (V = Hre(a, f6, y4, S, q1), q1[1] < q1[0] && V > 1 && Tie(), z3 = id2(a, f6, y4, S, q1[0]), V > 1 && (H = id2(a, f6, y4, S, q1[1]))), V === 2 ? ee < q1[0] ? R += z3 < a ? oe : -oe : ee < q1[1] ? R += H < z3 ? oe : -oe : R += S < H ? oe : -oe : ee < q1[0] ? R += z3 < a ? oe : -oe : R += S < z3 ? oe : -oe);
        }
        return R;
      }
      function A_e(s, a, n6, f6, d4, y4, _, S) {
        if (S > a && S > f6 && S > y4 || S < a && S < f6 && S < y4)
          return 0;
        var T = Cbe(a, f6, y4, S, Ry);
        if (T === 0)
          return 0;
        var E = Wre(a, f6, y4);
        if (E >= 0 && E <= 1) {
          for (var O = 0, R = Yv(a, f6, y4, E), V = 0; V < T; V++) {
            var z3 = Ry[V] === 0 || Ry[V] === 1 ? 0.5 : 1, H = Yv(s, n6, d4, Ry[V]);
            H < _ || (Ry[V] < E ? O += R < a ? z3 : -z3 : O += y4 < R ? z3 : -z3);
          }
          return O;
        } else {
          var z3 = Ry[0] === 0 || Ry[0] === 1 ? 0.5 : 1, H = Yv(s, n6, d4, Ry[0]);
          return H < _ ? 0 : y4 < a ? z3 : -z3;
        }
      }
      function I_e(s, a, n6, f6, d4, y4, _, S) {
        if (S -= a, S > n6 || S < -n6)
          return 0;
        var T = Math.sqrt(n6 * n6 - S * S);
        Ry[0] = -T, Ry[1] = T;
        var E = Math.abs(f6 - d4);
        if (E < 1e-4)
          return 0;
        if (E >= wE - 1e-4) {
          f6 = 0, d4 = wE;
          var O = y4 ? 1 : -1;
          return _ >= Ry[0] + s && _ <= Ry[1] + s ? O : 0;
        }
        if (f6 > d4) {
          var R = f6;
          f6 = d4, d4 = R;
        }
        f6 < 0 && (f6 += wE, d4 += wE);
        for (var V = 0, z3 = 0; z3 < 2; z3++) {
          var H = Ry[z3];
          if (H + s > _) {
            var Z = Math.atan2(S, H), O = y4 ? 1 : -1;
            Z < 0 && (Z = wE + Z), (Z >= f6 && Z <= d4 || Z + wE >= f6 && Z + wE <= d4) && (Z > Math.PI / 2 && Z < Math.PI * 1.5 && (O = -O), V += O);
          }
        }
        return V;
      }
      function Aie(s, a, n6, f6, d4) {
        for (var y4 = s.data, _ = s.len(), S = 0, T = 0, E = 0, O = 0, R = 0, V, z3, H = 0; H < _; ) {
          var Z = y4[H++], ee = H === 1;
          switch (Z === TT.M && H > 1 && (n6 || (S += yC(T, E, O, R, f6, d4))), ee && (T = y4[H], E = y4[H + 1], O = T, R = E), Z) {
            case TT.M:
              O = y4[H++], R = y4[H++], T = O, E = R;
              break;
            case TT.L:
              if (n6) {
                if (CT(T, E, y4[H], y4[H + 1], a, f6, d4))
                  return true;
              } else
                S += yC(T, E, y4[H], y4[H + 1], f6, d4) || 0;
              T = y4[H++], E = y4[H++];
              break;
            case TT.C:
              if (n6) {
                if (w_e(T, E, y4[H++], y4[H++], y4[H++], y4[H++], y4[H], y4[H + 1], a, f6, d4))
                  return true;
              } else
                S += T_e(T, E, y4[H++], y4[H++], y4[H++], y4[H++], y4[H], y4[H + 1], f6, d4) || 0;
              T = y4[H++], E = y4[H++];
              break;
            case TT.Q:
              if (n6) {
                if (Cie(T, E, y4[H++], y4[H++], y4[H], y4[H + 1], a, f6, d4))
                  return true;
              } else
                S += A_e(T, E, y4[H++], y4[H++], y4[H], y4[H + 1], f6, d4) || 0;
              T = y4[H++], E = y4[H++];
              break;
            case TT.A:
              var oe = y4[H++], fe = y4[H++], _e = y4[H++], pe = y4[H++], Ve = y4[H++], Le = y4[H++];
              H += 1;
              var je = !!(1 - y4[H++]);
              V = Math.cos(Ve) * _e + oe, z3 = Math.sin(Ve) * pe + fe, ee ? (O = V, R = z3) : S += yC(T, E, V, z3, f6, d4);
              var Xe = (f6 - oe) * pe / _e + oe;
              if (n6) {
                if (S_e(oe, fe, pe, Ve, Ve + Le, je, a, Xe, d4))
                  return true;
              } else
                S += I_e(oe, fe, pe, Ve, Ve + Le, je, Xe, d4);
              T = Math.cos(Ve + Le) * _e + oe, E = Math.sin(Ve + Le) * pe + fe;
              break;
            case TT.R:
              O = T = y4[H++], R = E = y4[H++];
              var Ye = y4[H++], rt2 = y4[H++];
              if (V = O + Ye, z3 = R + rt2, n6) {
                if (CT(O, R, V, R, a, f6, d4) || CT(V, R, V, z3, a, f6, d4) || CT(V, z3, O, z3, a, f6, d4) || CT(O, z3, O, R, a, f6, d4))
                  return true;
              } else
                S += yC(V, R, V, z3, f6, d4), S += yC(O, z3, O, R, f6, d4);
              break;
            case TT.Z:
              if (n6) {
                if (CT(T, E, O, R, a, f6, d4))
                  return true;
              } else
                S += yC(T, E, O, R, f6, d4);
              T = O, E = R;
              break;
          }
        }
        return !n6 && !M_e(E, R) && (S += yC(T, E, O, R, f6, d4) || 0), S !== 0;
      }
      function r7(s, a, n6) {
        return Aie(s, 0, false, a, n6);
      }
      function E_e(s, a, n6, f6) {
        return Aie(s, a, true, n6, f6);
      }
      var i7 = zo({ fill: "#000", stroke: null, strokePercent: 1, fillOpacity: 1, strokeOpacity: 1, lineDashOffset: 0, lineWidth: 1, lineCap: "butt", miterLimit: 10, strokeNoScale: false, strokeFirst: false }, gE), D_e = { style: zo({ fill: true, stroke: true, strokePercent: true, fillOpacity: true, strokeOpacity: true, lineDashOffset: true, lineWidth: true, miterLimit: true }, Z9.style) }, Mq = jb.concat(["invisible", "culling", "z", "z2", "zlevel", "parent"]), k_e = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.update = function() {
          var n6 = this;
          s.prototype.update.call(this);
          var f6 = this.style;
          if (f6.decal) {
            var d4 = this._decalEl = this._decalEl || new a();
            d4.buildPath === a.prototype.buildPath && (d4.buildPath = function(T) {
              n6.buildPath(T, n6.shape);
            }), d4.silent = true;
            var y4 = d4.style;
            for (var _ in f6)
              y4[_] !== f6[_] && (y4[_] = f6[_]);
            y4.fill = f6.fill ? f6.decal : null, y4.decal = null, y4.shadowColor = null, f6.strokeFirst && (y4.stroke = null);
            for (var S = 0; S < Mq.length; ++S)
              d4[Mq[S]] = this[Mq[S]];
            d4.__dirty |= x0;
          } else
            this._decalEl && (this._decalEl = null);
        }, a.prototype.getDecalElement = function() {
          return this._decalEl;
        }, a.prototype._init = function(n6) {
          var f6 = Wl(n6);
          this.shape = this.getDefaultShape();
          var d4 = this.getDefaultStyle();
          d4 && this.useStyle(d4);
          for (var y4 = 0; y4 < f6.length; y4++) {
            var _ = f6[y4], S = n6[_];
            _ === "style" ? this.style ? ei(this.style, S) : this.useStyle(S) : _ === "shape" ? ei(this.shape, S) : s.prototype.attrKV.call(this, _, S);
          }
          this.style || this.useStyle({});
        }, a.prototype.getDefaultStyle = function() {
          return null;
        }, a.prototype.getDefaultShape = function() {
          return {};
        }, a.prototype.canBeInsideText = function() {
          return this.hasFill();
        }, a.prototype.getInsideTextFill = function() {
          var n6 = this.style.fill;
          if (n6 !== "none") {
            if (Wa(n6)) {
              var f6 = b9(n6, 0);
              return f6 > 0.5 ? P9 : f6 > 0.2 ? jbe : VU;
            } else if (n6)
              return VU;
          }
          return P9;
        }, a.prototype.getInsideTextStroke = function(n6) {
          var f6 = this.style.fill;
          if (Wa(f6)) {
            var d4 = this.__zr, y4 = !!(d4 && d4.isDarkMode()), _ = b9(n6, 0) < nR;
            if (y4 === _)
              return f6;
          }
        }, a.prototype.buildPath = function(n6, f6, d4) {
        }, a.prototype.pathUpdated = function() {
          this.__dirty &= ~U_;
        }, a.prototype.getUpdatedPathProxy = function(n6) {
          return !this.path && this.createPathProxy(), this.path.beginPath(), this.buildPath(this.path, this.shape, n6), this.path;
        }, a.prototype.createPathProxy = function() {
          this.path = new aS(false);
        }, a.prototype.hasStroke = function() {
          var n6 = this.style, f6 = n6.stroke;
          return !(f6 == null || f6 === "none" || !(n6.lineWidth > 0));
        }, a.prototype.hasFill = function() {
          var n6 = this.style, f6 = n6.fill;
          return f6 != null && f6 !== "none";
        }, a.prototype.getBoundingRect = function() {
          var n6 = this._rect, f6 = this.style, d4 = !n6;
          if (d4) {
            var y4 = false;
            this.path || (y4 = true, this.createPathProxy());
            var _ = this.path;
            (y4 || this.__dirty & U_) && (_.beginPath(), this.buildPath(_, this.shape, false), this.pathUpdated()), n6 = _.getBoundingRect();
          }
          if (this._rect = n6, this.hasStroke() && this.path && this.path.len() > 0) {
            var S = this._rectStroke || (this._rectStroke = n6.clone());
            if (this.__dirty || d4) {
              S.copy(n6);
              var T = f6.strokeNoScale ? this.getLineScale() : 1, E = f6.lineWidth;
              if (!this.hasFill()) {
                var O = this.strokeContainThreshold;
                E = Math.max(E, O == null ? 4 : O);
              }
              T > 1e-10 && (S.width += E / T, S.height += E / T, S.x -= E / T / 2, S.y -= E / T / 2);
            }
            return S;
          }
          return n6;
        }, a.prototype.contain = function(n6, f6) {
          var d4 = this.transformCoordToLocal(n6, f6), y4 = this.getBoundingRect(), _ = this.style;
          if (n6 = d4[0], f6 = d4[1], y4.contain(n6, f6)) {
            var S = this.path;
            if (this.hasStroke()) {
              var T = _.lineWidth, E = _.strokeNoScale ? this.getLineScale() : 1;
              if (E > 1e-10 && (this.hasFill() || (T = Math.max(T, this.strokeContainThreshold)), E_e(S, T / E, n6, f6)))
                return true;
            }
            if (this.hasFill())
              return r7(S, n6, f6);
          }
          return false;
        }, a.prototype.dirtyShape = function() {
          this.__dirty |= U_, this._rect && (this._rect = null), this._decalEl && this._decalEl.dirtyShape(), this.markRedraw();
        }, a.prototype.dirty = function() {
          this.dirtyStyle(), this.dirtyShape();
        }, a.prototype.animateShape = function(n6) {
          return this.animate("shape", n6);
        }, a.prototype.updateDuringAnimation = function(n6) {
          n6 === "style" ? this.dirtyStyle() : n6 === "shape" ? this.dirtyShape() : this.markRedraw();
        }, a.prototype.attrKV = function(n6, f6) {
          n6 === "shape" ? this.setShape(f6) : s.prototype.attrKV.call(this, n6, f6);
        }, a.prototype.setShape = function(n6, f6) {
          var d4 = this.shape;
          return d4 || (d4 = this.shape = {}), typeof n6 == "string" ? d4[n6] = f6 : ei(d4, n6), this.dirtyShape(), this;
        }, a.prototype.shapeChanged = function() {
          return !!(this.__dirty & U_);
        }, a.prototype.createStyle = function(n6) {
          return zL(i7, n6);
        }, a.prototype._innerSaveToNormal = function(n6) {
          s.prototype._innerSaveToNormal.call(this, n6);
          var f6 = this._normalState;
          n6.shape && !f6.shape && (f6.shape = ei({}, this.shape));
        }, a.prototype._applyStateObj = function(n6, f6, d4, y4, _, S) {
          s.prototype._applyStateObj.call(this, n6, f6, d4, y4, _, S);
          var T = !(f6 && y4), E;
          if (f6 && f6.shape ? _ ? y4 ? E = f6.shape : (E = ei({}, d4.shape), ei(E, f6.shape)) : (E = ei({}, y4 ? this.shape : d4.shape), ei(E, f6.shape)) : T && (E = d4.shape), E)
            if (_) {
              this.shape = ei({}, this.shape);
              for (var O = {}, R = Wl(E), V = 0; V < R.length; V++) {
                var z3 = R[V];
                typeof E[z3] == "object" ? this.shape[z3] = E[z3] : O[z3] = E[z3];
              }
              this._transitionState(n6, { shape: O }, S);
            } else
              this.shape = E, this.dirtyShape();
        }, a.prototype._mergeStates = function(n6) {
          for (var f6 = s.prototype._mergeStates.call(this, n6), d4, y4 = 0; y4 < n6.length; y4++) {
            var _ = n6[y4];
            _.shape && (d4 = d4 || {}, this._mergeStyle(d4, _.shape));
          }
          return d4 && (f6.shape = d4), f6;
        }, a.prototype.getAnimationStyleProps = function() {
          return D_e;
        }, a.prototype.isZeroArea = function() {
          return false;
        }, a.extend = function(n6) {
          var f6 = function(y4) {
            Vt(_, y4);
            function _(S) {
              var T = y4.call(this, S) || this;
              return n6.init && n6.init.call(T, S), T;
            }
            return _.prototype.getDefaultStyle = function() {
              return Bo(n6.style);
            }, _.prototype.getDefaultShape = function() {
              return Bo(n6.shape);
            }, _;
          }(a);
          for (var d4 in n6)
            typeof n6[d4] == "function" && (f6.prototype[d4] = n6[d4]);
          return f6;
        }, a.initDefaultProps = function() {
          var n6 = a.prototype;
          n6.type = "path", n6.strokeContainThreshold = 5, n6.segmentIgnoreThreshold = 0, n6.subPixelOptimize = false, n6.autoBatch = false, n6.__dirty = x0 | qL | U_;
        }(), a;
      }(Hb), ml = k_e, O_e = zo({ strokeFirst: true, font: mc, x: 0, y: 0, textAlign: "left", textBaseline: "top", miterLimit: 2 }, i7), Iie = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.hasStroke = function() {
          var n6 = this.style, f6 = n6.stroke;
          return f6 != null && f6 !== "none" && n6.lineWidth > 0;
        }, a.prototype.hasFill = function() {
          var n6 = this.style, f6 = n6.fill;
          return f6 != null && f6 !== "none";
        }, a.prototype.createStyle = function(n6) {
          return zL(O_e, n6);
        }, a.prototype.setBoundingRect = function(n6) {
          this._rect = n6;
        }, a.prototype.getBoundingRect = function() {
          var n6 = this.style;
          if (!this._rect) {
            var f6 = n6.text;
            f6 != null ? f6 += "" : f6 = "";
            var d4 = cE(f6, n6.font, n6.textAlign, n6.textBaseline);
            if (d4.x += n6.x || 0, d4.y += n6.y || 0, this.hasStroke()) {
              var y4 = n6.lineWidth;
              d4.x -= y4 / 2, d4.y -= y4 / 2, d4.width += y4, d4.height += y4;
            }
            this._rect = d4;
          }
          return this._rect;
        }, a.initDefaultProps = function() {
          var n6 = a.prototype;
          n6.dirtyRectTolerance = 10;
        }(), a;
      }(Hb);
      Iie.prototype.type = "tspan";
      var _R = Iie, P_e = zo({ x: 0, y: 0 }, gE), L_e = { style: zo({ x: true, y: true, width: true, height: true, sx: true, sy: true, sWidth: true, sHeight: true }, Z9.style) };
      function a7(s) {
        return !!(s && typeof s != "string" && s.width && s.height);
      }
      var Eie = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.createStyle = function(n6) {
          return zL(P_e, n6);
        }, a.prototype._getSize = function(n6) {
          var f6 = this.style, d4 = f6[n6];
          if (d4 != null)
            return d4;
          var y4 = a7(f6.image) ? f6.image : this.__image;
          if (!y4)
            return 0;
          var _ = n6 === "width" ? "height" : "width", S = f6[_];
          return S == null ? y4[n6] : y4[n6] / y4[_] * S;
        }, a.prototype.getWidth = function() {
          return this._getSize("width");
        }, a.prototype.getHeight = function() {
          return this._getSize("height");
        }, a.prototype.getAnimationStyleProps = function() {
          return L_e;
        }, a.prototype.getBoundingRect = function() {
          var n6 = this.style;
          return this._rect || (this._rect = new il(n6.x || 0, n6.y || 0, this.getWidth(), this.getHeight())), this._rect;
        }, a;
      }(Hb);
      Eie.prototype.type = "image";
      var Zv = Eie;
      function Die(s, a) {
        var n6 = a.x, f6 = a.y, d4 = a.width, y4 = a.height, _ = a.r, S, T, E, O;
        d4 < 0 && (n6 = n6 + d4, d4 = -d4), y4 < 0 && (f6 = f6 + y4, y4 = -y4), typeof _ == "number" ? S = T = E = O = _ : _ instanceof Array ? _.length === 1 ? S = T = E = O = _[0] : _.length === 2 ? (S = E = _[0], T = O = _[1]) : _.length === 3 ? (S = _[0], T = O = _[1], E = _[2]) : (S = _[0], T = _[1], E = _[2], O = _[3]) : S = T = E = O = 0;
        var R;
        S + T > d4 && (R = S + T, S *= d4 / R, T *= d4 / R), E + O > d4 && (R = E + O, E *= d4 / R, O *= d4 / R), T + E > y4 && (R = T + E, T *= y4 / R, E *= y4 / R), S + O > y4 && (R = S + O, S *= y4 / R, O *= y4 / R), s.moveTo(n6 + S, f6), s.lineTo(n6 + d4 - T, f6), T !== 0 && s.arc(n6 + d4 - T, f6 + T, T, -Math.PI / 2, 0), s.lineTo(n6 + d4, f6 + y4 - E), E !== 0 && s.arc(n6 + d4 - E, f6 + y4 - E, E, 0, Math.PI / 2), s.lineTo(n6 + O, f6 + y4), O !== 0 && s.arc(n6 + O, f6 + y4 - O, O, Math.PI / 2, Math.PI), s.lineTo(n6, f6 + S), S !== 0 && s.arc(n6 + S, f6 + S, S, Math.PI, Math.PI * 1.5);
      }
      var AT = Math.round;
      function Tq(s, a, n6) {
        if (a) {
          var f6 = a.x1, d4 = a.x2, y4 = a.y1, _ = a.y2;
          s.x1 = f6, s.x2 = d4, s.y1 = y4, s.y2 = _;
          var S = n6 && n6.lineWidth;
          return S && (AT(f6 * 2) === AT(d4 * 2) && (s.x1 = s.x2 = IT(f6, S, true)), AT(y4 * 2) === AT(_ * 2) && (s.y1 = s.y2 = IT(y4, S, true))), s;
        }
      }
      function Aq(s, a, n6) {
        if (a) {
          var f6 = a.x, d4 = a.y, y4 = a.width, _ = a.height;
          s.x = f6, s.y = d4, s.width = y4, s.height = _;
          var S = n6 && n6.lineWidth;
          return S && (s.x = IT(f6, S, true), s.y = IT(d4, S, true), s.width = Math.max(IT(f6 + y4, S, false) - s.x, y4 === 0 ? 0 : 1), s.height = Math.max(IT(d4 + _, S, false) - s.y, _ === 0 ? 0 : 1)), s;
        }
      }
      function IT(s, a, n6) {
        if (!a)
          return s;
        var f6 = AT(s * 2);
        return (f6 + AT(a)) % 2 === 0 ? f6 / 2 : (f6 + (n6 ? 1 : -1)) / 2;
      }
      var kie = function() {
        function s() {
          this.x = 0, this.y = 0, this.width = 0, this.height = 0;
        }
        return s;
      }(), R_e = {}, Oie = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new kie();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4, y4, _, S;
          if (this.subPixelOptimize) {
            var T = Aq(R_e, f6, this.style);
            d4 = T.x, y4 = T.y, _ = T.width, S = T.height, T.r = f6.r, f6 = T;
          } else
            d4 = f6.x, y4 = f6.y, _ = f6.width, S = f6.height;
          f6.r ? Die(n6, f6) : n6.rect(d4, y4, _, S);
        }, a.prototype.isZeroArea = function() {
          return !this.shape.width || !this.shape.height;
        }, a;
      }(ml);
      Oie.prototype.type = "rect";
      var xu = Oie, xR = { fill: "#000" }, wR = 2, N_e = { style: zo({ fill: true, stroke: true, fillOpacity: true, strokeOpacity: true, lineWidth: true, fontSize: true, lineHeight: true, width: true, height: true, textShadowColor: true, textShadowBlur: true, textShadowOffsetX: true, textShadowOffsetY: true, backgroundColor: true, padding: true, borderColor: true, borderWidth: true, borderRadius: true }, Z9.style) }, Pie = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this) || this;
          return f6.type = "text", f6._children = [], f6._defaultStyle = xR, f6.attr(n6), f6;
        }
        return a.prototype.childrenRef = function() {
          return this._children;
        }, a.prototype.update = function() {
          s.prototype.update.call(this), this.styleChanged() && this._updateSubTexts();
          for (var n6 = 0; n6 < this._children.length; n6++) {
            var f6 = this._children[n6];
            f6.zlevel = this.zlevel, f6.z = this.z, f6.z2 = this.z2, f6.culling = this.culling, f6.cursor = this.cursor, f6.invisible = this.invisible;
          }
        }, a.prototype.updateTransform = function() {
          var n6 = this.innerTransformable;
          n6 ? (n6.updateTransform(), n6.transform && (this.transform = n6.transform)) : s.prototype.updateTransform.call(this);
        }, a.prototype.getLocalTransform = function(n6) {
          var f6 = this.innerTransformable;
          return f6 ? f6.getLocalTransform(n6) : s.prototype.getLocalTransform.call(this, n6);
        }, a.prototype.getComputedTransform = function() {
          return this.__hostTarget && (this.__hostTarget.getComputedTransform(), this.__hostTarget.updateInnerText(true)), s.prototype.getComputedTransform.call(this);
        }, a.prototype._updateSubTexts = function() {
          this._childCursor = 0, F_e(this.style), this.style.rich ? this._updateRichTexts() : this._updatePlainTexts(), this._children.length = this._childCursor, this.styleUpdated();
        }, a.prototype.addSelfToZr = function(n6) {
          s.prototype.addSelfToZr.call(this, n6);
          for (var f6 = 0; f6 < this._children.length; f6++)
            this._children[f6].__zr = n6;
        }, a.prototype.removeSelfFromZr = function(n6) {
          s.prototype.removeSelfFromZr.call(this, n6);
          for (var f6 = 0; f6 < this._children.length; f6++)
            this._children[f6].__zr = null;
        }, a.prototype.getBoundingRect = function() {
          if (this.styleChanged() && this._updateSubTexts(), !this._rect) {
            for (var n6 = new il(0, 0, 0, 0), f6 = this._children, d4 = [], y4 = null, _ = 0; _ < f6.length; _++) {
              var S = f6[_], T = S.getBoundingRect(), E = S.getLocalTransform(d4);
              E ? (n6.copy(T), n6.applyTransform(E), y4 = y4 || n6.clone(), y4.union(n6)) : (y4 = y4 || T.clone(), y4.union(T));
            }
            this._rect = y4 || n6;
          }
          return this._rect;
        }, a.prototype.setDefaultTextStyle = function(n6) {
          this._defaultStyle = n6 || xR;
        }, a.prototype.setTextContent = function(n6) {
        }, a.prototype._mergeStyle = function(n6, f6) {
          if (!f6)
            return n6;
          var d4 = f6.rich, y4 = n6.rich || d4 && {};
          return ei(n6, f6), d4 && y4 ? (this._mergeRich(y4, d4), n6.rich = y4) : y4 && (n6.rich = y4), n6;
        }, a.prototype._mergeRich = function(n6, f6) {
          for (var d4 = Wl(f6), y4 = 0; y4 < d4.length; y4++) {
            var _ = d4[y4];
            n6[_] = n6[_] || {}, ei(n6[_], f6[_]);
          }
        }, a.prototype.getAnimationStyleProps = function() {
          return N_e;
        }, a.prototype._getOrCreateChild = function(n6) {
          var f6 = this._children[this._childCursor];
          return (!f6 || !(f6 instanceof n6)) && (f6 = new n6()), this._children[this._childCursor++] = f6, f6.__zr = this.__zr, f6.parent = this, f6;
        }, a.prototype._updatePlainTexts = function() {
          var n6 = this.style, f6 = n6.font || mc, d4 = n6.padding, y4 = Hie(n6), _ = s_e(y4, n6), S = Eq(n6), T = !!n6.backgroundColor, E = _.outerHeight, O = _.outerWidth, R = _.contentWidth, V = _.lines, z3 = _.lineHeight, H = this._defaultStyle, Z = n6.x || 0, ee = n6.y || 0, oe = n6.align || H.align || "left", fe = n6.verticalAlign || H.verticalAlign || "top", _e = Z, pe = hC(ee, _.contentHeight, fe);
          if (S || d4) {
            var Ve = Vk(Z, O, oe), Le = hC(ee, E, fe);
            S && this._renderBackground(n6, n6, Ve, Le, O, E);
          }
          pe += z3 / 2, d4 && (_e = Gie(Z, oe, d4), fe === "top" ? pe += d4[0] : fe === "bottom" && (pe -= d4[2]));
          for (var je = 0, Xe = false, Ye = jie("fill" in n6 ? n6.fill : (Xe = true, H.fill)), rt2 = zie("stroke" in n6 ? n6.stroke : !T && (!H.autoStroke || Xe) ? (je = wR, H.stroke) : null), ut = n6.textShadowBlur > 0, wt = n6.width != null && (n6.overflow === "truncate" || n6.overflow === "break" || n6.overflow === "breakAll"), dt = _.calculatedLineHeight, Gt = 0; Gt < V.length; Gt++) {
            var Qt = this._getOrCreateChild(_R), Nt = Qt.createStyle();
            Qt.useStyle(Nt), Nt.text = V[Gt], Nt.x = _e, Nt.y = pe, oe && (Nt.textAlign = oe), Nt.textBaseline = "middle", Nt.opacity = n6.opacity, Nt.strokeFirst = true, ut && (Nt.shadowBlur = n6.textShadowBlur || 0, Nt.shadowColor = n6.textShadowColor || "transparent", Nt.shadowOffsetX = n6.textShadowOffsetX || 0, Nt.shadowOffsetY = n6.textShadowOffsetY || 0), Nt.stroke = rt2, Nt.fill = Ye, rt2 && (Nt.lineWidth = n6.lineWidth || je, Nt.lineDash = n6.lineDash, Nt.lineDashOffset = n6.lineDashOffset || 0), Nt.font = f6, Fie(Nt, n6), pe += z3, wt && Qt.setBoundingRect(new il(Vk(Nt.x, n6.width, Nt.textAlign), hC(Nt.y, dt, Nt.textBaseline), R, dt));
          }
        }, a.prototype._updateRichTexts = function() {
          var n6 = this.style, f6 = Hie(n6), d4 = c_e(f6, n6), y4 = d4.width, _ = d4.outerWidth, S = d4.outerHeight, T = n6.padding, E = n6.x || 0, O = n6.y || 0, R = this._defaultStyle, V = n6.align || R.align, z3 = n6.verticalAlign || R.verticalAlign, H = Vk(E, _, V), Z = hC(O, S, z3), ee = H, oe = Z;
          T && (ee += T[3], oe += T[0]);
          var fe = ee + y4;
          Eq(n6) && this._renderBackground(n6, n6, H, Z, _, S);
          for (var _e = !!n6.backgroundColor, pe = 0; pe < d4.lines.length; pe++) {
            for (var Ve = d4.lines[pe], Le = Ve.tokens, je = Le.length, Xe = Ve.lineHeight, Ye = Ve.width, rt2 = 0, ut = ee, wt = fe, dt = je - 1, Gt = void 0; rt2 < je && (Gt = Le[rt2], !Gt.align || Gt.align === "left"); )
              this._placeToken(Gt, n6, Xe, oe, ut, "left", _e), Ye -= Gt.width, ut += Gt.width, rt2++;
            for (; dt >= 0 && (Gt = Le[dt], Gt.align === "right"); )
              this._placeToken(Gt, n6, Xe, oe, wt, "right", _e), Ye -= Gt.width, wt -= Gt.width, dt--;
            for (ut += (y4 - (ut - ee) - (fe - wt) - Ye) / 2; rt2 <= dt; )
              Gt = Le[rt2], this._placeToken(Gt, n6, Xe, oe, ut + Gt.width / 2, "center", _e), ut += Gt.width, rt2++;
            oe += Xe;
          }
        }, a.prototype._placeToken = function(n6, f6, d4, y4, _, S, T) {
          var E = f6.rich[n6.styleName] || {};
          E.text = n6.text;
          var O = n6.verticalAlign, R = y4 + d4 / 2;
          O === "top" ? R = y4 + n6.height / 2 : O === "bottom" && (R = y4 + d4 - n6.height / 2);
          var V = !n6.isLineHolder && Eq(E);
          V && this._renderBackground(E, f6, S === "right" ? _ - n6.width : S === "center" ? _ - n6.width / 2 : _, R - n6.height / 2, n6.width, n6.height);
          var z3 = !!E.backgroundColor, H = n6.textPadding;
          H && (_ = Gie(_, S, H), R -= n6.height / 2 - H[0] - n6.innerHeight / 2);
          var Z = this._getOrCreateChild(_R), ee = Z.createStyle();
          Z.useStyle(ee);
          var oe = this._defaultStyle, fe = false, _e = 0, pe = jie("fill" in E ? E.fill : "fill" in f6 ? f6.fill : (fe = true, oe.fill)), Ve = zie("stroke" in E ? E.stroke : "stroke" in f6 ? f6.stroke : !z3 && !T && (!oe.autoStroke || fe) ? (_e = wR, oe.stroke) : null), Le = E.textShadowBlur > 0 || f6.textShadowBlur > 0;
          ee.text = n6.text, ee.x = _, ee.y = R, Le && (ee.shadowBlur = E.textShadowBlur || f6.textShadowBlur || 0, ee.shadowColor = E.textShadowColor || f6.textShadowColor || "transparent", ee.shadowOffsetX = E.textShadowOffsetX || f6.textShadowOffsetX || 0, ee.shadowOffsetY = E.textShadowOffsetY || f6.textShadowOffsetY || 0), ee.textAlign = S, ee.textBaseline = "middle", ee.font = n6.font || mc, ee.opacity = rC(E.opacity, f6.opacity, 1), Fie(ee, E), Ve && (ee.lineWidth = rC(E.lineWidth, f6.lineWidth, _e), ee.lineDash = Zs(E.lineDash, f6.lineDash), ee.lineDashOffset = f6.lineDashOffset || 0, ee.stroke = Ve), pe && (ee.fill = pe);
          var je = n6.contentWidth, Xe = n6.contentHeight;
          Z.setBoundingRect(new il(Vk(ee.x, je, ee.textAlign), hC(ee.y, Xe, ee.textBaseline), je, Xe));
        }, a.prototype._renderBackground = function(n6, f6, d4, y4, _, S) {
          var T = n6.backgroundColor, E = n6.borderWidth, O = n6.borderColor, R = T && T.image, V = T && !R, z3 = n6.borderRadius, H = this, Z, ee;
          if (V || n6.lineHeight || E && O) {
            Z = this._getOrCreateChild(xu), Z.useStyle(Z.createStyle()), Z.style.fill = null;
            var oe = Z.shape;
            oe.x = d4, oe.y = y4, oe.width = _, oe.height = S, oe.r = z3, Z.dirtyShape();
          }
          if (V) {
            var fe = Z.style;
            fe.fill = T || null, fe.fillOpacity = Zs(n6.fillOpacity, 1);
          } else if (R) {
            ee = this._getOrCreateChild(Zv), ee.onload = function() {
              H.dirtyStyle();
            };
            var _e = ee.style;
            _e.image = T.image, _e.x = d4, _e.y = y4, _e.width = _, _e.height = S;
          }
          if (E && O) {
            var fe = Z.style;
            fe.lineWidth = E, fe.stroke = O, fe.strokeOpacity = Zs(n6.strokeOpacity, 1), fe.lineDash = n6.borderDash, fe.lineDashOffset = n6.borderDashOffset || 0, Z.strokeContainThreshold = 0, Z.hasFill() && Z.hasStroke() && (fe.strokeFirst = true, fe.lineWidth *= 2);
          }
          var pe = (Z || ee).style;
          pe.shadowBlur = n6.shadowBlur || 0, pe.shadowColor = n6.shadowColor || "transparent", pe.shadowOffsetX = n6.shadowOffsetX || 0, pe.shadowOffsetY = n6.shadowOffsetY || 0, pe.opacity = rC(n6.opacity, f6.opacity, 1);
        }, a.makeFont = function(n6) {
          var f6 = "";
          return Vie(n6) && (f6 = [n6.fontStyle, n6.fontWeight, Nie(n6.fontSize), n6.fontFamily || "sans-serif"].join(" ")), f6 && wh(f6) || n6.textFont || n6.font;
        }, a;
      }(Hb), Iq = { left: true, right: 1, center: 1 }, Lie = { top: 1, bottom: 1, middle: 1 }, Rie = ["fontStyle", "fontWeight", "fontSize", "fontFamily"];
      function Nie(s) {
        return typeof s == "string" && (s.indexOf("px") !== -1 || s.indexOf("rem") !== -1 || s.indexOf("em") !== -1) ? s : isNaN(+s) ? fu + "px" : s + "px";
      }
      function Fie(s, a) {
        for (var n6 = 0; n6 < Rie.length; n6++) {
          var f6 = Rie[n6], d4 = a[f6];
          d4 != null && (s[f6] = d4);
        }
      }
      function Vie(s) {
        return s.fontSize != null || s.fontFamily || s.fontWeight;
      }
      function F_e(s) {
        return Bie(s), gt(s.rich, Bie), s;
      }
      function Bie(s) {
        if (s) {
          s.font = Pie.makeFont(s);
          var a = s.align;
          a === "middle" && (a = "center"), s.align = a == null || Iq[a] ? a : "left";
          var n6 = s.verticalAlign;
          n6 === "center" && (n6 = "middle"), s.verticalAlign = n6 == null || Lie[n6] ? n6 : "top";
          var f6 = s.padding;
          f6 && (s.padding = s9(s.padding));
        }
      }
      function zie(s, a) {
        return s == null || a <= 0 || s === "transparent" || s === "none" ? null : s.image || s.colorStops ? "#000" : s;
      }
      function jie(s) {
        return s == null || s === "none" ? null : s.image || s.colorStops ? "#000" : s;
      }
      function Gie(s, a, n6) {
        return a === "right" ? s - n6[1] : a === "center" ? s + n6[3] / 2 - n6[1] / 2 : s + n6[3];
      }
      function Hie(s) {
        var a = s.text;
        return a != null && (a += ""), a;
      }
      function Eq(s) {
        return !!(s.backgroundColor || s.lineHeight || s.borderWidth && s.borderColor);
      }
      var ju = Pie, qo = hu(), Dq = function(s, a, n6, f6) {
        if (f6) {
          var d4 = qo(f6);
          d4.dataIndex = n6, d4.dataType = a, d4.seriesIndex = s, f6.type === "group" && f6.traverse(function(y4) {
            var _ = qo(y4);
            _.seriesIndex = s, _.dataIndex = n6, _.dataType = a;
          });
        }
      }, Wie = 1, ET = {}, ql = hu(), kq = hu(), C0 = 0, lp = 1, o7 = 2, od = ["emphasis", "blur", "select"], SR = ["normal", "emphasis", "blur", "select"], jk = 10, V_e = 9, SE = "highlight", s7 = "downplay", CE = "select", l7 = "unselect", $1 = "toggleSelect";
      function ME(s) {
        return s != null && s !== "none";
      }
      var CR = new aC(100);
      function Sp(s) {
        if (Wa(s)) {
          var a = CR.get(s);
          return a || (a = AU(s, -0.1), CR.put(s, a)), a;
        } else if (th(s)) {
          var n6 = ei({}, s);
          return n6.colorStops = Pi(s.colorStops, function(f6) {
            return { offset: f6.offset, color: AU(f6.color, -0.1) };
          }), n6;
        }
        return s;
      }
      function up(s, a, n6) {
        s.onHoverStateChange && (s.hoverState || 0) !== n6 && s.onHoverStateChange(a), s.hoverState = n6;
      }
      function Oq(s) {
        up(s, "emphasis", o7);
      }
      function Uie(s) {
        s.hoverState === o7 && up(s, "normal", C0);
      }
      function Pq(s) {
        up(s, "blur", lp);
      }
      function qie(s) {
        s.hoverState === lp && up(s, "normal", C0);
      }
      function B_e(s) {
        s.selected = true;
      }
      function z_e(s) {
        s.selected = false;
      }
      function $ie(s, a, n6) {
        a(s, n6);
      }
      function oS(s, a, n6) {
        $ie(s, a, n6), s.isGroup && s.traverse(function(f6) {
          $ie(f6, a, n6);
        });
      }
      function DT(s, a) {
        switch (a) {
          case "emphasis":
            s.hoverState = o7;
            break;
          case "normal":
            s.hoverState = C0;
            break;
          case "blur":
            s.hoverState = lp;
            break;
          case "select":
            s.selected = true;
        }
      }
      function Lq(s, a, n6, f6) {
        for (var d4 = s.style, y4 = {}, _ = 0; _ < a.length; _++) {
          var S = a[_], T = d4[S];
          y4[S] = T == null ? f6 && f6[S] : T;
        }
        for (var _ = 0; _ < s.animators.length; _++) {
          var E = s.animators[_];
          E.__fromStateTransition && E.__fromStateTransition.indexOf(n6) < 0 && E.targetName === "style" && E.saveTo(y4, a);
        }
        return y4;
      }
      function j_e(s, a, n6, f6) {
        var d4 = n6 && Ns(n6, "select") >= 0, y4 = false;
        if (s instanceof ml) {
          var _ = ql(s), S = d4 && _.selectFill || _.normalFill, T = d4 && _.selectStroke || _.normalStroke;
          if (ME(S) || ME(T)) {
            f6 = f6 || {};
            var E = f6.style || {};
            E.fill === "inherit" ? (y4 = true, f6 = ei({}, f6), E = ei({}, E), E.fill = S) : !ME(E.fill) && ME(S) ? (y4 = true, f6 = ei({}, f6), E = ei({}, E), E.fill = Sp(S)) : !ME(E.stroke) && ME(T) && (y4 || (f6 = ei({}, f6), E = ei({}, E)), E.stroke = Sp(T)), f6.style = E;
          }
        }
        if (f6 && f6.z2 == null) {
          y4 || (f6 = ei({}, f6));
          var O = s.z2EmphasisLift;
          f6.z2 = s.z2 + (O != null ? O : jk);
        }
        return f6;
      }
      function Xie(s, a, n6) {
        if (n6 && n6.z2 == null) {
          n6 = ei({}, n6);
          var f6 = s.z2SelectLift;
          n6.z2 = s.z2 + (f6 != null ? f6 : V_e);
        }
        return n6;
      }
      function u7(s, a, n6) {
        var f6 = Ns(s.currentStates, a) >= 0, d4 = s.style.opacity, y4 = f6 ? null : Lq(s, ["opacity"], a, { opacity: 1 });
        n6 = n6 || {};
        var _ = n6.style || {};
        return _.opacity == null && (n6 = ei({}, n6), _ = ei({ opacity: f6 ? d4 : y4.opacity * 0.1 }, _), n6.style = _), n6;
      }
      function Ny(s, a) {
        var n6 = this.states[s];
        if (this.style) {
          if (s === "emphasis")
            return j_e(this, s, a, n6);
          if (s === "blur")
            return u7(this, s, n6);
          if (s === "select")
            return Xie(this, s, n6);
        }
        return n6;
      }
      function Wb(s) {
        s.stateProxy = Ny;
        var a = s.getTextContent(), n6 = s.getTextGuideLine();
        a && (a.stateProxy = Ny), n6 && (n6.stateProxy = Ny);
      }
      function Yie(s, a) {
        !Nq(s, a) && !s.__highByOuter && oS(s, Oq);
      }
      function Kie(s, a) {
        !Nq(s, a) && !s.__highByOuter && oS(s, Uie);
      }
      function sS(s, a) {
        s.__highByOuter |= 1 << (a || 0), oS(s, Oq);
      }
      function lS(s, a) {
        !(s.__highByOuter &= ~(1 << (a || 0))) && oS(s, Uie);
      }
      function Zie(s) {
        oS(s, Pq);
      }
      function Rq(s) {
        oS(s, qie);
      }
      function uS(s) {
        oS(s, B_e);
      }
      function pu(s) {
        oS(s, z_e);
      }
      function Nq(s, a) {
        return s.__highDownSilentOnTouch && a.zrByTouch;
      }
      function X1(s) {
        var a = s.getModel();
        a.eachComponent(function(n6, f6) {
          var d4 = kq(f6);
          if (d4.isBlured) {
            var y4 = n6 === "series" ? s.getViewOfSeriesModel(f6) : s.getViewOfComponentModel(f6);
            y4.group.traverse(function(_) {
              qie(_);
            });
          }
          d4.isBlured = false;
        });
      }
      function c7(s, a, n6, f6) {
        var d4 = f6.getModel();
        n6 = n6 || "coordinateSystem";
        function y4(E, O) {
          for (var R = 0; R < O.length; R++) {
            var V = E.getItemGraphicEl(O[R]);
            V && Rq(V);
          }
        }
        if (s != null && !(!a || a === "none")) {
          var _ = d4.getSeriesByIndex(s), S = _.coordinateSystem;
          S && S.master && (S = S.master);
          var T = [];
          d4.eachSeries(function(E) {
            var O = _ === E, R = E.coordinateSystem;
            R && R.master && (R = R.master);
            var V = R && S ? R === S : O;
            if (!(n6 === "series" && !O || n6 === "coordinateSystem" && !V || a === "series" && O)) {
              var z3 = f6.getViewOfSeriesModel(E);
              if (z3.group.traverse(function(ee) {
                Pq(ee);
              }), _0(a))
                y4(E.getData(), a);
              else if (Qo(a))
                for (var H = Wl(a), Z = 0; Z < H.length; Z++)
                  y4(E.getData(H[Z]), a[H[Z]]);
              T.push(E), kq(E).isBlured = true;
            }
          }), d4.eachComponent(function(E, O) {
            if (E !== "series") {
              var R = f6.getViewOfComponentModel(O);
              R && R.blurSeries && R.blurSeries(T, d4);
            }
          });
        }
      }
      function Fq(s, a, n6) {
        if (!(s == null || a == null)) {
          var f6 = n6.getModel().getComponent(s, a);
          if (f6) {
            kq(f6).isBlured = true;
            var d4 = n6.getViewOfComponentModel(f6);
            !d4 || !d4.focusBlurEnabled || d4.group.traverse(function(y4) {
              Pq(y4);
            });
          }
        }
      }
      function Lf(s, a, n6) {
        var f6 = s.seriesIndex, d4 = s.getData(a.dataType);
        if (d4) {
          var y4 = hE(d4, a);
          y4 = (Di(y4) ? y4[0] : y4) || 0;
          var _ = d4.getItemGraphicEl(y4);
          if (!_)
            for (var S = d4.count(), T = 0; !_ && T < S; )
              _ = d4.getItemGraphicEl(T++);
          if (_) {
            var E = qo(_);
            c7(f6, E.focus, E.blurScope, n6);
          } else {
            var O = s.get(["emphasis", "focus"]), R = s.get(["emphasis", "blurScope"]);
            O != null && c7(f6, O, R, n6);
          }
        }
      }
      function Vq(s, a, n6, f6) {
        var d4 = { focusSelf: false, dispatchers: null };
        if (s == null || s === "series" || a == null || n6 == null)
          return d4;
        var y4 = f6.getModel().getComponent(s, a);
        if (!y4)
          return d4;
        var _ = f6.getViewOfComponentModel(y4);
        if (!_ || !_.findHighDownDispatchers)
          return d4;
        for (var S = _.findHighDownDispatchers(n6), T, E = 0; E < S.length; E++)
          if (qo(S[E]).focus === "self") {
            T = true;
            break;
          }
        return { focusSelf: T, dispatchers: S };
      }
      function Jie(s, a, n6) {
        var f6 = qo(s), d4 = Vq(f6.componentMainType, f6.componentIndex, f6.componentHighDownName, n6), y4 = d4.dispatchers, _ = d4.focusSelf;
        y4 ? (_ && Fq(f6.componentMainType, f6.componentIndex, n6), gt(y4, function(S) {
          return Yie(S, a);
        })) : (c7(f6.seriesIndex, f6.focus, f6.blurScope, n6), f6.focus === "self" && Fq(f6.componentMainType, f6.componentIndex, n6), Yie(s, a));
      }
      function f7(s, a, n6) {
        X1(n6);
        var f6 = qo(s), d4 = Vq(f6.componentMainType, f6.componentIndex, f6.componentHighDownName, n6).dispatchers;
        d4 ? gt(d4, function(y4) {
          return Kie(y4, a);
        }) : Kie(s, a);
      }
      function G_e(s, a, n6) {
        if (jq(a)) {
          var f6 = a.dataType, d4 = s.getData(f6), y4 = hE(d4, a);
          Di(y4) || (y4 = [y4]), s[a.type === $1 ? "toggleSelect" : a.type === CE ? "select" : "unselect"](y4, f6);
        }
      }
      function Qie(s) {
        var a = s.getAllData();
        gt(a, function(n6) {
          var f6 = n6.data, d4 = n6.type;
          f6.eachItemGraphicEl(function(y4, _) {
            s.isSelected(_, d4) ? uS(y4) : pu(y4);
          });
        });
      }
      function H_e(s) {
        var a = [];
        return s.eachSeries(function(n6) {
          var f6 = n6.getAllData();
          gt(f6, function(d4) {
            d4.data;
            var y4 = d4.type, _ = n6.getSelectedDataIndices();
            if (_.length > 0) {
              var S = { dataIndex: _, seriesIndex: n6.seriesIndex };
              y4 != null && (S.dataType = y4), a.push(S);
            }
          });
        }), a;
      }
      function TE(s, a, n6) {
        AE(s, true), oS(s, Wb), Bq(s, a, n6);
      }
      function W_e(s) {
        AE(s, false);
      }
      function Up(s, a, n6, f6) {
        f6 ? W_e(s) : TE(s, a, n6);
      }
      function Bq(s, a, n6) {
        var f6 = qo(s);
        a != null ? (f6.focus = a, f6.blurScope = n6) : f6.focus && (f6.focus = null);
      }
      var eae = ["emphasis", "blur", "select"], U_e = { itemStyle: "getItemStyle", lineStyle: "getLineStyle", areaStyle: "getAreaStyle" };
      function Pg(s, a, n6, f6) {
        n6 = n6 || "itemStyle";
        for (var d4 = 0; d4 < eae.length; d4++) {
          var y4 = eae[d4], _ = a.getModel([y4, n6]), S = s.ensureState(y4);
          S.style = f6 ? f6(_) : _[U_e[n6]]();
        }
      }
      function AE(s, a) {
        var n6 = a === false, f6 = s;
        s.highDownSilentOnTouch && (f6.__highDownSilentOnTouch = s.highDownSilentOnTouch), (!n6 || f6.__highDownDispatcher) && (f6.__highByOuter = f6.__highByOuter || 0, f6.__highDownDispatcher = !n6);
      }
      function MR(s) {
        return !!(s && s.__highDownDispatcher);
      }
      function q_e(s, a, n6) {
        var f6 = qo(s);
        f6.componentMainType = a.mainType, f6.componentIndex = a.componentIndex, f6.componentHighDownName = n6;
      }
      function zq(s) {
        var a = ET[s];
        return a == null && Wie <= 32 && (a = ET[s] = Wie++), a;
      }
      function jq(s) {
        var a = s.type;
        return a === CE || a === l7 || a === $1;
      }
      function h7(s) {
        var a = s.type;
        return a === SE || a === s7;
      }
      function $_e(s) {
        var a = ql(s);
        a.normalFill = s.style.fill, a.normalStroke = s.style.stroke;
        var n6 = s.states.select || {};
        a.selectFill = n6.style && n6.style.fill || null, a.selectStroke = n6.style && n6.style.stroke || null;
      }
      var Gk = aS.CMD, X_e = [[], [], []], yv = Math.sqrt, Vm = Math.atan2;
      function tae(s, a) {
        if (a) {
          var n6 = s.data, f6 = s.len(), d4, y4, _, S, T, E, O = Gk.M, R = Gk.C, V = Gk.L, z3 = Gk.R, H = Gk.A, Z = Gk.Q;
          for (_ = 0, S = 0; _ < f6; ) {
            switch (d4 = n6[_++], S = _, y4 = 0, d4) {
              case O:
                y4 = 1;
                break;
              case V:
                y4 = 1;
                break;
              case R:
                y4 = 3;
                break;
              case Z:
                y4 = 2;
                break;
              case H:
                var ee = a[4], oe = a[5], fe = yv(a[0] * a[0] + a[1] * a[1]), _e = yv(a[2] * a[2] + a[3] * a[3]), pe = Vm(-a[1] / _e, a[0] / fe);
                n6[_] *= fe, n6[_++] += ee, n6[_] *= _e, n6[_++] += oe, n6[_++] *= fe, n6[_++] *= _e, n6[_++] += pe, n6[_++] += pe, _ += 2, S = _;
                break;
              case z3:
                E[0] = n6[_++], E[1] = n6[_++], Xv(E, E, a), n6[S++] = E[0], n6[S++] = E[1], E[0] += n6[_++], E[1] += n6[_++], Xv(E, E, a), n6[S++] = E[0], n6[S++] = E[1];
            }
            for (T = 0; T < y4; T++) {
              var Ve = X_e[T];
              Ve[0] = n6[_++], Ve[1] = n6[_++], Xv(Ve, Ve, a), n6[S++] = Ve[0], n6[S++] = Ve[1];
            }
          }
          s.increaseVersion();
        }
      }
      var Gq = Math.sqrt, p7 = Math.sin, TR = Math.cos, AR = Math.PI;
      function nae(s) {
        return Math.sqrt(s[0] * s[0] + s[1] * s[1]);
      }
      function Hq(s, a) {
        return (s[0] * a[0] + s[1] * a[1]) / (nae(s) * nae(a));
      }
      function Wq(s, a) {
        return (s[0] * a[1] < s[1] * a[0] ? -1 : 1) * Math.acos(Hq(s, a));
      }
      function rae(s, a, n6, f6, d4, y4, _, S, T, E, O) {
        var R = T * (AR / 180), V = TR(R) * (s - n6) / 2 + p7(R) * (a - f6) / 2, z3 = -1 * p7(R) * (s - n6) / 2 + TR(R) * (a - f6) / 2, H = V * V / (_ * _) + z3 * z3 / (S * S);
        H > 1 && (_ *= Gq(H), S *= Gq(H));
        var Z = (d4 === y4 ? -1 : 1) * Gq((_ * _ * (S * S) - _ * _ * (z3 * z3) - S * S * (V * V)) / (_ * _ * (z3 * z3) + S * S * (V * V))) || 0, ee = Z * _ * z3 / S, oe = Z * -S * V / _, fe = (s + n6) / 2 + TR(R) * ee - p7(R) * oe, _e = (a + f6) / 2 + p7(R) * ee + TR(R) * oe, pe = Wq([1, 0], [(V - ee) / _, (z3 - oe) / S]), Ve = [(V - ee) / _, (z3 - oe) / S], Le = [(-1 * V - ee) / _, (-1 * z3 - oe) / S], je = Wq(Ve, Le);
        if (Hq(Ve, Le) <= -1 && (je = AR), Hq(Ve, Le) >= 1 && (je = 0), je < 0) {
          var Xe = Math.round(je / AR * 1e6) / 1e6;
          je = AR * 2 + Xe % 2 * AR;
        }
        O.addData(E, fe, _e, _, S, pe, je, R, y4);
      }
      var Y_e = /([mlvhzcqtsa])([^mlvhzcqtsa]*)/ig, K_e = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
      function iae(s) {
        var a = new aS();
        if (!s)
          return a;
        var n6 = 0, f6 = 0, d4 = n6, y4 = f6, _, S = aS.CMD, T = s.match(Y_e);
        if (!T)
          return a;
        for (var E = 0; E < T.length; E++) {
          for (var O = T[E], R = O.charAt(0), V = void 0, z3 = O.match(K_e) || [], H = z3.length, Z = 0; Z < H; Z++)
            z3[Z] = parseFloat(z3[Z]);
          for (var ee = 0; ee < H; ) {
            var oe = void 0, fe = void 0, _e = void 0, pe = void 0, Ve = void 0, Le = void 0, je = void 0, Xe = n6, Ye = f6, rt2 = void 0, ut = void 0;
            switch (R) {
              case "l":
                n6 += z3[ee++], f6 += z3[ee++], V = S.L, a.addData(V, n6, f6);
                break;
              case "L":
                n6 = z3[ee++], f6 = z3[ee++], V = S.L, a.addData(V, n6, f6);
                break;
              case "m":
                n6 += z3[ee++], f6 += z3[ee++], V = S.M, a.addData(V, n6, f6), d4 = n6, y4 = f6, R = "l";
                break;
              case "M":
                n6 = z3[ee++], f6 = z3[ee++], V = S.M, a.addData(V, n6, f6), d4 = n6, y4 = f6, R = "L";
                break;
              case "h":
                n6 += z3[ee++], V = S.L, a.addData(V, n6, f6);
                break;
              case "H":
                n6 = z3[ee++], V = S.L, a.addData(V, n6, f6);
                break;
              case "v":
                f6 += z3[ee++], V = S.L, a.addData(V, n6, f6);
                break;
              case "V":
                f6 = z3[ee++], V = S.L, a.addData(V, n6, f6);
                break;
              case "C":
                V = S.C, a.addData(V, z3[ee++], z3[ee++], z3[ee++], z3[ee++], z3[ee++], z3[ee++]), n6 = z3[ee - 2], f6 = z3[ee - 1];
                break;
              case "c":
                V = S.C, a.addData(V, z3[ee++] + n6, z3[ee++] + f6, z3[ee++] + n6, z3[ee++] + f6, z3[ee++] + n6, z3[ee++] + f6), n6 += z3[ee - 2], f6 += z3[ee - 1];
                break;
              case "S":
                oe = n6, fe = f6, rt2 = a.len(), ut = a.data, _ === S.C && (oe += n6 - ut[rt2 - 4], fe += f6 - ut[rt2 - 3]), V = S.C, Xe = z3[ee++], Ye = z3[ee++], n6 = z3[ee++], f6 = z3[ee++], a.addData(V, oe, fe, Xe, Ye, n6, f6);
                break;
              case "s":
                oe = n6, fe = f6, rt2 = a.len(), ut = a.data, _ === S.C && (oe += n6 - ut[rt2 - 4], fe += f6 - ut[rt2 - 3]), V = S.C, Xe = n6 + z3[ee++], Ye = f6 + z3[ee++], n6 += z3[ee++], f6 += z3[ee++], a.addData(V, oe, fe, Xe, Ye, n6, f6);
                break;
              case "Q":
                Xe = z3[ee++], Ye = z3[ee++], n6 = z3[ee++], f6 = z3[ee++], V = S.Q, a.addData(V, Xe, Ye, n6, f6);
                break;
              case "q":
                Xe = z3[ee++] + n6, Ye = z3[ee++] + f6, n6 += z3[ee++], f6 += z3[ee++], V = S.Q, a.addData(V, Xe, Ye, n6, f6);
                break;
              case "T":
                oe = n6, fe = f6, rt2 = a.len(), ut = a.data, _ === S.Q && (oe += n6 - ut[rt2 - 4], fe += f6 - ut[rt2 - 3]), n6 = z3[ee++], f6 = z3[ee++], V = S.Q, a.addData(V, oe, fe, n6, f6);
                break;
              case "t":
                oe = n6, fe = f6, rt2 = a.len(), ut = a.data, _ === S.Q && (oe += n6 - ut[rt2 - 4], fe += f6 - ut[rt2 - 3]), n6 += z3[ee++], f6 += z3[ee++], V = S.Q, a.addData(V, oe, fe, n6, f6);
                break;
              case "A":
                _e = z3[ee++], pe = z3[ee++], Ve = z3[ee++], Le = z3[ee++], je = z3[ee++], Xe = n6, Ye = f6, n6 = z3[ee++], f6 = z3[ee++], V = S.A, rae(Xe, Ye, n6, f6, Le, je, _e, pe, Ve, V, a);
                break;
              case "a":
                _e = z3[ee++], pe = z3[ee++], Ve = z3[ee++], Le = z3[ee++], je = z3[ee++], Xe = n6, Ye = f6, n6 += z3[ee++], f6 += z3[ee++], V = S.A, rae(Xe, Ye, n6, f6, Le, je, _e, pe, Ve, V, a);
                break;
            }
          }
          (R === "z" || R === "Z") && (V = S.Z, a.addData(V), n6 = d4, f6 = y4), _ = V;
        }
        return a.toStatic(), a;
      }
      var Uq = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.applyTransform = function(n6) {
        }, a;
      }(ml);
      function aae(s) {
        return s.setData != null;
      }
      function oae(s, a) {
        var n6 = iae(s), f6 = ei({}, a);
        return f6.buildPath = function(d4) {
          if (aae(d4)) {
            d4.setData(n6.data);
            var y4 = d4.getContext();
            y4 && d4.rebuildPath(y4, 1);
          } else {
            var y4 = d4;
            n6.rebuildPath(y4, 1);
          }
        }, f6.applyTransform = function(d4) {
          tae(n6, d4), this.dirtyShape();
        }, f6;
      }
      function sae(s, a) {
        return new Uq(oae(s, a));
      }
      function Z_e(s, a) {
        var n6 = oae(s, a), f6 = function(d4) {
          Vt(y4, d4);
          function y4(_) {
            var S = d4.call(this, _) || this;
            return S.applyTransform = n6.applyTransform, S.buildPath = n6.buildPath, S;
          }
          return y4;
        }(Uq);
        return f6;
      }
      function Hk(s, a) {
        for (var n6 = [], f6 = s.length, d4 = 0; d4 < f6; d4++) {
          var y4 = s[d4];
          n6.push(y4.getUpdatedPathProxy(true));
        }
        var _ = new ml(a);
        return _.createPathProxy(), _.buildPath = function(S) {
          if (aae(S)) {
            S.appendPath(n6);
            var T = S.getContext();
            T && S.rebuildPath(T, 1);
          }
        }, _;
      }
      function qq(s, a) {
        a = a || {};
        var n6 = new ml();
        return s.shape && n6.setShape(s.shape), n6.setStyle(s.style), a.bakeTransform ? tae(n6.path, s.getComputedTransform()) : a.toLocal ? n6.setLocalTransform(s.getComputedTransform()) : n6.copyTransform(s), n6.buildPath = s.buildPath, n6.applyTransform = n6.applyTransform, n6.z = s.z, n6.z2 = s.z2, n6.zlevel = s.zlevel, n6;
      }
      var J_e = function() {
        function s() {
          this.cx = 0, this.cy = 0, this.r = 0;
        }
        return s;
      }(), lae = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new J_e();
        }, a.prototype.buildPath = function(n6, f6) {
          n6.moveTo(f6.cx + f6.r, f6.cy), n6.arc(f6.cx, f6.cy, f6.r, 0, Math.PI * 2);
        }, a;
      }(ml);
      lae.prototype.type = "circle";
      var cS = lae, Q_e = function() {
        function s() {
          this.cx = 0, this.cy = 0, this.rx = 0, this.ry = 0;
        }
        return s;
      }(), $q = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new Q_e();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = 0.5522848, y4 = f6.cx, _ = f6.cy, S = f6.rx, T = f6.ry, E = S * d4, O = T * d4;
          n6.moveTo(y4 - S, _), n6.bezierCurveTo(y4 - S, _ - O, y4 - E, _ - T, y4, _ - T), n6.bezierCurveTo(y4 + E, _ - T, y4 + S, _ - O, y4 + S, _), n6.bezierCurveTo(y4 + S, _ + O, y4 + E, _ + T, y4, _ + T), n6.bezierCurveTo(y4 - E, _ + T, y4 - S, _ + O, y4 - S, _), n6.closePath();
        }, a;
      }(ml);
      $q.prototype.type = "ellipse";
      var d7 = $q, uae = Math.PI, Xq = uae * 2, IE = Math.sin, Wk = Math.cos, exe = Math.acos, M0 = Math.atan2, cae = Math.abs, IR = Math.sqrt, ER = Math.max, fS = Math.min, ax = 1e-4;
      function txe(s, a, n6, f6, d4, y4, _, S) {
        var T = n6 - s, E = f6 - a, O = _ - d4, R = S - y4, V = R * T - O * E;
        if (!(V * V < ax))
          return V = (O * (a - y4) - R * (s - d4)) / V, [s + V * T, a + V * E];
      }
      function v7(s, a, n6, f6, d4, y4, _) {
        var S = s - n6, T = a - f6, E = (_ ? y4 : -y4) / IR(S * S + T * T), O = E * T, R = -E * S, V = s + O, z3 = a + R, H = n6 + O, Z = f6 + R, ee = (V + H) / 2, oe = (z3 + Z) / 2, fe = H - V, _e = Z - z3, pe = fe * fe + _e * _e, Ve = d4 - y4, Le = V * Z - H * z3, je = (_e < 0 ? -1 : 1) * IR(ER(0, Ve * Ve * pe - Le * Le)), Xe = (Le * _e - fe * je) / pe, Ye = (-Le * fe - _e * je) / pe, rt2 = (Le * _e + fe * je) / pe, ut = (-Le * fe + _e * je) / pe, wt = Xe - ee, dt = Ye - oe, Gt = rt2 - ee, Qt = ut - oe;
        return wt * wt + dt * dt > Gt * Gt + Qt * Qt && (Xe = rt2, Ye = ut), { cx: Xe, cy: Ye, x0: -O, y0: -R, x1: Xe * (d4 / Ve - 1), y1: Ye * (d4 / Ve - 1) };
      }
      function nxe(s) {
        var a;
        if (Di(s)) {
          var n6 = s.length;
          if (!n6)
            return s;
          n6 === 1 ? a = [s[0], s[0], 0, 0] : n6 === 2 ? a = [s[0], s[0], s[1], s[1]] : n6 === 3 ? a = s.concat(s[2]) : a = s;
        } else
          a = [s, s, s, s];
        return a;
      }
      function rxe(s, a) {
        var n6, f6 = ER(a.r, 0), d4 = ER(a.r0 || 0, 0), y4 = f6 > 0, _ = d4 > 0;
        if (!(!y4 && !_)) {
          if (y4 || (f6 = d4, d4 = 0), d4 > f6) {
            var S = f6;
            f6 = d4, d4 = S;
          }
          var T = a.startAngle, E = a.endAngle;
          if (!(isNaN(T) || isNaN(E))) {
            var O = a.cx, R = a.cy, V = !!a.clockwise, z3 = cae(E - T), H = z3 > Xq && z3 % Xq;
            if (H > ax && (z3 = H), !(f6 > ax))
              s.moveTo(O, R);
            else if (z3 > Xq - ax)
              s.moveTo(O + f6 * Wk(T), R + f6 * IE(T)), s.arc(O, R, f6, T, E, !V), d4 > ax && (s.moveTo(O + d4 * Wk(E), R + d4 * IE(E)), s.arc(O, R, d4, E, T, V));
            else {
              var Z = void 0, ee = void 0, oe = void 0, fe = void 0, _e = void 0, pe = void 0, Ve = void 0, Le = void 0, je = void 0, Xe = void 0, Ye = void 0, rt2 = void 0, ut = void 0, wt = void 0, dt = void 0, Gt = void 0, Qt = f6 * Wk(T), Nt = f6 * IE(T), er = d4 * Wk(E), un = d4 * IE(E), pn = z3 > ax;
              if (pn) {
                var On = a.cornerRadius;
                On && (n6 = nxe(On), Z = n6[0], ee = n6[1], oe = n6[2], fe = n6[3]);
                var fr = cae(f6 - d4) / 2;
                if (_e = fS(fr, oe), pe = fS(fr, fe), Ve = fS(fr, Z), Le = fS(fr, ee), Ye = je = ER(_e, pe), rt2 = Xe = ER(Ve, Le), (je > ax || Xe > ax) && (ut = f6 * Wk(E), wt = f6 * IE(E), dt = d4 * Wk(T), Gt = d4 * IE(T), z3 < uae)) {
                  var yr = txe(Qt, Nt, dt, Gt, ut, wt, er, un);
                  if (yr) {
                    var da = Qt - yr[0], Ja = Nt - yr[1], ko = ut - yr[0], wo = wt - yr[1], So = 1 / IE(exe((da * ko + Ja * wo) / (IR(da * da + Ja * Ja) * IR(ko * ko + wo * wo))) / 2), Fa = IR(yr[0] * yr[0] + yr[1] * yr[1]);
                    Ye = fS(je, (f6 - Fa) / (So + 1)), rt2 = fS(Xe, (d4 - Fa) / (So - 1));
                  }
                }
              }
              if (!pn)
                s.moveTo(O + Qt, R + Nt);
              else if (Ye > ax) {
                var po = fS(oe, Ye), To = fS(fe, Ye), Ya = v7(dt, Gt, Qt, Nt, f6, po, V), $o = v7(ut, wt, er, un, f6, To, V);
                s.moveTo(O + Ya.cx + Ya.x0, R + Ya.cy + Ya.y0), Ye < je && po === To ? s.arc(O + Ya.cx, R + Ya.cy, Ye, M0(Ya.y0, Ya.x0), M0($o.y0, $o.x0), !V) : (po > 0 && s.arc(O + Ya.cx, R + Ya.cy, po, M0(Ya.y0, Ya.x0), M0(Ya.y1, Ya.x1), !V), s.arc(O, R, f6, M0(Ya.cy + Ya.y1, Ya.cx + Ya.x1), M0($o.cy + $o.y1, $o.cx + $o.x1), !V), To > 0 && s.arc(O + $o.cx, R + $o.cy, To, M0($o.y1, $o.x1), M0($o.y0, $o.x0), !V));
              } else
                s.moveTo(O + Qt, R + Nt), s.arc(O, R, f6, T, E, !V);
              if (!(d4 > ax) || !pn)
                s.lineTo(O + er, R + un);
              else if (rt2 > ax) {
                var po = fS(Z, rt2), To = fS(ee, rt2), Ya = v7(er, un, ut, wt, d4, -To, V), $o = v7(Qt, Nt, dt, Gt, d4, -po, V);
                s.lineTo(O + Ya.cx + Ya.x0, R + Ya.cy + Ya.y0), rt2 < Xe && po === To ? s.arc(O + Ya.cx, R + Ya.cy, rt2, M0(Ya.y0, Ya.x0), M0($o.y0, $o.x0), !V) : (To > 0 && s.arc(O + Ya.cx, R + Ya.cy, To, M0(Ya.y0, Ya.x0), M0(Ya.y1, Ya.x1), !V), s.arc(O, R, d4, M0(Ya.cy + Ya.y1, Ya.cx + Ya.x1), M0($o.cy + $o.y1, $o.cx + $o.x1), V), po > 0 && s.arc(O + $o.cx, R + $o.cy, po, M0($o.y1, $o.x1), M0($o.y0, $o.x0), !V));
              } else
                s.lineTo(O + er, R + un), s.arc(O, R, d4, E, T, V);
            }
            s.closePath();
          }
        }
      }
      var ixe = function() {
        function s() {
          this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true, this.cornerRadius = 0;
        }
        return s;
      }(), fae = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new ixe();
        }, a.prototype.buildPath = function(n6, f6) {
          rxe(n6, f6);
        }, a.prototype.isZeroArea = function() {
          return this.shape.startAngle === this.shape.endAngle || this.shape.r === this.shape.r0;
        }, a;
      }(ml);
      fae.prototype.type = "sector";
      var Bm = fae, axe = function() {
        function s() {
          this.cx = 0, this.cy = 0, this.r = 0, this.r0 = 0;
        }
        return s;
      }(), hae = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new axe();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.cx, y4 = f6.cy, _ = Math.PI * 2;
          n6.moveTo(d4 + f6.r, y4), n6.arc(d4, y4, f6.r, 0, _, false), n6.moveTo(d4 + f6.r0, y4), n6.arc(d4, y4, f6.r0, 0, _, true);
        }, a;
      }(ml);
      hae.prototype.type = "ring";
      var g7 = hae;
      function oxe(s, a, n6, f6) {
        var d4 = [], y4 = [], _ = [], S = [], T, E, O, R;
        if (f6) {
          O = [1 / 0, 1 / 0], R = [-1 / 0, -1 / 0];
          for (var V = 0, z3 = s.length; V < z3; V++)
            H_(O, O, s[V]), G1(R, R, s[V]);
          H_(O, O, f6[0]), G1(R, R, f6[1]);
        }
        for (var V = 0, z3 = s.length; V < z3; V++) {
          var H = s[V];
          if (n6)
            T = s[V ? V - 1 : z3 - 1], E = s[(V + 1) % z3];
          else if (V === 0 || V === z3 - 1) {
            d4.push(Yd(s[V]));
            continue;
          } else
            T = s[V - 1], E = s[V + 1];
          Yw(y4, E, T), Kw(y4, y4, a);
          var Z = sU(H, T), ee = sU(H, E), oe = Z + ee;
          oe !== 0 && (Z /= oe, ee /= oe), Kw(_, y4, -Z), Kw(S, y4, ee);
          var fe = oU([], H, _), _e = oU([], H, S);
          f6 && (G1(fe, fe, O), H_(fe, fe, R), G1(_e, _e, O), H_(_e, _e, R)), d4.push(fe), d4.push(_e);
        }
        return n6 && d4.push(d4.shift()), d4;
      }
      function pae(s, a, n6) {
        var f6 = a.smooth, d4 = a.points;
        if (d4 && d4.length >= 2) {
          if (f6) {
            var y4 = oxe(d4, f6, n6, a.smoothConstraint);
            s.moveTo(d4[0][0], d4[0][1]);
            for (var _ = d4.length, S = 0; S < (n6 ? _ : _ - 1); S++) {
              var T = y4[S * 2], E = y4[S * 2 + 1], O = d4[(S + 1) % _];
              s.bezierCurveTo(T[0], T[1], E[0], E[1], O[0], O[1]);
            }
          } else {
            s.moveTo(d4[0][0], d4[0][1]);
            for (var S = 1, R = d4.length; S < R; S++)
              s.lineTo(d4[S][0], d4[S][1]);
          }
          n6 && s.closePath();
        }
      }
      var sxe = function() {
        function s() {
          this.points = null, this.smooth = 0, this.smoothConstraint = null;
        }
        return s;
      }(), dae = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new sxe();
        }, a.prototype.buildPath = function(n6, f6) {
          pae(n6, f6, true);
        }, a;
      }(ml);
      dae.prototype.type = "polygon";
      var T0 = dae, vae = function() {
        function s() {
          this.points = null, this.percent = 1, this.smooth = 0, this.smoothConstraint = null;
        }
        return s;
      }(), Yq = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new vae();
        }, a.prototype.buildPath = function(n6, f6) {
          pae(n6, f6, false);
        }, a;
      }(ml);
      Yq.prototype.type = "polyline";
      var zm = Yq, lxe = {}, uxe = function() {
        function s() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
        }
        return s;
      }(), y7 = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new uxe();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4, y4, _, S;
          if (this.subPixelOptimize) {
            var T = Tq(lxe, f6, this.style);
            d4 = T.x1, y4 = T.y1, _ = T.x2, S = T.y2;
          } else
            d4 = f6.x1, y4 = f6.y1, _ = f6.x2, S = f6.y2;
          var E = f6.percent;
          E !== 0 && (n6.moveTo(d4, y4), E < 1 && (_ = d4 * (1 - E) + _ * E, S = y4 * (1 - E) + S * E), n6.lineTo(_, S));
        }, a.prototype.pointAt = function(n6) {
          var f6 = this.shape;
          return [f6.x1 * (1 - n6) + f6.x2 * n6, f6.y1 * (1 - n6) + f6.y2 * n6];
        }, a;
      }(ml);
      y7.prototype.type = "line";
      var Jv = y7, jm = [], cxe = function() {
        function s() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.percent = 1;
        }
        return s;
      }();
      function Fy(s, a, n6) {
        var f6 = s.cpx2, d4 = s.cpy2;
        return f6 != null || d4 != null ? [(n6 ? Gre : id2)(s.x1, s.cpx1, s.cpx2, s.x2, a), (n6 ? Gre : id2)(s.y1, s.cpy1, s.cpy2, s.y2, a)] : [(n6 ? g9 : Yv)(s.x1, s.cpx1, s.x2, a), (n6 ? g9 : Yv)(s.y1, s.cpy1, s.y2, a)];
      }
      var m7 = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new cxe();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.x1, y4 = f6.y1, _ = f6.x2, S = f6.y2, T = f6.cpx1, E = f6.cpy1, O = f6.cpx2, R = f6.cpy2, V = f6.percent;
          V !== 0 && (n6.moveTo(d4, y4), O == null || R == null ? (V < 1 && (Hp(d4, T, _, V, jm), T = jm[1], _ = jm[2], Hp(y4, E, S, V, jm), E = jm[1], S = jm[2]), n6.quadraticCurveTo(T, E, _, S)) : (V < 1 && ($_(d4, T, O, _, V, jm), T = jm[1], O = jm[2], _ = jm[3], $_(y4, E, R, S, V, jm), E = jm[1], R = jm[2], S = jm[3]), n6.bezierCurveTo(T, E, O, R, _, S)));
        }, a.prototype.pointAt = function(n6) {
          return Fy(this.shape, n6, false);
        }, a.prototype.tangentAt = function(n6) {
          var f6 = Fy(this.shape, n6, true);
          return KI(f6, f6);
        }, a;
      }(ml);
      m7.prototype.type = "bezier-curve";
      var b7 = m7, fxe = function() {
        function s() {
          this.cx = 0, this.cy = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
        }
        return s;
      }(), gae = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new fxe();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.cx, y4 = f6.cy, _ = Math.max(f6.r, 0), S = f6.startAngle, T = f6.endAngle, E = f6.clockwise, O = Math.cos(S), R = Math.sin(S);
          n6.moveTo(O * _ + d4, R * _ + y4), n6.arc(d4, y4, _, S, T, !E);
        }, a;
      }(ml);
      gae.prototype.type = "arc";
      var Kq = gae, Zq = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "compound", n6;
        }
        return a.prototype._updatePathDirty = function() {
          for (var n6 = this.shape.paths, f6 = this.shapeChanged(), d4 = 0; d4 < n6.length; d4++)
            f6 = f6 || n6[d4].shapeChanged();
          f6 && this.dirtyShape();
        }, a.prototype.beforeBrush = function() {
          this._updatePathDirty();
          for (var n6 = this.shape.paths || [], f6 = this.getGlobalScale(), d4 = 0; d4 < n6.length; d4++)
            n6[d4].path || n6[d4].createPathProxy(), n6[d4].path.setScale(f6[0], f6[1], n6[d4].segmentIgnoreThreshold);
        }, a.prototype.buildPath = function(n6, f6) {
          for (var d4 = f6.paths || [], y4 = 0; y4 < d4.length; y4++)
            d4[y4].buildPath(n6, d4[y4].shape, true);
        }, a.prototype.afterBrush = function() {
          for (var n6 = this.shape.paths || [], f6 = 0; f6 < n6.length; f6++)
            n6[f6].pathUpdated();
        }, a.prototype.getBoundingRect = function() {
          return this._updatePathDirty.call(this), ml.prototype.getBoundingRect.call(this);
        }, a;
      }(ml), Jq = Zq, Qq = function() {
        function s(a) {
          this.colorStops = a || [];
        }
        return s.prototype.addColorStop = function(a, n6) {
          this.colorStops.push({ offset: a, color: n6 });
        }, s;
      }(), yae = Qq, hxe = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4, _, S) {
          var T = s.call(this, _) || this;
          return T.x = n6 == null ? 0 : n6, T.y = f6 == null ? 0 : f6, T.x2 = d4 == null ? 1 : d4, T.y2 = y4 == null ? 0 : y4, T.type = "linear", T.global = S || false, T;
        }
        return a;
      }(yae), DR = hxe, pxe = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4, _) {
          var S = s.call(this, y4) || this;
          return S.x = n6 == null ? 0.5 : n6, S.y = f6 == null ? 0.5 : f6, S.r = d4 == null ? 0.5 : d4, S.type = "radial", S.global = _ || false, S;
        }
        return a;
      }(yae), e$ = pxe, EE = [0, 0], DE = [0, 0], _7 = new zs(), Uk = new zs(), t$ = function() {
        function s(a, n6) {
          this._corners = [], this._axes = [], this._origin = [0, 0];
          for (var f6 = 0; f6 < 4; f6++)
            this._corners[f6] = new zs();
          for (var f6 = 0; f6 < 2; f6++)
            this._axes[f6] = new zs();
          a && this.fromBoundingRect(a, n6);
        }
        return s.prototype.fromBoundingRect = function(a, n6) {
          var f6 = this._corners, d4 = this._axes, y4 = a.x, _ = a.y, S = y4 + a.width, T = _ + a.height;
          if (f6[0].set(y4, _), f6[1].set(S, _), f6[2].set(S, T), f6[3].set(y4, T), n6)
            for (var E = 0; E < 4; E++)
              f6[E].transform(n6);
          zs.sub(d4[0], f6[1], f6[0]), zs.sub(d4[1], f6[3], f6[0]), d4[0].normalize(), d4[1].normalize();
          for (var E = 0; E < 2; E++)
            this._origin[E] = d4[E].dot(f6[0]);
        }, s.prototype.intersect = function(a, n6) {
          var f6 = true, d4 = !n6;
          return _7.set(1 / 0, 1 / 0), Uk.set(0, 0), !this._intersectCheckOneSide(this, a, _7, Uk, d4, 1) && (f6 = false, d4) || !this._intersectCheckOneSide(a, this, _7, Uk, d4, -1) && (f6 = false, d4) || d4 || zs.copy(n6, f6 ? _7 : Uk), f6;
        }, s.prototype._intersectCheckOneSide = function(a, n6, f6, d4, y4, _) {
          for (var S = true, T = 0; T < 2; T++) {
            var E = this._axes[T];
            if (this._getProjMinMaxOnAxis(T, a._corners, EE), this._getProjMinMaxOnAxis(T, n6._corners, DE), EE[1] < DE[0] || EE[0] > DE[1]) {
              if (S = false, y4)
                return S;
              var O = Math.abs(DE[0] - EE[1]), R = Math.abs(EE[0] - DE[1]);
              Math.min(O, R) > d4.len() && (O < R ? zs.scale(d4, E, -O * _) : zs.scale(d4, E, R * _));
            } else if (f6) {
              var O = Math.abs(DE[0] - EE[1]), R = Math.abs(EE[0] - DE[1]);
              Math.min(O, R) < f6.len() && (O < R ? zs.scale(f6, E, O * _) : zs.scale(f6, E, -R * _));
            }
          }
          return S;
        }, s.prototype._getProjMinMaxOnAxis = function(a, n6, f6) {
          for (var d4 = this._axes[a], y4 = this._origin, _ = n6[0].dot(d4) + y4[a], S = _, T = _, E = 1; E < n6.length; E++) {
            var O = n6[E].dot(d4) + y4[a];
            S = Math.min(O, S), T = Math.max(O, T);
          }
          f6[0] = S, f6[1] = T;
        }, s;
      }(), x7 = t$, dxe = [], vxe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.notClear = true, n6.incremental = true, n6._displayables = [], n6._temporaryDisplayables = [], n6._cursor = 0, n6;
        }
        return a.prototype.traverse = function(n6, f6) {
          n6.call(f6, this);
        }, a.prototype.useStyle = function() {
          this.style = {};
        }, a.prototype.getCursor = function() {
          return this._cursor;
        }, a.prototype.innerAfterBrush = function() {
          this._cursor = this._displayables.length;
        }, a.prototype.clearDisplaybles = function() {
          this._displayables = [], this._temporaryDisplayables = [], this._cursor = 0, this.markRedraw(), this.notClear = false;
        }, a.prototype.clearTemporalDisplayables = function() {
          this._temporaryDisplayables = [];
        }, a.prototype.addDisplayable = function(n6, f6) {
          f6 ? this._temporaryDisplayables.push(n6) : this._displayables.push(n6), this.markRedraw();
        }, a.prototype.addDisplayables = function(n6, f6) {
          f6 = f6 || false;
          for (var d4 = 0; d4 < n6.length; d4++)
            this.addDisplayable(n6[d4], f6);
        }, a.prototype.getDisplayables = function() {
          return this._displayables;
        }, a.prototype.getTemporalDisplayables = function() {
          return this._temporaryDisplayables;
        }, a.prototype.eachPendingDisplayable = function(n6) {
          for (var f6 = this._cursor; f6 < this._displayables.length; f6++)
            n6 && n6(this._displayables[f6]);
          for (var f6 = 0; f6 < this._temporaryDisplayables.length; f6++)
            n6 && n6(this._temporaryDisplayables[f6]);
        }, a.prototype.update = function() {
          this.updateTransform();
          for (var n6 = this._cursor; n6 < this._displayables.length; n6++) {
            var f6 = this._displayables[n6];
            f6.parent = this, f6.update(), f6.parent = null;
          }
          for (var n6 = 0; n6 < this._temporaryDisplayables.length; n6++) {
            var f6 = this._temporaryDisplayables[n6];
            f6.parent = this, f6.update(), f6.parent = null;
          }
        }, a.prototype.getBoundingRect = function() {
          if (!this._rect) {
            for (var n6 = new il(1 / 0, 1 / 0, -1 / 0, -1 / 0), f6 = 0; f6 < this._displayables.length; f6++) {
              var d4 = this._displayables[f6], y4 = d4.getBoundingRect().clone();
              d4.needLocalTransform() && y4.applyTransform(d4.getLocalTransform(dxe)), n6.union(y4);
            }
            this._rect = n6;
          }
          return this._rect;
        }, a.prototype.contain = function(n6, f6) {
          var d4 = this.transformCoordToLocal(n6, f6), y4 = this.getBoundingRect();
          if (y4.contain(d4[0], d4[1]))
            for (var _ = 0; _ < this._displayables.length; _++) {
              var S = this._displayables[_];
              if (S.contain(n6, f6))
                return true;
            }
          return false;
        }, a;
      }(Hb), gxe = vxe, mae = hu();
      function qk(s, a, n6, f6, d4) {
        var y4;
        if (a && a.ecModel) {
          var _ = a.ecModel.getUpdatePayload();
          y4 = _ && _.animation;
        }
        var S = a && a.isAnimationEnabled(), T = s === "update";
        if (S) {
          var E = void 0, O = void 0, R = void 0;
          f6 ? (E = Zs(f6.duration, 200), O = Zs(f6.easing, "cubicOut"), R = 0) : (E = a.getShallow(T ? "animationDurationUpdate" : "animationDuration"), O = a.getShallow(T ? "animationEasingUpdate" : "animationEasing"), R = a.getShallow(T ? "animationDelayUpdate" : "animationDelay")), y4 && (y4.duration != null && (E = y4.duration), y4.easing != null && (O = y4.easing), y4.delay != null && (R = y4.delay)), jo(R) && (R = R(n6, d4)), jo(E) && (E = E(n6));
          var V = { duration: E || 0, delay: R, easing: O };
          return V;
        } else
          return null;
      }
      function n$(s, a, n6, f6, d4, y4, _) {
        var S = false, T;
        jo(d4) ? (_ = y4, y4 = d4, d4 = null) : Qo(d4) && (y4 = d4.cb, _ = d4.during, S = d4.isFrom, T = d4.removeOpt, d4 = d4.dataIndex);
        var E = s === "leave";
        E || a.stopAnimation("leave");
        var O = qk(s, f6, d4, E ? T || {} : null, f6 && f6.getAnimationDelayParams ? f6.getAnimationDelayParams(a, d4) : null);
        if (O && O.duration > 0) {
          var R = O.duration, V = O.delay, z3 = O.easing, H = { duration: R, delay: V || 0, easing: z3, done: y4, force: !!y4 || !!_, setToFinal: !E, scope: s, during: _ };
          S ? a.animateFrom(n6, H) : a.animateTo(n6, H);
        } else
          a.stopAnimation(), !S && a.attr(n6), _ && _(1), y4 && y4();
      }
      function ku(s, a, n6, f6, d4, y4) {
        n$("update", s, a, n6, f6, d4, y4);
      }
      function $h(s, a, n6, f6, d4, y4) {
        n$("enter", s, a, n6, f6, d4, y4);
      }
      function $k(s) {
        if (!s.__zr)
          return true;
        for (var a = 0; a < s.animators.length; a++) {
          var n6 = s.animators[a];
          if (n6.scope === "leave")
            return true;
        }
        return false;
      }
      function kT(s, a, n6, f6, d4, y4) {
        $k(s) || n$("leave", s, a, n6, f6, d4, y4);
      }
      function bae(s, a, n6, f6) {
        s.removeTextContent(), s.removeTextGuideLine(), kT(s, { style: { opacity: 0 } }, a, n6, f6);
      }
      function kR(s, a, n6) {
        function f6() {
          s.parent && s.parent.remove(s);
        }
        s.isGroup ? s.traverse(function(d4) {
          d4.isGroup || bae(d4, a, n6, f6);
        }) : bae(s, a, n6, f6);
      }
      function ox(s) {
        mae(s).oldStyle = s.style;
      }
      function yxe(s) {
        return mae(s).oldStyle;
      }
      var w7 = Math.max, S7 = Math.min, r$ = {};
      function mxe(s) {
        return ml.extend(s);
      }
      var bxe = Z_e;
      function _xe(s, a) {
        return bxe(s, a);
      }
      function U(s, a) {
        r$[s] = a;
      }
      function ae(s) {
        if (r$.hasOwnProperty(s))
          return r$[s];
      }
      function Ie(s, a, n6, f6) {
        var d4 = sae(s, a);
        return n6 && (f6 === "center" && (n6 = At(n6, d4.getBoundingRect())), Hn(d4, n6)), d4;
      }
      function Qe(s, a, n6) {
        var f6 = new Zv({ style: { image: s, x: a.x, y: a.y, width: a.width, height: a.height }, onload: function(d4) {
          if (n6 === "center") {
            var y4 = { width: d4.width, height: d4.height };
            f6.setStyle(At(a, y4));
          }
        } });
        return f6;
      }
      function At(s, a) {
        var n6 = a.width / a.height, f6 = s.height * n6, d4;
        f6 <= s.width ? d4 = s.height : (f6 = s.width, d4 = f6 / n6);
        var y4 = s.x + s.width / 2, _ = s.y + s.height / 2;
        return { x: y4 - f6 / 2, y: _ - d4 / 2, width: f6, height: d4 };
      }
      var en = Hk;
      function Hn(s, a) {
        if (s.applyTransform) {
          var n6 = s.getBoundingRect(), f6 = n6.calculateTransform(a);
          s.applyTransform(f6);
        }
      }
      function Qn(s) {
        return Tq(s.shape, s.shape, s.style), s;
      }
      function Or(s) {
        return Aq(s.shape, s.shape, s.style), s;
      }
      var ia = IT;
      function Qi(s, a) {
        for (var n6 = rR([]); s && s !== a; )
          cC(n6, s.getLocalTransform(), n6), s = s.parent;
        return n6;
      }
      function pa(s, a, n6) {
        return a && !_0(a) && (a = Q_.getLocalTransform(a)), n6 && (a = aE([], a)), Xv([], s, a);
      }
      function mo(s, a, n6) {
        var f6 = a[4] === 0 || a[5] === 0 || a[0] === 0 ? 1 : Math.abs(2 * a[4] / a[0]), d4 = a[4] === 0 || a[5] === 0 || a[2] === 0 ? 1 : Math.abs(2 * a[4] / a[2]), y4 = [s === "left" ? -f6 : s === "right" ? f6 : 0, s === "top" ? -d4 : s === "bottom" ? d4 : 0];
        return y4 = pa(y4, a, n6), Math.abs(y4[0]) > Math.abs(y4[1]) ? y4[0] > 0 ? "right" : "left" : y4[1] > 0 ? "bottom" : "top";
      }
      function Ss(s) {
        return !s.isGroup;
      }
      function ul(s) {
        return s.shape != null;
      }
      function $l(s, a, n6) {
        if (!s || !a)
          return;
        function f6(_) {
          var S = {};
          return _.traverse(function(T) {
            Ss(T) && T.anid && (S[T.anid] = T);
          }), S;
        }
        function d4(_) {
          var S = { x: _.x, y: _.y, rotation: _.rotation };
          return ul(_) && (S.shape = ei({}, _.shape)), S;
        }
        var y4 = f6(s);
        a.traverse(function(_) {
          if (Ss(_) && _.anid) {
            var S = y4[_.anid];
            if (S) {
              var T = d4(_);
              _.attr(d4(S)), ku(_, T, n6, qo(_).dataIndex);
            }
          }
        });
      }
      function al(s, a) {
        return Pi(s, function(n6) {
          var f6 = n6[0];
          f6 = w7(f6, a.x), f6 = S7(f6, a.x + a.width);
          var d4 = n6[1];
          return d4 = w7(d4, a.y), d4 = S7(d4, a.y + a.height), [f6, d4];
        });
      }
      function bc(s, a) {
        var n6 = w7(s.x, a.x), f6 = S7(s.x + s.width, a.x + a.width), d4 = w7(s.y, a.y), y4 = S7(s.y + s.height, a.y + a.height);
        if (f6 >= n6 && y4 >= d4)
          return { x: n6, y: d4, width: f6 - n6, height: y4 - d4 };
      }
      function Gu(s, a, n6) {
        var f6 = ei({ rectHover: true }, a), d4 = f6.style = { strokeNoScale: true };
        if (n6 = n6 || { x: -1, y: -1, width: 2, height: 2 }, s)
          return s.indexOf("image://") === 0 ? (d4.image = s.slice(8), zo(d4, n6), new Zv(f6)) : Ie(s.replace("path://", ""), f6, n6, "center");
      }
      function Lg(s, a, n6, f6, d4) {
        for (var y4 = 0, _ = d4[d4.length - 1]; y4 < d4.length; y4++) {
          var S = d4[y4];
          if (A0(s, a, n6, f6, S[0], S[1], _[0], _[1]))
            return true;
          _ = S;
        }
      }
      function A0(s, a, n6, f6, d4, y4, _, S) {
        var T = n6 - s, E = f6 - a, O = _ - d4, R = S - y4, V = Vy(O, R, T, E);
        if (Md(V))
          return false;
        var z3 = s - d4, H = a - y4, Z = Vy(z3, H, T, E) / V;
        if (Z < 0 || Z > 1)
          return false;
        var ee = Vy(z3, H, O, R) / V;
        return !(ee < 0 || ee > 1);
      }
      function Vy(s, a, n6, f6) {
        return s * f6 - n6 * a;
      }
      function Md(s) {
        return s <= 1e-6 && s >= -1e-6;
      }
      function I0(s) {
        var a = s.itemTooltipOption, n6 = s.componentModel, f6 = s.itemName, d4 = Wa(a) ? { formatter: a } : a, y4 = n6.mainType, _ = n6.componentIndex, S = { componentType: y4, name: f6, $vars: ["name"] };
        S[y4 + "Index"] = _;
        var T = s.formatterParamsExtra;
        T && gt(Wl(T), function(O) {
          io(S, O) || (S[O] = T[O], S.$vars.push(O));
        });
        var E = qo(s.el);
        E.componentMainType = y4, E.componentIndex = _, E.tooltipConfig = { name: f6, option: zo({ content: f6, formatterParams: S }, d4) };
      }
      function hS(s, a) {
        var n6;
        s.isGroup && (n6 = a(s)), n6 || s.traverse(a);
      }
      function mC(s, a) {
        if (s)
          if (Di(s))
            for (var n6 = 0; n6 < s.length; n6++)
              hS(s[n6], a);
          else
            hS(s, a);
      }
      U("circle", cS), U("ellipse", d7), U("sector", Bm), U("ring", g7), U("polygon", T0), U("polyline", zm), U("rect", xu), U("line", Jv), U("bezierCurve", b7), U("arc", Kq);
      var i$ = Object.freeze(Object.defineProperty({ __proto__: null, updateProps: ku, initProps: $h, removeElement: kT, removeElementWithFadeOut: kR, isElementRemoved: $k, extendShape: mxe, extendPath: _xe, registerShape: U, getShapeClass: ae, makePath: Ie, makeImage: Qe, mergePath: en, resizePath: Hn, subPixelOptimizeLine: Qn, subPixelOptimizeRect: Or, subPixelOptimize: ia, getTransform: Qi, applyTransform: pa, transformDirection: mo, groupTransition: $l, clipPointsByRect: al, clipRectByRect: bc, createIcon: Gu, linePolygonIntersect: Lg, lineLineIntersect: A0, setTooltipConfig: I0, traverseElements: mC, Group: fs, Image: Zv, Text: ju, Circle: cS, Ellipse: d7, Sector: Bm, Ring: g7, Polygon: T0, Polyline: zm, Rect: xu, Line: Jv, BezierCurve: b7, Arc: Kq, IncrementalDisplayable: gxe, CompoundPath: Jq, LinearGradient: DR, RadialGradient: e$, BoundingRect: il, OrientedBoundingRect: x7, Point: zs, Path: ml }, Symbol.toStringTag, { value: "Module" })), _ae = {};
      function cje(s, a) {
        for (var n6 = 0; n6 < od.length; n6++) {
          var f6 = od[n6], d4 = a[f6], y4 = s.ensureState(f6);
          y4.style = y4.style || {}, y4.style.text = d4;
        }
        var _ = s.currentStates.slice();
        s.clearStates(true), s.setStyle({ text: a.normal }), s.useStates(_, true);
      }
      function xxe(s, a, n6) {
        var f6 = s.labelFetcher, d4 = s.labelDataIndex, y4 = s.labelDimIndex, _ = a.normal, S;
        f6 && (S = f6.getFormattedLabel(d4, "normal", null, y4, _ && _.get("formatter"), n6 != null ? { interpolatedValue: n6 } : null)), S == null && (S = jo(s.defaultText) ? s.defaultText(d4, s, n6) : s.defaultText);
        for (var T = { normal: S }, E = 0; E < od.length; E++) {
          var O = od[E], R = a[O];
          T[O] = Zs(f6 ? f6.getFormattedLabel(d4, O, null, y4, R && R.get("formatter")) : null, S);
        }
        return T;
      }
      function Gm(s, a, n6, f6) {
        n6 = n6 || _ae;
        for (var d4 = s instanceof ju, y4 = false, _ = 0; _ < SR.length; _++) {
          var S = a[SR[_]];
          if (S && S.getShallow("show")) {
            y4 = true;
            break;
          }
        }
        var T = d4 ? s : s.getTextContent();
        if (y4) {
          d4 || (T || (T = new ju(), s.setTextContent(T)), s.stateProxy && (T.stateProxy = s.stateProxy));
          var E = xxe(n6, a), O = a.normal, R = !!O.getShallow("show"), V = Zd(O, f6 && f6.normal, n6, false, !d4);
          V.text = E.normal, d4 || s.setTextConfig(xae(O, n6, false));
          for (var _ = 0; _ < od.length; _++) {
            var z3 = od[_], S = a[z3];
            if (S) {
              var H = T.ensureState(z3), Z = !!Zs(S.getShallow("show"), R);
              if (Z !== R && (H.ignore = !Z), H.style = Zd(S, f6 && f6[z3], n6, true, !d4), H.style.text = E[z3], !d4) {
                var ee = s.ensureState(z3);
                ee.textConfig = xae(S, n6, true);
              }
            }
          }
          T.silent = !!O.getShallow("silent"), T.style.x != null && (V.x = T.style.x), T.style.y != null && (V.y = T.style.y), T.ignore = !R, T.useStyle(V), T.dirty(), n6.enableTextSetter && (C7(T).setLabelText = function(oe) {
            var fe = xxe(n6, a, oe);
            cje(T, fe);
          });
        } else
          T && (T.ignore = true);
        s.dirty();
      }
      function E0(s, a) {
        a = a || "label";
        for (var n6 = { normal: s.getModel(a) }, f6 = 0; f6 < od.length; f6++) {
          var d4 = od[f6];
          n6[d4] = s.getModel([d4, a]);
        }
        return n6;
      }
      function Zd(s, a, n6, f6, d4) {
        var y4 = {};
        return DRt(y4, s, n6, f6, d4), a && ei(y4, a), y4;
      }
      function xae(s, a, n6) {
        a = a || {};
        var f6 = {}, d4, y4 = s.getShallow("rotate"), _ = Zs(s.getShallow("distance"), n6 ? null : 5), S = s.getShallow("offset");
        return d4 = s.getShallow("position") || (n6 ? null : "inside"), d4 === "outside" && (d4 = a.defaultOutsidePosition || "top"), d4 != null && (f6.position = d4), S != null && (f6.offset = S), y4 != null && (y4 *= Math.PI / 180, f6.rotation = y4), _ != null && (f6.distance = _), f6.outsideFill = s.get("color") === "inherit" ? a.inheritColor || null : "auto", f6;
      }
      function DRt(s, a, n6, f6, d4) {
        n6 = n6 || _ae;
        var y4 = a.ecModel, _ = y4 && y4.option.textStyle, S = kRt(a), T;
        if (S) {
          T = {};
          for (var E in S)
            if (S.hasOwnProperty(E)) {
              var O = a.getModel(["rich", E]);
              dje(T[E] = {}, O, _, n6, f6, d4, false, true);
            }
        }
        T && (s.rich = T);
        var R = a.get("overflow");
        R && (s.overflow = R);
        var V = a.get("minMargin");
        V != null && (s.margin = V), dje(s, a, _, n6, f6, d4, true, false);
      }
      function kRt(s) {
        for (var a; s && s !== s.ecModel; ) {
          var n6 = (s.option || _ae).rich;
          if (n6) {
            a = a || {};
            for (var f6 = Wl(n6), d4 = 0; d4 < f6.length; d4++) {
              var y4 = f6[d4];
              a[y4] = 1;
            }
          }
          s = s.parentModel;
        }
        return a;
      }
      var fje = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "textShadowColor", "textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], hje = ["align", "lineHeight", "width", "height", "tag", "verticalAlign"], pje = ["padding", "borderWidth", "borderRadius", "borderDashOffset", "backgroundColor", "borderColor", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"];
      function dje(s, a, n6, f6, d4, y4, _, S) {
        n6 = !d4 && n6 || _ae;
        var T = f6 && f6.inheritColor, E = a.getShallow("color"), O = a.getShallow("textBorderColor"), R = Zs(a.getShallow("opacity"), n6.opacity);
        (E === "inherit" || E === "auto") && (T ? E = T : E = null), (O === "inherit" || O === "auto") && (T ? O = T : O = null), y4 || (E = E || n6.color, O = O || n6.textBorderColor), E != null && (s.fill = E), O != null && (s.stroke = O);
        var V = Zs(a.getShallow("textBorderWidth"), n6.textBorderWidth);
        V != null && (s.lineWidth = V);
        var z3 = Zs(a.getShallow("textBorderType"), n6.textBorderType);
        z3 != null && (s.lineDash = z3);
        var H = Zs(a.getShallow("textBorderDashOffset"), n6.textBorderDashOffset);
        H != null && (s.lineDashOffset = H), !d4 && R == null && !S && (R = f6 && f6.defaultOpacity), R != null && (s.opacity = R), !d4 && !y4 && s.fill == null && f6.inheritColor && (s.fill = f6.inheritColor);
        for (var Z = 0; Z < fje.length; Z++) {
          var ee = fje[Z], oe = Zs(a.getShallow(ee), n6[ee]);
          oe != null && (s[ee] = oe);
        }
        for (var Z = 0; Z < hje.length; Z++) {
          var ee = hje[Z], oe = a.getShallow(ee);
          oe != null && (s[ee] = oe);
        }
        if (s.verticalAlign == null) {
          var fe = a.getShallow("baseline");
          fe != null && (s.verticalAlign = fe);
        }
        if (!_ || !f6.disableBox) {
          for (var Z = 0; Z < pje.length; Z++) {
            var ee = pje[Z], oe = a.getShallow(ee);
            oe != null && (s[ee] = oe);
          }
          var _e = a.getShallow("borderType");
          _e != null && (s.borderDash = _e), (s.backgroundColor === "auto" || s.backgroundColor === "inherit") && T && (s.backgroundColor = T), (s.borderColor === "auto" || s.borderColor === "inherit") && T && (s.borderColor = T);
        }
      }
      function vje(s, a) {
        var n6 = a && a.getModel("textStyle");
        return wh([s.fontStyle || n6 && n6.getShallow("fontStyle") || "", s.fontWeight || n6 && n6.getShallow("fontWeight") || "", (s.fontSize || n6 && n6.getShallow("fontSize") || 12) + "px", s.fontFamily || n6 && n6.getShallow("fontFamily") || "sans-serif"].join(" "));
      }
      var C7 = hu();
      function gje(s, a, n6, f6) {
        if (s) {
          var d4 = C7(s);
          d4.prevValue = d4.value, d4.value = n6;
          var y4 = a.normal;
          d4.valueAnimation = y4.get("valueAnimation"), d4.valueAnimation && (d4.precision = y4.get("precision"), d4.defaultInterpolatedText = f6, d4.statesModels = a);
        }
      }
      function yje(s, a, n6, f6, d4) {
        var y4 = C7(s);
        if (!y4.valueAnimation || y4.prevValue === y4.value)
          return;
        var _ = y4.defaultInterpolatedText, S = Zs(y4.interpolatedValue, y4.prevValue), T = y4.value;
        function E(O) {
          var R = iq(n6, y4.precision, S, T, O);
          y4.interpolatedValue = O === 1 ? null : R;
          var V = xxe({ labelDataIndex: a, labelFetcher: d4, defaultText: _ ? _(R) : R + "" }, y4.statesModels, R);
          cje(s, V);
        }
        s.percent = 0, (y4.prevValue == null ? $h : ku)(s, { percent: 1 }, f6, a, null, E);
      }
      var ORt = ["textStyle", "color"], wxe = ["fontStyle", "fontWeight", "fontSize", "fontFamily", "padding", "lineHeight", "rich", "width", "height", "overflow"], Sxe = new ju(), PRt = function() {
        function s() {
        }
        return s.prototype.getTextColor = function(a) {
          var n6 = this.ecModel;
          return this.getShallow("color") || (!a && n6 ? n6.get(ORt) : null);
        }, s.prototype.getFont = function() {
          return vje({ fontStyle: this.getShallow("fontStyle"), fontWeight: this.getShallow("fontWeight"), fontSize: this.getShallow("fontSize"), fontFamily: this.getShallow("fontFamily") }, this.ecModel);
        }, s.prototype.getTextRect = function(a) {
          for (var n6 = { text: a, verticalAlign: this.getShallow("verticalAlign") || this.getShallow("baseline") }, f6 = 0; f6 < wxe.length; f6++)
            n6[wxe[f6]] = this.getShallow(wxe[f6]);
          return Sxe.useStyle(n6), Sxe.update(), Sxe.getBoundingRect();
        }, s;
      }(), LRt = PRt, mje = [["lineWidth", "width"], ["stroke", "color"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "type"], ["lineDashOffset", "dashOffset"], ["lineCap", "cap"], ["lineJoin", "join"], ["miterLimit"]], RRt = vE(mje), NRt = function() {
        function s() {
        }
        return s.prototype.getLineStyle = function(a) {
          return RRt(this, a);
        }, s;
      }(), bje = [["fill", "color"], ["stroke", "borderColor"], ["lineWidth", "borderWidth"], ["opacity"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"], ["lineDash", "borderType"], ["lineDashOffset", "borderDashOffset"], ["lineCap", "borderCap"], ["lineJoin", "borderJoin"], ["miterLimit", "borderMiterLimit"]], FRt = vE(bje), VRt = function() {
        function s() {
        }
        return s.prototype.getItemStyle = function(a, n6) {
          return FRt(this, a, n6);
        }, s;
      }(), OR = function() {
        function s(a, n6, f6) {
          this.parentModel = n6, this.ecModel = f6, this.option = a;
        }
        return s.prototype.init = function(a, n6, f6) {
          for (var d4 = [], y4 = 3; y4 < arguments.length; y4++)
            d4[y4 - 3] = arguments[y4];
        }, s.prototype.mergeOption = function(a, n6) {
          Ms(this.option, a, true);
        }, s.prototype.get = function(a, n6) {
          return a == null ? this.option : this._doGet(this.parsePath(a), !n6 && this.parentModel);
        }, s.prototype.getShallow = function(a, n6) {
          var f6 = this.option, d4 = f6 == null ? f6 : f6[a];
          if (d4 == null && !n6) {
            var y4 = this.parentModel;
            y4 && (d4 = y4.getShallow(a));
          }
          return d4;
        }, s.prototype.getModel = function(a, n6) {
          var f6 = a != null, d4 = f6 ? this.parsePath(a) : null, y4 = f6 ? this._doGet(d4) : this.option;
          return n6 = n6 || this.parentModel && this.parentModel.getModel(this.resolveParentPath(d4)), new s(y4, n6, this.ecModel);
        }, s.prototype.isEmpty = function() {
          return this.option == null;
        }, s.prototype.restoreData = function() {
        }, s.prototype.clone = function() {
          var a = this.constructor;
          return new a(Bo(this.option));
        }, s.prototype.parsePath = function(a) {
          return typeof a == "string" ? a.split(".") : a;
        }, s.prototype.resolveParentPath = function(a) {
          return a;
        }, s.prototype.isAnimationEnabled = function() {
          if (!Na.node && this.option) {
            if (this.option.animation != null)
              return !!this.option.animation;
            if (this.parentModel)
              return this.parentModel.isAnimationEnabled();
          }
        }, s.prototype._doGet = function(a, n6) {
          var f6 = this.option;
          if (!a)
            return f6;
          for (var d4 = 0; d4 < a.length && !(!!a[d4] && (f6 = f6 && typeof f6 == "object" ? f6[a[d4]] : null, f6 == null)); d4++)
            ;
          return f6 == null && n6 && (f6 = n6._doGet(this.resolveParentPath(a), n6.parentModel)), f6;
        }, s;
      }();
      $9(OR), dE(OR), nd(OR, NRt), nd(OR, VRt), nd(OR, i_e), nd(OR, LRt);
      var Sh = OR, BRt = Math.round(Math.random() * 10);
      function M7(s) {
        return [s || "", BRt++].join("_");
      }
      function zRt(s) {
        var a = {};
        s.registerSubTypeDefaulter = function(n6, f6) {
          var d4 = Rm(n6);
          a[d4.main] = f6;
        }, s.determineSubType = function(n6, f6) {
          var d4 = f6.type;
          if (!d4) {
            var y4 = Rm(n6).main;
            s.hasSubTypes(n6) && a[y4] && (d4 = a[y4](f6));
          }
          return d4;
        };
      }
      function jRt(s, a) {
        s.topologicalTravel = function(y4, _, S, T) {
          if (!y4.length)
            return;
          var E = n6(_), O = E.graph, R = E.noEntryList, V = {};
          for (gt(y4, function(fe) {
            V[fe] = true;
          }); R.length; ) {
            var z3 = R.pop(), H = O[z3], Z = !!V[z3];
            Z && (S.call(T, z3, H.originalDeps.slice()), delete V[z3]), gt(H.successor, Z ? oe : ee);
          }
          gt(V, function() {
            var fe = "";
            throw new Error(fe);
          });
          function ee(fe) {
            O[fe].entryCount--, O[fe].entryCount === 0 && R.push(fe);
          }
          function oe(fe) {
            V[fe] = true, ee(fe);
          }
        };
        function n6(y4) {
          var _ = {}, S = [];
          return gt(y4, function(T) {
            var E = f6(_, T), O = E.originalDeps = a(T), R = d4(O, y4);
            E.entryCount = R.length, E.entryCount === 0 && S.push(T), gt(R, function(V) {
              Ns(E.predecessor, V) < 0 && E.predecessor.push(V);
              var z3 = f6(_, V);
              Ns(z3.successor, V) < 0 && z3.successor.push(T);
            });
          }), { graph: _, noEntryList: S };
        }
        function f6(y4, _) {
          return y4[_] || (y4[_] = { predecessor: [], successor: [] }), y4[_];
        }
        function d4(y4, _) {
          var S = [];
          return gt(y4, function(T) {
            Ns(_, T) >= 0 && S.push(T);
          }), S;
        }
      }
      function Xk(s, a) {
        return Ms(Ms({}, s, true), a, true);
      }
      var GRt = { time: { month: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthAbbr: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayOfWeek: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayOfWeekAbbr: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"] }, legend: { selector: { all: "All", inverse: "Inv" } }, toolbox: { brush: { title: { rect: "Box Select", polygon: "Lasso Select", lineX: "Horizontally Select", lineY: "Vertically Select", keep: "Keep Selections", clear: "Clear Selections" } }, dataView: { title: "Data View", lang: ["Data View", "Close", "Refresh"] }, dataZoom: { title: { zoom: "Zoom", back: "Zoom Reset" } }, magicType: { title: { line: "Switch to Line Chart", bar: "Switch to Bar Chart", stack: "Stack", tiled: "Tile" } }, restore: { title: "Restore" }, saveAsImage: { title: "Save as Image", lang: ["Right Click to Save Image"] } }, series: { typeNames: { pie: "Pie chart", bar: "Bar chart", line: "Line chart", scatter: "Scatter plot", effectScatter: "Ripple scatter plot", radar: "Radar chart", tree: "Tree", treemap: "Treemap", boxplot: "Boxplot", candlestick: "Candlestick", k: "K line chart", heatmap: "Heat map", map: "Map", parallel: "Parallel coordinate map", lines: "Line graph", graph: "Relationship graph", sankey: "Sankey diagram", funnel: "Funnel chart", gauge: "Gauge", pictorialBar: "Pictorial bar", themeRiver: "Theme River Map", sunburst: "Sunburst" } }, aria: { general: { withTitle: 'This is a chart about "{title}"', withoutTitle: "This is a chart" }, series: { single: { prefix: "", withName: " with type {seriesType} named {seriesName}.", withoutName: " with type {seriesType}." }, multiple: { prefix: ". It consists of {seriesCount} series count.", withName: " The {seriesId} series is a {seriesType} representing {seriesName}.", withoutName: " The {seriesId} series is a {seriesType}.", separator: { middle: "", end: "" } } }, data: { allData: "The data is as follows: ", partialData: "The first {displayCnt} items are: ", withName: "the data for {name} is {value}", withoutName: "{value}", separator: { middle: ", ", end: ". " } } } }, HRt = { time: { month: ["\u4E00\u6708", "\u4E8C\u6708", "\u4E09\u6708", "\u56DB\u6708", "\u4E94\u6708", "\u516D\u6708", "\u4E03\u6708", "\u516B\u6708", "\u4E5D\u6708", "\u5341\u6708", "\u5341\u4E00\u6708", "\u5341\u4E8C\u6708"], monthAbbr: ["1\u6708", "2\u6708", "3\u6708", "4\u6708", "5\u6708", "6\u6708", "7\u6708", "8\u6708", "9\u6708", "10\u6708", "11\u6708", "12\u6708"], dayOfWeek: ["\u661F\u671F\u65E5", "\u661F\u671F\u4E00", "\u661F\u671F\u4E8C", "\u661F\u671F\u4E09", "\u661F\u671F\u56DB", "\u661F\u671F\u4E94", "\u661F\u671F\u516D"], dayOfWeekAbbr: ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"] }, legend: { selector: { all: "\u5168\u9009", inverse: "\u53CD\u9009" } }, toolbox: { brush: { title: { rect: "\u77E9\u5F62\u9009\u62E9", polygon: "\u5708\u9009", lineX: "\u6A2A\u5411\u9009\u62E9", lineY: "\u7EB5\u5411\u9009\u62E9", keep: "\u4FDD\u6301\u9009\u62E9", clear: "\u6E05\u9664\u9009\u62E9" } }, dataView: { title: "\u6570\u636E\u89C6\u56FE", lang: ["\u6570\u636E\u89C6\u56FE", "\u5173\u95ED", "\u5237\u65B0"] }, dataZoom: { title: { zoom: "\u533A\u57DF\u7F29\u653E", back: "\u533A\u57DF\u7F29\u653E\u8FD8\u539F" } }, magicType: { title: { line: "\u5207\u6362\u4E3A\u6298\u7EBF\u56FE", bar: "\u5207\u6362\u4E3A\u67F1\u72B6\u56FE", stack: "\u5207\u6362\u4E3A\u5806\u53E0", tiled: "\u5207\u6362\u4E3A\u5E73\u94FA" } }, restore: { title: "\u8FD8\u539F" }, saveAsImage: { title: "\u4FDD\u5B58\u4E3A\u56FE\u7247", lang: ["\u53F3\u952E\u53E6\u5B58\u4E3A\u56FE\u7247"] } }, series: { typeNames: { pie: "\u997C\u56FE", bar: "\u67F1\u72B6\u56FE", line: "\u6298\u7EBF\u56FE", scatter: "\u6563\u70B9\u56FE", effectScatter: "\u6D9F\u6F2A\u6563\u70B9\u56FE", radar: "\u96F7\u8FBE\u56FE", tree: "\u6811\u56FE", treemap: "\u77E9\u5F62\u6811\u56FE", boxplot: "\u7BB1\u578B\u56FE", candlestick: "K\u7EBF\u56FE", k: "K\u7EBF\u56FE", heatmap: "\u70ED\u529B\u56FE", map: "\u5730\u56FE", parallel: "\u5E73\u884C\u5750\u6807\u56FE", lines: "\u7EBF\u56FE", graph: "\u5173\u7CFB\u56FE", sankey: "\u6851\u57FA\u56FE", funnel: "\u6F0F\u6597\u56FE", gauge: "\u4EEA\u8868\u76D8\u56FE", pictorialBar: "\u8C61\u5F62\u67F1\u56FE", themeRiver: "\u4E3B\u9898\u6CB3\u6D41\u56FE", sunburst: "\u65ED\u65E5\u56FE" } }, aria: { general: { withTitle: "\u8FD9\u662F\u4E00\u4E2A\u5173\u4E8E\u201C{title}\u201D\u7684\u56FE\u8868\u3002", withoutTitle: "\u8FD9\u662F\u4E00\u4E2A\u56FE\u8868\uFF0C" }, series: { single: { prefix: "", withName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\uFF0C\u8868\u793A{seriesName}\u3002", withoutName: "\u56FE\u8868\u7C7B\u578B\u662F{seriesType}\u3002" }, multiple: { prefix: "\u5B83\u7531{seriesCount}\u4E2A\u56FE\u8868\u7CFB\u5217\u7EC4\u6210\u3002", withName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A\u8868\u793A{seriesName}\u7684{seriesType}\uFF0C", withoutName: "\u7B2C{seriesId}\u4E2A\u7CFB\u5217\u662F\u4E00\u4E2A{seriesType}\uFF0C", separator: { middle: "\uFF1B", end: "\u3002" } } }, data: { allData: "\u5176\u6570\u636E\u662F\u2014\u2014", partialData: "\u5176\u4E2D\uFF0C\u524D{displayCnt}\u9879\u662F\u2014\u2014", withName: "{name}\u7684\u6570\u636E\u662F{value}", withoutName: "{value}", separator: { middle: "\uFF0C", end: "" } } } }, wae = "ZH", Cxe = "EN", a$ = Cxe, Sae = {}, Mxe = {}, _je = Na.domSupported ? function() {
        var s = (document.documentElement.lang || navigator.language || navigator.browserLanguage).toUpperCase();
        return s.indexOf(wae) > -1 ? wae : a$;
      }() : a$;
      function xje(s, a) {
        s = s.toUpperCase(), Mxe[s] = new Sh(a), Sae[s] = a;
      }
      function WRt(s) {
        if (Wa(s)) {
          var a = Sae[s.toUpperCase()] || {};
          return s === wae || s === Cxe ? Bo(a) : Ms(Bo(a), Bo(Sae[a$]), false);
        } else
          return Ms(Bo(s), Bo(Sae[a$]), false);
      }
      function Txe(s) {
        return Mxe[s];
      }
      function URt() {
        return Mxe[a$];
      }
      xje(Cxe, GRt), xje(wae, HRt);
      var Axe = 1e3, Ixe = Axe * 60, o$ = Ixe * 60, pS = o$ * 24, wje = pS * 365, s$ = { year: "{yyyy}", month: "{MMM}", day: "{d}", hour: "{HH}:{mm}", minute: "{HH}:{mm}", second: "{HH}:{mm}:{ss}", millisecond: "{HH}:{mm}:{ss} {SSS}", none: "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss} {SSS}" }, Cae = "{yyyy}-{MM}-{dd}", Sje = { year: "{yyyy}", month: "{yyyy}-{MM}", day: Cae, hour: Cae + " " + s$.hour, minute: Cae + " " + s$.minute, second: Cae + " " + s$.second, millisecond: s$.none }, Exe = ["year", "month", "day", "hour", "minute", "second", "millisecond"], Cje = ["year", "half-year", "quarter", "month", "week", "half-week", "day", "half-day", "quarter-day", "hour", "minute", "second", "millisecond"];
      function PR(s, a) {
        return s += "", "0000".substr(0, a - s.length) + s;
      }
      function T7(s) {
        switch (s) {
          case "half-year":
          case "quarter":
            return "month";
          case "week":
          case "half-week":
            return "day";
          case "half-day":
          case "quarter-day":
            return "hour";
          default:
            return s;
        }
      }
      function qRt(s) {
        return s === T7(s);
      }
      function $Rt(s) {
        switch (s) {
          case "year":
          case "month":
            return "day";
          case "millisecond":
            return "millisecond";
          default:
            return "second";
        }
      }
      function Mae(s, a, n6, f6) {
        var d4 = nx(s), y4 = d4[Dxe(n6)](), _ = d4[A7(n6)]() + 1, S = Math.floor((_ - 1) / 4) + 1, T = d4[Tae(n6)](), E = d4["get" + (n6 ? "UTC" : "") + "Day"](), O = d4[l$(n6)](), R = (O - 1) % 12 + 1, V = d4[Aae(n6)](), z3 = d4[Iae(n6)](), H = d4[Eae(n6)](), Z = f6 instanceof Sh ? f6 : Txe(f6 || _je) || URt(), ee = Z.getModel("time"), oe = ee.get("month"), fe = ee.get("monthAbbr"), _e = ee.get("dayOfWeek"), pe = ee.get("dayOfWeekAbbr");
        return (a || "").replace(/{yyyy}/g, y4 + "").replace(/{yy}/g, y4 % 100 + "").replace(/{Q}/g, S + "").replace(/{MMMM}/g, oe[_ - 1]).replace(/{MMM}/g, fe[_ - 1]).replace(/{MM}/g, PR(_, 2)).replace(/{M}/g, _ + "").replace(/{dd}/g, PR(T, 2)).replace(/{d}/g, T + "").replace(/{eeee}/g, _e[E]).replace(/{ee}/g, pe[E]).replace(/{e}/g, E + "").replace(/{HH}/g, PR(O, 2)).replace(/{H}/g, O + "").replace(/{hh}/g, PR(R + "", 2)).replace(/{h}/g, R + "").replace(/{mm}/g, PR(V, 2)).replace(/{m}/g, V + "").replace(/{ss}/g, PR(z3, 2)).replace(/{s}/g, z3 + "").replace(/{SSS}/g, PR(H, 3)).replace(/{S}/g, H + "");
      }
      function XRt(s, a, n6, f6, d4) {
        var y4 = null;
        if (Wa(n6))
          y4 = n6;
        else if (jo(n6))
          y4 = n6(s.value, a, { level: s.level });
        else {
          var _ = ei({}, s$);
          if (s.level > 0)
            for (var S = 0; S < Exe.length; ++S)
              _[Exe[S]] = "{primary|" + _[Exe[S]] + "}";
          var T = n6 ? n6.inherit === false ? n6 : zo(n6, _) : _, E = Mje(s.value, d4);
          if (T[E])
            y4 = T[E];
          else if (T.inherit) {
            for (var O = Cje.indexOf(E), S = O - 1; S >= 0; --S)
              if (T[E]) {
                y4 = T[E];
                break;
              }
            y4 = y4 || _.none;
          }
          if (Di(y4)) {
            var R = s.level == null ? 0 : s.level >= 0 ? s.level : y4.length + s.level;
            R = Math.min(R, y4.length - 1), y4 = y4[R];
          }
        }
        return Mae(new Date(s.value), y4, d4, f6);
      }
      function Mje(s, a) {
        var n6 = nx(s), f6 = n6[A7(a)]() + 1, d4 = n6[Tae(a)](), y4 = n6[l$(a)](), _ = n6[Aae(a)](), S = n6[Iae(a)](), T = n6[Eae(a)](), E = T === 0, O = E && S === 0, R = O && _ === 0, V = R && y4 === 0, z3 = V && d4 === 1, H = z3 && f6 === 1;
        return H ? "year" : z3 ? "month" : V ? "day" : R ? "hour" : O ? "minute" : E ? "second" : "millisecond";
      }
      function Tje(s, a, n6) {
        var f6 = ac(s) ? nx(s) : s;
        switch (a = a || Mje(s, n6), a) {
          case "year":
            return f6[Dxe(n6)]();
          case "half-year":
            return f6[A7(n6)]() >= 6 ? 1 : 0;
          case "quarter":
            return Math.floor((f6[A7(n6)]() + 1) / 4);
          case "month":
            return f6[A7(n6)]();
          case "day":
            return f6[Tae(n6)]();
          case "half-day":
            return f6[l$(n6)]() / 24;
          case "hour":
            return f6[l$(n6)]();
          case "minute":
            return f6[Aae(n6)]();
          case "second":
            return f6[Iae(n6)]();
          case "millisecond":
            return f6[Eae(n6)]();
        }
      }
      function Dxe(s) {
        return s ? "getUTCFullYear" : "getFullYear";
      }
      function A7(s) {
        return s ? "getUTCMonth" : "getMonth";
      }
      function Tae(s) {
        return s ? "getUTCDate" : "getDate";
      }
      function l$(s) {
        return s ? "getUTCHours" : "getHours";
      }
      function Aae(s) {
        return s ? "getUTCMinutes" : "getMinutes";
      }
      function Iae(s) {
        return s ? "getUTCSeconds" : "getSeconds";
      }
      function Eae(s) {
        return s ? "getUTCMilliseconds" : "getMilliseconds";
      }
      function YRt(s) {
        return s ? "setUTCFullYear" : "setFullYear";
      }
      function Aje(s) {
        return s ? "setUTCMonth" : "setMonth";
      }
      function Ije(s) {
        return s ? "setUTCDate" : "setDate";
      }
      function Eje(s) {
        return s ? "setUTCHours" : "setHours";
      }
      function Dje(s) {
        return s ? "setUTCMinutes" : "setMinutes";
      }
      function kje(s) {
        return s ? "setUTCSeconds" : "setSeconds";
      }
      function Oje(s) {
        return s ? "setUTCMilliseconds" : "setMilliseconds";
      }
      function Pje(s) {
        if (!fie(s))
          return Wa(s) ? s : "-";
        var a = (s + "").split(".");
        return a[0].replace(/(\d{1,3})(?=(?:\d{3})+(?!\d))/g, "$1,") + (a.length > 1 ? "." + a[1] : "");
      }
      function Lje(s, a) {
        return s = (s || "").toLowerCase().replace(/-(.)/g, function(n6, f6) {
          return f6.toUpperCase();
        }), a && s && (s = s.charAt(0).toUpperCase() + s.slice(1)), s;
      }
      var I7 = s9, KRt = /([&<>"'])/g, ZRt = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" };
      function sx(s) {
        return s == null ? "" : (s + "").replace(KRt, function(a, n6) {
          return ZRt[n6];
        });
      }
      function kxe(s, a, n6) {
        var f6 = "{yyyy}-{MM}-{dd} {HH}:{mm}:{ss}";
        function d4(O) {
          return O && wh(O) ? O : "-";
        }
        function y4(O) {
          return !!(O != null && !isNaN(O) && isFinite(O));
        }
        var _ = a === "time", S = s instanceof Date;
        if (_ || S) {
          var T = _ ? nx(s) : s;
          if (isNaN(+T)) {
            if (S)
              return "-";
          } else
            return Mae(T, f6, n6);
        }
        if (a === "ordinal")
          return FL(s) ? d4(s) : ac(s) && y4(s) ? s + "" : "-";
        var E = eS(s);
        return y4(E) ? Pje(E) : FL(s) ? d4(s) : typeof s == "boolean" ? s + "" : "-";
      }
      var Rje = ["a", "b", "c", "d", "e", "f", "g"], Oxe = function(s, a) {
        return "{" + s + (a == null ? "" : a) + "}";
      };
      function Nje(s, a, n6) {
        Di(a) || (a = [a]);
        var f6 = a.length;
        if (!f6)
          return "";
        for (var d4 = a[0].$vars || [], y4 = 0; y4 < d4.length; y4++) {
          var _ = Rje[y4];
          s = s.replace(Oxe(_), Oxe(_, 0));
        }
        for (var S = 0; S < f6; S++)
          for (var T = 0; T < d4.length; T++) {
            var E = a[S][d4[T]];
            s = s.replace(Oxe(Rje[T], S), n6 ? sx(E) : E);
          }
        return s;
      }
      function JRt(s, a, n6) {
        return gt(a, function(f6, d4) {
          s = s.replace("{" + d4 + "}", n6 ? sx(f6) : f6);
        }), s;
      }
      function QRt(s, a) {
        var n6 = Wa(s) ? { color: s, extraCssText: a } : s || {}, f6 = n6.color, d4 = n6.type;
        a = n6.extraCssText;
        var y4 = n6.renderMode || "html";
        if (!f6)
          return "";
        if (y4 === "html")
          return d4 === "subItem" ? '<span style="display:inline-block;vertical-align:middle;margin-right:8px;margin-left:3px;border-radius:4px;width:4px;height:4px;background-color:' + sx(f6) + ";" + (a || "") + '"></span>' : '<span style="display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:' + sx(f6) + ";" + (a || "") + '"></span>';
        var _ = n6.markerId || "markerX";
        return { renderMode: y4, content: "{" + _ + "|}  ", style: d4 === "subItem" ? { width: 4, height: 4, borderRadius: 2, backgroundColor: f6 } : { width: 10, height: 10, borderRadius: 5, backgroundColor: f6 } };
      }
      function LR(s, a) {
        return a = a || "transparent", Wa(s) ? s : Qo(s) && s.colorStops && (s.colorStops[0] || {}).color || a;
      }
      function Dae(s, a) {
        if (a === "_blank" || a === "blank") {
          var n6 = window.open();
          n6.opener = null, n6.location.href = s;
        } else
          window.open(s, a);
      }
      var kae = gt, Fje = ["left", "right", "top", "bottom", "width", "height"], RR = [["width", "left", "right"], ["height", "top", "bottom"]];
      function Pxe(s, a, n6, f6, d4) {
        var y4 = 0, _ = 0;
        f6 == null && (f6 = 1 / 0), d4 == null && (d4 = 1 / 0);
        var S = 0;
        a.eachChild(function(T, E) {
          var O = T.getBoundingRect(), R = a.childAt(E + 1), V = R && R.getBoundingRect(), z3, H;
          if (s === "horizontal") {
            var Z = O.width + (V ? -V.x + O.x : 0);
            z3 = y4 + Z, z3 > f6 || T.newline ? (y4 = 0, z3 = Z, _ += S + n6, S = O.height) : S = Math.max(S, O.height);
          } else {
            var ee = O.height + (V ? -V.y + O.y : 0);
            H = _ + ee, H > d4 || T.newline ? (y4 += S + n6, _ = 0, H = ee, S = O.width) : S = Math.max(S, O.width);
          }
          T.newline || (T.x = y4, T.y = _, T.markRedraw(), s === "horizontal" ? y4 = z3 + n6 : _ = H + n6);
        });
      }
      var NR = Pxe;
      ks(Pxe, "vertical"), ks(Pxe, "horizontal");
      function e4t(s, a, n6) {
        var f6 = a.width, d4 = a.height, y4 = Ia(s.left, f6), _ = Ia(s.top, d4), S = Ia(s.right, f6), T = Ia(s.bottom, d4);
        return (isNaN(y4) || isNaN(parseFloat(s.left))) && (y4 = 0), (isNaN(S) || isNaN(parseFloat(s.right))) && (S = f6), (isNaN(_) || isNaN(parseFloat(s.top))) && (_ = 0), (isNaN(T) || isNaN(parseFloat(s.bottom))) && (T = d4), n6 = I7(n6 || 0), { width: Math.max(S - y4 - n6[1] - n6[3], 0), height: Math.max(T - _ - n6[0] - n6[2], 0) };
      }
      function Qv(s, a, n6) {
        n6 = I7(n6 || 0);
        var f6 = a.width, d4 = a.height, y4 = Ia(s.left, f6), _ = Ia(s.top, d4), S = Ia(s.right, f6), T = Ia(s.bottom, d4), E = Ia(s.width, f6), O = Ia(s.height, d4), R = n6[2] + n6[0], V = n6[1] + n6[3], z3 = s.aspect;
        switch (isNaN(E) && (E = f6 - S - V - y4), isNaN(O) && (O = d4 - T - R - _), z3 != null && (isNaN(E) && isNaN(O) && (z3 > f6 / d4 ? E = f6 * 0.8 : O = d4 * 0.8), isNaN(E) && (E = z3 * O), isNaN(O) && (O = E / z3)), isNaN(y4) && (y4 = f6 - S - E - V), isNaN(_) && (_ = d4 - T - O - R), s.left || s.right) {
          case "center":
            y4 = f6 / 2 - E / 2 - n6[3];
            break;
          case "right":
            y4 = f6 - E - V;
            break;
        }
        switch (s.top || s.bottom) {
          case "middle":
          case "center":
            _ = d4 / 2 - O / 2 - n6[0];
            break;
          case "bottom":
            _ = d4 - O - R;
            break;
        }
        y4 = y4 || 0, _ = _ || 0, isNaN(E) && (E = f6 - V - y4 - (S || 0)), isNaN(O) && (O = d4 - R - _ - (T || 0));
        var H = new il(y4 + n6[3], _ + n6[0], E, O);
        return H.margin = n6, H;
      }
      function Oae(s, a, n6, f6, d4, y4) {
        var _ = !d4 || !d4.hv || d4.hv[0], S = !d4 || !d4.hv || d4.hv[1], T = d4 && d4.boundingMode || "all";
        if (y4 = y4 || s, y4.x = s.x, y4.y = s.y, !_ && !S)
          return false;
        var E;
        if (T === "raw")
          E = s.type === "group" ? new il(0, 0, +a.width || 0, +a.height || 0) : s.getBoundingRect();
        else if (E = s.getBoundingRect(), s.needLocalTransform()) {
          var O = s.getLocalTransform();
          E = E.clone(), E.applyTransform(O);
        }
        var R = Qv(zo({ width: E.width, height: E.height }, a), n6, f6), V = _ ? R.x - E.x : 0, z3 = S ? R.y - E.y : 0;
        return T === "raw" ? (y4.x = V, y4.y = z3) : (y4.x += V, y4.y += z3), y4 === s && s.markRedraw(), true;
      }
      function t4t(s, a) {
        return s[RR[a][0]] != null || s[RR[a][1]] != null && s[RR[a][2]] != null;
      }
      function u$(s) {
        var a = s.layoutMode || s.constructor.layoutMode;
        return Qo(a) ? a : a ? { type: a } : null;
      }
      function Yk(s, a, n6) {
        var f6 = n6 && n6.ignoreSize;
        !Di(f6) && (f6 = [f6, f6]);
        var d4 = _(RR[0], 0), y4 = _(RR[1], 1);
        E(RR[0], s, d4), E(RR[1], s, y4);
        function _(O, R) {
          var V = {}, z3 = 0, H = {}, Z = 0, ee = 2;
          if (kae(O, function(_e) {
            H[_e] = s[_e];
          }), kae(O, function(_e) {
            S(a, _e) && (V[_e] = H[_e] = a[_e]), T(V, _e) && z3++, T(H, _e) && Z++;
          }), f6[R])
            return T(a, O[1]) ? H[O[2]] = null : T(a, O[2]) && (H[O[1]] = null), H;
          if (Z === ee || !z3)
            return H;
          if (z3 >= ee)
            return V;
          for (var oe = 0; oe < O.length; oe++) {
            var fe = O[oe];
            if (!S(V, fe) && S(s, fe)) {
              V[fe] = s[fe];
              break;
            }
          }
          return V;
        }
        function S(O, R) {
          return O.hasOwnProperty(R);
        }
        function T(O, R) {
          return O[R] != null && O[R] !== "auto";
        }
        function E(O, R, V) {
          kae(O, function(z3) {
            R[z3] = V[z3];
          });
        }
      }
      function E7(s) {
        return Vje({}, s);
      }
      function Vje(s, a) {
        return a && s && kae(Fje, function(n6) {
          a.hasOwnProperty(n6) && (s[n6] = a[n6]);
        }), s;
      }
      var n4t = hu(), D7 = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this, n6, f6, d4) || this;
          return y4.uid = M7("ec_cpt_model"), y4;
        }
        return a.prototype.init = function(n6, f6, d4) {
          this.mergeDefaultAndTheme(n6, d4);
        }, a.prototype.mergeDefaultAndTheme = function(n6, f6) {
          var d4 = u$(this), y4 = d4 ? E7(n6) : {}, _ = f6.getTheme();
          Ms(n6, _.get(this.mainType)), Ms(n6, this.getDefaultOption()), d4 && Yk(n6, y4, d4);
        }, a.prototype.mergeOption = function(n6, f6) {
          Ms(this.option, n6, true);
          var d4 = u$(this);
          d4 && Yk(this.option, n6, d4);
        }, a.prototype.optionUpdated = function(n6, f6) {
        }, a.prototype.getDefaultOption = function() {
          var n6 = this.constructor;
          if (!yie(n6))
            return n6.defaultOption;
          var f6 = n4t(this);
          if (!f6.defaultOption) {
            for (var d4 = [], y4 = n6; y4; ) {
              var _ = y4.prototype.defaultOption;
              _ && d4.push(_), y4 = y4.superClass;
            }
            for (var S = {}, T = d4.length - 1; T >= 0; T--)
              S = Ms(S, d4[T], true);
            f6.defaultOption = S;
          }
          return f6.defaultOption;
        }, a.prototype.getReferringComponents = function(n6, f6) {
          var d4 = n6 + "Index", y4 = n6 + "Id";
          return yR(this.ecModel, n6, { index: this.get(d4, true), id: this.get(y4, true) }, f6);
        }, a.prototype.getBoxLayoutParams = function() {
          var n6 = this;
          return { left: n6.get("left"), top: n6.get("top"), right: n6.get("right"), bottom: n6.get("bottom"), width: n6.get("width"), height: n6.get("height") };
        }, a.prototype.getZLevelKey = function() {
          return "";
        }, a.prototype.setZLevel = function(n6) {
          this.option.zlevel = n6;
        }, a.protoInitialize = function() {
          var n6 = a.prototype;
          n6.type = "component", n6.id = "", n6.name = "", n6.mainType = "", n6.subType = "", n6.componentIndex = 0;
        }(), a;
      }(Sh);
      sq(D7, Sh), Y9(D7), zRt(D7), jRt(D7, r4t);
      function r4t(s) {
        var a = [];
        return gt(D7.getClassesByMainType(s), function(n6) {
          a = a.concat(n6.dependencies || n6.prototype.dependencies || []);
        }), a = Pi(a, function(n6) {
          return Rm(n6).main;
        }), s !== "dataset" && Ns(a, "dataset") <= 0 && a.unshift("dataset"), a;
      }
      var oc = D7, Bje = "";
      typeof navigator != "undefined" && (Bje = navigator.platform || "");
      var k7 = "rgba(0, 0, 0, 0.2)", i4t = { darkMode: "auto", colorBy: "series", color: ["#5470c6", "#91cc75", "#fac858", "#ee6666", "#73c0de", "#3ba272", "#fc8452", "#9a60b4", "#ea7ccc"], gradientColor: ["#f6efa6", "#d88273", "#bf444c"], aria: { decal: { decals: [{ color: k7, dashArrayX: [1, 0], dashArrayY: [2, 5], symbolSize: 1, rotation: Math.PI / 6 }, { color: k7, symbol: "circle", dashArrayX: [[8, 8], [0, 8, 8, 0]], dashArrayY: [6, 0], symbolSize: 0.8 }, { color: k7, dashArrayX: [1, 0], dashArrayY: [4, 3], rotation: -Math.PI / 4 }, { color: k7, dashArrayX: [[6, 6], [0, 6, 6, 0]], dashArrayY: [6, 0] }, { color: k7, dashArrayX: [[1, 0], [1, 6]], dashArrayY: [1, 0, 6, 0], rotation: Math.PI / 4 }, { color: k7, symbol: "triangle", dashArrayX: [[9, 9], [0, 9, 9, 0]], dashArrayY: [7, 2], symbolSize: 0.75 }] } }, textStyle: { fontFamily: Bje.match(/^Win/) ? "Microsoft YaHei" : "sans-serif", fontSize: 12, fontStyle: "normal", fontWeight: "normal" }, blendMode: null, stateAnimation: { duration: 300, easing: "cubicOut" }, animation: "auto", animationDuration: 1e3, animationDurationUpdate: 500, animationEasing: "cubicInOut", animationEasingUpdate: "cubicInOut", animationThreshold: 2e3, progressiveThreshold: 3e3, progressive: 400, hoverLayerThreshold: 3e3, useUTC: false }, zje = ro(["tooltip", "label", "itemName", "itemId", "itemGroupId", "seriesName"]), dS = "original", Hm = "arrayRows", vS = "objectRows", OT = "keyedColumns", Kk = "typedArray", jje = "unknown", PT = "column", O7 = "row", By = { Must: 1, Might: 2, Not: 3 }, Gje = hu();
      function a4t(s) {
        Gje(s).datasetMap = ro();
      }
      function Hje(s, a, n6) {
        var f6 = {}, d4 = Rxe(a);
        if (!d4 || !s)
          return f6;
        var y4 = [], _ = [], S = a.ecModel, T = Gje(S).datasetMap, E = d4.uid + "_" + n6.seriesLayoutBy, O, R;
        s = s.slice(), gt(s, function(Z, ee) {
          var oe = Qo(Z) ? Z : s[ee] = { name: Z };
          oe.type === "ordinal" && O == null && (O = ee, R = H(oe)), f6[oe.name] = [];
        });
        var V = T.get(E) || T.set(E, { categoryWayDim: R, valueWayDim: 0 });
        gt(s, function(Z, ee) {
          var oe = Z.name, fe = H(Z);
          if (O == null) {
            var _e = V.valueWayDim;
            z3(f6[oe], _e, fe), z3(_, _e, fe), V.valueWayDim += fe;
          } else if (O === ee)
            z3(f6[oe], 0, fe), z3(y4, 0, fe);
          else {
            var _e = V.categoryWayDim;
            z3(f6[oe], _e, fe), z3(_, _e, fe), V.categoryWayDim += fe;
          }
        });
        function z3(Z, ee, oe) {
          for (var fe = 0; fe < oe; fe++)
            Z.push(ee + fe);
        }
        function H(Z) {
          var ee = Z.dimsDef;
          return ee ? ee.length : 1;
        }
        return y4.length && (f6.itemName = y4), _.length && (f6.seriesName = _), f6;
      }
      function Lxe(s, a, n6) {
        var f6 = {}, d4 = Rxe(s);
        if (!d4)
          return f6;
        var y4 = a.sourceFormat, _ = a.dimensionsDefine, S;
        (y4 === vS || y4 === OT) && gt(_, function(O, R) {
          (Qo(O) ? O.name : O) === "name" && (S = R);
        });
        var T = function() {
          for (var O = {}, R = {}, V = [], z3 = 0, H = Math.min(5, n6); z3 < H; z3++) {
            var Z = Uje(a.data, y4, a.seriesLayoutBy, _, a.startIndex, z3);
            V.push(Z);
            var ee = Z === By.Not;
            if (ee && O.v == null && z3 !== S && (O.v = z3), (O.n == null || O.n === O.v || !ee && V[O.n] === By.Not) && (O.n = z3), oe(O) && V[O.n] !== By.Not)
              return O;
            ee || (Z === By.Might && R.v == null && z3 !== S && (R.v = z3), (R.n == null || R.n === R.v) && (R.n = z3));
          }
          function oe(fe) {
            return fe.v != null && fe.n != null;
          }
          return oe(O) ? O : oe(R) ? R : null;
        }();
        if (T) {
          f6.value = [T.v];
          var E = S != null ? S : T.n;
          f6.itemName = [E], f6.seriesName = [E];
        }
        return f6;
      }
      function Rxe(s) {
        var a = s.get("data", true);
        if (!a)
          return yR(s.ecModel, "dataset", { index: s.get("datasetIndex", true), id: s.get("datasetId", true) }, ad).models[0];
      }
      function o4t(s) {
        return !s.get("transform", true) && !s.get("fromTransformResult", true) ? [] : yR(s.ecModel, "dataset", { index: s.get("fromDatasetIndex", true), id: s.get("fromDatasetId", true) }, ad).models;
      }
      function Wje(s, a) {
        return Uje(s.data, s.sourceFormat, s.seriesLayoutBy, s.dimensionsDefine, s.startIndex, a);
      }
      function Uje(s, a, n6, f6, d4, y4) {
        var _, S = 5;
        if (j1(s))
          return By.Not;
        var T, E;
        if (f6) {
          var O = f6[y4];
          Qo(O) ? (T = O.name, E = O.type) : Wa(O) && (T = O);
        }
        if (E != null)
          return E === "ordinal" ? By.Must : By.Not;
        if (a === Hm) {
          var R = s;
          if (n6 === O7) {
            for (var V = R[y4], z3 = 0; z3 < (V || []).length && z3 < S; z3++)
              if ((_ = pe(V[d4 + z3])) != null)
                return _;
          } else
            for (var z3 = 0; z3 < R.length && z3 < S; z3++) {
              var H = R[d4 + z3];
              if (H && (_ = pe(H[y4])) != null)
                return _;
            }
        } else if (a === vS) {
          var Z = s;
          if (!T)
            return By.Not;
          for (var z3 = 0; z3 < Z.length && z3 < S; z3++) {
            var ee = Z[z3];
            if (ee && (_ = pe(ee[T])) != null)
              return _;
          }
        } else if (a === OT) {
          var oe = s;
          if (!T)
            return By.Not;
          var V = oe[T];
          if (!V || j1(V))
            return By.Not;
          for (var z3 = 0; z3 < V.length && z3 < S; z3++)
            if ((_ = pe(V[z3])) != null)
              return _;
        } else if (a === dS)
          for (var fe = s, z3 = 0; z3 < fe.length && z3 < S; z3++) {
            var ee = fe[z3], _e = pC(ee);
            if (!Di(_e))
              return By.Not;
            if ((_ = pe(_e[y4])) != null)
              return _;
          }
        function pe(Ve) {
          var Le = Wa(Ve);
          if (Ve != null && isFinite(Ve) && Ve !== "")
            return Le ? By.Might : By.Not;
          if (Le && Ve !== "-")
            return By.Must;
        }
        return By.Not;
      }
      var Nxe = ro();
      function s4t(s, a) {
        Ty(Nxe.get(s) == null && a), Nxe.set(s, a);
      }
      function l4t(s, a, n6) {
        var f6 = Nxe.get(a);
        if (!f6)
          return n6;
        var d4 = f6(s);
        return d4 ? n6.concat(d4) : n6;
      }
      var qje = hu(), u4t = hu(), Fxe = function() {
        function s() {
        }
        return s.prototype.getColorFromPalette = function(a, n6, f6) {
          var d4 = jc(this.get("color", true)), y4 = this.get("colorLayer", true);
          return $je(this, qje, d4, y4, a, n6, f6);
        }, s.prototype.clearColorPalette = function() {
          f4t(this, qje);
        }, s;
      }();
      function Vxe(s, a, n6, f6) {
        var d4 = jc(s.get(["aria", "decal", "decals"]));
        return $je(s, u4t, d4, null, a, n6, f6);
      }
      function c4t(s, a) {
        for (var n6 = s.length, f6 = 0; f6 < n6; f6++)
          if (s[f6].length > a)
            return s[f6];
        return s[n6 - 1];
      }
      function $je(s, a, n6, f6, d4, y4, _) {
        y4 = y4 || s;
        var S = a(y4), T = S.paletteIdx || 0, E = S.paletteNameMap = S.paletteNameMap || {};
        if (E.hasOwnProperty(d4))
          return E[d4];
        var O = _ == null || !f6 ? n6 : c4t(f6, _);
        if (O = O || n6, !(!O || !O.length)) {
          var R = O[T];
          return d4 && (E[d4] = R), S.paletteIdx = (T + 1) % O.length, R;
        }
      }
      function f4t(s, a) {
        a(s).paletteIdx = 0, a(s).paletteNameMap = {};
      }
      var Pae, c$, Xje, Yje = "\0_ec_inner", h4t = 1, Kje = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.init = function(n6, f6, d4, y4, _, S) {
          y4 = y4 || {}, this.option = null, this._theme = new Sh(y4), this._locale = new Sh(_), this._optionManager = S;
        }, a.prototype.setOption = function(n6, f6, d4) {
          var y4 = Qje(f6);
          this._optionManager.setOption(n6, d4, y4), this._resetOption(null, y4);
        }, a.prototype.resetOption = function(n6, f6) {
          return this._resetOption(n6, Qje(f6));
        }, a.prototype._resetOption = function(n6, f6) {
          var d4 = false, y4 = this._optionManager;
          if (!n6 || n6 === "recreate") {
            var _ = y4.mountOption(n6 === "recreate");
            !this.option || n6 === "recreate" ? Xje(this, _) : (this.restoreData(), this._mergeOption(_, f6)), d4 = true;
          }
          if ((n6 === "timeline" || n6 === "media") && this.restoreData(), !n6 || n6 === "recreate" || n6 === "timeline") {
            var S = y4.getTimelineOption(this);
            S && (d4 = true, this._mergeOption(S, f6));
          }
          if (!n6 || n6 === "recreate" || n6 === "media") {
            var T = y4.getMediaOption(this);
            T.length && gt(T, function(E) {
              d4 = true, this._mergeOption(E, f6);
            }, this);
          }
          return d4;
        }, a.prototype.mergeOption = function(n6) {
          this._mergeOption(n6, null);
        }, a.prototype._mergeOption = function(n6, f6) {
          var d4 = this.option, y4 = this._componentsMap, _ = this._componentsCount, S = [], T = ro(), E = f6 && f6.replaceMergeMainTypeMap;
          a4t(this), gt(n6, function(R, V) {
            R != null && (oc.hasClass(V) ? V && (S.push(V), T.set(V, true)) : d4[V] = d4[V] == null ? Bo(R) : Ms(d4[V], R, true));
          }), E && E.each(function(R, V) {
            oc.hasClass(V) && !T.get(V) && (S.push(V), T.set(V, true));
          }), oc.topologicalTravel(S, oc.getAllClassMainTypes(), O, this);
          function O(R) {
            var V = l4t(this, R, jc(n6[R])), z3 = y4.get(R), H = z3 ? E && E.get(R) ? "replaceMerge" : "normalMerge" : "replaceAll", Z = wT(z3, V, H);
            dC(Z, R, oc), d4[R] = null, y4.set(R, null), _.set(R, 0);
            var ee = [], oe = [], fe = 0, _e;
            gt(Z, function(pe, Ve) {
              var Le = pe.existing, je = pe.newOption;
              if (!je)
                Le && (Le.mergeOption({}, this), Le.optionUpdated({}, false));
              else {
                var Xe = R === "series", Ye = oc.getClass(R, pe.keyInfo.subType, !Xe);
                if (!Ye)
                  return;
                if (R === "tooltip") {
                  if (_e)
                    return;
                  _e = true;
                }
                if (Le && Le.constructor === Ye)
                  Le.name = pe.keyInfo.name, Le.mergeOption(je, this), Le.optionUpdated(je, false);
                else {
                  var rt2 = ei({ componentIndex: Ve }, pe.keyInfo);
                  Le = new Ye(je, this, this, rt2), ei(Le, rt2), pe.brandNew && (Le.__requireNewView = true), Le.init(je, this, this), Le.optionUpdated(null, true);
                }
              }
              Le ? (ee.push(Le.option), oe.push(Le), fe++) : (ee.push(void 0), oe.push(void 0));
            }, this), d4[R] = ee, y4.set(R, oe), _.set(R, fe), R === "series" && Pae(this);
          }
          this._seriesIndices || Pae(this);
        }, a.prototype.getOption = function() {
          var n6 = Bo(this.option);
          return gt(n6, function(f6, d4) {
            if (oc.hasClass(d4)) {
              for (var y4 = jc(f6), _ = y4.length, S = false, T = _ - 1; T >= 0; T--)
                y4[T] && !vR(y4[T]) ? S = true : (y4[T] = null, !S && _--);
              y4.length = _, n6[d4] = y4;
            }
          }), delete n6[Yje], n6;
        }, a.prototype.getTheme = function() {
          return this._theme;
        }, a.prototype.getLocaleModel = function() {
          return this._locale;
        }, a.prototype.setUpdatePayload = function(n6) {
          this._payload = n6;
        }, a.prototype.getUpdatePayload = function() {
          return this._payload;
        }, a.prototype.getComponent = function(n6, f6) {
          var d4 = this._componentsMap.get(n6);
          if (d4) {
            var y4 = d4[f6 || 0];
            if (y4)
              return y4;
            if (f6 == null) {
              for (var _ = 0; _ < d4.length; _++)
                if (d4[_])
                  return d4[_];
            }
          }
        }, a.prototype.queryComponents = function(n6) {
          var f6 = n6.mainType;
          if (!f6)
            return [];
          var d4 = n6.index, y4 = n6.id, _ = n6.name, S = this._componentsMap.get(f6);
          if (!S || !S.length)
            return [];
          var T;
          return d4 != null ? (T = [], gt(jc(d4), function(E) {
            S[E] && T.push(S[E]);
          })) : y4 != null ? T = Zje("id", y4, S) : _ != null ? T = Zje("name", _, S) : T = tf(S, function(E) {
            return !!E;
          }), Jje(T, n6);
        }, a.prototype.findComponents = function(n6) {
          var f6 = n6.query, d4 = n6.mainType, y4 = S(f6), _ = y4 ? this.queryComponents(y4) : tf(this._componentsMap.get(d4), function(E) {
            return !!E;
          });
          return T(Jje(_, n6));
          function S(E) {
            var O = d4 + "Index", R = d4 + "Id", V = d4 + "Name";
            return E && (E[O] != null || E[R] != null || E[V] != null) ? { mainType: d4, index: E[O], id: E[R], name: E[V] } : null;
          }
          function T(E) {
            return n6.filter ? tf(E, n6.filter) : E;
          }
        }, a.prototype.eachComponent = function(n6, f6, d4) {
          var y4 = this._componentsMap;
          if (jo(n6)) {
            var _ = f6, S = n6;
            y4.each(function(R, V) {
              for (var z3 = 0; R && z3 < R.length; z3++) {
                var H = R[z3];
                H && S.call(_, V, H, H.componentIndex);
              }
            });
          } else
            for (var T = Wa(n6) ? y4.get(n6) : Qo(n6) ? this.findComponents(n6) : null, E = 0; T && E < T.length; E++) {
              var O = T[E];
              O && f6.call(d4, O, O.componentIndex);
            }
        }, a.prototype.getSeriesByName = function(n6) {
          var f6 = Cd(n6, null);
          return tf(this._componentsMap.get("series"), function(d4) {
            return !!d4 && f6 != null && d4.name === f6;
          });
        }, a.prototype.getSeriesByIndex = function(n6) {
          return this._componentsMap.get("series")[n6];
        }, a.prototype.getSeriesByType = function(n6) {
          return tf(this._componentsMap.get("series"), function(f6) {
            return !!f6 && f6.subType === n6;
          });
        }, a.prototype.getSeries = function() {
          return tf(this._componentsMap.get("series"), function(n6) {
            return !!n6;
          });
        }, a.prototype.getSeriesCount = function() {
          return this._componentsCount.get("series");
        }, a.prototype.eachSeries = function(n6, f6) {
          c$(this), gt(this._seriesIndices, function(d4) {
            var y4 = this._componentsMap.get("series")[d4];
            n6.call(f6, y4, d4);
          }, this);
        }, a.prototype.eachRawSeries = function(n6, f6) {
          gt(this._componentsMap.get("series"), function(d4) {
            d4 && n6.call(f6, d4, d4.componentIndex);
          });
        }, a.prototype.eachSeriesByType = function(n6, f6, d4) {
          c$(this), gt(this._seriesIndices, function(y4) {
            var _ = this._componentsMap.get("series")[y4];
            _.subType === n6 && f6.call(d4, _, y4);
          }, this);
        }, a.prototype.eachRawSeriesByType = function(n6, f6, d4) {
          return gt(this.getSeriesByType(n6), f6, d4);
        }, a.prototype.isSeriesFiltered = function(n6) {
          return c$(this), this._seriesIndicesMap.get(n6.componentIndex) == null;
        }, a.prototype.getCurrentSeriesIndices = function() {
          return (this._seriesIndices || []).slice();
        }, a.prototype.filterSeries = function(n6, f6) {
          c$(this);
          var d4 = [];
          gt(this._seriesIndices, function(y4) {
            var _ = this._componentsMap.get("series")[y4];
            n6.call(f6, _, y4) && d4.push(y4);
          }, this), this._seriesIndices = d4, this._seriesIndicesMap = ro(d4);
        }, a.prototype.restoreData = function(n6) {
          Pae(this);
          var f6 = this._componentsMap, d4 = [];
          f6.each(function(y4, _) {
            oc.hasClass(_) && d4.push(_);
          }), oc.topologicalTravel(d4, oc.getAllClassMainTypes(), function(y4) {
            gt(f6.get(y4), function(_) {
              _ && (y4 !== "series" || !p4t(_, n6)) && _.restoreData();
            });
          });
        }, a.internalField = function() {
          Pae = function(n6) {
            var f6 = n6._seriesIndices = [];
            gt(n6._componentsMap.get("series"), function(d4) {
              d4 && f6.push(d4.componentIndex);
            }), n6._seriesIndicesMap = ro(f6);
          }, c$ = function(n6) {
          }, Xje = function(n6, f6) {
            n6.option = {}, n6.option[Yje] = h4t, n6._componentsMap = ro({ series: [] }), n6._componentsCount = ro();
            var d4 = f6.aria;
            Qo(d4) && d4.enabled == null && (d4.enabled = true), d4t(f6, n6._theme.option), Ms(f6, i4t, false), n6._mergeOption(f6, null);
          };
        }(), a;
      }(Sh);
      function p4t(s, a) {
        if (a) {
          var n6 = a.seriesIndex, f6 = a.seriesId, d4 = a.seriesName;
          return n6 != null && s.componentIndex !== n6 || f6 != null && s.id !== f6 || d4 != null && s.name !== d4;
        }
      }
      function d4t(s, a) {
        var n6 = s.color && !s.colorLayer;
        gt(a, function(f6, d4) {
          d4 === "colorLayer" && n6 || oc.hasClass(d4) || (typeof f6 == "object" ? s[d4] = s[d4] ? Ms(s[d4], f6, false) : Bo(f6) : s[d4] == null && (s[d4] = f6));
        });
      }
      function Zje(s, a, n6) {
        if (Di(a)) {
          var f6 = ro();
          return gt(a, function(y4) {
            if (y4 != null) {
              var _ = Cd(y4, null);
              _ != null && f6.set(y4, true);
            }
          }), tf(n6, function(y4) {
            return y4 && f6.get(y4[s]);
          });
        } else {
          var d4 = Cd(a, null);
          return tf(n6, function(y4) {
            return y4 && d4 != null && y4[s] === d4;
          });
        }
      }
      function Jje(s, a) {
        return a.hasOwnProperty("subType") ? tf(s, function(n6) {
          return n6 && n6.subType === a.subType;
        }) : s;
      }
      function Qje(s) {
        var a = ro();
        return s && gt(jc(s.replaceMerge), function(n6) {
          a.set(n6, true);
        }), { replaceMergeMainTypeMap: a };
      }
      nd(Kje, Fxe);
      var eGe = Kje, v4t = ["getDom", "getZr", "getWidth", "getHeight", "getDevicePixelRatio", "dispatchAction", "isSSR", "isDisposed", "on", "off", "getDataURL", "getConnectedDataURL", "getOption", "getId", "updateLabelLayout"], g4t = function() {
        function s(a) {
          gt(v4t, function(n6) {
            this[n6] = Za(a[n6], a);
          }, this);
        }
        return s;
      }(), tGe = g4t, Bxe = {}, y4t = function() {
        function s() {
          this._coordinateSystems = [];
        }
        return s.prototype.create = function(a, n6) {
          var f6 = [];
          gt(Bxe, function(d4, y4) {
            var _ = d4.create(a, n6);
            f6 = f6.concat(_ || []);
          }), this._coordinateSystems = f6;
        }, s.prototype.update = function(a, n6) {
          gt(this._coordinateSystems, function(f6) {
            f6.update && f6.update(a, n6);
          });
        }, s.prototype.getCoordinateSystems = function() {
          return this._coordinateSystems.slice();
        }, s.register = function(a, n6) {
          Bxe[a] = n6;
        }, s.get = function(a) {
          return Bxe[a];
        }, s;
      }(), f$ = y4t, m4t = /^(min|max)?(.+)$/, b4t = function() {
        function s(a) {
          this._timelineOptions = [], this._mediaList = [], this._currentMediaIndices = [], this._api = a;
        }
        return s.prototype.setOption = function(a, n6, f6) {
          a && (gt(jc(a.series), function(_) {
            _ && _.data && j1(_.data) && $w(_.data);
          }), gt(jc(a.dataset), function(_) {
            _ && _.source && j1(_.source) && $w(_.source);
          })), a = Bo(a);
          var d4 = this._optionBackup, y4 = _4t(a, n6, !d4);
          this._newBaseOption = y4.baseOption, d4 ? (y4.timelineOptions.length && (d4.timelineOptions = y4.timelineOptions), y4.mediaList.length && (d4.mediaList = y4.mediaList), y4.mediaDefault && (d4.mediaDefault = y4.mediaDefault)) : this._optionBackup = y4;
        }, s.prototype.mountOption = function(a) {
          var n6 = this._optionBackup;
          return this._timelineOptions = n6.timelineOptions, this._mediaList = n6.mediaList, this._mediaDefault = n6.mediaDefault, this._currentMediaIndices = [], Bo(a ? n6.baseOption : this._newBaseOption);
        }, s.prototype.getTimelineOption = function(a) {
          var n6, f6 = this._timelineOptions;
          if (f6.length) {
            var d4 = a.getComponent("timeline");
            d4 && (n6 = Bo(f6[d4.getCurrentIndex()]));
          }
          return n6;
        }, s.prototype.getMediaOption = function(a) {
          var n6 = this._api.getWidth(), f6 = this._api.getHeight(), d4 = this._mediaList, y4 = this._mediaDefault, _ = [], S = [];
          if (!d4.length && !y4)
            return S;
          for (var T = 0, E = d4.length; T < E; T++)
            x4t(d4[T].query, n6, f6) && _.push(T);
          return !_.length && y4 && (_ = [-1]), _.length && !S4t(_, this._currentMediaIndices) && (S = Pi(_, function(O) {
            return Bo(O === -1 ? y4.option : d4[O].option);
          })), this._currentMediaIndices = _, S;
        }, s;
      }();
      function _4t(s, a, n6) {
        var f6 = [], d4, y4, _ = s.baseOption, S = s.timeline, T = s.options, E = s.media, O = !!s.media, R = !!(T || S || _ && _.timeline);
        _ ? (y4 = _, y4.timeline || (y4.timeline = S)) : ((R || O) && (s.options = s.media = null), y4 = s), O && Di(E) && gt(E, function(z3) {
          z3 && z3.option && (z3.query ? f6.push(z3) : d4 || (d4 = z3));
        }), V(y4), gt(T, function(z3) {
          return V(z3);
        }), gt(f6, function(z3) {
          return V(z3.option);
        });
        function V(z3) {
          gt(a, function(H) {
            H(z3, n6);
          });
        }
        return { baseOption: y4, timelineOptions: T || [], mediaDefault: d4, mediaList: f6 };
      }
      function x4t(s, a, n6) {
        var f6 = { width: a, height: n6, aspectratio: a / n6 }, d4 = true;
        return gt(s, function(y4, _) {
          var S = _.match(m4t);
          if (!(!S || !S[1] || !S[2])) {
            var T = S[1], E = S[2].toLowerCase();
            w4t(f6[E], y4, T) || (d4 = false);
          }
        }), d4;
      }
      function w4t(s, a, n6) {
        return n6 === "min" ? s >= a : n6 === "max" ? s <= a : s === a;
      }
      function S4t(s, a) {
        return s.join(",") === a.join(",");
      }
      var C4t = b4t, bC = gt, h$ = Qo, nGe = ["areaStyle", "lineStyle", "nodeStyle", "linkStyle", "chordStyle", "label", "labelLine"];
      function zxe(s) {
        var a = s && s.itemStyle;
        if (a)
          for (var n6 = 0, f6 = nGe.length; n6 < f6; n6++) {
            var d4 = nGe[n6], y4 = a.normal, _ = a.emphasis;
            y4 && y4[d4] && (s[d4] = s[d4] || {}, s[d4].normal ? Ms(s[d4].normal, y4[d4]) : s[d4].normal = y4[d4], y4[d4] = null), _ && _[d4] && (s[d4] = s[d4] || {}, s[d4].emphasis ? Ms(s[d4].emphasis, _[d4]) : s[d4].emphasis = _[d4], _[d4] = null);
          }
      }
      function Wm(s, a, n6) {
        if (s && s[a] && (s[a].normal || s[a].emphasis)) {
          var f6 = s[a].normal, d4 = s[a].emphasis;
          f6 && (n6 ? (s[a].normal = s[a].emphasis = null, zo(s[a], f6)) : s[a] = f6), d4 && (s.emphasis = s.emphasis || {}, s.emphasis[a] = d4, d4.focus && (s.emphasis.focus = d4.focus), d4.blurScope && (s.emphasis.blurScope = d4.blurScope));
        }
      }
      function p$(s) {
        Wm(s, "itemStyle"), Wm(s, "lineStyle"), Wm(s, "areaStyle"), Wm(s, "label"), Wm(s, "labelLine"), Wm(s, "upperLabel"), Wm(s, "edgeLabel");
      }
      function mv(s, a) {
        var n6 = h$(s) && s[a], f6 = h$(n6) && n6.textStyle;
        if (f6)
          for (var d4 = 0, y4 = Js.length; d4 < y4; d4++) {
            var _ = Js[d4];
            f6.hasOwnProperty(_) && (n6[_] = f6[_]);
          }
      }
      function gS(s) {
        s && (p$(s), mv(s, "label"), s.emphasis && mv(s.emphasis, "label"));
      }
      function M4t(s) {
        if (h$(s)) {
          zxe(s), p$(s), mv(s, "label"), mv(s, "upperLabel"), mv(s, "edgeLabel"), s.emphasis && (mv(s.emphasis, "label"), mv(s.emphasis, "upperLabel"), mv(s.emphasis, "edgeLabel"));
          var a = s.markPoint;
          a && (zxe(a), gS(a));
          var n6 = s.markLine;
          n6 && (zxe(n6), gS(n6));
          var f6 = s.markArea;
          f6 && gS(f6);
          var d4 = s.data;
          if (s.type === "graph") {
            d4 = d4 || s.nodes;
            var y4 = s.links || s.edges;
            if (y4 && !j1(y4))
              for (var _ = 0; _ < y4.length; _++)
                gS(y4[_]);
            gt(s.categories, function(E) {
              p$(E);
            });
          }
          if (d4 && !j1(d4))
            for (var _ = 0; _ < d4.length; _++)
              gS(d4[_]);
          if (a = s.markPoint, a && a.data)
            for (var S = a.data, _ = 0; _ < S.length; _++)
              gS(S[_]);
          if (n6 = s.markLine, n6 && n6.data)
            for (var T = n6.data, _ = 0; _ < T.length; _++)
              Di(T[_]) ? (gS(T[_][0]), gS(T[_][1])) : gS(T[_]);
          s.type === "gauge" ? (mv(s, "axisLabel"), mv(s, "title"), mv(s, "detail")) : s.type === "treemap" ? (Wm(s.breadcrumb, "itemStyle"), gt(s.levels, function(E) {
            p$(E);
          })) : s.type === "tree" && p$(s.leaves);
        }
      }
      function kE(s) {
        return Di(s) ? s : s ? [s] : [];
      }
      function rGe(s) {
        return (Di(s) ? s[0] : s) || {};
      }
      function T4t(s, a) {
        bC(kE(s.series), function(f6) {
          h$(f6) && M4t(f6);
        });
        var n6 = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "parallelAxis", "radar"];
        a && n6.push("valueAxis", "categoryAxis", "logAxis", "timeAxis"), bC(n6, function(f6) {
          bC(kE(s[f6]), function(d4) {
            d4 && (mv(d4, "axisLabel"), mv(d4.axisPointer, "label"));
          });
        }), bC(kE(s.parallel), function(f6) {
          var d4 = f6 && f6.parallelAxisDefault;
          mv(d4, "axisLabel"), mv(d4 && d4.axisPointer, "label");
        }), bC(kE(s.calendar), function(f6) {
          Wm(f6, "itemStyle"), mv(f6, "dayLabel"), mv(f6, "monthLabel"), mv(f6, "yearLabel");
        }), bC(kE(s.radar), function(f6) {
          mv(f6, "name"), f6.name && f6.axisName == null && (f6.axisName = f6.name, delete f6.name), f6.nameGap != null && f6.axisNameGap == null && (f6.axisNameGap = f6.nameGap, delete f6.nameGap);
        }), bC(kE(s.geo), function(f6) {
          h$(f6) && (gS(f6), bC(kE(f6.regions), function(d4) {
            gS(d4);
          }));
        }), bC(kE(s.timeline), function(f6) {
          gS(f6), Wm(f6, "label"), Wm(f6, "itemStyle"), Wm(f6, "controlStyle", true);
          var d4 = f6.data;
          Di(d4) && gt(d4, function(y4) {
            Qo(y4) && (Wm(y4, "label"), Wm(y4, "itemStyle"));
          });
        }), bC(kE(s.toolbox), function(f6) {
          Wm(f6, "iconStyle"), bC(f6.feature, function(d4) {
            Wm(d4, "iconStyle");
          });
        }), mv(rGe(s.axisPointer), "label"), mv(rGe(s.tooltip).axisPointer, "label");
      }
      function A4t(s, a) {
        for (var n6 = a.split(","), f6 = s, d4 = 0; d4 < n6.length && (f6 = f6 && f6[n6[d4]], f6 != null); d4++)
          ;
        return f6;
      }
      function I4t(s, a, n6, f6) {
        for (var d4 = a.split(","), y4 = s, _, S = 0; S < d4.length - 1; S++)
          _ = d4[S], y4[_] == null && (y4[_] = {}), y4 = y4[_];
        (f6 || y4[d4[S]] == null) && (y4[d4[S]] = n6);
      }
      function iGe(s) {
        s && gt(E4t, function(a) {
          a[0] in s && !(a[1] in s) && (s[a[1]] = s[a[0]]);
        });
      }
      var E4t = [["x", "left"], ["y", "top"], ["x2", "right"], ["y2", "bottom"]], D4t = ["grid", "geo", "parallel", "legend", "toolbox", "title", "visualMap", "dataZoom", "timeline"], jxe = [["borderRadius", "barBorderRadius"], ["borderColor", "barBorderColor"], ["borderWidth", "barBorderWidth"]];
      function d$(s) {
        var a = s && s.itemStyle;
        if (a)
          for (var n6 = 0; n6 < jxe.length; n6++) {
            var f6 = jxe[n6][1], d4 = jxe[n6][0];
            a[f6] != null && (a[d4] = a[f6]);
          }
      }
      function aGe(s) {
        !s || s.alignTo === "edge" && s.margin != null && s.edgeDistance == null && (s.edgeDistance = s.margin);
      }
      function oGe(s) {
        !s || s.downplay && !s.blur && (s.blur = s.downplay);
      }
      function k4t(s) {
        !s || s.focusNodeAdjacency != null && (s.emphasis = s.emphasis || {}, s.emphasis.focus == null && (s.emphasis.focus = "adjacency"));
      }
      function sGe(s, a) {
        if (s)
          for (var n6 = 0; n6 < s.length; n6++)
            a(s[n6]), s[n6] && sGe(s[n6].children, a);
      }
      function lGe(s, a) {
        T4t(s, a), s.series = jc(s.series), gt(s.series, function(n6) {
          if (Qo(n6)) {
            var f6 = n6.type;
            if (f6 === "line")
              n6.clipOverflow != null && (n6.clip = n6.clipOverflow);
            else if (f6 === "pie" || f6 === "gauge") {
              n6.clockWise != null && (n6.clockwise = n6.clockWise), aGe(n6.label);
              var d4 = n6.data;
              if (d4 && !j1(d4))
                for (var y4 = 0; y4 < d4.length; y4++)
                  aGe(d4[y4]);
              n6.hoverOffset != null && (n6.emphasis = n6.emphasis || {}, (n6.emphasis.scaleSize = null) && (n6.emphasis.scaleSize = n6.hoverOffset));
            } else if (f6 === "gauge") {
              var _ = A4t(n6, "pointer.color");
              _ != null && I4t(n6, "itemStyle.color", _);
            } else if (f6 === "bar") {
              d$(n6), d$(n6.backgroundStyle), d$(n6.emphasis);
              var d4 = n6.data;
              if (d4 && !j1(d4))
                for (var y4 = 0; y4 < d4.length; y4++)
                  typeof d4[y4] == "object" && (d$(d4[y4]), d$(d4[y4] && d4[y4].emphasis));
            } else if (f6 === "sunburst") {
              var S = n6.highlightPolicy;
              S && (n6.emphasis = n6.emphasis || {}, n6.emphasis.focus || (n6.emphasis.focus = S)), oGe(n6), sGe(n6.data, oGe);
            } else
              f6 === "graph" || f6 === "sankey" ? k4t(n6) : f6 === "map" && (n6.mapType && !n6.map && (n6.map = n6.mapType), n6.mapLocation && zo(n6, n6.mapLocation));
            n6.hoverAnimation != null && (n6.emphasis = n6.emphasis || {}, n6.emphasis && n6.emphasis.scale == null && (n6.emphasis.scale = n6.hoverAnimation)), iGe(n6);
          }
        }), s.dataRange && (s.visualMap = s.dataRange), gt(D4t, function(n6) {
          var f6 = s[n6];
          f6 && (Di(f6) || (f6 = [f6]), gt(f6, function(d4) {
            iGe(d4);
          }));
        });
      }
      function O4t(s) {
        var a = ro();
        s.eachSeries(function(n6) {
          var f6 = n6.get("stack");
          if (f6) {
            var d4 = a.get(f6) || a.set(f6, []), y4 = n6.getData(), _ = { stackResultDimension: y4.getCalculationInfo("stackResultDimension"), stackedOverDimension: y4.getCalculationInfo("stackedOverDimension"), stackedDimension: y4.getCalculationInfo("stackedDimension"), stackedByDimension: y4.getCalculationInfo("stackedByDimension"), isStackedByIndex: y4.getCalculationInfo("isStackedByIndex"), data: y4, seriesModel: n6 };
            if (!_.stackedDimension || !(_.isStackedByIndex || _.stackedByDimension))
              return;
            d4.length && y4.setCalculationInfo("stackedOnSeries", d4[d4.length - 1].seriesModel), d4.push(_);
          }
        }), a.each(P4t);
      }
      function P4t(s) {
        gt(s, function(a, n6) {
          var f6 = [], d4 = [NaN, NaN], y4 = [a.stackResultDimension, a.stackedOverDimension], _ = a.data, S = a.isStackedByIndex;
          _.modify(y4, function(T, E, O) {
            var R = _.get(a.stackedDimension, O);
            if (isNaN(R))
              return d4;
            var V, z3;
            S ? z3 = _.getRawIndex(O) : V = _.get(a.stackedByDimension, O);
            for (var H = NaN, Z = n6 - 1; Z >= 0; Z--) {
              var ee = s[Z];
              if (S || (z3 = ee.data.rawIndexOf(ee.stackedByDimension, V)), z3 >= 0) {
                var oe = ee.data.getByRawIndex(ee.stackResultDimension, z3);
                if (R >= 0 && oe > 0 || R <= 0 && oe < 0) {
                  R = $U(R, oe), H = oe;
                  break;
                }
              }
            }
            return f6[0] = R, f6[1] = H, f6;
          });
        });
      }
      var Lae = function() {
        function s(a) {
          this.data = a.data || (a.sourceFormat === OT ? {} : []), this.sourceFormat = a.sourceFormat || jje, this.seriesLayoutBy = a.seriesLayoutBy || PT, this.startIndex = a.startIndex || 0, this.dimensionsDetectedCount = a.dimensionsDetectedCount, this.metaRawOption = a.metaRawOption;
          var n6 = this.dimensionsDefine = a.dimensionsDefine;
          if (n6)
            for (var f6 = 0; f6 < n6.length; f6++) {
              var d4 = n6[f6];
              d4.type == null && Wje(this, f6) === By.Must && (d4.type = "ordinal");
            }
        }
        return s;
      }();
      function Gxe(s) {
        return s instanceof Lae;
      }
      function Hxe(s, a, n6) {
        n6 = n6 || uGe(s);
        var f6 = a.seriesLayoutBy, d4 = R4t(s, n6, f6, a.sourceHeader, a.dimensions), y4 = new Lae({ data: s, sourceFormat: n6, seriesLayoutBy: f6, dimensionsDefine: d4.dimensionsDefine, startIndex: d4.startIndex, dimensionsDetectedCount: d4.dimensionsDetectedCount, metaRawOption: Bo(a) });
        return y4;
      }
      function Wxe(s) {
        return new Lae({ data: s, sourceFormat: j1(s) ? Kk : dS });
      }
      function L4t(s) {
        return new Lae({ data: s.data, sourceFormat: s.sourceFormat, seriesLayoutBy: s.seriesLayoutBy, dimensionsDefine: Bo(s.dimensionsDefine), startIndex: s.startIndex, dimensionsDetectedCount: s.dimensionsDetectedCount });
      }
      function uGe(s) {
        var a = jje;
        if (j1(s))
          a = Kk;
        else if (Di(s)) {
          s.length === 0 && (a = Hm);
          for (var n6 = 0, f6 = s.length; n6 < f6; n6++) {
            var d4 = s[n6];
            if (d4 != null) {
              if (Di(d4)) {
                a = Hm;
                break;
              } else if (Qo(d4)) {
                a = vS;
                break;
              }
            }
          }
        } else if (Qo(s)) {
          for (var y4 in s)
            if (io(s, y4) && _0(s[y4])) {
              a = OT;
              break;
            }
        }
        return a;
      }
      function R4t(s, a, n6, f6, d4) {
        var y4, _;
        if (!s)
          return { dimensionsDefine: cGe(d4), startIndex: _, dimensionsDetectedCount: y4 };
        if (a === Hm) {
          var S = s;
          f6 === "auto" || f6 == null ? fGe(function(E) {
            E != null && E !== "-" && (Wa(E) ? _ == null && (_ = 1) : _ = 0);
          }, n6, S, 10) : _ = ac(f6) ? f6 : f6 ? 1 : 0, !d4 && _ === 1 && (d4 = [], fGe(function(E, O) {
            d4[O] = E != null ? E + "" : "";
          }, n6, S, 1 / 0)), y4 = d4 ? d4.length : n6 === O7 ? S.length : S[0] ? S[0].length : null;
        } else if (a === vS)
          d4 || (d4 = N4t(s));
        else if (a === OT)
          d4 || (d4 = [], gt(s, function(E, O) {
            d4.push(O);
          }));
        else if (a === dS) {
          var T = pC(s[0]);
          y4 = Di(T) && T.length || 1;
        }
        return { startIndex: _, dimensionsDefine: cGe(d4), dimensionsDetectedCount: y4 };
      }
      function N4t(s) {
        for (var a = 0, n6; a < s.length && !(n6 = s[a++]); )
          ;
        if (n6) {
          var f6 = [];
          return gt(n6, function(d4, y4) {
            f6.push(y4);
          }), f6;
        }
      }
      function cGe(s) {
        if (s) {
          var a = ro();
          return Pi(s, function(n6, f6) {
            n6 = Qo(n6) ? n6 : { name: n6 };
            var d4 = { name: n6.name, displayName: n6.displayName, type: n6.type };
            if (d4.name == null)
              return d4;
            d4.name += "", d4.displayName == null && (d4.displayName = d4.name);
            var y4 = a.get(d4.name);
            return y4 ? d4.name += "-" + y4.count++ : a.set(d4.name, { count: 1 }), d4;
          });
        }
      }
      function fGe(s, a, n6, f6) {
        if (a === O7)
          for (var d4 = 0; d4 < n6.length && d4 < f6; d4++)
            s(n6[d4] ? n6[d4][0] : null, d4);
        else
          for (var y4 = n6[0] || [], d4 = 0; d4 < y4.length && d4 < f6; d4++)
            s(y4[d4], d4);
      }
      function hGe(s) {
        var a = s.sourceFormat;
        return a === vS || a === OT;
      }
      var FR, VR, BR, pGe, dGe, vGe = function() {
        function s(a, n6) {
          var f6 = Gxe(a) ? a : Wxe(a);
          this._source = f6;
          var d4 = this._data = f6.data;
          f6.sourceFormat === Kk && (this._offset = 0, this._dimSize = n6, this._data = d4), dGe(this, d4, f6);
        }
        return s.prototype.getSource = function() {
          return this._source;
        }, s.prototype.count = function() {
          return 0;
        }, s.prototype.getItem = function(a, n6) {
        }, s.prototype.appendData = function(a) {
        }, s.prototype.clean = function() {
        }, s.protoInitialize = function() {
          var a = s.prototype;
          a.pure = false, a.persistent = true;
        }(), s.internalField = function() {
          var a;
          dGe = function(_, S, T) {
            var E = T.sourceFormat, O = T.seriesLayoutBy, R = T.startIndex, V = T.dimensionsDefine, z3 = pGe[qxe(E, O)];
            if (ei(_, z3), E === Kk)
              _.getItem = n6, _.count = d4, _.fillStorage = f6;
            else {
              var H = yGe(E, O);
              _.getItem = Za(H, null, S, R, V);
              var Z = bGe(E, O);
              _.count = Za(Z, null, S, R, V);
            }
          };
          var n6 = function(_, S) {
            _ = _ - this._offset, S = S || [];
            for (var T = this._data, E = this._dimSize, O = E * _, R = 0; R < E; R++)
              S[R] = T[O + R];
            return S;
          }, f6 = function(_, S, T, E) {
            for (var O = this._data, R = this._dimSize, V = 0; V < R; V++) {
              for (var z3 = E[V], H = z3[0] == null ? 1 / 0 : z3[0], Z = z3[1] == null ? -1 / 0 : z3[1], ee = S - _, oe = T[V], fe = 0; fe < ee; fe++) {
                var _e = O[fe * R + V];
                oe[_ + fe] = _e, _e < H && (H = _e), _e > Z && (Z = _e);
              }
              z3[0] = H, z3[1] = Z;
            }
          }, d4 = function() {
            return this._data ? this._data.length / this._dimSize : 0;
          };
          pGe = (a = {}, a[Hm + "_" + PT] = { pure: true, appendData: y4 }, a[Hm + "_" + O7] = { pure: true, appendData: function() {
            throw new Error('Do not support appendData when set seriesLayoutBy: "row".');
          } }, a[vS] = { pure: true, appendData: y4 }, a[OT] = { pure: true, appendData: function(_) {
            var S = this._data;
            gt(_, function(T, E) {
              for (var O = S[E] || (S[E] = []), R = 0; R < (T || []).length; R++)
                O.push(T[R]);
            });
          } }, a[dS] = { appendData: y4 }, a[Kk] = { persistent: false, pure: true, appendData: function(_) {
            this._data = _;
          }, clean: function() {
            this._offset += this.count(), this._data = null;
          } }, a);
          function y4(_) {
            for (var S = 0; S < _.length; S++)
              this._data.push(_[S]);
          }
        }(), s;
      }(), gGe = function(s, a, n6, f6) {
        return s[f6];
      }, F4t = (FR = {}, FR[Hm + "_" + PT] = function(s, a, n6, f6) {
        return s[f6 + a];
      }, FR[Hm + "_" + O7] = function(s, a, n6, f6, d4) {
        f6 += a;
        for (var y4 = d4 || [], _ = s, S = 0; S < _.length; S++) {
          var T = _[S];
          y4[S] = T ? T[f6] : null;
        }
        return y4;
      }, FR[vS] = gGe, FR[OT] = function(s, a, n6, f6, d4) {
        for (var y4 = d4 || [], _ = 0; _ < n6.length; _++) {
          var S = n6[_].name, T = s[S];
          y4[_] = T ? T[f6] : null;
        }
        return y4;
      }, FR[dS] = gGe, FR);
      function yGe(s, a) {
        var n6 = F4t[qxe(s, a)];
        return n6;
      }
      var mGe = function(s, a, n6) {
        return s.length;
      }, V4t = (VR = {}, VR[Hm + "_" + PT] = function(s, a, n6) {
        return Math.max(0, s.length - a);
      }, VR[Hm + "_" + O7] = function(s, a, n6) {
        var f6 = s[0];
        return f6 ? Math.max(0, f6.length - a) : 0;
      }, VR[vS] = mGe, VR[OT] = function(s, a, n6) {
        var f6 = n6[0].name, d4 = s[f6];
        return d4 ? d4.length : 0;
      }, VR[dS] = mGe, VR);
      function bGe(s, a) {
        var n6 = V4t[qxe(s, a)];
        return n6;
      }
      var Uxe = function(s, a, n6) {
        return s[a];
      }, B4t = (BR = {}, BR[Hm] = Uxe, BR[vS] = function(s, a, n6) {
        return s[n6];
      }, BR[OT] = Uxe, BR[dS] = function(s, a, n6) {
        var f6 = pC(s);
        return f6 instanceof Array ? f6[a] : f6;
      }, BR[Kk] = Uxe, BR);
      function _Ge(s) {
        var a = B4t[s];
        return a;
      }
      function qxe(s, a) {
        return s === Hm ? s + "_" + a : s;
      }
      function P7(s, a, n6) {
        if (s) {
          var f6 = s.getRawDataItem(a);
          if (f6 != null) {
            var d4 = s.getStore(), y4 = d4.getSource().sourceFormat;
            if (n6 != null) {
              var _ = s.getDimensionIndex(n6), S = d4.getDimensionProperty(_);
              return _Ge(y4)(f6, _, S);
            } else {
              var T = f6;
              return y4 === dS && (T = pC(f6)), T;
            }
          }
        }
      }
      var z4t = /\{@(.+?)\}/g, $xe = function() {
        function s() {
        }
        return s.prototype.getDataParams = function(a, n6) {
          var f6 = this.getData(n6), d4 = this.getRawValue(a, n6), y4 = f6.getRawIndex(a), _ = f6.getName(a), S = f6.getRawDataItem(a), T = f6.getItemVisual(a, "style"), E = T && T[f6.getItemVisual(a, "drawType") || "fill"], O = T && T.stroke, R = this.mainType, V = R === "series", z3 = f6.userOutput && f6.userOutput.get();
          return { componentType: R, componentSubType: this.subType, componentIndex: this.componentIndex, seriesType: V ? this.subType : null, seriesIndex: this.seriesIndex, seriesId: V ? this.id : null, seriesName: V ? this.name : null, name: _, dataIndex: y4, data: S, dataType: n6, value: d4, color: E, borderColor: O, dimensionNames: z3 ? z3.fullDimensions : null, encode: z3 ? z3.encode : null, $vars: ["seriesName", "name", "value"] };
        }, s.prototype.getFormattedLabel = function(a, n6, f6, d4, y4, _) {
          n6 = n6 || "normal";
          var S = this.getData(f6), T = this.getDataParams(a, f6);
          if (_ && (T.value = _.interpolatedValue), d4 != null && Di(T.value) && (T.value = T.value[d4]), !y4) {
            var E = S.getItemModel(a);
            y4 = E.get(n6 === "normal" ? ["label", "formatter"] : [n6, "label", "formatter"]);
          }
          if (jo(y4))
            return T.status = n6, T.dimensionIndex = d4, y4(T);
          if (Wa(y4)) {
            var O = Nje(y4, T);
            return O.replace(z4t, function(R, V) {
              var z3 = V.length, H = V;
              H.charAt(0) === "[" && H.charAt(z3 - 1) === "]" && (H = +H.slice(1, z3 - 1));
              var Z = P7(S, a, H);
              if (_ && Di(_.interpolatedValue)) {
                var ee = S.getDimensionIndex(H);
                ee >= 0 && (Z = _.interpolatedValue[ee]);
              }
              return Z != null ? Z + "" : "";
            });
          }
        }, s.prototype.getRawValue = function(a, n6) {
          return P7(this.getData(n6), a);
        }, s.prototype.formatTooltip = function(a, n6, f6) {
        }, s;
      }();
      function xGe(s) {
        var a, n6;
        return Qo(s) ? s.type && (n6 = s) : a = s, { text: a, frag: n6 };
      }
      function v$(s) {
        return new j4t(s);
      }
      var j4t = function() {
        function s(a) {
          a = a || {}, this._reset = a.reset, this._plan = a.plan, this._count = a.count, this._onDirty = a.onDirty, this._dirty = true;
        }
        return s.prototype.perform = function(a) {
          var n6 = this._upstream, f6 = a && a.skip;
          if (this._dirty && n6) {
            var d4 = this.context;
            d4.data = d4.outputData = n6.context.outputData;
          }
          this.__pipeline && (this.__pipeline.currentTask = this);
          var y4;
          this._plan && !f6 && (y4 = this._plan(this.context));
          var _ = O(this._modBy), S = this._modDataCount || 0, T = O(a && a.modBy), E = a && a.modDataCount || 0;
          (_ !== T || S !== E) && (y4 = "reset");
          function O(fe) {
            return !(fe >= 1) && (fe = 1), fe;
          }
          var R;
          (this._dirty || y4 === "reset") && (this._dirty = false, R = this._doReset(f6)), this._modBy = T, this._modDataCount = E;
          var V = a && a.step;
          if (n6 ? this._dueEnd = n6._outputDueEnd : this._dueEnd = this._count ? this._count(this.context) : 1 / 0, this._progress) {
            var z3 = this._dueIndex, H = Math.min(V != null ? this._dueIndex + V : 1 / 0, this._dueEnd);
            if (!f6 && (R || z3 < H)) {
              var Z = this._progress;
              if (Di(Z))
                for (var ee = 0; ee < Z.length; ee++)
                  this._doProgress(Z[ee], z3, H, T, E);
              else
                this._doProgress(Z, z3, H, T, E);
            }
            this._dueIndex = H;
            var oe = this._settedOutputEnd != null ? this._settedOutputEnd : H;
            this._outputDueEnd = oe;
          } else
            this._dueIndex = this._outputDueEnd = this._settedOutputEnd != null ? this._settedOutputEnd : this._dueEnd;
          return this.unfinished();
        }, s.prototype.dirty = function() {
          this._dirty = true, this._onDirty && this._onDirty(this.context);
        }, s.prototype._doProgress = function(a, n6, f6, d4, y4) {
          wGe.reset(n6, f6, d4, y4), this._callingProgress = a, this._callingProgress({ start: n6, end: f6, count: f6 - n6, next: wGe.next }, this.context);
        }, s.prototype._doReset = function(a) {
          this._dueIndex = this._outputDueEnd = this._dueEnd = 0, this._settedOutputEnd = null;
          var n6, f6;
          !a && this._reset && (n6 = this._reset(this.context), n6 && n6.progress && (f6 = n6.forceFirstProgress, n6 = n6.progress), Di(n6) && !n6.length && (n6 = null)), this._progress = n6, this._modBy = this._modDataCount = null;
          var d4 = this._downstream;
          return d4 && d4.dirty(), f6;
        }, s.prototype.unfinished = function() {
          return this._progress && this._dueIndex < this._dueEnd;
        }, s.prototype.pipe = function(a) {
          (this._downstream !== a || this._dirty) && (this._downstream = a, a._upstream = this, a.dirty());
        }, s.prototype.dispose = function() {
          this._disposed || (this._upstream && (this._upstream._downstream = null), this._downstream && (this._downstream._upstream = null), this._dirty = false, this._disposed = true);
        }, s.prototype.getUpstream = function() {
          return this._upstream;
        }, s.prototype.getDownstream = function() {
          return this._downstream;
        }, s.prototype.setOutputEnd = function(a) {
          this._outputDueEnd = this._settedOutputEnd = a;
        }, s;
      }(), wGe = function() {
        var s, a, n6, f6, d4, y4 = { reset: function(T, E, O, R) {
          a = T, s = E, n6 = O, f6 = R, d4 = Math.ceil(f6 / n6), y4.next = n6 > 1 && f6 > 0 ? S : _;
        } };
        return y4;
        function _() {
          return a < s ? a++ : null;
        }
        function S() {
          var T = a % d4 * n6 + Math.ceil(a / d4), E = a >= s ? null : T < f6 ? T : a;
          return a++, E;
        }
      }();
      function Zk(s, a) {
        var n6 = a && a.type;
        return n6 === "ordinal" ? s : (n6 === "time" && !ac(s) && s != null && s !== "-" && (s = +nx(s)), s == null || s === "" ? NaN : +s);
      }
      var G4t = ro({ number: function(s) {
        return parseFloat(s);
      }, time: function(s) {
        return +nx(s);
      }, trim: function(s) {
        return Wa(s) ? wh(s) : s;
      } });
      function SGe(s) {
        return G4t.get(s);
      }
      var CGe = { lt: function(s, a) {
        return s < a;
      }, lte: function(s, a) {
        return s <= a;
      }, gt: function(s, a) {
        return s > a;
      }, gte: function(s, a) {
        return s >= a;
      } }, H4t = function() {
        function s(a, n6) {
          if (!ac(n6)) {
            var f6 = "";
            Ul(f6);
          }
          this._opFn = CGe[a], this._rvalFloat = eS(n6);
        }
        return s.prototype.evaluate = function(a) {
          return ac(a) ? this._opFn(a, this._rvalFloat) : this._opFn(eS(a), this._rvalFloat);
        }, s;
      }(), MGe = function() {
        function s(a, n6) {
          var f6 = a === "desc";
          this._resultLT = f6 ? 1 : -1, n6 == null && (n6 = f6 ? "min" : "max"), this._incomparable = n6 === "min" ? -1 / 0 : 1 / 0;
        }
        return s.prototype.evaluate = function(a, n6) {
          var f6 = ac(a) ? a : eS(a), d4 = ac(n6) ? n6 : eS(n6), y4 = isNaN(f6), _ = isNaN(d4);
          if (y4 && (f6 = this._incomparable), _ && (d4 = this._incomparable), y4 && _) {
            var S = Wa(a), T = Wa(n6);
            S && (f6 = T ? a : 0), T && (d4 = S ? n6 : 0);
          }
          return f6 < d4 ? this._resultLT : f6 > d4 ? -this._resultLT : 0;
        }, s;
      }(), W4t = function() {
        function s(a, n6) {
          this._rval = n6, this._isEQ = a, this._rvalTypeof = typeof n6, this._rvalFloat = eS(n6);
        }
        return s.prototype.evaluate = function(a) {
          var n6 = a === this._rval;
          if (!n6) {
            var f6 = typeof a;
            f6 !== this._rvalTypeof && (f6 === "number" || this._rvalTypeof === "number") && (n6 = eS(a) === this._rvalFloat);
          }
          return this._isEQ ? n6 : !n6;
        }, s;
      }();
      function U4t(s, a) {
        return s === "eq" || s === "ne" ? new W4t(s === "eq", a) : io(CGe, s) ? new H4t(s, a) : null;
      }
      var q4t = function() {
        function s() {
        }
        return s.prototype.getRawData = function() {
          throw new Error("not supported");
        }, s.prototype.getRawDataItem = function(a) {
          throw new Error("not supported");
        }, s.prototype.cloneRawData = function() {
        }, s.prototype.getDimensionInfo = function(a) {
        }, s.prototype.cloneAllDimensionInfo = function() {
        }, s.prototype.count = function() {
        }, s.prototype.retrieveValue = function(a, n6) {
        }, s.prototype.retrieveValueFromItem = function(a, n6) {
        }, s.prototype.convertValue = function(a, n6) {
          return Zk(a, n6);
        }, s;
      }();
      function $4t(s, a) {
        var n6 = new q4t(), f6 = s.data, d4 = n6.sourceFormat = s.sourceFormat, y4 = s.startIndex, _ = "";
        s.seriesLayoutBy !== PT && Ul(_);
        var S = [], T = {}, E = s.dimensionsDefine;
        if (E)
          gt(E, function(Z, ee) {
            var oe = Z.name, fe = { index: ee, name: oe, displayName: Z.displayName };
            if (S.push(fe), oe != null) {
              var _e = "";
              io(T, oe) && Ul(_e), T[oe] = fe;
            }
          });
        else
          for (var O = 0; O < s.dimensionsDetectedCount; O++)
            S.push({ index: O });
        var R = yGe(d4, PT);
        a.__isBuiltIn && (n6.getRawDataItem = function(Z) {
          return R(f6, y4, S, Z);
        }, n6.getRawData = Za(X4t, null, s)), n6.cloneRawData = Za(Y4t, null, s);
        var V = bGe(d4, PT);
        n6.count = Za(V, null, f6, y4, S);
        var z3 = _Ge(d4);
        n6.retrieveValue = function(Z, ee) {
          var oe = R(f6, y4, S, Z);
          return H(oe, ee);
        };
        var H = n6.retrieveValueFromItem = function(Z, ee) {
          if (Z != null) {
            var oe = S[ee];
            if (oe)
              return z3(Z, ee, oe.name);
          }
        };
        return n6.getDimensionInfo = Za(K4t, null, S, T), n6.cloneAllDimensionInfo = Za(Z4t, null, S), n6;
      }
      function X4t(s) {
        var a = s.sourceFormat;
        if (!Xxe(a)) {
          var n6 = "";
          Ul(n6);
        }
        return s.data;
      }
      function Y4t(s) {
        var a = s.sourceFormat, n6 = s.data;
        if (!Xxe(a)) {
          var f6 = "";
          Ul(f6);
        }
        if (a === Hm) {
          for (var d4 = [], y4 = 0, _ = n6.length; y4 < _; y4++)
            d4.push(n6[y4].slice());
          return d4;
        } else if (a === vS) {
          for (var d4 = [], y4 = 0, _ = n6.length; y4 < _; y4++)
            d4.push(ei({}, n6[y4]));
          return d4;
        }
      }
      function K4t(s, a, n6) {
        if (n6 != null) {
          if (ac(n6) || !isNaN(n6) && !io(a, n6))
            return s[n6];
          if (io(a, n6))
            return a[n6];
        }
      }
      function Z4t(s) {
        return Bo(s);
      }
      var TGe = ro();
      function J4t(s) {
        s = Bo(s);
        var a = s.type, n6 = "";
        a || Ul(n6);
        var f6 = a.split(":");
        f6.length !== 2 && Ul(n6);
        var d4 = false;
        f6[0] === "echarts" && (a = f6[1], d4 = true), s.__isBuiltIn = d4, TGe.set(a, s);
      }
      function Q4t(s, a, n6) {
        var f6 = jc(s), d4 = f6.length, y4 = "";
        d4 || Ul(y4);
        for (var _ = 0, S = d4; _ < S; _++) {
          var T = f6[_];
          a = e6t(T, a), _ !== S - 1 && (a.length = Math.max(a.length, 1));
        }
        return a;
      }
      function e6t(s, a, n6, f6) {
        var d4 = "";
        a.length || Ul(d4), Qo(s) || Ul(d4);
        var y4 = s.type, _ = TGe.get(y4);
        _ || Ul(d4);
        var S = Pi(a, function(E) {
          return $4t(E, _);
        }), T = jc(_.transform({ upstream: S[0], upstreamList: S, config: Bo(s.config) }));
        return Pi(T, function(E, O) {
          var R = "";
          Qo(E) || Ul(R), E.data || Ul(R);
          var V = uGe(E.data);
          Xxe(V) || Ul(R);
          var z3, H = a[0];
          if (H && O === 0 && !E.dimensions) {
            var Z = H.startIndex;
            Z && (E.data = H.data.slice(0, Z).concat(E.data)), z3 = { seriesLayoutBy: PT, sourceHeader: Z, dimensions: H.metaRawOption.dimensions };
          } else
            z3 = { seriesLayoutBy: PT, sourceHeader: 0, dimensions: E.dimensions };
          return Hxe(E.data, z3, null);
        });
      }
      function Xxe(s) {
        return s === Hm || s === vS;
      }
      var Rae = "undefined", t6t = typeof Uint32Array === Rae ? Array : Uint32Array, n6t = typeof Uint16Array === Rae ? Array : Uint16Array, AGe = typeof Int32Array === Rae ? Array : Int32Array, IGe = typeof Float64Array === Rae ? Array : Float64Array, EGe = { float: IGe, int: AGe, ordinal: Array, number: Array, time: IGe }, Yxe;
      function g$(s) {
        return s > 65535 ? t6t : n6t;
      }
      function L7() {
        return [1 / 0, -1 / 0];
      }
      function r6t(s) {
        var a = s.constructor;
        return a === Array ? s.slice() : new a(s);
      }
      function DGe(s, a, n6, f6, d4) {
        var y4 = EGe[n6 || "float"];
        if (d4) {
          var _ = s[a], S = _ && _.length;
          if (S !== f6) {
            for (var T = new y4(f6), E = 0; E < S; E++)
              T[E] = _[E];
            s[a] = T;
          }
        } else
          s[a] = new y4(f6);
      }
      var Kxe = function() {
        function s() {
          this._chunks = [], this._rawExtent = [], this._extent = [], this._count = 0, this._rawCount = 0, this._calcDimNameToIdx = ro();
        }
        return s.prototype.initData = function(a, n6, f6) {
          this._provider = a, this._chunks = [], this._indices = null, this.getRawIndex = this._getRawIdxIdentity;
          var d4 = a.getSource(), y4 = this.defaultDimValueGetter = Yxe[d4.sourceFormat];
          this._dimValueGetter = f6 || y4, this._rawExtent = [], hGe(d4), this._dimensions = Pi(n6, function(_) {
            return { type: _.type, property: _.property };
          }), this._initDataFromProvider(0, a.count());
        }, s.prototype.getProvider = function() {
          return this._provider;
        }, s.prototype.getSource = function() {
          return this._provider.getSource();
        }, s.prototype.ensureCalculationDimension = function(a, n6) {
          var f6 = this._calcDimNameToIdx, d4 = this._dimensions, y4 = f6.get(a);
          if (y4 != null) {
            if (d4[y4].type === n6)
              return y4;
          } else
            y4 = d4.length;
          return d4[y4] = { type: n6 }, f6.set(a, y4), this._chunks[y4] = new EGe[n6 || "float"](this._rawCount), this._rawExtent[y4] = L7(), y4;
        }, s.prototype.collectOrdinalMeta = function(a, n6) {
          var f6 = this._chunks[a], d4 = this._dimensions[a], y4 = this._rawExtent, _ = d4.ordinalOffset || 0, S = f6.length;
          _ === 0 && (y4[a] = L7());
          for (var T = y4[a], E = _; E < S; E++) {
            var O = f6[E] = n6.parseAndCollect(f6[E]);
            T[0] = Math.min(O, T[0]), T[1] = Math.max(O, T[1]);
          }
          d4.ordinalMeta = n6, d4.ordinalOffset = S, d4.type = "ordinal";
        }, s.prototype.getOrdinalMeta = function(a) {
          var n6 = this._dimensions[a], f6 = n6.ordinalMeta;
          return f6;
        }, s.prototype.getDimensionProperty = function(a) {
          var n6 = this._dimensions[a];
          return n6 && n6.property;
        }, s.prototype.appendData = function(a) {
          var n6 = this._provider, f6 = this.count();
          n6.appendData(a);
          var d4 = n6.count();
          return n6.persistent || (d4 += f6), f6 < d4 && this._initDataFromProvider(f6, d4, true), [f6, d4];
        }, s.prototype.appendValues = function(a, n6) {
          for (var f6 = this._chunks, d4 = this._dimensions, y4 = d4.length, _ = this._rawExtent, S = this.count(), T = S + Math.max(a.length, n6 || 0), E = 0; E < y4; E++) {
            var O = d4[E];
            DGe(f6, E, O.type, T, true);
          }
          for (var R = [], V = S; V < T; V++)
            for (var z3 = V - S, H = 0; H < y4; H++) {
              var O = d4[H], Z = Yxe.arrayRows.call(this, a[z3] || R, O.property, z3, H);
              f6[H][V] = Z;
              var ee = _[H];
              Z < ee[0] && (ee[0] = Z), Z > ee[1] && (ee[1] = Z);
            }
          return this._rawCount = this._count = T, { start: S, end: T };
        }, s.prototype._initDataFromProvider = function(a, n6, f6) {
          for (var d4 = this._provider, y4 = this._chunks, _ = this._dimensions, S = _.length, T = this._rawExtent, E = Pi(_, function(fe) {
            return fe.property;
          }), O = 0; O < S; O++) {
            var R = _[O];
            T[O] || (T[O] = L7()), DGe(y4, O, R.type, n6, f6);
          }
          if (d4.fillStorage)
            d4.fillStorage(a, n6, y4, T);
          else
            for (var V = [], z3 = a; z3 < n6; z3++) {
              V = d4.getItem(z3, V);
              for (var H = 0; H < S; H++) {
                var Z = y4[H], ee = this._dimValueGetter(V, E[H], z3, H);
                Z[z3] = ee;
                var oe = T[H];
                ee < oe[0] && (oe[0] = ee), ee > oe[1] && (oe[1] = ee);
              }
            }
          !d4.persistent && d4.clean && d4.clean(), this._rawCount = this._count = n6, this._extent = [];
        }, s.prototype.count = function() {
          return this._count;
        }, s.prototype.get = function(a, n6) {
          if (!(n6 >= 0 && n6 < this._count))
            return NaN;
          var f6 = this._chunks[a];
          return f6 ? f6[this.getRawIndex(n6)] : NaN;
        }, s.prototype.getValues = function(a, n6) {
          var f6 = [], d4 = [];
          if (n6 == null) {
            n6 = a, a = [];
            for (var y4 = 0; y4 < this._dimensions.length; y4++)
              d4.push(y4);
          } else
            d4 = a;
          for (var y4 = 0, _ = d4.length; y4 < _; y4++)
            f6.push(this.get(d4[y4], n6));
          return f6;
        }, s.prototype.getByRawIndex = function(a, n6) {
          if (!(n6 >= 0 && n6 < this._rawCount))
            return NaN;
          var f6 = this._chunks[a];
          return f6 ? f6[n6] : NaN;
        }, s.prototype.getSum = function(a) {
          var n6 = this._chunks[a], f6 = 0;
          if (n6)
            for (var d4 = 0, y4 = this.count(); d4 < y4; d4++) {
              var _ = this.get(a, d4);
              isNaN(_) || (f6 += _);
            }
          return f6;
        }, s.prototype.getMedian = function(a) {
          var n6 = [];
          this.each([a], function(y4) {
            isNaN(y4) || n6.push(y4);
          });
          var f6 = n6.sort(function(y4, _) {
            return y4 - _;
          }), d4 = this.count();
          return d4 === 0 ? 0 : d4 % 2 === 1 ? f6[(d4 - 1) / 2] : (f6[d4 / 2] + f6[d4 / 2 - 1]) / 2;
        }, s.prototype.indexOfRawIndex = function(a) {
          if (a >= this._rawCount || a < 0)
            return -1;
          if (!this._indices)
            return a;
          var n6 = this._indices, f6 = n6[a];
          if (f6 != null && f6 < this._count && f6 === a)
            return a;
          for (var d4 = 0, y4 = this._count - 1; d4 <= y4; ) {
            var _ = (d4 + y4) / 2 | 0;
            if (n6[_] < a)
              d4 = _ + 1;
            else if (n6[_] > a)
              y4 = _ - 1;
            else
              return _;
          }
          return -1;
        }, s.prototype.indicesOfNearest = function(a, n6, f6) {
          var d4 = this._chunks, y4 = d4[a], _ = [];
          if (!y4)
            return _;
          f6 == null && (f6 = 1 / 0);
          for (var S = 1 / 0, T = -1, E = 0, O = 0, R = this.count(); O < R; O++) {
            var V = this.getRawIndex(O), z3 = n6 - y4[V], H = Math.abs(z3);
            H <= f6 && ((H < S || H === S && z3 >= 0 && T < 0) && (S = H, T = z3, E = 0), z3 === T && (_[E++] = O));
          }
          return _.length = E, _;
        }, s.prototype.getIndices = function() {
          var a, n6 = this._indices;
          if (n6) {
            var f6 = n6.constructor, d4 = this._count;
            if (f6 === Array) {
              a = new f6(d4);
              for (var y4 = 0; y4 < d4; y4++)
                a[y4] = n6[y4];
            } else
              a = new f6(n6.buffer, 0, d4);
          } else {
            var f6 = g$(this._rawCount);
            a = new f6(this.count());
            for (var y4 = 0; y4 < a.length; y4++)
              a[y4] = y4;
          }
          return a;
        }, s.prototype.filter = function(a, n6) {
          if (!this._count)
            return this;
          for (var f6 = this.clone(), d4 = f6.count(), y4 = g$(f6._rawCount), _ = new y4(d4), S = [], T = a.length, E = 0, O = a[0], R = f6._chunks, V = 0; V < d4; V++) {
            var z3 = void 0, H = f6.getRawIndex(V);
            if (T === 0)
              z3 = n6(V);
            else if (T === 1) {
              var Z = R[O][H];
              z3 = n6(Z, V);
            } else {
              for (var ee = 0; ee < T; ee++)
                S[ee] = R[a[ee]][H];
              S[ee] = V, z3 = n6.apply(null, S);
            }
            z3 && (_[E++] = H);
          }
          return E < d4 && (f6._indices = _), f6._count = E, f6._extent = [], f6._updateGetRawIdx(), f6;
        }, s.prototype.selectRange = function(a) {
          var n6 = this.clone(), f6 = n6._count;
          if (!f6)
            return this;
          var d4 = Wl(a), y4 = d4.length;
          if (!y4)
            return this;
          var _ = n6.count(), S = g$(n6._rawCount), T = new S(_), E = 0, O = d4[0], R = a[O][0], V = a[O][1], z3 = n6._chunks, H = false;
          if (!n6._indices) {
            var Z = 0;
            if (y4 === 1) {
              for (var ee = z3[d4[0]], oe = 0; oe < f6; oe++) {
                var fe = ee[oe];
                (fe >= R && fe <= V || isNaN(fe)) && (T[E++] = Z), Z++;
              }
              H = true;
            } else if (y4 === 2) {
              for (var ee = z3[d4[0]], _e = z3[d4[1]], pe = a[d4[1]][0], Ve = a[d4[1]][1], oe = 0; oe < f6; oe++) {
                var fe = ee[oe], Le = _e[oe];
                (fe >= R && fe <= V || isNaN(fe)) && (Le >= pe && Le <= Ve || isNaN(Le)) && (T[E++] = Z), Z++;
              }
              H = true;
            }
          }
          if (!H)
            if (y4 === 1)
              for (var oe = 0; oe < _; oe++) {
                var je = n6.getRawIndex(oe), fe = z3[d4[0]][je];
                (fe >= R && fe <= V || isNaN(fe)) && (T[E++] = je);
              }
            else
              for (var oe = 0; oe < _; oe++) {
                for (var Xe = true, je = n6.getRawIndex(oe), Ye = 0; Ye < y4; Ye++) {
                  var rt2 = d4[Ye], fe = z3[rt2][je];
                  (fe < a[rt2][0] || fe > a[rt2][1]) && (Xe = false);
                }
                Xe && (T[E++] = n6.getRawIndex(oe));
              }
          return E < _ && (n6._indices = T), n6._count = E, n6._extent = [], n6._updateGetRawIdx(), n6;
        }, s.prototype.map = function(a, n6) {
          var f6 = this.clone(a);
          return this._updateDims(f6, a, n6), f6;
        }, s.prototype.modify = function(a, n6) {
          this._updateDims(this, a, n6);
        }, s.prototype._updateDims = function(a, n6, f6) {
          for (var d4 = a._chunks, y4 = [], _ = n6.length, S = a.count(), T = [], E = a._rawExtent, O = 0; O < n6.length; O++)
            E[n6[O]] = L7();
          for (var R = 0; R < S; R++) {
            for (var V = a.getRawIndex(R), z3 = 0; z3 < _; z3++)
              T[z3] = d4[n6[z3]][V];
            T[_] = R;
            var H = f6 && f6.apply(null, T);
            if (H != null) {
              typeof H != "object" && (y4[0] = H, H = y4);
              for (var O = 0; O < H.length; O++) {
                var Z = n6[O], ee = H[O], oe = E[Z], fe = d4[Z];
                fe && (fe[V] = ee), ee < oe[0] && (oe[0] = ee), ee > oe[1] && (oe[1] = ee);
              }
            }
          }
        }, s.prototype.lttbDownSample = function(a, n6) {
          var f6 = this.clone([a], true), d4 = f6._chunks, y4 = d4[a], _ = this.count(), S = 0, T = Math.floor(1 / n6), E = this.getRawIndex(0), O, R, V, z3 = new (g$(this._rawCount))(Math.min((Math.ceil(_ / T) + 2) * 2, _));
          z3[S++] = E;
          for (var H = 1; H < _ - 1; H += T) {
            for (var Z = Math.min(H + T, _ - 1), ee = Math.min(H + T * 2, _), oe = (ee + Z) / 2, fe = 0, _e = Z; _e < ee; _e++) {
              var pe = this.getRawIndex(_e), Ve = y4[pe];
              isNaN(Ve) || (fe += Ve);
            }
            fe /= ee - Z;
            var Le = H, je = Math.min(H + T, _), Xe = H - 1, Ye = y4[E];
            O = -1, V = Le;
            for (var rt2 = -1, ut = 0, _e = Le; _e < je; _e++) {
              var pe = this.getRawIndex(_e), Ve = y4[pe];
              if (isNaN(Ve)) {
                ut++, rt2 < 0 && (rt2 = pe);
                continue;
              }
              R = Math.abs((Xe - oe) * (Ve - Ye) - (Xe - _e) * (fe - Ye)), R > O && (O = R, V = pe);
            }
            ut > 0 && ut < je - Le && (z3[S++] = Math.min(rt2, V), V = Math.max(rt2, V)), z3[S++] = V, E = V;
          }
          return z3[S++] = this.getRawIndex(_ - 1), f6._count = S, f6._indices = z3, f6.getRawIndex = this._getRawIdx, f6;
        }, s.prototype.downSample = function(a, n6, f6, d4) {
          for (var y4 = this.clone([a], true), _ = y4._chunks, S = [], T = Math.floor(1 / n6), E = _[a], O = this.count(), R = y4._rawExtent[a] = L7(), V = new (g$(this._rawCount))(Math.ceil(O / T)), z3 = 0, H = 0; H < O; H += T) {
            T > O - H && (T = O - H, S.length = T);
            for (var Z = 0; Z < T; Z++) {
              var ee = this.getRawIndex(H + Z);
              S[Z] = E[ee];
            }
            var oe = f6(S), fe = this.getRawIndex(Math.min(H + d4(S, oe) || 0, O - 1));
            E[fe] = oe, oe < R[0] && (R[0] = oe), oe > R[1] && (R[1] = oe), V[z3++] = fe;
          }
          return y4._count = z3, y4._indices = V, y4._updateGetRawIdx(), y4;
        }, s.prototype.each = function(a, n6) {
          if (this._count)
            for (var f6 = a.length, d4 = this._chunks, y4 = 0, _ = this.count(); y4 < _; y4++) {
              var S = this.getRawIndex(y4);
              switch (f6) {
                case 0:
                  n6(y4);
                  break;
                case 1:
                  n6(d4[a[0]][S], y4);
                  break;
                case 2:
                  n6(d4[a[0]][S], d4[a[1]][S], y4);
                  break;
                default:
                  for (var T = 0, E = []; T < f6; T++)
                    E[T] = d4[a[T]][S];
                  E[T] = y4, n6.apply(null, E);
              }
            }
        }, s.prototype.getDataExtent = function(a) {
          var n6 = this._chunks[a], f6 = L7();
          if (!n6)
            return f6;
          var d4 = this.count(), y4 = !this._indices, _;
          if (y4)
            return this._rawExtent[a].slice();
          if (_ = this._extent[a], _)
            return _.slice();
          _ = f6;
          for (var S = _[0], T = _[1], E = 0; E < d4; E++) {
            var O = this.getRawIndex(E), R = n6[O];
            R < S && (S = R), R > T && (T = R);
          }
          return _ = [S, T], this._extent[a] = _, _;
        }, s.prototype.getRawDataItem = function(a) {
          var n6 = this.getRawIndex(a);
          if (this._provider.persistent)
            return this._provider.getItem(n6);
          for (var f6 = [], d4 = this._chunks, y4 = 0; y4 < d4.length; y4++)
            f6.push(d4[y4][n6]);
          return f6;
        }, s.prototype.clone = function(a, n6) {
          var f6 = new s(), d4 = this._chunks, y4 = a && G_(a, function(S, T) {
            return S[T] = true, S;
          }, {});
          if (y4)
            for (var _ = 0; _ < d4.length; _++)
              f6._chunks[_] = y4[_] ? r6t(d4[_]) : d4[_];
          else
            f6._chunks = d4;
          return this._copyCommonProps(f6), n6 || (f6._indices = this._cloneIndices()), f6._updateGetRawIdx(), f6;
        }, s.prototype._copyCommonProps = function(a) {
          a._count = this._count, a._rawCount = this._rawCount, a._provider = this._provider, a._dimensions = this._dimensions, a._extent = Bo(this._extent), a._rawExtent = Bo(this._rawExtent);
        }, s.prototype._cloneIndices = function() {
          if (this._indices) {
            var a = this._indices.constructor, n6 = void 0;
            if (a === Array) {
              var f6 = this._indices.length;
              n6 = new a(f6);
              for (var d4 = 0; d4 < f6; d4++)
                n6[d4] = this._indices[d4];
            } else
              n6 = new a(this._indices);
            return n6;
          }
          return null;
        }, s.prototype._getRawIdxIdentity = function(a) {
          return a;
        }, s.prototype._getRawIdx = function(a) {
          return a < this._count && a >= 0 ? this._indices[a] : -1;
        }, s.prototype._updateGetRawIdx = function() {
          this.getRawIndex = this._indices ? this._getRawIdx : this._getRawIdxIdentity;
        }, s.internalField = function() {
          function a(n6, f6, d4, y4) {
            return Zk(n6[y4], this._dimensions[y4]);
          }
          Yxe = { arrayRows: a, objectRows: function(n6, f6, d4, y4) {
            return Zk(n6[f6], this._dimensions[y4]);
          }, keyedColumns: a, original: function(n6, f6, d4, y4) {
            var _ = n6 && (n6.value == null ? n6 : n6.value);
            return Zk(_ instanceof Array ? _[y4] : _, this._dimensions[y4]);
          }, typedArray: function(n6, f6, d4, y4) {
            return n6[y4];
          } };
        }(), s;
      }(), kGe = function() {
        function s(a) {
          this._sourceList = [], this._storeList = [], this._upstreamSignList = [], this._versionSignBase = 0, this._dirty = true, this._sourceHost = a;
        }
        return s.prototype.dirty = function() {
          this._setLocalSource([], []), this._storeList = [], this._dirty = true;
        }, s.prototype._setLocalSource = function(a, n6) {
          this._sourceList = a, this._upstreamSignList = n6, this._versionSignBase++, this._versionSignBase > 9e10 && (this._versionSignBase = 0);
        }, s.prototype._getVersionSign = function() {
          return this._sourceHost.uid + "_" + this._versionSignBase;
        }, s.prototype.prepareSource = function() {
          this._isDirty() && (this._createSource(), this._dirty = false);
        }, s.prototype._createSource = function() {
          this._setLocalSource([], []);
          var a = this._sourceHost, n6 = this._getUpstreamSourceManagers(), f6 = !!n6.length, d4, y4;
          if (Nae(a)) {
            var _ = a, S = void 0, T = void 0, E = void 0;
            if (f6) {
              var O = n6[0];
              O.prepareSource(), E = O.getSource(), S = E.data, T = E.sourceFormat, y4 = [O._getVersionSign()];
            } else
              S = _.get("data", true), T = j1(S) ? Kk : dS, y4 = [];
            var R = this._getSourceMetaRawOption() || {}, V = E && E.metaRawOption || {}, z3 = Zs(R.seriesLayoutBy, V.seriesLayoutBy) || null, H = Zs(R.sourceHeader, V.sourceHeader), Z = Zs(R.dimensions, V.dimensions), ee = z3 !== V.seriesLayoutBy || !!H != !!V.sourceHeader || Z;
            d4 = ee ? [Hxe(S, { seriesLayoutBy: z3, sourceHeader: H, dimensions: Z }, T)] : [];
          } else {
            var oe = a;
            if (f6) {
              var fe = this._applyTransform(n6);
              d4 = fe.sourceList, y4 = fe.upstreamSignList;
            } else {
              var _e = oe.get("source", true);
              d4 = [Hxe(_e, this._getSourceMetaRawOption(), null)], y4 = [];
            }
          }
          this._setLocalSource(d4, y4);
        }, s.prototype._applyTransform = function(a) {
          var n6 = this._sourceHost, f6 = n6.get("transform", true), d4 = n6.get("fromTransformResult", true);
          if (d4 != null) {
            var y4 = "";
            a.length !== 1 && PGe(y4);
          }
          var _, S = [], T = [];
          return gt(a, function(E) {
            E.prepareSource();
            var O = E.getSource(d4 || 0), R = "";
            d4 != null && !O && PGe(R), S.push(O), T.push(E._getVersionSign());
          }), f6 ? _ = Q4t(f6, S, { datasetIndex: n6.componentIndex }) : d4 != null && (_ = [L4t(S[0])]), { sourceList: _, upstreamSignList: T };
        }, s.prototype._isDirty = function() {
          if (this._dirty)
            return true;
          for (var a = this._getUpstreamSourceManagers(), n6 = 0; n6 < a.length; n6++) {
            var f6 = a[n6];
            if (f6._isDirty() || this._upstreamSignList[n6] !== f6._getVersionSign())
              return true;
          }
        }, s.prototype.getSource = function(a) {
          a = a || 0;
          var n6 = this._sourceList[a];
          if (!n6) {
            var f6 = this._getUpstreamSourceManagers();
            return f6[0] && f6[0].getSource(a);
          }
          return n6;
        }, s.prototype.getSharedDataStore = function(a) {
          var n6 = a.makeStoreSchema();
          return this._innerGetDataStore(n6.dimensions, a.source, n6.hash);
        }, s.prototype._innerGetDataStore = function(a, n6, f6) {
          var d4 = 0, y4 = this._storeList, _ = y4[d4];
          _ || (_ = y4[d4] = {});
          var S = _[f6];
          if (!S) {
            var T = this._getUpstreamSourceManagers()[0];
            Nae(this._sourceHost) && T ? S = T._innerGetDataStore(a, n6, f6) : (S = new Kxe(), S.initData(new vGe(n6, a.length), a)), _[f6] = S;
          }
          return S;
        }, s.prototype._getUpstreamSourceManagers = function() {
          var a = this._sourceHost;
          if (Nae(a)) {
            var n6 = Rxe(a);
            return n6 ? [n6.getSourceManager()] : [];
          } else
            return Pi(o4t(a), function(f6) {
              return f6.getSourceManager();
            });
        }, s.prototype._getSourceMetaRawOption = function() {
          var a = this._sourceHost, n6, f6, d4;
          if (Nae(a))
            n6 = a.get("seriesLayoutBy", true), f6 = a.get("sourceHeader", true), d4 = a.get("dimensions", true);
          else if (!this._getUpstreamSourceManagers().length) {
            var y4 = a;
            n6 = y4.get("seriesLayoutBy", true), f6 = y4.get("sourceHeader", true), d4 = y4.get("dimensions", true);
          }
          return { seriesLayoutBy: n6, sourceHeader: f6, dimensions: d4 };
        }, s;
      }();
      function OGe(s) {
        var a = s.option.transform;
        a && $w(s.option.transform);
      }
      function Nae(s) {
        return s.mainType === "series";
      }
      function PGe(s) {
        throw new Error(s);
      }
      var LGe = "line-height:1";
      function RGe(s, a) {
        var n6 = s.color || "#6e7079", f6 = s.fontSize || 12, d4 = s.fontWeight || "400", y4 = s.color || "#464646", _ = s.fontSize || 14, S = s.fontWeight || "900";
        return a === "html" ? { nameStyle: "font-size:" + sx(f6 + "") + "px;color:" + sx(n6) + ";font-weight:" + sx(d4 + ""), valueStyle: "font-size:" + sx(_ + "") + "px;color:" + sx(y4) + ";font-weight:" + sx(S + "") } : { nameStyle: { fontSize: f6, fill: n6, fontWeight: d4 }, valueStyle: { fontSize: _, fill: y4, fontWeight: S } };
      }
      var i6t = [0, 10, 20, 30], a6t = ["", `
`, `

`, `


`];
      function Rg(s, a) {
        return a.type = s, a;
      }
      function Zxe(s) {
        return s.type === "section";
      }
      function NGe(s) {
        return Zxe(s) ? o6t : s6t;
      }
      function FGe(s) {
        if (Zxe(s)) {
          var a = 0, n6 = s.blocks.length, f6 = n6 > 1 || n6 > 0 && !s.noHeader;
          return gt(s.blocks, function(d4) {
            var y4 = FGe(d4);
            y4 >= a && (a = y4 + +(f6 && (!y4 || Zxe(d4) && !d4.noHeader)));
          }), a;
        }
        return 0;
      }
      function o6t(s, a, n6, f6) {
        var d4 = a.noHeader, y4 = l6t(FGe(a)), _ = [], S = a.blocks || [];
        Ty(!S || Di(S)), S = S || [];
        var T = s.orderMode;
        if (a.sortBlocks && T) {
          S = S.slice();
          var E = { valueAsc: "asc", valueDesc: "desc" };
          if (io(E, T)) {
            var O = new MGe(E[T], null);
            S.sort(function(H, Z) {
              return O.evaluate(H.sortParam, Z.sortParam);
            });
          } else
            T === "seriesDesc" && S.reverse();
        }
        gt(S, function(H, Z) {
          var ee = a.valueFormatter, oe = NGe(H)(ee ? ei(ei({}, s), { valueFormatter: ee }) : s, H, Z > 0 ? y4.html : 0, f6);
          oe != null && _.push(oe);
        });
        var R = s.renderMode === "richText" ? _.join(y4.richText) : Jxe(_.join(""), d4 ? n6 : y4.html);
        if (d4)
          return R;
        var V = kxe(a.header, "ordinal", s.useUTC), z3 = RGe(f6, s.renderMode).nameStyle;
        return s.renderMode === "richText" ? BGe(s, V, z3) + y4.richText + R : Jxe('<div style="' + z3 + ";" + LGe + ';">' + sx(V) + "</div>" + R, n6);
      }
      function s6t(s, a, n6, f6) {
        var d4 = s.renderMode, y4 = a.noName, _ = a.noValue, S = !a.markerType, T = a.name, E = s.useUTC, O = a.valueFormatter || s.valueFormatter || function(pe) {
          return pe = Di(pe) ? pe : [pe], Pi(pe, function(Ve, Le) {
            return kxe(Ve, Di(z3) ? z3[Le] : z3, E);
          });
        };
        if (!(y4 && _)) {
          var R = S ? "" : s.markupStyleCreator.makeTooltipMarker(a.markerType, a.markerColor || "#333", d4), V = y4 ? "" : kxe(T, "ordinal", E), z3 = a.valueType, H = _ ? [] : O(a.value), Z = !S || !y4, ee = !S && y4, oe = RGe(f6, d4), fe = oe.nameStyle, _e = oe.valueStyle;
          return d4 === "richText" ? (S ? "" : R) + (y4 ? "" : BGe(s, V, fe)) + (_ ? "" : f6t(s, H, Z, ee, _e)) : Jxe((S ? "" : R) + (y4 ? "" : u6t(V, !S, fe)) + (_ ? "" : c6t(H, Z, ee, _e)), n6);
        }
      }
      function VGe(s, a, n6, f6, d4, y4) {
        if (s) {
          var _ = NGe(s), S = { useUTC: d4, renderMode: n6, orderMode: f6, markupStyleCreator: a, valueFormatter: s.valueFormatter };
          return _(S, s, 0, y4);
        }
      }
      function l6t(s) {
        return { html: i6t[s], richText: a6t[s] };
      }
      function Jxe(s, a) {
        var n6 = '<div style="clear:both"></div>', f6 = "margin: " + a + "px 0 0";
        return '<div style="' + f6 + ";" + LGe + ';">' + s + n6 + "</div>";
      }
      function u6t(s, a, n6) {
        var f6 = a ? "margin-left:2px" : "";
        return '<span style="' + n6 + ";" + f6 + '">' + sx(s) + "</span>";
      }
      function c6t(s, a, n6, f6) {
        var d4 = n6 ? "10px" : "20px", y4 = a ? "float:right;margin-left:" + d4 : "";
        return s = Di(s) ? s : [s], '<span style="' + y4 + ";" + f6 + '">' + Pi(s, function(_) {
          return sx(_);
        }).join("&nbsp;&nbsp;") + "</span>";
      }
      function BGe(s, a, n6) {
        return s.markupStyleCreator.wrapRichTextStyle(a, n6);
      }
      function f6t(s, a, n6, f6, d4) {
        var y4 = [d4], _ = f6 ? 10 : 20;
        return n6 && y4.push({ padding: [0, 0, 0, _], align: "right" }), s.markupStyleCreator.wrapRichTextStyle(Di(a) ? a.join("  ") : a, y4);
      }
      function zGe(s, a) {
        var n6 = s.getData().getItemVisual(a, "style"), f6 = n6[s.visualDrawType];
        return LR(f6);
      }
      function jGe(s, a) {
        var n6 = s.get("padding");
        return n6 != null ? n6 : a === "richText" ? [8, 10] : 10;
      }
      var Qxe = function() {
        function s() {
          this.richTextStyles = {}, this._nextStyleNameId = JU();
        }
        return s.prototype._generateStyleName = function() {
          return "__EC_aUTo_" + this._nextStyleNameId++;
        }, s.prototype.makeTooltipMarker = function(a, n6, f6) {
          var d4 = f6 === "richText" ? this._generateStyleName() : null, y4 = QRt({ color: n6, type: a, renderMode: f6, markerId: d4 });
          return Wa(y4) ? y4 : (this.richTextStyles[d4] = y4.style, y4.content);
        }, s.prototype.wrapRichTextStyle = function(a, n6) {
          var f6 = {};
          Di(n6) ? gt(n6, function(y4) {
            return ei(f6, y4);
          }) : ei(f6, n6);
          var d4 = this._generateStyleName();
          return this.richTextStyles[d4] = f6, "{" + d4 + "|" + a + "}";
        }, s;
      }();
      function GGe(s) {
        var a = s.series, n6 = s.dataIndex, f6 = s.multipleSeries, d4 = a.getData(), y4 = d4.mapDimensionsAll("defaultedTooltip"), _ = y4.length, S = a.getRawValue(n6), T = Di(S), E = zGe(a, n6), O, R, V, z3;
        if (_ > 1 || T && !_) {
          var H = h6t(S, a, n6, y4, E);
          O = H.inlineValues, R = H.inlineValueTypes, V = H.blocks, z3 = H.inlineValues[0];
        } else if (_) {
          var Z = d4.getDimensionInfo(y4[0]);
          z3 = O = P7(d4, n6, y4[0]), R = Z.type;
        } else
          z3 = O = T ? S[0] : S;
        var ee = nq(a), oe = ee && a.name || "", fe = d4.getName(n6), _e = f6 ? oe : fe;
        return Rg("section", { header: oe, noHeader: f6 || !ee, sortParam: z3, blocks: [Rg("nameValue", { markerType: "item", markerColor: E, name: _e, noName: !wh(_e), value: O, valueType: R })].concat(V || []) });
      }
      function h6t(s, a, n6, f6, d4) {
        var y4 = a.getData(), _ = G_(s, function(R, V, z3) {
          var H = y4.getDimensionInfo(z3);
          return R = R || H && H.tooltip !== false && H.displayName != null;
        }, false), S = [], T = [], E = [];
        f6.length ? gt(f6, function(R) {
          O(P7(y4, n6, R), R);
        }) : gt(s, O);
        function O(R, V) {
          var z3 = y4.getDimensionInfo(V);
          !z3 || z3.otherDims.tooltip === false || (_ ? E.push(Rg("nameValue", { markerType: "subItem", markerColor: d4, name: z3.displayName, value: R, valueType: z3.type })) : (S.push(R), T.push(z3.type)));
        }
        return { inlineValues: S, inlineValueTypes: T, blocks: E };
      }
      var Jk = hu();
      function Fae(s, a) {
        return s.getName(a) || s.getId(a);
      }
      var Vae = "__universalTransitionEnabled", Bae = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6._selectedDataIndicesMap = {}, n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          this.seriesIndex = this.componentIndex, this.dataTask = v$({ count: d6t, reset: v6t }), this.dataTask.context = { model: this }, this.mergeDefaultAndTheme(n6, d4);
          var y4 = Jk(this).sourceManager = new kGe(this);
          y4.prepareSource();
          var _ = this.getInitialData(n6, d4);
          WGe(_, this), this.dataTask.context.data = _, Jk(this).dataBeforeProcessed = _, HGe(this), this._initSelectedMapFromData(_);
        }, a.prototype.mergeDefaultAndTheme = function(n6, f6) {
          var d4 = u$(this), y4 = d4 ? E7(n6) : {}, _ = this.subType;
          oc.hasClass(_) && (_ += "Series"), Ms(n6, f6.getTheme().get(this.subType)), Ms(n6, this.getDefaultOption()), Gb(n6, "label", ["show"]), this.fillDataTextStyle(n6.data), d4 && Yk(n6, y4, d4);
        }, a.prototype.mergeOption = function(n6, f6) {
          n6 = Ms(this.option, n6, true), this.fillDataTextStyle(n6.data);
          var d4 = u$(this);
          d4 && Yk(this.option, n6, d4);
          var y4 = Jk(this).sourceManager;
          y4.dirty(), y4.prepareSource();
          var _ = this.getInitialData(n6, f6);
          WGe(_, this), this.dataTask.dirty(), this.dataTask.context.data = _, Jk(this).dataBeforeProcessed = _, HGe(this), this._initSelectedMapFromData(_);
        }, a.prototype.fillDataTextStyle = function(n6) {
          if (n6 && !j1(n6))
            for (var f6 = ["show"], d4 = 0; d4 < n6.length; d4++)
              n6[d4] && n6[d4].label && Gb(n6[d4], "label", f6);
        }, a.prototype.getInitialData = function(n6, f6) {
        }, a.prototype.appendData = function(n6) {
          var f6 = this.getRawData();
          f6.appendData(n6.data);
        }, a.prototype.getData = function(n6) {
          var f6 = ewe(this);
          if (f6) {
            var d4 = f6.context.data;
            return n6 == null ? d4 : d4.getLinkedData(n6);
          } else
            return Jk(this).data;
        }, a.prototype.getAllData = function() {
          var n6 = this.getData();
          return n6 && n6.getLinkedDataAll ? n6.getLinkedDataAll() : [{ data: n6 }];
        }, a.prototype.setData = function(n6) {
          var f6 = ewe(this);
          if (f6) {
            var d4 = f6.context;
            d4.outputData = n6, f6 !== this.dataTask && (d4.data = n6);
          }
          Jk(this).data = n6;
        }, a.prototype.getEncode = function() {
          var n6 = this.get("encode", true);
          if (n6)
            return ro(n6);
        }, a.prototype.getSourceManager = function() {
          return Jk(this).sourceManager;
        }, a.prototype.getSource = function() {
          return this.getSourceManager().getSource();
        }, a.prototype.getRawData = function() {
          return Jk(this).dataBeforeProcessed;
        }, a.prototype.getColorBy = function() {
          var n6 = this.get("colorBy");
          return n6 || "series";
        }, a.prototype.isColorBySeries = function() {
          return this.getColorBy() === "series";
        }, a.prototype.getBaseAxis = function() {
          var n6 = this.coordinateSystem;
          return n6 && n6.getBaseAxis && n6.getBaseAxis();
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          return GGe({ series: this, dataIndex: n6, multipleSeries: f6 });
        }, a.prototype.isAnimationEnabled = function() {
          var n6 = this.ecModel;
          if (Na.node && !(n6 && n6.ssr))
            return false;
          var f6 = this.getShallow("animation");
          return f6 && this.getData().count() > this.getShallow("animationThreshold") && (f6 = false), !!f6;
        }, a.prototype.restoreData = function() {
          this.dataTask.dirty();
        }, a.prototype.getColorFromPalette = function(n6, f6, d4) {
          var y4 = this.ecModel, _ = Fxe.prototype.getColorFromPalette.call(this, n6, f6, d4);
          return _ || (_ = y4.getColorFromPalette(n6, f6, d4)), _;
        }, a.prototype.coordDimToDataDim = function(n6) {
          return this.getRawData().mapDimensionsAll(n6);
        }, a.prototype.getProgressive = function() {
          return this.get("progressive");
        }, a.prototype.getProgressiveThreshold = function() {
          return this.get("progressiveThreshold");
        }, a.prototype.select = function(n6, f6) {
          this._innerSelect(this.getData(f6), n6);
        }, a.prototype.unselect = function(n6, f6) {
          var d4 = this.option.selectedMap;
          if (d4) {
            var y4 = this.option.selectedMode, _ = this.getData(f6);
            if (y4 === "series" || d4 === "all") {
              this.option.selectedMap = {}, this._selectedDataIndicesMap = {};
              return;
            }
            for (var S = 0; S < n6.length; S++) {
              var T = n6[S], E = Fae(_, T);
              d4[E] = false, this._selectedDataIndicesMap[E] = -1;
            }
          }
        }, a.prototype.toggleSelect = function(n6, f6) {
          for (var d4 = [], y4 = 0; y4 < n6.length; y4++)
            d4[0] = n6[y4], this.isSelected(n6[y4], f6) ? this.unselect(d4, f6) : this.select(d4, f6);
        }, a.prototype.getSelectedDataIndices = function() {
          if (this.option.selectedMap === "all")
            return [].slice.call(this.getData().getIndices());
          for (var n6 = this._selectedDataIndicesMap, f6 = Wl(n6), d4 = [], y4 = 0; y4 < f6.length; y4++) {
            var _ = n6[f6[y4]];
            _ >= 0 && d4.push(_);
          }
          return d4;
        }, a.prototype.isSelected = function(n6, f6) {
          var d4 = this.option.selectedMap;
          if (!d4)
            return false;
          var y4 = this.getData(f6);
          return (d4 === "all" || d4[Fae(y4, n6)]) && !y4.getItemModel(n6).get(["select", "disabled"]);
        }, a.prototype.isUniversalTransitionEnabled = function() {
          if (this[Vae])
            return true;
          var n6 = this.option.universalTransition;
          return n6 ? n6 === true ? true : n6 && n6.enabled : false;
        }, a.prototype._innerSelect = function(n6, f6) {
          var d4, y4, _ = this.option, S = _.selectedMode, T = f6.length;
          if (!(!S || !T)) {
            if (S === "series")
              _.selectedMap = "all";
            else if (S === "multiple") {
              Qo(_.selectedMap) || (_.selectedMap = {});
              for (var E = _.selectedMap, O = 0; O < T; O++) {
                var R = f6[O], V = Fae(n6, R);
                E[V] = true, this._selectedDataIndicesMap[V] = n6.getRawIndex(R);
              }
            } else if (S === "single" || S === true) {
              var z3 = f6[T - 1], V = Fae(n6, z3);
              _.selectedMap = (d4 = {}, d4[V] = true, d4), this._selectedDataIndicesMap = (y4 = {}, y4[V] = n6.getRawIndex(z3), y4);
            }
          }
        }, a.prototype._initSelectedMapFromData = function(n6) {
          if (!this.option.selectedMap) {
            var f6 = [];
            n6.hasItemOption && n6.each(function(d4) {
              var y4 = n6.getRawDataItem(d4);
              y4 && y4.selected && f6.push(d4);
            }), f6.length > 0 && this._innerSelect(n6, f6);
          }
        }, a.registerClass = function(n6) {
          return oc.registerClass(n6);
        }, a.protoInitialize = function() {
          var n6 = a.prototype;
          n6.type = "series.__base__", n6.seriesIndex = 0, n6.ignoreStyleOnData = false, n6.hasSymbolVisual = false, n6.defaultSymbol = "circle", n6.visualStyleAccessPath = "itemStyle", n6.visualDrawType = "fill";
        }(), a;
      }(oc);
      nd(Bae, $xe), nd(Bae, Fxe), sq(Bae, oc);
      function HGe(s) {
        var a = s.name;
        nq(s) || (s.name = p6t(s) || a);
      }
      function p6t(s) {
        var a = s.getRawData(), n6 = a.mapDimensionsAll("seriesName"), f6 = [];
        return gt(n6, function(d4) {
          var y4 = a.getDimensionInfo(d4);
          y4.displayName && f6.push(y4.displayName);
        }), f6.join(" ");
      }
      function d6t(s) {
        return s.model.getRawData().count();
      }
      function v6t(s) {
        var a = s.model;
        return a.setData(a.getRawData().cloneShallow()), g6t;
      }
      function g6t(s, a) {
        a.outputData && s.end > a.outputData.count() && a.model.getRawData().cloneShallow(a.outputData);
      }
      function WGe(s, a) {
        gt(u9(s.CHANGABLE_METHODS, s.DOWNSAMPLE_METHODS), function(n6) {
          s.wrapMethod(n6, ks(y6t, a));
        });
      }
      function y6t(s, a) {
        var n6 = ewe(s);
        return n6 && n6.setOutputEnd((a || this).count()), a;
      }
      function ewe(s) {
        var a = (s.ecModel || {}).scheduler, n6 = a && a.getPipeline(s.uid);
        if (n6) {
          var f6 = n6.currentTask;
          if (f6) {
            var d4 = f6.agentStubMap;
            d4 && (f6 = d4.get(s.uid));
          }
          return f6;
        }
      }
      var Cp = Bae, twe = function() {
        function s() {
          this.group = new fs(), this.uid = M7("viewComponent");
        }
        return s.prototype.init = function(a, n6) {
        }, s.prototype.render = function(a, n6, f6, d4) {
        }, s.prototype.dispose = function(a, n6) {
        }, s.prototype.updateView = function(a, n6, f6, d4) {
        }, s.prototype.updateLayout = function(a, n6, f6, d4) {
        }, s.prototype.updateVisual = function(a, n6, f6, d4) {
        }, s.prototype.blurSeries = function(a, n6) {
        }, s.prototype.eachRendered = function(a) {
          var n6 = this.group;
          n6 && n6.traverse(a);
        }, s;
      }();
      $9(twe), Y9(twe);
      var sd = twe;
      function R7() {
        var s = hu();
        return function(a) {
          var n6 = s(a), f6 = a.pipelineContext, d4 = !!n6.large, y4 = !!n6.progressiveRender, _ = n6.large = !!(f6 && f6.large), S = n6.progressiveRender = !!(f6 && f6.progressiveRender);
          return (d4 !== _ || y4 !== S) && "reset";
        };
      }
      var UGe = hu(), m6t = R7(), nwe = function() {
        function s() {
          this.group = new fs(), this.uid = M7("viewChart"), this.renderTask = v$({ plan: b6t, reset: _6t }), this.renderTask.context = { view: this };
        }
        return s.prototype.init = function(a, n6) {
        }, s.prototype.render = function(a, n6, f6, d4) {
        }, s.prototype.highlight = function(a, n6, f6, d4) {
          var y4 = a.getData(d4 && d4.dataType);
          !y4 || $Ge(y4, d4, "emphasis");
        }, s.prototype.downplay = function(a, n6, f6, d4) {
          var y4 = a.getData(d4 && d4.dataType);
          !y4 || $Ge(y4, d4, "normal");
        }, s.prototype.remove = function(a, n6) {
          this.group.removeAll();
        }, s.prototype.dispose = function(a, n6) {
        }, s.prototype.updateView = function(a, n6, f6, d4) {
          this.render(a, n6, f6, d4);
        }, s.prototype.updateLayout = function(a, n6, f6, d4) {
          this.render(a, n6, f6, d4);
        }, s.prototype.updateVisual = function(a, n6, f6, d4) {
          this.render(a, n6, f6, d4);
        }, s.prototype.eachRendered = function(a) {
          mC(this.group, a);
        }, s.markUpdateMethod = function(a, n6) {
          UGe(a).updateMethod = n6;
        }, s.protoInitialize = function() {
          var a = s.prototype;
          a.type = "chart";
        }(), s;
      }();
      function qGe(s, a, n6) {
        s && MR(s) && (a === "emphasis" ? sS : lS)(s, n6);
      }
      function $Ge(s, a, n6) {
        var f6 = hE(s, a), d4 = a && a.highlightKey != null ? zq(a.highlightKey) : null;
        f6 != null ? gt(jc(f6), function(y4) {
          qGe(s.getItemGraphicEl(y4), n6, d4);
        }) : s.eachItemGraphicEl(function(y4) {
          qGe(y4, n6, d4);
        });
      }
      $9(nwe), Y9(nwe);
      function b6t(s) {
        return m6t(s.model);
      }
      function _6t(s) {
        var a = s.model, n6 = s.ecModel, f6 = s.api, d4 = s.payload, y4 = a.pipelineContext.progressiveRender, _ = s.view, S = d4 && UGe(d4).updateMethod, T = y4 ? "incrementalPrepareRender" : S && _[S] ? S : "render";
        return T !== "render" && _[T](a, n6, f6, d4), x6t[T];
      }
      var x6t = { incrementalPrepareRender: { progress: function(s, a) {
        a.view.incrementalRender(s, a.model, a.ecModel, a.api, a.payload);
      } }, render: { forceFirstProgress: true, progress: function(s, a) {
        a.view.render(a.model, a.ecModel, a.api, a.payload);
      } } }, Ch = nwe, zae = "\0__throttleOriginMethod", XGe = "\0__throttleRate", YGe = "\0__throttleType";
      function rwe(s, a, n6) {
        var f6, d4 = 0, y4 = 0, _ = null, S, T, E, O;
        a = a || 0;
        function R() {
          y4 = new Date().getTime(), _ = null, s.apply(T, E || []);
        }
        var V = function() {
          for (var z3 = [], H = 0; H < arguments.length; H++)
            z3[H] = arguments[H];
          f6 = new Date().getTime(), T = this, E = z3;
          var Z = O || a, ee = O || n6;
          O = null, S = f6 - (ee ? d4 : y4) - Z, clearTimeout(_), ee ? _ = setTimeout(R, Z) : S >= 0 ? R() : _ = setTimeout(R, -S), d4 = f6;
        };
        return V.clear = function() {
          _ && (clearTimeout(_), _ = null);
        }, V.debounceNextCall = function(z3) {
          O = z3;
        }, V;
      }
      function N7(s, a, n6, f6) {
        var d4 = s[a];
        if (d4) {
          var y4 = d4[zae] || d4, _ = d4[YGe], S = d4[XGe];
          if (S !== n6 || _ !== f6) {
            if (n6 == null || !f6)
              return s[a] = y4;
            d4 = s[a] = rwe(y4, n6, f6 === "debounce"), d4[zae] = y4, d4[YGe] = f6, d4[XGe] = n6;
          }
          return d4;
        }
      }
      function y$(s, a) {
        var n6 = s[a];
        n6 && n6[zae] && (n6.clear && n6.clear(), s[a] = n6[zae]);
      }
      var KGe = hu(), ZGe = { itemStyle: vE(bje, true), lineStyle: vE(mje, true) }, w6t = { lineStyle: "stroke", itemStyle: "fill" };
      function JGe(s, a) {
        var n6 = s.visualStyleMapper || ZGe[a];
        return n6 || (console.warn("Unkown style type '" + a + "'."), ZGe.itemStyle);
      }
      function QGe(s, a) {
        var n6 = s.visualDrawType || w6t[a];
        return n6 || (console.warn("Unkown style type '" + a + "'."), "fill");
      }
      var S6t = { createOnAllSeries: true, performRawSeries: true, reset: function(s, a) {
        var n6 = s.getData(), f6 = s.visualStyleAccessPath || "itemStyle", d4 = s.getModel(f6), y4 = JGe(s, f6), _ = y4(d4), S = d4.getShallow("decal");
        S && (n6.setVisual("decal", S), S.dirty = true);
        var T = QGe(s, f6), E = _[T], O = jo(E) ? E : null, R = _.fill === "auto" || _.stroke === "auto";
        if (!_[T] || O || R) {
          var V = s.getColorFromPalette(s.name, null, a.getSeriesCount());
          _[T] || (_[T] = V, n6.setVisual("colorFromPalette", true)), _.fill = _.fill === "auto" || jo(_.fill) ? V : _.fill, _.stroke = _.stroke === "auto" || jo(_.stroke) ? V : _.stroke;
        }
        if (n6.setVisual("style", _), n6.setVisual("drawType", T), !a.isSeriesFiltered(s) && O)
          return n6.setVisual("colorFromPalette", false), { dataEach: function(z3, H) {
            var Z = s.getDataParams(H), ee = ei({}, _);
            ee[T] = O(Z), z3.setItemVisual(H, "style", ee);
          } };
      } }, m$ = new Sh(), C6t = { createOnAllSeries: true, performRawSeries: true, reset: function(s, a) {
        if (!(s.ignoreStyleOnData || a.isSeriesFiltered(s))) {
          var n6 = s.getData(), f6 = s.visualStyleAccessPath || "itemStyle", d4 = JGe(s, f6), y4 = n6.getVisual("drawType");
          return { dataEach: n6.hasItemOption ? function(_, S) {
            var T = _.getRawDataItem(S);
            if (T && T[f6]) {
              m$.option = T[f6];
              var E = d4(m$), O = _.ensureUniqueItemVisual(S, "style");
              ei(O, E), m$.option.decal && (_.setItemVisual(S, "decal", m$.option.decal), m$.option.decal.dirty = true), y4 in E && _.setItemVisual(S, "colorFromPalette", false);
            }
          } : null };
        }
      } }, M6t = { performRawSeries: true, overallReset: function(s) {
        var a = ro();
        s.eachSeries(function(n6) {
          var f6 = n6.getColorBy();
          if (!n6.isColorBySeries()) {
            var d4 = n6.type + "-" + f6, y4 = a.get(d4);
            y4 || (y4 = {}, a.set(d4, y4)), KGe(n6).scope = y4;
          }
        }), s.eachSeries(function(n6) {
          if (!(n6.isColorBySeries() || s.isSeriesFiltered(n6))) {
            var f6 = n6.getRawData(), d4 = {}, y4 = n6.getData(), _ = KGe(n6).scope, S = n6.visualStyleAccessPath || "itemStyle", T = QGe(n6, S);
            y4.each(function(E) {
              var O = y4.getRawIndex(E);
              d4[O] = E;
            }), f6.each(function(E) {
              var O = d4[E], R = y4.getItemVisual(O, "colorFromPalette");
              if (R) {
                var V = y4.ensureUniqueItemVisual(O, "style"), z3 = f6.getName(E) || E + "", H = f6.count();
                V[T] = n6.getColorFromPalette(z3, _, H);
              }
            });
          }
        });
      } }, jae = Math.PI;
      function T6t(s, a) {
        a = a || {}, zo(a, { text: "loading", textColor: "#000", fontSize: 12, fontWeight: "normal", fontStyle: "normal", fontFamily: "sans-serif", maskColor: "rgba(255, 255, 255, 0.8)", showSpinner: true, color: "#5470c6", spinnerRadius: 10, lineWidth: 5, zlevel: 0 });
        var n6 = new fs(), f6 = new xu({ style: { fill: a.maskColor }, zlevel: a.zlevel, z: 1e4 });
        n6.add(f6);
        var d4 = new ju({ style: { text: a.text, fill: a.textColor, fontSize: a.fontSize, fontWeight: a.fontWeight, fontStyle: a.fontStyle, fontFamily: a.fontFamily }, zlevel: a.zlevel, z: 10001 }), y4 = new xu({ style: { fill: "none" }, textContent: d4, textConfig: { position: "right", distance: 10 }, zlevel: a.zlevel, z: 10001 });
        n6.add(y4);
        var _;
        return a.showSpinner && (_ = new Kq({ shape: { startAngle: -jae / 2, endAngle: -jae / 2 + 0.1, r: a.spinnerRadius }, style: { stroke: a.color, lineCap: "round", lineWidth: a.lineWidth }, zlevel: a.zlevel, z: 10001 }), _.animateShape(true).when(1e3, { endAngle: jae * 3 / 2 }).start("circularInOut"), _.animateShape(true).when(1e3, { startAngle: jae * 3 / 2 }).delay(300).start("circularInOut"), n6.add(_)), n6.resize = function() {
          var S = d4.getBoundingRect().width, T = a.showSpinner ? a.spinnerRadius : 0, E = (s.getWidth() - T * 2 - (a.showSpinner && S ? 10 : 0) - S) / 2 - (a.showSpinner && S ? 0 : 5 + S / 2) + (a.showSpinner ? 0 : S / 2) + (S ? 0 : T), O = s.getHeight() / 2;
          a.showSpinner && _.setShape({ cx: E, cy: O }), y4.setShape({ x: E - T, y: O - T, width: T * 2, height: T * 2 }), f6.setShape({ x: 0, y: 0, width: s.getWidth(), height: s.getHeight() });
        }, n6.resize(), n6;
      }
      var A6t = function() {
        function s(a, n6, f6, d4) {
          this._stageTaskMap = ro(), this.ecInstance = a, this.api = n6, f6 = this._dataProcessorHandlers = f6.slice(), d4 = this._visualHandlers = d4.slice(), this._allHandlers = f6.concat(d4);
        }
        return s.prototype.restoreData = function(a, n6) {
          a.restoreData(n6), this._stageTaskMap.each(function(f6) {
            var d4 = f6.overallTask;
            d4 && d4.dirty();
          });
        }, s.prototype.getPerformArgs = function(a, n6) {
          if (a.__pipeline) {
            var f6 = this._pipelineMap.get(a.__pipeline.id), d4 = f6.context, y4 = !n6 && f6.progressiveEnabled && (!d4 || d4.progressiveRender) && a.__idxInPipeline > f6.blockIndex, _ = y4 ? f6.step : null, S = d4 && d4.modDataCount, T = S != null ? Math.ceil(S / _) : null;
            return { step: _, modBy: T, modDataCount: S };
          }
        }, s.prototype.getPipeline = function(a) {
          return this._pipelineMap.get(a);
        }, s.prototype.updateStreamModes = function(a, n6) {
          var f6 = this._pipelineMap.get(a.uid), d4 = a.getData(), y4 = d4.count(), _ = f6.progressiveEnabled && n6.incrementalPrepareRender && y4 >= f6.threshold, S = a.get("large") && y4 >= a.get("largeThreshold"), T = a.get("progressiveChunkMode") === "mod" ? y4 : null;
          a.pipelineContext = f6.context = { progressiveRender: _, modDataCount: T, large: S };
        }, s.prototype.restorePipelines = function(a) {
          var n6 = this, f6 = n6._pipelineMap = ro();
          a.eachSeries(function(d4) {
            var y4 = d4.getProgressive(), _ = d4.uid;
            f6.set(_, { id: _, head: null, tail: null, threshold: d4.getProgressiveThreshold(), progressiveEnabled: y4 && !(d4.preventIncremental && d4.preventIncremental()), blockIndex: -1, step: Math.round(y4 || 700), count: 0 }), n6._pipe(d4, d4.dataTask);
          });
        }, s.prototype.prepareStageTasks = function() {
          var a = this._stageTaskMap, n6 = this.api.getModel(), f6 = this.api;
          gt(this._allHandlers, function(d4) {
            var y4 = a.get(d4.uid) || a.set(d4.uid, {}), _ = "";
            Ty(!(d4.reset && d4.overallReset), _), d4.reset && this._createSeriesStageTask(d4, y4, n6, f6), d4.overallReset && this._createOverallStageTask(d4, y4, n6, f6);
          }, this);
        }, s.prototype.prepareView = function(a, n6, f6, d4) {
          var y4 = a.renderTask, _ = y4.context;
          _.model = n6, _.ecModel = f6, _.api = d4, y4.__block = !a.incrementalPrepareRender, this._pipe(n6, y4);
        }, s.prototype.performDataProcessorTasks = function(a, n6) {
          this._performStageTasks(this._dataProcessorHandlers, a, n6, { block: true });
        }, s.prototype.performVisualTasks = function(a, n6, f6) {
          this._performStageTasks(this._visualHandlers, a, n6, f6);
        }, s.prototype._performStageTasks = function(a, n6, f6, d4) {
          d4 = d4 || {};
          var y4 = false, _ = this;
          gt(a, function(T, E) {
            if (!(d4.visualType && d4.visualType !== T.visualType)) {
              var O = _._stageTaskMap.get(T.uid), R = O.seriesTaskMap, V = O.overallTask;
              if (V) {
                var z3, H = V.agentStubMap;
                H.each(function(ee) {
                  S(d4, ee) && (ee.dirty(), z3 = true);
                }), z3 && V.dirty(), _.updatePayload(V, f6);
                var Z = _.getPerformArgs(V, d4.block);
                H.each(function(ee) {
                  ee.perform(Z);
                }), V.perform(Z) && (y4 = true);
              } else
                R && R.each(function(ee, oe) {
                  S(d4, ee) && ee.dirty();
                  var fe = _.getPerformArgs(ee, d4.block);
                  fe.skip = !T.performRawSeries && n6.isSeriesFiltered(ee.context.model), _.updatePayload(ee, f6), ee.perform(fe) && (y4 = true);
                });
            }
          });
          function S(T, E) {
            return T.setDirty && (!T.dirtyMap || T.dirtyMap.get(E.__pipeline.id));
          }
          this.unfinished = y4 || this.unfinished;
        }, s.prototype.performSeriesTasks = function(a) {
          var n6;
          a.eachSeries(function(f6) {
            n6 = f6.dataTask.perform() || n6;
          }), this.unfinished = n6 || this.unfinished;
        }, s.prototype.plan = function() {
          this._pipelineMap.each(function(a) {
            var n6 = a.tail;
            do {
              if (n6.__block) {
                a.blockIndex = n6.__idxInPipeline;
                break;
              }
              n6 = n6.getUpstream();
            } while (n6);
          });
        }, s.prototype.updatePayload = function(a, n6) {
          n6 !== "remain" && (a.context.payload = n6);
        }, s.prototype._createSeriesStageTask = function(a, n6, f6, d4) {
          var y4 = this, _ = n6.seriesTaskMap, S = n6.seriesTaskMap = ro(), T = a.seriesType, E = a.getTargetSeries;
          a.createOnAllSeries ? f6.eachRawSeries(O) : T ? f6.eachRawSeriesByType(T, O) : E && E(f6, d4).each(O);
          function O(R) {
            var V = R.uid, z3 = S.set(V, _ && _.get(V) || v$({ plan: O6t, reset: P6t, count: R6t }));
            z3.context = { model: R, ecModel: f6, api: d4, useClearVisual: a.isVisual && !a.isLayout, plan: a.plan, reset: a.reset, scheduler: y4 }, y4._pipe(R, z3);
          }
        }, s.prototype._createOverallStageTask = function(a, n6, f6, d4) {
          var y4 = this, _ = n6.overallTask = n6.overallTask || v$({ reset: I6t });
          _.context = { ecModel: f6, api: d4, overallReset: a.overallReset, scheduler: y4 };
          var S = _.agentStubMap, T = _.agentStubMap = ro(), E = a.seriesType, O = a.getTargetSeries, R = true, V = false, z3 = "";
          Ty(!a.createOnAllSeries, z3), E ? f6.eachRawSeriesByType(E, H) : O ? O(f6, d4).each(H) : (R = false, gt(f6.getSeries(), H));
          function H(Z) {
            var ee = Z.uid, oe = T.set(ee, S && S.get(ee) || (V = true, v$({ reset: E6t, onDirty: k6t })));
            oe.context = { model: Z, overallProgress: R }, oe.agent = _, oe.__block = R, y4._pipe(Z, oe);
          }
          V && _.dirty();
        }, s.prototype._pipe = function(a, n6) {
          var f6 = a.uid, d4 = this._pipelineMap.get(f6);
          !d4.head && (d4.head = n6), d4.tail && d4.tail.pipe(n6), d4.tail = n6, n6.__idxInPipeline = d4.count++, n6.__pipeline = d4;
        }, s.wrapStageHandler = function(a, n6) {
          return jo(a) && (a = { overallReset: a, seriesType: N6t(a) }), a.uid = M7("stageHandler"), n6 && (a.visualType = n6), a;
        }, s;
      }();
      function I6t(s) {
        s.overallReset(s.ecModel, s.api, s.payload);
      }
      function E6t(s) {
        return s.overallProgress && D6t;
      }
      function D6t() {
        this.agent.dirty(), this.getDownstream().dirty();
      }
      function k6t() {
        this.agent && this.agent.dirty();
      }
      function O6t(s) {
        return s.plan ? s.plan(s.model, s.ecModel, s.api, s.payload) : null;
      }
      function P6t(s) {
        s.useClearVisual && s.data.clearAllVisual();
        var a = s.resetDefines = jc(s.reset(s.model, s.ecModel, s.api, s.payload));
        return a.length > 1 ? Pi(a, function(n6, f6) {
          return eHe(f6);
        }) : L6t;
      }
      var L6t = eHe(0);
      function eHe(s) {
        return function(a, n6) {
          var f6 = n6.data, d4 = n6.resetDefines[s];
          if (d4 && d4.dataEach)
            for (var y4 = a.start; y4 < a.end; y4++)
              d4.dataEach(f6, y4);
          else
            d4 && d4.progress && d4.progress(a, f6);
        };
      }
      function R6t(s) {
        return s.data.count();
      }
      function N6t(s) {
        Gae = null;
        try {
          s(b$, tHe);
        } catch {
        }
        return Gae;
      }
      var b$ = {}, tHe = {}, Gae;
      nHe(b$, eGe), nHe(tHe, tGe), b$.eachSeriesByType = b$.eachRawSeriesByType = function(s) {
        Gae = s;
      }, b$.eachComponent = function(s) {
        s.mainType === "series" && s.subType && (Gae = s.subType);
      };
      function nHe(s, a) {
        for (var n6 in a.prototype)
          s[n6] = rd;
      }
      var rHe = A6t, iHe = ["#37A2DA", "#32C5E9", "#67E0E3", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#E062AE", "#E690D1", "#e7bcf3", "#9d96f5", "#8378EA", "#96BFFF"], F6t = { color: iHe, colorLayer: [["#37A2DA", "#ffd85c", "#fd7b5f"], ["#37A2DA", "#67E0E3", "#FFDB5C", "#ff9f7f", "#E062AE", "#9d96f5"], ["#37A2DA", "#32C5E9", "#9FE6B8", "#FFDB5C", "#ff9f7f", "#fb7293", "#e7bcf3", "#8378EA", "#96BFFF"], iHe] }, Y1 = "#B9B8CE", aHe = "#100C2A", Hae = function() {
        return { axisLine: { lineStyle: { color: Y1 } }, splitLine: { lineStyle: { color: "#484753" } }, splitArea: { areaStyle: { color: ["rgba(255,255,255,0.02)", "rgba(255,255,255,0.05)"] } }, minorSplitLine: { lineStyle: { color: "#20203B" } } };
      }, oHe = ["#4992ff", "#7cffb2", "#fddd60", "#ff6e76", "#58d9f9", "#05c091", "#ff8a45", "#8d48e3", "#dd79ff"], sHe = { darkMode: true, color: oHe, backgroundColor: aHe, axisPointer: { lineStyle: { color: "#817f91" }, crossStyle: { color: "#817f91" }, label: { color: "#fff" } }, legend: { textStyle: { color: Y1 } }, textStyle: { color: Y1 }, title: { textStyle: { color: "#EEF1FA" }, subtextStyle: { color: "#B9B8CE" } }, toolbox: { iconStyle: { borderColor: Y1 } }, dataZoom: { borderColor: "#71708A", textStyle: { color: Y1 }, brushStyle: { color: "rgba(135,163,206,0.3)" }, handleStyle: { color: "#353450", borderColor: "#C5CBE3" }, moveHandleStyle: { color: "#B0B6C3", opacity: 0.3 }, fillerColor: "rgba(135,163,206,0.2)", emphasis: { handleStyle: { borderColor: "#91B7F2", color: "#4D587D" }, moveHandleStyle: { color: "#636D9A", opacity: 0.7 } }, dataBackground: { lineStyle: { color: "#71708A", width: 1 }, areaStyle: { color: "#71708A" } }, selectedDataBackground: { lineStyle: { color: "#87A3CE" }, areaStyle: { color: "#87A3CE" } } }, visualMap: { textStyle: { color: Y1 } }, timeline: { lineStyle: { color: Y1 }, label: { color: Y1 }, controlStyle: { color: Y1, borderColor: Y1 } }, calendar: { itemStyle: { color: aHe }, dayLabel: { color: Y1 }, monthLabel: { color: Y1 }, yearLabel: { color: Y1 } }, timeAxis: Hae(), logAxis: Hae(), valueAxis: Hae(), categoryAxis: Hae(), line: { symbol: "circle" }, graph: { color: oHe }, gauge: { title: { color: Y1 }, axisLine: { lineStyle: { color: [[1, "rgba(207,212,219,0.2)"]] } }, axisLabel: { color: Y1 }, detail: { color: "#EEF1FA" } }, candlestick: { itemStyle: { color: "#f64e56", color0: "#54ea92", borderColor: "#f64e56", borderColor0: "#54ea92" } } };
      sHe.categoryAxis.splitLine.show = false;
      var V6t = sHe, B6t = function() {
        function s() {
        }
        return s.prototype.normalizeQuery = function(a) {
          var n6 = {}, f6 = {}, d4 = {};
          if (Wa(a)) {
            var y4 = Rm(a);
            n6.mainType = y4.main || null, n6.subType = y4.sub || null;
          } else {
            var _ = ["Index", "Name", "Id"], S = { name: 1, dataIndex: 1, dataType: 1 };
            gt(a, function(T, E) {
              for (var O = false, R = 0; R < _.length; R++) {
                var V = _[R], z3 = E.lastIndexOf(V);
                if (z3 > 0 && z3 === E.length - V.length) {
                  var H = E.slice(0, z3);
                  H !== "data" && (n6.mainType = H, n6[V.toLowerCase()] = T, O = true);
                }
              }
              S.hasOwnProperty(E) && (f6[E] = T, O = true), O || (d4[E] = T);
            });
          }
          return { cptQuery: n6, dataQuery: f6, otherQuery: d4 };
        }, s.prototype.filter = function(a, n6) {
          var f6 = this.eventInfo;
          if (!f6)
            return true;
          var d4 = f6.targetEl, y4 = f6.packedEvent, _ = f6.model, S = f6.view;
          if (!_ || !S)
            return true;
          var T = n6.cptQuery, E = n6.dataQuery;
          return O(T, _, "mainType") && O(T, _, "subType") && O(T, _, "index", "componentIndex") && O(T, _, "name") && O(T, _, "id") && O(E, y4, "name") && O(E, y4, "dataIndex") && O(E, y4, "dataType") && (!S.filterForExposedEvent || S.filterForExposedEvent(a, n6.otherQuery, d4, y4));
          function O(R, V, z3, H) {
            return R[z3] == null || V[H || z3] === R[z3];
          }
        }, s.prototype.afterTrigger = function() {
          this.eventInfo = null;
        }, s;
      }(), iwe = ["symbol", "symbolSize", "symbolRotate", "symbolOffset"], lHe = iwe.concat(["symbolKeepAspect"]), z6t = { createOnAllSeries: true, performRawSeries: true, reset: function(s, a) {
        var n6 = s.getData();
        if (s.legendIcon && n6.setVisual("legendIcon", s.legendIcon), !s.hasSymbolVisual)
          return;
        for (var f6 = {}, d4 = {}, y4 = false, _ = 0; _ < iwe.length; _++) {
          var S = iwe[_], T = s.get(S);
          jo(T) ? (y4 = true, d4[S] = T) : f6[S] = T;
        }
        if (f6.symbol = f6.symbol || s.defaultSymbol, n6.setVisual(ei({ legendIcon: s.legendIcon || f6.symbol, symbolKeepAspect: s.get("symbolKeepAspect") }, f6)), a.isSeriesFiltered(s))
          return;
        var E = Wl(d4);
        function O(R, V) {
          for (var z3 = s.getRawValue(V), H = s.getDataParams(V), Z = 0; Z < E.length; Z++) {
            var ee = E[Z];
            R.setItemVisual(V, ee, d4[ee](z3, H));
          }
        }
        return { dataEach: y4 ? O : null };
      } }, j6t = { createOnAllSeries: true, performRawSeries: true, reset: function(s, a) {
        if (!s.hasSymbolVisual || a.isSeriesFiltered(s))
          return;
        var n6 = s.getData();
        function f6(d4, y4) {
          for (var _ = d4.getItemModel(y4), S = 0; S < lHe.length; S++) {
            var T = lHe[S], E = _.getShallow(T, true);
            E != null && d4.setItemVisual(y4, T, E);
          }
        }
        return { dataEach: n6.hasItemOption ? f6 : null };
      } };
      function awe(s, a, n6) {
        switch (n6) {
          case "color":
            var f6 = s.getItemVisual(a, "style");
            return f6[s.getVisual("drawType")];
          case "opacity":
            return s.getItemVisual(a, "style").opacity;
          case "symbol":
          case "symbolSize":
          case "liftZ":
            return s.getItemVisual(a, n6);
        }
      }
      function _$(s, a) {
        switch (a) {
          case "color":
            var n6 = s.getVisual("style");
            return n6[s.getVisual("drawType")];
          case "opacity":
            return s.getVisual("style").opacity;
          case "symbol":
          case "symbolSize":
          case "liftZ":
            return s.getVisual(a);
        }
      }
      function uHe(s, a, n6, f6) {
        switch (n6) {
          case "color":
            var d4 = s.ensureUniqueItemVisual(a, "style");
            d4[s.getVisual("drawType")] = f6, s.setItemVisual(a, "colorFromPalette", false);
            break;
          case "opacity":
            s.ensureUniqueItemVisual(a, "style").opacity = f6;
            break;
          case "symbol":
          case "symbolSize":
          case "liftZ":
            s.setItemVisual(a, n6, f6);
            break;
        }
      }
      function cHe(s, a) {
        function n6(f6, d4) {
          var y4 = [];
          return f6.eachComponent({ mainType: "series", subType: s, query: d4 }, function(_) {
            y4.push(_.seriesIndex);
          }), y4;
        }
        gt([[s + "ToggleSelect", "toggleSelect"], [s + "Select", "select"], [s + "UnSelect", "unselect"]], function(f6) {
          a(f6[0], function(d4, y4, _) {
            d4 = ei({}, d4), _.dispatchAction(ei(d4, { type: f6[1], seriesIndex: n6(y4, d4) }));
          });
        });
      }
      function F7(s, a, n6, f6, d4) {
        var y4 = s + a;
        n6.isSilent(y4) || f6.eachComponent({ mainType: "series", subType: "pie" }, function(_) {
          for (var S = _.seriesIndex, T = _.option.selectedMap, E = d4.selected, O = 0; O < E.length; O++)
            if (E[O].seriesIndex === S) {
              var R = _.getData(), V = hE(R, d4.fromActionPayload);
              n6.trigger(y4, { type: y4, seriesId: _.id, name: Di(V) ? R.getName(V[0]) : R.getName(V), selected: Wa(T) ? T : ei({}, T) });
            }
        });
      }
      function G6t(s, a, n6) {
        s.on("selectchanged", function(f6) {
          var d4 = n6.getModel();
          f6.isFromClick ? (F7("map", "selectchanged", a, d4, f6), F7("pie", "selectchanged", a, d4, f6)) : f6.fromAction === "select" ? (F7("map", "selected", a, d4, f6), F7("pie", "selected", a, d4, f6)) : f6.fromAction === "unselect" && (F7("map", "unselected", a, d4, f6), F7("pie", "unselected", a, d4, f6));
        });
      }
      function V7(s, a, n6) {
        for (var f6; s && !(a(s) && (f6 = s, n6)); )
          s = s.__hostTarget || s.parent;
        return f6;
      }
      var H6t = Math.round(Math.random() * 9), W6t = typeof Object.defineProperty == "function", U6t = function() {
        function s() {
          this._id = "__ec_inner_" + H6t++;
        }
        return s.prototype.get = function(a) {
          return this._guard(a)[this._id];
        }, s.prototype.set = function(a, n6) {
          var f6 = this._guard(a);
          return W6t ? Object.defineProperty(f6, this._id, { value: n6, enumerable: false, configurable: true }) : f6[this._id] = n6, this;
        }, s.prototype.delete = function(a) {
          return this.has(a) ? (delete this._guard(a)[this._id], true) : false;
        }, s.prototype.has = function(a) {
          return !!this._guard(a)[this._id];
        }, s.prototype._guard = function(a) {
          if (a !== Object(a))
            throw TypeError("Value of WeakMap is not a non-null object.");
          return a;
        }, s;
      }(), q6t = U6t, $6t = ml.extend({ type: "triangle", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(s, a) {
        var n6 = a.cx, f6 = a.cy, d4 = a.width / 2, y4 = a.height / 2;
        s.moveTo(n6, f6 - y4), s.lineTo(n6 + d4, f6 + y4), s.lineTo(n6 - d4, f6 + y4), s.closePath();
      } }), X6t = ml.extend({ type: "diamond", shape: { cx: 0, cy: 0, width: 0, height: 0 }, buildPath: function(s, a) {
        var n6 = a.cx, f6 = a.cy, d4 = a.width / 2, y4 = a.height / 2;
        s.moveTo(n6, f6 - y4), s.lineTo(n6 + d4, f6), s.lineTo(n6, f6 + y4), s.lineTo(n6 - d4, f6), s.closePath();
      } }), Y6t = ml.extend({ type: "pin", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(s, a) {
        var n6 = a.x, f6 = a.y, d4 = a.width / 5 * 3, y4 = Math.max(d4, a.height), _ = d4 / 2, S = _ * _ / (y4 - _), T = f6 - y4 + _ + S, E = Math.asin(S / _), O = Math.cos(E) * _, R = Math.sin(E), V = Math.cos(E), z3 = _ * 0.6, H = _ * 0.7;
        s.moveTo(n6 - O, T + S), s.arc(n6, T, _, Math.PI - E, Math.PI * 2 + E), s.bezierCurveTo(n6 + O - R * z3, T + S + V * z3, n6, f6 - H, n6, f6), s.bezierCurveTo(n6, f6 - H, n6 - O + R * z3, T + S + V * z3, n6 - O, T + S), s.closePath();
      } }), K6t = ml.extend({ type: "arrow", shape: { x: 0, y: 0, width: 0, height: 0 }, buildPath: function(s, a) {
        var n6 = a.height, f6 = a.width, d4 = a.x, y4 = a.y, _ = f6 / 3 * 2;
        s.moveTo(d4, y4), s.lineTo(d4 + _, y4 + n6), s.lineTo(d4, y4 + n6 / 4 * 3), s.lineTo(d4 - _, y4 + n6), s.lineTo(d4, y4), s.closePath();
      } }), Z6t = { line: Jv, rect: xu, roundRect: xu, square: xu, circle: cS, diamond: X6t, pin: Y6t, arrow: K6t, triangle: $6t }, J6t = { line: function(s, a, n6, f6, d4) {
        d4.x1 = s, d4.y1 = a + f6 / 2, d4.x2 = s + n6, d4.y2 = a + f6 / 2;
      }, rect: function(s, a, n6, f6, d4) {
        d4.x = s, d4.y = a, d4.width = n6, d4.height = f6;
      }, roundRect: function(s, a, n6, f6, d4) {
        d4.x = s, d4.y = a, d4.width = n6, d4.height = f6, d4.r = Math.min(n6, f6) / 4;
      }, square: function(s, a, n6, f6, d4) {
        var y4 = Math.min(n6, f6);
        d4.x = s, d4.y = a, d4.width = y4, d4.height = y4;
      }, circle: function(s, a, n6, f6, d4) {
        d4.cx = s + n6 / 2, d4.cy = a + f6 / 2, d4.r = Math.min(n6, f6) / 2;
      }, diamond: function(s, a, n6, f6, d4) {
        d4.cx = s + n6 / 2, d4.cy = a + f6 / 2, d4.width = n6, d4.height = f6;
      }, pin: function(s, a, n6, f6, d4) {
        d4.x = s + n6 / 2, d4.y = a + f6 / 2, d4.width = n6, d4.height = f6;
      }, arrow: function(s, a, n6, f6, d4) {
        d4.x = s + n6 / 2, d4.y = a + f6 / 2, d4.width = n6, d4.height = f6;
      }, triangle: function(s, a, n6, f6, d4) {
        d4.cx = s + n6 / 2, d4.cy = a + f6 / 2, d4.width = n6, d4.height = f6;
      } }, Wae = {};
      gt(Z6t, function(s, a) {
        Wae[a] = new s();
      });
      var Q6t = ml.extend({ type: "symbol", shape: { symbolType: "", x: 0, y: 0, width: 0, height: 0 }, calculateTextPosition: function(s, a, n6) {
        var f6 = lR(s, a, n6), d4 = this.shape;
        return d4 && d4.symbolType === "pin" && a.position === "inside" && (f6.y = n6.y + n6.height * 0.4), f6;
      }, buildPath: function(s, a, n6) {
        var f6 = a.symbolType;
        if (f6 !== "none") {
          var d4 = Wae[f6];
          d4 || (f6 = "rect", d4 = Wae[f6]), J6t[f6](a.x, a.y, a.width, a.height, d4.shape), d4.buildPath(s, d4.shape, n6);
        }
      } });
      function eNt(s, a) {
        if (this.type !== "image") {
          var n6 = this.style;
          this.__isEmptyBrush ? (n6.stroke = s, n6.fill = a || "#fff", n6.lineWidth = 2) : this.shape.symbolType === "line" ? n6.stroke = s : n6.fill = s, this.markRedraw();
        }
      }
      function bv(s, a, n6, f6, d4, y4, _) {
        var S = s.indexOf("empty") === 0;
        S && (s = s.substr(5, 1).toLowerCase() + s.substr(6));
        var T;
        return s.indexOf("image://") === 0 ? T = Qe(s.slice(8), new il(a, n6, f6, d4), _ ? "center" : "cover") : s.indexOf("path://") === 0 ? T = Ie(s.slice(7), {}, new il(a, n6, f6, d4), _ ? "center" : "cover") : T = new Q6t({ shape: { symbolType: s, x: a, y: n6, width: f6, height: d4 } }), T.__isEmptyBrush = S, T.setColor = eNt, y4 && T.setColor(y4), T;
      }
      function x$(s) {
        return Di(s) || (s = [+s, +s]), [s[0] || 0, s[1] || 0];
      }
      function B7(s, a) {
        if (s != null)
          return Di(s) || (s = [s, s]), [Ia(s[0], a[0]) || 0, Ia(Zs(s[1], s[0]), a[1]) || 0];
      }
      function tNt(s, a, n6) {
        var f6 = a.x == null ? 0 : a.x, d4 = a.x2 == null ? 1 : a.x2, y4 = a.y == null ? 0 : a.y, _ = a.y2 == null ? 0 : a.y2;
        a.global || (f6 = f6 * n6.width + n6.x, d4 = d4 * n6.width + n6.x, y4 = y4 * n6.height + n6.y, _ = _ * n6.height + n6.y), f6 = isNaN(f6) ? 0 : f6, d4 = isNaN(d4) ? 1 : d4, y4 = isNaN(y4) ? 0 : y4, _ = isNaN(_) ? 0 : _;
        var S = s.createLinearGradient(f6, y4, d4, _);
        return S;
      }
      function nNt(s, a, n6) {
        var f6 = n6.width, d4 = n6.height, y4 = Math.min(f6, d4), _ = a.x == null ? 0.5 : a.x, S = a.y == null ? 0.5 : a.y, T = a.r == null ? 0.5 : a.r;
        a.global || (_ = _ * f6 + n6.x, S = S * d4 + n6.y, T = T * y4);
        var E = s.createRadialGradient(_, S, 0, _, S, T);
        return E;
      }
      function owe(s, a, n6) {
        for (var f6 = a.type === "radial" ? nNt(s, a, n6) : tNt(s, a, n6), d4 = a.colorStops, y4 = 0; y4 < d4.length; y4++)
          f6.addColorStop(d4[y4].offset, d4[y4].color);
        return f6;
      }
      function rNt(s, a) {
        if (s === a || !s && !a)
          return false;
        if (!s || !a || s.length !== a.length)
          return true;
        for (var n6 = 0; n6 < s.length; n6++)
          if (s[n6] !== a[n6])
            return true;
        return false;
      }
      function Uae(s) {
        return parseInt(s, 10);
      }
      function z7(s, a, n6) {
        var f6 = ["width", "height"][a], d4 = ["clientWidth", "clientHeight"][a], y4 = ["paddingLeft", "paddingTop"][a], _ = ["paddingRight", "paddingBottom"][a];
        if (n6[f6] != null && n6[f6] !== "auto")
          return parseFloat(n6[f6]);
        var S = document.defaultView.getComputedStyle(s);
        return (s[d4] || Uae(S[f6]) || Uae(s.style[f6])) - (Uae(S[y4]) || 0) - (Uae(S[_]) || 0) | 0;
      }
      function iNt(s, a) {
        return !s || s === "solid" || !(a > 0) ? null : s === "dashed" ? [4 * a, 2 * a] : s === "dotted" ? [a] : ac(s) ? [s] : Di(s) ? s : null;
      }
      function swe(s) {
        var a = s.style, n6 = a.lineDash && a.lineWidth > 0 && iNt(a.lineDash, a.lineWidth), f6 = a.lineDashOffset;
        if (n6) {
          var d4 = a.strokeNoScale && s.getLineScale ? s.getLineScale() : 1;
          d4 && d4 !== 1 && (n6 = Pi(n6, function(y4) {
            return y4 / d4;
          }), f6 /= d4);
        }
        return [n6, f6];
      }
      var aNt = new aS(true);
      function qae(s) {
        var a = s.stroke;
        return !(a == null || a === "none" || !(s.lineWidth > 0));
      }
      function fHe(s) {
        return typeof s == "string" && s !== "none";
      }
      function $ae(s) {
        var a = s.fill;
        return a != null && a !== "none";
      }
      function hHe(s, a) {
        if (a.fillOpacity != null && a.fillOpacity !== 1) {
          var n6 = s.globalAlpha;
          s.globalAlpha = a.fillOpacity * a.opacity, s.fill(), s.globalAlpha = n6;
        } else
          s.fill();
      }
      function pHe(s, a) {
        if (a.strokeOpacity != null && a.strokeOpacity !== 1) {
          var n6 = s.globalAlpha;
          s.globalAlpha = a.strokeOpacity * a.opacity, s.stroke(), s.globalAlpha = n6;
        } else
          s.stroke();
      }
      function lwe(s, a, n6) {
        var f6 = uq(a.image, a.__image, n6);
        if (K9(f6)) {
          var d4 = s.createPattern(f6, a.repeat || "repeat");
          if (typeof DOMMatrix == "function" && d4 && d4.setTransform) {
            var y4 = new DOMMatrix();
            y4.translateSelf(a.x || 0, a.y || 0), y4.rotateSelf(0, 0, (a.rotation || 0) * jL), y4.scaleSelf(a.scaleX || 1, a.scaleY || 1), d4.setTransform(y4);
          }
          return d4;
        }
      }
      function oNt(s, a, n6, f6) {
        var d4, y4 = qae(n6), _ = $ae(n6), S = n6.strokePercent, T = S < 1, E = !a.path;
        (!a.silent || T) && E && a.createPathProxy();
        var O = a.path || aNt, R = a.__dirty;
        if (!f6) {
          var V = n6.fill, z3 = n6.stroke, H = _ && !!V.colorStops, Z = y4 && !!z3.colorStops, ee = _ && !!V.image, oe = y4 && !!z3.image, fe = void 0, _e = void 0, pe = void 0, Ve = void 0, Le = void 0;
          (H || Z) && (Le = a.getBoundingRect()), H && (fe = R ? owe(s, V, Le) : a.__canvasFillGradient, a.__canvasFillGradient = fe), Z && (_e = R ? owe(s, z3, Le) : a.__canvasStrokeGradient, a.__canvasStrokeGradient = _e), ee && (pe = R || !a.__canvasFillPattern ? lwe(s, V, a) : a.__canvasFillPattern, a.__canvasFillPattern = pe), oe && (Ve = R || !a.__canvasStrokePattern ? lwe(s, z3, a) : a.__canvasStrokePattern, a.__canvasStrokePattern = pe), H ? s.fillStyle = fe : ee && (pe ? s.fillStyle = pe : _ = false), Z ? s.strokeStyle = _e : oe && (Ve ? s.strokeStyle = Ve : y4 = false);
        }
        var je = a.getGlobalScale();
        O.setScale(je[0], je[1], a.segmentIgnoreThreshold);
        var Xe, Ye;
        s.setLineDash && n6.lineDash && (d4 = swe(a), Xe = d4[0], Ye = d4[1]);
        var rt2 = true;
        (E || R & U_) && (O.setDPR(s.dpr), T ? O.setContext(null) : (O.setContext(s), rt2 = false), O.reset(), a.buildPath(O, a.shape, f6), O.toStatic(), a.pathUpdated()), rt2 && O.rebuildPath(s, T ? S : 1), Xe && (s.setLineDash(Xe), s.lineDashOffset = Ye), f6 || (n6.strokeFirst ? (y4 && pHe(s, n6), _ && hHe(s, n6)) : (_ && hHe(s, n6), y4 && pHe(s, n6))), Xe && s.setLineDash([]);
      }
      function sNt(s, a, n6) {
        var f6 = a.__image = uq(n6.image, a.__image, a, a.onload);
        if (!(!f6 || !K9(f6))) {
          var d4 = n6.x || 0, y4 = n6.y || 0, _ = a.getWidth(), S = a.getHeight(), T = f6.width / f6.height;
          if (_ == null && S != null ? _ = S * T : S == null && _ != null ? S = _ / T : _ == null && S == null && (_ = f6.width, S = f6.height), n6.sWidth && n6.sHeight) {
            var E = n6.sx || 0, O = n6.sy || 0;
            s.drawImage(f6, E, O, n6.sWidth, n6.sHeight, d4, y4, _, S);
          } else if (n6.sx && n6.sy) {
            var E = n6.sx, O = n6.sy, R = _ - E, V = S - O;
            s.drawImage(f6, E, O, R, V, d4, y4, _, S);
          } else
            s.drawImage(f6, d4, y4, _, S);
        }
      }
      function lNt(s, a, n6) {
        var f6, d4 = n6.text;
        if (d4 != null && (d4 += ""), d4) {
          s.font = n6.font || mc, s.textAlign = n6.textAlign, s.textBaseline = n6.textBaseline;
          var y4 = void 0, _ = void 0;
          s.setLineDash && n6.lineDash && (f6 = swe(a), y4 = f6[0], _ = f6[1]), y4 && (s.setLineDash(y4), s.lineDashOffset = _), n6.strokeFirst ? (qae(n6) && s.strokeText(d4, n6.x, n6.y), $ae(n6) && s.fillText(d4, n6.x, n6.y)) : ($ae(n6) && s.fillText(d4, n6.x, n6.y), qae(n6) && s.strokeText(d4, n6.x, n6.y)), y4 && s.setLineDash([]);
        }
      }
      var dHe = ["shadowBlur", "shadowOffsetX", "shadowOffsetY"], vHe = [["lineCap", "butt"], ["lineJoin", "miter"], ["miterLimit", 10]];
      function gHe(s, a, n6, f6, d4) {
        var y4 = false;
        if (!f6 && (n6 = n6 || {}, a === n6))
          return false;
        if (f6 || a.opacity !== n6.opacity) {
          Ub(s, d4), y4 = true;
          var _ = Math.max(Math.min(a.opacity, 1), 0);
          s.globalAlpha = isNaN(_) ? gE.opacity : _;
        }
        (f6 || a.blend !== n6.blend) && (y4 || (Ub(s, d4), y4 = true), s.globalCompositeOperation = a.blend || gE.blend);
        for (var S = 0; S < dHe.length; S++) {
          var T = dHe[S];
          (f6 || a[T] !== n6[T]) && (y4 || (Ub(s, d4), y4 = true), s[T] = s.dpr * (a[T] || 0));
        }
        return (f6 || a.shadowColor !== n6.shadowColor) && (y4 || (Ub(s, d4), y4 = true), s.shadowColor = a.shadowColor || gE.shadowColor), y4;
      }
      function yHe(s, a, n6, f6, d4) {
        var y4 = w$(a, d4.inHover), _ = f6 ? null : n6 && w$(n6, d4.inHover) || {};
        if (y4 === _)
          return false;
        var S = gHe(s, y4, _, f6, d4);
        if ((f6 || y4.fill !== _.fill) && (S || (Ub(s, d4), S = true), fHe(y4.fill) && (s.fillStyle = y4.fill)), (f6 || y4.stroke !== _.stroke) && (S || (Ub(s, d4), S = true), fHe(y4.stroke) && (s.strokeStyle = y4.stroke)), (f6 || y4.opacity !== _.opacity) && (S || (Ub(s, d4), S = true), s.globalAlpha = y4.opacity == null ? 1 : y4.opacity), a.hasStroke()) {
          var T = y4.lineWidth, E = T / (y4.strokeNoScale && a.getLineScale ? a.getLineScale() : 1);
          s.lineWidth !== E && (S || (Ub(s, d4), S = true), s.lineWidth = E);
        }
        for (var O = 0; O < vHe.length; O++) {
          var R = vHe[O], V = R[0];
          (f6 || y4[V] !== _[V]) && (S || (Ub(s, d4), S = true), s[V] = y4[V] || R[1]);
        }
        return S;
      }
      function uNt(s, a, n6, f6, d4) {
        return gHe(s, w$(a, d4.inHover), n6 && w$(n6, d4.inHover), f6, d4);
      }
      function mHe(s, a) {
        var n6 = a.transform, f6 = s.dpr || 1;
        n6 ? s.setTransform(f6 * n6[0], f6 * n6[1], f6 * n6[2], f6 * n6[3], f6 * n6[4], f6 * n6[5]) : s.setTransform(f6, 0, 0, f6, 0, 0);
      }
      function cNt(s, a, n6) {
        for (var f6 = false, d4 = 0; d4 < s.length; d4++) {
          var y4 = s[d4];
          f6 = f6 || y4.isZeroArea(), mHe(a, y4), a.beginPath(), y4.buildPath(a, y4.shape), a.clip();
        }
        n6.allClipped = f6;
      }
      function fNt(s, a) {
        return s && a ? s[0] !== a[0] || s[1] !== a[1] || s[2] !== a[2] || s[3] !== a[3] || s[4] !== a[4] || s[5] !== a[5] : !(!s && !a);
      }
      var bHe = 1, _He = 2, xHe = 3, wHe = 4;
      function hNt(s) {
        var a = $ae(s), n6 = qae(s);
        return !(s.lineDash || !(+a ^ +n6) || a && typeof s.fill != "string" || n6 && typeof s.stroke != "string" || s.strokePercent < 1 || s.strokeOpacity < 1 || s.fillOpacity < 1);
      }
      function Ub(s, a) {
        a.batchFill && s.fill(), a.batchStroke && s.stroke(), a.batchFill = "", a.batchStroke = "";
      }
      function w$(s, a) {
        return a && s.__hoverStyle || s.style;
      }
      function SHe(s, a) {
        zR(s, a, { inHover: false, viewWidth: 0, viewHeight: 0 }, true);
      }
      function zR(s, a, n6, f6) {
        var d4 = a.transform;
        if (!a.shouldBePainted(n6.viewWidth, n6.viewHeight, false, false)) {
          a.__dirty &= ~x0, a.__isRendered = false;
          return;
        }
        var y4 = a.__clipPaths, _ = n6.prevElClipPaths, S = false, T = false;
        if ((!_ || rNt(y4, _)) && (_ && _.length && (Ub(s, n6), s.restore(), T = S = true, n6.prevElClipPaths = null, n6.allClipped = false, n6.prevEl = null), y4 && y4.length && (Ub(s, n6), s.save(), cNt(y4, s, n6), S = true), n6.prevElClipPaths = y4), n6.allClipped) {
          a.__isRendered = false;
          return;
        }
        a.beforeBrush && a.beforeBrush(), a.innerBeforeBrush();
        var E = n6.prevEl;
        E || (T = S = true);
        var O = a instanceof ml && a.autoBatch && hNt(a.style);
        S || fNt(d4, E.transform) ? (Ub(s, n6), mHe(s, a)) : O || Ub(s, n6);
        var R = w$(a, n6.inHover);
        a instanceof ml ? (n6.lastDrawType !== bHe && (T = true, n6.lastDrawType = bHe), yHe(s, a, E, T, n6), (!O || !n6.batchFill && !n6.batchStroke) && s.beginPath(), oNt(s, a, R, O), O && (n6.batchFill = R.fill || "", n6.batchStroke = R.stroke || "")) : a instanceof _R ? (n6.lastDrawType !== xHe && (T = true, n6.lastDrawType = xHe), yHe(s, a, E, T, n6), lNt(s, a, R)) : a instanceof Zv ? (n6.lastDrawType !== _He && (T = true, n6.lastDrawType = _He), uNt(s, a, E, T, n6), sNt(s, a, R)) : a.getTemporalDisplayables && (n6.lastDrawType !== wHe && (T = true, n6.lastDrawType = wHe), pNt(s, a, n6)), O && f6 && Ub(s, n6), a.innerAfterBrush(), a.afterBrush && a.afterBrush(), n6.prevEl = a, a.__dirty = 0, a.__isRendered = true;
      }
      function pNt(s, a, n6) {
        var f6 = a.getDisplayables(), d4 = a.getTemporalDisplayables();
        s.save();
        var y4 = { prevElClipPaths: null, prevEl: null, allClipped: false, viewWidth: n6.viewWidth, viewHeight: n6.viewHeight, inHover: n6.inHover }, _, S;
        for (_ = a.getCursor(), S = f6.length; _ < S; _++) {
          var T = f6[_];
          T.beforeBrush && T.beforeBrush(), T.innerBeforeBrush(), zR(s, T, y4, _ === S - 1), T.innerAfterBrush(), T.afterBrush && T.afterBrush(), y4.prevEl = T;
        }
        for (var E = 0, O = d4.length; E < O; E++) {
          var T = d4[E];
          T.beforeBrush && T.beforeBrush(), T.innerBeforeBrush(), zR(s, T, y4, E === O - 1), T.innerAfterBrush(), T.afterBrush && T.afterBrush(), y4.prevEl = T;
        }
        a.clearTemporalDisplayables(), a.notClear = true, s.restore();
      }
      var uwe = new q6t(), CHe = new aC(100), MHe = ["symbol", "symbolSize", "symbolKeepAspect", "color", "backgroundColor", "dashArrayX", "dashArrayY", "maxTileWidth", "maxTileHeight"];
      function S$(s, a) {
        if (s === "none")
          return null;
        var n6 = a.getDevicePixelRatio(), f6 = a.getZr(), d4 = f6.painter.type === "svg";
        s.dirty && uwe.delete(s);
        var y4 = uwe.get(s);
        if (y4)
          return y4;
        var _ = zo(s, { symbol: "rect", symbolSize: 1, symbolKeepAspect: true, color: "rgba(0, 0, 0, 0.2)", backgroundColor: null, dashArrayX: 5, dashArrayY: 5, rotation: 0, maxTileWidth: 512, maxTileHeight: 512 });
        _.backgroundColor === "none" && (_.backgroundColor = null);
        var S = { repeat: "repeat" };
        return T(S), S.rotation = _.rotation, S.scaleX = S.scaleY = d4 ? 1 : 1 / n6, uwe.set(s, S), s.dirty = false, S;
        function T(E) {
          for (var O = [n6], R = true, V = 0; V < MHe.length; ++V) {
            var z3 = _[MHe[V]];
            if (z3 != null && !Di(z3) && !Wa(z3) && !ac(z3) && typeof z3 != "boolean") {
              R = false;
              break;
            }
            O.push(z3);
          }
          var H;
          if (R) {
            H = O.join(",") + (d4 ? "-svg" : "");
            var Z = CHe.get(H);
            Z && (d4 ? E.svgElement = Z : E.image = Z);
          }
          var ee = AHe(_.dashArrayX), oe = dNt(_.dashArrayY), fe = THe(_.symbol), _e = vNt(ee), pe = IHe(oe), Ve = !d4 && td.createCanvas(), Le = d4 && { tag: "g", attrs: {}, key: "dcl", children: [] }, je = Ye(), Xe;
          Ve && (Ve.width = je.width * n6, Ve.height = je.height * n6, Xe = Ve.getContext("2d")), rt2(), R && CHe.put(H, Ve || Le), E.image = Ve, E.svgElement = Le, E.svgWidth = je.width, E.svgHeight = je.height;
          function Ye() {
            for (var ut = 1, wt = 0, dt = _e.length; wt < dt; ++wt)
              ut = pie(ut, _e[wt]);
            for (var Gt = 1, wt = 0, dt = fe.length; wt < dt; ++wt)
              Gt = pie(Gt, fe[wt].length);
            ut *= Gt;
            var Qt = pe * _e.length * fe.length;
            return { width: Math.max(1, Math.min(ut, _.maxTileWidth)), height: Math.max(1, Math.min(Qt, _.maxTileHeight)) };
          }
          function rt2() {
            Xe && (Xe.clearRect(0, 0, Ve.width, Ve.height), _.backgroundColor && (Xe.fillStyle = _.backgroundColor, Xe.fillRect(0, 0, Ve.width, Ve.height)));
            for (var ut = 0, wt = 0; wt < oe.length; ++wt)
              ut += oe[wt];
            if (ut <= 0)
              return;
            for (var dt = -pe, Gt = 0, Qt = 0, Nt = 0; dt < je.height; ) {
              if (Gt % 2 === 0) {
                for (var er = Qt / 2 % fe.length, un = 0, pn = 0, On = 0; un < je.width * 2; ) {
                  for (var fr = 0, wt = 0; wt < ee[Nt].length; ++wt)
                    fr += ee[Nt][wt];
                  if (fr <= 0)
                    break;
                  if (pn % 2 === 0) {
                    var yr = (1 - _.symbolSize) * 0.5, da = un + ee[Nt][pn] * yr, Ja = dt + oe[Gt] * yr, ko = ee[Nt][pn] * _.symbolSize, wo = oe[Gt] * _.symbolSize, So = On / 2 % fe[er].length;
                    Fa(da, Ja, ko, wo, fe[er][So]);
                  }
                  un += ee[Nt][pn], ++On, ++pn, pn === ee[Nt].length && (pn = 0);
                }
                ++Nt, Nt === ee.length && (Nt = 0);
              }
              dt += oe[Gt], ++Qt, ++Gt, Gt === oe.length && (Gt = 0);
            }
            function Fa(po, To, Ya, $o, Hu) {
              var ms = d4 ? 1 : n6, sc = bv(Hu, po * ms, To * ms, Ya * ms, $o * ms, _.color, _.symbolKeepAspect);
              if (d4) {
                var Oc = f6.painter.renderOneToVNode(sc);
                Oc && Le.children.push(Oc);
              } else
                SHe(Xe, sc);
            }
          }
        }
      }
      function THe(s) {
        if (!s || s.length === 0)
          return [["rect"]];
        if (Wa(s))
          return [[s]];
        for (var a = true, n6 = 0; n6 < s.length; ++n6)
          if (!Wa(s[n6])) {
            a = false;
            break;
          }
        if (a)
          return THe([s]);
        for (var f6 = [], n6 = 0; n6 < s.length; ++n6)
          Wa(s[n6]) ? f6.push([s[n6]]) : f6.push(s[n6]);
        return f6;
      }
      function AHe(s) {
        if (!s || s.length === 0)
          return [[0, 0]];
        if (ac(s)) {
          var a = Math.ceil(s);
          return [[a, a]];
        }
        for (var n6 = true, f6 = 0; f6 < s.length; ++f6)
          if (!ac(s[f6])) {
            n6 = false;
            break;
          }
        if (n6)
          return AHe([s]);
        for (var d4 = [], f6 = 0; f6 < s.length; ++f6)
          if (ac(s[f6])) {
            var a = Math.ceil(s[f6]);
            d4.push([a, a]);
          } else {
            var a = Pi(s[f6], function(S) {
              return Math.ceil(S);
            });
            a.length % 2 === 1 ? d4.push(a.concat(a)) : d4.push(a);
          }
        return d4;
      }
      function dNt(s) {
        if (!s || typeof s == "object" && s.length === 0)
          return [0, 0];
        if (ac(s)) {
          var a = Math.ceil(s);
          return [a, a];
        }
        var n6 = Pi(s, function(f6) {
          return Math.ceil(f6);
        });
        return s.length % 2 ? n6.concat(n6) : n6;
      }
      function vNt(s) {
        return Pi(s, function(a) {
          return IHe(a);
        });
      }
      function IHe(s) {
        for (var a = 0, n6 = 0; n6 < s.length; ++n6)
          a += s[n6];
        return s.length % 2 === 1 ? a * 2 : a;
      }
      function gNt(s, a) {
        s.eachRawSeries(function(n6) {
          if (!s.isSeriesFiltered(n6)) {
            var f6 = n6.getData();
            f6.hasItemVisual() && f6.each(function(_) {
              var S = f6.getItemVisual(_, "decal");
              if (S) {
                var T = f6.ensureUniqueItemVisual(_, "style");
                T.decal = S$(S, a);
              }
            });
            var d4 = f6.getVisual("decal");
            if (d4) {
              var y4 = f6.getVisual("style");
              y4.decal = S$(d4, a);
            }
          }
        });
      }
      var yNt = new Dm(), _C = yNt, EHe = {};
      function mNt(s, a) {
        EHe[s] = a;
      }
      function bNt(s) {
        return EHe[s];
      }
      var _Nt = typeof window != "undefined", xNt = 1, wNt = 800, SNt = 900, CNt = 1e3, MNt = 2e3, TNt = 5e3, DHe = 1e3, ANt = 1100, cwe = 2e3, kHe = 3e3, INt = 4e3, Xae = 4500, ENt = 4600, DNt = 5e3, kNt = 6e3, OHe = 7e3, ONt = { PROCESSOR: { FILTER: CNt, SERIES_FILTER: wNt, STATISTIC: TNt }, VISUAL: { LAYOUT: DHe, PROGRESSIVE_LAYOUT: ANt, GLOBAL: cwe, CHART: kHe, POST_CHART_LAYOUT: ENt, COMPONENT: INt, BRUSH: DNt, CHART_ITEM: Xae, ARIA: kNt, DECAL: OHe } }, Um = "__flagInMainProcess", qb = "__pendingUpdate", fwe = "__needsUpdateStatus", PHe = /^[a-zA-Z0-9_]+$/, hwe = "__connectUpdateStatus", LHe = 0, PNt = 1, LNt = 2;
      function RHe(s) {
        return function() {
          for (var a = [], n6 = 0; n6 < arguments.length; n6++)
            a[n6] = arguments[n6];
          if (this.isDisposed()) {
            this.id;
            return;
          }
          return FHe(this, s, a);
        };
      }
      function NHe(s) {
        return function() {
          for (var a = [], n6 = 0; n6 < arguments.length; n6++)
            a[n6] = arguments[n6];
          return FHe(this, s, a);
        };
      }
      function FHe(s, a, n6) {
        return n6[0] = n6[0] && n6[0].toLowerCase(), Dm.prototype[a].apply(s, n6);
      }
      var VHe = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a;
      }(Dm), BHe = VHe.prototype;
      BHe.on = NHe("on"), BHe.off = NHe("off");
      var j7, pwe, Yae, Qk, dwe, vwe, gwe, C$, M$, zHe, jHe, ywe, GHe, Kae, HHe, WHe, yS, UHe, qHe = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this, new B6t()) || this;
          y4._chartsViews = [], y4._chartsMap = {}, y4._componentsViews = [], y4._componentsMap = {}, y4._pendingActions = [], d4 = d4 || {}, Wa(f6) && (f6 = $He[f6]), y4._dom = n6;
          var _ = "canvas", S = false, T = y4._zr = fE(n6, { renderer: d4.renderer || _, devicePixelRatio: d4.devicePixelRatio, width: d4.width, height: d4.height, ssr: d4.ssr, useDirtyRect: d4.useDirtyRect == null ? S : d4.useDirtyRect });
          y4._ssr = d4.ssr, y4._throttledZrFlush = rwe(Za(T.flush, T), 17), f6 = Bo(f6), f6 && lGe(f6, true), y4._theme = f6, y4._locale = WRt(d4.locale || _je), y4._coordSysMgr = new f$();
          var E = y4._api = HHe(y4);
          function O(R, V) {
            return R.__prio - V.__prio;
          }
          return Ey(Jae, O), Ey(bwe, O), y4._scheduler = new rHe(y4, E, bwe, Jae), y4._messageCenter = new VHe(), y4._initEvents(), y4.resize = Za(y4.resize, y4), T.animation.on("frame", y4._onframe, y4), zHe(T, y4), jHe(T, y4), $w(y4), y4;
        }
        return a.prototype._onframe = function() {
          if (!this._disposed) {
            UHe(this);
            var n6 = this._scheduler;
            if (this[qb]) {
              var f6 = this[qb].silent;
              this[Um] = true;
              try {
                j7(this), Qk.update.call(this, null, this[qb].updateParams);
              } catch (T) {
                throw this[Um] = false, this[qb] = null, T;
              }
              this._zr.flush(), this[Um] = false, this[qb] = null, C$.call(this, f6), M$.call(this, f6);
            } else if (n6.unfinished) {
              var d4 = xNt, y4 = this._model, _ = this._api;
              n6.unfinished = false;
              do {
                var S = +new Date();
                n6.performSeriesTasks(y4), n6.performDataProcessorTasks(y4), vwe(this, y4), n6.performVisualTasks(y4), Kae(this, this._model, _, "remain", {}), d4 -= +new Date() - S;
              } while (d4 > 0 && n6.unfinished);
              n6.unfinished || this._zr.flush();
            }
          }
        }, a.prototype.getDom = function() {
          return this._dom;
        }, a.prototype.getId = function() {
          return this.id;
        }, a.prototype.getZr = function() {
          return this._zr;
        }, a.prototype.isSSR = function() {
          return this._ssr;
        }, a.prototype.setOption = function(n6, f6, d4) {
          if (!this[Um]) {
            if (this._disposed) {
              this.id;
              return;
            }
            var y4, _, S;
            if (Qo(f6) && (d4 = f6.lazyUpdate, y4 = f6.silent, _ = f6.replaceMerge, S = f6.transition, f6 = f6.notMerge), this[Um] = true, !this._model || f6) {
              var T = new C4t(this._api), E = this._theme, O = this._model = new eGe();
              O.scheduler = this._scheduler, O.ssr = this._ssr, O.init(null, null, null, E, this._locale, T);
            }
            this._model.setOption(n6, { replaceMerge: _ }, _we);
            var R = { seriesTransition: S, optionChanged: true };
            if (d4)
              this[qb] = { silent: y4, updateParams: R }, this[Um] = false, this.getZr().wakeUp();
            else {
              try {
                j7(this), Qk.update.call(this, null, R);
              } catch (V) {
                throw this[qb] = null, this[Um] = false, V;
              }
              this._ssr || this._zr.flush(), this[qb] = null, this[Um] = false, C$.call(this, y4), M$.call(this, y4);
            }
          }
        }, a.prototype.setTheme = function() {
        }, a.prototype.getModel = function() {
          return this._model;
        }, a.prototype.getOption = function() {
          return this._model && this._model.getOption();
        }, a.prototype.getWidth = function() {
          return this._zr.getWidth();
        }, a.prototype.getHeight = function() {
          return this._zr.getHeight();
        }, a.prototype.getDevicePixelRatio = function() {
          return this._zr.painter.dpr || _Nt && window.devicePixelRatio || 1;
        }, a.prototype.getRenderedCanvas = function(n6) {
          return this.renderToCanvas(n6);
        }, a.prototype.renderToCanvas = function(n6) {
          n6 = n6 || {};
          var f6 = this._zr.painter;
          return f6.getRenderedCanvas({ backgroundColor: n6.backgroundColor || this._model.get("backgroundColor"), pixelRatio: n6.pixelRatio || this.getDevicePixelRatio() });
        }, a.prototype.renderToSVGString = function(n6) {
          n6 = n6 || {};
          var f6 = this._zr.painter;
          return f6.renderToString({ useViewBox: n6.useViewBox });
        }, a.prototype.getSvgDataURL = function() {
          if (Na.svgSupported) {
            var n6 = this._zr, f6 = n6.storage.getDisplayList();
            return gt(f6, function(d4) {
              d4.stopAnimation(null, true);
            }), n6.painter.toDataURL();
          }
        }, a.prototype.getDataURL = function(n6) {
          if (this._disposed) {
            this.id;
            return;
          }
          n6 = n6 || {};
          var f6 = n6.excludeComponents, d4 = this._model, y4 = [], _ = this;
          gt(f6, function(T) {
            d4.eachComponent({ mainType: T }, function(E) {
              var O = _._componentsMap[E.__viewId];
              O.group.ignore || (y4.push(O), O.group.ignore = true);
            });
          });
          var S = this._zr.painter.getType() === "svg" ? this.getSvgDataURL() : this.renderToCanvas(n6).toDataURL("image/" + (n6 && n6.type || "png"));
          return gt(y4, function(T) {
            T.group.ignore = false;
          }), S;
        }, a.prototype.getConnectedDataURL = function(n6) {
          if (this._disposed) {
            this.id;
            return;
          }
          var f6 = n6.type === "svg", d4 = this.group, y4 = Math.min, _ = Math.max, S = 1 / 0;
          if (XHe[d4]) {
            var T = S, E = S, O = -S, R = -S, V = [], z3 = n6 && n6.pixelRatio || this.getDevicePixelRatio();
            gt(A$, function(_e, pe) {
              if (_e.group === d4) {
                var Ve = f6 ? _e.getZr().painter.getSvgDom().innerHTML : _e.renderToCanvas(Bo(n6)), Le = _e.getDom().getBoundingClientRect();
                T = y4(Le.left, T), E = y4(Le.top, E), O = _(Le.right, O), R = _(Le.bottom, R), V.push({ dom: Ve, left: Le.left, top: Le.top });
              }
            }), T *= z3, E *= z3, O *= z3, R *= z3;
            var H = O - T, Z = R - E, ee = td.createCanvas(), oe = fE(ee, { renderer: f6 ? "svg" : "canvas" });
            if (oe.resize({ width: H, height: Z }), f6) {
              var fe = "";
              return gt(V, function(_e) {
                var pe = _e.left - T, Ve = _e.top - E;
                fe += '<g transform="translate(' + pe + "," + Ve + ')">' + _e.dom + "</g>";
              }), oe.painter.getSvgRoot().innerHTML = fe, n6.connectedBackgroundColor && oe.painter.setBackgroundColor(n6.connectedBackgroundColor), oe.refreshImmediately(), oe.painter.toDataURL();
            } else
              return n6.connectedBackgroundColor && oe.add(new xu({ shape: { x: 0, y: 0, width: H, height: Z }, style: { fill: n6.connectedBackgroundColor } })), gt(V, function(_e) {
                var pe = new Zv({ style: { x: _e.left * z3 - T, y: _e.top * z3 - E, image: _e.dom } });
                oe.add(pe);
              }), oe.refreshImmediately(), ee.toDataURL("image/" + (n6 && n6.type || "png"));
          } else
            return this.getDataURL(n6);
        }, a.prototype.convertToPixel = function(n6, f6) {
          return dwe(this, "convertToPixel", n6, f6);
        }, a.prototype.convertFromPixel = function(n6, f6) {
          return dwe(this, "convertFromPixel", n6, f6);
        }, a.prototype.containPixel = function(n6, f6) {
          if (this._disposed) {
            this.id;
            return;
          }
          var d4 = this._model, y4, _ = gR(d4, n6);
          return gt(_, function(S, T) {
            T.indexOf("Models") >= 0 && gt(S, function(E) {
              var O = E.coordinateSystem;
              if (O && O.containPoint)
                y4 = y4 || !!O.containPoint(f6);
              else if (T === "seriesModels") {
                var R = this._chartsMap[E.__viewId];
                R && R.containPoint && (y4 = y4 || R.containPoint(f6, E));
              }
            }, this);
          }, this), !!y4;
        }, a.prototype.getVisual = function(n6, f6) {
          var d4 = this._model, y4 = gR(d4, n6, { defaultMainType: "series" }), _ = y4.seriesModel, S = _.getData(), T = y4.hasOwnProperty("dataIndexInside") ? y4.dataIndexInside : y4.hasOwnProperty("dataIndex") ? S.indexOfRawIndex(y4.dataIndex) : null;
          return T != null ? awe(S, T, f6) : _$(S, f6);
        }, a.prototype.getViewOfComponentModel = function(n6) {
          return this._componentsMap[n6.__viewId];
        }, a.prototype.getViewOfSeriesModel = function(n6) {
          return this._chartsMap[n6.__viewId];
        }, a.prototype._initEvents = function() {
          var n6 = this;
          gt(RNt, function(f6) {
            var d4 = function(y4) {
              var _ = n6.getModel(), S = y4.target, T, E = f6 === "globalout";
              if (E ? T = {} : S && V7(S, function(H) {
                var Z = qo(H);
                if (Z && Z.dataIndex != null) {
                  var ee = Z.dataModel || _.getSeriesByIndex(Z.seriesIndex);
                  return T = ee && ee.getDataParams(Z.dataIndex, Z.dataType) || {}, true;
                } else if (Z.eventData)
                  return T = ei({}, Z.eventData), true;
              }, true), T) {
                var O = T.componentType, R = T.componentIndex;
                (O === "markLine" || O === "markPoint" || O === "markArea") && (O = "series", R = T.seriesIndex);
                var V = O && R != null && _.getComponent(O, R), z3 = V && n6[V.mainType === "series" ? "_chartsMap" : "_componentsMap"][V.__viewId];
                T.event = y4, T.type = f6, n6._$eventProcessor.eventInfo = { targetEl: S, packedEvent: T, model: V, view: z3 }, n6.trigger(f6, T);
              }
            };
            d4.zrEventfulCallAtLast = true, n6._zr.on(f6, d4, n6);
          }), gt(T$, function(f6, d4) {
            n6._messageCenter.on(d4, function(y4) {
              this.trigger(d4, y4);
            }, n6);
          }), gt(["selectchanged"], function(f6) {
            n6._messageCenter.on(f6, function(d4) {
              this.trigger(f6, d4);
            }, n6);
          }), G6t(this._messageCenter, this, this._api);
        }, a.prototype.isDisposed = function() {
          return this._disposed;
        }, a.prototype.clear = function() {
          if (this._disposed) {
            this.id;
            return;
          }
          this.setOption({ series: [] }, true);
        }, a.prototype.dispose = function() {
          if (this._disposed) {
            this.id;
            return;
          }
          this._disposed = true;
          var n6 = this.getDom();
          n6 && gie(this.getDom(), wwe, "");
          var f6 = this, d4 = f6._api, y4 = f6._model;
          gt(f6._componentsViews, function(_) {
            _.dispose(y4, d4);
          }), gt(f6._chartsViews, function(_) {
            _.dispose(y4, d4);
          }), f6._zr.dispose(), f6._dom = f6._model = f6._chartsMap = f6._componentsMap = f6._chartsViews = f6._componentsViews = f6._scheduler = f6._api = f6._zr = f6._throttledZrFlush = f6._theme = f6._coordSysMgr = f6._messageCenter = null, delete A$[f6.id];
        }, a.prototype.resize = function(n6) {
          if (!this[Um]) {
            if (this._disposed) {
              this.id;
              return;
            }
            this._zr.resize(n6);
            var f6 = this._model;
            if (this._loadingFX && this._loadingFX.resize(), !!f6) {
              var d4 = f6.resetOption("media"), y4 = n6 && n6.silent;
              this[qb] && (y4 == null && (y4 = this[qb].silent), d4 = true, this[qb] = null), this[Um] = true;
              try {
                d4 && j7(this), Qk.update.call(this, { type: "resize", animation: ei({ duration: 0 }, n6 && n6.animation) });
              } catch (_) {
                throw this[Um] = false, _;
              }
              this[Um] = false, C$.call(this, y4), M$.call(this, y4);
            }
          }
        }, a.prototype.showLoading = function(n6, f6) {
          if (this._disposed) {
            this.id;
            return;
          }
          if (Qo(n6) && (f6 = n6, n6 = ""), n6 = n6 || "default", this.hideLoading(), !!xwe[n6]) {
            var d4 = xwe[n6](this._api, f6), y4 = this._zr;
            this._loadingFX = d4, y4.add(d4);
          }
        }, a.prototype.hideLoading = function() {
          if (this._disposed) {
            this.id;
            return;
          }
          this._loadingFX && this._zr.remove(this._loadingFX), this._loadingFX = null;
        }, a.prototype.makeActionFromEvent = function(n6) {
          var f6 = ei({}, n6);
          return f6.type = T$[n6.type], f6;
        }, a.prototype.dispatchAction = function(n6, f6) {
          if (this._disposed) {
            this.id;
            return;
          }
          if (Qo(f6) || (f6 = { silent: !!f6 }), !!Zae[n6.type] && !!this._model) {
            if (this[Um]) {
              this._pendingActions.push(n6);
              return;
            }
            var d4 = f6.silent;
            gwe.call(this, n6, d4);
            var y4 = f6.flush;
            y4 ? this._zr.flush() : y4 !== false && Na.browser.weChat && this._throttledZrFlush(), C$.call(this, d4), M$.call(this, d4);
          }
        }, a.prototype.updateLabelLayout = function() {
          _C.trigger("series:layoutlabels", this._model, this._api, { updatedSeries: [] });
        }, a.prototype.appendData = function(n6) {
          if (this._disposed) {
            this.id;
            return;
          }
          var f6 = n6.seriesIndex, d4 = this.getModel(), y4 = d4.getSeriesByIndex(f6);
          y4.appendData(n6), this._scheduler.unfinished = true, this.getZr().wakeUp();
        }, a.internalField = function() {
          j7 = function(R) {
            var V = R._scheduler;
            V.restorePipelines(R._model), V.prepareStageTasks(), pwe(R, true), pwe(R, false), V.plan();
          }, pwe = function(R, V) {
            for (var z3 = R._model, H = R._scheduler, Z = V ? R._componentsViews : R._chartsViews, ee = V ? R._componentsMap : R._chartsMap, oe = R._zr, fe = R._api, _e = 0; _e < Z.length; _e++)
              Z[_e].__alive = false;
            V ? z3.eachComponent(function(Le, je) {
              Le !== "series" && pe(je);
            }) : z3.eachSeries(pe);
            function pe(Le) {
              var je = Le.__requireNewView;
              Le.__requireNewView = false;
              var Xe = "_ec_" + Le.id + "_" + Le.type, Ye = !je && ee[Xe];
              if (!Ye) {
                var rt2 = Rm(Le.type), ut = V ? sd.getClass(rt2.main, rt2.sub) : Ch.getClass(rt2.sub);
                Ye = new ut(), Ye.init(z3, fe), ee[Xe] = Ye, Z.push(Ye), oe.add(Ye.group);
              }
              Le.__viewId = Ye.__id = Xe, Ye.__alive = true, Ye.__model = Le, Ye.group.__ecComponentInfo = { mainType: Le.mainType, index: Le.componentIndex }, !V && H.prepareView(Ye, Le, z3, fe);
            }
            for (var _e = 0; _e < Z.length; ) {
              var Ve = Z[_e];
              Ve.__alive ? _e++ : (!V && Ve.renderTask.dispose(), oe.remove(Ve.group), Ve.dispose(z3, fe), Z.splice(_e, 1), ee[Ve.__id] === Ve && delete ee[Ve.__id], Ve.__id = Ve.group.__ecComponentInfo = null);
            }
          }, Yae = function(R, V, z3, H, Z) {
            var ee = R._model;
            if (ee.setUpdatePayload(z3), !H) {
              gt([].concat(R._componentsViews).concat(R._chartsViews), Ve);
              return;
            }
            var oe = {};
            oe[H + "Id"] = z3[H + "Id"], oe[H + "Index"] = z3[H + "Index"], oe[H + "Name"] = z3[H + "Name"];
            var fe = { mainType: H, query: oe };
            Z && (fe.subType = Z);
            var _e = z3.excludeSeriesId, pe;
            _e != null && (pe = ro(), gt(jc(_e), function(Le) {
              var je = Cd(Le, null);
              je != null && pe.set(je, true);
            })), ee && ee.eachComponent(fe, function(Le) {
              var je = pe && pe.get(Le.id) !== null;
              if (!je)
                if (h7(z3))
                  if (Le instanceof Cp)
                    z3.type === SE && !z3.notBlur && !Le.get(["emphasis", "disabled"]) && Lf(Le, z3, R._api);
                  else {
                    var Xe = Vq(Le.mainType, Le.componentIndex, z3.name, R._api), Ye = Xe.focusSelf, rt2 = Xe.dispatchers;
                    z3.type === SE && Ye && !z3.notBlur && Fq(Le.mainType, Le.componentIndex, R._api), rt2 && gt(rt2, function(ut) {
                      z3.type === SE ? sS(ut) : lS(ut);
                    });
                  }
                else
                  jq(z3) && Le instanceof Cp && (G_e(Le, z3, R._api), Qie(Le), yS(R));
            }, R), ee && ee.eachComponent(fe, function(Le) {
              var je = pe && pe.get(Le.id) !== null;
              je || Ve(R[H === "series" ? "_chartsMap" : "_componentsMap"][Le.__viewId]);
            }, R);
            function Ve(Le) {
              Le && Le.__alive && Le[V] && Le[V](Le.__model, ee, R._api, z3);
            }
          }, Qk = { prepareAndUpdate: function(R) {
            j7(this), Qk.update.call(this, R, { optionChanged: R.newOption != null });
          }, update: function(R, V) {
            var z3 = this._model, H = this._api, Z = this._zr, ee = this._coordSysMgr, oe = this._scheduler;
            if (z3) {
              z3.setUpdatePayload(R), oe.restoreData(z3, R), oe.performSeriesTasks(z3), ee.create(z3, H), oe.performDataProcessorTasks(z3, R), vwe(this, z3), ee.update(z3, H), n6(z3), oe.performVisualTasks(z3, R), ywe(this, z3, H, R, V);
              var fe = z3.get("backgroundColor") || "transparent", _e = z3.get("darkMode");
              Z.setBackgroundColor(fe), _e != null && _e !== "auto" && Z.setDarkMode(_e), _C.trigger("afterupdate", z3, H);
            }
          }, updateTransform: function(R) {
            var V = this, z3 = this._model, H = this._api;
            if (z3) {
              z3.setUpdatePayload(R);
              var Z = [];
              z3.eachComponent(function(oe, fe) {
                if (oe !== "series") {
                  var _e = V.getViewOfComponentModel(fe);
                  if (_e && _e.__alive)
                    if (_e.updateTransform) {
                      var pe = _e.updateTransform(fe, z3, H, R);
                      pe && pe.update && Z.push(_e);
                    } else
                      Z.push(_e);
                }
              });
              var ee = ro();
              z3.eachSeries(function(oe) {
                var fe = V._chartsMap[oe.__viewId];
                if (fe.updateTransform) {
                  var _e = fe.updateTransform(oe, z3, H, R);
                  _e && _e.update && ee.set(oe.uid, 1);
                } else
                  ee.set(oe.uid, 1);
              }), n6(z3), this._scheduler.performVisualTasks(z3, R, { setDirty: true, dirtyMap: ee }), Kae(this, z3, H, R, {}, ee), _C.trigger("afterupdate", z3, H);
            }
          }, updateView: function(R) {
            var V = this._model;
            !V || (V.setUpdatePayload(R), Ch.markUpdateMethod(R, "updateView"), n6(V), this._scheduler.performVisualTasks(V, R, { setDirty: true }), ywe(this, V, this._api, R, {}), _C.trigger("afterupdate", V, this._api));
          }, updateVisual: function(R) {
            var V = this, z3 = this._model;
            !z3 || (z3.setUpdatePayload(R), z3.eachSeries(function(H) {
              H.getData().clearAllVisual();
            }), Ch.markUpdateMethod(R, "updateVisual"), n6(z3), this._scheduler.performVisualTasks(z3, R, { visualType: "visual", setDirty: true }), z3.eachComponent(function(H, Z) {
              if (H !== "series") {
                var ee = V.getViewOfComponentModel(Z);
                ee && ee.__alive && ee.updateVisual(Z, z3, V._api, R);
              }
            }), z3.eachSeries(function(H) {
              var Z = V._chartsMap[H.__viewId];
              Z.updateVisual(H, z3, V._api, R);
            }), _C.trigger("afterupdate", z3, this._api));
          }, updateLayout: function(R) {
            Qk.update.call(this, R);
          } }, dwe = function(R, V, z3, H) {
            if (R._disposed) {
              R.id;
              return;
            }
            for (var Z = R._model, ee = R._coordSysMgr.getCoordinateSystems(), oe, fe = gR(Z, z3), _e = 0; _e < ee.length; _e++) {
              var pe = ee[_e];
              if (pe[V] && (oe = pe[V](Z, fe, H)) != null)
                return oe;
            }
          }, vwe = function(R, V) {
            var z3 = R._chartsMap, H = R._scheduler;
            V.eachSeries(function(Z) {
              H.updateStreamModes(Z, z3[Z.__viewId]);
            });
          }, gwe = function(R, V) {
            var z3 = this, H = this.getModel(), Z = R.type, ee = R.escapeConnect, oe = Zae[Z], fe = oe.actionInfo, _e = (fe.update || "update").split(":"), pe = _e.pop(), Ve = _e[0] != null && Rm(_e[0]);
            this[Um] = true;
            var Le = [R], je = false;
            R.batch && (je = true, Le = Pi(R.batch, function(Gt) {
              return Gt = zo(ei({}, Gt), R), Gt.batch = null, Gt;
            }));
            var Xe = [], Ye, rt2 = jq(R), ut = h7(R);
            if (ut && X1(this._api), gt(Le, function(Gt) {
              if (Ye = oe.action(Gt, z3._model, z3._api), Ye = Ye || ei({}, Gt), Ye.type = fe.event || Ye.type, Xe.push(Ye), ut) {
                var Qt = pE(R), Nt = Qt.queryOptionMap, er = Qt.mainTypeSpecified, un = er ? Nt.keys()[0] : "series";
                Yae(z3, pe, Gt, un), yS(z3);
              } else
                rt2 ? (Yae(z3, pe, Gt, "series"), yS(z3)) : Ve && Yae(z3, pe, Gt, Ve.main, Ve.sub);
            }), pe !== "none" && !ut && !rt2 && !Ve)
              try {
                this[qb] ? (j7(this), Qk.update.call(this, R), this[qb] = null) : Qk[pe].call(this, R);
              } catch (Gt) {
                throw this[Um] = false, Gt;
              }
            if (je ? Ye = { type: fe.event || Z, escapeConnect: ee, batch: Xe } : Ye = Xe[0], this[Um] = false, !V) {
              var wt = this._messageCenter;
              if (wt.trigger(Ye.type, Ye), rt2) {
                var dt = { type: "selectchanged", escapeConnect: ee, selected: H_e(H), isFromClick: R.isFromClick || false, fromAction: R.type, fromActionPayload: R };
                wt.trigger(dt.type, dt);
              }
            }
          }, C$ = function(R) {
            for (var V = this._pendingActions; V.length; ) {
              var z3 = V.shift();
              gwe.call(this, z3, R);
            }
          }, M$ = function(R) {
            !R && this.trigger("updated");
          }, zHe = function(R, V) {
            R.on("rendered", function(z3) {
              V.trigger("rendered", z3), R.animation.isFinished() && !V[qb] && !V._scheduler.unfinished && !V._pendingActions.length && V.trigger("finished");
            });
          }, jHe = function(R, V) {
            R.on("mouseover", function(z3) {
              var H = z3.target, Z = V7(H, MR);
              Z && (Jie(Z, z3, V._api), yS(V));
            }).on("mouseout", function(z3) {
              var H = z3.target, Z = V7(H, MR);
              Z && (f7(Z, z3, V._api), yS(V));
            }).on("click", function(z3) {
              var H = z3.target, Z = V7(H, function(fe) {
                return qo(fe).dataIndex != null;
              }, true);
              if (Z) {
                var ee = Z.selected ? "unselect" : "select", oe = qo(Z);
                V._api.dispatchAction({ type: ee, dataType: oe.dataType, dataIndexInside: oe.dataIndex, seriesIndex: oe.seriesIndex, isFromClick: true });
              }
            });
          };
          function n6(R) {
            R.clearColorPalette(), R.eachSeries(function(V) {
              V.clearColorPalette();
            });
          }
          function f6(R) {
            var V = [], z3 = [], H = false;
            if (R.eachComponent(function(fe, _e) {
              var pe = _e.get("zlevel") || 0, Ve = _e.get("z") || 0, Le = _e.getZLevelKey();
              H = H || !!Le, (fe === "series" ? z3 : V).push({ zlevel: pe, z: Ve, idx: _e.componentIndex, type: fe, key: Le });
            }), H) {
              var Z = V.concat(z3), ee, oe;
              Ey(Z, function(fe, _e) {
                return fe.zlevel === _e.zlevel ? fe.z - _e.z : fe.zlevel - _e.zlevel;
              }), gt(Z, function(fe) {
                var _e = R.getComponent(fe.type, fe.idx), pe = fe.zlevel, Ve = fe.key;
                ee != null && (pe = Math.max(ee, pe)), Ve ? (pe === ee && Ve !== oe && pe++, oe = Ve) : oe && (pe === ee && pe++, oe = ""), ee = pe, _e.setZLevel(pe);
              });
            }
          }
          ywe = function(R, V, z3, H, Z) {
            f6(V), GHe(R, V, z3, H, Z), gt(R._chartsViews, function(ee) {
              ee.__alive = false;
            }), Kae(R, V, z3, H, Z), gt(R._chartsViews, function(ee) {
              ee.__alive || ee.remove(V, z3);
            });
          }, GHe = function(R, V, z3, H, Z, ee) {
            gt(ee || R._componentsViews, function(oe) {
              var fe = oe.__model;
              E(fe, oe), oe.render(fe, V, z3, H), S(fe, oe), O(fe, oe);
            });
          }, Kae = function(R, V, z3, H, Z, ee) {
            var oe = R._scheduler;
            Z = ei(Z || {}, { updatedSeries: V.getSeries() }), _C.trigger("series:beforeupdate", V, z3, Z);
            var fe = false;
            V.eachSeries(function(_e) {
              var pe = R._chartsMap[_e.__viewId];
              pe.__alive = true;
              var Ve = pe.renderTask;
              oe.updatePayload(Ve, H), E(_e, pe), ee && ee.get(_e.uid) && Ve.dirty(), Ve.perform(oe.getPerformArgs(Ve)) && (fe = true), pe.group.silent = !!_e.get("silent"), _(_e, pe), Qie(_e);
            }), oe.unfinished = fe || oe.unfinished, _C.trigger("series:layoutlabels", V, z3, Z), _C.trigger("series:transition", V, z3, Z), V.eachSeries(function(_e) {
              var pe = R._chartsMap[_e.__viewId];
              S(_e, pe), O(_e, pe);
            }), y4(R, V), _C.trigger("series:afterupdate", V, z3, Z);
          }, yS = function(R) {
            R[fwe] = true, R.getZr().wakeUp();
          }, UHe = function(R) {
            !R[fwe] || (R.getZr().storage.traverse(function(V) {
              $k(V) || d4(V);
            }), R[fwe] = false);
          };
          function d4(R) {
            for (var V = [], z3 = R.currentStates, H = 0; H < z3.length; H++) {
              var Z = z3[H];
              Z === "emphasis" || Z === "blur" || Z === "select" || V.push(Z);
            }
            R.selected && R.states.select && V.push("select"), R.hoverState === o7 && R.states.emphasis ? V.push("emphasis") : R.hoverState === lp && R.states.blur && V.push("blur"), R.useStates(V);
          }
          function y4(R, V) {
            var z3 = R._zr, H = z3.storage, Z = 0;
            H.traverse(function(ee) {
              ee.isGroup || Z++;
            }), Z > V.get("hoverLayerThreshold") && !Na.node && !Na.worker && V.eachSeries(function(ee) {
              if (!ee.preventUsingHoverLayer) {
                var oe = R._chartsMap[ee.__viewId];
                oe.__alive && oe.eachRendered(function(fe) {
                  fe.states.emphasis && (fe.states.emphasis.hoverLayer = true);
                });
              }
            });
          }
          function _(R, V) {
            var z3 = R.get("blendMode") || null;
            V.eachRendered(function(H) {
              H.isGroup || (H.style.blend = z3);
            });
          }
          function S(R, V) {
            if (!R.preventAutoZ) {
              var z3 = R.get("z") || 0, H = R.get("zlevel") || 0;
              V.eachRendered(function(Z) {
                return T(Z, z3, H, -1 / 0), true;
              });
            }
          }
          function T(R, V, z3, H) {
            var Z = R.getTextContent(), ee = R.getTextGuideLine(), oe = R.isGroup;
            if (oe)
              for (var fe = R.childrenRef(), _e = 0; _e < fe.length; _e++)
                H = Math.max(T(fe[_e], V, z3, H), H);
            else
              R.z = V, R.zlevel = z3, H = Math.max(R.z2, H);
            if (Z && (Z.z = V, Z.zlevel = z3, isFinite(H) && (Z.z2 = H + 2)), ee) {
              var pe = R.textGuideLineConfig;
              ee.z = V, ee.zlevel = z3, isFinite(H) && (ee.z2 = H + (pe && pe.showAbove ? 1 : -1));
            }
            return H;
          }
          function E(R, V) {
            V.eachRendered(function(z3) {
              if (!$k(z3)) {
                var H = z3.getTextContent(), Z = z3.getTextGuideLine();
                z3.stateTransition && (z3.stateTransition = null), H && H.stateTransition && (H.stateTransition = null), Z && Z.stateTransition && (Z.stateTransition = null), z3.hasState() ? (z3.prevStates = z3.currentStates, z3.clearStates()) : z3.prevStates && (z3.prevStates = null);
              }
            });
          }
          function O(R, V) {
            var z3 = R.getModel("stateAnimation"), H = R.isAnimationEnabled(), Z = z3.get("duration"), ee = Z > 0 ? { duration: Z, delay: z3.get("delay"), easing: z3.get("easing") } : null;
            V.eachRendered(function(oe) {
              if (oe.states && oe.states.emphasis) {
                if ($k(oe))
                  return;
                if (oe instanceof ml && $_e(oe), oe.__dirty) {
                  var fe = oe.prevStates;
                  fe && oe.useStates(fe);
                }
                if (H) {
                  oe.stateTransition = ee;
                  var _e = oe.getTextContent(), pe = oe.getTextGuideLine();
                  _e && (_e.stateTransition = ee), pe && (pe.stateTransition = ee);
                }
                oe.__dirty && d4(oe);
              }
            });
          }
          HHe = function(R) {
            return new (function(V) {
              Vt(z3, V);
              function z3() {
                return V !== null && V.apply(this, arguments) || this;
              }
              return z3.prototype.getCoordinateSystems = function() {
                return R._coordSysMgr.getCoordinateSystems();
              }, z3.prototype.getComponentByElement = function(H) {
                for (; H; ) {
                  var Z = H.__ecComponentInfo;
                  if (Z != null)
                    return R._model.getComponent(Z.mainType, Z.index);
                  H = H.parent;
                }
              }, z3.prototype.enterEmphasis = function(H, Z) {
                sS(H, Z), yS(R);
              }, z3.prototype.leaveEmphasis = function(H, Z) {
                lS(H, Z), yS(R);
              }, z3.prototype.enterBlur = function(H) {
                Zie(H), yS(R);
              }, z3.prototype.leaveBlur = function(H) {
                Rq(H), yS(R);
              }, z3.prototype.enterSelect = function(H) {
                uS(H), yS(R);
              }, z3.prototype.leaveSelect = function(H) {
                pu(H), yS(R);
              }, z3.prototype.getModel = function() {
                return R.getModel();
              }, z3.prototype.getViewOfComponentModel = function(H) {
                return R.getViewOfComponentModel(H);
              }, z3.prototype.getViewOfSeriesModel = function(H) {
                return R.getViewOfSeriesModel(H);
              }, z3;
            }(tGe))(R);
          }, WHe = function(R) {
            function V(z3, H) {
              for (var Z = 0; Z < z3.length; Z++) {
                var ee = z3[Z];
                ee[hwe] = H;
              }
            }
            gt(T$, function(z3, H) {
              R._messageCenter.on(H, function(Z) {
                if (XHe[R.group] && R[hwe] !== LHe) {
                  if (Z && Z.escapeConnect)
                    return;
                  var ee = R.makeActionFromEvent(Z), oe = [];
                  gt(A$, function(fe) {
                    fe !== R && fe.group === R.group && oe.push(fe);
                  }), V(oe, LHe), gt(oe, function(fe) {
                    fe[hwe] !== PNt && fe.dispatchAction(ee);
                  }), V(oe, LNt);
                }
              });
            });
          };
        }(), a;
      }(Dm), mwe = qHe.prototype;
      mwe.on = RHe("on"), mwe.off = RHe("off"), mwe.one = function(s, a, n6) {
        var f6 = this;
        function d4() {
          for (var y4 = [], _ = 0; _ < arguments.length; _++)
            y4[_] = arguments[_];
          a && a.apply && a.apply(this, y4), f6.off(s, d4);
        }
        this.on.call(this, s, d4, n6);
      };
      var RNt = ["click", "dblclick", "mouseover", "mouseout", "mousemove", "mousedown", "mouseup", "globalout", "contextmenu"], Zae = {}, T$ = {}, bwe = [], _we = [], Jae = [], $He = {}, xwe = {}, A$ = {}, XHe = {}, NNt = +new Date() - 0, wwe = "_echarts_instance_";
      function FNt(s, a, n6) {
        var f6 = !(n6 && n6.ssr);
        if (f6) {
          var d4 = VNt(s);
          if (d4)
            return d4;
        }
        var y4 = new qHe(s, a, n6);
        return y4.id = "ec_" + NNt++, A$[y4.id] = y4, f6 && gie(s, wwe, y4.id), WHe(y4), _C.trigger("afterinit", y4), y4;
      }
      function VNt(s) {
        return A$[Jbe(s, wwe)];
      }
      function YHe(s, a) {
        $He[s] = a;
      }
      function KHe(s) {
        Ns(_we, s) < 0 && _we.push(s);
      }
      function ZHe(s, a) {
        Cwe(bwe, s, a, MNt);
      }
      function BNt(s) {
        Swe("afterinit", s);
      }
      function zNt(s) {
        Swe("afterupdate", s);
      }
      function Swe(s, a) {
        _C.on(s, a);
      }
      function LT(s, a, n6) {
        jo(a) && (n6 = a, a = "");
        var f6 = Qo(s) ? s.type : [s, s = { event: a }][0];
        s.event = (s.event || f6).toLowerCase(), a = s.event, !T$[a] && (Ty(PHe.test(f6) && PHe.test(a)), Zae[f6] || (Zae[f6] = { action: n6, actionInfo: s }), T$[a] = f6);
      }
      function jNt(s, a) {
        f$.register(s, a);
      }
      function GNt(s, a) {
        Cwe(Jae, s, a, DHe, "layout");
      }
      function jR(s, a) {
        Cwe(Jae, s, a, kHe, "visual");
      }
      var JHe = [];
      function Cwe(s, a, n6, f6, d4) {
        if ((jo(a) || Qo(a)) && (n6 = a, a = f6), !(Ns(JHe, n6) >= 0)) {
          JHe.push(n6);
          var y4 = rHe.wrapStageHandler(n6, d4);
          y4.__prio = a, y4.__raw = n6, s.push(y4);
        }
      }
      function QHe(s, a) {
        xwe[s] = a;
      }
      function HNt(s, a, n6) {
        var f6 = bNt("registerMap");
        f6 && f6(s, a, n6);
      }
      var WNt = J4t;
      jR(cwe, S6t), jR(Xae, C6t), jR(Xae, M6t), jR(cwe, z6t), jR(Xae, j6t), jR(OHe, gNt), KHe(lGe), ZHe(SNt, O4t), QHe("default", T6t), LT({ type: SE, event: SE, update: SE }, rd), LT({ type: s7, event: s7, update: s7 }, rd), LT({ type: CE, event: CE, update: CE }, rd), LT({ type: l7, event: l7, update: l7 }, rd), LT({ type: $1, event: $1, update: $1 }, rd), YHe("light", F6t), YHe("dark", V6t);
      var eWe = [], UNt = { registerPreprocessor: KHe, registerProcessor: ZHe, registerPostInit: BNt, registerPostUpdate: zNt, registerUpdateLifecycle: Swe, registerAction: LT, registerCoordinateSystem: jNt, registerLayout: GNt, registerVisual: jR, registerTransform: WNt, registerLoading: QHe, registerMap: HNt, registerImpl: mNt, PRIORITY: ONt, ComponentModel: oc, ComponentView: sd, SeriesModel: Cp, ChartView: Ch, registerComponentModel: function(s) {
        oc.registerClass(s);
      }, registerComponentView: function(s) {
        sd.registerClass(s);
      }, registerSeriesModel: function(s) {
        Cp.registerClass(s);
      }, registerChartView: function(s) {
        Ch.registerClass(s);
      }, registerSubTypeDefaulter: function(s, a) {
        oc.registerSubTypeDefaulter(s, a);
      }, registerPainter: function(s, a) {
        sie(s, a);
      } };
      function Il(s) {
        if (Di(s)) {
          gt(s, function(a) {
            Il(a);
          });
          return;
        }
        Ns(eWe, s) >= 0 || (eWe.push(s), jo(s) && (s = { install: s }), s.install(UNt));
      }
      function I$(s) {
        return s == null ? 0 : s.length || 1;
      }
      function tWe(s) {
        return s;
      }
      var qNt = function() {
        function s(a, n6, f6, d4, y4, _) {
          this._old = a, this._new = n6, this._oldKeyGetter = f6 || tWe, this._newKeyGetter = d4 || tWe, this.context = y4, this._diffModeMultiple = _ === "multiple";
        }
        return s.prototype.add = function(a) {
          return this._add = a, this;
        }, s.prototype.update = function(a) {
          return this._update = a, this;
        }, s.prototype.updateManyToOne = function(a) {
          return this._updateManyToOne = a, this;
        }, s.prototype.updateOneToMany = function(a) {
          return this._updateOneToMany = a, this;
        }, s.prototype.updateManyToMany = function(a) {
          return this._updateManyToMany = a, this;
        }, s.prototype.remove = function(a) {
          return this._remove = a, this;
        }, s.prototype.execute = function() {
          this[this._diffModeMultiple ? "_executeMultiple" : "_executeOneToOne"]();
        }, s.prototype._executeOneToOne = function() {
          var a = this._old, n6 = this._new, f6 = {}, d4 = new Array(a.length), y4 = new Array(n6.length);
          this._initIndexMap(a, null, d4, "_oldKeyGetter"), this._initIndexMap(n6, f6, y4, "_newKeyGetter");
          for (var _ = 0; _ < a.length; _++) {
            var S = d4[_], T = f6[S], E = I$(T);
            if (E > 1) {
              var O = T.shift();
              T.length === 1 && (f6[S] = T[0]), this._update && this._update(O, _);
            } else
              E === 1 ? (f6[S] = null, this._update && this._update(T, _)) : this._remove && this._remove(_);
          }
          this._performRestAdd(y4, f6);
        }, s.prototype._executeMultiple = function() {
          var a = this._old, n6 = this._new, f6 = {}, d4 = {}, y4 = [], _ = [];
          this._initIndexMap(a, f6, y4, "_oldKeyGetter"), this._initIndexMap(n6, d4, _, "_newKeyGetter");
          for (var S = 0; S < y4.length; S++) {
            var T = y4[S], E = f6[T], O = d4[T], R = I$(E), V = I$(O);
            if (R > 1 && V === 1)
              this._updateManyToOne && this._updateManyToOne(O, E), d4[T] = null;
            else if (R === 1 && V > 1)
              this._updateOneToMany && this._updateOneToMany(O, E), d4[T] = null;
            else if (R === 1 && V === 1)
              this._update && this._update(O, E), d4[T] = null;
            else if (R > 1 && V > 1)
              this._updateManyToMany && this._updateManyToMany(O, E), d4[T] = null;
            else if (R > 1)
              for (var z3 = 0; z3 < R; z3++)
                this._remove && this._remove(E[z3]);
            else
              this._remove && this._remove(E);
          }
          this._performRestAdd(_, d4);
        }, s.prototype._performRestAdd = function(a, n6) {
          for (var f6 = 0; f6 < a.length; f6++) {
            var d4 = a[f6], y4 = n6[d4], _ = I$(y4);
            if (_ > 1)
              for (var S = 0; S < _; S++)
                this._add && this._add(y4[S]);
            else
              _ === 1 && this._add && this._add(y4);
            n6[d4] = null;
          }
        }, s.prototype._initIndexMap = function(a, n6, f6, d4) {
          for (var y4 = this._diffModeMultiple, _ = 0; _ < a.length; _++) {
            var S = "_ec_" + this[d4](a[_], _);
            if (y4 || (f6[_] = S), !!n6) {
              var T = n6[S], E = I$(T);
              E === 0 ? (n6[S] = _, y4 && f6.push(S)) : E === 1 ? n6[S] = [T, _] : T.push(_);
            }
          }
        }, s;
      }(), OE = qNt, $Nt = function() {
        function s(a, n6) {
          this._encode = a, this._schema = n6;
        }
        return s.prototype.get = function() {
          return { fullDimensions: this._getFullDimensionNames(), encode: this._encode };
        }, s.prototype._getFullDimensionNames = function() {
          return this._cachedDimNames || (this._cachedDimNames = this._schema ? this._schema.makeOutputDimensionNames() : []), this._cachedDimNames;
        }, s;
      }();
      function XNt(s, a) {
        var n6 = {}, f6 = n6.encode = {}, d4 = ro(), y4 = [], _ = [], S = {};
        gt(s.dimensions, function(V) {
          var z3 = s.getDimensionInfo(V), H = z3.coordDim;
          if (H) {
            var Z = z3.coordDimIndex;
            Mwe(f6, H)[Z] = V, z3.isExtraCoord || (d4.set(H, 1), YNt(z3.type) && (y4[0] = V), Mwe(S, H)[Z] = s.getDimensionIndex(z3.name)), z3.defaultTooltip && _.push(V);
          }
          zje.each(function(ee, oe) {
            var fe = Mwe(f6, oe), _e = z3.otherDims[oe];
            _e != null && _e !== false && (fe[_e] = z3.name);
          });
        });
        var T = [], E = {};
        d4.each(function(V, z3) {
          var H = f6[z3];
          E[z3] = H[0], T = T.concat(H);
        }), n6.dataDimsOnCoord = T, n6.dataDimIndicesOnCoord = Pi(T, function(V) {
          return s.getDimensionInfo(V).storeDimIndex;
        }), n6.encodeFirstDimNotExtra = E;
        var O = f6.label;
        O && O.length && (y4 = O.slice());
        var R = f6.tooltip;
        return R && R.length ? _ = R.slice() : _.length || (_ = y4.slice()), f6.defaultedLabel = y4, f6.defaultedTooltip = _, n6.userOutput = new $Nt(S, a), n6;
      }
      function Mwe(s, a) {
        return s.hasOwnProperty(a) || (s[a] = []), s[a];
      }
      function Qae(s) {
        return s === "category" ? "ordinal" : s === "time" ? "time" : "float";
      }
      function YNt(s) {
        return !(s === "ordinal" || s === "time");
      }
      var KNt = function() {
        function s(a) {
          this.otherDims = {}, a != null && ei(this, a);
        }
        return s;
      }(), eoe = KNt, ZNt = hu(), JNt = { float: "f", int: "i", ordinal: "o", number: "n", time: "t" }, nWe = function() {
        function s(a) {
          this.dimensions = a.dimensions, this._dimOmitted = a.dimensionOmitted, this.source = a.source, this._fullDimCount = a.fullDimensionCount, this._updateDimOmitted(a.dimensionOmitted);
        }
        return s.prototype.isDimensionOmitted = function() {
          return this._dimOmitted;
        }, s.prototype._updateDimOmitted = function(a) {
          this._dimOmitted = a, a && (this._dimNameMap || (this._dimNameMap = aWe(this.source)));
        }, s.prototype.getSourceDimensionIndex = function(a) {
          return Zs(this._dimNameMap.get(a), -1);
        }, s.prototype.getSourceDimension = function(a) {
          var n6 = this.source.dimensionsDefine;
          if (n6)
            return n6[a];
        }, s.prototype.makeStoreSchema = function() {
          for (var a = this._fullDimCount, n6 = hGe(this.source), f6 = !oWe(a), d4 = "", y4 = [], _ = 0, S = 0; _ < a; _++) {
            var T = void 0, E = void 0, O = void 0, R = this.dimensions[S];
            if (R && R.storeDimIndex === _)
              T = n6 ? R.name : null, E = R.type, O = R.ordinalMeta, S++;
            else {
              var V = this.getSourceDimension(_);
              V && (T = n6 ? V.name : null, E = V.type);
            }
            y4.push({ property: T, type: E, ordinalMeta: O }), n6 && T != null && (!R || !R.isCalculationCoord) && (d4 += f6 ? T.replace(/\`/g, "`1").replace(/\$/g, "`2") : T), d4 += "$", d4 += JNt[E] || "f", O && (d4 += O.uid), d4 += "$";
          }
          var z3 = this.source, H = [z3.seriesLayoutBy, z3.startIndex, d4].join("$$");
          return { dimensions: y4, hash: H };
        }, s.prototype.makeOutputDimensionNames = function() {
          for (var a = [], n6 = 0, f6 = 0; n6 < this._fullDimCount; n6++) {
            var d4 = void 0, y4 = this.dimensions[f6];
            if (y4 && y4.storeDimIndex === n6)
              y4.isCalculationCoord || (d4 = y4.name), f6++;
            else {
              var _ = this.getSourceDimension(n6);
              _ && (d4 = _.name);
            }
            a.push(d4);
          }
          return a;
        }, s.prototype.appendCalculationDimension = function(a) {
          this.dimensions.push(a), a.isCalculationCoord = true, this._fullDimCount++, this._updateDimOmitted(true);
        }, s;
      }();
      function rWe(s) {
        return s instanceof nWe;
      }
      function iWe(s) {
        for (var a = ro(), n6 = 0; n6 < (s || []).length; n6++) {
          var f6 = s[n6], d4 = Qo(f6) ? f6.name : f6;
          d4 != null && a.get(d4) == null && a.set(d4, n6);
        }
        return a;
      }
      function aWe(s) {
        var a = ZNt(s);
        return a.dimNameMap || (a.dimNameMap = iWe(s.dimensionsDefine));
      }
      function oWe(s) {
        return s > 30;
      }
      var E$ = Qo, e32 = Pi, QNt = typeof Int32Array == "undefined" ? Array : Int32Array, eFt = "e\0\0", sWe = -1, tFt = ["hasItemOption", "_nameList", "_idList", "_invertedIndicesMap", "_dimSummary", "userOutput", "_rawData", "_dimValueGetter", "_nameDimIdx", "_idDimIdx", "_nameRepeatCount"], nFt = ["_approximateExtent"], lWe, toe, D$, k$, Twe, noe, Awe, rFt = function() {
        function s(a, n6) {
          this.type = "list", this._dimOmitted = false, this._nameList = [], this._idList = [], this._visual = {}, this._layout = {}, this._itemVisuals = [], this._itemLayouts = [], this._graphicEls = [], this._approximateExtent = {}, this._calculationInfo = {}, this.hasItemOption = false, this.TRANSFERABLE_METHODS = ["cloneShallow", "downSample", "lttbDownSample", "map"], this.CHANGABLE_METHODS = ["filterSelf", "selectRange"], this.DOWNSAMPLE_METHODS = ["downSample", "lttbDownSample"];
          var f6, d4 = false;
          rWe(a) ? (f6 = a.dimensions, this._dimOmitted = a.isDimensionOmitted(), this._schema = a) : (d4 = true, f6 = a), f6 = f6 || ["x", "y"];
          for (var y4 = {}, _ = [], S = {}, T = false, E = {}, O = 0; O < f6.length; O++) {
            var R = f6[O], V = Wa(R) ? new eoe({ name: R }) : R instanceof eoe ? R : new eoe(R), z3 = V.name;
            V.type = V.type || "float", V.coordDim || (V.coordDim = z3, V.coordDimIndex = 0);
            var H = V.otherDims = V.otherDims || {};
            _.push(z3), y4[z3] = V, E[z3] != null && (T = true), V.createInvertedIndices && (S[z3] = []), H.itemName === 0 && (this._nameDimIdx = O), H.itemId === 0 && (this._idDimIdx = O), d4 && (V.storeDimIndex = O);
          }
          if (this.dimensions = _, this._dimInfos = y4, this._initGetDimensionInfo(T), this.hostModel = n6, this._invertedIndicesMap = S, this._dimOmitted) {
            var Z = this._dimIdxToName = ro();
            gt(_, function(ee) {
              Z.set(y4[ee].storeDimIndex, ee);
            });
          }
        }
        return s.prototype.getDimension = function(a) {
          var n6 = this._recognizeDimIndex(a);
          if (n6 == null)
            return a;
          if (n6 = a, !this._dimOmitted)
            return this.dimensions[n6];
          var f6 = this._dimIdxToName.get(n6);
          if (f6 != null)
            return f6;
          var d4 = this._schema.getSourceDimension(n6);
          if (d4)
            return d4.name;
        }, s.prototype.getDimensionIndex = function(a) {
          var n6 = this._recognizeDimIndex(a);
          if (n6 != null)
            return n6;
          if (a == null)
            return -1;
          var f6 = this._getDimInfo(a);
          return f6 ? f6.storeDimIndex : this._dimOmitted ? this._schema.getSourceDimensionIndex(a) : -1;
        }, s.prototype._recognizeDimIndex = function(a) {
          if (ac(a) || a != null && !isNaN(a) && !this._getDimInfo(a) && (!this._dimOmitted || this._schema.getSourceDimensionIndex(a) < 0))
            return +a;
        }, s.prototype._getStoreDimIndex = function(a) {
          var n6 = this.getDimensionIndex(a);
          return n6;
        }, s.prototype.getDimensionInfo = function(a) {
          return this._getDimInfo(this.getDimension(a));
        }, s.prototype._initGetDimensionInfo = function(a) {
          var n6 = this._dimInfos;
          this._getDimInfo = a ? function(f6) {
            return n6.hasOwnProperty(f6) ? n6[f6] : void 0;
          } : function(f6) {
            return n6[f6];
          };
        }, s.prototype.getDimensionsOnCoord = function() {
          return this._dimSummary.dataDimsOnCoord.slice();
        }, s.prototype.mapDimension = function(a, n6) {
          var f6 = this._dimSummary;
          if (n6 == null)
            return f6.encodeFirstDimNotExtra[a];
          var d4 = f6.encode[a];
          return d4 ? d4[n6] : null;
        }, s.prototype.mapDimensionsAll = function(a) {
          var n6 = this._dimSummary, f6 = n6.encode[a];
          return (f6 || []).slice();
        }, s.prototype.getStore = function() {
          return this._store;
        }, s.prototype.initData = function(a, n6, f6) {
          var d4 = this, y4;
          if (a instanceof Kxe && (y4 = a), !y4) {
            var _ = this.dimensions, S = Gxe(a) || _0(a) ? new vGe(a, _.length) : a;
            y4 = new Kxe();
            var T = e32(_, function(E) {
              return { type: d4._dimInfos[E].type, property: E };
            });
            y4.initData(S, T, f6);
          }
          this._store = y4, this._nameList = (n6 || []).slice(), this._idList = [], this._nameRepeatCount = {}, this._doInit(0, y4.count()), this._dimSummary = XNt(this, this._schema), this.userOutput = this._dimSummary.userOutput;
        }, s.prototype.appendData = function(a) {
          var n6 = this._store.appendData(a);
          this._doInit(n6[0], n6[1]);
        }, s.prototype.appendValues = function(a, n6) {
          var f6 = this._store.appendValues(a, n6.length), d4 = f6.start, y4 = f6.end, _ = this._shouldMakeIdFromName();
          if (this._updateOrdinalMeta(), n6)
            for (var S = d4; S < y4; S++) {
              var T = S - d4;
              this._nameList[S] = n6[T], _ && Awe(this, S);
            }
        }, s.prototype._updateOrdinalMeta = function() {
          for (var a = this._store, n6 = this.dimensions, f6 = 0; f6 < n6.length; f6++) {
            var d4 = this._dimInfos[n6[f6]];
            d4.ordinalMeta && a.collectOrdinalMeta(d4.storeDimIndex, d4.ordinalMeta);
          }
        }, s.prototype._shouldMakeIdFromName = function() {
          var a = this._store.getProvider();
          return this._idDimIdx == null && a.getSource().sourceFormat !== Kk && !a.fillStorage;
        }, s.prototype._doInit = function(a, n6) {
          if (!(a >= n6)) {
            var f6 = this._store, d4 = f6.getProvider();
            this._updateOrdinalMeta();
            var y4 = this._nameList, _ = this._idList, S = d4.getSource().sourceFormat, T = S === dS;
            if (T && !d4.pure)
              for (var E = [], O = a; O < n6; O++) {
                var R = d4.getItem(O, E);
                if (!this.hasItemOption && QU(R) && (this.hasItemOption = true), R) {
                  var V = R.name;
                  y4[O] == null && V != null && (y4[O] = Cd(V, null));
                  var z3 = R.id;
                  _[O] == null && z3 != null && (_[O] = Cd(z3, null));
                }
              }
            if (this._shouldMakeIdFromName())
              for (var O = a; O < n6; O++)
                Awe(this, O);
            lWe(this);
          }
        }, s.prototype.getApproximateExtent = function(a) {
          return this._approximateExtent[a] || this._store.getDataExtent(this._getStoreDimIndex(a));
        }, s.prototype.setApproximateExtent = function(a, n6) {
          n6 = this.getDimension(n6), this._approximateExtent[n6] = a.slice();
        }, s.prototype.getCalculationInfo = function(a) {
          return this._calculationInfo[a];
        }, s.prototype.setCalculationInfo = function(a, n6) {
          E$(a) ? ei(this._calculationInfo, a) : this._calculationInfo[a] = n6;
        }, s.prototype.getName = function(a) {
          var n6 = this.getRawIndex(a), f6 = this._nameList[n6];
          return f6 == null && this._nameDimIdx != null && (f6 = D$(this, this._nameDimIdx, n6)), f6 == null && (f6 = ""), f6;
        }, s.prototype._getCategory = function(a, n6) {
          var f6 = this._store.get(a, n6), d4 = this._store.getOrdinalMeta(a);
          return d4 ? d4.categories[f6] : f6;
        }, s.prototype.getId = function(a) {
          return toe(this, this.getRawIndex(a));
        }, s.prototype.count = function() {
          return this._store.count();
        }, s.prototype.get = function(a, n6) {
          var f6 = this._store, d4 = this._dimInfos[a];
          if (d4)
            return f6.get(d4.storeDimIndex, n6);
        }, s.prototype.getByRawIndex = function(a, n6) {
          var f6 = this._store, d4 = this._dimInfos[a];
          if (d4)
            return f6.getByRawIndex(d4.storeDimIndex, n6);
        }, s.prototype.getIndices = function() {
          return this._store.getIndices();
        }, s.prototype.getDataExtent = function(a) {
          return this._store.getDataExtent(this._getStoreDimIndex(a));
        }, s.prototype.getSum = function(a) {
          return this._store.getSum(this._getStoreDimIndex(a));
        }, s.prototype.getMedian = function(a) {
          return this._store.getMedian(this._getStoreDimIndex(a));
        }, s.prototype.getValues = function(a, n6) {
          var f6 = this, d4 = this._store;
          return Di(a) ? d4.getValues(e32(a, function(y4) {
            return f6._getStoreDimIndex(y4);
          }), n6) : d4.getValues(a);
        }, s.prototype.hasValue = function(a) {
          for (var n6 = this._dimSummary.dataDimIndicesOnCoord, f6 = 0, d4 = n6.length; f6 < d4; f6++)
            if (isNaN(this._store.get(n6[f6], a)))
              return false;
          return true;
        }, s.prototype.indexOfName = function(a) {
          for (var n6 = 0, f6 = this._store.count(); n6 < f6; n6++)
            if (this.getName(n6) === a)
              return n6;
          return -1;
        }, s.prototype.getRawIndex = function(a) {
          return this._store.getRawIndex(a);
        }, s.prototype.indexOfRawIndex = function(a) {
          return this._store.indexOfRawIndex(a);
        }, s.prototype.rawIndexOf = function(a, n6) {
          var f6 = a && this._invertedIndicesMap[a], d4 = f6[n6];
          return d4 == null || isNaN(d4) ? sWe : d4;
        }, s.prototype.indicesOfNearest = function(a, n6, f6) {
          return this._store.indicesOfNearest(this._getStoreDimIndex(a), n6, f6);
        }, s.prototype.each = function(a, n6, f6) {
          jo(a) && (f6 = n6, n6 = a, a = []);
          var d4 = f6 || this, y4 = e32(k$(a), this._getStoreDimIndex, this);
          this._store.each(y4, d4 ? Za(n6, d4) : n6);
        }, s.prototype.filterSelf = function(a, n6, f6) {
          jo(a) && (f6 = n6, n6 = a, a = []);
          var d4 = f6 || this, y4 = e32(k$(a), this._getStoreDimIndex, this);
          return this._store = this._store.filter(y4, d4 ? Za(n6, d4) : n6), this;
        }, s.prototype.selectRange = function(a) {
          var n6 = this, f6 = {}, d4 = Wl(a);
          return gt(d4, function(y4) {
            var _ = n6._getStoreDimIndex(y4);
            f6[_] = a[y4];
          }), this._store = this._store.selectRange(f6), this;
        }, s.prototype.mapArray = function(a, n6, f6) {
          jo(a) && (f6 = n6, n6 = a, a = []), f6 = f6 || this;
          var d4 = [];
          return this.each(a, function() {
            d4.push(n6 && n6.apply(this, arguments));
          }, f6), d4;
        }, s.prototype.map = function(a, n6, f6, d4) {
          var y4 = f6 || d4 || this, _ = e32(k$(a), this._getStoreDimIndex, this), S = noe(this);
          return S._store = this._store.map(_, y4 ? Za(n6, y4) : n6), S;
        }, s.prototype.modify = function(a, n6, f6, d4) {
          var y4 = f6 || d4 || this, _ = e32(k$(a), this._getStoreDimIndex, this);
          this._store.modify(_, y4 ? Za(n6, y4) : n6);
        }, s.prototype.downSample = function(a, n6, f6, d4) {
          var y4 = noe(this);
          return y4._store = this._store.downSample(this._getStoreDimIndex(a), n6, f6, d4), y4;
        }, s.prototype.lttbDownSample = function(a, n6) {
          var f6 = noe(this);
          return f6._store = this._store.lttbDownSample(this._getStoreDimIndex(a), n6), f6;
        }, s.prototype.getRawDataItem = function(a) {
          return this._store.getRawDataItem(a);
        }, s.prototype.getItemModel = function(a) {
          var n6 = this.hostModel, f6 = this.getRawDataItem(a);
          return new Sh(f6, n6, n6 && n6.ecModel);
        }, s.prototype.diff = function(a) {
          var n6 = this;
          return new OE(a ? a.getStore().getIndices() : [], this.getStore().getIndices(), function(f6) {
            return toe(a, f6);
          }, function(f6) {
            return toe(n6, f6);
          });
        }, s.prototype.getVisual = function(a) {
          var n6 = this._visual;
          return n6 && n6[a];
        }, s.prototype.setVisual = function(a, n6) {
          this._visual = this._visual || {}, E$(a) ? ei(this._visual, a) : this._visual[a] = n6;
        }, s.prototype.getItemVisual = function(a, n6) {
          var f6 = this._itemVisuals[a], d4 = f6 && f6[n6];
          return d4 == null ? this.getVisual(n6) : d4;
        }, s.prototype.hasItemVisual = function() {
          return this._itemVisuals.length > 0;
        }, s.prototype.ensureUniqueItemVisual = function(a, n6) {
          var f6 = this._itemVisuals, d4 = f6[a];
          d4 || (d4 = f6[a] = {});
          var y4 = d4[n6];
          return y4 == null && (y4 = this.getVisual(n6), Di(y4) ? y4 = y4.slice() : E$(y4) && (y4 = ei({}, y4)), d4[n6] = y4), y4;
        }, s.prototype.setItemVisual = function(a, n6, f6) {
          var d4 = this._itemVisuals[a] || {};
          this._itemVisuals[a] = d4, E$(n6) ? ei(d4, n6) : d4[n6] = f6;
        }, s.prototype.clearAllVisual = function() {
          this._visual = {}, this._itemVisuals = [];
        }, s.prototype.setLayout = function(a, n6) {
          E$(a) ? ei(this._layout, a) : this._layout[a] = n6;
        }, s.prototype.getLayout = function(a) {
          return this._layout[a];
        }, s.prototype.getItemLayout = function(a) {
          return this._itemLayouts[a];
        }, s.prototype.setItemLayout = function(a, n6, f6) {
          this._itemLayouts[a] = f6 ? ei(this._itemLayouts[a] || {}, n6) : n6;
        }, s.prototype.clearItemLayouts = function() {
          this._itemLayouts.length = 0;
        }, s.prototype.setItemGraphicEl = function(a, n6) {
          var f6 = this.hostModel && this.hostModel.seriesIndex;
          Dq(f6, this.dataType, a, n6), this._graphicEls[a] = n6;
        }, s.prototype.getItemGraphicEl = function(a) {
          return this._graphicEls[a];
        }, s.prototype.eachItemGraphicEl = function(a, n6) {
          gt(this._graphicEls, function(f6, d4) {
            f6 && a && a.call(n6, f6, d4);
          });
        }, s.prototype.cloneShallow = function(a) {
          return a || (a = new s(this._schema ? this._schema : e32(this.dimensions, this._getDimInfo, this), this.hostModel)), Twe(a, this), a._store = this._store, a;
        }, s.prototype.wrapMethod = function(a, n6) {
          var f6 = this[a];
          !jo(f6) || (this.__wrappedMethods = this.__wrappedMethods || [], this.__wrappedMethods.push(a), this[a] = function() {
            var d4 = f6.apply(this, arguments);
            return n6.apply(this, [d4].concat(rU(arguments)));
          });
        }, s.internalField = function() {
          lWe = function(a) {
            var n6 = a._invertedIndicesMap;
            gt(n6, function(f6, d4) {
              var y4 = a._dimInfos[d4], _ = y4.ordinalMeta, S = a._store;
              if (_) {
                f6 = n6[d4] = new QNt(_.categories.length);
                for (var T = 0; T < f6.length; T++)
                  f6[T] = sWe;
                for (var T = 0; T < S.count(); T++)
                  f6[S.get(y4.storeDimIndex, T)] = T;
              }
            });
          }, D$ = function(a, n6, f6) {
            return Cd(a._getCategory(n6, f6), null);
          }, toe = function(a, n6) {
            var f6 = a._idList[n6];
            return f6 == null && a._idDimIdx != null && (f6 = D$(a, a._idDimIdx, n6)), f6 == null && (f6 = eFt + n6), f6;
          }, k$ = function(a) {
            return Di(a) || (a = a != null ? [a] : []), a;
          }, noe = function(a) {
            var n6 = new s(a._schema ? a._schema : e32(a.dimensions, a._getDimInfo, a), a.hostModel);
            return Twe(n6, a), n6;
          }, Twe = function(a, n6) {
            gt(tFt.concat(n6.__wrappedMethods || []), function(f6) {
              n6.hasOwnProperty(f6) && (a[f6] = n6[f6]);
            }), a.__wrappedMethods = n6.__wrappedMethods, gt(nFt, function(f6) {
              a[f6] = Bo(n6[f6]);
            }), a._calculationInfo = ei({}, n6._calculationInfo);
          }, Awe = function(a, n6) {
            var f6 = a._nameList, d4 = a._idList, y4 = a._nameDimIdx, _ = a._idDimIdx, S = f6[n6], T = d4[n6];
            if (S == null && y4 != null && (f6[n6] = S = D$(a, y4, n6)), T == null && _ != null && (d4[n6] = T = D$(a, _, n6)), T == null && S != null) {
              var E = a._nameRepeatCount, O = E[S] = (E[S] || 0) + 1;
              T = S, O > 1 && (T += "__ec__" + O), d4[n6] = T;
            }
          };
        }(), s;
      }(), K1 = rFt;
      function O$(s, a) {
        Gxe(s) || (s = Wxe(s)), a = a || {};
        var n6 = a.coordDimensions || [], f6 = a.dimensionsDefine || s.dimensionsDefine || [], d4 = ro(), y4 = [], _ = aFt(s, n6, f6, a.dimensionsCount), S = a.canOmitUnusedDimensions && oWe(_), T = f6 === s.dimensionsDefine, E = T ? aWe(s) : iWe(f6), O = a.encodeDefine;
        !O && a.encodeDefaulter && (O = a.encodeDefaulter(s, _));
        for (var R = ro(O), V = new AGe(_), z3 = 0; z3 < V.length; z3++)
          V[z3] = -1;
        function H(Ye) {
          var rt2 = V[Ye];
          if (rt2 < 0) {
            var ut = f6[Ye], wt = Qo(ut) ? ut : { name: ut }, dt = new eoe(), Gt = wt.name;
            Gt != null && E.get(Gt) != null && (dt.name = dt.displayName = Gt), wt.type != null && (dt.type = wt.type), wt.displayName != null && (dt.displayName = wt.displayName);
            var Qt = y4.length;
            return V[Ye] = Qt, dt.storeDimIndex = Ye, y4.push(dt), dt;
          }
          return y4[rt2];
        }
        if (!S)
          for (var z3 = 0; z3 < _; z3++)
            H(z3);
        R.each(function(Ye, rt2) {
          var ut = jc(Ye).slice();
          if (ut.length === 1 && !Wa(ut[0]) && ut[0] < 0) {
            R.set(rt2, false);
            return;
          }
          var wt = R.set(rt2, []);
          gt(ut, function(dt, Gt) {
            var Qt = Wa(dt) ? E.get(dt) : dt;
            Qt != null && Qt < _ && (wt[Gt] = Qt, ee(H(Qt), rt2, Gt));
          });
        });
        var Z = 0;
        gt(n6, function(Ye) {
          var rt2, ut, wt, dt;
          if (Wa(Ye))
            rt2 = Ye, dt = {};
          else {
            dt = Ye, rt2 = dt.name;
            var Gt = dt.ordinalMeta;
            dt.ordinalMeta = null, dt = ei({}, dt), dt.ordinalMeta = Gt, ut = dt.dimsDef, wt = dt.otherDims, dt.name = dt.coordDim = dt.coordDimIndex = dt.dimsDef = dt.otherDims = null;
          }
          var Qt = R.get(rt2);
          if (Qt !== false) {
            if (Qt = jc(Qt), !Qt.length)
              for (var Nt = 0; Nt < (ut && ut.length || 1); Nt++) {
                for (; Z < _ && H(Z).coordDim != null; )
                  Z++;
                Z < _ && Qt.push(Z++);
              }
            gt(Qt, function(er, un) {
              var pn = H(er);
              if (T && dt.type != null && (pn.type = dt.type), ee(zo(pn, dt), rt2, un), pn.name == null && ut) {
                var On = ut[un];
                !Qo(On) && (On = { name: On }), pn.name = pn.displayName = On.name, pn.defaultTooltip = On.defaultTooltip;
              }
              wt && zo(pn.otherDims, wt);
            });
          }
        });
        function ee(Ye, rt2, ut) {
          zje.get(rt2) != null ? Ye.otherDims[rt2] = ut : (Ye.coordDim = rt2, Ye.coordDimIndex = ut, d4.set(rt2, true));
        }
        var oe = a.generateCoord, fe = a.generateCoordCount, _e = fe != null;
        fe = oe ? fe || 1 : 0;
        var pe = oe || "value";
        function Ve(Ye) {
          Ye.name == null && (Ye.name = Ye.coordDim);
        }
        if (S)
          gt(y4, function(Ye) {
            Ve(Ye);
          }), y4.sort(function(Ye, rt2) {
            return Ye.storeDimIndex - rt2.storeDimIndex;
          });
        else
          for (var Le = 0; Le < _; Le++) {
            var je = H(Le), Xe = je.coordDim;
            Xe == null && (je.coordDim = oFt(pe, d4, _e), je.coordDimIndex = 0, (!oe || fe <= 0) && (je.isExtraCoord = true), fe--), Ve(je), je.type == null && (Wje(s, Le) === By.Must || je.isExtraCoord && (je.otherDims.itemName != null || je.otherDims.seriesName != null)) && (je.type = "ordinal");
          }
        return iFt(y4), new nWe({ source: s, dimensions: y4, fullDimensionCount: _, dimensionOmitted: S });
      }
      function iFt(s) {
        for (var a = ro(), n6 = 0; n6 < s.length; n6++) {
          var f6 = s[n6], d4 = f6.name, y4 = a.get(d4) || 0;
          y4 > 0 && (f6.name = d4 + (y4 - 1)), y4++, a.set(d4, y4);
        }
      }
      function aFt(s, a, n6, f6) {
        var d4 = Math.max(s.dimensionsDetectedCount || 1, a.length, n6.length, f6 || 0);
        return gt(a, function(y4) {
          var _;
          Qo(y4) && (_ = y4.dimsDef) && (d4 = Math.max(d4, _.length));
        }), d4;
      }
      function oFt(s, a, n6) {
        var f6 = a.data;
        if (n6 || f6.hasOwnProperty(s)) {
          for (var d4 = 0; f6.hasOwnProperty(s + d4); )
            d4++;
          s += d4;
        }
        return a.set(s, true), s;
      }
      var sFt = function() {
        function s(a) {
          this.coordSysDims = [], this.axisMap = ro(), this.categoryAxisMap = ro(), this.coordSysName = a;
        }
        return s;
      }();
      function lFt(s) {
        var a = s.get("coordinateSystem"), n6 = new sFt(a), f6 = uFt[a];
        if (f6)
          return f6(s, n6, n6.axisMap, n6.categoryAxisMap), n6;
      }
      var uFt = { cartesian2d: function(s, a, n6, f6) {
        var d4 = s.getReferringComponents("xAxis", ad).models[0], y4 = s.getReferringComponents("yAxis", ad).models[0];
        a.coordSysDims = ["x", "y"], n6.set("x", d4), n6.set("y", y4), G7(d4) && (f6.set("x", d4), a.firstCategoryDimIndex = 0), G7(y4) && (f6.set("y", y4), a.firstCategoryDimIndex == null && (a.firstCategoryDimIndex = 1));
      }, singleAxis: function(s, a, n6, f6) {
        var d4 = s.getReferringComponents("singleAxis", ad).models[0];
        a.coordSysDims = ["single"], n6.set("single", d4), G7(d4) && (f6.set("single", d4), a.firstCategoryDimIndex = 0);
      }, polar: function(s, a, n6, f6) {
        var d4 = s.getReferringComponents("polar", ad).models[0], y4 = d4.findAxisModel("radiusAxis"), _ = d4.findAxisModel("angleAxis");
        a.coordSysDims = ["radius", "angle"], n6.set("radius", y4), n6.set("angle", _), G7(y4) && (f6.set("radius", y4), a.firstCategoryDimIndex = 0), G7(_) && (f6.set("angle", _), a.firstCategoryDimIndex == null && (a.firstCategoryDimIndex = 1));
      }, geo: function(s, a, n6, f6) {
        a.coordSysDims = ["lng", "lat"];
      }, parallel: function(s, a, n6, f6) {
        var d4 = s.ecModel, y4 = d4.getComponent("parallel", s.get("parallelIndex")), _ = a.coordSysDims = y4.dimensions.slice();
        gt(y4.parallelAxisIndex, function(S, T) {
          var E = d4.getComponent("parallelAxis", S), O = _[T];
          n6.set(O, E), G7(E) && (f6.set(O, E), a.firstCategoryDimIndex == null && (a.firstCategoryDimIndex = T));
        });
      } };
      function G7(s) {
        return s.get("type") === "category";
      }
      function cFt(s, a, n6) {
        n6 = n6 || {};
        var f6 = n6.byIndex, d4 = n6.stackedCoordDimension, y4, _, S;
        fFt(a) ? y4 = a : (_ = a.schema, y4 = _.dimensions, S = a.store);
        var T = !!(s && s.get("stack")), E, O, R, V;
        if (gt(y4, function(fe, _e) {
          Wa(fe) && (y4[_e] = fe = { name: fe }), T && !fe.isExtraCoord && (!f6 && !E && fe.ordinalMeta && (E = fe), !O && fe.type !== "ordinal" && fe.type !== "time" && (!d4 || d4 === fe.coordDim) && (O = fe));
        }), O && !f6 && !E && (f6 = true), O) {
          R = "__\0ecstackresult_" + s.id, V = "__\0ecstackedover_" + s.id, E && (E.createInvertedIndices = true);
          var z3 = O.coordDim, H = O.type, Z = 0;
          gt(y4, function(fe) {
            fe.coordDim === z3 && Z++;
          });
          var ee = { name: R, coordDim: z3, coordDimIndex: Z, type: H, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: y4.length }, oe = { name: V, coordDim: V, coordDimIndex: Z + 1, type: H, isExtraCoord: true, isCalculationCoord: true, storeDimIndex: y4.length + 1 };
          _ ? (S && (ee.storeDimIndex = S.ensureCalculationDimension(V, H), oe.storeDimIndex = S.ensureCalculationDimension(R, H)), _.appendCalculationDimension(ee), _.appendCalculationDimension(oe)) : (y4.push(ee), y4.push(oe));
        }
        return { stackedDimension: O && O.name, stackedByDimension: E && E.name, isStackedByIndex: f6, stackedOverDimension: V, stackResultDimension: R };
      }
      function fFt(s) {
        return !rWe(s.schema);
      }
      function t32(s, a) {
        return !!a && a === s.getCalculationInfo("stackedDimension");
      }
      function uWe(s, a) {
        return t32(s, a) ? s.getCalculationInfo("stackResultDimension") : a;
      }
      function hFt(s, a) {
        var n6 = s.get("coordinateSystem"), f6 = f$.get(n6), d4;
        return a && a.coordSysDims && (d4 = Pi(a.coordSysDims, function(y4) {
          var _ = { name: y4 }, S = a.axisMap.get(y4);
          if (S) {
            var T = S.get("type");
            _.type = Qae(T);
          }
          return _;
        })), d4 || (d4 = f6 && (f6.getDimensionsInfo ? f6.getDimensionsInfo() : f6.dimensions.slice()) || ["x", "y"]), d4;
      }
      function pFt(s, a, n6) {
        var f6, d4;
        return n6 && gt(s, function(y4, _) {
          var S = y4.coordDim, T = n6.categoryAxisMap.get(S);
          T && (f6 == null && (f6 = _), y4.ordinalMeta = T.getOrdinalMeta(), a && (y4.createInvertedIndices = true)), y4.otherDims.itemName != null && (d4 = true);
        }), !d4 && f6 != null && (s[f6].otherDims.itemName = 0), f6;
      }
      function PE(s, a, n6) {
        n6 = n6 || {};
        var f6 = a.getSourceManager(), d4, y4 = false;
        s ? (y4 = true, d4 = Wxe(s)) : (d4 = f6.getSource(), y4 = d4.sourceFormat === dS);
        var _ = lFt(a), S = hFt(a, _), T = n6.useEncodeDefaulter, E = jo(T) ? T : T ? ks(Hje, S, a) : null, O = { coordDimensions: S, generateCoord: n6.generateCoord, encodeDefine: a.getEncode(), encodeDefaulter: E, canOmitUnusedDimensions: !y4 }, R = O$(d4, O), V = pFt(R.dimensions, n6.createInvertedIndices, _), z3 = y4 ? null : f6.getSharedDataStore(R), H = cFt(a, { schema: R, store: z3 }), Z = new K1(R, a);
        Z.setCalculationInfo(H);
        var ee = V != null && dFt(d4) ? function(oe, fe, _e, pe) {
          return pe === V ? _e : this.defaultDimValueGetter(oe, fe, _e, pe);
        } : null;
        return Z.hasItemOption = false, Z.initData(y4 ? d4 : z3, null, ee), Z;
      }
      function dFt(s) {
        if (s.sourceFormat === dS) {
          var a = vFt(s.data || []);
          return !Di(pC(a));
        }
      }
      function vFt(s) {
        for (var a = 0; a < s.length && s[a] == null; )
          a++;
        return s[a];
      }
      var cWe = function() {
        function s(a) {
          this._setting = a || {}, this._extent = [1 / 0, -1 / 0];
        }
        return s.prototype.getSetting = function(a) {
          return this._setting[a];
        }, s.prototype.unionExtent = function(a) {
          var n6 = this._extent;
          a[0] < n6[0] && (n6[0] = a[0]), a[1] > n6[1] && (n6[1] = a[1]);
        }, s.prototype.unionExtentFromData = function(a, n6) {
          this.unionExtent(a.getApproximateExtent(n6));
        }, s.prototype.getExtent = function() {
          return this._extent.slice();
        }, s.prototype.setExtent = function(a, n6) {
          var f6 = this._extent;
          isNaN(a) || (f6[0] = a), isNaN(n6) || (f6[1] = n6);
        }, s.prototype.isInExtentRange = function(a) {
          return this._extent[0] <= a && this._extent[1] >= a;
        }, s.prototype.isBlank = function() {
          return this._isBlank;
        }, s.prototype.setBlank = function(a) {
          this._isBlank = a;
        }, s;
      }();
      Y9(cWe);
      var LE = cWe, gFt = 0, yFt = function() {
        function s(a) {
          this.categories = a.categories || [], this._needCollect = a.needCollect, this._deduplication = a.deduplication, this.uid = ++gFt;
        }
        return s.createByAxisModel = function(a) {
          var n6 = a.option, f6 = n6.data, d4 = f6 && Pi(f6, mFt);
          return new s({ categories: d4, needCollect: !d4, deduplication: n6.dedplication !== false });
        }, s.prototype.getOrdinal = function(a) {
          return this._getOrCreateMap().get(a);
        }, s.prototype.parseAndCollect = function(a) {
          var n6, f6 = this._needCollect;
          if (!Wa(a) && !f6)
            return a;
          if (f6 && !this._deduplication)
            return n6 = this.categories.length, this.categories[n6] = a, n6;
          var d4 = this._getOrCreateMap();
          return n6 = d4.get(a), n6 == null && (f6 ? (n6 = this.categories.length, this.categories[n6] = a, d4.set(a, n6)) : n6 = NaN), n6;
        }, s.prototype._getOrCreateMap = function() {
          return this._map || (this._map = ro(this.categories));
        }, s;
      }();
      function mFt(s) {
        return Qo(s) && s.value != null ? s.value : s + "";
      }
      var Iwe = yFt;
      function Ewe(s) {
        return s.type === "interval" || s.type === "log";
      }
      function bFt(s, a, n6, f6) {
        var d4 = {}, y4 = s[1] - s[0], _ = d4.interval = KU(y4 / a, true);
        n6 != null && _ < n6 && (_ = d4.interval = n6), f6 != null && _ > f6 && (_ = d4.interval = f6);
        var S = d4.intervalPrecision = fWe(_), T = d4.niceTickExtent = [Wp(Math.ceil(s[0] / _) * _, S), Wp(Math.floor(s[1] / _) * _, S)];
        return _Ft(T, s), d4;
      }
      function Dwe(s) {
        var a = Math.pow(10, YU(s)), n6 = s / a;
        return n6 ? n6 === 2 ? n6 = 3 : n6 === 3 ? n6 = 5 : n6 *= 2 : n6 = 1, Wp(n6 * a);
      }
      function fWe(s) {
        return tx(s) + 2;
      }
      function hWe(s, a, n6) {
        s[a] = Math.max(Math.min(s[a], n6[1]), n6[0]);
      }
      function _Ft(s, a) {
        !isFinite(s[0]) && (s[0] = a[0]), !isFinite(s[1]) && (s[1] = a[1]), hWe(s, 0, a), hWe(s, 1, a), s[0] > s[1] && (s[0] = s[1]);
      }
      function roe(s, a) {
        return s >= a[0] && s <= a[1];
      }
      function ioe(s, a) {
        return a[1] === a[0] ? 0.5 : (s - a[0]) / (a[1] - a[0]);
      }
      function aoe(s, a) {
        return s * (a[1] - a[0]) + a[0];
      }
      var pWe = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          f6.type = "ordinal";
          var d4 = f6.getSetting("ordinalMeta");
          return d4 || (d4 = new Iwe({})), Di(d4) && (d4 = new Iwe({ categories: Pi(d4, function(y4) {
            return Qo(y4) ? y4.value : y4;
          }) })), f6._ordinalMeta = d4, f6._extent = f6.getSetting("extent") || [0, d4.categories.length - 1], f6;
        }
        return a.prototype.parse = function(n6) {
          return Wa(n6) ? this._ordinalMeta.getOrdinal(n6) : Math.round(n6);
        }, a.prototype.contain = function(n6) {
          return n6 = this.parse(n6), roe(n6, this._extent) && this._ordinalMeta.categories[n6] != null;
        }, a.prototype.normalize = function(n6) {
          return n6 = this._getTickNumber(this.parse(n6)), ioe(n6, this._extent);
        }, a.prototype.scale = function(n6) {
          return n6 = Math.round(aoe(n6, this._extent)), this.getRawOrdinalNumber(n6);
        }, a.prototype.getTicks = function() {
          for (var n6 = [], f6 = this._extent, d4 = f6[0]; d4 <= f6[1]; )
            n6.push({ value: d4 }), d4++;
          return n6;
        }, a.prototype.getMinorTicks = function(n6) {
        }, a.prototype.setSortInfo = function(n6) {
          if (n6 == null) {
            this._ordinalNumbersByTick = this._ticksByOrdinalNumber = null;
            return;
          }
          for (var f6 = n6.ordinalNumbers, d4 = this._ordinalNumbersByTick = [], y4 = this._ticksByOrdinalNumber = [], _ = 0, S = this._ordinalMeta.categories.length, T = Math.min(S, f6.length); _ < T; ++_) {
            var E = f6[_];
            d4[_] = E, y4[E] = _;
          }
          for (var O = 0; _ < S; ++_) {
            for (; y4[O] != null; )
              O++;
            d4.push(O), y4[O] = _;
          }
        }, a.prototype._getTickNumber = function(n6) {
          var f6 = this._ticksByOrdinalNumber;
          return f6 && n6 >= 0 && n6 < f6.length ? f6[n6] : n6;
        }, a.prototype.getRawOrdinalNumber = function(n6) {
          var f6 = this._ordinalNumbersByTick;
          return f6 && n6 >= 0 && n6 < f6.length ? f6[n6] : n6;
        }, a.prototype.getLabel = function(n6) {
          if (!this.isBlank()) {
            var f6 = this.getRawOrdinalNumber(n6.value), d4 = this._ordinalMeta.categories[f6];
            return d4 == null ? "" : d4 + "";
          }
        }, a.prototype.count = function() {
          return this._extent[1] - this._extent[0] + 1;
        }, a.prototype.unionExtentFromData = function(n6, f6) {
          this.unionExtent(n6.getApproximateExtent(f6));
        }, a.prototype.isInExtentRange = function(n6) {
          return n6 = this._getTickNumber(n6), this._extent[0] <= n6 && this._extent[1] >= n6;
        }, a.prototype.getOrdinalMeta = function() {
          return this._ordinalMeta;
        }, a.prototype.calcNiceTicks = function() {
        }, a.prototype.calcNiceExtent = function() {
        }, a.type = "ordinal", a;
      }(LE);
      LE.registerClass(pWe);
      var kwe = pWe, GR = Wp, dWe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "interval", n6._interval = 0, n6._intervalPrecision = 2, n6;
        }
        return a.prototype.parse = function(n6) {
          return n6;
        }, a.prototype.contain = function(n6) {
          return roe(n6, this._extent);
        }, a.prototype.normalize = function(n6) {
          return ioe(n6, this._extent);
        }, a.prototype.scale = function(n6) {
          return aoe(n6, this._extent);
        }, a.prototype.setExtent = function(n6, f6) {
          var d4 = this._extent;
          isNaN(n6) || (d4[0] = parseFloat(n6)), isNaN(f6) || (d4[1] = parseFloat(f6));
        }, a.prototype.unionExtent = function(n6) {
          var f6 = this._extent;
          n6[0] < f6[0] && (f6[0] = n6[0]), n6[1] > f6[1] && (f6[1] = n6[1]), this.setExtent(f6[0], f6[1]);
        }, a.prototype.getInterval = function() {
          return this._interval;
        }, a.prototype.setInterval = function(n6) {
          this._interval = n6, this._niceExtent = this._extent.slice(), this._intervalPrecision = fWe(n6);
        }, a.prototype.getTicks = function(n6) {
          var f6 = this._interval, d4 = this._extent, y4 = this._niceExtent, _ = this._intervalPrecision, S = [];
          if (!f6)
            return S;
          var T = 1e4;
          d4[0] < y4[0] && (n6 ? S.push({ value: GR(y4[0] - f6, _) }) : S.push({ value: d4[0] }));
          for (var E = y4[0]; E <= y4[1] && (S.push({ value: E }), E = GR(E + f6, _), E !== S[S.length - 1].value); )
            if (S.length > T)
              return [];
          var O = S.length ? S[S.length - 1].value : y4[1];
          return d4[1] > O && (n6 ? S.push({ value: GR(O + f6, _) }) : S.push({ value: d4[1] })), S;
        }, a.prototype.getMinorTicks = function(n6) {
          for (var f6 = this.getTicks(true), d4 = [], y4 = this.getExtent(), _ = 1; _ < f6.length; _++) {
            for (var S = f6[_], T = f6[_ - 1], E = 0, O = [], R = S.value - T.value, V = R / n6; E < n6 - 1; ) {
              var z3 = GR(T.value + (E + 1) * V);
              z3 > y4[0] && z3 < y4[1] && O.push(z3), E++;
            }
            d4.push(O);
          }
          return d4;
        }, a.prototype.getLabel = function(n6, f6) {
          if (n6 == null)
            return "";
          var d4 = f6 && f6.precision;
          d4 == null ? d4 = tx(n6.value) || 0 : d4 === "auto" && (d4 = this._intervalPrecision);
          var y4 = GR(n6.value, d4, true);
          return Pje(y4);
        }, a.prototype.calcNiceTicks = function(n6, f6, d4) {
          n6 = n6 || 5;
          var y4 = this._extent, _ = y4[1] - y4[0];
          if (isFinite(_)) {
            _ < 0 && (_ = -_, y4.reverse());
            var S = bFt(y4, n6, f6, d4);
            this._intervalPrecision = S.intervalPrecision, this._interval = S.interval, this._niceExtent = S.niceTickExtent;
          }
        }, a.prototype.calcNiceExtent = function(n6) {
          var f6 = this._extent;
          if (f6[0] === f6[1])
            if (f6[0] !== 0) {
              var d4 = f6[0];
              n6.fixMax || (f6[1] += d4 / 2), f6[0] -= d4 / 2;
            } else
              f6[1] = 1;
          var y4 = f6[1] - f6[0];
          isFinite(y4) || (f6[0] = 0, f6[1] = 1), this.calcNiceTicks(n6.splitNumber, n6.minInterval, n6.maxInterval);
          var _ = this._interval;
          n6.fixMin || (f6[0] = GR(Math.floor(f6[0] / _) * _)), n6.fixMax || (f6[1] = GR(Math.ceil(f6[1] / _) * _));
        }, a.prototype.setNiceExtent = function(n6, f6) {
          this._niceExtent = [n6, f6];
        }, a.type = "interval", a;
      }(LE);
      LE.registerClass(dWe);
      var n3 = dWe, vWe = typeof Float32Array != "undefined", xFt = vWe ? Float32Array : Array;
      function RT(s) {
        return Di(s) ? vWe ? new Float32Array(s) : s : new xFt(s);
      }
      var Owe = "__ec_stack_";
      function Pwe(s) {
        return s.get("stack") || Owe + s.seriesIndex;
      }
      function Lwe(s) {
        return s.dim + s.index;
      }
      function wFt(s) {
        var a = [], n6 = s.axis, f6 = "axis0";
        if (n6.type === "category") {
          for (var d4 = n6.getBandWidth(), y4 = 0; y4 < s.count; y4++)
            a.push(zo({ bandWidth: d4, axisKey: f6, stackId: Owe + y4 }, s));
          for (var _ = mWe(a), S = [], y4 = 0; y4 < s.count; y4++) {
            var T = _[f6][Owe + y4];
            T.offsetCenter = T.offset + T.width / 2, S.push(T);
          }
          return S;
        }
      }
      function gWe(s, a) {
        var n6 = [];
        return a.eachSeriesByType(s, function(f6) {
          xWe(f6) && n6.push(f6);
        }), n6;
      }
      function SFt(s) {
        var a = {};
        gt(s, function(T) {
          var E = T.coordinateSystem, O = E.getBaseAxis();
          if (!(O.type !== "time" && O.type !== "value"))
            for (var R = T.getData(), V = O.dim + "_" + O.index, z3 = R.getDimensionIndex(R.mapDimension(O.dim)), H = R.getStore(), Z = 0, ee = H.count(); Z < ee; ++Z) {
              var oe = H.get(z3, Z);
              a[V] ? a[V].push(oe) : a[V] = [oe];
            }
        });
        var n6 = {};
        for (var f6 in a)
          if (a.hasOwnProperty(f6)) {
            var d4 = a[f6];
            if (d4) {
              d4.sort(function(T, E) {
                return T - E;
              });
              for (var y4 = null, _ = 1; _ < d4.length; ++_) {
                var S = d4[_] - d4[_ - 1];
                S > 0 && (y4 = y4 === null ? S : Math.min(y4, S));
              }
              n6[f6] = y4;
            }
          }
        return n6;
      }
      function yWe(s) {
        var a = SFt(s), n6 = [];
        return gt(s, function(f6) {
          var d4 = f6.coordinateSystem, y4 = d4.getBaseAxis(), _ = y4.getExtent(), S;
          if (y4.type === "category")
            S = y4.getBandWidth();
          else if (y4.type === "value" || y4.type === "time") {
            var T = y4.dim + "_" + y4.index, E = a[T], O = Math.abs(_[1] - _[0]), R = y4.scale.getExtent(), V = Math.abs(R[1] - R[0]);
            S = E ? O / V * E : O;
          } else {
            var z3 = f6.getData();
            S = Math.abs(_[1] - _[0]) / z3.count();
          }
          var H = Ia(f6.get("barWidth"), S), Z = Ia(f6.get("barMaxWidth"), S), ee = Ia(f6.get("barMinWidth") || (wWe(f6) ? 0.5 : 1), S), oe = f6.get("barGap"), fe = f6.get("barCategoryGap");
          n6.push({ bandWidth: S, barWidth: H, barMaxWidth: Z, barMinWidth: ee, barGap: oe, barCategoryGap: fe, axisKey: Lwe(y4), stackId: Pwe(f6) });
        }), mWe(n6);
      }
      function mWe(s) {
        var a = {};
        gt(s, function(f6, d4) {
          var y4 = f6.axisKey, _ = f6.bandWidth, S = a[y4] || { bandWidth: _, remainedWidth: _, autoWidthCount: 0, categoryGap: null, gap: "20%", stacks: {} }, T = S.stacks;
          a[y4] = S;
          var E = f6.stackId;
          T[E] || S.autoWidthCount++, T[E] = T[E] || { width: 0, maxWidth: 0 };
          var O = f6.barWidth;
          O && !T[E].width && (T[E].width = O, O = Math.min(S.remainedWidth, O), S.remainedWidth -= O);
          var R = f6.barMaxWidth;
          R && (T[E].maxWidth = R);
          var V = f6.barMinWidth;
          V && (T[E].minWidth = V);
          var z3 = f6.barGap;
          z3 != null && (S.gap = z3);
          var H = f6.barCategoryGap;
          H != null && (S.categoryGap = H);
        });
        var n6 = {};
        return gt(a, function(f6, d4) {
          n6[d4] = {};
          var y4 = f6.stacks, _ = f6.bandWidth, S = f6.categoryGap;
          if (S == null) {
            var T = Wl(y4).length;
            S = Math.max(35 - T * 4, 15) + "%";
          }
          var E = Ia(S, _), O = Ia(f6.gap, 1), R = f6.remainedWidth, V = f6.autoWidthCount, z3 = (R - E) / (V + (V - 1) * O);
          z3 = Math.max(z3, 0), gt(y4, function(oe) {
            var fe = oe.maxWidth, _e = oe.minWidth;
            if (oe.width) {
              var pe = oe.width;
              fe && (pe = Math.min(pe, fe)), _e && (pe = Math.max(pe, _e)), oe.width = pe, R -= pe + O * pe, V--;
            } else {
              var pe = z3;
              fe && fe < pe && (pe = Math.min(fe, R)), _e && _e > pe && (pe = _e), pe !== z3 && (oe.width = pe, R -= pe + O * pe, V--);
            }
          }), z3 = (R - E) / (V + (V - 1) * O), z3 = Math.max(z3, 0);
          var H = 0, Z;
          gt(y4, function(oe, fe) {
            oe.width || (oe.width = z3), Z = oe, H += oe.width * (1 + O);
          }), Z && (H -= Z.width * O);
          var ee = -H / 2;
          gt(y4, function(oe, fe) {
            n6[d4][fe] = n6[d4][fe] || { bandWidth: _, offset: ee, width: oe.width }, ee += oe.width * (1 + O);
          });
        }), n6;
      }
      function CFt(s, a, n6) {
        if (s && a) {
          var f6 = s[Lwe(a)];
          return f6 != null && n6 != null ? f6[Pwe(n6)] : f6;
        }
      }
      function bWe(s, a) {
        var n6 = gWe(s, a), f6 = yWe(n6);
        gt(n6, function(d4) {
          var y4 = d4.getData(), _ = d4.coordinateSystem, S = _.getBaseAxis(), T = Pwe(d4), E = f6[Lwe(S)][T], O = E.offset, R = E.width;
          y4.setLayout({ bandWidth: E.bandWidth, offset: O, size: R });
        });
      }
      function _We(s) {
        return { seriesType: s, plan: R7(), reset: function(a) {
          if (xWe(a)) {
            var n6 = a.getData(), f6 = a.coordinateSystem, d4 = f6.getBaseAxis(), y4 = f6.getOtherAxis(d4), _ = n6.getDimensionIndex(n6.mapDimension(y4.dim)), S = n6.getDimensionIndex(n6.mapDimension(d4.dim)), T = a.get("showBackground", true), E = n6.mapDimension(y4.dim), O = n6.getCalculationInfo("stackResultDimension"), R = t32(n6, E) && !!n6.getCalculationInfo("stackedOnSeries"), V = y4.isHorizontal(), z3 = MFt(d4, y4), H = wWe(a), Z = a.get("barMinHeight") || 0, ee = O && n6.getDimensionIndex(O), oe = n6.getLayout("size"), fe = n6.getLayout("offset");
            return { progress: function(_e, pe) {
              for (var Ve = _e.count, Le = H && RT(Ve * 3), je = H && T && RT(Ve * 3), Xe = H && RT(Ve), Ye = f6.master.getRect(), rt2 = V ? Ye.width : Ye.height, ut, wt = pe.getStore(), dt = 0; (ut = _e.next()) != null; ) {
                var Gt = wt.get(R ? ee : _, ut), Qt = wt.get(S, ut), Nt = z3, er = void 0;
                R && (er = +Gt - wt.get(_, ut));
                var un = void 0, pn = void 0, On = void 0, fr = void 0;
                if (V) {
                  var yr = f6.dataToPoint([Gt, Qt]);
                  if (R) {
                    var da = f6.dataToPoint([er, Qt]);
                    Nt = da[0];
                  }
                  un = Nt, pn = yr[1] + fe, On = yr[0] - Nt, fr = oe, Math.abs(On) < Z && (On = (On < 0 ? -1 : 1) * Z);
                } else {
                  var yr = f6.dataToPoint([Qt, Gt]);
                  if (R) {
                    var da = f6.dataToPoint([Qt, er]);
                    Nt = da[1];
                  }
                  un = yr[0] + fe, pn = Nt, On = oe, fr = yr[1] - Nt, Math.abs(fr) < Z && (fr = (fr <= 0 ? -1 : 1) * Z);
                }
                H ? (Le[dt] = un, Le[dt + 1] = pn, Le[dt + 2] = V ? On : fr, je && (je[dt] = V ? Ye.x : un, je[dt + 1] = V ? pn : Ye.y, je[dt + 2] = rt2), Xe[ut] = ut) : pe.setItemLayout(ut, { x: un, y: pn, width: On, height: fr }), dt += 3;
              }
              H && pe.setLayout({ largePoints: Le, largeDataIndices: Xe, largeBackgroundPoints: je, valueAxisHorizontal: V });
            } };
          }
        } };
      }
      function xWe(s) {
        return s.coordinateSystem && s.coordinateSystem.type === "cartesian2d";
      }
      function wWe(s) {
        return s.pipelineContext && s.pipelineContext.large;
      }
      function MFt(s, a) {
        return a.toGlobalCoord(a.dataToCoord(a.type === "log" ? 1 : 0));
      }
      var TFt = function(s, a, n6, f6) {
        for (; n6 < f6; ) {
          var d4 = n6 + f6 >>> 1;
          s[d4][1] < a ? n6 = d4 + 1 : f6 = d4;
        }
        return n6;
      }, SWe = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "time", f6;
        }
        return a.prototype.getLabel = function(n6) {
          var f6 = this.getSetting("useUTC");
          return Mae(n6.value, Sje[$Rt(T7(this._minLevelUnit))] || Sje.second, f6, this.getSetting("locale"));
        }, a.prototype.getFormattedLabel = function(n6, f6, d4) {
          var y4 = this.getSetting("useUTC"), _ = this.getSetting("locale");
          return XRt(n6, f6, d4, _, y4);
        }, a.prototype.getTicks = function() {
          var n6 = this._interval, f6 = this._extent, d4 = [];
          if (!n6)
            return d4;
          d4.push({ value: f6[0], level: 0 });
          var y4 = this.getSetting("useUTC"), _ = PFt(this._minLevelUnit, this._approxInterval, y4, f6);
          return d4 = d4.concat(_), d4.push({ value: f6[1], level: 0 }), d4;
        }, a.prototype.calcNiceExtent = function(n6) {
          var f6 = this._extent;
          if (f6[0] === f6[1] && (f6[0] -= pS, f6[1] += pS), f6[1] === -1 / 0 && f6[0] === 1 / 0) {
            var d4 = new Date();
            f6[1] = +new Date(d4.getFullYear(), d4.getMonth(), d4.getDate()), f6[0] = f6[1] - pS;
          }
          this.calcNiceTicks(n6.splitNumber, n6.minInterval, n6.maxInterval);
        }, a.prototype.calcNiceTicks = function(n6, f6, d4) {
          n6 = n6 || 10;
          var y4 = this._extent, _ = y4[1] - y4[0];
          this._approxInterval = _ / n6, f6 != null && this._approxInterval < f6 && (this._approxInterval = f6), d4 != null && this._approxInterval > d4 && (this._approxInterval = d4);
          var S = ooe.length, T = Math.min(TFt(ooe, this._approxInterval, 0, S), S - 1);
          this._interval = ooe[T][1], this._minLevelUnit = ooe[Math.max(T - 1, 0)][0];
        }, a.prototype.parse = function(n6) {
          return ac(n6) ? n6 : +nx(n6);
        }, a.prototype.contain = function(n6) {
          return roe(this.parse(n6), this._extent);
        }, a.prototype.normalize = function(n6) {
          return ioe(this.parse(n6), this._extent);
        }, a.prototype.scale = function(n6) {
          return aoe(n6, this._extent);
        }, a.type = "time", a;
      }(n3), ooe = [["second", Axe], ["minute", Ixe], ["hour", o$], ["quarter-day", o$ * 6], ["half-day", o$ * 12], ["day", pS * 1.2], ["half-week", pS * 3.5], ["week", pS * 7], ["month", pS * 31], ["quarter", pS * 95], ["half-year", wje / 2], ["year", wje]];
      function AFt(s, a, n6, f6) {
        var d4 = nx(a), y4 = nx(n6), _ = function(H) {
          return Tje(d4, H, f6) === Tje(y4, H, f6);
        }, S = function() {
          return _("year");
        }, T = function() {
          return S() && _("month");
        }, E = function() {
          return T() && _("day");
        }, O = function() {
          return E() && _("hour");
        }, R = function() {
          return O() && _("minute");
        }, V = function() {
          return R() && _("second");
        }, z3 = function() {
          return V() && _("millisecond");
        };
        switch (s) {
          case "year":
            return S();
          case "month":
            return T();
          case "day":
            return E();
          case "hour":
            return O();
          case "minute":
            return R();
          case "second":
            return V();
          case "millisecond":
            return z3();
        }
      }
      function IFt(s, a) {
        return s /= pS, s > 16 ? 16 : s > 7.5 ? 7 : s > 3.5 ? 4 : s > 1.5 ? 2 : 1;
      }
      function EFt(s) {
        var a = 30 * pS;
        return s /= a, s > 6 ? 6 : s > 3 ? 3 : s > 2 ? 2 : 1;
      }
      function DFt(s) {
        return s /= o$, s > 12 ? 12 : s > 6 ? 6 : s > 3.5 ? 4 : s > 2 ? 2 : 1;
      }
      function CWe(s, a) {
        return s /= a ? Ixe : Axe, s > 30 ? 30 : s > 20 ? 20 : s > 15 ? 15 : s > 10 ? 10 : s > 5 ? 5 : s > 2 ? 2 : 1;
      }
      function kFt(s) {
        return KU(s, true);
      }
      function OFt(s, a, n6) {
        var f6 = new Date(s);
        switch (T7(a)) {
          case "year":
          case "month":
            f6[Aje(n6)](0);
          case "day":
            f6[Ije(n6)](1);
          case "hour":
            f6[Eje(n6)](0);
          case "minute":
            f6[Dje(n6)](0);
          case "second":
            f6[kje(n6)](0), f6[Oje(n6)](0);
        }
        return f6.getTime();
      }
      function PFt(s, a, n6, f6) {
        var d4 = 1e4, y4 = Cje, _ = 0;
        function S(rt2, ut, wt, dt, Gt, Qt, Nt) {
          for (var er = new Date(ut), un = ut, pn = er[dt](); un < wt && un <= f6[1]; )
            Nt.push({ value: un }), pn += rt2, er[Gt](pn), un = er.getTime();
          Nt.push({ value: un, notAdd: true });
        }
        function T(rt2, ut, wt) {
          var dt = [], Gt = !ut.length;
          if (!AFt(T7(rt2), f6[0], f6[1], n6)) {
            Gt && (ut = [{ value: OFt(new Date(f6[0]), rt2, n6) }, { value: f6[1] }]);
            for (var Qt = 0; Qt < ut.length - 1; Qt++) {
              var Nt = ut[Qt].value, er = ut[Qt + 1].value;
              if (Nt !== er) {
                var un = void 0, pn = void 0, On = void 0, fr = false;
                switch (rt2) {
                  case "year":
                    un = Math.max(1, Math.round(a / pS / 365)), pn = Dxe(n6), On = YRt(n6);
                    break;
                  case "half-year":
                  case "quarter":
                  case "month":
                    un = EFt(a), pn = A7(n6), On = Aje(n6);
                    break;
                  case "week":
                  case "half-week":
                  case "day":
                    un = IFt(a), pn = Tae(n6), On = Ije(n6), fr = true;
                    break;
                  case "half-day":
                  case "quarter-day":
                  case "hour":
                    un = DFt(a), pn = l$(n6), On = Eje(n6);
                    break;
                  case "minute":
                    un = CWe(a, true), pn = Aae(n6), On = Dje(n6);
                    break;
                  case "second":
                    un = CWe(a, false), pn = Iae(n6), On = kje(n6);
                    break;
                  case "millisecond":
                    un = kFt(a), pn = Eae(n6), On = Oje(n6);
                    break;
                }
                S(un, Nt, er, pn, On, fr, dt), rt2 === "year" && wt.length > 1 && Qt === 0 && wt.unshift({ value: wt[0].value - un });
              }
            }
            for (var Qt = 0; Qt < dt.length; Qt++)
              wt.push(dt[Qt]);
            return dt;
          }
        }
        for (var E = [], O = [], R = 0, V = 0, z3 = 0; z3 < y4.length && _++ < d4; ++z3) {
          var H = T7(y4[z3]);
          if (qRt(y4[z3])) {
            T(y4[z3], E[E.length - 1] || [], O);
            var Z = y4[z3 + 1] ? T7(y4[z3 + 1]) : null;
            if (H !== Z) {
              if (O.length) {
                V = R, O.sort(function(rt2, ut) {
                  return rt2.value - ut.value;
                });
                for (var ee = [], oe = 0; oe < O.length; ++oe) {
                  var fe = O[oe].value;
                  (oe === 0 || O[oe - 1].value !== fe) && (ee.push(O[oe]), fe >= f6[0] && fe <= f6[1] && R++);
                }
                var _e = (f6[1] - f6[0]) / a;
                if (R > _e * 1.5 && V > _e / 1.5 || (E.push(ee), R > _e || s === y4[z3]))
                  break;
              }
              O = [];
            }
          }
        }
        for (var pe = tf(Pi(E, function(ut) {
          return tf(ut, function(wt) {
            return wt.value >= f6[0] && wt.value <= f6[1] && !wt.notAdd;
          });
        }), function(ut) {
          return ut.length > 0;
        }), Ve = [], Le = pe.length - 1, z3 = 0; z3 < pe.length; ++z3)
          for (var je = pe[z3], Xe = 0; Xe < je.length; ++Xe)
            Ve.push({ value: je[Xe].value, level: Le - z3 });
        Ve.sort(function(rt2, ut) {
          return rt2.value - ut.value;
        });
        for (var Ye = [], z3 = 0; z3 < Ve.length; ++z3)
          (z3 === 0 || Ve[z3].value !== Ve[z3 - 1].value) && Ye.push(Ve[z3]);
        return Ye;
      }
      LE.registerClass(SWe);
      var MWe = SWe, TWe = LE.prototype, P$ = n3.prototype, LFt = Wp, RFt = Math.floor, NFt = Math.ceil, soe = Math.pow, mS = Math.log, Rwe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "log", n6.base = 10, n6._originalScale = new n3(), n6._interval = 0, n6;
        }
        return a.prototype.getTicks = function(n6) {
          var f6 = this._originalScale, d4 = this._extent, y4 = f6.getExtent(), _ = P$.getTicks.call(this, n6);
          return Pi(_, function(S) {
            var T = S.value, E = Wp(soe(this.base, T));
            return E = T === d4[0] && this._fixMin ? loe(E, y4[0]) : E, E = T === d4[1] && this._fixMax ? loe(E, y4[1]) : E, { value: E };
          }, this);
        }, a.prototype.setExtent = function(n6, f6) {
          var d4 = this.base;
          n6 = mS(n6) / mS(d4), f6 = mS(f6) / mS(d4), P$.setExtent.call(this, n6, f6);
        }, a.prototype.getExtent = function() {
          var n6 = this.base, f6 = TWe.getExtent.call(this);
          f6[0] = soe(n6, f6[0]), f6[1] = soe(n6, f6[1]);
          var d4 = this._originalScale, y4 = d4.getExtent();
          return this._fixMin && (f6[0] = loe(f6[0], y4[0])), this._fixMax && (f6[1] = loe(f6[1], y4[1])), f6;
        }, a.prototype.unionExtent = function(n6) {
          this._originalScale.unionExtent(n6);
          var f6 = this.base;
          n6[0] = mS(n6[0]) / mS(f6), n6[1] = mS(n6[1]) / mS(f6), TWe.unionExtent.call(this, n6);
        }, a.prototype.unionExtentFromData = function(n6, f6) {
          this.unionExtent(n6.getApproximateExtent(f6));
        }, a.prototype.calcNiceTicks = function(n6) {
          n6 = n6 || 10;
          var f6 = this._extent, d4 = f6[1] - f6[0];
          if (!(d4 === 1 / 0 || d4 <= 0)) {
            var y4 = XU(d4), _ = n6 / d4 * y4;
            for (_ <= 0.5 && (y4 *= 10); !isNaN(y4) && Math.abs(y4) < 1 && Math.abs(y4) > 0; )
              y4 *= 10;
            var S = [Wp(NFt(f6[0] / y4) * y4), Wp(RFt(f6[1] / y4) * y4)];
            this._interval = y4, this._niceExtent = S;
          }
        }, a.prototype.calcNiceExtent = function(n6) {
          P$.calcNiceExtent.call(this, n6), this._fixMin = n6.fixMin, this._fixMax = n6.fixMax;
        }, a.prototype.parse = function(n6) {
          return n6;
        }, a.prototype.contain = function(n6) {
          return n6 = mS(n6) / mS(this.base), roe(n6, this._extent);
        }, a.prototype.normalize = function(n6) {
          return n6 = mS(n6) / mS(this.base), ioe(n6, this._extent);
        }, a.prototype.scale = function(n6) {
          return n6 = aoe(n6, this._extent), soe(this.base, n6);
        }, a.type = "log", a;
      }(LE), AWe = Rwe.prototype;
      AWe.getMinorTicks = P$.getMinorTicks, AWe.getLabel = P$.getLabel;
      function loe(s, a) {
        return LFt(s, tx(a));
      }
      LE.registerClass(Rwe);
      var FFt = Rwe, VFt = function() {
        function s(a, n6, f6) {
          this._prepareParams(a, n6, f6);
        }
        return s.prototype._prepareParams = function(a, n6, f6) {
          f6[1] < f6[0] && (f6 = [NaN, NaN]), this._dataMin = f6[0], this._dataMax = f6[1];
          var d4 = this._isOrdinal = a.type === "ordinal";
          this._needCrossZero = a.type === "interval" && n6.getNeedCrossZero && n6.getNeedCrossZero();
          var y4 = this._modelMinRaw = n6.get("min", true);
          jo(y4) ? this._modelMinNum = uoe(a, y4({ min: f6[0], max: f6[1] })) : y4 !== "dataMin" && (this._modelMinNum = uoe(a, y4));
          var _ = this._modelMaxRaw = n6.get("max", true);
          if (jo(_) ? this._modelMaxNum = uoe(a, _({ min: f6[0], max: f6[1] })) : _ !== "dataMax" && (this._modelMaxNum = uoe(a, _)), d4)
            this._axisDataLen = n6.getCategories().length;
          else {
            var S = n6.get("boundaryGap"), T = Di(S) ? S : [S || 0, S || 0];
            typeof T[0] == "boolean" || typeof T[1] == "boolean" ? this._boundaryGapInner = [0, 0] : this._boundaryGapInner = [H1(T[0], 1), H1(T[1], 1)];
          }
        }, s.prototype.calculate = function() {
          var a = this._isOrdinal, n6 = this._dataMin, f6 = this._dataMax, d4 = this._axisDataLen, y4 = this._boundaryGapInner, _ = a ? null : f6 - n6 || Math.abs(n6), S = this._modelMinRaw === "dataMin" ? n6 : this._modelMinNum, T = this._modelMaxRaw === "dataMax" ? f6 : this._modelMaxNum, E = S != null, O = T != null;
          S == null && (S = a ? d4 ? 0 : NaN : n6 - y4[0] * _), T == null && (T = a ? d4 ? d4 - 1 : NaN : f6 + y4[1] * _), (S == null || !isFinite(S)) && (S = NaN), (T == null || !isFinite(T)) && (T = NaN);
          var R = BL(S) || BL(T) || a && !d4;
          this._needCrossZero && (S > 0 && T > 0 && !E && (S = 0), S < 0 && T < 0 && !O && (T = 0));
          var V = this._determinedMin, z3 = this._determinedMax;
          return V != null && (S = V, E = true), z3 != null && (T = z3, O = true), { min: S, max: T, minFixed: E, maxFixed: O, isBlank: R };
        }, s.prototype.modifyDataMinMax = function(a, n6) {
          this[zFt[a]] = n6;
        }, s.prototype.setDeterminedMinMax = function(a, n6) {
          var f6 = BFt[a];
          this[f6] = n6;
        }, s.prototype.freeze = function() {
          this.frozen = true;
        }, s;
      }(), BFt = { min: "_determinedMin", max: "_determinedMax" }, zFt = { min: "_dataMin", max: "_dataMax" };
      function IWe(s, a, n6) {
        var f6 = s.rawExtentInfo;
        return f6 || (f6 = new VFt(s, a, n6), s.rawExtentInfo = f6, f6);
      }
      function uoe(s, a) {
        return a == null ? null : BL(a) ? NaN : s.parse(a);
      }
      function EWe(s, a) {
        var n6 = s.type, f6 = IWe(s, a, s.getExtent()).calculate();
        s.setBlank(f6.isBlank);
        var d4 = f6.min, y4 = f6.max, _ = a.ecModel;
        if (_ && n6 === "time") {
          var S = gWe("bar", _), T = false;
          if (gt(S, function(R) {
            T = T || R.getBaseAxis() === a.axis;
          }), T) {
            var E = yWe(S), O = jFt(d4, y4, a, E);
            d4 = O.min, y4 = O.max;
          }
        }
        return { extent: [d4, y4], fixMin: f6.minFixed, fixMax: f6.maxFixed };
      }
      function jFt(s, a, n6, f6) {
        var d4 = n6.axis.getExtent(), y4 = d4[1] - d4[0], _ = CFt(f6, n6.axis);
        if (_ === void 0)
          return { min: s, max: a };
        var S = 1 / 0;
        gt(_, function(z3) {
          S = Math.min(z3.offset, S);
        });
        var T = -1 / 0;
        gt(_, function(z3) {
          T = Math.max(z3.offset + z3.width, T);
        }), S = Math.abs(S), T = Math.abs(T);
        var E = S + T, O = a - s, R = 1 - (S + T) / y4, V = O / R - O;
        return a += V * (T / E), s -= V * (S / E), { min: s, max: a };
      }
      function H7(s, a) {
        var n6 = a, f6 = EWe(s, n6), d4 = f6.extent, y4 = n6.get("splitNumber");
        s instanceof FFt && (s.base = n6.get("logBase"));
        var _ = s.type, S = n6.get("interval"), T = _ === "interval" || _ === "time";
        s.setExtent(d4[0], d4[1]), s.calcNiceExtent({ splitNumber: y4, fixMin: f6.fixMin, fixMax: f6.fixMax, minInterval: T ? n6.get("minInterval") : null, maxInterval: T ? n6.get("maxInterval") : null }), S != null && s.setInterval && s.setInterval(S);
      }
      function coe(s, a) {
        if (a = a || s.get("type"), a)
          switch (a) {
            case "category":
              return new kwe({ ordinalMeta: s.getOrdinalMeta ? s.getOrdinalMeta() : s.getCategories(), extent: [1 / 0, -1 / 0] });
            case "time":
              return new MWe({ locale: s.ecModel.getLocaleModel(), useUTC: s.ecModel.get("useUTC") });
            default:
              return new (LE.getClass(a) || n3)();
          }
      }
      function GFt(s) {
        var a = s.scale.getExtent(), n6 = a[0], f6 = a[1];
        return !(n6 > 0 && f6 > 0 || n6 < 0 && f6 < 0);
      }
      function L$(s) {
        var a = s.getLabelModel().get("formatter"), n6 = s.type === "category" ? s.scale.getExtent()[0] : null;
        return s.scale.type === "time" ? function(f6) {
          return function(d4, y4) {
            return s.scale.getFormattedLabel(d4, y4, f6);
          };
        }(a) : Wa(a) ? function(f6) {
          return function(d4) {
            var y4 = s.scale.getLabel(d4), _ = f6.replace("{value}", y4 != null ? y4 : "");
            return _;
          };
        }(a) : jo(a) ? function(f6) {
          return function(d4, y4) {
            return n6 != null && (y4 = d4.value - n6), f6(Nwe(s, d4), y4, d4.level != null ? { level: d4.level } : null);
          };
        }(a) : function(f6) {
          return s.scale.getLabel(f6);
        };
      }
      function Nwe(s, a) {
        return s.type === "category" ? s.scale.getLabel(a) : a.value;
      }
      function HFt(s) {
        var a = s.model, n6 = s.scale;
        if (!(!a.get(["axisLabel", "show"]) || n6.isBlank())) {
          var f6, d4, y4 = n6.getExtent();
          n6 instanceof kwe ? d4 = n6.count() : (f6 = n6.getTicks(), d4 = f6.length);
          var _ = s.getLabelModel(), S = L$(s), T, E = 1;
          d4 > 40 && (E = Math.ceil(d4 / 40));
          for (var O = 0; O < d4; O += E) {
            var R = f6 ? f6[O] : { value: y4[0] + O }, V = S(R, O), z3 = _.getTextRect(V), H = WFt(z3, _.get("rotate") || 0);
            T ? T.union(H) : T = H;
          }
          return T;
        }
      }
      function WFt(s, a) {
        var n6 = a * Math.PI / 180, f6 = s.width, d4 = s.height, y4 = f6 * Math.abs(Math.cos(n6)) + Math.abs(d4 * Math.sin(n6)), _ = f6 * Math.abs(Math.sin(n6)) + Math.abs(d4 * Math.cos(n6)), S = new il(s.x, s.y, y4, _);
        return S;
      }
      function Fwe(s) {
        var a = s.get("interval");
        return a == null ? "auto" : a;
      }
      function DWe(s) {
        return s.type === "category" && Fwe(s.getLabelModel()) === 0;
      }
      function foe(s, a) {
        var n6 = {};
        return gt(s.mapDimensionsAll(a), function(f6) {
          n6[uWe(s, f6)] = true;
        }), Wl(n6);
      }
      function UFt(s, a, n6) {
        a && gt(foe(a, n6), function(f6) {
          var d4 = a.getApproximateExtent(f6);
          d4[0] < s[0] && (s[0] = d4[0]), d4[1] > s[1] && (s[1] = d4[1]);
        });
      }
      var R$ = function() {
        function s() {
        }
        return s.prototype.getNeedCrossZero = function() {
          var a = this.option;
          return !a.scale;
        }, s.prototype.getCoordSysModel = function() {
        }, s;
      }(), qFt = 1e-8;
      function kWe(s, a) {
        return Math.abs(s - a) < qFt;
      }
      function HR(s, a, n6) {
        var f6 = 0, d4 = s[0];
        if (!d4)
          return false;
        for (var y4 = 1; y4 < s.length; y4++) {
          var _ = s[y4];
          f6 += yC(d4[0], d4[1], _[0], _[1], a, n6), d4 = _;
        }
        var S = s[0];
        return (!kWe(d4[0], S[0]) || !kWe(d4[1], S[1])) && (f6 += yC(d4[0], d4[1], S[0], S[1], a, n6)), f6 !== 0;
      }
      var $Ft = [];
      function Vwe(s, a) {
        for (var n6 = 0; n6 < s.length; n6++)
          Xv(s[n6], s[n6], a);
      }
      function OWe(s, a, n6, f6) {
        for (var d4 = 0; d4 < s.length; d4++) {
          var y4 = s[d4];
          f6 && (y4 = f6.project(y4)), y4 && isFinite(y4[0]) && isFinite(y4[1]) && (H_(a, a, y4), G1(n6, n6, y4));
        }
      }
      function XFt(s) {
        for (var a = 0, n6 = 0, f6 = 0, d4 = s.length, y4 = s[d4 - 1][0], _ = s[d4 - 1][1], S = 0; S < d4; S++) {
          var T = s[S][0], E = s[S][1], O = y4 * E - T * _;
          a += O, n6 += (y4 + T) * O, f6 += (_ + E) * O, y4 = T, _ = E;
        }
        return a ? [n6 / a / 3, f6 / a / 3, a] : [s[0][0] || 0, s[0][1] || 0];
      }
      var PWe = function() {
        function s(a) {
          this.name = a;
        }
        return s.prototype.setCenter = function(a) {
          this._center = a;
        }, s.prototype.getCenter = function() {
          var a = this._center;
          return a || (a = this._center = this.calcCenter()), a;
        }, s;
      }(), LWe = function() {
        function s(a, n6) {
          this.type = "polygon", this.exterior = a, this.interiors = n6;
        }
        return s;
      }(), RWe = function() {
        function s(a) {
          this.type = "linestring", this.points = a;
        }
        return s;
      }(), NWe = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this, n6) || this;
          return y4.type = "geoJSON", y4.geometries = f6, y4._center = d4 && [d4[0], d4[1]], y4;
        }
        return a.prototype.calcCenter = function() {
          for (var n6 = this.geometries, f6, d4 = 0, y4 = 0; y4 < n6.length; y4++) {
            var _ = n6[y4], S = _.exterior, T = S && S.length;
            T > d4 && (f6 = _, d4 = T);
          }
          if (f6)
            return XFt(f6.exterior);
          var E = this.getBoundingRect();
          return [E.x + E.width / 2, E.y + E.height / 2];
        }, a.prototype.getBoundingRect = function(n6) {
          var f6 = this._rect;
          if (f6 && !n6)
            return f6;
          var d4 = [1 / 0, 1 / 0], y4 = [-1 / 0, -1 / 0], _ = this.geometries;
          return gt(_, function(S) {
            S.type === "polygon" ? OWe(S.exterior, d4, y4, n6) : gt(S.points, function(T) {
              OWe(T, d4, y4, n6);
            });
          }), isFinite(d4[0]) && isFinite(d4[1]) && isFinite(y4[0]) && isFinite(y4[1]) || (d4[0] = d4[1] = y4[0] = y4[1] = 0), f6 = new il(d4[0], d4[1], y4[0] - d4[0], y4[1] - d4[1]), n6 || (this._rect = f6), f6;
        }, a.prototype.contain = function(n6) {
          var f6 = this.getBoundingRect(), d4 = this.geometries;
          if (!f6.contain(n6[0], n6[1]))
            return false;
          e:
            for (var y4 = 0, _ = d4.length; y4 < _; y4++) {
              var S = d4[y4];
              if (S.type === "polygon") {
                var T = S.exterior, E = S.interiors;
                if (HR(T, n6[0], n6[1])) {
                  for (var O = 0; O < (E ? E.length : 0); O++)
                    if (HR(E[O], n6[0], n6[1]))
                      continue e;
                  return true;
                }
              }
            }
          return false;
        }, a.prototype.transformTo = function(n6, f6, d4, y4) {
          var _ = this.getBoundingRect(), S = _.width / _.height;
          d4 ? y4 || (y4 = d4 / S) : d4 = S * y4;
          for (var T = new il(n6, f6, d4, y4), E = _.calculateTransform(T), O = this.geometries, R = 0; R < O.length; R++) {
            var V = O[R];
            V.type === "polygon" ? (Vwe(V.exterior, E), gt(V.interiors, function(z3) {
              Vwe(z3, E);
            })) : gt(V.points, function(z3) {
              Vwe(z3, E);
            });
          }
          _ = this._rect, _.copy(T), this._center = [_.x + _.width / 2, _.y + _.height / 2];
        }, a.prototype.cloneShallow = function(n6) {
          n6 == null && (n6 = this.name);
          var f6 = new a(n6, this.geometries, this._center);
          return f6._rect = this._rect, f6.transformTo = null, f6;
        }, a;
      }(PWe), YFt = function(s) {
        Vt(a, s);
        function a(n6, f6) {
          var d4 = s.call(this, n6) || this;
          return d4.type = "geoSVG", d4._elOnlyForCalculate = f6, d4;
        }
        return a.prototype.calcCenter = function() {
          for (var n6 = this._elOnlyForCalculate, f6 = n6.getBoundingRect(), d4 = [f6.x + f6.width / 2, f6.y + f6.height / 2], y4 = rR($Ft), _ = n6; _ && !_.isGeoSVGGraphicRoot; )
            cC(y4, _.getLocalTransform(), y4), _ = _.parent;
          return aE(y4, y4), Xv(d4, d4, y4), d4;
        }, a;
      }(PWe);
      function KFt(s) {
        if (!s.UTF8Encoding)
          return s;
        var a = s, n6 = a.UTF8Scale;
        n6 == null && (n6 = 1024);
        var f6 = a.features;
        return gt(f6, function(d4) {
          var y4 = d4.geometry, _ = y4.encodeOffsets, S = y4.coordinates;
          if (_)
            switch (y4.type) {
              case "LineString":
                y4.coordinates = FWe(S, _, n6);
                break;
              case "Polygon":
                Bwe(S, _, n6);
                break;
              case "MultiLineString":
                Bwe(S, _, n6);
                break;
              case "MultiPolygon":
                gt(S, function(T, E) {
                  return Bwe(T, _[E], n6);
                });
            }
        }), a.UTF8Encoding = false, a;
      }
      function Bwe(s, a, n6) {
        for (var f6 = 0; f6 < s.length; f6++)
          s[f6] = FWe(s[f6], a[f6], n6);
      }
      function FWe(s, a, n6) {
        for (var f6 = [], d4 = a[0], y4 = a[1], _ = 0; _ < s.length; _ += 2) {
          var S = s.charCodeAt(_) - 64, T = s.charCodeAt(_ + 1) - 64;
          S = S >> 1 ^ -(S & 1), T = T >> 1 ^ -(T & 1), S += d4, T += y4, d4 = S, y4 = T, f6.push([S / n6, T / n6]);
        }
        return f6;
      }
      function ZFt(s, a) {
        return s = KFt(s), Pi(tf(s.features, function(n6) {
          return n6.geometry && n6.properties && n6.geometry.coordinates.length > 0;
        }), function(n6) {
          var f6 = n6.properties, d4 = n6.geometry, y4 = [];
          switch (d4.type) {
            case "Polygon":
              var _ = d4.coordinates;
              y4.push(new LWe(_[0], _.slice(1)));
              break;
            case "MultiPolygon":
              gt(d4.coordinates, function(T) {
                T[0] && y4.push(new LWe(T[0], T.slice(1)));
              });
              break;
            case "LineString":
              y4.push(new RWe([d4.coordinates]));
              break;
            case "MultiLineString":
              y4.push(new RWe(d4.coordinates));
          }
          var S = new NWe(f6[a || "name"], y4, f6.cp);
          return S.properties = f6, S;
        });
      }
      var N$ = hu();
      function JFt(s) {
        return s.type === "category" ? e8t(s) : n8t(s);
      }
      function QFt(s, a) {
        return s.type === "category" ? t8t(s, a) : { ticks: Pi(s.scale.getTicks(), function(n6) {
          return n6.value;
        }) };
      }
      function e8t(s) {
        var a = s.getLabelModel(), n6 = VWe(s, a);
        return !a.get("show") || s.scale.isBlank() ? { labels: [], labelCategoryInterval: n6.labelCategoryInterval } : n6;
      }
      function VWe(s, a) {
        var n6 = BWe(s, "labels"), f6 = Fwe(a), d4 = zWe(n6, f6);
        if (d4)
          return d4;
        var y4, _;
        return jo(f6) ? y4 = HWe(s, f6) : (_ = f6 === "auto" ? r8t(s) : f6, y4 = GWe(s, _)), jWe(n6, f6, { labels: y4, labelCategoryInterval: _ });
      }
      function t8t(s, a) {
        var n6 = BWe(s, "ticks"), f6 = Fwe(a), d4 = zWe(n6, f6);
        if (d4)
          return d4;
        var y4, _;
        if ((!a.get("show") || s.scale.isBlank()) && (y4 = []), jo(f6))
          y4 = HWe(s, f6, true);
        else if (f6 === "auto") {
          var S = VWe(s, s.getLabelModel());
          _ = S.labelCategoryInterval, y4 = Pi(S.labels, function(T) {
            return T.tickValue;
          });
        } else
          _ = f6, y4 = GWe(s, _, true);
        return jWe(n6, f6, { ticks: y4, tickCategoryInterval: _ });
      }
      function n8t(s) {
        var a = s.scale.getTicks(), n6 = L$(s);
        return { labels: Pi(a, function(f6, d4) {
          return { level: f6.level, formattedLabel: n6(f6, d4), rawLabel: s.scale.getLabel(f6), tickValue: f6.value };
        }) };
      }
      function BWe(s, a) {
        return N$(s)[a] || (N$(s)[a] = []);
      }
      function zWe(s, a) {
        for (var n6 = 0; n6 < s.length; n6++)
          if (s[n6].key === a)
            return s[n6].value;
      }
      function jWe(s, a, n6) {
        return s.push({ key: a, value: n6 }), n6;
      }
      function r8t(s) {
        var a = N$(s).autoInterval;
        return a != null ? a : N$(s).autoInterval = s.calculateCategoryInterval();
      }
      function i8t(s) {
        var a = a8t(s), n6 = L$(s), f6 = (a.axisRotate - a.labelRotate) / 180 * Math.PI, d4 = s.scale, y4 = d4.getExtent(), _ = d4.count();
        if (y4[1] - y4[0] < 1)
          return 0;
        var S = 1;
        _ > 40 && (S = Math.max(1, Math.floor(_ / 40)));
        for (var T = y4[0], E = s.dataToCoord(T + 1) - s.dataToCoord(T), O = Math.abs(E * Math.cos(f6)), R = Math.abs(E * Math.sin(f6)), V = 0, z3 = 0; T <= y4[1]; T += S) {
          var H = 0, Z = 0, ee = cE(n6({ value: T }), a.font, "center", "top");
          H = ee.width * 1.3, Z = ee.height * 1.3, V = Math.max(V, H, 7), z3 = Math.max(z3, Z, 7);
        }
        var oe = V / O, fe = z3 / R;
        isNaN(oe) && (oe = 1 / 0), isNaN(fe) && (fe = 1 / 0);
        var _e = Math.max(0, Math.floor(Math.min(oe, fe))), pe = N$(s.model), Ve = s.getExtent(), Le = pe.lastAutoInterval, je = pe.lastTickCount;
        return Le != null && je != null && Math.abs(Le - _e) <= 1 && Math.abs(je - _) <= 1 && Le > _e && pe.axisExtent0 === Ve[0] && pe.axisExtent1 === Ve[1] ? _e = Le : (pe.lastTickCount = _, pe.lastAutoInterval = _e, pe.axisExtent0 = Ve[0], pe.axisExtent1 = Ve[1]), _e;
      }
      function a8t(s) {
        var a = s.getLabelModel();
        return { axisRotate: s.getRotate ? s.getRotate() : s.isHorizontal && !s.isHorizontal() ? 90 : 0, labelRotate: a.get("rotate") || 0, font: a.getFont() };
      }
      function GWe(s, a, n6) {
        var f6 = L$(s), d4 = s.scale, y4 = d4.getExtent(), _ = s.getLabelModel(), S = [], T = Math.max((a || 0) + 1, 1), E = y4[0], O = d4.count();
        E !== 0 && T > 1 && O / T > 2 && (E = Math.round(Math.ceil(E / T) * T));
        var R = DWe(s), V = _.get("showMinLabel") || R, z3 = _.get("showMaxLabel") || R;
        V && E !== y4[0] && Z(y4[0]);
        for (var H = E; H <= y4[1]; H += T)
          Z(H);
        z3 && H - T !== y4[1] && Z(y4[1]);
        function Z(ee) {
          var oe = { value: ee };
          S.push(n6 ? ee : { formattedLabel: f6(oe), rawLabel: d4.getLabel(oe), tickValue: ee });
        }
        return S;
      }
      function HWe(s, a, n6) {
        var f6 = s.scale, d4 = L$(s), y4 = [];
        return gt(f6.getTicks(), function(_) {
          var S = f6.getLabel(_), T = _.value;
          a(_.value, S) && y4.push(n6 ? T : { formattedLabel: d4(_), rawLabel: S, tickValue: T });
        }), y4;
      }
      var WWe = [0, 1], o8t = function() {
        function s(a, n6, f6) {
          this.onBand = false, this.inverse = false, this.dim = a, this.scale = n6, this._extent = f6 || [0, 0];
        }
        return s.prototype.contain = function(a) {
          var n6 = this._extent, f6 = Math.min(n6[0], n6[1]), d4 = Math.max(n6[0], n6[1]);
          return a >= f6 && a <= d4;
        }, s.prototype.containData = function(a) {
          return this.scale.contain(a);
        }, s.prototype.getExtent = function() {
          return this._extent.slice();
        }, s.prototype.getPixelPrecision = function(a) {
          return qU(a || this.scale.getExtent(), this._extent);
        }, s.prototype.setExtent = function(a, n6) {
          var f6 = this._extent;
          f6[0] = a, f6[1] = n6;
        }, s.prototype.dataToCoord = function(a, n6) {
          var f6 = this._extent, d4 = this.scale;
          return a = d4.normalize(a), this.onBand && d4.type === "ordinal" && (f6 = f6.slice(), UWe(f6, d4.count())), zu(a, WWe, f6, n6);
        }, s.prototype.coordToData = function(a, n6) {
          var f6 = this._extent, d4 = this.scale;
          this.onBand && d4.type === "ordinal" && (f6 = f6.slice(), UWe(f6, d4.count()));
          var y4 = zu(a, f6, WWe, n6);
          return this.scale.scale(y4);
        }, s.prototype.pointToData = function(a, n6) {
        }, s.prototype.getTicksCoords = function(a) {
          a = a || {};
          var n6 = a.tickModel || this.getTickModel(), f6 = QFt(this, n6), d4 = f6.ticks, y4 = Pi(d4, function(S) {
            return { coord: this.dataToCoord(this.scale.type === "ordinal" ? this.scale.getRawOrdinalNumber(S) : S), tickValue: S };
          }, this), _ = n6.get("alignWithLabel");
          return s8t(this, y4, _, a.clamp), y4;
        }, s.prototype.getMinorTicksCoords = function() {
          if (this.scale.type === "ordinal")
            return [];
          var a = this.model.getModel("minorTick"), n6 = a.get("splitNumber");
          n6 > 0 && n6 < 100 || (n6 = 5);
          var f6 = this.scale.getMinorTicks(n6), d4 = Pi(f6, function(y4) {
            return Pi(y4, function(_) {
              return { coord: this.dataToCoord(_), tickValue: _ };
            }, this);
          }, this);
          return d4;
        }, s.prototype.getViewLabels = function() {
          return JFt(this).labels;
        }, s.prototype.getLabelModel = function() {
          return this.model.getModel("axisLabel");
        }, s.prototype.getTickModel = function() {
          return this.model.getModel("axisTick");
        }, s.prototype.getBandWidth = function() {
          var a = this._extent, n6 = this.scale.getExtent(), f6 = n6[1] - n6[0] + (this.onBand ? 1 : 0);
          f6 === 0 && (f6 = 1);
          var d4 = Math.abs(a[1] - a[0]);
          return Math.abs(d4) / f6;
        }, s.prototype.calculateCategoryInterval = function() {
          return i8t(this);
        }, s;
      }();
      function UWe(s, a) {
        var n6 = s[1] - s[0], f6 = a, d4 = n6 / f6 / 2;
        s[0] += d4, s[1] -= d4;
      }
      function s8t(s, a, n6, f6) {
        var d4 = a.length;
        if (!s.onBand || n6 || !d4)
          return;
        var y4 = s.getExtent(), _, S;
        if (d4 === 1)
          a[0].coord = y4[0], _ = a[1] = { coord: y4[0] };
        else {
          var T = a[d4 - 1].tickValue - a[0].tickValue, E = (a[d4 - 1].coord - a[0].coord) / T;
          gt(a, function(z3) {
            z3.coord -= E / 2;
          });
          var O = s.scale.getExtent();
          S = 1 + O[1] - a[d4 - 1].tickValue, _ = { coord: a[d4 - 1].coord + E * S }, a.push(_);
        }
        var R = y4[0] > y4[1];
        V(a[0].coord, y4[0]) && (f6 ? a[0].coord = y4[0] : a.shift()), f6 && V(y4[0], a[0].coord) && a.unshift({ coord: y4[0] }), V(y4[1], _.coord) && (f6 ? _.coord = y4[1] : a.pop()), f6 && V(_.coord, y4[1]) && a.push({ coord: y4[1] });
        function V(z3, H) {
          return z3 = Wp(z3), H = Wp(H), R ? z3 > H : z3 < H;
        }
      }
      var xC = o8t, F$ = Math.PI * 2, WR = aS.CMD, l8t = ["top", "right", "bottom", "left"];
      function u8t(s, a, n6, f6, d4) {
        var y4 = n6.width, _ = n6.height;
        switch (s) {
          case "top":
            f6.set(n6.x + y4 / 2, n6.y - a), d4.set(0, -1);
            break;
          case "bottom":
            f6.set(n6.x + y4 / 2, n6.y + _ + a), d4.set(0, 1);
            break;
          case "left":
            f6.set(n6.x - a, n6.y + _ / 2), d4.set(-1, 0);
            break;
          case "right":
            f6.set(n6.x + y4 + a, n6.y + _ / 2), d4.set(1, 0);
            break;
        }
      }
      function c8t(s, a, n6, f6, d4, y4, _, S, T) {
        _ -= s, S -= a;
        var E = Math.sqrt(_ * _ + S * S);
        _ /= E, S /= E;
        var O = _ * n6 + s, R = S * n6 + a;
        if (Math.abs(f6 - d4) % F$ < 1e-4)
          return T[0] = O, T[1] = R, E - n6;
        if (y4) {
          var V = f6;
          f6 = MT(d4), d4 = MT(V);
        } else
          f6 = MT(f6), d4 = MT(d4);
        f6 > d4 && (d4 += F$);
        var z3 = Math.atan2(S, _);
        if (z3 < 0 && (z3 += F$), z3 >= f6 && z3 <= d4 || z3 + F$ >= f6 && z3 + F$ <= d4)
          return T[0] = O, T[1] = R, E - n6;
        var H = n6 * Math.cos(f6) + s, Z = n6 * Math.sin(f6) + a, ee = n6 * Math.cos(d4) + s, oe = n6 * Math.sin(d4) + a, fe = (H - _) * (H - _) + (Z - S) * (Z - S), _e = (ee - _) * (ee - _) + (oe - S) * (oe - S);
        return fe < _e ? (T[0] = H, T[1] = Z, Math.sqrt(fe)) : (T[0] = ee, T[1] = oe, Math.sqrt(_e));
      }
      function hoe(s, a, n6, f6, d4, y4, _, S) {
        var T = d4 - s, E = y4 - a, O = n6 - s, R = f6 - a, V = Math.sqrt(O * O + R * R);
        O /= V, R /= V;
        var z3 = T * O + E * R, H = z3 / V;
        S && (H = Math.min(Math.max(H, 0), 1)), H *= V;
        var Z = _[0] = s + H * O, ee = _[1] = a + H * R;
        return Math.sqrt((Z - d4) * (Z - d4) + (ee - y4) * (ee - y4));
      }
      function qWe(s, a, n6, f6, d4, y4, _) {
        n6 < 0 && (s = s + n6, n6 = -n6), f6 < 0 && (a = a + f6, f6 = -f6);
        var S = s + n6, T = a + f6, E = _[0] = Math.min(Math.max(d4, s), S), O = _[1] = Math.min(Math.max(y4, a), T);
        return Math.sqrt((E - d4) * (E - d4) + (O - y4) * (O - y4));
      }
      var wC = [];
      function f8t(s, a, n6) {
        var f6 = qWe(a.x, a.y, a.width, a.height, s.x, s.y, wC);
        return n6.set(wC[0], wC[1]), f6;
      }
      function h8t(s, a, n6) {
        for (var f6 = 0, d4 = 0, y4 = 0, _ = 0, S, T, E = 1 / 0, O = a.data, R = s.x, V = s.y, z3 = 0; z3 < O.length; ) {
          var H = O[z3++];
          z3 === 1 && (f6 = O[z3], d4 = O[z3 + 1], y4 = f6, _ = d4);
          var Z = E;
          switch (H) {
            case WR.M:
              y4 = O[z3++], _ = O[z3++], f6 = y4, d4 = _;
              break;
            case WR.L:
              Z = hoe(f6, d4, O[z3], O[z3 + 1], R, V, wC, true), f6 = O[z3++], d4 = O[z3++];
              break;
            case WR.C:
              Z = ZL(f6, d4, O[z3++], O[z3++], O[z3++], O[z3++], O[z3], O[z3 + 1], R, V, wC), f6 = O[z3++], d4 = O[z3++];
              break;
            case WR.Q:
              Z = Dg(f6, d4, O[z3++], O[z3++], O[z3], O[z3 + 1], R, V, wC), f6 = O[z3++], d4 = O[z3++];
              break;
            case WR.A:
              var ee = O[z3++], oe = O[z3++], fe = O[z3++], _e = O[z3++], pe = O[z3++], Ve = O[z3++];
              z3 += 1;
              var Le = !!(1 - O[z3++]);
              S = Math.cos(pe) * fe + ee, T = Math.sin(pe) * _e + oe, z3 <= 1 && (y4 = S, _ = T);
              var je = (R - ee) * _e / fe + ee;
              Z = c8t(ee, oe, _e, pe, pe + Ve, Le, je, V, wC), f6 = Math.cos(pe + Ve) * fe + ee, d4 = Math.sin(pe + Ve) * _e + oe;
              break;
            case WR.R:
              y4 = f6 = O[z3++], _ = d4 = O[z3++];
              var Xe = O[z3++], Ye = O[z3++];
              Z = qWe(y4, _, Xe, Ye, R, V, wC);
              break;
            case WR.Z:
              Z = hoe(f6, d4, y4, _, R, V, wC, true), f6 = y4, d4 = _;
              break;
          }
          Z < E && (E = Z, n6.set(wC[0], wC[1]));
        }
        return E;
      }
      var SC = new zs(), Mh = new zs(), Jd = new zs(), NT = new zs(), FT = new zs();
      function $We(s, a) {
        if (s) {
          var n6 = s.getTextGuideLine(), f6 = s.getTextContent();
          if (f6 && n6) {
            var d4 = s.textGuideLineConfig || {}, y4 = [[0, 0], [0, 0], [0, 0]], _ = d4.candidates || l8t, S = f6.getBoundingRect().clone();
            S.applyTransform(f6.getComputedTransform());
            var T = 1 / 0, E = d4.anchor, O = s.getComputedTransform(), R = O && aE([], O), V = a.get("length2") || 0;
            E && Jd.copy(E);
            for (var z3 = 0; z3 < _.length; z3++) {
              var H = _[z3];
              u8t(H, 0, S, SC, NT), zs.scaleAndAdd(Mh, SC, NT, V), Mh.transform(R);
              var Z = s.getBoundingRect(), ee = E ? E.distance(Mh) : s instanceof ml ? h8t(Mh, s.path, Jd) : f8t(Mh, Z, Jd);
              ee < T && (T = ee, Mh.transform(O), Jd.transform(O), Jd.toArray(y4[0]), Mh.toArray(y4[1]), SC.toArray(y4[2]));
            }
            XWe(y4, a.get("minTurnAngle")), n6.setShape({ points: y4 });
          }
        }
      }
      var poe = [], Z1 = new zs();
      function XWe(s, a) {
        if (a <= 180 && a > 0) {
          a = a / 180 * Math.PI, SC.fromArray(s[0]), Mh.fromArray(s[1]), Jd.fromArray(s[2]), zs.sub(NT, SC, Mh), zs.sub(FT, Jd, Mh);
          var n6 = NT.len(), f6 = FT.len();
          if (!(n6 < 1e-3 || f6 < 1e-3)) {
            NT.scale(1 / n6), FT.scale(1 / f6);
            var d4 = NT.dot(FT), y4 = Math.cos(a);
            if (y4 < d4) {
              var _ = hoe(Mh.x, Mh.y, Jd.x, Jd.y, SC.x, SC.y, poe, false);
              Z1.fromArray(poe), Z1.scaleAndAdd(FT, _ / Math.tan(Math.PI - a));
              var S = Jd.x !== Mh.x ? (Z1.x - Mh.x) / (Jd.x - Mh.x) : (Z1.y - Mh.y) / (Jd.y - Mh.y);
              if (isNaN(S))
                return;
              S < 0 ? zs.copy(Z1, Mh) : S > 1 && zs.copy(Z1, Jd), Z1.toArray(s[1]);
            }
          }
        }
      }
      function p8t(s, a, n6) {
        if (n6 <= 180 && n6 > 0) {
          n6 = n6 / 180 * Math.PI, SC.fromArray(s[0]), Mh.fromArray(s[1]), Jd.fromArray(s[2]), zs.sub(NT, Mh, SC), zs.sub(FT, Jd, Mh);
          var f6 = NT.len(), d4 = FT.len();
          if (!(f6 < 1e-3 || d4 < 1e-3)) {
            NT.scale(1 / f6), FT.scale(1 / d4);
            var y4 = NT.dot(a), _ = Math.cos(n6);
            if (y4 < _) {
              var S = hoe(Mh.x, Mh.y, Jd.x, Jd.y, SC.x, SC.y, poe, false);
              Z1.fromArray(poe);
              var T = Math.PI / 2, E = Math.acos(FT.dot(a)), O = T + E - n6;
              if (O >= T)
                zs.copy(Z1, Jd);
              else {
                Z1.scaleAndAdd(FT, S / Math.tan(Math.PI / 2 - O));
                var R = Jd.x !== Mh.x ? (Z1.x - Mh.x) / (Jd.x - Mh.x) : (Z1.y - Mh.y) / (Jd.y - Mh.y);
                if (isNaN(R))
                  return;
                R < 0 ? zs.copy(Z1, Mh) : R > 1 && zs.copy(Z1, Jd);
              }
              Z1.toArray(s[1]);
            }
          }
        }
      }
      function YWe(s, a, n6, f6) {
        var d4 = n6 === "normal", y4 = d4 ? s : s.ensureState(n6);
        y4.ignore = a;
        var _ = f6.get("smooth");
        _ && _ === true && (_ = 0.3), y4.shape = y4.shape || {}, _ > 0 && (y4.shape.smooth = _);
        var S = f6.getModel("lineStyle").getLineStyle();
        d4 ? s.useStyle(S) : y4.style = S;
      }
      function d8t(s, a) {
        var n6 = a.smooth, f6 = a.points;
        if (f6)
          if (s.moveTo(f6[0][0], f6[0][1]), n6 > 0 && f6.length >= 3) {
            var d4 = Zw(f6[0], f6[1]), y4 = Zw(f6[1], f6[2]);
            if (!d4 || !y4) {
              s.lineTo(f6[1][0], f6[1][1]), s.lineTo(f6[2][0], f6[2][1]);
              return;
            }
            var _ = Math.min(d4, y4) * n6, S = c9([], f6[1], f6[0], _ / d4), T = c9([], f6[1], f6[2], _ / y4), E = c9([], S, T, 0.5);
            s.bezierCurveTo(S[0], S[1], S[0], S[1], E[0], E[1]), s.bezierCurveTo(T[0], T[1], T[0], T[1], f6[2][0], f6[2][1]);
          } else
            for (var O = 1; O < f6.length; O++)
              s.lineTo(f6[O][0], f6[O][1]);
      }
      function zwe(s, a, n6) {
        var f6 = s.getTextGuideLine(), d4 = s.getTextContent();
        if (!d4) {
          f6 && s.removeTextGuideLine();
          return;
        }
        for (var y4 = a.normal, _ = y4.get("show"), S = d4.ignore, T = 0; T < SR.length; T++) {
          var E = SR[T], O = a[E], R = E === "normal";
          if (O) {
            var V = O.get("show"), z3 = R ? S : Zs(d4.states[E] && d4.states[E].ignore, S);
            if (z3 || !Zs(V, _)) {
              var H = R ? f6 : f6 && f6.states.normal;
              H && (H.ignore = true);
              continue;
            }
            f6 || (f6 = new zm(), s.setTextGuideLine(f6), !R && (S || !_) && YWe(f6, true, "normal", a.normal), s.stateProxy && (f6.stateProxy = s.stateProxy)), YWe(f6, false, E, O);
          }
        }
        if (f6) {
          zo(f6.style, n6), f6.style.fill = null;
          var Z = y4.get("showAbove"), ee = s.textGuideLineConfig = s.textGuideLineConfig || {};
          ee.showAbove = Z || false, f6.buildPath = d8t;
        }
      }
      function jwe(s, a) {
        a = a || "labelLine";
        for (var n6 = { normal: s.getModel(a) }, f6 = 0; f6 < od.length; f6++) {
          var d4 = od[f6];
          n6[d4] = s.getModel([d4, a]);
        }
        return n6;
      }
      function KWe(s) {
        for (var a = [], n6 = 0; n6 < s.length; n6++) {
          var f6 = s[n6];
          if (!f6.defaultAttr.ignore) {
            var d4 = f6.label, y4 = d4.getComputedTransform(), _ = d4.getBoundingRect(), S = !y4 || y4[1] < 1e-5 && y4[2] < 1e-5, T = d4.style.margin || 0, E = _.clone();
            E.applyTransform(y4), E.x -= T / 2, E.y -= T / 2, E.width += T, E.height += T;
            var O = S ? new x7(_, y4) : null;
            a.push({ label: d4, labelLine: f6.labelLine, rect: E, localRect: _, obb: O, priority: f6.priority, defaultAttr: f6.defaultAttr, layoutOption: f6.computedLayoutOption, axisAligned: S, transform: y4 });
          }
        }
        return a;
      }
      function ZWe(s, a, n6, f6, d4, y4) {
        var _ = s.length;
        if (_ < 2)
          return;
        s.sort(function(Xe, Ye) {
          return Xe.rect[a] - Ye.rect[a];
        });
        for (var S = 0, T, E = false, O = 0, R = 0; R < _; R++) {
          var V = s[R], z3 = V.rect;
          T = z3[a] - S, T < 0 && (z3[a] -= T, V.label[a] -= T, E = true);
          var H = Math.max(-T, 0);
          O += H, S = z3[a] + z3[n6];
        }
        O > 0 && y4 && Ve(-O / _, 0, _);
        var Z = s[0], ee = s[_ - 1], oe, fe;
        _e(), oe < 0 && Le(-oe, 0.8), fe < 0 && Le(fe, 0.8), _e(), pe(oe, fe, 1), pe(fe, oe, -1), _e(), oe < 0 && je(-oe), fe < 0 && je(fe);
        function _e() {
          oe = Z.rect[a] - f6, fe = d4 - ee.rect[a] - ee.rect[n6];
        }
        function pe(Xe, Ye, rt2) {
          if (Xe < 0) {
            var ut = Math.min(Ye, -Xe);
            if (ut > 0) {
              Ve(ut * rt2, 0, _);
              var wt = ut + Xe;
              wt < 0 && Le(-wt * rt2, 1);
            } else
              Le(-Xe * rt2, 1);
          }
        }
        function Ve(Xe, Ye, rt2) {
          Xe !== 0 && (E = true);
          for (var ut = Ye; ut < rt2; ut++) {
            var wt = s[ut], dt = wt.rect;
            dt[a] += Xe, wt.label[a] += Xe;
          }
        }
        function Le(Xe, Ye) {
          for (var rt2 = [], ut = 0, wt = 1; wt < _; wt++) {
            var dt = s[wt - 1].rect, Gt = Math.max(s[wt].rect[a] - dt[a] - dt[n6], 0);
            rt2.push(Gt), ut += Gt;
          }
          if (ut) {
            var Qt = Math.min(Math.abs(Xe) / ut, Ye);
            if (Xe > 0)
              for (var wt = 0; wt < _ - 1; wt++) {
                var Nt = rt2[wt] * Qt;
                Ve(Nt, 0, wt + 1);
              }
            else
              for (var wt = _ - 1; wt > 0; wt--) {
                var Nt = rt2[wt - 1] * Qt;
                Ve(-Nt, wt, _);
              }
          }
        }
        function je(Xe) {
          var Ye = Xe < 0 ? -1 : 1;
          Xe = Math.abs(Xe);
          for (var rt2 = Math.ceil(Xe / (_ - 1)), ut = 0; ut < _ - 1; ut++)
            if (Ye > 0 ? Ve(rt2, 0, ut + 1) : Ve(-rt2, _ - ut - 1, _), Xe -= rt2, Xe <= 0)
              return;
        }
        return E;
      }
      function v8t(s, a, n6, f6) {
        return ZWe(s, "x", "width", a, n6, f6);
      }
      function JWe(s, a, n6, f6) {
        return ZWe(s, "y", "height", a, n6, f6);
      }
      function QWe(s) {
        var a = [];
        s.sort(function(Z, ee) {
          return ee.priority - Z.priority;
        });
        var n6 = new il(0, 0, 0, 0);
        function f6(Z) {
          if (!Z.ignore) {
            var ee = Z.ensureState("emphasis");
            ee.ignore == null && (ee.ignore = false);
          }
          Z.ignore = true;
        }
        for (var d4 = 0; d4 < s.length; d4++) {
          var y4 = s[d4], _ = y4.axisAligned, S = y4.localRect, T = y4.transform, E = y4.label, O = y4.labelLine;
          n6.copy(y4.rect), n6.width -= 0.1, n6.height -= 0.1, n6.x += 0.05, n6.y += 0.05;
          for (var R = y4.obb, V = false, z3 = 0; z3 < a.length; z3++) {
            var H = a[z3];
            if (n6.intersect(H.rect)) {
              if (_ && H.axisAligned) {
                V = true;
                break;
              }
              if (H.obb || (H.obb = new x7(H.localRect, H.transform)), R || (R = new x7(S, T)), R.intersect(H.obb)) {
                V = true;
                break;
              }
            }
          }
          V ? (f6(E), O && f6(O)) : (E.attr("ignore", y4.defaultAttr.ignore), O && O.attr("ignore", y4.defaultAttr.labelGuideIgnore), a.push(y4));
        }
      }
      function g8t(s) {
        if (s) {
          for (var a = [], n6 = 0; n6 < s.length; n6++)
            a.push(s[n6].slice());
          return a;
        }
      }
      function y8t(s, a) {
        var n6 = s.label, f6 = a && a.getTextGuideLine();
        return { dataIndex: s.dataIndex, dataType: s.dataType, seriesIndex: s.seriesModel.seriesIndex, text: s.label.style.text, rect: s.hostRect, labelRect: s.rect, align: n6.style.align, verticalAlign: n6.style.verticalAlign, labelLinePoints: g8t(f6 && f6.shape.points) };
      }
      var eUe = ["align", "verticalAlign", "width", "height", "fontSize"], lx = new Q_(), Gwe = hu(), m8t = hu();
      function doe(s, a, n6) {
        for (var f6 = 0; f6 < n6.length; f6++) {
          var d4 = n6[f6];
          a[d4] != null && (s[d4] = a[d4]);
        }
      }
      var voe = ["x", "y", "rotation"], b8t = function() {
        function s() {
          this._labelList = [], this._chartViewList = [];
        }
        return s.prototype.clearLabels = function() {
          this._labelList = [], this._chartViewList = [];
        }, s.prototype._addLabel = function(a, n6, f6, d4, y4) {
          var _ = d4.style, S = d4.__hostTarget, T = S.textConfig || {}, E = d4.getComputedTransform(), O = d4.getBoundingRect().plain();
          il.applyTransform(O, O, E), E ? lx.setLocalTransform(E) : (lx.x = lx.y = lx.rotation = lx.originX = lx.originY = 0, lx.scaleX = lx.scaleY = 1);
          var R = d4.__hostTarget, V;
          if (R) {
            V = R.getBoundingRect().plain();
            var z3 = R.getComputedTransform();
            il.applyTransform(V, V, z3);
          }
          var H = V && R.getTextGuideLine();
          this._labelList.push({ label: d4, labelLine: H, seriesModel: f6, dataIndex: a, dataType: n6, layoutOption: y4, computedLayoutOption: null, rect: O, hostRect: V, priority: V ? V.width * V.height : 0, defaultAttr: { ignore: d4.ignore, labelGuideIgnore: H && H.ignore, x: lx.x, y: lx.y, scaleX: lx.scaleX, scaleY: lx.scaleY, rotation: lx.rotation, style: { x: _.x, y: _.y, align: _.align, verticalAlign: _.verticalAlign, width: _.width, height: _.height, fontSize: _.fontSize }, cursor: d4.cursor, attachedPos: T.position, attachedRot: T.rotation } });
        }, s.prototype.addLabelsOfSeries = function(a) {
          var n6 = this;
          this._chartViewList.push(a);
          var f6 = a.__model, d4 = f6.get("labelLayout");
          !(jo(d4) || Wl(d4).length) || a.group.traverse(function(y4) {
            if (y4.ignore)
              return true;
            var _ = y4.getTextContent(), S = qo(y4);
            _ && !_.disableLabelLayout && n6._addLabel(S.dataIndex, S.dataType, f6, _, d4);
          });
        }, s.prototype.updateLayoutConfig = function(a) {
          var n6 = a.getWidth(), f6 = a.getHeight();
          function d4(_e, pe) {
            return function() {
              $We(_e, pe);
            };
          }
          for (var y4 = 0; y4 < this._labelList.length; y4++) {
            var _ = this._labelList[y4], S = _.label, T = S.__hostTarget, E = _.defaultAttr, O = void 0;
            jo(_.layoutOption) ? O = _.layoutOption(y8t(_, T)) : O = _.layoutOption, O = O || {}, _.computedLayoutOption = O;
            var R = Math.PI / 180;
            T && T.setTextConfig({ local: false, position: O.x != null || O.y != null ? null : E.attachedPos, rotation: O.rotate != null ? O.rotate * R : E.attachedRot, offset: [O.dx || 0, O.dy || 0] });
            var V = false;
            if (O.x != null ? (S.x = Ia(O.x, n6), S.setStyle("x", 0), V = true) : (S.x = E.x, S.setStyle("x", E.style.x)), O.y != null ? (S.y = Ia(O.y, f6), S.setStyle("y", 0), V = true) : (S.y = E.y, S.setStyle("y", E.style.y)), O.labelLinePoints) {
              var z3 = T.getTextGuideLine();
              z3 && (z3.setShape({ points: O.labelLinePoints }), V = false);
            }
            var H = Gwe(S);
            H.needsUpdateLabelLine = V, S.rotation = O.rotate != null ? O.rotate * R : E.rotation, S.scaleX = E.scaleX, S.scaleY = E.scaleY;
            for (var Z = 0; Z < eUe.length; Z++) {
              var ee = eUe[Z];
              S.setStyle(ee, O[ee] != null ? O[ee] : E.style[ee]);
            }
            if (O.draggable) {
              if (S.draggable = true, S.cursor = "move", T) {
                var oe = _.seriesModel;
                if (_.dataIndex != null) {
                  var fe = _.seriesModel.getData(_.dataType);
                  oe = fe.getItemModel(_.dataIndex);
                }
                S.on("drag", d4(T, oe.getModel("labelLine")));
              }
            } else
              S.off("drag"), S.cursor = E.cursor;
          }
        }, s.prototype.layout = function(a) {
          var n6 = a.getWidth(), f6 = a.getHeight(), d4 = KWe(this._labelList), y4 = tf(d4, function(T) {
            return T.layoutOption.moveOverlap === "shiftX";
          }), _ = tf(d4, function(T) {
            return T.layoutOption.moveOverlap === "shiftY";
          });
          v8t(y4, 0, n6), JWe(_, 0, f6);
          var S = tf(d4, function(T) {
            return T.layoutOption.hideOverlap;
          });
          QWe(S);
        }, s.prototype.processLabelsOverall = function() {
          var a = this;
          gt(this._chartViewList, function(n6) {
            var f6 = n6.__model, d4 = n6.ignoreLabelLineUpdate, y4 = f6.isAnimationEnabled();
            n6.group.traverse(function(_) {
              if (_.ignore && !_.forceLabelAnimation)
                return true;
              var S = !d4, T = _.getTextContent();
              !S && T && (S = Gwe(T).needsUpdateLabelLine), S && a._updateLabelLine(_, f6), y4 && a._animateLabels(_, f6);
            });
          });
        }, s.prototype._updateLabelLine = function(a, n6) {
          var f6 = a.getTextContent(), d4 = qo(a), y4 = d4.dataIndex;
          if (f6 && y4 != null) {
            var _ = n6.getData(d4.dataType), S = _.getItemModel(y4), T = {}, E = _.getItemVisual(y4, "style"), O = _.getVisual("drawType");
            T.stroke = E[O];
            var R = S.getModel("labelLine");
            zwe(a, jwe(S), T), $We(a, R);
          }
        }, s.prototype._animateLabels = function(a, n6) {
          var f6 = a.getTextContent(), d4 = a.getTextGuideLine();
          if (f6 && (a.forceLabelAnimation || !f6.ignore && !f6.invisible && !a.disableLabelAnimation && !$k(a))) {
            var y4 = Gwe(f6), _ = y4.oldLayout, S = qo(a), T = S.dataIndex, E = { x: f6.x, y: f6.y, rotation: f6.rotation }, O = n6.getData(S.dataType);
            if (_) {
              f6.attr(_);
              var R = a.prevStates;
              R && (Ns(R, "select") >= 0 && f6.attr(y4.oldLayoutSelect), Ns(R, "emphasis") >= 0 && f6.attr(y4.oldLayoutEmphasis)), ku(f6, E, n6, T);
            } else if (f6.attr(E), !C7(f6).valueAnimation) {
              var V = Zs(f6.style.opacity, 1);
              f6.style.opacity = 0, $h(f6, { style: { opacity: V } }, n6, T);
            }
            if (y4.oldLayout = E, f6.states.select) {
              var z3 = y4.oldLayoutSelect = {};
              doe(z3, E, voe), doe(z3, f6.states.select, voe);
            }
            if (f6.states.emphasis) {
              var H = y4.oldLayoutEmphasis = {};
              doe(H, E, voe), doe(H, f6.states.emphasis, voe);
            }
            yje(f6, T, O, n6, n6);
          }
          if (d4 && !d4.ignore && !d4.invisible) {
            var y4 = m8t(d4), _ = y4.oldLayout, Z = { points: d4.shape.points };
            _ ? (d4.attr({ shape: _ }), ku(d4, { shape: Z }, n6)) : (d4.setShape(Z), d4.style.strokePercent = 0, $h(d4, { style: { strokePercent: 1 } }, n6)), y4.oldLayout = Z;
          }
        }, s;
      }(), _8t = b8t, Hwe = hu();
      function x8t(s) {
        s.registerUpdateLifecycle("series:beforeupdate", function(a, n6, f6) {
          var d4 = Hwe(n6).labelManager;
          d4 || (d4 = Hwe(n6).labelManager = new _8t()), d4.clearLabels();
        }), s.registerUpdateLifecycle("series:layoutlabels", function(a, n6, f6) {
          var d4 = Hwe(n6).labelManager;
          f6.updatedSeries.forEach(function(y4) {
            d4.addLabelsOfSeries(n6.getViewOfSeriesModel(y4));
          }), d4.updateLayoutConfig(n6), d4.layout(n6), d4.processLabelsOverall();
        });
      }
      var Wwe = Math.sin, Uwe = Math.cos, tUe = Math.PI, UR = Math.PI * 2, w8t = 180 / tUe, S8t = function() {
        function s() {
        }
        return s.prototype.reset = function(a) {
          this._start = true, this._d = [], this._str = "", this._p = Math.pow(10, a || 4);
        }, s.prototype.moveTo = function(a, n6) {
          this._add("M", a, n6);
        }, s.prototype.lineTo = function(a, n6) {
          this._add("L", a, n6);
        }, s.prototype.bezierCurveTo = function(a, n6, f6, d4, y4, _) {
          this._add("C", a, n6, f6, d4, y4, _);
        }, s.prototype.quadraticCurveTo = function(a, n6, f6, d4) {
          this._add("Q", a, n6, f6, d4);
        }, s.prototype.arc = function(a, n6, f6, d4, y4, _) {
          this.ellipse(a, n6, f6, f6, 0, d4, y4, _);
        }, s.prototype.ellipse = function(a, n6, f6, d4, y4, _, S, T) {
          var E = S - _, O = !T, R = Math.abs(E), V = cT(R - UR) || (O ? E >= UR : -E >= UR), z3 = E > 0 ? E % UR : E % UR + UR, H = false;
          V ? H = true : cT(R) ? H = false : H = z3 >= tUe == !!O;
          var Z = a + f6 * Uwe(_), ee = n6 + d4 * Wwe(_);
          this._start && this._add("M", Z, ee);
          var oe = Math.round(y4 * w8t);
          if (V) {
            var fe = 1 / this._p, _e = (O ? 1 : -1) * (UR - fe);
            this._add("A", f6, d4, oe, 1, +O, a + f6 * Uwe(_ + _e), n6 + d4 * Wwe(_ + _e)), fe > 0.01 && this._add("A", f6, d4, oe, 0, +O, Z, ee);
          } else {
            var pe = a + f6 * Uwe(S), Ve = n6 + d4 * Wwe(S);
            this._add("A", f6, d4, oe, +H, +O, pe, Ve);
          }
        }, s.prototype.rect = function(a, n6, f6, d4) {
          this._add("M", a, n6), this._add("l", f6, 0), this._add("l", 0, d4), this._add("l", -f6, 0), this._add("Z");
        }, s.prototype.closePath = function() {
          this._d.length > 0 && this._add("Z");
        }, s.prototype._add = function(a, n6, f6, d4, y4, _, S, T, E) {
          for (var O = [], R = this._p, V = 1; V < arguments.length; V++) {
            var z3 = arguments[V];
            if (isNaN(z3)) {
              this._invalid = true;
              return;
            }
            O.push(Math.round(z3 * R) / R);
          }
          this._d.push(a + O.join(" ")), this._start = a === "Z";
        }, s.prototype.generateStr = function() {
          this._str = this._invalid ? "" : this._d.join(""), this._d = [];
        }, s.prototype.getStr = function() {
          return this._str;
        }, s;
      }(), nUe = S8t, V$ = "none", C8t = Math.round;
      function M8t(s) {
        var a = s.fill;
        return a != null && a !== V$;
      }
      function T8t(s) {
        var a = s.stroke;
        return a != null && a !== V$;
      }
      var qwe = ["lineCap", "miterLimit", "lineJoin"], A8t = Pi(qwe, function(s) {
        return "stroke-" + s.toLowerCase();
      });
      function I8t(s, a, n6, f6) {
        var d4 = a.opacity == null ? 1 : a.opacity;
        if (n6 instanceof Zv) {
          s("opacity", d4);
          return;
        }
        if (M8t(a)) {
          var y4 = Nk(a.fill);
          s("fill", y4.color);
          var _ = a.fillOpacity != null ? a.fillOpacity * y4.opacity * d4 : y4.opacity * d4;
          (f6 || _ < 1) && s("fill-opacity", _);
        } else
          s("fill", V$);
        if (T8t(a)) {
          var S = Nk(a.stroke);
          s("stroke", S.color);
          var T = a.strokeNoScale ? n6.getLineScale() : 1, E = T ? (a.lineWidth || 0) / T : 0, O = a.strokeOpacity != null ? a.strokeOpacity * S.opacity * d4 : S.opacity * d4, R = a.strokeFirst;
          if ((f6 || E !== 1) && s("stroke-width", E), (f6 || R) && s("paint-order", R ? "stroke" : "fill"), (f6 || O < 1) && s("stroke-opacity", O), a.lineDash) {
            var V = swe(n6), z3 = V[0], H = V[1];
            z3 && (H = C8t(H || 0), s("stroke-dasharray", z3.join(",")), (H || f6) && s("stroke-dashoffset", H));
          } else
            f6 && s("stroke-dasharray", V$);
          for (var Z = 0; Z < qwe.length; Z++) {
            var ee = qwe[Z];
            if (f6 || a[ee] !== i7[ee]) {
              var oe = a[ee] || i7[ee];
              oe && s(A8t[Z], oe);
            }
          }
        } else
          f6 && s("stroke", V$);
      }
      var rUe = "http://www.w3.org/2000/svg", iUe = "http://www.w3.org/1999/xlink", E8t = "http://www.w3.org/2000/xmlns/", D8t = "http://www.w3.org/XML/1998/namespace";
      function aUe(s) {
        return document.createElementNS(rUe, s);
      }
      function Ng(s, a, n6, f6, d4) {
        return { tag: s, attrs: n6 || {}, children: f6, text: d4, key: a };
      }
      function k8t(s, a) {
        var n6 = [];
        if (a)
          for (var f6 in a) {
            var d4 = a[f6], y4 = f6;
            d4 !== false && (d4 !== true && d4 != null && (y4 += '="' + d4 + '"'), n6.push(y4));
          }
        return "<" + s + " " + n6.join(" ") + ">";
      }
      function O8t(s) {
        return "</" + s + ">";
      }
      function $we(s, a) {
        a = a || {};
        var n6 = a.newline ? `
` : "";
        function f6(d4) {
          var y4 = d4.children, _ = d4.tag, S = d4.attrs;
          return k8t(_, S) + (d4.text || "") + (y4 ? "" + n6 + Pi(y4, function(T) {
            return f6(T);
          }).join(n6) + n6 : "") + O8t(_);
        }
        return f6(s);
      }
      function P8t(s, a, n6) {
        n6 = n6 || {};
        var f6 = n6.newline ? `
` : "", d4 = " {" + f6, y4 = f6 + "}", _ = Pi(Wl(s), function(T) {
          return T + d4 + Pi(Wl(s[T]), function(E) {
            return E + ":" + s[T][E] + ";";
          }).join(f6) + y4;
        }).join(f6), S = Pi(Wl(a), function(T) {
          return "@keyframes " + T + d4 + Pi(Wl(a[T]), function(E) {
            return E + d4 + Pi(Wl(a[T][E]), function(O) {
              var R = a[T][E][O];
              return O === "d" && (R = 'path("' + R + '")'), O + ":" + R + ";";
            }).join(f6) + y4;
          }).join(f6) + y4;
        }).join(f6);
        return !_ && !S ? "" : ["<![CDATA[", _, S, "]]>"].join(f6);
      }
      function Xwe(s) {
        return { zrId: s, shadowCache: {}, patternCache: {}, gradientCache: {}, clipPathCache: {}, defs: {}, cssNodes: {}, cssAnims: {}, cssClassIdx: 0, cssAnimIdx: 0, shadowIdx: 0, gradientIdx: 0, patternIdx: 0, clipPathIdx: 0 };
      }
      function oUe(s, a, n6, f6) {
        return Ng("svg", "root", { width: s, height: a, xmlns: rUe, "xmlns:xlink": iUe, version: "1.1", baseProfile: "full", viewBox: f6 ? "0 0 " + s + " " + a : false }, n6);
      }
      var sUe = { cubicIn: "0.32,0,0.67,0", cubicOut: "0.33,1,0.68,1", cubicInOut: "0.65,0,0.35,1", quadraticIn: "0.11,0,0.5,0", quadraticOut: "0.5,1,0.89,1", quadraticInOut: "0.45,0,0.55,1", quarticIn: "0.5,0,0.75,0", quarticOut: "0.25,1,0.5,1", quarticInOut: "0.76,0,0.24,1", quinticIn: "0.64,0,0.78,0", quinticOut: "0.22,1,0.36,1", quinticInOut: "0.83,0,0.17,1", sinusoidalIn: "0.12,0,0.39,0", sinusoidalOut: "0.61,1,0.88,1", sinusoidalInOut: "0.37,0,0.63,1", exponentialIn: "0.7,0,0.84,0", exponentialOut: "0.16,1,0.3,1", exponentialInOut: "0.87,0,0.13,1", circularIn: "0.55,0,1,0.45", circularOut: "0,0.55,0.45,1", circularInOut: "0.85,0,0.15,1" }, qR = "transform-origin";
      function L8t(s, a, n6) {
        var f6 = ei({}, s.shape);
        ei(f6, a), s.buildPath(n6, f6);
        var d4 = new nUe();
        return d4.reset($re(s)), n6.rebuildPath(d4, 1), d4.generateStr(), d4.getStr();
      }
      function R8t(s, a) {
        var n6 = a.originX, f6 = a.originY;
        (n6 || f6) && (s[qR] = n6 + "px " + f6 + "px");
      }
      var N8t = { fill: "fill", opacity: "opacity", lineWidth: "stroke-width", lineDashOffset: "stroke-dashoffset" };
      function lUe(s, a) {
        var n6 = a.zrId + "-ani-" + a.cssAnimIdx++;
        return a.cssAnims[n6] = s, n6;
      }
      function F8t(s, a, n6) {
        var f6 = s.shape.paths, d4 = {}, y4, _;
        if (gt(f6, function(T) {
          var E = Xwe(n6.zrId);
          E.animation = true, goe(T, {}, E, true);
          var O = E.cssAnims, R = E.cssNodes, V = Wl(O), z3 = V.length;
          if (z3) {
            _ = V[z3 - 1];
            var H = O[_];
            for (var Z in H) {
              var ee = H[Z];
              d4[Z] = d4[Z] || { d: "" }, d4[Z].d += ee.d || "";
            }
            for (var oe in R) {
              var fe = R[oe].animation;
              fe.indexOf(_) >= 0 && (y4 = fe);
            }
          }
        }), !!y4) {
          a.d = false;
          var S = lUe(d4, n6);
          return y4.replace(_, S);
        }
      }
      function uUe(s) {
        return Wa(s) ? sUe[s] ? "cubic-bezier(" + sUe[s] + ")" : y9(s) ? s : "" : "";
      }
      function goe(s, a, n6, f6) {
        var d4 = s.animators, y4 = d4.length, _ = [];
        if (s instanceof Jq) {
          var S = F8t(s, a, n6);
          if (S)
            _.push(S);
          else if (!y4)
            return;
        } else if (!y4)
          return;
        for (var T = {}, E = 0; E < y4; E++) {
          var O = d4[E], R = [O.getMaxTime() / 1e3 + "s"], V = uUe(O.getClip().easing), z3 = O.getDelay();
          V ? R.push(V) : R.push("linear"), z3 && R.push(z3 / 1e3 + "s"), O.getLoop() && R.push("infinite");
          var H = R.join(" ");
          T[H] = T[H] || [H, []], T[H][1].push(O);
        }
        function Z(fe) {
          var _e = fe[1], pe = _e.length, Ve = {}, Le = {}, je = {}, Xe = "animation-timing-function";
          function Ye(Fa, po, To) {
            for (var Ya = Fa.getTracks(), $o = Fa.getMaxTime(), Hu = 0; Hu < Ya.length; Hu++) {
              var ms = Ya[Hu];
              if (ms.needsAnimate()) {
                var sc = ms.keyframes, Oc = ms.propName;
                if (To && (Oc = To(Oc)), Oc)
                  for (var _c2 = 0; _c2 < sc.length; _c2++) {
                    var _v = sc[_c2], cp = Math.round(_v.time / $o * 100) + "%", Vg = uUe(_v.easing), rh = _v.rawValue;
                    (Wa(rh) || ac(rh)) && (po[cp] = po[cp] || {}, po[cp][Oc] = _v.rawValue, Vg && (po[cp][Xe] = Vg));
                  }
              }
            }
          }
          for (var rt2 = 0; rt2 < pe; rt2++) {
            var ut = _e[rt2], wt = ut.targetName;
            wt ? wt === "shape" && Ye(ut, Le) : !f6 && Ye(ut, Ve);
          }
          for (var dt in Ve) {
            var Gt = {};
            iie(Gt, s), ei(Gt, Ve[dt]);
            var Qt = Xre(Gt), Nt = Ve[dt][Xe];
            je[dt] = Qt ? { transform: Qt } : {}, R8t(je[dt], Gt), Nt && (je[dt][Xe] = Nt);
          }
          var er, un = true;
          for (var dt in Le) {
            je[dt] = je[dt] || {};
            var pn = !er, Nt = Le[dt][Xe];
            pn && (er = new aS());
            var On = er.len();
            er.reset(), je[dt].d = L8t(s, Le[dt], er);
            var fr = er.len();
            if (!pn && On !== fr) {
              un = false;
              break;
            }
            Nt && (je[dt][Xe] = Nt);
          }
          if (!un)
            for (var dt in je)
              delete je[dt].d;
          if (!f6)
            for (var rt2 = 0; rt2 < pe; rt2++) {
              var ut = _e[rt2], wt = ut.targetName;
              wt === "style" && Ye(ut, je, function(Ya) {
                return N8t[Ya];
              });
            }
          for (var yr = Wl(je), da = true, Ja, rt2 = 1; rt2 < yr.length; rt2++) {
            var ko = yr[rt2 - 1], wo = yr[rt2];
            if (je[ko][qR] !== je[wo][qR]) {
              da = false;
              break;
            }
            Ja = je[ko][qR];
          }
          if (da && Ja) {
            for (var dt in je)
              je[dt][qR] && delete je[dt][qR];
            a[qR] = Ja;
          }
          if (tf(yr, function(Fa) {
            return Wl(je[Fa]).length > 0;
          }).length) {
            var So = lUe(je, n6);
            return So + " " + fe[0] + " both";
          }
        }
        for (var ee in T) {
          var S = Z(T[ee]);
          S && _.push(S);
        }
        if (_.length) {
          var oe = n6.zrId + "-cls-" + n6.cssClassIdx++;
          n6.cssNodes["." + oe] = { animation: _.join(",") }, a.class = oe;
        }
      }
      var B$ = Math.round;
      function cUe(s) {
        return s && Wa(s.src);
      }
      function fUe(s) {
        return s && jo(s.toDataURL);
      }
      function Ywe(s, a, n6, f6) {
        I8t(function(d4, y4) {
          var _ = d4 === "fill" || d4 === "stroke";
          _ && Rbe(y4) ? U8t(a, s, d4, f6) : _ && Lbe(y4) ? q8t(n6, s, d4, f6) : s[d4] = y4;
        }, a, n6, false), W8t(n6, s, f6);
      }
      function hUe(s) {
        return cT(s[0] - 1) && cT(s[1]) && cT(s[2]) && cT(s[3] - 1);
      }
      function V8t(s) {
        return cT(s[4]) && cT(s[5]);
      }
      function Kwe(s, a, n6) {
        if (a && !(V8t(a) && hUe(a))) {
          var f6 = n6 ? 10 : 1e4;
          s.transform = hUe(a) ? "translate(" + B$(a[4] * f6) / f6 + " " + B$(a[5] * f6) / f6 + ")" : Ebe(a);
        }
      }
      function pUe(s, a, n6) {
        for (var f6 = s.points, d4 = [], y4 = 0; y4 < f6.length; y4++)
          d4.push(B$(f6[y4][0] * n6) / n6), d4.push(B$(f6[y4][1] * n6) / n6);
        a.points = d4.join(" ");
      }
      function dUe(s) {
        return !s.smooth;
      }
      function B8t(s) {
        var a = Pi(s, function(n6) {
          return typeof n6 == "string" ? [n6, n6] : n6;
        });
        return function(n6, f6, d4) {
          for (var y4 = 0; y4 < a.length; y4++) {
            var _ = a[y4], S = n6[_[0]];
            S != null && (f6[_[1]] = B$(S * d4) / d4);
          }
        };
      }
      var z8t = { circle: [B8t(["cx", "cy", "r"])], polyline: [pUe, dUe], polygon: [pUe, dUe] };
      function j8t(s) {
        for (var a = s.animators, n6 = 0; n6 < a.length; n6++)
          if (a[n6].targetName === "shape")
            return true;
        return false;
      }
      function vUe(s, a) {
        var n6 = s.style, f6 = s.shape, d4 = z8t[s.type], y4 = {}, _ = a.animation, S = "path", T = s.style.strokePercent, E = a.compress && $re(s) || 4;
        if (d4 && !a.willUpdate && !(d4[1] && !d4[1](f6)) && !(_ && j8t(s)) && !(T < 1)) {
          S = s.type;
          var O = Math.pow(10, E);
          d4[0](f6, y4, O);
        } else {
          s.path || s.createPathProxy();
          var R = s.path;
          s.shapeChanged() && (R.beginPath(), s.buildPath(R, s.shape), s.pathUpdated());
          var V = R.getVersion(), z3 = s, H = z3.__svgPathBuilder;
          (z3.__svgPathVersion !== V || !H || T !== z3.__svgPathStrokePercent) && (H || (H = z3.__svgPathBuilder = new nUe()), H.reset(E), R.rebuildPath(H, T), H.generateStr(), z3.__svgPathVersion = V, z3.__svgPathStrokePercent = T), y4.d = H.getStr();
        }
        return Kwe(y4, s.transform), Ywe(y4, n6, s, a), a.animation && goe(s, y4, a), Ng(S, s.id + "", y4);
      }
      function G8t(s, a) {
        var n6 = s.style, f6 = n6.image;
        if (f6 && !Wa(f6) && (cUe(f6) ? f6 = f6.src : fUe(f6) && (f6 = f6.toDataURL())), !!f6) {
          var d4 = n6.x || 0, y4 = n6.y || 0, _ = n6.width, S = n6.height, T = { href: f6, width: _, height: S };
          return d4 && (T.x = d4), y4 && (T.y = y4), Kwe(T, s.transform), Ywe(T, n6, s, a), a.animation && goe(s, T, a), Ng("image", s.id + "", T);
        }
      }
      function H8t(s, a) {
        var n6 = s.style, f6 = n6.text;
        if (f6 != null && (f6 += ""), !(!f6 || isNaN(n6.x) || isNaN(n6.y))) {
          var d4 = n6.font || mc, y4 = n6.x || 0, _ = sC(n6.y || 0, sR(d4), n6.textBaseline), S = Dbe[n6.textAlign] || n6.textAlign, T = { "dominant-baseline": "central", "text-anchor": S };
          if (Vie(n6)) {
            var E = "", O = n6.fontStyle, R = Nie(n6.fontSize);
            if (!parseFloat(R))
              return;
            var V = n6.fontFamily || ic, z3 = n6.fontWeight;
            E += "font-size:" + R + ";font-family:" + V + ";", O && O !== "normal" && (E += "font-style:" + O + ";"), z3 && z3 !== "normal" && (E += "font-weight:" + z3 + ";"), T.style = E;
          } else
            T.style = "font: " + d4;
          return f6.match(/\s/) && (T["xml:space"] = "preserve"), y4 && (T.x = y4), _ && (T.y = _), Kwe(T, s.transform), Ywe(T, n6, s, a), a.animation && goe(s, T, a), Ng("text", s.id + "", T, void 0, f6);
        }
      }
      function gUe(s, a) {
        if (s instanceof ml)
          return vUe(s, a);
        if (s instanceof Zv)
          return G8t(s, a);
        if (s instanceof _R)
          return H8t(s, a);
      }
      function W8t(s, a, n6) {
        var f6 = s.style;
        if (kbe(f6)) {
          var d4 = Obe(s), y4 = n6.shadowCache, _ = y4[d4];
          if (!_) {
            var S = s.getGlobalScale(), T = S[0], E = S[1];
            if (!T || !E)
              return;
            var O = f6.shadowOffsetX || 0, R = f6.shadowOffsetY || 0, V = f6.shadowBlur, z3 = Nk(f6.shadowColor), H = z3.opacity, Z = z3.color, ee = V / 2 / T, oe = V / 2 / E, fe = ee + " " + oe;
            _ = n6.zrId + "-s" + n6.shadowIdx++, n6.defs[_] = Ng("filter", _, { id: _, x: "-100%", y: "-100%", width: "300%", height: "300%" }, [Ng("feDropShadow", "", { dx: O / T, dy: R / E, stdDeviation: fe, "flood-color": Z, "flood-opacity": H })]), y4[d4] = _;
          }
          a.filter = Pm(_);
        }
      }
      function U8t(s, a, n6, f6) {
        var d4 = s[n6], y4, _ = { gradientUnits: d4.global ? "userSpaceOnUse" : "objectBoundingBox" };
        if (fT(d4))
          y4 = "linearGradient", _.x1 = d4.x, _.y1 = d4.y, _.x2 = d4.x2, _.y2 = d4.y2;
        else if (qre(d4))
          y4 = "radialGradient", _.cx = Zs(d4.x, 0.5), _.cy = Zs(d4.y, 0.5), _.r = Zs(d4.r, 0.5);
        else
          return;
        for (var S = d4.colorStops, T = [], E = 0, O = S.length; E < O; ++E) {
          var R = EU(S[E].offset) * 100 + "%", V = S[E].color, z3 = Nk(V), H = z3.color, Z = z3.opacity, ee = { offset: R };
          ee["stop-color"] = H, Z < 1 && (ee["stop-opacity"] = Z), T.push(Ng("stop", E + "", ee));
        }
        var oe = Ng(y4, "", _, T), fe = $we(oe), _e = f6.gradientCache, pe = _e[fe];
        pe || (pe = f6.zrId + "-g" + f6.gradientIdx++, _e[fe] = pe, _.id = pe, f6.defs[pe] = Ng(y4, pe, _, T)), a[n6] = Pm(pe);
      }
      function q8t(s, a, n6, f6) {
        var d4 = s.style[n6], y4 = { patternUnits: "userSpaceOnUse" }, _;
        if (Ure(d4)) {
          var S = d4.imageWidth, T = d4.imageHeight, E = void 0, O = d4.image;
          if (Wa(O) ? E = O : cUe(O) ? E = O.src : fUe(O) && (E = O.toDataURL()), typeof Image == "undefined") {
            var R = "Image width/height must been given explictly in svg-ssr renderer.";
            Ty(S, R), Ty(T, R);
          } else if (S == null || T == null) {
            var V = function(fe, _e) {
              if (fe) {
                var pe = fe.elm, Ve = fe.attrs.width = S || _e.width, Le = fe.attrs.height = T || _e.height;
                pe && (pe.setAttribute("width", Ve), pe.setAttribute("height", Le));
              }
            }, z3 = uq(E, null, s, function(fe) {
              V(H, fe), V(_, fe);
            });
            z3 && z3.width && z3.height && (S = S || z3.width, T = T || z3.height);
          }
          _ = Ng("image", "img", { href: E, width: S, height: T }), y4.width = S, y4.height = T;
        } else
          d4.svgElement && (_ = Bo(d4.svgElement), y4.width = d4.svgWidth, y4.height = d4.svgHeight);
        if (_) {
          y4.patternTransform = Xre(d4);
          var H = Ng("pattern", "", y4, [_]), Z = $we(H), ee = f6.patternCache, oe = ee[Z];
          oe || (oe = f6.zrId + "-p" + f6.patternIdx++, ee[Z] = oe, y4.id = oe, H = f6.defs[oe] = Ng("pattern", oe, y4, [_])), a[n6] = Pm(oe);
        }
      }
      function $8t(s, a, n6) {
        var f6 = n6.clipPathCache, d4 = n6.defs, y4 = f6[s.id];
        if (!y4) {
          y4 = n6.zrId + "-c" + n6.clipPathIdx++;
          var _ = { id: y4 };
          f6[s.id] = y4, d4[y4] = Ng("clipPath", y4, _, [vUe(s, n6)]);
        }
        a["clip-path"] = Pm(y4);
      }
      function yUe(s) {
        return document.createTextNode(s);
      }
      function $R(s, a, n6) {
        s.insertBefore(a, n6);
      }
      function mUe(s, a) {
        s.removeChild(a);
      }
      function bUe(s, a) {
        s.appendChild(a);
      }
      function _Ue(s) {
        return s.parentNode;
      }
      function xUe(s) {
        return s.nextSibling;
      }
      function Zwe(s, a) {
        s.textContent = a;
      }
      var wUe = 58, X8t = 120, Y8t = Ng("", "");
      function Jwe(s) {
        return s === void 0;
      }
      function VT(s) {
        return s !== void 0;
      }
      function K8t(s, a, n6) {
        for (var f6 = {}, d4 = a; d4 <= n6; ++d4) {
          var y4 = s[d4].key;
          y4 !== void 0 && (f6[y4] = d4);
        }
        return f6;
      }
      function z$(s, a) {
        var n6 = s.key === a.key, f6 = s.tag === a.tag;
        return f6 && n6;
      }
      function j$(s) {
        var a, n6 = s.children, f6 = s.tag;
        if (VT(f6)) {
          var d4 = s.elm = aUe(f6);
          if (Qwe(Y8t, s), Di(n6))
            for (a = 0; a < n6.length; ++a) {
              var y4 = n6[a];
              y4 != null && bUe(d4, j$(y4));
            }
          else
            VT(s.text) && !Qo(s.text) && bUe(d4, yUe(s.text));
        } else
          s.elm = yUe(s.text);
        return s.elm;
      }
      function SUe(s, a, n6, f6, d4) {
        for (; f6 <= d4; ++f6) {
          var y4 = n6[f6];
          y4 != null && $R(s, j$(y4), a);
        }
      }
      function yoe(s, a, n6, f6) {
        for (; n6 <= f6; ++n6) {
          var d4 = a[n6];
          if (d4 != null)
            if (VT(d4.tag)) {
              var y4 = _Ue(d4.elm);
              mUe(y4, d4.elm);
            } else
              mUe(s, d4.elm);
        }
      }
      function Qwe(s, a) {
        var n6, f6 = a.elm, d4 = s && s.attrs || {}, y4 = a.attrs || {};
        if (d4 !== y4) {
          for (n6 in y4) {
            var _ = y4[n6], S = d4[n6];
            S !== _ && (_ === true ? f6.setAttribute(n6, "") : _ === false ? f6.removeAttribute(n6) : n6.charCodeAt(0) !== X8t ? f6.setAttribute(n6, _) : n6 === "xmlns:xlink" || n6 === "xmlns" ? f6.setAttributeNS(E8t, n6, _) : n6.charCodeAt(3) === wUe ? f6.setAttributeNS(D8t, n6, _) : n6.charCodeAt(5) === wUe ? f6.setAttributeNS(iUe, n6, _) : f6.setAttribute(n6, _));
          }
          for (n6 in d4)
            n6 in y4 || f6.removeAttribute(n6);
        }
      }
      function Z8t(s, a, n6) {
        for (var f6 = 0, d4 = 0, y4 = a.length - 1, _ = a[0], S = a[y4], T = n6.length - 1, E = n6[0], O = n6[T], R, V, z3, H; f6 <= y4 && d4 <= T; )
          _ == null ? _ = a[++f6] : S == null ? S = a[--y4] : E == null ? E = n6[++d4] : O == null ? O = n6[--T] : z$(_, E) ? (W7(_, E), _ = a[++f6], E = n6[++d4]) : z$(S, O) ? (W7(S, O), S = a[--y4], O = n6[--T]) : z$(_, O) ? (W7(_, O), $R(s, _.elm, xUe(S.elm)), _ = a[++f6], O = n6[--T]) : z$(S, E) ? (W7(S, E), $R(s, S.elm, _.elm), S = a[--y4], E = n6[++d4]) : (Jwe(R) && (R = K8t(a, f6, y4)), V = R[E.key], Jwe(V) ? $R(s, j$(E), _.elm) : (z3 = a[V], z3.tag !== E.tag ? $R(s, j$(E), _.elm) : (W7(z3, E), a[V] = void 0, $R(s, z3.elm, _.elm))), E = n6[++d4]);
        (f6 <= y4 || d4 <= T) && (f6 > y4 ? (H = n6[T + 1] == null ? null : n6[T + 1].elm, SUe(s, H, n6, d4, T)) : yoe(s, a, f6, y4));
      }
      function W7(s, a) {
        var n6 = a.elm = s.elm, f6 = s.children, d4 = a.children;
        s !== a && (Qwe(s, a), Jwe(a.text) ? VT(f6) && VT(d4) ? f6 !== d4 && Z8t(n6, f6, d4) : VT(d4) ? (VT(s.text) && Zwe(n6, ""), SUe(n6, null, d4, 0, d4.length - 1)) : VT(f6) ? yoe(n6, f6, 0, f6.length - 1) : VT(s.text) && Zwe(n6, "") : s.text !== a.text && (VT(f6) && yoe(n6, f6, 0, f6.length - 1), Zwe(n6, a.text)));
      }
      function J8t(s, a) {
        if (z$(s, a))
          W7(s, a);
        else {
          var n6 = s.elm, f6 = _Ue(n6);
          j$(a), f6 !== null && ($R(f6, a.elm, xUe(n6)), yoe(f6, [s], 0, 0));
        }
        return a;
      }
      var Q8t = 0, e9t = function() {
        function s(a, n6, f6) {
          if (this.type = "svg", this.refreshHover = CUe(), this.configLayer = CUe(), this.storage = n6, this._opts = f6 = ei({}, f6), this.root = a, this._id = "zr" + Q8t++, this._oldVNode = oUe(f6.width, f6.height), a && !f6.ssr) {
            var d4 = this._viewport = document.createElement("div");
            d4.style.cssText = "position:relative;overflow:hidden";
            var y4 = this._svgDom = this._oldVNode.elm = aUe("svg");
            Qwe(null, this._oldVNode), d4.appendChild(y4), a.appendChild(d4);
          }
          this.resize(f6.width, f6.height);
        }
        return s.prototype.getType = function() {
          return this.type;
        }, s.prototype.getViewportRoot = function() {
          return this._viewport;
        }, s.prototype.getViewportRootOffset = function() {
          var a = this.getViewportRoot();
          if (a)
            return { offsetLeft: a.offsetLeft || 0, offsetTop: a.offsetTop || 0 };
        }, s.prototype.getSvgDom = function() {
          return this._svgDom;
        }, s.prototype.refresh = function() {
          if (this.root) {
            var a = this.renderToVNode({ willUpdate: true });
            a.attrs.style = "position:absolute;left:0;top:0;user-select:none", J8t(this._oldVNode, a), this._oldVNode = a;
          }
        }, s.prototype.renderOneToVNode = function(a) {
          return gUe(a, Xwe(this._id));
        }, s.prototype.renderToVNode = function(a) {
          a = a || {};
          var n6 = this.storage.getDisplayList(true), f6 = this._backgroundColor, d4 = this._width, y4 = this._height, _ = Xwe(this._id);
          _.animation = a.animation, _.willUpdate = a.willUpdate, _.compress = a.compress;
          var S = [];
          if (f6 && f6 !== "none") {
            var T = Nk(f6), E = T.color, O = T.opacity;
            this._bgVNode = Ng("rect", "bg", { width: d4, height: y4, x: "0", y: "0", id: "0", fill: E, "fill-opacity": O }), S.push(this._bgVNode);
          } else
            this._bgVNode = null;
          var R = a.compress ? null : this._mainVNode = Ng("g", "main", {}, []);
          this._paintList(n6, _, R ? R.children : S), R && S.push(R);
          var V = Pi(Wl(_.defs), function(Z) {
            return _.defs[Z];
          });
          if (V.length && S.push(Ng("defs", "defs", {}, V)), a.animation) {
            var z3 = P8t(_.cssNodes, _.cssAnims, { newline: true });
            if (z3) {
              var H = Ng("style", "stl", {}, [], z3);
              S.push(H);
            }
          }
          return oUe(d4, y4, S, a.useViewBox);
        }, s.prototype.renderToString = function(a) {
          return a = a || {}, $we(this.renderToVNode({ animation: Zs(a.cssAnimation, true), willUpdate: false, compress: true, useViewBox: Zs(a.useViewBox, true) }), { newline: true });
        }, s.prototype.setBackgroundColor = function(a) {
          this._backgroundColor = a;
          var n6 = this._bgVNode;
          if (n6 && n6.elm) {
            var f6 = Nk(a), d4 = f6.color, y4 = f6.opacity;
            n6.elm.setAttribute("fill", d4), y4 < 1 && n6.elm.setAttribute("fill-opacity", y4);
          }
        }, s.prototype.getSvgRoot = function() {
          return this._mainVNode && this._mainVNode.elm;
        }, s.prototype._paintList = function(a, n6, f6) {
          for (var d4 = a.length, y4 = [], _ = 0, S, T, E = 0, O = 0; O < d4; O++) {
            var R = a[O];
            if (!R.invisible) {
              var V = R.__clipPaths, z3 = V && V.length || 0, H = T && T.length || 0, Z = void 0;
              for (Z = Math.max(z3 - 1, H - 1); Z >= 0 && !(V && T && V[Z] === T[Z]); Z--)
                ;
              for (var ee = H - 1; ee > Z; ee--)
                _--, S = y4[_ - 1];
              for (var oe = Z + 1; oe < z3; oe++) {
                var fe = {};
                $8t(V[oe], fe, n6);
                var _e = Ng("g", "clip-g-" + E++, fe, []);
                (S ? S.children : f6).push(_e), y4[_++] = _e, S = _e;
              }
              T = V;
              var pe = gUe(R, n6);
              pe && (S ? S.children : f6).push(pe);
            }
          }
        }, s.prototype.resize = function(a, n6) {
          var f6 = this._opts, d4 = this.root, y4 = this._viewport;
          if (a != null && (f6.width = a), n6 != null && (f6.height = n6), d4 && y4 && (y4.style.display = "none", a = z7(d4, 0, f6), n6 = z7(d4, 1, f6), y4.style.display = ""), this._width !== a || this._height !== n6) {
            if (this._width = a, this._height = n6, y4) {
              var _ = y4.style;
              _.width = a + "px", _.height = n6 + "px";
            }
            var S = this._svgDom;
            S && (S.setAttribute("width", a), S.setAttribute("height", n6));
          }
        }, s.prototype.getWidth = function() {
          return this._width;
        }, s.prototype.getHeight = function() {
          return this._height;
        }, s.prototype.dispose = function() {
          this.root && (this.root.innerHTML = ""), this._svgDom = this._viewport = this.storage = this._oldVNode = this._bgVNode = this._mainVNode = null;
        }, s.prototype.clear = function() {
          this._svgDom && (this._svgDom.innerHTML = null), this._oldVNode = null;
        }, s.prototype.toDataURL = function(a) {
          var n6 = encodeURIComponent(this.renderToString()), f6 = "data:image/svg+xml;";
          return a ? (n6 = Nbe(n6), n6 && f6 + "base64," + n6) : f6 + "charset=UTF-8," + n6;
        }, s;
      }();
      function CUe(s) {
        return function() {
        };
      }
      var t9t = e9t;
      function n9t(s) {
        s.registerPainter("svg", t9t);
      }
      function MUe(s, a, n6) {
        var f6 = td.createCanvas(), d4 = a.getWidth(), y4 = a.getHeight(), _ = f6.style;
        return _ && (_.position = "absolute", _.left = "0", _.top = "0", _.width = d4 + "px", _.height = y4 + "px", f6.setAttribute("data-zr-dom-id", s)), f6.width = d4 * n6, f6.height = y4 * n6, f6;
      }
      var r9t = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this) || this;
          y4.motionBlur = false, y4.lastFrameAlpha = 0.7, y4.dpr = 1, y4.virtual = false, y4.config = {}, y4.incremental = false, y4.zlevel = 0, y4.maxRepaintRectCount = 5, y4.__dirty = true, y4.__firstTimePaint = true, y4.__used = false, y4.__drawIndex = 0, y4.__startIndex = 0, y4.__endIndex = 0, y4.__prevStartIndex = null, y4.__prevEndIndex = null;
          var _;
          d4 = d4 || O9, typeof n6 == "string" ? _ = MUe(n6, f6, d4) : Qo(n6) && (_ = n6, n6 = _.id), y4.id = n6, y4.dom = _;
          var S = _.style;
          return S && (aU(_), _.onselectstart = function() {
            return false;
          }, S.padding = "0", S.margin = "0", S.borderWidth = "0"), y4.painter = f6, y4.dpr = d4, y4;
        }
        return a.prototype.getElementCount = function() {
          return this.__endIndex - this.__startIndex;
        }, a.prototype.afterBrush = function() {
          this.__prevStartIndex = this.__startIndex, this.__prevEndIndex = this.__endIndex;
        }, a.prototype.initContext = function() {
          this.ctx = this.dom.getContext("2d"), this.ctx.dpr = this.dpr;
        }, a.prototype.setUnpainted = function() {
          this.__firstTimePaint = true;
        }, a.prototype.createBackBuffer = function() {
          var n6 = this.dpr;
          this.domBack = MUe("back-" + this.id, this.painter, n6), this.ctxBack = this.domBack.getContext("2d"), n6 !== 1 && this.ctxBack.scale(n6, n6);
        }, a.prototype.createRepaintRects = function(n6, f6, d4, y4) {
          if (this.__firstTimePaint)
            return this.__firstTimePaint = false, null;
          var _ = [], S = this.maxRepaintRectCount, T = false, E = new il(0, 0, 0, 0);
          function O(fe) {
            if (!(!fe.isFinite() || fe.isZero()))
              if (_.length === 0) {
                var _e = new il(0, 0, 0, 0);
                _e.copy(fe), _.push(_e);
              } else {
                for (var pe = false, Ve = 1 / 0, Le = 0, je = 0; je < _.length; ++je) {
                  var Xe = _[je];
                  if (Xe.intersect(fe)) {
                    var Ye = new il(0, 0, 0, 0);
                    Ye.copy(Xe), Ye.union(fe), _[je] = Ye, pe = true;
                    break;
                  } else if (T) {
                    E.copy(fe), E.union(Xe);
                    var rt2 = fe.width * fe.height, ut = Xe.width * Xe.height, wt = E.width * E.height, dt = wt - rt2 - ut;
                    dt < Ve && (Ve = dt, Le = je);
                  }
                }
                if (T && (_[Le].union(fe), pe = true), !pe) {
                  var _e = new il(0, 0, 0, 0);
                  _e.copy(fe), _.push(_e);
                }
                T || (T = _.length >= S);
              }
          }
          for (var R = this.__startIndex; R < this.__endIndex; ++R) {
            var V = n6[R];
            if (V) {
              var z3 = V.shouldBePainted(d4, y4, true, true), H = V.__isRendered && (V.__dirty & x0 || !z3) ? V.getPrevPaintRect() : null;
              H && O(H);
              var Z = z3 && (V.__dirty & x0 || !V.__isRendered) ? V.getPaintRect() : null;
              Z && O(Z);
            }
          }
          for (var R = this.__prevStartIndex; R < this.__prevEndIndex; ++R) {
            var V = f6[R], z3 = V.shouldBePainted(d4, y4, true, true);
            if (V && (!z3 || !V.__zr) && V.__isRendered) {
              var H = V.getPrevPaintRect();
              H && O(H);
            }
          }
          var ee;
          do {
            ee = false;
            for (var R = 0; R < _.length; ) {
              if (_[R].isZero()) {
                _.splice(R, 1);
                continue;
              }
              for (var oe = R + 1; oe < _.length; )
                _[R].intersect(_[oe]) ? (ee = true, _[R].union(_[oe]), _.splice(oe, 1)) : oe++;
              R++;
            }
          } while (ee);
          return this._paintRects = _, _;
        }, a.prototype.debugGetPaintRects = function() {
          return (this._paintRects || []).slice();
        }, a.prototype.resize = function(n6, f6) {
          var d4 = this.dpr, y4 = this.dom, _ = y4.style, S = this.domBack;
          _ && (_.width = n6 + "px", _.height = f6 + "px"), y4.width = n6 * d4, y4.height = f6 * d4, S && (S.width = n6 * d4, S.height = f6 * d4, d4 !== 1 && this.ctxBack.scale(d4, d4));
        }, a.prototype.clear = function(n6, f6, d4) {
          var y4 = this.dom, _ = this.ctx, S = y4.width, T = y4.height;
          f6 = f6 || this.clearColor;
          var E = this.motionBlur && !n6, O = this.lastFrameAlpha, R = this.dpr, V = this;
          E && (this.domBack || this.createBackBuffer(), this.ctxBack.globalCompositeOperation = "copy", this.ctxBack.drawImage(y4, 0, 0, S / R, T / R));
          var z3 = this.domBack;
          function H(Z, ee, oe, fe) {
            if (_.clearRect(Z, ee, oe, fe), f6 && f6 !== "transparent") {
              var _e = void 0;
              th(f6) ? (_e = f6.__canvasGradient || owe(_, f6, { x: 0, y: 0, width: oe, height: fe }), f6.__canvasGradient = _e) : qh(f6) && (_e = lwe(_, f6, { dirty: function() {
                V.setUnpainted(), V.__painter.refresh();
              } })), _.save(), _.fillStyle = _e || f6, _.fillRect(Z, ee, oe, fe), _.restore();
            }
            E && (_.save(), _.globalAlpha = O, _.drawImage(z3, Z, ee, oe, fe), _.restore());
          }
          !d4 || E ? H(0, 0, S, T) : d4.length && gt(d4, function(Z) {
            H(Z.x * R, Z.y * R, Z.width * R, Z.height * R);
          });
        }, a;
      }(Dm), eSe = r9t, TUe = 1e5, XR = 314159, moe = 0.01, i9t = 1e-3;
      function a9t(s) {
        return s ? s.__builtin__ ? true : !(typeof s.resize != "function" || typeof s.refresh != "function") : false;
      }
      function o9t(s, a) {
        var n6 = document.createElement("div");
        return n6.style.cssText = ["position:relative", "width:" + s + "px", "height:" + a + "px", "padding:0", "margin:0", "border-width:0"].join(";") + ";", n6;
      }
      var s9t = function() {
        function s(a, n6, f6, d4) {
          this.type = "canvas", this._zlevelList = [], this._prevDisplayList = [], this._layers = {}, this._layerConfig = {}, this._needsManuallyCompositing = false, this.type = "canvas";
          var y4 = !a.nodeName || a.nodeName.toUpperCase() === "CANVAS";
          this._opts = f6 = ei({}, f6 || {}), this.dpr = f6.devicePixelRatio || O9, this._singleCanvas = y4, this.root = a;
          var _ = a.style;
          _ && (aU(a), a.innerHTML = ""), this.storage = n6;
          var S = this._zlevelList;
          this._prevDisplayList = [];
          var T = this._layers;
          if (y4) {
            var E = a, O = E.width, R = E.height;
            f6.width != null && (O = f6.width), f6.height != null && (R = f6.height), this.dpr = f6.devicePixelRatio || 1, E.width = O * this.dpr, E.height = R * this.dpr, this._width = O, this._height = R;
            var V = new eSe(E, this, this.dpr);
            V.__builtin__ = true, V.initContext(), T[XR] = V, V.zlevel = XR, S.push(XR), this._domRoot = a;
          } else {
            this._width = z7(a, 0, f6), this._height = z7(a, 1, f6);
            var z3 = this._domRoot = o9t(this._width, this._height);
            a.appendChild(z3);
          }
        }
        return s.prototype.getType = function() {
          return "canvas";
        }, s.prototype.isSingleCanvas = function() {
          return this._singleCanvas;
        }, s.prototype.getViewportRoot = function() {
          return this._domRoot;
        }, s.prototype.getViewportRootOffset = function() {
          var a = this.getViewportRoot();
          if (a)
            return { offsetLeft: a.offsetLeft || 0, offsetTop: a.offsetTop || 0 };
        }, s.prototype.refresh = function(a) {
          var n6 = this.storage.getDisplayList(true), f6 = this._prevDisplayList, d4 = this._zlevelList;
          this._redrawId = Math.random(), this._paintList(n6, f6, a, this._redrawId);
          for (var y4 = 0; y4 < d4.length; y4++) {
            var _ = d4[y4], S = this._layers[_];
            if (!S.__builtin__ && S.refresh) {
              var T = y4 === 0 ? this._backgroundColor : null;
              S.refresh(T);
            }
          }
          return this._opts.useDirtyRect && (this._prevDisplayList = n6.slice()), this;
        }, s.prototype.refreshHover = function() {
          this._paintHoverList(this.storage.getDisplayList(false));
        }, s.prototype._paintHoverList = function(a) {
          var n6 = a.length, f6 = this._hoverlayer;
          if (f6 && f6.clear(), !!n6) {
            for (var d4 = { inHover: true, viewWidth: this._width, viewHeight: this._height }, y4, _ = 0; _ < n6; _++) {
              var S = a[_];
              S.__inHover && (f6 || (f6 = this._hoverlayer = this.getLayer(TUe)), y4 || (y4 = f6.ctx, y4.save()), zR(y4, S, d4, _ === n6 - 1));
            }
            y4 && y4.restore();
          }
        }, s.prototype.getHoverLayer = function() {
          return this.getLayer(TUe);
        }, s.prototype.paintOne = function(a, n6) {
          SHe(a, n6);
        }, s.prototype._paintList = function(a, n6, f6, d4) {
          if (this._redrawId === d4) {
            f6 = f6 || false, this._updateLayerStatus(a);
            var y4 = this._doPaintList(a, n6, f6), _ = y4.finished, S = y4.needsRefreshHover;
            if (this._needsManuallyCompositing && this._compositeManually(), S && this._paintHoverList(a), _)
              this.eachLayer(function(E) {
                E.afterBrush && E.afterBrush();
              });
            else {
              var T = this;
              bU(function() {
                T._paintList(a, n6, f6, d4);
              });
            }
          }
        }, s.prototype._compositeManually = function() {
          var a = this.getLayer(XR).ctx, n6 = this._domRoot.width, f6 = this._domRoot.height;
          a.clearRect(0, 0, n6, f6), this.eachBuiltinLayer(function(d4) {
            d4.virtual && a.drawImage(d4.dom, 0, 0, n6, f6);
          });
        }, s.prototype._doPaintList = function(a, n6, f6) {
          for (var d4 = this, y4 = [], _ = this._opts.useDirtyRect, S = 0; S < this._zlevelList.length; S++) {
            var T = this._zlevelList[S], E = this._layers[T];
            E.__builtin__ && E !== this._hoverlayer && (E.__dirty || f6) && y4.push(E);
          }
          for (var O = true, R = false, V = function(Z) {
            var ee = y4[Z], oe = ee.ctx, fe = _ && ee.createRepaintRects(a, n6, z3._width, z3._height), _e = f6 ? ee.__startIndex : ee.__drawIndex, pe = !f6 && ee.incremental && Date.now, Ve = pe && Date.now(), Le = ee.zlevel === z3._zlevelList[0] ? z3._backgroundColor : null;
            if (ee.__startIndex === ee.__endIndex)
              ee.clear(false, Le, fe);
            else if (_e === ee.__startIndex) {
              var je = a[_e];
              (!je.incremental || !je.notClear || f6) && ee.clear(false, Le, fe);
            }
            _e === -1 && (console.error("For some unknown reason. drawIndex is -1"), _e = ee.__startIndex);
            var Xe, Ye = function(dt) {
              var Gt = { inHover: false, allClipped: false, prevEl: null, viewWidth: d4._width, viewHeight: d4._height };
              for (Xe = _e; Xe < ee.__endIndex; Xe++) {
                var Qt = a[Xe];
                if (Qt.__inHover && (R = true), d4._doPaintEl(Qt, ee, _, dt, Gt, Xe === ee.__endIndex - 1), pe) {
                  var Nt = Date.now() - Ve;
                  if (Nt > 15)
                    break;
                }
              }
              Gt.prevElClipPaths && oe.restore();
            };
            if (fe)
              if (fe.length === 0)
                Xe = ee.__endIndex;
              else
                for (var rt2 = z3.dpr, ut = 0; ut < fe.length; ++ut) {
                  var wt = fe[ut];
                  oe.save(), oe.beginPath(), oe.rect(wt.x * rt2, wt.y * rt2, wt.width * rt2, wt.height * rt2), oe.clip(), Ye(wt), oe.restore();
                }
            else
              oe.save(), Ye(), oe.restore();
            ee.__drawIndex = Xe, ee.__drawIndex < ee.__endIndex && (O = false);
          }, z3 = this, H = 0; H < y4.length; H++)
            V(H);
          return Na.wxa && gt(this._layers, function(Z) {
            Z && Z.ctx && Z.ctx.draw && Z.ctx.draw();
          }), { finished: O, needsRefreshHover: R };
        }, s.prototype._doPaintEl = function(a, n6, f6, d4, y4, _) {
          var S = n6.ctx;
          if (f6) {
            var T = a.getPaintRect();
            (!d4 || T && T.intersect(d4)) && (zR(S, a, y4, _), a.setPrevPaintRect(T));
          } else
            zR(S, a, y4, _);
        }, s.prototype.getLayer = function(a, n6) {
          this._singleCanvas && !this._needsManuallyCompositing && (a = XR);
          var f6 = this._layers[a];
          return f6 || (f6 = new eSe("zr_" + a, this, this.dpr), f6.zlevel = a, f6.__builtin__ = true, this._layerConfig[a] ? Ms(f6, this._layerConfig[a], true) : this._layerConfig[a - moe] && Ms(f6, this._layerConfig[a - moe], true), n6 && (f6.virtual = n6), this.insertLayer(a, f6), f6.initContext()), f6;
        }, s.prototype.insertLayer = function(a, n6) {
          var f6 = this._layers, d4 = this._zlevelList, y4 = d4.length, _ = this._domRoot, S = null, T = -1;
          if (!f6[a] && !!a9t(n6)) {
            if (y4 > 0 && a > d4[0]) {
              for (T = 0; T < y4 - 1 && !(d4[T] < a && d4[T + 1] > a); T++)
                ;
              S = f6[d4[T]];
            }
            if (d4.splice(T + 1, 0, a), f6[a] = n6, !n6.virtual)
              if (S) {
                var E = S.dom;
                E.nextSibling ? _.insertBefore(n6.dom, E.nextSibling) : _.appendChild(n6.dom);
              } else
                _.firstChild ? _.insertBefore(n6.dom, _.firstChild) : _.appendChild(n6.dom);
            n6.__painter = this;
          }
        }, s.prototype.eachLayer = function(a, n6) {
          for (var f6 = this._zlevelList, d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            a.call(n6, this._layers[y4], y4);
          }
        }, s.prototype.eachBuiltinLayer = function(a, n6) {
          for (var f6 = this._zlevelList, d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4], _ = this._layers[y4];
            _.__builtin__ && a.call(n6, _, y4);
          }
        }, s.prototype.eachOtherLayer = function(a, n6) {
          for (var f6 = this._zlevelList, d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4], _ = this._layers[y4];
            _.__builtin__ || a.call(n6, _, y4);
          }
        }, s.prototype.getLayers = function() {
          return this._layers;
        }, s.prototype._updateLayerStatus = function(a) {
          this.eachBuiltinLayer(function(R, V) {
            R.__dirty = R.__used = false;
          });
          function n6(R) {
            y4 && (y4.__endIndex !== R && (y4.__dirty = true), y4.__endIndex = R);
          }
          if (this._singleCanvas)
            for (var f6 = 1; f6 < a.length; f6++) {
              var d4 = a[f6];
              if (d4.zlevel !== a[f6 - 1].zlevel || d4.incremental) {
                this._needsManuallyCompositing = true;
                break;
              }
            }
          var y4 = null, _ = 0, S, T;
          for (T = 0; T < a.length; T++) {
            var d4 = a[T], E = d4.zlevel, O = void 0;
            S !== E && (S = E, _ = 0), d4.incremental ? (O = this.getLayer(E + i9t, this._needsManuallyCompositing), O.incremental = true, _ = 1) : O = this.getLayer(E + (_ > 0 ? moe : 0), this._needsManuallyCompositing), O.__builtin__ || sT("ZLevel " + E + " has been used by unkown layer " + O.id), O !== y4 && (O.__used = true, O.__startIndex !== T && (O.__dirty = true), O.__startIndex = T, O.incremental ? O.__drawIndex = -1 : O.__drawIndex = T, n6(T), y4 = O), d4.__dirty & x0 && !d4.__inHover && (O.__dirty = true, O.incremental && O.__drawIndex < 0 && (O.__drawIndex = T));
          }
          n6(T), this.eachBuiltinLayer(function(R, V) {
            !R.__used && R.getElementCount() > 0 && (R.__dirty = true, R.__startIndex = R.__endIndex = R.__drawIndex = 0), R.__dirty && R.__drawIndex < 0 && (R.__drawIndex = R.__startIndex);
          });
        }, s.prototype.clear = function() {
          return this.eachBuiltinLayer(this._clearLayer), this;
        }, s.prototype._clearLayer = function(a) {
          a.clear();
        }, s.prototype.setBackgroundColor = function(a) {
          this._backgroundColor = a, gt(this._layers, function(n6) {
            n6.setUnpainted();
          });
        }, s.prototype.configLayer = function(a, n6) {
          if (n6) {
            var f6 = this._layerConfig;
            f6[a] ? Ms(f6[a], n6, true) : f6[a] = n6;
            for (var d4 = 0; d4 < this._zlevelList.length; d4++) {
              var y4 = this._zlevelList[d4];
              if (y4 === a || y4 === a + moe) {
                var _ = this._layers[y4];
                Ms(_, f6[a], true);
              }
            }
          }
        }, s.prototype.delLayer = function(a) {
          var n6 = this._layers, f6 = this._zlevelList, d4 = n6[a];
          !d4 || (d4.dom.parentNode.removeChild(d4.dom), delete n6[a], f6.splice(Ns(f6, a), 1));
        }, s.prototype.resize = function(a, n6) {
          if (this._domRoot.style) {
            var f6 = this._domRoot;
            f6.style.display = "none";
            var d4 = this._opts, y4 = this.root;
            if (a != null && (d4.width = a), n6 != null && (d4.height = n6), a = z7(y4, 0, d4), n6 = z7(y4, 1, d4), f6.style.display = "", this._width !== a || n6 !== this._height) {
              f6.style.width = a + "px", f6.style.height = n6 + "px";
              for (var _ in this._layers)
                this._layers.hasOwnProperty(_) && this._layers[_].resize(a, n6);
              this.refresh(true);
            }
            this._width = a, this._height = n6;
          } else {
            if (a == null || n6 == null)
              return;
            this._width = a, this._height = n6, this.getLayer(XR).resize(a, n6);
          }
          return this;
        }, s.prototype.clearLayer = function(a) {
          var n6 = this._layers[a];
          n6 && n6.clear();
        }, s.prototype.dispose = function() {
          this.root.innerHTML = "", this.root = this.storage = this._domRoot = this._layers = null;
        }, s.prototype.getRenderedCanvas = function(a) {
          if (a = a || {}, this._singleCanvas && !this._compositeManually)
            return this._layers[XR].dom;
          var n6 = new eSe("image", this, a.pixelRatio || this.dpr);
          n6.initContext(), n6.clear(false, a.backgroundColor || this._backgroundColor);
          var f6 = n6.ctx;
          if (a.pixelRatio <= this.dpr) {
            this.refresh();
            var d4 = n6.dom.width, y4 = n6.dom.height;
            this.eachLayer(function(R) {
              R.__builtin__ ? f6.drawImage(R.dom, 0, 0, d4, y4) : R.renderToCanvas && (f6.save(), R.renderToCanvas(f6), f6.restore());
            });
          } else
            for (var _ = { inHover: false, viewWidth: this._width, viewHeight: this._height }, S = this.storage.getDisplayList(true), T = 0, E = S.length; T < E; T++) {
              var O = S[T];
              zR(f6, O, _, T === E - 1);
            }
          return n6.dom;
        }, s.prototype.getWidth = function() {
          return this._width;
        }, s.prototype.getHeight = function() {
          return this._height;
        }, s;
      }(), l9t = s9t;
      function u9t(s) {
        s.registerPainter("canvas", l9t);
      }
      var c9t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.hasSymbolVisual = true, n6;
        }
        return a.prototype.getInitialData = function(n6) {
          return PE(null, this, { useEncodeDefaulter: true });
        }, a.prototype.getLegendIcon = function(n6) {
          var f6 = new fs(), d4 = bv("line", 0, n6.itemHeight / 2, n6.itemWidth, 0, n6.lineStyle.stroke, false);
          f6.add(d4), d4.setStyle(n6.lineStyle);
          var y4 = this.getData().getVisual("symbol"), _ = this.getData().getVisual("symbolRotate"), S = y4 === "none" ? "circle" : y4, T = n6.itemHeight * 0.8, E = bv(S, (n6.itemWidth - T) / 2, (n6.itemHeight - T) / 2, T, T, n6.itemStyle.fill);
          f6.add(E), E.setStyle(n6.itemStyle);
          var O = n6.iconRotate === "inherit" ? _ : n6.iconRotate || 0;
          return E.rotation = O * Math.PI / 180, E.setOrigin([n6.itemWidth / 2, n6.itemHeight / 2]), S.indexOf("empty") > -1 && (E.style.stroke = E.style.fill, E.style.fill = "#fff", E.style.lineWidth = 2), f6;
        }, a.type = "series.line", a.dependencies = ["grid", "polar"], a.defaultOption = { z: 3, coordinateSystem: "cartesian2d", legendHoverLink: true, clip: true, label: { position: "top" }, endLabel: { show: false, valueAnimation: true, distance: 8 }, lineStyle: { width: 2, type: "solid" }, emphasis: { scale: true }, step: false, smooth: false, smoothMonotone: null, symbol: "emptyCircle", symbolSize: 4, symbolRotate: null, showSymbol: true, showAllSymbol: "auto", connectNulls: false, sampling: "none", animationEasing: "linear", progressive: 0, hoverLayerThreshold: 1 / 0, universalTransition: { divideShape: "clone" }, triggerLineEvent: false }, a;
      }(Cp), f9t = c9t;
      function U7(s, a) {
        var n6 = s.mapDimensionsAll("defaultedLabel"), f6 = n6.length;
        if (f6 === 1) {
          var d4 = P7(s, a, n6[0]);
          return d4 != null ? d4 + "" : null;
        } else if (f6) {
          for (var y4 = [], _ = 0; _ < n6.length; _++)
            y4.push(P7(s, a, n6[_]));
          return y4.join(" ");
        }
      }
      function AUe(s, a) {
        var n6 = s.mapDimensionsAll("defaultedLabel");
        if (!Di(a))
          return a + "";
        for (var f6 = [], d4 = 0; d4 < n6.length; d4++) {
          var y4 = s.getDimensionIndex(n6[d4]);
          y4 >= 0 && f6.push(a[y4]);
        }
        return f6.join(" ");
      }
      var h9t = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4) {
          var _ = s.call(this) || this;
          return _.updateData(n6, f6, d4, y4), _;
        }
        return a.prototype._createSymbol = function(n6, f6, d4, y4, _) {
          this.removeAll();
          var S = bv(n6, -1, -1, 2, 2, null, _);
          S.attr({ z2: 100, culling: true, scaleX: y4[0] / 2, scaleY: y4[1] / 2 }), S.drift = p9t, this._symbolType = n6, this.add(S);
        }, a.prototype.stopSymbolAnimation = function(n6) {
          this.childAt(0).stopAnimation(null, n6);
        }, a.prototype.getSymbolType = function() {
          return this._symbolType;
        }, a.prototype.getSymbolPath = function() {
          return this.childAt(0);
        }, a.prototype.highlight = function() {
          sS(this.childAt(0));
        }, a.prototype.downplay = function() {
          lS(this.childAt(0));
        }, a.prototype.setZ = function(n6, f6) {
          var d4 = this.childAt(0);
          d4.zlevel = n6, d4.z = f6;
        }, a.prototype.setDraggable = function(n6) {
          var f6 = this.childAt(0);
          f6.draggable = n6, f6.cursor = n6 ? "move" : f6.cursor;
        }, a.prototype.updateData = function(n6, f6, d4, y4) {
          this.silent = false;
          var _ = n6.getItemVisual(f6, "symbol") || "circle", S = n6.hostModel, T = a.getSymbolSize(n6, f6), E = _ !== this._symbolType, O = y4 && y4.disableAnimation;
          if (E) {
            var R = n6.getItemVisual(f6, "symbolKeepAspect");
            this._createSymbol(_, n6, f6, T, R);
          } else {
            var V = this.childAt(0);
            V.silent = false;
            var z3 = { scaleX: T[0] / 2, scaleY: T[1] / 2 };
            O ? V.attr(z3) : ku(V, z3, S, f6), ox(V);
          }
          if (this._updateCommon(n6, f6, T, d4, y4), E) {
            var V = this.childAt(0);
            if (!O) {
              var z3 = { scaleX: this._sizeX, scaleY: this._sizeY, style: { opacity: V.style.opacity } };
              V.scaleX = V.scaleY = 0, V.style.opacity = 0, $h(V, z3, S, f6);
            }
          }
          O && this.childAt(0).stopAnimation("leave");
        }, a.prototype._updateCommon = function(n6, f6, d4, y4, _) {
          var S = this.childAt(0), T = n6.hostModel, E, O, R, V, z3, H, Z, ee, oe;
          if (y4 && (E = y4.emphasisItemStyle, O = y4.blurItemStyle, R = y4.selectItemStyle, V = y4.focus, z3 = y4.blurScope, Z = y4.labelStatesModels, ee = y4.hoverScale, oe = y4.cursorStyle, H = y4.emphasisDisabled), !y4 || n6.hasItemOption) {
            var fe = y4 && y4.itemModel ? y4.itemModel : n6.getItemModel(f6), _e = fe.getModel("emphasis");
            E = _e.getModel("itemStyle").getItemStyle(), R = fe.getModel(["select", "itemStyle"]).getItemStyle(), O = fe.getModel(["blur", "itemStyle"]).getItemStyle(), V = _e.get("focus"), z3 = _e.get("blurScope"), H = _e.get("disabled"), Z = E0(fe), ee = _e.getShallow("scale"), oe = fe.getShallow("cursor");
          }
          var pe = n6.getItemVisual(f6, "symbolRotate");
          S.attr("rotation", (pe || 0) * Math.PI / 180 || 0);
          var Ve = B7(n6.getItemVisual(f6, "symbolOffset"), d4);
          Ve && (S.x = Ve[0], S.y = Ve[1]), oe && S.attr("cursor", oe);
          var Le = n6.getItemVisual(f6, "style"), je = Le.fill;
          if (S instanceof Zv) {
            var Xe = S.style;
            S.useStyle(ei({ image: Xe.image, x: Xe.x, y: Xe.y, width: Xe.width, height: Xe.height }, Le));
          } else
            S.__isEmptyBrush ? S.useStyle(ei({}, Le)) : S.useStyle(Le), S.style.decal = null, S.setColor(je, _ && _.symbolInnerColor), S.style.strokeNoScale = true;
          var Ye = n6.getItemVisual(f6, "liftZ"), rt2 = this._z2;
          Ye != null ? rt2 == null && (this._z2 = S.z2, S.z2 += Ye) : rt2 != null && (S.z2 = rt2, this._z2 = null);
          var ut = _ && _.useNameLabel;
          Gm(S, Z, { labelFetcher: T, labelDataIndex: f6, defaultText: wt, inheritColor: je, defaultOpacity: Le.opacity });
          function wt(Qt) {
            return ut ? n6.getName(Qt) : U7(n6, Qt);
          }
          this._sizeX = d4[0] / 2, this._sizeY = d4[1] / 2;
          var dt = S.ensureState("emphasis");
          if (dt.style = E, S.ensureState("select").style = R, S.ensureState("blur").style = O, ee) {
            var Gt = Math.max(1.1, 3 / this._sizeY);
            dt.scaleX = this._sizeX * Gt, dt.scaleY = this._sizeY * Gt;
          }
          this.setSymbolScale(1), Up(this, V, z3, H);
        }, a.prototype.setSymbolScale = function(n6) {
          this.scaleX = this.scaleY = n6;
        }, a.prototype.fadeOut = function(n6, f6, d4) {
          var y4 = this.childAt(0), _ = qo(this).dataIndex, S = d4 && d4.animation;
          if (this.silent = y4.silent = true, d4 && d4.fadeLabel) {
            var T = y4.getTextContent();
            T && kT(T, { style: { opacity: 0 } }, f6, { dataIndex: _, removeOpt: S, cb: function() {
              y4.removeTextContent();
            } });
          } else
            y4.removeTextContent();
          kT(y4, { style: { opacity: 0 }, scaleX: 0, scaleY: 0 }, f6, { dataIndex: _, cb: n6, removeOpt: S });
        }, a.getSymbolSize = function(n6, f6) {
          return x$(n6.getItemVisual(f6, "symbolSize"));
        }, a;
      }(fs);
      function p9t(s, a) {
        this.parent.drift(s, a);
      }
      var G$ = h9t;
      function tSe(s, a, n6, f6) {
        return a && !isNaN(a[0]) && !isNaN(a[1]) && !(f6.isIgnore && f6.isIgnore(n6)) && !(f6.clipShape && !f6.clipShape.contain(a[0], a[1])) && s.getItemVisual(n6, "symbol") !== "none";
      }
      function IUe(s) {
        return s != null && !Qo(s) && (s = { isIgnore: s }), s || {};
      }
      function EUe(s) {
        var a = s.hostModel, n6 = a.getModel("emphasis");
        return { emphasisItemStyle: n6.getModel("itemStyle").getItemStyle(), blurItemStyle: a.getModel(["blur", "itemStyle"]).getItemStyle(), selectItemStyle: a.getModel(["select", "itemStyle"]).getItemStyle(), focus: n6.get("focus"), blurScope: n6.get("blurScope"), emphasisDisabled: n6.get("disabled"), hoverScale: n6.get("scale"), labelStatesModels: E0(a), cursorStyle: a.get("cursor") };
      }
      var d9t = function() {
        function s(a) {
          this.group = new fs(), this._SymbolCtor = a || G$;
        }
        return s.prototype.updateData = function(a, n6) {
          this._progressiveEls = null, n6 = IUe(n6);
          var f6 = this.group, d4 = a.hostModel, y4 = this._data, _ = this._SymbolCtor, S = n6.disableAnimation, T = EUe(a), E = { disableAnimation: S }, O = n6.getSymbolPoint || function(R) {
            return a.getItemLayout(R);
          };
          y4 || f6.removeAll(), a.diff(y4).add(function(R) {
            var V = O(R);
            if (tSe(a, V, R, n6)) {
              var z3 = new _(a, R, T, E);
              z3.setPosition(V), a.setItemGraphicEl(R, z3), f6.add(z3);
            }
          }).update(function(R, V) {
            var z3 = y4.getItemGraphicEl(V), H = O(R);
            if (!tSe(a, H, R, n6)) {
              f6.remove(z3);
              return;
            }
            var Z = a.getItemVisual(R, "symbol") || "circle", ee = z3 && z3.getSymbolType && z3.getSymbolType();
            if (!z3 || ee && ee !== Z)
              f6.remove(z3), z3 = new _(a, R, T, E), z3.setPosition(H);
            else {
              z3.updateData(a, R, T, E);
              var oe = { x: H[0], y: H[1] };
              S ? z3.attr(oe) : ku(z3, oe, d4);
            }
            f6.add(z3), a.setItemGraphicEl(R, z3);
          }).remove(function(R) {
            var V = y4.getItemGraphicEl(R);
            V && V.fadeOut(function() {
              f6.remove(V);
            }, d4);
          }).execute(), this._getSymbolPoint = O, this._data = a;
        }, s.prototype.updateLayout = function() {
          var a = this, n6 = this._data;
          n6 && n6.eachItemGraphicEl(function(f6, d4) {
            var y4 = a._getSymbolPoint(d4);
            f6.setPosition(y4), f6.markRedraw();
          });
        }, s.prototype.incrementalPrepareUpdate = function(a) {
          this._seriesScope = EUe(a), this._data = null, this.group.removeAll();
        }, s.prototype.incrementalUpdate = function(a, n6, f6) {
          this._progressiveEls = [], f6 = IUe(f6);
          function d4(T) {
            T.isGroup || (T.incremental = true, T.ensureState("emphasis").hoverLayer = true);
          }
          for (var y4 = a.start; y4 < a.end; y4++) {
            var _ = n6.getItemLayout(y4);
            if (tSe(n6, _, y4, f6)) {
              var S = new this._SymbolCtor(n6, y4, this._seriesScope);
              S.traverse(d4), S.setPosition(_), this.group.add(S), n6.setItemGraphicEl(y4, S), this._progressiveEls.push(S);
            }
          }
        }, s.prototype.eachRendered = function(a) {
          mC(this._progressiveEls || this.group, a);
        }, s.prototype.remove = function(a) {
          var n6 = this.group, f6 = this._data;
          f6 && a ? f6.eachItemGraphicEl(function(d4) {
            d4.fadeOut(function() {
              n6.remove(d4);
            }, f6.hostModel);
          }) : n6.removeAll();
        }, s;
      }(), H$ = d9t;
      function DUe(s, a, n6) {
        var f6 = s.getBaseAxis(), d4 = s.getOtherAxis(f6), y4 = v9t(d4, n6), _ = f6.dim, S = d4.dim, T = a.mapDimension(S), E = a.mapDimension(_), O = S === "x" || S === "radius" ? 1 : 0, R = Pi(s.dimensions, function(H) {
          return a.mapDimension(H);
        }), V = false, z3 = a.getCalculationInfo("stackResultDimension");
        return t32(a, R[0]) && (V = true, R[0] = z3), t32(a, R[1]) && (V = true, R[1] = z3), { dataDimsForPoint: R, valueStart: y4, valueAxisDim: S, baseAxisDim: _, stacked: !!V, valueDim: T, baseDim: E, baseDataOffset: O, stackedOverDimension: a.getCalculationInfo("stackedOverDimension") };
      }
      function v9t(s, a) {
        var n6 = 0, f6 = s.scale.getExtent();
        return a === "start" ? n6 = f6[0] : a === "end" ? n6 = f6[1] : f6[0] > 0 ? n6 = f6[0] : f6[1] < 0 && (n6 = f6[1]), n6;
      }
      function kUe(s, a, n6, f6) {
        var d4 = NaN;
        s.stacked && (d4 = n6.get(n6.getCalculationInfo("stackedOverDimension"), f6)), isNaN(d4) && (d4 = s.valueStart);
        var y4 = s.baseDataOffset, _ = [];
        return _[y4] = n6.get(s.baseDim, f6), _[1 - y4] = d4, a.dataToPoint(_);
      }
      function g9t(s, a) {
        var n6 = [];
        return a.diff(s).add(function(f6) {
          n6.push({ cmd: "+", idx: f6 });
        }).update(function(f6, d4) {
          n6.push({ cmd: "=", idx: d4, idx1: f6 });
        }).remove(function(f6) {
          n6.push({ cmd: "-", idx: f6 });
        }).execute(), n6;
      }
      function y9t(s, a, n6, f6, d4, y4, _, S) {
        for (var T = g9t(s, a), E = [], O = [], R = [], V = [], z3 = [], H = [], Z = [], ee = DUe(d4, a, _), oe = s.getLayout("points") || [], fe = a.getLayout("points") || [], _e = 0; _e < T.length; _e++) {
          var pe = T[_e], Ve = true, Le = void 0, je = void 0;
          switch (pe.cmd) {
            case "=":
              Le = pe.idx * 2, je = pe.idx1 * 2;
              var Xe = oe[Le], Ye = oe[Le + 1], rt2 = fe[je], ut = fe[je + 1];
              (isNaN(Xe) || isNaN(Ye)) && (Xe = rt2, Ye = ut), E.push(Xe, Ye), O.push(rt2, ut), R.push(n6[Le], n6[Le + 1]), V.push(f6[je], f6[je + 1]), Z.push(a.getRawIndex(pe.idx1));
              break;
            case "+":
              var wt = pe.idx, dt = ee.dataDimsForPoint, Gt = d4.dataToPoint([a.get(dt[0], wt), a.get(dt[1], wt)]);
              je = wt * 2, E.push(Gt[0], Gt[1]), O.push(fe[je], fe[je + 1]);
              var Qt = kUe(ee, d4, a, wt);
              R.push(Qt[0], Qt[1]), V.push(f6[je], f6[je + 1]), Z.push(a.getRawIndex(wt));
              break;
            case "-":
              Ve = false;
          }
          Ve && (z3.push(pe), H.push(H.length));
        }
        H.sort(function(ko, wo) {
          return Z[ko] - Z[wo];
        });
        for (var Nt = E.length, er = RT(Nt), un = RT(Nt), pn = RT(Nt), On = RT(Nt), fr = [], _e = 0; _e < H.length; _e++) {
          var yr = H[_e], da = _e * 2, Ja = yr * 2;
          er[da] = E[Ja], er[da + 1] = E[Ja + 1], un[da] = O[Ja], un[da + 1] = O[Ja + 1], pn[da] = R[Ja], pn[da + 1] = R[Ja + 1], On[da] = V[Ja], On[da + 1] = V[Ja + 1], fr[_e] = z3[yr];
        }
        return { current: er, next: un, stackedOnCurrent: pn, stackedOnNext: On, status: fr };
      }
      var r32 = Math.min, i3 = Math.max;
      function YR(s, a) {
        return isNaN(s) || isNaN(a);
      }
      function nSe(s, a, n6, f6, d4, y4, _, S, T) {
        for (var E, O, R, V, z3, H, Z = n6, ee = 0; ee < f6; ee++) {
          var oe = a[Z * 2], fe = a[Z * 2 + 1];
          if (Z >= d4 || Z < 0)
            break;
          if (YR(oe, fe)) {
            if (T) {
              Z += y4;
              continue;
            }
            break;
          }
          if (Z === n6)
            s[y4 > 0 ? "moveTo" : "lineTo"](oe, fe), R = oe, V = fe;
          else {
            var _e = oe - E, pe = fe - O;
            if (_e * _e + pe * pe < 0.5) {
              Z += y4;
              continue;
            }
            if (_ > 0) {
              for (var Ve = Z + y4, Le = a[Ve * 2], je = a[Ve * 2 + 1]; Le === oe && je === fe && ee < f6; )
                ee++, Ve += y4, Z += y4, Le = a[Ve * 2], je = a[Ve * 2 + 1], oe = a[Z * 2], fe = a[Z * 2 + 1], _e = oe - E, pe = fe - O;
              var Xe = ee + 1;
              if (T)
                for (; YR(Le, je) && Xe < f6; )
                  Xe++, Ve += y4, Le = a[Ve * 2], je = a[Ve * 2 + 1];
              var Ye = 0.5, rt2 = 0, ut = 0, wt = void 0, dt = void 0;
              if (Xe >= f6 || YR(Le, je))
                z3 = oe, H = fe;
              else {
                rt2 = Le - E, ut = je - O;
                var Gt = oe - E, Qt = Le - oe, Nt = fe - O, er = je - fe, un = void 0, pn = void 0;
                if (S === "x") {
                  un = Math.abs(Gt), pn = Math.abs(Qt);
                  var On = rt2 > 0 ? 1 : -1;
                  z3 = oe - On * un * _, H = fe, wt = oe + On * pn * _, dt = fe;
                } else if (S === "y") {
                  un = Math.abs(Nt), pn = Math.abs(er);
                  var fr = ut > 0 ? 1 : -1;
                  z3 = oe, H = fe - fr * un * _, wt = oe, dt = fe + fr * pn * _;
                } else
                  un = Math.sqrt(Gt * Gt + Nt * Nt), pn = Math.sqrt(Qt * Qt + er * er), Ye = pn / (pn + un), z3 = oe - rt2 * _ * (1 - Ye), H = fe - ut * _ * (1 - Ye), wt = oe + rt2 * _ * Ye, dt = fe + ut * _ * Ye, wt = r32(wt, i3(Le, oe)), dt = r32(dt, i3(je, fe)), wt = i3(wt, r32(Le, oe)), dt = i3(dt, r32(je, fe)), rt2 = wt - oe, ut = dt - fe, z3 = oe - rt2 * un / pn, H = fe - ut * un / pn, z3 = r32(z3, i3(E, oe)), H = r32(H, i3(O, fe)), z3 = i3(z3, r32(E, oe)), H = i3(H, r32(O, fe)), rt2 = oe - z3, ut = fe - H, wt = oe + rt2 * pn / un, dt = fe + ut * pn / un;
              }
              s.bezierCurveTo(R, V, z3, H, oe, fe), R = wt, V = dt;
            } else
              s.lineTo(oe, fe);
          }
          E = oe, O = fe, Z += y4;
        }
        return ee;
      }
      var OUe = function() {
        function s() {
          this.smooth = 0, this.smoothConstraint = true;
        }
        return s;
      }(), m9t = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "ec-polyline", f6;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new OUe();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.points, y4 = 0, _ = d4.length / 2;
          if (f6.connectNulls) {
            for (; _ > 0 && YR(d4[_ * 2 - 2], d4[_ * 2 - 1]); _--)
              ;
            for (; y4 < _ && YR(d4[y4 * 2], d4[y4 * 2 + 1]); y4++)
              ;
          }
          for (; y4 < _; )
            y4 += nSe(n6, d4, y4, _, _, 1, f6.smooth, f6.smoothMonotone, f6.connectNulls) + 1;
        }, a.prototype.getPointOn = function(n6, f6) {
          this.path || (this.createPathProxy(), this.buildPath(this.path, this.shape));
          for (var d4 = this.path, y4 = d4.data, _ = aS.CMD, S, T, E = f6 === "x", O = [], R = 0; R < y4.length; ) {
            var V = y4[R++], z3 = void 0, H = void 0, Z = void 0, ee = void 0, oe = void 0, fe = void 0, _e = void 0;
            switch (V) {
              case _.M:
                S = y4[R++], T = y4[R++];
                break;
              case _.L:
                if (z3 = y4[R++], H = y4[R++], _e = E ? (n6 - S) / (z3 - S) : (n6 - T) / (H - T), _e <= 1 && _e >= 0) {
                  var pe = E ? (H - T) * _e + T : (z3 - S) * _e + S;
                  return E ? [n6, pe] : [pe, n6];
                }
                S = z3, T = H;
                break;
              case _.C:
                z3 = y4[R++], H = y4[R++], Z = y4[R++], ee = y4[R++], oe = y4[R++], fe = y4[R++];
                var Ve = E ? v9(S, z3, Z, oe, n6, O) : v9(T, H, ee, fe, n6, O);
                if (Ve > 0)
                  for (var Le = 0; Le < Ve; Le++) {
                    var je = O[Le];
                    if (je <= 1 && je >= 0) {
                      var pe = E ? id2(T, H, ee, fe, je) : id2(S, z3, Z, oe, je);
                      return E ? [n6, pe] : [pe, n6];
                    }
                  }
                S = oe, T = fe;
                break;
            }
          }
        }, a;
      }(ml), b9t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a;
      }(OUe), PUe = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "ec-polygon", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new b9t();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.points, y4 = f6.stackedOnPoints, _ = 0, S = d4.length / 2, T = f6.smoothMonotone;
          if (f6.connectNulls) {
            for (; S > 0 && YR(d4[S * 2 - 2], d4[S * 2 - 1]); S--)
              ;
            for (; _ < S && YR(d4[_ * 2], d4[_ * 2 + 1]); _++)
              ;
          }
          for (; _ < S; ) {
            var E = nSe(n6, d4, _, S, S, 1, f6.smooth, T, f6.connectNulls);
            nSe(n6, y4, _ + E - 1, E, S, -1, f6.stackedOnSmooth, T, f6.connectNulls), _ += E + 1, n6.closePath();
          }
        }, a;
      }(ml);
      function LUe(s, a, n6, f6, d4) {
        var y4 = s.getArea(), _ = y4.x, S = y4.y, T = y4.width, E = y4.height, O = n6.get(["lineStyle", "width"]) || 2;
        _ -= O / 2, S -= O / 2, T += O, E += O, _ = Math.floor(_), T = Math.round(T);
        var R = new xu({ shape: { x: _, y: S, width: T, height: E } });
        if (a) {
          var V = s.getBaseAxis(), z3 = V.isHorizontal(), H = V.inverse;
          z3 ? (H && (R.shape.x += T), R.shape.width = 0) : (H || (R.shape.y += E), R.shape.height = 0);
          var Z = jo(d4) ? function(ee) {
            d4(ee, R);
          } : null;
          $h(R, { shape: { width: T, height: E, x: _, y: S } }, n6, null, f6, Z);
        }
        return R;
      }
      function RUe(s, a, n6) {
        var f6 = s.getArea(), d4 = Wp(f6.r0, 1), y4 = Wp(f6.r, 1), _ = new Bm({ shape: { cx: Wp(s.cx, 1), cy: Wp(s.cy, 1), r0: d4, r: y4, startAngle: f6.startAngle, endAngle: f6.endAngle, clockwise: f6.clockwise } });
        if (a) {
          var S = s.getBaseAxis().dim === "angle";
          S ? _.shape.endAngle = f6.startAngle : _.shape.r = d4, $h(_, { shape: { endAngle: f6.endAngle, r: y4 } }, n6);
        }
        return _;
      }
      function boe(s, a, n6, f6, d4) {
        if (s) {
          if (s.type === "polar")
            return RUe(s, a, n6);
          if (s.type === "cartesian2d")
            return LUe(s, a, n6, f6, d4);
        } else
          return null;
        return null;
      }
      function RE(s, a) {
        return s.type === a;
      }
      function NUe(s, a) {
        if (s.length === a.length) {
          for (var n6 = 0; n6 < s.length; n6++)
            if (s[n6] !== a[n6])
              return;
          return true;
        }
      }
      function FUe(s) {
        for (var a = 1 / 0, n6 = 1 / 0, f6 = -1 / 0, d4 = -1 / 0, y4 = 0; y4 < s.length; ) {
          var _ = s[y4++], S = s[y4++];
          isNaN(_) || (a = Math.min(_, a), f6 = Math.max(_, f6)), isNaN(S) || (n6 = Math.min(S, n6), d4 = Math.max(S, d4));
        }
        return [[a, n6], [f6, d4]];
      }
      function VUe(s, a) {
        var n6 = FUe(s), f6 = n6[0], d4 = n6[1], y4 = FUe(a), _ = y4[0], S = y4[1];
        return Math.max(Math.abs(f6[0] - _[0]), Math.abs(f6[1] - _[1]), Math.abs(d4[0] - S[0]), Math.abs(d4[1] - S[1]));
      }
      function BUe(s) {
        return ac(s) ? s : s ? 0.5 : 0;
      }
      function _9t(s, a, n6) {
        if (!n6.valueDim)
          return [];
        for (var f6 = a.count(), d4 = RT(f6 * 2), y4 = 0; y4 < f6; y4++) {
          var _ = kUe(n6, s, a, y4);
          d4[y4 * 2] = _[0], d4[y4 * 2 + 1] = _[1];
        }
        return d4;
      }
      function a3(s, a, n6, f6) {
        var d4 = a.getBaseAxis(), y4 = d4.dim === "x" || d4.dim === "radius" ? 0 : 1, _ = [], S = 0, T = [], E = [], O = [], R = [];
        if (f6) {
          for (S = 0; S < s.length; S += 2)
            !isNaN(s[S]) && !isNaN(s[S + 1]) && R.push(s[S], s[S + 1]);
          s = R;
        }
        for (S = 0; S < s.length - 2; S += 2)
          switch (O[0] = s[S + 2], O[1] = s[S + 3], E[0] = s[S], E[1] = s[S + 1], _.push(E[0], E[1]), n6) {
            case "end":
              T[y4] = O[y4], T[1 - y4] = E[1 - y4], _.push(T[0], T[1]);
              break;
            case "middle":
              var V = (E[y4] + O[y4]) / 2, z3 = [];
              T[y4] = z3[y4] = V, T[1 - y4] = E[1 - y4], z3[1 - y4] = O[1 - y4], _.push(T[0], T[1]), _.push(z3[0], z3[1]);
              break;
            default:
              T[y4] = E[y4], T[1 - y4] = O[1 - y4], _.push(T[0], T[1]);
          }
        return _.push(s[S++], s[S++]), _;
      }
      function x9t(s, a) {
        var n6 = [], f6 = s.length, d4, y4;
        function _(O, R, V) {
          var z3 = O.coord, H = (V - z3) / (R.coord - z3), Z = Ibe(H, [O.color, R.color]);
          return { coord: V, color: Z };
        }
        for (var S = 0; S < f6; S++) {
          var T = s[S], E = T.coord;
          if (E < 0)
            d4 = T;
          else if (E > a) {
            y4 ? n6.push(_(y4, T, a)) : d4 && n6.push(_(d4, T, 0), _(d4, T, a));
            break;
          } else
            d4 && (n6.push(_(d4, T, 0)), d4 = null), n6.push(T), y4 = T;
        }
        return n6;
      }
      function w9t(s, a, n6) {
        var f6 = s.getVisual("visualMeta");
        if (!(!f6 || !f6.length || !s.count()) && a.type === "cartesian2d") {
          for (var d4, y4, _ = f6.length - 1; _ >= 0; _--) {
            var S = s.getDimensionInfo(f6[_].dimension);
            if (d4 = S && S.coordDim, d4 === "x" || d4 === "y") {
              y4 = f6[_];
              break;
            }
          }
          if (y4) {
            var T = a.getAxis(d4), E = Pi(y4.stops, function(_e) {
              return { coord: T.toGlobalCoord(T.dataToCoord(_e.value)), color: _e.color };
            }), O = E.length, R = y4.outerColors.slice();
            O && E[0].coord > E[O - 1].coord && (E.reverse(), R.reverse());
            var V = x9t(E, d4 === "x" ? n6.getWidth() : n6.getHeight()), z3 = V.length;
            if (!z3 && O)
              return E[0].coord < 0 ? R[1] ? R[1] : E[O - 1].color : R[0] ? R[0] : E[0].color;
            var H = 10, Z = V[0].coord - H, ee = V[z3 - 1].coord + H, oe = ee - Z;
            if (oe < 1e-3)
              return "transparent";
            gt(V, function(_e) {
              _e.offset = (_e.coord - Z) / oe;
            }), V.push({ offset: z3 ? V[z3 - 1].offset : 0.5, color: R[1] || "transparent" }), V.unshift({ offset: z3 ? V[0].offset : 0.5, color: R[0] || "transparent" });
            var fe = new DR(0, 0, 0, 0, V, true);
            return fe[d4] = Z, fe[d4 + "2"] = ee, fe;
          }
        }
      }
      function S9t(s, a, n6) {
        var f6 = s.get("showAllSymbol"), d4 = f6 === "auto";
        if (!(f6 && !d4)) {
          var y4 = n6.getAxesByScale("ordinal")[0];
          if (!!y4 && !(d4 && C9t(y4, a))) {
            var _ = a.mapDimension(y4.dim), S = {};
            return gt(y4.getViewLabels(), function(T) {
              var E = y4.scale.getRawOrdinalNumber(T.tickValue);
              S[E] = 1;
            }), function(T) {
              return !S.hasOwnProperty(a.get(_, T));
            };
          }
        }
      }
      function C9t(s, a) {
        var n6 = s.getExtent(), f6 = Math.abs(n6[1] - n6[0]) / s.scale.count();
        isNaN(f6) && (f6 = 0);
        for (var d4 = a.count(), y4 = Math.max(1, Math.round(d4 / 5)), _ = 0; _ < d4; _ += y4)
          if (G$.getSymbolSize(a, _)[s.isHorizontal() ? 1 : 0] * 1.5 > f6)
            return false;
        return true;
      }
      function M9t(s, a) {
        return isNaN(s) || isNaN(a);
      }
      function T9t(s) {
        for (var a = s.length / 2; a > 0 && M9t(s[a * 2 - 2], s[a * 2 - 1]); a--)
          ;
        return a - 1;
      }
      function zUe(s, a) {
        return [s[a * 2], s[a * 2 + 1]];
      }
      function A9t(s, a, n6) {
        for (var f6 = s.length / 2, d4 = n6 === "x" ? 0 : 1, y4, _, S = 0, T = -1, E = 0; E < f6; E++)
          if (_ = s[E * 2 + d4], !(isNaN(_) || isNaN(s[E * 2 + 1 - d4]))) {
            if (E === 0) {
              y4 = _;
              continue;
            }
            if (y4 <= a && _ >= a || y4 >= a && _ <= a) {
              T = E;
              break;
            }
            S = E, y4 = _;
          }
        return { range: [S, T], t: (a - y4) / (_ - y4) };
      }
      function jUe(s) {
        if (s.get(["endLabel", "show"]))
          return true;
        for (var a = 0; a < od.length; a++)
          if (s.get([od[a], "endLabel", "show"]))
            return true;
        return false;
      }
      function rSe(s, a, n6, f6) {
        if (RE(a, "cartesian2d")) {
          var d4 = f6.getModel("endLabel"), y4 = d4.get("valueAnimation"), _ = f6.getData(), S = { lastFrameIndex: 0 }, T = jUe(f6) ? function(z3, H) {
            s._endLabelOnDuring(z3, H, _, S, y4, d4, a);
          } : null, E = a.getBaseAxis().isHorizontal(), O = LUe(a, n6, f6, function() {
            var z3 = s._endLabel;
            z3 && n6 && S.originalX != null && z3.attr({ x: S.originalX, y: S.originalY });
          }, T);
          if (!f6.get("clip", true)) {
            var R = O.shape, V = Math.max(R.width, R.height);
            E ? (R.y -= V, R.height += V * 2) : (R.x -= V, R.width += V * 2);
          }
          return T && T(1, O), O;
        } else
          return RUe(a, n6, f6);
      }
      function I9t(s, a) {
        var n6 = a.getBaseAxis(), f6 = n6.isHorizontal(), d4 = n6.inverse, y4 = f6 ? d4 ? "right" : "left" : "center", _ = f6 ? "middle" : d4 ? "top" : "bottom";
        return { normal: { align: s.get("align") || y4, verticalAlign: s.get("verticalAlign") || _ } };
      }
      var E9t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.init = function() {
          var n6 = new fs(), f6 = new H$();
          this.group.add(f6.group), this._symbolDraw = f6, this._lineGroup = n6;
        }, a.prototype.render = function(n6, f6, d4) {
          var y4 = this, _ = n6.coordinateSystem, S = this.group, T = n6.getData(), E = n6.getModel("lineStyle"), O = n6.getModel("areaStyle"), R = T.getLayout("points") || [], V = _.type === "polar", z3 = this._coordSys, H = this._symbolDraw, Z = this._polyline, ee = this._polygon, oe = this._lineGroup, fe = n6.get("animation"), _e = !O.isEmpty(), pe = O.get("origin"), Ve = DUe(_, T, pe), Le = _e && _9t(_, T, Ve), je = n6.get("showSymbol"), Xe = n6.get("connectNulls"), Ye = je && !V && S9t(n6, T, _), rt2 = this._data;
          rt2 && rt2.eachItemGraphicEl(function(wo, So) {
            wo.__temp && (S.remove(wo), rt2.setItemGraphicEl(So, null));
          }), je || H.remove(), S.add(oe);
          var ut = V ? false : n6.get("step"), wt;
          _ && _.getArea && n6.get("clip", true) && (wt = _.getArea(), wt.width != null ? (wt.x -= 0.1, wt.y -= 0.1, wt.width += 0.2, wt.height += 0.2) : wt.r0 && (wt.r0 -= 0.5, wt.r += 0.5)), this._clipShapeForSymbol = wt;
          var dt = w9t(T, _, d4) || T.getVisual("style")[T.getVisual("drawType")];
          if (!(Z && z3.type === _.type && ut === this._step))
            je && H.updateData(T, { isIgnore: Ye, clipShape: wt, disableAnimation: true, getSymbolPoint: function(wo) {
              return [R[wo * 2], R[wo * 2 + 1]];
            } }), fe && this._initSymbolLabelAnimation(T, _, wt), ut && (R = a3(R, _, ut, Xe), Le && (Le = a3(Le, _, ut, Xe))), Z = this._newPolyline(R), _e && (ee = this._newPolygon(R, Le)), V || this._initOrUpdateEndLabel(n6, _, LR(dt)), oe.setClipPath(rSe(this, _, true, n6));
          else {
            _e && !ee ? ee = this._newPolygon(R, Le) : ee && !_e && (oe.remove(ee), ee = this._polygon = null), V || this._initOrUpdateEndLabel(n6, _, LR(dt));
            var Gt = oe.getClipPath();
            if (Gt) {
              var Qt = rSe(this, _, false, n6);
              $h(Gt, { shape: Qt.shape }, n6);
            } else
              oe.setClipPath(rSe(this, _, true, n6));
            je && H.updateData(T, { isIgnore: Ye, clipShape: wt, disableAnimation: true, getSymbolPoint: function(wo) {
              return [R[wo * 2], R[wo * 2 + 1]];
            } }), (!NUe(this._stackedOnPoints, Le) || !NUe(this._points, R)) && (fe ? this._doUpdateAnimation(T, Le, _, d4, ut, pe, Xe) : (ut && (R = a3(R, _, ut, Xe), Le && (Le = a3(Le, _, ut, Xe))), Z.setShape({ points: R }), ee && ee.setShape({ points: R, stackedOnPoints: Le })));
          }
          var Nt = n6.getModel("emphasis"), er = Nt.get("focus"), un = Nt.get("blurScope"), pn = Nt.get("disabled");
          if (Z.useStyle(zo(E.getLineStyle(), { fill: "none", stroke: dt, lineJoin: "bevel" })), Pg(Z, n6, "lineStyle"), Z.style.lineWidth > 0 && n6.get(["emphasis", "lineStyle", "width"]) === "bolder") {
            var On = Z.getState("emphasis").style;
            On.lineWidth = +Z.style.lineWidth + 1;
          }
          qo(Z).seriesIndex = n6.seriesIndex, Up(Z, er, un, pn);
          var fr = BUe(n6.get("smooth")), yr = n6.get("smoothMonotone");
          if (Z.setShape({ smooth: fr, smoothMonotone: yr, connectNulls: Xe }), ee) {
            var da = T.getCalculationInfo("stackedOnSeries"), Ja = 0;
            ee.useStyle(zo(O.getAreaStyle(), { fill: dt, opacity: 0.7, lineJoin: "bevel", decal: T.getVisual("style").decal })), da && (Ja = BUe(da.get("smooth"))), ee.setShape({ smooth: fr, stackedOnSmooth: Ja, smoothMonotone: yr, connectNulls: Xe }), Pg(ee, n6, "areaStyle"), qo(ee).seriesIndex = n6.seriesIndex, Up(ee, er, un, pn);
          }
          var ko = function(wo) {
            y4._changePolyState(wo);
          };
          T.eachItemGraphicEl(function(wo) {
            wo && (wo.onHoverStateChange = ko);
          }), this._polyline.onHoverStateChange = ko, this._data = T, this._coordSys = _, this._stackedOnPoints = Le, this._points = R, this._step = ut, this._valueOrigin = pe, n6.get("triggerLineEvent") && (this.packEventData(n6, Z), ee && this.packEventData(n6, ee));
        }, a.prototype.packEventData = function(n6, f6) {
          qo(f6).eventData = { componentType: "series", componentSubType: "line", componentIndex: n6.componentIndex, seriesIndex: n6.seriesIndex, seriesName: n6.name, seriesType: "line" };
        }, a.prototype.highlight = function(n6, f6, d4, y4) {
          var _ = n6.getData(), S = hE(_, y4);
          if (this._changePolyState("emphasis"), !(S instanceof Array) && S != null && S >= 0) {
            var T = _.getLayout("points"), E = _.getItemGraphicEl(S);
            if (!E) {
              var O = T[S * 2], R = T[S * 2 + 1];
              if (isNaN(O) || isNaN(R) || this._clipShapeForSymbol && !this._clipShapeForSymbol.contain(O, R))
                return;
              var V = n6.get("zlevel"), z3 = n6.get("z");
              E = new G$(_, S), E.x = O, E.y = R, E.setZ(V, z3);
              var H = E.getSymbolPath().getTextContent();
              H && (H.zlevel = V, H.z = z3, H.z2 = this._polyline.z2 + 1), E.__temp = true, _.setItemGraphicEl(S, E), E.stopSymbolAnimation(true), this.group.add(E);
            }
            E.highlight();
          } else
            Ch.prototype.highlight.call(this, n6, f6, d4, y4);
        }, a.prototype.downplay = function(n6, f6, d4, y4) {
          var _ = n6.getData(), S = hE(_, y4);
          if (this._changePolyState("normal"), S != null && S >= 0) {
            var T = _.getItemGraphicEl(S);
            T && (T.__temp ? (_.setItemGraphicEl(S, null), this.group.remove(T)) : T.downplay());
          } else
            Ch.prototype.downplay.call(this, n6, f6, d4, y4);
        }, a.prototype._changePolyState = function(n6) {
          var f6 = this._polygon;
          DT(this._polyline, n6), f6 && DT(f6, n6);
        }, a.prototype._newPolyline = function(n6) {
          var f6 = this._polyline;
          return f6 && this._lineGroup.remove(f6), f6 = new m9t({ shape: { points: n6 }, segmentIgnoreThreshold: 2, z2: 10 }), this._lineGroup.add(f6), this._polyline = f6, f6;
        }, a.prototype._newPolygon = function(n6, f6) {
          var d4 = this._polygon;
          return d4 && this._lineGroup.remove(d4), d4 = new PUe({ shape: { points: n6, stackedOnPoints: f6 }, segmentIgnoreThreshold: 2 }), this._lineGroup.add(d4), this._polygon = d4, d4;
        }, a.prototype._initSymbolLabelAnimation = function(n6, f6, d4) {
          var y4, _, S = f6.getBaseAxis(), T = S.inverse;
          f6.type === "cartesian2d" ? (y4 = S.isHorizontal(), _ = false) : f6.type === "polar" && (y4 = S.dim === "angle", _ = true);
          var E = n6.hostModel, O = E.get("animationDuration");
          jo(O) && (O = O(null));
          var R = E.get("animationDelay") || 0, V = jo(R) ? R(null) : R;
          n6.eachItemGraphicEl(function(z3, H) {
            var Z = z3;
            if (Z) {
              var ee = [z3.x, z3.y], oe = void 0, fe = void 0, _e = void 0;
              if (d4)
                if (_) {
                  var pe = d4, Ve = f6.pointToCoord(ee);
                  y4 ? (oe = pe.startAngle, fe = pe.endAngle, _e = -Ve[1] / 180 * Math.PI) : (oe = pe.r0, fe = pe.r, _e = Ve[0]);
                } else {
                  var Le = d4;
                  y4 ? (oe = Le.x, fe = Le.x + Le.width, _e = z3.x) : (oe = Le.y + Le.height, fe = Le.y, _e = z3.y);
                }
              var je = fe === oe ? 0 : (_e - oe) / (fe - oe);
              T && (je = 1 - je);
              var Xe = jo(R) ? R(H) : O * je + V, Ye = Z.getSymbolPath(), rt2 = Ye.getTextContent();
              Z.attr({ scaleX: 0, scaleY: 0 }), Z.animateTo({ scaleX: 1, scaleY: 1 }, { duration: 200, setToFinal: true, delay: Xe }), rt2 && rt2.animateFrom({ style: { opacity: 0 } }, { duration: 300, delay: Xe }), Ye.disableLabelAnimation = true;
            }
          });
        }, a.prototype._initOrUpdateEndLabel = function(n6, f6, d4) {
          var y4 = n6.getModel("endLabel");
          if (jUe(n6)) {
            var _ = n6.getData(), S = this._polyline, T = _.getLayout("points");
            if (!T) {
              S.removeTextContent(), this._endLabel = null;
              return;
            }
            var E = this._endLabel;
            E || (E = this._endLabel = new ju({ z2: 200 }), E.ignoreClip = true, S.setTextContent(this._endLabel), S.disableLabelAnimation = true);
            var O = T9t(T);
            O >= 0 && (Gm(S, E0(n6, "endLabel"), { inheritColor: d4, labelFetcher: n6, labelDataIndex: O, defaultText: function(R, V, z3) {
              return z3 != null ? AUe(_, z3) : U7(_, R);
            }, enableTextSetter: true }, I9t(y4, f6)), S.textConfig.position = null);
          } else
            this._endLabel && (this._polyline.removeTextContent(), this._endLabel = null);
        }, a.prototype._endLabelOnDuring = function(n6, f6, d4, y4, _, S, T) {
          var E = this._endLabel, O = this._polyline;
          if (E) {
            n6 < 1 && y4.originalX == null && (y4.originalX = E.x, y4.originalY = E.y);
            var R = d4.getLayout("points"), V = d4.hostModel, z3 = V.get("connectNulls"), H = S.get("precision"), Z = S.get("distance") || 0, ee = T.getBaseAxis(), oe = ee.isHorizontal(), fe = ee.inverse, _e = f6.shape, pe = fe ? oe ? _e.x : _e.y + _e.height : oe ? _e.x + _e.width : _e.y, Ve = (oe ? Z : 0) * (fe ? -1 : 1), Le = (oe ? 0 : -Z) * (fe ? -1 : 1), je = oe ? "x" : "y", Xe = A9t(R, pe, je), Ye = Xe.range, rt2 = Ye[1] - Ye[0], ut = void 0;
            if (rt2 >= 1) {
              if (rt2 > 1 && !z3) {
                var wt = zUe(R, Ye[0]);
                E.attr({ x: wt[0] + Ve, y: wt[1] + Le }), _ && (ut = V.getRawValue(Ye[0]));
              } else {
                var wt = O.getPointOn(pe, je);
                wt && E.attr({ x: wt[0] + Ve, y: wt[1] + Le });
                var dt = V.getRawValue(Ye[0]), Gt = V.getRawValue(Ye[1]);
                _ && (ut = iq(d4, H, dt, Gt, Xe.t));
              }
              y4.lastFrameIndex = Ye[0];
            } else {
              var Qt = n6 === 1 || y4.lastFrameIndex > 0 ? Ye[0] : 0, wt = zUe(R, Qt);
              _ && (ut = V.getRawValue(Qt)), E.attr({ x: wt[0] + Ve, y: wt[1] + Le });
            }
            _ && C7(E).setLabelText(ut);
          }
        }, a.prototype._doUpdateAnimation = function(n6, f6, d4, y4, _, S, T) {
          var E = this._polyline, O = this._polygon, R = n6.hostModel, V = y9t(this._data, n6, this._stackedOnPoints, f6, this._coordSys, d4, this._valueOrigin), z3 = V.current, H = V.stackedOnCurrent, Z = V.next, ee = V.stackedOnNext;
          if (_ && (z3 = a3(V.current, d4, _, T), H = a3(V.stackedOnCurrent, d4, _, T), Z = a3(V.next, d4, _, T), ee = a3(V.stackedOnNext, d4, _, T)), VUe(z3, Z) > 3e3 || O && VUe(H, ee) > 3e3) {
            E.stopAnimation(), E.setShape({ points: Z }), O && (O.stopAnimation(), O.setShape({ points: Z, stackedOnPoints: ee }));
            return;
          }
          E.shape.__points = V.current, E.shape.points = z3;
          var oe = { shape: { points: Z } };
          V.current !== z3 && (oe.shape.__points = V.next), E.stopAnimation(), ku(E, oe, R), O && (O.setShape({ points: z3, stackedOnPoints: H }), O.stopAnimation(), ku(O, { shape: { stackedOnPoints: ee } }, R), E.shape.points !== O.shape.points && (O.shape.points = E.shape.points));
          for (var fe = [], _e = V.status, pe = 0; pe < _e.length; pe++) {
            var Ve = _e[pe].cmd;
            if (Ve === "=") {
              var Le = n6.getItemGraphicEl(_e[pe].idx1);
              Le && fe.push({ el: Le, ptIdx: pe });
            }
          }
          E.animators && E.animators.length && E.animators[0].during(function() {
            O && O.dirtyShape();
            for (var je = E.shape.__points, Xe = 0; Xe < fe.length; Xe++) {
              var Ye = fe[Xe].el, rt2 = fe[Xe].ptIdx * 2;
              Ye.x = je[rt2], Ye.y = je[rt2 + 1], Ye.markRedraw();
            }
          });
        }, a.prototype.remove = function(n6) {
          var f6 = this.group, d4 = this._data;
          this._lineGroup.removeAll(), this._symbolDraw.remove(true), d4 && d4.eachItemGraphicEl(function(y4, _) {
            y4.__temp && (f6.remove(y4), d4.setItemGraphicEl(_, null));
          }), this._polyline = this._polygon = this._coordSys = this._points = this._stackedOnPoints = this._endLabel = this._data = null;
        }, a.type = "line", a;
      }(Ch), D9t = E9t;
      function W$(s, a) {
        return { seriesType: s, plan: R7(), reset: function(n6) {
          var f6 = n6.getData(), d4 = n6.coordinateSystem, y4 = n6.pipelineContext, _ = a || y4.large;
          if (d4) {
            var S = Pi(d4.dimensions, function(z3) {
              return f6.mapDimension(z3);
            }).slice(0, 2), T = S.length, E = f6.getCalculationInfo("stackResultDimension");
            t32(f6, S[0]) && (S[0] = E), t32(f6, S[1]) && (S[1] = E);
            var O = f6.getStore(), R = f6.getDimensionIndex(S[0]), V = f6.getDimensionIndex(S[1]);
            return T && { progress: function(z3, H) {
              for (var Z = z3.end - z3.start, ee = _ && RT(Z * T), oe = [], fe = [], _e = z3.start, pe = 0; _e < z3.end; _e++) {
                var Ve = void 0;
                if (T === 1) {
                  var Le = O.get(R, _e);
                  Ve = d4.dataToPoint(Le, null, fe);
                } else
                  oe[0] = O.get(R, _e), oe[1] = O.get(V, _e), Ve = d4.dataToPoint(oe, null, fe);
                _ ? (ee[pe++] = Ve[0], ee[pe++] = Ve[1]) : H.setItemLayout(_e, Ve.slice());
              }
              _ && H.setLayout("points", ee);
            } };
          }
        } };
      }
      var k9t = { average: function(s) {
        for (var a = 0, n6 = 0, f6 = 0; f6 < s.length; f6++)
          isNaN(s[f6]) || (a += s[f6], n6++);
        return n6 === 0 ? NaN : a / n6;
      }, sum: function(s) {
        for (var a = 0, n6 = 0; n6 < s.length; n6++)
          a += s[n6] || 0;
        return a;
      }, max: function(s) {
        for (var a = -1 / 0, n6 = 0; n6 < s.length; n6++)
          s[n6] > a && (a = s[n6]);
        return isFinite(a) ? a : NaN;
      }, min: function(s) {
        for (var a = 1 / 0, n6 = 0; n6 < s.length; n6++)
          s[n6] < a && (a = s[n6]);
        return isFinite(a) ? a : NaN;
      }, nearest: function(s) {
        return s[0];
      } }, O9t = function(s) {
        return Math.round(s.length / 2);
      };
      function GUe(s) {
        return { seriesType: s, reset: function(a, n6, f6) {
          var d4 = a.getData(), y4 = a.get("sampling"), _ = a.coordinateSystem, S = d4.count();
          if (S > 10 && _.type === "cartesian2d" && y4) {
            var T = _.getBaseAxis(), E = _.getOtherAxis(T), O = T.getExtent(), R = f6.getDevicePixelRatio(), V = Math.abs(O[1] - O[0]) * (R || 1), z3 = Math.round(S / V);
            if (isFinite(z3) && z3 > 1) {
              y4 === "lttb" && a.setData(d4.lttbDownSample(d4.mapDimension(E.dim), 1 / z3));
              var H = void 0;
              Wa(y4) ? H = k9t[y4] : jo(y4) && (H = y4), H && a.setData(d4.downSample(d4.mapDimension(E.dim), 1 / z3, H, O9t));
            }
          }
        } };
      }
      function P9t(s) {
        s.registerChartView(D9t), s.registerSeriesModel(f9t), s.registerLayout(W$("line", true)), s.registerVisual({ seriesType: "line", reset: function(a) {
          var n6 = a.getData(), f6 = a.getModel("lineStyle").getLineStyle();
          f6 && !f6.stroke && (f6.stroke = n6.getVisual("style").fill), n6.setVisual("legendLineStyle", f6);
        } }), s.registerProcessor(s.PRIORITY.PROCESSOR.STATISTIC, GUe("line"));
      }
      var HUe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          return PE(null, this, { useEncodeDefaulter: true });
        }, a.prototype.getMarkerPosition = function(n6) {
          var f6 = this.coordinateSystem;
          if (f6 && f6.clampData) {
            var d4 = f6.dataToPoint(f6.clampData(n6)), y4 = this.getData(), _ = y4.getLayout("offset"), S = y4.getLayout("size"), T = f6.getBaseAxis().isHorizontal() ? 0 : 1;
            return d4[T] += _ + S / 2, d4;
          }
          return [NaN, NaN];
        }, a.type = "series.__base_bar__", a.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, barMinHeight: 0, barMinAngle: 0, large: false, largeThreshold: 400, progressive: 3e3, progressiveChunkMode: "mod" }, a;
      }(Cp);
      Cp.registerClass(HUe);
      var _oe = HUe, L9t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.getInitialData = function() {
          return PE(null, this, { useEncodeDefaulter: true, createInvertedIndices: !!this.get("realtimeSort", true) || null });
        }, a.prototype.getProgressive = function() {
          return this.get("large") ? this.get("progressive") : false;
        }, a.prototype.getProgressiveThreshold = function() {
          var n6 = this.get("progressiveThreshold"), f6 = this.get("largeThreshold");
          return f6 > n6 && (n6 = f6), n6;
        }, a.prototype.brushSelector = function(n6, f6, d4) {
          return d4.rect(f6.getItemLayout(n6));
        }, a.type = "series.bar", a.dependencies = ["grid", "polar"], a.defaultOption = Xk(_oe.defaultOption, { clip: true, roundCap: false, showBackground: false, backgroundStyle: { color: "rgba(180, 180, 180, 0.2)", borderColor: null, borderWidth: 0, borderType: "solid", borderRadius: 0, shadowBlur: 0, shadowColor: null, shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, select: { itemStyle: { borderColor: "#212121" } }, realtimeSort: false }), a;
      }(_oe), R9t = L9t, N9t = function() {
        function s() {
          this.cx = 0, this.cy = 0, this.r0 = 0, this.r = 0, this.startAngle = 0, this.endAngle = Math.PI * 2, this.clockwise = true;
        }
        return s;
      }(), F9t = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "sausage", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new N9t();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.cx, y4 = f6.cy, _ = Math.max(f6.r0 || 0, 0), S = Math.max(f6.r, 0), T = (S - _) * 0.5, E = _ + T, O = f6.startAngle, R = f6.endAngle, V = f6.clockwise, z3 = Math.PI * 2, H = V ? R - O < z3 : O - R < z3;
          H || (O = R - (V ? z3 : -z3));
          var Z = Math.cos(O), ee = Math.sin(O), oe = Math.cos(R), fe = Math.sin(R);
          H ? (n6.moveTo(Z * _ + d4, ee * _ + y4), n6.arc(Z * E + d4, ee * E + y4, T, -Math.PI + O, O, !V)) : n6.moveTo(Z * S + d4, ee * S + y4), n6.arc(d4, y4, S, O, R, !V), n6.arc(oe * E + d4, fe * E + y4, T, R - Math.PI * 2, R - Math.PI, !V), _ !== 0 && n6.arc(d4, y4, _, R, O, V);
        }, a;
      }(ml), xoe = F9t;
      function V9t(s, a) {
        a = a || {};
        var n6 = a.isRoundCap;
        return function(f6, d4, y4) {
          var _ = d4.position;
          if (!_ || _ instanceof Array)
            return lR(f6, d4, y4);
          var S = s(_), T = d4.distance != null ? d4.distance : 5, E = this.shape, O = E.cx, R = E.cy, V = E.r, z3 = E.r0, H = (V + z3) / 2, Z = E.startAngle, ee = E.endAngle, oe = (Z + ee) / 2, fe = n6 ? Math.abs(V - z3) / 2 : 0, _e = Math.cos, pe = Math.sin, Ve = O + V * _e(Z), Le = R + V * pe(Z), je = "left", Xe = "top";
          switch (S) {
            case "startArc":
              Ve = O + (z3 - T) * _e(oe), Le = R + (z3 - T) * pe(oe), je = "center", Xe = "top";
              break;
            case "insideStartArc":
              Ve = O + (z3 + T) * _e(oe), Le = R + (z3 + T) * pe(oe), je = "center", Xe = "bottom";
              break;
            case "startAngle":
              Ve = O + H * _e(Z) + woe(Z, T + fe, false), Le = R + H * pe(Z) + Soe(Z, T + fe, false), je = "right", Xe = "middle";
              break;
            case "insideStartAngle":
              Ve = O + H * _e(Z) + woe(Z, -T + fe, false), Le = R + H * pe(Z) + Soe(Z, -T + fe, false), je = "left", Xe = "middle";
              break;
            case "middle":
              Ve = O + H * _e(oe), Le = R + H * pe(oe), je = "center", Xe = "middle";
              break;
            case "endArc":
              Ve = O + (V + T) * _e(oe), Le = R + (V + T) * pe(oe), je = "center", Xe = "bottom";
              break;
            case "insideEndArc":
              Ve = O + (V - T) * _e(oe), Le = R + (V - T) * pe(oe), je = "center", Xe = "top";
              break;
            case "endAngle":
              Ve = O + H * _e(ee) + woe(ee, T + fe, true), Le = R + H * pe(ee) + Soe(ee, T + fe, true), je = "left", Xe = "middle";
              break;
            case "insideEndAngle":
              Ve = O + H * _e(ee) + woe(ee, -T + fe, true), Le = R + H * pe(ee) + Soe(ee, -T + fe, true), je = "right", Xe = "middle";
              break;
            default:
              return lR(f6, d4, y4);
          }
          return f6 = f6 || {}, f6.x = Ve, f6.y = Le, f6.align = je, f6.verticalAlign = Xe, f6;
        };
      }
      function B9t(s, a, n6, f6) {
        if (ac(f6)) {
          s.setTextConfig({ rotation: f6 });
          return;
        } else if (Di(a)) {
          s.setTextConfig({ rotation: 0 });
          return;
        }
        var d4 = s.shape, y4 = d4.clockwise ? d4.startAngle : d4.endAngle, _ = d4.clockwise ? d4.endAngle : d4.startAngle, S = (y4 + _) / 2, T, E = n6(a);
        switch (E) {
          case "startArc":
          case "insideStartArc":
          case "middle":
          case "insideEndArc":
          case "endArc":
            T = S;
            break;
          case "startAngle":
          case "insideStartAngle":
            T = y4;
            break;
          case "endAngle":
          case "insideEndAngle":
            T = _;
            break;
          default:
            s.setTextConfig({ rotation: 0 });
            return;
        }
        var O = Math.PI * 1.5 - T;
        E === "middle" && O > Math.PI / 2 && O < Math.PI * 1.5 && (O -= Math.PI), s.setTextConfig({ rotation: O });
      }
      function woe(s, a, n6) {
        return a * Math.sin(s) * (n6 ? -1 : 1);
      }
      function Soe(s, a, n6) {
        return a * Math.cos(s) * (n6 ? 1 : -1);
      }
      var iSe = Math.max, aSe = Math.min;
      function z9t(s, a) {
        var n6 = s.getArea && s.getArea();
        if (RE(s, "cartesian2d")) {
          var f6 = s.getBaseAxis();
          if (f6.type !== "category" || !f6.onBand) {
            var d4 = a.getLayout("bandWidth");
            f6.isHorizontal() ? (n6.x -= d4, n6.width += d4 * 2) : (n6.y -= d4, n6.height += d4 * 2);
          }
        }
        return n6;
      }
      var j9t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s.call(this) || this;
          return n6.type = a.type, n6._isFirstFrame = true, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          this._model = n6, this._removeOnRenderedListener(d4), this._updateDrawMode(n6);
          var _ = n6.get("coordinateSystem");
          (_ === "cartesian2d" || _ === "polar") && (this._progressiveEls = null, this._isLargeDraw ? this._renderLarge(n6, f6, d4) : this._renderNormal(n6, f6, d4, y4));
        }, a.prototype.incrementalPrepareRender = function(n6) {
          this._clear(), this._updateDrawMode(n6), this._updateLargeClip(n6);
        }, a.prototype.incrementalRender = function(n6, f6) {
          this._progressiveEls = [], this._incrementalRenderLarge(n6, f6);
        }, a.prototype.eachRendered = function(n6) {
          mC(this._progressiveEls || this.group, n6);
        }, a.prototype._updateDrawMode = function(n6) {
          var f6 = n6.pipelineContext.large;
          (this._isLargeDraw == null || f6 !== this._isLargeDraw) && (this._isLargeDraw = f6, this._clear());
        }, a.prototype._renderNormal = function(n6, f6, d4, y4) {
          var _ = this.group, S = n6.getData(), T = this._data, E = n6.coordinateSystem, O = E.getBaseAxis(), R;
          E.type === "cartesian2d" ? R = O.isHorizontal() : E.type === "polar" && (R = O.dim === "angle");
          var V = n6.isAnimationEnabled() ? n6 : null, z3 = G9t(n6, E);
          z3 && this._enableRealtimeSort(z3, S, d4);
          var H = n6.get("clip", true) || z3, Z = z9t(E, S);
          _.removeClipPath();
          var ee = n6.get("roundCap", true), oe = n6.get("showBackground", true), fe = n6.getModel("backgroundStyle"), _e = fe.get("borderRadius") || 0, pe = [], Ve = this._backgroundEls, Le = y4 && y4.isInitSort, je = y4 && y4.type === "changeAxisOrder";
          function Xe(ut) {
            var wt = Coe[E.type](S, ut), dt = Y9t(E, R, wt);
            return dt.useStyle(fe.getItemStyle()), E.type === "cartesian2d" && dt.setShape("r", _e), pe[ut] = dt, dt;
          }
          S.diff(T).add(function(ut) {
            var wt = S.getItemModel(ut), dt = Coe[E.type](S, ut, wt);
            if (oe && Xe(ut), !(!S.hasValue(ut) || !XUe[E.type](dt))) {
              var Gt = false;
              H && (Gt = WUe[E.type](Z, dt));
              var Qt = UUe[E.type](n6, S, ut, dt, R, V, O.model, false, ee);
              z3 && (Qt.forceLabelAnimation = true), KUe(Qt, S, ut, wt, dt, n6, R, E.type === "polar"), Le ? Qt.attr({ shape: dt }) : z3 ? qUe(z3, V, Qt, dt, ut, R, false, false) : $h(Qt, { shape: dt }, n6, ut), S.setItemGraphicEl(ut, Qt), _.add(Qt), Qt.ignore = Gt;
            }
          }).update(function(ut, wt) {
            var dt = S.getItemModel(ut), Gt = Coe[E.type](S, ut, dt);
            if (oe) {
              var Qt = void 0;
              Ve.length === 0 ? Qt = Xe(wt) : (Qt = Ve[wt], Qt.useStyle(fe.getItemStyle()), E.type === "cartesian2d" && Qt.setShape("r", _e), pe[ut] = Qt);
              var Nt = Coe[E.type](S, ut), er = eqe(R, Nt, E);
              ku(Qt, { shape: er }, V, ut);
            }
            var un = T.getItemGraphicEl(wt);
            if (!S.hasValue(ut) || !XUe[E.type](Gt)) {
              _.remove(un);
              return;
            }
            var pn = false;
            if (H && (pn = WUe[E.type](Z, Gt), pn && _.remove(un)), un ? ox(un) : un = UUe[E.type](n6, S, ut, Gt, R, V, O.model, !!un, ee), z3 && (un.forceLabelAnimation = true), je) {
              var On = un.getTextContent();
              if (On) {
                var fr = C7(On);
                fr.prevValue != null && (fr.prevValue = fr.value);
              }
            } else
              KUe(un, S, ut, dt, Gt, n6, R, E.type === "polar");
            Le ? un.attr({ shape: Gt }) : z3 ? qUe(z3, V, un, Gt, ut, R, true, je) : ku(un, { shape: Gt }, n6, ut, null), S.setItemGraphicEl(ut, un), un.ignore = pn, _.add(un);
          }).remove(function(ut) {
            var wt = T.getItemGraphicEl(ut);
            wt && kR(wt, n6, ut);
          }).execute();
          var Ye = this._backgroundGroup || (this._backgroundGroup = new fs());
          Ye.removeAll();
          for (var rt2 = 0; rt2 < pe.length; ++rt2)
            Ye.add(pe[rt2]);
          _.add(Ye), this._backgroundEls = pe, this._data = S;
        }, a.prototype._renderLarge = function(n6, f6, d4) {
          this._clear(), JUe(n6, this.group), this._updateLargeClip(n6);
        }, a.prototype._incrementalRenderLarge = function(n6, f6) {
          this._removeBackground(), JUe(f6, this.group, this._progressiveEls, true);
        }, a.prototype._updateLargeClip = function(n6) {
          var f6 = n6.get("clip", true) && boe(n6.coordinateSystem, false, n6), d4 = this.group;
          f6 ? d4.setClipPath(f6) : d4.removeClipPath();
        }, a.prototype._enableRealtimeSort = function(n6, f6, d4) {
          var y4 = this;
          if (f6.count()) {
            var _ = n6.baseAxis;
            if (this._isFirstFrame)
              this._dispatchInitSort(f6, n6, d4), this._isFirstFrame = false;
            else {
              var S = function(T) {
                var E = f6.getItemGraphicEl(T), O = E && E.shape;
                return O && Math.abs(_.isHorizontal() ? O.height : O.width) || 0;
              };
              this._onRendered = function() {
                y4._updateSortWithinSameData(f6, S, _, d4);
              }, d4.getZr().on("rendered", this._onRendered);
            }
          }
        }, a.prototype._dataSort = function(n6, f6, d4) {
          var y4 = [];
          return n6.each(n6.mapDimension(f6.dim), function(_, S) {
            var T = d4(S);
            T = T == null ? NaN : T, y4.push({ dataIndex: S, mappedValue: T, ordinalNumber: _ });
          }), y4.sort(function(_, S) {
            return S.mappedValue - _.mappedValue;
          }), { ordinalNumbers: Pi(y4, function(_) {
            return _.ordinalNumber;
          }) };
        }, a.prototype._isOrderChangedWithinSameData = function(n6, f6, d4) {
          for (var y4 = d4.scale, _ = n6.mapDimension(d4.dim), S = Number.MAX_VALUE, T = 0, E = y4.getOrdinalMeta().categories.length; T < E; ++T) {
            var O = n6.rawIndexOf(_, y4.getRawOrdinalNumber(T)), R = O < 0 ? Number.MIN_VALUE : f6(n6.indexOfRawIndex(O));
            if (R > S)
              return true;
            S = R;
          }
          return false;
        }, a.prototype._isOrderDifferentInView = function(n6, f6) {
          for (var d4 = f6.scale, y4 = d4.getExtent(), _ = Math.max(0, y4[0]), S = Math.min(y4[1], d4.getOrdinalMeta().categories.length - 1); _ <= S; ++_)
            if (n6.ordinalNumbers[_] !== d4.getRawOrdinalNumber(_))
              return true;
        }, a.prototype._updateSortWithinSameData = function(n6, f6, d4, y4) {
          if (this._isOrderChangedWithinSameData(n6, f6, d4)) {
            var _ = this._dataSort(n6, d4, f6);
            this._isOrderDifferentInView(_, d4) && (this._removeOnRenderedListener(y4), y4.dispatchAction({ type: "changeAxisOrder", componentType: d4.dim + "Axis", axisId: d4.index, sortInfo: _ }));
          }
        }, a.prototype._dispatchInitSort = function(n6, f6, d4) {
          var y4 = f6.baseAxis, _ = this._dataSort(n6, y4, function(S) {
            return n6.get(n6.mapDimension(f6.otherAxis.dim), S);
          });
          d4.dispatchAction({ type: "changeAxisOrder", componentType: y4.dim + "Axis", isInitSort: true, axisId: y4.index, sortInfo: _ });
        }, a.prototype.remove = function(n6, f6) {
          this._clear(this._model), this._removeOnRenderedListener(f6);
        }, a.prototype.dispose = function(n6, f6) {
          this._removeOnRenderedListener(f6);
        }, a.prototype._removeOnRenderedListener = function(n6) {
          this._onRendered && (n6.getZr().off("rendered", this._onRendered), this._onRendered = null);
        }, a.prototype._clear = function(n6) {
          var f6 = this.group, d4 = this._data;
          n6 && n6.isAnimationEnabled() && d4 && !this._isLargeDraw ? (this._removeBackground(), this._backgroundEls = [], d4.eachItemGraphicEl(function(y4) {
            kR(y4, n6, qo(y4).dataIndex);
          })) : f6.removeAll(), this._data = null, this._isFirstFrame = true;
        }, a.prototype._removeBackground = function() {
          this.group.remove(this._backgroundGroup), this._backgroundGroup = null;
        }, a.type = "bar", a;
      }(Ch), WUe = { cartesian2d: function(s, a) {
        var n6 = a.width < 0 ? -1 : 1, f6 = a.height < 0 ? -1 : 1;
        n6 < 0 && (a.x += a.width, a.width = -a.width), f6 < 0 && (a.y += a.height, a.height = -a.height);
        var d4 = s.x + s.width, y4 = s.y + s.height, _ = iSe(a.x, s.x), S = aSe(a.x + a.width, d4), T = iSe(a.y, s.y), E = aSe(a.y + a.height, y4), O = S < _, R = E < T;
        return a.x = O && _ > d4 ? S : _, a.y = R && T > y4 ? E : T, a.width = O ? 0 : S - _, a.height = R ? 0 : E - T, n6 < 0 && (a.x += a.width, a.width = -a.width), f6 < 0 && (a.y += a.height, a.height = -a.height), O || R;
      }, polar: function(s, a) {
        var n6 = a.r0 <= a.r ? 1 : -1;
        if (n6 < 0) {
          var f6 = a.r;
          a.r = a.r0, a.r0 = f6;
        }
        var d4 = aSe(a.r, s.r), y4 = iSe(a.r0, s.r0);
        a.r = d4, a.r0 = y4;
        var _ = d4 - y4 < 0;
        if (n6 < 0) {
          var f6 = a.r;
          a.r = a.r0, a.r0 = f6;
        }
        return _;
      } }, UUe = { cartesian2d: function(s, a, n6, f6, d4, y4, _, S, T) {
        var E = new xu({ shape: ei({}, f6), z2: 1 });
        if (E.__dataIndex = n6, E.name = "item", y4) {
          var O = E.shape, R = d4 ? "height" : "width";
          O[R] = 0;
        }
        return E;
      }, polar: function(s, a, n6, f6, d4, y4, _, S, T) {
        var E = !d4 && T ? xoe : Bm, O = new E({ shape: f6, z2: 1 });
        O.name = "item";
        var R = YUe(d4);
        if (O.calculateTextPosition = V9t(R, { isRoundCap: E === xoe }), y4) {
          var V = O.shape, z3 = d4 ? "r" : "endAngle", H = {};
          V[z3] = d4 ? 0 : f6.startAngle, H[z3] = f6[z3], (S ? ku : $h)(O, { shape: H }, y4);
        }
        return O;
      } };
      function G9t(s, a) {
        var n6 = s.get("realtimeSort", true), f6 = a.getBaseAxis();
        if (n6 && f6.type === "category" && a.type === "cartesian2d")
          return { baseAxis: f6, otherAxis: a.getOtherAxis(f6) };
      }
      function qUe(s, a, n6, f6, d4, y4, _, S) {
        var T, E;
        y4 ? (E = { x: f6.x, width: f6.width }, T = { y: f6.y, height: f6.height }) : (E = { y: f6.y, height: f6.height }, T = { x: f6.x, width: f6.width }), S || (_ ? ku : $h)(n6, { shape: T }, a, d4, null);
        var O = a ? s.baseAxis.model : null;
        (_ ? ku : $h)(n6, { shape: E }, O, d4);
      }
      function $Ue(s, a) {
        for (var n6 = 0; n6 < a.length; n6++)
          if (!isFinite(s[a[n6]]))
            return true;
        return false;
      }
      var H9t = ["x", "y", "width", "height"], W9t = ["cx", "cy", "r", "startAngle", "endAngle"], XUe = { cartesian2d: function(s) {
        return !$Ue(s, H9t);
      }, polar: function(s) {
        return !$Ue(s, W9t);
      } }, Coe = { cartesian2d: function(s, a, n6) {
        var f6 = s.getItemLayout(a), d4 = n6 ? q9t(n6, f6) : 0, y4 = f6.width > 0 ? 1 : -1, _ = f6.height > 0 ? 1 : -1;
        return { x: f6.x + y4 * d4 / 2, y: f6.y + _ * d4 / 2, width: f6.width - y4 * d4, height: f6.height - _ * d4 };
      }, polar: function(s, a, n6) {
        var f6 = s.getItemLayout(a);
        return { cx: f6.cx, cy: f6.cy, r0: f6.r0, r: f6.r, startAngle: f6.startAngle, endAngle: f6.endAngle, clockwise: f6.clockwise };
      } };
      function U9t(s) {
        return s.startAngle != null && s.endAngle != null && s.startAngle === s.endAngle;
      }
      function YUe(s) {
        return function(a) {
          var n6 = a ? "Arc" : "Angle";
          return function(f6) {
            switch (f6) {
              case "start":
              case "insideStart":
              case "end":
              case "insideEnd":
                return f6 + n6;
              default:
                return f6;
            }
          };
        }(s);
      }
      function KUe(s, a, n6, f6, d4, y4, _, S) {
        var T = a.getItemVisual(n6, "style");
        S || s.setShape("r", f6.get(["itemStyle", "borderRadius"]) || 0), s.useStyle(T);
        var E = f6.getShallow("cursor");
        E && s.attr("cursor", E);
        var O = S ? _ ? d4.r >= d4.r0 ? "endArc" : "startArc" : d4.endAngle >= d4.startAngle ? "endAngle" : "startAngle" : _ ? d4.height >= 0 ? "bottom" : "top" : d4.width >= 0 ? "right" : "left", R = E0(f6);
        Gm(s, R, { labelFetcher: y4, labelDataIndex: n6, defaultText: U7(y4.getData(), n6), inheritColor: T.fill, defaultOpacity: T.opacity, defaultOutsidePosition: O });
        var V = s.getTextContent();
        if (S && V) {
          var z3 = f6.get(["label", "position"]);
          s.textConfig.inside = z3 === "middle" ? true : null, B9t(s, z3 === "outside" ? O : z3, YUe(_), f6.get(["label", "rotate"]));
        }
        gje(V, R, y4.getRawValue(n6), function(Z) {
          return AUe(a, Z);
        });
        var H = f6.getModel(["emphasis"]);
        Up(s, H.get("focus"), H.get("blurScope"), H.get("disabled")), Pg(s, f6), U9t(d4) && (s.style.fill = "none", s.style.stroke = "none", gt(s.states, function(Z) {
          Z.style && (Z.style.fill = Z.style.stroke = "none");
        }));
      }
      function q9t(s, a) {
        var n6 = s.get(["itemStyle", "borderColor"]);
        if (!n6 || n6 === "none")
          return 0;
        var f6 = s.get(["itemStyle", "borderWidth"]) || 0, d4 = isNaN(a.width) ? Number.MAX_VALUE : Math.abs(a.width), y4 = isNaN(a.height) ? Number.MAX_VALUE : Math.abs(a.height);
        return Math.min(f6, d4, y4);
      }
      var $9t = function() {
        function s() {
        }
        return s;
      }(), ZUe = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "largeBar", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new $9t();
        }, a.prototype.buildPath = function(n6, f6) {
          for (var d4 = f6.points, y4 = this.baseDimIdx, _ = 1 - this.baseDimIdx, S = [], T = [], E = this.barWidth, O = 0; O < d4.length; O += 3)
            T[y4] = E, T[_] = d4[O + 2], S[y4] = d4[O + y4], S[_] = d4[O + _], n6.rect(S[0], S[1], T[0], T[1]);
        }, a;
      }(ml);
      function JUe(s, a, n6, f6) {
        var d4 = s.getData(), y4 = d4.getLayout("valueAxisHorizontal") ? 1 : 0, _ = d4.getLayout("largeDataIndices"), S = d4.getLayout("size"), T = s.getModel("backgroundStyle"), E = d4.getLayout("largeBackgroundPoints");
        if (E) {
          var O = new ZUe({ shape: { points: E }, incremental: !!f6, silent: true, z2: 0 });
          O.baseDimIdx = y4, O.largeDataIndices = _, O.barWidth = S, O.useStyle(T.getItemStyle()), a.add(O), n6 && n6.push(O);
        }
        var R = new ZUe({ shape: { points: d4.getLayout("largePoints") }, incremental: !!f6, z2: 1 });
        R.baseDimIdx = y4, R.largeDataIndices = _, R.barWidth = S, a.add(R), R.useStyle(d4.getVisual("style")), qo(R).seriesIndex = s.seriesIndex, s.get("silent") || (R.on("mousedown", QUe), R.on("mousemove", QUe)), n6 && n6.push(R);
      }
      var QUe = rwe(function(s) {
        var a = this, n6 = X9t(a, s.offsetX, s.offsetY);
        qo(a).dataIndex = n6 >= 0 ? n6 : null;
      }, 30, false);
      function X9t(s, a, n6) {
        for (var f6 = s.baseDimIdx, d4 = 1 - f6, y4 = s.shape.points, _ = s.largeDataIndices, S = [], T = [], E = s.barWidth, O = 0, R = y4.length / 3; O < R; O++) {
          var V = O * 3;
          if (T[f6] = E, T[d4] = y4[V + 2], S[f6] = y4[V + f6], S[d4] = y4[V + d4], T[d4] < 0 && (S[d4] += T[d4], T[d4] = -T[d4]), a >= S[0] && a <= S[0] + T[0] && n6 >= S[1] && n6 <= S[1] + T[1])
            return _[O];
        }
        return -1;
      }
      function eqe(s, a, n6) {
        if (RE(n6, "cartesian2d")) {
          var f6 = a, d4 = n6.getArea();
          return { x: s ? f6.x : d4.x, y: s ? d4.y : f6.y, width: s ? f6.width : d4.width, height: s ? d4.height : f6.height };
        } else {
          var d4 = n6.getArea(), y4 = a;
          return { cx: d4.cx, cy: d4.cy, r0: s ? d4.r0 : y4.r0, r: s ? d4.r : y4.r, startAngle: s ? y4.startAngle : 0, endAngle: s ? y4.endAngle : Math.PI * 2 };
        }
      }
      function Y9t(s, a, n6) {
        var f6 = s.type === "polar" ? Bm : xu;
        return new f6({ shape: eqe(a, n6, s), silent: true, z2: 0 });
      }
      var K9t = j9t;
      function Z9t(s) {
        s.registerChartView(K9t), s.registerSeriesModel(R9t), s.registerLayout(s.PRIORITY.VISUAL.LAYOUT, ks(bWe, "bar")), s.registerLayout(s.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, _We("bar")), s.registerProcessor(s.PRIORITY.PROCESSOR.STATISTIC, GUe("bar")), s.registerAction({ type: "changeAxisOrder", event: "changeAxisOrder", update: "update" }, function(a, n6) {
          var f6 = a.componentType || "series";
          n6.eachComponent({ mainType: f6, query: a }, function(d4) {
            a.sortInfo && d4.axis.setCategorySortInfo(a.sortInfo);
          });
        });
      }
      var Moe = Math.PI * 2, tqe = Math.PI / 180;
      function nqe(s, a) {
        return Qv(s.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
      }
      function rqe(s, a) {
        var n6 = nqe(s, a), f6 = s.get("center"), d4 = s.get("radius");
        Di(d4) || (d4 = [0, d4]), Di(f6) || (f6 = [f6, f6]);
        var y4 = Ia(n6.width, a.getWidth()), _ = Ia(n6.height, a.getHeight()), S = Math.min(y4, _), T = Ia(f6[0], y4) + n6.x, E = Ia(f6[1], _) + n6.y, O = Ia(d4[0], S / 2), R = Ia(d4[1], S / 2);
        return { cx: T, cy: E, r0: O, r: R };
      }
      function J9t(s, a, n6) {
        a.eachSeriesByType(s, function(f6) {
          var d4 = f6.getData(), y4 = d4.mapDimension("value"), _ = nqe(f6, n6), S = rqe(f6, n6), T = S.cx, E = S.cy, O = S.r, R = S.r0, V = -f6.get("startAngle") * tqe, z3 = f6.get("minAngle") * tqe, H = 0;
          d4.each(y4, function(rt2) {
            !isNaN(rt2) && H++;
          });
          var Z = d4.getSum(y4), ee = Math.PI / (Z || H) * 2, oe = f6.get("clockwise"), fe = f6.get("roseType"), _e = f6.get("stillShowZeroSum"), pe = d4.getDataExtent(y4);
          pe[0] = 0;
          var Ve = Moe, Le = 0, je = V, Xe = oe ? 1 : -1;
          if (d4.setLayout({ viewRect: _, r: O }), d4.each(y4, function(rt2, ut) {
            var wt;
            if (isNaN(rt2)) {
              d4.setItemLayout(ut, { angle: NaN, startAngle: NaN, endAngle: NaN, clockwise: oe, cx: T, cy: E, r0: R, r: fe ? NaN : O });
              return;
            }
            fe !== "area" ? wt = Z === 0 && _e ? ee : rt2 * ee : wt = Moe / H, wt < z3 ? (wt = z3, Ve -= z3) : Le += rt2;
            var dt = je + Xe * wt;
            d4.setItemLayout(ut, { angle: wt, startAngle: je, endAngle: dt, clockwise: oe, cx: T, cy: E, r0: R, r: fe ? zu(rt2, pe, [R, O]) : O }), je = dt;
          }), Ve < Moe && H)
            if (Ve <= 1e-3) {
              var Ye = Moe / H;
              d4.each(y4, function(rt2, ut) {
                if (!isNaN(rt2)) {
                  var wt = d4.getItemLayout(ut);
                  wt.angle = Ye, wt.startAngle = V + Xe * ut * Ye, wt.endAngle = V + Xe * (ut + 1) * Ye;
                }
              });
            } else
              ee = Ve / Le, je = V, d4.each(y4, function(rt2, ut) {
                if (!isNaN(rt2)) {
                  var wt = d4.getItemLayout(ut), dt = wt.angle === z3 ? z3 : rt2 * ee;
                  wt.startAngle = je, wt.endAngle = je + Xe * dt, je += Xe * dt;
                }
              });
        });
      }
      function U$(s) {
        return { seriesType: s, reset: function(a, n6) {
          var f6 = n6.findComponents({ mainType: "legend" });
          if (!(!f6 || !f6.length)) {
            var d4 = a.getData();
            d4.filterSelf(function(y4) {
              for (var _ = d4.getName(y4), S = 0; S < f6.length; S++)
                if (!f6[S].isSelected(_))
                  return false;
              return true;
            });
          }
        } };
      }
      var Q9t = Math.PI / 180;
      function iqe(s, a, n6, f6, d4, y4, _, S, T, E) {
        if (s.length < 2)
          return;
        function O(Z) {
          for (var ee = Z.rB, oe = ee * ee, fe = 0; fe < Z.list.length; fe++) {
            var _e = Z.list[fe], pe = Math.abs(_e.label.y - n6), Ve = f6 + _e.len, Le = Ve * Ve, je = Math.sqrt((1 - Math.abs(pe * pe / oe)) * Le), Xe = a + (je + _e.len2) * d4, Ye = Xe - _e.label.x, rt2 = _e.targetTextWidth - Ye * d4;
            aqe(_e, rt2, true), _e.label.x = Xe;
          }
        }
        function R(Z) {
          for (var ee = { list: [], maxY: 0 }, oe = { list: [], maxY: 0 }, fe = 0; fe < Z.length; fe++)
            if (Z[fe].labelAlignTo === "none") {
              var _e = Z[fe], pe = _e.label.y > n6 ? oe : ee, Ve = Math.abs(_e.label.y - n6);
              if (Ve >= pe.maxY) {
                var Le = _e.label.x - a - _e.len2 * d4, je = f6 + _e.len, Xe = Math.abs(Le) < je ? Math.sqrt(Ve * Ve / (1 - Le * Le / je / je)) : je;
                pe.rB = Xe, pe.maxY = Ve;
              }
              pe.list.push(_e);
            }
          O(ee), O(oe);
        }
        for (var V = s.length, z3 = 0; z3 < V; z3++)
          if (s[z3].position === "outer" && s[z3].labelAlignTo === "labelLine") {
            var H = s[z3].label.x - E;
            s[z3].linePoints[1][0] += H, s[z3].label.x = E;
          }
        JWe(s, T, T + _) && R(s);
      }
      function e7t(s, a, n6, f6, d4, y4, _, S) {
        for (var T = [], E = [], O = Number.MAX_VALUE, R = -Number.MAX_VALUE, V = 0; V < s.length; V++) {
          var z3 = s[V].label;
          oSe(s[V]) || (z3.x < a ? (O = Math.min(O, z3.x), T.push(s[V])) : (R = Math.max(R, z3.x), E.push(s[V])));
        }
        for (var V = 0; V < s.length; V++) {
          var H = s[V];
          if (!oSe(H) && H.linePoints) {
            if (H.labelStyleWidth != null)
              continue;
            var z3 = H.label, Z = H.linePoints, ee = void 0;
            H.labelAlignTo === "edge" ? z3.x < a ? ee = Z[2][0] - H.labelDistance - _ - H.edgeDistance : ee = _ + d4 - H.edgeDistance - Z[2][0] - H.labelDistance : H.labelAlignTo === "labelLine" ? z3.x < a ? ee = O - _ - H.bleedMargin : ee = _ + d4 - R - H.bleedMargin : z3.x < a ? ee = z3.x - _ - H.bleedMargin : ee = _ + d4 - z3.x - H.bleedMargin, H.targetTextWidth = ee, aqe(H, ee);
          }
        }
        iqe(E, a, n6, f6, 1, d4, y4, _, S, R), iqe(T, a, n6, f6, -1, d4, y4, _, S, O);
        for (var V = 0; V < s.length; V++) {
          var H = s[V];
          if (!oSe(H) && H.linePoints) {
            var z3 = H.label, Z = H.linePoints, oe = H.labelAlignTo === "edge", fe = z3.style.padding, _e = fe ? fe[1] + fe[3] : 0, pe = z3.style.backgroundColor ? 0 : _e, Ve = H.rect.width + pe, Le = Z[1][0] - Z[2][0];
            oe ? z3.x < a ? Z[2][0] = _ + H.edgeDistance + Ve + H.labelDistance : Z[2][0] = _ + d4 - H.edgeDistance - Ve - H.labelDistance : (z3.x < a ? Z[2][0] = z3.x + H.labelDistance : Z[2][0] = z3.x - H.labelDistance, Z[1][0] = Z[2][0] + Le), Z[1][1] = Z[2][1] = z3.y;
          }
        }
      }
      function aqe(s, a, n6) {
        if (n6 === void 0 && (n6 = false), s.labelStyleWidth == null) {
          var f6 = s.label, d4 = f6.style, y4 = s.rect, _ = d4.backgroundColor, S = d4.padding, T = S ? S[1] + S[3] : 0, E = d4.overflow, O = y4.width + (_ ? 0 : T);
          if (a < O || n6) {
            var R = y4.height;
            if (E && E.match("break")) {
              f6.setStyle("backgroundColor", null), f6.setStyle("width", a - T);
              var V = f6.getBoundingRect();
              f6.setStyle("width", Math.ceil(V.width)), f6.setStyle("backgroundColor", _);
            } else {
              var z3 = a - T, H = a < O ? z3 : n6 ? z3 > s.unconstrainedWidth ? null : z3 : null;
              f6.setStyle("width", H);
            }
            var Z = f6.getBoundingRect();
            y4.width = Z.width;
            var ee = (f6.style.margin || 0) + 2.1;
            y4.height = Z.height + ee, y4.y -= (y4.height - R) / 2;
          }
        }
      }
      function oSe(s) {
        return s.position === "center";
      }
      function t7t(s) {
        var a = s.getData(), n6 = [], f6, d4, y4 = false, _ = (s.get("minShowLabelAngle") || 0) * Q9t, S = a.getLayout("viewRect"), T = a.getLayout("r"), E = S.width, O = S.x, R = S.y, V = S.height;
        function z3(Le) {
          Le.ignore = true;
        }
        function H(Le) {
          if (!Le.ignore)
            return true;
          for (var je in Le.states)
            if (Le.states[je].ignore === false)
              return true;
          return false;
        }
        a.each(function(Le) {
          var je = a.getItemGraphicEl(Le), Xe = je.shape, Ye = je.getTextContent(), rt2 = je.getTextGuideLine(), ut = a.getItemModel(Le), wt = ut.getModel("label"), dt = wt.get("position") || ut.get(["emphasis", "label", "position"]), Gt = wt.get("distanceToLabelLine"), Qt = wt.get("alignTo"), Nt = Ia(wt.get("edgeDistance"), E), er = wt.get("bleedMargin"), un = ut.getModel("labelLine"), pn = un.get("length");
          pn = Ia(pn, E);
          var On = un.get("length2");
          if (On = Ia(On, E), Math.abs(Xe.endAngle - Xe.startAngle) < _) {
            gt(Ye.states, z3), Ye.ignore = true;
            return;
          }
          if (H(Ye)) {
            var fr = (Xe.startAngle + Xe.endAngle) / 2, yr = Math.cos(fr), da = Math.sin(fr), Ja, ko, wo, So;
            f6 = Xe.cx, d4 = Xe.cy;
            var Fa = dt === "inside" || dt === "inner";
            if (dt === "center")
              Ja = Xe.cx, ko = Xe.cy, So = "center";
            else {
              var po = (Fa ? (Xe.r + Xe.r0) / 2 * yr : Xe.r * yr) + f6, To = (Fa ? (Xe.r + Xe.r0) / 2 * da : Xe.r * da) + d4;
              if (Ja = po + yr * 3, ko = To + da * 3, !Fa) {
                var Ya = po + yr * (pn + T - Xe.r), $o = To + da * (pn + T - Xe.r), Hu = Ya + (yr < 0 ? -1 : 1) * On, ms = $o;
                Qt === "edge" ? Ja = yr < 0 ? O + Nt : O + E - Nt : Ja = Hu + (yr < 0 ? -Gt : Gt), ko = ms, wo = [[po, To], [Ya, $o], [Hu, ms]];
              }
              So = Fa ? "center" : Qt === "edge" ? yr > 0 ? "right" : "left" : yr > 0 ? "left" : "right";
            }
            var sc = Math.PI, Oc = 0, _c2 = wt.get("rotate");
            if (ac(_c2))
              Oc = _c2 * (sc / 180);
            else if (dt === "center")
              Oc = 0;
            else if (_c2 === "radial" || _c2 === true) {
              var _v = yr < 0 ? -fr + sc : -fr;
              Oc = _v;
            } else if (_c2 === "tangential" && dt !== "outside" && dt !== "outer") {
              var cp = Math.atan2(yr, da);
              cp < 0 && (cp = sc * 2 + cp);
              var Vg = da > 0;
              Vg && (cp = sc + cp), Oc = cp - sc;
            }
            if (y4 = !!Oc, Ye.x = Ja, Ye.y = ko, Ye.rotation = Oc, Ye.setStyle({ verticalAlign: "middle" }), Fa) {
              Ye.setStyle({ align: So });
              var rh = Ye.states.select;
              rh && (rh.x += Ye.x, rh.y += Ye.y);
            } else {
              var Mp = Ye.getBoundingRect().clone();
              Mp.applyTransform(Ye.getComputedTransform());
              var fp = (Ye.style.margin || 0) + 2.1;
              Mp.y -= fp / 2, Mp.height += fp, n6.push({ label: Ye, labelLine: rt2, position: dt, len: pn, len2: On, minTurnAngle: un.get("minTurnAngle"), maxSurfaceAngle: un.get("maxSurfaceAngle"), surfaceNormal: new zs(yr, da), linePoints: wo, textAlign: So, labelDistance: Gt, labelAlignTo: Qt, edgeDistance: Nt, bleedMargin: er, rect: Mp, unconstrainedWidth: Mp.width, labelStyleWidth: Ye.style.width });
            }
            je.setTextConfig({ inside: Fa });
          }
        }), !y4 && s.get("avoidLabelOverlap") && e7t(n6, f6, d4, T, E, V, O, R);
        for (var Z = 0; Z < n6.length; Z++) {
          var ee = n6[Z], oe = ee.label, fe = ee.labelLine, _e = isNaN(oe.x) || isNaN(oe.y);
          if (oe) {
            oe.setStyle({ align: ee.textAlign }), _e && (gt(oe.states, z3), oe.ignore = true);
            var pe = oe.states.select;
            pe && (pe.x += oe.x, pe.y += oe.y);
          }
          if (fe) {
            var Ve = ee.linePoints;
            _e || !Ve ? (gt(fe.states, z3), fe.ignore = true) : (XWe(Ve, ee.minTurnAngle), p8t(Ve, ee.surfaceNormal, ee.maxSurfaceAngle), fe.setShape({ points: Ve }), oe.__hostTarget.textGuideLineConfig = { anchor: new zs(Ve[0][0], Ve[0][1]) });
          }
        }
      }
      function q7(s, a, n6) {
        var f6 = s.get("borderRadius");
        if (f6 == null)
          return n6 ? { cornerRadius: 0 } : null;
        Di(f6) || (f6 = [f6, f6, f6, f6]);
        var d4 = Math.abs(a.r || 0 - a.r0 || 0);
        return { cornerRadius: Pi(f6, function(y4) {
          return H1(y4, d4);
        }) };
      }
      var n7t = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this) || this;
          y4.z2 = 2;
          var _ = new ju();
          return y4.setTextContent(_), y4.updateData(n6, f6, d4, true), y4;
        }
        return a.prototype.updateData = function(n6, f6, d4, y4) {
          var _ = this, S = n6.hostModel, T = n6.getItemModel(f6), E = T.getModel("emphasis"), O = n6.getItemLayout(f6), R = ei(q7(T.getModel("itemStyle"), O, true), O);
          if (isNaN(R.startAngle)) {
            _.setShape(R);
            return;
          }
          if (y4) {
            _.setShape(R);
            var V = S.getShallow("animationType");
            S.ecModel.ssr ? ($h(_, { scaleX: 0, scaleY: 0 }, S, { dataIndex: f6, isFrom: true }), _.originX = R.cx, _.originY = R.cy) : V === "scale" ? (_.shape.r = O.r0, $h(_, { shape: { r: O.r } }, S, f6)) : d4 != null ? (_.setShape({ startAngle: d4, endAngle: d4 }), $h(_, { shape: { startAngle: O.startAngle, endAngle: O.endAngle } }, S, f6)) : (_.shape.endAngle = O.startAngle, ku(_, { shape: { endAngle: O.endAngle } }, S, f6));
          } else
            ox(_), ku(_, { shape: R }, S, f6);
          _.useStyle(n6.getItemVisual(f6, "style")), Pg(_, T);
          var z3 = (O.startAngle + O.endAngle) / 2, H = S.get("selectedOffset"), Z = Math.cos(z3) * H, ee = Math.sin(z3) * H, oe = T.getShallow("cursor");
          oe && _.attr("cursor", oe), this._updateLabel(S, n6, f6), _.ensureState("emphasis").shape = ei({ r: O.r + (E.get("scale") && E.get("scaleSize") || 0) }, q7(E.getModel("itemStyle"), O)), ei(_.ensureState("select"), { x: Z, y: ee, shape: q7(T.getModel(["select", "itemStyle"]), O) }), ei(_.ensureState("blur"), { shape: q7(T.getModel(["blur", "itemStyle"]), O) });
          var fe = _.getTextGuideLine(), _e = _.getTextContent();
          fe && ei(fe.ensureState("select"), { x: Z, y: ee }), ei(_e.ensureState("select"), { x: Z, y: ee }), Up(this, E.get("focus"), E.get("blurScope"), E.get("disabled"));
        }, a.prototype._updateLabel = function(n6, f6, d4) {
          var y4 = this, _ = f6.getItemModel(d4), S = _.getModel("labelLine"), T = f6.getItemVisual(d4, "style"), E = T && T.fill, O = T && T.opacity;
          Gm(y4, E0(_), { labelFetcher: f6.hostModel, labelDataIndex: d4, inheritColor: E, defaultOpacity: O, defaultText: n6.getFormattedLabel(d4, "normal") || f6.getName(d4) });
          var R = y4.getTextContent();
          y4.setTextConfig({ position: null, rotation: null }), R.attr({ z2: 10 });
          var V = n6.get(["label", "position"]);
          if (V !== "outside" && V !== "outer")
            y4.removeTextGuideLine();
          else {
            var z3 = this.getTextGuideLine();
            z3 || (z3 = new zm(), this.setTextGuideLine(z3)), zwe(this, jwe(_), { stroke: E, opacity: rC(S.get(["lineStyle", "opacity"]), O, 1) });
          }
        }, a;
      }(Bm), r7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.ignoreLabelLineUpdate = true, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          var _ = n6.getData(), S = this._data, T = this.group, E;
          if (!S && _.count() > 0) {
            for (var O = _.getItemLayout(0), R = 1; isNaN(O && O.startAngle) && R < _.count(); ++R)
              O = _.getItemLayout(R);
            O && (E = O.startAngle);
          }
          if (this._emptyCircleSector && T.remove(this._emptyCircleSector), _.count() === 0 && n6.get("showEmptyCircle")) {
            var V = new Bm({ shape: rqe(n6, d4) });
            V.useStyle(n6.getModel("emptyCircleStyle").getItemStyle()), this._emptyCircleSector = V, T.add(V);
          }
          _.diff(S).add(function(z3) {
            var H = new n7t(_, z3, E);
            _.setItemGraphicEl(z3, H), T.add(H);
          }).update(function(z3, H) {
            var Z = S.getItemGraphicEl(H);
            Z.updateData(_, z3, E), Z.off("click"), T.add(Z), _.setItemGraphicEl(z3, Z);
          }).remove(function(z3) {
            var H = S.getItemGraphicEl(z3);
            kR(H, n6, z3);
          }).execute(), t7t(n6), n6.get("animationTypeUpdate") !== "expansion" && (this._data = _);
        }, a.prototype.dispose = function() {
        }, a.prototype.containPoint = function(n6, f6) {
          var d4 = f6.getData(), y4 = d4.getItemLayout(0);
          if (y4) {
            var _ = n6[0] - y4.cx, S = n6[1] - y4.cy, T = Math.sqrt(_ * _ + S * S);
            return T <= y4.r && T >= y4.r0;
          }
        }, a.type = "pie", a;
      }(Ch), i7t = r7t;
      function $7(s, a, n6) {
        a = Di(a) && { coordDimensions: a } || ei({ encodeDefine: s.getEncode() }, a);
        var f6 = s.getSource(), d4 = O$(f6, a).dimensions, y4 = new K1(d4, s);
        return y4.initData(f6, n6), y4;
      }
      var a7t = function() {
        function s(a, n6) {
          this._getDataWithEncodedVisual = a, this._getRawData = n6;
        }
        return s.prototype.getAllNames = function() {
          var a = this._getRawData();
          return a.mapArray(a.getName);
        }, s.prototype.containName = function(a) {
          var n6 = this._getRawData();
          return n6.indexOfName(a) >= 0;
        }, s.prototype.indexOfName = function(a) {
          var n6 = this._getDataWithEncodedVisual();
          return n6.indexOfName(a);
        }, s.prototype.getItemVisual = function(a, n6) {
          var f6 = this._getDataWithEncodedVisual();
          return f6.getItemVisual(a, n6);
        }, s;
      }(), q$ = a7t, o7t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.init = function(n6) {
          s.prototype.init.apply(this, arguments), this.legendVisualProvider = new q$(Za(this.getData, this), Za(this.getRawData, this)), this._defaultLabelLine(n6);
        }, a.prototype.mergeOption = function() {
          s.prototype.mergeOption.apply(this, arguments);
        }, a.prototype.getInitialData = function() {
          return $7(this, { coordDimensions: ["value"], encodeDefaulter: ks(Lxe, this) });
        }, a.prototype.getDataParams = function(n6) {
          var f6 = this.getData(), d4 = s.prototype.getDataParams.call(this, n6), y4 = [];
          return f6.each(f6.mapDimension("value"), function(_) {
            y4.push(_);
          }), d4.percent = j9(y4, n6, f6.hostModel.get("percentPrecision")), d4.$vars.push("percent"), d4;
        }, a.prototype._defaultLabelLine = function(n6) {
          Gb(n6, "labelLine", ["show"]);
          var f6 = n6.labelLine, d4 = n6.emphasis.labelLine;
          f6.show = f6.show && n6.label.show, d4.show = d4.show && n6.emphasis.label.show;
        }, a.type = "series.pie", a.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, minShowLabelAngle: 0, selectedOffset: 10, percentPrecision: 2, stillShowZeroSum: true, left: 0, top: 0, right: 0, bottom: 0, width: null, height: null, label: { rotate: 0, show: true, overflow: "truncate", position: "outer", alignTo: "none", edgeDistance: "25%", bleedMargin: 10, distanceToLabelLine: 5 }, labelLine: { show: true, length: 15, length2: 15, smooth: false, minTurnAngle: 90, maxSurfaceAngle: 90, lineStyle: { width: 1, type: "solid" } }, itemStyle: { borderWidth: 1, borderJoin: "round" }, showEmptyCircle: true, emptyCircleStyle: { color: "lightgray", opacity: 1 }, labelLayout: { hideOverlap: true }, emphasis: { scale: true, scaleSize: 5 }, avoidLabelOverlap: true, animationType: "expansion", animationDuration: 1e3, animationTypeUpdate: "transition", animationEasingUpdate: "cubicInOut", animationDurationUpdate: 500, animationEasing: "cubicInOut" }, a;
      }(Cp), s7t = o7t;
      function l7t(s) {
        return { seriesType: s, reset: function(a, n6) {
          var f6 = a.getData();
          f6.filterSelf(function(d4) {
            var y4 = f6.mapDimension("value"), _ = f6.get(y4, d4);
            return !(ac(_) && !isNaN(_) && _ < 0);
          });
        } };
      }
      function u7t(s) {
        s.registerChartView(i7t), s.registerSeriesModel(s7t), cHe("pie", s.registerAction), s.registerLayout(ks(J9t, "pie")), s.registerProcessor(U$("pie")), s.registerProcessor(l7t("pie"));
      }
      var c7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.hasSymbolVisual = true, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          return PE(null, this, { useEncodeDefaulter: true });
        }, a.prototype.getProgressive = function() {
          var n6 = this.option.progressive;
          return n6 == null ? this.option.large ? 5e3 : this.get("progressive") : n6;
        }, a.prototype.getProgressiveThreshold = function() {
          var n6 = this.option.progressiveThreshold;
          return n6 == null ? this.option.large ? 1e4 : this.get("progressiveThreshold") : n6;
        }, a.prototype.brushSelector = function(n6, f6, d4) {
          return d4.point(f6.getItemLayout(n6));
        }, a.prototype.getZLevelKey = function() {
          return this.getData().count() > this.getProgressiveThreshold() ? this.id : "";
        }, a.type = "series.scatter", a.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, symbolSize: 10, large: false, largeThreshold: 2e3, itemStyle: { opacity: 0.8 }, emphasis: { scale: true }, clip: true, select: { itemStyle: { borderColor: "#212121" } }, universalTransition: { divideShape: "clone" } }, a;
      }(Cp), f7t = c7t, oqe = 4, h7t = function() {
        function s() {
        }
        return s;
      }(), p7t = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6._off = 0, f6.hoverDataIdx = -1, f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new h7t();
        }, a.prototype.reset = function() {
          this.notClear = false, this._off = 0;
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.points, y4 = f6.size, _ = this.symbolProxy, S = _.shape, T = n6.getContext ? n6.getContext() : n6, E = T && y4[0] < oqe, O = this.softClipShape, R;
          if (E) {
            this._ctx = T;
            return;
          }
          for (this._ctx = null, R = this._off; R < d4.length; ) {
            var V = d4[R++], z3 = d4[R++];
            isNaN(V) || isNaN(z3) || O && !O.contain(V, z3) || (S.x = V - y4[0] / 2, S.y = z3 - y4[1] / 2, S.width = y4[0], S.height = y4[1], _.buildPath(n6, S, true));
          }
          this.incremental && (this._off = R, this.notClear = true);
        }, a.prototype.afterBrush = function() {
          var n6 = this.shape, f6 = n6.points, d4 = n6.size, y4 = this._ctx, _ = this.softClipShape, S;
          if (y4) {
            for (S = this._off; S < f6.length; ) {
              var T = f6[S++], E = f6[S++];
              isNaN(T) || isNaN(E) || _ && !_.contain(T, E) || y4.fillRect(T - d4[0] / 2, E - d4[1] / 2, d4[0], d4[1]);
            }
            this.incremental && (this._off = S, this.notClear = true);
          }
        }, a.prototype.findDataIndex = function(n6, f6) {
          for (var d4 = this.shape, y4 = d4.points, _ = d4.size, S = Math.max(_[0], 4), T = Math.max(_[1], 4), E = y4.length / 2 - 1; E >= 0; E--) {
            var O = E * 2, R = y4[O] - S / 2, V = y4[O + 1] - T / 2;
            if (n6 >= R && f6 >= V && n6 <= R + S && f6 <= V + T)
              return E;
          }
          return -1;
        }, a.prototype.contain = function(n6, f6) {
          var d4 = this.transformCoordToLocal(n6, f6), y4 = this.getBoundingRect();
          if (n6 = d4[0], f6 = d4[1], y4.contain(n6, f6)) {
            var _ = this.hoverDataIdx = this.findDataIndex(n6, f6);
            return _ >= 0;
          }
          return this.hoverDataIdx = -1, false;
        }, a.prototype.getBoundingRect = function() {
          var n6 = this._rect;
          if (!n6) {
            for (var f6 = this.shape, d4 = f6.points, y4 = f6.size, _ = y4[0], S = y4[1], T = 1 / 0, E = 1 / 0, O = -1 / 0, R = -1 / 0, V = 0; V < d4.length; ) {
              var z3 = d4[V++], H = d4[V++];
              T = Math.min(z3, T), O = Math.max(z3, O), E = Math.min(H, E), R = Math.max(H, R);
            }
            n6 = this._rect = new il(T - _ / 2, E - S / 2, O - T + _, R - E + S);
          }
          return n6;
        }, a;
      }(ml), d7t = function() {
        function s() {
          this.group = new fs();
        }
        return s.prototype.updateData = function(a, n6) {
          this._clear();
          var f6 = this._create();
          f6.setShape({ points: a.getLayout("points") }), this._setCommon(f6, a, n6);
        }, s.prototype.updateLayout = function(a) {
          var n6 = a.getLayout("points");
          this.group.eachChild(function(f6) {
            if (f6.startIndex != null) {
              var d4 = (f6.endIndex - f6.startIndex) * 2, y4 = f6.startIndex * 4 * 2;
              n6 = new Float32Array(n6.buffer, y4, d4);
            }
            f6.setShape("points", n6), f6.reset();
          });
        }, s.prototype.incrementalPrepareUpdate = function(a) {
          this._clear();
        }, s.prototype.incrementalUpdate = function(a, n6, f6) {
          var d4 = this._newAdded[0], y4 = n6.getLayout("points"), _ = d4 && d4.shape.points;
          if (_ && _.length < 2e4) {
            var S = _.length, T = new Float32Array(S + y4.length);
            T.set(_), T.set(y4, S), d4.endIndex = a.end, d4.setShape({ points: T });
          } else {
            this._newAdded = [];
            var E = this._create();
            E.startIndex = a.start, E.endIndex = a.end, E.incremental = true, E.setShape({ points: y4 }), this._setCommon(E, n6, f6);
          }
        }, s.prototype.eachRendered = function(a) {
          this._newAdded[0] && a(this._newAdded[0]);
        }, s.prototype._create = function() {
          var a = new p7t({ cursor: "default" });
          return this.group.add(a), this._newAdded.push(a), a;
        }, s.prototype._setCommon = function(a, n6, f6) {
          var d4 = n6.hostModel;
          f6 = f6 || {};
          var y4 = n6.getVisual("symbolSize");
          a.setShape("size", y4 instanceof Array ? y4 : [y4, y4]), a.softClipShape = f6.clipShape || null, a.symbolProxy = bv(n6.getVisual("symbol"), 0, 0, 0, 0), a.setColor = a.symbolProxy.setColor;
          var _ = a.shape.size[0] < oqe;
          a.useStyle(d4.getModel("itemStyle").getItemStyle(_ ? ["color", "shadowBlur", "shadowColor"] : ["color"]));
          var S = n6.getVisual("style"), T = S && S.fill;
          T && a.setColor(T);
          var E = qo(a);
          E.seriesIndex = d4.seriesIndex, a.on("mousemove", function(O) {
            E.dataIndex = null;
            var R = a.hoverDataIdx;
            R >= 0 && (E.dataIndex = R + (a.startIndex || 0));
          });
        }, s.prototype.remove = function() {
          this._clear();
        }, s.prototype._clear = function() {
          this._newAdded = [], this.group.removeAll();
        }, s;
      }(), v7t = d7t, g7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this._updateSymbolDraw(y4, n6);
          _.updateData(y4, { clipShape: this._getClipShape(n6) }), this._finished = true;
        }, a.prototype.incrementalPrepareRender = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this._updateSymbolDraw(y4, n6);
          _.incrementalPrepareUpdate(y4), this._finished = false;
        }, a.prototype.incrementalRender = function(n6, f6, d4) {
          this._symbolDraw.incrementalUpdate(n6, f6.getData(), { clipShape: this._getClipShape(f6) }), this._finished = n6.end === f6.getData().count();
        }, a.prototype.updateTransform = function(n6, f6, d4) {
          var y4 = n6.getData();
          if (this.group.dirty(), !this._finished || y4.count() > 1e4)
            return { update: true };
          var _ = W$("").reset(n6, f6, d4);
          _.progress && _.progress({ start: 0, end: y4.count(), count: y4.count() }, y4), this._symbolDraw.updateLayout(y4);
        }, a.prototype.eachRendered = function(n6) {
          this._symbolDraw && this._symbolDraw.eachRendered(n6);
        }, a.prototype._getClipShape = function(n6) {
          var f6 = n6.coordinateSystem, d4 = f6 && f6.getArea && f6.getArea();
          return n6.get("clip", true) ? d4 : null;
        }, a.prototype._updateSymbolDraw = function(n6, f6) {
          var d4 = this._symbolDraw, y4 = f6.pipelineContext, _ = y4.large;
          return (!d4 || _ !== this._isLargeDraw) && (d4 && d4.remove(), d4 = this._symbolDraw = _ ? new v7t() : new H$(), this._isLargeDraw = _, this.group.removeAll()), this.group.add(d4.group), d4;
        }, a.prototype.remove = function(n6, f6) {
          this._symbolDraw && this._symbolDraw.remove(true), this._symbolDraw = null;
        }, a.prototype.dispose = function() {
        }, a.type = "scatter", a;
      }(Ch), y7t = g7t, m7t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.type = "grid", a.dependencies = ["xAxis", "yAxis"], a.layoutMode = "box", a.defaultOption = { show: false, z: 0, left: "10%", top: 60, right: "10%", bottom: 70, containLabel: false, backgroundColor: "rgba(0,0,0,0)", borderWidth: 1, borderColor: "#ccc" }, a;
      }(oc), b7t = m7t, sSe = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.getCoordSysModel = function() {
          return this.getReferringComponents("grid", ad).models[0];
        }, a.type = "cartesian2dAxis", a;
      }(oc);
      nd(sSe, R$);
      var sqe = { show: true, z: 0, inverse: false, name: "", nameLocation: "end", nameRotate: null, nameTruncate: { maxWidth: null, ellipsis: "...", placeholder: "." }, nameTextStyle: {}, nameGap: 15, silent: false, triggerEvent: false, tooltip: { show: false }, axisPointer: {}, axisLine: { show: true, onZero: true, onZeroAxisIndex: null, lineStyle: { color: "#6E7079", width: 1, type: "solid" }, symbol: ["none", "none"], symbolSize: [10, 15] }, axisTick: { show: true, inside: false, length: 5, lineStyle: { width: 1 } }, axisLabel: { show: true, inside: false, rotate: 0, showMinLabel: null, showMaxLabel: null, margin: 8, fontSize: 12 }, splitLine: { show: true, lineStyle: { color: ["#E0E6F1"], width: 1, type: "solid" } }, splitArea: { show: false, areaStyle: { color: ["rgba(250,250,250,0.2)", "rgba(210,219,238,0.2)"] } } }, _7t = Ms({ boundaryGap: true, deduplication: null, splitLine: { show: false }, axisTick: { alignWithLabel: false, interval: "auto" }, axisLabel: { interval: "auto" } }, sqe), lSe = Ms({ boundaryGap: [0, 0], axisLine: { show: "auto" }, axisTick: { show: "auto" }, splitNumber: 5, minorTick: { show: false, splitNumber: 5, length: 3, lineStyle: {} }, minorSplitLine: { show: false, lineStyle: { color: "#F4F7FD", width: 1 } } }, sqe), x7t = Ms({ splitNumber: 6, axisLabel: { showMinLabel: false, showMaxLabel: false, rich: { primary: { fontWeight: "bold" } } }, splitLine: { show: false } }, lSe), w7t = zo({ logBase: 10 }, lSe), lqe = { category: _7t, value: lSe, time: x7t, log: w7t }, S7t = { value: 1, category: 1, time: 1, log: 1 };
      function X7(s, a, n6, f6) {
        gt(S7t, function(d4, y4) {
          var _ = Ms(Ms({}, lqe[y4], true), f6, true), S = function(T) {
            Vt(E, T);
            function E() {
              var O = T !== null && T.apply(this, arguments) || this;
              return O.type = a + "Axis." + y4, O;
            }
            return E.prototype.mergeDefaultAndTheme = function(O, R) {
              var V = u$(this), z3 = V ? E7(O) : {}, H = R.getTheme();
              Ms(O, H.get(y4 + "Axis")), Ms(O, this.getDefaultOption()), O.type = uqe(O), V && Yk(O, z3, V);
            }, E.prototype.optionUpdated = function() {
              var O = this.option;
              O.type === "category" && (this.__ordinalMeta = Iwe.createByAxisModel(this));
            }, E.prototype.getCategories = function(O) {
              var R = this.option;
              if (R.type === "category")
                return O ? R.data : this.__ordinalMeta.categories;
            }, E.prototype.getOrdinalMeta = function() {
              return this.__ordinalMeta;
            }, E.type = a + "Axis." + y4, E.defaultOption = _, E;
          }(n6);
          s.registerComponentModel(S);
        }), s.registerSubTypeDefaulter(a + "Axis", uqe);
      }
      function uqe(s) {
        return s.type || (s.data ? "category" : "value");
      }
      var C7t = function() {
        function s(a) {
          this.type = "cartesian", this._dimList = [], this._axes = {}, this.name = a || "";
        }
        return s.prototype.getAxis = function(a) {
          return this._axes[a];
        }, s.prototype.getAxes = function() {
          return Pi(this._dimList, function(a) {
            return this._axes[a];
          }, this);
        }, s.prototype.getAxesByScale = function(a) {
          return a = a.toLowerCase(), tf(this.getAxes(), function(n6) {
            return n6.scale.type === a;
          });
        }, s.prototype.addAxis = function(a) {
          var n6 = a.dim;
          this._axes[n6] = a, this._dimList.push(n6);
        }, s;
      }(), M7t = C7t, uSe = ["x", "y"];
      function cqe(s) {
        return s.type === "interval" || s.type === "time";
      }
      var T7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "cartesian2d", n6.dimensions = uSe, n6;
        }
        return a.prototype.calcAffineTransform = function() {
          this._transform = this._invTransform = null;
          var n6 = this.getAxis("x").scale, f6 = this.getAxis("y").scale;
          if (!(!cqe(n6) || !cqe(f6))) {
            var d4 = n6.getExtent(), y4 = f6.getExtent(), _ = this.dataToPoint([d4[0], y4[0]]), S = this.dataToPoint([d4[1], y4[1]]), T = d4[1] - d4[0], E = y4[1] - y4[0];
            if (!(!T || !E)) {
              var O = (S[0] - _[0]) / T, R = (S[1] - _[1]) / E, V = _[0] - d4[0] * O, z3 = _[1] - y4[0] * R, H = this._transform = [O, 0, 0, R, V, z3];
              this._invTransform = aE([], H);
            }
          }
        }, a.prototype.getBaseAxis = function() {
          return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAxis("x");
        }, a.prototype.containPoint = function(n6) {
          var f6 = this.getAxis("x"), d4 = this.getAxis("y");
          return f6.contain(f6.toLocalCoord(n6[0])) && d4.contain(d4.toLocalCoord(n6[1]));
        }, a.prototype.containData = function(n6) {
          return this.getAxis("x").containData(n6[0]) && this.getAxis("y").containData(n6[1]);
        }, a.prototype.dataToPoint = function(n6, f6, d4) {
          d4 = d4 || [];
          var y4 = n6[0], _ = n6[1];
          if (this._transform && y4 != null && isFinite(y4) && _ != null && isFinite(_))
            return Xv(d4, n6, this._transform);
          var S = this.getAxis("x"), T = this.getAxis("y");
          return d4[0] = S.toGlobalCoord(S.dataToCoord(y4, f6)), d4[1] = T.toGlobalCoord(T.dataToCoord(_, f6)), d4;
        }, a.prototype.clampData = function(n6, f6) {
          var d4 = this.getAxis("x").scale, y4 = this.getAxis("y").scale, _ = d4.getExtent(), S = y4.getExtent(), T = d4.parse(n6[0]), E = y4.parse(n6[1]);
          return f6 = f6 || [], f6[0] = Math.min(Math.max(Math.min(_[0], _[1]), T), Math.max(_[0], _[1])), f6[1] = Math.min(Math.max(Math.min(S[0], S[1]), E), Math.max(S[0], S[1])), f6;
        }, a.prototype.pointToData = function(n6, f6) {
          var d4 = [];
          if (this._invTransform)
            return Xv(d4, n6, this._invTransform);
          var y4 = this.getAxis("x"), _ = this.getAxis("y");
          return d4[0] = y4.coordToData(y4.toLocalCoord(n6[0]), f6), d4[1] = _.coordToData(_.toLocalCoord(n6[1]), f6), d4;
        }, a.prototype.getOtherAxis = function(n6) {
          return this.getAxis(n6.dim === "x" ? "y" : "x");
        }, a.prototype.getArea = function() {
          var n6 = this.getAxis("x").getGlobalExtent(), f6 = this.getAxis("y").getGlobalExtent(), d4 = Math.min(n6[0], n6[1]), y4 = Math.min(f6[0], f6[1]), _ = Math.max(n6[0], n6[1]) - d4, S = Math.max(f6[0], f6[1]) - y4;
          return new il(d4, y4, _, S);
        }, a;
      }(M7t), A7t = T7t, I7t = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4, _) {
          var S = s.call(this, n6, f6, d4) || this;
          return S.index = 0, S.type = y4 || "value", S.position = _ || "bottom", S;
        }
        return a.prototype.isHorizontal = function() {
          var n6 = this.position;
          return n6 === "top" || n6 === "bottom";
        }, a.prototype.getGlobalExtent = function(n6) {
          var f6 = this.getExtent();
          return f6[0] = this.toGlobalCoord(f6[0]), f6[1] = this.toGlobalCoord(f6[1]), n6 && f6[0] > f6[1] && f6.reverse(), f6;
        }, a.prototype.pointToData = function(n6, f6) {
          return this.coordToData(this.toLocalCoord(n6[this.dim === "x" ? 0 : 1]), f6);
        }, a.prototype.setCategorySortInfo = function(n6) {
          if (this.type !== "category")
            return false;
          this.model.option.categorySortInfo = n6, this.scale.setSortInfo(n6);
        }, a;
      }(xC), E7t = I7t;
      function cSe(s, a, n6) {
        n6 = n6 || {};
        var f6 = s.coordinateSystem, d4 = a.axis, y4 = {}, _ = d4.getAxesOnZeroOf()[0], S = d4.position, T = _ ? "onZero" : S, E = d4.dim, O = f6.getRect(), R = [O.x, O.x + O.width, O.y, O.y + O.height], V = { left: 0, right: 1, top: 0, bottom: 1, onZero: 2 }, z3 = a.get("offset") || 0, H = E === "x" ? [R[2] - z3, R[3] + z3] : [R[0] - z3, R[1] + z3];
        if (_) {
          var Z = _.toGlobalCoord(_.dataToCoord(0));
          H[V.onZero] = Math.max(Math.min(Z, H[1]), H[0]);
        }
        y4.position = [E === "y" ? H[V[T]] : R[0], E === "x" ? H[V[T]] : R[3]], y4.rotation = Math.PI / 2 * (E === "x" ? 0 : 1);
        var ee = { top: -1, bottom: 1, left: -1, right: 1 };
        y4.labelDirection = y4.tickDirection = y4.nameDirection = ee[S], y4.labelOffset = _ ? H[V[S]] - H[V.onZero] : 0, a.get(["axisTick", "inside"]) && (y4.tickDirection = -y4.tickDirection), $v(n6.labelInside, a.get(["axisLabel", "inside"])) && (y4.labelDirection = -y4.labelDirection);
        var oe = a.get(["axisLabel", "rotate"]);
        return y4.labelRotate = T === "top" ? -oe : oe, y4.z2 = 1, y4;
      }
      function fqe(s) {
        return s.get("coordinateSystem") === "cartesian2d";
      }
      function hqe(s) {
        var a = { xAxisModel: null, yAxisModel: null };
        return gt(a, function(n6, f6) {
          var d4 = f6.replace(/Model$/, ""), y4 = s.getReferringComponents(d4, ad).models[0];
          a[f6] = y4;
        }), a;
      }
      var fSe = Math.log;
      function pqe(s, a, n6) {
        var f6 = n3.prototype, d4 = f6.getTicks.call(n6), y4 = f6.getTicks.call(n6, true), _ = d4.length - 1, S = f6.getInterval.call(n6), T = EWe(s, a), E = T.extent, O = T.fixMin, R = T.fixMax;
        if (s.type === "log") {
          var V = fSe(s.base);
          E = [fSe(E[0]) / V, fSe(E[1]) / V];
        }
        s.setExtent(E[0], E[1]), s.calcNiceExtent({ splitNumber: _, fixMin: O, fixMax: R });
        var z3 = f6.getExtent.call(s);
        O && (E[0] = z3[0]), R && (E[1] = z3[1]);
        var H = f6.getInterval.call(s), Z = E[0], ee = E[1];
        if (O && R)
          H = (ee - Z) / _;
        else if (O)
          for (ee = E[0] + H * _; ee < E[1] && isFinite(ee) && isFinite(E[1]); )
            H = Dwe(H), ee = E[0] + H * _;
        else if (R)
          for (Z = E[1] - H * _; Z > E[0] && isFinite(Z) && isFinite(E[0]); )
            H = Dwe(H), Z = E[1] - H * _;
        else {
          var oe = s.getTicks().length - 1;
          oe > _ && (H = Dwe(H));
          var fe = H * _;
          ee = Math.ceil(E[1] / H) * H, Z = Wp(ee - fe), Z < 0 && E[0] >= 0 ? (Z = 0, ee = Wp(fe)) : ee > 0 && E[1] <= 0 && (ee = 0, Z = -Wp(fe));
        }
        var _e = (d4[0].value - y4[0].value) / S, pe = (d4[_].value - y4[_].value) / S;
        f6.setExtent.call(s, Z + H * _e, ee + H * pe), f6.setInterval.call(s, H), (_e || pe) && f6.setNiceExtent.call(s, Z + H, ee - H);
      }
      var D7t = function() {
        function s(a, n6, f6) {
          this.type = "grid", this._coordsMap = {}, this._coordsList = [], this._axesMap = {}, this._axesList = [], this.axisPointerEnabled = true, this.dimensions = uSe, this._initCartesian(a, n6, f6), this.model = a;
        }
        return s.prototype.getRect = function() {
          return this._rect;
        }, s.prototype.update = function(a, n6) {
          var f6 = this._axesMap;
          this._updateScale(a, this.model);
          function d4(_) {
            var S, T = Wl(_), E = T.length;
            if (E) {
              for (var O = [], R = E - 1; R >= 0; R--) {
                var V = +T[R], z3 = _[V], H = z3.model, Z = z3.scale;
                Ewe(Z) && H.get("alignTicks") && H.get("interval") == null ? O.push(z3) : (H7(Z, H), Ewe(Z) && (S = z3));
              }
              O.length && (S || (S = O.pop(), H7(S.scale, S.model)), gt(O, function(ee) {
                pqe(ee.scale, ee.model, S.scale);
              }));
            }
          }
          d4(f6.x), d4(f6.y);
          var y4 = {};
          gt(f6.x, function(_) {
            dqe(f6, "y", _, y4);
          }), gt(f6.y, function(_) {
            dqe(f6, "x", _, y4);
          }), this.resize(this.model, n6);
        }, s.prototype.resize = function(a, n6, f6) {
          var d4 = a.getBoxLayoutParams(), y4 = !f6 && a.get("containLabel"), _ = Qv(d4, { width: n6.getWidth(), height: n6.getHeight() });
          this._rect = _;
          var S = this._axesList;
          T(), y4 && (gt(S, function(E) {
            if (!E.model.get(["axisLabel", "inside"])) {
              var O = HFt(E);
              if (O) {
                var R = E.isHorizontal() ? "height" : "width", V = E.model.get(["axisLabel", "margin"]);
                _[R] -= O[R] + V, E.position === "top" ? _.y += O.height + V : E.position === "left" && (_.x += O.width + V);
              }
            }
          }), T()), gt(this._coordsList, function(E) {
            E.calcAffineTransform();
          });
          function T() {
            gt(S, function(E) {
              var O = E.isHorizontal(), R = O ? [0, _.width] : [0, _.height], V = E.inverse ? 1 : 0;
              E.setExtent(R[V], R[1 - V]), k7t(E, O ? _.x : _.y);
            });
          }
        }, s.prototype.getAxis = function(a, n6) {
          var f6 = this._axesMap[a];
          if (f6 != null)
            return f6[n6 || 0];
        }, s.prototype.getAxes = function() {
          return this._axesList.slice();
        }, s.prototype.getCartesian = function(a, n6) {
          if (a != null && n6 != null) {
            var f6 = "x" + a + "y" + n6;
            return this._coordsMap[f6];
          }
          Qo(a) && (n6 = a.yAxisIndex, a = a.xAxisIndex);
          for (var d4 = 0, y4 = this._coordsList; d4 < y4.length; d4++)
            if (y4[d4].getAxis("x").index === a || y4[d4].getAxis("y").index === n6)
              return y4[d4];
        }, s.prototype.getCartesians = function() {
          return this._coordsList.slice();
        }, s.prototype.convertToPixel = function(a, n6, f6) {
          var d4 = this._findConvertTarget(n6);
          return d4.cartesian ? d4.cartesian.dataToPoint(f6) : d4.axis ? d4.axis.toGlobalCoord(d4.axis.dataToCoord(f6)) : null;
        }, s.prototype.convertFromPixel = function(a, n6, f6) {
          var d4 = this._findConvertTarget(n6);
          return d4.cartesian ? d4.cartesian.pointToData(f6) : d4.axis ? d4.axis.coordToData(d4.axis.toLocalCoord(f6)) : null;
        }, s.prototype._findConvertTarget = function(a) {
          var n6 = a.seriesModel, f6 = a.xAxisModel || n6 && n6.getReferringComponents("xAxis", ad).models[0], d4 = a.yAxisModel || n6 && n6.getReferringComponents("yAxis", ad).models[0], y4 = a.gridModel, _ = this._coordsList, S, T;
          if (n6)
            S = n6.coordinateSystem, Ns(_, S) < 0 && (S = null);
          else if (f6 && d4)
            S = this.getCartesian(f6.componentIndex, d4.componentIndex);
          else if (f6)
            T = this.getAxis("x", f6.componentIndex);
          else if (d4)
            T = this.getAxis("y", d4.componentIndex);
          else if (y4) {
            var E = y4.coordinateSystem;
            E === this && (S = this._coordsList[0]);
          }
          return { cartesian: S, axis: T };
        }, s.prototype.containPoint = function(a) {
          var n6 = this._coordsList[0];
          if (n6)
            return n6.containPoint(a);
        }, s.prototype._initCartesian = function(a, n6, f6) {
          var d4 = this, y4 = this, _ = { left: false, right: false, top: false, bottom: false }, S = { x: {}, y: {} }, T = { x: 0, y: 0 };
          if (n6.eachComponent("xAxis", E("x"), this), n6.eachComponent("yAxis", E("y"), this), !T.x || !T.y) {
            this._axesMap = {}, this._axesList = [];
            return;
          }
          this._axesMap = S, gt(S.x, function(O, R) {
            gt(S.y, function(V, z3) {
              var H = "x" + R + "y" + z3, Z = new A7t(H);
              Z.master = d4, Z.model = a, d4._coordsMap[H] = Z, d4._coordsList.push(Z), Z.addAxis(O), Z.addAxis(V);
            });
          });
          function E(O) {
            return function(R, V) {
              if (hSe(R, a)) {
                var z3 = R.get("position");
                O === "x" ? z3 !== "top" && z3 !== "bottom" && (z3 = _.bottom ? "top" : "bottom") : z3 !== "left" && z3 !== "right" && (z3 = _.left ? "right" : "left"), _[z3] = true;
                var H = new E7t(O, coe(R), [0, 0], R.get("type"), z3), Z = H.type === "category";
                H.onBand = Z && R.get("boundaryGap"), H.inverse = R.get("inverse"), R.axis = H, H.model = R, H.grid = y4, H.index = V, y4._axesList.push(H), S[O][V] = H, T[O]++;
              }
            };
          }
        }, s.prototype._updateScale = function(a, n6) {
          gt(this._axesList, function(d4) {
            if (d4.scale.setExtent(1 / 0, -1 / 0), d4.type === "category") {
              var y4 = d4.model.get("categorySortInfo");
              d4.scale.setSortInfo(y4);
            }
          }), a.eachSeries(function(d4) {
            if (fqe(d4)) {
              var y4 = hqe(d4), _ = y4.xAxisModel, S = y4.yAxisModel;
              if (!hSe(_, n6) || !hSe(S, n6))
                return;
              var T = this.getCartesian(_.componentIndex, S.componentIndex), E = d4.getData(), O = T.getAxis("x"), R = T.getAxis("y");
              f6(E, O), f6(E, R);
            }
          }, this);
          function f6(d4, y4) {
            gt(foe(d4, y4.dim), function(_) {
              y4.scale.unionExtentFromData(d4, _);
            });
          }
        }, s.prototype.getTooltipAxes = function(a) {
          var n6 = [], f6 = [];
          return gt(this.getCartesians(), function(d4) {
            var y4 = a != null && a !== "auto" ? d4.getAxis(a) : d4.getBaseAxis(), _ = d4.getOtherAxis(y4);
            Ns(n6, y4) < 0 && n6.push(y4), Ns(f6, _) < 0 && f6.push(_);
          }), { baseAxes: n6, otherAxes: f6 };
        }, s.create = function(a, n6) {
          var f6 = [];
          return a.eachComponent("grid", function(d4, y4) {
            var _ = new s(d4, a, n6);
            _.name = "grid_" + y4, _.resize(d4, n6, true), d4.coordinateSystem = _, f6.push(_);
          }), a.eachSeries(function(d4) {
            if (fqe(d4)) {
              var y4 = hqe(d4), _ = y4.xAxisModel, S = y4.yAxisModel, T = _.getCoordSysModel(), E = T.coordinateSystem;
              d4.coordinateSystem = E.getCartesian(_.componentIndex, S.componentIndex);
            }
          }), f6;
        }, s.dimensions = uSe, s;
      }();
      function hSe(s, a) {
        return s.getCoordSysModel() === a;
      }
      function dqe(s, a, n6, f6) {
        n6.getAxesOnZeroOf = function() {
          return y4 ? [y4] : [];
        };
        var d4 = s[a], y4, _ = n6.model, S = _.get(["axisLine", "onZero"]), T = _.get(["axisLine", "onZeroAxisIndex"]);
        if (!S)
          return;
        if (T != null)
          vqe(d4[T]) && (y4 = d4[T]);
        else
          for (var E in d4)
            if (d4.hasOwnProperty(E) && vqe(d4[E]) && !f6[O(d4[E])]) {
              y4 = d4[E];
              break;
            }
        y4 && (f6[O(y4)] = true);
        function O(R) {
          return R.dim + "_" + R.index;
        }
      }
      function vqe(s) {
        return s && s.type !== "category" && s.type !== "time" && GFt(s);
      }
      function k7t(s, a) {
        var n6 = s.getExtent(), f6 = n6[0] + n6[1];
        s.toGlobalCoord = s.dim === "x" ? function(d4) {
          return d4 + a;
        } : function(d4) {
          return f6 - d4 + a;
        }, s.toLocalCoord = s.dim === "x" ? function(d4) {
          return d4 - a;
        } : function(d4) {
          return f6 - d4 + a;
        };
      }
      var O7t = D7t, o3 = Math.PI, KR = function() {
        function s(a, n6) {
          this.group = new fs(), this.opt = n6, this.axisModel = a, zo(n6, { labelOffset: 0, nameDirection: 1, tickDirection: 1, labelDirection: 1, silent: true, handleAutoShown: function() {
            return true;
          } });
          var f6 = new fs({ x: n6.position[0], y: n6.position[1], rotation: n6.rotation });
          f6.updateTransform(), this._transformGroup = f6;
        }
        return s.prototype.hasBuilder = function(a) {
          return !!gqe[a];
        }, s.prototype.add = function(a) {
          gqe[a](this.opt, this.axisModel, this.group, this._transformGroup);
        }, s.prototype.getGroup = function() {
          return this.group;
        }, s.innerTextLayout = function(a, n6, f6) {
          var d4 = cie(n6 - a), y4, _;
          return pR(d4) ? (_ = f6 > 0 ? "top" : "bottom", y4 = "center") : pR(d4 - o3) ? (_ = f6 > 0 ? "bottom" : "top", y4 = "center") : (_ = "middle", d4 > 0 && d4 < o3 ? y4 = f6 > 0 ? "right" : "left" : y4 = f6 > 0 ? "left" : "right"), { rotation: d4, textAlign: y4, textVerticalAlign: _ };
        }, s.makeAxisEventDataBase = function(a) {
          var n6 = { componentType: a.mainType, componentIndex: a.componentIndex };
          return n6[a.mainType + "Index"] = a.componentIndex, n6;
        }, s.isLabelSilent = function(a) {
          var n6 = a.get("tooltip");
          return a.get("silent") || !(a.get("triggerEvent") || n6 && n6.show);
        }, s;
      }(), gqe = { axisLine: function(s, a, n6, f6) {
        var d4 = a.get(["axisLine", "show"]);
        if (d4 === "auto" && s.handleAutoShown && (d4 = s.handleAutoShown("axisLine")), !!d4) {
          var y4 = a.axis.getExtent(), _ = f6.transform, S = [y4[0], 0], T = [y4[1], 0];
          _ && (Xv(S, S, _), Xv(T, T, _));
          var E = ei({ lineCap: "round" }, a.getModel(["axisLine", "lineStyle"]).getLineStyle()), O = new Jv({ subPixelOptimize: true, shape: { x1: S[0], y1: S[1], x2: T[0], y2: T[1] }, style: E, strokeContainThreshold: s.strokeContainThreshold || 5, silent: true, z2: 1 });
          O.anid = "line", n6.add(O);
          var R = a.get(["axisLine", "symbol"]);
          if (R != null) {
            var V = a.get(["axisLine", "symbolSize"]);
            Wa(R) && (R = [R, R]), (Wa(V) || ac(V)) && (V = [V, V]);
            var z3 = B7(a.get(["axisLine", "symbolOffset"]) || 0, V), H = V[0], Z = V[1];
            gt([{ rotate: s.rotation + Math.PI / 2, offset: z3[0], r: 0 }, { rotate: s.rotation - Math.PI / 2, offset: z3[1], r: Math.sqrt((S[0] - T[0]) * (S[0] - T[0]) + (S[1] - T[1]) * (S[1] - T[1])) }], function(ee, oe) {
              if (R[oe] !== "none" && R[oe] != null) {
                var fe = bv(R[oe], -H / 2, -Z / 2, H, Z, E.stroke, true), _e = ee.r + ee.offset;
                fe.attr({ rotation: ee.rotate, x: S[0] + _e * Math.cos(s.rotation), y: S[1] - _e * Math.sin(s.rotation), silent: true, z2: 11 }), n6.add(fe);
              }
            });
          }
        }
      }, axisTickLabel: function(s, a, n6, f6) {
        var d4 = R7t(n6, f6, a, s), y4 = F7t(n6, f6, a, s);
        if (L7t(a, y4, d4), N7t(n6, f6, a, s.tickDirection), a.get(["axisLabel", "hideOverlap"])) {
          var _ = KWe(Pi(y4, function(S) {
            return { label: S, priority: S.z2, defaultAttr: { ignore: S.ignore } };
          }));
          QWe(_);
        }
      }, axisName: function(s, a, n6, f6) {
        var d4 = $v(s.axisName, a.get("name"));
        if (d4) {
          var y4 = a.get("nameLocation"), _ = s.nameDirection, S = a.getModel("nameTextStyle"), T = a.get("nameGap") || 0, E = a.axis.getExtent(), O = E[0] > E[1] ? -1 : 1, R = [y4 === "start" ? E[0] - O * T : y4 === "end" ? E[1] + O * T : (E[0] + E[1]) / 2, mqe(y4) ? s.labelOffset + _ * T : 0], V, z3 = a.get("nameRotate");
          z3 != null && (z3 = z3 * o3 / 180);
          var H;
          mqe(y4) ? V = KR.innerTextLayout(s.rotation, z3 != null ? z3 : s.rotation, _) : (V = P7t(s.rotation, y4, z3 || 0, E), H = s.axisNameAvailableWidth, H != null && (H = Math.abs(H / Math.sin(V.rotation)), !isFinite(H) && (H = null)));
          var Z = S.getFont(), ee = a.get("nameTruncate", true) || {}, oe = ee.ellipsis, fe = $v(s.nameTruncateMaxWidth, ee.maxWidth, H), _e = new ju({ x: R[0], y: R[1], rotation: V.rotation, silent: KR.isLabelSilent(a), style: Zd(S, { text: d4, font: Z, overflow: "truncate", width: fe, ellipsis: oe, fill: S.getTextColor() || a.get(["axisLine", "lineStyle", "color"]), align: S.get("align") || V.textAlign, verticalAlign: S.get("verticalAlign") || V.textVerticalAlign }), z2: 1 });
          if (I0({ el: _e, componentModel: a, itemName: d4 }), _e.__fullText = d4, _e.anid = "name", a.get("triggerEvent")) {
            var pe = KR.makeAxisEventDataBase(a);
            pe.targetType = "axisName", pe.name = d4, qo(_e).eventData = pe;
          }
          f6.add(_e), _e.updateTransform(), n6.add(_e), _e.decomposeTransform();
        }
      } };
      function P7t(s, a, n6, f6) {
        var d4 = cie(n6 - s), y4, _, S = f6[0] > f6[1], T = a === "start" && !S || a !== "start" && S;
        return pR(d4 - o3 / 2) ? (_ = T ? "bottom" : "top", y4 = "center") : pR(d4 - o3 * 1.5) ? (_ = T ? "top" : "bottom", y4 = "center") : (_ = "middle", d4 < o3 * 1.5 && d4 > o3 / 2 ? y4 = T ? "left" : "right" : y4 = T ? "right" : "left"), { rotation: d4, textAlign: y4, textVerticalAlign: _ };
      }
      function L7t(s, a, n6) {
        if (!DWe(s.axis)) {
          var f6 = s.get(["axisLabel", "showMinLabel"]), d4 = s.get(["axisLabel", "showMaxLabel"]);
          a = a || [], n6 = n6 || [];
          var y4 = a[0], _ = a[1], S = a[a.length - 1], T = a[a.length - 2], E = n6[0], O = n6[1], R = n6[n6.length - 1], V = n6[n6.length - 2];
          f6 === false ? (bS(y4), bS(E)) : yqe(y4, _) && (f6 ? (bS(_), bS(O)) : (bS(y4), bS(E))), d4 === false ? (bS(S), bS(R)) : yqe(T, S) && (d4 ? (bS(T), bS(V)) : (bS(S), bS(R)));
        }
      }
      function bS(s) {
        s && (s.ignore = true);
      }
      function yqe(s, a) {
        var n6 = s && s.getBoundingRect().clone(), f6 = a && a.getBoundingRect().clone();
        if (!(!n6 || !f6)) {
          var d4 = rR([]);
          return vT(d4, d4, -s.rotation), n6.applyTransform(cC([], d4, s.getLocalTransform())), f6.applyTransform(cC([], d4, a.getLocalTransform())), n6.intersect(f6);
        }
      }
      function mqe(s) {
        return s === "middle" || s === "center";
      }
      function bqe(s, a, n6, f6, d4) {
        for (var y4 = [], _ = [], S = [], T = 0; T < s.length; T++) {
          var E = s[T].coord;
          _[0] = E, _[1] = 0, S[0] = E, S[1] = n6, a && (Xv(_, _, a), Xv(S, S, a));
          var O = new Jv({ subPixelOptimize: true, shape: { x1: _[0], y1: _[1], x2: S[0], y2: S[1] }, style: f6, z2: 2, autoBatch: true, silent: true });
          O.anid = d4 + "_" + s[T].tickValue, y4.push(O);
        }
        return y4;
      }
      function R7t(s, a, n6, f6) {
        var d4 = n6.axis, y4 = n6.getModel("axisTick"), _ = y4.get("show");
        if (_ === "auto" && f6.handleAutoShown && (_ = f6.handleAutoShown("axisTick")), !(!_ || d4.scale.isBlank())) {
          for (var S = y4.getModel("lineStyle"), T = f6.tickDirection * y4.get("length"), E = d4.getTicksCoords(), O = bqe(E, a.transform, T, zo(S.getLineStyle(), { stroke: n6.get(["axisLine", "lineStyle", "color"]) }), "ticks"), R = 0; R < O.length; R++)
            s.add(O[R]);
          return O;
        }
      }
      function N7t(s, a, n6, f6) {
        var d4 = n6.axis, y4 = n6.getModel("minorTick");
        if (!(!y4.get("show") || d4.scale.isBlank())) {
          var _ = d4.getMinorTicksCoords();
          if (_.length)
            for (var S = y4.getModel("lineStyle"), T = f6 * y4.get("length"), E = zo(S.getLineStyle(), zo(n6.getModel("axisTick").getLineStyle(), { stroke: n6.get(["axisLine", "lineStyle", "color"]) })), O = 0; O < _.length; O++)
              for (var R = bqe(_[O], a.transform, T, E, "minorticks_" + O), V = 0; V < R.length; V++)
                s.add(R[V]);
        }
      }
      function F7t(s, a, n6, f6) {
        var d4 = n6.axis, y4 = $v(f6.axisLabelShow, n6.get(["axisLabel", "show"]));
        if (!(!y4 || d4.scale.isBlank())) {
          var _ = n6.getModel("axisLabel"), S = _.get("margin"), T = d4.getViewLabels(), E = ($v(f6.labelRotate, _.get("rotate")) || 0) * o3 / 180, O = KR.innerTextLayout(f6.rotation, E, f6.labelDirection), R = n6.getCategories && n6.getCategories(true), V = [], z3 = KR.isLabelSilent(n6), H = n6.get("triggerEvent");
          return gt(T, function(Z, ee) {
            var oe = d4.scale.type === "ordinal" ? d4.scale.getRawOrdinalNumber(Z.tickValue) : Z.tickValue, fe = Z.formattedLabel, _e = Z.rawLabel, pe = _;
            if (R && R[oe]) {
              var Ve = R[oe];
              Qo(Ve) && Ve.textStyle && (pe = new Sh(Ve.textStyle, _, n6.ecModel));
            }
            var Le = pe.getTextColor() || n6.get(["axisLine", "lineStyle", "color"]), je = d4.dataToCoord(oe), Xe = new ju({ x: je, y: f6.labelOffset + f6.labelDirection * S, rotation: O.rotation, silent: z3, z2: 10 + (Z.level || 0), style: Zd(pe, { text: fe, align: pe.getShallow("align", true) || O.textAlign, verticalAlign: pe.getShallow("verticalAlign", true) || pe.getShallow("baseline", true) || O.textVerticalAlign, fill: jo(Le) ? Le(d4.type === "category" ? _e : d4.type === "value" ? oe + "" : oe, ee) : Le }) });
            if (Xe.anid = "label_" + oe, H) {
              var Ye = KR.makeAxisEventDataBase(n6);
              Ye.targetType = "axisLabel", Ye.value = _e, Ye.tickIndex = ee, d4.type === "category" && (Ye.dataIndex = oe), qo(Xe).eventData = Ye;
            }
            a.add(Xe), Xe.updateTransform(), V.push(Xe), s.add(Xe), Xe.decomposeTransform();
          }), V;
        }
      }
      var NE = KR;
      function V7t(s, a) {
        var n6 = { axesInfo: {}, seriesInvolved: false, coordSysAxesInfo: {}, coordSysMap: {} };
        return B7t(n6, s, a), n6.seriesInvolved && j7t(n6, s), n6;
      }
      function B7t(s, a, n6) {
        var f6 = a.getComponent("tooltip"), d4 = a.getComponent("axisPointer"), y4 = d4.get("link", true) || [], _ = [];
        gt(n6.getCoordinateSystems(), function(S) {
          if (!S.axisPointerEnabled)
            return;
          var T = $$(S.model), E = s.coordSysAxesInfo[T] = {};
          s.coordSysMap[T] = S;
          var O = S.model, R = O.getModel("tooltip", f6);
          if (gt(S.getAxes(), ks(Z, false, null)), S.getTooltipAxes && f6 && R.get("show")) {
            var V = R.get("trigger") === "axis", z3 = R.get(["axisPointer", "type"]) === "cross", H = S.getTooltipAxes(R.get(["axisPointer", "axis"]));
            (V || z3) && gt(H.baseAxes, ks(Z, z3 ? "cross" : true, V)), z3 && gt(H.otherAxes, ks(Z, "cross", false));
          }
          function Z(ee, oe, fe) {
            var _e = fe.model.getModel("axisPointer", d4), pe = _e.get("show");
            if (!(!pe || pe === "auto" && !ee && !vSe(_e))) {
              oe == null && (oe = _e.get("triggerTooltip")), _e = ee ? z7t(fe, R, d4, a, ee, oe) : _e;
              var Ve = _e.get("snap"), Le = $$(fe.model), je = oe || Ve || fe.type === "category", Xe = s.axesInfo[Le] = { key: Le, axis: fe, coordSys: S, axisPointerModel: _e, triggerTooltip: oe, involveSeries: je, snap: Ve, useHandle: vSe(_e), seriesModels: [], linkGroup: null };
              E[Le] = Xe, s.seriesInvolved = s.seriesInvolved || je;
              var Ye = G7t(y4, fe);
              if (Ye != null) {
                var rt2 = _[Ye] || (_[Ye] = { axesInfo: {} });
                rt2.axesInfo[Le] = Xe, rt2.mapper = y4[Ye].mapper, Xe.linkGroup = rt2;
              }
            }
          }
        });
      }
      function z7t(s, a, n6, f6, d4, y4) {
        var _ = a.getModel("axisPointer"), S = ["type", "snap", "lineStyle", "shadowStyle", "label", "animation", "animationDurationUpdate", "animationEasingUpdate", "z"], T = {};
        gt(S, function(V) {
          T[V] = Bo(_.get(V));
        }), T.snap = s.type !== "category" && !!y4, _.get("type") === "cross" && (T.type = "line");
        var E = T.label || (T.label = {});
        if (E.show == null && (E.show = false), d4 === "cross") {
          var O = _.get(["label", "show"]);
          if (E.show = O != null ? O : true, !y4) {
            var R = T.lineStyle = _.get("crossStyle");
            R && zo(E, R.textStyle);
          }
        }
        return s.model.getModel("axisPointer", new Sh(T, n6, f6));
      }
      function j7t(s, a) {
        a.eachSeries(function(n6) {
          var f6 = n6.coordinateSystem, d4 = n6.get(["tooltip", "trigger"], true), y4 = n6.get(["tooltip", "show"], true);
          !f6 || d4 === "none" || d4 === false || d4 === "item" || y4 === false || n6.get(["axisPointer", "show"], true) === false || gt(s.coordSysAxesInfo[$$(f6.model)], function(_) {
            var S = _.axis;
            f6.getAxis(S.dim) === S && (_.seriesModels.push(n6), _.seriesDataCount == null && (_.seriesDataCount = 0), _.seriesDataCount += n6.getData().count());
          });
        });
      }
      function G7t(s, a) {
        for (var n6 = a.model, f6 = a.dim, d4 = 0; d4 < s.length; d4++) {
          var y4 = s[d4] || {};
          if (pSe(y4[f6 + "AxisId"], n6.id) || pSe(y4[f6 + "AxisIndex"], n6.componentIndex) || pSe(y4[f6 + "AxisName"], n6.name))
            return d4;
        }
      }
      function pSe(s, a) {
        return s === "all" || Di(s) && Ns(s, a) >= 0 || s === a;
      }
      function H7t(s) {
        var a = dSe(s);
        if (a) {
          var n6 = a.axisPointerModel, f6 = a.axis.scale, d4 = n6.option, y4 = n6.get("status"), _ = n6.get("value");
          _ != null && (_ = f6.parse(_));
          var S = vSe(n6);
          y4 == null && (d4.status = S ? "show" : "hide");
          var T = f6.getExtent().slice();
          T[0] > T[1] && T.reverse(), (_ == null || _ > T[1]) && (_ = T[1]), _ < T[0] && (_ = T[0]), d4.value = _, S && (d4.status = a.axis.scale.isBlank() ? "hide" : "show");
        }
      }
      function dSe(s) {
        var a = (s.ecModel.getComponent("axisPointer") || {}).coordSysAxesInfo;
        return a && a.axesInfo[$$(s)];
      }
      function W7t(s) {
        var a = dSe(s);
        return a && a.axisPointerModel;
      }
      function vSe(s) {
        return !!s.get(["handle", "show"]);
      }
      function $$(s) {
        return s.type + "||" + s.id;
      }
      var _qe = {}, U7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          this.axisPointerClass && H7t(n6), s.prototype.render.apply(this, arguments), this._doUpdateAxisPointerClass(n6, d4, true);
        }, a.prototype.updateAxisPointer = function(n6, f6, d4, y4) {
          this._doUpdateAxisPointerClass(n6, d4, false);
        }, a.prototype.remove = function(n6, f6) {
          var d4 = this._axisPointer;
          d4 && d4.remove(f6);
        }, a.prototype.dispose = function(n6, f6) {
          this._disposeAxisPointer(f6), s.prototype.dispose.apply(this, arguments);
        }, a.prototype._doUpdateAxisPointerClass = function(n6, f6, d4) {
          var y4 = a.getAxisPointerClass(this.axisPointerClass);
          if (y4) {
            var _ = W7t(n6);
            _ ? (this._axisPointer || (this._axisPointer = new y4())).render(n6, _, f6, d4) : this._disposeAxisPointer(f6);
          }
        }, a.prototype._disposeAxisPointer = function(n6) {
          this._axisPointer && this._axisPointer.dispose(n6), this._axisPointer = null;
        }, a.registerAxisPointerClass = function(n6, f6) {
          _qe[n6] = f6;
        }, a.getAxisPointerClass = function(n6) {
          return n6 && _qe[n6];
        }, a.type = "axis", a;
      }(sd), ZR = U7t, gSe = hu();
      function xqe(s, a, n6, f6) {
        var d4 = n6.axis;
        if (!d4.scale.isBlank()) {
          var y4 = n6.getModel("splitArea"), _ = y4.getModel("areaStyle"), S = _.get("color"), T = f6.coordinateSystem.getRect(), E = d4.getTicksCoords({ tickModel: y4, clamp: true });
          if (E.length) {
            var O = S.length, R = gSe(s).splitAreaColors, V = ro(), z3 = 0;
            if (R)
              for (var H = 0; H < E.length; H++) {
                var Z = R.get(E[H].tickValue);
                if (Z != null) {
                  z3 = (Z + (O - 1) * H) % O;
                  break;
                }
              }
            var ee = d4.toGlobalCoord(E[0].coord), oe = _.getAreaStyle();
            S = Di(S) ? S : [S];
            for (var H = 1; H < E.length; H++) {
              var fe = d4.toGlobalCoord(E[H].coord), _e = void 0, pe = void 0, Ve = void 0, Le = void 0;
              d4.isHorizontal() ? (_e = ee, pe = T.y, Ve = fe - _e, Le = T.height, ee = _e + Ve) : (_e = T.x, pe = ee, Ve = T.width, Le = fe - pe, ee = pe + Le);
              var je = E[H - 1].tickValue;
              je != null && V.set(je, z3), a.add(new xu({ anid: je != null ? "area_" + je : null, shape: { x: _e, y: pe, width: Ve, height: Le }, style: zo({ fill: S[z3] }, oe), autoBatch: true, silent: true })), z3 = (z3 + 1) % O;
            }
            gSe(s).splitAreaColors = V;
          }
        }
      }
      function wqe(s) {
        gSe(s).splitAreaColors = null;
      }
      var q7t = ["axisLine", "axisTickLabel", "axisName"], $7t = ["splitArea", "splitLine", "minorSplitLine"], Sqe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.axisPointerClass = "CartesianAxisPointer", n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          this.group.removeAll();
          var _ = this._axisGroup;
          if (this._axisGroup = new fs(), this.group.add(this._axisGroup), !!n6.get("show")) {
            var S = n6.getCoordSysModel(), T = cSe(S, n6), E = new NE(n6, ei({ handleAutoShown: function(R) {
              for (var V = S.coordinateSystem.getCartesians(), z3 = 0; z3 < V.length; z3++)
                if (Ewe(V[z3].getOtherAxis(n6.axis).scale))
                  return true;
              return false;
            } }, T));
            gt(q7t, E.add, E), this._axisGroup.add(E.getGroup()), gt($7t, function(R) {
              n6.get([R, "show"]) && X7t[R](this, this._axisGroup, n6, S);
            }, this);
            var O = y4 && y4.type === "changeAxisOrder" && y4.isInitSort;
            O || $l(_, this._axisGroup, n6), s.prototype.render.call(this, n6, f6, d4, y4);
          }
        }, a.prototype.remove = function() {
          wqe(this);
        }, a.type = "cartesianAxis", a;
      }(ZR), X7t = { splitLine: function(s, a, n6, f6) {
        var d4 = n6.axis;
        if (!d4.scale.isBlank()) {
          var y4 = n6.getModel("splitLine"), _ = y4.getModel("lineStyle"), S = _.get("color");
          S = Di(S) ? S : [S];
          for (var T = f6.coordinateSystem.getRect(), E = d4.isHorizontal(), O = 0, R = d4.getTicksCoords({ tickModel: y4 }), V = [], z3 = [], H = _.getLineStyle(), Z = 0; Z < R.length; Z++) {
            var ee = d4.toGlobalCoord(R[Z].coord);
            E ? (V[0] = ee, V[1] = T.y, z3[0] = ee, z3[1] = T.y + T.height) : (V[0] = T.x, V[1] = ee, z3[0] = T.x + T.width, z3[1] = ee);
            var oe = O++ % S.length, fe = R[Z].tickValue;
            a.add(new Jv({ anid: fe != null ? "line_" + R[Z].tickValue : null, subPixelOptimize: true, autoBatch: true, shape: { x1: V[0], y1: V[1], x2: z3[0], y2: z3[1] }, style: zo({ stroke: S[oe] }, H), silent: true }));
          }
        }
      }, minorSplitLine: function(s, a, n6, f6) {
        var d4 = n6.axis, y4 = n6.getModel("minorSplitLine"), _ = y4.getModel("lineStyle"), S = f6.coordinateSystem.getRect(), T = d4.isHorizontal(), E = d4.getMinorTicksCoords();
        if (E.length)
          for (var O = [], R = [], V = _.getLineStyle(), z3 = 0; z3 < E.length; z3++)
            for (var H = 0; H < E[z3].length; H++) {
              var Z = d4.toGlobalCoord(E[z3][H].coord);
              T ? (O[0] = Z, O[1] = S.y, R[0] = Z, R[1] = S.y + S.height) : (O[0] = S.x, O[1] = Z, R[0] = S.x + S.width, R[1] = Z), a.add(new Jv({ anid: "minor_line_" + E[z3][H].tickValue, subPixelOptimize: true, autoBatch: true, shape: { x1: O[0], y1: O[1], x2: R[0], y2: R[1] }, style: V, silent: true }));
            }
      }, splitArea: function(s, a, n6, f6) {
        xqe(s, a, n6, f6);
      } }, Cqe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "xAxis", a;
      }(Sqe), Y7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = Cqe.type, n6;
        }
        return a.type = "yAxis", a;
      }(Sqe), K7t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "grid", n6;
        }
        return a.prototype.render = function(n6, f6) {
          this.group.removeAll(), n6.get("show") && this.group.add(new xu({ shape: n6.coordinateSystem.getRect(), style: zo({ fill: n6.get("backgroundColor") }, n6.getItemStyle()), silent: true, z2: -1 }));
        }, a.type = "grid", a;
      }(sd), Mqe = { offset: 0 };
      function Tqe(s) {
        s.registerComponentView(K7t), s.registerComponentModel(b7t), s.registerCoordinateSystem("cartesian2d", O7t), X7(s, "x", sSe, Mqe), X7(s, "y", sSe, Mqe), s.registerComponentView(Cqe), s.registerComponentView(Y7t), s.registerPreprocessor(function(a) {
          a.xAxis && a.yAxis && !a.grid && (a.grid = {});
        });
      }
      function Z7t(s) {
        Il(Tqe), s.registerSeriesModel(f7t), s.registerChartView(y7t), s.registerLayout(W$("scatter"));
      }
      function J7t(s) {
        s.eachSeriesByType("radar", function(a) {
          var n6 = a.getData(), f6 = [], d4 = a.coordinateSystem;
          if (d4) {
            var y4 = d4.getIndicatorAxes();
            gt(y4, function(_, S) {
              n6.each(n6.mapDimension(y4[S].dim), function(T, E) {
                f6[E] = f6[E] || [];
                var O = d4.dataToPoint(T, S);
                f6[E][S] = Aqe(O) ? O : Iqe(d4);
              });
            }), n6.each(function(_) {
              var S = fbe(f6[_], function(T) {
                return Aqe(T);
              }) || Iqe(d4);
              f6[_].push(S.slice()), n6.setItemLayout(_, f6[_]);
            });
          }
        });
      }
      function Aqe(s) {
        return !isNaN(s[0]) && !isNaN(s[1]);
      }
      function Iqe(s) {
        return [s.cx, s.cy];
      }
      function Q7t(s) {
        var a = s.polar;
        if (a) {
          Di(a) || (a = [a]);
          var n6 = [];
          gt(a, function(f6, d4) {
            f6.indicator ? (f6.type && !f6.shape && (f6.shape = f6.type), s.radar = s.radar || [], Di(s.radar) || (s.radar = [s.radar]), s.radar.push(f6)) : n6.push(f6);
          }), s.polar = n6;
        }
        gt(s.series, function(f6) {
          f6 && f6.type === "radar" && f6.polarIndex && (f6.radarIndex = f6.polarIndex);
        });
      }
      var eVt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.coordinateSystem, _ = this.group, S = n6.getData(), T = this._data;
          function E(V, z3) {
            var H = V.getItemVisual(z3, "symbol") || "circle";
            if (H !== "none") {
              var Z = x$(V.getItemVisual(z3, "symbolSize")), ee = bv(H, -1, -1, 2, 2), oe = V.getItemVisual(z3, "symbolRotate") || 0;
              return ee.attr({ style: { strokeNoScale: true }, z2: 100, scaleX: Z[0] / 2, scaleY: Z[1] / 2, rotation: oe * Math.PI / 180 || 0 }), ee;
            }
          }
          function O(V, z3, H, Z, ee, oe) {
            H.removeAll();
            for (var fe = 0; fe < z3.length - 1; fe++) {
              var _e = E(Z, ee);
              _e && (_e.__dimIdx = fe, V[fe] ? (_e.setPosition(V[fe]), i$[oe ? "initProps" : "updateProps"](_e, { x: z3[fe][0], y: z3[fe][1] }, n6, ee)) : _e.setPosition(z3[fe]), H.add(_e));
            }
          }
          function R(V) {
            return Pi(V, function(z3) {
              return [y4.cx, y4.cy];
            });
          }
          S.diff(T).add(function(V) {
            var z3 = S.getItemLayout(V);
            if (z3) {
              var H = new T0(), Z = new zm(), ee = { shape: { points: z3 } };
              H.shape.points = R(z3), Z.shape.points = R(z3), $h(H, ee, n6, V), $h(Z, ee, n6, V);
              var oe = new fs(), fe = new fs();
              oe.add(Z), oe.add(H), oe.add(fe), O(Z.shape.points, z3, fe, S, V, true), S.setItemGraphicEl(V, oe);
            }
          }).update(function(V, z3) {
            var H = T.getItemGraphicEl(z3), Z = H.childAt(0), ee = H.childAt(1), oe = H.childAt(2), fe = { shape: { points: S.getItemLayout(V) } };
            !fe.shape.points || (O(Z.shape.points, fe.shape.points, oe, S, V, false), ox(ee), ox(Z), ku(Z, fe, n6), ku(ee, fe, n6), S.setItemGraphicEl(V, H));
          }).remove(function(V) {
            _.remove(T.getItemGraphicEl(V));
          }).execute(), S.eachItemGraphicEl(function(V, z3) {
            var H = S.getItemModel(z3), Z = V.childAt(0), ee = V.childAt(1), oe = V.childAt(2), fe = S.getItemVisual(z3, "style"), _e = fe.fill;
            _.add(V), Z.useStyle(zo(H.getModel("lineStyle").getLineStyle(), { fill: "none", stroke: _e })), Pg(Z, H, "lineStyle"), Pg(ee, H, "areaStyle");
            var pe = H.getModel("areaStyle"), Ve = pe.isEmpty() && pe.parentModel.isEmpty();
            ee.ignore = Ve, gt(["emphasis", "select", "blur"], function(Xe) {
              var Ye = H.getModel([Xe, "areaStyle"]), rt2 = Ye.isEmpty() && Ye.parentModel.isEmpty();
              ee.ensureState(Xe).ignore = rt2 && Ve;
            }), ee.useStyle(zo(pe.getAreaStyle(), { fill: _e, opacity: 0.7, decal: fe.decal }));
            var Le = H.getModel("emphasis"), je = Le.getModel("itemStyle").getItemStyle();
            oe.eachChild(function(Xe) {
              if (Xe instanceof Zv) {
                var Ye = Xe.style;
                Xe.useStyle(ei({ image: Ye.image, x: Ye.x, y: Ye.y, width: Ye.width, height: Ye.height }, fe));
              } else
                Xe.useStyle(fe), Xe.setColor(_e), Xe.style.strokeNoScale = true;
              var rt2 = Xe.ensureState("emphasis");
              rt2.style = Bo(je);
              var ut = S.getStore().get(S.getDimensionIndex(Xe.__dimIdx), z3);
              (ut == null || isNaN(ut)) && (ut = ""), Gm(Xe, E0(H), { labelFetcher: S.hostModel, labelDataIndex: z3, labelDimIndex: Xe.__dimIdx, defaultText: ut, inheritColor: _e, defaultOpacity: fe.opacity });
            }), Up(V, Le.get("focus"), Le.get("blurScope"), Le.get("disabled"));
          }), this._data = S;
        }, a.prototype.remove = function() {
          this.group.removeAll(), this._data = null;
        }, a.type = "radar", a;
      }(Ch), tVt = eVt, nVt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.hasSymbolVisual = true, n6;
        }
        return a.prototype.init = function(n6) {
          s.prototype.init.apply(this, arguments), this.legendVisualProvider = new q$(Za(this.getData, this), Za(this.getRawData, this));
        }, a.prototype.getInitialData = function(n6, f6) {
          return $7(this, { generateCoord: "indicator_", generateCoordCount: 1 / 0 });
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          var y4 = this.getData(), _ = this.coordinateSystem, S = _.getIndicatorAxes(), T = this.getData().getName(n6), E = T === "" ? this.name : T, O = zGe(this, n6);
          return Rg("section", { header: E, sortBlocks: true, blocks: Pi(S, function(R) {
            var V = y4.get(y4.mapDimension(R.dim), n6);
            return Rg("nameValue", { markerType: "subItem", markerColor: O, name: R.name, value: V, sortParam: V });
          }) });
        }, a.prototype.getTooltipPosition = function(n6) {
          if (n6 != null) {
            for (var f6 = this.getData(), d4 = this.coordinateSystem, y4 = f6.getValues(Pi(d4.dimensions, function(E) {
              return f6.mapDimension(E);
            }), n6), _ = 0, S = y4.length; _ < S; _++)
              if (!isNaN(y4[_])) {
                var T = d4.getIndicatorAxes();
                return d4.coordToPoint(T[_].dataToCoord(y4[_]), _);
              }
          }
        }, a.type = "series.radar", a.dependencies = ["radar"], a.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "radar", legendHoverLink: true, radarIndex: 0, lineStyle: { width: 2, type: "solid", join: "round" }, label: { position: "top" }, symbolSize: 8 }, a;
      }(Cp), rVt = nVt, X$ = lqe.value;
      function Toe(s, a) {
        return zo({ show: a }, s);
      }
      var iVt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.optionUpdated = function() {
          var n6 = this.get("boundaryGap"), f6 = this.get("splitNumber"), d4 = this.get("scale"), y4 = this.get("axisLine"), _ = this.get("axisTick"), S = this.get("axisLabel"), T = this.get("axisName"), E = this.get(["axisName", "show"]), O = this.get(["axisName", "formatter"]), R = this.get("axisNameGap"), V = this.get("triggerEvent"), z3 = Pi(this.get("indicator") || [], function(H) {
            H.max != null && H.max > 0 && !H.min ? H.min = 0 : H.min != null && H.min < 0 && !H.max && (H.max = 0);
            var Z = T;
            H.color != null && (Z = zo({ color: H.color }, T));
            var ee = Ms(Bo(H), { boundaryGap: n6, splitNumber: f6, scale: d4, axisLine: y4, axisTick: _, axisLabel: S, name: H.text, showName: E, nameLocation: "end", nameGap: R, nameTextStyle: Z, triggerEvent: V }, false);
            if (E || (ee.name = ""), Wa(O)) {
              var oe = ee.name;
              ee.name = O.replace("{value}", oe != null ? oe : "");
            } else
              jo(O) && (ee.name = O(ee.name, ee));
            var fe = new Sh(ee, null, this.ecModel);
            return nd(fe, R$.prototype), fe.mainType = "radar", fe.componentIndex = this.componentIndex, fe;
          }, this);
          this._indicatorModels = z3;
        }, a.prototype.getIndicatorModels = function() {
          return this._indicatorModels;
        }, a.type = "radar", a.defaultOption = { z: 0, center: ["50%", "50%"], radius: "75%", startAngle: 90, axisName: { show: true }, boundaryGap: [0, 0], splitNumber: 5, axisNameGap: 15, scale: false, shape: "polygon", axisLine: Ms({ lineStyle: { color: "#bbb" } }, X$.axisLine), axisLabel: Toe(X$.axisLabel, false), axisTick: Toe(X$.axisTick, false), splitLine: Toe(X$.splitLine, true), splitArea: Toe(X$.splitArea, true), indicator: [] }, a;
      }(oc), aVt = iVt, oVt = ["axisLine", "axisTickLabel", "axisName"], sVt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = this.group;
          y4.removeAll(), this._buildAxes(n6), this._buildSplitLineAndArea(n6);
        }, a.prototype._buildAxes = function(n6) {
          var f6 = n6.coordinateSystem, d4 = f6.getIndicatorAxes(), y4 = Pi(d4, function(_) {
            var S = _.model.get("showName") ? _.name : "", T = new NE(_.model, { axisName: S, position: [f6.cx, f6.cy], rotation: _.angle, labelDirection: -1, tickDirection: -1, nameDirection: 1 });
            return T;
          });
          gt(y4, function(_) {
            gt(oVt, _.add, _), this.group.add(_.getGroup());
          }, this);
        }, a.prototype._buildSplitLineAndArea = function(n6) {
          var f6 = n6.coordinateSystem, d4 = f6.getIndicatorAxes();
          if (!d4.length)
            return;
          var y4 = n6.get("shape"), _ = n6.getModel("splitLine"), S = n6.getModel("splitArea"), T = _.getModel("lineStyle"), E = S.getModel("areaStyle"), O = _.get("show"), R = S.get("show"), V = T.get("color"), z3 = E.get("color"), H = Di(V) ? V : [V], Z = Di(z3) ? z3 : [z3], ee = [], oe = [];
          function fe(Qt, Nt, er) {
            var un = er % Nt.length;
            return Qt[un] = Qt[un] || [], un;
          }
          if (y4 === "circle")
            for (var _e = d4[0].getTicksCoords(), pe = f6.cx, Ve = f6.cy, Le = 0; Le < _e.length; Le++) {
              if (O) {
                var je = fe(ee, H, Le);
                ee[je].push(new cS({ shape: { cx: pe, cy: Ve, r: _e[Le].coord } }));
              }
              if (R && Le < _e.length - 1) {
                var je = fe(oe, Z, Le);
                oe[je].push(new g7({ shape: { cx: pe, cy: Ve, r0: _e[Le].coord, r: _e[Le + 1].coord } }));
              }
            }
          else
            for (var Xe, Ye = Pi(d4, function(Nt, er) {
              var un = Nt.getTicksCoords();
              return Xe = Xe == null ? un.length - 1 : Math.min(un.length - 1, Xe), Pi(un, function(pn) {
                return f6.coordToPoint(pn.coord, er);
              });
            }), rt2 = [], Le = 0; Le <= Xe; Le++) {
              for (var ut = [], wt = 0; wt < d4.length; wt++)
                ut.push(Ye[wt][Le]);
              if (ut[0] && ut.push(ut[0].slice()), O) {
                var je = fe(ee, H, Le);
                ee[je].push(new zm({ shape: { points: ut } }));
              }
              if (R && rt2) {
                var je = fe(oe, Z, Le - 1);
                oe[je].push(new T0({ shape: { points: ut.concat(rt2) } }));
              }
              rt2 = ut.slice().reverse();
            }
          var dt = T.getLineStyle(), Gt = E.getAreaStyle();
          gt(oe, function(Qt, Nt) {
            this.group.add(en(Qt, { style: zo({ stroke: "none", fill: Z[Nt % Z.length] }, Gt), silent: true }));
          }, this), gt(ee, function(Qt, Nt) {
            this.group.add(en(Qt, { style: zo({ fill: "none", stroke: H[Nt % H.length] }, dt), silent: true }));
          }, this);
        }, a.type = "radar", a;
      }(sd), lVt = sVt, uVt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this, n6, f6, d4) || this;
          return y4.type = "value", y4.angle = 0, y4.name = "", y4;
        }
        return a;
      }(xC), cVt = uVt, fVt = function() {
        function s(a, n6, f6) {
          this.dimensions = [], this._model = a, this._indicatorAxes = Pi(a.getIndicatorModels(), function(d4, y4) {
            var _ = "indicator_" + y4, S = new cVt(_, new n3());
            return S.name = d4.get("name"), S.model = d4, d4.axis = S, this.dimensions.push(_), S;
          }, this), this.resize(a, f6);
        }
        return s.prototype.getIndicatorAxes = function() {
          return this._indicatorAxes;
        }, s.prototype.dataToPoint = function(a, n6) {
          var f6 = this._indicatorAxes[n6];
          return this.coordToPoint(f6.dataToCoord(a), n6);
        }, s.prototype.coordToPoint = function(a, n6) {
          var f6 = this._indicatorAxes[n6], d4 = f6.angle, y4 = this.cx + a * Math.cos(d4), _ = this.cy - a * Math.sin(d4);
          return [y4, _];
        }, s.prototype.pointToData = function(a) {
          var n6 = a[0] - this.cx, f6 = a[1] - this.cy, d4 = Math.sqrt(n6 * n6 + f6 * f6);
          n6 /= d4, f6 /= d4;
          for (var y4 = Math.atan2(-f6, n6), _ = 1 / 0, S, T = -1, E = 0; E < this._indicatorAxes.length; E++) {
            var O = this._indicatorAxes[E], R = Math.abs(y4 - O.angle);
            R < _ && (S = O, T = E, _ = R);
          }
          return [T, +(S && S.coordToData(d4))];
        }, s.prototype.resize = function(a, n6) {
          var f6 = a.get("center"), d4 = n6.getWidth(), y4 = n6.getHeight(), _ = Math.min(d4, y4) / 2;
          this.cx = Ia(f6[0], d4), this.cy = Ia(f6[1], y4), this.startAngle = a.get("startAngle") * Math.PI / 180;
          var S = a.get("radius");
          (Wa(S) || ac(S)) && (S = [0, S]), this.r0 = Ia(S[0], _), this.r = Ia(S[1], _), gt(this._indicatorAxes, function(T, E) {
            T.setExtent(this.r0, this.r);
            var O = this.startAngle + E * Math.PI * 2 / this._indicatorAxes.length;
            O = Math.atan2(Math.sin(O), Math.cos(O)), T.angle = O;
          }, this);
        }, s.prototype.update = function(a, n6) {
          var f6 = this._indicatorAxes, d4 = this._model;
          gt(f6, function(S) {
            S.scale.setExtent(1 / 0, -1 / 0);
          }), a.eachSeriesByType("radar", function(S, T) {
            if (!(S.get("coordinateSystem") !== "radar" || a.getComponent("radar", S.get("radarIndex")) !== d4)) {
              var E = S.getData();
              gt(f6, function(O) {
                O.scale.unionExtentFromData(E, E.mapDimension(O.dim));
              });
            }
          }, this);
          var y4 = d4.get("splitNumber"), _ = new n3();
          _.setExtent(0, y4), _.setInterval(1), gt(f6, function(S, T) {
            pqe(S.scale, S.model, _);
          });
        }, s.prototype.convertToPixel = function(a, n6, f6) {
          return console.warn("Not implemented."), null;
        }, s.prototype.convertFromPixel = function(a, n6, f6) {
          return console.warn("Not implemented."), null;
        }, s.prototype.containPoint = function(a) {
          return console.warn("Not implemented."), false;
        }, s.create = function(a, n6) {
          var f6 = [];
          return a.eachComponent("radar", function(d4) {
            var y4 = new s(d4, a, n6);
            f6.push(y4), d4.coordinateSystem = y4;
          }), a.eachSeriesByType("radar", function(d4) {
            d4.get("coordinateSystem") === "radar" && (d4.coordinateSystem = f6[d4.get("radarIndex") || 0]);
          }), f6;
        }, s.dimensions = [], s;
      }(), hVt = fVt;
      function pVt(s) {
        s.registerCoordinateSystem("radar", hVt), s.registerComponentModel(aVt), s.registerComponentView(lVt), s.registerVisual({ seriesType: "radar", reset: function(a) {
          var n6 = a.getData();
          n6.each(function(f6) {
            n6.setItemVisual(f6, "legendIcon", "roundRect");
          }), n6.setVisual("legendIcon", "roundRect");
        } });
      }
      function dVt(s) {
        Il(pVt), s.registerChartView(tVt), s.registerSeriesModel(rVt), s.registerLayout(J7t), s.registerProcessor(U$("radar")), s.registerPreprocessor(Q7t);
      }
      var Eqe = "\0_ec_interaction_mutex";
      function vVt(s, a, n6) {
        var f6 = ySe(s);
        f6[a] = n6;
      }
      function gVt(s, a, n6) {
        var f6 = ySe(s), d4 = f6[a];
        d4 === n6 && (f6[a] = null);
      }
      function Dqe(s, a) {
        return !!ySe(s)[a];
      }
      function ySe(s) {
        return s[Eqe] || (s[Eqe] = {});
      }
      LT({ type: "takeGlobalCursor", event: "globalCursorTaken", update: "update" }, rd);
      var yVt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this) || this;
          f6._zr = n6;
          var d4 = Za(f6._mousedownHandler, f6), y4 = Za(f6._mousemoveHandler, f6), _ = Za(f6._mouseupHandler, f6), S = Za(f6._mousewheelHandler, f6), T = Za(f6._pinchHandler, f6);
          return f6.enable = function(E, O) {
            this.disable(), this._opt = zo(Bo(O) || {}, { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), E == null && (E = true), (E === true || E === "move" || E === "pan") && (n6.on("mousedown", d4), n6.on("mousemove", y4), n6.on("mouseup", _)), (E === true || E === "scale" || E === "zoom") && (n6.on("mousewheel", S), n6.on("pinch", T));
          }, f6.disable = function() {
            n6.off("mousedown", d4), n6.off("mousemove", y4), n6.off("mouseup", _), n6.off("mousewheel", S), n6.off("pinch", T);
          }, f6;
        }
        return a.prototype.isDragging = function() {
          return this._dragging;
        }, a.prototype.isPinching = function() {
          return this._pinching;
        }, a.prototype.setPointerChecker = function(n6) {
          this.pointerChecker = n6;
        }, a.prototype.dispose = function() {
          this.disable();
        }, a.prototype._mousedownHandler = function(n6) {
          if (!(iC(n6) || n6.target && n6.target.draggable)) {
            var f6 = n6.offsetX, d4 = n6.offsetY;
            this.pointerChecker && this.pointerChecker(n6, f6, d4) && (this._x = f6, this._y = d4, this._dragging = true);
          }
        }, a.prototype._mousemoveHandler = function(n6) {
          if (!(!this._dragging || !Aoe("moveOnMouseMove", n6, this._opt) || n6.gestureEvent === "pinch" || Dqe(this._zr, "globalPan"))) {
            var f6 = n6.offsetX, d4 = n6.offsetY, y4 = this._x, _ = this._y, S = f6 - y4, T = d4 - _;
            this._x = f6, this._y = d4, this._opt.preventDefaultMouseMove && Jw(n6.event), kqe(this, "pan", "moveOnMouseMove", n6, { dx: S, dy: T, oldX: y4, oldY: _, newX: f6, newY: d4, isAvailableBehavior: null });
          }
        }, a.prototype._mouseupHandler = function(n6) {
          iC(n6) || (this._dragging = false);
        }, a.prototype._mousewheelHandler = function(n6) {
          var f6 = Aoe("zoomOnMouseWheel", n6, this._opt), d4 = Aoe("moveOnMouseWheel", n6, this._opt), y4 = n6.wheelDelta, _ = Math.abs(y4), S = n6.offsetX, T = n6.offsetY;
          if (!(y4 === 0 || !f6 && !d4)) {
            if (f6) {
              var E = _ > 3 ? 1.4 : _ > 1 ? 1.2 : 1.1, O = y4 > 0 ? E : 1 / E;
              mSe(this, "zoom", "zoomOnMouseWheel", n6, { scale: O, originX: S, originY: T, isAvailableBehavior: null });
            }
            if (d4) {
              var R = Math.abs(y4), V = (y4 > 0 ? 1 : -1) * (R > 3 ? 0.4 : R > 1 ? 0.15 : 0.05);
              mSe(this, "scrollMove", "moveOnMouseWheel", n6, { scrollDelta: V, originX: S, originY: T, isAvailableBehavior: null });
            }
          }
        }, a.prototype._pinchHandler = function(n6) {
          if (!Dqe(this._zr, "globalPan")) {
            var f6 = n6.pinchScale > 1 ? 1.1 : 0.9090909090909091;
            mSe(this, "zoom", null, n6, { scale: f6, originX: n6.pinchX, originY: n6.pinchY, isAvailableBehavior: null });
          }
        }, a;
      }(Dm);
      function mSe(s, a, n6, f6, d4) {
        s.pointerChecker && s.pointerChecker(f6, d4.originX, d4.originY) && (Jw(f6.event), kqe(s, a, n6, f6, d4));
      }
      function kqe(s, a, n6, f6, d4) {
        d4.isAvailableBehavior = Za(Aoe, null, n6, f6), s.trigger(a, d4);
      }
      function Aoe(s, a, n6) {
        var f6 = n6[s];
        return !s || f6 && (!Wa(f6) || a.event[f6 + "Key"]);
      }
      var Y$ = yVt;
      function bSe(s, a, n6) {
        var f6 = s.target;
        f6.x += a, f6.y += n6, f6.dirty();
      }
      function _Se(s, a, n6, f6) {
        var d4 = s.target, y4 = s.zoomLimit, _ = s.zoom = s.zoom || 1;
        if (_ *= a, y4) {
          var S = y4.min || 0, T = y4.max || 1 / 0;
          _ = Math.max(Math.min(T, _), S);
        }
        var E = _ / s.zoom;
        s.zoom = _, d4.x -= (n6 - d4.x) * (E - 1), d4.y -= (f6 - d4.y) * (E - 1), d4.scaleX *= E, d4.scaleY *= E, d4.dirty();
      }
      var mVt = { axisPointer: 1, tooltip: 1, brush: 1 };
      function Ioe(s, a, n6) {
        var f6 = a.getComponentByElement(s.topTarget), d4 = f6 && f6.coordinateSystem;
        return f6 && f6 !== n6 && !mVt.hasOwnProperty(f6.mainType) && d4 && d4.model !== n6;
      }
      function Oqe(s) {
        if (Wa(s)) {
          var a = new DOMParser();
          s = a.parseFromString(s, "text/xml");
        }
        var n6 = s;
        for (n6.nodeType === 9 && (n6 = n6.firstChild); n6.nodeName.toLowerCase() !== "svg" || n6.nodeType !== 1; )
          n6 = n6.nextSibling;
        return n6;
      }
      var xSe, Eoe = { fill: "fill", stroke: "stroke", "stroke-width": "lineWidth", opacity: "opacity", "fill-opacity": "fillOpacity", "stroke-opacity": "strokeOpacity", "stroke-dasharray": "lineDash", "stroke-dashoffset": "lineDashOffset", "stroke-linecap": "lineCap", "stroke-linejoin": "lineJoin", "stroke-miterlimit": "miterLimit", "font-family": "fontFamily", "font-size": "fontSize", "font-style": "fontStyle", "font-weight": "fontWeight", "text-anchor": "textAlign", visibility: "visibility", display: "display" }, Pqe = Wl(Eoe), Doe = { "alignment-baseline": "textBaseline", "stop-color": "stopColor" }, Lqe = Wl(Doe), bVt = function() {
        function s() {
          this._defs = {}, this._root = null;
        }
        return s.prototype.parse = function(a, n6) {
          n6 = n6 || {};
          var f6 = Oqe(a);
          this._defsUsePending = [];
          var d4 = new fs();
          this._root = d4;
          var y4 = [], _ = f6.getAttribute("viewBox") || "", S = parseFloat(f6.getAttribute("width") || n6.width), T = parseFloat(f6.getAttribute("height") || n6.height);
          isNaN(S) && (S = null), isNaN(T) && (T = null), ux(f6, d4, null, true, false);
          for (var E = f6.firstChild; E; )
            this._parseNode(E, d4, y4, null, false, false), E = E.nextSibling;
          wVt(this._defs, this._defsUsePending), this._defsUsePending = [];
          var O, R;
          if (_) {
            var V = koe(_);
            V.length >= 4 && (O = { x: parseFloat(V[0] || 0), y: parseFloat(V[1] || 0), width: parseFloat(V[2]), height: parseFloat(V[3]) });
          }
          if (O && S != null && T != null && (R = Gqe(O, { x: 0, y: 0, width: S, height: T }), !n6.ignoreViewBox)) {
            var z3 = d4;
            d4 = new fs(), d4.add(z3), z3.scaleX = z3.scaleY = R.scale, z3.x = R.x, z3.y = R.y;
          }
          return !n6.ignoreRootClip && S != null && T != null && d4.setClipPath(new xu({ shape: { x: 0, y: 0, width: S, height: T } })), { root: d4, width: S, height: T, viewBoxRect: O, viewBoxTransform: R, named: y4 };
        }, s.prototype._parseNode = function(a, n6, f6, d4, y4, _) {
          var S = a.nodeName.toLowerCase(), T, E = d4;
          if (S === "defs" && (y4 = true), S === "text" && (_ = true), S === "defs" || S === "switch")
            T = n6;
          else {
            if (!y4) {
              var O = xSe[S];
              if (O && io(xSe, S)) {
                T = O.call(this, a, n6);
                var R = a.getAttribute("name");
                if (R) {
                  var V = { name: R, namedFrom: null, svgNodeTagLower: S, el: T };
                  f6.push(V), S === "g" && (E = V);
                } else
                  d4 && f6.push({ name: d4.name, namedFrom: d4, svgNodeTagLower: S, el: T });
                n6.add(T);
              }
            }
            var z3 = Rqe[S];
            if (z3 && io(Rqe, S)) {
              var H = z3.call(this, a), Z = a.getAttribute("id");
              Z && (this._defs[Z] = H);
            }
          }
          if (T && T.isGroup)
            for (var ee = a.firstChild; ee; )
              ee.nodeType === 1 ? this._parseNode(ee, T, f6, E, y4, _) : ee.nodeType === 3 && _ && this._parseText(ee, T), ee = ee.nextSibling;
        }, s.prototype._parseText = function(a, n6) {
          var f6 = new _R({ style: { text: a.textContent }, silent: true, x: this._textX || 0, y: this._textY || 0 });
          _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), _Vt(f6, n6);
          var d4 = f6.style, y4 = d4.fontSize;
          y4 && y4 < 9 && (d4.fontSize = 9, f6.scaleX *= y4 / 9, f6.scaleY *= y4 / 9);
          var _ = (d4.fontSize || d4.fontFamily) && [d4.fontStyle, d4.fontWeight, (d4.fontSize || 12) + "px", d4.fontFamily || "sans-serif"].join(" ");
          d4.font = _;
          var S = f6.getBoundingRect();
          return this._textX += S.width, n6.add(f6), f6;
        }, s.internalField = function() {
          xSe = { g: function(a, n6) {
            var f6 = new fs();
            return _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), f6;
          }, rect: function(a, n6) {
            var f6 = new xu();
            return _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), f6.setShape({ x: parseFloat(a.getAttribute("x") || "0"), y: parseFloat(a.getAttribute("y") || "0"), width: parseFloat(a.getAttribute("width") || "0"), height: parseFloat(a.getAttribute("height") || "0") }), f6.silent = true, f6;
          }, circle: function(a, n6) {
            var f6 = new cS();
            return _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), f6.setShape({ cx: parseFloat(a.getAttribute("cx") || "0"), cy: parseFloat(a.getAttribute("cy") || "0"), r: parseFloat(a.getAttribute("r") || "0") }), f6.silent = true, f6;
          }, line: function(a, n6) {
            var f6 = new Jv();
            return _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), f6.setShape({ x1: parseFloat(a.getAttribute("x1") || "0"), y1: parseFloat(a.getAttribute("y1") || "0"), x2: parseFloat(a.getAttribute("x2") || "0"), y2: parseFloat(a.getAttribute("y2") || "0") }), f6.silent = true, f6;
          }, ellipse: function(a, n6) {
            var f6 = new d7();
            return _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), f6.setShape({ cx: parseFloat(a.getAttribute("cx") || "0"), cy: parseFloat(a.getAttribute("cy") || "0"), rx: parseFloat(a.getAttribute("rx") || "0"), ry: parseFloat(a.getAttribute("ry") || "0") }), f6.silent = true, f6;
          }, polygon: function(a, n6) {
            var f6 = a.getAttribute("points"), d4;
            f6 && (d4 = Vqe(f6));
            var y4 = new T0({ shape: { points: d4 || [] }, silent: true });
            return _S(n6, y4), ux(a, y4, this._defsUsePending, false, false), y4;
          }, polyline: function(a, n6) {
            var f6 = a.getAttribute("points"), d4;
            f6 && (d4 = Vqe(f6));
            var y4 = new zm({ shape: { points: d4 || [] }, silent: true });
            return _S(n6, y4), ux(a, y4, this._defsUsePending, false, false), y4;
          }, image: function(a, n6) {
            var f6 = new Zv();
            return _S(n6, f6), ux(a, f6, this._defsUsePending, false, false), f6.setStyle({ image: a.getAttribute("xlink:href") || a.getAttribute("href"), x: +a.getAttribute("x"), y: +a.getAttribute("y"), width: +a.getAttribute("width"), height: +a.getAttribute("height") }), f6.silent = true, f6;
          }, text: function(a, n6) {
            var f6 = a.getAttribute("x") || "0", d4 = a.getAttribute("y") || "0", y4 = a.getAttribute("dx") || "0", _ = a.getAttribute("dy") || "0";
            this._textX = parseFloat(f6) + parseFloat(y4), this._textY = parseFloat(d4) + parseFloat(_);
            var S = new fs();
            return _S(n6, S), ux(a, S, this._defsUsePending, false, true), S;
          }, tspan: function(a, n6) {
            var f6 = a.getAttribute("x"), d4 = a.getAttribute("y");
            f6 != null && (this._textX = parseFloat(f6)), d4 != null && (this._textY = parseFloat(d4));
            var y4 = a.getAttribute("dx") || "0", _ = a.getAttribute("dy") || "0", S = new fs();
            return _S(n6, S), ux(a, S, this._defsUsePending, false, true), this._textX += parseFloat(y4), this._textY += parseFloat(_), S;
          }, path: function(a, n6) {
            var f6 = a.getAttribute("d") || "", d4 = sae(f6);
            return _S(n6, d4), ux(a, d4, this._defsUsePending, false, false), d4.silent = true, d4;
          } };
        }(), s;
      }(), Rqe = { lineargradient: function(s) {
        var a = parseInt(s.getAttribute("x1") || "0", 10), n6 = parseInt(s.getAttribute("y1") || "0", 10), f6 = parseInt(s.getAttribute("x2") || "10", 10), d4 = parseInt(s.getAttribute("y2") || "0", 10), y4 = new DR(a, n6, f6, d4);
        return Nqe(s, y4), Fqe(s, y4), y4;
      }, radialgradient: function(s) {
        var a = parseInt(s.getAttribute("cx") || "0", 10), n6 = parseInt(s.getAttribute("cy") || "0", 10), f6 = parseInt(s.getAttribute("r") || "0", 10), d4 = new e$(a, n6, f6);
        return Nqe(s, d4), Fqe(s, d4), d4;
      } };
      function Nqe(s, a) {
        var n6 = s.getAttribute("gradientUnits");
        n6 === "userSpaceOnUse" && (a.global = true);
      }
      function Fqe(s, a) {
        for (var n6 = s.firstChild; n6; ) {
          if (n6.nodeType === 1 && n6.nodeName.toLocaleLowerCase() === "stop") {
            var f6 = n6.getAttribute("offset"), d4 = void 0;
            f6 && f6.indexOf("%") > 0 ? d4 = parseInt(f6, 10) / 100 : f6 ? d4 = parseFloat(f6) : d4 = 0;
            var y4 = {};
            jqe(n6, y4, y4);
            var _ = y4.stopColor || n6.getAttribute("stop-color") || "#000000";
            a.colorStops.push({ offset: d4, color: _ });
          }
          n6 = n6.nextSibling;
        }
      }
      function _S(s, a) {
        s && s.__inheritedStyle && (a.__inheritedStyle || (a.__inheritedStyle = {}), zo(a.__inheritedStyle, s.__inheritedStyle));
      }
      function Vqe(s) {
        for (var a = koe(s), n6 = [], f6 = 0; f6 < a.length; f6 += 2) {
          var d4 = parseFloat(a[f6]), y4 = parseFloat(a[f6 + 1]);
          n6.push([d4, y4]);
        }
        return n6;
      }
      function ux(s, a, n6, f6, d4) {
        var y4 = a, _ = y4.__inheritedStyle = y4.__inheritedStyle || {}, S = {};
        s.nodeType === 1 && (MVt(s, a), jqe(s, _, S), f6 || TVt(s, _, S)), y4.style = y4.style || {}, _.fill != null && (y4.style.fill = Bqe(y4, "fill", _.fill, n6)), _.stroke != null && (y4.style.stroke = Bqe(y4, "stroke", _.stroke, n6)), gt(["lineWidth", "opacity", "fillOpacity", "strokeOpacity", "miterLimit", "fontSize"], function(T) {
          _[T] != null && (y4.style[T] = parseFloat(_[T]));
        }), gt(["lineDashOffset", "lineCap", "lineJoin", "fontWeight", "fontFamily", "fontStyle", "textAlign"], function(T) {
          _[T] != null && (y4.style[T] = _[T]);
        }), d4 && (y4.__selfStyle = S), _.lineDash && (y4.style.lineDash = Pi(koe(_.lineDash), function(T) {
          return parseFloat(T);
        })), (_.visibility === "hidden" || _.visibility === "collapse") && (y4.invisible = true), _.display === "none" && (y4.ignore = true);
      }
      function _Vt(s, a) {
        var n6 = a.__selfStyle;
        if (n6) {
          var f6 = n6.textBaseline, d4 = f6;
          !f6 || f6 === "auto" || f6 === "baseline" ? d4 = "alphabetic" : f6 === "before-edge" || f6 === "text-before-edge" ? d4 = "top" : f6 === "after-edge" || f6 === "text-after-edge" ? d4 = "bottom" : (f6 === "central" || f6 === "mathematical") && (d4 = "middle"), s.style.textBaseline = d4;
        }
        var y4 = a.__inheritedStyle;
        if (y4) {
          var _ = y4.textAlign, S = _;
          _ && (_ === "middle" && (S = "center"), s.style.textAlign = S);
        }
      }
      var xVt = /^url\(\s*#(.*?)\)/;
      function Bqe(s, a, n6, f6) {
        var d4 = n6 && n6.match(xVt);
        if (d4) {
          var y4 = wh(d4[1]);
          f6.push([s, a, y4]);
          return;
        }
        return n6 === "none" && (n6 = null), n6;
      }
      function wVt(s, a) {
        for (var n6 = 0; n6 < a.length; n6++) {
          var f6 = a[n6];
          f6[0].style[f6[1]] = s[f6[2]];
        }
      }
      var SVt = /-?([0-9]*\.)?[0-9]+([eE]-?[0-9]+)?/g;
      function koe(s) {
        return s.match(SVt) || [];
      }
      var CVt = /(translate|scale|rotate|skewX|skewY|matrix)\(([\-\s0-9\.eE,]*)\)/g, wSe = Math.PI / 180;
      function MVt(s, a) {
        var n6 = s.getAttribute("transform");
        if (n6) {
          n6 = n6.replace(/,/g, " ");
          var f6 = [], d4 = null;
          n6.replace(CVt, function(R, V, z3) {
            return f6.push(V, z3), "";
          });
          for (var y4 = f6.length - 1; y4 > 0; y4 -= 2) {
            var _ = f6[y4], S = f6[y4 - 1], T = koe(_);
            switch (d4 = d4 || Bb(), S) {
              case "translate":
                zb(d4, d4, [parseFloat(T[0]), parseFloat(T[1] || "0")]);
                break;
              case "scale":
                L9(d4, d4, [parseFloat(T[0]), parseFloat(T[1] || T[0])]);
                break;
              case "rotate":
                vT(d4, d4, -parseFloat(T[0]) * wSe);
                break;
              case "skewX":
                var E = Math.tan(parseFloat(T[0]) * wSe);
                cC(d4, [1, 0, E, 1, 0, 0], d4);
                break;
              case "skewY":
                var O = Math.tan(parseFloat(T[0]) * wSe);
                cC(d4, [1, O, 0, 1, 0, 0], d4);
                break;
              case "matrix":
                d4[0] = parseFloat(T[0]), d4[1] = parseFloat(T[1]), d4[2] = parseFloat(T[2]), d4[3] = parseFloat(T[3]), d4[4] = parseFloat(T[4]), d4[5] = parseFloat(T[5]);
                break;
            }
          }
          a.setLocalTransform(d4);
        }
      }
      var zqe = /([^\s:;]+)\s*:\s*([^:;]+)/g;
      function jqe(s, a, n6) {
        var f6 = s.getAttribute("style");
        if (f6) {
          zqe.lastIndex = 0;
          for (var d4; (d4 = zqe.exec(f6)) != null; ) {
            var y4 = d4[1], _ = io(Eoe, y4) ? Eoe[y4] : null;
            _ && (a[_] = d4[2]);
            var S = io(Doe, y4) ? Doe[y4] : null;
            S && (n6[S] = d4[2]);
          }
        }
      }
      function TVt(s, a, n6) {
        for (var f6 = 0; f6 < Pqe.length; f6++) {
          var d4 = Pqe[f6], y4 = s.getAttribute(d4);
          y4 != null && (a[Eoe[d4]] = y4);
        }
        for (var f6 = 0; f6 < Lqe.length; f6++) {
          var d4 = Lqe[f6], y4 = s.getAttribute(d4);
          y4 != null && (n6[Doe[d4]] = y4);
        }
      }
      function Gqe(s, a) {
        var n6 = a.width / s.width, f6 = a.height / s.height, d4 = Math.min(n6, f6);
        return { scale: d4, x: -(s.x + s.width / 2) * d4 + (a.x + a.width / 2), y: -(s.y + s.height / 2) * d4 + (a.y + a.height / 2) };
      }
      function AVt(s, a) {
        var n6 = new bVt();
        return n6.parse(s, a);
      }
      var IVt = ro(["rect", "circle", "line", "ellipse", "polygon", "polyline", "path", "text", "tspan", "g"]), EVt = function() {
        function s(a, n6) {
          this.type = "geoSVG", this._usedGraphicMap = ro(), this._freedGraphics = [], this._mapName = a, this._parsedXML = Oqe(n6);
        }
        return s.prototype.load = function() {
          var a = this._firstGraphic;
          if (!a) {
            a = this._firstGraphic = this._buildGraphic(this._parsedXML), this._freedGraphics.push(a), this._boundingRect = this._firstGraphic.boundingRect.clone();
            var n6 = kVt(a.named), f6 = n6.regions, d4 = n6.regionsMap;
            this._regions = f6, this._regionsMap = d4;
          }
          return { boundingRect: this._boundingRect, regions: this._regions, regionsMap: this._regionsMap };
        }, s.prototype._buildGraphic = function(a) {
          var n6, f6;
          try {
            n6 = a && AVt(a, { ignoreViewBox: true, ignoreRootClip: true }) || {}, f6 = n6.root, Ty(f6 != null);
          } catch (ee) {
            throw new Error(`Invalid svg format
` + ee.message);
          }
          var d4 = new fs();
          d4.add(f6), d4.isGeoSVGGraphicRoot = true;
          var y4 = n6.width, _ = n6.height, S = n6.viewBoxRect, T = this._boundingRect;
          if (!T) {
            var E = void 0, O = void 0, R = void 0, V = void 0;
            if (y4 != null ? (E = 0, R = y4) : S && (E = S.x, R = S.width), _ != null ? (O = 0, V = _) : S && (O = S.y, V = S.height), E == null || O == null) {
              var z3 = f6.getBoundingRect();
              E == null && (E = z3.x, R = z3.width), O == null && (O = z3.y, V = z3.height);
            }
            T = this._boundingRect = new il(E, O, R, V);
          }
          if (S) {
            var H = Gqe(S, T);
            f6.scaleX = f6.scaleY = H.scale, f6.x = H.x, f6.y = H.y;
          }
          d4.setClipPath(new xu({ shape: T.plain() }));
          var Z = [];
          return gt(n6.named, function(ee) {
            IVt.get(ee.svgNodeTagLower) != null && (Z.push(ee), DVt(ee.el));
          }), { root: d4, boundingRect: T, named: Z };
        }, s.prototype.useGraphic = function(a) {
          var n6 = this._usedGraphicMap, f6 = n6.get(a);
          return f6 || (f6 = this._freedGraphics.pop() || this._buildGraphic(this._parsedXML), n6.set(a, f6), f6);
        }, s.prototype.freeGraphic = function(a) {
          var n6 = this._usedGraphicMap, f6 = n6.get(a);
          f6 && (n6.removeKey(a), this._freedGraphics.push(f6));
        }, s;
      }();
      function DVt(s) {
        s.silent = false, s.isGroup && s.traverse(function(a) {
          a.silent = false;
        });
      }
      function kVt(s) {
        var a = [], n6 = ro();
        return gt(s, function(f6) {
          if (f6.namedFrom == null) {
            var d4 = new YFt(f6.name, f6.el);
            a.push(d4), n6.set(f6.name, d4);
          }
        }), { regions: a, regionsMap: n6 };
      }
      for (var SSe = [126, 25], Hqe = "\u5357\u6D77\u8BF8\u5C9B", JR = [[[0, 3.5], [7, 11.2], [15, 11.9], [30, 7], [42, 0.7], [52, 0.7], [56, 7.7], [59, 0.7], [64, 0.7], [64, 0], [5, 0], [0, 3.5]], [[13, 16.1], [19, 14.7], [16, 21.7], [11, 23.1], [13, 16.1]], [[12, 32.2], [14, 38.5], [15, 38.5], [13, 32.2], [12, 32.2]], [[16, 47.6], [12, 53.2], [13, 53.2], [18, 47.6], [16, 47.6]], [[6, 64.4], [8, 70], [9, 70], [8, 64.4], [6, 64.4]], [[23, 82.6], [29, 79.8], [30, 79.8], [25, 82.6], [23, 82.6]], [[37, 70.7], [43, 62.3], [44, 62.3], [39, 70.7], [37, 70.7]], [[48, 51.1], [51, 45.5], [53, 45.5], [50, 51.1], [48, 51.1]], [[51, 35], [51, 28.7], [53, 28.7], [53, 35], [51, 35]], [[52, 22.4], [55, 17.5], [56, 17.5], [53, 22.4], [52, 22.4]], [[58, 12.6], [62, 7], [63, 7], [60, 12.6], [58, 12.6]], [[0, 3.5], [0, 93.1], [64, 93.1], [64, 0], [63, 0], [63, 92.4], [1, 92.4], [1, 3.5], [0, 3.5]]], QR = 0; QR < JR.length; QR++)
        for (var Y7 = 0; Y7 < JR[QR].length; Y7++)
          JR[QR][Y7][0] /= 10.5, JR[QR][Y7][1] /= -10.5 / 0.75, JR[QR][Y7][0] += SSe[0], JR[QR][Y7][1] += SSe[1];
      function OVt(s, a) {
        if (s === "china") {
          for (var n6 = 0; n6 < a.length; n6++)
            if (a[n6].name === Hqe)
              return;
          a.push(new NWe(Hqe, Pi(JR, function(f6) {
            return { type: "polygon", exterior: f6 };
          }), SSe));
        }
      }
      var PVt = { \u5357\u6D77\u8BF8\u5C9B: [32, 80], \u5E7F\u4E1C: [0, -10], \u9999\u6E2F: [10, 5], \u6FB3\u95E8: [-10, 10], \u5929\u6D25: [5, 5] };
      function LVt(s, a) {
        if (s === "china") {
          var n6 = PVt[a.name];
          if (n6) {
            var f6 = a.getCenter();
            f6[0] += n6[0] / 10.5, f6[1] += -n6[1] / (10.5 / 0.75), a.setCenter(f6);
          }
        }
      }
      var RVt = [[[123.45165252685547, 25.73527164402261], [123.49731445312499, 25.73527164402261], [123.49731445312499, 25.750734064600884], [123.45165252685547, 25.750734064600884], [123.45165252685547, 25.73527164402261]]];
      function NVt(s, a) {
        s === "china" && a.name === "\u53F0\u6E7E" && a.geometries.push({ type: "polygon", exterior: RVt[0] });
      }
      var FVt = "name", VVt = function() {
        function s(a, n6, f6) {
          this.type = "geoJSON", this._parsedMap = ro(), this._mapName = a, this._specialAreas = f6, this._geoJSON = zVt(n6);
        }
        return s.prototype.load = function(a, n6) {
          n6 = n6 || FVt;
          var f6 = this._parsedMap.get(n6);
          if (!f6) {
            var d4 = this._parseToRegions(n6);
            f6 = this._parsedMap.set(n6, { regions: d4, boundingRect: BVt(d4) });
          }
          var y4 = ro(), _ = [];
          return gt(f6.regions, function(S) {
            var T = S.name;
            a && io(a, T) && (S = S.cloneShallow(T = a[T])), _.push(S), y4.set(T, S);
          }), { regions: _, boundingRect: f6.boundingRect || new il(0, 0, 0, 0), regionsMap: y4 };
        }, s.prototype._parseToRegions = function(a) {
          var n6 = this._mapName, f6 = this._geoJSON, d4;
          try {
            d4 = f6 ? ZFt(f6, a) : [];
          } catch (y4) {
            throw new Error(`Invalid geoJson format
` + y4.message);
          }
          return OVt(n6, d4), gt(d4, function(y4) {
            var _ = y4.name;
            LVt(n6, y4), NVt(n6, y4);
            var S = this._specialAreas && this._specialAreas[_];
            S && y4.transformTo(S.left, S.top, S.width, S.height);
          }, this), d4;
        }, s.prototype.getMapForUser = function() {
          return { geoJson: this._geoJSON, geoJSON: this._geoJSON, specialAreas: this._specialAreas };
        }, s;
      }();
      function BVt(s) {
        for (var a, n6 = 0; n6 < s.length; n6++) {
          var f6 = s[n6].getBoundingRect();
          a = a || f6.clone(), a.union(f6);
        }
        return a;
      }
      function zVt(s) {
        return Wa(s) ? typeof JSON != "undefined" && JSON.parse ? JSON.parse(s) : new Function("return (" + s + ");")() : s;
      }
      var K$ = ro(), FE = { registerMap: function(s, a, n6) {
        if (a.svg) {
          var f6 = new EVt(s, a.svg);
          K$.set(s, f6);
        } else {
          var d4 = a.geoJson || a.geoJSON;
          d4 && !a.features ? n6 = a.specialAreas : d4 = a;
          var f6 = new VVt(s, d4, n6);
          K$.set(s, f6);
        }
      }, getGeoResource: function(s) {
        return K$.get(s);
      }, getMapForUser: function(s) {
        var a = K$.get(s);
        return a && a.type === "geoJSON" && a.getMapForUser();
      }, load: function(s, a, n6) {
        var f6 = K$.get(s);
        if (f6)
          return f6.load(a, n6);
      } }, CSe = ["rect", "circle", "line", "ellipse", "polygon", "polyline", "path"], jVt = ro(CSe), GVt = ro(CSe.concat(["g"])), HVt = ro(CSe.concat(["g"])), Wqe = hu();
      function Ooe(s) {
        var a = s.getItemStyle(), n6 = s.get("areaColor");
        return n6 != null && (a.fill = n6), a;
      }
      function Uqe(s) {
        var a = s.style;
        a && (a.stroke = a.stroke || a.fill, a.fill = null);
      }
      var WVt = function() {
        function s(a) {
          var n6 = new fs();
          this.uid = M7("ec_map_draw"), this._controller = new Y$(a.getZr()), this._controllerHost = { target: n6 }, this.group = n6, n6.add(this._regionsGroup = new fs()), n6.add(this._svgGroup = new fs());
        }
        return s.prototype.draw = function(a, n6, f6, d4, y4) {
          var _ = a.mainType === "geo", S = a.getData && a.getData();
          _ && n6.eachComponent({ mainType: "series", subType: "map" }, function(oe) {
            !S && oe.getHostGeoModel() === a && (S = oe.getData());
          });
          var T = a.coordinateSystem, E = this._regionsGroup, O = this.group, R = T.getTransformInfo(), V = R.raw, z3 = R.roam, H = !E.childAt(0) || y4;
          H ? (O.x = z3.x, O.y = z3.y, O.scaleX = z3.scaleX, O.scaleY = z3.scaleY, O.dirty()) : ku(O, z3, a);
          var Z = S && S.getVisual("visualMeta") && S.getVisual("visualMeta").length > 0, ee = { api: f6, geo: T, mapOrGeoModel: a, data: S, isVisualEncodedByVisualMap: Z, isGeo: _, transformInfoRaw: V };
          T.resourceType === "geoJSON" ? this._buildGeoJSON(ee) : T.resourceType === "geoSVG" && this._buildSVG(ee), this._updateController(a, n6, f6), this._updateMapSelectHandler(a, E, f6, d4);
        }, s.prototype._buildGeoJSON = function(a) {
          var n6 = this._regionsGroupByName = ro(), f6 = ro(), d4 = this._regionsGroup, y4 = a.transformInfoRaw, _ = a.mapOrGeoModel, S = a.data, T = a.geo.projection, E = T && T.stream;
          function O(z3, H) {
            return H && (z3 = H(z3)), z3 && [z3[0] * y4.scaleX + y4.x, z3[1] * y4.scaleY + y4.y];
          }
          function R(z3) {
            for (var H = [], Z = !E && T && T.project, ee = 0; ee < z3.length; ++ee) {
              var oe = O(z3[ee], Z);
              oe && H.push(oe);
            }
            return H;
          }
          function V(z3) {
            return { shape: { points: R(z3) } };
          }
          d4.removeAll(), gt(a.geo.regions, function(z3) {
            var H = z3.name, Z = n6.get(H), ee = f6.get(H) || {}, oe = ee.dataIdx, fe = ee.regionModel;
            Z || (Z = n6.set(H, new fs()), d4.add(Z), oe = S ? S.indexOfName(H) : null, fe = a.isGeo ? _.getRegionModel(H) : S ? S.getItemModel(oe) : null, f6.set(H, { dataIdx: oe, regionModel: fe }));
            var _e = [], pe = [];
            gt(z3.geometries, function(je) {
              if (je.type === "polygon") {
                var Xe = [je.exterior].concat(je.interiors || []);
                E && (Xe = Zqe(Xe, E)), gt(Xe, function(rt2) {
                  _e.push(new T0(V(rt2)));
                });
              } else {
                var Ye = je.points;
                E && (Ye = Zqe(Ye, E, true)), gt(Ye, function(rt2) {
                  pe.push(new zm(V(rt2)));
                });
              }
            });
            var Ve = O(z3.getCenter(), T && T.project);
            function Le(je, Xe) {
              if (je.length) {
                var Ye = new Jq({ culling: true, segmentIgnoreThreshold: 1, shape: { paths: je } });
                Z.add(Ye), qqe(a, Ye, oe, fe), $qe(a, Ye, H, fe, _, oe, Ve), Xe && (Uqe(Ye), gt(Ye.states, Uqe));
              }
            }
            Le(_e), Le(pe, true);
          }), n6.each(function(z3, H) {
            var Z = f6.get(H), ee = Z.dataIdx, oe = Z.regionModel;
            Xqe(a, z3, H, oe, _, ee), Yqe(a, z3, H, oe, _), Kqe(a, z3, H, oe, _);
          }, this);
        }, s.prototype._buildSVG = function(a) {
          var n6 = a.geo.map, f6 = a.transformInfoRaw;
          this._svgGroup.x = f6.x, this._svgGroup.y = f6.y, this._svgGroup.scaleX = f6.scaleX, this._svgGroup.scaleY = f6.scaleY, this._svgResourceChanged(n6) && (this._freeSVG(), this._useSVG(n6));
          var d4 = this._svgDispatcherMap = ro(), y4 = false;
          gt(this._svgGraphicRecord.named, function(_) {
            var S = _.name, T = a.mapOrGeoModel, E = a.data, O = _.svgNodeTagLower, R = _.el, V = E ? E.indexOfName(S) : null, z3 = T.getRegionModel(S);
            if (jVt.get(O) != null && R instanceof Hb && qqe(a, R, V, z3), R instanceof Hb && (R.culling = true), R.z2EmphasisLift = 0, !_.namedFrom && (HVt.get(O) != null && $qe(a, R, S, z3, T, V, null), Xqe(a, R, S, z3, T, V), Yqe(a, R, S, z3, T), GVt.get(O) != null)) {
              var H = Kqe(a, R, S, z3, T);
              H === "self" && (y4 = true);
              var Z = d4.get(S) || d4.set(S, []);
              Z.push(R);
            }
          }, this), this._enableBlurEntireSVG(y4, a);
        }, s.prototype._enableBlurEntireSVG = function(a, n6) {
          if (a && n6.isGeo) {
            var f6 = n6.mapOrGeoModel.getModel(["blur", "itemStyle"]).getItemStyle(), d4 = f6.opacity;
            this._svgGraphicRecord.root.traverse(function(y4) {
              if (!y4.isGroup) {
                Wb(y4);
                var _ = y4.ensureState("blur").style || {};
                _.opacity == null && d4 != null && (_.opacity = d4), y4.ensureState("emphasis");
              }
            });
          }
        }, s.prototype.remove = function() {
          this._regionsGroup.removeAll(), this._regionsGroupByName = null, this._svgGroup.removeAll(), this._freeSVG(), this._controller.dispose(), this._controllerHost = null;
        }, s.prototype.findHighDownDispatchers = function(a, n6) {
          if (a == null)
            return [];
          var f6 = n6.coordinateSystem;
          if (f6.resourceType === "geoJSON") {
            var d4 = this._regionsGroupByName;
            if (d4) {
              var y4 = d4.get(a);
              return y4 ? [y4] : [];
            }
          } else if (f6.resourceType === "geoSVG")
            return this._svgDispatcherMap && this._svgDispatcherMap.get(a) || [];
        }, s.prototype._svgResourceChanged = function(a) {
          return this._svgMapName !== a;
        }, s.prototype._useSVG = function(a) {
          var n6 = FE.getGeoResource(a);
          if (n6 && n6.type === "geoSVG") {
            var f6 = n6.useGraphic(this.uid);
            this._svgGroup.add(f6.root), this._svgGraphicRecord = f6, this._svgMapName = a;
          }
        }, s.prototype._freeSVG = function() {
          var a = this._svgMapName;
          if (a != null) {
            var n6 = FE.getGeoResource(a);
            n6 && n6.type === "geoSVG" && n6.freeGraphic(this.uid), this._svgGraphicRecord = null, this._svgDispatcherMap = null, this._svgGroup.removeAll(), this._svgMapName = null;
          }
        }, s.prototype._updateController = function(a, n6, f6) {
          var d4 = a.coordinateSystem, y4 = this._controller, _ = this._controllerHost;
          _.zoomLimit = a.get("scaleLimit"), _.zoom = d4.getZoom(), y4.enable(a.get("roam") || false);
          var S = a.mainType;
          function T() {
            var E = { type: "geoRoam", componentType: S };
            return E[S + "Id"] = a.id, E;
          }
          y4.off("pan").on("pan", function(E) {
            this._mouseDownFlag = false, bSe(_, E.dx, E.dy), f6.dispatchAction(ei(T(), { dx: E.dx, dy: E.dy, animation: { duration: 0 } }));
          }, this), y4.off("zoom").on("zoom", function(E) {
            this._mouseDownFlag = false, _Se(_, E.scale, E.originX, E.originY), f6.dispatchAction(ei(T(), { zoom: E.scale, originX: E.originX, originY: E.originY, animation: { duration: 0 } }));
          }, this), y4.setPointerChecker(function(E, O, R) {
            return d4.containPoint([O, R]) && !Ioe(E, f6, a);
          });
        }, s.prototype.resetForLabelLayout = function() {
          this.group.traverse(function(a) {
            var n6 = a.getTextContent();
            n6 && (n6.ignore = Wqe(n6).ignore);
          });
        }, s.prototype._updateMapSelectHandler = function(a, n6, f6, d4) {
          var y4 = this;
          n6.off("mousedown"), n6.off("click"), a.get("selectedMode") && (n6.on("mousedown", function() {
            y4._mouseDownFlag = true;
          }), n6.on("click", function(_) {
            !y4._mouseDownFlag || (y4._mouseDownFlag = false);
          }));
        }, s;
      }();
      function qqe(s, a, n6, f6) {
        var d4 = f6.getModel("itemStyle"), y4 = f6.getModel(["emphasis", "itemStyle"]), _ = f6.getModel(["blur", "itemStyle"]), S = f6.getModel(["select", "itemStyle"]), T = Ooe(d4), E = Ooe(y4), O = Ooe(S), R = Ooe(_), V = s.data;
        if (V) {
          var z3 = V.getItemVisual(n6, "style"), H = V.getItemVisual(n6, "decal");
          s.isVisualEncodedByVisualMap && z3.fill && (T.fill = z3.fill), H && (T.decal = S$(H, s.api));
        }
        a.setStyle(T), a.style.strokeNoScale = true, a.ensureState("emphasis").style = E, a.ensureState("select").style = O, a.ensureState("blur").style = R, Wb(a);
      }
      function $qe(s, a, n6, f6, d4, y4, _) {
        var S = s.data, T = s.isGeo, E = S && isNaN(S.get(S.mapDimension("value"), y4)), O = S && S.getItemLayout(y4);
        if (T || E || O && O.showLabel) {
          var R = T ? n6 : y4, V = void 0;
          (!S || y4 >= 0) && (V = d4);
          var z3 = _ ? { normal: { align: "center", verticalAlign: "middle" } } : null;
          Gm(a, E0(f6), { labelFetcher: V, labelDataIndex: R, defaultText: n6 }, z3);
          var H = a.getTextContent();
          if (H && (Wqe(H).ignore = H.ignore, a.textConfig && _)) {
            var Z = a.getBoundingRect().clone();
            a.textConfig.layoutRect = Z, a.textConfig.position = [(_[0] - Z.x) / Z.width * 100 + "%", (_[1] - Z.y) / Z.height * 100 + "%"];
          }
          a.disableLabelAnimation = true;
        } else
          a.removeTextContent(), a.removeTextConfig(), a.disableLabelAnimation = null;
      }
      function Xqe(s, a, n6, f6, d4, y4) {
        s.data ? s.data.setItemGraphicEl(y4, a) : qo(a).eventData = { componentType: "geo", componentIndex: d4.componentIndex, geoIndex: d4.componentIndex, name: n6, region: f6 && f6.option || {} };
      }
      function Yqe(s, a, n6, f6, d4) {
        s.data || I0({ el: a, componentModel: d4, itemName: n6, itemTooltipOption: f6.get("tooltip") });
      }
      function Kqe(s, a, n6, f6, d4) {
        a.highDownSilentOnTouch = !!d4.get("selectedMode");
        var y4 = f6.getModel("emphasis"), _ = y4.get("focus");
        return Up(a, _, y4.get("blurScope"), y4.get("disabled")), s.isGeo && q_e(a, d4, n6), _;
      }
      function Zqe(s, a, n6) {
        var f6 = [], d4;
        function y4() {
          d4 = [];
        }
        function _() {
          d4.length && (f6.push(d4), d4 = []);
        }
        var S = a({ polygonStart: y4, polygonEnd: _, lineStart: y4, lineEnd: _, point: function(T, E) {
          isFinite(T) && isFinite(E) && d4.push([T, E]);
        }, sphere: function() {
        } });
        return !n6 && S.polygonStart(), gt(s, function(T) {
          S.lineStart();
          for (var E = 0; E < T.length; E++)
            S.point(T[E][0], T[E][1]);
          S.lineEnd();
        }), !n6 && S.polygonEnd(), f6;
      }
      var Jqe = WVt, UVt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          if (!(y4 && y4.type === "mapToggleSelect" && y4.from === this.uid)) {
            var _ = this.group;
            if (_.removeAll(), !n6.getHostGeoModel()) {
              if (this._mapDraw && y4 && y4.type === "geoRoam" && this._mapDraw.resetForLabelLayout(), y4 && y4.type === "geoRoam" && y4.componentType === "series" && y4.seriesId === n6.id) {
                var S = this._mapDraw;
                S && _.add(S.group);
              } else if (n6.needsDrawMap) {
                var S = this._mapDraw || new Jqe(d4);
                _.add(S.group), S.draw(n6, f6, d4, this, y4), this._mapDraw = S;
              } else
                this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
              n6.get("showLegendSymbol") && f6.getComponent("legend") && this._renderSymbols(n6, f6, d4);
            }
          }
        }, a.prototype.remove = function() {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null, this.group.removeAll();
        }, a.prototype.dispose = function() {
          this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
        }, a.prototype._renderSymbols = function(n6, f6, d4) {
          var y4 = n6.originalData, _ = this.group;
          y4.each(y4.mapDimension("value"), function(S, T) {
            if (!isNaN(S)) {
              var E = y4.getItemLayout(T);
              if (!(!E || !E.point)) {
                var O = E.point, R = E.offset, V = new cS({ style: { fill: n6.getData().getVisual("style").fill }, shape: { cx: O[0] + R * 9, cy: O[1], r: 3 }, silent: true, z2: 8 + (R ? 0 : jk + 1) });
                if (!R) {
                  var z3 = n6.mainSeries.getData(), H = y4.getName(T), Z = z3.indexOfName(H), ee = y4.getItemModel(T), oe = ee.getModel("label"), fe = z3.getItemGraphicEl(Z);
                  Gm(V, E0(ee), { labelFetcher: { getFormattedLabel: function(_e, pe) {
                    return n6.getFormattedLabel(Z, pe);
                  } }, defaultText: H }), V.disableLabelAnimation = true, oe.get("position") || V.setTextConfig({ position: "bottom" }), fe.onHoverStateChange = function(_e) {
                    DT(V, _e);
                  };
                }
                _.add(V);
              }
            }
          });
        }, a.type = "map", a;
      }(Ch), qVt = UVt, $Vt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.needsDrawMap = false, n6.seriesGroup = [], n6.getTooltipPosition = function(f6) {
            if (f6 != null) {
              var d4 = this.getData().getName(f6), y4 = this.coordinateSystem, _ = y4.getRegion(d4);
              return _ && y4.dataToPoint(_.getCenter());
            }
          }, n6;
        }
        return a.prototype.getInitialData = function(n6) {
          for (var f6 = $7(this, { coordDimensions: ["value"], encodeDefaulter: ks(Lxe, this) }), d4 = ro(), y4 = [], _ = 0, S = f6.count(); _ < S; _++) {
            var T = f6.getName(_);
            d4.set(T, true);
          }
          var E = FE.load(this.getMapType(), this.option.nameMap, this.option.nameProperty);
          return gt(E.regions, function(O) {
            var R = O.name;
            d4.get(R) || y4.push(R);
          }), f6.appendValues([], y4), f6;
        }, a.prototype.getHostGeoModel = function() {
          var n6 = this.option.geoIndex;
          return n6 != null ? this.ecModel.getComponent("geo", n6) : null;
        }, a.prototype.getMapType = function() {
          return (this.getHostGeoModel() || this).option.map;
        }, a.prototype.getRawValue = function(n6) {
          var f6 = this.getData();
          return f6.get(f6.mapDimension("value"), n6);
        }, a.prototype.getRegionModel = function(n6) {
          var f6 = this.getData();
          return f6.getItemModel(f6.indexOfName(n6));
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          for (var y4 = this.getData(), _ = this.getRawValue(n6), S = y4.getName(n6), T = this.seriesGroup, E = [], O = 0; O < T.length; O++) {
            var R = T[O].originalData.indexOfName(S), V = y4.mapDimension("value");
            isNaN(T[O].originalData.get(V, R)) || E.push(T[O].name);
          }
          return Rg("section", { header: E.join(", "), noHeader: !E.length, blocks: [Rg("nameValue", { name: S, value: _ })] });
        }, a.prototype.setZoom = function(n6) {
          this.option.zoom = n6;
        }, a.prototype.setCenter = function(n6) {
          this.option.center = n6;
        }, a.prototype.getLegendIcon = function(n6) {
          var f6 = n6.icon || "roundRect", d4 = bv(f6, 0, 0, n6.itemWidth, n6.itemHeight, n6.itemStyle.fill);
          return d4.setStyle(n6.itemStyle), d4.style.stroke = "none", f6.indexOf("empty") > -1 && (d4.style.stroke = d4.style.fill, d4.style.fill = "#fff", d4.style.lineWidth = 2), d4;
        }, a.type = "series.map", a.dependencies = ["geo"], a.layoutMode = "box", a.defaultOption = { z: 2, coordinateSystem: "geo", map: "", left: "center", top: "center", aspectScale: null, showLegendSymbol: true, boundingCoords: null, center: null, zoom: 1, scaleLimit: null, selectedMode: true, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444", areaColor: "#eee" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { areaColor: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, nameProperty: "name" }, a;
      }(Cp), XVt = $Vt;
      function YVt(s, a) {
        var n6 = {};
        return gt(s, function(f6) {
          f6.each(f6.mapDimension("value"), function(d4, y4) {
            var _ = "ec-" + f6.getName(y4);
            n6[_] = n6[_] || [], isNaN(d4) || n6[_].push(d4);
          });
        }), s[0].map(s[0].mapDimension("value"), function(f6, d4) {
          for (var y4 = "ec-" + s[0].getName(d4), _ = 0, S = 1 / 0, T = -1 / 0, E = n6[y4].length, O = 0; O < E; O++)
            S = Math.min(S, n6[y4][O]), T = Math.max(T, n6[y4][O]), _ += n6[y4][O];
          var R;
          return a === "min" ? R = S : a === "max" ? R = T : a === "average" ? R = _ / E : R = _, E === 0 ? NaN : R;
        });
      }
      function KVt(s) {
        var a = {};
        s.eachSeriesByType("map", function(n6) {
          var f6 = n6.getHostGeoModel(), d4 = f6 ? "o" + f6.id : "i" + n6.getMapType();
          (a[d4] = a[d4] || []).push(n6);
        }), gt(a, function(n6, f6) {
          for (var d4 = YVt(Pi(n6, function(_) {
            return _.getData();
          }), n6[0].get("mapValueCalculation")), y4 = 0; y4 < n6.length; y4++)
            n6[y4].originalData = n6[y4].getData();
          for (var y4 = 0; y4 < n6.length; y4++)
            n6[y4].seriesGroup = n6, n6[y4].needsDrawMap = y4 === 0 && !n6[y4].getHostGeoModel(), n6[y4].setData(d4.cloneShallow()), n6[y4].mainSeries = n6[0];
        });
      }
      function ZVt(s) {
        var a = {};
        s.eachSeriesByType("map", function(n6) {
          var f6 = n6.getMapType();
          if (!(n6.getHostGeoModel() || a[f6])) {
            var d4 = {};
            gt(n6.seriesGroup, function(_) {
              var S = _.coordinateSystem, T = _.originalData;
              _.get("showLegendSymbol") && s.getComponent("legend") && T.each(T.mapDimension("value"), function(E, O) {
                var R = T.getName(O), V = S.getRegion(R);
                if (!(!V || isNaN(E))) {
                  var z3 = d4[R] || 0, H = S.dataToPoint(V.getCenter());
                  d4[R] = z3 + 1, T.setItemLayout(O, { point: H, offset: z3 });
                }
              });
            });
            var y4 = n6.getData();
            y4.each(function(_) {
              var S = y4.getName(_), T = y4.getItemLayout(_) || {};
              T.showLabel = !d4[S], y4.setItemLayout(_, T);
            }), a[f6] = true;
          }
        });
      }
      var Qqe = Xv, JVt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this) || this;
          return f6.type = "view", f6.dimensions = ["x", "y"], f6._roamTransformable = new Q_(), f6._rawTransformable = new Q_(), f6.name = n6, f6;
        }
        return a.prototype.setBoundingRect = function(n6, f6, d4, y4) {
          return this._rect = new il(n6, f6, d4, y4), this._rect;
        }, a.prototype.getBoundingRect = function() {
          return this._rect;
        }, a.prototype.setViewRect = function(n6, f6, d4, y4) {
          this._transformTo(n6, f6, d4, y4), this._viewRect = new il(n6, f6, d4, y4);
        }, a.prototype._transformTo = function(n6, f6, d4, y4) {
          var _ = this.getBoundingRect(), S = this._rawTransformable;
          S.transform = _.calculateTransform(new il(n6, f6, d4, y4));
          var T = S.parent;
          S.parent = null, S.decomposeTransform(), S.parent = T, this._updateTransform();
        }, a.prototype.setCenter = function(n6) {
          !n6 || (this._center = n6, this._updateCenterAndZoom());
        }, a.prototype.setZoom = function(n6) {
          n6 = n6 || 1;
          var f6 = this.zoomLimit;
          f6 && (f6.max != null && (n6 = Math.min(f6.max, n6)), f6.min != null && (n6 = Math.max(f6.min, n6))), this._zoom = n6, this._updateCenterAndZoom();
        }, a.prototype.getDefaultCenter = function() {
          var n6 = this.getBoundingRect(), f6 = n6.x + n6.width / 2, d4 = n6.y + n6.height / 2;
          return [f6, d4];
        }, a.prototype.getCenter = function() {
          return this._center || this.getDefaultCenter();
        }, a.prototype.getZoom = function() {
          return this._zoom || 1;
        }, a.prototype.getRoamTransform = function() {
          return this._roamTransformable.getLocalTransform();
        }, a.prototype._updateCenterAndZoom = function() {
          var n6 = this._rawTransformable.getLocalTransform(), f6 = this._roamTransformable, d4 = this.getDefaultCenter(), y4 = this.getCenter(), _ = this.getZoom();
          y4 = Xv([], y4, n6), d4 = Xv([], d4, n6), f6.originX = y4[0], f6.originY = y4[1], f6.x = d4[0] - y4[0], f6.y = d4[1] - y4[1], f6.scaleX = f6.scaleY = _, this._updateTransform();
        }, a.prototype._updateTransform = function() {
          var n6 = this._roamTransformable, f6 = this._rawTransformable;
          f6.parent = n6, n6.updateTransform(), f6.updateTransform(), iR(this.transform || (this.transform = []), f6.transform || Bb()), this._rawTransform = f6.getLocalTransform(), this.invTransform = this.invTransform || [], aE(this.invTransform, this.transform), this.decomposeTransform();
        }, a.prototype.getTransformInfo = function() {
          var n6 = this._rawTransformable, f6 = this._roamTransformable, d4 = new Q_();
          return d4.transform = f6.transform, d4.decomposeTransform(), { roam: { x: d4.x, y: d4.y, scaleX: d4.scaleX, scaleY: d4.scaleY }, raw: { x: n6.x, y: n6.y, scaleX: n6.scaleX, scaleY: n6.scaleY } };
        }, a.prototype.getViewRect = function() {
          return this._viewRect;
        }, a.prototype.getViewRectAfterRoam = function() {
          var n6 = this.getBoundingRect().clone();
          return n6.applyTransform(this.transform), n6;
        }, a.prototype.dataToPoint = function(n6, f6, d4) {
          var y4 = f6 ? this._rawTransform : this.transform;
          return d4 = d4 || [], y4 ? Qqe(d4, n6, y4) : Ay(d4, n6);
        }, a.prototype.pointToData = function(n6) {
          var f6 = this.invTransform;
          return f6 ? Qqe([], n6, f6) : [n6[0], n6[1]];
        }, a.prototype.convertToPixel = function(n6, f6, d4) {
          var y4 = e$e(f6);
          return y4 === this ? y4.dataToPoint(d4) : null;
        }, a.prototype.convertFromPixel = function(n6, f6, d4) {
          var y4 = e$e(f6);
          return y4 === this ? y4.pointToData(d4) : null;
        }, a.prototype.containPoint = function(n6) {
          return this.getViewRectAfterRoam().contain(n6[0], n6[1]);
        }, a.dimensions = ["x", "y"], a;
      }(Q_);
      function e$e(s) {
        var a = s.seriesModel;
        return a ? a.coordinateSystem : null;
      }
      var Z$ = JVt, QVt = { geoJSON: { aspectScale: 0.75, invertLongitute: true }, geoSVG: { aspectScale: 1, invertLongitute: false } }, t$e = ["lng", "lat"], n$e = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this, n6) || this;
          y4.dimensions = t$e, y4.type = "geo", y4._nameCoordMap = ro(), y4.map = f6;
          var _ = d4.projection, S = FE.load(f6, d4.nameMap, d4.nameProperty), T = FE.getGeoResource(f6);
          y4.resourceType = T ? T.type : null;
          var E = y4.regions = S.regions, O = QVt[T.type];
          y4._regionsMap = S.regionsMap, y4.regions = S.regions, y4.projection = _;
          var R;
          if (_)
            for (var V = 0; V < E.length; V++) {
              var z3 = E[V].getBoundingRect(_);
              R = R || z3.clone(), R.union(z3);
            }
          else
            R = S.boundingRect;
          return y4.setBoundingRect(R.x, R.y, R.width, R.height), y4.aspectScale = _ ? 1 : Zs(d4.aspectScale, O.aspectScale), y4._invertLongitute = _ ? false : O.invertLongitute, y4;
        }
        return a.prototype._transformTo = function(n6, f6, d4, y4) {
          var _ = this.getBoundingRect(), S = this._invertLongitute;
          _ = _.clone(), S && (_.y = -_.y - _.height);
          var T = this._rawTransformable;
          T.transform = _.calculateTransform(new il(n6, f6, d4, y4));
          var E = T.parent;
          T.parent = null, T.decomposeTransform(), T.parent = E, S && (T.scaleY = -T.scaleY), this._updateTransform();
        }, a.prototype.getRegion = function(n6) {
          return this._regionsMap.get(n6);
        }, a.prototype.getRegionByCoord = function(n6) {
          for (var f6 = this.regions, d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            if (y4.type === "geoJSON" && y4.contain(n6))
              return f6[d4];
          }
        }, a.prototype.addGeoCoord = function(n6, f6) {
          this._nameCoordMap.set(n6, f6);
        }, a.prototype.getGeoCoord = function(n6) {
          var f6 = this._regionsMap.get(n6);
          return this._nameCoordMap.get(n6) || f6 && f6.getCenter();
        }, a.prototype.dataToPoint = function(n6, f6, d4) {
          if (Wa(n6) && (n6 = this.getGeoCoord(n6)), n6) {
            var y4 = this.projection;
            return y4 && (n6 = y4.project(n6)), n6 && this.projectedToPoint(n6);
          }
        }, a.prototype.pointToData = function(n6) {
          var f6 = this.projection;
          return f6 && (n6 = f6.unproject(n6)), n6 && this.pointToProjected(n6);
        }, a.prototype.pointToProjected = function(n6) {
          return s.prototype.pointToData.call(this, n6);
        }, a.prototype.projectedToPoint = function(n6, f6, d4) {
          return s.prototype.dataToPoint.call(this, n6, f6, d4);
        }, a.prototype.convertToPixel = function(n6, f6, d4) {
          var y4 = r$e(f6);
          return y4 === this ? y4.dataToPoint(d4) : null;
        }, a.prototype.convertFromPixel = function(n6, f6, d4) {
          var y4 = r$e(f6);
          return y4 === this ? y4.pointToData(d4) : null;
        }, a;
      }(Z$);
      nd(n$e, Z$);
      function r$e(s) {
        var a = s.geoModel, n6 = s.seriesModel;
        return a ? a.coordinateSystem : n6 ? n6.coordinateSystem || (n6.getReferringComponents("geo", ad).models[0] || {}).coordinateSystem : null;
      }
      var i$e = n$e;
      function a$e(s, a) {
        var n6 = s.get("boundingCoords");
        if (n6 != null) {
          var f6 = n6[0], d4 = n6[1];
          if (isFinite(f6[0]) && isFinite(f6[1]) && isFinite(d4[0]) && isFinite(d4[1])) {
            var y4 = this.projection;
            if (y4) {
              var _ = f6[0], S = f6[1], T = d4[0], E = d4[1];
              f6 = [1 / 0, 1 / 0], d4 = [-1 / 0, -1 / 0];
              var O = function(Le, je, Xe, Ye) {
                for (var rt2 = Xe - Le, ut = Ye - je, wt = 0; wt <= 100; wt++) {
                  var dt = wt / 100, Gt = y4.project([Le + rt2 * dt, je + ut * dt]);
                  H_(f6, f6, Gt), G1(d4, d4, Gt);
                }
              };
              O(_, S, T, S), O(T, S, T, E), O(T, E, _, E), O(_, E, T, S);
            }
            this.setBoundingRect(f6[0], f6[1], d4[0] - f6[0], d4[1] - f6[1]);
          }
        }
        var R = this.getBoundingRect(), V = s.get("layoutCenter"), z3 = s.get("layoutSize"), H = a.getWidth(), Z = a.getHeight(), ee = R.width / R.height * this.aspectScale, oe = false, fe, _e;
        V && z3 && (fe = [Ia(V[0], H), Ia(V[1], Z)], _e = Ia(z3, Math.min(H, Z)), !isNaN(fe[0]) && !isNaN(fe[1]) && !isNaN(_e) && (oe = true));
        var pe;
        if (oe)
          pe = {}, ee > 1 ? (pe.width = _e, pe.height = _e / ee) : (pe.height = _e, pe.width = _e * ee), pe.y = fe[1] - pe.height / 2, pe.x = fe[0] - pe.width / 2;
        else {
          var Ve = s.getBoxLayoutParams();
          Ve.aspect = ee, pe = Qv(Ve, { width: H, height: Z });
        }
        this.setViewRect(pe.x, pe.y, pe.width, pe.height), this.setCenter(s.get("center")), this.setZoom(s.get("zoom"));
      }
      function eBt(s, a) {
        gt(a.get("geoCoord"), function(n6, f6) {
          s.addGeoCoord(f6, n6);
        });
      }
      var tBt = function() {
        function s() {
          this.dimensions = t$e;
        }
        return s.prototype.create = function(a, n6) {
          var f6 = [];
          function d4(_) {
            return { nameProperty: _.get("nameProperty"), aspectScale: _.get("aspectScale"), projection: _.get("projection") };
          }
          a.eachComponent("geo", function(_, S) {
            var T = _.get("map"), E = new i$e(T + S, T, ei({ nameMap: _.get("nameMap") }, d4(_)));
            E.zoomLimit = _.get("scaleLimit"), f6.push(E), _.coordinateSystem = E, E.model = _, E.resize = a$e, E.resize(_, n6);
          }), a.eachSeries(function(_) {
            var S = _.get("coordinateSystem");
            if (S === "geo") {
              var T = _.get("geoIndex") || 0;
              _.coordinateSystem = f6[T];
            }
          });
          var y4 = {};
          return a.eachSeriesByType("map", function(_) {
            if (!_.getHostGeoModel()) {
              var S = _.getMapType();
              y4[S] = y4[S] || [], y4[S].push(_);
            }
          }), gt(y4, function(_, S) {
            var T = Pi(_, function(O) {
              return O.get("nameMap");
            }), E = new i$e(S, S, ei({ nameMap: YI(T) }, d4(_[0])));
            E.zoomLimit = $v.apply(null, Pi(_, function(O) {
              return O.get("scaleLimit");
            })), f6.push(E), E.resize = a$e, E.resize(_[0], n6), gt(_, function(O) {
              O.coordinateSystem = E, eBt(E, O);
            });
          }), f6;
        }, s.prototype.getFilledRegions = function(a, n6, f6, d4) {
          for (var y4 = (a || []).slice(), _ = ro(), S = 0; S < y4.length; S++)
            _.set(y4[S].name, y4[S]);
          var T = FE.load(n6, f6, d4);
          return gt(T.regions, function(E) {
            var O = E.name;
            !_.get(O) && y4.push({ name: O });
          }), y4;
        }, s;
      }(), nBt = new tBt(), o$e = nBt, rBt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          var y4 = FE.getGeoResource(n6.map);
          if (y4 && y4.type === "geoJSON") {
            var _ = n6.itemStyle = n6.itemStyle || {};
            "color" in _ || (_.color = "#eee");
          }
          this.mergeDefaultAndTheme(n6, d4), Gb(n6, "label", ["show"]);
        }, a.prototype.optionUpdated = function() {
          var n6 = this, f6 = this.option;
          f6.regions = o$e.getFilledRegions(f6.regions, f6.map, f6.nameMap, f6.nameProperty);
          var d4 = {};
          this._optionModelMap = G_(f6.regions || [], function(y4, _) {
            var S = _.name;
            return S && (y4.set(S, new Sh(_, n6, n6.ecModel)), _.selected && (d4[S] = true)), y4;
          }, ro()), f6.selectedMap || (f6.selectedMap = d4);
        }, a.prototype.getRegionModel = function(n6) {
          return this._optionModelMap.get(n6) || new Sh(null, this, this.ecModel);
        }, a.prototype.getFormattedLabel = function(n6, f6) {
          var d4 = this.getRegionModel(n6), y4 = f6 === "normal" ? d4.get(["label", "formatter"]) : d4.get(["emphasis", "label", "formatter"]), _ = { name: n6 };
          if (jo(y4))
            return _.status = f6, y4(_);
          if (Wa(y4))
            return y4.replace("{a}", n6 != null ? n6 : "");
        }, a.prototype.setZoom = function(n6) {
          this.option.zoom = n6;
        }, a.prototype.setCenter = function(n6) {
          this.option.center = n6;
        }, a.prototype.select = function(n6) {
          var f6 = this.option, d4 = f6.selectedMode;
          if (d4) {
            d4 !== "multiple" && (f6.selectedMap = null);
            var y4 = f6.selectedMap || (f6.selectedMap = {});
            y4[n6] = true;
          }
        }, a.prototype.unSelect = function(n6) {
          var f6 = this.option.selectedMap;
          f6 && (f6[n6] = false);
        }, a.prototype.toggleSelected = function(n6) {
          this[this.isSelected(n6) ? "unSelect" : "select"](n6);
        }, a.prototype.isSelected = function(n6) {
          var f6 = this.option.selectedMap;
          return !!(f6 && f6[n6]);
        }, a.type = "geo", a.layoutMode = "box", a.defaultOption = { z: 0, show: true, left: "center", top: "center", aspectScale: null, silent: false, map: "", boundingCoords: null, center: null, zoom: 1, scaleLimit: null, label: { show: false, color: "#000" }, itemStyle: { borderWidth: 0.5, borderColor: "#444" }, emphasis: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, select: { label: { show: true, color: "rgb(100,0,0)" }, itemStyle: { color: "rgba(255,215,0,0.8)" } }, regions: [] }, a;
      }(oc), iBt = rBt;
      function s$e(s, a) {
        return s.pointToProjected ? s.pointToProjected(a) : s.pointToData(a);
      }
      function MSe(s, a, n6) {
        var f6 = s.getZoom(), d4 = s.getCenter(), y4 = a.zoom, _ = s.projectedToPoint ? s.projectedToPoint(d4) : s.dataToPoint(d4);
        if (a.dx != null && a.dy != null && (_[0] -= a.dx, _[1] -= a.dy, s.setCenter(s$e(s, _))), y4 != null) {
          if (n6) {
            var S = n6.min || 0, T = n6.max || 1 / 0;
            y4 = Math.max(Math.min(f6 * y4, T), S) / f6;
          }
          s.scaleX *= y4, s.scaleY *= y4;
          var E = (a.originX - s.x) * (y4 - 1), O = (a.originY - s.y) * (y4 - 1);
          s.x -= E, s.y -= O, s.updateTransform(), s.setCenter(s$e(s, _)), s.setZoom(y4 * f6);
        }
        return { center: s.getCenter(), zoom: s.getZoom() };
      }
      var aBt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.focusBlurEnabled = true, n6;
        }
        return a.prototype.init = function(n6, f6) {
          this._api = f6;
        }, a.prototype.render = function(n6, f6, d4, y4) {
          if (this._model = n6, !n6.get("show")) {
            this._mapDraw && this._mapDraw.remove(), this._mapDraw = null;
            return;
          }
          this._mapDraw || (this._mapDraw = new Jqe(d4));
          var _ = this._mapDraw;
          _.draw(n6, f6, d4, this, y4), _.group.on("click", this._handleRegionClick, this), _.group.silent = n6.get("silent"), this.group.add(_.group), this.updateSelectStatus(n6, f6, d4);
        }, a.prototype._handleRegionClick = function(n6) {
          var f6;
          V7(n6.target, function(d4) {
            return (f6 = qo(d4).eventData) != null;
          }, true), f6 && this._api.dispatchAction({ type: "geoToggleSelect", geoId: this._model.id, name: f6.name });
        }, a.prototype.updateSelectStatus = function(n6, f6, d4) {
          var y4 = this;
          this._mapDraw.group.traverse(function(_) {
            var S = qo(_).eventData;
            if (S)
              return y4._model.isSelected(S.name) ? d4.enterSelect(_) : d4.leaveSelect(_), true;
          });
        }, a.prototype.findHighDownDispatchers = function(n6) {
          return this._mapDraw && this._mapDraw.findHighDownDispatchers(n6, this._model);
        }, a.prototype.dispose = function() {
          this._mapDraw && this._mapDraw.remove();
        }, a.type = "geo", a;
      }(sd), oBt = aBt;
      function sBt(s, a, n6) {
        FE.registerMap(s, a, n6);
      }
      function l$e(s) {
        s.registerCoordinateSystem("geo", o$e), s.registerComponentModel(iBt), s.registerComponentView(oBt), s.registerImpl("registerMap", sBt), s.registerImpl("getMap", function(n6) {
          return FE.getMapForUser(n6);
        });
        function a(n6, f6) {
          f6.update = "geo:updateSelectStatus", s.registerAction(f6, function(d4, y4) {
            var _ = {}, S = [];
            return y4.eachComponent({ mainType: "geo", query: d4 }, function(T) {
              T[n6](d4.name);
              var E = T.coordinateSystem;
              gt(E.regions, function(R) {
                _[R.name] = T.isSelected(R.name) || false;
              });
              var O = [];
              gt(_, function(R, V) {
                _[V] && O.push(V);
              }), S.push({ geoIndex: T.componentIndex, name: O });
            }), { selected: _, allSelected: S, name: d4.name };
          });
        }
        a("toggleSelected", { type: "geoToggleSelect", event: "geoselectchanged" }), a("select", { type: "geoSelect", event: "geoselected" }), a("unSelect", { type: "geoUnSelect", event: "geounselected" }), s.registerAction({ type: "geoRoam", event: "geoRoam", update: "updateTransform" }, function(n6, f6) {
          var d4 = n6.componentType || "series";
          f6.eachComponent({ mainType: d4, query: n6 }, function(y4) {
            var _ = y4.coordinateSystem;
            if (_.type === "geo") {
              var S = MSe(_, n6, y4.get("scaleLimit"));
              y4.setCenter && y4.setCenter(S.center), y4.setZoom && y4.setZoom(S.zoom), d4 === "series" && gt(y4.seriesGroup, function(T) {
                T.setCenter(S.center), T.setZoom(S.zoom);
              });
            }
          });
        });
      }
      function lBt(s) {
        Il(l$e), s.registerChartView(qVt), s.registerSeriesModel(XVt), s.registerLayout(ZVt), s.registerProcessor(s.PRIORITY.PROCESSOR.STATISTIC, KVt), cHe("map", s.registerAction);
      }
      function uBt(s) {
        var a = s;
        a.hierNode = { defaultAncestor: null, ancestor: a, prelim: 0, modifier: 0, change: 0, shift: 0, i: 0, thread: null };
        for (var n6 = [a], f6, d4; f6 = n6.pop(); )
          if (d4 = f6.children, f6.isExpand && d4.length)
            for (var y4 = d4.length, _ = y4 - 1; _ >= 0; _--) {
              var S = d4[_];
              S.hierNode = { defaultAncestor: null, ancestor: S, prelim: 0, modifier: 0, change: 0, shift: 0, i: _, thread: null }, n6.push(S);
            }
      }
      function cBt(s, a) {
        var n6 = s.isExpand ? s.children : [], f6 = s.parentNode.children, d4 = s.hierNode.i ? f6[s.hierNode.i - 1] : null;
        if (n6.length) {
          pBt(s);
          var y4 = (n6[0].hierNode.prelim + n6[n6.length - 1].hierNode.prelim) / 2;
          d4 ? (s.hierNode.prelim = d4.hierNode.prelim + a(s, d4), s.hierNode.modifier = s.hierNode.prelim - y4) : s.hierNode.prelim = y4;
        } else
          d4 && (s.hierNode.prelim = d4.hierNode.prelim + a(s, d4));
        s.parentNode.hierNode.defaultAncestor = dBt(s, d4, s.parentNode.hierNode.defaultAncestor || f6[0], a);
      }
      function fBt(s) {
        var a = s.hierNode.prelim + s.parentNode.hierNode.modifier;
        s.setLayout({ x: a }, true), s.hierNode.modifier += s.parentNode.hierNode.modifier;
      }
      function u$e(s) {
        return arguments.length ? s : yBt;
      }
      function J$(s, a) {
        return s -= Math.PI / 2, { x: a * Math.cos(s), y: a * Math.sin(s) };
      }
      function hBt(s, a) {
        return Qv(s.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
      }
      function pBt(s) {
        for (var a = s.children, n6 = a.length, f6 = 0, d4 = 0; --n6 >= 0; ) {
          var y4 = a[n6];
          y4.hierNode.prelim += f6, y4.hierNode.modifier += f6, d4 += y4.hierNode.change, f6 += y4.hierNode.shift + d4;
        }
      }
      function dBt(s, a, n6, f6) {
        if (a) {
          for (var d4 = s, y4 = s, _ = y4.parentNode.children[0], S = a, T = d4.hierNode.modifier, E = y4.hierNode.modifier, O = _.hierNode.modifier, R = S.hierNode.modifier; S = TSe(S), y4 = ASe(y4), S && y4; ) {
            d4 = TSe(d4), _ = ASe(_), d4.hierNode.ancestor = s;
            var V = S.hierNode.prelim + R - y4.hierNode.prelim - E + f6(S, y4);
            V > 0 && (gBt(vBt(S, s, n6), s, V), E += V, T += V), R += S.hierNode.modifier, E += y4.hierNode.modifier, T += d4.hierNode.modifier, O += _.hierNode.modifier;
          }
          S && !TSe(d4) && (d4.hierNode.thread = S, d4.hierNode.modifier += R - T), y4 && !ASe(_) && (_.hierNode.thread = y4, _.hierNode.modifier += E - O, n6 = s);
        }
        return n6;
      }
      function TSe(s) {
        var a = s.children;
        return a.length && s.isExpand ? a[a.length - 1] : s.hierNode.thread;
      }
      function ASe(s) {
        var a = s.children;
        return a.length && s.isExpand ? a[0] : s.hierNode.thread;
      }
      function vBt(s, a, n6) {
        return s.hierNode.ancestor.parentNode === a.parentNode ? s.hierNode.ancestor : n6;
      }
      function gBt(s, a, n6) {
        var f6 = n6 / (a.hierNode.i - s.hierNode.i);
        a.hierNode.change -= f6, a.hierNode.shift += n6, a.hierNode.modifier += n6, a.hierNode.prelim += n6, s.hierNode.change += f6;
      }
      function yBt(s, a) {
        return s.parentNode === a.parentNode ? 1 : 2;
      }
      var mBt = function() {
        function s() {
          this.parentPoint = [], this.childPoints = [];
        }
        return s;
      }(), bBt = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new mBt();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.childPoints, y4 = d4.length, _ = f6.parentPoint, S = d4[0], T = d4[y4 - 1];
          if (y4 === 1) {
            n6.moveTo(_[0], _[1]), n6.lineTo(S[0], S[1]);
            return;
          }
          var E = f6.orient, O = E === "TB" || E === "BT" ? 0 : 1, R = 1 - O, V = Ia(f6.forkPosition, 1), z3 = [];
          z3[O] = _[O], z3[R] = _[R] + (T[R] - _[R]) * V, n6.moveTo(_[0], _[1]), n6.lineTo(z3[0], z3[1]), n6.moveTo(S[0], S[1]), z3[O] = S[O], n6.lineTo(z3[0], z3[1]), z3[O] = T[O], n6.lineTo(z3[0], z3[1]), n6.lineTo(T[0], T[1]);
          for (var H = 1; H < y4 - 1; H++) {
            var Z = d4[H];
            n6.moveTo(Z[0], Z[1]), z3[O] = Z[O], n6.lineTo(z3[0], z3[1]);
          }
        }, a;
      }(ml), _Bt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._mainGroup = new fs(), n6;
        }
        return a.prototype.init = function(n6, f6) {
          this._controller = new Y$(f6.getZr()), this._controllerHost = { target: this.group }, this.group.add(this._mainGroup);
        }, a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = n6.layoutInfo, S = this._mainGroup, T = n6.get("layout");
          T === "radial" ? (S.x = _.x + _.width / 2, S.y = _.y + _.height / 2) : (S.x = _.x, S.y = _.y), this._updateViewCoordSys(n6), this._updateController(n6, f6, d4);
          var E = this._data;
          y4.diff(E).add(function(O) {
            c$e(y4, O) && f$e(y4, O, null, S, n6);
          }).update(function(O, R) {
            var V = E.getItemGraphicEl(R);
            if (!c$e(y4, O)) {
              V && d$e(E, R, V, S, n6);
              return;
            }
            f$e(y4, O, V, S, n6);
          }).remove(function(O) {
            var R = E.getItemGraphicEl(O);
            R && d$e(E, O, R, S, n6);
          }).execute(), this._nodeScaleRatio = n6.get("nodeScaleRatio"), this._updateNodeAndLinkScale(n6), n6.get("expandAndCollapse") === true && y4.eachItemGraphicEl(function(O, R) {
            O.off("click").on("click", function() {
              d4.dispatchAction({ type: "treeExpandAndCollapse", seriesId: n6.id, dataIndex: R });
            });
          }), this._data = y4;
        }, a.prototype._updateViewCoordSys = function(n6) {
          var f6 = n6.getData(), d4 = [];
          f6.each(function(O) {
            var R = f6.getItemLayout(O);
            R && !isNaN(R.x) && !isNaN(R.y) && d4.push([+R.x, +R.y]);
          });
          var y4 = [], _ = [];
          t7(d4, y4, _);
          var S = this._min, T = this._max;
          _[0] - y4[0] === 0 && (y4[0] = S ? S[0] : y4[0] - 1, _[0] = T ? T[0] : _[0] + 1), _[1] - y4[1] === 0 && (y4[1] = S ? S[1] : y4[1] - 1, _[1] = T ? T[1] : _[1] + 1);
          var E = n6.coordinateSystem = new Z$();
          E.zoomLimit = n6.get("scaleLimit"), E.setBoundingRect(y4[0], y4[1], _[0] - y4[0], _[1] - y4[1]), E.setCenter(n6.get("center")), E.setZoom(n6.get("zoom")), this.group.attr({ x: E.x, y: E.y, scaleX: E.scaleX, scaleY: E.scaleY }), this._min = y4, this._max = _;
        }, a.prototype._updateController = function(n6, f6, d4) {
          var y4 = this, _ = this._controller, S = this._controllerHost, T = this.group;
          _.setPointerChecker(function(E, O, R) {
            var V = T.getBoundingRect();
            return V.applyTransform(T.transform), V.contain(O, R) && !Ioe(E, d4, n6);
          }), _.enable(n6.get("roam")), S.zoomLimit = n6.get("scaleLimit"), S.zoom = n6.coordinateSystem.getZoom(), _.off("pan").off("zoom").on("pan", function(E) {
            bSe(S, E.dx, E.dy), d4.dispatchAction({ seriesId: n6.id, type: "treeRoam", dx: E.dx, dy: E.dy });
          }).on("zoom", function(E) {
            _Se(S, E.scale, E.originX, E.originY), d4.dispatchAction({ seriesId: n6.id, type: "treeRoam", zoom: E.scale, originX: E.originX, originY: E.originY }), y4._updateNodeAndLinkScale(n6), d4.updateLabelLayout();
          });
        }, a.prototype._updateNodeAndLinkScale = function(n6) {
          var f6 = n6.getData(), d4 = this._getNodeGlobalScale(n6);
          f6.eachItemGraphicEl(function(y4, _) {
            y4.setSymbolScale(d4);
          });
        }, a.prototype._getNodeGlobalScale = function(n6) {
          var f6 = n6.coordinateSystem;
          if (f6.type !== "view")
            return 1;
          var d4 = this._nodeScaleRatio, y4 = f6.scaleX || 1, _ = f6.getZoom(), S = (_ - 1) * d4 + 1;
          return S / y4;
        }, a.prototype.dispose = function() {
          this._controller && this._controller.dispose(), this._controllerHost = null;
        }, a.prototype.remove = function() {
          this._mainGroup.removeAll(), this._data = null;
        }, a.type = "tree", a;
      }(Ch);
      function c$e(s, a) {
        var n6 = s.getItemLayout(a);
        return n6 && !isNaN(n6.x) && !isNaN(n6.y);
      }
      function f$e(s, a, n6, f6, d4) {
        var y4 = !n6, _ = s.tree.getNodeByDataIndex(a), S = _.getModel(), T = _.getVisual("style").fill, E = _.isExpand === false && _.children.length !== 0 ? T : "#fff", O = s.tree.root, R = _.parentNode === O ? _ : _.parentNode || _, V = s.getItemGraphicEl(R.dataIndex), z3 = R.getLayout(), H = V ? { x: V.__oldX, y: V.__oldY, rawX: V.__radialOldRawX, rawY: V.__radialOldRawY } : z3, Z = _.getLayout();
        y4 ? (n6 = new G$(s, a, null, { symbolInnerColor: E, useNameLabel: true }), n6.x = H.x, n6.y = H.y) : n6.updateData(s, a, null, { symbolInnerColor: E, useNameLabel: true }), n6.__radialOldRawX = n6.__radialRawX, n6.__radialOldRawY = n6.__radialRawY, n6.__radialRawX = Z.rawX, n6.__radialRawY = Z.rawY, f6.add(n6), s.setItemGraphicEl(a, n6), n6.__oldX = n6.x, n6.__oldY = n6.y, ku(n6, { x: Z.x, y: Z.y }, d4);
        var ee = n6.getSymbolPath();
        if (d4.get("layout") === "radial") {
          var oe = O.children[0], fe = oe.getLayout(), _e = oe.children.length, pe = void 0, Ve = void 0;
          if (Z.x === fe.x && _.isExpand === true) {
            var Le = { x: (oe.children[0].getLayout().x + oe.children[_e - 1].getLayout().x) / 2, y: (oe.children[0].getLayout().y + oe.children[_e - 1].getLayout().y) / 2 };
            pe = Math.atan2(Le.y - fe.y, Le.x - fe.x), pe < 0 && (pe = Math.PI * 2 + pe), Ve = Le.x < fe.x, Ve && (pe = pe - Math.PI);
          } else
            pe = Math.atan2(Z.y - fe.y, Z.x - fe.x), pe < 0 && (pe = Math.PI * 2 + pe), _.children.length === 0 || _.children.length !== 0 && _.isExpand === false ? (Ve = Z.x < fe.x, Ve && (pe = pe - Math.PI)) : (Ve = Z.x > fe.x, Ve || (pe = pe - Math.PI));
          var je = Ve ? "left" : "right", Xe = S.getModel("label"), Ye = Xe.get("rotate"), rt2 = Ye * (Math.PI / 180), ut = ee.getTextContent();
          ut && (ee.setTextConfig({ position: Xe.get("position") || je, rotation: Ye == null ? -pe : rt2, origin: "center" }), ut.setStyle("verticalAlign", "middle"));
        }
        var wt = S.get(["emphasis", "focus"]), dt = wt === "ancestor" ? _.getAncestorsIndices() : wt === "descendant" ? _.getDescendantIndices() : null;
        dt && (qo(n6).focus = dt), xBt(d4, _, O, n6, H, z3, Z, f6), n6.__edge && (n6.onHoverStateChange = function(Gt) {
          if (Gt !== "blur") {
            var Qt = _.parentNode && s.getItemGraphicEl(_.parentNode.dataIndex);
            Qt && Qt.hoverState === lp || DT(n6.__edge, Gt);
          }
        });
      }
      function xBt(s, a, n6, f6, d4, y4, _, S) {
        var T = a.getModel(), E = s.get("edgeShape"), O = s.get("layout"), R = s.getOrient(), V = s.get(["lineStyle", "curveness"]), z3 = s.get("edgeForkPosition"), H = T.getModel("lineStyle").getLineStyle(), Z = f6.__edge;
        if (E === "curve")
          a.parentNode && a.parentNode !== n6 && (Z || (Z = f6.__edge = new b7({ shape: ISe(O, R, V, d4, d4) })), ku(Z, { shape: ISe(O, R, V, y4, _) }, s));
        else if (E === "polyline" && O === "orthogonal" && a !== n6 && a.children && a.children.length !== 0 && a.isExpand === true) {
          for (var ee = a.children, oe = [], fe = 0; fe < ee.length; fe++) {
            var _e = ee[fe].getLayout();
            oe.push([_e.x, _e.y]);
          }
          Z || (Z = f6.__edge = new bBt({ shape: { parentPoint: [_.x, _.y], childPoints: [[_.x, _.y]], orient: R, forkPosition: z3 } })), ku(Z, { shape: { parentPoint: [_.x, _.y], childPoints: oe } }, s);
        }
        Z && (Z.useStyle(zo({ strokeNoScale: true, fill: null }, H)), Pg(Z, T, "lineStyle"), Wb(Z), S.add(Z));
      }
      function h$e(s, a, n6, f6, d4) {
        var y4 = a.tree.root, _ = p$e(y4, s), S = _.source, T = _.sourceLayout, E = a.getItemGraphicEl(s.dataIndex);
        if (E) {
          var O = a.getItemGraphicEl(S.dataIndex), R = O.__edge, V = E.__edge || (S.isExpand === false || S.children.length === 1 ? R : void 0), z3 = f6.get("edgeShape"), H = f6.get("layout"), Z = f6.get("orient"), ee = f6.get(["lineStyle", "curveness"]);
          V && (z3 === "curve" ? kT(V, { shape: ISe(H, Z, ee, T, T), style: { opacity: 0 } }, f6, { cb: function() {
            n6.remove(V);
          }, removeOpt: d4 }) : z3 === "polyline" && f6.get("layout") === "orthogonal" && kT(V, { shape: { parentPoint: [T.x, T.y], childPoints: [[T.x, T.y]] }, style: { opacity: 0 } }, f6, { cb: function() {
            n6.remove(V);
          }, removeOpt: d4 }));
        }
      }
      function p$e(s, a) {
        for (var n6 = a.parentNode === s ? a : a.parentNode || a, f6; f6 = n6.getLayout(), f6 == null; )
          n6 = n6.parentNode === s ? n6 : n6.parentNode || n6;
        return { source: n6, sourceLayout: f6 };
      }
      function d$e(s, a, n6, f6, d4) {
        var y4 = s.tree.getNodeByDataIndex(a), _ = s.tree.root, S = p$e(_, y4).sourceLayout, T = { duration: d4.get("animationDurationUpdate"), easing: d4.get("animationEasingUpdate") };
        kT(n6, { x: S.x + 1, y: S.y + 1 }, d4, { cb: function() {
          f6.remove(n6), s.setItemGraphicEl(a, null);
        }, removeOpt: T }), n6.fadeOut(null, s.hostModel, { fadeLabel: true, animation: T }), y4.children.forEach(function(E) {
          h$e(E, s, f6, d4, T);
        }), h$e(y4, s, f6, d4, T);
      }
      function ISe(s, a, n6, f6, d4) {
        var y4, _, S, T, E, O, R, V;
        if (s === "radial") {
          E = f6.rawX, R = f6.rawY, O = d4.rawX, V = d4.rawY;
          var z3 = J$(E, R), H = J$(E, R + (V - R) * n6), Z = J$(O, V + (R - V) * n6), ee = J$(O, V);
          return { x1: z3.x || 0, y1: z3.y || 0, x2: ee.x || 0, y2: ee.y || 0, cpx1: H.x || 0, cpy1: H.y || 0, cpx2: Z.x || 0, cpy2: Z.y || 0 };
        } else
          E = f6.x, R = f6.y, O = d4.x, V = d4.y, (a === "LR" || a === "RL") && (y4 = E + (O - E) * n6, _ = R, S = O + (E - O) * n6, T = V), (a === "TB" || a === "BT") && (y4 = E, _ = R + (V - R) * n6, S = O, T = V + (R - V) * n6);
        return { x1: E, y1: R, x2: O, y2: V, cpx1: y4, cpy1: _, cpx2: S, cpy2: T };
      }
      var wBt = _Bt, xS = hu();
      function v$e(s) {
        var a = s.mainData, n6 = s.datas;
        n6 || (n6 = { main: a }, s.datasAttr = { main: "data" }), s.datas = s.mainData = null, g$e(a, n6, s), gt(n6, function(f6) {
          gt(a.TRANSFERABLE_METHODS, function(d4) {
            f6.wrapMethod(d4, ks(SBt, s));
          });
        }), a.wrapMethod("cloneShallow", ks(MBt, s)), gt(a.CHANGABLE_METHODS, function(f6) {
          a.wrapMethod(f6, ks(CBt, s));
        }), Ty(n6[a.dataType] === a);
      }
      function SBt(s, a) {
        if (IBt(this)) {
          var n6 = ei({}, xS(this).datas);
          n6[this.dataType] = a, g$e(a, n6, s);
        } else
          ESe(a, this.dataType, xS(this).mainData, s);
        return a;
      }
      function CBt(s, a) {
        return s.struct && s.struct.update(), a;
      }
      function MBt(s, a) {
        return gt(xS(a).datas, function(n6, f6) {
          n6 !== a && ESe(n6.cloneShallow(), f6, a, s);
        }), a;
      }
      function TBt(s) {
        var a = xS(this).mainData;
        return s == null || a == null ? a : xS(a).datas[s];
      }
      function ABt() {
        var s = xS(this).mainData;
        return s == null ? [{ data: s }] : Pi(Wl(xS(s).datas), function(a) {
          return { type: a, data: xS(s).datas[a] };
        });
      }
      function IBt(s) {
        return xS(s).mainData === s;
      }
      function g$e(s, a, n6) {
        xS(s).datas = {}, gt(a, function(f6, d4) {
          ESe(f6, d4, s, n6);
        });
      }
      function ESe(s, a, n6, f6) {
        xS(n6).datas[a] = s, xS(s).mainData = n6, s.dataType = a, f6.struct && (s[f6.structAttr] = f6.struct, f6.struct[f6.datasAttr[a]] = s), s.getLinkedData = TBt, s.getLinkedDataAll = ABt;
      }
      var EBt = function() {
        function s(a, n6) {
          this.depth = 0, this.height = 0, this.dataIndex = -1, this.children = [], this.viewChildren = [], this.isExpand = false, this.name = a || "", this.hostTree = n6;
        }
        return s.prototype.isRemoved = function() {
          return this.dataIndex < 0;
        }, s.prototype.eachNode = function(a, n6, f6) {
          jo(a) && (f6 = n6, n6 = a, a = null), a = a || {}, Wa(a) && (a = { order: a });
          var d4 = a.order || "preorder", y4 = this[a.attr || "children"], _;
          d4 === "preorder" && (_ = n6.call(f6, this));
          for (var S = 0; !_ && S < y4.length; S++)
            y4[S].eachNode(a, n6, f6);
          d4 === "postorder" && n6.call(f6, this);
        }, s.prototype.updateDepthAndHeight = function(a) {
          var n6 = 0;
          this.depth = a;
          for (var f6 = 0; f6 < this.children.length; f6++) {
            var d4 = this.children[f6];
            d4.updateDepthAndHeight(a + 1), d4.height > n6 && (n6 = d4.height);
          }
          this.height = n6 + 1;
        }, s.prototype.getNodeById = function(a) {
          if (this.getId() === a)
            return this;
          for (var n6 = 0, f6 = this.children, d4 = f6.length; n6 < d4; n6++) {
            var y4 = f6[n6].getNodeById(a);
            if (y4)
              return y4;
          }
        }, s.prototype.contains = function(a) {
          if (a === this)
            return true;
          for (var n6 = 0, f6 = this.children, d4 = f6.length; n6 < d4; n6++) {
            var y4 = f6[n6].contains(a);
            if (y4)
              return y4;
          }
        }, s.prototype.getAncestors = function(a) {
          for (var n6 = [], f6 = a ? this : this.parentNode; f6; )
            n6.push(f6), f6 = f6.parentNode;
          return n6.reverse(), n6;
        }, s.prototype.getAncestorsIndices = function() {
          for (var a = [], n6 = this; n6; )
            a.push(n6.dataIndex), n6 = n6.parentNode;
          return a.reverse(), a;
        }, s.prototype.getDescendantIndices = function() {
          var a = [];
          return this.eachNode(function(n6) {
            a.push(n6.dataIndex);
          }), a;
        }, s.prototype.getValue = function(a) {
          var n6 = this.hostTree.data;
          return n6.getStore().get(n6.getDimensionIndex(a || "value"), this.dataIndex);
        }, s.prototype.setLayout = function(a, n6) {
          this.dataIndex >= 0 && this.hostTree.data.setItemLayout(this.dataIndex, a, n6);
        }, s.prototype.getLayout = function() {
          return this.hostTree.data.getItemLayout(this.dataIndex);
        }, s.prototype.getModel = function(a) {
          if (!(this.dataIndex < 0)) {
            var n6 = this.hostTree, f6 = n6.data.getItemModel(this.dataIndex);
            return f6.getModel(a);
          }
        }, s.prototype.getLevelModel = function() {
          return (this.hostTree.levelModels || [])[this.depth];
        }, s.prototype.setVisual = function(a, n6) {
          this.dataIndex >= 0 && this.hostTree.data.setItemVisual(this.dataIndex, a, n6);
        }, s.prototype.getVisual = function(a) {
          return this.hostTree.data.getItemVisual(this.dataIndex, a);
        }, s.prototype.getRawIndex = function() {
          return this.hostTree.data.getRawIndex(this.dataIndex);
        }, s.prototype.getId = function() {
          return this.hostTree.data.getId(this.dataIndex);
        }, s.prototype.getChildIndex = function() {
          if (this.parentNode) {
            for (var a = this.parentNode.children, n6 = 0; n6 < a.length; ++n6)
              if (a[n6] === this)
                return n6;
            return -1;
          }
          return -1;
        }, s.prototype.isAncestorOf = function(a) {
          for (var n6 = a.parentNode; n6; ) {
            if (n6 === this)
              return true;
            n6 = n6.parentNode;
          }
          return false;
        }, s.prototype.isDescendantOf = function(a) {
          return a !== this && a.isAncestorOf(this);
        }, s;
      }(), DBt = function() {
        function s(a) {
          this.type = "tree", this._nodes = [], this.hostModel = a;
        }
        return s.prototype.eachNode = function(a, n6, f6) {
          this.root.eachNode(a, n6, f6);
        }, s.prototype.getNodeByDataIndex = function(a) {
          var n6 = this.data.getRawIndex(a);
          return this._nodes[n6];
        }, s.prototype.getNodeById = function(a) {
          return this.root.getNodeById(a);
        }, s.prototype.update = function() {
          for (var a = this.data, n6 = this._nodes, f6 = 0, d4 = n6.length; f6 < d4; f6++)
            n6[f6].dataIndex = -1;
          for (var f6 = 0, d4 = a.count(); f6 < d4; f6++)
            n6[a.getRawIndex(f6)].dataIndex = f6;
        }, s.prototype.clearLayouts = function() {
          this.data.clearItemLayouts();
        }, s.createTree = function(a, n6, f6) {
          var d4 = new s(n6), y4 = [], _ = 1;
          S(a);
          function S(O, R) {
            var V = O.value;
            _ = Math.max(_, Di(V) ? V.length : 1), y4.push(O);
            var z3 = new EBt(Cd(O.name, ""), d4);
            R ? kBt(z3, R) : d4.root = z3, d4._nodes.push(z3);
            var H = O.children;
            if (H)
              for (var Z = 0; Z < H.length; Z++)
                S(H[Z], z3);
          }
          d4.root.updateDepthAndHeight(0);
          var T = O$(y4, { coordDimensions: ["value"], dimensionsCount: _ }).dimensions, E = new K1(T, n6);
          return E.initData(y4), f6 && f6(E), v$e({ mainData: E, struct: d4, structAttr: "tree" }), d4.update(), d4;
        }, s;
      }();
      function kBt(s, a) {
        var n6 = a.children;
        s.parentNode !== a && (n6.push(s), s.parentNode = a);
      }
      var DSe = DBt;
      function Q$(s, a, n6) {
        if (s && Ns(a, s.type) >= 0) {
          var f6 = n6.getData().tree.root, d4 = s.targetNode;
          if (Wa(d4) && (d4 = f6.getNodeById(d4)), d4 && f6.contains(d4))
            return { node: d4 };
          var y4 = s.targetNodeId;
          if (y4 != null && (d4 = f6.getNodeById(y4)))
            return { node: d4 };
        }
      }
      function y$e(s) {
        for (var a = []; s; )
          s = s.parentNode, s && a.push(s);
        return a.reverse();
      }
      function kSe(s, a) {
        var n6 = y$e(s);
        return Ns(n6, a) >= 0;
      }
      function Poe(s, a) {
        for (var n6 = []; s; ) {
          var f6 = s.dataIndex;
          n6.push({ name: s.name, dataIndex: f6, value: a.getRawValue(f6) }), s = s.parentNode;
        }
        return n6.reverse(), n6;
      }
      var OBt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.hasSymbolVisual = true, n6.ignoreStyleOnData = true, n6;
        }
        return a.prototype.getInitialData = function(n6) {
          var f6 = { name: n6.name, children: n6.data }, d4 = n6.leaves || {}, y4 = new Sh(d4, this, this.ecModel), _ = DSe.createTree(f6, this, S);
          function S(R) {
            R.wrapMethod("getItemModel", function(V, z3) {
              var H = _.getNodeByDataIndex(z3);
              return H && H.children.length && H.isExpand || (V.parentModel = y4), V;
            });
          }
          var T = 0;
          _.eachNode("preorder", function(R) {
            R.depth > T && (T = R.depth);
          });
          var E = n6.expandAndCollapse, O = E && n6.initialTreeDepth >= 0 ? n6.initialTreeDepth : T;
          return _.root.eachNode("preorder", function(R) {
            var V = R.hostTree.data.getRawDataItem(R.dataIndex);
            R.isExpand = V && V.collapsed != null ? !V.collapsed : R.depth <= O;
          }), _.data;
        }, a.prototype.getOrient = function() {
          var n6 = this.get("orient");
          return n6 === "horizontal" ? n6 = "LR" : n6 === "vertical" && (n6 = "TB"), n6;
        }, a.prototype.setZoom = function(n6) {
          this.option.zoom = n6;
        }, a.prototype.setCenter = function(n6) {
          this.option.center = n6;
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          for (var y4 = this.getData().tree, _ = y4.root.children[0], S = y4.getNodeByDataIndex(n6), T = S.getValue(), E = S.name; S && S !== _; )
            E = S.parentNode.name + "." + E, S = S.parentNode;
          return Rg("nameValue", { name: E, value: T, noValue: isNaN(T) || T == null });
        }, a.prototype.getDataParams = function(n6) {
          var f6 = s.prototype.getDataParams.apply(this, arguments), d4 = this.getData().tree.getNodeByDataIndex(n6);
          return f6.treeAncestors = Poe(d4, this), f6;
        }, a.type = "series.tree", a.layoutMode = "box", a.defaultOption = { z: 2, coordinateSystem: "view", left: "12%", top: "12%", right: "12%", bottom: "12%", layout: "orthogonal", edgeShape: "curve", edgeForkPosition: "50%", roam: false, nodeScaleRatio: 0.4, center: null, zoom: 1, orient: "LR", symbol: "emptyCircle", symbolSize: 7, expandAndCollapse: true, initialTreeDepth: 2, lineStyle: { color: "#ccc", width: 1.5, curveness: 0.5 }, itemStyle: { color: "lightsteelblue", borderWidth: 1.5 }, label: { show: true }, animationEasing: "linear", animationDuration: 700, animationDurationUpdate: 500 }, a;
      }(Cp), PBt = OBt;
      function LBt(s, a, n6) {
        for (var f6 = [s], d4 = [], y4; y4 = f6.pop(); )
          if (d4.push(y4), y4.isExpand) {
            var _ = y4.children;
            if (_.length)
              for (var S = 0; S < _.length; S++)
                f6.push(_[S]);
          }
        for (; y4 = d4.pop(); )
          a(y4, n6);
      }
      function eX(s, a) {
        for (var n6 = [s], f6; f6 = n6.pop(); )
          if (a(f6), f6.isExpand) {
            var d4 = f6.children;
            if (d4.length)
              for (var y4 = d4.length - 1; y4 >= 0; y4--)
                n6.push(d4[y4]);
          }
      }
      function RBt(s, a) {
        s.eachSeriesByType("tree", function(n6) {
          NBt(n6, a);
        });
      }
      function NBt(s, a) {
        var n6 = hBt(s, a);
        s.layoutInfo = n6;
        var f6 = s.get("layout"), d4 = 0, y4 = 0, _ = null;
        f6 === "radial" ? (d4 = 2 * Math.PI, y4 = Math.min(n6.height, n6.width) / 2, _ = u$e(function(_e, pe) {
          return (_e.parentNode === pe.parentNode ? 1 : 2) / _e.depth;
        })) : (d4 = n6.width, y4 = n6.height, _ = u$e());
        var S = s.getData().tree.root, T = S.children[0];
        if (T) {
          uBt(S), LBt(T, cBt, _), S.hierNode.modifier = -T.hierNode.prelim, eX(T, fBt);
          var E = T, O = T, R = T;
          eX(T, function(_e) {
            var pe = _e.getLayout().x;
            pe < E.getLayout().x && (E = _e), pe > O.getLayout().x && (O = _e), _e.depth > R.depth && (R = _e);
          });
          var V = E === O ? 1 : _(E, O) / 2, z3 = V - E.getLayout().x, H = 0, Z = 0, ee = 0, oe = 0;
          if (f6 === "radial")
            H = d4 / (O.getLayout().x + V + z3), Z = y4 / (R.depth - 1 || 1), eX(T, function(_e) {
              ee = (_e.getLayout().x + z3) * H, oe = (_e.depth - 1) * Z;
              var pe = J$(ee, oe);
              _e.setLayout({ x: pe.x, y: pe.y, rawX: ee, rawY: oe }, true);
            });
          else {
            var fe = s.getOrient();
            fe === "RL" || fe === "LR" ? (Z = y4 / (O.getLayout().x + V + z3), H = d4 / (R.depth - 1 || 1), eX(T, function(_e) {
              oe = (_e.getLayout().x + z3) * Z, ee = fe === "LR" ? (_e.depth - 1) * H : d4 - (_e.depth - 1) * H, _e.setLayout({ x: ee, y: oe }, true);
            })) : (fe === "TB" || fe === "BT") && (H = d4 / (O.getLayout().x + V + z3), Z = y4 / (R.depth - 1 || 1), eX(T, function(_e) {
              ee = (_e.getLayout().x + z3) * H, oe = fe === "TB" ? (_e.depth - 1) * Z : y4 - (_e.depth - 1) * Z, _e.setLayout({ x: ee, y: oe }, true);
            }));
          }
        }
      }
      function FBt(s) {
        s.eachSeriesByType("tree", function(a) {
          var n6 = a.getData(), f6 = n6.tree;
          f6.eachNode(function(d4) {
            var y4 = d4.getModel(), _ = y4.getModel("itemStyle").getItemStyle(), S = n6.ensureUniqueItemVisual(d4.dataIndex, "style");
            ei(S, _);
          });
        });
      }
      function VBt(s) {
        s.registerAction({ type: "treeExpandAndCollapse", event: "treeExpandAndCollapse", update: "update" }, function(a, n6) {
          n6.eachComponent({ mainType: "series", subType: "tree", query: a }, function(f6) {
            var d4 = a.dataIndex, y4 = f6.getData().tree, _ = y4.getNodeByDataIndex(d4);
            _.isExpand = !_.isExpand;
          });
        }), s.registerAction({ type: "treeRoam", event: "treeRoam", update: "none" }, function(a, n6) {
          n6.eachComponent({ mainType: "series", subType: "tree", query: a }, function(f6) {
            var d4 = f6.coordinateSystem, y4 = MSe(d4, a);
            f6.setCenter && f6.setCenter(y4.center), f6.setZoom && f6.setZoom(y4.zoom);
          });
        });
      }
      function BBt(s) {
        s.registerChartView(wBt), s.registerSeriesModel(PBt), s.registerLayout(RBt), s.registerVisual(FBt), VBt(s);
      }
      var m$e = ["treemapZoomToNode", "treemapRender", "treemapMove"];
      function zBt(s) {
        for (var a = 0; a < m$e.length; a++)
          s.registerAction({ type: m$e[a], update: "updateView" }, rd);
        s.registerAction({ type: "treemapRootToNode", update: "updateView" }, function(n6, f6) {
          f6.eachComponent({ mainType: "series", subType: "treemap", query: n6 }, d4);
          function d4(y4, _) {
            var S = ["treemapZoomToNode", "treemapRootToNode"], T = Q$(n6, S, y4);
            if (T) {
              var E = y4.getViewRoot();
              E && (n6.direction = kSe(E, T.node) ? "rollUp" : "drillDown"), y4.resetViewRoot(T.node);
            }
          }
        });
      }
      function b$e(s) {
        var a = s.getData(), n6 = a.tree, f6 = {};
        n6.eachNode(function(d4) {
          for (var y4 = d4; y4 && y4.depth > 1; )
            y4 = y4.parentNode;
          var _ = Vxe(s.ecModel, y4.name || y4.dataIndex + "", f6);
          d4.setVisual("decal", _);
        });
      }
      var jBt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.preventUsingHoverLayer = true, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          var d4 = { name: n6.name, children: n6.data };
          _$e(d4);
          var y4 = n6.levels || [], _ = this.designatedVisualItemStyle = {}, S = new Sh({ itemStyle: _ }, this, f6);
          y4 = n6.levels = GBt(y4, f6);
          var T = Pi(y4 || [], function(R) {
            return new Sh(R, S, f6);
          }, this), E = DSe.createTree(d4, this, O);
          function O(R) {
            R.wrapMethod("getItemModel", function(V, z3) {
              var H = E.getNodeByDataIndex(z3), Z = H ? T[H.depth] : null;
              return V.parentModel = Z || S, V;
            });
          }
          return E.data;
        }, a.prototype.optionUpdated = function() {
          this.resetViewRoot();
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          var y4 = this.getData(), _ = this.getRawValue(n6), S = y4.getName(n6);
          return Rg("nameValue", { name: S, value: _ });
        }, a.prototype.getDataParams = function(n6) {
          var f6 = s.prototype.getDataParams.apply(this, arguments), d4 = this.getData().tree.getNodeByDataIndex(n6);
          return f6.treeAncestors = Poe(d4, this), f6.treePathInfo = f6.treeAncestors, f6;
        }, a.prototype.setLayoutInfo = function(n6) {
          this.layoutInfo = this.layoutInfo || {}, ei(this.layoutInfo, n6);
        }, a.prototype.mapIdToIndex = function(n6) {
          var f6 = this._idIndexMap;
          f6 || (f6 = this._idIndexMap = ro(), this._idIndexMapCount = 0);
          var d4 = f6.get(n6);
          return d4 == null && f6.set(n6, d4 = this._idIndexMapCount++), d4;
        }, a.prototype.getViewRoot = function() {
          return this._viewRoot;
        }, a.prototype.resetViewRoot = function(n6) {
          n6 ? this._viewRoot = n6 : n6 = this._viewRoot;
          var f6 = this.getRawData().tree.root;
          (!n6 || n6 !== f6 && !f6.contains(n6)) && (this._viewRoot = f6);
        }, a.prototype.enableAriaDecal = function() {
          b$e(this);
        }, a.type = "series.treemap", a.layoutMode = "box", a.defaultOption = { progressive: 0, left: "center", top: "middle", width: "80%", height: "80%", sort: true, clipWindow: "origin", squareRatio: 0.5 * (1 + Math.sqrt(5)), leafDepth: null, drillDownIcon: "\u25B6", zoomToNodeRatio: 0.32 * 0.32, roam: true, nodeClick: "zoomToNode", animation: true, animationDurationUpdate: 900, animationEasing: "quinticInOut", breadcrumb: { show: true, height: 22, left: "center", top: "bottom", emptyItemWidth: 25, itemStyle: { color: "rgba(0,0,0,0.7)", textStyle: { color: "#fff" } } }, label: { show: true, distance: 0, padding: 5, position: "inside", color: "#fff", overflow: "truncate" }, upperLabel: { show: false, position: [0, "50%"], height: 20, overflow: "truncate", verticalAlign: "middle" }, itemStyle: { color: null, colorAlpha: null, colorSaturation: null, borderWidth: 0, gapWidth: 0, borderColor: "#fff", borderColorSaturation: null }, emphasis: { upperLabel: { show: true, position: [0, "50%"], overflow: "truncate", verticalAlign: "middle" } }, visualDimension: 0, visualMin: null, visualMax: null, color: [], colorAlpha: null, colorSaturation: null, colorMappingBy: "index", visibleMin: 10, childrenVisibleMin: null, levels: [] }, a;
      }(Cp);
      function _$e(s) {
        var a = 0;
        gt(s.children, function(f6) {
          _$e(f6);
          var d4 = f6.value;
          Di(d4) && (d4 = d4[0]), a += d4;
        });
        var n6 = s.value;
        Di(n6) && (n6 = n6[0]), (n6 == null || isNaN(n6)) && (n6 = a), n6 < 0 && (n6 = 0), Di(s.value) ? s.value[0] = n6 : s.value = n6;
      }
      function GBt(s, a) {
        var n6 = jc(a.get("color")), f6 = jc(a.get(["aria", "decal", "decals"]));
        if (n6) {
          s = s || [];
          var d4, y4;
          gt(s, function(S) {
            var T = new Sh(S), E = T.get("color"), O = T.get("decal");
            (T.get(["itemStyle", "color"]) || E && E !== "none") && (d4 = true), (T.get(["itemStyle", "decal"]) || O && O !== "none") && (y4 = true);
          });
          var _ = s[0] || (s[0] = {});
          return d4 || (_.color = n6.slice()), !y4 && f6 && (_.decal = f6.slice()), s;
        }
      }
      var HBt = jBt, WBt = 8, x$e = 8, OSe = 5, UBt = function() {
        function s(a) {
          this.group = new fs(), a.add(this.group);
        }
        return s.prototype.render = function(a, n6, f6, d4) {
          var y4 = a.getModel("breadcrumb"), _ = this.group;
          if (_.removeAll(), !(!y4.get("show") || !f6)) {
            var S = y4.getModel("itemStyle"), T = S.getModel("textStyle"), E = { pos: { left: y4.get("left"), right: y4.get("right"), top: y4.get("top"), bottom: y4.get("bottom") }, box: { width: n6.getWidth(), height: n6.getHeight() }, emptyItemWidth: y4.get("emptyItemWidth"), totalWidth: 0, renderList: [] };
            this._prepare(f6, E, T), this._renderContent(a, E, S, T, d4), Oae(_, E.pos, E.box);
          }
        }, s.prototype._prepare = function(a, n6, f6) {
          for (var d4 = a; d4; d4 = d4.parentNode) {
            var y4 = Cd(d4.getModel().get("name"), ""), _ = f6.getTextRect(y4), S = Math.max(_.width + WBt * 2, n6.emptyItemWidth);
            n6.totalWidth += S + x$e, n6.renderList.push({ node: d4, text: y4, width: S });
          }
        }, s.prototype._renderContent = function(a, n6, f6, d4, y4) {
          for (var _ = 0, S = n6.emptyItemWidth, T = a.get(["breadcrumb", "height"]), E = e4t(n6.pos, n6.box), O = n6.totalWidth, R = n6.renderList, V = R.length - 1; V >= 0; V--) {
            var z3 = R[V], H = z3.node, Z = z3.width, ee = z3.text;
            O > E.width && (O -= Z - S, Z = S, ee = null);
            var oe = new T0({ shape: { points: qBt(_, 0, Z, T, V === R.length - 1, V === 0) }, style: zo(f6.getItemStyle(), { lineJoin: "bevel" }), textContent: new ju({ style: { text: ee, fill: d4.getTextColor(), font: d4.getFont() } }), textConfig: { position: "inside" }, z2: jk * 1e4, onclick: ks(y4, H) });
            oe.disableLabelAnimation = true, this.group.add(oe), $Bt(oe, a, H), _ += Z + x$e;
          }
        }, s.prototype.remove = function() {
          this.group.removeAll();
        }, s;
      }();
      function qBt(s, a, n6, f6, d4, y4) {
        var _ = [[d4 ? s : s - OSe, a], [s + n6, a], [s + n6, a + f6], [d4 ? s : s - OSe, a + f6]];
        return !y4 && _.splice(2, 0, [s + n6 + OSe, a + f6 / 2]), !d4 && _.push([s, a + f6 / 2]), _;
      }
      function $Bt(s, a, n6) {
        qo(s).eventData = { componentType: "series", componentSubType: "treemap", componentIndex: a.componentIndex, seriesIndex: a.seriesIndex, seriesName: a.name, seriesType: "treemap", selfType: "breadcrumb", nodeData: { dataIndex: n6 && n6.dataIndex, name: n6 && n6.name }, treePathInfo: n6 && Poe(n6, a) };
      }
      var XBt = UBt, YBt = function() {
        function s() {
          this._storage = [], this._elExistsMap = {};
        }
        return s.prototype.add = function(a, n6, f6, d4, y4) {
          return this._elExistsMap[a.id] ? false : (this._elExistsMap[a.id] = true, this._storage.push({ el: a, target: n6, duration: f6, delay: d4, easing: y4 }), true);
        }, s.prototype.finished = function(a) {
          return this._finishedCallback = a, this;
        }, s.prototype.start = function() {
          for (var a = this, n6 = this._storage.length, f6 = function() {
            n6--, n6 <= 0 && (a._storage.length = 0, a._elExistsMap = {}, a._finishedCallback && a._finishedCallback());
          }, d4 = 0, y4 = this._storage.length; d4 < y4; d4++) {
            var _ = this._storage[d4];
            _.el.animateTo(_.target, { duration: _.duration, delay: _.delay, easing: _.easing, setToFinal: true, done: f6, aborted: f6 });
          }
          return this;
        }, s;
      }();
      function KBt() {
        return new YBt();
      }
      var PSe = fs, w$e = xu, S$e = 3, C$e = "label", M$e = "upperLabel", ZBt = jk * 10, JBt = jk * 2, QBt = jk * 3, e4 = vE([["fill", "color"], ["stroke", "strokeColor"], ["lineWidth", "strokeWidth"], ["shadowBlur"], ["shadowOffsetX"], ["shadowOffsetY"], ["shadowColor"]]), T$e = function(s) {
        var a = e4(s);
        return a.stroke = a.fill = a.lineWidth = null, a;
      }, Loe = hu(), ezt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._state = "ready", n6._storage = tX(), n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          var _ = f6.findComponents({ mainType: "series", subType: "treemap", query: y4 });
          if (!(Ns(_, n6) < 0)) {
            this.seriesModel = n6, this.api = d4, this.ecModel = f6;
            var S = ["treemapZoomToNode", "treemapRootToNode"], T = Q$(y4, S, n6), E = y4 && y4.type, O = n6.layoutInfo, R = !this._oldTree, V = this._storage, z3 = E === "treemapRootToNode" && T && V ? { rootNodeGroup: V.nodeGroup[T.node.getRawIndex()], direction: y4.direction } : null, H = this._giveContainerGroup(O), Z = n6.get("animation"), ee = this._doRender(H, n6, z3);
            Z && !R && (!E || E === "treemapZoomToNode" || E === "treemapRootToNode") ? this._doAnimation(H, ee, n6, z3) : ee.renderFinally(), this._resetController(d4), this._renderBreadcrumb(n6, d4, T);
          }
        }, a.prototype._giveContainerGroup = function(n6) {
          var f6 = this._containerGroup;
          return f6 || (f6 = this._containerGroup = new PSe(), this._initEvents(f6), this.group.add(f6)), f6.x = n6.x, f6.y = n6.y, f6;
        }, a.prototype._doRender = function(n6, f6, d4) {
          var y4 = f6.getData().tree, _ = this._oldTree, S = tX(), T = tX(), E = this._storage, O = [];
          function R(ee, oe, fe, _e) {
            return tzt(f6, T, E, d4, S, O, ee, oe, fe, _e);
          }
          z3(y4.root ? [y4.root] : [], _ && _.root ? [_.root] : [], n6, y4 === _ || !_, 0);
          var V = H(E);
          return this._oldTree = y4, this._storage = T, { lastsForAnimation: S, willDeleteEls: V, renderFinally: Z };
          function z3(ee, oe, fe, _e, pe) {
            _e ? (oe = ee, gt(ee, function(je, Xe) {
              !je.isRemoved() && Le(Xe, Xe);
            })) : new OE(oe, ee, Ve, Ve).add(Le).update(Le).remove(ks(Le, null)).execute();
            function Ve(je) {
              return je.getId();
            }
            function Le(je, Xe) {
              var Ye = je != null ? ee[je] : null, rt2 = Xe != null ? oe[Xe] : null, ut = R(Ye, rt2, fe, pe);
              ut && z3(Ye && Ye.viewChildren || [], rt2 && rt2.viewChildren || [], ut, _e, pe + 1);
            }
          }
          function H(ee) {
            var oe = tX();
            return ee && gt(ee, function(fe, _e) {
              var pe = oe[_e];
              gt(fe, function(Ve) {
                Ve && (pe.push(Ve), Loe(Ve).willDelete = true);
              });
            }), oe;
          }
          function Z() {
            gt(V, function(ee) {
              gt(ee, function(oe) {
                oe.parent && oe.parent.remove(oe);
              });
            }), gt(O, function(ee) {
              ee.invisible = true, ee.dirty();
            });
          }
        }, a.prototype._doAnimation = function(n6, f6, d4, y4) {
          var _ = d4.get("animationDurationUpdate"), S = d4.get("animationEasing"), T = (jo(_) ? 0 : _) || 0, E = (jo(S) ? null : S) || "cubicOut", O = KBt();
          gt(f6.willDeleteEls, function(R, V) {
            gt(R, function(z3, H) {
              if (!z3.invisible) {
                var Z = z3.parent, ee, oe = Loe(Z);
                if (y4 && y4.direction === "drillDown")
                  ee = Z === y4.rootNodeGroup ? { shape: { x: 0, y: 0, width: oe.nodeWidth, height: oe.nodeHeight }, style: { opacity: 0 } } : { style: { opacity: 0 } };
                else {
                  var fe = 0, _e = 0;
                  oe.willDelete || (fe = oe.nodeWidth / 2, _e = oe.nodeHeight / 2), ee = V === "nodeGroup" ? { x: fe, y: _e, style: { opacity: 0 } } : { shape: { x: fe, y: _e, width: 0, height: 0 }, style: { opacity: 0 } };
                }
                ee && O.add(z3, ee, T, 0, E);
              }
            });
          }), gt(this._storage, function(R, V) {
            gt(R, function(z3, H) {
              var Z = f6.lastsForAnimation[V][H], ee = {};
              !Z || (z3 instanceof fs ? Z.oldX != null && (ee.x = z3.x, ee.y = z3.y, z3.x = Z.oldX, z3.y = Z.oldY) : (Z.oldShape && (ee.shape = ei({}, z3.shape), z3.setShape(Z.oldShape)), Z.fadein ? (z3.setStyle("opacity", 0), ee.style = { opacity: 1 }) : z3.style.opacity !== 1 && (ee.style = { opacity: 1 })), O.add(z3, ee, T, 0, E));
            });
          }, this), this._state = "animating", O.finished(Za(function() {
            this._state = "ready", f6.renderFinally();
          }, this)).start();
        }, a.prototype._resetController = function(n6) {
          var f6 = this._controller;
          f6 || (f6 = this._controller = new Y$(n6.getZr()), f6.enable(this.seriesModel.get("roam")), f6.on("pan", Za(this._onPan, this)), f6.on("zoom", Za(this._onZoom, this)));
          var d4 = new il(0, 0, n6.getWidth(), n6.getHeight());
          f6.setPointerChecker(function(y4, _, S) {
            return d4.contain(_, S);
          });
        }, a.prototype._clearController = function() {
          var n6 = this._controller;
          n6 && (n6.dispose(), n6 = null);
        }, a.prototype._onPan = function(n6) {
          if (this._state !== "animating" && (Math.abs(n6.dx) > S$e || Math.abs(n6.dy) > S$e)) {
            var f6 = this.seriesModel.getData().tree.root;
            if (!f6)
              return;
            var d4 = f6.getLayout();
            if (!d4)
              return;
            this.api.dispatchAction({ type: "treemapMove", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: d4.x + n6.dx, y: d4.y + n6.dy, width: d4.width, height: d4.height } });
          }
        }, a.prototype._onZoom = function(n6) {
          var f6 = n6.originX, d4 = n6.originY;
          if (this._state !== "animating") {
            var y4 = this.seriesModel.getData().tree.root;
            if (!y4)
              return;
            var _ = y4.getLayout();
            if (!_)
              return;
            var S = new il(_.x, _.y, _.width, _.height), T = this.seriesModel.layoutInfo;
            f6 -= T.x, d4 -= T.y;
            var E = Bb();
            zb(E, E, [-f6, -d4]), L9(E, E, [n6.scale, n6.scale]), zb(E, E, [f6, d4]), S.applyTransform(E), this.api.dispatchAction({ type: "treemapRender", from: this.uid, seriesId: this.seriesModel.id, rootRect: { x: S.x, y: S.y, width: S.width, height: S.height } });
          }
        }, a.prototype._initEvents = function(n6) {
          var f6 = this;
          n6.on("click", function(d4) {
            if (f6._state === "ready") {
              var y4 = f6.seriesModel.get("nodeClick", true);
              if (y4) {
                var _ = f6.findTarget(d4.offsetX, d4.offsetY);
                if (_) {
                  var S = _.node;
                  if (S.getLayout().isLeafRoot)
                    f6._rootToNode(_);
                  else if (y4 === "zoomToNode")
                    f6._zoomToNode(_);
                  else if (y4 === "link") {
                    var T = S.hostTree.data.getItemModel(S.dataIndex), E = T.get("link", true), O = T.get("target", true) || "blank";
                    E && Dae(E, O);
                  }
                }
              }
            }
          }, this);
        }, a.prototype._renderBreadcrumb = function(n6, f6, d4) {
          var y4 = this;
          d4 || (d4 = n6.get("leafDepth", true) != null ? { node: n6.getViewRoot() } : this.findTarget(f6.getWidth() / 2, f6.getHeight() / 2), d4 || (d4 = { node: n6.getData().tree.root })), (this._breadcrumb || (this._breadcrumb = new XBt(this.group))).render(n6, f6, d4.node, function(_) {
            y4._state !== "animating" && (kSe(n6.getViewRoot(), _) ? y4._rootToNode({ node: _ }) : y4._zoomToNode({ node: _ }));
          });
        }, a.prototype.remove = function() {
          this._clearController(), this._containerGroup && this._containerGroup.removeAll(), this._storage = tX(), this._state = "ready", this._breadcrumb && this._breadcrumb.remove();
        }, a.prototype.dispose = function() {
          this._clearController();
        }, a.prototype._zoomToNode = function(n6) {
          this.api.dispatchAction({ type: "treemapZoomToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: n6.node });
        }, a.prototype._rootToNode = function(n6) {
          this.api.dispatchAction({ type: "treemapRootToNode", from: this.uid, seriesId: this.seriesModel.id, targetNode: n6.node });
        }, a.prototype.findTarget = function(n6, f6) {
          var d4, y4 = this.seriesModel.getViewRoot();
          return y4.eachNode({ attr: "viewChildren", order: "preorder" }, function(_) {
            var S = this._storage.background[_.getRawIndex()];
            if (S) {
              var T = S.transformCoordToLocal(n6, f6), E = S.shape;
              if (E.x <= T[0] && T[0] <= E.x + E.width && E.y <= T[1] && T[1] <= E.y + E.height)
                d4 = { node: _, offsetX: T[0], offsetY: T[1] };
              else
                return false;
            }
          }, this), d4;
        }, a.type = "treemap", a;
      }(Ch);
      function tX() {
        return { nodeGroup: [], background: [], content: [] };
      }
      function tzt(s, a, n6, f6, d4, y4, _, S, T, E) {
        if (!_)
          return;
        var O = _.getLayout(), R = s.getData(), V = _.getModel();
        if (R.setItemGraphicEl(_.dataIndex, null), !O || !O.isInView)
          return;
        var z3 = O.width, H = O.height, Z = O.borderWidth, ee = O.invisible, oe = _.getRawIndex(), fe = S && S.getRawIndex(), _e = _.viewChildren, pe = O.upperHeight, Ve = _e && _e.length, Le = V.getModel("itemStyle"), je = V.getModel(["emphasis", "itemStyle"]), Xe = V.getModel(["blur", "itemStyle"]), Ye = V.getModel(["select", "itemStyle"]), rt2 = Le.get("borderRadius") || 0, ut = Ja("nodeGroup", PSe);
        if (!ut)
          return;
        if (T.add(ut), ut.x = O.x || 0, ut.y = O.y || 0, ut.markRedraw(), Loe(ut).nodeWidth = z3, Loe(ut).nodeHeight = H, O.isAboveViewRoot)
          return ut;
        var wt = Ja("background", w$e, E, JBt);
        wt && pn(ut, wt, Ve && O.upperLabelHeight);
        var dt = V.getModel("emphasis"), Gt = dt.get("focus"), Qt = dt.get("blurScope"), Nt = dt.get("disabled"), er = Gt === "ancestor" ? _.getAncestorsIndices() : Gt === "descendant" ? _.getDescendantIndices() : Gt;
        if (Ve)
          MR(ut) && AE(ut, false), wt && (AE(wt, !Nt), R.setItemGraphicEl(_.dataIndex, wt), Bq(wt, er, Qt));
        else {
          var un = Ja("content", w$e, E, QBt);
          un && On(ut, un), wt.disableMorphing = true, wt && MR(wt) && AE(wt, false), AE(ut, !Nt), R.setItemGraphicEl(_.dataIndex, ut), Bq(ut, er, Qt);
        }
        return ut;
        function pn(So, Fa, po) {
          var To = qo(Fa);
          if (To.dataIndex = _.dataIndex, To.seriesIndex = s.seriesIndex, Fa.setShape({ x: 0, y: 0, width: z3, height: H, r: rt2 }), ee)
            fr(Fa);
          else {
            Fa.invisible = false;
            var Ya = _.getVisual("style"), $o = Ya.stroke, Hu = T$e(Le);
            Hu.fill = $o;
            var ms = e4(je);
            ms.fill = je.get("borderColor");
            var sc = e4(Xe);
            sc.fill = Xe.get("borderColor");
            var Oc = e4(Ye);
            if (Oc.fill = Ye.get("borderColor"), po) {
              var _c2 = z3 - 2 * Z;
              yr(Fa, $o, Ya.opacity, { x: Z, y: 0, width: _c2, height: pe });
            } else
              Fa.removeTextContent();
            Fa.setStyle(Hu), Fa.ensureState("emphasis").style = ms, Fa.ensureState("blur").style = sc, Fa.ensureState("select").style = Oc, Wb(Fa);
          }
          So.add(Fa);
        }
        function On(So, Fa) {
          var po = qo(Fa);
          po.dataIndex = _.dataIndex, po.seriesIndex = s.seriesIndex;
          var To = Math.max(z3 - 2 * Z, 0), Ya = Math.max(H - 2 * Z, 0);
          if (Fa.culling = true, Fa.setShape({ x: Z, y: Z, width: To, height: Ya, r: rt2 }), ee)
            fr(Fa);
          else {
            Fa.invisible = false;
            var $o = _.getVisual("style"), Hu = $o.fill, ms = T$e(Le);
            ms.fill = Hu, ms.decal = $o.decal;
            var sc = e4(je), Oc = e4(Xe), _c2 = e4(Ye);
            yr(Fa, Hu, $o.opacity, null), Fa.setStyle(ms), Fa.ensureState("emphasis").style = sc, Fa.ensureState("blur").style = Oc, Fa.ensureState("select").style = _c2, Wb(Fa);
          }
          So.add(Fa);
        }
        function fr(So) {
          !So.invisible && y4.push(So);
        }
        function yr(So, Fa, po, To) {
          var Ya = V.getModel(To ? M$e : C$e), $o = Cd(V.get("name"), null), Hu = Ya.getShallow("show");
          Gm(So, E0(V, To ? M$e : C$e), { defaultText: Hu ? $o : null, inheritColor: Fa, defaultOpacity: po, labelFetcher: s, labelDataIndex: _.dataIndex });
          var ms = So.getTextContent();
          if (ms) {
            var sc = ms.style, Oc = s9(sc.padding || 0);
            To && (So.setTextConfig({ layoutRect: To }), ms.disableLabelLayout = true), ms.beforeUpdate = function() {
              var _v = Math.max((To ? To.width : So.shape.width) - Oc[1] - Oc[3], 0), cp = Math.max((To ? To.height : So.shape.height) - Oc[0] - Oc[2], 0);
              (sc.width !== _v || sc.height !== cp) && ms.setStyle({ width: _v, height: cp });
            }, sc.truncateMinChar = 2, sc.lineOverflow = "truncate", da(sc, To, O);
            var _c2 = ms.getState("emphasis");
            da(_c2 ? _c2.style : null, To, O);
          }
        }
        function da(So, Fa, po) {
          var To = So ? So.text : null;
          if (!Fa && po.isLeafRoot && To != null) {
            var Ya = s.get("drillDownIcon", true);
            So.text = Ya ? Ya + " " + To : To;
          }
        }
        function Ja(So, Fa, po, To) {
          var Ya = fe != null && n6[So][fe], $o = d4[So];
          return Ya ? (n6[So][fe] = null, ko($o, Ya)) : ee || (Ya = new Fa(), Ya instanceof Hb && (Ya.z2 = nzt(po, To)), wo($o, Ya)), a[So][oe] = Ya;
        }
        function ko(So, Fa) {
          var po = So[oe] = {};
          Fa instanceof PSe ? (po.oldX = Fa.x, po.oldY = Fa.y) : po.oldShape = ei({}, Fa.shape);
        }
        function wo(So, Fa) {
          var po = So[oe] = {}, To = _.parentNode, Ya = Fa instanceof fs;
          if (To && (!f6 || f6.direction === "drillDown")) {
            var $o = 0, Hu = 0, ms = d4.background[To.getRawIndex()];
            !f6 && ms && ms.oldShape && ($o = ms.oldShape.width, Hu = ms.oldShape.height), Ya ? (po.oldX = 0, po.oldY = Hu) : po.oldShape = { x: $o, y: Hu, width: 0, height: 0 };
          }
          po.fadein = !Ya;
        }
      }
      function nzt(s, a) {
        return s * ZBt + a;
      }
      var rzt = ezt, nX = gt, izt = Qo, Roe = -1, LSe = function() {
        function s(a) {
          var n6 = a.mappingMethod, f6 = a.type, d4 = this.option = Bo(a);
          this.type = f6, this.mappingMethod = n6, this._normalizeData = szt[n6];
          var y4 = s.visualHandlers[f6];
          this.applyVisual = y4.applyVisual, this.getColorMapper = y4.getColorMapper, this._normalizedToVisual = y4._normalizedToVisual[n6], n6 === "piecewise" ? (RSe(d4), azt(d4)) : n6 === "category" ? d4.categories ? ozt(d4) : RSe(d4, true) : (Ty(n6 !== "linear" || d4.dataExtent), RSe(d4));
        }
        return s.prototype.mapValueToVisual = function(a) {
          var n6 = this._normalizeData(a);
          return this._normalizedToVisual(n6, a);
        }, s.prototype.getNormalizer = function() {
          return Za(this._normalizeData, this);
        }, s.listVisualTypes = function() {
          return Wl(s.visualHandlers);
        }, s.isValidType = function(a) {
          return s.visualHandlers.hasOwnProperty(a);
        }, s.eachVisual = function(a, n6, f6) {
          Qo(a) ? gt(a, n6, f6) : n6.call(f6, a);
        }, s.mapVisual = function(a, n6, f6) {
          var d4, y4 = Di(a) ? [] : Qo(a) ? {} : (d4 = true, null);
          return s.eachVisual(a, function(_, S) {
            var T = n6.call(f6, _, S);
            d4 ? y4 = T : y4[S] = T;
          }), y4;
        }, s.retrieveVisuals = function(a) {
          var n6 = {}, f6;
          return a && nX(s.visualHandlers, function(d4, y4) {
            a.hasOwnProperty(y4) && (n6[y4] = a[y4], f6 = true);
          }), f6 ? n6 : null;
        }, s.prepareVisualTypes = function(a) {
          if (Di(a))
            a = a.slice();
          else if (izt(a)) {
            var n6 = [];
            nX(a, function(f6, d4) {
              n6.push(d4);
            }), a = n6;
          } else
            return [];
          return a.sort(function(f6, d4) {
            return d4 === "color" && f6 !== "color" && f6.indexOf("color") === 0 ? 1 : -1;
          }), a;
        }, s.dependsOn = function(a, n6) {
          return n6 === "color" ? !!(a && a.indexOf(n6) === 0) : a === n6;
        }, s.findPieceIndex = function(a, n6, f6) {
          for (var d4, y4 = 1 / 0, _ = 0, S = n6.length; _ < S; _++) {
            var T = n6[_].value;
            if (T != null) {
              if (T === a || Wa(T) && T === a + "")
                return _;
              f6 && V(T, _);
            }
          }
          for (var _ = 0, S = n6.length; _ < S; _++) {
            var E = n6[_], O = E.interval, R = E.close;
            if (O) {
              if (O[0] === -1 / 0) {
                if (Foe(R[1], a, O[1]))
                  return _;
              } else if (O[1] === 1 / 0) {
                if (Foe(R[0], O[0], a))
                  return _;
              } else if (Foe(R[0], O[0], a) && Foe(R[1], a, O[1]))
                return _;
              f6 && V(O[0], _), f6 && V(O[1], _);
            }
          }
          if (f6)
            return a === 1 / 0 ? n6.length - 1 : a === -1 / 0 ? 0 : d4;
          function V(z3, H) {
            var Z = Math.abs(z3 - a);
            Z < y4 && (y4 = Z, d4 = H);
          }
        }, s.visualHandlers = { color: { applyVisual: rX("color"), getColorMapper: function() {
          var a = this.option;
          return Za(a.mappingMethod === "category" ? function(n6, f6) {
            return !f6 && (n6 = this._normalizeData(n6)), iX.call(this, n6);
          } : function(n6, f6, d4) {
            var y4 = !!d4;
            return !f6 && (n6 = this._normalizeData(n6)), d4 = IU(n6, a.parsedVisual, d4), y4 ? d4 : oC(d4, "rgba");
          }, this);
        }, _normalizedToVisual: { linear: function(a) {
          return oC(IU(a, this.option.parsedVisual), "rgba");
        }, category: iX, piecewise: function(a, n6) {
          var f6 = FSe.call(this, n6);
          return f6 == null && (f6 = oC(IU(a, this.option.parsedVisual), "rgba")), f6;
        }, fixed: t4 } }, colorHue: Noe(function(a, n6) {
          return Y_(a, n6);
        }), colorSaturation: Noe(function(a, n6) {
          return Y_(a, null, n6);
        }), colorLightness: Noe(function(a, n6) {
          return Y_(a, null, null, n6);
        }), colorAlpha: Noe(function(a, n6) {
          return m9(a, n6);
        }), decal: { applyVisual: rX("decal"), _normalizedToVisual: { linear: null, category: iX, piecewise: null, fixed: null } }, opacity: { applyVisual: rX("opacity"), _normalizedToVisual: NSe([0, 1]) }, liftZ: { applyVisual: rX("liftZ"), _normalizedToVisual: { linear: t4, category: t4, piecewise: t4, fixed: t4 } }, symbol: { applyVisual: function(a, n6, f6) {
          var d4 = this.mapValueToVisual(a);
          f6("symbol", d4);
        }, _normalizedToVisual: { linear: A$e, category: iX, piecewise: function(a, n6) {
          var f6 = FSe.call(this, n6);
          return f6 == null && (f6 = A$e.call(this, a)), f6;
        }, fixed: t4 } }, symbolSize: { applyVisual: rX("symbolSize"), _normalizedToVisual: NSe([0, 1]) } }, s;
      }();
      function azt(s) {
        var a = s.pieceList;
        s.hasSpecialVisual = false, gt(a, function(n6, f6) {
          n6.originIndex = f6, n6.visual != null && (s.hasSpecialVisual = true);
        });
      }
      function ozt(s) {
        var a = s.categories, n6 = s.categoryMap = {}, f6 = s.visual;
        if (nX(a, function(_, S) {
          n6[_] = S;
        }), !Di(f6)) {
          var d4 = [];
          Qo(f6) ? nX(f6, function(_, S) {
            var T = n6[S];
            d4[T != null ? T : Roe] = _;
          }) : d4[Roe] = f6, f6 = I$e(s, d4);
        }
        for (var y4 = a.length - 1; y4 >= 0; y4--)
          f6[y4] == null && (delete n6[a[y4]], a.pop());
      }
      function RSe(s, a) {
        var n6 = s.visual, f6 = [];
        Qo(n6) ? nX(n6, function(y4) {
          f6.push(y4);
        }) : n6 != null && f6.push(n6);
        var d4 = { color: 1, symbol: 1 };
        !a && f6.length === 1 && !d4.hasOwnProperty(s.type) && (f6[1] = f6[0]), I$e(s, f6);
      }
      function Noe(s) {
        return { applyVisual: function(a, n6, f6) {
          var d4 = this.mapValueToVisual(a);
          f6("color", s(n6("color"), d4));
        }, _normalizedToVisual: NSe([0, 1]) };
      }
      function A$e(s) {
        var a = this.option.visual;
        return a[Math.round(zu(s, [0, 1], [0, a.length - 1], true))] || {};
      }
      function rX(s) {
        return function(a, n6, f6) {
          f6(s, this.mapValueToVisual(a));
        };
      }
      function iX(s) {
        var a = this.option.visual;
        return a[this.option.loop && s !== Roe ? s % a.length : s];
      }
      function t4() {
        return this.option.visual[0];
      }
      function NSe(s) {
        return { linear: function(a) {
          return zu(a, s, this.option.visual, true);
        }, category: iX, piecewise: function(a, n6) {
          var f6 = FSe.call(this, n6);
          return f6 == null && (f6 = zu(a, s, this.option.visual, true)), f6;
        }, fixed: t4 };
      }
      function FSe(s) {
        var a = this.option, n6 = a.pieceList;
        if (a.hasSpecialVisual) {
          var f6 = LSe.findPieceIndex(s, n6), d4 = n6[f6];
          if (d4 && d4.visual)
            return d4.visual[this.type];
        }
      }
      function I$e(s, a) {
        return s.visual = a, s.type === "color" && (s.parsedVisual = Pi(a, function(n6) {
          return w0(n6);
        })), a;
      }
      var szt = { linear: function(s) {
        return zu(s, this.option.dataExtent, [0, 1], true);
      }, piecewise: function(s) {
        var a = this.option.pieceList, n6 = LSe.findPieceIndex(s, a, true);
        if (n6 != null)
          return zu(n6, [0, a.length - 1], [0, 1], true);
      }, category: function(s) {
        var a = this.option.categories ? this.option.categoryMap[s] : s;
        return a == null ? Roe : a;
      }, fixed: rd };
      function Foe(s, a, n6) {
        return s ? a <= n6 : a < n6;
      }
      var zy = LSe, lzt = "itemStyle", E$e = hu(), uzt = { seriesType: "treemap", reset: function(s) {
        var a = s.getData().tree, n6 = a.root;
        n6.isRemoved() || D$e(n6, {}, s.getViewRoot().getAncestors(), s);
      } };
      function D$e(s, a, n6, f6) {
        var d4 = s.getModel(), y4 = s.getLayout(), _ = s.hostTree.data;
        if (!(!y4 || y4.invisible || !y4.isInView)) {
          var S = d4.getModel(lzt), T = czt(S, a, f6), E = _.ensureUniqueItemVisual(s.dataIndex, "style"), O = S.get("borderColor"), R = S.get("borderColorSaturation"), V;
          R != null && (V = k$e(T), O = fzt(R, V)), E.stroke = O;
          var z3 = s.viewChildren;
          if (!z3 || !z3.length)
            V = k$e(T), E.fill = V;
          else {
            var H = hzt(s, d4, y4, S, T, z3);
            gt(z3, function(Z, ee) {
              if (Z.depth >= n6.length || Z === n6[Z.depth]) {
                var oe = pzt(d4, T, Z, ee, H, f6);
                D$e(Z, oe, n6, f6);
              }
            });
          }
        }
      }
      function czt(s, a, n6) {
        var f6 = ei({}, a), d4 = n6.designatedVisualItemStyle;
        return gt(["color", "colorAlpha", "colorSaturation"], function(y4) {
          d4[y4] = a[y4];
          var _ = s.get(y4);
          d4[y4] = null, _ != null && (f6[y4] = _);
        }), f6;
      }
      function k$e(s) {
        var a = VSe(s, "color");
        if (a) {
          var n6 = VSe(s, "colorAlpha"), f6 = VSe(s, "colorSaturation");
          return f6 && (a = Y_(a, null, null, f6)), n6 && (a = m9(a, n6)), a;
        }
      }
      function fzt(s, a) {
        return a != null ? Y_(a, null, null, s) : null;
      }
      function VSe(s, a) {
        var n6 = s[a];
        if (n6 != null && n6 !== "none")
          return n6;
      }
      function hzt(s, a, n6, f6, d4, y4) {
        if (!(!y4 || !y4.length)) {
          var _ = BSe(a, "color") || d4.color != null && d4.color !== "none" && (BSe(a, "colorAlpha") || BSe(a, "colorSaturation"));
          if (_) {
            var S = a.get("visualMin"), T = a.get("visualMax"), E = n6.dataExtent.slice();
            S != null && S < E[0] && (E[0] = S), T != null && T > E[1] && (E[1] = T);
            var O = a.get("colorMappingBy"), R = { type: _.name, dataExtent: E, visual: _.range };
            R.type === "color" && (O === "index" || O === "id") ? (R.mappingMethod = "category", R.loop = true) : R.mappingMethod = "linear";
            var V = new zy(R);
            return E$e(V).drColorMappingBy = O, V;
          }
        }
      }
      function BSe(s, a) {
        var n6 = s.get(a);
        return Di(n6) && n6.length ? { name: a, range: n6 } : null;
      }
      function pzt(s, a, n6, f6, d4, y4) {
        var _ = ei({}, a);
        if (d4) {
          var S = d4.type, T = S === "color" && E$e(d4).drColorMappingBy, E = T === "index" ? f6 : T === "id" ? y4.mapIdToIndex(n6.getId()) : n6.getValue(s.get("visualDimension"));
          _[S] = d4.mapValueToVisual(E);
        }
        return _;
      }
      var aX = Math.max, Voe = Math.min, O$e = $v, zSe = gt, P$e = ["itemStyle", "borderWidth"], dzt = ["itemStyle", "gapWidth"], vzt = ["upperLabel", "show"], gzt = ["upperLabel", "height"], yzt = { seriesType: "treemap", reset: function(s, a, n6, f6) {
        var d4 = n6.getWidth(), y4 = n6.getHeight(), _ = s.option, S = Qv(s.getBoxLayoutParams(), { width: n6.getWidth(), height: n6.getHeight() }), T = _.size || [], E = Ia(O$e(S.width, T[0]), d4), O = Ia(O$e(S.height, T[1]), y4), R = f6 && f6.type, V = ["treemapZoomToNode", "treemapRootToNode"], z3 = Q$(f6, V, s), H = R === "treemapRender" || R === "treemapMove" ? f6.rootRect : null, Z = s.getViewRoot(), ee = y$e(Z);
        if (R !== "treemapMove") {
          var oe = R === "treemapZoomToNode" ? Szt(s, z3, Z, E, O) : H ? [H.width, H.height] : [E, O], fe = _.sort;
          fe && fe !== "asc" && fe !== "desc" && (fe = "desc");
          var _e = { squareRatio: _.squareRatio, sort: fe, leafDepth: _.leafDepth };
          Z.hostTree.clearLayouts();
          var pe = { x: 0, y: 0, width: oe[0], height: oe[1], area: oe[0] * oe[1] };
          Z.setLayout(pe), L$e(Z, _e, false, 0), pe = Z.getLayout(), zSe(ee, function(Le, je) {
            var Xe = (ee[je + 1] || Z).getValue();
            Le.setLayout(ei({ dataExtent: [Xe, Xe], borderWidth: 0, upperHeight: 0 }, pe));
          });
        }
        var Ve = s.getData().tree.root;
        Ve.setLayout(Czt(S, H, z3), true), s.setLayoutInfo(S), N$e(Ve, new il(-S.x, -S.y, d4, y4), ee, Z, 0);
      } };
      function L$e(s, a, n6, f6) {
        var d4, y4;
        if (!s.isRemoved()) {
          var _ = s.getLayout();
          d4 = _.width, y4 = _.height;
          var S = s.getModel(), T = S.get(P$e), E = S.get(dzt) / 2, O = F$e(S), R = Math.max(T, O), V = T - E, z3 = R - E;
          s.setLayout({ borderWidth: T, upperHeight: R, upperLabelHeight: O }, true), d4 = aX(d4 - 2 * V, 0), y4 = aX(y4 - V - z3, 0);
          var H = d4 * y4, Z = mzt(s, S, H, a, n6, f6);
          if (Z.length) {
            var ee = { x: V, y: z3, width: d4, height: y4 }, oe = Voe(d4, y4), fe = 1 / 0, _e = [];
            _e.area = 0;
            for (var pe = 0, Ve = Z.length; pe < Ve; ) {
              var Le = Z[pe];
              _e.push(Le), _e.area += Le.getLayout().area;
              var je = wzt(_e, oe, a.squareRatio);
              je <= fe ? (pe++, fe = je) : (_e.area -= _e.pop().getLayout().area, R$e(_e, oe, ee, E, false), oe = Voe(ee.width, ee.height), _e.length = _e.area = 0, fe = 1 / 0);
            }
            if (_e.length && R$e(_e, oe, ee, E, true), !n6) {
              var Xe = S.get("childrenVisibleMin");
              Xe != null && H < Xe && (n6 = true);
            }
            for (var pe = 0, Ve = Z.length; pe < Ve; pe++)
              L$e(Z[pe], a, n6, f6 + 1);
          }
        }
      }
      function mzt(s, a, n6, f6, d4, y4) {
        var _ = s.children || [], S = f6.sort;
        S !== "asc" && S !== "desc" && (S = null);
        var T = f6.leafDepth != null && f6.leafDepth <= y4;
        if (d4 && !T)
          return s.viewChildren = [];
        _ = tf(_, function(z3) {
          return !z3.isRemoved();
        }), _zt(_, S);
        var E = xzt(a, _, S);
        if (E.sum === 0)
          return s.viewChildren = [];
        if (E.sum = bzt(a, n6, E.sum, S, _), E.sum === 0)
          return s.viewChildren = [];
        for (var O = 0, R = _.length; O < R; O++) {
          var V = _[O].getValue() / E.sum * n6;
          _[O].setLayout({ area: V });
        }
        return T && (_.length && s.setLayout({ isLeafRoot: true }, true), _.length = 0), s.viewChildren = _, s.setLayout({ dataExtent: E.dataExtent }, true), _;
      }
      function bzt(s, a, n6, f6, d4) {
        if (!f6)
          return n6;
        for (var y4 = s.get("visibleMin"), _ = d4.length, S = _, T = _ - 1; T >= 0; T--) {
          var E = d4[f6 === "asc" ? _ - T - 1 : T].getValue();
          E / n6 * a < y4 && (S = T, n6 -= E);
        }
        return f6 === "asc" ? d4.splice(0, _ - S) : d4.splice(S, _ - S), n6;
      }
      function _zt(s, a) {
        return a && s.sort(function(n6, f6) {
          var d4 = a === "asc" ? n6.getValue() - f6.getValue() : f6.getValue() - n6.getValue();
          return d4 === 0 ? a === "asc" ? n6.dataIndex - f6.dataIndex : f6.dataIndex - n6.dataIndex : d4;
        }), s;
      }
      function xzt(s, a, n6) {
        for (var f6 = 0, d4 = 0, y4 = a.length; d4 < y4; d4++)
          f6 += a[d4].getValue();
        var _ = s.get("visualDimension"), S;
        return !a || !a.length ? S = [NaN, NaN] : _ === "value" && n6 ? (S = [a[a.length - 1].getValue(), a[0].getValue()], n6 === "asc" && S.reverse()) : (S = [1 / 0, -1 / 0], zSe(a, function(T) {
          var E = T.getValue(_);
          E < S[0] && (S[0] = E), E > S[1] && (S[1] = E);
        })), { sum: f6, dataExtent: S };
      }
      function wzt(s, a, n6) {
        for (var f6 = 0, d4 = 1 / 0, y4 = 0, _ = void 0, S = s.length; y4 < S; y4++)
          _ = s[y4].getLayout().area, _ && (_ < d4 && (d4 = _), _ > f6 && (f6 = _));
        var T = s.area * s.area, E = a * a * n6;
        return T ? aX(E * f6 / T, T / (E * d4)) : 1 / 0;
      }
      function R$e(s, a, n6, f6, d4) {
        var y4 = a === n6.width ? 0 : 1, _ = 1 - y4, S = ["x", "y"], T = ["width", "height"], E = n6[S[y4]], O = a ? s.area / a : 0;
        (d4 || O > n6[T[_]]) && (O = n6[T[_]]);
        for (var R = 0, V = s.length; R < V; R++) {
          var z3 = s[R], H = {}, Z = O ? z3.getLayout().area / O : 0, ee = H[T[_]] = aX(O - 2 * f6, 0), oe = n6[S[y4]] + n6[T[y4]] - E, fe = R === V - 1 || oe < Z ? oe : Z, _e = H[T[y4]] = aX(fe - 2 * f6, 0);
          H[S[_]] = n6[S[_]] + Voe(f6, ee / 2), H[S[y4]] = E + Voe(f6, _e / 2), E += fe, z3.setLayout(H, true);
        }
        n6[S[_]] += O, n6[T[_]] -= O;
      }
      function Szt(s, a, n6, f6, d4) {
        var y4 = (a || {}).node, _ = [f6, d4];
        if (!y4 || y4 === n6)
          return _;
        for (var S, T = f6 * d4, E = T * s.option.zoomToNodeRatio; S = y4.parentNode; ) {
          for (var O = 0, R = S.children, V = 0, z3 = R.length; V < z3; V++)
            O += R[V].getValue();
          var H = y4.getValue();
          if (H === 0)
            return _;
          E *= O / H;
          var Z = S.getModel(), ee = Z.get(P$e), oe = Math.max(ee, F$e(Z));
          E += 4 * ee * ee + (3 * ee + oe) * Math.pow(E, 0.5), E > hR && (E = hR), y4 = S;
        }
        E < T && (E = T);
        var fe = Math.pow(E / T, 0.5);
        return [f6 * fe, d4 * fe];
      }
      function Czt(s, a, n6) {
        if (a)
          return { x: a.x, y: a.y };
        var f6 = { x: 0, y: 0 };
        if (!n6)
          return f6;
        var d4 = n6.node, y4 = d4.getLayout();
        if (!y4)
          return f6;
        for (var _ = [y4.width / 2, y4.height / 2], S = d4; S; ) {
          var T = S.getLayout();
          _[0] += T.x, _[1] += T.y, S = S.parentNode;
        }
        return { x: s.width / 2 - _[0], y: s.height / 2 - _[1] };
      }
      function N$e(s, a, n6, f6, d4) {
        var y4 = s.getLayout(), _ = n6[d4], S = _ && _ === s;
        if (!(_ && !S || d4 === n6.length && s !== f6)) {
          s.setLayout({ isInView: true, invisible: !S && !a.intersect(y4), isAboveViewRoot: S }, true);
          var T = new il(a.x - y4.x, a.y - y4.y, a.width, a.height);
          zSe(s.viewChildren || [], function(E) {
            N$e(E, T, n6, f6, d4 + 1);
          });
        }
      }
      function F$e(s) {
        return s.get(vzt) ? s.get(gzt) : 0;
      }
      function Mzt(s) {
        s.registerSeriesModel(HBt), s.registerChartView(rzt), s.registerVisual(uzt), s.registerLayout(yzt), zBt(s);
      }
      function Tzt(s) {
        var a = s.findComponents({ mainType: "legend" });
        !a || !a.length || s.eachSeriesByType("graph", function(n6) {
          var f6 = n6.getCategoriesData(), d4 = n6.getGraph(), y4 = d4.data, _ = f6.mapArray(f6.getName);
          y4.filterSelf(function(S) {
            var T = y4.getItemModel(S), E = T.getShallow("category");
            if (E != null) {
              ac(E) && (E = _[E]);
              for (var O = 0; O < a.length; O++)
                if (!a[O].isSelected(E))
                  return false;
            }
            return true;
          });
        });
      }
      function Azt(s) {
        var a = {};
        s.eachSeriesByType("graph", function(n6) {
          var f6 = n6.getCategoriesData(), d4 = n6.getData(), y4 = {};
          f6.each(function(_) {
            var S = f6.getName(_);
            y4["ec-" + S] = _;
            var T = f6.getItemModel(_), E = T.getModel("itemStyle").getItemStyle();
            E.fill || (E.fill = n6.getColorFromPalette(S, a)), f6.setItemVisual(_, "style", E);
            for (var O = ["symbol", "symbolSize", "symbolKeepAspect"], R = 0; R < O.length; R++) {
              var V = T.getShallow(O[R], true);
              V != null && f6.setItemVisual(_, O[R], V);
            }
          }), f6.count() && d4.each(function(_) {
            var S = d4.getItemModel(_), T = S.getShallow("category");
            if (T != null) {
              Wa(T) && (T = y4["ec-" + T]);
              var E = f6.getItemVisual(T, "style"), O = d4.ensureUniqueItemVisual(_, "style");
              ei(O, E);
              for (var R = ["symbol", "symbolSize", "symbolKeepAspect"], V = 0; V < R.length; V++)
                d4.setItemVisual(_, R[V], f6.getItemVisual(T, R[V]));
            }
          });
        });
      }
      function Boe(s) {
        return s instanceof Array || (s = [s, s]), s;
      }
      function Izt(s) {
        s.eachSeriesByType("graph", function(a) {
          var n6 = a.getGraph(), f6 = a.getEdgeData(), d4 = Boe(a.get("edgeSymbol")), y4 = Boe(a.get("edgeSymbolSize"));
          f6.setVisual("fromSymbol", d4 && d4[0]), f6.setVisual("toSymbol", d4 && d4[1]), f6.setVisual("fromSymbolSize", y4 && y4[0]), f6.setVisual("toSymbolSize", y4 && y4[1]), f6.setVisual("style", a.getModel("lineStyle").getLineStyle()), f6.each(function(_) {
            var S = f6.getItemModel(_), T = n6.getEdgeByIndex(_), E = Boe(S.getShallow("symbol", true)), O = Boe(S.getShallow("symbolSize", true)), R = S.getModel("lineStyle").getLineStyle(), V = f6.ensureUniqueItemVisual(_, "style");
            switch (ei(V, R), V.stroke) {
              case "source": {
                var z3 = T.node1.getVisual("style");
                V.stroke = z3 && z3.fill;
                break;
              }
              case "target": {
                var z3 = T.node2.getVisual("style");
                V.stroke = z3 && z3.fill;
                break;
              }
            }
            E[0] && T.setVisual("fromSymbol", E[0]), E[1] && T.setVisual("toSymbol", E[1]), O[0] && T.setVisual("fromSymbolSize", O[0]), O[1] && T.setVisual("toSymbolSize", O[1]);
          });
        });
      }
      var jSe = "-->", zoe = function(s) {
        return s.get("autoCurveness") || null;
      }, V$e = function(s, a) {
        var n6 = zoe(s), f6 = 20, d4 = [];
        if (ac(n6))
          f6 = n6;
        else if (Di(n6)) {
          s.__curvenessList = n6;
          return;
        }
        a > f6 && (f6 = a);
        var y4 = f6 % 2 ? f6 + 2 : f6 + 3;
        d4 = [];
        for (var _ = 0; _ < y4; _++)
          d4.push((_ % 2 ? _ + 1 : _) / 10 * (_ % 2 ? -1 : 1));
        s.__curvenessList = d4;
      }, oX = function(s, a, n6) {
        var f6 = [s.id, s.dataIndex].join("."), d4 = [a.id, a.dataIndex].join(".");
        return [n6.uid, f6, d4].join(jSe);
      }, B$e = function(s) {
        var a = s.split(jSe);
        return [a[0], a[2], a[1]].join(jSe);
      }, Ezt = function(s, a) {
        var n6 = oX(s.node1, s.node2, a);
        return a.__edgeMap[n6];
      }, Dzt = function(s, a) {
        var n6 = GSe(oX(s.node1, s.node2, a), a), f6 = GSe(oX(s.node2, s.node1, a), a);
        return n6 + f6;
      }, GSe = function(s, a) {
        var n6 = a.__edgeMap;
        return n6[s] ? n6[s].length : 0;
      };
      function kzt(s) {
        !zoe(s) || (s.__curvenessList = [], s.__edgeMap = {}, V$e(s));
      }
      function Ozt(s, a, n6, f6) {
        if (zoe(n6)) {
          var d4 = oX(s, a, n6), y4 = n6.__edgeMap, _ = y4[B$e(d4)];
          y4[d4] && !_ ? y4[d4].isForward = true : _ && y4[d4] && (_.isForward = true, y4[d4].isForward = false), y4[d4] = y4[d4] || [], y4[d4].push(f6);
        }
      }
      function HSe(s, a, n6, f6) {
        var d4 = zoe(a), y4 = Di(d4);
        if (!d4)
          return null;
        var _ = Ezt(s, a);
        if (!_)
          return null;
        for (var S = -1, T = 0; T < _.length; T++)
          if (_[T] === n6) {
            S = T;
            break;
          }
        var E = Dzt(s, a);
        V$e(a, E), s.lineStyle = s.lineStyle || {};
        var O = oX(s.node1, s.node2, a), R = a.__curvenessList, V = y4 || E % 2 ? 0 : 1;
        if (_.isForward)
          return R[V + S];
        var z3 = B$e(O), H = GSe(z3, a), Z = R[S + H + V];
        return f6 ? y4 ? d4 && d4[0] === 0 ? (H + V) % 2 ? Z : -Z : ((H % 2 ? 0 : 1) + V) % 2 ? Z : -Z : (H + V) % 2 ? Z : -Z : R[S + H + V];
      }
      function z$e(s) {
        var a = s.coordinateSystem;
        if (!(a && a.type !== "view")) {
          var n6 = s.getGraph();
          n6.eachNode(function(f6) {
            var d4 = f6.getModel();
            f6.setLayout([+d4.get("x"), +d4.get("y")]);
          }), j$e(n6, s);
        }
      }
      function j$e(s, a) {
        s.eachEdge(function(n6, f6) {
          var d4 = rC(n6.getModel().get(["lineStyle", "curveness"]), -HSe(n6, a, f6, true), 0), y4 = Yd(n6.node1.getLayout()), _ = Yd(n6.node2.getLayout()), S = [y4, _];
          +d4 && S.push([(y4[0] + _[0]) / 2 - (y4[1] - _[1]) * d4, (y4[1] + _[1]) / 2 - (_[0] - y4[0]) * d4]), n6.setLayout(S);
        });
      }
      function Pzt(s, a) {
        s.eachSeriesByType("graph", function(n6) {
          var f6 = n6.get("layout"), d4 = n6.coordinateSystem;
          if (d4 && d4.type !== "view") {
            var y4 = n6.getData(), _ = [];
            gt(d4.dimensions, function(V) {
              _ = _.concat(y4.mapDimensionsAll(V));
            });
            for (var S = 0; S < y4.count(); S++) {
              for (var T = [], E = false, O = 0; O < _.length; O++) {
                var R = y4.get(_[O], S);
                isNaN(R) || (E = true), T.push(R);
              }
              E ? y4.setItemLayout(S, d4.dataToPoint(T)) : y4.setItemLayout(S, [NaN, NaN]);
            }
            j$e(y4.graph, n6);
          } else
            (!f6 || f6 === "none") && z$e(n6);
        });
      }
      function sX(s) {
        var a = s.coordinateSystem;
        if (a.type !== "view")
          return 1;
        var n6 = s.option.nodeScaleRatio, f6 = a.scaleX, d4 = a.getZoom(), y4 = (d4 - 1) * n6 + 1;
        return y4 / f6;
      }
      function lX(s) {
        var a = s.getVisual("symbolSize");
        return a instanceof Array && (a = (a[0] + a[1]) / 2), +a;
      }
      var G$e = Math.PI, WSe = [];
      function H$e(s, a) {
        var n6 = s.coordinateSystem;
        if (!(n6 && n6.type !== "view")) {
          var f6 = n6.getBoundingRect(), d4 = s.getData(), y4 = d4.graph, _ = f6.width / 2 + f6.x, S = f6.height / 2 + f6.y, T = Math.min(f6.width, f6.height) / 2, E = d4.count();
          d4.setLayout({ cx: _, cy: S }), E && (Lzt[a](s, y4, d4, T, _, S, E), y4.eachEdge(function(O, R) {
            var V = rC(O.getModel().get(["lineStyle", "curveness"]), HSe(O, s, R), 0), z3 = Yd(O.node1.getLayout()), H = Yd(O.node2.getLayout()), Z, ee = (z3[0] + H[0]) / 2, oe = (z3[1] + H[1]) / 2;
            +V && (V *= 3, Z = [_ * V + ee * (1 - V), S * V + oe * (1 - V)]), O.setLayout([z3, H, Z]);
          }));
        }
      }
      var Lzt = { value: function(s, a, n6, f6, d4, y4, _) {
        var S = 0, T = n6.getSum("value"), E = Math.PI * 2 / (T || _);
        a.eachNode(function(O) {
          var R = O.getValue("value"), V = E * (T ? R : 1) / 2;
          S += V, O.setLayout([f6 * Math.cos(S) + d4, f6 * Math.sin(S) + y4]), S += V;
        });
      }, symbolSize: function(s, a, n6, f6, d4, y4, _) {
        var S = 0;
        WSe.length = _;
        var T = sX(s);
        a.eachNode(function(R) {
          var V = lX(R);
          isNaN(V) && (V = 2), V < 0 && (V = 0), V *= T;
          var z3 = Math.asin(V / 2 / f6);
          isNaN(z3) && (z3 = G$e / 2), WSe[R.dataIndex] = z3, S += z3 * 2;
        });
        var E = (2 * G$e - S) / _ / 2, O = 0;
        a.eachNode(function(R) {
          var V = E + WSe[R.dataIndex];
          O += V, R.setLayout([f6 * Math.cos(O) + d4, f6 * Math.sin(O) + y4]), O += V;
        });
      } };
      function Rzt(s) {
        s.eachSeriesByType("graph", function(a) {
          a.get("layout") === "circular" && H$e(a, "symbolSize");
        });
      }
      var K7 = Xw;
      function Nzt(s, a, n6) {
        for (var f6 = s, d4 = a, y4 = n6.rect, _ = y4.width, S = y4.height, T = [y4.x + _ / 2, y4.y + S / 2], E = n6.gravity == null ? 0.1 : n6.gravity, O = 0; O < f6.length; O++) {
          var R = f6[O];
          R.p || (R.p = gv(_ * (Math.random() - 0.5) + T[0], S * (Math.random() - 0.5) + T[1])), R.pp = Yd(R.p), R.edges = null;
        }
        var V = n6.friction == null ? 0.6 : n6.friction, z3 = V, H, Z;
        return { warmUp: function() {
          z3 = V * 0.8;
        }, setFixed: function(ee) {
          f6[ee].fixed = true;
        }, setUnfixed: function(ee) {
          f6[ee].fixed = false;
        }, beforeStep: function(ee) {
          H = ee;
        }, afterStep: function(ee) {
          Z = ee;
        }, step: function(ee) {
          H && H(f6, d4);
          for (var oe = [], fe = f6.length, _e = 0; _e < d4.length; _e++) {
            var pe = d4[_e];
            if (!pe.ignoreForceLayout) {
              var Ve = pe.n1, Le = pe.n2;
              Yw(oe, Le.p, Ve.p);
              var je = GL(oe) - pe.d, Xe = Le.w / (Ve.w + Le.w);
              isNaN(Xe) && (Xe = 0), KI(oe, oe), !Ve.fixed && K7(Ve.p, Ve.p, oe, Xe * je * z3), !Le.fixed && K7(Le.p, Le.p, oe, -(1 - Xe) * je * z3);
            }
          }
          for (var _e = 0; _e < fe; _e++) {
            var Ye = f6[_e];
            Ye.fixed || (Yw(oe, T, Ye.p), K7(Ye.p, Ye.p, oe, E * z3));
          }
          for (var _e = 0; _e < fe; _e++)
            for (var Ve = f6[_e], rt2 = _e + 1; rt2 < fe; rt2++) {
              var Le = f6[rt2];
              Yw(oe, Le.p, Ve.p);
              var je = GL(oe);
              je === 0 && (dbe(oe, Math.random() - 0.5, Math.random() - 0.5), je = 1);
              var ut = (Ve.rep + Le.rep) / je / je;
              !Ve.fixed && K7(Ve.pp, Ve.pp, oe, ut), !Le.fixed && K7(Le.pp, Le.pp, oe, -ut);
            }
          for (var wt = [], _e = 0; _e < fe; _e++) {
            var Ye = f6[_e];
            Ye.fixed || (Yw(wt, Ye.p, Ye.pp), K7(Ye.p, Ye.p, wt, z3), Ay(Ye.pp, Ye.p));
          }
          z3 = z3 * 0.992;
          var dt = z3 < 0.01;
          Z && Z(f6, d4, dt), ee && ee(dt);
        } };
      }
      function Fzt(s) {
        s.eachSeriesByType("graph", function(a) {
          var n6 = a.coordinateSystem;
          if (!(n6 && n6.type !== "view"))
            if (a.get("layout") === "force") {
              var f6 = a.preservedPoints || {}, d4 = a.getGraph(), y4 = d4.data, _ = d4.edgeData, S = a.getModel("force"), T = S.get("initLayout");
              a.preservedPoints ? y4.each(function(_e) {
                var pe = y4.getId(_e);
                y4.setItemLayout(_e, f6[pe] || [NaN, NaN]);
              }) : !T || T === "none" ? z$e(a) : T === "circular" && H$e(a, "value");
              var E = y4.getDataExtent("value"), O = _.getDataExtent("value"), R = S.get("repulsion"), V = S.get("edgeLength"), z3 = Di(R) ? R : [R, R], H = Di(V) ? V : [V, V];
              H = [H[1], H[0]];
              var Z = y4.mapArray("value", function(_e, pe) {
                var Ve = y4.getItemLayout(pe), Le = zu(_e, E, z3);
                return isNaN(Le) && (Le = (z3[0] + z3[1]) / 2), { w: Le, rep: Le, fixed: y4.getItemModel(pe).get("fixed"), p: !Ve || isNaN(Ve[0]) || isNaN(Ve[1]) ? null : Ve };
              }), ee = _.mapArray("value", function(_e, pe) {
                var Ve = d4.getEdgeByIndex(pe), Le = zu(_e, O, H);
                isNaN(Le) && (Le = (H[0] + H[1]) / 2);
                var je = Ve.getModel(), Xe = rC(Ve.getModel().get(["lineStyle", "curveness"]), -HSe(Ve, a, pe, true), 0);
                return { n1: Z[Ve.node1.dataIndex], n2: Z[Ve.node2.dataIndex], d: Le, curveness: Xe, ignoreForceLayout: je.get("ignoreForceLayout") };
              }), oe = n6.getBoundingRect(), fe = Nzt(Z, ee, { rect: oe, gravity: S.get("gravity"), friction: S.get("friction") });
              fe.beforeStep(function(_e, pe) {
                for (var Ve = 0, Le = _e.length; Ve < Le; Ve++)
                  _e[Ve].fixed && Ay(_e[Ve].p, d4.getNodeByIndex(Ve).getLayout());
              }), fe.afterStep(function(_e, pe, Ve) {
                for (var Le = 0, je = _e.length; Le < je; Le++)
                  _e[Le].fixed || d4.getNodeByIndex(Le).setLayout(_e[Le].p), f6[y4.getId(Le)] = _e[Le].p;
                for (var Le = 0, je = pe.length; Le < je; Le++) {
                  var Xe = pe[Le], Ye = d4.getEdgeByIndex(Le), rt2 = Xe.n1.p, ut = Xe.n2.p, wt = Ye.getLayout();
                  wt = wt ? wt.slice() : [], wt[0] = wt[0] || [], wt[1] = wt[1] || [], Ay(wt[0], rt2), Ay(wt[1], ut), +Xe.curveness && (wt[2] = [(rt2[0] + ut[0]) / 2 - (rt2[1] - ut[1]) * Xe.curveness, (rt2[1] + ut[1]) / 2 - (ut[0] - rt2[0]) * Xe.curveness]), Ye.setLayout(wt);
                }
              }), a.forceLayout = fe, a.preservedPoints = f6, fe.step();
            } else
              a.forceLayout = null;
        });
      }
      function Vzt(s, a, n6) {
        var f6 = ei(s.getBoxLayoutParams(), { aspect: n6 });
        return Qv(f6, { width: a.getWidth(), height: a.getHeight() });
      }
      function Bzt(s, a) {
        var n6 = [];
        return s.eachSeriesByType("graph", function(f6) {
          var d4 = f6.get("coordinateSystem");
          if (!d4 || d4 === "view") {
            var y4 = f6.getData(), _ = y4.mapArray(function(ee) {
              var oe = y4.getItemModel(ee);
              return [+oe.get("x"), +oe.get("y")];
            }), S = [], T = [];
            t7(_, S, T), T[0] - S[0] === 0 && (T[0] += 1, S[0] -= 1), T[1] - S[1] === 0 && (T[1] += 1, S[1] -= 1);
            var E = (T[0] - S[0]) / (T[1] - S[1]), O = Vzt(f6, a, E);
            isNaN(E) && (S = [O.x, O.y], T = [O.x + O.width, O.y + O.height]);
            var R = T[0] - S[0], V = T[1] - S[1], z3 = O.width, H = O.height, Z = f6.coordinateSystem = new Z$();
            Z.zoomLimit = f6.get("scaleLimit"), Z.setBoundingRect(S[0], S[1], R, V), Z.setViewRect(O.x, O.y, z3, H), Z.setCenter(f6.get("center")), Z.setZoom(f6.get("zoom")), n6.push(Z);
          }
        }), n6;
      }
      var W$e = Jv.prototype, USe = b7.prototype, U$e = function() {
        function s() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.percent = 1;
        }
        return s;
      }();
      (function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a;
      })(U$e);
      function qSe(s) {
        return isNaN(+s.cpx1) || isNaN(+s.cpy1);
      }
      var zzt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "ec-line", f6;
        }
        return a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new U$e();
        }, a.prototype.buildPath = function(n6, f6) {
          qSe(f6) ? W$e.buildPath.call(this, n6, f6) : USe.buildPath.call(this, n6, f6);
        }, a.prototype.pointAt = function(n6) {
          return qSe(this.shape) ? W$e.pointAt.call(this, n6) : USe.pointAt.call(this, n6);
        }, a.prototype.tangentAt = function(n6) {
          var f6 = this.shape, d4 = qSe(f6) ? [f6.x2 - f6.x1, f6.y2 - f6.y1] : USe.tangentAt.call(this, n6);
          return KI(d4, d4);
        }, a;
      }(ml), jzt = zzt, $Se = ["fromSymbol", "toSymbol"];
      function q$e(s) {
        return "_" + s + "Type";
      }
      function $$e(s, a, n6) {
        var f6 = a.getItemVisual(n6, s);
        if (!(!f6 || f6 === "none")) {
          var d4 = a.getItemVisual(n6, s + "Size"), y4 = a.getItemVisual(n6, s + "Rotate"), _ = a.getItemVisual(n6, s + "Offset"), S = a.getItemVisual(n6, s + "KeepAspect"), T = x$(d4), E = B7(_ || 0, T), O = bv(f6, -T[0] / 2 + E[0], -T[1] / 2 + E[1], T[0], T[1], null, S);
          return O.__specifiedRotation = y4 == null || isNaN(y4) ? void 0 : +y4 * Math.PI / 180 || 0, O.name = s, O;
        }
      }
      function Gzt(s) {
        var a = new jzt({ name: "line", subPixelOptimize: true });
        return XSe(a.shape, s), a;
      }
      function XSe(s, a) {
        s.x1 = a[0][0], s.y1 = a[0][1], s.x2 = a[1][0], s.y2 = a[1][1], s.percent = 1;
        var n6 = a[2];
        n6 ? (s.cpx1 = n6[0], s.cpy1 = n6[1]) : (s.cpx1 = NaN, s.cpy1 = NaN);
      }
      var Hzt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this) || this;
          return y4._createLine(n6, f6, d4), y4;
        }
        return a.prototype._createLine = function(n6, f6, d4) {
          var y4 = n6.hostModel, _ = n6.getItemLayout(f6), S = Gzt(_);
          S.shape.percent = 0, $h(S, { shape: { percent: 1 } }, y4, f6), this.add(S), gt($Se, function(T) {
            var E = $$e(T, n6, f6);
            this.add(E), this[q$e(T)] = n6.getItemVisual(f6, T);
          }, this), this._updateCommonStl(n6, f6, d4);
        }, a.prototype.updateData = function(n6, f6, d4) {
          var y4 = n6.hostModel, _ = this.childOfName("line"), S = n6.getItemLayout(f6), T = { shape: {} };
          XSe(T.shape, S), ku(_, T, y4, f6), gt($Se, function(E) {
            var O = n6.getItemVisual(f6, E), R = q$e(E);
            if (this[R] !== O) {
              this.remove(this.childOfName(E));
              var V = $$e(E, n6, f6);
              this.add(V);
            }
            this[R] = O;
          }, this), this._updateCommonStl(n6, f6, d4);
        }, a.prototype.getLinePath = function() {
          return this.childAt(0);
        }, a.prototype._updateCommonStl = function(n6, f6, d4) {
          var y4 = n6.hostModel, _ = this.childOfName("line"), S = d4 && d4.emphasisLineStyle, T = d4 && d4.blurLineStyle, E = d4 && d4.selectLineStyle, O = d4 && d4.labelStatesModels, R = d4 && d4.emphasisDisabled, V = d4 && d4.focus, z3 = d4 && d4.blurScope;
          if (!d4 || n6.hasItemOption) {
            var H = n6.getItemModel(f6), Z = H.getModel("emphasis");
            S = Z.getModel("lineStyle").getLineStyle(), T = H.getModel(["blur", "lineStyle"]).getLineStyle(), E = H.getModel(["select", "lineStyle"]).getLineStyle(), R = Z.get("disabled"), V = Z.get("focus"), z3 = Z.get("blurScope"), O = E0(H);
          }
          var ee = n6.getItemVisual(f6, "style"), oe = ee.stroke;
          _.useStyle(ee), _.style.fill = null, _.style.strokeNoScale = true, _.ensureState("emphasis").style = S, _.ensureState("blur").style = T, _.ensureState("select").style = E, gt($Se, function(Le) {
            var je = this.childOfName(Le);
            if (je) {
              je.setColor(oe), je.style.opacity = ee.opacity;
              for (var Xe = 0; Xe < od.length; Xe++) {
                var Ye = od[Xe], rt2 = _.getState(Ye);
                if (rt2) {
                  var ut = rt2.style || {}, wt = je.ensureState(Ye), dt = wt.style || (wt.style = {});
                  ut.stroke != null && (dt[je.__isEmptyBrush ? "stroke" : "fill"] = ut.stroke), ut.opacity != null && (dt.opacity = ut.opacity);
                }
              }
              je.markRedraw();
            }
          }, this);
          var fe = y4.getRawValue(f6);
          Gm(this, O, { labelDataIndex: f6, labelFetcher: { getFormattedLabel: function(Le, je) {
            return y4.getFormattedLabel(Le, je, n6.dataType);
          } }, inheritColor: oe || "#000", defaultOpacity: ee.opacity, defaultText: (fe == null ? n6.getName(f6) : isFinite(fe) ? Wp(fe) : fe) + "" });
          var _e = this.getTextContent();
          if (_e) {
            var pe = O.normal;
            _e.__align = _e.style.align, _e.__verticalAlign = _e.style.verticalAlign, _e.__position = pe.get("position") || "middle";
            var Ve = pe.get("distance");
            Di(Ve) || (Ve = [Ve, Ve]), _e.__labelDistance = Ve;
          }
          this.setTextConfig({ position: null, local: true, inside: false }), Up(this, V, z3, R);
        }, a.prototype.highlight = function() {
          sS(this);
        }, a.prototype.downplay = function() {
          lS(this);
        }, a.prototype.updateLayout = function(n6, f6) {
          this.setLinePoints(n6.getItemLayout(f6));
        }, a.prototype.setLinePoints = function(n6) {
          var f6 = this.childOfName("line");
          XSe(f6.shape, n6), f6.dirty();
        }, a.prototype.beforeUpdate = function() {
          var n6 = this, f6 = n6.childOfName("fromSymbol"), d4 = n6.childOfName("toSymbol"), y4 = n6.getTextContent();
          if (!f6 && !d4 && (!y4 || y4.ignore))
            return;
          for (var _ = 1, S = this.parent; S; )
            S.scaleX && (_ /= S.scaleX), S = S.parent;
          var T = n6.childOfName("line");
          if (!this.__dirty && !T.__dirty)
            return;
          var E = T.shape.percent, O = T.pointAt(0), R = T.pointAt(E), V = Yw([], R, O);
          KI(V, V);
          function z3(rt2, ut) {
            var wt = rt2.__specifiedRotation;
            if (wt == null) {
              var dt = T.tangentAt(ut);
              rt2.attr("rotation", (ut === 1 ? -1 : 1) * Math.PI / 2 - Math.atan2(dt[1], dt[0]));
            } else
              rt2.attr("rotation", wt);
          }
          if (f6 && (f6.setPosition(O), z3(f6, 0), f6.scaleX = f6.scaleY = _ * E, f6.markRedraw()), d4 && (d4.setPosition(R), z3(d4, 1), d4.scaleX = d4.scaleY = _ * E, d4.markRedraw()), y4 && !y4.ignore) {
            y4.x = y4.y = 0, y4.originX = y4.originY = 0;
            var H = void 0, Z = void 0, ee = y4.__labelDistance, oe = ee[0] * _, fe = ee[1] * _, _e = E / 2, pe = T.tangentAt(_e), Ve = [pe[1], -pe[0]], Le = T.pointAt(_e);
            Ve[1] > 0 && (Ve[0] = -Ve[0], Ve[1] = -Ve[1]);
            var je = pe[0] < 0 ? -1 : 1;
            if (y4.__position !== "start" && y4.__position !== "end") {
              var Xe = -Math.atan2(pe[1], pe[0]);
              R[0] < O[0] && (Xe = Math.PI + Xe), y4.rotation = Xe;
            }
            var Ye = void 0;
            switch (y4.__position) {
              case "insideStartTop":
              case "insideMiddleTop":
              case "insideEndTop":
              case "middle":
                Ye = -fe, Z = "bottom";
                break;
              case "insideStartBottom":
              case "insideMiddleBottom":
              case "insideEndBottom":
                Ye = fe, Z = "top";
                break;
              default:
                Ye = 0, Z = "middle";
            }
            switch (y4.__position) {
              case "end":
                y4.x = V[0] * oe + R[0], y4.y = V[1] * fe + R[1], H = V[0] > 0.8 ? "left" : V[0] < -0.8 ? "right" : "center", Z = V[1] > 0.8 ? "top" : V[1] < -0.8 ? "bottom" : "middle";
                break;
              case "start":
                y4.x = -V[0] * oe + O[0], y4.y = -V[1] * fe + O[1], H = V[0] > 0.8 ? "right" : V[0] < -0.8 ? "left" : "center", Z = V[1] > 0.8 ? "bottom" : V[1] < -0.8 ? "top" : "middle";
                break;
              case "insideStartTop":
              case "insideStart":
              case "insideStartBottom":
                y4.x = oe * je + O[0], y4.y = O[1] + Ye, H = pe[0] < 0 ? "right" : "left", y4.originX = -oe * je, y4.originY = -Ye;
                break;
              case "insideMiddleTop":
              case "insideMiddle":
              case "insideMiddleBottom":
              case "middle":
                y4.x = Le[0], y4.y = Le[1] + Ye, H = "center", y4.originY = -Ye;
                break;
              case "insideEndTop":
              case "insideEnd":
              case "insideEndBottom":
                y4.x = -oe * je + R[0], y4.y = R[1] + Ye, H = pe[0] >= 0 ? "right" : "left", y4.originX = oe * je, y4.originY = -Ye;
                break;
            }
            y4.scaleX = y4.scaleY = _, y4.setStyle({ verticalAlign: y4.__verticalAlign || Z, align: y4.__align || H });
          }
        }, a;
      }(fs), YSe = Hzt, Wzt = function() {
        function s(a) {
          this.group = new fs(), this._LineCtor = a || YSe;
        }
        return s.prototype.updateData = function(a) {
          var n6 = this;
          this._progressiveEls = null;
          var f6 = this, d4 = f6.group, y4 = f6._lineData;
          f6._lineData = a, y4 || d4.removeAll();
          var _ = X$e(a);
          a.diff(y4).add(function(S) {
            n6._doAdd(a, S, _);
          }).update(function(S, T) {
            n6._doUpdate(y4, a, T, S, _);
          }).remove(function(S) {
            d4.remove(y4.getItemGraphicEl(S));
          }).execute();
        }, s.prototype.updateLayout = function() {
          var a = this._lineData;
          !a || a.eachItemGraphicEl(function(n6, f6) {
            n6.updateLayout(a, f6);
          }, this);
        }, s.prototype.incrementalPrepareUpdate = function(a) {
          this._seriesScope = X$e(a), this._lineData = null, this.group.removeAll();
        }, s.prototype.incrementalUpdate = function(a, n6) {
          this._progressiveEls = [];
          function f6(S) {
            !S.isGroup && !Uzt(S) && (S.incremental = true, S.ensureState("emphasis").hoverLayer = true);
          }
          for (var d4 = a.start; d4 < a.end; d4++) {
            var y4 = n6.getItemLayout(d4);
            if (KSe(y4)) {
              var _ = new this._LineCtor(n6, d4, this._seriesScope);
              _.traverse(f6), this.group.add(_), n6.setItemGraphicEl(d4, _), this._progressiveEls.push(_);
            }
          }
        }, s.prototype.remove = function() {
          this.group.removeAll();
        }, s.prototype.eachRendered = function(a) {
          mC(this._progressiveEls || this.group, a);
        }, s.prototype._doAdd = function(a, n6, f6) {
          var d4 = a.getItemLayout(n6);
          if (KSe(d4)) {
            var y4 = new this._LineCtor(a, n6, f6);
            a.setItemGraphicEl(n6, y4), this.group.add(y4);
          }
        }, s.prototype._doUpdate = function(a, n6, f6, d4, y4) {
          var _ = a.getItemGraphicEl(f6);
          if (!KSe(n6.getItemLayout(d4))) {
            this.group.remove(_);
            return;
          }
          _ ? _.updateData(n6, d4, y4) : _ = new this._LineCtor(n6, d4, y4), n6.setItemGraphicEl(d4, _), this.group.add(_);
        }, s;
      }();
      function Uzt(s) {
        return s.animators && s.animators.length > 0;
      }
      function X$e(s) {
        var a = s.hostModel, n6 = a.getModel("emphasis");
        return { lineStyle: a.getModel("lineStyle").getLineStyle(), emphasisLineStyle: n6.getModel(["lineStyle"]).getLineStyle(), blurLineStyle: a.getModel(["blur", "lineStyle"]).getLineStyle(), selectLineStyle: a.getModel(["select", "lineStyle"]).getLineStyle(), emphasisDisabled: n6.get("disabled"), blurScope: n6.get("blurScope"), focus: n6.get("focus"), labelStatesModels: E0(a) };
      }
      function Y$e(s) {
        return isNaN(s[0]) || isNaN(s[1]);
      }
      function KSe(s) {
        return s && !Y$e(s[0]) && !Y$e(s[1]);
      }
      var ZSe = Wzt, JSe = [], QSe = [], e2e = [], Z7 = Yv, t2e = ZI, K$e = Math.abs;
      function Z$e(s, a, n6) {
        for (var f6 = s[0], d4 = s[1], y4 = s[2], _ = 1 / 0, S, T = n6 * n6, E = 0.1, O = 0.1; O <= 0.9; O += 0.1) {
          JSe[0] = Z7(f6[0], d4[0], y4[0], O), JSe[1] = Z7(f6[1], d4[1], y4[1], O);
          var R = K$e(t2e(JSe, a) - T);
          R < _ && (_ = R, S = O);
        }
        for (var V = 0; V < 32; V++) {
          var z3 = S + E;
          QSe[0] = Z7(f6[0], d4[0], y4[0], S), QSe[1] = Z7(f6[1], d4[1], y4[1], S), e2e[0] = Z7(f6[0], d4[0], y4[0], z3), e2e[1] = Z7(f6[1], d4[1], y4[1], z3);
          var R = t2e(QSe, a) - T;
          if (K$e(R) < 0.01)
            break;
          var H = t2e(e2e, a) - T;
          E /= 2, R < 0 ? H >= 0 ? S = S + E : S = S - E : H >= 0 ? S = S - E : S = S + E;
        }
        return S;
      }
      function n2e(s, a) {
        var n6 = [], f6 = Hp, d4 = [[], [], []], y4 = [[], []], _ = [];
        a /= 2, s.eachEdge(function(S, T) {
          var E = S.getLayout(), O = S.getVisual("fromSymbol"), R = S.getVisual("toSymbol");
          E.__original || (E.__original = [Yd(E[0]), Yd(E[1])], E[2] && E.__original.push(Yd(E[2])));
          var V = E.__original;
          if (E[2] != null) {
            if (Ay(d4[0], V[0]), Ay(d4[1], V[2]), Ay(d4[2], V[1]), O && O !== "none") {
              var z3 = lX(S.node1), H = Z$e(d4, V[0], z3 * a);
              f6(d4[0][0], d4[1][0], d4[2][0], H, n6), d4[0][0] = n6[3], d4[1][0] = n6[4], f6(d4[0][1], d4[1][1], d4[2][1], H, n6), d4[0][1] = n6[3], d4[1][1] = n6[4];
            }
            if (R && R !== "none") {
              var z3 = lX(S.node2), H = Z$e(d4, V[1], z3 * a);
              f6(d4[0][0], d4[1][0], d4[2][0], H, n6), d4[1][0] = n6[1], d4[2][0] = n6[2], f6(d4[0][1], d4[1][1], d4[2][1], H, n6), d4[1][1] = n6[1], d4[2][1] = n6[2];
            }
            Ay(E[0], d4[0]), Ay(E[1], d4[2]), Ay(E[2], d4[1]);
          } else {
            if (Ay(y4[0], V[0]), Ay(y4[1], V[1]), Yw(_, y4[1], y4[0]), KI(_, _), O && O !== "none") {
              var z3 = lX(S.node1);
              Xw(y4[0], y4[0], _, z3 * a);
            }
            if (R && R !== "none") {
              var z3 = lX(S.node2);
              Xw(y4[1], y4[1], _, -z3 * a);
            }
            Ay(E[0], y4[0]), Ay(E[1], y4[1]);
          }
        });
      }
      function J$e(s) {
        return s.type === "view";
      }
      var qzt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6) {
          var d4 = new H$(), y4 = new ZSe(), _ = this.group;
          this._controller = new Y$(f6.getZr()), this._controllerHost = { target: _ }, _.add(d4.group), _.add(y4.group), this._symbolDraw = d4, this._lineDraw = y4, this._firstRender = true;
        }, a.prototype.render = function(n6, f6, d4) {
          var y4 = this, _ = n6.coordinateSystem;
          this._model = n6;
          var S = this._symbolDraw, T = this._lineDraw, E = this.group;
          if (J$e(_)) {
            var O = { x: _.x, y: _.y, scaleX: _.scaleX, scaleY: _.scaleY };
            this._firstRender ? E.attr(O) : ku(E, O, n6);
          }
          n2e(n6.getGraph(), sX(n6));
          var R = n6.getData();
          S.updateData(R);
          var V = n6.getEdgeData();
          T.updateData(V), this._updateNodeAndLinkScale(), this._updateController(n6, f6, d4), clearTimeout(this._layoutTimeout);
          var z3 = n6.forceLayout, H = n6.get(["force", "layoutAnimation"]);
          z3 && this._startForceLayoutIteration(z3, H), R.graph.eachNode(function(fe) {
            var _e = fe.dataIndex, pe = fe.getGraphicEl(), Ve = fe.getModel();
            if (pe) {
              pe.off("drag").off("dragend");
              var Le = Ve.get("draggable");
              Le && pe.on("drag", function() {
                z3 && (z3.warmUp(), !y4._layouting && y4._startForceLayoutIteration(z3, H), z3.setFixed(_e), R.setItemLayout(_e, [pe.x, pe.y]));
              }).on("dragend", function() {
                z3 && z3.setUnfixed(_e);
              }), pe.setDraggable(Le && !!z3);
              var je = Ve.get(["emphasis", "focus"]);
              je === "adjacency" && (qo(pe).focus = fe.getAdjacentDataIndices());
            }
          }), R.graph.eachEdge(function(fe) {
            var _e = fe.getGraphicEl(), pe = fe.getModel().get(["emphasis", "focus"]);
            !_e || pe === "adjacency" && (qo(_e).focus = { edge: [fe.dataIndex], node: [fe.node1.dataIndex, fe.node2.dataIndex] });
          });
          var Z = n6.get("layout") === "circular" && n6.get(["circular", "rotateLabel"]), ee = R.getLayout("cx"), oe = R.getLayout("cy");
          R.eachItemGraphicEl(function(fe, _e) {
            var pe = R.getItemModel(_e), Ve = pe.get(["label", "rotate"]) || 0, Le = fe.getSymbolPath();
            if (Z) {
              var je = R.getItemLayout(_e), Xe = Math.atan2(je[1] - oe, je[0] - ee);
              Xe < 0 && (Xe = Math.PI * 2 + Xe);
              var Ye = je[0] < ee;
              Ye && (Xe = Xe - Math.PI);
              var rt2 = Ye ? "left" : "right";
              Le.setTextConfig({ rotation: -Xe, position: rt2, origin: "center" });
              var ut = Le.ensureState("emphasis");
              ei(ut.textConfig || (ut.textConfig = {}), { position: rt2 });
            } else
              Le.setTextConfig({ rotation: Ve *= Math.PI / 180 });
          }), this._firstRender = false;
        }, a.prototype.dispose = function() {
          this._controller && this._controller.dispose(), this._controllerHost = null;
        }, a.prototype._startForceLayoutIteration = function(n6, f6) {
          var d4 = this;
          (function y4() {
            n6.step(function(_) {
              d4.updateLayout(d4._model), (d4._layouting = !_) && (f6 ? d4._layoutTimeout = setTimeout(y4, 16) : y4());
            });
          })();
        }, a.prototype._updateController = function(n6, f6, d4) {
          var y4 = this, _ = this._controller, S = this._controllerHost, T = this.group;
          if (_.setPointerChecker(function(E, O, R) {
            var V = T.getBoundingRect();
            return V.applyTransform(T.transform), V.contain(O, R) && !Ioe(E, d4, n6);
          }), !J$e(n6.coordinateSystem)) {
            _.disable();
            return;
          }
          _.enable(n6.get("roam")), S.zoomLimit = n6.get("scaleLimit"), S.zoom = n6.coordinateSystem.getZoom(), _.off("pan").off("zoom").on("pan", function(E) {
            bSe(S, E.dx, E.dy), d4.dispatchAction({ seriesId: n6.id, type: "graphRoam", dx: E.dx, dy: E.dy });
          }).on("zoom", function(E) {
            _Se(S, E.scale, E.originX, E.originY), d4.dispatchAction({ seriesId: n6.id, type: "graphRoam", zoom: E.scale, originX: E.originX, originY: E.originY }), y4._updateNodeAndLinkScale(), n2e(n6.getGraph(), sX(n6)), y4._lineDraw.updateLayout(), d4.updateLabelLayout();
          });
        }, a.prototype._updateNodeAndLinkScale = function() {
          var n6 = this._model, f6 = n6.getData(), d4 = sX(n6);
          f6.eachItemGraphicEl(function(y4, _) {
            y4 && y4.setSymbolScale(d4);
          });
        }, a.prototype.updateLayout = function(n6) {
          n2e(n6.getGraph(), sX(n6)), this._symbolDraw.updateLayout(), this._lineDraw.updateLayout();
        }, a.prototype.remove = function(n6, f6) {
          this._symbolDraw && this._symbolDraw.remove(), this._lineDraw && this._lineDraw.remove();
        }, a.type = "graph", a;
      }(Ch), $zt = qzt;
      function J7(s) {
        return "_EC_" + s;
      }
      var Xzt = function() {
        function s(a) {
          this.type = "graph", this.nodes = [], this.edges = [], this._nodesMap = {}, this._edgesMap = {}, this._directed = a || false;
        }
        return s.prototype.isDirected = function() {
          return this._directed;
        }, s.prototype.addNode = function(a, n6) {
          a = a == null ? "" + n6 : "" + a;
          var f6 = this._nodesMap;
          if (!f6[J7(a)]) {
            var d4 = new n4(a, n6);
            return d4.hostGraph = this, this.nodes.push(d4), f6[J7(a)] = d4, d4;
          }
        }, s.prototype.getNodeByIndex = function(a) {
          var n6 = this.data.getRawIndex(a);
          return this.nodes[n6];
        }, s.prototype.getNodeById = function(a) {
          return this._nodesMap[J7(a)];
        }, s.prototype.addEdge = function(a, n6, f6) {
          var d4 = this._nodesMap, y4 = this._edgesMap;
          if (ac(a) && (a = this.nodes[a]), ac(n6) && (n6 = this.nodes[n6]), a instanceof n4 || (a = d4[J7(a)]), n6 instanceof n4 || (n6 = d4[J7(n6)]), !(!a || !n6)) {
            var _ = a.id + "-" + n6.id, S = new Q$e(a, n6, f6);
            return S.hostGraph = this, this._directed && (a.outEdges.push(S), n6.inEdges.push(S)), a.edges.push(S), a !== n6 && n6.edges.push(S), this.edges.push(S), y4[_] = S, S;
          }
        }, s.prototype.getEdgeByIndex = function(a) {
          var n6 = this.edgeData.getRawIndex(a);
          return this.edges[n6];
        }, s.prototype.getEdge = function(a, n6) {
          a instanceof n4 && (a = a.id), n6 instanceof n4 && (n6 = n6.id);
          var f6 = this._edgesMap;
          return this._directed ? f6[a + "-" + n6] : f6[a + "-" + n6] || f6[n6 + "-" + a];
        }, s.prototype.eachNode = function(a, n6) {
          for (var f6 = this.nodes, d4 = f6.length, y4 = 0; y4 < d4; y4++)
            f6[y4].dataIndex >= 0 && a.call(n6, f6[y4], y4);
        }, s.prototype.eachEdge = function(a, n6) {
          for (var f6 = this.edges, d4 = f6.length, y4 = 0; y4 < d4; y4++)
            f6[y4].dataIndex >= 0 && f6[y4].node1.dataIndex >= 0 && f6[y4].node2.dataIndex >= 0 && a.call(n6, f6[y4], y4);
        }, s.prototype.breadthFirstTraverse = function(a, n6, f6, d4) {
          if (n6 instanceof n4 || (n6 = this._nodesMap[J7(n6)]), !!n6) {
            for (var y4 = f6 === "out" ? "outEdges" : f6 === "in" ? "inEdges" : "edges", _ = 0; _ < this.nodes.length; _++)
              this.nodes[_].__visited = false;
            if (!a.call(d4, n6, null))
              for (var S = [n6]; S.length; )
                for (var T = S.shift(), E = T[y4], _ = 0; _ < E.length; _++) {
                  var O = E[_], R = O.node1 === T ? O.node2 : O.node1;
                  if (!R.__visited) {
                    if (a.call(d4, R, T))
                      return;
                    S.push(R), R.__visited = true;
                  }
                }
          }
        }, s.prototype.update = function() {
          for (var a = this.data, n6 = this.edgeData, f6 = this.nodes, d4 = this.edges, y4 = 0, _ = f6.length; y4 < _; y4++)
            f6[y4].dataIndex = -1;
          for (var y4 = 0, _ = a.count(); y4 < _; y4++)
            f6[a.getRawIndex(y4)].dataIndex = y4;
          n6.filterSelf(function(S) {
            var T = d4[n6.getRawIndex(S)];
            return T.node1.dataIndex >= 0 && T.node2.dataIndex >= 0;
          });
          for (var y4 = 0, _ = d4.length; y4 < _; y4++)
            d4[y4].dataIndex = -1;
          for (var y4 = 0, _ = n6.count(); y4 < _; y4++)
            d4[n6.getRawIndex(y4)].dataIndex = y4;
        }, s.prototype.clone = function() {
          for (var a = new s(this._directed), n6 = this.nodes, f6 = this.edges, d4 = 0; d4 < n6.length; d4++)
            a.addNode(n6[d4].id, n6[d4].dataIndex);
          for (var d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            a.addEdge(y4.node1.id, y4.node2.id, y4.dataIndex);
          }
          return a;
        }, s;
      }(), n4 = function() {
        function s(a, n6) {
          this.inEdges = [], this.outEdges = [], this.edges = [], this.dataIndex = -1, this.id = a == null ? "" : a, this.dataIndex = n6 == null ? -1 : n6;
        }
        return s.prototype.degree = function() {
          return this.edges.length;
        }, s.prototype.inDegree = function() {
          return this.inEdges.length;
        }, s.prototype.outDegree = function() {
          return this.outEdges.length;
        }, s.prototype.getModel = function(a) {
          if (!(this.dataIndex < 0)) {
            var n6 = this.hostGraph, f6 = n6.data.getItemModel(this.dataIndex);
            return f6.getModel(a);
          }
        }, s.prototype.getAdjacentDataIndices = function() {
          for (var a = { edge: [], node: [] }, n6 = 0; n6 < this.edges.length; n6++) {
            var f6 = this.edges[n6];
            f6.dataIndex < 0 || (a.edge.push(f6.dataIndex), a.node.push(f6.node1.dataIndex, f6.node2.dataIndex));
          }
          return a;
        }, s;
      }(), Q$e = function() {
        function s(a, n6, f6) {
          this.dataIndex = -1, this.node1 = a, this.node2 = n6, this.dataIndex = f6 == null ? -1 : f6;
        }
        return s.prototype.getModel = function(a) {
          if (!(this.dataIndex < 0)) {
            var n6 = this.hostGraph, f6 = n6.edgeData.getItemModel(this.dataIndex);
            return f6.getModel(a);
          }
        }, s.prototype.getAdjacentDataIndices = function() {
          return { edge: [this.dataIndex], node: [this.node1.dataIndex, this.node2.dataIndex] };
        }, s;
      }();
      function eXe(s, a) {
        return { getValue: function(n6) {
          var f6 = this[s][a];
          return f6.getStore().get(f6.getDimensionIndex(n6 || "value"), this.dataIndex);
        }, setVisual: function(n6, f6) {
          this.dataIndex >= 0 && this[s][a].setItemVisual(this.dataIndex, n6, f6);
        }, getVisual: function(n6) {
          return this[s][a].getItemVisual(this.dataIndex, n6);
        }, setLayout: function(n6, f6) {
          this.dataIndex >= 0 && this[s][a].setItemLayout(this.dataIndex, n6, f6);
        }, getLayout: function() {
          return this[s][a].getItemLayout(this.dataIndex);
        }, getGraphicEl: function() {
          return this[s][a].getItemGraphicEl(this.dataIndex);
        }, getRawIndex: function() {
          return this[s][a].getRawIndex(this.dataIndex);
        } };
      }
      nd(n4, eXe("hostGraph", "data")), nd(Q$e, eXe("hostGraph", "edgeData"));
      var Yzt = Xzt;
      function tXe(s, a, n6, f6, d4) {
        for (var y4 = new Yzt(f6), _ = 0; _ < s.length; _++)
          y4.addNode($v(s[_].id, s[_].name, _), _);
        for (var S = [], T = [], E = 0, _ = 0; _ < a.length; _++) {
          var O = a[_], R = O.source, V = O.target;
          y4.addEdge(R, V, E) && (T.push(O), S.push($v(Cd(O.id, null), R + " > " + V)), E++);
        }
        var z3 = n6.get("coordinateSystem"), H;
        if (z3 === "cartesian2d" || z3 === "polar")
          H = PE(s, n6);
        else {
          var Z = f$.get(z3), ee = Z ? Z.dimensions || [] : [];
          Ns(ee, "value") < 0 && ee.concat(["value"]);
          var oe = O$(s, { coordDimensions: ee, encodeDefine: n6.getEncode() }).dimensions;
          H = new K1(oe, n6), H.initData(s);
        }
        var fe = new K1(["value"], n6);
        return fe.initData(T, S), d4 && d4(H, fe), v$e({ mainData: H, struct: y4, structAttr: "graph", datas: { node: H, edge: fe }, datasAttr: { node: "data", edge: "edgeData" } }), y4.update(), y4;
      }
      var Kzt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.hasSymbolVisual = true, n6;
        }
        return a.prototype.init = function(n6) {
          s.prototype.init.apply(this, arguments);
          var f6 = this;
          function d4() {
            return f6._categoriesData;
          }
          this.legendVisualProvider = new q$(d4, d4), this.fillDataTextStyle(n6.edges || n6.links), this._updateCategoriesData();
        }, a.prototype.mergeOption = function(n6) {
          s.prototype.mergeOption.apply(this, arguments), this.fillDataTextStyle(n6.edges || n6.links), this._updateCategoriesData();
        }, a.prototype.mergeDefaultAndTheme = function(n6) {
          s.prototype.mergeDefaultAndTheme.apply(this, arguments), Gb(n6, "edgeLabel", ["show"]);
        }, a.prototype.getInitialData = function(n6, f6) {
          var d4 = n6.edges || n6.links || [], y4 = n6.data || n6.nodes || [], _ = this;
          if (y4 && d4) {
            kzt(this);
            var S = tXe(y4, d4, this, true, T);
            return gt(S.edges, function(E) {
              Ozt(E.node1, E.node2, this, E.dataIndex);
            }, this), S.data;
          }
          function T(E, O) {
            E.wrapMethod("getItemModel", function(H) {
              var Z = _._categoriesModels, ee = H.getShallow("category"), oe = Z[ee];
              return oe && (oe.parentModel = H.parentModel, H.parentModel = oe), H;
            });
            var R = Sh.prototype.getModel;
            function V(H, Z) {
              var ee = R.call(this, H, Z);
              return ee.resolveParentPath = z3, ee;
            }
            O.wrapMethod("getItemModel", function(H) {
              return H.resolveParentPath = z3, H.getModel = V, H;
            });
            function z3(H) {
              if (H && (H[0] === "label" || H[1] === "label")) {
                var Z = H.slice();
                return H[0] === "label" ? Z[0] = "edgeLabel" : H[1] === "label" && (Z[1] = "edgeLabel"), Z;
              }
              return H;
            }
          }
        }, a.prototype.getGraph = function() {
          return this.getData().graph;
        }, a.prototype.getEdgeData = function() {
          return this.getGraph().edgeData;
        }, a.prototype.getCategoriesData = function() {
          return this._categoriesData;
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          if (d4 === "edge") {
            var y4 = this.getData(), _ = this.getDataParams(n6, d4), S = y4.graph.getEdgeByIndex(n6), T = y4.getName(S.node1.dataIndex), E = y4.getName(S.node2.dataIndex), O = [];
            return T != null && O.push(T), E != null && O.push(E), Rg("nameValue", { name: O.join(" > "), value: _.value, noValue: _.value == null });
          }
          var R = GGe({ series: this, dataIndex: n6, multipleSeries: f6 });
          return R;
        }, a.prototype._updateCategoriesData = function() {
          var n6 = Pi(this.option.categories || [], function(d4) {
            return d4.value != null ? d4 : ei({ value: 0 }, d4);
          }), f6 = new K1(["value"], this);
          f6.initData(n6), this._categoriesData = f6, this._categoriesModels = f6.mapArray(function(d4) {
            return f6.getItemModel(d4);
          });
        }, a.prototype.setZoom = function(n6) {
          this.option.zoom = n6;
        }, a.prototype.setCenter = function(n6) {
          this.option.center = n6;
        }, a.prototype.isAnimationEnabled = function() {
          return s.prototype.isAnimationEnabled.call(this) && !(this.get("layout") === "force" && this.get(["force", "layoutAnimation"]));
        }, a.type = "series.graph", a.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], a.defaultOption = { z: 2, coordinateSystem: "view", legendHoverLink: true, layout: null, circular: { rotateLabel: false }, force: { initLayout: null, repulsion: [0, 50], gravity: 0.1, friction: 0.6, edgeLength: 30, layoutAnimation: true }, left: "center", top: "center", symbol: "circle", symbolSize: 10, edgeSymbol: ["none", "none"], edgeSymbolSize: 10, edgeLabel: { position: "middle", distance: 5 }, draggable: false, roam: false, center: null, zoom: 1, nodeScaleRatio: 0.6, label: { show: false, formatter: "{b}" }, itemStyle: {}, lineStyle: { color: "#aaa", width: 1, opacity: 0.5 }, emphasis: { scale: true, label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, a;
      }(Cp), Zzt = Kzt, Jzt = { type: "graphRoam", event: "graphRoam", update: "none" };
      function Qzt(s) {
        s.registerChartView($zt), s.registerSeriesModel(Zzt), s.registerProcessor(Tzt), s.registerVisual(Azt), s.registerVisual(Izt), s.registerLayout(Pzt), s.registerLayout(s.PRIORITY.VISUAL.POST_CHART_LAYOUT, Rzt), s.registerLayout(Fzt), s.registerCoordinateSystem("graphView", { dimensions: Z$.dimensions, create: Bzt }), s.registerAction({ type: "focusNodeAdjacency", event: "focusNodeAdjacency", update: "series:focusNodeAdjacency" }, rd), s.registerAction({ type: "unfocusNodeAdjacency", event: "unfocusNodeAdjacency", update: "series:unfocusNodeAdjacency" }, rd), s.registerAction(Jzt, function(a, n6) {
          n6.eachComponent({ mainType: "series", query: a }, function(f6) {
            var d4 = f6.coordinateSystem, y4 = MSe(d4, a);
            f6.setCenter && f6.setCenter(y4.center), f6.setZoom && f6.setZoom(y4.zoom);
          });
        });
      }
      var ejt = function() {
        function s() {
          this.angle = 0, this.width = 10, this.r = 10, this.x = 0, this.y = 0;
        }
        return s;
      }(), tjt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "pointer", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new ejt();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = Math.cos, y4 = Math.sin, _ = f6.r, S = f6.width, T = f6.angle, E = f6.x - d4(T) * S * (S >= _ / 3 ? 1 : 2), O = f6.y - y4(T) * S * (S >= _ / 3 ? 1 : 2);
          T = f6.angle - Math.PI / 2, n6.moveTo(E, O), n6.lineTo(f6.x + d4(T) * S, f6.y + y4(T) * S), n6.lineTo(f6.x + d4(f6.angle) * _, f6.y + y4(f6.angle) * _), n6.lineTo(f6.x - d4(T) * S, f6.y - y4(T) * S), n6.lineTo(E, O);
        }, a;
      }(ml), njt = tjt;
      function rjt(s, a) {
        var n6 = s.get("center"), f6 = a.getWidth(), d4 = a.getHeight(), y4 = Math.min(f6, d4), _ = Ia(n6[0], a.getWidth()), S = Ia(n6[1], a.getHeight()), T = Ia(s.get("radius"), y4 / 2);
        return { cx: _, cy: S, r: T };
      }
      function joe(s, a) {
        var n6 = s == null ? "" : s + "";
        return a && (Wa(a) ? n6 = a.replace("{value}", n6) : jo(a) && (n6 = a(s))), n6;
      }
      var r2e = Math.PI * 2, ijt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          this.group.removeAll();
          var y4 = n6.get(["axisLine", "lineStyle", "color"]), _ = rjt(n6, d4);
          this._renderMain(n6, f6, d4, y4, _), this._data = n6.getData();
        }, a.prototype.dispose = function() {
        }, a.prototype._renderMain = function(n6, f6, d4, y4, _) {
          for (var S = this.group, T = n6.get("clockwise"), E = -n6.get("startAngle") / 180 * Math.PI, O = -n6.get("endAngle") / 180 * Math.PI, R = n6.getModel("axisLine"), V = R.get("roundCap"), z3 = V ? xoe : Bm, H = R.get("show"), Z = R.getModel("lineStyle"), ee = Z.get("width"), oe = !((O - E) % r2e) && O !== E ? r2e : (O - E) % r2e, fe = E, _e = 0; H && _e < y4.length; _e++) {
            var pe = Math.min(Math.max(y4[_e][0], 0), 1);
            O = E + oe * pe;
            var Ve = new z3({ shape: { startAngle: fe, endAngle: O, cx: _.cx, cy: _.cy, clockwise: T, r0: _.r - ee, r: _.r }, silent: true });
            Ve.setStyle({ fill: y4[_e][1] }), Ve.setStyle(Z.getLineStyle(["color", "width"])), S.add(Ve), fe = O;
          }
          var Le = function(Xe) {
            if (Xe <= 0)
              return y4[0][1];
            var Ye;
            for (Ye = 0; Ye < y4.length; Ye++)
              if (y4[Ye][0] >= Xe && (Ye === 0 ? 0 : y4[Ye - 1][0]) < Xe)
                return y4[Ye][1];
            return y4[Ye - 1][1];
          };
          if (!T) {
            var je = E;
            E = O, O = je;
          }
          this._renderTicks(n6, f6, d4, Le, _, E, O, T, ee), this._renderTitleAndDetail(n6, f6, d4, Le, _), this._renderAnchor(n6, _), this._renderPointer(n6, f6, d4, Le, _, E, O, T, ee);
        }, a.prototype._renderTicks = function(n6, f6, d4, y4, _, S, T, E, O) {
          for (var R = this.group, V = _.cx, z3 = _.cy, H = _.r, Z = +n6.get("min"), ee = +n6.get("max"), oe = n6.getModel("splitLine"), fe = n6.getModel("axisTick"), _e = n6.getModel("axisLabel"), pe = n6.get("splitNumber"), Ve = fe.get("splitNumber"), Le = Ia(oe.get("length"), H), je = Ia(fe.get("length"), H), Xe = S, Ye = (T - S) / pe, rt2 = Ye / Ve, ut = oe.getModel("lineStyle").getLineStyle(), wt = fe.getModel("lineStyle").getLineStyle(), dt = oe.get("distance"), Gt, Qt, Nt = 0; Nt <= pe; Nt++) {
            if (Gt = Math.cos(Xe), Qt = Math.sin(Xe), oe.get("show")) {
              var er = dt ? dt + O : O, un = new Jv({ shape: { x1: Gt * (H - er) + V, y1: Qt * (H - er) + z3, x2: Gt * (H - Le - er) + V, y2: Qt * (H - Le - er) + z3 }, style: ut, silent: true });
              ut.stroke === "auto" && un.setStyle({ stroke: y4(Nt / pe) }), R.add(un);
            }
            if (_e.get("show")) {
              var er = _e.get("distance") + dt, pn = joe(Wp(Nt / pe * (ee - Z) + Z), _e.get("formatter")), On = y4(Nt / pe);
              R.add(new ju({ style: Zd(_e, { text: pn, x: Gt * (H - Le - er) + V, y: Qt * (H - Le - er) + z3, verticalAlign: Qt < -0.8 ? "top" : Qt > 0.8 ? "bottom" : "middle", align: Gt < -0.4 ? "left" : Gt > 0.4 ? "right" : "center" }, { inheritColor: On }), silent: true }));
            }
            if (fe.get("show") && Nt !== pe) {
              var er = fe.get("distance");
              er = er ? er + O : O;
              for (var fr = 0; fr <= Ve; fr++) {
                Gt = Math.cos(Xe), Qt = Math.sin(Xe);
                var yr = new Jv({ shape: { x1: Gt * (H - er) + V, y1: Qt * (H - er) + z3, x2: Gt * (H - je - er) + V, y2: Qt * (H - je - er) + z3 }, silent: true, style: wt });
                wt.stroke === "auto" && yr.setStyle({ stroke: y4((Nt + fr / Ve) / pe) }), R.add(yr), Xe += rt2;
              }
              Xe -= rt2;
            } else
              Xe += Ye;
          }
        }, a.prototype._renderPointer = function(n6, f6, d4, y4, _, S, T, E, O) {
          var R = this.group, V = this._data, z3 = this._progressEls, H = [], Z = n6.get(["pointer", "show"]), ee = n6.getModel("progress"), oe = ee.get("show"), fe = n6.getData(), _e = fe.mapDimension("value"), pe = +n6.get("min"), Ve = +n6.get("max"), Le = [pe, Ve], je = [S, T];
          function Xe(rt2, ut) {
            var wt = fe.getItemModel(rt2), dt = wt.getModel("pointer"), Gt = Ia(dt.get("width"), _.r), Qt = Ia(dt.get("length"), _.r), Nt = n6.get(["pointer", "icon"]), er = dt.get("offsetCenter"), un = Ia(er[0], _.r), pn = Ia(er[1], _.r), On = dt.get("keepAspect"), fr;
            return Nt ? fr = bv(Nt, un - Gt / 2, pn - Qt, Gt, Qt, null, On) : fr = new njt({ shape: { angle: -Math.PI / 2, width: Gt, r: Qt, x: un, y: pn } }), fr.rotation = -(ut + Math.PI / 2), fr.x = _.cx, fr.y = _.cy, fr;
          }
          function Ye(rt2, ut) {
            var wt = ee.get("roundCap"), dt = wt ? xoe : Bm, Gt = ee.get("overlap"), Qt = Gt ? ee.get("width") : O / fe.count(), Nt = Gt ? _.r - Qt : _.r - (rt2 + 1) * Qt, er = Gt ? _.r : _.r - rt2 * Qt, un = new dt({ shape: { startAngle: S, endAngle: ut, cx: _.cx, cy: _.cy, clockwise: E, r0: Nt, r: er } });
            return Gt && (un.z2 = Ve - fe.get(_e, rt2) % Ve), un;
          }
          (oe || Z) && (fe.diff(V).add(function(rt2) {
            var ut = fe.get(_e, rt2);
            if (Z) {
              var wt = Xe(rt2, S);
              $h(wt, { rotation: -((isNaN(+ut) ? je[0] : zu(ut, Le, je, true)) + Math.PI / 2) }, n6), R.add(wt), fe.setItemGraphicEl(rt2, wt);
            }
            if (oe) {
              var dt = Ye(rt2, S), Gt = ee.get("clip");
              $h(dt, { shape: { endAngle: zu(ut, Le, je, Gt) } }, n6), R.add(dt), Dq(n6.seriesIndex, fe.dataType, rt2, dt), H[rt2] = dt;
            }
          }).update(function(rt2, ut) {
            var wt = fe.get(_e, rt2);
            if (Z) {
              var dt = V.getItemGraphicEl(ut), Gt = dt ? dt.rotation : S, Qt = Xe(rt2, Gt);
              Qt.rotation = Gt, ku(Qt, { rotation: -((isNaN(+wt) ? je[0] : zu(wt, Le, je, true)) + Math.PI / 2) }, n6), R.add(Qt), fe.setItemGraphicEl(rt2, Qt);
            }
            if (oe) {
              var Nt = z3[ut], er = Nt ? Nt.shape.endAngle : S, un = Ye(rt2, er), pn = ee.get("clip");
              ku(un, { shape: { endAngle: zu(wt, Le, je, pn) } }, n6), R.add(un), Dq(n6.seriesIndex, fe.dataType, rt2, un), H[rt2] = un;
            }
          }).execute(), fe.each(function(rt2) {
            var ut = fe.getItemModel(rt2), wt = ut.getModel("emphasis"), dt = wt.get("focus"), Gt = wt.get("blurScope"), Qt = wt.get("disabled");
            if (Z) {
              var Nt = fe.getItemGraphicEl(rt2), er = fe.getItemVisual(rt2, "style"), un = er.fill;
              if (Nt instanceof Zv) {
                var pn = Nt.style;
                Nt.useStyle(ei({ image: pn.image, x: pn.x, y: pn.y, width: pn.width, height: pn.height }, er));
              } else
                Nt.useStyle(er), Nt.type !== "pointer" && Nt.setColor(un);
              Nt.setStyle(ut.getModel(["pointer", "itemStyle"]).getItemStyle()), Nt.style.fill === "auto" && Nt.setStyle("fill", y4(zu(fe.get(_e, rt2), Le, [0, 1], true))), Nt.z2EmphasisLift = 0, Pg(Nt, ut), Up(Nt, dt, Gt, Qt);
            }
            if (oe) {
              var On = H[rt2];
              On.useStyle(fe.getItemVisual(rt2, "style")), On.setStyle(ut.getModel(["progress", "itemStyle"]).getItemStyle()), On.z2EmphasisLift = 0, Pg(On, ut), Up(On, dt, Gt, Qt);
            }
          }), this._progressEls = H);
        }, a.prototype._renderAnchor = function(n6, f6) {
          var d4 = n6.getModel("anchor"), y4 = d4.get("show");
          if (y4) {
            var _ = d4.get("size"), S = d4.get("icon"), T = d4.get("offsetCenter"), E = d4.get("keepAspect"), O = bv(S, f6.cx - _ / 2 + Ia(T[0], f6.r), f6.cy - _ / 2 + Ia(T[1], f6.r), _, _, null, E);
            O.z2 = d4.get("showAbove") ? 1 : 0, O.setStyle(d4.getModel("itemStyle").getItemStyle()), this.group.add(O);
          }
        }, a.prototype._renderTitleAndDetail = function(n6, f6, d4, y4, _) {
          var S = this, T = n6.getData(), E = T.mapDimension("value"), O = +n6.get("min"), R = +n6.get("max"), V = new fs(), z3 = [], H = [], Z = n6.isAnimationEnabled(), ee = n6.get(["pointer", "showAbove"]);
          T.diff(this._data).add(function(oe) {
            z3[oe] = new ju({ silent: true }), H[oe] = new ju({ silent: true });
          }).update(function(oe, fe) {
            z3[oe] = S._titleEls[fe], H[oe] = S._detailEls[fe];
          }).execute(), T.each(function(oe) {
            var fe = T.getItemModel(oe), _e = T.get(E, oe), pe = new fs(), Ve = y4(zu(_e, [O, R], [0, 1], true)), Le = fe.getModel("title");
            if (Le.get("show")) {
              var je = Le.get("offsetCenter"), Xe = _.cx + Ia(je[0], _.r), Ye = _.cy + Ia(je[1], _.r), rt2 = z3[oe];
              rt2.attr({ z2: ee ? 0 : 2, style: Zd(Le, { x: Xe, y: Ye, text: T.getName(oe), align: "center", verticalAlign: "middle" }, { inheritColor: Ve }) }), pe.add(rt2);
            }
            var ut = fe.getModel("detail");
            if (ut.get("show")) {
              var wt = ut.get("offsetCenter"), dt = _.cx + Ia(wt[0], _.r), Gt = _.cy + Ia(wt[1], _.r), Qt = Ia(ut.get("width"), _.r), Nt = Ia(ut.get("height"), _.r), er = n6.get(["progress", "show"]) ? T.getItemVisual(oe, "style").fill : Ve, rt2 = H[oe], un = ut.get("formatter");
              rt2.attr({ z2: ee ? 0 : 2, style: Zd(ut, { x: dt, y: Gt, text: joe(_e, un), width: isNaN(Qt) ? null : Qt, height: isNaN(Nt) ? null : Nt, align: "center", verticalAlign: "middle" }, { inheritColor: er }) }), gje(rt2, { normal: ut }, _e, function(On) {
                return joe(On, un);
              }), Z && yje(rt2, oe, T, n6, { getFormattedLabel: function(On, fr, yr, da, Ja, ko) {
                return joe(ko ? ko.interpolatedValue : _e, un);
              } }), pe.add(rt2);
            }
            V.add(pe);
          }), this.group.add(V), this._titleEls = z3, this._detailEls = H;
        }, a.type = "gauge", a;
      }(Ch), ajt = ijt, ojt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.visualStyleAccessPath = "itemStyle", n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          return $7(this, ["value"]);
        }, a.type = "series.gauge", a.defaultOption = { z: 2, colorBy: "data", center: ["50%", "50%"], legendHoverLink: true, radius: "75%", startAngle: 225, endAngle: -45, clockwise: true, min: 0, max: 100, splitNumber: 10, axisLine: { show: true, roundCap: false, lineStyle: { color: [[1, "#E6EBF8"]], width: 10 } }, progress: { show: false, overlap: true, width: 10, roundCap: false, clip: true }, splitLine: { show: true, length: 10, distance: 10, lineStyle: { color: "#63677A", width: 3, type: "solid" } }, axisTick: { show: true, splitNumber: 5, length: 6, distance: 10, lineStyle: { color: "#63677A", width: 1, type: "solid" } }, axisLabel: { show: true, distance: 15, color: "#464646", fontSize: 12 }, pointer: { icon: null, offsetCenter: [0, 0], show: true, showAbove: true, length: "60%", width: 6, keepAspect: false }, anchor: { show: false, showAbove: false, size: 6, icon: "circle", offsetCenter: [0, 0], keepAspect: false, itemStyle: { color: "#fff", borderWidth: 0, borderColor: "#5470c6" } }, title: { show: true, offsetCenter: [0, "20%"], color: "#464646", fontSize: 16, valueAnimation: false }, detail: { show: true, backgroundColor: "rgba(0,0,0,0)", borderWidth: 0, borderColor: "#ccc", width: 100, height: null, padding: [5, 10], offsetCenter: [0, "40%"], color: "#464646", fontSize: 30, fontWeight: "bold", lineHeight: 30, valueAnimation: false } }, a;
      }(Cp), sjt = ojt;
      function ljt(s) {
        s.registerChartView(ajt), s.registerSeriesModel(sjt);
      }
      var ujt = ["itemStyle", "opacity"], cjt = function(s) {
        Vt(a, s);
        function a(n6, f6) {
          var d4 = s.call(this) || this, y4 = d4, _ = new zm(), S = new ju();
          return y4.setTextContent(S), d4.setTextGuideLine(_), d4.updateData(n6, f6, true), d4;
        }
        return a.prototype.updateData = function(n6, f6, d4) {
          var y4 = this, _ = n6.hostModel, S = n6.getItemModel(f6), T = n6.getItemLayout(f6), E = S.getModel("emphasis"), O = S.get(ujt);
          O = O == null ? 1 : O, d4 || ox(y4), y4.useStyle(n6.getItemVisual(f6, "style")), y4.style.lineJoin = "round", d4 ? (y4.setShape({ points: T.points }), y4.style.opacity = 0, $h(y4, { style: { opacity: O } }, _, f6)) : ku(y4, { style: { opacity: O }, shape: { points: T.points } }, _, f6), Pg(y4, S), this._updateLabel(n6, f6), Up(this, E.get("focus"), E.get("blurScope"), E.get("disabled"));
        }, a.prototype._updateLabel = function(n6, f6) {
          var d4 = this, y4 = this.getTextGuideLine(), _ = d4.getTextContent(), S = n6.hostModel, T = n6.getItemModel(f6), E = n6.getItemLayout(f6), O = E.label, R = n6.getItemVisual(f6, "style"), V = R.fill;
          Gm(_, E0(T), { labelFetcher: n6.hostModel, labelDataIndex: f6, defaultOpacity: R.opacity, defaultText: n6.getName(f6) }, { normal: { align: O.textAlign, verticalAlign: O.verticalAlign } }), d4.setTextConfig({ local: true, inside: !!O.inside, insideStroke: V, outsideFill: V });
          var z3 = O.linePoints;
          y4.setShape({ points: z3 }), d4.textGuideLineConfig = { anchor: z3 ? new zs(z3[0][0], z3[0][1]) : null }, ku(_, { style: { x: O.x, y: O.y } }, S, f6), _.attr({ rotation: O.rotation, originX: O.x, originY: O.y, z2: 10 }), zwe(d4, jwe(T), { stroke: V });
        }, a;
      }(T0), fjt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.ignoreLabelLineUpdate = true, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this._data, S = this.group;
          y4.diff(_).add(function(T) {
            var E = new cjt(y4, T);
            y4.setItemGraphicEl(T, E), S.add(E);
          }).update(function(T, E) {
            var O = _.getItemGraphicEl(E);
            O.updateData(y4, T), S.add(O), y4.setItemGraphicEl(T, O);
          }).remove(function(T) {
            var E = _.getItemGraphicEl(T);
            kR(E, n6, T);
          }).execute(), this._data = y4;
        }, a.prototype.remove = function() {
          this.group.removeAll(), this._data = null;
        }, a.prototype.dispose = function() {
        }, a.type = "funnel", a;
      }(Ch), hjt = fjt, pjt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6) {
          s.prototype.init.apply(this, arguments), this.legendVisualProvider = new q$(Za(this.getData, this), Za(this.getRawData, this)), this._defaultLabelLine(n6);
        }, a.prototype.getInitialData = function(n6, f6) {
          return $7(this, { coordDimensions: ["value"], encodeDefaulter: ks(Lxe, this) });
        }, a.prototype._defaultLabelLine = function(n6) {
          Gb(n6, "labelLine", ["show"]);
          var f6 = n6.labelLine, d4 = n6.emphasis.labelLine;
          f6.show = f6.show && n6.label.show, d4.show = d4.show && n6.emphasis.label.show;
        }, a.prototype.getDataParams = function(n6) {
          var f6 = this.getData(), d4 = s.prototype.getDataParams.call(this, n6), y4 = f6.mapDimension("value"), _ = f6.getSum(y4);
          return d4.percent = _ ? +(f6.get(y4, n6) / _ * 100).toFixed(2) : 0, d4.$vars.push("percent"), d4;
        }, a.type = "series.funnel", a.defaultOption = { z: 2, legendHoverLink: true, colorBy: "data", left: 80, top: 60, right: 80, bottom: 60, minSize: "0%", maxSize: "100%", sort: "descending", orient: "vertical", gap: 0, funnelAlign: "center", label: { show: true, position: "outer" }, labelLine: { show: true, length: 20, lineStyle: { width: 1 } }, itemStyle: { borderColor: "#fff", borderWidth: 1 }, emphasis: { label: { show: true } }, select: { itemStyle: { borderColor: "#212121" } } }, a;
      }(Cp), djt = pjt;
      function vjt(s, a) {
        return Qv(s.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
      }
      function gjt(s, a) {
        for (var n6 = s.mapDimension("value"), f6 = s.mapArray(n6, function(T) {
          return T;
        }), d4 = [], y4 = a === "ascending", _ = 0, S = s.count(); _ < S; _++)
          d4[_] = _;
        return jo(a) ? d4.sort(a) : a !== "none" && d4.sort(function(T, E) {
          return y4 ? f6[T] - f6[E] : f6[E] - f6[T];
        }), d4;
      }
      function yjt(s) {
        var a = s.hostModel, n6 = a.get("orient");
        s.each(function(f6) {
          var d4 = s.getItemModel(f6), y4 = d4.getModel("label"), _ = y4.get("position"), S = d4.getModel("labelLine"), T = s.getItemLayout(f6), E = T.points, O = _ === "inner" || _ === "inside" || _ === "center" || _ === "insideLeft" || _ === "insideRight", R, V, z3, H;
          if (O)
            _ === "insideLeft" ? (V = (E[0][0] + E[3][0]) / 2 + 5, z3 = (E[0][1] + E[3][1]) / 2, R = "left") : _ === "insideRight" ? (V = (E[1][0] + E[2][0]) / 2 - 5, z3 = (E[1][1] + E[2][1]) / 2, R = "right") : (V = (E[0][0] + E[1][0] + E[2][0] + E[3][0]) / 4, z3 = (E[0][1] + E[1][1] + E[2][1] + E[3][1]) / 4, R = "center"), H = [[V, z3], [V, z3]];
          else {
            var Z = void 0, ee = void 0, oe = void 0, fe = void 0, _e = S.get("length");
            _ === "left" ? (Z = (E[3][0] + E[0][0]) / 2, ee = (E[3][1] + E[0][1]) / 2, oe = Z - _e, V = oe - 5, R = "right") : _ === "right" ? (Z = (E[1][0] + E[2][0]) / 2, ee = (E[1][1] + E[2][1]) / 2, oe = Z + _e, V = oe + 5, R = "left") : _ === "top" ? (Z = (E[3][0] + E[0][0]) / 2, ee = (E[3][1] + E[0][1]) / 2, fe = ee - _e, z3 = fe - 5, R = "center") : _ === "bottom" ? (Z = (E[1][0] + E[2][0]) / 2, ee = (E[1][1] + E[2][1]) / 2, fe = ee + _e, z3 = fe + 5, R = "center") : _ === "rightTop" ? (Z = n6 === "horizontal" ? E[3][0] : E[1][0], ee = n6 === "horizontal" ? E[3][1] : E[1][1], n6 === "horizontal" ? (fe = ee - _e, z3 = fe - 5, R = "center") : (oe = Z + _e, V = oe + 5, R = "top")) : _ === "rightBottom" ? (Z = E[2][0], ee = E[2][1], n6 === "horizontal" ? (fe = ee + _e, z3 = fe + 5, R = "center") : (oe = Z + _e, V = oe + 5, R = "bottom")) : _ === "leftTop" ? (Z = E[0][0], ee = n6 === "horizontal" ? E[0][1] : E[1][1], n6 === "horizontal" ? (fe = ee - _e, z3 = fe - 5, R = "center") : (oe = Z - _e, V = oe - 5, R = "right")) : _ === "leftBottom" ? (Z = n6 === "horizontal" ? E[1][0] : E[3][0], ee = n6 === "horizontal" ? E[1][1] : E[2][1], n6 === "horizontal" ? (fe = ee + _e, z3 = fe + 5, R = "center") : (oe = Z - _e, V = oe - 5, R = "right")) : (Z = (E[1][0] + E[2][0]) / 2, ee = (E[1][1] + E[2][1]) / 2, n6 === "horizontal" ? (fe = ee + _e, z3 = fe + 5, R = "center") : (oe = Z + _e, V = oe + 5, R = "left")), n6 === "horizontal" ? (oe = Z, V = oe) : (fe = ee, z3 = fe), H = [[Z, ee], [oe, fe]];
          }
          T.label = { linePoints: H, x: V, y: z3, verticalAlign: "middle", textAlign: R, inside: O };
        });
      }
      function mjt(s, a) {
        s.eachSeriesByType("funnel", function(n6) {
          var f6 = n6.getData(), d4 = f6.mapDimension("value"), y4 = n6.get("sort"), _ = vjt(n6, a), S = n6.get("orient"), T = _.width, E = _.height, O = gjt(f6, y4), R = _.x, V = _.y, z3 = S === "horizontal" ? [Ia(n6.get("minSize"), E), Ia(n6.get("maxSize"), E)] : [Ia(n6.get("minSize"), T), Ia(n6.get("maxSize"), T)], H = f6.getDataExtent(d4), Z = n6.get("min"), ee = n6.get("max");
          Z == null && (Z = Math.min(H[0], 0)), ee == null && (ee = H[1]);
          var oe = n6.get("funnelAlign"), fe = n6.get("gap"), _e = S === "horizontal" ? T : E, pe = (_e - fe * (f6.count() - 1)) / f6.count(), Ve = function(Gt, Qt) {
            if (S === "horizontal") {
              var Nt = f6.get(d4, Gt) || 0, er = zu(Nt, [Z, ee], z3, true), un = void 0;
              switch (oe) {
                case "top":
                  un = V;
                  break;
                case "center":
                  un = V + (E - er) / 2;
                  break;
                case "bottom":
                  un = V + (E - er);
                  break;
              }
              return [[Qt, un], [Qt, un + er]];
            }
            var pn = f6.get(d4, Gt) || 0, On = zu(pn, [Z, ee], z3, true), fr;
            switch (oe) {
              case "left":
                fr = R;
                break;
              case "center":
                fr = R + (T - On) / 2;
                break;
              case "right":
                fr = R + T - On;
                break;
            }
            return [[fr, Qt], [fr + On, Qt]];
          };
          y4 === "ascending" && (pe = -pe, fe = -fe, S === "horizontal" ? R += T : V += E, O = O.reverse());
          for (var Le = 0; Le < O.length; Le++) {
            var je = O[Le], Xe = O[Le + 1], Ye = f6.getItemModel(je);
            if (S === "horizontal") {
              var rt2 = Ye.get(["itemStyle", "width"]);
              rt2 == null ? rt2 = pe : (rt2 = Ia(rt2, T), y4 === "ascending" && (rt2 = -rt2));
              var ut = Ve(je, R), wt = Ve(Xe, R + rt2);
              R += rt2 + fe, f6.setItemLayout(je, { points: ut.concat(wt.slice().reverse()) });
            } else {
              var dt = Ye.get(["itemStyle", "height"]);
              dt == null ? dt = pe : (dt = Ia(dt, E), y4 === "ascending" && (dt = -dt));
              var ut = Ve(je, V), wt = Ve(Xe, V + dt);
              V += dt + fe, f6.setItemLayout(je, { points: ut.concat(wt.slice().reverse()) });
            }
          }
          yjt(f6);
        });
      }
      function bjt(s) {
        s.registerChartView(hjt), s.registerSeriesModel(djt), s.registerLayout(mjt), s.registerProcessor(U$("funnel"));
      }
      var _jt = 0.3, xjt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._dataGroup = new fs(), n6._initialized = false, n6;
        }
        return a.prototype.init = function() {
          this.group.add(this._dataGroup);
        }, a.prototype.render = function(n6, f6, d4, y4) {
          this._progressiveEls = null;
          var _ = this._dataGroup, S = n6.getData(), T = this._data, E = n6.coordinateSystem, O = E.dimensions, R = iXe(n6);
          S.diff(T).add(V).update(z3).remove(H).execute();
          function V(ee) {
            var oe = rXe(S, _, ee, O, E);
            i2e(oe, S, ee, R);
          }
          function z3(ee, oe) {
            var fe = T.getItemGraphicEl(oe), _e = nXe(S, ee, O, E);
            S.setItemGraphicEl(ee, fe), ku(fe, { shape: { points: _e } }, n6, ee), ox(fe), i2e(fe, S, ee, R);
          }
          function H(ee) {
            var oe = T.getItemGraphicEl(ee);
            _.remove(oe);
          }
          if (!this._initialized) {
            this._initialized = true;
            var Z = wjt(E, n6, function() {
              setTimeout(function() {
                _.removeClipPath();
              });
            });
            _.setClipPath(Z);
          }
          this._data = S;
        }, a.prototype.incrementalPrepareRender = function(n6, f6, d4) {
          this._initialized = true, this._data = null, this._dataGroup.removeAll();
        }, a.prototype.incrementalRender = function(n6, f6, d4) {
          for (var y4 = f6.getData(), _ = f6.coordinateSystem, S = _.dimensions, T = iXe(f6), E = this._progressiveEls = [], O = n6.start; O < n6.end; O++) {
            var R = rXe(y4, this._dataGroup, O, S, _);
            R.incremental = true, i2e(R, y4, O, T), E.push(R);
          }
        }, a.prototype.remove = function() {
          this._dataGroup && this._dataGroup.removeAll(), this._data = null;
        }, a.type = "parallel", a;
      }(Ch);
      function wjt(s, a, n6) {
        var f6 = s.model, d4 = s.getRect(), y4 = new xu({ shape: { x: d4.x, y: d4.y, width: d4.width, height: d4.height } }), _ = f6.get("layout") === "horizontal" ? "width" : "height";
        return y4.setShape(_, 0), $h(y4, { shape: { width: d4.width, height: d4.height } }, a, n6), y4;
      }
      function nXe(s, a, n6, f6) {
        for (var d4 = [], y4 = 0; y4 < n6.length; y4++) {
          var _ = n6[y4], S = s.get(s.mapDimension(_), a);
          Sjt(S, f6.getAxis(_).type) || d4.push(f6.dataToPoint(S, _));
        }
        return d4;
      }
      function rXe(s, a, n6, f6, d4) {
        var y4 = nXe(s, n6, f6, d4), _ = new zm({ shape: { points: y4 }, z2: 10 });
        return a.add(_), s.setItemGraphicEl(n6, _), _;
      }
      function iXe(s) {
        var a = s.get("smooth", true);
        return a === true && (a = _jt), a = eS(a), BL(a) && (a = 0), { smooth: a };
      }
      function i2e(s, a, n6, f6) {
        s.useStyle(a.getItemVisual(n6, "style")), s.style.fill = null, s.setShape("smooth", f6.smooth);
        var d4 = a.getItemModel(n6), y4 = d4.getModel("emphasis");
        Pg(s, d4, "lineStyle"), Up(s, y4.get("focus"), y4.get("blurScope"), y4.get("disabled"));
      }
      function Sjt(s, a) {
        return a === "category" ? s == null : s == null || isNaN(s);
      }
      var Cjt = xjt, Mjt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.visualStyleAccessPath = "lineStyle", n6.visualDrawType = "stroke", n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          return PE(null, this, { useEncodeDefaulter: Za(Tjt, null, this) });
        }, a.prototype.getRawIndicesByActiveState = function(n6) {
          var f6 = this.coordinateSystem, d4 = this.getData(), y4 = [];
          return f6.eachActiveState(d4, function(_, S) {
            n6 === _ && y4.push(d4.getRawIndex(S));
          }), y4;
        }, a.type = "series.parallel", a.dependencies = ["parallel"], a.defaultOption = { z: 2, coordinateSystem: "parallel", parallelIndex: 0, label: { show: false }, inactiveOpacity: 0.05, activeOpacity: 1, lineStyle: { width: 1, opacity: 0.45, type: "solid" }, emphasis: { label: { show: false } }, progressive: 500, smooth: false, animationEasing: "linear" }, a;
      }(Cp);
      function Tjt(s) {
        var a = s.ecModel.getComponent("parallel", s.get("parallelIndex"));
        if (a) {
          var n6 = {};
          return gt(a.dimensions, function(f6) {
            var d4 = Ajt(f6);
            n6[f6] = d4;
          }), n6;
        }
      }
      function Ajt(s) {
        return +s.replace("dim", "");
      }
      var Ijt = Mjt, Ejt = ["lineStyle", "opacity"], Djt = { seriesType: "parallel", reset: function(s, a) {
        var n6 = s.coordinateSystem, f6 = { normal: s.get(["lineStyle", "opacity"]), active: s.get("activeOpacity"), inactive: s.get("inactiveOpacity") };
        return { progress: function(d4, y4) {
          n6.eachActiveState(y4, function(_, S) {
            var T = f6[_];
            if (_ === "normal" && y4.hasItemOption) {
              var E = y4.getItemModel(S).get(Ejt, true);
              E != null && (T = E);
            }
            var O = y4.ensureUniqueItemVisual(S, "style");
            O.opacity = T;
          }, d4.start, d4.end);
        } };
      } }, kjt = Djt;
      function Ojt(s) {
        Pjt(s), Ljt(s);
      }
      function Pjt(s) {
        if (!s.parallel) {
          var a = false;
          gt(s.series, function(n6) {
            n6 && n6.type === "parallel" && (a = true);
          }), a && (s.parallel = [{}]);
        }
      }
      function Ljt(s) {
        var a = jc(s.parallelAxis);
        gt(a, function(n6) {
          if (Qo(n6)) {
            var f6 = n6.parallelIndex || 0, d4 = jc(s.parallel)[f6];
            d4 && d4.parallelAxisDefault && Ms(n6, d4.parallelAxisDefault, false);
          }
        });
      }
      var Rjt = 5, Njt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          this._model = n6, this._api = d4, this._handlers || (this._handlers = {}, gt(Fjt, function(y4, _) {
            d4.getZr().on(_, this._handlers[_] = Za(y4, this));
          }, this)), N7(this, "_throttledDispatchExpand", n6.get("axisExpandRate"), "fixRate");
        }, a.prototype.dispose = function(n6, f6) {
          y$(this, "_throttledDispatchExpand"), gt(this._handlers, function(d4, y4) {
            f6.getZr().off(y4, d4);
          }), this._handlers = null;
        }, a.prototype._throttledDispatchExpand = function(n6) {
          this._dispatchExpand(n6);
        }, a.prototype._dispatchExpand = function(n6) {
          n6 && this._api.dispatchAction(ei({ type: "parallelAxisExpand" }, n6));
        }, a.type = "parallel", a;
      }(sd), Fjt = { mousedown: function(s) {
        a2e(this, "click") && (this._mouseDownPoint = [s.offsetX, s.offsetY]);
      }, mouseup: function(s) {
        var a = this._mouseDownPoint;
        if (a2e(this, "click") && a) {
          var n6 = [s.offsetX, s.offsetY], f6 = Math.pow(a[0] - n6[0], 2) + Math.pow(a[1] - n6[1], 2);
          if (f6 > Rjt)
            return;
          var d4 = this._model.coordinateSystem.getSlidedAxisExpandWindow([s.offsetX, s.offsetY]);
          d4.behavior !== "none" && this._dispatchExpand({ axisExpandWindow: d4.axisExpandWindow });
        }
        this._mouseDownPoint = null;
      }, mousemove: function(s) {
        if (!(this._mouseDownPoint || !a2e(this, "mousemove"))) {
          var a = this._model, n6 = a.coordinateSystem.getSlidedAxisExpandWindow([s.offsetX, s.offsetY]), f6 = n6.behavior;
          f6 === "jump" && this._throttledDispatchExpand.debounceNextCall(a.get("axisExpandDebounce")), this._throttledDispatchExpand(f6 === "none" ? null : { axisExpandWindow: n6.axisExpandWindow, animation: f6 === "jump" ? null : { duration: 0 } });
        }
      } };
      function a2e(s, a) {
        var n6 = s._model;
        return n6.get("axisExpandable") && n6.get("axisExpandTriggerOn") === a;
      }
      var Vjt = Njt, Bjt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function() {
          s.prototype.init.apply(this, arguments), this.mergeOption({});
        }, a.prototype.mergeOption = function(n6) {
          var f6 = this.option;
          n6 && Ms(f6, n6, true), this._initDimensions();
        }, a.prototype.contains = function(n6, f6) {
          var d4 = n6.get("parallelIndex");
          return d4 != null && f6.getComponent("parallel", d4) === this;
        }, a.prototype.setAxisExpand = function(n6) {
          gt(["axisExpandable", "axisExpandCenter", "axisExpandCount", "axisExpandWidth", "axisExpandWindow"], function(f6) {
            n6.hasOwnProperty(f6) && (this.option[f6] = n6[f6]);
          }, this);
        }, a.prototype._initDimensions = function() {
          var n6 = this.dimensions = [], f6 = this.parallelAxisIndex = [], d4 = tf(this.ecModel.queryComponents({ mainType: "parallelAxis" }), function(y4) {
            return (y4.get("parallelIndex") || 0) === this.componentIndex;
          }, this);
          gt(d4, function(y4) {
            n6.push("dim" + y4.get("dim")), f6.push(y4.componentIndex);
          });
        }, a.type = "parallel", a.dependencies = ["parallelAxis"], a.layoutMode = "box", a.defaultOption = { z: 0, left: 80, top: 60, right: 80, bottom: 60, layout: "horizontal", axisExpandable: false, axisExpandCenter: null, axisExpandCount: 0, axisExpandWidth: 50, axisExpandRate: 17, axisExpandDebounce: 50, axisExpandSlideTriggerArea: [-0.15, 0.05, 0.4], axisExpandTriggerOn: "click", parallelAxisDefault: null }, a;
      }(oc), zjt = Bjt, jjt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4, _) {
          var S = s.call(this, n6, f6, d4) || this;
          return S.type = y4 || "value", S.axisIndex = _, S;
        }
        return a.prototype.isHorizontal = function() {
          return this.coordinateSystem.getModel().get("layout") !== "horizontal";
        }, a;
      }(xC), Gjt = jjt;
      function r4(s, a, n6, f6, d4, y4) {
        s = s || 0;
        var _ = n6[1] - n6[0];
        if (d4 != null && (d4 = Q7(d4, [0, _])), y4 != null && (y4 = Math.max(y4, d4 != null ? d4 : 0)), f6 === "all") {
          var S = Math.abs(a[1] - a[0]);
          S = Q7(S, [0, _]), d4 = y4 = Q7(S, [d4, y4]), f6 = 0;
        }
        a[0] = Q7(a[0], n6), a[1] = Q7(a[1], n6);
        var T = o2e(a, f6);
        a[f6] += s;
        var E = d4 || 0, O = n6.slice();
        T.sign < 0 ? O[0] += E : O[1] -= E, a[f6] = Q7(a[f6], O);
        var R;
        return R = o2e(a, f6), d4 != null && (R.sign !== T.sign || R.span < d4) && (a[1 - f6] = a[f6] + T.sign * d4), R = o2e(a, f6), y4 != null && R.span > y4 && (a[1 - f6] = a[f6] + R.sign * y4), a;
      }
      function o2e(s, a) {
        var n6 = s[a] - s[1 - a];
        return { span: Math.abs(n6), sign: n6 > 0 ? -1 : n6 < 0 ? 1 : a ? -1 : 1 };
      }
      function Q7(s, a) {
        return Math.min(a[1] != null ? a[1] : 1 / 0, Math.max(a[0] != null ? a[0] : -1 / 0, s));
      }
      var s2e = gt, aXe = Math.min, oXe = Math.max, sXe = Math.floor, Hjt = Math.ceil, lXe = Wp, Wjt = Math.PI, Ujt = function() {
        function s(a, n6, f6) {
          this.type = "parallel", this._axesMap = ro(), this._axesLayout = {}, this.dimensions = a.dimensions, this._model = a, this._init(a, n6, f6);
        }
        return s.prototype._init = function(a, n6, f6) {
          var d4 = a.dimensions, y4 = a.parallelAxisIndex;
          s2e(d4, function(_, S) {
            var T = y4[S], E = n6.getComponent("parallelAxis", T), O = this._axesMap.set(_, new Gjt(_, coe(E), [0, 0], E.get("type"), T)), R = O.type === "category";
            O.onBand = R && E.get("boundaryGap"), O.inverse = E.get("inverse"), E.axis = O, O.model = E, O.coordinateSystem = E.coordinateSystem = this;
          }, this);
        }, s.prototype.update = function(a, n6) {
          this._updateAxesFromSeries(this._model, a);
        }, s.prototype.containPoint = function(a) {
          var n6 = this._makeLayoutInfo(), f6 = n6.axisBase, d4 = n6.layoutBase, y4 = n6.pixelDimIndex, _ = a[1 - y4], S = a[y4];
          return _ >= f6 && _ <= f6 + n6.axisLength && S >= d4 && S <= d4 + n6.layoutLength;
        }, s.prototype.getModel = function() {
          return this._model;
        }, s.prototype._updateAxesFromSeries = function(a, n6) {
          n6.eachSeries(function(f6) {
            if (a.contains(f6, n6)) {
              var d4 = f6.getData();
              s2e(this.dimensions, function(y4) {
                var _ = this._axesMap.get(y4);
                _.scale.unionExtentFromData(d4, d4.mapDimension(y4)), H7(_.scale, _.model);
              }, this);
            }
          }, this);
        }, s.prototype.resize = function(a, n6) {
          this._rect = Qv(a.getBoxLayoutParams(), { width: n6.getWidth(), height: n6.getHeight() }), this._layoutAxes();
        }, s.prototype.getRect = function() {
          return this._rect;
        }, s.prototype._makeLayoutInfo = function() {
          var a = this._model, n6 = this._rect, f6 = ["x", "y"], d4 = ["width", "height"], y4 = a.get("layout"), _ = y4 === "horizontal" ? 0 : 1, S = n6[d4[_]], T = [0, S], E = this.dimensions.length, O = Goe(a.get("axisExpandWidth"), T), R = Goe(a.get("axisExpandCount") || 0, [0, E]), V = a.get("axisExpandable") && E > 3 && E > R && R > 1 && O > 0 && S > 0, z3 = a.get("axisExpandWindow"), H;
          if (z3)
            H = Goe(z3[1] - z3[0], T), z3[1] = z3[0] + H;
          else {
            H = Goe(O * (R - 1), T);
            var Z = a.get("axisExpandCenter") || sXe(E / 2);
            z3 = [O * Z - H / 2], z3[1] = z3[0] + H;
          }
          var ee = (S - H) / (E - R);
          ee < 3 && (ee = 0);
          var oe = [sXe(lXe(z3[0] / O, 1)) + 1, Hjt(lXe(z3[1] / O, 1)) - 1], fe = ee / O * z3[0];
          return { layout: y4, pixelDimIndex: _, layoutBase: n6[f6[_]], layoutLength: S, axisBase: n6[f6[1 - _]], axisLength: n6[d4[1 - _]], axisExpandable: V, axisExpandWidth: O, axisCollapseWidth: ee, axisExpandWindow: z3, axisCount: E, winInnerIndices: oe, axisExpandWindow0Pos: fe };
        }, s.prototype._layoutAxes = function() {
          var a = this._rect, n6 = this._axesMap, f6 = this.dimensions, d4 = this._makeLayoutInfo(), y4 = d4.layout;
          n6.each(function(_) {
            var S = [0, d4.axisLength], T = _.inverse ? 1 : 0;
            _.setExtent(S[T], S[1 - T]);
          }), s2e(f6, function(_, S) {
            var T = (d4.axisExpandable ? $jt : qjt)(S, d4), E = { horizontal: { x: T.position, y: d4.axisLength }, vertical: { x: 0, y: T.position } }, O = { horizontal: Wjt / 2, vertical: 0 }, R = [E[y4].x + a.x, E[y4].y + a.y], V = O[y4], z3 = Bb();
            vT(z3, z3, V), zb(z3, z3, R), this._axesLayout[_] = { position: R, rotation: V, transform: z3, axisNameAvailableWidth: T.axisNameAvailableWidth, axisLabelShow: T.axisLabelShow, nameTruncateMaxWidth: T.nameTruncateMaxWidth, tickDirection: 1, labelDirection: 1 };
          }, this);
        }, s.prototype.getAxis = function(a) {
          return this._axesMap.get(a);
        }, s.prototype.dataToPoint = function(a, n6) {
          return this.axisCoordToPoint(this._axesMap.get(n6).dataToCoord(a), n6);
        }, s.prototype.eachActiveState = function(a, n6, f6, d4) {
          f6 == null && (f6 = 0), d4 == null && (d4 = a.count());
          var y4 = this._axesMap, _ = this.dimensions, S = [], T = [];
          gt(_, function(ee) {
            S.push(a.mapDimension(ee)), T.push(y4.get(ee).model);
          });
          for (var E = this.hasAxisBrushed(), O = f6; O < d4; O++) {
            var R = void 0;
            if (!E)
              R = "normal";
            else {
              R = "active";
              for (var V = a.getValues(S, O), z3 = 0, H = _.length; z3 < H; z3++) {
                var Z = T[z3].getActiveState(V[z3]);
                if (Z === "inactive") {
                  R = "inactive";
                  break;
                }
              }
            }
            n6(R, O);
          }
        }, s.prototype.hasAxisBrushed = function() {
          for (var a = this.dimensions, n6 = this._axesMap, f6 = false, d4 = 0, y4 = a.length; d4 < y4; d4++)
            n6.get(a[d4]).model.getActiveState() !== "normal" && (f6 = true);
          return f6;
        }, s.prototype.axisCoordToPoint = function(a, n6) {
          var f6 = this._axesLayout[n6];
          return pa([a, 0], f6.transform);
        }, s.prototype.getAxisLayout = function(a) {
          return Bo(this._axesLayout[a]);
        }, s.prototype.getSlidedAxisExpandWindow = function(a) {
          var n6 = this._makeLayoutInfo(), f6 = n6.pixelDimIndex, d4 = n6.axisExpandWindow.slice(), y4 = d4[1] - d4[0], _ = [0, n6.axisExpandWidth * (n6.axisCount - 1)];
          if (!this.containPoint(a))
            return { behavior: "none", axisExpandWindow: d4 };
          var S = a[f6] - n6.layoutBase - n6.axisExpandWindow0Pos, T, E = "slide", O = n6.axisCollapseWidth, R = this._model.get("axisExpandSlideTriggerArea"), V = R[0] != null;
          if (O)
            V && O && S < y4 * R[0] ? (E = "jump", T = S - y4 * R[2]) : V && O && S > y4 * (1 - R[0]) ? (E = "jump", T = S - y4 * (1 - R[2])) : (T = S - y4 * R[1]) >= 0 && (T = S - y4 * (1 - R[1])) <= 0 && (T = 0), T *= n6.axisExpandWidth / O, T ? r4(T, d4, _, "all") : E = "none";
          else {
            var z3 = d4[1] - d4[0], H = _[1] * S / z3;
            d4 = [oXe(0, H - z3 / 2)], d4[1] = aXe(_[1], d4[0] + z3), d4[0] = d4[1] - z3;
          }
          return { axisExpandWindow: d4, behavior: E };
        }, s;
      }();
      function Goe(s, a) {
        return aXe(oXe(s, a[0]), a[1]);
      }
      function qjt(s, a) {
        var n6 = a.layoutLength / (a.axisCount - 1);
        return { position: n6 * s, axisNameAvailableWidth: n6, axisLabelShow: true };
      }
      function $jt(s, a) {
        var n6 = a.layoutLength, f6 = a.axisExpandWidth, d4 = a.axisCount, y4 = a.axisCollapseWidth, _ = a.winInnerIndices, S, T = y4, E = false, O;
        return s < _[0] ? (S = s * y4, O = y4) : s <= _[1] ? (S = a.axisExpandWindow0Pos + s * f6 - a.axisExpandWindow[0], T = f6, E = true) : (S = n6 - (d4 - 1 - s) * y4, O = y4), { position: S, axisNameAvailableWidth: T, axisLabelShow: E, nameTruncateMaxWidth: O };
      }
      var Xjt = Ujt;
      function Yjt(s, a) {
        var n6 = [];
        return s.eachComponent("parallel", function(f6, d4) {
          var y4 = new Xjt(f6, s, a);
          y4.name = "parallel_" + d4, y4.resize(f6, a), f6.coordinateSystem = y4, y4.model = f6, n6.push(y4);
        }), s.eachSeries(function(f6) {
          if (f6.get("coordinateSystem") === "parallel") {
            var d4 = f6.getReferringComponents("parallel", ad).models[0];
            f6.coordinateSystem = d4.coordinateSystem;
          }
        }), n6;
      }
      var Kjt = { create: Yjt }, Zjt = Kjt, uXe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.activeIntervals = [], n6;
        }
        return a.prototype.getAreaSelectStyle = function() {
          return vE([["fill", "color"], ["lineWidth", "borderWidth"], ["stroke", "borderColor"], ["width", "width"], ["opacity", "opacity"]])(this.getModel("areaSelectStyle"));
        }, a.prototype.setActiveIntervals = function(n6) {
          var f6 = this.activeIntervals = Bo(n6);
          if (f6)
            for (var d4 = f6.length - 1; d4 >= 0; d4--)
              W1(f6[d4]);
        }, a.prototype.getActiveState = function(n6) {
          var f6 = this.activeIntervals;
          if (!f6.length)
            return "normal";
          if (n6 == null || isNaN(+n6))
            return "inactive";
          if (f6.length === 1) {
            var d4 = f6[0];
            if (d4[0] <= n6 && n6 <= d4[1])
              return "active";
          } else
            for (var y4 = 0, _ = f6.length; y4 < _; y4++)
              if (f6[y4][0] <= n6 && n6 <= f6[y4][1])
                return "active";
          return "inactive";
        }, a;
      }(oc);
      nd(uXe, R$);
      var cXe = uXe, i4 = true, uX = Math.min, eV = Math.max, Jjt = Math.pow, Qjt = 1e4, eGt = 6, tGt = 6, fXe = "globalPan", nGt = { w: [0, 0], e: [0, 1], n: [1, 0], s: [1, 1] }, rGt = { w: "ew", e: "ew", n: "ns", s: "ns", ne: "nesw", sw: "nesw", nw: "nwse", se: "nwse" }, hXe = { brushStyle: { lineWidth: 2, stroke: "rgba(210,219,238,0.3)", fill: "#D2DBEE" }, transformable: true, brushMode: "single", removeOnClick: false }, iGt = 0, aGt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this) || this;
          return f6._track = [], f6._covers = [], f6._handlers = {}, f6._zr = n6, f6.group = new fs(), f6._uid = "brushController_" + iGt++, gt(hGt, function(d4, y4) {
            this._handlers[y4] = Za(d4, this);
          }, f6), f6;
        }
        return a.prototype.enableBrush = function(n6) {
          return this._brushType && this._doDisableBrush(), n6.brushType && this._doEnableBrush(n6), this;
        }, a.prototype._doEnableBrush = function(n6) {
          var f6 = this._zr;
          this._enableGlobalPan || vVt(f6, fXe, this._uid), gt(this._handlers, function(d4, y4) {
            f6.on(y4, d4);
          }), this._brushType = n6.brushType, this._brushOption = Ms(Bo(hXe), n6, true);
        }, a.prototype._doDisableBrush = function() {
          var n6 = this._zr;
          gVt(n6, fXe, this._uid), gt(this._handlers, function(f6, d4) {
            n6.off(d4, f6);
          }), this._brushType = this._brushOption = null;
        }, a.prototype.setPanels = function(n6) {
          if (n6 && n6.length) {
            var f6 = this._panels = {};
            gt(n6, function(d4) {
              f6[d4.panelId] = Bo(d4);
            });
          } else
            this._panels = null;
          return this;
        }, a.prototype.mount = function(n6) {
          n6 = n6 || {}, this._enableGlobalPan = n6.enableGlobalPan;
          var f6 = this.group;
          return this._zr.add(f6), f6.attr({ x: n6.x || 0, y: n6.y || 0, rotation: n6.rotation || 0, scaleX: n6.scaleX || 1, scaleY: n6.scaleY || 1 }), this._transform = f6.getLocalTransform(), this;
        }, a.prototype.updateCovers = function(n6) {
          n6 = Pi(n6, function(V) {
            return Ms(Bo(hXe), V, true);
          });
          var f6 = "\0-brush-index-", d4 = this._covers, y4 = this._covers = [], _ = this, S = this._creatingCover;
          return new OE(d4, n6, E, T).add(O).update(O).remove(R).execute(), this;
          function T(V, z3) {
            return (V.id != null ? V.id : f6 + z3) + "-" + V.brushType;
          }
          function E(V, z3) {
            return T(V.__brushOption, z3);
          }
          function O(V, z3) {
            var H = n6[V];
            if (z3 != null && d4[z3] === S)
              y4[V] = d4[z3];
            else {
              var Z = y4[V] = z3 != null ? (d4[z3].__brushOption = H, d4[z3]) : dXe(_, pXe(_, H));
              l2e(_, Z);
            }
          }
          function R(V) {
            d4[V] !== S && _.group.remove(d4[V]);
          }
        }, a.prototype.unmount = function() {
          return this.enableBrush(false), f2e(this), this._zr.remove(this.group), this;
        }, a.prototype.dispose = function() {
          this.unmount(), this.off();
        }, a;
      }(Dm);
      function pXe(s, a) {
        var n6 = Hoe[a.brushType].createCover(s, a);
        return n6.__brushOption = a, gXe(n6, a), s.group.add(n6), n6;
      }
      function dXe(s, a) {
        var n6 = u2e(a);
        return n6.endCreating && (n6.endCreating(s, a), gXe(a, a.__brushOption)), a;
      }
      function vXe(s, a) {
        var n6 = a.__brushOption;
        u2e(a).updateCoverShape(s, a, n6.range, n6);
      }
      function gXe(s, a) {
        var n6 = a.z;
        n6 == null && (n6 = Qjt), s.traverse(function(f6) {
          f6.z = n6, f6.z2 = n6;
        });
      }
      function l2e(s, a) {
        u2e(a).updateCommon(s, a), vXe(s, a);
      }
      function u2e(s) {
        return Hoe[s.__brushOption.brushType];
      }
      function c2e(s, a, n6) {
        var f6 = s._panels;
        if (!f6)
          return i4;
        var d4, y4 = s._transform;
        return gt(f6, function(_) {
          _.isTargetByCursor(a, n6, y4) && (d4 = _);
        }), d4;
      }
      function yXe(s, a) {
        var n6 = s._panels;
        if (!n6)
          return i4;
        var f6 = a.__brushOption.panelId;
        return f6 != null ? n6[f6] : i4;
      }
      function f2e(s) {
        var a = s._covers, n6 = a.length;
        return gt(a, function(f6) {
          s.group.remove(f6);
        }, s), a.length = 0, !!n6;
      }
      function a4(s, a) {
        var n6 = Pi(s._covers, function(f6) {
          var d4 = f6.__brushOption, y4 = Bo(d4.range);
          return { brushType: d4.brushType, panelId: d4.panelId, range: y4 };
        });
        s.trigger("brush", { areas: n6, isEnd: !!a.isEnd, removeOnClick: !!a.removeOnClick });
      }
      function oGt(s) {
        var a = s._track;
        if (!a.length)
          return false;
        var n6 = a[a.length - 1], f6 = a[0], d4 = n6[0] - f6[0], y4 = n6[1] - f6[1], _ = Jjt(d4 * d4 + y4 * y4, 0.5);
        return _ > eGt;
      }
      function mXe(s) {
        var a = s.length - 1;
        return a < 0 && (a = 0), [s[0], s[a]];
      }
      function bXe(s, a, n6, f6) {
        var d4 = new fs();
        return d4.add(new xu({ name: "main", style: p2e(n6), silent: true, draggable: true, cursor: "move", drift: ks(wXe, s, a, d4, ["n", "s", "w", "e"]), ondragend: ks(a4, a, { isEnd: true }) })), gt(f6, function(y4) {
          d4.add(new xu({ name: y4.join(""), style: { opacity: 0 }, draggable: true, silent: true, invisible: true, drift: ks(wXe, s, a, d4, y4), ondragend: ks(a4, a, { isEnd: true }) }));
        }), d4;
      }
      function _Xe(s, a, n6, f6) {
        var d4 = f6.brushStyle.lineWidth || 0, y4 = eV(d4, tGt), _ = n6[0][0], S = n6[1][0], T = _ - d4 / 2, E = S - d4 / 2, O = n6[0][1], R = n6[1][1], V = O - y4 + d4 / 2, z3 = R - y4 + d4 / 2, H = O - _, Z = R - S, ee = H + d4, oe = Z + d4;
        VE(s, a, "main", _, S, H, Z), f6.transformable && (VE(s, a, "w", T, E, y4, oe), VE(s, a, "e", V, E, y4, oe), VE(s, a, "n", T, E, ee, y4), VE(s, a, "s", T, z3, ee, y4), VE(s, a, "nw", T, E, y4, y4), VE(s, a, "ne", V, E, y4, y4), VE(s, a, "sw", T, z3, y4, y4), VE(s, a, "se", V, z3, y4, y4));
      }
      function h2e(s, a) {
        var n6 = a.__brushOption, f6 = n6.transformable, d4 = a.childAt(0);
        d4.useStyle(p2e(n6)), d4.attr({ silent: !f6, cursor: f6 ? "move" : "default" }), gt([["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]], function(y4) {
          var _ = a.childOfName(y4.join("")), S = y4.length === 1 ? d2e(s, y4[0]) : lGt(s, y4);
          _ && _.attr({ silent: !f6, invisible: !f6, cursor: f6 ? rGt[S] + "-resize" : null });
        });
      }
      function VE(s, a, n6, f6, d4, y4, _) {
        var S = a.childOfName(n6);
        S && S.setShape(cGt(v2e(s, a, [[f6, d4], [f6 + y4, d4 + _]])));
      }
      function p2e(s) {
        return zo({ strokeNoScale: true }, s.brushStyle);
      }
      function xXe(s, a, n6, f6) {
        var d4 = [uX(s, n6), uX(a, f6)], y4 = [eV(s, n6), eV(a, f6)];
        return [[d4[0], y4[0]], [d4[1], y4[1]]];
      }
      function sGt(s) {
        return Qi(s.group);
      }
      function d2e(s, a) {
        var n6 = { w: "left", e: "right", n: "top", s: "bottom" }, f6 = { left: "w", right: "e", top: "n", bottom: "s" }, d4 = mo(n6[a], sGt(s));
        return f6[d4];
      }
      function lGt(s, a) {
        var n6 = [d2e(s, a[0]), d2e(s, a[1])];
        return (n6[0] === "e" || n6[0] === "w") && n6.reverse(), n6.join("");
      }
      function wXe(s, a, n6, f6, d4, y4) {
        var _ = n6.__brushOption, S = s.toRectRange(_.range), T = SXe(a, d4, y4);
        gt(f6, function(E) {
          var O = nGt[E];
          S[O[0]][O[1]] += T[O[0]];
        }), _.range = s.fromRectRange(xXe(S[0][0], S[1][0], S[0][1], S[1][1])), l2e(a, n6), a4(a, { isEnd: false });
      }
      function uGt(s, a, n6, f6) {
        var d4 = a.__brushOption.range, y4 = SXe(s, n6, f6);
        gt(d4, function(_) {
          _[0] += y4[0], _[1] += y4[1];
        }), l2e(s, a), a4(s, { isEnd: false });
      }
      function SXe(s, a, n6) {
        var f6 = s.group, d4 = f6.transformCoordToLocal(a, n6), y4 = f6.transformCoordToLocal(0, 0);
        return [d4[0] - y4[0], d4[1] - y4[1]];
      }
      function v2e(s, a, n6) {
        var f6 = yXe(s, a);
        return f6 && f6 !== i4 ? f6.clipPath(n6, s._transform) : Bo(n6);
      }
      function cGt(s) {
        var a = uX(s[0][0], s[1][0]), n6 = uX(s[0][1], s[1][1]), f6 = eV(s[0][0], s[1][0]), d4 = eV(s[0][1], s[1][1]);
        return { x: a, y: n6, width: f6 - a, height: d4 - n6 };
      }
      function fGt(s, a, n6) {
        if (!(!s._brushType || pGt(s, a.offsetX, a.offsetY))) {
          var f6 = s._zr, d4 = s._covers, y4 = c2e(s, a, n6);
          if (!s._dragging)
            for (var _ = 0; _ < d4.length; _++) {
              var S = d4[_].__brushOption;
              if (y4 && (y4 === i4 || S.panelId === y4.panelId) && Hoe[S.brushType].contain(d4[_], n6[0], n6[1]))
                return;
            }
          y4 && f6.setCursorStyle("crosshair");
        }
      }
      function g2e(s) {
        var a = s.event;
        a.preventDefault && a.preventDefault();
      }
      function y2e(s, a, n6) {
        return s.childOfName("main").contain(a, n6);
      }
      function CXe(s, a, n6, f6) {
        var d4 = s._creatingCover, y4 = s._creatingPanel, _ = s._brushOption, S;
        if (s._track.push(n6.slice()), oGt(s) || d4) {
          if (y4 && !d4) {
            _.brushMode === "single" && f2e(s);
            var T = Bo(_);
            T.brushType = MXe(T.brushType, y4), T.panelId = y4 === i4 ? null : y4.panelId, d4 = s._creatingCover = pXe(s, T), s._covers.push(d4);
          }
          if (d4) {
            var E = Hoe[MXe(s._brushType, y4)], O = d4.__brushOption;
            O.range = E.getCreatingRange(v2e(s, d4, s._track)), f6 && (dXe(s, d4), E.updateCommon(s, d4)), vXe(s, d4), S = { isEnd: f6 };
          }
        } else
          f6 && _.brushMode === "single" && _.removeOnClick && c2e(s, a, n6) && f2e(s) && (S = { isEnd: f6, removeOnClick: true });
        return S;
      }
      function MXe(s, a) {
        return s === "auto" ? a.defaultBrushType : s;
      }
      var hGt = { mousedown: function(s) {
        if (this._dragging)
          TXe(this, s);
        else if (!s.target || !s.target.draggable) {
          g2e(s);
          var a = this.group.transformCoordToLocal(s.offsetX, s.offsetY);
          this._creatingCover = null;
          var n6 = this._creatingPanel = c2e(this, s, a);
          n6 && (this._dragging = true, this._track = [a.slice()]);
        }
      }, mousemove: function(s) {
        var a = s.offsetX, n6 = s.offsetY, f6 = this.group.transformCoordToLocal(a, n6);
        if (fGt(this, s, f6), this._dragging) {
          g2e(s);
          var d4 = CXe(this, s, f6, false);
          d4 && a4(this, d4);
        }
      }, mouseup: function(s) {
        TXe(this, s);
      } };
      function TXe(s, a) {
        if (s._dragging) {
          g2e(a);
          var n6 = a.offsetX, f6 = a.offsetY, d4 = s.group.transformCoordToLocal(n6, f6), y4 = CXe(s, a, d4, true);
          s._dragging = false, s._track = [], s._creatingCover = null, y4 && a4(s, y4);
        }
      }
      function pGt(s, a, n6) {
        var f6 = s._zr;
        return a < 0 || a > f6.getWidth() || n6 < 0 || n6 > f6.getHeight();
      }
      var Hoe = { lineX: AXe(0), lineY: AXe(1), rect: { createCover: function(s, a) {
        function n6(f6) {
          return f6;
        }
        return bXe({ toRectRange: n6, fromRectRange: n6 }, s, a, [["w"], ["e"], ["n"], ["s"], ["s", "e"], ["s", "w"], ["n", "e"], ["n", "w"]]);
      }, getCreatingRange: function(s) {
        var a = mXe(s);
        return xXe(a[1][0], a[1][1], a[0][0], a[0][1]);
      }, updateCoverShape: function(s, a, n6, f6) {
        _Xe(s, a, n6, f6);
      }, updateCommon: h2e, contain: y2e }, polygon: { createCover: function(s, a) {
        var n6 = new fs();
        return n6.add(new zm({ name: "main", style: p2e(a), silent: true })), n6;
      }, getCreatingRange: function(s) {
        return s;
      }, endCreating: function(s, a) {
        a.remove(a.childAt(0)), a.add(new T0({ name: "main", draggable: true, drift: ks(uGt, s, a), ondragend: ks(a4, s, { isEnd: true }) }));
      }, updateCoverShape: function(s, a, n6, f6) {
        a.childAt(0).setShape({ points: v2e(s, a, n6) });
      }, updateCommon: h2e, contain: y2e } };
      function AXe(s) {
        return { createCover: function(a, n6) {
          return bXe({ toRectRange: function(f6) {
            var d4 = [f6, [0, 100]];
            return s && d4.reverse(), d4;
          }, fromRectRange: function(f6) {
            return f6[s];
          } }, a, n6, [[["w"], ["e"]], [["n"], ["s"]]][s]);
        }, getCreatingRange: function(a) {
          var n6 = mXe(a), f6 = uX(n6[0][s], n6[1][s]), d4 = eV(n6[0][s], n6[1][s]);
          return [f6, d4];
        }, updateCoverShape: function(a, n6, f6, d4) {
          var y4, _ = yXe(a, n6);
          if (_ !== i4 && _.getLinearBrushOtherExtent)
            y4 = _.getLinearBrushOtherExtent(s);
          else {
            var S = a._zr;
            y4 = [0, [S.getWidth(), S.getHeight()][1 - s]];
          }
          var T = [f6, y4];
          s && T.reverse(), _Xe(a, n6, T, d4);
        }, updateCommon: h2e, contain: y2e };
      }
      var m2e = aGt;
      function IXe(s) {
        return s = b2e(s), function(a) {
          return al(a, s);
        };
      }
      function EXe(s, a) {
        return s = b2e(s), function(n6) {
          var f6 = a != null ? a : n6, d4 = f6 ? s.width : s.height, y4 = f6 ? s.x : s.y;
          return [y4, y4 + (d4 || 0)];
        };
      }
      function DXe(s, a, n6) {
        var f6 = b2e(s);
        return function(d4, y4) {
          return f6.contain(y4[0], y4[1]) && !Ioe(d4, a, n6);
        };
      }
      function b2e(s) {
        return il.create(s);
      }
      var dGt = ["axisLine", "axisTickLabel", "axisName"], vGt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6) {
          s.prototype.init.apply(this, arguments), (this._brushController = new m2e(f6.getZr())).on("brush", Za(this._onBrush, this));
        }, a.prototype.render = function(n6, f6, d4, y4) {
          if (!gGt(n6, f6, y4)) {
            this.axisModel = n6, this.api = d4, this.group.removeAll();
            var _ = this._axisGroup;
            if (this._axisGroup = new fs(), this.group.add(this._axisGroup), !!n6.get("show")) {
              var S = mGt(n6, f6), T = S.coordinateSystem, E = n6.getAreaSelectStyle(), O = E.width, R = n6.axis.dim, V = T.getAxisLayout(R), z3 = ei({ strokeContainThreshold: O }, V), H = new NE(n6, z3);
              gt(dGt, H.add, H), this._axisGroup.add(H.getGroup()), this._refreshBrushController(z3, E, n6, S, O, d4), $l(_, this._axisGroup, n6);
            }
          }
        }, a.prototype._refreshBrushController = function(n6, f6, d4, y4, _, S) {
          var T = d4.axis.getExtent(), E = T[1] - T[0], O = Math.min(30, Math.abs(E) * 0.1), R = il.create({ x: T[0], y: -_ / 2, width: E, height: _ });
          R.x -= O, R.width += 2 * O, this._brushController.mount({ enableGlobalPan: true, rotation: n6.rotation, x: n6.position[0], y: n6.position[1] }).setPanels([{ panelId: "pl", clipPath: IXe(R), isTargetByCursor: DXe(R, S, y4), getLinearBrushOtherExtent: EXe(R, 0) }]).enableBrush({ brushType: "lineX", brushStyle: f6, removeOnClick: true }).updateCovers(yGt(d4));
        }, a.prototype._onBrush = function(n6) {
          var f6 = n6.areas, d4 = this.axisModel, y4 = d4.axis, _ = Pi(f6, function(S) {
            return [y4.coordToData(S.range[0], true), y4.coordToData(S.range[1], true)];
          });
          (!d4.option.realtime === n6.isEnd || n6.removeOnClick) && this.api.dispatchAction({ type: "axisAreaSelect", parallelAxisId: d4.id, intervals: _ });
        }, a.prototype.dispose = function() {
          this._brushController.dispose();
        }, a.type = "parallelAxis", a;
      }(sd);
      function gGt(s, a, n6) {
        return n6 && n6.type === "axisAreaSelect" && a.findComponents({ mainType: "parallelAxis", query: n6 })[0] === s;
      }
      function yGt(s) {
        var a = s.axis;
        return Pi(s.activeIntervals, function(n6) {
          return { brushType: "lineX", panelId: "pl", range: [a.dataToCoord(n6[0], true), a.dataToCoord(n6[1], true)] };
        });
      }
      function mGt(s, a) {
        return a.getComponent("parallel", s.get("parallelIndex"));
      }
      var bGt = vGt, _Gt = { type: "axisAreaSelect", event: "axisAreaSelected" };
      function xGt(s) {
        s.registerAction(_Gt, function(a, n6) {
          n6.eachComponent({ mainType: "parallelAxis", query: a }, function(f6) {
            f6.axis.model.setActiveIntervals(a.intervals);
          });
        }), s.registerAction("parallelAxisExpand", function(a, n6) {
          n6.eachComponent({ mainType: "parallel", query: a }, function(f6) {
            f6.setAxisExpand(a);
          });
        });
      }
      var wGt = { type: "value", areaSelectStyle: { width: 20, borderWidth: 1, borderColor: "rgba(160,197,232)", color: "rgba(160,197,232)", opacity: 0.3 }, realtime: true, z: 10 };
      function kXe(s) {
        s.registerComponentView(Vjt), s.registerComponentModel(zjt), s.registerCoordinateSystem("parallel", Zjt), s.registerPreprocessor(Ojt), s.registerComponentModel(cXe), s.registerComponentView(bGt), X7(s, "parallel", cXe, wGt), xGt(s);
      }
      function SGt(s) {
        Il(kXe), s.registerChartView(Cjt), s.registerSeriesModel(Ijt), s.registerVisual(s.PRIORITY.VISUAL.BRUSH, kjt);
      }
      var CGt = function() {
        function s() {
          this.x1 = 0, this.y1 = 0, this.x2 = 0, this.y2 = 0, this.cpx1 = 0, this.cpy1 = 0, this.cpx2 = 0, this.cpy2 = 0, this.extent = 0;
        }
        return s;
      }(), MGt = function(s) {
        Vt(a, s);
        function a(n6) {
          return s.call(this, n6) || this;
        }
        return a.prototype.getDefaultShape = function() {
          return new CGt();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.extent;
          n6.moveTo(f6.x1, f6.y1), n6.bezierCurveTo(f6.cpx1, f6.cpy1, f6.cpx2, f6.cpy2, f6.x2, f6.y2), f6.orient === "vertical" ? (n6.lineTo(f6.x2 + d4, f6.y2), n6.bezierCurveTo(f6.cpx2 + d4, f6.cpy2, f6.cpx1 + d4, f6.cpy1, f6.x1 + d4, f6.y1)) : (n6.lineTo(f6.x2, f6.y2 + d4), n6.bezierCurveTo(f6.cpx2, f6.cpy2 + d4, f6.cpx1, f6.cpy1 + d4, f6.x1, f6.y1 + d4)), n6.closePath();
        }, a.prototype.highlight = function() {
          sS(this);
        }, a.prototype.downplay = function() {
          lS(this);
        }, a;
      }(ml), TGt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._focusAdjacencyDisabled = false, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = this, _ = n6.getGraph(), S = this.group, T = n6.layoutInfo, E = T.width, O = T.height, R = n6.getData(), V = n6.getData("edge"), z3 = n6.get("orient");
          this._model = n6, S.removeAll(), S.x = T.x, S.y = T.y, _.eachEdge(function(H) {
            var Z = new MGt(), ee = qo(Z);
            ee.dataIndex = H.dataIndex, ee.seriesIndex = n6.seriesIndex, ee.dataType = "edge";
            var oe = H.getModel(), fe = oe.getModel("lineStyle"), _e = fe.get("curveness"), pe = H.node1.getLayout(), Ve = H.node1.getModel(), Le = Ve.get("localX"), je = Ve.get("localY"), Xe = H.node2.getLayout(), Ye = H.node2.getModel(), rt2 = Ye.get("localX"), ut = Ye.get("localY"), wt = H.getLayout(), dt, Gt, Qt, Nt, er, un, pn, On;
            switch (Z.shape.extent = Math.max(1, wt.dy), Z.shape.orient = z3, z3 === "vertical" ? (dt = (Le != null ? Le * E : pe.x) + wt.sy, Gt = (je != null ? je * O : pe.y) + pe.dy, Qt = (rt2 != null ? rt2 * E : Xe.x) + wt.ty, Nt = ut != null ? ut * O : Xe.y, er = dt, un = Gt * (1 - _e) + Nt * _e, pn = Qt, On = Gt * _e + Nt * (1 - _e)) : (dt = (Le != null ? Le * E : pe.x) + pe.dx, Gt = (je != null ? je * O : pe.y) + wt.sy, Qt = rt2 != null ? rt2 * E : Xe.x, Nt = (ut != null ? ut * O : Xe.y) + wt.ty, er = dt * (1 - _e) + Qt * _e, un = Gt, pn = dt * _e + Qt * (1 - _e), On = Nt), Z.setShape({ x1: dt, y1: Gt, x2: Qt, y2: Nt, cpx1: er, cpy1: un, cpx2: pn, cpy2: On }), Z.useStyle(fe.getItemStyle()), Z.style.fill) {
              case "source":
                Z.style.fill = H.node1.getVisual("color"), Z.style.decal = H.node1.getVisual("style").decal;
                break;
              case "target":
                Z.style.fill = H.node2.getVisual("color"), Z.style.decal = H.node2.getVisual("style").decal;
                break;
              case "gradient":
                var fr = H.node1.getVisual("color"), yr = H.node2.getVisual("color");
                Wa(fr) && Wa(yr) && (Z.style.fill = new DR(0, 0, +(z3 === "horizontal"), +(z3 === "vertical"), [{ color: fr, offset: 0 }, { color: yr, offset: 1 }]));
            }
            var da = oe.getModel("emphasis");
            Pg(Z, oe, "lineStyle", function(ko) {
              return ko.getItemStyle();
            }), S.add(Z), V.setItemGraphicEl(H.dataIndex, Z);
            var Ja = da.get("focus");
            Up(Z, Ja === "adjacency" ? H.getAdjacentDataIndices() : Ja, da.get("blurScope"), da.get("disabled")), qo(Z).dataType = "edge";
          }), _.eachNode(function(H) {
            var Z = H.getLayout(), ee = H.getModel(), oe = ee.get("localX"), fe = ee.get("localY"), _e = ee.getModel("emphasis"), pe = new xu({ shape: { x: oe != null ? oe * E : Z.x, y: fe != null ? fe * O : Z.y, width: Z.dx, height: Z.dy }, style: ee.getModel("itemStyle").getItemStyle(), z2: 10 });
            Gm(pe, E0(ee), { labelFetcher: n6, labelDataIndex: H.dataIndex, defaultText: H.id }), pe.disableLabelAnimation = true, pe.setStyle("fill", H.getVisual("color")), pe.setStyle("decal", H.getVisual("style").decal), Pg(pe, ee), S.add(pe), R.setItemGraphicEl(H.dataIndex, pe), qo(pe).dataType = "node";
            var Ve = _e.get("focus");
            Up(pe, Ve === "adjacency" ? H.getAdjacentDataIndices() : Ve, _e.get("blurScope"), _e.get("disabled"));
          }), R.eachItemGraphicEl(function(H, Z) {
            var ee = R.getItemModel(Z);
            ee.get("draggable") && (H.drift = function(oe, fe) {
              y4._focusAdjacencyDisabled = true, this.shape.x += oe, this.shape.y += fe, this.dirty(), d4.dispatchAction({ type: "dragNode", seriesId: n6.id, dataIndex: R.getRawIndex(Z), localX: this.shape.x / E, localY: this.shape.y / O });
            }, H.ondragend = function() {
              y4._focusAdjacencyDisabled = false;
            }, H.draggable = true, H.cursor = "move");
          }), !this._data && n6.isAnimationEnabled() && S.setClipPath(AGt(S.getBoundingRect(), n6, function() {
            S.removeClipPath();
          })), this._data = n6.getData();
        }, a.prototype.dispose = function() {
        }, a.type = "sankey", a;
      }(Ch);
      function AGt(s, a, n6) {
        var f6 = new xu({ shape: { x: s.x - 10, y: s.y - 10, width: 0, height: s.height + 20 } });
        return $h(f6, { shape: { width: s.width + 20 } }, a, n6), f6;
      }
      var IGt = TGt, EGt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          var d4 = n6.edges || n6.links, y4 = n6.data || n6.nodes, _ = n6.levels;
          this.levelModels = [];
          for (var S = this.levelModels, T = 0; T < _.length; T++)
            _[T].depth != null && _[T].depth >= 0 && (S[_[T].depth] = new Sh(_[T], this, f6));
          if (y4 && d4) {
            var E = tXe(y4, d4, this, true, O);
            return E.data;
          }
          function O(R, V) {
            R.wrapMethod("getItemModel", function(z3, H) {
              var Z = z3.parentModel, ee = Z.getData().getItemLayout(H);
              if (ee) {
                var oe = ee.depth, fe = Z.levelModels[oe];
                fe && (z3.parentModel = fe);
              }
              return z3;
            }), V.wrapMethod("getItemModel", function(z3, H) {
              var Z = z3.parentModel, ee = Z.getGraph().getEdgeByIndex(H), oe = ee.node1.getLayout();
              if (oe) {
                var fe = oe.depth, _e = Z.levelModels[fe];
                _e && (z3.parentModel = _e);
              }
              return z3;
            });
          }
        }, a.prototype.setNodePosition = function(n6, f6) {
          var d4 = this.option.data || this.option.nodes, y4 = d4[n6];
          y4.localX = f6[0], y4.localY = f6[1];
        }, a.prototype.getGraph = function() {
          return this.getData().graph;
        }, a.prototype.getEdgeData = function() {
          return this.getGraph().edgeData;
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          function y4(z3) {
            return isNaN(z3) || z3 == null;
          }
          if (d4 === "edge") {
            var _ = this.getDataParams(n6, d4), S = _.data, T = _.value, E = S.source + " -- " + S.target;
            return Rg("nameValue", { name: E, value: T, noValue: y4(T) });
          } else {
            var O = this.getGraph().getNodeByIndex(n6), R = O.getLayout().value, V = this.getDataParams(n6, d4).data.name;
            return Rg("nameValue", { name: V != null ? V + "" : null, value: R, noValue: y4(R) });
          }
        }, a.prototype.optionUpdated = function() {
        }, a.prototype.getDataParams = function(n6, f6) {
          var d4 = s.prototype.getDataParams.call(this, n6, f6);
          if (d4.value == null && f6 === "node") {
            var y4 = this.getGraph().getNodeByIndex(n6), _ = y4.getLayout().value;
            d4.value = _;
          }
          return d4;
        }, a.type = "series.sankey", a.defaultOption = { z: 2, coordinateSystem: "view", left: "5%", top: "5%", right: "20%", bottom: "5%", orient: "horizontal", nodeWidth: 20, nodeGap: 8, draggable: true, layoutIterations: 32, label: { show: true, position: "right", fontSize: 12 }, levels: [], nodeAlign: "justify", lineStyle: { color: "#314656", opacity: 0.2, curveness: 0.5 }, emphasis: { label: { show: true }, lineStyle: { opacity: 0.5 } }, select: { itemStyle: { borderColor: "#212121" } }, animationEasing: "linear", animationDuration: 1e3 }, a;
      }(Cp), DGt = EGt;
      function kGt(s, a) {
        s.eachSeriesByType("sankey", function(n6) {
          var f6 = n6.get("nodeWidth"), d4 = n6.get("nodeGap"), y4 = OGt(n6, a);
          n6.layoutInfo = y4;
          var _ = y4.width, S = y4.height, T = n6.getGraph(), E = T.nodes, O = T.edges;
          LGt(E);
          var R = tf(E, function(Z) {
            return Z.getLayout().value === 0;
          }), V = R.length !== 0 ? 0 : n6.get("layoutIterations"), z3 = n6.get("orient"), H = n6.get("nodeAlign");
          PGt(E, O, f6, d4, _, S, V, z3, H);
        });
      }
      function OGt(s, a) {
        return Qv(s.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() });
      }
      function PGt(s, a, n6, f6, d4, y4, _, S, T) {
        RGt(s, a, n6, d4, y4, S, T), BGt(s, a, y4, d4, f6, _, S), XGt(s, S);
      }
      function LGt(s) {
        gt(s, function(a) {
          var n6 = l32(a.outEdges, Woe), f6 = l32(a.inEdges, Woe), d4 = a.getValue() || 0, y4 = Math.max(n6, f6, d4);
          a.setLayout({ value: y4 }, true);
        });
      }
      function RGt(s, a, n6, f6, d4, y4, _) {
        for (var S = [], T = [], E = [], O = [], R = 0, V = 0; V < a.length; V++)
          S[V] = 1;
        for (var V = 0; V < s.length; V++)
          T[V] = s[V].inEdges.length, T[V] === 0 && E.push(s[V]);
        for (var z3 = -1; E.length; ) {
          for (var H = 0; H < E.length; H++) {
            var Z = E[H], ee = Z.hostGraph.data.getRawDataItem(Z.dataIndex), oe = ee.depth != null && ee.depth >= 0;
            oe && ee.depth > z3 && (z3 = ee.depth), Z.setLayout({ depth: oe ? ee.depth : R }, true), y4 === "vertical" ? Z.setLayout({ dy: n6 }, true) : Z.setLayout({ dx: n6 }, true);
            for (var fe = 0; fe < Z.outEdges.length; fe++) {
              var _e = Z.outEdges[fe], pe = a.indexOf(_e);
              S[pe] = 0;
              var Ve = _e.node2, Le = s.indexOf(Ve);
              --T[Le] === 0 && O.indexOf(Ve) < 0 && O.push(Ve);
            }
          }
          ++R, E = O, O = [];
        }
        for (var V = 0; V < S.length; V++)
          if (S[V] === 1)
            throw new Error("Sankey is a DAG, the original data has cycle!");
        var je = z3 > R - 1 ? z3 : R - 1;
        _ && _ !== "left" && NGt(s, _, y4, je);
        var Xe = y4 === "vertical" ? (d4 - n6) / je : (f6 - n6) / je;
        VGt(s, Xe, y4);
      }
      function OXe(s) {
        var a = s.hostGraph.data.getRawDataItem(s.dataIndex);
        return a.depth != null && a.depth >= 0;
      }
      function NGt(s, a, n6, f6) {
        if (a === "right") {
          for (var d4 = [], y4 = s, _ = 0; y4.length; ) {
            for (var S = 0; S < y4.length; S++) {
              var T = y4[S];
              T.setLayout({ skNodeHeight: _ }, true);
              for (var E = 0; E < T.inEdges.length; E++) {
                var O = T.inEdges[E];
                d4.indexOf(O.node1) < 0 && d4.push(O.node1);
              }
            }
            y4 = d4, d4 = [], ++_;
          }
          gt(s, function(R) {
            OXe(R) || R.setLayout({ depth: Math.max(0, f6 - R.getLayout().skNodeHeight) }, true);
          });
        } else
          a === "justify" && FGt(s, f6);
      }
      function FGt(s, a) {
        gt(s, function(n6) {
          !OXe(n6) && !n6.outEdges.length && n6.setLayout({ depth: a }, true);
        });
      }
      function VGt(s, a, n6) {
        gt(s, function(f6) {
          var d4 = f6.getLayout().depth * a;
          n6 === "vertical" ? f6.setLayout({ y: d4 }, true) : f6.setLayout({ x: d4 }, true);
        });
      }
      function BGt(s, a, n6, f6, d4, y4, _) {
        var S = zGt(s, _);
        jGt(S, a, n6, f6, d4, _), _2e(S, d4, n6, f6, _);
        for (var T = 1; y4 > 0; y4--)
          T *= 0.99, GGt(S, T, _), _2e(S, d4, n6, f6, _), $Gt(S, T, _), _2e(S, d4, n6, f6, _);
      }
      function zGt(s, a) {
        var n6 = [], f6 = a === "vertical" ? "y" : "x", d4 = q9(s, function(y4) {
          return y4.getLayout()[f6];
        });
        return d4.keys.sort(function(y4, _) {
          return y4 - _;
        }), gt(d4.keys, function(y4) {
          n6.push(d4.buckets.get(y4));
        }), n6;
      }
      function jGt(s, a, n6, f6, d4, y4) {
        var _ = 1 / 0;
        gt(s, function(S) {
          var T = S.length, E = 0;
          gt(S, function(R) {
            E += R.getLayout().value;
          });
          var O = y4 === "vertical" ? (f6 - (T - 1) * d4) / E : (n6 - (T - 1) * d4) / E;
          O < _ && (_ = O);
        }), gt(s, function(S) {
          gt(S, function(T, E) {
            var O = T.getLayout().value * _;
            y4 === "vertical" ? (T.setLayout({ x: E }, true), T.setLayout({ dx: O }, true)) : (T.setLayout({ y: E }, true), T.setLayout({ dy: O }, true));
          });
        }), gt(a, function(S) {
          var T = +S.getValue() * _;
          S.setLayout({ dy: T }, true);
        });
      }
      function _2e(s, a, n6, f6, d4) {
        var y4 = d4 === "vertical" ? "x" : "y";
        gt(s, function(_) {
          _.sort(function(Z, ee) {
            return Z.getLayout()[y4] - ee.getLayout()[y4];
          });
          for (var S, T, E, O = 0, R = _.length, V = d4 === "vertical" ? "dx" : "dy", z3 = 0; z3 < R; z3++)
            T = _[z3], E = O - T.getLayout()[y4], E > 0 && (S = T.getLayout()[y4] + E, d4 === "vertical" ? T.setLayout({ x: S }, true) : T.setLayout({ y: S }, true)), O = T.getLayout()[y4] + T.getLayout()[V] + a;
          var H = d4 === "vertical" ? f6 : n6;
          if (E = O - a - H, E > 0) {
            S = T.getLayout()[y4] - E, d4 === "vertical" ? T.setLayout({ x: S }, true) : T.setLayout({ y: S }, true), O = S;
            for (var z3 = R - 2; z3 >= 0; --z3)
              T = _[z3], E = T.getLayout()[y4] + T.getLayout()[V] + a - O, E > 0 && (S = T.getLayout()[y4] - E, d4 === "vertical" ? T.setLayout({ x: S }, true) : T.setLayout({ y: S }, true)), O = T.getLayout()[y4];
          }
        });
      }
      function GGt(s, a, n6) {
        gt(s.slice().reverse(), function(f6) {
          gt(f6, function(d4) {
            if (d4.outEdges.length) {
              var y4 = l32(d4.outEdges, HGt, n6) / l32(d4.outEdges, Woe);
              if (isNaN(y4)) {
                var _ = d4.outEdges.length;
                y4 = _ ? l32(d4.outEdges, WGt, n6) / _ : 0;
              }
              if (n6 === "vertical") {
                var S = d4.getLayout().x + (y4 - s3(d4, n6)) * a;
                d4.setLayout({ x: S }, true);
              } else {
                var T = d4.getLayout().y + (y4 - s3(d4, n6)) * a;
                d4.setLayout({ y: T }, true);
              }
            }
          });
        });
      }
      function HGt(s, a) {
        return s3(s.node2, a) * s.getValue();
      }
      function WGt(s, a) {
        return s3(s.node2, a);
      }
      function UGt(s, a) {
        return s3(s.node1, a) * s.getValue();
      }
      function qGt(s, a) {
        return s3(s.node1, a);
      }
      function s3(s, a) {
        return a === "vertical" ? s.getLayout().x + s.getLayout().dx / 2 : s.getLayout().y + s.getLayout().dy / 2;
      }
      function Woe(s) {
        return s.getValue();
      }
      function l32(s, a, n6) {
        for (var f6 = 0, d4 = s.length, y4 = -1; ++y4 < d4; ) {
          var _ = +a(s[y4], n6);
          isNaN(_) || (f6 += _);
        }
        return f6;
      }
      function $Gt(s, a, n6) {
        gt(s, function(f6) {
          gt(f6, function(d4) {
            if (d4.inEdges.length) {
              var y4 = l32(d4.inEdges, UGt, n6) / l32(d4.inEdges, Woe);
              if (isNaN(y4)) {
                var _ = d4.inEdges.length;
                y4 = _ ? l32(d4.inEdges, qGt, n6) / _ : 0;
              }
              if (n6 === "vertical") {
                var S = d4.getLayout().x + (y4 - s3(d4, n6)) * a;
                d4.setLayout({ x: S }, true);
              } else {
                var T = d4.getLayout().y + (y4 - s3(d4, n6)) * a;
                d4.setLayout({ y: T }, true);
              }
            }
          });
        });
      }
      function XGt(s, a) {
        var n6 = a === "vertical" ? "x" : "y";
        gt(s, function(f6) {
          f6.outEdges.sort(function(d4, y4) {
            return d4.node2.getLayout()[n6] - y4.node2.getLayout()[n6];
          }), f6.inEdges.sort(function(d4, y4) {
            return d4.node1.getLayout()[n6] - y4.node1.getLayout()[n6];
          });
        }), gt(s, function(f6) {
          var d4 = 0, y4 = 0;
          gt(f6.outEdges, function(_) {
            _.setLayout({ sy: d4 }, true), d4 += _.getLayout().dy;
          }), gt(f6.inEdges, function(_) {
            _.setLayout({ ty: y4 }, true), y4 += _.getLayout().dy;
          });
        });
      }
      function YGt(s) {
        s.eachSeriesByType("sankey", function(a) {
          var n6 = a.getGraph(), f6 = n6.nodes;
          if (f6.length) {
            var d4 = 1 / 0, y4 = -1 / 0;
            gt(f6, function(_) {
              var S = _.getLayout().value;
              S < d4 && (d4 = S), S > y4 && (y4 = S);
            }), gt(f6, function(_) {
              var S = new zy({ type: "color", mappingMethod: "linear", dataExtent: [d4, y4], visual: a.get("color") }), T = S.mapValueToVisual(_.getLayout().value), E = _.getModel().get(["itemStyle", "color"]);
              E != null ? (_.setVisual("color", E), _.setVisual("style", { fill: E })) : (_.setVisual("color", T), _.setVisual("style", { fill: T }));
            });
          }
        });
      }
      function KGt(s) {
        s.registerChartView(IGt), s.registerSeriesModel(DGt), s.registerLayout(kGt), s.registerVisual(YGt), s.registerAction({ type: "dragNode", event: "dragnode", update: "update" }, function(a, n6) {
          n6.eachComponent({ mainType: "series", subType: "sankey", query: a }, function(f6) {
            f6.setNodePosition(a.dataIndex, [a.localX, a.localY]);
          });
        });
      }
      var PXe = function() {
        function s() {
        }
        return s.prototype.getInitialData = function(a, n6) {
          var f6, d4 = n6.getComponent("xAxis", this.get("xAxisIndex")), y4 = n6.getComponent("yAxis", this.get("yAxisIndex")), _ = d4.get("type"), S = y4.get("type"), T;
          _ === "category" ? (a.layout = "horizontal", f6 = d4.getOrdinalMeta(), T = true) : S === "category" ? (a.layout = "vertical", f6 = y4.getOrdinalMeta(), T = true) : a.layout = a.layout || "horizontal";
          var E = ["x", "y"], O = a.layout === "horizontal" ? 0 : 1, R = this._baseAxisDim = E[O], V = E[1 - O], z3 = [d4, y4], H = z3[O].get("type"), Z = z3[1 - O].get("type"), ee = a.data;
          if (ee && T) {
            var oe = [];
            gt(ee, function(pe, Ve) {
              var Le;
              Di(pe) ? (Le = pe.slice(), pe.unshift(Ve)) : Di(pe.value) ? (Le = ei({}, pe), Le.value = Le.value.slice(), pe.value.unshift(Ve)) : Le = pe, oe.push(Le);
            }), a.data = oe;
          }
          var fe = this.defaultValueDimensions, _e = [{ name: R, type: Qae(H), ordinalMeta: f6, otherDims: { tooltip: false, itemName: 0 }, dimsDef: ["base"] }, { name: V, type: Qae(Z), dimsDef: fe.slice() }];
          return $7(this, { coordDimensions: _e, dimensionsCount: fe.length + 1, encodeDefaulter: ks(Hje, _e, this) });
        }, s.prototype.getBaseAxis = function() {
          var a = this._baseAxisDim;
          return this.ecModel.getComponent(a + "Axis", this.get(a + "AxisIndex")).axis;
        }, s;
      }(), LXe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.defaultValueDimensions = [{ name: "min", defaultTooltip: true }, { name: "Q1", defaultTooltip: true }, { name: "median", defaultTooltip: true }, { name: "Q3", defaultTooltip: true }, { name: "max", defaultTooltip: true }], n6.visualDrawType = "stroke", n6;
        }
        return a.type = "series.boxplot", a.dependencies = ["xAxis", "yAxis", "grid"], a.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, boxWidth: [7, 50], itemStyle: { color: "#fff", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2, shadowBlur: 5, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }, animationDuration: 800 }, a;
      }(Cp);
      nd(LXe, PXe, true);
      var ZGt = LXe, JGt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this.group, S = this._data;
          this._data || _.removeAll();
          var T = n6.get("layout") === "horizontal" ? 1 : 0;
          y4.diff(S).add(function(E) {
            if (y4.hasValue(E)) {
              var O = y4.getItemLayout(E), R = RXe(O, y4, E, T, true);
              y4.setItemGraphicEl(E, R), _.add(R);
            }
          }).update(function(E, O) {
            var R = S.getItemGraphicEl(O);
            if (!y4.hasValue(E)) {
              _.remove(R);
              return;
            }
            var V = y4.getItemLayout(E);
            R ? (ox(R), NXe(V, R, y4, E)) : R = RXe(V, y4, E, T), _.add(R), y4.setItemGraphicEl(E, R);
          }).remove(function(E) {
            var O = S.getItemGraphicEl(E);
            O && _.remove(O);
          }).execute(), this._data = y4;
        }, a.prototype.remove = function(n6) {
          var f6 = this.group, d4 = this._data;
          this._data = null, d4 && d4.eachItemGraphicEl(function(y4) {
            y4 && f6.remove(y4);
          });
        }, a.type = "boxplot", a;
      }(Ch), QGt = function() {
        function s() {
        }
        return s;
      }(), eHt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "boxplotBoxPath", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new QGt();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.points, y4 = 0;
          for (n6.moveTo(d4[y4][0], d4[y4][1]), y4++; y4 < 4; y4++)
            n6.lineTo(d4[y4][0], d4[y4][1]);
          for (n6.closePath(); y4 < d4.length; y4++)
            n6.moveTo(d4[y4][0], d4[y4][1]), y4++, n6.lineTo(d4[y4][0], d4[y4][1]);
        }, a;
      }(ml);
      function RXe(s, a, n6, f6, d4) {
        var y4 = s.ends, _ = new eHt({ shape: { points: d4 ? tHt(y4, f6, s) : y4 } });
        return NXe(s, _, a, n6, d4), _;
      }
      function NXe(s, a, n6, f6, d4) {
        var y4 = n6.hostModel, _ = i$[d4 ? "initProps" : "updateProps"];
        _(a, { shape: { points: s.ends } }, y4, f6), a.useStyle(n6.getItemVisual(f6, "style")), a.style.strokeNoScale = true, a.z2 = 100;
        var S = n6.getItemModel(f6), T = S.getModel("emphasis");
        Pg(a, S), Up(a, T.get("focus"), T.get("blurScope"), T.get("disabled"));
      }
      function tHt(s, a, n6) {
        return Pi(s, function(f6) {
          return f6 = f6.slice(), f6[a] = n6.initBaseline, f6;
        });
      }
      var nHt = JGt;
      function rHt(s, a) {
      }
      var cX = gt;
      function iHt(s) {
        var a = aHt(s);
        cX(a, function(n6) {
          var f6 = n6.seriesModels;
          !f6.length || (oHt(n6), cX(f6, function(d4, y4) {
            sHt(d4, n6.boxOffsetList[y4], n6.boxWidthList[y4]);
          }));
        });
      }
      function aHt(s) {
        var a = [], n6 = [];
        return s.eachSeriesByType("boxplot", function(f6) {
          var d4 = f6.getBaseAxis(), y4 = Ns(n6, d4);
          y4 < 0 && (y4 = n6.length, n6[y4] = d4, a[y4] = { axis: d4, seriesModels: [] }), a[y4].seriesModels.push(f6);
        }), a;
      }
      function oHt(s) {
        var a = s.axis, n6 = s.seriesModels, f6 = n6.length, d4 = s.boxWidthList = [], y4 = s.boxOffsetList = [], _ = [], S;
        if (a.type === "category")
          S = a.getBandWidth();
        else {
          var T = 0;
          cX(n6, function(H) {
            T = Math.max(T, H.getData().count());
          });
          var E = a.getExtent();
          S = Math.abs(E[1] - E[0]) / T;
        }
        cX(n6, function(H) {
          var Z = H.get("boxWidth");
          Di(Z) || (Z = [Z, Z]), _.push([Ia(Z[0], S) || 0, Ia(Z[1], S) || 0]);
        });
        var O = S * 0.8 - 2, R = O / f6 * 0.3, V = (O - R * (f6 - 1)) / f6, z3 = V / 2 - O / 2;
        cX(n6, function(H, Z) {
          y4.push(z3), z3 += R + V, d4.push(Math.min(Math.max(V, _[Z][0]), _[Z][1]));
        });
      }
      function sHt(s, a, n6) {
        var f6 = s.coordinateSystem, d4 = s.getData(), y4 = n6 / 2, _ = s.get("layout") === "horizontal" ? 0 : 1, S = 1 - _, T = ["x", "y"], E = d4.mapDimension(T[_]), O = d4.mapDimensionsAll(T[S]);
        if (E == null || O.length < 5)
          return;
        for (var R = 0; R < d4.count(); R++) {
          var V = d4.get(E, R), z3 = _e(V, O[2], R), H = _e(V, O[0], R), Z = _e(V, O[1], R), ee = _e(V, O[3], R), oe = _e(V, O[4], R), fe = [];
          pe(fe, Z, false), pe(fe, ee, true), fe.push(H, Z, oe, ee), Ve(fe, H), Ve(fe, oe), Ve(fe, z3), d4.setItemLayout(R, { initBaseline: z3[S], ends: fe });
        }
        function _e(Le, je, Xe) {
          var Ye = d4.get(je, Xe), rt2 = [];
          rt2[_] = Le, rt2[S] = Ye;
          var ut;
          return isNaN(Le) || isNaN(Ye) ? ut = [NaN, NaN] : (ut = f6.dataToPoint(rt2), ut[_] += a), ut;
        }
        function pe(Le, je, Xe) {
          var Ye = je.slice(), rt2 = je.slice();
          Ye[_] += y4, rt2[_] -= y4, Xe ? Le.push(Ye, rt2) : Le.push(rt2, Ye);
        }
        function Ve(Le, je) {
          var Xe = je.slice(), Ye = je.slice();
          Xe[_] -= y4, Ye[_] += y4, Le.push(Xe, Ye);
        }
      }
      function lHt(s, a) {
        a = a || {};
        for (var n6 = [], f6 = [], d4 = a.boundIQR, y4 = d4 === "none" || d4 === 0, _ = 0; _ < s.length; _++) {
          var S = W1(s[_].slice()), T = rx(S, 0.25), E = rx(S, 0.5), O = rx(S, 0.75), R = S[0], V = S[S.length - 1], z3 = (d4 == null ? 1.5 : d4) * (O - T), H = y4 ? R : Math.max(R, T - z3), Z = y4 ? V : Math.min(V, O + z3), ee = a.itemNameFormatter, oe = jo(ee) ? ee({ value: _ }) : Wa(ee) ? ee.replace("{value}", _ + "") : _ + "";
          n6.push([oe, H, T, E, O, Z]);
          for (var fe = 0; fe < S.length; fe++) {
            var _e = S[fe];
            if (_e < H || _e > Z) {
              var pe = [oe, _e];
              f6.push(pe);
            }
          }
        }
        return { boxData: n6, outliers: f6 };
      }
      var uHt = { type: "echarts:boxplot", transform: function(s) {
        var a = s.upstream;
        if (a.sourceFormat !== Hm) {
          var n6 = "";
          Ul(n6);
        }
        var f6 = lHt(a.getRawData(), s.config);
        return [{ dimensions: ["ItemName", "Low", "Q1", "Q2", "Q3", "High"], data: f6.boxData }, { data: f6.outliers }];
      } };
      function cHt(s) {
        s.registerSeriesModel(ZGt), s.registerChartView(nHt), s.registerVisual(rHt), s.registerLayout(iHt), s.registerTransform(uHt);
      }
      var fHt = ["color", "borderColor"], hHt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          this.group.removeClipPath(), this._progressiveEls = null, this._updateDrawMode(n6), this._isLargeDraw ? this._renderLarge(n6) : this._renderNormal(n6);
        }, a.prototype.incrementalPrepareRender = function(n6, f6, d4) {
          this._clear(), this._updateDrawMode(n6);
        }, a.prototype.incrementalRender = function(n6, f6, d4, y4) {
          this._progressiveEls = [], this._isLargeDraw ? this._incrementalRenderLarge(n6, f6) : this._incrementalRenderNormal(n6, f6);
        }, a.prototype.eachRendered = function(n6) {
          mC(this._progressiveEls || this.group, n6);
        }, a.prototype._updateDrawMode = function(n6) {
          var f6 = n6.pipelineContext.large;
          (this._isLargeDraw == null || f6 !== this._isLargeDraw) && (this._isLargeDraw = f6, this._clear());
        }, a.prototype._renderNormal = function(n6) {
          var f6 = n6.getData(), d4 = this._data, y4 = this.group, _ = f6.getLayout("isSimpleBox"), S = n6.get("clip", true), T = n6.coordinateSystem, E = T.getArea && T.getArea();
          this._data || y4.removeAll(), f6.diff(d4).add(function(O) {
            if (f6.hasValue(O)) {
              var R = f6.getItemLayout(O);
              if (S && FXe(E, R))
                return;
              var V = x2e(R, O, true);
              $h(V, { shape: { points: R.ends } }, n6, O), w2e(V, f6, O, _), y4.add(V), f6.setItemGraphicEl(O, V);
            }
          }).update(function(O, R) {
            var V = d4.getItemGraphicEl(R);
            if (!f6.hasValue(O)) {
              y4.remove(V);
              return;
            }
            var z3 = f6.getItemLayout(O);
            if (S && FXe(E, z3)) {
              y4.remove(V);
              return;
            }
            V ? (ku(V, { shape: { points: z3.ends } }, n6, O), ox(V)) : V = x2e(z3), w2e(V, f6, O, _), y4.add(V), f6.setItemGraphicEl(O, V);
          }).remove(function(O) {
            var R = d4.getItemGraphicEl(O);
            R && y4.remove(R);
          }).execute(), this._data = f6;
        }, a.prototype._renderLarge = function(n6) {
          this._clear(), BXe(n6, this.group);
          var f6 = n6.get("clip", true) ? boe(n6.coordinateSystem, false, n6) : null;
          f6 ? this.group.setClipPath(f6) : this.group.removeClipPath();
        }, a.prototype._incrementalRenderNormal = function(n6, f6) {
          for (var d4 = f6.getData(), y4 = d4.getLayout("isSimpleBox"), _; (_ = n6.next()) != null; ) {
            var S = d4.getItemLayout(_), T = x2e(S);
            w2e(T, d4, _, y4), T.incremental = true, this.group.add(T), this._progressiveEls.push(T);
          }
        }, a.prototype._incrementalRenderLarge = function(n6, f6) {
          BXe(f6, this.group, this._progressiveEls, true);
        }, a.prototype.remove = function(n6) {
          this._clear();
        }, a.prototype._clear = function() {
          this.group.removeAll(), this._data = null;
        }, a.type = "candlestick", a;
      }(Ch), pHt = function() {
        function s() {
        }
        return s;
      }(), dHt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "normalCandlestickBox", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new pHt();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.points;
          this.__simpleBox ? (n6.moveTo(d4[4][0], d4[4][1]), n6.lineTo(d4[6][0], d4[6][1])) : (n6.moveTo(d4[0][0], d4[0][1]), n6.lineTo(d4[1][0], d4[1][1]), n6.lineTo(d4[2][0], d4[2][1]), n6.lineTo(d4[3][0], d4[3][1]), n6.closePath(), n6.moveTo(d4[4][0], d4[4][1]), n6.lineTo(d4[5][0], d4[5][1]), n6.moveTo(d4[6][0], d4[6][1]), n6.lineTo(d4[7][0], d4[7][1]));
        }, a;
      }(ml);
      function x2e(s, a, n6) {
        var f6 = s.ends;
        return new dHt({ shape: { points: n6 ? vHt(f6, s) : f6 }, z2: 100 });
      }
      function FXe(s, a) {
        for (var n6 = true, f6 = 0; f6 < a.ends.length; f6++)
          if (s.contain(a.ends[f6][0], a.ends[f6][1])) {
            n6 = false;
            break;
          }
        return n6;
      }
      function w2e(s, a, n6, f6) {
        var d4 = a.getItemModel(n6);
        s.useStyle(a.getItemVisual(n6, "style")), s.style.strokeNoScale = true, s.__simpleBox = f6, Pg(s, d4);
      }
      function vHt(s, a) {
        return Pi(s, function(n6) {
          return n6 = n6.slice(), n6[1] = a.initBaseline, n6;
        });
      }
      var gHt = function() {
        function s() {
        }
        return s;
      }(), VXe = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6.type = "largeCandlestickBox", f6;
        }
        return a.prototype.getDefaultShape = function() {
          return new gHt();
        }, a.prototype.buildPath = function(n6, f6) {
          for (var d4 = f6.points, y4 = 0; y4 < d4.length; )
            if (this.__sign === d4[y4++]) {
              var _ = d4[y4++];
              n6.moveTo(_, d4[y4++]), n6.lineTo(_, d4[y4++]);
            } else
              y4 += 3;
        }, a;
      }(ml);
      function BXe(s, a, n6, f6) {
        var d4 = s.getData(), y4 = d4.getLayout("largePoints"), _ = new VXe({ shape: { points: y4 }, __sign: 1 });
        a.add(_);
        var S = new VXe({ shape: { points: y4 }, __sign: -1 });
        a.add(S), zXe(1, _, s), zXe(-1, S, s), f6 && (_.incremental = true, S.incremental = true), n6 && n6.push(_, S);
      }
      function zXe(s, a, n6, f6) {
        var d4 = n6.get(["itemStyle", s > 0 ? "borderColor" : "borderColor0"]) || n6.get(["itemStyle", s > 0 ? "color" : "color0"]), y4 = n6.getModel("itemStyle").getItemStyle(fHt);
        a.useStyle(y4), a.style.fill = null, a.style.stroke = d4;
      }
      var yHt = hHt, jXe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.defaultValueDimensions = [{ name: "open", defaultTooltip: true }, { name: "close", defaultTooltip: true }, { name: "lowest", defaultTooltip: true }, { name: "highest", defaultTooltip: true }], n6;
        }
        return a.prototype.getShadowDim = function() {
          return "open";
        }, a.prototype.brushSelector = function(n6, f6, d4) {
          var y4 = f6.getItemLayout(n6);
          return y4 && d4.rect(y4.brushRect);
        }, a.type = "series.candlestick", a.dependencies = ["xAxis", "yAxis", "grid"], a.defaultOption = { z: 2, coordinateSystem: "cartesian2d", legendHoverLink: true, layout: null, clip: true, itemStyle: { color: "#eb5454", color0: "#47b262", borderColor: "#eb5454", borderColor0: "#47b262", borderWidth: 1 }, emphasis: { scale: true, itemStyle: { borderWidth: 2 } }, barMaxWidth: null, barMinWidth: null, barWidth: null, large: true, largeThreshold: 600, progressive: 3e3, progressiveThreshold: 1e4, progressiveChunkMode: "mod", animationEasing: "linear", animationDuration: 300 }, a;
      }(Cp);
      nd(jXe, PXe, true);
      var mHt = jXe;
      function bHt(s) {
        !s || !Di(s.series) || gt(s.series, function(a) {
          Qo(a) && a.type === "k" && (a.type = "candlestick");
        });
      }
      var _Ht = ["itemStyle", "borderColor"], xHt = ["itemStyle", "borderColor0"], wHt = ["itemStyle", "color"], SHt = ["itemStyle", "color0"], CHt = { seriesType: "candlestick", plan: R7(), performRawSeries: true, reset: function(s, a) {
        function n6(y4, _) {
          return _.get(y4 > 0 ? wHt : SHt);
        }
        function f6(y4, _) {
          return _.get(y4 > 0 ? _Ht : xHt);
        }
        if (!a.isSeriesFiltered(s)) {
          var d4 = s.pipelineContext.large;
          return !d4 && { progress: function(y4, _) {
            for (var S; (S = y4.next()) != null; ) {
              var T = _.getItemModel(S), E = _.getItemLayout(S).sign, O = T.getItemStyle();
              O.fill = n6(E, T), O.stroke = f6(E, T) || O.fill;
              var R = _.ensureUniqueItemVisual(S, "style");
              ei(R, O);
            }
          } };
        }
      } }, MHt = CHt, THt = { seriesType: "candlestick", plan: R7(), reset: function(s) {
        var a = s.coordinateSystem, n6 = s.getData(), f6 = AHt(s, n6), d4 = 0, y4 = 1, _ = ["x", "y"], S = n6.getDimensionIndex(n6.mapDimension(_[d4])), T = Pi(n6.mapDimensionsAll(_[y4]), n6.getDimensionIndex, n6), E = T[0], O = T[1], R = T[2], V = T[3];
        if (n6.setLayout({ candleWidth: f6, isSimpleBox: f6 <= 1.3 }), S < 0 || T.length < 4)
          return;
        return { progress: s.pipelineContext.large ? H : z3 };
        function z3(Z, ee) {
          for (var oe, fe = ee.getStore(); (oe = Z.next()) != null; ) {
            var _e = fe.get(S, oe), pe = fe.get(E, oe), Ve = fe.get(O, oe), Le = fe.get(R, oe), je = fe.get(V, oe), Xe = Math.min(pe, Ve), Ye = Math.max(pe, Ve), rt2 = Qt(Xe, _e), ut = Qt(Ye, _e), wt = Qt(Le, _e), dt = Qt(je, _e), Gt = [];
            Nt(Gt, ut, 0), Nt(Gt, rt2, 1), Gt.push(un(dt), un(ut), un(wt), un(rt2)), ee.setItemLayout(oe, { sign: GXe(fe, oe, pe, Ve, O), initBaseline: pe > Ve ? ut[y4] : rt2[y4], ends: Gt, brushRect: er(Le, je, _e) });
          }
          function Qt(pn, On) {
            var fr = [];
            return fr[d4] = On, fr[y4] = pn, isNaN(On) || isNaN(pn) ? [NaN, NaN] : a.dataToPoint(fr);
          }
          function Nt(pn, On, fr) {
            var yr = On.slice(), da = On.slice();
            yr[d4] = ia(yr[d4] + f6 / 2, 1, false), da[d4] = ia(da[d4] - f6 / 2, 1, true), fr ? pn.push(yr, da) : pn.push(da, yr);
          }
          function er(pn, On, fr) {
            var yr = Qt(pn, fr), da = Qt(On, fr);
            return yr[d4] -= f6 / 2, da[d4] -= f6 / 2, { x: yr[0], y: yr[1], width: f6, height: da[1] - yr[1] };
          }
          function un(pn) {
            return pn[d4] = ia(pn[d4], 1), pn;
          }
        }
        function H(Z, ee) {
          for (var oe = RT(Z.count * 4), fe = 0, _e, pe = [], Ve = [], Le, je = ee.getStore(); (Le = Z.next()) != null; ) {
            var Xe = je.get(S, Le), Ye = je.get(E, Le), rt2 = je.get(O, Le), ut = je.get(R, Le), wt = je.get(V, Le);
            if (isNaN(Xe) || isNaN(ut) || isNaN(wt)) {
              oe[fe++] = NaN, fe += 3;
              continue;
            }
            oe[fe++] = GXe(je, Le, Ye, rt2, O), pe[d4] = Xe, pe[y4] = ut, _e = a.dataToPoint(pe, null, Ve), oe[fe++] = _e ? _e[0] : NaN, oe[fe++] = _e ? _e[1] : NaN, pe[y4] = wt, _e = a.dataToPoint(pe, null, Ve), oe[fe++] = _e ? _e[1] : NaN;
          }
          ee.setLayout("largePoints", oe);
        }
      } };
      function GXe(s, a, n6, f6, d4) {
        var y4;
        return n6 > f6 ? y4 = -1 : n6 < f6 ? y4 = 1 : y4 = a > 0 ? s.get(d4, a - 1) <= f6 ? 1 : -1 : 1, y4;
      }
      function AHt(s, a) {
        var n6 = s.getBaseAxis(), f6, d4 = n6.type === "category" ? n6.getBandWidth() : (f6 = n6.getExtent(), Math.abs(f6[1] - f6[0]) / a.count()), y4 = Ia(Zs(s.get("barMaxWidth"), d4), d4), _ = Ia(Zs(s.get("barMinWidth"), 1), d4), S = s.get("barWidth");
        return S != null ? Ia(S, d4) : Math.max(Math.min(d4 / 2, y4), _);
      }
      var IHt = THt;
      function EHt(s) {
        s.registerChartView(yHt), s.registerSeriesModel(mHt), s.registerPreprocessor(bHt), s.registerVisual(MHt), s.registerLayout(IHt);
      }
      function HXe(s, a) {
        var n6 = a.rippleEffectColor || a.color;
        s.eachChild(function(f6) {
          f6.attr({ z: a.z, zlevel: a.zlevel, style: { stroke: a.brushType === "stroke" ? n6 : null, fill: a.brushType === "fill" ? n6 : null } });
        });
      }
      var DHt = function(s) {
        Vt(a, s);
        function a(n6, f6) {
          var d4 = s.call(this) || this, y4 = new G$(n6, f6), _ = new fs();
          return d4.add(y4), d4.add(_), d4.updateData(n6, f6), d4;
        }
        return a.prototype.stopEffectAnimation = function() {
          this.childAt(1).removeAll();
        }, a.prototype.startEffectAnimation = function(n6) {
          for (var f6 = n6.symbolType, d4 = n6.color, y4 = n6.rippleNumber, _ = this.childAt(1), S = 0; S < y4; S++) {
            var T = bv(f6, -1, -1, 2, 2, d4);
            T.attr({ style: { strokeNoScale: true }, z2: 99, silent: true, scaleX: 0.5, scaleY: 0.5 });
            var E = -S / y4 * n6.period + n6.effectOffset;
            T.animate("", true).when(n6.period, { scaleX: n6.rippleScale / 2, scaleY: n6.rippleScale / 2 }).delay(E).start(), T.animateStyle(true).when(n6.period, { opacity: 0 }).delay(E).start(), _.add(T);
          }
          HXe(_, n6);
        }, a.prototype.updateEffectAnimation = function(n6) {
          for (var f6 = this._effectCfg, d4 = this.childAt(1), y4 = ["symbolType", "period", "rippleScale", "rippleNumber"], _ = 0; _ < y4.length; _++) {
            var S = y4[_];
            if (f6[S] !== n6[S]) {
              this.stopEffectAnimation(), this.startEffectAnimation(n6);
              return;
            }
          }
          HXe(d4, n6);
        }, a.prototype.highlight = function() {
          sS(this);
        }, a.prototype.downplay = function() {
          lS(this);
        }, a.prototype.getSymbolType = function() {
          var n6 = this.childAt(0);
          return n6 && n6.getSymbolType();
        }, a.prototype.updateData = function(n6, f6) {
          var d4 = this, y4 = n6.hostModel;
          this.childAt(0).updateData(n6, f6);
          var _ = this.childAt(1), S = n6.getItemModel(f6), T = n6.getItemVisual(f6, "symbol"), E = x$(n6.getItemVisual(f6, "symbolSize")), O = n6.getItemVisual(f6, "style"), R = O && O.fill, V = S.getModel("emphasis");
          _.setScale(E), _.traverse(function(ee) {
            ee.setStyle("fill", R);
          });
          var z3 = B7(n6.getItemVisual(f6, "symbolOffset"), E);
          z3 && (_.x = z3[0], _.y = z3[1]);
          var H = n6.getItemVisual(f6, "symbolRotate");
          _.rotation = (H || 0) * Math.PI / 180 || 0;
          var Z = {};
          Z.showEffectOn = y4.get("showEffectOn"), Z.rippleScale = S.get(["rippleEffect", "scale"]), Z.brushType = S.get(["rippleEffect", "brushType"]), Z.period = S.get(["rippleEffect", "period"]) * 1e3, Z.effectOffset = f6 / n6.count(), Z.z = y4.getShallow("z") || 0, Z.zlevel = y4.getShallow("zlevel") || 0, Z.symbolType = T, Z.color = R, Z.rippleEffectColor = S.get(["rippleEffect", "color"]), Z.rippleNumber = S.get(["rippleEffect", "number"]), Z.showEffectOn === "render" ? (this._effectCfg ? this.updateEffectAnimation(Z) : this.startEffectAnimation(Z), this._effectCfg = Z) : (this._effectCfg = null, this.stopEffectAnimation(), this.onHoverStateChange = function(ee) {
            ee === "emphasis" ? Z.showEffectOn !== "render" && d4.startEffectAnimation(Z) : ee === "normal" && Z.showEffectOn !== "render" && d4.stopEffectAnimation();
          }), this._effectCfg = Z, Up(this, V.get("focus"), V.get("blurScope"), V.get("disabled"));
        }, a.prototype.fadeOut = function(n6) {
          n6 && n6();
        }, a;
      }(fs), kHt = DHt, OHt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function() {
          this._symbolDraw = new H$(kHt);
        }, a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this._symbolDraw;
          _.updateData(y4, { clipShape: this._getClipShape(n6) }), this.group.add(_.group);
        }, a.prototype._getClipShape = function(n6) {
          var f6 = n6.coordinateSystem, d4 = f6 && f6.getArea && f6.getArea();
          return n6.get("clip", true) ? d4 : null;
        }, a.prototype.updateTransform = function(n6, f6, d4) {
          var y4 = n6.getData();
          this.group.dirty();
          var _ = W$("").reset(n6, f6, d4);
          _.progress && _.progress({ start: 0, end: y4.count(), count: y4.count() }, y4), this._symbolDraw.updateLayout();
        }, a.prototype._updateGroupTransform = function(n6) {
          var f6 = n6.coordinateSystem;
          f6 && f6.getRoamTransform && (this.group.transform = R9(f6.getRoamTransform()), this.group.decomposeTransform());
        }, a.prototype.remove = function(n6, f6) {
          this._symbolDraw && this._symbolDraw.remove(true);
        }, a.type = "effectScatter", a;
      }(Ch), PHt = OHt, LHt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.hasSymbolVisual = true, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          return PE(null, this, { useEncodeDefaulter: true });
        }, a.prototype.brushSelector = function(n6, f6, d4) {
          return d4.point(f6.getItemLayout(n6));
        }, a.type = "series.effectScatter", a.dependencies = ["grid", "polar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, effectType: "ripple", progressive: 0, showEffectOn: "render", clip: true, rippleEffect: { period: 4, scale: 2.5, brushType: "fill", number: 3 }, universalTransition: { divideShape: "clone" }, symbolSize: 10 }, a;
      }(Cp), RHt = LHt;
      function NHt(s) {
        s.registerChartView(PHt), s.registerSeriesModel(RHt), s.registerLayout(W$("effectScatter"));
      }
      var FHt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this) || this;
          return y4.add(y4.createLine(n6, f6, d4)), y4._updateEffectSymbol(n6, f6), y4;
        }
        return a.prototype.createLine = function(n6, f6, d4) {
          return new YSe(n6, f6, d4);
        }, a.prototype._updateEffectSymbol = function(n6, f6) {
          var d4 = n6.getItemModel(f6), y4 = d4.getModel("effect"), _ = y4.get("symbolSize"), S = y4.get("symbol");
          Di(_) || (_ = [_, _]);
          var T = n6.getItemVisual(f6, "style"), E = y4.get("color") || T && T.stroke, O = this.childAt(1);
          this._symbolType !== S && (this.remove(O), O = bv(S, -0.5, -0.5, 1, 1, E), O.z2 = 100, O.culling = true, this.add(O)), O && (O.setStyle("shadowColor", E), O.setStyle(y4.getItemStyle(["color"])), O.scaleX = _[0], O.scaleY = _[1], O.setColor(E), this._symbolType = S, this._symbolScale = _, this._updateEffectAnimation(n6, y4, f6));
        }, a.prototype._updateEffectAnimation = function(n6, f6, d4) {
          var y4 = this.childAt(1);
          if (y4) {
            var _ = n6.getItemLayout(d4), S = f6.get("period") * 1e3, T = f6.get("loop"), E = f6.get("constantSpeed"), O = $v(f6.get("delay"), function(V) {
              return V / n6.count() * S / 3;
            });
            if (y4.ignore = true, this._updateAnimationPoints(y4, _), E > 0 && (S = this._getLineLength(y4) / E * 1e3), S !== this._period || T !== this._loop) {
              y4.stopAnimation();
              var R = void 0;
              jo(O) ? R = O(d4) : R = O, y4.__t > 0 && (R = -S * y4.__t), this._animateSymbol(y4, S, R, T);
            }
            this._period = S, this._loop = T;
          }
        }, a.prototype._animateSymbol = function(n6, f6, d4, y4) {
          if (f6 > 0) {
            n6.__t = 0;
            var _ = this, S = n6.animate("", y4).when(f6, { __t: 1 }).delay(d4).during(function() {
              _._updateSymbolPosition(n6);
            });
            y4 || S.done(function() {
              _.remove(n6);
            }), S.start();
          }
        }, a.prototype._getLineLength = function(n6) {
          return Zw(n6.__p1, n6.__cp1) + Zw(n6.__cp1, n6.__p2);
        }, a.prototype._updateAnimationPoints = function(n6, f6) {
          n6.__p1 = f6[0], n6.__p2 = f6[1], n6.__cp1 = f6[2] || [(f6[0][0] + f6[1][0]) / 2, (f6[0][1] + f6[1][1]) / 2];
        }, a.prototype.updateData = function(n6, f6, d4) {
          this.childAt(0).updateData(n6, f6, d4), this._updateEffectSymbol(n6, f6);
        }, a.prototype._updateSymbolPosition = function(n6) {
          var f6 = n6.__p1, d4 = n6.__p2, y4 = n6.__cp1, _ = n6.__t, S = [n6.x, n6.y], T = S.slice(), E = Yv, O = g9;
          S[0] = E(f6[0], y4[0], d4[0], _), S[1] = E(f6[1], y4[1], d4[1], _);
          var R = O(f6[0], y4[0], d4[0], _), V = O(f6[1], y4[1], d4[1], _);
          n6.rotation = -Math.atan2(V, R) - Math.PI / 2, (this._symbolType === "line" || this._symbolType === "rect" || this._symbolType === "roundRect") && (n6.__lastT !== void 0 && n6.__lastT < n6.__t ? (n6.scaleY = Zw(T, S) * 1.05, _ === 1 && (S[0] = T[0] + (S[0] - T[0]) / 2, S[1] = T[1] + (S[1] - T[1]) / 2)) : n6.__lastT === 1 ? n6.scaleY = 2 * Zw(f6, S) : n6.scaleY = this._symbolScale[1]), n6.__lastT = n6.__t, n6.ignore = false, n6.x = S[0], n6.y = S[1];
        }, a.prototype.updateLayout = function(n6, f6) {
          this.childAt(0).updateLayout(n6, f6);
          var d4 = n6.getItemModel(f6).getModel("effect");
          this._updateEffectAnimation(n6, d4, f6);
        }, a;
      }(fs), WXe = FHt, VHt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4) {
          var y4 = s.call(this) || this;
          return y4._createPolyline(n6, f6, d4), y4;
        }
        return a.prototype._createPolyline = function(n6, f6, d4) {
          var y4 = n6.getItemLayout(f6), _ = new zm({ shape: { points: y4 } });
          this.add(_), this._updateCommonStl(n6, f6, d4);
        }, a.prototype.updateData = function(n6, f6, d4) {
          var y4 = n6.hostModel, _ = this.childAt(0), S = { shape: { points: n6.getItemLayout(f6) } };
          ku(_, S, y4, f6), this._updateCommonStl(n6, f6, d4);
        }, a.prototype._updateCommonStl = function(n6, f6, d4) {
          var y4 = this.childAt(0), _ = n6.getItemModel(f6), S = d4 && d4.emphasisLineStyle, T = d4 && d4.focus, E = d4 && d4.blurScope, O = d4 && d4.emphasisDisabled;
          if (!d4 || n6.hasItemOption) {
            var R = _.getModel("emphasis");
            S = R.getModel("lineStyle").getLineStyle(), O = R.get("disabled"), T = R.get("focus"), E = R.get("blurScope");
          }
          y4.useStyle(n6.getItemVisual(f6, "style")), y4.style.fill = null, y4.style.strokeNoScale = true;
          var V = y4.ensureState("emphasis");
          V.style = S, Up(this, T, E, O);
        }, a.prototype.updateLayout = function(n6, f6) {
          var d4 = this.childAt(0);
          d4.setShape("points", n6.getItemLayout(f6));
        }, a;
      }(fs), UXe = VHt, BHt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6._lastFrame = 0, n6._lastFramePercent = 0, n6;
        }
        return a.prototype.createLine = function(n6, f6, d4) {
          return new UXe(n6, f6, d4);
        }, a.prototype._updateAnimationPoints = function(n6, f6) {
          this._points = f6;
          for (var d4 = [0], y4 = 0, _ = 1; _ < f6.length; _++) {
            var S = f6[_ - 1], T = f6[_];
            y4 += Zw(S, T), d4.push(y4);
          }
          if (y4 === 0) {
            this._length = 0;
            return;
          }
          for (var _ = 0; _ < d4.length; _++)
            d4[_] /= y4;
          this._offsets = d4, this._length = y4;
        }, a.prototype._getLineLength = function() {
          return this._length;
        }, a.prototype._updateSymbolPosition = function(n6) {
          var f6 = n6.__t, d4 = this._points, y4 = this._offsets, _ = d4.length;
          if (y4) {
            var S = this._lastFrame, T;
            if (f6 < this._lastFramePercent) {
              var E = Math.min(S + 1, _ - 1);
              for (T = E; T >= 0 && !(y4[T] <= f6); T--)
                ;
              T = Math.min(T, _ - 2);
            } else {
              for (T = S; T < _ && !(y4[T] > f6); T++)
                ;
              T = Math.min(T - 1, _ - 2);
            }
            var O = (f6 - y4[T]) / (y4[T + 1] - y4[T]), R = d4[T], V = d4[T + 1];
            n6.x = R[0] * (1 - O) + O * V[0], n6.y = R[1] * (1 - O) + O * V[1];
            var z3 = V[0] - R[0], H = V[1] - R[1];
            n6.rotation = -Math.atan2(H, z3) - Math.PI / 2, this._lastFrame = T, this._lastFramePercent = f6, n6.ignore = false;
          }
        }, a;
      }(WXe), zHt = BHt, jHt = function() {
        function s() {
          this.polyline = false, this.curveness = 0, this.segs = [];
        }
        return s;
      }(), GHt = function(s) {
        Vt(a, s);
        function a(n6) {
          var f6 = s.call(this, n6) || this;
          return f6._off = 0, f6.hoverDataIdx = -1, f6;
        }
        return a.prototype.reset = function() {
          this.notClear = false, this._off = 0;
        }, a.prototype.getDefaultStyle = function() {
          return { stroke: "#000", fill: null };
        }, a.prototype.getDefaultShape = function() {
          return new jHt();
        }, a.prototype.buildPath = function(n6, f6) {
          var d4 = f6.segs, y4 = f6.curveness, _;
          if (f6.polyline)
            for (_ = this._off; _ < d4.length; ) {
              var S = d4[_++];
              if (S > 0) {
                n6.moveTo(d4[_++], d4[_++]);
                for (var T = 1; T < S; T++)
                  n6.lineTo(d4[_++], d4[_++]);
              }
            }
          else
            for (_ = this._off; _ < d4.length; ) {
              var E = d4[_++], O = d4[_++], R = d4[_++], V = d4[_++];
              if (n6.moveTo(E, O), y4 > 0) {
                var z3 = (E + R) / 2 - (O - V) * y4, H = (O + V) / 2 - (R - E) * y4;
                n6.quadraticCurveTo(z3, H, R, V);
              } else
                n6.lineTo(R, V);
            }
          this.incremental && (this._off = _, this.notClear = true);
        }, a.prototype.findDataIndex = function(n6, f6) {
          var d4 = this.shape, y4 = d4.segs, _ = d4.curveness, S = this.style.lineWidth;
          if (d4.polyline)
            for (var T = 0, E = 0; E < y4.length; ) {
              var O = y4[E++];
              if (O > 0)
                for (var R = y4[E++], V = y4[E++], z3 = 1; z3 < O; z3++) {
                  var H = y4[E++], Z = y4[E++];
                  if (CT(R, V, H, Z, S, n6, f6))
                    return T;
                }
              T++;
            }
          else
            for (var T = 0, E = 0; E < y4.length; ) {
              var R = y4[E++], V = y4[E++], H = y4[E++], Z = y4[E++];
              if (_ > 0) {
                var ee = (R + H) / 2 - (V - Z) * _, oe = (V + Z) / 2 - (H - R) * _;
                if (Cie(R, V, ee, oe, H, Z, S, n6, f6))
                  return T;
              } else if (CT(R, V, H, Z, S, n6, f6))
                return T;
              T++;
            }
          return -1;
        }, a.prototype.contain = function(n6, f6) {
          var d4 = this.transformCoordToLocal(n6, f6), y4 = this.getBoundingRect();
          if (n6 = d4[0], f6 = d4[1], y4.contain(n6, f6)) {
            var _ = this.hoverDataIdx = this.findDataIndex(n6, f6);
            return _ >= 0;
          }
          return this.hoverDataIdx = -1, false;
        }, a.prototype.getBoundingRect = function() {
          var n6 = this._rect;
          if (!n6) {
            for (var f6 = this.shape, d4 = f6.segs, y4 = 1 / 0, _ = 1 / 0, S = -1 / 0, T = -1 / 0, E = 0; E < d4.length; ) {
              var O = d4[E++], R = d4[E++];
              y4 = Math.min(O, y4), S = Math.max(O, S), _ = Math.min(R, _), T = Math.max(R, T);
            }
            n6 = this._rect = new il(y4, _, S, T);
          }
          return n6;
        }, a;
      }(ml), HHt = function() {
        function s() {
          this.group = new fs();
        }
        return s.prototype.updateData = function(a) {
          this._clear();
          var n6 = this._create();
          n6.setShape({ segs: a.getLayout("linesPoints") }), this._setCommon(n6, a);
        }, s.prototype.incrementalPrepareUpdate = function(a) {
          this.group.removeAll(), this._clear();
        }, s.prototype.incrementalUpdate = function(a, n6) {
          var f6 = this._newAdded[0], d4 = n6.getLayout("linesPoints"), y4 = f6 && f6.shape.segs;
          if (y4 && y4.length < 2e4) {
            var _ = y4.length, S = new Float32Array(_ + d4.length);
            S.set(y4), S.set(d4, _), f6.setShape({ segs: S });
          } else {
            this._newAdded = [];
            var T = this._create();
            T.incremental = true, T.setShape({ segs: d4 }), this._setCommon(T, n6), T.__startIndex = a.start;
          }
        }, s.prototype.remove = function() {
          this._clear();
        }, s.prototype.eachRendered = function(a) {
          this._newAdded[0] && a(this._newAdded[0]);
        }, s.prototype._create = function() {
          var a = new GHt({ cursor: "default" });
          return this._newAdded.push(a), this.group.add(a), a;
        }, s.prototype._setCommon = function(a, n6, f6) {
          var d4 = n6.hostModel;
          a.setShape({ polyline: d4.get("polyline"), curveness: d4.get(["lineStyle", "curveness"]) }), a.useStyle(d4.getModel("lineStyle").getLineStyle()), a.style.strokeNoScale = true;
          var y4 = n6.getVisual("style");
          y4 && y4.stroke && a.setStyle("stroke", y4.stroke), a.setStyle("fill", null);
          var _ = qo(a);
          _.seriesIndex = d4.seriesIndex, a.on("mousemove", function(S) {
            _.dataIndex = null;
            var T = a.hoverDataIdx;
            T > 0 && (_.dataIndex = T + a.__startIndex);
          });
        }, s.prototype._clear = function() {
          this._newAdded = [], this.group.removeAll();
        }, s;
      }(), WHt = HHt, UHt = { seriesType: "lines", plan: R7(), reset: function(s) {
        var a = s.coordinateSystem;
        if (a) {
          var n6 = s.get("polyline"), f6 = s.pipelineContext.large;
          return { progress: function(d4, y4) {
            var _ = [];
            if (f6) {
              var S = void 0, T = d4.end - d4.start;
              if (n6) {
                for (var E = 0, O = d4.start; O < d4.end; O++)
                  E += s.getLineCoordsCount(O);
                S = new Float32Array(T + E * 2);
              } else
                S = new Float32Array(T * 4);
              for (var R = 0, V = [], O = d4.start; O < d4.end; O++) {
                var z3 = s.getLineCoords(O, _);
                n6 && (S[R++] = z3);
                for (var H = 0; H < z3; H++)
                  V = a.dataToPoint(_[H], false, V), S[R++] = V[0], S[R++] = V[1];
              }
              y4.setLayout("linesPoints", S);
            } else
              for (var O = d4.start; O < d4.end; O++) {
                var Z = y4.getItemModel(O), z3 = s.getLineCoords(O, _), ee = [];
                if (n6)
                  for (var oe = 0; oe < z3; oe++)
                    ee.push(a.dataToPoint(_[oe]));
                else {
                  ee[0] = a.dataToPoint(_[0]), ee[1] = a.dataToPoint(_[1]);
                  var fe = Z.get(["lineStyle", "curveness"]);
                  +fe && (ee[2] = [(ee[0][0] + ee[1][0]) / 2 - (ee[0][1] - ee[1][1]) * fe, (ee[0][1] + ee[1][1]) / 2 - (ee[1][0] - ee[0][0]) * fe]);
                }
                y4.setItemLayout(O, ee);
              }
          } };
        }
      } }, qXe = UHt, qHt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this._updateLineDraw(y4, n6), S = n6.get("zlevel"), T = n6.get(["effect", "trailLength"]), E = d4.getZr(), O = E.painter.getType() === "svg";
          O || E.painter.getLayer(S).clear(true), this._lastZlevel != null && !O && E.configLayer(this._lastZlevel, { motionBlur: false }), this._showEffect(n6) && T > 0 && (O || E.configLayer(S, { motionBlur: true, lastFrameAlpha: Math.max(Math.min(T / 10 + 0.9, 1), 0) })), _.updateData(y4);
          var R = n6.get("clip", true) && boe(n6.coordinateSystem, false, n6);
          R ? this.group.setClipPath(R) : this.group.removeClipPath(), this._lastZlevel = S, this._finished = true;
        }, a.prototype.incrementalPrepareRender = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this._updateLineDraw(y4, n6);
          _.incrementalPrepareUpdate(y4), this._clearLayer(d4), this._finished = false;
        }, a.prototype.incrementalRender = function(n6, f6, d4) {
          this._lineDraw.incrementalUpdate(n6, f6.getData()), this._finished = n6.end === f6.getData().count();
        }, a.prototype.eachRendered = function(n6) {
          this._lineDraw && this._lineDraw.eachRendered(n6);
        }, a.prototype.updateTransform = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = n6.pipelineContext;
          if (!this._finished || _.large || _.progressiveRender)
            return { update: true };
          var S = qXe.reset(n6, f6, d4);
          S.progress && S.progress({ start: 0, end: y4.count(), count: y4.count() }, y4), this._lineDraw.updateLayout(), this._clearLayer(d4);
        }, a.prototype._updateLineDraw = function(n6, f6) {
          var d4 = this._lineDraw, y4 = this._showEffect(f6), _ = !!f6.get("polyline"), S = f6.pipelineContext, T = S.large;
          return (!d4 || y4 !== this._hasEffet || _ !== this._isPolyline || T !== this._isLargeDraw) && (d4 && d4.remove(), d4 = this._lineDraw = T ? new WHt() : new ZSe(_ ? y4 ? zHt : UXe : y4 ? WXe : YSe), this._hasEffet = y4, this._isPolyline = _, this._isLargeDraw = T), this.group.add(d4.group), d4;
        }, a.prototype._showEffect = function(n6) {
          return !!n6.get(["effect", "show"]);
        }, a.prototype._clearLayer = function(n6) {
          var f6 = n6.getZr(), d4 = f6.painter.getType() === "svg";
          !d4 && this._lastZlevel != null && f6.painter.getLayer(this._lastZlevel).clear(true);
        }, a.prototype.remove = function(n6, f6) {
          this._lineDraw && this._lineDraw.remove(), this._lineDraw = null, this._clearLayer(f6);
        }, a.prototype.dispose = function(n6, f6) {
          this.remove(n6, f6);
        }, a.type = "lines", a;
      }(Ch), $Ht = qHt, XHt = typeof Uint32Array == "undefined" ? Array : Uint32Array, YHt = typeof Float64Array == "undefined" ? Array : Float64Array;
      function $Xe(s) {
        var a = s.data;
        a && a[0] && a[0][0] && a[0][0].coord && (s.data = Pi(a, function(n6) {
          var f6 = [n6[0].coord, n6[1].coord], d4 = { coords: f6 };
          return n6[0].name && (d4.fromName = n6[0].name), n6[1].name && (d4.toName = n6[1].name), YI([d4, n6[0], n6[1]]);
        }));
      }
      var KHt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.visualStyleAccessPath = "lineStyle", n6.visualDrawType = "stroke", n6;
        }
        return a.prototype.init = function(n6) {
          n6.data = n6.data || [], $Xe(n6);
          var f6 = this._processFlatCoordsArray(n6.data);
          this._flatCoords = f6.flatCoords, this._flatCoordsOffset = f6.flatCoordsOffset, f6.flatCoords && (n6.data = new Float32Array(f6.count)), s.prototype.init.apply(this, arguments);
        }, a.prototype.mergeOption = function(n6) {
          if ($Xe(n6), n6.data) {
            var f6 = this._processFlatCoordsArray(n6.data);
            this._flatCoords = f6.flatCoords, this._flatCoordsOffset = f6.flatCoordsOffset, f6.flatCoords && (n6.data = new Float32Array(f6.count));
          }
          s.prototype.mergeOption.apply(this, arguments);
        }, a.prototype.appendData = function(n6) {
          var f6 = this._processFlatCoordsArray(n6.data);
          f6.flatCoords && (this._flatCoords ? (this._flatCoords = u9(this._flatCoords, f6.flatCoords), this._flatCoordsOffset = u9(this._flatCoordsOffset, f6.flatCoordsOffset)) : (this._flatCoords = f6.flatCoords, this._flatCoordsOffset = f6.flatCoordsOffset), n6.data = new Float32Array(f6.count)), this.getRawData().appendData(n6.data);
        }, a.prototype._getCoordsFromItemModel = function(n6) {
          var f6 = this.getData().getItemModel(n6), d4 = f6.option instanceof Array ? f6.option : f6.getShallow("coords");
          return d4;
        }, a.prototype.getLineCoordsCount = function(n6) {
          return this._flatCoordsOffset ? this._flatCoordsOffset[n6 * 2 + 1] : this._getCoordsFromItemModel(n6).length;
        }, a.prototype.getLineCoords = function(n6, f6) {
          if (this._flatCoordsOffset) {
            for (var d4 = this._flatCoordsOffset[n6 * 2], y4 = this._flatCoordsOffset[n6 * 2 + 1], _ = 0; _ < y4; _++)
              f6[_] = f6[_] || [], f6[_][0] = this._flatCoords[d4 + _ * 2], f6[_][1] = this._flatCoords[d4 + _ * 2 + 1];
            return y4;
          } else {
            for (var S = this._getCoordsFromItemModel(n6), _ = 0; _ < S.length; _++)
              f6[_] = f6[_] || [], f6[_][0] = S[_][0], f6[_][1] = S[_][1];
            return S.length;
          }
        }, a.prototype._processFlatCoordsArray = function(n6) {
          var f6 = 0;
          if (this._flatCoords && (f6 = this._flatCoords.length), ac(n6[0])) {
            for (var d4 = n6.length, y4 = new XHt(d4), _ = new YHt(d4), S = 0, T = 0, E = 0, O = 0; O < d4; ) {
              E++;
              var R = n6[O++];
              y4[T++] = S + f6, y4[T++] = R;
              for (var V = 0; V < R; V++) {
                var z3 = n6[O++], H = n6[O++];
                _[S++] = z3, _[S++] = H;
              }
            }
            return { flatCoordsOffset: new Uint32Array(y4.buffer, 0, T), flatCoords: _, count: E };
          }
          return { flatCoordsOffset: null, flatCoords: null, count: n6.length };
        }, a.prototype.getInitialData = function(n6, f6) {
          var d4 = new K1(["value"], this);
          return d4.hasItemOption = false, d4.initData(n6.data, [], function(y4, _, S, T) {
            if (y4 instanceof Array)
              return NaN;
            d4.hasItemOption = true;
            var E = y4.value;
            if (E != null)
              return E instanceof Array ? E[T] : E;
          }), d4;
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          var y4 = this.getData(), _ = y4.getItemModel(n6), S = _.get("name");
          if (S)
            return S;
          var T = _.get("fromName"), E = _.get("toName"), O = [];
          return T != null && O.push(T), E != null && O.push(E), Rg("nameValue", { name: O.join(" > ") });
        }, a.prototype.preventIncremental = function() {
          return !!this.get(["effect", "show"]);
        }, a.prototype.getProgressive = function() {
          var n6 = this.option.progressive;
          return n6 == null ? this.option.large ? 1e4 : this.get("progressive") : n6;
        }, a.prototype.getProgressiveThreshold = function() {
          var n6 = this.option.progressiveThreshold;
          return n6 == null ? this.option.large ? 2e4 : this.get("progressiveThreshold") : n6;
        }, a.prototype.getZLevelKey = function() {
          var n6 = this.getModel("effect"), f6 = n6.get("trailLength");
          return this.getData().count() > this.getProgressiveThreshold() ? this.id : n6.get("show") && f6 > 0 ? f6 + "" : "";
        }, a.type = "series.lines", a.dependencies = ["grid", "polar", "geo", "calendar"], a.defaultOption = { coordinateSystem: "geo", z: 2, legendHoverLink: true, xAxisIndex: 0, yAxisIndex: 0, symbol: ["none", "none"], symbolSize: [10, 10], geoIndex: 0, effect: { show: false, period: 4, constantSpeed: 0, symbol: "circle", symbolSize: 3, loop: true, trailLength: 0.2 }, large: false, largeThreshold: 2e3, polyline: false, clip: true, label: { show: false, position: "end" }, lineStyle: { opacity: 0.5 } }, a;
      }(Cp), ZHt = KHt;
      function Uoe(s) {
        return s instanceof Array || (s = [s, s]), s;
      }
      var JHt = { seriesType: "lines", reset: function(s) {
        var a = Uoe(s.get("symbol")), n6 = Uoe(s.get("symbolSize")), f6 = s.getData();
        f6.setVisual("fromSymbol", a && a[0]), f6.setVisual("toSymbol", a && a[1]), f6.setVisual("fromSymbolSize", n6 && n6[0]), f6.setVisual("toSymbolSize", n6 && n6[1]);
        function d4(y4, _) {
          var S = y4.getItemModel(_), T = Uoe(S.getShallow("symbol", true)), E = Uoe(S.getShallow("symbolSize", true));
          T[0] && y4.setItemVisual(_, "fromSymbol", T[0]), T[1] && y4.setItemVisual(_, "toSymbol", T[1]), E[0] && y4.setItemVisual(_, "fromSymbolSize", E[0]), E[1] && y4.setItemVisual(_, "toSymbolSize", E[1]);
        }
        return { dataEach: f6.hasItemOption ? d4 : null };
      } }, QHt = JHt;
      function eWt(s) {
        s.registerChartView($Ht), s.registerSeriesModel(ZHt), s.registerLayout(qXe), s.registerVisual(QHt);
      }
      var tWt = 256, nWt = function() {
        function s() {
          this.blurSize = 30, this.pointSize = 20, this.maxOpacity = 1, this.minOpacity = 0, this._gradientPixels = { inRange: null, outOfRange: null };
          var a = td.createCanvas();
          this.canvas = a;
        }
        return s.prototype.update = function(a, n6, f6, d4, y4, _) {
          var S = this._getBrush(), T = this._getGradient(y4, "inRange"), E = this._getGradient(y4, "outOfRange"), O = this.pointSize + this.blurSize, R = this.canvas, V = R.getContext("2d"), z3 = a.length;
          R.width = n6, R.height = f6;
          for (var H = 0; H < z3; ++H) {
            var Z = a[H], ee = Z[0], oe = Z[1], fe = Z[2], _e = d4(fe);
            V.globalAlpha = _e, V.drawImage(S, ee - O, oe - O);
          }
          if (!R.width || !R.height)
            return R;
          for (var pe = V.getImageData(0, 0, R.width, R.height), Ve = pe.data, Le = 0, je = Ve.length, Xe = this.minOpacity, Ye = this.maxOpacity, rt2 = Ye - Xe; Le < je; ) {
            var _e = Ve[Le + 3] / 256, ut = Math.floor(_e * (tWt - 1)) * 4;
            if (_e > 0) {
              var wt = _(_e) ? T : E;
              _e > 0 && (_e = _e * rt2 + Xe), Ve[Le++] = wt[ut], Ve[Le++] = wt[ut + 1], Ve[Le++] = wt[ut + 2], Ve[Le++] = wt[ut + 3] * _e * 256;
            } else
              Le += 4;
          }
          return V.putImageData(pe, 0, 0), R;
        }, s.prototype._getBrush = function() {
          var a = this._brushCanvas || (this._brushCanvas = td.createCanvas()), n6 = this.pointSize + this.blurSize, f6 = n6 * 2;
          a.width = f6, a.height = f6;
          var d4 = a.getContext("2d");
          return d4.clearRect(0, 0, f6, f6), d4.shadowOffsetX = f6, d4.shadowBlur = this.blurSize, d4.shadowColor = "#000", d4.beginPath(), d4.arc(-n6, n6, this.pointSize, 0, Math.PI * 2, true), d4.closePath(), d4.fill(), a;
        }, s.prototype._getGradient = function(a, n6) {
          for (var f6 = this._gradientPixels, d4 = f6[n6] || (f6[n6] = new Uint8ClampedArray(256 * 4)), y4 = [0, 0, 0, 0], _ = 0, S = 0; S < 256; S++)
            a[n6](S / 255, true, y4), d4[_++] = y4[0], d4[_++] = y4[1], d4[_++] = y4[2], d4[_++] = y4[3];
          return d4;
        }, s;
      }(), rWt = nWt;
      function iWt(s, a, n6) {
        var f6 = s[1] - s[0];
        a = Pi(a, function(_) {
          return { interval: [(_.interval[0] - s[0]) / f6, (_.interval[1] - s[0]) / f6] };
        });
        var d4 = a.length, y4 = 0;
        return function(_) {
          var S;
          for (S = y4; S < d4; S++) {
            var T = a[S].interval;
            if (T[0] <= _ && _ <= T[1]) {
              y4 = S;
              break;
            }
          }
          if (S === d4)
            for (S = y4 - 1; S >= 0; S--) {
              var T = a[S].interval;
              if (T[0] <= _ && _ <= T[1]) {
                y4 = S;
                break;
              }
            }
          return S >= 0 && S < d4 && n6[S];
        };
      }
      function aWt(s, a) {
        var n6 = s[1] - s[0];
        return a = [(a[0] - s[0]) / n6, (a[1] - s[0]) / n6], function(f6) {
          return f6 >= a[0] && f6 <= a[1];
        };
      }
      function XXe(s) {
        var a = s.dimensions;
        return a[0] === "lng" && a[1] === "lat";
      }
      var oWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4;
          f6.eachComponent("visualMap", function(S) {
            S.eachTargetSeries(function(T) {
              T === n6 && (y4 = S);
            });
          }), this._progressiveEls = null, this.group.removeAll();
          var _ = n6.coordinateSystem;
          _.type === "cartesian2d" || _.type === "calendar" ? this._renderOnCartesianAndCalendar(n6, d4, 0, n6.getData().count()) : XXe(_) && this._renderOnGeo(_, n6, y4, d4);
        }, a.prototype.incrementalPrepareRender = function(n6, f6, d4) {
          this.group.removeAll();
        }, a.prototype.incrementalRender = function(n6, f6, d4, y4) {
          var _ = f6.coordinateSystem;
          _ && (XXe(_) ? this.render(f6, d4, y4) : (this._progressiveEls = [], this._renderOnCartesianAndCalendar(f6, y4, n6.start, n6.end, true)));
        }, a.prototype.eachRendered = function(n6) {
          mC(this._progressiveEls || this.group, n6);
        }, a.prototype._renderOnCartesianAndCalendar = function(n6, f6, d4, y4, _) {
          var S = n6.coordinateSystem, T, E, O, R;
          if (RE(S, "cartesian2d")) {
            var V = S.getAxis("x"), z3 = S.getAxis("y");
            T = V.getBandWidth(), E = z3.getBandWidth(), O = V.scale.getExtent(), R = z3.scale.getExtent();
          }
          for (var H = this.group, Z = n6.getData(), ee = n6.getModel(["emphasis", "itemStyle"]).getItemStyle(), oe = n6.getModel(["blur", "itemStyle"]).getItemStyle(), fe = n6.getModel(["select", "itemStyle"]).getItemStyle(), _e = n6.get(["itemStyle", "borderRadius"]), pe = E0(n6), Ve = n6.getModel("emphasis"), Le = Ve.get("focus"), je = Ve.get("blurScope"), Xe = Ve.get("disabled"), Ye = RE(S, "cartesian2d") ? [Z.mapDimension("x"), Z.mapDimension("y"), Z.mapDimension("value")] : [Z.mapDimension("time"), Z.mapDimension("value")], rt2 = d4; rt2 < y4; rt2++) {
            var ut = void 0, wt = Z.getItemVisual(rt2, "style");
            if (RE(S, "cartesian2d")) {
              var dt = Z.get(Ye[0], rt2), Gt = Z.get(Ye[1], rt2);
              if (isNaN(Z.get(Ye[2], rt2)) || dt < O[0] || dt > O[1] || Gt < R[0] || Gt > R[1])
                continue;
              var Qt = S.dataToPoint([dt, Gt]);
              ut = new xu({ shape: { x: Math.floor(Math.round(Qt[0]) - T / 2), y: Math.floor(Math.round(Qt[1]) - E / 2), width: Math.ceil(T), height: Math.ceil(E) }, style: wt });
            } else {
              if (isNaN(Z.get(Ye[1], rt2)))
                continue;
              ut = new xu({ z2: 1, shape: S.dataToRect([Z.get(Ye[0], rt2)]).contentShape, style: wt });
            }
            if (Z.hasItemOption) {
              var Nt = Z.getItemModel(rt2), er = Nt.getModel("emphasis");
              ee = er.getModel("itemStyle").getItemStyle(), oe = Nt.getModel(["blur", "itemStyle"]).getItemStyle(), fe = Nt.getModel(["select", "itemStyle"]).getItemStyle(), _e = Nt.get(["itemStyle", "borderRadius"]), Le = er.get("focus"), je = er.get("blurScope"), Xe = er.get("disabled"), pe = E0(Nt);
            }
            ut.shape.r = _e;
            var un = n6.getRawValue(rt2), pn = "-";
            un && un[2] != null && (pn = un[2] + ""), Gm(ut, pe, { labelFetcher: n6, labelDataIndex: rt2, defaultOpacity: wt.opacity, defaultText: pn }), ut.ensureState("emphasis").style = ee, ut.ensureState("blur").style = oe, ut.ensureState("select").style = fe, Up(ut, Le, je, Xe), ut.incremental = _, _ && (ut.states.emphasis.hoverLayer = true), H.add(ut), Z.setItemGraphicEl(rt2, ut), this._progressiveEls && this._progressiveEls.push(ut);
          }
        }, a.prototype._renderOnGeo = function(n6, f6, d4, y4) {
          var _ = d4.targetVisuals.inRange, S = d4.targetVisuals.outOfRange, T = f6.getData(), E = this._hmLayer || this._hmLayer || new rWt();
          E.blurSize = f6.get("blurSize"), E.pointSize = f6.get("pointSize"), E.minOpacity = f6.get("minOpacity"), E.maxOpacity = f6.get("maxOpacity");
          var O = n6.getViewRect().clone(), R = n6.getRoamTransform();
          O.applyTransform(R);
          var V = Math.max(O.x, 0), z3 = Math.max(O.y, 0), H = Math.min(O.width + O.x, y4.getWidth()), Z = Math.min(O.height + O.y, y4.getHeight()), ee = H - V, oe = Z - z3, fe = [T.mapDimension("lng"), T.mapDimension("lat"), T.mapDimension("value")], _e = T.mapArray(fe, function(je, Xe, Ye) {
            var rt2 = n6.dataToPoint([je, Xe]);
            return rt2[0] -= V, rt2[1] -= z3, rt2.push(Ye), rt2;
          }), pe = d4.getExtent(), Ve = d4.type === "visualMap.continuous" ? aWt(pe, d4.option.range) : iWt(pe, d4.getPieceList(), d4.option.selected);
          E.update(_e, ee, oe, _.color.getNormalizer(), { inRange: _.color.getColorMapper(), outOfRange: S.color.getColorMapper() }, Ve);
          var Le = new Zv({ style: { width: ee, height: oe, x: V, y: z3, image: E.canvas }, silent: true });
          this.group.add(Le);
        }, a.type = "heatmap", a;
      }(Ch), sWt = oWt, lWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          return PE(null, this, { generateCoord: "value" });
        }, a.prototype.preventIncremental = function() {
          var n6 = f$.get(this.get("coordinateSystem"));
          if (n6 && n6.dimensions)
            return n6.dimensions[0] === "lng" && n6.dimensions[1] === "lat";
        }, a.type = "series.heatmap", a.dependencies = ["grid", "geo", "calendar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, geoIndex: 0, blurSize: 30, pointSize: 20, maxOpacity: 1, minOpacity: 0, select: { itemStyle: { borderColor: "#212121" } } }, a;
      }(Cp), uWt = lWt;
      function cWt(s) {
        s.registerChartView(sWt), s.registerSeriesModel(uWt);
      }
      var fWt = ["itemStyle", "borderWidth"], YXe = [{ xy: "x", wh: "width", index: 0, posDesc: ["left", "right"] }, { xy: "y", wh: "height", index: 1, posDesc: ["top", "bottom"] }], S2e = new cS(), hWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = this.group, _ = n6.getData(), S = this._data, T = n6.coordinateSystem, E = T.getBaseAxis(), O = E.isHorizontal(), R = T.master.getRect(), V = { ecSize: { width: d4.getWidth(), height: d4.getHeight() }, seriesModel: n6, coordSys: T, coordSysExtent: [[R.x, R.x + R.width], [R.y, R.y + R.height]], isHorizontal: O, valueDim: YXe[+O], categoryDim: YXe[1 - +O] };
          return _.diff(S).add(function(z3) {
            if (_.hasValue(z3)) {
              var H = nYe(_, z3), Z = KXe(_, z3, H, V), ee = rYe(_, V, Z);
              _.setItemGraphicEl(z3, ee), y4.add(ee), oYe(ee, V, Z);
            }
          }).update(function(z3, H) {
            var Z = S.getItemGraphicEl(H);
            if (!_.hasValue(z3)) {
              y4.remove(Z);
              return;
            }
            var ee = nYe(_, z3), oe = KXe(_, z3, ee, V), fe = aYe(_, oe);
            Z && fe !== Z.__pictorialShapeStr && (y4.remove(Z), _.setItemGraphicEl(z3, null), Z = null), Z ? bWt(Z, V, oe) : Z = rYe(_, V, oe, true), _.setItemGraphicEl(z3, Z), Z.__pictorialSymbolMeta = oe, y4.add(Z), oYe(Z, V, oe);
          }).remove(function(z3) {
            var H = S.getItemGraphicEl(z3);
            H && iYe(S, z3, H.__pictorialSymbolMeta.animationModel, H);
          }).execute(), this._data = _, this.group;
        }, a.prototype.remove = function(n6, f6) {
          var d4 = this.group, y4 = this._data;
          n6.get("animation") ? y4 && y4.eachItemGraphicEl(function(_) {
            iYe(y4, qo(_).dataIndex, n6, _);
          }) : d4.removeAll();
        }, a.type = "pictorialBar", a;
      }(Ch);
      function KXe(s, a, n6, f6) {
        var d4 = s.getItemLayout(a), y4 = n6.get("symbolRepeat"), _ = n6.get("symbolClip"), S = n6.get("symbolPosition") || "start", T = n6.get("symbolRotate"), E = (T || 0) * Math.PI / 180 || 0, O = n6.get("symbolPatternSize") || 2, R = n6.isAnimationEnabled(), V = { dataIndex: a, layout: d4, itemModel: n6, symbolType: s.getItemVisual(a, "symbol") || "circle", style: s.getItemVisual(a, "style"), symbolClip: _, symbolRepeat: y4, symbolRepeatDirection: n6.get("symbolRepeatDirection"), symbolPatternSize: O, rotation: E, animationModel: R ? n6 : null, hoverScale: R && n6.get(["emphasis", "scale"]), z2: n6.getShallow("z", true) || 0 };
        pWt(n6, y4, d4, f6, V), dWt(s, a, d4, y4, _, V.boundingLength, V.pxSign, O, f6, V), vWt(n6, V.symbolScale, E, f6, V);
        var z3 = V.symbolSize, H = B7(n6.get("symbolOffset"), z3);
        return gWt(n6, z3, d4, y4, _, H, S, V.valueLineWidth, V.boundingLength, V.repeatCutLength, f6, V), V;
      }
      function pWt(s, a, n6, f6, d4) {
        var y4 = f6.valueDim, _ = s.get("symbolBoundingData"), S = f6.coordSys.getOtherAxis(f6.coordSys.getBaseAxis()), T = S.toGlobalCoord(S.dataToCoord(0)), E = 1 - +(n6[y4.wh] <= 0), O;
        if (Di(_)) {
          var R = [C2e(S, _[0]) - T, C2e(S, _[1]) - T];
          R[1] < R[0] && R.reverse(), O = R[E];
        } else
          _ != null ? O = C2e(S, _) - T : a ? O = f6.coordSysExtent[y4.index][E] - T : O = n6[y4.wh];
        d4.boundingLength = O, a && (d4.repeatCutLength = n6[y4.wh]), d4.pxSign = O > 0 ? 1 : -1;
      }
      function C2e(s, a) {
        return s.toGlobalCoord(s.dataToCoord(s.scale.parse(a)));
      }
      function dWt(s, a, n6, f6, d4, y4, _, S, T, E) {
        var O = T.valueDim, R = T.categoryDim, V = Math.abs(n6[R.wh]), z3 = s.getItemVisual(a, "symbolSize"), H;
        Di(z3) ? H = z3.slice() : z3 == null ? H = ["100%", "100%"] : H = [z3, z3], H[R.index] = Ia(H[R.index], V), H[O.index] = Ia(H[O.index], f6 ? V : Math.abs(y4)), E.symbolSize = H;
        var Z = E.symbolScale = [H[0] / S, H[1] / S];
        Z[O.index] *= (T.isHorizontal ? -1 : 1) * _;
      }
      function vWt(s, a, n6, f6, d4) {
        var y4 = s.get(fWt) || 0;
        y4 && (S2e.attr({ scaleX: a[0], scaleY: a[1], rotation: n6 }), S2e.updateTransform(), y4 /= S2e.getLineScale(), y4 *= a[f6.valueDim.index]), d4.valueLineWidth = y4 || 0;
      }
      function gWt(s, a, n6, f6, d4, y4, _, S, T, E, O, R) {
        var V = O.categoryDim, z3 = O.valueDim, H = R.pxSign, Z = Math.max(a[z3.index] + S, 0), ee = Z;
        if (f6) {
          var oe = Math.abs(T), fe = $v(s.get("symbolMargin"), "15%") + "", _e = false;
          fe.lastIndexOf("!") === fe.length - 1 && (_e = true, fe = fe.slice(0, fe.length - 1));
          var pe = Ia(fe, a[z3.index]), Ve = Math.max(Z + pe * 2, 0), Le = _e ? 0 : pe * 2, je = fie(f6), Xe = je ? f6 : sYe((oe + Le) / Ve), Ye = oe - Xe * Z;
          pe = Ye / 2 / (_e ? Xe : Math.max(Xe - 1, 1)), Ve = Z + pe * 2, Le = _e ? 0 : pe * 2, !je && f6 !== "fixed" && (Xe = E ? sYe((Math.abs(E) + Le) / Ve) : 0), ee = Xe * Ve - Le, R.repeatTimes = Xe, R.symbolMargin = pe;
        }
        var rt2 = H * (ee / 2), ut = R.pathPosition = [];
        ut[V.index] = n6[V.wh] / 2, ut[z3.index] = _ === "start" ? rt2 : _ === "end" ? T - rt2 : T / 2, y4 && (ut[0] += y4[0], ut[1] += y4[1]);
        var wt = R.bundlePosition = [];
        wt[V.index] = n6[V.xy], wt[z3.index] = n6[z3.xy];
        var dt = R.barRectShape = ei({}, n6);
        dt[z3.wh] = H * Math.max(Math.abs(n6[z3.wh]), Math.abs(ut[z3.index] + rt2)), dt[V.wh] = n6[V.wh];
        var Gt = R.clipShape = {};
        Gt[V.xy] = -n6[V.xy], Gt[V.wh] = O.ecSize[V.wh], Gt[z3.xy] = 0, Gt[z3.wh] = n6[z3.wh];
      }
      function ZXe(s) {
        var a = s.symbolPatternSize, n6 = bv(s.symbolType, -a / 2, -a / 2, a, a);
        return n6.attr({ culling: true }), n6.type !== "image" && n6.setStyle({ strokeNoScale: true }), n6;
      }
      function JXe(s, a, n6, f6) {
        var d4 = s.__pictorialBundle, y4 = n6.symbolSize, _ = n6.valueLineWidth, S = n6.pathPosition, T = a.valueDim, E = n6.repeatTimes || 0, O = 0, R = y4[a.valueDim.index] + _ + n6.symbolMargin * 2;
        for (M2e(s, function(Z) {
          Z.__pictorialAnimationIndex = O, Z.__pictorialRepeatTimes = E, O < E ? tV(Z, null, H(O), n6, f6) : tV(Z, null, { scaleX: 0, scaleY: 0 }, n6, f6, function() {
            d4.remove(Z);
          }), O++;
        }); O < E; O++) {
          var V = ZXe(n6);
          V.__pictorialAnimationIndex = O, V.__pictorialRepeatTimes = E, d4.add(V);
          var z3 = H(O);
          tV(V, { x: z3.x, y: z3.y, scaleX: 0, scaleY: 0 }, { scaleX: z3.scaleX, scaleY: z3.scaleY, rotation: z3.rotation }, n6, f6);
        }
        function H(Z) {
          var ee = S.slice(), oe = n6.pxSign, fe = Z;
          return (n6.symbolRepeatDirection === "start" ? oe > 0 : oe < 0) && (fe = E - 1 - Z), ee[T.index] = R * (fe - E / 2 + 0.5) + S[T.index], { x: ee[0], y: ee[1], scaleX: n6.symbolScale[0], scaleY: n6.symbolScale[1], rotation: n6.rotation };
        }
      }
      function QXe(s, a, n6, f6) {
        var d4 = s.__pictorialBundle, y4 = s.__pictorialMainPath;
        y4 ? tV(y4, null, { x: n6.pathPosition[0], y: n6.pathPosition[1], scaleX: n6.symbolScale[0], scaleY: n6.symbolScale[1], rotation: n6.rotation }, n6, f6) : (y4 = s.__pictorialMainPath = ZXe(n6), d4.add(y4), tV(y4, { x: n6.pathPosition[0], y: n6.pathPosition[1], scaleX: 0, scaleY: 0, rotation: n6.rotation }, { scaleX: n6.symbolScale[0], scaleY: n6.symbolScale[1] }, n6, f6));
      }
      function eYe(s, a, n6) {
        var f6 = ei({}, a.barRectShape), d4 = s.__pictorialBarRect;
        d4 ? tV(d4, null, { shape: f6 }, a, n6) : (d4 = s.__pictorialBarRect = new xu({ z2: 2, shape: f6, silent: true, style: { stroke: "transparent", fill: "transparent", lineWidth: 0 } }), d4.disableMorphing = true, s.add(d4));
      }
      function tYe(s, a, n6, f6) {
        if (n6.symbolClip) {
          var d4 = s.__pictorialClipPath, y4 = ei({}, n6.clipShape), _ = a.valueDim, S = n6.animationModel, T = n6.dataIndex;
          if (d4)
            ku(d4, { shape: y4 }, S, T);
          else {
            y4[_.wh] = 0, d4 = new xu({ shape: y4 }), s.__pictorialBundle.setClipPath(d4), s.__pictorialClipPath = d4;
            var E = {};
            E[_.wh] = n6.clipShape[_.wh], i$[f6 ? "updateProps" : "initProps"](d4, { shape: E }, S, T);
          }
        }
      }
      function nYe(s, a) {
        var n6 = s.getItemModel(a);
        return n6.getAnimationDelayParams = yWt, n6.isAnimationEnabled = mWt, n6;
      }
      function yWt(s) {
        return { index: s.__pictorialAnimationIndex, count: s.__pictorialRepeatTimes };
      }
      function mWt() {
        return this.parentModel.isAnimationEnabled() && !!this.getShallow("animation");
      }
      function rYe(s, a, n6, f6) {
        var d4 = new fs(), y4 = new fs();
        return d4.add(y4), d4.__pictorialBundle = y4, y4.x = n6.bundlePosition[0], y4.y = n6.bundlePosition[1], n6.symbolRepeat ? JXe(d4, a, n6) : QXe(d4, a, n6), eYe(d4, n6, f6), tYe(d4, a, n6, f6), d4.__pictorialShapeStr = aYe(s, n6), d4.__pictorialSymbolMeta = n6, d4;
      }
      function bWt(s, a, n6) {
        var f6 = n6.animationModel, d4 = n6.dataIndex, y4 = s.__pictorialBundle;
        ku(y4, { x: n6.bundlePosition[0], y: n6.bundlePosition[1] }, f6, d4), n6.symbolRepeat ? JXe(s, a, n6, true) : QXe(s, a, n6, true), eYe(s, n6, true), tYe(s, a, n6, true);
      }
      function iYe(s, a, n6, f6) {
        var d4 = f6.__pictorialBarRect;
        d4 && d4.removeTextContent();
        var y4 = [];
        M2e(f6, function(_) {
          y4.push(_);
        }), f6.__pictorialMainPath && y4.push(f6.__pictorialMainPath), f6.__pictorialClipPath && (n6 = null), gt(y4, function(_) {
          kT(_, { scaleX: 0, scaleY: 0 }, n6, a, function() {
            f6.parent && f6.parent.remove(f6);
          });
        }), s.setItemGraphicEl(a, null);
      }
      function aYe(s, a) {
        return [s.getItemVisual(a.dataIndex, "symbol") || "none", !!a.symbolRepeat, !!a.symbolClip].join(":");
      }
      function M2e(s, a, n6) {
        gt(s.__pictorialBundle.children(), function(f6) {
          f6 !== s.__pictorialBarRect && a.call(n6, f6);
        });
      }
      function tV(s, a, n6, f6, d4, y4) {
        a && s.attr(a), f6.symbolClip && !d4 ? n6 && s.attr(n6) : n6 && i$[d4 ? "updateProps" : "initProps"](s, n6, f6.animationModel, f6.dataIndex, y4);
      }
      function oYe(s, a, n6) {
        var f6 = n6.dataIndex, d4 = n6.itemModel, y4 = d4.getModel("emphasis"), _ = y4.getModel("itemStyle").getItemStyle(), S = d4.getModel(["blur", "itemStyle"]).getItemStyle(), T = d4.getModel(["select", "itemStyle"]).getItemStyle(), E = d4.getShallow("cursor"), O = y4.get("focus"), R = y4.get("blurScope"), V = y4.get("scale");
        M2e(s, function(Z) {
          if (Z instanceof Zv) {
            var ee = Z.style;
            Z.useStyle(ei({ image: ee.image, x: ee.x, y: ee.y, width: ee.width, height: ee.height }, n6.style));
          } else
            Z.useStyle(n6.style);
          var oe = Z.ensureState("emphasis");
          oe.style = _, V && (oe.scaleX = Z.scaleX * 1.1, oe.scaleY = Z.scaleY * 1.1), Z.ensureState("blur").style = S, Z.ensureState("select").style = T, E && (Z.cursor = E), Z.z2 = n6.z2;
        });
        var z3 = a.valueDim.posDesc[+(n6.boundingLength > 0)], H = s.__pictorialBarRect;
        Gm(H, E0(d4), { labelFetcher: a.seriesModel, labelDataIndex: f6, defaultText: U7(a.seriesModel.getData(), f6), inheritColor: n6.style.fill, defaultOpacity: n6.style.opacity, defaultOutsidePosition: z3 }), Up(s, O, R, y4.get("disabled"));
      }
      function sYe(s) {
        var a = Math.round(s);
        return Math.abs(s - a) < 1e-4 ? a : Math.ceil(s);
      }
      var _Wt = hWt, xWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.hasSymbolVisual = true, n6.defaultSymbol = "roundRect", n6;
        }
        return a.prototype.getInitialData = function(n6) {
          return n6.stack = null, s.prototype.getInitialData.apply(this, arguments);
        }, a.type = "series.pictorialBar", a.dependencies = ["grid"], a.defaultOption = Xk(_oe.defaultOption, { symbol: "circle", symbolSize: null, symbolRotate: null, symbolPosition: null, symbolOffset: null, symbolMargin: null, symbolRepeat: false, symbolRepeatDirection: "end", symbolClip: false, symbolBoundingData: null, symbolPatternSize: 400, barGap: "-100%", progressive: 0, emphasis: { scale: false }, select: { itemStyle: { borderColor: "#212121" } } }), a;
      }(_oe), wWt = xWt;
      function SWt(s) {
        s.registerChartView(_Wt), s.registerSeriesModel(wWt), s.registerLayout(s.PRIORITY.VISUAL.LAYOUT, ks(bWe, "pictorialBar")), s.registerLayout(s.PRIORITY.VISUAL.PROGRESSIVE_LAYOUT, _We("pictorialBar"));
      }
      var CWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._layers = [], n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = n6.getData(), _ = this, S = this.group, T = n6.getLayerSeries(), E = y4.getLayout("layoutInfo"), O = E.rect, R = E.boundaryGap;
          S.x = 0, S.y = O.y + R[0];
          function V(ee) {
            return ee.name;
          }
          var z3 = new OE(this._layersSeries || [], T, V, V), H = [];
          z3.add(Za(Z, this, "add")).update(Za(Z, this, "update")).remove(Za(Z, this, "remove")).execute();
          function Z(ee, oe, fe) {
            var _e = _._layers;
            if (ee === "remove") {
              S.remove(_e[oe]);
              return;
            }
            for (var pe = [], Ve = [], Le, je = T[oe].indices, Xe = 0; Xe < je.length; Xe++) {
              var Ye = y4.getItemLayout(je[Xe]), rt2 = Ye.x, ut = Ye.y0, wt = Ye.y;
              pe.push(rt2, ut), Ve.push(rt2, ut + wt), Le = y4.getItemVisual(je[Xe], "style");
            }
            var dt, Gt = y4.getItemLayout(je[0]), Qt = n6.getModel("label"), Nt = Qt.get("margin"), er = n6.getModel("emphasis");
            if (ee === "add") {
              var un = H[oe] = new fs();
              dt = new PUe({ shape: { points: pe, stackedOnPoints: Ve, smooth: 0.4, stackedOnSmooth: 0.4, smoothConstraint: false }, z2: 0 }), un.add(dt), S.add(un), n6.isAnimationEnabled() && dt.setClipPath(MWt(dt.getBoundingRect(), n6, function() {
                dt.removeClipPath();
              }));
            } else {
              var un = _e[fe];
              dt = un.childAt(0), S.add(un), H[oe] = un, ku(dt, { shape: { points: pe, stackedOnPoints: Ve } }, n6), ox(dt);
            }
            Gm(dt, E0(n6), { labelDataIndex: je[Xe - 1], defaultText: y4.getName(je[Xe - 1]), inheritColor: Le.fill }, { normal: { verticalAlign: "middle" } }), dt.setTextConfig({ position: null, local: true });
            var pn = dt.getTextContent();
            pn && (pn.x = Gt.x - Nt, pn.y = Gt.y0 + Gt.y / 2), dt.useStyle(Le), y4.setItemGraphicEl(oe, dt), Pg(dt, n6), Up(dt, er.get("focus"), er.get("blurScope"), er.get("disabled"));
          }
          this._layersSeries = T, this._layers = H;
        }, a.type = "themeRiver", a;
      }(Ch);
      function MWt(s, a, n6) {
        var f6 = new xu({ shape: { x: s.x - 10, y: s.y - 10, width: 0, height: s.height + 20 } });
        return $h(f6, { shape: { x: s.x - 50, width: s.width + 100, height: s.height + 20 } }, a, n6), f6;
      }
      var TWt = CWt, T2e = 2, AWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6) {
          s.prototype.init.apply(this, arguments), this.legendVisualProvider = new q$(Za(this.getData, this), Za(this.getRawData, this));
        }, a.prototype.fixData = function(n6) {
          var f6 = n6.length, d4 = {}, y4 = q9(n6, function(V) {
            return d4.hasOwnProperty(V[0] + "") || (d4[V[0] + ""] = -1), V[2];
          }), _ = [];
          y4.buckets.each(function(V, z3) {
            _.push({ name: z3, dataList: V });
          });
          for (var S = _.length, T = 0; T < S; ++T) {
            for (var E = _[T].name, O = 0; O < _[T].dataList.length; ++O) {
              var R = _[T].dataList[O][0] + "";
              d4[R] = T;
            }
            for (var R in d4)
              d4.hasOwnProperty(R) && d4[R] !== T && (d4[R] = T, n6[f6] = [R, 0, E], f6++);
          }
          return n6;
        }, a.prototype.getInitialData = function(n6, f6) {
          for (var d4 = this.getReferringComponents("singleAxis", ad).models[0], y4 = d4.get("type"), _ = tf(n6.data, function(H) {
            return H[2] !== void 0;
          }), S = this.fixData(_ || []), T = [], E = this.nameMap = ro(), O = 0, R = 0; R < S.length; ++R)
            T.push(S[R][T2e]), E.get(S[R][T2e]) || (E.set(S[R][T2e], O), O++);
          var V = O$(S, { coordDimensions: ["single"], dimensionsDefine: [{ name: "time", type: Qae(y4) }, { name: "value", type: "float" }, { name: "name", type: "ordinal" }], encodeDefine: { single: 0, value: 1, itemName: 2 } }).dimensions, z3 = new K1(V, this);
          return z3.initData(S), z3;
        }, a.prototype.getLayerSeries = function() {
          for (var n6 = this.getData(), f6 = n6.count(), d4 = [], y4 = 0; y4 < f6; ++y4)
            d4[y4] = y4;
          var _ = n6.mapDimension("single"), S = q9(d4, function(E) {
            return n6.get("name", E);
          }), T = [];
          return S.buckets.each(function(E, O) {
            E.sort(function(R, V) {
              return n6.get(_, R) - n6.get(_, V);
            }), T.push({ name: O, indices: E });
          }), T;
        }, a.prototype.getAxisTooltipData = function(n6, f6, d4) {
          Di(n6) || (n6 = n6 ? [n6] : []);
          for (var y4 = this.getData(), _ = this.getLayerSeries(), S = [], T = _.length, E, O = 0; O < T; ++O) {
            for (var R = Number.MAX_VALUE, V = -1, z3 = _[O].indices.length, H = 0; H < z3; ++H) {
              var Z = y4.get(n6[0], _[O].indices[H]), ee = Math.abs(Z - f6);
              ee <= R && (E = Z, R = ee, V = _[O].indices[H]);
            }
            S.push(V);
          }
          return { dataIndices: S, nestestValue: E };
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          var y4 = this.getData(), _ = y4.getName(n6), S = y4.get(y4.mapDimension("value"), n6);
          return Rg("nameValue", { name: _, value: S });
        }, a.type = "series.themeRiver", a.dependencies = ["singleAxis"], a.defaultOption = { z: 2, colorBy: "data", coordinateSystem: "singleAxis", boundaryGap: ["10%", "10%"], singleAxisIndex: 0, animationEasing: "linear", label: { margin: 4, show: true, position: "left", fontSize: 11 }, emphasis: { label: { show: true } } }, a;
      }(Cp), IWt = AWt;
      function EWt(s, a) {
        s.eachSeriesByType("themeRiver", function(n6) {
          var f6 = n6.getData(), d4 = n6.coordinateSystem, y4 = {}, _ = d4.getRect();
          y4.rect = _;
          var S = n6.get("boundaryGap"), T = d4.getAxis();
          if (y4.boundaryGap = S, T.orient === "horizontal") {
            S[0] = Ia(S[0], _.height), S[1] = Ia(S[1], _.height);
            var E = _.height - S[0] - S[1];
            lYe(f6, n6, E);
          } else {
            S[0] = Ia(S[0], _.width), S[1] = Ia(S[1], _.width);
            var O = _.width - S[0] - S[1];
            lYe(f6, n6, O);
          }
          f6.setLayout("layoutInfo", y4);
        });
      }
      function lYe(s, a, n6) {
        if (s.count())
          for (var f6 = a.coordinateSystem, d4 = a.getLayerSeries(), y4 = s.mapDimension("single"), _ = s.mapDimension("value"), S = Pi(d4, function(ee) {
            return Pi(ee.indices, function(oe) {
              var fe = f6.dataToPoint(s.get(y4, oe));
              return fe[1] = s.get(_, oe), fe;
            });
          }), T = DWt(S), E = T.y0, O = n6 / T.max, R = d4.length, V = d4[0].indices.length, z3, H = 0; H < V; ++H) {
            z3 = E[H] * O, s.setItemLayout(d4[0].indices[H], { layerIndex: 0, x: S[0][H][0], y0: z3, y: S[0][H][1] * O });
            for (var Z = 1; Z < R; ++Z)
              z3 += S[Z - 1][H][1] * O, s.setItemLayout(d4[Z].indices[H], { layerIndex: Z, x: S[Z][H][0], y0: z3, y: S[Z][H][1] * O });
          }
      }
      function DWt(s) {
        for (var a = s.length, n6 = s[0].length, f6 = [], d4 = [], y4 = 0, _ = 0; _ < n6; ++_) {
          for (var S = 0, T = 0; T < a; ++T)
            S += s[T][_][1];
          S > y4 && (y4 = S), f6.push(S);
        }
        for (var E = 0; E < n6; ++E)
          d4[E] = (y4 - f6[E]) / 2;
        y4 = 0;
        for (var O = 0; O < n6; ++O) {
          var R = f6[O] + d4[O];
          R > y4 && (y4 = R);
        }
        return { y0: d4, max: y4 };
      }
      function kWt(s) {
        s.registerChartView(TWt), s.registerSeriesModel(IWt), s.registerLayout(EWt), s.registerProcessor(U$("themeRiver"));
      }
      var OWt = 2, PWt = 4, LWt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4) {
          var _ = s.call(this) || this;
          _.z2 = OWt, _.textConfig = { inside: true }, qo(_).seriesIndex = f6.seriesIndex;
          var S = new ju({ z2: PWt, silent: n6.getModel().get(["label", "silent"]) });
          return _.setTextContent(S), _.updateData(true, n6, f6, d4, y4), _;
        }
        return a.prototype.updateData = function(n6, f6, d4, y4, _) {
          this.node = f6, f6.piece = this, d4 = d4 || this._seriesModel, y4 = y4 || this._ecModel;
          var S = this;
          qo(S).dataIndex = f6.dataIndex;
          var T = f6.getModel(), E = T.getModel("emphasis"), O = f6.getLayout(), R = ei({}, O);
          R.label = null;
          var V = f6.getVisual("style");
          V.lineJoin = "bevel";
          var z3 = f6.getVisual("decal");
          z3 && (V.decal = S$(z3, _));
          var H = q7(T.getModel("itemStyle"), R, true);
          ei(R, H), gt(od, function(fe) {
            var _e = S.ensureState(fe), pe = T.getModel([fe, "itemStyle"]);
            _e.style = pe.getItemStyle();
            var Ve = q7(pe, R);
            Ve && (_e.shape = Ve);
          }), n6 ? (S.setShape(R), S.shape.r = O.r0, ku(S, { shape: { r: O.r } }, d4, f6.dataIndex)) : (ku(S, { shape: R }, d4), ox(S)), S.useStyle(V), this._updateLabel(d4);
          var Z = T.getShallow("cursor");
          Z && S.attr("cursor", Z), this._seriesModel = d4 || this._seriesModel, this._ecModel = y4 || this._ecModel;
          var ee = E.get("focus"), oe = ee === "ancestor" ? f6.getAncestorsIndices() : ee === "descendant" ? f6.getDescendantIndices() : ee;
          Up(this, oe, E.get("blurScope"), E.get("disabled"));
        }, a.prototype._updateLabel = function(n6) {
          var f6 = this, d4 = this.node.getModel(), y4 = d4.getModel("label"), _ = this.node.getLayout(), S = _.endAngle - _.startAngle, T = (_.startAngle + _.endAngle) / 2, E = Math.cos(T), O = Math.sin(T), R = this, V = R.getTextContent(), z3 = this.node.dataIndex, H = y4.get("minAngle") / 180 * Math.PI, Z = y4.get("show") && !(H != null && Math.abs(S) < H);
          V.ignore = !Z, gt(SR, function(oe) {
            var fe = oe === "normal" ? d4.getModel("label") : d4.getModel([oe, "label"]), _e = oe === "normal", pe = _e ? V : V.ensureState(oe), Ve = n6.getFormattedLabel(z3, oe);
            _e && (Ve = Ve || f6.node.name), pe.style = Zd(fe, {}, null, oe !== "normal", true), Ve && (pe.style.text = Ve);
            var Le = fe.get("show");
            Le != null && !_e && (pe.ignore = !Le);
            var je = ee(fe, "position"), Xe = _e ? R : R.states[oe], Ye = Xe.style.fill;
            Xe.textConfig = { outsideFill: fe.get("color") === "inherit" ? Ye : null, inside: je !== "outside" };
            var rt2, ut = ee(fe, "distance") || 0, wt = ee(fe, "align");
            je === "outside" ? (rt2 = _.r + ut, wt = T > Math.PI / 2 ? "right" : "left") : !wt || wt === "center" ? (S === 2 * Math.PI && _.r0 === 0 ? rt2 = 0 : rt2 = (_.r + _.r0) / 2, wt = "center") : wt === "left" ? (rt2 = _.r0 + ut, T > Math.PI / 2 && (wt = "right")) : wt === "right" && (rt2 = _.r - ut, T > Math.PI / 2 && (wt = "left")), pe.style.align = wt, pe.style.verticalAlign = ee(fe, "verticalAlign") || "middle", pe.x = rt2 * E + _.cx, pe.y = rt2 * O + _.cy;
            var dt = ee(fe, "rotate"), Gt = 0;
            dt === "radial" ? (Gt = -T, Gt < -Math.PI / 2 && (Gt += Math.PI)) : dt === "tangential" ? (Gt = Math.PI / 2 - T, Gt > Math.PI / 2 ? Gt -= Math.PI : Gt < -Math.PI / 2 && (Gt += Math.PI)) : ac(dt) && (Gt = dt * Math.PI / 180), pe.rotation = Gt;
          });
          function ee(oe, fe) {
            var _e = oe.get(fe);
            return _e == null ? y4.get(fe) : _e;
          }
          V.dirtyStyle();
        }, a;
      }(Bm), uYe = LWt, A2e = "sunburstRootToNode", cYe = "sunburstHighlight", RWt = "sunburstUnhighlight";
      function NWt(s) {
        s.registerAction({ type: A2e, update: "updateView" }, function(a, n6) {
          n6.eachComponent({ mainType: "series", subType: "sunburst", query: a }, f6);
          function f6(d4, y4) {
            var _ = Q$(a, [A2e], d4);
            if (_) {
              var S = d4.getViewRoot();
              S && (a.direction = kSe(S, _.node) ? "rollUp" : "drillDown"), d4.resetViewRoot(_.node);
            }
          }
        }), s.registerAction({ type: cYe, update: "none" }, function(a, n6, f6) {
          a = ei({}, a), n6.eachComponent({ mainType: "series", subType: "sunburst", query: a }, d4);
          function d4(y4) {
            var _ = Q$(a, [cYe], y4);
            _ && (a.dataIndex = _.node.dataIndex);
          }
          f6.dispatchAction(ei(a, { type: "highlight" }));
        }), s.registerAction({ type: RWt, update: "updateView" }, function(a, n6, f6) {
          a = ei({}, a), f6.dispatchAction(ei(a, { type: "downplay" }));
        });
      }
      var FWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          var _ = this;
          this.seriesModel = n6, this.api = d4, this.ecModel = f6;
          var S = n6.getData(), T = S.tree.root, E = n6.getViewRoot(), O = this.group, R = n6.get("renderLabelForZeroData"), V = [];
          E.eachNode(function(fe) {
            V.push(fe);
          });
          var z3 = this._oldChildren || [];
          H(V, z3), oe(T, E), this._initEvents(), this._oldChildren = V;
          function H(fe, _e) {
            if (fe.length === 0 && _e.length === 0)
              return;
            new OE(_e, fe, pe, pe).add(Ve).update(Ve).remove(ks(Ve, null)).execute();
            function pe(Le) {
              return Le.getId();
            }
            function Ve(Le, je) {
              var Xe = Le == null ? null : fe[Le], Ye = je == null ? null : _e[je];
              Z(Xe, Ye);
            }
          }
          function Z(fe, _e) {
            if (!R && fe && !fe.getValue() && (fe = null), fe !== T && _e !== T) {
              if (_e && _e.piece)
                fe ? (_e.piece.updateData(false, fe, n6, f6, d4), S.setItemGraphicEl(fe.dataIndex, _e.piece)) : ee(_e);
              else if (fe) {
                var pe = new uYe(fe, n6, f6, d4);
                O.add(pe), S.setItemGraphicEl(fe.dataIndex, pe);
              }
            }
          }
          function ee(fe) {
            !fe || fe.piece && (O.remove(fe.piece), fe.piece = null);
          }
          function oe(fe, _e) {
            _e.depth > 0 ? (_.virtualPiece ? _.virtualPiece.updateData(false, fe, n6, f6, d4) : (_.virtualPiece = new uYe(fe, n6, f6, d4), O.add(_.virtualPiece)), _e.piece.off("click"), _.virtualPiece.on("click", function(pe) {
              _._rootToNode(_e.parentNode);
            })) : _.virtualPiece && (O.remove(_.virtualPiece), _.virtualPiece = null);
          }
        }, a.prototype._initEvents = function() {
          var n6 = this;
          this.group.off("click"), this.group.on("click", function(f6) {
            var d4 = false, y4 = n6.seriesModel.getViewRoot();
            y4.eachNode(function(_) {
              if (!d4 && _.piece && _.piece === f6.target) {
                var S = _.getModel().get("nodeClick");
                if (S === "rootToNode")
                  n6._rootToNode(_);
                else if (S === "link") {
                  var T = _.getModel(), E = T.get("link");
                  if (E) {
                    var O = T.get("target", true) || "_blank";
                    Dae(E, O);
                  }
                }
                d4 = true;
              }
            });
          });
        }, a.prototype._rootToNode = function(n6) {
          n6 !== this.seriesModel.getViewRoot() && this.api.dispatchAction({ type: A2e, from: this.uid, seriesId: this.seriesModel.id, targetNode: n6 });
        }, a.prototype.containPoint = function(n6, f6) {
          var d4 = f6.getData(), y4 = d4.getItemLayout(0);
          if (y4) {
            var _ = n6[0] - y4.cx, S = n6[1] - y4.cy, T = Math.sqrt(_ * _ + S * S);
            return T <= y4.r && T >= y4.r0;
          }
        }, a.type = "sunburst", a;
      }(Ch), VWt = FWt, BWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.ignoreStyleOnData = true, n6;
        }
        return a.prototype.getInitialData = function(n6, f6) {
          var d4 = { name: n6.name, children: n6.data };
          fYe(d4);
          var y4 = this._levelModels = Pi(n6.levels || [], function(T) {
            return new Sh(T, this, f6);
          }, this), _ = DSe.createTree(d4, this, S);
          function S(T) {
            T.wrapMethod("getItemModel", function(E, O) {
              var R = _.getNodeByDataIndex(O), V = y4[R.depth];
              return V && (E.parentModel = V), E;
            });
          }
          return _.data;
        }, a.prototype.optionUpdated = function() {
          this.resetViewRoot();
        }, a.prototype.getDataParams = function(n6) {
          var f6 = s.prototype.getDataParams.apply(this, arguments), d4 = this.getData().tree.getNodeByDataIndex(n6);
          return f6.treePathInfo = Poe(d4, this), f6;
        }, a.prototype.getLevelModel = function(n6) {
          return this._levelModels && this._levelModels[n6.depth];
        }, a.prototype.getViewRoot = function() {
          return this._viewRoot;
        }, a.prototype.resetViewRoot = function(n6) {
          n6 ? this._viewRoot = n6 : n6 = this._viewRoot;
          var f6 = this.getRawData().tree.root;
          (!n6 || n6 !== f6 && !f6.contains(n6)) && (this._viewRoot = f6);
        }, a.prototype.enableAriaDecal = function() {
          b$e(this);
        }, a.type = "series.sunburst", a.defaultOption = { z: 2, center: ["50%", "50%"], radius: [0, "75%"], clockwise: true, startAngle: 90, minAngle: 0, stillShowZeroSum: true, nodeClick: "rootToNode", renderLabelForZeroData: false, label: { rotate: "radial", show: true, opacity: 1, align: "center", position: "inside", distance: 5, silent: true }, itemStyle: { borderWidth: 1, borderColor: "white", borderType: "solid", shadowBlur: 0, shadowColor: "rgba(0, 0, 0, 0.2)", shadowOffsetX: 0, shadowOffsetY: 0, opacity: 1 }, emphasis: { focus: "descendant" }, blur: { itemStyle: { opacity: 0.2 }, label: { opacity: 0.1 } }, animationType: "expansion", animationDuration: 1e3, animationDurationUpdate: 500, data: [], sort: "desc" }, a;
      }(Cp);
      function fYe(s) {
        var a = 0;
        gt(s.children, function(f6) {
          fYe(f6);
          var d4 = f6.value;
          Di(d4) && (d4 = d4[0]), a += d4;
        });
        var n6 = s.value;
        Di(n6) && (n6 = n6[0]), (n6 == null || isNaN(n6)) && (n6 = a), n6 < 0 && (n6 = 0), Di(s.value) ? s.value[0] = n6 : s.value = n6;
      }
      var zWt = BWt, hYe = Math.PI / 180;
      function jWt(s, a, n6) {
        a.eachSeriesByType(s, function(f6) {
          var d4 = f6.get("center"), y4 = f6.get("radius");
          Di(y4) || (y4 = [0, y4]), Di(d4) || (d4 = [d4, d4]);
          var _ = n6.getWidth(), S = n6.getHeight(), T = Math.min(_, S), E = Ia(d4[0], _), O = Ia(d4[1], S), R = Ia(y4[0], T / 2), V = Ia(y4[1], T / 2), z3 = -f6.get("startAngle") * hYe, H = f6.get("minAngle") * hYe, Z = f6.getData().tree.root, ee = f6.getViewRoot(), oe = ee.depth, fe = f6.get("sort");
          fe != null && pYe(ee, fe);
          var _e = 0;
          gt(ee.children, function(Nt) {
            !isNaN(Nt.getValue()) && _e++;
          });
          var pe = ee.getValue(), Ve = Math.PI / (pe || _e) * 2, Le = ee.depth > 0, je = ee.height - (Le ? -1 : 1), Xe = (V - R) / (je || 1), Ye = f6.get("clockwise"), rt2 = f6.get("stillShowZeroSum"), ut = Ye ? 1 : -1, wt = function(Nt, er) {
            if (Nt) {
              var un = er;
              if (Nt !== Z) {
                var pn = Nt.getValue(), On = pe === 0 && rt2 ? Ve : pn * Ve;
                On < H && (On = H), un = er + ut * On;
                var fr = Nt.depth - oe - (Le ? -1 : 1), yr = R + Xe * fr, da = R + Xe * (fr + 1), Ja = f6.getLevelModel(Nt);
                if (Ja) {
                  var ko = Ja.get("r0", true), wo = Ja.get("r", true), So = Ja.get("radius", true);
                  So != null && (ko = So[0], wo = So[1]), ko != null && (yr = Ia(ko, T / 2)), wo != null && (da = Ia(wo, T / 2));
                }
                Nt.setLayout({ angle: On, startAngle: er, endAngle: un, clockwise: Ye, cx: E, cy: O, r0: yr, r: da });
              }
              if (Nt.children && Nt.children.length) {
                var Fa = 0;
                gt(Nt.children, function(po) {
                  Fa += wt(po, er + Fa);
                });
              }
              return un - er;
            }
          };
          if (Le) {
            var dt = R, Gt = R + Xe, Qt = Math.PI * 2;
            Z.setLayout({ angle: Qt, startAngle: z3, endAngle: z3 + Qt, clockwise: Ye, cx: E, cy: O, r0: dt, r: Gt });
          }
          wt(ee, z3);
        });
      }
      function pYe(s, a) {
        var n6 = s.children || [];
        s.children = GWt(n6, a), n6.length && gt(s.children, function(f6) {
          pYe(f6, a);
        });
      }
      function GWt(s, a) {
        if (jo(a)) {
          var n6 = Pi(s, function(d4, y4) {
            var _ = d4.getValue();
            return { params: { depth: d4.depth, height: d4.height, dataIndex: d4.dataIndex, getValue: function() {
              return _;
            } }, index: y4 };
          });
          return n6.sort(function(d4, y4) {
            return a(d4.params, y4.params);
          }), Pi(n6, function(d4) {
            return s[d4.index];
          });
        } else {
          var f6 = a === "asc";
          return s.sort(function(d4, y4) {
            var _ = (d4.getValue() - y4.getValue()) * (f6 ? 1 : -1);
            return _ === 0 ? (d4.dataIndex - y4.dataIndex) * (f6 ? -1 : 1) : _;
          });
        }
      }
      function HWt(s) {
        var a = {};
        function n6(f6, d4, y4) {
          for (var _ = f6; _ && _.depth > 1; )
            _ = _.parentNode;
          var S = d4.getColorFromPalette(_.name || _.dataIndex + "", a);
          return f6.depth > 1 && Wa(S) && (S = AU(S, (f6.depth - 1) / (y4 - 1) * 0.5)), S;
        }
        s.eachSeriesByType("sunburst", function(f6) {
          var d4 = f6.getData(), y4 = d4.tree;
          y4.eachNode(function(_) {
            var S = _.getModel(), T = S.getModel("itemStyle").getItemStyle();
            T.fill || (T.fill = n6(_, f6, y4.root.height));
            var E = d4.ensureUniqueItemVisual(_.dataIndex, "style");
            ei(E, T);
          });
        });
      }
      function WWt(s) {
        s.registerChartView(VWt), s.registerSeriesModel(zWt), s.registerLayout(ks(jWt, "sunburst")), s.registerProcessor(ks(U$, "sunburst")), s.registerVisual(HWt), NWt(s);
      }
      var dYe = { color: "fill", borderColor: "stroke" }, UWt = { symbol: 1, symbolSize: 1, symbolKeepAspect: 1, legendIcon: 1, visualMeta: 1, liftZ: 1, decal: 1 }, BE = hu(), qWt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.optionUpdated = function() {
          this.currentZLevel = this.get("zlevel", true), this.currentZ = this.get("z", true);
        }, a.prototype.getInitialData = function(n6, f6) {
          return PE(null, this);
        }, a.prototype.getDataParams = function(n6, f6, d4) {
          var y4 = s.prototype.getDataParams.call(this, n6, f6);
          return d4 && (y4.info = BE(d4).info), y4;
        }, a.type = "series.custom", a.dependencies = ["grid", "polar", "geo", "singleAxis", "calendar"], a.defaultOption = { coordinateSystem: "cartesian2d", z: 2, legendHoverLink: true, clip: false }, a;
      }(Cp), $Wt = qWt;
      function XWt(s, a) {
        return a = a || [0, 0], Pi(["x", "y"], function(n6, f6) {
          var d4 = this.getAxis(n6), y4 = a[f6], _ = s[f6] / 2;
          return d4.type === "category" ? d4.getBandWidth() : Math.abs(d4.dataToCoord(y4 - _) - d4.dataToCoord(y4 + _));
        }, this);
      }
      function YWt(s) {
        var a = s.master.getRect();
        return { coordSys: { type: "cartesian2d", x: a.x, y: a.y, width: a.width, height: a.height }, api: { coord: function(n6) {
          return s.dataToPoint(n6);
        }, size: Za(XWt, s) } };
      }
      function KWt(s, a) {
        return a = a || [0, 0], Pi([0, 1], function(n6) {
          var f6 = a[n6], d4 = s[n6] / 2, y4 = [], _ = [];
          return y4[n6] = f6 - d4, _[n6] = f6 + d4, y4[1 - n6] = _[1 - n6] = a[1 - n6], Math.abs(this.dataToPoint(y4)[n6] - this.dataToPoint(_)[n6]);
        }, this);
      }
      function ZWt(s) {
        var a = s.getBoundingRect();
        return { coordSys: { type: "geo", x: a.x, y: a.y, width: a.width, height: a.height, zoom: s.getZoom() }, api: { coord: function(n6) {
          return s.dataToPoint(n6);
        }, size: Za(KWt, s) } };
      }
      function JWt(s, a) {
        var n6 = this.getAxis(), f6 = a instanceof Array ? a[0] : a, d4 = (s instanceof Array ? s[0] : s) / 2;
        return n6.type === "category" ? n6.getBandWidth() : Math.abs(n6.dataToCoord(f6 - d4) - n6.dataToCoord(f6 + d4));
      }
      function QWt(s) {
        var a = s.getRect();
        return { coordSys: { type: "singleAxis", x: a.x, y: a.y, width: a.width, height: a.height }, api: { coord: function(n6) {
          return s.dataToPoint(n6);
        }, size: Za(JWt, s) } };
      }
      function eUt(s, a) {
        return a = a || [0, 0], Pi(["Radius", "Angle"], function(n6, f6) {
          var d4 = "get" + n6 + "Axis", y4 = this[d4](), _ = a[f6], S = s[f6] / 2, T = y4.type === "category" ? y4.getBandWidth() : Math.abs(y4.dataToCoord(_ - S) - y4.dataToCoord(_ + S));
          return n6 === "Angle" && (T = T * Math.PI / 180), T;
        }, this);
      }
      function tUt(s) {
        var a = s.getRadiusAxis(), n6 = s.getAngleAxis(), f6 = a.getExtent();
        return f6[0] > f6[1] && f6.reverse(), { coordSys: { type: "polar", cx: s.cx, cy: s.cy, r: f6[1], r0: f6[0] }, api: { coord: function(d4) {
          var y4 = a.dataToRadius(d4[0]), _ = n6.dataToAngle(d4[1]), S = s.coordToPoint([y4, _]);
          return S.push(y4, _ * Math.PI / 180), S;
        }, size: Za(eUt, s) } };
      }
      function nUt(s) {
        var a = s.getRect(), n6 = s.getRangeInfo();
        return { coordSys: { type: "calendar", x: a.x, y: a.y, width: a.width, height: a.height, cellWidth: s.getCellWidth(), cellHeight: s.getCellHeight(), rangeInfo: { start: n6.start, end: n6.end, weeks: n6.weeks, dayCount: n6.allDay } }, api: { coord: function(f6, d4) {
          return s.dataToPoint(f6, d4);
        } } };
      }
      function vYe(s, a, n6, f6) {
        return s && (s.legacy || s.legacy !== false && !n6 && !f6 && a !== "tspan" && (a === "text" || io(s, "text")));
      }
      function gYe(s, a, n6) {
        var f6 = s, d4, y4, _;
        if (a === "text")
          _ = f6;
        else {
          _ = {}, io(f6, "text") && (_.text = f6.text), io(f6, "rich") && (_.rich = f6.rich), io(f6, "textFill") && (_.fill = f6.textFill), io(f6, "textStroke") && (_.stroke = f6.textStroke), io(f6, "fontFamily") && (_.fontFamily = f6.fontFamily), io(f6, "fontSize") && (_.fontSize = f6.fontSize), io(f6, "fontStyle") && (_.fontStyle = f6.fontStyle), io(f6, "fontWeight") && (_.fontWeight = f6.fontWeight), y4 = { type: "text", style: _, silent: true }, d4 = {};
          var S = io(f6, "textPosition");
          n6 ? d4.position = S ? f6.textPosition : "inside" : S && (d4.position = f6.textPosition), io(f6, "textPosition") && (d4.position = f6.textPosition), io(f6, "textOffset") && (d4.offset = f6.textOffset), io(f6, "textRotation") && (d4.rotation = f6.textRotation), io(f6, "textDistance") && (d4.distance = f6.textDistance);
        }
        return yYe(_, s), gt(_.rich, function(T) {
          yYe(T, T);
        }), { textConfig: d4, textContent: y4 };
      }
      function yYe(s, a) {
        !a || (a.font = a.textFont || a.font, io(a, "textStrokeWidth") && (s.lineWidth = a.textStrokeWidth), io(a, "textAlign") && (s.align = a.textAlign), io(a, "textVerticalAlign") && (s.verticalAlign = a.textVerticalAlign), io(a, "textLineHeight") && (s.lineHeight = a.textLineHeight), io(a, "textWidth") && (s.width = a.textWidth), io(a, "textHeight") && (s.height = a.textHeight), io(a, "textBackgroundColor") && (s.backgroundColor = a.textBackgroundColor), io(a, "textPadding") && (s.padding = a.textPadding), io(a, "textBorderColor") && (s.borderColor = a.textBorderColor), io(a, "textBorderWidth") && (s.borderWidth = a.textBorderWidth), io(a, "textBorderRadius") && (s.borderRadius = a.textBorderRadius), io(a, "textBoxShadowColor") && (s.shadowColor = a.textBoxShadowColor), io(a, "textBoxShadowBlur") && (s.shadowBlur = a.textBoxShadowBlur), io(a, "textBoxShadowOffsetX") && (s.shadowOffsetX = a.textBoxShadowOffsetX), io(a, "textBoxShadowOffsetY") && (s.shadowOffsetY = a.textBoxShadowOffsetY));
      }
      function mYe(s, a, n6) {
        var f6 = s;
        f6.textPosition = f6.textPosition || n6.position || "inside", n6.offset != null && (f6.textOffset = n6.offset), n6.rotation != null && (f6.textRotation = n6.rotation), n6.distance != null && (f6.textDistance = n6.distance);
        var d4 = f6.textPosition.indexOf("inside") >= 0, y4 = s.fill || "#000";
        bYe(f6, a);
        var _ = f6.textFill == null;
        return d4 ? _ && (f6.textFill = n6.insideFill || "#fff", !f6.textStroke && n6.insideStroke && (f6.textStroke = n6.insideStroke), !f6.textStroke && (f6.textStroke = y4), f6.textStrokeWidth == null && (f6.textStrokeWidth = 2)) : (_ && (f6.textFill = s.fill || n6.outsideFill || "#000"), !f6.textStroke && n6.outsideStroke && (f6.textStroke = n6.outsideStroke)), f6.text = a.text, f6.rich = a.rich, gt(a.rich, function(S) {
          bYe(S, S);
        }), f6;
      }
      function bYe(s, a) {
        !a || (io(a, "fill") && (s.textFill = a.fill), io(a, "stroke") && (s.textStroke = a.fill), io(a, "lineWidth") && (s.textStrokeWidth = a.lineWidth), io(a, "font") && (s.font = a.font), io(a, "fontStyle") && (s.fontStyle = a.fontStyle), io(a, "fontWeight") && (s.fontWeight = a.fontWeight), io(a, "fontSize") && (s.fontSize = a.fontSize), io(a, "fontFamily") && (s.fontFamily = a.fontFamily), io(a, "align") && (s.textAlign = a.align), io(a, "verticalAlign") && (s.textVerticalAlign = a.verticalAlign), io(a, "lineHeight") && (s.textLineHeight = a.lineHeight), io(a, "width") && (s.textWidth = a.width), io(a, "height") && (s.textHeight = a.height), io(a, "backgroundColor") && (s.textBackgroundColor = a.backgroundColor), io(a, "padding") && (s.textPadding = a.padding), io(a, "borderColor") && (s.textBorderColor = a.borderColor), io(a, "borderWidth") && (s.textBorderWidth = a.borderWidth), io(a, "borderRadius") && (s.textBorderRadius = a.borderRadius), io(a, "shadowColor") && (s.textBoxShadowColor = a.shadowColor), io(a, "shadowBlur") && (s.textBoxShadowBlur = a.shadowBlur), io(a, "shadowOffsetX") && (s.textBoxShadowOffsetX = a.shadowOffsetX), io(a, "shadowOffsetY") && (s.textBoxShadowOffsetY = a.shadowOffsetY), io(a, "textShadowColor") && (s.textShadowColor = a.textShadowColor), io(a, "textShadowBlur") && (s.textShadowBlur = a.textShadowBlur), io(a, "textShadowOffsetX") && (s.textShadowOffsetX = a.textShadowOffsetX), io(a, "textShadowOffsetY") && (s.textShadowOffsetY = a.textShadowOffsetY));
      }
      var _Ye = { position: ["x", "y"], scale: ["scaleX", "scaleY"], origin: ["originX", "originY"] }, xYe = Wl(_Ye);
      G_(jb, function(s, a) {
        return s[a] = 1, s;
      }, {}), jb.join(", ");
      var qoe = ["", "style", "shape", "extra"], nV = hu();
      function I2e(s, a, n6, f6, d4) {
        var y4 = s + "Animation", _ = qk(s, f6, d4) || {}, S = nV(a).userDuring;
        return _.duration > 0 && (_.during = S ? Za(sUt, { el: a, userDuring: S }) : null, _.setToFinal = true, _.scope = s), ei(_, n6[y4]), _;
      }
      function $oe(s, a, n6, f6) {
        f6 = f6 || {};
        var d4 = f6.dataIndex, y4 = f6.isInit, _ = f6.clearStyle, S = n6.isAnimationEnabled(), T = nV(s), E = a.style;
        T.userDuring = a.during;
        var O = {}, R = {};
        if (uUt(s, a, R), CYe("shape", a, R), CYe("extra", a, R), !y4 && S && (lUt(s, a, O), SYe("shape", s, a, O), SYe("extra", s, a, O), cUt(s, a, E, O)), R.style = E, rUt(s, R, _), aUt(s, a), S)
          if (y4) {
            var V = {};
            gt(qoe, function(H) {
              var Z = H ? a[H] : a;
              Z && Z.enterFrom && (H && (V[H] = V[H] || {}), ei(H ? V[H] : V, Z.enterFrom));
            });
            var z3 = I2e("enter", s, a, n6, d4);
            z3.duration > 0 && s.animateFrom(V, z3);
          } else
            iUt(s, a, d4 || 0, n6, O);
        wYe(s, a), E ? s.dirty() : s.markRedraw();
      }
      function wYe(s, a) {
        for (var n6 = nV(s).leaveToProps, f6 = 0; f6 < qoe.length; f6++) {
          var d4 = qoe[f6], y4 = d4 ? a[d4] : a;
          y4 && y4.leaveTo && (n6 || (n6 = nV(s).leaveToProps = {}), d4 && (n6[d4] = n6[d4] || {}), ei(d4 ? n6[d4] : n6, y4.leaveTo));
        }
      }
      function Xoe(s, a, n6, f6) {
        if (s) {
          var d4 = s.parent, y4 = nV(s).leaveToProps;
          if (y4) {
            var _ = I2e("update", s, a, n6, 0);
            _.done = function() {
              d4.remove(s), f6 && f6();
            }, s.animateTo(y4, _);
          } else
            d4.remove(s), f6 && f6();
        }
      }
      function o4(s) {
        return s === "all";
      }
      function rUt(s, a, n6) {
        var f6 = a.style;
        if (!s.isGroup && f6) {
          if (n6) {
            s.useStyle({});
            for (var d4 = s.animators, y4 = 0; y4 < d4.length; y4++) {
              var _ = d4[y4];
              _.targetName === "style" && _.changeTarget(s.style);
            }
          }
          s.setStyle(f6);
        }
        a && (a.style = null, a && s.attr(a), a.style = f6);
      }
      function iUt(s, a, n6, f6, d4) {
        if (d4) {
          var y4 = I2e("update", s, a, f6, n6);
          y4.duration > 0 && s.animateFrom(d4, y4);
        }
      }
      function aUt(s, a) {
        io(a, "silent") && (s.silent = a.silent), io(a, "ignore") && (s.ignore = a.ignore), s instanceof Hb && io(a, "invisible") && (s.invisible = a.invisible), s instanceof ml && io(a, "autoBatch") && (s.autoBatch = a.autoBatch);
      }
      var BT = {}, oUt = { setTransform: function(s, a) {
        return BT.el[s] = a, this;
      }, getTransform: function(s) {
        return BT.el[s];
      }, setShape: function(s, a) {
        var n6 = BT.el, f6 = n6.shape || (n6.shape = {});
        return f6[s] = a, n6.dirtyShape && n6.dirtyShape(), this;
      }, getShape: function(s) {
        var a = BT.el.shape;
        if (a)
          return a[s];
      }, setStyle: function(s, a) {
        var n6 = BT.el, f6 = n6.style;
        return f6 && (f6[s] = a, n6.dirtyStyle && n6.dirtyStyle()), this;
      }, getStyle: function(s) {
        var a = BT.el.style;
        if (a)
          return a[s];
      }, setExtra: function(s, a) {
        var n6 = BT.el.extra || (BT.el.extra = {});
        return n6[s] = a, this;
      }, getExtra: function(s) {
        var a = BT.el.extra;
        if (a)
          return a[s];
      } };
      function sUt() {
        var s = this, a = s.el;
        if (a) {
          var n6 = nV(a).userDuring, f6 = s.userDuring;
          if (n6 !== f6) {
            s.el = s.userDuring = null;
            return;
          }
          BT.el = a, f6(oUt);
        }
      }
      function SYe(s, a, n6, f6) {
        var d4 = n6[s];
        if (d4) {
          var y4 = a[s], _;
          if (y4) {
            var S = n6.transition, T = d4.transition;
            if (T)
              if (!_ && (_ = f6[s] = {}), o4(T))
                ei(_, y4);
              else
                for (var E = jc(T), O = 0; O < E.length; O++) {
                  var R = E[O], V = y4[R];
                  _[R] = V;
                }
            else if (o4(S) || Ns(S, s) >= 0) {
              !_ && (_ = f6[s] = {});
              for (var z3 = Wl(y4), O = 0; O < z3.length; O++) {
                var R = z3[O], V = y4[R];
                fUt(d4[R], V) && (_[R] = V);
              }
            }
          }
        }
      }
      function CYe(s, a, n6) {
        var f6 = a[s];
        if (f6)
          for (var d4 = n6[s] = {}, y4 = Wl(f6), _ = 0; _ < y4.length; _++) {
            var S = y4[_];
            d4[S] = hT(f6[S]);
          }
      }
      function lUt(s, a, n6) {
        for (var f6 = a.transition, d4 = o4(f6) ? jb : jc(f6 || []), y4 = 0; y4 < d4.length; y4++) {
          var _ = d4[y4];
          if (!(_ === "style" || _ === "shape" || _ === "extra")) {
            var S = s[_];
            n6[_] = S;
          }
        }
      }
      function uUt(s, a, n6) {
        for (var f6 = 0; f6 < xYe.length; f6++) {
          var d4 = xYe[f6], y4 = _Ye[d4], _ = a[d4];
          _ && (n6[y4[0]] = _[0], n6[y4[1]] = _[1]);
        }
        for (var f6 = 0; f6 < jb.length; f6++) {
          var S = jb[f6];
          a[S] != null && (n6[S] = a[S]);
        }
      }
      function cUt(s, a, n6, f6) {
        if (n6) {
          var d4 = s.style, y4;
          if (d4) {
            var _ = n6.transition, S = a.transition;
            if (_ && !o4(_)) {
              var T = jc(_);
              !y4 && (y4 = f6.style = {});
              for (var E = 0; E < T.length; E++) {
                var O = T[E], R = d4[O];
                y4[O] = R;
              }
            } else if (s.getAnimationStyleProps && (o4(S) || o4(_) || Ns(S, "style") >= 0)) {
              var V = s.getAnimationStyleProps(), z3 = V ? V.style : null;
              if (z3) {
                !y4 && (y4 = f6.style = {});
                for (var H = Wl(n6), E = 0; E < H.length; E++) {
                  var O = H[E];
                  if (z3[O]) {
                    var R = d4[O];
                    y4[O] = R;
                  }
                }
              }
            }
          }
        }
      }
      function fUt(s, a) {
        return _0(s) ? s !== a : s != null && isFinite(s);
      }
      var MYe = hu(), hUt = ["percent", "easing", "shape", "style", "extra"];
      function TYe(s) {
        s.stopAnimation("keyframe"), s.attr(MYe(s));
      }
      function Yoe(s, a, n6) {
        if (!(!n6.isAnimationEnabled() || !a)) {
          if (Di(a)) {
            gt(a, function(S) {
              Yoe(s, S, n6);
            });
            return;
          }
          var f6 = a.keyframes, d4 = a.duration;
          if (n6 && d4 == null) {
            var y4 = qk("enter", n6, 0);
            d4 = y4 && y4.duration;
          }
          if (!(!f6 || !d4)) {
            var _ = MYe(s);
            gt(qoe, function(S) {
              if (!(S && !s[S])) {
                var T;
                f6.sort(function(E, O) {
                  return E.percent - O.percent;
                }), gt(f6, function(E) {
                  var O = s.animators, R = S ? E[S] : E;
                  if (R) {
                    var V = Wl(R);
                    if (S || (V = tf(V, function(Z) {
                      return Ns(hUt, Z) < 0;
                    })), !!V.length) {
                      T || (T = s.animate(S, a.loop, true), T.scope = "keyframe");
                      for (var z3 = 0; z3 < O.length; z3++)
                        O[z3] !== T && O[z3].targetName === T.targetName && O[z3].stopTracks(V);
                      S && (_[S] = _[S] || {});
                      var H = S ? _[S] : _;
                      gt(V, function(Z) {
                        H[Z] = ((S ? s[S] : s) || {})[Z];
                      }), T.whenWithKeys(d4 * E.percent, R, V, E.easing);
                    }
                  }
                }), T && T.delay(a.delay || 0).duration(d4).start(a.easing);
              }
            });
          }
        }
      }
      var zE = "emphasis", u3 = "normal", E2e = "blur", D2e = "select", c32 = [u3, zE, E2e, D2e], k2e = { normal: ["itemStyle"], emphasis: [zE, "itemStyle"], blur: [E2e, "itemStyle"], select: [D2e, "itemStyle"] }, O2e = { normal: ["label"], emphasis: [zE, "label"], blur: [E2e, "label"], select: [D2e, "label"] }, pUt = ["x", "y"], dUt = "e\0\0", wS = { normal: {}, emphasis: {}, blur: {}, select: {} }, vUt = { cartesian2d: YWt, geo: ZWt, singleAxis: QWt, polar: tUt, calendar: nUt };
      function P2e(s) {
        return s instanceof ml;
      }
      function L2e(s) {
        return s instanceof Hb;
      }
      function gUt(s, a) {
        a.copyTransform(s), L2e(a) && L2e(s) && (a.setStyle(s.style), a.z = s.z, a.z2 = s.z2, a.zlevel = s.zlevel, a.invisible = s.invisible, a.ignore = s.ignore, P2e(a) && P2e(s) && a.setShape(s.shape));
      }
      var yUt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          this._progressiveEls = null;
          var _ = this._data, S = n6.getData(), T = this.group, E = IYe(n6, S, f6, d4);
          _ || T.removeAll(), S.diff(_).add(function(R) {
            F2e(d4, null, R, E(R, y4), n6, T, S);
          }).remove(function(R) {
            var V = _.getItemGraphicEl(R);
            Xoe(V, BE(V).option, n6);
          }).update(function(R, V) {
            var z3 = _.getItemGraphicEl(V);
            F2e(d4, z3, R, E(R, y4), n6, T, S);
          }).execute();
          var O = n6.get("clip", true) ? boe(n6.coordinateSystem, false, n6) : null;
          O ? T.setClipPath(O) : T.removeClipPath(), this._data = S;
        }, a.prototype.incrementalPrepareRender = function(n6, f6, d4) {
          this.group.removeAll(), this._data = null;
        }, a.prototype.incrementalRender = function(n6, f6, d4, y4, _) {
          var S = f6.getData(), T = IYe(f6, S, d4, y4), E = this._progressiveEls = [];
          function O(z3) {
            z3.isGroup || (z3.incremental = true, z3.ensureState("emphasis").hoverLayer = true);
          }
          for (var R = n6.start; R < n6.end; R++) {
            var V = F2e(null, null, R, T(R, _), f6, this.group, S);
            V && (V.traverse(O), E.push(V));
          }
        }, a.prototype.eachRendered = function(n6) {
          mC(this._progressiveEls || this.group, n6);
        }, a.prototype.filterForExposedEvent = function(n6, f6, d4, y4) {
          var _ = f6.element;
          if (_ == null || d4.name === _)
            return true;
          for (; (d4 = d4.__hostTarget || d4.parent) && d4 !== this.group; )
            if (d4.name === _)
              return true;
          return false;
        }, a.type = "custom", a;
      }(Ch), mUt = yUt;
      function R2e(s) {
        var a = s.type, n6;
        if (a === "path") {
          var f6 = s.shape, d4 = f6.width != null && f6.height != null ? { x: f6.x || 0, y: f6.y || 0, width: f6.width, height: f6.height } : null, y4 = PYe(f6);
          n6 = Ie(y4, null, d4, f6.layout || "center"), BE(n6).customPathData = y4;
        } else if (a === "image")
          n6 = new Zv({}), BE(n6).customImagePath = s.style.image;
        else if (a === "text")
          n6 = new ju({});
        else if (a === "group")
          n6 = new fs();
        else {
          if (a === "compoundPath")
            throw new Error('"compoundPath" is not supported yet.');
          var _ = ae(a);
          if (!_) {
            var S = "";
            Ul(S);
          }
          n6 = new _();
        }
        return BE(n6).customGraphicType = a, n6.name = s.name, n6.z2EmphasisLift = 1, n6.z2SelectLift = 1, n6;
      }
      function N2e(s, a, n6, f6, d4, y4, _) {
        TYe(a);
        var S = d4 && d4.normal.cfg;
        S && a.setTextConfig(S), f6 && f6.transition == null && (f6.transition = pUt);
        var T = f6 && f6.style;
        if (T) {
          if (a.type === "text") {
            var E = T;
            io(E, "textFill") && (E.fill = E.textFill), io(E, "textStroke") && (E.stroke = E.textStroke);
          }
          var O = void 0, R = P2e(a) ? T.decal : null;
          s && R && (R.dirty = true, O = S$(R, s)), T.__decalPattern = O;
        }
        if (L2e(a) && T) {
          var O = T.__decalPattern;
          O && (T.decal = O);
        }
        $oe(a, f6, y4, { dataIndex: n6, isInit: _, clearStyle: true }), Yoe(a, f6.keyframeAnimation, y4);
      }
      function AYe(s, a, n6, f6, d4) {
        var y4 = a.isGroup ? null : a, _ = d4 && d4[s].cfg;
        if (y4) {
          var S = y4.ensureState(s);
          if (f6 === false) {
            var T = y4.getState(s);
            T && (T.style = null);
          } else
            S.style = f6 || null;
          _ && (S.textConfig = _), Wb(y4);
        }
      }
      function bUt(s, a, n6) {
        if (!s.isGroup) {
          var f6 = s, d4 = n6.currentZ, y4 = n6.currentZLevel;
          f6.z = d4, f6.zlevel = y4;
          var _ = a.z2;
          _ != null && (f6.z2 = _ || 0);
          for (var S = 0; S < c32.length; S++)
            _Ut(f6, a, c32[S]);
        }
      }
      function _Ut(s, a, n6) {
        var f6 = n6 === u3, d4 = f6 ? a : Koe(a, n6), y4 = d4 ? d4.z2 : null, _;
        y4 != null && (_ = f6 ? s : s.ensureState(n6), _.z2 = y4 || 0);
      }
      function IYe(s, a, n6, f6) {
        var d4 = s.get("renderItem"), y4 = s.coordinateSystem, _ = {};
        y4 && (_ = y4.prepareCustoms ? y4.prepareCustoms(y4) : vUt[y4.type](y4));
        for (var S = zo({ getWidth: f6.getWidth, getHeight: f6.getHeight, getZr: f6.getZr, getDevicePixelRatio: f6.getDevicePixelRatio, value: pe, style: Le, ordinalRawValue: Ve, styleEmphasis: je, visual: rt2, barLayout: ut, currentSeriesIndices: wt, font: dt }, _.api || {}), T = { context: {}, seriesId: s.id, seriesName: s.name, seriesIndex: s.seriesIndex, coordSys: _.coordSys, dataInsideLength: a.count(), encode: xUt(s.getData()) }, E, O, R = {}, V = {}, z3 = {}, H = {}, Z = 0; Z < c32.length; Z++) {
          var ee = c32[Z];
          z3[ee] = s.getModel(k2e[ee]), H[ee] = s.getModel(O2e[ee]);
        }
        function oe(Gt) {
          return Gt === E ? O || (O = a.getItemModel(Gt)) : a.getItemModel(Gt);
        }
        function fe(Gt, Qt) {
          return a.hasItemOption ? Gt === E ? R[Qt] || (R[Qt] = oe(Gt).getModel(k2e[Qt])) : oe(Gt).getModel(k2e[Qt]) : z3[Qt];
        }
        function _e(Gt, Qt) {
          return a.hasItemOption ? Gt === E ? V[Qt] || (V[Qt] = oe(Gt).getModel(O2e[Qt])) : oe(Gt).getModel(O2e[Qt]) : H[Qt];
        }
        return function(Gt, Qt) {
          return E = Gt, O = null, R = {}, V = {}, d4 && d4(zo({ dataIndexInside: Gt, dataIndex: a.getRawIndex(Gt), actionType: Qt ? Qt.type : null }, T), S);
        };
        function pe(Gt, Qt) {
          return Qt == null && (Qt = E), a.getStore().get(a.getDimensionIndex(Gt || 0), Qt);
        }
        function Ve(Gt, Qt) {
          Qt == null && (Qt = E), Gt = Gt || 0;
          var Nt = a.getDimensionInfo(Gt);
          if (!Nt) {
            var er = a.getDimensionIndex(Gt);
            return er >= 0 ? a.getStore().get(er, Qt) : void 0;
          }
          var un = a.get(Nt.name, Qt), pn = Nt && Nt.ordinalMeta;
          return pn ? pn.categories[un] : un;
        }
        function Le(Gt, Qt) {
          Qt == null && (Qt = E);
          var Nt = a.getItemVisual(Qt, "style"), er = Nt && Nt.fill, un = Nt && Nt.opacity, pn = fe(Qt, u3).getItemStyle();
          er != null && (pn.fill = er), un != null && (pn.opacity = un);
          var On = { inheritColor: Wa(er) ? er : "#000" }, fr = _e(Qt, u3), yr = Zd(fr, null, On, false, true);
          yr.text = fr.getShallow("show") ? Zs(s.getFormattedLabel(Qt, u3), U7(a, Qt)) : null;
          var da = xae(fr, On, false);
          return Ye(Gt, pn), pn = mYe(pn, yr, da), Gt && Xe(pn, Gt), pn.legacy = true, pn;
        }
        function je(Gt, Qt) {
          Qt == null && (Qt = E);
          var Nt = fe(Qt, zE).getItemStyle(), er = _e(Qt, zE), un = Zd(er, null, null, true, true);
          un.text = er.getShallow("show") ? rC(s.getFormattedLabel(Qt, zE), s.getFormattedLabel(Qt, u3), U7(a, Qt)) : null;
          var pn = xae(er, null, true);
          return Ye(Gt, Nt), Nt = mYe(Nt, un, pn), Gt && Xe(Nt, Gt), Nt.legacy = true, Nt;
        }
        function Xe(Gt, Qt) {
          for (var Nt in Qt)
            io(Qt, Nt) && (Gt[Nt] = Qt[Nt]);
        }
        function Ye(Gt, Qt) {
          Gt && (Gt.textFill && (Qt.textFill = Gt.textFill), Gt.textPosition && (Qt.textPosition = Gt.textPosition));
        }
        function rt2(Gt, Qt) {
          if (Qt == null && (Qt = E), io(dYe, Gt)) {
            var Nt = a.getItemVisual(Qt, "style");
            return Nt ? Nt[dYe[Gt]] : null;
          }
          if (io(UWt, Gt))
            return a.getItemVisual(Qt, Gt);
        }
        function ut(Gt) {
          if (y4.type === "cartesian2d") {
            var Qt = y4.getBaseAxis();
            return wFt(zo({ axis: Qt }, Gt));
          }
        }
        function wt() {
          return n6.getCurrentSeriesIndices();
        }
        function dt(Gt) {
          return vje(Gt, n6);
        }
      }
      function xUt(s) {
        var a = {};
        return gt(s.dimensions, function(n6) {
          var f6 = s.getDimensionInfo(n6);
          if (!f6.isExtraCoord) {
            var d4 = f6.coordDim, y4 = a[d4] = a[d4] || [];
            y4[f6.coordDimIndex] = s.getDimensionIndex(n6);
          }
        }), a;
      }
      function F2e(s, a, n6, f6, d4, y4, _) {
        if (!f6) {
          y4.remove(a);
          return;
        }
        var S = V2e(s, a, n6, f6, d4, y4);
        return S && _.setItemGraphicEl(n6, S), S && Up(S, f6.focus, f6.blurScope, f6.emphasisDisabled), S;
      }
      function V2e(s, a, n6, f6, d4, y4) {
        var _ = -1, S = a;
        a && EYe(a, f6, d4) && (_ = Ns(y4.childrenRef(), a), a = null);
        var T = !a, E = a;
        E ? E.clearStates() : (E = R2e(f6), S && gUt(S, E)), f6.morph === false ? E.disableMorphing = true : E.disableMorphing && (E.disableMorphing = false), wS.normal.cfg = wS.normal.conOpt = wS.emphasis.cfg = wS.emphasis.conOpt = wS.blur.cfg = wS.blur.conOpt = wS.select.cfg = wS.select.conOpt = null, wS.isLegacy = false, SUt(E, n6, f6, d4, T, wS), wUt(E, n6, f6, d4, T), N2e(s, E, n6, f6, wS, d4, T), io(f6, "info") && (BE(E).info = f6.info);
        for (var O = 0; O < c32.length; O++) {
          var R = c32[O];
          if (R !== u3) {
            var V = Koe(f6, R), z3 = B2e(f6, V, R);
            AYe(R, E, V, z3, wS);
          }
        }
        return bUt(E, f6, d4), f6.type === "group" && CUt(s, E, n6, f6, d4), _ >= 0 ? y4.replaceAt(E, _) : y4.add(E), E;
      }
      function EYe(s, a, n6) {
        var f6 = BE(s), d4 = a.type, y4 = a.shape, _ = a.style;
        return n6.isUniversalTransitionEnabled() || d4 != null && d4 !== f6.customGraphicType || d4 === "path" && AUt(y4) && PYe(y4) !== f6.customPathData || d4 === "image" && io(_, "image") && _.image !== f6.customImagePath;
      }
      function wUt(s, a, n6, f6, d4) {
        var y4 = n6.clipPath;
        if (y4 === false)
          s && s.getClipPath() && s.removeClipPath();
        else if (y4) {
          var _ = s.getClipPath();
          _ && EYe(_, y4, f6) && (_ = null), _ || (_ = R2e(y4), s.setClipPath(_)), N2e(null, _, a, y4, null, f6, d4);
        }
      }
      function SUt(s, a, n6, f6, d4, y4) {
        if (!s.isGroup) {
          DYe(n6, null, y4), DYe(n6, zE, y4);
          var _ = y4.normal.conOpt, S = y4.emphasis.conOpt, T = y4.blur.conOpt, E = y4.select.conOpt;
          if (_ != null || S != null || E != null || T != null) {
            var O = s.getTextContent();
            if (_ === false)
              O && s.removeTextContent();
            else {
              _ = y4.normal.conOpt = _ || { type: "text" }, O ? O.clearStates() : (O = R2e(_), s.setTextContent(O)), N2e(null, O, a, _, null, f6, d4);
              for (var R = _ && _.style, V = 0; V < c32.length; V++) {
                var z3 = c32[V];
                if (z3 !== u3) {
                  var H = y4[z3].conOpt;
                  AYe(z3, O, H, B2e(_, H, z3), null);
                }
              }
              R ? O.dirty() : O.markRedraw();
            }
          }
        }
      }
      function DYe(s, a, n6) {
        var f6 = a ? Koe(s, a) : s, d4 = a ? B2e(s, f6, zE) : s.style, y4 = s.type, _ = f6 ? f6.textConfig : null, S = s.textContent, T = S ? a ? Koe(S, a) : S : null;
        if (d4 && (n6.isLegacy || vYe(d4, y4, !!_, !!T))) {
          n6.isLegacy = true;
          var E = gYe(d4, y4, !a);
          !_ && E.textConfig && (_ = E.textConfig), !T && E.textContent && (T = E.textContent);
        }
        if (!a && T) {
          var O = T;
          !O.type && (O.type = "text");
        }
        var R = a ? n6[a] : n6.normal;
        R.cfg = _, R.conOpt = T;
      }
      function Koe(s, a) {
        return a ? s ? s[a] : null : s;
      }
      function B2e(s, a, n6) {
        var f6 = a && a.style;
        return f6 == null && n6 === zE && s && (f6 = s.styleEmphasis), f6;
      }
      function CUt(s, a, n6, f6, d4) {
        var y4 = f6.children, _ = y4 ? y4.length : 0, S = f6.$mergeChildren, T = S === "byName" || f6.diffChildrenByName, E = S === false;
        if (!(!_ && !T && !E)) {
          if (T) {
            MUt({ api: s, oldChildren: a.children() || [], newChildren: y4 || [], dataIndex: n6, seriesModel: d4, group: a });
            return;
          }
          E && a.removeAll();
          for (var O = 0; O < _; O++)
            y4[O] && V2e(s, a.childAt(O), n6, y4[O], d4, a);
          for (var R = a.childCount() - 1; R >= O; R--) {
            var V = a.childAt(R);
            Xoe(V, BE(a).option, d4);
          }
        }
      }
      function MUt(s) {
        new OE(s.oldChildren, s.newChildren, kYe, kYe, s).add(OYe).update(OYe).remove(TUt).execute();
      }
      function kYe(s, a) {
        var n6 = s && s.name;
        return n6 != null ? n6 : dUt + a;
      }
      function OYe(s, a) {
        var n6 = this.context, f6 = s != null ? n6.newChildren[s] : null, d4 = a != null ? n6.oldChildren[a] : null;
        V2e(n6.api, d4, n6.dataIndex, f6, n6.seriesModel, n6.group);
      }
      function TUt(s) {
        var a = this.context, n6 = a.oldChildren[s];
        Xoe(n6, BE(n6).option, a.seriesModel);
      }
      function PYe(s) {
        return s && (s.pathData || s.d);
      }
      function AUt(s) {
        return s && (io(s, "pathData") || io(s, "d"));
      }
      function IUt(s) {
        s.registerChartView(mUt), s.registerSeriesModel($Wt);
      }
      var s4 = hu(), LYe = Bo, z2e = Za, EUt = function() {
        function s() {
          this._dragging = false, this.animationThreshold = 15;
        }
        return s.prototype.render = function(a, n6, f6, d4) {
          var y4 = n6.get("value"), _ = n6.get("status");
          if (this._axisModel = a, this._axisPointerModel = n6, this._api = f6, !(!d4 && this._lastValue === y4 && this._lastStatus === _)) {
            this._lastValue = y4, this._lastStatus = _;
            var S = this._group, T = this._handle;
            if (!_ || _ === "hide") {
              S && S.hide(), T && T.hide();
              return;
            }
            S && S.show(), T && T.show();
            var E = {};
            this.makeElOption(E, y4, a, n6, f6);
            var O = E.graphicKey;
            O !== this._lastGraphicKey && this.clear(f6), this._lastGraphicKey = O;
            var R = this._moveAnimation = this.determineAnimation(a, n6);
            if (!S)
              S = this._group = new fs(), this.createPointerEl(S, E, a, n6), this.createLabelEl(S, E, a, n6), f6.getZr().add(S);
            else {
              var V = ks(RYe, n6, R);
              this.updatePointerEl(S, E, V), this.updateLabelEl(S, E, V, n6);
            }
            VYe(S, n6, true), this._renderHandle(y4);
          }
        }, s.prototype.remove = function(a) {
          this.clear(a);
        }, s.prototype.dispose = function(a) {
          this.clear(a);
        }, s.prototype.determineAnimation = function(a, n6) {
          var f6 = n6.get("animation"), d4 = a.axis, y4 = d4.type === "category", _ = n6.get("snap");
          if (!_ && !y4)
            return false;
          if (f6 === "auto" || f6 == null) {
            var S = this.animationThreshold;
            if (y4 && d4.getBandWidth() > S)
              return true;
            if (_) {
              var T = dSe(a).seriesDataCount, E = d4.getExtent();
              return Math.abs(E[0] - E[1]) / T > S;
            }
            return false;
          }
          return f6 === true;
        }, s.prototype.makeElOption = function(a, n6, f6, d4, y4) {
        }, s.prototype.createPointerEl = function(a, n6, f6, d4) {
          var y4 = n6.pointer;
          if (y4) {
            var _ = s4(a).pointerEl = new i$[y4.type](LYe(n6.pointer));
            a.add(_);
          }
        }, s.prototype.createLabelEl = function(a, n6, f6, d4) {
          if (n6.label) {
            var y4 = s4(a).labelEl = new ju(LYe(n6.label));
            a.add(y4), FYe(y4, d4);
          }
        }, s.prototype.updatePointerEl = function(a, n6, f6) {
          var d4 = s4(a).pointerEl;
          d4 && n6.pointer && (d4.setStyle(n6.pointer.style), f6(d4, { shape: n6.pointer.shape }));
        }, s.prototype.updateLabelEl = function(a, n6, f6, d4) {
          var y4 = s4(a).labelEl;
          y4 && (y4.setStyle(n6.label.style), f6(y4, { x: n6.label.x, y: n6.label.y }), FYe(y4, d4));
        }, s.prototype._renderHandle = function(a) {
          if (!(this._dragging || !this.updateHandleTransform)) {
            var n6 = this._axisPointerModel, f6 = this._api.getZr(), d4 = this._handle, y4 = n6.getModel("handle"), _ = n6.get("status");
            if (!y4.get("show") || !_ || _ === "hide") {
              d4 && f6.remove(d4), this._handle = null;
              return;
            }
            var S;
            this._handle || (S = true, d4 = this._handle = Gu(y4.get("icon"), { cursor: "move", draggable: true, onmousemove: function(E) {
              Jw(E.event);
            }, onmousedown: z2e(this._onHandleDragMove, this, 0, 0), drift: z2e(this._onHandleDragMove, this), ondragend: z2e(this._onHandleDragEnd, this) }), f6.add(d4)), VYe(d4, n6, false), d4.setStyle(y4.getItemStyle(null, ["color", "borderColor", "borderWidth", "opacity", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"]));
            var T = y4.get("size");
            Di(T) || (T = [T, T]), d4.scaleX = T[0] / 2, d4.scaleY = T[1] / 2, N7(this, "_doDispatchAxisPointer", y4.get("throttle") || 0, "fixRate"), this._moveHandleToValue(a, S);
          }
        }, s.prototype._moveHandleToValue = function(a, n6) {
          RYe(this._axisPointerModel, !n6 && this._moveAnimation, this._handle, j2e(this.getHandleTransform(a, this._axisModel, this._axisPointerModel)));
        }, s.prototype._onHandleDragMove = function(a, n6) {
          var f6 = this._handle;
          if (f6) {
            this._dragging = true;
            var d4 = this.updateHandleTransform(j2e(f6), [a, n6], this._axisModel, this._axisPointerModel);
            this._payloadInfo = d4, f6.stopAnimation(), f6.attr(j2e(d4)), s4(f6).lastProp = null, this._doDispatchAxisPointer();
          }
        }, s.prototype._doDispatchAxisPointer = function() {
          var a = this._handle;
          if (a) {
            var n6 = this._payloadInfo, f6 = this._axisModel;
            this._api.dispatchAction({ type: "updateAxisPointer", x: n6.cursorPoint[0], y: n6.cursorPoint[1], tooltipOption: n6.tooltipOption, axesInfo: [{ axisDim: f6.axis.dim, axisIndex: f6.componentIndex }] });
          }
        }, s.prototype._onHandleDragEnd = function() {
          this._dragging = false;
          var a = this._handle;
          if (a) {
            var n6 = this._axisPointerModel.get("value");
            this._moveHandleToValue(n6), this._api.dispatchAction({ type: "hideTip" });
          }
        }, s.prototype.clear = function(a) {
          this._lastValue = null, this._lastStatus = null;
          var n6 = a.getZr(), f6 = this._group, d4 = this._handle;
          n6 && f6 && (this._lastGraphicKey = null, f6 && n6.remove(f6), d4 && n6.remove(d4), this._group = null, this._handle = null, this._payloadInfo = null), y$(this, "_doDispatchAxisPointer");
        }, s.prototype.doClear = function() {
        }, s.prototype.buildLabel = function(a, n6, f6) {
          return f6 = f6 || 0, { x: a[f6], y: a[1 - f6], width: n6[f6], height: n6[1 - f6] };
        }, s;
      }();
      function RYe(s, a, n6, f6) {
        NYe(s4(n6).lastProp, f6) || (s4(n6).lastProp = f6, a ? ku(n6, f6, s) : (n6.stopAnimation(), n6.attr(f6)));
      }
      function NYe(s, a) {
        if (Qo(s) && Qo(a)) {
          var n6 = true;
          return gt(a, function(f6, d4) {
            n6 = n6 && NYe(s[d4], f6);
          }), !!n6;
        } else
          return s === a;
      }
      function FYe(s, a) {
        s[a.get(["label", "show"]) ? "show" : "hide"]();
      }
      function j2e(s) {
        return { x: s.x || 0, y: s.y || 0, rotation: s.rotation || 0 };
      }
      function VYe(s, a, n6) {
        var f6 = a.get("z"), d4 = a.get("zlevel");
        s && s.traverse(function(y4) {
          y4.type !== "group" && (f6 != null && (y4.z = f6), d4 != null && (y4.zlevel = d4), y4.silent = n6);
        });
      }
      var G2e = EUt;
      function H2e(s) {
        var a = s.get("type"), n6 = s.getModel(a + "Style"), f6;
        return a === "line" ? (f6 = n6.getLineStyle(), f6.fill = null) : a === "shadow" && (f6 = n6.getAreaStyle(), f6.stroke = null), f6;
      }
      function BYe(s, a, n6, f6, d4) {
        var y4 = n6.get("value"), _ = zYe(y4, a.axis, a.ecModel, n6.get("seriesDataIndices"), { precision: n6.get(["label", "precision"]), formatter: n6.get(["label", "formatter"]) }), S = n6.getModel("label"), T = I7(S.get("padding") || 0), E = S.getFont(), O = cE(_, E), R = d4.position, V = O.width + T[1] + T[3], z3 = O.height + T[0] + T[2], H = d4.align;
        H === "right" && (R[0] -= V), H === "center" && (R[0] -= V / 2);
        var Z = d4.verticalAlign;
        Z === "bottom" && (R[1] -= z3), Z === "middle" && (R[1] -= z3 / 2), DUt(R, V, z3, f6);
        var ee = S.get("backgroundColor");
        (!ee || ee === "auto") && (ee = a.get(["axisLine", "lineStyle", "color"])), s.label = { x: R[0], y: R[1], style: Zd(S, { text: _, font: E, fill: S.getTextColor(), padding: T, backgroundColor: ee }), z2: 10 };
      }
      function DUt(s, a, n6, f6) {
        var d4 = f6.getWidth(), y4 = f6.getHeight();
        s[0] = Math.min(s[0] + a, d4) - a, s[1] = Math.min(s[1] + n6, y4) - n6, s[0] = Math.max(s[0], 0), s[1] = Math.max(s[1], 0);
      }
      function zYe(s, a, n6, f6, d4) {
        s = a.scale.parse(s);
        var y4 = a.scale.getLabel({ value: s }, { precision: d4.precision }), _ = d4.formatter;
        if (_) {
          var S = { value: Nwe(a, { value: s }), axisDimension: a.dim, axisIndex: a.index, seriesData: [] };
          gt(f6, function(T) {
            var E = n6.getSeriesByIndex(T.seriesIndex), O = T.dataIndexInside, R = E && E.getDataParams(O);
            R && S.seriesData.push(R);
          }), Wa(_) ? y4 = _.replace("{value}", y4) : jo(_) && (y4 = _(S));
        }
        return y4;
      }
      function W2e(s, a, n6) {
        var f6 = Bb();
        return vT(f6, f6, n6.rotation), zb(f6, f6, n6.position), pa([s.dataToCoord(a), (n6.labelOffset || 0) + (n6.labelDirection || 1) * (n6.labelMargin || 0)], f6);
      }
      function jYe(s, a, n6, f6, d4, y4) {
        var _ = NE.innerTextLayout(n6.rotation, 0, n6.labelDirection);
        n6.labelMargin = d4.get(["label", "margin"]), BYe(a, f6, d4, y4, { position: W2e(f6.axis, s, n6), align: _.textAlign, verticalAlign: _.textVerticalAlign });
      }
      function U2e(s, a, n6) {
        return n6 = n6 || 0, { x1: s[n6], y1: s[1 - n6], x2: a[n6], y2: a[1 - n6] };
      }
      function GYe(s, a, n6) {
        return n6 = n6 || 0, { x: s[n6], y: s[1 - n6], width: a[n6], height: a[1 - n6] };
      }
      function HYe(s, a, n6, f6, d4, y4) {
        return { cx: s, cy: a, r0: n6, r: f6, startAngle: d4, endAngle: y4, clockwise: true };
      }
      var kUt = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.makeElOption = function(n6, f6, d4, y4, _) {
          var S = d4.axis, T = S.grid, E = y4.get("type"), O = WYe(T, S).getOtherAxis(S).getGlobalExtent(), R = S.toGlobalCoord(S.dataToCoord(f6, true));
          if (E && E !== "none") {
            var V = H2e(y4), z3 = OUt[E](S, R, O);
            z3.style = V, n6.graphicKey = z3.type, n6.pointer = z3;
          }
          var H = cSe(T.model, d4);
          jYe(f6, n6, H, d4, y4, _);
        }, a.prototype.getHandleTransform = function(n6, f6, d4) {
          var y4 = cSe(f6.axis.grid.model, f6, { labelInside: false });
          y4.labelMargin = d4.get(["handle", "margin"]);
          var _ = W2e(f6.axis, n6, y4);
          return { x: _[0], y: _[1], rotation: y4.rotation + (y4.labelDirection < 0 ? Math.PI : 0) };
        }, a.prototype.updateHandleTransform = function(n6, f6, d4, y4) {
          var _ = d4.axis, S = _.grid, T = _.getGlobalExtent(true), E = WYe(S, _).getOtherAxis(_).getGlobalExtent(), O = _.dim === "x" ? 0 : 1, R = [n6.x, n6.y];
          R[O] += f6[O], R[O] = Math.min(T[1], R[O]), R[O] = Math.max(T[0], R[O]);
          var V = (E[1] + E[0]) / 2, z3 = [V, V];
          z3[O] = R[O];
          var H = [{ verticalAlign: "middle" }, { align: "center" }];
          return { x: R[0], y: R[1], rotation: n6.rotation, cursorPoint: z3, tooltipOption: H[O] };
        }, a;
      }(G2e);
      function WYe(s, a) {
        var n6 = {};
        return n6[a.dim + "AxisIndex"] = a.index, s.getCartesian(n6);
      }
      var OUt = { line: function(s, a, n6) {
        var f6 = U2e([a, n6[0]], [a, n6[1]], UYe(s));
        return { type: "Line", subPixelOptimize: true, shape: f6 };
      }, shadow: function(s, a, n6) {
        var f6 = Math.max(1, s.getBandWidth()), d4 = n6[1] - n6[0];
        return { type: "Rect", shape: GYe([a - f6 / 2, n6[0]], [f6, d4], UYe(s)) };
      } };
      function UYe(s) {
        return s.dim === "x" ? 0 : 1;
      }
      var PUt = kUt, LUt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "axisPointer", a.defaultOption = { show: "auto", z: 50, type: "line", snap: false, triggerTooltip: true, value: null, status: null, link: [], animation: null, animationDurationUpdate: 200, lineStyle: { color: "#B9BEC9", width: 1, type: "dashed" }, shadowStyle: { color: "rgba(210,219,238,0.2)" }, label: { show: true, formatter: null, precision: "auto", margin: 3, color: "#fff", padding: [5, 7, 5, 7], backgroundColor: "auto", borderColor: null, borderWidth: 0, borderRadius: 3 }, handle: { show: false, icon: "M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4h1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7v-1.2h6.6z M13.3,22H6.7v-1.2h6.6z M13.3,19.6H6.7v-1.2h6.6z", size: 45, margin: 50, color: "#333", shadowBlur: 3, shadowColor: "#aaa", shadowOffsetX: 0, shadowOffsetY: 2, throttle: 40 } }, a;
      }(oc), RUt = LUt, jE = hu(), NUt = gt;
      function qYe(s, a, n6) {
        if (!Na.node) {
          var f6 = a.getZr();
          jE(f6).records || (jE(f6).records = {}), FUt(f6, a);
          var d4 = jE(f6).records[s] || (jE(f6).records[s] = {});
          d4.handler = n6;
        }
      }
      function FUt(s, a) {
        if (jE(s).initialized)
          return;
        jE(s).initialized = true, n6("click", ks($Ye, "click")), n6("mousemove", ks($Ye, "mousemove")), n6("globalout", BUt);
        function n6(f6, d4) {
          s.on(f6, function(y4) {
            var _ = zUt(a);
            NUt(jE(s).records, function(S) {
              S && d4(S, y4, _.dispatchAction);
            }), VUt(_.pendings, a);
          });
        }
      }
      function VUt(s, a) {
        var n6 = s.showTip.length, f6 = s.hideTip.length, d4;
        n6 ? d4 = s.showTip[n6 - 1] : f6 && (d4 = s.hideTip[f6 - 1]), d4 && (d4.dispatchAction = null, a.dispatchAction(d4));
      }
      function BUt(s, a, n6) {
        s.handler("leave", null, n6);
      }
      function $Ye(s, a, n6, f6) {
        a.handler(s, n6, f6);
      }
      function zUt(s) {
        var a = { showTip: [], hideTip: [] }, n6 = function(f6) {
          var d4 = a[f6.type];
          d4 ? d4.push(f6) : (f6.dispatchAction = n6, s.dispatchAction(f6));
        };
        return { dispatchAction: n6, pendings: a };
      }
      function q2e(s, a) {
        if (!Na.node) {
          var n6 = a.getZr(), f6 = (jE(n6).records || {})[s];
          f6 && (jE(n6).records[s] = null);
        }
      }
      var jUt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = f6.getComponent("tooltip"), _ = n6.get("triggerOn") || y4 && y4.get("triggerOn") || "mousemove|click";
          qYe("axisPointer", d4, function(S, T, E) {
            _ !== "none" && (S === "leave" || _.indexOf(S) >= 0) && E({ type: "updateAxisPointer", currTrigger: S, x: T && T.offsetX, y: T && T.offsetY });
          });
        }, a.prototype.remove = function(n6, f6) {
          q2e("axisPointer", f6);
        }, a.prototype.dispose = function(n6, f6) {
          q2e("axisPointer", f6);
        }, a.type = "axisPointer", a;
      }(sd), GUt = jUt;
      function XYe(s, a) {
        var n6 = [], f6 = s.seriesIndex, d4;
        if (f6 == null || !(d4 = a.getSeriesByIndex(f6)))
          return { point: [] };
        var y4 = d4.getData(), _ = hE(y4, s);
        if (_ == null || _ < 0 || Di(_))
          return { point: [] };
        var S = y4.getItemGraphicEl(_), T = d4.coordinateSystem;
        if (d4.getTooltipPosition)
          n6 = d4.getTooltipPosition(_) || [];
        else if (T && T.dataToPoint)
          if (s.isStacked) {
            var E = T.getBaseAxis(), O = T.getOtherAxis(E), R = O.dim, V = E.dim, z3 = R === "x" || R === "radius" ? 1 : 0, H = y4.mapDimension(V), Z = [];
            Z[z3] = y4.get(H, _), Z[1 - z3] = y4.get(y4.getCalculationInfo("stackResultDimension"), _), n6 = T.dataToPoint(Z) || [];
          } else
            n6 = T.dataToPoint(y4.getValues(Pi(T.dimensions, function(oe) {
              return y4.mapDimension(oe);
            }), _)) || [];
        else if (S) {
          var ee = S.getBoundingRect().clone();
          ee.applyTransform(S.transform), n6 = [ee.x + ee.width / 2, ee.y + ee.height / 2];
        }
        return { point: n6, el: S };
      }
      var YYe = hu();
      function HUt(s, a, n6) {
        var f6 = s.currTrigger, d4 = [s.x, s.y], y4 = s, _ = s.dispatchAction || Za(n6.dispatchAction, n6), S = a.getComponent("axisPointer").coordSysAxesInfo;
        if (S) {
          Zoe(d4) && (d4 = XYe({ seriesIndex: y4.seriesIndex, dataIndex: y4.dataIndex }, a).point);
          var T = Zoe(d4), E = y4.axesInfo, O = S.axesInfo, R = f6 === "leave" || Zoe(d4), V = {}, z3 = {}, H = { list: [], map: {} }, Z = { showPointer: ks(UUt, z3), showTooltip: ks(qUt, H) };
          gt(S.coordSysMap, function(oe, fe) {
            var _e = T || oe.containPoint(d4);
            gt(S.coordSysAxesInfo[fe], function(pe, Ve) {
              var Le = pe.axis, je = KUt(E, pe);
              if (!R && _e && (!E || je)) {
                var Xe = je && je.value;
                Xe == null && !T && (Xe = Le.pointToData(d4)), Xe != null && KYe(pe, Xe, Z, false, V);
              }
            });
          });
          var ee = {};
          return gt(O, function(oe, fe) {
            var _e = oe.linkGroup;
            _e && !z3[fe] && gt(_e.axesInfo, function(pe, Ve) {
              var Le = z3[Ve];
              if (pe !== oe && Le) {
                var je = Le.value;
                _e.mapper && (je = oe.axis.scale.parse(_e.mapper(je, ZYe(pe), ZYe(oe)))), ee[oe.key] = je;
              }
            });
          }), gt(ee, function(oe, fe) {
            KYe(O[fe], oe, Z, true, V);
          }), $Ut(z3, O, V), XUt(H, d4, s, _), YUt(O, _, n6), V;
        }
      }
      function KYe(s, a, n6, f6, d4) {
        var y4 = s.axis;
        if (!(y4.scale.isBlank() || !y4.containData(a))) {
          if (!s.involveSeries) {
            n6.showPointer(s, a);
            return;
          }
          var _ = WUt(a, s), S = _.payloadBatch, T = _.snapToValue;
          S[0] && d4.seriesIndex == null && ei(d4, S[0]), !f6 && s.snap && y4.containData(T) && T != null && (a = T), n6.showPointer(s, a, S), n6.showTooltip(s, _, T);
        }
      }
      function WUt(s, a) {
        var n6 = a.axis, f6 = n6.dim, d4 = s, y4 = [], _ = Number.MAX_VALUE, S = -1;
        return gt(a.seriesModels, function(T, E) {
          var O = T.getData().mapDimensionsAll(f6), R, V;
          if (T.getAxisTooltipData) {
            var z3 = T.getAxisTooltipData(O, s, n6);
            V = z3.dataIndices, R = z3.nestestValue;
          } else {
            if (V = T.getData().indicesOfNearest(O[0], s, n6.type === "category" ? 0.5 : null), !V.length)
              return;
            R = T.getData().get(O[0], V[0]);
          }
          if (!(R == null || !isFinite(R))) {
            var H = s - R, Z = Math.abs(H);
            Z <= _ && ((Z < _ || H >= 0 && S < 0) && (_ = Z, S = H, d4 = R, y4.length = 0), gt(V, function(ee) {
              y4.push({ seriesIndex: T.seriesIndex, dataIndexInside: ee, dataIndex: T.getData().getRawIndex(ee) });
            }));
          }
        }), { payloadBatch: y4, snapToValue: d4 };
      }
      function UUt(s, a, n6, f6) {
        s[a.key] = { value: n6, payloadBatch: f6 };
      }
      function qUt(s, a, n6, f6) {
        var d4 = n6.payloadBatch, y4 = a.axis, _ = y4.model, S = a.axisPointerModel;
        if (!(!a.triggerTooltip || !d4.length)) {
          var T = a.coordSys.model, E = $$(T), O = s.map[E];
          O || (O = s.map[E] = { coordSysId: T.id, coordSysIndex: T.componentIndex, coordSysType: T.type, coordSysMainType: T.mainType, dataByAxis: [] }, s.list.push(O)), O.dataByAxis.push({ axisDim: y4.dim, axisIndex: _.componentIndex, axisType: _.type, axisId: _.id, value: f6, valueLabelOpt: { precision: S.get(["label", "precision"]), formatter: S.get(["label", "formatter"]) }, seriesDataIndices: d4.slice() });
        }
      }
      function $Ut(s, a, n6) {
        var f6 = n6.axesInfo = [];
        gt(a, function(d4, y4) {
          var _ = d4.axisPointerModel.option, S = s[y4];
          S ? (!d4.useHandle && (_.status = "show"), _.value = S.value, _.seriesDataIndices = (S.payloadBatch || []).slice()) : !d4.useHandle && (_.status = "hide"), _.status === "show" && f6.push({ axisDim: d4.axis.dim, axisIndex: d4.axis.model.componentIndex, value: _.value });
        });
      }
      function XUt(s, a, n6, f6) {
        if (Zoe(a) || !s.list.length) {
          f6({ type: "hideTip" });
          return;
        }
        var d4 = ((s.list[0].dataByAxis[0] || {}).seriesDataIndices || [])[0] || {};
        f6({ type: "showTip", escapeConnect: true, x: a[0], y: a[1], tooltipOption: n6.tooltipOption, position: n6.position, dataIndexInside: d4.dataIndexInside, dataIndex: d4.dataIndex, seriesIndex: d4.seriesIndex, dataByCoordSys: s.list });
      }
      function YUt(s, a, n6) {
        var f6 = n6.getZr(), d4 = "axisPointerLastHighlights", y4 = YYe(f6)[d4] || {}, _ = YYe(f6)[d4] = {};
        gt(s, function(E, O) {
          var R = E.axisPointerModel.option;
          R.status === "show" && gt(R.seriesDataIndices, function(V) {
            var z3 = V.seriesIndex + " | " + V.dataIndex;
            _[z3] = V;
          });
        });
        var S = [], T = [];
        gt(y4, function(E, O) {
          !_[O] && T.push(E);
        }), gt(_, function(E, O) {
          !y4[O] && S.push(E);
        }), T.length && n6.dispatchAction({ type: "downplay", escapeConnect: true, notBlur: true, batch: T }), S.length && n6.dispatchAction({ type: "highlight", escapeConnect: true, notBlur: true, batch: S });
      }
      function KUt(s, a) {
        for (var n6 = 0; n6 < (s || []).length; n6++) {
          var f6 = s[n6];
          if (a.axis.dim === f6.axisDim && a.axis.model.componentIndex === f6.axisIndex)
            return f6;
        }
      }
      function ZYe(s) {
        var a = s.axis.model, n6 = {}, f6 = n6.axisDim = s.axis.dim;
        return n6.axisIndex = n6[f6 + "AxisIndex"] = a.componentIndex, n6.axisName = n6[f6 + "AxisName"] = a.name, n6.axisId = n6[f6 + "AxisId"] = a.id, n6;
      }
      function Zoe(s) {
        return !s || s[0] == null || isNaN(s[0]) || s[1] == null || isNaN(s[1]);
      }
      function fX(s) {
        ZR.registerAxisPointerClass("CartesianAxisPointer", PUt), s.registerComponentModel(RUt), s.registerComponentView(GUt), s.registerPreprocessor(function(a) {
          if (a) {
            (!a.axisPointer || a.axisPointer.length === 0) && (a.axisPointer = {});
            var n6 = a.axisPointer.link;
            n6 && !Di(n6) && (a.axisPointer.link = [n6]);
          }
        }), s.registerProcessor(s.PRIORITY.PROCESSOR.STATISTIC, function(a, n6) {
          a.getComponent("axisPointer").coordSysAxesInfo = V7t(a, n6);
        }), s.registerAction({ type: "updateAxisPointer", event: "updateAxisPointer", update: ":updateAxisPointer" }, HUt);
      }
      function ZUt(s) {
        Il(Tqe), Il(fX);
      }
      var JUt = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.makeElOption = function(n6, f6, d4, y4, _) {
          var S = d4.axis;
          S.dim === "angle" && (this.animationThreshold = Math.PI / 18);
          var T = S.polar, E = T.getOtherAxis(S), O = E.getExtent(), R = S.dataToCoord(f6), V = y4.get("type");
          if (V && V !== "none") {
            var z3 = H2e(y4), H = eqt[V](S, T, R, O);
            H.style = z3, n6.graphicKey = H.type, n6.pointer = H;
          }
          var Z = y4.get(["label", "margin"]), ee = QUt(f6, d4, y4, T, Z);
          BYe(n6, d4, y4, _, ee);
        }, a;
      }(G2e);
      function QUt(s, a, n6, f6, d4) {
        var y4 = a.axis, _ = y4.dataToCoord(s), S = f6.getAngleAxis().getExtent()[0];
        S = S / 180 * Math.PI;
        var T = f6.getRadiusAxis().getExtent(), E, O, R;
        if (y4.dim === "radius") {
          var V = Bb();
          vT(V, V, S), zb(V, V, [f6.cx, f6.cy]), E = pa([_, -d4], V);
          var z3 = a.getModel("axisLabel").get("rotate") || 0, H = NE.innerTextLayout(S, z3 * Math.PI / 180, -1);
          O = H.textAlign, R = H.textVerticalAlign;
        } else {
          var Z = T[1];
          E = f6.coordToPoint([Z + d4, _]);
          var ee = f6.cx, oe = f6.cy;
          O = Math.abs(E[0] - ee) / Z < 0.3 ? "center" : E[0] > ee ? "left" : "right", R = Math.abs(E[1] - oe) / Z < 0.3 ? "middle" : E[1] > oe ? "top" : "bottom";
        }
        return { position: E, align: O, verticalAlign: R };
      }
      var eqt = { line: function(s, a, n6, f6) {
        return s.dim === "angle" ? { type: "Line", shape: U2e(a.coordToPoint([f6[0], n6]), a.coordToPoint([f6[1], n6])) } : { type: "Circle", shape: { cx: a.cx, cy: a.cy, r: n6 } };
      }, shadow: function(s, a, n6, f6) {
        var d4 = Math.max(1, s.getBandWidth()), y4 = Math.PI / 180;
        return s.dim === "angle" ? { type: "Sector", shape: HYe(a.cx, a.cy, f6[0], f6[1], (-n6 - d4 / 2) * y4, (-n6 + d4 / 2) * y4) } : { type: "Sector", shape: HYe(a.cx, a.cy, n6 - d4 / 2, n6 + d4 / 2, 0, Math.PI * 2) };
      } }, tqt = JUt, nqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.findAxisModel = function(n6) {
          var f6, d4 = this.ecModel;
          return d4.eachComponent(n6, function(y4) {
            y4.getCoordSysModel() === this && (f6 = y4);
          }, this), f6;
        }, a.type = "polar", a.dependencies = ["radiusAxis", "angleAxis"], a.defaultOption = { z: 0, center: ["50%", "50%"], radius: "80%" }, a;
      }(oc), rqt = nqt, $2e = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.getCoordSysModel = function() {
          return this.getReferringComponents("polar", ad).models[0];
        }, a.type = "polarAxis", a;
      }(oc);
      nd($2e, R$);
      var iqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "angleAxis", a;
      }($2e), aqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "radiusAxis", a;
      }($2e), X2e = function(s) {
        Vt(a, s);
        function a(n6, f6) {
          return s.call(this, "radius", n6, f6) || this;
        }
        return a.prototype.pointToData = function(n6, f6) {
          return this.polar.pointToData(n6, f6)[this.dim === "radius" ? 0 : 1];
        }, a;
      }(xC);
      X2e.prototype.dataToRadius = xC.prototype.dataToCoord, X2e.prototype.radiusToData = xC.prototype.coordToData;
      var oqt = X2e, sqt = hu(), Y2e = function(s) {
        Vt(a, s);
        function a(n6, f6) {
          return s.call(this, "angle", n6, f6 || [0, 360]) || this;
        }
        return a.prototype.pointToData = function(n6, f6) {
          return this.polar.pointToData(n6, f6)[this.dim === "radius" ? 0 : 1];
        }, a.prototype.calculateCategoryInterval = function() {
          var n6 = this, f6 = n6.getLabelModel(), d4 = n6.scale, y4 = d4.getExtent(), _ = d4.count();
          if (y4[1] - y4[0] < 1)
            return 0;
          var S = y4[0], T = n6.dataToCoord(S + 1) - n6.dataToCoord(S), E = Math.abs(T), O = cE(S == null ? "" : S + "", f6.getFont(), "center", "top"), R = Math.max(O.height, 7), V = R / E;
          isNaN(V) && (V = 1 / 0);
          var z3 = Math.max(0, Math.floor(V)), H = sqt(n6.model), Z = H.lastAutoInterval, ee = H.lastTickCount;
          return Z != null && ee != null && Math.abs(Z - z3) <= 1 && Math.abs(ee - _) <= 1 && Z > z3 ? z3 = Z : (H.lastTickCount = _, H.lastAutoInterval = z3), z3;
        }, a;
      }(xC);
      Y2e.prototype.dataToAngle = xC.prototype.dataToCoord, Y2e.prototype.angleToData = xC.prototype.coordToData;
      var lqt = Y2e, JYe = ["radius", "angle"], uqt = function() {
        function s(a) {
          this.dimensions = JYe, this.type = "polar", this.cx = 0, this.cy = 0, this._radiusAxis = new oqt(), this._angleAxis = new lqt(), this.axisPointerEnabled = true, this.name = a || "", this._radiusAxis.polar = this._angleAxis.polar = this;
        }
        return s.prototype.containPoint = function(a) {
          var n6 = this.pointToCoord(a);
          return this._radiusAxis.contain(n6[0]) && this._angleAxis.contain(n6[1]);
        }, s.prototype.containData = function(a) {
          return this._radiusAxis.containData(a[0]) && this._angleAxis.containData(a[1]);
        }, s.prototype.getAxis = function(a) {
          var n6 = "_" + a + "Axis";
          return this[n6];
        }, s.prototype.getAxes = function() {
          return [this._radiusAxis, this._angleAxis];
        }, s.prototype.getAxesByScale = function(a) {
          var n6 = [], f6 = this._angleAxis, d4 = this._radiusAxis;
          return f6.scale.type === a && n6.push(f6), d4.scale.type === a && n6.push(d4), n6;
        }, s.prototype.getAngleAxis = function() {
          return this._angleAxis;
        }, s.prototype.getRadiusAxis = function() {
          return this._radiusAxis;
        }, s.prototype.getOtherAxis = function(a) {
          var n6 = this._angleAxis;
          return a === n6 ? this._radiusAxis : n6;
        }, s.prototype.getBaseAxis = function() {
          return this.getAxesByScale("ordinal")[0] || this.getAxesByScale("time")[0] || this.getAngleAxis();
        }, s.prototype.getTooltipAxes = function(a) {
          var n6 = a != null && a !== "auto" ? this.getAxis(a) : this.getBaseAxis();
          return { baseAxes: [n6], otherAxes: [this.getOtherAxis(n6)] };
        }, s.prototype.dataToPoint = function(a, n6) {
          return this.coordToPoint([this._radiusAxis.dataToRadius(a[0], n6), this._angleAxis.dataToAngle(a[1], n6)]);
        }, s.prototype.pointToData = function(a, n6) {
          var f6 = this.pointToCoord(a);
          return [this._radiusAxis.radiusToData(f6[0], n6), this._angleAxis.angleToData(f6[1], n6)];
        }, s.prototype.pointToCoord = function(a) {
          var n6 = a[0] - this.cx, f6 = a[1] - this.cy, d4 = this.getAngleAxis(), y4 = d4.getExtent(), _ = Math.min(y4[0], y4[1]), S = Math.max(y4[0], y4[1]);
          d4.inverse ? _ = S - 360 : S = _ + 360;
          var T = Math.sqrt(n6 * n6 + f6 * f6);
          n6 /= T, f6 /= T;
          for (var E = Math.atan2(-f6, n6) / Math.PI * 180, O = E < _ ? 1 : -1; E < _ || E > S; )
            E += O * 360;
          return [T, E];
        }, s.prototype.coordToPoint = function(a) {
          var n6 = a[0], f6 = a[1] / 180 * Math.PI, d4 = Math.cos(f6) * n6 + this.cx, y4 = -Math.sin(f6) * n6 + this.cy;
          return [d4, y4];
        }, s.prototype.getArea = function() {
          var a = this.getAngleAxis(), n6 = this.getRadiusAxis(), f6 = n6.getExtent().slice();
          f6[0] > f6[1] && f6.reverse();
          var d4 = a.getExtent(), y4 = Math.PI / 180;
          return { cx: this.cx, cy: this.cy, r0: f6[0], r: f6[1], startAngle: -d4[0] * y4, endAngle: -d4[1] * y4, clockwise: a.inverse, contain: function(_, S) {
            var T = _ - this.cx, E = S - this.cy, O = T * T + E * E - 1e-4, R = this.r, V = this.r0;
            return O <= R * R && O >= V * V;
          } };
        }, s.prototype.convertToPixel = function(a, n6, f6) {
          var d4 = QYe(n6);
          return d4 === this ? this.dataToPoint(f6) : null;
        }, s.prototype.convertFromPixel = function(a, n6, f6) {
          var d4 = QYe(n6);
          return d4 === this ? this.pointToData(f6) : null;
        }, s;
      }();
      function QYe(s) {
        var a = s.seriesModel, n6 = s.polarModel;
        return n6 && n6.coordinateSystem || a && a.coordinateSystem;
      }
      var cqt = uqt;
      function fqt(s, a, n6) {
        var f6 = a.get("center"), d4 = n6.getWidth(), y4 = n6.getHeight();
        s.cx = Ia(f6[0], d4), s.cy = Ia(f6[1], y4);
        var _ = s.getRadiusAxis(), S = Math.min(d4, y4) / 2, T = a.get("radius");
        T == null ? T = [0, "100%"] : Di(T) || (T = [0, T]);
        var E = [Ia(T[0], S), Ia(T[1], S)];
        _.inverse ? _.setExtent(E[1], E[0]) : _.setExtent(E[0], E[1]);
      }
      function hqt(s, a) {
        var n6 = this, f6 = n6.getAngleAxis(), d4 = n6.getRadiusAxis();
        if (f6.scale.setExtent(1 / 0, -1 / 0), d4.scale.setExtent(1 / 0, -1 / 0), s.eachSeries(function(S) {
          if (S.coordinateSystem === n6) {
            var T = S.getData();
            gt(foe(T, "radius"), function(E) {
              d4.scale.unionExtentFromData(T, E);
            }), gt(foe(T, "angle"), function(E) {
              f6.scale.unionExtentFromData(T, E);
            });
          }
        }), H7(f6.scale, f6.model), H7(d4.scale, d4.model), f6.type === "category" && !f6.onBand) {
          var y4 = f6.getExtent(), _ = 360 / f6.scale.count();
          f6.inverse ? y4[1] += _ : y4[1] -= _, f6.setExtent(y4[0], y4[1]);
        }
      }
      function pqt(s) {
        return s.mainType === "angleAxis";
      }
      function eKe(s, a) {
        if (s.type = a.get("type"), s.scale = coe(a), s.onBand = a.get("boundaryGap") && s.type === "category", s.inverse = a.get("inverse"), pqt(a)) {
          s.inverse = s.inverse !== a.get("clockwise");
          var n6 = a.get("startAngle");
          s.setExtent(n6, n6 + (s.inverse ? -360 : 360));
        }
        a.axis = s, s.model = a;
      }
      var dqt = { dimensions: JYe, create: function(s, a) {
        var n6 = [];
        return s.eachComponent("polar", function(f6, d4) {
          var y4 = new cqt(d4 + "");
          y4.update = hqt;
          var _ = y4.getRadiusAxis(), S = y4.getAngleAxis(), T = f6.findAxisModel("radiusAxis"), E = f6.findAxisModel("angleAxis");
          eKe(_, T), eKe(S, E), fqt(y4, f6, a), n6.push(y4), f6.coordinateSystem = y4, y4.model = f6;
        }), s.eachSeries(function(f6) {
          if (f6.get("coordinateSystem") === "polar") {
            var d4 = f6.getReferringComponents("polar", ad).models[0];
            f6.coordinateSystem = d4.coordinateSystem;
          }
        }), n6;
      } }, vqt = dqt, gqt = ["axisLine", "axisLabel", "axisTick", "minorTick", "splitLine", "minorSplitLine", "splitArea"];
      function Joe(s, a, n6) {
        a[1] > a[0] && (a = a.slice().reverse());
        var f6 = s.coordToPoint([a[0], n6]), d4 = s.coordToPoint([a[1], n6]);
        return { x1: f6[0], y1: f6[1], x2: d4[0], y2: d4[1] };
      }
      function Qoe(s) {
        var a = s.getRadiusAxis();
        return a.inverse ? 0 : 1;
      }
      function tKe(s) {
        var a = s[0], n6 = s[s.length - 1];
        a && n6 && Math.abs(Math.abs(a.coord - n6.coord) - 360) < 1e-4 && s.pop();
      }
      var yqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.axisPointerClass = "PolarAxisPointer", n6;
        }
        return a.prototype.render = function(n6, f6) {
          if (this.group.removeAll(), !!n6.get("show")) {
            var d4 = n6.axis, y4 = d4.polar, _ = y4.getRadiusAxis().getExtent(), S = d4.getTicksCoords(), T = d4.getMinorTicksCoords(), E = Pi(d4.getViewLabels(), function(O) {
              O = Bo(O);
              var R = d4.scale, V = R.type === "ordinal" ? R.getRawOrdinalNumber(O.tickValue) : O.tickValue;
              return O.coord = d4.dataToCoord(V), O;
            });
            tKe(E), tKe(S), gt(gqt, function(O) {
              n6.get([O, "show"]) && (!d4.scale.isBlank() || O === "axisLine") && mqt[O](this.group, n6, y4, S, T, _, E);
            }, this);
          }
        }, a.type = "angleAxis", a;
      }(ZR), mqt = { axisLine: function(s, a, n6, f6, d4, y4) {
        var _ = a.getModel(["axisLine", "lineStyle"]), S = Qoe(n6), T = S ? 0 : 1, E;
        y4[T] === 0 ? E = new cS({ shape: { cx: n6.cx, cy: n6.cy, r: y4[S] }, style: _.getLineStyle(), z2: 1, silent: true }) : E = new g7({ shape: { cx: n6.cx, cy: n6.cy, r: y4[S], r0: y4[T] }, style: _.getLineStyle(), z2: 1, silent: true }), E.style.fill = null, s.add(E);
      }, axisTick: function(s, a, n6, f6, d4, y4) {
        var _ = a.getModel("axisTick"), S = (_.get("inside") ? -1 : 1) * _.get("length"), T = y4[Qoe(n6)], E = Pi(f6, function(O) {
          return new Jv({ shape: Joe(n6, [T, T + S], O.coord) });
        });
        s.add(en(E, { style: zo(_.getModel("lineStyle").getLineStyle(), { stroke: a.get(["axisLine", "lineStyle", "color"]) }) }));
      }, minorTick: function(s, a, n6, f6, d4, y4) {
        if (d4.length) {
          for (var _ = a.getModel("axisTick"), S = a.getModel("minorTick"), T = (_.get("inside") ? -1 : 1) * S.get("length"), E = y4[Qoe(n6)], O = [], R = 0; R < d4.length; R++)
            for (var V = 0; V < d4[R].length; V++)
              O.push(new Jv({ shape: Joe(n6, [E, E + T], d4[R][V].coord) }));
          s.add(en(O, { style: zo(S.getModel("lineStyle").getLineStyle(), zo(_.getLineStyle(), { stroke: a.get(["axisLine", "lineStyle", "color"]) })) }));
        }
      }, axisLabel: function(s, a, n6, f6, d4, y4, _) {
        var S = a.getCategories(true), T = a.getModel("axisLabel"), E = T.get("margin"), O = a.get("triggerEvent");
        gt(_, function(R, V) {
          var z3 = T, H = R.tickValue, Z = y4[Qoe(n6)], ee = n6.coordToPoint([Z + E, R.coord]), oe = n6.cx, fe = n6.cy, _e = Math.abs(ee[0] - oe) / Z < 0.3 ? "center" : ee[0] > oe ? "left" : "right", pe = Math.abs(ee[1] - fe) / Z < 0.3 ? "middle" : ee[1] > fe ? "top" : "bottom";
          if (S && S[H]) {
            var Ve = S[H];
            Qo(Ve) && Ve.textStyle && (z3 = new Sh(Ve.textStyle, T, T.ecModel));
          }
          var Le = new ju({ silent: NE.isLabelSilent(a), style: Zd(z3, { x: ee[0], y: ee[1], fill: z3.getTextColor() || a.get(["axisLine", "lineStyle", "color"]), text: R.formattedLabel, align: _e, verticalAlign: pe }) });
          if (s.add(Le), O) {
            var je = NE.makeAxisEventDataBase(a);
            je.targetType = "axisLabel", je.value = R.rawLabel, qo(Le).eventData = je;
          }
        }, this);
      }, splitLine: function(s, a, n6, f6, d4, y4) {
        var _ = a.getModel("splitLine"), S = _.getModel("lineStyle"), T = S.get("color"), E = 0;
        T = T instanceof Array ? T : [T];
        for (var O = [], R = 0; R < f6.length; R++) {
          var V = E++ % T.length;
          O[V] = O[V] || [], O[V].push(new Jv({ shape: Joe(n6, y4, f6[R].coord) }));
        }
        for (var R = 0; R < O.length; R++)
          s.add(en(O[R], { style: zo({ stroke: T[R % T.length] }, S.getLineStyle()), silent: true, z: a.get("z") }));
      }, minorSplitLine: function(s, a, n6, f6, d4, y4) {
        if (d4.length) {
          for (var _ = a.getModel("minorSplitLine"), S = _.getModel("lineStyle"), T = [], E = 0; E < d4.length; E++)
            for (var O = 0; O < d4[E].length; O++)
              T.push(new Jv({ shape: Joe(n6, y4, d4[E][O].coord) }));
          s.add(en(T, { style: S.getLineStyle(), silent: true, z: a.get("z") }));
        }
      }, splitArea: function(s, a, n6, f6, d4, y4) {
        if (f6.length) {
          var _ = a.getModel("splitArea"), S = _.getModel("areaStyle"), T = S.get("color"), E = 0;
          T = T instanceof Array ? T : [T];
          for (var O = [], R = Math.PI / 180, V = -f6[0].coord * R, z3 = Math.min(y4[0], y4[1]), H = Math.max(y4[0], y4[1]), Z = a.get("clockwise"), ee = 1, oe = f6.length; ee <= oe; ee++) {
            var fe = ee === oe ? f6[0].coord : f6[ee].coord, _e = E++ % T.length;
            O[_e] = O[_e] || [], O[_e].push(new Bm({ shape: { cx: n6.cx, cy: n6.cy, r0: z3, r: H, startAngle: V, endAngle: -fe * R, clockwise: Z }, silent: true })), V = -fe * R;
          }
          for (var ee = 0; ee < O.length; ee++)
            s.add(en(O[ee], { style: zo({ fill: T[ee % T.length] }, S.getAreaStyle()), silent: true }));
        }
      } }, bqt = yqt, _qt = ["axisLine", "axisTickLabel", "axisName"], xqt = ["splitLine", "splitArea", "minorSplitLine"], wqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.axisPointerClass = "PolarAxisPointer", n6;
        }
        return a.prototype.render = function(n6, f6) {
          if (this.group.removeAll(), !!n6.get("show")) {
            var d4 = this._axisGroup, y4 = this._axisGroup = new fs();
            this.group.add(y4);
            var _ = n6.axis, S = _.polar, T = S.getAngleAxis(), E = _.getTicksCoords(), O = _.getMinorTicksCoords(), R = T.getExtent()[0], V = _.getExtent(), z3 = Cqt(S, n6, R), H = new NE(n6, z3);
            gt(_qt, H.add, H), y4.add(H.getGroup()), $l(d4, y4, n6), gt(xqt, function(Z) {
              n6.get([Z, "show"]) && !_.scale.isBlank() && Sqt[Z](this.group, n6, S, R, V, E, O);
            }, this);
          }
        }, a.type = "radiusAxis", a;
      }(ZR), Sqt = { splitLine: function(s, a, n6, f6, d4, y4) {
        var _ = a.getModel("splitLine"), S = _.getModel("lineStyle"), T = S.get("color"), E = 0;
        T = T instanceof Array ? T : [T];
        for (var O = [], R = 0; R < y4.length; R++) {
          var V = E++ % T.length;
          O[V] = O[V] || [], O[V].push(new cS({ shape: { cx: n6.cx, cy: n6.cy, r: y4[R].coord } }));
        }
        for (var R = 0; R < O.length; R++)
          s.add(en(O[R], { style: zo({ stroke: T[R % T.length], fill: null }, S.getLineStyle()), silent: true }));
      }, minorSplitLine: function(s, a, n6, f6, d4, y4, _) {
        if (_.length) {
          for (var S = a.getModel("minorSplitLine"), T = S.getModel("lineStyle"), E = [], O = 0; O < _.length; O++)
            for (var R = 0; R < _[O].length; R++)
              E.push(new cS({ shape: { cx: n6.cx, cy: n6.cy, r: _[O][R].coord } }));
          s.add(en(E, { style: zo({ fill: null }, T.getLineStyle()), silent: true }));
        }
      }, splitArea: function(s, a, n6, f6, d4, y4) {
        if (y4.length) {
          var _ = a.getModel("splitArea"), S = _.getModel("areaStyle"), T = S.get("color"), E = 0;
          T = T instanceof Array ? T : [T];
          for (var O = [], R = y4[0].coord, V = 1; V < y4.length; V++) {
            var z3 = E++ % T.length;
            O[z3] = O[z3] || [], O[z3].push(new Bm({ shape: { cx: n6.cx, cy: n6.cy, r0: R, r: y4[V].coord, startAngle: 0, endAngle: Math.PI * 2 }, silent: true })), R = y4[V].coord;
          }
          for (var V = 0; V < O.length; V++)
            s.add(en(O[V], { style: zo({ fill: T[V % T.length] }, S.getAreaStyle()), silent: true }));
        }
      } };
      function Cqt(s, a, n6) {
        return { position: [s.cx, s.cy], rotation: n6 / 180 * Math.PI, labelDirection: -1, tickDirection: -1, nameDirection: 1, labelRotate: a.getModel("axisLabel").get("rotate"), z2: 1 };
      }
      var Mqt = wqt;
      function nKe(s) {
        return s.get("stack") || "__ec_stack_" + s.seriesIndex;
      }
      function rKe(s, a) {
        return a.dim + s.model.componentIndex;
      }
      function Tqt(s, a, n6) {
        var f6 = {}, d4 = Aqt(tf(a.getSeriesByType(s), function(y4) {
          return !a.isSeriesFiltered(y4) && y4.coordinateSystem && y4.coordinateSystem.type === "polar";
        }));
        a.eachSeriesByType(s, function(y4) {
          if (y4.coordinateSystem.type === "polar") {
            var _ = y4.getData(), S = y4.coordinateSystem, T = S.getBaseAxis(), E = rKe(S, T), O = nKe(y4), R = d4[E][O], V = R.offset, z3 = R.width, H = S.getOtherAxis(T), Z = y4.coordinateSystem.cx, ee = y4.coordinateSystem.cy, oe = y4.get("barMinHeight") || 0, fe = y4.get("barMinAngle") || 0;
            f6[O] = f6[O] || [];
            for (var _e = _.mapDimension(H.dim), pe = _.mapDimension(T.dim), Ve = t32(_, _e), Le = T.dim !== "radius" || !y4.get("roundCap", true), je = H.dataToCoord(0), Xe = 0, Ye = _.count(); Xe < Ye; Xe++) {
              var rt2 = _.get(_e, Xe), ut = _.get(pe, Xe), wt = rt2 >= 0 ? "p" : "n", dt = je;
              Ve && (f6[O][ut] || (f6[O][ut] = { p: je, n: je }), dt = f6[O][ut][wt]);
              var Gt = void 0, Qt = void 0, Nt = void 0, er = void 0;
              if (H.dim === "radius") {
                var un = H.dataToCoord(rt2) - je, pn = T.dataToCoord(ut);
                Math.abs(un) < oe && (un = (un < 0 ? -1 : 1) * oe), Gt = dt, Qt = dt + un, Nt = pn - V, er = Nt - z3, Ve && (f6[O][ut][wt] = Qt);
              } else {
                var On = H.dataToCoord(rt2, Le) - je, fr = T.dataToCoord(ut);
                Math.abs(On) < fe && (On = (On < 0 ? -1 : 1) * fe), Gt = fr + V, Qt = Gt + z3, Nt = dt, er = dt + On, Ve && (f6[O][ut][wt] = er);
              }
              _.setItemLayout(Xe, { cx: Z, cy: ee, r0: Gt, r: Qt, startAngle: -Nt * Math.PI / 180, endAngle: -er * Math.PI / 180, clockwise: Nt >= er });
            }
          }
        });
      }
      function Aqt(s) {
        var a = {};
        gt(s, function(f6, d4) {
          var y4 = f6.getData(), _ = f6.coordinateSystem, S = _.getBaseAxis(), T = rKe(_, S), E = S.getExtent(), O = S.type === "category" ? S.getBandWidth() : Math.abs(E[1] - E[0]) / y4.count(), R = a[T] || { bandWidth: O, remainedWidth: O, autoWidthCount: 0, categoryGap: "20%", gap: "30%", stacks: {} }, V = R.stacks;
          a[T] = R;
          var z3 = nKe(f6);
          V[z3] || R.autoWidthCount++, V[z3] = V[z3] || { width: 0, maxWidth: 0 };
          var H = Ia(f6.get("barWidth"), O), Z = Ia(f6.get("barMaxWidth"), O), ee = f6.get("barGap"), oe = f6.get("barCategoryGap");
          H && !V[z3].width && (H = Math.min(R.remainedWidth, H), V[z3].width = H, R.remainedWidth -= H), Z && (V[z3].maxWidth = Z), ee != null && (R.gap = ee), oe != null && (R.categoryGap = oe);
        });
        var n6 = {};
        return gt(a, function(f6, d4) {
          n6[d4] = {};
          var y4 = f6.stacks, _ = f6.bandWidth, S = Ia(f6.categoryGap, _), T = Ia(f6.gap, 1), E = f6.remainedWidth, O = f6.autoWidthCount, R = (E - S) / (O + (O - 1) * T);
          R = Math.max(R, 0), gt(y4, function(Z, ee) {
            var oe = Z.maxWidth;
            oe && oe < R && (oe = Math.min(oe, E), Z.width && (oe = Math.min(oe, Z.width)), E -= oe, Z.width = oe, O--);
          }), R = (E - S) / (O + (O - 1) * T), R = Math.max(R, 0);
          var V = 0, z3;
          gt(y4, function(Z, ee) {
            Z.width || (Z.width = R), z3 = Z, V += Z.width * (1 + T);
          }), z3 && (V -= z3.width * T);
          var H = -V / 2;
          gt(y4, function(Z, ee) {
            n6[d4][ee] = n6[d4][ee] || { offset: H, width: Z.width }, H += Z.width * (1 + T);
          });
        }), n6;
      }
      var Iqt = { startAngle: 90, clockwise: true, splitNumber: 12, axisLabel: { rotate: 0 } }, Eqt = { splitNumber: 5 }, Dqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "polar", a;
      }(sd);
      function kqt(s) {
        Il(fX), ZR.registerAxisPointerClass("PolarAxisPointer", tqt), s.registerCoordinateSystem("polar", vqt), s.registerComponentModel(rqt), s.registerComponentView(Dqt), X7(s, "angle", iqt, Iqt), X7(s, "radius", aqt, Eqt), s.registerComponentView(bqt), s.registerComponentView(Mqt), s.registerLayout(ks(Tqt, "bar"));
      }
      function K2e(s, a) {
        a = a || {};
        var n6 = s.coordinateSystem, f6 = s.axis, d4 = {}, y4 = f6.position, _ = f6.orient, S = n6.getRect(), T = [S.x, S.x + S.width, S.y, S.y + S.height], E = { horizontal: { top: T[2], bottom: T[3] }, vertical: { left: T[0], right: T[1] } };
        d4.position = [_ === "vertical" ? E.vertical[y4] : T[0], _ === "horizontal" ? E.horizontal[y4] : T[3]];
        var O = { horizontal: 0, vertical: 1 };
        d4.rotation = Math.PI / 2 * O[_];
        var R = { top: -1, bottom: 1, right: 1, left: -1 };
        d4.labelDirection = d4.tickDirection = d4.nameDirection = R[y4], s.get(["axisTick", "inside"]) && (d4.tickDirection = -d4.tickDirection), $v(a.labelInside, s.get(["axisLabel", "inside"])) && (d4.labelDirection = -d4.labelDirection);
        var V = a.rotate;
        return V == null && (V = s.get(["axisLabel", "rotate"])), d4.labelRotation = y4 === "top" ? -V : V, d4.z2 = 1, d4;
      }
      var Oqt = ["axisLine", "axisTickLabel", "axisName"], Pqt = ["splitArea", "splitLine"], Lqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.axisPointerClass = "SingleAxisPointer", n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          var _ = this.group;
          _.removeAll();
          var S = this._axisGroup;
          this._axisGroup = new fs();
          var T = K2e(n6), E = new NE(n6, T);
          gt(Oqt, E.add, E), _.add(this._axisGroup), _.add(E.getGroup()), gt(Pqt, function(O) {
            n6.get([O, "show"]) && Rqt[O](this, this.group, this._axisGroup, n6);
          }, this), $l(S, this._axisGroup, n6), s.prototype.render.call(this, n6, f6, d4, y4);
        }, a.prototype.remove = function() {
          wqe(this);
        }, a.type = "singleAxis", a;
      }(ZR), Rqt = { splitLine: function(s, a, n6, f6) {
        var d4 = f6.axis;
        if (!d4.scale.isBlank()) {
          var y4 = f6.getModel("splitLine"), _ = y4.getModel("lineStyle"), S = _.get("color");
          S = S instanceof Array ? S : [S];
          for (var T = f6.coordinateSystem.getRect(), E = d4.isHorizontal(), O = [], R = 0, V = d4.getTicksCoords({ tickModel: y4 }), z3 = [], H = [], Z = 0; Z < V.length; ++Z) {
            var ee = d4.toGlobalCoord(V[Z].coord);
            E ? (z3[0] = ee, z3[1] = T.y, H[0] = ee, H[1] = T.y + T.height) : (z3[0] = T.x, z3[1] = ee, H[0] = T.x + T.width, H[1] = ee);
            var oe = R++ % S.length;
            O[oe] = O[oe] || [], O[oe].push(new Jv({ subPixelOptimize: true, shape: { x1: z3[0], y1: z3[1], x2: H[0], y2: H[1] }, silent: true }));
          }
          for (var fe = _.getLineStyle(["color"]), Z = 0; Z < O.length; ++Z)
            a.add(en(O[Z], { style: zo({ stroke: S[Z % S.length] }, fe), silent: true }));
        }
      }, splitArea: function(s, a, n6, f6) {
        xqe(s, n6, f6, f6);
      } }, Nqt = Lqt, iKe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.getCoordSysModel = function() {
          return this;
        }, a.type = "singleAxis", a.layoutMode = "box", a.defaultOption = { left: "5%", top: "5%", right: "5%", bottom: "5%", type: "value", position: "bottom", orient: "horizontal", axisLine: { show: true, lineStyle: { width: 1, type: "solid" } }, tooltip: { show: true }, axisTick: { show: true, length: 6, lineStyle: { width: 1 } }, axisLabel: { show: true, interval: "auto" }, splitLine: { show: true, lineStyle: { type: "dashed", opacity: 0.2 } } }, a;
      }(oc);
      nd(iKe, R$.prototype);
      var Z2e = iKe, Fqt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4, _) {
          var S = s.call(this, n6, f6, d4) || this;
          return S.type = y4 || "value", S.position = _ || "bottom", S;
        }
        return a.prototype.isHorizontal = function() {
          var n6 = this.position;
          return n6 === "top" || n6 === "bottom";
        }, a.prototype.pointToData = function(n6, f6) {
          return this.coordinateSystem.pointToData(n6)[0];
        }, a;
      }(xC), Vqt = Fqt, aKe = ["single"], Bqt = function() {
        function s(a, n6, f6) {
          this.type = "single", this.dimension = "single", this.dimensions = aKe, this.axisPointerEnabled = true, this.model = a, this._init(a, n6, f6);
        }
        return s.prototype._init = function(a, n6, f6) {
          var d4 = this.dimension, y4 = new Vqt(d4, coe(a), [0, 0], a.get("type"), a.get("position")), _ = y4.type === "category";
          y4.onBand = _ && a.get("boundaryGap"), y4.inverse = a.get("inverse"), y4.orient = a.get("orient"), a.axis = y4, y4.model = a, y4.coordinateSystem = this, this._axis = y4;
        }, s.prototype.update = function(a, n6) {
          a.eachSeries(function(f6) {
            if (f6.coordinateSystem === this) {
              var d4 = f6.getData();
              gt(d4.mapDimensionsAll(this.dimension), function(y4) {
                this._axis.scale.unionExtentFromData(d4, y4);
              }, this), H7(this._axis.scale, this._axis.model);
            }
          }, this);
        }, s.prototype.resize = function(a, n6) {
          this._rect = Qv({ left: a.get("left"), top: a.get("top"), right: a.get("right"), bottom: a.get("bottom"), width: a.get("width"), height: a.get("height") }, { width: n6.getWidth(), height: n6.getHeight() }), this._adjustAxis();
        }, s.prototype.getRect = function() {
          return this._rect;
        }, s.prototype._adjustAxis = function() {
          var a = this._rect, n6 = this._axis, f6 = n6.isHorizontal(), d4 = f6 ? [0, a.width] : [0, a.height], y4 = n6.reverse ? 1 : 0;
          n6.setExtent(d4[y4], d4[1 - y4]), this._updateAxisTransform(n6, f6 ? a.x : a.y);
        }, s.prototype._updateAxisTransform = function(a, n6) {
          var f6 = a.getExtent(), d4 = f6[0] + f6[1], y4 = a.isHorizontal();
          a.toGlobalCoord = y4 ? function(_) {
            return _ + n6;
          } : function(_) {
            return d4 - _ + n6;
          }, a.toLocalCoord = y4 ? function(_) {
            return _ - n6;
          } : function(_) {
            return d4 - _ + n6;
          };
        }, s.prototype.getAxis = function() {
          return this._axis;
        }, s.prototype.getBaseAxis = function() {
          return this._axis;
        }, s.prototype.getAxes = function() {
          return [this._axis];
        }, s.prototype.getTooltipAxes = function() {
          return { baseAxes: [this.getAxis()], otherAxes: [] };
        }, s.prototype.containPoint = function(a) {
          var n6 = this.getRect(), f6 = this.getAxis(), d4 = f6.orient;
          return d4 === "horizontal" ? f6.contain(f6.toLocalCoord(a[0])) && a[1] >= n6.y && a[1] <= n6.y + n6.height : f6.contain(f6.toLocalCoord(a[1])) && a[0] >= n6.y && a[0] <= n6.y + n6.height;
        }, s.prototype.pointToData = function(a) {
          var n6 = this.getAxis();
          return [n6.coordToData(n6.toLocalCoord(a[n6.orient === "horizontal" ? 0 : 1]))];
        }, s.prototype.dataToPoint = function(a) {
          var n6 = this.getAxis(), f6 = this.getRect(), d4 = [], y4 = n6.orient === "horizontal" ? 0 : 1;
          return a instanceof Array && (a = a[0]), d4[y4] = n6.toGlobalCoord(n6.dataToCoord(+a)), d4[1 - y4] = y4 === 0 ? f6.y + f6.height / 2 : f6.x + f6.width / 2, d4;
        }, s.prototype.convertToPixel = function(a, n6, f6) {
          var d4 = oKe(n6);
          return d4 === this ? this.dataToPoint(f6) : null;
        }, s.prototype.convertFromPixel = function(a, n6, f6) {
          var d4 = oKe(n6);
          return d4 === this ? this.pointToData(f6) : null;
        }, s;
      }();
      function oKe(s) {
        var a = s.seriesModel, n6 = s.singleAxisModel;
        return n6 && n6.coordinateSystem || a && a.coordinateSystem;
      }
      function zqt(s, a) {
        var n6 = [];
        return s.eachComponent("singleAxis", function(f6, d4) {
          var y4 = new Bqt(f6, s, a);
          y4.name = "single_" + d4, y4.resize(f6, a), f6.coordinateSystem = y4, n6.push(y4);
        }), s.eachSeries(function(f6) {
          if (f6.get("coordinateSystem") === "singleAxis") {
            var d4 = f6.getReferringComponents("singleAxis", ad).models[0];
            f6.coordinateSystem = d4 && d4.coordinateSystem;
          }
        }), n6;
      }
      var jqt = { create: zqt, dimensions: aKe }, Gqt = jqt, sKe = ["x", "y"], Hqt = ["width", "height"], Wqt = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.makeElOption = function(n6, f6, d4, y4, _) {
          var S = d4.axis, T = S.coordinateSystem, E = J2e(T, 1 - ese(S)), O = T.dataToPoint(f6)[0], R = y4.get("type");
          if (R && R !== "none") {
            var V = H2e(y4), z3 = Uqt[R](S, O, E);
            z3.style = V, n6.graphicKey = z3.type, n6.pointer = z3;
          }
          var H = K2e(d4);
          jYe(f6, n6, H, d4, y4, _);
        }, a.prototype.getHandleTransform = function(n6, f6, d4) {
          var y4 = K2e(f6, { labelInside: false });
          y4.labelMargin = d4.get(["handle", "margin"]);
          var _ = W2e(f6.axis, n6, y4);
          return { x: _[0], y: _[1], rotation: y4.rotation + (y4.labelDirection < 0 ? Math.PI : 0) };
        }, a.prototype.updateHandleTransform = function(n6, f6, d4, y4) {
          var _ = d4.axis, S = _.coordinateSystem, T = ese(_), E = J2e(S, T), O = [n6.x, n6.y];
          O[T] += f6[T], O[T] = Math.min(E[1], O[T]), O[T] = Math.max(E[0], O[T]);
          var R = J2e(S, 1 - T), V = (R[1] + R[0]) / 2, z3 = [V, V];
          return z3[T] = O[T], { x: O[0], y: O[1], rotation: n6.rotation, cursorPoint: z3, tooltipOption: { verticalAlign: "middle" } };
        }, a;
      }(G2e), Uqt = { line: function(s, a, n6) {
        var f6 = U2e([a, n6[0]], [a, n6[1]], ese(s));
        return { type: "Line", subPixelOptimize: true, shape: f6 };
      }, shadow: function(s, a, n6) {
        var f6 = s.getBandWidth(), d4 = n6[1] - n6[0];
        return { type: "Rect", shape: GYe([a - f6 / 2, n6[0]], [f6, d4], ese(s)) };
      } };
      function ese(s) {
        return s.isHorizontal() ? 0 : 1;
      }
      function J2e(s, a) {
        var n6 = s.getRect();
        return [n6[sKe[a]], n6[sKe[a]] + n6[Hqt[a]]];
      }
      var qqt = Wqt, $qt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "single", a;
      }(sd);
      function Xqt(s) {
        Il(fX), ZR.registerAxisPointerClass("SingleAxisPointer", qqt), s.registerComponentView($qt), s.registerComponentView(Nqt), s.registerComponentModel(Z2e), X7(s, "single", Z2e, Z2e.defaultOption), s.registerCoordinateSystem("single", Gqt);
      }
      var Yqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          var y4 = E7(n6);
          s.prototype.init.apply(this, arguments), lKe(n6, y4);
        }, a.prototype.mergeOption = function(n6) {
          s.prototype.mergeOption.apply(this, arguments), lKe(this.option, n6);
        }, a.prototype.getCellSize = function() {
          return this.option.cellSize;
        }, a.type = "calendar", a.defaultOption = { z: 2, left: 80, top: 60, cellSize: 20, orient: "horizontal", splitLine: { show: true, lineStyle: { color: "#000", width: 1, type: "solid" } }, itemStyle: { color: "#fff", borderWidth: 1, borderColor: "#ccc" }, dayLabel: { show: true, firstDay: 0, position: "start", margin: "50%", color: "#000" }, monthLabel: { show: true, position: "start", margin: 5, align: "center", formatter: null, color: "#000" }, yearLabel: { show: true, position: null, margin: 30, formatter: null, color: "#ccc", fontFamily: "sans-serif", fontWeight: "bolder", fontSize: 20 } }, a;
      }(oc);
      function lKe(s, a) {
        var n6 = s.cellSize, f6;
        Di(n6) ? f6 = n6 : f6 = s.cellSize = [n6, n6], f6.length === 1 && (f6[1] = f6[0]);
        var d4 = Pi([0, 1], function(y4) {
          return t4t(a, y4) && (f6[y4] = "auto"), f6[y4] != null && f6[y4] !== "auto";
        });
        Yk(s, a, { type: "box", ignoreSize: d4 });
      }
      var Kqt = Yqt, Zqt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4 = this.group;
          y4.removeAll();
          var _ = n6.coordinateSystem, S = _.getRangeInfo(), T = _.getOrient(), E = f6.getLocaleModel();
          this._renderDayRect(n6, S, y4), this._renderLines(n6, S, T, y4), this._renderYearText(n6, S, T, y4), this._renderMonthText(n6, E, T, y4), this._renderWeekText(n6, E, S, T, y4);
        }, a.prototype._renderDayRect = function(n6, f6, d4) {
          for (var y4 = n6.coordinateSystem, _ = n6.getModel("itemStyle").getItemStyle(), S = y4.getCellWidth(), T = y4.getCellHeight(), E = f6.start.time; E <= f6.end.time; E = y4.getNextNDay(E, 1).time) {
            var O = y4.dataToRect([E], false).tl, R = new xu({ shape: { x: O[0], y: O[1], width: S, height: T }, cursor: "default", style: _ });
            d4.add(R);
          }
        }, a.prototype._renderLines = function(n6, f6, d4, y4) {
          var _ = this, S = n6.coordinateSystem, T = n6.getModel(["splitLine", "lineStyle"]).getLineStyle(), E = n6.get(["splitLine", "show"]), O = T.lineWidth;
          this._tlpoints = [], this._blpoints = [], this._firstDayOfMonth = [], this._firstDayPoints = [];
          for (var R = f6.start, V = 0; R.time <= f6.end.time; V++) {
            H(R.formatedDate), V === 0 && (R = S.getDateInfo(f6.start.y + "-" + f6.start.m));
            var z3 = R.date;
            z3.setMonth(z3.getMonth() + 1), R = S.getDateInfo(z3);
          }
          H(S.getNextNDay(f6.end.time, 1).formatedDate);
          function H(Z) {
            _._firstDayOfMonth.push(S.getDateInfo(Z)), _._firstDayPoints.push(S.dataToRect([Z], false).tl);
            var ee = _._getLinePointsOfOneWeek(n6, Z, d4);
            _._tlpoints.push(ee[0]), _._blpoints.push(ee[ee.length - 1]), E && _._drawSplitline(ee, T, y4);
          }
          E && this._drawSplitline(_._getEdgesPoints(_._tlpoints, O, d4), T, y4), E && this._drawSplitline(_._getEdgesPoints(_._blpoints, O, d4), T, y4);
        }, a.prototype._getEdgesPoints = function(n6, f6, d4) {
          var y4 = [n6[0].slice(), n6[n6.length - 1].slice()], _ = d4 === "horizontal" ? 0 : 1;
          return y4[0][_] = y4[0][_] - f6 / 2, y4[1][_] = y4[1][_] + f6 / 2, y4;
        }, a.prototype._drawSplitline = function(n6, f6, d4) {
          var y4 = new zm({ z2: 20, shape: { points: n6 }, style: f6 });
          d4.add(y4);
        }, a.prototype._getLinePointsOfOneWeek = function(n6, f6, d4) {
          for (var y4 = n6.coordinateSystem, _ = y4.getDateInfo(f6), S = [], T = 0; T < 7; T++) {
            var E = y4.getNextNDay(_.time, T), O = y4.dataToRect([E.time], false);
            S[2 * E.day] = O.tl, S[2 * E.day + 1] = O[d4 === "horizontal" ? "bl" : "tr"];
          }
          return S;
        }, a.prototype._formatterLabel = function(n6, f6) {
          return Wa(n6) && n6 ? JRt(n6, f6) : jo(n6) ? n6(f6) : f6.nameMap;
        }, a.prototype._yearTextPositionControl = function(n6, f6, d4, y4, _) {
          var S = f6[0], T = f6[1], E = ["center", "bottom"];
          y4 === "bottom" ? (T += _, E = ["center", "top"]) : y4 === "left" ? S -= _ : y4 === "right" ? (S += _, E = ["center", "top"]) : T -= _;
          var O = 0;
          return (y4 === "left" || y4 === "right") && (O = Math.PI / 2), { rotation: O, x: S, y: T, style: { align: E[0], verticalAlign: E[1] } };
        }, a.prototype._renderYearText = function(n6, f6, d4, y4) {
          var _ = n6.getModel("yearLabel");
          if (_.get("show")) {
            var S = _.get("margin"), T = _.get("position");
            T || (T = d4 !== "horizontal" ? "top" : "left");
            var E = [this._tlpoints[this._tlpoints.length - 1], this._blpoints[0]], O = (E[0][0] + E[1][0]) / 2, R = (E[0][1] + E[1][1]) / 2, V = d4 === "horizontal" ? 0 : 1, z3 = { top: [O, E[V][1]], bottom: [O, E[1 - V][1]], left: [E[1 - V][0], R], right: [E[V][0], R] }, H = f6.start.y;
            +f6.end.y > +f6.start.y && (H = H + "-" + f6.end.y);
            var Z = _.get("formatter"), ee = { start: f6.start.y, end: f6.end.y, nameMap: H }, oe = this._formatterLabel(Z, ee), fe = new ju({ z2: 30, style: Zd(_, { text: oe }) });
            fe.attr(this._yearTextPositionControl(fe, z3[T], d4, T, S)), y4.add(fe);
          }
        }, a.prototype._monthTextPositionControl = function(n6, f6, d4, y4, _) {
          var S = "left", T = "top", E = n6[0], O = n6[1];
          return d4 === "horizontal" ? (O = O + _, f6 && (S = "center"), y4 === "start" && (T = "bottom")) : (E = E + _, f6 && (T = "middle"), y4 === "start" && (S = "right")), { x: E, y: O, align: S, verticalAlign: T };
        }, a.prototype._renderMonthText = function(n6, f6, d4, y4) {
          var _ = n6.getModel("monthLabel");
          if (_.get("show")) {
            var S = _.get("nameMap"), T = _.get("margin"), E = _.get("position"), O = _.get("align"), R = [this._tlpoints, this._blpoints];
            (!S || Wa(S)) && (S && (f6 = Txe(S) || f6), S = f6.get(["time", "monthAbbr"]) || []);
            var V = E === "start" ? 0 : 1, z3 = d4 === "horizontal" ? 0 : 1;
            T = E === "start" ? -T : T;
            for (var H = O === "center", Z = 0; Z < R[V].length - 1; Z++) {
              var ee = R[V][Z].slice(), oe = this._firstDayOfMonth[Z];
              if (H) {
                var fe = this._firstDayPoints[Z];
                ee[z3] = (fe[z3] + R[0][Z + 1][z3]) / 2;
              }
              var _e = _.get("formatter"), pe = S[+oe.m - 1], Ve = { yyyy: oe.y, yy: (oe.y + "").slice(2), MM: oe.m, M: +oe.m, nameMap: pe }, Le = this._formatterLabel(_e, Ve), je = new ju({ z2: 30, style: ei(Zd(_, { text: Le }), this._monthTextPositionControl(ee, H, d4, E, T)) });
              y4.add(je);
            }
          }
        }, a.prototype._weekTextPositionControl = function(n6, f6, d4, y4, _) {
          var S = "center", T = "middle", E = n6[0], O = n6[1], R = d4 === "start";
          return f6 === "horizontal" ? (E = E + y4 + (R ? 1 : -1) * _[0] / 2, S = R ? "right" : "left") : (O = O + y4 + (R ? 1 : -1) * _[1] / 2, T = R ? "bottom" : "top"), { x: E, y: O, align: S, verticalAlign: T };
        }, a.prototype._renderWeekText = function(n6, f6, d4, y4, _) {
          var S = n6.getModel("dayLabel");
          if (S.get("show")) {
            var T = n6.coordinateSystem, E = S.get("position"), O = S.get("nameMap"), R = S.get("margin"), V = T.getFirstDayOfWeek();
            if (!O || Wa(O)) {
              O && (f6 = Txe(O) || f6);
              var z3 = f6.get(["time", "dayOfWeekShort"]);
              O = z3 || Pi(f6.get(["time", "dayOfWeekAbbr"]), function(Ve) {
                return Ve[0];
              });
            }
            var H = T.getNextNDay(d4.end.time, 7 - d4.lweek).time, Z = [T.getCellWidth(), T.getCellHeight()];
            R = Ia(R, Math.min(Z[1], Z[0])), E === "start" && (H = T.getNextNDay(d4.start.time, -(7 + d4.fweek)).time, R = -R);
            for (var ee = 0; ee < 7; ee++) {
              var oe = T.getNextNDay(H, ee), fe = T.dataToRect([oe.time], false).center, _e = ee;
              _e = Math.abs((ee + V) % 7);
              var pe = new ju({ z2: 30, style: ei(Zd(S, { text: O[_e] }), this._weekTextPositionControl(fe, y4, E, R, Z)) });
              _.add(pe);
            }
          }
        }, a.type = "calendar", a;
      }(sd), Jqt = Zqt, Q2e = 864e5, Qqt = function() {
        function s(a, n6, f6) {
          this.type = "calendar", this.dimensions = s.dimensions, this.getDimensionsInfo = s.getDimensionsInfo, this._model = a;
        }
        return s.getDimensionsInfo = function() {
          return [{ name: "time", type: "time" }, "value"];
        }, s.prototype.getRangeInfo = function() {
          return this._rangeInfo;
        }, s.prototype.getModel = function() {
          return this._model;
        }, s.prototype.getRect = function() {
          return this._rect;
        }, s.prototype.getCellWidth = function() {
          return this._sw;
        }, s.prototype.getCellHeight = function() {
          return this._sh;
        }, s.prototype.getOrient = function() {
          return this._orient;
        }, s.prototype.getFirstDayOfWeek = function() {
          return this._firstDayOfWeek;
        }, s.prototype.getDateInfo = function(a) {
          a = nx(a);
          var n6 = a.getFullYear(), f6 = a.getMonth() + 1, d4 = f6 < 10 ? "0" + f6 : "" + f6, y4 = a.getDate(), _ = y4 < 10 ? "0" + y4 : "" + y4, S = a.getDay();
          return S = Math.abs((S + 7 - this.getFirstDayOfWeek()) % 7), { y: n6 + "", m: d4, d: _, day: S, time: a.getTime(), formatedDate: n6 + "-" + d4 + "-" + _, date: a };
        }, s.prototype.getNextNDay = function(a, n6) {
          return n6 = n6 || 0, n6 === 0 ? this.getDateInfo(a) : (a = new Date(this.getDateInfo(a).time), a.setDate(a.getDate() + n6), this.getDateInfo(a));
        }, s.prototype.update = function(a, n6) {
          this._firstDayOfWeek = +this._model.getModel("dayLabel").get("firstDay"), this._orient = this._model.get("orient"), this._lineWidth = this._model.getModel("itemStyle").getItemStyle().lineWidth || 0, this._rangeInfo = this._getRangeInfo(this._initRangeOption());
          var f6 = this._rangeInfo.weeks || 1, d4 = ["width", "height"], y4 = this._model.getCellSize().slice(), _ = this._model.getBoxLayoutParams(), S = this._orient === "horizontal" ? [f6, 7] : [7, f6];
          gt([0, 1], function(R) {
            O(y4, R) && (_[d4[R]] = y4[R] * S[R]);
          });
          var T = { width: n6.getWidth(), height: n6.getHeight() }, E = this._rect = Qv(_, T);
          gt([0, 1], function(R) {
            O(y4, R) || (y4[R] = E[d4[R]] / S[R]);
          });
          function O(R, V) {
            return R[V] != null && R[V] !== "auto";
          }
          this._sw = y4[0], this._sh = y4[1];
        }, s.prototype.dataToPoint = function(a, n6) {
          Di(a) && (a = a[0]), n6 == null && (n6 = true);
          var f6 = this.getDateInfo(a), d4 = this._rangeInfo, y4 = f6.formatedDate;
          if (n6 && !(f6.time >= d4.start.time && f6.time < d4.end.time + Q2e))
            return [NaN, NaN];
          var _ = f6.day, S = this._getRangeInfo([d4.start.time, y4]).nthWeek;
          return this._orient === "vertical" ? [this._rect.x + _ * this._sw + this._sw / 2, this._rect.y + S * this._sh + this._sh / 2] : [this._rect.x + S * this._sw + this._sw / 2, this._rect.y + _ * this._sh + this._sh / 2];
        }, s.prototype.pointToData = function(a) {
          var n6 = this.pointToDate(a);
          return n6 && n6.time;
        }, s.prototype.dataToRect = function(a, n6) {
          var f6 = this.dataToPoint(a, n6);
          return { contentShape: { x: f6[0] - (this._sw - this._lineWidth) / 2, y: f6[1] - (this._sh - this._lineWidth) / 2, width: this._sw - this._lineWidth, height: this._sh - this._lineWidth }, center: f6, tl: [f6[0] - this._sw / 2, f6[1] - this._sh / 2], tr: [f6[0] + this._sw / 2, f6[1] - this._sh / 2], br: [f6[0] + this._sw / 2, f6[1] + this._sh / 2], bl: [f6[0] - this._sw / 2, f6[1] + this._sh / 2] };
        }, s.prototype.pointToDate = function(a) {
          var n6 = Math.floor((a[0] - this._rect.x) / this._sw) + 1, f6 = Math.floor((a[1] - this._rect.y) / this._sh) + 1, d4 = this._rangeInfo.range;
          return this._orient === "vertical" ? this._getDateByWeeksAndDay(f6, n6 - 1, d4) : this._getDateByWeeksAndDay(n6, f6 - 1, d4);
        }, s.prototype.convertToPixel = function(a, n6, f6) {
          var d4 = uKe(n6);
          return d4 === this ? d4.dataToPoint(f6) : null;
        }, s.prototype.convertFromPixel = function(a, n6, f6) {
          var d4 = uKe(n6);
          return d4 === this ? d4.pointToData(f6) : null;
        }, s.prototype.containPoint = function(a) {
          return console.warn("Not implemented."), false;
        }, s.prototype._initRangeOption = function() {
          var a = this._model.get("range"), n6;
          if (Di(a) && a.length === 1 && (a = a[0]), Di(a))
            n6 = a;
          else {
            var f6 = a.toString();
            if (/^\d{4}$/.test(f6) && (n6 = [f6 + "-01-01", f6 + "-12-31"]), /^\d{4}[\/|-]\d{1,2}$/.test(f6)) {
              var d4 = this.getDateInfo(f6), y4 = d4.date;
              y4.setMonth(y4.getMonth() + 1);
              var _ = this.getNextNDay(y4, -1);
              n6 = [d4.formatedDate, _.formatedDate];
            }
            /^\d{4}[\/|-]\d{1,2}[\/|-]\d{1,2}$/.test(f6) && (n6 = [f6, f6]);
          }
          if (!n6)
            return a;
          var S = this._getRangeInfo(n6);
          return S.start.time > S.end.time && n6.reverse(), n6;
        }, s.prototype._getRangeInfo = function(a) {
          var n6 = [this.getDateInfo(a[0]), this.getDateInfo(a[1])], f6;
          n6[0].time > n6[1].time && (f6 = true, n6.reverse());
          var d4 = Math.floor(n6[1].time / Q2e) - Math.floor(n6[0].time / Q2e) + 1, y4 = new Date(n6[0].time), _ = y4.getDate(), S = n6[1].date.getDate();
          y4.setDate(_ + d4 - 1);
          var T = y4.getDate();
          if (T !== S)
            for (var E = y4.getTime() - n6[1].time > 0 ? 1 : -1; (T = y4.getDate()) !== S && (y4.getTime() - n6[1].time) * E > 0; )
              d4 -= E, y4.setDate(T - E);
          var O = Math.floor((d4 + n6[0].day + 6) / 7), R = f6 ? -O + 1 : O - 1;
          return f6 && n6.reverse(), { range: [n6[0].formatedDate, n6[1].formatedDate], start: n6[0], end: n6[1], allDay: d4, weeks: O, nthWeek: R, fweek: n6[0].day, lweek: n6[1].day };
        }, s.prototype._getDateByWeeksAndDay = function(a, n6, f6) {
          var d4 = this._getRangeInfo(f6);
          if (a > d4.weeks || a === 0 && n6 < d4.fweek || a === d4.weeks && n6 > d4.lweek)
            return null;
          var y4 = (a - 1) * 7 - d4.fweek + n6, _ = new Date(d4.start.time);
          return _.setDate(+d4.start.d + y4), this.getDateInfo(_);
        }, s.create = function(a, n6) {
          var f6 = [];
          return a.eachComponent("calendar", function(d4) {
            var y4 = new s(d4, a, n6);
            f6.push(y4), d4.coordinateSystem = y4;
          }), a.eachSeries(function(d4) {
            d4.get("coordinateSystem") === "calendar" && (d4.coordinateSystem = f6[d4.get("calendarIndex") || 0]);
          }), f6;
        }, s.dimensions = ["time", "value"], s;
      }();
      function uKe(s) {
        var a = s.calendarModel, n6 = s.seriesModel, f6 = a ? a.coordinateSystem : n6 ? n6.coordinateSystem : null;
        return f6;
      }
      var e$t = Qqt;
      function t$t(s) {
        s.registerComponentModel(Kqt), s.registerComponentView(Jqt), s.registerCoordinateSystem("calendar", e$t);
      }
      function n$t(s, a) {
        var n6 = s.existing;
        if (a.id = s.keyInfo.id, !a.type && n6 && (a.type = n6.type), a.parentId == null) {
          var f6 = a.parentOption;
          f6 ? a.parentId = f6.id : n6 && (a.parentId = n6.parentId);
        }
        a.parentOption = null;
      }
      function cKe(s, a) {
        var n6;
        return gt(a, function(f6) {
          s[f6] != null && s[f6] !== "auto" && (n6 = true);
        }), n6;
      }
      function r$t(s, a, n6) {
        var f6 = ei({}, n6), d4 = s[a], y4 = n6.$action || "merge";
        y4 === "merge" ? d4 ? (Ms(d4, f6, true), Yk(d4, f6, { ignoreSize: true }), Vje(n6, d4), tse(n6, d4), tse(n6, d4, "shape"), tse(n6, d4, "style"), tse(n6, d4, "extra"), n6.clipPath = d4.clipPath) : s[a] = f6 : y4 === "replace" ? s[a] = f6 : y4 === "remove" && d4 && (s[a] = null);
      }
      var fKe = ["transition", "enterFrom", "leaveTo"], i$t = fKe.concat(["enterAnimation", "updateAnimation", "leaveAnimation"]);
      function tse(s, a, n6) {
        if (n6 && (!s[n6] && a[n6] && (s[n6] = {}), s = s[n6], a = a[n6]), !(!s || !a))
          for (var f6 = n6 ? fKe : i$t, d4 = 0; d4 < f6.length; d4++) {
            var y4 = f6[d4];
            s[y4] == null && a[y4] != null && (s[y4] = a[y4]);
          }
      }
      function a$t(s, a) {
        if (!!s && (s.hv = a.hv = [cKe(a, ["left", "right"]), cKe(a, ["top", "bottom"])], s.type === "group")) {
          var n6 = s, f6 = a;
          n6.width == null && (n6.width = f6.width = 0), n6.height == null && (n6.height = f6.height = 0);
        }
      }
      var o$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.preventAutoZ = true, n6;
        }
        return a.prototype.mergeOption = function(n6, f6) {
          var d4 = this.option.elements;
          this.option.elements = null, s.prototype.mergeOption.call(this, n6, f6), this.option.elements = d4;
        }, a.prototype.optionUpdated = function(n6, f6) {
          var d4 = this.option, y4 = (f6 ? d4 : n6).elements, _ = d4.elements = f6 ? [] : d4.elements, S = [];
          this._flatten(y4, S, null);
          var T = wT(_, S, "normalMerge"), E = this._elOptionsToUpdate = [];
          gt(T, function(O, R) {
            var V = O.newOption;
            !V || (E.push(V), n$t(O, V), r$t(_, R, V), a$t(_[R], V));
          }, this), d4.elements = tf(_, function(O) {
            return O && delete O.$action, O != null;
          });
        }, a.prototype._flatten = function(n6, f6, d4) {
          gt(n6, function(y4) {
            if (y4) {
              d4 && (y4.parentOption = d4), f6.push(y4);
              var _ = y4.children;
              y4.type === "group" && _ && this._flatten(_, f6, y4), delete y4.children;
            }
          }, this);
        }, a.prototype.useElOptionsToUpdate = function() {
          var n6 = this._elOptionsToUpdate;
          return this._elOptionsToUpdate = null, n6;
        }, a.type = "graphic", a.defaultOption = { elements: [] }, a;
      }(oc), hKe = { path: null, compoundPath: null, group: fs, image: Zv, text: ju }, SS = hu(), s$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function() {
          this._elMap = ro();
        }, a.prototype.render = function(n6, f6, d4) {
          n6 !== this._lastGraphicModel && this._clear(), this._lastGraphicModel = n6, this._updateElements(n6), this._relocate(n6, d4);
        }, a.prototype._updateElements = function(n6) {
          var f6 = n6.useElOptionsToUpdate();
          if (f6) {
            var d4 = this._elMap, y4 = this.group, _ = n6.get("z"), S = n6.get("zlevel");
            gt(f6, function(T) {
              var E = Cd(T.id, null), O = E != null ? d4.get(E) : null, R = Cd(T.parentId, null), V = R != null ? d4.get(R) : y4, z3 = T.type, H = T.style;
              z3 === "text" && H && T.hv && T.hv[1] && (H.textVerticalAlign = H.textBaseline = H.verticalAlign = H.align = null);
              var Z = T.textContent, ee = T.textConfig;
              if (H && vYe(H, z3, !!ee, !!Z)) {
                var oe = gYe(H, z3, true);
                !ee && oe.textConfig && (ee = T.textConfig = oe.textConfig), !Z && oe.textContent && (Z = oe.textContent);
              }
              var fe = l$t(T), _e = T.$action || "merge", pe = _e === "merge", Ve = _e === "replace";
              if (pe) {
                var Le = !O, je = O;
                Le ? je = pKe(E, V, T.type, d4) : (je && (SS(je).isNew = false), TYe(je)), je && ($oe(je, fe, n6, { isInit: Le }), dKe(je, T, _, S));
              } else if (Ve) {
                nse(O, T, d4, n6);
                var Xe = pKe(E, V, T.type, d4);
                Xe && ($oe(Xe, fe, n6, { isInit: true }), dKe(Xe, T, _, S));
              } else
                _e === "remove" && (wYe(O, T), nse(O, T, d4, n6));
              var Ye = d4.get(E);
              if (Ye && Z)
                if (pe) {
                  var rt2 = Ye.getTextContent();
                  rt2 ? rt2.attr(Z) : Ye.setTextContent(new ju(Z));
                } else
                  Ve && Ye.setTextContent(new ju(Z));
              if (Ye) {
                var ut = T.clipPath;
                if (ut) {
                  var wt = ut.type, dt = void 0, Le = false;
                  if (pe) {
                    var Gt = Ye.getClipPath();
                    Le = !Gt || SS(Gt).type !== wt, dt = Le ? eCe(wt) : Gt;
                  } else
                    Ve && (Le = true, dt = eCe(wt));
                  Ye.setClipPath(dt), $oe(dt, ut, n6, { isInit: Le }), Yoe(dt, ut.keyframeAnimation, n6);
                }
                var Qt = SS(Ye);
                Ye.setTextConfig(ee), Qt.option = T, u$t(Ye, n6, T), I0({ el: Ye, componentModel: n6, itemName: Ye.name, itemTooltipOption: T.tooltip }), Yoe(Ye, T.keyframeAnimation, n6);
              }
            });
          }
        }, a.prototype._relocate = function(n6, f6) {
          for (var d4 = n6.option.elements, y4 = this.group, _ = this._elMap, S = f6.getWidth(), T = f6.getHeight(), E = ["x", "y"], O = 0; O < d4.length; O++) {
            var R = d4[O], V = Cd(R.id, null), z3 = V != null ? _.get(V) : null;
            if (!(!z3 || !z3.isGroup)) {
              var H = z3.parent, Z = H === y4, ee = SS(z3), oe = SS(H);
              ee.width = Ia(ee.option.width, Z ? S : oe.width) || 0, ee.height = Ia(ee.option.height, Z ? T : oe.height) || 0;
            }
          }
          for (var O = d4.length - 1; O >= 0; O--) {
            var R = d4[O], V = Cd(R.id, null), z3 = V != null ? _.get(V) : null;
            if (z3) {
              var H = z3.parent, oe = SS(H), fe = H === y4 ? { width: S, height: T } : { width: oe.width, height: oe.height }, _e = {}, pe = Oae(z3, R, fe, null, { hv: R.hv, boundingMode: R.bounding }, _e);
              if (!SS(z3).isNew && pe) {
                for (var Ve = R.transition, Le = {}, je = 0; je < E.length; je++) {
                  var Xe = E[je], Ye = _e[Xe];
                  Ve && (o4(Ve) || Ns(Ve, Xe) >= 0) ? Le[Xe] = Ye : z3[Xe] = Ye;
                }
                ku(z3, Le, n6, 0);
              } else
                z3.attr(_e);
            }
          }
        }, a.prototype._clear = function() {
          var n6 = this, f6 = this._elMap;
          f6.each(function(d4) {
            nse(d4, SS(d4).option, f6, n6._lastGraphicModel);
          }), this._elMap = ro();
        }, a.prototype.dispose = function() {
          this._clear();
        }, a.type = "graphic", a;
      }(sd);
      function eCe(s) {
        var a = io(hKe, s) ? hKe[s] : ae(s), n6 = new a({});
        return SS(n6).type = s, n6;
      }
      function pKe(s, a, n6, f6) {
        var d4 = eCe(n6);
        return a.add(d4), f6.set(s, d4), SS(d4).id = s, SS(d4).isNew = true, d4;
      }
      function nse(s, a, n6, f6) {
        var d4 = s && s.parent;
        d4 && (s.type === "group" && s.traverse(function(y4) {
          nse(y4, a, n6, f6);
        }), Xoe(s, a, f6), n6.removeKey(SS(s).id));
      }
      function dKe(s, a, n6, f6) {
        if (!s.isGroup) {
          var d4 = s;
          d4.cursor = Zs(a.cursor, Hb.prototype.cursor), d4.z = Zs(a.z, n6 || 0), d4.zlevel = Zs(a.zlevel, f6 || 0);
          var y4 = a.z2;
          y4 != null && (d4.z2 = y4 || 0);
        }
        gt(Wl(a), function(_) {
          var S = a[_];
          _.indexOf("on") === 0 && jo(S) && (s[_] = S);
        }), s.draggable = a.draggable, a.name != null && (s.name = a.name), a.id != null && (s.id = a.id);
      }
      function l$t(s) {
        return s = ei({}, s), gt(["id", "parentId", "$action", "hv", "bounding", "textContent", "clipPath"].concat(Fje), function(a) {
          delete s[a];
        }), s;
      }
      function u$t(s, a, n6) {
        var f6 = qo(s).eventData;
        !s.silent && !s.ignore && !f6 && (f6 = qo(s).eventData = { componentType: "graphic", componentIndex: a.componentIndex, name: s.name }), f6 && (f6.info = n6.info);
      }
      function c$t(s) {
        s.registerComponentModel(o$t), s.registerComponentView(s$t), s.registerPreprocessor(function(a) {
          var n6 = a.graphic;
          Di(n6) ? !n6[0] || !n6[0].elements ? a.graphic = [{ elements: n6 }] : a.graphic = [a.graphic[0]] : n6 && !n6.elements && (a.graphic = [{ elements: [n6] }]);
        });
      }
      var vKe = ["x", "y", "radius", "angle", "single"], f$t = ["cartesian2d", "polar", "singleAxis"];
      function h$t(s) {
        var a = s.get("coordinateSystem");
        return Ns(f$t, a) >= 0;
      }
      function f3(s) {
        return s + "Axis";
      }
      function p$t(s, a) {
        var n6 = ro(), f6 = [], d4 = ro();
        s.eachComponent({ mainType: "dataZoom", query: a }, function(O) {
          d4.get(O.uid) || S(O);
        });
        var y4;
        do
          y4 = false, s.eachComponent("dataZoom", _);
        while (y4);
        function _(O) {
          !d4.get(O.uid) && T(O) && (S(O), y4 = true);
        }
        function S(O) {
          d4.set(O.uid, true), f6.push(O), E(O);
        }
        function T(O) {
          var R = false;
          return O.eachTargetAxis(function(V, z3) {
            var H = n6.get(V);
            H && H[z3] && (R = true);
          }), R;
        }
        function E(O) {
          O.eachTargetAxis(function(R, V) {
            (n6.get(R) || n6.set(R, []))[V] = true;
          });
        }
        return f6;
      }
      function gKe(s) {
        var a = s.ecModel, n6 = { infoList: [], infoMap: ro() };
        return s.eachTargetAxis(function(f6, d4) {
          var y4 = a.getComponent(f3(f6), d4);
          if (y4) {
            var _ = y4.getCoordSysModel();
            if (_) {
              var S = _.uid, T = n6.infoMap.get(S);
              T || (T = { model: _, axisModels: [] }, n6.infoList.push(T), n6.infoMap.set(S, T)), T.axisModels.push(y4);
            }
          }
        }), n6;
      }
      var tCe = function() {
        function s() {
          this.indexList = [], this.indexMap = [];
        }
        return s.prototype.add = function(a) {
          this.indexMap[a] || (this.indexList.push(a), this.indexMap[a] = true);
        }, s;
      }(), d$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._autoThrottle = true, n6._noTarget = true, n6._rangePropMode = ["percent", "percent"], n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          var y4 = yKe(n6);
          this.settledOption = y4, this.mergeDefaultAndTheme(n6, d4), this._doInit(y4);
        }, a.prototype.mergeOption = function(n6) {
          var f6 = yKe(n6);
          Ms(this.option, n6, true), Ms(this.settledOption, f6, true), this._doInit(f6);
        }, a.prototype._doInit = function(n6) {
          var f6 = this.option;
          this._setDefaultThrottle(n6), this._updateRangeUse(n6);
          var d4 = this.settledOption;
          gt([["start", "startValue"], ["end", "endValue"]], function(y4, _) {
            this._rangePropMode[_] === "value" && (f6[y4[0]] = d4[y4[0]] = null);
          }, this), this._resetTarget();
        }, a.prototype._resetTarget = function() {
          var n6 = this.get("orient", true), f6 = this._targetAxisInfoMap = ro(), d4 = this._fillSpecifiedTargetAxis(f6);
          d4 ? this._orient = n6 || this._makeAutoOrientByTargetAxis() : (this._orient = n6 || "horizontal", this._fillAutoTargetAxisByOrient(f6, this._orient)), this._noTarget = true, f6.each(function(y4) {
            y4.indexList.length && (this._noTarget = false);
          }, this);
        }, a.prototype._fillSpecifiedTargetAxis = function(n6) {
          var f6 = false;
          return gt(vKe, function(d4) {
            var y4 = this.getReferringComponents(f3(d4), vie);
            if (y4.specified) {
              f6 = true;
              var _ = new tCe();
              gt(y4.models, function(S) {
                _.add(S.componentIndex);
              }), n6.set(d4, _);
            }
          }, this), f6;
        }, a.prototype._fillAutoTargetAxisByOrient = function(n6, f6) {
          var d4 = this.ecModel, y4 = true;
          if (y4) {
            var _ = f6 === "vertical" ? "y" : "x", S = d4.findComponents({ mainType: _ + "Axis" });
            T(S, _);
          }
          if (y4) {
            var S = d4.findComponents({ mainType: "singleAxis", filter: function(O) {
              return O.get("orient", true) === f6;
            } });
            T(S, "single");
          }
          function T(E, O) {
            var R = E[0];
            if (R) {
              var V = new tCe();
              if (V.add(R.componentIndex), n6.set(O, V), y4 = false, O === "x" || O === "y") {
                var z3 = R.getReferringComponents("grid", ad).models[0];
                z3 && gt(E, function(H) {
                  R.componentIndex !== H.componentIndex && z3 === H.getReferringComponents("grid", ad).models[0] && V.add(H.componentIndex);
                });
              }
            }
          }
          y4 && gt(vKe, function(E) {
            if (y4) {
              var O = d4.findComponents({ mainType: f3(E), filter: function(V) {
                return V.get("type", true) === "category";
              } });
              if (O[0]) {
                var R = new tCe();
                R.add(O[0].componentIndex), n6.set(E, R), y4 = false;
              }
            }
          }, this);
        }, a.prototype._makeAutoOrientByTargetAxis = function() {
          var n6;
          return this.eachTargetAxis(function(f6) {
            !n6 && (n6 = f6);
          }, this), n6 === "y" ? "vertical" : "horizontal";
        }, a.prototype._setDefaultThrottle = function(n6) {
          if (n6.hasOwnProperty("throttle") && (this._autoThrottle = false), this._autoThrottle) {
            var f6 = this.ecModel.option;
            this.option.throttle = f6.animation && f6.animationDurationUpdate > 0 ? 100 : 20;
          }
        }, a.prototype._updateRangeUse = function(n6) {
          var f6 = this._rangePropMode, d4 = this.get("rangeMode");
          gt([["start", "startValue"], ["end", "endValue"]], function(y4, _) {
            var S = n6[y4[0]] != null, T = n6[y4[1]] != null;
            S && !T ? f6[_] = "percent" : !S && T ? f6[_] = "value" : d4 ? f6[_] = d4[_] : S && (f6[_] = "percent");
          });
        }, a.prototype.noTarget = function() {
          return this._noTarget;
        }, a.prototype.getFirstTargetAxisModel = function() {
          var n6;
          return this.eachTargetAxis(function(f6, d4) {
            n6 == null && (n6 = this.ecModel.getComponent(f3(f6), d4));
          }, this), n6;
        }, a.prototype.eachTargetAxis = function(n6, f6) {
          this._targetAxisInfoMap.each(function(d4, y4) {
            gt(d4.indexList, function(_) {
              n6.call(f6, y4, _);
            });
          });
        }, a.prototype.getAxisProxy = function(n6, f6) {
          var d4 = this.getAxisModel(n6, f6);
          if (d4)
            return d4.__dzAxisProxy;
        }, a.prototype.getAxisModel = function(n6, f6) {
          var d4 = this._targetAxisInfoMap.get(n6);
          if (d4 && d4.indexMap[f6])
            return this.ecModel.getComponent(f3(n6), f6);
        }, a.prototype.setRawRange = function(n6) {
          var f6 = this.option, d4 = this.settledOption;
          gt([["start", "startValue"], ["end", "endValue"]], function(y4) {
            (n6[y4[0]] != null || n6[y4[1]] != null) && (f6[y4[0]] = d4[y4[0]] = n6[y4[0]], f6[y4[1]] = d4[y4[1]] = n6[y4[1]]);
          }, this), this._updateRangeUse(n6);
        }, a.prototype.setCalculatedRange = function(n6) {
          var f6 = this.option;
          gt(["start", "startValue", "end", "endValue"], function(d4) {
            f6[d4] = n6[d4];
          });
        }, a.prototype.getPercentRange = function() {
          var n6 = this.findRepresentativeAxisProxy();
          if (n6)
            return n6.getDataPercentWindow();
        }, a.prototype.getValueRange = function(n6, f6) {
          if (n6 == null && f6 == null) {
            var d4 = this.findRepresentativeAxisProxy();
            if (d4)
              return d4.getDataValueWindow();
          } else
            return this.getAxisProxy(n6, f6).getDataValueWindow();
        }, a.prototype.findRepresentativeAxisProxy = function(n6) {
          if (n6)
            return n6.__dzAxisProxy;
          for (var f6, d4 = this._targetAxisInfoMap.keys(), y4 = 0; y4 < d4.length; y4++)
            for (var _ = d4[y4], S = this._targetAxisInfoMap.get(_), T = 0; T < S.indexList.length; T++) {
              var E = this.getAxisProxy(_, S.indexList[T]);
              if (E.hostedBy(this))
                return E;
              f6 || (f6 = E);
            }
          return f6;
        }, a.prototype.getRangePropMode = function() {
          return this._rangePropMode.slice();
        }, a.prototype.getOrient = function() {
          return this._orient;
        }, a.type = "dataZoom", a.dependencies = ["xAxis", "yAxis", "radiusAxis", "angleAxis", "singleAxis", "series", "toolbox"], a.defaultOption = { z: 4, filterMode: "filter", start: 0, end: 100 }, a;
      }(oc);
      function yKe(s) {
        var a = {};
        return gt(["start", "end", "startValue", "endValue", "throttle"], function(n6) {
          s.hasOwnProperty(n6) && (a[n6] = s[n6]);
        }), a;
      }
      var hX = d$t, v$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "dataZoom.select", a;
      }(hX), g$t = v$t, y$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          this.dataZoomModel = n6, this.ecModel = f6, this.api = d4;
        }, a.type = "dataZoom", a;
      }(sd), nCe = y$t, m$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "dataZoom.select", a;
      }(nCe), b$t = m$t, rV = gt, mKe = W1, _$t = function() {
        function s(a, n6, f6, d4) {
          this._dimName = a, this._axisIndex = n6, this.ecModel = d4, this._dataZoomModel = f6;
        }
        return s.prototype.hostedBy = function(a) {
          return this._dataZoomModel === a;
        }, s.prototype.getDataValueWindow = function() {
          return this._valueWindow.slice();
        }, s.prototype.getDataPercentWindow = function() {
          return this._percentWindow.slice();
        }, s.prototype.getTargetSeriesModels = function() {
          var a = [];
          return this.ecModel.eachSeries(function(n6) {
            if (h$t(n6)) {
              var f6 = f3(this._dimName), d4 = n6.getReferringComponents(f6, ad).models[0];
              d4 && this._axisIndex === d4.componentIndex && a.push(n6);
            }
          }, this), a;
        }, s.prototype.getAxisModel = function() {
          return this.ecModel.getComponent(this._dimName + "Axis", this._axisIndex);
        }, s.prototype.getMinMaxSpan = function() {
          return Bo(this._minMaxSpan);
        }, s.prototype.calculateDataWindow = function(a) {
          var n6 = this._dataExtent, f6 = this.getAxisModel(), d4 = f6.axis.scale, y4 = this._dataZoomModel.getRangePropMode(), _ = [0, 100], S = [], T = [], E;
          rV(["start", "end"], function(V, z3) {
            var H = a[V], Z = a[V + "Value"];
            y4[z3] === "percent" ? (H == null && (H = _[z3]), Z = d4.parse(zu(H, _, n6))) : (E = true, Z = Z == null ? n6[z3] : d4.parse(Z), H = zu(Z, n6, _)), T[z3] = Z, S[z3] = H;
          }), mKe(T), mKe(S);
          var O = this._minMaxSpan;
          E ? R(T, S, n6, _, false) : R(S, T, _, n6, true);
          function R(V, z3, H, Z, ee) {
            var oe = ee ? "Span" : "ValueSpan";
            r4(0, V, H, "all", O["min" + oe], O["max" + oe]);
            for (var fe = 0; fe < 2; fe++)
              z3[fe] = zu(V[fe], H, Z, true), ee && (z3[fe] = d4.parse(z3[fe]));
          }
          return { valueWindow: T, percentWindow: S };
        }, s.prototype.reset = function(a) {
          if (a === this._dataZoomModel) {
            var n6 = this.getTargetSeriesModels();
            this._dataExtent = x$t(this, this._dimName, n6), this._updateMinMaxSpan();
            var f6 = this.calculateDataWindow(a.settledOption);
            this._valueWindow = f6.valueWindow, this._percentWindow = f6.percentWindow, this._setAxisModel();
          }
        }, s.prototype.filterData = function(a, n6) {
          if (a !== this._dataZoomModel)
            return;
          var f6 = this._dimName, d4 = this.getTargetSeriesModels(), y4 = a.get("filterMode"), _ = this._valueWindow;
          if (y4 === "none")
            return;
          rV(d4, function(T) {
            var E = T.getData(), O = E.mapDimensionsAll(f6);
            if (O.length) {
              if (y4 === "weakFilter") {
                var R = E.getStore(), V = Pi(O, function(z3) {
                  return E.getDimensionIndex(z3);
                }, E);
                E.filterSelf(function(z3) {
                  for (var H, Z, ee, oe = 0; oe < O.length; oe++) {
                    var fe = R.get(V[oe], z3), _e = !isNaN(fe), pe = fe < _[0], Ve = fe > _[1];
                    if (_e && !pe && !Ve)
                      return true;
                    _e && (ee = true), pe && (H = true), Ve && (Z = true);
                  }
                  return ee && H && Z;
                });
              } else
                rV(O, function(z3) {
                  if (y4 === "empty")
                    T.setData(E = E.map(z3, function(Z) {
                      return S(Z) ? Z : NaN;
                    }));
                  else {
                    var H = {};
                    H[z3] = _, E.selectRange(H);
                  }
                });
              rV(O, function(z3) {
                E.setApproximateExtent(_, z3);
              });
            }
          });
          function S(T) {
            return T >= _[0] && T <= _[1];
          }
        }, s.prototype._updateMinMaxSpan = function() {
          var a = this._minMaxSpan = {}, n6 = this._dataZoomModel, f6 = this._dataExtent;
          rV(["min", "max"], function(d4) {
            var y4 = n6.get(d4 + "Span"), _ = n6.get(d4 + "ValueSpan");
            _ != null && (_ = this.getAxisModel().axis.scale.parse(_)), _ != null ? y4 = zu(f6[0] + _, f6, [0, 100], true) : y4 != null && (_ = zu(y4, [0, 100], f6, true) - f6[0]), a[d4 + "Span"] = y4, a[d4 + "ValueSpan"] = _;
          }, this);
        }, s.prototype._setAxisModel = function() {
          var a = this.getAxisModel(), n6 = this._percentWindow, f6 = this._valueWindow;
          if (n6) {
            var d4 = qU(f6, [0, 500]);
            d4 = Math.min(d4, 20);
            var y4 = a.axis.scale.rawExtentInfo;
            n6[0] !== 0 && y4.setDeterminedMinMax("min", +f6[0].toFixed(d4)), n6[1] !== 100 && y4.setDeterminedMinMax("max", +f6[1].toFixed(d4)), y4.freeze();
          }
        }, s;
      }();
      function x$t(s, a, n6) {
        var f6 = [1 / 0, -1 / 0];
        rV(n6, function(_) {
          UFt(f6, _.getData(), a);
        });
        var d4 = s.getAxisModel(), y4 = IWe(d4.axis.scale, d4, f6).calculate();
        return [y4.min, y4.max];
      }
      var w$t = _$t, S$t = { getTargetSeries: function(s) {
        function a(d4) {
          s.eachComponent("dataZoom", function(y4) {
            y4.eachTargetAxis(function(_, S) {
              var T = s.getComponent(f3(_), S);
              d4(_, S, T, y4);
            });
          });
        }
        a(function(d4, y4, _, S) {
          _.__dzAxisProxy = null;
        });
        var n6 = [];
        a(function(d4, y4, _, S) {
          _.__dzAxisProxy || (_.__dzAxisProxy = new w$t(d4, y4, S, s), n6.push(_.__dzAxisProxy));
        });
        var f6 = ro();
        return gt(n6, function(d4) {
          gt(d4.getTargetSeriesModels(), function(y4) {
            f6.set(y4.uid, y4);
          });
        }), f6;
      }, overallReset: function(s, a) {
        s.eachComponent("dataZoom", function(n6) {
          n6.eachTargetAxis(function(f6, d4) {
            n6.getAxisProxy(f6, d4).reset(n6);
          }), n6.eachTargetAxis(function(f6, d4) {
            n6.getAxisProxy(f6, d4).filterData(n6, a);
          });
        }), s.eachComponent("dataZoom", function(n6) {
          var f6 = n6.findRepresentativeAxisProxy();
          if (f6) {
            var d4 = f6.getDataPercentWindow(), y4 = f6.getDataValueWindow();
            n6.setCalculatedRange({ start: d4[0], end: d4[1], startValue: y4[0], endValue: y4[1] });
          }
        });
      } }, C$t = S$t;
      function M$t(s) {
        s.registerAction("dataZoom", function(a, n6) {
          var f6 = p$t(n6, a);
          gt(f6, function(d4) {
            d4.setRawRange({ start: a.start, end: a.end, startValue: a.startValue, endValue: a.endValue });
          });
        });
      }
      var bKe = false;
      function rCe(s) {
        bKe || (bKe = true, s.registerProcessor(s.PRIORITY.PROCESSOR.FILTER, C$t), M$t(s), s.registerSubTypeDefaulter("dataZoom", function() {
          return "slider";
        }));
      }
      function T$t(s) {
        s.registerComponentModel(g$t), s.registerComponentView(b$t), rCe(s);
      }
      var CS = function() {
        function s() {
        }
        return s;
      }(), _Ke = {};
      function iV(s, a) {
        _Ke[s] = a;
      }
      function xKe(s) {
        return _Ke[s];
      }
      var A$t = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.optionUpdated = function() {
          s.prototype.optionUpdated.apply(this, arguments);
          var n6 = this.ecModel;
          gt(this.option.feature, function(f6, d4) {
            var y4 = xKe(d4);
            y4 && (y4.getDefaultOption && (y4.defaultOption = y4.getDefaultOption(n6)), Ms(f6, y4.defaultOption));
          });
        }, a.type = "toolbox", a.layoutMode = { type: "box", ignoreSize: true }, a.defaultOption = { show: true, z: 6, orient: "horizontal", left: "right", top: "top", backgroundColor: "transparent", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemSize: 15, itemGap: 8, showTitle: true, iconStyle: { borderColor: "#666", color: "none" }, emphasis: { iconStyle: { borderColor: "#3E98C5" } }, tooltip: { show: false, position: "bottom" } }, a;
      }(oc), I$t = A$t;
      function E$t(s, a, n6) {
        var f6 = a.getBoxLayoutParams(), d4 = a.get("padding"), y4 = { width: n6.getWidth(), height: n6.getHeight() }, _ = Qv(f6, y4, d4);
        NR(a.get("orient"), s, a.get("itemGap"), _.width, _.height), Oae(s, f6, y4, d4);
      }
      function wKe(s, a) {
        var n6 = I7(a.get("padding")), f6 = a.getItemStyle(["color", "opacity"]);
        return f6.fill = a.get("backgroundColor"), s = new xu({ shape: { x: s.x - n6[3], y: s.y - n6[0], width: s.width + n6[1] + n6[3], height: s.height + n6[0] + n6[2], r: a.get("borderRadius") }, style: f6, silent: true, z2: -1 }), s;
      }
      var D$t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          var _ = this.group;
          if (_.removeAll(), !n6.get("show"))
            return;
          var S = +n6.get("itemSize"), T = n6.get("feature") || {}, E = this._features || (this._features = {}), O = [];
          gt(T, function(z3, H) {
            O.push(H);
          }), new OE(this._featureNames || [], O).add(R).update(R).remove(ks(R, null)).execute(), this._featureNames = O;
          function R(z3, H) {
            var Z = O[z3], ee = O[H], oe = T[Z], fe = new Sh(oe, n6, n6.ecModel), _e;
            if (y4 && y4.newTitle != null && y4.featureName === Z && (oe.title = y4.newTitle), Z && !ee) {
              if (k$t(Z))
                _e = { onclick: fe.option.onclick, featureName: Z };
              else {
                var pe = xKe(Z);
                if (!pe)
                  return;
                _e = new pe();
              }
              E[Z] = _e;
            } else if (_e = E[ee], !_e)
              return;
            _e.uid = M7("toolbox-feature"), _e.model = fe, _e.ecModel = f6, _e.api = d4;
            var Ve = _e instanceof CS;
            if (!Z && ee) {
              Ve && _e.dispose && _e.dispose(f6, d4);
              return;
            }
            if (!fe.get("show") || Ve && _e.unusable) {
              Ve && _e.remove && _e.remove(f6, d4);
              return;
            }
            V(fe, _e, Z), fe.setIconStatus = function(Le, je) {
              var Xe = this.option, Ye = this.iconPaths;
              Xe.iconStatus = Xe.iconStatus || {}, Xe.iconStatus[Le] = je, Ye[Le] && (je === "emphasis" ? sS : lS)(Ye[Le]);
            }, _e instanceof CS && _e.render && _e.render(fe, f6, d4, y4);
          }
          function V(z3, H, Z) {
            var ee = z3.getModel("iconStyle"), oe = z3.getModel(["emphasis", "iconStyle"]), fe = H instanceof CS && H.getIcons ? H.getIcons() : z3.get("icon"), _e = z3.get("title") || {}, pe, Ve;
            Wa(fe) ? (pe = {}, pe[Z] = fe) : pe = fe, Wa(_e) ? (Ve = {}, Ve[Z] = _e) : Ve = _e;
            var Le = z3.iconPaths = {};
            gt(pe, function(je, Xe) {
              var Ye = Gu(je, {}, { x: -S / 2, y: -S / 2, width: S, height: S });
              Ye.setStyle(ee.getItemStyle());
              var rt2 = Ye.ensureState("emphasis");
              rt2.style = oe.getItemStyle();
              var ut = new ju({ style: { text: Ve[Xe], align: oe.get("textAlign"), borderRadius: oe.get("textBorderRadius"), padding: oe.get("textPadding"), fill: null }, ignore: true });
              Ye.setTextContent(ut), I0({ el: Ye, componentModel: n6, itemName: Xe, formatterParamsExtra: { title: Ve[Xe] } }), Ye.__title = Ve[Xe], Ye.on("mouseover", function() {
                var wt = oe.getItemStyle(), dt = n6.get("orient") === "vertical" ? n6.get("right") == null ? "right" : "left" : n6.get("bottom") == null ? "bottom" : "top";
                ut.setStyle({ fill: oe.get("textFill") || wt.fill || wt.stroke || "#000", backgroundColor: oe.get("textBackgroundColor") }), Ye.setTextConfig({ position: oe.get("textPosition") || dt }), ut.ignore = !n6.get("showTitle"), sS(this);
              }).on("mouseout", function() {
                z3.get(["iconStatus", Xe]) !== "emphasis" && lS(this), ut.hide();
              }), (z3.get(["iconStatus", Xe]) === "emphasis" ? sS : lS)(Ye), _.add(Ye), Ye.on("click", Za(H.onclick, H, f6, d4, Xe)), Le[Xe] = Ye;
            });
          }
          E$t(_, n6, d4), _.add(wKe(_.getBoundingRect(), n6)), _.eachChild(function(z3) {
            var H = z3.__title, Z = z3.ensureState("emphasis"), ee = Z.textConfig || (Z.textConfig = {}), oe = z3.getTextContent(), fe = oe && oe.states.emphasis;
            if (fe && !jo(fe) && H) {
              var _e = fe.style || (fe.style = {}), pe = cE(H, ju.makeFont(_e)), Ve = z3.x + _.x, Le = z3.y + _.y + S, je = false;
              Le + pe.height > d4.getHeight() && (ee.position = "top", je = true);
              var Xe = je ? -5 - pe.height : S + 8;
              Ve + pe.width / 2 > d4.getWidth() ? (ee.position = ["100%", Xe], _e.align = "right") : Ve - pe.width / 2 < 0 && (ee.position = [0, Xe], _e.align = "left");
            }
          });
        }, a.prototype.updateView = function(n6, f6, d4, y4) {
          gt(this._features, function(_) {
            _ instanceof CS && _.updateView && _.updateView(_.model, f6, d4, y4);
          });
        }, a.prototype.remove = function(n6, f6) {
          gt(this._features, function(d4) {
            d4 instanceof CS && d4.remove && d4.remove(n6, f6);
          }), this.group.removeAll();
        }, a.prototype.dispose = function(n6, f6) {
          gt(this._features, function(d4) {
            d4 instanceof CS && d4.dispose && d4.dispose(n6, f6);
          });
        }, a.type = "toolbox", a;
      }(sd);
      function k$t(s) {
        return s.indexOf("my") === 0;
      }
      var O$t = D$t, P$t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.onclick = function(n6, f6) {
          var d4 = this.model, y4 = d4.get("name") || n6.get("title.0.text") || "echarts", _ = f6.getZr().painter.getType() === "svg", S = _ ? "svg" : d4.get("type", true) || "png", T = f6.getConnectedDataURL({ type: S, backgroundColor: d4.get("backgroundColor", true) || n6.get("backgroundColor") || "#fff", connectedBackgroundColor: d4.get("connectedBackgroundColor"), excludeComponents: d4.get("excludeComponents"), pixelRatio: d4.get("pixelRatio") }), E = Na.browser;
          if (jo(MouseEvent) && (E.newEdge || !E.ie && !E.edge)) {
            var O = document.createElement("a");
            O.download = y4 + "." + S, O.target = "_blank", O.href = T;
            var R = new MouseEvent("click", { view: document.defaultView, bubbles: true, cancelable: false });
            O.dispatchEvent(R);
          } else if (window.navigator.msSaveOrOpenBlob || _) {
            var V = T.split(","), z3 = V[0].indexOf("base64") > -1, H = _ ? decodeURIComponent(V[1]) : V[1];
            z3 && (H = window.atob(H));
            var Z = y4 + "." + S;
            if (window.navigator.msSaveOrOpenBlob) {
              for (var ee = H.length, oe = new Uint8Array(ee); ee--; )
                oe[ee] = H.charCodeAt(ee);
              var fe = new Blob([oe]);
              window.navigator.msSaveOrOpenBlob(fe, Z);
            } else {
              var _e = document.createElement("iframe");
              document.body.appendChild(_e);
              var pe = _e.contentWindow, Ve = pe.document;
              Ve.open("image/svg+xml", "replace"), Ve.write(H), Ve.close(), pe.focus(), Ve.execCommand("SaveAs", true, Z), document.body.removeChild(_e);
            }
          } else {
            var Le = d4.get("lang"), je = '<body style="margin:0;"><img src="' + T + '" style="max-width:100%;" title="' + (Le && Le[0] || "") + '" /></body>', Xe = window.open();
            Xe.document.write(je), Xe.document.title = y4;
          }
        }, a.getDefaultOption = function(n6) {
          var f6 = { show: true, icon: "M4.7,22.9L29.3,45.5L54.7,23.4M4.6,43.6L4.6,58L53.8,58L53.8,43.6M29.2,45.1L29.2,0", title: n6.getLocaleModel().get(["toolbox", "saveAsImage", "title"]), type: "png", connectedBackgroundColor: "#fff", name: "", excludeComponents: ["toolbox"], lang: n6.getLocaleModel().get(["toolbox", "saveAsImage", "lang"]) };
          return f6;
        }, a;
      }(CS), L$t = P$t, SKe = "__ec_magicType_stack__", R$t = [["line", "bar"], ["stack"]], N$t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.getIcons = function() {
          var n6 = this.model, f6 = n6.get("icon"), d4 = {};
          return gt(n6.get("type"), function(y4) {
            f6[y4] && (d4[y4] = f6[y4]);
          }), d4;
        }, a.getDefaultOption = function(n6) {
          var f6 = { show: true, type: [], icon: { line: "M4.1,28.9h7.1l9.3-22l7.4,38l9.7-19.7l3,12.8h14.9M4.1,58h51.4", bar: "M6.7,22.9h10V48h-10V22.9zM24.9,13h10v35h-10V13zM43.2,2h10v46h-10V2zM3.1,58h53.7", stack: "M8.2,38.4l-8.4,4.1l30.6,15.3L60,42.5l-8.1-4.1l-21.5,11L8.2,38.4z M51.9,30l-8.1,4.2l-13.4,6.9l-13.9-6.9L8.2,30l-8.4,4.2l8.4,4.2l22.2,11l21.5-11l8.1-4.2L51.9,30z M51.9,21.7l-8.1,4.2L35.7,30l-5.3,2.8L24.9,30l-8.4-4.1l-8.3-4.2l-8.4,4.2L8.2,30l8.3,4.2l13.9,6.9l13.4-6.9l8.1-4.2l8.1-4.1L51.9,21.7zM30.4,2.2L-0.2,17.5l8.4,4.1l8.3,4.2l8.4,4.2l5.5,2.7l5.3-2.7l8.1-4.2l8.1-4.2l8.1-4.1L30.4,2.2z" }, title: n6.getLocaleModel().get(["toolbox", "magicType", "title"]), option: {}, seriesIndex: {} };
          return f6;
        }, a.prototype.onclick = function(n6, f6, d4) {
          var y4 = this.model, _ = y4.get(["seriesIndex", d4]);
          if (CKe[d4]) {
            var S = { series: [] }, T = function(R) {
              var V = R.subType, z3 = R.id, H = CKe[d4](V, z3, R, y4);
              H && (zo(H, R.option), S.series.push(H));
              var Z = R.coordinateSystem;
              if (Z && Z.type === "cartesian2d" && (d4 === "line" || d4 === "bar")) {
                var ee = Z.getAxesByScale("ordinal")[0];
                if (ee) {
                  var oe = ee.dim, fe = oe + "Axis", _e = R.getReferringComponents(fe, ad).models[0], pe = _e.componentIndex;
                  S[fe] = S[fe] || [];
                  for (var Ve = 0; Ve <= pe; Ve++)
                    S[fe][pe] = S[fe][pe] || {};
                  S[fe][pe].boundaryGap = d4 === "bar";
                }
              }
            };
            gt(R$t, function(R) {
              Ns(R, d4) >= 0 && gt(R, function(V) {
                y4.setIconStatus(V, "normal");
              });
            }), y4.setIconStatus(d4, "emphasis"), n6.eachComponent({ mainType: "series", query: _ == null ? null : { seriesIndex: _ } }, T);
            var E, O = d4;
            d4 === "stack" && (E = Ms({ stack: y4.option.title.tiled, tiled: y4.option.title.stack }, y4.option.title), y4.get(["iconStatus", d4]) !== "emphasis" && (O = "tiled")), f6.dispatchAction({ type: "changeMagicType", currentType: O, newOption: S, newTitle: E, featureName: "magicType" });
          }
        }, a;
      }(CS), CKe = { line: function(s, a, n6, f6) {
        if (s === "bar")
          return Ms({ id: a, type: "line", data: n6.get("data"), stack: n6.get("stack"), markPoint: n6.get("markPoint"), markLine: n6.get("markLine") }, f6.get(["option", "line"]) || {}, true);
      }, bar: function(s, a, n6, f6) {
        if (s === "line")
          return Ms({ id: a, type: "bar", data: n6.get("data"), stack: n6.get("stack"), markPoint: n6.get("markPoint"), markLine: n6.get("markLine") }, f6.get(["option", "bar"]) || {}, true);
      }, stack: function(s, a, n6, f6) {
        var d4 = n6.get("stack") === SKe;
        if (s === "line" || s === "bar")
          return f6.setIconStatus("stack", d4 ? "normal" : "emphasis"), Ms({ id: a, stack: d4 ? "" : SKe }, f6.get(["option", "stack"]) || {}, true);
      } };
      LT({ type: "changeMagicType", event: "magicTypeChanged", update: "prepareAndUpdate" }, function(s, a) {
        a.mergeOption(s.newOption);
      });
      var F$t = N$t, rse = new Array(60).join("-"), aV = "	";
      function V$t(s) {
        var a = {}, n6 = [], f6 = [];
        return s.eachRawSeries(function(d4) {
          var y4 = d4.coordinateSystem;
          if (y4 && (y4.type === "cartesian2d" || y4.type === "polar")) {
            var _ = y4.getBaseAxis();
            if (_.type === "category") {
              var S = _.dim + "_" + _.index;
              a[S] || (a[S] = { categoryAxis: _, valueAxis: y4.getOtherAxis(_), series: [] }, f6.push({ axisDim: _.dim, axisIndex: _.index })), a[S].series.push(d4);
            } else
              n6.push(d4);
          } else
            n6.push(d4);
        }), { seriesGroupByCategoryAxis: a, other: n6, meta: f6 };
      }
      function B$t(s) {
        var a = [];
        return gt(s, function(n6, f6) {
          var d4 = n6.categoryAxis, y4 = n6.valueAxis, _ = y4.dim, S = [" "].concat(Pi(n6.series, function(z3) {
            return z3.name;
          })), T = [d4.model.getCategories()];
          gt(n6.series, function(z3) {
            var H = z3.getRawData();
            T.push(z3.getRawData().mapArray(H.mapDimension(_), function(Z) {
              return Z;
            }));
          });
          for (var E = [S.join(aV)], O = 0; O < T[0].length; O++) {
            for (var R = [], V = 0; V < T.length; V++)
              R.push(T[V][O]);
            E.push(R.join(aV));
          }
          a.push(E.join(`
`));
        }), a.join(`

` + rse + `

`);
      }
      function z$t(s) {
        return Pi(s, function(a) {
          var n6 = a.getRawData(), f6 = [a.name], d4 = [];
          return n6.each(n6.dimensions, function() {
            for (var y4 = arguments.length, _ = arguments[y4 - 1], S = n6.getName(_), T = 0; T < y4 - 1; T++)
              d4[T] = arguments[T];
            f6.push((S ? S + aV : "") + d4.join(aV));
          }), f6.join(`
`);
        }).join(`

` + rse + `

`);
      }
      function j$t(s) {
        var a = V$t(s);
        return { value: tf([B$t(a.seriesGroupByCategoryAxis), z$t(a.other)], function(n6) {
          return !!n6.replace(/[\n\t\s]/g, "");
        }).join(`

` + rse + `

`), meta: a.meta };
      }
      function ise(s) {
        return s.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
      }
      function G$t(s) {
        var a = s.slice(0, s.indexOf(`
`));
        if (a.indexOf(aV) >= 0)
          return true;
      }
      var iCe = new RegExp("[" + aV + "]+", "g");
      function H$t(s) {
        for (var a = s.split(/\n+/g), n6 = ise(a.shift()).split(iCe), f6 = [], d4 = Pi(n6, function(T) {
          return { name: T, data: [] };
        }), y4 = 0; y4 < a.length; y4++) {
          var _ = ise(a[y4]).split(iCe);
          f6.push(_.shift());
          for (var S = 0; S < _.length; S++)
            d4[S] && (d4[S].data[y4] = _[S]);
        }
        return { series: d4, categories: f6 };
      }
      function W$t(s) {
        for (var a = s.split(/\n+/g), n6 = ise(a.shift()), f6 = [], d4 = 0; d4 < a.length; d4++) {
          var y4 = ise(a[d4]);
          if (y4) {
            var _ = y4.split(iCe), S = "", T = void 0, E = false;
            isNaN(_[0]) ? (E = true, S = _[0], _ = _.slice(1), f6[d4] = { name: S, value: [] }, T = f6[d4].value) : T = f6[d4] = [];
            for (var O = 0; O < _.length; O++)
              T.push(+_[O]);
            T.length === 1 && (E ? f6[d4].value = T[0] : f6[d4] = T[0]);
          }
        }
        return { name: n6, data: f6 };
      }
      function U$t(s, a) {
        var n6 = s.split(new RegExp(`
*` + rse + `
*`, "g")), f6 = { series: [] };
        return gt(n6, function(d4, y4) {
          if (G$t(d4)) {
            var _ = H$t(d4), S = a[y4], T = S.axisDim + "Axis";
            S && (f6[T] = f6[T] || [], f6[T][S.axisIndex] = { data: _.categories }, f6.series = f6.series.concat(_.series));
          } else {
            var _ = W$t(d4);
            f6.series.push(_);
          }
        }), f6;
      }
      var q$t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.onclick = function(n6, f6) {
          setTimeout(function() {
            f6.dispatchAction({ type: "hideTip" });
          });
          var d4 = f6.getDom(), y4 = this.model;
          this._dom && d4.removeChild(this._dom);
          var _ = document.createElement("div");
          _.style.cssText = "position:absolute;top:0;bottom:0;left:0;right:0;padding:5px", _.style.backgroundColor = y4.get("backgroundColor") || "#fff";
          var S = document.createElement("h4"), T = y4.get("lang") || [];
          S.innerHTML = T[0] || y4.get("title"), S.style.cssText = "margin:10px 20px", S.style.color = y4.get("textColor");
          var E = document.createElement("div"), O = document.createElement("textarea");
          E.style.cssText = "overflow:auto";
          var R = y4.get("optionToContent"), V = y4.get("contentToOption"), z3 = j$t(n6);
          if (jo(R)) {
            var H = R(f6.getOption());
            Wa(H) ? E.innerHTML = H : VL(H) && E.appendChild(H);
          } else {
            O.readOnly = y4.get("readOnly");
            var Z = O.style;
            Z.cssText = "width:100%;height:100%;font-family:monospace;font-size:14px;line-height:1.6rem;resize:none", Z.color = y4.get("textColor"), Z.borderColor = y4.get("textareaBorderColor"), Z.backgroundColor = y4.get("textareaColor"), O.value = z3.value, E.appendChild(O);
          }
          var ee = z3.meta, oe = document.createElement("div");
          oe.style.cssText = "position:absolute;bottom:5px;left:0;right:0";
          var fe = "float:right;margin-right:20px;border:none;cursor:pointer;padding:2px 5px;font-size:12px;border-radius:3px", _e = document.createElement("div"), pe = document.createElement("div");
          fe += ";background-color:" + y4.get("buttonColor"), fe += ";color:" + y4.get("buttonTextColor");
          var Ve = this;
          function Le() {
            d4.removeChild(_), Ve._dom = null;
          }
          gU(_e, "click", Le), gU(pe, "click", function() {
            if (V == null && R != null || V != null && R == null) {
              Le();
              return;
            }
            var je;
            try {
              jo(V) ? je = V(E, f6.getOption()) : je = U$t(O.value, ee);
            } catch (Xe) {
              throw Le(), new Error("Data view format error " + Xe);
            }
            je && f6.dispatchAction({ type: "changeDataView", newOption: je }), Le();
          }), _e.innerHTML = T[1], pe.innerHTML = T[2], pe.style.cssText = _e.style.cssText = fe, !y4.get("readOnly") && oe.appendChild(pe), oe.appendChild(_e), _.appendChild(S), _.appendChild(E), _.appendChild(oe), E.style.height = d4.clientHeight - 80 + "px", d4.appendChild(_), this._dom = _;
        }, a.prototype.remove = function(n6, f6) {
          this._dom && f6.getDom().removeChild(this._dom);
        }, a.prototype.dispose = function(n6, f6) {
          this.remove(n6, f6);
        }, a.getDefaultOption = function(n6) {
          var f6 = { show: true, readOnly: false, optionToContent: null, contentToOption: null, icon: "M17.5,17.3H33 M17.5,17.3H33 M45.4,29.5h-28 M11.5,2v56H51V14.8L38.4,2H11.5z M38.4,2.2v12.7H51 M45.4,41.7h-28", title: n6.getLocaleModel().get(["toolbox", "dataView", "title"]), lang: n6.getLocaleModel().get(["toolbox", "dataView", "lang"]), backgroundColor: "#fff", textColor: "#000", textareaColor: "#fff", textareaBorderColor: "#333", buttonColor: "#c23531", buttonTextColor: "#fff" };
          return f6;
        }, a;
      }(CS);
      function $$t(s, a) {
        return Pi(s, function(n6, f6) {
          var d4 = a && a[f6];
          if (Qo(d4) && !Di(d4)) {
            var y4 = Qo(n6) && !Di(n6);
            y4 || (n6 = { value: n6 });
            var _ = d4.name != null && n6.name == null;
            return n6 = zo(n6, d4), _ && delete n6.name, n6;
          } else
            return n6;
        });
      }
      LT({ type: "changeDataView", event: "dataViewChanged", update: "prepareAndUpdate" }, function(s, a) {
        var n6 = [];
        gt(s.newOption.series, function(f6) {
          var d4 = a.getSeriesByName(f6.name)[0];
          if (!d4)
            n6.push(ei({ type: "scatter" }, f6));
          else {
            var y4 = d4.get("data");
            n6.push({ name: f6.name, data: $$t(f6.data, y4) });
          }
        }), a.mergeOption(zo({ series: n6 }, s.newOption));
      });
      var X$t = q$t, MKe = gt, TKe = hu();
      function Y$t(s, a) {
        var n6 = aCe(s);
        MKe(a, function(f6, d4) {
          for (var y4 = n6.length - 1; y4 >= 0; y4--) {
            var _ = n6[y4];
            if (_[d4])
              break;
          }
          if (y4 < 0) {
            var S = s.queryComponents({ mainType: "dataZoom", subType: "select", id: d4 })[0];
            if (S) {
              var T = S.getPercentRange();
              n6[0][d4] = { dataZoomId: d4, start: T[0], end: T[1] };
            }
          }
        }), n6.push(a);
      }
      function K$t(s) {
        var a = aCe(s), n6 = a[a.length - 1];
        a.length > 1 && a.pop();
        var f6 = {};
        return MKe(n6, function(d4, y4) {
          for (var _ = a.length - 1; _ >= 0; _--)
            if (d4 = a[_][y4], d4) {
              f6[y4] = d4;
              break;
            }
        }), f6;
      }
      function Z$t(s) {
        TKe(s).snapshots = null;
      }
      function J$t(s) {
        return aCe(s).length;
      }
      function aCe(s) {
        var a = TKe(s);
        return a.snapshots || (a.snapshots = [{}]), a.snapshots;
      }
      var Q$t = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.onclick = function(n6, f6) {
          Z$t(n6), f6.dispatchAction({ type: "restore", from: this.uid });
        }, a.getDefaultOption = function(n6) {
          var f6 = { show: true, icon: "M3.8,33.4 M47,18.9h9.8V8.7 M56.3,20.1 C52.1,9,40.5,0.6,26.8,2.1C12.6,3.7,1.6,16.2,2.1,30.6 M13,41.1H3.1v10.2 M3.7,39.9c4.2,11.1,15.8,19.5,29.5,18 c14.2-1.6,25.2-14.1,24.7-28.5", title: n6.getLocaleModel().get(["toolbox", "restore", "title"]) };
          return f6;
        }, a;
      }(CS);
      LT({ type: "restore", event: "restore", update: "prepareAndUpdate" }, function(s, a) {
        a.resetOption("recreate");
      });
      var eXt = Q$t, tXt = ["grid", "xAxis", "yAxis", "geo", "graph", "polar", "radiusAxis", "angleAxis", "bmap"], nXt = function() {
        function s(a, n6, f6) {
          var d4 = this;
          this._targetInfoList = [];
          var y4 = AKe(n6, a);
          gt(rXt, function(_, S) {
            (!f6 || !f6.include || Ns(f6.include, S) >= 0) && _(y4, d4._targetInfoList);
          });
        }
        return s.prototype.setOutputRanges = function(a, n6) {
          return this.matchOutputRanges(a, n6, function(f6, d4, y4) {
            if ((f6.coordRanges || (f6.coordRanges = [])).push(d4), !f6.coordRange) {
              f6.coordRange = d4;
              var _ = sCe[f6.brushType](0, y4, d4);
              f6.__rangeOffset = { offset: kKe[f6.brushType](_.values, f6.range, [1, 1]), xyMinMax: _.xyMinMax };
            }
          }), a;
        }, s.prototype.matchOutputRanges = function(a, n6, f6) {
          gt(a, function(d4) {
            var y4 = this.findTargetInfo(d4, n6);
            y4 && y4 !== true && gt(y4.coordSyses, function(_) {
              var S = sCe[d4.brushType](1, _, d4.range, true);
              f6(d4, S.values, _, n6);
            });
          }, this);
        }, s.prototype.setInputRanges = function(a, n6) {
          gt(a, function(f6) {
            var d4 = this.findTargetInfo(f6, n6);
            if (f6.range = f6.range || [], d4 && d4 !== true) {
              f6.panelId = d4.panelId;
              var y4 = sCe[f6.brushType](0, d4.coordSys, f6.coordRange), _ = f6.__rangeOffset;
              f6.range = _ ? kKe[f6.brushType](y4.values, _.offset, iXt(y4.xyMinMax, _.xyMinMax)) : y4.values;
            }
          }, this);
        }, s.prototype.makePanelOpts = function(a, n6) {
          return Pi(this._targetInfoList, function(f6) {
            var d4 = f6.getPanelRect();
            return { panelId: f6.panelId, defaultBrushType: n6 ? n6(f6) : null, clipPath: IXe(d4), isTargetByCursor: DXe(d4, a, f6.coordSysModel), getLinearBrushOtherExtent: EXe(d4) };
          });
        }, s.prototype.controlSeries = function(a, n6, f6) {
          var d4 = this.findTargetInfo(a, f6);
          return d4 === true || d4 && Ns(d4.coordSyses, n6.coordinateSystem) >= 0;
        }, s.prototype.findTargetInfo = function(a, n6) {
          for (var f6 = this._targetInfoList, d4 = AKe(n6, a), y4 = 0; y4 < f6.length; y4++) {
            var _ = f6[y4], S = a.panelId;
            if (S) {
              if (_.panelId === S)
                return _;
            } else
              for (var T = 0; T < IKe.length; T++)
                if (IKe[T](d4, _))
                  return _;
          }
          return true;
        }, s;
      }();
      function oCe(s) {
        return s[0] > s[1] && s.reverse(), s;
      }
      function AKe(s, a) {
        return gR(s, a, { includeMainTypes: tXt });
      }
      var rXt = { grid: function(s, a) {
        var n6 = s.xAxisModels, f6 = s.yAxisModels, d4 = s.gridModels, y4 = ro(), _ = {}, S = {};
        !n6 && !f6 && !d4 || (gt(n6, function(T) {
          var E = T.axis.grid.model;
          y4.set(E.id, E), _[E.id] = true;
        }), gt(f6, function(T) {
          var E = T.axis.grid.model;
          y4.set(E.id, E), S[E.id] = true;
        }), gt(d4, function(T) {
          y4.set(T.id, T), _[T.id] = true, S[T.id] = true;
        }), y4.each(function(T) {
          var E = T.coordinateSystem, O = [];
          gt(E.getCartesians(), function(R, V) {
            (Ns(n6, R.getAxis("x").model) >= 0 || Ns(f6, R.getAxis("y").model) >= 0) && O.push(R);
          }), a.push({ panelId: "grid--" + T.id, gridModel: T, coordSysModel: T, coordSys: O[0], coordSyses: O, getPanelRect: EKe.grid, xAxisDeclared: _[T.id], yAxisDeclared: S[T.id] });
        }));
      }, geo: function(s, a) {
        gt(s.geoModels, function(n6) {
          var f6 = n6.coordinateSystem;
          a.push({ panelId: "geo--" + n6.id, geoModel: n6, coordSysModel: n6, coordSys: f6, coordSyses: [f6], getPanelRect: EKe.geo });
        });
      } }, IKe = [function(s, a) {
        var n6 = s.xAxisModel, f6 = s.yAxisModel, d4 = s.gridModel;
        return !d4 && n6 && (d4 = n6.axis.grid.model), !d4 && f6 && (d4 = f6.axis.grid.model), d4 && d4 === a.gridModel;
      }, function(s, a) {
        var n6 = s.geoModel;
        return n6 && n6 === a.geoModel;
      }], EKe = { grid: function() {
        return this.coordSys.master.getRect().clone();
      }, geo: function() {
        var s = this.coordSys, a = s.getBoundingRect().clone();
        return a.applyTransform(Qi(s)), a;
      } }, sCe = { lineX: ks(DKe, 0), lineY: ks(DKe, 1), rect: function(s, a, n6, f6) {
        var d4 = s ? a.pointToData([n6[0][0], n6[1][0]], f6) : a.dataToPoint([n6[0][0], n6[1][0]], f6), y4 = s ? a.pointToData([n6[0][1], n6[1][1]], f6) : a.dataToPoint([n6[0][1], n6[1][1]], f6), _ = [oCe([d4[0], y4[0]]), oCe([d4[1], y4[1]])];
        return { values: _, xyMinMax: _ };
      }, polygon: function(s, a, n6, f6) {
        var d4 = [[1 / 0, -1 / 0], [1 / 0, -1 / 0]], y4 = Pi(n6, function(_) {
          var S = s ? a.pointToData(_, f6) : a.dataToPoint(_, f6);
          return d4[0][0] = Math.min(d4[0][0], S[0]), d4[1][0] = Math.min(d4[1][0], S[1]), d4[0][1] = Math.max(d4[0][1], S[0]), d4[1][1] = Math.max(d4[1][1], S[1]), S;
        });
        return { values: y4, xyMinMax: d4 };
      } };
      function DKe(s, a, n6, f6) {
        var d4 = n6.getAxis(["x", "y"][s]), y4 = oCe(Pi([0, 1], function(S) {
          return a ? d4.coordToData(d4.toLocalCoord(f6[S]), true) : d4.toGlobalCoord(d4.dataToCoord(f6[S]));
        })), _ = [];
        return _[s] = y4, _[1 - s] = [NaN, NaN], { values: y4, xyMinMax: _ };
      }
      var kKe = { lineX: ks(OKe, 0), lineY: ks(OKe, 1), rect: function(s, a, n6) {
        return [[s[0][0] - n6[0] * a[0][0], s[0][1] - n6[0] * a[0][1]], [s[1][0] - n6[1] * a[1][0], s[1][1] - n6[1] * a[1][1]]];
      }, polygon: function(s, a, n6) {
        return Pi(s, function(f6, d4) {
          return [f6[0] - n6[0] * a[d4][0], f6[1] - n6[1] * a[d4][1]];
        });
      } };
      function OKe(s, a, n6, f6) {
        return [a[0] - f6[s] * n6[0], a[1] - f6[s] * n6[1]];
      }
      function iXt(s, a) {
        var n6 = PKe(s), f6 = PKe(a), d4 = [n6[0] / f6[0], n6[1] / f6[1]];
        return isNaN(d4[0]) && (d4[0] = 1), isNaN(d4[1]) && (d4[1] = 1), d4;
      }
      function PKe(s) {
        return s ? [s[0][1] - s[0][0], s[1][1] - s[1][0]] : [NaN, NaN];
      }
      var lCe = nXt, uCe = gt, aXt = Kbe("toolbox-dataZoom_"), oXt = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.render = function(n6, f6, d4, y4) {
          this._brushController || (this._brushController = new m2e(d4.getZr()), this._brushController.on("brush", Za(this._onBrush, this)).mount()), uXt(n6, f6, this, y4, d4), lXt(n6, f6);
        }, a.prototype.onclick = function(n6, f6, d4) {
          sXt[d4].call(this);
        }, a.prototype.remove = function(n6, f6) {
          this._brushController && this._brushController.unmount();
        }, a.prototype.dispose = function(n6, f6) {
          this._brushController && this._brushController.dispose();
        }, a.prototype._onBrush = function(n6) {
          var f6 = n6.areas;
          if (!n6.isEnd || !f6.length)
            return;
          var d4 = {}, y4 = this.ecModel;
          this._brushController.updateCovers([]);
          var _ = new lCe(cCe(this.model), y4, { include: ["grid"] });
          _.matchOutputRanges(f6, y4, function(E, O, R) {
            if (R.type === "cartesian2d") {
              var V = E.brushType;
              V === "rect" ? (S("x", R, O[0]), S("y", R, O[1])) : S({ lineX: "x", lineY: "y" }[V], R, O);
            }
          }), Y$t(y4, d4), this._dispatchZoomAction(d4);
          function S(E, O, R) {
            var V = O.getAxis(E), z3 = V.model, H = T(E, z3, y4), Z = H.findRepresentativeAxisProxy(z3).getMinMaxSpan();
            (Z.minValueSpan != null || Z.maxValueSpan != null) && (R = r4(0, R.slice(), V.scale.getExtent(), 0, Z.minValueSpan, Z.maxValueSpan)), H && (d4[H.id] = { dataZoomId: H.id, startValue: R[0], endValue: R[1] });
          }
          function T(E, O, R) {
            var V;
            return R.eachComponent({ mainType: "dataZoom", subType: "select" }, function(z3) {
              var H = z3.getAxisModel(E, O.componentIndex);
              H && (V = z3);
            }), V;
          }
        }, a.prototype._dispatchZoomAction = function(n6) {
          var f6 = [];
          uCe(n6, function(d4, y4) {
            f6.push(Bo(d4));
          }), f6.length && this.api.dispatchAction({ type: "dataZoom", from: this.uid, batch: f6 });
        }, a.getDefaultOption = function(n6) {
          var f6 = { show: true, filterMode: "filter", icon: { zoom: "M0,13.5h26.9 M13.5,26.9V0 M32.1,13.5H58V58H13.5 V32.1", back: "M22,1.4L9.9,13.5l12.3,12.3 M10.3,13.5H54.9v44.6 H10.3v-26" }, title: n6.getLocaleModel().get(["toolbox", "dataZoom", "title"]), brushStyle: { borderWidth: 0, color: "rgba(210,219,238,0.2)" } };
          return f6;
        }, a;
      }(CS), sXt = { zoom: function() {
        var s = !this._isZoomActive;
        this.api.dispatchAction({ type: "takeGlobalCursor", key: "dataZoomSelect", dataZoomSelectActive: s });
      }, back: function() {
        this._dispatchZoomAction(K$t(this.ecModel));
      } };
      function cCe(s) {
        var a = { xAxisIndex: s.get("xAxisIndex", true), yAxisIndex: s.get("yAxisIndex", true), xAxisId: s.get("xAxisId", true), yAxisId: s.get("yAxisId", true) };
        return a.xAxisIndex == null && a.xAxisId == null && (a.xAxisIndex = "all"), a.yAxisIndex == null && a.yAxisId == null && (a.yAxisIndex = "all"), a;
      }
      function lXt(s, a) {
        s.setIconStatus("back", J$t(a) > 1 ? "emphasis" : "normal");
      }
      function uXt(s, a, n6, f6, d4) {
        var y4 = n6._isZoomActive;
        f6 && f6.type === "takeGlobalCursor" && (y4 = f6.key === "dataZoomSelect" ? f6.dataZoomSelectActive : false), n6._isZoomActive = y4, s.setIconStatus("zoom", y4 ? "emphasis" : "normal");
        var _ = new lCe(cCe(s), a, { include: ["grid"] }), S = _.makePanelOpts(d4, function(T) {
          return T.xAxisDeclared && !T.yAxisDeclared ? "lineX" : !T.xAxisDeclared && T.yAxisDeclared ? "lineY" : "rect";
        });
        n6._brushController.setPanels(S).enableBrush(y4 && S.length ? { brushType: "auto", brushStyle: s.getModel("brushStyle").getItemStyle() } : false);
      }
      s4t("dataZoom", function(s) {
        var a = s.getComponent("toolbox", 0), n6 = ["feature", "dataZoom"];
        if (!a || a.get(n6) == null)
          return;
        var f6 = a.getModel(n6), d4 = [], y4 = cCe(f6), _ = gR(s, y4);
        uCe(_.xAxisModels, function(T) {
          return S(T, "xAxis", "xAxisIndex");
        }), uCe(_.yAxisModels, function(T) {
          return S(T, "yAxis", "yAxisIndex");
        });
        function S(T, E, O) {
          var R = T.componentIndex, V = { type: "select", $fromToolbox: true, filterMode: f6.get("filterMode", true) || "filter", id: aXt + E + R };
          V[O] = R, d4.push(V);
        }
        return d4;
      });
      var cXt = oXt;
      function fXt(s) {
        s.registerComponentModel(I$t), s.registerComponentView(O$t), iV("saveAsImage", L$t), iV("magicType", F$t), iV("dataView", X$t), iV("dataZoom", cXt), iV("restore", eXt), Il(T$t);
      }
      var hXt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "tooltip", a.dependencies = ["axisPointer"], a.defaultOption = { z: 60, show: true, showContent: true, trigger: "item", triggerOn: "mousemove|click", alwaysShowContent: false, displayMode: "single", renderMode: "auto", confine: null, showDelay: 0, hideDelay: 100, transitionDuration: 0.4, enterable: false, backgroundColor: "#fff", shadowBlur: 10, shadowColor: "rgba(0, 0, 0, .2)", shadowOffsetX: 1, shadowOffsetY: 2, borderRadius: 4, borderWidth: 1, padding: null, extraCssText: "", axisPointer: { type: "line", axis: "auto", animation: "auto", animationDurationUpdate: 200, animationEasingUpdate: "exponentialOut", crossStyle: { color: "#999", width: 1, type: "dashed", textStyle: {} } }, textStyle: { color: "#666", fontSize: 14 } }, a;
      }(oc), pXt = hXt;
      function LKe(s) {
        var a = s.get("confine");
        return a != null ? !!a : s.get("renderMode") === "richText";
      }
      function RKe(s) {
        if (Na.domSupported) {
          for (var a = document.documentElement.style, n6 = 0, f6 = s.length; n6 < f6; n6++)
            if (s[n6] in a)
              return s[n6];
        }
      }
      var NKe = RKe(["transform", "webkitTransform", "OTransform", "MozTransform", "msTransform"]), dXt = RKe(["webkitTransition", "transition", "OTransition", "MozTransition", "msTransition"]);
      function FKe(s, a) {
        if (!s)
          return a;
        a = Lje(a, true);
        var n6 = s.indexOf(a);
        return s = n6 === -1 ? a : "-" + s.slice(0, n6) + "-" + a, s.toLowerCase();
      }
      function vXt(s, a) {
        var n6 = s.currentStyle || document.defaultView && document.defaultView.getComputedStyle(s);
        return n6 ? a ? n6[a] : n6 : null;
      }
      var gXt = FKe(dXt, "transition"), fCe = FKe(NKe, "transform"), yXt = "position:absolute;display:block;border-style:solid;white-space:nowrap;z-index:9999999;" + (Na.transform3dSupported ? "will-change:transform;" : "");
      function mXt(s) {
        return s = s === "left" ? "right" : s === "right" ? "left" : s === "top" ? "bottom" : "top", s;
      }
      function bXt(s, a, n6) {
        if (!Wa(n6) || n6 === "inside")
          return "";
        var f6 = s.get("backgroundColor"), d4 = s.get("borderWidth");
        a = LR(a);
        var y4 = mXt(n6), _ = Math.max(Math.round(d4) * 1.5, 6), S = "", T = fCe + ":", E;
        Ns(["left", "right"], y4) > -1 ? (S += "top:50%", T += "translateY(-50%) rotate(" + (E = y4 === "left" ? -225 : -45) + "deg)") : (S += "left:50%", T += "translateX(-50%) rotate(" + (E = y4 === "top" ? 225 : 45) + "deg)");
        var O = E * Math.PI / 180, R = _ + d4, V = R * Math.abs(Math.cos(O)) + R * Math.abs(Math.sin(O)), z3 = Math.round(((V - Math.SQRT2 * d4) / 2 + Math.SQRT2 * d4 - (V - R) / 2) * 100) / 100;
        S += ";" + y4 + ":-" + z3 + "px";
        var H = a + " solid " + d4 + "px;", Z = ["position:absolute;width:" + _ + "px;height:" + _ + "px;", S + ";" + T + ";", "border-bottom:" + H, "border-right:" + H, "background-color:" + f6 + ";"];
        return '<div style="' + Z.join("") + '"></div>';
      }
      function _Xt(s, a) {
        var n6 = "cubic-bezier(0.23,1,0.32,1)", f6 = " " + s / 2 + "s " + n6, d4 = "opacity" + f6 + ",visibility" + f6;
        return a || (f6 = " " + s + "s " + n6, d4 += Na.transformSupported ? "," + fCe + f6 : ",left" + f6 + ",top" + f6), gXt + ":" + d4;
      }
      function VKe(s, a, n6) {
        var f6 = s.toFixed(0) + "px", d4 = a.toFixed(0) + "px";
        if (!Na.transformSupported)
          return n6 ? "top:" + d4 + ";left:" + f6 + ";" : [["top", d4], ["left", f6]];
        var y4 = Na.transform3dSupported, _ = "translate" + (y4 ? "3d" : "") + "(" + f6 + "," + d4 + (y4 ? ",0" : "") + ")";
        return n6 ? "top:0;left:0;" + fCe + ":" + _ + ";" : [["top", 0], ["left", 0], [NKe, _]];
      }
      function xXt(s) {
        var a = [], n6 = s.get("fontSize"), f6 = s.getTextColor();
        f6 && a.push("color:" + f6), a.push("font:" + s.getFont()), n6 && a.push("line-height:" + Math.round(n6 * 3 / 2) + "px");
        var d4 = s.get("textShadowColor"), y4 = s.get("textShadowBlur") || 0, _ = s.get("textShadowOffsetX") || 0, S = s.get("textShadowOffsetY") || 0;
        return d4 && y4 && a.push("text-shadow:" + _ + "px " + S + "px " + y4 + "px " + d4), gt(["decoration", "align"], function(T) {
          var E = s.get(T);
          E && a.push("text-" + T + ":" + E);
        }), a.join(";");
      }
      function wXt(s, a, n6) {
        var f6 = [], d4 = s.get("transitionDuration"), y4 = s.get("backgroundColor"), _ = s.get("shadowBlur"), S = s.get("shadowColor"), T = s.get("shadowOffsetX"), E = s.get("shadowOffsetY"), O = s.getModel("textStyle"), R = jGe(s, "html"), V = T + "px " + E + "px " + _ + "px " + S;
        return f6.push("box-shadow:" + V), a && d4 && f6.push(_Xt(d4, n6)), y4 && f6.push("background-color:" + y4), gt(["width", "color", "radius"], function(z3) {
          var H = "border-" + z3, Z = Lje(H), ee = s.get(Z);
          ee != null && f6.push(H + ":" + ee + (z3 === "color" ? "" : "px"));
        }), f6.push(xXt(O)), R != null && f6.push("padding:" + I7(R).join("px ") + "px"), f6.join(";") + ";";
      }
      function BKe(s, a, n6, f6, d4) {
        var y4 = a && a.painter;
        if (n6) {
          var _ = y4 && y4.getViewportRoot();
          _ && Lre(s, _, document.body, f6, d4);
        } else {
          s[0] = f6, s[1] = d4;
          var S = y4 && y4.getViewportRootOffset();
          S && (s[0] += S.offsetLeft, s[1] += S.offsetTop);
        }
        s[2] = s[0] / a.getWidth(), s[3] = s[1] / a.getHeight();
      }
      var SXt = function() {
        function s(a, n6, f6) {
          if (this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._firstShow = true, this._longHide = true, Na.wxa)
            return null;
          var d4 = document.createElement("div");
          d4.domBelongToZr = true, this.el = d4;
          var y4 = this._zr = n6.getZr(), _ = this._appendToBody = f6 && f6.appendToBody;
          BKe(this._styleCoord, y4, _, n6.getWidth() / 2, n6.getHeight() / 2), _ ? document.body.appendChild(d4) : a.appendChild(d4), this._container = a;
          var S = this;
          d4.onmouseenter = function() {
            S._enterable && (clearTimeout(S._hideTimeout), S._show = true), S._inContent = true;
          }, d4.onmousemove = function(T) {
            if (T = T || window.event, !S._enterable) {
              var E = y4.handler, O = y4.painter.getViewportRoot();
              Eg(O, T, true), E.dispatch("mousemove", T);
            }
          }, d4.onmouseleave = function() {
            S._inContent = false, S._enterable && S._show && S.hideLater(S._hideDelay);
          };
        }
        return s.prototype.update = function(a) {
          var n6 = this._container, f6 = vXt(n6, "position"), d4 = n6.style;
          d4.position !== "absolute" && f6 !== "absolute" && (d4.position = "relative");
          var y4 = a.get("alwaysShowContent");
          y4 && this._moveIfResized(), this.el.className = a.get("className") || "";
        }, s.prototype.show = function(a, n6) {
          clearTimeout(this._hideTimeout), clearTimeout(this._longHideTimeout);
          var f6 = this.el, d4 = f6.style, y4 = this._styleCoord;
          f6.innerHTML ? d4.cssText = yXt + wXt(a, !this._firstShow, this._longHide) + VKe(y4[0], y4[1], true) + ("border-color:" + LR(n6) + ";") + (a.get("extraCssText") || "") + (";pointer-events:" + (this._enterable ? "auto" : "none")) : d4.display = "none", this._show = true, this._firstShow = false, this._longHide = false;
        }, s.prototype.setContent = function(a, n6, f6, d4, y4) {
          var _ = this.el;
          if (a == null) {
            _.innerHTML = "";
            return;
          }
          var S = "";
          if (Wa(y4) && f6.get("trigger") === "item" && !LKe(f6) && (S = bXt(f6, d4, y4)), Wa(a))
            _.innerHTML = a + S;
          else if (a) {
            _.innerHTML = "", Di(a) || (a = [a]);
            for (var T = 0; T < a.length; T++)
              VL(a[T]) && a[T].parentNode !== _ && _.appendChild(a[T]);
            if (S && _.childNodes.length) {
              var E = document.createElement("div");
              E.innerHTML = S, _.appendChild(E);
            }
          }
        }, s.prototype.setEnterable = function(a) {
          this._enterable = a;
        }, s.prototype.getSize = function() {
          var a = this.el;
          return [a.offsetWidth, a.offsetHeight];
        }, s.prototype.moveTo = function(a, n6) {
          var f6 = this._styleCoord;
          if (BKe(f6, this._zr, this._appendToBody, a, n6), f6[0] != null && f6[1] != null) {
            var d4 = this.el.style, y4 = VKe(f6[0], f6[1]);
            gt(y4, function(_) {
              d4[_[0]] = _[1];
            });
          }
        }, s.prototype._moveIfResized = function() {
          var a = this._styleCoord[2], n6 = this._styleCoord[3];
          this.moveTo(a * this._zr.getWidth(), n6 * this._zr.getHeight());
        }, s.prototype.hide = function() {
          var a = this, n6 = this.el.style;
          n6.visibility = "hidden", n6.opacity = "0", Na.transform3dSupported && (n6.willChange = ""), this._show = false, this._longHideTimeout = setTimeout(function() {
            return a._longHide = true;
          }, 500);
        }, s.prototype.hideLater = function(a) {
          this._show && !(this._inContent && this._enterable) && (a ? (this._hideDelay = a, this._show = false, this._hideTimeout = setTimeout(Za(this.hide, this), a)) : this.hide());
        }, s.prototype.isShow = function() {
          return this._show;
        }, s.prototype.dispose = function() {
          this.el.parentNode.removeChild(this.el);
        }, s;
      }(), CXt = SXt, MXt = function() {
        function s(a) {
          this._show = false, this._styleCoord = [0, 0, 0, 0], this._enterable = true, this._zr = a.getZr(), jKe(this._styleCoord, this._zr, a.getWidth() / 2, a.getHeight() / 2);
        }
        return s.prototype.update = function(a) {
          var n6 = a.get("alwaysShowContent");
          n6 && this._moveIfResized();
        }, s.prototype.show = function() {
          this._hideTimeout && clearTimeout(this._hideTimeout), this.el.show(), this._show = true;
        }, s.prototype.setContent = function(a, n6, f6, d4, y4) {
          var _ = this;
          Qo(a) && Ul(""), this.el && this._zr.remove(this.el);
          var S = f6.getModel("textStyle");
          this.el = new ju({ style: { rich: n6.richTextStyles, text: a, lineHeight: 22, borderWidth: 1, borderColor: d4, textShadowColor: S.get("textShadowColor"), fill: f6.get(["textStyle", "color"]), padding: jGe(f6, "richText"), verticalAlign: "top", align: "left" }, z: f6.get("z") }), gt(["backgroundColor", "borderRadius", "shadowColor", "shadowBlur", "shadowOffsetX", "shadowOffsetY"], function(E) {
            _.el.style[E] = f6.get(E);
          }), gt(["textShadowBlur", "textShadowOffsetX", "textShadowOffsetY"], function(E) {
            _.el.style[E] = S.get(E) || 0;
          }), this._zr.add(this.el);
          var T = this;
          this.el.on("mouseover", function() {
            T._enterable && (clearTimeout(T._hideTimeout), T._show = true), T._inContent = true;
          }), this.el.on("mouseout", function() {
            T._enterable && T._show && T.hideLater(T._hideDelay), T._inContent = false;
          });
        }, s.prototype.setEnterable = function(a) {
          this._enterable = a;
        }, s.prototype.getSize = function() {
          var a = this.el, n6 = this.el.getBoundingRect(), f6 = zKe(a.style);
          return [n6.width + f6.left + f6.right, n6.height + f6.top + f6.bottom];
        }, s.prototype.moveTo = function(a, n6) {
          var f6 = this.el;
          if (f6) {
            var d4 = this._styleCoord;
            jKe(d4, this._zr, a, n6), a = d4[0], n6 = d4[1];
            var y4 = f6.style, _ = h3(y4.borderWidth || 0), S = zKe(y4);
            f6.x = a + _ + S.left, f6.y = n6 + _ + S.top, f6.markRedraw();
          }
        }, s.prototype._moveIfResized = function() {
          var a = this._styleCoord[2], n6 = this._styleCoord[3];
          this.moveTo(a * this._zr.getWidth(), n6 * this._zr.getHeight());
        }, s.prototype.hide = function() {
          this.el && this.el.hide(), this._show = false;
        }, s.prototype.hideLater = function(a) {
          this._show && !(this._inContent && this._enterable) && (a ? (this._hideDelay = a, this._show = false, this._hideTimeout = setTimeout(Za(this.hide, this), a)) : this.hide());
        }, s.prototype.isShow = function() {
          return this._show;
        }, s.prototype.dispose = function() {
          this._zr.remove(this.el);
        }, s;
      }();
      function h3(s) {
        return Math.max(0, s);
      }
      function zKe(s) {
        var a = h3(s.shadowBlur || 0), n6 = h3(s.shadowOffsetX || 0), f6 = h3(s.shadowOffsetY || 0);
        return { left: h3(a - n6), right: h3(a + n6), top: h3(a - f6), bottom: h3(a + f6) };
      }
      function jKe(s, a, n6, f6) {
        s[0] = n6, s[1] = f6, s[2] = s[0] / a.getWidth(), s[3] = s[1] / a.getHeight();
      }
      var TXt = MXt, AXt = new xu({ shape: { x: -1, y: -1, width: 2, height: 2 } }), IXt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6) {
          if (!(Na.node || !f6.getDom())) {
            var d4 = n6.getComponent("tooltip"), y4 = this._renderMode = Qbe(d4.get("renderMode"));
            this._tooltipContent = y4 === "richText" ? new TXt(f6) : new CXt(f6.getDom(), f6, { appendToBody: d4.get("appendToBody", true) });
          }
        }, a.prototype.render = function(n6, f6, d4) {
          if (!(Na.node || !d4.getDom())) {
            this.group.removeAll(), this._tooltipModel = n6, this._ecModel = f6, this._api = d4, this._alwaysShowContent = n6.get("alwaysShowContent");
            var y4 = this._tooltipContent;
            y4.update(n6), y4.setEnterable(n6.get("enterable")), this._initGlobalListener(), this._keepShow(), this._renderMode !== "richText" && n6.get("transitionDuration") ? N7(this, "_updatePosition", 50, "fixRate") : y$(this, "_updatePosition");
          }
        }, a.prototype._initGlobalListener = function() {
          var n6 = this._tooltipModel, f6 = n6.get("triggerOn");
          qYe("itemTooltip", this._api, Za(function(d4, y4, _) {
            f6 !== "none" && (f6.indexOf(d4) >= 0 ? this._tryShow(y4, _) : d4 === "leave" && this._hide(_));
          }, this));
        }, a.prototype._keepShow = function() {
          var n6 = this._tooltipModel, f6 = this._ecModel, d4 = this._api;
          if (this._lastX != null && this._lastY != null && n6.get("triggerOn") !== "none") {
            var y4 = this;
            clearTimeout(this._refreshUpdateTimeout), this._refreshUpdateTimeout = setTimeout(function() {
              !d4.isDisposed() && y4.manuallyShowTip(n6, f6, d4, { x: y4._lastX, y: y4._lastY, dataByCoordSys: y4._lastDataByCoordSys });
            });
          }
        }, a.prototype.manuallyShowTip = function(n6, f6, d4, y4) {
          if (!(y4.from === this.uid || Na.node || !d4.getDom())) {
            var _ = GKe(y4, d4);
            this._ticket = "";
            var S = y4.dataByCoordSys, T = OXt(y4, f6, d4);
            if (T) {
              var E = T.el.getBoundingRect().clone();
              E.applyTransform(T.el.transform), this._tryShow({ offsetX: E.x + E.width / 2, offsetY: E.y + E.height / 2, target: T.el, position: y4.position, positionDefault: "bottom" }, _);
            } else if (y4.tooltip && y4.x != null && y4.y != null) {
              var O = AXt;
              O.x = y4.x, O.y = y4.y, O.update(), qo(O).tooltipConfig = { name: null, option: y4.tooltip }, this._tryShow({ offsetX: y4.x, offsetY: y4.y, target: O }, _);
            } else if (S)
              this._tryShow({ offsetX: y4.x, offsetY: y4.y, position: y4.position, dataByCoordSys: S, tooltipOption: y4.tooltipOption }, _);
            else if (y4.seriesIndex != null) {
              if (this._manuallyAxisShowTip(n6, f6, d4, y4))
                return;
              var R = XYe(y4, f6), V = R.point[0], z3 = R.point[1];
              V != null && z3 != null && this._tryShow({ offsetX: V, offsetY: z3, target: R.el, position: y4.position, positionDefault: "bottom" }, _);
            } else
              y4.x != null && y4.y != null && (d4.dispatchAction({ type: "updateAxisPointer", x: y4.x, y: y4.y }), this._tryShow({ offsetX: y4.x, offsetY: y4.y, position: y4.position, target: d4.getZr().findHover(y4.x, y4.y).target }, _));
          }
        }, a.prototype.manuallyHideTip = function(n6, f6, d4, y4) {
          var _ = this._tooltipContent;
          !this._alwaysShowContent && this._tooltipModel && _.hideLater(this._tooltipModel.get("hideDelay")), this._lastX = this._lastY = this._lastDataByCoordSys = null, y4.from !== this.uid && this._hide(GKe(y4, d4));
        }, a.prototype._manuallyAxisShowTip = function(n6, f6, d4, y4) {
          var _ = y4.seriesIndex, S = y4.dataIndex, T = f6.getComponent("axisPointer").coordSysAxesInfo;
          if (!(_ == null || S == null || T == null)) {
            var E = f6.getSeriesByIndex(_);
            if (E) {
              var O = E.getData(), R = pX([O.getItemModel(S), E, (E.coordinateSystem || {}).model], this._tooltipModel);
              if (R.get("trigger") === "axis")
                return d4.dispatchAction({ type: "updateAxisPointer", seriesIndex: _, dataIndex: S, position: y4.position }), true;
            }
          }
        }, a.prototype._tryShow = function(n6, f6) {
          var d4 = n6.target, y4 = this._tooltipModel;
          if (y4) {
            this._lastX = n6.offsetX, this._lastY = n6.offsetY;
            var _ = n6.dataByCoordSys;
            if (_ && _.length)
              this._showAxisTooltip(_, n6);
            else if (d4) {
              this._lastDataByCoordSys = null;
              var S, T;
              V7(d4, function(E) {
                if (qo(E).dataIndex != null)
                  return S = E, true;
                if (qo(E).tooltipConfig != null)
                  return T = E, true;
              }, true), S ? this._showSeriesItemTooltip(n6, S, f6) : T ? this._showComponentItemTooltip(n6, T, f6) : this._hide(f6);
            } else
              this._lastDataByCoordSys = null, this._hide(f6);
          }
        }, a.prototype._showOrMove = function(n6, f6) {
          var d4 = n6.get("showDelay");
          f6 = Za(f6, this), clearTimeout(this._showTimout), d4 > 0 ? this._showTimout = setTimeout(f6, d4) : f6();
        }, a.prototype._showAxisTooltip = function(n6, f6) {
          var d4 = this._ecModel, y4 = this._tooltipModel, _ = [f6.offsetX, f6.offsetY], S = pX([f6.tooltipOption], y4), T = this._renderMode, E = [], O = Rg("section", { blocks: [], noHeader: true }), R = [], V = new Qxe();
          gt(n6, function(fe) {
            gt(fe.dataByAxis, function(_e) {
              var pe = d4.getComponent(_e.axisDim + "Axis", _e.axisIndex), Ve = _e.value;
              if (!(!pe || Ve == null)) {
                var Le = zYe(Ve, pe.axis, d4, _e.seriesDataIndices, _e.valueLabelOpt), je = Rg("section", { header: Le, noHeader: !wh(Le), sortBlocks: true, blocks: [] });
                O.blocks.push(je), gt(_e.seriesDataIndices, function(Xe) {
                  var Ye = d4.getSeriesByIndex(Xe.seriesIndex), rt2 = Xe.dataIndexInside, ut = Ye.getDataParams(rt2);
                  if (!(ut.dataIndex < 0)) {
                    ut.axisDim = _e.axisDim, ut.axisIndex = _e.axisIndex, ut.axisType = _e.axisType, ut.axisId = _e.axisId, ut.axisValue = Nwe(pe.axis, { value: Ve }), ut.axisValueLabel = Le, ut.marker = V.makeTooltipMarker("item", LR(ut.color), T);
                    var wt = xGe(Ye.formatTooltip(rt2, true, null)), dt = wt.frag;
                    if (dt) {
                      var Gt = pX([Ye], y4).get("valueFormatter");
                      je.blocks.push(Gt ? ei({ valueFormatter: Gt }, dt) : dt);
                    }
                    wt.text && R.push(wt.text), E.push(ut);
                  }
                });
              }
            });
          }), O.blocks.reverse(), R.reverse();
          var z3 = f6.position, H = S.get("order"), Z = VGe(O, V, T, H, d4.get("useUTC"), S.get("textStyle"));
          Z && R.unshift(Z);
          var ee = T === "richText" ? `

` : "<br/>", oe = R.join(ee);
          this._showOrMove(S, function() {
            this._updateContentNotChangedOnAxis(n6, E) ? this._updatePosition(S, z3, _[0], _[1], this._tooltipContent, E) : this._showTooltipContent(S, oe, E, Math.random() + "", _[0], _[1], z3, null, V);
          });
        }, a.prototype._showSeriesItemTooltip = function(n6, f6, d4) {
          var y4 = this._ecModel, _ = qo(f6), S = _.seriesIndex, T = y4.getSeriesByIndex(S), E = _.dataModel || T, O = _.dataIndex, R = _.dataType, V = E.getData(R), z3 = this._renderMode, H = n6.positionDefault, Z = pX([V.getItemModel(O), E, T && (T.coordinateSystem || {}).model], this._tooltipModel, H ? { position: H } : null), ee = Z.get("trigger");
          if (!(ee != null && ee !== "item")) {
            var oe = E.getDataParams(O, R), fe = new Qxe();
            oe.marker = fe.makeTooltipMarker("item", LR(oe.color), z3);
            var _e = xGe(E.formatTooltip(O, false, R)), pe = Z.get("order"), Ve = Z.get("valueFormatter"), Le = _e.frag, je = Le ? VGe(Ve ? ei({ valueFormatter: Ve }, Le) : Le, fe, z3, pe, y4.get("useUTC"), Z.get("textStyle")) : _e.text, Xe = "item_" + E.name + "_" + O;
            this._showOrMove(Z, function() {
              this._showTooltipContent(Z, je, oe, Xe, n6.offsetX, n6.offsetY, n6.position, n6.target, fe);
            }), d4({ type: "showTip", dataIndexInside: O, dataIndex: V.getRawIndex(O), seriesIndex: S, from: this.uid });
          }
        }, a.prototype._showComponentItemTooltip = function(n6, f6, d4) {
          var y4 = qo(f6), _ = y4.tooltipConfig, S = _.option || {};
          if (Wa(S)) {
            var T = S;
            S = { content: T, formatter: T };
          }
          var E = [S], O = this._ecModel.getComponent(y4.componentMainType, y4.componentIndex);
          O && E.push(O), E.push({ formatter: S.content });
          var R = n6.positionDefault, V = pX(E, this._tooltipModel, R ? { position: R } : null), z3 = V.get("content"), H = Math.random() + "", Z = new Qxe();
          this._showOrMove(V, function() {
            var ee = Bo(V.get("formatterParams") || {});
            this._showTooltipContent(V, z3, ee, H, n6.offsetX, n6.offsetY, n6.position, f6, Z);
          }), d4({ type: "showTip", from: this.uid });
        }, a.prototype._showTooltipContent = function(n6, f6, d4, y4, _, S, T, E, O) {
          if (this._ticket = "", !(!n6.get("showContent") || !n6.get("show"))) {
            var R = this._tooltipContent;
            R.setEnterable(n6.get("enterable"));
            var V = n6.get("formatter");
            T = T || n6.get("position");
            var z3 = f6, H = this._getNearestPoint([_, S], d4, n6.get("trigger"), n6.get("borderColor")), Z = H.color;
            if (V)
              if (Wa(V)) {
                var ee = n6.ecModel.get("useUTC"), oe = Di(d4) ? d4[0] : d4, fe = oe && oe.axisType && oe.axisType.indexOf("time") >= 0;
                z3 = V, fe && (z3 = Mae(oe.axisValue, z3, ee)), z3 = Nje(z3, d4, true);
              } else if (jo(V)) {
                var _e = Za(function(pe, Ve) {
                  pe === this._ticket && (R.setContent(Ve, O, n6, Z, T), this._updatePosition(n6, T, _, S, R, d4, E));
                }, this);
                this._ticket = y4, z3 = V(d4, y4, _e);
              } else
                z3 = V;
            R.setContent(z3, O, n6, Z, T), R.show(n6, Z), this._updatePosition(n6, T, _, S, R, d4, E);
          }
        }, a.prototype._getNearestPoint = function(n6, f6, d4, y4) {
          if (d4 === "axis" || Di(f6))
            return { color: y4 || (this._renderMode === "html" ? "#fff" : "none") };
          if (!Di(f6))
            return { color: y4 || f6.color || f6.borderColor };
        }, a.prototype._updatePosition = function(n6, f6, d4, y4, _, S, T) {
          var E = this._api.getWidth(), O = this._api.getHeight();
          f6 = f6 || n6.get("position");
          var R = _.getSize(), V = n6.get("align"), z3 = n6.get("verticalAlign"), H = T && T.getBoundingRect().clone();
          if (T && H.applyTransform(T.transform), jo(f6) && (f6 = f6([d4, y4], S, _.el, H, { viewSize: [E, O], contentSize: R.slice() })), Di(f6))
            d4 = Ia(f6[0], E), y4 = Ia(f6[1], O);
          else if (Qo(f6)) {
            var Z = f6;
            Z.width = R[0], Z.height = R[1];
            var ee = Qv(Z, { width: E, height: O });
            d4 = ee.x, y4 = ee.y, V = null, z3 = null;
          } else if (Wa(f6) && T) {
            var oe = kXt(f6, H, R, n6.get("borderWidth"));
            d4 = oe[0], y4 = oe[1];
          } else {
            var oe = EXt(d4, y4, _, E, O, V ? null : 20, z3 ? null : 20);
            d4 = oe[0], y4 = oe[1];
          }
          if (V && (d4 -= HKe(V) ? R[0] / 2 : V === "right" ? R[0] : 0), z3 && (y4 -= HKe(z3) ? R[1] / 2 : z3 === "bottom" ? R[1] : 0), LKe(n6)) {
            var oe = DXt(d4, y4, _, E, O);
            d4 = oe[0], y4 = oe[1];
          }
          _.moveTo(d4, y4);
        }, a.prototype._updateContentNotChangedOnAxis = function(n6, f6) {
          var d4 = this._lastDataByCoordSys, y4 = this._cbParamsList, _ = !!d4 && d4.length === n6.length;
          return _ && gt(d4, function(S, T) {
            var E = S.dataByAxis || [], O = n6[T] || {}, R = O.dataByAxis || [];
            _ = _ && E.length === R.length, _ && gt(E, function(V, z3) {
              var H = R[z3] || {}, Z = V.seriesDataIndices || [], ee = H.seriesDataIndices || [];
              _ = _ && V.value === H.value && V.axisType === H.axisType && V.axisId === H.axisId && Z.length === ee.length, _ && gt(Z, function(oe, fe) {
                var _e = ee[fe];
                _ = _ && oe.seriesIndex === _e.seriesIndex && oe.dataIndex === _e.dataIndex;
              }), y4 && gt(V.seriesDataIndices, function(oe) {
                var fe = oe.seriesIndex, _e = f6[fe], pe = y4[fe];
                _e && pe && pe.data !== _e.data && (_ = false);
              });
            });
          }), this._lastDataByCoordSys = n6, this._cbParamsList = f6, !!_;
        }, a.prototype._hide = function(n6) {
          this._lastDataByCoordSys = null, n6({ type: "hideTip", from: this.uid });
        }, a.prototype.dispose = function(n6, f6) {
          Na.node || !f6.getDom() || (y$(this, "_updatePosition"), this._tooltipContent.dispose(), q2e("itemTooltip", f6));
        }, a.type = "tooltip", a;
      }(sd);
      function pX(s, a, n6) {
        var f6 = a.ecModel, d4;
        n6 ? (d4 = new Sh(n6, f6, f6), d4 = new Sh(a.option, d4, f6)) : d4 = a;
        for (var y4 = s.length - 1; y4 >= 0; y4--) {
          var _ = s[y4];
          _ && (_ instanceof Sh && (_ = _.get("tooltip", true)), Wa(_) && (_ = { formatter: _ }), _ && (d4 = new Sh(_, d4, f6)));
        }
        return d4;
      }
      function GKe(s, a) {
        return s.dispatchAction || Za(a.dispatchAction, a);
      }
      function EXt(s, a, n6, f6, d4, y4, _) {
        var S = n6.getSize(), T = S[0], E = S[1];
        return y4 != null && (s + T + y4 + 2 > f6 ? s -= T + y4 : s += y4), _ != null && (a + E + _ > d4 ? a -= E + _ : a += _), [s, a];
      }
      function DXt(s, a, n6, f6, d4) {
        var y4 = n6.getSize(), _ = y4[0], S = y4[1];
        return s = Math.min(s + _, f6) - _, a = Math.min(a + S, d4) - S, s = Math.max(s, 0), a = Math.max(a, 0), [s, a];
      }
      function kXt(s, a, n6, f6) {
        var d4 = n6[0], y4 = n6[1], _ = Math.ceil(Math.SQRT2 * f6) + 8, S = 0, T = 0, E = a.width, O = a.height;
        switch (s) {
          case "inside":
            S = a.x + E / 2 - d4 / 2, T = a.y + O / 2 - y4 / 2;
            break;
          case "top":
            S = a.x + E / 2 - d4 / 2, T = a.y - y4 - _;
            break;
          case "bottom":
            S = a.x + E / 2 - d4 / 2, T = a.y + O + _;
            break;
          case "left":
            S = a.x - d4 - _, T = a.y + O / 2 - y4 / 2;
            break;
          case "right":
            S = a.x + E + _, T = a.y + O / 2 - y4 / 2;
        }
        return [S, T];
      }
      function HKe(s) {
        return s === "center" || s === "middle";
      }
      function OXt(s, a, n6) {
        var f6 = pE(s).queryOptionMap, d4 = f6.keys()[0];
        if (!(!d4 || d4 === "series")) {
          var y4 = yR(a, d4, f6.get(d4), { useDefault: false, enableAll: false, enableNone: false }), _ = y4.models[0];
          if (_) {
            var S = n6.getViewOfComponentModel(_), T;
            if (S.group.traverse(function(E) {
              var O = qo(E).tooltipConfig;
              if (O && O.name === s.name)
                return T = E, true;
            }), T)
              return { componentMainType: d4, componentIndex: _.componentIndex, el: T };
          }
        }
      }
      var PXt = IXt;
      function LXt(s) {
        Il(fX), s.registerComponentModel(pXt), s.registerComponentView(PXt), s.registerAction({ type: "showTip", event: "showTip", update: "tooltip:manuallyShowTip" }, rd), s.registerAction({ type: "hideTip", event: "hideTip", update: "tooltip:manuallyHideTip" }, rd);
      }
      var RXt = ["rect", "polygon", "keep", "clear"];
      function NXt(s, a) {
        var n6 = jc(s ? s.brush : []);
        if (n6.length) {
          var f6 = [];
          gt(n6, function(T) {
            var E = T.hasOwnProperty("toolbox") ? T.toolbox : [];
            E instanceof Array && (f6 = f6.concat(E));
          });
          var d4 = s && s.toolbox;
          Di(d4) && (d4 = d4[0]), d4 || (d4 = { feature: {} }, s.toolbox = [d4]);
          var y4 = d4.feature || (d4.feature = {}), _ = y4.brush || (y4.brush = {}), S = _.type || (_.type = []);
          S.push.apply(S, f6), FXt(S), a && !S.length && S.push.apply(S, RXt);
        }
      }
      function FXt(s) {
        var a = {};
        gt(s, function(n6) {
          a[n6] = 1;
        }), s.length = 0, gt(a, function(n6, f6) {
          s.push(f6);
        });
      }
      var WKe = gt;
      function UKe(s) {
        if (s) {
          for (var a in s)
            if (s.hasOwnProperty(a))
              return true;
        }
      }
      function hCe(s, a, n6) {
        var f6 = {};
        return WKe(a, function(y4) {
          var _ = f6[y4] = d4();
          WKe(s[y4], function(S, T) {
            if (zy.isValidType(T)) {
              var E = { type: T, visual: S };
              n6 && n6(E, y4), _[T] = new zy(E), T === "opacity" && (E = Bo(E), E.type = "colorAlpha", _.__hidden.__alphaForOpacity = new zy(E));
            }
          });
        }), f6;
        function d4() {
          var y4 = function() {
          };
          y4.prototype.__hidden = y4.prototype;
          var _ = new y4();
          return _;
        }
      }
      function qKe(s, a, n6) {
        var f6;
        gt(n6, function(d4) {
          a.hasOwnProperty(d4) && UKe(a[d4]) && (f6 = true);
        }), f6 && gt(n6, function(d4) {
          a.hasOwnProperty(d4) && UKe(a[d4]) ? s[d4] = Bo(a[d4]) : delete s[d4];
        });
      }
      function VXt(s, a, n6, f6, d4, y4) {
        var _ = {};
        gt(s, function(R) {
          var V = zy.prepareVisualTypes(a[R]);
          _[R] = V;
        });
        var S;
        function T(R) {
          return awe(n6, S, R);
        }
        function E(R, V) {
          uHe(n6, S, R, V);
        }
        y4 == null ? n6.each(O) : n6.each([y4], O);
        function O(R, V) {
          S = y4 == null ? R : V;
          var z3 = n6.getRawDataItem(S);
          if (!(z3 && z3.visualMap === false))
            for (var H = f6.call(d4, R), Z = a[H], ee = _[H], oe = 0, fe = ee.length; oe < fe; oe++) {
              var _e = ee[oe];
              Z[_e] && Z[_e].applyVisual(R, T, E);
            }
        }
      }
      function BXt(s, a, n6, f6) {
        var d4 = {};
        return gt(s, function(y4) {
          var _ = zy.prepareVisualTypes(a[y4]);
          d4[y4] = _;
        }), { progress: function(y4, _) {
          var S;
          f6 != null && (S = _.getDimensionIndex(f6));
          function T(pe) {
            return awe(_, O, pe);
          }
          function E(pe, Ve) {
            uHe(_, O, pe, Ve);
          }
          for (var O, R = _.getStore(); (O = y4.next()) != null; ) {
            var V = _.getRawDataItem(O);
            if (!(V && V.visualMap === false))
              for (var z3 = f6 != null ? R.get(S, O) : O, H = n6(z3), Z = a[H], ee = d4[H], oe = 0, fe = ee.length; oe < fe; oe++) {
                var _e = ee[oe];
                Z[_e] && Z[_e].applyVisual(z3, T, E);
              }
          }
        } };
      }
      function zXt(s) {
        var a = s.brushType, n6 = { point: function(f6) {
          return $Ke[a].point(f6, n6, s);
        }, rect: function(f6) {
          return $Ke[a].rect(f6, n6, s);
        } };
        return n6;
      }
      var $Ke = { lineX: XKe(0), lineY: XKe(1), rect: { point: function(s, a, n6) {
        return s && n6.boundingRect.contain(s[0], s[1]);
      }, rect: function(s, a, n6) {
        return s && n6.boundingRect.intersect(s);
      } }, polygon: { point: function(s, a, n6) {
        return s && n6.boundingRect.contain(s[0], s[1]) && HR(n6.range, s[0], s[1]);
      }, rect: function(s, a, n6) {
        var f6 = n6.range;
        if (!s || f6.length <= 1)
          return false;
        var d4 = s.x, y4 = s.y, _ = s.width, S = s.height, T = f6[0];
        if (HR(f6, d4, y4) || HR(f6, d4 + _, y4) || HR(f6, d4, y4 + S) || HR(f6, d4 + _, y4 + S) || il.create(s).contain(T[0], T[1]) || Lg(d4, y4, d4 + _, y4, f6) || Lg(d4, y4, d4, y4 + S, f6) || Lg(d4 + _, y4, d4 + _, y4 + S, f6) || Lg(d4, y4 + S, d4 + _, y4 + S, f6))
          return true;
      } } };
      function XKe(s) {
        var a = ["x", "y"], n6 = ["width", "height"];
        return { point: function(f6, d4, y4) {
          if (f6) {
            var _ = y4.range, S = f6[s];
            return dX(S, _);
          }
        }, rect: function(f6, d4, y4) {
          if (f6) {
            var _ = y4.range, S = [f6[a[s]], f6[a[s]] + f6[n6[s]]];
            return S[1] < S[0] && S.reverse(), dX(S[0], _) || dX(S[1], _) || dX(_[0], S) || dX(_[1], S);
          }
        } };
      }
      function dX(s, a) {
        return a[0] <= s && s <= a[1];
      }
      var YKe = ["inBrush", "outOfBrush"], pCe = "__ecBrushSelect", dCe = "__ecInBrushSelectEvent";
      function KKe(s) {
        s.eachComponent({ mainType: "brush" }, function(a) {
          var n6 = a.brushTargetManager = new lCe(a.option, s);
          n6.setInputRanges(a.areas, s);
        });
      }
      function jXt(s, a, n6) {
        var f6 = [], d4, y4;
        s.eachComponent({ mainType: "brush" }, function(_) {
          n6 && n6.type === "takeGlobalCursor" && _.setBrushOption(n6.key === "brush" ? n6.brushOption : { brushType: false });
        }), KKe(s), s.eachComponent({ mainType: "brush" }, function(_, S) {
          var T = { brushId: _.id, brushIndex: S, brushName: _.name, areas: Bo(_.areas), selected: [] };
          f6.push(T);
          var E = _.option, O = E.brushLink, R = [], V = [], z3 = [], H = false;
          S || (d4 = E.throttleType, y4 = E.throttleDelay);
          var Z = Pi(_.areas, function(Ve) {
            var Le = UXt[Ve.brushType], je = zo({ boundingRect: Le ? Le(Ve) : void 0 }, Ve);
            return je.selectors = zXt(je), je;
          }), ee = hCe(_.option, YKe, function(Ve) {
            Ve.mappingMethod = "fixed";
          });
          Di(O) && gt(O, function(Ve) {
            R[Ve] = 1;
          });
          function oe(Ve) {
            return O === "all" || !!R[Ve];
          }
          function fe(Ve) {
            return !!Ve.length;
          }
          s.eachSeries(function(Ve, Le) {
            var je = z3[Le] = [];
            Ve.subType === "parallel" ? _e(Ve, Le) : pe(Ve, Le, je);
          });
          function _e(Ve, Le) {
            var je = Ve.coordinateSystem;
            H = H || je.hasAxisBrushed(), oe(Le) && je.eachActiveState(Ve.getData(), function(Xe, Ye) {
              Xe === "active" && (V[Ye] = 1);
            });
          }
          function pe(Ve, Le, je) {
            if (!(!Ve.brushSelector || WXt(_, Le)) && (gt(Z, function(Ye) {
              _.brushTargetManager.controlSeries(Ye, Ve, s) && je.push(Ye), H = H || fe(je);
            }), oe(Le) && fe(je))) {
              var Xe = Ve.getData();
              Xe.each(function(Ye) {
                ZKe(Ve, je, Xe, Ye) && (V[Ye] = 1);
              });
            }
          }
          s.eachSeries(function(Ve, Le) {
            var je = { seriesId: Ve.id, seriesIndex: Le, seriesName: Ve.name, dataIndex: [] };
            T.selected.push(je);
            var Xe = z3[Le], Ye = Ve.getData(), rt2 = oe(Le) ? function(ut) {
              return V[ut] ? (je.dataIndex.push(Ye.getRawIndex(ut)), "inBrush") : "outOfBrush";
            } : function(ut) {
              return ZKe(Ve, Xe, Ye, ut) ? (je.dataIndex.push(Ye.getRawIndex(ut)), "inBrush") : "outOfBrush";
            };
            (oe(Le) ? H : fe(Xe)) && VXt(YKe, ee, Ye, rt2);
          });
        }), GXt(a, d4, y4, f6, n6);
      }
      function GXt(s, a, n6, f6, d4) {
        if (d4) {
          var y4 = s.getZr();
          if (!y4[dCe]) {
            y4[pCe] || (y4[pCe] = HXt);
            var _ = N7(y4, pCe, n6, a);
            _(s, f6);
          }
        }
      }
      function HXt(s, a) {
        if (!s.isDisposed()) {
          var n6 = s.getZr();
          n6[dCe] = true, s.dispatchAction({ type: "brushSelect", batch: a }), n6[dCe] = false;
        }
      }
      function ZKe(s, a, n6, f6) {
        for (var d4 = 0, y4 = a.length; d4 < y4; d4++) {
          var _ = a[d4];
          if (s.brushSelector(f6, n6, _.selectors, _))
            return true;
        }
      }
      function WXt(s, a) {
        var n6 = s.option.seriesIndex;
        return n6 != null && n6 !== "all" && (Di(n6) ? Ns(n6, a) < 0 : a !== n6);
      }
      var UXt = { rect: function(s) {
        return JKe(s.range);
      }, polygon: function(s) {
        for (var a, n6 = s.range, f6 = 0, d4 = n6.length; f6 < d4; f6++) {
          a = a || [[1 / 0, -1 / 0], [1 / 0, -1 / 0]];
          var y4 = n6[f6];
          y4[0] < a[0][0] && (a[0][0] = y4[0]), y4[0] > a[0][1] && (a[0][1] = y4[0]), y4[1] < a[1][0] && (a[1][0] = y4[1]), y4[1] > a[1][1] && (a[1][1] = y4[1]);
        }
        return a && JKe(a);
      } };
      function JKe(s) {
        return new il(s[0][0], s[1][0], s[0][1] - s[0][0], s[1][1] - s[1][0]);
      }
      var qXt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6) {
          this.ecModel = n6, this.api = f6, this.model, (this._brushController = new m2e(f6.getZr())).on("brush", Za(this._onBrush, this)).mount();
        }, a.prototype.render = function(n6, f6, d4, y4) {
          this.model = n6, this._updateController(n6, f6, d4, y4);
        }, a.prototype.updateTransform = function(n6, f6, d4, y4) {
          KKe(f6), this._updateController(n6, f6, d4, y4);
        }, a.prototype.updateVisual = function(n6, f6, d4, y4) {
          this.updateTransform(n6, f6, d4, y4);
        }, a.prototype.updateView = function(n6, f6, d4, y4) {
          this._updateController(n6, f6, d4, y4);
        }, a.prototype._updateController = function(n6, f6, d4, y4) {
          (!y4 || y4.$from !== n6.id) && this._brushController.setPanels(n6.brushTargetManager.makePanelOpts(d4)).enableBrush(n6.brushOption).updateCovers(n6.areas.slice());
        }, a.prototype.dispose = function() {
          this._brushController.dispose();
        }, a.prototype._onBrush = function(n6) {
          var f6 = this.model.id, d4 = this.model.brushTargetManager.setOutputRanges(n6.areas, this.ecModel);
          (!n6.isEnd || n6.removeOnClick) && this.api.dispatchAction({ type: "brush", brushId: f6, areas: Bo(d4), $from: f6 }), n6.isEnd && this.api.dispatchAction({ type: "brushEnd", brushId: f6, areas: Bo(d4), $from: f6 });
        }, a.type = "brush", a;
      }(sd), $Xt = qXt, XXt = "#ddd", YXt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.areas = [], n6.brushOption = {}, n6;
        }
        return a.prototype.optionUpdated = function(n6, f6) {
          var d4 = this.option;
          !f6 && qKe(d4, n6, ["inBrush", "outOfBrush"]);
          var y4 = d4.inBrush = d4.inBrush || {};
          d4.outOfBrush = d4.outOfBrush || { color: XXt }, y4.hasOwnProperty("liftZ") || (y4.liftZ = 5);
        }, a.prototype.setAreas = function(n6) {
          !n6 || (this.areas = Pi(n6, function(f6) {
            return QKe(this.option, f6);
          }, this));
        }, a.prototype.setBrushOption = function(n6) {
          this.brushOption = QKe(this.option, n6), this.brushType = this.brushOption.brushType;
        }, a.type = "brush", a.dependencies = ["geo", "grid", "xAxis", "yAxis", "parallel", "series"], a.defaultOption = { seriesIndex: "all", brushType: "rect", brushMode: "single", transformable: true, brushStyle: { borderWidth: 1, color: "rgba(210,219,238,0.3)", borderColor: "#D2DBEE" }, throttleType: "fixRate", throttleDelay: 0, removeOnClick: true, z: 1e4 }, a;
      }(oc);
      function QKe(s, a) {
        return Ms({ brushType: s.brushType, brushMode: s.brushMode, transformable: s.transformable, brushStyle: new Sh(s.brushStyle).getItemStyle(), removeOnClick: s.removeOnClick, z: s.z }, a, true);
      }
      var KXt = YXt, ZXt = ["rect", "polygon", "lineX", "lineY", "keep", "clear"], JXt = function(s) {
        Vt(a, s);
        function a() {
          return s !== null && s.apply(this, arguments) || this;
        }
        return a.prototype.render = function(n6, f6, d4) {
          var y4, _, S;
          f6.eachComponent({ mainType: "brush" }, function(T) {
            y4 = T.brushType, _ = T.brushOption.brushMode || "single", S = S || !!T.areas.length;
          }), this._brushType = y4, this._brushMode = _, gt(n6.get("type", true), function(T) {
            n6.setIconStatus(T, (T === "keep" ? _ === "multiple" : T === "clear" ? S : T === y4) ? "emphasis" : "normal");
          });
        }, a.prototype.updateView = function(n6, f6, d4) {
          this.render(n6, f6, d4);
        }, a.prototype.getIcons = function() {
          var n6 = this.model, f6 = n6.get("icon", true), d4 = {};
          return gt(n6.get("type", true), function(y4) {
            f6[y4] && (d4[y4] = f6[y4]);
          }), d4;
        }, a.prototype.onclick = function(n6, f6, d4) {
          var y4 = this._brushType, _ = this._brushMode;
          d4 === "clear" ? (f6.dispatchAction({ type: "axisAreaSelect", intervals: [] }), f6.dispatchAction({ type: "brush", command: "clear", areas: [] })) : f6.dispatchAction({ type: "takeGlobalCursor", key: "brush", brushOption: { brushType: d4 === "keep" ? y4 : y4 === d4 ? false : d4, brushMode: d4 === "keep" ? _ === "multiple" ? "single" : "multiple" : _ } });
        }, a.getDefaultOption = function(n6) {
          var f6 = { show: true, type: ZXt.slice(), icon: { rect: "M7.3,34.7 M0.4,10V-0.2h9.8 M89.6,10V-0.2h-9.8 M0.4,60v10.2h9.8 M89.6,60v10.2h-9.8 M12.3,22.4V10.5h13.1 M33.6,10.5h7.8 M49.1,10.5h7.8 M77.5,22.4V10.5h-13 M12.3,31.1v8.2 M77.7,31.1v8.2 M12.3,47.6v11.9h13.1 M33.6,59.5h7.6 M49.1,59.5 h7.7 M77.5,47.6v11.9h-13", polygon: "M55.2,34.9c1.7,0,3.1,1.4,3.1,3.1s-1.4,3.1-3.1,3.1 s-3.1-1.4-3.1-3.1S53.5,34.9,55.2,34.9z M50.4,51c1.7,0,3.1,1.4,3.1,3.1c0,1.7-1.4,3.1-3.1,3.1c-1.7,0-3.1-1.4-3.1-3.1 C47.3,52.4,48.7,51,50.4,51z M55.6,37.1l1.5-7.8 M60.1,13.5l1.6-8.7l-7.8,4 M59,19l-1,5.3 M24,16.1l6.4,4.9l6.4-3.3 M48.5,11.6 l-5.9,3.1 M19.1,12.8L9.7,5.1l1.1,7.7 M13.4,29.8l1,7.3l6.6,1.6 M11.6,18.4l1,6.1 M32.8,41.9 M26.6,40.4 M27.3,40.2l6.1,1.6 M49.9,52.1l-5.6-7.6l-4.9-1.2", lineX: "M15.2,30 M19.7,15.6V1.9H29 M34.8,1.9H40.4 M55.3,15.6V1.9H45.9 M19.7,44.4V58.1H29 M34.8,58.1H40.4 M55.3,44.4 V58.1H45.9 M12.5,20.3l-9.4,9.6l9.6,9.8 M3.1,29.9h16.5 M62.5,20.3l9.4,9.6L62.3,39.7 M71.9,29.9H55.4", lineY: "M38.8,7.7 M52.7,12h13.2v9 M65.9,26.6V32 M52.7,46.3h13.2v-9 M24.9,12H11.8v9 M11.8,26.6V32 M24.9,46.3H11.8v-9 M48.2,5.1l-9.3-9l-9.4,9.2 M38.9-3.9V12 M48.2,53.3l-9.3,9l-9.4-9.2 M38.9,62.3V46.4", keep: "M4,10.5V1h10.3 M20.7,1h6.1 M33,1h6.1 M55.4,10.5V1H45.2 M4,17.3v6.6 M55.6,17.3v6.6 M4,30.5V40h10.3 M20.7,40 h6.1 M33,40h6.1 M55.4,30.5V40H45.2 M21,18.9h62.9v48.6H21V18.9z", clear: "M22,14.7l30.9,31 M52.9,14.7L22,45.7 M4.7,16.8V4.2h13.1 M26,4.2h7.8 M41.6,4.2h7.8 M70.3,16.8V4.2H57.2 M4.7,25.9v8.6 M70.3,25.9v8.6 M4.7,43.2v12.6h13.1 M26,55.8h7.8 M41.6,55.8h7.8 M70.3,43.2v12.6H57.2" }, title: n6.getLocaleModel().get(["toolbox", "brush", "title"]) };
          return f6;
        }, a;
      }(CS), QXt = JXt;
      function eYt(s) {
        s.registerComponentView($Xt), s.registerComponentModel(KXt), s.registerPreprocessor(NXt), s.registerVisual(s.PRIORITY.VISUAL.BRUSH, jXt), s.registerAction({ type: "brush", event: "brush", update: "updateVisual" }, function(a, n6) {
          n6.eachComponent({ mainType: "brush", query: a }, function(f6) {
            f6.setAreas(a.areas);
          });
        }), s.registerAction({ type: "brushSelect", event: "brushSelected", update: "none" }, rd), s.registerAction({ type: "brushEnd", event: "brushEnd", update: "none" }, rd), iV("brush", QXt);
      }
      var tYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.layoutMode = { type: "box", ignoreSize: true }, n6;
        }
        return a.type = "title", a.defaultOption = { z: 6, show: true, text: "", target: "blank", subtext: "", subtarget: "blank", left: 0, top: 0, backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, padding: 5, itemGap: 10, textStyle: { fontSize: 18, fontWeight: "bold", color: "#464646" }, subtextStyle: { fontSize: 12, color: "#6E7079" } }, a;
      }(oc), nYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          if (this.group.removeAll(), !!n6.get("show")) {
            var y4 = this.group, _ = n6.getModel("textStyle"), S = n6.getModel("subtextStyle"), T = n6.get("textAlign"), E = Zs(n6.get("textBaseline"), n6.get("textVerticalAlign")), O = new ju({ style: Zd(_, { text: n6.get("text"), fill: _.getTextColor() }, { disableBox: true }), z2: 10 }), R = O.getBoundingRect(), V = n6.get("subtext"), z3 = new ju({ style: Zd(S, { text: V, fill: S.getTextColor(), y: R.height + n6.get("itemGap"), verticalAlign: "top" }, { disableBox: true }), z2: 10 }), H = n6.get("link"), Z = n6.get("sublink"), ee = n6.get("triggerEvent", true);
            O.silent = !H && !ee, z3.silent = !Z && !ee, H && O.on("click", function() {
              Dae(H, "_" + n6.get("target"));
            }), Z && z3.on("click", function() {
              Dae(Z, "_" + n6.get("subtarget"));
            }), qo(O).eventData = qo(z3).eventData = ee ? { componentType: "title", componentIndex: n6.componentIndex } : null, y4.add(O), V && y4.add(z3);
            var oe = y4.getBoundingRect(), fe = n6.getBoxLayoutParams();
            fe.width = oe.width, fe.height = oe.height;
            var _e = Qv(fe, { width: d4.getWidth(), height: d4.getHeight() }, n6.get("padding"));
            T || (T = n6.get("left") || n6.get("right"), T === "middle" && (T = "center"), T === "right" ? _e.x += _e.width : T === "center" && (_e.x += _e.width / 2)), E || (E = n6.get("top") || n6.get("bottom"), E === "center" && (E = "middle"), E === "bottom" ? _e.y += _e.height : E === "middle" && (_e.y += _e.height / 2), E = E || "top"), y4.x = _e.x, y4.y = _e.y, y4.markRedraw();
            var pe = { align: T, verticalAlign: E };
            O.setStyle(pe), z3.setStyle(pe), oe = y4.getBoundingRect();
            var Ve = _e.margin, Le = n6.getItemStyle(["color", "opacity"]);
            Le.fill = n6.get("backgroundColor");
            var je = new xu({ shape: { x: oe.x - Ve[3], y: oe.y - Ve[0], width: oe.width + Ve[1] + Ve[3], height: oe.height + Ve[0] + Ve[2], r: n6.get("borderRadius") }, style: Le, subPixelOptimize: true, silent: true });
            y4.add(je);
          }
        }, a.type = "title", a;
      }(sd);
      function rYt(s) {
        s.registerComponentModel(tYt), s.registerComponentView(nYt);
      }
      var iYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.layoutMode = "box", n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          this.mergeDefaultAndTheme(n6, d4), this._initData();
        }, a.prototype.mergeOption = function(n6) {
          s.prototype.mergeOption.apply(this, arguments), this._initData();
        }, a.prototype.setCurrentIndex = function(n6) {
          n6 == null && (n6 = this.option.currentIndex);
          var f6 = this._data.count();
          this.option.loop ? n6 = (n6 % f6 + f6) % f6 : (n6 >= f6 && (n6 = f6 - 1), n6 < 0 && (n6 = 0)), this.option.currentIndex = n6;
        }, a.prototype.getCurrentIndex = function() {
          return this.option.currentIndex;
        }, a.prototype.isIndexMax = function() {
          return this.getCurrentIndex() >= this._data.count() - 1;
        }, a.prototype.setPlayState = function(n6) {
          this.option.autoPlay = !!n6;
        }, a.prototype.getPlayState = function() {
          return !!this.option.autoPlay;
        }, a.prototype._initData = function() {
          var n6 = this.option, f6 = n6.data || [], d4 = n6.axisType, y4 = this._names = [], _;
          d4 === "category" ? (_ = [], gt(f6, function(E, O) {
            var R = Cd(pC(E), ""), V;
            Qo(E) ? (V = Bo(E), V.value = O) : V = O, _.push(V), y4.push(R);
          })) : _ = f6;
          var S = { category: "ordinal", time: "time", value: "number" }[d4] || "number", T = this._data = new K1([{ name: "value", type: S }], this);
          T.initData(_, y4);
        }, a.prototype.getData = function() {
          return this._data;
        }, a.prototype.getCategories = function() {
          if (this.get("axisType") === "category")
            return this._names.slice();
        }, a.type = "timeline", a.defaultOption = { z: 4, show: true, axisType: "time", realtime: true, left: "20%", top: null, right: "20%", bottom: 0, width: null, height: 40, padding: 5, controlPosition: "left", autoPlay: false, rewind: false, loop: true, playInterval: 2e3, currentIndex: 0, itemStyle: {}, label: { color: "#000" }, data: [] }, a;
      }(oc), eZe = iYt, tZe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "timeline.slider", a.defaultOption = Xk(eZe.defaultOption, { backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderWidth: 0, orient: "horizontal", inverse: false, tooltip: { trigger: "item" }, symbol: "circle", symbolSize: 12, lineStyle: { show: true, width: 2, color: "#DAE1F5" }, label: { position: "auto", show: true, interval: "auto", rotate: 0, color: "#A4B1D7" }, itemStyle: { color: "#A4B1D7", borderWidth: 1 }, checkpointStyle: { symbol: "circle", symbolSize: 15, color: "#316bf3", borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0, 0, 0, 0.3)", animation: true, animationDuration: 300, animationEasing: "quinticInOut" }, controlStyle: { show: true, showPlayBtn: true, showPrevBtn: true, showNextBtn: true, itemSize: 24, itemGap: 12, position: "left", playIcon: "path://M31.6,53C17.5,53,6,41.5,6,27.4S17.5,1.8,31.6,1.8C45.7,1.8,57.2,13.3,57.2,27.4S45.7,53,31.6,53z M31.6,3.3 C18.4,3.3,7.5,14.1,7.5,27.4c0,13.3,10.8,24.1,24.1,24.1C44.9,51.5,55.7,40.7,55.7,27.4C55.7,14.1,44.9,3.3,31.6,3.3z M24.9,21.3 c0-2.2,1.6-3.1,3.5-2l10.5,6.1c1.899,1.1,1.899,2.9,0,4l-10.5,6.1c-1.9,1.1-3.5,0.2-3.5-2V21.3z", stopIcon: "path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5C17.6,3.5,6.8,14.4,6.8,27.6c0,13.3,10.8,24.1,24.101,24.1C44.2,51.7,55,40.9,55,27.6C54.9,14.4,44.1,3.5,30.9,3.5z M36.9,35.8c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H36c0.5,0,0.9,0.4,0.9,1V35.8z M27.8,35.8 c0,0.601-0.4,1-0.9,1h-1.3c-0.5,0-0.9-0.399-0.9-1V19.5c0-0.6,0.4-1,0.9-1H27c0.5,0,0.9,0.4,0.9,1L27.8,35.8L27.8,35.8z", nextIcon: "M2,18.5A1.52,1.52,0,0,1,.92,18a1.49,1.49,0,0,1,0-2.12L7.81,9.36,1,3.11A1.5,1.5,0,1,1,3,.89l8,7.34a1.48,1.48,0,0,1,.49,1.09,1.51,1.51,0,0,1-.46,1.1L3,18.08A1.5,1.5,0,0,1,2,18.5Z", prevIcon: "M10,.5A1.52,1.52,0,0,1,11.08,1a1.49,1.49,0,0,1,0,2.12L4.19,9.64,11,15.89a1.5,1.5,0,1,1-2,2.22L1,10.77A1.48,1.48,0,0,1,.5,9.68,1.51,1.51,0,0,1,1,8.58L9,.92A1.5,1.5,0,0,1,10,.5Z", prevBtnSize: 18, nextBtnSize: 18, color: "#A4B1D7", borderColor: "#A4B1D7", borderWidth: 1 }, emphasis: { label: { show: true, color: "#6f778d" }, itemStyle: { color: "#316BF3" }, controlStyle: { color: "#316BF3", borderColor: "#316BF3", borderWidth: 2 } }, progress: { lineStyle: { color: "#316BF3" }, itemStyle: { color: "#316BF3" }, label: { color: "#6f778d" } }, data: [] }), a;
      }(eZe);
      nd(tZe, $xe.prototype);
      var aYt = tZe, oYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "timeline", a;
      }(sd), sYt = oYt, lYt = function(s) {
        Vt(a, s);
        function a(n6, f6, d4, y4) {
          var _ = s.call(this, n6, f6, d4) || this;
          return _.type = y4 || "value", _;
        }
        return a.prototype.getLabelModel = function() {
          return this.model.getModel("label");
        }, a.prototype.isHorizontal = function() {
          return this.model.get("orient") === "horizontal";
        }, a;
      }(xC), uYt = lYt, vCe = Math.PI, nZe = hu(), cYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function(n6, f6) {
          this.api = f6;
        }, a.prototype.render = function(n6, f6, d4) {
          if (this.model = n6, this.api = d4, this.ecModel = f6, this.group.removeAll(), n6.get("show", true)) {
            var y4 = this._layout(n6, d4), _ = this._createGroup("_mainGroup"), S = this._createGroup("_labelGroup"), T = this._axis = this._createAxis(y4, n6);
            n6.formatTooltip = function(E) {
              var O = T.scale.getLabel({ value: E });
              return Rg("nameValue", { noName: true, value: O });
            }, gt(["AxisLine", "AxisTick", "Control", "CurrentPointer"], function(E) {
              this["_render" + E](y4, _, T, n6);
            }, this), this._renderAxisLabel(y4, S, T, n6), this._position(y4, n6);
          }
          this._doPlayStop(), this._updateTicksStatus();
        }, a.prototype.remove = function() {
          this._clearTimer(), this.group.removeAll();
        }, a.prototype.dispose = function() {
          this._clearTimer();
        }, a.prototype._layout = function(n6, f6) {
          var d4 = n6.get(["label", "position"]), y4 = n6.get("orient"), _ = hYt(n6, f6), S;
          d4 == null || d4 === "auto" ? S = y4 === "horizontal" ? _.y + _.height / 2 < f6.getHeight() / 2 ? "-" : "+" : _.x + _.width / 2 < f6.getWidth() / 2 ? "+" : "-" : Wa(d4) ? S = { horizontal: { top: "-", bottom: "+" }, vertical: { left: "-", right: "+" } }[y4][d4] : S = d4;
          var T = { horizontal: "center", vertical: S >= 0 || S === "+" ? "left" : "right" }, E = { horizontal: S >= 0 || S === "+" ? "top" : "bottom", vertical: "middle" }, O = { horizontal: 0, vertical: vCe / 2 }, R = y4 === "vertical" ? _.height : _.width, V = n6.getModel("controlStyle"), z3 = V.get("show", true), H = z3 ? V.get("itemSize") : 0, Z = z3 ? V.get("itemGap") : 0, ee = H + Z, oe = n6.get(["label", "rotate"]) || 0;
          oe = oe * vCe / 180;
          var fe, _e, pe, Ve = V.get("position", true), Le = z3 && V.get("showPlayBtn", true), je = z3 && V.get("showPrevBtn", true), Xe = z3 && V.get("showNextBtn", true), Ye = 0, rt2 = R;
          Ve === "left" || Ve === "bottom" ? (Le && (fe = [0, 0], Ye += ee), je && (_e = [Ye, 0], Ye += ee), Xe && (pe = [rt2 - H, 0], rt2 -= ee)) : (Le && (fe = [rt2 - H, 0], rt2 -= ee), je && (_e = [0, 0], Ye += ee), Xe && (pe = [rt2 - H, 0], rt2 -= ee));
          var ut = [Ye, rt2];
          return n6.get("inverse") && ut.reverse(), { viewRect: _, mainLength: R, orient: y4, rotation: O[y4], labelRotation: oe, labelPosOpt: S, labelAlign: n6.get(["label", "align"]) || T[y4], labelBaseline: n6.get(["label", "verticalAlign"]) || n6.get(["label", "baseline"]) || E[y4], playPosition: fe, prevBtnPosition: _e, nextBtnPosition: pe, axisExtent: ut, controlSize: H, controlGap: Z };
        }, a.prototype._position = function(n6, f6) {
          var d4 = this._mainGroup, y4 = this._labelGroup, _ = n6.viewRect;
          if (n6.orient === "vertical") {
            var S = Bb(), T = _.x, E = _.y + _.height;
            zb(S, S, [-T, -E]), vT(S, S, -vCe / 2), zb(S, S, [T, E]), _ = _.clone(), _.applyTransform(S);
          }
          var O = fe(_), R = fe(d4.getBoundingRect()), V = fe(y4.getBoundingRect()), z3 = [d4.x, d4.y], H = [y4.x, y4.y];
          H[0] = z3[0] = O[0][0];
          var Z = n6.labelPosOpt;
          if (Z == null || Wa(Z)) {
            var ee = Z === "+" ? 0 : 1;
            _e(z3, R, O, 1, ee), _e(H, V, O, 1, 1 - ee);
          } else {
            var ee = Z >= 0 ? 0 : 1;
            _e(z3, R, O, 1, ee), H[1] = z3[1] + Z;
          }
          d4.setPosition(z3), y4.setPosition(H), d4.rotation = y4.rotation = n6.rotation, oe(d4), oe(y4);
          function oe(pe) {
            pe.originX = O[0][0] - pe.x, pe.originY = O[1][0] - pe.y;
          }
          function fe(pe) {
            return [[pe.x, pe.x + pe.width], [pe.y, pe.y + pe.height]];
          }
          function _e(pe, Ve, Le, je, Xe) {
            pe[je] += Le[je][Xe] - Ve[je][Xe];
          }
        }, a.prototype._createAxis = function(n6, f6) {
          var d4 = f6.getData(), y4 = f6.get("axisType"), _ = fYt(f6, y4);
          _.getTicks = function() {
            return d4.mapArray(["value"], function(E) {
              return { value: E };
            });
          };
          var S = d4.getDataExtent("value");
          _.setExtent(S[0], S[1]), _.calcNiceTicks();
          var T = new uYt("value", _, n6.axisExtent, y4);
          return T.model = f6, T;
        }, a.prototype._createGroup = function(n6) {
          var f6 = this[n6] = new fs();
          return this.group.add(f6), f6;
        }, a.prototype._renderAxisLine = function(n6, f6, d4, y4) {
          var _ = d4.getExtent();
          if (y4.get(["lineStyle", "show"])) {
            var S = new Jv({ shape: { x1: _[0], y1: 0, x2: _[1], y2: 0 }, style: ei({ lineCap: "round" }, y4.getModel("lineStyle").getLineStyle()), silent: true, z2: 1 });
            f6.add(S);
            var T = this._progressLine = new Jv({ shape: { x1: _[0], x2: this._currentPointer ? this._currentPointer.x : _[0], y1: 0, y2: 0 }, style: zo({ lineCap: "round", lineWidth: S.style.lineWidth }, y4.getModel(["progress", "lineStyle"]).getLineStyle()), silent: true, z2: 1 });
            f6.add(T);
          }
        }, a.prototype._renderAxisTick = function(n6, f6, d4, y4) {
          var _ = this, S = y4.getData(), T = d4.scale.getTicks();
          this._tickSymbols = [], gt(T, function(E) {
            var O = d4.dataToCoord(E.value), R = S.getItemModel(E.value), V = R.getModel("itemStyle"), z3 = R.getModel(["emphasis", "itemStyle"]), H = R.getModel(["progress", "itemStyle"]), Z = { x: O, y: 0, onclick: Za(_._changeTimeline, _, E.value) }, ee = rZe(R, V, f6, Z);
            ee.ensureState("emphasis").style = z3.getItemStyle(), ee.ensureState("progress").style = H.getItemStyle(), TE(ee);
            var oe = qo(ee);
            R.get("tooltip") ? (oe.dataIndex = E.value, oe.dataModel = y4) : oe.dataIndex = oe.dataModel = null, _._tickSymbols.push(ee);
          });
        }, a.prototype._renderAxisLabel = function(n6, f6, d4, y4) {
          var _ = this, S = d4.getLabelModel();
          if (S.get("show")) {
            var T = y4.getData(), E = d4.getViewLabels();
            this._tickLabels = [], gt(E, function(O) {
              var R = O.tickValue, V = T.getItemModel(R), z3 = V.getModel("label"), H = V.getModel(["emphasis", "label"]), Z = V.getModel(["progress", "label"]), ee = d4.dataToCoord(O.tickValue), oe = new ju({ x: ee, y: 0, rotation: n6.labelRotation - n6.rotation, onclick: Za(_._changeTimeline, _, R), silent: false, style: Zd(z3, { text: O.formattedLabel, align: n6.labelAlign, verticalAlign: n6.labelBaseline }) });
              oe.ensureState("emphasis").style = Zd(H), oe.ensureState("progress").style = Zd(Z), f6.add(oe), TE(oe), nZe(oe).dataIndex = R, _._tickLabels.push(oe);
            });
          }
        }, a.prototype._renderControl = function(n6, f6, d4, y4) {
          var _ = n6.controlSize, S = n6.rotation, T = y4.getModel("controlStyle").getItemStyle(), E = y4.getModel(["emphasis", "controlStyle"]).getItemStyle(), O = y4.getPlayState(), R = y4.get("inverse", true);
          V(n6.nextBtnPosition, "next", Za(this._changeTimeline, this, R ? "-" : "+")), V(n6.prevBtnPosition, "prev", Za(this._changeTimeline, this, R ? "+" : "-")), V(n6.playPosition, O ? "stop" : "play", Za(this._handlePlayClick, this, !O), true);
          function V(z3, H, Z, ee) {
            if (z3) {
              var oe = H1(Zs(y4.get(["controlStyle", H + "BtnSize"]), _), _), fe = [0, -oe / 2, oe, oe], _e = pYt(y4, H + "Icon", fe, { x: z3[0], y: z3[1], originX: _ / 2, originY: 0, rotation: ee ? -S : 0, rectHover: true, style: T, onclick: Z });
              _e.ensureState("emphasis").style = E, f6.add(_e), TE(_e);
            }
          }
        }, a.prototype._renderCurrentPointer = function(n6, f6, d4, y4) {
          var _ = y4.getData(), S = y4.getCurrentIndex(), T = _.getItemModel(S).getModel("checkpointStyle"), E = this, O = { onCreate: function(R) {
            R.draggable = true, R.drift = Za(E._handlePointerDrag, E), R.ondragend = Za(E._handlePointerDragend, E), iZe(R, E._progressLine, S, d4, y4, true);
          }, onUpdate: function(R) {
            iZe(R, E._progressLine, S, d4, y4);
          } };
          this._currentPointer = rZe(T, T, this._mainGroup, {}, this._currentPointer, O);
        }, a.prototype._handlePlayClick = function(n6) {
          this._clearTimer(), this.api.dispatchAction({ type: "timelinePlayChange", playState: n6, from: this.uid });
        }, a.prototype._handlePointerDrag = function(n6, f6, d4) {
          this._clearTimer(), this._pointerChangeTimeline([d4.offsetX, d4.offsetY]);
        }, a.prototype._handlePointerDragend = function(n6) {
          this._pointerChangeTimeline([n6.offsetX, n6.offsetY], true);
        }, a.prototype._pointerChangeTimeline = function(n6, f6) {
          var d4 = this._toAxisCoord(n6)[0], y4 = this._axis, _ = W1(y4.getExtent().slice());
          d4 > _[1] && (d4 = _[1]), d4 < _[0] && (d4 = _[0]), this._currentPointer.x = d4, this._currentPointer.markRedraw(), this._progressLine.shape.x2 = d4, this._progressLine.dirty();
          var S = this._findNearestTick(d4), T = this.model;
          (f6 || S !== T.getCurrentIndex() && T.get("realtime")) && this._changeTimeline(S);
        }, a.prototype._doPlayStop = function() {
          var n6 = this;
          this._clearTimer(), this.model.getPlayState() && (this._timer = setTimeout(function() {
            var f6 = n6.model;
            n6._changeTimeline(f6.getCurrentIndex() + (f6.get("rewind", true) ? -1 : 1));
          }, this.model.get("playInterval")));
        }, a.prototype._toAxisCoord = function(n6) {
          var f6 = this._mainGroup.getLocalTransform();
          return pa(n6, f6, true);
        }, a.prototype._findNearestTick = function(n6) {
          var f6 = this.model.getData(), d4 = 1 / 0, y4, _ = this._axis;
          return f6.each(["value"], function(S, T) {
            var E = _.dataToCoord(S), O = Math.abs(E - n6);
            O < d4 && (d4 = O, y4 = T);
          }), y4;
        }, a.prototype._clearTimer = function() {
          this._timer && (clearTimeout(this._timer), this._timer = null);
        }, a.prototype._changeTimeline = function(n6) {
          var f6 = this.model.getCurrentIndex();
          n6 === "+" ? n6 = f6 + 1 : n6 === "-" && (n6 = f6 - 1), this.api.dispatchAction({ type: "timelineChange", currentIndex: n6, from: this.uid });
        }, a.prototype._updateTicksStatus = function() {
          var n6 = this.model.getCurrentIndex(), f6 = this._tickSymbols, d4 = this._tickLabels;
          if (f6)
            for (var y4 = 0; y4 < f6.length; y4++)
              f6 && f6[y4] && f6[y4].toggleState("progress", y4 < n6);
          if (d4)
            for (var y4 = 0; y4 < d4.length; y4++)
              d4 && d4[y4] && d4[y4].toggleState("progress", nZe(d4[y4]).dataIndex <= n6);
        }, a.type = "timeline.slider", a;
      }(sYt);
      function fYt(s, a) {
        if (a = a || s.get("type"), a)
          switch (a) {
            case "category":
              return new kwe({ ordinalMeta: s.getCategories(), extent: [1 / 0, -1 / 0] });
            case "time":
              return new MWe({ locale: s.ecModel.getLocaleModel(), useUTC: s.ecModel.get("useUTC") });
            default:
              return new n3();
          }
      }
      function hYt(s, a) {
        return Qv(s.getBoxLayoutParams(), { width: a.getWidth(), height: a.getHeight() }, s.get("padding"));
      }
      function pYt(s, a, n6, f6) {
        var d4 = f6.style, y4 = Gu(s.get(["controlStyle", a]), f6 || {}, new il(n6[0], n6[1], n6[2], n6[3]));
        return d4 && y4.setStyle(d4), y4;
      }
      function rZe(s, a, n6, f6, d4, y4) {
        var _ = a.get("color");
        if (d4)
          d4.setColor(_), n6.add(d4), y4 && y4.onUpdate(d4);
        else {
          var S = s.get("symbol");
          d4 = bv(S, -1, -1, 2, 2, _), d4.setStyle("strokeNoScale", true), n6.add(d4), y4 && y4.onCreate(d4);
        }
        var T = a.getItemStyle(["color"]);
        d4.setStyle(T), f6 = Ms({ rectHover: true, z2: 100 }, f6, true);
        var E = x$(s.get("symbolSize"));
        f6.scaleX = E[0] / 2, f6.scaleY = E[1] / 2;
        var O = B7(s.get("symbolOffset"), E);
        O && (f6.x = (f6.x || 0) + O[0], f6.y = (f6.y || 0) + O[1]);
        var R = s.get("symbolRotate");
        return f6.rotation = (R || 0) * Math.PI / 180 || 0, d4.attr(f6), d4.updateTransform(), d4;
      }
      function iZe(s, a, n6, f6, d4, y4) {
        if (!s.dragging) {
          var _ = d4.getModel("checkpointStyle"), S = f6.dataToCoord(d4.getData().get("value", n6));
          if (y4 || !_.get("animation", true))
            s.attr({ x: S, y: 0 }), a && a.attr({ shape: { x2: S } });
          else {
            var T = { duration: _.get("animationDuration", true), easing: _.get("animationEasing", true) };
            s.stopAnimation(null, true), s.animateTo({ x: S, y: 0 }, T), a && a.animateTo({ shape: { x2: S } }, T);
          }
        }
      }
      var dYt = cYt;
      function vYt(s) {
        s.registerAction({ type: "timelineChange", event: "timelineChanged", update: "prepareAndUpdate" }, function(a, n6, f6) {
          var d4 = n6.getComponent("timeline");
          return d4 && a.currentIndex != null && (d4.setCurrentIndex(a.currentIndex), !d4.get("loop", true) && d4.isIndexMax() && d4.getPlayState() && (d4.setPlayState(false), f6.dispatchAction({ type: "timelinePlayChange", playState: false, from: a.from }))), n6.resetOption("timeline", { replaceMerge: d4.get("replaceMerge", true) }), zo({ currentIndex: d4.option.currentIndex }, a);
        }), s.registerAction({ type: "timelinePlayChange", event: "timelinePlayChanged", update: "update" }, function(a, n6) {
          var f6 = n6.getComponent("timeline");
          f6 && a.playState != null && f6.setPlayState(a.playState);
        });
      }
      function gYt(s) {
        var a = s && s.timeline;
        Di(a) || (a = a ? [a] : []), gt(a, function(n6) {
          !n6 || yYt(n6);
        });
      }
      function yYt(s) {
        var a = s.type, n6 = { number: "value", time: "time" };
        if (n6[a] && (s.axisType = n6[a], delete s.type), aZe(s), l4(s, "controlPosition")) {
          var f6 = s.controlStyle || (s.controlStyle = {});
          l4(f6, "position") || (f6.position = s.controlPosition), f6.position === "none" && !l4(f6, "show") && (f6.show = false, delete f6.position), delete s.controlPosition;
        }
        gt(s.data || [], function(d4) {
          Qo(d4) && !Di(d4) && (!l4(d4, "value") && l4(d4, "name") && (d4.value = d4.name), aZe(d4));
        });
      }
      function aZe(s) {
        var a = s.itemStyle || (s.itemStyle = {}), n6 = a.emphasis || (a.emphasis = {}), f6 = s.label || s.label || {}, d4 = f6.normal || (f6.normal = {}), y4 = { normal: 1, emphasis: 1 };
        gt(f6, function(_, S) {
          !y4[S] && !l4(d4, S) && (d4[S] = _);
        }), n6.label && !l4(f6, "emphasis") && (f6.emphasis = n6.label, delete n6.label);
      }
      function l4(s, a) {
        return s.hasOwnProperty(a);
      }
      function mYt(s) {
        s.registerComponentModel(aYt), s.registerComponentView(dYt), s.registerSubTypeDefaulter("timeline", function() {
          return "slider";
        }), vYt(s), s.registerPreprocessor(gYt);
      }
      function gCe(s, a) {
        if (!s)
          return false;
        for (var n6 = Di(s) ? s : [s], f6 = 0; f6 < n6.length; f6++)
          if (n6[f6] && n6[f6][a])
            return true;
        return false;
      }
      function ase(s) {
        Gb(s, "label", ["show"]);
      }
      var ose = hu(), oZe = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.createdBySelf = false, n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          this.mergeDefaultAndTheme(n6, d4), this._mergeOption(n6, d4, false, true);
        }, a.prototype.isAnimationEnabled = function() {
          if (Na.node)
            return false;
          var n6 = this.__hostSeries;
          return this.getShallow("animation") && n6 && n6.isAnimationEnabled();
        }, a.prototype.mergeOption = function(n6, f6) {
          this._mergeOption(n6, f6, false, false);
        }, a.prototype._mergeOption = function(n6, f6, d4, y4) {
          var _ = this.mainType;
          d4 || f6.eachSeries(function(S) {
            var T = S.get(this.mainType, true), E = ose(S)[_];
            if (!T || !T.data) {
              ose(S)[_] = null;
              return;
            }
            E ? E._mergeOption(T, f6, true) : (y4 && ase(T), gt(T.data, function(O) {
              O instanceof Array ? (ase(O[0]), ase(O[1])) : ase(O);
            }), E = this.createMarkerModelFromSeries(T, this, f6), ei(E, { mainType: this.mainType, seriesIndex: S.seriesIndex, name: S.name, createdBySelf: true }), E.__hostSeries = S), ose(S)[_] = E;
          }, this);
        }, a.prototype.formatTooltip = function(n6, f6, d4) {
          var y4 = this.getData(), _ = this.getRawValue(n6), S = y4.getName(n6);
          return Rg("section", { header: this.name, blocks: [Rg("nameValue", { name: S, value: _, noName: !S, noValue: _ == null })] });
        }, a.prototype.getData = function() {
          return this._data;
        }, a.prototype.setData = function(n6) {
          this._data = n6;
        }, a.getMarkerModelFromSeries = function(n6, f6) {
          return ose(n6)[f6];
        }, a.type = "marker", a.dependencies = ["series", "grid", "polar", "geo"], a;
      }(oc);
      nd(oZe, $xe.prototype);
      var p32 = oZe, bYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.createMarkerModelFromSeries = function(n6, f6, d4) {
          return new a(n6, f6, d4);
        }, a.type = "markPoint", a.defaultOption = { z: 5, symbol: "pin", symbolSize: 50, tooltip: { trigger: "item" }, label: { show: true, position: "inside" }, itemStyle: { borderWidth: 2 }, emphasis: { label: { show: true } } }, a;
      }(p32), _Yt = bYt;
      function xYt(s) {
        return !(isNaN(parseFloat(s.x)) && isNaN(parseFloat(s.y)));
      }
      function wYt(s) {
        return !isNaN(parseFloat(s.x)) && !isNaN(parseFloat(s.y));
      }
      function sse(s, a, n6, f6, d4, y4) {
        var _ = [], S = t32(a, f6), T = S ? a.getCalculationInfo("stackResultDimension") : f6, E = mCe(a, T, s), O = a.indicesOfNearest(T, E)[0];
        _[d4] = a.get(n6, O), _[y4] = a.get(T, O);
        var R = a.get(f6, O), V = tx(a.get(f6, O));
        return V = Math.min(V, 20), V >= 0 && (_[y4] = +_[y4].toFixed(V)), [_, R];
      }
      var yCe = { min: ks(sse, "min"), max: ks(sse, "max"), average: ks(sse, "average"), median: ks(sse, "median") };
      function vX(s, a) {
        var n6 = s.getData(), f6 = s.coordinateSystem;
        if (a && !wYt(a) && !Di(a.coord) && f6) {
          var d4 = f6.dimensions, y4 = sZe(a, n6, f6, s);
          if (a = Bo(a), a.type && yCe[a.type] && y4.baseAxis && y4.valueAxis) {
            var _ = Ns(d4, y4.baseAxis.dim), S = Ns(d4, y4.valueAxis.dim), T = yCe[a.type](n6, y4.baseDataDim, y4.valueDataDim, _, S);
            a.coord = T[0], a.value = T[1];
          } else {
            for (var E = [a.xAxis != null ? a.xAxis : a.radiusAxis, a.yAxis != null ? a.yAxis : a.angleAxis], O = 0; O < 2; O++)
              yCe[E[O]] && (E[O] = mCe(n6, n6.mapDimension(d4[O]), E[O]));
            a.coord = E;
          }
        }
        return a;
      }
      function sZe(s, a, n6, f6) {
        var d4 = {};
        return s.valueIndex != null || s.valueDim != null ? (d4.valueDataDim = s.valueIndex != null ? a.getDimension(s.valueIndex) : s.valueDim, d4.valueAxis = n6.getAxis(SYt(f6, d4.valueDataDim)), d4.baseAxis = n6.getOtherAxis(d4.valueAxis), d4.baseDataDim = a.mapDimension(d4.baseAxis.dim)) : (d4.baseAxis = f6.getBaseAxis(), d4.valueAxis = n6.getOtherAxis(d4.baseAxis), d4.baseDataDim = a.mapDimension(d4.baseAxis.dim), d4.valueDataDim = a.mapDimension(d4.valueAxis.dim)), d4;
      }
      function SYt(s, a) {
        var n6 = s.getData().getDimensionInfo(a);
        return n6 && n6.coordDim;
      }
      function gX(s, a) {
        return s && s.containData && a.coord && !xYt(a) ? s.containData(a.coord) : true;
      }
      function lZe(s, a) {
        return s ? function(n6, f6, d4, y4) {
          var _ = y4 < 2 ? n6.coord && n6.coord[y4] : n6.value;
          return Zk(_, a[y4]);
        } : function(n6, f6, d4, y4) {
          return Zk(n6.value, a[y4]);
        };
      }
      function mCe(s, a, n6) {
        if (n6 === "average") {
          var f6 = 0, d4 = 0;
          return s.each(a, function(y4, _) {
            isNaN(y4) || (f6 += y4, d4++);
          }), f6 / d4;
        } else
          return n6 === "median" ? s.getMedian(a) : s.getDataExtent(a)[n6 === "max" ? 1 : 0];
      }
      var bCe = hu(), CYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.init = function() {
          this.markerGroupMap = ro();
        }, a.prototype.render = function(n6, f6, d4) {
          var y4 = this, _ = this.markerGroupMap;
          _.each(function(S) {
            bCe(S).keep = false;
          }), f6.eachSeries(function(S) {
            var T = p32.getMarkerModelFromSeries(S, y4.type);
            T && y4.renderSeries(S, T, f6, d4);
          }), _.each(function(S) {
            !bCe(S).keep && y4.group.remove(S.group);
          });
        }, a.prototype.markKeep = function(n6) {
          bCe(n6).keep = true;
        }, a.prototype.blurSeries = function(n6) {
          var f6 = this;
          gt(n6, function(d4) {
            var y4 = p32.getMarkerModelFromSeries(d4, f6.type);
            if (y4) {
              var _ = y4.getData();
              _.eachItemGraphicEl(function(S) {
                S && Zie(S);
              });
            }
          });
        }, a.type = "marker", a;
      }(sd), _Ce = CYt;
      function uZe(s, a, n6) {
        var f6 = a.coordinateSystem;
        s.each(function(d4) {
          var y4 = s.getItemModel(d4), _, S = Ia(y4.get("x"), n6.getWidth()), T = Ia(y4.get("y"), n6.getHeight());
          if (!isNaN(S) && !isNaN(T))
            _ = [S, T];
          else if (a.getMarkerPosition)
            _ = a.getMarkerPosition(s.getValues(s.dimensions, d4));
          else if (f6) {
            var E = s.get(f6.dimensions[0], d4), O = s.get(f6.dimensions[1], d4);
            _ = f6.dataToPoint([E, O]);
          }
          isNaN(S) || (_[0] = S), isNaN(T) || (_[1] = T), s.setItemLayout(d4, _);
        });
      }
      var MYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.updateTransform = function(n6, f6, d4) {
          f6.eachSeries(function(y4) {
            var _ = p32.getMarkerModelFromSeries(y4, "markPoint");
            _ && (uZe(_.getData(), y4, d4), this.markerGroupMap.get(y4.id).updateLayout());
          }, this);
        }, a.prototype.renderSeries = function(n6, f6, d4, y4) {
          var _ = n6.coordinateSystem, S = n6.id, T = n6.getData(), E = this.markerGroupMap, O = E.get(S) || E.set(S, new H$()), R = TYt(_, n6, f6);
          f6.setData(R), uZe(f6.getData(), n6, y4), R.each(function(V) {
            var z3 = R.getItemModel(V), H = z3.getShallow("symbol"), Z = z3.getShallow("symbolSize"), ee = z3.getShallow("symbolRotate"), oe = z3.getShallow("symbolOffset"), fe = z3.getShallow("symbolKeepAspect");
            if (jo(H) || jo(Z) || jo(ee) || jo(oe)) {
              var _e = f6.getRawValue(V), pe = f6.getDataParams(V);
              jo(H) && (H = H(_e, pe)), jo(Z) && (Z = Z(_e, pe)), jo(ee) && (ee = ee(_e, pe)), jo(oe) && (oe = oe(_e, pe));
            }
            var Ve = z3.getModel("itemStyle").getItemStyle(), Le = _$(T, "color");
            Ve.fill || (Ve.fill = Le), R.setItemVisual(V, { symbol: H, symbolSize: Z, symbolRotate: ee, symbolOffset: oe, symbolKeepAspect: fe, style: Ve });
          }), O.updateData(R), this.group.add(O.group), R.eachItemGraphicEl(function(V) {
            V.traverse(function(z3) {
              qo(z3).dataModel = f6;
            });
          }), this.markKeep(O), O.group.silent = f6.get("silent") || n6.get("silent");
        }, a.type = "markPoint", a;
      }(_Ce);
      function TYt(s, a, n6) {
        var f6;
        s ? f6 = Pi(s && s.dimensions, function(S) {
          var T = a.getData().getDimensionInfo(a.getData().mapDimension(S)) || {};
          return ei(ei({}, T), { name: S, ordinalMeta: null });
        }) : f6 = [{ name: "value", type: "float" }];
        var d4 = new K1(f6, n6), y4 = Pi(n6.get("data"), ks(vX, a));
        s && (y4 = tf(y4, ks(gX, s)));
        var _ = lZe(!!s, f6);
        return d4.initData(y4, null, _), d4;
      }
      var AYt = MYt;
      function IYt(s) {
        s.registerComponentModel(_Yt), s.registerComponentView(AYt), s.registerPreprocessor(function(a) {
          gCe(a.series, "markPoint") && (a.markPoint = a.markPoint || {});
        });
      }
      var EYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.createMarkerModelFromSeries = function(n6, f6, d4) {
          return new a(n6, f6, d4);
        }, a.type = "markLine", a.defaultOption = { z: 5, symbol: ["circle", "arrow"], symbolSize: [8, 16], symbolOffset: 0, precision: 2, tooltip: { trigger: "item" }, label: { show: true, position: "end", distance: 5 }, lineStyle: { type: "dashed" }, emphasis: { label: { show: true }, lineStyle: { width: 3 } }, animationEasing: "linear" }, a;
      }(p32), DYt = EYt, lse = hu(), kYt = function(s, a, n6, f6) {
        var d4 = s.getData(), y4;
        if (Di(f6))
          y4 = f6;
        else {
          var _ = f6.type;
          if (_ === "min" || _ === "max" || _ === "average" || _ === "median" || f6.xAxis != null || f6.yAxis != null) {
            var S = void 0, T = void 0;
            if (f6.yAxis != null || f6.xAxis != null)
              S = a.getAxis(f6.yAxis != null ? "y" : "x"), T = $v(f6.yAxis, f6.xAxis);
            else {
              var E = sZe(f6, d4, a, s);
              S = E.valueAxis;
              var O = uWe(d4, E.valueDataDim);
              T = mCe(d4, O, _);
            }
            var R = S.dim === "x" ? 0 : 1, V = 1 - R, z3 = Bo(f6), H = { coord: [] };
            z3.type = null, z3.coord = [], z3.coord[V] = -1 / 0, H.coord[V] = 1 / 0;
            var Z = n6.get("precision");
            Z >= 0 && ac(T) && (T = +T.toFixed(Math.min(Z, 20))), z3.coord[R] = H.coord[R] = T, y4 = [z3, H, { type: _, valueIndex: f6.valueIndex, value: T }];
          } else
            y4 = [];
        }
        var ee = [vX(s, y4[0]), vX(s, y4[1]), ei({}, y4[2])];
        return ee[2].type = ee[2].type || null, Ms(ee[2], ee[0]), Ms(ee[2], ee[1]), ee;
      };
      function use2(s) {
        return !isNaN(s) && !isFinite(s);
      }
      function cZe(s, a, n6, f6) {
        var d4 = 1 - s, y4 = f6.dimensions[s];
        return use2(a[d4]) && use2(n6[d4]) && a[s] === n6[s] && f6.getAxis(y4).containData(a[s]);
      }
      function OYt(s, a) {
        if (s.type === "cartesian2d") {
          var n6 = a[0].coord, f6 = a[1].coord;
          if (n6 && f6 && (cZe(1, n6, f6, s) || cZe(0, n6, f6, s)))
            return true;
        }
        return gX(s, a[0]) && gX(s, a[1]);
      }
      function xCe(s, a, n6, f6, d4) {
        var y4 = f6.coordinateSystem, _ = s.getItemModel(a), S, T = Ia(_.get("x"), d4.getWidth()), E = Ia(_.get("y"), d4.getHeight());
        if (!isNaN(T) && !isNaN(E))
          S = [T, E];
        else {
          if (f6.getMarkerPosition)
            S = f6.getMarkerPosition(s.getValues(s.dimensions, a));
          else {
            var O = y4.dimensions, R = s.get(O[0], a), V = s.get(O[1], a);
            S = y4.dataToPoint([R, V]);
          }
          if (RE(y4, "cartesian2d")) {
            var z3 = y4.getAxis("x"), H = y4.getAxis("y"), O = y4.dimensions;
            use2(s.get(O[0], a)) ? S[0] = z3.toGlobalCoord(z3.getExtent()[n6 ? 0 : 1]) : use2(s.get(O[1], a)) && (S[1] = H.toGlobalCoord(H.getExtent()[n6 ? 0 : 1]));
          }
          isNaN(T) || (S[0] = T), isNaN(E) || (S[1] = E);
        }
        s.setItemLayout(a, S);
      }
      var PYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.updateTransform = function(n6, f6, d4) {
          f6.eachSeries(function(y4) {
            var _ = p32.getMarkerModelFromSeries(y4, "markLine");
            if (_) {
              var S = _.getData(), T = lse(_).from, E = lse(_).to;
              T.each(function(O) {
                xCe(T, O, true, y4, d4), xCe(E, O, false, y4, d4);
              }), S.each(function(O) {
                S.setItemLayout(O, [T.getItemLayout(O), E.getItemLayout(O)]);
              }), this.markerGroupMap.get(y4.id).updateLayout();
            }
          }, this);
        }, a.prototype.renderSeries = function(n6, f6, d4, y4) {
          var _ = n6.coordinateSystem, S = n6.id, T = n6.getData(), E = this.markerGroupMap, O = E.get(S) || E.set(S, new ZSe());
          this.group.add(O.group);
          var R = LYt(_, n6, f6), V = R.from, z3 = R.to, H = R.line;
          lse(f6).from = V, lse(f6).to = z3, f6.setData(H);
          var Z = f6.get("symbol"), ee = f6.get("symbolSize"), oe = f6.get("symbolRotate"), fe = f6.get("symbolOffset");
          Di(Z) || (Z = [Z, Z]), Di(ee) || (ee = [ee, ee]), Di(oe) || (oe = [oe, oe]), Di(fe) || (fe = [fe, fe]), R.from.each(function(pe) {
            _e(V, pe, true), _e(z3, pe, false);
          }), H.each(function(pe) {
            var Ve = H.getItemModel(pe).getModel("lineStyle").getLineStyle();
            H.setItemLayout(pe, [V.getItemLayout(pe), z3.getItemLayout(pe)]), Ve.stroke == null && (Ve.stroke = V.getItemVisual(pe, "style").fill), H.setItemVisual(pe, { fromSymbolKeepAspect: V.getItemVisual(pe, "symbolKeepAspect"), fromSymbolOffset: V.getItemVisual(pe, "symbolOffset"), fromSymbolRotate: V.getItemVisual(pe, "symbolRotate"), fromSymbolSize: V.getItemVisual(pe, "symbolSize"), fromSymbol: V.getItemVisual(pe, "symbol"), toSymbolKeepAspect: z3.getItemVisual(pe, "symbolKeepAspect"), toSymbolOffset: z3.getItemVisual(pe, "symbolOffset"), toSymbolRotate: z3.getItemVisual(pe, "symbolRotate"), toSymbolSize: z3.getItemVisual(pe, "symbolSize"), toSymbol: z3.getItemVisual(pe, "symbol"), style: Ve });
          }), O.updateData(H), R.line.eachItemGraphicEl(function(pe, Ve) {
            pe.traverse(function(Le) {
              qo(Le).dataModel = f6;
            });
          });
          function _e(pe, Ve, Le) {
            var je = pe.getItemModel(Ve);
            xCe(pe, Ve, Le, n6, y4);
            var Xe = je.getModel("itemStyle").getItemStyle();
            Xe.fill == null && (Xe.fill = _$(T, "color")), pe.setItemVisual(Ve, { symbolKeepAspect: je.get("symbolKeepAspect"), symbolOffset: Zs(je.get("symbolOffset", true), fe[Le ? 0 : 1]), symbolRotate: Zs(je.get("symbolRotate", true), oe[Le ? 0 : 1]), symbolSize: Zs(je.get("symbolSize"), ee[Le ? 0 : 1]), symbol: Zs(je.get("symbol", true), Z[Le ? 0 : 1]), style: Xe });
          }
          this.markKeep(O), O.group.silent = f6.get("silent") || n6.get("silent");
        }, a.type = "markLine", a;
      }(_Ce);
      function LYt(s, a, n6) {
        var f6;
        s ? f6 = Pi(s && s.dimensions, function(E) {
          var O = a.getData().getDimensionInfo(a.getData().mapDimension(E)) || {};
          return ei(ei({}, O), { name: E, ordinalMeta: null });
        }) : f6 = [{ name: "value", type: "float" }];
        var d4 = new K1(f6, n6), y4 = new K1(f6, n6), _ = new K1([], n6), S = Pi(n6.get("data"), ks(kYt, a, s, n6));
        s && (S = tf(S, ks(OYt, s)));
        var T = lZe(!!s, f6);
        return d4.initData(Pi(S, function(E) {
          return E[0];
        }), null, T), y4.initData(Pi(S, function(E) {
          return E[1];
        }), null, T), _.initData(Pi(S, function(E) {
          return E[2];
        })), _.hasItemOption = true, { from: d4, to: y4, line: _ };
      }
      var RYt = PYt;
      function NYt(s) {
        s.registerComponentModel(DYt), s.registerComponentView(RYt), s.registerPreprocessor(function(a) {
          gCe(a.series, "markLine") && (a.markLine = a.markLine || {});
        });
      }
      var FYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.createMarkerModelFromSeries = function(n6, f6, d4) {
          return new a(n6, f6, d4);
        }, a.type = "markArea", a.defaultOption = { z: 1, tooltip: { trigger: "item" }, animation: false, label: { show: true, position: "top" }, itemStyle: { borderWidth: 0 }, emphasis: { label: { show: true, position: "top" } } }, a;
      }(p32), VYt = FYt, cse = hu(), BYt = function(s, a, n6, f6) {
        var d4 = vX(s, f6[0]), y4 = vX(s, f6[1]), _ = d4.coord, S = y4.coord;
        _[0] = $v(_[0], -1 / 0), _[1] = $v(_[1], -1 / 0), S[0] = $v(S[0], 1 / 0), S[1] = $v(S[1], 1 / 0);
        var T = YI([{}, d4, y4]);
        return T.coord = [d4.coord, y4.coord], T.x0 = d4.x, T.y0 = d4.y, T.x1 = y4.x, T.y1 = y4.y, T;
      };
      function fse(s) {
        return !isNaN(s) && !isFinite(s);
      }
      function fZe(s, a, n6, f6) {
        var d4 = 1 - s;
        return fse(a[d4]) && fse(n6[d4]);
      }
      function zYt(s, a) {
        var n6 = a.coord[0], f6 = a.coord[1];
        return RE(s, "cartesian2d") && n6 && f6 && (fZe(1, n6, f6) || fZe(0, n6, f6)) ? true : gX(s, { coord: n6, x: a.x0, y: a.y0 }) || gX(s, { coord: f6, x: a.x1, y: a.y1 });
      }
      function hZe(s, a, n6, f6, d4) {
        var y4 = f6.coordinateSystem, _ = s.getItemModel(a), S, T = Ia(_.get(n6[0]), d4.getWidth()), E = Ia(_.get(n6[1]), d4.getHeight());
        if (!isNaN(T) && !isNaN(E))
          S = [T, E];
        else {
          if (f6.getMarkerPosition)
            S = f6.getMarkerPosition(s.getValues(n6, a));
          else {
            var O = s.get(n6[0], a), R = s.get(n6[1], a), V = [O, R];
            y4.clampData && y4.clampData(V, V), S = y4.dataToPoint(V, true);
          }
          if (RE(y4, "cartesian2d")) {
            var z3 = y4.getAxis("x"), H = y4.getAxis("y"), O = s.get(n6[0], a), R = s.get(n6[1], a);
            fse(O) ? S[0] = z3.toGlobalCoord(z3.getExtent()[n6[0] === "x0" ? 0 : 1]) : fse(R) && (S[1] = H.toGlobalCoord(H.getExtent()[n6[1] === "y0" ? 0 : 1]));
          }
          isNaN(T) || (S[0] = T), isNaN(E) || (S[1] = E);
        }
        return S;
      }
      var pZe = [["x0", "y0"], ["x1", "y0"], ["x1", "y1"], ["x0", "y1"]], jYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.updateTransform = function(n6, f6, d4) {
          f6.eachSeries(function(y4) {
            var _ = p32.getMarkerModelFromSeries(y4, "markArea");
            if (_) {
              var S = _.getData();
              S.each(function(T) {
                var E = Pi(pZe, function(R) {
                  return hZe(S, T, R, y4, d4);
                });
                S.setItemLayout(T, E);
                var O = S.getItemGraphicEl(T);
                O.setShape("points", E);
              });
            }
          }, this);
        }, a.prototype.renderSeries = function(n6, f6, d4, y4) {
          var _ = n6.coordinateSystem, S = n6.id, T = n6.getData(), E = this.markerGroupMap, O = E.get(S) || E.set(S, { group: new fs() });
          this.group.add(O.group), this.markKeep(O);
          var R = GYt(_, n6, f6);
          f6.setData(R), R.each(function(V) {
            var z3 = Pi(pZe, function(Xe) {
              return hZe(R, V, Xe, n6, y4);
            }), H = _.getAxis("x").scale, Z = _.getAxis("y").scale, ee = H.getExtent(), oe = Z.getExtent(), fe = [H.parse(R.get("x0", V)), H.parse(R.get("x1", V))], _e = [Z.parse(R.get("y0", V)), Z.parse(R.get("y1", V))];
            W1(fe), W1(_e);
            var pe = !(ee[0] > fe[1] || ee[1] < fe[0] || oe[0] > _e[1] || oe[1] < _e[0]), Ve = !pe;
            R.setItemLayout(V, { points: z3, allClipped: Ve });
            var Le = R.getItemModel(V).getModel("itemStyle").getItemStyle(), je = _$(T, "color");
            Le.fill || (Le.fill = je, Wa(Le.fill) && (Le.fill = m9(Le.fill, 0.4))), Le.stroke || (Le.stroke = je), R.setItemVisual(V, "style", Le);
          }), R.diff(cse(O).data).add(function(V) {
            var z3 = R.getItemLayout(V);
            if (!z3.allClipped) {
              var H = new T0({ shape: { points: z3.points } });
              R.setItemGraphicEl(V, H), O.group.add(H);
            }
          }).update(function(V, z3) {
            var H = cse(O).data.getItemGraphicEl(z3), Z = R.getItemLayout(V);
            Z.allClipped ? H && O.group.remove(H) : (H ? ku(H, { shape: { points: Z.points } }, f6, V) : H = new T0({ shape: { points: Z.points } }), R.setItemGraphicEl(V, H), O.group.add(H));
          }).remove(function(V) {
            var z3 = cse(O).data.getItemGraphicEl(V);
            O.group.remove(z3);
          }).execute(), R.eachItemGraphicEl(function(V, z3) {
            var H = R.getItemModel(z3), Z = R.getItemVisual(z3, "style");
            V.useStyle(R.getItemVisual(z3, "style")), Gm(V, E0(H), { labelFetcher: f6, labelDataIndex: z3, defaultText: R.getName(z3) || "", inheritColor: Wa(Z.fill) ? m9(Z.fill, 1) : "#000" }), Pg(V, H), Up(V, null, null, H.get(["emphasis", "disabled"])), qo(V).dataModel = f6;
          }), cse(O).data = R, O.group.silent = f6.get("silent") || n6.get("silent");
        }, a.type = "markArea", a;
      }(_Ce);
      function GYt(s, a, n6) {
        var f6, d4, y4 = ["x0", "y0", "x1", "y1"];
        if (s) {
          var _ = Pi(s && s.dimensions, function(E) {
            var O = a.getData(), R = O.getDimensionInfo(O.mapDimension(E)) || {};
            return ei(ei({}, R), { name: E, ordinalMeta: null });
          });
          d4 = Pi(y4, function(E, O) {
            return { name: E, type: _[O % 2].type };
          }), f6 = new K1(d4, n6);
        } else
          d4 = [{ name: "value", type: "float" }], f6 = new K1(d4, n6);
        var S = Pi(n6.get("data"), ks(BYt, a, s, n6));
        s && (S = tf(S, ks(zYt, s)));
        var T = s ? function(E, O, R, V) {
          var z3 = E.coord[Math.floor(V / 2)][V % 2];
          return Zk(z3, d4[V]);
        } : function(E, O, R, V) {
          return Zk(E.value, d4[V]);
        };
        return f6.initData(S, null, T), f6.hasItemOption = true, f6;
      }
      var HYt = jYt;
      function WYt(s) {
        s.registerComponentModel(VYt), s.registerComponentView(HYt), s.registerPreprocessor(function(a) {
          gCe(a.series, "markArea") && (a.markArea = a.markArea || {});
        });
      }
      var UYt = function(s, a) {
        if (a === "all")
          return { type: "all", title: s.getLocaleModel().get(["legend", "selector", "all"]) };
        if (a === "inverse")
          return { type: "inverse", title: s.getLocaleModel().get(["legend", "selector", "inverse"]) };
      }, qYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.layoutMode = { type: "box", ignoreSize: true }, n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          this.mergeDefaultAndTheme(n6, d4), n6.selected = n6.selected || {}, this._updateSelector(n6);
        }, a.prototype.mergeOption = function(n6, f6) {
          s.prototype.mergeOption.call(this, n6, f6), this._updateSelector(n6);
        }, a.prototype._updateSelector = function(n6) {
          var f6 = n6.selector, d4 = this.ecModel;
          f6 === true && (f6 = n6.selector = ["all", "inverse"]), Di(f6) && gt(f6, function(y4, _) {
            Wa(y4) && (y4 = { type: y4 }), f6[_] = Ms(y4, UYt(d4, y4.type));
          });
        }, a.prototype.optionUpdated = function() {
          this._updateData(this.ecModel);
          var n6 = this._data;
          if (n6[0] && this.get("selectedMode") === "single") {
            for (var f6 = false, d4 = 0; d4 < n6.length; d4++) {
              var y4 = n6[d4].get("name");
              if (this.isSelected(y4)) {
                this.select(y4), f6 = true;
                break;
              }
            }
            !f6 && this.select(n6[0].get("name"));
          }
        }, a.prototype._updateData = function(n6) {
          var f6 = [], d4 = [];
          n6.eachRawSeries(function(S) {
            var T = S.name;
            d4.push(T);
            var E;
            if (S.legendVisualProvider) {
              var O = S.legendVisualProvider, R = O.getAllNames();
              n6.isSeriesFiltered(S) || (d4 = d4.concat(R)), R.length ? f6 = f6.concat(R) : E = true;
            } else
              E = true;
            E && nq(S) && f6.push(S.name);
          }), this._availableNames = d4;
          var y4 = this.get("data") || f6, _ = Pi(y4, function(S) {
            return (Wa(S) || ac(S)) && (S = { name: S }), new Sh(S, this, this.ecModel);
          }, this);
          this._data = _;
        }, a.prototype.getData = function() {
          return this._data;
        }, a.prototype.select = function(n6) {
          var f6 = this.option.selected, d4 = this.get("selectedMode");
          if (d4 === "single") {
            var y4 = this._data;
            gt(y4, function(_) {
              f6[_.get("name")] = false;
            });
          }
          f6[n6] = true;
        }, a.prototype.unSelect = function(n6) {
          this.get("selectedMode") !== "single" && (this.option.selected[n6] = false);
        }, a.prototype.toggleSelected = function(n6) {
          var f6 = this.option.selected;
          f6.hasOwnProperty(n6) || (f6[n6] = true), this[f6[n6] ? "unSelect" : "select"](n6);
        }, a.prototype.allSelect = function() {
          var n6 = this._data, f6 = this.option.selected;
          gt(n6, function(d4) {
            f6[d4.get("name", true)] = true;
          });
        }, a.prototype.inverseSelect = function() {
          var n6 = this._data, f6 = this.option.selected;
          gt(n6, function(d4) {
            var y4 = d4.get("name", true);
            f6.hasOwnProperty(y4) || (f6[y4] = true), f6[y4] = !f6[y4];
          });
        }, a.prototype.isSelected = function(n6) {
          var f6 = this.option.selected;
          return !(f6.hasOwnProperty(n6) && !f6[n6]) && Ns(this._availableNames, n6) >= 0;
        }, a.prototype.getOrient = function() {
          return this.get("orient") === "vertical" ? { index: 1, name: "vertical" } : { index: 0, name: "horizontal" };
        }, a.type = "legend.plain", a.dependencies = ["series"], a.defaultOption = { z: 4, show: true, orient: "horizontal", left: "center", top: 0, align: "auto", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", borderRadius: 0, borderWidth: 0, padding: 5, itemGap: 10, itemWidth: 25, itemHeight: 14, symbolRotate: "inherit", symbolKeepAspect: true, inactiveColor: "#ccc", inactiveBorderColor: "#ccc", inactiveBorderWidth: "auto", itemStyle: { color: "inherit", opacity: "inherit", borderColor: "inherit", borderWidth: "auto", borderCap: "inherit", borderJoin: "inherit", borderDashOffset: "inherit", borderMiterLimit: "inherit" }, lineStyle: { width: "auto", color: "inherit", inactiveColor: "#ccc", inactiveWidth: 2, opacity: "inherit", type: "inherit", cap: "inherit", join: "inherit", dashOffset: "inherit", miterLimit: "inherit" }, textStyle: { color: "#333" }, selectedMode: true, selector: false, selectorLabel: { show: true, borderRadius: 10, padding: [3, 5, 3, 5], fontSize: 12, fontFamily: "sans-serif", color: "#666", borderWidth: 1, borderColor: "#666" }, emphasis: { selectorLabel: { show: true, color: "#eee", backgroundColor: "#666" } }, selectorPosition: "auto", selectorItemGap: 7, selectorButtonGap: 10, tooltip: { show: false } }, a;
      }(oc), wCe = qYt, oV = ks, SCe = gt, hse = fs, $Yt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.newlineDisabled = false, n6;
        }
        return a.prototype.init = function() {
          this.group.add(this._contentGroup = new hse()), this.group.add(this._selectorGroup = new hse()), this._isFirstRender = true;
        }, a.prototype.getContentGroup = function() {
          return this._contentGroup;
        }, a.prototype.getSelectorGroup = function() {
          return this._selectorGroup;
        }, a.prototype.render = function(n6, f6, d4) {
          var y4 = this._isFirstRender;
          if (this._isFirstRender = false, this.resetInner(), !!n6.get("show", true)) {
            var _ = n6.get("align"), S = n6.get("orient");
            (!_ || _ === "auto") && (_ = n6.get("left") === "right" && S === "vertical" ? "right" : "left");
            var T = n6.get("selector", true), E = n6.get("selectorPosition", true);
            T && (!E || E === "auto") && (E = S === "horizontal" ? "end" : "start"), this.renderInner(_, n6, f6, d4, T, S, E);
            var O = n6.getBoxLayoutParams(), R = { width: d4.getWidth(), height: d4.getHeight() }, V = n6.get("padding"), z3 = Qv(O, R, V), H = this.layoutInner(n6, _, z3, y4, T, E), Z = Qv(zo({ width: H.width, height: H.height }, O), R, V);
            this.group.x = Z.x - H.x, this.group.y = Z.y - H.y, this.group.markRedraw(), this.group.add(this._backgroundEl = wKe(H, n6));
          }
        }, a.prototype.resetInner = function() {
          this.getContentGroup().removeAll(), this._backgroundEl && this.group.remove(this._backgroundEl), this.getSelectorGroup().removeAll();
        }, a.prototype.renderInner = function(n6, f6, d4, y4, _, S, T) {
          var E = this.getContentGroup(), O = ro(), R = f6.get("selectedMode"), V = [];
          d4.eachRawSeries(function(z3) {
            !z3.get("legendHoverLink") && V.push(z3.id);
          }), SCe(f6.getData(), function(z3, H) {
            var Z = z3.get("name");
            if (!this.newlineDisabled && (Z === "" || Z === `
`)) {
              var ee = new hse();
              ee.newline = true, E.add(ee);
              return;
            }
            var oe = d4.getSeriesByName(Z)[0];
            if (!O.get(Z))
              if (oe) {
                var fe = oe.getData(), _e = fe.getVisual("legendLineStyle") || {}, pe = fe.getVisual("legendIcon"), Ve = fe.getVisual("style"), Le = this._createItem(oe, Z, H, z3, f6, n6, _e, Ve, pe, R);
                Le.on("click", oV(dZe, Z, null, y4, V)).on("mouseover", oV(CCe, oe.name, null, y4, V)).on("mouseout", oV(MCe, oe.name, null, y4, V)), O.set(Z, true);
              } else
                d4.eachRawSeries(function(je) {
                  if (!O.get(Z) && je.legendVisualProvider) {
                    var Xe = je.legendVisualProvider;
                    if (!Xe.containName(Z))
                      return;
                    var Ye = Xe.indexOfName(Z), rt2 = Xe.getItemVisual(Ye, "style"), ut = Xe.getItemVisual(Ye, "legendIcon"), wt = w0(rt2.fill);
                    wt && wt[3] === 0 && (wt[3] = 0.2, rt2 = ei(ei({}, rt2), { fill: oC(wt, "rgba") }));
                    var dt = this._createItem(je, Z, H, z3, f6, n6, {}, rt2, ut, R);
                    dt.on("click", oV(dZe, null, Z, y4, V)).on("mouseover", oV(CCe, null, Z, y4, V)).on("mouseout", oV(MCe, null, Z, y4, V)), O.set(Z, true);
                  }
                }, this);
          }, this), _ && this._createSelector(_, f6, y4, S, T);
        }, a.prototype._createSelector = function(n6, f6, d4, y4, _) {
          var S = this.getSelectorGroup();
          SCe(n6, function(T) {
            var E = T.type, O = new ju({ style: { x: 0, y: 0, align: "center", verticalAlign: "middle" }, onclick: function() {
              d4.dispatchAction({ type: E === "all" ? "legendAllSelect" : "legendInverseSelect" });
            } });
            S.add(O);
            var R = f6.getModel("selectorLabel"), V = f6.getModel(["emphasis", "selectorLabel"]);
            Gm(O, { normal: R, emphasis: V }, { defaultText: T.title }), TE(O);
          });
        }, a.prototype._createItem = function(n6, f6, d4, y4, _, S, T, E, O, R) {
          var V = n6.visualDrawType, z3 = _.get("itemWidth"), H = _.get("itemHeight"), Z = _.isSelected(f6), ee = y4.get("symbolRotate"), oe = y4.get("symbolKeepAspect"), fe = y4.get("icon");
          O = fe || O || "roundRect";
          var _e = XYt(O, y4, T, E, V, Z), pe = new hse(), Ve = y4.getModel("textStyle");
          if (jo(n6.getLegendIcon) && (!fe || fe === "inherit"))
            pe.add(n6.getLegendIcon({ itemWidth: z3, itemHeight: H, icon: O, iconRotate: ee, itemStyle: _e.itemStyle, lineStyle: _e.lineStyle, symbolKeepAspect: oe }));
          else {
            var Le = fe === "inherit" && n6.getData().getVisual("symbol") ? ee === "inherit" ? n6.getData().getVisual("symbolRotate") : ee : 0;
            pe.add(YYt({ itemWidth: z3, itemHeight: H, icon: O, iconRotate: Le, itemStyle: _e.itemStyle, lineStyle: _e.lineStyle, symbolKeepAspect: oe }));
          }
          var je = S === "left" ? z3 + 5 : -5, Xe = S, Ye = _.get("formatter"), rt2 = f6;
          Wa(Ye) && Ye ? rt2 = Ye.replace("{name}", f6 != null ? f6 : "") : jo(Ye) && (rt2 = Ye(f6));
          var ut = y4.get("inactiveColor");
          pe.add(new ju({ style: Zd(Ve, { text: rt2, x: je, y: H / 2, fill: Z ? Ve.getTextColor() : ut, align: Xe, verticalAlign: "middle" }) }));
          var wt = new xu({ shape: pe.getBoundingRect(), invisible: true }), dt = y4.getModel("tooltip");
          return dt.get("show") && I0({ el: wt, componentModel: _, itemName: f6, itemTooltipOption: dt.option }), pe.add(wt), pe.eachChild(function(Gt) {
            Gt.silent = true;
          }), wt.silent = !R, this.getContentGroup().add(pe), TE(pe), pe.__legendDataIndex = d4, pe;
        }, a.prototype.layoutInner = function(n6, f6, d4, y4, _, S) {
          var T = this.getContentGroup(), E = this.getSelectorGroup();
          NR(n6.get("orient"), T, n6.get("itemGap"), d4.width, d4.height);
          var O = T.getBoundingRect(), R = [-O.x, -O.y];
          if (E.markRedraw(), T.markRedraw(), _) {
            NR("horizontal", E, n6.get("selectorItemGap", true));
            var V = E.getBoundingRect(), z3 = [-V.x, -V.y], H = n6.get("selectorButtonGap", true), Z = n6.getOrient().index, ee = Z === 0 ? "width" : "height", oe = Z === 0 ? "height" : "width", fe = Z === 0 ? "y" : "x";
            S === "end" ? z3[Z] += O[ee] + H : R[Z] += V[ee] + H, z3[1 - Z] += O[oe] / 2 - V[oe] / 2, E.x = z3[0], E.y = z3[1], T.x = R[0], T.y = R[1];
            var _e = { x: 0, y: 0 };
            return _e[ee] = O[ee] + H + V[ee], _e[oe] = Math.max(O[oe], V[oe]), _e[fe] = Math.min(0, V[fe] + z3[1 - Z]), _e;
          } else
            return T.x = R[0], T.y = R[1], this.group.getBoundingRect();
        }, a.prototype.remove = function() {
          this.getContentGroup().removeAll(), this._isFirstRender = true;
        }, a.type = "legend.plain", a;
      }(sd);
      function XYt(s, a, n6, f6, d4, y4) {
        function _(H, Z) {
          H.lineWidth === "auto" && (H.lineWidth = Z.lineWidth > 0 ? 2 : 0), SCe(H, function(ee, oe) {
            H[oe] === "inherit" && (H[oe] = Z[oe]);
          });
        }
        var S = a.getModel("itemStyle"), T = S.getItemStyle(), E = s.lastIndexOf("empty", 0) === 0 ? "fill" : "stroke";
        T.decal = f6.decal, T.fill === "inherit" && (T.fill = f6[d4]), T.stroke === "inherit" && (T.stroke = f6[E]), T.opacity === "inherit" && (T.opacity = (d4 === "fill" ? f6 : n6).opacity), _(T, f6);
        var O = a.getModel("lineStyle"), R = O.getLineStyle();
        if (_(R, n6), T.fill === "auto" && (T.fill = f6.fill), T.stroke === "auto" && (T.stroke = f6.fill), R.stroke === "auto" && (R.stroke = f6.fill), !y4) {
          var V = a.get("inactiveBorderWidth"), z3 = T[E];
          T.lineWidth = V === "auto" ? f6.lineWidth > 0 && z3 ? 2 : 0 : T.lineWidth, T.fill = a.get("inactiveColor"), T.stroke = a.get("inactiveBorderColor"), R.stroke = O.get("inactiveColor"), R.lineWidth = O.get("inactiveWidth");
        }
        return { itemStyle: T, lineStyle: R };
      }
      function YYt(s) {
        var a = s.icon || "roundRect", n6 = bv(a, 0, 0, s.itemWidth, s.itemHeight, s.itemStyle.fill, s.symbolKeepAspect);
        return n6.setStyle(s.itemStyle), n6.rotation = (s.iconRotate || 0) * Math.PI / 180, n6.setOrigin([s.itemWidth / 2, s.itemHeight / 2]), a.indexOf("empty") > -1 && (n6.style.stroke = n6.style.fill, n6.style.fill = "#fff", n6.style.lineWidth = 2), n6;
      }
      function dZe(s, a, n6, f6) {
        MCe(s, a, n6, f6), n6.dispatchAction({ type: "legendToggleSelect", name: s != null ? s : a }), CCe(s, a, n6, f6);
      }
      function vZe(s) {
        for (var a = s.getZr().storage.getDisplayList(), n6, f6 = 0, d4 = a.length; f6 < d4 && !(n6 = a[f6].states.emphasis); )
          f6++;
        return n6 && n6.hoverLayer;
      }
      function CCe(s, a, n6, f6) {
        vZe(n6) || n6.dispatchAction({ type: "highlight", seriesName: s, name: a, excludeSeriesId: f6 });
      }
      function MCe(s, a, n6, f6) {
        vZe(n6) || n6.dispatchAction({ type: "downplay", seriesName: s, name: a, excludeSeriesId: f6 });
      }
      var gZe = $Yt;
      function KYt(s) {
        var a = s.findComponents({ mainType: "legend" });
        a && a.length && s.filterSeries(function(n6) {
          for (var f6 = 0; f6 < a.length; f6++)
            if (!a[f6].isSelected(n6.name))
              return false;
          return true;
        });
      }
      function yX(s, a, n6) {
        var f6 = {}, d4 = s === "toggleSelected", y4;
        return n6.eachComponent("legend", function(_) {
          d4 && y4 != null ? _[y4 ? "select" : "unSelect"](a.name) : s === "allSelect" || s === "inverseSelect" ? _[s]() : (_[s](a.name), y4 = _.isSelected(a.name));
          var S = _.getData();
          gt(S, function(T) {
            var E = T.get("name");
            if (!(E === `
` || E === "")) {
              var O = _.isSelected(E);
              f6.hasOwnProperty(E) ? f6[E] = f6[E] && O : f6[E] = O;
            }
          });
        }), s === "allSelect" || s === "inverseSelect" ? { selected: f6 } : { name: a.name, selected: f6 };
      }
      function ZYt(s) {
        s.registerAction("legendToggleSelect", "legendselectchanged", ks(yX, "toggleSelected")), s.registerAction("legendAllSelect", "legendselectall", ks(yX, "allSelect")), s.registerAction("legendInverseSelect", "legendinverseselect", ks(yX, "inverseSelect")), s.registerAction("legendSelect", "legendselected", ks(yX, "select")), s.registerAction("legendUnSelect", "legendunselected", ks(yX, "unSelect"));
      }
      function yZe(s) {
        s.registerComponentModel(wCe), s.registerComponentView(gZe), s.registerProcessor(s.PRIORITY.PROCESSOR.SERIES_FILTER, KYt), s.registerSubTypeDefaulter("legend", function() {
          return "plain";
        }), ZYt(s);
      }
      var JYt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.setScrollDataIndex = function(n6) {
          this.option.scrollDataIndex = n6;
        }, a.prototype.init = function(n6, f6, d4) {
          var y4 = E7(n6);
          s.prototype.init.call(this, n6, f6, d4), mZe(this, n6, y4);
        }, a.prototype.mergeOption = function(n6, f6) {
          s.prototype.mergeOption.call(this, n6, f6), mZe(this, this.option, n6);
        }, a.type = "legend.scroll", a.defaultOption = Xk(wCe.defaultOption, { scrollDataIndex: 0, pageButtonItemGap: 5, pageButtonGap: null, pageButtonPosition: "end", pageFormatter: "{current}/{total}", pageIcons: { horizontal: ["M0,0L12,-10L12,10z", "M0,0L-12,-10L-12,10z"], vertical: ["M0,0L20,0L10,-20z", "M0,0L20,0L10,20z"] }, pageIconColor: "#2f4554", pageIconInactiveColor: "#aaa", pageIconSize: 15, pageTextStyle: { color: "#333" }, animationDurationUpdate: 800 }), a;
      }(wCe);
      function mZe(s, a, n6) {
        var f6 = s.getOrient(), d4 = [1, 1];
        d4[f6.index] = 0, Yk(a, n6, { type: "box", ignoreSize: !!d4 });
      }
      var QYt = JYt, bZe = fs, TCe = ["width", "height"], ACe = ["x", "y"], eKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.newlineDisabled = true, n6._currentIndex = 0, n6;
        }
        return a.prototype.init = function() {
          s.prototype.init.call(this), this.group.add(this._containerGroup = new bZe()), this._containerGroup.add(this.getContentGroup()), this.group.add(this._controllerGroup = new bZe());
        }, a.prototype.resetInner = function() {
          s.prototype.resetInner.call(this), this._controllerGroup.removeAll(), this._containerGroup.removeClipPath(), this._containerGroup.__rectSize = null;
        }, a.prototype.renderInner = function(n6, f6, d4, y4, _, S, T) {
          var E = this;
          s.prototype.renderInner.call(this, n6, f6, d4, y4, _, S, T);
          var O = this._controllerGroup, R = f6.get("pageIconSize", true), V = Di(R) ? R : [R, R];
          H("pagePrev", 0);
          var z3 = f6.getModel("pageTextStyle");
          O.add(new ju({ name: "pageText", style: { text: "xx/xx", fill: z3.getTextColor(), font: z3.getFont(), verticalAlign: "middle", align: "center" }, silent: true })), H("pageNext", 1);
          function H(Z, ee) {
            var oe = Z + "DataIndex", fe = Gu(f6.get("pageIcons", true)[f6.getOrient().name][ee], { onclick: Za(E._pageGo, E, oe, f6, y4) }, { x: -V[0] / 2, y: -V[1] / 2, width: V[0], height: V[1] });
            fe.name = Z, O.add(fe);
          }
        }, a.prototype.layoutInner = function(n6, f6, d4, y4, _, S) {
          var T = this.getSelectorGroup(), E = n6.getOrient().index, O = TCe[E], R = ACe[E], V = TCe[1 - E], z3 = ACe[1 - E];
          _ && NR("horizontal", T, n6.get("selectorItemGap", true));
          var H = n6.get("selectorButtonGap", true), Z = T.getBoundingRect(), ee = [-Z.x, -Z.y], oe = Bo(d4);
          _ && (oe[O] = d4[O] - Z[O] - H);
          var fe = this._layoutContentAndController(n6, y4, oe, E, O, V, z3, R);
          if (_) {
            if (S === "end")
              ee[E] += fe[O] + H;
            else {
              var _e = Z[O] + H;
              ee[E] -= _e, fe[R] -= _e;
            }
            fe[O] += Z[O] + H, ee[1 - E] += fe[z3] + fe[V] / 2 - Z[V] / 2, fe[V] = Math.max(fe[V], Z[V]), fe[z3] = Math.min(fe[z3], Z[z3] + ee[1 - E]), T.x = ee[0], T.y = ee[1], T.markRedraw();
          }
          return fe;
        }, a.prototype._layoutContentAndController = function(n6, f6, d4, y4, _, S, T, E) {
          var O = this.getContentGroup(), R = this._containerGroup, V = this._controllerGroup;
          NR(n6.get("orient"), O, n6.get("itemGap"), y4 ? d4.width : null, y4 ? null : d4.height), NR("horizontal", V, n6.get("pageButtonItemGap", true));
          var z3 = O.getBoundingRect(), H = V.getBoundingRect(), Z = this._showController = z3[_] > d4[_], ee = [-z3.x, -z3.y];
          f6 || (ee[y4] = O[E]);
          var oe = [0, 0], fe = [-H.x, -H.y], _e = Zs(n6.get("pageButtonGap", true), n6.get("itemGap", true));
          if (Z) {
            var pe = n6.get("pageButtonPosition", true);
            pe === "end" ? fe[y4] += d4[_] - H[_] : oe[y4] += H[_] + _e;
          }
          fe[1 - y4] += z3[S] / 2 - H[S] / 2, O.setPosition(ee), R.setPosition(oe), V.setPosition(fe);
          var Ve = { x: 0, y: 0 };
          if (Ve[_] = Z ? d4[_] : z3[_], Ve[S] = Math.max(z3[S], H[S]), Ve[T] = Math.min(0, H[T] + fe[1 - y4]), R.__rectSize = d4[_], Z) {
            var Le = { x: 0, y: 0 };
            Le[_] = Math.max(d4[_] - H[_] - _e, 0), Le[S] = Ve[S], R.setClipPath(new xu({ shape: Le })), R.__rectSize = Le[_];
          } else
            V.eachChild(function(Xe) {
              Xe.attr({ invisible: true, silent: true });
            });
          var je = this._getPageInfo(n6);
          return je.pageIndex != null && ku(O, { x: je.contentPosition[0], y: je.contentPosition[1] }, Z ? n6 : null), this._updatePageInfoView(n6, je), Ve;
        }, a.prototype._pageGo = function(n6, f6, d4) {
          var y4 = this._getPageInfo(f6)[n6];
          y4 != null && d4.dispatchAction({ type: "legendScroll", scrollDataIndex: y4, legendId: f6.id });
        }, a.prototype._updatePageInfoView = function(n6, f6) {
          var d4 = this._controllerGroup;
          gt(["pagePrev", "pageNext"], function(O) {
            var R = O + "DataIndex", V = f6[R] != null, z3 = d4.childOfName(O);
            z3 && (z3.setStyle("fill", V ? n6.get("pageIconColor", true) : n6.get("pageIconInactiveColor", true)), z3.cursor = V ? "pointer" : "default");
          });
          var y4 = d4.childOfName("pageText"), _ = n6.get("pageFormatter"), S = f6.pageIndex, T = S != null ? S + 1 : 0, E = f6.pageCount;
          y4 && _ && y4.setStyle("text", Wa(_) ? _.replace("{current}", T == null ? "" : T + "").replace("{total}", E == null ? "" : E + "") : _({ current: T, total: E }));
        }, a.prototype._getPageInfo = function(n6) {
          var f6 = n6.get("scrollDataIndex", true), d4 = this.getContentGroup(), y4 = this._containerGroup.__rectSize, _ = n6.getOrient().index, S = TCe[_], T = ACe[_], E = this._findTargetItemIndex(f6), O = d4.children(), R = O[E], V = O.length, z3 = V ? 1 : 0, H = { contentPosition: [d4.x, d4.y], pageCount: z3, pageIndex: z3 - 1, pagePrevDataIndex: null, pageNextDataIndex: null };
          if (!R)
            return H;
          var Z = pe(R);
          H.contentPosition[_] = -Z.s;
          for (var ee = E + 1, oe = Z, fe = Z, _e = null; ee <= V; ++ee)
            _e = pe(O[ee]), (!_e && fe.e > oe.s + y4 || _e && !Ve(_e, oe.s)) && (fe.i > oe.i ? oe = fe : oe = _e, oe && (H.pageNextDataIndex == null && (H.pageNextDataIndex = oe.i), ++H.pageCount)), fe = _e;
          for (var ee = E - 1, oe = Z, fe = Z, _e = null; ee >= -1; --ee)
            _e = pe(O[ee]), (!_e || !Ve(fe, _e.s)) && oe.i < fe.i && (fe = oe, H.pagePrevDataIndex == null && (H.pagePrevDataIndex = oe.i), ++H.pageCount, ++H.pageIndex), oe = _e;
          return H;
          function pe(Le) {
            if (Le) {
              var je = Le.getBoundingRect(), Xe = je[T] + Le[T];
              return { s: Xe, e: Xe + je[S], i: Le.__legendDataIndex };
            }
          }
          function Ve(Le, je) {
            return Le.e >= je && Le.s <= je + y4;
          }
        }, a.prototype._findTargetItemIndex = function(n6) {
          if (!this._showController)
            return 0;
          var f6, d4 = this.getContentGroup(), y4;
          return d4.eachChild(function(_, S) {
            var T = _.__legendDataIndex;
            y4 == null && T != null && (y4 = S), T === n6 && (f6 = S);
          }), f6 != null ? f6 : y4;
        }, a.type = "legend.scroll", a;
      }(gZe), tKt = eKt;
      function nKt(s) {
        s.registerAction("legendScroll", "legendscroll", function(a, n6) {
          var f6 = a.scrollDataIndex;
          f6 != null && n6.eachComponent({ mainType: "legend", subType: "scroll", query: a }, function(d4) {
            d4.setScrollDataIndex(f6);
          });
        });
      }
      function rKt(s) {
        Il(yZe), s.registerComponentModel(QYt), s.registerComponentView(tKt), nKt(s);
      }
      function iKt(s) {
        Il(yZe), Il(rKt);
      }
      var aKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "dataZoom.inside", a.defaultOption = Xk(hX.defaultOption, { disabled: false, zoomLock: false, zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: false, preventDefaultMouseMove: true }), a;
      }(hX), oKt = aKt, ICe = hu();
      function sKt(s, a, n6) {
        ICe(s).coordSysRecordMap.each(function(f6) {
          var d4 = f6.dataZoomInfoMap.get(a.uid);
          d4 && (d4.getRange = n6);
        });
      }
      function lKt(s, a) {
        for (var n6 = ICe(s).coordSysRecordMap, f6 = n6.keys(), d4 = 0; d4 < f6.length; d4++) {
          var y4 = f6[d4], _ = n6.get(y4), S = _.dataZoomInfoMap;
          if (S) {
            var T = a.uid, E = S.get(T);
            E && (S.removeKey(T), S.keys().length || _Ze(n6, _));
          }
        }
      }
      function _Ze(s, a) {
        if (a) {
          s.removeKey(a.model.uid);
          var n6 = a.controller;
          n6 && n6.dispose();
        }
      }
      function uKt(s, a) {
        var n6 = { model: a, containsPoint: ks(fKt, a), dispatchAction: ks(cKt, s), dataZoomInfoMap: null, controller: null }, f6 = n6.controller = new Y$(s.getZr());
        return gt(["pan", "zoom", "scrollMove"], function(d4) {
          f6.on(d4, function(y4) {
            var _ = [];
            n6.dataZoomInfoMap.each(function(S) {
              if (y4.isAvailableBehavior(S.model.option)) {
                var T = (S.getRange || {})[d4], E = T && T(S.dzReferCoordSysInfo, n6.model.mainType, n6.controller, y4);
                !S.model.get("disabled", true) && E && _.push({ dataZoomId: S.model.id, start: E[0], end: E[1] });
              }
            }), _.length && n6.dispatchAction(_);
          });
        }), n6;
      }
      function cKt(s, a) {
        s.isDisposed() || s.dispatchAction({ type: "dataZoom", animation: { easing: "cubicOut", duration: 100 }, batch: a });
      }
      function fKt(s, a, n6, f6) {
        return s.coordinateSystem.containPoint([n6, f6]);
      }
      function hKt(s) {
        var a, n6 = "type_", f6 = { type_true: 2, type_move: 1, type_false: 0, type_undefined: -1 }, d4 = true;
        return s.each(function(y4) {
          var _ = y4.model, S = _.get("disabled", true) ? false : _.get("zoomLock", true) ? "move" : true;
          f6[n6 + S] > f6[n6 + a] && (a = S), d4 = d4 && _.get("preventDefaultMouseMove", true);
        }), { controlType: a, opt: { zoomOnMouseWheel: true, moveOnMouseMove: true, moveOnMouseWheel: true, preventDefaultMouseMove: !!d4 } };
      }
      function pKt(s) {
        s.registerProcessor(s.PRIORITY.PROCESSOR.FILTER, function(a, n6) {
          var f6 = ICe(n6), d4 = f6.coordSysRecordMap || (f6.coordSysRecordMap = ro());
          d4.each(function(y4) {
            y4.dataZoomInfoMap = null;
          }), a.eachComponent({ mainType: "dataZoom", subType: "inside" }, function(y4) {
            var _ = gKe(y4);
            gt(_.infoList, function(S) {
              var T = S.model.uid, E = d4.get(T) || d4.set(T, uKt(n6, S.model)), O = E.dataZoomInfoMap || (E.dataZoomInfoMap = ro());
              O.set(y4.uid, { dzReferCoordSysInfo: S, model: y4, getRange: null });
            });
          }), d4.each(function(y4) {
            var _ = y4.controller, S, T = y4.dataZoomInfoMap;
            if (T) {
              var E = T.keys()[0];
              E != null && (S = T.get(E));
            }
            if (!S) {
              _Ze(d4, y4);
              return;
            }
            var O = hKt(T);
            _.enable(O.controlType, O.opt), _.setPointerChecker(y4.containsPoint), N7(y4, "dispatchAction", S.model.get("throttle", true), "fixRate");
          });
        });
      }
      var dKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "dataZoom.inside", n6;
        }
        return a.prototype.render = function(n6, f6, d4) {
          if (s.prototype.render.apply(this, arguments), n6.noTarget()) {
            this._clear();
            return;
          }
          this.range = n6.getPercentRange(), sKt(d4, n6, { pan: Za(ECe.pan, this), zoom: Za(ECe.zoom, this), scrollMove: Za(ECe.scrollMove, this) });
        }, a.prototype.dispose = function() {
          this._clear(), s.prototype.dispose.apply(this, arguments);
        }, a.prototype._clear = function() {
          lKt(this.api, this.dataZoomModel), this.range = null;
        }, a.type = "dataZoom.inside", a;
      }(nCe), ECe = { zoom: function(s, a, n6, f6) {
        var d4 = this.range, y4 = d4.slice(), _ = s.axisModels[0];
        if (_) {
          var S = DCe[a](null, [f6.originX, f6.originY], _, n6, s), T = (S.signal > 0 ? S.pixelStart + S.pixelLength - S.pixel : S.pixel - S.pixelStart) / S.pixelLength * (y4[1] - y4[0]) + y4[0], E = Math.max(1 / f6.scale, 0);
          y4[0] = (y4[0] - T) * E + T, y4[1] = (y4[1] - T) * E + T;
          var O = this.dataZoomModel.findRepresentativeAxisProxy().getMinMaxSpan();
          if (r4(0, y4, [0, 100], 0, O.minSpan, O.maxSpan), this.range = y4, d4[0] !== y4[0] || d4[1] !== y4[1])
            return y4;
        }
      }, pan: xZe(function(s, a, n6, f6, d4, y4) {
        var _ = DCe[f6]([y4.oldX, y4.oldY], [y4.newX, y4.newY], a, d4, n6);
        return _.signal * (s[1] - s[0]) * _.pixel / _.pixelLength;
      }), scrollMove: xZe(function(s, a, n6, f6, d4, y4) {
        var _ = DCe[f6]([0, 0], [y4.scrollDelta, y4.scrollDelta], a, d4, n6);
        return _.signal * (s[1] - s[0]) * y4.scrollDelta;
      }) };
      function xZe(s) {
        return function(a, n6, f6, d4) {
          var y4 = this.range, _ = y4.slice(), S = a.axisModels[0];
          if (S) {
            var T = s(_, S, a, n6, f6, d4);
            if (r4(T, _, [0, 100], "all"), this.range = _, y4[0] !== _[0] || y4[1] !== _[1])
              return _;
          }
        };
      }
      var DCe = { grid: function(s, a, n6, f6, d4) {
        var y4 = n6.axis, _ = {}, S = d4.model.coordinateSystem.getRect();
        return s = s || [0, 0], y4.dim === "x" ? (_.pixel = a[0] - s[0], _.pixelLength = S.width, _.pixelStart = S.x, _.signal = y4.inverse ? 1 : -1) : (_.pixel = a[1] - s[1], _.pixelLength = S.height, _.pixelStart = S.y, _.signal = y4.inverse ? -1 : 1), _;
      }, polar: function(s, a, n6, f6, d4) {
        var y4 = n6.axis, _ = {}, S = d4.model.coordinateSystem, T = S.getRadiusAxis().getExtent(), E = S.getAngleAxis().getExtent();
        return s = s ? S.pointToCoord(s) : [0, 0], a = S.pointToCoord(a), n6.mainType === "radiusAxis" ? (_.pixel = a[0] - s[0], _.pixelLength = T[1] - T[0], _.pixelStart = T[0], _.signal = y4.inverse ? 1 : -1) : (_.pixel = a[1] - s[1], _.pixelLength = E[1] - E[0], _.pixelStart = E[0], _.signal = y4.inverse ? -1 : 1), _;
      }, singleAxis: function(s, a, n6, f6, d4) {
        var y4 = n6.axis, _ = d4.model.coordinateSystem.getRect(), S = {};
        return s = s || [0, 0], y4.orient === "horizontal" ? (S.pixel = a[0] - s[0], S.pixelLength = _.width, S.pixelStart = _.x, S.signal = y4.inverse ? 1 : -1) : (S.pixel = a[1] - s[1], S.pixelLength = _.height, S.pixelStart = _.y, S.signal = y4.inverse ? -1 : 1), S;
      } }, vKt = dKt;
      function wZe(s) {
        rCe(s), s.registerComponentModel(oKt), s.registerComponentView(vKt), pKt(s);
      }
      var gKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.type = "dataZoom.slider", a.layoutMode = "box", a.defaultOption = Xk(hX.defaultOption, { show: true, right: "ph", top: "ph", width: "ph", height: "ph", left: null, bottom: null, borderColor: "#d2dbee", borderRadius: 3, backgroundColor: "rgba(47,69,84,0)", dataBackground: { lineStyle: { color: "#d2dbee", width: 0.5 }, areaStyle: { color: "#d2dbee", opacity: 0.2 } }, selectedDataBackground: { lineStyle: { color: "#8fb0f7", width: 0.5 }, areaStyle: { color: "#8fb0f7", opacity: 0.2 } }, fillerColor: "rgba(135,175,274,0.2)", handleIcon: "path://M-9.35,34.56V42m0-40V9.5m-2,0h4a2,2,0,0,1,2,2v21a2,2,0,0,1-2,2h-4a2,2,0,0,1-2-2v-21A2,2,0,0,1-11.35,9.5Z", handleSize: "100%", handleStyle: { color: "#fff", borderColor: "#ACB8D1" }, moveHandleSize: 7, moveHandleIcon: "path://M-320.9-50L-320.9-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-348-41-339-50-320.9-50z M-212.3-50L-212.3-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-239.4-41-230.4-50-212.3-50z M-103.7-50L-103.7-50c18.1,0,27.1,9,27.1,27.1V85.7c0,18.1-9,27.1-27.1,27.1l0,0c-18.1,0-27.1-9-27.1-27.1V-22.9C-130.9-41-121.8-50-103.7-50z", moveHandleStyle: { color: "#D2DBEE", opacity: 0.7 }, showDetail: true, showDataShadow: "auto", realtime: true, zoomLock: false, textStyle: { color: "#6E7079" }, brushSelect: true, brushStyle: { color: "rgba(135,175,274,0.15)" }, emphasis: { handleStyle: { borderColor: "#8FB0F7" }, moveHandleStyle: { color: "#8FB0F7" } } }), a;
      }(hX), yKt = gKt, mX = xu, SZe = 7, mKt = 1, kCe = 30, bKt = 7, bX = "horizontal", CZe = "vertical", _Kt = 5, xKt = ["line", "bar", "candlestick", "scatter"], wKt = { easing: "cubicOut", duration: 100, delay: 0 }, SKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._displayables = {}, n6;
        }
        return a.prototype.init = function(n6, f6) {
          this.api = f6, this._onBrush = Za(this._onBrush, this), this._onBrushEnd = Za(this._onBrushEnd, this);
        }, a.prototype.render = function(n6, f6, d4, y4) {
          if (s.prototype.render.apply(this, arguments), N7(this, "_dispatchZoomAction", n6.get("throttle"), "fixRate"), this._orient = n6.getOrient(), n6.get("show") === false) {
            this.group.removeAll();
            return;
          }
          if (n6.noTarget()) {
            this._clear(), this.group.removeAll();
            return;
          }
          (!y4 || y4.type !== "dataZoom" || y4.from !== this.uid) && this._buildView(), this._updateView();
        }, a.prototype.dispose = function() {
          this._clear(), s.prototype.dispose.apply(this, arguments);
        }, a.prototype._clear = function() {
          y$(this, "_dispatchZoomAction");
          var n6 = this.api.getZr();
          n6.off("mousemove", this._onBrush), n6.off("mouseup", this._onBrushEnd);
        }, a.prototype._buildView = function() {
          var n6 = this.group;
          n6.removeAll(), this._brushing = false, this._displayables.brushRect = null, this._resetLocation(), this._resetInterval();
          var f6 = this._displayables.sliderGroup = new fs();
          this._renderBackground(), this._renderHandle(), this._renderDataShadow(), n6.add(f6), this._positionGroup();
        }, a.prototype._resetLocation = function() {
          var n6 = this.dataZoomModel, f6 = this.api, d4 = n6.get("brushSelect"), y4 = d4 ? bKt : 0, _ = this._findCoordRect(), S = { width: f6.getWidth(), height: f6.getHeight() }, T = this._orient === bX ? { right: S.width - _.x - _.width, top: S.height - kCe - SZe - y4, width: _.width, height: kCe } : { right: SZe, top: _.y, width: kCe, height: _.height }, E = E7(n6.option);
          gt(["right", "top", "width", "height"], function(R) {
            E[R] === "ph" && (E[R] = T[R]);
          });
          var O = Qv(E, S);
          this._location = { x: O.x, y: O.y }, this._size = [O.width, O.height], this._orient === CZe && this._size.reverse();
        }, a.prototype._positionGroup = function() {
          var n6 = this.group, f6 = this._location, d4 = this._orient, y4 = this.dataZoomModel.getFirstTargetAxisModel(), _ = y4 && y4.get("inverse"), S = this._displayables.sliderGroup, T = (this._dataShadowInfo || {}).otherAxisInverse;
          S.attr(d4 === bX && !_ ? { scaleY: T ? 1 : -1, scaleX: 1 } : d4 === bX && _ ? { scaleY: T ? 1 : -1, scaleX: -1 } : d4 === CZe && !_ ? { scaleY: T ? -1 : 1, scaleX: 1, rotation: Math.PI / 2 } : { scaleY: T ? -1 : 1, scaleX: -1, rotation: Math.PI / 2 });
          var E = n6.getBoundingRect([S]);
          n6.x = f6.x - E.x, n6.y = f6.y - E.y, n6.markRedraw();
        }, a.prototype._getViewExtent = function() {
          return [0, this._size[0]];
        }, a.prototype._renderBackground = function() {
          var n6 = this.dataZoomModel, f6 = this._size, d4 = this._displayables.sliderGroup, y4 = n6.get("brushSelect");
          d4.add(new mX({ silent: true, shape: { x: 0, y: 0, width: f6[0], height: f6[1] }, style: { fill: n6.get("backgroundColor") }, z2: -40 }));
          var _ = new mX({ shape: { x: 0, y: 0, width: f6[0], height: f6[1] }, style: { fill: "transparent" }, z2: 0, onclick: Za(this._onClickPanel, this) }), S = this.api.getZr();
          y4 ? (_.on("mousedown", this._onBrushStart, this), _.cursor = "crosshair", S.on("mousemove", this._onBrush), S.on("mouseup", this._onBrushEnd)) : (S.off("mousemove", this._onBrush), S.off("mouseup", this._onBrushEnd)), d4.add(_);
        }, a.prototype._renderDataShadow = function() {
          var n6 = this._dataShadowInfo = this._prepareDataShadowInfo();
          if (this._displayables.dataShadowSegs = [], !n6)
            return;
          var f6 = this._size, d4 = this._shadowSize || [], y4 = n6.series, _ = y4.getRawData(), S = y4.getShadowDim ? y4.getShadowDim() : n6.otherDim;
          if (S == null)
            return;
          var T = this._shadowPolygonPts, E = this._shadowPolylinePts;
          if (_ !== this._shadowData || S !== this._shadowDim || f6[0] !== d4[0] || f6[1] !== d4[1]) {
            var O = _.getDataExtent(S), R = (O[1] - O[0]) * 0.3;
            O = [O[0] - R, O[1] + R];
            var V = [0, f6[1]], z3 = [0, f6[0]], H = [[f6[0], 0], [0, 0]], Z = [], ee = z3[1] / (_.count() - 1), oe = 0, fe = Math.round(_.count() / f6[0]), _e;
            _.each([S], function(Xe, Ye) {
              if (fe > 0 && Ye % fe) {
                oe += ee;
                return;
              }
              var rt2 = Xe == null || isNaN(Xe) || Xe === "", ut = rt2 ? 0 : zu(Xe, O, V, true);
              rt2 && !_e && Ye ? (H.push([H[H.length - 1][0], 0]), Z.push([Z[Z.length - 1][0], 0])) : !rt2 && _e && (H.push([oe, 0]), Z.push([oe, 0])), H.push([oe, ut]), Z.push([oe, ut]), oe += ee, _e = rt2;
            }), T = this._shadowPolygonPts = H, E = this._shadowPolylinePts = Z;
          }
          this._shadowData = _, this._shadowDim = S, this._shadowSize = [f6[0], f6[1]];
          var pe = this.dataZoomModel;
          function Ve(Xe) {
            var Ye = pe.getModel(Xe ? "selectedDataBackground" : "dataBackground"), rt2 = new fs(), ut = new T0({ shape: { points: T }, segmentIgnoreThreshold: 1, style: Ye.getModel("areaStyle").getAreaStyle(), silent: true, z2: -20 }), wt = new zm({ shape: { points: E }, segmentIgnoreThreshold: 1, style: Ye.getModel("lineStyle").getLineStyle(), silent: true, z2: -19 });
            return rt2.add(ut), rt2.add(wt), rt2;
          }
          for (var Le = 0; Le < 3; Le++) {
            var je = Ve(Le === 1);
            this._displayables.sliderGroup.add(je), this._displayables.dataShadowSegs.push(je);
          }
        }, a.prototype._prepareDataShadowInfo = function() {
          var n6 = this.dataZoomModel, f6 = n6.get("showDataShadow");
          if (f6 !== false) {
            var d4, y4 = this.ecModel;
            return n6.eachTargetAxis(function(_, S) {
              var T = n6.getAxisProxy(_, S).getTargetSeriesModels();
              gt(T, function(E) {
                if (!d4 && !(f6 !== true && Ns(xKt, E.get("type")) < 0)) {
                  var O = y4.getComponent(f3(_), S).axis, R = CKt(_), V, z3 = E.coordinateSystem;
                  R != null && z3.getOtherAxis && (V = z3.getOtherAxis(O).inverse), R = E.getData().mapDimension(R), d4 = { thisAxis: O, series: E, thisDim: _, otherDim: R, otherAxisInverse: V };
                }
              }, this);
            }, this), d4;
          }
        }, a.prototype._renderHandle = function() {
          var n6 = this.group, f6 = this._displayables, d4 = f6.handles = [null, null], y4 = f6.handleLabels = [null, null], _ = this._displayables.sliderGroup, S = this._size, T = this.dataZoomModel, E = this.api, O = T.get("borderRadius") || 0, R = T.get("brushSelect"), V = f6.filler = new mX({ silent: R, style: { fill: T.get("fillerColor") }, textConfig: { position: "inside" } });
          _.add(V), _.add(new mX({ silent: true, subPixelOptimize: true, shape: { x: 0, y: 0, width: S[0], height: S[1], r: O }, style: { stroke: T.get("dataBackgroundColor") || T.get("borderColor"), lineWidth: mKt, fill: "rgba(0,0,0,0)" } })), gt([0, 1], function(_e) {
            var pe = T.get("handleIcon");
            !Wae[pe] && pe.indexOf("path://") < 0 && pe.indexOf("image://") < 0 && (pe = "path://" + pe);
            var Ve = bv(pe, -1, 0, 2, 2, null, true);
            Ve.attr({ cursor: MZe(this._orient), draggable: true, drift: Za(this._onDragMove, this, _e), ondragend: Za(this._onDragEnd, this), onmouseover: Za(this._showDataInfo, this, true), onmouseout: Za(this._showDataInfo, this, false), z2: 5 });
            var Le = Ve.getBoundingRect(), je = T.get("handleSize");
            this._handleHeight = Ia(je, this._size[1]), this._handleWidth = Le.width / Le.height * this._handleHeight, Ve.setStyle(T.getModel("handleStyle").getItemStyle()), Ve.style.strokeNoScale = true, Ve.rectHover = true, Ve.ensureState("emphasis").style = T.getModel(["emphasis", "handleStyle"]).getItemStyle(), TE(Ve);
            var Xe = T.get("handleColor");
            Xe != null && (Ve.style.fill = Xe), _.add(d4[_e] = Ve);
            var Ye = T.getModel("textStyle");
            n6.add(y4[_e] = new ju({ silent: true, invisible: true, style: Zd(Ye, { x: 0, y: 0, text: "", verticalAlign: "middle", align: "center", fill: Ye.getTextColor(), font: Ye.getFont() }), z2: 10 }));
          }, this);
          var z3 = V;
          if (R) {
            var H = Ia(T.get("moveHandleSize"), S[1]), Z = f6.moveHandle = new xu({ style: T.getModel("moveHandleStyle").getItemStyle(), silent: true, shape: { r: [0, 0, 2, 2], y: S[1] - 0.5, height: H } }), ee = H * 0.8, oe = f6.moveHandleIcon = bv(T.get("moveHandleIcon"), -ee / 2, -ee / 2, ee, ee, "#fff", true);
            oe.silent = true, oe.y = S[1] + H / 2 - 0.5, Z.ensureState("emphasis").style = T.getModel(["emphasis", "moveHandleStyle"]).getItemStyle();
            var fe = Math.min(S[1] / 2, Math.max(H, 10));
            z3 = f6.moveZone = new xu({ invisible: true, shape: { y: S[1] - fe, height: H + fe } }), z3.on("mouseover", function() {
              E.enterEmphasis(Z);
            }).on("mouseout", function() {
              E.leaveEmphasis(Z);
            }), _.add(Z), _.add(oe), _.add(z3);
          }
          z3.attr({ draggable: true, cursor: MZe(this._orient), drift: Za(this._onDragMove, this, "all"), ondragstart: Za(this._showDataInfo, this, true), ondragend: Za(this._onDragEnd, this), onmouseover: Za(this._showDataInfo, this, true), onmouseout: Za(this._showDataInfo, this, false) });
        }, a.prototype._resetInterval = function() {
          var n6 = this._range = this.dataZoomModel.getPercentRange(), f6 = this._getViewExtent();
          this._handleEnds = [zu(n6[0], [0, 100], f6, true), zu(n6[1], [0, 100], f6, true)];
        }, a.prototype._updateInterval = function(n6, f6) {
          var d4 = this.dataZoomModel, y4 = this._handleEnds, _ = this._getViewExtent(), S = d4.findRepresentativeAxisProxy().getMinMaxSpan(), T = [0, 100];
          r4(f6, y4, _, d4.get("zoomLock") ? "all" : n6, S.minSpan != null ? zu(S.minSpan, T, _, true) : null, S.maxSpan != null ? zu(S.maxSpan, T, _, true) : null);
          var E = this._range, O = this._range = W1([zu(y4[0], _, T, true), zu(y4[1], _, T, true)]);
          return !E || E[0] !== O[0] || E[1] !== O[1];
        }, a.prototype._updateView = function(n6) {
          var f6 = this._displayables, d4 = this._handleEnds, y4 = W1(d4.slice()), _ = this._size;
          gt([0, 1], function(z3) {
            var H = f6.handles[z3], Z = this._handleHeight;
            H.attr({ scaleX: Z / 2, scaleY: Z / 2, x: d4[z3] + (z3 ? -1 : 1), y: _[1] / 2 - Z / 2 });
          }, this), f6.filler.setShape({ x: y4[0], y: 0, width: y4[1] - y4[0], height: _[1] });
          var S = { x: y4[0], width: y4[1] - y4[0] };
          f6.moveHandle && (f6.moveHandle.setShape(S), f6.moveZone.setShape(S), f6.moveZone.getBoundingRect(), f6.moveHandleIcon && f6.moveHandleIcon.attr("x", S.x + S.width / 2));
          for (var T = f6.dataShadowSegs, E = [0, y4[0], y4[1], _[0]], O = 0; O < T.length; O++) {
            var R = T[O], V = R.getClipPath();
            V || (V = new xu(), R.setClipPath(V)), V.setShape({ x: E[O], y: 0, width: E[O + 1] - E[O], height: _[1] });
          }
          this._updateDataInfo(n6);
        }, a.prototype._updateDataInfo = function(n6) {
          var f6 = this.dataZoomModel, d4 = this._displayables, y4 = d4.handleLabels, _ = this._orient, S = ["", ""];
          if (f6.get("showDetail")) {
            var T = f6.findRepresentativeAxisProxy();
            if (T) {
              var E = T.getAxisModel().axis, O = this._range, R = n6 ? T.calculateDataWindow({ start: O[0], end: O[1] }).valueWindow : T.getDataValueWindow();
              S = [this._formatLabel(R[0], E), this._formatLabel(R[1], E)];
            }
          }
          var V = W1(this._handleEnds.slice());
          z3.call(this, 0), z3.call(this, 1);
          function z3(H) {
            var Z = Qi(d4.handles[H].parent, this.group), ee = mo(H === 0 ? "right" : "left", Z), oe = this._handleWidth / 2 + _Kt, fe = pa([V[H] + (H === 0 ? -oe : oe), this._size[1] / 2], Z);
            y4[H].setStyle({ x: fe[0], y: fe[1], verticalAlign: _ === bX ? "middle" : ee, align: _ === bX ? ee : "center", text: S[H] });
          }
        }, a.prototype._formatLabel = function(n6, f6) {
          var d4 = this.dataZoomModel, y4 = d4.get("labelFormatter"), _ = d4.get("labelPrecision");
          (_ == null || _ === "auto") && (_ = f6.getPixelPrecision());
          var S = n6 == null || isNaN(n6) ? "" : f6.type === "category" || f6.type === "time" ? f6.scale.getLabel({ value: Math.round(n6) }) : n6.toFixed(Math.min(_, 20));
          return jo(y4) ? y4(n6, S) : Wa(y4) ? y4.replace("{value}", S) : S;
        }, a.prototype._showDataInfo = function(n6) {
          n6 = this._dragging || n6;
          var f6 = this._displayables, d4 = f6.handleLabels;
          d4[0].attr("invisible", !n6), d4[1].attr("invisible", !n6), f6.moveHandle && this.api[n6 ? "enterEmphasis" : "leaveEmphasis"](f6.moveHandle, 1);
        }, a.prototype._onDragMove = function(n6, f6, d4, y4) {
          this._dragging = true, Jw(y4.event);
          var _ = this._displayables.sliderGroup.getLocalTransform(), S = pa([f6, d4], _, true), T = this._updateInterval(n6, S[0]), E = this.dataZoomModel.get("realtime");
          this._updateView(!E), T && E && this._dispatchZoomAction(true);
        }, a.prototype._onDragEnd = function() {
          this._dragging = false, this._showDataInfo(false);
          var n6 = this.dataZoomModel.get("realtime");
          !n6 && this._dispatchZoomAction(false);
        }, a.prototype._onClickPanel = function(n6) {
          var f6 = this._size, d4 = this._displayables.sliderGroup.transformCoordToLocal(n6.offsetX, n6.offsetY);
          if (!(d4[0] < 0 || d4[0] > f6[0] || d4[1] < 0 || d4[1] > f6[1])) {
            var y4 = this._handleEnds, _ = (y4[0] + y4[1]) / 2, S = this._updateInterval("all", d4[0] - _);
            this._updateView(), S && this._dispatchZoomAction(false);
          }
        }, a.prototype._onBrushStart = function(n6) {
          var f6 = n6.offsetX, d4 = n6.offsetY;
          this._brushStart = new zs(f6, d4), this._brushing = true, this._brushStartTime = +new Date();
        }, a.prototype._onBrushEnd = function(n6) {
          if (this._brushing) {
            var f6 = this._displayables.brushRect;
            if (this._brushing = false, !!f6) {
              f6.attr("ignore", true);
              var d4 = f6.shape, y4 = +new Date();
              if (!(y4 - this._brushStartTime < 200 && Math.abs(d4.width) < 5)) {
                var _ = this._getViewExtent(), S = [0, 100];
                this._range = W1([zu(d4.x, _, S, true), zu(d4.x + d4.width, _, S, true)]), this._handleEnds = [d4.x, d4.x + d4.width], this._updateView(), this._dispatchZoomAction(false);
              }
            }
          }
        }, a.prototype._onBrush = function(n6) {
          this._brushing && (Jw(n6.event), this._updateBrushRect(n6.offsetX, n6.offsetY));
        }, a.prototype._updateBrushRect = function(n6, f6) {
          var d4 = this._displayables, y4 = this.dataZoomModel, _ = d4.brushRect;
          _ || (_ = d4.brushRect = new mX({ silent: true, style: y4.getModel("brushStyle").getItemStyle() }), d4.sliderGroup.add(_)), _.attr("ignore", false);
          var S = this._brushStart, T = this._displayables.sliderGroup, E = T.transformCoordToLocal(n6, f6), O = T.transformCoordToLocal(S.x, S.y), R = this._size;
          E[0] = Math.max(Math.min(R[0], E[0]), 0), _.setShape({ x: O[0], y: 0, width: E[0] - O[0], height: R[1] });
        }, a.prototype._dispatchZoomAction = function(n6) {
          var f6 = this._range;
          this.api.dispatchAction({ type: "dataZoom", from: this.uid, dataZoomId: this.dataZoomModel.id, animation: n6 ? wKt : null, start: f6[0], end: f6[1] });
        }, a.prototype._findCoordRect = function() {
          var n6, f6 = gKe(this.dataZoomModel).infoList;
          if (!n6 && f6.length) {
            var d4 = f6[0].model.coordinateSystem;
            n6 = d4.getRect && d4.getRect();
          }
          if (!n6) {
            var y4 = this.api.getWidth(), _ = this.api.getHeight();
            n6 = { x: y4 * 0.2, y: _ * 0.2, width: y4 * 0.6, height: _ * 0.6 };
          }
          return n6;
        }, a.type = "dataZoom.slider", a;
      }(nCe);
      function CKt(s) {
        var a = { x: "y", y: "x", radius: "angle", angle: "radius" };
        return a[s];
      }
      function MZe(s) {
        return s === "vertical" ? "ns-resize" : "ew-resize";
      }
      var MKt = SKt;
      function TZe(s) {
        s.registerComponentModel(yKt), s.registerComponentView(MKt), rCe(s);
      }
      function TKt(s) {
        Il(wZe), Il(TZe);
      }
      var AKt = { get: function(s, a, n6) {
        var f6 = Bo((IKt[s] || {})[a]);
        return n6 && Di(f6) ? f6[f6.length - 1] : f6;
      } }, IKt = { color: { active: ["#006edd", "#e0ffff"], inactive: ["rgba(0,0,0,0)"] }, colorHue: { active: [0, 360], inactive: [0, 0] }, colorSaturation: { active: [0.3, 1], inactive: [0, 0] }, colorLightness: { active: [0.9, 0.5], inactive: [0, 0] }, colorAlpha: { active: [0.3, 1], inactive: [0, 0] }, opacity: { active: [0.3, 1], inactive: [0, 0] }, symbol: { active: ["circle", "roundRect", "diamond"], inactive: ["none"] }, symbolSize: { active: [10, 50], inactive: [0, 0] } }, AZe = AKt, IZe = zy.mapVisual, EKt = zy.eachVisual, DKt = Di, EZe = gt, kKt = W1, OKt = zu, PKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.stateList = ["inRange", "outOfRange"], n6.replacableOptionKeys = ["inRange", "outOfRange", "target", "controller", "color"], n6.layoutMode = { type: "box", ignoreSize: true }, n6.dataBound = [-1 / 0, 1 / 0], n6.targetVisuals = {}, n6.controllerVisuals = {}, n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          this.mergeDefaultAndTheme(n6, d4);
        }, a.prototype.optionUpdated = function(n6, f6) {
          var d4 = this.option;
          !f6 && qKe(d4, n6, this.replacableOptionKeys), this.textStyleModel = this.getModel("textStyle"), this.resetItemSize(), this.completeVisualOption();
        }, a.prototype.resetVisual = function(n6) {
          var f6 = this.stateList;
          n6 = Za(n6, this), this.controllerVisuals = hCe(this.option.controller, f6, n6), this.targetVisuals = hCe(this.option.target, f6, n6);
        }, a.prototype.getItemSymbol = function() {
          return null;
        }, a.prototype.getTargetSeriesIndices = function() {
          var n6 = this.option.seriesIndex, f6 = [];
          return n6 == null || n6 === "all" ? this.ecModel.eachSeries(function(d4, y4) {
            f6.push(y4);
          }) : f6 = jc(n6), f6;
        }, a.prototype.eachTargetSeries = function(n6, f6) {
          gt(this.getTargetSeriesIndices(), function(d4) {
            var y4 = this.ecModel.getSeriesByIndex(d4);
            y4 && n6.call(f6, y4);
          }, this);
        }, a.prototype.isTargetSeries = function(n6) {
          var f6 = false;
          return this.eachTargetSeries(function(d4) {
            d4 === n6 && (f6 = true);
          }), f6;
        }, a.prototype.formatValueText = function(n6, f6, d4) {
          var y4 = this.option, _ = y4.precision, S = this.dataBound, T = y4.formatter, E;
          d4 = d4 || ["<", ">"], Di(n6) && (n6 = n6.slice(), E = true);
          var O = f6 ? n6 : E ? [R(n6[0]), R(n6[1])] : R(n6);
          if (Wa(T))
            return T.replace("{value}", E ? O[0] : O).replace("{value2}", E ? O[1] : O);
          if (jo(T))
            return E ? T(n6[0], n6[1]) : T(n6);
          if (E)
            return n6[0] === S[0] ? d4[0] + " " + O[1] : n6[1] === S[1] ? d4[1] + " " + O[0] : O[0] + " - " + O[1];
          return O;
          function R(V) {
            return V === S[0] ? "min" : V === S[1] ? "max" : (+V).toFixed(Math.min(_, 20));
          }
        }, a.prototype.resetExtent = function() {
          var n6 = this.option, f6 = kKt([n6.min, n6.max]);
          this._dataExtent = f6;
        }, a.prototype.getDataDimensionIndex = function(n6) {
          var f6 = this.option.dimension;
          if (f6 != null)
            return n6.getDimensionIndex(f6);
          for (var d4 = n6.dimensions, y4 = d4.length - 1; y4 >= 0; y4--) {
            var _ = d4[y4], S = n6.getDimensionInfo(_);
            if (!S.isCalculationCoord)
              return S.storeDimIndex;
          }
        }, a.prototype.getExtent = function() {
          return this._dataExtent.slice();
        }, a.prototype.completeVisualOption = function() {
          var n6 = this.ecModel, f6 = this.option, d4 = { inRange: f6.inRange, outOfRange: f6.outOfRange }, y4 = f6.target || (f6.target = {}), _ = f6.controller || (f6.controller = {});
          Ms(y4, d4), Ms(_, d4);
          var S = this.isCategory();
          T.call(this, y4), T.call(this, _), E.call(this, y4, "inRange", "outOfRange"), O.call(this, _);
          function T(R) {
            DKt(f6.color) && !R.inRange && (R.inRange = { color: f6.color.slice().reverse() }), R.inRange = R.inRange || { color: n6.get("gradientColor") };
          }
          function E(R, V, z3) {
            var H = R[V], Z = R[z3];
            H && !Z && (Z = R[z3] = {}, EZe(H, function(ee, oe) {
              if (zy.isValidType(oe)) {
                var fe = AZe.get(oe, "inactive", S);
                fe != null && (Z[oe] = fe, oe === "color" && !Z.hasOwnProperty("opacity") && !Z.hasOwnProperty("colorAlpha") && (Z.opacity = [0, 0]));
              }
            }));
          }
          function O(R) {
            var V = (R.inRange || {}).symbol || (R.outOfRange || {}).symbol, z3 = (R.inRange || {}).symbolSize || (R.outOfRange || {}).symbolSize, H = this.get("inactiveColor"), Z = this.getItemSymbol(), ee = Z || "roundRect";
            EZe(this.stateList, function(oe) {
              var fe = this.itemSize, _e = R[oe];
              _e || (_e = R[oe] = { color: S ? H : [H] }), _e.symbol == null && (_e.symbol = V && Bo(V) || (S ? ee : [ee])), _e.symbolSize == null && (_e.symbolSize = z3 && Bo(z3) || (S ? fe[0] : [fe[0], fe[0]])), _e.symbol = IZe(_e.symbol, function(Le) {
                return Le === "none" ? ee : Le;
              });
              var pe = _e.symbolSize;
              if (pe != null) {
                var Ve = -1 / 0;
                EKt(pe, function(Le) {
                  Le > Ve && (Ve = Le);
                }), _e.symbolSize = IZe(pe, function(Le) {
                  return OKt(Le, [0, Ve], [0, fe[0]], true);
                });
              }
            }, this);
          }
        }, a.prototype.resetItemSize = function() {
          this.itemSize = [parseFloat(this.get("itemWidth")), parseFloat(this.get("itemHeight"))];
        }, a.prototype.isCategory = function() {
          return !!this.option.categories;
        }, a.prototype.setSelected = function(n6) {
        }, a.prototype.getSelected = function() {
          return null;
        }, a.prototype.getValueState = function(n6) {
          return null;
        }, a.prototype.getVisualMeta = function(n6) {
          return null;
        }, a.type = "visualMap", a.dependencies = ["series"], a.defaultOption = { show: true, z: 4, seriesIndex: "all", min: 0, max: 200, left: 0, right: null, top: null, bottom: 0, itemWidth: null, itemHeight: null, inverse: false, orient: "vertical", backgroundColor: "rgba(0,0,0,0)", borderColor: "#ccc", contentColor: "#5793f3", inactiveColor: "#aaa", borderWidth: 0, padding: 5, textGap: 10, precision: 0, textStyle: { color: "#333" } }, a;
      }(oc), pse = PKt, DZe = [20, 140], LKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.optionUpdated = function(n6, f6) {
          s.prototype.optionUpdated.apply(this, arguments), this.resetExtent(), this.resetVisual(function(d4) {
            d4.mappingMethod = "linear", d4.dataExtent = this.getExtent();
          }), this._resetRange();
        }, a.prototype.resetItemSize = function() {
          s.prototype.resetItemSize.apply(this, arguments);
          var n6 = this.itemSize;
          (n6[0] == null || isNaN(n6[0])) && (n6[0] = DZe[0]), (n6[1] == null || isNaN(n6[1])) && (n6[1] = DZe[1]);
        }, a.prototype._resetRange = function() {
          var n6 = this.getExtent(), f6 = this.option.range;
          !f6 || f6.auto ? (n6.auto = 1, this.option.range = n6) : Di(f6) && (f6[0] > f6[1] && f6.reverse(), f6[0] = Math.max(f6[0], n6[0]), f6[1] = Math.min(f6[1], n6[1]));
        }, a.prototype.completeVisualOption = function() {
          s.prototype.completeVisualOption.apply(this, arguments), gt(this.stateList, function(n6) {
            var f6 = this.option.controller[n6].symbolSize;
            f6 && f6[0] !== f6[1] && (f6[0] = f6[1] / 3);
          }, this);
        }, a.prototype.setSelected = function(n6) {
          this.option.range = n6.slice(), this._resetRange();
        }, a.prototype.getSelected = function() {
          var n6 = this.getExtent(), f6 = W1((this.get("range") || []).slice());
          return f6[0] > n6[1] && (f6[0] = n6[1]), f6[1] > n6[1] && (f6[1] = n6[1]), f6[0] < n6[0] && (f6[0] = n6[0]), f6[1] < n6[0] && (f6[1] = n6[0]), f6;
        }, a.prototype.getValueState = function(n6) {
          var f6 = this.option.range, d4 = this.getExtent();
          return (f6[0] <= d4[0] || f6[0] <= n6) && (f6[1] >= d4[1] || n6 <= f6[1]) ? "inRange" : "outOfRange";
        }, a.prototype.findTargetDataIndices = function(n6) {
          var f6 = [];
          return this.eachTargetSeries(function(d4) {
            var y4 = [], _ = d4.getData();
            _.each(this.getDataDimensionIndex(_), function(S, T) {
              n6[0] <= S && S <= n6[1] && y4.push(T);
            }, this), f6.push({ seriesId: d4.id, dataIndex: y4 });
          }, this), f6;
        }, a.prototype.getVisualMeta = function(n6) {
          var f6 = kZe(this, "outOfRange", this.getExtent()), d4 = kZe(this, "inRange", this.option.range.slice()), y4 = [];
          function _(z3, H) {
            y4.push({ value: z3, color: n6(z3, H) });
          }
          for (var S = 0, T = 0, E = d4.length, O = f6.length; T < O && (!d4.length || f6[T] <= d4[0]); T++)
            f6[T] < d4[S] && _(f6[T], "outOfRange");
          for (var R = 1; S < E; S++, R = 0)
            R && y4.length && _(d4[S], "outOfRange"), _(d4[S], "inRange");
          for (var R = 1; T < O; T++)
            (!d4.length || d4[d4.length - 1] < f6[T]) && (R && (y4.length && _(y4[y4.length - 1].value, "outOfRange"), R = 0), _(f6[T], "outOfRange"));
          var V = y4.length;
          return { stops: y4, outerColors: [V ? y4[0].color : "transparent", V ? y4[V - 1].color : "transparent"] };
        }, a.type = "visualMap.continuous", a.defaultOption = Xk(pse.defaultOption, { align: "auto", calculable: false, hoverLink: true, realtime: true, handleIcon: "path://M-11.39,9.77h0a3.5,3.5,0,0,1-3.5,3.5h-22a3.5,3.5,0,0,1-3.5-3.5h0a3.5,3.5,0,0,1,3.5-3.5h22A3.5,3.5,0,0,1-11.39,9.77Z", handleSize: "120%", handleStyle: { borderColor: "#fff", borderWidth: 1 }, indicatorIcon: "circle", indicatorSize: "50%", indicatorStyle: { borderColor: "#fff", borderWidth: 2, shadowBlur: 2, shadowOffsetX: 1, shadowOffsetY: 1, shadowColor: "rgba(0,0,0,0.2)" } }), a;
      }(pse);
      function kZe(s, a, n6) {
        if (n6[0] === n6[1])
          return n6.slice();
        for (var f6 = 200, d4 = (n6[1] - n6[0]) / f6, y4 = n6[0], _ = [], S = 0; S <= f6 && y4 < n6[1]; S++)
          _.push(y4), y4 += d4;
        return _.push(n6[1]), _;
      }
      var RKt = LKt, NKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6.autoPositionValues = { left: 1, right: 1, top: 1, bottom: 1 }, n6;
        }
        return a.prototype.init = function(n6, f6) {
          this.ecModel = n6, this.api = f6;
        }, a.prototype.render = function(n6, f6, d4, y4) {
          if (this.visualMapModel = n6, n6.get("show") === false) {
            this.group.removeAll();
            return;
          }
          this.doRender(n6, f6, d4, y4);
        }, a.prototype.renderBackground = function(n6) {
          var f6 = this.visualMapModel, d4 = I7(f6.get("padding") || 0), y4 = n6.getBoundingRect();
          n6.add(new xu({ z2: -1, silent: true, shape: { x: y4.x - d4[3], y: y4.y - d4[0], width: y4.width + d4[3] + d4[1], height: y4.height + d4[0] + d4[2] }, style: { fill: f6.get("backgroundColor"), stroke: f6.get("borderColor"), lineWidth: f6.get("borderWidth") } }));
        }, a.prototype.getControllerVisual = function(n6, f6, d4) {
          d4 = d4 || {};
          var y4 = d4.forceState, _ = this.visualMapModel, S = {};
          if (f6 === "color") {
            var T = _.get("contentColor");
            S.color = T;
          }
          function E(z3) {
            return S[z3];
          }
          function O(z3, H) {
            S[z3] = H;
          }
          var R = _.controllerVisuals[y4 || _.getValueState(n6)], V = zy.prepareVisualTypes(R);
          return gt(V, function(z3) {
            var H = R[z3];
            d4.convertOpacityToAlpha && z3 === "opacity" && (z3 = "colorAlpha", H = R.__alphaForOpacity), zy.dependsOn(z3, f6) && H && H.applyVisual(n6, E, O);
          }), S[f6];
        }, a.prototype.positionGroup = function(n6) {
          var f6 = this.visualMapModel, d4 = this.api;
          Oae(n6, f6.getBoxLayoutParams(), { width: d4.getWidth(), height: d4.getHeight() });
        }, a.prototype.doRender = function(n6, f6, d4, y4) {
        }, a.type = "visualMap", a;
      }(sd), OZe = NKt, PZe = [["left", "right", "width"], ["top", "bottom", "height"]];
      function LZe(s, a, n6) {
        var f6 = s.option, d4 = f6.align;
        if (d4 != null && d4 !== "auto")
          return d4;
        for (var y4 = { width: a.getWidth(), height: a.getHeight() }, _ = f6.orient === "horizontal" ? 1 : 0, S = PZe[_], T = [0, null, 10], E = {}, O = 0; O < 3; O++)
          E[PZe[1 - _][O]] = T[O], E[S[O]] = O === 2 ? n6[0] : f6[S[O]];
        var R = [["x", "width", 3], ["y", "height", 0]][_], V = Qv(E, y4, f6.padding);
        return S[(V.margin[R[2]] || 0) + V[R[0]] + V[R[1]] * 0.5 < y4[R[1]] * 0.5 ? 0 : 1];
      }
      function dse(s, a) {
        return gt(s || [], function(n6) {
          n6.dataIndex != null && (n6.dataIndexInside = n6.dataIndex, n6.dataIndex = null), n6.highlightKey = "visualMap" + (a ? a.componentIndex : "");
        }), s;
      }
      var zT = zu, FKt = gt, RZe = Math.min, OCe = Math.max, VKt = 12, BKt = 6, zKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._shapes = {}, n6._dataInterval = [], n6._handleEnds = [], n6._hoverLinkDataIndices = [], n6;
        }
        return a.prototype.doRender = function(n6, f6, d4, y4) {
          this._api = d4, (!y4 || y4.type !== "selectDataRange" || y4.from !== this.uid) && this._buildView();
        }, a.prototype._buildView = function() {
          this.group.removeAll();
          var n6 = this.visualMapModel, f6 = this.group;
          this._orient = n6.get("orient"), this._useHandle = n6.get("calculable"), this._resetInterval(), this._renderBar(f6);
          var d4 = n6.get("text");
          this._renderEndsText(f6, d4, 0), this._renderEndsText(f6, d4, 1), this._updateView(true), this.renderBackground(f6), this._updateView(), this._enableHoverLinkToSeries(), this._enableHoverLinkFromSeries(), this.positionGroup(f6);
        }, a.prototype._renderEndsText = function(n6, f6, d4) {
          if (f6) {
            var y4 = f6[1 - d4];
            y4 = y4 != null ? y4 + "" : "";
            var _ = this.visualMapModel, S = _.get("textGap"), T = _.itemSize, E = this._shapes.mainGroup, O = this._applyTransform([T[0] / 2, d4 === 0 ? -S : T[1] + S], E), R = this._applyTransform(d4 === 0 ? "bottom" : "top", E), V = this._orient, z3 = this.visualMapModel.textStyleModel;
            this.group.add(new ju({ style: { x: O[0], y: O[1], verticalAlign: V === "horizontal" ? "middle" : R, align: V === "horizontal" ? R : "center", text: y4, font: z3.getFont(), fill: z3.getTextColor() } }));
          }
        }, a.prototype._renderBar = function(n6) {
          var f6 = this.visualMapModel, d4 = this._shapes, y4 = f6.itemSize, _ = this._orient, S = this._useHandle, T = LZe(f6, this.api, y4), E = d4.mainGroup = this._createBarGroup(T), O = new fs();
          E.add(O), O.add(d4.outOfRange = NZe()), O.add(d4.inRange = NZe(null, S ? VZe(this._orient) : null, Za(this._dragHandle, this, "all", false), Za(this._dragHandle, this, "all", true))), O.setClipPath(new xu({ shape: { x: 0, y: 0, width: y4[0], height: y4[1], r: 3 } }));
          var R = f6.textStyleModel.getTextRect("\u56FD"), V = OCe(R.width, R.height);
          S && (d4.handleThumbs = [], d4.handleLabels = [], d4.handleLabelPoints = [], this._createHandle(f6, E, 0, y4, V, _), this._createHandle(f6, E, 1, y4, V, _)), this._createIndicator(f6, E, y4, V, _), n6.add(E);
        }, a.prototype._createHandle = function(n6, f6, d4, y4, _, S) {
          var T = Za(this._dragHandle, this, d4, false), E = Za(this._dragHandle, this, d4, true), O = H1(n6.get("handleSize"), y4[0]), R = bv(n6.get("handleIcon"), -O / 2, -O / 2, O, O, null, true), V = VZe(this._orient);
          R.attr({ cursor: V, draggable: true, drift: T, ondragend: E, onmousemove: function(oe) {
            Jw(oe.event);
          } }), R.x = y4[0] / 2, R.useStyle(n6.getModel("handleStyle").getItemStyle()), R.setStyle({ strokeNoScale: true, strokeFirst: true }), R.style.lineWidth *= 2, R.ensureState("emphasis").style = n6.getModel(["emphasis", "handleStyle"]).getItemStyle(), AE(R, true), f6.add(R);
          var z3 = this.visualMapModel.textStyleModel, H = new ju({ cursor: V, draggable: true, drift: T, onmousemove: function(oe) {
            Jw(oe.event);
          }, ondragend: E, style: { x: 0, y: 0, text: "", font: z3.getFont(), fill: z3.getTextColor() } });
          H.ensureState("blur").style = { opacity: 0.1 }, H.stateTransition = { duration: 200 }, this.group.add(H);
          var Z = [O, 0], ee = this._shapes;
          ee.handleThumbs[d4] = R, ee.handleLabelPoints[d4] = Z, ee.handleLabels[d4] = H;
        }, a.prototype._createIndicator = function(n6, f6, d4, y4, _) {
          var S = H1(n6.get("indicatorSize"), d4[0]), T = bv(n6.get("indicatorIcon"), -S / 2, -S / 2, S, S, null, true);
          T.attr({ cursor: "move", invisible: true, silent: true, x: d4[0] / 2 });
          var E = n6.getModel("indicatorStyle").getItemStyle();
          if (T instanceof Zv) {
            var O = T.style;
            T.useStyle(ei({ image: O.image, x: O.x, y: O.y, width: O.width, height: O.height }, E));
          } else
            T.useStyle(E);
          f6.add(T);
          var R = this.visualMapModel.textStyleModel, V = new ju({ silent: true, invisible: true, style: { x: 0, y: 0, text: "", font: R.getFont(), fill: R.getTextColor() } });
          this.group.add(V);
          var z3 = [(_ === "horizontal" ? y4 / 2 : BKt) + d4[0] / 2, 0], H = this._shapes;
          H.indicator = T, H.indicatorLabel = V, H.indicatorLabelPoint = z3, this._firstShowIndicator = true;
        }, a.prototype._dragHandle = function(n6, f6, d4, y4) {
          if (this._useHandle) {
            if (this._dragging = !f6, !f6) {
              var _ = this._applyTransform([d4, y4], this._shapes.mainGroup, true);
              this._updateInterval(n6, _[1]), this._hideIndicator(), this._updateView();
            }
            f6 === !this.visualMapModel.get("realtime") && this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: this._dataInterval.slice() }), f6 ? !this._hovering && this._clearHoverLinkToSeries() : FZe(this.visualMapModel) && this._doHoverLinkToSeries(this._handleEnds[n6], false);
          }
        }, a.prototype._resetInterval = function() {
          var n6 = this.visualMapModel, f6 = this._dataInterval = n6.getSelected(), d4 = n6.getExtent(), y4 = [0, n6.itemSize[1]];
          this._handleEnds = [zT(f6[0], d4, y4, true), zT(f6[1], d4, y4, true)];
        }, a.prototype._updateInterval = function(n6, f6) {
          f6 = f6 || 0;
          var d4 = this.visualMapModel, y4 = this._handleEnds, _ = [0, d4.itemSize[1]];
          r4(f6, y4, _, n6, 0);
          var S = d4.getExtent();
          this._dataInterval = [zT(y4[0], _, S, true), zT(y4[1], _, S, true)];
        }, a.prototype._updateView = function(n6) {
          var f6 = this.visualMapModel, d4 = f6.getExtent(), y4 = this._shapes, _ = [0, f6.itemSize[1]], S = n6 ? _ : this._handleEnds, T = this._createBarVisual(this._dataInterval, d4, S, "inRange"), E = this._createBarVisual(d4, d4, _, "outOfRange");
          y4.inRange.setStyle({ fill: T.barColor }).setShape("points", T.barPoints), y4.outOfRange.setStyle({ fill: E.barColor }).setShape("points", E.barPoints), this._updateHandle(S, T);
        }, a.prototype._createBarVisual = function(n6, f6, d4, y4) {
          var _ = { forceState: y4, convertOpacityToAlpha: true }, S = this._makeColorGradient(n6, _), T = [this.getControllerVisual(n6[0], "symbolSize", _), this.getControllerVisual(n6[1], "symbolSize", _)], E = this._createBarPoints(d4, T);
          return { barColor: new DR(0, 0, 0, 1, S), barPoints: E, handlesColor: [S[0].color, S[S.length - 1].color] };
        }, a.prototype._makeColorGradient = function(n6, f6) {
          var d4 = 100, y4 = [], _ = (n6[1] - n6[0]) / d4;
          y4.push({ color: this.getControllerVisual(n6[0], "color", f6), offset: 0 });
          for (var S = 1; S < d4; S++) {
            var T = n6[0] + _ * S;
            if (T > n6[1])
              break;
            y4.push({ color: this.getControllerVisual(T, "color", f6), offset: S / d4 });
          }
          return y4.push({ color: this.getControllerVisual(n6[1], "color", f6), offset: 1 }), y4;
        }, a.prototype._createBarPoints = function(n6, f6) {
          var d4 = this.visualMapModel.itemSize;
          return [[d4[0] - f6[0], n6[0]], [d4[0], n6[0]], [d4[0], n6[1]], [d4[0] - f6[1], n6[1]]];
        }, a.prototype._createBarGroup = function(n6) {
          var f6 = this._orient, d4 = this.visualMapModel.get("inverse");
          return new fs(f6 === "horizontal" && !d4 ? { scaleX: n6 === "bottom" ? 1 : -1, rotation: Math.PI / 2 } : f6 === "horizontal" && d4 ? { scaleX: n6 === "bottom" ? -1 : 1, rotation: -Math.PI / 2 } : f6 === "vertical" && !d4 ? { scaleX: n6 === "left" ? 1 : -1, scaleY: -1 } : { scaleX: n6 === "left" ? 1 : -1 });
        }, a.prototype._updateHandle = function(n6, f6) {
          if (this._useHandle) {
            var d4 = this._shapes, y4 = this.visualMapModel, _ = d4.handleThumbs, S = d4.handleLabels, T = y4.itemSize, E = y4.getExtent();
            FKt([0, 1], function(O) {
              var R = _[O];
              R.setStyle("fill", f6.handlesColor[O]), R.y = n6[O];
              var V = zT(n6[O], [0, T[1]], E, true), z3 = this.getControllerVisual(V, "symbolSize");
              R.scaleX = R.scaleY = z3 / T[0], R.x = T[0] - z3 / 2;
              var H = pa(d4.handleLabelPoints[O], Qi(R, this.group));
              S[O].setStyle({ x: H[0], y: H[1], text: y4.formatValueText(this._dataInterval[O]), verticalAlign: "middle", align: this._orient === "vertical" ? this._applyTransform("left", d4.mainGroup) : "center" });
            }, this);
          }
        }, a.prototype._showIndicator = function(n6, f6, d4, y4) {
          var _ = this.visualMapModel, S = _.getExtent(), T = _.itemSize, E = [0, T[1]], O = this._shapes, R = O.indicator;
          if (R) {
            R.attr("invisible", false);
            var V = { convertOpacityToAlpha: true }, z3 = this.getControllerVisual(n6, "color", V), H = this.getControllerVisual(n6, "symbolSize"), Z = zT(n6, S, E, true), ee = T[0] - H / 2, oe = { x: R.x, y: R.y };
            R.y = Z, R.x = ee;
            var fe = pa(O.indicatorLabelPoint, Qi(R, this.group)), _e = O.indicatorLabel;
            _e.attr("invisible", false);
            var pe = this._applyTransform("left", O.mainGroup), Ve = this._orient, Le = Ve === "horizontal";
            _e.setStyle({ text: (d4 || "") + _.formatValueText(f6), verticalAlign: Le ? pe : "middle", align: Le ? "center" : pe });
            var je = { x: ee, y: Z, style: { fill: z3 } }, Xe = { style: { x: fe[0], y: fe[1] } };
            if (_.ecModel.isAnimationEnabled() && !this._firstShowIndicator) {
              var Ye = { duration: 100, easing: "cubicInOut", additive: true };
              R.x = oe.x, R.y = oe.y, R.animateTo(je, Ye), _e.animateTo(Xe, Ye);
            } else
              R.attr(je), _e.attr(Xe);
            this._firstShowIndicator = false;
            var rt2 = this._shapes.handleLabels;
            if (rt2)
              for (var ut = 0; ut < rt2.length; ut++)
                this._api.enterBlur(rt2[ut]);
          }
        }, a.prototype._enableHoverLinkToSeries = function() {
          var n6 = this;
          this._shapes.mainGroup.on("mousemove", function(f6) {
            if (n6._hovering = true, !n6._dragging) {
              var d4 = n6.visualMapModel.itemSize, y4 = n6._applyTransform([f6.offsetX, f6.offsetY], n6._shapes.mainGroup, true, true);
              y4[1] = RZe(OCe(0, y4[1]), d4[1]), n6._doHoverLinkToSeries(y4[1], 0 <= y4[0] && y4[0] <= d4[0]);
            }
          }).on("mouseout", function() {
            n6._hovering = false, !n6._dragging && n6._clearHoverLinkToSeries();
          });
        }, a.prototype._enableHoverLinkFromSeries = function() {
          var n6 = this.api.getZr();
          this.visualMapModel.option.hoverLink ? (n6.on("mouseover", this._hoverLinkFromSeriesMouseOver, this), n6.on("mouseout", this._hideIndicator, this)) : this._clearHoverLinkFromSeries();
        }, a.prototype._doHoverLinkToSeries = function(n6, f6) {
          var d4 = this.visualMapModel, y4 = d4.itemSize;
          if (d4.option.hoverLink) {
            var _ = [0, y4[1]], S = d4.getExtent();
            n6 = RZe(OCe(_[0], n6), _[1]);
            var T = jKt(d4, S, _), E = [n6 - T, n6 + T], O = zT(n6, _, S, true), R = [zT(E[0], _, S, true), zT(E[1], _, S, true)];
            E[0] < _[0] && (R[0] = -1 / 0), E[1] > _[1] && (R[1] = 1 / 0), f6 && (R[0] === -1 / 0 ? this._showIndicator(O, R[1], "< ", T) : R[1] === 1 / 0 ? this._showIndicator(O, R[0], "> ", T) : this._showIndicator(O, O, "\u2248 ", T));
            var V = this._hoverLinkDataIndices, z3 = [];
            (f6 || FZe(d4)) && (z3 = this._hoverLinkDataIndices = d4.findTargetDataIndices(R));
            var H = rq(V, z3);
            this._dispatchHighDown("downplay", dse(H[0], d4)), this._dispatchHighDown("highlight", dse(H[1], d4));
          }
        }, a.prototype._hoverLinkFromSeriesMouseOver = function(n6) {
          var f6 = n6.target, d4 = this.visualMapModel;
          if (!(!f6 || qo(f6).dataIndex == null)) {
            var y4 = qo(f6), _ = this.ecModel.getSeriesByIndex(y4.seriesIndex);
            if (d4.isTargetSeries(_)) {
              var S = _.getData(y4.dataType), T = S.getStore().get(d4.getDataDimensionIndex(S), y4.dataIndex);
              isNaN(T) || this._showIndicator(T, T);
            }
          }
        }, a.prototype._hideIndicator = function() {
          var n6 = this._shapes;
          n6.indicator && n6.indicator.attr("invisible", true), n6.indicatorLabel && n6.indicatorLabel.attr("invisible", true);
          var f6 = this._shapes.handleLabels;
          if (f6)
            for (var d4 = 0; d4 < f6.length; d4++)
              this._api.leaveBlur(f6[d4]);
        }, a.prototype._clearHoverLinkToSeries = function() {
          this._hideIndicator();
          var n6 = this._hoverLinkDataIndices;
          this._dispatchHighDown("downplay", dse(n6, this.visualMapModel)), n6.length = 0;
        }, a.prototype._clearHoverLinkFromSeries = function() {
          this._hideIndicator();
          var n6 = this.api.getZr();
          n6.off("mouseover", this._hoverLinkFromSeriesMouseOver), n6.off("mouseout", this._hideIndicator);
        }, a.prototype._applyTransform = function(n6, f6, d4, y4) {
          var _ = Qi(f6, y4 ? null : this.group);
          return Di(n6) ? pa(n6, _, d4) : mo(n6, _, d4);
        }, a.prototype._dispatchHighDown = function(n6, f6) {
          f6 && f6.length && this.api.dispatchAction({ type: n6, batch: f6 });
        }, a.prototype.dispose = function() {
          this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
        }, a.prototype.remove = function() {
          this._clearHoverLinkFromSeries(), this._clearHoverLinkToSeries();
        }, a.type = "visualMap.continuous", a;
      }(OZe);
      function NZe(s, a, n6, f6) {
        return new T0({ shape: { points: s }, draggable: !!n6, cursor: a, drift: n6, onmousemove: function(d4) {
          Jw(d4.event);
        }, ondragend: f6 });
      }
      function jKt(s, a, n6) {
        var f6 = VKt / 2, d4 = s.get("hoverLinkDataSize");
        return d4 && (f6 = zT(d4, a, n6, true) / 2), f6;
      }
      function FZe(s) {
        var a = s.get("hoverLinkOnHandle");
        return !!(a == null ? s.get("realtime") : a);
      }
      function VZe(s) {
        return s === "vertical" ? "ns-resize" : "ew-resize";
      }
      var GKt = zKt, HKt = { type: "selectDataRange", event: "dataRangeSelected", update: "update" }, WKt = function(s, a) {
        a.eachComponent({ mainType: "visualMap", query: s }, function(n6) {
          n6.setSelected(s.selected);
        });
      }, UKt = [{ createOnAllSeries: true, reset: function(s, a) {
        var n6 = [];
        return a.eachComponent("visualMap", function(f6) {
          var d4 = s.pipelineContext;
          !f6.isTargetSeries(s) || d4 && d4.large || n6.push(BXt(f6.stateList, f6.targetVisuals, Za(f6.getValueState, f6), f6.getDataDimensionIndex(s.getData())));
        }), n6;
      } }, { createOnAllSeries: true, reset: function(s, a) {
        var n6 = s.getData(), f6 = [];
        a.eachComponent("visualMap", function(d4) {
          if (d4.isTargetSeries(s)) {
            var y4 = d4.getVisualMeta(Za(qKt, null, s, d4)) || { stops: [], outerColors: [] }, _ = d4.getDataDimensionIndex(n6);
            _ >= 0 && (y4.dimension = _, f6.push(y4));
          }
        }), s.getData().setVisual("visualMeta", f6);
      } }];
      function qKt(s, a, n6, f6) {
        for (var d4 = a.targetVisuals[f6], y4 = zy.prepareVisualTypes(d4), _ = { color: _$(s.getData(), "color") }, S = 0, T = y4.length; S < T; S++) {
          var E = y4[S], O = d4[E === "opacity" ? "__alphaForOpacity" : E];
          O && O.applyVisual(n6, R, V);
        }
        return _.color;
        function R(z3) {
          return _[z3];
        }
        function V(z3, H) {
          _[z3] = H;
        }
      }
      var BZe = gt;
      function $Kt(s) {
        var a = s && s.visualMap;
        Di(a) || (a = a ? [a] : []), BZe(a, function(n6) {
          if (n6) {
            sV(n6, "splitList") && !sV(n6, "pieces") && (n6.pieces = n6.splitList, delete n6.splitList);
            var f6 = n6.pieces;
            f6 && Di(f6) && BZe(f6, function(d4) {
              Qo(d4) && (sV(d4, "start") && !sV(d4, "min") && (d4.min = d4.start), sV(d4, "end") && !sV(d4, "max") && (d4.max = d4.end));
            });
          }
        });
      }
      function sV(s, a) {
        return s && s.hasOwnProperty && s.hasOwnProperty(a);
      }
      var zZe = false;
      function jZe(s) {
        zZe || (zZe = true, s.registerSubTypeDefaulter("visualMap", function(a) {
          return !a.categories && (!(a.pieces ? a.pieces.length > 0 : a.splitNumber > 0) || a.calculable) ? "continuous" : "piecewise";
        }), s.registerAction(HKt, WKt), gt(UKt, function(a) {
          s.registerVisual(s.PRIORITY.VISUAL.COMPONENT, a);
        }), s.registerPreprocessor($Kt));
      }
      function GZe(s) {
        s.registerComponentModel(RKt), s.registerComponentView(GKt), jZe(s);
      }
      var XKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6._pieceList = [], n6;
        }
        return a.prototype.optionUpdated = function(n6, f6) {
          s.prototype.optionUpdated.apply(this, arguments), this.resetExtent();
          var d4 = this._mode = this._determineMode();
          this._pieceList = [], YKt[this._mode].call(this, this._pieceList), this._resetSelected(n6, f6);
          var y4 = this.option.categories;
          this.resetVisual(function(_, S) {
            d4 === "categories" ? (_.mappingMethod = "category", _.categories = Bo(y4)) : (_.dataExtent = this.getExtent(), _.mappingMethod = "piecewise", _.pieceList = Pi(this._pieceList, function(T) {
              return T = Bo(T), S !== "inRange" && (T.visual = null), T;
            }));
          });
        }, a.prototype.completeVisualOption = function() {
          var n6 = this.option, f6 = {}, d4 = zy.listVisualTypes(), y4 = this.isCategory();
          gt(n6.pieces, function(S) {
            gt(d4, function(T) {
              S.hasOwnProperty(T) && (f6[T] = 1);
            });
          }), gt(f6, function(S, T) {
            var E = false;
            gt(this.stateList, function(O) {
              E = E || _(n6, O, T) || _(n6.target, O, T);
            }, this), !E && gt(this.stateList, function(O) {
              (n6[O] || (n6[O] = {}))[T] = AZe.get(T, O === "inRange" ? "active" : "inactive", y4);
            });
          }, this);
          function _(S, T, E) {
            return S && S[T] && S[T].hasOwnProperty(E);
          }
          s.prototype.completeVisualOption.apply(this, arguments);
        }, a.prototype._resetSelected = function(n6, f6) {
          var d4 = this.option, y4 = this._pieceList, _ = (f6 ? d4 : n6).selected || {};
          if (d4.selected = _, gt(y4, function(T, E) {
            var O = this.getSelectedMapKey(T);
            _.hasOwnProperty(O) || (_[O] = true);
          }, this), d4.selectedMode === "single") {
            var S = false;
            gt(y4, function(T, E) {
              var O = this.getSelectedMapKey(T);
              _[O] && (S ? _[O] = false : S = true);
            }, this);
          }
        }, a.prototype.getItemSymbol = function() {
          return this.get("itemSymbol");
        }, a.prototype.getSelectedMapKey = function(n6) {
          return this._mode === "categories" ? n6.value + "" : n6.index + "";
        }, a.prototype.getPieceList = function() {
          return this._pieceList;
        }, a.prototype._determineMode = function() {
          var n6 = this.option;
          return n6.pieces && n6.pieces.length > 0 ? "pieces" : this.option.categories ? "categories" : "splitNumber";
        }, a.prototype.setSelected = function(n6) {
          this.option.selected = Bo(n6);
        }, a.prototype.getValueState = function(n6) {
          var f6 = zy.findPieceIndex(n6, this._pieceList);
          return f6 != null && this.option.selected[this.getSelectedMapKey(this._pieceList[f6])] ? "inRange" : "outOfRange";
        }, a.prototype.findTargetDataIndices = function(n6) {
          var f6 = [], d4 = this._pieceList;
          return this.eachTargetSeries(function(y4) {
            var _ = [], S = y4.getData();
            S.each(this.getDataDimensionIndex(S), function(T, E) {
              var O = zy.findPieceIndex(T, d4);
              O === n6 && _.push(E);
            }, this), f6.push({ seriesId: y4.id, dataIndex: _ });
          }, this), f6;
        }, a.prototype.getRepresentValue = function(n6) {
          var f6;
          if (this.isCategory())
            f6 = n6.value;
          else if (n6.value != null)
            f6 = n6.value;
          else {
            var d4 = n6.interval || [];
            f6 = d4[0] === -1 / 0 && d4[1] === 1 / 0 ? 0 : (d4[0] + d4[1]) / 2;
          }
          return f6;
        }, a.prototype.getVisualMeta = function(n6) {
          if (this.isCategory())
            return;
          var f6 = [], d4 = ["", ""], y4 = this;
          function _(O, R) {
            var V = y4.getRepresentValue({ interval: O });
            R || (R = y4.getValueState(V));
            var z3 = n6(V, R);
            O[0] === -1 / 0 ? d4[0] = z3 : O[1] === 1 / 0 ? d4[1] = z3 : f6.push({ value: O[0], color: z3 }, { value: O[1], color: z3 });
          }
          var S = this._pieceList.slice();
          if (!S.length)
            S.push({ interval: [-1 / 0, 1 / 0] });
          else {
            var T = S[0].interval[0];
            T !== -1 / 0 && S.unshift({ interval: [-1 / 0, T] }), T = S[S.length - 1].interval[1], T !== 1 / 0 && S.push({ interval: [T, 1 / 0] });
          }
          var E = -1 / 0;
          return gt(S, function(O) {
            var R = O.interval;
            R && (R[0] > E && _([E, R[0]], "outOfRange"), _(R.slice()), E = R[1]);
          }, this), { stops: f6, outerColors: d4 };
        }, a.type = "visualMap.piecewise", a.defaultOption = Xk(pse.defaultOption, { selected: null, minOpen: false, maxOpen: false, align: "auto", itemWidth: 20, itemHeight: 14, itemSymbol: "roundRect", pieces: null, categories: null, splitNumber: 5, selectedMode: "multiple", itemGap: 10, hoverLink: true }), a;
      }(pse), YKt = { splitNumber: function(s) {
        var a = this.option, n6 = Math.min(a.precision, 20), f6 = this.getExtent(), d4 = a.splitNumber;
        d4 = Math.max(parseInt(d4, 10), 1), a.splitNumber = d4;
        for (var y4 = (f6[1] - f6[0]) / d4; +y4.toFixed(n6) !== y4 && n6 < 5; )
          n6++;
        a.precision = n6, y4 = +y4.toFixed(n6), a.minOpen && s.push({ interval: [-1 / 0, f6[0]], close: [0, 0] });
        for (var _ = 0, S = f6[0]; _ < d4; S += y4, _++) {
          var T = _ === d4 - 1 ? f6[1] : S + y4;
          s.push({ interval: [S, T], close: [1, 1] });
        }
        a.maxOpen && s.push({ interval: [f6[1], 1 / 0], close: [0, 0] }), ZU(s), gt(s, function(E, O) {
          E.index = O, E.text = this.formatValueText(E.interval);
        }, this);
      }, categories: function(s) {
        var a = this.option;
        gt(a.categories, function(n6) {
          s.push({ text: this.formatValueText(n6, true), value: n6 });
        }, this), HZe(a, s);
      }, pieces: function(s) {
        var a = this.option;
        gt(a.pieces, function(n6, f6) {
          Qo(n6) || (n6 = { value: n6 });
          var d4 = { text: "", index: f6 };
          if (n6.label != null && (d4.text = n6.label), n6.hasOwnProperty("value")) {
            var y4 = d4.value = n6.value;
            d4.interval = [y4, y4], d4.close = [1, 1];
          } else {
            for (var _ = d4.interval = [], S = d4.close = [0, 0], T = [1, 0, 1], E = [-1 / 0, 1 / 0], O = [], R = 0; R < 2; R++) {
              for (var V = [["gte", "gt", "min"], ["lte", "lt", "max"]][R], z3 = 0; z3 < 3 && _[R] == null; z3++)
                _[R] = n6[V[z3]], S[R] = T[z3], O[R] = z3 === 2;
              _[R] == null && (_[R] = E[R]);
            }
            O[0] && _[1] === 1 / 0 && (S[0] = 0), O[1] && _[0] === -1 / 0 && (S[1] = 0), _[0] === _[1] && S[0] && S[1] && (d4.value = _[0]);
          }
          d4.visual = zy.retrieveVisuals(n6), s.push(d4);
        }, this), HZe(a, s), ZU(s), gt(s, function(n6) {
          var f6 = n6.close, d4 = [["<", "\u2264"][f6[1]], [">", "\u2265"][f6[0]]];
          n6.text = n6.text || this.formatValueText(n6.value != null ? n6.value : n6.interval, false, d4);
        }, this);
      } };
      function HZe(s, a) {
        var n6 = s.inverse;
        (s.orient === "vertical" ? !n6 : n6) && a.reverse();
      }
      var KKt = XKt, ZKt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = a.type, n6;
        }
        return a.prototype.doRender = function() {
          var n6 = this.group;
          n6.removeAll();
          var f6 = this.visualMapModel, d4 = f6.get("textGap"), y4 = f6.textStyleModel, _ = y4.getFont(), S = y4.getTextColor(), T = this._getItemAlign(), E = f6.itemSize, O = this._getViewData(), R = O.endsText, V = $v(f6.get("showLabel", true), !R);
          R && this._renderEndsText(n6, R[0], E, V, T), gt(O.viewPieceList, function(z3) {
            var H = z3.piece, Z = new fs();
            Z.onclick = Za(this._onItemClick, this, H), this._enableHoverLink(Z, z3.indexInModelPieceList);
            var ee = f6.getRepresentValue(H);
            if (this._createItemSymbol(Z, ee, [0, 0, E[0], E[1]]), V) {
              var oe = this.visualMapModel.getValueState(ee);
              Z.add(new ju({ style: { x: T === "right" ? -d4 : E[0] + d4, y: E[1] / 2, text: H.text, verticalAlign: "middle", align: T, font: _, fill: S, opacity: oe === "outOfRange" ? 0.5 : 1 } }));
            }
            n6.add(Z);
          }, this), R && this._renderEndsText(n6, R[1], E, V, T), NR(f6.get("orient"), n6, f6.get("itemGap")), this.renderBackground(n6), this.positionGroup(n6);
        }, a.prototype._enableHoverLink = function(n6, f6) {
          var d4 = this;
          n6.on("mouseover", function() {
            return y4("highlight");
          }).on("mouseout", function() {
            return y4("downplay");
          });
          var y4 = function(_) {
            var S = d4.visualMapModel;
            S.option.hoverLink && d4.api.dispatchAction({ type: _, batch: dse(S.findTargetDataIndices(f6), S) });
          };
        }, a.prototype._getItemAlign = function() {
          var n6 = this.visualMapModel, f6 = n6.option;
          if (f6.orient === "vertical")
            return LZe(n6, this.api, n6.itemSize);
          var d4 = f6.align;
          return (!d4 || d4 === "auto") && (d4 = "left"), d4;
        }, a.prototype._renderEndsText = function(n6, f6, d4, y4, _) {
          if (f6) {
            var S = new fs(), T = this.visualMapModel.textStyleModel;
            S.add(new ju({ style: { x: y4 ? _ === "right" ? d4[0] : 0 : d4[0] / 2, y: d4[1] / 2, verticalAlign: "middle", align: y4 ? _ : "center", text: f6, font: T.getFont(), fill: T.getTextColor() } })), n6.add(S);
          }
        }, a.prototype._getViewData = function() {
          var n6 = this.visualMapModel, f6 = Pi(n6.getPieceList(), function(S, T) {
            return { piece: S, indexInModelPieceList: T };
          }), d4 = n6.get("text"), y4 = n6.get("orient"), _ = n6.get("inverse");
          return (y4 === "horizontal" ? _ : !_) ? f6.reverse() : d4 && (d4 = d4.slice().reverse()), { viewPieceList: f6, endsText: d4 };
        }, a.prototype._createItemSymbol = function(n6, f6, d4) {
          n6.add(bv(this.getControllerVisual(f6, "symbol"), d4[0], d4[1], d4[2], d4[3], this.getControllerVisual(f6, "color")));
        }, a.prototype._onItemClick = function(n6) {
          var f6 = this.visualMapModel, d4 = f6.option, y4 = Bo(d4.selected), _ = f6.getSelectedMapKey(n6);
          d4.selectedMode === "single" ? (y4[_] = true, gt(y4, function(S, T) {
            y4[T] = T === _;
          })) : y4[_] = !y4[_], this.api.dispatchAction({ type: "selectDataRange", from: this.uid, visualMapId: this.visualMapModel.id, selected: y4 });
        }, a.type = "visualMap.piecewise", a;
      }(OZe), JKt = ZKt;
      function WZe(s) {
        s.registerComponentModel(KKt), s.registerComponentView(JKt), jZe(s);
      }
      function QKt(s) {
        Il(GZe), Il(WZe);
      }
      var eZt = { label: { enabled: true }, decal: { show: false } }, UZe = hu(), tZt = {};
      function nZt(s, a) {
        var n6 = s.getModel("aria");
        if (!n6.get("enabled"))
          return;
        var f6 = Bo(eZt);
        Ms(f6.label, s.getLocaleModel().get("aria"), false), Ms(n6.option, f6, false), d4(), y4();
        function d4() {
          var E = n6.getModel("decal"), O = E.get("show");
          if (O) {
            var R = ro();
            s.eachSeries(function(V) {
              if (!V.isColorBySeries()) {
                var z3 = R.get(V.type);
                z3 || (z3 = {}, R.set(V.type, z3)), UZe(V).scope = z3;
              }
            }), s.eachRawSeries(function(V) {
              if (s.isSeriesFiltered(V))
                return;
              if (jo(V.enableAriaDecal)) {
                V.enableAriaDecal();
                return;
              }
              var z3 = V.getData();
              if (V.isColorBySeries()) {
                var H = Vxe(V.ecModel, V.name, tZt, s.getSeriesCount()), Z = z3.getVisual("decal");
                z3.setVisual("decal", pe(Z, H));
              } else {
                var ee = V.getRawData(), oe = {}, fe = UZe(V).scope;
                z3.each(function(Ve) {
                  var Le = z3.getRawIndex(Ve);
                  oe[Le] = Ve;
                });
                var _e = ee.count();
                ee.each(function(Ve) {
                  var Le = oe[Ve], je = ee.getName(Ve) || Ve + "", Xe = Vxe(V.ecModel, je, fe, _e), Ye = z3.getItemVisual(Le, "decal");
                  z3.setItemVisual(Le, "decal", pe(Ye, Xe));
                });
              }
              function pe(Ve, Le) {
                var je = Ve ? ei(ei({}, Le), Ve) : Le;
                return je.dirty = true, je;
              }
            });
          }
        }
        function y4() {
          var E = s.getLocaleModel().get("aria"), O = n6.getModel("label");
          if (O.option = zo(O.option, E), !!O.get("enabled")) {
            var R = a.getZr().dom;
            if (O.get("description")) {
              R.setAttribute("aria-label", O.get("description"));
              return;
            }
            var V = s.getSeriesCount(), z3 = O.get(["data", "maxCount"]) || 10, H = O.get(["series", "maxCount"]) || 10, Z = Math.min(V, H), ee;
            if (!(V < 1)) {
              var oe = S();
              if (oe) {
                var fe = O.get(["general", "withTitle"]);
                ee = _(fe, { title: oe });
              } else
                ee = O.get(["general", "withoutTitle"]);
              var _e = [], pe = V > 1 ? O.get(["series", "multiple", "prefix"]) : O.get(["series", "single", "prefix"]);
              ee += _(pe, { seriesCount: V }), s.eachSeries(function(Xe, Ye) {
                if (Ye < Z) {
                  var rt2 = void 0, ut = Xe.get("name"), wt = ut ? "withName" : "withoutName";
                  rt2 = V > 1 ? O.get(["series", "multiple", wt]) : O.get(["series", "single", wt]), rt2 = _(rt2, { seriesId: Xe.seriesIndex, seriesName: Xe.get("name"), seriesType: T(Xe.subType) });
                  var dt = Xe.getData();
                  if (dt.count() > z3) {
                    var Gt = O.get(["data", "partialData"]);
                    rt2 += _(Gt, { displayCnt: z3 });
                  } else
                    rt2 += O.get(["data", "allData"]);
                  for (var Qt = O.get(["data", "separator", "middle"]), Nt = O.get(["data", "separator", "end"]), er = [], un = 0; un < dt.count(); un++)
                    if (un < z3) {
                      var pn = dt.getName(un), On = dt.getValues(un), fr = O.get(["data", pn ? "withName" : "withoutName"]);
                      er.push(_(fr, { name: pn, value: On.join(Qt) }));
                    }
                  rt2 += er.join(Qt) + Nt, _e.push(rt2);
                }
              });
              var Ve = O.getModel(["series", "multiple", "separator"]), Le = Ve.get("middle"), je = Ve.get("end");
              ee += _e.join(Le) + je, R.setAttribute("aria-label", ee);
            }
          }
        }
        function _(E, O) {
          if (!Wa(E))
            return E;
          var R = E;
          return gt(O, function(V, z3) {
            R = R.replace(new RegExp("\\{\\s*" + z3 + "\\s*\\}", "g"), V);
          }), R;
        }
        function S() {
          var E = s.get("title");
          return E && E.length && (E = E[0]), E && E.text;
        }
        function T(E) {
          return s.getLocaleModel().get(["series", "typeNames"])[E] || "\u81EA\u5B9A\u4E49\u56FE";
        }
      }
      function rZt(s) {
        if (!(!s || !s.aria)) {
          var a = s.aria;
          a.show != null && (a.enabled = a.show), a.label = a.label || {}, gt(["description", "general", "series", "data"], function(n6) {
            a[n6] != null && (a.label[n6] = a[n6]);
          });
        }
      }
      function iZt(s) {
        s.registerPreprocessor(rZt), s.registerVisual(s.PRIORITY.VISUAL.ARIA, nZt);
      }
      var qZe = { value: "eq", "<": "lt", "<=": "lte", ">": "gt", ">=": "gte", "=": "eq", "!=": "ne", "<>": "ne" }, aZt = function() {
        function s(a) {
          var n6 = this._condVal = Wa(a) ? new RegExp(a) : pbe(a) ? a : null;
          if (n6 == null) {
            var f6 = "";
            Ul(f6);
          }
        }
        return s.prototype.evaluate = function(a) {
          var n6 = typeof a;
          return Wa(n6) ? this._condVal.test(a) : ac(n6) ? this._condVal.test(a + "") : false;
        }, s;
      }(), oZt = function() {
        function s() {
        }
        return s.prototype.evaluate = function() {
          return this.value;
        }, s;
      }(), sZt = function() {
        function s() {
        }
        return s.prototype.evaluate = function() {
          for (var a = this.children, n6 = 0; n6 < a.length; n6++)
            if (!a[n6].evaluate())
              return false;
          return true;
        }, s;
      }(), lZt = function() {
        function s() {
        }
        return s.prototype.evaluate = function() {
          for (var a = this.children, n6 = 0; n6 < a.length; n6++)
            if (a[n6].evaluate())
              return true;
          return false;
        }, s;
      }(), uZt = function() {
        function s() {
        }
        return s.prototype.evaluate = function() {
          return !this.child.evaluate();
        }, s;
      }(), cZt = function() {
        function s() {
        }
        return s.prototype.evaluate = function() {
          for (var a = !!this.valueParser, n6 = this.getValue, f6 = n6(this.valueGetterParam), d4 = a ? this.valueParser(f6) : null, y4 = 0; y4 < this.subCondList.length; y4++)
            if (!this.subCondList[y4].evaluate(a ? d4 : f6))
              return false;
          return true;
        }, s;
      }();
      function PCe(s, a) {
        if (s === true || s === false) {
          var n6 = new oZt();
          return n6.value = s, n6;
        }
        var f6 = "";
        return XZe(s) || Ul(f6), s.and ? $Ze("and", s, a) : s.or ? $Ze("or", s, a) : s.not ? fZt(s, a) : hZt(s, a);
      }
      function $Ze(s, a, n6) {
        var f6 = a[s], d4 = "";
        Di(f6) || Ul(d4), f6.length || Ul(d4);
        var y4 = s === "and" ? new sZt() : new lZt();
        return y4.children = Pi(f6, function(_) {
          return PCe(_, n6);
        }), y4.children.length || Ul(d4), y4;
      }
      function fZt(s, a) {
        var n6 = s.not, f6 = "";
        XZe(n6) || Ul(f6);
        var d4 = new uZt();
        return d4.child = PCe(n6, a), d4.child || Ul(f6), d4;
      }
      function hZt(s, a) {
        for (var n6 = "", f6 = a.prepareGetValue(s), d4 = [], y4 = Wl(s), _ = s.parser, S = _ ? SGe(_) : null, T = 0; T < y4.length; T++) {
          var E = y4[T];
          if (!(E === "parser" || a.valueGetterAttrMap.get(E))) {
            var O = io(qZe, E) ? qZe[E] : E, R = s[E], V = S ? S(R) : R, z3 = U4t(O, V) || O === "reg" && new aZt(V);
            z3 || Ul(n6), d4.push(z3);
          }
        }
        d4.length || Ul(n6);
        var H = new cZt();
        return H.valueGetterParam = f6, H.valueParser = S, H.getValue = a.getValue, H.subCondList = d4, H;
      }
      function XZe(s) {
        return Qo(s) && !_0(s);
      }
      var pZt = function() {
        function s(a, n6) {
          this._cond = PCe(a, n6);
        }
        return s.prototype.evaluate = function() {
          return this._cond.evaluate();
        }, s;
      }();
      function dZt(s, a) {
        return new pZt(s, a);
      }
      var vZt = { type: "echarts:filter", transform: function(s) {
        for (var a = s.upstream, n6, f6 = dZt(s.config, { valueGetterAttrMap: ro({ dimension: true }), prepareGetValue: function(S) {
          var T = "", E = S.dimension;
          io(S, "dimension") || Ul(T);
          var O = a.getDimensionInfo(E);
          return O || Ul(T), { dimIdx: O.index };
        }, getValue: function(S) {
          return a.retrieveValueFromItem(n6, S.dimIdx);
        } }), d4 = [], y4 = 0, _ = a.count(); y4 < _; y4++)
          n6 = a.getRawDataItem(y4), f6.evaluate() && d4.push(n6);
        return { data: d4 };
      } }, gZt = { type: "echarts:sort", transform: function(s) {
        var a = s.upstream, n6 = s.config, f6 = "", d4 = jc(n6);
        d4.length || Ul(f6);
        var y4 = [];
        gt(d4, function(O) {
          var R = O.dimension, V = O.order, z3 = O.parser, H = O.incomparable;
          if (R == null && Ul(f6), V !== "asc" && V !== "desc" && Ul(f6), H && H !== "min" && H !== "max") {
            var Z = "";
            Ul(Z);
          }
          if (V !== "asc" && V !== "desc") {
            var ee = "";
            Ul(ee);
          }
          var oe = a.getDimensionInfo(R);
          oe || Ul(f6);
          var fe = z3 ? SGe(z3) : null;
          z3 && !fe && Ul(f6), y4.push({ dimIdx: oe.index, parser: fe, comparator: new MGe(V, H) });
        });
        var _ = a.sourceFormat;
        _ !== Hm && _ !== vS && Ul(f6);
        for (var S = [], T = 0, E = a.count(); T < E; T++)
          S.push(a.getRawDataItem(T));
        return S.sort(function(O, R) {
          for (var V = 0; V < y4.length; V++) {
            var z3 = y4[V], H = a.retrieveValueFromItem(O, z3.dimIdx), Z = a.retrieveValueFromItem(R, z3.dimIdx);
            z3.parser && (H = z3.parser(H), Z = z3.parser(Z));
            var ee = z3.comparator.evaluate(H, Z);
            if (ee !== 0)
              return ee;
          }
          return 0;
        }), { data: S };
      } };
      function yZt(s) {
        s.registerTransform(vZt), s.registerTransform(gZt);
      }
      var mZt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "dataset", n6;
        }
        return a.prototype.init = function(n6, f6, d4) {
          s.prototype.init.call(this, n6, f6, d4), this._sourceManager = new kGe(this), OGe(this);
        }, a.prototype.mergeOption = function(n6, f6) {
          s.prototype.mergeOption.call(this, n6, f6), OGe(this);
        }, a.prototype.optionUpdated = function() {
          this._sourceManager.dirty();
        }, a.prototype.getSourceManager = function() {
          return this._sourceManager;
        }, a.type = "dataset", a.defaultOption = { seriesLayoutBy: PT }, a;
      }(oc), bZt = function(s) {
        Vt(a, s);
        function a() {
          var n6 = s !== null && s.apply(this, arguments) || this;
          return n6.type = "dataset", n6;
        }
        return a.type = "dataset", a;
      }(sd);
      function _Zt(s) {
        s.registerComponentModel(mZt), s.registerComponentView(bZt);
      }
      var jT = aS.CMD;
      function lV(s, a) {
        return Math.abs(s - a) < 1e-5;
      }
      function LCe(s) {
        var a = s.data, n6 = s.len(), f6 = [], d4, y4 = 0, _ = 0, S = 0, T = 0;
        function E(dt, Gt) {
          d4 && d4.length > 2 && f6.push(d4), d4 = [dt, Gt];
        }
        function O(dt, Gt, Qt, Nt) {
          lV(dt, Qt) && lV(Gt, Nt) || d4.push(dt, Gt, Qt, Nt, Qt, Nt);
        }
        function R(dt, Gt, Qt, Nt, er, un) {
          var pn = Math.abs(Gt - dt), On = Math.tan(pn / 4) * 4 / 3, fr = Gt < dt ? -1 : 1, yr = Math.cos(dt), da = Math.sin(dt), Ja = Math.cos(Gt), ko = Math.sin(Gt), wo = yr * er + Qt, So = da * un + Nt, Fa = Ja * er + Qt, po = ko * un + Nt, To = er * On * fr, Ya = un * On * fr;
          d4.push(wo - To * da, So + Ya * yr, Fa + To * ko, po - Ya * Ja, Fa, po);
        }
        for (var V, z3, H, Z, ee = 0; ee < n6; ) {
          var oe = a[ee++], fe = ee === 1;
          switch (fe && (y4 = a[ee], _ = a[ee + 1], S = y4, T = _, (oe === jT.L || oe === jT.C || oe === jT.Q) && (d4 = [S, T])), oe) {
            case jT.M:
              y4 = S = a[ee++], _ = T = a[ee++], E(S, T);
              break;
            case jT.L:
              V = a[ee++], z3 = a[ee++], O(y4, _, V, z3), y4 = V, _ = z3;
              break;
            case jT.C:
              d4.push(a[ee++], a[ee++], a[ee++], a[ee++], y4 = a[ee++], _ = a[ee++]);
              break;
            case jT.Q:
              V = a[ee++], z3 = a[ee++], H = a[ee++], Z = a[ee++], d4.push(y4 + 2 / 3 * (V - y4), _ + 2 / 3 * (z3 - _), H + 2 / 3 * (V - H), Z + 2 / 3 * (z3 - Z), H, Z), y4 = H, _ = Z;
              break;
            case jT.A:
              var _e = a[ee++], pe = a[ee++], Ve = a[ee++], Le = a[ee++], je = a[ee++], Xe = a[ee++] + je;
              ee += 1;
              var Ye = !a[ee++];
              V = Math.cos(je) * Ve + _e, z3 = Math.sin(je) * Le + pe, fe ? (S = V, T = z3, E(S, T)) : O(y4, _, V, z3), y4 = Math.cos(Xe) * Ve + _e, _ = Math.sin(Xe) * Le + pe;
              for (var rt2 = (Ye ? -1 : 1) * Math.PI / 2, ut = je; Ye ? ut > Xe : ut < Xe; ut += rt2) {
                var wt = Ye ? Math.max(ut + rt2, Xe) : Math.min(ut + rt2, Xe);
                R(ut, wt, _e, pe, Ve, Le);
              }
              break;
            case jT.R:
              S = y4 = a[ee++], T = _ = a[ee++], V = S + a[ee++], z3 = T + a[ee++], E(V, T), O(V, T, V, z3), O(V, z3, S, z3), O(S, z3, S, T), O(S, T, V, T);
              break;
            case jT.Z:
              d4 && O(y4, _, S, T), y4 = S, _ = T;
              break;
          }
        }
        return d4 && d4.length > 2 && f6.push(d4), f6;
      }
      function RCe(s, a, n6, f6, d4, y4, _, S, T, E) {
        if (lV(s, n6) && lV(a, f6) && lV(d4, _) && lV(y4, S)) {
          T.push(_, S);
          return;
        }
        var O = 2 / E, R = O * O, V = _ - s, z3 = S - a, H = Math.sqrt(V * V + z3 * z3);
        V /= H, z3 /= H;
        var Z = n6 - s, ee = f6 - a, oe = d4 - _, fe = y4 - S, _e = Z * Z + ee * ee, pe = oe * oe + fe * fe;
        if (_e < R && pe < R) {
          T.push(_, S);
          return;
        }
        var Ve = V * Z + z3 * ee, Le = -V * oe - z3 * fe, je = _e - Ve * Ve, Xe = pe - Le * Le;
        if (je < R && Ve >= 0 && Xe < R && Le >= 0) {
          T.push(_, S);
          return;
        }
        var Ye = [], rt2 = [];
        $_(s, n6, d4, _, 0.5, Ye), $_(a, f6, y4, S, 0.5, rt2), RCe(Ye[0], rt2[0], Ye[1], rt2[1], Ye[2], rt2[2], Ye[3], rt2[3], T, E), RCe(Ye[4], rt2[4], Ye[5], rt2[5], Ye[6], rt2[6], Ye[7], rt2[7], T, E);
      }
      function xZt(s, a) {
        var n6 = LCe(s), f6 = [];
        a = a || 1;
        for (var d4 = 0; d4 < n6.length; d4++) {
          var y4 = n6[d4], _ = [], S = y4[0], T = y4[1];
          _.push(S, T);
          for (var E = 2; E < y4.length; ) {
            var O = y4[E++], R = y4[E++], V = y4[E++], z3 = y4[E++], H = y4[E++], Z = y4[E++];
            RCe(S, T, O, R, V, z3, H, Z, _, a), S = H, T = Z;
          }
          f6.push(_);
        }
        return f6;
      }
      function YZe(s, a, n6) {
        var f6 = s[a], d4 = s[1 - a], y4 = Math.abs(f6 / d4), _ = Math.ceil(Math.sqrt(y4 * n6)), S = Math.floor(n6 / _);
        S === 0 && (S = 1, _ = n6);
        for (var T = [], E = 0; E < _; E++)
          T.push(S);
        var O = _ * S, R = n6 - O;
        if (R > 0)
          for (var E = 0; E < R; E++)
            T[E % _] += 1;
        return T;
      }
      function KZe(s, a, n6) {
        for (var f6 = s.r0, d4 = s.r, y4 = s.startAngle, _ = s.endAngle, S = Math.abs(_ - y4), T = S * d4, E = d4 - f6, O = T > Math.abs(E), R = YZe([T, E], O ? 0 : 1, a), V = (O ? S : E) / R.length, z3 = 0; z3 < R.length; z3++)
          for (var H = (O ? E : S) / R[z3], Z = 0; Z < R[z3]; Z++) {
            var ee = {};
            O ? (ee.startAngle = y4 + V * z3, ee.endAngle = y4 + V * (z3 + 1), ee.r0 = f6 + H * Z, ee.r = f6 + H * (Z + 1)) : (ee.startAngle = y4 + H * Z, ee.endAngle = y4 + H * (Z + 1), ee.r0 = f6 + V * z3, ee.r = f6 + V * (z3 + 1)), ee.clockwise = s.clockwise, ee.cx = s.cx, ee.cy = s.cy, n6.push(ee);
          }
      }
      function wZt(s, a, n6) {
        for (var f6 = s.width, d4 = s.height, y4 = f6 > d4, _ = YZe([f6, d4], y4 ? 0 : 1, a), S = y4 ? "width" : "height", T = y4 ? "height" : "width", E = y4 ? "x" : "y", O = y4 ? "y" : "x", R = s[S] / _.length, V = 0; V < _.length; V++)
          for (var z3 = s[T] / _[V], H = 0; H < _[V]; H++) {
            var Z = {};
            Z[E] = V * R, Z[O] = H * z3, Z[S] = R, Z[T] = z3, Z.x += s.x, Z.y += s.y, n6.push(Z);
          }
      }
      function ZZe(s, a, n6, f6) {
        return s * f6 - n6 * a;
      }
      function SZt(s, a, n6, f6, d4, y4, _, S) {
        var T = n6 - s, E = f6 - a, O = _ - d4, R = S - y4, V = ZZe(O, R, T, E);
        if (Math.abs(V) < 1e-6)
          return null;
        var z3 = s - d4, H = a - y4, Z = ZZe(z3, H, O, R) / V;
        return Z < 0 || Z > 1 ? null : new zs(Z * T + s, Z * E + a);
      }
      function CZt(s, a, n6) {
        var f6 = new zs();
        zs.sub(f6, n6, a), f6.normalize();
        var d4 = new zs();
        zs.sub(d4, s, a);
        var y4 = d4.dot(f6);
        return y4;
      }
      function uV(s, a) {
        var n6 = s[s.length - 1];
        n6 && n6[0] === a[0] && n6[1] === a[1] || s.push(a);
      }
      function MZt(s, a, n6) {
        for (var f6 = s.length, d4 = [], y4 = 0; y4 < f6; y4++) {
          var _ = s[y4], S = s[(y4 + 1) % f6], T = SZt(_[0], _[1], S[0], S[1], a.x, a.y, n6.x, n6.y);
          T && d4.push({ projPt: CZt(T, a, n6), pt: T, idx: y4 });
        }
        if (d4.length < 2)
          return [{ points: s }, { points: s }];
        d4.sort(function(ee, oe) {
          return ee.projPt - oe.projPt;
        });
        var E = d4[0], O = d4[d4.length - 1];
        if (O.idx < E.idx) {
          var R = E;
          E = O, O = R;
        }
        for (var V = [E.pt.x, E.pt.y], z3 = [O.pt.x, O.pt.y], H = [V], Z = [z3], y4 = E.idx + 1; y4 <= O.idx; y4++)
          uV(H, s[y4].slice());
        uV(H, z3), uV(H, V);
        for (var y4 = O.idx + 1; y4 <= E.idx + f6; y4++)
          uV(Z, s[y4 % f6].slice());
        return uV(Z, V), uV(Z, z3), [{ points: H }, { points: Z }];
      }
      function JZe(s) {
        var a = s.points, n6 = [], f6 = [];
        t7(a, n6, f6);
        var d4 = new il(n6[0], n6[1], f6[0] - n6[0], f6[1] - n6[1]), y4 = d4.width, _ = d4.height, S = d4.x, T = d4.y, E = new zs(), O = new zs();
        return y4 > _ ? (E.x = O.x = S + y4 / 2, E.y = T, O.y = T + _) : (E.y = O.y = T + _ / 2, E.x = S, O.x = S + y4), MZt(a, E, O);
      }
      function vse(s, a, n6, f6) {
        if (n6 === 1)
          f6.push(a);
        else {
          var d4 = Math.floor(n6 / 2), y4 = s(a);
          vse(s, y4[0], d4, f6), vse(s, y4[1], n6 - d4, f6);
        }
        return f6;
      }
      function TZt(s, a) {
        for (var n6 = [], f6 = 0; f6 < a; f6++)
          n6.push(qq(s));
        return n6;
      }
      function AZt(s, a) {
        a.setStyle(s.style), a.z = s.z, a.z2 = s.z2, a.zlevel = s.zlevel;
      }
      function IZt(s) {
        for (var a = [], n6 = 0; n6 < s.length; )
          a.push([s[n6++], s[n6++]]);
        return a;
      }
      function EZt(s, a) {
        var n6 = [], f6 = s.shape, d4;
        switch (s.type) {
          case "rect":
            wZt(f6, a, n6), d4 = xu;
            break;
          case "sector":
            KZe(f6, a, n6), d4 = Bm;
            break;
          case "circle":
            KZe({ r0: 0, r: f6.r, startAngle: 0, endAngle: Math.PI * 2, cx: f6.cx, cy: f6.cy }, a, n6), d4 = Bm;
            break;
          default:
            var y4 = s.getComputedTransform(), _ = y4 ? Math.sqrt(Math.max(y4[0] * y4[0] + y4[1] * y4[1], y4[2] * y4[2] + y4[3] * y4[3])) : 1, S = Pi(xZt(s.getUpdatedPathProxy(), _), function(oe) {
              return IZt(oe);
            }), T = S.length;
            if (T === 0)
              vse(JZe, { points: S[0] }, a, n6);
            else if (T === a)
              for (var E = 0; E < T; E++)
                n6.push({ points: S[E] });
            else {
              var O = 0, R = Pi(S, function(oe) {
                var fe = [], _e = [];
                t7(oe, fe, _e);
                var pe = (_e[1] - fe[1]) * (_e[0] - fe[0]);
                return O += pe, { poly: oe, area: pe };
              });
              R.sort(function(oe, fe) {
                return fe.area - oe.area;
              });
              for (var V = a, E = 0; E < T; E++) {
                var z3 = R[E];
                if (V <= 0)
                  break;
                var H = E === T - 1 ? V : Math.ceil(z3.area / O * a);
                H < 0 || (vse(JZe, { points: z3.poly }, H, n6), V -= H);
              }
            }
            d4 = T0;
            break;
        }
        if (!d4)
          return TZt(s, a);
        for (var Z = [], E = 0; E < n6.length; E++) {
          var ee = new d4();
          ee.setShape(n6[E]), AZt(s, ee), Z.push(ee);
        }
        return Z;
      }
      function DZt(s, a) {
        var n6 = s.length, f6 = a.length;
        if (n6 === f6)
          return [s, a];
        for (var d4 = [], y4 = [], _ = n6 < f6 ? s : a, S = Math.min(n6, f6), T = Math.abs(f6 - n6) / 6, E = (S - 2) / 6, O = Math.ceil(T / E) + 1, R = [_[0], _[1]], V = T, z3 = 2; z3 < S; ) {
          var H = _[z3 - 2], Z = _[z3 - 1], ee = _[z3++], oe = _[z3++], fe = _[z3++], _e = _[z3++], pe = _[z3++], Ve = _[z3++];
          if (V <= 0) {
            R.push(ee, oe, fe, _e, pe, Ve);
            continue;
          }
          for (var Le = Math.min(V, O - 1) + 1, je = 1; je <= Le; je++) {
            var Xe = je / Le;
            $_(H, ee, fe, pe, Xe, d4), $_(Z, oe, _e, Ve, Xe, y4), H = d4[3], Z = y4[3], R.push(d4[1], y4[1], d4[2], y4[2], H, Z), ee = d4[5], oe = y4[5], fe = d4[6], _e = y4[6];
          }
          V -= Le - 1;
        }
        return _ === s ? [R, a] : [s, R];
      }
      function QZe(s, a) {
        for (var n6 = s.length, f6 = s[n6 - 2], d4 = s[n6 - 1], y4 = [], _ = 0; _ < a.length; )
          y4[_++] = f6, y4[_++] = d4;
        return y4;
      }
      function kZt(s, a) {
        for (var n6, f6, d4, y4 = [], _ = [], S = 0; S < Math.max(s.length, a.length); S++) {
          var T = s[S], E = a[S], O = void 0, R = void 0;
          T ? E ? (n6 = DZt(T, E), O = n6[0], R = n6[1], f6 = O, d4 = R) : (R = QZe(d4 || T, T), O = T) : (O = QZe(f6 || E, E), R = E), y4.push(O), _.push(R);
        }
        return [y4, _];
      }
      function eJe(s) {
        for (var a = 0, n6 = 0, f6 = 0, d4 = s.length, y4 = 0, _ = d4 - 2; y4 < d4; _ = y4, y4 += 2) {
          var S = s[_], T = s[_ + 1], E = s[y4], O = s[y4 + 1], R = S * O - E * T;
          a += R, n6 += (S + E) * R, f6 += (T + O) * R;
        }
        return a === 0 ? [s[0] || 0, s[1] || 0] : [n6 / a / 3, f6 / a / 3, a];
      }
      function OZt(s, a, n6, f6) {
        for (var d4 = (s.length - 2) / 6, y4 = 1 / 0, _ = 0, S = s.length, T = S - 2, E = 0; E < d4; E++) {
          for (var O = E * 6, R = 0, V = 0; V < S; V += 2) {
            var z3 = V === 0 ? O : (O + V - 2) % T + 2, H = s[z3] - n6[0], Z = s[z3 + 1] - n6[1], ee = a[V] - f6[0], oe = a[V + 1] - f6[1], fe = ee - H, _e = oe - Z;
            R += fe * fe + _e * _e;
          }
          R < y4 && (y4 = R, _ = E);
        }
        return _;
      }
      function PZt(s) {
        for (var a = [], n6 = s.length, f6 = 0; f6 < n6; f6 += 2)
          a[f6] = s[n6 - f6 - 2], a[f6 + 1] = s[n6 - f6 - 1];
        return a;
      }
      function LZt(s, a, n6, f6) {
        for (var d4 = [], y4, _ = 0; _ < s.length; _++) {
          var S = s[_], T = a[_], E = eJe(S), O = eJe(T);
          y4 == null && (y4 = E[2] < 0 != O[2] < 0);
          var R = [], V = [], z3 = 0, H = 1 / 0, Z = [], ee = S.length;
          y4 && (S = PZt(S));
          for (var oe = OZt(S, T, E, O) * 6, fe = ee - 2, _e = 0; _e < fe; _e += 2) {
            var pe = (oe + _e) % fe + 2;
            R[_e + 2] = S[pe] - E[0], R[_e + 3] = S[pe + 1] - E[1];
          }
          if (R[0] = S[oe] - E[0], R[1] = S[oe + 1] - E[1], n6 > 0)
            for (var Ve = f6 / n6, Le = -f6 / 2; Le <= f6 / 2; Le += Ve) {
              for (var je = Math.sin(Le), Xe = Math.cos(Le), Ye = 0, _e = 0; _e < S.length; _e += 2) {
                var rt2 = R[_e], ut = R[_e + 1], wt = T[_e] - O[0], dt = T[_e + 1] - O[1], Gt = wt * Xe - dt * je, Qt = wt * je + dt * Xe;
                Z[_e] = Gt, Z[_e + 1] = Qt;
                var Nt = Gt - rt2, er = Qt - ut;
                Ye += Nt * Nt + er * er;
              }
              if (Ye < H) {
                H = Ye, z3 = Le;
                for (var un = 0; un < Z.length; un++)
                  V[un] = Z[un];
              }
            }
          else
            for (var pn = 0; pn < ee; pn += 2)
              V[pn] = T[pn] - O[0], V[pn + 1] = T[pn + 1] - O[1];
          d4.push({ from: R, to: V, fromCp: E, toCp: O, rotation: -z3 });
        }
        return d4;
      }
      function gse(s) {
        return s.__isCombineMorphing;
      }
      var tJe = "__mOriginal_";
      function yse(s, a, n6) {
        var f6 = tJe + a, d4 = s[f6] || s[a];
        s[f6] || (s[f6] = s[a]);
        var y4 = n6.replace, _ = n6.after, S = n6.before;
        s[a] = function() {
          var T = arguments, E;
          return S && S.apply(this, T), y4 ? E = y4.apply(this, T) : E = d4.apply(this, T), _ && _.apply(this, T), E;
        };
      }
      function _X(s, a) {
        var n6 = tJe + a;
        s[n6] && (s[a] = s[n6], s[n6] = null);
      }
      function nJe(s, a) {
        for (var n6 = 0; n6 < s.length; n6++)
          for (var f6 = s[n6], d4 = 0; d4 < f6.length; ) {
            var y4 = f6[d4], _ = f6[d4 + 1];
            f6[d4++] = a[0] * y4 + a[2] * _ + a[4], f6[d4++] = a[1] * y4 + a[3] * _ + a[5];
          }
      }
      function rJe(s, a) {
        var n6 = s.getUpdatedPathProxy(), f6 = a.getUpdatedPathProxy(), d4 = kZt(LCe(n6), LCe(f6)), y4 = d4[0], _ = d4[1], S = s.getComputedTransform(), T = a.getComputedTransform();
        function E() {
          this.transform = null;
        }
        S && nJe(y4, S), T && nJe(_, T), yse(a, "updateTransform", { replace: E }), a.transform = null;
        var O = LZt(y4, _, 10, Math.PI), R = [];
        yse(a, "buildPath", { replace: function(V) {
          for (var z3 = a.__morphT, H = 1 - z3, Z = [], ee = 0; ee < O.length; ee++) {
            var oe = O[ee], fe = oe.from, _e = oe.to, pe = oe.rotation * z3, Ve = oe.fromCp, Le = oe.toCp, je = Math.sin(pe), Xe = Math.cos(pe);
            c9(Z, Ve, Le, z3);
            for (var Ye = 0; Ye < fe.length; Ye += 2) {
              var rt2 = fe[Ye], ut = fe[Ye + 1], wt = _e[Ye], dt = _e[Ye + 1], Gt = rt2 * H + wt * z3, Qt = ut * H + dt * z3;
              R[Ye] = Gt * Xe - Qt * je + Z[0], R[Ye + 1] = Gt * je + Qt * Xe + Z[1];
            }
            var Nt = R[0], er = R[1];
            V.moveTo(Nt, er);
            for (var Ye = 2; Ye < fe.length; ) {
              var wt = R[Ye++], dt = R[Ye++], un = R[Ye++], pn = R[Ye++], On = R[Ye++], fr = R[Ye++];
              Nt === wt && er === dt && un === On && pn === fr ? V.lineTo(On, fr) : V.bezierCurveTo(wt, dt, un, pn, On, fr), Nt = On, er = fr;
            }
          }
        } });
      }
      function NCe(s, a, n6) {
        if (!s || !a)
          return a;
        var f6 = n6.done, d4 = n6.during;
        rJe(s, a), a.__morphT = 0;
        function y4() {
          _X(a, "buildPath"), _X(a, "updateTransform"), a.__morphT = -1, a.createPathProxy(), a.dirtyShape();
        }
        return a.animateTo({ __morphT: 1 }, zo({ during: function(_) {
          a.dirtyShape(), d4 && d4(_);
        }, done: function() {
          y4(), f6 && f6();
        } }, n6)), a;
      }
      function RZt(s, a, n6, f6, d4, y4) {
        var _ = 16;
        s = d4 === n6 ? 0 : Math.round(32767 * (s - n6) / (d4 - n6)), a = y4 === f6 ? 0 : Math.round(32767 * (a - f6) / (y4 - f6));
        for (var S = 0, T, E = (1 << _) / 2; E > 0; E /= 2) {
          var O = 0, R = 0;
          (s & E) > 0 && (O = 1), (a & E) > 0 && (R = 1), S += E * E * (3 * O ^ R), R === 0 && (O === 1 && (s = E - 1 - s, a = E - 1 - a), T = s, s = a, a = T);
        }
        return S;
      }
      function mse(s) {
        var a = 1 / 0, n6 = 1 / 0, f6 = -1 / 0, d4 = -1 / 0, y4 = Pi(s, function(S) {
          var T = S.getBoundingRect(), E = S.getComputedTransform(), O = T.x + T.width / 2 + (E ? E[4] : 0), R = T.y + T.height / 2 + (E ? E[5] : 0);
          return a = Math.min(O, a), n6 = Math.min(R, n6), f6 = Math.max(O, f6), d4 = Math.max(R, d4), [O, R];
        }), _ = Pi(y4, function(S, T) {
          return { cp: S, z: RZt(S[0], S[1], a, n6, f6, d4), path: s[T] };
        });
        return _.sort(function(S, T) {
          return S.z - T.z;
        }).map(function(S) {
          return S.path;
        });
      }
      function iJe(s) {
        return EZt(s.path, s.count);
      }
      function FCe() {
        return { fromIndividuals: [], toIndividuals: [], count: 0 };
      }
      function NZt(s, a, n6) {
        var f6 = [];
        function d4(Ve) {
          for (var Le = 0; Le < Ve.length; Le++) {
            var je = Ve[Le];
            gse(je) ? d4(je.childrenRef()) : je instanceof ml && f6.push(je);
          }
        }
        d4(s);
        var y4 = f6.length;
        if (!y4)
          return FCe();
        var _ = n6.dividePath || iJe, S = _({ path: a, count: y4 });
        if (S.length !== y4)
          return console.error("Invalid morphing: unmatched splitted path"), FCe();
        f6 = mse(f6), S = mse(S);
        for (var T = n6.done, E = n6.during, O = n6.individualDelay, R = new Q_(), V = 0; V < y4; V++) {
          var z3 = f6[V], H = S[V];
          H.parent = a, H.copyTransform(R), O || rJe(z3, H);
        }
        a.__isCombineMorphing = true, a.childrenRef = function() {
          return S;
        };
        function Z(Ve) {
          for (var Le = 0; Le < S.length; Le++)
            S[Le].addSelfToZr(Ve);
        }
        yse(a, "addSelfToZr", { after: function(Ve) {
          Z(Ve);
        } }), yse(a, "removeSelfFromZr", { after: function(Ve) {
          for (var Le = 0; Le < S.length; Le++)
            S[Le].removeSelfFromZr(Ve);
        } });
        function ee() {
          a.__isCombineMorphing = false, a.__morphT = -1, a.childrenRef = null, _X(a, "addSelfToZr"), _X(a, "removeSelfFromZr");
        }
        var oe = S.length;
        if (O)
          for (var fe = oe, _e = function() {
            fe--, fe === 0 && (ee(), T && T());
          }, V = 0; V < oe; V++) {
            var pe = O ? zo({ delay: (n6.delay || 0) + O(V, oe, f6[V], S[V]), done: _e }, n6) : n6;
            NCe(f6[V], S[V], pe);
          }
        else
          a.__morphT = 0, a.animateTo({ __morphT: 1 }, zo({ during: function(Ve) {
            for (var Le = 0; Le < oe; Le++) {
              var je = S[Le];
              je.__morphT = a.__morphT, je.dirtyShape();
            }
            E && E(Ve);
          }, done: function() {
            ee();
            for (var Ve = 0; Ve < s.length; Ve++)
              _X(s[Ve], "updateTransform");
            T && T();
          } }, n6));
        return a.__zr && Z(a.__zr), { fromIndividuals: f6, toIndividuals: S, count: oe };
      }
      function FZt(s, a, n6) {
        var f6 = a.length, d4 = [], y4 = n6.dividePath || iJe;
        function _(z3) {
          for (var H = 0; H < z3.length; H++) {
            var Z = z3[H];
            gse(Z) ? _(Z.childrenRef()) : Z instanceof ml && d4.push(Z);
          }
        }
        if (gse(s)) {
          _(s.childrenRef());
          var S = d4.length;
          if (S < f6)
            for (var T = 0, E = S; E < f6; E++)
              d4.push(qq(d4[T++ % S]));
          d4.length = f6;
        } else {
          d4 = y4({ path: s, count: f6 });
          for (var O = s.getComputedTransform(), E = 0; E < d4.length; E++)
            d4[E].setLocalTransform(O);
          if (d4.length !== f6)
            return console.error("Invalid morphing: unmatched splitted path"), FCe();
        }
        d4 = mse(d4), a = mse(a);
        for (var R = n6.individualDelay, E = 0; E < f6; E++) {
          var V = R ? zo({ delay: (n6.delay || 0) + R(E, f6, d4[E], a[E]) }, n6) : n6;
          NCe(d4[E], a[E], V);
        }
        return { fromIndividuals: d4, toIndividuals: a, count: a.length };
      }
      function aJe(s) {
        return Di(s[0]);
      }
      function oJe(s, a) {
        for (var n6 = [], f6 = s.length, d4 = 0; d4 < f6; d4++)
          n6.push({ one: s[d4], many: [] });
        for (var d4 = 0; d4 < a.length; d4++) {
          var y4 = a[d4].length, _ = void 0;
          for (_ = 0; _ < y4; _++)
            n6[_ % f6].many.push(a[d4][_]);
        }
        for (var S = 0, d4 = f6 - 1; d4 >= 0; d4--)
          if (!n6[d4].many.length) {
            var T = n6[S].many;
            if (T.length <= 1)
              if (S)
                S = 0;
              else
                return n6;
            var y4 = T.length, E = Math.ceil(y4 / 2);
            n6[d4].many = T.slice(E, y4), n6[S].many = T.slice(0, E), S++;
          }
        return n6;
      }
      var VZt = { clone: function(s) {
        for (var a = [], n6 = 1 - Math.pow(1 - s.path.style.opacity, 1 / s.count), f6 = 0; f6 < s.count; f6++) {
          var d4 = qq(s.path);
          d4.setStyle("opacity", n6), a.push(d4);
        }
        return a;
      }, split: null };
      function VCe(s, a, n6, f6, d4, y4) {
        if (!s.length || !a.length)
          return;
        var _ = qk("update", f6, d4);
        if (!(_ && _.duration > 0))
          return;
        var S = f6.getModel("universalTransition").get("delay"), T = Object.assign({ setToFinal: true }, _), E, O;
        aJe(s) && (E = s, O = a), aJe(a) && (E = a, O = s);
        function R(oe, fe, _e, pe, Ve) {
          var Le = oe.many, je = oe.one;
          if (Le.length === 1 && !Ve) {
            var Xe = fe ? Le[0] : je, Ye = fe ? je : Le[0];
            if (gse(Xe))
              R({ many: [Xe], one: Ye }, true, _e, pe, true);
            else {
              var rt2 = S ? zo({ delay: S(_e, pe) }, T) : T;
              NCe(Xe, Ye, rt2), y4(Xe, Ye, Xe, Ye, rt2);
            }
          } else
            for (var ut = zo({ dividePath: VZt[n6], individualDelay: S && function(er, un, pn, On) {
              return S(er + _e, pe);
            } }, T), wt = fe ? NZt(Le, je, ut) : FZt(je, Le, ut), dt = wt.fromIndividuals, Gt = wt.toIndividuals, Qt = dt.length, Nt = 0; Nt < Qt; Nt++) {
              var rt2 = S ? zo({ delay: S(Nt, Qt) }, T) : T;
              y4(dt[Nt], Gt[Nt], fe ? Le[Nt] : oe.one, fe ? oe.one : Le[Nt], rt2);
            }
        }
        for (var V = E ? E === s : s.length > a.length, z3 = E ? oJe(O, E) : oJe(V ? a : s, [V ? s : a]), H = 0, Z = 0; Z < z3.length; Z++)
          H += z3[Z].many.length;
        for (var ee = 0, Z = 0; Z < z3.length; Z++)
          R(z3[Z], V, ee, H), ee += z3[Z].many.length;
      }
      function u4(s) {
        if (!s)
          return [];
        if (Di(s)) {
          for (var a = [], n6 = 0; n6 < s.length; n6++)
            a.push(u4(s[n6]));
          return a;
        }
        var f6 = [];
        return s.traverse(function(d4) {
          d4 instanceof ml && !d4.disableMorphing && !d4.invisible && !d4.ignore && f6.push(d4);
        }), f6;
      }
      var sJe = 1e4, BZt = hu();
      function zZt(s) {
        for (var a = s.dimensions, n6 = 0; n6 < a.length; n6++) {
          var f6 = s.getDimensionInfo(a[n6]);
          if (f6 && f6.otherDims.itemGroupId === 0)
            return a[n6];
        }
      }
      function lJe(s) {
        var a = [];
        return gt(s, function(n6) {
          var f6 = n6.data;
          if (!(f6.count() > sJe))
            for (var d4 = f6.getIndices(), y4 = zZt(f6), _ = 0; _ < d4.length; _++)
              a.push({ data: f6, dim: n6.dim || y4, divide: n6.divide, dataIndex: _ });
        }), a;
      }
      function BCe(s, a, n6) {
        s.traverse(function(f6) {
          f6 instanceof ml && $h(f6, { style: { opacity: 0 } }, a, { dataIndex: n6, isFrom: true });
        });
      }
      function zCe(s) {
        if (s.parent) {
          var a = s.getComputedTransform();
          s.setLocalTransform(a), s.parent.remove(s);
        }
      }
      function cV(s) {
        s.stopAnimation(), s.isGroup && s.traverse(function(a) {
          a.stopAnimation();
        });
      }
      function jZt(s, a, n6) {
        var f6 = qk("update", n6, a);
        f6 && s.traverse(function(d4) {
          if (d4 instanceof Hb) {
            var y4 = yxe(d4);
            y4 && d4.animateFrom({ style: y4 }, f6);
          }
        });
      }
      function GZt(s, a) {
        var n6 = s.length;
        if (n6 !== a.length)
          return false;
        for (var f6 = 0; f6 < n6; f6++) {
          var d4 = s[f6], y4 = a[f6];
          if (d4.data.getId(d4.dataIndex) !== y4.data.getId(y4.dataIndex))
            return false;
        }
        return true;
      }
      function uJe(s, a, n6) {
        var f6 = lJe(s), d4 = lJe(a);
        function y4(oe, fe, _e, pe, Ve) {
          (_e || oe) && fe.animateFrom({ style: _e && _e !== oe ? ei(ei({}, _e.style), oe.style) : oe.style }, Ve);
        }
        function _(oe) {
          for (var fe = 0; fe < oe.length; fe++)
            if (oe[fe].dim)
              return oe[fe].dim;
        }
        var S = _(f6), T = _(d4), E = false;
        function O(oe, fe) {
          return function(_e) {
            var pe = _e.data, Ve = _e.dataIndex;
            if (fe)
              return pe.getId(Ve);
            var Le = pe.hostModel && pe.hostModel.get("dataGroupId"), je = oe ? S || T : T || S, Xe = je && pe.getDimensionInfo(je), Ye = Xe && Xe.ordinalMeta;
            if (Xe) {
              var rt2 = pe.get(Xe.name, Ve);
              return Ye && Ye.categories[rt2] || rt2 + "";
            }
            var ut = pe.getRawDataItem(Ve);
            return ut && ut.groupId ? ut.groupId + "" : Le || pe.getId(Ve);
          };
        }
        var R = GZt(f6, d4), V = {};
        if (!R)
          for (var z3 = 0; z3 < d4.length; z3++) {
            var H = d4[z3], Z = H.data.getItemGraphicEl(H.dataIndex);
            Z && (V[Z.id] = true);
          }
        function ee(oe, fe) {
          var _e = f6[fe], pe = d4[oe], Ve = pe.data.hostModel, Le = _e.data.getItemGraphicEl(_e.dataIndex), je = pe.data.getItemGraphicEl(pe.dataIndex);
          if (Le === je) {
            je && jZt(je, pe.dataIndex, Ve);
            return;
          }
          Le && V[Le.id] || je && (cV(je), Le ? (cV(Le), zCe(Le), E = true, VCe(u4(Le), u4(je), pe.divide, Ve, oe, y4)) : BCe(je, Ve, oe));
        }
        new OE(f6, d4, O(true, R), O(false, R), null, "multiple").update(ee).updateManyToOne(function(oe, fe) {
          var _e = d4[oe], pe = _e.data, Ve = pe.hostModel, Le = pe.getItemGraphicEl(_e.dataIndex), je = tf(Pi(fe, function(Xe) {
            return f6[Xe].data.getItemGraphicEl(f6[Xe].dataIndex);
          }), function(Xe) {
            return Xe && Xe !== Le && !V[Xe.id];
          });
          Le && (cV(Le), je.length ? (gt(je, function(Xe) {
            cV(Xe), zCe(Xe);
          }), E = true, VCe(u4(je), u4(Le), _e.divide, Ve, oe, y4)) : BCe(Le, Ve, _e.dataIndex));
        }).updateOneToMany(function(oe, fe) {
          var _e = f6[fe], pe = _e.data.getItemGraphicEl(_e.dataIndex);
          if (!(pe && V[pe.id])) {
            var Ve = tf(Pi(oe, function(je) {
              return d4[je].data.getItemGraphicEl(d4[je].dataIndex);
            }), function(je) {
              return je && je !== pe;
            }), Le = d4[oe[0]].data.hostModel;
            Ve.length && (gt(Ve, function(je) {
              return cV(je);
            }), pe ? (cV(pe), zCe(pe), E = true, VCe(u4(pe), u4(Ve), _e.divide, Le, oe[0], y4)) : gt(Ve, function(je) {
              return BCe(je, Le, oe[0]);
            }));
          }
        }).updateManyToMany(function(oe, fe) {
          new OE(fe, oe, function(_e) {
            return f6[_e].data.getId(f6[_e].dataIndex);
          }, function(_e) {
            return d4[_e].data.getId(d4[_e].dataIndex);
          }).update(function(_e, pe) {
            ee(oe[_e], fe[pe]);
          }).execute();
        }).execute(), E && gt(a, function(oe) {
          var fe = oe.data, _e = fe.hostModel, pe = _e && n6.getViewOfSeriesModel(_e), Ve = qk("update", _e, 0);
          pe && _e.isAnimationEnabled() && Ve && Ve.duration > 0 && pe.group.traverse(function(Le) {
            Le instanceof ml && !Le.animators.length && Le.animateFrom({ style: { opacity: 0 } }, Ve);
          });
        });
      }
      function cJe(s) {
        var a = s.getModel("universalTransition").get("seriesKey");
        return a || s.id;
      }
      function fJe(s) {
        return Di(s) ? s.sort().join(",") : s;
      }
      function d3(s) {
        if (s.hostModel)
          return s.hostModel.getModel("universalTransition").get("divideShape");
      }
      function HZt(s, a) {
        var n6 = ro(), f6 = ro(), d4 = ro();
        return gt(s.oldSeries, function(y4, _) {
          var S = s.oldData[_], T = cJe(y4), E = fJe(T);
          f6.set(E, S), Di(T) && gt(T, function(O) {
            d4.set(O, { data: S, key: E });
          });
        }), gt(a.updatedSeries, function(y4) {
          if (y4.isUniversalTransitionEnabled() && y4.isAnimationEnabled()) {
            var _ = y4.getData(), S = cJe(y4), T = fJe(S), E = f6.get(T);
            if (E)
              n6.set(T, { oldSeries: [{ divide: d3(E), data: E }], newSeries: [{ divide: d3(_), data: _ }] });
            else if (Di(S)) {
              var O = [];
              gt(S, function(z3) {
                var H = f6.get(z3);
                H && O.push({ divide: d3(H), data: H });
              }), O.length && n6.set(T, { oldSeries: O, newSeries: [{ data: _, divide: d3(_) }] });
            } else {
              var R = d4.get(S);
              if (R) {
                var V = n6.get(R.key);
                V || (V = { oldSeries: [{ data: R.data, divide: d3(R.data) }], newSeries: [] }, n6.set(R.key, V)), V.newSeries.push({ data: _, divide: d3(_) });
              }
            }
          }
        }), n6;
      }
      function hJe(s, a) {
        for (var n6 = 0; n6 < s.length; n6++) {
          var f6 = a.seriesIndex != null && a.seriesIndex === s[n6].seriesIndex || a.seriesId != null && a.seriesId === s[n6].id;
          if (f6)
            return n6;
        }
      }
      function WZt(s, a, n6, f6) {
        var d4 = [], y4 = [];
        gt(jc(s.from), function(_) {
          var S = hJe(a.oldSeries, _);
          S >= 0 && d4.push({ data: a.oldData[S], divide: d3(a.oldData[S]), dim: _.dimension });
        }), gt(jc(s.to), function(_) {
          var S = hJe(n6.updatedSeries, _);
          if (S >= 0) {
            var T = n6.updatedSeries[S].getData();
            y4.push({ data: T, divide: d3(T), dim: _.dimension });
          }
        }), d4.length > 0 && y4.length > 0 && uJe(d4, y4, f6);
      }
      function UZt(s) {
        s.registerUpdateLifecycle("series:beforeupdate", function(a, n6, f6) {
          gt(jc(f6.seriesTransition), function(d4) {
            gt(jc(d4.to), function(y4) {
              for (var _ = f6.updatedSeries, S = 0; S < _.length; S++)
                (y4.seriesIndex != null && y4.seriesIndex === _[S].seriesIndex || y4.seriesId != null && y4.seriesId === _[S].id) && (_[S][Vae] = true);
            });
          });
        }), s.registerUpdateLifecycle("series:transition", function(a, n6, f6) {
          var d4 = BZt(n6);
          if (d4.oldSeries && f6.updatedSeries && f6.optionChanged) {
            var y4 = f6.seriesTransition;
            if (y4)
              gt(jc(y4), function(V) {
                WZt(V, d4, f6, n6);
              });
            else {
              var _ = HZt(d4, f6);
              gt(_.keys(), function(V) {
                var z3 = _.get(V);
                uJe(z3.oldSeries, z3.newSeries, n6);
              });
            }
            gt(f6.updatedSeries, function(V) {
              V[Vae] && (V[Vae] = false);
            });
          }
          for (var S = a.getSeries(), T = d4.oldSeries = [], E = d4.oldData = [], O = 0; O < S.length; O++) {
            var R = S[O].getData();
            R.count() < sJe && (T.push(S[O]), E.push(R));
          }
        });
      }
      Il([u9t]), Il([n9t]), Il([P9t, Z9t, u7t, Z7t, dVt, lBt, BBt, Mzt, Qzt, ljt, bjt, SGt, KGt, cHt, EHt, NHt, eWt, cWt, SWt, kWt, WWt, IUt]), Il(ZUt), Il(kqt), Il(l$e), Il(Xqt), Il(kXe), Il(t$t), Il(c$t), Il(fXt), Il(LXt), Il(fX), Il(eYt), Il(rYt), Il(mYt), Il(IYt), Il(NYt), Il(WYt), Il(iKt), Il(TKt), Il(wZe), Il(TZe), Il(QKt), Il(GZe), Il(WZe), Il(iZt), Il(yZt), Il(_Zt), Il(UZt), Il(x8t);
      function qZt(s) {
        const { defaultOptions: a } = s != null ? s : {}, n6 = M.useRef(null), f6 = M.useRef(), d4 = M.useRef(a);
        return M.useEffect(() => {
          if (!n6.current)
            return;
          const y4 = FNt(n6.current);
          f6.current = y4, d4.current && y4.setOption(d4.current);
        }, []), M.useEffect(() => () => {
          var y4, _, S, T;
          (_ = (y4 = f6.current) == null ? void 0 : y4.dispose) == null || _.call(y4), (T = (S = f6.current) == null ? void 0 : S.off) == null || T.call(S, "*"), f6.current = void 0;
        }, []), _n("resize", () => {
          requestAnimationFrame(() => {
            var y4, _;
            (_ = (y4 = f6 == null ? void 0 : f6.current) == null ? void 0 : y4.resize) == null || _.call(y4);
          });
        }), { chart: f6, container: n6 };
      }
      class $Zt {
        constructor() {
          w3(this, "chartsEmitters", /* @__PURE__ */ new Map()), w3(this, "add", (a, n6, f6, d4) => {
            n6 && f6 ? this.chartsEmitters.set(a, { chart: n6, option: f6, title: d4 }) : console.log("\u6DFB\u52A0\u5931\u8D25");
          }), w3(this, "get", (a) => this.chartsEmitters.get(a)), w3(this, "clear", () => {
            this.chartsEmitters.clear();
          }), w3(this, "delete", (a) => {
            this.chartsEmitters.delete(a);
          }), w3(this, "list", () => {
            var a, n6, f6;
            const d4 = [];
            for (const y4 of this.chartsEmitters.keys())
              d4.push({ id: y4, chart: (a = this.chartsEmitters.get(y4)) == null ? void 0 : a.chart, option: (n6 = this.chartsEmitters.get(y4)) == null ? void 0 : n6.option, title: (f6 = this.chartsEmitters.get(y4)) == null ? void 0 : f6.title });
            return d4;
          });
        }
      }
      const XZt = new $Zt();
      var bse = { exports: {} };
      /**
      * @license
      * Lodash <https://lodash.com/>
      * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
      * Released under MIT license <https://lodash.com/license>
      * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
      * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
      */
      (function(s, a) {
        (function() {
          var n6, f6 = "4.17.21", d4 = 200, y4 = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", _ = "Expected a function", S = "Invalid `variable` option passed into `_.template`", T = "__lodash_hash_undefined__", E = 500, O = "__lodash_placeholder__", R = 1, V = 2, z3 = 4, H = 1, Z = 2, ee = 1, oe = 2, fe = 4, _e = 8, pe = 16, Ve = 32, Le = 64, je = 128, Xe = 256, Ye = 512, rt2 = 30, ut = "...", wt = 800, dt = 16, Gt = 1, Qt = 2, Nt = 3, er = 1 / 0, un = 9007199254740991, pn = 17976931348623157e292, On = 0 / 0, fr = 4294967295, yr = fr - 1, da = fr >>> 1, Ja = [["ary", je], ["bind", ee], ["bindKey", oe], ["curry", _e], ["curryRight", pe], ["flip", Ye], ["partial", Ve], ["partialRight", Le], ["rearg", Xe]], ko = "[object Arguments]", wo = "[object Array]", So = "[object AsyncFunction]", Fa = "[object Boolean]", po = "[object Date]", To = "[object DOMException]", Ya = "[object Error]", $o = "[object Function]", Hu = "[object GeneratorFunction]", ms = "[object Map]", sc = "[object Number]", Oc = "[object Null]", _c2 = "[object Object]", _v = "[object Promise]", cp = "[object Proxy]", Vg = "[object RegExp]", rh = "[object Set]", Mp = "[object String]", fp = "[object Symbol]", vx = "[object Undefined]", ea = "[object WeakMap]", Qr = "[object WeakSet]", Yr = "[object ArrayBuffer]", na = "[object DataView]", lo = "[object Float32Array]", hs = "[object Float64Array]", du = "[object Int8Array]", au = "[object Int16Array]", pf = "[object Int32Array]", hp = "[object Uint8Array]", Ah = "[object Uint8ClampedArray]", Td = "[object Uint16Array]", Ih = "[object Uint32Array]", k0 = /\b__p \+= '';/g, jy = /\b(__p \+=) '' \+/g, J1 = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Gy = /&(?:amp|lt|gt|quot|#39);/g, $p = /[&<>"']/g, xc = RegExp(Gy.source), xv = RegExp($p.source), Bg = /<%-([\s\S]+?)%>/g, $b = /<%([\s\S]+?)%>/g, Xm = /<%=([\s\S]+?)%>/g, Hy = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, Q1 = /^\w*$/, IS = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, ES = /[\\^$.*+?()[\]{}|]/g, LX = RegExp(ES.source), HT = /^\s+/, RX = /\s/, NX = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, FX = /\{\n\/\* \[wrapped with (.+)\] \*/, VX = /,? & /, m32 = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, En = /[()=,{}\[\]\/\s]/, Pn = /\\(\\)?/g, Kt = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, yn = /\w*$/, fn = /^[-+]0x[0-9a-f]+$/i, Br = /^0b[01]+$/i, Nr = /^\[object .+?Constructor\]$/, yi = /^0o[0-7]+$/i, Er = /^(?:0|[1-9]\d*)$/, _a2 = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, rs = /($^)/, wu = /['\n\r\u2028\u2029\\]/g, _l = "\\ud800-\\udfff", Rf = "\\u0300-\\u036f", Ol = "\\ufe20-\\ufe2f", Sf = "\\u20d0-\\u20ff", qf = Rf + Ol + Sf, _s = "\\u2700-\\u27bf", df = "a-z\\xdf-\\xf6\\xf8-\\xff", Wy = "\\xac\\xb1\\xd7\\xf7", gx = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", b32 = "\\u2000-\\u206f", Ym = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", MC = "A-Z\\xc0-\\xd6\\xd8-\\xde", TC = "\\ufe0e\\ufe0f", Ad = Wy + gx + b32 + Ym, DS = "['\u2019]", HE = "[" + _l + "]", AC = "[" + Ad + "]", WE = "[" + qf + "]", WT = "\\d+", zg = "[" + _s + "]", UE = "[" + df + "]", kS = "[^" + _l + Ad + WT + _s + df + MC + "]", qE = "\\ud83c[\\udffb-\\udfff]", UT = "(?:" + WE + "|" + qE + ")", Xb = "[^" + _l + "]", p4 = "(?:\\ud83c[\\udde6-\\uddff]){2}", d42 = "[\\ud800-\\udbff][\\udc00-\\udfff]", O0 = "[" + MC + "]", qse = "\\u200d", OS = "(?:" + UE + "|" + kS + ")", mV = "(?:" + O0 + "|" + kS + ")", BX = "(?:" + DS + "(?:d|ll|m|re|s|t|ve))?", $se = "(?:" + DS + "(?:D|LL|M|RE|S|T|VE))?", Xse = UT + "?", Yse = "[" + TC + "]?", Kse = "(?:" + qse + "(?:" + [Xb, p4, d42].join("|") + ")" + Yse + Xse + ")*", Zse = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", OMe = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", zX = Yse + Xse + Kse, bV = "(?:" + [zg, p4, d42].join("|") + ")" + zX, PMe = "(?:" + [Xb + WE + "?", WE, p4, d42, HE].join("|") + ")", Jse = RegExp(DS, "g"), Qse = RegExp(WE, "g"), _V = RegExp(qE + "(?=" + qE + ")|" + PMe + zX, "g"), jX = RegExp([O0 + "?" + UE + "+" + BX + "(?=" + [AC, O0, "$"].join("|") + ")", mV + "+" + $se + "(?=" + [AC, O0 + OS, "$"].join("|") + ")", O0 + "?" + OS + "+" + BX, O0 + "+" + $se, OMe, Zse, WT, bV].join("|"), "g"), GX = RegExp("[" + qse + _l + qf + TC + "]"), P0 = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, HX = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], ele = -1, pp = {};
          pp[lo] = pp[hs] = pp[du] = pp[au] = pp[pf] = pp[hp] = pp[Ah] = pp[Td] = pp[Ih] = true, pp[ko] = pp[wo] = pp[Yr] = pp[Fa] = pp[na] = pp[po] = pp[Ya] = pp[$o] = pp[ms] = pp[sc] = pp[_c2] = pp[Vg] = pp[rh] = pp[Mp] = pp[ea] = false;
          var Xh = {};
          Xh[ko] = Xh[wo] = Xh[Yr] = Xh[na] = Xh[Fa] = Xh[po] = Xh[lo] = Xh[hs] = Xh[du] = Xh[au] = Xh[pf] = Xh[ms] = Xh[sc] = Xh[_c2] = Xh[Vg] = Xh[rh] = Xh[Mp] = Xh[fp] = Xh[hp] = Xh[Ah] = Xh[Td] = Xh[Ih] = true, Xh[Ya] = Xh[$o] = Xh[ea] = false;
          var PS = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, tle = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, LMe = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, nle = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, WX = parseFloat, rle = parseInt, xV = typeof bt == "object" && bt && bt.Object === Object && bt, RMe = typeof self == "object" && self && self.Object === Object && self, ng = xV || RMe || Function("return this")(), UX = a && !a.nodeType && a, qT = UX && true && s && !s.nodeType && s, qX = qT && qT.exports === UX, v42 = qX && xV.process, eb = function() {
            try {
              var mr = qT && qT.require && qT.require("util").types;
              return mr || v42 && v42.binding && v42.binding("util");
            } catch {
            }
          }(), $X = eb && eb.isArrayBuffer, ile = eb && eb.isDate, ale = eb && eb.isMap, ole = eb && eb.isRegExp, _3 = eb && eb.isSet, sle = eb && eb.isTypedArray;
          function tb(mr, Li, hi) {
            switch (hi.length) {
              case 0:
                return mr.call(Li);
              case 1:
                return mr.call(Li, hi[0]);
              case 2:
                return mr.call(Li, hi[0], hi[1]);
              case 3:
                return mr.call(Li, hi[0], hi[1], hi[2]);
            }
            return mr.apply(Li, hi);
          }
          function wV(mr, Li, hi, Wo) {
            for (var cl = -1, Cf = mr == null ? 0 : mr.length; ++cl < Cf; ) {
              var Id = mr[cl];
              Li(Wo, Id, hi(Id), mr);
            }
            return Wo;
          }
          function Km(mr, Li) {
            for (var hi = -1, Wo = mr == null ? 0 : mr.length; ++hi < Wo && Li(mr[hi], hi, mr) !== false; )
              ;
            return mr;
          }
          function lle(mr, Li) {
            for (var hi = mr == null ? 0 : mr.length; hi-- && Li(mr[hi], hi, mr) !== false; )
              ;
            return mr;
          }
          function ule(mr, Li) {
            for (var hi = -1, Wo = mr == null ? 0 : mr.length; ++hi < Wo; )
              if (!Li(mr[hi], hi, mr))
                return false;
            return true;
          }
          function $T(mr, Li) {
            for (var hi = -1, Wo = mr == null ? 0 : mr.length, cl = 0, Cf = []; ++hi < Wo; ) {
              var Id = mr[hi];
              Li(Id, hi, mr) && (Cf[cl++] = Id);
            }
            return Cf;
          }
          function $E(mr, Li) {
            var hi = mr == null ? 0 : mr.length;
            return !!hi && IC(mr, Li, 0) > -1;
          }
          function XX(mr, Li, hi) {
            for (var Wo = -1, cl = mr == null ? 0 : mr.length; ++Wo < cl; )
              if (hi(Li, mr[Wo]))
                return true;
            return false;
          }
          function Tp(mr, Li) {
            for (var hi = -1, Wo = mr == null ? 0 : mr.length, cl = Array(Wo); ++hi < Wo; )
              cl[hi] = Li(mr[hi], hi, mr);
            return cl;
          }
          function XT(mr, Li) {
            for (var hi = -1, Wo = Li.length, cl = mr.length; ++hi < Wo; )
              mr[cl + hi] = Li[hi];
            return mr;
          }
          function SV(mr, Li, hi, Wo) {
            var cl = -1, Cf = mr == null ? 0 : mr.length;
            for (Wo && Cf && (hi = mr[++cl]); ++cl < Cf; )
              hi = Li(hi, mr[cl], cl, mr);
            return hi;
          }
          function NMe(mr, Li, hi, Wo) {
            var cl = mr == null ? 0 : mr.length;
            for (Wo && cl && (hi = mr[--cl]); cl--; )
              hi = Li(hi, mr[cl], cl, mr);
            return hi;
          }
          function ld(mr, Li) {
            for (var hi = -1, Wo = mr == null ? 0 : mr.length; ++hi < Wo; )
              if (Li(mr[hi], hi, mr))
                return true;
            return false;
          }
          var g4 = m4("length");
          function cle(mr) {
            return mr.split("");
          }
          function y42(mr) {
            return mr.match(m32) || [];
          }
          function CV(mr, Li, hi) {
            var Wo;
            return hi(mr, function(cl, Cf, Id) {
              if (Li(cl, Cf, Id))
                return Wo = Cf, false;
            }), Wo;
          }
          function x32(mr, Li, hi, Wo) {
            for (var cl = mr.length, Cf = hi + (Wo ? 1 : -1); Wo ? Cf-- : ++Cf < cl; )
              if (Li(mr[Cf], Cf, mr))
                return Cf;
            return -1;
          }
          function IC(mr, Li, hi) {
            return Li === Li ? GMe(mr, Li, hi) : x32(mr, MV, hi);
          }
          function FMe(mr, Li, hi, Wo) {
            for (var cl = hi - 1, Cf = mr.length; ++cl < Cf; )
              if (Wo(mr[cl], Li))
                return cl;
            return -1;
          }
          function MV(mr) {
            return mr !== mr;
          }
          function fle(mr, Li) {
            var hi = mr == null ? 0 : mr.length;
            return hi ? _4(mr, Li) / hi : On;
          }
          function m4(mr) {
            return function(Li) {
              return Li == null ? n6 : Li[mr];
            };
          }
          function b4(mr) {
            return function(Li) {
              return mr == null ? n6 : mr[Li];
            };
          }
          function Nf(mr, Li, hi, Wo, cl) {
            return cl(mr, function(Cf, Id, Mf) {
              hi = Wo ? (Wo = false, Cf) : Li(hi, Cf, Id, Mf);
            }), hi;
          }
          function rg(mr, Li) {
            var hi = mr.length;
            for (mr.sort(Li); hi--; )
              mr[hi] = mr[hi].value;
            return mr;
          }
          function _4(mr, Li) {
            for (var hi, Wo = -1, cl = mr.length; ++Wo < cl; ) {
              var Cf = Li(mr[Wo]);
              Cf !== n6 && (hi = hi === n6 ? Cf : hi + Cf);
            }
            return hi;
          }
          function x4(mr, Li) {
            for (var hi = -1, Wo = Array(mr); ++hi < mr; )
              Wo[hi] = Li(hi);
            return Wo;
          }
          function TV(mr, Li) {
            return Tp(Li, function(hi) {
              return [hi, mr[hi]];
            });
          }
          function w4(mr) {
            return mr && mr.slice(0, KX(mr) + 1).replace(HT, "");
          }
          function L0(mr) {
            return function(Li) {
              return mr(Li);
            };
          }
          function w32(mr, Li) {
            return Tp(Li, function(hi) {
              return mr[hi];
            });
          }
          function YT(mr, Li) {
            return mr.has(Li);
          }
          function AV(mr, Li) {
            for (var hi = -1, Wo = mr.length; ++hi < Wo && IC(Li, mr[hi], 0) > -1; )
              ;
            return hi;
          }
          function S4(mr, Li) {
            for (var hi = mr.length; hi-- && IC(Li, mr[hi], 0) > -1; )
              ;
            return hi;
          }
          function IV(mr, Li) {
            for (var hi = mr.length, Wo = 0; hi--; )
              mr[hi] === Li && ++Wo;
            return Wo;
          }
          var EV = b4(PS), VMe = b4(tle);
          function DV(mr) {
            return "\\" + nle[mr];
          }
          function kV(mr, Li) {
            return mr == null ? n6 : mr[Li];
          }
          function S3(mr) {
            return GX.test(mr);
          }
          function BMe(mr) {
            return P0.test(mr);
          }
          function zMe(mr) {
            for (var Li, hi = []; !(Li = mr.next()).done; )
              hi.push(Li.value);
            return hi;
          }
          function YX(mr) {
            var Li = -1, hi = Array(mr.size);
            return mr.forEach(function(Wo, cl) {
              hi[++Li] = [cl, Wo];
            }), hi;
          }
          function Zm(mr, Li) {
            return function(hi) {
              return mr(Li(hi));
            };
          }
          function EC(mr, Li) {
            for (var hi = -1, Wo = mr.length, cl = 0, Cf = []; ++hi < Wo; ) {
              var Id = mr[hi];
              (Id === Li || Id === O) && (mr[hi] = O, Cf[cl++] = hi);
            }
            return Cf;
          }
          function C3(mr) {
            var Li = -1, hi = Array(mr.size);
            return mr.forEach(function(Wo) {
              hi[++Li] = Wo;
            }), hi;
          }
          function jMe(mr) {
            var Li = -1, hi = Array(mr.size);
            return mr.forEach(function(Wo) {
              hi[++Li] = [Wo, Wo];
            }), hi;
          }
          function GMe(mr, Li, hi) {
            for (var Wo = hi - 1, cl = mr.length; ++Wo < cl; )
              if (mr[Wo] === Li)
                return Wo;
            return -1;
          }
          function HMe(mr, Li, hi) {
            for (var Wo = hi + 1; Wo--; )
              if (mr[Wo] === Li)
                return Wo;
            return Wo;
          }
          function M3(mr) {
            return S3(mr) ? Gc(mr) : g4(mr);
          }
          function yx(mr) {
            return S3(mr) ? T3(mr) : cle(mr);
          }
          function KX(mr) {
            for (var Li = mr.length; Li-- && RX.test(mr.charAt(Li)); )
              ;
            return Li;
          }
          var WMe = b4(LMe);
          function Gc(mr) {
            for (var Li = _V.lastIndex = 0; _V.test(mr); )
              ++Li;
            return Li;
          }
          function T3(mr) {
            return mr.match(_V) || [];
          }
          function dp(mr) {
            return mr.match(jX) || [];
          }
          var C4 = function mr(Li) {
            Li = Li == null ? ng : KT.defaults(ng.Object(), Li, KT.pick(ng, HX));
            var hi = Li.Array, Wo = Li.Date, cl = Li.Error, Cf = Li.Function, Id = Li.Math, Mf = Li.Object, ZX = Li.RegExp, OV = Li.String, Yb = Li.TypeError, A3 = hi.prototype, UMe = Cf.prototype, I3 = Mf.prototype, E3 = Li["__core-js_shared__"], R0 = UMe.toString, $f = I3.hasOwnProperty, wv = 0, hle = function() {
              var q10 = /[^.]+$/.exec(E3 && E3.keys && E3.keys.IE_PROTO || "");
              return q10 ? "Symbol(src)_1." + q10 : "";
            }(), M4 = I3.toString, qMe = R0.call(Mf), ple = ng._, $Me = ZX("^" + R0.call($f).replace(ES, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), PV = qX ? Li.Buffer : n6, ZT = Li.Symbol, T4 = Li.Uint8Array, JX = PV ? PV.allocUnsafe : n6, A4 = Zm(Mf.getPrototypeOf, Mf), dle = Mf.create, LV = I3.propertyIsEnumerable, JT = A3.splice, vle = ZT ? ZT.isConcatSpreadable : n6, I4 = ZT ? ZT.iterator : n6, Kb = ZT ? ZT.toStringTag : n6, RV = function() {
              try {
                var q10 = Yh(Mf, "defineProperty");
                return q10({}, "", {}), q10;
              } catch {
              }
            }(), XMe = Li.clearTimeout !== ng.clearTimeout && Li.clearTimeout, Pc = Wo && Wo.now !== ng.Date.now && Wo.now, YMe = Li.setTimeout !== ng.setTimeout && Li.setTimeout, NV = Id.ceil, FV = Id.floor, QX = Mf.getOwnPropertySymbols, KMe = PV ? PV.isBuffer : n6, gle = Li.isFinite, ZMe = A3.join, JMe = Zm(Mf.keys, Mf), Sv = Id.max, N0 = Id.min, QMe = Wo.now, eTe = Li.parseInt, yle = Id.random, tTe = A3.reverse, E4 = Yh(Li, "DataView"), D4 = Yh(Li, "Map"), XE = Yh(Li, "Promise"), QT = Yh(Li, "Set"), YE = Yh(Li, "WeakMap"), DC = Yh(Mf, "create"), F0 = YE && new YE(), KE = {}, mle = Ot(E4), nTe = Ot(D4), ble = Ot(XE), rTe = Ot(QT), Qd = Ot(YE), kC = ZT ? ZT.prototype : n6, mx = kC ? kC.valueOf : n6, eY = kC ? kC.toString : n6;
            function Wt(q10) {
              if (sh(q10) && !Pl(q10) && !(q10 instanceof wc)) {
                if (q10 instanceof Uy)
                  return q10;
                if ($f.call(q10, "__wrapped__"))
                  return wn(q10);
              }
              return new Uy(q10);
            }
            var ZE = function() {
              function q10() {
              }
              return function(re) {
                if (!oh(re))
                  return {};
                if (dle)
                  return dle(re);
                q10.prototype = re;
                var Ee = new q10();
                return q10.prototype = n6, Ee;
              };
            }();
            function k4() {
            }
            function Uy(q10, re) {
              this.__wrapped__ = q10, this.__actions__ = [], this.__chain__ = !!re, this.__index__ = 0, this.__values__ = n6;
            }
            Wt.templateSettings = { escape: Bg, evaluate: $b, interpolate: Xm, variable: "", imports: { _: Wt } }, Wt.prototype = k4.prototype, Wt.prototype.constructor = Wt, Uy.prototype = ZE(k4.prototype), Uy.prototype.constructor = Uy;
            function wc(q10) {
              this.__wrapped__ = q10, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = fr, this.__views__ = [];
            }
            function iTe() {
              var q10 = new wc(this.__wrapped__);
              return q10.__actions__ = nr(this.__actions__), q10.__dir__ = this.__dir__, q10.__filtered__ = this.__filtered__, q10.__iteratees__ = nr(this.__iteratees__), q10.__takeCount__ = this.__takeCount__, q10.__views__ = nr(this.__views__), q10;
            }
            function aTe() {
              if (this.__filtered__) {
                var q10 = new wc(this);
                q10.__dir__ = -1, q10.__filtered__ = true;
              } else
                q10 = this.clone(), q10.__dir__ *= -1;
              return q10;
            }
            function _le() {
              var q10 = this.__wrapped__.value(), re = this.__dir__, Ee = Pl(q10), Je = re < 0, St = Ee ? q10.length : 0, rn = qr(0, St, this.__views__), Gn = rn.start, Yn = rn.end, Cr = Yn - Gn, aa = Je ? Yn : Gn - 1, oa = this.__iteratees__, ua = oa.length, bo = 0, os = N0(Cr, this.__takeCount__);
              if (!Ee || !Je && St == Cr && os == Cr)
                return zle(q10, this.__actions__);
              var Rs = [];
              e:
                for (; Cr-- && bo < os; ) {
                  aa += re;
                  for (var su = -1, Us = q10[aa]; ++su < ua; ) {
                    var Qs = oa[su], Yl = Qs.iteratee, Kg = Qs.type, lg = Yl(Us);
                    if (Kg == Qt)
                      Us = lg;
                    else if (!lg) {
                      if (Kg == Gt)
                        continue e;
                      break e;
                    }
                  }
                  Rs[bo++] = Us;
                }
              return Rs;
            }
            wc.prototype = ZE(k4.prototype), wc.prototype.constructor = wc;
            function JE(q10) {
              var re = -1, Ee = q10 == null ? 0 : q10.length;
              for (this.clear(); ++re < Ee; ) {
                var Je = q10[re];
                this.set(Je[0], Je[1]);
              }
            }
            function oTe() {
              this.__data__ = DC ? DC(null) : {}, this.size = 0;
            }
            function tY(q10) {
              var re = this.has(q10) && delete this.__data__[q10];
              return this.size -= re ? 1 : 0, re;
            }
            function nY(q10) {
              var re = this.__data__;
              if (DC) {
                var Ee = re[q10];
                return Ee === T ? n6 : Ee;
              }
              return $f.call(re, q10) ? re[q10] : n6;
            }
            function sTe(q10) {
              var re = this.__data__;
              return DC ? re[q10] !== n6 : $f.call(re, q10);
            }
            function lTe(q10, re) {
              var Ee = this.__data__;
              return this.size += this.has(q10) ? 0 : 1, Ee[q10] = DC && re === n6 ? T : re, this;
            }
            JE.prototype.clear = oTe, JE.prototype.delete = tY, JE.prototype.get = nY, JE.prototype.has = sTe, JE.prototype.set = lTe;
            function bx(q10) {
              var re = -1, Ee = q10 == null ? 0 : q10.length;
              for (this.clear(); ++re < Ee; ) {
                var Je = q10[re];
                this.set(Je[0], Je[1]);
              }
            }
            function uTe() {
              this.__data__ = [], this.size = 0;
            }
            function rY(q10) {
              var re = this.__data__, Ee = R4(re, q10);
              if (Ee < 0)
                return false;
              var Je = re.length - 1;
              return Ee == Je ? re.pop() : JT.call(re, Ee, 1), --this.size, true;
            }
            function cTe(q10) {
              var re = this.__data__, Ee = R4(re, q10);
              return Ee < 0 ? n6 : re[Ee][1];
            }
            function Zb(q10) {
              return R4(this.__data__, q10) > -1;
            }
            function xle(q10, re) {
              var Ee = this.__data__, Je = R4(Ee, q10);
              return Je < 0 ? (++this.size, Ee.push([q10, re])) : Ee[Je][1] = re, this;
            }
            bx.prototype.clear = uTe, bx.prototype.delete = rY, bx.prototype.get = cTe, bx.prototype.has = Zb, bx.prototype.set = xle;
            function _x(q10) {
              var re = -1, Ee = q10 == null ? 0 : q10.length;
              for (this.clear(); ++re < Ee; ) {
                var Je = q10[re];
                this.set(Je[0], Je[1]);
              }
            }
            function wle() {
              this.size = 0, this.__data__ = { hash: new JE(), map: new (D4 || bx)(), string: new JE() };
            }
            function fTe(q10) {
              var re = ag(this, q10).delete(q10);
              return this.size -= re ? 1 : 0, re;
            }
            function hTe(q10) {
              return ag(this, q10).get(q10);
            }
            function pTe(q10) {
              return ag(this, q10).has(q10);
            }
            function Sle(q10, re) {
              var Ee = ag(this, q10), Je = Ee.size;
              return Ee.set(q10, re), this.size += Ee.size == Je ? 0 : 1, this;
            }
            _x.prototype.clear = wle, _x.prototype.delete = fTe, _x.prototype.get = hTe, _x.prototype.has = pTe, _x.prototype.set = Sle;
            function OC(q10) {
              var re = -1, Ee = q10 == null ? 0 : q10.length;
              for (this.__data__ = new _x(); ++re < Ee; )
                this.add(q10[re]);
            }
            function O4(q10) {
              return this.__data__.set(q10, T), this;
            }
            function dTe(q10) {
              return this.__data__.has(q10);
            }
            OC.prototype.add = OC.prototype.push = O4, OC.prototype.has = dTe;
            function xx(q10) {
              var re = this.__data__ = new bx(q10);
              this.size = re.size;
            }
            function Cle() {
              this.__data__ = new bx(), this.size = 0;
            }
            function iY(q10) {
              var re = this.__data__, Ee = re.delete(q10);
              return this.size = re.size, Ee;
            }
            function vTe(q10) {
              return this.__data__.get(q10);
            }
            function gTe(q10) {
              return this.__data__.has(q10);
            }
            function yTe(q10, re) {
              var Ee = this.__data__;
              if (Ee instanceof bx) {
                var Je = Ee.__data__;
                if (!D4 || Je.length < d4 - 1)
                  return Je.push([q10, re]), this.size = ++Ee.size, this;
                Ee = this.__data__ = new _x(Je);
              }
              return Ee.set(q10, re), this.size = Ee.size, this;
            }
            xx.prototype.clear = Cle, xx.prototype.delete = iY, xx.prototype.get = vTe, xx.prototype.has = gTe, xx.prototype.set = yTe;
            function Mle(q10, re) {
              var Ee = Pl(q10), Je = !Ee && H0(q10), St = !Ee && !Je && go(q10), rn = !Ee && !Je && !St && kx(q10), Gn = Ee || Je || St || rn, Yn = Gn ? x4(q10.length, OV) : [], Cr = Yn.length;
              for (var aa in q10)
                (re || $f.call(q10, aa)) && !(Gn && (aa == "length" || St && (aa == "offset" || aa == "parent") || rn && (aa == "buffer" || aa == "byteLength" || aa == "byteOffset") || Sc(aa, Cr))) && Yn.push(aa);
              return Yn;
            }
            function P4(q10) {
              var re = q10.length;
              return re ? q10[yY(0, re - 1)] : n6;
            }
            function mTe(q10, re) {
              return e_(nr(q10), QE(re, 0, q10.length));
            }
            function bTe(q10) {
              return e_(nr(q10));
            }
            function aY(q10, re, Ee) {
              (Ee !== n6 && !$g(q10[re], Ee) || Ee === n6 && !(re in q10)) && PC(q10, re, Ee);
            }
            function L4(q10, re, Ee) {
              var Je = q10[re];
              (!($f.call(q10, re) && $g(Je, Ee)) || Ee === n6 && !(re in q10)) && PC(q10, re, Ee);
            }
            function R4(q10, re) {
              for (var Ee = q10.length; Ee--; )
                if ($g(q10[Ee][0], re))
                  return Ee;
              return -1;
            }
            function _Te(q10, re, Ee, Je) {
              return eA(q10, function(St, rn, Gn) {
                re(Je, St, Ee(St), Gn);
              }), Je;
            }
            function oY(q10, re) {
              return q10 && sr(re, kp(re), q10);
            }
            function nb(q10, re) {
              return q10 && sr(re, Bt(re), q10);
            }
            function PC(q10, re, Ee) {
              re == "__proto__" && RV ? RV(q10, re, { configurable: true, enumerable: true, value: Ee, writable: true }) : q10[re] = Ee;
            }
            function VV(q10, re) {
              for (var Ee = -1, Je = re.length, St = hi(Je), rn = q10 == null; ++Ee < Je; )
                St[Ee] = rn ? n6 : US(q10, re[Ee]);
              return St;
            }
            function QE(q10, re, Ee) {
              return q10 === q10 && (Ee !== n6 && (q10 = q10 <= Ee ? q10 : Ee), re !== n6 && (q10 = q10 >= re ? q10 : re)), q10;
            }
            function Jb(q10, re, Ee, Je, St, rn) {
              var Gn, Yn = re & R, Cr = re & V, aa = re & z3;
              if (Ee && (Gn = St ? Ee(q10, Je, St, rn) : Ee(q10)), Gn !== n6)
                return Gn;
              if (!oh(q10))
                return q10;
              var oa = Pl(q10);
              if (oa) {
                if (Gn = is(q10), !Yn)
                  return nr(q10, Gn);
              } else {
                var ua = Rr(q10), bo = ua == $o || ua == Hu;
                if (go(q10))
                  return Re(q10, Yn);
                if (ua == _c2 || ua == ko || bo && !St) {
                  if (Gn = Cr || bo ? {} : Bl(q10), !Yn)
                    return Cr ? gi(q10, nb(Gn, q10)) : Ii(q10, oY(Gn, q10));
                } else {
                  if (!Xh[ua])
                    return St ? q10 : {};
                  Gn = zl(q10, ua, Yn);
                }
              }
              rn || (rn = new xx());
              var os = rn.get(q10);
              if (os)
                return os;
              rn.set(q10, Gn), yD(q10) ? q10.forEach(function(Us) {
                Gn.add(Jb(Us, re, Ee, Us, q10, rn));
              }) : yf(q10) && q10.forEach(function(Us, Qs) {
                Gn.set(Qs, Jb(Us, re, Ee, Qs, q10, rn));
              });
              var Rs = aa ? Cr ? ig : Ap : Cr ? Bt : kp, su = oa ? n6 : Rs(q10);
              return Km(su || q10, function(Us, Qs) {
                su && (Qs = Us, Us = q10[Qs]), L4(Gn, Qs, Jb(Us, re, Ee, Qs, q10, rn));
              }), Gn;
            }
            function sY(q10) {
              var re = kp(q10);
              return function(Ee) {
                return Tle(Ee, q10, re);
              };
            }
            function Tle(q10, re, Ee) {
              var Je = Ee.length;
              if (q10 == null)
                return !Je;
              for (q10 = Mf(q10); Je--; ) {
                var St = Ee[Je], rn = re[St], Gn = q10[St];
                if (Gn === n6 && !(St in q10) || !rn(Gn))
                  return false;
              }
              return true;
            }
            function Ale(q10, re, Ee) {
              if (typeof q10 != "function")
                throw new Yb(_);
              return LC(function() {
                q10.apply(n6, Ee);
              }, re);
            }
            function N4(q10, re, Ee, Je) {
              var St = -1, rn = $E, Gn = true, Yn = q10.length, Cr = [], aa = re.length;
              if (!Yn)
                return Cr;
              Ee && (re = Tp(re, L0(Ee))), Je ? (rn = XX, Gn = false) : re.length >= d4 && (rn = YT, Gn = false, re = new OC(re));
              e:
                for (; ++St < Yn; ) {
                  var oa = q10[St], ua = Ee == null ? oa : Ee(oa);
                  if (oa = Je || oa !== 0 ? oa : 0, Gn && ua === ua) {
                    for (var bo = aa; bo--; )
                      if (re[bo] === ua)
                        continue e;
                    Cr.push(oa);
                  } else
                    rn(re, ua, Je) || Cr.push(oa);
                }
              return Cr;
            }
            var eA = Ar(Gg), Ile = Ar(BV, true);
            function Ele(q10, re) {
              var Ee = true;
              return eA(q10, function(Je, St, rn) {
                return Ee = !!re(Je, St, rn), Ee;
              }), Ee;
            }
            function F4(q10, re, Ee) {
              for (var Je = -1, St = q10.length; ++Je < St; ) {
                var rn = q10[Je], Gn = re(rn);
                if (Gn != null && (Yn === n6 ? Gn === Gn && !Rd(Gn) : Ee(Gn, Yn)))
                  var Yn = Gn, Cr = rn;
              }
              return Cr;
            }
            function lY(q10, re, Ee, Je) {
              var St = q10.length;
              for (Ee = Rl(Ee), Ee < 0 && (Ee = -Ee > St ? 0 : St + Ee), Je = Je === n6 || Je > St ? St : Rl(Je), Je < 0 && (Je += St), Je = Ee > Je ? 0 : bD(Je); Ee < Je; )
                q10[Ee++] = re;
              return q10;
            }
            function D3(q10, re) {
              var Ee = [];
              return eA(q10, function(Je, St, rn) {
                re(Je, St, rn) && Ee.push(Je);
              }), Ee;
            }
            function jg(q10, re, Ee, Je, St) {
              var rn = -1, Gn = q10.length;
              for (Ee || (Ee = Dh), St || (St = []); ++rn < Gn; ) {
                var Yn = q10[rn];
                re > 0 && Ee(Yn) ? re > 1 ? jg(Yn, re - 1, Ee, Je, St) : XT(St, Yn) : Je || (St[St.length] = Yn);
              }
              return St;
            }
            var uY = Vr(), Dle = Vr(true);
            function Gg(q10, re) {
              return q10 && uY(q10, re, kp);
            }
            function BV(q10, re) {
              return q10 && Dle(q10, re, kp);
            }
            function zV(q10, re) {
              return $T(re, function(Ee) {
                return Kh(q10[Ee]);
              });
            }
            function eD(q10, re) {
              re = Ge(re, q10);
              for (var Ee = 0, Je = re.length; q10 != null && Ee < Je; )
                q10 = q10[Dn(re[Ee++])];
              return Ee && Ee == Je ? q10 : n6;
            }
            function cY(q10, re, Ee) {
              var Je = re(q10);
              return Pl(q10) ? Je : XT(Je, Ee(q10));
            }
            function V0(q10) {
              return q10 == null ? q10 === n6 ? vx : Oc : Kb && Kb in Mf(q10) ? Ip(q10) : Ug(q10);
            }
            function jV(q10, re) {
              return q10 > re;
            }
            function fY(q10, re) {
              return q10 != null && $f.call(q10, re);
            }
            function kle(q10, re) {
              return q10 != null && re in Mf(q10);
            }
            function GV(q10, re, Ee) {
              return q10 >= N0(re, Ee) && q10 < Sv(re, Ee);
            }
            function hY(q10, re, Ee) {
              for (var Je = Ee ? XX : $E, St = q10[0].length, rn = q10.length, Gn = rn, Yn = hi(rn), Cr = 1 / 0, aa = []; Gn--; ) {
                var oa = q10[Gn];
                Gn && re && (oa = Tp(oa, L0(re))), Cr = N0(oa.length, Cr), Yn[Gn] = !Ee && (re || St >= 120 && oa.length >= 120) ? new OC(Gn && oa) : n6;
              }
              oa = q10[0];
              var ua = -1, bo = Yn[0];
              e:
                for (; ++ua < St && aa.length < Cr; ) {
                  var os = oa[ua], Rs = re ? re(os) : os;
                  if (os = Ee || os !== 0 ? os : 0, !(bo ? YT(bo, Rs) : Je(aa, Rs, Ee))) {
                    for (Gn = rn; --Gn; ) {
                      var su = Yn[Gn];
                      if (!(su ? YT(su, Rs) : Je(q10[Gn], Rs, Ee)))
                        continue e;
                    }
                    bo && bo.push(Rs), aa.push(os);
                  }
                }
              return aa;
            }
            function fl(q10, re, Ee, Je) {
              return Gg(q10, function(St, rn, Gn) {
                re(Je, Ee(St), rn, Gn);
              }), Je;
            }
            function k32(q10, re, Ee) {
              re = Ge(re, q10), q10 = Sx(q10, re);
              var Je = q10 == null ? q10 : q10[Dn(Ep(re))];
              return Je == null ? n6 : tb(Je, q10, Ee);
            }
            function Ole(q10) {
              return sh(q10) && V0(q10) == ko;
            }
            function xTe(q10) {
              return sh(q10) && V0(q10) == Yr;
            }
            function wTe(q10) {
              return sh(q10) && V0(q10) == po;
            }
            function O3(q10, re, Ee, Je, St) {
              return q10 === re ? true : q10 == null || re == null || !sh(q10) && !sh(re) ? q10 !== q10 && re !== re : HV(q10, re, Ee, Je, O3, St);
            }
            function HV(q10, re, Ee, Je, St, rn) {
              var Gn = Pl(q10), Yn = Pl(re), Cr = Gn ? wo : Rr(q10), aa = Yn ? wo : Rr(re);
              Cr = Cr == ko ? _c2 : Cr, aa = aa == ko ? _c2 : aa;
              var oa = Cr == _c2, ua = aa == _c2, bo = Cr == aa;
              if (bo && go(q10)) {
                if (!go(re))
                  return false;
                Gn = true, oa = false;
              }
              if (bo && !oa)
                return rn || (rn = new xx()), Gn || kx(q10) ? Eh(q10, re, Ee, Je, St, rn) : B0(q10, re, Cr, Ee, Je, St, rn);
              if (!(Ee & H)) {
                var os = oa && $f.call(q10, "__wrapped__"), Rs = ua && $f.call(re, "__wrapped__");
                if (os || Rs) {
                  var su = os ? q10.value() : q10, Us = Rs ? re.value() : re;
                  return rn || (rn = new xx()), St(su, Us, Ee, Je, rn);
                }
              }
              return bo ? (rn || (rn = new xx()), qy(q10, re, Ee, Je, St, rn)) : false;
            }
            function tD(q10) {
              return sh(q10) && Rr(q10) == ms;
            }
            function V4(q10, re, Ee, Je) {
              var St = Ee.length, rn = St, Gn = !Je;
              if (q10 == null)
                return !rn;
              for (q10 = Mf(q10); St--; ) {
                var Yn = Ee[St];
                if (Gn && Yn[2] ? Yn[1] !== q10[Yn[0]] : !(Yn[0] in q10))
                  return false;
              }
              for (; ++St < rn; ) {
                Yn = Ee[St];
                var Cr = Yn[0], aa = q10[Cr], oa = Yn[1];
                if (Gn && Yn[2]) {
                  if (aa === n6 && !(Cr in q10))
                    return false;
                } else {
                  var ua = new xx();
                  if (Je)
                    var bo = Je(aa, oa, Cr, q10, re, ua);
                  if (!(bo === n6 ? O3(oa, aa, H | Z, Je, ua) : bo))
                    return false;
                }
              }
              return true;
            }
            function B4(q10) {
              if (!oh(q10) || Qm(q10))
                return false;
              var re = Kh(q10) ? $Me : Nr;
              return re.test(Ot(q10));
            }
            function STe(q10) {
              return sh(q10) && V0(q10) == Vg;
            }
            function Ple(q10) {
              return sh(q10) && Rr(q10) == rh;
            }
            function CTe(q10) {
              return sh(q10) && Yf(q10.length) && !!pp[V0(q10)];
            }
            function nD(q10) {
              return typeof q10 == "function" ? q10 : q10 == null ? Yg : typeof q10 == "object" ? Pl(q10) ? UV(q10[0], q10[1]) : dY(q10) : qC(q10);
            }
            function P3(q10) {
              if (!ih(q10))
                return JMe(q10);
              var re = [];
              for (var Ee in Mf(q10))
                $f.call(q10, Ee) && Ee != "constructor" && re.push(Ee);
              return re;
            }
            function pY(q10) {
              if (!oh(q10))
                return Wg(q10);
              var re = ih(q10), Ee = [];
              for (var Je in q10)
                Je == "constructor" && (re || !$f.call(q10, Je)) || Ee.push(Je);
              return Ee;
            }
            function WV(q10, re) {
              return q10 < re;
            }
            function Lle(q10, re) {
              var Ee = -1, Je = ir(q10) ? hi(q10.length) : [];
              return eA(q10, function(St, rn, Gn) {
                Je[++Ee] = re(St, rn, Gn);
              }), Je;
            }
            function dY(q10) {
              var re = gp(q10);
              return re.length == 1 && re[0][2] ? ud(re[0][0], re[0][1]) : function(Ee) {
                return Ee === q10 || V4(Ee, q10, re);
              };
            }
            function UV(q10, re) {
              return Af(q10) && Ou(re) ? ud(Dn(q10), re) : function(Ee) {
                var Je = US(Ee, q10);
                return Je === n6 && Je === re ? $3(Ee, q10) : O3(re, Je, H | Z);
              };
            }
            function tA(q10, re, Ee, Je, St) {
              q10 !== re && uY(re, function(rn, Gn) {
                if (St || (St = new xx()), oh(rn))
                  MTe(q10, re, Gn, Ee, tA, Je, St);
                else {
                  var Yn = Je ? Je(iD(q10, Gn), rn, Gn + "", q10, re, St) : n6;
                  Yn === n6 && (Yn = rn), aY(q10, Gn, Yn);
                }
              }, Bt);
            }
            function MTe(q10, re, Ee, Je, St, rn, Gn) {
              var Yn = iD(q10, Ee), Cr = iD(re, Ee), aa = Gn.get(Cr);
              if (aa) {
                aY(q10, Ee, aa);
                return;
              }
              var oa = rn ? rn(Yn, Cr, Ee + "", q10, re, Gn) : n6, ua = oa === n6;
              if (ua) {
                var bo = Pl(Cr), os = !bo && go(Cr), Rs = !bo && !os && kx(Cr);
                oa = Cr, bo || os || Rs ? Pl(Yn) ? oa = Yn : li(Yn) ? oa = nr(Yn) : os ? (ua = false, oa = Re(Cr, true)) : Rs ? (ua = false, oa = Pt(Cr, true)) : oa = [] : i1(Cr) || H0(Cr) ? (oa = Yn, H0(Yn) ? oa = CB(Yn) : (!oh(Yn) || Kh(Yn)) && (oa = Bl(Cr))) : ua = false;
              }
              ua && (Gn.set(Cr, oa), St(oa, Cr, Je, rn, Gn), Gn.delete(Cr)), aY(q10, Ee, oa);
            }
            function vY(q10, re) {
              var Ee = q10.length;
              if (Ee)
                return re += re < 0 ? Ee : 0, Sc(re, Ee) ? q10[re] : n6;
            }
            function gY(q10, re, Ee) {
              re.length ? re = Tp(re, function(rn) {
                return Pl(rn) ? function(Gn) {
                  return eD(Gn, rn.length === 1 ? rn[0] : rn);
                } : rn;
              }) : re = [Yg];
              var Je = -1;
              re = Tp(re, L0(ws()));
              var St = Lle(q10, function(rn, Gn, Yn) {
                var Cr = Tp(re, function(aa) {
                  return aa(rn);
                });
                return { criteria: Cr, index: ++Je, value: rn };
              });
              return rg(St, function(rn, Gn) {
                return Fn(rn, Gn, Ee);
              });
            }
            function TTe(q10, re) {
              return Rle(q10, re, function(Ee, Je) {
                return $3(q10, Je);
              });
            }
            function Rle(q10, re, Ee) {
              for (var Je = -1, St = re.length, rn = {}; ++Je < St; ) {
                var Gn = re[Je], Yn = eD(q10, Gn);
                Ee(Yn, Gn) && z4(rn, Ge(Gn, q10), Yn);
              }
              return rn;
            }
            function ATe(q10) {
              return function(re) {
                return eD(re, q10);
              };
            }
            function qV(q10, re, Ee, Je) {
              var St = Je ? FMe : IC, rn = -1, Gn = re.length, Yn = q10;
              for (q10 === re && (re = nr(re)), Ee && (Yn = Tp(q10, L0(Ee))); ++rn < Gn; )
                for (var Cr = 0, aa = re[rn], oa = Ee ? Ee(aa) : aa; (Cr = St(Yn, oa, Cr, Je)) > -1; )
                  Yn !== q10 && JT.call(Yn, Cr, 1), JT.call(q10, Cr, 1);
              return q10;
            }
            function rD(q10, re) {
              for (var Ee = q10 ? re.length : 0, Je = Ee - 1; Ee--; ) {
                var St = re[Ee];
                if (Ee == Je || St !== rn) {
                  var rn = St;
                  Sc(St) ? JT.call(q10, St, 1) : bY(q10, St);
                }
              }
              return q10;
            }
            function yY(q10, re) {
              return q10 + FV(yle() * (re - q10 + 1));
            }
            function ITe(q10, re, Ee, Je) {
              for (var St = -1, rn = Sv(NV((re - q10) / (Ee || 1)), 0), Gn = hi(rn); rn--; )
                Gn[Je ? rn : ++St] = q10, q10 += Ee;
              return Gn;
            }
            function $V(q10, re) {
              var Ee = "";
              if (!q10 || re < 1 || re > un)
                return Ee;
              do
                re % 2 && (Ee += q10), re = FV(re / 2), re && (q10 += q10);
              while (re);
              return Ee;
            }
            function Wu(q10, re) {
              return aD(G0(q10, re, Yg), q10 + "");
            }
            function XV(q10) {
              return P4(hA(q10));
            }
            function ETe(q10, re) {
              var Ee = hA(q10);
              return e_(Ee, QE(re, 0, Ee.length));
            }
            function z4(q10, re, Ee, Je) {
              if (!oh(q10))
                return q10;
              re = Ge(re, q10);
              for (var St = -1, rn = re.length, Gn = rn - 1, Yn = q10; Yn != null && ++St < rn; ) {
                var Cr = Dn(re[St]), aa = Ee;
                if (Cr === "__proto__" || Cr === "constructor" || Cr === "prototype")
                  return q10;
                if (St != Gn) {
                  var oa = Yn[Cr];
                  aa = Je ? Je(oa, Cr, Yn) : n6, aa === n6 && (aa = oh(oa) ? oa : Sc(re[St + 1]) ? [] : {});
                }
                L4(Yn, Cr, aa), Yn = Yn[Cr];
              }
              return q10;
            }
            var Nle = F0 ? function(q10, re) {
              return F0.set(q10, re), q10;
            } : Yg, Fle = RV ? function(q10, re) {
              return RV(q10, "toString", { configurable: true, enumerable: false, value: g6(re), writable: true });
            } : Yg;
            function DTe(q10) {
              return e_(hA(q10));
            }
            function Qb(q10, re, Ee) {
              var Je = -1, St = q10.length;
              re < 0 && (re = -re > St ? 0 : St + re), Ee = Ee > St ? St : Ee, Ee < 0 && (Ee += St), St = re > Ee ? 0 : Ee - re >>> 0, re >>>= 0;
              for (var rn = hi(St); ++Je < St; )
                rn[Je] = q10[Je + re];
              return rn;
            }
            function kTe(q10, re) {
              var Ee;
              return eA(q10, function(Je, St, rn) {
                return Ee = re(Je, St, rn), !Ee;
              }), !!Ee;
            }
            function YV(q10, re, Ee) {
              var Je = 0, St = q10 == null ? Je : q10.length;
              if (typeof re == "number" && re === re && St <= da) {
                for (; Je < St; ) {
                  var rn = Je + St >>> 1, Gn = q10[rn];
                  Gn !== null && !Rd(Gn) && (Ee ? Gn <= re : Gn < re) ? Je = rn + 1 : St = rn;
                }
                return St;
              }
              return KV(q10, re, Yg, Ee);
            }
            function KV(q10, re, Ee, Je) {
              var St = 0, rn = q10 == null ? 0 : q10.length;
              if (rn === 0)
                return 0;
              re = Ee(re);
              for (var Gn = re !== re, Yn = re === null, Cr = Rd(re), aa = re === n6; St < rn; ) {
                var oa = FV((St + rn) / 2), ua = Ee(q10[oa]), bo = ua !== n6, os = ua === null, Rs = ua === ua, su = Rd(ua);
                if (Gn)
                  var Us = Je || Rs;
                else
                  aa ? Us = Rs && (Je || bo) : Yn ? Us = Rs && bo && (Je || !os) : Cr ? Us = Rs && bo && !os && (Je || !su) : os || su ? Us = false : Us = Je ? ua <= re : ua < re;
                Us ? St = oa + 1 : rn = oa;
              }
              return N0(rn, yr);
            }
            function Vle(q10, re) {
              for (var Ee = -1, Je = q10.length, St = 0, rn = []; ++Ee < Je; ) {
                var Gn = q10[Ee], Yn = re ? re(Gn) : Gn;
                if (!Ee || !$g(Yn, Cr)) {
                  var Cr = Yn;
                  rn[St++] = Gn === 0 ? 0 : Gn;
                }
              }
              return rn;
            }
            function mY(q10) {
              return typeof q10 == "number" ? q10 : Rd(q10) ? On : +q10;
            }
            function rb2(q10) {
              if (typeof q10 == "string")
                return q10;
              if (Pl(q10))
                return Tp(q10, rb2) + "";
              if (Rd(q10))
                return eY ? eY.call(q10) : "";
              var re = q10 + "";
              return re == "0" && 1 / q10 == -er ? "-0" : re;
            }
            function LS(q10, re, Ee) {
              var Je = -1, St = $E, rn = q10.length, Gn = true, Yn = [], Cr = Yn;
              if (Ee)
                Gn = false, St = XX;
              else if (rn >= d4) {
                var aa = re ? null : Uu(q10);
                if (aa)
                  return C3(aa);
                Gn = false, St = YT, Cr = new OC();
              } else
                Cr = re ? [] : Yn;
              e:
                for (; ++Je < rn; ) {
                  var oa = q10[Je], ua = re ? re(oa) : oa;
                  if (oa = Ee || oa !== 0 ? oa : 0, Gn && ua === ua) {
                    for (var bo = Cr.length; bo--; )
                      if (Cr[bo] === ua)
                        continue e;
                    re && Cr.push(ua), Yn.push(oa);
                  } else
                    St(Cr, ua, Ee) || (Cr !== Yn && Cr.push(ua), Yn.push(oa));
                }
              return Yn;
            }
            function bY(q10, re) {
              return re = Ge(re, q10), q10 = Sx(q10, re), q10 == null || delete q10[Dn(Ep(re))];
            }
            function Ble(q10, re, Ee, Je) {
              return z4(q10, re, Ee(eD(q10, re)), Je);
            }
            function ZV(q10, re, Ee, Je) {
              for (var St = q10.length, rn = Je ? St : -1; (Je ? rn-- : ++rn < St) && re(q10[rn], rn, q10); )
                ;
              return Ee ? Qb(q10, Je ? 0 : rn, Je ? rn + 1 : St) : Qb(q10, Je ? rn + 1 : 0, Je ? St : rn);
            }
            function zle(q10, re) {
              var Ee = q10;
              return Ee instanceof wc && (Ee = Ee.value()), SV(re, function(Je, St) {
                return St.func.apply(St.thisArg, XT([Je], St.args));
              }, Ee);
            }
            function JV(q10, re, Ee) {
              var Je = q10.length;
              if (Je < 2)
                return Je ? LS(q10[0]) : [];
              for (var St = -1, rn = hi(Je); ++St < Je; )
                for (var Gn = q10[St], Yn = -1; ++Yn < Je; )
                  Yn != St && (rn[St] = N4(rn[St] || Gn, q10[Yn], re, Ee));
              return LS(jg(rn, 1), re, Ee);
            }
            function jle(q10, re, Ee) {
              for (var Je = -1, St = q10.length, rn = re.length, Gn = {}; ++Je < St; ) {
                var Yn = Je < rn ? re[Je] : n6;
                Ee(Gn, q10[Je], Yn);
              }
              return Gn;
            }
            function _Y(q10) {
              return li(q10) ? q10 : [];
            }
            function ye(q10) {
              return typeof q10 == "function" ? q10 : Yg;
            }
            function Ge(q10, re) {
              return Pl(q10) ? q10 : Af(q10, re) ? [q10] : dn(mf(q10));
            }
            var xe = Wu;
            function Se(q10, re, Ee) {
              var Je = q10.length;
              return Ee = Ee === n6 ? Je : Ee, !re && Ee >= Je ? q10 : Qb(q10, re, Ee);
            }
            var Ce = XMe || function(q10) {
              return ng.clearTimeout(q10);
            };
            function Re(q10, re) {
              if (re)
                return q10.slice();
              var Ee = q10.length, Je = JX ? JX(Ee) : new q10.constructor(Ee);
              return q10.copy(Je), Je;
            }
            function at(q10) {
              var re = new q10.constructor(q10.byteLength);
              return new T4(re).set(new T4(q10)), re;
            }
            function ft(q10, re) {
              var Ee = re ? at(q10.buffer) : q10.buffer;
              return new q10.constructor(Ee, q10.byteOffset, q10.byteLength);
            }
            function st(q10) {
              var re = new q10.constructor(q10.source, yn.exec(q10));
              return re.lastIndex = q10.lastIndex, re;
            }
            function Dt(q10) {
              return mx ? Mf(mx.call(q10)) : {};
            }
            function Pt(q10, re) {
              var Ee = re ? at(q10.buffer) : q10.buffer;
              return new q10.constructor(Ee, q10.byteOffset, q10.length);
            }
            function tn(q10, re) {
              if (q10 !== re) {
                var Ee = q10 !== n6, Je = q10 === null, St = q10 === q10, rn = Rd(q10), Gn = re !== n6, Yn = re === null, Cr = re === re, aa = Rd(re);
                if (!Yn && !aa && !rn && q10 > re || rn && Gn && Cr && !Yn && !aa || Je && Gn && Cr || !Ee && Cr || !St)
                  return 1;
                if (!Je && !rn && !aa && q10 < re || aa && Ee && St && !Je && !rn || Yn && Ee && St || !Gn && St || !Cr)
                  return -1;
              }
              return 0;
            }
            function Fn(q10, re, Ee) {
              for (var Je = -1, St = q10.criteria, rn = re.criteria, Gn = St.length, Yn = Ee.length; ++Je < Gn; ) {
                var Cr = tn(St[Je], rn[Je]);
                if (Cr) {
                  if (Je >= Yn)
                    return Cr;
                  var aa = Ee[Je];
                  return Cr * (aa == "desc" ? -1 : 1);
                }
              }
              return q10.index - re.index;
            }
            function Un(q10, re, Ee, Je) {
              for (var St = -1, rn = q10.length, Gn = Ee.length, Yn = -1, Cr = re.length, aa = Sv(rn - Gn, 0), oa = hi(Cr + aa), ua = !Je; ++Yn < Cr; )
                oa[Yn] = re[Yn];
              for (; ++St < Gn; )
                (ua || St < rn) && (oa[Ee[St]] = q10[St]);
              for (; aa--; )
                oa[Yn++] = q10[St++];
              return oa;
            }
            function qn(q10, re, Ee, Je) {
              for (var St = -1, rn = q10.length, Gn = -1, Yn = Ee.length, Cr = -1, aa = re.length, oa = Sv(rn - Yn, 0), ua = hi(oa + aa), bo = !Je; ++St < oa; )
                ua[St] = q10[St];
              for (var os = St; ++Cr < aa; )
                ua[os + Cr] = re[Cr];
              for (; ++Gn < Yn; )
                (bo || St < rn) && (ua[os + Ee[Gn]] = q10[St++]);
              return ua;
            }
            function nr(q10, re) {
              var Ee = -1, Je = q10.length;
              for (re || (re = hi(Je)); ++Ee < Je; )
                re[Ee] = q10[Ee];
              return re;
            }
            function sr(q10, re, Ee, Je) {
              var St = !Ee;
              Ee || (Ee = {});
              for (var rn = -1, Gn = re.length; ++rn < Gn; ) {
                var Yn = re[rn], Cr = Je ? Je(Ee[Yn], q10[Yn], Yn, Ee, q10) : n6;
                Cr === n6 && (Cr = q10[Yn]), St ? PC(Ee, Yn, Cr) : L4(Ee, Yn, Cr);
              }
              return Ee;
            }
            function Ii(q10, re) {
              return sr(q10, Jm(q10), re);
            }
            function gi(q10, re) {
              return sr(q10, qi(q10), re);
            }
            function Sa(q10, re) {
              return function(Ee, Je) {
                var St = Pl(Ee) ? wV : _Te, rn = re ? re() : {};
                return St(Ee, q10, ws(Je, 2), rn);
              };
            }
            function Tt(q10) {
              return Wu(function(re, Ee) {
                var Je = -1, St = Ee.length, rn = St > 1 ? Ee[St - 1] : n6, Gn = St > 2 ? Ee[2] : n6;
                for (rn = q10.length > 3 && typeof rn == "function" ? (St--, rn) : n6, Gn && lc(Ee[0], Ee[1], Gn) && (rn = St < 3 ? n6 : rn, St = 1), re = Mf(re); ++Je < St; ) {
                  var Yn = Ee[Je];
                  Yn && q10(re, Yn, Je, rn);
                }
                return re;
              });
            }
            function Ar(q10, re) {
              return function(Ee, Je) {
                if (Ee == null)
                  return Ee;
                if (!ir(Ee))
                  return q10(Ee, Je);
                for (var St = Ee.length, rn = re ? St : -1, Gn = Mf(Ee); (re ? rn-- : ++rn < St) && Je(Gn[rn], rn, Gn) !== false; )
                  ;
                return Ee;
              };
            }
            function Vr(q10) {
              return function(re, Ee, Je) {
                for (var St = -1, rn = Mf(re), Gn = Je(re), Yn = Gn.length; Yn--; ) {
                  var Cr = Gn[q10 ? Yn : ++St];
                  if (Ee(rn[Cr], Cr, rn) === false)
                    break;
                }
                return re;
              };
            }
            function Si(q10, re, Ee) {
              var Je = re & ee, St = Gr(q10);
              function rn() {
                var Gn = this && this !== ng && this instanceof rn ? St : q10;
                return Gn.apply(Je ? Ee : this, arguments);
              }
              return rn;
            }
            function mi(q10) {
              return function(re) {
                re = mf(re);
                var Ee = S3(re) ? yx(re) : n6, Je = Ee ? Ee[0] : re.charAt(0), St = Ee ? Se(Ee, 1).join("") : re.slice(1);
                return Je[q10]() + St;
              };
            }
            function Dr(q10) {
              return function(re) {
                return SV(UC(kB(re).replace(Jse, "")), q10, "");
              };
            }
            function Gr(q10) {
              return function() {
                var re = arguments;
                switch (re.length) {
                  case 0:
                    return new q10();
                  case 1:
                    return new q10(re[0]);
                  case 2:
                    return new q10(re[0], re[1]);
                  case 3:
                    return new q10(re[0], re[1], re[2]);
                  case 4:
                    return new q10(re[0], re[1], re[2], re[3]);
                  case 5:
                    return new q10(re[0], re[1], re[2], re[3], re[4]);
                  case 6:
                    return new q10(re[0], re[1], re[2], re[3], re[4], re[5]);
                  case 7:
                    return new q10(re[0], re[1], re[2], re[3], re[4], re[5], re[6]);
                }
                var Ee = ZE(q10.prototype), Je = q10.apply(Ee, re);
                return oh(Je) ? Je : Ee;
              };
            }
            function Vi(q10, re, Ee) {
              var Je = Gr(q10);
              function St() {
                for (var rn = arguments.length, Gn = hi(rn), Yn = rn, Cr = z0(St); Yn--; )
                  Gn[Yn] = arguments[Yn];
                var aa = rn < 3 && Gn[0] !== Cr && Gn[rn - 1] !== Cr ? [] : EC(Gn, Cr);
                if (rn -= aa.length, rn < Ee)
                  return Ta(q10, re, Ro, St.placeholder, n6, Gn, aa, n6, n6, Ee - rn);
                var oa = this && this !== ng && this instanceof St ? Je : q10;
                return tb(oa, this, Gn);
              }
              return St;
            }
            function ya(q10) {
              return function(re, Ee, Je) {
                var St = Mf(re);
                if (!ir(re)) {
                  var rn = ws(Ee, 3);
                  re = kp(re), Ee = function(Yn) {
                    return rn(St[Yn], Yn, St);
                  };
                }
                var Gn = q10(re, Ee, Je);
                return Gn > -1 ? St[rn ? re[Gn] : Gn] : n6;
              };
            }
            function xr(q10) {
              return vp(function(re) {
                var Ee = re.length, Je = Ee, St = Uy.prototype.thru;
                for (q10 && re.reverse(); Je--; ) {
                  var rn = re[Je];
                  if (typeof rn != "function")
                    throw new Yb(_);
                  if (St && !Gn && Ed(rn) == "wrapper")
                    var Gn = new Uy([], true);
                }
                for (Je = Gn ? Je : Ee; ++Je < Ee; ) {
                  rn = re[Je];
                  var Yn = Ed(rn), Cr = Yn == "wrapper" ? $y(rn) : n6;
                  Cr && Mv(Cr[0]) && Cr[1] == (je | _e | Ve | Xe) && !Cr[4].length && Cr[9] == 1 ? Gn = Gn[Ed(Cr[0])].apply(Gn, Cr[3]) : Gn = rn.length == 1 && Mv(rn) ? Gn[Yn]() : Gn.thru(rn);
                }
                return function() {
                  var aa = arguments, oa = aa[0];
                  if (Gn && aa.length == 1 && Pl(oa))
                    return Gn.plant(oa).value();
                  for (var ua = 0, bo = Ee ? re[ua].apply(this, aa) : oa; ++ua < Ee; )
                    bo = re[ua].call(this, bo);
                  return bo;
                };
              });
            }
            function Ro(q10, re, Ee, Je, St, rn, Gn, Yn, Cr, aa) {
              var oa = re & je, ua = re & ee, bo = re & oe, os = re & (_e | pe), Rs = re & Ye, su = bo ? n6 : Gr(q10);
              function Us() {
                for (var Qs = arguments.length, Yl = hi(Qs), Kg = Qs; Kg--; )
                  Yl[Kg] = arguments[Kg];
                if (os)
                  var lg = z0(Us), ge = IV(Yl, lg);
                if (Je && (Yl = Un(Yl, Je, St, os)), rn && (Yl = qn(Yl, rn, Gn, os)), Qs -= ge, os && Qs < aa) {
                  var He = EC(Yl, lg);
                  return Ta(q10, re, Ro, Us.placeholder, Ee, Yl, He, Yn, Cr, aa - Qs);
                }
                var we = ua ? Ee : this, Me = bo ? we[q10] : q10;
                return Qs = Yl.length, Yn ? Yl = Cx(Yl, Yn) : Rs && Qs > 1 && Yl.reverse(), oa && Cr < Qs && (Yl.length = Cr), this && this !== ng && this instanceof Us && (Me = su || Gr(Me)), Me.apply(we, Yl);
              }
              return Us;
            }
            function Oo(q10, re) {
              return function(Ee, Je) {
                return fl(Ee, q10, re(Je), {});
              };
            }
            function pi(q10, re) {
              return function(Ee, Je) {
                var St;
                if (Ee === n6 && Je === n6)
                  return re;
                if (Ee !== n6 && (St = Ee), Je !== n6) {
                  if (St === n6)
                    return Je;
                  typeof Ee == "string" || typeof Je == "string" ? (Ee = rb2(Ee), Je = rb2(Je)) : (Ee = mY(Ee), Je = mY(Je)), St = q10(Ee, Je);
                }
                return St;
              };
            }
            function xs(q10) {
              return vp(function(re) {
                return re = Tp(re, L0(ws())), Wu(function(Ee) {
                  var Je = this;
                  return q10(re, function(St) {
                    return tb(St, Je, Ee);
                  });
                });
              });
            }
            function Ti(q10, re) {
              re = re === n6 ? " " : rb2(re);
              var Ee = re.length;
              if (Ee < 2)
                return Ee ? $V(re, q10) : re;
              var Je = $V(re, NV(q10 / M3(re)));
              return S3(re) ? Se(yx(Je), 0, q10).join("") : Je.slice(0, q10);
            }
            function si(q10, re, Ee, Je) {
              var St = re & ee, rn = Gr(q10);
              function Gn() {
                for (var Yn = -1, Cr = arguments.length, aa = -1, oa = Je.length, ua = hi(oa + Cr), bo = this && this !== ng && this instanceof Gn ? rn : q10; ++aa < oa; )
                  ua[aa] = Je[aa];
                for (; Cr--; )
                  ua[aa++] = arguments[++Yn];
                return tb(bo, St ? Ee : this, ua);
              }
              return Gn;
            }
            function ni(q10) {
              return function(re, Ee, Je) {
                return Je && typeof Je != "number" && lc(re, Ee, Je) && (Ee = Je = n6), re = Ox(re), Ee === n6 ? (Ee = re, re = 0) : Ee = Ox(Ee), Je = Je === n6 ? re < Ee ? 1 : -1 : Ox(Je), ITe(re, Ee, Je, q10);
              };
            }
            function ja(q10) {
              return function(re, Ee) {
                return typeof re == "string" && typeof Ee == "string" || (re = U0(re), Ee = U0(Ee)), q10(re, Ee);
              };
            }
            function Ta(q10, re, Ee, Je, St, rn, Gn, Yn, Cr, aa) {
              var oa = re & _e, ua = oa ? Gn : n6, bo = oa ? n6 : Gn, os = oa ? rn : n6, Rs = oa ? n6 : rn;
              re |= oa ? Ve : Le, re &= ~(oa ? Le : Ve), re & fe || (re &= ~(ee | oe));
              var su = [q10, re, St, os, ua, Rs, bo, Yn, Cr, aa], Us = Ee.apply(n6, su);
              return Mv(q10) && Mx(Us, su), Us.placeholder = Je, nA(Us, q10, re);
            }
            function Ws(q10) {
              var re = Id[q10];
              return function(Ee, Je) {
                if (Ee = U0(Ee), Je = Je == null ? 0 : N0(Rl(Je), 292), Je && gle(Ee)) {
                  var St = (mf(Ee) + "e").split("e"), rn = re(St[0] + "e" + (+St[1] + Je));
                  return St = (mf(rn) + "e").split("e"), +(St[0] + "e" + (+St[1] - Je));
                }
                return re(Ee);
              };
            }
            var Uu = QT && 1 / C3(new QT([, -0]))[1] == er ? function(q10) {
              return new QT(q10);
            } : Gs;
            function Su(q10) {
              return function(re) {
                var Ee = Rr(re);
                return Ee == ms ? YX(re) : Ee == rh ? jMe(re) : TV(re, q10(re));
              };
            }
            function hl(q10, re, Ee, Je, St, rn, Gn, Yn) {
              var Cr = re & oe;
              if (!Cr && typeof q10 != "function")
                throw new Yb(_);
              var aa = Je ? Je.length : 0;
              if (aa || (re &= ~(Ve | Le), Je = St = n6), Gn = Gn === n6 ? Gn : Sv(Rl(Gn), 0), Yn = Yn === n6 ? Yn : Rl(Yn), aa -= St ? St.length : 0, re & Le) {
                var oa = Je, ua = St;
                Je = St = n6;
              }
              var bo = Cr ? n6 : $y(q10), os = [q10, re, Ee, Je, St, oa, ua, rn, Gn, Yn];
              if (bo && j0(os, bo), q10 = os[0], re = os[1], Ee = os[2], Je = os[3], St = os[4], Yn = os[9] = os[9] === n6 ? Cr ? 0 : q10.length : Sv(os[9] - aa, 0), !Yn && re & (_e | pe) && (re &= ~(_e | pe)), !re || re == ee)
                var Rs = Si(q10, re, Ee);
              else
                re == _e || re == pe ? Rs = Vi(q10, re, Yn) : (re == Ve || re == (ee | Ve)) && !St.length ? Rs = si(q10, re, Ee, Je) : Rs = Ro.apply(n6, os);
              var su = bo ? Nle : Mx;
              return nA(su(Rs, os), q10, re);
            }
            function Tf(q10, re, Ee, Je) {
              return q10 === n6 || $g(q10, I3[Ee]) && !$f.call(Je, Ee) ? re : q10;
            }
            function Cu(q10, re, Ee, Je, St, rn) {
              return oh(q10) && oh(re) && (rn.set(re, q10), tA(q10, re, n6, Cu, rn), rn.delete(re)), q10;
            }
            function Lc(q10) {
              return i1(q10) ? n6 : q10;
            }
            function Eh(q10, re, Ee, Je, St, rn) {
              var Gn = Ee & H, Yn = q10.length, Cr = re.length;
              if (Yn != Cr && !(Gn && Cr > Yn))
                return false;
              var aa = rn.get(q10), oa = rn.get(re);
              if (aa && oa)
                return aa == re && oa == q10;
              var ua = -1, bo = true, os = Ee & Z ? new OC() : n6;
              for (rn.set(q10, re), rn.set(re, q10); ++ua < Yn; ) {
                var Rs = q10[ua], su = re[ua];
                if (Je)
                  var Us = Gn ? Je(su, Rs, ua, re, q10, rn) : Je(Rs, su, ua, q10, re, rn);
                if (Us !== n6) {
                  if (Us)
                    continue;
                  bo = false;
                  break;
                }
                if (os) {
                  if (!ld(re, function(Qs, Yl) {
                    if (!YT(os, Yl) && (Rs === Qs || St(Rs, Qs, Ee, Je, rn)))
                      return os.push(Yl);
                  })) {
                    bo = false;
                    break;
                  }
                } else if (!(Rs === su || St(Rs, su, Ee, Je, rn))) {
                  bo = false;
                  break;
                }
              }
              return rn.delete(q10), rn.delete(re), bo;
            }
            function B0(q10, re, Ee, Je, St, rn, Gn) {
              switch (Ee) {
                case na:
                  if (q10.byteLength != re.byteLength || q10.byteOffset != re.byteOffset)
                    return false;
                  q10 = q10.buffer, re = re.buffer;
                case Yr:
                  return !(q10.byteLength != re.byteLength || !rn(new T4(q10), new T4(re)));
                case Fa:
                case po:
                case sc:
                  return $g(+q10, +re);
                case Ya:
                  return q10.name == re.name && q10.message == re.message;
                case Vg:
                case Mp:
                  return q10 == re + "";
                case ms:
                  var Yn = YX;
                case rh:
                  var Cr = Je & H;
                  if (Yn || (Yn = C3), q10.size != re.size && !Cr)
                    return false;
                  var aa = Gn.get(q10);
                  if (aa)
                    return aa == re;
                  Je |= Z, Gn.set(q10, re);
                  var oa = Eh(Yn(q10), Yn(re), Je, St, rn, Gn);
                  return Gn.delete(q10), oa;
                case fp:
                  if (mx)
                    return mx.call(q10) == mx.call(re);
              }
              return false;
            }
            function qy(q10, re, Ee, Je, St, rn) {
              var Gn = Ee & H, Yn = Ap(q10), Cr = Yn.length, aa = Ap(re), oa = aa.length;
              if (Cr != oa && !Gn)
                return false;
              for (var ua = Cr; ua--; ) {
                var bo = Yn[ua];
                if (!(Gn ? bo in re : $f.call(re, bo)))
                  return false;
              }
              var os = rn.get(q10), Rs = rn.get(re);
              if (os && Rs)
                return os == re && Rs == q10;
              var su = true;
              rn.set(q10, re), rn.set(re, q10);
              for (var Us = Gn; ++ua < Cr; ) {
                bo = Yn[ua];
                var Qs = q10[bo], Yl = re[bo];
                if (Je)
                  var Kg = Gn ? Je(Yl, Qs, bo, re, q10, rn) : Je(Qs, Yl, bo, q10, re, rn);
                if (!(Kg === n6 ? Qs === Yl || St(Qs, Yl, Ee, Je, rn) : Kg)) {
                  su = false;
                  break;
                }
                Us || (Us = bo == "constructor");
              }
              if (su && !Us) {
                var lg = q10.constructor, ge = re.constructor;
                lg != ge && "constructor" in q10 && "constructor" in re && !(typeof lg == "function" && lg instanceof lg && typeof ge == "function" && ge instanceof ge) && (su = false);
              }
              return rn.delete(q10), rn.delete(re), su;
            }
            function vp(q10) {
              return aD(G0(q10, n6, Oh), q10 + "");
            }
            function Ap(q10) {
              return cY(q10, kp, Jm);
            }
            function ig(q10) {
              return cY(q10, Bt, qi);
            }
            var $y = F0 ? function(q10) {
              return F0.get(q10);
            } : Gs;
            function Ed(q10) {
              for (var re = q10.name + "", Ee = KE[re], Je = $f.call(KE, re) ? Ee.length : 0; Je--; ) {
                var St = Ee[Je], rn = St.func;
                if (rn == null || rn == q10)
                  return St.name;
              }
              return re;
            }
            function z0(q10) {
              var re = $f.call(Wt, "placeholder") ? Wt : q10;
              return re.placeholder;
            }
            function ws() {
              var q10 = Wt.iteratee || Zy;
              return q10 = q10 === Zy ? nD : q10, arguments.length ? q10(arguments[0], arguments[1]) : q10;
            }
            function ag(q10, re) {
              var Ee = q10.__data__;
              return Cv(re) ? Ee[typeof re == "string" ? "string" : "hash"] : Ee.map;
            }
            function gp(q10) {
              for (var re = kp(q10), Ee = re.length; Ee--; ) {
                var Je = re[Ee], St = q10[Je];
                re[Ee] = [Je, St, Ou(St)];
              }
              return re;
            }
            function Yh(q10, re) {
              var Ee = kV(q10, re);
              return B4(Ee) ? Ee : n6;
            }
            function Ip(q10) {
              var re = $f.call(q10, Kb), Ee = q10[Kb];
              try {
                q10[Kb] = n6;
                var Je = true;
              } catch {
              }
              var St = M4.call(q10);
              return Je && (re ? q10[Kb] = Ee : delete q10[Kb]), St;
            }
            var Jm = QX ? function(q10) {
              return q10 == null ? [] : (q10 = Mf(q10), $T(QX(q10), function(re) {
                return LV.call(q10, re);
              }));
            } : n_, qi = QX ? function(q10) {
              for (var re = []; q10; )
                XT(re, Jm(q10)), q10 = A4(q10);
              return re;
            } : n_, Rr = V0;
            (E4 && Rr(new E4(new ArrayBuffer(1))) != na || D4 && Rr(new D4()) != ms || XE && Rr(XE.resolve()) != _v || QT && Rr(new QT()) != rh || YE && Rr(new YE()) != ea) && (Rr = function(q10) {
              var re = V0(q10), Ee = re == _c2 ? q10.constructor : n6, Je = Ee ? Ot(Ee) : "";
              if (Je)
                switch (Je) {
                  case mle:
                    return na;
                  case nTe:
                    return ms;
                  case ble:
                    return _v;
                  case rTe:
                    return rh;
                  case Qd:
                    return ea;
                }
              return re;
            });
            function qr(q10, re, Ee) {
              for (var Je = -1, St = Ee.length; ++Je < St; ) {
                var rn = Ee[Je], Gn = rn.size;
                switch (rn.type) {
                  case "drop":
                    q10 += Gn;
                    break;
                  case "dropRight":
                    re -= Gn;
                    break;
                  case "take":
                    re = N0(re, q10 + Gn);
                    break;
                  case "takeRight":
                    q10 = Sv(q10, re - Gn);
                    break;
                }
              }
              return { start: q10, end: re };
            }
            function Yi(q10) {
              var re = q10.match(FX);
              return re ? re[1].split(VX) : [];
            }
            function to(q10, re, Ee) {
              re = Ge(re, q10);
              for (var Je = -1, St = re.length, rn = false; ++Je < St; ) {
                var Gn = Dn(re[Je]);
                if (!(rn = q10 != null && Ee(q10, Gn)))
                  break;
                q10 = q10[Gn];
              }
              return rn || ++Je != St ? rn : (St = q10 == null ? 0 : q10.length, !!St && Yf(St) && Sc(Gn, St) && (Pl(q10) || H0(q10)));
            }
            function is(q10) {
              var re = q10.length, Ee = new q10.constructor(re);
              return re && typeof q10[0] == "string" && $f.call(q10, "index") && (Ee.index = q10.index, Ee.input = q10.input), Ee;
            }
            function Bl(q10) {
              return typeof q10.constructor == "function" && !ih(q10) ? ZE(A4(q10)) : {};
            }
            function zl(q10, re, Ee) {
              var Je = q10.constructor;
              switch (re) {
                case Yr:
                  return at(q10);
                case Fa:
                case po:
                  return new Je(+q10);
                case na:
                  return ft(q10, Ee);
                case lo:
                case hs:
                case du:
                case au:
                case pf:
                case hp:
                case Ah:
                case Td:
                case Ih:
                  return Pt(q10, Ee);
                case ms:
                  return new Je();
                case sc:
                case Mp:
                  return new Je(q10);
                case Vg:
                  return st(q10);
                case rh:
                  return new Je();
                case fp:
                  return Dt(q10);
              }
            }
            function $c(q10, re) {
              var Ee = re.length;
              if (!Ee)
                return q10;
              var Je = Ee - 1;
              return re[Je] = (Ee > 1 ? "& " : "") + re[Je], re = re.join(Ee > 2 ? ", " : " "), q10.replace(NX, `{
/* [wrapped with ` + re + `] */
`);
            }
            function Dh(q10) {
              return Pl(q10) || H0(q10) || !!(vle && q10 && q10[vle]);
            }
            function Sc(q10, re) {
              var Ee = typeof q10;
              return re = re == null ? un : re, !!re && (Ee == "number" || Ee != "symbol" && Er.test(q10)) && q10 > -1 && q10 % 1 == 0 && q10 < re;
            }
            function lc(q10, re, Ee) {
              if (!oh(Ee))
                return false;
              var Je = typeof re;
              return (Je == "number" ? ir(Ee) && Sc(re, Ee.length) : Je == "string" && re in Ee) ? $g(Ee[re], q10) : false;
            }
            function Af(q10, re) {
              if (Pl(q10))
                return false;
              var Ee = typeof q10;
              return Ee == "number" || Ee == "symbol" || Ee == "boolean" || q10 == null || Rd(q10) ? true : Q1.test(q10) || !Hy.test(q10) || re != null && q10 in Mf(re);
            }
            function Cv(q10) {
              var re = typeof q10;
              return re == "string" || re == "number" || re == "symbol" || re == "boolean" ? q10 !== "__proto__" : q10 === null;
            }
            function Mv(q10) {
              var re = Ed(q10), Ee = Wt[re];
              if (typeof Ee != "function" || !(re in wc.prototype))
                return false;
              if (q10 === Ee)
                return true;
              var Je = $y(Ee);
              return !!Je && q10 === Je[0];
            }
            function Qm(q10) {
              return !!hle && hle in q10;
            }
            var Hg = E3 ? Kh : w6;
            function ih(q10) {
              var re = q10 && q10.constructor, Ee = typeof re == "function" && re.prototype || I3;
              return q10 === Ee;
            }
            function Ou(q10) {
              return q10 === q10 && !oh(q10);
            }
            function ud(q10, re) {
              return function(Ee) {
                return Ee == null ? false : Ee[q10] === re && (re !== n6 || q10 in Mf(Ee));
              };
            }
            function Tv(q10) {
              var re = zC(q10, function(Je) {
                return Ee.size === E && Ee.clear(), Je;
              }), Ee = re.cache;
              return re;
            }
            function j0(q10, re) {
              var Ee = q10[1], Je = re[1], St = Ee | Je, rn = St < (ee | oe | je), Gn = Je == je && Ee == _e || Je == je && Ee == Xe && q10[7].length <= re[8] || Je == (je | Xe) && re[7].length <= re[8] && Ee == _e;
              if (!(rn || Gn))
                return q10;
              Je & ee && (q10[2] = re[2], St |= Ee & ee ? 0 : fe);
              var Yn = re[3];
              if (Yn) {
                var Cr = q10[3];
                q10[3] = Cr ? Un(Cr, Yn, re[4]) : Yn, q10[4] = Cr ? EC(q10[3], O) : re[4];
              }
              return Yn = re[5], Yn && (Cr = q10[5], q10[5] = Cr ? qn(Cr, Yn, re[6]) : Yn, q10[6] = Cr ? EC(q10[5], O) : re[6]), Yn = re[7], Yn && (q10[7] = Yn), Je & je && (q10[8] = q10[8] == null ? re[8] : N0(q10[8], re[8])), q10[9] == null && (q10[9] = re[9]), q10[0] = re[0], q10[1] = St, q10;
            }
            function Wg(q10) {
              var re = [];
              if (q10 != null)
                for (var Ee in Mf(q10))
                  re.push(Ee);
              return re;
            }
            function Ug(q10) {
              return M4.call(q10);
            }
            function G0(q10, re, Ee) {
              return re = Sv(re === n6 ? q10.length - 1 : re, 0), function() {
                for (var Je = arguments, St = -1, rn = Sv(Je.length - re, 0), Gn = hi(rn); ++St < rn; )
                  Gn[St] = Je[re + St];
                St = -1;
                for (var Yn = hi(re + 1); ++St < re; )
                  Yn[St] = Je[St];
                return Yn[re] = Ee(Gn), tb(q10, this, Yn);
              };
            }
            function Sx(q10, re) {
              return re.length < 2 ? q10 : eD(q10, Qb(re, 0, -1));
            }
            function Cx(q10, re) {
              for (var Ee = q10.length, Je = N0(re.length, Ee), St = nr(q10); Je--; ) {
                var rn = re[Je];
                q10[Je] = Sc(rn, Ee) ? St[rn] : n6;
              }
              return q10;
            }
            function iD(q10, re) {
              if (!(re === "constructor" && typeof q10[re] == "function") && re != "__proto__")
                return q10[re];
            }
            var Mx = L3(Nle), LC = YMe || function(q10, re) {
              return ng.setTimeout(q10, re);
            }, aD = L3(Fle);
            function nA(q10, re, Ee) {
              var Je = re + "";
              return aD(q10, $c(Je, gn(Yi(Je), Ee)));
            }
            function L3(q10) {
              var re = 0, Ee = 0;
              return function() {
                var Je = QMe(), St = dt - (Je - Ee);
                if (Ee = Je, St > 0) {
                  if (++re >= wt)
                    return arguments[0];
                } else
                  re = 0;
                return q10.apply(n6, arguments);
              };
            }
            function e_(q10, re) {
              var Ee = -1, Je = q10.length, St = Je - 1;
              for (re = re === n6 ? Je : re; ++Ee < re; ) {
                var rn = yY(Ee, St), Gn = q10[rn];
                q10[rn] = q10[Ee], q10[Ee] = Gn;
              }
              return q10.length = re, q10;
            }
            var dn = Tv(function(q10) {
              var re = [];
              return q10.charCodeAt(0) === 46 && re.push(""), q10.replace(IS, function(Ee, Je, St, rn) {
                re.push(St ? rn.replace(Pn, "$1") : Je || Ee);
              }), re;
            });
            function Dn(q10) {
              if (typeof q10 == "string" || Rd(q10))
                return q10;
              var re = q10 + "";
              return re == "0" && 1 / q10 == -er ? "-0" : re;
            }
            function Ot(q10) {
              if (q10 != null) {
                try {
                  return R0.call(q10);
                } catch {
                }
                try {
                  return q10 + "";
                } catch {
                }
              }
              return "";
            }
            function gn(q10, re) {
              return Km(Ja, function(Ee) {
                var Je = "_." + Ee[0];
                re & Ee[1] && !$E(q10, Je) && q10.push(Je);
              }), q10.sort();
            }
            function wn(q10) {
              if (q10 instanceof wc)
                return q10.clone();
              var re = new Uy(q10.__wrapped__, q10.__chain__);
              return re.__actions__ = nr(q10.__actions__), re.__index__ = q10.__index__, re.__values__ = q10.__values__, re;
            }
            function Fr(q10, re, Ee) {
              (Ee ? lc(q10, re, Ee) : re === n6) ? re = 1 : re = Sv(Rl(re), 0);
              var Je = q10 == null ? 0 : q10.length;
              if (!Je || re < 1)
                return [];
              for (var St = 0, rn = 0, Gn = hi(NV(Je / re)); St < Je; )
                Gn[rn++] = Qb(q10, St, St += re);
              return Gn;
            }
            function Ri(q10) {
              for (var re = -1, Ee = q10 == null ? 0 : q10.length, Je = 0, St = []; ++re < Ee; ) {
                var rn = q10[re];
                rn && (St[Je++] = rn);
              }
              return St;
            }
            function di() {
              var q10 = arguments.length;
              if (!q10)
                return [];
              for (var re = hi(q10 - 1), Ee = arguments[0], Je = q10; Je--; )
                re[Je - 1] = arguments[Je];
              return XT(Pl(Ee) ? nr(Ee) : [Ee], jg(re, 1));
            }
            var ur = Wu(function(q10, re) {
              return li(q10) ? N4(q10, jg(re, 1, li, true)) : [];
            }), xa = Wu(function(q10, re) {
              var Ee = Ep(re);
              return li(Ee) && (Ee = n6), li(q10) ? N4(q10, jg(re, 1, li, true), ws(Ee, 2)) : [];
            }), Go = Wu(function(q10, re) {
              var Ee = Ep(re);
              return li(Ee) && (Ee = n6), li(q10) ? N4(q10, jg(re, 1, li, true), n6, Ee) : [];
            });
            function ou(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              return Je ? (re = Ee || re === n6 ? 1 : Rl(re), Qb(q10, re < 0 ? 0 : re, Je)) : [];
            }
            function Xl(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              return Je ? (re = Ee || re === n6 ? 1 : Rl(re), re = Je - re, Qb(q10, 0, re < 0 ? 0 : re)) : [];
            }
            function El(q10, re) {
              return q10 && q10.length ? ZV(q10, ws(re, 3), true, true) : [];
            }
            function js(q10, re) {
              return q10 && q10.length ? ZV(q10, ws(re, 3), true) : [];
            }
            function vf(q10, re, Ee, Je) {
              var St = q10 == null ? 0 : q10.length;
              return St ? (Ee && typeof Ee != "number" && lc(q10, re, Ee) && (Ee = 0, Je = St), lY(q10, re, Ee, Je)) : [];
            }
            function kh(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              if (!Je)
                return -1;
              var St = Ee == null ? 0 : Rl(Ee);
              return St < 0 && (St = Sv(Je + St, 0)), x32(q10, ws(re, 3), St);
            }
            function pl(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              if (!Je)
                return -1;
              var St = Je - 1;
              return Ee !== n6 && (St = Rl(Ee), St = Ee < 0 ? Sv(Je + St, 0) : N0(St, Je - 1)), x32(q10, ws(re, 3), St, true);
            }
            function Oh(q10) {
              var re = q10 == null ? 0 : q10.length;
              return re ? jg(q10, 1) : [];
            }
            function Av(q10) {
              var re = q10 == null ? 0 : q10.length;
              return re ? jg(q10, er) : [];
            }
            function ib(q10, re) {
              var Ee = q10 == null ? 0 : q10.length;
              return Ee ? (re = re === n6 ? 1 : Rl(re), jg(q10, re)) : [];
            }
            function RS(q10) {
              for (var re = -1, Ee = q10 == null ? 0 : q10.length, Je = {}; ++re < Ee; ) {
                var St = q10[re];
                Je[St[0]] = St[1];
              }
              return Je;
            }
            function e1(q10) {
              return q10 && q10.length ? q10[0] : n6;
            }
            function RC(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              if (!Je)
                return -1;
              var St = Ee == null ? 0 : Rl(Ee);
              return St < 0 && (St = Sv(Je + St, 0)), IC(q10, re, St);
            }
            function Tx(q10) {
              var re = q10 == null ? 0 : q10.length;
              return re ? Qb(q10, 0, -1) : [];
            }
            var Dd = Wu(function(q10) {
              var re = Tp(q10, _Y);
              return re.length && re[0] === q10[0] ? hY(re) : [];
            }), ab = Wu(function(q10) {
              var re = Ep(q10), Ee = Tp(q10, _Y);
              return re === Ep(Ee) ? re = n6 : Ee.pop(), Ee.length && Ee[0] === q10[0] ? hY(Ee, ws(re, 2)) : [];
            }), kd = Wu(function(q10) {
              var re = Ep(q10), Ee = Tp(q10, _Y);
              return re = typeof re == "function" ? re : n6, re && Ee.pop(), Ee.length && Ee[0] === q10[0] ? hY(Ee, n6, re) : [];
            });
            function t_(q10, re) {
              return q10 == null ? "" : ZMe.call(q10, re);
            }
            function Ep(q10) {
              var re = q10 == null ? 0 : q10.length;
              return re ? q10[re - 1] : n6;
            }
            function NC(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              if (!Je)
                return -1;
              var St = Je;
              return Ee !== n6 && (St = Rl(Ee), St = St < 0 ? Sv(Je + St, 0) : N0(St, Je - 1)), re === re ? HMe(q10, re, St) : x32(q10, MV, St, true);
            }
            function oD(q10, re) {
              return q10 && q10.length ? vY(q10, Rl(re)) : n6;
            }
            var Xy = Wu(Ax);
            function Ax(q10, re) {
              return q10 && q10.length && re && re.length ? qV(q10, re) : q10;
            }
            function Ix(q10, re, Ee) {
              return q10 && q10.length && re && re.length ? qV(q10, re, ws(Ee, 2)) : q10;
            }
            function ev(q10, re, Ee) {
              return q10 && q10.length && re && re.length ? qV(q10, re, n6, Ee) : q10;
            }
            var sD = vp(function(q10, re) {
              var Ee = q10 == null ? 0 : q10.length, Je = VV(q10, re);
              return rD(q10, Tp(re, function(St) {
                return Sc(St, Ee) ? +St : St;
              }).sort(tn)), Je;
            });
            function ob(q10, re) {
              var Ee = [];
              if (!(q10 && q10.length))
                return Ee;
              var Je = -1, St = [], rn = q10.length;
              for (re = ws(re, 3); ++Je < rn; ) {
                var Gn = q10[Je];
                re(Gn, Je, q10) && (Ee.push(Gn), St.push(Je));
              }
              return rD(q10, St), Ee;
            }
            function NS(q10) {
              return q10 == null ? q10 : tTe.call(q10);
            }
            function FC(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              return Je ? (Ee && typeof Ee != "number" && lc(q10, re, Ee) ? (re = 0, Ee = Je) : (re = re == null ? 0 : Rl(re), Ee = Ee === n6 ? Je : Rl(Ee)), Qb(q10, re, Ee)) : [];
            }
            function QV(q10, re) {
              return YV(q10, re);
            }
            function eB(q10, re, Ee) {
              return KV(q10, re, ws(Ee, 2));
            }
            function xY(q10, re) {
              var Ee = q10 == null ? 0 : q10.length;
              if (Ee) {
                var Je = YV(q10, re);
                if (Je < Ee && $g(q10[Je], re))
                  return Je;
              }
              return -1;
            }
            function j4(q10, re) {
              return YV(q10, re, true);
            }
            function G4(q10, re, Ee) {
              return KV(q10, re, ws(Ee, 2), true);
            }
            function tB(q10, re) {
              var Ee = q10 == null ? 0 : q10.length;
              if (Ee) {
                var Je = YV(q10, re, true) - 1;
                if ($g(q10[Je], re))
                  return Je;
              }
              return -1;
            }
            function H4(q10) {
              return q10 && q10.length ? Vle(q10) : [];
            }
            function R3(q10, re) {
              return q10 && q10.length ? Vle(q10, ws(re, 2)) : [];
            }
            function wY(q10) {
              var re = q10 == null ? 0 : q10.length;
              return re ? Qb(q10, 1, re) : [];
            }
            function nB(q10, re, Ee) {
              return q10 && q10.length ? (re = Ee || re === n6 ? 1 : Rl(re), Qb(q10, 0, re < 0 ? 0 : re)) : [];
            }
            function W4(q10, re, Ee) {
              var Je = q10 == null ? 0 : q10.length;
              return Je ? (re = Ee || re === n6 ? 1 : Rl(re), re = Je - re, Qb(q10, re < 0 ? 0 : re, Je)) : [];
            }
            function rB(q10, re) {
              return q10 && q10.length ? ZV(q10, ws(re, 3), false, true) : [];
            }
            function U4(q10, re) {
              return q10 && q10.length ? ZV(q10, ws(re, 3)) : [];
            }
            var q4 = Wu(function(q10) {
              return LS(jg(q10, 1, li, true));
            }), og = Wu(function(q10) {
              var re = Ep(q10);
              return li(re) && (re = n6), LS(jg(q10, 1, li, true), ws(re, 2));
            }), lD = Wu(function(q10) {
              var re = Ep(q10);
              return re = typeof re == "function" ? re : n6, LS(jg(q10, 1, li, true), n6, re);
            });
            function iB(q10) {
              return q10 && q10.length ? LS(q10) : [];
            }
            function SY(q10, re) {
              return q10 && q10.length ? LS(q10, ws(re, 2)) : [];
            }
            function CY(q10, re) {
              return re = typeof re == "function" ? re : n6, q10 && q10.length ? LS(q10, n6, re) : [];
            }
            function t1(q10) {
              if (!(q10 && q10.length))
                return [];
              var re = 0;
              return q10 = $T(q10, function(Ee) {
                if (li(Ee))
                  return re = Sv(Ee.length, re), true;
              }), x4(re, function(Ee) {
                return Tp(q10, m4(Ee));
              });
            }
            function $4(q10, re) {
              if (!(q10 && q10.length))
                return [];
              var Ee = t1(q10);
              return re == null ? Ee : Tp(Ee, function(Je) {
                return tb(re, n6, Je);
              });
            }
            var Ph = Wu(function(q10, re) {
              return li(q10) ? N4(q10, re) : [];
            }), Xf = Wu(function(q10) {
              return JV($T(q10, li));
            }), X4 = Wu(function(q10) {
              var re = Ep(q10);
              return li(re) && (re = n6), JV($T(q10, li), ws(re, 2));
            }), aB = Wu(function(q10) {
              var re = Ep(q10);
              return re = typeof re == "function" ? re : n6, JV($T(q10, li), n6, re);
            }), Y4 = Wu(t1);
            function MY(q10, re) {
              return jle(q10 || [], re || [], L4);
            }
            function oB(q10, re) {
              return jle(q10 || [], re || [], z4);
            }
            var TY = Wu(function(q10) {
              var re = q10.length, Ee = re > 1 ? q10[re - 1] : n6;
              return Ee = typeof Ee == "function" ? (q10.pop(), Ee) : n6, $4(q10, Ee);
            });
            function N3(q10) {
              var re = Wt(q10);
              return re.__chain__ = true, re;
            }
            function sB(q10, re) {
              return re(q10), q10;
            }
            function Dp(q10, re) {
              return re(q10);
            }
            var F3 = vp(function(q10) {
              var re = q10.length, Ee = re ? q10[0] : 0, Je = this.__wrapped__, St = function(rn) {
                return VV(rn, q10);
              };
              return re > 1 || this.__actions__.length || !(Je instanceof wc) || !Sc(Ee) ? this.thru(St) : (Je = Je.slice(Ee, +Ee + (re ? 1 : 0)), Je.__actions__.push({ func: Dp, args: [St], thisArg: n6 }), new Uy(Je, this.__chain__).thru(function(rn) {
                return re && !rn.length && rn.push(n6), rn;
              }));
            });
            function FS() {
              return N3(this);
            }
            function lB() {
              return new Uy(this.value(), this.__chain__);
            }
            function K4() {
              this.__values__ === n6 && (this.__values__ = SB(this.value()));
              var q10 = this.__index__ >= this.__values__.length, re = q10 ? n6 : this.__values__[this.__index__++];
              return { done: q10, value: re };
            }
            function n1() {
              return this;
            }
            function rA(q10) {
              for (var re, Ee = this; Ee instanceof k4; ) {
                var Je = wn(Ee);
                Je.__index__ = 0, Je.__values__ = n6, re ? St.__wrapped__ = Je : re = Je;
                var St = Je;
                Ee = Ee.__wrapped__;
              }
              return St.__wrapped__ = q10, re;
            }
            function uB() {
              var q10 = this.__wrapped__;
              if (q10 instanceof wc) {
                var re = q10;
                return this.__actions__.length && (re = new wc(this)), re = re.reverse(), re.__actions__.push({ func: Dp, args: [NS], thisArg: n6 }), new Uy(re, this.__chain__);
              }
              return this.thru(NS);
            }
            function cB() {
              return zle(this.__wrapped__, this.__actions__);
            }
            var uD = Sa(function(q10, re, Ee) {
              $f.call(q10, Ee) ? ++q10[Ee] : PC(q10, Ee, 1);
            });
            function V3(q10, re, Ee) {
              var Je = Pl(q10) ? ule : Ele;
              return Ee && lc(q10, re, Ee) && (re = n6), Je(q10, ws(re, 3));
            }
            function Z4(q10, re) {
              var Ee = Pl(q10) ? $T : D3;
              return Ee(q10, ws(re, 3));
            }
            var Yy = ya(kh), AY = ya(pl);
            function qg(q10, re) {
              return jg(VS(q10, re), 1);
            }
            function IY(q10, re) {
              return jg(VS(q10, re), er);
            }
            function fB(q10, re, Ee) {
              return Ee = Ee === n6 ? 1 : Rl(Ee), jg(VS(q10, re), Ee);
            }
            function Ex(q10, re) {
              var Ee = Pl(q10) ? Km : eA;
              return Ee(q10, ws(re, 3));
            }
            function iA(q10, re) {
              var Ee = Pl(q10) ? lle : Ile;
              return Ee(q10, ws(re, 3));
            }
            var J4 = Sa(function(q10, re, Ee) {
              $f.call(q10, Ee) ? q10[Ee].push(re) : PC(q10, Ee, [re]);
            });
            function jl(q10, re, Ee, Je) {
              q10 = ir(q10) ? q10 : hA(q10), Ee = Ee && !Je ? Rl(Ee) : 0;
              var St = q10.length;
              return Ee < 0 && (Ee = Sv(St + Ee, 0)), mD(q10) ? Ee <= St && q10.indexOf(re, Ee) > -1 : !!St && IC(q10, re, Ee) > -1;
            }
            var r1 = Wu(function(q10, re, Ee) {
              var Je = -1, St = typeof re == "function", rn = ir(q10) ? hi(q10.length) : [];
              return eA(q10, function(Gn) {
                rn[++Je] = St ? tb(re, Gn, Ee) : k32(Gn, re, Ee);
              }), rn;
            }), B3 = Sa(function(q10, re, Ee) {
              PC(q10, Ee, re);
            });
            function VS(q10, re) {
              var Ee = Pl(q10) ? Tp : Lle;
              return Ee(q10, ws(re, 3));
            }
            function cD(q10, re, Ee, Je) {
              return q10 == null ? [] : (Pl(re) || (re = re == null ? [] : [re]), Ee = Je ? n6 : Ee, Pl(Ee) || (Ee = Ee == null ? [] : [Ee]), gY(q10, re, Ee));
            }
            var Q4 = Sa(function(q10, re, Ee) {
              q10[Ee ? 0 : 1].push(re);
            }, function() {
              return [[], []];
            });
            function z32(q10, re, Ee) {
              var Je = Pl(q10) ? SV : Nf, St = arguments.length < 3;
              return Je(q10, ws(re, 4), Ee, St, eA);
            }
            function EY(q10, re, Ee) {
              var Je = Pl(q10) ? NMe : Nf, St = arguments.length < 3;
              return Je(q10, ws(re, 4), Ee, St, Ile);
            }
            function j3(q10, re) {
              var Ee = Pl(q10) ? $T : D3;
              return Ee(q10, H3(ws(re, 3)));
            }
            function G3(q10) {
              var re = Pl(q10) ? P4 : XV;
              return re(q10);
            }
            function BS(q10, re, Ee) {
              (Ee ? lc(q10, re, Ee) : re === n6) ? re = 1 : re = Rl(re);
              var Je = Pl(q10) ? mTe : ETe;
              return Je(q10, re);
            }
            function e6(q10) {
              var re = Pl(q10) ? bTe : DTe;
              return re(q10);
            }
            function gf(q10) {
              if (q10 == null)
                return 0;
              if (ir(q10))
                return mD(q10) ? M3(q10) : q10.length;
              var re = Rr(q10);
              return re == ms || re == rh ? q10.size : P3(q10).length;
            }
            function Od(q10, re, Ee) {
              var Je = Pl(q10) ? ld : kTe;
              return Ee && lc(q10, re, Ee) && (re = n6), Je(q10, ws(re, 3));
            }
            var fD = Wu(function(q10, re) {
              if (q10 == null)
                return [];
              var Ee = re.length;
              return Ee > 1 && lc(q10, re[0], re[1]) ? re = [] : Ee > 2 && lc(re[0], re[1], re[2]) && (re = [re[0]]), gY(q10, jg(re, 1), []);
            }), zS = Pc || function() {
              return ng.Date.now();
            };
            function hD(q10, re) {
              if (typeof re != "function")
                throw new Yb(_);
              return q10 = Rl(q10), function() {
                if (--q10 < 1)
                  return re.apply(this, arguments);
              };
            }
            function pD(q10, re, Ee) {
              return re = Ee ? n6 : re, re = q10 && re == null ? q10.length : re, hl(q10, je, n6, n6, n6, n6, re);
            }
            function VC(q10, re) {
              var Ee;
              if (typeof re != "function")
                throw new Yb(_);
              return q10 = Rl(q10), function() {
                return --q10 > 0 && (Ee = re.apply(this, arguments)), q10 <= 1 && (re = n6), Ee;
              };
            }
            var jS = Wu(function(q10, re, Ee) {
              var Je = ee;
              if (Ee.length) {
                var St = EC(Ee, z0(jS));
                Je |= Ve;
              }
              return hl(q10, Je, re, Ee, St);
            }), dD = Wu(function(q10, re, Ee) {
              var Je = ee | oe;
              if (Ee.length) {
                var St = EC(Ee, z0(dD));
                Je |= Ve;
              }
              return hl(re, Je, q10, Ee, St);
            });
            function vD(q10, re, Ee) {
              re = Ee ? n6 : re;
              var Je = hl(q10, _e, n6, n6, n6, n6, n6, re);
              return Je.placeholder = vD.placeholder, Je;
            }
            function Iv(q10, re, Ee) {
              re = Ee ? n6 : re;
              var Je = hl(q10, pe, n6, n6, n6, n6, n6, re);
              return Je.placeholder = Iv.placeholder, Je;
            }
            function BC(q10, re, Ee) {
              var Je, St, rn, Gn, Yn, Cr, aa = 0, oa = false, ua = false, bo = true;
              if (typeof q10 != "function")
                throw new Yb(_);
              re = U0(re) || 0, oh(Ee) && (oa = !!Ee.leading, ua = "maxWait" in Ee, rn = ua ? Sv(U0(Ee.maxWait) || 0, re) : rn, bo = "trailing" in Ee ? !!Ee.trailing : bo);
              function os(He) {
                var we = Je, Me = St;
                return Je = St = n6, aa = He, Gn = q10.apply(Me, we), Gn;
              }
              function Rs(He) {
                return aa = He, Yn = LC(Qs, re), oa ? os(He) : Gn;
              }
              function su(He) {
                var we = He - Cr, Me = He - aa, Te = re - we;
                return ua ? N0(Te, rn - Me) : Te;
              }
              function Us(He) {
                var we = He - Cr, Me = He - aa;
                return Cr === n6 || we >= re || we < 0 || ua && Me >= rn;
              }
              function Qs() {
                var He = zS();
                if (Us(He))
                  return Yl(He);
                Yn = LC(Qs, su(He));
              }
              function Yl(He) {
                return Yn = n6, bo && Je ? os(He) : (Je = St = n6, Gn);
              }
              function Kg() {
                Yn !== n6 && Ce(Yn), aa = 0, Je = Cr = St = Yn = n6;
              }
              function lg() {
                return Yn === n6 ? Gn : Yl(zS());
              }
              function ge() {
                var He = zS(), we = Us(He);
                if (Je = arguments, St = this, Cr = He, we) {
                  if (Yn === n6)
                    return Rs(Cr);
                  if (ua)
                    return Ce(Yn), Yn = LC(Qs, re), os(Cr);
                }
                return Yn === n6 && (Yn = LC(Qs, re)), Gn;
              }
              return ge.cancel = Kg, ge.flush = lg, ge;
            }
            var GS = Wu(function(q10, re) {
              return Ale(q10, 1, re);
            }), hB = Wu(function(q10, re, Ee) {
              return Ale(q10, U0(re) || 0, Ee);
            });
            function gD(q10) {
              return hl(q10, Ye);
            }
            function zC(q10, re) {
              if (typeof q10 != "function" || re != null && typeof re != "function")
                throw new Yb(_);
              var Ee = function() {
                var Je = arguments, St = re ? re.apply(this, Je) : Je[0], rn = Ee.cache;
                if (rn.has(St))
                  return rn.get(St);
                var Gn = q10.apply(this, Je);
                return Ee.cache = rn.set(St, Gn) || rn, Gn;
              };
              return Ee.cache = new (zC.Cache || _x)(), Ee;
            }
            zC.Cache = _x;
            function H3(q10) {
              if (typeof q10 != "function")
                throw new Yb(_);
              return function() {
                var re = arguments;
                switch (re.length) {
                  case 0:
                    return !q10.call(this);
                  case 1:
                    return !q10.call(this, re[0]);
                  case 2:
                    return !q10.call(this, re[0], re[1]);
                  case 3:
                    return !q10.call(this, re[0], re[1], re[2]);
                }
                return !q10.apply(this, re);
              };
            }
            function DY(q10) {
              return VC(2, q10);
            }
            var kY = xe(function(q10, re) {
              re = re.length == 1 && Pl(re[0]) ? Tp(re[0], L0(ws())) : Tp(jg(re, 1), L0(ws()));
              var Ee = re.length;
              return Wu(function(Je) {
                for (var St = -1, rn = N0(Je.length, Ee); ++St < rn; )
                  Je[St] = re[St].call(this, Je[St]);
                return tb(q10, this, Je);
              });
            }), t6 = Wu(function(q10, re) {
              var Ee = EC(re, z0(t6));
              return hl(q10, Ve, n6, re, Ee);
            }), Pd = Wu(function(q10, re) {
              var Ee = EC(re, z0(Pd));
              return hl(q10, Le, n6, re, Ee);
            }), pB = vp(function(q10, re) {
              return hl(q10, Xe, n6, n6, n6, re);
            });
            function n62(q10, re) {
              if (typeof q10 != "function")
                throw new Yb(_);
              return re = re === n6 ? re : Rl(re), Wu(q10, re);
            }
            function r6(q10, re) {
              if (typeof q10 != "function")
                throw new Yb(_);
              return re = re == null ? 0 : Sv(Rl(re), 0), Wu(function(Ee) {
                var Je = Ee[re], St = Se(Ee, 0, re);
                return Je && XT(St, Je), tb(q10, this, St);
              });
            }
            function dB(q10, re, Ee) {
              var Je = true, St = true;
              if (typeof q10 != "function")
                throw new Yb(_);
              return oh(Ee) && (Je = "leading" in Ee ? !!Ee.leading : Je, St = "trailing" in Ee ? !!Ee.trailing : St), BC(q10, re, { leading: Je, maxWait: re, trailing: St });
            }
            function HS(q10) {
              return pD(q10, 1);
            }
            function W3(q10, re) {
              return t6(ye(re), q10);
            }
            function OY() {
              if (!arguments.length)
                return [];
              var q10 = arguments[0];
              return Pl(q10) ? q10 : [q10];
            }
            function vB(q10) {
              return Jb(q10, z3);
            }
            function PY(q10, re) {
              return re = typeof re == "function" ? re : n6, Jb(q10, z3, re);
            }
            function vu(q10) {
              return Jb(q10, R | z3);
            }
            function sg(q10, re) {
              return re = typeof re == "function" ? re : n6, Jb(q10, R | z3, re);
            }
            function ah(q10, re) {
              return re == null || Tle(q10, re, kp(re));
            }
            function $g(q10, re) {
              return q10 === re || q10 !== q10 && re !== re;
            }
            var i6 = ja(jV), gB = ja(function(q10, re) {
              return q10 >= re;
            }), H0 = Ole(function() {
              return arguments;
            }()) ? Ole : function(q10) {
              return sh(q10) && $f.call(q10, "callee") && !LV.call(q10, "callee");
            }, Pl = hi.isArray, Dx = $X ? L0($X) : xTe;
            function ir(q10) {
              return q10 != null && Yf(q10.length) && !Kh(q10);
            }
            function li(q10) {
              return sh(q10) && ir(q10);
            }
            function ui(q10) {
              return q10 === true || q10 === false || sh(q10) && V0(q10) == Fa;
            }
            var go = KMe || w6, Ll = ile ? L0(ile) : wTe;
            function Rc(q10) {
              return sh(q10) && q10.nodeType === 1 && !i1(q10);
            }
            function Ld(q10) {
              if (q10 == null)
                return true;
              if (ir(q10) && (Pl(q10) || typeof q10 == "string" || typeof q10.splice == "function" || go(q10) || kx(q10) || H0(q10)))
                return !q10.length;
              var re = Rr(q10);
              if (re == ms || re == rh)
                return !q10.size;
              if (ih(q10))
                return !P3(q10).length;
              for (var Ee in q10)
                if ($f.call(q10, Ee))
                  return false;
              return true;
            }
            function If(q10, re) {
              return O3(q10, re);
            }
            function a6(q10, re, Ee) {
              Ee = typeof Ee == "function" ? Ee : n6;
              var Je = Ee ? Ee(q10, re) : n6;
              return Je === n6 ? O3(q10, re, n6, Ee) : !!Je;
            }
            function o6(q10) {
              if (!sh(q10))
                return false;
              var re = V0(q10);
              return re == Ya || re == To || typeof q10.message == "string" && typeof q10.name == "string" && !i1(q10);
            }
            function W0(q10) {
              return typeof q10 == "number" && gle(q10);
            }
            function Kh(q10) {
              if (!oh(q10))
                return false;
              var re = V0(q10);
              return re == $o || re == Hu || re == So || re == cp;
            }
            function yB(q10) {
              return typeof q10 == "number" && q10 == Rl(q10);
            }
            function Yf(q10) {
              return typeof q10 == "number" && q10 > -1 && q10 % 1 == 0 && q10 <= un;
            }
            function oh(q10) {
              var re = typeof q10;
              return q10 != null && (re == "object" || re == "function");
            }
            function sh(q10) {
              return q10 != null && typeof q10 == "object";
            }
            var yf = ale ? L0(ale) : tD;
            function mB(q10, re) {
              return q10 === re || V4(q10, re, gp(re));
            }
            function bB(q10, re, Ee) {
              return Ee = typeof Ee == "function" ? Ee : n6, V4(q10, re, gp(re), Ee);
            }
            function U3(q10) {
              return aA(q10) && q10 != +q10;
            }
            function LY(q10) {
              if (Hg(q10))
                throw new cl(y4);
              return B4(q10);
            }
            function _B(q10) {
              return q10 === null;
            }
            function xB(q10) {
              return q10 == null;
            }
            function aA(q10) {
              return typeof q10 == "number" || sh(q10) && V0(q10) == sc;
            }
            function i1(q10) {
              if (!sh(q10) || V0(q10) != _c2)
                return false;
              var re = A4(q10);
              if (re === null)
                return true;
              var Ee = $f.call(re, "constructor") && re.constructor;
              return typeof Ee == "function" && Ee instanceof Ee && R0.call(Ee) == qMe;
            }
            var WS = ole ? L0(ole) : STe;
            function oA(q10) {
              return yB(q10) && q10 >= -un && q10 <= un;
            }
            var yD = _3 ? L0(_3) : Ple;
            function mD(q10) {
              return typeof q10 == "string" || !Pl(q10) && sh(q10) && V0(q10) == Mp;
            }
            function Rd(q10) {
              return typeof q10 == "symbol" || sh(q10) && V0(q10) == fp;
            }
            var kx = sle ? L0(sle) : CTe;
            function wB(q10) {
              return q10 === n6;
            }
            function gu(q10) {
              return sh(q10) && Rr(q10) == ea;
            }
            function jC(q10) {
              return sh(q10) && V0(q10) == Qr;
            }
            var q3 = ja(WV), RY = ja(function(q10, re) {
              return q10 <= re;
            });
            function SB(q10) {
              if (!q10)
                return [];
              if (ir(q10))
                return mD(q10) ? yx(q10) : nr(q10);
              if (I4 && q10[I4])
                return zMe(q10[I4]());
              var re = Rr(q10), Ee = re == ms ? YX : re == rh ? C3 : hA;
              return Ee(q10);
            }
            function Ox(q10) {
              if (!q10)
                return q10 === 0 ? q10 : 0;
              if (q10 = U0(q10), q10 === er || q10 === -er) {
                var re = q10 < 0 ? -1 : 1;
                return re * pn;
              }
              return q10 === q10 ? q10 : 0;
            }
            function Rl(q10) {
              var re = Ox(q10), Ee = re % 1;
              return re === re ? Ee ? re - Ee : re : 0;
            }
            function bD(q10) {
              return q10 ? QE(Rl(q10), 0, fr) : 0;
            }
            function U0(q10) {
              if (typeof q10 == "number")
                return q10;
              if (Rd(q10))
                return On;
              if (oh(q10)) {
                var re = typeof q10.valueOf == "function" ? q10.valueOf() : q10;
                q10 = oh(re) ? re + "" : re;
              }
              if (typeof q10 != "string")
                return q10 === 0 ? q10 : +q10;
              q10 = w4(q10);
              var Ee = Br.test(q10);
              return Ee || yi.test(q10) ? rle(q10.slice(2), Ee ? 2 : 8) : fn.test(q10) ? On : +q10;
            }
            function CB(q10) {
              return sr(q10, Bt(q10));
            }
            function MB(q10) {
              return q10 ? QE(Rl(q10), -un, un) : q10 === 0 ? q10 : 0;
            }
            function mf(q10) {
              return q10 == null ? "" : rb2(q10);
            }
            var NY = Tt(function(q10, re) {
              if (ih(re) || ir(re)) {
                sr(re, kp(re), q10);
                return;
              }
              for (var Ee in re)
                $f.call(re, Ee) && L4(q10, Ee, re[Ee]);
            }), cd = Tt(function(q10, re) {
              sr(re, Bt(re), q10);
            }), Nd = Tt(function(q10, re, Ee, Je) {
              sr(re, Bt(re), q10, Je);
            }), s6 = Tt(function(q10, re, Ee, Je) {
              sr(re, kp(re), q10, Je);
            }), FY = vp(VV);
            function sA(q10, re) {
              var Ee = ZE(q10);
              return re == null ? Ee : oY(Ee, re);
            }
            var l6 = Wu(function(q10, re) {
              q10 = Mf(q10);
              var Ee = -1, Je = re.length, St = Je > 2 ? re[2] : n6;
              for (St && lc(re[0], re[1], St) && (Je = 1); ++Ee < Je; )
                for (var rn = re[Ee], Gn = Bt(rn), Yn = -1, Cr = Gn.length; ++Yn < Cr; ) {
                  var aa = Gn[Yn], oa = q10[aa];
                  (oa === n6 || $g(oa, I3[aa]) && !$f.call(q10, aa)) && (q10[aa] = rn[aa]);
                }
              return q10;
            }), _D = Wu(function(q10) {
              return q10.push(n6, Cu), tb(qu, n6, q10);
            });
            function Px(q10, re) {
              return CV(q10, ws(re, 3), Gg);
            }
            function Xg(q10, re) {
              return CV(q10, ws(re, 3), BV);
            }
            function GC(q10, re) {
              return q10 == null ? q10 : uY(q10, ws(re, 3), Bt);
            }
            function lA(q10, re) {
              return q10 == null ? q10 : Dle(q10, ws(re, 3), Bt);
            }
            function xD(q10, re) {
              return q10 && Gg(q10, ws(re, 3));
            }
            function wD(q10, re) {
              return q10 && BV(q10, ws(re, 3));
            }
            function uA(q10) {
              return q10 == null ? [] : zV(q10, kp(q10));
            }
            function fd(q10) {
              return q10 == null ? [] : zV(q10, Bt(q10));
            }
            function US(q10, re, Ee) {
              var Je = q10 == null ? n6 : eD(q10, re);
              return Je === n6 ? Ee : Je;
            }
            function HC(q10, re) {
              return q10 != null && to(q10, re, fY);
            }
            function $3(q10, re) {
              return q10 != null && to(q10, re, kle);
            }
            var SD = Oo(function(q10, re, Ee) {
              re != null && typeof re.toString != "function" && (re = M4.call(re)), q10[re] = Ee;
            }, g6(Yg)), CD = Oo(function(q10, re, Ee) {
              re != null && typeof re.toString != "function" && (re = M4.call(re)), $f.call(q10, re) ? q10[re].push(Ee) : q10[re] = [Ee];
            }, ws), cA = Wu(k32);
            function kp(q10) {
              return ir(q10) ? Mle(q10) : P3(q10);
            }
            function Bt(q10) {
              return ir(q10) ? Mle(q10, true) : pY(q10);
            }
            function fA(q10, re) {
              var Ee = {};
              return re = ws(re, 3), Gg(q10, function(Je, St, rn) {
                PC(Ee, re(Je, St, rn), Je);
              }), Ee;
            }
            function X3(q10, re) {
              var Ee = {};
              return re = ws(re, 3), Gg(q10, function(Je, St, rn) {
                PC(Ee, St, re(Je, St, rn));
              }), Ee;
            }
            var Ky = Tt(function(q10, re, Ee) {
              tA(q10, re, Ee);
            }), qu = Tt(function(q10, re, Ee, Je) {
              tA(q10, re, Ee, Je);
            }), VY = vp(function(q10, re) {
              var Ee = {};
              if (q10 == null)
                return Ee;
              var Je = false;
              re = Tp(re, function(rn) {
                return rn = Ge(rn, q10), Je || (Je = rn.length > 1), rn;
              }), sr(q10, ig(q10), Ee), Je && (Ee = Jb(Ee, R | V | z3, Lc));
              for (var St = re.length; St--; )
                bY(Ee, re[St]);
              return Ee;
            });
            function u6(q10, re) {
              return qS(q10, H3(ws(re)));
            }
            var c6 = vp(function(q10, re) {
              return q10 == null ? {} : TTe(q10, re);
            });
            function qS(q10, re) {
              if (q10 == null)
                return {};
              var Ee = Tp(ig(q10), function(Je) {
                return [Je];
              });
              return re = ws(re), Rle(q10, Ee, function(Je, St) {
                return re(Je, St[0]);
              });
            }
            function BY(q10, re, Ee) {
              re = Ge(re, q10);
              var Je = -1, St = re.length;
              for (St || (St = 1, q10 = n6); ++Je < St; ) {
                var rn = q10 == null ? n6 : q10[Dn(re[Je])];
                rn === n6 && (Je = St, rn = Ee), q10 = Kh(rn) ? rn.call(q10) : rn;
              }
              return q10;
            }
            function f62(q10, re, Ee) {
              return q10 == null ? q10 : z4(q10, re, Ee);
            }
            function zY(q10, re, Ee, Je) {
              return Je = typeof Je == "function" ? Je : n6, q10 == null ? q10 : z4(q10, re, Ee, Je);
            }
            var Y3 = Su(kp), TB = Su(Bt);
            function hd(q10, re, Ee) {
              var Je = Pl(q10), St = Je || go(q10) || kx(q10);
              if (re = ws(re, 4), Ee == null) {
                var rn = q10 && q10.constructor;
                St ? Ee = Je ? new rn() : [] : oh(q10) ? Ee = Kh(rn) ? ZE(A4(q10)) : {} : Ee = {};
              }
              return (St ? Km : Gg)(q10, function(Gn, Yn, Cr) {
                return re(Ee, Gn, Yn, Cr);
              }), Ee;
            }
            function AB(q10, re) {
              return q10 == null ? true : bY(q10, re);
            }
            function h6(q10, re, Ee) {
              return q10 == null ? q10 : Ble(q10, re, ye(Ee));
            }
            function IB(q10, re, Ee, Je) {
              return Je = typeof Je == "function" ? Je : n6, q10 == null ? q10 : Ble(q10, re, ye(Ee), Je);
            }
            function hA(q10) {
              return q10 == null ? [] : w32(q10, kp(q10));
            }
            function jY(q10) {
              return q10 == null ? [] : w32(q10, Bt(q10));
            }
            function Lx(q10, re, Ee) {
              return Ee === n6 && (Ee = re, re = n6), Ee !== n6 && (Ee = U0(Ee), Ee = Ee === Ee ? Ee : 0), re !== n6 && (re = U0(re), re = re === re ? re : 0), QE(U0(q10), re, Ee);
            }
            function EB(q10, re, Ee) {
              return re = Ox(re), Ee === n6 ? (Ee = re, re = 0) : Ee = Ox(Ee), q10 = U0(q10), GV(q10, re, Ee);
            }
            function p6(q10, re, Ee) {
              if (Ee && typeof Ee != "boolean" && lc(q10, re, Ee) && (re = Ee = n6), Ee === n6 && (typeof re == "boolean" ? (Ee = re, re = n6) : typeof q10 == "boolean" && (Ee = q10, q10 = n6)), q10 === n6 && re === n6 ? (q10 = 0, re = 1) : (q10 = Ox(q10), re === n6 ? (re = q10, q10 = 0) : re = Ox(re)), q10 > re) {
                var Je = q10;
                q10 = re, re = Je;
              }
              if (Ee || q10 % 1 || re % 1) {
                var St = yle();
                return N0(q10 + St * (re - q10 + WX("1e-" + ((St + "").length - 1))), re);
              }
              return yY(q10, re);
            }
            var MD = Dr(function(q10, re, Ee) {
              return re = re.toLowerCase(), q10 + (Ee ? DB(re) : re);
            });
            function DB(q10) {
              return TD(mf(q10).toLowerCase());
            }
            function kB(q10) {
              return q10 = mf(q10), q10 && q10.replace(_a2, EV).replace(Qse, "");
            }
            function $S(q10, re, Ee) {
              q10 = mf(q10), re = rb2(re);
              var Je = q10.length;
              Ee = Ee === n6 ? Je : QE(Rl(Ee), 0, Je);
              var St = Ee;
              return Ee -= re.length, Ee >= 0 && q10.slice(Ee, St) == re;
            }
            function d6(q10) {
              return q10 = mf(q10), q10 && xv.test(q10) ? q10.replace($p, VMe) : q10;
            }
            function GY(q10) {
              return q10 = mf(q10), q10 && LX.test(q10) ? q10.replace(ES, "\\$&") : q10;
            }
            var sb = Dr(function(q10, re, Ee) {
              return q10 + (Ee ? "-" : "") + re.toLowerCase();
            }), HY = Dr(function(q10, re, Ee) {
              return q10 + (Ee ? " " : "") + re.toLowerCase();
            }), WY = mi("toLowerCase");
            function K3(q10, re, Ee) {
              q10 = mf(q10), re = Rl(re);
              var Je = re ? M3(q10) : 0;
              if (!re || Je >= re)
                return q10;
              var St = (re - Je) / 2;
              return Ti(FV(St), Ee) + q10 + Ti(NV(St), Ee);
            }
            function UY(q10, re, Ee) {
              q10 = mf(q10), re = Rl(re);
              var Je = re ? M3(q10) : 0;
              return re && Je < re ? q10 + Ti(re - Je, Ee) : q10;
            }
            function qY(q10, re, Ee) {
              q10 = mf(q10), re = Rl(re);
              var Je = re ? M3(q10) : 0;
              return re && Je < re ? Ti(re - Je, Ee) + q10 : q10;
            }
            function OB(q10, re, Ee) {
              return Ee || re == null ? re = 0 : re && (re = +re), eTe(mf(q10).replace(HT, ""), re || 0);
            }
            function PB(q10, re, Ee) {
              return (Ee ? lc(q10, re, Ee) : re === n6) ? re = 1 : re = Rl(re), $V(mf(q10), re);
            }
            function LB() {
              var q10 = arguments, re = mf(q10[0]);
              return q10.length < 3 ? re : re.replace(q10[1], q10[2]);
            }
            var $Y = Dr(function(q10, re, Ee) {
              return q10 + (Ee ? "_" : "") + re.toLowerCase();
            });
            function Z3(q10, re, Ee) {
              return Ee && typeof Ee != "number" && lc(q10, re, Ee) && (re = Ee = n6), Ee = Ee === n6 ? fr : Ee >>> 0, Ee ? (q10 = mf(q10), q10 && (typeof re == "string" || re != null && !WS(re)) && (re = rb2(re), !re && S3(q10)) ? Se(yx(q10), 0, Ee) : q10.split(re, Ee)) : [];
            }
            var Ev = Dr(function(q10, re, Ee) {
              return q10 + (Ee ? " " : "") + TD(re);
            });
            function J3(q10, re, Ee) {
              return q10 = mf(q10), Ee = Ee == null ? 0 : QE(Rl(Ee), 0, q10.length), re = rb2(re), q10.slice(Ee, Ee + re.length) == re;
            }
            function RB(q10, re, Ee) {
              var Je = Wt.templateSettings;
              Ee && lc(q10, re, Ee) && (re = n6), q10 = mf(q10), re = Nd({}, re, Je, Tf);
              var St = Nd({}, re.imports, Je.imports, Tf), rn = kp(St), Gn = w32(St, rn), Yn, Cr, aa = 0, oa = re.interpolate || rs, ua = "__p += '", bo = ZX((re.escape || rs).source + "|" + oa.source + "|" + (oa === Xm ? Kt : rs).source + "|" + (re.evaluate || rs).source + "|$", "g"), os = "//# sourceURL=" + ($f.call(re, "sourceURL") ? (re.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++ele + "]") + `
`;
              q10.replace(bo, function(Us, Qs, Yl, Kg, lg, ge) {
                return Yl || (Yl = Kg), ua += q10.slice(aa, ge).replace(wu, DV), Qs && (Yn = true, ua += `' +
__e(` + Qs + `) +
'`), lg && (Cr = true, ua += `';
` + lg + `;
__p += '`), Yl && (ua += `' +
((__t = (` + Yl + `)) == null ? '' : __t) +
'`), aa = ge + Us.length, Us;
              }), ua += `';
`;
              var Rs = $f.call(re, "variable") && re.variable;
              if (!Rs)
                ua = `with (obj) {
` + ua + `
}
`;
              else if (En.test(Rs))
                throw new cl(S);
              ua = (Cr ? ua.replace(k0, "") : ua).replace(jy, "$1").replace(J1, "$1;"), ua = "function(" + (Rs || "obj") + `) {
` + (Rs ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (Yn ? ", __e = _.escape" : "") + (Cr ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + ua + `return __p
}`;
              var su = ub(function() {
                return Cf(rn, os + "return " + ua).apply(n6, Gn);
              });
              if (su.source = ua, o6(su))
                throw su;
              return su;
            }
            function NB(q10) {
              return mf(q10).toLowerCase();
            }
            function XY2(q10) {
              return mf(q10).toUpperCase();
            }
            function lb2(q10, re, Ee) {
              if (q10 = mf(q10), q10 && (Ee || re === n6))
                return w4(q10);
              if (!q10 || !(re = rb2(re)))
                return q10;
              var Je = yx(q10), St = yx(re), rn = AV(Je, St), Gn = S4(Je, St) + 1;
              return Se(Je, rn, Gn).join("");
            }
            function v6(q10, re, Ee) {
              if (q10 = mf(q10), q10 && (Ee || re === n6))
                return q10.slice(0, KX(q10) + 1);
              if (!q10 || !(re = rb2(re)))
                return q10;
              var Je = yx(q10), St = S4(Je, yx(re)) + 1;
              return Se(Je, 0, St).join("");
            }
            function WC(q10, re, Ee) {
              if (q10 = mf(q10), q10 && (Ee || re === n6))
                return q10.replace(HT, "");
              if (!q10 || !(re = rb2(re)))
                return q10;
              var Je = yx(q10), St = AV(Je, yx(re));
              return Se(Je, St).join("");
            }
            function a1(q10, re) {
              var Ee = rt2, Je = ut;
              if (oh(re)) {
                var St = "separator" in re ? re.separator : St;
                Ee = "length" in re ? Rl(re.length) : Ee, Je = "omission" in re ? rb2(re.omission) : Je;
              }
              q10 = mf(q10);
              var rn = q10.length;
              if (S3(q10)) {
                var Gn = yx(q10);
                rn = Gn.length;
              }
              if (Ee >= rn)
                return q10;
              var Yn = Ee - M3(Je);
              if (Yn < 1)
                return Je;
              var Cr = Gn ? Se(Gn, 0, Yn).join("") : q10.slice(0, Yn);
              if (St === n6)
                return Cr + Je;
              if (Gn && (Yn += Cr.length - Yn), WS(St)) {
                if (q10.slice(Yn).search(St)) {
                  var aa, oa = Cr;
                  for (St.global || (St = ZX(St.source, mf(yn.exec(St)) + "g")), St.lastIndex = 0; aa = St.exec(oa); )
                    var ua = aa.index;
                  Cr = Cr.slice(0, ua === n6 ? Yn : ua);
                }
              } else if (q10.indexOf(rb2(St), Yn) != Yn) {
                var bo = Cr.lastIndexOf(St);
                bo > -1 && (Cr = Cr.slice(0, bo));
              }
              return Cr + Je;
            }
            function YY(q10) {
              return q10 = mf(q10), q10 && xc.test(q10) ? q10.replace(Gy, WMe) : q10;
            }
            var FB = Dr(function(q10, re, Ee) {
              return q10 + (Ee ? " " : "") + re.toUpperCase();
            }), TD = mi("toUpperCase");
            function UC(q10, re, Ee) {
              return q10 = mf(q10), re = Ee ? n6 : re, re === n6 ? BMe(q10) ? dp(q10) : y42(q10) : q10.match(re) || [];
            }
            var ub = Wu(function(q10, re) {
              try {
                return tb(q10, n6, re);
              } catch (Ee) {
                return o6(Ee) ? Ee : new cl(Ee);
              }
            }), pA = vp(function(q10, re) {
              return Km(re, function(Ee) {
                Ee = Dn(Ee), PC(q10, Ee, jS(q10[Ee], q10));
              }), q10;
            });
            function KY(q10) {
              var re = q10 == null ? 0 : q10.length, Ee = ws();
              return q10 = re ? Tp(q10, function(Je) {
                if (typeof Je[1] != "function")
                  throw new Yb(_);
                return [Ee(Je[0]), Je[1]];
              }) : [], Wu(function(Je) {
                for (var St = -1; ++St < re; ) {
                  var rn = q10[St];
                  if (tb(rn[0], this, Je))
                    return tb(rn[1], this, Je);
                }
              });
            }
            function Q3(q10) {
              return sY(Jb(q10, R));
            }
            function g6(q10) {
              return function() {
                return q10;
              };
            }
            function Rx(q10, re) {
              return q10 == null || q10 !== q10 ? re : q10;
            }
            var tv = xr(), y6 = xr(true);
            function Yg(q10) {
              return q10;
            }
            function Zy(q10) {
              return nD(typeof q10 == "function" ? q10 : Jb(q10, R));
            }
            function eO(q10) {
              return dY(Jb(q10, R));
            }
            function AD(q10, re) {
              return UV(q10, Jb(re, R));
            }
            var Nx = Wu(function(q10, re) {
              return function(Ee) {
                return k32(Ee, q10, re);
              };
            }), m6 = Wu(function(q10, re) {
              return function(Ee) {
                return k32(q10, Ee, re);
              };
            });
            function pd(q10, re, Ee) {
              var Je = kp(re), St = zV(re, Je);
              Ee == null && !(oh(re) && (St.length || !Je.length)) && (Ee = re, re = q10, q10 = this, St = zV(re, kp(re)));
              var rn = !(oh(Ee) && "chain" in Ee) || !!Ee.chain, Gn = Kh(q10);
              return Km(St, function(Yn) {
                var Cr = re[Yn];
                q10[Yn] = Cr, Gn && (q10.prototype[Yn] = function() {
                  var aa = this.__chain__;
                  if (rn || aa) {
                    var oa = q10(this.__wrapped__), ua = oa.__actions__ = nr(this.__actions__);
                    return ua.push({ func: Cr, args: arguments, thisArg: q10 }), oa.__chain__ = aa, oa;
                  }
                  return Cr.apply(q10, XT([this.value()], arguments));
                });
              }), q10;
            }
            function b6() {
              return ng._ === this && (ng._ = ple), this;
            }
            function Gs() {
            }
            function VB(q10) {
              return q10 = Rl(q10), Wu(function(re) {
                return vY(re, q10);
              });
            }
            var ZY = xs(Tp), _6 = xs(ule), JY = xs(ld);
            function qC(q10) {
              return Af(q10) ? m4(Dn(q10)) : ATe(q10);
            }
            function ID(q10) {
              return function(re) {
                return q10 == null ? n6 : eD(q10, re);
              };
            }
            var $C = ni(), x6 = ni(true);
            function n_() {
              return [];
            }
            function w6() {
              return false;
            }
            function BB() {
              return {};
            }
            function S6() {
              return "";
            }
            function XC() {
              return true;
            }
            function tO(q10, re) {
              if (q10 = Rl(q10), q10 < 1 || q10 > un)
                return [];
              var Ee = fr, Je = N0(q10, fr);
              re = ws(re), q10 -= fr;
              for (var St = x4(Je, re); ++Ee < q10; )
                re(Ee);
              return St;
            }
            function C6(q10) {
              return Pl(q10) ? Tp(q10, Dn) : Rd(q10) ? [q10] : nr(dn(mf(q10)));
            }
            function zB(q10) {
              var re = ++wv;
              return mf(q10) + re;
            }
            var jB = pi(function(q10, re) {
              return q10 + re;
            }, 0), nO = Ws("ceil"), M6 = pi(function(q10, re) {
              return q10 / re;
            }, 1), YC = Ws("floor");
            function GB(q10) {
              return q10 && q10.length ? F4(q10, Yg, jV) : n6;
            }
            function T6(q10, re) {
              return q10 && q10.length ? F4(q10, ws(re, 2), jV) : n6;
            }
            function A6(q10) {
              return fle(q10, Yg);
            }
            function rO(q10, re) {
              return fle(q10, ws(re, 2));
            }
            function QY(q10) {
              return q10 && q10.length ? F4(q10, Yg, WV) : n6;
            }
            function HB(q10, re) {
              return q10 && q10.length ? F4(q10, ws(re, 2), WV) : n6;
            }
            var I6 = pi(function(q10, re) {
              return q10 * re;
            }, 1), dA = Ws("round"), WB = pi(function(q10, re) {
              return q10 - re;
            }, 0);
            function eK(q10) {
              return q10 && q10.length ? _4(q10, Yg) : 0;
            }
            function iO(q10, re) {
              return q10 && q10.length ? _4(q10, ws(re, 2)) : 0;
            }
            return Wt.after = hD, Wt.ary = pD, Wt.assign = NY, Wt.assignIn = cd, Wt.assignInWith = Nd, Wt.assignWith = s6, Wt.at = FY, Wt.before = VC, Wt.bind = jS, Wt.bindAll = pA, Wt.bindKey = dD, Wt.castArray = OY, Wt.chain = N3, Wt.chunk = Fr, Wt.compact = Ri, Wt.concat = di, Wt.cond = KY, Wt.conforms = Q3, Wt.constant = g6, Wt.countBy = uD, Wt.create = sA, Wt.curry = vD, Wt.curryRight = Iv, Wt.debounce = BC, Wt.defaults = l6, Wt.defaultsDeep = _D, Wt.defer = GS, Wt.delay = hB, Wt.difference = ur, Wt.differenceBy = xa, Wt.differenceWith = Go, Wt.drop = ou, Wt.dropRight = Xl, Wt.dropRightWhile = El, Wt.dropWhile = js, Wt.fill = vf, Wt.filter = Z4, Wt.flatMap = qg, Wt.flatMapDeep = IY, Wt.flatMapDepth = fB, Wt.flatten = Oh, Wt.flattenDeep = Av, Wt.flattenDepth = ib, Wt.flip = gD, Wt.flow = tv, Wt.flowRight = y6, Wt.fromPairs = RS, Wt.functions = uA, Wt.functionsIn = fd, Wt.groupBy = J4, Wt.initial = Tx, Wt.intersection = Dd, Wt.intersectionBy = ab, Wt.intersectionWith = kd, Wt.invert = SD, Wt.invertBy = CD, Wt.invokeMap = r1, Wt.iteratee = Zy, Wt.keyBy = B3, Wt.keys = kp, Wt.keysIn = Bt, Wt.map = VS, Wt.mapKeys = fA, Wt.mapValues = X3, Wt.matches = eO, Wt.matchesProperty = AD, Wt.memoize = zC, Wt.merge = Ky, Wt.mergeWith = qu, Wt.method = Nx, Wt.methodOf = m6, Wt.mixin = pd, Wt.negate = H3, Wt.nthArg = VB, Wt.omit = VY, Wt.omitBy = u6, Wt.once = DY, Wt.orderBy = cD, Wt.over = ZY, Wt.overArgs = kY, Wt.overEvery = _6, Wt.overSome = JY, Wt.partial = t6, Wt.partialRight = Pd, Wt.partition = Q4, Wt.pick = c6, Wt.pickBy = qS, Wt.property = qC, Wt.propertyOf = ID, Wt.pull = Xy, Wt.pullAll = Ax, Wt.pullAllBy = Ix, Wt.pullAllWith = ev, Wt.pullAt = sD, Wt.range = $C, Wt.rangeRight = x6, Wt.rearg = pB, Wt.reject = j3, Wt.remove = ob, Wt.rest = n62, Wt.reverse = NS, Wt.sampleSize = BS, Wt.set = f62, Wt.setWith = zY, Wt.shuffle = e6, Wt.slice = FC, Wt.sortBy = fD, Wt.sortedUniq = H4, Wt.sortedUniqBy = R3, Wt.split = Z3, Wt.spread = r6, Wt.tail = wY, Wt.take = nB, Wt.takeRight = W4, Wt.takeRightWhile = rB, Wt.takeWhile = U4, Wt.tap = sB, Wt.throttle = dB, Wt.thru = Dp, Wt.toArray = SB, Wt.toPairs = Y3, Wt.toPairsIn = TB, Wt.toPath = C6, Wt.toPlainObject = CB, Wt.transform = hd, Wt.unary = HS, Wt.union = q4, Wt.unionBy = og, Wt.unionWith = lD, Wt.uniq = iB, Wt.uniqBy = SY, Wt.uniqWith = CY, Wt.unset = AB, Wt.unzip = t1, Wt.unzipWith = $4, Wt.update = h6, Wt.updateWith = IB, Wt.values = hA, Wt.valuesIn = jY, Wt.without = Ph, Wt.words = UC, Wt.wrap = W3, Wt.xor = Xf, Wt.xorBy = X4, Wt.xorWith = aB, Wt.zip = Y4, Wt.zipObject = MY, Wt.zipObjectDeep = oB, Wt.zipWith = TY, Wt.entries = Y3, Wt.entriesIn = TB, Wt.extend = cd, Wt.extendWith = Nd, pd(Wt, Wt), Wt.add = jB, Wt.attempt = ub, Wt.camelCase = MD, Wt.capitalize = DB, Wt.ceil = nO, Wt.clamp = Lx, Wt.clone = vB, Wt.cloneDeep = vu, Wt.cloneDeepWith = sg, Wt.cloneWith = PY, Wt.conformsTo = ah, Wt.deburr = kB, Wt.defaultTo = Rx, Wt.divide = M6, Wt.endsWith = $S, Wt.eq = $g, Wt.escape = d6, Wt.escapeRegExp = GY, Wt.every = V3, Wt.find = Yy, Wt.findIndex = kh, Wt.findKey = Px, Wt.findLast = AY, Wt.findLastIndex = pl, Wt.findLastKey = Xg, Wt.floor = YC, Wt.forEach = Ex, Wt.forEachRight = iA, Wt.forIn = GC, Wt.forInRight = lA, Wt.forOwn = xD, Wt.forOwnRight = wD, Wt.get = US, Wt.gt = i6, Wt.gte = gB, Wt.has = HC, Wt.hasIn = $3, Wt.head = e1, Wt.identity = Yg, Wt.includes = jl, Wt.indexOf = RC, Wt.inRange = EB, Wt.invoke = cA, Wt.isArguments = H0, Wt.isArray = Pl, Wt.isArrayBuffer = Dx, Wt.isArrayLike = ir, Wt.isArrayLikeObject = li, Wt.isBoolean = ui, Wt.isBuffer = go, Wt.isDate = Ll, Wt.isElement = Rc, Wt.isEmpty = Ld, Wt.isEqual = If, Wt.isEqualWith = a6, Wt.isError = o6, Wt.isFinite = W0, Wt.isFunction = Kh, Wt.isInteger = yB, Wt.isLength = Yf, Wt.isMap = yf, Wt.isMatch = mB, Wt.isMatchWith = bB, Wt.isNaN = U3, Wt.isNative = LY, Wt.isNil = xB, Wt.isNull = _B, Wt.isNumber = aA, Wt.isObject = oh, Wt.isObjectLike = sh, Wt.isPlainObject = i1, Wt.isRegExp = WS, Wt.isSafeInteger = oA, Wt.isSet = yD, Wt.isString = mD, Wt.isSymbol = Rd, Wt.isTypedArray = kx, Wt.isUndefined = wB, Wt.isWeakMap = gu, Wt.isWeakSet = jC, Wt.join = t_, Wt.kebabCase = sb, Wt.last = Ep, Wt.lastIndexOf = NC, Wt.lowerCase = HY, Wt.lowerFirst = WY, Wt.lt = q3, Wt.lte = RY, Wt.max = GB, Wt.maxBy = T6, Wt.mean = A6, Wt.meanBy = rO, Wt.min = QY, Wt.minBy = HB, Wt.stubArray = n_, Wt.stubFalse = w6, Wt.stubObject = BB, Wt.stubString = S6, Wt.stubTrue = XC, Wt.multiply = I6, Wt.nth = oD, Wt.noConflict = b6, Wt.noop = Gs, Wt.now = zS, Wt.pad = K3, Wt.padEnd = UY, Wt.padStart = qY, Wt.parseInt = OB, Wt.random = p6, Wt.reduce = z32, Wt.reduceRight = EY, Wt.repeat = PB, Wt.replace = LB, Wt.result = BY, Wt.round = dA, Wt.runInContext = mr, Wt.sample = G3, Wt.size = gf, Wt.snakeCase = $Y, Wt.some = Od, Wt.sortedIndex = QV, Wt.sortedIndexBy = eB, Wt.sortedIndexOf = xY, Wt.sortedLastIndex = j4, Wt.sortedLastIndexBy = G4, Wt.sortedLastIndexOf = tB, Wt.startCase = Ev, Wt.startsWith = J3, Wt.subtract = WB, Wt.sum = eK, Wt.sumBy = iO, Wt.template = RB, Wt.times = tO, Wt.toFinite = Ox, Wt.toInteger = Rl, Wt.toLength = bD, Wt.toLower = NB, Wt.toNumber = U0, Wt.toSafeInteger = MB, Wt.toString = mf, Wt.toUpper = XY2, Wt.trim = lb2, Wt.trimEnd = v6, Wt.trimStart = WC, Wt.truncate = a1, Wt.unescape = YY, Wt.uniqueId = zB, Wt.upperCase = FB, Wt.upperFirst = TD, Wt.each = Ex, Wt.eachRight = iA, Wt.first = e1, pd(Wt, function() {
              var q10 = {};
              return Gg(Wt, function(re, Ee) {
                $f.call(Wt.prototype, Ee) || (q10[Ee] = re);
              }), q10;
            }(), { chain: false }), Wt.VERSION = f6, Km(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(q10) {
              Wt[q10].placeholder = Wt;
            }), Km(["drop", "take"], function(q10, re) {
              wc.prototype[q10] = function(Ee) {
                Ee = Ee === n6 ? 1 : Sv(Rl(Ee), 0);
                var Je = this.__filtered__ && !re ? new wc(this) : this.clone();
                return Je.__filtered__ ? Je.__takeCount__ = N0(Ee, Je.__takeCount__) : Je.__views__.push({ size: N0(Ee, fr), type: q10 + (Je.__dir__ < 0 ? "Right" : "") }), Je;
              }, wc.prototype[q10 + "Right"] = function(Ee) {
                return this.reverse()[q10](Ee).reverse();
              };
            }), Km(["filter", "map", "takeWhile"], function(q10, re) {
              var Ee = re + 1, Je = Ee == Gt || Ee == Nt;
              wc.prototype[q10] = function(St) {
                var rn = this.clone();
                return rn.__iteratees__.push({ iteratee: ws(St, 3), type: Ee }), rn.__filtered__ = rn.__filtered__ || Je, rn;
              };
            }), Km(["head", "last"], function(q10, re) {
              var Ee = "take" + (re ? "Right" : "");
              wc.prototype[q10] = function() {
                return this[Ee](1).value()[0];
              };
            }), Km(["initial", "tail"], function(q10, re) {
              var Ee = "drop" + (re ? "" : "Right");
              wc.prototype[q10] = function() {
                return this.__filtered__ ? new wc(this) : this[Ee](1);
              };
            }), wc.prototype.compact = function() {
              return this.filter(Yg);
            }, wc.prototype.find = function(q10) {
              return this.filter(q10).head();
            }, wc.prototype.findLast = function(q10) {
              return this.reverse().find(q10);
            }, wc.prototype.invokeMap = Wu(function(q10, re) {
              return typeof q10 == "function" ? new wc(this) : this.map(function(Ee) {
                return k32(Ee, q10, re);
              });
            }), wc.prototype.reject = function(q10) {
              return this.filter(H3(ws(q10)));
            }, wc.prototype.slice = function(q10, re) {
              q10 = Rl(q10);
              var Ee = this;
              return Ee.__filtered__ && (q10 > 0 || re < 0) ? new wc(Ee) : (q10 < 0 ? Ee = Ee.takeRight(-q10) : q10 && (Ee = Ee.drop(q10)), re !== n6 && (re = Rl(re), Ee = re < 0 ? Ee.dropRight(-re) : Ee.take(re - q10)), Ee);
            }, wc.prototype.takeRightWhile = function(q10) {
              return this.reverse().takeWhile(q10).reverse();
            }, wc.prototype.toArray = function() {
              return this.take(fr);
            }, Gg(wc.prototype, function(q10, re) {
              var Ee = /^(?:filter|find|map|reject)|While$/.test(re), Je = /^(?:head|last)$/.test(re), St = Wt[Je ? "take" + (re == "last" ? "Right" : "") : re], rn = Je || /^find/.test(re);
              !St || (Wt.prototype[re] = function() {
                var Gn = this.__wrapped__, Yn = Je ? [1] : arguments, Cr = Gn instanceof wc, aa = Yn[0], oa = Cr || Pl(Gn), ua = function(Qs) {
                  var Yl = St.apply(Wt, XT([Qs], Yn));
                  return Je && bo ? Yl[0] : Yl;
                };
                oa && Ee && typeof aa == "function" && aa.length != 1 && (Cr = oa = false);
                var bo = this.__chain__, os = !!this.__actions__.length, Rs = rn && !bo, su = Cr && !os;
                if (!rn && oa) {
                  Gn = su ? Gn : new wc(this);
                  var Us = q10.apply(Gn, Yn);
                  return Us.__actions__.push({ func: Dp, args: [ua], thisArg: n6 }), new Uy(Us, bo);
                }
                return Rs && su ? q10.apply(this, Yn) : (Us = this.thru(ua), Rs ? Je ? Us.value()[0] : Us.value() : Us);
              });
            }), Km(["pop", "push", "shift", "sort", "splice", "unshift"], function(q10) {
              var re = A3[q10], Ee = /^(?:push|sort|unshift)$/.test(q10) ? "tap" : "thru", Je = /^(?:pop|shift)$/.test(q10);
              Wt.prototype[q10] = function() {
                var St = arguments;
                if (Je && !this.__chain__) {
                  var rn = this.value();
                  return re.apply(Pl(rn) ? rn : [], St);
                }
                return this[Ee](function(Gn) {
                  return re.apply(Pl(Gn) ? Gn : [], St);
                });
              };
            }), Gg(wc.prototype, function(q10, re) {
              var Ee = Wt[re];
              if (Ee) {
                var Je = Ee.name + "";
                $f.call(KE, Je) || (KE[Je] = []), KE[Je].push({ name: re, func: Ee });
              }
            }), KE[Ro(n6, oe).name] = [{ name: "wrapper", func: n6 }], wc.prototype.clone = iTe, wc.prototype.reverse = aTe, wc.prototype.value = _le, Wt.prototype.at = F3, Wt.prototype.chain = FS, Wt.prototype.commit = lB, Wt.prototype.next = K4, Wt.prototype.plant = rA, Wt.prototype.reverse = uB, Wt.prototype.toJSON = Wt.prototype.valueOf = Wt.prototype.value = cB, Wt.prototype.first = Wt.prototype.head, I4 && (Wt.prototype[I4] = n1), Wt;
          }, KT = C4();
          qT ? ((qT.exports = KT)._ = KT, UX._ = KT) : ng._ = KT;
        }).call(bt);
      })(bse, bse.exports);
      class pJe {
        constructor() {
          w3(this, "subscriptions", /* @__PURE__ */ new Map()), w3(this, "emitEffectCache", /* @__PURE__ */ new Map()), w3(this, "useSubscription", (a, n6) => {
            const f6 = M.useRef();
            M.useEffect(() => {
              var d4, y4;
              f6.current = n6;
              function _(T) {
                f6.current && f6.current(T);
              }
              const S = (y4 = (d4 = this.subscriptions) == null ? void 0 : d4.get(a)) != null ? y4 : [];
              return S.push(_), this.subscriptions.set(a, S), this.emitEffect(a), () => {
                this.subscriptions.delete(a);
              };
            });
          }), w3(this, "emit", (a, ...n6) => {
            if (typeof a == "string" || typeof a == "number") {
              const f6 = this.subscriptions.get(a);
              f6 == null || f6.forEach((d4) => {
                d4 == null || d4({ params: bse.exports.cloneDeep(n6), event: a });
              }), this.emitEffectCache.set(a, { params: bse.exports.cloneDeep(n6), event: a });
            } else
              throw new TypeError("event must be string or number !");
          }), w3(this, "emitEffect", (a) => {
            const n6 = this.emitEffectCache.get(a), f6 = this.subscriptions.get(a);
            n6 && (f6 == null || f6.forEach((d4) => {
              d4 == null || d4(b3({}, n6));
            }));
          }), w3(this, "removeListener", (a) => {
            this.subscriptions.delete(a);
          }), w3(this, "clear", () => {
            this.subscriptions.clear();
          }), this.clear();
        }
      }
      const YZt = new pJe();
      function _se(s) {
        const a = M.useRef(), n6 = M.useMemo(() => s != null ? s : { global: false }, [s]);
        return a.current || (a.current = n6.global ? a.current = YZt : a.current = new pJe()), M.useEffect(() => () => {
          var f6;
          return (f6 = a.current) == null ? void 0 : f6.clear();
        }, []), a.current;
      }
      const jCe = ({ id: s, title: a, chart: n6, option: f6 }, d4) => {
        const y4 = M.useRef(), _ = _se({ global: true });
        y4.current = M.useMemo(() => {
          if (!y4.current)
            return XZt;
        }, []);
        const { run: S } = Yt(() => {
          s && _.emit("list");
        }, { wait: 100 });
        return M.useEffect(() => {
          console.log(n6 == null ? void 0 : n6.current), y4.current && (n6 == null ? void 0 : n6.current) && s && f6 && (y4.current.add(s, n6 == null ? void 0 : n6.current, f6, a), S());
        }, d4), { tool: y4.current };
      };
      var KZt = M.createContext({}), dJe = KZt;
      function nh(s, a, n6) {
        return a in s ? Object.defineProperty(s, a, { value: n6, enumerable: true, configurable: true, writable: true }) : s[a] = n6, s;
      }
      function vJe(s, a) {
        var n6 = Object.keys(s);
        if (Object.getOwnPropertySymbols) {
          var f6 = Object.getOwnPropertySymbols(s);
          a && (f6 = f6.filter(function(d4) {
            return Object.getOwnPropertyDescriptor(s, d4).enumerable;
          })), n6.push.apply(n6, f6);
        }
        return n6;
      }
      function iu(s) {
        for (var a = 1; a < arguments.length; a++) {
          var n6 = arguments[a] != null ? arguments[a] : {};
          a % 2 ? vJe(Object(n6), true).forEach(function(f6) {
            nh(s, f6, n6[f6]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(s, Object.getOwnPropertyDescriptors(n6)) : vJe(Object(n6)).forEach(function(f6) {
            Object.defineProperty(s, f6, Object.getOwnPropertyDescriptor(n6, f6));
          });
        }
        return s;
      }
      function gJe(s) {
        if (Array.isArray(s))
          return s;
      }
      function ZZt(s, a) {
        var n6 = s == null ? null : typeof Symbol != "undefined" && s[Symbol.iterator] || s["@@iterator"];
        if (n6 != null) {
          var f6 = [], d4 = true, y4 = false, _, S;
          try {
            for (n6 = n6.call(s); !(d4 = (_ = n6.next()).done) && (f6.push(_.value), !(a && f6.length === a)); d4 = true)
              ;
          } catch (T) {
            y4 = true, S = T;
          } finally {
            try {
              !d4 && n6.return != null && n6.return();
            } finally {
              if (y4)
                throw S;
            }
          }
          return f6;
        }
      }
      function GCe(s, a) {
        (a == null || a > s.length) && (a = s.length);
        for (var n6 = 0, f6 = new Array(a); n6 < a; n6++)
          f6[n6] = s[n6];
        return f6;
      }
      function HCe(s, a) {
        if (s) {
          if (typeof s == "string")
            return GCe(s, a);
          var n6 = Object.prototype.toString.call(s).slice(8, -1);
          if (n6 === "Object" && s.constructor && (n6 = s.constructor.name), n6 === "Map" || n6 === "Set")
            return Array.from(s);
          if (n6 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n6))
            return GCe(s, a);
        }
      }
      function yJe() {
        throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function MS(s, a) {
        return gJe(s) || ZZt(s, a) || HCe(s, a) || yJe();
      }
      function JZt(s, a) {
        if (s == null)
          return {};
        var n6 = {}, f6 = Object.keys(s), d4, y4;
        for (y4 = 0; y4 < f6.length; y4++)
          d4 = f6[y4], !(a.indexOf(d4) >= 0) && (n6[d4] = s[d4]);
        return n6;
      }
      function fV(s, a) {
        if (s == null)
          return {};
        var n6 = JZt(s, a), f6, d4;
        if (Object.getOwnPropertySymbols) {
          var y4 = Object.getOwnPropertySymbols(s);
          for (d4 = 0; d4 < y4.length; d4++)
            f6 = y4[d4], !(a.indexOf(f6) >= 0) && (!Object.prototype.propertyIsEnumerable.call(s, f6) || (n6[f6] = s[f6]));
        }
        return n6;
      }
      var mJe = { exports: {} };
      /*!
        Copyright (c) 2018 Jed Watson.
        Licensed under the MIT License (MIT), see
        http://jedwatson.github.io/classnames
      */
      (function(s) {
        (function() {
          var a = {}.hasOwnProperty;
          function n6() {
            for (var f6 = [], d4 = 0; d4 < arguments.length; d4++) {
              var y4 = arguments[d4];
              if (y4) {
                var _ = typeof y4;
                if (_ === "string" || _ === "number")
                  f6.push(y4);
                else if (Array.isArray(y4)) {
                  if (y4.length) {
                    var S = n6.apply(null, y4);
                    S && f6.push(S);
                  }
                } else if (_ === "object")
                  if (y4.toString === Object.prototype.toString)
                    for (var T in y4)
                      a.call(y4, T) && y4[T] && f6.push(T);
                  else
                    f6.push(y4.toString());
              }
            }
            return f6.join(" ");
          }
          s.exports ? (n6.default = n6, s.exports = n6) : window.classNames = n6;
        })();
      })(mJe);
      var hV = mJe.exports;
      function qm(s) {
        return qm = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(a) {
          return typeof a;
        } : function(a) {
          return a && typeof Symbol == "function" && a.constructor === Symbol && a !== Symbol.prototype ? "symbol" : typeof a;
        }, qm(s);
      }
      function TS(s, a) {
        QZt(s) && (s = "100%");
        var n6 = eJt(s);
        return s = a === 360 ? s : Math.min(a, Math.max(0, parseFloat(s))), n6 && (s = parseInt(String(s * a), 10) / 100), Math.abs(s - a) < 1e-6 ? 1 : (a === 360 ? s = (s < 0 ? s % a + a : s % a) / parseFloat(String(a)) : s = s % a / parseFloat(String(a)), s);
      }
      function QZt(s) {
        return typeof s == "string" && s.indexOf(".") !== -1 && parseFloat(s) === 1;
      }
      function eJt(s) {
        return typeof s == "string" && s.indexOf("%") !== -1;
      }
      function tJt(s) {
        return s = parseFloat(s), (isNaN(s) || s < 0 || s > 1) && (s = 1), s;
      }
      function xse(s) {
        return s <= 1 ? Number(s) * 100 + "%" : s;
      }
      function WCe(s) {
        return s.length === 1 ? "0" + s : String(s);
      }
      function nJt(s, a, n6) {
        return { r: TS(s, 255) * 255, g: TS(a, 255) * 255, b: TS(n6, 255) * 255 };
      }
      function UCe(s, a, n6) {
        return n6 < 0 && (n6 += 1), n6 > 1 && (n6 -= 1), n6 < 1 / 6 ? s + (a - s) * (6 * n6) : n6 < 1 / 2 ? a : n6 < 2 / 3 ? s + (a - s) * (2 / 3 - n6) * 6 : s;
      }
      function rJt(s, a, n6) {
        var f6, d4, y4;
        if (s = TS(s, 360), a = TS(a, 100), n6 = TS(n6, 100), a === 0)
          d4 = n6, y4 = n6, f6 = n6;
        else {
          var _ = n6 < 0.5 ? n6 * (1 + a) : n6 + a - n6 * a, S = 2 * n6 - _;
          f6 = UCe(S, _, s + 1 / 3), d4 = UCe(S, _, s), y4 = UCe(S, _, s - 1 / 3);
        }
        return { r: f6 * 255, g: d4 * 255, b: y4 * 255 };
      }
      function iJt(s, a, n6) {
        s = TS(s, 255), a = TS(a, 255), n6 = TS(n6, 255);
        var f6 = Math.max(s, a, n6), d4 = Math.min(s, a, n6), y4 = 0, _ = f6, S = f6 - d4, T = f6 === 0 ? 0 : S / f6;
        if (f6 === d4)
          y4 = 0;
        else {
          switch (f6) {
            case s:
              y4 = (a - n6) / S + (a < n6 ? 6 : 0);
              break;
            case a:
              y4 = (n6 - s) / S + 2;
              break;
            case n6:
              y4 = (s - a) / S + 4;
              break;
          }
          y4 /= 6;
        }
        return { h: y4, s: T, v: _ };
      }
      function aJt(s, a, n6) {
        s = TS(s, 360) * 6, a = TS(a, 100), n6 = TS(n6, 100);
        var f6 = Math.floor(s), d4 = s - f6, y4 = n6 * (1 - a), _ = n6 * (1 - d4 * a), S = n6 * (1 - (1 - d4) * a), T = f6 % 6, E = [n6, _, y4, y4, S, n6][T], O = [S, n6, n6, _, y4, y4][T], R = [y4, y4, S, n6, n6, _][T];
        return { r: E * 255, g: O * 255, b: R * 255 };
      }
      function oJt(s, a, n6, f6) {
        var d4 = [WCe(Math.round(s).toString(16)), WCe(Math.round(a).toString(16)), WCe(Math.round(n6).toString(16))];
        return f6 && d4[0].startsWith(d4[0].charAt(1)) && d4[1].startsWith(d4[1].charAt(1)) && d4[2].startsWith(d4[2].charAt(1)) ? d4[0].charAt(0) + d4[1].charAt(0) + d4[2].charAt(0) : d4.join("");
      }
      function bJe(s) {
        return cx(s) / 255;
      }
      function cx(s) {
        return parseInt(s, 16);
      }
      var _Je = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
      function xX(s) {
        var a = { r: 0, g: 0, b: 0 }, n6 = 1, f6 = null, d4 = null, y4 = null, _ = false, S = false;
        return typeof s == "string" && (s = uJt(s)), typeof s == "object" && (GE(s.r) && GE(s.g) && GE(s.b) ? (a = nJt(s.r, s.g, s.b), _ = true, S = String(s.r).substr(-1) === "%" ? "prgb" : "rgb") : GE(s.h) && GE(s.s) && GE(s.v) ? (f6 = xse(s.s), d4 = xse(s.v), a = aJt(s.h, f6, d4), _ = true, S = "hsv") : GE(s.h) && GE(s.s) && GE(s.l) && (f6 = xse(s.s), y4 = xse(s.l), a = rJt(s.h, f6, y4), _ = true, S = "hsl"), Object.prototype.hasOwnProperty.call(s, "a") && (n6 = s.a)), n6 = tJt(n6), { ok: _, format: s.format || S, r: Math.min(255, Math.max(a.r, 0)), g: Math.min(255, Math.max(a.g, 0)), b: Math.min(255, Math.max(a.b, 0)), a: n6 };
      }
      var sJt = "[-\\+]?\\d+%?", lJt = "[-\\+]?\\d*\\.\\d+%?", v32 = "(?:" + lJt + ")|(?:" + sJt + ")", qCe = "[\\s|\\(]+(" + v32 + ")[,|\\s]+(" + v32 + ")[,|\\s]+(" + v32 + ")\\s*\\)?", $Ce = "[\\s|\\(]+(" + v32 + ")[,|\\s]+(" + v32 + ")[,|\\s]+(" + v32 + ")[,|\\s]+(" + v32 + ")\\s*\\)?", CC = { CSS_UNIT: new RegExp(v32), rgb: new RegExp("rgb" + qCe), rgba: new RegExp("rgba" + $Ce), hsl: new RegExp("hsl" + qCe), hsla: new RegExp("hsla" + $Ce), hsv: new RegExp("hsv" + qCe), hsva: new RegExp("hsva" + $Ce), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
      function uJt(s) {
        if (s = s.trim().toLowerCase(), s.length === 0)
          return false;
        var a = false;
        if (_Je[s])
          s = _Je[s], a = true;
        else if (s === "transparent")
          return { r: 0, g: 0, b: 0, a: 0, format: "name" };
        var n6 = CC.rgb.exec(s);
        return n6 ? { r: n6[1], g: n6[2], b: n6[3] } : (n6 = CC.rgba.exec(s), n6 ? { r: n6[1], g: n6[2], b: n6[3], a: n6[4] } : (n6 = CC.hsl.exec(s), n6 ? { h: n6[1], s: n6[2], l: n6[3] } : (n6 = CC.hsla.exec(s), n6 ? { h: n6[1], s: n6[2], l: n6[3], a: n6[4] } : (n6 = CC.hsv.exec(s), n6 ? { h: n6[1], s: n6[2], v: n6[3] } : (n6 = CC.hsva.exec(s), n6 ? { h: n6[1], s: n6[2], v: n6[3], a: n6[4] } : (n6 = CC.hex8.exec(s), n6 ? { r: cx(n6[1]), g: cx(n6[2]), b: cx(n6[3]), a: bJe(n6[4]), format: a ? "name" : "hex8" } : (n6 = CC.hex6.exec(s), n6 ? { r: cx(n6[1]), g: cx(n6[2]), b: cx(n6[3]), format: a ? "name" : "hex" } : (n6 = CC.hex4.exec(s), n6 ? { r: cx(n6[1] + n6[1]), g: cx(n6[2] + n6[2]), b: cx(n6[3] + n6[3]), a: bJe(n6[4] + n6[4]), format: a ? "name" : "hex8" } : (n6 = CC.hex3.exec(s), n6 ? { r: cx(n6[1] + n6[1]), g: cx(n6[2] + n6[2]), b: cx(n6[3] + n6[3]), format: a ? "name" : "hex" } : false)))))))));
      }
      function GE(s) {
        return Boolean(CC.CSS_UNIT.exec(String(s)));
      }
      var wse = 2, xJe = 0.16, cJt = 0.05, fJt = 0.05, hJt = 0.15, wJe = 5, SJe = 4, pJt = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
      function CJe(s) {
        var a = s.r, n6 = s.g, f6 = s.b, d4 = iJt(a, n6, f6);
        return { h: d4.h * 360, s: d4.s, v: d4.v };
      }
      function Sse(s) {
        var a = s.r, n6 = s.g, f6 = s.b;
        return "#".concat(oJt(a, n6, f6, false));
      }
      function dJt(s, a, n6) {
        var f6 = n6 / 100, d4 = { r: (a.r - s.r) * f6 + s.r, g: (a.g - s.g) * f6 + s.g, b: (a.b - s.b) * f6 + s.b };
        return d4;
      }
      function MJe(s, a, n6) {
        var f6;
        return Math.round(s.h) >= 60 && Math.round(s.h) <= 240 ? f6 = n6 ? Math.round(s.h) - wse * a : Math.round(s.h) + wse * a : f6 = n6 ? Math.round(s.h) + wse * a : Math.round(s.h) - wse * a, f6 < 0 ? f6 += 360 : f6 >= 360 && (f6 -= 360), f6;
      }
      function TJe(s, a, n6) {
        if (s.h === 0 && s.s === 0)
          return s.s;
        var f6;
        return n6 ? f6 = s.s - xJe * a : a === SJe ? f6 = s.s + xJe : f6 = s.s + cJt * a, f6 > 1 && (f6 = 1), n6 && a === wJe && f6 > 0.1 && (f6 = 0.1), f6 < 0.06 && (f6 = 0.06), Number(f6.toFixed(2));
      }
      function AJe(s, a, n6) {
        var f6;
        return n6 ? f6 = s.v + fJt * a : f6 = s.v - hJt * a, f6 > 1 && (f6 = 1), Number(f6.toFixed(2));
      }
      function XCe(s) {
        for (var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n6 = [], f6 = xX(s), d4 = wJe; d4 > 0; d4 -= 1) {
          var y4 = CJe(f6), _ = Sse(xX({ h: MJe(y4, d4, true), s: TJe(y4, d4, true), v: AJe(y4, d4, true) }));
          n6.push(_);
        }
        n6.push(Sse(f6));
        for (var S = 1; S <= SJe; S += 1) {
          var T = CJe(f6), E = Sse(xX({ h: MJe(T, S), s: TJe(T, S), v: AJe(T, S) }));
          n6.push(E);
        }
        return a.theme === "dark" ? pJt.map(function(O) {
          var R = O.index, V = O.opacity, z3 = Sse(dJt(xX(a.backgroundColor || "#141414"), xX(n6[R]), V * 100));
          return z3;
        }) : n6;
      }
      var YCe = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, $m = {}, KCe = {};
      Object.keys(YCe).forEach(function(s) {
        $m[s] = XCe(YCe[s]), $m[s].primary = $m[s][5], KCe[s] = XCe(YCe[s], { theme: "dark", backgroundColor: "#141414" }), KCe[s].primary = KCe[s][5];
      }), $m.red, $m.volcano, $m.gold, $m.orange, $m.yellow, $m.lime, $m.green, $m.cyan, $m.blue, $m.geekblue, $m.purple, $m.magenta, $m.grey;
      var IJe = {};
      function vJt(s, a) {
      }
      function gJt(s, a, n6) {
        !a && !IJe[n6] && (s(false, n6), IJe[n6] = true);
      }
      function GT(s, a) {
        gJt(vJt, s, a);
      }
      function EJe() {
        return !!(typeof window != "undefined" && window.document && window.document.createElement);
      }
      var yJt = "rc-util-key";
      function DJe() {
        var s = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, a = s.mark;
        return a ? a.startsWith("data-") ? a : "data-".concat(a) : yJt;
      }
      function ZCe(s) {
        if (s.attachTo)
          return s.attachTo;
        var a = document.querySelector("head");
        return a || document.body;
      }
      function kJe(s) {
        var a, n6 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        if (!EJe())
          return null;
        var f6 = document.createElement("style");
        if (!((a = n6.csp) === null || a === void 0) && a.nonce) {
          var d4;
          f6.nonce = (d4 = n6.csp) === null || d4 === void 0 ? void 0 : d4.nonce;
        }
        f6.innerHTML = s;
        var y4 = ZCe(n6), _ = y4.firstChild;
        return n6.prepend && y4.prepend ? y4.prepend(f6) : n6.prepend && _ ? y4.insertBefore(f6, _) : y4.appendChild(f6), f6;
      }
      var JCe = /* @__PURE__ */ new Map();
      function mJt(s) {
        var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n6 = ZCe(a);
        return Array.from(JCe.get(n6).children).find(function(f6) {
          return f6.tagName === "STYLE" && f6.getAttribute(DJe(a)) === s;
        });
      }
      function OJe(s, a) {
        var n6 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, f6 = ZCe(n6);
        if (!JCe.has(f6)) {
          var d4 = kJe("", n6), y4 = d4.parentNode;
          JCe.set(f6, y4), y4.removeChild(d4);
        }
        var _ = mJt(a, n6);
        if (_) {
          var S, T;
          if (((S = n6.csp) === null || S === void 0 ? void 0 : S.nonce) && _.nonce !== ((T = n6.csp) === null || T === void 0 ? void 0 : T.nonce)) {
            var E;
            _.nonce = (E = n6.csp) === null || E === void 0 ? void 0 : E.nonce;
          }
          return _.innerHTML !== s && (_.innerHTML = s), _;
        }
        var O = kJe(s, n6);
        return O.setAttribute(DJe(n6), a), O;
      }
      function bJt(s, a) {
        GT(s, "[@ant-design/icons] ".concat(a));
      }
      function PJe(s) {
        return qm(s) === "object" && typeof s.name == "string" && typeof s.theme == "string" && (qm(s.icon) === "object" || typeof s.icon == "function");
      }
      function LJe() {
        var s = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
        return Object.keys(s).reduce(function(a, n6) {
          var f6 = s[n6];
          switch (n6) {
            case "class":
              a.className = f6, delete a.class;
              break;
            default:
              a[n6] = f6;
          }
          return a;
        }, {});
      }
      function QCe(s, a, n6) {
        return n6 ? L.default.createElement(s.tag, iu(iu({ key: a }, LJe(s.attrs)), n6), (s.children || []).map(function(f6, d4) {
          return QCe(f6, "".concat(a, "-").concat(s.tag, "-").concat(d4));
        })) : L.default.createElement(s.tag, iu({ key: a }, LJe(s.attrs)), (s.children || []).map(function(f6, d4) {
          return QCe(f6, "".concat(a, "-").concat(s.tag, "-").concat(d4));
        }));
      }
      function RJe(s) {
        return XCe(s)[0];
      }
      function NJe(s) {
        return s ? Array.isArray(s) ? s : [s] : [];
      }
      var _Jt = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, xJt = function() {
        var s = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : _Jt, a = M.useContext(dJe), n6 = a.csp;
        M.useEffect(function() {
          OJe(s, "@ant-design-icons", { prepend: true, csp: n6 });
        }, []);
      }, wJt = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], wX = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
      function SJt(s) {
        var a = s.primaryColor, n6 = s.secondaryColor;
        wX.primaryColor = a, wX.secondaryColor = n6 || RJe(a), wX.calculated = !!n6;
      }
      function CJt() {
        return iu({}, wX);
      }
      var Cse = function(s) {
        var a = s.icon, n6 = s.className, f6 = s.onClick, d4 = s.style, y4 = s.primaryColor, _ = s.secondaryColor, S = fV(s, wJt), T = wX;
        if (y4 && (T = { primaryColor: y4, secondaryColor: _ || RJe(y4) }), xJt(), bJt(PJe(a), "icon should be icon definiton, but got ".concat(a)), !PJe(a))
          return null;
        var E = a;
        return E && typeof E.icon == "function" && (E = iu(iu({}, E), {}, { icon: E.icon(T.primaryColor, T.secondaryColor) })), QCe(E.icon, "svg-".concat(E.name), iu({ className: n6, onClick: f6, style: d4, "data-icon": E.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, S));
      };
      Cse.displayName = "IconReact", Cse.getTwoToneColors = CJt, Cse.setTwoToneColors = SJt;
      var eMe = Cse;
      function FJe(s) {
        var a = NJe(s), n6 = MS(a, 2), f6 = n6[0], d4 = n6[1];
        return eMe.setTwoToneColors({ primaryColor: f6, secondaryColor: d4 });
      }
      function MJt() {
        var s = eMe.getTwoToneColors();
        return s.calculated ? [s.primaryColor, s.secondaryColor] : s.primaryColor;
      }
      var TJt = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
      FJe("#1890ff");
      var Mse = F.forwardRef(function(s, a) {
        var n6, f6 = s.className, d4 = s.icon, y4 = s.spin, _ = s.rotate, S = s.tabIndex, T = s.onClick, E = s.twoToneColor, O = fV(s, TJt), R = F.useContext(dJe), V = R.prefixCls, z3 = V === void 0 ? "anticon" : V, H = hV(z3, (n6 = {}, nh(n6, "".concat(z3, "-").concat(d4.name), !!d4.name), nh(n6, "".concat(z3, "-spin"), !!y4 || d4.name === "loading"), n6), f6), Z = S;
        Z === void 0 && T && (Z = -1);
        var ee = _ ? { msTransform: "rotate(".concat(_, "deg)"), transform: "rotate(".concat(_, "deg)") } : void 0, oe = NJe(E), fe = MS(oe, 2), _e = fe[0], pe = fe[1];
        return F.createElement("span", iu(iu({ role: "img", "aria-label": d4.name }, O), {}, { ref: a, tabIndex: Z, onClick: T, className: H }), F.createElement(eMe, { icon: d4, primaryColor: _e, secondaryColor: pe, style: ee }));
      });
      Mse.displayName = "AntdIcon", Mse.getTwoToneColor = MJt, Mse.setTwoToneColor = FJe;
      var AJt = Mse, IJt = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, EJt = IJt, VJe = function(s, a) {
        return F.createElement(AJt, iu(iu({}, s), {}, { ref: a, icon: EJt }));
      };
      VJe.displayName = "LoadingOutlined";
      var DJt = F.forwardRef(VJe);
      function eg() {
        return eg = Object.assign || function(s) {
          for (var a = 1; a < arguments.length; a++) {
            var n6 = arguments[a];
            for (var f6 in n6)
              Object.prototype.hasOwnProperty.call(n6, f6) && (s[f6] = n6[f6]);
          }
          return s;
        }, eg.apply(this, arguments);
      }
      function SX(s, a) {
        if (!(s instanceof a))
          throw new TypeError("Cannot call a class as a function");
      }
      function BJe(s, a) {
        for (var n6 = 0; n6 < a.length; n6++) {
          var f6 = a[n6];
          f6.enumerable = f6.enumerable || false, f6.configurable = true, "value" in f6 && (f6.writable = true), Object.defineProperty(s, f6.key, f6);
        }
      }
      function CX(s, a, n6) {
        return a && BJe(s.prototype, a), n6 && BJe(s, n6), Object.defineProperty(s, "prototype", { writable: false }), s;
      }
      function tMe(s, a) {
        return tMe = Object.setPrototypeOf || function(n6, f6) {
          return n6.__proto__ = f6, n6;
        }, tMe(s, a);
      }
      function nMe(s, a) {
        if (typeof a != "function" && a !== null)
          throw new TypeError("Super expression must either be null or a function");
        s.prototype = Object.create(a && a.prototype, { constructor: { value: s, writable: true, configurable: true } }), Object.defineProperty(s, "prototype", { writable: false }), a && tMe(s, a);
      }
      function Tse(s) {
        return Tse = Object.setPrototypeOf ? Object.getPrototypeOf : function(a) {
          return a.__proto__ || Object.getPrototypeOf(a);
        }, Tse(s);
      }
      function kJt() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function rMe(s) {
        if (s === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return s;
      }
      function OJt(s, a) {
        if (a && (qm(a) === "object" || typeof a == "function"))
          return a;
        if (a !== void 0)
          throw new TypeError("Derived constructors may only return object or undefined");
        return rMe(s);
      }
      function iMe(s) {
        var a = kJt();
        return function() {
          var n6 = Tse(s), f6;
          if (a) {
            var d4 = Tse(this).constructor;
            f6 = Reflect.construct(n6, arguments, d4);
          } else
            f6 = n6.apply(this, arguments);
          return OJt(this, f6);
        };
      }
      var aMe = { exports: {} }, Th = {};
      /** @license React v16.13.1
      * react-is.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var D0 = typeof Symbol == "function" && Symbol.for, oMe = D0 ? Symbol.for("react.element") : 60103, sMe = D0 ? Symbol.for("react.portal") : 60106, Ase = D0 ? Symbol.for("react.fragment") : 60107, Ise = D0 ? Symbol.for("react.strict_mode") : 60108, Ese = D0 ? Symbol.for("react.profiler") : 60114, Dse = D0 ? Symbol.for("react.provider") : 60109, kse = D0 ? Symbol.for("react.context") : 60110, lMe = D0 ? Symbol.for("react.async_mode") : 60111, Ose = D0 ? Symbol.for("react.concurrent_mode") : 60111, Pse = D0 ? Symbol.for("react.forward_ref") : 60112, Lse = D0 ? Symbol.for("react.suspense") : 60113, PJt = D0 ? Symbol.for("react.suspense_list") : 60120, Rse = D0 ? Symbol.for("react.memo") : 60115, Nse = D0 ? Symbol.for("react.lazy") : 60116, LJt = D0 ? Symbol.for("react.block") : 60121, RJt = D0 ? Symbol.for("react.fundamental") : 60117, NJt = D0 ? Symbol.for("react.responder") : 60118, FJt = D0 ? Symbol.for("react.scope") : 60119;
      function fx(s) {
        if (typeof s == "object" && s !== null) {
          var a = s.$$typeof;
          switch (a) {
            case oMe:
              switch (s = s.type, s) {
                case lMe:
                case Ose:
                case Ase:
                case Ese:
                case Ise:
                case Lse:
                  return s;
                default:
                  switch (s = s && s.$$typeof, s) {
                    case kse:
                    case Pse:
                    case Nse:
                    case Rse:
                    case Dse:
                      return s;
                    default:
                      return a;
                  }
              }
            case sMe:
              return a;
          }
        }
      }
      function zJe(s) {
        return fx(s) === Ose;
      }
      Th.AsyncMode = lMe, Th.ConcurrentMode = Ose, Th.ContextConsumer = kse, Th.ContextProvider = Dse, Th.Element = oMe, Th.ForwardRef = Pse, Th.Fragment = Ase, Th.Lazy = Nse, Th.Memo = Rse, Th.Portal = sMe, Th.Profiler = Ese, Th.StrictMode = Ise, Th.Suspense = Lse, Th.isAsyncMode = function(s) {
        return zJe(s) || fx(s) === lMe;
      }, Th.isConcurrentMode = zJe, Th.isContextConsumer = function(s) {
        return fx(s) === kse;
      }, Th.isContextProvider = function(s) {
        return fx(s) === Dse;
      }, Th.isElement = function(s) {
        return typeof s == "object" && s !== null && s.$$typeof === oMe;
      }, Th.isForwardRef = function(s) {
        return fx(s) === Pse;
      }, Th.isFragment = function(s) {
        return fx(s) === Ase;
      }, Th.isLazy = function(s) {
        return fx(s) === Nse;
      }, Th.isMemo = function(s) {
        return fx(s) === Rse;
      }, Th.isPortal = function(s) {
        return fx(s) === sMe;
      }, Th.isProfiler = function(s) {
        return fx(s) === Ese;
      }, Th.isStrictMode = function(s) {
        return fx(s) === Ise;
      }, Th.isSuspense = function(s) {
        return fx(s) === Lse;
      }, Th.isValidElementType = function(s) {
        return typeof s == "string" || typeof s == "function" || s === Ase || s === Ose || s === Ese || s === Ise || s === Lse || s === PJt || typeof s == "object" && s !== null && (s.$$typeof === Nse || s.$$typeof === Rse || s.$$typeof === Dse || s.$$typeof === kse || s.$$typeof === Pse || s.$$typeof === RJt || s.$$typeof === NJt || s.$$typeof === FJt || s.$$typeof === LJt);
      }, Th.typeOf = fx, aMe.exports = Th;
      function uMe(s) {
        var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n6 = [];
        return L.default.Children.forEach(s, function(f6) {
          f6 == null && !a.keepEmpty || (Array.isArray(f6) ? n6 = n6.concat(uMe(f6)) : aMe.exports.isFragment(f6) && f6.props ? n6 = n6.concat(uMe(f6.props.children, a)) : n6.push(f6));
        }), n6;
      }
      function VJt(s, a) {
        typeof s == "function" ? s(a) : qm(s) === "object" && s && "current" in s && (s.current = a);
      }
      function BJt() {
        for (var s = arguments.length, a = new Array(s), n6 = 0; n6 < s; n6++)
          a[n6] = arguments[n6];
        var f6 = a.filter(function(d4) {
          return d4;
        });
        return f6.length <= 1 ? f6[0] : function(d4) {
          a.forEach(function(y4) {
            VJt(y4, d4);
          });
        };
      }
      function zJt(s) {
        var a, n6, f6 = aMe.exports.isMemo(s) ? s.type.type : s.type;
        return !(typeof f6 == "function" && !(!((a = f6.prototype) === null || a === void 0) && a.render) || typeof s == "function" && !(!((n6 = s.prototype) === null || n6 === void 0) && n6.render));
      }
      function jJt() {
        try {
          if (!Object.assign)
            return false;
          var s = new String("abc");
          if (s[5] = "de", Object.getOwnPropertyNames(s)[0] === "5")
            return false;
          for (var a = {}, n6 = 0; n6 < 10; n6++)
            a["_" + String.fromCharCode(n6)] = n6;
          var f6 = Object.getOwnPropertyNames(a).map(function(y4) {
            return a[y4];
          });
          if (f6.join("") !== "0123456789")
            return false;
          var d4 = {};
          return "abcdefghijklmnopqrst".split("").forEach(function(y4) {
            d4[y4] = y4;
          }), Object.keys(Object.assign({}, d4)).join("") === "abcdefghijklmnopqrst";
        } catch {
          return false;
        }
      }
      jJt();
      function GJt(s) {
        if (Array.isArray(s))
          return GCe(s);
      }
      function jJe(s) {
        if (typeof Symbol != "undefined" && s[Symbol.iterator] != null || s["@@iterator"] != null)
          return Array.from(s);
      }
      function HJt() {
        throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      }
      function nf(s) {
        return GJt(s) || jJe(s) || HCe(s) || HJt();
      }
      var pV = "RC_FORM_INTERNAL_HOOKS", qp = function() {
        GT(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
      }, MX = F.createContext({ getFieldValue: qp, getFieldsValue: qp, getFieldError: qp, getFieldWarning: qp, getFieldsError: qp, isFieldsTouched: qp, isFieldTouched: qp, isFieldValidating: qp, isFieldsValidating: qp, resetFields: qp, setFields: qp, setFieldsValue: qp, validateFields: qp, submit: qp, getInternalHooks: function() {
        return qp(), { dispatch: qp, initEntityValue: qp, registerField: qp, useSubscribe: qp, setInitialValues: qp, setCallbacks: qp, getFields: qp, setValidateMessages: qp, setPreserve: qp, getInitialValue: qp };
      } });
      function cMe(s) {
        return s == null ? [] : Array.isArray(s) ? s : [s];
      }
      var GJe = { exports: {} };
      (function(s) {
        var a = function(n6) {
          var f6 = Object.prototype, d4 = f6.hasOwnProperty, y4, _ = typeof Symbol == "function" ? Symbol : {}, S = _.iterator || "@@iterator", T = _.asyncIterator || "@@asyncIterator", E = _.toStringTag || "@@toStringTag";
          function O(un, pn, On) {
            return Object.defineProperty(un, pn, { value: On, enumerable: true, configurable: true, writable: true }), un[pn];
          }
          try {
            O({}, "");
          } catch {
            O = function(un, pn, On) {
              return un[pn] = On;
            };
          }
          function R(un, pn, On, fr) {
            var yr = pn && pn.prototype instanceof fe ? pn : fe, da = Object.create(yr.prototype), Ja = new Qt(fr || []);
            return da._invoke = ut(un, On, Ja), da;
          }
          n6.wrap = R;
          function V(un, pn, On) {
            try {
              return { type: "normal", arg: un.call(pn, On) };
            } catch (fr) {
              return { type: "throw", arg: fr };
            }
          }
          var z3 = "suspendedStart", H = "suspendedYield", Z = "executing", ee = "completed", oe = {};
          function fe() {
          }
          function _e() {
          }
          function pe() {
          }
          var Ve = {};
          O(Ve, S, function() {
            return this;
          });
          var Le = Object.getPrototypeOf, je = Le && Le(Le(Nt([])));
          je && je !== f6 && d4.call(je, S) && (Ve = je);
          var Xe = pe.prototype = fe.prototype = Object.create(Ve);
          _e.prototype = pe, O(Xe, "constructor", pe), O(pe, "constructor", _e), _e.displayName = O(pe, E, "GeneratorFunction");
          function Ye(un) {
            ["next", "throw", "return"].forEach(function(pn) {
              O(un, pn, function(On) {
                return this._invoke(pn, On);
              });
            });
          }
          n6.isGeneratorFunction = function(un) {
            var pn = typeof un == "function" && un.constructor;
            return pn ? pn === _e || (pn.displayName || pn.name) === "GeneratorFunction" : false;
          }, n6.mark = function(un) {
            return Object.setPrototypeOf ? Object.setPrototypeOf(un, pe) : (un.__proto__ = pe, O(un, E, "GeneratorFunction")), un.prototype = Object.create(Xe), un;
          }, n6.awrap = function(un) {
            return { __await: un };
          };
          function rt2(un, pn) {
            function On(da, Ja, ko, wo) {
              var So = V(un[da], un, Ja);
              if (So.type === "throw")
                wo(So.arg);
              else {
                var Fa = So.arg, po = Fa.value;
                return po && typeof po == "object" && d4.call(po, "__await") ? pn.resolve(po.__await).then(function(To) {
                  On("next", To, ko, wo);
                }, function(To) {
                  On("throw", To, ko, wo);
                }) : pn.resolve(po).then(function(To) {
                  Fa.value = To, ko(Fa);
                }, function(To) {
                  return On("throw", To, ko, wo);
                });
              }
            }
            var fr;
            function yr(da, Ja) {
              function ko() {
                return new pn(function(wo, So) {
                  On(da, Ja, wo, So);
                });
              }
              return fr = fr ? fr.then(ko, ko) : ko();
            }
            this._invoke = yr;
          }
          Ye(rt2.prototype), O(rt2.prototype, T, function() {
            return this;
          }), n6.AsyncIterator = rt2, n6.async = function(un, pn, On, fr, yr) {
            yr === void 0 && (yr = Promise);
            var da = new rt2(R(un, pn, On, fr), yr);
            return n6.isGeneratorFunction(pn) ? da : da.next().then(function(Ja) {
              return Ja.done ? Ja.value : da.next();
            });
          };
          function ut(un, pn, On) {
            var fr = z3;
            return function(yr, da) {
              if (fr === Z)
                throw new Error("Generator is already running");
              if (fr === ee) {
                if (yr === "throw")
                  throw da;
                return er();
              }
              for (On.method = yr, On.arg = da; ; ) {
                var Ja = On.delegate;
                if (Ja) {
                  var ko = wt(Ja, On);
                  if (ko) {
                    if (ko === oe)
                      continue;
                    return ko;
                  }
                }
                if (On.method === "next")
                  On.sent = On._sent = On.arg;
                else if (On.method === "throw") {
                  if (fr === z3)
                    throw fr = ee, On.arg;
                  On.dispatchException(On.arg);
                } else
                  On.method === "return" && On.abrupt("return", On.arg);
                fr = Z;
                var wo = V(un, pn, On);
                if (wo.type === "normal") {
                  if (fr = On.done ? ee : H, wo.arg === oe)
                    continue;
                  return { value: wo.arg, done: On.done };
                } else
                  wo.type === "throw" && (fr = ee, On.method = "throw", On.arg = wo.arg);
              }
            };
          }
          function wt(un, pn) {
            var On = un.iterator[pn.method];
            if (On === y4) {
              if (pn.delegate = null, pn.method === "throw") {
                if (un.iterator.return && (pn.method = "return", pn.arg = y4, wt(un, pn), pn.method === "throw"))
                  return oe;
                pn.method = "throw", pn.arg = new TypeError("The iterator does not provide a 'throw' method");
              }
              return oe;
            }
            var fr = V(On, un.iterator, pn.arg);
            if (fr.type === "throw")
              return pn.method = "throw", pn.arg = fr.arg, pn.delegate = null, oe;
            var yr = fr.arg;
            if (!yr)
              return pn.method = "throw", pn.arg = new TypeError("iterator result is not an object"), pn.delegate = null, oe;
            if (yr.done)
              pn[un.resultName] = yr.value, pn.next = un.nextLoc, pn.method !== "return" && (pn.method = "next", pn.arg = y4);
            else
              return yr;
            return pn.delegate = null, oe;
          }
          Ye(Xe), O(Xe, E, "Generator"), O(Xe, S, function() {
            return this;
          }), O(Xe, "toString", function() {
            return "[object Generator]";
          });
          function dt(un) {
            var pn = { tryLoc: un[0] };
            1 in un && (pn.catchLoc = un[1]), 2 in un && (pn.finallyLoc = un[2], pn.afterLoc = un[3]), this.tryEntries.push(pn);
          }
          function Gt(un) {
            var pn = un.completion || {};
            pn.type = "normal", delete pn.arg, un.completion = pn;
          }
          function Qt(un) {
            this.tryEntries = [{ tryLoc: "root" }], un.forEach(dt, this), this.reset(true);
          }
          n6.keys = function(un) {
            var pn = [];
            for (var On in un)
              pn.push(On);
            return pn.reverse(), function fr() {
              for (; pn.length; ) {
                var yr = pn.pop();
                if (yr in un)
                  return fr.value = yr, fr.done = false, fr;
              }
              return fr.done = true, fr;
            };
          };
          function Nt(un) {
            if (un) {
              var pn = un[S];
              if (pn)
                return pn.call(un);
              if (typeof un.next == "function")
                return un;
              if (!isNaN(un.length)) {
                var On = -1, fr = function yr() {
                  for (; ++On < un.length; )
                    if (d4.call(un, On))
                      return yr.value = un[On], yr.done = false, yr;
                  return yr.value = y4, yr.done = true, yr;
                };
                return fr.next = fr;
              }
            }
            return { next: er };
          }
          n6.values = Nt;
          function er() {
            return { value: y4, done: true };
          }
          return Qt.prototype = { constructor: Qt, reset: function(un) {
            if (this.prev = 0, this.next = 0, this.sent = this._sent = y4, this.done = false, this.delegate = null, this.method = "next", this.arg = y4, this.tryEntries.forEach(Gt), !un)
              for (var pn in this)
                pn.charAt(0) === "t" && d4.call(this, pn) && !isNaN(+pn.slice(1)) && (this[pn] = y4);
          }, stop: function() {
            this.done = true;
            var un = this.tryEntries[0], pn = un.completion;
            if (pn.type === "throw")
              throw pn.arg;
            return this.rval;
          }, dispatchException: function(un) {
            if (this.done)
              throw un;
            var pn = this;
            function On(wo, So) {
              return da.type = "throw", da.arg = un, pn.next = wo, So && (pn.method = "next", pn.arg = y4), !!So;
            }
            for (var fr = this.tryEntries.length - 1; fr >= 0; --fr) {
              var yr = this.tryEntries[fr], da = yr.completion;
              if (yr.tryLoc === "root")
                return On("end");
              if (yr.tryLoc <= this.prev) {
                var Ja = d4.call(yr, "catchLoc"), ko = d4.call(yr, "finallyLoc");
                if (Ja && ko) {
                  if (this.prev < yr.catchLoc)
                    return On(yr.catchLoc, true);
                  if (this.prev < yr.finallyLoc)
                    return On(yr.finallyLoc);
                } else if (Ja) {
                  if (this.prev < yr.catchLoc)
                    return On(yr.catchLoc, true);
                } else if (ko) {
                  if (this.prev < yr.finallyLoc)
                    return On(yr.finallyLoc);
                } else
                  throw new Error("try statement without catch or finally");
              }
            }
          }, abrupt: function(un, pn) {
            for (var On = this.tryEntries.length - 1; On >= 0; --On) {
              var fr = this.tryEntries[On];
              if (fr.tryLoc <= this.prev && d4.call(fr, "finallyLoc") && this.prev < fr.finallyLoc) {
                var yr = fr;
                break;
              }
            }
            yr && (un === "break" || un === "continue") && yr.tryLoc <= pn && pn <= yr.finallyLoc && (yr = null);
            var da = yr ? yr.completion : {};
            return da.type = un, da.arg = pn, yr ? (this.method = "next", this.next = yr.finallyLoc, oe) : this.complete(da);
          }, complete: function(un, pn) {
            if (un.type === "throw")
              throw un.arg;
            return un.type === "break" || un.type === "continue" ? this.next = un.arg : un.type === "return" ? (this.rval = this.arg = un.arg, this.method = "return", this.next = "end") : un.type === "normal" && pn && (this.next = pn), oe;
          }, finish: function(un) {
            for (var pn = this.tryEntries.length - 1; pn >= 0; --pn) {
              var On = this.tryEntries[pn];
              if (On.finallyLoc === un)
                return this.complete(On.completion, On.afterLoc), Gt(On), oe;
            }
          }, catch: function(un) {
            for (var pn = this.tryEntries.length - 1; pn >= 0; --pn) {
              var On = this.tryEntries[pn];
              if (On.tryLoc === un) {
                var fr = On.completion;
                if (fr.type === "throw") {
                  var yr = fr.arg;
                  Gt(On);
                }
                return yr;
              }
            }
            throw new Error("illegal catch attempt");
          }, delegateYield: function(un, pn, On) {
            return this.delegate = { iterator: Nt(un), resultName: pn, nextLoc: On }, this.method === "next" && (this.arg = y4), oe;
          } }, n6;
        }(s.exports);
        try {
          regeneratorRuntime = a;
        } catch {
          typeof globalThis == "object" ? globalThis.regeneratorRuntime = a : Function("r", "regeneratorRuntime = r")(a);
        }
      })(GJe);
      var g32 = GJe.exports;
      function HJe(s, a, n6, f6, d4, y4, _) {
        try {
          var S = s[y4](_), T = S.value;
        } catch (E) {
          n6(E);
          return;
        }
        S.done ? a(T) : Promise.resolve(T).then(f6, d4);
      }
      function Fse(s) {
        return function() {
          var a = this, n6 = arguments;
          return new Promise(function(f6, d4) {
            var y4 = s.apply(a, n6);
            function _(T) {
              HJe(y4, f6, d4, _, S, "next", T);
            }
            function S(T) {
              HJe(y4, f6, d4, _, S, "throw", T);
            }
            _(void 0);
          });
        };
      }
      function c4() {
        return c4 = Object.assign || function(s) {
          for (var a = 1; a < arguments.length; a++) {
            var n6 = arguments[a];
            for (var f6 in n6)
              Object.prototype.hasOwnProperty.call(n6, f6) && (s[f6] = n6[f6]);
          }
          return s;
        }, c4.apply(this, arguments);
      }
      function WJt(s, a) {
        s.prototype = Object.create(a.prototype), s.prototype.constructor = s, TX(s, a);
      }
      function fMe(s) {
        return fMe = Object.setPrototypeOf ? Object.getPrototypeOf : function(a) {
          return a.__proto__ || Object.getPrototypeOf(a);
        }, fMe(s);
      }
      function TX(s, a) {
        return TX = Object.setPrototypeOf || function(n6, f6) {
          return n6.__proto__ = f6, n6;
        }, TX(s, a);
      }
      function UJt() {
        if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
          return false;
        if (typeof Proxy == "function")
          return true;
        try {
          return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
          })), true;
        } catch {
          return false;
        }
      }
      function Vse(s, a, n6) {
        return UJt() ? Vse = Reflect.construct : Vse = function(f6, d4, y4) {
          var _ = [null];
          _.push.apply(_, d4);
          var S = Function.bind.apply(f6, _), T = new S();
          return y4 && TX(T, y4.prototype), T;
        }, Vse.apply(null, arguments);
      }
      function qJt(s) {
        return Function.toString.call(s).indexOf("[native code]") !== -1;
      }
      function hMe(s) {
        var a = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
        return hMe = function(n6) {
          if (n6 === null || !qJt(n6))
            return n6;
          if (typeof n6 != "function")
            throw new TypeError("Super expression must either be null or a function");
          if (typeof a != "undefined") {
            if (a.has(n6))
              return a.get(n6);
            a.set(n6, f6);
          }
          function f6() {
            return Vse(n6, arguments, fMe(this).constructor);
          }
          return f6.prototype = Object.create(n6.prototype, { constructor: { value: f6, enumerable: false, writable: true, configurable: true } }), TX(f6, n6);
        }, hMe(s);
      }
      var $Jt = /%[sdj%]/g, XJt = function() {
      };
      typeof process != "undefined" && process.env;
      function pMe(s) {
        if (!s || !s.length)
          return null;
        var a = {};
        return s.forEach(function(n6) {
          var f6 = n6.field;
          a[f6] = a[f6] || [], a[f6].push(n6);
        }), a;
      }
      function hx(s) {
        for (var a = arguments.length, n6 = new Array(a > 1 ? a - 1 : 0), f6 = 1; f6 < a; f6++)
          n6[f6 - 1] = arguments[f6];
        var d4 = 0, y4 = n6.length;
        if (typeof s == "function")
          return s.apply(null, n6);
        if (typeof s == "string") {
          var _ = s.replace($Jt, function(S) {
            if (S === "%%")
              return "%";
            if (d4 >= y4)
              return S;
            switch (S) {
              case "%s":
                return String(n6[d4++]);
              case "%d":
                return Number(n6[d4++]);
              case "%j":
                try {
                  return JSON.stringify(n6[d4++]);
                } catch {
                  return "[Circular]";
                }
                break;
              default:
                return S;
            }
          });
          return _;
        }
        return s;
      }
      function YJt(s) {
        return s === "string" || s === "url" || s === "hex" || s === "email" || s === "date" || s === "pattern";
      }
      function Fg(s, a) {
        return !!(s == null || a === "array" && Array.isArray(s) && !s.length || YJt(a) && typeof s == "string" && !s);
      }
      function KJt(s, a, n6) {
        var f6 = [], d4 = 0, y4 = s.length;
        function _(S) {
          f6.push.apply(f6, S || []), d4++, d4 === y4 && n6(f6);
        }
        s.forEach(function(S) {
          a(S, _);
        });
      }
      function WJe(s, a, n6) {
        var f6 = 0, d4 = s.length;
        function y4(_) {
          if (_ && _.length) {
            n6(_);
            return;
          }
          var S = f6;
          f6 = f6 + 1, S < d4 ? a(s[S], y4) : n6([]);
        }
        y4([]);
      }
      function ZJt(s) {
        var a = [];
        return Object.keys(s).forEach(function(n6) {
          a.push.apply(a, s[n6] || []);
        }), a;
      }
      var UJe = function(s) {
        WJt(a, s);
        function a(n6, f6) {
          var d4;
          return d4 = s.call(this, "Async Validation Error") || this, d4.errors = n6, d4.fields = f6, d4;
        }
        return a;
      }(hMe(Error));
      function JJt(s, a, n6, f6, d4) {
        if (a.first) {
          var y4 = new Promise(function(V, z3) {
            var H = function(ee) {
              return f6(ee), ee.length ? z3(new UJe(ee, pMe(ee))) : V(d4);
            }, Z = ZJt(s);
            WJe(Z, n6, H);
          });
          return y4.catch(function(V) {
            return V;
          }), y4;
        }
        var _ = a.firstFields === true ? Object.keys(s) : a.firstFields || [], S = Object.keys(s), T = S.length, E = 0, O = [], R = new Promise(function(V, z3) {
          var H = function(Z) {
            if (O.push.apply(O, Z), E++, E === T)
              return f6(O), O.length ? z3(new UJe(O, pMe(O))) : V(d4);
          };
          S.length || (f6(O), V(d4)), S.forEach(function(Z) {
            var ee = s[Z];
            _.indexOf(Z) !== -1 ? WJe(ee, n6, H) : KJt(ee, n6, H);
          });
        });
        return R.catch(function(V) {
          return V;
        }), R;
      }
      function QJt(s) {
        return !!(s && s.message !== void 0);
      }
      function eQt(s, a) {
        for (var n6 = s, f6 = 0; f6 < a.length; f6++) {
          if (n6 == null)
            return n6;
          n6 = n6[a[f6]];
        }
        return n6;
      }
      function qJe(s, a) {
        return function(n6) {
          var f6;
          return s.fullFields ? f6 = eQt(a, s.fullFields) : f6 = a[n6.field || s.fullField], QJt(n6) ? (n6.field = n6.field || s.fullField, n6.fieldValue = f6, n6) : { message: typeof n6 == "function" ? n6() : n6, fieldValue: f6, field: n6.field || s.fullField };
        };
      }
      function $Je(s, a) {
        if (a) {
          for (var n6 in a)
            if (a.hasOwnProperty(n6)) {
              var f6 = a[n6];
              typeof f6 == "object" && typeof s[n6] == "object" ? s[n6] = c4({}, s[n6], f6) : s[n6] = f6;
            }
        }
        return s;
      }
      var XJe = function(s, a, n6, f6, d4, y4) {
        s.required && (!n6.hasOwnProperty(s.field) || Fg(a, y4 || s.type)) && f6.push(hx(d4.messages.required, s.fullField));
      }, tQt = function(s, a, n6, f6, d4) {
        (/^\s+$/.test(a) || a === "") && f6.push(hx(d4.messages.whitespace, s.fullField));
      }, dMe = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, AX = { integer: function(s) {
        return AX.number(s) && parseInt(s, 10) === s;
      }, float: function(s) {
        return AX.number(s) && !AX.integer(s);
      }, array: function(s) {
        return Array.isArray(s);
      }, regexp: function(s) {
        if (s instanceof RegExp)
          return true;
        try {
          return !!new RegExp(s);
        } catch {
          return false;
        }
      }, date: function(s) {
        return typeof s.getTime == "function" && typeof s.getMonth == "function" && typeof s.getYear == "function" && !isNaN(s.getTime());
      }, number: function(s) {
        return isNaN(s) ? false : typeof s == "number";
      }, object: function(s) {
        return typeof s == "object" && !AX.array(s);
      }, method: function(s) {
        return typeof s == "function";
      }, email: function(s) {
        return typeof s == "string" && s.length <= 320 && !!s.match(dMe.email);
      }, url: function(s) {
        return typeof s == "string" && s.length <= 2048 && !!s.match(dMe.url);
      }, hex: function(s) {
        return typeof s == "string" && !!s.match(dMe.hex);
      } }, nQt = function(s, a, n6, f6, d4) {
        if (s.required && a === void 0) {
          XJe(s, a, n6, f6, d4);
          return;
        }
        var y4 = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], _ = s.type;
        y4.indexOf(_) > -1 ? AX[_](a) || f6.push(hx(d4.messages.types[_], s.fullField, s.type)) : _ && typeof a !== s.type && f6.push(hx(d4.messages.types[_], s.fullField, s.type));
      }, rQt = function(s, a, n6, f6, d4) {
        var y4 = typeof s.len == "number", _ = typeof s.min == "number", S = typeof s.max == "number", T = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, E = a, O = null, R = typeof a == "number", V = typeof a == "string", z3 = Array.isArray(a);
        if (R ? O = "number" : V ? O = "string" : z3 && (O = "array"), !O)
          return false;
        z3 && (E = a.length), V && (E = a.replace(T, "_").length), y4 ? E !== s.len && f6.push(hx(d4.messages[O].len, s.fullField, s.len)) : _ && !S && E < s.min ? f6.push(hx(d4.messages[O].min, s.fullField, s.min)) : S && !_ && E > s.max ? f6.push(hx(d4.messages[O].max, s.fullField, s.max)) : _ && S && (E < s.min || E > s.max) && f6.push(hx(d4.messages[O].range, s.fullField, s.min, s.max));
      }, dV = "enum", iQt = function(s, a, n6, f6, d4) {
        s[dV] = Array.isArray(s[dV]) ? s[dV] : [], s[dV].indexOf(a) === -1 && f6.push(hx(d4.messages[dV], s.fullField, s[dV].join(", ")));
      }, aQt = function(s, a, n6, f6, d4) {
        if (s.pattern) {
          if (s.pattern instanceof RegExp)
            s.pattern.lastIndex = 0, s.pattern.test(a) || f6.push(hx(d4.messages.pattern.mismatch, s.fullField, a, s.pattern));
          else if (typeof s.pattern == "string") {
            var y4 = new RegExp(s.pattern);
            y4.test(a) || f6.push(hx(d4.messages.pattern.mismatch, s.fullField, a, s.pattern));
          }
        }
      }, qc = { required: XJe, whitespace: tQt, type: nQt, range: rQt, enum: iQt, pattern: aQt }, oQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a, "string") && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4, "string"), Fg(a, "string") || (qc.type(s, a, f6, y4, d4), qc.range(s, a, f6, y4, d4), qc.pattern(s, a, f6, y4, d4), s.whitespace === true && qc.whitespace(s, a, f6, y4, d4));
        }
        n6(y4);
      }, sQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && qc.type(s, a, f6, y4, d4);
        }
        n6(y4);
      }, lQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (a === "" && (a = void 0), Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && (qc.type(s, a, f6, y4, d4), qc.range(s, a, f6, y4, d4));
        }
        n6(y4);
      }, uQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && qc.type(s, a, f6, y4, d4);
        }
        n6(y4);
      }, cQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), Fg(a) || qc.type(s, a, f6, y4, d4);
        }
        n6(y4);
      }, fQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && (qc.type(s, a, f6, y4, d4), qc.range(s, a, f6, y4, d4));
        }
        n6(y4);
      }, hQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && (qc.type(s, a, f6, y4, d4), qc.range(s, a, f6, y4, d4));
        }
        n6(y4);
      }, pQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (a == null && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4, "array"), a != null && (qc.type(s, a, f6, y4, d4), qc.range(s, a, f6, y4, d4));
        }
        n6(y4);
      }, dQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && qc.type(s, a, f6, y4, d4);
        }
        n6(y4);
      }, vQt = "enum", gQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), a !== void 0 && qc[vQt](s, a, f6, y4, d4);
        }
        n6(y4);
      }, yQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a, "string") && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4), Fg(a, "string") || qc.pattern(s, a, f6, y4, d4);
        }
        n6(y4);
      }, mQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a, "date") && !s.required)
            return n6();
          if (qc.required(s, a, f6, y4, d4), !Fg(a, "date")) {
            var S;
            a instanceof Date ? S = a : S = new Date(a), qc.type(s, S, f6, y4, d4), S && qc.range(s, S.getTime(), f6, y4, d4);
          }
        }
        n6(y4);
      }, bQt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = Array.isArray(a) ? "array" : typeof a;
        qc.required(s, a, f6, y4, d4, _), n6(y4);
      }, vMe = function(s, a, n6, f6, d4) {
        var y4 = s.type, _ = [], S = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (S) {
          if (Fg(a, y4) && !s.required)
            return n6();
          qc.required(s, a, f6, _, d4, y4), Fg(a, y4) || qc.type(s, a, f6, _, d4);
        }
        n6(_);
      }, _Qt = function(s, a, n6, f6, d4) {
        var y4 = [], _ = s.required || !s.required && f6.hasOwnProperty(s.field);
        if (_) {
          if (Fg(a) && !s.required)
            return n6();
          qc.required(s, a, f6, y4, d4);
        }
        n6(y4);
      }, IX = { string: oQt, method: sQt, number: lQt, boolean: uQt, regexp: cQt, integer: fQt, float: hQt, array: pQt, object: dQt, enum: gQt, pattern: yQt, date: mQt, url: vMe, hex: vMe, email: vMe, required: bQt, any: _Qt };
      function gMe() {
        return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
          var s = JSON.parse(JSON.stringify(this));
          return s.clone = this.clone, s;
        } };
      }
      var yMe = gMe(), EX = function() {
        function s(n6) {
          this.rules = null, this._messages = yMe, this.define(n6);
        }
        var a = s.prototype;
        return a.define = function(n6) {
          var f6 = this;
          if (!n6)
            throw new Error("Cannot configure a schema with no rules");
          if (typeof n6 != "object" || Array.isArray(n6))
            throw new Error("Rules must be an object");
          this.rules = {}, Object.keys(n6).forEach(function(d4) {
            var y4 = n6[d4];
            f6.rules[d4] = Array.isArray(y4) ? y4 : [y4];
          });
        }, a.messages = function(n6) {
          return n6 && (this._messages = $Je(gMe(), n6)), this._messages;
        }, a.validate = function(n6, f6, d4) {
          var y4 = this;
          f6 === void 0 && (f6 = {}), d4 === void 0 && (d4 = function() {
          });
          var _ = n6, S = f6, T = d4;
          if (typeof S == "function" && (T = S, S = {}), !this.rules || Object.keys(this.rules).length === 0)
            return T && T(null, _), Promise.resolve(_);
          function E(H) {
            var Z = [], ee = {};
            function oe(_e) {
              if (Array.isArray(_e)) {
                var pe;
                Z = (pe = Z).concat.apply(pe, _e);
              } else
                Z.push(_e);
            }
            for (var fe = 0; fe < H.length; fe++)
              oe(H[fe]);
            Z.length ? (ee = pMe(Z), T(Z, ee)) : T(null, _);
          }
          if (S.messages) {
            var O = this.messages();
            O === yMe && (O = gMe()), $Je(O, S.messages), S.messages = O;
          } else
            S.messages = this.messages();
          var R = {}, V = S.keys || Object.keys(this.rules);
          V.forEach(function(H) {
            var Z = y4.rules[H], ee = _[H];
            Z.forEach(function(oe) {
              var fe = oe;
              typeof fe.transform == "function" && (_ === n6 && (_ = c4({}, _)), ee = _[H] = fe.transform(ee)), typeof fe == "function" ? fe = { validator: fe } : fe = c4({}, fe), fe.validator = y4.getValidationMethod(fe), fe.validator && (fe.field = H, fe.fullField = fe.fullField || H, fe.type = y4.getType(fe), R[H] = R[H] || [], R[H].push({ rule: fe, value: ee, source: _, field: H }));
            });
          });
          var z3 = {};
          return JJt(R, S, function(H, Z) {
            var ee = H.rule, oe = (ee.type === "object" || ee.type === "array") && (typeof ee.fields == "object" || typeof ee.defaultField == "object");
            oe = oe && (ee.required || !ee.required && H.value), ee.field = H.field;
            function fe(Ve, Le) {
              return c4({}, Le, { fullField: ee.fullField + "." + Ve, fullFields: ee.fullFields ? [].concat(ee.fullFields, [Ve]) : [Ve] });
            }
            function _e(Ve) {
              Ve === void 0 && (Ve = []);
              var Le = Array.isArray(Ve) ? Ve : [Ve];
              !S.suppressWarning && Le.length && s.warning("async-validator:", Le), Le.length && ee.message !== void 0 && (Le = [].concat(ee.message));
              var je = Le.map(qJe(ee, _));
              if (S.first && je.length)
                return z3[ee.field] = 1, Z(je);
              if (!oe)
                Z(je);
              else {
                if (ee.required && !H.value)
                  return ee.message !== void 0 ? je = [].concat(ee.message).map(qJe(ee, _)) : S.error && (je = [S.error(ee, hx(S.messages.required, ee.field))]), Z(je);
                var Xe = {};
                ee.defaultField && Object.keys(H.value).map(function(ut) {
                  Xe[ut] = ee.defaultField;
                }), Xe = c4({}, Xe, H.rule.fields);
                var Ye = {};
                Object.keys(Xe).forEach(function(ut) {
                  var wt = Xe[ut], dt = Array.isArray(wt) ? wt : [wt];
                  Ye[ut] = dt.map(fe.bind(null, ut));
                });
                var rt2 = new s(Ye);
                rt2.messages(S.messages), H.rule.options && (H.rule.options.messages = S.messages, H.rule.options.error = S.error), rt2.validate(H.value, H.rule.options || S, function(ut) {
                  var wt = [];
                  je && je.length && wt.push.apply(wt, je), ut && ut.length && wt.push.apply(wt, ut), Z(wt.length ? wt : null);
                });
              }
            }
            var pe;
            ee.asyncValidator ? pe = ee.asyncValidator(ee, H.value, _e, H.source, S) : ee.validator && (pe = ee.validator(ee, H.value, _e, H.source, S), pe === true ? _e() : pe === false ? _e(typeof ee.message == "function" ? ee.message(ee.fullField || ee.field) : ee.message || (ee.fullField || ee.field) + " fails") : pe instanceof Array ? _e(pe) : pe instanceof Error && _e(pe.message)), pe && pe.then && pe.then(function() {
              return _e();
            }, function(Ve) {
              return _e(Ve);
            });
          }, function(H) {
            E(H);
          }, _);
        }, a.getType = function(n6) {
          if (n6.type === void 0 && n6.pattern instanceof RegExp && (n6.type = "pattern"), typeof n6.validator != "function" && n6.type && !IX.hasOwnProperty(n6.type))
            throw new Error(hx("Unknown rule type %s", n6.type));
          return n6.type || "string";
        }, a.getValidationMethod = function(n6) {
          if (typeof n6.validator == "function")
            return n6.validator;
          var f6 = Object.keys(n6), d4 = f6.indexOf("message");
          return d4 !== -1 && f6.splice(d4, 1), f6.length === 1 && f6[0] === "required" ? IX.required : IX[this.getType(n6)] || void 0;
        }, s;
      }();
      EX.register = function(s, a) {
        if (typeof a != "function")
          throw new Error("Cannot register a validator by type, validator is not a function");
        IX[s] = a;
      }, EX.warning = XJt, EX.messages = yMe, EX.validators = IX;
      var px = "'${name}' is not a valid ${type}", YJe = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: px, method: px, array: px, object: px, number: px, date: px, boolean: px, integer: px, float: px, regexp: px, email: px, url: px, hex: px }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
      function KJe(s, a) {
        for (var n6 = s, f6 = 0; f6 < a.length; f6 += 1) {
          if (n6 == null)
            return;
          n6 = n6[a[f6]];
        }
        return n6;
      }
      function xQt(s) {
        return gJe(s) || jJe(s) || HCe(s) || yJe();
      }
      function ZJe(s, a, n6, f6) {
        if (!a.length)
          return n6;
        var d4 = xQt(a), y4 = d4[0], _ = d4.slice(1), S;
        return !s && typeof y4 == "number" ? S = [] : Array.isArray(s) ? S = nf(s) : S = iu({}, s), f6 && n6 === void 0 && _.length === 1 ? delete S[y4][_[0]] : S[y4] = ZJe(S[y4], _, n6, f6), S;
      }
      function wQt(s, a, n6) {
        var f6 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
        return a.length && f6 && n6 === void 0 && !KJe(s, a.slice(0, -1)) ? s : ZJe(s, a, n6, f6);
      }
      function tg(s) {
        return cMe(s);
      }
      function vV(s, a) {
        var n6 = KJe(s, a);
        return n6;
      }
      function f4(s, a, n6) {
        var f6 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, d4 = wQt(s, a, n6, f6);
        return d4;
      }
      function JJe(s, a) {
        var n6 = {};
        return a.forEach(function(f6) {
          var d4 = vV(s, f6);
          n6 = f4(n6, f6, d4);
        }), n6;
      }
      function DX(s, a) {
        return s && s.some(function(n6) {
          return tQe(n6, a);
        });
      }
      function QJe(s) {
        return qm(s) === "object" && s !== null && Object.getPrototypeOf(s) === Object.prototype;
      }
      function eQe(s, a) {
        var n6 = Array.isArray(s) ? nf(s) : iu({}, s);
        return a && Object.keys(a).forEach(function(f6) {
          var d4 = n6[f6], y4 = a[f6], _ = QJe(d4) && QJe(y4);
          n6[f6] = _ ? eQe(d4, y4 || {}) : y4;
        }), n6;
      }
      function Bse(s) {
        for (var a = arguments.length, n6 = new Array(a > 1 ? a - 1 : 0), f6 = 1; f6 < a; f6++)
          n6[f6 - 1] = arguments[f6];
        return n6.reduce(function(d4, y4) {
          return eQe(d4, y4);
        }, s);
      }
      function tQe(s, a) {
        return !s || !a || s.length !== a.length ? false : s.every(function(n6, f6) {
          return a[f6] === n6;
        });
      }
      function SQt(s, a) {
        if (s === a)
          return true;
        if (!s && a || s && !a || !s || !a || qm(s) !== "object" || qm(a) !== "object")
          return false;
        var n6 = Object.keys(s), f6 = Object.keys(a), d4 = new Set([].concat(nf(n6), nf(f6)));
        return nf(d4).every(function(y4) {
          var _ = s[y4], S = a[y4];
          return typeof _ == "function" && typeof S == "function" ? true : _ === S;
        });
      }
      function CQt(s) {
        var a = arguments.length <= 1 ? void 0 : arguments[1];
        return a && a.target && qm(a.target) === "object" && s in a.target ? a.target[s] : a;
      }
      function nQe(s, a, n6) {
        var f6 = s.length;
        if (a < 0 || a >= f6 || n6 < 0 || n6 >= f6)
          return s;
        var d4 = s[a], y4 = a - n6;
        return y4 > 0 ? [].concat(nf(s.slice(0, n6)), [d4], nf(s.slice(n6, a)), nf(s.slice(a + 1, f6))) : y4 < 0 ? [].concat(nf(s.slice(0, a)), nf(s.slice(a + 1, n6 + 1)), [d4], nf(s.slice(n6 + 1, f6))) : s;
      }
      var MQt = EX;
      function TQt(s, a) {
        return s.replace(/\$\{\w+\}/g, function(n6) {
          var f6 = n6.slice(2, -1);
          return a[f6];
        });
      }
      function mMe(s, a, n6, f6, d4) {
        return bMe.apply(this, arguments);
      }
      function bMe() {
        return bMe = Fse(g32.mark(function s(a, n6, f6, d4, y4) {
          var _, S, T, E, O, R, V, z3;
          return g32.wrap(function(H) {
            for (; ; )
              switch (H.prev = H.next) {
                case 0:
                  return _ = iu({}, f6), delete _.ruleIndex, S = null, _ && _.type === "array" && _.defaultField && (S = _.defaultField, delete _.defaultField), T = new MQt(nh({}, a, [_])), E = Bse({}, YJe, d4.validateMessages), T.messages(E), O = [], H.prev = 8, H.next = 11, Promise.resolve(T.validate(nh({}, a, n6), iu({}, d4)));
                case 11:
                  H.next = 16;
                  break;
                case 13:
                  H.prev = 13, H.t0 = H.catch(8), H.t0.errors ? O = H.t0.errors.map(function(Z, ee) {
                    var oe = Z.message;
                    return F.isValidElement(oe) ? F.cloneElement(oe, { key: "error_".concat(ee) }) : oe;
                  }) : (console.error(H.t0), O = [E.default]);
                case 16:
                  if (!(!O.length && S)) {
                    H.next = 21;
                    break;
                  }
                  return H.next = 19, Promise.all(n6.map(function(Z, ee) {
                    return mMe("".concat(a, ".").concat(ee), Z, S, d4, y4);
                  }));
                case 19:
                  return R = H.sent, H.abrupt("return", R.reduce(function(Z, ee) {
                    return [].concat(nf(Z), nf(ee));
                  }, []));
                case 21:
                  return V = iu(iu({}, f6), {}, { name: a, enum: (f6.enum || []).join(", ") }, y4), z3 = O.map(function(Z) {
                    return typeof Z == "string" ? TQt(Z, V) : Z;
                  }), H.abrupt("return", z3);
                case 24:
                case "end":
                  return H.stop();
              }
          }, s, null, [[8, 13]]);
        })), bMe.apply(this, arguments);
      }
      function AQt(s, a, n6, f6, d4, y4) {
        var _ = s.join("."), S = n6.map(function(O, R) {
          var V = O.validator, z3 = iu(iu({}, O), {}, { ruleIndex: R });
          return V && (z3.validator = function(H, Z, ee) {
            var oe = false, fe = function() {
              for (var pe = arguments.length, Ve = new Array(pe), Le = 0; Le < pe; Le++)
                Ve[Le] = arguments[Le];
              Promise.resolve().then(function() {
                GT(!oe, "Your validator function has already return a promise. `callback` will be ignored."), oe || ee.apply(void 0, Ve);
              });
            }, _e = V(H, Z, fe);
            oe = _e && typeof _e.then == "function" && typeof _e.catch == "function", GT(oe, "`callback` is deprecated. Please return a promise instead."), oe && _e.then(function() {
              ee();
            }).catch(function(pe) {
              ee(pe || " ");
            });
          }), z3;
        }).sort(function(O, R) {
          var V = O.warningOnly, z3 = O.ruleIndex, H = R.warningOnly, Z = R.ruleIndex;
          return !!V == !!H ? z3 - Z : V ? 1 : -1;
        }), T;
        if (d4 === true)
          T = new Promise(function() {
            var O = Fse(g32.mark(function R(V, z3) {
              var H, Z, ee;
              return g32.wrap(function(oe) {
                for (; ; )
                  switch (oe.prev = oe.next) {
                    case 0:
                      H = 0;
                    case 1:
                      if (!(H < S.length)) {
                        oe.next = 12;
                        break;
                      }
                      return Z = S[H], oe.next = 5, mMe(_, a, Z, f6, y4);
                    case 5:
                      if (ee = oe.sent, !ee.length) {
                        oe.next = 9;
                        break;
                      }
                      return z3([{ errors: ee, rule: Z }]), oe.abrupt("return");
                    case 9:
                      H += 1, oe.next = 1;
                      break;
                    case 12:
                      V([]);
                    case 13:
                    case "end":
                      return oe.stop();
                  }
              }, R);
            }));
            return function(R, V) {
              return O.apply(this, arguments);
            };
          }());
        else {
          var E = S.map(function(O) {
            return mMe(_, a, O, f6, y4).then(function(R) {
              return { errors: R, rule: O };
            });
          });
          T = (d4 ? EQt(E) : IQt(E)).then(function(O) {
            return Promise.reject(O);
          });
        }
        return T.catch(function(O) {
          return O;
        }), T;
      }
      function IQt(s) {
        return _Me.apply(this, arguments);
      }
      function _Me() {
        return _Me = Fse(g32.mark(function s(a) {
          return g32.wrap(function(n6) {
            for (; ; )
              switch (n6.prev = n6.next) {
                case 0:
                  return n6.abrupt("return", Promise.all(a).then(function(f6) {
                    var d4, y4 = (d4 = []).concat.apply(d4, nf(f6));
                    return y4;
                  }));
                case 1:
                case "end":
                  return n6.stop();
              }
          }, s);
        })), _Me.apply(this, arguments);
      }
      function EQt(s) {
        return xMe.apply(this, arguments);
      }
      function xMe() {
        return xMe = Fse(g32.mark(function s(a) {
          var n6;
          return g32.wrap(function(f6) {
            for (; ; )
              switch (f6.prev = f6.next) {
                case 0:
                  return n6 = 0, f6.abrupt("return", new Promise(function(d4) {
                    a.forEach(function(y4) {
                      y4.then(function(_) {
                        _.errors.length && d4([_]), n6 += 1, n6 === a.length && d4([]);
                      });
                    });
                  }));
                case 2:
                case "end":
                  return f6.stop();
              }
          }, s);
        })), xMe.apply(this, arguments);
      }
      var DQt = ["name"], AS = [];
      function rQe(s, a, n6, f6, d4, y4) {
        return typeof s == "function" ? s(a, n6, "source" in y4 ? { source: y4.source } : {}) : f6 !== d4;
      }
      var wMe = function(s) {
        nMe(n6, s);
        var a = iMe(n6);
        function n6(f6) {
          var d4;
          if (SX(this, n6), d4 = a.call(this, f6), d4.state = { resetCount: 0 }, d4.cancelRegisterFunc = null, d4.mounted = false, d4.touched = false, d4.dirty = false, d4.validatePromise = null, d4.prevValidating = void 0, d4.errors = AS, d4.warnings = AS, d4.cancelRegister = function() {
            var T = d4.props, E = T.preserve, O = T.isListField, R = T.name;
            d4.cancelRegisterFunc && d4.cancelRegisterFunc(O, E, tg(R)), d4.cancelRegisterFunc = null;
          }, d4.getNamePath = function() {
            var T = d4.props, E = T.name, O = T.fieldContext, R = O.prefixName, V = R === void 0 ? [] : R;
            return E !== void 0 ? [].concat(nf(V), nf(E)) : [];
          }, d4.getRules = function() {
            var T = d4.props, E = T.rules, O = E === void 0 ? [] : E, R = T.fieldContext;
            return O.map(function(V) {
              return typeof V == "function" ? V(R) : V;
            });
          }, d4.refresh = function() {
            !d4.mounted || d4.setState(function(T) {
              var E = T.resetCount;
              return { resetCount: E + 1 };
            });
          }, d4.triggerMetaEvent = function(T) {
            var E = d4.props.onMetaChange;
            E == null || E(iu(iu({}, d4.getMeta()), {}, { destroy: T }));
          }, d4.onStoreChange = function(T, E, O) {
            var R = d4.props, V = R.shouldUpdate, z3 = R.dependencies, H = z3 === void 0 ? [] : z3, Z = R.onReset, ee = O.store, oe = d4.getNamePath(), fe = d4.getValue(T), _e = d4.getValue(ee), pe = E && DX(E, oe);
            switch (O.type === "valueUpdate" && O.source === "external" && fe !== _e && (d4.touched = true, d4.dirty = true, d4.validatePromise = null, d4.errors = AS, d4.warnings = AS, d4.triggerMetaEvent()), O.type) {
              case "reset":
                if (!E || pe) {
                  d4.touched = false, d4.dirty = false, d4.validatePromise = null, d4.errors = AS, d4.warnings = AS, d4.triggerMetaEvent(), Z == null || Z(), d4.refresh();
                  return;
                }
                break;
              case "remove": {
                if (V) {
                  d4.reRender();
                  return;
                }
                break;
              }
              case "setField": {
                if (pe) {
                  var Ve = O.data;
                  "touched" in Ve && (d4.touched = Ve.touched), "validating" in Ve && !("originRCField" in Ve) && (d4.validatePromise = Ve.validating ? Promise.resolve([]) : null), "errors" in Ve && (d4.errors = Ve.errors || AS), "warnings" in Ve && (d4.warnings = Ve.warnings || AS), d4.dirty = true, d4.triggerMetaEvent(), d4.reRender();
                  return;
                }
                if (V && !oe.length && rQe(V, T, ee, fe, _e, O)) {
                  d4.reRender();
                  return;
                }
                break;
              }
              case "dependenciesUpdate": {
                var Le = H.map(tg);
                if (Le.some(function(je) {
                  return DX(O.relatedFields, je);
                })) {
                  d4.reRender();
                  return;
                }
                break;
              }
              default:
                if (pe || (!H.length || oe.length || V) && rQe(V, T, ee, fe, _e, O)) {
                  d4.reRender();
                  return;
                }
                break;
            }
            V === true && d4.reRender();
          }, d4.validateRules = function(T) {
            var E = d4.getNamePath(), O = d4.getValue(), R = Promise.resolve().then(function() {
              if (!d4.mounted)
                return [];
              var V = d4.props, z3 = V.validateFirst, H = z3 === void 0 ? false : z3, Z = V.messageVariables, ee = T || {}, oe = ee.triggerName, fe = d4.getRules();
              oe && (fe = fe.filter(function(pe) {
                var Ve = pe.validateTrigger;
                if (!Ve)
                  return true;
                var Le = cMe(Ve);
                return Le.includes(oe);
              }));
              var _e = AQt(E, O, fe, T, H, Z);
              return _e.catch(function(pe) {
                return pe;
              }).then(function() {
                var pe = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : AS;
                if (d4.validatePromise === R) {
                  d4.validatePromise = null;
                  var Ve = [], Le = [];
                  pe.forEach(function(je) {
                    var Xe = je.rule.warningOnly, Ye = je.errors, rt2 = Ye === void 0 ? AS : Ye;
                    Xe ? Le.push.apply(Le, nf(rt2)) : Ve.push.apply(Ve, nf(rt2));
                  }), d4.errors = Ve, d4.warnings = Le, d4.triggerMetaEvent(), d4.reRender();
                }
              }), _e;
            });
            return d4.validatePromise = R, d4.dirty = true, d4.errors = AS, d4.warnings = AS, d4.triggerMetaEvent(), d4.reRender(), R;
          }, d4.isFieldValidating = function() {
            return !!d4.validatePromise;
          }, d4.isFieldTouched = function() {
            return d4.touched;
          }, d4.isFieldDirty = function() {
            if (d4.dirty || d4.props.initialValue !== void 0)
              return true;
            var T = d4.props.fieldContext, E = T.getInternalHooks(pV), O = E.getInitialValue;
            return O(d4.getNamePath()) !== void 0;
          }, d4.getErrors = function() {
            return d4.errors;
          }, d4.getWarnings = function() {
            return d4.warnings;
          }, d4.isListField = function() {
            return d4.props.isListField;
          }, d4.isList = function() {
            return d4.props.isList;
          }, d4.isPreserve = function() {
            return d4.props.preserve;
          }, d4.getMeta = function() {
            d4.prevValidating = d4.isFieldValidating();
            var T = { touched: d4.isFieldTouched(), validating: d4.prevValidating, errors: d4.errors, warnings: d4.warnings, name: d4.getNamePath() };
            return T;
          }, d4.getOnlyChild = function(T) {
            if (typeof T == "function") {
              var E = d4.getMeta();
              return iu(iu({}, d4.getOnlyChild(T(d4.getControlled(), E, d4.props.fieldContext))), {}, { isFunction: true });
            }
            var O = uMe(T);
            return O.length !== 1 || !F.isValidElement(O[0]) ? { child: O, isFunction: false } : { child: O[0], isFunction: false };
          }, d4.getValue = function(T) {
            var E = d4.props.fieldContext.getFieldsValue, O = d4.getNamePath();
            return vV(T || E(true), O);
          }, d4.getControlled = function() {
            var T = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, E = d4.props, O = E.trigger, R = E.validateTrigger, V = E.getValueFromEvent, z3 = E.normalize, H = E.valuePropName, Z = E.getValueProps, ee = E.fieldContext, oe = R !== void 0 ? R : ee.validateTrigger, fe = d4.getNamePath(), _e = ee.getInternalHooks, pe = ee.getFieldsValue, Ve = _e(pV), Le = Ve.dispatch, je = d4.getValue(), Xe = Z || function(wt) {
              return nh({}, H, wt);
            }, Ye = T[O], rt2 = iu(iu({}, T), Xe(je));
            rt2[O] = function() {
              d4.touched = true, d4.dirty = true, d4.triggerMetaEvent();
              for (var wt, dt = arguments.length, Gt = new Array(dt), Qt = 0; Qt < dt; Qt++)
                Gt[Qt] = arguments[Qt];
              V ? wt = V.apply(void 0, Gt) : wt = CQt.apply(void 0, [H].concat(Gt)), z3 && (wt = z3(wt, je, pe(true))), Le({ type: "updateValue", namePath: fe, value: wt }), Ye && Ye.apply(void 0, Gt);
            };
            var ut = cMe(oe || []);
            return ut.forEach(function(wt) {
              var dt = rt2[wt];
              rt2[wt] = function() {
                dt && dt.apply(void 0, arguments);
                var Gt = d4.props.rules;
                Gt && Gt.length && Le({ type: "validateField", namePath: fe, triggerName: wt });
              };
            }), rt2;
          }, f6.fieldContext) {
            var y4 = f6.fieldContext.getInternalHooks, _ = y4(pV), S = _.initEntityValue;
            S(rMe(d4));
          }
          return d4;
        }
        return CX(n6, [{ key: "componentDidMount", value: function() {
          var f6 = this.props, d4 = f6.shouldUpdate, y4 = f6.fieldContext;
          if (this.mounted = true, y4) {
            var _ = y4.getInternalHooks, S = _(pV), T = S.registerField;
            this.cancelRegisterFunc = T(this);
          }
          d4 === true && this.reRender();
        } }, { key: "componentWillUnmount", value: function() {
          this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
        } }, { key: "reRender", value: function() {
          !this.mounted || this.forceUpdate();
        } }, { key: "render", value: function() {
          var f6 = this.state.resetCount, d4 = this.props.children, y4 = this.getOnlyChild(d4), _ = y4.child, S = y4.isFunction, T;
          return S ? T = _ : F.isValidElement(_) ? T = F.cloneElement(_, this.getControlled(_.props)) : (GT(!_, "`children` of Field is not validate ReactElement."), T = _), F.createElement(F.Fragment, { key: f6 }, T);
        } }]), n6;
      }(F.Component);
      wMe.contextType = MX, wMe.defaultProps = { trigger: "onChange", valuePropName: "value" };
      function iQe(s) {
        var a = s.name, n6 = fV(s, DQt), f6 = F.useContext(MX), d4 = a !== void 0 ? tg(a) : void 0, y4 = "keep";
        return n6.isListField || (y4 = "_".concat((d4 || []).join("_"))), F.createElement(wMe, eg({ key: y4, name: d4 }, n6, { fieldContext: f6 }));
      }
      var kQt = F.createContext(null), OQt = function(s) {
        var a = s.name, n6 = s.initialValue, f6 = s.children, d4 = s.rules, y4 = s.validateTrigger, _ = F.useContext(MX), S = F.useRef({ keys: [], id: 0 }), T = S.current, E = F.useMemo(function() {
          var z3 = tg(_.prefixName) || [];
          return [].concat(nf(z3), nf(tg(a)));
        }, [_.prefixName, a]), O = F.useMemo(function() {
          return iu(iu({}, _), {}, { prefixName: E });
        }, [_, E]), R = F.useMemo(function() {
          return { getKey: function(z3) {
            var H = E.length, Z = z3[H];
            return [T.keys[Z], z3.slice(H + 1)];
          } };
        }, [E]);
        if (typeof f6 != "function")
          return GT(false, "Form.List only accepts function as children."), null;
        var V = function(z3, H, Z) {
          var ee = Z.source;
          return ee === "internal" ? false : z3 !== H;
        };
        return F.createElement(kQt.Provider, { value: R }, F.createElement(MX.Provider, { value: O }, F.createElement(iQe, { name: [], shouldUpdate: V, rules: d4, validateTrigger: y4, initialValue: n6, isList: true }, function(z3, H) {
          var Z = z3.value, ee = Z === void 0 ? [] : Z, oe = z3.onChange, fe = _.getFieldValue, _e = function() {
            var Le = fe(E || []);
            return Le || [];
          }, pe = { add: function(Le, je) {
            var Xe = _e();
            je >= 0 && je <= Xe.length ? (T.keys = [].concat(nf(T.keys.slice(0, je)), [T.id], nf(T.keys.slice(je))), oe([].concat(nf(Xe.slice(0, je)), [Le], nf(Xe.slice(je))))) : (T.keys = [].concat(nf(T.keys), [T.id]), oe([].concat(nf(Xe), [Le]))), T.id += 1;
          }, remove: function(Le) {
            var je = _e(), Xe = new Set(Array.isArray(Le) ? Le : [Le]);
            Xe.size <= 0 || (T.keys = T.keys.filter(function(Ye, rt2) {
              return !Xe.has(rt2);
            }), oe(je.filter(function(Ye, rt2) {
              return !Xe.has(rt2);
            })));
          }, move: function(Le, je) {
            if (Le !== je) {
              var Xe = _e();
              Le < 0 || Le >= Xe.length || je < 0 || je >= Xe.length || (T.keys = nQe(T.keys, Le, je), oe(nQe(Xe, Le, je)));
            }
          } }, Ve = ee || [];
          return Array.isArray(Ve) || (Ve = []), f6(Ve.map(function(Le, je) {
            var Xe = T.keys[je];
            return Xe === void 0 && (T.keys[je] = T.id, Xe = T.keys[je], T.id += 1), { name: je, key: Xe, isListField: true };
          }), pe, H);
        })));
      };
      function PQt(s) {
        var a = false, n6 = s.length, f6 = [];
        return s.length ? new Promise(function(d4, y4) {
          s.forEach(function(_, S) {
            _.catch(function(T) {
              return a = true, T;
            }).then(function(T) {
              n6 -= 1, f6[S] = T, !(n6 > 0) && (a && y4(f6), d4(f6));
            });
          });
        }) : Promise.resolve([]);
      }
      var aQe = "__@field_split__";
      function SMe(s) {
        return s.map(function(a) {
          return "".concat(qm(a), ":").concat(a);
        }).join(aQe);
      }
      var kX = function() {
        function s() {
          SX(this, s), this.kvs = /* @__PURE__ */ new Map();
        }
        return CX(s, [{ key: "set", value: function(a, n6) {
          this.kvs.set(SMe(a), n6);
        } }, { key: "get", value: function(a) {
          return this.kvs.get(SMe(a));
        } }, { key: "update", value: function(a, n6) {
          var f6 = this.get(a), d4 = n6(f6);
          d4 ? this.set(a, d4) : this.delete(a);
        } }, { key: "delete", value: function(a) {
          this.kvs.delete(SMe(a));
        } }, { key: "map", value: function(a) {
          return nf(this.kvs.entries()).map(function(n6) {
            var f6 = MS(n6, 2), d4 = f6[0], y4 = f6[1], _ = d4.split(aQe);
            return a({ key: _.map(function(S) {
              var T = S.match(/^([^:]*):(.*)$/), E = MS(T, 3), O = E[1], R = E[2];
              return O === "number" ? Number(R) : R;
            }), value: y4 });
          });
        } }, { key: "toJSON", value: function() {
          var a = {};
          return this.map(function(n6) {
            var f6 = n6.key, d4 = n6.value;
            return a[f6.join(".")] = d4, null;
          }), a;
        } }]), s;
      }(), LQt = ["name", "errors"], RQt = CX(function s(a) {
        var n6 = this;
        SX(this, s), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
          return { getFieldValue: n6.getFieldValue, getFieldsValue: n6.getFieldsValue, getFieldError: n6.getFieldError, getFieldWarning: n6.getFieldWarning, getFieldsError: n6.getFieldsError, isFieldsTouched: n6.isFieldsTouched, isFieldTouched: n6.isFieldTouched, isFieldValidating: n6.isFieldValidating, isFieldsValidating: n6.isFieldsValidating, resetFields: n6.resetFields, setFields: n6.setFields, setFieldsValue: n6.setFieldsValue, validateFields: n6.validateFields, submit: n6.submit, getInternalHooks: n6.getInternalHooks };
        }, this.getInternalHooks = function(f6) {
          return f6 === pV ? (n6.formHooked = true, { dispatch: n6.dispatch, initEntityValue: n6.initEntityValue, registerField: n6.registerField, useSubscribe: n6.useSubscribe, setInitialValues: n6.setInitialValues, setCallbacks: n6.setCallbacks, setValidateMessages: n6.setValidateMessages, getFields: n6.getFields, setPreserve: n6.setPreserve, getInitialValue: n6.getInitialValue }) : (GT(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
        }, this.useSubscribe = function(f6) {
          n6.subscribable = f6;
        }, this.setInitialValues = function(f6, d4) {
          n6.initialValues = f6 || {}, d4 && (n6.store = Bse({}, f6, n6.store));
        }, this.getInitialValue = function(f6) {
          return vV(n6.initialValues, f6);
        }, this.setCallbacks = function(f6) {
          n6.callbacks = f6;
        }, this.setValidateMessages = function(f6) {
          n6.validateMessages = f6;
        }, this.setPreserve = function(f6) {
          n6.preserve = f6;
        }, this.timeoutId = null, this.warningUnhooked = function() {
        }, this.getFieldEntities = function() {
          var f6 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
          return f6 ? n6.fieldEntities.filter(function(d4) {
            return d4.getNamePath().length;
          }) : n6.fieldEntities;
        }, this.getFieldsMap = function() {
          var f6 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, d4 = new kX();
          return n6.getFieldEntities(f6).forEach(function(y4) {
            var _ = y4.getNamePath();
            d4.set(_, y4);
          }), d4;
        }, this.getFieldEntitiesForNamePathList = function(f6) {
          if (!f6)
            return n6.getFieldEntities(true);
          var d4 = n6.getFieldsMap(true);
          return f6.map(function(y4) {
            var _ = tg(y4);
            return d4.get(_) || { INVALIDATE_NAME_PATH: tg(y4) };
          });
        }, this.getFieldsValue = function(f6, d4) {
          if (n6.warningUnhooked(), f6 === true && !d4)
            return n6.store;
          var y4 = n6.getFieldEntitiesForNamePathList(Array.isArray(f6) ? f6 : null), _ = [];
          return y4.forEach(function(S) {
            var T, E = "INVALIDATE_NAME_PATH" in S ? S.INVALIDATE_NAME_PATH : S.getNamePath();
            if (!(!f6 && ((T = S.isListField) === null || T === void 0 ? void 0 : T.call(S))))
              if (!d4)
                _.push(E);
              else {
                var O = "getMeta" in S ? S.getMeta() : null;
                d4(O) && _.push(E);
              }
          }), JJe(n6.store, _.map(tg));
        }, this.getFieldValue = function(f6) {
          n6.warningUnhooked();
          var d4 = tg(f6);
          return vV(n6.store, d4);
        }, this.getFieldsError = function(f6) {
          n6.warningUnhooked();
          var d4 = n6.getFieldEntitiesForNamePathList(f6);
          return d4.map(function(y4, _) {
            return y4 && !("INVALIDATE_NAME_PATH" in y4) ? { name: y4.getNamePath(), errors: y4.getErrors(), warnings: y4.getWarnings() } : { name: tg(f6[_]), errors: [], warnings: [] };
          });
        }, this.getFieldError = function(f6) {
          n6.warningUnhooked();
          var d4 = tg(f6), y4 = n6.getFieldsError([d4])[0];
          return y4.errors;
        }, this.getFieldWarning = function(f6) {
          n6.warningUnhooked();
          var d4 = tg(f6), y4 = n6.getFieldsError([d4])[0];
          return y4.warnings;
        }, this.isFieldsTouched = function() {
          n6.warningUnhooked();
          for (var f6 = arguments.length, d4 = new Array(f6), y4 = 0; y4 < f6; y4++)
            d4[y4] = arguments[y4];
          var _ = d4[0], S = d4[1], T, E = false;
          d4.length === 0 ? T = null : d4.length === 1 ? Array.isArray(_) ? (T = _.map(tg), E = false) : (T = null, E = _) : (T = _.map(tg), E = S);
          var O = n6.getFieldEntities(true), R = function(Z) {
            return Z.isFieldTouched();
          };
          if (!T)
            return E ? O.every(R) : O.some(R);
          var V = new kX();
          T.forEach(function(Z) {
            V.set(Z, []);
          }), O.forEach(function(Z) {
            var ee = Z.getNamePath();
            T.forEach(function(oe) {
              oe.every(function(fe, _e) {
                return ee[_e] === fe;
              }) && V.update(oe, function(fe) {
                return [].concat(nf(fe), [Z]);
              });
            });
          });
          var z3 = function(Z) {
            return Z.some(R);
          }, H = V.map(function(Z) {
            var ee = Z.value;
            return ee;
          });
          return E ? H.every(z3) : H.some(z3);
        }, this.isFieldTouched = function(f6) {
          return n6.warningUnhooked(), n6.isFieldsTouched([f6]);
        }, this.isFieldsValidating = function(f6) {
          n6.warningUnhooked();
          var d4 = n6.getFieldEntities();
          if (!f6)
            return d4.some(function(_) {
              return _.isFieldValidating();
            });
          var y4 = f6.map(tg);
          return d4.some(function(_) {
            var S = _.getNamePath();
            return DX(y4, S) && _.isFieldValidating();
          });
        }, this.isFieldValidating = function(f6) {
          return n6.warningUnhooked(), n6.isFieldsValidating([f6]);
        }, this.resetWithFieldInitialValue = function() {
          var f6 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, d4 = new kX(), y4 = n6.getFieldEntities(true);
          y4.forEach(function(T) {
            var E = T.props.initialValue, O = T.getNamePath();
            if (E !== void 0) {
              var R = d4.get(O) || /* @__PURE__ */ new Set();
              R.add({ entity: T, value: E }), d4.set(O, R);
            }
          });
          var _ = function(T) {
            T.forEach(function(E) {
              var O = E.props.initialValue;
              if (O !== void 0) {
                var R = E.getNamePath(), V = n6.getInitialValue(R);
                if (V !== void 0)
                  GT(false, "Form already set 'initialValues' with path '".concat(R.join("."), "'. Field can not overwrite it."));
                else {
                  var z3 = d4.get(R);
                  if (z3 && z3.size > 1)
                    GT(false, "Multiple Field with path '".concat(R.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                  else if (z3) {
                    var H = n6.getFieldValue(R);
                    (!f6.skipExist || H === void 0) && (n6.store = f4(n6.store, R, nf(z3)[0].value));
                  }
                }
              }
            });
          }, S;
          f6.entities ? S = f6.entities : f6.namePathList ? (S = [], f6.namePathList.forEach(function(T) {
            var E = d4.get(T);
            if (E) {
              var O;
              (O = S).push.apply(O, nf(nf(E).map(function(R) {
                return R.entity;
              })));
            }
          })) : S = y4, _(S);
        }, this.resetFields = function(f6) {
          n6.warningUnhooked();
          var d4 = n6.store;
          if (!f6) {
            n6.store = Bse({}, n6.initialValues), n6.resetWithFieldInitialValue(), n6.notifyObservers(d4, null, { type: "reset" });
            return;
          }
          var y4 = f6.map(tg);
          y4.forEach(function(_) {
            var S = n6.getInitialValue(_);
            n6.store = f4(n6.store, _, S);
          }), n6.resetWithFieldInitialValue({ namePathList: y4 }), n6.notifyObservers(d4, y4, { type: "reset" });
        }, this.setFields = function(f6) {
          n6.warningUnhooked();
          var d4 = n6.store;
          f6.forEach(function(y4) {
            var _ = y4.name;
            y4.errors;
            var S = fV(y4, LQt), T = tg(_);
            "value" in S && (n6.store = f4(n6.store, T, S.value)), n6.notifyObservers(d4, [T], { type: "setField", data: y4 });
          });
        }, this.getFields = function() {
          var f6 = n6.getFieldEntities(true), d4 = f6.map(function(y4) {
            var _ = y4.getNamePath(), S = y4.getMeta(), T = iu(iu({}, S), {}, { name: _, value: n6.getFieldValue(_) });
            return Object.defineProperty(T, "originRCField", { value: true }), T;
          });
          return d4;
        }, this.initEntityValue = function(f6) {
          var d4 = f6.props.initialValue;
          if (d4 !== void 0) {
            var y4 = f6.getNamePath(), _ = vV(n6.store, y4);
            _ === void 0 && (n6.store = f4(n6.store, y4, d4));
          }
        }, this.registerField = function(f6) {
          if (n6.fieldEntities.push(f6), f6.props.initialValue !== void 0) {
            var d4 = n6.store;
            n6.resetWithFieldInitialValue({ entities: [f6], skipExist: true }), n6.notifyObservers(d4, [f6.getNamePath()], { type: "valueUpdate", source: "internal" });
          }
          return function(y4, _) {
            var S = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
            n6.fieldEntities = n6.fieldEntities.filter(function(V) {
              return V !== f6;
            });
            var T = _ !== void 0 ? _ : n6.preserve;
            if (T === false && (!y4 || S.length > 1)) {
              var E = f6.getNamePath(), O = y4 ? void 0 : vV(n6.initialValues, E);
              if (E.length && n6.getFieldValue(E) !== O && n6.fieldEntities.every(function(V) {
                return !tQe(V.getNamePath(), E);
              })) {
                var R = n6.store;
                n6.store = f4(R, E, O, true), n6.notifyObservers(R, [E], { type: "remove" }), n6.triggerDependenciesUpdate(R, E);
              }
            }
          };
        }, this.dispatch = function(f6) {
          switch (f6.type) {
            case "updateValue": {
              var d4 = f6.namePath, y4 = f6.value;
              n6.updateValue(d4, y4);
              break;
            }
            case "validateField": {
              var _ = f6.namePath, S = f6.triggerName;
              n6.validateFields([_], { triggerName: S });
              break;
            }
          }
        }, this.notifyObservers = function(f6, d4, y4) {
          if (n6.subscribable) {
            var _ = iu(iu({}, y4), {}, { store: n6.getFieldsValue(true) });
            n6.getFieldEntities().forEach(function(S) {
              var T = S.onStoreChange;
              T(f6, d4, _);
            });
          } else
            n6.forceRootUpdate();
        }, this.triggerDependenciesUpdate = function(f6, d4) {
          var y4 = n6.getDependencyChildrenFields(d4);
          return y4.length && n6.validateFields(y4), n6.notifyObservers(f6, y4, { type: "dependenciesUpdate", relatedFields: [d4].concat(nf(y4)) }), y4;
        }, this.updateValue = function(f6, d4) {
          var y4 = tg(f6), _ = n6.store;
          n6.store = f4(n6.store, y4, d4), n6.notifyObservers(_, [y4], { type: "valueUpdate", source: "internal" });
          var S = n6.triggerDependenciesUpdate(_, y4), T = n6.callbacks.onValuesChange;
          if (T) {
            var E = JJe(n6.store, [y4]);
            T(E, n6.getFieldsValue());
          }
          n6.triggerOnFieldsChange([y4].concat(nf(S)));
        }, this.setFieldsValue = function(f6) {
          n6.warningUnhooked();
          var d4 = n6.store;
          f6 && (n6.store = Bse(n6.store, f6)), n6.notifyObservers(d4, null, { type: "valueUpdate", source: "external" });
        }, this.getDependencyChildrenFields = function(f6) {
          var d4 = /* @__PURE__ */ new Set(), y4 = [], _ = new kX();
          n6.getFieldEntities().forEach(function(T) {
            var E = T.props.dependencies;
            (E || []).forEach(function(O) {
              var R = tg(O);
              _.update(R, function() {
                var V = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                return V.add(T), V;
              });
            });
          });
          var S = function T(E) {
            var O = _.get(E) || /* @__PURE__ */ new Set();
            O.forEach(function(R) {
              if (!d4.has(R)) {
                d4.add(R);
                var V = R.getNamePath();
                R.isFieldDirty() && V.length && (y4.push(V), T(V));
              }
            });
          };
          return S(f6), y4;
        }, this.triggerOnFieldsChange = function(f6, d4) {
          var y4 = n6.callbacks.onFieldsChange;
          if (y4) {
            var _ = n6.getFields();
            if (d4) {
              var S = new kX();
              d4.forEach(function(E) {
                var O = E.name, R = E.errors;
                S.set(O, R);
              }), _.forEach(function(E) {
                E.errors = S.get(E.name) || E.errors;
              });
            }
            var T = _.filter(function(E) {
              var O = E.name;
              return DX(f6, O);
            });
            y4(T, _);
          }
        }, this.validateFields = function(f6, d4) {
          n6.warningUnhooked();
          var y4 = !!f6, _ = y4 ? f6.map(tg) : [], S = [];
          n6.getFieldEntities(true).forEach(function(O) {
            if (y4 || _.push(O.getNamePath()), (d4 == null ? void 0 : d4.recursive) && y4) {
              var R = O.getNamePath();
              R.every(function(H, Z) {
                return f6[Z] === H || f6[Z] === void 0;
              }) && _.push(R);
            }
            if (!(!O.props.rules || !O.props.rules.length)) {
              var V = O.getNamePath();
              if (!y4 || DX(_, V)) {
                var z3 = O.validateRules(iu({ validateMessages: iu(iu({}, YJe), n6.validateMessages) }, d4));
                S.push(z3.then(function() {
                  return { name: V, errors: [], warnings: [] };
                }).catch(function(H) {
                  var Z = [], ee = [];
                  return H.forEach(function(oe) {
                    var fe = oe.rule.warningOnly, _e = oe.errors;
                    fe ? ee.push.apply(ee, nf(_e)) : Z.push.apply(Z, nf(_e));
                  }), Z.length ? Promise.reject({ name: V, errors: Z, warnings: ee }) : { name: V, errors: Z, warnings: ee };
                }));
              }
            }
          });
          var T = PQt(S);
          n6.lastValidatePromise = T, T.catch(function(O) {
            return O;
          }).then(function(O) {
            var R = O.map(function(V) {
              var z3 = V.name;
              return z3;
            });
            n6.notifyObservers(n6.store, R, { type: "validateFinish" }), n6.triggerOnFieldsChange(R, O);
          });
          var E = T.then(function() {
            return n6.lastValidatePromise === T ? Promise.resolve(n6.getFieldsValue(_)) : Promise.reject([]);
          }).catch(function(O) {
            var R = O.filter(function(V) {
              return V && V.errors.length;
            });
            return Promise.reject({ values: n6.getFieldsValue(_), errorFields: R, outOfDate: n6.lastValidatePromise !== T });
          });
          return E.catch(function(O) {
            return O;
          }), E;
        }, this.submit = function() {
          n6.warningUnhooked(), n6.validateFields().then(function(f6) {
            var d4 = n6.callbacks.onFinish;
            if (d4)
              try {
                d4(f6);
              } catch (y4) {
                console.error(y4);
              }
          }).catch(function(f6) {
            var d4 = n6.callbacks.onFinishFailed;
            d4 && d4(f6);
          });
        }, this.forceRootUpdate = a;
      });
      function oQe(s) {
        var a = F.useRef(), n6 = F.useState({}), f6 = MS(n6, 2), d4 = f6[1];
        if (!a.current)
          if (s)
            a.current = s;
          else {
            var y4 = function() {
              d4({});
            }, _ = new RQt(y4);
            a.current = _.getForm();
          }
        return [a.current];
      }
      var CMe = F.createContext({ triggerFormChange: function() {
      }, triggerFormFinish: function() {
      }, registerForm: function() {
      }, unregisterForm: function() {
      } }), NQt = function(s) {
        var a = s.validateMessages, n6 = s.onFormChange, f6 = s.onFormFinish, d4 = s.children, y4 = F.useContext(CMe), _ = F.useRef({});
        return F.createElement(CMe.Provider, { value: iu(iu({}, y4), {}, { validateMessages: iu(iu({}, y4.validateMessages), a), triggerFormChange: function(S, T) {
          n6 && n6(S, { changedFields: T, forms: _.current }), y4.triggerFormChange(S, T);
        }, triggerFormFinish: function(S, T) {
          f6 && f6(S, { values: T, forms: _.current }), y4.triggerFormFinish(S, T);
        }, registerForm: function(S, T) {
          S && (_.current = iu(iu({}, _.current), {}, nh({}, S, T))), y4.registerForm(S, T);
        }, unregisterForm: function(S) {
          var T = iu({}, _.current);
          delete T[S], _.current = T, y4.unregisterForm(S);
        } }) }, d4);
      }, FQt = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], VQt = function(s, a) {
        var n6 = s.name, f6 = s.initialValues, d4 = s.fields, y4 = s.form, _ = s.preserve, S = s.children, T = s.component, E = T === void 0 ? "form" : T, O = s.validateMessages, R = s.validateTrigger, V = R === void 0 ? "onChange" : R, z3 = s.onValuesChange, H = s.onFieldsChange, Z = s.onFinish, ee = s.onFinishFailed, oe = fV(s, FQt), fe = F.useContext(CMe), _e = oQe(y4), pe = MS(_e, 1), Ve = pe[0], Le = Ve.getInternalHooks(pV), je = Le.useSubscribe, Xe = Le.setInitialValues, Ye = Le.setCallbacks, rt2 = Le.setValidateMessages, ut = Le.setPreserve;
        F.useImperativeHandle(a, function() {
          return Ve;
        }), F.useEffect(function() {
          return fe.registerForm(n6, Ve), function() {
            fe.unregisterForm(n6);
          };
        }, [fe, Ve, n6]), rt2(iu(iu({}, fe.validateMessages), O)), Ye({ onValuesChange: z3, onFieldsChange: function(pn) {
          if (fe.triggerFormChange(n6, pn), H) {
            for (var On = arguments.length, fr = new Array(On > 1 ? On - 1 : 0), yr = 1; yr < On; yr++)
              fr[yr - 1] = arguments[yr];
            H.apply(void 0, [pn].concat(fr));
          }
        }, onFinish: function(pn) {
          fe.triggerFormFinish(n6, pn), Z && Z(pn);
        }, onFinishFailed: ee }), ut(_);
        var wt = F.useRef(null);
        Xe(f6, !wt.current), wt.current || (wt.current = true);
        var dt = S, Gt = typeof S == "function";
        if (Gt) {
          var Qt = Ve.getFieldsValue(true);
          dt = S(Qt, Ve);
        }
        je(!Gt);
        var Nt = F.useRef();
        F.useEffect(function() {
          SQt(Nt.current || [], d4 || []) || Ve.setFields(d4 || []), Nt.current = d4;
        }, [d4, Ve]);
        var er = F.useMemo(function() {
          return iu(iu({}, Ve), {}, { validateTrigger: V });
        }, [Ve, V]), un = F.createElement(MX.Provider, { value: er }, dt);
        return E === false ? un : F.createElement(E, eg({}, oe, { onSubmit: function(pn) {
          pn.preventDefault(), pn.stopPropagation(), Ve.submit();
        }, onReset: function(pn) {
          var On;
          pn.preventDefault(), Ve.resetFields(), (On = oe.onReset) === null || On === void 0 || On.call(oe, pn);
        } }), un);
      }, BQt = F.forwardRef(VQt), zse = BQt;
      zse.FormProvider = NQt, zse.Field = iQe, zse.List = OQt, zse.useForm = oQe;
      var zQt = function(s, a, n6) {
        GT(s, "[antd: ".concat(a, "] ").concat(n6));
      }, jQt = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, GQt = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, HQt = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, sQe = HQt, WQt = { lang: eg({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, GQt), timePickerLocale: eg({}, sQe) }, lQe = WQt, dx = "${label} is not a valid ${type}", UQt = { locale: "en", Pagination: jQt, DatePicker: lQe, TimePicker: sQe, Calendar: lQe, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: dx, method: dx, array: dx, object: dx, number: dx, date: dx, boolean: dx, integer: dx, float: dx, regexp: dx, email: dx, url: dx, hex: dx }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, uQe = UQt, qQt = M.createContext(void 0), $Qt = qQt, MMe = function(s) {
        nMe(n6, s);
        var a = iMe(n6);
        function n6() {
          return SX(this, n6), a.apply(this, arguments);
        }
        return CX(n6, [{ key: "getLocale", value: function() {
          var f6 = this.props, d4 = f6.componentName, y4 = f6.defaultLocale, _ = y4 || uQe[d4 != null ? d4 : "global"], S = this.context, T = d4 && S ? S[d4] : {};
          return eg(eg({}, _ instanceof Function ? _() : _), T || {});
        } }, { key: "getLocaleCode", value: function() {
          var f6 = this.context, d4 = f6 && f6.locale;
          return f6 && f6.exist && !d4 ? uQe.locale : d4;
        } }, { key: "render", value: function() {
          return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
        } }]), n6;
      }(F.Component);
      MMe.defaultProps = { componentName: "global" }, MMe.contextType = $Qt;
      var XQt = function() {
        var s = F.useContext(y3), a = s.getPrefixCls, n6 = a("empty-img-default");
        return F.createElement("svg", { className: n6, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, F.createElement("g", { fill: "none", fillRule: "evenodd" }, F.createElement("g", { transform: "translate(24 31.67)" }, F.createElement("ellipse", { className: "".concat(n6, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), F.createElement("path", { className: "".concat(n6, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), F.createElement("path", { className: "".concat(n6, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), F.createElement("path", { className: "".concat(n6, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), F.createElement("path", { className: "".concat(n6, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), F.createElement("path", { className: "".concat(n6, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), F.createElement("g", { className: "".concat(n6, "-g"), transform: "translate(149.65 15.383)" }, F.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), F.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
      }, YQt = XQt, KQt = function() {
        var s = F.useContext(y3), a = s.getPrefixCls, n6 = a("empty-img-simple");
        return F.createElement("svg", { className: n6, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, F.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, F.createElement("ellipse", { className: "".concat(n6, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), F.createElement("g", { className: "".concat(n6, "-g"), fillRule: "nonzero" }, F.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), F.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(n6, "-path") }))));
      }, ZQt = KQt, JQt = globalThis && globalThis.__rest || function(s, a) {
        var n6 = {};
        for (var f6 in s)
          Object.prototype.hasOwnProperty.call(s, f6) && a.indexOf(f6) < 0 && (n6[f6] = s[f6]);
        if (s != null && typeof Object.getOwnPropertySymbols == "function")
          for (var d4 = 0, f6 = Object.getOwnPropertySymbols(s); d4 < f6.length; d4++)
            a.indexOf(f6[d4]) < 0 && Object.prototype.propertyIsEnumerable.call(s, f6[d4]) && (n6[f6[d4]] = s[f6[d4]]);
        return n6;
      }, cQe = F.createElement(YQt, null), fQe = F.createElement(ZQt, null), TMe = function(s) {
        var a = s.className, n6 = s.prefixCls, f6 = s.image, d4 = f6 === void 0 ? cQe : f6, y4 = s.description, _ = s.children, S = s.imageStyle, T = JQt(s, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), E = F.useContext(y3), O = E.getPrefixCls, R = E.direction;
        return F.createElement(MMe, { componentName: "Empty" }, function(V) {
          var z3, H = O("empty", n6), Z = typeof y4 != "undefined" ? y4 : V.description, ee = typeof Z == "string" ? Z : "empty", oe = null;
          return typeof d4 == "string" ? oe = F.createElement("img", { alt: ee, src: d4 }) : oe = d4, F.createElement("div", eg({ className: hV(H, (z3 = {}, nh(z3, "".concat(H, "-normal"), d4 === fQe), nh(z3, "".concat(H, "-rtl"), R === "rtl"), z3), a) }, T), F.createElement("div", { className: "".concat(H, "-image"), style: S }, oe), Z && F.createElement("div", { className: "".concat(H, "-description") }, Z), _ && F.createElement("div", { className: "".concat(H, "-footer") }, _));
        });
      };
      TMe.PRESENTED_IMAGE_DEFAULT = cQe, TMe.PRESENTED_IMAGE_SIMPLE = fQe;
      var OX = TMe, QQt = function(s) {
        return F.createElement(hQe, null, function(a) {
          var n6 = a.getPrefixCls, f6 = n6("empty");
          switch (s) {
            case "Table":
            case "List":
              return F.createElement(OX, { image: OX.PRESENTED_IMAGE_SIMPLE });
            case "Select":
            case "TreeSelect":
            case "Cascader":
            case "Transfer":
            case "Mentions":
              return F.createElement(OX, { image: OX.PRESENTED_IMAGE_SIMPLE, className: "".concat(f6, "-small") });
            default:
              return F.createElement(OX, null);
          }
        });
      }, een = QQt, ten = function(s, a) {
        return a || (s ? "ant-".concat(s) : "ant");
      }, y3 = F.createContext({ getPrefixCls: ten, renderEmpty: een }), hQe = y3.Consumer, nen = F.createContext(void 0), ren = nen, pQe = function(s) {
        return +setTimeout(s, 16);
      }, dQe = function(s) {
        return clearTimeout(s);
      };
      typeof window != "undefined" && "requestAnimationFrame" in window && (pQe = function(s) {
        return window.requestAnimationFrame(s);
      }, dQe = function(s) {
        return window.cancelAnimationFrame(s);
      });
      var vQe = 0, AMe = /* @__PURE__ */ new Map();
      function gQe(s) {
        AMe.delete(s);
      }
      function jse(s) {
        var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
        vQe += 1;
        var n6 = vQe;
        function f6(d4) {
          if (d4 === 0)
            gQe(n6), s();
          else {
            var y4 = pQe(function() {
              f6(d4 - 1);
            });
            AMe.set(n6, y4);
          }
        }
        return f6(a), n6;
      }
      jse.cancel = function(s) {
        var a = AMe.get(s);
        return gQe(a), dQe(a);
      };
      function ien(s, a) {
        var n6 = a || {}, f6 = n6.defaultValue, d4 = n6.value, y4 = n6.onChange, _ = n6.postState, S = F.useState(function() {
          return d4 !== void 0 ? d4 : f6 !== void 0 ? typeof f6 == "function" ? f6() : f6 : typeof s == "function" ? s() : s;
        }), T = MS(S, 2), E = T[0], O = T[1], R = d4 !== void 0 ? d4 : E;
        _ && (R = _(R));
        var V = F.useRef(y4);
        V.current = y4;
        var z3 = F.useCallback(function(Z) {
          O(Z), R !== Z && V.current && V.current(Z, R);
        }, [R, V]), H = F.useRef(true);
        return F.useEffect(function() {
          if (H.current) {
            H.current = false;
            return;
          }
          d4 === void 0 && O(d4);
        }, [d4]), [R, z3];
      }
      var bl = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(s) {
        var a = s.keyCode;
        if (s.altKey && !s.ctrlKey || s.metaKey || a >= bl.F1 && a <= bl.F12)
          return false;
        switch (a) {
          case bl.ALT:
          case bl.CAPS_LOCK:
          case bl.CONTEXT_MENU:
          case bl.CTRL:
          case bl.DOWN:
          case bl.END:
          case bl.ESC:
          case bl.HOME:
          case bl.INSERT:
          case bl.LEFT:
          case bl.MAC_FF_META:
          case bl.META:
          case bl.NUMLOCK:
          case bl.NUM_CENTER:
          case bl.PAGE_DOWN:
          case bl.PAGE_UP:
          case bl.PAUSE:
          case bl.PRINT_SCREEN:
          case bl.RIGHT:
          case bl.SHIFT:
          case bl.UP:
          case bl.WIN_KEY:
          case bl.WIN_KEY_RIGHT:
            return false;
          default:
            return true;
        }
      }, isCharacterKey: function(s) {
        if (s >= bl.ZERO && s <= bl.NINE || s >= bl.NUM_ZERO && s <= bl.NUM_MULTIPLY || s >= bl.A && s <= bl.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && s === 0)
          return true;
        switch (s) {
          case bl.SPACE:
          case bl.QUESTION_MARK:
          case bl.NUM_PLUS:
          case bl.NUM_MINUS:
          case bl.NUM_PERIOD:
          case bl.NUM_DIVISION:
          case bl.SEMICOLON:
          case bl.DASH:
          case bl.EQUALS:
          case bl.COMMA:
          case bl.PERIOD:
          case bl.SLASH:
          case bl.APOSTROPHE:
          case bl.SINGLE_QUOTE:
          case bl.OPEN_SQUARE_BRACKET:
          case bl.BACKSLASH:
          case bl.CLOSE_SQUARE_BRACKET:
            return true;
          default:
            return false;
        }
      } }, yQe = function() {
        for (var s = arguments.length, a = new Array(s), n6 = 0; n6 < s; n6++)
          a[n6] = arguments[n6];
        return a;
      }, aen = F.isValidElement;
      function oen(s, a, n6) {
        return aen(s) ? F.cloneElement(s, typeof n6 == "function" ? n6(s.props || {}) : n6) : a;
      }
      function sen(s, a) {
        return oen(s, s, a);
      }
      var mQe = ["xxl", "xl", "lg", "md", "sm", "xs"], Gse = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, h4 = /* @__PURE__ */ new Map(), IMe = -1, Hse = {}, len2 = { matchHandlers: {}, dispatch: function(s) {
        return Hse = s, h4.forEach(function(a) {
          return a(Hse);
        }), h4.size >= 1;
      }, subscribe: function(s) {
        return h4.size || this.register(), IMe += 1, h4.set(IMe, s), s(Hse), IMe;
      }, unsubscribe: function(s) {
        h4.delete(s), h4.size || this.unregister();
      }, unregister: function() {
        var s = this;
        Object.keys(Gse).forEach(function(a) {
          var n6 = Gse[a], f6 = s.matchHandlers[n6];
          f6 == null || f6.mql.removeListener(f6 == null ? void 0 : f6.listener);
        }), h4.clear();
      }, register: function() {
        var s = this;
        Object.keys(Gse).forEach(function(a) {
          var n6 = Gse[a], f6 = function(y4) {
            var _ = y4.matches;
            s.dispatch(eg(eg({}, Hse), nh({}, a, _)));
          }, d4 = window.matchMedia(n6);
          d4.addListener(f6), s.matchHandlers[n6] = { mql: d4, listener: f6 }, f6(d4);
        });
      } }, bQe = len2, uen = 0, gV = {};
      function Wse(s) {
        var a = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, n6 = uen++, f6 = a;
        function d4() {
          f6 -= 1, f6 <= 0 ? (s(), delete gV[n6]) : gV[n6] = jse(d4);
        }
        return gV[n6] = jse(d4), n6;
      }
      Wse.cancel = function(s) {
        s !== void 0 && (jse.cancel(gV[s]), delete gV[s]);
      }, Wse.ids = gV;
      var EMe;
      function _Qe(s) {
        return !s || s.offsetParent === null || s.hidden;
      }
      function cen(s) {
        var a = (s || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
        return a && a[1] && a[2] && a[3] ? !(a[1] === a[2] && a[2] === a[3]) : true;
      }
      var xQe = function(s) {
        nMe(n6, s);
        var a = iMe(n6);
        function n6() {
          var f6;
          return SX(this, n6), f6 = a.apply(this, arguments), f6.containerRef = F.createRef(), f6.animationStart = false, f6.destroyed = false, f6.onClick = function(d4, y4) {
            var _, S, T = f6.props, E = T.insertExtraNode, O = T.disabled;
            if (!(O || !d4 || _Qe(d4) || d4.className.indexOf("-leave") >= 0)) {
              f6.extraNode = document.createElement("div");
              var R = rMe(f6), V = R.extraNode, z3 = f6.context.getPrefixCls;
              V.className = "".concat(z3(""), "-click-animating-node");
              var H = f6.getAttributeName();
              if (d4.setAttribute(H, "true"), y4 && y4 !== "#ffffff" && y4 !== "rgb(255, 255, 255)" && cen(y4) && !/rgba\((?:\d*, ){3}0\)/.test(y4) && y4 !== "transparent") {
                V.style.borderColor = y4;
                var Z = ((_ = d4.getRootNode) === null || _ === void 0 ? void 0 : _.call(d4)) || d4.ownerDocument, ee = Z instanceof Document ? Z.body : (S = Z.firstChild) !== null && S !== void 0 ? S : Z;
                EMe = OJe(`
      [`.concat(z3(""), "-click-animating-without-extra-node='true']::after, .").concat(z3(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(y4, `;
      }`), "antd-wave", { csp: f6.csp, attachTo: ee });
              }
              E && d4.appendChild(V), ["transition", "animation"].forEach(function(oe) {
                d4.addEventListener("".concat(oe, "start"), f6.onTransitionStart), d4.addEventListener("".concat(oe, "end"), f6.onTransitionEnd);
              });
            }
          }, f6.onTransitionStart = function(d4) {
            if (!f6.destroyed) {
              var y4 = f6.containerRef.current;
              !d4 || d4.target !== y4 || f6.animationStart || f6.resetEffect(y4);
            }
          }, f6.onTransitionEnd = function(d4) {
            !d4 || d4.animationName !== "fadeEffect" || f6.resetEffect(d4.target);
          }, f6.bindAnimationEvent = function(d4) {
            if (!(!d4 || !d4.getAttribute || d4.getAttribute("disabled") || d4.className.indexOf("disabled") >= 0)) {
              var y4 = function(_) {
                if (!(_.target.tagName === "INPUT" || _Qe(_.target))) {
                  f6.resetEffect(d4);
                  var S = getComputedStyle(d4).getPropertyValue("border-top-color") || getComputedStyle(d4).getPropertyValue("border-color") || getComputedStyle(d4).getPropertyValue("background-color");
                  f6.clickWaveTimeoutId = window.setTimeout(function() {
                    return f6.onClick(d4, S);
                  }, 0), Wse.cancel(f6.animationStartId), f6.animationStart = true, f6.animationStartId = Wse(function() {
                    f6.animationStart = false;
                  }, 10);
                }
              };
              return d4.addEventListener("click", y4, true), { cancel: function() {
                d4.removeEventListener("click", y4, true);
              } };
            }
          }, f6.renderWave = function(d4) {
            var y4 = d4.csp, _ = f6.props.children;
            if (f6.csp = y4, !F.isValidElement(_))
              return _;
            var S = f6.containerRef;
            return zJt(_) && (S = BJt(_.ref, f6.containerRef)), sen(_, { ref: S });
          }, f6;
        }
        return CX(n6, [{ key: "componentDidMount", value: function() {
          var f6 = this.containerRef.current;
          !f6 || f6.nodeType !== 1 || (this.instance = this.bindAnimationEvent(f6));
        } }, { key: "componentWillUnmount", value: function() {
          this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
        } }, { key: "getAttributeName", value: function() {
          var f6 = this.context.getPrefixCls, d4 = this.props.insertExtraNode;
          return d4 ? "".concat(f6(""), "-click-animating") : "".concat(f6(""), "-click-animating-without-extra-node");
        } }, { key: "resetEffect", value: function(f6) {
          var d4 = this;
          if (!(!f6 || f6 === this.extraNode || !(f6 instanceof Element))) {
            var y4 = this.props.insertExtraNode, _ = this.getAttributeName();
            f6.setAttribute(_, "false"), EMe && (EMe.innerHTML = ""), y4 && this.extraNode && f6.contains(this.extraNode) && f6.removeChild(this.extraNode), ["transition", "animation"].forEach(function(S) {
              f6.removeEventListener("".concat(S, "start"), d4.onTransitionStart), f6.removeEventListener("".concat(S, "end"), d4.onTransitionEnd);
            });
          }
        } }, { key: "render", value: function() {
          return F.createElement(hQe, null, this.renderWave);
        } }]), n6;
      }(F.Component);
      xQe.contextType = y3;
      var DMe = { exports: {} }, PX = {};
      /** @license React v17.0.2
      * react-jsx-runtime.production.min.js
      *
      * Copyright (c) Facebook, Inc. and its affiliates.
      *
      * This source code is licensed under the MIT license found in the
      * LICENSE file in the root directory of this source tree.
      */
      var fen = L.default, wQe = 60103;
      if (PX.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
        var SQe = Symbol.for;
        wQe = SQe("react.element"), PX.Fragment = SQe("react.fragment");
      }
      var hen = fen.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, pen = Object.prototype.hasOwnProperty, den = { key: true, ref: true, __self: true, __source: true };
      function CQe(s, a, n6) {
        var f6, d4 = {}, y4 = null, _ = null;
        n6 !== void 0 && (y4 = "" + n6), a.key !== void 0 && (y4 = "" + a.key), a.ref !== void 0 && (_ = a.ref);
        for (f6 in a)
          pen.call(a, f6) && !den.hasOwnProperty(f6) && (d4[f6] = a[f6]);
        if (s && s.defaultProps)
          for (f6 in a = s.defaultProps, a)
            d4[f6] === void 0 && (d4[f6] = a[f6]);
        return { $$typeof: wQe, type: s, key: y4, ref: _, props: d4, _owner: hen.current };
      }
      PX.jsx = CQe, PX.jsxs = CQe, DMe.exports = PX;
      const yV = DMe.exports.jsx, ven = DMe.exports.jsxs;
      var gen = M.createContext({}), MQe = gen, yen = function() {
        return EJe() && window.document.documentElement;
      }, Use, men = function() {
        if (!yen())
          return false;
        if (Use !== void 0)
          return Use;
        var s = document.createElement("div");
        return s.style.display = "flex", s.style.flexDirection = "column", s.style.rowGap = "1px", s.appendChild(document.createElement("div")), s.appendChild(document.createElement("div")), document.body.appendChild(s), Use = s.scrollHeight === 1, document.body.removeChild(s), Use;
      }, ben = function() {
        var s = F.useState(false), a = MS(s, 2), n6 = a[0], f6 = a[1];
        return F.useEffect(function() {
          f6(men());
        }, []), n6;
      }, _en = globalThis && globalThis.__rest || function(s, a) {
        var n6 = {};
        for (var f6 in s)
          Object.prototype.hasOwnProperty.call(s, f6) && a.indexOf(f6) < 0 && (n6[f6] = s[f6]);
        if (s != null && typeof Object.getOwnPropertySymbols == "function")
          for (var d4 = 0, f6 = Object.getOwnPropertySymbols(s); d4 < f6.length; d4++)
            a.indexOf(f6[d4]) < 0 && Object.prototype.propertyIsEnumerable.call(s, f6[d4]) && (n6[f6[d4]] = s[f6[d4]]);
        return n6;
      };
      yQe("top", "middle", "bottom", "stretch"), yQe("start", "end", "center", "space-around", "space-between");
      var TQe = F.forwardRef(function(s, a) {
        var n6, f6 = s.prefixCls, d4 = s.justify, y4 = s.align, _ = s.className, S = s.style, T = s.children, E = s.gutter, O = E === void 0 ? 0 : E, R = s.wrap, V = _en(s, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), z3 = F.useContext(y3), H = z3.getPrefixCls, Z = z3.direction, ee = F.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), oe = MS(ee, 2), fe = oe[0], _e = oe[1], pe = ben(), Ve = F.useRef(O);
        F.useEffect(function() {
          var un = bQe.subscribe(function(pn) {
            var On = Ve.current || 0;
            (!Array.isArray(On) && qm(On) === "object" || Array.isArray(On) && (qm(On[0]) === "object" || qm(On[1]) === "object")) && _e(pn);
          });
          return function() {
            return bQe.unsubscribe(un);
          };
        }, []);
        var Le = function() {
          var un = [0, 0], pn = Array.isArray(O) ? O : [O, 0];
          return pn.forEach(function(On, fr) {
            if (qm(On) === "object")
              for (var yr = 0; yr < mQe.length; yr++) {
                var da = mQe[yr];
                if (fe[da] && On[da] !== void 0) {
                  un[fr] = On[da];
                  break;
                }
              }
            else
              un[fr] = On || 0;
          }), un;
        }, je = H("row", f6), Xe = Le(), Ye = hV(je, (n6 = {}, nh(n6, "".concat(je, "-no-wrap"), R === false), nh(n6, "".concat(je, "-").concat(d4), d4), nh(n6, "".concat(je, "-").concat(y4), y4), nh(n6, "".concat(je, "-rtl"), Z === "rtl"), n6), _), rt2 = {}, ut = Xe[0] > 0 ? Xe[0] / -2 : void 0, wt = Xe[1] > 0 ? Xe[1] / -2 : void 0;
        if (ut && (rt2.marginLeft = ut, rt2.marginRight = ut), pe) {
          var dt = MS(Xe, 2);
          rt2.rowGap = dt[1];
        } else
          wt && (rt2.marginTop = wt, rt2.marginBottom = wt);
        var Gt = MS(Xe, 2), Qt = Gt[0], Nt = Gt[1], er = F.useMemo(function() {
          return { gutter: [Qt, Nt], wrap: R, supportFlexGap: pe };
        }, [Qt, Nt, R, pe]);
        return F.createElement(MQe.Provider, { value: er }, F.createElement("div", eg({}, V, { className: Ye, style: eg(eg({}, rt2), S), ref: a }), T));
      });
      TQe.displayName = "Row";
      var xen = TQe, wen = globalThis && globalThis.__rest || function(s, a) {
        var n6 = {};
        for (var f6 in s)
          Object.prototype.hasOwnProperty.call(s, f6) && a.indexOf(f6) < 0 && (n6[f6] = s[f6]);
        if (s != null && typeof Object.getOwnPropertySymbols == "function")
          for (var d4 = 0, f6 = Object.getOwnPropertySymbols(s); d4 < f6.length; d4++)
            a.indexOf(f6[d4]) < 0 && Object.prototype.propertyIsEnumerable.call(s, f6[d4]) && (n6[f6[d4]] = s[f6[d4]]);
        return n6;
      };
      function Sen(s) {
        return typeof s == "number" ? "".concat(s, " ").concat(s, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(s) ? "0 0 ".concat(s) : s;
      }
      var Cen = ["xs", "sm", "md", "lg", "xl", "xxl"], AQe = F.forwardRef(function(s, a) {
        var n6, f6 = F.useContext(y3), d4 = f6.getPrefixCls, y4 = f6.direction, _ = F.useContext(MQe), S = _.gutter, T = _.wrap, E = _.supportFlexGap, O = s.prefixCls, R = s.span, V = s.order, z3 = s.offset, H = s.push, Z = s.pull, ee = s.className, oe = s.children, fe = s.flex, _e = s.style, pe = wen(s, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), Ve = d4("col", O), Le = {};
        Cen.forEach(function(ut) {
          var wt, dt = {}, Gt = s[ut];
          typeof Gt == "number" ? dt.span = Gt : qm(Gt) === "object" && (dt = Gt || {}), delete pe[ut], Le = eg(eg({}, Le), (wt = {}, nh(wt, "".concat(Ve, "-").concat(ut, "-").concat(dt.span), dt.span !== void 0), nh(wt, "".concat(Ve, "-").concat(ut, "-order-").concat(dt.order), dt.order || dt.order === 0), nh(wt, "".concat(Ve, "-").concat(ut, "-offset-").concat(dt.offset), dt.offset || dt.offset === 0), nh(wt, "".concat(Ve, "-").concat(ut, "-push-").concat(dt.push), dt.push || dt.push === 0), nh(wt, "".concat(Ve, "-").concat(ut, "-pull-").concat(dt.pull), dt.pull || dt.pull === 0), nh(wt, "".concat(Ve, "-rtl"), y4 === "rtl"), wt));
        });
        var je = hV(Ve, (n6 = {}, nh(n6, "".concat(Ve, "-").concat(R), R !== void 0), nh(n6, "".concat(Ve, "-order-").concat(V), V), nh(n6, "".concat(Ve, "-offset-").concat(z3), z3), nh(n6, "".concat(Ve, "-push-").concat(H), H), nh(n6, "".concat(Ve, "-pull-").concat(Z), Z), n6), ee, Le), Xe = {};
        if (S && S[0] > 0) {
          var Ye = S[0] / 2;
          Xe.paddingLeft = Ye, Xe.paddingRight = Ye;
        }
        if (S && S[1] > 0 && !E) {
          var rt2 = S[1] / 2;
          Xe.paddingTop = rt2, Xe.paddingBottom = rt2;
        }
        return fe && (Xe.flex = Sen(fe), T === false && !Xe.minWidth && (Xe.minWidth = 0)), F.createElement("div", eg({}, pe, { style: eg(eg({}, Xe), _e), className: je, ref: a }), oe);
      });
      AQe.displayName = "Col";
      var Men = AQe, IQe = F.forwardRef(function(s, a) {
        var n6, f6 = s.prefixCls, d4 = f6 === void 0 ? "rc-switch" : f6, y4 = s.className, _ = s.checked, S = s.defaultChecked, T = s.disabled, E = s.loadingIcon, O = s.checkedChildren, R = s.unCheckedChildren, V = s.onClick, z3 = s.onChange, H = s.onKeyDown, Z = fV(s, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), ee = ien(false, { value: _, defaultValue: S }), oe = MS(ee, 2), fe = oe[0], _e = oe[1];
        function pe(Xe, Ye) {
          var rt2 = fe;
          return T || (rt2 = Xe, _e(rt2), z3 == null || z3(rt2, Ye)), rt2;
        }
        function Ve(Xe) {
          Xe.which === bl.LEFT ? pe(false, Xe) : Xe.which === bl.RIGHT && pe(true, Xe), H == null || H(Xe);
        }
        function Le(Xe) {
          var Ye = pe(!fe, Xe);
          V == null || V(Ye, Xe);
        }
        var je = hV(d4, y4, (n6 = {}, nh(n6, "".concat(d4, "-checked"), fe), nh(n6, "".concat(d4, "-disabled"), T), n6));
        return F.createElement("button", Object.assign({}, Z, { type: "button", role: "switch", "aria-checked": fe, disabled: T, className: je, ref: a, onKeyDown: Ve, onClick: Le }), E, F.createElement("span", { className: "".concat(d4, "-inner") }, fe ? O : R));
      });
      IQe.displayName = "Switch";
      var Ten = globalThis && globalThis.__rest || function(s, a) {
        var n6 = {};
        for (var f6 in s)
          Object.prototype.hasOwnProperty.call(s, f6) && a.indexOf(f6) < 0 && (n6[f6] = s[f6]);
        if (s != null && typeof Object.getOwnPropertySymbols == "function")
          for (var d4 = 0, f6 = Object.getOwnPropertySymbols(s); d4 < f6.length; d4++)
            a.indexOf(f6[d4]) < 0 && Object.prototype.propertyIsEnumerable.call(s, f6[d4]) && (n6[f6[d4]] = s[f6[d4]]);
        return n6;
      }, kMe = F.forwardRef(function(s, a) {
        var n6, f6 = s.prefixCls, d4 = s.size, y4 = s.loading, _ = s.className, S = _ === void 0 ? "" : _, T = s.disabled, E = Ten(s, ["prefixCls", "size", "loading", "className", "disabled"]);
        zQt("checked" in E || !("value" in E), "Switch", "`value` is not a valid prop, do you mean `checked`?");
        var O = F.useContext(y3), R = O.getPrefixCls, V = O.direction, z3 = F.useContext(ren), H = R("switch", f6), Z = F.createElement("div", { className: "".concat(H, "-handle") }, y4 && F.createElement(DJt, { className: "".concat(H, "-loading-icon") })), ee = hV((n6 = {}, nh(n6, "".concat(H, "-small"), (d4 || z3) === "small"), nh(n6, "".concat(H, "-loading"), y4), nh(n6, "".concat(H, "-rtl"), V === "rtl"), n6), S);
        return F.createElement(xQe, { insertExtraNode: true }, F.createElement(IQe, eg({}, E, { prefixCls: H, className: ee, disabled: T || y4, ref: a, loadingIcon: Z })));
      });
      kMe.__ANT_SWITCH = true, kMe.displayName = "Switch";
      var Aen = kMe, Ien = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, Een = {};
      (function(s) {
        var a = Object.defineProperty, n6 = Object.getOwnPropertySymbols, f6 = Object.prototype.hasOwnProperty, d4 = Object.prototype.propertyIsEnumerable, y4 = (ye, Ge, xe) => Ge in ye ? a(ye, Ge, { enumerable: true, configurable: true, writable: true, value: xe }) : ye[Ge] = xe, _ = (ye, Ge) => {
          for (var xe in Ge || (Ge = {}))
            f6.call(Ge, xe) && y4(ye, xe, Ge[xe]);
          if (n6)
            for (var xe of n6(Ge))
              d4.call(Ge, xe) && y4(ye, xe, Ge[xe]);
          return ye;
        }, S = (ye, Ge, xe) => (y4(ye, typeof Ge != "symbol" ? Ge + "" : Ge, xe), xe);
        Object.defineProperties(s, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
        var T = L.default;
        function E(ye) {
          return ye && typeof ye == "object" && "default" in ye ? ye : { default: ye };
        }
        function O(ye) {
          if (ye && ye.__esModule)
            return ye;
          var Ge = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
          return ye && Object.keys(ye).forEach(function(xe) {
            if (xe !== "default") {
              var Se = Object.getOwnPropertyDescriptor(ye, xe);
              Object.defineProperty(Ge, xe, Se.get ? Se : { enumerable: true, get: function() {
                return ye[xe];
              } });
            }
          }), Ge.default = ye, Object.freeze(Ge);
        }
        var R = E(T), V = O(T);
        class z3 {
          constructor() {
            S(this, "chartsEmitters", /* @__PURE__ */ new Map()), S(this, "add", (Ge, xe, Se, Ce) => {
              xe && Se ? this.chartsEmitters.set(Ge, { chart: xe, option: Se, title: Ce }) : console.log("\u6DFB\u52A0\u5931\u8D25");
            }), S(this, "get", (Ge) => this.chartsEmitters.get(Ge)), S(this, "clear", () => {
              this.chartsEmitters.clear();
            }), S(this, "delete", (Ge) => {
              this.chartsEmitters.delete(Ge);
            }), S(this, "list", () => {
              var Ge, xe, Se;
              const Ce = [];
              for (const Re of this.chartsEmitters.keys())
                Ce.push({ id: Re, chart: (Ge = this.chartsEmitters.get(Re)) == null ? void 0 : Ge.chart, option: (xe = this.chartsEmitters.get(Re)) == null ? void 0 : xe.option, title: (Se = this.chartsEmitters.get(Re)) == null ? void 0 : Se.title });
              return Ce;
            });
          }
        }
        const H = new z3();
        var Z = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof bt != "undefined" ? bt : typeof self != "undefined" ? self : {};
        function ee(ye) {
          return ye && ye.__esModule && Object.prototype.hasOwnProperty.call(ye, "default") ? ye.default : ye;
        }
        var oe = { exports: {} };
        /**
        * @license
        * Lodash <https://lodash.com/>
        * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
        * Released under MIT license <https://lodash.com/license>
        * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
        * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
        */
        (function(ye, Ge) {
          (function() {
            var xe, Se = "4.17.21", Ce = 200, Re = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", at = "Expected a function", ft = "Invalid `variable` option passed into `_.template`", st = "__lodash_hash_undefined__", Dt = 500, Pt = "__lodash_placeholder__", tn = 1, Fn = 2, Un = 4, qn = 1, nr = 2, sr = 1, Ii = 2, gi = 4, Sa = 8, Tt = 16, Ar = 32, Vr = 64, Si = 128, mi = 256, Dr = 512, Gr = 30, Vi = "...", ya = 800, xr = 16, Ro = 1, Oo = 2, pi = 3, xs = 1 / 0, Ti = 9007199254740991, si = 17976931348623157e292, ni = 0 / 0, ja = 4294967295, Ta = ja - 1, Ws = ja >>> 1, Uu = [["ary", Si], ["bind", sr], ["bindKey", Ii], ["curry", Sa], ["curryRight", Tt], ["flip", Dr], ["partial", Ar], ["partialRight", Vr], ["rearg", mi]], Su = "[object Arguments]", hl = "[object Array]", Tf = "[object AsyncFunction]", Cu = "[object Boolean]", Lc = "[object Date]", Eh = "[object DOMException]", B0 = "[object Error]", qy = "[object Function]", vp = "[object GeneratorFunction]", Ap = "[object Map]", ig = "[object Number]", $y = "[object Null]", Ed = "[object Object]", z0 = "[object Promise]", ws = "[object Proxy]", ag = "[object RegExp]", gp = "[object Set]", Yh = "[object String]", Ip = "[object Symbol]", Jm = "[object Undefined]", qi = "[object WeakMap]", Rr = "[object WeakSet]", qr = "[object ArrayBuffer]", Yi = "[object DataView]", to = "[object Float32Array]", is = "[object Float64Array]", Bl = "[object Int8Array]", zl = "[object Int16Array]", $c = "[object Int32Array]", Dh = "[object Uint8Array]", Sc = "[object Uint8ClampedArray]", lc = "[object Uint16Array]", Af = "[object Uint32Array]", Cv = /\b__p \+= '';/g, Mv = /\b(__p \+=) '' \+/g, Qm = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Hg = /&(?:amp|lt|gt|quot|#39);/g, ih = /[&<>"']/g, Ou = RegExp(Hg.source), ud = RegExp(ih.source), Tv = /<%-([\s\S]+?)%>/g, j0 = /<%([\s\S]+?)%>/g, Wg = /<%=([\s\S]+?)%>/g, Ug = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, G0 = /^\w*$/, Sx = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, Cx = /[\\^$.*+?()[\]{}|]/g, iD = RegExp(Cx.source), Mx = /^\s+/, LC = /\s/, aD = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, nA = /\{\n\/\* \[wrapped with (.+)\] \*/, L3 = /,? & /, e_ = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, dn = /[()=,{}\[\]\/\s]/, Dn = /\\(\\)?/g, Ot = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, gn = /\w*$/, wn = /^[-+]0x[0-9a-f]+$/i, Fr = /^0b[01]+$/i, Ri = /^\[object .+?Constructor\]$/, di = /^0o[0-7]+$/i, ur = /^(?:0|[1-9]\d*)$/, xa = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, Go = /($^)/, ou = /['\n\r\u2028\u2029\\]/g, Xl = "\\ud800-\\udfff", El = "\\u0300-\\u036f", js = "\\ufe20-\\ufe2f", vf = "\\u20d0-\\u20ff", kh = El + js + vf, pl = "\\u2700-\\u27bf", Oh = "a-z\\xdf-\\xf6\\xf8-\\xff", Av = "\\xac\\xb1\\xd7\\xf7", ib = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", RS = "\\u2000-\\u206f", e1 = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", RC = "A-Z\\xc0-\\xd6\\xd8-\\xde", Tx = "\\ufe0e\\ufe0f", Dd = Av + ib + RS + e1, ab = "['\u2019]", kd = "[" + Xl + "]", t_ = "[" + Dd + "]", Ep = "[" + kh + "]", NC = "\\d+", oD = "[" + pl + "]", Xy = "[" + Oh + "]", Ax = "[^" + Xl + Dd + NC + pl + Oh + RC + "]", Ix = "\\ud83c[\\udffb-\\udfff]", ev = "(?:" + Ep + "|" + Ix + ")", sD = "[^" + Xl + "]", ob = "(?:\\ud83c[\\udde6-\\uddff]){2}", NS = "[\\ud800-\\udbff][\\udc00-\\udfff]", FC = "[" + RC + "]", QV = "\\u200d", eB = "(?:" + Xy + "|" + Ax + ")", xY = "(?:" + FC + "|" + Ax + ")", j4 = "(?:" + ab + "(?:d|ll|m|re|s|t|ve))?", G4 = "(?:" + ab + "(?:D|LL|M|RE|S|T|VE))?", tB = ev + "?", H4 = "[" + Tx + "]?", R3 = "(?:" + QV + "(?:" + [sD, ob, NS].join("|") + ")" + H4 + tB + ")*", wY = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", nB = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", W4 = H4 + tB + R3, rB = "(?:" + [oD, ob, NS].join("|") + ")" + W4, U4 = "(?:" + [sD + Ep + "?", Ep, ob, NS, kd].join("|") + ")", q4 = RegExp(ab, "g"), og = RegExp(Ep, "g"), lD = RegExp(Ix + "(?=" + Ix + ")|" + U4 + W4, "g"), iB = RegExp([FC + "?" + Xy + "+" + j4 + "(?=" + [t_, FC, "$"].join("|") + ")", xY + "+" + G4 + "(?=" + [t_, FC + eB, "$"].join("|") + ")", FC + "?" + eB + "+" + j4, FC + "+" + G4, nB, wY, NC, rB].join("|"), "g"), SY = RegExp("[" + QV + Xl + kh + Tx + "]"), CY = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, t1 = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], $4 = -1, Ph = {};
            Ph[to] = Ph[is] = Ph[Bl] = Ph[zl] = Ph[$c] = Ph[Dh] = Ph[Sc] = Ph[lc] = Ph[Af] = true, Ph[Su] = Ph[hl] = Ph[qr] = Ph[Cu] = Ph[Yi] = Ph[Lc] = Ph[B0] = Ph[qy] = Ph[Ap] = Ph[ig] = Ph[Ed] = Ph[ag] = Ph[gp] = Ph[Yh] = Ph[qi] = false;
            var Xf = {};
            Xf[Su] = Xf[hl] = Xf[qr] = Xf[Yi] = Xf[Cu] = Xf[Lc] = Xf[to] = Xf[is] = Xf[Bl] = Xf[zl] = Xf[$c] = Xf[Ap] = Xf[ig] = Xf[Ed] = Xf[ag] = Xf[gp] = Xf[Yh] = Xf[Ip] = Xf[Dh] = Xf[Sc] = Xf[lc] = Xf[Af] = true, Xf[B0] = Xf[qy] = Xf[qi] = false;
            var X4 = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, aB = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, Y4 = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, MY = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, oB = parseFloat, TY = parseInt, N3 = typeof Z == "object" && Z && Z.Object === Object && Z, sB = typeof self == "object" && self && self.Object === Object && self, Dp = N3 || sB || Function("return this")(), F3 = Ge && !Ge.nodeType && Ge, FS = F3 && true && ye && !ye.nodeType && ye, lB = FS && FS.exports === F3, K4 = lB && N3.process, n1 = function() {
              try {
                var ir = FS && FS.require && FS.require("util").types;
                return ir || K4 && K4.binding && K4.binding("util");
              } catch {
              }
            }(), rA = n1 && n1.isArrayBuffer, uB = n1 && n1.isDate, cB = n1 && n1.isMap, uD = n1 && n1.isRegExp, V3 = n1 && n1.isSet, Z4 = n1 && n1.isTypedArray;
            function Yy(ir, li, ui) {
              switch (ui.length) {
                case 0:
                  return ir.call(li);
                case 1:
                  return ir.call(li, ui[0]);
                case 2:
                  return ir.call(li, ui[0], ui[1]);
                case 3:
                  return ir.call(li, ui[0], ui[1], ui[2]);
              }
              return ir.apply(li, ui);
            }
            function AY(ir, li, ui, go) {
              for (var Ll = -1, Rc = ir == null ? 0 : ir.length; ++Ll < Rc; ) {
                var Ld = ir[Ll];
                li(go, Ld, ui(Ld), ir);
              }
              return go;
            }
            function qg(ir, li) {
              for (var ui = -1, go = ir == null ? 0 : ir.length; ++ui < go && li(ir[ui], ui, ir) !== false; )
                ;
              return ir;
            }
            function IY(ir, li) {
              for (var ui = ir == null ? 0 : ir.length; ui-- && li(ir[ui], ui, ir) !== false; )
                ;
              return ir;
            }
            function fB(ir, li) {
              for (var ui = -1, go = ir == null ? 0 : ir.length; ++ui < go; )
                if (!li(ir[ui], ui, ir))
                  return false;
              return true;
            }
            function Ex(ir, li) {
              for (var ui = -1, go = ir == null ? 0 : ir.length, Ll = 0, Rc = []; ++ui < go; ) {
                var Ld = ir[ui];
                li(Ld, ui, ir) && (Rc[Ll++] = Ld);
              }
              return Rc;
            }
            function iA(ir, li) {
              var ui = ir == null ? 0 : ir.length;
              return !!ui && BS(ir, li, 0) > -1;
            }
            function J4(ir, li, ui) {
              for (var go = -1, Ll = ir == null ? 0 : ir.length; ++go < Ll; )
                if (ui(li, ir[go]))
                  return true;
              return false;
            }
            function jl(ir, li) {
              for (var ui = -1, go = ir == null ? 0 : ir.length, Ll = Array(go); ++ui < go; )
                Ll[ui] = li(ir[ui], ui, ir);
              return Ll;
            }
            function r1(ir, li) {
              for (var ui = -1, go = li.length, Ll = ir.length; ++ui < go; )
                ir[Ll + ui] = li[ui];
              return ir;
            }
            function B3(ir, li, ui, go) {
              var Ll = -1, Rc = ir == null ? 0 : ir.length;
              for (go && Rc && (ui = ir[++Ll]); ++Ll < Rc; )
                ui = li(ui, ir[Ll], Ll, ir);
              return ui;
            }
            function VS(ir, li, ui, go) {
              var Ll = ir == null ? 0 : ir.length;
              for (go && Ll && (ui = ir[--Ll]); Ll--; )
                ui = li(ui, ir[Ll], Ll, ir);
              return ui;
            }
            function cD(ir, li) {
              for (var ui = -1, go = ir == null ? 0 : ir.length; ++ui < go; )
                if (li(ir[ui], ui, ir))
                  return true;
              return false;
            }
            var Q4 = fD("length");
            function z32(ir) {
              return ir.split("");
            }
            function EY(ir) {
              return ir.match(e_) || [];
            }
            function j3(ir, li, ui) {
              var go;
              return ui(ir, function(Ll, Rc, Ld) {
                if (li(Ll, Rc, Ld))
                  return go = Rc, false;
              }), go;
            }
            function G3(ir, li, ui, go) {
              for (var Ll = ir.length, Rc = ui + (go ? 1 : -1); go ? Rc-- : ++Rc < Ll; )
                if (li(ir[Rc], Rc, ir))
                  return Rc;
              return -1;
            }
            function BS(ir, li, ui) {
              return li === li ? vB(ir, li, ui) : G3(ir, gf, ui);
            }
            function e6(ir, li, ui, go) {
              for (var Ll = ui - 1, Rc = ir.length; ++Ll < Rc; )
                if (go(ir[Ll], li))
                  return Ll;
              return -1;
            }
            function gf(ir) {
              return ir !== ir;
            }
            function Od(ir, li) {
              var ui = ir == null ? 0 : ir.length;
              return ui ? VC(ir, li) / ui : ni;
            }
            function fD(ir) {
              return function(li) {
                return li == null ? xe : li[ir];
              };
            }
            function zS(ir) {
              return function(li) {
                return ir == null ? xe : ir[li];
              };
            }
            function hD(ir, li, ui, go, Ll) {
              return Ll(ir, function(Rc, Ld, If) {
                ui = go ? (go = false, Rc) : li(ui, Rc, Ld, If);
              }), ui;
            }
            function pD(ir, li) {
              var ui = ir.length;
              for (ir.sort(li); ui--; )
                ir[ui] = ir[ui].value;
              return ir;
            }
            function VC(ir, li) {
              for (var ui, go = -1, Ll = ir.length; ++go < Ll; ) {
                var Rc = li(ir[go]);
                Rc !== xe && (ui = ui === xe ? Rc : ui + Rc);
              }
              return ui;
            }
            function jS(ir, li) {
              for (var ui = -1, go = Array(ir); ++ui < ir; )
                go[ui] = li(ui);
              return go;
            }
            function dD(ir, li) {
              return jl(li, function(ui) {
                return [ui, ir[ui]];
              });
            }
            function vD(ir) {
              return ir && ir.slice(0, ah(ir) + 1).replace(Mx, "");
            }
            function Iv(ir) {
              return function(li) {
                return ir(li);
              };
            }
            function BC(ir, li) {
              return jl(li, function(ui) {
                return ir[ui];
              });
            }
            function GS(ir, li) {
              return ir.has(li);
            }
            function hB(ir, li) {
              for (var ui = -1, go = ir.length; ++ui < go && BS(li, ir[ui], 0) > -1; )
                ;
              return ui;
            }
            function gD(ir, li) {
              for (var ui = ir.length; ui-- && BS(li, ir[ui], 0) > -1; )
                ;
              return ui;
            }
            function zC(ir, li) {
              for (var ui = ir.length, go = 0; ui--; )
                ir[ui] === li && ++go;
              return go;
            }
            var H3 = zS(X4), DY = zS(aB);
            function kY(ir) {
              return "\\" + MY[ir];
            }
            function t6(ir, li) {
              return ir == null ? xe : ir[li];
            }
            function Pd(ir) {
              return SY.test(ir);
            }
            function pB(ir) {
              return CY.test(ir);
            }
            function n62(ir) {
              for (var li, ui = []; !(li = ir.next()).done; )
                ui.push(li.value);
              return ui;
            }
            function r6(ir) {
              var li = -1, ui = Array(ir.size);
              return ir.forEach(function(go, Ll) {
                ui[++li] = [Ll, go];
              }), ui;
            }
            function dB(ir, li) {
              return function(ui) {
                return ir(li(ui));
              };
            }
            function HS(ir, li) {
              for (var ui = -1, go = ir.length, Ll = 0, Rc = []; ++ui < go; ) {
                var Ld = ir[ui];
                (Ld === li || Ld === Pt) && (ir[ui] = Pt, Rc[Ll++] = ui);
              }
              return Rc;
            }
            function W3(ir) {
              var li = -1, ui = Array(ir.size);
              return ir.forEach(function(go) {
                ui[++li] = go;
              }), ui;
            }
            function OY(ir) {
              var li = -1, ui = Array(ir.size);
              return ir.forEach(function(go) {
                ui[++li] = [go, go];
              }), ui;
            }
            function vB(ir, li, ui) {
              for (var go = ui - 1, Ll = ir.length; ++go < Ll; )
                if (ir[go] === li)
                  return go;
              return -1;
            }
            function PY(ir, li, ui) {
              for (var go = ui + 1; go--; )
                if (ir[go] === li)
                  return go;
              return go;
            }
            function vu(ir) {
              return Pd(ir) ? i6(ir) : Q4(ir);
            }
            function sg(ir) {
              return Pd(ir) ? gB(ir) : z32(ir);
            }
            function ah(ir) {
              for (var li = ir.length; li-- && LC.test(ir.charAt(li)); )
                ;
              return li;
            }
            var $g = zS(Y4);
            function i6(ir) {
              for (var li = lD.lastIndex = 0; lD.test(ir); )
                ++li;
              return li;
            }
            function gB(ir) {
              return ir.match(lD) || [];
            }
            function H0(ir) {
              return ir.match(iB) || [];
            }
            var Pl = function ir(li) {
              li = li == null ? Dp : Dx.defaults(Dp.Object(), li, Dx.pick(Dp, t1));
              var ui = li.Array, go = li.Date, Ll = li.Error, Rc = li.Function, Ld = li.Math, If = li.Object, a6 = li.RegExp, o6 = li.String, W0 = li.TypeError, Kh = ui.prototype, yB = Rc.prototype, Yf = If.prototype, oh = li["__core-js_shared__"], sh = yB.toString, yf = Yf.hasOwnProperty, mB = 0, bB = function() {
                var X = /[^.]+$/.exec(oh && oh.keys && oh.keys.IE_PROTO || "");
                return X ? "Symbol(src)_1." + X : "";
              }(), U3 = Yf.toString, LY = sh.call(If), _B = Dp._, xB = a6("^" + sh.call(yf).replace(Cx, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), aA = lB ? li.Buffer : xe, i1 = li.Symbol, WS = li.Uint8Array, oA = aA ? aA.allocUnsafe : xe, yD = dB(If.getPrototypeOf, If), mD = If.create, Rd = Yf.propertyIsEnumerable, kx = Kh.splice, wB = i1 ? i1.isConcatSpreadable : xe, gu = i1 ? i1.iterator : xe, jC = i1 ? i1.toStringTag : xe, q3 = function() {
                try {
                  var X = Hr(If, "defineProperty");
                  return X({}, "", {}), X;
                } catch {
                }
              }(), RY = li.clearTimeout !== Dp.clearTimeout && li.clearTimeout, SB = go && go.now !== Dp.Date.now && go.now, Ox = li.setTimeout !== Dp.setTimeout && li.setTimeout, Rl = Ld.ceil, bD = Ld.floor, U0 = If.getOwnPropertySymbols, CB = aA ? aA.isBuffer : xe, MB = li.isFinite, mf = Kh.join, NY = dB(If.keys, If), cd = Ld.max, Nd = Ld.min, s6 = go.now, FY = li.parseInt, sA = Ld.random, l6 = Kh.reverse, _D = Hr(li, "DataView"), Px = Hr(li, "Map"), Xg = Hr(li, "Promise"), GC = Hr(li, "Set"), lA = Hr(li, "WeakMap"), xD = Hr(If, "create"), wD = lA && new lA(), uA = {}, fd = ci(_D), US = ci(Px), HC = ci(Xg), $3 = ci(GC), SD = ci(lA), CD = i1 ? i1.prototype : xe, cA = CD ? CD.valueOf : xe, kp = CD ? CD.toString : xe;
              function Bt(X) {
                if (gd(X) && !ba(X) && !(X instanceof qu)) {
                  if (X instanceof Ky)
                    return X;
                  if (yf.call(X, "__wrapped__"))
                    return Ca(X);
                }
                return new Ky(X);
              }
              var fA = function() {
                function X() {
                }
                return function(le) {
                  if (!Qh(le))
                    return {};
                  if (mD)
                    return mD(le);
                  X.prototype = le;
                  var Ae = new X();
                  return X.prototype = xe, Ae;
                };
              }();
              function X3() {
              }
              function Ky(X, le) {
                this.__wrapped__ = X, this.__actions__ = [], this.__chain__ = !!le, this.__index__ = 0, this.__values__ = xe;
              }
              Bt.templateSettings = { escape: Tv, evaluate: j0, interpolate: Wg, variable: "", imports: { _: Bt } }, Bt.prototype = X3.prototype, Bt.prototype.constructor = Bt, Ky.prototype = fA(X3.prototype), Ky.prototype.constructor = Ky;
              function qu(X) {
                this.__wrapped__ = X, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = ja, this.__views__ = [];
              }
              function VY() {
                var X = new qu(this.__wrapped__);
                return X.__actions__ = Ct(this.__actions__), X.__dir__ = this.__dir__, X.__filtered__ = this.__filtered__, X.__iteratees__ = Ct(this.__iteratees__), X.__takeCount__ = this.__takeCount__, X.__views__ = Ct(this.__views__), X;
              }
              function u6() {
                if (this.__filtered__) {
                  var X = new qu(this);
                  X.__dir__ = -1, X.__filtered__ = true;
                } else
                  X = this.clone(), X.__dir__ *= -1;
                return X;
              }
              function c6() {
                var X = this.__wrapped__.value(), le = this.__dir__, Ae = ba(X), et = le < 0, It = Ae ? X.length : 0, an = uu(0, It, this.__views__), Vn = an.start, tr = an.end, Tr = tr - Vn, sa = et ? tr : Vn - 1, fa = this.__iteratees__, Ea = fa.length, eo = 0, ts = Nd(Tr, this.__takeCount__);
                if (!Ae || !et && It == Tr && ts == Tr)
                  return He(X, this.__actions__);
                var tl = [];
                e:
                  for (; Tr-- && eo < ts; ) {
                    sa += le;
                    for (var Au = -1, $s = X[sa]; ++Au < Ea; ) {
                      var uc = fa[Au], Ic = uc.iteratee, f1 = uc.type, r0 = Ic($s);
                      if (f1 == Oo)
                        $s = r0;
                      else if (!r0) {
                        if (f1 == Ro)
                          continue e;
                        break e;
                      }
                    }
                    tl[eo++] = $s;
                  }
                return tl;
              }
              qu.prototype = fA(X3.prototype), qu.prototype.constructor = qu;
              function qS(X) {
                var le = -1, Ae = X == null ? 0 : X.length;
                for (this.clear(); ++le < Ae; ) {
                  var et = X[le];
                  this.set(et[0], et[1]);
                }
              }
              function BY() {
                this.__data__ = xD ? xD(null) : {}, this.size = 0;
              }
              function f62(X) {
                var le = this.has(X) && delete this.__data__[X];
                return this.size -= le ? 1 : 0, le;
              }
              function zY(X) {
                var le = this.__data__;
                if (xD) {
                  var Ae = le[X];
                  return Ae === st ? xe : Ae;
                }
                return yf.call(le, X) ? le[X] : xe;
              }
              function Y3(X) {
                var le = this.__data__;
                return xD ? le[X] !== xe : yf.call(le, X);
              }
              function TB(X, le) {
                var Ae = this.__data__;
                return this.size += this.has(X) ? 0 : 1, Ae[X] = xD && le === xe ? st : le, this;
              }
              qS.prototype.clear = BY, qS.prototype.delete = f62, qS.prototype.get = zY, qS.prototype.has = Y3, qS.prototype.set = TB;
              function hd(X) {
                var le = -1, Ae = X == null ? 0 : X.length;
                for (this.clear(); ++le < Ae; ) {
                  var et = X[le];
                  this.set(et[0], et[1]);
                }
              }
              function AB() {
                this.__data__ = [], this.size = 0;
              }
              function h6(X) {
                var le = this.__data__, Ae = J3(le, X);
                if (Ae < 0)
                  return false;
                var et = le.length - 1;
                return Ae == et ? le.pop() : kx.call(le, Ae, 1), --this.size, true;
              }
              function IB(X) {
                var le = this.__data__, Ae = J3(le, X);
                return Ae < 0 ? xe : le[Ae][1];
              }
              function hA(X) {
                return J3(this.__data__, X) > -1;
              }
              function jY(X, le) {
                var Ae = this.__data__, et = J3(Ae, X);
                return et < 0 ? (++this.size, Ae.push([X, le])) : Ae[et][1] = le, this;
              }
              hd.prototype.clear = AB, hd.prototype.delete = h6, hd.prototype.get = IB, hd.prototype.has = hA, hd.prototype.set = jY;
              function Lx(X) {
                var le = -1, Ae = X == null ? 0 : X.length;
                for (this.clear(); ++le < Ae; ) {
                  var et = X[le];
                  this.set(et[0], et[1]);
                }
              }
              function EB() {
                this.size = 0, this.__data__ = { hash: new qS(), map: new (Px || hd)(), string: new qS() };
              }
              function p6(X) {
                var le = $i(this, X).delete(X);
                return this.size -= le ? 1 : 0, le;
              }
              function MD(X) {
                return $i(this, X).get(X);
              }
              function DB(X) {
                return $i(this, X).has(X);
              }
              function kB(X, le) {
                var Ae = $i(this, X), et = Ae.size;
                return Ae.set(X, le), this.size += Ae.size == et ? 0 : 1, this;
              }
              Lx.prototype.clear = EB, Lx.prototype.delete = p6, Lx.prototype.get = MD, Lx.prototype.has = DB, Lx.prototype.set = kB;
              function $S(X) {
                var le = -1, Ae = X == null ? 0 : X.length;
                for (this.__data__ = new Lx(); ++le < Ae; )
                  this.add(X[le]);
              }
              function d6(X) {
                return this.__data__.set(X, st), this;
              }
              function GY(X) {
                return this.__data__.has(X);
              }
              $S.prototype.add = $S.prototype.push = d6, $S.prototype.has = GY;
              function sb(X) {
                var le = this.__data__ = new hd(X);
                this.size = le.size;
              }
              function HY() {
                this.__data__ = new hd(), this.size = 0;
              }
              function WY(X) {
                var le = this.__data__, Ae = le.delete(X);
                return this.size = le.size, Ae;
              }
              function K3(X) {
                return this.__data__.get(X);
              }
              function UY(X) {
                return this.__data__.has(X);
              }
              function qY(X, le) {
                var Ae = this.__data__;
                if (Ae instanceof hd) {
                  var et = Ae.__data__;
                  if (!Px || et.length < Ce - 1)
                    return et.push([X, le]), this.size = ++Ae.size, this;
                  Ae = this.__data__ = new Lx(et);
                }
                return Ae.set(X, le), this.size = Ae.size, this;
              }
              sb.prototype.clear = HY, sb.prototype.delete = WY, sb.prototype.get = K3, sb.prototype.has = UY, sb.prototype.set = qY;
              function OB(X, le) {
                var Ae = ba(X), et = !Ae && ri(X), It = !Ae && !et && YS(X), an = !Ae && !et && !It && vO(X), Vn = Ae || et || It || an, tr = Vn ? jS(X.length, o6) : [], Tr = tr.length;
                for (var sa in X)
                  (le || yf.call(X, sa)) && !(Vn && (sa == "length" || It && (sa == "offset" || sa == "parent") || an && (sa == "buffer" || sa == "byteLength" || sa == "byteOffset") || rv(sa, Tr))) && tr.push(sa);
                return tr;
              }
              function PB(X) {
                var le = X.length;
                return le ? X[re(0, le - 1)] : xe;
              }
              function LB(X, le) {
                return Sn(Ct(X), WC(le, 0, X.length));
              }
              function $Y(X) {
                return Sn(Ct(X));
              }
              function Z3(X, le, Ae) {
                (Ae !== xe && !Y0(X[le], Ae) || Ae === xe && !(le in X)) && lb2(X, le, Ae);
              }
              function Ev(X, le, Ae) {
                var et = X[le];
                (!(yf.call(X, le) && Y0(et, Ae)) || Ae === xe && !(le in X)) && lb2(X, le, Ae);
              }
              function J3(X, le) {
                for (var Ae = X.length; Ae--; )
                  if (Y0(X[Ae][0], le))
                    return Ae;
                return -1;
              }
              function RB(X, le, Ae, et) {
                return ub(X, function(It, an, Vn) {
                  le(et, It, Ae(It), Vn);
                }), et;
              }
              function NB(X, le) {
                return X && dr(le, qs(le), X);
              }
              function XY2(X, le) {
                return X && dr(le, c1(le), X);
              }
              function lb2(X, le, Ae) {
                le == "__proto__" && q3 ? q3(X, le, { configurable: true, enumerable: true, value: Ae, writable: true }) : X[le] = Ae;
              }
              function v6(X, le) {
                for (var Ae = -1, et = le.length, It = ui(et), an = X == null; ++Ae < et; )
                  It[Ae] = an ? xe : RD(X, le[Ae]);
                return It;
              }
              function WC(X, le, Ae) {
                return X === X && (Ae !== xe && (X = X <= Ae ? X : Ae), le !== xe && (X = X >= le ? X : le)), X;
              }
              function a1(X, le, Ae, et, It, an) {
                var Vn, tr = le & tn, Tr = le & Fn, sa = le & Un;
                if (Ae && (Vn = It ? Ae(X, et, It, an) : Ae(X)), Vn !== xe)
                  return Vn;
                if (!Qh(X))
                  return X;
                var fa = ba(X);
                if (fa) {
                  if (Vn = Rh(X), !tr)
                    return Ct(X, Vn);
                } else {
                  var Ea = Os(X), eo = Ea == qy || Ea == vp;
                  if (YS(X))
                    return Lt(X, tr);
                  if (Ea == Ed || Ea == Su || eo && !It) {
                    if (Vn = Tr || eo ? {} : vd(X), !tr)
                      return Tr ? Ci(X, XY2(Vn, X)) : Wr(X, NB(Vn, X));
                  } else {
                    if (!Xf[Ea])
                      return It ? X : {};
                    Vn = Nh(X, Ea, tr);
                  }
                }
                an || (an = new sb());
                var ts = an.get(X);
                if (ts)
                  return ts;
                an.set(X, Vn), dO(X) ? X.forEach(function($s) {
                  Vn.add(a1($s, le, Ae, $s, X, an));
                }) : hue(X) && X.forEach(function($s, uc) {
                  Vn.set(uc, a1($s, le, Ae, uc, X, an));
                });
                var tl = sa ? Tr ? s1 : i_ : Tr ? c1 : qs, Au = fa ? xe : tl(X);
                return qg(Au || X, function($s, uc) {
                  Au && (uc = $s, $s = X[uc]), Ev(Vn, uc, a1($s, le, Ae, uc, X, an));
                }), Vn;
              }
              function YY(X) {
                var le = qs(X);
                return function(Ae) {
                  return FB(Ae, X, le);
                };
              }
              function FB(X, le, Ae) {
                var et = Ae.length;
                if (X == null)
                  return !et;
                for (X = If(X); et--; ) {
                  var It = Ae[et], an = le[It], Vn = X[It];
                  if (Vn === xe && !(It in X) || !an(Vn))
                    return false;
                }
                return true;
              }
              function TD(X, le, Ae) {
                if (typeof X != "function")
                  throw new W0(at);
                return Tn(function() {
                  X.apply(xe, Ae);
                }, le);
              }
              function UC(X, le, Ae, et) {
                var It = -1, an = iA, Vn = true, tr = X.length, Tr = [], sa = le.length;
                if (!tr)
                  return Tr;
                Ae && (le = jl(le, Iv(Ae))), et ? (an = J4, Vn = false) : le.length >= Ce && (an = GS, Vn = false, le = new $S(le));
                e:
                  for (; ++It < tr; ) {
                    var fa = X[It], Ea = Ae == null ? fa : Ae(fa);
                    if (fa = et || fa !== 0 ? fa : 0, Vn && Ea === Ea) {
                      for (var eo = sa; eo--; )
                        if (le[eo] === Ea)
                          continue e;
                      Tr.push(fa);
                    } else
                      an(le, Ea, et) || Tr.push(fa);
                  }
                return Tr;
              }
              var ub = $r(Zy), pA = $r(eO, true);
              function KY(X, le) {
                var Ae = true;
                return ub(X, function(et, It, an) {
                  return Ae = !!le(et, It, an), Ae;
                }), Ae;
              }
              function Q3(X, le, Ae) {
                for (var et = -1, It = X.length; ++et < It; ) {
                  var an = X[et], Vn = le(an);
                  if (Vn != null && (tr === xe ? Vn === Vn && !K0(Vn) : Ae(Vn, tr)))
                    var tr = Vn, Tr = an;
                }
                return Tr;
              }
              function g6(X, le, Ae, et) {
                var It = X.length;
                for (Ae = Tu(Ae), Ae < 0 && (Ae = -Ae > It ? 0 : It + Ae), et = et === xe || et > It ? It : Tu(et), et < 0 && (et += It), et = Ae > et ? 0 : gue(et); Ae < et; )
                  X[Ae++] = le;
                return X;
              }
              function Rx(X, le) {
                var Ae = [];
                return ub(X, function(et, It, an) {
                  le(et, It, an) && Ae.push(et);
                }), Ae;
              }
              function tv(X, le, Ae, et, It) {
                var an = -1, Vn = X.length;
                for (Ae || (Ae = Qy), It || (It = []); ++an < Vn; ) {
                  var tr = X[an];
                  le > 0 && Ae(tr) ? le > 1 ? tv(tr, le - 1, Ae, et, It) : r1(It, tr) : et || (It[It.length] = tr);
                }
                return It;
              }
              var y6 = Hi(), Yg = Hi(true);
              function Zy(X, le) {
                return X && y6(X, le, qs);
              }
              function eO(X, le) {
                return X && Yg(X, le, qs);
              }
              function AD(X, le) {
                return Ex(le, function(Ae) {
                  return Ac(X[Ae]);
                });
              }
              function Nx(X, le) {
                le = it(le, X);
                for (var Ae = 0, et = le.length; X != null && Ae < et; )
                  X = X[Ai(le[Ae++])];
                return Ae && Ae == et ? X : xe;
              }
              function m6(X, le, Ae) {
                var et = le(X);
                return ba(X) ? et : r1(et, Ae(X));
              }
              function pd(X) {
                return X == null ? X === xe ? Jm : $y : jC && jC in If(X) ? ra(X) : gA(X);
              }
              function b6(X, le) {
                return X > le;
              }
              function Gs(X, le) {
                return X != null && yf.call(X, le);
              }
              function VB(X, le) {
                return X != null && le in If(X);
              }
              function ZY(X, le, Ae) {
                return X >= Nd(le, Ae) && X < cd(le, Ae);
              }
              function _6(X, le, Ae) {
                for (var et = Ae ? J4 : iA, It = X[0].length, an = X.length, Vn = an, tr = ui(an), Tr = 1 / 0, sa = []; Vn--; ) {
                  var fa = X[Vn];
                  Vn && le && (fa = jl(fa, Iv(le))), Tr = Nd(fa.length, Tr), tr[Vn] = !Ae && (le || It >= 120 && fa.length >= 120) ? new $S(Vn && fa) : xe;
                }
                fa = X[0];
                var Ea = -1, eo = tr[0];
                e:
                  for (; ++Ea < It && sa.length < Tr; ) {
                    var ts = fa[Ea], tl = le ? le(ts) : ts;
                    if (ts = Ae || ts !== 0 ? ts : 0, !(eo ? GS(eo, tl) : et(sa, tl, Ae))) {
                      for (Vn = an; --Vn; ) {
                        var Au = tr[Vn];
                        if (!(Au ? GS(Au, tl) : et(X[Vn], tl, Ae)))
                          continue e;
                      }
                      eo && eo.push(tl), sa.push(ts);
                    }
                  }
                return sa;
              }
              function JY(X, le, Ae, et) {
                return Zy(X, function(It, an, Vn) {
                  le(et, Ae(It), an, Vn);
                }), et;
              }
              function qC(X, le, Ae) {
                le = it(le, X), X = qB(X, le);
                var et = X == null ? X : X[Ai(cg(le))];
                return et == null ? xe : Yy(et, X, Ae);
              }
              function ID(X) {
                return gd(X) && pd(X) == Su;
              }
              function $C(X) {
                return gd(X) && pd(X) == qr;
              }
              function x6(X) {
                return gd(X) && pd(X) == Lc;
              }
              function n_(X, le, Ae, et, It) {
                return X === le ? true : X == null || le == null || !gd(X) && !gd(le) ? X !== X && le !== le : w6(X, le, Ae, et, n_, It);
              }
              function w6(X, le, Ae, et, It, an) {
                var Vn = ba(X), tr = ba(le), Tr = Vn ? hl : Os(X), sa = tr ? hl : Os(le);
                Tr = Tr == Su ? Ed : Tr, sa = sa == Su ? Ed : sa;
                var fa = Tr == Ed, Ea = sa == Ed, eo = Tr == sa;
                if (eo && YS(X)) {
                  if (!YS(le))
                    return false;
                  Vn = true, fa = false;
                }
                if (eo && !fa)
                  return an || (an = new sb()), Vn || vO(X) ? Jy(X, le, Ae, et, It, an) : Fx(X, le, Tr, Ae, et, It, an);
                if (!(Ae & qn)) {
                  var ts = fa && yf.call(X, "__wrapped__"), tl = Ea && yf.call(le, "__wrapped__");
                  if (ts || tl) {
                    var Au = ts ? X.value() : X, $s = tl ? le.value() : le;
                    return an || (an = new sb()), It(Au, $s, Ae, et, an);
                  }
                }
                return eo ? (an || (an = new sb()), q0(X, le, Ae, et, It, an)) : false;
              }
              function BB(X) {
                return gd(X) && Os(X) == Ap;
              }
              function S6(X, le, Ae, et) {
                var It = Ae.length, an = It, Vn = !et;
                if (X == null)
                  return !an;
                for (X = If(X); It--; ) {
                  var tr = Ae[It];
                  if (Vn && tr[2] ? tr[1] !== X[tr[0]] : !(tr[0] in X))
                    return false;
                }
                for (; ++It < an; ) {
                  tr = Ae[It];
                  var Tr = tr[0], sa = X[Tr], fa = tr[1];
                  if (Vn && tr[2]) {
                    if (sa === xe && !(Tr in X))
                      return false;
                  } else {
                    var Ea = new sb();
                    if (et)
                      var eo = et(sa, fa, Tr, X, le, Ea);
                    if (!(eo === xe ? n_(fa, sa, qn | nr, et, Ea) : eo))
                      return false;
                  }
                }
                return true;
              }
              function XC(X) {
                if (!Qh(X) || Jg(X))
                  return false;
                var le = Ac(X) ? xB : Ri;
                return le.test(ci(X));
              }
              function tO(X) {
                return gd(X) && pd(X) == ag;
              }
              function C6(X) {
                return gd(X) && Os(X) == gp;
              }
              function zB(X) {
                return gd(X) && P6(X.length) && !!Ph[pd(X)];
              }
              function jB(X) {
                return typeof X == "function" ? X : X == null ? nm : typeof X == "object" ? ba(X) ? A6(X[0], X[1]) : T6(X) : Lue(X);
              }
              function nO(X) {
                if (!ug(X))
                  return NY(X);
                var le = [];
                for (var Ae in If(X))
                  yf.call(X, Ae) && Ae != "constructor" && le.push(Ae);
                return le;
              }
              function M6(X) {
                if (!Qh(X))
                  return tK(X);
                var le = ug(X), Ae = [];
                for (var et in X)
                  et == "constructor" && (le || !yf.call(X, et)) || Ae.push(et);
                return Ae;
              }
              function YC(X, le) {
                return X < le;
              }
              function GB(X, le) {
                var Ae = -1, et = Zl(X) ? ui(X.length) : [];
                return ub(X, function(It, an, Vn) {
                  et[++Ae] = le(It, an, Vn);
                }), et;
              }
              function T6(X) {
                var le = Kr(X);
                return le.length == 1 && le[0][2] ? l1(le[0][0], le[0][1]) : function(Ae) {
                  return Ae === X || S6(Ae, X, le);
                };
              }
              function A6(X, le) {
                return Pp(X) && X0(le) ? l1(Ai(X), le) : function(Ae) {
                  var et = RD(Ae, X);
                  return et === xe && et === le ? qt(Ae, X) : n_(le, et, qn | nr);
                };
              }
              function rO(X, le, Ae, et, It) {
                X !== le && y6(le, function(an, Vn) {
                  if (It || (It = new sb()), Qh(an))
                    QY(X, le, Vn, Ae, rO, et, It);
                  else {
                    var tr = et ? et(E6(X, Vn), an, Vn + "", X, le, It) : xe;
                    tr === xe && (tr = an), Z3(X, Vn, tr);
                  }
                }, c1);
              }
              function QY(X, le, Ae, et, It, an, Vn) {
                var tr = E6(X, Ae), Tr = E6(le, Ae), sa = Vn.get(Tr);
                if (sa) {
                  Z3(X, Ae, sa);
                  return;
                }
                var fa = an ? an(tr, Tr, Ae + "", X, le, Vn) : xe, Ea = fa === xe;
                if (Ea) {
                  var eo = ba(Tr), ts = !eo && YS(Tr), tl = !eo && !ts && vO(Tr);
                  fa = Tr, eo || ts || tl ? ba(tr) ? fa = tr : Yu(tr) ? fa = Ct(tr) : ts ? (Ea = false, fa = Lt(Tr, true)) : tl ? (Ea = false, fa = lr(Tr, true)) : fa = [] : hO(Tr) || ri(Tr) ? (fa = tr, ri(tr) ? fa = e0(tr) : (!Qh(tr) || Ac(tr)) && (fa = vd(Tr))) : Ea = false;
                }
                Ea && (Vn.set(Tr, fa), It(fa, Tr, et, an, Vn), Vn.delete(Tr)), Z3(X, Ae, fa);
              }
              function HB(X, le) {
                var Ae = X.length;
                if (Ae)
                  return le += le < 0 ? Ae : 0, rv(le, Ae) ? X[le] : xe;
              }
              function I6(X, le, Ae) {
                le.length ? le = jl(le, function(an) {
                  return ba(an) ? function(Vn) {
                    return Nx(Vn, an.length === 1 ? an[0] : an);
                  } : an;
                }) : le = [nm];
                var et = -1;
                le = jl(le, Iv(Ts()));
                var It = GB(X, function(an, Vn, tr) {
                  var Tr = jl(le, function(sa) {
                    return sa(an);
                  });
                  return { criteria: Tr, index: ++et, value: an };
                });
                return pD(It, function(an, Vn) {
                  return ki(an, Vn, Ae);
                });
              }
              function dA(X, le) {
                return WB(X, le, function(Ae, et) {
                  return qt(X, et);
                });
              }
              function WB(X, le, Ae) {
                for (var et = -1, It = le.length, an = {}; ++et < It; ) {
                  var Vn = le[et], tr = Nx(X, Vn);
                  Ae(tr, Vn) && Yn(an, it(Vn, X), tr);
                }
                return an;
              }
              function eK(X) {
                return function(le) {
                  return Nx(le, X);
                };
              }
              function iO(X, le, Ae, et) {
                var It = et ? e6 : BS, an = -1, Vn = le.length, tr = X;
                for (X === le && (le = Ct(le)), Ae && (tr = jl(X, Iv(Ae))); ++an < Vn; )
                  for (var Tr = 0, sa = le[an], fa = Ae ? Ae(sa) : sa; (Tr = It(tr, fa, Tr, et)) > -1; )
                    tr !== X && kx.call(tr, Tr, 1), kx.call(X, Tr, 1);
                return X;
              }
              function q10(X, le) {
                for (var Ae = X ? le.length : 0, et = Ae - 1; Ae--; ) {
                  var It = le[Ae];
                  if (Ae == et || It !== an) {
                    var an = It;
                    rv(It) ? kx.call(X, It, 1) : Kg(X, It);
                  }
                }
                return X;
              }
              function re(X, le) {
                return X + bD(sA() * (le - X + 1));
              }
              function Ee(X, le, Ae, et) {
                for (var It = -1, an = cd(Rl((le - X) / (Ae || 1)), 0), Vn = ui(an); an--; )
                  Vn[et ? an : ++It] = X, X += Ae;
                return Vn;
              }
              function Je(X, le) {
                var Ae = "";
                if (!X || le < 1 || le > Ti)
                  return Ae;
                do
                  le % 2 && (Ae += X), le = bD(le / 2), le && (X += X);
                while (le);
                return Ae;
              }
              function St(X, le) {
                return Ln(UB(X, le, nm), X + "");
              }
              function rn(X) {
                return PB(_O(X));
              }
              function Gn(X, le) {
                var Ae = _O(X);
                return Sn(Ae, WC(le, 0, Ae.length));
              }
              function Yn(X, le, Ae, et) {
                if (!Qh(X))
                  return X;
                le = it(le, X);
                for (var It = -1, an = le.length, Vn = an - 1, tr = X; tr != null && ++It < an; ) {
                  var Tr = Ai(le[It]), sa = Ae;
                  if (Tr === "__proto__" || Tr === "constructor" || Tr === "prototype")
                    return X;
                  if (It != Vn) {
                    var fa = tr[Tr];
                    sa = et ? et(fa, Tr, tr) : xe, sa === xe && (sa = Qh(fa) ? fa : rv(le[It + 1]) ? [] : {});
                  }
                  Ev(tr, Tr, sa), tr = tr[Tr];
                }
                return X;
              }
              var Cr = wD ? function(X, le) {
                return wD.set(X, le), X;
              } : nm, aa = q3 ? function(X, le) {
                return q3(X, "toString", { configurable: true, enumerable: false, value: h_(le), writable: true });
              } : nm;
              function oa(X) {
                return Sn(_O(X));
              }
              function ua(X, le, Ae) {
                var et = -1, It = X.length;
                le < 0 && (le = -le > It ? 0 : It + le), Ae = Ae > It ? It : Ae, Ae < 0 && (Ae += It), It = le > Ae ? 0 : Ae - le >>> 0, le >>>= 0;
                for (var an = ui(It); ++et < It; )
                  an[et] = X[et + le];
                return an;
              }
              function bo(X, le) {
                var Ae;
                return ub(X, function(et, It, an) {
                  return Ae = le(et, It, an), !Ae;
                }), !!Ae;
              }
              function os(X, le, Ae) {
                var et = 0, It = X == null ? et : X.length;
                if (typeof le == "number" && le === le && It <= Ws) {
                  for (; et < It; ) {
                    var an = et + It >>> 1, Vn = X[an];
                    Vn !== null && !K0(Vn) && (Ae ? Vn <= le : Vn < le) ? et = an + 1 : It = an;
                  }
                  return It;
                }
                return Rs(X, le, nm, Ae);
              }
              function Rs(X, le, Ae, et) {
                var It = 0, an = X == null ? 0 : X.length;
                if (an === 0)
                  return 0;
                le = Ae(le);
                for (var Vn = le !== le, tr = le === null, Tr = K0(le), sa = le === xe; It < an; ) {
                  var fa = bD((It + an) / 2), Ea = Ae(X[fa]), eo = Ea !== xe, ts = Ea === null, tl = Ea === Ea, Au = K0(Ea);
                  if (Vn)
                    var $s = et || tl;
                  else
                    sa ? $s = tl && (et || eo) : tr ? $s = tl && eo && (et || !ts) : Tr ? $s = tl && eo && !ts && (et || !Au) : ts || Au ? $s = false : $s = et ? Ea <= le : Ea < le;
                  $s ? It = fa + 1 : an = fa;
                }
                return Nd(an, Ta);
              }
              function su(X, le) {
                for (var Ae = -1, et = X.length, It = 0, an = []; ++Ae < et; ) {
                  var Vn = X[Ae], tr = le ? le(Vn) : Vn;
                  if (!Ae || !Y0(tr, Tr)) {
                    var Tr = tr;
                    an[It++] = Vn === 0 ? 0 : Vn;
                  }
                }
                return an;
              }
              function Us(X) {
                return typeof X == "number" ? X : K0(X) ? ni : +X;
              }
              function Qs(X) {
                if (typeof X == "string")
                  return X;
                if (ba(X))
                  return jl(X, Qs) + "";
                if (K0(X))
                  return kp ? kp.call(X) : "";
                var le = X + "";
                return le == "0" && 1 / X == -xs ? "-0" : le;
              }
              function Yl(X, le, Ae) {
                var et = -1, It = iA, an = X.length, Vn = true, tr = [], Tr = tr;
                if (Ae)
                  Vn = false, It = J4;
                else if (an >= Ce) {
                  var sa = le ? null : rf(X);
                  if (sa)
                    return W3(sa);
                  Vn = false, It = GS, Tr = new $S();
                } else
                  Tr = le ? [] : tr;
                e:
                  for (; ++et < an; ) {
                    var fa = X[et], Ea = le ? le(fa) : fa;
                    if (fa = Ae || fa !== 0 ? fa : 0, Vn && Ea === Ea) {
                      for (var eo = Tr.length; eo--; )
                        if (Tr[eo] === Ea)
                          continue e;
                      le && Tr.push(Ea), tr.push(fa);
                    } else
                      It(Tr, Ea, Ae) || (Tr !== tr && Tr.push(Ea), tr.push(fa));
                  }
                return tr;
              }
              function Kg(X, le) {
                return le = it(le, X), X = qB(X, le), X == null || delete X[Ai(cg(le))];
              }
              function lg(X, le, Ae, et) {
                return Yn(X, le, Ae(Nx(X, le)), et);
              }
              function ge(X, le, Ae, et) {
                for (var It = X.length, an = et ? It : -1; (et ? an-- : ++an < It) && le(X[an], an, X); )
                  ;
                return Ae ? ua(X, et ? 0 : an, et ? an + 1 : It) : ua(X, et ? an + 1 : 0, et ? It : an);
              }
              function He(X, le) {
                var Ae = X;
                return Ae instanceof qu && (Ae = Ae.value()), B3(le, function(et, It) {
                  return It.func.apply(It.thisArg, r1([et], It.args));
                }, Ae);
              }
              function we(X, le, Ae) {
                var et = X.length;
                if (et < 2)
                  return et ? Yl(X[0]) : [];
                for (var It = -1, an = ui(et); ++It < et; )
                  for (var Vn = X[It], tr = -1; ++tr < et; )
                    tr != It && (an[It] = UC(an[It] || Vn, X[tr], le, Ae));
                return Yl(tv(an, 1), le, Ae);
              }
              function Me(X, le, Ae) {
                for (var et = -1, It = X.length, an = le.length, Vn = {}; ++et < It; ) {
                  var tr = et < an ? le[et] : xe;
                  Ae(Vn, X[et], tr);
                }
                return Vn;
              }
              function Te(X) {
                return Yu(X) ? X : [];
              }
              function Ne(X) {
                return typeof X == "function" ? X : nm;
              }
              function it(X, le) {
                return ba(X) ? X : Pp(X, le) ? [X] : zr(zf(X));
              }
              var ht = St;
              function xt(X, le, Ae) {
                var et = X.length;
                return Ae = Ae === xe ? et : Ae, !le && Ae >= et ? X : ua(X, le, Ae);
              }
              var kt = RY || function(X) {
                return Dp.clearTimeout(X);
              };
              function Lt(X, le) {
                if (le)
                  return X.slice();
                var Ae = X.length, et = oA ? oA(Ae) : new X.constructor(Ae);
                return X.copy(et), et;
              }
              function sn(X) {
                var le = new X.constructor(X.byteLength);
                return new WS(le).set(new WS(X)), le;
              }
              function Bn(X, le) {
                var Ae = le ? sn(X.buffer) : X.buffer;
                return new X.constructor(Ae, X.byteOffset, X.byteLength);
              }
              function Xn(X) {
                var le = new X.constructor(X.source, gn.exec(X));
                return le.lastIndex = X.lastIndex, le;
              }
              function $n(X) {
                return cA ? If(cA.call(X)) : {};
              }
              function lr(X, le) {
                var Ae = le ? sn(X.buffer) : X.buffer;
                return new X.constructor(Ae, X.byteOffset, X.length);
              }
              function br(X, le) {
                if (X !== le) {
                  var Ae = X !== xe, et = X === null, It = X === X, an = K0(X), Vn = le !== xe, tr = le === null, Tr = le === le, sa = K0(le);
                  if (!tr && !sa && !an && X > le || an && Vn && Tr && !tr && !sa || et && Vn && Tr || !Ae && Tr || !It)
                    return 1;
                  if (!et && !an && !sa && X < le || sa && Ae && It && !et && !an || tr && Ae && It || !Vn && It || !Tr)
                    return -1;
                }
                return 0;
              }
              function ki(X, le, Ae) {
                for (var et = -1, It = X.criteria, an = le.criteria, Vn = It.length, tr = Ae.length; ++et < Vn; ) {
                  var Tr = br(It[et], an[et]);
                  if (Tr) {
                    if (et >= tr)
                      return Tr;
                    var sa = Ae[et];
                    return Tr * (sa == "desc" ? -1 : 1);
                  }
                }
                return X.index - le.index;
              }
              function bi(X, le, Ae, et) {
                for (var It = -1, an = X.length, Vn = Ae.length, tr = -1, Tr = le.length, sa = cd(an - Vn, 0), fa = ui(Tr + sa), Ea = !et; ++tr < Tr; )
                  fa[tr] = le[tr];
                for (; ++It < Vn; )
                  (Ea || It < an) && (fa[Ae[It]] = X[It]);
                for (; sa--; )
                  fa[tr++] = X[It++];
                return fa;
              }
              function Oa(X, le, Ae, et) {
                for (var It = -1, an = X.length, Vn = -1, tr = Ae.length, Tr = -1, sa = le.length, fa = cd(an - tr, 0), Ea = ui(fa + sa), eo = !et; ++It < fa; )
                  Ea[It] = X[It];
                for (var ts = It; ++Tr < sa; )
                  Ea[ts + Tr] = le[Tr];
                for (; ++Vn < tr; )
                  (eo || It < an) && (Ea[ts + Ae[Vn]] = X[It++]);
                return Ea;
              }
              function Ct(X, le) {
                var Ae = -1, et = X.length;
                for (le || (le = ui(et)); ++Ae < et; )
                  le[Ae] = X[Ae];
                return le;
              }
              function dr(X, le, Ae, et) {
                var It = !Ae;
                Ae || (Ae = {});
                for (var an = -1, Vn = le.length; ++an < Vn; ) {
                  var tr = le[an], Tr = et ? et(Ae[tr], X[tr], tr, Ae, X) : xe;
                  Tr === xe && (Tr = X[tr]), It ? lb2(Ae, tr, Tr) : Ev(Ae, tr, Tr);
                }
                return Ae;
              }
              function Wr(X, le) {
                return dr(X, ao(X), le);
              }
              function Ci(X, le) {
                return dr(X, ss(X), le);
              }
              function _i(X, le) {
                return function(Ae, et) {
                  var It = ba(Ae) ? AY : RB, an = le ? le() : {};
                  return It(Ae, X, Ts(et, 2), an);
                };
              }
              function Pr(X) {
                return St(function(le, Ae) {
                  var et = -1, It = Ae.length, an = It > 1 ? Ae[It - 1] : xe, Vn = It > 2 ? Ae[2] : xe;
                  for (an = X.length > 3 && typeof an == "function" ? (It--, an) : xe, Vn && Zf(Ae[0], Ae[1], Vn) && (an = It < 3 ? xe : an, It = 1), le = If(le); ++et < It; ) {
                    var tr = Ae[et];
                    tr && X(le, tr, et, an);
                  }
                  return le;
                });
              }
              function $r(X, le) {
                return function(Ae, et) {
                  if (Ae == null)
                    return Ae;
                  if (!Zl(Ae))
                    return X(Ae, et);
                  for (var It = Ae.length, an = le ? It : -1, Vn = If(Ae); (le ? an-- : ++an < It) && et(Vn[an], an, Vn) !== false; )
                    ;
                  return Ae;
                };
              }
              function Hi(X) {
                return function(le, Ae, et) {
                  for (var It = -1, an = If(le), Vn = et(le), tr = Vn.length; tr--; ) {
                    var Tr = Vn[X ? tr : ++It];
                    if (Ae(an[Tr], Tr, an) === false)
                      break;
                  }
                  return le;
                };
              }
              function wa(X, le, Ae) {
                var et = le & sr, It = Po(X);
                function an() {
                  var Vn = this && this !== Dp && this instanceof an ? It : X;
                  return Vn.apply(et ? Ae : this, arguments);
                }
                return an;
              }
              function Mr(X) {
                return function(le) {
                  le = zf(le);
                  var Ae = Pd(le) ? sg(le) : xe, et = Ae ? Ae[0] : le.charAt(0), It = Ae ? xt(Ae, 1).join("") : le.slice(1);
                  return et[X]() + It;
                };
              }
              function No(X) {
                return function(le) {
                  return B3(kue(Cue(le).replace(q4, "")), X, "");
                };
              }
              function Po(X) {
                return function() {
                  var le = arguments;
                  switch (le.length) {
                    case 0:
                      return new X();
                    case 1:
                      return new X(le[0]);
                    case 2:
                      return new X(le[0], le[1]);
                    case 3:
                      return new X(le[0], le[1], le[2]);
                    case 4:
                      return new X(le[0], le[1], le[2], le[3]);
                    case 5:
                      return new X(le[0], le[1], le[2], le[3], le[4]);
                    case 6:
                      return new X(le[0], le[1], le[2], le[3], le[4], le[5]);
                    case 7:
                      return new X(le[0], le[1], le[2], le[3], le[4], le[5], le[6]);
                  }
                  var Ae = fA(X.prototype), et = X.apply(Ae, le);
                  return Qh(et) ? et : Ae;
                };
              }
              function Mi(X, le, Ae) {
                var et = Po(X);
                function It() {
                  for (var an = arguments.length, Vn = ui(an), tr = an, Tr = Lh(It); tr--; )
                    Vn[tr] = arguments[tr];
                  var sa = an < 3 && Vn[0] !== Tr && Vn[an - 1] !== Tr ? [] : HS(Vn, Tr);
                  if (an -= sa.length, an < Ae)
                    return Kf(X, le, ii, It.placeholder, xe, Vn, sa, xe, xe, Ae - an);
                  var fa = this && this !== Dp && this instanceof It ? et : X;
                  return Yy(fa, this, Vn);
                }
                return It;
              }
              function Is(X) {
                return function(le, Ae, et) {
                  var It = If(le);
                  if (!Zl(le)) {
                    var an = Ts(Ae, 3);
                    le = qs(le), Ae = function(tr) {
                      return an(It[tr], tr, It);
                    };
                  }
                  var Vn = X(le, Ae, et);
                  return Vn > -1 ? It[an ? le[Vn] : Vn] : xe;
                };
              }
              function Oi(X) {
                return Zg(function(le) {
                  var Ae = le.length, et = Ae, It = Ky.prototype.thru;
                  for (X && le.reverse(); et--; ) {
                    var an = le[et];
                    if (typeof an != "function")
                      throw new W0(at);
                    if (It && !Vn && Fd(an) == "wrapper")
                      var Vn = new Ky([], true);
                  }
                  for (et = Vn ? et : Ae; ++et < Ae; ) {
                    an = le[et];
                    var tr = Fd(an), Tr = tr == "wrapper" ? Xp(an) : xe;
                    Tr && Vd(Tr[0]) && Tr[1] == (Si | Sa | Ar | mi) && !Tr[4].length && Tr[9] == 1 ? Vn = Vn[Fd(Tr[0])].apply(Vn, Tr[3]) : Vn = an.length == 1 && Vd(an) ? Vn[tr]() : Vn.thru(an);
                  }
                  return function() {
                    var sa = arguments, fa = sa[0];
                    if (Vn && sa.length == 1 && ba(fa))
                      return Vn.plant(fa).value();
                    for (var Ea = 0, eo = Ae ? le[Ea].apply(this, sa) : fa; ++Ea < Ae; )
                      eo = le[Ea].call(this, eo);
                    return eo;
                  };
                });
              }
              function ii(X, le, Ae, et, It, an, Vn, tr, Tr, sa) {
                var fa = le & Si, Ea = le & sr, eo = le & Ii, ts = le & (Sa | Tt), tl = le & Dr, Au = eo ? xe : Po(X);
                function $s() {
                  for (var uc = arguments.length, Ic = ui(uc), f1 = uc; f1--; )
                    Ic[f1] = arguments[f1];
                  if (ts)
                    var r0 = Lh($s), rm = zC(Ic, r0);
                  if (et && (Ic = bi(Ic, et, It, ts)), an && (Ic = Oa(Ic, an, Vn, ts)), uc -= rm, ts && uc < sa) {
                    var lh = HS(Ic, r0);
                    return Kf(X, le, ii, $s.placeholder, Ae, Ic, lh, tr, Tr, sa - uc);
                  }
                  var zx = Ea ? Ae : this, Z0 = eo ? zx[X] : X;
                  return uc = Ic.length, tr ? Ic = nK(Ic, tr) : tl && uc > 1 && Ic.reverse(), fa && Tr < uc && (Ic.length = Tr), this && this !== Dp && this instanceof $s && (Z0 = Au || Po(Z0)), Z0.apply(zx, Ic);
                }
                return $s;
              }
              function ai(X, le) {
                return function(Ae, et) {
                  return JY(Ae, X, le(et), {});
                };
              }
              function Ga(X, le) {
                return function(Ae, et) {
                  var It;
                  if (Ae === xe && et === xe)
                    return le;
                  if (Ae !== xe && (It = Ae), et !== xe) {
                    if (It === xe)
                      return et;
                    typeof Ae == "string" || typeof et == "string" ? (Ae = Qs(Ae), et = Qs(et)) : (Ae = Us(Ae), et = Us(et)), It = X(Ae, et);
                  }
                  return It;
                };
              }
              function Aa(X) {
                return Zg(function(le) {
                  return le = jl(le, Iv(Ts())), St(function(Ae) {
                    var et = this;
                    return X(le, function(It) {
                      return Yy(It, et, Ae);
                    });
                  });
                });
              }
              function el(X, le) {
                le = le === xe ? " " : Qs(le);
                var Ae = le.length;
                if (Ae < 2)
                  return Ae ? Je(le, X) : le;
                var et = Je(le, Rl(X / vu(le)));
                return Pd(le) ? xt(sg(et), 0, X).join("") : et.slice(0, X);
              }
              function Cc(X, le, Ae, et) {
                var It = le & sr, an = Po(X);
                function Vn() {
                  for (var tr = -1, Tr = arguments.length, sa = -1, fa = et.length, Ea = ui(fa + Tr), eo = this && this !== Dp && this instanceof Vn ? an : X; ++sa < fa; )
                    Ea[sa] = et[sa];
                  for (; Tr--; )
                    Ea[sa++] = arguments[++tr];
                  return Yy(eo, It ? Ae : this, Ea);
                }
                return Vn;
              }
              function $u(X) {
                return function(le, Ae, et) {
                  return et && typeof et != "number" && Zf(le, Ae, et) && (Ae = et = xe), le = ZS(le), Ae === xe ? (Ae = le, le = 0) : Ae = ZS(Ae), et = et === xe ? le < Ae ? 1 : -1 : ZS(et), Ee(le, Ae, et, X);
                };
              }
              function lu(X) {
                return function(le, Ae) {
                  return typeof le == "string" && typeof Ae == "string" || (le = Bf(le), Ae = Bf(Ae)), X(le, Ae);
                };
              }
              function Kf(X, le, Ae, et, It, an, Vn, tr, Tr, sa) {
                var fa = le & Sa, Ea = fa ? Vn : xe, eo = fa ? xe : Vn, ts = fa ? an : xe, tl = fa ? xe : an;
                le |= fa ? Ar : Vr, le &= ~(fa ? Vr : Ar), le & gi || (le &= ~(sr | Ii));
                var Au = [X, le, It, ts, Ea, tl, eo, tr, Tr, sa], $s = Ae.apply(xe, Au);
                return Vd(X) && ED($s, Au), $s.placeholder = et, Xt($s, X, le);
              }
              function Xu(X) {
                var le = Ld[X];
                return function(Ae, et) {
                  if (Ae = Bf(Ae), et = et == null ? 0 : Nd(Tu(et), 292), et && MB(Ae)) {
                    var It = (zf(Ae) + "e").split("e"), an = le(It[0] + "e" + (+It[1] + et));
                    return It = (zf(an) + "e").split("e"), +(It[0] + "e" + (+It[1] - et));
                  }
                  return le(Ae);
                };
              }
              var rf = GC && 1 / W3(new GC([, -0]))[1] == xs ? function(X) {
                return new GC(X);
              } : zD;
              function Op(X) {
                return function(le) {
                  var Ae = Os(le);
                  return Ae == Ap ? r6(le) : Ae == gp ? OY(le) : dD(le, X(le));
                };
              }
              function dd(X, le, Ae, et, It, an, Vn, tr) {
                var Tr = le & Ii;
                if (!Tr && typeof X != "function")
                  throw new W0(at);
                var sa = et ? et.length : 0;
                if (sa || (le &= ~(Ar | Vr), et = It = xe), Vn = Vn === xe ? Vn : cd(Tu(Vn), 0), tr = tr === xe ? tr : Tu(tr), sa -= It ? It.length : 0, le & Vr) {
                  var fa = et, Ea = It;
                  et = It = xe;
                }
                var eo = Tr ? xe : Xp(X), ts = [X, le, Ae, et, It, fa, Ea, an, Vn, tr];
                if (eo && KC(ts, eo), X = ts[0], le = ts[1], Ae = ts[2], et = ts[3], It = ts[4], tr = ts[9] = ts[9] === xe ? Tr ? 0 : X.length : cd(ts[9] - sa, 0), !tr && le & (Sa | Tt) && (le &= ~(Sa | Tt)), !le || le == sr)
                  var tl = wa(X, le, Ae);
                else
                  le == Sa || le == Tt ? tl = Mi(X, le, tr) : (le == Ar || le == (sr | Ar)) && !It.length ? tl = Cc(X, le, Ae, et) : tl = ii.apply(xe, ts);
                var Au = eo ? Cr : ED;
                return Xt(Au(tl, ts), X, le);
              }
              function o1(X, le, Ae, et) {
                return X === xe || Y0(X, Yf[Ae]) && !yf.call(et, Ae) ? le : X;
              }
              function r_(X, le, Ae, et, It, an) {
                return Qh(X) && Qh(le) && (an.set(le, X), rO(X, le, xe, r_, an), an.delete(le)), X;
              }
              function nv(X) {
                return hO(X) ? xe : X;
              }
              function Jy(X, le, Ae, et, It, an) {
                var Vn = Ae & qn, tr = X.length, Tr = le.length;
                if (tr != Tr && !(Vn && Tr > tr))
                  return false;
                var sa = an.get(X), fa = an.get(le);
                if (sa && fa)
                  return sa == le && fa == X;
                var Ea = -1, eo = true, ts = Ae & nr ? new $S() : xe;
                for (an.set(X, le), an.set(le, X); ++Ea < tr; ) {
                  var tl = X[Ea], Au = le[Ea];
                  if (et)
                    var $s = Vn ? et(Au, tl, Ea, le, X, an) : et(tl, Au, Ea, X, le, an);
                  if ($s !== xe) {
                    if ($s)
                      continue;
                    eo = false;
                    break;
                  }
                  if (ts) {
                    if (!cD(le, function(uc, Ic) {
                      if (!GS(ts, Ic) && (tl === uc || It(tl, uc, Ae, et, an)))
                        return ts.push(Ic);
                    })) {
                      eo = false;
                      break;
                    }
                  } else if (!(tl === Au || It(tl, Au, Ae, et, an))) {
                    eo = false;
                    break;
                  }
                }
                return an.delete(X), an.delete(le), eo;
              }
              function Fx(X, le, Ae, et, It, an, Vn) {
                switch (Ae) {
                  case Yi:
                    if (X.byteLength != le.byteLength || X.byteOffset != le.byteOffset)
                      return false;
                    X = X.buffer, le = le.buffer;
                  case qr:
                    return !(X.byteLength != le.byteLength || !an(new WS(X), new WS(le)));
                  case Cu:
                  case Lc:
                  case ig:
                    return Y0(+X, +le);
                  case B0:
                    return X.name == le.name && X.message == le.message;
                  case ag:
                  case Yh:
                    return X == le + "";
                  case Ap:
                    var tr = r6;
                  case gp:
                    var Tr = et & qn;
                    if (tr || (tr = W3), X.size != le.size && !Tr)
                      return false;
                    var sa = Vn.get(X);
                    if (sa)
                      return sa == le;
                    et |= nr, Vn.set(X, le);
                    var fa = Jy(tr(X), tr(le), et, It, an, Vn);
                    return Vn.delete(X), fa;
                  case Ip:
                    if (cA)
                      return cA.call(X) == cA.call(le);
                }
                return false;
              }
              function q0(X, le, Ae, et, It, an) {
                var Vn = Ae & qn, tr = i_(X), Tr = tr.length, sa = i_(le), fa = sa.length;
                if (Tr != fa && !Vn)
                  return false;
                for (var Ea = Tr; Ea--; ) {
                  var eo = tr[Ea];
                  if (!(Vn ? eo in le : yf.call(le, eo)))
                    return false;
                }
                var ts = an.get(X), tl = an.get(le);
                if (ts && tl)
                  return ts == le && tl == X;
                var Au = true;
                an.set(X, le), an.set(le, X);
                for (var $s = Vn; ++Ea < Tr; ) {
                  eo = tr[Ea];
                  var uc = X[eo], Ic = le[eo];
                  if (et)
                    var f1 = Vn ? et(Ic, uc, eo, le, X, an) : et(uc, Ic, eo, X, le, an);
                  if (!(f1 === xe ? uc === Ic || It(uc, Ic, Ae, et, an) : f1)) {
                    Au = false;
                    break;
                  }
                  $s || ($s = eo == "constructor");
                }
                if (Au && !$s) {
                  var r0 = X.constructor, rm = le.constructor;
                  r0 != rm && "constructor" in X && "constructor" in le && !(typeof r0 == "function" && r0 instanceof r0 && typeof rm == "function" && rm instanceof rm) && (Au = false);
                }
                return an.delete(X), an.delete(le), Au;
              }
              function Zg(X) {
                return Ln(UB(X, xe, yA), X + "");
              }
              function i_(X) {
                return m6(X, qs, ao);
              }
              function s1(X) {
                return m6(X, c1, ss);
              }
              var Xp = wD ? function(X) {
                return wD.get(X);
              } : zD;
              function Fd(X) {
                for (var le = X.name + "", Ae = uA[le], et = yf.call(uA, le) ? Ae.length : 0; et--; ) {
                  var It = Ae[et], an = It.func;
                  if (an == null || an == X)
                    return It.name;
                }
                return le;
              }
              function Lh(X) {
                var le = yf.call(Bt, "placeholder") ? Bt : X;
                return le.placeholder;
              }
              function Ts() {
                var X = Bt.iteratee || n0;
                return X = X === n0 ? jB : X, arguments.length ? X(arguments[0], arguments[1]) : X;
              }
              function $i(X, le) {
                var Ae = X.__data__;
                return Mc(le) ? Ae[typeof le == "string" ? "string" : "hash"] : Ae.map;
              }
              function Kr(X) {
                for (var le = qs(X), Ae = le.length; Ae--; ) {
                  var et = le[Ae], It = X[et];
                  le[Ae] = [et, It, X0(It)];
                }
                return le;
              }
              function Hr(X, le) {
                var Ae = t6(X, le);
                return XC(Ae) ? Ae : xe;
              }
              function ra(X) {
                var le = yf.call(X, jC), Ae = X[jC];
                try {
                  X[jC] = xe;
                  var et = true;
                } catch {
                }
                var It = U3.call(X);
                return et && (le ? X[jC] = Ae : delete X[jC]), It;
              }
              var ao = U0 ? function(X) {
                return X == null ? [] : (X = If(X), Ex(U0(X), function(le) {
                  return Rd.call(X, le);
                }));
              } : IK, ss = U0 ? function(X) {
                for (var le = []; X; )
                  r1(le, ao(X)), X = yD(X);
                return le;
              } : IK, Os = pd;
              (_D && Os(new _D(new ArrayBuffer(1))) != Yi || Px && Os(new Px()) != Ap || Xg && Os(Xg.resolve()) != z0 || GC && Os(new GC()) != gp || lA && Os(new lA()) != qi) && (Os = function(X) {
                var le = pd(X), Ae = le == Ed ? X.constructor : xe, et = Ae ? ci(Ae) : "";
                if (et)
                  switch (et) {
                    case fd:
                      return Yi;
                    case US:
                      return Ap;
                    case HC:
                      return z0;
                    case $3:
                      return gp;
                    case SD:
                      return qi;
                  }
                return le;
              });
              function uu(X, le, Ae) {
                for (var et = -1, It = Ae.length; ++et < It; ) {
                  var an = Ae[et], Vn = an.size;
                  switch (an.type) {
                    case "drop":
                      X += Vn;
                      break;
                    case "dropRight":
                      le -= Vn;
                      break;
                    case "take":
                      le = Nd(le, X + Vn);
                      break;
                    case "takeRight":
                      X = cd(X, le - Vn);
                      break;
                  }
                }
                return { start: X, end: le };
              }
              function bf(X) {
                var le = X.match(nA);
                return le ? le[1].split(L3) : [];
              }
              function Zh(X, le, Ae) {
                le = it(le, X);
                for (var et = -1, It = le.length, an = false; ++et < It; ) {
                  var Vn = Ai(le[et]);
                  if (!(an = X != null && Ae(X, Vn)))
                    break;
                  X = X[Vn];
                }
                return an || ++et != It ? an : (It = X == null ? 0 : X.length, !!It && P6(It) && rv(Vn, It) && (ba(X) || ri(X)));
              }
              function Rh(X) {
                var le = X.length, Ae = new X.constructor(le);
                return le && typeof X[0] == "string" && yf.call(X, "index") && (Ae.index = X.index, Ae.input = X.input), Ae;
              }
              function vd(X) {
                return typeof X.constructor == "function" && !ug(X) ? fA(yD(X)) : {};
              }
              function Nh(X, le, Ae) {
                var et = X.constructor;
                switch (le) {
                  case qr:
                    return sn(X);
                  case Cu:
                  case Lc:
                    return new et(+X);
                  case Yi:
                    return Bn(X, Ae);
                  case to:
                  case is:
                  case Bl:
                  case zl:
                  case $c:
                  case Dh:
                  case Sc:
                  case lc:
                  case Af:
                    return lr(X, Ae);
                  case Ap:
                    return new et();
                  case ig:
                  case Yh:
                    return new et(X);
                  case ag:
                    return Xn(X);
                  case gp:
                    return new et();
                  case Ip:
                    return $n(X);
                }
              }
              function $0(X, le) {
                var Ae = le.length;
                if (!Ae)
                  return X;
                var et = Ae - 1;
                return le[et] = (Ae > 1 ? "& " : "") + le[et], le = le.join(Ae > 2 ? ", " : " "), X.replace(aD, `{
/* [wrapped with ` + le + `] */
`);
              }
              function Qy(X) {
                return ba(X) || ri(X) || !!(wB && X && X[wB]);
              }
              function rv(X, le) {
                var Ae = typeof X;
                return le = le == null ? Ti : le, !!le && (Ae == "number" || Ae != "symbol" && ur.test(X)) && X > -1 && X % 1 == 0 && X < le;
              }
              function Zf(X, le, Ae) {
                if (!Qh(Ae))
                  return false;
                var et = typeof le;
                return (et == "number" ? Zl(Ae) && rv(le, Ae.length) : et == "string" && le in Ae) ? Y0(Ae[le], X) : false;
              }
              function Pp(X, le) {
                if (ba(X))
                  return false;
                var Ae = typeof X;
                return Ae == "number" || Ae == "symbol" || Ae == "boolean" || X == null || K0(X) ? true : G0.test(X) || !Ug.test(X) || le != null && X in If(le);
              }
              function Mc(X) {
                var le = typeof X;
                return le == "string" || le == "number" || le == "symbol" || le == "boolean" ? X !== "__proto__" : X === null;
              }
              function Vd(X) {
                var le = Fd(X), Ae = Bt[le];
                if (typeof Ae != "function" || !(le in qu.prototype))
                  return false;
                if (X === Ae)
                  return true;
                var et = Xp(Ae);
                return !!et && X === et[0];
              }
              function Jg(X) {
                return !!bB && bB in X;
              }
              var a_ = oh ? Ac : EK;
              function ug(X) {
                var le = X && X.constructor, Ae = typeof le == "function" && le.prototype || Yf;
                return X === Ae;
              }
              function X0(X) {
                return X === X && !Qh(X);
              }
              function l1(X, le) {
                return function(Ae) {
                  return Ae == null ? false : Ae[X] === le && (le !== xe || X in If(Ae));
                };
              }
              function vA(X) {
                var le = QC(X, function(et) {
                  return Ae.size === Dt && Ae.clear(), et;
                }), Ae = le.cache;
                return le;
              }
              function KC(X, le) {
                var Ae = X[1], et = le[1], It = Ae | et, an = It < (sr | Ii | Si), Vn = et == Si && Ae == Sa || et == Si && Ae == mi && X[7].length <= le[8] || et == (Si | mi) && le[7].length <= le[8] && Ae == Sa;
                if (!(an || Vn))
                  return X;
                et & sr && (X[2] = le[2], It |= Ae & sr ? 0 : gi);
                var tr = le[3];
                if (tr) {
                  var Tr = X[3];
                  X[3] = Tr ? bi(Tr, tr, le[4]) : tr, X[4] = Tr ? HS(X[3], Pt) : le[4];
                }
                return tr = le[5], tr && (Tr = X[5], X[5] = Tr ? Oa(Tr, tr, le[6]) : tr, X[6] = Tr ? HS(X[5], Pt) : le[6]), tr = le[7], tr && (X[7] = tr), et & Si && (X[8] = X[8] == null ? le[8] : Nd(X[8], le[8])), X[9] == null && (X[9] = le[9]), X[0] = le[0], X[1] = It, X;
              }
              function tK(X) {
                var le = [];
                if (X != null)
                  for (var Ae in If(X))
                    le.push(Ae);
                return le;
              }
              function gA(X) {
                return U3.call(X);
              }
              function UB(X, le, Ae) {
                return le = cd(le === xe ? X.length - 1 : le, 0), function() {
                  for (var et = arguments, It = -1, an = cd(et.length - le, 0), Vn = ui(an); ++It < an; )
                    Vn[It] = et[le + It];
                  It = -1;
                  for (var tr = ui(le + 1); ++It < le; )
                    tr[It] = et[It];
                  return tr[le] = Ae(Vn), Yy(X, this, tr);
                };
              }
              function qB(X, le) {
                return le.length < 2 ? X : Nx(X, ua(le, 0, -1));
              }
              function nK(X, le) {
                for (var Ae = X.length, et = Nd(le.length, Ae), It = Ct(X); et--; ) {
                  var an = le[et];
                  X[et] = rv(an, Ae) ? It[an] : xe;
                }
                return X;
              }
              function E6(X, le) {
                if (!(le === "constructor" && typeof X[le] == "function") && le != "__proto__")
                  return X[le];
              }
              var ED = mn(Cr), Tn = Ox || function(X, le) {
                return Dp.setTimeout(X, le);
              }, Ln = mn(aa);
              function Xt(X, le, Ae) {
                var et = le + "";
                return Ln(X, $0(et, kr(bf(et), Ae)));
              }
              function mn(X) {
                var le = 0, Ae = 0;
                return function() {
                  var et = s6(), It = xr - (et - Ae);
                  if (Ae = et, It > 0) {
                    if (++le >= ya)
                      return arguments[0];
                  } else
                    le = 0;
                  return X.apply(xe, arguments);
                };
              }
              function Sn(X, le) {
                var Ae = -1, et = X.length, It = et - 1;
                for (le = le === xe ? et : le; ++Ae < le; ) {
                  var an = re(Ae, It), Vn = X[an];
                  X[an] = X[Ae], X[Ae] = Vn;
                }
                return X.length = le, X;
              }
              var zr = vA(function(X) {
                var le = [];
                return X.charCodeAt(0) === 46 && le.push(""), X.replace(Sx, function(Ae, et, It, an) {
                  le.push(It ? an.replace(Dn, "$1") : et || Ae);
                }), le;
              });
              function Ai(X) {
                if (typeof X == "string" || K0(X))
                  return X;
                var le = X + "";
                return le == "0" && 1 / X == -xs ? "-0" : le;
              }
              function ci(X) {
                if (X != null) {
                  try {
                    return sh.call(X);
                  } catch {
                  }
                  try {
                    return X + "";
                  } catch {
                  }
                }
                return "";
              }
              function kr(X, le) {
                return qg(Uu, function(Ae) {
                  var et = "_." + Ae[0];
                  le & Ae[1] && !iA(X, et) && X.push(et);
                }), X.sort();
              }
              function Ca(X) {
                if (X instanceof qu)
                  return X.clone();
                var le = new Ky(X.__wrapped__, X.__chain__);
                return le.__actions__ = Ct(X.__actions__), le.__index__ = X.__index__, le.__values__ = X.__values__, le;
              }
              function ps(X, le, Ae) {
                (Ae ? Zf(X, le, Ae) : le === xe) ? le = 1 : le = cd(Tu(le), 0);
                var et = X == null ? 0 : X.length;
                if (!et || le < 1)
                  return [];
                for (var It = 0, an = 0, Vn = ui(Rl(et / le)); It < et; )
                  Vn[an++] = ua(X, It, It += le);
                return Vn;
              }
              function Pu(X) {
                for (var le = -1, Ae = X == null ? 0 : X.length, et = 0, It = []; ++le < Ae; ) {
                  var an = X[le];
                  an && (It[et++] = an);
                }
                return It;
              }
              function Tc() {
                var X = arguments.length;
                if (!X)
                  return [];
                for (var le = ui(X - 1), Ae = arguments[0], et = X; et--; )
                  le[et - 1] = arguments[et];
                return r1(ba(Ae) ? Ct(Ae) : [Ae], tv(le, 1));
              }
              var Ff = St(function(X, le) {
                return Yu(X) ? UC(X, tv(le, 1, Yu, true)) : [];
              }), Mu = St(function(X, le) {
                var Ae = cg(le);
                return Yu(Ae) && (Ae = xe), Yu(X) ? UC(X, tv(le, 1, Yu, true), Ts(Ae, 2)) : [];
              }), Vf = St(function(X, le) {
                var Ae = cg(le);
                return Yu(Ae) && (Ae = xe), Yu(X) ? UC(X, tv(le, 1, Yu, true), xe, Ae) : [];
              });
              function Lp(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                return et ? (le = Ae || le === xe ? 1 : Tu(le), ua(X, le < 0 ? 0 : le, et)) : [];
              }
              function Dl(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                return et ? (le = Ae || le === xe ? 1 : Tu(le), le = et - le, ua(X, 0, le < 0 ? 0 : le)) : [];
              }
              function Bd(X, le) {
                return X && X.length ? ge(X, Ts(le, 3), true, true) : [];
              }
              function em(X, le) {
                return X && X.length ? ge(X, Ts(le, 3), true) : [];
              }
              function Vx(X, le, Ae, et) {
                var It = X == null ? 0 : X.length;
                return It ? (Ae && typeof Ae != "number" && Zf(X, le, Ae) && (Ae = 0, et = It), g6(X, le, Ae, et)) : [];
              }
              function DD(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                if (!et)
                  return -1;
                var It = Ae == null ? 0 : Tu(Ae);
                return It < 0 && (It = cd(et + It, 0)), G3(X, Ts(le, 3), It);
              }
              function o_(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                if (!et)
                  return -1;
                var It = et - 1;
                return Ae !== xe && (It = Tu(Ae), It = Ae < 0 ? cd(et + It, 0) : Nd(It, et - 1)), G3(X, Ts(le, 3), It, true);
              }
              function yA(X) {
                var le = X == null ? 0 : X.length;
                return le ? tv(X, 1) : [];
              }
              function ZC(X) {
                var le = X == null ? 0 : X.length;
                return le ? tv(X, xs) : [];
              }
              function Dv(X, le) {
                var Ae = X == null ? 0 : X.length;
                return Ae ? (le = le === xe ? 1 : Tu(le), tv(X, le)) : [];
              }
              function XS(X) {
                for (var le = -1, Ae = X == null ? 0 : X.length, et = {}; ++le < Ae; ) {
                  var It = X[le];
                  et[It[0]] = It[1];
                }
                return et;
              }
              function mA(X) {
                return X && X.length ? X[0] : xe;
              }
              function JC(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                if (!et)
                  return -1;
                var It = Ae == null ? 0 : Tu(Ae);
                return It < 0 && (It = cd(et + It, 0)), BS(X, le, It);
              }
              function kD(X) {
                var le = X == null ? 0 : X.length;
                return le ? ua(X, 0, -1) : [];
              }
              var OD = St(function(X) {
                var le = jl(X, Te);
                return le.length && le[0] === X[0] ? _6(le) : [];
              }), D6 = St(function(X) {
                var le = cg(X), Ae = jl(X, Te);
                return le === cg(Ae) ? le = xe : Ae.pop(), Ae.length && Ae[0] === X[0] ? _6(Ae, Ts(le, 2)) : [];
              }), aO = St(function(X) {
                var le = cg(X), Ae = jl(X, Te);
                return le = typeof le == "function" ? le : xe, le && Ae.pop(), Ae.length && Ae[0] === X[0] ? _6(Ae, xe, le) : [];
              });
              function oO(X, le) {
                return X == null ? "" : mf.call(X, le);
              }
              function cg(X) {
                var le = X == null ? 0 : X.length;
                return le ? X[le - 1] : xe;
              }
              function bA(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                if (!et)
                  return -1;
                var It = et;
                return Ae !== xe && (It = Tu(Ae), It = It < 0 ? cd(et + It, 0) : Nd(It, et - 1)), le === le ? PY(X, le, It) : G3(X, gf, It, true);
              }
              function k6(X, le) {
                return X && X.length ? HB(X, Tu(le)) : xe;
              }
              var rK = St($B);
              function $B(X, le) {
                return X && X.length && le && le.length ? iO(X, le) : X;
              }
              function sO(X, le, Ae) {
                return X && X.length && le && le.length ? iO(X, le, Ts(Ae, 2)) : X;
              }
              function Gle(X, le, Ae) {
                return X && X.length && le && le.length ? iO(X, le, xe, Ae) : X;
              }
              var Hle = Zg(function(X, le) {
                var Ae = X == null ? 0 : X.length, et = v6(X, le);
                return q10(X, jl(le, function(It) {
                  return rv(It, Ae) ? +It : It;
                }).sort(br)), et;
              });
              function OTe(X, le) {
                var Ae = [];
                if (!(X && X.length))
                  return Ae;
                var et = -1, It = [], an = X.length;
                for (le = Ts(le, 3); ++et < an; ) {
                  var Vn = X[et];
                  le(Vn, et, X) && (Ae.push(Vn), It.push(et));
                }
                return q10(X, It), Ae;
              }
              function XB(X) {
                return X == null ? X : l6.call(X);
              }
              function Wle(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                return et ? (Ae && typeof Ae != "number" && Zf(X, le, Ae) ? (le = 0, Ae = et) : (le = le == null ? 0 : Tu(le), Ae = Ae === xe ? et : Tu(Ae)), ua(X, le, Ae)) : [];
              }
              function Ule(X, le) {
                return os(X, le);
              }
              function qle(X, le, Ae) {
                return Rs(X, le, Ts(Ae, 2));
              }
              function PTe(X, le) {
                var Ae = X == null ? 0 : X.length;
                if (Ae) {
                  var et = os(X, le);
                  if (et < Ae && Y0(X[et], le))
                    return et;
                }
                return -1;
              }
              function LTe(X, le) {
                return os(X, le, true);
              }
              function RTe(X, le, Ae) {
                return Rs(X, le, Ts(Ae, 2), true);
              }
              function $le(X, le) {
                var Ae = X == null ? 0 : X.length;
                if (Ae) {
                  var et = os(X, le, true) - 1;
                  if (Y0(X[et], le))
                    return et;
                }
                return -1;
              }
              function NTe(X) {
                return X && X.length ? su(X) : [];
              }
              function FTe(X, le) {
                return X && X.length ? su(X, Ts(le, 2)) : [];
              }
              function VTe(X) {
                var le = X == null ? 0 : X.length;
                return le ? ua(X, 1, le) : [];
              }
              function BTe(X, le, Ae) {
                return X && X.length ? (le = Ae || le === xe ? 1 : Tu(le), ua(X, 0, le < 0 ? 0 : le)) : [];
              }
              function iK(X, le, Ae) {
                var et = X == null ? 0 : X.length;
                return et ? (le = Ae || le === xe ? 1 : Tu(le), le = et - le, ua(X, le < 0 ? 0 : le, et)) : [];
              }
              function zTe(X, le) {
                return X && X.length ? ge(X, Ts(le, 3), false, true) : [];
              }
              function jTe(X, le) {
                return X && X.length ? ge(X, Ts(le, 3)) : [];
              }
              var GTe = St(function(X) {
                return Yl(tv(X, 1, Yu, true));
              }), HTe = St(function(X) {
                var le = cg(X);
                return Yu(le) && (le = xe), Yl(tv(X, 1, Yu, true), Ts(le, 2));
              }), WTe = St(function(X) {
                var le = cg(X);
                return le = typeof le == "function" ? le : xe, Yl(tv(X, 1, Yu, true), xe, le);
              });
              function yp(X) {
                return X && X.length ? Yl(X) : [];
              }
              function Jh(X, le) {
                return X && X.length ? Yl(X, Ts(le, 2)) : [];
              }
              function UTe(X, le) {
                return le = typeof le == "function" ? le : xe, X && X.length ? Yl(X, xe, le) : [];
              }
              function aK(X) {
                if (!(X && X.length))
                  return [];
                var le = 0;
                return X = Ex(X, function(Ae) {
                  if (Yu(Ae))
                    return le = cd(Ae.length, le), true;
                }), jS(le, function(Ae) {
                  return jl(X, fD(Ae));
                });
              }
              function Xle(X, le) {
                if (!(X && X.length))
                  return [];
                var Ae = aK(X);
                return le == null ? Ae : jl(Ae, function(et) {
                  return Yy(le, xe, et);
                });
              }
              var qTe = St(function(X, le) {
                return Yu(X) ? UC(X, le) : [];
              }), $Te = St(function(X) {
                return we(Ex(X, Yu));
              }), XTe = St(function(X) {
                var le = cg(X);
                return Yu(le) && (le = xe), we(Ex(X, Yu), Ts(le, 2));
              }), Yle = St(function(X) {
                var le = cg(X);
                return le = typeof le == "function" ? le : xe, we(Ex(X, Yu), xe, le);
              }), YTe = St(aK);
              function Qg(X, le) {
                return Me(X || [], le || [], Ev);
              }
              function oK(X, le) {
                return Me(X || [], le || [], Yn);
              }
              var PD = St(function(X) {
                var le = X.length, Ae = le > 1 ? X[le - 1] : xe;
                return Ae = typeof Ae == "function" ? (X.pop(), Ae) : xe, Xle(X, Ae);
              });
              function sK(X) {
                var le = Bt(X);
                return le.__chain__ = true, le;
              }
              function lK(X, le) {
                return le(X), X;
              }
              function tm(X, le) {
                return le(X);
              }
              var Kle = Zg(function(X) {
                var le = X.length, Ae = le ? X[0] : 0, et = this.__wrapped__, It = function(an) {
                  return v6(an, X);
                };
                return le > 1 || this.__actions__.length || !(et instanceof qu) || !rv(Ae) ? this.thru(It) : (et = et.slice(Ae, +Ae + (le ? 1 : 0)), et.__actions__.push({ func: tm, args: [It], thisArg: xe }), new Ky(et, this.__chain__).thru(function(an) {
                  return le && !an.length && an.push(xe), an;
                }));
              });
              function Zle() {
                return sK(this);
              }
              function Jle() {
                return new Ky(this.value(), this.__chain__);
              }
              function Qle() {
                this.__values__ === xe && (this.__values__ = vue(this.value()));
                var X = this.__index__ >= this.__values__.length, le = X ? xe : this.__values__[this.__index__++];
                return { done: X, value: le };
              }
              function eue() {
                return this;
              }
              function tue(X) {
                for (var le, Ae = this; Ae instanceof X3; ) {
                  var et = Ca(Ae);
                  et.__index__ = 0, et.__values__ = xe, le ? It.__wrapped__ = et : le = et;
                  var It = et;
                  Ae = Ae.__wrapped__;
                }
                return It.__wrapped__ = X, le;
              }
              function cb() {
                var X = this.__wrapped__;
                if (X instanceof qu) {
                  var le = X;
                  return this.__actions__.length && (le = new qu(this)), le = le.reverse(), le.__actions__.push({ func: tm, args: [XB], thisArg: xe }), new Ky(le, this.__chain__);
                }
                return this.thru(XB);
              }
              function KTe() {
                return He(this.__wrapped__, this.__actions__);
              }
              var s_ = _i(function(X, le, Ae) {
                yf.call(X, Ae) ? ++X[Ae] : lb2(X, Ae, 1);
              });
              function ZTe(X, le, Ae) {
                var et = ba(X) ? fB : KY;
                return Ae && Zf(X, le, Ae) && (le = xe), et(X, Ts(le, 3));
              }
              function nue(X, le) {
                var Ae = ba(X) ? Ex : Rx;
                return Ae(X, Ts(le, 3));
              }
              var _A = Is(DD), YB = Is(o_);
              function uK(X, le) {
                return tv(O6(X, le), 1);
              }
              function Rp(X, le) {
                return tv(O6(X, le), xs);
              }
              function xA(X, le, Ae) {
                return Ae = Ae === xe ? 1 : Tu(Ae), tv(O6(X, le), Ae);
              }
              function KB(X, le) {
                var Ae = ba(X) ? qg : ub;
                return Ae(X, Ts(le, 3));
              }
              function rue(X, le) {
                var Ae = ba(X) ? IY : pA;
                return Ae(X, Ts(le, 3));
              }
              var cK = _i(function(X, le, Ae) {
                yf.call(X, Ae) ? X[Ae].push(le) : lb2(X, Ae, [le]);
              });
              function JTe(X, le, Ae, et) {
                X = Zl(X) ? X : _O(X), Ae = Ae && !et ? Tu(Ae) : 0;
                var It = X.length;
                return Ae < 0 && (Ae = cd(It + Ae, 0)), KS(X) ? Ae <= It && X.indexOf(le, Ae) > -1 : !!It && BS(X, le, Ae) > -1;
              }
              var QTe = St(function(X, le, Ae) {
                var et = -1, It = typeof le == "function", an = Zl(X) ? ui(X.length) : [];
                return ub(X, function(Vn) {
                  an[++et] = It ? Yy(le, Vn, Ae) : qC(Vn, le, Ae);
                }), an;
              }), eAe = _i(function(X, le, Ae) {
                lb2(X, Ae, le);
              });
              function O6(X, le) {
                var Ae = ba(X) ? jl : GB;
                return Ae(X, Ts(le, 3));
              }
              function ZB(X, le, Ae, et) {
                return X == null ? [] : (ba(le) || (le = le == null ? [] : [le]), Ae = et ? xe : Ae, ba(Ae) || (Ae = Ae == null ? [] : [Ae]), I6(X, le, Ae));
              }
              var lO = _i(function(X, le, Ae) {
                X[Ae ? 0 : 1].push(le);
              }, function() {
                return [[], []];
              });
              function tAe(X, le, Ae) {
                var et = ba(X) ? B3 : hD, It = arguments.length < 3;
                return et(X, Ts(le, 4), Ae, It, ub);
              }
              function iue(X, le, Ae) {
                var et = ba(X) ? VS : hD, It = arguments.length < 3;
                return et(X, Ts(le, 4), Ae, It, pA);
              }
              function aue(X, le) {
                var Ae = ba(X) ? Ex : Rx;
                return Ae(X, ez(Ts(le, 3)));
              }
              function fK(X) {
                var le = ba(X) ? PB : rn;
                return le(X);
              }
              function hK(X, le, Ae) {
                (Ae ? Zf(X, le, Ae) : le === xe) ? le = 1 : le = Tu(le);
                var et = ba(X) ? LB : Gn;
                return et(X, le);
              }
              function oue(X) {
                var le = ba(X) ? $Y : oa;
                return le(X);
              }
              function nAe(X) {
                if (X == null)
                  return 0;
                if (Zl(X))
                  return KS(X) ? vu(X) : X.length;
                var le = Os(X);
                return le == Ap || le == gp ? X.size : nO(X).length;
              }
              function pK(X, le, Ae) {
                var et = ba(X) ? cD : bo;
                return Ae && Zf(X, le, Ae) && (le = xe), et(X, Ts(le, 3));
              }
              var dK = St(function(X, le) {
                if (X == null)
                  return [];
                var Ae = le.length;
                return Ae > 1 && Zf(X, le[0], le[1]) ? le = [] : Ae > 2 && Zf(le[0], le[1], le[2]) && (le = [le[0]]), I6(X, tv(le, 1), []);
              }), JB = SB || function() {
                return Dp.Date.now();
              };
              function sue(X, le) {
                if (typeof le != "function")
                  throw new W0(at);
                return X = Tu(X), function() {
                  if (--X < 1)
                    return le.apply(this, arguments);
                };
              }
              function u1(X, le, Ae) {
                return le = Ae ? xe : le, le = X && le == null ? X.length : le, dd(X, Si, xe, xe, xe, xe, le);
              }
              function QB(X, le) {
                var Ae;
                if (typeof le != "function")
                  throw new W0(at);
                return X = Tu(X), function() {
                  return --X > 0 && (Ae = le.apply(this, arguments)), X <= 1 && (le = xe), Ae;
                };
              }
              var LD = St(function(X, le, Ae) {
                var et = sr;
                if (Ae.length) {
                  var It = HS(Ae, Lh(LD));
                  et |= Ar;
                }
                return dd(X, et, le, Ae, It);
              }), vK = St(function(X, le, Ae) {
                var et = sr | Ii;
                if (Ae.length) {
                  var It = HS(Ae, Lh(vK));
                  et |= Ar;
                }
                return dd(le, et, X, Ae, It);
              });
              function gK(X, le, Ae) {
                le = Ae ? xe : le;
                var et = dd(X, Sa, xe, xe, xe, xe, xe, le);
                return et.placeholder = gK.placeholder, et;
              }
              function lue(X, le, Ae) {
                le = Ae ? xe : le;
                var et = dd(X, Tt, xe, xe, xe, xe, xe, le);
                return et.placeholder = lue.placeholder, et;
              }
              function uue(X, le, Ae) {
                var et, It, an, Vn, tr, Tr, sa = 0, fa = false, Ea = false, eo = true;
                if (typeof X != "function")
                  throw new W0(at);
                le = Bf(le) || 0, Qh(Ae) && (fa = !!Ae.leading, Ea = "maxWait" in Ae, an = Ea ? cd(Bf(Ae.maxWait) || 0, le) : an, eo = "trailing" in Ae ? !!Ae.trailing : eo);
                function ts(lh) {
                  var zx = et, Z0 = It;
                  return et = It = xe, sa = lh, Vn = X.apply(Z0, zx), Vn;
                }
                function tl(lh) {
                  return sa = lh, tr = Tn(uc, le), fa ? ts(lh) : Vn;
                }
                function Au(lh) {
                  var zx = lh - Tr, Z0 = lh - sa, RK = le - zx;
                  return Ea ? Nd(RK, an - Z0) : RK;
                }
                function $s(lh) {
                  var zx = lh - Tr, Z0 = lh - sa;
                  return Tr === xe || zx >= le || zx < 0 || Ea && Z0 >= an;
                }
                function uc() {
                  var lh = JB();
                  if ($s(lh))
                    return Ic(lh);
                  tr = Tn(uc, Au(lh));
                }
                function Ic(lh) {
                  return tr = xe, eo && et ? ts(lh) : (et = It = xe, Vn);
                }
                function f1() {
                  tr !== xe && kt(tr), sa = 0, et = Tr = It = tr = xe;
                }
                function r0() {
                  return tr === xe ? Vn : Ic(JB());
                }
                function rm() {
                  var lh = JB(), zx = $s(lh);
                  if (et = arguments, It = this, Tr = lh, zx) {
                    if (tr === xe)
                      return tl(Tr);
                    if (Ea)
                      return kt(tr), tr = Tn(uc, le), ts(Tr);
                  }
                  return tr === xe && (tr = Tn(uc, le)), Vn;
                }
                return rm.cancel = f1, rm.flush = r0, rm;
              }
              var rAe = St(function(X, le) {
                return TD(X, 1, le);
              }), iAe = St(function(X, le, Ae) {
                return TD(X, Bf(le) || 0, Ae);
              });
              function aAe(X) {
                return dd(X, Dr);
              }
              function QC(X, le) {
                if (typeof X != "function" || le != null && typeof le != "function")
                  throw new W0(at);
                var Ae = function() {
                  var et = arguments, It = le ? le.apply(this, et) : et[0], an = Ae.cache;
                  if (an.has(It))
                    return an.get(It);
                  var Vn = X.apply(this, et);
                  return Ae.cache = an.set(It, Vn) || an, Vn;
                };
                return Ae.cache = new (QC.Cache || Lx)(), Ae;
              }
              QC.Cache = Lx;
              function ez(X) {
                if (typeof X != "function")
                  throw new W0(at);
                return function() {
                  var le = arguments;
                  switch (le.length) {
                    case 0:
                      return !X.call(this);
                    case 1:
                      return !X.call(this, le[0]);
                    case 2:
                      return !X.call(this, le[0], le[1]);
                    case 3:
                      return !X.call(this, le[0], le[1], le[2]);
                  }
                  return !X.apply(this, le);
                };
              }
              function oAe(X) {
                return QB(2, X);
              }
              var yK = ht(function(X, le) {
                le = le.length == 1 && ba(le[0]) ? jl(le[0], Iv(Ts())) : jl(tv(le, 1), Iv(Ts()));
                var Ae = le.length;
                return St(function(et) {
                  for (var It = -1, an = Nd(et.length, Ae); ++It < an; )
                    et[It] = le[It].call(this, et[It]);
                  return Yy(X, this, et);
                });
              }), tz = St(function(X, le) {
                var Ae = HS(le, Lh(tz));
                return dd(X, Ar, xe, le, Ae);
              }), eM = St(function(X, le) {
                var Ae = HS(le, Lh(eM));
                return dd(X, Vr, xe, le, Ae);
              }), nz = Zg(function(X, le) {
                return dd(X, mi, xe, xe, xe, le);
              });
              function sAe(X, le) {
                if (typeof X != "function")
                  throw new W0(at);
                return le = le === xe ? le : Tu(le), St(X, le);
              }
              function lAe(X, le) {
                if (typeof X != "function")
                  throw new W0(at);
                return le = le == null ? 0 : cd(Tu(le), 0), St(function(Ae) {
                  var et = Ae[le], It = xt(Ae, 0, le);
                  return et && r1(It, et), Yy(X, this, It);
                });
              }
              function uAe(X, le, Ae) {
                var et = true, It = true;
                if (typeof X != "function")
                  throw new W0(at);
                return Qh(Ae) && (et = "leading" in Ae ? !!Ae.leading : et, It = "trailing" in Ae ? !!Ae.trailing : It), uue(X, le, { leading: et, maxWait: le, trailing: It });
              }
              function uO(X) {
                return u1(X, 1);
              }
              function Bx(X, le) {
                return tz(Ne(le), X);
              }
              function cue() {
                if (!arguments.length)
                  return [];
                var X = arguments[0];
                return ba(X) ? X : [X];
              }
              function cAe(X) {
                return a1(X, Un);
              }
              function fAe(X, le) {
                return le = typeof le == "function" ? le : xe, a1(X, Un, le);
              }
              function hAe(X) {
                return a1(X, tn | Un);
              }
              function pAe(X, le) {
                return le = typeof le == "function" ? le : xe, a1(X, tn | Un, le);
              }
              function dAe(X, le) {
                return le == null || FB(X, le, qs(le));
              }
              function Y0(X, le) {
                return X === le || X !== X && le !== le;
              }
              var wr = lu(b6), Xi = lu(function(X, le) {
                return X >= le;
              }), ri = ID(function() {
                return arguments;
              }()) ? ID : function(X) {
                return gd(X) && yf.call(X, "callee") && !Rd.call(X, "callee");
              }, ba = ui.isArray, Kl = rA ? Iv(rA) : $C;
              function Zl(X) {
                return X != null && P6(X.length) && !Ac(X);
              }
              function Yu(X) {
                return gd(X) && Zl(X);
              }
              function Fh(X) {
                return X === true || X === false || gd(X) && pd(X) == Cu;
              }
              var YS = CB || EK, vAe = uB ? Iv(uB) : x6;
              function l_(X) {
                return gd(X) && X.nodeType === 1 && !hO(X);
              }
              function rz(X) {
                if (X == null)
                  return true;
                if (Zl(X) && (ba(X) || typeof X == "string" || typeof X.splice == "function" || YS(X) || vO(X) || ri(X)))
                  return !X.length;
                var le = Os(X);
                if (le == Ap || le == gp)
                  return !X.size;
                if (ug(X))
                  return !nO(X).length;
                for (var Ae in X)
                  if (yf.call(X, Ae))
                    return false;
                return true;
              }
              function gAe(X, le) {
                return n_(X, le);
              }
              function cO(X, le, Ae) {
                Ae = typeof Ae == "function" ? Ae : xe;
                var et = Ae ? Ae(X, le) : xe;
                return et === xe ? n_(X, le, xe, Ae) : !!et;
              }
              function fO(X) {
                if (!gd(X))
                  return false;
                var le = pd(X);
                return le == B0 || le == Eh || typeof X.message == "string" && typeof X.name == "string" && !hO(X);
              }
              function iz(X) {
                return typeof X == "number" && MB(X);
              }
              function Ac(X) {
                if (!Qh(X))
                  return false;
                var le = pd(X);
                return le == qy || le == vp || le == Tf || le == ws;
              }
              function fue(X) {
                return typeof X == "number" && X == Tu(X);
              }
              function P6(X) {
                return typeof X == "number" && X > -1 && X % 1 == 0 && X <= Ti;
              }
              function Qh(X) {
                var le = typeof X;
                return X != null && (le == "object" || le == "function");
              }
              function gd(X) {
                return X != null && typeof X == "object";
              }
              var hue = cB ? Iv(cB) : BB;
              function yAe(X, le) {
                return X === le || S6(X, le, Kr(le));
              }
              function az(X, le, Ae) {
                return Ae = typeof Ae == "function" ? Ae : xe, S6(X, le, Kr(le), Ae);
              }
              function wA(X) {
                return mK(X) && X != +X;
              }
              function oz(X) {
                if (a_(X))
                  throw new Ll(Re);
                return XC(X);
              }
              function pue(X) {
                return X === null;
              }
              function sz(X) {
                return X == null;
              }
              function mK(X) {
                return typeof X == "number" || gd(X) && pd(X) == ig;
              }
              function hO(X) {
                if (!gd(X) || pd(X) != Ed)
                  return false;
                var le = yD(X);
                if (le === null)
                  return true;
                var Ae = yf.call(le, "constructor") && le.constructor;
                return typeof Ae == "function" && Ae instanceof Ae && sh.call(Ae) == LY;
              }
              var pO = uD ? Iv(uD) : tO;
              function due(X) {
                return fue(X) && X >= -Ti && X <= Ti;
              }
              var dO = V3 ? Iv(V3) : C6;
              function KS(X) {
                return typeof X == "string" || !ba(X) && gd(X) && pd(X) == Yh;
              }
              function K0(X) {
                return typeof X == "symbol" || gd(X) && pd(X) == Ip;
              }
              var vO = Z4 ? Iv(Z4) : zB;
              function mAe(X) {
                return X === xe;
              }
              function bAe(X) {
                return gd(X) && Os(X) == qi;
              }
              function lz(X) {
                return gd(X) && pd(X) == Rr;
              }
              var uz = lu(YC), bK = lu(function(X, le) {
                return X <= le;
              });
              function vue(X) {
                if (!X)
                  return [];
                if (Zl(X))
                  return KS(X) ? sg(X) : Ct(X);
                if (gu && X[gu])
                  return n62(X[gu]());
                var le = Os(X), Ae = le == Ap ? r6 : le == gp ? W3 : _O;
                return Ae(X);
              }
              function ZS(X) {
                if (!X)
                  return X === 0 ? X : 0;
                if (X = Bf(X), X === xs || X === -xs) {
                  var le = X < 0 ? -1 : 1;
                  return le * si;
                }
                return X === X ? X : 0;
              }
              function Tu(X) {
                var le = ZS(X), Ae = le % 1;
                return le === le ? Ae ? le - Ae : le : 0;
              }
              function gue(X) {
                return X ? WC(Tu(X), 0, ja) : 0;
              }
              function Bf(X) {
                if (typeof X == "number")
                  return X;
                if (K0(X))
                  return ni;
                if (Qh(X)) {
                  var le = typeof X.valueOf == "function" ? X.valueOf() : X;
                  X = Qh(le) ? le + "" : le;
                }
                if (typeof X != "string")
                  return X === 0 ? X : +X;
                X = vD(X);
                var Ae = Fr.test(X);
                return Ae || di.test(X) ? TY(X.slice(2), Ae ? 2 : 8) : wn.test(X) ? ni : +X;
              }
              function e0(X) {
                return dr(X, c1(X));
              }
              function _Ae(X) {
                return X ? WC(Tu(X), -Ti, Ti) : X === 0 ? X : 0;
              }
              function zf(X) {
                return X == null ? "" : Qs(X);
              }
              var yue = Pr(function(X, le) {
                if (ug(le) || Zl(le)) {
                  dr(le, qs(le), X);
                  return;
                }
                for (var Ae in le)
                  yf.call(le, Ae) && Ev(X, Ae, le[Ae]);
              }), mue = Pr(function(X, le) {
                dr(le, c1(le), X);
              }), gO = Pr(function(X, le, Ae, et) {
                dr(le, c1(le), X, et);
              }), L6 = Pr(function(X, le, Ae, et) {
                dr(le, qs(le), X, et);
              }), _K = Zg(v6);
              function yO(X, le) {
                var Ae = fA(X);
                return le == null ? Ae : NB(Ae, le);
              }
              var R6 = St(function(X, le) {
                X = If(X);
                var Ae = -1, et = le.length, It = et > 2 ? le[2] : xe;
                for (It && Zf(le[0], le[1], It) && (et = 1); ++Ae < et; )
                  for (var an = le[Ae], Vn = c1(an), tr = -1, Tr = Vn.length; ++tr < Tr; ) {
                    var sa = Vn[tr], fa = X[sa];
                    (fa === xe || Y0(fa, Yf[sa]) && !yf.call(X, sa)) && (X[sa] = an[sa]);
                  }
                return X;
              }), N6 = St(function(X) {
                return X.push(xe, r_), Yy(_ue, xe, X);
              });
              function cz(X, le) {
                return j3(X, Ts(le, 3), Zy);
              }
              function mO(X, le) {
                return j3(X, Ts(le, 3), eO);
              }
              function xAe(X, le) {
                return X == null ? X : y6(X, Ts(le, 3), c1);
              }
              function wAe(X, le) {
                return X == null ? X : Yg(X, Ts(le, 3), c1);
              }
              function SAe(X, le) {
                return X && Zy(X, Ts(le, 3));
              }
              function CAe(X, le) {
                return X && eO(X, Ts(le, 3));
              }
              function MAe(X) {
                return X == null ? [] : AD(X, qs(X));
              }
              function fz(X) {
                return X == null ? [] : AD(X, c1(X));
              }
              function RD(X, le, Ae) {
                var et = X == null ? xe : Nx(X, le);
                return et === xe ? Ae : et;
              }
              function bue(X, le) {
                return X != null && Zh(X, le, Gs);
              }
              function qt(X, le) {
                return X != null && Zh(X, le, VB);
              }
              var bO = ai(function(X, le, Ae) {
                le != null && typeof le.toString != "function" && (le = U3.call(le)), X[le] = Ae;
              }, h_(nm)), hz = ai(function(X, le, Ae) {
                le != null && typeof le.toString != "function" && (le = U3.call(le)), yf.call(X, le) ? X[le].push(Ae) : X[le] = [Ae];
              }, Ts), u_ = St(qC);
              function qs(X) {
                return Zl(X) ? OB(X) : nO(X);
              }
              function c1(X) {
                return Zl(X) ? OB(X, true) : M6(X);
              }
              function TAe(X, le) {
                var Ae = {};
                return le = Ts(le, 3), Zy(X, function(et, It, an) {
                  lb2(Ae, le(et, It, an), et);
                }), Ae;
              }
              function AAe(X, le) {
                var Ae = {};
                return le = Ts(le, 3), Zy(X, function(et, It, an) {
                  lb2(Ae, It, le(et, It, an));
                }), Ae;
              }
              var ND = Pr(function(X, le, Ae) {
                rO(X, le, Ae);
              }), _ue = Pr(function(X, le, Ae, et) {
                rO(X, le, Ae, et);
              }), IAe = Zg(function(X, le) {
                var Ae = {};
                if (X == null)
                  return Ae;
                var et = false;
                le = jl(le, function(an) {
                  return an = it(an, X), et || (et = an.length > 1), an;
                }), dr(X, s1(X), Ae), et && (Ae = a1(Ae, tn | Fn | Un, nv));
                for (var It = le.length; It--; )
                  Kg(Ae, le[It]);
                return Ae;
              });
              function EAe(X, le) {
                return xue(X, ez(Ts(le)));
              }
              var DAe = Zg(function(X, le) {
                return X == null ? {} : dA(X, le);
              });
              function xue(X, le) {
                if (X == null)
                  return {};
                var Ae = jl(s1(X), function(et) {
                  return [et];
                });
                return le = Ts(le), WB(X, Ae, function(et, It) {
                  return le(et, It[0]);
                });
              }
              function tM(X, le, Ae) {
                le = it(le, X);
                var et = -1, It = le.length;
                for (It || (It = 1, X = xe); ++et < It; ) {
                  var an = X == null ? xe : X[Ai(le[et])];
                  an === xe && (et = It, an = Ae), X = Ac(an) ? an.call(X) : an;
                }
                return X;
              }
              function kAe(X, le, Ae) {
                return X == null ? X : Yn(X, le, Ae);
              }
              function OAe(X, le, Ae, et) {
                return et = typeof et == "function" ? et : xe, X == null ? X : Yn(X, le, Ae, et);
              }
              var wue = Op(qs), Sue = Op(c1);
              function PAe(X, le, Ae) {
                var et = ba(X), It = et || YS(X) || vO(X);
                if (le = Ts(le, 4), Ae == null) {
                  var an = X && X.constructor;
                  It ? Ae = et ? new an() : [] : Qh(X) ? Ae = Ac(an) ? fA(yD(X)) : {} : Ae = {};
                }
                return (It ? qg : Zy)(X, function(Vn, tr, Tr) {
                  return le(Ae, Vn, tr, Tr);
                }), Ae;
              }
              function nM(X, le) {
                return X == null ? true : Kg(X, le);
              }
              function LAe(X, le, Ae) {
                return X == null ? X : lg(X, le, Ne(Ae));
              }
              function RAe(X, le, Ae, et) {
                return et = typeof et == "function" ? et : xe, X == null ? X : lg(X, le, Ne(Ae), et);
              }
              function _O(X) {
                return X == null ? [] : BC(X, qs(X));
              }
              function NAe(X) {
                return X == null ? [] : BC(X, c1(X));
              }
              function FAe(X, le, Ae) {
                return Ae === xe && (Ae = le, le = xe), Ae !== xe && (Ae = Bf(Ae), Ae = Ae === Ae ? Ae : 0), le !== xe && (le = Bf(le), le = le === le ? le : 0), WC(Bf(X), le, Ae);
              }
              function FD(X, le, Ae) {
                return le = ZS(le), Ae === xe ? (Ae = le, le = 0) : Ae = ZS(Ae), X = Bf(X), ZY(X, le, Ae);
              }
              function VAe(X, le, Ae) {
                if (Ae && typeof Ae != "boolean" && Zf(X, le, Ae) && (le = Ae = xe), Ae === xe && (typeof le == "boolean" ? (Ae = le, le = xe) : typeof X == "boolean" && (Ae = X, X = xe)), X === xe && le === xe ? (X = 0, le = 1) : (X = ZS(X), le === xe ? (le = X, X = 0) : le = ZS(le)), X > le) {
                  var et = X;
                  X = le, le = et;
                }
                if (Ae || X % 1 || le % 1) {
                  var It = sA();
                  return Nd(X + It * (le - X + oB("1e-" + ((It + "").length - 1))), le);
                }
                return re(X, le);
              }
              var BAe = No(function(X, le, Ae) {
                return le = le.toLowerCase(), X + (Ae ? c_(le) : le);
              });
              function c_(X) {
                return xO(zf(X).toLowerCase());
              }
              function Cue(X) {
                return X = zf(X), X && X.replace(xa, H3).replace(og, "");
              }
              function zAe(X, le, Ae) {
                X = zf(X), le = Qs(le);
                var et = X.length;
                Ae = Ae === xe ? et : WC(Tu(Ae), 0, et);
                var It = Ae;
                return Ae -= le.length, Ae >= 0 && X.slice(Ae, It) == le;
              }
              function jAe(X) {
                return X = zf(X), X && ud.test(X) ? X.replace(ih, DY) : X;
              }
              function GAe(X) {
                return X = zf(X), X && iD.test(X) ? X.replace(Cx, "\\$&") : X;
              }
              var HAe = No(function(X, le, Ae) {
                return X + (Ae ? "-" : "") + le.toLowerCase();
              }), Mue = No(function(X, le, Ae) {
                return X + (Ae ? " " : "") + le.toLowerCase();
              }), Tue = Mr("toLowerCase");
              function WAe(X, le, Ae) {
                X = zf(X), le = Tu(le);
                var et = le ? vu(X) : 0;
                if (!le || et >= le)
                  return X;
                var It = (le - et) / 2;
                return el(bD(It), Ae) + X + el(Rl(It), Ae);
              }
              function UAe(X, le, Ae) {
                X = zf(X), le = Tu(le);
                var et = le ? vu(X) : 0;
                return le && et < le ? X + el(le - et, Ae) : X;
              }
              function xK(X, le, Ae) {
                X = zf(X), le = Tu(le);
                var et = le ? vu(X) : 0;
                return le && et < le ? el(le - et, Ae) + X : X;
              }
              function F6(X, le, Ae) {
                return Ae || le == null ? le = 0 : le && (le = +le), FY(zf(X).replace(Mx, ""), le || 0);
              }
              function pz(X, le, Ae) {
                return (Ae ? Zf(X, le, Ae) : le === xe) ? le = 1 : le = Tu(le), Je(zf(X), le);
              }
              function qAe() {
                var X = arguments, le = zf(X[0]);
                return X.length < 3 ? le : le.replace(X[1], X[2]);
              }
              var Aue = No(function(X, le, Ae) {
                return X + (Ae ? "_" : "") + le.toLowerCase();
              });
              function $Ae(X, le, Ae) {
                return Ae && typeof Ae != "number" && Zf(X, le, Ae) && (le = Ae = xe), Ae = Ae === xe ? ja : Ae >>> 0, Ae ? (X = zf(X), X && (typeof le == "string" || le != null && !pO(le)) && (le = Qs(le), !le && Pd(X)) ? xt(sg(X), 0, Ae) : X.split(le, Ae)) : [];
              }
              var rM = No(function(X, le, Ae) {
                return X + (Ae ? " " : "") + xO(le);
              });
              function wK(X, le, Ae) {
                return X = zf(X), Ae = Ae == null ? 0 : WC(Tu(Ae), 0, X.length), le = Qs(le), X.slice(Ae, Ae + le.length) == le;
              }
              function VD(X, le, Ae) {
                var et = Bt.templateSettings;
                Ae && Zf(X, le, Ae) && (le = xe), X = zf(X), le = gO({}, le, et, o1);
                var It = gO({}, le.imports, et.imports, o1), an = qs(It), Vn = BC(It, an), tr, Tr, sa = 0, fa = le.interpolate || Go, Ea = "__p += '", eo = a6((le.escape || Go).source + "|" + fa.source + "|" + (fa === Wg ? Ot : Go).source + "|" + (le.evaluate || Go).source + "|$", "g"), ts = "//# sourceURL=" + (yf.call(le, "sourceURL") ? (le.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++$4 + "]") + `
`;
                X.replace(eo, function($s, uc, Ic, f1, r0, rm) {
                  return Ic || (Ic = f1), Ea += X.slice(sa, rm).replace(ou, kY), uc && (tr = true, Ea += `' +
__e(` + uc + `) +
'`), r0 && (Tr = true, Ea += `';
` + r0 + `;
__p += '`), Ic && (Ea += `' +
((__t = (` + Ic + `)) == null ? '' : __t) +
'`), sa = rm + $s.length, $s;
                }), Ea += `';
`;
                var tl = yf.call(le, "variable") && le.variable;
                if (!tl)
                  Ea = `with (obj) {
` + Ea + `
}
`;
                else if (dn.test(tl))
                  throw new Ll(ft);
                Ea = (Tr ? Ea.replace(Cv, "") : Ea).replace(Mv, "$1").replace(Qm, "$1;"), Ea = "function(" + (tl || "obj") + `) {
` + (tl ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (tr ? ", __e = _.escape" : "") + (Tr ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Ea + `return __p
}`;
                var Au = SK(function() {
                  return Rc(an, ts + "return " + Ea).apply(xe, Vn);
                });
                if (Au.source = Ea, fO(Au))
                  throw Au;
                return Au;
              }
              function f_(X) {
                return zf(X).toLowerCase();
              }
              function XAe(X) {
                return zf(X).toUpperCase();
              }
              function Iue(X, le, Ae) {
                if (X = zf(X), X && (Ae || le === xe))
                  return vD(X);
                if (!X || !(le = Qs(le)))
                  return X;
                var et = sg(X), It = sg(le), an = hB(et, It), Vn = gD(et, It) + 1;
                return xt(et, an, Vn).join("");
              }
              function Eue(X, le, Ae) {
                if (X = zf(X), X && (Ae || le === xe))
                  return X.slice(0, ah(X) + 1);
                if (!X || !(le = Qs(le)))
                  return X;
                var et = sg(X), It = gD(et, sg(le)) + 1;
                return xt(et, 0, It).join("");
              }
              function V6(X, le, Ae) {
                if (X = zf(X), X && (Ae || le === xe))
                  return X.replace(Mx, "");
                if (!X || !(le = Qs(le)))
                  return X;
                var et = sg(X), It = hB(et, sg(le));
                return xt(et, It).join("");
              }
              function SA(X, le) {
                var Ae = Gr, et = Vi;
                if (Qh(le)) {
                  var It = "separator" in le ? le.separator : It;
                  Ae = "length" in le ? Tu(le.length) : Ae, et = "omission" in le ? Qs(le.omission) : et;
                }
                X = zf(X);
                var an = X.length;
                if (Pd(X)) {
                  var Vn = sg(X);
                  an = Vn.length;
                }
                if (Ae >= an)
                  return X;
                var tr = Ae - vu(et);
                if (tr < 1)
                  return et;
                var Tr = Vn ? xt(Vn, 0, tr).join("") : X.slice(0, tr);
                if (It === xe)
                  return Tr + et;
                if (Vn && (tr += Tr.length - tr), pO(It)) {
                  if (X.slice(tr).search(It)) {
                    var sa, fa = Tr;
                    for (It.global || (It = a6(It.source, zf(gn.exec(It)) + "g")), It.lastIndex = 0; sa = It.exec(fa); )
                      var Ea = sa.index;
                    Tr = Tr.slice(0, Ea === xe ? tr : Ea);
                  }
                } else if (X.indexOf(Qs(It), tr) != tr) {
                  var eo = Tr.lastIndexOf(It);
                  eo > -1 && (Tr = Tr.slice(0, eo));
                }
                return Tr + et;
              }
              function Due(X) {
                return X = zf(X), X && Ou.test(X) ? X.replace(Hg, $g) : X;
              }
              var YAe = No(function(X, le, Ae) {
                return X + (Ae ? " " : "") + le.toUpperCase();
              }), xO = Mr("toUpperCase");
              function kue(X, le, Ae) {
                return X = zf(X), le = Ae ? xe : le, le === xe ? pB(X) ? H0(X) : EY(X) : X.match(le) || [];
              }
              var SK = St(function(X, le) {
                try {
                  return Yy(X, xe, le);
                } catch (Ae) {
                  return fO(Ae) ? Ae : new Ll(Ae);
                }
              }), t0 = Zg(function(X, le) {
                return qg(le, function(Ae) {
                  Ae = Ai(Ae), lb2(X, Ae, LD(X[Ae], X));
                }), X;
              });
              function CK(X) {
                var le = X == null ? 0 : X.length, Ae = Ts();
                return X = le ? jl(X, function(et) {
                  if (typeof et[1] != "function")
                    throw new W0(at);
                  return [Ae(et[0]), et[1]];
                }) : [], St(function(et) {
                  for (var It = -1; ++It < le; ) {
                    var an = X[It];
                    if (Yy(an[0], this, et))
                      return Yy(an[1], this, et);
                  }
                });
              }
              function Oue(X) {
                return YY(a1(X, tn));
              }
              function h_(X) {
                return function() {
                  return X;
                };
              }
              function MK(X, le) {
                return X == null || X !== X ? le : X;
              }
              var dz = Oi(), BD = Oi(true);
              function nm(X) {
                return X;
              }
              function n0(X) {
                return jB(typeof X == "function" ? X : a1(X, tn));
              }
              function TK(X) {
                return T6(a1(X, tn));
              }
              function KAe(X, le) {
                return A6(X, a1(le, tn));
              }
              var ZAe = St(function(X, le) {
                return function(Ae) {
                  return qC(Ae, X, le);
                };
              }), JAe = St(function(X, le) {
                return function(Ae) {
                  return qC(X, Ae, le);
                };
              });
              function B6(X, le, Ae) {
                var et = qs(le), It = AD(le, et);
                Ae == null && !(Qh(le) && (It.length || !et.length)) && (Ae = le, le = X, X = this, It = AD(le, qs(le)));
                var an = !(Qh(Ae) && "chain" in Ae) || !!Ae.chain, Vn = Ac(X);
                return qg(It, function(tr) {
                  var Tr = le[tr];
                  X[tr] = Tr, Vn && (X.prototype[tr] = function() {
                    var sa = this.__chain__;
                    if (an || sa) {
                      var fa = X(this.__wrapped__), Ea = fa.__actions__ = Ct(this.__actions__);
                      return Ea.push({ func: Tr, args: arguments, thisArg: X }), fa.__chain__ = sa, fa;
                    }
                    return Tr.apply(X, r1([this.value()], arguments));
                  });
                }), X;
              }
              function QAe() {
                return Dp._ === this && (Dp._ = _B), this;
              }
              function zD() {
              }
              function Pue(X) {
                return X = Tu(X), St(function(le) {
                  return HB(le, X);
                });
              }
              var eIe = Aa(jl), tIe = Aa(fB), z6 = Aa(cD);
              function Lue(X) {
                return Pp(X) ? fD(Ai(X)) : eK(X);
              }
              function nIe(X) {
                return function(le) {
                  return X == null ? xe : Nx(X, le);
                };
              }
              var AK = $u(), Rue = $u(true);
              function IK() {
                return [];
              }
              function EK() {
                return false;
              }
              function rIe() {
                return {};
              }
              function Nue() {
                return "";
              }
              function DK() {
                return true;
              }
              function iIe(X, le) {
                if (X = Tu(X), X < 1 || X > Ti)
                  return [];
                var Ae = ja, et = Nd(X, ja);
                le = Ts(le), X -= ja;
                for (var It = jS(et, le); ++Ae < X; )
                  le(Ae);
                return It;
              }
              function kK(X) {
                return ba(X) ? jl(X, Ai) : K0(X) ? [X] : Ct(zr(zf(X)));
              }
              function Fue(X) {
                var le = ++mB;
                return zf(X) + le;
              }
              var Vue = Ga(function(X, le) {
                return X + le;
              }, 0), Bue = Xu("ceil"), vz = Ga(function(X, le) {
                return X / le;
              }, 1), aIe = Xu("floor");
              function zue(X) {
                return X && X.length ? Q3(X, nm, b6) : xe;
              }
              function jue(X, le) {
                return X && X.length ? Q3(X, Ts(le, 2), b6) : xe;
              }
              function oIe(X) {
                return Od(X, nm);
              }
              function Gue(X, le) {
                return Od(X, Ts(le, 2));
              }
              function sIe(X) {
                return X && X.length ? Q3(X, nm, YC) : xe;
              }
              function OK(X, le) {
                return X && X.length ? Q3(X, Ts(le, 2), YC) : xe;
              }
              var Hue = Ga(function(X, le) {
                return X * le;
              }, 1), PK = Xu("round"), lIe = Ga(function(X, le) {
                return X - le;
              }, 0);
              function LK(X) {
                return X && X.length ? VC(X, nm) : 0;
              }
              function Ku(X, le) {
                return X && X.length ? VC(X, Ts(le, 2)) : 0;
              }
              return Bt.after = sue, Bt.ary = u1, Bt.assign = yue, Bt.assignIn = mue, Bt.assignInWith = gO, Bt.assignWith = L6, Bt.at = _K, Bt.before = QB, Bt.bind = LD, Bt.bindAll = t0, Bt.bindKey = vK, Bt.castArray = cue, Bt.chain = sK, Bt.chunk = ps, Bt.compact = Pu, Bt.concat = Tc, Bt.cond = CK, Bt.conforms = Oue, Bt.constant = h_, Bt.countBy = s_, Bt.create = yO, Bt.curry = gK, Bt.curryRight = lue, Bt.debounce = uue, Bt.defaults = R6, Bt.defaultsDeep = N6, Bt.defer = rAe, Bt.delay = iAe, Bt.difference = Ff, Bt.differenceBy = Mu, Bt.differenceWith = Vf, Bt.drop = Lp, Bt.dropRight = Dl, Bt.dropRightWhile = Bd, Bt.dropWhile = em, Bt.fill = Vx, Bt.filter = nue, Bt.flatMap = uK, Bt.flatMapDeep = Rp, Bt.flatMapDepth = xA, Bt.flatten = yA, Bt.flattenDeep = ZC, Bt.flattenDepth = Dv, Bt.flip = aAe, Bt.flow = dz, Bt.flowRight = BD, Bt.fromPairs = XS, Bt.functions = MAe, Bt.functionsIn = fz, Bt.groupBy = cK, Bt.initial = kD, Bt.intersection = OD, Bt.intersectionBy = D6, Bt.intersectionWith = aO, Bt.invert = bO, Bt.invertBy = hz, Bt.invokeMap = QTe, Bt.iteratee = n0, Bt.keyBy = eAe, Bt.keys = qs, Bt.keysIn = c1, Bt.map = O6, Bt.mapKeys = TAe, Bt.mapValues = AAe, Bt.matches = TK, Bt.matchesProperty = KAe, Bt.memoize = QC, Bt.merge = ND, Bt.mergeWith = _ue, Bt.method = ZAe, Bt.methodOf = JAe, Bt.mixin = B6, Bt.negate = ez, Bt.nthArg = Pue, Bt.omit = IAe, Bt.omitBy = EAe, Bt.once = oAe, Bt.orderBy = ZB, Bt.over = eIe, Bt.overArgs = yK, Bt.overEvery = tIe, Bt.overSome = z6, Bt.partial = tz, Bt.partialRight = eM, Bt.partition = lO, Bt.pick = DAe, Bt.pickBy = xue, Bt.property = Lue, Bt.propertyOf = nIe, Bt.pull = rK, Bt.pullAll = $B, Bt.pullAllBy = sO, Bt.pullAllWith = Gle, Bt.pullAt = Hle, Bt.range = AK, Bt.rangeRight = Rue, Bt.rearg = nz, Bt.reject = aue, Bt.remove = OTe, Bt.rest = sAe, Bt.reverse = XB, Bt.sampleSize = hK, Bt.set = kAe, Bt.setWith = OAe, Bt.shuffle = oue, Bt.slice = Wle, Bt.sortBy = dK, Bt.sortedUniq = NTe, Bt.sortedUniqBy = FTe, Bt.split = $Ae, Bt.spread = lAe, Bt.tail = VTe, Bt.take = BTe, Bt.takeRight = iK, Bt.takeRightWhile = zTe, Bt.takeWhile = jTe, Bt.tap = lK, Bt.throttle = uAe, Bt.thru = tm, Bt.toArray = vue, Bt.toPairs = wue, Bt.toPairsIn = Sue, Bt.toPath = kK, Bt.toPlainObject = e0, Bt.transform = PAe, Bt.unary = uO, Bt.union = GTe, Bt.unionBy = HTe, Bt.unionWith = WTe, Bt.uniq = yp, Bt.uniqBy = Jh, Bt.uniqWith = UTe, Bt.unset = nM, Bt.unzip = aK, Bt.unzipWith = Xle, Bt.update = LAe, Bt.updateWith = RAe, Bt.values = _O, Bt.valuesIn = NAe, Bt.without = qTe, Bt.words = kue, Bt.wrap = Bx, Bt.xor = $Te, Bt.xorBy = XTe, Bt.xorWith = Yle, Bt.zip = YTe, Bt.zipObject = Qg, Bt.zipObjectDeep = oK, Bt.zipWith = PD, Bt.entries = wue, Bt.entriesIn = Sue, Bt.extend = mue, Bt.extendWith = gO, B6(Bt, Bt), Bt.add = Vue, Bt.attempt = SK, Bt.camelCase = BAe, Bt.capitalize = c_, Bt.ceil = Bue, Bt.clamp = FAe, Bt.clone = cAe, Bt.cloneDeep = hAe, Bt.cloneDeepWith = pAe, Bt.cloneWith = fAe, Bt.conformsTo = dAe, Bt.deburr = Cue, Bt.defaultTo = MK, Bt.divide = vz, Bt.endsWith = zAe, Bt.eq = Y0, Bt.escape = jAe, Bt.escapeRegExp = GAe, Bt.every = ZTe, Bt.find = _A, Bt.findIndex = DD, Bt.findKey = cz, Bt.findLast = YB, Bt.findLastIndex = o_, Bt.findLastKey = mO, Bt.floor = aIe, Bt.forEach = KB, Bt.forEachRight = rue, Bt.forIn = xAe, Bt.forInRight = wAe, Bt.forOwn = SAe, Bt.forOwnRight = CAe, Bt.get = RD, Bt.gt = wr, Bt.gte = Xi, Bt.has = bue, Bt.hasIn = qt, Bt.head = mA, Bt.identity = nm, Bt.includes = JTe, Bt.indexOf = JC, Bt.inRange = FD, Bt.invoke = u_, Bt.isArguments = ri, Bt.isArray = ba, Bt.isArrayBuffer = Kl, Bt.isArrayLike = Zl, Bt.isArrayLikeObject = Yu, Bt.isBoolean = Fh, Bt.isBuffer = YS, Bt.isDate = vAe, Bt.isElement = l_, Bt.isEmpty = rz, Bt.isEqual = gAe, Bt.isEqualWith = cO, Bt.isError = fO, Bt.isFinite = iz, Bt.isFunction = Ac, Bt.isInteger = fue, Bt.isLength = P6, Bt.isMap = hue, Bt.isMatch = yAe, Bt.isMatchWith = az, Bt.isNaN = wA, Bt.isNative = oz, Bt.isNil = sz, Bt.isNull = pue, Bt.isNumber = mK, Bt.isObject = Qh, Bt.isObjectLike = gd, Bt.isPlainObject = hO, Bt.isRegExp = pO, Bt.isSafeInteger = due, Bt.isSet = dO, Bt.isString = KS, Bt.isSymbol = K0, Bt.isTypedArray = vO, Bt.isUndefined = mAe, Bt.isWeakMap = bAe, Bt.isWeakSet = lz, Bt.join = oO, Bt.kebabCase = HAe, Bt.last = cg, Bt.lastIndexOf = bA, Bt.lowerCase = Mue, Bt.lowerFirst = Tue, Bt.lt = uz, Bt.lte = bK, Bt.max = zue, Bt.maxBy = jue, Bt.mean = oIe, Bt.meanBy = Gue, Bt.min = sIe, Bt.minBy = OK, Bt.stubArray = IK, Bt.stubFalse = EK, Bt.stubObject = rIe, Bt.stubString = Nue, Bt.stubTrue = DK, Bt.multiply = Hue, Bt.nth = k6, Bt.noConflict = QAe, Bt.noop = zD, Bt.now = JB, Bt.pad = WAe, Bt.padEnd = UAe, Bt.padStart = xK, Bt.parseInt = F6, Bt.random = VAe, Bt.reduce = tAe, Bt.reduceRight = iue, Bt.repeat = pz, Bt.replace = qAe, Bt.result = tM, Bt.round = PK, Bt.runInContext = ir, Bt.sample = fK, Bt.size = nAe, Bt.snakeCase = Aue, Bt.some = pK, Bt.sortedIndex = Ule, Bt.sortedIndexBy = qle, Bt.sortedIndexOf = PTe, Bt.sortedLastIndex = LTe, Bt.sortedLastIndexBy = RTe, Bt.sortedLastIndexOf = $le, Bt.startCase = rM, Bt.startsWith = wK, Bt.subtract = lIe, Bt.sum = LK, Bt.sumBy = Ku, Bt.template = VD, Bt.times = iIe, Bt.toFinite = ZS, Bt.toInteger = Tu, Bt.toLength = gue, Bt.toLower = f_, Bt.toNumber = Bf, Bt.toSafeInteger = _Ae, Bt.toString = zf, Bt.toUpper = XAe, Bt.trim = Iue, Bt.trimEnd = Eue, Bt.trimStart = V6, Bt.truncate = SA, Bt.unescape = Due, Bt.uniqueId = Fue, Bt.upperCase = YAe, Bt.upperFirst = xO, Bt.each = KB, Bt.eachRight = rue, Bt.first = mA, B6(Bt, function() {
                var X = {};
                return Zy(Bt, function(le, Ae) {
                  yf.call(Bt.prototype, Ae) || (X[Ae] = le);
                }), X;
              }(), { chain: false }), Bt.VERSION = Se, qg(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(X) {
                Bt[X].placeholder = Bt;
              }), qg(["drop", "take"], function(X, le) {
                qu.prototype[X] = function(Ae) {
                  Ae = Ae === xe ? 1 : cd(Tu(Ae), 0);
                  var et = this.__filtered__ && !le ? new qu(this) : this.clone();
                  return et.__filtered__ ? et.__takeCount__ = Nd(Ae, et.__takeCount__) : et.__views__.push({ size: Nd(Ae, ja), type: X + (et.__dir__ < 0 ? "Right" : "") }), et;
                }, qu.prototype[X + "Right"] = function(Ae) {
                  return this.reverse()[X](Ae).reverse();
                };
              }), qg(["filter", "map", "takeWhile"], function(X, le) {
                var Ae = le + 1, et = Ae == Ro || Ae == pi;
                qu.prototype[X] = function(It) {
                  var an = this.clone();
                  return an.__iteratees__.push({ iteratee: Ts(It, 3), type: Ae }), an.__filtered__ = an.__filtered__ || et, an;
                };
              }), qg(["head", "last"], function(X, le) {
                var Ae = "take" + (le ? "Right" : "");
                qu.prototype[X] = function() {
                  return this[Ae](1).value()[0];
                };
              }), qg(["initial", "tail"], function(X, le) {
                var Ae = "drop" + (le ? "" : "Right");
                qu.prototype[X] = function() {
                  return this.__filtered__ ? new qu(this) : this[Ae](1);
                };
              }), qu.prototype.compact = function() {
                return this.filter(nm);
              }, qu.prototype.find = function(X) {
                return this.filter(X).head();
              }, qu.prototype.findLast = function(X) {
                return this.reverse().find(X);
              }, qu.prototype.invokeMap = St(function(X, le) {
                return typeof X == "function" ? new qu(this) : this.map(function(Ae) {
                  return qC(Ae, X, le);
                });
              }), qu.prototype.reject = function(X) {
                return this.filter(ez(Ts(X)));
              }, qu.prototype.slice = function(X, le) {
                X = Tu(X);
                var Ae = this;
                return Ae.__filtered__ && (X > 0 || le < 0) ? new qu(Ae) : (X < 0 ? Ae = Ae.takeRight(-X) : X && (Ae = Ae.drop(X)), le !== xe && (le = Tu(le), Ae = le < 0 ? Ae.dropRight(-le) : Ae.take(le - X)), Ae);
              }, qu.prototype.takeRightWhile = function(X) {
                return this.reverse().takeWhile(X).reverse();
              }, qu.prototype.toArray = function() {
                return this.take(ja);
              }, Zy(qu.prototype, function(X, le) {
                var Ae = /^(?:filter|find|map|reject)|While$/.test(le), et = /^(?:head|last)$/.test(le), It = Bt[et ? "take" + (le == "last" ? "Right" : "") : le], an = et || /^find/.test(le);
                !It || (Bt.prototype[le] = function() {
                  var Vn = this.__wrapped__, tr = et ? [1] : arguments, Tr = Vn instanceof qu, sa = tr[0], fa = Tr || ba(Vn), Ea = function(uc) {
                    var Ic = It.apply(Bt, r1([uc], tr));
                    return et && eo ? Ic[0] : Ic;
                  };
                  fa && Ae && typeof sa == "function" && sa.length != 1 && (Tr = fa = false);
                  var eo = this.__chain__, ts = !!this.__actions__.length, tl = an && !eo, Au = Tr && !ts;
                  if (!an && fa) {
                    Vn = Au ? Vn : new qu(this);
                    var $s = X.apply(Vn, tr);
                    return $s.__actions__.push({ func: tm, args: [Ea], thisArg: xe }), new Ky($s, eo);
                  }
                  return tl && Au ? X.apply(this, tr) : ($s = this.thru(Ea), tl ? et ? $s.value()[0] : $s.value() : $s);
                });
              }), qg(["pop", "push", "shift", "sort", "splice", "unshift"], function(X) {
                var le = Kh[X], Ae = /^(?:push|sort|unshift)$/.test(X) ? "tap" : "thru", et = /^(?:pop|shift)$/.test(X);
                Bt.prototype[X] = function() {
                  var It = arguments;
                  if (et && !this.__chain__) {
                    var an = this.value();
                    return le.apply(ba(an) ? an : [], It);
                  }
                  return this[Ae](function(Vn) {
                    return le.apply(ba(Vn) ? Vn : [], It);
                  });
                };
              }), Zy(qu.prototype, function(X, le) {
                var Ae = Bt[le];
                if (Ae) {
                  var et = Ae.name + "";
                  yf.call(uA, et) || (uA[et] = []), uA[et].push({ name: le, func: Ae });
                }
              }), uA[ii(xe, Ii).name] = [{ name: "wrapper", func: xe }], qu.prototype.clone = VY, qu.prototype.reverse = u6, qu.prototype.value = c6, Bt.prototype.at = Kle, Bt.prototype.chain = Zle, Bt.prototype.commit = Jle, Bt.prototype.next = Qle, Bt.prototype.plant = tue, Bt.prototype.reverse = cb, Bt.prototype.toJSON = Bt.prototype.valueOf = Bt.prototype.value = KTe, Bt.prototype.first = Bt.prototype.head, gu && (Bt.prototype[gu] = eue), Bt;
            }, Dx = Pl();
            FS ? ((FS.exports = Dx)._ = Dx, F3._ = Dx) : Dp._ = Dx;
          }).call(Z);
        })(oe, oe.exports);
        class fe {
          constructor() {
            S(this, "subscriptions", /* @__PURE__ */ new Map()), S(this, "emitEffectCache", /* @__PURE__ */ new Map()), S(this, "useSubscription", (Ge, xe) => {
              const Se = T.useRef();
              T.useEffect(() => {
                var Ce, Re;
                Se.current = xe;
                function at(st) {
                  Se.current && Se.current(st);
                }
                const ft = (Re = (Ce = this.subscriptions) == null ? void 0 : Ce.get(Ge)) != null ? Re : [];
                return ft.push(at), this.subscriptions.set(Ge, ft), this.emitEffect(Ge), () => {
                  this.subscriptions.delete(Ge);
                };
              });
            }), S(this, "emit", (Ge, ...xe) => {
              if (typeof Ge == "string" || typeof Ge == "number") {
                const Se = this.subscriptions.get(Ge);
                Se == null || Se.forEach((Ce) => {
                  Ce == null || Ce({ params: oe.exports.cloneDeep(xe), event: Ge });
                }), this.emitEffectCache.set(Ge, { params: oe.exports.cloneDeep(xe), event: Ge });
              } else
                throw new TypeError("event must be string or number !");
            }), S(this, "emitEffect", (Ge) => {
              const xe = this.emitEffectCache.get(Ge), Se = this.subscriptions.get(Ge);
              xe && (Se == null || Se.forEach((Ce) => {
                Ce == null || Ce(_({}, xe));
              }));
            }), S(this, "removeListener", (Ge) => {
              this.subscriptions.delete(Ge);
            }), S(this, "clear", () => {
              this.subscriptions.clear();
            }), this.clear();
          }
        }
        const _e = new fe();
        function pe(ye) {
          const Ge = T.useRef(), xe = T.useMemo(() => ye != null ? ye : { global: false }, [ye]);
          return Ge.current || (Ge.current = xe.global ? Ge.current = _e : Ge.current = new fe()), T.useEffect(() => () => {
            var Se;
            return (Se = Ge.current) == null ? void 0 : Se.clear();
          }, []), Ge.current;
        }
        var Ve = globalThis && globalThis.__read || function(ye, Ge) {
          var xe = typeof Symbol == "function" && ye[Symbol.iterator];
          if (!xe)
            return ye;
          var Se = xe.call(ye), Ce, Re = [], at;
          try {
            for (; (Ge === void 0 || Ge-- > 0) && !(Ce = Se.next()).done; )
              Re.push(Ce.value);
          } catch (ft) {
            at = { error: ft };
          } finally {
            try {
              Ce && !Ce.done && (xe = Se.return) && xe.call(Se);
            } finally {
              if (at)
                throw at.error;
            }
          }
          return Re;
        };
        function Le(ye, Ge) {
          ye === void 0 && (ye = false);
          var xe = Ve(T.useState(ye), 2), Se = xe[0], Ce = xe[1], Re = T.useMemo(function() {
            var at = Ge === void 0 ? !ye : Ge, ft = function() {
              return Ce(function(tn) {
                return tn === ye ? at : ye;
              });
            }, st = function(tn) {
              return Ce(tn);
            }, Dt = function() {
              return Ce(ye);
            }, Pt = function() {
              return Ce(at);
            };
            return { toggle: ft, set: st, setLeft: Dt, setRight: Pt };
          }, []);
          return [Se, Re];
        }
        var je = globalThis && globalThis.__read || function(ye, Ge) {
          var xe = typeof Symbol == "function" && ye[Symbol.iterator];
          if (!xe)
            return ye;
          var Se = xe.call(ye), Ce, Re = [], at;
          try {
            for (; (Ge === void 0 || Ge-- > 0) && !(Ce = Se.next()).done; )
              Re.push(Ce.value);
          } catch (ft) {
            at = { error: ft };
          } finally {
            try {
              Ce && !Ce.done && (xe = Se.return) && xe.call(Se);
            } finally {
              if (at)
                throw at.error;
            }
          }
          return Re;
        };
        function Xe(ye) {
          ye === void 0 && (ye = false);
          var Ge = je(Le(ye), 2), xe = Ge[0], Se = Ge[1], Ce = Se.toggle, Re = Se.set, at = T.useMemo(function() {
            var ft = function() {
              return Re(true);
            }, st = function() {
              return Re(false);
            };
            return { toggle: Ce, set: function(Dt) {
              return Re(!!Dt);
            }, setTrue: ft, setFalse: st };
          }, []);
          return [xe, at];
        }
        function Ye(ye) {
          var Ge = T.useRef(ye);
          return Ge.current = ye, Ge;
        }
        var rt2 = function(ye) {
          var Ge = Ye(ye);
          T.useEffect(function() {
            return function() {
              Ge.current();
            };
          }, []);
        }, ut = rt2;
        function wt(ye) {
          var Ge = typeof ye;
          return ye != null && (Ge == "object" || Ge == "function");
        }
        var dt = wt, Gt = typeof Z == "object" && Z && Z.Object === Object && Z, Qt = Gt, Nt = Qt, er = typeof self == "object" && self && self.Object === Object && self, un = Nt || er || Function("return this")(), pn = un, On = pn, fr = function() {
          return On.Date.now();
        }, yr = fr, da = /\s/;
        function Ja(ye) {
          for (var Ge = ye.length; Ge-- && da.test(ye.charAt(Ge)); )
            ;
          return Ge;
        }
        var ko = Ja, wo = ko, So = /^\s+/;
        function Fa(ye) {
          return ye && ye.slice(0, wo(ye) + 1).replace(So, "");
        }
        var po = Fa, To = pn, Ya = To.Symbol, $o = Ya, Hu = $o, ms = Object.prototype, sc = ms.hasOwnProperty, Oc = ms.toString, _c2 = Hu ? Hu.toStringTag : void 0;
        function _v(ye) {
          var Ge = sc.call(ye, _c2), xe = ye[_c2];
          try {
            ye[_c2] = void 0;
            var Se = true;
          } catch {
          }
          var Ce = Oc.call(ye);
          return Se && (Ge ? ye[_c2] = xe : delete ye[_c2]), Ce;
        }
        var cp = _v, Vg = Object.prototype, rh = Vg.toString;
        function Mp(ye) {
          return rh.call(ye);
        }
        var fp = Mp, vx = $o, ea = cp, Qr = fp, Yr = "[object Null]", na = "[object Undefined]", lo = vx ? vx.toStringTag : void 0;
        function hs(ye) {
          return ye == null ? ye === void 0 ? na : Yr : lo && lo in Object(ye) ? ea(ye) : Qr(ye);
        }
        var du = hs;
        function au(ye) {
          return ye != null && typeof ye == "object";
        }
        var pf = au, hp = du, Ah = pf, Td = "[object Symbol]";
        function Ih(ye) {
          return typeof ye == "symbol" || Ah(ye) && hp(ye) == Td;
        }
        var k0 = Ih, jy = po, J1 = dt, Gy = k0, $p = 0 / 0, xc = /^[-+]0x[0-9a-f]+$/i, xv = /^0b[01]+$/i, Bg = /^0o[0-7]+$/i, $b = parseInt;
        function Xm(ye) {
          if (typeof ye == "number")
            return ye;
          if (Gy(ye))
            return $p;
          if (J1(ye)) {
            var Ge = typeof ye.valueOf == "function" ? ye.valueOf() : ye;
            ye = J1(Ge) ? Ge + "" : Ge;
          }
          if (typeof ye != "string")
            return ye === 0 ? ye : +ye;
          ye = jy(ye);
          var xe = xv.test(ye);
          return xe || Bg.test(ye) ? $b(ye.slice(2), xe ? 2 : 8) : xc.test(ye) ? $p : +ye;
        }
        var Hy = Xm, Q1 = dt, IS = yr, ES = Hy, LX = "Expected a function", HT = Math.max, RX = Math.min;
        function NX(ye, Ge, xe) {
          var Se, Ce, Re, at, ft, st, Dt = 0, Pt = false, tn = false, Fn = true;
          if (typeof ye != "function")
            throw new TypeError(LX);
          Ge = ES(Ge) || 0, Q1(xe) && (Pt = !!xe.leading, tn = "maxWait" in xe, Re = tn ? HT(ES(xe.maxWait) || 0, Ge) : Re, Fn = "trailing" in xe ? !!xe.trailing : Fn);
          function Un(Vr) {
            var Si = Se, mi = Ce;
            return Se = Ce = void 0, Dt = Vr, at = ye.apply(mi, Si), at;
          }
          function qn(Vr) {
            return Dt = Vr, ft = setTimeout(Ii, Ge), Pt ? Un(Vr) : at;
          }
          function nr(Vr) {
            var Si = Vr - st, mi = Vr - Dt, Dr = Ge - Si;
            return tn ? RX(Dr, Re - mi) : Dr;
          }
          function sr(Vr) {
            var Si = Vr - st, mi = Vr - Dt;
            return st === void 0 || Si >= Ge || Si < 0 || tn && mi >= Re;
          }
          function Ii() {
            var Vr = IS();
            if (sr(Vr))
              return gi(Vr);
            ft = setTimeout(Ii, nr(Vr));
          }
          function gi(Vr) {
            return ft = void 0, Fn && Se ? Un(Vr) : (Se = Ce = void 0, at);
          }
          function Sa() {
            ft !== void 0 && clearTimeout(ft), Dt = 0, Se = st = Ce = ft = void 0;
          }
          function Tt() {
            return ft === void 0 ? at : gi(IS());
          }
          function Ar() {
            var Vr = IS(), Si = sr(Vr);
            if (Se = arguments, Ce = this, st = Vr, Si) {
              if (ft === void 0)
                return qn(st);
              if (tn)
                return clearTimeout(ft), ft = setTimeout(Ii, Ge), Un(st);
            }
            return ft === void 0 && (ft = setTimeout(Ii, Ge)), at;
          }
          return Ar.cancel = Sa, Ar.flush = Tt, Ar;
        }
        var FX = NX, VX = globalThis && globalThis.__read || function(ye, Ge) {
          var xe = typeof Symbol == "function" && ye[Symbol.iterator];
          if (!xe)
            return ye;
          var Se = xe.call(ye), Ce, Re = [], at;
          try {
            for (; (Ge === void 0 || Ge-- > 0) && !(Ce = Se.next()).done; )
              Re.push(Ce.value);
          } catch (ft) {
            at = { error: ft };
          } finally {
            try {
              Ce && !Ce.done && (xe = Se.return) && xe.call(Se);
            } finally {
              if (at)
                throw at.error;
            }
          }
          return Re;
        }, m32 = globalThis && globalThis.__spread || function() {
          for (var ye = [], Ge = 0; Ge < arguments.length; Ge++)
            ye = ye.concat(VX(arguments[Ge]));
          return ye;
        };
        function En(ye, Ge) {
          var xe, Se = Ye(ye), Ce = (xe = Ge == null ? void 0 : Ge.wait) !== null && xe !== void 0 ? xe : 1e3, Re = T.useMemo(function() {
            return FX(function() {
              for (var at = [], ft = 0; ft < arguments.length; ft++)
                at[ft] = arguments[ft];
              return Se.current.apply(Se, m32(at));
            }, Ce, Ge);
          }, []);
          return ut(function() {
            Re.cancel();
          }), { run: Re, cancel: Re.cancel, flush: Re.flush };
        }
        const Pn = ({ id: ye, title: Ge, chart: xe, option: Se }, Ce) => {
          const Re = T.useRef(), at = pe({ global: true });
          Re.current = T.useMemo(() => {
            if (!Re.current)
              return H;
          }, []);
          const { run: ft } = En(() => {
            ye && at.emit("list");
          }, { wait: 100 });
          return T.useEffect(() => {
            console.log(xe == null ? void 0 : xe.current), Re.current && (xe == null ? void 0 : xe.current) && ye && Se && (Re.current.add(ye, xe == null ? void 0 : xe.current, Se, Ge), ft());
          }, Ce), { tool: Re.current };
        };
        var Kt = T.createContext({}), yn = Kt;
        function fn(ye, Ge, xe) {
          return Ge in ye ? Object.defineProperty(ye, Ge, { value: xe, enumerable: true, configurable: true, writable: true }) : ye[Ge] = xe, ye;
        }
        function Br(ye, Ge) {
          var xe = Object.keys(ye);
          if (Object.getOwnPropertySymbols) {
            var Se = Object.getOwnPropertySymbols(ye);
            Ge && (Se = Se.filter(function(Ce) {
              return Object.getOwnPropertyDescriptor(ye, Ce).enumerable;
            })), xe.push.apply(xe, Se);
          }
          return xe;
        }
        function Nr(ye) {
          for (var Ge = 1; Ge < arguments.length; Ge++) {
            var xe = arguments[Ge] != null ? arguments[Ge] : {};
            Ge % 2 ? Br(Object(xe), true).forEach(function(Se) {
              fn(ye, Se, xe[Se]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(ye, Object.getOwnPropertyDescriptors(xe)) : Br(Object(xe)).forEach(function(Se) {
              Object.defineProperty(ye, Se, Object.getOwnPropertyDescriptor(xe, Se));
            });
          }
          return ye;
        }
        function yi(ye) {
          if (Array.isArray(ye))
            return ye;
        }
        function Er(ye, Ge) {
          var xe = ye == null ? null : typeof Symbol != "undefined" && ye[Symbol.iterator] || ye["@@iterator"];
          if (xe != null) {
            var Se = [], Ce = true, Re = false, at, ft;
            try {
              for (xe = xe.call(ye); !(Ce = (at = xe.next()).done) && (Se.push(at.value), !(Ge && Se.length === Ge)); Ce = true)
                ;
            } catch (st) {
              Re = true, ft = st;
            } finally {
              try {
                !Ce && xe.return != null && xe.return();
              } finally {
                if (Re)
                  throw ft;
              }
            }
            return Se;
          }
        }
        function _a2(ye, Ge) {
          (Ge == null || Ge > ye.length) && (Ge = ye.length);
          for (var xe = 0, Se = new Array(Ge); xe < Ge; xe++)
            Se[xe] = ye[xe];
          return Se;
        }
        function rs(ye, Ge) {
          if (ye) {
            if (typeof ye == "string")
              return _a2(ye, Ge);
            var xe = Object.prototype.toString.call(ye).slice(8, -1);
            if (xe === "Object" && ye.constructor && (xe = ye.constructor.name), xe === "Map" || xe === "Set")
              return Array.from(ye);
            if (xe === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(xe))
              return _a2(ye, Ge);
          }
        }
        function wu() {
          throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
        }
        function _l(ye, Ge) {
          return yi(ye) || Er(ye, Ge) || rs(ye, Ge) || wu();
        }
        function Rf(ye, Ge) {
          if (ye == null)
            return {};
          var xe = {}, Se = Object.keys(ye), Ce, Re;
          for (Re = 0; Re < Se.length; Re++)
            Ce = Se[Re], !(Ge.indexOf(Ce) >= 0) && (xe[Ce] = ye[Ce]);
          return xe;
        }
        function Ol(ye, Ge) {
          if (ye == null)
            return {};
          var xe = Rf(ye, Ge), Se, Ce;
          if (Object.getOwnPropertySymbols) {
            var Re = Object.getOwnPropertySymbols(ye);
            for (Ce = 0; Ce < Re.length; Ce++)
              Se = Re[Ce], !(Ge.indexOf(Se) >= 0) && (!Object.prototype.propertyIsEnumerable.call(ye, Se) || (xe[Se] = ye[Se]));
          }
          return xe;
        }
        var Sf = { exports: {} };
        /*!
          Copyright (c) 2018 Jed Watson.
          Licensed under the MIT License (MIT), see
          http://jedwatson.github.io/classnames
        */
        (function(ye) {
          (function() {
            var Ge = {}.hasOwnProperty;
            function xe() {
              for (var Se = [], Ce = 0; Ce < arguments.length; Ce++) {
                var Re = arguments[Ce];
                if (Re) {
                  var at = typeof Re;
                  if (at === "string" || at === "number")
                    Se.push(Re);
                  else if (Array.isArray(Re)) {
                    if (Re.length) {
                      var ft = xe.apply(null, Re);
                      ft && Se.push(ft);
                    }
                  } else if (at === "object")
                    if (Re.toString === Object.prototype.toString)
                      for (var st in Re)
                        Ge.call(Re, st) && Re[st] && Se.push(st);
                    else
                      Se.push(Re.toString());
                }
              }
              return Se.join(" ");
            }
            ye.exports ? (xe.default = xe, ye.exports = xe) : window.classNames = xe;
          })();
        })(Sf);
        var qf = Sf.exports;
        function _s(ye) {
          return _s = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Ge) {
            return typeof Ge;
          } : function(Ge) {
            return Ge && typeof Symbol == "function" && Ge.constructor === Symbol && Ge !== Symbol.prototype ? "symbol" : typeof Ge;
          }, _s(ye);
        }
        function df(ye, Ge) {
          Wy(ye) && (ye = "100%");
          var xe = gx(ye);
          return ye = Ge === 360 ? ye : Math.min(Ge, Math.max(0, parseFloat(ye))), xe && (ye = parseInt(String(ye * Ge), 10) / 100), Math.abs(ye - Ge) < 1e-6 ? 1 : (Ge === 360 ? ye = (ye < 0 ? ye % Ge + Ge : ye % Ge) / parseFloat(String(Ge)) : ye = ye % Ge / parseFloat(String(Ge)), ye);
        }
        function Wy(ye) {
          return typeof ye == "string" && ye.indexOf(".") !== -1 && parseFloat(ye) === 1;
        }
        function gx(ye) {
          return typeof ye == "string" && ye.indexOf("%") !== -1;
        }
        function b32(ye) {
          return ye = parseFloat(ye), (isNaN(ye) || ye < 0 || ye > 1) && (ye = 1), ye;
        }
        function Ym(ye) {
          return ye <= 1 ? Number(ye) * 100 + "%" : ye;
        }
        function MC(ye) {
          return ye.length === 1 ? "0" + ye : String(ye);
        }
        function TC(ye, Ge, xe) {
          return { r: df(ye, 255) * 255, g: df(Ge, 255) * 255, b: df(xe, 255) * 255 };
        }
        function Ad(ye, Ge, xe) {
          return xe < 0 && (xe += 1), xe > 1 && (xe -= 1), xe < 1 / 6 ? ye + (Ge - ye) * (6 * xe) : xe < 1 / 2 ? Ge : xe < 2 / 3 ? ye + (Ge - ye) * (2 / 3 - xe) * 6 : ye;
        }
        function DS(ye, Ge, xe) {
          var Se, Ce, Re;
          if (ye = df(ye, 360), Ge = df(Ge, 100), xe = df(xe, 100), Ge === 0)
            Ce = xe, Re = xe, Se = xe;
          else {
            var at = xe < 0.5 ? xe * (1 + Ge) : xe + Ge - xe * Ge, ft = 2 * xe - at;
            Se = Ad(ft, at, ye + 1 / 3), Ce = Ad(ft, at, ye), Re = Ad(ft, at, ye - 1 / 3);
          }
          return { r: Se * 255, g: Ce * 255, b: Re * 255 };
        }
        function HE(ye, Ge, xe) {
          ye = df(ye, 255), Ge = df(Ge, 255), xe = df(xe, 255);
          var Se = Math.max(ye, Ge, xe), Ce = Math.min(ye, Ge, xe), Re = 0, at = Se, ft = Se - Ce, st = Se === 0 ? 0 : ft / Se;
          if (Se === Ce)
            Re = 0;
          else {
            switch (Se) {
              case ye:
                Re = (Ge - xe) / ft + (Ge < xe ? 6 : 0);
                break;
              case Ge:
                Re = (xe - ye) / ft + 2;
                break;
              case xe:
                Re = (ye - Ge) / ft + 4;
                break;
            }
            Re /= 6;
          }
          return { h: Re, s: st, v: at };
        }
        function AC(ye, Ge, xe) {
          ye = df(ye, 360) * 6, Ge = df(Ge, 100), xe = df(xe, 100);
          var Se = Math.floor(ye), Ce = ye - Se, Re = xe * (1 - Ge), at = xe * (1 - Ce * Ge), ft = xe * (1 - (1 - Ce) * Ge), st = Se % 6, Dt = [xe, at, Re, Re, ft, xe][st], Pt = [ft, xe, xe, at, Re, Re][st], tn = [Re, Re, ft, xe, xe, at][st];
          return { r: Dt * 255, g: Pt * 255, b: tn * 255 };
        }
        function WE(ye, Ge, xe, Se) {
          var Ce = [MC(Math.round(ye).toString(16)), MC(Math.round(Ge).toString(16)), MC(Math.round(xe).toString(16))];
          return Se && Ce[0].startsWith(Ce[0].charAt(1)) && Ce[1].startsWith(Ce[1].charAt(1)) && Ce[2].startsWith(Ce[2].charAt(1)) ? Ce[0].charAt(0) + Ce[1].charAt(0) + Ce[2].charAt(0) : Ce.join("");
        }
        function WT(ye) {
          return zg(ye) / 255;
        }
        function zg(ye) {
          return parseInt(ye, 16);
        }
        var UE = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
        function kS(ye) {
          var Ge = { r: 0, g: 0, b: 0 }, xe = 1, Se = null, Ce = null, Re = null, at = false, ft = false;
          return typeof ye == "string" && (ye = qse(ye)), typeof ye == "object" && (OS(ye.r) && OS(ye.g) && OS(ye.b) ? (Ge = TC(ye.r, ye.g, ye.b), at = true, ft = String(ye.r).substr(-1) === "%" ? "prgb" : "rgb") : OS(ye.h) && OS(ye.s) && OS(ye.v) ? (Se = Ym(ye.s), Ce = Ym(ye.v), Ge = AC(ye.h, Se, Ce), at = true, ft = "hsv") : OS(ye.h) && OS(ye.s) && OS(ye.l) && (Se = Ym(ye.s), Re = Ym(ye.l), Ge = DS(ye.h, Se, Re), at = true, ft = "hsl"), Object.prototype.hasOwnProperty.call(ye, "a") && (xe = ye.a)), xe = b32(xe), { ok: at, format: ye.format || ft, r: Math.min(255, Math.max(Ge.r, 0)), g: Math.min(255, Math.max(Ge.g, 0)), b: Math.min(255, Math.max(Ge.b, 0)), a: xe };
        }
        var qE = "[-\\+]?\\d+%?", UT = "[-\\+]?\\d*\\.\\d+%?", Xb = "(?:" + UT + ")|(?:" + qE + ")", p4 = "[\\s|\\(]+(" + Xb + ")[,|\\s]+(" + Xb + ")[,|\\s]+(" + Xb + ")\\s*\\)?", d42 = "[\\s|\\(]+(" + Xb + ")[,|\\s]+(" + Xb + ")[,|\\s]+(" + Xb + ")[,|\\s]+(" + Xb + ")\\s*\\)?", O0 = { CSS_UNIT: new RegExp(Xb), rgb: new RegExp("rgb" + p4), rgba: new RegExp("rgba" + d42), hsl: new RegExp("hsl" + p4), hsla: new RegExp("hsla" + d42), hsv: new RegExp("hsv" + p4), hsva: new RegExp("hsva" + d42), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
        function qse(ye) {
          if (ye = ye.trim().toLowerCase(), ye.length === 0)
            return false;
          var Ge = false;
          if (UE[ye])
            ye = UE[ye], Ge = true;
          else if (ye === "transparent")
            return { r: 0, g: 0, b: 0, a: 0, format: "name" };
          var xe = O0.rgb.exec(ye);
          return xe ? { r: xe[1], g: xe[2], b: xe[3] } : (xe = O0.rgba.exec(ye), xe ? { r: xe[1], g: xe[2], b: xe[3], a: xe[4] } : (xe = O0.hsl.exec(ye), xe ? { h: xe[1], s: xe[2], l: xe[3] } : (xe = O0.hsla.exec(ye), xe ? { h: xe[1], s: xe[2], l: xe[3], a: xe[4] } : (xe = O0.hsv.exec(ye), xe ? { h: xe[1], s: xe[2], v: xe[3] } : (xe = O0.hsva.exec(ye), xe ? { h: xe[1], s: xe[2], v: xe[3], a: xe[4] } : (xe = O0.hex8.exec(ye), xe ? { r: zg(xe[1]), g: zg(xe[2]), b: zg(xe[3]), a: WT(xe[4]), format: Ge ? "name" : "hex8" } : (xe = O0.hex6.exec(ye), xe ? { r: zg(xe[1]), g: zg(xe[2]), b: zg(xe[3]), format: Ge ? "name" : "hex" } : (xe = O0.hex4.exec(ye), xe ? { r: zg(xe[1] + xe[1]), g: zg(xe[2] + xe[2]), b: zg(xe[3] + xe[3]), a: WT(xe[4] + xe[4]), format: Ge ? "name" : "hex8" } : (xe = O0.hex3.exec(ye), xe ? { r: zg(xe[1] + xe[1]), g: zg(xe[2] + xe[2]), b: zg(xe[3] + xe[3]), format: Ge ? "name" : "hex" } : false)))))))));
        }
        function OS(ye) {
          return Boolean(O0.CSS_UNIT.exec(String(ye)));
        }
        var mV = 2, BX = 0.16, $se = 0.05, Xse = 0.05, Yse = 0.15, Kse = 5, Zse = 4, OMe = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
        function zX(ye) {
          var Ge = ye.r, xe = ye.g, Se = ye.b, Ce = HE(Ge, xe, Se);
          return { h: Ce.h * 360, s: Ce.s, v: Ce.v };
        }
        function bV(ye) {
          var Ge = ye.r, xe = ye.g, Se = ye.b;
          return "#".concat(WE(Ge, xe, Se, false));
        }
        function PMe(ye, Ge, xe) {
          var Se = xe / 100, Ce = { r: (Ge.r - ye.r) * Se + ye.r, g: (Ge.g - ye.g) * Se + ye.g, b: (Ge.b - ye.b) * Se + ye.b };
          return Ce;
        }
        function Jse(ye, Ge, xe) {
          var Se;
          return Math.round(ye.h) >= 60 && Math.round(ye.h) <= 240 ? Se = xe ? Math.round(ye.h) - mV * Ge : Math.round(ye.h) + mV * Ge : Se = xe ? Math.round(ye.h) + mV * Ge : Math.round(ye.h) - mV * Ge, Se < 0 ? Se += 360 : Se >= 360 && (Se -= 360), Se;
        }
        function Qse(ye, Ge, xe) {
          if (ye.h === 0 && ye.s === 0)
            return ye.s;
          var Se;
          return xe ? Se = ye.s - BX * Ge : Ge === Zse ? Se = ye.s + BX : Se = ye.s + $se * Ge, Se > 1 && (Se = 1), xe && Ge === Kse && Se > 0.1 && (Se = 0.1), Se < 0.06 && (Se = 0.06), Number(Se.toFixed(2));
        }
        function _V(ye, Ge, xe) {
          var Se;
          return xe ? Se = ye.v + Xse * Ge : Se = ye.v - Yse * Ge, Se > 1 && (Se = 1), Number(Se.toFixed(2));
        }
        function jX(ye) {
          for (var Ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, xe = [], Se = kS(ye), Ce = Kse; Ce > 0; Ce -= 1) {
            var Re = zX(Se), at = bV(kS({ h: Jse(Re, Ce, true), s: Qse(Re, Ce, true), v: _V(Re, Ce, true) }));
            xe.push(at);
          }
          xe.push(bV(Se));
          for (var ft = 1; ft <= Zse; ft += 1) {
            var st = zX(Se), Dt = bV(kS({ h: Jse(st, ft), s: Qse(st, ft), v: _V(st, ft) }));
            xe.push(Dt);
          }
          return Ge.theme === "dark" ? OMe.map(function(Pt) {
            var tn = Pt.index, Fn = Pt.opacity, Un = bV(PMe(kS(Ge.backgroundColor || "#141414"), kS(xe[tn]), Fn * 100));
            return Un;
          }) : xe;
        }
        var GX = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, P0 = {}, HX = {};
        Object.keys(GX).forEach(function(ye) {
          P0[ye] = jX(GX[ye]), P0[ye].primary = P0[ye][5], HX[ye] = jX(GX[ye], { theme: "dark", backgroundColor: "#141414" }), HX[ye].primary = HX[ye][5];
        }), P0.red, P0.volcano, P0.gold, P0.orange, P0.yellow, P0.lime, P0.green, P0.cyan, P0.blue, P0.geekblue, P0.purple, P0.magenta, P0.grey;
        var ele = {};
        function pp(ye, Ge) {
        }
        function Xh(ye, Ge, xe) {
          !Ge && !ele[xe] && (ye(false, xe), ele[xe] = true);
        }
        function PS(ye, Ge) {
          Xh(pp, ye, Ge);
        }
        function tle() {
          return !!(typeof window != "undefined" && window.document && window.document.createElement);
        }
        var LMe = "rc-util-key";
        function nle() {
          var ye = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Ge = ye.mark;
          return Ge ? Ge.startsWith("data-") ? Ge : "data-".concat(Ge) : LMe;
        }
        function WX(ye) {
          if (ye.attachTo)
            return ye.attachTo;
          var Ge = document.querySelector("head");
          return Ge || document.body;
        }
        function rle(ye) {
          var Ge, xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
          if (!tle())
            return null;
          var Se = document.createElement("style");
          if (!((Ge = xe.csp) === null || Ge === void 0) && Ge.nonce) {
            var Ce;
            Se.nonce = (Ce = xe.csp) === null || Ce === void 0 ? void 0 : Ce.nonce;
          }
          Se.innerHTML = ye;
          var Re = WX(xe), at = Re.firstChild;
          return xe.prepend && Re.prepend ? Re.prepend(Se) : xe.prepend && at ? Re.insertBefore(Se, at) : Re.appendChild(Se), Se;
        }
        var xV = /* @__PURE__ */ new Map();
        function RMe(ye) {
          var Ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, xe = WX(Ge);
          return Array.from(xV.get(xe).children).find(function(Se) {
            return Se.tagName === "STYLE" && Se.getAttribute(nle(Ge)) === ye;
          });
        }
        function ng(ye, Ge) {
          var xe = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Se = WX(xe);
          if (!xV.has(Se)) {
            var Ce = rle("", xe), Re = Ce.parentNode;
            xV.set(Se, Re), Re.removeChild(Ce);
          }
          var at = RMe(Ge, xe);
          if (at) {
            var ft, st;
            if (((ft = xe.csp) === null || ft === void 0 ? void 0 : ft.nonce) && at.nonce !== ((st = xe.csp) === null || st === void 0 ? void 0 : st.nonce)) {
              var Dt;
              at.nonce = (Dt = xe.csp) === null || Dt === void 0 ? void 0 : Dt.nonce;
            }
            return at.innerHTML !== ye && (at.innerHTML = ye), at;
          }
          var Pt = rle(ye, xe);
          return Pt.setAttribute(nle(xe), Ge), Pt;
        }
        function UX(ye, Ge) {
          PS(ye, "[@ant-design/icons] ".concat(Ge));
        }
        function qT(ye) {
          return _s(ye) === "object" && typeof ye.name == "string" && typeof ye.theme == "string" && (_s(ye.icon) === "object" || typeof ye.icon == "function");
        }
        function qX() {
          var ye = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          return Object.keys(ye).reduce(function(Ge, xe) {
            var Se = ye[xe];
            switch (xe) {
              case "class":
                Ge.className = Se, delete Ge.class;
                break;
              default:
                Ge[xe] = Se;
            }
            return Ge;
          }, {});
        }
        function v42(ye, Ge, xe) {
          return xe ? R.default.createElement(ye.tag, Nr(Nr({ key: Ge }, qX(ye.attrs)), xe), (ye.children || []).map(function(Se, Ce) {
            return v42(Se, "".concat(Ge, "-").concat(ye.tag, "-").concat(Ce));
          })) : R.default.createElement(ye.tag, Nr({ key: Ge }, qX(ye.attrs)), (ye.children || []).map(function(Se, Ce) {
            return v42(Se, "".concat(Ge, "-").concat(ye.tag, "-").concat(Ce));
          }));
        }
        function eb(ye) {
          return jX(ye)[0];
        }
        function $X(ye) {
          return ye ? Array.isArray(ye) ? ye : [ye] : [];
        }
        var ile = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, ale = function() {
          var ye = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ile, Ge = T.useContext(yn), xe = Ge.csp;
          T.useEffect(function() {
            ng(ye, "@ant-design-icons", { prepend: true, csp: xe });
          }, []);
        }, ole = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], _3 = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
        function sle(ye) {
          var Ge = ye.primaryColor, xe = ye.secondaryColor;
          _3.primaryColor = Ge, _3.secondaryColor = xe || eb(Ge), _3.calculated = !!xe;
        }
        function tb() {
          return Nr({}, _3);
        }
        var wV = function(ye) {
          var Ge = ye.icon, xe = ye.className, Se = ye.onClick, Ce = ye.style, Re = ye.primaryColor, at = ye.secondaryColor, ft = Ol(ye, ole), st = _3;
          if (Re && (st = { primaryColor: Re, secondaryColor: at || eb(Re) }), ale(), UX(qT(Ge), "icon should be icon definiton, but got ".concat(Ge)), !qT(Ge))
            return null;
          var Dt = Ge;
          return Dt && typeof Dt.icon == "function" && (Dt = Nr(Nr({}, Dt), {}, { icon: Dt.icon(st.primaryColor, st.secondaryColor) })), v42(Dt.icon, "svg-".concat(Dt.name), Nr({ className: xe, onClick: Se, style: Ce, "data-icon": Dt.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, ft));
        };
        wV.displayName = "IconReact", wV.getTwoToneColors = tb, wV.setTwoToneColors = sle;
        var Km = wV;
        function lle(ye) {
          var Ge = $X(ye), xe = _l(Ge, 2), Se = xe[0], Ce = xe[1];
          return Km.setTwoToneColors({ primaryColor: Se, secondaryColor: Ce });
        }
        function ule() {
          var ye = Km.getTwoToneColors();
          return ye.calculated ? [ye.primaryColor, ye.secondaryColor] : ye.primaryColor;
        }
        var $T = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
        lle("#1890ff");
        var $E = V.forwardRef(function(ye, Ge) {
          var xe, Se = ye.className, Ce = ye.icon, Re = ye.spin, at = ye.rotate, ft = ye.tabIndex, st = ye.onClick, Dt = ye.twoToneColor, Pt = Ol(ye, $T), tn = V.useContext(yn), Fn = tn.prefixCls, Un = Fn === void 0 ? "anticon" : Fn, qn = qf(Un, (xe = {}, fn(xe, "".concat(Un, "-").concat(Ce.name), !!Ce.name), fn(xe, "".concat(Un, "-spin"), !!Re || Ce.name === "loading"), xe), Se), nr = ft;
          nr === void 0 && st && (nr = -1);
          var sr = at ? { msTransform: "rotate(".concat(at, "deg)"), transform: "rotate(".concat(at, "deg)") } : void 0, Ii = $X(Dt), gi = _l(Ii, 2), Sa = gi[0], Tt = gi[1];
          return V.createElement("span", Nr(Nr({ role: "img", "aria-label": Ce.name }, Pt), {}, { ref: Ge, tabIndex: nr, onClick: st, className: qn }), V.createElement(Km, { icon: Ce, primaryColor: Sa, secondaryColor: Tt, style: sr }));
        });
        $E.displayName = "AntdIcon", $E.getTwoToneColor = ule, $E.setTwoToneColor = lle;
        var XX = $E, Tp = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, XT = Tp, SV = function(ye, Ge) {
          return V.createElement(XX, Nr(Nr({}, ye), {}, { ref: Ge, icon: XT }));
        };
        SV.displayName = "LoadingOutlined";
        var NMe = V.forwardRef(SV);
        function ld() {
          return ld = Object.assign || function(ye) {
            for (var Ge = 1; Ge < arguments.length; Ge++) {
              var xe = arguments[Ge];
              for (var Se in xe)
                Object.prototype.hasOwnProperty.call(xe, Se) && (ye[Se] = xe[Se]);
            }
            return ye;
          }, ld.apply(this, arguments);
        }
        function g4(ye, Ge) {
          if (!(ye instanceof Ge))
            throw new TypeError("Cannot call a class as a function");
        }
        function cle(ye, Ge) {
          for (var xe = 0; xe < Ge.length; xe++) {
            var Se = Ge[xe];
            Se.enumerable = Se.enumerable || false, Se.configurable = true, "value" in Se && (Se.writable = true), Object.defineProperty(ye, Se.key, Se);
          }
        }
        function y42(ye, Ge, xe) {
          return Ge && cle(ye.prototype, Ge), xe && cle(ye, xe), Object.defineProperty(ye, "prototype", { writable: false }), ye;
        }
        function CV(ye, Ge) {
          return CV = Object.setPrototypeOf || function(xe, Se) {
            return xe.__proto__ = Se, xe;
          }, CV(ye, Ge);
        }
        function x32(ye, Ge) {
          if (typeof Ge != "function" && Ge !== null)
            throw new TypeError("Super expression must either be null or a function");
          ye.prototype = Object.create(Ge && Ge.prototype, { constructor: { value: ye, writable: true, configurable: true } }), Object.defineProperty(ye, "prototype", { writable: false }), Ge && CV(ye, Ge);
        }
        function IC(ye) {
          return IC = Object.setPrototypeOf ? Object.getPrototypeOf : function(Ge) {
            return Ge.__proto__ || Object.getPrototypeOf(Ge);
          }, IC(ye);
        }
        function FMe() {
          if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), true;
          } catch {
            return false;
          }
        }
        function MV(ye) {
          if (ye === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return ye;
        }
        function fle(ye, Ge) {
          if (Ge && (_s(Ge) === "object" || typeof Ge == "function"))
            return Ge;
          if (Ge !== void 0)
            throw new TypeError("Derived constructors may only return object or undefined");
          return MV(ye);
        }
        function m4(ye) {
          var Ge = FMe();
          return function() {
            var xe = IC(ye), Se;
            if (Ge) {
              var Ce = IC(this).constructor;
              Se = Reflect.construct(xe, arguments, Ce);
            } else
              Se = xe.apply(this, arguments);
            return fle(this, Se);
          };
        }
        var b4 = { exports: {} }, Nf = {};
        /** @license React v16.13.1
        * react-is.production.min.js
        *
        * Copyright (c) Facebook, Inc. and its affiliates.
        *
        * This source code is licensed under the MIT license found in the
        * LICENSE file in the root directory of this source tree.
        */
        var rg = typeof Symbol == "function" && Symbol.for, _4 = rg ? Symbol.for("react.element") : 60103, x4 = rg ? Symbol.for("react.portal") : 60106, TV = rg ? Symbol.for("react.fragment") : 60107, w4 = rg ? Symbol.for("react.strict_mode") : 60108, L0 = rg ? Symbol.for("react.profiler") : 60114, w32 = rg ? Symbol.for("react.provider") : 60109, YT = rg ? Symbol.for("react.context") : 60110, AV = rg ? Symbol.for("react.async_mode") : 60111, S4 = rg ? Symbol.for("react.concurrent_mode") : 60111, IV = rg ? Symbol.for("react.forward_ref") : 60112, EV = rg ? Symbol.for("react.suspense") : 60113, VMe = rg ? Symbol.for("react.suspense_list") : 60120, DV = rg ? Symbol.for("react.memo") : 60115, kV = rg ? Symbol.for("react.lazy") : 60116, S3 = rg ? Symbol.for("react.block") : 60121, BMe = rg ? Symbol.for("react.fundamental") : 60117, zMe = rg ? Symbol.for("react.responder") : 60118, YX = rg ? Symbol.for("react.scope") : 60119;
        function Zm(ye) {
          if (typeof ye == "object" && ye !== null) {
            var Ge = ye.$$typeof;
            switch (Ge) {
              case _4:
                switch (ye = ye.type, ye) {
                  case AV:
                  case S4:
                  case TV:
                  case L0:
                  case w4:
                  case EV:
                    return ye;
                  default:
                    switch (ye = ye && ye.$$typeof, ye) {
                      case YT:
                      case IV:
                      case kV:
                      case DV:
                      case w32:
                        return ye;
                      default:
                        return Ge;
                    }
                }
              case x4:
                return Ge;
            }
          }
        }
        function EC(ye) {
          return Zm(ye) === S4;
        }
        Nf.AsyncMode = AV, Nf.ConcurrentMode = S4, Nf.ContextConsumer = YT, Nf.ContextProvider = w32, Nf.Element = _4, Nf.ForwardRef = IV, Nf.Fragment = TV, Nf.Lazy = kV, Nf.Memo = DV, Nf.Portal = x4, Nf.Profiler = L0, Nf.StrictMode = w4, Nf.Suspense = EV, Nf.isAsyncMode = function(ye) {
          return EC(ye) || Zm(ye) === AV;
        }, Nf.isConcurrentMode = EC, Nf.isContextConsumer = function(ye) {
          return Zm(ye) === YT;
        }, Nf.isContextProvider = function(ye) {
          return Zm(ye) === w32;
        }, Nf.isElement = function(ye) {
          return typeof ye == "object" && ye !== null && ye.$$typeof === _4;
        }, Nf.isForwardRef = function(ye) {
          return Zm(ye) === IV;
        }, Nf.isFragment = function(ye) {
          return Zm(ye) === TV;
        }, Nf.isLazy = function(ye) {
          return Zm(ye) === kV;
        }, Nf.isMemo = function(ye) {
          return Zm(ye) === DV;
        }, Nf.isPortal = function(ye) {
          return Zm(ye) === x4;
        }, Nf.isProfiler = function(ye) {
          return Zm(ye) === L0;
        }, Nf.isStrictMode = function(ye) {
          return Zm(ye) === w4;
        }, Nf.isSuspense = function(ye) {
          return Zm(ye) === EV;
        }, Nf.isValidElementType = function(ye) {
          return typeof ye == "string" || typeof ye == "function" || ye === TV || ye === S4 || ye === L0 || ye === w4 || ye === EV || ye === VMe || typeof ye == "object" && ye !== null && (ye.$$typeof === kV || ye.$$typeof === DV || ye.$$typeof === w32 || ye.$$typeof === YT || ye.$$typeof === IV || ye.$$typeof === BMe || ye.$$typeof === zMe || ye.$$typeof === YX || ye.$$typeof === S3);
        }, Nf.typeOf = Zm, b4.exports = Nf;
        function C3(ye) {
          var Ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, xe = [];
          return R.default.Children.forEach(ye, function(Se) {
            Se == null && !Ge.keepEmpty || (Array.isArray(Se) ? xe = xe.concat(C3(Se)) : b4.exports.isFragment(Se) && Se.props ? xe = xe.concat(C3(Se.props.children, Ge)) : xe.push(Se));
          }), xe;
        }
        function jMe(ye, Ge) {
          typeof ye == "function" ? ye(Ge) : _s(ye) === "object" && ye && "current" in ye && (ye.current = Ge);
        }
        function GMe() {
          for (var ye = arguments.length, Ge = new Array(ye), xe = 0; xe < ye; xe++)
            Ge[xe] = arguments[xe];
          var Se = Ge.filter(function(Ce) {
            return Ce;
          });
          return Se.length <= 1 ? Se[0] : function(Ce) {
            Ge.forEach(function(Re) {
              jMe(Re, Ce);
            });
          };
        }
        function HMe(ye) {
          var Ge, xe, Se = b4.exports.isMemo(ye) ? ye.type.type : ye.type;
          return !(typeof Se == "function" && !(!((Ge = Se.prototype) === null || Ge === void 0) && Ge.render) || typeof ye == "function" && !(!((xe = ye.prototype) === null || xe === void 0) && xe.render));
        }
        function M3() {
          try {
            if (!Object.assign)
              return false;
            var ye = new String("abc");
            if (ye[5] = "de", Object.getOwnPropertyNames(ye)[0] === "5")
              return false;
            for (var Ge = {}, xe = 0; xe < 10; xe++)
              Ge["_" + String.fromCharCode(xe)] = xe;
            var Se = Object.getOwnPropertyNames(Ge).map(function(Re) {
              return Ge[Re];
            });
            if (Se.join("") !== "0123456789")
              return false;
            var Ce = {};
            return "abcdefghijklmnopqrst".split("").forEach(function(Re) {
              Ce[Re] = Re;
            }), Object.keys(Object.assign({}, Ce)).join("") === "abcdefghijklmnopqrst";
          } catch {
            return false;
          }
        }
        M3();
        function yx(ye) {
          if (Array.isArray(ye))
            return _a2(ye);
        }
        function KX(ye) {
          if (typeof Symbol != "undefined" && ye[Symbol.iterator] != null || ye["@@iterator"] != null)
            return Array.from(ye);
        }
        function WMe() {
          throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
        }
        function Gc(ye) {
          return yx(ye) || KX(ye) || rs(ye) || WMe();
        }
        var T3 = "RC_FORM_INTERNAL_HOOKS", dp = function() {
          PS(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
        }, C4 = V.createContext({ getFieldValue: dp, getFieldsValue: dp, getFieldError: dp, getFieldWarning: dp, getFieldsError: dp, isFieldsTouched: dp, isFieldTouched: dp, isFieldValidating: dp, isFieldsValidating: dp, resetFields: dp, setFields: dp, setFieldsValue: dp, validateFields: dp, submit: dp, getInternalHooks: function() {
          return dp(), { dispatch: dp, initEntityValue: dp, registerField: dp, useSubscribe: dp, setInitialValues: dp, setCallbacks: dp, getFields: dp, setValidateMessages: dp, setPreserve: dp, getInitialValue: dp };
        } });
        function KT(ye) {
          return ye == null ? [] : Array.isArray(ye) ? ye : [ye];
        }
        var mr = { exports: {} };
        (function(ye) {
          var Ge = function(xe) {
            var Se = Object.prototype, Ce = Se.hasOwnProperty, Re, at = typeof Symbol == "function" ? Symbol : {}, ft = at.iterator || "@@iterator", st = at.asyncIterator || "@@asyncIterator", Dt = at.toStringTag || "@@toStringTag";
            function Pt(Ti, si, ni) {
              return Object.defineProperty(Ti, si, { value: ni, enumerable: true, configurable: true, writable: true }), Ti[si];
            }
            try {
              Pt({}, "");
            } catch {
              Pt = function(Ti, si, ni) {
                return Ti[si] = ni;
              };
            }
            function tn(Ti, si, ni, ja) {
              var Ta = si && si.prototype instanceof gi ? si : gi, Ws = Object.create(Ta.prototype), Uu = new Oo(ja || []);
              return Ws._invoke = Vi(Ti, ni, Uu), Ws;
            }
            xe.wrap = tn;
            function Fn(Ti, si, ni) {
              try {
                return { type: "normal", arg: Ti.call(si, ni) };
              } catch (ja) {
                return { type: "throw", arg: ja };
              }
            }
            var Un = "suspendedStart", qn = "suspendedYield", nr = "executing", sr = "completed", Ii = {};
            function gi() {
            }
            function Sa() {
            }
            function Tt() {
            }
            var Ar = {};
            Pt(Ar, ft, function() {
              return this;
            });
            var Vr = Object.getPrototypeOf, Si = Vr && Vr(Vr(pi([])));
            Si && Si !== Se && Ce.call(Si, ft) && (Ar = Si);
            var mi = Tt.prototype = gi.prototype = Object.create(Ar);
            Sa.prototype = Tt, Pt(mi, "constructor", Tt), Pt(Tt, "constructor", Sa), Sa.displayName = Pt(Tt, Dt, "GeneratorFunction");
            function Dr(Ti) {
              ["next", "throw", "return"].forEach(function(si) {
                Pt(Ti, si, function(ni) {
                  return this._invoke(si, ni);
                });
              });
            }
            xe.isGeneratorFunction = function(Ti) {
              var si = typeof Ti == "function" && Ti.constructor;
              return si ? si === Sa || (si.displayName || si.name) === "GeneratorFunction" : false;
            }, xe.mark = function(Ti) {
              return Object.setPrototypeOf ? Object.setPrototypeOf(Ti, Tt) : (Ti.__proto__ = Tt, Pt(Ti, Dt, "GeneratorFunction")), Ti.prototype = Object.create(mi), Ti;
            }, xe.awrap = function(Ti) {
              return { __await: Ti };
            };
            function Gr(Ti, si) {
              function ni(Ws, Uu, Su, hl) {
                var Tf = Fn(Ti[Ws], Ti, Uu);
                if (Tf.type === "throw")
                  hl(Tf.arg);
                else {
                  var Cu = Tf.arg, Lc = Cu.value;
                  return Lc && typeof Lc == "object" && Ce.call(Lc, "__await") ? si.resolve(Lc.__await).then(function(Eh) {
                    ni("next", Eh, Su, hl);
                  }, function(Eh) {
                    ni("throw", Eh, Su, hl);
                  }) : si.resolve(Lc).then(function(Eh) {
                    Cu.value = Eh, Su(Cu);
                  }, function(Eh) {
                    return ni("throw", Eh, Su, hl);
                  });
                }
              }
              var ja;
              function Ta(Ws, Uu) {
                function Su() {
                  return new si(function(hl, Tf) {
                    ni(Ws, Uu, hl, Tf);
                  });
                }
                return ja = ja ? ja.then(Su, Su) : Su();
              }
              this._invoke = Ta;
            }
            Dr(Gr.prototype), Pt(Gr.prototype, st, function() {
              return this;
            }), xe.AsyncIterator = Gr, xe.async = function(Ti, si, ni, ja, Ta) {
              Ta === void 0 && (Ta = Promise);
              var Ws = new Gr(tn(Ti, si, ni, ja), Ta);
              return xe.isGeneratorFunction(si) ? Ws : Ws.next().then(function(Uu) {
                return Uu.done ? Uu.value : Ws.next();
              });
            };
            function Vi(Ti, si, ni) {
              var ja = Un;
              return function(Ta, Ws) {
                if (ja === nr)
                  throw new Error("Generator is already running");
                if (ja === sr) {
                  if (Ta === "throw")
                    throw Ws;
                  return xs();
                }
                for (ni.method = Ta, ni.arg = Ws; ; ) {
                  var Uu = ni.delegate;
                  if (Uu) {
                    var Su = ya(Uu, ni);
                    if (Su) {
                      if (Su === Ii)
                        continue;
                      return Su;
                    }
                  }
                  if (ni.method === "next")
                    ni.sent = ni._sent = ni.arg;
                  else if (ni.method === "throw") {
                    if (ja === Un)
                      throw ja = sr, ni.arg;
                    ni.dispatchException(ni.arg);
                  } else
                    ni.method === "return" && ni.abrupt("return", ni.arg);
                  ja = nr;
                  var hl = Fn(Ti, si, ni);
                  if (hl.type === "normal") {
                    if (ja = ni.done ? sr : qn, hl.arg === Ii)
                      continue;
                    return { value: hl.arg, done: ni.done };
                  } else
                    hl.type === "throw" && (ja = sr, ni.method = "throw", ni.arg = hl.arg);
                }
              };
            }
            function ya(Ti, si) {
              var ni = Ti.iterator[si.method];
              if (ni === Re) {
                if (si.delegate = null, si.method === "throw") {
                  if (Ti.iterator.return && (si.method = "return", si.arg = Re, ya(Ti, si), si.method === "throw"))
                    return Ii;
                  si.method = "throw", si.arg = new TypeError("The iterator does not provide a 'throw' method");
                }
                return Ii;
              }
              var ja = Fn(ni, Ti.iterator, si.arg);
              if (ja.type === "throw")
                return si.method = "throw", si.arg = ja.arg, si.delegate = null, Ii;
              var Ta = ja.arg;
              if (!Ta)
                return si.method = "throw", si.arg = new TypeError("iterator result is not an object"), si.delegate = null, Ii;
              if (Ta.done)
                si[Ti.resultName] = Ta.value, si.next = Ti.nextLoc, si.method !== "return" && (si.method = "next", si.arg = Re);
              else
                return Ta;
              return si.delegate = null, Ii;
            }
            Dr(mi), Pt(mi, Dt, "Generator"), Pt(mi, ft, function() {
              return this;
            }), Pt(mi, "toString", function() {
              return "[object Generator]";
            });
            function xr(Ti) {
              var si = { tryLoc: Ti[0] };
              1 in Ti && (si.catchLoc = Ti[1]), 2 in Ti && (si.finallyLoc = Ti[2], si.afterLoc = Ti[3]), this.tryEntries.push(si);
            }
            function Ro(Ti) {
              var si = Ti.completion || {};
              si.type = "normal", delete si.arg, Ti.completion = si;
            }
            function Oo(Ti) {
              this.tryEntries = [{ tryLoc: "root" }], Ti.forEach(xr, this), this.reset(true);
            }
            xe.keys = function(Ti) {
              var si = [];
              for (var ni in Ti)
                si.push(ni);
              return si.reverse(), function ja() {
                for (; si.length; ) {
                  var Ta = si.pop();
                  if (Ta in Ti)
                    return ja.value = Ta, ja.done = false, ja;
                }
                return ja.done = true, ja;
              };
            };
            function pi(Ti) {
              if (Ti) {
                var si = Ti[ft];
                if (si)
                  return si.call(Ti);
                if (typeof Ti.next == "function")
                  return Ti;
                if (!isNaN(Ti.length)) {
                  var ni = -1, ja = function Ta() {
                    for (; ++ni < Ti.length; )
                      if (Ce.call(Ti, ni))
                        return Ta.value = Ti[ni], Ta.done = false, Ta;
                    return Ta.value = Re, Ta.done = true, Ta;
                  };
                  return ja.next = ja;
                }
              }
              return { next: xs };
            }
            xe.values = pi;
            function xs() {
              return { value: Re, done: true };
            }
            return Oo.prototype = { constructor: Oo, reset: function(Ti) {
              if (this.prev = 0, this.next = 0, this.sent = this._sent = Re, this.done = false, this.delegate = null, this.method = "next", this.arg = Re, this.tryEntries.forEach(Ro), !Ti)
                for (var si in this)
                  si.charAt(0) === "t" && Ce.call(this, si) && !isNaN(+si.slice(1)) && (this[si] = Re);
            }, stop: function() {
              this.done = true;
              var Ti = this.tryEntries[0], si = Ti.completion;
              if (si.type === "throw")
                throw si.arg;
              return this.rval;
            }, dispatchException: function(Ti) {
              if (this.done)
                throw Ti;
              var si = this;
              function ni(hl, Tf) {
                return Ws.type = "throw", Ws.arg = Ti, si.next = hl, Tf && (si.method = "next", si.arg = Re), !!Tf;
              }
              for (var ja = this.tryEntries.length - 1; ja >= 0; --ja) {
                var Ta = this.tryEntries[ja], Ws = Ta.completion;
                if (Ta.tryLoc === "root")
                  return ni("end");
                if (Ta.tryLoc <= this.prev) {
                  var Uu = Ce.call(Ta, "catchLoc"), Su = Ce.call(Ta, "finallyLoc");
                  if (Uu && Su) {
                    if (this.prev < Ta.catchLoc)
                      return ni(Ta.catchLoc, true);
                    if (this.prev < Ta.finallyLoc)
                      return ni(Ta.finallyLoc);
                  } else if (Uu) {
                    if (this.prev < Ta.catchLoc)
                      return ni(Ta.catchLoc, true);
                  } else if (Su) {
                    if (this.prev < Ta.finallyLoc)
                      return ni(Ta.finallyLoc);
                  } else
                    throw new Error("try statement without catch or finally");
                }
              }
            }, abrupt: function(Ti, si) {
              for (var ni = this.tryEntries.length - 1; ni >= 0; --ni) {
                var ja = this.tryEntries[ni];
                if (ja.tryLoc <= this.prev && Ce.call(ja, "finallyLoc") && this.prev < ja.finallyLoc) {
                  var Ta = ja;
                  break;
                }
              }
              Ta && (Ti === "break" || Ti === "continue") && Ta.tryLoc <= si && si <= Ta.finallyLoc && (Ta = null);
              var Ws = Ta ? Ta.completion : {};
              return Ws.type = Ti, Ws.arg = si, Ta ? (this.method = "next", this.next = Ta.finallyLoc, Ii) : this.complete(Ws);
            }, complete: function(Ti, si) {
              if (Ti.type === "throw")
                throw Ti.arg;
              return Ti.type === "break" || Ti.type === "continue" ? this.next = Ti.arg : Ti.type === "return" ? (this.rval = this.arg = Ti.arg, this.method = "return", this.next = "end") : Ti.type === "normal" && si && (this.next = si), Ii;
            }, finish: function(Ti) {
              for (var si = this.tryEntries.length - 1; si >= 0; --si) {
                var ni = this.tryEntries[si];
                if (ni.finallyLoc === Ti)
                  return this.complete(ni.completion, ni.afterLoc), Ro(ni), Ii;
              }
            }, catch: function(Ti) {
              for (var si = this.tryEntries.length - 1; si >= 0; --si) {
                var ni = this.tryEntries[si];
                if (ni.tryLoc === Ti) {
                  var ja = ni.completion;
                  if (ja.type === "throw") {
                    var Ta = ja.arg;
                    Ro(ni);
                  }
                  return Ta;
                }
              }
              throw new Error("illegal catch attempt");
            }, delegateYield: function(Ti, si, ni) {
              return this.delegate = { iterator: pi(Ti), resultName: si, nextLoc: ni }, this.method === "next" && (this.arg = Re), Ii;
            } }, xe;
          }(ye.exports);
          try {
            regeneratorRuntime = Ge;
          } catch {
            typeof globalThis == "object" ? globalThis.regeneratorRuntime = Ge : Function("r", "regeneratorRuntime = r")(Ge);
          }
        })(mr);
        var Li = mr.exports;
        function hi(ye, Ge, xe, Se, Ce, Re, at) {
          try {
            var ft = ye[Re](at), st = ft.value;
          } catch (Dt) {
            xe(Dt);
            return;
          }
          ft.done ? Ge(st) : Promise.resolve(st).then(Se, Ce);
        }
        function Wo(ye) {
          return function() {
            var Ge = this, xe = arguments;
            return new Promise(function(Se, Ce) {
              var Re = ye.apply(Ge, xe);
              function at(st) {
                hi(Re, Se, Ce, at, ft, "next", st);
              }
              function ft(st) {
                hi(Re, Se, Ce, at, ft, "throw", st);
              }
              at(void 0);
            });
          };
        }
        function cl() {
          return cl = Object.assign || function(ye) {
            for (var Ge = 1; Ge < arguments.length; Ge++) {
              var xe = arguments[Ge];
              for (var Se in xe)
                Object.prototype.hasOwnProperty.call(xe, Se) && (ye[Se] = xe[Se]);
            }
            return ye;
          }, cl.apply(this, arguments);
        }
        function Cf(ye, Ge) {
          ye.prototype = Object.create(Ge.prototype), ye.prototype.constructor = ye, Mf(ye, Ge);
        }
        function Id(ye) {
          return Id = Object.setPrototypeOf ? Object.getPrototypeOf : function(Ge) {
            return Ge.__proto__ || Object.getPrototypeOf(Ge);
          }, Id(ye);
        }
        function Mf(ye, Ge) {
          return Mf = Object.setPrototypeOf || function(xe, Se) {
            return xe.__proto__ = Se, xe;
          }, Mf(ye, Ge);
        }
        function ZX() {
          if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), true;
          } catch {
            return false;
          }
        }
        function OV(ye, Ge, xe) {
          return ZX() ? OV = Reflect.construct : OV = function(Se, Ce, Re) {
            var at = [null];
            at.push.apply(at, Ce);
            var ft = Function.bind.apply(Se, at), st = new ft();
            return Re && Mf(st, Re.prototype), st;
          }, OV.apply(null, arguments);
        }
        function Yb(ye) {
          return Function.toString.call(ye).indexOf("[native code]") !== -1;
        }
        function A3(ye) {
          var Ge = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
          return A3 = function(xe) {
            if (xe === null || !Yb(xe))
              return xe;
            if (typeof xe != "function")
              throw new TypeError("Super expression must either be null or a function");
            if (typeof Ge != "undefined") {
              if (Ge.has(xe))
                return Ge.get(xe);
              Ge.set(xe, Se);
            }
            function Se() {
              return OV(xe, arguments, Id(this).constructor);
            }
            return Se.prototype = Object.create(xe.prototype, { constructor: { value: Se, enumerable: false, writable: true, configurable: true } }), Mf(Se, xe);
          }, A3(ye);
        }
        var UMe = /%[sdj%]/g, I3 = function() {
        };
        typeof process != "undefined" && process.env;
        function E3(ye) {
          if (!ye || !ye.length)
            return null;
          var Ge = {};
          return ye.forEach(function(xe) {
            var Se = xe.field;
            Ge[Se] = Ge[Se] || [], Ge[Se].push(xe);
          }), Ge;
        }
        function R0(ye) {
          for (var Ge = arguments.length, xe = new Array(Ge > 1 ? Ge - 1 : 0), Se = 1; Se < Ge; Se++)
            xe[Se - 1] = arguments[Se];
          var Ce = 0, Re = xe.length;
          if (typeof ye == "function")
            return ye.apply(null, xe);
          if (typeof ye == "string") {
            var at = ye.replace(UMe, function(ft) {
              if (ft === "%%")
                return "%";
              if (Ce >= Re)
                return ft;
              switch (ft) {
                case "%s":
                  return String(xe[Ce++]);
                case "%d":
                  return Number(xe[Ce++]);
                case "%j":
                  try {
                    return JSON.stringify(xe[Ce++]);
                  } catch {
                    return "[Circular]";
                  }
                  break;
                default:
                  return ft;
              }
            });
            return at;
          }
          return ye;
        }
        function $f(ye) {
          return ye === "string" || ye === "url" || ye === "hex" || ye === "email" || ye === "date" || ye === "pattern";
        }
        function wv(ye, Ge) {
          return !!(ye == null || Ge === "array" && Array.isArray(ye) && !ye.length || $f(Ge) && typeof ye == "string" && !ye);
        }
        function hle(ye, Ge, xe) {
          var Se = [], Ce = 0, Re = ye.length;
          function at(ft) {
            Se.push.apply(Se, ft || []), Ce++, Ce === Re && xe(Se);
          }
          ye.forEach(function(ft) {
            Ge(ft, at);
          });
        }
        function M4(ye, Ge, xe) {
          var Se = 0, Ce = ye.length;
          function Re(at) {
            if (at && at.length) {
              xe(at);
              return;
            }
            var ft = Se;
            Se = Se + 1, ft < Ce ? Ge(ye[ft], Re) : xe([]);
          }
          Re([]);
        }
        function qMe(ye) {
          var Ge = [];
          return Object.keys(ye).forEach(function(xe) {
            Ge.push.apply(Ge, ye[xe] || []);
          }), Ge;
        }
        var ple = function(ye) {
          Cf(Ge, ye);
          function Ge(xe, Se) {
            var Ce;
            return Ce = ye.call(this, "Async Validation Error") || this, Ce.errors = xe, Ce.fields = Se, Ce;
          }
          return Ge;
        }(A3(Error));
        function $Me(ye, Ge, xe, Se, Ce) {
          if (Ge.first) {
            var Re = new Promise(function(Fn, Un) {
              var qn = function(sr) {
                return Se(sr), sr.length ? Un(new ple(sr, E3(sr))) : Fn(Ce);
              }, nr = qMe(ye);
              M4(nr, xe, qn);
            });
            return Re.catch(function(Fn) {
              return Fn;
            }), Re;
          }
          var at = Ge.firstFields === true ? Object.keys(ye) : Ge.firstFields || [], ft = Object.keys(ye), st = ft.length, Dt = 0, Pt = [], tn = new Promise(function(Fn, Un) {
            var qn = function(nr) {
              if (Pt.push.apply(Pt, nr), Dt++, Dt === st)
                return Se(Pt), Pt.length ? Un(new ple(Pt, E3(Pt))) : Fn(Ce);
            };
            ft.length || (Se(Pt), Fn(Ce)), ft.forEach(function(nr) {
              var sr = ye[nr];
              at.indexOf(nr) !== -1 ? M4(sr, xe, qn) : hle(sr, xe, qn);
            });
          });
          return tn.catch(function(Fn) {
            return Fn;
          }), tn;
        }
        function PV(ye) {
          return !!(ye && ye.message !== void 0);
        }
        function ZT(ye, Ge) {
          for (var xe = ye, Se = 0; Se < Ge.length; Se++) {
            if (xe == null)
              return xe;
            xe = xe[Ge[Se]];
          }
          return xe;
        }
        function T4(ye, Ge) {
          return function(xe) {
            var Se;
            return ye.fullFields ? Se = ZT(Ge, ye.fullFields) : Se = Ge[xe.field || ye.fullField], PV(xe) ? (xe.field = xe.field || ye.fullField, xe.fieldValue = Se, xe) : { message: typeof xe == "function" ? xe() : xe, fieldValue: Se, field: xe.field || ye.fullField };
          };
        }
        function JX(ye, Ge) {
          if (Ge) {
            for (var xe in Ge)
              if (Ge.hasOwnProperty(xe)) {
                var Se = Ge[xe];
                typeof Se == "object" && typeof ye[xe] == "object" ? ye[xe] = cl({}, ye[xe], Se) : ye[xe] = Se;
              }
          }
          return ye;
        }
        var A4 = function(ye, Ge, xe, Se, Ce, Re) {
          ye.required && (!xe.hasOwnProperty(ye.field) || wv(Ge, Re || ye.type)) && Se.push(R0(Ce.messages.required, ye.fullField));
        }, dle = function(ye, Ge, xe, Se, Ce) {
          (/^\s+$/.test(Ge) || Ge === "") && Se.push(R0(Ce.messages.whitespace, ye.fullField));
        }, LV = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, JT = { integer: function(ye) {
          return JT.number(ye) && parseInt(ye, 10) === ye;
        }, float: function(ye) {
          return JT.number(ye) && !JT.integer(ye);
        }, array: function(ye) {
          return Array.isArray(ye);
        }, regexp: function(ye) {
          if (ye instanceof RegExp)
            return true;
          try {
            return !!new RegExp(ye);
          } catch {
            return false;
          }
        }, date: function(ye) {
          return typeof ye.getTime == "function" && typeof ye.getMonth == "function" && typeof ye.getYear == "function" && !isNaN(ye.getTime());
        }, number: function(ye) {
          return isNaN(ye) ? false : typeof ye == "number";
        }, object: function(ye) {
          return typeof ye == "object" && !JT.array(ye);
        }, method: function(ye) {
          return typeof ye == "function";
        }, email: function(ye) {
          return typeof ye == "string" && ye.length <= 320 && !!ye.match(LV.email);
        }, url: function(ye) {
          return typeof ye == "string" && ye.length <= 2048 && !!ye.match(LV.url);
        }, hex: function(ye) {
          return typeof ye == "string" && !!ye.match(LV.hex);
        } }, vle = function(ye, Ge, xe, Se, Ce) {
          if (ye.required && Ge === void 0) {
            A4(ye, Ge, xe, Se, Ce);
            return;
          }
          var Re = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], at = ye.type;
          Re.indexOf(at) > -1 ? JT[at](Ge) || Se.push(R0(Ce.messages.types[at], ye.fullField, ye.type)) : at && typeof Ge !== ye.type && Se.push(R0(Ce.messages.types[at], ye.fullField, ye.type));
        }, I4 = function(ye, Ge, xe, Se, Ce) {
          var Re = typeof ye.len == "number", at = typeof ye.min == "number", ft = typeof ye.max == "number", st = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, Dt = Ge, Pt = null, tn = typeof Ge == "number", Fn = typeof Ge == "string", Un = Array.isArray(Ge);
          if (tn ? Pt = "number" : Fn ? Pt = "string" : Un && (Pt = "array"), !Pt)
            return false;
          Un && (Dt = Ge.length), Fn && (Dt = Ge.replace(st, "_").length), Re ? Dt !== ye.len && Se.push(R0(Ce.messages[Pt].len, ye.fullField, ye.len)) : at && !ft && Dt < ye.min ? Se.push(R0(Ce.messages[Pt].min, ye.fullField, ye.min)) : ft && !at && Dt > ye.max ? Se.push(R0(Ce.messages[Pt].max, ye.fullField, ye.max)) : at && ft && (Dt < ye.min || Dt > ye.max) && Se.push(R0(Ce.messages[Pt].range, ye.fullField, ye.min, ye.max));
        }, Kb = "enum", RV = function(ye, Ge, xe, Se, Ce) {
          ye[Kb] = Array.isArray(ye[Kb]) ? ye[Kb] : [], ye[Kb].indexOf(Ge) === -1 && Se.push(R0(Ce.messages[Kb], ye.fullField, ye[Kb].join(", ")));
        }, XMe = function(ye, Ge, xe, Se, Ce) {
          if (ye.pattern) {
            if (ye.pattern instanceof RegExp)
              ye.pattern.lastIndex = 0, ye.pattern.test(Ge) || Se.push(R0(Ce.messages.pattern.mismatch, ye.fullField, Ge, ye.pattern));
            else if (typeof ye.pattern == "string") {
              var Re = new RegExp(ye.pattern);
              Re.test(Ge) || Se.push(R0(Ce.messages.pattern.mismatch, ye.fullField, Ge, ye.pattern));
            }
          }
        }, Pc = { required: A4, whitespace: dle, type: vle, range: I4, enum: RV, pattern: XMe }, YMe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge, "string") && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce, "string"), wv(Ge, "string") || (Pc.type(ye, Ge, Se, Re, Ce), Pc.range(ye, Ge, Se, Re, Ce), Pc.pattern(ye, Ge, Se, Re, Ce), ye.whitespace === true && Pc.whitespace(ye, Ge, Se, Re, Ce));
          }
          xe(Re);
        }, NV = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && Pc.type(ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, FV = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (Ge === "" && (Ge = void 0), wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && (Pc.type(ye, Ge, Se, Re, Ce), Pc.range(ye, Ge, Se, Re, Ce));
          }
          xe(Re);
        }, QX = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && Pc.type(ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, KMe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), wv(Ge) || Pc.type(ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, gle = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && (Pc.type(ye, Ge, Se, Re, Ce), Pc.range(ye, Ge, Se, Re, Ce));
          }
          xe(Re);
        }, ZMe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && (Pc.type(ye, Ge, Se, Re, Ce), Pc.range(ye, Ge, Se, Re, Ce));
          }
          xe(Re);
        }, JMe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (Ge == null && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce, "array"), Ge != null && (Pc.type(ye, Ge, Se, Re, Ce), Pc.range(ye, Ge, Se, Re, Ce));
          }
          xe(Re);
        }, Sv = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && Pc.type(ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, N0 = "enum", QMe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), Ge !== void 0 && Pc[N0](ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, eTe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge, "string") && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce), wv(Ge, "string") || Pc.pattern(ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, yle = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge, "date") && !ye.required)
              return xe();
            if (Pc.required(ye, Ge, Se, Re, Ce), !wv(Ge, "date")) {
              var ft;
              Ge instanceof Date ? ft = Ge : ft = new Date(Ge), Pc.type(ye, ft, Se, Re, Ce), ft && Pc.range(ye, ft.getTime(), Se, Re, Ce);
            }
          }
          xe(Re);
        }, tTe = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = Array.isArray(Ge) ? "array" : typeof Ge;
          Pc.required(ye, Ge, Se, Re, Ce, at), xe(Re);
        }, E4 = function(ye, Ge, xe, Se, Ce) {
          var Re = ye.type, at = [], ft = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (ft) {
            if (wv(Ge, Re) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, at, Ce, Re), wv(Ge, Re) || Pc.type(ye, Ge, Se, at, Ce);
          }
          xe(at);
        }, D4 = function(ye, Ge, xe, Se, Ce) {
          var Re = [], at = ye.required || !ye.required && Se.hasOwnProperty(ye.field);
          if (at) {
            if (wv(Ge) && !ye.required)
              return xe();
            Pc.required(ye, Ge, Se, Re, Ce);
          }
          xe(Re);
        }, XE = { string: YMe, method: NV, number: FV, boolean: QX, regexp: KMe, integer: gle, float: ZMe, array: JMe, object: Sv, enum: QMe, pattern: eTe, date: yle, url: E4, hex: E4, email: E4, required: tTe, any: D4 };
        function QT() {
          return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
            var ye = JSON.parse(JSON.stringify(this));
            return ye.clone = this.clone, ye;
          } };
        }
        var YE = QT(), DC = function() {
          function ye(xe) {
            this.rules = null, this._messages = YE, this.define(xe);
          }
          var Ge = ye.prototype;
          return Ge.define = function(xe) {
            var Se = this;
            if (!xe)
              throw new Error("Cannot configure a schema with no rules");
            if (typeof xe != "object" || Array.isArray(xe))
              throw new Error("Rules must be an object");
            this.rules = {}, Object.keys(xe).forEach(function(Ce) {
              var Re = xe[Ce];
              Se.rules[Ce] = Array.isArray(Re) ? Re : [Re];
            });
          }, Ge.messages = function(xe) {
            return xe && (this._messages = JX(QT(), xe)), this._messages;
          }, Ge.validate = function(xe, Se, Ce) {
            var Re = this;
            Se === void 0 && (Se = {}), Ce === void 0 && (Ce = function() {
            });
            var at = xe, ft = Se, st = Ce;
            if (typeof ft == "function" && (st = ft, ft = {}), !this.rules || Object.keys(this.rules).length === 0)
              return st && st(null, at), Promise.resolve(at);
            function Dt(qn) {
              var nr = [], sr = {};
              function Ii(Sa) {
                if (Array.isArray(Sa)) {
                  var Tt;
                  nr = (Tt = nr).concat.apply(Tt, Sa);
                } else
                  nr.push(Sa);
              }
              for (var gi = 0; gi < qn.length; gi++)
                Ii(qn[gi]);
              nr.length ? (sr = E3(nr), st(nr, sr)) : st(null, at);
            }
            if (ft.messages) {
              var Pt = this.messages();
              Pt === YE && (Pt = QT()), JX(Pt, ft.messages), ft.messages = Pt;
            } else
              ft.messages = this.messages();
            var tn = {}, Fn = ft.keys || Object.keys(this.rules);
            Fn.forEach(function(qn) {
              var nr = Re.rules[qn], sr = at[qn];
              nr.forEach(function(Ii) {
                var gi = Ii;
                typeof gi.transform == "function" && (at === xe && (at = cl({}, at)), sr = at[qn] = gi.transform(sr)), typeof gi == "function" ? gi = { validator: gi } : gi = cl({}, gi), gi.validator = Re.getValidationMethod(gi), gi.validator && (gi.field = qn, gi.fullField = gi.fullField || qn, gi.type = Re.getType(gi), tn[qn] = tn[qn] || [], tn[qn].push({ rule: gi, value: sr, source: at, field: qn }));
              });
            });
            var Un = {};
            return $Me(tn, ft, function(qn, nr) {
              var sr = qn.rule, Ii = (sr.type === "object" || sr.type === "array") && (typeof sr.fields == "object" || typeof sr.defaultField == "object");
              Ii = Ii && (sr.required || !sr.required && qn.value), sr.field = qn.field;
              function gi(Ar, Vr) {
                return cl({}, Vr, { fullField: sr.fullField + "." + Ar, fullFields: sr.fullFields ? [].concat(sr.fullFields, [Ar]) : [Ar] });
              }
              function Sa(Ar) {
                Ar === void 0 && (Ar = []);
                var Vr = Array.isArray(Ar) ? Ar : [Ar];
                !ft.suppressWarning && Vr.length && ye.warning("async-validator:", Vr), Vr.length && sr.message !== void 0 && (Vr = [].concat(sr.message));
                var Si = Vr.map(T4(sr, at));
                if (ft.first && Si.length)
                  return Un[sr.field] = 1, nr(Si);
                if (!Ii)
                  nr(Si);
                else {
                  if (sr.required && !qn.value)
                    return sr.message !== void 0 ? Si = [].concat(sr.message).map(T4(sr, at)) : ft.error && (Si = [ft.error(sr, R0(ft.messages.required, sr.field))]), nr(Si);
                  var mi = {};
                  sr.defaultField && Object.keys(qn.value).map(function(Vi) {
                    mi[Vi] = sr.defaultField;
                  }), mi = cl({}, mi, qn.rule.fields);
                  var Dr = {};
                  Object.keys(mi).forEach(function(Vi) {
                    var ya = mi[Vi], xr = Array.isArray(ya) ? ya : [ya];
                    Dr[Vi] = xr.map(gi.bind(null, Vi));
                  });
                  var Gr = new ye(Dr);
                  Gr.messages(ft.messages), qn.rule.options && (qn.rule.options.messages = ft.messages, qn.rule.options.error = ft.error), Gr.validate(qn.value, qn.rule.options || ft, function(Vi) {
                    var ya = [];
                    Si && Si.length && ya.push.apply(ya, Si), Vi && Vi.length && ya.push.apply(ya, Vi), nr(ya.length ? ya : null);
                  });
                }
              }
              var Tt;
              sr.asyncValidator ? Tt = sr.asyncValidator(sr, qn.value, Sa, qn.source, ft) : sr.validator && (Tt = sr.validator(sr, qn.value, Sa, qn.source, ft), Tt === true ? Sa() : Tt === false ? Sa(typeof sr.message == "function" ? sr.message(sr.fullField || sr.field) : sr.message || (sr.fullField || sr.field) + " fails") : Tt instanceof Array ? Sa(Tt) : Tt instanceof Error && Sa(Tt.message)), Tt && Tt.then && Tt.then(function() {
                return Sa();
              }, function(Ar) {
                return Sa(Ar);
              });
            }, function(qn) {
              Dt(qn);
            }, at);
          }, Ge.getType = function(xe) {
            if (xe.type === void 0 && xe.pattern instanceof RegExp && (xe.type = "pattern"), typeof xe.validator != "function" && xe.type && !XE.hasOwnProperty(xe.type))
              throw new Error(R0("Unknown rule type %s", xe.type));
            return xe.type || "string";
          }, Ge.getValidationMethod = function(xe) {
            if (typeof xe.validator == "function")
              return xe.validator;
            var Se = Object.keys(xe), Ce = Se.indexOf("message");
            return Ce !== -1 && Se.splice(Ce, 1), Se.length === 1 && Se[0] === "required" ? XE.required : XE[this.getType(xe)] || void 0;
          }, ye;
        }();
        DC.register = function(ye, Ge) {
          if (typeof Ge != "function")
            throw new Error("Cannot register a validator by type, validator is not a function");
          XE[ye] = Ge;
        }, DC.warning = I3, DC.messages = YE, DC.validators = XE;
        var F0 = "'${name}' is not a valid ${type}", KE = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: F0, method: F0, array: F0, object: F0, number: F0, date: F0, boolean: F0, integer: F0, float: F0, regexp: F0, email: F0, url: F0, hex: F0 }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
        function mle(ye, Ge) {
          for (var xe = ye, Se = 0; Se < Ge.length; Se += 1) {
            if (xe == null)
              return;
            xe = xe[Ge[Se]];
          }
          return xe;
        }
        function nTe(ye) {
          return yi(ye) || KX(ye) || rs(ye) || wu();
        }
        function ble(ye, Ge, xe, Se) {
          if (!Ge.length)
            return xe;
          var Ce = nTe(Ge), Re = Ce[0], at = Ce.slice(1), ft;
          return !ye && typeof Re == "number" ? ft = [] : Array.isArray(ye) ? ft = Gc(ye) : ft = Nr({}, ye), Se && xe === void 0 && at.length === 1 ? delete ft[Re][at[0]] : ft[Re] = ble(ft[Re], at, xe, Se), ft;
        }
        function rTe(ye, Ge, xe) {
          var Se = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
          return Ge.length && Se && xe === void 0 && !mle(ye, Ge.slice(0, -1)) ? ye : ble(ye, Ge, xe, Se);
        }
        function Qd(ye) {
          return KT(ye);
        }
        function kC(ye, Ge) {
          var xe = mle(ye, Ge);
          return xe;
        }
        function mx(ye, Ge, xe) {
          var Se = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, Ce = rTe(ye, Ge, xe, Se);
          return Ce;
        }
        function eY(ye, Ge) {
          var xe = {};
          return Ge.forEach(function(Se) {
            var Ce = kC(ye, Se);
            xe = mx(xe, Se, Ce);
          }), xe;
        }
        function Wt(ye, Ge) {
          return ye && ye.some(function(xe) {
            return wc(xe, Ge);
          });
        }
        function ZE(ye) {
          return _s(ye) === "object" && ye !== null && Object.getPrototypeOf(ye) === Object.prototype;
        }
        function k4(ye, Ge) {
          var xe = Array.isArray(ye) ? Gc(ye) : Nr({}, ye);
          return Ge && Object.keys(Ge).forEach(function(Se) {
            var Ce = xe[Se], Re = Ge[Se], at = ZE(Ce) && ZE(Re);
            xe[Se] = at ? k4(Ce, Re || {}) : Re;
          }), xe;
        }
        function Uy(ye) {
          for (var Ge = arguments.length, xe = new Array(Ge > 1 ? Ge - 1 : 0), Se = 1; Se < Ge; Se++)
            xe[Se - 1] = arguments[Se];
          return xe.reduce(function(Ce, Re) {
            return k4(Ce, Re);
          }, ye);
        }
        function wc(ye, Ge) {
          return !ye || !Ge || ye.length !== Ge.length ? false : ye.every(function(xe, Se) {
            return Ge[Se] === xe;
          });
        }
        function iTe(ye, Ge) {
          if (ye === Ge)
            return true;
          if (!ye && Ge || ye && !Ge || !ye || !Ge || _s(ye) !== "object" || _s(Ge) !== "object")
            return false;
          var xe = Object.keys(ye), Se = Object.keys(Ge), Ce = new Set([].concat(Gc(xe), Gc(Se)));
          return Gc(Ce).every(function(Re) {
            var at = ye[Re], ft = Ge[Re];
            return typeof at == "function" && typeof ft == "function" ? true : at === ft;
          });
        }
        function aTe(ye) {
          var Ge = arguments.length <= 1 ? void 0 : arguments[1];
          return Ge && Ge.target && _s(Ge.target) === "object" && ye in Ge.target ? Ge.target[ye] : Ge;
        }
        function _le(ye, Ge, xe) {
          var Se = ye.length;
          if (Ge < 0 || Ge >= Se || xe < 0 || xe >= Se)
            return ye;
          var Ce = ye[Ge], Re = Ge - xe;
          return Re > 0 ? [].concat(Gc(ye.slice(0, xe)), [Ce], Gc(ye.slice(xe, Ge)), Gc(ye.slice(Ge + 1, Se))) : Re < 0 ? [].concat(Gc(ye.slice(0, Ge)), Gc(ye.slice(Ge + 1, xe + 1)), [Ce], Gc(ye.slice(xe + 1, Se))) : ye;
        }
        var JE = DC;
        function oTe(ye, Ge) {
          return ye.replace(/\$\{\w+\}/g, function(xe) {
            var Se = xe.slice(2, -1);
            return Ge[Se];
          });
        }
        function tY(ye, Ge, xe, Se, Ce) {
          return nY.apply(this, arguments);
        }
        function nY() {
          return nY = Wo(Li.mark(function ye(Ge, xe, Se, Ce, Re) {
            var at, ft, st, Dt, Pt, tn, Fn, Un;
            return Li.wrap(function(qn) {
              for (; ; )
                switch (qn.prev = qn.next) {
                  case 0:
                    return at = Nr({}, Se), delete at.ruleIndex, ft = null, at && at.type === "array" && at.defaultField && (ft = at.defaultField, delete at.defaultField), st = new JE(fn({}, Ge, [at])), Dt = Uy({}, KE, Ce.validateMessages), st.messages(Dt), Pt = [], qn.prev = 8, qn.next = 11, Promise.resolve(st.validate(fn({}, Ge, xe), Nr({}, Ce)));
                  case 11:
                    qn.next = 16;
                    break;
                  case 13:
                    qn.prev = 13, qn.t0 = qn.catch(8), qn.t0.errors ? Pt = qn.t0.errors.map(function(nr, sr) {
                      var Ii = nr.message;
                      return V.isValidElement(Ii) ? V.cloneElement(Ii, { key: "error_".concat(sr) }) : Ii;
                    }) : (console.error(qn.t0), Pt = [Dt.default]);
                  case 16:
                    if (!(!Pt.length && ft)) {
                      qn.next = 21;
                      break;
                    }
                    return qn.next = 19, Promise.all(xe.map(function(nr, sr) {
                      return tY("".concat(Ge, ".").concat(sr), nr, ft, Ce, Re);
                    }));
                  case 19:
                    return tn = qn.sent, qn.abrupt("return", tn.reduce(function(nr, sr) {
                      return [].concat(Gc(nr), Gc(sr));
                    }, []));
                  case 21:
                    return Fn = Nr(Nr({}, Se), {}, { name: Ge, enum: (Se.enum || []).join(", ") }, Re), Un = Pt.map(function(nr) {
                      return typeof nr == "string" ? oTe(nr, Fn) : nr;
                    }), qn.abrupt("return", Un);
                  case 24:
                  case "end":
                    return qn.stop();
                }
            }, ye, null, [[8, 13]]);
          })), nY.apply(this, arguments);
        }
        function sTe(ye, Ge, xe, Se, Ce, Re) {
          var at = ye.join("."), ft = xe.map(function(Pt, tn) {
            var Fn = Pt.validator, Un = Nr(Nr({}, Pt), {}, { ruleIndex: tn });
            return Fn && (Un.validator = function(qn, nr, sr) {
              var Ii = false, gi = function() {
                for (var Tt = arguments.length, Ar = new Array(Tt), Vr = 0; Vr < Tt; Vr++)
                  Ar[Vr] = arguments[Vr];
                Promise.resolve().then(function() {
                  PS(!Ii, "Your validator function has already return a promise. `callback` will be ignored."), Ii || sr.apply(void 0, Ar);
                });
              }, Sa = Fn(qn, nr, gi);
              Ii = Sa && typeof Sa.then == "function" && typeof Sa.catch == "function", PS(Ii, "`callback` is deprecated. Please return a promise instead."), Ii && Sa.then(function() {
                sr();
              }).catch(function(Tt) {
                sr(Tt || " ");
              });
            }), Un;
          }).sort(function(Pt, tn) {
            var Fn = Pt.warningOnly, Un = Pt.ruleIndex, qn = tn.warningOnly, nr = tn.ruleIndex;
            return !!Fn == !!qn ? Un - nr : Fn ? 1 : -1;
          }), st;
          if (Ce === true)
            st = new Promise(function() {
              var Pt = Wo(Li.mark(function tn(Fn, Un) {
                var qn, nr, sr;
                return Li.wrap(function(Ii) {
                  for (; ; )
                    switch (Ii.prev = Ii.next) {
                      case 0:
                        qn = 0;
                      case 1:
                        if (!(qn < ft.length)) {
                          Ii.next = 12;
                          break;
                        }
                        return nr = ft[qn], Ii.next = 5, tY(at, Ge, nr, Se, Re);
                      case 5:
                        if (sr = Ii.sent, !sr.length) {
                          Ii.next = 9;
                          break;
                        }
                        return Un([{ errors: sr, rule: nr }]), Ii.abrupt("return");
                      case 9:
                        qn += 1, Ii.next = 1;
                        break;
                      case 12:
                        Fn([]);
                      case 13:
                      case "end":
                        return Ii.stop();
                    }
                }, tn);
              }));
              return function(tn, Fn) {
                return Pt.apply(this, arguments);
              };
            }());
          else {
            var Dt = ft.map(function(Pt) {
              return tY(at, Ge, Pt, Se, Re).then(function(tn) {
                return { errors: tn, rule: Pt };
              });
            });
            st = (Ce ? uTe(Dt) : lTe(Dt)).then(function(Pt) {
              return Promise.reject(Pt);
            });
          }
          return st.catch(function(Pt) {
            return Pt;
          }), st;
        }
        function lTe(ye) {
          return bx.apply(this, arguments);
        }
        function bx() {
          return bx = Wo(Li.mark(function ye(Ge) {
            return Li.wrap(function(xe) {
              for (; ; )
                switch (xe.prev = xe.next) {
                  case 0:
                    return xe.abrupt("return", Promise.all(Ge).then(function(Se) {
                      var Ce, Re = (Ce = []).concat.apply(Ce, Gc(Se));
                      return Re;
                    }));
                  case 1:
                  case "end":
                    return xe.stop();
                }
            }, ye);
          })), bx.apply(this, arguments);
        }
        function uTe(ye) {
          return rY.apply(this, arguments);
        }
        function rY() {
          return rY = Wo(Li.mark(function ye(Ge) {
            var xe;
            return Li.wrap(function(Se) {
              for (; ; )
                switch (Se.prev = Se.next) {
                  case 0:
                    return xe = 0, Se.abrupt("return", new Promise(function(Ce) {
                      Ge.forEach(function(Re) {
                        Re.then(function(at) {
                          at.errors.length && Ce([at]), xe += 1, xe === Ge.length && Ce([]);
                        });
                      });
                    }));
                  case 2:
                  case "end":
                    return Se.stop();
                }
            }, ye);
          })), rY.apply(this, arguments);
        }
        var cTe = ["name"], Zb = [];
        function xle(ye, Ge, xe, Se, Ce, Re) {
          return typeof ye == "function" ? ye(Ge, xe, "source" in Re ? { source: Re.source } : {}) : Se !== Ce;
        }
        var _x = function(ye) {
          x32(xe, ye);
          var Ge = m4(xe);
          function xe(Se) {
            var Ce;
            if (g4(this, xe), Ce = Ge.call(this, Se), Ce.state = { resetCount: 0 }, Ce.cancelRegisterFunc = null, Ce.mounted = false, Ce.touched = false, Ce.dirty = false, Ce.validatePromise = null, Ce.prevValidating = void 0, Ce.errors = Zb, Ce.warnings = Zb, Ce.cancelRegister = function() {
              var st = Ce.props, Dt = st.preserve, Pt = st.isListField, tn = st.name;
              Ce.cancelRegisterFunc && Ce.cancelRegisterFunc(Pt, Dt, Qd(tn)), Ce.cancelRegisterFunc = null;
            }, Ce.getNamePath = function() {
              var st = Ce.props, Dt = st.name, Pt = st.fieldContext, tn = Pt.prefixName, Fn = tn === void 0 ? [] : tn;
              return Dt !== void 0 ? [].concat(Gc(Fn), Gc(Dt)) : [];
            }, Ce.getRules = function() {
              var st = Ce.props, Dt = st.rules, Pt = Dt === void 0 ? [] : Dt, tn = st.fieldContext;
              return Pt.map(function(Fn) {
                return typeof Fn == "function" ? Fn(tn) : Fn;
              });
            }, Ce.refresh = function() {
              !Ce.mounted || Ce.setState(function(st) {
                var Dt = st.resetCount;
                return { resetCount: Dt + 1 };
              });
            }, Ce.triggerMetaEvent = function(st) {
              var Dt = Ce.props.onMetaChange;
              Dt == null || Dt(Nr(Nr({}, Ce.getMeta()), {}, { destroy: st }));
            }, Ce.onStoreChange = function(st, Dt, Pt) {
              var tn = Ce.props, Fn = tn.shouldUpdate, Un = tn.dependencies, qn = Un === void 0 ? [] : Un, nr = tn.onReset, sr = Pt.store, Ii = Ce.getNamePath(), gi = Ce.getValue(st), Sa = Ce.getValue(sr), Tt = Dt && Wt(Dt, Ii);
              switch (Pt.type === "valueUpdate" && Pt.source === "external" && gi !== Sa && (Ce.touched = true, Ce.dirty = true, Ce.validatePromise = null, Ce.errors = Zb, Ce.warnings = Zb, Ce.triggerMetaEvent()), Pt.type) {
                case "reset":
                  if (!Dt || Tt) {
                    Ce.touched = false, Ce.dirty = false, Ce.validatePromise = null, Ce.errors = Zb, Ce.warnings = Zb, Ce.triggerMetaEvent(), nr == null || nr(), Ce.refresh();
                    return;
                  }
                  break;
                case "remove": {
                  if (Fn) {
                    Ce.reRender();
                    return;
                  }
                  break;
                }
                case "setField": {
                  if (Tt) {
                    var Ar = Pt.data;
                    "touched" in Ar && (Ce.touched = Ar.touched), "validating" in Ar && !("originRCField" in Ar) && (Ce.validatePromise = Ar.validating ? Promise.resolve([]) : null), "errors" in Ar && (Ce.errors = Ar.errors || Zb), "warnings" in Ar && (Ce.warnings = Ar.warnings || Zb), Ce.dirty = true, Ce.triggerMetaEvent(), Ce.reRender();
                    return;
                  }
                  if (Fn && !Ii.length && xle(Fn, st, sr, gi, Sa, Pt)) {
                    Ce.reRender();
                    return;
                  }
                  break;
                }
                case "dependenciesUpdate": {
                  var Vr = qn.map(Qd);
                  if (Vr.some(function(Si) {
                    return Wt(Pt.relatedFields, Si);
                  })) {
                    Ce.reRender();
                    return;
                  }
                  break;
                }
                default:
                  if (Tt || (!qn.length || Ii.length || Fn) && xle(Fn, st, sr, gi, Sa, Pt)) {
                    Ce.reRender();
                    return;
                  }
                  break;
              }
              Fn === true && Ce.reRender();
            }, Ce.validateRules = function(st) {
              var Dt = Ce.getNamePath(), Pt = Ce.getValue(), tn = Promise.resolve().then(function() {
                if (!Ce.mounted)
                  return [];
                var Fn = Ce.props, Un = Fn.validateFirst, qn = Un === void 0 ? false : Un, nr = Fn.messageVariables, sr = st || {}, Ii = sr.triggerName, gi = Ce.getRules();
                Ii && (gi = gi.filter(function(Tt) {
                  var Ar = Tt.validateTrigger;
                  if (!Ar)
                    return true;
                  var Vr = KT(Ar);
                  return Vr.includes(Ii);
                }));
                var Sa = sTe(Dt, Pt, gi, st, qn, nr);
                return Sa.catch(function(Tt) {
                  return Tt;
                }).then(function() {
                  var Tt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : Zb;
                  if (Ce.validatePromise === tn) {
                    Ce.validatePromise = null;
                    var Ar = [], Vr = [];
                    Tt.forEach(function(Si) {
                      var mi = Si.rule.warningOnly, Dr = Si.errors, Gr = Dr === void 0 ? Zb : Dr;
                      mi ? Vr.push.apply(Vr, Gc(Gr)) : Ar.push.apply(Ar, Gc(Gr));
                    }), Ce.errors = Ar, Ce.warnings = Vr, Ce.triggerMetaEvent(), Ce.reRender();
                  }
                }), Sa;
              });
              return Ce.validatePromise = tn, Ce.dirty = true, Ce.errors = Zb, Ce.warnings = Zb, Ce.triggerMetaEvent(), Ce.reRender(), tn;
            }, Ce.isFieldValidating = function() {
              return !!Ce.validatePromise;
            }, Ce.isFieldTouched = function() {
              return Ce.touched;
            }, Ce.isFieldDirty = function() {
              if (Ce.dirty || Ce.props.initialValue !== void 0)
                return true;
              var st = Ce.props.fieldContext, Dt = st.getInternalHooks(T3), Pt = Dt.getInitialValue;
              return Pt(Ce.getNamePath()) !== void 0;
            }, Ce.getErrors = function() {
              return Ce.errors;
            }, Ce.getWarnings = function() {
              return Ce.warnings;
            }, Ce.isListField = function() {
              return Ce.props.isListField;
            }, Ce.isList = function() {
              return Ce.props.isList;
            }, Ce.isPreserve = function() {
              return Ce.props.preserve;
            }, Ce.getMeta = function() {
              Ce.prevValidating = Ce.isFieldValidating();
              var st = { touched: Ce.isFieldTouched(), validating: Ce.prevValidating, errors: Ce.errors, warnings: Ce.warnings, name: Ce.getNamePath() };
              return st;
            }, Ce.getOnlyChild = function(st) {
              if (typeof st == "function") {
                var Dt = Ce.getMeta();
                return Nr(Nr({}, Ce.getOnlyChild(st(Ce.getControlled(), Dt, Ce.props.fieldContext))), {}, { isFunction: true });
              }
              var Pt = C3(st);
              return Pt.length !== 1 || !V.isValidElement(Pt[0]) ? { child: Pt, isFunction: false } : { child: Pt[0], isFunction: false };
            }, Ce.getValue = function(st) {
              var Dt = Ce.props.fieldContext.getFieldsValue, Pt = Ce.getNamePath();
              return kC(st || Dt(true), Pt);
            }, Ce.getControlled = function() {
              var st = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Dt = Ce.props, Pt = Dt.trigger, tn = Dt.validateTrigger, Fn = Dt.getValueFromEvent, Un = Dt.normalize, qn = Dt.valuePropName, nr = Dt.getValueProps, sr = Dt.fieldContext, Ii = tn !== void 0 ? tn : sr.validateTrigger, gi = Ce.getNamePath(), Sa = sr.getInternalHooks, Tt = sr.getFieldsValue, Ar = Sa(T3), Vr = Ar.dispatch, Si = Ce.getValue(), mi = nr || function(ya) {
                return fn({}, qn, ya);
              }, Dr = st[Pt], Gr = Nr(Nr({}, st), mi(Si));
              Gr[Pt] = function() {
                Ce.touched = true, Ce.dirty = true, Ce.triggerMetaEvent();
                for (var ya, xr = arguments.length, Ro = new Array(xr), Oo = 0; Oo < xr; Oo++)
                  Ro[Oo] = arguments[Oo];
                Fn ? ya = Fn.apply(void 0, Ro) : ya = aTe.apply(void 0, [qn].concat(Ro)), Un && (ya = Un(ya, Si, Tt(true))), Vr({ type: "updateValue", namePath: gi, value: ya }), Dr && Dr.apply(void 0, Ro);
              };
              var Vi = KT(Ii || []);
              return Vi.forEach(function(ya) {
                var xr = Gr[ya];
                Gr[ya] = function() {
                  xr && xr.apply(void 0, arguments);
                  var Ro = Ce.props.rules;
                  Ro && Ro.length && Vr({ type: "validateField", namePath: gi, triggerName: ya });
                };
              }), Gr;
            }, Se.fieldContext) {
              var Re = Se.fieldContext.getInternalHooks, at = Re(T3), ft = at.initEntityValue;
              ft(MV(Ce));
            }
            return Ce;
          }
          return y42(xe, [{ key: "componentDidMount", value: function() {
            var Se = this.props, Ce = Se.shouldUpdate, Re = Se.fieldContext;
            if (this.mounted = true, Re) {
              var at = Re.getInternalHooks, ft = at(T3), st = ft.registerField;
              this.cancelRegisterFunc = st(this);
            }
            Ce === true && this.reRender();
          } }, { key: "componentWillUnmount", value: function() {
            this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
          } }, { key: "reRender", value: function() {
            !this.mounted || this.forceUpdate();
          } }, { key: "render", value: function() {
            var Se = this.state.resetCount, Ce = this.props.children, Re = this.getOnlyChild(Ce), at = Re.child, ft = Re.isFunction, st;
            return ft ? st = at : V.isValidElement(at) ? st = V.cloneElement(at, this.getControlled(at.props)) : (PS(!at, "`children` of Field is not validate ReactElement."), st = at), V.createElement(V.Fragment, { key: Se }, st);
          } }]), xe;
        }(V.Component);
        _x.contextType = C4, _x.defaultProps = { trigger: "onChange", valuePropName: "value" };
        function wle(ye) {
          var Ge = ye.name, xe = Ol(ye, cTe), Se = V.useContext(C4), Ce = Ge !== void 0 ? Qd(Ge) : void 0, Re = "keep";
          return xe.isListField || (Re = "_".concat((Ce || []).join("_"))), V.createElement(_x, ld({ key: Re, name: Ce }, xe, { fieldContext: Se }));
        }
        var fTe = V.createContext(null), hTe = function(ye) {
          var Ge = ye.name, xe = ye.initialValue, Se = ye.children, Ce = ye.rules, Re = ye.validateTrigger, at = V.useContext(C4), ft = V.useRef({ keys: [], id: 0 }), st = ft.current, Dt = V.useMemo(function() {
            var Un = Qd(at.prefixName) || [];
            return [].concat(Gc(Un), Gc(Qd(Ge)));
          }, [at.prefixName, Ge]), Pt = V.useMemo(function() {
            return Nr(Nr({}, at), {}, { prefixName: Dt });
          }, [at, Dt]), tn = V.useMemo(function() {
            return { getKey: function(Un) {
              var qn = Dt.length, nr = Un[qn];
              return [st.keys[nr], Un.slice(qn + 1)];
            } };
          }, [Dt]);
          if (typeof Se != "function")
            return PS(false, "Form.List only accepts function as children."), null;
          var Fn = function(Un, qn, nr) {
            var sr = nr.source;
            return sr === "internal" ? false : Un !== qn;
          };
          return V.createElement(fTe.Provider, { value: tn }, V.createElement(C4.Provider, { value: Pt }, V.createElement(wle, { name: [], shouldUpdate: Fn, rules: Ce, validateTrigger: Re, initialValue: xe, isList: true }, function(Un, qn) {
            var nr = Un.value, sr = nr === void 0 ? [] : nr, Ii = Un.onChange, gi = at.getFieldValue, Sa = function() {
              var Vr = gi(Dt || []);
              return Vr || [];
            }, Tt = { add: function(Vr, Si) {
              var mi = Sa();
              Si >= 0 && Si <= mi.length ? (st.keys = [].concat(Gc(st.keys.slice(0, Si)), [st.id], Gc(st.keys.slice(Si))), Ii([].concat(Gc(mi.slice(0, Si)), [Vr], Gc(mi.slice(Si))))) : (st.keys = [].concat(Gc(st.keys), [st.id]), Ii([].concat(Gc(mi), [Vr]))), st.id += 1;
            }, remove: function(Vr) {
              var Si = Sa(), mi = new Set(Array.isArray(Vr) ? Vr : [Vr]);
              mi.size <= 0 || (st.keys = st.keys.filter(function(Dr, Gr) {
                return !mi.has(Gr);
              }), Ii(Si.filter(function(Dr, Gr) {
                return !mi.has(Gr);
              })));
            }, move: function(Vr, Si) {
              if (Vr !== Si) {
                var mi = Sa();
                Vr < 0 || Vr >= mi.length || Si < 0 || Si >= mi.length || (st.keys = _le(st.keys, Vr, Si), Ii(_le(mi, Vr, Si)));
              }
            } }, Ar = sr || [];
            return Array.isArray(Ar) || (Ar = []), Se(Ar.map(function(Vr, Si) {
              var mi = st.keys[Si];
              return mi === void 0 && (st.keys[Si] = st.id, mi = st.keys[Si], st.id += 1), { name: Si, key: mi, isListField: true };
            }), Tt, qn);
          })));
        };
        function pTe(ye) {
          var Ge = false, xe = ye.length, Se = [];
          return ye.length ? new Promise(function(Ce, Re) {
            ye.forEach(function(at, ft) {
              at.catch(function(st) {
                return Ge = true, st;
              }).then(function(st) {
                xe -= 1, Se[ft] = st, !(xe > 0) && (Ge && Re(Se), Ce(Se));
              });
            });
          }) : Promise.resolve([]);
        }
        var Sle = "__@field_split__";
        function OC(ye) {
          return ye.map(function(Ge) {
            return "".concat(_s(Ge), ":").concat(Ge);
          }).join(Sle);
        }
        var O4 = function() {
          function ye() {
            g4(this, ye), this.kvs = /* @__PURE__ */ new Map();
          }
          return y42(ye, [{ key: "set", value: function(Ge, xe) {
            this.kvs.set(OC(Ge), xe);
          } }, { key: "get", value: function(Ge) {
            return this.kvs.get(OC(Ge));
          } }, { key: "update", value: function(Ge, xe) {
            var Se = this.get(Ge), Ce = xe(Se);
            Ce ? this.set(Ge, Ce) : this.delete(Ge);
          } }, { key: "delete", value: function(Ge) {
            this.kvs.delete(OC(Ge));
          } }, { key: "map", value: function(Ge) {
            return Gc(this.kvs.entries()).map(function(xe) {
              var Se = _l(xe, 2), Ce = Se[0], Re = Se[1], at = Ce.split(Sle);
              return Ge({ key: at.map(function(ft) {
                var st = ft.match(/^([^:]*):(.*)$/), Dt = _l(st, 3), Pt = Dt[1], tn = Dt[2];
                return Pt === "number" ? Number(tn) : tn;
              }), value: Re });
            });
          } }, { key: "toJSON", value: function() {
            var Ge = {};
            return this.map(function(xe) {
              var Se = xe.key, Ce = xe.value;
              return Ge[Se.join(".")] = Ce, null;
            }), Ge;
          } }]), ye;
        }(), dTe = ["name", "errors"], xx = y42(function ye(Ge) {
          var xe = this;
          g4(this, ye), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
            return { getFieldValue: xe.getFieldValue, getFieldsValue: xe.getFieldsValue, getFieldError: xe.getFieldError, getFieldWarning: xe.getFieldWarning, getFieldsError: xe.getFieldsError, isFieldsTouched: xe.isFieldsTouched, isFieldTouched: xe.isFieldTouched, isFieldValidating: xe.isFieldValidating, isFieldsValidating: xe.isFieldsValidating, resetFields: xe.resetFields, setFields: xe.setFields, setFieldsValue: xe.setFieldsValue, validateFields: xe.validateFields, submit: xe.submit, getInternalHooks: xe.getInternalHooks };
          }, this.getInternalHooks = function(Se) {
            return Se === T3 ? (xe.formHooked = true, { dispatch: xe.dispatch, initEntityValue: xe.initEntityValue, registerField: xe.registerField, useSubscribe: xe.useSubscribe, setInitialValues: xe.setInitialValues, setCallbacks: xe.setCallbacks, setValidateMessages: xe.setValidateMessages, getFields: xe.getFields, setPreserve: xe.setPreserve, getInitialValue: xe.getInitialValue }) : (PS(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
          }, this.useSubscribe = function(Se) {
            xe.subscribable = Se;
          }, this.setInitialValues = function(Se, Ce) {
            xe.initialValues = Se || {}, Ce && (xe.store = Uy({}, Se, xe.store));
          }, this.getInitialValue = function(Se) {
            return kC(xe.initialValues, Se);
          }, this.setCallbacks = function(Se) {
            xe.callbacks = Se;
          }, this.setValidateMessages = function(Se) {
            xe.validateMessages = Se;
          }, this.setPreserve = function(Se) {
            xe.preserve = Se;
          }, this.timeoutId = null, this.warningUnhooked = function() {
          }, this.getFieldEntities = function() {
            var Se = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
            return Se ? xe.fieldEntities.filter(function(Ce) {
              return Ce.getNamePath().length;
            }) : xe.fieldEntities;
          }, this.getFieldsMap = function() {
            var Se = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, Ce = new O4();
            return xe.getFieldEntities(Se).forEach(function(Re) {
              var at = Re.getNamePath();
              Ce.set(at, Re);
            }), Ce;
          }, this.getFieldEntitiesForNamePathList = function(Se) {
            if (!Se)
              return xe.getFieldEntities(true);
            var Ce = xe.getFieldsMap(true);
            return Se.map(function(Re) {
              var at = Qd(Re);
              return Ce.get(at) || { INVALIDATE_NAME_PATH: Qd(Re) };
            });
          }, this.getFieldsValue = function(Se, Ce) {
            if (xe.warningUnhooked(), Se === true && !Ce)
              return xe.store;
            var Re = xe.getFieldEntitiesForNamePathList(Array.isArray(Se) ? Se : null), at = [];
            return Re.forEach(function(ft) {
              var st, Dt = "INVALIDATE_NAME_PATH" in ft ? ft.INVALIDATE_NAME_PATH : ft.getNamePath();
              if (!(!Se && ((st = ft.isListField) === null || st === void 0 ? void 0 : st.call(ft))))
                if (!Ce)
                  at.push(Dt);
                else {
                  var Pt = "getMeta" in ft ? ft.getMeta() : null;
                  Ce(Pt) && at.push(Dt);
                }
            }), eY(xe.store, at.map(Qd));
          }, this.getFieldValue = function(Se) {
            xe.warningUnhooked();
            var Ce = Qd(Se);
            return kC(xe.store, Ce);
          }, this.getFieldsError = function(Se) {
            xe.warningUnhooked();
            var Ce = xe.getFieldEntitiesForNamePathList(Se);
            return Ce.map(function(Re, at) {
              return Re && !("INVALIDATE_NAME_PATH" in Re) ? { name: Re.getNamePath(), errors: Re.getErrors(), warnings: Re.getWarnings() } : { name: Qd(Se[at]), errors: [], warnings: [] };
            });
          }, this.getFieldError = function(Se) {
            xe.warningUnhooked();
            var Ce = Qd(Se), Re = xe.getFieldsError([Ce])[0];
            return Re.errors;
          }, this.getFieldWarning = function(Se) {
            xe.warningUnhooked();
            var Ce = Qd(Se), Re = xe.getFieldsError([Ce])[0];
            return Re.warnings;
          }, this.isFieldsTouched = function() {
            xe.warningUnhooked();
            for (var Se = arguments.length, Ce = new Array(Se), Re = 0; Re < Se; Re++)
              Ce[Re] = arguments[Re];
            var at = Ce[0], ft = Ce[1], st, Dt = false;
            Ce.length === 0 ? st = null : Ce.length === 1 ? Array.isArray(at) ? (st = at.map(Qd), Dt = false) : (st = null, Dt = at) : (st = at.map(Qd), Dt = ft);
            var Pt = xe.getFieldEntities(true), tn = function(nr) {
              return nr.isFieldTouched();
            };
            if (!st)
              return Dt ? Pt.every(tn) : Pt.some(tn);
            var Fn = new O4();
            st.forEach(function(nr) {
              Fn.set(nr, []);
            }), Pt.forEach(function(nr) {
              var sr = nr.getNamePath();
              st.forEach(function(Ii) {
                Ii.every(function(gi, Sa) {
                  return sr[Sa] === gi;
                }) && Fn.update(Ii, function(gi) {
                  return [].concat(Gc(gi), [nr]);
                });
              });
            });
            var Un = function(nr) {
              return nr.some(tn);
            }, qn = Fn.map(function(nr) {
              var sr = nr.value;
              return sr;
            });
            return Dt ? qn.every(Un) : qn.some(Un);
          }, this.isFieldTouched = function(Se) {
            return xe.warningUnhooked(), xe.isFieldsTouched([Se]);
          }, this.isFieldsValidating = function(Se) {
            xe.warningUnhooked();
            var Ce = xe.getFieldEntities();
            if (!Se)
              return Ce.some(function(at) {
                return at.isFieldValidating();
              });
            var Re = Se.map(Qd);
            return Ce.some(function(at) {
              var ft = at.getNamePath();
              return Wt(Re, ft) && at.isFieldValidating();
            });
          }, this.isFieldValidating = function(Se) {
            return xe.warningUnhooked(), xe.isFieldsValidating([Se]);
          }, this.resetWithFieldInitialValue = function() {
            var Se = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Ce = new O4(), Re = xe.getFieldEntities(true);
            Re.forEach(function(st) {
              var Dt = st.props.initialValue, Pt = st.getNamePath();
              if (Dt !== void 0) {
                var tn = Ce.get(Pt) || /* @__PURE__ */ new Set();
                tn.add({ entity: st, value: Dt }), Ce.set(Pt, tn);
              }
            });
            var at = function(st) {
              st.forEach(function(Dt) {
                var Pt = Dt.props.initialValue;
                if (Pt !== void 0) {
                  var tn = Dt.getNamePath(), Fn = xe.getInitialValue(tn);
                  if (Fn !== void 0)
                    PS(false, "Form already set 'initialValues' with path '".concat(tn.join("."), "'. Field can not overwrite it."));
                  else {
                    var Un = Ce.get(tn);
                    if (Un && Un.size > 1)
                      PS(false, "Multiple Field with path '".concat(tn.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                    else if (Un) {
                      var qn = xe.getFieldValue(tn);
                      (!Se.skipExist || qn === void 0) && (xe.store = mx(xe.store, tn, Gc(Un)[0].value));
                    }
                  }
                }
              });
            }, ft;
            Se.entities ? ft = Se.entities : Se.namePathList ? (ft = [], Se.namePathList.forEach(function(st) {
              var Dt = Ce.get(st);
              if (Dt) {
                var Pt;
                (Pt = ft).push.apply(Pt, Gc(Gc(Dt).map(function(tn) {
                  return tn.entity;
                })));
              }
            })) : ft = Re, at(ft);
          }, this.resetFields = function(Se) {
            xe.warningUnhooked();
            var Ce = xe.store;
            if (!Se) {
              xe.store = Uy({}, xe.initialValues), xe.resetWithFieldInitialValue(), xe.notifyObservers(Ce, null, { type: "reset" });
              return;
            }
            var Re = Se.map(Qd);
            Re.forEach(function(at) {
              var ft = xe.getInitialValue(at);
              xe.store = mx(xe.store, at, ft);
            }), xe.resetWithFieldInitialValue({ namePathList: Re }), xe.notifyObservers(Ce, Re, { type: "reset" });
          }, this.setFields = function(Se) {
            xe.warningUnhooked();
            var Ce = xe.store;
            Se.forEach(function(Re) {
              var at = Re.name;
              Re.errors;
              var ft = Ol(Re, dTe), st = Qd(at);
              "value" in ft && (xe.store = mx(xe.store, st, ft.value)), xe.notifyObservers(Ce, [st], { type: "setField", data: Re });
            });
          }, this.getFields = function() {
            var Se = xe.getFieldEntities(true), Ce = Se.map(function(Re) {
              var at = Re.getNamePath(), ft = Re.getMeta(), st = Nr(Nr({}, ft), {}, { name: at, value: xe.getFieldValue(at) });
              return Object.defineProperty(st, "originRCField", { value: true }), st;
            });
            return Ce;
          }, this.initEntityValue = function(Se) {
            var Ce = Se.props.initialValue;
            if (Ce !== void 0) {
              var Re = Se.getNamePath(), at = kC(xe.store, Re);
              at === void 0 && (xe.store = mx(xe.store, Re, Ce));
            }
          }, this.registerField = function(Se) {
            if (xe.fieldEntities.push(Se), Se.props.initialValue !== void 0) {
              var Ce = xe.store;
              xe.resetWithFieldInitialValue({ entities: [Se], skipExist: true }), xe.notifyObservers(Ce, [Se.getNamePath()], { type: "valueUpdate", source: "internal" });
            }
            return function(Re, at) {
              var ft = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
              xe.fieldEntities = xe.fieldEntities.filter(function(Fn) {
                return Fn !== Se;
              });
              var st = at !== void 0 ? at : xe.preserve;
              if (st === false && (!Re || ft.length > 1)) {
                var Dt = Se.getNamePath(), Pt = Re ? void 0 : kC(xe.initialValues, Dt);
                if (Dt.length && xe.getFieldValue(Dt) !== Pt && xe.fieldEntities.every(function(Fn) {
                  return !wc(Fn.getNamePath(), Dt);
                })) {
                  var tn = xe.store;
                  xe.store = mx(tn, Dt, Pt, true), xe.notifyObservers(tn, [Dt], { type: "remove" }), xe.triggerDependenciesUpdate(tn, Dt);
                }
              }
            };
          }, this.dispatch = function(Se) {
            switch (Se.type) {
              case "updateValue": {
                var Ce = Se.namePath, Re = Se.value;
                xe.updateValue(Ce, Re);
                break;
              }
              case "validateField": {
                var at = Se.namePath, ft = Se.triggerName;
                xe.validateFields([at], { triggerName: ft });
                break;
              }
            }
          }, this.notifyObservers = function(Se, Ce, Re) {
            if (xe.subscribable) {
              var at = Nr(Nr({}, Re), {}, { store: xe.getFieldsValue(true) });
              xe.getFieldEntities().forEach(function(ft) {
                var st = ft.onStoreChange;
                st(Se, Ce, at);
              });
            } else
              xe.forceRootUpdate();
          }, this.triggerDependenciesUpdate = function(Se, Ce) {
            var Re = xe.getDependencyChildrenFields(Ce);
            return Re.length && xe.validateFields(Re), xe.notifyObservers(Se, Re, { type: "dependenciesUpdate", relatedFields: [Ce].concat(Gc(Re)) }), Re;
          }, this.updateValue = function(Se, Ce) {
            var Re = Qd(Se), at = xe.store;
            xe.store = mx(xe.store, Re, Ce), xe.notifyObservers(at, [Re], { type: "valueUpdate", source: "internal" });
            var ft = xe.triggerDependenciesUpdate(at, Re), st = xe.callbacks.onValuesChange;
            if (st) {
              var Dt = eY(xe.store, [Re]);
              st(Dt, xe.getFieldsValue());
            }
            xe.triggerOnFieldsChange([Re].concat(Gc(ft)));
          }, this.setFieldsValue = function(Se) {
            xe.warningUnhooked();
            var Ce = xe.store;
            Se && (xe.store = Uy(xe.store, Se)), xe.notifyObservers(Ce, null, { type: "valueUpdate", source: "external" });
          }, this.getDependencyChildrenFields = function(Se) {
            var Ce = /* @__PURE__ */ new Set(), Re = [], at = new O4();
            xe.getFieldEntities().forEach(function(st) {
              var Dt = st.props.dependencies;
              (Dt || []).forEach(function(Pt) {
                var tn = Qd(Pt);
                at.update(tn, function() {
                  var Fn = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                  return Fn.add(st), Fn;
                });
              });
            });
            var ft = function st(Dt) {
              var Pt = at.get(Dt) || /* @__PURE__ */ new Set();
              Pt.forEach(function(tn) {
                if (!Ce.has(tn)) {
                  Ce.add(tn);
                  var Fn = tn.getNamePath();
                  tn.isFieldDirty() && Fn.length && (Re.push(Fn), st(Fn));
                }
              });
            };
            return ft(Se), Re;
          }, this.triggerOnFieldsChange = function(Se, Ce) {
            var Re = xe.callbacks.onFieldsChange;
            if (Re) {
              var at = xe.getFields();
              if (Ce) {
                var ft = new O4();
                Ce.forEach(function(Dt) {
                  var Pt = Dt.name, tn = Dt.errors;
                  ft.set(Pt, tn);
                }), at.forEach(function(Dt) {
                  Dt.errors = ft.get(Dt.name) || Dt.errors;
                });
              }
              var st = at.filter(function(Dt) {
                var Pt = Dt.name;
                return Wt(Se, Pt);
              });
              Re(st, at);
            }
          }, this.validateFields = function(Se, Ce) {
            xe.warningUnhooked();
            var Re = !!Se, at = Re ? Se.map(Qd) : [], ft = [];
            xe.getFieldEntities(true).forEach(function(Pt) {
              if (Re || at.push(Pt.getNamePath()), (Ce == null ? void 0 : Ce.recursive) && Re) {
                var tn = Pt.getNamePath();
                tn.every(function(qn, nr) {
                  return Se[nr] === qn || Se[nr] === void 0;
                }) && at.push(tn);
              }
              if (!(!Pt.props.rules || !Pt.props.rules.length)) {
                var Fn = Pt.getNamePath();
                if (!Re || Wt(at, Fn)) {
                  var Un = Pt.validateRules(Nr({ validateMessages: Nr(Nr({}, KE), xe.validateMessages) }, Ce));
                  ft.push(Un.then(function() {
                    return { name: Fn, errors: [], warnings: [] };
                  }).catch(function(qn) {
                    var nr = [], sr = [];
                    return qn.forEach(function(Ii) {
                      var gi = Ii.rule.warningOnly, Sa = Ii.errors;
                      gi ? sr.push.apply(sr, Gc(Sa)) : nr.push.apply(nr, Gc(Sa));
                    }), nr.length ? Promise.reject({ name: Fn, errors: nr, warnings: sr }) : { name: Fn, errors: nr, warnings: sr };
                  }));
                }
              }
            });
            var st = pTe(ft);
            xe.lastValidatePromise = st, st.catch(function(Pt) {
              return Pt;
            }).then(function(Pt) {
              var tn = Pt.map(function(Fn) {
                var Un = Fn.name;
                return Un;
              });
              xe.notifyObservers(xe.store, tn, { type: "validateFinish" }), xe.triggerOnFieldsChange(tn, Pt);
            });
            var Dt = st.then(function() {
              return xe.lastValidatePromise === st ? Promise.resolve(xe.getFieldsValue(at)) : Promise.reject([]);
            }).catch(function(Pt) {
              var tn = Pt.filter(function(Fn) {
                return Fn && Fn.errors.length;
              });
              return Promise.reject({ values: xe.getFieldsValue(at), errorFields: tn, outOfDate: xe.lastValidatePromise !== st });
            });
            return Dt.catch(function(Pt) {
              return Pt;
            }), Dt;
          }, this.submit = function() {
            xe.warningUnhooked(), xe.validateFields().then(function(Se) {
              var Ce = xe.callbacks.onFinish;
              if (Ce)
                try {
                  Ce(Se);
                } catch (Re) {
                  console.error(Re);
                }
            }).catch(function(Se) {
              var Ce = xe.callbacks.onFinishFailed;
              Ce && Ce(Se);
            });
          }, this.forceRootUpdate = Ge;
        });
        function Cle(ye) {
          var Ge = V.useRef(), xe = V.useState({}), Se = _l(xe, 2), Ce = Se[1];
          if (!Ge.current)
            if (ye)
              Ge.current = ye;
            else {
              var Re = function() {
                Ce({});
              }, at = new xx(Re);
              Ge.current = at.getForm();
            }
          return [Ge.current];
        }
        var iY = V.createContext({ triggerFormChange: function() {
        }, triggerFormFinish: function() {
        }, registerForm: function() {
        }, unregisterForm: function() {
        } }), vTe = function(ye) {
          var Ge = ye.validateMessages, xe = ye.onFormChange, Se = ye.onFormFinish, Ce = ye.children, Re = V.useContext(iY), at = V.useRef({});
          return V.createElement(iY.Provider, { value: Nr(Nr({}, Re), {}, { validateMessages: Nr(Nr({}, Re.validateMessages), Ge), triggerFormChange: function(ft, st) {
            xe && xe(ft, { changedFields: st, forms: at.current }), Re.triggerFormChange(ft, st);
          }, triggerFormFinish: function(ft, st) {
            Se && Se(ft, { values: st, forms: at.current }), Re.triggerFormFinish(ft, st);
          }, registerForm: function(ft, st) {
            ft && (at.current = Nr(Nr({}, at.current), {}, fn({}, ft, st))), Re.registerForm(ft, st);
          }, unregisterForm: function(ft) {
            var st = Nr({}, at.current);
            delete st[ft], at.current = st, Re.unregisterForm(ft);
          } }) }, Ce);
        }, gTe = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], yTe = function(ye, Ge) {
          var xe = ye.name, Se = ye.initialValues, Ce = ye.fields, Re = ye.form, at = ye.preserve, ft = ye.children, st = ye.component, Dt = st === void 0 ? "form" : st, Pt = ye.validateMessages, tn = ye.validateTrigger, Fn = tn === void 0 ? "onChange" : tn, Un = ye.onValuesChange, qn = ye.onFieldsChange, nr = ye.onFinish, sr = ye.onFinishFailed, Ii = Ol(ye, gTe), gi = V.useContext(iY), Sa = Cle(Re), Tt = _l(Sa, 1), Ar = Tt[0], Vr = Ar.getInternalHooks(T3), Si = Vr.useSubscribe, mi = Vr.setInitialValues, Dr = Vr.setCallbacks, Gr = Vr.setValidateMessages, Vi = Vr.setPreserve;
          V.useImperativeHandle(Ge, function() {
            return Ar;
          }), V.useEffect(function() {
            return gi.registerForm(xe, Ar), function() {
              gi.unregisterForm(xe);
            };
          }, [gi, Ar, xe]), Gr(Nr(Nr({}, gi.validateMessages), Pt)), Dr({ onValuesChange: Un, onFieldsChange: function(si) {
            if (gi.triggerFormChange(xe, si), qn) {
              for (var ni = arguments.length, ja = new Array(ni > 1 ? ni - 1 : 0), Ta = 1; Ta < ni; Ta++)
                ja[Ta - 1] = arguments[Ta];
              qn.apply(void 0, [si].concat(ja));
            }
          }, onFinish: function(si) {
            gi.triggerFormFinish(xe, si), nr && nr(si);
          }, onFinishFailed: sr }), Vi(at);
          var ya = V.useRef(null);
          mi(Se, !ya.current), ya.current || (ya.current = true);
          var xr = ft, Ro = typeof ft == "function";
          if (Ro) {
            var Oo = Ar.getFieldsValue(true);
            xr = ft(Oo, Ar);
          }
          Si(!Ro);
          var pi = V.useRef();
          V.useEffect(function() {
            iTe(pi.current || [], Ce || []) || Ar.setFields(Ce || []), pi.current = Ce;
          }, [Ce, Ar]);
          var xs = V.useMemo(function() {
            return Nr(Nr({}, Ar), {}, { validateTrigger: Fn });
          }, [Ar, Fn]), Ti = V.createElement(C4.Provider, { value: xs }, xr);
          return Dt === false ? Ti : V.createElement(Dt, ld({}, Ii, { onSubmit: function(si) {
            si.preventDefault(), si.stopPropagation(), Ar.submit();
          }, onReset: function(si) {
            var ni;
            si.preventDefault(), Ar.resetFields(), (ni = Ii.onReset) === null || ni === void 0 || ni.call(Ii, si);
          } }), Ti);
        }, Mle = V.forwardRef(yTe), P4 = Mle;
        P4.FormProvider = vTe, P4.Field = wle, P4.List = hTe, P4.useForm = Cle;
        var mTe = function(ye, Ge, xe) {
          PS(ye, "[antd: ".concat(Ge, "] ").concat(xe));
        }, bTe = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, aY = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, L4 = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, R4 = L4, _Te = { lang: ld({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, aY), timePickerLocale: ld({}, R4) }, oY = _Te, nb = "${label} is not a valid ${type}", PC = { locale: "en", Pagination: bTe, DatePicker: oY, TimePicker: R4, Calendar: oY, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: nb, method: nb, array: nb, object: nb, number: nb, date: nb, boolean: nb, integer: nb, float: nb, regexp: nb, email: nb, url: nb, hex: nb }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, VV = PC, QE = T.createContext(void 0), Jb = QE, sY = function(ye) {
          x32(xe, ye);
          var Ge = m4(xe);
          function xe() {
            return g4(this, xe), Ge.apply(this, arguments);
          }
          return y42(xe, [{ key: "getLocale", value: function() {
            var Se = this.props, Ce = Se.componentName, Re = Se.defaultLocale, at = Re || VV[Ce != null ? Ce : "global"], ft = this.context, st = Ce && ft ? ft[Ce] : {};
            return ld(ld({}, at instanceof Function ? at() : at), st || {});
          } }, { key: "getLocaleCode", value: function() {
            var Se = this.context, Ce = Se && Se.locale;
            return Se && Se.exist && !Ce ? VV.locale : Ce;
          } }, { key: "render", value: function() {
            return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
          } }]), xe;
        }(V.Component);
        sY.defaultProps = { componentName: "global" }, sY.contextType = Jb;
        var Tle = function() {
          var ye = V.useContext(Gg), Ge = ye.getPrefixCls, xe = Ge("empty-img-default");
          return V.createElement("svg", { className: xe, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, V.createElement("g", { fill: "none", fillRule: "evenodd" }, V.createElement("g", { transform: "translate(24 31.67)" }, V.createElement("ellipse", { className: "".concat(xe, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), V.createElement("path", { className: "".concat(xe, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), V.createElement("path", { className: "".concat(xe, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), V.createElement("path", { className: "".concat(xe, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), V.createElement("path", { className: "".concat(xe, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), V.createElement("path", { className: "".concat(xe, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), V.createElement("g", { className: "".concat(xe, "-g"), transform: "translate(149.65 15.383)" }, V.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), V.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
        }, Ale = Tle, N4 = function() {
          var ye = V.useContext(Gg), Ge = ye.getPrefixCls, xe = Ge("empty-img-simple");
          return V.createElement("svg", { className: xe, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, V.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, V.createElement("ellipse", { className: "".concat(xe, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), V.createElement("g", { className: "".concat(xe, "-g"), fillRule: "nonzero" }, V.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), V.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(xe, "-path") }))));
        }, eA = N4, Ile = globalThis && globalThis.__rest || function(ye, Ge) {
          var xe = {};
          for (var Se in ye)
            Object.prototype.hasOwnProperty.call(ye, Se) && Ge.indexOf(Se) < 0 && (xe[Se] = ye[Se]);
          if (ye != null && typeof Object.getOwnPropertySymbols == "function")
            for (var Ce = 0, Se = Object.getOwnPropertySymbols(ye); Ce < Se.length; Ce++)
              Ge.indexOf(Se[Ce]) < 0 && Object.prototype.propertyIsEnumerable.call(ye, Se[Ce]) && (xe[Se[Ce]] = ye[Se[Ce]]);
          return xe;
        }, Ele = V.createElement(Ale, null), F4 = V.createElement(eA, null), lY = function(ye) {
          var Ge = ye.className, xe = ye.prefixCls, Se = ye.image, Ce = Se === void 0 ? Ele : Se, Re = ye.description, at = ye.children, ft = ye.imageStyle, st = Ile(ye, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), Dt = V.useContext(Gg), Pt = Dt.getPrefixCls, tn = Dt.direction;
          return V.createElement(sY, { componentName: "Empty" }, function(Fn) {
            var Un, qn = Pt("empty", xe), nr = typeof Re != "undefined" ? Re : Fn.description, sr = typeof nr == "string" ? nr : "empty", Ii = null;
            return typeof Ce == "string" ? Ii = V.createElement("img", { alt: sr, src: Ce }) : Ii = Ce, V.createElement("div", ld({ className: qf(qn, (Un = {}, fn(Un, "".concat(qn, "-normal"), Ce === F4), fn(Un, "".concat(qn, "-rtl"), tn === "rtl"), Un), Ge) }, st), V.createElement("div", { className: "".concat(qn, "-image"), style: ft }, Ii), nr && V.createElement("div", { className: "".concat(qn, "-description") }, nr), at && V.createElement("div", { className: "".concat(qn, "-footer") }, at));
          });
        };
        lY.PRESENTED_IMAGE_DEFAULT = Ele, lY.PRESENTED_IMAGE_SIMPLE = F4;
        var D3 = lY, jg = function(ye) {
          return V.createElement(BV, null, function(Ge) {
            var xe = Ge.getPrefixCls, Se = xe("empty");
            switch (ye) {
              case "Table":
              case "List":
                return V.createElement(D3, { image: D3.PRESENTED_IMAGE_SIMPLE });
              case "Select":
              case "TreeSelect":
              case "Cascader":
              case "Transfer":
              case "Mentions":
                return V.createElement(D3, { image: D3.PRESENTED_IMAGE_SIMPLE, className: "".concat(Se, "-small") });
              default:
                return V.createElement(D3, null);
            }
          });
        }, uY = jg, Dle = function(ye, Ge) {
          return Ge || (ye ? "ant-".concat(ye) : "ant");
        }, Gg = V.createContext({ getPrefixCls: Dle, renderEmpty: uY }), BV = Gg.Consumer, zV = V.createContext(void 0), eD = zV, cY = function(ye) {
          return +setTimeout(ye, 16);
        }, V0 = function(ye) {
          return clearTimeout(ye);
        };
        typeof window != "undefined" && "requestAnimationFrame" in window && (cY = function(ye) {
          return window.requestAnimationFrame(ye);
        }, V0 = function(ye) {
          return window.cancelAnimationFrame(ye);
        });
        var jV = 0, fY = /* @__PURE__ */ new Map();
        function kle(ye) {
          fY.delete(ye);
        }
        function GV(ye) {
          var Ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
          jV += 1;
          var xe = jV;
          function Se(Ce) {
            if (Ce === 0)
              kle(xe), ye();
            else {
              var Re = cY(function() {
                Se(Ce - 1);
              });
              fY.set(xe, Re);
            }
          }
          return Se(Ge), xe;
        }
        GV.cancel = function(ye) {
          var Ge = fY.get(ye);
          return kle(Ge), V0(Ge);
        };
        function hY(ye, Ge) {
          var xe = Ge || {}, Se = xe.defaultValue, Ce = xe.value, Re = xe.onChange, at = xe.postState, ft = V.useState(function() {
            return Ce !== void 0 ? Ce : Se !== void 0 ? typeof Se == "function" ? Se() : Se : typeof ye == "function" ? ye() : ye;
          }), st = _l(ft, 2), Dt = st[0], Pt = st[1], tn = Ce !== void 0 ? Ce : Dt;
          at && (tn = at(tn));
          var Fn = V.useRef(Re);
          Fn.current = Re;
          var Un = V.useCallback(function(nr) {
            Pt(nr), tn !== nr && Fn.current && Fn.current(nr, tn);
          }, [tn, Fn]), qn = V.useRef(true);
          return V.useEffect(function() {
            if (qn.current) {
              qn.current = false;
              return;
            }
            Ce === void 0 && Pt(Ce);
          }, [Ce]), [tn, Un];
        }
        var fl = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(ye) {
          var Ge = ye.keyCode;
          if (ye.altKey && !ye.ctrlKey || ye.metaKey || Ge >= fl.F1 && Ge <= fl.F12)
            return false;
          switch (Ge) {
            case fl.ALT:
            case fl.CAPS_LOCK:
            case fl.CONTEXT_MENU:
            case fl.CTRL:
            case fl.DOWN:
            case fl.END:
            case fl.ESC:
            case fl.HOME:
            case fl.INSERT:
            case fl.LEFT:
            case fl.MAC_FF_META:
            case fl.META:
            case fl.NUMLOCK:
            case fl.NUM_CENTER:
            case fl.PAGE_DOWN:
            case fl.PAGE_UP:
            case fl.PAUSE:
            case fl.PRINT_SCREEN:
            case fl.RIGHT:
            case fl.SHIFT:
            case fl.UP:
            case fl.WIN_KEY:
            case fl.WIN_KEY_RIGHT:
              return false;
            default:
              return true;
          }
        }, isCharacterKey: function(ye) {
          if (ye >= fl.ZERO && ye <= fl.NINE || ye >= fl.NUM_ZERO && ye <= fl.NUM_MULTIPLY || ye >= fl.A && ye <= fl.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && ye === 0)
            return true;
          switch (ye) {
            case fl.SPACE:
            case fl.QUESTION_MARK:
            case fl.NUM_PLUS:
            case fl.NUM_MINUS:
            case fl.NUM_PERIOD:
            case fl.NUM_DIVISION:
            case fl.SEMICOLON:
            case fl.DASH:
            case fl.EQUALS:
            case fl.COMMA:
            case fl.PERIOD:
            case fl.SLASH:
            case fl.APOSTROPHE:
            case fl.SINGLE_QUOTE:
            case fl.OPEN_SQUARE_BRACKET:
            case fl.BACKSLASH:
            case fl.CLOSE_SQUARE_BRACKET:
              return true;
            default:
              return false;
          }
        } }, k32 = function() {
          for (var ye = arguments.length, Ge = new Array(ye), xe = 0; xe < ye; xe++)
            Ge[xe] = arguments[xe];
          return Ge;
        }, Ole = V.isValidElement;
        function xTe(ye, Ge, xe) {
          return Ole(ye) ? V.cloneElement(ye, typeof xe == "function" ? xe(ye.props || {}) : xe) : Ge;
        }
        function wTe(ye, Ge) {
          return xTe(ye, ye, Ge);
        }
        var O3 = ["xxl", "xl", "lg", "md", "sm", "xs"], HV = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, tD = /* @__PURE__ */ new Map(), V4 = -1, B4 = {}, STe = { matchHandlers: {}, dispatch: function(ye) {
          return B4 = ye, tD.forEach(function(Ge) {
            return Ge(B4);
          }), tD.size >= 1;
        }, subscribe: function(ye) {
          return tD.size || this.register(), V4 += 1, tD.set(V4, ye), ye(B4), V4;
        }, unsubscribe: function(ye) {
          tD.delete(ye), tD.size || this.unregister();
        }, unregister: function() {
          var ye = this;
          Object.keys(HV).forEach(function(Ge) {
            var xe = HV[Ge], Se = ye.matchHandlers[xe];
            Se == null || Se.mql.removeListener(Se == null ? void 0 : Se.listener);
          }), tD.clear();
        }, register: function() {
          var ye = this;
          Object.keys(HV).forEach(function(Ge) {
            var xe = HV[Ge], Se = function(Re) {
              var at = Re.matches;
              ye.dispatch(ld(ld({}, B4), fn({}, Ge, at)));
            }, Ce = window.matchMedia(xe);
            Ce.addListener(Se), ye.matchHandlers[xe] = { mql: Ce, listener: Se }, Se(Ce);
          });
        } }, Ple = STe, CTe = 0, nD = {};
        function P3(ye) {
          var Ge = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, xe = CTe++, Se = Ge;
          function Ce() {
            Se -= 1, Se <= 0 ? (ye(), delete nD[xe]) : nD[xe] = GV(Ce);
          }
          return nD[xe] = GV(Ce), xe;
        }
        P3.cancel = function(ye) {
          ye !== void 0 && (GV.cancel(nD[ye]), delete nD[ye]);
        }, P3.ids = nD;
        var pY;
        function WV(ye) {
          return !ye || ye.offsetParent === null || ye.hidden;
        }
        function Lle(ye) {
          var Ge = (ye || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
          return Ge && Ge[1] && Ge[2] && Ge[3] ? !(Ge[1] === Ge[2] && Ge[2] === Ge[3]) : true;
        }
        var dY = function(ye) {
          x32(xe, ye);
          var Ge = m4(xe);
          function xe() {
            var Se;
            return g4(this, xe), Se = Ge.apply(this, arguments), Se.containerRef = V.createRef(), Se.animationStart = false, Se.destroyed = false, Se.onClick = function(Ce, Re) {
              var at, ft, st = Se.props, Dt = st.insertExtraNode, Pt = st.disabled;
              if (!(Pt || !Ce || WV(Ce) || Ce.className.indexOf("-leave") >= 0)) {
                Se.extraNode = document.createElement("div");
                var tn = MV(Se), Fn = tn.extraNode, Un = Se.context.getPrefixCls;
                Fn.className = "".concat(Un(""), "-click-animating-node");
                var qn = Se.getAttributeName();
                if (Ce.setAttribute(qn, "true"), Re && Re !== "#ffffff" && Re !== "rgb(255, 255, 255)" && Lle(Re) && !/rgba\((?:\d*, ){3}0\)/.test(Re) && Re !== "transparent") {
                  Fn.style.borderColor = Re;
                  var nr = ((at = Ce.getRootNode) === null || at === void 0 ? void 0 : at.call(Ce)) || Ce.ownerDocument, sr = nr instanceof Document ? nr.body : (ft = nr.firstChild) !== null && ft !== void 0 ? ft : nr;
                  pY = ng(`
      [`.concat(Un(""), "-click-animating-without-extra-node='true']::after, .").concat(Un(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(Re, `;
      }`), "antd-wave", { csp: Se.csp, attachTo: sr });
                }
                Dt && Ce.appendChild(Fn), ["transition", "animation"].forEach(function(Ii) {
                  Ce.addEventListener("".concat(Ii, "start"), Se.onTransitionStart), Ce.addEventListener("".concat(Ii, "end"), Se.onTransitionEnd);
                });
              }
            }, Se.onTransitionStart = function(Ce) {
              if (!Se.destroyed) {
                var Re = Se.containerRef.current;
                !Ce || Ce.target !== Re || Se.animationStart || Se.resetEffect(Re);
              }
            }, Se.onTransitionEnd = function(Ce) {
              !Ce || Ce.animationName !== "fadeEffect" || Se.resetEffect(Ce.target);
            }, Se.bindAnimationEvent = function(Ce) {
              if (!(!Ce || !Ce.getAttribute || Ce.getAttribute("disabled") || Ce.className.indexOf("disabled") >= 0)) {
                var Re = function(at) {
                  if (!(at.target.tagName === "INPUT" || WV(at.target))) {
                    Se.resetEffect(Ce);
                    var ft = getComputedStyle(Ce).getPropertyValue("border-top-color") || getComputedStyle(Ce).getPropertyValue("border-color") || getComputedStyle(Ce).getPropertyValue("background-color");
                    Se.clickWaveTimeoutId = window.setTimeout(function() {
                      return Se.onClick(Ce, ft);
                    }, 0), P3.cancel(Se.animationStartId), Se.animationStart = true, Se.animationStartId = P3(function() {
                      Se.animationStart = false;
                    }, 10);
                  }
                };
                return Ce.addEventListener("click", Re, true), { cancel: function() {
                  Ce.removeEventListener("click", Re, true);
                } };
              }
            }, Se.renderWave = function(Ce) {
              var Re = Ce.csp, at = Se.props.children;
              if (Se.csp = Re, !V.isValidElement(at))
                return at;
              var ft = Se.containerRef;
              return HMe(at) && (ft = GMe(at.ref, Se.containerRef)), wTe(at, { ref: ft });
            }, Se;
          }
          return y42(xe, [{ key: "componentDidMount", value: function() {
            var Se = this.containerRef.current;
            !Se || Se.nodeType !== 1 || (this.instance = this.bindAnimationEvent(Se));
          } }, { key: "componentWillUnmount", value: function() {
            this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
          } }, { key: "getAttributeName", value: function() {
            var Se = this.context.getPrefixCls, Ce = this.props.insertExtraNode;
            return Ce ? "".concat(Se(""), "-click-animating") : "".concat(Se(""), "-click-animating-without-extra-node");
          } }, { key: "resetEffect", value: function(Se) {
            var Ce = this;
            if (!(!Se || Se === this.extraNode || !(Se instanceof Element))) {
              var Re = this.props.insertExtraNode, at = this.getAttributeName();
              Se.setAttribute(at, "false"), pY && (pY.innerHTML = ""), Re && this.extraNode && Se.contains(this.extraNode) && Se.removeChild(this.extraNode), ["transition", "animation"].forEach(function(ft) {
                Se.removeEventListener("".concat(ft, "start"), Ce.onTransitionStart), Se.removeEventListener("".concat(ft, "end"), Ce.onTransitionEnd);
              });
            }
          } }, { key: "render", value: function() {
            return V.createElement(BV, null, this.renderWave);
          } }]), xe;
        }(V.Component);
        dY.contextType = Gg;
        var UV = { exports: {} }, tA = {};
        /** @license React v17.0.2
        * react-jsx-runtime.production.min.js
        *
        * Copyright (c) Facebook, Inc. and its affiliates.
        *
        * This source code is licensed under the MIT license found in the
        * LICENSE file in the root directory of this source tree.
        */
        var MTe = R.default, vY = 60103;
        if (tA.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
          var gY = Symbol.for;
          vY = gY("react.element"), tA.Fragment = gY("react.fragment");
        }
        var TTe = MTe.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, Rle = Object.prototype.hasOwnProperty, ATe = { key: true, ref: true, __self: true, __source: true };
        function qV(ye, Ge, xe) {
          var Se, Ce = {}, Re = null, at = null;
          xe !== void 0 && (Re = "" + xe), Ge.key !== void 0 && (Re = "" + Ge.key), Ge.ref !== void 0 && (at = Ge.ref);
          for (Se in Ge)
            Rle.call(Ge, Se) && !ATe.hasOwnProperty(Se) && (Ce[Se] = Ge[Se]);
          if (ye && ye.defaultProps)
            for (Se in Ge = ye.defaultProps, Ge)
              Ce[Se] === void 0 && (Ce[Se] = Ge[Se]);
          return { $$typeof: vY, type: ye, key: Re, ref: at, props: Ce, _owner: TTe.current };
        }
        tA.jsx = qV, tA.jsxs = qV, UV.exports = tA;
        const rD = UV.exports.jsx, yY = UV.exports.jsxs;
        var ITe = T.createContext({}), $V = ITe, Wu = function() {
          return tle() && window.document.documentElement;
        }, XV, ETe = function() {
          if (!Wu())
            return false;
          if (XV !== void 0)
            return XV;
          var ye = document.createElement("div");
          return ye.style.display = "flex", ye.style.flexDirection = "column", ye.style.rowGap = "1px", ye.appendChild(document.createElement("div")), ye.appendChild(document.createElement("div")), document.body.appendChild(ye), XV = ye.scrollHeight === 1, document.body.removeChild(ye), XV;
        }, z4 = function() {
          var ye = V.useState(false), Ge = _l(ye, 2), xe = Ge[0], Se = Ge[1];
          return V.useEffect(function() {
            Se(ETe());
          }, []), xe;
        }, Nle = globalThis && globalThis.__rest || function(ye, Ge) {
          var xe = {};
          for (var Se in ye)
            Object.prototype.hasOwnProperty.call(ye, Se) && Ge.indexOf(Se) < 0 && (xe[Se] = ye[Se]);
          if (ye != null && typeof Object.getOwnPropertySymbols == "function")
            for (var Ce = 0, Se = Object.getOwnPropertySymbols(ye); Ce < Se.length; Ce++)
              Ge.indexOf(Se[Ce]) < 0 && Object.prototype.propertyIsEnumerable.call(ye, Se[Ce]) && (xe[Se[Ce]] = ye[Se[Ce]]);
          return xe;
        };
        k32("top", "middle", "bottom", "stretch"), k32("start", "end", "center", "space-around", "space-between");
        var Fle = V.forwardRef(function(ye, Ge) {
          var xe, Se = ye.prefixCls, Ce = ye.justify, Re = ye.align, at = ye.className, ft = ye.style, st = ye.children, Dt = ye.gutter, Pt = Dt === void 0 ? 0 : Dt, tn = ye.wrap, Fn = Nle(ye, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Un = V.useContext(Gg), qn = Un.getPrefixCls, nr = Un.direction, sr = V.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), Ii = _l(sr, 2), gi = Ii[0], Sa = Ii[1], Tt = z4(), Ar = V.useRef(Pt);
          V.useEffect(function() {
            var Ti = Ple.subscribe(function(si) {
              var ni = Ar.current || 0;
              (!Array.isArray(ni) && _s(ni) === "object" || Array.isArray(ni) && (_s(ni[0]) === "object" || _s(ni[1]) === "object")) && Sa(si);
            });
            return function() {
              return Ple.unsubscribe(Ti);
            };
          }, []);
          var Vr = function() {
            var Ti = [0, 0], si = Array.isArray(Pt) ? Pt : [Pt, 0];
            return si.forEach(function(ni, ja) {
              if (_s(ni) === "object")
                for (var Ta = 0; Ta < O3.length; Ta++) {
                  var Ws = O3[Ta];
                  if (gi[Ws] && ni[Ws] !== void 0) {
                    Ti[ja] = ni[Ws];
                    break;
                  }
                }
              else
                Ti[ja] = ni || 0;
            }), Ti;
          }, Si = qn("row", Se), mi = Vr(), Dr = qf(Si, (xe = {}, fn(xe, "".concat(Si, "-no-wrap"), tn === false), fn(xe, "".concat(Si, "-").concat(Ce), Ce), fn(xe, "".concat(Si, "-").concat(Re), Re), fn(xe, "".concat(Si, "-rtl"), nr === "rtl"), xe), at), Gr = {}, Vi = mi[0] > 0 ? mi[0] / -2 : void 0, ya = mi[1] > 0 ? mi[1] / -2 : void 0;
          if (Vi && (Gr.marginLeft = Vi, Gr.marginRight = Vi), Tt) {
            var xr = _l(mi, 2);
            Gr.rowGap = xr[1];
          } else
            ya && (Gr.marginTop = ya, Gr.marginBottom = ya);
          var Ro = _l(mi, 2), Oo = Ro[0], pi = Ro[1], xs = V.useMemo(function() {
            return { gutter: [Oo, pi], wrap: tn, supportFlexGap: Tt };
          }, [Oo, pi, tn, Tt]);
          return V.createElement($V.Provider, { value: xs }, V.createElement("div", ld({}, Fn, { className: Dr, style: ld(ld({}, Gr), ft), ref: Ge }), st));
        });
        Fle.displayName = "Row";
        var DTe = Fle, Qb = globalThis && globalThis.__rest || function(ye, Ge) {
          var xe = {};
          for (var Se in ye)
            Object.prototype.hasOwnProperty.call(ye, Se) && Ge.indexOf(Se) < 0 && (xe[Se] = ye[Se]);
          if (ye != null && typeof Object.getOwnPropertySymbols == "function")
            for (var Ce = 0, Se = Object.getOwnPropertySymbols(ye); Ce < Se.length; Ce++)
              Ge.indexOf(Se[Ce]) < 0 && Object.prototype.propertyIsEnumerable.call(ye, Se[Ce]) && (xe[Se[Ce]] = ye[Se[Ce]]);
          return xe;
        };
        function kTe(ye) {
          return typeof ye == "number" ? "".concat(ye, " ").concat(ye, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(ye) ? "0 0 ".concat(ye) : ye;
        }
        var YV = ["xs", "sm", "md", "lg", "xl", "xxl"], KV = V.forwardRef(function(ye, Ge) {
          var xe, Se = V.useContext(Gg), Ce = Se.getPrefixCls, Re = Se.direction, at = V.useContext($V), ft = at.gutter, st = at.wrap, Dt = at.supportFlexGap, Pt = ye.prefixCls, tn = ye.span, Fn = ye.order, Un = ye.offset, qn = ye.push, nr = ye.pull, sr = ye.className, Ii = ye.children, gi = ye.flex, Sa = ye.style, Tt = Qb(ye, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), Ar = Ce("col", Pt), Vr = {};
          YV.forEach(function(Vi) {
            var ya, xr = {}, Ro = ye[Vi];
            typeof Ro == "number" ? xr.span = Ro : _s(Ro) === "object" && (xr = Ro || {}), delete Tt[Vi], Vr = ld(ld({}, Vr), (ya = {}, fn(ya, "".concat(Ar, "-").concat(Vi, "-").concat(xr.span), xr.span !== void 0), fn(ya, "".concat(Ar, "-").concat(Vi, "-order-").concat(xr.order), xr.order || xr.order === 0), fn(ya, "".concat(Ar, "-").concat(Vi, "-offset-").concat(xr.offset), xr.offset || xr.offset === 0), fn(ya, "".concat(Ar, "-").concat(Vi, "-push-").concat(xr.push), xr.push || xr.push === 0), fn(ya, "".concat(Ar, "-").concat(Vi, "-pull-").concat(xr.pull), xr.pull || xr.pull === 0), fn(ya, "".concat(Ar, "-rtl"), Re === "rtl"), ya));
          });
          var Si = qf(Ar, (xe = {}, fn(xe, "".concat(Ar, "-").concat(tn), tn !== void 0), fn(xe, "".concat(Ar, "-order-").concat(Fn), Fn), fn(xe, "".concat(Ar, "-offset-").concat(Un), Un), fn(xe, "".concat(Ar, "-push-").concat(qn), qn), fn(xe, "".concat(Ar, "-pull-").concat(nr), nr), xe), sr, Vr), mi = {};
          if (ft && ft[0] > 0) {
            var Dr = ft[0] / 2;
            mi.paddingLeft = Dr, mi.paddingRight = Dr;
          }
          if (ft && ft[1] > 0 && !Dt) {
            var Gr = ft[1] / 2;
            mi.paddingTop = Gr, mi.paddingBottom = Gr;
          }
          return gi && (mi.flex = kTe(gi), st === false && !mi.minWidth && (mi.minWidth = 0)), V.createElement("div", ld({}, Tt, { style: ld(ld({}, mi), Sa), className: Si, ref: Ge }), Ii);
        });
        KV.displayName = "Col";
        var Vle = KV, mY = V.forwardRef(function(ye, Ge) {
          var xe, Se = ye.prefixCls, Ce = Se === void 0 ? "rc-switch" : Se, Re = ye.className, at = ye.checked, ft = ye.defaultChecked, st = ye.disabled, Dt = ye.loadingIcon, Pt = ye.checkedChildren, tn = ye.unCheckedChildren, Fn = ye.onClick, Un = ye.onChange, qn = ye.onKeyDown, nr = Ol(ye, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), sr = hY(false, { value: at, defaultValue: ft }), Ii = _l(sr, 2), gi = Ii[0], Sa = Ii[1];
          function Tt(mi, Dr) {
            var Gr = gi;
            return st || (Gr = mi, Sa(Gr), Un == null || Un(Gr, Dr)), Gr;
          }
          function Ar(mi) {
            mi.which === fl.LEFT ? Tt(false, mi) : mi.which === fl.RIGHT && Tt(true, mi), qn == null || qn(mi);
          }
          function Vr(mi) {
            var Dr = Tt(!gi, mi);
            Fn == null || Fn(Dr, mi);
          }
          var Si = qf(Ce, Re, (xe = {}, fn(xe, "".concat(Ce, "-checked"), gi), fn(xe, "".concat(Ce, "-disabled"), st), xe));
          return V.createElement("button", Object.assign({}, nr, { type: "button", role: "switch", "aria-checked": gi, disabled: st, className: Si, ref: Ge, onKeyDown: Ar, onClick: Vr }), Dt, V.createElement("span", { className: "".concat(Ce, "-inner") }, gi ? Pt : tn));
        });
        mY.displayName = "Switch";
        var rb2 = globalThis && globalThis.__rest || function(ye, Ge) {
          var xe = {};
          for (var Se in ye)
            Object.prototype.hasOwnProperty.call(ye, Se) && Ge.indexOf(Se) < 0 && (xe[Se] = ye[Se]);
          if (ye != null && typeof Object.getOwnPropertySymbols == "function")
            for (var Ce = 0, Se = Object.getOwnPropertySymbols(ye); Ce < Se.length; Ce++)
              Ge.indexOf(Se[Ce]) < 0 && Object.prototype.propertyIsEnumerable.call(ye, Se[Ce]) && (xe[Se[Ce]] = ye[Se[Ce]]);
          return xe;
        }, LS = V.forwardRef(function(ye, Ge) {
          var xe, Se = ye.prefixCls, Ce = ye.size, Re = ye.loading, at = ye.className, ft = at === void 0 ? "" : at, st = ye.disabled, Dt = rb2(ye, ["prefixCls", "size", "loading", "className", "disabled"]);
          mTe("checked" in Dt || !("value" in Dt), "Switch", "`value` is not a valid prop, do you mean `checked`?");
          var Pt = V.useContext(Gg), tn = Pt.getPrefixCls, Fn = Pt.direction, Un = V.useContext(eD), qn = tn("switch", Se), nr = V.createElement("div", { className: "".concat(qn, "-handle") }, Re && V.createElement(NMe, { className: "".concat(qn, "-loading-icon") })), sr = qf((xe = {}, fn(xe, "".concat(qn, "-small"), (Ce || Un) === "small"), fn(xe, "".concat(qn, "-loading"), Re), fn(xe, "".concat(qn, "-rtl"), Fn === "rtl"), xe), ft);
          return V.createElement(dY, { insertExtraNode: true }, V.createElement(mY, ld({}, Dt, { prefixCls: qn, className: sr, disabled: st || Re, ref: Ge, loadingIcon: nr })));
        });
        LS.__ANT_SWITCH = true, LS.displayName = "Switch";
        var bY = LS, Ble = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, ZV = {};
        (function(ye) {
          var Ge = Object.defineProperty, xe = (ge, He, we) => He in ge ? Ge(ge, He, { enumerable: true, configurable: true, writable: true, value: we }) : ge[He] = we, Se = (ge, He, we) => (xe(ge, typeof He != "symbol" ? He + "" : He, we), we);
          Object.defineProperties(ye, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
          var Ce = R.default;
          function Re(ge) {
            return ge && typeof ge == "object" && "default" in ge ? ge : { default: ge };
          }
          function at(ge) {
            if (ge && ge.__esModule)
              return ge;
            var He = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
            return ge && Object.keys(ge).forEach(function(we) {
              if (we !== "default") {
                var Me = Object.getOwnPropertyDescriptor(ge, we);
                Object.defineProperty(He, we, Me.get ? Me : { enumerable: true, get: function() {
                  return ge[we];
                } });
              }
            }), He.default = ge, Object.freeze(He);
          }
          var ft = Re(Ce), st = at(Ce);
          class Dt {
            constructor() {
              Se(this, "chartsEmitters", /* @__PURE__ */ new Map()), Se(this, "add", (He, we, Me, Te) => {
                we && Me ? this.chartsEmitters.set(He, { chart: we, option: Me, title: Te }) : console.log("\u6DFB\u52A0\u5931\u8D25");
              }), Se(this, "get", (He) => this.chartsEmitters.get(He)), Se(this, "clear", () => {
                this.chartsEmitters.clear();
              }), Se(this, "delete", (He) => {
                this.chartsEmitters.delete(He);
              }), Se(this, "list", () => {
                var He, we, Me;
                const Te = [];
                for (const Ne of this.chartsEmitters.keys())
                  Te.push({ id: Ne, chart: (He = this.chartsEmitters.get(Ne)) == null ? void 0 : He.chart, option: (we = this.chartsEmitters.get(Ne)) == null ? void 0 : we.option, title: (Me = this.chartsEmitters.get(Ne)) == null ? void 0 : Me.title });
                return Te;
              });
            }
          }
          const Pt = new Dt();
          var tn = typeof globalThis != "undefined" ? globalThis : typeof window != "undefined" ? window : typeof Z != "undefined" ? Z : typeof self != "undefined" ? self : {};
          function Fn(ge) {
            return ge && ge.__esModule && Object.prototype.hasOwnProperty.call(ge, "default") ? ge.default : ge;
          }
          var Un = { exports: {} };
          /**
          * @license
          * Lodash <https://lodash.com/>
          * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
          * Released under MIT license <https://lodash.com/license>
          * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
          * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
          */
          (function(ge, He) {
            (function() {
              var we, Me = "4.17.21", Te = 200, Ne = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", it = "Expected a function", ht = "Invalid `variable` option passed into `_.template`", xt = "__lodash_hash_undefined__", kt = 500, Lt = "__lodash_placeholder__", sn = 1, Bn = 2, Xn = 4, $n = 1, lr = 2, br = 1, ki = 2, bi = 4, Oa = 8, Ct = 16, dr = 32, Wr = 64, Ci = 128, _i = 256, Pr = 512, $r = 30, Hi = "...", wa = 800, Mr = 16, No = 1, Po = 2, Mi = 3, Is = 1 / 0, Oi = 9007199254740991, ii = 17976931348623157e292, ai = 0 / 0, Ga = 4294967295, Aa = Ga - 1, el = Ga >>> 1, Cc = [["ary", Ci], ["bind", br], ["bindKey", ki], ["curry", Oa], ["curryRight", Ct], ["flip", Pr], ["partial", dr], ["partialRight", Wr], ["rearg", _i]], $u = "[object Arguments]", lu = "[object Array]", Kf = "[object AsyncFunction]", Xu = "[object Boolean]", rf = "[object Date]", Op = "[object DOMException]", dd = "[object Error]", o1 = "[object Function]", r_ = "[object GeneratorFunction]", nv = "[object Map]", Jy = "[object Number]", Fx = "[object Null]", q0 = "[object Object]", Zg = "[object Promise]", i_ = "[object Proxy]", s1 = "[object RegExp]", Xp = "[object Set]", Fd = "[object String]", Lh = "[object Symbol]", Ts = "[object Undefined]", $i = "[object WeakMap]", Kr = "[object WeakSet]", Hr = "[object ArrayBuffer]", ra = "[object DataView]", ao = "[object Float32Array]", ss = "[object Float64Array]", Os = "[object Int8Array]", uu = "[object Int16Array]", bf = "[object Int32Array]", Zh = "[object Uint8Array]", Rh = "[object Uint8ClampedArray]", vd = "[object Uint16Array]", Nh = "[object Uint32Array]", $0 = /\b__p \+= '';/g, Qy = /\b(__p \+=) '' \+/g, rv = /(__e\(.*?\)|\b__t\)) \+\n'';/g, Zf = /&(?:amp|lt|gt|quot|#39);/g, Pp = /[&<>"']/g, Mc = RegExp(Zf.source), Vd = RegExp(Pp.source), Jg = /<%-([\s\S]+?)%>/g, a_ = /<%([\s\S]+?)%>/g, ug = /<%=([\s\S]+?)%>/g, X0 = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, l1 = /^\w*$/, vA = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, KC = /[\\^$.*+?()[\]{}|]/g, tK = RegExp(KC.source), gA = /^\s+/, UB = /\s/, qB = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, nK = /\{\n\/\* \[wrapped with (.+)\] \*/, E6 = /,? & /, ED = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Tn = /[()=,{}\[\]\/\s]/, Ln = /\\(\\)?/g, Xt = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, mn = /\w*$/, Sn = /^[-+]0x[0-9a-f]+$/i, zr = /^0b[01]+$/i, Ai = /^\[object .+?Constructor\]$/, ci = /^0o[0-7]+$/i, kr = /^(?:0|[1-9]\d*)$/, Ca = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, ps = /($^)/, Pu = /['\n\r\u2028\u2029\\]/g, Tc = "\\ud800-\\udfff", Ff = "\\u0300-\\u036f", Mu = "\\ufe20-\\ufe2f", Vf = "\\u20d0-\\u20ff", Lp = Ff + Mu + Vf, Dl = "\\u2700-\\u27bf", Bd = "a-z\\xdf-\\xf6\\xf8-\\xff", em = "\\xac\\xb1\\xd7\\xf7", Vx = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", DD = "\\u2000-\\u206f", o_ = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", yA = "A-Z\\xc0-\\xd6\\xd8-\\xde", ZC = "\\ufe0e\\ufe0f", Dv = em + Vx + DD + o_, XS = "['\u2019]", mA = "[" + Tc + "]", JC = "[" + Dv + "]", kD = "[" + Lp + "]", OD = "\\d+", D6 = "[" + Dl + "]", aO = "[" + Bd + "]", oO = "[^" + Tc + Dv + OD + Dl + Bd + yA + "]", cg = "\\ud83c[\\udffb-\\udfff]", bA = "(?:" + kD + "|" + cg + ")", k6 = "[^" + Tc + "]", rK = "(?:\\ud83c[\\udde6-\\uddff]){2}", $B = "[\\ud800-\\udbff][\\udc00-\\udfff]", sO = "[" + yA + "]", Gle = "\\u200d", Hle = "(?:" + aO + "|" + oO + ")", OTe = "(?:" + sO + "|" + oO + ")", XB = "(?:" + XS + "(?:d|ll|m|re|s|t|ve))?", Wle = "(?:" + XS + "(?:D|LL|M|RE|S|T|VE))?", Ule = bA + "?", qle = "[" + ZC + "]?", PTe = "(?:" + Gle + "(?:" + [k6, rK, $B].join("|") + ")" + qle + Ule + ")*", LTe = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", RTe = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", $le = qle + Ule + PTe, NTe = "(?:" + [D6, rK, $B].join("|") + ")" + $le, FTe = "(?:" + [k6 + kD + "?", kD, rK, $B, mA].join("|") + ")", VTe = RegExp(XS, "g"), BTe = RegExp(kD, "g"), iK = RegExp(cg + "(?=" + cg + ")|" + FTe + $le, "g"), zTe = RegExp([sO + "?" + aO + "+" + XB + "(?=" + [JC, sO, "$"].join("|") + ")", OTe + "+" + Wle + "(?=" + [JC, sO + Hle, "$"].join("|") + ")", sO + "?" + Hle + "+" + XB, sO + "+" + Wle, RTe, LTe, OD, NTe].join("|"), "g"), jTe = RegExp("[" + Gle + Tc + Lp + ZC + "]"), GTe = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, HTe = ["Array", "Buffer", "DataView", "Date", "Error", "Float32Array", "Float64Array", "Function", "Int8Array", "Int16Array", "Int32Array", "Map", "Math", "Object", "Promise", "RegExp", "Set", "String", "Symbol", "TypeError", "Uint8Array", "Uint8ClampedArray", "Uint16Array", "Uint32Array", "WeakMap", "_", "clearTimeout", "isFinite", "parseInt", "setTimeout"], WTe = -1, yp = {};
              yp[ao] = yp[ss] = yp[Os] = yp[uu] = yp[bf] = yp[Zh] = yp[Rh] = yp[vd] = yp[Nh] = true, yp[$u] = yp[lu] = yp[Hr] = yp[Xu] = yp[ra] = yp[rf] = yp[dd] = yp[o1] = yp[nv] = yp[Jy] = yp[q0] = yp[s1] = yp[Xp] = yp[Fd] = yp[$i] = false;
              var Jh = {};
              Jh[$u] = Jh[lu] = Jh[Hr] = Jh[ra] = Jh[Xu] = Jh[rf] = Jh[ao] = Jh[ss] = Jh[Os] = Jh[uu] = Jh[bf] = Jh[nv] = Jh[Jy] = Jh[q0] = Jh[s1] = Jh[Xp] = Jh[Fd] = Jh[Lh] = Jh[Zh] = Jh[Rh] = Jh[vd] = Jh[Nh] = true, Jh[dd] = Jh[o1] = Jh[$i] = false;
              var UTe = { \u00C0: "A", \u00C1: "A", \u00C2: "A", \u00C3: "A", \u00C4: "A", \u00C5: "A", \u00E0: "a", \u00E1: "a", \u00E2: "a", \u00E3: "a", \u00E4: "a", \u00E5: "a", \u00C7: "C", \u00E7: "c", \u00D0: "D", \u00F0: "d", \u00C8: "E", \u00C9: "E", \u00CA: "E", \u00CB: "E", \u00E8: "e", \u00E9: "e", \u00EA: "e", \u00EB: "e", \u00CC: "I", \u00CD: "I", \u00CE: "I", \u00CF: "I", \u00EC: "i", \u00ED: "i", \u00EE: "i", \u00EF: "i", \u00D1: "N", \u00F1: "n", \u00D2: "O", \u00D3: "O", \u00D4: "O", \u00D5: "O", \u00D6: "O", \u00D8: "O", \u00F2: "o", \u00F3: "o", \u00F4: "o", \u00F5: "o", \u00F6: "o", \u00F8: "o", \u00D9: "U", \u00DA: "U", \u00DB: "U", \u00DC: "U", \u00F9: "u", \u00FA: "u", \u00FB: "u", \u00FC: "u", \u00DD: "Y", \u00FD: "y", \u00FF: "y", \u00C6: "Ae", \u00E6: "ae", \u00DE: "Th", \u00FE: "th", \u00DF: "ss", \u0100: "A", \u0102: "A", \u0104: "A", \u0101: "a", \u0103: "a", \u0105: "a", \u0106: "C", \u0108: "C", \u010A: "C", \u010C: "C", \u0107: "c", \u0109: "c", \u010B: "c", \u010D: "c", \u010E: "D", \u0110: "D", \u010F: "d", \u0111: "d", \u0112: "E", \u0114: "E", \u0116: "E", \u0118: "E", \u011A: "E", \u0113: "e", \u0115: "e", \u0117: "e", \u0119: "e", \u011B: "e", \u011C: "G", \u011E: "G", \u0120: "G", \u0122: "G", \u011D: "g", \u011F: "g", \u0121: "g", \u0123: "g", \u0124: "H", \u0126: "H", \u0125: "h", \u0127: "h", \u0128: "I", \u012A: "I", \u012C: "I", \u012E: "I", \u0130: "I", \u0129: "i", \u012B: "i", \u012D: "i", \u012F: "i", \u0131: "i", \u0134: "J", \u0135: "j", \u0136: "K", \u0137: "k", \u0138: "k", \u0139: "L", \u013B: "L", \u013D: "L", \u013F: "L", \u0141: "L", \u013A: "l", \u013C: "l", \u013E: "l", \u0140: "l", \u0142: "l", \u0143: "N", \u0145: "N", \u0147: "N", \u014A: "N", \u0144: "n", \u0146: "n", \u0148: "n", \u014B: "n", \u014C: "O", \u014E: "O", \u0150: "O", \u014D: "o", \u014F: "o", \u0151: "o", \u0154: "R", \u0156: "R", \u0158: "R", \u0155: "r", \u0157: "r", \u0159: "r", \u015A: "S", \u015C: "S", \u015E: "S", \u0160: "S", \u015B: "s", \u015D: "s", \u015F: "s", \u0161: "s", \u0162: "T", \u0164: "T", \u0166: "T", \u0163: "t", \u0165: "t", \u0167: "t", \u0168: "U", \u016A: "U", \u016C: "U", \u016E: "U", \u0170: "U", \u0172: "U", \u0169: "u", \u016B: "u", \u016D: "u", \u016F: "u", \u0171: "u", \u0173: "u", \u0174: "W", \u0175: "w", \u0176: "Y", \u0177: "y", \u0178: "Y", \u0179: "Z", \u017B: "Z", \u017D: "Z", \u017A: "z", \u017C: "z", \u017E: "z", \u0132: "IJ", \u0133: "ij", \u0152: "Oe", \u0153: "oe", \u0149: "'n", \u017F: "s" }, aK = { "&": "&amp;", "<": "&lt;", ">": "&gt;", '"': "&quot;", "'": "&#39;" }, Xle = { "&amp;": "&", "&lt;": "<", "&gt;": ">", "&quot;": '"', "&#39;": "'" }, qTe = { "\\": "\\", "'": "'", "\n": "n", "\r": "r", "\u2028": "u2028", "\u2029": "u2029" }, $Te = parseFloat, XTe = parseInt, Yle = typeof tn == "object" && tn && tn.Object === Object && tn, YTe = typeof self == "object" && self && self.Object === Object && self, Qg = Yle || YTe || Function("return this")(), oK = He && !He.nodeType && He, PD = oK && true && ge && !ge.nodeType && ge, sK = PD && PD.exports === oK, lK = sK && Yle.process, tm = function() {
                try {
                  var wr = PD && PD.require && PD.require("util").types;
                  return wr || lK && lK.binding && lK.binding("util");
                } catch {
                }
              }(), Kle = tm && tm.isArrayBuffer, Zle = tm && tm.isDate, Jle = tm && tm.isMap, Qle = tm && tm.isRegExp, eue = tm && tm.isSet, tue = tm && tm.isTypedArray;
              function cb(wr, Xi, ri) {
                switch (ri.length) {
                  case 0:
                    return wr.call(Xi);
                  case 1:
                    return wr.call(Xi, ri[0]);
                  case 2:
                    return wr.call(Xi, ri[0], ri[1]);
                  case 3:
                    return wr.call(Xi, ri[0], ri[1], ri[2]);
                }
                return wr.apply(Xi, ri);
              }
              function KTe(wr, Xi, ri, ba) {
                for (var Kl = -1, Zl = wr == null ? 0 : wr.length; ++Kl < Zl; ) {
                  var Yu = wr[Kl];
                  Xi(ba, Yu, ri(Yu), wr);
                }
                return ba;
              }
              function s_(wr, Xi) {
                for (var ri = -1, ba = wr == null ? 0 : wr.length; ++ri < ba && Xi(wr[ri], ri, wr) !== false; )
                  ;
                return wr;
              }
              function ZTe(wr, Xi) {
                for (var ri = wr == null ? 0 : wr.length; ri-- && Xi(wr[ri], ri, wr) !== false; )
                  ;
                return wr;
              }
              function nue(wr, Xi) {
                for (var ri = -1, ba = wr == null ? 0 : wr.length; ++ri < ba; )
                  if (!Xi(wr[ri], ri, wr))
                    return false;
                return true;
              }
              function _A(wr, Xi) {
                for (var ri = -1, ba = wr == null ? 0 : wr.length, Kl = 0, Zl = []; ++ri < ba; ) {
                  var Yu = wr[ri];
                  Xi(Yu, ri, wr) && (Zl[Kl++] = Yu);
                }
                return Zl;
              }
              function YB(wr, Xi) {
                var ri = wr == null ? 0 : wr.length;
                return !!ri && lO(wr, Xi, 0) > -1;
              }
              function uK(wr, Xi, ri) {
                for (var ba = -1, Kl = wr == null ? 0 : wr.length; ++ba < Kl; )
                  if (ri(Xi, wr[ba]))
                    return true;
                return false;
              }
              function Rp(wr, Xi) {
                for (var ri = -1, ba = wr == null ? 0 : wr.length, Kl = Array(ba); ++ri < ba; )
                  Kl[ri] = Xi(wr[ri], ri, wr);
                return Kl;
              }
              function xA(wr, Xi) {
                for (var ri = -1, ba = Xi.length, Kl = wr.length; ++ri < ba; )
                  wr[Kl + ri] = Xi[ri];
                return wr;
              }
              function KB(wr, Xi, ri, ba) {
                var Kl = -1, Zl = wr == null ? 0 : wr.length;
                for (ba && Zl && (ri = wr[++Kl]); ++Kl < Zl; )
                  ri = Xi(ri, wr[Kl], Kl, wr);
                return ri;
              }
              function rue(wr, Xi, ri, ba) {
                var Kl = wr == null ? 0 : wr.length;
                for (ba && Kl && (ri = wr[--Kl]); Kl--; )
                  ri = Xi(ri, wr[Kl], Kl, wr);
                return ri;
              }
              function cK(wr, Xi) {
                for (var ri = -1, ba = wr == null ? 0 : wr.length; ++ri < ba; )
                  if (Xi(wr[ri], ri, wr))
                    return true;
                return false;
              }
              var JTe = fK("length");
              function QTe(wr) {
                return wr.split("");
              }
              function eAe(wr) {
                return wr.match(ED) || [];
              }
              function O6(wr, Xi, ri) {
                var ba;
                return ri(wr, function(Kl, Zl, Yu) {
                  if (Xi(Kl, Zl, Yu))
                    return ba = Zl, false;
                }), ba;
              }
              function ZB(wr, Xi, ri, ba) {
                for (var Kl = wr.length, Zl = ri + (ba ? 1 : -1); ba ? Zl-- : ++Zl < Kl; )
                  if (Xi(wr[Zl], Zl, wr))
                    return Zl;
                return -1;
              }
              function lO(wr, Xi, ri) {
                return Xi === Xi ? lAe(wr, Xi, ri) : ZB(wr, iue, ri);
              }
              function tAe(wr, Xi, ri, ba) {
                for (var Kl = ri - 1, Zl = wr.length; ++Kl < Zl; )
                  if (ba(wr[Kl], Xi))
                    return Kl;
                return -1;
              }
              function iue(wr) {
                return wr !== wr;
              }
              function aue(wr, Xi) {
                var ri = wr == null ? 0 : wr.length;
                return ri ? pK(wr, Xi) / ri : ai;
              }
              function fK(wr) {
                return function(Xi) {
                  return Xi == null ? we : Xi[wr];
                };
              }
              function hK(wr) {
                return function(Xi) {
                  return wr == null ? we : wr[Xi];
                };
              }
              function oue(wr, Xi, ri, ba, Kl) {
                return Kl(wr, function(Zl, Yu, Fh) {
                  ri = ba ? (ba = false, Zl) : Xi(ri, Zl, Yu, Fh);
                }), ri;
              }
              function nAe(wr, Xi) {
                var ri = wr.length;
                for (wr.sort(Xi); ri--; )
                  wr[ri] = wr[ri].value;
                return wr;
              }
              function pK(wr, Xi) {
                for (var ri, ba = -1, Kl = wr.length; ++ba < Kl; ) {
                  var Zl = Xi(wr[ba]);
                  Zl !== we && (ri = ri === we ? Zl : ri + Zl);
                }
                return ri;
              }
              function dK(wr, Xi) {
                for (var ri = -1, ba = Array(wr); ++ri < wr; )
                  ba[ri] = Xi(ri);
                return ba;
              }
              function JB(wr, Xi) {
                return Rp(Xi, function(ri) {
                  return [ri, wr[ri]];
                });
              }
              function sue(wr) {
                return wr && wr.slice(0, cue(wr) + 1).replace(gA, "");
              }
              function u1(wr) {
                return function(Xi) {
                  return wr(Xi);
                };
              }
              function QB(wr, Xi) {
                return Rp(Xi, function(ri) {
                  return wr[ri];
                });
              }
              function LD(wr, Xi) {
                return wr.has(Xi);
              }
              function vK(wr, Xi) {
                for (var ri = -1, ba = wr.length; ++ri < ba && lO(Xi, wr[ri], 0) > -1; )
                  ;
                return ri;
              }
              function gK(wr, Xi) {
                for (var ri = wr.length; ri-- && lO(Xi, wr[ri], 0) > -1; )
                  ;
                return ri;
              }
              function lue(wr, Xi) {
                for (var ri = wr.length, ba = 0; ri--; )
                  wr[ri] === Xi && ++ba;
                return ba;
              }
              var uue = hK(UTe), rAe = hK(aK);
              function iAe(wr) {
                return "\\" + qTe[wr];
              }
              function aAe(wr, Xi) {
                return wr == null ? we : wr[Xi];
              }
              function QC(wr) {
                return jTe.test(wr);
              }
              function ez(wr) {
                return GTe.test(wr);
              }
              function oAe(wr) {
                for (var Xi, ri = []; !(Xi = wr.next()).done; )
                  ri.push(Xi.value);
                return ri;
              }
              function yK(wr) {
                var Xi = -1, ri = Array(wr.size);
                return wr.forEach(function(ba, Kl) {
                  ri[++Xi] = [Kl, ba];
                }), ri;
              }
              function tz(wr, Xi) {
                return function(ri) {
                  return wr(Xi(ri));
                };
              }
              function eM(wr, Xi) {
                for (var ri = -1, ba = wr.length, Kl = 0, Zl = []; ++ri < ba; ) {
                  var Yu = wr[ri];
                  (Yu === Xi || Yu === Lt) && (wr[ri] = Lt, Zl[Kl++] = ri);
                }
                return Zl;
              }
              function nz(wr) {
                var Xi = -1, ri = Array(wr.size);
                return wr.forEach(function(ba) {
                  ri[++Xi] = ba;
                }), ri;
              }
              function sAe(wr) {
                var Xi = -1, ri = Array(wr.size);
                return wr.forEach(function(ba) {
                  ri[++Xi] = [ba, ba];
                }), ri;
              }
              function lAe(wr, Xi, ri) {
                for (var ba = ri - 1, Kl = wr.length; ++ba < Kl; )
                  if (wr[ba] === Xi)
                    return ba;
                return -1;
              }
              function uAe(wr, Xi, ri) {
                for (var ba = ri + 1; ba--; )
                  if (wr[ba] === Xi)
                    return ba;
                return ba;
              }
              function uO(wr) {
                return QC(wr) ? fAe(wr) : JTe(wr);
              }
              function Bx(wr) {
                return QC(wr) ? hAe(wr) : QTe(wr);
              }
              function cue(wr) {
                for (var Xi = wr.length; Xi-- && UB.test(wr.charAt(Xi)); )
                  ;
                return Xi;
              }
              var cAe = hK(Xle);
              function fAe(wr) {
                for (var Xi = iK.lastIndex = 0; iK.test(wr); )
                  ++Xi;
                return Xi;
              }
              function hAe(wr) {
                return wr.match(iK) || [];
              }
              function pAe(wr) {
                return wr.match(zTe) || [];
              }
              var dAe = function wr(Xi) {
                Xi = Xi == null ? Qg : Y0.defaults(Qg.Object(), Xi, Y0.pick(Qg, HTe));
                var ri = Xi.Array, ba = Xi.Date, Kl = Xi.Error, Zl = Xi.Function, Yu = Xi.Math, Fh = Xi.Object, YS = Xi.RegExp, vAe = Xi.String, l_ = Xi.TypeError, rz = ri.prototype, gAe = Zl.prototype, cO = Fh.prototype, fO = Xi["__core-js_shared__"], iz = gAe.toString, Ac = cO.hasOwnProperty, fue = 0, P6 = function() {
                  var Y = /[^.]+$/.exec(fO && fO.keys && fO.keys.IE_PROTO || "");
                  return Y ? "Symbol(src)_1." + Y : "";
                }(), Qh = cO.toString, gd = iz.call(Fh), hue = Qg._, yAe = YS("^" + iz.call(Ac).replace(KC, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), az = sK ? Xi.Buffer : we, wA = Xi.Symbol, oz = Xi.Uint8Array, pue = az ? az.allocUnsafe : we, sz = tz(Fh.getPrototypeOf, Fh), mK = Fh.create, hO = cO.propertyIsEnumerable, pO = rz.splice, due = wA ? wA.isConcatSpreadable : we, dO = wA ? wA.iterator : we, KS = wA ? wA.toStringTag : we, K0 = function() {
                  try {
                    var Y = j6(Fh, "defineProperty");
                    return Y({}, "", {}), Y;
                  } catch {
                  }
                }(), vO = Xi.clearTimeout !== Qg.clearTimeout && Xi.clearTimeout, mAe = ba && ba.now !== Qg.Date.now && ba.now, bAe = Xi.setTimeout !== Qg.setTimeout && Xi.setTimeout, lz = Yu.ceil, uz = Yu.floor, bK = Fh.getOwnPropertySymbols, vue = az ? az.isBuffer : we, ZS = Xi.isFinite, Tu = rz.join, gue = tz(Fh.keys, Fh), Bf = Yu.max, e0 = Yu.min, _Ae = ba.now, zf = Xi.parseInt, yue = Yu.random, mue = rz.reverse, gO = j6(Xi, "DataView"), L6 = j6(Xi, "Map"), _K = j6(Xi, "Promise"), yO = j6(Xi, "Set"), R6 = j6(Xi, "WeakMap"), N6 = j6(Fh, "create"), cz = R6 && new R6(), mO = {}, xAe = G6(gO), wAe = G6(L6), SAe = G6(_K), CAe = G6(yO), MAe = G6(R6), fz = wA ? wA.prototype : we, RD = fz ? fz.valueOf : we, bue = fz ? fz.toString : we;
                function qt(Y) {
                  if (iv(Y) && !Iu(Y) && !(Y instanceof qs)) {
                    if (Y instanceof u_)
                      return Y;
                    if (Ac.call(Y, "__wrapped__"))
                      return iet(Y);
                  }
                  return new u_(Y);
                }
                var bO = function() {
                  function Y() {
                  }
                  return function(ue) {
                    if (!zd(ue))
                      return {};
                    if (mK)
                      return mK(ue);
                    Y.prototype = ue;
                    var ke = new Y();
                    return Y.prototype = we, ke;
                  };
                }();
                function hz() {
                }
                function u_(Y, ue) {
                  this.__wrapped__ = Y, this.__actions__ = [], this.__chain__ = !!ue, this.__index__ = 0, this.__values__ = we;
                }
                qt.templateSettings = { escape: Jg, evaluate: a_, interpolate: ug, variable: "", imports: { _: qt } }, qt.prototype = hz.prototype, qt.prototype.constructor = qt, u_.prototype = bO(hz.prototype), u_.prototype.constructor = u_;
                function qs(Y) {
                  this.__wrapped__ = Y, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = false, this.__iteratees__ = [], this.__takeCount__ = Ga, this.__views__ = [];
                }
                function c1() {
                  var Y = new qs(this.__wrapped__);
                  return Y.__actions__ = p_(this.__actions__), Y.__dir__ = this.__dir__, Y.__filtered__ = this.__filtered__, Y.__iteratees__ = p_(this.__iteratees__), Y.__takeCount__ = this.__takeCount__, Y.__views__ = p_(this.__views__), Y;
                }
                function TAe() {
                  if (this.__filtered__) {
                    var Y = new qs(this);
                    Y.__dir__ = -1, Y.__filtered__ = true;
                  } else
                    Y = this.clone(), Y.__dir__ *= -1;
                  return Y;
                }
                function AAe() {
                  var Y = this.__wrapped__.value(), ue = this.__dir__, ke = Iu(Y), ot = ue < 0, Et = ke ? Y.length : 0, on = $en(0, Et, this.__views__), Wn = on.start, rr = on.end, Lr = rr - Wn, va = ot ? rr : Wn - 1, ga = this.__iteratees__, Va = ga.length, Fo = 0, Ds = e0(Lr, this.__takeCount__);
                  if (!ke || !ot && Et == Lr && Ds == Lr)
                    return uc(Y, this.__actions__);
                  var xl = [];
                  e:
                    for (; Lr-- && Fo < Ds; ) {
                      va += ue;
                      for (var cc = -1, wl = Y[va]; ++cc < Va; ) {
                        var Hc = ga[cc], af = Hc.iteratee, Gx = Hc.type, hb = af(wl);
                        if (Gx == Po)
                          wl = hb;
                        else if (!hb) {
                          if (Gx == No)
                            continue e;
                          break e;
                        }
                      }
                      xl[Fo++] = wl;
                    }
                  return xl;
                }
                qs.prototype = bO(hz.prototype), qs.prototype.constructor = qs;
                function ND(Y) {
                  var ue = -1, ke = Y == null ? 0 : Y.length;
                  for (this.clear(); ++ue < ke; ) {
                    var ot = Y[ue];
                    this.set(ot[0], ot[1]);
                  }
                }
                function _ue() {
                  this.__data__ = N6 ? N6(null) : {}, this.size = 0;
                }
                function IAe(Y) {
                  var ue = this.has(Y) && delete this.__data__[Y];
                  return this.size -= ue ? 1 : 0, ue;
                }
                function EAe(Y) {
                  var ue = this.__data__;
                  if (N6) {
                    var ke = ue[Y];
                    return ke === xt ? we : ke;
                  }
                  return Ac.call(ue, Y) ? ue[Y] : we;
                }
                function DAe(Y) {
                  var ue = this.__data__;
                  return N6 ? ue[Y] !== we : Ac.call(ue, Y);
                }
                function xue(Y, ue) {
                  var ke = this.__data__;
                  return this.size += this.has(Y) ? 0 : 1, ke[Y] = N6 && ue === we ? xt : ue, this;
                }
                ND.prototype.clear = _ue, ND.prototype.delete = IAe, ND.prototype.get = EAe, ND.prototype.has = DAe, ND.prototype.set = xue;
                function tM(Y) {
                  var ue = -1, ke = Y == null ? 0 : Y.length;
                  for (this.clear(); ++ue < ke; ) {
                    var ot = Y[ue];
                    this.set(ot[0], ot[1]);
                  }
                }
                function kAe() {
                  this.__data__ = [], this.size = 0;
                }
                function OAe(Y) {
                  var ue = this.__data__, ke = pz(ue, Y);
                  if (ke < 0)
                    return false;
                  var ot = ue.length - 1;
                  return ke == ot ? ue.pop() : pO.call(ue, ke, 1), --this.size, true;
                }
                function wue(Y) {
                  var ue = this.__data__, ke = pz(ue, Y);
                  return ke < 0 ? we : ue[ke][1];
                }
                function Sue(Y) {
                  return pz(this.__data__, Y) > -1;
                }
                function PAe(Y, ue) {
                  var ke = this.__data__, ot = pz(ke, Y);
                  return ot < 0 ? (++this.size, ke.push([Y, ue])) : ke[ot][1] = ue, this;
                }
                tM.prototype.clear = kAe, tM.prototype.delete = OAe, tM.prototype.get = wue, tM.prototype.has = Sue, tM.prototype.set = PAe;
                function nM(Y) {
                  var ue = -1, ke = Y == null ? 0 : Y.length;
                  for (this.clear(); ++ue < ke; ) {
                    var ot = Y[ue];
                    this.set(ot[0], ot[1]);
                  }
                }
                function LAe() {
                  this.size = 0, this.__data__ = { hash: new ND(), map: new (L6 || tM)(), string: new ND() };
                }
                function RAe(Y) {
                  var ue = Kue(this, Y).delete(Y);
                  return this.size -= ue ? 1 : 0, ue;
                }
                function _O(Y) {
                  return Kue(this, Y).get(Y);
                }
                function NAe(Y) {
                  return Kue(this, Y).has(Y);
                }
                function FAe(Y, ue) {
                  var ke = Kue(this, Y), ot = ke.size;
                  return ke.set(Y, ue), this.size += ke.size == ot ? 0 : 1, this;
                }
                nM.prototype.clear = LAe, nM.prototype.delete = RAe, nM.prototype.get = _O, nM.prototype.has = NAe, nM.prototype.set = FAe;
                function FD(Y) {
                  var ue = -1, ke = Y == null ? 0 : Y.length;
                  for (this.__data__ = new nM(); ++ue < ke; )
                    this.add(Y[ue]);
                }
                function VAe(Y) {
                  return this.__data__.set(Y, xt), this;
                }
                function BAe(Y) {
                  return this.__data__.has(Y);
                }
                FD.prototype.add = FD.prototype.push = VAe, FD.prototype.has = BAe;
                function c_(Y) {
                  var ue = this.__data__ = new tM(Y);
                  this.size = ue.size;
                }
                function Cue() {
                  this.__data__ = new tM(), this.size = 0;
                }
                function zAe(Y) {
                  var ue = this.__data__, ke = ue.delete(Y);
                  return this.size = ue.size, ke;
                }
                function jAe(Y) {
                  return this.__data__.get(Y);
                }
                function GAe(Y) {
                  return this.__data__.has(Y);
                }
                function HAe(Y, ue) {
                  var ke = this.__data__;
                  if (ke instanceof tM) {
                    var ot = ke.__data__;
                    if (!L6 || ot.length < Te - 1)
                      return ot.push([Y, ue]), this.size = ++ke.size, this;
                    ke = this.__data__ = new nM(ot);
                  }
                  return ke.set(Y, ue), this.size = ke.size, this;
                }
                c_.prototype.clear = Cue, c_.prototype.delete = zAe, c_.prototype.get = jAe, c_.prototype.has = GAe, c_.prototype.set = HAe;
                function Mue(Y, ue) {
                  var ke = Iu(Y), ot = !ke && H6(Y), Et = !ke && !ot && wO(Y), on = !ke && !ot && !Et && bz(Y), Wn = ke || ot || Et || on, rr = Wn ? dK(Y.length, vAe) : [], Lr = rr.length;
                  for (var va in Y)
                    (ue || Ac.call(Y, va)) && !(Wn && (va == "length" || Et && (va == "offset" || va == "parent") || on && (va == "buffer" || va == "byteLength" || va == "byteOffset") || HD(va, Lr))) && rr.push(va);
                  return rr;
                }
                function Tue(Y) {
                  var ue = Y.length;
                  return ue ? Y[PK(0, ue - 1)] : we;
                }
                function WAe(Y, ue) {
                  return Zue(p_(Y), VD(ue, 0, Y.length));
                }
                function UAe(Y) {
                  return Zue(p_(Y));
                }
                function xK(Y, ue, ke) {
                  (ke !== we && !iM(Y[ue], ke) || ke === we && !(ue in Y)) && rM(Y, ue, ke);
                }
                function F6(Y, ue, ke) {
                  var ot = Y[ue];
                  (!(Ac.call(Y, ue) && iM(ot, ke)) || ke === we && !(ue in Y)) && rM(Y, ue, ke);
                }
                function pz(Y, ue) {
                  for (var ke = Y.length; ke--; )
                    if (iM(Y[ke][0], ue))
                      return ke;
                  return -1;
                }
                function qAe(Y, ue, ke, ot) {
                  return SA(Y, function(Et, on, Wn) {
                    ue(ot, Et, ke(Et), Wn);
                  }), ot;
                }
                function Aue(Y, ue) {
                  return Y && CA(ue, J0(ue), Y);
                }
                function $Ae(Y, ue) {
                  return Y && CA(ue, v_(ue), Y);
                }
                function rM(Y, ue, ke) {
                  ue == "__proto__" && K0 ? K0(Y, ue, { configurable: true, enumerable: true, value: ke, writable: true }) : Y[ue] = ke;
                }
                function wK(Y, ue) {
                  for (var ke = -1, ot = ue.length, Et = ri(ot), on = Y == null; ++ke < ot; )
                    Et[ke] = on ? we : AIe(Y, ue[ke]);
                  return Et;
                }
                function VD(Y, ue, ke) {
                  return Y === Y && (ke !== we && (Y = Y <= ke ? Y : ke), ue !== we && (Y = Y >= ue ? Y : ue)), Y;
                }
                function f_(Y, ue, ke, ot, Et, on) {
                  var Wn, rr = ue & sn, Lr = ue & Bn, va = ue & Xn;
                  if (ke && (Wn = Et ? ke(Y, ot, Et, on) : ke(Y)), Wn !== we)
                    return Wn;
                  if (!zd(Y))
                    return Y;
                  var ga = Iu(Y);
                  if (ga) {
                    if (Wn = Yen(Y), !rr)
                      return p_(Y, Wn);
                  } else {
                    var Va = h1(Y), Fo = Va == o1 || Va == r_;
                    if (wO(Y))
                      return DQe(Y, rr);
                    if (Va == q0 || Va == $u || Fo && !Et) {
                      if (Wn = Lr || Fo ? {} : YQe(Y), !rr)
                        return Lr ? Ven(Y, $Ae(Wn, Y)) : Fen(Y, Aue(Wn, Y));
                    } else {
                      if (!Jh[Va])
                        return Et ? Y : {};
                      Wn = Ken(Y, Va, rr);
                    }
                  }
                  on || (on = new c_());
                  var Ds = on.get(Y);
                  if (Ds)
                    return Ds;
                  on.set(Y, Wn), Tet(Y) ? Y.forEach(function(wl) {
                    Wn.add(f_(wl, ue, ke, wl, Y, on));
                  }) : Cet(Y) && Y.forEach(function(wl, Hc) {
                    Wn.set(Hc, f_(wl, ue, ke, Hc, Y, on));
                  });
                  var xl = va ? Lr ? pIe : hIe : Lr ? v_ : J0, cc = ga ? we : xl(Y);
                  return s_(cc || Y, function(wl, Hc) {
                    cc && (Hc = wl, wl = Y[Hc]), F6(Wn, Hc, f_(wl, ue, ke, Hc, Y, on));
                  }), Wn;
                }
                function XAe(Y) {
                  var ue = J0(Y);
                  return function(ke) {
                    return Iue(ke, Y, ue);
                  };
                }
                function Iue(Y, ue, ke) {
                  var ot = ke.length;
                  if (Y == null)
                    return !ot;
                  for (Y = Fh(Y); ot--; ) {
                    var Et = ke[ot], on = ue[Et], Wn = Y[Et];
                    if (Wn === we && !(Et in Y) || !on(Wn))
                      return false;
                  }
                  return true;
                }
                function Eue(Y, ue, ke) {
                  if (typeof Y != "function")
                    throw new l_(it);
                  return VK(function() {
                    Y.apply(we, ke);
                  }, ue);
                }
                function V6(Y, ue, ke, ot) {
                  var Et = -1, on = YB, Wn = true, rr = Y.length, Lr = [], va = ue.length;
                  if (!rr)
                    return Lr;
                  ke && (ue = Rp(ue, u1(ke))), ot ? (on = uK, Wn = false) : ue.length >= Te && (on = LD, Wn = false, ue = new FD(ue));
                  e:
                    for (; ++Et < rr; ) {
                      var ga = Y[Et], Va = ke == null ? ga : ke(ga);
                      if (ga = ot || ga !== 0 ? ga : 0, Wn && Va === Va) {
                        for (var Fo = va; Fo--; )
                          if (ue[Fo] === Va)
                            continue e;
                        Lr.push(ga);
                      } else
                        on(ue, Va, ot) || Lr.push(ga);
                    }
                  return Lr;
                }
                var SA = RQe(h_), Due = RQe(MK, true);
                function YAe(Y, ue) {
                  var ke = true;
                  return SA(Y, function(ot, Et, on) {
                    return ke = !!ue(ot, Et, on), ke;
                  }), ke;
                }
                function xO(Y, ue, ke) {
                  for (var ot = -1, Et = Y.length; ++ot < Et; ) {
                    var on = Y[ot], Wn = ue(on);
                    if (Wn != null && (rr === we ? Wn === Wn && !jx(Wn) : ke(Wn, rr)))
                      var rr = Wn, Lr = on;
                  }
                  return Lr;
                }
                function kue(Y, ue, ke, ot) {
                  var Et = Y.length;
                  for (ke = Zu(ke), ke < 0 && (ke = -ke > Et ? 0 : Et + ke), ot = ot === we || ot > Et ? Et : Zu(ot), ot < 0 && (ot += Et), ot = ke > ot ? 0 : Iet(ot); ke < ot; )
                    Y[ke++] = ue;
                  return Y;
                }
                function SK(Y, ue) {
                  var ke = [];
                  return SA(Y, function(ot, Et, on) {
                    ue(ot, Et, on) && ke.push(ot);
                  }), ke;
                }
                function t0(Y, ue, ke, ot, Et) {
                  var on = -1, Wn = Y.length;
                  for (ke || (ke = Jen), Et || (Et = []); ++on < Wn; ) {
                    var rr = Y[on];
                    ue > 0 && ke(rr) ? ue > 1 ? t0(rr, ue - 1, ke, ot, Et) : xA(Et, rr) : ot || (Et[Et.length] = rr);
                  }
                  return Et;
                }
                var CK = NQe(), Oue = NQe(true);
                function h_(Y, ue) {
                  return Y && CK(Y, ue, J0);
                }
                function MK(Y, ue) {
                  return Y && Oue(Y, ue, J0);
                }
                function dz(Y, ue) {
                  return _A(ue, function(ke) {
                    return WD(Y[ke]);
                  });
                }
                function BD(Y, ue) {
                  ue = lh(ue, Y);
                  for (var ke = 0, ot = ue.length; Y != null && ke < ot; )
                    Y = Y[MA(ue[ke++])];
                  return ke && ke == ot ? Y : we;
                }
                function nm(Y, ue, ke) {
                  var ot = ue(Y);
                  return Iu(Y) ? ot : xA(ot, ke(Y));
                }
                function n0(Y) {
                  return Y == null ? Y === we ? Ts : Fx : KS && KS in Fh(Y) ? qen(Y) : atn(Y);
                }
                function TK(Y, ue) {
                  return Y > ue;
                }
                function KAe(Y, ue) {
                  return Y != null && Ac.call(Y, ue);
                }
                function ZAe(Y, ue) {
                  return Y != null && ue in Fh(Y);
                }
                function JAe(Y, ue, ke) {
                  return Y >= e0(ue, ke) && Y < Bf(ue, ke);
                }
                function B6(Y, ue, ke) {
                  for (var ot = ke ? uK : YB, Et = Y[0].length, on = Y.length, Wn = on, rr = ri(on), Lr = 1 / 0, va = []; Wn--; ) {
                    var ga = Y[Wn];
                    Wn && ue && (ga = Rp(ga, u1(ue))), Lr = e0(ga.length, Lr), rr[Wn] = !ke && (ue || Et >= 120 && ga.length >= 120) ? new FD(Wn && ga) : we;
                  }
                  ga = Y[0];
                  var Va = -1, Fo = rr[0];
                  e:
                    for (; ++Va < Et && va.length < Lr; ) {
                      var Ds = ga[Va], xl = ue ? ue(Ds) : Ds;
                      if (Ds = ke || Ds !== 0 ? Ds : 0, !(Fo ? LD(Fo, xl) : ot(va, xl, ke))) {
                        for (Wn = on; --Wn; ) {
                          var cc = rr[Wn];
                          if (!(cc ? LD(cc, xl) : ot(Y[Wn], xl, ke)))
                            continue e;
                        }
                        Fo && Fo.push(xl), va.push(Ds);
                      }
                    }
                  return va;
                }
                function QAe(Y, ue, ke, ot) {
                  return h_(Y, function(Et, on, Wn) {
                    ue(ot, ke(Et), on, Wn);
                  }), ot;
                }
                function zD(Y, ue, ke) {
                  ue = lh(ue, Y), Y = QQe(Y, ue);
                  var ot = Y == null ? Y : Y[MA(JS(ue))];
                  return ot == null ? we : cb(ot, Y, ke);
                }
                function Pue(Y) {
                  return iv(Y) && n0(Y) == $u;
                }
                function eIe(Y) {
                  return iv(Y) && n0(Y) == Hr;
                }
                function tIe(Y) {
                  return iv(Y) && n0(Y) == rf;
                }
                function z6(Y, ue, ke, ot, Et) {
                  return Y === ue ? true : Y == null || ue == null || !iv(Y) && !iv(ue) ? Y !== Y && ue !== ue : Lue(Y, ue, ke, ot, z6, Et);
                }
                function Lue(Y, ue, ke, ot, Et, on) {
                  var Wn = Iu(Y), rr = Iu(ue), Lr = Wn ? lu : h1(Y), va = rr ? lu : h1(ue);
                  Lr = Lr == $u ? q0 : Lr, va = va == $u ? q0 : va;
                  var ga = Lr == q0, Va = va == q0, Fo = Lr == va;
                  if (Fo && wO(Y)) {
                    if (!wO(ue))
                      return false;
                    Wn = true, ga = false;
                  }
                  if (Fo && !ga)
                    return on || (on = new c_()), Wn || bz(Y) ? qQe(Y, ue, ke, ot, Et, on) : Wen(Y, ue, Lr, ke, ot, Et, on);
                  if (!(ke & $n)) {
                    var Ds = ga && Ac.call(Y, "__wrapped__"), xl = Va && Ac.call(ue, "__wrapped__");
                    if (Ds || xl) {
                      var cc = Ds ? Y.value() : Y, wl = xl ? ue.value() : ue;
                      return on || (on = new c_()), Et(cc, wl, ke, ot, on);
                    }
                  }
                  return Fo ? (on || (on = new c_()), Uen(Y, ue, ke, ot, Et, on)) : false;
                }
                function nIe(Y) {
                  return iv(Y) && h1(Y) == nv;
                }
                function AK(Y, ue, ke, ot) {
                  var Et = ke.length, on = Et, Wn = !ot;
                  if (Y == null)
                    return !on;
                  for (Y = Fh(Y); Et--; ) {
                    var rr = ke[Et];
                    if (Wn && rr[2] ? rr[1] !== Y[rr[0]] : !(rr[0] in Y))
                      return false;
                  }
                  for (; ++Et < on; ) {
                    rr = ke[Et];
                    var Lr = rr[0], va = Y[Lr], ga = rr[1];
                    if (Wn && rr[2]) {
                      if (va === we && !(Lr in Y))
                        return false;
                    } else {
                      var Va = new c_();
                      if (ot)
                        var Fo = ot(va, ga, Lr, Y, ue, Va);
                      if (!(Fo === we ? z6(ga, va, $n | lr, ot, Va) : Fo))
                        return false;
                    }
                  }
                  return true;
                }
                function Rue(Y) {
                  if (!zd(Y) || etn(Y))
                    return false;
                  var ue = WD(Y) ? yAe : Ai;
                  return ue.test(G6(Y));
                }
                function IK(Y) {
                  return iv(Y) && n0(Y) == s1;
                }
                function EK(Y) {
                  return iv(Y) && h1(Y) == Xp;
                }
                function rIe(Y) {
                  return iv(Y) && rce(Y.length) && !!yp[n0(Y)];
                }
                function Nue(Y) {
                  return typeof Y == "function" ? Y : Y == null ? g_ : typeof Y == "object" ? Iu(Y) ? Bue(Y[0], Y[1]) : Vue(Y) : Bet(Y);
                }
                function DK(Y) {
                  if (!FK(Y))
                    return gue(Y);
                  var ue = [];
                  for (var ke in Fh(Y))
                    Ac.call(Y, ke) && ke != "constructor" && ue.push(ke);
                  return ue;
                }
                function iIe(Y) {
                  if (!zd(Y))
                    return itn(Y);
                  var ue = FK(Y), ke = [];
                  for (var ot in Y)
                    ot == "constructor" && (ue || !Ac.call(Y, ot)) || ke.push(ot);
                  return ke;
                }
                function kK(Y, ue) {
                  return Y < ue;
                }
                function Fue(Y, ue) {
                  var ke = -1, ot = d_(Y) ? ri(Y.length) : [];
                  return SA(Y, function(Et, on, Wn) {
                    ot[++ke] = ue(Et, on, Wn);
                  }), ot;
                }
                function Vue(Y) {
                  var ue = vIe(Y);
                  return ue.length == 1 && ue[0][2] ? ZQe(ue[0][0], ue[0][1]) : function(ke) {
                    return ke === Y || AK(ke, Y, ue);
                  };
                }
                function Bue(Y, ue) {
                  return yIe(Y) && KQe(ue) ? ZQe(MA(Y), ue) : function(ke) {
                    var ot = AIe(ke, Y);
                    return ot === we && ot === ue ? IIe(ke, Y) : z6(ue, ot, $n | lr);
                  };
                }
                function vz(Y, ue, ke, ot, Et) {
                  Y !== ue && CK(ue, function(on, Wn) {
                    if (Et || (Et = new c_()), zd(on))
                      aIe(Y, ue, Wn, ke, vz, ot, Et);
                    else {
                      var rr = ot ? ot(bIe(Y, Wn), on, Wn + "", Y, ue, Et) : we;
                      rr === we && (rr = on), xK(Y, Wn, rr);
                    }
                  }, v_);
                }
                function aIe(Y, ue, ke, ot, Et, on, Wn) {
                  var rr = bIe(Y, ke), Lr = bIe(ue, ke), va = Wn.get(Lr);
                  if (va) {
                    xK(Y, ke, va);
                    return;
                  }
                  var ga = on ? on(rr, Lr, ke + "", Y, ue, Wn) : we, Va = ga === we;
                  if (Va) {
                    var Fo = Iu(Lr), Ds = !Fo && wO(Lr), xl = !Fo && !Ds && bz(Lr);
                    ga = Lr, Fo || Ds || xl ? Iu(rr) ? ga = rr : kv(rr) ? ga = p_(rr) : Ds ? (Va = false, ga = DQe(Lr, true)) : xl ? (Va = false, ga = kQe(Lr, true)) : ga = [] : BK(Lr) || H6(Lr) ? (ga = rr, H6(rr) ? ga = Eet(rr) : (!zd(rr) || WD(rr)) && (ga = YQe(Lr))) : Va = false;
                  }
                  Va && (Wn.set(Lr, ga), Et(ga, Lr, ot, on, Wn), Wn.delete(Lr)), xK(Y, ke, ga);
                }
                function zue(Y, ue) {
                  var ke = Y.length;
                  if (ke)
                    return ue += ue < 0 ? ke : 0, HD(ue, ke) ? Y[ue] : we;
                }
                function jue(Y, ue, ke) {
                  ue.length ? ue = Rp(ue, function(on) {
                    return Iu(on) ? function(Wn) {
                      return BD(Wn, on.length === 1 ? on[0] : on);
                    } : on;
                  }) : ue = [g_];
                  var ot = -1;
                  ue = Rp(ue, u1(vl()));
                  var Et = Fue(Y, function(on, Wn, rr) {
                    var Lr = Rp(ue, function(va) {
                      return va(on);
                    });
                    return { criteria: Lr, index: ++ot, value: on };
                  });
                  return nAe(Et, function(on, Wn) {
                    return Nen(on, Wn, ke);
                  });
                }
                function oIe(Y, ue) {
                  return Gue(Y, ue, function(ke, ot) {
                    return IIe(Y, ot);
                  });
                }
                function Gue(Y, ue, ke) {
                  for (var ot = -1, Et = ue.length, on = {}; ++ot < Et; ) {
                    var Wn = ue[ot], rr = BD(Y, Wn);
                    ke(rr, Wn) && Ae(on, lh(Wn, Y), rr);
                  }
                  return on;
                }
                function sIe(Y) {
                  return function(ue) {
                    return BD(ue, Y);
                  };
                }
                function OK(Y, ue, ke, ot) {
                  var Et = ot ? tAe : lO, on = -1, Wn = ue.length, rr = Y;
                  for (Y === ue && (ue = p_(ue)), ke && (rr = Rp(Y, u1(ke))); ++on < Wn; )
                    for (var Lr = 0, va = ue[on], ga = ke ? ke(va) : va; (Lr = Et(rr, ga, Lr, ot)) > -1; )
                      rr !== Y && pO.call(rr, Lr, 1), pO.call(Y, Lr, 1);
                  return Y;
                }
                function Hue(Y, ue) {
                  for (var ke = Y ? ue.length : 0, ot = ke - 1; ke--; ) {
                    var Et = ue[ke];
                    if (ke == ot || Et !== on) {
                      var on = Et;
                      HD(Et) ? pO.call(Y, Et, 1) : tl(Y, Et);
                    }
                  }
                  return Y;
                }
                function PK(Y, ue) {
                  return Y + uz(yue() * (ue - Y + 1));
                }
                function lIe(Y, ue, ke, ot) {
                  for (var Et = -1, on = Bf(lz((ue - Y) / (ke || 1)), 0), Wn = ri(on); on--; )
                    Wn[ot ? on : ++Et] = Y, Y += ke;
                  return Wn;
                }
                function LK(Y, ue) {
                  var ke = "";
                  if (!Y || ue < 1 || ue > Oi)
                    return ke;
                  do
                    ue % 2 && (ke += Y), ue = uz(ue / 2), ue && (Y += Y);
                  while (ue);
                  return ke;
                }
                function Ku(Y, ue) {
                  return _Ie(JQe(Y, ue, g_), Y + "");
                }
                function X(Y) {
                  return Tue(_z(Y));
                }
                function le(Y, ue) {
                  var ke = _z(Y);
                  return Zue(ke, VD(ue, 0, ke.length));
                }
                function Ae(Y, ue, ke, ot) {
                  if (!zd(Y))
                    return Y;
                  ue = lh(ue, Y);
                  for (var Et = -1, on = ue.length, Wn = on - 1, rr = Y; rr != null && ++Et < on; ) {
                    var Lr = MA(ue[Et]), va = ke;
                    if (Lr === "__proto__" || Lr === "constructor" || Lr === "prototype")
                      return Y;
                    if (Et != Wn) {
                      var ga = rr[Lr];
                      va = ot ? ot(ga, Lr, rr) : we, va === we && (va = zd(ga) ? ga : HD(ue[Et + 1]) ? [] : {});
                    }
                    F6(rr, Lr, va), rr = rr[Lr];
                  }
                  return Y;
                }
                var et = cz ? function(Y, ue) {
                  return cz.set(Y, ue), Y;
                } : g_, It = K0 ? function(Y, ue) {
                  return K0(Y, "toString", { configurable: true, enumerable: false, value: DIe(ue), writable: true });
                } : g_;
                function an(Y) {
                  return Zue(_z(Y));
                }
                function Vn(Y, ue, ke) {
                  var ot = -1, Et = Y.length;
                  ue < 0 && (ue = -ue > Et ? 0 : Et + ue), ke = ke > Et ? Et : ke, ke < 0 && (ke += Et), Et = ue > ke ? 0 : ke - ue >>> 0, ue >>>= 0;
                  for (var on = ri(Et); ++ot < Et; )
                    on[ot] = Y[ot + ue];
                  return on;
                }
                function tr(Y, ue) {
                  var ke;
                  return SA(Y, function(ot, Et, on) {
                    return ke = ue(ot, Et, on), !ke;
                  }), !!ke;
                }
                function Tr(Y, ue, ke) {
                  var ot = 0, Et = Y == null ? ot : Y.length;
                  if (typeof ue == "number" && ue === ue && Et <= el) {
                    for (; ot < Et; ) {
                      var on = ot + Et >>> 1, Wn = Y[on];
                      Wn !== null && !jx(Wn) && (ke ? Wn <= ue : Wn < ue) ? ot = on + 1 : Et = on;
                    }
                    return Et;
                  }
                  return sa(Y, ue, g_, ke);
                }
                function sa(Y, ue, ke, ot) {
                  var Et = 0, on = Y == null ? 0 : Y.length;
                  if (on === 0)
                    return 0;
                  ue = ke(ue);
                  for (var Wn = ue !== ue, rr = ue === null, Lr = jx(ue), va = ue === we; Et < on; ) {
                    var ga = uz((Et + on) / 2), Va = ke(Y[ga]), Fo = Va !== we, Ds = Va === null, xl = Va === Va, cc = jx(Va);
                    if (Wn)
                      var wl = ot || xl;
                    else
                      va ? wl = xl && (ot || Fo) : rr ? wl = xl && Fo && (ot || !Ds) : Lr ? wl = xl && Fo && !Ds && (ot || !cc) : Ds || cc ? wl = false : wl = ot ? Va <= ue : Va < ue;
                    wl ? Et = ga + 1 : on = ga;
                  }
                  return e0(on, Aa);
                }
                function fa(Y, ue) {
                  for (var ke = -1, ot = Y.length, Et = 0, on = []; ++ke < ot; ) {
                    var Wn = Y[ke], rr = ue ? ue(Wn) : Wn;
                    if (!ke || !iM(rr, Lr)) {
                      var Lr = rr;
                      on[Et++] = Wn === 0 ? 0 : Wn;
                    }
                  }
                  return on;
                }
                function Ea(Y) {
                  return typeof Y == "number" ? Y : jx(Y) ? ai : +Y;
                }
                function eo(Y) {
                  if (typeof Y == "string")
                    return Y;
                  if (Iu(Y))
                    return Rp(Y, eo) + "";
                  if (jx(Y))
                    return bue ? bue.call(Y) : "";
                  var ue = Y + "";
                  return ue == "0" && 1 / Y == -Is ? "-0" : ue;
                }
                function ts(Y, ue, ke) {
                  var ot = -1, Et = YB, on = Y.length, Wn = true, rr = [], Lr = rr;
                  if (ke)
                    Wn = false, Et = uK;
                  else if (on >= Te) {
                    var va = ue ? null : Gen(Y);
                    if (va)
                      return nz(va);
                    Wn = false, Et = LD, Lr = new FD();
                  } else
                    Lr = ue ? [] : rr;
                  e:
                    for (; ++ot < on; ) {
                      var ga = Y[ot], Va = ue ? ue(ga) : ga;
                      if (ga = ke || ga !== 0 ? ga : 0, Wn && Va === Va) {
                        for (var Fo = Lr.length; Fo--; )
                          if (Lr[Fo] === Va)
                            continue e;
                        ue && Lr.push(Va), rr.push(ga);
                      } else
                        Et(Lr, Va, ke) || (Lr !== rr && Lr.push(Va), rr.push(ga));
                    }
                  return rr;
                }
                function tl(Y, ue) {
                  return ue = lh(ue, Y), Y = QQe(Y, ue), Y == null || delete Y[MA(JS(ue))];
                }
                function Au(Y, ue, ke, ot) {
                  return Ae(Y, ue, ke(BD(Y, ue)), ot);
                }
                function $s(Y, ue, ke, ot) {
                  for (var Et = Y.length, on = ot ? Et : -1; (ot ? on-- : ++on < Et) && ue(Y[on], on, Y); )
                    ;
                  return ke ? Vn(Y, ot ? 0 : on, ot ? on + 1 : Et) : Vn(Y, ot ? on + 1 : 0, ot ? Et : on);
                }
                function uc(Y, ue) {
                  var ke = Y;
                  return ke instanceof qs && (ke = ke.value()), KB(ue, function(ot, Et) {
                    return Et.func.apply(Et.thisArg, xA([ot], Et.args));
                  }, ke);
                }
                function Ic(Y, ue, ke) {
                  var ot = Y.length;
                  if (ot < 2)
                    return ot ? ts(Y[0]) : [];
                  for (var Et = -1, on = ri(ot); ++Et < ot; )
                    for (var Wn = Y[Et], rr = -1; ++rr < ot; )
                      rr != Et && (on[Et] = V6(on[Et] || Wn, Y[rr], ue, ke));
                  return ts(t0(on, 1), ue, ke);
                }
                function f1(Y, ue, ke) {
                  for (var ot = -1, Et = Y.length, on = ue.length, Wn = {}; ++ot < Et; ) {
                    var rr = ot < on ? ue[ot] : we;
                    ke(Wn, Y[ot], rr);
                  }
                  return Wn;
                }
                function r0(Y) {
                  return kv(Y) ? Y : [];
                }
                function rm(Y) {
                  return typeof Y == "function" ? Y : g_;
                }
                function lh(Y, ue) {
                  return Iu(Y) ? Y : yIe(Y, ue) ? [Y] : ret(uh(Y));
                }
                var zx = Ku;
                function Z0(Y, ue, ke) {
                  var ot = Y.length;
                  return ke = ke === we ? ot : ke, !ue && ke >= ot ? Y : Vn(Y, ue, ke);
                }
                var RK = vO || function(Y) {
                  return Qg.clearTimeout(Y);
                };
                function DQe(Y, ue) {
                  if (ue)
                    return Y.slice();
                  var ke = Y.length, ot = pue ? pue(ke) : new Y.constructor(ke);
                  return Y.copy(ot), ot;
                }
                function uIe(Y) {
                  var ue = new Y.constructor(Y.byteLength);
                  return new oz(ue).set(new oz(Y)), ue;
                }
                function Pen(Y, ue) {
                  var ke = ue ? uIe(Y.buffer) : Y.buffer;
                  return new Y.constructor(ke, Y.byteOffset, Y.byteLength);
                }
                function Len(Y) {
                  var ue = new Y.constructor(Y.source, mn.exec(Y));
                  return ue.lastIndex = Y.lastIndex, ue;
                }
                function Ren(Y) {
                  return RD ? Fh(RD.call(Y)) : {};
                }
                function kQe(Y, ue) {
                  var ke = ue ? uIe(Y.buffer) : Y.buffer;
                  return new Y.constructor(ke, Y.byteOffset, Y.length);
                }
                function OQe(Y, ue) {
                  if (Y !== ue) {
                    var ke = Y !== we, ot = Y === null, Et = Y === Y, on = jx(Y), Wn = ue !== we, rr = ue === null, Lr = ue === ue, va = jx(ue);
                    if (!rr && !va && !on && Y > ue || on && Wn && Lr && !rr && !va || ot && Wn && Lr || !ke && Lr || !Et)
                      return 1;
                    if (!ot && !on && !va && Y < ue || va && ke && Et && !ot && !on || rr && ke && Et || !Wn && Et || !Lr)
                      return -1;
                  }
                  return 0;
                }
                function Nen(Y, ue, ke) {
                  for (var ot = -1, Et = Y.criteria, on = ue.criteria, Wn = Et.length, rr = ke.length; ++ot < Wn; ) {
                    var Lr = OQe(Et[ot], on[ot]);
                    if (Lr) {
                      if (ot >= rr)
                        return Lr;
                      var va = ke[ot];
                      return Lr * (va == "desc" ? -1 : 1);
                    }
                  }
                  return Y.index - ue.index;
                }
                function PQe(Y, ue, ke, ot) {
                  for (var Et = -1, on = Y.length, Wn = ke.length, rr = -1, Lr = ue.length, va = Bf(on - Wn, 0), ga = ri(Lr + va), Va = !ot; ++rr < Lr; )
                    ga[rr] = ue[rr];
                  for (; ++Et < Wn; )
                    (Va || Et < on) && (ga[ke[Et]] = Y[Et]);
                  for (; va--; )
                    ga[rr++] = Y[Et++];
                  return ga;
                }
                function LQe(Y, ue, ke, ot) {
                  for (var Et = -1, on = Y.length, Wn = -1, rr = ke.length, Lr = -1, va = ue.length, ga = Bf(on - rr, 0), Va = ri(ga + va), Fo = !ot; ++Et < ga; )
                    Va[Et] = Y[Et];
                  for (var Ds = Et; ++Lr < va; )
                    Va[Ds + Lr] = ue[Lr];
                  for (; ++Wn < rr; )
                    (Fo || Et < on) && (Va[Ds + ke[Wn]] = Y[Et++]);
                  return Va;
                }
                function p_(Y, ue) {
                  var ke = -1, ot = Y.length;
                  for (ue || (ue = ri(ot)); ++ke < ot; )
                    ue[ke] = Y[ke];
                  return ue;
                }
                function CA(Y, ue, ke, ot) {
                  var Et = !ke;
                  ke || (ke = {});
                  for (var on = -1, Wn = ue.length; ++on < Wn; ) {
                    var rr = ue[on], Lr = ot ? ot(ke[rr], Y[rr], rr, ke, Y) : we;
                    Lr === we && (Lr = Y[rr]), Et ? rM(ke, rr, Lr) : F6(ke, rr, Lr);
                  }
                  return ke;
                }
                function Fen(Y, ue) {
                  return CA(Y, gIe(Y), ue);
                }
                function Ven(Y, ue) {
                  return CA(Y, $Qe(Y), ue);
                }
                function Wue(Y, ue) {
                  return function(ke, ot) {
                    var Et = Iu(ke) ? KTe : qAe, on = ue ? ue() : {};
                    return Et(ke, Y, vl(ot, 2), on);
                  };
                }
                function gz(Y) {
                  return Ku(function(ue, ke) {
                    var ot = -1, Et = ke.length, on = Et > 1 ? ke[Et - 1] : we, Wn = Et > 2 ? ke[2] : we;
                    for (on = Y.length > 3 && typeof on == "function" ? (Et--, on) : we, Wn && fb(ke[0], ke[1], Wn) && (on = Et < 3 ? we : on, Et = 1), ue = Fh(ue); ++ot < Et; ) {
                      var rr = ke[ot];
                      rr && Y(ue, rr, ot, on);
                    }
                    return ue;
                  });
                }
                function RQe(Y, ue) {
                  return function(ke, ot) {
                    if (ke == null)
                      return ke;
                    if (!d_(ke))
                      return Y(ke, ot);
                    for (var Et = ke.length, on = ue ? Et : -1, Wn = Fh(ke); (ue ? on-- : ++on < Et) && ot(Wn[on], on, Wn) !== false; )
                      ;
                    return ke;
                  };
                }
                function NQe(Y) {
                  return function(ue, ke, ot) {
                    for (var Et = -1, on = Fh(ue), Wn = ot(ue), rr = Wn.length; rr--; ) {
                      var Lr = Wn[Y ? rr : ++Et];
                      if (ke(on[Lr], Lr, on) === false)
                        break;
                    }
                    return ue;
                  };
                }
                function Ben(Y, ue, ke) {
                  var ot = ue & br, Et = NK(Y);
                  function on() {
                    var Wn = this && this !== Qg && this instanceof on ? Et : Y;
                    return Wn.apply(ot ? ke : this, arguments);
                  }
                  return on;
                }
                function FQe(Y) {
                  return function(ue) {
                    ue = uh(ue);
                    var ke = QC(ue) ? Bx(ue) : we, ot = ke ? ke[0] : ue.charAt(0), Et = ke ? Z0(ke, 1).join("") : ue.slice(1);
                    return ot[Y]() + Et;
                  };
                }
                function yz(Y) {
                  return function(ue) {
                    return KB(Fet(Net(ue).replace(VTe, "")), Y, "");
                  };
                }
                function NK(Y) {
                  return function() {
                    var ue = arguments;
                    switch (ue.length) {
                      case 0:
                        return new Y();
                      case 1:
                        return new Y(ue[0]);
                      case 2:
                        return new Y(ue[0], ue[1]);
                      case 3:
                        return new Y(ue[0], ue[1], ue[2]);
                      case 4:
                        return new Y(ue[0], ue[1], ue[2], ue[3]);
                      case 5:
                        return new Y(ue[0], ue[1], ue[2], ue[3], ue[4]);
                      case 6:
                        return new Y(ue[0], ue[1], ue[2], ue[3], ue[4], ue[5]);
                      case 7:
                        return new Y(ue[0], ue[1], ue[2], ue[3], ue[4], ue[5], ue[6]);
                    }
                    var ke = bO(Y.prototype), ot = Y.apply(ke, ue);
                    return zd(ot) ? ot : ke;
                  };
                }
                function zen(Y, ue, ke) {
                  var ot = NK(Y);
                  function Et() {
                    for (var on = arguments.length, Wn = ri(on), rr = on, Lr = mz(Et); rr--; )
                      Wn[rr] = arguments[rr];
                    var va = on < 3 && Wn[0] !== Lr && Wn[on - 1] !== Lr ? [] : eM(Wn, Lr);
                    if (on -= va.length, on < ke)
                      return GQe(Y, ue, Uue, Et.placeholder, we, Wn, va, we, we, ke - on);
                    var ga = this && this !== Qg && this instanceof Et ? ot : Y;
                    return cb(ga, this, Wn);
                  }
                  return Et;
                }
                function VQe(Y) {
                  return function(ue, ke, ot) {
                    var Et = Fh(ue);
                    if (!d_(ue)) {
                      var on = vl(ke, 3);
                      ue = J0(ue), ke = function(rr) {
                        return on(Et[rr], rr, Et);
                      };
                    }
                    var Wn = Y(ue, ke, ot);
                    return Wn > -1 ? Et[on ? ue[Wn] : Wn] : we;
                  };
                }
                function BQe(Y) {
                  return GD(function(ue) {
                    var ke = ue.length, ot = ke, Et = u_.prototype.thru;
                    for (Y && ue.reverse(); ot--; ) {
                      var on = ue[ot];
                      if (typeof on != "function")
                        throw new l_(it);
                      if (Et && !Wn && Yue(on) == "wrapper")
                        var Wn = new u_([], true);
                    }
                    for (ot = Wn ? ot : ke; ++ot < ke; ) {
                      on = ue[ot];
                      var rr = Yue(on), Lr = rr == "wrapper" ? dIe(on) : we;
                      Lr && mIe(Lr[0]) && Lr[1] == (Ci | Oa | dr | _i) && !Lr[4].length && Lr[9] == 1 ? Wn = Wn[Yue(Lr[0])].apply(Wn, Lr[3]) : Wn = on.length == 1 && mIe(on) ? Wn[rr]() : Wn.thru(on);
                    }
                    return function() {
                      var va = arguments, ga = va[0];
                      if (Wn && va.length == 1 && Iu(ga))
                        return Wn.plant(ga).value();
                      for (var Va = 0, Fo = ke ? ue[Va].apply(this, va) : ga; ++Va < ke; )
                        Fo = ue[Va].call(this, Fo);
                      return Fo;
                    };
                  });
                }
                function Uue(Y, ue, ke, ot, Et, on, Wn, rr, Lr, va) {
                  var ga = ue & Ci, Va = ue & br, Fo = ue & ki, Ds = ue & (Oa | Ct), xl = ue & Pr, cc = Fo ? we : NK(Y);
                  function wl() {
                    for (var Hc = arguments.length, af = ri(Hc), Gx = Hc; Gx--; )
                      af[Gx] = arguments[Gx];
                    if (Ds)
                      var hb = mz(wl), Hx = lue(af, hb);
                    if (ot && (af = PQe(af, ot, Et, Ds)), on && (af = LQe(af, on, Wn, Ds)), Hc -= Hx, Ds && Hc < va) {
                      var Ov = eM(af, hb);
                      return GQe(Y, ue, Uue, wl.placeholder, ke, af, Ov, rr, Lr, va - Hc);
                    }
                    var aM = Va ? ke : this, qD = Fo ? aM[Y] : Y;
                    return Hc = af.length, rr ? af = otn(af, rr) : xl && Hc > 1 && af.reverse(), ga && Lr < Hc && (af.length = Lr), this && this !== Qg && this instanceof wl && (qD = cc || NK(qD)), qD.apply(aM, af);
                  }
                  return wl;
                }
                function zQe(Y, ue) {
                  return function(ke, ot) {
                    return QAe(ke, Y, ue(ot), {});
                  };
                }
                function que(Y, ue) {
                  return function(ke, ot) {
                    var Et;
                    if (ke === we && ot === we)
                      return ue;
                    if (ke !== we && (Et = ke), ot !== we) {
                      if (Et === we)
                        return ot;
                      typeof ke == "string" || typeof ot == "string" ? (ke = eo(ke), ot = eo(ot)) : (ke = Ea(ke), ot = Ea(ot)), Et = Y(ke, ot);
                    }
                    return Et;
                  };
                }
                function cIe(Y) {
                  return GD(function(ue) {
                    return ue = Rp(ue, u1(vl())), Ku(function(ke) {
                      var ot = this;
                      return Y(ue, function(Et) {
                        return cb(Et, ot, ke);
                      });
                    });
                  });
                }
                function $ue(Y, ue) {
                  ue = ue === we ? " " : eo(ue);
                  var ke = ue.length;
                  if (ke < 2)
                    return ke ? LK(ue, Y) : ue;
                  var ot = LK(ue, lz(Y / uO(ue)));
                  return QC(ue) ? Z0(Bx(ot), 0, Y).join("") : ot.slice(0, Y);
                }
                function jen(Y, ue, ke, ot) {
                  var Et = ue & br, on = NK(Y);
                  function Wn() {
                    for (var rr = -1, Lr = arguments.length, va = -1, ga = ot.length, Va = ri(ga + Lr), Fo = this && this !== Qg && this instanceof Wn ? on : Y; ++va < ga; )
                      Va[va] = ot[va];
                    for (; Lr--; )
                      Va[va++] = arguments[++rr];
                    return cb(Fo, Et ? ke : this, Va);
                  }
                  return Wn;
                }
                function jQe(Y) {
                  return function(ue, ke, ot) {
                    return ot && typeof ot != "number" && fb(ue, ke, ot) && (ke = ot = we), ue = UD(ue), ke === we ? (ke = ue, ue = 0) : ke = UD(ke), ot = ot === we ? ue < ke ? 1 : -1 : UD(ot), lIe(ue, ke, ot, Y);
                  };
                }
                function Xue(Y) {
                  return function(ue, ke) {
                    return typeof ue == "string" && typeof ke == "string" || (ue = QS(ue), ke = QS(ke)), Y(ue, ke);
                  };
                }
                function GQe(Y, ue, ke, ot, Et, on, Wn, rr, Lr, va) {
                  var ga = ue & Oa, Va = ga ? Wn : we, Fo = ga ? we : Wn, Ds = ga ? on : we, xl = ga ? we : on;
                  ue |= ga ? dr : Wr, ue &= ~(ga ? Wr : dr), ue & bi || (ue &= ~(br | ki));
                  var cc = [Y, ue, Et, Ds, Va, xl, Fo, rr, Lr, va], wl = ke.apply(we, cc);
                  return mIe(Y) && eet(wl, cc), wl.placeholder = ot, tet(wl, Y, ue);
                }
                function fIe(Y) {
                  var ue = Yu[Y];
                  return function(ke, ot) {
                    if (ke = QS(ke), ot = ot == null ? 0 : e0(Zu(ot), 292), ot && ZS(ke)) {
                      var Et = (uh(ke) + "e").split("e"), on = ue(Et[0] + "e" + (+Et[1] + ot));
                      return Et = (uh(on) + "e").split("e"), +(Et[0] + "e" + (+Et[1] - ot));
                    }
                    return ue(ke);
                  };
                }
                var Gen = yO && 1 / nz(new yO([, -0]))[1] == Is ? function(Y) {
                  return new yO(Y);
                } : PIe;
                function HQe(Y) {
                  return function(ue) {
                    var ke = h1(ue);
                    return ke == nv ? yK(ue) : ke == Xp ? sAe(ue) : JB(ue, Y(ue));
                  };
                }
                function jD(Y, ue, ke, ot, Et, on, Wn, rr) {
                  var Lr = ue & ki;
                  if (!Lr && typeof Y != "function")
                    throw new l_(it);
                  var va = ot ? ot.length : 0;
                  if (va || (ue &= ~(dr | Wr), ot = Et = we), Wn = Wn === we ? Wn : Bf(Zu(Wn), 0), rr = rr === we ? rr : Zu(rr), va -= Et ? Et.length : 0, ue & Wr) {
                    var ga = ot, Va = Et;
                    ot = Et = we;
                  }
                  var Fo = Lr ? we : dIe(Y), Ds = [Y, ue, ke, ot, Et, ga, Va, on, Wn, rr];
                  if (Fo && rtn(Ds, Fo), Y = Ds[0], ue = Ds[1], ke = Ds[2], ot = Ds[3], Et = Ds[4], rr = Ds[9] = Ds[9] === we ? Lr ? 0 : Y.length : Bf(Ds[9] - va, 0), !rr && ue & (Oa | Ct) && (ue &= ~(Oa | Ct)), !ue || ue == br)
                    var xl = Ben(Y, ue, ke);
                  else
                    ue == Oa || ue == Ct ? xl = zen(Y, ue, rr) : (ue == dr || ue == (br | dr)) && !Et.length ? xl = jen(Y, ue, ke, ot) : xl = Uue.apply(we, Ds);
                  var cc = Fo ? et : eet;
                  return tet(cc(xl, Ds), Y, ue);
                }
                function WQe(Y, ue, ke, ot) {
                  return Y === we || iM(Y, cO[ke]) && !Ac.call(ot, ke) ? ue : Y;
                }
                function UQe(Y, ue, ke, ot, Et, on) {
                  return zd(Y) && zd(ue) && (on.set(ue, Y), vz(Y, ue, we, UQe, on), on.delete(ue)), Y;
                }
                function Hen(Y) {
                  return BK(Y) ? we : Y;
                }
                function qQe(Y, ue, ke, ot, Et, on) {
                  var Wn = ke & $n, rr = Y.length, Lr = ue.length;
                  if (rr != Lr && !(Wn && Lr > rr))
                    return false;
                  var va = on.get(Y), ga = on.get(ue);
                  if (va && ga)
                    return va == ue && ga == Y;
                  var Va = -1, Fo = true, Ds = ke & lr ? new FD() : we;
                  for (on.set(Y, ue), on.set(ue, Y); ++Va < rr; ) {
                    var xl = Y[Va], cc = ue[Va];
                    if (ot)
                      var wl = Wn ? ot(cc, xl, Va, ue, Y, on) : ot(xl, cc, Va, Y, ue, on);
                    if (wl !== we) {
                      if (wl)
                        continue;
                      Fo = false;
                      break;
                    }
                    if (Ds) {
                      if (!cK(ue, function(Hc, af) {
                        if (!LD(Ds, af) && (xl === Hc || Et(xl, Hc, ke, ot, on)))
                          return Ds.push(af);
                      })) {
                        Fo = false;
                        break;
                      }
                    } else if (!(xl === cc || Et(xl, cc, ke, ot, on))) {
                      Fo = false;
                      break;
                    }
                  }
                  return on.delete(Y), on.delete(ue), Fo;
                }
                function Wen(Y, ue, ke, ot, Et, on, Wn) {
                  switch (ke) {
                    case ra:
                      if (Y.byteLength != ue.byteLength || Y.byteOffset != ue.byteOffset)
                        return false;
                      Y = Y.buffer, ue = ue.buffer;
                    case Hr:
                      return !(Y.byteLength != ue.byteLength || !on(new oz(Y), new oz(ue)));
                    case Xu:
                    case rf:
                    case Jy:
                      return iM(+Y, +ue);
                    case dd:
                      return Y.name == ue.name && Y.message == ue.message;
                    case s1:
                    case Fd:
                      return Y == ue + "";
                    case nv:
                      var rr = yK;
                    case Xp:
                      var Lr = ot & $n;
                      if (rr || (rr = nz), Y.size != ue.size && !Lr)
                        return false;
                      var va = Wn.get(Y);
                      if (va)
                        return va == ue;
                      ot |= lr, Wn.set(Y, ue);
                      var ga = qQe(rr(Y), rr(ue), ot, Et, on, Wn);
                      return Wn.delete(Y), ga;
                    case Lh:
                      if (RD)
                        return RD.call(Y) == RD.call(ue);
                  }
                  return false;
                }
                function Uen(Y, ue, ke, ot, Et, on) {
                  var Wn = ke & $n, rr = hIe(Y), Lr = rr.length, va = hIe(ue), ga = va.length;
                  if (Lr != ga && !Wn)
                    return false;
                  for (var Va = Lr; Va--; ) {
                    var Fo = rr[Va];
                    if (!(Wn ? Fo in ue : Ac.call(ue, Fo)))
                      return false;
                  }
                  var Ds = on.get(Y), xl = on.get(ue);
                  if (Ds && xl)
                    return Ds == ue && xl == Y;
                  var cc = true;
                  on.set(Y, ue), on.set(ue, Y);
                  for (var wl = Wn; ++Va < Lr; ) {
                    Fo = rr[Va];
                    var Hc = Y[Fo], af = ue[Fo];
                    if (ot)
                      var Gx = Wn ? ot(af, Hc, Fo, ue, Y, on) : ot(Hc, af, Fo, Y, ue, on);
                    if (!(Gx === we ? Hc === af || Et(Hc, af, ke, ot, on) : Gx)) {
                      cc = false;
                      break;
                    }
                    wl || (wl = Fo == "constructor");
                  }
                  if (cc && !wl) {
                    var hb = Y.constructor, Hx = ue.constructor;
                    hb != Hx && "constructor" in Y && "constructor" in ue && !(typeof hb == "function" && hb instanceof hb && typeof Hx == "function" && Hx instanceof Hx) && (cc = false);
                  }
                  return on.delete(Y), on.delete(ue), cc;
                }
                function GD(Y) {
                  return _Ie(JQe(Y, we, set2), Y + "");
                }
                function hIe(Y) {
                  return nm(Y, J0, gIe);
                }
                function pIe(Y) {
                  return nm(Y, v_, $Qe);
                }
                var dIe = cz ? function(Y) {
                  return cz.get(Y);
                } : PIe;
                function Yue(Y) {
                  for (var ue = Y.name + "", ke = mO[ue], ot = Ac.call(mO, ue) ? ke.length : 0; ot--; ) {
                    var Et = ke[ot], on = Et.func;
                    if (on == null || on == Y)
                      return Et.name;
                  }
                  return ue;
                }
                function mz(Y) {
                  var ue = Ac.call(qt, "placeholder") ? qt : Y;
                  return ue.placeholder;
                }
                function vl() {
                  var Y = qt.iteratee || kIe;
                  return Y = Y === kIe ? Nue : Y, arguments.length ? Y(arguments[0], arguments[1]) : Y;
                }
                function Kue(Y, ue) {
                  var ke = Y.__data__;
                  return Qen(ue) ? ke[typeof ue == "string" ? "string" : "hash"] : ke.map;
                }
                function vIe(Y) {
                  for (var ue = J0(Y), ke = ue.length; ke--; ) {
                    var ot = ue[ke], Et = Y[ot];
                    ue[ke] = [ot, Et, KQe(Et)];
                  }
                  return ue;
                }
                function j6(Y, ue) {
                  var ke = aAe(Y, ue);
                  return Rue(ke) ? ke : we;
                }
                function qen(Y) {
                  var ue = Ac.call(Y, KS), ke = Y[KS];
                  try {
                    Y[KS] = we;
                    var ot = true;
                  } catch {
                  }
                  var Et = Qh.call(Y);
                  return ot && (ue ? Y[KS] = ke : delete Y[KS]), Et;
                }
                var gIe = bK ? function(Y) {
                  return Y == null ? [] : (Y = Fh(Y), _A(bK(Y), function(ue) {
                    return hO.call(Y, ue);
                  }));
                } : LIe, $Qe = bK ? function(Y) {
                  for (var ue = []; Y; )
                    xA(ue, gIe(Y)), Y = sz(Y);
                  return ue;
                } : LIe, h1 = n0;
                (gO && h1(new gO(new ArrayBuffer(1))) != ra || L6 && h1(new L6()) != nv || _K && h1(_K.resolve()) != Zg || yO && h1(new yO()) != Xp || R6 && h1(new R6()) != $i) && (h1 = function(Y) {
                  var ue = n0(Y), ke = ue == q0 ? Y.constructor : we, ot = ke ? G6(ke) : "";
                  if (ot)
                    switch (ot) {
                      case xAe:
                        return ra;
                      case wAe:
                        return nv;
                      case SAe:
                        return Zg;
                      case CAe:
                        return Xp;
                      case MAe:
                        return $i;
                    }
                  return ue;
                });
                function $en(Y, ue, ke) {
                  for (var ot = -1, Et = ke.length; ++ot < Et; ) {
                    var on = ke[ot], Wn = on.size;
                    switch (on.type) {
                      case "drop":
                        Y += Wn;
                        break;
                      case "dropRight":
                        ue -= Wn;
                        break;
                      case "take":
                        ue = e0(ue, Y + Wn);
                        break;
                      case "takeRight":
                        Y = Bf(Y, ue - Wn);
                        break;
                    }
                  }
                  return { start: Y, end: ue };
                }
                function Xen(Y) {
                  var ue = Y.match(nK);
                  return ue ? ue[1].split(E6) : [];
                }
                function XQe(Y, ue, ke) {
                  ue = lh(ue, Y);
                  for (var ot = -1, Et = ue.length, on = false; ++ot < Et; ) {
                    var Wn = MA(ue[ot]);
                    if (!(on = Y != null && ke(Y, Wn)))
                      break;
                    Y = Y[Wn];
                  }
                  return on || ++ot != Et ? on : (Et = Y == null ? 0 : Y.length, !!Et && rce(Et) && HD(Wn, Et) && (Iu(Y) || H6(Y)));
                }
                function Yen(Y) {
                  var ue = Y.length, ke = new Y.constructor(ue);
                  return ue && typeof Y[0] == "string" && Ac.call(Y, "index") && (ke.index = Y.index, ke.input = Y.input), ke;
                }
                function YQe(Y) {
                  return typeof Y.constructor == "function" && !FK(Y) ? bO(sz(Y)) : {};
                }
                function Ken(Y, ue, ke) {
                  var ot = Y.constructor;
                  switch (ue) {
                    case Hr:
                      return uIe(Y);
                    case Xu:
                    case rf:
                      return new ot(+Y);
                    case ra:
                      return Pen(Y, ke);
                    case ao:
                    case ss:
                    case Os:
                    case uu:
                    case bf:
                    case Zh:
                    case Rh:
                    case vd:
                    case Nh:
                      return kQe(Y, ke);
                    case nv:
                      return new ot();
                    case Jy:
                    case Fd:
                      return new ot(Y);
                    case s1:
                      return Len(Y);
                    case Xp:
                      return new ot();
                    case Lh:
                      return Ren(Y);
                  }
                }
                function Zen(Y, ue) {
                  var ke = ue.length;
                  if (!ke)
                    return Y;
                  var ot = ke - 1;
                  return ue[ot] = (ke > 1 ? "& " : "") + ue[ot], ue = ue.join(ke > 2 ? ", " : " "), Y.replace(qB, `{
/* [wrapped with ` + ue + `] */
`);
                }
                function Jen(Y) {
                  return Iu(Y) || H6(Y) || !!(due && Y && Y[due]);
                }
                function HD(Y, ue) {
                  var ke = typeof Y;
                  return ue = ue == null ? Oi : ue, !!ue && (ke == "number" || ke != "symbol" && kr.test(Y)) && Y > -1 && Y % 1 == 0 && Y < ue;
                }
                function fb(Y, ue, ke) {
                  if (!zd(ke))
                    return false;
                  var ot = typeof ue;
                  return (ot == "number" ? d_(ke) && HD(ue, ke.length) : ot == "string" && ue in ke) ? iM(ke[ue], Y) : false;
                }
                function yIe(Y, ue) {
                  if (Iu(Y))
                    return false;
                  var ke = typeof Y;
                  return ke == "number" || ke == "symbol" || ke == "boolean" || Y == null || jx(Y) ? true : l1.test(Y) || !X0.test(Y) || ue != null && Y in Fh(ue);
                }
                function Qen(Y) {
                  var ue = typeof Y;
                  return ue == "string" || ue == "number" || ue == "symbol" || ue == "boolean" ? Y !== "__proto__" : Y === null;
                }
                function mIe(Y) {
                  var ue = Yue(Y), ke = qt[ue];
                  if (typeof ke != "function" || !(ue in qs.prototype))
                    return false;
                  if (Y === ke)
                    return true;
                  var ot = dIe(ke);
                  return !!ot && Y === ot[0];
                }
                function etn(Y) {
                  return !!P6 && P6 in Y;
                }
                var ttn = fO ? WD : RIe;
                function FK(Y) {
                  var ue = Y && Y.constructor, ke = typeof ue == "function" && ue.prototype || cO;
                  return Y === ke;
                }
                function KQe(Y) {
                  return Y === Y && !zd(Y);
                }
                function ZQe(Y, ue) {
                  return function(ke) {
                    return ke == null ? false : ke[Y] === ue && (ue !== we || Y in Fh(ke));
                  };
                }
                function ntn(Y) {
                  var ue = tce(Y, function(ot) {
                    return ke.size === kt && ke.clear(), ot;
                  }), ke = ue.cache;
                  return ue;
                }
                function rtn(Y, ue) {
                  var ke = Y[1], ot = ue[1], Et = ke | ot, on = Et < (br | ki | Ci), Wn = ot == Ci && ke == Oa || ot == Ci && ke == _i && Y[7].length <= ue[8] || ot == (Ci | _i) && ue[7].length <= ue[8] && ke == Oa;
                  if (!(on || Wn))
                    return Y;
                  ot & br && (Y[2] = ue[2], Et |= ke & br ? 0 : bi);
                  var rr = ue[3];
                  if (rr) {
                    var Lr = Y[3];
                    Y[3] = Lr ? PQe(Lr, rr, ue[4]) : rr, Y[4] = Lr ? eM(Y[3], Lt) : ue[4];
                  }
                  return rr = ue[5], rr && (Lr = Y[5], Y[5] = Lr ? LQe(Lr, rr, ue[6]) : rr, Y[6] = Lr ? eM(Y[5], Lt) : ue[6]), rr = ue[7], rr && (Y[7] = rr), ot & Ci && (Y[8] = Y[8] == null ? ue[8] : e0(Y[8], ue[8])), Y[9] == null && (Y[9] = ue[9]), Y[0] = ue[0], Y[1] = Et, Y;
                }
                function itn(Y) {
                  var ue = [];
                  if (Y != null)
                    for (var ke in Fh(Y))
                      ue.push(ke);
                  return ue;
                }
                function atn(Y) {
                  return Qh.call(Y);
                }
                function JQe(Y, ue, ke) {
                  return ue = Bf(ue === we ? Y.length - 1 : ue, 0), function() {
                    for (var ot = arguments, Et = -1, on = Bf(ot.length - ue, 0), Wn = ri(on); ++Et < on; )
                      Wn[Et] = ot[ue + Et];
                    Et = -1;
                    for (var rr = ri(ue + 1); ++Et < ue; )
                      rr[Et] = ot[Et];
                    return rr[ue] = ke(Wn), cb(Y, this, rr);
                  };
                }
                function QQe(Y, ue) {
                  return ue.length < 2 ? Y : BD(Y, Vn(ue, 0, -1));
                }
                function otn(Y, ue) {
                  for (var ke = Y.length, ot = e0(ue.length, ke), Et = p_(Y); ot--; ) {
                    var on = ue[ot];
                    Y[ot] = HD(on, ke) ? Et[on] : we;
                  }
                  return Y;
                }
                function bIe(Y, ue) {
                  if (!(ue === "constructor" && typeof Y[ue] == "function") && ue != "__proto__")
                    return Y[ue];
                }
                var eet = net(et), VK = bAe || function(Y, ue) {
                  return Qg.setTimeout(Y, ue);
                }, _Ie = net(It);
                function tet(Y, ue, ke) {
                  var ot = ue + "";
                  return _Ie(Y, Zen(ot, stn(Xen(ot), ke)));
                }
                function net(Y) {
                  var ue = 0, ke = 0;
                  return function() {
                    var ot = _Ae(), Et = Mr - (ot - ke);
                    if (ke = ot, Et > 0) {
                      if (++ue >= wa)
                        return arguments[0];
                    } else
                      ue = 0;
                    return Y.apply(we, arguments);
                  };
                }
                function Zue(Y, ue) {
                  var ke = -1, ot = Y.length, Et = ot - 1;
                  for (ue = ue === we ? ot : ue; ++ke < ue; ) {
                    var on = PK(ke, Et), Wn = Y[on];
                    Y[on] = Y[ke], Y[ke] = Wn;
                  }
                  return Y.length = ue, Y;
                }
                var ret = ntn(function(Y) {
                  var ue = [];
                  return Y.charCodeAt(0) === 46 && ue.push(""), Y.replace(vA, function(ke, ot, Et, on) {
                    ue.push(Et ? on.replace(Ln, "$1") : ot || ke);
                  }), ue;
                });
                function MA(Y) {
                  if (typeof Y == "string" || jx(Y))
                    return Y;
                  var ue = Y + "";
                  return ue == "0" && 1 / Y == -Is ? "-0" : ue;
                }
                function G6(Y) {
                  if (Y != null) {
                    try {
                      return iz.call(Y);
                    } catch {
                    }
                    try {
                      return Y + "";
                    } catch {
                    }
                  }
                  return "";
                }
                function stn(Y, ue) {
                  return s_(Cc, function(ke) {
                    var ot = "_." + ke[0];
                    ue & ke[1] && !YB(Y, ot) && Y.push(ot);
                  }), Y.sort();
                }
                function iet(Y) {
                  if (Y instanceof qs)
                    return Y.clone();
                  var ue = new u_(Y.__wrapped__, Y.__chain__);
                  return ue.__actions__ = p_(Y.__actions__), ue.__index__ = Y.__index__, ue.__values__ = Y.__values__, ue;
                }
                function ltn(Y, ue, ke) {
                  (ke ? fb(Y, ue, ke) : ue === we) ? ue = 1 : ue = Bf(Zu(ue), 0);
                  var ot = Y == null ? 0 : Y.length;
                  if (!ot || ue < 1)
                    return [];
                  for (var Et = 0, on = 0, Wn = ri(lz(ot / ue)); Et < ot; )
                    Wn[on++] = Vn(Y, Et, Et += ue);
                  return Wn;
                }
                function utn(Y) {
                  for (var ue = -1, ke = Y == null ? 0 : Y.length, ot = 0, Et = []; ++ue < ke; ) {
                    var on = Y[ue];
                    on && (Et[ot++] = on);
                  }
                  return Et;
                }
                function ctn() {
                  var Y = arguments.length;
                  if (!Y)
                    return [];
                  for (var ue = ri(Y - 1), ke = arguments[0], ot = Y; ot--; )
                    ue[ot - 1] = arguments[ot];
                  return xA(Iu(ke) ? p_(ke) : [ke], t0(ue, 1));
                }
                var ftn = Ku(function(Y, ue) {
                  return kv(Y) ? V6(Y, t0(ue, 1, kv, true)) : [];
                }), htn = Ku(function(Y, ue) {
                  var ke = JS(ue);
                  return kv(ke) && (ke = we), kv(Y) ? V6(Y, t0(ue, 1, kv, true), vl(ke, 2)) : [];
                }), ptn = Ku(function(Y, ue) {
                  var ke = JS(ue);
                  return kv(ke) && (ke = we), kv(Y) ? V6(Y, t0(ue, 1, kv, true), we, ke) : [];
                });
                function dtn(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  return ot ? (ue = ke || ue === we ? 1 : Zu(ue), Vn(Y, ue < 0 ? 0 : ue, ot)) : [];
                }
                function vtn(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  return ot ? (ue = ke || ue === we ? 1 : Zu(ue), ue = ot - ue, Vn(Y, 0, ue < 0 ? 0 : ue)) : [];
                }
                function gtn(Y, ue) {
                  return Y && Y.length ? $s(Y, vl(ue, 3), true, true) : [];
                }
                function ytn(Y, ue) {
                  return Y && Y.length ? $s(Y, vl(ue, 3), true) : [];
                }
                function mtn(Y, ue, ke, ot) {
                  var Et = Y == null ? 0 : Y.length;
                  return Et ? (ke && typeof ke != "number" && fb(Y, ue, ke) && (ke = 0, ot = Et), kue(Y, ue, ke, ot)) : [];
                }
                function aet(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  if (!ot)
                    return -1;
                  var Et = ke == null ? 0 : Zu(ke);
                  return Et < 0 && (Et = Bf(ot + Et, 0)), ZB(Y, vl(ue, 3), Et);
                }
                function oet(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  if (!ot)
                    return -1;
                  var Et = ot - 1;
                  return ke !== we && (Et = Zu(ke), Et = ke < 0 ? Bf(ot + Et, 0) : e0(Et, ot - 1)), ZB(Y, vl(ue, 3), Et, true);
                }
                function set2(Y) {
                  var ue = Y == null ? 0 : Y.length;
                  return ue ? t0(Y, 1) : [];
                }
                function btn(Y) {
                  var ue = Y == null ? 0 : Y.length;
                  return ue ? t0(Y, Is) : [];
                }
                function _tn(Y, ue) {
                  var ke = Y == null ? 0 : Y.length;
                  return ke ? (ue = ue === we ? 1 : Zu(ue), t0(Y, ue)) : [];
                }
                function xtn(Y) {
                  for (var ue = -1, ke = Y == null ? 0 : Y.length, ot = {}; ++ue < ke; ) {
                    var Et = Y[ue];
                    ot[Et[0]] = Et[1];
                  }
                  return ot;
                }
                function uet(Y) {
                  return Y && Y.length ? Y[0] : we;
                }
                function wtn(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  if (!ot)
                    return -1;
                  var Et = ke == null ? 0 : Zu(ke);
                  return Et < 0 && (Et = Bf(ot + Et, 0)), lO(Y, ue, Et);
                }
                function Stn(Y) {
                  var ue = Y == null ? 0 : Y.length;
                  return ue ? Vn(Y, 0, -1) : [];
                }
                var Ctn = Ku(function(Y) {
                  var ue = Rp(Y, r0);
                  return ue.length && ue[0] === Y[0] ? B6(ue) : [];
                }), Mtn = Ku(function(Y) {
                  var ue = JS(Y), ke = Rp(Y, r0);
                  return ue === JS(ke) ? ue = we : ke.pop(), ke.length && ke[0] === Y[0] ? B6(ke, vl(ue, 2)) : [];
                }), Ttn = Ku(function(Y) {
                  var ue = JS(Y), ke = Rp(Y, r0);
                  return ue = typeof ue == "function" ? ue : we, ue && ke.pop(), ke.length && ke[0] === Y[0] ? B6(ke, we, ue) : [];
                });
                function Atn(Y, ue) {
                  return Y == null ? "" : Tu.call(Y, ue);
                }
                function JS(Y) {
                  var ue = Y == null ? 0 : Y.length;
                  return ue ? Y[ue - 1] : we;
                }
                function Itn(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  if (!ot)
                    return -1;
                  var Et = ot;
                  return ke !== we && (Et = Zu(ke), Et = Et < 0 ? Bf(ot + Et, 0) : e0(Et, ot - 1)), ue === ue ? uAe(Y, ue, Et) : ZB(Y, iue, Et, true);
                }
                function Etn(Y, ue) {
                  return Y && Y.length ? zue(Y, Zu(ue)) : we;
                }
                var Dtn = Ku(cet);
                function cet(Y, ue) {
                  return Y && Y.length && ue && ue.length ? OK(Y, ue) : Y;
                }
                function ktn(Y, ue, ke) {
                  return Y && Y.length && ue && ue.length ? OK(Y, ue, vl(ke, 2)) : Y;
                }
                function Otn(Y, ue, ke) {
                  return Y && Y.length && ue && ue.length ? OK(Y, ue, we, ke) : Y;
                }
                var Ptn = GD(function(Y, ue) {
                  var ke = Y == null ? 0 : Y.length, ot = wK(Y, ue);
                  return Hue(Y, Rp(ue, function(Et) {
                    return HD(Et, ke) ? +Et : Et;
                  }).sort(OQe)), ot;
                });
                function Ltn(Y, ue) {
                  var ke = [];
                  if (!(Y && Y.length))
                    return ke;
                  var ot = -1, Et = [], on = Y.length;
                  for (ue = vl(ue, 3); ++ot < on; ) {
                    var Wn = Y[ot];
                    ue(Wn, ot, Y) && (ke.push(Wn), Et.push(ot));
                  }
                  return Hue(Y, Et), ke;
                }
                function xIe(Y) {
                  return Y == null ? Y : mue.call(Y);
                }
                function Rtn(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  return ot ? (ke && typeof ke != "number" && fb(Y, ue, ke) ? (ue = 0, ke = ot) : (ue = ue == null ? 0 : Zu(ue), ke = ke === we ? ot : Zu(ke)), Vn(Y, ue, ke)) : [];
                }
                function Ntn(Y, ue) {
                  return Tr(Y, ue);
                }
                function Ftn(Y, ue, ke) {
                  return sa(Y, ue, vl(ke, 2));
                }
                function Vtn(Y, ue) {
                  var ke = Y == null ? 0 : Y.length;
                  if (ke) {
                    var ot = Tr(Y, ue);
                    if (ot < ke && iM(Y[ot], ue))
                      return ot;
                  }
                  return -1;
                }
                function Btn(Y, ue) {
                  return Tr(Y, ue, true);
                }
                function ztn(Y, ue, ke) {
                  return sa(Y, ue, vl(ke, 2), true);
                }
                function jtn(Y, ue) {
                  var ke = Y == null ? 0 : Y.length;
                  if (ke) {
                    var ot = Tr(Y, ue, true) - 1;
                    if (iM(Y[ot], ue))
                      return ot;
                  }
                  return -1;
                }
                function Gtn(Y) {
                  return Y && Y.length ? fa(Y) : [];
                }
                function Htn(Y, ue) {
                  return Y && Y.length ? fa(Y, vl(ue, 2)) : [];
                }
                function Wtn(Y) {
                  var ue = Y == null ? 0 : Y.length;
                  return ue ? Vn(Y, 1, ue) : [];
                }
                function Utn(Y, ue, ke) {
                  return Y && Y.length ? (ue = ke || ue === we ? 1 : Zu(ue), Vn(Y, 0, ue < 0 ? 0 : ue)) : [];
                }
                function qtn(Y, ue, ke) {
                  var ot = Y == null ? 0 : Y.length;
                  return ot ? (ue = ke || ue === we ? 1 : Zu(ue), ue = ot - ue, Vn(Y, ue < 0 ? 0 : ue, ot)) : [];
                }
                function $tn(Y, ue) {
                  return Y && Y.length ? $s(Y, vl(ue, 3), false, true) : [];
                }
                function Xtn(Y, ue) {
                  return Y && Y.length ? $s(Y, vl(ue, 3)) : [];
                }
                var Ytn = Ku(function(Y) {
                  return ts(t0(Y, 1, kv, true));
                }), Ktn = Ku(function(Y) {
                  var ue = JS(Y);
                  return kv(ue) && (ue = we), ts(t0(Y, 1, kv, true), vl(ue, 2));
                }), Ztn = Ku(function(Y) {
                  var ue = JS(Y);
                  return ue = typeof ue == "function" ? ue : we, ts(t0(Y, 1, kv, true), we, ue);
                });
                function Jtn(Y) {
                  return Y && Y.length ? ts(Y) : [];
                }
                function Qtn(Y, ue) {
                  return Y && Y.length ? ts(Y, vl(ue, 2)) : [];
                }
                function enn(Y, ue) {
                  return ue = typeof ue == "function" ? ue : we, Y && Y.length ? ts(Y, we, ue) : [];
                }
                function wIe(Y) {
                  if (!(Y && Y.length))
                    return [];
                  var ue = 0;
                  return Y = _A(Y, function(ke) {
                    if (kv(ke))
                      return ue = Bf(ke.length, ue), true;
                  }), dK(ue, function(ke) {
                    return Rp(Y, fK(ke));
                  });
                }
                function fet(Y, ue) {
                  if (!(Y && Y.length))
                    return [];
                  var ke = wIe(Y);
                  return ue == null ? ke : Rp(ke, function(ot) {
                    return cb(ue, we, ot);
                  });
                }
                var tnn = Ku(function(Y, ue) {
                  return kv(Y) ? V6(Y, ue) : [];
                }), nnn = Ku(function(Y) {
                  return Ic(_A(Y, kv));
                }), rnn = Ku(function(Y) {
                  var ue = JS(Y);
                  return kv(ue) && (ue = we), Ic(_A(Y, kv), vl(ue, 2));
                }), inn = Ku(function(Y) {
                  var ue = JS(Y);
                  return ue = typeof ue == "function" ? ue : we, Ic(_A(Y, kv), we, ue);
                }), ann = Ku(wIe);
                function onn(Y, ue) {
                  return f1(Y || [], ue || [], F6);
                }
                function snn(Y, ue) {
                  return f1(Y || [], ue || [], Ae);
                }
                var lnn = Ku(function(Y) {
                  var ue = Y.length, ke = ue > 1 ? Y[ue - 1] : we;
                  return ke = typeof ke == "function" ? (Y.pop(), ke) : we, fet(Y, ke);
                });
                function het(Y) {
                  var ue = qt(Y);
                  return ue.__chain__ = true, ue;
                }
                function unn(Y, ue) {
                  return ue(Y), Y;
                }
                function Jue(Y, ue) {
                  return ue(Y);
                }
                var cnn = GD(function(Y) {
                  var ue = Y.length, ke = ue ? Y[0] : 0, ot = this.__wrapped__, Et = function(on) {
                    return wK(on, Y);
                  };
                  return ue > 1 || this.__actions__.length || !(ot instanceof qs) || !HD(ke) ? this.thru(Et) : (ot = ot.slice(ke, +ke + (ue ? 1 : 0)), ot.__actions__.push({ func: Jue, args: [Et], thisArg: we }), new u_(ot, this.__chain__).thru(function(on) {
                    return ue && !on.length && on.push(we), on;
                  }));
                });
                function fnn() {
                  return het(this);
                }
                function hnn() {
                  return new u_(this.value(), this.__chain__);
                }
                function pnn() {
                  this.__values__ === we && (this.__values__ = Aet(this.value()));
                  var Y = this.__index__ >= this.__values__.length, ue = Y ? we : this.__values__[this.__index__++];
                  return { done: Y, value: ue };
                }
                function dnn() {
                  return this;
                }
                function vnn(Y) {
                  for (var ue, ke = this; ke instanceof hz; ) {
                    var ot = iet(ke);
                    ot.__index__ = 0, ot.__values__ = we, ue ? Et.__wrapped__ = ot : ue = ot;
                    var Et = ot;
                    ke = ke.__wrapped__;
                  }
                  return Et.__wrapped__ = Y, ue;
                }
                function gnn() {
                  var Y = this.__wrapped__;
                  if (Y instanceof qs) {
                    var ue = Y;
                    return this.__actions__.length && (ue = new qs(this)), ue = ue.reverse(), ue.__actions__.push({ func: Jue, args: [xIe], thisArg: we }), new u_(ue, this.__chain__);
                  }
                  return this.thru(xIe);
                }
                function ynn() {
                  return uc(this.__wrapped__, this.__actions__);
                }
                var mnn = Wue(function(Y, ue, ke) {
                  Ac.call(Y, ke) ? ++Y[ke] : rM(Y, ke, 1);
                });
                function bnn(Y, ue, ke) {
                  var ot = Iu(Y) ? nue : YAe;
                  return ke && fb(Y, ue, ke) && (ue = we), ot(Y, vl(ue, 3));
                }
                function _nn(Y, ue) {
                  var ke = Iu(Y) ? _A : SK;
                  return ke(Y, vl(ue, 3));
                }
                var xnn = VQe(aet), wnn = VQe(oet);
                function Snn(Y, ue) {
                  return t0(Que(Y, ue), 1);
                }
                function Cnn(Y, ue) {
                  return t0(Que(Y, ue), Is);
                }
                function Mnn(Y, ue, ke) {
                  return ke = ke === we ? 1 : Zu(ke), t0(Que(Y, ue), ke);
                }
                function pet(Y, ue) {
                  var ke = Iu(Y) ? s_ : SA;
                  return ke(Y, vl(ue, 3));
                }
                function det(Y, ue) {
                  var ke = Iu(Y) ? ZTe : Due;
                  return ke(Y, vl(ue, 3));
                }
                var Tnn = Wue(function(Y, ue, ke) {
                  Ac.call(Y, ke) ? Y[ke].push(ue) : rM(Y, ke, [ue]);
                });
                function Ann(Y, ue, ke, ot) {
                  Y = d_(Y) ? Y : _z(Y), ke = ke && !ot ? Zu(ke) : 0;
                  var Et = Y.length;
                  return ke < 0 && (ke = Bf(Et + ke, 0)), ice(Y) ? ke <= Et && Y.indexOf(ue, ke) > -1 : !!Et && lO(Y, ue, ke) > -1;
                }
                var Inn = Ku(function(Y, ue, ke) {
                  var ot = -1, Et = typeof ue == "function", on = d_(Y) ? ri(Y.length) : [];
                  return SA(Y, function(Wn) {
                    on[++ot] = Et ? cb(ue, Wn, ke) : zD(Wn, ue, ke);
                  }), on;
                }), Enn = Wue(function(Y, ue, ke) {
                  rM(Y, ke, ue);
                });
                function Que(Y, ue) {
                  var ke = Iu(Y) ? Rp : Fue;
                  return ke(Y, vl(ue, 3));
                }
                function Dnn(Y, ue, ke, ot) {
                  return Y == null ? [] : (Iu(ue) || (ue = ue == null ? [] : [ue]), ke = ot ? we : ke, Iu(ke) || (ke = ke == null ? [] : [ke]), jue(Y, ue, ke));
                }
                var knn = Wue(function(Y, ue, ke) {
                  Y[ke ? 0 : 1].push(ue);
                }, function() {
                  return [[], []];
                });
                function Onn(Y, ue, ke) {
                  var ot = Iu(Y) ? KB : oue, Et = arguments.length < 3;
                  return ot(Y, vl(ue, 4), ke, Et, SA);
                }
                function Pnn(Y, ue, ke) {
                  var ot = Iu(Y) ? rue : oue, Et = arguments.length < 3;
                  return ot(Y, vl(ue, 4), ke, Et, Due);
                }
                function Lnn(Y, ue) {
                  var ke = Iu(Y) ? _A : SK;
                  return ke(Y, nce(vl(ue, 3)));
                }
                function Rnn(Y) {
                  var ue = Iu(Y) ? Tue : X;
                  return ue(Y);
                }
                function Nnn(Y, ue, ke) {
                  (ke ? fb(Y, ue, ke) : ue === we) ? ue = 1 : ue = Zu(ue);
                  var ot = Iu(Y) ? WAe : le;
                  return ot(Y, ue);
                }
                function Fnn(Y) {
                  var ue = Iu(Y) ? UAe : an;
                  return ue(Y);
                }
                function Vnn(Y) {
                  if (Y == null)
                    return 0;
                  if (d_(Y))
                    return ice(Y) ? uO(Y) : Y.length;
                  var ue = h1(Y);
                  return ue == nv || ue == Xp ? Y.size : DK(Y).length;
                }
                function Bnn(Y, ue, ke) {
                  var ot = Iu(Y) ? cK : tr;
                  return ke && fb(Y, ue, ke) && (ue = we), ot(Y, vl(ue, 3));
                }
                var znn = Ku(function(Y, ue) {
                  if (Y == null)
                    return [];
                  var ke = ue.length;
                  return ke > 1 && fb(Y, ue[0], ue[1]) ? ue = [] : ke > 2 && fb(ue[0], ue[1], ue[2]) && (ue = [ue[0]]), jue(Y, t0(ue, 1), []);
                }), ece = mAe || function() {
                  return Qg.Date.now();
                };
                function jnn(Y, ue) {
                  if (typeof ue != "function")
                    throw new l_(it);
                  return Y = Zu(Y), function() {
                    if (--Y < 1)
                      return ue.apply(this, arguments);
                  };
                }
                function vet(Y, ue, ke) {
                  return ue = ke ? we : ue, ue = Y && ue == null ? Y.length : ue, jD(Y, Ci, we, we, we, we, ue);
                }
                function get2(Y, ue) {
                  var ke;
                  if (typeof ue != "function")
                    throw new l_(it);
                  return Y = Zu(Y), function() {
                    return --Y > 0 && (ke = ue.apply(this, arguments)), Y <= 1 && (ue = we), ke;
                  };
                }
                var SIe = Ku(function(Y, ue, ke) {
                  var ot = br;
                  if (ke.length) {
                    var Et = eM(ke, mz(SIe));
                    ot |= dr;
                  }
                  return jD(Y, ot, ue, ke, Et);
                }), yet = Ku(function(Y, ue, ke) {
                  var ot = br | ki;
                  if (ke.length) {
                    var Et = eM(ke, mz(yet));
                    ot |= dr;
                  }
                  return jD(ue, ot, Y, ke, Et);
                });
                function met(Y, ue, ke) {
                  ue = ke ? we : ue;
                  var ot = jD(Y, Oa, we, we, we, we, we, ue);
                  return ot.placeholder = met.placeholder, ot;
                }
                function bet(Y, ue, ke) {
                  ue = ke ? we : ue;
                  var ot = jD(Y, Ct, we, we, we, we, we, ue);
                  return ot.placeholder = bet.placeholder, ot;
                }
                function _et(Y, ue, ke) {
                  var ot, Et, on, Wn, rr, Lr, va = 0, ga = false, Va = false, Fo = true;
                  if (typeof Y != "function")
                    throw new l_(it);
                  ue = QS(ue) || 0, zd(ke) && (ga = !!ke.leading, Va = "maxWait" in ke, on = Va ? Bf(QS(ke.maxWait) || 0, ue) : on, Fo = "trailing" in ke ? !!ke.trailing : Fo);
                  function Ds(Ov) {
                    var aM = ot, qD = Et;
                    return ot = Et = we, va = Ov, Wn = Y.apply(qD, aM), Wn;
                  }
                  function xl(Ov) {
                    return va = Ov, rr = VK(Hc, ue), ga ? Ds(Ov) : Wn;
                  }
                  function cc(Ov) {
                    var aM = Ov - Lr, qD = Ov - va, zet = ue - aM;
                    return Va ? e0(zet, on - qD) : zet;
                  }
                  function wl(Ov) {
                    var aM = Ov - Lr, qD = Ov - va;
                    return Lr === we || aM >= ue || aM < 0 || Va && qD >= on;
                  }
                  function Hc() {
                    var Ov = ece();
                    if (wl(Ov))
                      return af(Ov);
                    rr = VK(Hc, cc(Ov));
                  }
                  function af(Ov) {
                    return rr = we, Fo && ot ? Ds(Ov) : (ot = Et = we, Wn);
                  }
                  function Gx() {
                    rr !== we && RK(rr), va = 0, ot = Lr = Et = rr = we;
                  }
                  function hb() {
                    return rr === we ? Wn : af(ece());
                  }
                  function Hx() {
                    var Ov = ece(), aM = wl(Ov);
                    if (ot = arguments, Et = this, Lr = Ov, aM) {
                      if (rr === we)
                        return xl(Lr);
                      if (Va)
                        return RK(rr), rr = VK(Hc, ue), Ds(Lr);
                    }
                    return rr === we && (rr = VK(Hc, ue)), Wn;
                  }
                  return Hx.cancel = Gx, Hx.flush = hb, Hx;
                }
                var Gnn = Ku(function(Y, ue) {
                  return Eue(Y, 1, ue);
                }), Hnn = Ku(function(Y, ue, ke) {
                  return Eue(Y, QS(ue) || 0, ke);
                });
                function Wnn(Y) {
                  return jD(Y, Pr);
                }
                function tce(Y, ue) {
                  if (typeof Y != "function" || ue != null && typeof ue != "function")
                    throw new l_(it);
                  var ke = function() {
                    var ot = arguments, Et = ue ? ue.apply(this, ot) : ot[0], on = ke.cache;
                    if (on.has(Et))
                      return on.get(Et);
                    var Wn = Y.apply(this, ot);
                    return ke.cache = on.set(Et, Wn) || on, Wn;
                  };
                  return ke.cache = new (tce.Cache || nM)(), ke;
                }
                tce.Cache = nM;
                function nce(Y) {
                  if (typeof Y != "function")
                    throw new l_(it);
                  return function() {
                    var ue = arguments;
                    switch (ue.length) {
                      case 0:
                        return !Y.call(this);
                      case 1:
                        return !Y.call(this, ue[0]);
                      case 2:
                        return !Y.call(this, ue[0], ue[1]);
                      case 3:
                        return !Y.call(this, ue[0], ue[1], ue[2]);
                    }
                    return !Y.apply(this, ue);
                  };
                }
                function Unn(Y) {
                  return get2(2, Y);
                }
                var qnn = zx(function(Y, ue) {
                  ue = ue.length == 1 && Iu(ue[0]) ? Rp(ue[0], u1(vl())) : Rp(t0(ue, 1), u1(vl()));
                  var ke = ue.length;
                  return Ku(function(ot) {
                    for (var Et = -1, on = e0(ot.length, ke); ++Et < on; )
                      ot[Et] = ue[Et].call(this, ot[Et]);
                    return cb(Y, this, ot);
                  });
                }), CIe = Ku(function(Y, ue) {
                  var ke = eM(ue, mz(CIe));
                  return jD(Y, dr, we, ue, ke);
                }), xet = Ku(function(Y, ue) {
                  var ke = eM(ue, mz(xet));
                  return jD(Y, Wr, we, ue, ke);
                }), $nn = GD(function(Y, ue) {
                  return jD(Y, _i, we, we, we, ue);
                });
                function Xnn(Y, ue) {
                  if (typeof Y != "function")
                    throw new l_(it);
                  return ue = ue === we ? ue : Zu(ue), Ku(Y, ue);
                }
                function Ynn(Y, ue) {
                  if (typeof Y != "function")
                    throw new l_(it);
                  return ue = ue == null ? 0 : Bf(Zu(ue), 0), Ku(function(ke) {
                    var ot = ke[ue], Et = Z0(ke, 0, ue);
                    return ot && xA(Et, ot), cb(Y, this, Et);
                  });
                }
                function Knn(Y, ue, ke) {
                  var ot = true, Et = true;
                  if (typeof Y != "function")
                    throw new l_(it);
                  return zd(ke) && (ot = "leading" in ke ? !!ke.leading : ot, Et = "trailing" in ke ? !!ke.trailing : Et), _et(Y, ue, { leading: ot, maxWait: ue, trailing: Et });
                }
                function Znn(Y) {
                  return vet(Y, 1);
                }
                function Jnn(Y, ue) {
                  return CIe(rm(ue), Y);
                }
                function Qnn() {
                  if (!arguments.length)
                    return [];
                  var Y = arguments[0];
                  return Iu(Y) ? Y : [Y];
                }
                function ern(Y) {
                  return f_(Y, Xn);
                }
                function trn(Y, ue) {
                  return ue = typeof ue == "function" ? ue : we, f_(Y, Xn, ue);
                }
                function nrn(Y) {
                  return f_(Y, sn | Xn);
                }
                function rrn(Y, ue) {
                  return ue = typeof ue == "function" ? ue : we, f_(Y, sn | Xn, ue);
                }
                function irn(Y, ue) {
                  return ue == null || Iue(Y, ue, J0(ue));
                }
                function iM(Y, ue) {
                  return Y === ue || Y !== Y && ue !== ue;
                }
                var arn = Xue(TK), orn = Xue(function(Y, ue) {
                  return Y >= ue;
                }), H6 = Pue(function() {
                  return arguments;
                }()) ? Pue : function(Y) {
                  return iv(Y) && Ac.call(Y, "callee") && !hO.call(Y, "callee");
                }, Iu = ri.isArray, srn = Kle ? u1(Kle) : eIe;
                function d_(Y) {
                  return Y != null && rce(Y.length) && !WD(Y);
                }
                function kv(Y) {
                  return iv(Y) && d_(Y);
                }
                function lrn(Y) {
                  return Y === true || Y === false || iv(Y) && n0(Y) == Xu;
                }
                var wO = vue || RIe, urn = Zle ? u1(Zle) : tIe;
                function crn(Y) {
                  return iv(Y) && Y.nodeType === 1 && !BK(Y);
                }
                function frn(Y) {
                  if (Y == null)
                    return true;
                  if (d_(Y) && (Iu(Y) || typeof Y == "string" || typeof Y.splice == "function" || wO(Y) || bz(Y) || H6(Y)))
                    return !Y.length;
                  var ue = h1(Y);
                  if (ue == nv || ue == Xp)
                    return !Y.size;
                  if (FK(Y))
                    return !DK(Y).length;
                  for (var ke in Y)
                    if (Ac.call(Y, ke))
                      return false;
                  return true;
                }
                function hrn(Y, ue) {
                  return z6(Y, ue);
                }
                function prn(Y, ue, ke) {
                  ke = typeof ke == "function" ? ke : we;
                  var ot = ke ? ke(Y, ue) : we;
                  return ot === we ? z6(Y, ue, we, ke) : !!ot;
                }
                function MIe(Y) {
                  if (!iv(Y))
                    return false;
                  var ue = n0(Y);
                  return ue == dd || ue == Op || typeof Y.message == "string" && typeof Y.name == "string" && !BK(Y);
                }
                function drn(Y) {
                  return typeof Y == "number" && ZS(Y);
                }
                function WD(Y) {
                  if (!zd(Y))
                    return false;
                  var ue = n0(Y);
                  return ue == o1 || ue == r_ || ue == Kf || ue == i_;
                }
                function wet(Y) {
                  return typeof Y == "number" && Y == Zu(Y);
                }
                function rce(Y) {
                  return typeof Y == "number" && Y > -1 && Y % 1 == 0 && Y <= Oi;
                }
                function zd(Y) {
                  var ue = typeof Y;
                  return Y != null && (ue == "object" || ue == "function");
                }
                function iv(Y) {
                  return Y != null && typeof Y == "object";
                }
                var Cet = Jle ? u1(Jle) : nIe;
                function vrn(Y, ue) {
                  return Y === ue || AK(Y, ue, vIe(ue));
                }
                function grn(Y, ue, ke) {
                  return ke = typeof ke == "function" ? ke : we, AK(Y, ue, vIe(ue), ke);
                }
                function yrn(Y) {
                  return Met(Y) && Y != +Y;
                }
                function mrn(Y) {
                  if (ttn(Y))
                    throw new Kl(Ne);
                  return Rue(Y);
                }
                function brn(Y) {
                  return Y === null;
                }
                function _rn(Y) {
                  return Y == null;
                }
                function Met(Y) {
                  return typeof Y == "number" || iv(Y) && n0(Y) == Jy;
                }
                function BK(Y) {
                  if (!iv(Y) || n0(Y) != q0)
                    return false;
                  var ue = sz(Y);
                  if (ue === null)
                    return true;
                  var ke = Ac.call(ue, "constructor") && ue.constructor;
                  return typeof ke == "function" && ke instanceof ke && iz.call(ke) == gd;
                }
                var TIe = Qle ? u1(Qle) : IK;
                function xrn(Y) {
                  return wet(Y) && Y >= -Oi && Y <= Oi;
                }
                var Tet = eue ? u1(eue) : EK;
                function ice(Y) {
                  return typeof Y == "string" || !Iu(Y) && iv(Y) && n0(Y) == Fd;
                }
                function jx(Y) {
                  return typeof Y == "symbol" || iv(Y) && n0(Y) == Lh;
                }
                var bz = tue ? u1(tue) : rIe;
                function wrn(Y) {
                  return Y === we;
                }
                function Srn(Y) {
                  return iv(Y) && h1(Y) == $i;
                }
                function Crn(Y) {
                  return iv(Y) && n0(Y) == Kr;
                }
                var Mrn = Xue(kK), Trn = Xue(function(Y, ue) {
                  return Y <= ue;
                });
                function Aet(Y) {
                  if (!Y)
                    return [];
                  if (d_(Y))
                    return ice(Y) ? Bx(Y) : p_(Y);
                  if (dO && Y[dO])
                    return oAe(Y[dO]());
                  var ue = h1(Y), ke = ue == nv ? yK : ue == Xp ? nz : _z;
                  return ke(Y);
                }
                function UD(Y) {
                  if (!Y)
                    return Y === 0 ? Y : 0;
                  if (Y = QS(Y), Y === Is || Y === -Is) {
                    var ue = Y < 0 ? -1 : 1;
                    return ue * ii;
                  }
                  return Y === Y ? Y : 0;
                }
                function Zu(Y) {
                  var ue = UD(Y), ke = ue % 1;
                  return ue === ue ? ke ? ue - ke : ue : 0;
                }
                function Iet(Y) {
                  return Y ? VD(Zu(Y), 0, Ga) : 0;
                }
                function QS(Y) {
                  if (typeof Y == "number")
                    return Y;
                  if (jx(Y))
                    return ai;
                  if (zd(Y)) {
                    var ue = typeof Y.valueOf == "function" ? Y.valueOf() : Y;
                    Y = zd(ue) ? ue + "" : ue;
                  }
                  if (typeof Y != "string")
                    return Y === 0 ? Y : +Y;
                  Y = sue(Y);
                  var ke = zr.test(Y);
                  return ke || ci.test(Y) ? XTe(Y.slice(2), ke ? 2 : 8) : Sn.test(Y) ? ai : +Y;
                }
                function Eet(Y) {
                  return CA(Y, v_(Y));
                }
                function Arn(Y) {
                  return Y ? VD(Zu(Y), -Oi, Oi) : Y === 0 ? Y : 0;
                }
                function uh(Y) {
                  return Y == null ? "" : eo(Y);
                }
                var Irn = gz(function(Y, ue) {
                  if (FK(ue) || d_(ue)) {
                    CA(ue, J0(ue), Y);
                    return;
                  }
                  for (var ke in ue)
                    Ac.call(ue, ke) && F6(Y, ke, ue[ke]);
                }), Det = gz(function(Y, ue) {
                  CA(ue, v_(ue), Y);
                }), ace = gz(function(Y, ue, ke, ot) {
                  CA(ue, v_(ue), Y, ot);
                }), Ern = gz(function(Y, ue, ke, ot) {
                  CA(ue, J0(ue), Y, ot);
                }), Drn = GD(wK);
                function krn(Y, ue) {
                  var ke = bO(Y);
                  return ue == null ? ke : Aue(ke, ue);
                }
                var Orn = Ku(function(Y, ue) {
                  Y = Fh(Y);
                  var ke = -1, ot = ue.length, Et = ot > 2 ? ue[2] : we;
                  for (Et && fb(ue[0], ue[1], Et) && (ot = 1); ++ke < ot; )
                    for (var on = ue[ke], Wn = v_(on), rr = -1, Lr = Wn.length; ++rr < Lr; ) {
                      var va = Wn[rr], ga = Y[va];
                      (ga === we || iM(ga, cO[va]) && !Ac.call(Y, va)) && (Y[va] = on[va]);
                    }
                  return Y;
                }), Prn = Ku(function(Y) {
                  return Y.push(we, UQe), cb(ket, we, Y);
                });
                function Lrn(Y, ue) {
                  return O6(Y, vl(ue, 3), h_);
                }
                function Rrn(Y, ue) {
                  return O6(Y, vl(ue, 3), MK);
                }
                function Nrn(Y, ue) {
                  return Y == null ? Y : CK(Y, vl(ue, 3), v_);
                }
                function Frn(Y, ue) {
                  return Y == null ? Y : Oue(Y, vl(ue, 3), v_);
                }
                function Vrn(Y, ue) {
                  return Y && h_(Y, vl(ue, 3));
                }
                function Brn(Y, ue) {
                  return Y && MK(Y, vl(ue, 3));
                }
                function zrn(Y) {
                  return Y == null ? [] : dz(Y, J0(Y));
                }
                function jrn(Y) {
                  return Y == null ? [] : dz(Y, v_(Y));
                }
                function AIe(Y, ue, ke) {
                  var ot = Y == null ? we : BD(Y, ue);
                  return ot === we ? ke : ot;
                }
                function Grn(Y, ue) {
                  return Y != null && XQe(Y, ue, KAe);
                }
                function IIe(Y, ue) {
                  return Y != null && XQe(Y, ue, ZAe);
                }
                var Hrn = zQe(function(Y, ue, ke) {
                  ue != null && typeof ue.toString != "function" && (ue = Qh.call(ue)), Y[ue] = ke;
                }, DIe(g_)), Wrn = zQe(function(Y, ue, ke) {
                  ue != null && typeof ue.toString != "function" && (ue = Qh.call(ue)), Ac.call(Y, ue) ? Y[ue].push(ke) : Y[ue] = [ke];
                }, vl), Urn = Ku(zD);
                function J0(Y) {
                  return d_(Y) ? Mue(Y) : DK(Y);
                }
                function v_(Y) {
                  return d_(Y) ? Mue(Y, true) : iIe(Y);
                }
                function qrn(Y, ue) {
                  var ke = {};
                  return ue = vl(ue, 3), h_(Y, function(ot, Et, on) {
                    rM(ke, ue(ot, Et, on), ot);
                  }), ke;
                }
                function $rn(Y, ue) {
                  var ke = {};
                  return ue = vl(ue, 3), h_(Y, function(ot, Et, on) {
                    rM(ke, Et, ue(ot, Et, on));
                  }), ke;
                }
                var Xrn = gz(function(Y, ue, ke) {
                  vz(Y, ue, ke);
                }), ket = gz(function(Y, ue, ke, ot) {
                  vz(Y, ue, ke, ot);
                }), Yrn = GD(function(Y, ue) {
                  var ke = {};
                  if (Y == null)
                    return ke;
                  var ot = false;
                  ue = Rp(ue, function(on) {
                    return on = lh(on, Y), ot || (ot = on.length > 1), on;
                  }), CA(Y, pIe(Y), ke), ot && (ke = f_(ke, sn | Bn | Xn, Hen));
                  for (var Et = ue.length; Et--; )
                    tl(ke, ue[Et]);
                  return ke;
                });
                function Krn(Y, ue) {
                  return Oet(Y, nce(vl(ue)));
                }
                var Zrn = GD(function(Y, ue) {
                  return Y == null ? {} : oIe(Y, ue);
                });
                function Oet(Y, ue) {
                  if (Y == null)
                    return {};
                  var ke = Rp(pIe(Y), function(ot) {
                    return [ot];
                  });
                  return ue = vl(ue), Gue(Y, ke, function(ot, Et) {
                    return ue(ot, Et[0]);
                  });
                }
                function Jrn(Y, ue, ke) {
                  ue = lh(ue, Y);
                  var ot = -1, Et = ue.length;
                  for (Et || (Et = 1, Y = we); ++ot < Et; ) {
                    var on = Y == null ? we : Y[MA(ue[ot])];
                    on === we && (ot = Et, on = ke), Y = WD(on) ? on.call(Y) : on;
                  }
                  return Y;
                }
                function Qrn(Y, ue, ke) {
                  return Y == null ? Y : Ae(Y, ue, ke);
                }
                function ein(Y, ue, ke, ot) {
                  return ot = typeof ot == "function" ? ot : we, Y == null ? Y : Ae(Y, ue, ke, ot);
                }
                var Pet = HQe(J0), Let = HQe(v_);
                function tin(Y, ue, ke) {
                  var ot = Iu(Y), Et = ot || wO(Y) || bz(Y);
                  if (ue = vl(ue, 4), ke == null) {
                    var on = Y && Y.constructor;
                    Et ? ke = ot ? new on() : [] : zd(Y) ? ke = WD(on) ? bO(sz(Y)) : {} : ke = {};
                  }
                  return (Et ? s_ : h_)(Y, function(Wn, rr, Lr) {
                    return ue(ke, Wn, rr, Lr);
                  }), ke;
                }
                function nin(Y, ue) {
                  return Y == null ? true : tl(Y, ue);
                }
                function rin(Y, ue, ke) {
                  return Y == null ? Y : Au(Y, ue, rm(ke));
                }
                function iin(Y, ue, ke, ot) {
                  return ot = typeof ot == "function" ? ot : we, Y == null ? Y : Au(Y, ue, rm(ke), ot);
                }
                function _z(Y) {
                  return Y == null ? [] : QB(Y, J0(Y));
                }
                function ain(Y) {
                  return Y == null ? [] : QB(Y, v_(Y));
                }
                function oin(Y, ue, ke) {
                  return ke === we && (ke = ue, ue = we), ke !== we && (ke = QS(ke), ke = ke === ke ? ke : 0), ue !== we && (ue = QS(ue), ue = ue === ue ? ue : 0), VD(QS(Y), ue, ke);
                }
                function sin(Y, ue, ke) {
                  return ue = UD(ue), ke === we ? (ke = ue, ue = 0) : ke = UD(ke), Y = QS(Y), JAe(Y, ue, ke);
                }
                function lin(Y, ue, ke) {
                  if (ke && typeof ke != "boolean" && fb(Y, ue, ke) && (ue = ke = we), ke === we && (typeof ue == "boolean" ? (ke = ue, ue = we) : typeof Y == "boolean" && (ke = Y, Y = we)), Y === we && ue === we ? (Y = 0, ue = 1) : (Y = UD(Y), ue === we ? (ue = Y, Y = 0) : ue = UD(ue)), Y > ue) {
                    var ot = Y;
                    Y = ue, ue = ot;
                  }
                  if (ke || Y % 1 || ue % 1) {
                    var Et = yue();
                    return e0(Y + Et * (ue - Y + $Te("1e-" + ((Et + "").length - 1))), ue);
                  }
                  return PK(Y, ue);
                }
                var uin = yz(function(Y, ue, ke) {
                  return ue = ue.toLowerCase(), Y + (ke ? Ret(ue) : ue);
                });
                function Ret(Y) {
                  return EIe(uh(Y).toLowerCase());
                }
                function Net(Y) {
                  return Y = uh(Y), Y && Y.replace(Ca, uue).replace(BTe, "");
                }
                function cin(Y, ue, ke) {
                  Y = uh(Y), ue = eo(ue);
                  var ot = Y.length;
                  ke = ke === we ? ot : VD(Zu(ke), 0, ot);
                  var Et = ke;
                  return ke -= ue.length, ke >= 0 && Y.slice(ke, Et) == ue;
                }
                function fin(Y) {
                  return Y = uh(Y), Y && Vd.test(Y) ? Y.replace(Pp, rAe) : Y;
                }
                function hin(Y) {
                  return Y = uh(Y), Y && tK.test(Y) ? Y.replace(KC, "\\$&") : Y;
                }
                var pin = yz(function(Y, ue, ke) {
                  return Y + (ke ? "-" : "") + ue.toLowerCase();
                }), din = yz(function(Y, ue, ke) {
                  return Y + (ke ? " " : "") + ue.toLowerCase();
                }), vin = FQe("toLowerCase");
                function gin(Y, ue, ke) {
                  Y = uh(Y), ue = Zu(ue);
                  var ot = ue ? uO(Y) : 0;
                  if (!ue || ot >= ue)
                    return Y;
                  var Et = (ue - ot) / 2;
                  return $ue(uz(Et), ke) + Y + $ue(lz(Et), ke);
                }
                function yin(Y, ue, ke) {
                  Y = uh(Y), ue = Zu(ue);
                  var ot = ue ? uO(Y) : 0;
                  return ue && ot < ue ? Y + $ue(ue - ot, ke) : Y;
                }
                function min3(Y, ue, ke) {
                  Y = uh(Y), ue = Zu(ue);
                  var ot = ue ? uO(Y) : 0;
                  return ue && ot < ue ? $ue(ue - ot, ke) + Y : Y;
                }
                function bin(Y, ue, ke) {
                  return ke || ue == null ? ue = 0 : ue && (ue = +ue), zf(uh(Y).replace(gA, ""), ue || 0);
                }
                function _in(Y, ue, ke) {
                  return (ke ? fb(Y, ue, ke) : ue === we) ? ue = 1 : ue = Zu(ue), LK(uh(Y), ue);
                }
                function xin() {
                  var Y = arguments, ue = uh(Y[0]);
                  return Y.length < 3 ? ue : ue.replace(Y[1], Y[2]);
                }
                var win = yz(function(Y, ue, ke) {
                  return Y + (ke ? "_" : "") + ue.toLowerCase();
                });
                function Sin(Y, ue, ke) {
                  return ke && typeof ke != "number" && fb(Y, ue, ke) && (ue = ke = we), ke = ke === we ? Ga : ke >>> 0, ke ? (Y = uh(Y), Y && (typeof ue == "string" || ue != null && !TIe(ue)) && (ue = eo(ue), !ue && QC(Y)) ? Z0(Bx(Y), 0, ke) : Y.split(ue, ke)) : [];
                }
                var Cin = yz(function(Y, ue, ke) {
                  return Y + (ke ? " " : "") + EIe(ue);
                });
                function Min(Y, ue, ke) {
                  return Y = uh(Y), ke = ke == null ? 0 : VD(Zu(ke), 0, Y.length), ue = eo(ue), Y.slice(ke, ke + ue.length) == ue;
                }
                function Tin(Y, ue, ke) {
                  var ot = qt.templateSettings;
                  ke && fb(Y, ue, ke) && (ue = we), Y = uh(Y), ue = ace({}, ue, ot, WQe);
                  var Et = ace({}, ue.imports, ot.imports, WQe), on = J0(Et), Wn = QB(Et, on), rr, Lr, va = 0, ga = ue.interpolate || ps, Va = "__p += '", Fo = YS((ue.escape || ps).source + "|" + ga.source + "|" + (ga === ug ? Xt : ps).source + "|" + (ue.evaluate || ps).source + "|$", "g"), Ds = "//# sourceURL=" + (Ac.call(ue, "sourceURL") ? (ue.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++WTe + "]") + `
`;
                  Y.replace(Fo, function(wl, Hc, af, Gx, hb, Hx) {
                    return af || (af = Gx), Va += Y.slice(va, Hx).replace(Pu, iAe), Hc && (rr = true, Va += `' +
__e(` + Hc + `) +
'`), hb && (Lr = true, Va += `';
` + hb + `;
__p += '`), af && (Va += `' +
((__t = (` + af + `)) == null ? '' : __t) +
'`), va = Hx + wl.length, wl;
                  }), Va += `';
`;
                  var xl = Ac.call(ue, "variable") && ue.variable;
                  if (!xl)
                    Va = `with (obj) {
` + Va + `
}
`;
                  else if (Tn.test(xl))
                    throw new Kl(ht);
                  Va = (Lr ? Va.replace($0, "") : Va).replace(Qy, "$1").replace(rv, "$1;"), Va = "function(" + (xl || "obj") + `) {
` + (xl ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (rr ? ", __e = _.escape" : "") + (Lr ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + Va + `return __p
}`;
                  var cc = Vet(function() {
                    return Zl(on, Ds + "return " + Va).apply(we, Wn);
                  });
                  if (cc.source = Va, MIe(cc))
                    throw cc;
                  return cc;
                }
                function Ain(Y) {
                  return uh(Y).toLowerCase();
                }
                function Iin(Y) {
                  return uh(Y).toUpperCase();
                }
                function Ein(Y, ue, ke) {
                  if (Y = uh(Y), Y && (ke || ue === we))
                    return sue(Y);
                  if (!Y || !(ue = eo(ue)))
                    return Y;
                  var ot = Bx(Y), Et = Bx(ue), on = vK(ot, Et), Wn = gK(ot, Et) + 1;
                  return Z0(ot, on, Wn).join("");
                }
                function Din(Y, ue, ke) {
                  if (Y = uh(Y), Y && (ke || ue === we))
                    return Y.slice(0, cue(Y) + 1);
                  if (!Y || !(ue = eo(ue)))
                    return Y;
                  var ot = Bx(Y), Et = gK(ot, Bx(ue)) + 1;
                  return Z0(ot, 0, Et).join("");
                }
                function kin(Y, ue, ke) {
                  if (Y = uh(Y), Y && (ke || ue === we))
                    return Y.replace(gA, "");
                  if (!Y || !(ue = eo(ue)))
                    return Y;
                  var ot = Bx(Y), Et = vK(ot, Bx(ue));
                  return Z0(ot, Et).join("");
                }
                function Oin(Y, ue) {
                  var ke = $r, ot = Hi;
                  if (zd(ue)) {
                    var Et = "separator" in ue ? ue.separator : Et;
                    ke = "length" in ue ? Zu(ue.length) : ke, ot = "omission" in ue ? eo(ue.omission) : ot;
                  }
                  Y = uh(Y);
                  var on = Y.length;
                  if (QC(Y)) {
                    var Wn = Bx(Y);
                    on = Wn.length;
                  }
                  if (ke >= on)
                    return Y;
                  var rr = ke - uO(ot);
                  if (rr < 1)
                    return ot;
                  var Lr = Wn ? Z0(Wn, 0, rr).join("") : Y.slice(0, rr);
                  if (Et === we)
                    return Lr + ot;
                  if (Wn && (rr += Lr.length - rr), TIe(Et)) {
                    if (Y.slice(rr).search(Et)) {
                      var va, ga = Lr;
                      for (Et.global || (Et = YS(Et.source, uh(mn.exec(Et)) + "g")), Et.lastIndex = 0; va = Et.exec(ga); )
                        var Va = va.index;
                      Lr = Lr.slice(0, Va === we ? rr : Va);
                    }
                  } else if (Y.indexOf(eo(Et), rr) != rr) {
                    var Fo = Lr.lastIndexOf(Et);
                    Fo > -1 && (Lr = Lr.slice(0, Fo));
                  }
                  return Lr + ot;
                }
                function Pin2(Y) {
                  return Y = uh(Y), Y && Mc.test(Y) ? Y.replace(Zf, cAe) : Y;
                }
                var Lin = yz(function(Y, ue, ke) {
                  return Y + (ke ? " " : "") + ue.toUpperCase();
                }), EIe = FQe("toUpperCase");
                function Fet(Y, ue, ke) {
                  return Y = uh(Y), ue = ke ? we : ue, ue === we ? ez(Y) ? pAe(Y) : eAe(Y) : Y.match(ue) || [];
                }
                var Vet = Ku(function(Y, ue) {
                  try {
                    return cb(Y, we, ue);
                  } catch (ke) {
                    return MIe(ke) ? ke : new Kl(ke);
                  }
                }), Rin = GD(function(Y, ue) {
                  return s_(ue, function(ke) {
                    ke = MA(ke), rM(Y, ke, SIe(Y[ke], Y));
                  }), Y;
                });
                function Nin(Y) {
                  var ue = Y == null ? 0 : Y.length, ke = vl();
                  return Y = ue ? Rp(Y, function(ot) {
                    if (typeof ot[1] != "function")
                      throw new l_(it);
                    return [ke(ot[0]), ot[1]];
                  }) : [], Ku(function(ot) {
                    for (var Et = -1; ++Et < ue; ) {
                      var on = Y[Et];
                      if (cb(on[0], this, ot))
                        return cb(on[1], this, ot);
                    }
                  });
                }
                function Fin(Y) {
                  return XAe(f_(Y, sn));
                }
                function DIe(Y) {
                  return function() {
                    return Y;
                  };
                }
                function Vin(Y, ue) {
                  return Y == null || Y !== Y ? ue : Y;
                }
                var Bin = BQe(), zin = BQe(true);
                function g_(Y) {
                  return Y;
                }
                function kIe(Y) {
                  return Nue(typeof Y == "function" ? Y : f_(Y, sn));
                }
                function jin(Y) {
                  return Vue(f_(Y, sn));
                }
                function Gin(Y, ue) {
                  return Bue(Y, f_(ue, sn));
                }
                var Hin = Ku(function(Y, ue) {
                  return function(ke) {
                    return zD(ke, Y, ue);
                  };
                }), Win = Ku(function(Y, ue) {
                  return function(ke) {
                    return zD(Y, ke, ue);
                  };
                });
                function OIe(Y, ue, ke) {
                  var ot = J0(ue), Et = dz(ue, ot);
                  ke == null && !(zd(ue) && (Et.length || !ot.length)) && (ke = ue, ue = Y, Y = this, Et = dz(ue, J0(ue)));
                  var on = !(zd(ke) && "chain" in ke) || !!ke.chain, Wn = WD(Y);
                  return s_(Et, function(rr) {
                    var Lr = ue[rr];
                    Y[rr] = Lr, Wn && (Y.prototype[rr] = function() {
                      var va = this.__chain__;
                      if (on || va) {
                        var ga = Y(this.__wrapped__), Va = ga.__actions__ = p_(this.__actions__);
                        return Va.push({ func: Lr, args: arguments, thisArg: Y }), ga.__chain__ = va, ga;
                      }
                      return Lr.apply(Y, xA([this.value()], arguments));
                    });
                  }), Y;
                }
                function Uin() {
                  return Qg._ === this && (Qg._ = hue), this;
                }
                function PIe() {
                }
                function qin(Y) {
                  return Y = Zu(Y), Ku(function(ue) {
                    return zue(ue, Y);
                  });
                }
                var $in = cIe(Rp), Xin = cIe(nue), Yin = cIe(cK);
                function Bet(Y) {
                  return yIe(Y) ? fK(MA(Y)) : sIe(Y);
                }
                function Kin(Y) {
                  return function(ue) {
                    return Y == null ? we : BD(Y, ue);
                  };
                }
                var Zin = jQe(), Jin = jQe(true);
                function LIe() {
                  return [];
                }
                function RIe() {
                  return false;
                }
                function Qin() {
                  return {};
                }
                function ean() {
                  return "";
                }
                function tan() {
                  return true;
                }
                function nan(Y, ue) {
                  if (Y = Zu(Y), Y < 1 || Y > Oi)
                    return [];
                  var ke = Ga, ot = e0(Y, Ga);
                  ue = vl(ue), Y -= Ga;
                  for (var Et = dK(ot, ue); ++ke < Y; )
                    ue(ke);
                  return Et;
                }
                function ran(Y) {
                  return Iu(Y) ? Rp(Y, MA) : jx(Y) ? [Y] : p_(ret(uh(Y)));
                }
                function ian(Y) {
                  var ue = ++fue;
                  return uh(Y) + ue;
                }
                var aan = que(function(Y, ue) {
                  return Y + ue;
                }, 0), oan = fIe("ceil"), san = que(function(Y, ue) {
                  return Y / ue;
                }, 1), lan = fIe("floor");
                function uan(Y) {
                  return Y && Y.length ? xO(Y, g_, TK) : we;
                }
                function can(Y, ue) {
                  return Y && Y.length ? xO(Y, vl(ue, 2), TK) : we;
                }
                function fan(Y) {
                  return aue(Y, g_);
                }
                function han(Y, ue) {
                  return aue(Y, vl(ue, 2));
                }
                function pan(Y) {
                  return Y && Y.length ? xO(Y, g_, kK) : we;
                }
                function dan(Y, ue) {
                  return Y && Y.length ? xO(Y, vl(ue, 2), kK) : we;
                }
                var van = que(function(Y, ue) {
                  return Y * ue;
                }, 1), gan = fIe("round"), yan = que(function(Y, ue) {
                  return Y - ue;
                }, 0);
                function man(Y) {
                  return Y && Y.length ? pK(Y, g_) : 0;
                }
                function ban(Y, ue) {
                  return Y && Y.length ? pK(Y, vl(ue, 2)) : 0;
                }
                return qt.after = jnn, qt.ary = vet, qt.assign = Irn, qt.assignIn = Det, qt.assignInWith = ace, qt.assignWith = Ern, qt.at = Drn, qt.before = get2, qt.bind = SIe, qt.bindAll = Rin, qt.bindKey = yet, qt.castArray = Qnn, qt.chain = het, qt.chunk = ltn, qt.compact = utn, qt.concat = ctn, qt.cond = Nin, qt.conforms = Fin, qt.constant = DIe, qt.countBy = mnn, qt.create = krn, qt.curry = met, qt.curryRight = bet, qt.debounce = _et, qt.defaults = Orn, qt.defaultsDeep = Prn, qt.defer = Gnn, qt.delay = Hnn, qt.difference = ftn, qt.differenceBy = htn, qt.differenceWith = ptn, qt.drop = dtn, qt.dropRight = vtn, qt.dropRightWhile = gtn, qt.dropWhile = ytn, qt.fill = mtn, qt.filter = _nn, qt.flatMap = Snn, qt.flatMapDeep = Cnn, qt.flatMapDepth = Mnn, qt.flatten = set2, qt.flattenDeep = btn, qt.flattenDepth = _tn, qt.flip = Wnn, qt.flow = Bin, qt.flowRight = zin, qt.fromPairs = xtn, qt.functions = zrn, qt.functionsIn = jrn, qt.groupBy = Tnn, qt.initial = Stn, qt.intersection = Ctn, qt.intersectionBy = Mtn, qt.intersectionWith = Ttn, qt.invert = Hrn, qt.invertBy = Wrn, qt.invokeMap = Inn, qt.iteratee = kIe, qt.keyBy = Enn, qt.keys = J0, qt.keysIn = v_, qt.map = Que, qt.mapKeys = qrn, qt.mapValues = $rn, qt.matches = jin, qt.matchesProperty = Gin, qt.memoize = tce, qt.merge = Xrn, qt.mergeWith = ket, qt.method = Hin, qt.methodOf = Win, qt.mixin = OIe, qt.negate = nce, qt.nthArg = qin, qt.omit = Yrn, qt.omitBy = Krn, qt.once = Unn, qt.orderBy = Dnn, qt.over = $in, qt.overArgs = qnn, qt.overEvery = Xin, qt.overSome = Yin, qt.partial = CIe, qt.partialRight = xet, qt.partition = knn, qt.pick = Zrn, qt.pickBy = Oet, qt.property = Bet, qt.propertyOf = Kin, qt.pull = Dtn, qt.pullAll = cet, qt.pullAllBy = ktn, qt.pullAllWith = Otn, qt.pullAt = Ptn, qt.range = Zin, qt.rangeRight = Jin, qt.rearg = $nn, qt.reject = Lnn, qt.remove = Ltn, qt.rest = Xnn, qt.reverse = xIe, qt.sampleSize = Nnn, qt.set = Qrn, qt.setWith = ein, qt.shuffle = Fnn, qt.slice = Rtn, qt.sortBy = znn, qt.sortedUniq = Gtn, qt.sortedUniqBy = Htn, qt.split = Sin, qt.spread = Ynn, qt.tail = Wtn, qt.take = Utn, qt.takeRight = qtn, qt.takeRightWhile = $tn, qt.takeWhile = Xtn, qt.tap = unn, qt.throttle = Knn, qt.thru = Jue, qt.toArray = Aet, qt.toPairs = Pet, qt.toPairsIn = Let, qt.toPath = ran, qt.toPlainObject = Eet, qt.transform = tin, qt.unary = Znn, qt.union = Ytn, qt.unionBy = Ktn, qt.unionWith = Ztn, qt.uniq = Jtn, qt.uniqBy = Qtn, qt.uniqWith = enn, qt.unset = nin, qt.unzip = wIe, qt.unzipWith = fet, qt.update = rin, qt.updateWith = iin, qt.values = _z, qt.valuesIn = ain, qt.without = tnn, qt.words = Fet, qt.wrap = Jnn, qt.xor = nnn, qt.xorBy = rnn, qt.xorWith = inn, qt.zip = ann, qt.zipObject = onn, qt.zipObjectDeep = snn, qt.zipWith = lnn, qt.entries = Pet, qt.entriesIn = Let, qt.extend = Det, qt.extendWith = ace, OIe(qt, qt), qt.add = aan, qt.attempt = Vet, qt.camelCase = uin, qt.capitalize = Ret, qt.ceil = oan, qt.clamp = oin, qt.clone = ern, qt.cloneDeep = nrn, qt.cloneDeepWith = rrn, qt.cloneWith = trn, qt.conformsTo = irn, qt.deburr = Net, qt.defaultTo = Vin, qt.divide = san, qt.endsWith = cin, qt.eq = iM, qt.escape = fin, qt.escapeRegExp = hin, qt.every = bnn, qt.find = xnn, qt.findIndex = aet, qt.findKey = Lrn, qt.findLast = wnn, qt.findLastIndex = oet, qt.findLastKey = Rrn, qt.floor = lan, qt.forEach = pet, qt.forEachRight = det, qt.forIn = Nrn, qt.forInRight = Frn, qt.forOwn = Vrn, qt.forOwnRight = Brn, qt.get = AIe, qt.gt = arn, qt.gte = orn, qt.has = Grn, qt.hasIn = IIe, qt.head = uet, qt.identity = g_, qt.includes = Ann, qt.indexOf = wtn, qt.inRange = sin, qt.invoke = Urn, qt.isArguments = H6, qt.isArray = Iu, qt.isArrayBuffer = srn, qt.isArrayLike = d_, qt.isArrayLikeObject = kv, qt.isBoolean = lrn, qt.isBuffer = wO, qt.isDate = urn, qt.isElement = crn, qt.isEmpty = frn, qt.isEqual = hrn, qt.isEqualWith = prn, qt.isError = MIe, qt.isFinite = drn, qt.isFunction = WD, qt.isInteger = wet, qt.isLength = rce, qt.isMap = Cet, qt.isMatch = vrn, qt.isMatchWith = grn, qt.isNaN = yrn, qt.isNative = mrn, qt.isNil = _rn, qt.isNull = brn, qt.isNumber = Met, qt.isObject = zd, qt.isObjectLike = iv, qt.isPlainObject = BK, qt.isRegExp = TIe, qt.isSafeInteger = xrn, qt.isSet = Tet, qt.isString = ice, qt.isSymbol = jx, qt.isTypedArray = bz, qt.isUndefined = wrn, qt.isWeakMap = Srn, qt.isWeakSet = Crn, qt.join = Atn, qt.kebabCase = pin, qt.last = JS, qt.lastIndexOf = Itn, qt.lowerCase = din, qt.lowerFirst = vin, qt.lt = Mrn, qt.lte = Trn, qt.max = uan, qt.maxBy = can, qt.mean = fan, qt.meanBy = han, qt.min = pan, qt.minBy = dan, qt.stubArray = LIe, qt.stubFalse = RIe, qt.stubObject = Qin, qt.stubString = ean, qt.stubTrue = tan, qt.multiply = van, qt.nth = Etn, qt.noConflict = Uin, qt.noop = PIe, qt.now = ece, qt.pad = gin, qt.padEnd = yin, qt.padStart = min3, qt.parseInt = bin, qt.random = lin, qt.reduce = Onn, qt.reduceRight = Pnn, qt.repeat = _in, qt.replace = xin, qt.result = Jrn, qt.round = gan, qt.runInContext = wr, qt.sample = Rnn, qt.size = Vnn, qt.snakeCase = win, qt.some = Bnn, qt.sortedIndex = Ntn, qt.sortedIndexBy = Ftn, qt.sortedIndexOf = Vtn, qt.sortedLastIndex = Btn, qt.sortedLastIndexBy = ztn, qt.sortedLastIndexOf = jtn, qt.startCase = Cin, qt.startsWith = Min, qt.subtract = yan, qt.sum = man, qt.sumBy = ban, qt.template = Tin, qt.times = nan, qt.toFinite = UD, qt.toInteger = Zu, qt.toLength = Iet, qt.toLower = Ain, qt.toNumber = QS, qt.toSafeInteger = Arn, qt.toString = uh, qt.toUpper = Iin, qt.trim = Ein, qt.trimEnd = Din, qt.trimStart = kin, qt.truncate = Oin, qt.unescape = Pin2, qt.uniqueId = ian, qt.upperCase = Lin, qt.upperFirst = EIe, qt.each = pet, qt.eachRight = det, qt.first = uet, OIe(qt, function() {
                  var Y = {};
                  return h_(qt, function(ue, ke) {
                    Ac.call(qt.prototype, ke) || (Y[ke] = ue);
                  }), Y;
                }(), { chain: false }), qt.VERSION = Me, s_(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(Y) {
                  qt[Y].placeholder = qt;
                }), s_(["drop", "take"], function(Y, ue) {
                  qs.prototype[Y] = function(ke) {
                    ke = ke === we ? 1 : Bf(Zu(ke), 0);
                    var ot = this.__filtered__ && !ue ? new qs(this) : this.clone();
                    return ot.__filtered__ ? ot.__takeCount__ = e0(ke, ot.__takeCount__) : ot.__views__.push({ size: e0(ke, Ga), type: Y + (ot.__dir__ < 0 ? "Right" : "") }), ot;
                  }, qs.prototype[Y + "Right"] = function(ke) {
                    return this.reverse()[Y](ke).reverse();
                  };
                }), s_(["filter", "map", "takeWhile"], function(Y, ue) {
                  var ke = ue + 1, ot = ke == No || ke == Mi;
                  qs.prototype[Y] = function(Et) {
                    var on = this.clone();
                    return on.__iteratees__.push({ iteratee: vl(Et, 3), type: ke }), on.__filtered__ = on.__filtered__ || ot, on;
                  };
                }), s_(["head", "last"], function(Y, ue) {
                  var ke = "take" + (ue ? "Right" : "");
                  qs.prototype[Y] = function() {
                    return this[ke](1).value()[0];
                  };
                }), s_(["initial", "tail"], function(Y, ue) {
                  var ke = "drop" + (ue ? "" : "Right");
                  qs.prototype[Y] = function() {
                    return this.__filtered__ ? new qs(this) : this[ke](1);
                  };
                }), qs.prototype.compact = function() {
                  return this.filter(g_);
                }, qs.prototype.find = function(Y) {
                  return this.filter(Y).head();
                }, qs.prototype.findLast = function(Y) {
                  return this.reverse().find(Y);
                }, qs.prototype.invokeMap = Ku(function(Y, ue) {
                  return typeof Y == "function" ? new qs(this) : this.map(function(ke) {
                    return zD(ke, Y, ue);
                  });
                }), qs.prototype.reject = function(Y) {
                  return this.filter(nce(vl(Y)));
                }, qs.prototype.slice = function(Y, ue) {
                  Y = Zu(Y);
                  var ke = this;
                  return ke.__filtered__ && (Y > 0 || ue < 0) ? new qs(ke) : (Y < 0 ? ke = ke.takeRight(-Y) : Y && (ke = ke.drop(Y)), ue !== we && (ue = Zu(ue), ke = ue < 0 ? ke.dropRight(-ue) : ke.take(ue - Y)), ke);
                }, qs.prototype.takeRightWhile = function(Y) {
                  return this.reverse().takeWhile(Y).reverse();
                }, qs.prototype.toArray = function() {
                  return this.take(Ga);
                }, h_(qs.prototype, function(Y, ue) {
                  var ke = /^(?:filter|find|map|reject)|While$/.test(ue), ot = /^(?:head|last)$/.test(ue), Et = qt[ot ? "take" + (ue == "last" ? "Right" : "") : ue], on = ot || /^find/.test(ue);
                  !Et || (qt.prototype[ue] = function() {
                    var Wn = this.__wrapped__, rr = ot ? [1] : arguments, Lr = Wn instanceof qs, va = rr[0], ga = Lr || Iu(Wn), Va = function(Hc) {
                      var af = Et.apply(qt, xA([Hc], rr));
                      return ot && Fo ? af[0] : af;
                    };
                    ga && ke && typeof va == "function" && va.length != 1 && (Lr = ga = false);
                    var Fo = this.__chain__, Ds = !!this.__actions__.length, xl = on && !Fo, cc = Lr && !Ds;
                    if (!on && ga) {
                      Wn = cc ? Wn : new qs(this);
                      var wl = Y.apply(Wn, rr);
                      return wl.__actions__.push({ func: Jue, args: [Va], thisArg: we }), new u_(wl, Fo);
                    }
                    return xl && cc ? Y.apply(this, rr) : (wl = this.thru(Va), xl ? ot ? wl.value()[0] : wl.value() : wl);
                  });
                }), s_(["pop", "push", "shift", "sort", "splice", "unshift"], function(Y) {
                  var ue = rz[Y], ke = /^(?:push|sort|unshift)$/.test(Y) ? "tap" : "thru", ot = /^(?:pop|shift)$/.test(Y);
                  qt.prototype[Y] = function() {
                    var Et = arguments;
                    if (ot && !this.__chain__) {
                      var on = this.value();
                      return ue.apply(Iu(on) ? on : [], Et);
                    }
                    return this[ke](function(Wn) {
                      return ue.apply(Iu(Wn) ? Wn : [], Et);
                    });
                  };
                }), h_(qs.prototype, function(Y, ue) {
                  var ke = qt[ue];
                  if (ke) {
                    var ot = ke.name + "";
                    Ac.call(mO, ot) || (mO[ot] = []), mO[ot].push({ name: ue, func: ke });
                  }
                }), mO[Uue(we, ki).name] = [{ name: "wrapper", func: we }], qs.prototype.clone = c1, qs.prototype.reverse = TAe, qs.prototype.value = AAe, qt.prototype.at = cnn, qt.prototype.chain = fnn, qt.prototype.commit = hnn, qt.prototype.next = pnn, qt.prototype.plant = vnn, qt.prototype.reverse = gnn, qt.prototype.toJSON = qt.prototype.valueOf = qt.prototype.value = ynn, qt.prototype.first = qt.prototype.head, dO && (qt.prototype[dO] = dnn), qt;
              }, Y0 = dAe();
              PD ? ((PD.exports = Y0)._ = Y0, oK._ = Y0) : Qg._ = Y0;
            }).call(tn);
          })(Un, Un.exports);
          class qn {
            constructor() {
              Se(this, "subscriptions", /* @__PURE__ */ new Map()), Se(this, "useSubscription", (He, we) => {
                const Me = Ce.useRef();
                Ce.useEffect(() => {
                  Me.current = we;
                  function Te(Ne) {
                    Me.current && Me.current(Ne);
                  }
                  return this.subscriptions.set(He, Te), () => {
                    this.subscriptions.delete(He);
                  };
                }, []);
              }), Se(this, "emit", (He, ...we) => {
                if (typeof He == "string" || typeof He == "number") {
                  const Me = this.subscriptions.get(He);
                  Me == null || Me({ params: Un.exports.cloneDeep(we), event: He });
                } else
                  throw new TypeError("event must be string or number !");
              }), Se(this, "removeListener", (He) => {
                this.subscriptions.delete(He);
              }), Se(this, "clear", () => {
                this.subscriptions.clear();
              }), this.clear();
            }
          }
          const nr = new qn();
          function sr(ge) {
            const He = Ce.useRef(), we = Ce.useMemo(() => ge != null ? ge : { global: false }, [ge]);
            return He.current || (He.current = we.global ? He.current = nr : He.current = new qn()), Ce.useEffect(() => () => {
              var Me;
              return (Me = He.current) == null ? void 0 : Me.clear();
            }, []), He.current;
          }
          var Ii = globalThis && globalThis.__read || function(ge, He) {
            var we = typeof Symbol == "function" && ge[Symbol.iterator];
            if (!we)
              return ge;
            var Me = we.call(ge), Te, Ne = [], it;
            try {
              for (; (He === void 0 || He-- > 0) && !(Te = Me.next()).done; )
                Ne.push(Te.value);
            } catch (ht) {
              it = { error: ht };
            } finally {
              try {
                Te && !Te.done && (we = Me.return) && we.call(Me);
              } finally {
                if (it)
                  throw it.error;
              }
            }
            return Ne;
          };
          function gi(ge, He) {
            ge === void 0 && (ge = false);
            var we = Ii(Ce.useState(ge), 2), Me = we[0], Te = we[1], Ne = Ce.useMemo(function() {
              var it = He === void 0 ? !ge : He, ht = function() {
                return Te(function(sn) {
                  return sn === ge ? it : ge;
                });
              }, xt = function(sn) {
                return Te(sn);
              }, kt = function() {
                return Te(ge);
              }, Lt = function() {
                return Te(it);
              };
              return { toggle: ht, set: xt, setLeft: kt, setRight: Lt };
            }, []);
            return [Me, Ne];
          }
          var Sa = globalThis && globalThis.__read || function(ge, He) {
            var we = typeof Symbol == "function" && ge[Symbol.iterator];
            if (!we)
              return ge;
            var Me = we.call(ge), Te, Ne = [], it;
            try {
              for (; (He === void 0 || He-- > 0) && !(Te = Me.next()).done; )
                Ne.push(Te.value);
            } catch (ht) {
              it = { error: ht };
            } finally {
              try {
                Te && !Te.done && (we = Me.return) && we.call(Me);
              } finally {
                if (it)
                  throw it.error;
              }
            }
            return Ne;
          };
          function Tt(ge) {
            ge === void 0 && (ge = false);
            var He = Sa(gi(ge), 2), we = He[0], Me = He[1], Te = Me.toggle, Ne = Me.set, it = Ce.useMemo(function() {
              var ht = function() {
                return Ne(true);
              }, xt = function() {
                return Ne(false);
              };
              return { toggle: Te, set: function(kt) {
                return Ne(!!kt);
              }, setTrue: ht, setFalse: xt };
            }, []);
            return [we, it];
          }
          function Ar(ge) {
            var He = Ce.useRef(ge);
            return He.current = ge, He;
          }
          var Vr = function(ge) {
            var He = Ar(ge);
            Ce.useEffect(function() {
              return function() {
                He.current();
              };
            }, []);
          }, Si = Vr;
          function mi(ge) {
            var He = typeof ge;
            return ge != null && (He == "object" || He == "function");
          }
          var Dr = mi, Gr = typeof tn == "object" && tn && tn.Object === Object && tn, Vi = Gr, ya = Vi, xr = typeof self == "object" && self && self.Object === Object && self, Ro = ya || xr || Function("return this")(), Oo = Ro, pi = Oo, xs = function() {
            return pi.Date.now();
          }, Ti = xs, si = /\s/;
          function ni(ge) {
            for (var He = ge.length; He-- && si.test(ge.charAt(He)); )
              ;
            return He;
          }
          var ja = ni, Ta = ja, Ws = /^\s+/;
          function Uu(ge) {
            return ge && ge.slice(0, Ta(ge) + 1).replace(Ws, "");
          }
          var Su = Uu, hl = Oo, Tf = hl.Symbol, Cu = Tf, Lc = Cu, Eh = Object.prototype, B0 = Eh.hasOwnProperty, qy = Eh.toString, vp = Lc ? Lc.toStringTag : void 0;
          function Ap(ge) {
            var He = B0.call(ge, vp), we = ge[vp];
            try {
              ge[vp] = void 0;
              var Me = true;
            } catch {
            }
            var Te = qy.call(ge);
            return Me && (He ? ge[vp] = we : delete ge[vp]), Te;
          }
          var ig = Ap, $y = Object.prototype, Ed = $y.toString;
          function z0(ge) {
            return Ed.call(ge);
          }
          var ws = z0, ag = Cu, gp = ig, Yh = ws, Ip = "[object Null]", Jm = "[object Undefined]", qi = ag ? ag.toStringTag : void 0;
          function Rr(ge) {
            return ge == null ? ge === void 0 ? Jm : Ip : qi && qi in Object(ge) ? gp(ge) : Yh(ge);
          }
          var qr = Rr;
          function Yi(ge) {
            return ge != null && typeof ge == "object";
          }
          var to = Yi, is = qr, Bl = to, zl = "[object Symbol]";
          function $c(ge) {
            return typeof ge == "symbol" || Bl(ge) && is(ge) == zl;
          }
          var Dh = $c, Sc = Su, lc = Dr, Af = Dh, Cv = 0 / 0, Mv = /^[-+]0x[0-9a-f]+$/i, Qm = /^0b[01]+$/i, Hg = /^0o[0-7]+$/i, ih = parseInt;
          function Ou(ge) {
            if (typeof ge == "number")
              return ge;
            if (Af(ge))
              return Cv;
            if (lc(ge)) {
              var He = typeof ge.valueOf == "function" ? ge.valueOf() : ge;
              ge = lc(He) ? He + "" : He;
            }
            if (typeof ge != "string")
              return ge === 0 ? ge : +ge;
            ge = Sc(ge);
            var we = Qm.test(ge);
            return we || Hg.test(ge) ? ih(ge.slice(2), we ? 2 : 8) : Mv.test(ge) ? Cv : +ge;
          }
          var ud = Ou, Tv = Dr, j0 = Ti, Wg = ud, Ug = "Expected a function", G0 = Math.max, Sx = Math.min;
          function Cx(ge, He, we) {
            var Me, Te, Ne, it, ht, xt, kt = 0, Lt = false, sn = false, Bn = true;
            if (typeof ge != "function")
              throw new TypeError(Ug);
            He = Wg(He) || 0, Tv(we) && (Lt = !!we.leading, sn = "maxWait" in we, Ne = sn ? G0(Wg(we.maxWait) || 0, He) : Ne, Bn = "trailing" in we ? !!we.trailing : Bn);
            function Xn(Wr) {
              var Ci = Me, _i = Te;
              return Me = Te = void 0, kt = Wr, it = ge.apply(_i, Ci), it;
            }
            function $n(Wr) {
              return kt = Wr, ht = setTimeout(ki, He), Lt ? Xn(Wr) : it;
            }
            function lr(Wr) {
              var Ci = Wr - xt, _i = Wr - kt, Pr = He - Ci;
              return sn ? Sx(Pr, Ne - _i) : Pr;
            }
            function br(Wr) {
              var Ci = Wr - xt, _i = Wr - kt;
              return xt === void 0 || Ci >= He || Ci < 0 || sn && _i >= Ne;
            }
            function ki() {
              var Wr = j0();
              if (br(Wr))
                return bi(Wr);
              ht = setTimeout(ki, lr(Wr));
            }
            function bi(Wr) {
              return ht = void 0, Bn && Me ? Xn(Wr) : (Me = Te = void 0, it);
            }
            function Oa() {
              ht !== void 0 && clearTimeout(ht), kt = 0, Me = xt = Te = ht = void 0;
            }
            function Ct() {
              return ht === void 0 ? it : bi(j0());
            }
            function dr() {
              var Wr = j0(), Ci = br(Wr);
              if (Me = arguments, Te = this, xt = Wr, Ci) {
                if (ht === void 0)
                  return $n(xt);
                if (sn)
                  return clearTimeout(ht), ht = setTimeout(ki, He), Xn(xt);
              }
              return ht === void 0 && (ht = setTimeout(ki, He)), it;
            }
            return dr.cancel = Oa, dr.flush = Ct, dr;
          }
          var iD = Cx, Mx = globalThis && globalThis.__read || function(ge, He) {
            var we = typeof Symbol == "function" && ge[Symbol.iterator];
            if (!we)
              return ge;
            var Me = we.call(ge), Te, Ne = [], it;
            try {
              for (; (He === void 0 || He-- > 0) && !(Te = Me.next()).done; )
                Ne.push(Te.value);
            } catch (ht) {
              it = { error: ht };
            } finally {
              try {
                Te && !Te.done && (we = Me.return) && we.call(Me);
              } finally {
                if (it)
                  throw it.error;
              }
            }
            return Ne;
          }, LC = globalThis && globalThis.__spread || function() {
            for (var ge = [], He = 0; He < arguments.length; He++)
              ge = ge.concat(Mx(arguments[He]));
            return ge;
          };
          function aD(ge, He) {
            var we, Me = Ar(ge), Te = (we = He == null ? void 0 : He.wait) !== null && we !== void 0 ? we : 1e3, Ne = Ce.useMemo(function() {
              return iD(function() {
                for (var it = [], ht = 0; ht < arguments.length; ht++)
                  it[ht] = arguments[ht];
                return Me.current.apply(Me, LC(it));
              }, Te, He);
            }, []);
            return Si(function() {
              Ne.cancel();
            }), { run: Ne, cancel: Ne.cancel, flush: Ne.flush };
          }
          const nA = ({ id: ge, title: He, chart: we, option: Me }, Te) => {
            const Ne = Ce.useRef(), it = sr({ global: true });
            Ne.current = Ce.useMemo(() => {
              if (!Ne.current)
                return Pt;
            }, []);
            const { run: ht } = aD(() => {
              ge && it.emit("list");
            }, { wait: 100 });
            return Ce.useEffect(() => {
              console.log(we == null ? void 0 : we.current), Ne.current && (we == null ? void 0 : we.current) && ge && Me && (Ne.current.add(ge, we == null ? void 0 : we.current, Me, He), ht());
            }, Te), { tool: Ne.current };
          };
          var L3 = Ce.createContext({}), e_ = L3;
          function dn(ge, He, we) {
            return He in ge ? Object.defineProperty(ge, He, { value: we, enumerable: true, configurable: true, writable: true }) : ge[He] = we, ge;
          }
          function Dn(ge, He) {
            var we = Object.keys(ge);
            if (Object.getOwnPropertySymbols) {
              var Me = Object.getOwnPropertySymbols(ge);
              He && (Me = Me.filter(function(Te) {
                return Object.getOwnPropertyDescriptor(ge, Te).enumerable;
              })), we.push.apply(we, Me);
            }
            return we;
          }
          function Ot(ge) {
            for (var He = 1; He < arguments.length; He++) {
              var we = arguments[He] != null ? arguments[He] : {};
              He % 2 ? Dn(Object(we), true).forEach(function(Me) {
                dn(ge, Me, we[Me]);
              }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(ge, Object.getOwnPropertyDescriptors(we)) : Dn(Object(we)).forEach(function(Me) {
                Object.defineProperty(ge, Me, Object.getOwnPropertyDescriptor(we, Me));
              });
            }
            return ge;
          }
          function gn(ge) {
            if (Array.isArray(ge))
              return ge;
          }
          function wn(ge, He) {
            var we = ge == null ? null : typeof Symbol != "undefined" && ge[Symbol.iterator] || ge["@@iterator"];
            if (we != null) {
              var Me = [], Te = true, Ne = false, it, ht;
              try {
                for (we = we.call(ge); !(Te = (it = we.next()).done) && (Me.push(it.value), !(He && Me.length === He)); Te = true)
                  ;
              } catch (xt) {
                Ne = true, ht = xt;
              } finally {
                try {
                  !Te && we.return != null && we.return();
                } finally {
                  if (Ne)
                    throw ht;
                }
              }
              return Me;
            }
          }
          function Fr(ge, He) {
            (He == null || He > ge.length) && (He = ge.length);
            for (var we = 0, Me = new Array(He); we < He; we++)
              Me[we] = ge[we];
            return Me;
          }
          function Ri(ge, He) {
            if (ge) {
              if (typeof ge == "string")
                return Fr(ge, He);
              var we = Object.prototype.toString.call(ge).slice(8, -1);
              if (we === "Object" && ge.constructor && (we = ge.constructor.name), we === "Map" || we === "Set")
                return Array.from(ge);
              if (we === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))
                return Fr(ge, He);
            }
          }
          function di() {
            throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          function ur(ge, He) {
            return gn(ge) || wn(ge, He) || Ri(ge, He) || di();
          }
          function xa(ge, He) {
            if (ge == null)
              return {};
            var we = {}, Me = Object.keys(ge), Te, Ne;
            for (Ne = 0; Ne < Me.length; Ne++)
              Te = Me[Ne], !(He.indexOf(Te) >= 0) && (we[Te] = ge[Te]);
            return we;
          }
          function Go(ge, He) {
            if (ge == null)
              return {};
            var we = xa(ge, He), Me, Te;
            if (Object.getOwnPropertySymbols) {
              var Ne = Object.getOwnPropertySymbols(ge);
              for (Te = 0; Te < Ne.length; Te++)
                Me = Ne[Te], !(He.indexOf(Me) >= 0) && (!Object.prototype.propertyIsEnumerable.call(ge, Me) || (we[Me] = ge[Me]));
            }
            return we;
          }
          var ou = { exports: {} };
          /*!
            Copyright (c) 2018 Jed Watson.
            Licensed under the MIT License (MIT), see
            http://jedwatson.github.io/classnames
          */
          (function(ge) {
            (function() {
              var He = {}.hasOwnProperty;
              function we() {
                for (var Me = [], Te = 0; Te < arguments.length; Te++) {
                  var Ne = arguments[Te];
                  if (Ne) {
                    var it = typeof Ne;
                    if (it === "string" || it === "number")
                      Me.push(Ne);
                    else if (Array.isArray(Ne)) {
                      if (Ne.length) {
                        var ht = we.apply(null, Ne);
                        ht && Me.push(ht);
                      }
                    } else if (it === "object")
                      if (Ne.toString === Object.prototype.toString)
                        for (var xt in Ne)
                          He.call(Ne, xt) && Ne[xt] && Me.push(xt);
                      else
                        Me.push(Ne.toString());
                  }
                }
                return Me.join(" ");
              }
              ge.exports ? (we.default = we, ge.exports = we) : window.classNames = we;
            })();
          })(ou);
          var Xl = ou.exports;
          function El(ge) {
            return El = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(He) {
              return typeof He;
            } : function(He) {
              return He && typeof Symbol == "function" && He.constructor === Symbol && He !== Symbol.prototype ? "symbol" : typeof He;
            }, El(ge);
          }
          function js(ge, He) {
            vf(ge) && (ge = "100%");
            var we = kh(ge);
            return ge = He === 360 ? ge : Math.min(He, Math.max(0, parseFloat(ge))), we && (ge = parseInt(String(ge * He), 10) / 100), Math.abs(ge - He) < 1e-6 ? 1 : (He === 360 ? ge = (ge < 0 ? ge % He + He : ge % He) / parseFloat(String(He)) : ge = ge % He / parseFloat(String(He)), ge);
          }
          function vf(ge) {
            return typeof ge == "string" && ge.indexOf(".") !== -1 && parseFloat(ge) === 1;
          }
          function kh(ge) {
            return typeof ge == "string" && ge.indexOf("%") !== -1;
          }
          function pl(ge) {
            return ge = parseFloat(ge), (isNaN(ge) || ge < 0 || ge > 1) && (ge = 1), ge;
          }
          function Oh(ge) {
            return ge <= 1 ? Number(ge) * 100 + "%" : ge;
          }
          function Av(ge) {
            return ge.length === 1 ? "0" + ge : String(ge);
          }
          function ib(ge, He, we) {
            return { r: js(ge, 255) * 255, g: js(He, 255) * 255, b: js(we, 255) * 255 };
          }
          function RS(ge, He, we) {
            return we < 0 && (we += 1), we > 1 && (we -= 1), we < 1 / 6 ? ge + (He - ge) * (6 * we) : we < 1 / 2 ? He : we < 2 / 3 ? ge + (He - ge) * (2 / 3 - we) * 6 : ge;
          }
          function e1(ge, He, we) {
            var Me, Te, Ne;
            if (ge = js(ge, 360), He = js(He, 100), we = js(we, 100), He === 0)
              Te = we, Ne = we, Me = we;
            else {
              var it = we < 0.5 ? we * (1 + He) : we + He - we * He, ht = 2 * we - it;
              Me = RS(ht, it, ge + 1 / 3), Te = RS(ht, it, ge), Ne = RS(ht, it, ge - 1 / 3);
            }
            return { r: Me * 255, g: Te * 255, b: Ne * 255 };
          }
          function RC(ge, He, we) {
            ge = js(ge, 255), He = js(He, 255), we = js(we, 255);
            var Me = Math.max(ge, He, we), Te = Math.min(ge, He, we), Ne = 0, it = Me, ht = Me - Te, xt = Me === 0 ? 0 : ht / Me;
            if (Me === Te)
              Ne = 0;
            else {
              switch (Me) {
                case ge:
                  Ne = (He - we) / ht + (He < we ? 6 : 0);
                  break;
                case He:
                  Ne = (we - ge) / ht + 2;
                  break;
                case we:
                  Ne = (ge - He) / ht + 4;
                  break;
              }
              Ne /= 6;
            }
            return { h: Ne, s: xt, v: it };
          }
          function Tx(ge, He, we) {
            ge = js(ge, 360) * 6, He = js(He, 100), we = js(we, 100);
            var Me = Math.floor(ge), Te = ge - Me, Ne = we * (1 - He), it = we * (1 - Te * He), ht = we * (1 - (1 - Te) * He), xt = Me % 6, kt = [we, it, Ne, Ne, ht, we][xt], Lt = [ht, we, we, it, Ne, Ne][xt], sn = [Ne, Ne, ht, we, we, it][xt];
            return { r: kt * 255, g: Lt * 255, b: sn * 255 };
          }
          function Dd(ge, He, we, Me) {
            var Te = [Av(Math.round(ge).toString(16)), Av(Math.round(He).toString(16)), Av(Math.round(we).toString(16))];
            return Me && Te[0].startsWith(Te[0].charAt(1)) && Te[1].startsWith(Te[1].charAt(1)) && Te[2].startsWith(Te[2].charAt(1)) ? Te[0].charAt(0) + Te[1].charAt(0) + Te[2].charAt(0) : Te.join("");
          }
          function ab(ge) {
            return kd(ge) / 255;
          }
          function kd(ge) {
            return parseInt(ge, 16);
          }
          var t_ = { aliceblue: "#f0f8ff", antiquewhite: "#faebd7", aqua: "#00ffff", aquamarine: "#7fffd4", azure: "#f0ffff", beige: "#f5f5dc", bisque: "#ffe4c4", black: "#000000", blanchedalmond: "#ffebcd", blue: "#0000ff", blueviolet: "#8a2be2", brown: "#a52a2a", burlywood: "#deb887", cadetblue: "#5f9ea0", chartreuse: "#7fff00", chocolate: "#d2691e", coral: "#ff7f50", cornflowerblue: "#6495ed", cornsilk: "#fff8dc", crimson: "#dc143c", cyan: "#00ffff", darkblue: "#00008b", darkcyan: "#008b8b", darkgoldenrod: "#b8860b", darkgray: "#a9a9a9", darkgreen: "#006400", darkgrey: "#a9a9a9", darkkhaki: "#bdb76b", darkmagenta: "#8b008b", darkolivegreen: "#556b2f", darkorange: "#ff8c00", darkorchid: "#9932cc", darkred: "#8b0000", darksalmon: "#e9967a", darkseagreen: "#8fbc8f", darkslateblue: "#483d8b", darkslategray: "#2f4f4f", darkslategrey: "#2f4f4f", darkturquoise: "#00ced1", darkviolet: "#9400d3", deeppink: "#ff1493", deepskyblue: "#00bfff", dimgray: "#696969", dimgrey: "#696969", dodgerblue: "#1e90ff", firebrick: "#b22222", floralwhite: "#fffaf0", forestgreen: "#228b22", fuchsia: "#ff00ff", gainsboro: "#dcdcdc", ghostwhite: "#f8f8ff", goldenrod: "#daa520", gold: "#ffd700", gray: "#808080", green: "#008000", greenyellow: "#adff2f", grey: "#808080", honeydew: "#f0fff0", hotpink: "#ff69b4", indianred: "#cd5c5c", indigo: "#4b0082", ivory: "#fffff0", khaki: "#f0e68c", lavenderblush: "#fff0f5", lavender: "#e6e6fa", lawngreen: "#7cfc00", lemonchiffon: "#fffacd", lightblue: "#add8e6", lightcoral: "#f08080", lightcyan: "#e0ffff", lightgoldenrodyellow: "#fafad2", lightgray: "#d3d3d3", lightgreen: "#90ee90", lightgrey: "#d3d3d3", lightpink: "#ffb6c1", lightsalmon: "#ffa07a", lightseagreen: "#20b2aa", lightskyblue: "#87cefa", lightslategray: "#778899", lightslategrey: "#778899", lightsteelblue: "#b0c4de", lightyellow: "#ffffe0", lime: "#00ff00", limegreen: "#32cd32", linen: "#faf0e6", magenta: "#ff00ff", maroon: "#800000", mediumaquamarine: "#66cdaa", mediumblue: "#0000cd", mediumorchid: "#ba55d3", mediumpurple: "#9370db", mediumseagreen: "#3cb371", mediumslateblue: "#7b68ee", mediumspringgreen: "#00fa9a", mediumturquoise: "#48d1cc", mediumvioletred: "#c71585", midnightblue: "#191970", mintcream: "#f5fffa", mistyrose: "#ffe4e1", moccasin: "#ffe4b5", navajowhite: "#ffdead", navy: "#000080", oldlace: "#fdf5e6", olive: "#808000", olivedrab: "#6b8e23", orange: "#ffa500", orangered: "#ff4500", orchid: "#da70d6", palegoldenrod: "#eee8aa", palegreen: "#98fb98", paleturquoise: "#afeeee", palevioletred: "#db7093", papayawhip: "#ffefd5", peachpuff: "#ffdab9", peru: "#cd853f", pink: "#ffc0cb", plum: "#dda0dd", powderblue: "#b0e0e6", purple: "#800080", rebeccapurple: "#663399", red: "#ff0000", rosybrown: "#bc8f8f", royalblue: "#4169e1", saddlebrown: "#8b4513", salmon: "#fa8072", sandybrown: "#f4a460", seagreen: "#2e8b57", seashell: "#fff5ee", sienna: "#a0522d", silver: "#c0c0c0", skyblue: "#87ceeb", slateblue: "#6a5acd", slategray: "#708090", slategrey: "#708090", snow: "#fffafa", springgreen: "#00ff7f", steelblue: "#4682b4", tan: "#d2b48c", teal: "#008080", thistle: "#d8bfd8", tomato: "#ff6347", turquoise: "#40e0d0", violet: "#ee82ee", wheat: "#f5deb3", white: "#ffffff", whitesmoke: "#f5f5f5", yellow: "#ffff00", yellowgreen: "#9acd32" };
          function Ep(ge) {
            var He = { r: 0, g: 0, b: 0 }, we = 1, Me = null, Te = null, Ne = null, it = false, ht = false;
            return typeof ge == "string" && (ge = sD(ge)), typeof ge == "object" && (ob(ge.r) && ob(ge.g) && ob(ge.b) ? (He = ib(ge.r, ge.g, ge.b), it = true, ht = String(ge.r).substr(-1) === "%" ? "prgb" : "rgb") : ob(ge.h) && ob(ge.s) && ob(ge.v) ? (Me = Oh(ge.s), Te = Oh(ge.v), He = Tx(ge.h, Me, Te), it = true, ht = "hsv") : ob(ge.h) && ob(ge.s) && ob(ge.l) && (Me = Oh(ge.s), Ne = Oh(ge.l), He = e1(ge.h, Me, Ne), it = true, ht = "hsl"), Object.prototype.hasOwnProperty.call(ge, "a") && (we = ge.a)), we = pl(we), { ok: it, format: ge.format || ht, r: Math.min(255, Math.max(He.r, 0)), g: Math.min(255, Math.max(He.g, 0)), b: Math.min(255, Math.max(He.b, 0)), a: we };
          }
          var NC = "[-\\+]?\\d+%?", oD = "[-\\+]?\\d*\\.\\d+%?", Xy = "(?:" + oD + ")|(?:" + NC + ")", Ax = "[\\s|\\(]+(" + Xy + ")[,|\\s]+(" + Xy + ")[,|\\s]+(" + Xy + ")\\s*\\)?", Ix = "[\\s|\\(]+(" + Xy + ")[,|\\s]+(" + Xy + ")[,|\\s]+(" + Xy + ")[,|\\s]+(" + Xy + ")\\s*\\)?", ev = { CSS_UNIT: new RegExp(Xy), rgb: new RegExp("rgb" + Ax), rgba: new RegExp("rgba" + Ix), hsl: new RegExp("hsl" + Ax), hsla: new RegExp("hsla" + Ix), hsv: new RegExp("hsv" + Ax), hsva: new RegExp("hsva" + Ix), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ };
          function sD(ge) {
            if (ge = ge.trim().toLowerCase(), ge.length === 0)
              return false;
            var He = false;
            if (t_[ge])
              ge = t_[ge], He = true;
            else if (ge === "transparent")
              return { r: 0, g: 0, b: 0, a: 0, format: "name" };
            var we = ev.rgb.exec(ge);
            return we ? { r: we[1], g: we[2], b: we[3] } : (we = ev.rgba.exec(ge), we ? { r: we[1], g: we[2], b: we[3], a: we[4] } : (we = ev.hsl.exec(ge), we ? { h: we[1], s: we[2], l: we[3] } : (we = ev.hsla.exec(ge), we ? { h: we[1], s: we[2], l: we[3], a: we[4] } : (we = ev.hsv.exec(ge), we ? { h: we[1], s: we[2], v: we[3] } : (we = ev.hsva.exec(ge), we ? { h: we[1], s: we[2], v: we[3], a: we[4] } : (we = ev.hex8.exec(ge), we ? { r: kd(we[1]), g: kd(we[2]), b: kd(we[3]), a: ab(we[4]), format: He ? "name" : "hex8" } : (we = ev.hex6.exec(ge), we ? { r: kd(we[1]), g: kd(we[2]), b: kd(we[3]), format: He ? "name" : "hex" } : (we = ev.hex4.exec(ge), we ? { r: kd(we[1] + we[1]), g: kd(we[2] + we[2]), b: kd(we[3] + we[3]), a: ab(we[4] + we[4]), format: He ? "name" : "hex8" } : (we = ev.hex3.exec(ge), we ? { r: kd(we[1] + we[1]), g: kd(we[2] + we[2]), b: kd(we[3] + we[3]), format: He ? "name" : "hex" } : false)))))))));
          }
          function ob(ge) {
            return Boolean(ev.CSS_UNIT.exec(String(ge)));
          }
          var NS = 2, FC = 0.16, QV = 0.05, eB = 0.05, xY = 0.15, j4 = 5, G4 = 4, tB = [{ index: 7, opacity: 0.15 }, { index: 6, opacity: 0.25 }, { index: 5, opacity: 0.3 }, { index: 5, opacity: 0.45 }, { index: 5, opacity: 0.65 }, { index: 5, opacity: 0.85 }, { index: 4, opacity: 0.9 }, { index: 3, opacity: 0.95 }, { index: 2, opacity: 0.97 }, { index: 1, opacity: 0.98 }];
          function H4(ge) {
            var He = ge.r, we = ge.g, Me = ge.b, Te = RC(He, we, Me);
            return { h: Te.h * 360, s: Te.s, v: Te.v };
          }
          function R3(ge) {
            var He = ge.r, we = ge.g, Me = ge.b;
            return "#".concat(Dd(He, we, Me, false));
          }
          function wY(ge, He, we) {
            var Me = we / 100, Te = { r: (He.r - ge.r) * Me + ge.r, g: (He.g - ge.g) * Me + ge.g, b: (He.b - ge.b) * Me + ge.b };
            return Te;
          }
          function nB(ge, He, we) {
            var Me;
            return Math.round(ge.h) >= 60 && Math.round(ge.h) <= 240 ? Me = we ? Math.round(ge.h) - NS * He : Math.round(ge.h) + NS * He : Me = we ? Math.round(ge.h) + NS * He : Math.round(ge.h) - NS * He, Me < 0 ? Me += 360 : Me >= 360 && (Me -= 360), Me;
          }
          function W4(ge, He, we) {
            if (ge.h === 0 && ge.s === 0)
              return ge.s;
            var Me;
            return we ? Me = ge.s - FC * He : He === G4 ? Me = ge.s + FC : Me = ge.s + QV * He, Me > 1 && (Me = 1), we && He === j4 && Me > 0.1 && (Me = 0.1), Me < 0.06 && (Me = 0.06), Number(Me.toFixed(2));
          }
          function rB(ge, He, we) {
            var Me;
            return we ? Me = ge.v + eB * He : Me = ge.v - xY * He, Me > 1 && (Me = 1), Number(Me.toFixed(2));
          }
          function U4(ge) {
            for (var He = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, we = [], Me = Ep(ge), Te = j4; Te > 0; Te -= 1) {
              var Ne = H4(Me), it = R3(Ep({ h: nB(Ne, Te, true), s: W4(Ne, Te, true), v: rB(Ne, Te, true) }));
              we.push(it);
            }
            we.push(R3(Me));
            for (var ht = 1; ht <= G4; ht += 1) {
              var xt = H4(Me), kt = R3(Ep({ h: nB(xt, ht), s: W4(xt, ht), v: rB(xt, ht) }));
              we.push(kt);
            }
            return He.theme === "dark" ? tB.map(function(Lt) {
              var sn = Lt.index, Bn = Lt.opacity, Xn = R3(wY(Ep(He.backgroundColor || "#141414"), Ep(we[sn]), Bn * 100));
              return Xn;
            }) : we;
          }
          var q4 = { red: "#F5222D", volcano: "#FA541C", orange: "#FA8C16", gold: "#FAAD14", yellow: "#FADB14", lime: "#A0D911", green: "#52C41A", cyan: "#13C2C2", blue: "#1890FF", geekblue: "#2F54EB", purple: "#722ED1", magenta: "#EB2F96", grey: "#666666" }, og = {}, lD = {};
          Object.keys(q4).forEach(function(ge) {
            og[ge] = U4(q4[ge]), og[ge].primary = og[ge][5], lD[ge] = U4(q4[ge], { theme: "dark", backgroundColor: "#141414" }), lD[ge].primary = lD[ge][5];
          }), og.red, og.volcano, og.gold, og.orange, og.yellow, og.lime, og.green, og.cyan, og.blue, og.geekblue, og.purple, og.magenta, og.grey;
          var iB = {};
          function SY(ge, He) {
          }
          function CY(ge, He, we) {
            !He && !iB[we] && (ge(false, we), iB[we] = true);
          }
          function t1(ge, He) {
            CY(SY, ge, He);
          }
          function $4() {
            return !!(typeof window != "undefined" && window.document && window.document.createElement);
          }
          var Ph = "rc-util-key";
          function Xf() {
            var ge = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, He = ge.mark;
            return He ? He.startsWith("data-") ? He : "data-".concat(He) : Ph;
          }
          function X4(ge) {
            if (ge.attachTo)
              return ge.attachTo;
            var He = document.querySelector("head");
            return He || document.body;
          }
          function aB(ge) {
            var He, we = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            if (!$4())
              return null;
            var Me = document.createElement("style");
            if (!((He = we.csp) === null || He === void 0) && He.nonce) {
              var Te;
              Me.nonce = (Te = we.csp) === null || Te === void 0 ? void 0 : Te.nonce;
            }
            Me.innerHTML = ge;
            var Ne = X4(we), it = Ne.firstChild;
            return we.prepend && Ne.prepend ? Ne.prepend(Me) : we.prepend && it ? Ne.insertBefore(Me, it) : Ne.appendChild(Me), Me;
          }
          var Y4 = /* @__PURE__ */ new Map();
          function MY(ge) {
            var He = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, we = X4(He);
            return Array.from(Y4.get(we).children).find(function(Me) {
              return Me.tagName === "STYLE" && Me.getAttribute(Xf(He)) === ge;
            });
          }
          function oB(ge, He) {
            var we = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Me = X4(we);
            if (!Y4.has(Me)) {
              var Te = aB("", we), Ne = Te.parentNode;
              Y4.set(Me, Ne), Ne.removeChild(Te);
            }
            var it = MY(He, we);
            if (it) {
              var ht, xt;
              if (((ht = we.csp) === null || ht === void 0 ? void 0 : ht.nonce) && it.nonce !== ((xt = we.csp) === null || xt === void 0 ? void 0 : xt.nonce)) {
                var kt;
                it.nonce = (kt = we.csp) === null || kt === void 0 ? void 0 : kt.nonce;
              }
              return it.innerHTML !== ge && (it.innerHTML = ge), it;
            }
            var Lt = aB(ge, we);
            return Lt.setAttribute(Xf(we), He), Lt;
          }
          function TY(ge, He) {
            t1(ge, "[@ant-design/icons] ".concat(He));
          }
          function N3(ge) {
            return El(ge) === "object" && typeof ge.name == "string" && typeof ge.theme == "string" && (El(ge.icon) === "object" || typeof ge.icon == "function");
          }
          function sB() {
            var ge = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            return Object.keys(ge).reduce(function(He, we) {
              var Me = ge[we];
              switch (we) {
                case "class":
                  He.className = Me, delete He.class;
                  break;
                default:
                  He[we] = Me;
              }
              return He;
            }, {});
          }
          function Dp(ge, He, we) {
            return we ? ft.default.createElement(ge.tag, Ot(Ot({ key: He }, sB(ge.attrs)), we), (ge.children || []).map(function(Me, Te) {
              return Dp(Me, "".concat(He, "-").concat(ge.tag, "-").concat(Te));
            })) : ft.default.createElement(ge.tag, Ot({ key: He }, sB(ge.attrs)), (ge.children || []).map(function(Me, Te) {
              return Dp(Me, "".concat(He, "-").concat(ge.tag, "-").concat(Te));
            }));
          }
          function F3(ge) {
            return U4(ge)[0];
          }
          function FS(ge) {
            return ge ? Array.isArray(ge) ? ge : [ge] : [];
          }
          var lB = `
.anticon {
  display: inline-block;
  color: inherit;
  font-style: normal;
  line-height: 0;
  text-align: center;
  text-transform: none;
  vertical-align: -0.125em;
  text-rendering: optimizeLegibility;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.anticon > * {
  line-height: 1;
}

.anticon svg {
  display: inline-block;
}

.anticon::before {
  display: none;
}

.anticon .anticon-icon {
  display: block;
}

.anticon[tabindex] {
  cursor: pointer;
}

.anticon-spin::before,
.anticon-spin {
  display: inline-block;
  -webkit-animation: loadingCircle 1s infinite linear;
  animation: loadingCircle 1s infinite linear;
}

@-webkit-keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}

@keyframes loadingCircle {
  100% {
    -webkit-transform: rotate(360deg);
    transform: rotate(360deg);
  }
}
`, K4 = function() {
            var ge = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : lB, He = Ce.useContext(e_), we = He.csp;
            Ce.useEffect(function() {
              oB(ge, "@ant-design-icons", { prepend: true, csp: we });
            }, []);
          }, n1 = ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"], rA = { primaryColor: "#333", secondaryColor: "#E6E6E6", calculated: false };
          function uB(ge) {
            var He = ge.primaryColor, we = ge.secondaryColor;
            rA.primaryColor = He, rA.secondaryColor = we || F3(He), rA.calculated = !!we;
          }
          function cB() {
            return Ot({}, rA);
          }
          var uD = function(ge) {
            var He = ge.icon, we = ge.className, Me = ge.onClick, Te = ge.style, Ne = ge.primaryColor, it = ge.secondaryColor, ht = Go(ge, n1), xt = rA;
            if (Ne && (xt = { primaryColor: Ne, secondaryColor: it || F3(Ne) }), K4(), TY(N3(He), "icon should be icon definiton, but got ".concat(He)), !N3(He))
              return null;
            var kt = He;
            return kt && typeof kt.icon == "function" && (kt = Ot(Ot({}, kt), {}, { icon: kt.icon(xt.primaryColor, xt.secondaryColor) })), Dp(kt.icon, "svg-".concat(kt.name), Ot({ className: we, onClick: Me, style: Te, "data-icon": kt.name, width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" }, ht));
          };
          uD.displayName = "IconReact", uD.getTwoToneColors = cB, uD.setTwoToneColors = uB;
          var V3 = uD;
          function Z4(ge) {
            var He = FS(ge), we = ur(He, 2), Me = we[0], Te = we[1];
            return V3.setTwoToneColors({ primaryColor: Me, secondaryColor: Te });
          }
          function Yy() {
            var ge = V3.getTwoToneColors();
            return ge.calculated ? [ge.primaryColor, ge.secondaryColor] : ge.primaryColor;
          }
          var AY = ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"];
          Z4("#1890ff");
          var qg = st.forwardRef(function(ge, He) {
            var we, Me = ge.className, Te = ge.icon, Ne = ge.spin, it = ge.rotate, ht = ge.tabIndex, xt = ge.onClick, kt = ge.twoToneColor, Lt = Go(ge, AY), sn = st.useContext(e_), Bn = sn.prefixCls, Xn = Bn === void 0 ? "anticon" : Bn, $n = Xl(Xn, (we = {}, dn(we, "".concat(Xn, "-").concat(Te.name), !!Te.name), dn(we, "".concat(Xn, "-spin"), !!Ne || Te.name === "loading"), we), Me), lr = ht;
            lr === void 0 && xt && (lr = -1);
            var br = it ? { msTransform: "rotate(".concat(it, "deg)"), transform: "rotate(".concat(it, "deg)") } : void 0, ki = FS(kt), bi = ur(ki, 2), Oa = bi[0], Ct = bi[1];
            return st.createElement("span", Ot(Ot({ role: "img", "aria-label": Te.name }, Lt), {}, { ref: He, tabIndex: lr, onClick: xt, className: $n }), st.createElement(V3, { icon: Te, primaryColor: Oa, secondaryColor: Ct, style: br }));
          });
          qg.displayName = "AntdIcon", qg.getTwoToneColor = Yy, qg.setTwoToneColor = Z4;
          var IY = qg, fB = { icon: { tag: "svg", attrs: { viewBox: "0 0 1024 1024", focusable: "false" }, children: [{ tag: "path", attrs: { d: "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, name: "loading", theme: "outlined" }, Ex = fB, iA = function(ge, He) {
            return st.createElement(IY, Ot(Ot({}, ge), {}, { ref: He, icon: Ex }));
          };
          iA.displayName = "LoadingOutlined";
          var J4 = st.forwardRef(iA);
          function jl() {
            return jl = Object.assign || function(ge) {
              for (var He = 1; He < arguments.length; He++) {
                var we = arguments[He];
                for (var Me in we)
                  Object.prototype.hasOwnProperty.call(we, Me) && (ge[Me] = we[Me]);
              }
              return ge;
            }, jl.apply(this, arguments);
          }
          function r1(ge, He) {
            if (!(ge instanceof He))
              throw new TypeError("Cannot call a class as a function");
          }
          function B3(ge, He) {
            for (var we = 0; we < He.length; we++) {
              var Me = He[we];
              Me.enumerable = Me.enumerable || false, Me.configurable = true, "value" in Me && (Me.writable = true), Object.defineProperty(ge, Me.key, Me);
            }
          }
          function VS(ge, He, we) {
            return He && B3(ge.prototype, He), we && B3(ge, we), Object.defineProperty(ge, "prototype", { writable: false }), ge;
          }
          function cD(ge, He) {
            return cD = Object.setPrototypeOf || function(we, Me) {
              return we.__proto__ = Me, we;
            }, cD(ge, He);
          }
          function Q4(ge, He) {
            if (typeof He != "function" && He !== null)
              throw new TypeError("Super expression must either be null or a function");
            ge.prototype = Object.create(He && He.prototype, { constructor: { value: ge, writable: true, configurable: true } }), Object.defineProperty(ge, "prototype", { writable: false }), He && cD(ge, He);
          }
          function z32(ge) {
            return z32 = Object.setPrototypeOf ? Object.getPrototypeOf : function(He) {
              return He.__proto__ || Object.getPrototypeOf(He);
            }, z32(ge);
          }
          function EY() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function j3(ge) {
            if (ge === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return ge;
          }
          function G3(ge, He) {
            if (He && (El(He) === "object" || typeof He == "function"))
              return He;
            if (He !== void 0)
              throw new TypeError("Derived constructors may only return object or undefined");
            return j3(ge);
          }
          function BS(ge) {
            var He = EY();
            return function() {
              var we = z32(ge), Me;
              if (He) {
                var Te = z32(this).constructor;
                Me = Reflect.construct(we, arguments, Te);
              } else
                Me = we.apply(this, arguments);
              return G3(this, Me);
            };
          }
          var e6 = { exports: {} }, gf = {};
          /** @license React v16.13.1
          * react-is.production.min.js
          *
          * Copyright (c) Facebook, Inc. and its affiliates.
          *
          * This source code is licensed under the MIT license found in the
          * LICENSE file in the root directory of this source tree.
          */
          var Od = typeof Symbol == "function" && Symbol.for, fD = Od ? Symbol.for("react.element") : 60103, zS = Od ? Symbol.for("react.portal") : 60106, hD = Od ? Symbol.for("react.fragment") : 60107, pD = Od ? Symbol.for("react.strict_mode") : 60108, VC = Od ? Symbol.for("react.profiler") : 60114, jS = Od ? Symbol.for("react.provider") : 60109, dD = Od ? Symbol.for("react.context") : 60110, vD = Od ? Symbol.for("react.async_mode") : 60111, Iv = Od ? Symbol.for("react.concurrent_mode") : 60111, BC = Od ? Symbol.for("react.forward_ref") : 60112, GS = Od ? Symbol.for("react.suspense") : 60113, hB = Od ? Symbol.for("react.suspense_list") : 60120, gD = Od ? Symbol.for("react.memo") : 60115, zC = Od ? Symbol.for("react.lazy") : 60116, H3 = Od ? Symbol.for("react.block") : 60121, DY = Od ? Symbol.for("react.fundamental") : 60117, kY = Od ? Symbol.for("react.responder") : 60118, t6 = Od ? Symbol.for("react.scope") : 60119;
          function Pd(ge) {
            if (typeof ge == "object" && ge !== null) {
              var He = ge.$$typeof;
              switch (He) {
                case fD:
                  switch (ge = ge.type, ge) {
                    case vD:
                    case Iv:
                    case hD:
                    case VC:
                    case pD:
                    case GS:
                      return ge;
                    default:
                      switch (ge = ge && ge.$$typeof, ge) {
                        case dD:
                        case BC:
                        case zC:
                        case gD:
                        case jS:
                          return ge;
                        default:
                          return He;
                      }
                  }
                case zS:
                  return He;
              }
            }
          }
          function pB(ge) {
            return Pd(ge) === Iv;
          }
          gf.AsyncMode = vD, gf.ConcurrentMode = Iv, gf.ContextConsumer = dD, gf.ContextProvider = jS, gf.Element = fD, gf.ForwardRef = BC, gf.Fragment = hD, gf.Lazy = zC, gf.Memo = gD, gf.Portal = zS, gf.Profiler = VC, gf.StrictMode = pD, gf.Suspense = GS, gf.isAsyncMode = function(ge) {
            return pB(ge) || Pd(ge) === vD;
          }, gf.isConcurrentMode = pB, gf.isContextConsumer = function(ge) {
            return Pd(ge) === dD;
          }, gf.isContextProvider = function(ge) {
            return Pd(ge) === jS;
          }, gf.isElement = function(ge) {
            return typeof ge == "object" && ge !== null && ge.$$typeof === fD;
          }, gf.isForwardRef = function(ge) {
            return Pd(ge) === BC;
          }, gf.isFragment = function(ge) {
            return Pd(ge) === hD;
          }, gf.isLazy = function(ge) {
            return Pd(ge) === zC;
          }, gf.isMemo = function(ge) {
            return Pd(ge) === gD;
          }, gf.isPortal = function(ge) {
            return Pd(ge) === zS;
          }, gf.isProfiler = function(ge) {
            return Pd(ge) === VC;
          }, gf.isStrictMode = function(ge) {
            return Pd(ge) === pD;
          }, gf.isSuspense = function(ge) {
            return Pd(ge) === GS;
          }, gf.isValidElementType = function(ge) {
            return typeof ge == "string" || typeof ge == "function" || ge === hD || ge === Iv || ge === VC || ge === pD || ge === GS || ge === hB || typeof ge == "object" && ge !== null && (ge.$$typeof === zC || ge.$$typeof === gD || ge.$$typeof === jS || ge.$$typeof === dD || ge.$$typeof === BC || ge.$$typeof === DY || ge.$$typeof === kY || ge.$$typeof === t6 || ge.$$typeof === H3);
          }, gf.typeOf = Pd, e6.exports = gf;
          function n62(ge) {
            var He = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, we = [];
            return ft.default.Children.forEach(ge, function(Me) {
              Me == null && !He.keepEmpty || (Array.isArray(Me) ? we = we.concat(n62(Me)) : e6.exports.isFragment(Me) && Me.props ? we = we.concat(n62(Me.props.children, He)) : we.push(Me));
            }), we;
          }
          function r6(ge, He) {
            typeof ge == "function" ? ge(He) : El(ge) === "object" && ge && "current" in ge && (ge.current = He);
          }
          function dB() {
            for (var ge = arguments.length, He = new Array(ge), we = 0; we < ge; we++)
              He[we] = arguments[we];
            var Me = He.filter(function(Te) {
              return Te;
            });
            return Me.length <= 1 ? Me[0] : function(Te) {
              He.forEach(function(Ne) {
                r6(Ne, Te);
              });
            };
          }
          function HS(ge) {
            var He, we, Me = e6.exports.isMemo(ge) ? ge.type.type : ge.type;
            return !(typeof Me == "function" && !(!((He = Me.prototype) === null || He === void 0) && He.render) || typeof ge == "function" && !(!((we = ge.prototype) === null || we === void 0) && we.render));
          }
          function W3() {
            try {
              if (!Object.assign)
                return false;
              var ge = new String("abc");
              if (ge[5] = "de", Object.getOwnPropertyNames(ge)[0] === "5")
                return false;
              for (var He = {}, we = 0; we < 10; we++)
                He["_" + String.fromCharCode(we)] = we;
              var Me = Object.getOwnPropertyNames(He).map(function(Ne) {
                return He[Ne];
              });
              if (Me.join("") !== "0123456789")
                return false;
              var Te = {};
              return "abcdefghijklmnopqrst".split("").forEach(function(Ne) {
                Te[Ne] = Ne;
              }), Object.keys(Object.assign({}, Te)).join("") === "abcdefghijklmnopqrst";
            } catch {
              return false;
            }
          }
          W3();
          function OY(ge) {
            if (Array.isArray(ge))
              return Fr(ge);
          }
          function vB(ge) {
            if (typeof Symbol != "undefined" && ge[Symbol.iterator] != null || ge["@@iterator"] != null)
              return Array.from(ge);
          }
          function PY() {
            throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          function vu(ge) {
            return OY(ge) || vB(ge) || Ri(ge) || PY();
          }
          var sg = "RC_FORM_INTERNAL_HOOKS", ah = function() {
            t1(false, "Can not find FormContext. Please make sure you wrap Field under Form.");
          }, $g = st.createContext({ getFieldValue: ah, getFieldsValue: ah, getFieldError: ah, getFieldWarning: ah, getFieldsError: ah, isFieldsTouched: ah, isFieldTouched: ah, isFieldValidating: ah, isFieldsValidating: ah, resetFields: ah, setFields: ah, setFieldsValue: ah, validateFields: ah, submit: ah, getInternalHooks: function() {
            return ah(), { dispatch: ah, initEntityValue: ah, registerField: ah, useSubscribe: ah, setInitialValues: ah, setCallbacks: ah, getFields: ah, setValidateMessages: ah, setPreserve: ah, getInitialValue: ah };
          } });
          function i6(ge) {
            return ge == null ? [] : Array.isArray(ge) ? ge : [ge];
          }
          var gB = { exports: {} };
          (function(ge) {
            var He = function(we) {
              var Me = Object.prototype, Te = Me.hasOwnProperty, Ne, it = typeof Symbol == "function" ? Symbol : {}, ht = it.iterator || "@@iterator", xt = it.asyncIterator || "@@asyncIterator", kt = it.toStringTag || "@@toStringTag";
              function Lt(Oi, ii, ai) {
                return Object.defineProperty(Oi, ii, { value: ai, enumerable: true, configurable: true, writable: true }), Oi[ii];
              }
              try {
                Lt({}, "");
              } catch {
                Lt = function(Oi, ii, ai) {
                  return Oi[ii] = ai;
                };
              }
              function sn(Oi, ii, ai, Ga) {
                var Aa = ii && ii.prototype instanceof bi ? ii : bi, el = Object.create(Aa.prototype), Cc = new Po(Ga || []);
                return el._invoke = Hi(Oi, ai, Cc), el;
              }
              we.wrap = sn;
              function Bn(Oi, ii, ai) {
                try {
                  return { type: "normal", arg: Oi.call(ii, ai) };
                } catch (Ga) {
                  return { type: "throw", arg: Ga };
                }
              }
              var Xn = "suspendedStart", $n = "suspendedYield", lr = "executing", br = "completed", ki = {};
              function bi() {
              }
              function Oa() {
              }
              function Ct() {
              }
              var dr = {};
              Lt(dr, ht, function() {
                return this;
              });
              var Wr = Object.getPrototypeOf, Ci = Wr && Wr(Wr(Mi([])));
              Ci && Ci !== Me && Te.call(Ci, ht) && (dr = Ci);
              var _i = Ct.prototype = bi.prototype = Object.create(dr);
              Oa.prototype = Ct, Lt(_i, "constructor", Ct), Lt(Ct, "constructor", Oa), Oa.displayName = Lt(Ct, kt, "GeneratorFunction");
              function Pr(Oi) {
                ["next", "throw", "return"].forEach(function(ii) {
                  Lt(Oi, ii, function(ai) {
                    return this._invoke(ii, ai);
                  });
                });
              }
              we.isGeneratorFunction = function(Oi) {
                var ii = typeof Oi == "function" && Oi.constructor;
                return ii ? ii === Oa || (ii.displayName || ii.name) === "GeneratorFunction" : false;
              }, we.mark = function(Oi) {
                return Object.setPrototypeOf ? Object.setPrototypeOf(Oi, Ct) : (Oi.__proto__ = Ct, Lt(Oi, kt, "GeneratorFunction")), Oi.prototype = Object.create(_i), Oi;
              }, we.awrap = function(Oi) {
                return { __await: Oi };
              };
              function $r(Oi, ii) {
                function ai(el, Cc, $u, lu) {
                  var Kf = Bn(Oi[el], Oi, Cc);
                  if (Kf.type === "throw")
                    lu(Kf.arg);
                  else {
                    var Xu = Kf.arg, rf = Xu.value;
                    return rf && typeof rf == "object" && Te.call(rf, "__await") ? ii.resolve(rf.__await).then(function(Op) {
                      ai("next", Op, $u, lu);
                    }, function(Op) {
                      ai("throw", Op, $u, lu);
                    }) : ii.resolve(rf).then(function(Op) {
                      Xu.value = Op, $u(Xu);
                    }, function(Op) {
                      return ai("throw", Op, $u, lu);
                    });
                  }
                }
                var Ga;
                function Aa(el, Cc) {
                  function $u() {
                    return new ii(function(lu, Kf) {
                      ai(el, Cc, lu, Kf);
                    });
                  }
                  return Ga = Ga ? Ga.then($u, $u) : $u();
                }
                this._invoke = Aa;
              }
              Pr($r.prototype), Lt($r.prototype, xt, function() {
                return this;
              }), we.AsyncIterator = $r, we.async = function(Oi, ii, ai, Ga, Aa) {
                Aa === void 0 && (Aa = Promise);
                var el = new $r(sn(Oi, ii, ai, Ga), Aa);
                return we.isGeneratorFunction(ii) ? el : el.next().then(function(Cc) {
                  return Cc.done ? Cc.value : el.next();
                });
              };
              function Hi(Oi, ii, ai) {
                var Ga = Xn;
                return function(Aa, el) {
                  if (Ga === lr)
                    throw new Error("Generator is already running");
                  if (Ga === br) {
                    if (Aa === "throw")
                      throw el;
                    return Is();
                  }
                  for (ai.method = Aa, ai.arg = el; ; ) {
                    var Cc = ai.delegate;
                    if (Cc) {
                      var $u = wa(Cc, ai);
                      if ($u) {
                        if ($u === ki)
                          continue;
                        return $u;
                      }
                    }
                    if (ai.method === "next")
                      ai.sent = ai._sent = ai.arg;
                    else if (ai.method === "throw") {
                      if (Ga === Xn)
                        throw Ga = br, ai.arg;
                      ai.dispatchException(ai.arg);
                    } else
                      ai.method === "return" && ai.abrupt("return", ai.arg);
                    Ga = lr;
                    var lu = Bn(Oi, ii, ai);
                    if (lu.type === "normal") {
                      if (Ga = ai.done ? br : $n, lu.arg === ki)
                        continue;
                      return { value: lu.arg, done: ai.done };
                    } else
                      lu.type === "throw" && (Ga = br, ai.method = "throw", ai.arg = lu.arg);
                  }
                };
              }
              function wa(Oi, ii) {
                var ai = Oi.iterator[ii.method];
                if (ai === Ne) {
                  if (ii.delegate = null, ii.method === "throw") {
                    if (Oi.iterator.return && (ii.method = "return", ii.arg = Ne, wa(Oi, ii), ii.method === "throw"))
                      return ki;
                    ii.method = "throw", ii.arg = new TypeError("The iterator does not provide a 'throw' method");
                  }
                  return ki;
                }
                var Ga = Bn(ai, Oi.iterator, ii.arg);
                if (Ga.type === "throw")
                  return ii.method = "throw", ii.arg = Ga.arg, ii.delegate = null, ki;
                var Aa = Ga.arg;
                if (!Aa)
                  return ii.method = "throw", ii.arg = new TypeError("iterator result is not an object"), ii.delegate = null, ki;
                if (Aa.done)
                  ii[Oi.resultName] = Aa.value, ii.next = Oi.nextLoc, ii.method !== "return" && (ii.method = "next", ii.arg = Ne);
                else
                  return Aa;
                return ii.delegate = null, ki;
              }
              Pr(_i), Lt(_i, kt, "Generator"), Lt(_i, ht, function() {
                return this;
              }), Lt(_i, "toString", function() {
                return "[object Generator]";
              });
              function Mr(Oi) {
                var ii = { tryLoc: Oi[0] };
                1 in Oi && (ii.catchLoc = Oi[1]), 2 in Oi && (ii.finallyLoc = Oi[2], ii.afterLoc = Oi[3]), this.tryEntries.push(ii);
              }
              function No(Oi) {
                var ii = Oi.completion || {};
                ii.type = "normal", delete ii.arg, Oi.completion = ii;
              }
              function Po(Oi) {
                this.tryEntries = [{ tryLoc: "root" }], Oi.forEach(Mr, this), this.reset(true);
              }
              we.keys = function(Oi) {
                var ii = [];
                for (var ai in Oi)
                  ii.push(ai);
                return ii.reverse(), function Ga() {
                  for (; ii.length; ) {
                    var Aa = ii.pop();
                    if (Aa in Oi)
                      return Ga.value = Aa, Ga.done = false, Ga;
                  }
                  return Ga.done = true, Ga;
                };
              };
              function Mi(Oi) {
                if (Oi) {
                  var ii = Oi[ht];
                  if (ii)
                    return ii.call(Oi);
                  if (typeof Oi.next == "function")
                    return Oi;
                  if (!isNaN(Oi.length)) {
                    var ai = -1, Ga = function Aa() {
                      for (; ++ai < Oi.length; )
                        if (Te.call(Oi, ai))
                          return Aa.value = Oi[ai], Aa.done = false, Aa;
                      return Aa.value = Ne, Aa.done = true, Aa;
                    };
                    return Ga.next = Ga;
                  }
                }
                return { next: Is };
              }
              we.values = Mi;
              function Is() {
                return { value: Ne, done: true };
              }
              return Po.prototype = { constructor: Po, reset: function(Oi) {
                if (this.prev = 0, this.next = 0, this.sent = this._sent = Ne, this.done = false, this.delegate = null, this.method = "next", this.arg = Ne, this.tryEntries.forEach(No), !Oi)
                  for (var ii in this)
                    ii.charAt(0) === "t" && Te.call(this, ii) && !isNaN(+ii.slice(1)) && (this[ii] = Ne);
              }, stop: function() {
                this.done = true;
                var Oi = this.tryEntries[0], ii = Oi.completion;
                if (ii.type === "throw")
                  throw ii.arg;
                return this.rval;
              }, dispatchException: function(Oi) {
                if (this.done)
                  throw Oi;
                var ii = this;
                function ai(lu, Kf) {
                  return el.type = "throw", el.arg = Oi, ii.next = lu, Kf && (ii.method = "next", ii.arg = Ne), !!Kf;
                }
                for (var Ga = this.tryEntries.length - 1; Ga >= 0; --Ga) {
                  var Aa = this.tryEntries[Ga], el = Aa.completion;
                  if (Aa.tryLoc === "root")
                    return ai("end");
                  if (Aa.tryLoc <= this.prev) {
                    var Cc = Te.call(Aa, "catchLoc"), $u = Te.call(Aa, "finallyLoc");
                    if (Cc && $u) {
                      if (this.prev < Aa.catchLoc)
                        return ai(Aa.catchLoc, true);
                      if (this.prev < Aa.finallyLoc)
                        return ai(Aa.finallyLoc);
                    } else if (Cc) {
                      if (this.prev < Aa.catchLoc)
                        return ai(Aa.catchLoc, true);
                    } else if ($u) {
                      if (this.prev < Aa.finallyLoc)
                        return ai(Aa.finallyLoc);
                    } else
                      throw new Error("try statement without catch or finally");
                  }
                }
              }, abrupt: function(Oi, ii) {
                for (var ai = this.tryEntries.length - 1; ai >= 0; --ai) {
                  var Ga = this.tryEntries[ai];
                  if (Ga.tryLoc <= this.prev && Te.call(Ga, "finallyLoc") && this.prev < Ga.finallyLoc) {
                    var Aa = Ga;
                    break;
                  }
                }
                Aa && (Oi === "break" || Oi === "continue") && Aa.tryLoc <= ii && ii <= Aa.finallyLoc && (Aa = null);
                var el = Aa ? Aa.completion : {};
                return el.type = Oi, el.arg = ii, Aa ? (this.method = "next", this.next = Aa.finallyLoc, ki) : this.complete(el);
              }, complete: function(Oi, ii) {
                if (Oi.type === "throw")
                  throw Oi.arg;
                return Oi.type === "break" || Oi.type === "continue" ? this.next = Oi.arg : Oi.type === "return" ? (this.rval = this.arg = Oi.arg, this.method = "return", this.next = "end") : Oi.type === "normal" && ii && (this.next = ii), ki;
              }, finish: function(Oi) {
                for (var ii = this.tryEntries.length - 1; ii >= 0; --ii) {
                  var ai = this.tryEntries[ii];
                  if (ai.finallyLoc === Oi)
                    return this.complete(ai.completion, ai.afterLoc), No(ai), ki;
                }
              }, catch: function(Oi) {
                for (var ii = this.tryEntries.length - 1; ii >= 0; --ii) {
                  var ai = this.tryEntries[ii];
                  if (ai.tryLoc === Oi) {
                    var Ga = ai.completion;
                    if (Ga.type === "throw") {
                      var Aa = Ga.arg;
                      No(ai);
                    }
                    return Aa;
                  }
                }
                throw new Error("illegal catch attempt");
              }, delegateYield: function(Oi, ii, ai) {
                return this.delegate = { iterator: Mi(Oi), resultName: ii, nextLoc: ai }, this.method === "next" && (this.arg = Ne), ki;
              } }, we;
            }(ge.exports);
            try {
              regeneratorRuntime = He;
            } catch {
              typeof globalThis == "object" ? globalThis.regeneratorRuntime = He : Function("r", "regeneratorRuntime = r")(He);
            }
          })(gB);
          var H0 = gB.exports;
          function Pl(ge, He, we, Me, Te, Ne, it) {
            try {
              var ht = ge[Ne](it), xt = ht.value;
            } catch (kt) {
              we(kt);
              return;
            }
            ht.done ? He(xt) : Promise.resolve(xt).then(Me, Te);
          }
          function Dx(ge) {
            return function() {
              var He = this, we = arguments;
              return new Promise(function(Me, Te) {
                var Ne = ge.apply(He, we);
                function it(xt) {
                  Pl(Ne, Me, Te, it, ht, "next", xt);
                }
                function ht(xt) {
                  Pl(Ne, Me, Te, it, ht, "throw", xt);
                }
                it(void 0);
              });
            };
          }
          function ir() {
            return ir = Object.assign || function(ge) {
              for (var He = 1; He < arguments.length; He++) {
                var we = arguments[He];
                for (var Me in we)
                  Object.prototype.hasOwnProperty.call(we, Me) && (ge[Me] = we[Me]);
              }
              return ge;
            }, ir.apply(this, arguments);
          }
          function li(ge, He) {
            ge.prototype = Object.create(He.prototype), ge.prototype.constructor = ge, go(ge, He);
          }
          function ui(ge) {
            return ui = Object.setPrototypeOf ? Object.getPrototypeOf : function(He) {
              return He.__proto__ || Object.getPrototypeOf(He);
            }, ui(ge);
          }
          function go(ge, He) {
            return go = Object.setPrototypeOf || function(we, Me) {
              return we.__proto__ = Me, we;
            }, go(ge, He);
          }
          function Ll() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function Rc(ge, He, we) {
            return Ll() ? Rc = Reflect.construct : Rc = function(Me, Te, Ne) {
              var it = [null];
              it.push.apply(it, Te);
              var ht = Function.bind.apply(Me, it), xt = new ht();
              return Ne && go(xt, Ne.prototype), xt;
            }, Rc.apply(null, arguments);
          }
          function Ld(ge) {
            return Function.toString.call(ge).indexOf("[native code]") !== -1;
          }
          function If(ge) {
            var He = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
            return If = function(we) {
              if (we === null || !Ld(we))
                return we;
              if (typeof we != "function")
                throw new TypeError("Super expression must either be null or a function");
              if (typeof He != "undefined") {
                if (He.has(we))
                  return He.get(we);
                He.set(we, Me);
              }
              function Me() {
                return Rc(we, arguments, ui(this).constructor);
              }
              return Me.prototype = Object.create(we.prototype, { constructor: { value: Me, enumerable: false, writable: true, configurable: true } }), go(Me, we);
            }, If(ge);
          }
          var a6 = /%[sdj%]/g, o6 = function() {
          };
          typeof process != "undefined" && process.env;
          function W0(ge) {
            if (!ge || !ge.length)
              return null;
            var He = {};
            return ge.forEach(function(we) {
              var Me = we.field;
              He[Me] = He[Me] || [], He[Me].push(we);
            }), He;
          }
          function Kh(ge) {
            for (var He = arguments.length, we = new Array(He > 1 ? He - 1 : 0), Me = 1; Me < He; Me++)
              we[Me - 1] = arguments[Me];
            var Te = 0, Ne = we.length;
            if (typeof ge == "function")
              return ge.apply(null, we);
            if (typeof ge == "string") {
              var it = ge.replace(a6, function(ht) {
                if (ht === "%%")
                  return "%";
                if (Te >= Ne)
                  return ht;
                switch (ht) {
                  case "%s":
                    return String(we[Te++]);
                  case "%d":
                    return Number(we[Te++]);
                  case "%j":
                    try {
                      return JSON.stringify(we[Te++]);
                    } catch {
                      return "[Circular]";
                    }
                    break;
                  default:
                    return ht;
                }
              });
              return it;
            }
            return ge;
          }
          function yB(ge) {
            return ge === "string" || ge === "url" || ge === "hex" || ge === "email" || ge === "date" || ge === "pattern";
          }
          function Yf(ge, He) {
            return !!(ge == null || He === "array" && Array.isArray(ge) && !ge.length || yB(He) && typeof ge == "string" && !ge);
          }
          function oh(ge, He, we) {
            var Me = [], Te = 0, Ne = ge.length;
            function it(ht) {
              Me.push.apply(Me, ht || []), Te++, Te === Ne && we(Me);
            }
            ge.forEach(function(ht) {
              He(ht, it);
            });
          }
          function sh(ge, He, we) {
            var Me = 0, Te = ge.length;
            function Ne(it) {
              if (it && it.length) {
                we(it);
                return;
              }
              var ht = Me;
              Me = Me + 1, ht < Te ? He(ge[ht], Ne) : we([]);
            }
            Ne([]);
          }
          function yf(ge) {
            var He = [];
            return Object.keys(ge).forEach(function(we) {
              He.push.apply(He, ge[we] || []);
            }), He;
          }
          var mB = function(ge) {
            li(He, ge);
            function He(we, Me) {
              var Te;
              return Te = ge.call(this, "Async Validation Error") || this, Te.errors = we, Te.fields = Me, Te;
            }
            return He;
          }(If(Error));
          function bB(ge, He, we, Me, Te) {
            if (He.first) {
              var Ne = new Promise(function(Bn, Xn) {
                var $n = function(br) {
                  return Me(br), br.length ? Xn(new mB(br, W0(br))) : Bn(Te);
                }, lr = yf(ge);
                sh(lr, we, $n);
              });
              return Ne.catch(function(Bn) {
                return Bn;
              }), Ne;
            }
            var it = He.firstFields === true ? Object.keys(ge) : He.firstFields || [], ht = Object.keys(ge), xt = ht.length, kt = 0, Lt = [], sn = new Promise(function(Bn, Xn) {
              var $n = function(lr) {
                if (Lt.push.apply(Lt, lr), kt++, kt === xt)
                  return Me(Lt), Lt.length ? Xn(new mB(Lt, W0(Lt))) : Bn(Te);
              };
              ht.length || (Me(Lt), Bn(Te)), ht.forEach(function(lr) {
                var br = ge[lr];
                it.indexOf(lr) !== -1 ? sh(br, we, $n) : oh(br, we, $n);
              });
            });
            return sn.catch(function(Bn) {
              return Bn;
            }), sn;
          }
          function U3(ge) {
            return !!(ge && ge.message !== void 0);
          }
          function LY(ge, He) {
            for (var we = ge, Me = 0; Me < He.length; Me++) {
              if (we == null)
                return we;
              we = we[He[Me]];
            }
            return we;
          }
          function _B(ge, He) {
            return function(we) {
              var Me;
              return ge.fullFields ? Me = LY(He, ge.fullFields) : Me = He[we.field || ge.fullField], U3(we) ? (we.field = we.field || ge.fullField, we.fieldValue = Me, we) : { message: typeof we == "function" ? we() : we, fieldValue: Me, field: we.field || ge.fullField };
            };
          }
          function xB(ge, He) {
            if (He) {
              for (var we in He)
                if (He.hasOwnProperty(we)) {
                  var Me = He[we];
                  typeof Me == "object" && typeof ge[we] == "object" ? ge[we] = ir({}, ge[we], Me) : ge[we] = Me;
                }
            }
            return ge;
          }
          var aA = function(ge, He, we, Me, Te, Ne) {
            ge.required && (!we.hasOwnProperty(ge.field) || Yf(He, Ne || ge.type)) && Me.push(Kh(Te.messages.required, ge.fullField));
          }, i1 = function(ge, He, we, Me, Te) {
            (/^\s+$/.test(He) || He === "") && Me.push(Kh(Te.messages.whitespace, ge.fullField));
          }, WS = { email: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+\.)+[a-zA-Z\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]{2,}))$/, url: new RegExp("^(?!mailto:)(?:(?:http|https|ftp)://|//)(?:\\S+(?::\\S*)?@)?(?:(?:(?:[1-9]\\d?|1\\d\\d|2[01]\\d|22[0-3])(?:\\.(?:1?\\d{1,2}|2[0-4]\\d|25[0-5])){2}(?:\\.(?:[0-9]\\d?|1\\d\\d|2[0-4]\\d|25[0-4]))|(?:(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)(?:\\.(?:[a-z\\u00a1-\\uffff0-9]+-*)*[a-z\\u00a1-\\uffff0-9]+)*(?:\\.(?:[a-z\\u00a1-\\uffff]{2,})))|localhost)(?::\\d{2,5})?(?:(/|\\?|#)[^\\s]*)?$", "i"), hex: /^#?([a-f0-9]{6}|[a-f0-9]{3})$/i }, oA = { integer: function(ge) {
            return oA.number(ge) && parseInt(ge, 10) === ge;
          }, float: function(ge) {
            return oA.number(ge) && !oA.integer(ge);
          }, array: function(ge) {
            return Array.isArray(ge);
          }, regexp: function(ge) {
            if (ge instanceof RegExp)
              return true;
            try {
              return !!new RegExp(ge);
            } catch {
              return false;
            }
          }, date: function(ge) {
            return typeof ge.getTime == "function" && typeof ge.getMonth == "function" && typeof ge.getYear == "function" && !isNaN(ge.getTime());
          }, number: function(ge) {
            return isNaN(ge) ? false : typeof ge == "number";
          }, object: function(ge) {
            return typeof ge == "object" && !oA.array(ge);
          }, method: function(ge) {
            return typeof ge == "function";
          }, email: function(ge) {
            return typeof ge == "string" && ge.length <= 320 && !!ge.match(WS.email);
          }, url: function(ge) {
            return typeof ge == "string" && ge.length <= 2048 && !!ge.match(WS.url);
          }, hex: function(ge) {
            return typeof ge == "string" && !!ge.match(WS.hex);
          } }, yD = function(ge, He, we, Me, Te) {
            if (ge.required && He === void 0) {
              aA(ge, He, we, Me, Te);
              return;
            }
            var Ne = ["integer", "float", "array", "regexp", "object", "method", "email", "number", "date", "url", "hex"], it = ge.type;
            Ne.indexOf(it) > -1 ? oA[it](He) || Me.push(Kh(Te.messages.types[it], ge.fullField, ge.type)) : it && typeof He !== ge.type && Me.push(Kh(Te.messages.types[it], ge.fullField, ge.type));
          }, mD = function(ge, He, we, Me, Te) {
            var Ne = typeof ge.len == "number", it = typeof ge.min == "number", ht = typeof ge.max == "number", xt = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g, kt = He, Lt = null, sn = typeof He == "number", Bn = typeof He == "string", Xn = Array.isArray(He);
            if (sn ? Lt = "number" : Bn ? Lt = "string" : Xn && (Lt = "array"), !Lt)
              return false;
            Xn && (kt = He.length), Bn && (kt = He.replace(xt, "_").length), Ne ? kt !== ge.len && Me.push(Kh(Te.messages[Lt].len, ge.fullField, ge.len)) : it && !ht && kt < ge.min ? Me.push(Kh(Te.messages[Lt].min, ge.fullField, ge.min)) : ht && !it && kt > ge.max ? Me.push(Kh(Te.messages[Lt].max, ge.fullField, ge.max)) : it && ht && (kt < ge.min || kt > ge.max) && Me.push(Kh(Te.messages[Lt].range, ge.fullField, ge.min, ge.max));
          }, Rd = "enum", kx = function(ge, He, we, Me, Te) {
            ge[Rd] = Array.isArray(ge[Rd]) ? ge[Rd] : [], ge[Rd].indexOf(He) === -1 && Me.push(Kh(Te.messages[Rd], ge.fullField, ge[Rd].join(", ")));
          }, wB = function(ge, He, we, Me, Te) {
            if (ge.pattern) {
              if (ge.pattern instanceof RegExp)
                ge.pattern.lastIndex = 0, ge.pattern.test(He) || Me.push(Kh(Te.messages.pattern.mismatch, ge.fullField, He, ge.pattern));
              else if (typeof ge.pattern == "string") {
                var Ne = new RegExp(ge.pattern);
                Ne.test(He) || Me.push(Kh(Te.messages.pattern.mismatch, ge.fullField, He, ge.pattern));
              }
            }
          }, gu = { required: aA, whitespace: i1, type: yD, range: mD, enum: kx, pattern: wB }, jC = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He, "string") && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te, "string"), Yf(He, "string") || (gu.type(ge, He, Me, Ne, Te), gu.range(ge, He, Me, Ne, Te), gu.pattern(ge, He, Me, Ne, Te), ge.whitespace === true && gu.whitespace(ge, He, Me, Ne, Te));
            }
            we(Ne);
          }, q3 = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && gu.type(ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, RY = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (He === "" && (He = void 0), Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && (gu.type(ge, He, Me, Ne, Te), gu.range(ge, He, Me, Ne, Te));
            }
            we(Ne);
          }, SB = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && gu.type(ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, Ox = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), Yf(He) || gu.type(ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, Rl = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && (gu.type(ge, He, Me, Ne, Te), gu.range(ge, He, Me, Ne, Te));
            }
            we(Ne);
          }, bD = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && (gu.type(ge, He, Me, Ne, Te), gu.range(ge, He, Me, Ne, Te));
            }
            we(Ne);
          }, U0 = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (He == null && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te, "array"), He != null && (gu.type(ge, He, Me, Ne, Te), gu.range(ge, He, Me, Ne, Te));
            }
            we(Ne);
          }, CB = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && gu.type(ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, MB = "enum", mf = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), He !== void 0 && gu[MB](ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, NY = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He, "string") && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te), Yf(He, "string") || gu.pattern(ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, cd = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He, "date") && !ge.required)
                return we();
              if (gu.required(ge, He, Me, Ne, Te), !Yf(He, "date")) {
                var ht;
                He instanceof Date ? ht = He : ht = new Date(He), gu.type(ge, ht, Me, Ne, Te), ht && gu.range(ge, ht.getTime(), Me, Ne, Te);
              }
            }
            we(Ne);
          }, Nd = function(ge, He, we, Me, Te) {
            var Ne = [], it = Array.isArray(He) ? "array" : typeof He;
            gu.required(ge, He, Me, Ne, Te, it), we(Ne);
          }, s6 = function(ge, He, we, Me, Te) {
            var Ne = ge.type, it = [], ht = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (ht) {
              if (Yf(He, Ne) && !ge.required)
                return we();
              gu.required(ge, He, Me, it, Te, Ne), Yf(He, Ne) || gu.type(ge, He, Me, it, Te);
            }
            we(it);
          }, FY = function(ge, He, we, Me, Te) {
            var Ne = [], it = ge.required || !ge.required && Me.hasOwnProperty(ge.field);
            if (it) {
              if (Yf(He) && !ge.required)
                return we();
              gu.required(ge, He, Me, Ne, Te);
            }
            we(Ne);
          }, sA = { string: jC, method: q3, number: RY, boolean: SB, regexp: Ox, integer: Rl, float: bD, array: U0, object: CB, enum: mf, pattern: NY, date: cd, url: s6, hex: s6, email: s6, required: Nd, any: FY };
          function l6() {
            return { default: "Validation error on field %s", required: "%s is required", enum: "%s must be one of %s", whitespace: "%s cannot be empty", date: { format: "%s date %s is invalid for format %s", parse: "%s date could not be parsed, %s is invalid ", invalid: "%s date %s is invalid" }, types: { string: "%s is not a %s", method: "%s is not a %s (function)", array: "%s is not an %s", object: "%s is not an %s", number: "%s is not a %s", date: "%s is not a %s", boolean: "%s is not a %s", integer: "%s is not an %s", float: "%s is not a %s", regexp: "%s is not a valid %s", email: "%s is not a valid %s", url: "%s is not a valid %s", hex: "%s is not a valid %s" }, string: { len: "%s must be exactly %s characters", min: "%s must be at least %s characters", max: "%s cannot be longer than %s characters", range: "%s must be between %s and %s characters" }, number: { len: "%s must equal %s", min: "%s cannot be less than %s", max: "%s cannot be greater than %s", range: "%s must be between %s and %s" }, array: { len: "%s must be exactly %s in length", min: "%s cannot be less than %s in length", max: "%s cannot be greater than %s in length", range: "%s must be between %s and %s in length" }, pattern: { mismatch: "%s value %s does not match pattern %s" }, clone: function() {
              var ge = JSON.parse(JSON.stringify(this));
              return ge.clone = this.clone, ge;
            } };
          }
          var _D = l6(), Px = function() {
            function ge(we) {
              this.rules = null, this._messages = _D, this.define(we);
            }
            var He = ge.prototype;
            return He.define = function(we) {
              var Me = this;
              if (!we)
                throw new Error("Cannot configure a schema with no rules");
              if (typeof we != "object" || Array.isArray(we))
                throw new Error("Rules must be an object");
              this.rules = {}, Object.keys(we).forEach(function(Te) {
                var Ne = we[Te];
                Me.rules[Te] = Array.isArray(Ne) ? Ne : [Ne];
              });
            }, He.messages = function(we) {
              return we && (this._messages = xB(l6(), we)), this._messages;
            }, He.validate = function(we, Me, Te) {
              var Ne = this;
              Me === void 0 && (Me = {}), Te === void 0 && (Te = function() {
              });
              var it = we, ht = Me, xt = Te;
              if (typeof ht == "function" && (xt = ht, ht = {}), !this.rules || Object.keys(this.rules).length === 0)
                return xt && xt(null, it), Promise.resolve(it);
              function kt($n) {
                var lr = [], br = {};
                function ki(Oa) {
                  if (Array.isArray(Oa)) {
                    var Ct;
                    lr = (Ct = lr).concat.apply(Ct, Oa);
                  } else
                    lr.push(Oa);
                }
                for (var bi = 0; bi < $n.length; bi++)
                  ki($n[bi]);
                lr.length ? (br = W0(lr), xt(lr, br)) : xt(null, it);
              }
              if (ht.messages) {
                var Lt = this.messages();
                Lt === _D && (Lt = l6()), xB(Lt, ht.messages), ht.messages = Lt;
              } else
                ht.messages = this.messages();
              var sn = {}, Bn = ht.keys || Object.keys(this.rules);
              Bn.forEach(function($n) {
                var lr = Ne.rules[$n], br = it[$n];
                lr.forEach(function(ki) {
                  var bi = ki;
                  typeof bi.transform == "function" && (it === we && (it = ir({}, it)), br = it[$n] = bi.transform(br)), typeof bi == "function" ? bi = { validator: bi } : bi = ir({}, bi), bi.validator = Ne.getValidationMethod(bi), bi.validator && (bi.field = $n, bi.fullField = bi.fullField || $n, bi.type = Ne.getType(bi), sn[$n] = sn[$n] || [], sn[$n].push({ rule: bi, value: br, source: it, field: $n }));
                });
              });
              var Xn = {};
              return bB(sn, ht, function($n, lr) {
                var br = $n.rule, ki = (br.type === "object" || br.type === "array") && (typeof br.fields == "object" || typeof br.defaultField == "object");
                ki = ki && (br.required || !br.required && $n.value), br.field = $n.field;
                function bi(dr, Wr) {
                  return ir({}, Wr, { fullField: br.fullField + "." + dr, fullFields: br.fullFields ? [].concat(br.fullFields, [dr]) : [dr] });
                }
                function Oa(dr) {
                  dr === void 0 && (dr = []);
                  var Wr = Array.isArray(dr) ? dr : [dr];
                  !ht.suppressWarning && Wr.length && ge.warning("async-validator:", Wr), Wr.length && br.message !== void 0 && (Wr = [].concat(br.message));
                  var Ci = Wr.map(_B(br, it));
                  if (ht.first && Ci.length)
                    return Xn[br.field] = 1, lr(Ci);
                  if (!ki)
                    lr(Ci);
                  else {
                    if (br.required && !$n.value)
                      return br.message !== void 0 ? Ci = [].concat(br.message).map(_B(br, it)) : ht.error && (Ci = [ht.error(br, Kh(ht.messages.required, br.field))]), lr(Ci);
                    var _i = {};
                    br.defaultField && Object.keys($n.value).map(function(Hi) {
                      _i[Hi] = br.defaultField;
                    }), _i = ir({}, _i, $n.rule.fields);
                    var Pr = {};
                    Object.keys(_i).forEach(function(Hi) {
                      var wa = _i[Hi], Mr = Array.isArray(wa) ? wa : [wa];
                      Pr[Hi] = Mr.map(bi.bind(null, Hi));
                    });
                    var $r = new ge(Pr);
                    $r.messages(ht.messages), $n.rule.options && ($n.rule.options.messages = ht.messages, $n.rule.options.error = ht.error), $r.validate($n.value, $n.rule.options || ht, function(Hi) {
                      var wa = [];
                      Ci && Ci.length && wa.push.apply(wa, Ci), Hi && Hi.length && wa.push.apply(wa, Hi), lr(wa.length ? wa : null);
                    });
                  }
                }
                var Ct;
                br.asyncValidator ? Ct = br.asyncValidator(br, $n.value, Oa, $n.source, ht) : br.validator && (Ct = br.validator(br, $n.value, Oa, $n.source, ht), Ct === true ? Oa() : Ct === false ? Oa(typeof br.message == "function" ? br.message(br.fullField || br.field) : br.message || (br.fullField || br.field) + " fails") : Ct instanceof Array ? Oa(Ct) : Ct instanceof Error && Oa(Ct.message)), Ct && Ct.then && Ct.then(function() {
                  return Oa();
                }, function(dr) {
                  return Oa(dr);
                });
              }, function($n) {
                kt($n);
              }, it);
            }, He.getType = function(we) {
              if (we.type === void 0 && we.pattern instanceof RegExp && (we.type = "pattern"), typeof we.validator != "function" && we.type && !sA.hasOwnProperty(we.type))
                throw new Error(Kh("Unknown rule type %s", we.type));
              return we.type || "string";
            }, He.getValidationMethod = function(we) {
              if (typeof we.validator == "function")
                return we.validator;
              var Me = Object.keys(we), Te = Me.indexOf("message");
              return Te !== -1 && Me.splice(Te, 1), Me.length === 1 && Me[0] === "required" ? sA.required : sA[this.getType(we)] || void 0;
            }, ge;
          }();
          Px.register = function(ge, He) {
            if (typeof He != "function")
              throw new Error("Cannot register a validator by type, validator is not a function");
            sA[ge] = He;
          }, Px.warning = o6, Px.messages = _D, Px.validators = sA;
          var Xg = "'${name}' is not a valid ${type}", GC = { default: "Validation error on field '${name}'", required: "'${name}' is required", enum: "'${name}' must be one of [${enum}]", whitespace: "'${name}' cannot be empty", date: { format: "'${name}' is invalid for format date", parse: "'${name}' could not be parsed as date", invalid: "'${name}' is invalid date" }, types: { string: Xg, method: Xg, array: Xg, object: Xg, number: Xg, date: Xg, boolean: Xg, integer: Xg, float: Xg, regexp: Xg, email: Xg, url: Xg, hex: Xg }, string: { len: "'${name}' must be exactly ${len} characters", min: "'${name}' must be at least ${min} characters", max: "'${name}' cannot be longer than ${max} characters", range: "'${name}' must be between ${min} and ${max} characters" }, number: { len: "'${name}' must equal ${len}", min: "'${name}' cannot be less than ${min}", max: "'${name}' cannot be greater than ${max}", range: "'${name}' must be between ${min} and ${max}" }, array: { len: "'${name}' must be exactly ${len} in length", min: "'${name}' cannot be less than ${min} in length", max: "'${name}' cannot be greater than ${max} in length", range: "'${name}' must be between ${min} and ${max} in length" }, pattern: { mismatch: "'${name}' does not match pattern ${pattern}" } };
          function lA(ge, He) {
            for (var we = ge, Me = 0; Me < He.length; Me += 1) {
              if (we == null)
                return;
              we = we[He[Me]];
            }
            return we;
          }
          function xD(ge) {
            return gn(ge) || vB(ge) || Ri(ge) || di();
          }
          function wD(ge, He, we, Me) {
            if (!He.length)
              return we;
            var Te = xD(He), Ne = Te[0], it = Te.slice(1), ht;
            return !ge && typeof Ne == "number" ? ht = [] : Array.isArray(ge) ? ht = vu(ge) : ht = Ot({}, ge), Me && we === void 0 && it.length === 1 ? delete ht[Ne][it[0]] : ht[Ne] = wD(ht[Ne], it, we, Me), ht;
          }
          function uA(ge, He, we) {
            var Me = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
            return He.length && Me && we === void 0 && !lA(ge, He.slice(0, -1)) ? ge : wD(ge, He, we, Me);
          }
          function fd(ge) {
            return i6(ge);
          }
          function US(ge, He) {
            var we = lA(ge, He);
            return we;
          }
          function HC(ge, He, we) {
            var Me = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, Te = uA(ge, He, we, Me);
            return Te;
          }
          function $3(ge, He) {
            var we = {};
            return He.forEach(function(Me) {
              var Te = US(ge, Me);
              we = HC(we, Me, Te);
            }), we;
          }
          function SD(ge, He) {
            return ge && ge.some(function(we) {
              return Bt(we, He);
            });
          }
          function CD(ge) {
            return El(ge) === "object" && ge !== null && Object.getPrototypeOf(ge) === Object.prototype;
          }
          function cA(ge, He) {
            var we = Array.isArray(ge) ? vu(ge) : Ot({}, ge);
            return He && Object.keys(He).forEach(function(Me) {
              var Te = we[Me], Ne = He[Me], it = CD(Te) && CD(Ne);
              we[Me] = it ? cA(Te, Ne || {}) : Ne;
            }), we;
          }
          function kp(ge) {
            for (var He = arguments.length, we = new Array(He > 1 ? He - 1 : 0), Me = 1; Me < He; Me++)
              we[Me - 1] = arguments[Me];
            return we.reduce(function(Te, Ne) {
              return cA(Te, Ne);
            }, ge);
          }
          function Bt(ge, He) {
            return !ge || !He || ge.length !== He.length ? false : ge.every(function(we, Me) {
              return He[Me] === we;
            });
          }
          function fA(ge, He) {
            if (ge === He)
              return true;
            if (!ge && He || ge && !He || !ge || !He || El(ge) !== "object" || El(He) !== "object")
              return false;
            var we = Object.keys(ge), Me = Object.keys(He), Te = new Set([].concat(vu(we), vu(Me)));
            return vu(Te).every(function(Ne) {
              var it = ge[Ne], ht = He[Ne];
              return typeof it == "function" && typeof ht == "function" ? true : it === ht;
            });
          }
          function X3(ge) {
            var He = arguments.length <= 1 ? void 0 : arguments[1];
            return He && He.target && El(He.target) === "object" && ge in He.target ? He.target[ge] : He;
          }
          function Ky(ge, He, we) {
            var Me = ge.length;
            if (He < 0 || He >= Me || we < 0 || we >= Me)
              return ge;
            var Te = ge[He], Ne = He - we;
            return Ne > 0 ? [].concat(vu(ge.slice(0, we)), [Te], vu(ge.slice(we, He)), vu(ge.slice(He + 1, Me))) : Ne < 0 ? [].concat(vu(ge.slice(0, He)), vu(ge.slice(He + 1, we + 1)), [Te], vu(ge.slice(we + 1, Me))) : ge;
          }
          var qu = Px;
          function VY(ge, He) {
            return ge.replace(/\$\{\w+\}/g, function(we) {
              var Me = we.slice(2, -1);
              return He[Me];
            });
          }
          function u6(ge, He, we, Me, Te) {
            return c6.apply(this, arguments);
          }
          function c6() {
            return c6 = Dx(H0.mark(function ge(He, we, Me, Te, Ne) {
              var it, ht, xt, kt, Lt, sn, Bn, Xn;
              return H0.wrap(function($n) {
                for (; ; )
                  switch ($n.prev = $n.next) {
                    case 0:
                      return it = Ot({}, Me), delete it.ruleIndex, ht = null, it && it.type === "array" && it.defaultField && (ht = it.defaultField, delete it.defaultField), xt = new qu(dn({}, He, [it])), kt = kp({}, GC, Te.validateMessages), xt.messages(kt), Lt = [], $n.prev = 8, $n.next = 11, Promise.resolve(xt.validate(dn({}, He, we), Ot({}, Te)));
                    case 11:
                      $n.next = 16;
                      break;
                    case 13:
                      $n.prev = 13, $n.t0 = $n.catch(8), $n.t0.errors ? Lt = $n.t0.errors.map(function(lr, br) {
                        var ki = lr.message;
                        return st.isValidElement(ki) ? st.cloneElement(ki, { key: "error_".concat(br) }) : ki;
                      }) : (console.error($n.t0), Lt = [kt.default]);
                    case 16:
                      if (!(!Lt.length && ht)) {
                        $n.next = 21;
                        break;
                      }
                      return $n.next = 19, Promise.all(we.map(function(lr, br) {
                        return u6("".concat(He, ".").concat(br), lr, ht, Te, Ne);
                      }));
                    case 19:
                      return sn = $n.sent, $n.abrupt("return", sn.reduce(function(lr, br) {
                        return [].concat(vu(lr), vu(br));
                      }, []));
                    case 21:
                      return Bn = Ot(Ot({}, Me), {}, { name: He, enum: (Me.enum || []).join(", ") }, Ne), Xn = Lt.map(function(lr) {
                        return typeof lr == "string" ? VY(lr, Bn) : lr;
                      }), $n.abrupt("return", Xn);
                    case 24:
                    case "end":
                      return $n.stop();
                  }
              }, ge, null, [[8, 13]]);
            })), c6.apply(this, arguments);
          }
          function qS(ge, He, we, Me, Te, Ne) {
            var it = ge.join("."), ht = we.map(function(Lt, sn) {
              var Bn = Lt.validator, Xn = Ot(Ot({}, Lt), {}, { ruleIndex: sn });
              return Bn && (Xn.validator = function($n, lr, br) {
                var ki = false, bi = function() {
                  for (var Ct = arguments.length, dr = new Array(Ct), Wr = 0; Wr < Ct; Wr++)
                    dr[Wr] = arguments[Wr];
                  Promise.resolve().then(function() {
                    t1(!ki, "Your validator function has already return a promise. `callback` will be ignored."), ki || br.apply(void 0, dr);
                  });
                }, Oa = Bn($n, lr, bi);
                ki = Oa && typeof Oa.then == "function" && typeof Oa.catch == "function", t1(ki, "`callback` is deprecated. Please return a promise instead."), ki && Oa.then(function() {
                  br();
                }).catch(function(Ct) {
                  br(Ct || " ");
                });
              }), Xn;
            }).sort(function(Lt, sn) {
              var Bn = Lt.warningOnly, Xn = Lt.ruleIndex, $n = sn.warningOnly, lr = sn.ruleIndex;
              return !!Bn == !!$n ? Xn - lr : Bn ? 1 : -1;
            }), xt;
            if (Te === true)
              xt = new Promise(function() {
                var Lt = Dx(H0.mark(function sn(Bn, Xn) {
                  var $n, lr, br;
                  return H0.wrap(function(ki) {
                    for (; ; )
                      switch (ki.prev = ki.next) {
                        case 0:
                          $n = 0;
                        case 1:
                          if (!($n < ht.length)) {
                            ki.next = 12;
                            break;
                          }
                          return lr = ht[$n], ki.next = 5, u6(it, He, lr, Me, Ne);
                        case 5:
                          if (br = ki.sent, !br.length) {
                            ki.next = 9;
                            break;
                          }
                          return Xn([{ errors: br, rule: lr }]), ki.abrupt("return");
                        case 9:
                          $n += 1, ki.next = 1;
                          break;
                        case 12:
                          Bn([]);
                        case 13:
                        case "end":
                          return ki.stop();
                      }
                  }, sn);
                }));
                return function(sn, Bn) {
                  return Lt.apply(this, arguments);
                };
              }());
            else {
              var kt = ht.map(function(Lt) {
                return u6(it, He, Lt, Me, Ne).then(function(sn) {
                  return { errors: sn, rule: Lt };
                });
              });
              xt = (Te ? zY(kt) : BY(kt)).then(function(Lt) {
                return Promise.reject(Lt);
              });
            }
            return xt.catch(function(Lt) {
              return Lt;
            }), xt;
          }
          function BY(ge) {
            return f62.apply(this, arguments);
          }
          function f62() {
            return f62 = Dx(H0.mark(function ge(He) {
              return H0.wrap(function(we) {
                for (; ; )
                  switch (we.prev = we.next) {
                    case 0:
                      return we.abrupt("return", Promise.all(He).then(function(Me) {
                        var Te, Ne = (Te = []).concat.apply(Te, vu(Me));
                        return Ne;
                      }));
                    case 1:
                    case "end":
                      return we.stop();
                  }
              }, ge);
            })), f62.apply(this, arguments);
          }
          function zY(ge) {
            return Y3.apply(this, arguments);
          }
          function Y3() {
            return Y3 = Dx(H0.mark(function ge(He) {
              var we;
              return H0.wrap(function(Me) {
                for (; ; )
                  switch (Me.prev = Me.next) {
                    case 0:
                      return we = 0, Me.abrupt("return", new Promise(function(Te) {
                        He.forEach(function(Ne) {
                          Ne.then(function(it) {
                            it.errors.length && Te([it]), we += 1, we === He.length && Te([]);
                          });
                        });
                      }));
                    case 2:
                    case "end":
                      return Me.stop();
                  }
              }, ge);
            })), Y3.apply(this, arguments);
          }
          var TB = ["name"], hd = [];
          function AB(ge, He, we, Me, Te, Ne) {
            return typeof ge == "function" ? ge(He, we, "source" in Ne ? { source: Ne.source } : {}) : Me !== Te;
          }
          var h6 = function(ge) {
            Q4(we, ge);
            var He = BS(we);
            function we(Me) {
              var Te;
              if (r1(this, we), Te = He.call(this, Me), Te.state = { resetCount: 0 }, Te.cancelRegisterFunc = null, Te.mounted = false, Te.touched = false, Te.dirty = false, Te.validatePromise = null, Te.prevValidating = void 0, Te.errors = hd, Te.warnings = hd, Te.cancelRegister = function() {
                var xt = Te.props, kt = xt.preserve, Lt = xt.isListField, sn = xt.name;
                Te.cancelRegisterFunc && Te.cancelRegisterFunc(Lt, kt, fd(sn)), Te.cancelRegisterFunc = null;
              }, Te.getNamePath = function() {
                var xt = Te.props, kt = xt.name, Lt = xt.fieldContext, sn = Lt.prefixName, Bn = sn === void 0 ? [] : sn;
                return kt !== void 0 ? [].concat(vu(Bn), vu(kt)) : [];
              }, Te.getRules = function() {
                var xt = Te.props, kt = xt.rules, Lt = kt === void 0 ? [] : kt, sn = xt.fieldContext;
                return Lt.map(function(Bn) {
                  return typeof Bn == "function" ? Bn(sn) : Bn;
                });
              }, Te.refresh = function() {
                !Te.mounted || Te.setState(function(xt) {
                  var kt = xt.resetCount;
                  return { resetCount: kt + 1 };
                });
              }, Te.triggerMetaEvent = function(xt) {
                var kt = Te.props.onMetaChange;
                kt == null || kt(Ot(Ot({}, Te.getMeta()), {}, { destroy: xt }));
              }, Te.onStoreChange = function(xt, kt, Lt) {
                var sn = Te.props, Bn = sn.shouldUpdate, Xn = sn.dependencies, $n = Xn === void 0 ? [] : Xn, lr = sn.onReset, br = Lt.store, ki = Te.getNamePath(), bi = Te.getValue(xt), Oa = Te.getValue(br), Ct = kt && SD(kt, ki);
                switch (Lt.type === "valueUpdate" && Lt.source === "external" && bi !== Oa && (Te.touched = true, Te.dirty = true, Te.validatePromise = null, Te.errors = hd, Te.warnings = hd, Te.triggerMetaEvent()), Lt.type) {
                  case "reset":
                    if (!kt || Ct) {
                      Te.touched = false, Te.dirty = false, Te.validatePromise = null, Te.errors = hd, Te.warnings = hd, Te.triggerMetaEvent(), lr == null || lr(), Te.refresh();
                      return;
                    }
                    break;
                  case "remove": {
                    if (Bn) {
                      Te.reRender();
                      return;
                    }
                    break;
                  }
                  case "setField": {
                    if (Ct) {
                      var dr = Lt.data;
                      "touched" in dr && (Te.touched = dr.touched), "validating" in dr && !("originRCField" in dr) && (Te.validatePromise = dr.validating ? Promise.resolve([]) : null), "errors" in dr && (Te.errors = dr.errors || hd), "warnings" in dr && (Te.warnings = dr.warnings || hd), Te.dirty = true, Te.triggerMetaEvent(), Te.reRender();
                      return;
                    }
                    if (Bn && !ki.length && AB(Bn, xt, br, bi, Oa, Lt)) {
                      Te.reRender();
                      return;
                    }
                    break;
                  }
                  case "dependenciesUpdate": {
                    var Wr = $n.map(fd);
                    if (Wr.some(function(Ci) {
                      return SD(Lt.relatedFields, Ci);
                    })) {
                      Te.reRender();
                      return;
                    }
                    break;
                  }
                  default:
                    if (Ct || (!$n.length || ki.length || Bn) && AB(Bn, xt, br, bi, Oa, Lt)) {
                      Te.reRender();
                      return;
                    }
                    break;
                }
                Bn === true && Te.reRender();
              }, Te.validateRules = function(xt) {
                var kt = Te.getNamePath(), Lt = Te.getValue(), sn = Promise.resolve().then(function() {
                  if (!Te.mounted)
                    return [];
                  var Bn = Te.props, Xn = Bn.validateFirst, $n = Xn === void 0 ? false : Xn, lr = Bn.messageVariables, br = xt || {}, ki = br.triggerName, bi = Te.getRules();
                  ki && (bi = bi.filter(function(Ct) {
                    var dr = Ct.validateTrigger;
                    if (!dr)
                      return true;
                    var Wr = i6(dr);
                    return Wr.includes(ki);
                  }));
                  var Oa = qS(kt, Lt, bi, xt, $n, lr);
                  return Oa.catch(function(Ct) {
                    return Ct;
                  }).then(function() {
                    var Ct = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : hd;
                    if (Te.validatePromise === sn) {
                      Te.validatePromise = null;
                      var dr = [], Wr = [];
                      Ct.forEach(function(Ci) {
                        var _i = Ci.rule.warningOnly, Pr = Ci.errors, $r = Pr === void 0 ? hd : Pr;
                        _i ? Wr.push.apply(Wr, vu($r)) : dr.push.apply(dr, vu($r));
                      }), Te.errors = dr, Te.warnings = Wr, Te.triggerMetaEvent(), Te.reRender();
                    }
                  }), Oa;
                });
                return Te.validatePromise = sn, Te.dirty = true, Te.errors = hd, Te.warnings = hd, Te.triggerMetaEvent(), Te.reRender(), sn;
              }, Te.isFieldValidating = function() {
                return !!Te.validatePromise;
              }, Te.isFieldTouched = function() {
                return Te.touched;
              }, Te.isFieldDirty = function() {
                if (Te.dirty || Te.props.initialValue !== void 0)
                  return true;
                var xt = Te.props.fieldContext, kt = xt.getInternalHooks(sg), Lt = kt.getInitialValue;
                return Lt(Te.getNamePath()) !== void 0;
              }, Te.getErrors = function() {
                return Te.errors;
              }, Te.getWarnings = function() {
                return Te.warnings;
              }, Te.isListField = function() {
                return Te.props.isListField;
              }, Te.isList = function() {
                return Te.props.isList;
              }, Te.isPreserve = function() {
                return Te.props.preserve;
              }, Te.getMeta = function() {
                Te.prevValidating = Te.isFieldValidating();
                var xt = { touched: Te.isFieldTouched(), validating: Te.prevValidating, errors: Te.errors, warnings: Te.warnings, name: Te.getNamePath() };
                return xt;
              }, Te.getOnlyChild = function(xt) {
                if (typeof xt == "function") {
                  var kt = Te.getMeta();
                  return Ot(Ot({}, Te.getOnlyChild(xt(Te.getControlled(), kt, Te.props.fieldContext))), {}, { isFunction: true });
                }
                var Lt = n62(xt);
                return Lt.length !== 1 || !st.isValidElement(Lt[0]) ? { child: Lt, isFunction: false } : { child: Lt[0], isFunction: false };
              }, Te.getValue = function(xt) {
                var kt = Te.props.fieldContext.getFieldsValue, Lt = Te.getNamePath();
                return US(xt || kt(true), Lt);
              }, Te.getControlled = function() {
                var xt = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, kt = Te.props, Lt = kt.trigger, sn = kt.validateTrigger, Bn = kt.getValueFromEvent, Xn = kt.normalize, $n = kt.valuePropName, lr = kt.getValueProps, br = kt.fieldContext, ki = sn !== void 0 ? sn : br.validateTrigger, bi = Te.getNamePath(), Oa = br.getInternalHooks, Ct = br.getFieldsValue, dr = Oa(sg), Wr = dr.dispatch, Ci = Te.getValue(), _i = lr || function(wa) {
                  return dn({}, $n, wa);
                }, Pr = xt[Lt], $r = Ot(Ot({}, xt), _i(Ci));
                $r[Lt] = function() {
                  Te.touched = true, Te.dirty = true, Te.triggerMetaEvent();
                  for (var wa, Mr = arguments.length, No = new Array(Mr), Po = 0; Po < Mr; Po++)
                    No[Po] = arguments[Po];
                  Bn ? wa = Bn.apply(void 0, No) : wa = X3.apply(void 0, [$n].concat(No)), Xn && (wa = Xn(wa, Ci, Ct(true))), Wr({ type: "updateValue", namePath: bi, value: wa }), Pr && Pr.apply(void 0, No);
                };
                var Hi = i6(ki || []);
                return Hi.forEach(function(wa) {
                  var Mr = $r[wa];
                  $r[wa] = function() {
                    Mr && Mr.apply(void 0, arguments);
                    var No = Te.props.rules;
                    No && No.length && Wr({ type: "validateField", namePath: bi, triggerName: wa });
                  };
                }), $r;
              }, Me.fieldContext) {
                var Ne = Me.fieldContext.getInternalHooks, it = Ne(sg), ht = it.initEntityValue;
                ht(j3(Te));
              }
              return Te;
            }
            return VS(we, [{ key: "componentDidMount", value: function() {
              var Me = this.props, Te = Me.shouldUpdate, Ne = Me.fieldContext;
              if (this.mounted = true, Ne) {
                var it = Ne.getInternalHooks, ht = it(sg), xt = ht.registerField;
                this.cancelRegisterFunc = xt(this);
              }
              Te === true && this.reRender();
            } }, { key: "componentWillUnmount", value: function() {
              this.cancelRegister(), this.triggerMetaEvent(true), this.mounted = false;
            } }, { key: "reRender", value: function() {
              !this.mounted || this.forceUpdate();
            } }, { key: "render", value: function() {
              var Me = this.state.resetCount, Te = this.props.children, Ne = this.getOnlyChild(Te), it = Ne.child, ht = Ne.isFunction, xt;
              return ht ? xt = it : st.isValidElement(it) ? xt = st.cloneElement(it, this.getControlled(it.props)) : (t1(!it, "`children` of Field is not validate ReactElement."), xt = it), st.createElement(st.Fragment, { key: Me }, xt);
            } }]), we;
          }(st.Component);
          h6.contextType = $g, h6.defaultProps = { trigger: "onChange", valuePropName: "value" };
          function IB(ge) {
            var He = ge.name, we = Go(ge, TB), Me = st.useContext($g), Te = He !== void 0 ? fd(He) : void 0, Ne = "keep";
            return we.isListField || (Ne = "_".concat((Te || []).join("_"))), st.createElement(h6, jl({ key: Ne, name: Te }, we, { fieldContext: Me }));
          }
          var hA = st.createContext(null), jY = function(ge) {
            var He = ge.name, we = ge.initialValue, Me = ge.children, Te = ge.rules, Ne = ge.validateTrigger, it = st.useContext($g), ht = st.useRef({ keys: [], id: 0 }), xt = ht.current, kt = st.useMemo(function() {
              var Xn = fd(it.prefixName) || [];
              return [].concat(vu(Xn), vu(fd(He)));
            }, [it.prefixName, He]), Lt = st.useMemo(function() {
              return Ot(Ot({}, it), {}, { prefixName: kt });
            }, [it, kt]), sn = st.useMemo(function() {
              return { getKey: function(Xn) {
                var $n = kt.length, lr = Xn[$n];
                return [xt.keys[lr], Xn.slice($n + 1)];
              } };
            }, [kt]);
            if (typeof Me != "function")
              return t1(false, "Form.List only accepts function as children."), null;
            var Bn = function(Xn, $n, lr) {
              var br = lr.source;
              return br === "internal" ? false : Xn !== $n;
            };
            return st.createElement(hA.Provider, { value: sn }, st.createElement($g.Provider, { value: Lt }, st.createElement(IB, { name: [], shouldUpdate: Bn, rules: Te, validateTrigger: Ne, initialValue: we, isList: true }, function(Xn, $n) {
              var lr = Xn.value, br = lr === void 0 ? [] : lr, ki = Xn.onChange, bi = it.getFieldValue, Oa = function() {
                var Wr = bi(kt || []);
                return Wr || [];
              }, Ct = { add: function(Wr, Ci) {
                var _i = Oa();
                Ci >= 0 && Ci <= _i.length ? (xt.keys = [].concat(vu(xt.keys.slice(0, Ci)), [xt.id], vu(xt.keys.slice(Ci))), ki([].concat(vu(_i.slice(0, Ci)), [Wr], vu(_i.slice(Ci))))) : (xt.keys = [].concat(vu(xt.keys), [xt.id]), ki([].concat(vu(_i), [Wr]))), xt.id += 1;
              }, remove: function(Wr) {
                var Ci = Oa(), _i = new Set(Array.isArray(Wr) ? Wr : [Wr]);
                _i.size <= 0 || (xt.keys = xt.keys.filter(function(Pr, $r) {
                  return !_i.has($r);
                }), ki(Ci.filter(function(Pr, $r) {
                  return !_i.has($r);
                })));
              }, move: function(Wr, Ci) {
                if (Wr !== Ci) {
                  var _i = Oa();
                  Wr < 0 || Wr >= _i.length || Ci < 0 || Ci >= _i.length || (xt.keys = Ky(xt.keys, Wr, Ci), ki(Ky(_i, Wr, Ci)));
                }
              } }, dr = br || [];
              return Array.isArray(dr) || (dr = []), Me(dr.map(function(Wr, Ci) {
                var _i = xt.keys[Ci];
                return _i === void 0 && (xt.keys[Ci] = xt.id, _i = xt.keys[Ci], xt.id += 1), { name: Ci, key: _i, isListField: true };
              }), Ct, $n);
            })));
          };
          function Lx(ge) {
            var He = false, we = ge.length, Me = [];
            return ge.length ? new Promise(function(Te, Ne) {
              ge.forEach(function(it, ht) {
                it.catch(function(xt) {
                  return He = true, xt;
                }).then(function(xt) {
                  we -= 1, Me[ht] = xt, !(we > 0) && (He && Ne(Me), Te(Me));
                });
              });
            }) : Promise.resolve([]);
          }
          var EB = "__@field_split__";
          function p6(ge) {
            return ge.map(function(He) {
              return "".concat(El(He), ":").concat(He);
            }).join(EB);
          }
          var MD = function() {
            function ge() {
              r1(this, ge), this.kvs = /* @__PURE__ */ new Map();
            }
            return VS(ge, [{ key: "set", value: function(He, we) {
              this.kvs.set(p6(He), we);
            } }, { key: "get", value: function(He) {
              return this.kvs.get(p6(He));
            } }, { key: "update", value: function(He, we) {
              var Me = this.get(He), Te = we(Me);
              Te ? this.set(He, Te) : this.delete(He);
            } }, { key: "delete", value: function(He) {
              this.kvs.delete(p6(He));
            } }, { key: "map", value: function(He) {
              return vu(this.kvs.entries()).map(function(we) {
                var Me = ur(we, 2), Te = Me[0], Ne = Me[1], it = Te.split(EB);
                return He({ key: it.map(function(ht) {
                  var xt = ht.match(/^([^:]*):(.*)$/), kt = ur(xt, 3), Lt = kt[1], sn = kt[2];
                  return Lt === "number" ? Number(sn) : sn;
                }), value: Ne });
              });
            } }, { key: "toJSON", value: function() {
              var He = {};
              return this.map(function(we) {
                var Me = we.key, Te = we.value;
                return He[Me.join(".")] = Te, null;
              }), He;
            } }]), ge;
          }(), DB = ["name", "errors"], kB = VS(function ge(He) {
            var we = this;
            r1(this, ge), this.formHooked = false, this.forceRootUpdate = void 0, this.subscribable = true, this.store = {}, this.fieldEntities = [], this.initialValues = {}, this.callbacks = {}, this.validateMessages = null, this.preserve = null, this.lastValidatePromise = null, this.getForm = function() {
              return { getFieldValue: we.getFieldValue, getFieldsValue: we.getFieldsValue, getFieldError: we.getFieldError, getFieldWarning: we.getFieldWarning, getFieldsError: we.getFieldsError, isFieldsTouched: we.isFieldsTouched, isFieldTouched: we.isFieldTouched, isFieldValidating: we.isFieldValidating, isFieldsValidating: we.isFieldsValidating, resetFields: we.resetFields, setFields: we.setFields, setFieldsValue: we.setFieldsValue, validateFields: we.validateFields, submit: we.submit, getInternalHooks: we.getInternalHooks };
            }, this.getInternalHooks = function(Me) {
              return Me === sg ? (we.formHooked = true, { dispatch: we.dispatch, initEntityValue: we.initEntityValue, registerField: we.registerField, useSubscribe: we.useSubscribe, setInitialValues: we.setInitialValues, setCallbacks: we.setCallbacks, setValidateMessages: we.setValidateMessages, getFields: we.getFields, setPreserve: we.setPreserve, getInitialValue: we.getInitialValue }) : (t1(false, "`getInternalHooks` is internal usage. Should not call directly."), null);
            }, this.useSubscribe = function(Me) {
              we.subscribable = Me;
            }, this.setInitialValues = function(Me, Te) {
              we.initialValues = Me || {}, Te && (we.store = kp({}, Me, we.store));
            }, this.getInitialValue = function(Me) {
              return US(we.initialValues, Me);
            }, this.setCallbacks = function(Me) {
              we.callbacks = Me;
            }, this.setValidateMessages = function(Me) {
              we.validateMessages = Me;
            }, this.setPreserve = function(Me) {
              we.preserve = Me;
            }, this.timeoutId = null, this.warningUnhooked = function() {
            }, this.getFieldEntities = function() {
              var Me = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false;
              return Me ? we.fieldEntities.filter(function(Te) {
                return Te.getNamePath().length;
              }) : we.fieldEntities;
            }, this.getFieldsMap = function() {
              var Me = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, Te = new MD();
              return we.getFieldEntities(Me).forEach(function(Ne) {
                var it = Ne.getNamePath();
                Te.set(it, Ne);
              }), Te;
            }, this.getFieldEntitiesForNamePathList = function(Me) {
              if (!Me)
                return we.getFieldEntities(true);
              var Te = we.getFieldsMap(true);
              return Me.map(function(Ne) {
                var it = fd(Ne);
                return Te.get(it) || { INVALIDATE_NAME_PATH: fd(Ne) };
              });
            }, this.getFieldsValue = function(Me, Te) {
              if (we.warningUnhooked(), Me === true && !Te)
                return we.store;
              var Ne = we.getFieldEntitiesForNamePathList(Array.isArray(Me) ? Me : null), it = [];
              return Ne.forEach(function(ht) {
                var xt, kt = "INVALIDATE_NAME_PATH" in ht ? ht.INVALIDATE_NAME_PATH : ht.getNamePath();
                if (!(!Me && ((xt = ht.isListField) === null || xt === void 0 ? void 0 : xt.call(ht))))
                  if (!Te)
                    it.push(kt);
                  else {
                    var Lt = "getMeta" in ht ? ht.getMeta() : null;
                    Te(Lt) && it.push(kt);
                  }
              }), $3(we.store, it.map(fd));
            }, this.getFieldValue = function(Me) {
              we.warningUnhooked();
              var Te = fd(Me);
              return US(we.store, Te);
            }, this.getFieldsError = function(Me) {
              we.warningUnhooked();
              var Te = we.getFieldEntitiesForNamePathList(Me);
              return Te.map(function(Ne, it) {
                return Ne && !("INVALIDATE_NAME_PATH" in Ne) ? { name: Ne.getNamePath(), errors: Ne.getErrors(), warnings: Ne.getWarnings() } : { name: fd(Me[it]), errors: [], warnings: [] };
              });
            }, this.getFieldError = function(Me) {
              we.warningUnhooked();
              var Te = fd(Me), Ne = we.getFieldsError([Te])[0];
              return Ne.errors;
            }, this.getFieldWarning = function(Me) {
              we.warningUnhooked();
              var Te = fd(Me), Ne = we.getFieldsError([Te])[0];
              return Ne.warnings;
            }, this.isFieldsTouched = function() {
              we.warningUnhooked();
              for (var Me = arguments.length, Te = new Array(Me), Ne = 0; Ne < Me; Ne++)
                Te[Ne] = arguments[Ne];
              var it = Te[0], ht = Te[1], xt, kt = false;
              Te.length === 0 ? xt = null : Te.length === 1 ? Array.isArray(it) ? (xt = it.map(fd), kt = false) : (xt = null, kt = it) : (xt = it.map(fd), kt = ht);
              var Lt = we.getFieldEntities(true), sn = function(lr) {
                return lr.isFieldTouched();
              };
              if (!xt)
                return kt ? Lt.every(sn) : Lt.some(sn);
              var Bn = new MD();
              xt.forEach(function(lr) {
                Bn.set(lr, []);
              }), Lt.forEach(function(lr) {
                var br = lr.getNamePath();
                xt.forEach(function(ki) {
                  ki.every(function(bi, Oa) {
                    return br[Oa] === bi;
                  }) && Bn.update(ki, function(bi) {
                    return [].concat(vu(bi), [lr]);
                  });
                });
              });
              var Xn = function(lr) {
                return lr.some(sn);
              }, $n = Bn.map(function(lr) {
                var br = lr.value;
                return br;
              });
              return kt ? $n.every(Xn) : $n.some(Xn);
            }, this.isFieldTouched = function(Me) {
              return we.warningUnhooked(), we.isFieldsTouched([Me]);
            }, this.isFieldsValidating = function(Me) {
              we.warningUnhooked();
              var Te = we.getFieldEntities();
              if (!Me)
                return Te.some(function(it) {
                  return it.isFieldValidating();
                });
              var Ne = Me.map(fd);
              return Te.some(function(it) {
                var ht = it.getNamePath();
                return SD(Ne, ht) && it.isFieldValidating();
              });
            }, this.isFieldValidating = function(Me) {
              return we.warningUnhooked(), we.isFieldsValidating([Me]);
            }, this.resetWithFieldInitialValue = function() {
              var Me = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, Te = new MD(), Ne = we.getFieldEntities(true);
              Ne.forEach(function(xt) {
                var kt = xt.props.initialValue, Lt = xt.getNamePath();
                if (kt !== void 0) {
                  var sn = Te.get(Lt) || /* @__PURE__ */ new Set();
                  sn.add({ entity: xt, value: kt }), Te.set(Lt, sn);
                }
              });
              var it = function(xt) {
                xt.forEach(function(kt) {
                  var Lt = kt.props.initialValue;
                  if (Lt !== void 0) {
                    var sn = kt.getNamePath(), Bn = we.getInitialValue(sn);
                    if (Bn !== void 0)
                      t1(false, "Form already set 'initialValues' with path '".concat(sn.join("."), "'. Field can not overwrite it."));
                    else {
                      var Xn = Te.get(sn);
                      if (Xn && Xn.size > 1)
                        t1(false, "Multiple Field with path '".concat(sn.join("."), "' set 'initialValue'. Can not decide which one to pick."));
                      else if (Xn) {
                        var $n = we.getFieldValue(sn);
                        (!Me.skipExist || $n === void 0) && (we.store = HC(we.store, sn, vu(Xn)[0].value));
                      }
                    }
                  }
                });
              }, ht;
              Me.entities ? ht = Me.entities : Me.namePathList ? (ht = [], Me.namePathList.forEach(function(xt) {
                var kt = Te.get(xt);
                if (kt) {
                  var Lt;
                  (Lt = ht).push.apply(Lt, vu(vu(kt).map(function(sn) {
                    return sn.entity;
                  })));
                }
              })) : ht = Ne, it(ht);
            }, this.resetFields = function(Me) {
              we.warningUnhooked();
              var Te = we.store;
              if (!Me) {
                we.store = kp({}, we.initialValues), we.resetWithFieldInitialValue(), we.notifyObservers(Te, null, { type: "reset" });
                return;
              }
              var Ne = Me.map(fd);
              Ne.forEach(function(it) {
                var ht = we.getInitialValue(it);
                we.store = HC(we.store, it, ht);
              }), we.resetWithFieldInitialValue({ namePathList: Ne }), we.notifyObservers(Te, Ne, { type: "reset" });
            }, this.setFields = function(Me) {
              we.warningUnhooked();
              var Te = we.store;
              Me.forEach(function(Ne) {
                var it = Ne.name;
                Ne.errors;
                var ht = Go(Ne, DB), xt = fd(it);
                "value" in ht && (we.store = HC(we.store, xt, ht.value)), we.notifyObservers(Te, [xt], { type: "setField", data: Ne });
              });
            }, this.getFields = function() {
              var Me = we.getFieldEntities(true), Te = Me.map(function(Ne) {
                var it = Ne.getNamePath(), ht = Ne.getMeta(), xt = Ot(Ot({}, ht), {}, { name: it, value: we.getFieldValue(it) });
                return Object.defineProperty(xt, "originRCField", { value: true }), xt;
              });
              return Te;
            }, this.initEntityValue = function(Me) {
              var Te = Me.props.initialValue;
              if (Te !== void 0) {
                var Ne = Me.getNamePath(), it = US(we.store, Ne);
                it === void 0 && (we.store = HC(we.store, Ne, Te));
              }
            }, this.registerField = function(Me) {
              if (we.fieldEntities.push(Me), Me.props.initialValue !== void 0) {
                var Te = we.store;
                we.resetWithFieldInitialValue({ entities: [Me], skipExist: true }), we.notifyObservers(Te, [Me.getNamePath()], { type: "valueUpdate", source: "internal" });
              }
              return function(Ne, it) {
                var ht = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : [];
                we.fieldEntities = we.fieldEntities.filter(function(Bn) {
                  return Bn !== Me;
                });
                var xt = it !== void 0 ? it : we.preserve;
                if (xt === false && (!Ne || ht.length > 1)) {
                  var kt = Me.getNamePath(), Lt = Ne ? void 0 : US(we.initialValues, kt);
                  if (kt.length && we.getFieldValue(kt) !== Lt && we.fieldEntities.every(function(Bn) {
                    return !Bt(Bn.getNamePath(), kt);
                  })) {
                    var sn = we.store;
                    we.store = HC(sn, kt, Lt, true), we.notifyObservers(sn, [kt], { type: "remove" }), we.triggerDependenciesUpdate(sn, kt);
                  }
                }
              };
            }, this.dispatch = function(Me) {
              switch (Me.type) {
                case "updateValue": {
                  var Te = Me.namePath, Ne = Me.value;
                  we.updateValue(Te, Ne);
                  break;
                }
                case "validateField": {
                  var it = Me.namePath, ht = Me.triggerName;
                  we.validateFields([it], { triggerName: ht });
                  break;
                }
              }
            }, this.notifyObservers = function(Me, Te, Ne) {
              if (we.subscribable) {
                var it = Ot(Ot({}, Ne), {}, { store: we.getFieldsValue(true) });
                we.getFieldEntities().forEach(function(ht) {
                  var xt = ht.onStoreChange;
                  xt(Me, Te, it);
                });
              } else
                we.forceRootUpdate();
            }, this.triggerDependenciesUpdate = function(Me, Te) {
              var Ne = we.getDependencyChildrenFields(Te);
              return Ne.length && we.validateFields(Ne), we.notifyObservers(Me, Ne, { type: "dependenciesUpdate", relatedFields: [Te].concat(vu(Ne)) }), Ne;
            }, this.updateValue = function(Me, Te) {
              var Ne = fd(Me), it = we.store;
              we.store = HC(we.store, Ne, Te), we.notifyObservers(it, [Ne], { type: "valueUpdate", source: "internal" });
              var ht = we.triggerDependenciesUpdate(it, Ne), xt = we.callbacks.onValuesChange;
              if (xt) {
                var kt = $3(we.store, [Ne]);
                xt(kt, we.getFieldsValue());
              }
              we.triggerOnFieldsChange([Ne].concat(vu(ht)));
            }, this.setFieldsValue = function(Me) {
              we.warningUnhooked();
              var Te = we.store;
              Me && (we.store = kp(we.store, Me)), we.notifyObservers(Te, null, { type: "valueUpdate", source: "external" });
            }, this.getDependencyChildrenFields = function(Me) {
              var Te = /* @__PURE__ */ new Set(), Ne = [], it = new MD();
              we.getFieldEntities().forEach(function(xt) {
                var kt = xt.props.dependencies;
                (kt || []).forEach(function(Lt) {
                  var sn = fd(Lt);
                  it.update(sn, function() {
                    var Bn = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : /* @__PURE__ */ new Set();
                    return Bn.add(xt), Bn;
                  });
                });
              });
              var ht = function xt(kt) {
                var Lt = it.get(kt) || /* @__PURE__ */ new Set();
                Lt.forEach(function(sn) {
                  if (!Te.has(sn)) {
                    Te.add(sn);
                    var Bn = sn.getNamePath();
                    sn.isFieldDirty() && Bn.length && (Ne.push(Bn), xt(Bn));
                  }
                });
              };
              return ht(Me), Ne;
            }, this.triggerOnFieldsChange = function(Me, Te) {
              var Ne = we.callbacks.onFieldsChange;
              if (Ne) {
                var it = we.getFields();
                if (Te) {
                  var ht = new MD();
                  Te.forEach(function(kt) {
                    var Lt = kt.name, sn = kt.errors;
                    ht.set(Lt, sn);
                  }), it.forEach(function(kt) {
                    kt.errors = ht.get(kt.name) || kt.errors;
                  });
                }
                var xt = it.filter(function(kt) {
                  var Lt = kt.name;
                  return SD(Me, Lt);
                });
                Ne(xt, it);
              }
            }, this.validateFields = function(Me, Te) {
              we.warningUnhooked();
              var Ne = !!Me, it = Ne ? Me.map(fd) : [], ht = [];
              we.getFieldEntities(true).forEach(function(Lt) {
                if (Ne || it.push(Lt.getNamePath()), (Te == null ? void 0 : Te.recursive) && Ne) {
                  var sn = Lt.getNamePath();
                  sn.every(function($n, lr) {
                    return Me[lr] === $n || Me[lr] === void 0;
                  }) && it.push(sn);
                }
                if (!(!Lt.props.rules || !Lt.props.rules.length)) {
                  var Bn = Lt.getNamePath();
                  if (!Ne || SD(it, Bn)) {
                    var Xn = Lt.validateRules(Ot({ validateMessages: Ot(Ot({}, GC), we.validateMessages) }, Te));
                    ht.push(Xn.then(function() {
                      return { name: Bn, errors: [], warnings: [] };
                    }).catch(function($n) {
                      var lr = [], br = [];
                      return $n.forEach(function(ki) {
                        var bi = ki.rule.warningOnly, Oa = ki.errors;
                        bi ? br.push.apply(br, vu(Oa)) : lr.push.apply(lr, vu(Oa));
                      }), lr.length ? Promise.reject({ name: Bn, errors: lr, warnings: br }) : { name: Bn, errors: lr, warnings: br };
                    }));
                  }
                }
              });
              var xt = Lx(ht);
              we.lastValidatePromise = xt, xt.catch(function(Lt) {
                return Lt;
              }).then(function(Lt) {
                var sn = Lt.map(function(Bn) {
                  var Xn = Bn.name;
                  return Xn;
                });
                we.notifyObservers(we.store, sn, { type: "validateFinish" }), we.triggerOnFieldsChange(sn, Lt);
              });
              var kt = xt.then(function() {
                return we.lastValidatePromise === xt ? Promise.resolve(we.getFieldsValue(it)) : Promise.reject([]);
              }).catch(function(Lt) {
                var sn = Lt.filter(function(Bn) {
                  return Bn && Bn.errors.length;
                });
                return Promise.reject({ values: we.getFieldsValue(it), errorFields: sn, outOfDate: we.lastValidatePromise !== xt });
              });
              return kt.catch(function(Lt) {
                return Lt;
              }), kt;
            }, this.submit = function() {
              we.warningUnhooked(), we.validateFields().then(function(Me) {
                var Te = we.callbacks.onFinish;
                if (Te)
                  try {
                    Te(Me);
                  } catch (Ne) {
                    console.error(Ne);
                  }
              }).catch(function(Me) {
                var Te = we.callbacks.onFinishFailed;
                Te && Te(Me);
              });
            }, this.forceRootUpdate = He;
          });
          function $S(ge) {
            var He = st.useRef(), we = st.useState({}), Me = ur(we, 2), Te = Me[1];
            if (!He.current)
              if (ge)
                He.current = ge;
              else {
                var Ne = function() {
                  Te({});
                }, it = new kB(Ne);
                He.current = it.getForm();
              }
            return [He.current];
          }
          var d6 = st.createContext({ triggerFormChange: function() {
          }, triggerFormFinish: function() {
          }, registerForm: function() {
          }, unregisterForm: function() {
          } }), GY = function(ge) {
            var He = ge.validateMessages, we = ge.onFormChange, Me = ge.onFormFinish, Te = ge.children, Ne = st.useContext(d6), it = st.useRef({});
            return st.createElement(d6.Provider, { value: Ot(Ot({}, Ne), {}, { validateMessages: Ot(Ot({}, Ne.validateMessages), He), triggerFormChange: function(ht, xt) {
              we && we(ht, { changedFields: xt, forms: it.current }), Ne.triggerFormChange(ht, xt);
            }, triggerFormFinish: function(ht, xt) {
              Me && Me(ht, { values: xt, forms: it.current }), Ne.triggerFormFinish(ht, xt);
            }, registerForm: function(ht, xt) {
              ht && (it.current = Ot(Ot({}, it.current), {}, dn({}, ht, xt))), Ne.registerForm(ht, xt);
            }, unregisterForm: function(ht) {
              var xt = Ot({}, it.current);
              delete xt[ht], it.current = xt, Ne.unregisterForm(ht);
            } }) }, Te);
          }, sb = ["name", "initialValues", "fields", "form", "preserve", "children", "component", "validateMessages", "validateTrigger", "onValuesChange", "onFieldsChange", "onFinish", "onFinishFailed"], HY = function(ge, He) {
            var we = ge.name, Me = ge.initialValues, Te = ge.fields, Ne = ge.form, it = ge.preserve, ht = ge.children, xt = ge.component, kt = xt === void 0 ? "form" : xt, Lt = ge.validateMessages, sn = ge.validateTrigger, Bn = sn === void 0 ? "onChange" : sn, Xn = ge.onValuesChange, $n = ge.onFieldsChange, lr = ge.onFinish, br = ge.onFinishFailed, ki = Go(ge, sb), bi = st.useContext(d6), Oa = $S(Ne), Ct = ur(Oa, 1), dr = Ct[0], Wr = dr.getInternalHooks(sg), Ci = Wr.useSubscribe, _i = Wr.setInitialValues, Pr = Wr.setCallbacks, $r = Wr.setValidateMessages, Hi = Wr.setPreserve;
            st.useImperativeHandle(He, function() {
              return dr;
            }), st.useEffect(function() {
              return bi.registerForm(we, dr), function() {
                bi.unregisterForm(we);
              };
            }, [bi, dr, we]), $r(Ot(Ot({}, bi.validateMessages), Lt)), Pr({ onValuesChange: Xn, onFieldsChange: function(ii) {
              if (bi.triggerFormChange(we, ii), $n) {
                for (var ai = arguments.length, Ga = new Array(ai > 1 ? ai - 1 : 0), Aa = 1; Aa < ai; Aa++)
                  Ga[Aa - 1] = arguments[Aa];
                $n.apply(void 0, [ii].concat(Ga));
              }
            }, onFinish: function(ii) {
              bi.triggerFormFinish(we, ii), lr && lr(ii);
            }, onFinishFailed: br }), Hi(it);
            var wa = st.useRef(null);
            _i(Me, !wa.current), wa.current || (wa.current = true);
            var Mr = ht, No = typeof ht == "function";
            if (No) {
              var Po = dr.getFieldsValue(true);
              Mr = ht(Po, dr);
            }
            Ci(!No);
            var Mi = st.useRef();
            st.useEffect(function() {
              fA(Mi.current || [], Te || []) || dr.setFields(Te || []), Mi.current = Te;
            }, [Te, dr]);
            var Is = st.useMemo(function() {
              return Ot(Ot({}, dr), {}, { validateTrigger: Bn });
            }, [dr, Bn]), Oi = st.createElement($g.Provider, { value: Is }, Mr);
            return kt === false ? Oi : st.createElement(kt, jl({}, ki, { onSubmit: function(ii) {
              ii.preventDefault(), ii.stopPropagation(), dr.submit();
            }, onReset: function(ii) {
              var ai;
              ii.preventDefault(), dr.resetFields(), (ai = ki.onReset) === null || ai === void 0 || ai.call(ki, ii);
            } }), Oi);
          }, WY = st.forwardRef(HY), K3 = WY;
          K3.FormProvider = GY, K3.Field = IB, K3.List = jY, K3.useForm = $S;
          var UY = function(ge, He, we) {
            t1(ge, "[antd: ".concat(He, "] ").concat(we));
          }, qY = { items_per_page: "/ page", jump_to: "Go to", jump_to_confirm: "confirm", page: "Page", prev_page: "Previous Page", next_page: "Next Page", prev_5: "Previous 5 Pages", next_5: "Next 5 Pages", prev_3: "Previous 3 Pages", next_3: "Next 3 Pages", page_size: "Page Size" }, OB = { locale: "en_US", today: "Today", now: "Now", backToToday: "Back to today", ok: "Ok", clear: "Clear", month: "Month", year: "Year", timeSelect: "select time", dateSelect: "select date", weekSelect: "Choose a week", monthSelect: "Choose a month", yearSelect: "Choose a year", decadeSelect: "Choose a decade", yearFormat: "YYYY", dateFormat: "M/D/YYYY", dayFormat: "D", dateTimeFormat: "M/D/YYYY HH:mm:ss", monthBeforeYear: true, previousMonth: "Previous month (PageUp)", nextMonth: "Next month (PageDown)", previousYear: "Last year (Control + left)", nextYear: "Next year (Control + right)", previousDecade: "Last decade", nextDecade: "Next decade", previousCentury: "Last century", nextCentury: "Next century" }, PB = { placeholder: "Select time", rangePlaceholder: ["Start time", "End time"] }, LB = PB, $Y = { lang: jl({ placeholder: "Select date", yearPlaceholder: "Select year", quarterPlaceholder: "Select quarter", monthPlaceholder: "Select month", weekPlaceholder: "Select week", rangePlaceholder: ["Start date", "End date"], rangeYearPlaceholder: ["Start year", "End year"], rangeQuarterPlaceholder: ["Start quarter", "End quarter"], rangeMonthPlaceholder: ["Start month", "End month"], rangeWeekPlaceholder: ["Start week", "End week"] }, OB), timePickerLocale: jl({}, LB) }, Z3 = $Y, Ev = "${label} is not a valid ${type}", J3 = { locale: "en", Pagination: qY, DatePicker: Z3, TimePicker: LB, Calendar: Z3, global: { placeholder: "Please select" }, Table: { filterTitle: "Filter menu", filterConfirm: "OK", filterReset: "Reset", filterEmptyText: "No filters", filterCheckall: "Select all items", filterSearchPlaceholder: "Search in filters", emptyText: "No data", selectAll: "Select current page", selectInvert: "Invert current page", selectNone: "Clear all data", selectionAll: "Select all data", sortTitle: "Sort", expand: "Expand row", collapse: "Collapse row", triggerDesc: "Click to sort descending", triggerAsc: "Click to sort ascending", cancelSort: "Click to cancel sorting" }, Modal: { okText: "OK", cancelText: "Cancel", justOkText: "OK" }, Popconfirm: { okText: "OK", cancelText: "Cancel" }, Transfer: { titles: ["", ""], searchPlaceholder: "Search here", itemUnit: "item", itemsUnit: "items", remove: "Remove", selectCurrent: "Select current page", removeCurrent: "Remove current page", selectAll: "Select all data", removeAll: "Remove all data", selectInvert: "Invert current page" }, Upload: { uploading: "Uploading...", removeFile: "Remove file", uploadError: "Upload error", previewFile: "Preview file", downloadFile: "Download file" }, Empty: { description: "No Data" }, Icon: { icon: "icon" }, Text: { edit: "Edit", copy: "Copy", copied: "Copied", expand: "Expand" }, PageHeader: { back: "Back" }, Form: { optional: "(optional)", defaultValidateMessages: { default: "Field validation error for ${label}", required: "Please enter ${label}", enum: "${label} must be one of [${enum}]", whitespace: "${label} cannot be a blank character", date: { format: "${label} date format is invalid", parse: "${label} cannot be converted to a date", invalid: "${label} is an invalid date" }, types: { string: Ev, method: Ev, array: Ev, object: Ev, number: Ev, date: Ev, boolean: Ev, integer: Ev, float: Ev, regexp: Ev, email: Ev, url: Ev, hex: Ev }, string: { len: "${label} must be ${len} characters", min: "${label} must be at least ${min} characters", max: "${label} must be up to ${max} characters", range: "${label} must be between ${min}-${max} characters" }, number: { len: "${label} must be equal to ${len}", min: "${label} must be minimum ${min}", max: "${label} must be maximum ${max}", range: "${label} must be between ${min}-${max}" }, array: { len: "Must be ${len} ${label}", min: "At least ${min} ${label}", max: "At most ${max} ${label}", range: "The amount of ${label} must be between ${min}-${max}" }, pattern: { mismatch: "${label} does not match the pattern ${pattern}" } } }, Image: { preview: "Preview" } }, RB = J3, NB = Ce.createContext(void 0), XY2 = NB, lb2 = function(ge) {
            Q4(we, ge);
            var He = BS(we);
            function we() {
              return r1(this, we), He.apply(this, arguments);
            }
            return VS(we, [{ key: "getLocale", value: function() {
              var Me = this.props, Te = Me.componentName, Ne = Me.defaultLocale, it = Ne || RB[Te != null ? Te : "global"], ht = this.context, xt = Te && ht ? ht[Te] : {};
              return jl(jl({}, it instanceof Function ? it() : it), xt || {});
            } }, { key: "getLocaleCode", value: function() {
              var Me = this.context, Te = Me && Me.locale;
              return Me && Me.exist && !Te ? RB.locale : Te;
            } }, { key: "render", value: function() {
              return this.props.children(this.getLocale(), this.getLocaleCode(), this.context);
            } }]), we;
          }(st.Component);
          lb2.defaultProps = { componentName: "global" }, lb2.contextType = XY2;
          var v6 = function() {
            var ge = st.useContext(Rx), He = ge.getPrefixCls, we = He("empty-img-default");
            return st.createElement("svg", { className: we, width: "184", height: "152", viewBox: "0 0 184 152", xmlns: "http://www.w3.org/2000/svg" }, st.createElement("g", { fill: "none", fillRule: "evenodd" }, st.createElement("g", { transform: "translate(24 31.67)" }, st.createElement("ellipse", { className: "".concat(we, "-ellipse"), cx: "67.797", cy: "106.89", rx: "67.797", ry: "12.668" }), st.createElement("path", { className: "".concat(we, "-path-1"), d: "M122.034 69.674L98.109 40.229c-1.148-1.386-2.826-2.225-4.593-2.225h-51.44c-1.766 0-3.444.839-4.592 2.225L13.56 69.674v15.383h108.475V69.674z" }), st.createElement("path", { className: "".concat(we, "-path-2"), d: "M101.537 86.214L80.63 61.102c-1.001-1.207-2.507-1.867-4.048-1.867H31.724c-1.54 0-3.047.66-4.048 1.867L6.769 86.214v13.792h94.768V86.214z", transform: "translate(13.56)" }), st.createElement("path", { className: "".concat(we, "-path-3"), d: "M33.83 0h67.933a4 4 0 0 1 4 4v93.344a4 4 0 0 1-4 4H33.83a4 4 0 0 1-4-4V4a4 4 0 0 1 4-4z" }), st.createElement("path", { className: "".concat(we, "-path-4"), d: "M42.678 9.953h50.237a2 2 0 0 1 2 2V36.91a2 2 0 0 1-2 2H42.678a2 2 0 0 1-2-2V11.953a2 2 0 0 1 2-2zM42.94 49.767h49.713a2.262 2.262 0 1 1 0 4.524H42.94a2.262 2.262 0 0 1 0-4.524zM42.94 61.53h49.713a2.262 2.262 0 1 1 0 4.525H42.94a2.262 2.262 0 0 1 0-4.525zM121.813 105.032c-.775 3.071-3.497 5.36-6.735 5.36H20.515c-3.238 0-5.96-2.29-6.734-5.36a7.309 7.309 0 0 1-.222-1.79V69.675h26.318c2.907 0 5.25 2.448 5.25 5.42v.04c0 2.971 2.37 5.37 5.277 5.37h34.785c2.907 0 5.277-2.421 5.277-5.393V75.1c0-2.972 2.343-5.426 5.25-5.426h26.318v33.569c0 .617-.077 1.216-.221 1.789z" })), st.createElement("path", { className: "".concat(we, "-path-5"), d: "M149.121 33.292l-6.83 2.65a1 1 0 0 1-1.317-1.23l1.937-6.207c-2.589-2.944-4.109-6.534-4.109-10.408C138.802 8.102 148.92 0 161.402 0 173.881 0 184 8.102 184 18.097c0 9.995-10.118 18.097-22.599 18.097-4.528 0-8.744-1.066-12.28-2.902z" }), st.createElement("g", { className: "".concat(we, "-g"), transform: "translate(149.65 15.383)" }, st.createElement("ellipse", { cx: "20.654", cy: "3.167", rx: "2.849", ry: "2.815" }), st.createElement("path", { d: "M5.698 5.63H0L2.898.704zM9.259.704h4.985V5.63H9.259z" }))));
          }, WC = v6, a1 = function() {
            var ge = st.useContext(Rx), He = ge.getPrefixCls, we = He("empty-img-simple");
            return st.createElement("svg", { className: we, width: "64", height: "41", viewBox: "0 0 64 41", xmlns: "http://www.w3.org/2000/svg" }, st.createElement("g", { transform: "translate(0 1)", fill: "none", fillRule: "evenodd" }, st.createElement("ellipse", { className: "".concat(we, "-ellipse"), cx: "32", cy: "33", rx: "32", ry: "7" }), st.createElement("g", { className: "".concat(we, "-g"), fillRule: "nonzero" }, st.createElement("path", { d: "M55 12.76L44.854 1.258C44.367.474 43.656 0 42.907 0H21.093c-.749 0-1.46.474-1.947 1.257L9 12.761V22h46v-9.24z" }), st.createElement("path", { d: "M41.613 15.931c0-1.605.994-2.93 2.227-2.931H55v18.137C55 33.26 53.68 35 52.05 35h-40.1C10.32 35 9 33.259 9 31.137V13h11.16c1.233 0 2.227 1.323 2.227 2.928v.022c0 1.605 1.005 2.901 2.237 2.901h14.752c1.232 0 2.237-1.308 2.237-2.913v-.007z", className: "".concat(we, "-path") }))));
          }, YY = a1, FB = globalThis && globalThis.__rest || function(ge, He) {
            var we = {};
            for (var Me in ge)
              Object.prototype.hasOwnProperty.call(ge, Me) && He.indexOf(Me) < 0 && (we[Me] = ge[Me]);
            if (ge != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Te = 0, Me = Object.getOwnPropertySymbols(ge); Te < Me.length; Te++)
                He.indexOf(Me[Te]) < 0 && Object.prototype.propertyIsEnumerable.call(ge, Me[Te]) && (we[Me[Te]] = ge[Me[Te]]);
            return we;
          }, TD = st.createElement(WC, null), UC = st.createElement(YY, null), ub = function(ge) {
            var He = ge.className, we = ge.prefixCls, Me = ge.image, Te = Me === void 0 ? TD : Me, Ne = ge.description, it = ge.children, ht = ge.imageStyle, xt = FB(ge, ["className", "prefixCls", "image", "description", "children", "imageStyle"]), kt = st.useContext(Rx), Lt = kt.getPrefixCls, sn = kt.direction;
            return st.createElement(lb2, { componentName: "Empty" }, function(Bn) {
              var Xn, $n = Lt("empty", we), lr = typeof Ne != "undefined" ? Ne : Bn.description, br = typeof lr == "string" ? lr : "empty", ki = null;
              return typeof Te == "string" ? ki = st.createElement("img", { alt: br, src: Te }) : ki = Te, st.createElement("div", jl({ className: Xl($n, (Xn = {}, dn(Xn, "".concat($n, "-normal"), Te === UC), dn(Xn, "".concat($n, "-rtl"), sn === "rtl"), Xn), He) }, xt), st.createElement("div", { className: "".concat($n, "-image"), style: ht }, ki), lr && st.createElement("div", { className: "".concat($n, "-description") }, lr), it && st.createElement("div", { className: "".concat($n, "-footer") }, it));
            });
          };
          ub.PRESENTED_IMAGE_DEFAULT = TD, ub.PRESENTED_IMAGE_SIMPLE = UC;
          var pA = ub, KY = function(ge) {
            return st.createElement(tv, null, function(He) {
              var we = He.getPrefixCls, Me = we("empty");
              switch (ge) {
                case "Table":
                case "List":
                  return st.createElement(pA, { image: pA.PRESENTED_IMAGE_SIMPLE });
                case "Select":
                case "TreeSelect":
                case "Cascader":
                case "Transfer":
                case "Mentions":
                  return st.createElement(pA, { image: pA.PRESENTED_IMAGE_SIMPLE, className: "".concat(Me, "-small") });
                default:
                  return st.createElement(pA, null);
              }
            });
          }, Q3 = KY, g6 = function(ge, He) {
            return He || (ge ? "ant-".concat(ge) : "ant");
          }, Rx = st.createContext({ getPrefixCls: g6, renderEmpty: Q3 }), tv = Rx.Consumer, y6 = st.createContext(void 0), Yg = y6, Zy = function(ge) {
            return +setTimeout(ge, 16);
          }, eO = function(ge) {
            return clearTimeout(ge);
          };
          typeof window != "undefined" && "requestAnimationFrame" in window && (Zy = function(ge) {
            return window.requestAnimationFrame(ge);
          }, eO = function(ge) {
            return window.cancelAnimationFrame(ge);
          });
          var AD = 0, Nx = /* @__PURE__ */ new Map();
          function m6(ge) {
            Nx.delete(ge);
          }
          function pd(ge) {
            var He = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
            AD += 1;
            var we = AD;
            function Me(Te) {
              if (Te === 0)
                m6(we), ge();
              else {
                var Ne = Zy(function() {
                  Me(Te - 1);
                });
                Nx.set(we, Ne);
              }
            }
            return Me(He), we;
          }
          pd.cancel = function(ge) {
            var He = Nx.get(ge);
            return m6(He), eO(He);
          };
          function b6(ge, He) {
            var we = He || {}, Me = we.defaultValue, Te = we.value, Ne = we.onChange, it = we.postState, ht = st.useState(function() {
              return Te !== void 0 ? Te : Me !== void 0 ? typeof Me == "function" ? Me() : Me : typeof ge == "function" ? ge() : ge;
            }), xt = ur(ht, 2), kt = xt[0], Lt = xt[1], sn = Te !== void 0 ? Te : kt;
            it && (sn = it(sn));
            var Bn = st.useRef(Ne);
            Bn.current = Ne;
            var Xn = st.useCallback(function(lr) {
              Lt(lr), sn !== lr && Bn.current && Bn.current(lr, sn);
            }, [sn, Bn]), $n = st.useRef(true);
            return st.useEffect(function() {
              if ($n.current) {
                $n.current = false;
                return;
              }
              Te === void 0 && Lt(Te);
            }, [Te]), [sn, Xn];
          }
          var Gs = { MAC_ENTER: 3, BACKSPACE: 8, TAB: 9, NUM_CENTER: 12, ENTER: 13, SHIFT: 16, CTRL: 17, ALT: 18, PAUSE: 19, CAPS_LOCK: 20, ESC: 27, SPACE: 32, PAGE_UP: 33, PAGE_DOWN: 34, END: 35, HOME: 36, LEFT: 37, UP: 38, RIGHT: 39, DOWN: 40, PRINT_SCREEN: 44, INSERT: 45, DELETE: 46, ZERO: 48, ONE: 49, TWO: 50, THREE: 51, FOUR: 52, FIVE: 53, SIX: 54, SEVEN: 55, EIGHT: 56, NINE: 57, QUESTION_MARK: 63, A: 65, B: 66, C: 67, D: 68, E: 69, F: 70, G: 71, H: 72, I: 73, J: 74, K: 75, L: 76, M: 77, N: 78, O: 79, P: 80, Q: 81, R: 82, S: 83, T: 84, U: 85, V: 86, W: 87, X: 88, Y: 89, Z: 90, META: 91, WIN_KEY_RIGHT: 92, CONTEXT_MENU: 93, NUM_ZERO: 96, NUM_ONE: 97, NUM_TWO: 98, NUM_THREE: 99, NUM_FOUR: 100, NUM_FIVE: 101, NUM_SIX: 102, NUM_SEVEN: 103, NUM_EIGHT: 104, NUM_NINE: 105, NUM_MULTIPLY: 106, NUM_PLUS: 107, NUM_MINUS: 109, NUM_PERIOD: 110, NUM_DIVISION: 111, F1: 112, F2: 113, F3: 114, F4: 115, F5: 116, F6: 117, F7: 118, F8: 119, F9: 120, F10: 121, F11: 122, F12: 123, NUMLOCK: 144, SEMICOLON: 186, DASH: 189, EQUALS: 187, COMMA: 188, PERIOD: 190, SLASH: 191, APOSTROPHE: 192, SINGLE_QUOTE: 222, OPEN_SQUARE_BRACKET: 219, BACKSLASH: 220, CLOSE_SQUARE_BRACKET: 221, WIN_KEY: 224, MAC_FF_META: 224, WIN_IME: 229, isTextModifyingKeyEvent: function(ge) {
            var He = ge.keyCode;
            if (ge.altKey && !ge.ctrlKey || ge.metaKey || He >= Gs.F1 && He <= Gs.F12)
              return false;
            switch (He) {
              case Gs.ALT:
              case Gs.CAPS_LOCK:
              case Gs.CONTEXT_MENU:
              case Gs.CTRL:
              case Gs.DOWN:
              case Gs.END:
              case Gs.ESC:
              case Gs.HOME:
              case Gs.INSERT:
              case Gs.LEFT:
              case Gs.MAC_FF_META:
              case Gs.META:
              case Gs.NUMLOCK:
              case Gs.NUM_CENTER:
              case Gs.PAGE_DOWN:
              case Gs.PAGE_UP:
              case Gs.PAUSE:
              case Gs.PRINT_SCREEN:
              case Gs.RIGHT:
              case Gs.SHIFT:
              case Gs.UP:
              case Gs.WIN_KEY:
              case Gs.WIN_KEY_RIGHT:
                return false;
              default:
                return true;
            }
          }, isCharacterKey: function(ge) {
            if (ge >= Gs.ZERO && ge <= Gs.NINE || ge >= Gs.NUM_ZERO && ge <= Gs.NUM_MULTIPLY || ge >= Gs.A && ge <= Gs.Z || window.navigator.userAgent.indexOf("WebKit") !== -1 && ge === 0)
              return true;
            switch (ge) {
              case Gs.SPACE:
              case Gs.QUESTION_MARK:
              case Gs.NUM_PLUS:
              case Gs.NUM_MINUS:
              case Gs.NUM_PERIOD:
              case Gs.NUM_DIVISION:
              case Gs.SEMICOLON:
              case Gs.DASH:
              case Gs.EQUALS:
              case Gs.COMMA:
              case Gs.PERIOD:
              case Gs.SLASH:
              case Gs.APOSTROPHE:
              case Gs.SINGLE_QUOTE:
              case Gs.OPEN_SQUARE_BRACKET:
              case Gs.BACKSLASH:
              case Gs.CLOSE_SQUARE_BRACKET:
                return true;
              default:
                return false;
            }
          } }, VB = function() {
            for (var ge = arguments.length, He = new Array(ge), we = 0; we < ge; we++)
              He[we] = arguments[we];
            return He;
          }, ZY = st.isValidElement;
          function _6(ge, He, we) {
            return ZY(ge) ? st.cloneElement(ge, typeof we == "function" ? we(ge.props || {}) : we) : He;
          }
          function JY(ge, He) {
            return _6(ge, ge, He);
          }
          var qC = ["xxl", "xl", "lg", "md", "sm", "xs"], ID = { xs: "(max-width: 575px)", sm: "(min-width: 576px)", md: "(min-width: 768px)", lg: "(min-width: 992px)", xl: "(min-width: 1200px)", xxl: "(min-width: 1600px)" }, $C = /* @__PURE__ */ new Map(), x6 = -1, n_ = {}, w6 = { matchHandlers: {}, dispatch: function(ge) {
            return n_ = ge, $C.forEach(function(He) {
              return He(n_);
            }), $C.size >= 1;
          }, subscribe: function(ge) {
            return $C.size || this.register(), x6 += 1, $C.set(x6, ge), ge(n_), x6;
          }, unsubscribe: function(ge) {
            $C.delete(ge), $C.size || this.unregister();
          }, unregister: function() {
            var ge = this;
            Object.keys(ID).forEach(function(He) {
              var we = ID[He], Me = ge.matchHandlers[we];
              Me == null || Me.mql.removeListener(Me == null ? void 0 : Me.listener);
            }), $C.clear();
          }, register: function() {
            var ge = this;
            Object.keys(ID).forEach(function(He) {
              var we = ID[He], Me = function(Ne) {
                var it = Ne.matches;
                ge.dispatch(jl(jl({}, n_), dn({}, He, it)));
              }, Te = window.matchMedia(we);
              Te.addListener(Me), ge.matchHandlers[we] = { mql: Te, listener: Me }, Me(Te);
            });
          } }, BB = w6, S6 = 0, XC = {};
          function tO(ge) {
            var He = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1, we = S6++, Me = He;
            function Te() {
              Me -= 1, Me <= 0 ? (ge(), delete XC[we]) : XC[we] = pd(Te);
            }
            return XC[we] = pd(Te), we;
          }
          tO.cancel = function(ge) {
            ge !== void 0 && (pd.cancel(XC[ge]), delete XC[ge]);
          }, tO.ids = XC;
          var C6;
          function zB(ge) {
            return !ge || ge.offsetParent === null || ge.hidden;
          }
          function jB(ge) {
            var He = (ge || "").match(/rgba?\((\d*), (\d*), (\d*)(, [\d.]*)?\)/);
            return He && He[1] && He[2] && He[3] ? !(He[1] === He[2] && He[2] === He[3]) : true;
          }
          var nO = function(ge) {
            Q4(we, ge);
            var He = BS(we);
            function we() {
              var Me;
              return r1(this, we), Me = He.apply(this, arguments), Me.containerRef = st.createRef(), Me.animationStart = false, Me.destroyed = false, Me.onClick = function(Te, Ne) {
                var it, ht, xt = Me.props, kt = xt.insertExtraNode, Lt = xt.disabled;
                if (!(Lt || !Te || zB(Te) || Te.className.indexOf("-leave") >= 0)) {
                  Me.extraNode = document.createElement("div");
                  var sn = j3(Me), Bn = sn.extraNode, Xn = Me.context.getPrefixCls;
                  Bn.className = "".concat(Xn(""), "-click-animating-node");
                  var $n = Me.getAttributeName();
                  if (Te.setAttribute($n, "true"), Ne && Ne !== "#ffffff" && Ne !== "rgb(255, 255, 255)" && jB(Ne) && !/rgba\((?:\d*, ){3}0\)/.test(Ne) && Ne !== "transparent") {
                    Bn.style.borderColor = Ne;
                    var lr = ((it = Te.getRootNode) === null || it === void 0 ? void 0 : it.call(Te)) || Te.ownerDocument, br = lr instanceof Document ? lr.body : (ht = lr.firstChild) !== null && ht !== void 0 ? ht : lr;
                    C6 = oB(`
      [`.concat(Xn(""), "-click-animating-without-extra-node='true']::after, .").concat(Xn(""), `-click-animating-node {
        --antd-wave-shadow-color: `).concat(Ne, `;
      }`), "antd-wave", { csp: Me.csp, attachTo: br });
                  }
                  kt && Te.appendChild(Bn), ["transition", "animation"].forEach(function(ki) {
                    Te.addEventListener("".concat(ki, "start"), Me.onTransitionStart), Te.addEventListener("".concat(ki, "end"), Me.onTransitionEnd);
                  });
                }
              }, Me.onTransitionStart = function(Te) {
                if (!Me.destroyed) {
                  var Ne = Me.containerRef.current;
                  !Te || Te.target !== Ne || Me.animationStart || Me.resetEffect(Ne);
                }
              }, Me.onTransitionEnd = function(Te) {
                !Te || Te.animationName !== "fadeEffect" || Me.resetEffect(Te.target);
              }, Me.bindAnimationEvent = function(Te) {
                if (!(!Te || !Te.getAttribute || Te.getAttribute("disabled") || Te.className.indexOf("disabled") >= 0)) {
                  var Ne = function(it) {
                    if (!(it.target.tagName === "INPUT" || zB(it.target))) {
                      Me.resetEffect(Te);
                      var ht = getComputedStyle(Te).getPropertyValue("border-top-color") || getComputedStyle(Te).getPropertyValue("border-color") || getComputedStyle(Te).getPropertyValue("background-color");
                      Me.clickWaveTimeoutId = window.setTimeout(function() {
                        return Me.onClick(Te, ht);
                      }, 0), tO.cancel(Me.animationStartId), Me.animationStart = true, Me.animationStartId = tO(function() {
                        Me.animationStart = false;
                      }, 10);
                    }
                  };
                  return Te.addEventListener("click", Ne, true), { cancel: function() {
                    Te.removeEventListener("click", Ne, true);
                  } };
                }
              }, Me.renderWave = function(Te) {
                var Ne = Te.csp, it = Me.props.children;
                if (Me.csp = Ne, !st.isValidElement(it))
                  return it;
                var ht = Me.containerRef;
                return HS(it) && (ht = dB(it.ref, Me.containerRef)), JY(it, { ref: ht });
              }, Me;
            }
            return VS(we, [{ key: "componentDidMount", value: function() {
              var Me = this.containerRef.current;
              !Me || Me.nodeType !== 1 || (this.instance = this.bindAnimationEvent(Me));
            } }, { key: "componentWillUnmount", value: function() {
              this.instance && this.instance.cancel(), this.clickWaveTimeoutId && clearTimeout(this.clickWaveTimeoutId), this.destroyed = true;
            } }, { key: "getAttributeName", value: function() {
              var Me = this.context.getPrefixCls, Te = this.props.insertExtraNode;
              return Te ? "".concat(Me(""), "-click-animating") : "".concat(Me(""), "-click-animating-without-extra-node");
            } }, { key: "resetEffect", value: function(Me) {
              var Te = this;
              if (!(!Me || Me === this.extraNode || !(Me instanceof Element))) {
                var Ne = this.props.insertExtraNode, it = this.getAttributeName();
                Me.setAttribute(it, "false"), C6 && (C6.innerHTML = ""), Ne && this.extraNode && Me.contains(this.extraNode) && Me.removeChild(this.extraNode), ["transition", "animation"].forEach(function(ht) {
                  Me.removeEventListener("".concat(ht, "start"), Te.onTransitionStart), Me.removeEventListener("".concat(ht, "end"), Te.onTransitionEnd);
                });
              }
            } }, { key: "render", value: function() {
              return st.createElement(tv, null, this.renderWave);
            } }]), we;
          }(st.Component);
          nO.contextType = Rx;
          var M6 = { exports: {} }, YC = {};
          /** @license React v17.0.2
          * react-jsx-runtime.production.min.js
          *
          * Copyright (c) Facebook, Inc. and its affiliates.
          *
          * This source code is licensed under the MIT license found in the
          * LICENSE file in the root directory of this source tree.
          */
          var GB = ft.default, T6 = 60103;
          if (YC.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
            var A6 = Symbol.for;
            T6 = A6("react.element"), YC.Fragment = A6("react.fragment");
          }
          var rO = GB.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, QY = Object.prototype.hasOwnProperty, HB = { key: true, ref: true, __self: true, __source: true };
          function I6(ge, He, we) {
            var Me, Te = {}, Ne = null, it = null;
            we !== void 0 && (Ne = "" + we), He.key !== void 0 && (Ne = "" + He.key), He.ref !== void 0 && (it = He.ref);
            for (Me in He)
              QY.call(He, Me) && !HB.hasOwnProperty(Me) && (Te[Me] = He[Me]);
            if (ge && ge.defaultProps)
              for (Me in He = ge.defaultProps, He)
                Te[Me] === void 0 && (Te[Me] = He[Me]);
            return { $$typeof: T6, type: ge, key: Ne, ref: it, props: Te, _owner: rO.current };
          }
          YC.jsx = I6, YC.jsxs = I6, M6.exports = YC;
          const dA = M6.exports.jsx, WB = M6.exports.jsxs;
          var eK = Ce.createContext({}), iO = eK, q10 = function() {
            return $4() && window.document.documentElement;
          }, re, Ee = function() {
            if (!q10())
              return false;
            if (re !== void 0)
              return re;
            var ge = document.createElement("div");
            return ge.style.display = "flex", ge.style.flexDirection = "column", ge.style.rowGap = "1px", ge.appendChild(document.createElement("div")), ge.appendChild(document.createElement("div")), document.body.appendChild(ge), re = ge.scrollHeight === 1, document.body.removeChild(ge), re;
          }, Je = function() {
            var ge = st.useState(false), He = ur(ge, 2), we = He[0], Me = He[1];
            return st.useEffect(function() {
              Me(Ee());
            }, []), we;
          }, St = globalThis && globalThis.__rest || function(ge, He) {
            var we = {};
            for (var Me in ge)
              Object.prototype.hasOwnProperty.call(ge, Me) && He.indexOf(Me) < 0 && (we[Me] = ge[Me]);
            if (ge != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Te = 0, Me = Object.getOwnPropertySymbols(ge); Te < Me.length; Te++)
                He.indexOf(Me[Te]) < 0 && Object.prototype.propertyIsEnumerable.call(ge, Me[Te]) && (we[Me[Te]] = ge[Me[Te]]);
            return we;
          };
          VB("top", "middle", "bottom", "stretch"), VB("start", "end", "center", "space-around", "space-between");
          var rn = st.forwardRef(function(ge, He) {
            var we, Me = ge.prefixCls, Te = ge.justify, Ne = ge.align, it = ge.className, ht = ge.style, xt = ge.children, kt = ge.gutter, Lt = kt === void 0 ? 0 : kt, sn = ge.wrap, Bn = St(ge, ["prefixCls", "justify", "align", "className", "style", "children", "gutter", "wrap"]), Xn = st.useContext(Rx), $n = Xn.getPrefixCls, lr = Xn.direction, br = st.useState({ xs: true, sm: true, md: true, lg: true, xl: true, xxl: true }), ki = ur(br, 2), bi = ki[0], Oa = ki[1], Ct = Je(), dr = st.useRef(Lt);
            st.useEffect(function() {
              var Oi = BB.subscribe(function(ii) {
                var ai = dr.current || 0;
                (!Array.isArray(ai) && El(ai) === "object" || Array.isArray(ai) && (El(ai[0]) === "object" || El(ai[1]) === "object")) && Oa(ii);
              });
              return function() {
                return BB.unsubscribe(Oi);
              };
            }, []);
            var Wr = function() {
              var Oi = [0, 0], ii = Array.isArray(Lt) ? Lt : [Lt, 0];
              return ii.forEach(function(ai, Ga) {
                if (El(ai) === "object")
                  for (var Aa = 0; Aa < qC.length; Aa++) {
                    var el = qC[Aa];
                    if (bi[el] && ai[el] !== void 0) {
                      Oi[Ga] = ai[el];
                      break;
                    }
                  }
                else
                  Oi[Ga] = ai || 0;
              }), Oi;
            }, Ci = $n("row", Me), _i = Wr(), Pr = Xl(Ci, (we = {}, dn(we, "".concat(Ci, "-no-wrap"), sn === false), dn(we, "".concat(Ci, "-").concat(Te), Te), dn(we, "".concat(Ci, "-").concat(Ne), Ne), dn(we, "".concat(Ci, "-rtl"), lr === "rtl"), we), it), $r = {}, Hi = _i[0] > 0 ? _i[0] / -2 : void 0, wa = _i[1] > 0 ? _i[1] / -2 : void 0;
            if (Hi && ($r.marginLeft = Hi, $r.marginRight = Hi), Ct) {
              var Mr = ur(_i, 2);
              $r.rowGap = Mr[1];
            } else
              wa && ($r.marginTop = wa, $r.marginBottom = wa);
            var No = ur(_i, 2), Po = No[0], Mi = No[1], Is = st.useMemo(function() {
              return { gutter: [Po, Mi], wrap: sn, supportFlexGap: Ct };
            }, [Po, Mi, sn, Ct]);
            return st.createElement(iO.Provider, { value: Is }, st.createElement("div", jl({}, Bn, { className: Pr, style: jl(jl({}, $r), ht), ref: He }), xt));
          });
          rn.displayName = "Row";
          var Gn = rn, Yn = globalThis && globalThis.__rest || function(ge, He) {
            var we = {};
            for (var Me in ge)
              Object.prototype.hasOwnProperty.call(ge, Me) && He.indexOf(Me) < 0 && (we[Me] = ge[Me]);
            if (ge != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Te = 0, Me = Object.getOwnPropertySymbols(ge); Te < Me.length; Te++)
                He.indexOf(Me[Te]) < 0 && Object.prototype.propertyIsEnumerable.call(ge, Me[Te]) && (we[Me[Te]] = ge[Me[Te]]);
            return we;
          };
          function Cr(ge) {
            return typeof ge == "number" ? "".concat(ge, " ").concat(ge, " auto") : /^\d+(\.\d+)?(px|em|rem|%)$/.test(ge) ? "0 0 ".concat(ge) : ge;
          }
          var aa = ["xs", "sm", "md", "lg", "xl", "xxl"], oa = st.forwardRef(function(ge, He) {
            var we, Me = st.useContext(Rx), Te = Me.getPrefixCls, Ne = Me.direction, it = st.useContext(iO), ht = it.gutter, xt = it.wrap, kt = it.supportFlexGap, Lt = ge.prefixCls, sn = ge.span, Bn = ge.order, Xn = ge.offset, $n = ge.push, lr = ge.pull, br = ge.className, ki = ge.children, bi = ge.flex, Oa = ge.style, Ct = Yn(ge, ["prefixCls", "span", "order", "offset", "push", "pull", "className", "children", "flex", "style"]), dr = Te("col", Lt), Wr = {};
            aa.forEach(function(Hi) {
              var wa, Mr = {}, No = ge[Hi];
              typeof No == "number" ? Mr.span = No : El(No) === "object" && (Mr = No || {}), delete Ct[Hi], Wr = jl(jl({}, Wr), (wa = {}, dn(wa, "".concat(dr, "-").concat(Hi, "-").concat(Mr.span), Mr.span !== void 0), dn(wa, "".concat(dr, "-").concat(Hi, "-order-").concat(Mr.order), Mr.order || Mr.order === 0), dn(wa, "".concat(dr, "-").concat(Hi, "-offset-").concat(Mr.offset), Mr.offset || Mr.offset === 0), dn(wa, "".concat(dr, "-").concat(Hi, "-push-").concat(Mr.push), Mr.push || Mr.push === 0), dn(wa, "".concat(dr, "-").concat(Hi, "-pull-").concat(Mr.pull), Mr.pull || Mr.pull === 0), dn(wa, "".concat(dr, "-rtl"), Ne === "rtl"), wa));
            });
            var Ci = Xl(dr, (we = {}, dn(we, "".concat(dr, "-").concat(sn), sn !== void 0), dn(we, "".concat(dr, "-order-").concat(Bn), Bn), dn(we, "".concat(dr, "-offset-").concat(Xn), Xn), dn(we, "".concat(dr, "-push-").concat($n), $n), dn(we, "".concat(dr, "-pull-").concat(lr), lr), we), br, Wr), _i = {};
            if (ht && ht[0] > 0) {
              var Pr = ht[0] / 2;
              _i.paddingLeft = Pr, _i.paddingRight = Pr;
            }
            if (ht && ht[1] > 0 && !kt) {
              var $r = ht[1] / 2;
              _i.paddingTop = $r, _i.paddingBottom = $r;
            }
            return bi && (_i.flex = Cr(bi), xt === false && !_i.minWidth && (_i.minWidth = 0)), st.createElement("div", jl({}, Ct, { style: jl(jl({}, _i), Oa), className: Ci, ref: He }), ki);
          });
          oa.displayName = "Col";
          var ua = oa, bo = st.forwardRef(function(ge, He) {
            var we, Me = ge.prefixCls, Te = Me === void 0 ? "rc-switch" : Me, Ne = ge.className, it = ge.checked, ht = ge.defaultChecked, xt = ge.disabled, kt = ge.loadingIcon, Lt = ge.checkedChildren, sn = ge.unCheckedChildren, Bn = ge.onClick, Xn = ge.onChange, $n = ge.onKeyDown, lr = Go(ge, ["prefixCls", "className", "checked", "defaultChecked", "disabled", "loadingIcon", "checkedChildren", "unCheckedChildren", "onClick", "onChange", "onKeyDown"]), br = b6(false, { value: it, defaultValue: ht }), ki = ur(br, 2), bi = ki[0], Oa = ki[1];
            function Ct(_i, Pr) {
              var $r = bi;
              return xt || ($r = _i, Oa($r), Xn == null || Xn($r, Pr)), $r;
            }
            function dr(_i) {
              _i.which === Gs.LEFT ? Ct(false, _i) : _i.which === Gs.RIGHT && Ct(true, _i), $n == null || $n(_i);
            }
            function Wr(_i) {
              var Pr = Ct(!bi, _i);
              Bn == null || Bn(Pr, _i);
            }
            var Ci = Xl(Te, Ne, (we = {}, dn(we, "".concat(Te, "-checked"), bi), dn(we, "".concat(Te, "-disabled"), xt), we));
            return st.createElement("button", Object.assign({}, lr, { type: "button", role: "switch", "aria-checked": bi, disabled: xt, className: Ci, ref: He, onKeyDown: dr, onClick: Wr }), kt, st.createElement("span", { className: "".concat(Te, "-inner") }, bi ? Lt : sn));
          });
          bo.displayName = "Switch";
          var os = globalThis && globalThis.__rest || function(ge, He) {
            var we = {};
            for (var Me in ge)
              Object.prototype.hasOwnProperty.call(ge, Me) && He.indexOf(Me) < 0 && (we[Me] = ge[Me]);
            if (ge != null && typeof Object.getOwnPropertySymbols == "function")
              for (var Te = 0, Me = Object.getOwnPropertySymbols(ge); Te < Me.length; Te++)
                He.indexOf(Me[Te]) < 0 && Object.prototype.propertyIsEnumerable.call(ge, Me[Te]) && (we[Me[Te]] = ge[Me[Te]]);
            return we;
          }, Rs = st.forwardRef(function(ge, He) {
            var we, Me = ge.prefixCls, Te = ge.size, Ne = ge.loading, it = ge.className, ht = it === void 0 ? "" : it, xt = ge.disabled, kt = os(ge, ["prefixCls", "size", "loading", "className", "disabled"]);
            UY("checked" in kt || !("value" in kt), "Switch", "`value` is not a valid prop, do you mean `checked`?");
            var Lt = st.useContext(Rx), sn = Lt.getPrefixCls, Bn = Lt.direction, Xn = st.useContext(Yg), $n = sn("switch", Me), lr = st.createElement("div", { className: "".concat($n, "-handle") }, Ne && st.createElement(J4, { className: "".concat($n, "-loading-icon") })), br = Xl((we = {}, dn(we, "".concat($n, "-small"), (Te || Xn) === "small"), dn(we, "".concat($n, "-loading"), Ne), dn(we, "".concat($n, "-rtl"), Bn === "rtl"), we), ht);
            return st.createElement(nO, { insertExtraNode: true }, st.createElement(bo, jl({}, kt, { prefixCls: $n, className: br, disabled: xt || Ne, ref: He, loadingIcon: lr })));
          });
          Rs.__ANT_SWITCH = true, Rs.displayName = "Switch";
          var su = Rs, Us = { container: "_container_oi76t_1", function: "_function_oi76t_10" }, Qs = { exports: {} };
          (function(ge, He) {
            (function(we, Me) {
              ge.exports = Me(ft.default);
            })(tn, function(we) {
              return function(Me) {
                var Te = {};
                function Ne(it) {
                  if (Te[it])
                    return Te[it].exports;
                  var ht = Te[it] = { i: it, l: false, exports: {} };
                  return Me[it].call(ht.exports, ht, ht.exports, Ne), ht.l = true, ht.exports;
                }
                return Ne.m = Me, Ne.c = Te, Ne.d = function(it, ht, xt) {
                  Ne.o(it, ht) || Object.defineProperty(it, ht, { enumerable: true, get: xt });
                }, Ne.r = function(it) {
                  typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(it, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(it, "__esModule", { value: true });
                }, Ne.t = function(it, ht) {
                  if (1 & ht && (it = Ne(it)), 8 & ht || 4 & ht && typeof it == "object" && it && it.__esModule)
                    return it;
                  var xt = /* @__PURE__ */ Object.create(null);
                  if (Ne.r(xt), Object.defineProperty(xt, "default", { enumerable: true, value: it }), 2 & ht && typeof it != "string")
                    for (var kt in it)
                      Ne.d(xt, kt, function(Lt) {
                        return it[Lt];
                      }.bind(null, kt));
                  return xt;
                }, Ne.n = function(it) {
                  var ht = it && it.__esModule ? function() {
                    return it.default;
                  } : function() {
                    return it;
                  };
                  return Ne.d(ht, "a", ht), ht;
                }, Ne.o = function(it, ht) {
                  return Object.prototype.hasOwnProperty.call(it, ht);
                }, Ne.p = "", Ne(Ne.s = 48);
              }([function(Me, Te) {
                Me.exports = we;
              }, function(Me, Te) {
                var Ne = Me.exports = { version: "2.6.12" };
                typeof __e == "number" && (__e = Ne);
              }, function(Me, Te, Ne) {
                var it = Ne(26)("wks"), ht = Ne(17), xt = Ne(3).Symbol, kt = typeof xt == "function";
                (Me.exports = function(Lt) {
                  return it[Lt] || (it[Lt] = kt && xt[Lt] || (kt ? xt : ht)("Symbol." + Lt));
                }).store = it;
              }, function(Me, Te) {
                var Ne = Me.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
                typeof __g == "number" && (__g = Ne);
              }, function(Me, Te, Ne) {
                Me.exports = !Ne(8)(function() {
                  return Object.defineProperty({}, "a", { get: function() {
                    return 7;
                  } }).a != 7;
                });
              }, function(Me, Te) {
                var Ne = {}.hasOwnProperty;
                Me.exports = function(it, ht) {
                  return Ne.call(it, ht);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(7), ht = Ne(16);
                Me.exports = Ne(4) ? function(xt, kt, Lt) {
                  return it.f(xt, kt, ht(1, Lt));
                } : function(xt, kt, Lt) {
                  return xt[kt] = Lt, xt;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(10), ht = Ne(35), xt = Ne(23), kt = Object.defineProperty;
                Te.f = Ne(4) ? Object.defineProperty : function(Lt, sn, Bn) {
                  if (it(Lt), sn = xt(sn, true), it(Bn), ht)
                    try {
                      return kt(Lt, sn, Bn);
                    } catch {
                    }
                  if ("get" in Bn || "set" in Bn)
                    throw TypeError("Accessors not supported!");
                  return "value" in Bn && (Lt[sn] = Bn.value), Lt;
                };
              }, function(Me, Te) {
                Me.exports = function(Ne) {
                  try {
                    return !!Ne();
                  } catch {
                    return true;
                  }
                };
              }, function(Me, Te, Ne) {
                var it = Ne(40), ht = Ne(22);
                Me.exports = function(xt) {
                  return it(ht(xt));
                };
              }, function(Me, Te, Ne) {
                var it = Ne(11);
                Me.exports = function(ht) {
                  if (!it(ht))
                    throw TypeError(ht + " is not an object!");
                  return ht;
                };
              }, function(Me, Te) {
                Me.exports = function(Ne) {
                  return typeof Ne == "object" ? Ne !== null : typeof Ne == "function";
                };
              }, function(Me, Te) {
                Me.exports = {};
              }, function(Me, Te, Ne) {
                var it = Ne(39), ht = Ne(27);
                Me.exports = Object.keys || function(xt) {
                  return it(xt, ht);
                };
              }, function(Me, Te) {
                Me.exports = true;
              }, function(Me, Te, Ne) {
                var it = Ne(3), ht = Ne(1), xt = Ne(53), kt = Ne(6), Lt = Ne(5), sn = function(Bn, Xn, $n) {
                  var lr, br, ki, bi = Bn & sn.F, Oa = Bn & sn.G, Ct = Bn & sn.S, dr = Bn & sn.P, Wr = Bn & sn.B, Ci = Bn & sn.W, _i = Oa ? ht : ht[Xn] || (ht[Xn] = {}), Pr = _i.prototype, $r = Oa ? it : Ct ? it[Xn] : (it[Xn] || {}).prototype;
                  for (lr in Oa && ($n = Xn), $n)
                    (br = !bi && $r && $r[lr] !== void 0) && Lt(_i, lr) || (ki = br ? $r[lr] : $n[lr], _i[lr] = Oa && typeof $r[lr] != "function" ? $n[lr] : Wr && br ? xt(ki, it) : Ci && $r[lr] == ki ? function(Hi) {
                      var wa = function(Mr, No, Po) {
                        if (this instanceof Hi) {
                          switch (arguments.length) {
                            case 0:
                              return new Hi();
                            case 1:
                              return new Hi(Mr);
                            case 2:
                              return new Hi(Mr, No);
                          }
                          return new Hi(Mr, No, Po);
                        }
                        return Hi.apply(this, arguments);
                      };
                      return wa.prototype = Hi.prototype, wa;
                    }(ki) : dr && typeof ki == "function" ? xt(Function.call, ki) : ki, dr && ((_i.virtual || (_i.virtual = {}))[lr] = ki, Bn & sn.R && Pr && !Pr[lr] && kt(Pr, lr, ki)));
                };
                sn.F = 1, sn.G = 2, sn.S = 4, sn.P = 8, sn.B = 16, sn.W = 32, sn.U = 64, sn.R = 128, Me.exports = sn;
              }, function(Me, Te) {
                Me.exports = function(Ne, it) {
                  return { enumerable: !(1 & Ne), configurable: !(2 & Ne), writable: !(4 & Ne), value: it };
                };
              }, function(Me, Te) {
                var Ne = 0, it = Math.random();
                Me.exports = function(ht) {
                  return "Symbol(".concat(ht === void 0 ? "" : ht, ")_", (++Ne + it).toString(36));
                };
              }, function(Me, Te, Ne) {
                var it = Ne(22);
                Me.exports = function(ht) {
                  return Object(it(ht));
                };
              }, function(Me, Te) {
                Te.f = {}.propertyIsEnumerable;
              }, function(Me, Te, Ne) {
                var it = Ne(52)(true);
                Ne(34)(String, "String", function(ht) {
                  this._t = String(ht), this._i = 0;
                }, function() {
                  var ht, xt = this._t, kt = this._i;
                  return kt >= xt.length ? { value: void 0, done: true } : (ht = it(xt, kt), this._i += ht.length, { value: ht, done: false });
                });
              }, function(Me, Te) {
                var Ne = Math.ceil, it = Math.floor;
                Me.exports = function(ht) {
                  return isNaN(ht = +ht) ? 0 : (ht > 0 ? it : Ne)(ht);
                };
              }, function(Me, Te) {
                Me.exports = function(Ne) {
                  if (Ne == null)
                    throw TypeError("Can't call method on  " + Ne);
                  return Ne;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(11);
                Me.exports = function(ht, xt) {
                  if (!it(ht))
                    return ht;
                  var kt, Lt;
                  if (xt && typeof (kt = ht.toString) == "function" && !it(Lt = kt.call(ht)) || typeof (kt = ht.valueOf) == "function" && !it(Lt = kt.call(ht)) || !xt && typeof (kt = ht.toString) == "function" && !it(Lt = kt.call(ht)))
                    return Lt;
                  throw TypeError("Can't convert object to primitive value");
                };
              }, function(Me, Te) {
                var Ne = {}.toString;
                Me.exports = function(it) {
                  return Ne.call(it).slice(8, -1);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(26)("keys"), ht = Ne(17);
                Me.exports = function(xt) {
                  return it[xt] || (it[xt] = ht(xt));
                };
              }, function(Me, Te, Ne) {
                var it = Ne(1), ht = Ne(3), xt = ht["__core-js_shared__"] || (ht["__core-js_shared__"] = {});
                (Me.exports = function(kt, Lt) {
                  return xt[kt] || (xt[kt] = Lt !== void 0 ? Lt : {});
                })("versions", []).push({ version: it.version, mode: Ne(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
              }, function(Me, Te) {
                Me.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
              }, function(Me, Te, Ne) {
                var it = Ne(7).f, ht = Ne(5), xt = Ne(2)("toStringTag");
                Me.exports = function(kt, Lt, sn) {
                  kt && !ht(kt = sn ? kt : kt.prototype, xt) && it(kt, xt, { configurable: true, value: Lt });
                };
              }, function(Me, Te, Ne) {
                Ne(62);
                for (var it = Ne(3), ht = Ne(6), xt = Ne(12), kt = Ne(2)("toStringTag"), Lt = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), sn = 0; sn < Lt.length; sn++) {
                  var Bn = Lt[sn], Xn = it[Bn], $n = Xn && Xn.prototype;
                  $n && !$n[kt] && ht($n, kt, Bn), xt[Bn] = xt.Array;
                }
              }, function(Me, Te, Ne) {
                Te.f = Ne(2);
              }, function(Me, Te, Ne) {
                var it = Ne(3), ht = Ne(1), xt = Ne(14), kt = Ne(30), Lt = Ne(7).f;
                Me.exports = function(sn) {
                  var Bn = ht.Symbol || (ht.Symbol = xt ? {} : it.Symbol || {});
                  sn.charAt(0) == "_" || sn in Bn || Lt(Bn, sn, { value: kt.f(sn) });
                };
              }, function(Me, Te) {
                Te.f = Object.getOwnPropertySymbols;
              }, function(Me, Te) {
                Me.exports = function(Ne, it, ht) {
                  return Math.min(Math.max(Ne, it), ht);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(14), ht = Ne(15), xt = Ne(37), kt = Ne(6), Lt = Ne(12), sn = Ne(55), Bn = Ne(28), Xn = Ne(61), $n = Ne(2)("iterator"), lr = !([].keys && "next" in [].keys()), br = function() {
                  return this;
                };
                Me.exports = function(ki, bi, Oa, Ct, dr, Wr, Ci) {
                  sn(Oa, bi, Ct);
                  var _i, Pr, $r, Hi = function(ai) {
                    if (!lr && ai in Po)
                      return Po[ai];
                    switch (ai) {
                      case "keys":
                      case "values":
                        return function() {
                          return new Oa(this, ai);
                        };
                    }
                    return function() {
                      return new Oa(this, ai);
                    };
                  }, wa = bi + " Iterator", Mr = dr == "values", No = false, Po = ki.prototype, Mi = Po[$n] || Po["@@iterator"] || dr && Po[dr], Is = Mi || Hi(dr), Oi = dr ? Mr ? Hi("entries") : Is : void 0, ii = bi == "Array" && Po.entries || Mi;
                  if (ii && ($r = Xn(ii.call(new ki()))) !== Object.prototype && $r.next && (Bn($r, wa, true), it || typeof $r[$n] == "function" || kt($r, $n, br)), Mr && Mi && Mi.name !== "values" && (No = true, Is = function() {
                    return Mi.call(this);
                  }), it && !Ci || !lr && !No && Po[$n] || kt(Po, $n, Is), Lt[bi] = Is, Lt[wa] = br, dr)
                    if (_i = { values: Mr ? Is : Hi("values"), keys: Wr ? Is : Hi("keys"), entries: Oi }, Ci)
                      for (Pr in _i)
                        Pr in Po || xt(Po, Pr, _i[Pr]);
                    else
                      ht(ht.P + ht.F * (lr || No), bi, _i);
                  return _i;
                };
              }, function(Me, Te, Ne) {
                Me.exports = !Ne(4) && !Ne(8)(function() {
                  return Object.defineProperty(Ne(36)("div"), "a", { get: function() {
                    return 7;
                  } }).a != 7;
                });
              }, function(Me, Te, Ne) {
                var it = Ne(11), ht = Ne(3).document, xt = it(ht) && it(ht.createElement);
                Me.exports = function(kt) {
                  return xt ? ht.createElement(kt) : {};
                };
              }, function(Me, Te, Ne) {
                Me.exports = Ne(6);
              }, function(Me, Te, Ne) {
                var it = Ne(10), ht = Ne(56), xt = Ne(27), kt = Ne(25)("IE_PROTO"), Lt = function() {
                }, sn = function() {
                  var Bn, Xn = Ne(36)("iframe"), $n = xt.length;
                  for (Xn.style.display = "none", Ne(60).appendChild(Xn), Xn.src = "javascript:", (Bn = Xn.contentWindow.document).open(), Bn.write("<script>document.F=Object<\/script>"), Bn.close(), sn = Bn.F; $n--; )
                    delete sn.prototype[xt[$n]];
                  return sn();
                };
                Me.exports = Object.create || function(Bn, Xn) {
                  var $n;
                  return Bn !== null ? (Lt.prototype = it(Bn), $n = new Lt(), Lt.prototype = null, $n[kt] = Bn) : $n = sn(), Xn === void 0 ? $n : ht($n, Xn);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(5), ht = Ne(9), xt = Ne(57)(false), kt = Ne(25)("IE_PROTO");
                Me.exports = function(Lt, sn) {
                  var Bn, Xn = ht(Lt), $n = 0, lr = [];
                  for (Bn in Xn)
                    Bn != kt && it(Xn, Bn) && lr.push(Bn);
                  for (; sn.length > $n; )
                    it(Xn, Bn = sn[$n++]) && (~xt(lr, Bn) || lr.push(Bn));
                  return lr;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(24);
                Me.exports = Object("z").propertyIsEnumerable(0) ? Object : function(ht) {
                  return it(ht) == "String" ? ht.split("") : Object(ht);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(39), ht = Ne(27).concat("length", "prototype");
                Te.f = Object.getOwnPropertyNames || function(xt) {
                  return it(xt, ht);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(24), ht = Ne(2)("toStringTag"), xt = it(function() {
                  return arguments;
                }()) == "Arguments";
                Me.exports = function(kt) {
                  var Lt, sn, Bn;
                  return kt === void 0 ? "Undefined" : kt === null ? "Null" : typeof (sn = function(Xn, $n) {
                    try {
                      return Xn[$n];
                    } catch {
                    }
                  }(Lt = Object(kt), ht)) == "string" ? sn : xt ? it(Lt) : (Bn = it(Lt)) == "Object" && typeof Lt.callee == "function" ? "Arguments" : Bn;
                };
              }, function(Me, Te) {
                var Ne;
                Ne = function() {
                  return this;
                }();
                try {
                  Ne = Ne || new Function("return this")();
                } catch {
                  typeof window == "object" && (Ne = window);
                }
                Me.exports = Ne;
              }, function(Me, Te) {
                var Ne = /-?\d+(\.\d+)?%?/g;
                Me.exports = function(it) {
                  return it.match(Ne);
                };
              }, function(Me, Te, Ne) {
                Object.defineProperty(Te, "__esModule", { value: true }), Te.getBase16Theme = Te.createStyling = Te.invertTheme = void 0;
                var it = br(Ne(49)), ht = br(Ne(76)), xt = br(Ne(81)), kt = br(Ne(89)), Lt = br(Ne(93)), sn = function(Pr) {
                  if (Pr && Pr.__esModule)
                    return Pr;
                  var $r = {};
                  if (Pr != null)
                    for (var Hi in Pr)
                      Object.prototype.hasOwnProperty.call(Pr, Hi) && ($r[Hi] = Pr[Hi]);
                  return $r.default = Pr, $r;
                }(Ne(94)), Bn = br(Ne(132)), Xn = br(Ne(133)), $n = br(Ne(138)), lr = Ne(139);
                function br(Pr) {
                  return Pr && Pr.__esModule ? Pr : { default: Pr };
                }
                var ki = sn.default, bi = (0, kt.default)(ki), Oa = (0, $n.default)(Xn.default, lr.rgb2yuv, function(Pr) {
                  var $r, Hi = (0, xt.default)(Pr, 3), wa = Hi[0], Mr = Hi[1], No = Hi[2];
                  return [($r = wa, $r < 0.25 ? 1 : $r < 0.5 ? 0.9 - $r : 1.1 - $r), Mr, No];
                }, lr.yuv2rgb, Bn.default), Ct = function(Pr) {
                  return function($r) {
                    return { className: [$r.className, Pr.className].filter(Boolean).join(" "), style: (0, ht.default)({}, $r.style || {}, Pr.style || {}) };
                  };
                }, dr = function(Pr, $r) {
                  var Hi = (0, kt.default)($r);
                  for (var wa in Pr)
                    Hi.indexOf(wa) === -1 && Hi.push(wa);
                  return Hi.reduce(function(Mr, No) {
                    return Mr[No] = function(Po, Mi) {
                      if (Po === void 0)
                        return Mi;
                      if (Mi === void 0)
                        return Po;
                      var Is = Po === void 0 ? "undefined" : (0, it.default)(Po), Oi = Mi === void 0 ? "undefined" : (0, it.default)(Mi);
                      switch (Is) {
                        case "string":
                          switch (Oi) {
                            case "string":
                              return [Mi, Po].filter(Boolean).join(" ");
                            case "object":
                              return Ct({ className: Po, style: Mi });
                            case "function":
                              return function(ii) {
                                for (var ai = arguments.length, Ga = Array(ai > 1 ? ai - 1 : 0), Aa = 1; Aa < ai; Aa++)
                                  Ga[Aa - 1] = arguments[Aa];
                                return Ct({ className: Po })(Mi.apply(void 0, [ii].concat(Ga)));
                              };
                          }
                        case "object":
                          switch (Oi) {
                            case "string":
                              return Ct({ className: Mi, style: Po });
                            case "object":
                              return (0, ht.default)({}, Mi, Po);
                            case "function":
                              return function(ii) {
                                for (var ai = arguments.length, Ga = Array(ai > 1 ? ai - 1 : 0), Aa = 1; Aa < ai; Aa++)
                                  Ga[Aa - 1] = arguments[Aa];
                                return Ct({ style: Po })(Mi.apply(void 0, [ii].concat(Ga)));
                              };
                          }
                        case "function":
                          switch (Oi) {
                            case "string":
                              return function(ii) {
                                for (var ai = arguments.length, Ga = Array(ai > 1 ? ai - 1 : 0), Aa = 1; Aa < ai; Aa++)
                                  Ga[Aa - 1] = arguments[Aa];
                                return Po.apply(void 0, [Ct(ii)({ className: Mi })].concat(Ga));
                              };
                            case "object":
                              return function(ii) {
                                for (var ai = arguments.length, Ga = Array(ai > 1 ? ai - 1 : 0), Aa = 1; Aa < ai; Aa++)
                                  Ga[Aa - 1] = arguments[Aa];
                                return Po.apply(void 0, [Ct(ii)({ style: Mi })].concat(Ga));
                              };
                            case "function":
                              return function(ii) {
                                for (var ai = arguments.length, Ga = Array(ai > 1 ? ai - 1 : 0), Aa = 1; Aa < ai; Aa++)
                                  Ga[Aa - 1] = arguments[Aa];
                                return Po.apply(void 0, [Mi.apply(void 0, [ii].concat(Ga))].concat(Ga));
                              };
                          }
                      }
                    }(Pr[No], $r[No]), Mr;
                  }, {});
                }, Wr = function(Pr, $r) {
                  for (var Hi = arguments.length, wa = Array(Hi > 2 ? Hi - 2 : 0), Mr = 2; Mr < Hi; Mr++)
                    wa[Mr - 2] = arguments[Mr];
                  if ($r === null)
                    return Pr;
                  Array.isArray($r) || ($r = [$r]);
                  var No = $r.map(function(Mi) {
                    return Pr[Mi];
                  }).filter(Boolean), Po = No.reduce(function(Mi, Is) {
                    return typeof Is == "string" ? Mi.className = [Mi.className, Is].filter(Boolean).join(" ") : (Is === void 0 ? "undefined" : (0, it.default)(Is)) === "object" ? Mi.style = (0, ht.default)({}, Mi.style, Is) : typeof Is == "function" && (Mi = (0, ht.default)({}, Mi, Is.apply(void 0, [Mi].concat(wa)))), Mi;
                  }, { className: "", style: {} });
                  return Po.className || delete Po.className, (0, kt.default)(Po.style).length === 0 && delete Po.style, Po;
                }, Ci = Te.invertTheme = function(Pr) {
                  return (0, kt.default)(Pr).reduce(function($r, Hi) {
                    return $r[Hi] = /^base/.test(Hi) ? Oa(Pr[Hi]) : Hi === "scheme" ? Pr[Hi] + ":inverted" : Pr[Hi], $r;
                  }, {});
                }, _i = (Te.createStyling = (0, Lt.default)(function(Pr) {
                  for (var $r = arguments.length, Hi = Array($r > 3 ? $r - 3 : 0), wa = 3; wa < $r; wa++)
                    Hi[wa - 3] = arguments[wa];
                  var Mr = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, No = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Po = Mr.defaultBase16, Mi = Po === void 0 ? ki : Po, Is = Mr.base16Themes, Oi = Is === void 0 ? null : Is, ii = _i(No, Oi);
                  ii && (No = (0, ht.default)({}, ii, No));
                  var ai = bi.reduce(function(Cc, $u) {
                    return Cc[$u] = No[$u] || Mi[$u], Cc;
                  }, {}), Ga = (0, kt.default)(No).reduce(function(Cc, $u) {
                    return bi.indexOf($u) === -1 && (Cc[$u] = No[$u]), Cc;
                  }, {}), Aa = Pr(ai), el = dr(Ga, Aa);
                  return (0, Lt.default)(Wr, 2).apply(void 0, [el].concat(Hi));
                }, 3), Te.getBase16Theme = function(Pr, $r) {
                  if (Pr && Pr.extend && (Pr = Pr.extend), typeof Pr == "string") {
                    var Hi = Pr.split(":"), wa = (0, xt.default)(Hi, 2), Mr = wa[0], No = wa[1];
                    Pr = ($r || {})[Mr] || sn[Mr], No === "inverted" && (Pr = Ci(Pr));
                  }
                  return Pr && Pr.hasOwnProperty("base00") ? Pr : void 0;
                });
              }, function(Me, Te, Ne) {
                var it, ht = typeof Reflect == "object" ? Reflect : null, xt = ht && typeof ht.apply == "function" ? ht.apply : function(Ct, dr, Wr) {
                  return Function.prototype.apply.call(Ct, dr, Wr);
                };
                it = ht && typeof ht.ownKeys == "function" ? ht.ownKeys : Object.getOwnPropertySymbols ? function(Ct) {
                  return Object.getOwnPropertyNames(Ct).concat(Object.getOwnPropertySymbols(Ct));
                } : function(Ct) {
                  return Object.getOwnPropertyNames(Ct);
                };
                var kt = Number.isNaN || function(Ct) {
                  return Ct != Ct;
                };
                function Lt() {
                  Lt.init.call(this);
                }
                Me.exports = Lt, Me.exports.once = function(Ct, dr) {
                  return new Promise(function(Wr, Ci) {
                    function _i() {
                      Pr !== void 0 && Ct.removeListener("error", Pr), Wr([].slice.call(arguments));
                    }
                    var Pr;
                    dr !== "error" && (Pr = function($r) {
                      Ct.removeListener(dr, _i), Ci($r);
                    }, Ct.once("error", Pr)), Ct.once(dr, _i);
                  });
                }, Lt.EventEmitter = Lt, Lt.prototype._events = void 0, Lt.prototype._eventsCount = 0, Lt.prototype._maxListeners = void 0;
                var sn = 10;
                function Bn(Ct) {
                  if (typeof Ct != "function")
                    throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof Ct);
                }
                function Xn(Ct) {
                  return Ct._maxListeners === void 0 ? Lt.defaultMaxListeners : Ct._maxListeners;
                }
                function $n(Ct, dr, Wr, Ci) {
                  var _i, Pr, $r, Hi;
                  if (Bn(Wr), (Pr = Ct._events) === void 0 ? (Pr = Ct._events = /* @__PURE__ */ Object.create(null), Ct._eventsCount = 0) : (Pr.newListener !== void 0 && (Ct.emit("newListener", dr, Wr.listener ? Wr.listener : Wr), Pr = Ct._events), $r = Pr[dr]), $r === void 0)
                    $r = Pr[dr] = Wr, ++Ct._eventsCount;
                  else if (typeof $r == "function" ? $r = Pr[dr] = Ci ? [Wr, $r] : [$r, Wr] : Ci ? $r.unshift(Wr) : $r.push(Wr), (_i = Xn(Ct)) > 0 && $r.length > _i && !$r.warned) {
                    $r.warned = true;
                    var wa = new Error("Possible EventEmitter memory leak detected. " + $r.length + " " + String(dr) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                    wa.name = "MaxListenersExceededWarning", wa.emitter = Ct, wa.type = dr, wa.count = $r.length, Hi = wa, console && console.warn && console.warn(Hi);
                  }
                  return Ct;
                }
                function lr() {
                  if (!this.fired)
                    return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
                }
                function br(Ct, dr, Wr) {
                  var Ci = { fired: false, wrapFn: void 0, target: Ct, type: dr, listener: Wr }, _i = lr.bind(Ci);
                  return _i.listener = Wr, Ci.wrapFn = _i, _i;
                }
                function ki(Ct, dr, Wr) {
                  var Ci = Ct._events;
                  if (Ci === void 0)
                    return [];
                  var _i = Ci[dr];
                  return _i === void 0 ? [] : typeof _i == "function" ? Wr ? [_i.listener || _i] : [_i] : Wr ? function(Pr) {
                    for (var $r = new Array(Pr.length), Hi = 0; Hi < $r.length; ++Hi)
                      $r[Hi] = Pr[Hi].listener || Pr[Hi];
                    return $r;
                  }(_i) : Oa(_i, _i.length);
                }
                function bi(Ct) {
                  var dr = this._events;
                  if (dr !== void 0) {
                    var Wr = dr[Ct];
                    if (typeof Wr == "function")
                      return 1;
                    if (Wr !== void 0)
                      return Wr.length;
                  }
                  return 0;
                }
                function Oa(Ct, dr) {
                  for (var Wr = new Array(dr), Ci = 0; Ci < dr; ++Ci)
                    Wr[Ci] = Ct[Ci];
                  return Wr;
                }
                Object.defineProperty(Lt, "defaultMaxListeners", { enumerable: true, get: function() {
                  return sn;
                }, set: function(Ct) {
                  if (typeof Ct != "number" || Ct < 0 || kt(Ct))
                    throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + Ct + ".");
                  sn = Ct;
                } }), Lt.init = function() {
                  this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
                }, Lt.prototype.setMaxListeners = function(Ct) {
                  if (typeof Ct != "number" || Ct < 0 || kt(Ct))
                    throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + Ct + ".");
                  return this._maxListeners = Ct, this;
                }, Lt.prototype.getMaxListeners = function() {
                  return Xn(this);
                }, Lt.prototype.emit = function(Ct) {
                  for (var dr = [], Wr = 1; Wr < arguments.length; Wr++)
                    dr.push(arguments[Wr]);
                  var Ci = Ct === "error", _i = this._events;
                  if (_i !== void 0)
                    Ci = Ci && _i.error === void 0;
                  else if (!Ci)
                    return false;
                  if (Ci) {
                    var Pr;
                    if (dr.length > 0 && (Pr = dr[0]), Pr instanceof Error)
                      throw Pr;
                    var $r = new Error("Unhandled error." + (Pr ? " (" + Pr.message + ")" : ""));
                    throw $r.context = Pr, $r;
                  }
                  var Hi = _i[Ct];
                  if (Hi === void 0)
                    return false;
                  if (typeof Hi == "function")
                    xt(Hi, this, dr);
                  else {
                    var wa = Hi.length, Mr = Oa(Hi, wa);
                    for (Wr = 0; Wr < wa; ++Wr)
                      xt(Mr[Wr], this, dr);
                  }
                  return true;
                }, Lt.prototype.addListener = function(Ct, dr) {
                  return $n(this, Ct, dr, false);
                }, Lt.prototype.on = Lt.prototype.addListener, Lt.prototype.prependListener = function(Ct, dr) {
                  return $n(this, Ct, dr, true);
                }, Lt.prototype.once = function(Ct, dr) {
                  return Bn(dr), this.on(Ct, br(this, Ct, dr)), this;
                }, Lt.prototype.prependOnceListener = function(Ct, dr) {
                  return Bn(dr), this.prependListener(Ct, br(this, Ct, dr)), this;
                }, Lt.prototype.removeListener = function(Ct, dr) {
                  var Wr, Ci, _i, Pr, $r;
                  if (Bn(dr), (Ci = this._events) === void 0)
                    return this;
                  if ((Wr = Ci[Ct]) === void 0)
                    return this;
                  if (Wr === dr || Wr.listener === dr)
                    --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete Ci[Ct], Ci.removeListener && this.emit("removeListener", Ct, Wr.listener || dr));
                  else if (typeof Wr != "function") {
                    for (_i = -1, Pr = Wr.length - 1; Pr >= 0; Pr--)
                      if (Wr[Pr] === dr || Wr[Pr].listener === dr) {
                        $r = Wr[Pr].listener, _i = Pr;
                        break;
                      }
                    if (_i < 0)
                      return this;
                    _i === 0 ? Wr.shift() : function(Hi, wa) {
                      for (; wa + 1 < Hi.length; wa++)
                        Hi[wa] = Hi[wa + 1];
                      Hi.pop();
                    }(Wr, _i), Wr.length === 1 && (Ci[Ct] = Wr[0]), Ci.removeListener !== void 0 && this.emit("removeListener", Ct, $r || dr);
                  }
                  return this;
                }, Lt.prototype.off = Lt.prototype.removeListener, Lt.prototype.removeAllListeners = function(Ct) {
                  var dr, Wr, Ci;
                  if ((Wr = this._events) === void 0)
                    return this;
                  if (Wr.removeListener === void 0)
                    return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Wr[Ct] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Wr[Ct]), this;
                  if (arguments.length === 0) {
                    var _i, Pr = Object.keys(Wr);
                    for (Ci = 0; Ci < Pr.length; ++Ci)
                      (_i = Pr[Ci]) !== "removeListener" && this.removeAllListeners(_i);
                    return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
                  }
                  if (typeof (dr = Wr[Ct]) == "function")
                    this.removeListener(Ct, dr);
                  else if (dr !== void 0)
                    for (Ci = dr.length - 1; Ci >= 0; Ci--)
                      this.removeListener(Ct, dr[Ci]);
                  return this;
                }, Lt.prototype.listeners = function(Ct) {
                  return ki(this, Ct, true);
                }, Lt.prototype.rawListeners = function(Ct) {
                  return ki(this, Ct, false);
                }, Lt.listenerCount = function(Ct, dr) {
                  return typeof Ct.listenerCount == "function" ? Ct.listenerCount(dr) : bi.call(Ct, dr);
                }, Lt.prototype.listenerCount = bi, Lt.prototype.eventNames = function() {
                  return this._eventsCount > 0 ? it(this._events) : [];
                };
              }, function(Me, Te, Ne) {
                Me.exports.Dispatcher = Ne(140);
              }, function(Me, Te, Ne) {
                Me.exports = Ne(142);
              }, function(Me, Te, Ne) {
                Te.__esModule = true;
                var it = kt(Ne(50)), ht = kt(Ne(65)), xt = typeof ht.default == "function" && typeof it.default == "symbol" ? function(Lt) {
                  return typeof Lt;
                } : function(Lt) {
                  return Lt && typeof ht.default == "function" && Lt.constructor === ht.default && Lt !== ht.default.prototype ? "symbol" : typeof Lt;
                };
                function kt(Lt) {
                  return Lt && Lt.__esModule ? Lt : { default: Lt };
                }
                Te.default = typeof ht.default == "function" && xt(it.default) === "symbol" ? function(Lt) {
                  return Lt === void 0 ? "undefined" : xt(Lt);
                } : function(Lt) {
                  return Lt && typeof ht.default == "function" && Lt.constructor === ht.default && Lt !== ht.default.prototype ? "symbol" : Lt === void 0 ? "undefined" : xt(Lt);
                };
              }, function(Me, Te, Ne) {
                Me.exports = { default: Ne(51), __esModule: true };
              }, function(Me, Te, Ne) {
                Ne(20), Ne(29), Me.exports = Ne(30).f("iterator");
              }, function(Me, Te, Ne) {
                var it = Ne(21), ht = Ne(22);
                Me.exports = function(xt) {
                  return function(kt, Lt) {
                    var sn, Bn, Xn = String(ht(kt)), $n = it(Lt), lr = Xn.length;
                    return $n < 0 || $n >= lr ? xt ? "" : void 0 : (sn = Xn.charCodeAt($n)) < 55296 || sn > 56319 || $n + 1 === lr || (Bn = Xn.charCodeAt($n + 1)) < 56320 || Bn > 57343 ? xt ? Xn.charAt($n) : sn : xt ? Xn.slice($n, $n + 2) : Bn - 56320 + (sn - 55296 << 10) + 65536;
                  };
                };
              }, function(Me, Te, Ne) {
                var it = Ne(54);
                Me.exports = function(ht, xt, kt) {
                  if (it(ht), xt === void 0)
                    return ht;
                  switch (kt) {
                    case 1:
                      return function(Lt) {
                        return ht.call(xt, Lt);
                      };
                    case 2:
                      return function(Lt, sn) {
                        return ht.call(xt, Lt, sn);
                      };
                    case 3:
                      return function(Lt, sn, Bn) {
                        return ht.call(xt, Lt, sn, Bn);
                      };
                  }
                  return function() {
                    return ht.apply(xt, arguments);
                  };
                };
              }, function(Me, Te) {
                Me.exports = function(Ne) {
                  if (typeof Ne != "function")
                    throw TypeError(Ne + " is not a function!");
                  return Ne;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(38), ht = Ne(16), xt = Ne(28), kt = {};
                Ne(6)(kt, Ne(2)("iterator"), function() {
                  return this;
                }), Me.exports = function(Lt, sn, Bn) {
                  Lt.prototype = it(kt, { next: ht(1, Bn) }), xt(Lt, sn + " Iterator");
                };
              }, function(Me, Te, Ne) {
                var it = Ne(7), ht = Ne(10), xt = Ne(13);
                Me.exports = Ne(4) ? Object.defineProperties : function(kt, Lt) {
                  ht(kt);
                  for (var sn, Bn = xt(Lt), Xn = Bn.length, $n = 0; Xn > $n; )
                    it.f(kt, sn = Bn[$n++], Lt[sn]);
                  return kt;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(9), ht = Ne(58), xt = Ne(59);
                Me.exports = function(kt) {
                  return function(Lt, sn, Bn) {
                    var Xn, $n = it(Lt), lr = ht($n.length), br = xt(Bn, lr);
                    if (kt && sn != sn) {
                      for (; lr > br; )
                        if ((Xn = $n[br++]) != Xn)
                          return true;
                    } else
                      for (; lr > br; br++)
                        if ((kt || br in $n) && $n[br] === sn)
                          return kt || br || 0;
                    return !kt && -1;
                  };
                };
              }, function(Me, Te, Ne) {
                var it = Ne(21), ht = Math.min;
                Me.exports = function(xt) {
                  return xt > 0 ? ht(it(xt), 9007199254740991) : 0;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(21), ht = Math.max, xt = Math.min;
                Me.exports = function(kt, Lt) {
                  return (kt = it(kt)) < 0 ? ht(kt + Lt, 0) : xt(kt, Lt);
                };
              }, function(Me, Te, Ne) {
                var it = Ne(3).document;
                Me.exports = it && it.documentElement;
              }, function(Me, Te, Ne) {
                var it = Ne(5), ht = Ne(18), xt = Ne(25)("IE_PROTO"), kt = Object.prototype;
                Me.exports = Object.getPrototypeOf || function(Lt) {
                  return Lt = ht(Lt), it(Lt, xt) ? Lt[xt] : typeof Lt.constructor == "function" && Lt instanceof Lt.constructor ? Lt.constructor.prototype : Lt instanceof Object ? kt : null;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(63), ht = Ne(64), xt = Ne(12), kt = Ne(9);
                Me.exports = Ne(34)(Array, "Array", function(Lt, sn) {
                  this._t = kt(Lt), this._i = 0, this._k = sn;
                }, function() {
                  var Lt = this._t, sn = this._k, Bn = this._i++;
                  return !Lt || Bn >= Lt.length ? (this._t = void 0, ht(1)) : ht(0, sn == "keys" ? Bn : sn == "values" ? Lt[Bn] : [Bn, Lt[Bn]]);
                }, "values"), xt.Arguments = xt.Array, it("keys"), it("values"), it("entries");
              }, function(Me, Te) {
                Me.exports = function() {
                };
              }, function(Me, Te) {
                Me.exports = function(Ne, it) {
                  return { value: it, done: !!Ne };
                };
              }, function(Me, Te, Ne) {
                Me.exports = { default: Ne(66), __esModule: true };
              }, function(Me, Te, Ne) {
                Ne(67), Ne(73), Ne(74), Ne(75), Me.exports = Ne(1).Symbol;
              }, function(Me, Te, Ne) {
                var it = Ne(3), ht = Ne(5), xt = Ne(4), kt = Ne(15), Lt = Ne(37), sn = Ne(68).KEY, Bn = Ne(8), Xn = Ne(26), $n = Ne(28), lr = Ne(17), br = Ne(2), ki = Ne(30), bi = Ne(31), Oa = Ne(69), Ct = Ne(70), dr = Ne(10), Wr = Ne(11), Ci = Ne(18), _i = Ne(9), Pr = Ne(23), $r = Ne(16), Hi = Ne(38), wa = Ne(71), Mr = Ne(72), No = Ne(32), Po = Ne(7), Mi = Ne(13), Is = Mr.f, Oi = Po.f, ii = wa.f, ai = it.Symbol, Ga = it.JSON, Aa = Ga && Ga.stringify, el = br("_hidden"), Cc = br("toPrimitive"), $u = {}.propertyIsEnumerable, lu = Xn("symbol-registry"), Kf = Xn("symbols"), Xu = Xn("op-symbols"), rf = Object.prototype, Op = typeof ai == "function" && !!No.f, dd = it.QObject, o1 = !dd || !dd.prototype || !dd.prototype.findChild, r_ = xt && Bn(function() {
                  return Hi(Oi({}, "a", { get: function() {
                    return Oi(this, "a", { value: 7 }).a;
                  } })).a != 7;
                }) ? function(Hr, ra, ao) {
                  var ss = Is(rf, ra);
                  ss && delete rf[ra], Oi(Hr, ra, ao), ss && Hr !== rf && Oi(rf, ra, ss);
                } : Oi, nv = function(Hr) {
                  var ra = Kf[Hr] = Hi(ai.prototype);
                  return ra._k = Hr, ra;
                }, Jy = Op && typeof ai.iterator == "symbol" ? function(Hr) {
                  return typeof Hr == "symbol";
                } : function(Hr) {
                  return Hr instanceof ai;
                }, Fx = function(Hr, ra, ao) {
                  return Hr === rf && Fx(Xu, ra, ao), dr(Hr), ra = Pr(ra, true), dr(ao), ht(Kf, ra) ? (ao.enumerable ? (ht(Hr, el) && Hr[el][ra] && (Hr[el][ra] = false), ao = Hi(ao, { enumerable: $r(0, false) })) : (ht(Hr, el) || Oi(Hr, el, $r(1, {})), Hr[el][ra] = true), r_(Hr, ra, ao)) : Oi(Hr, ra, ao);
                }, q0 = function(Hr, ra) {
                  dr(Hr);
                  for (var ao, ss = Oa(ra = _i(ra)), Os = 0, uu = ss.length; uu > Os; )
                    Fx(Hr, ao = ss[Os++], ra[ao]);
                  return Hr;
                }, Zg = function(Hr) {
                  var ra = $u.call(this, Hr = Pr(Hr, true));
                  return !(this === rf && ht(Kf, Hr) && !ht(Xu, Hr)) && (!(ra || !ht(this, Hr) || !ht(Kf, Hr) || ht(this, el) && this[el][Hr]) || ra);
                }, i_ = function(Hr, ra) {
                  if (Hr = _i(Hr), ra = Pr(ra, true), Hr !== rf || !ht(Kf, ra) || ht(Xu, ra)) {
                    var ao = Is(Hr, ra);
                    return !ao || !ht(Kf, ra) || ht(Hr, el) && Hr[el][ra] || (ao.enumerable = true), ao;
                  }
                }, s1 = function(Hr) {
                  for (var ra, ao = ii(_i(Hr)), ss = [], Os = 0; ao.length > Os; )
                    ht(Kf, ra = ao[Os++]) || ra == el || ra == sn || ss.push(ra);
                  return ss;
                }, Xp = function(Hr) {
                  for (var ra, ao = Hr === rf, ss = ii(ao ? Xu : _i(Hr)), Os = [], uu = 0; ss.length > uu; )
                    !ht(Kf, ra = ss[uu++]) || ao && !ht(rf, ra) || Os.push(Kf[ra]);
                  return Os;
                };
                Op || (Lt((ai = function() {
                  if (this instanceof ai)
                    throw TypeError("Symbol is not a constructor!");
                  var Hr = lr(arguments.length > 0 ? arguments[0] : void 0), ra = function(ao) {
                    this === rf && ra.call(Xu, ao), ht(this, el) && ht(this[el], Hr) && (this[el][Hr] = false), r_(this, Hr, $r(1, ao));
                  };
                  return xt && o1 && r_(rf, Hr, { configurable: true, set: ra }), nv(Hr);
                }).prototype, "toString", function() {
                  return this._k;
                }), Mr.f = i_, Po.f = Fx, Ne(41).f = wa.f = s1, Ne(19).f = Zg, No.f = Xp, xt && !Ne(14) && Lt(rf, "propertyIsEnumerable", Zg, true), ki.f = function(Hr) {
                  return nv(br(Hr));
                }), kt(kt.G + kt.W + kt.F * !Op, { Symbol: ai });
                for (var Fd = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Lh = 0; Fd.length > Lh; )
                  br(Fd[Lh++]);
                for (var Ts = Mi(br.store), $i = 0; Ts.length > $i; )
                  bi(Ts[$i++]);
                kt(kt.S + kt.F * !Op, "Symbol", { for: function(Hr) {
                  return ht(lu, Hr += "") ? lu[Hr] : lu[Hr] = ai(Hr);
                }, keyFor: function(Hr) {
                  if (!Jy(Hr))
                    throw TypeError(Hr + " is not a symbol!");
                  for (var ra in lu)
                    if (lu[ra] === Hr)
                      return ra;
                }, useSetter: function() {
                  o1 = true;
                }, useSimple: function() {
                  o1 = false;
                } }), kt(kt.S + kt.F * !Op, "Object", { create: function(Hr, ra) {
                  return ra === void 0 ? Hi(Hr) : q0(Hi(Hr), ra);
                }, defineProperty: Fx, defineProperties: q0, getOwnPropertyDescriptor: i_, getOwnPropertyNames: s1, getOwnPropertySymbols: Xp });
                var Kr = Bn(function() {
                  No.f(1);
                });
                kt(kt.S + kt.F * Kr, "Object", { getOwnPropertySymbols: function(Hr) {
                  return No.f(Ci(Hr));
                } }), Ga && kt(kt.S + kt.F * (!Op || Bn(function() {
                  var Hr = ai();
                  return Aa([Hr]) != "[null]" || Aa({ a: Hr }) != "{}" || Aa(Object(Hr)) != "{}";
                })), "JSON", { stringify: function(Hr) {
                  for (var ra, ao, ss = [Hr], Os = 1; arguments.length > Os; )
                    ss.push(arguments[Os++]);
                  if (ao = ra = ss[1], (Wr(ra) || Hr !== void 0) && !Jy(Hr))
                    return Ct(ra) || (ra = function(uu, bf) {
                      if (typeof ao == "function" && (bf = ao.call(this, uu, bf)), !Jy(bf))
                        return bf;
                    }), ss[1] = ra, Aa.apply(Ga, ss);
                } }), ai.prototype[Cc] || Ne(6)(ai.prototype, Cc, ai.prototype.valueOf), $n(ai, "Symbol"), $n(Math, "Math", true), $n(it.JSON, "JSON", true);
              }, function(Me, Te, Ne) {
                var it = Ne(17)("meta"), ht = Ne(11), xt = Ne(5), kt = Ne(7).f, Lt = 0, sn = Object.isExtensible || function() {
                  return true;
                }, Bn = !Ne(8)(function() {
                  return sn(Object.preventExtensions({}));
                }), Xn = function(lr) {
                  kt(lr, it, { value: { i: "O" + ++Lt, w: {} } });
                }, $n = Me.exports = { KEY: it, NEED: false, fastKey: function(lr, br) {
                  if (!ht(lr))
                    return typeof lr == "symbol" ? lr : (typeof lr == "string" ? "S" : "P") + lr;
                  if (!xt(lr, it)) {
                    if (!sn(lr))
                      return "F";
                    if (!br)
                      return "E";
                    Xn(lr);
                  }
                  return lr[it].i;
                }, getWeak: function(lr, br) {
                  if (!xt(lr, it)) {
                    if (!sn(lr))
                      return true;
                    if (!br)
                      return false;
                    Xn(lr);
                  }
                  return lr[it].w;
                }, onFreeze: function(lr) {
                  return Bn && $n.NEED && sn(lr) && !xt(lr, it) && Xn(lr), lr;
                } };
              }, function(Me, Te, Ne) {
                var it = Ne(13), ht = Ne(32), xt = Ne(19);
                Me.exports = function(kt) {
                  var Lt = it(kt), sn = ht.f;
                  if (sn)
                    for (var Bn, Xn = sn(kt), $n = xt.f, lr = 0; Xn.length > lr; )
                      $n.call(kt, Bn = Xn[lr++]) && Lt.push(Bn);
                  return Lt;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(24);
                Me.exports = Array.isArray || function(ht) {
                  return it(ht) == "Array";
                };
              }, function(Me, Te, Ne) {
                var it = Ne(9), ht = Ne(41).f, xt = {}.toString, kt = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
                Me.exports.f = function(Lt) {
                  return kt && xt.call(Lt) == "[object Window]" ? function(sn) {
                    try {
                      return ht(sn);
                    } catch {
                      return kt.slice();
                    }
                  }(Lt) : ht(it(Lt));
                };
              }, function(Me, Te, Ne) {
                var it = Ne(19), ht = Ne(16), xt = Ne(9), kt = Ne(23), Lt = Ne(5), sn = Ne(35), Bn = Object.getOwnPropertyDescriptor;
                Te.f = Ne(4) ? Bn : function(Xn, $n) {
                  if (Xn = xt(Xn), $n = kt($n, true), sn)
                    try {
                      return Bn(Xn, $n);
                    } catch {
                    }
                  if (Lt(Xn, $n))
                    return ht(!it.f.call(Xn, $n), Xn[$n]);
                };
              }, function(Me, Te) {
              }, function(Me, Te, Ne) {
                Ne(31)("asyncIterator");
              }, function(Me, Te, Ne) {
                Ne(31)("observable");
              }, function(Me, Te, Ne) {
                Te.__esModule = true;
                var it, ht = Ne(77), xt = (it = ht) && it.__esModule ? it : { default: it };
                Te.default = xt.default || function(kt) {
                  for (var Lt = 1; Lt < arguments.length; Lt++) {
                    var sn = arguments[Lt];
                    for (var Bn in sn)
                      Object.prototype.hasOwnProperty.call(sn, Bn) && (kt[Bn] = sn[Bn]);
                  }
                  return kt;
                };
              }, function(Me, Te, Ne) {
                Me.exports = { default: Ne(78), __esModule: true };
              }, function(Me, Te, Ne) {
                Ne(79), Me.exports = Ne(1).Object.assign;
              }, function(Me, Te, Ne) {
                var it = Ne(15);
                it(it.S + it.F, "Object", { assign: Ne(80) });
              }, function(Me, Te, Ne) {
                var it = Ne(4), ht = Ne(13), xt = Ne(32), kt = Ne(19), Lt = Ne(18), sn = Ne(40), Bn = Object.assign;
                Me.exports = !Bn || Ne(8)(function() {
                  var Xn = {}, $n = {}, lr = Symbol(), br = "abcdefghijklmnopqrst";
                  return Xn[lr] = 7, br.split("").forEach(function(ki) {
                    $n[ki] = ki;
                  }), Bn({}, Xn)[lr] != 7 || Object.keys(Bn({}, $n)).join("") != br;
                }) ? function(Xn, $n) {
                  for (var lr = Lt(Xn), br = arguments.length, ki = 1, bi = xt.f, Oa = kt.f; br > ki; )
                    for (var Ct, dr = sn(arguments[ki++]), Wr = bi ? ht(dr).concat(bi(dr)) : ht(dr), Ci = Wr.length, _i = 0; Ci > _i; )
                      Ct = Wr[_i++], it && !Oa.call(dr, Ct) || (lr[Ct] = dr[Ct]);
                  return lr;
                } : Bn;
              }, function(Me, Te, Ne) {
                Te.__esModule = true;
                var it = xt(Ne(82)), ht = xt(Ne(85));
                function xt(kt) {
                  return kt && kt.__esModule ? kt : { default: kt };
                }
                Te.default = function(kt, Lt) {
                  if (Array.isArray(kt))
                    return kt;
                  if ((0, it.default)(Object(kt)))
                    return function(sn, Bn) {
                      var Xn = [], $n = true, lr = false, br = void 0;
                      try {
                        for (var ki, bi = (0, ht.default)(sn); !($n = (ki = bi.next()).done) && (Xn.push(ki.value), !Bn || Xn.length !== Bn); $n = true)
                          ;
                      } catch (Oa) {
                        lr = true, br = Oa;
                      } finally {
                        try {
                          !$n && bi.return && bi.return();
                        } finally {
                          if (lr)
                            throw br;
                        }
                      }
                      return Xn;
                    }(kt, Lt);
                  throw new TypeError("Invalid attempt to destructure non-iterable instance");
                };
              }, function(Me, Te, Ne) {
                Me.exports = { default: Ne(83), __esModule: true };
              }, function(Me, Te, Ne) {
                Ne(29), Ne(20), Me.exports = Ne(84);
              }, function(Me, Te, Ne) {
                var it = Ne(42), ht = Ne(2)("iterator"), xt = Ne(12);
                Me.exports = Ne(1).isIterable = function(kt) {
                  var Lt = Object(kt);
                  return Lt[ht] !== void 0 || "@@iterator" in Lt || xt.hasOwnProperty(it(Lt));
                };
              }, function(Me, Te, Ne) {
                Me.exports = { default: Ne(86), __esModule: true };
              }, function(Me, Te, Ne) {
                Ne(29), Ne(20), Me.exports = Ne(87);
              }, function(Me, Te, Ne) {
                var it = Ne(10), ht = Ne(88);
                Me.exports = Ne(1).getIterator = function(xt) {
                  var kt = ht(xt);
                  if (typeof kt != "function")
                    throw TypeError(xt + " is not iterable!");
                  return it(kt.call(xt));
                };
              }, function(Me, Te, Ne) {
                var it = Ne(42), ht = Ne(2)("iterator"), xt = Ne(12);
                Me.exports = Ne(1).getIteratorMethod = function(kt) {
                  if (kt != null)
                    return kt[ht] || kt["@@iterator"] || xt[it(kt)];
                };
              }, function(Me, Te, Ne) {
                Me.exports = { default: Ne(90), __esModule: true };
              }, function(Me, Te, Ne) {
                Ne(91), Me.exports = Ne(1).Object.keys;
              }, function(Me, Te, Ne) {
                var it = Ne(18), ht = Ne(13);
                Ne(92)("keys", function() {
                  return function(xt) {
                    return ht(it(xt));
                  };
                });
              }, function(Me, Te, Ne) {
                var it = Ne(15), ht = Ne(1), xt = Ne(8);
                Me.exports = function(kt, Lt) {
                  var sn = (ht.Object || {})[kt] || Object[kt], Bn = {};
                  Bn[kt] = Lt(sn), it(it.S + it.F * xt(function() {
                    sn(1);
                  }), "Object", Bn);
                };
              }, function(Me, Te, Ne) {
                (function(it) {
                  var ht = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], xt = /^\s+|\s+$/g, kt = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Lt = /\{\n\/\* \[wrapped with (.+)\] \*/, sn = /,? & /, Bn = /^[-+]0x[0-9a-f]+$/i, Xn = /^0b[01]+$/i, $n = /^\[object .+?Constructor\]$/, lr = /^0o[0-7]+$/i, br = /^(?:0|[1-9]\d*)$/, ki = parseInt, bi = typeof it == "object" && it && it.Object === Object && it, Oa = typeof self == "object" && self && self.Object === Object && self, Ct = bi || Oa || Function("return this")();
                  function dr($i, Kr, Hr) {
                    switch (Hr.length) {
                      case 0:
                        return $i.call(Kr);
                      case 1:
                        return $i.call(Kr, Hr[0]);
                      case 2:
                        return $i.call(Kr, Hr[0], Hr[1]);
                      case 3:
                        return $i.call(Kr, Hr[0], Hr[1], Hr[2]);
                    }
                    return $i.apply(Kr, Hr);
                  }
                  function Wr($i, Kr) {
                    return !!($i && $i.length) && function(Hr, ra, ao) {
                      if (ra != ra)
                        return function(uu, bf, Zh, Rh) {
                          for (var vd = uu.length, Nh = Zh + (Rh ? 1 : -1); Rh ? Nh-- : ++Nh < vd; )
                            if (bf(uu[Nh], Nh, uu))
                              return Nh;
                          return -1;
                        }(Hr, Ci, ao);
                      for (var ss = ao - 1, Os = Hr.length; ++ss < Os; )
                        if (Hr[ss] === ra)
                          return ss;
                      return -1;
                    }($i, Kr, 0) > -1;
                  }
                  function Ci($i) {
                    return $i != $i;
                  }
                  function _i($i, Kr) {
                    for (var Hr = $i.length, ra = 0; Hr--; )
                      $i[Hr] === Kr && ra++;
                    return ra;
                  }
                  function Pr($i, Kr) {
                    for (var Hr = -1, ra = $i.length, ao = 0, ss = []; ++Hr < ra; ) {
                      var Os = $i[Hr];
                      Os !== Kr && Os !== "__lodash_placeholder__" || ($i[Hr] = "__lodash_placeholder__", ss[ao++] = Hr);
                    }
                    return ss;
                  }
                  var $r, Hi, wa, Mr = Function.prototype, No = Object.prototype, Po = Ct["__core-js_shared__"], Mi = ($r = /[^.]+$/.exec(Po && Po.keys && Po.keys.IE_PROTO || "")) ? "Symbol(src)_1." + $r : "", Is = Mr.toString, Oi = No.hasOwnProperty, ii = No.toString, ai = RegExp("^" + Is.call(Oi).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), Ga = Object.create, Aa = Math.max, el = Math.min, Cc = (Hi = nv(Object, "defineProperty"), (wa = nv.name) && wa.length > 2 ? Hi : void 0);
                  function $u($i) {
                    return Fd($i) ? Ga($i) : {};
                  }
                  function lu($i) {
                    return !(!Fd($i) || function(Kr) {
                      return !!Mi && Mi in Kr;
                    }($i)) && (function(Kr) {
                      var Hr = Fd(Kr) ? ii.call(Kr) : "";
                      return Hr == "[object Function]" || Hr == "[object GeneratorFunction]";
                    }($i) || function(Kr) {
                      var Hr = false;
                      if (Kr != null && typeof Kr.toString != "function")
                        try {
                          Hr = !!(Kr + "");
                        } catch {
                        }
                      return Hr;
                    }($i) ? ai : $n).test(function(Kr) {
                      if (Kr != null) {
                        try {
                          return Is.call(Kr);
                        } catch {
                        }
                        try {
                          return Kr + "";
                        } catch {
                        }
                      }
                      return "";
                    }($i));
                  }
                  function Kf($i, Kr, Hr, ra) {
                    for (var ao = -1, ss = $i.length, Os = Hr.length, uu = -1, bf = Kr.length, Zh = Aa(ss - Os, 0), Rh = Array(bf + Zh), vd = !ra; ++uu < bf; )
                      Rh[uu] = Kr[uu];
                    for (; ++ao < Os; )
                      (vd || ao < ss) && (Rh[Hr[ao]] = $i[ao]);
                    for (; Zh--; )
                      Rh[uu++] = $i[ao++];
                    return Rh;
                  }
                  function Xu($i, Kr, Hr, ra) {
                    for (var ao = -1, ss = $i.length, Os = -1, uu = Hr.length, bf = -1, Zh = Kr.length, Rh = Aa(ss - uu, 0), vd = Array(Rh + Zh), Nh = !ra; ++ao < Rh; )
                      vd[ao] = $i[ao];
                    for (var $0 = ao; ++bf < Zh; )
                      vd[$0 + bf] = Kr[bf];
                    for (; ++Os < uu; )
                      (Nh || ao < ss) && (vd[$0 + Hr[Os]] = $i[ao++]);
                    return vd;
                  }
                  function rf($i) {
                    return function() {
                      var Kr = arguments;
                      switch (Kr.length) {
                        case 0:
                          return new $i();
                        case 1:
                          return new $i(Kr[0]);
                        case 2:
                          return new $i(Kr[0], Kr[1]);
                        case 3:
                          return new $i(Kr[0], Kr[1], Kr[2]);
                        case 4:
                          return new $i(Kr[0], Kr[1], Kr[2], Kr[3]);
                        case 5:
                          return new $i(Kr[0], Kr[1], Kr[2], Kr[3], Kr[4]);
                        case 6:
                          return new $i(Kr[0], Kr[1], Kr[2], Kr[3], Kr[4], Kr[5]);
                        case 7:
                          return new $i(Kr[0], Kr[1], Kr[2], Kr[3], Kr[4], Kr[5], Kr[6]);
                      }
                      var Hr = $u($i.prototype), ra = $i.apply(Hr, Kr);
                      return Fd(ra) ? ra : Hr;
                    };
                  }
                  function Op($i, Kr, Hr, ra, ao, ss, Os, uu, bf, Zh) {
                    var Rh = 128 & Kr, vd = 1 & Kr, Nh = 2 & Kr, $0 = 24 & Kr, Qy = 512 & Kr, rv = Nh ? void 0 : rf($i);
                    return function Zf() {
                      for (var Pp = arguments.length, Mc = Array(Pp), Vd = Pp; Vd--; )
                        Mc[Vd] = arguments[Vd];
                      if ($0)
                        var Jg = r_(Zf), a_ = _i(Mc, Jg);
                      if (ra && (Mc = Kf(Mc, ra, ao, $0)), ss && (Mc = Xu(Mc, ss, Os, $0)), Pp -= a_, $0 && Pp < Zh) {
                        var ug = Pr(Mc, Jg);
                        return dd($i, Kr, Op, Zf.placeholder, Hr, Mc, ug, uu, bf, Zh - Pp);
                      }
                      var X0 = vd ? Hr : this, l1 = Nh ? X0[$i] : $i;
                      return Pp = Mc.length, uu ? Mc = Zg(Mc, uu) : Qy && Pp > 1 && Mc.reverse(), Rh && bf < Pp && (Mc.length = bf), this && this !== Ct && this instanceof Zf && (l1 = rv || rf(l1)), l1.apply(X0, Mc);
                    };
                  }
                  function dd($i, Kr, Hr, ra, ao, ss, Os, uu, bf, Zh) {
                    var Rh = 8 & Kr;
                    Kr |= Rh ? 32 : 64, 4 & (Kr &= ~(Rh ? 64 : 32)) || (Kr &= -4);
                    var vd = Hr($i, Kr, ao, Rh ? ss : void 0, Rh ? Os : void 0, Rh ? void 0 : ss, Rh ? void 0 : Os, uu, bf, Zh);
                    return vd.placeholder = ra, i_(vd, $i, Kr);
                  }
                  function o1($i, Kr, Hr, ra, ao, ss, Os, uu) {
                    var bf = 2 & Kr;
                    if (!bf && typeof $i != "function")
                      throw new TypeError("Expected a function");
                    var Zh = ra ? ra.length : 0;
                    if (Zh || (Kr &= -97, ra = ao = void 0), Os = Os === void 0 ? Os : Aa(Ts(Os), 0), uu = uu === void 0 ? uu : Ts(uu), Zh -= ao ? ao.length : 0, 64 & Kr) {
                      var Rh = ra, vd = ao;
                      ra = ao = void 0;
                    }
                    var Nh = [$i, Kr, Hr, ra, ao, Rh, vd, ss, Os, uu];
                    if ($i = Nh[0], Kr = Nh[1], Hr = Nh[2], ra = Nh[3], ao = Nh[4], !(uu = Nh[9] = Nh[9] == null ? bf ? 0 : $i.length : Aa(Nh[9] - Zh, 0)) && 24 & Kr && (Kr &= -25), Kr && Kr != 1)
                      $0 = Kr == 8 || Kr == 16 ? function(Qy, rv, Zf) {
                        var Pp = rf(Qy);
                        return function Mc() {
                          for (var Vd = arguments.length, Jg = Array(Vd), a_ = Vd, ug = r_(Mc); a_--; )
                            Jg[a_] = arguments[a_];
                          var X0 = Vd < 3 && Jg[0] !== ug && Jg[Vd - 1] !== ug ? [] : Pr(Jg, ug);
                          if ((Vd -= X0.length) < Zf)
                            return dd(Qy, rv, Op, Mc.placeholder, void 0, Jg, X0, void 0, void 0, Zf - Vd);
                          var l1 = this && this !== Ct && this instanceof Mc ? Pp : Qy;
                          return dr(l1, this, Jg);
                        };
                      }($i, Kr, uu) : Kr != 32 && Kr != 33 || ao.length ? Op.apply(void 0, Nh) : function(Qy, rv, Zf, Pp) {
                        var Mc = 1 & rv, Vd = rf(Qy);
                        return function Jg() {
                          for (var a_ = -1, ug = arguments.length, X0 = -1, l1 = Pp.length, vA = Array(l1 + ug), KC = this && this !== Ct && this instanceof Jg ? Vd : Qy; ++X0 < l1; )
                            vA[X0] = Pp[X0];
                          for (; ug--; )
                            vA[X0++] = arguments[++a_];
                          return dr(KC, Mc ? Zf : this, vA);
                        };
                      }($i, Kr, Hr, ra);
                    else
                      var $0 = function(Qy, rv, Zf) {
                        var Pp = 1 & rv, Mc = rf(Qy);
                        return function Vd() {
                          var Jg = this && this !== Ct && this instanceof Vd ? Mc : Qy;
                          return Jg.apply(Pp ? Zf : this, arguments);
                        };
                      }($i, Kr, Hr);
                    return i_($0, $i, Kr);
                  }
                  function r_($i) {
                    return $i.placeholder;
                  }
                  function nv($i, Kr) {
                    var Hr = function(ra, ao) {
                      return ra == null ? void 0 : ra[ao];
                    }($i, Kr);
                    return lu(Hr) ? Hr : void 0;
                  }
                  function Jy($i) {
                    var Kr = $i.match(Lt);
                    return Kr ? Kr[1].split(sn) : [];
                  }
                  function Fx($i, Kr) {
                    var Hr = Kr.length, ra = Hr - 1;
                    return Kr[ra] = (Hr > 1 ? "& " : "") + Kr[ra], Kr = Kr.join(Hr > 2 ? ", " : " "), $i.replace(kt, `{
/* [wrapped with ` + Kr + `] */
`);
                  }
                  function q0($i, Kr) {
                    return !!(Kr = Kr == null ? 9007199254740991 : Kr) && (typeof $i == "number" || br.test($i)) && $i > -1 && $i % 1 == 0 && $i < Kr;
                  }
                  function Zg($i, Kr) {
                    for (var Hr = $i.length, ra = el(Kr.length, Hr), ao = function(Os, uu) {
                      var bf = -1, Zh = Os.length;
                      for (uu || (uu = Array(Zh)); ++bf < Zh; )
                        uu[bf] = Os[bf];
                      return uu;
                    }($i); ra--; ) {
                      var ss = Kr[ra];
                      $i[ra] = q0(ss, Hr) ? ao[ss] : void 0;
                    }
                    return $i;
                  }
                  var i_ = Cc ? function($i, Kr, Hr) {
                    var ra, ao = Kr + "";
                    return Cc($i, "toString", { configurable: true, enumerable: false, value: (ra = Fx(ao, s1(Jy(ao), Hr)), function() {
                      return ra;
                    }) });
                  } : function($i) {
                    return $i;
                  };
                  function s1($i, Kr) {
                    return function(Hr, ra) {
                      for (var ao = -1, ss = Hr ? Hr.length : 0; ++ao < ss && ra(Hr[ao], ao, Hr) !== false; )
                        ;
                    }(ht, function(Hr) {
                      var ra = "_." + Hr[0];
                      Kr & Hr[1] && !Wr($i, ra) && $i.push(ra);
                    }), $i.sort();
                  }
                  function Xp($i, Kr, Hr) {
                    var ra = o1($i, 8, void 0, void 0, void 0, void 0, void 0, Kr = Hr ? void 0 : Kr);
                    return ra.placeholder = Xp.placeholder, ra;
                  }
                  function Fd($i) {
                    var Kr = typeof $i;
                    return !!$i && (Kr == "object" || Kr == "function");
                  }
                  function Lh($i) {
                    return $i ? ($i = function(Kr) {
                      if (typeof Kr == "number")
                        return Kr;
                      if (function(ao) {
                        return typeof ao == "symbol" || function(ss) {
                          return !!ss && typeof ss == "object";
                        }(ao) && ii.call(ao) == "[object Symbol]";
                      }(Kr))
                        return NaN;
                      if (Fd(Kr)) {
                        var Hr = typeof Kr.valueOf == "function" ? Kr.valueOf() : Kr;
                        Kr = Fd(Hr) ? Hr + "" : Hr;
                      }
                      if (typeof Kr != "string")
                        return Kr === 0 ? Kr : +Kr;
                      Kr = Kr.replace(xt, "");
                      var ra = Xn.test(Kr);
                      return ra || lr.test(Kr) ? ki(Kr.slice(2), ra ? 2 : 8) : Bn.test(Kr) ? NaN : +Kr;
                    }($i)) === 1 / 0 || $i === -1 / 0 ? 17976931348623157e292 * ($i < 0 ? -1 : 1) : $i == $i ? $i : 0 : $i === 0 ? $i : 0;
                  }
                  function Ts($i) {
                    var Kr = Lh($i), Hr = Kr % 1;
                    return Kr == Kr ? Hr ? Kr - Hr : Kr : 0;
                  }
                  Xp.placeholder = {}, Me.exports = Xp;
                }).call(this, Ne(43));
              }, function(Me, Te, Ne) {
                function it(Xu) {
                  return Xu && Xu.__esModule ? Xu.default : Xu;
                }
                Te.__esModule = true;
                var ht = Ne(95);
                Te.threezerotwofour = it(ht);
                var xt = Ne(96);
                Te.apathy = it(xt);
                var kt = Ne(97);
                Te.ashes = it(kt);
                var Lt = Ne(98);
                Te.atelierDune = it(Lt);
                var sn = Ne(99);
                Te.atelierForest = it(sn);
                var Bn = Ne(100);
                Te.atelierHeath = it(Bn);
                var Xn = Ne(101);
                Te.atelierLakeside = it(Xn);
                var $n = Ne(102);
                Te.atelierSeaside = it($n);
                var lr = Ne(103);
                Te.bespin = it(lr);
                var br = Ne(104);
                Te.brewer = it(br);
                var ki = Ne(105);
                Te.bright = it(ki);
                var bi = Ne(106);
                Te.chalk = it(bi);
                var Oa = Ne(107);
                Te.codeschool = it(Oa);
                var Ct = Ne(108);
                Te.colors = it(Ct);
                var dr = Ne(109);
                Te.default = it(dr);
                var Wr = Ne(110);
                Te.eighties = it(Wr);
                var Ci = Ne(111);
                Te.embers = it(Ci);
                var _i = Ne(112);
                Te.flat = it(_i);
                var Pr = Ne(113);
                Te.google = it(Pr);
                var $r = Ne(114);
                Te.grayscale = it($r);
                var Hi = Ne(115);
                Te.greenscreen = it(Hi);
                var wa = Ne(116);
                Te.harmonic = it(wa);
                var Mr = Ne(117);
                Te.hopscotch = it(Mr);
                var No = Ne(118);
                Te.isotope = it(No);
                var Po = Ne(119);
                Te.marrakesh = it(Po);
                var Mi = Ne(120);
                Te.mocha = it(Mi);
                var Is = Ne(121);
                Te.monokai = it(Is);
                var Oi = Ne(122);
                Te.ocean = it(Oi);
                var ii = Ne(123);
                Te.paraiso = it(ii);
                var ai = Ne(124);
                Te.pop = it(ai);
                var Ga = Ne(125);
                Te.railscasts = it(Ga);
                var Aa = Ne(126);
                Te.shapeshifter = it(Aa);
                var el = Ne(127);
                Te.solarized = it(el);
                var Cc = Ne(128);
                Te.summerfruit = it(Cc);
                var $u = Ne(129);
                Te.tomorrow = it($u);
                var lu = Ne(130);
                Te.tube = it(lu);
                var Kf = Ne(131);
                Te.twilight = it(Kf);
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                Te.__esModule = true, Te.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, Me.exports = Te.default;
              }, function(Me, Te, Ne) {
                var it = Ne(33);
                function ht(xt) {
                  var kt = Math.round(it(xt, 0, 255)).toString(16);
                  return kt.length == 1 ? "0" + kt : kt;
                }
                Me.exports = function(xt) {
                  var kt = xt.length === 4 ? ht(255 * xt[3]) : "";
                  return "#" + ht(xt[0]) + ht(xt[1]) + ht(xt[2]) + kt;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(134), ht = Ne(135), xt = Ne(136), kt = Ne(137), Lt = { "#": ht, hsl: function(Bn) {
                  var Xn = it(Bn), $n = kt(Xn);
                  return Xn.length === 4 && $n.push(Xn[3]), $n;
                }, rgb: xt };
                function sn(Bn) {
                  for (var Xn in Lt)
                    if (Bn.indexOf(Xn) === 0)
                      return Lt[Xn](Bn);
                }
                sn.rgb = xt, sn.hsl = it, sn.hex = ht, Me.exports = sn;
              }, function(Me, Te, Ne) {
                var it = Ne(44), ht = Ne(33);
                function xt(kt, Lt) {
                  switch (kt = parseFloat(kt), Lt) {
                    case 0:
                      return ht(kt, 0, 360);
                    case 1:
                    case 2:
                      return ht(kt, 0, 100);
                    case 3:
                      return ht(kt, 0, 1);
                  }
                }
                Me.exports = function(kt) {
                  return it(kt).map(xt);
                };
              }, function(Me, Te) {
                Me.exports = function(Ne) {
                  Ne.length !== 4 && Ne.length !== 5 || (Ne = function(xt) {
                    for (var kt = "#", Lt = 1; Lt < xt.length; Lt++) {
                      var sn = xt.charAt(Lt);
                      kt += sn + sn;
                    }
                    return kt;
                  }(Ne));
                  var it = [parseInt(Ne.substring(1, 3), 16), parseInt(Ne.substring(3, 5), 16), parseInt(Ne.substring(5, 7), 16)];
                  if (Ne.length === 9) {
                    var ht = parseFloat((parseInt(Ne.substring(7, 9), 16) / 255).toFixed(2));
                    it.push(ht);
                  }
                  return it;
                };
              }, function(Me, Te, Ne) {
                var it = Ne(44), ht = Ne(33);
                function xt(kt, Lt) {
                  return Lt < 3 ? kt.indexOf("%") != -1 ? Math.round(255 * ht(parseInt(kt, 10), 0, 100) / 100) : ht(parseInt(kt, 10), 0, 255) : ht(parseFloat(kt), 0, 1);
                }
                Me.exports = function(kt) {
                  return it(kt).map(xt);
                };
              }, function(Me, Te) {
                Me.exports = function(Ne) {
                  var it, ht, xt, kt, Lt, sn = Ne[0] / 360, Bn = Ne[1] / 100, Xn = Ne[2] / 100;
                  if (Bn == 0)
                    return [Lt = 255 * Xn, Lt, Lt];
                  it = 2 * Xn - (ht = Xn < 0.5 ? Xn * (1 + Bn) : Xn + Bn - Xn * Bn), kt = [0, 0, 0];
                  for (var $n = 0; $n < 3; $n++)
                    (xt = sn + 1 / 3 * -($n - 1)) < 0 && xt++, xt > 1 && xt--, Lt = 6 * xt < 1 ? it + 6 * (ht - it) * xt : 2 * xt < 1 ? ht : 3 * xt < 2 ? it + (ht - it) * (2 / 3 - xt) * 6 : it, kt[$n] = 255 * Lt;
                  return kt;
                };
              }, function(Me, Te, Ne) {
                (function(it) {
                  var ht = typeof it == "object" && it && it.Object === Object && it, xt = typeof self == "object" && self && self.Object === Object && self, kt = ht || xt || Function("return this")();
                  function Lt(Pr, $r, Hi) {
                    switch (Hi.length) {
                      case 0:
                        return Pr.call($r);
                      case 1:
                        return Pr.call($r, Hi[0]);
                      case 2:
                        return Pr.call($r, Hi[0], Hi[1]);
                      case 3:
                        return Pr.call($r, Hi[0], Hi[1], Hi[2]);
                    }
                    return Pr.apply($r, Hi);
                  }
                  function sn(Pr, $r) {
                    for (var Hi = -1, wa = $r.length, Mr = Pr.length; ++Hi < wa; )
                      Pr[Mr + Hi] = $r[Hi];
                    return Pr;
                  }
                  var Bn = Object.prototype, Xn = Bn.hasOwnProperty, $n = Bn.toString, lr = kt.Symbol, br = Bn.propertyIsEnumerable, ki = lr ? lr.isConcatSpreadable : void 0, bi = Math.max;
                  function Oa(Pr) {
                    return Ct(Pr) || function($r) {
                      return function(Hi) {
                        return function(wa) {
                          return !!wa && typeof wa == "object";
                        }(Hi) && function(wa) {
                          return wa != null && function(Mr) {
                            return typeof Mr == "number" && Mr > -1 && Mr % 1 == 0 && Mr <= 9007199254740991;
                          }(wa.length) && !function(Mr) {
                            var No = function(Po) {
                              var Mi = typeof Po;
                              return !!Po && (Mi == "object" || Mi == "function");
                            }(Mr) ? $n.call(Mr) : "";
                            return No == "[object Function]" || No == "[object GeneratorFunction]";
                          }(wa);
                        }(Hi);
                      }($r) && Xn.call($r, "callee") && (!br.call($r, "callee") || $n.call($r) == "[object Arguments]");
                    }(Pr) || !!(ki && Pr && Pr[ki]);
                  }
                  var Ct = Array.isArray, dr, Wr, Ci, _i = (Wr = function(Pr) {
                    var $r = (Pr = function wa(Mr, No, Po, Mi, Is) {
                      var Oi = -1, ii = Mr.length;
                      for (Po || (Po = Oa), Is || (Is = []); ++Oi < ii; ) {
                        var ai = Mr[Oi];
                        No > 0 && Po(ai) ? No > 1 ? wa(ai, No - 1, Po, Mi, Is) : sn(Is, ai) : Mi || (Is[Is.length] = ai);
                      }
                      return Is;
                    }(Pr, 1)).length, Hi = $r;
                    for (dr; Hi--; )
                      if (typeof Pr[Hi] != "function")
                        throw new TypeError("Expected a function");
                    return function() {
                      for (var wa = 0, Mr = $r ? Pr[wa].apply(this, arguments) : arguments[0]; ++wa < $r; )
                        Mr = Pr[wa].call(this, Mr);
                      return Mr;
                    };
                  }, Ci = bi(Ci === void 0 ? Wr.length - 1 : Ci, 0), function() {
                    for (var Pr = arguments, $r = -1, Hi = bi(Pr.length - Ci, 0), wa = Array(Hi); ++$r < Hi; )
                      wa[$r] = Pr[Ci + $r];
                    $r = -1;
                    for (var Mr = Array(Ci + 1); ++$r < Ci; )
                      Mr[$r] = Pr[$r];
                    return Mr[Ci] = wa, Lt(Wr, this, Mr);
                  });
                  Me.exports = _i;
                }).call(this, Ne(43));
              }, function(Me, Te, Ne) {
                Object.defineProperty(Te, "__esModule", { value: true }), Te.yuv2rgb = function(it) {
                  var ht, xt, kt, Lt = it[0], sn = it[1], Bn = it[2];
                  return ht = 1 * Lt + 0 * sn + 1.13983 * Bn, xt = 1 * Lt + -0.39465 * sn + -0.5806 * Bn, kt = 1 * Lt + 2.02311 * sn + 0 * Bn, ht = Math.min(Math.max(0, ht), 1), xt = Math.min(Math.max(0, xt), 1), kt = Math.min(Math.max(0, kt), 1), [255 * ht, 255 * xt, 255 * kt];
                }, Te.rgb2yuv = function(it) {
                  var ht = it[0] / 255, xt = it[1] / 255, kt = it[2] / 255;
                  return [0.299 * ht + 0.587 * xt + 0.114 * kt, -0.14713 * ht + -0.28886 * xt + 0.436 * kt, 0.615 * ht + -0.51499 * xt + -0.10001 * kt];
                };
              }, function(Me, Te, Ne) {
                function it(kt, Lt, sn) {
                  return Lt in kt ? Object.defineProperty(kt, Lt, { value: sn, enumerable: true, configurable: true, writable: true }) : kt[Lt] = sn, kt;
                }
                var ht = Ne(141), xt = function() {
                  function kt() {
                    it(this, "_callbacks", void 0), it(this, "_isDispatching", void 0), it(this, "_isHandled", void 0), it(this, "_isPending", void 0), it(this, "_lastID", void 0), it(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
                  }
                  var Lt = kt.prototype;
                  return Lt.register = function(sn) {
                    var Bn = "ID_" + this._lastID++;
                    return this._callbacks[Bn] = sn, Bn;
                  }, Lt.unregister = function(sn) {
                    this._callbacks[sn] || ht(false), delete this._callbacks[sn];
                  }, Lt.waitFor = function(sn) {
                    this._isDispatching || ht(false);
                    for (var Bn = 0; Bn < sn.length; Bn++) {
                      var Xn = sn[Bn];
                      this._isPending[Xn] ? this._isHandled[Xn] || ht(false) : (this._callbacks[Xn] || ht(false), this._invokeCallback(Xn));
                    }
                  }, Lt.dispatch = function(sn) {
                    this._isDispatching && ht(false), this._startDispatching(sn);
                    try {
                      for (var Bn in this._callbacks)
                        this._isPending[Bn] || this._invokeCallback(Bn);
                    } finally {
                      this._stopDispatching();
                    }
                  }, Lt.isDispatching = function() {
                    return this._isDispatching;
                  }, Lt._invokeCallback = function(sn) {
                    this._isPending[sn] = true, this._callbacks[sn](this._pendingPayload), this._isHandled[sn] = true;
                  }, Lt._startDispatching = function(sn) {
                    for (var Bn in this._callbacks)
                      this._isPending[Bn] = false, this._isHandled[Bn] = false;
                    this._pendingPayload = sn, this._isDispatching = true;
                  }, Lt._stopDispatching = function() {
                    delete this._pendingPayload, this._isDispatching = false;
                  }, kt;
                }();
                Me.exports = xt;
              }, function(Me, Te, Ne) {
                Me.exports = function(it, ht) {
                  for (var xt = arguments.length, kt = new Array(xt > 2 ? xt - 2 : 0), Lt = 2; Lt < xt; Lt++)
                    kt[Lt - 2] = arguments[Lt];
                  if (!it) {
                    var sn;
                    if (ht === void 0)
                      sn = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                    else {
                      var Bn = 0;
                      (sn = new Error(ht.replace(/%s/g, function() {
                        return String(kt[Bn++]);
                      }))).name = "Invariant Violation";
                    }
                    throw sn.framesToPop = 1, sn;
                  }
                };
              }, function(Me, Te, Ne) {
                function it(Tn, Ln, Xt) {
                  return Ln in Tn ? Object.defineProperty(Tn, Ln, { value: Xt, enumerable: true, configurable: true, writable: true }) : Tn[Ln] = Xt, Tn;
                }
                function ht(Tn, Ln) {
                  var Xt = Object.keys(Tn);
                  if (Object.getOwnPropertySymbols) {
                    var mn = Object.getOwnPropertySymbols(Tn);
                    Ln && (mn = mn.filter(function(Sn) {
                      return Object.getOwnPropertyDescriptor(Tn, Sn).enumerable;
                    })), Xt.push.apply(Xt, mn);
                  }
                  return Xt;
                }
                function xt(Tn) {
                  for (var Ln = 1; Ln < arguments.length; Ln++) {
                    var Xt = arguments[Ln] != null ? arguments[Ln] : {};
                    Ln % 2 ? ht(Object(Xt), true).forEach(function(mn) {
                      it(Tn, mn, Xt[mn]);
                    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(Tn, Object.getOwnPropertyDescriptors(Xt)) : ht(Object(Xt)).forEach(function(mn) {
                      Object.defineProperty(Tn, mn, Object.getOwnPropertyDescriptor(Xt, mn));
                    });
                  }
                  return Tn;
                }
                function kt(Tn, Ln) {
                  if (!(Tn instanceof Ln))
                    throw new TypeError("Cannot call a class as a function");
                }
                function Lt(Tn, Ln) {
                  for (var Xt = 0; Xt < Ln.length; Xt++) {
                    var mn = Ln[Xt];
                    mn.enumerable = mn.enumerable || false, mn.configurable = true, "value" in mn && (mn.writable = true), Object.defineProperty(Tn, mn.key, mn);
                  }
                }
                function sn(Tn, Ln, Xt) {
                  return Ln && Lt(Tn.prototype, Ln), Xt && Lt(Tn, Xt), Tn;
                }
                function Bn(Tn, Ln) {
                  return (Bn = Object.setPrototypeOf || function(Xt, mn) {
                    return Xt.__proto__ = mn, Xt;
                  })(Tn, Ln);
                }
                function Xn(Tn, Ln) {
                  if (typeof Ln != "function" && Ln !== null)
                    throw new TypeError("Super expression must either be null or a function");
                  Tn.prototype = Object.create(Ln && Ln.prototype, { constructor: { value: Tn, writable: true, configurable: true } }), Ln && Bn(Tn, Ln);
                }
                function $n(Tn) {
                  return ($n = Object.setPrototypeOf ? Object.getPrototypeOf : function(Ln) {
                    return Ln.__proto__ || Object.getPrototypeOf(Ln);
                  })(Tn);
                }
                function lr(Tn) {
                  return (lr = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Ln) {
                    return typeof Ln;
                  } : function(Ln) {
                    return Ln && typeof Symbol == "function" && Ln.constructor === Symbol && Ln !== Symbol.prototype ? "symbol" : typeof Ln;
                  })(Tn);
                }
                function br(Tn) {
                  if (Tn === void 0)
                    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                  return Tn;
                }
                function ki(Tn, Ln) {
                  return !Ln || lr(Ln) !== "object" && typeof Ln != "function" ? br(Tn) : Ln;
                }
                function bi(Tn) {
                  var Ln = function() {
                    if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                      return false;
                    if (typeof Proxy == "function")
                      return true;
                    try {
                      return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                      })), true;
                    } catch {
                      return false;
                    }
                  }();
                  return function() {
                    var Xt, mn = $n(Tn);
                    if (Ln) {
                      var Sn = $n(this).constructor;
                      Xt = Reflect.construct(mn, arguments, Sn);
                    } else
                      Xt = mn.apply(this, arguments);
                    return ki(this, Xt);
                  };
                }
                Ne.r(Te);
                var Oa = Ne(0), Ct = Ne.n(Oa);
                function dr() {
                  var Tn = this.constructor.getDerivedStateFromProps(this.props, this.state);
                  Tn != null && this.setState(Tn);
                }
                function Wr(Tn) {
                  this.setState(function(Ln) {
                    var Xt = this.constructor.getDerivedStateFromProps(Tn, Ln);
                    return Xt != null ? Xt : null;
                  }.bind(this));
                }
                function Ci(Tn, Ln) {
                  try {
                    var Xt = this.props, mn = this.state;
                    this.props = Tn, this.state = Ln, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Xt, mn);
                  } finally {
                    this.props = Xt, this.state = mn;
                  }
                }
                function _i(Tn) {
                  var Ln = Tn.prototype;
                  if (!Ln || !Ln.isReactComponent)
                    throw new Error("Can only polyfill class components");
                  if (typeof Tn.getDerivedStateFromProps != "function" && typeof Ln.getSnapshotBeforeUpdate != "function")
                    return Tn;
                  var Xt = null, mn = null, Sn = null;
                  if (typeof Ln.componentWillMount == "function" ? Xt = "componentWillMount" : typeof Ln.UNSAFE_componentWillMount == "function" && (Xt = "UNSAFE_componentWillMount"), typeof Ln.componentWillReceiveProps == "function" ? mn = "componentWillReceiveProps" : typeof Ln.UNSAFE_componentWillReceiveProps == "function" && (mn = "UNSAFE_componentWillReceiveProps"), typeof Ln.componentWillUpdate == "function" ? Sn = "componentWillUpdate" : typeof Ln.UNSAFE_componentWillUpdate == "function" && (Sn = "UNSAFE_componentWillUpdate"), Xt !== null || mn !== null || Sn !== null) {
                    var zr = Tn.displayName || Tn.name, Ai = typeof Tn.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                    throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + zr + " uses " + Ai + " but also contains the following legacy lifecycles:" + (Xt !== null ? `
  ` + Xt : "") + (mn !== null ? `
  ` + mn : "") + (Sn !== null ? `
  ` + Sn : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
                  }
                  if (typeof Tn.getDerivedStateFromProps == "function" && (Ln.componentWillMount = dr, Ln.componentWillReceiveProps = Wr), typeof Ln.getSnapshotBeforeUpdate == "function") {
                    if (typeof Ln.componentDidUpdate != "function")
                      throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                    Ln.componentWillUpdate = Ci;
                    var ci = Ln.componentDidUpdate;
                    Ln.componentDidUpdate = function(kr, Ca, ps) {
                      var Pu = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : ps;
                      ci.call(this, kr, Ca, Pu);
                    };
                  }
                  return Tn;
                }
                function Pr(Tn, Ln) {
                  if (Tn == null)
                    return {};
                  var Xt, mn, Sn = function(Ai, ci) {
                    if (Ai == null)
                      return {};
                    var kr, Ca, ps = {}, Pu = Object.keys(Ai);
                    for (Ca = 0; Ca < Pu.length; Ca++)
                      kr = Pu[Ca], ci.indexOf(kr) >= 0 || (ps[kr] = Ai[kr]);
                    return ps;
                  }(Tn, Ln);
                  if (Object.getOwnPropertySymbols) {
                    var zr = Object.getOwnPropertySymbols(Tn);
                    for (mn = 0; mn < zr.length; mn++)
                      Xt = zr[mn], Ln.indexOf(Xt) >= 0 || Object.prototype.propertyIsEnumerable.call(Tn, Xt) && (Sn[Xt] = Tn[Xt]);
                  }
                  return Sn;
                }
                function $r(Tn) {
                  var Ln = function(Xt) {
                    return {}.toString.call(Xt).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                  }(Tn);
                  return Ln === "number" && (Ln = isNaN(Tn) ? "nan" : (0 | Tn) != Tn ? "float" : "integer"), Ln;
                }
                dr.__suppressDeprecationWarning = true, Wr.__suppressDeprecationWarning = true, Ci.__suppressDeprecationWarning = true;
                var Hi = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, wa = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, Mr = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, No = Ne(45), Po = function(Tn) {
                  var Ln = function(Xt) {
                    return { backgroundColor: Xt.base00, ellipsisColor: Xt.base09, braceColor: Xt.base07, expandedIcon: Xt.base0D, collapsedIcon: Xt.base0E, keyColor: Xt.base07, arrayKeyColor: Xt.base0C, objectSize: Xt.base04, copyToClipboard: Xt.base0F, copyToClipboardCheck: Xt.base0D, objectBorder: Xt.base02, dataTypes: { boolean: Xt.base0E, date: Xt.base0D, float: Xt.base0B, function: Xt.base0D, integer: Xt.base0F, string: Xt.base09, nan: Xt.base08, null: Xt.base0A, undefined: Xt.base05, regexp: Xt.base0A, background: Xt.base02 }, editVariable: { editIcon: Xt.base0E, cancelIcon: Xt.base09, removeIcon: Xt.base09, addIcon: Xt.base0E, checkIcon: Xt.base0E, background: Xt.base01, color: Xt.base0A, border: Xt.base07 }, addKeyModal: { background: Xt.base05, border: Xt.base04, color: Xt.base0A, labelColor: Xt.base01 }, validationFailure: { background: Xt.base09, iconColor: Xt.base01, fontColor: Xt.base01 } };
                  }(Tn);
                  return { "app-container": { fontFamily: Mr.globalFontFamily, cursor: Mr.globalCursor, backgroundColor: Ln.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Ln.ellipsisColor, fontSize: Mr.ellipsisFontSize, lineHeight: Mr.ellipsisLineHeight, cursor: Mr.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: Mr.braceCursor, fontWeight: Mr.braceFontWeight, color: Ln.braceColor }, "expanded-icon": { color: Ln.expandedIcon }, "collapsed-icon": { color: Ln.collapsedIcon }, colon: { display: "inline-block", margin: Mr.keyMargin, color: Ln.keyColor, verticalAlign: "top" }, objectKeyVal: function(Xt, mn) {
                    return { style: xt({ paddingTop: Mr.keyValPaddingTop, paddingRight: Mr.keyValPaddingRight, paddingBottom: Mr.keyValPaddingBottom, borderLeft: Mr.keyValBorderLeft + " " + Ln.objectBorder, ":hover": { paddingLeft: mn.paddingLeft - 1 + "px", borderLeft: Mr.keyValBorderHover + " " + Ln.objectBorder } }, mn) };
                  }, "object-key-val-no-border": { padding: Mr.keyValPadding }, "pushed-content": { marginLeft: Mr.pushedContentMarginLeft }, variableValue: function(Xt, mn) {
                    return { style: xt({ display: "inline-block", paddingRight: Mr.variableValuePaddingRight, position: "relative" }, mn) };
                  }, "object-name": { display: "inline-block", color: Ln.keyColor, letterSpacing: Mr.keyLetterSpacing, fontStyle: Mr.keyFontStyle, verticalAlign: Mr.keyVerticalAlign, opacity: Mr.keyOpacity, ":hover": { opacity: Mr.keyOpacityHover } }, "array-key": { display: "inline-block", color: Ln.arrayKeyColor, letterSpacing: Mr.keyLetterSpacing, fontStyle: Mr.keyFontStyle, verticalAlign: Mr.keyVerticalAlign, opacity: Mr.keyOpacity, ":hover": { opacity: Mr.keyOpacityHover } }, "object-size": { color: Ln.objectSize, borderRadius: Mr.objectSizeBorderRadius, fontStyle: Mr.objectSizeFontStyle, margin: Mr.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: Mr.dataTypeFontSize, marginRight: Mr.dataTypeMarginRight, opacity: Mr.datatypeOpacity }, boolean: { display: "inline-block", color: Ln.dataTypes.boolean }, date: { display: "inline-block", color: Ln.dataTypes.date }, "date-value": { marginLeft: Mr.dateValueMarginLeft }, float: { display: "inline-block", color: Ln.dataTypes.float }, function: { display: "inline-block", color: Ln.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Ln.dataTypes.integer }, string: { display: "inline-block", color: Ln.dataTypes.string }, nan: { display: "inline-block", color: Ln.dataTypes.nan, fontSize: Mr.nanFontSize, fontWeight: Mr.nanFontWeight, backgroundColor: Ln.dataTypes.background, padding: Mr.nanPadding, borderRadius: Mr.nanBorderRadius }, null: { display: "inline-block", color: Ln.dataTypes.null, fontSize: Mr.nullFontSize, fontWeight: Mr.nullFontWeight, backgroundColor: Ln.dataTypes.background, padding: Mr.nullPadding, borderRadius: Mr.nullBorderRadius }, undefined: { display: "inline-block", color: Ln.dataTypes.undefined, fontSize: Mr.undefinedFontSize, padding: Mr.undefinedPadding, borderRadius: Mr.undefinedBorderRadius, backgroundColor: Ln.dataTypes.background }, regexp: { display: "inline-block", color: Ln.dataTypes.regexp }, "copy-to-clipboard": { cursor: Mr.clipboardCursor }, "copy-icon": { color: Ln.copyToClipboard, fontSize: Mr.iconFontSize, marginRight: Mr.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Ln.copyToClipboardCheck, marginLeft: Mr.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: Mr.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: Mr.metaDataPadding }, "icon-container": { display: "inline-block", width: Mr.iconContainerWidth }, tooltip: { padding: Mr.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Ln.editVariable.removeIcon, cursor: Mr.iconCursor, fontSize: Mr.iconFontSize, marginRight: Mr.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Ln.editVariable.addIcon, cursor: Mr.iconCursor, fontSize: Mr.iconFontSize, marginRight: Mr.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Ln.editVariable.editIcon, cursor: Mr.iconCursor, fontSize: Mr.iconFontSize, marginRight: Mr.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: Mr.iconCursor, color: Ln.editVariable.checkIcon, fontSize: Mr.iconFontSize, paddingRight: Mr.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: Mr.iconCursor, color: Ln.editVariable.cancelIcon, fontSize: Mr.iconFontSize, paddingRight: Mr.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: Mr.editInputMinWidth, borderRadius: Mr.editInputBorderRadius, backgroundColor: Ln.editVariable.background, color: Ln.editVariable.color, padding: Mr.editInputPadding, marginRight: Mr.editInputMarginRight, fontFamily: Mr.editInputFontFamily }, "detected-row": { paddingTop: Mr.detectedRowPaddingTop }, "key-modal-request": { position: Mr.addKeyCoverPosition, top: Mr.addKeyCoverPositionPx, left: Mr.addKeyCoverPositionPx, right: Mr.addKeyCoverPositionPx, bottom: Mr.addKeyCoverPositionPx, backgroundColor: Mr.addKeyCoverBackground }, "key-modal": { width: Mr.addKeyModalWidth, backgroundColor: Ln.addKeyModal.background, marginLeft: Mr.addKeyModalMargin, marginRight: Mr.addKeyModalMargin, padding: Mr.addKeyModalPadding, borderRadius: Mr.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Ln.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Ln.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Ln.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Ln.addKeyModal.labelColor, fontSize: Mr.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Ln.editVariable.addIcon, fontSize: Mr.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Ln.ellipsisColor, fontSize: Mr.ellipsisFontSize, lineHeight: Mr.ellipsisLineHeight, cursor: Mr.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Ln.validationFailure.fontColor, backgroundColor: Ln.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Ln.validationFailure.iconColor, fontSize: Mr.iconFontSize, transform: "rotate(45deg)" } };
                };
                function Mi(Tn, Ln, Xt) {
                  return Tn || console.error("theme has not been set"), function(mn) {
                    var Sn = Hi;
                    return mn !== false && mn !== "none" || (Sn = wa), Object(No.createStyling)(Po, { defaultBase16: Sn })(mn);
                  }(Tn)(Ln, Xt);
                }
                var Is = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = (mn.rjvId, mn.type_name), zr = mn.displayDataTypes, Ai = mn.theme;
                    return zr ? Ct.a.createElement("span", Object.assign({ className: "data-type-label" }, Mi(Ai, "data-type-label")), Sn) : null;
                  } }]), Xt;
                }(Ct.a.PureComponent), Oi = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props;
                    return Ct.a.createElement("div", Mi(mn.theme, "boolean"), Ct.a.createElement(Is, Object.assign({ type_name: "bool" }, mn)), mn.value ? "true" : "false");
                  } }]), Xt;
                }(Ct.a.PureComponent), ii = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props;
                    return Ct.a.createElement("div", Mi(mn.theme, "date"), Ct.a.createElement(Is, Object.assign({ type_name: "date" }, mn)), Ct.a.createElement("span", Object.assign({ className: "date-value" }, Mi(mn.theme, "date-value")), mn.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), ai = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props;
                    return Ct.a.createElement("div", Mi(mn.theme, "float"), Ct.a.createElement(Is, Object.assign({ type_name: "float" }, mn)), this.props.value);
                  } }]), Xt;
                }(Ct.a.PureComponent);
                function Ga(Tn, Ln) {
                  (Ln == null || Ln > Tn.length) && (Ln = Tn.length);
                  for (var Xt = 0, mn = new Array(Ln); Xt < Ln; Xt++)
                    mn[Xt] = Tn[Xt];
                  return mn;
                }
                function Aa(Tn, Ln) {
                  if (Tn) {
                    if (typeof Tn == "string")
                      return Ga(Tn, Ln);
                    var Xt = Object.prototype.toString.call(Tn).slice(8, -1);
                    return Xt === "Object" && Tn.constructor && (Xt = Tn.constructor.name), Xt === "Map" || Xt === "Set" ? Array.from(Tn) : Xt === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Xt) ? Ga(Tn, Ln) : void 0;
                  }
                }
                function el(Tn, Ln) {
                  var Xt;
                  if (typeof Symbol == "undefined" || Tn[Symbol.iterator] == null) {
                    if (Array.isArray(Tn) || (Xt = Aa(Tn)) || Ln && Tn && typeof Tn.length == "number") {
                      Xt && (Tn = Xt);
                      var mn = 0, Sn = function() {
                      };
                      return { s: Sn, n: function() {
                        return mn >= Tn.length ? { done: true } : { done: false, value: Tn[mn++] };
                      }, e: function(kr) {
                        throw kr;
                      }, f: Sn };
                    }
                    throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                  }
                  var zr, Ai = true, ci = false;
                  return { s: function() {
                    Xt = Tn[Symbol.iterator]();
                  }, n: function() {
                    var kr = Xt.next();
                    return Ai = kr.done, kr;
                  }, e: function(kr) {
                    ci = true, zr = kr;
                  }, f: function() {
                    try {
                      Ai || Xt.return == null || Xt.return();
                    } finally {
                      if (ci)
                        throw zr;
                    }
                  } };
                }
                function Cc(Tn) {
                  return function(Ln) {
                    if (Array.isArray(Ln))
                      return Ga(Ln);
                  }(Tn) || function(Ln) {
                    if (typeof Symbol != "undefined" && Symbol.iterator in Object(Ln))
                      return Array.from(Ln);
                  }(Tn) || Aa(Tn) || function() {
                    throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                  }();
                }
                var $u = Ne(46), lu = new (Ne(47)).Dispatcher(), Kf = new (function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    var mn;
                    kt(this, Xt);
                    for (var Sn = arguments.length, zr = new Array(Sn), Ai = 0; Ai < Sn; Ai++)
                      zr[Ai] = arguments[Ai];
                    return (mn = Ln.call.apply(Ln, [this].concat(zr))).objects = {}, mn.set = function(ci, kr, Ca, ps) {
                      mn.objects[ci] === void 0 && (mn.objects[ci] = {}), mn.objects[ci][kr] === void 0 && (mn.objects[ci][kr] = {}), mn.objects[ci][kr][Ca] = ps;
                    }, mn.get = function(ci, kr, Ca, ps) {
                      return mn.objects[ci] === void 0 || mn.objects[ci][kr] === void 0 || mn.objects[ci][kr][Ca] == null ? ps : mn.objects[ci][kr][Ca];
                    }, mn.handleAction = function(ci) {
                      var kr = ci.rjvId, Ca = ci.data;
                      switch (ci.name) {
                        case "RESET":
                          mn.emit("reset-" + kr);
                          break;
                        case "VARIABLE_UPDATED":
                          ci.data.updated_src = mn.updateSrc(kr, Ca), mn.set(kr, "action", "variable-update", xt(xt({}, Ca), {}, { type: "variable-edited" })), mn.emit("variable-update-" + kr);
                          break;
                        case "VARIABLE_REMOVED":
                          ci.data.updated_src = mn.updateSrc(kr, Ca), mn.set(kr, "action", "variable-update", xt(xt({}, Ca), {}, { type: "variable-removed" })), mn.emit("variable-update-" + kr);
                          break;
                        case "VARIABLE_ADDED":
                          ci.data.updated_src = mn.updateSrc(kr, Ca), mn.set(kr, "action", "variable-update", xt(xt({}, Ca), {}, { type: "variable-added" })), mn.emit("variable-update-" + kr);
                          break;
                        case "ADD_VARIABLE_KEY_REQUEST":
                          mn.set(kr, "action", "new-key-request", Ca), mn.emit("add-key-request-" + kr);
                      }
                    }, mn.updateSrc = function(ci, kr) {
                      var Ca = kr.name, ps = kr.namespace, Pu = kr.new_value, Tc = (kr.existing_value, kr.variable_removed);
                      ps.shift();
                      var Ff, Mu = mn.get(ci, "global", "src"), Vf = mn.deepCopy(Mu, Cc(ps)), Lp = Vf, Dl = el(ps);
                      try {
                        for (Dl.s(); !(Ff = Dl.n()).done; )
                          Lp = Lp[Ff.value];
                      } catch (Bd) {
                        Dl.e(Bd);
                      } finally {
                        Dl.f();
                      }
                      return Tc ? $r(Lp) == "array" ? Lp.splice(Ca, 1) : delete Lp[Ca] : Ca !== null ? Lp[Ca] = Pu : Vf = Pu, mn.set(ci, "global", "src", Vf), Vf;
                    }, mn.deepCopy = function(ci, kr) {
                      var Ca, ps = $r(ci), Pu = kr.shift();
                      return ps == "array" ? Ca = Cc(ci) : ps == "object" && (Ca = xt({}, ci)), Pu !== void 0 && (Ca[Pu] = mn.deepCopy(ci[Pu], kr)), Ca;
                    }, mn;
                  }
                  return Xt;
                }($u.EventEmitter))();
                lu.register(Kf.handleAction.bind(Kf));
                var Xu = Kf, rf = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).toggleCollapsed = function() {
                      Sn.setState({ collapsed: !Sn.state.collapsed }, function() {
                        Xu.set(Sn.props.rjvId, Sn.props.namespace, "collapsed", Sn.state.collapsed);
                      });
                    }, Sn.getFunctionDisplay = function(zr) {
                      var Ai = br(Sn).props;
                      return zr ? Ct.a.createElement("span", null, Sn.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), Ct.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, Ct.a.createElement("span", null, "{"), Ct.a.createElement("span", Mi(Ai.theme, "ellipsis"), "..."), Ct.a.createElement("span", null, "}"))) : Sn.props.value.toString().slice(9, -1);
                    }, Sn.state = { collapsed: Xu.get(mn.rjvId, mn.namespace, "collapsed", true) }, Sn;
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = this.state.collapsed;
                    return Ct.a.createElement("div", Mi(mn.theme, "function"), Ct.a.createElement(Is, Object.assign({ type_name: "function" }, mn)), Ct.a.createElement("span", Object.assign({}, Mi(mn.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Sn)));
                  } }]), Xt;
                }(Ct.a.PureComponent), Op = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    return Ct.a.createElement("div", Mi(this.props.theme, "nan"), "NaN");
                  } }]), Xt;
                }(Ct.a.PureComponent), dd = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    return Ct.a.createElement("div", Mi(this.props.theme, "null"), "NULL");
                  } }]), Xt;
                }(Ct.a.PureComponent), o1 = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props;
                    return Ct.a.createElement("div", Mi(mn.theme, "integer"), Ct.a.createElement(Is, Object.assign({ type_name: "int" }, mn)), this.props.value);
                  } }]), Xt;
                }(Ct.a.PureComponent), r_ = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props;
                    return Ct.a.createElement("div", Mi(mn.theme, "regexp"), Ct.a.createElement(Is, Object.assign({ type_name: "regexp" }, mn)), this.props.value.toString());
                  } }]), Xt;
                }(Ct.a.PureComponent), nv = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).toggleCollapsed = function() {
                      Sn.setState({ collapsed: !Sn.state.collapsed }, function() {
                        Xu.set(Sn.props.rjvId, Sn.props.namespace, "collapsed", Sn.state.collapsed);
                      });
                    }, Sn.state = { collapsed: Xu.get(mn.rjvId, mn.namespace, "collapsed", true) }, Sn;
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    this.state.collapsed;
                    var mn = this.props, Sn = mn.collapseStringsAfterLength, zr = mn.theme, Ai = mn.value, ci = { style: { cursor: "default" } };
                    return $r(Sn) === "integer" && Ai.length > Sn && (ci.style.cursor = "pointer", this.state.collapsed && (Ai = Ct.a.createElement("span", null, Ai.substring(0, Sn), Ct.a.createElement("span", Mi(zr, "ellipsis"), " ...")))), Ct.a.createElement("div", Mi(zr, "string"), Ct.a.createElement(Is, Object.assign({ type_name: "string" }, mn)), Ct.a.createElement("span", Object.assign({ className: "string-value" }, ci, { onClick: this.toggleCollapsed }), '"', Ai, '"'));
                  } }]), Xt;
                }(Ct.a.PureComponent), Jy = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    return Ct.a.createElement("div", Mi(this.props.theme, "undefined"), "undefined");
                  } }]), Xt;
                }(Ct.a.PureComponent);
                function Fx() {
                  return (Fx = Object.assign || function(Tn) {
                    for (var Ln = 1; Ln < arguments.length; Ln++) {
                      var Xt = arguments[Ln];
                      for (var mn in Xt)
                        Object.prototype.hasOwnProperty.call(Xt, mn) && (Tn[mn] = Xt[mn]);
                    }
                    return Tn;
                  }).apply(this, arguments);
                }
                var q0 = Oa.useLayoutEffect, Zg = function(Tn) {
                  var Ln = Object(Oa.useRef)(Tn);
                  return q0(function() {
                    Ln.current = Tn;
                  }), Ln;
                }, i_ = function(Tn, Ln) {
                  typeof Tn != "function" ? Tn.current = Ln : Tn(Ln);
                }, s1 = function(Tn, Ln) {
                  var Xt = Object(Oa.useRef)();
                  return Object(Oa.useCallback)(function(mn) {
                    Tn.current = mn, Xt.current && i_(Xt.current, null), Xt.current = Ln, Ln && i_(Ln, mn);
                  }, [Ln]);
                }, Xp = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Fd = function(Tn) {
                  Object.keys(Xp).forEach(function(Ln) {
                    Tn.style.setProperty(Ln, Xp[Ln], "important");
                  });
                }, Lh = null, Ts = function() {
                }, $i = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Kr = !!document.documentElement.currentStyle, Hr = function(Tn, Ln) {
                  var Xt = Tn.cacheMeasurements, mn = Tn.maxRows, Sn = Tn.minRows, zr = Tn.onChange, Ai = zr === void 0 ? Ts : zr, ci = Tn.onHeightChange, kr = ci === void 0 ? Ts : ci, Ca = function(Dl, Bd) {
                    if (Dl == null)
                      return {};
                    var em, Vx, DD = {}, o_ = Object.keys(Dl);
                    for (Vx = 0; Vx < o_.length; Vx++)
                      em = o_[Vx], Bd.indexOf(em) >= 0 || (DD[em] = Dl[em]);
                    return DD;
                  }(Tn, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), ps, Pu = Ca.value !== void 0, Tc = Object(Oa.useRef)(null), Ff = s1(Tc, Ln), Mu = Object(Oa.useRef)(0), Vf = Object(Oa.useRef)(), Lp = function() {
                    var Dl = Tc.current, Bd = Xt && Vf.current ? Vf.current : function(o_) {
                      var yA = window.getComputedStyle(o_);
                      if (yA === null)
                        return null;
                      var ZC, Dv = (ZC = yA, $i.reduce(function(mA, JC) {
                        return mA[JC] = ZC[JC], mA;
                      }, {})), XS = Dv.boxSizing;
                      return XS === "" ? null : (Kr && XS === "border-box" && (Dv.width = parseFloat(Dv.width) + parseFloat(Dv.borderRightWidth) + parseFloat(Dv.borderLeftWidth) + parseFloat(Dv.paddingRight) + parseFloat(Dv.paddingLeft) + "px"), { sizingStyle: Dv, paddingSize: parseFloat(Dv.paddingBottom) + parseFloat(Dv.paddingTop), borderSize: parseFloat(Dv.borderBottomWidth) + parseFloat(Dv.borderTopWidth) });
                    }(Dl);
                    if (Bd) {
                      Vf.current = Bd;
                      var em = function(o_, yA, ZC, Dv) {
                        ZC === void 0 && (ZC = 1), Dv === void 0 && (Dv = 1 / 0), Lh || ((Lh = document.createElement("textarea")).setAttribute("tab-index", "-1"), Lh.setAttribute("aria-hidden", "true"), Fd(Lh)), Lh.parentNode === null && document.body.appendChild(Lh);
                        var XS = o_.paddingSize, mA = o_.borderSize, JC = o_.sizingStyle, kD = JC.boxSizing;
                        Object.keys(JC).forEach(function(cg) {
                          var bA = cg;
                          Lh.style[bA] = JC[bA];
                        }), Fd(Lh), Lh.value = yA;
                        var OD = function(cg, bA) {
                          var k6 = cg.scrollHeight;
                          return bA.sizingStyle.boxSizing === "border-box" ? k6 + bA.borderSize : k6 - bA.paddingSize;
                        }(Lh, o_);
                        Lh.value = "x";
                        var D6 = Lh.scrollHeight - XS, aO = D6 * ZC;
                        kD === "border-box" && (aO = aO + XS + mA), OD = Math.max(aO, OD);
                        var oO = D6 * Dv;
                        return kD === "border-box" && (oO = oO + XS + mA), [OD = Math.min(oO, OD), D6];
                      }(Bd, Dl.value || Dl.placeholder || "x", Sn, mn), Vx = em[0], DD = em[1];
                      Mu.current !== Vx && (Mu.current = Vx, Dl.style.setProperty("height", Vx + "px", "important"), kr(Vx, { rowHeight: DD }));
                    }
                  };
                  return Object(Oa.useLayoutEffect)(Lp), ps = Zg(Lp), Object(Oa.useLayoutEffect)(function() {
                    var Dl = function(Bd) {
                      ps.current(Bd);
                    };
                    return window.addEventListener("resize", Dl), function() {
                      window.removeEventListener("resize", Dl);
                    };
                  }, []), Object(Oa.createElement)("textarea", Fx({}, Ca, { onChange: function(Dl) {
                    Pu || Lp(), Ai(Dl);
                  }, ref: Ff }));
                }, ra = Object(Oa.forwardRef)(Hr);
                function ao(Tn) {
                  Tn = Tn.trim();
                  try {
                    if ((Tn = JSON.stringify(JSON.parse(Tn)))[0] === "[")
                      return ss("array", JSON.parse(Tn));
                    if (Tn[0] === "{")
                      return ss("object", JSON.parse(Tn));
                    if (Tn.match(/\-?\d+\.\d+/) && Tn.match(/\-?\d+\.\d+/)[0] === Tn)
                      return ss("float", parseFloat(Tn));
                    if (Tn.match(/\-?\d+e-\d+/) && Tn.match(/\-?\d+e-\d+/)[0] === Tn)
                      return ss("float", Number(Tn));
                    if (Tn.match(/\-?\d+/) && Tn.match(/\-?\d+/)[0] === Tn)
                      return ss("integer", parseInt(Tn));
                    if (Tn.match(/\-?\d+e\+\d+/) && Tn.match(/\-?\d+e\+\d+/)[0] === Tn)
                      return ss("integer", Number(Tn));
                  } catch {
                  }
                  switch (Tn = Tn.toLowerCase()) {
                    case "undefined":
                      return ss("undefined", void 0);
                    case "nan":
                      return ss("nan", NaN);
                    case "null":
                      return ss("null", null);
                    case "true":
                      return ss("boolean", true);
                    case "false":
                      return ss("boolean", false);
                    default:
                      if (Tn = Date.parse(Tn))
                        return ss("date", new Date(Tn));
                  }
                  return ss(false, null);
                }
                function ss(Tn, Ln) {
                  return { type: Tn, value: Ln };
                }
                var Os = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), uu = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), bf = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]), Ai = Mc(Sn).style;
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", { fill: Ai.color, width: Ai.height, height: Ai.width, style: Ai, viewBox: "0 0 1792 1792" }, Ct.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), Zh = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]), Ai = Mc(Sn).style;
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", { fill: Ai.color, width: Ai.height, height: Ai.width, style: Ai, viewBox: "0 0 1792 1792" }, Ct.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), Rh = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", { style: xt(xt({}, Mc(Sn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Ct.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), vd = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", { style: xt(xt({}, Mc(Sn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Ct.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
                  } }]), Xt;
                }(Ct.a.PureComponent), Nh = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("g", null, Ct.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
                  } }]), Xt;
                }(Ct.a.PureComponent), $0 = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("g", null, Ct.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                  } }]), Xt;
                }(Ct.a.PureComponent), Qy = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("g", null, Ct.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                  } }]), Xt;
                }(Ct.a.PureComponent), rv = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("g", null, Ct.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
                  } }]), Xt;
                }(Ct.a.PureComponent), Zf = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("g", null, Ct.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
                  } }]), Xt;
                }(Ct.a.PureComponent), Pp = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.style, zr = Pr(mn, ["style"]);
                    return Ct.a.createElement("span", zr, Ct.a.createElement("svg", Object.assign({}, Mc(Sn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Ct.a.createElement("g", null, Ct.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                  } }]), Xt;
                }(Ct.a.PureComponent);
                function Mc(Tn) {
                  return Tn || (Tn = {}), { style: xt(xt({ verticalAlign: "middle" }, Tn), {}, { color: Tn.color ? Tn.color : "#000000", height: "1em", width: "1em" }) };
                }
                var Vd = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).copiedTimer = null, Sn.handleCopy = function() {
                      var zr = document.createElement("textarea"), Ai = Sn.props, ci = Ai.clickCallback, kr = Ai.src, Ca = Ai.namespace;
                      zr.innerHTML = JSON.stringify(Sn.clipboardValue(kr), null, "  "), document.body.appendChild(zr), zr.select(), document.execCommand("copy"), document.body.removeChild(zr), Sn.copiedTimer = setTimeout(function() {
                        Sn.setState({ copied: false });
                      }, 5500), Sn.setState({ copied: true }, function() {
                        typeof ci == "function" && ci({ src: kr, namespace: Ca, name: Ca[Ca.length - 1] });
                      });
                    }, Sn.getClippyIcon = function() {
                      var zr = Sn.props.theme;
                      return Sn.state.copied ? Ct.a.createElement("span", null, Ct.a.createElement(Nh, Object.assign({ className: "copy-icon" }, Mi(zr, "copy-icon"))), Ct.a.createElement("span", Mi(zr, "copy-icon-copied"), "\u2714")) : Ct.a.createElement(Nh, Object.assign({ className: "copy-icon" }, Mi(zr, "copy-icon")));
                    }, Sn.clipboardValue = function(zr) {
                      switch ($r(zr)) {
                        case "function":
                        case "regexp":
                          return zr.toString();
                        default:
                          return zr;
                      }
                    }, Sn.state = { copied: false }, Sn;
                  }
                  return sn(Xt, [{ key: "componentWillUnmount", value: function() {
                    this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
                  } }, { key: "render", value: function() {
                    var mn = this.props, Sn = (mn.src, mn.theme), zr = mn.hidden, Ai = mn.rowHovered, ci = Mi(Sn, "copy-to-clipboard").style, kr = "inline";
                    return zr && (kr = "none"), Ct.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Ai ? "inline-block" : "none" } }, Ct.a.createElement("span", { style: xt(xt({}, ci), {}, { display: kr }), onClick: this.handleCopy }, this.getClippyIcon()));
                  } }]), Xt;
                }(Ct.a.PureComponent), Jg = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).getEditIcon = function() {
                      var zr = Sn.props, Ai = zr.variable, ci = zr.theme;
                      return Ct.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Sn.state.hovered ? "inline-block" : "none" } }, Ct.a.createElement(Zf, Object.assign({ className: "click-to-edit-icon" }, Mi(ci, "editVarIcon"), { onClick: function() {
                        Sn.prepopInput(Ai);
                      } })));
                    }, Sn.prepopInput = function(zr) {
                      if (Sn.props.onEdit !== false) {
                        var Ai = function(kr) {
                          var Ca;
                          switch ($r(kr)) {
                            case "undefined":
                              Ca = "undefined";
                              break;
                            case "nan":
                              Ca = "NaN";
                              break;
                            case "string":
                              Ca = kr;
                              break;
                            case "date":
                            case "function":
                            case "regexp":
                              Ca = kr.toString();
                              break;
                            default:
                              try {
                                Ca = JSON.stringify(kr, null, "  ");
                              } catch {
                                Ca = "";
                              }
                          }
                          return Ca;
                        }(zr.value), ci = ao(Ai);
                        Sn.setState({ editMode: true, editValue: Ai, parsedInput: { type: ci.type, value: ci.value } });
                      }
                    }, Sn.getRemoveIcon = function() {
                      var zr = Sn.props, Ai = zr.variable, ci = zr.namespace, kr = zr.theme, Ca = zr.rjvId;
                      return Ct.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Sn.state.hovered ? "inline-block" : "none" } }, Ct.a.createElement($0, Object.assign({ className: "click-to-remove-icon" }, Mi(kr, "removeVarIcon"), { onClick: function() {
                        lu.dispatch({ name: "VARIABLE_REMOVED", rjvId: Ca, data: { name: Ai.name, namespace: ci, existing_value: Ai.value, variable_removed: true } });
                      } })));
                    }, Sn.getValue = function(zr, Ai) {
                      var ci = !Ai && zr.type, kr = br(Sn).props;
                      switch (ci) {
                        case false:
                          return Sn.getEditInput();
                        case "string":
                          return Ct.a.createElement(nv, Object.assign({ value: zr.value }, kr));
                        case "integer":
                          return Ct.a.createElement(o1, Object.assign({ value: zr.value }, kr));
                        case "float":
                          return Ct.a.createElement(ai, Object.assign({ value: zr.value }, kr));
                        case "boolean":
                          return Ct.a.createElement(Oi, Object.assign({ value: zr.value }, kr));
                        case "function":
                          return Ct.a.createElement(rf, Object.assign({ value: zr.value }, kr));
                        case "null":
                          return Ct.a.createElement(dd, kr);
                        case "nan":
                          return Ct.a.createElement(Op, kr);
                        case "undefined":
                          return Ct.a.createElement(Jy, kr);
                        case "date":
                          return Ct.a.createElement(ii, Object.assign({ value: zr.value }, kr));
                        case "regexp":
                          return Ct.a.createElement(r_, Object.assign({ value: zr.value }, kr));
                        default:
                          return Ct.a.createElement("div", { className: "object-value" }, JSON.stringify(zr.value));
                      }
                    }, Sn.getEditInput = function() {
                      var zr = Sn.props.theme, Ai = Sn.state.editValue;
                      return Ct.a.createElement("div", null, Ct.a.createElement(ra, Object.assign({ type: "text", inputRef: function(ci) {
                        return ci && ci.focus();
                      }, value: Ai, className: "variable-editor", onChange: function(ci) {
                        var kr = ci.target.value, Ca = ao(kr);
                        Sn.setState({ editValue: kr, parsedInput: { type: Ca.type, value: Ca.value } });
                      }, onKeyDown: function(ci) {
                        switch (ci.key) {
                          case "Escape":
                            Sn.setState({ editMode: false, editValue: "" });
                            break;
                          case "Enter":
                            (ci.ctrlKey || ci.metaKey) && Sn.submitEdit(true);
                        }
                        ci.stopPropagation();
                      }, placeholder: "update this value", minRows: 2 }, Mi(zr, "edit-input"))), Ct.a.createElement("div", Mi(zr, "edit-icon-container"), Ct.a.createElement($0, Object.assign({ className: "edit-cancel" }, Mi(zr, "cancel-icon"), { onClick: function() {
                        Sn.setState({ editMode: false, editValue: "" });
                      } })), Ct.a.createElement(Pp, Object.assign({ className: "edit-check string-value" }, Mi(zr, "check-icon"), { onClick: function() {
                        Sn.submitEdit();
                      } })), Ct.a.createElement("div", null, Sn.showDetected())));
                    }, Sn.submitEdit = function(zr) {
                      var Ai = Sn.props, ci = Ai.variable, kr = Ai.namespace, Ca = Ai.rjvId, ps = Sn.state, Pu = ps.editValue, Tc = ps.parsedInput, Ff = Pu;
                      zr && Tc.type && (Ff = Tc.value), Sn.setState({ editMode: false }), lu.dispatch({ name: "VARIABLE_UPDATED", rjvId: Ca, data: { name: ci.name, namespace: kr, existing_value: ci.value, new_value: Ff, variable_removed: false } });
                    }, Sn.showDetected = function() {
                      var zr = Sn.props, Ai = zr.theme, ci = (zr.variable, zr.namespace, zr.rjvId, Sn.state.parsedInput), kr = (ci.type, ci.value, Sn.getDetectedInput());
                      if (kr)
                        return Ct.a.createElement("div", null, Ct.a.createElement("div", Mi(Ai, "detected-row"), kr, Ct.a.createElement(Pp, { className: "edit-check detected", style: xt({ verticalAlign: "top", paddingLeft: "3px" }, Mi(Ai, "check-icon").style), onClick: function() {
                          Sn.submitEdit(true);
                        } })));
                    }, Sn.getDetectedInput = function() {
                      var zr = Sn.state.parsedInput, Ai = zr.type, ci = zr.value, kr = br(Sn).props, Ca = kr.theme;
                      if (Ai !== false)
                        switch (Ai.toLowerCase()) {
                          case "object":
                            return Ct.a.createElement("span", null, Ct.a.createElement("span", { style: xt(xt({}, Mi(Ca, "brace").style), {}, { cursor: "default" }) }, "{"), Ct.a.createElement("span", { style: xt(xt({}, Mi(Ca, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Ct.a.createElement("span", { style: xt(xt({}, Mi(Ca, "brace").style), {}, { cursor: "default" }) }, "}"));
                          case "array":
                            return Ct.a.createElement("span", null, Ct.a.createElement("span", { style: xt(xt({}, Mi(Ca, "brace").style), {}, { cursor: "default" }) }, "["), Ct.a.createElement("span", { style: xt(xt({}, Mi(Ca, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Ct.a.createElement("span", { style: xt(xt({}, Mi(Ca, "brace").style), {}, { cursor: "default" }) }, "]"));
                          case "string":
                            return Ct.a.createElement(nv, Object.assign({ value: ci }, kr));
                          case "integer":
                            return Ct.a.createElement(o1, Object.assign({ value: ci }, kr));
                          case "float":
                            return Ct.a.createElement(ai, Object.assign({ value: ci }, kr));
                          case "boolean":
                            return Ct.a.createElement(Oi, Object.assign({ value: ci }, kr));
                          case "function":
                            return Ct.a.createElement(rf, Object.assign({ value: ci }, kr));
                          case "null":
                            return Ct.a.createElement(dd, kr);
                          case "nan":
                            return Ct.a.createElement(Op, kr);
                          case "undefined":
                            return Ct.a.createElement(Jy, kr);
                          case "date":
                            return Ct.a.createElement(ii, Object.assign({ value: new Date(ci) }, kr));
                        }
                    }, Sn.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Sn;
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this, Sn = this.props, zr = Sn.variable, Ai = Sn.singleIndent, ci = Sn.type, kr = Sn.theme, Ca = Sn.namespace, ps = Sn.indentWidth, Pu = Sn.enableClipboard, Tc = Sn.onEdit, Ff = Sn.onDelete, Mu = Sn.onSelect, Vf = Sn.displayArrayKey, Lp = Sn.quotesOnKeys, Dl = this.state.editMode;
                    return Ct.a.createElement("div", Object.assign({}, Mi(kr, "objectKeyVal", { paddingLeft: ps * Ai }), { onMouseEnter: function() {
                      return mn.setState(xt(xt({}, mn.state), {}, { hovered: true }));
                    }, onMouseLeave: function() {
                      return mn.setState(xt(xt({}, mn.state), {}, { hovered: false }));
                    }, className: "variable-row", key: zr.name }), ci == "array" ? Vf ? Ct.a.createElement("span", Object.assign({}, Mi(kr, "array-key"), { key: zr.name + "_" + Ca }), zr.name, Ct.a.createElement("div", Mi(kr, "colon"), ":")) : null : Ct.a.createElement("span", null, Ct.a.createElement("span", Object.assign({}, Mi(kr, "object-name"), { className: "object-key", key: zr.name + "_" + Ca }), !!Lp && Ct.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Ct.a.createElement("span", { style: { display: "inline-block" } }, zr.name), !!Lp && Ct.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Ct.a.createElement("span", Mi(kr, "colon"), ":")), Ct.a.createElement("div", Object.assign({ className: "variable-value", onClick: Mu === false && Tc === false ? null : function(Bd) {
                      var em = Cc(Ca);
                      (Bd.ctrlKey || Bd.metaKey) && Tc !== false ? mn.prepopInput(zr) : Mu !== false && (em.shift(), Mu(xt(xt({}, zr), {}, { namespace: em })));
                    } }, Mi(kr, "variableValue", { cursor: Mu === false ? "default" : "pointer" })), this.getValue(zr, Dl)), Pu ? Ct.a.createElement(Vd, { rowHovered: this.state.hovered, hidden: Dl, src: zr.value, clickCallback: Pu, theme: kr, namespace: [].concat(Cc(Ca), [zr.name]) }) : null, Tc !== false && Dl == 0 ? this.getEditIcon() : null, Ff !== false && Dl == 0 ? this.getRemoveIcon() : null);
                  } }]), Xt;
                }(Ct.a.PureComponent), a_ = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    var mn;
                    kt(this, Xt);
                    for (var Sn = arguments.length, zr = new Array(Sn), Ai = 0; Ai < Sn; Ai++)
                      zr[Ai] = arguments[Ai];
                    return (mn = Ln.call.apply(Ln, [this].concat(zr))).getObjectSize = function() {
                      var ci = mn.props, kr = ci.size, Ca = ci.theme;
                      if (ci.displayObjectSize)
                        return Ct.a.createElement("span", Object.assign({ className: "object-size" }, Mi(Ca, "object-size")), kr, " item", kr === 1 ? "" : "s");
                    }, mn.getAddAttribute = function(ci) {
                      var kr = mn.props, Ca = kr.theme, ps = kr.namespace, Pu = kr.name, Tc = kr.src, Ff = kr.rjvId, Mu = kr.depth;
                      return Ct.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: ci ? "inline-block" : "none" } }, Ct.a.createElement(Qy, Object.assign({ className: "click-to-add-icon" }, Mi(Ca, "addVarIcon"), { onClick: function() {
                        var Vf = { name: Mu > 0 ? Pu : null, namespace: ps.splice(0, ps.length - 1), existing_value: Tc, variable_removed: false, key_name: null };
                        $r(Tc) === "object" ? lu.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Ff, data: Vf }) : lu.dispatch({ name: "VARIABLE_ADDED", rjvId: Ff, data: xt(xt({}, Vf), {}, { new_value: [].concat(Cc(Tc), [null]) }) });
                      } })));
                    }, mn.getRemoveObject = function(ci) {
                      var kr = mn.props, Ca = kr.theme, ps = (kr.hover, kr.namespace), Pu = kr.name, Tc = kr.src, Ff = kr.rjvId;
                      if (ps.length !== 1)
                        return Ct.a.createElement("span", { className: "click-to-remove", style: { display: ci ? "inline-block" : "none" } }, Ct.a.createElement($0, Object.assign({ className: "click-to-remove-icon" }, Mi(Ca, "removeVarIcon"), { onClick: function() {
                          lu.dispatch({ name: "VARIABLE_REMOVED", rjvId: Ff, data: { name: Pu, namespace: ps.splice(0, ps.length - 1), existing_value: Tc, variable_removed: true } });
                        } })));
                    }, mn.render = function() {
                      var ci = mn.props, kr = ci.theme, Ca = ci.onDelete, ps = ci.onAdd, Pu = ci.enableClipboard, Tc = ci.src, Ff = ci.namespace, Mu = ci.rowHovered;
                      return Ct.a.createElement("div", Object.assign({}, Mi(kr, "object-meta-data"), { className: "object-meta-data", onClick: function(Vf) {
                        Vf.stopPropagation();
                      } }), mn.getObjectSize(), Pu ? Ct.a.createElement(Vd, { rowHovered: Mu, clickCallback: Pu, src: Tc, theme: kr, namespace: Ff }) : null, ps !== false ? mn.getAddAttribute(Mu) : null, Ca !== false ? mn.getRemoveObject(Mu) : null);
                    }, mn;
                  }
                  return Xt;
                }(Ct.a.PureComponent);
                function ug(Tn) {
                  var Ln = Tn.parent_type, Xt = Tn.namespace, mn = Tn.quotesOnKeys, Sn = Tn.theme, zr = Tn.jsvRoot, Ai = Tn.name, ci = Tn.displayArrayKey, kr = Tn.name ? Tn.name : "";
                  return !zr || Ai !== false && Ai !== null ? Ln == "array" ? ci ? Ct.a.createElement("span", Object.assign({}, Mi(Sn, "array-key"), { key: Xt }), Ct.a.createElement("span", { className: "array-key" }, kr), Ct.a.createElement("span", Mi(Sn, "colon"), ":")) : Ct.a.createElement("span", null) : Ct.a.createElement("span", Object.assign({}, Mi(Sn, "object-name"), { key: Xt }), Ct.a.createElement("span", { className: "object-key" }, mn && Ct.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Ct.a.createElement("span", null, kr), mn && Ct.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Ct.a.createElement("span", Mi(Sn, "colon"), ":")) : Ct.a.createElement("span", null);
                }
                function X0(Tn) {
                  var Ln = Tn.theme;
                  switch (Tn.iconStyle) {
                    case "triangle":
                      return Ct.a.createElement(vd, Object.assign({}, Mi(Ln, "expanded-icon"), { className: "expanded-icon" }));
                    case "square":
                      return Ct.a.createElement(bf, Object.assign({}, Mi(Ln, "expanded-icon"), { className: "expanded-icon" }));
                    default:
                      return Ct.a.createElement(Os, Object.assign({}, Mi(Ln, "expanded-icon"), { className: "expanded-icon" }));
                  }
                }
                function l1(Tn) {
                  var Ln = Tn.theme;
                  switch (Tn.iconStyle) {
                    case "triangle":
                      return Ct.a.createElement(Rh, Object.assign({}, Mi(Ln, "collapsed-icon"), { className: "collapsed-icon" }));
                    case "square":
                      return Ct.a.createElement(Zh, Object.assign({}, Mi(Ln, "collapsed-icon"), { className: "collapsed-icon" }));
                    default:
                      return Ct.a.createElement(uu, Object.assign({}, Mi(Ln, "collapsed-icon"), { className: "collapsed-icon" }));
                  }
                }
                var vA = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).toggleCollapsed = function(zr) {
                      var Ai = [];
                      for (var ci in Sn.state.expanded)
                        Ai.push(Sn.state.expanded[ci]);
                      Ai[zr] = !Ai[zr], Sn.setState({ expanded: Ai });
                    }, Sn.state = { expanded: [] }, Sn;
                  }
                  return sn(Xt, [{ key: "getExpandedIcon", value: function(mn) {
                    var Sn = this.props, zr = Sn.theme, Ai = Sn.iconStyle;
                    return this.state.expanded[mn] ? Ct.a.createElement(X0, { theme: zr, iconStyle: Ai }) : Ct.a.createElement(l1, { theme: zr, iconStyle: Ai });
                  } }, { key: "render", value: function() {
                    var mn = this, Sn = this.props, zr = Sn.src, Ai = Sn.groupArraysAfterLength, ci = (Sn.depth, Sn.name), kr = Sn.theme, Ca = Sn.jsvRoot, ps = Sn.namespace, Pu = (Sn.parent_type, Pr(Sn, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Tc = 0, Ff = 5 * this.props.indentWidth;
                    Ca || (Tc = 5 * this.props.indentWidth);
                    var Mu = Ai, Vf = Math.ceil(zr.length / Mu);
                    return Ct.a.createElement("div", Object.assign({ className: "object-key-val" }, Mi(kr, Ca ? "jsv-root" : "objectKeyVal", { paddingLeft: Tc })), Ct.a.createElement(ug, this.props), Ct.a.createElement("span", null, Ct.a.createElement(a_, Object.assign({ size: zr.length }, this.props))), Cc(Array(Vf)).map(function(Lp, Dl) {
                      return Ct.a.createElement("div", Object.assign({ key: Dl, className: "object-key-val array-group" }, Mi(kr, "objectKeyVal", { marginLeft: 6, paddingLeft: Ff })), Ct.a.createElement("span", Mi(kr, "brace-row"), Ct.a.createElement("div", Object.assign({ className: "icon-container" }, Mi(kr, "icon-container"), { onClick: function(Bd) {
                        mn.toggleCollapsed(Dl);
                      } }), mn.getExpandedIcon(Dl)), mn.state.expanded[Dl] ? Ct.a.createElement(gA, Object.assign({ key: ci + Dl, depth: 0, name: false, collapsed: false, groupArraysAfterLength: Mu, index_offset: Dl * Mu, src: zr.slice(Dl * Mu, Dl * Mu + Mu), namespace: ps, type: "array", parent_type: "array_group", theme: kr }, Pu)) : Ct.a.createElement("span", Object.assign({}, Mi(kr, "brace"), { onClick: function(Bd) {
                        mn.toggleCollapsed(Dl);
                      }, className: "array-group-brace" }), "[", Ct.a.createElement("div", Object.assign({}, Mi(kr, "array-group-meta-data"), { className: "array-group-meta-data" }), Ct.a.createElement("span", Object.assign({ className: "object-size" }, Mi(kr, "object-size")), Dl * Mu, " - ", Dl * Mu + Mu > zr.length ? zr.length : Dl * Mu + Mu)), "]")));
                    }));
                  } }]), Xt;
                }(Ct.a.PureComponent), KC = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    kt(this, Xt), (Sn = Ln.call(this, mn)).toggleCollapsed = function() {
                      Sn.setState({ expanded: !Sn.state.expanded }, function() {
                        Xu.set(Sn.props.rjvId, Sn.props.namespace, "expanded", Sn.state.expanded);
                      });
                    }, Sn.getObjectContent = function(Ai, ci, kr) {
                      return Ct.a.createElement("div", { className: "pushed-content object-container" }, Ct.a.createElement("div", Object.assign({ className: "object-content" }, Mi(Sn.props.theme, "pushed-content")), Sn.renderObjectContents(ci, kr)));
                    }, Sn.getEllipsis = function() {
                      return Sn.state.size === 0 ? null : Ct.a.createElement("div", Object.assign({}, Mi(Sn.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Sn.toggleCollapsed }), "...");
                    }, Sn.getObjectMetaData = function(Ai) {
                      var ci = Sn.props, kr = (ci.rjvId, ci.theme, Sn.state), Ca = kr.size, ps = kr.hovered;
                      return Ct.a.createElement(a_, Object.assign({ rowHovered: ps, size: Ca }, Sn.props));
                    }, Sn.renderObjectContents = function(Ai, ci) {
                      var kr, Ca = Sn.props, ps = Ca.depth, Pu = Ca.parent_type, Tc = Ca.index_offset, Ff = Ca.groupArraysAfterLength, Mu = Ca.namespace, Vf = Sn.state.object_type, Lp = [], Dl = Object.keys(Ai || {});
                      return Sn.props.sortKeys && Vf !== "array" && (Dl = Dl.sort()), Dl.forEach(function(Bd) {
                        if (kr = new tK(Bd, Ai[Bd]), Pu === "array_group" && Tc && (kr.name = parseInt(kr.name) + Tc), Ai.hasOwnProperty(Bd))
                          if (kr.type === "object")
                            Lp.push(Ct.a.createElement(gA, Object.assign({ key: kr.name, depth: ps + 1, name: kr.name, src: kr.value, namespace: Mu.concat(kr.name), parent_type: Vf }, ci)));
                          else if (kr.type === "array") {
                            var em = gA;
                            Ff && kr.value.length > Ff && (em = vA), Lp.push(Ct.a.createElement(em, Object.assign({ key: kr.name, depth: ps + 1, name: kr.name, src: kr.value, namespace: Mu.concat(kr.name), type: "array", parent_type: Vf }, ci)));
                          } else
                            Lp.push(Ct.a.createElement(Jg, Object.assign({ key: kr.name + "_" + Mu, variable: kr, singleIndent: 5, namespace: Mu, type: Sn.props.type }, ci)));
                      }), Lp;
                    };
                    var zr = Xt.getState(mn);
                    return Sn.state = xt(xt({}, zr), {}, { prevProps: {} }), Sn;
                  }
                  return sn(Xt, [{ key: "getBraceStart", value: function(mn, Sn) {
                    var zr = this, Ai = this.props, ci = Ai.src, kr = Ai.theme, Ca = Ai.iconStyle;
                    if (Ai.parent_type === "array_group")
                      return Ct.a.createElement("span", null, Ct.a.createElement("span", Mi(kr, "brace"), mn === "array" ? "[" : "{"), Sn ? this.getObjectMetaData(ci) : null);
                    var ps = Sn ? X0 : l1;
                    return Ct.a.createElement("span", null, Ct.a.createElement("span", Object.assign({ onClick: function(Pu) {
                      zr.toggleCollapsed();
                    } }, Mi(kr, "brace-row")), Ct.a.createElement("div", Object.assign({ className: "icon-container" }, Mi(kr, "icon-container")), Ct.a.createElement(ps, { theme: kr, iconStyle: Ca })), Ct.a.createElement(ug, this.props), Ct.a.createElement("span", Mi(kr, "brace"), mn === "array" ? "[" : "{")), Sn ? this.getObjectMetaData(ci) : null);
                  } }, { key: "render", value: function() {
                    var mn = this, Sn = this.props, zr = Sn.depth, Ai = Sn.src, ci = (Sn.namespace, Sn.name, Sn.type, Sn.parent_type), kr = Sn.theme, Ca = Sn.jsvRoot, ps = Sn.iconStyle, Pu = Pr(Sn, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Tc = this.state, Ff = Tc.object_type, Mu = Tc.expanded, Vf = {};
                    return Ca || ci === "array_group" ? ci === "array_group" && (Vf.borderLeft = 0, Vf.display = "inline") : Vf.paddingLeft = 5 * this.props.indentWidth, Ct.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                      return mn.setState(xt(xt({}, mn.state), {}, { hovered: true }));
                    }, onMouseLeave: function() {
                      return mn.setState(xt(xt({}, mn.state), {}, { hovered: false }));
                    } }, Mi(kr, Ca ? "jsv-root" : "objectKeyVal", Vf)), this.getBraceStart(Ff, Mu), Mu ? this.getObjectContent(zr, Ai, xt({ theme: kr, iconStyle: ps }, Pu)) : this.getEllipsis(), Ct.a.createElement("span", { className: "brace-row" }, Ct.a.createElement("span", { style: xt(xt({}, Mi(kr, "brace").style), {}, { paddingLeft: Mu ? "3px" : "0px" }) }, Ff === "array" ? "]" : "}"), Mu ? null : this.getObjectMetaData(Ai)));
                  } }], [{ key: "getDerivedStateFromProps", value: function(mn, Sn) {
                    var zr = Sn.prevProps;
                    return mn.src !== zr.src || mn.collapsed !== zr.collapsed || mn.name !== zr.name || mn.namespace !== zr.namespace || mn.rjvId !== zr.rjvId ? xt(xt({}, Xt.getState(mn)), {}, { prevProps: mn }) : null;
                  } }]), Xt;
                }(Ct.a.PureComponent);
                KC.getState = function(Tn) {
                  var Ln = Object.keys(Tn.src).length, Xt = (Tn.collapsed === false || Tn.collapsed !== true && Tn.collapsed > Tn.depth) && (!Tn.shouldCollapse || Tn.shouldCollapse({ name: Tn.name, src: Tn.src, type: $r(Tn.src), namespace: Tn.namespace }) === false) && Ln !== 0;
                  return { expanded: Xu.get(Tn.rjvId, Tn.namespace, "expanded", Xt), object_type: Tn.type === "array" ? "array" : "object", parent_type: Tn.type === "array" ? "array" : "object", size: Ln, hovered: false };
                };
                var tK = function Tn(Ln, Xt) {
                  kt(this, Tn), this.name = Ln, this.value = Xt, this.type = $r(Xt);
                };
                _i(KC);
                var gA = KC, UB = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    var mn;
                    kt(this, Xt);
                    for (var Sn = arguments.length, zr = new Array(Sn), Ai = 0; Ai < Sn; Ai++)
                      zr[Ai] = arguments[Ai];
                    return (mn = Ln.call.apply(Ln, [this].concat(zr))).render = function() {
                      var ci = br(mn).props, kr = [ci.name], Ca = gA;
                      return Array.isArray(ci.src) && ci.groupArraysAfterLength && ci.src.length > ci.groupArraysAfterLength && (Ca = vA), Ct.a.createElement("div", { className: "pretty-json-container object-container" }, Ct.a.createElement("div", { className: "object-content" }, Ct.a.createElement(Ca, Object.assign({ namespace: kr, depth: 0, jsvRoot: true }, ci))));
                    }, mn;
                  }
                  return Xt;
                }(Ct.a.PureComponent), qB = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).closeModal = function() {
                      lu.dispatch({ rjvId: Sn.props.rjvId, name: "RESET" });
                    }, Sn.submit = function() {
                      Sn.props.submit(Sn.state.input);
                    }, Sn.state = { input: mn.input ? mn.input : "" }, Sn;
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this, Sn = this.props, zr = Sn.theme, Ai = Sn.rjvId, ci = Sn.isValid, kr = this.state.input, Ca = ci(kr);
                    return Ct.a.createElement("div", Object.assign({ className: "key-modal-request" }, Mi(zr, "key-modal-request"), { onClick: this.closeModal }), Ct.a.createElement("div", Object.assign({}, Mi(zr, "key-modal"), { onClick: function(ps) {
                      ps.stopPropagation();
                    } }), Ct.a.createElement("div", Mi(zr, "key-modal-label"), "Key Name:"), Ct.a.createElement("div", { style: { position: "relative" } }, Ct.a.createElement("input", Object.assign({}, Mi(zr, "key-modal-input"), { className: "key-modal-input", ref: function(ps) {
                      return ps && ps.focus();
                    }, spellCheck: false, value: kr, placeholder: "...", onChange: function(ps) {
                      mn.setState({ input: ps.target.value });
                    }, onKeyPress: function(ps) {
                      Ca && ps.key === "Enter" ? mn.submit() : ps.key === "Escape" && mn.closeModal();
                    } })), Ca ? Ct.a.createElement(Pp, Object.assign({}, Mi(zr, "key-modal-submit"), { className: "key-modal-submit", onClick: function(ps) {
                      return mn.submit();
                    } })) : null), Ct.a.createElement("span", Mi(zr, "key-modal-cancel"), Ct.a.createElement(rv, Object.assign({}, Mi(zr, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                      lu.dispatch({ rjvId: Ai, name: "RESET" });
                    } })))));
                  } }]), Xt;
                }(Ct.a.PureComponent), nK = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    var mn;
                    kt(this, Xt);
                    for (var Sn = arguments.length, zr = new Array(Sn), Ai = 0; Ai < Sn; Ai++)
                      zr[Ai] = arguments[Ai];
                    return (mn = Ln.call.apply(Ln, [this].concat(zr))).isValid = function(ci) {
                      var kr = mn.props.rjvId, Ca = Xu.get(kr, "action", "new-key-request");
                      return ci != "" && Object.keys(Ca.existing_value).indexOf(ci) === -1;
                    }, mn.submit = function(ci) {
                      var kr = mn.props.rjvId, Ca = Xu.get(kr, "action", "new-key-request");
                      Ca.new_value = xt({}, Ca.existing_value), Ca.new_value[ci] = mn.props.defaultValue, lu.dispatch({ name: "VARIABLE_ADDED", rjvId: kr, data: Ca });
                    }, mn;
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.active, zr = mn.theme, Ai = mn.rjvId;
                    return Sn ? Ct.a.createElement(qB, { rjvId: Ai, theme: zr, isValid: this.isValid, submit: this.submit }) : null;
                  } }]), Xt;
                }(Ct.a.PureComponent), E6 = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt() {
                    return kt(this, Xt), Ln.apply(this, arguments);
                  }
                  return sn(Xt, [{ key: "render", value: function() {
                    var mn = this.props, Sn = mn.message, zr = mn.active, Ai = mn.theme, ci = mn.rjvId;
                    return zr ? Ct.a.createElement("div", Object.assign({ className: "validation-failure" }, Mi(Ai, "validation-failure"), { onClick: function() {
                      lu.dispatch({ rjvId: ci, name: "RESET" });
                    } }), Ct.a.createElement("span", Mi(Ai, "validation-failure-label"), Sn), Ct.a.createElement(rv, Mi(Ai, "validation-failure-clear"))) : null;
                  } }]), Xt;
                }(Ct.a.PureComponent), ED = function(Tn) {
                  Xn(Xt, Tn);
                  var Ln = bi(Xt);
                  function Xt(mn) {
                    var Sn;
                    return kt(this, Xt), (Sn = Ln.call(this, mn)).rjvId = Date.now().toString(), Sn.getListeners = function() {
                      return { reset: Sn.resetState, "variable-update": Sn.updateSrc, "add-key-request": Sn.addKeyRequest };
                    }, Sn.updateSrc = function() {
                      var zr, Ai = Xu.get(Sn.rjvId, "action", "variable-update"), ci = Ai.name, kr = Ai.namespace, Ca = Ai.new_value, ps = Ai.existing_value, Pu = (Ai.variable_removed, Ai.updated_src), Tc = Ai.type, Ff = Sn.props, Mu = Ff.onEdit, Vf = Ff.onDelete, Lp = Ff.onAdd, Dl = { existing_src: Sn.state.src, new_value: Ca, updated_src: Pu, name: ci, namespace: kr, existing_value: ps };
                      switch (Tc) {
                        case "variable-added":
                          zr = Lp(Dl);
                          break;
                        case "variable-edited":
                          zr = Mu(Dl);
                          break;
                        case "variable-removed":
                          zr = Vf(Dl);
                      }
                      zr !== false ? (Xu.set(Sn.rjvId, "global", "src", Pu), Sn.setState({ src: Pu })) : Sn.setState({ validationFailure: true });
                    }, Sn.addKeyRequest = function() {
                      Sn.setState({ addKeyRequest: true });
                    }, Sn.resetState = function() {
                      Sn.setState({ validationFailure: false, addKeyRequest: false });
                    }, Sn.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Xt.defaultProps.src, name: Xt.defaultProps.name, theme: Xt.defaultProps.theme, validationMessage: Xt.defaultProps.validationMessage, prevSrc: Xt.defaultProps.src, prevName: Xt.defaultProps.name, prevTheme: Xt.defaultProps.theme }, Sn;
                  }
                  return sn(Xt, [{ key: "componentDidMount", value: function() {
                    Xu.set(this.rjvId, "global", "src", this.state.src);
                    var mn = this.getListeners();
                    for (var Sn in mn)
                      Xu.on(Sn + "-" + this.rjvId, mn[Sn]);
                    this.setState({ addKeyRequest: false, editKeyRequest: false });
                  } }, { key: "componentDidUpdate", value: function(mn, Sn) {
                    Sn.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Sn.editKeyRequest !== false && this.setState({ editKeyRequest: false }), mn.src !== this.state.src && Xu.set(this.rjvId, "global", "src", this.state.src);
                  } }, { key: "componentWillUnmount", value: function() {
                    var mn = this.getListeners();
                    for (var Sn in mn)
                      Xu.removeListener(Sn + "-" + this.rjvId, mn[Sn]);
                  } }, { key: "render", value: function() {
                    var mn = this.state, Sn = mn.validationFailure, zr = mn.validationMessage, Ai = mn.addKeyRequest, ci = mn.theme, kr = mn.src, Ca = mn.name, ps = this.props, Pu = ps.style, Tc = ps.defaultValue;
                    return Ct.a.createElement("div", { className: "react-json-view", style: xt(xt({}, Mi(ci, "app-container").style), Pu) }, Ct.a.createElement(E6, { message: zr, active: Sn, theme: ci, rjvId: this.rjvId }), Ct.a.createElement(UB, Object.assign({}, this.props, { src: kr, name: Ca, theme: ci, type: $r(kr), rjvId: this.rjvId })), Ct.a.createElement(nK, { active: Ai, theme: ci, rjvId: this.rjvId, defaultValue: Tc }));
                  } }], [{ key: "getDerivedStateFromProps", value: function(mn, Sn) {
                    if (mn.src !== Sn.prevSrc || mn.name !== Sn.prevName || mn.theme !== Sn.prevTheme) {
                      var zr = { src: mn.src, name: mn.name, theme: mn.theme, validationMessage: mn.validationMessage, prevSrc: mn.src, prevName: mn.name, prevTheme: mn.theme };
                      return Xt.validateState(zr);
                    }
                    return null;
                  } }]), Xt;
                }(Ct.a.PureComponent);
                ED.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, ED.validateState = function(Tn) {
                  var Ln = {};
                  return $r(Tn.theme) !== "object" || function(Xt) {
                    var mn = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                    if ($r(Xt) === "object") {
                      for (var Sn = 0; Sn < mn.length; Sn++)
                        if (!(mn[Sn] in Xt))
                          return false;
                      return true;
                    }
                    return false;
                  }(Tn.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Ln.theme = "rjv-default"), $r(Tn.src) !== "object" && $r(Tn.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Ln.name = "ERROR", Ln.src = { message: "src property must be a valid json object" }), xt(xt({}, Tn), Ln);
                }, _i(ED), Te.default = ED;
              }]);
            });
          })(Qs);
          var Yl = Fn(Qs.exports);
          const Kg = ({ id: ge, title: He, chart: we, option: Me }) => {
            const { tool: Te } = nA({}), Ne = sr({ global: true }), [it, { set: ht }] = Tt(true), xt = (kt) => {
              const { updated_src: Lt } = kt;
              we == null || we.setOption(Lt), Te == null || Te.add(ge, we, Lt, He), Ne.emit("list");
            };
            return WB("div", { children: [dA(Gn, { children: dA(ua, { children: dA(su, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (kt) => {
              ht(!kt);
            } }) }) }), dA("br", {}), Me && dA(Yl, { src: Me, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: it, iconStyle: "triangle", enableClipboard: true, onEdit: xt, onAdd: xt, onDelete: xt })] });
          }, lg = () => {
            const ge = sr({ global: true }), He = Ce.useRef(0), { tool: we } = nA({});
            Ce.useState(false), Ce.useState("right");
            const [Me, Te] = Ce.useState([]), [Ne, it] = Ce.useState();
            return ge.useSubscription("list", () => {
              var ht;
              we != null && we.list().length && (it((ht = we == null ? void 0 : we.list()) == null ? void 0 : ht[He.current]), Te(we == null ? void 0 : we.list()));
            }), dA("div", { className: Us.container, children: false });
          };
          ye.EchartTool = lg, ye.ReactEchartsJson = Kg, ye.useEchartsTool = nA, ye.useEventEmitter = sr;
        })(ZV);
        const zle = () => {
          const ye = pe({ global: true }), Ge = T.useRef(0), { tool: xe } = Pn({});
          T.useState(false), T.useState("right");
          const [Se, Ce] = T.useState([]), [Re, at] = T.useState();
          return ye.useSubscription("list", () => {
            var ft;
            xe != null && xe.list().length && (at((ft = xe == null ? void 0 : xe.list()) == null ? void 0 : ft[Ge.current]), Ce(xe == null ? void 0 : xe.list()));
          }), rD("div", { className: Ble.container, children: false });
        };
        var JV = { exports: {} };
        (function(ye, Ge) {
          (function(xe, Se) {
            ye.exports = Se(R.default);
          })(Z, function(xe) {
            return function(Se) {
              var Ce = {};
              function Re(at) {
                if (Ce[at])
                  return Ce[at].exports;
                var ft = Ce[at] = { i: at, l: false, exports: {} };
                return Se[at].call(ft.exports, ft, ft.exports, Re), ft.l = true, ft.exports;
              }
              return Re.m = Se, Re.c = Ce, Re.d = function(at, ft, st) {
                Re.o(at, ft) || Object.defineProperty(at, ft, { enumerable: true, get: st });
              }, Re.r = function(at) {
                typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(at, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(at, "__esModule", { value: true });
              }, Re.t = function(at, ft) {
                if (1 & ft && (at = Re(at)), 8 & ft || 4 & ft && typeof at == "object" && at && at.__esModule)
                  return at;
                var st = /* @__PURE__ */ Object.create(null);
                if (Re.r(st), Object.defineProperty(st, "default", { enumerable: true, value: at }), 2 & ft && typeof at != "string")
                  for (var Dt in at)
                    Re.d(st, Dt, function(Pt) {
                      return at[Pt];
                    }.bind(null, Dt));
                return st;
              }, Re.n = function(at) {
                var ft = at && at.__esModule ? function() {
                  return at.default;
                } : function() {
                  return at;
                };
                return Re.d(ft, "a", ft), ft;
              }, Re.o = function(at, ft) {
                return Object.prototype.hasOwnProperty.call(at, ft);
              }, Re.p = "", Re(Re.s = 48);
            }([function(Se, Ce) {
              Se.exports = xe;
            }, function(Se, Ce) {
              var Re = Se.exports = { version: "2.6.12" };
              typeof __e == "number" && (__e = Re);
            }, function(Se, Ce, Re) {
              var at = Re(26)("wks"), ft = Re(17), st = Re(3).Symbol, Dt = typeof st == "function";
              (Se.exports = function(Pt) {
                return at[Pt] || (at[Pt] = Dt && st[Pt] || (Dt ? st : ft)("Symbol." + Pt));
              }).store = at;
            }, function(Se, Ce) {
              var Re = Se.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
              typeof __g == "number" && (__g = Re);
            }, function(Se, Ce, Re) {
              Se.exports = !Re(8)(function() {
                return Object.defineProperty({}, "a", { get: function() {
                  return 7;
                } }).a != 7;
              });
            }, function(Se, Ce) {
              var Re = {}.hasOwnProperty;
              Se.exports = function(at, ft) {
                return Re.call(at, ft);
              };
            }, function(Se, Ce, Re) {
              var at = Re(7), ft = Re(16);
              Se.exports = Re(4) ? function(st, Dt, Pt) {
                return at.f(st, Dt, ft(1, Pt));
              } : function(st, Dt, Pt) {
                return st[Dt] = Pt, st;
              };
            }, function(Se, Ce, Re) {
              var at = Re(10), ft = Re(35), st = Re(23), Dt = Object.defineProperty;
              Ce.f = Re(4) ? Object.defineProperty : function(Pt, tn, Fn) {
                if (at(Pt), tn = st(tn, true), at(Fn), ft)
                  try {
                    return Dt(Pt, tn, Fn);
                  } catch {
                  }
                if ("get" in Fn || "set" in Fn)
                  throw TypeError("Accessors not supported!");
                return "value" in Fn && (Pt[tn] = Fn.value), Pt;
              };
            }, function(Se, Ce) {
              Se.exports = function(Re) {
                try {
                  return !!Re();
                } catch {
                  return true;
                }
              };
            }, function(Se, Ce, Re) {
              var at = Re(40), ft = Re(22);
              Se.exports = function(st) {
                return at(ft(st));
              };
            }, function(Se, Ce, Re) {
              var at = Re(11);
              Se.exports = function(ft) {
                if (!at(ft))
                  throw TypeError(ft + " is not an object!");
                return ft;
              };
            }, function(Se, Ce) {
              Se.exports = function(Re) {
                return typeof Re == "object" ? Re !== null : typeof Re == "function";
              };
            }, function(Se, Ce) {
              Se.exports = {};
            }, function(Se, Ce, Re) {
              var at = Re(39), ft = Re(27);
              Se.exports = Object.keys || function(st) {
                return at(st, ft);
              };
            }, function(Se, Ce) {
              Se.exports = true;
            }, function(Se, Ce, Re) {
              var at = Re(3), ft = Re(1), st = Re(53), Dt = Re(6), Pt = Re(5), tn = function(Fn, Un, qn) {
                var nr, sr, Ii, gi = Fn & tn.F, Sa = Fn & tn.G, Tt = Fn & tn.S, Ar = Fn & tn.P, Vr = Fn & tn.B, Si = Fn & tn.W, mi = Sa ? ft : ft[Un] || (ft[Un] = {}), Dr = mi.prototype, Gr = Sa ? at : Tt ? at[Un] : (at[Un] || {}).prototype;
                for (nr in Sa && (qn = Un), qn)
                  (sr = !gi && Gr && Gr[nr] !== void 0) && Pt(mi, nr) || (Ii = sr ? Gr[nr] : qn[nr], mi[nr] = Sa && typeof Gr[nr] != "function" ? qn[nr] : Vr && sr ? st(Ii, at) : Si && Gr[nr] == Ii ? function(Vi) {
                    var ya = function(xr, Ro, Oo) {
                      if (this instanceof Vi) {
                        switch (arguments.length) {
                          case 0:
                            return new Vi();
                          case 1:
                            return new Vi(xr);
                          case 2:
                            return new Vi(xr, Ro);
                        }
                        return new Vi(xr, Ro, Oo);
                      }
                      return Vi.apply(this, arguments);
                    };
                    return ya.prototype = Vi.prototype, ya;
                  }(Ii) : Ar && typeof Ii == "function" ? st(Function.call, Ii) : Ii, Ar && ((mi.virtual || (mi.virtual = {}))[nr] = Ii, Fn & tn.R && Dr && !Dr[nr] && Dt(Dr, nr, Ii)));
              };
              tn.F = 1, tn.G = 2, tn.S = 4, tn.P = 8, tn.B = 16, tn.W = 32, tn.U = 64, tn.R = 128, Se.exports = tn;
            }, function(Se, Ce) {
              Se.exports = function(Re, at) {
                return { enumerable: !(1 & Re), configurable: !(2 & Re), writable: !(4 & Re), value: at };
              };
            }, function(Se, Ce) {
              var Re = 0, at = Math.random();
              Se.exports = function(ft) {
                return "Symbol(".concat(ft === void 0 ? "" : ft, ")_", (++Re + at).toString(36));
              };
            }, function(Se, Ce, Re) {
              var at = Re(22);
              Se.exports = function(ft) {
                return Object(at(ft));
              };
            }, function(Se, Ce) {
              Ce.f = {}.propertyIsEnumerable;
            }, function(Se, Ce, Re) {
              var at = Re(52)(true);
              Re(34)(String, "String", function(ft) {
                this._t = String(ft), this._i = 0;
              }, function() {
                var ft, st = this._t, Dt = this._i;
                return Dt >= st.length ? { value: void 0, done: true } : (ft = at(st, Dt), this._i += ft.length, { value: ft, done: false });
              });
            }, function(Se, Ce) {
              var Re = Math.ceil, at = Math.floor;
              Se.exports = function(ft) {
                return isNaN(ft = +ft) ? 0 : (ft > 0 ? at : Re)(ft);
              };
            }, function(Se, Ce) {
              Se.exports = function(Re) {
                if (Re == null)
                  throw TypeError("Can't call method on  " + Re);
                return Re;
              };
            }, function(Se, Ce, Re) {
              var at = Re(11);
              Se.exports = function(ft, st) {
                if (!at(ft))
                  return ft;
                var Dt, Pt;
                if (st && typeof (Dt = ft.toString) == "function" && !at(Pt = Dt.call(ft)) || typeof (Dt = ft.valueOf) == "function" && !at(Pt = Dt.call(ft)) || !st && typeof (Dt = ft.toString) == "function" && !at(Pt = Dt.call(ft)))
                  return Pt;
                throw TypeError("Can't convert object to primitive value");
              };
            }, function(Se, Ce) {
              var Re = {}.toString;
              Se.exports = function(at) {
                return Re.call(at).slice(8, -1);
              };
            }, function(Se, Ce, Re) {
              var at = Re(26)("keys"), ft = Re(17);
              Se.exports = function(st) {
                return at[st] || (at[st] = ft(st));
              };
            }, function(Se, Ce, Re) {
              var at = Re(1), ft = Re(3), st = ft["__core-js_shared__"] || (ft["__core-js_shared__"] = {});
              (Se.exports = function(Dt, Pt) {
                return st[Dt] || (st[Dt] = Pt !== void 0 ? Pt : {});
              })("versions", []).push({ version: at.version, mode: Re(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
            }, function(Se, Ce) {
              Se.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
            }, function(Se, Ce, Re) {
              var at = Re(7).f, ft = Re(5), st = Re(2)("toStringTag");
              Se.exports = function(Dt, Pt, tn) {
                Dt && !ft(Dt = tn ? Dt : Dt.prototype, st) && at(Dt, st, { configurable: true, value: Pt });
              };
            }, function(Se, Ce, Re) {
              Re(62);
              for (var at = Re(3), ft = Re(6), st = Re(12), Dt = Re(2)("toStringTag"), Pt = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), tn = 0; tn < Pt.length; tn++) {
                var Fn = Pt[tn], Un = at[Fn], qn = Un && Un.prototype;
                qn && !qn[Dt] && ft(qn, Dt, Fn), st[Fn] = st.Array;
              }
            }, function(Se, Ce, Re) {
              Ce.f = Re(2);
            }, function(Se, Ce, Re) {
              var at = Re(3), ft = Re(1), st = Re(14), Dt = Re(30), Pt = Re(7).f;
              Se.exports = function(tn) {
                var Fn = ft.Symbol || (ft.Symbol = st ? {} : at.Symbol || {});
                tn.charAt(0) == "_" || tn in Fn || Pt(Fn, tn, { value: Dt.f(tn) });
              };
            }, function(Se, Ce) {
              Ce.f = Object.getOwnPropertySymbols;
            }, function(Se, Ce) {
              Se.exports = function(Re, at, ft) {
                return Math.min(Math.max(Re, at), ft);
              };
            }, function(Se, Ce, Re) {
              var at = Re(14), ft = Re(15), st = Re(37), Dt = Re(6), Pt = Re(12), tn = Re(55), Fn = Re(28), Un = Re(61), qn = Re(2)("iterator"), nr = !([].keys && "next" in [].keys()), sr = function() {
                return this;
              };
              Se.exports = function(Ii, gi, Sa, Tt, Ar, Vr, Si) {
                tn(Sa, gi, Tt);
                var mi, Dr, Gr, Vi = function(ni) {
                  if (!nr && ni in Oo)
                    return Oo[ni];
                  switch (ni) {
                    case "keys":
                    case "values":
                      return function() {
                        return new Sa(this, ni);
                      };
                  }
                  return function() {
                    return new Sa(this, ni);
                  };
                }, ya = gi + " Iterator", xr = Ar == "values", Ro = false, Oo = Ii.prototype, pi = Oo[qn] || Oo["@@iterator"] || Ar && Oo[Ar], xs = pi || Vi(Ar), Ti = Ar ? xr ? Vi("entries") : xs : void 0, si = gi == "Array" && Oo.entries || pi;
                if (si && (Gr = Un(si.call(new Ii()))) !== Object.prototype && Gr.next && (Fn(Gr, ya, true), at || typeof Gr[qn] == "function" || Dt(Gr, qn, sr)), xr && pi && pi.name !== "values" && (Ro = true, xs = function() {
                  return pi.call(this);
                }), at && !Si || !nr && !Ro && Oo[qn] || Dt(Oo, qn, xs), Pt[gi] = xs, Pt[ya] = sr, Ar)
                  if (mi = { values: xr ? xs : Vi("values"), keys: Vr ? xs : Vi("keys"), entries: Ti }, Si)
                    for (Dr in mi)
                      Dr in Oo || st(Oo, Dr, mi[Dr]);
                  else
                    ft(ft.P + ft.F * (nr || Ro), gi, mi);
                return mi;
              };
            }, function(Se, Ce, Re) {
              Se.exports = !Re(4) && !Re(8)(function() {
                return Object.defineProperty(Re(36)("div"), "a", { get: function() {
                  return 7;
                } }).a != 7;
              });
            }, function(Se, Ce, Re) {
              var at = Re(11), ft = Re(3).document, st = at(ft) && at(ft.createElement);
              Se.exports = function(Dt) {
                return st ? ft.createElement(Dt) : {};
              };
            }, function(Se, Ce, Re) {
              Se.exports = Re(6);
            }, function(Se, Ce, Re) {
              var at = Re(10), ft = Re(56), st = Re(27), Dt = Re(25)("IE_PROTO"), Pt = function() {
              }, tn = function() {
                var Fn, Un = Re(36)("iframe"), qn = st.length;
                for (Un.style.display = "none", Re(60).appendChild(Un), Un.src = "javascript:", (Fn = Un.contentWindow.document).open(), Fn.write("<script>document.F=Object<\/script>"), Fn.close(), tn = Fn.F; qn--; )
                  delete tn.prototype[st[qn]];
                return tn();
              };
              Se.exports = Object.create || function(Fn, Un) {
                var qn;
                return Fn !== null ? (Pt.prototype = at(Fn), qn = new Pt(), Pt.prototype = null, qn[Dt] = Fn) : qn = tn(), Un === void 0 ? qn : ft(qn, Un);
              };
            }, function(Se, Ce, Re) {
              var at = Re(5), ft = Re(9), st = Re(57)(false), Dt = Re(25)("IE_PROTO");
              Se.exports = function(Pt, tn) {
                var Fn, Un = ft(Pt), qn = 0, nr = [];
                for (Fn in Un)
                  Fn != Dt && at(Un, Fn) && nr.push(Fn);
                for (; tn.length > qn; )
                  at(Un, Fn = tn[qn++]) && (~st(nr, Fn) || nr.push(Fn));
                return nr;
              };
            }, function(Se, Ce, Re) {
              var at = Re(24);
              Se.exports = Object("z").propertyIsEnumerable(0) ? Object : function(ft) {
                return at(ft) == "String" ? ft.split("") : Object(ft);
              };
            }, function(Se, Ce, Re) {
              var at = Re(39), ft = Re(27).concat("length", "prototype");
              Ce.f = Object.getOwnPropertyNames || function(st) {
                return at(st, ft);
              };
            }, function(Se, Ce, Re) {
              var at = Re(24), ft = Re(2)("toStringTag"), st = at(function() {
                return arguments;
              }()) == "Arguments";
              Se.exports = function(Dt) {
                var Pt, tn, Fn;
                return Dt === void 0 ? "Undefined" : Dt === null ? "Null" : typeof (tn = function(Un, qn) {
                  try {
                    return Un[qn];
                  } catch {
                  }
                }(Pt = Object(Dt), ft)) == "string" ? tn : st ? at(Pt) : (Fn = at(Pt)) == "Object" && typeof Pt.callee == "function" ? "Arguments" : Fn;
              };
            }, function(Se, Ce) {
              var Re;
              Re = function() {
                return this;
              }();
              try {
                Re = Re || new Function("return this")();
              } catch {
                typeof window == "object" && (Re = window);
              }
              Se.exports = Re;
            }, function(Se, Ce) {
              var Re = /-?\d+(\.\d+)?%?/g;
              Se.exports = function(at) {
                return at.match(Re);
              };
            }, function(Se, Ce, Re) {
              Object.defineProperty(Ce, "__esModule", { value: true }), Ce.getBase16Theme = Ce.createStyling = Ce.invertTheme = void 0;
              var at = sr(Re(49)), ft = sr(Re(76)), st = sr(Re(81)), Dt = sr(Re(89)), Pt = sr(Re(93)), tn = function(Dr) {
                if (Dr && Dr.__esModule)
                  return Dr;
                var Gr = {};
                if (Dr != null)
                  for (var Vi in Dr)
                    Object.prototype.hasOwnProperty.call(Dr, Vi) && (Gr[Vi] = Dr[Vi]);
                return Gr.default = Dr, Gr;
              }(Re(94)), Fn = sr(Re(132)), Un = sr(Re(133)), qn = sr(Re(138)), nr = Re(139);
              function sr(Dr) {
                return Dr && Dr.__esModule ? Dr : { default: Dr };
              }
              var Ii = tn.default, gi = (0, Dt.default)(Ii), Sa = (0, qn.default)(Un.default, nr.rgb2yuv, function(Dr) {
                var Gr, Vi = (0, st.default)(Dr, 3), ya = Vi[0], xr = Vi[1], Ro = Vi[2];
                return [(Gr = ya, Gr < 0.25 ? 1 : Gr < 0.5 ? 0.9 - Gr : 1.1 - Gr), xr, Ro];
              }, nr.yuv2rgb, Fn.default), Tt = function(Dr) {
                return function(Gr) {
                  return { className: [Gr.className, Dr.className].filter(Boolean).join(" "), style: (0, ft.default)({}, Gr.style || {}, Dr.style || {}) };
                };
              }, Ar = function(Dr, Gr) {
                var Vi = (0, Dt.default)(Gr);
                for (var ya in Dr)
                  Vi.indexOf(ya) === -1 && Vi.push(ya);
                return Vi.reduce(function(xr, Ro) {
                  return xr[Ro] = function(Oo, pi) {
                    if (Oo === void 0)
                      return pi;
                    if (pi === void 0)
                      return Oo;
                    var xs = Oo === void 0 ? "undefined" : (0, at.default)(Oo), Ti = pi === void 0 ? "undefined" : (0, at.default)(pi);
                    switch (xs) {
                      case "string":
                        switch (Ti) {
                          case "string":
                            return [pi, Oo].filter(Boolean).join(" ");
                          case "object":
                            return Tt({ className: Oo, style: pi });
                          case "function":
                            return function(si) {
                              for (var ni = arguments.length, ja = Array(ni > 1 ? ni - 1 : 0), Ta = 1; Ta < ni; Ta++)
                                ja[Ta - 1] = arguments[Ta];
                              return Tt({ className: Oo })(pi.apply(void 0, [si].concat(ja)));
                            };
                        }
                      case "object":
                        switch (Ti) {
                          case "string":
                            return Tt({ className: pi, style: Oo });
                          case "object":
                            return (0, ft.default)({}, pi, Oo);
                          case "function":
                            return function(si) {
                              for (var ni = arguments.length, ja = Array(ni > 1 ? ni - 1 : 0), Ta = 1; Ta < ni; Ta++)
                                ja[Ta - 1] = arguments[Ta];
                              return Tt({ style: Oo })(pi.apply(void 0, [si].concat(ja)));
                            };
                        }
                      case "function":
                        switch (Ti) {
                          case "string":
                            return function(si) {
                              for (var ni = arguments.length, ja = Array(ni > 1 ? ni - 1 : 0), Ta = 1; Ta < ni; Ta++)
                                ja[Ta - 1] = arguments[Ta];
                              return Oo.apply(void 0, [Tt(si)({ className: pi })].concat(ja));
                            };
                          case "object":
                            return function(si) {
                              for (var ni = arguments.length, ja = Array(ni > 1 ? ni - 1 : 0), Ta = 1; Ta < ni; Ta++)
                                ja[Ta - 1] = arguments[Ta];
                              return Oo.apply(void 0, [Tt(si)({ style: pi })].concat(ja));
                            };
                          case "function":
                            return function(si) {
                              for (var ni = arguments.length, ja = Array(ni > 1 ? ni - 1 : 0), Ta = 1; Ta < ni; Ta++)
                                ja[Ta - 1] = arguments[Ta];
                              return Oo.apply(void 0, [pi.apply(void 0, [si].concat(ja))].concat(ja));
                            };
                        }
                    }
                  }(Dr[Ro], Gr[Ro]), xr;
                }, {});
              }, Vr = function(Dr, Gr) {
                for (var Vi = arguments.length, ya = Array(Vi > 2 ? Vi - 2 : 0), xr = 2; xr < Vi; xr++)
                  ya[xr - 2] = arguments[xr];
                if (Gr === null)
                  return Dr;
                Array.isArray(Gr) || (Gr = [Gr]);
                var Ro = Gr.map(function(pi) {
                  return Dr[pi];
                }).filter(Boolean), Oo = Ro.reduce(function(pi, xs) {
                  return typeof xs == "string" ? pi.className = [pi.className, xs].filter(Boolean).join(" ") : (xs === void 0 ? "undefined" : (0, at.default)(xs)) === "object" ? pi.style = (0, ft.default)({}, pi.style, xs) : typeof xs == "function" && (pi = (0, ft.default)({}, pi, xs.apply(void 0, [pi].concat(ya)))), pi;
                }, { className: "", style: {} });
                return Oo.className || delete Oo.className, (0, Dt.default)(Oo.style).length === 0 && delete Oo.style, Oo;
              }, Si = Ce.invertTheme = function(Dr) {
                return (0, Dt.default)(Dr).reduce(function(Gr, Vi) {
                  return Gr[Vi] = /^base/.test(Vi) ? Sa(Dr[Vi]) : Vi === "scheme" ? Dr[Vi] + ":inverted" : Dr[Vi], Gr;
                }, {});
              }, mi = (Ce.createStyling = (0, Pt.default)(function(Dr) {
                for (var Gr = arguments.length, Vi = Array(Gr > 3 ? Gr - 3 : 0), ya = 3; ya < Gr; ya++)
                  Vi[ya - 3] = arguments[ya];
                var xr = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Ro = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Oo = xr.defaultBase16, pi = Oo === void 0 ? Ii : Oo, xs = xr.base16Themes, Ti = xs === void 0 ? null : xs, si = mi(Ro, Ti);
                si && (Ro = (0, ft.default)({}, si, Ro));
                var ni = gi.reduce(function(Uu, Su) {
                  return Uu[Su] = Ro[Su] || pi[Su], Uu;
                }, {}), ja = (0, Dt.default)(Ro).reduce(function(Uu, Su) {
                  return gi.indexOf(Su) === -1 && (Uu[Su] = Ro[Su]), Uu;
                }, {}), Ta = Dr(ni), Ws = Ar(ja, Ta);
                return (0, Pt.default)(Vr, 2).apply(void 0, [Ws].concat(Vi));
              }, 3), Ce.getBase16Theme = function(Dr, Gr) {
                if (Dr && Dr.extend && (Dr = Dr.extend), typeof Dr == "string") {
                  var Vi = Dr.split(":"), ya = (0, st.default)(Vi, 2), xr = ya[0], Ro = ya[1];
                  Dr = (Gr || {})[xr] || tn[xr], Ro === "inverted" && (Dr = Si(Dr));
                }
                return Dr && Dr.hasOwnProperty("base00") ? Dr : void 0;
              });
            }, function(Se, Ce, Re) {
              var at, ft = typeof Reflect == "object" ? Reflect : null, st = ft && typeof ft.apply == "function" ? ft.apply : function(Tt, Ar, Vr) {
                return Function.prototype.apply.call(Tt, Ar, Vr);
              };
              at = ft && typeof ft.ownKeys == "function" ? ft.ownKeys : Object.getOwnPropertySymbols ? function(Tt) {
                return Object.getOwnPropertyNames(Tt).concat(Object.getOwnPropertySymbols(Tt));
              } : function(Tt) {
                return Object.getOwnPropertyNames(Tt);
              };
              var Dt = Number.isNaN || function(Tt) {
                return Tt != Tt;
              };
              function Pt() {
                Pt.init.call(this);
              }
              Se.exports = Pt, Se.exports.once = function(Tt, Ar) {
                return new Promise(function(Vr, Si) {
                  function mi() {
                    Dr !== void 0 && Tt.removeListener("error", Dr), Vr([].slice.call(arguments));
                  }
                  var Dr;
                  Ar !== "error" && (Dr = function(Gr) {
                    Tt.removeListener(Ar, mi), Si(Gr);
                  }, Tt.once("error", Dr)), Tt.once(Ar, mi);
                });
              }, Pt.EventEmitter = Pt, Pt.prototype._events = void 0, Pt.prototype._eventsCount = 0, Pt.prototype._maxListeners = void 0;
              var tn = 10;
              function Fn(Tt) {
                if (typeof Tt != "function")
                  throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof Tt);
              }
              function Un(Tt) {
                return Tt._maxListeners === void 0 ? Pt.defaultMaxListeners : Tt._maxListeners;
              }
              function qn(Tt, Ar, Vr, Si) {
                var mi, Dr, Gr, Vi;
                if (Fn(Vr), (Dr = Tt._events) === void 0 ? (Dr = Tt._events = /* @__PURE__ */ Object.create(null), Tt._eventsCount = 0) : (Dr.newListener !== void 0 && (Tt.emit("newListener", Ar, Vr.listener ? Vr.listener : Vr), Dr = Tt._events), Gr = Dr[Ar]), Gr === void 0)
                  Gr = Dr[Ar] = Vr, ++Tt._eventsCount;
                else if (typeof Gr == "function" ? Gr = Dr[Ar] = Si ? [Vr, Gr] : [Gr, Vr] : Si ? Gr.unshift(Vr) : Gr.push(Vr), (mi = Un(Tt)) > 0 && Gr.length > mi && !Gr.warned) {
                  Gr.warned = true;
                  var ya = new Error("Possible EventEmitter memory leak detected. " + Gr.length + " " + String(Ar) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                  ya.name = "MaxListenersExceededWarning", ya.emitter = Tt, ya.type = Ar, ya.count = Gr.length, Vi = ya, console && console.warn && console.warn(Vi);
                }
                return Tt;
              }
              function nr() {
                if (!this.fired)
                  return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
              }
              function sr(Tt, Ar, Vr) {
                var Si = { fired: false, wrapFn: void 0, target: Tt, type: Ar, listener: Vr }, mi = nr.bind(Si);
                return mi.listener = Vr, Si.wrapFn = mi, mi;
              }
              function Ii(Tt, Ar, Vr) {
                var Si = Tt._events;
                if (Si === void 0)
                  return [];
                var mi = Si[Ar];
                return mi === void 0 ? [] : typeof mi == "function" ? Vr ? [mi.listener || mi] : [mi] : Vr ? function(Dr) {
                  for (var Gr = new Array(Dr.length), Vi = 0; Vi < Gr.length; ++Vi)
                    Gr[Vi] = Dr[Vi].listener || Dr[Vi];
                  return Gr;
                }(mi) : Sa(mi, mi.length);
              }
              function gi(Tt) {
                var Ar = this._events;
                if (Ar !== void 0) {
                  var Vr = Ar[Tt];
                  if (typeof Vr == "function")
                    return 1;
                  if (Vr !== void 0)
                    return Vr.length;
                }
                return 0;
              }
              function Sa(Tt, Ar) {
                for (var Vr = new Array(Ar), Si = 0; Si < Ar; ++Si)
                  Vr[Si] = Tt[Si];
                return Vr;
              }
              Object.defineProperty(Pt, "defaultMaxListeners", { enumerable: true, get: function() {
                return tn;
              }, set: function(Tt) {
                if (typeof Tt != "number" || Tt < 0 || Dt(Tt))
                  throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + Tt + ".");
                tn = Tt;
              } }), Pt.init = function() {
                this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
              }, Pt.prototype.setMaxListeners = function(Tt) {
                if (typeof Tt != "number" || Tt < 0 || Dt(Tt))
                  throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + Tt + ".");
                return this._maxListeners = Tt, this;
              }, Pt.prototype.getMaxListeners = function() {
                return Un(this);
              }, Pt.prototype.emit = function(Tt) {
                for (var Ar = [], Vr = 1; Vr < arguments.length; Vr++)
                  Ar.push(arguments[Vr]);
                var Si = Tt === "error", mi = this._events;
                if (mi !== void 0)
                  Si = Si && mi.error === void 0;
                else if (!Si)
                  return false;
                if (Si) {
                  var Dr;
                  if (Ar.length > 0 && (Dr = Ar[0]), Dr instanceof Error)
                    throw Dr;
                  var Gr = new Error("Unhandled error." + (Dr ? " (" + Dr.message + ")" : ""));
                  throw Gr.context = Dr, Gr;
                }
                var Vi = mi[Tt];
                if (Vi === void 0)
                  return false;
                if (typeof Vi == "function")
                  st(Vi, this, Ar);
                else {
                  var ya = Vi.length, xr = Sa(Vi, ya);
                  for (Vr = 0; Vr < ya; ++Vr)
                    st(xr[Vr], this, Ar);
                }
                return true;
              }, Pt.prototype.addListener = function(Tt, Ar) {
                return qn(this, Tt, Ar, false);
              }, Pt.prototype.on = Pt.prototype.addListener, Pt.prototype.prependListener = function(Tt, Ar) {
                return qn(this, Tt, Ar, true);
              }, Pt.prototype.once = function(Tt, Ar) {
                return Fn(Ar), this.on(Tt, sr(this, Tt, Ar)), this;
              }, Pt.prototype.prependOnceListener = function(Tt, Ar) {
                return Fn(Ar), this.prependListener(Tt, sr(this, Tt, Ar)), this;
              }, Pt.prototype.removeListener = function(Tt, Ar) {
                var Vr, Si, mi, Dr, Gr;
                if (Fn(Ar), (Si = this._events) === void 0)
                  return this;
                if ((Vr = Si[Tt]) === void 0)
                  return this;
                if (Vr === Ar || Vr.listener === Ar)
                  --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete Si[Tt], Si.removeListener && this.emit("removeListener", Tt, Vr.listener || Ar));
                else if (typeof Vr != "function") {
                  for (mi = -1, Dr = Vr.length - 1; Dr >= 0; Dr--)
                    if (Vr[Dr] === Ar || Vr[Dr].listener === Ar) {
                      Gr = Vr[Dr].listener, mi = Dr;
                      break;
                    }
                  if (mi < 0)
                    return this;
                  mi === 0 ? Vr.shift() : function(Vi, ya) {
                    for (; ya + 1 < Vi.length; ya++)
                      Vi[ya] = Vi[ya + 1];
                    Vi.pop();
                  }(Vr, mi), Vr.length === 1 && (Si[Tt] = Vr[0]), Si.removeListener !== void 0 && this.emit("removeListener", Tt, Gr || Ar);
                }
                return this;
              }, Pt.prototype.off = Pt.prototype.removeListener, Pt.prototype.removeAllListeners = function(Tt) {
                var Ar, Vr, Si;
                if ((Vr = this._events) === void 0)
                  return this;
                if (Vr.removeListener === void 0)
                  return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Vr[Tt] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Vr[Tt]), this;
                if (arguments.length === 0) {
                  var mi, Dr = Object.keys(Vr);
                  for (Si = 0; Si < Dr.length; ++Si)
                    (mi = Dr[Si]) !== "removeListener" && this.removeAllListeners(mi);
                  return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
                }
                if (typeof (Ar = Vr[Tt]) == "function")
                  this.removeListener(Tt, Ar);
                else if (Ar !== void 0)
                  for (Si = Ar.length - 1; Si >= 0; Si--)
                    this.removeListener(Tt, Ar[Si]);
                return this;
              }, Pt.prototype.listeners = function(Tt) {
                return Ii(this, Tt, true);
              }, Pt.prototype.rawListeners = function(Tt) {
                return Ii(this, Tt, false);
              }, Pt.listenerCount = function(Tt, Ar) {
                return typeof Tt.listenerCount == "function" ? Tt.listenerCount(Ar) : gi.call(Tt, Ar);
              }, Pt.prototype.listenerCount = gi, Pt.prototype.eventNames = function() {
                return this._eventsCount > 0 ? at(this._events) : [];
              };
            }, function(Se, Ce, Re) {
              Se.exports.Dispatcher = Re(140);
            }, function(Se, Ce, Re) {
              Se.exports = Re(142);
            }, function(Se, Ce, Re) {
              Ce.__esModule = true;
              var at = Dt(Re(50)), ft = Dt(Re(65)), st = typeof ft.default == "function" && typeof at.default == "symbol" ? function(Pt) {
                return typeof Pt;
              } : function(Pt) {
                return Pt && typeof ft.default == "function" && Pt.constructor === ft.default && Pt !== ft.default.prototype ? "symbol" : typeof Pt;
              };
              function Dt(Pt) {
                return Pt && Pt.__esModule ? Pt : { default: Pt };
              }
              Ce.default = typeof ft.default == "function" && st(at.default) === "symbol" ? function(Pt) {
                return Pt === void 0 ? "undefined" : st(Pt);
              } : function(Pt) {
                return Pt && typeof ft.default == "function" && Pt.constructor === ft.default && Pt !== ft.default.prototype ? "symbol" : Pt === void 0 ? "undefined" : st(Pt);
              };
            }, function(Se, Ce, Re) {
              Se.exports = { default: Re(51), __esModule: true };
            }, function(Se, Ce, Re) {
              Re(20), Re(29), Se.exports = Re(30).f("iterator");
            }, function(Se, Ce, Re) {
              var at = Re(21), ft = Re(22);
              Se.exports = function(st) {
                return function(Dt, Pt) {
                  var tn, Fn, Un = String(ft(Dt)), qn = at(Pt), nr = Un.length;
                  return qn < 0 || qn >= nr ? st ? "" : void 0 : (tn = Un.charCodeAt(qn)) < 55296 || tn > 56319 || qn + 1 === nr || (Fn = Un.charCodeAt(qn + 1)) < 56320 || Fn > 57343 ? st ? Un.charAt(qn) : tn : st ? Un.slice(qn, qn + 2) : Fn - 56320 + (tn - 55296 << 10) + 65536;
                };
              };
            }, function(Se, Ce, Re) {
              var at = Re(54);
              Se.exports = function(ft, st, Dt) {
                if (at(ft), st === void 0)
                  return ft;
                switch (Dt) {
                  case 1:
                    return function(Pt) {
                      return ft.call(st, Pt);
                    };
                  case 2:
                    return function(Pt, tn) {
                      return ft.call(st, Pt, tn);
                    };
                  case 3:
                    return function(Pt, tn, Fn) {
                      return ft.call(st, Pt, tn, Fn);
                    };
                }
                return function() {
                  return ft.apply(st, arguments);
                };
              };
            }, function(Se, Ce) {
              Se.exports = function(Re) {
                if (typeof Re != "function")
                  throw TypeError(Re + " is not a function!");
                return Re;
              };
            }, function(Se, Ce, Re) {
              var at = Re(38), ft = Re(16), st = Re(28), Dt = {};
              Re(6)(Dt, Re(2)("iterator"), function() {
                return this;
              }), Se.exports = function(Pt, tn, Fn) {
                Pt.prototype = at(Dt, { next: ft(1, Fn) }), st(Pt, tn + " Iterator");
              };
            }, function(Se, Ce, Re) {
              var at = Re(7), ft = Re(10), st = Re(13);
              Se.exports = Re(4) ? Object.defineProperties : function(Dt, Pt) {
                ft(Dt);
                for (var tn, Fn = st(Pt), Un = Fn.length, qn = 0; Un > qn; )
                  at.f(Dt, tn = Fn[qn++], Pt[tn]);
                return Dt;
              };
            }, function(Se, Ce, Re) {
              var at = Re(9), ft = Re(58), st = Re(59);
              Se.exports = function(Dt) {
                return function(Pt, tn, Fn) {
                  var Un, qn = at(Pt), nr = ft(qn.length), sr = st(Fn, nr);
                  if (Dt && tn != tn) {
                    for (; nr > sr; )
                      if ((Un = qn[sr++]) != Un)
                        return true;
                  } else
                    for (; nr > sr; sr++)
                      if ((Dt || sr in qn) && qn[sr] === tn)
                        return Dt || sr || 0;
                  return !Dt && -1;
                };
              };
            }, function(Se, Ce, Re) {
              var at = Re(21), ft = Math.min;
              Se.exports = function(st) {
                return st > 0 ? ft(at(st), 9007199254740991) : 0;
              };
            }, function(Se, Ce, Re) {
              var at = Re(21), ft = Math.max, st = Math.min;
              Se.exports = function(Dt, Pt) {
                return (Dt = at(Dt)) < 0 ? ft(Dt + Pt, 0) : st(Dt, Pt);
              };
            }, function(Se, Ce, Re) {
              var at = Re(3).document;
              Se.exports = at && at.documentElement;
            }, function(Se, Ce, Re) {
              var at = Re(5), ft = Re(18), st = Re(25)("IE_PROTO"), Dt = Object.prototype;
              Se.exports = Object.getPrototypeOf || function(Pt) {
                return Pt = ft(Pt), at(Pt, st) ? Pt[st] : typeof Pt.constructor == "function" && Pt instanceof Pt.constructor ? Pt.constructor.prototype : Pt instanceof Object ? Dt : null;
              };
            }, function(Se, Ce, Re) {
              var at = Re(63), ft = Re(64), st = Re(12), Dt = Re(9);
              Se.exports = Re(34)(Array, "Array", function(Pt, tn) {
                this._t = Dt(Pt), this._i = 0, this._k = tn;
              }, function() {
                var Pt = this._t, tn = this._k, Fn = this._i++;
                return !Pt || Fn >= Pt.length ? (this._t = void 0, ft(1)) : ft(0, tn == "keys" ? Fn : tn == "values" ? Pt[Fn] : [Fn, Pt[Fn]]);
              }, "values"), st.Arguments = st.Array, at("keys"), at("values"), at("entries");
            }, function(Se, Ce) {
              Se.exports = function() {
              };
            }, function(Se, Ce) {
              Se.exports = function(Re, at) {
                return { value: at, done: !!Re };
              };
            }, function(Se, Ce, Re) {
              Se.exports = { default: Re(66), __esModule: true };
            }, function(Se, Ce, Re) {
              Re(67), Re(73), Re(74), Re(75), Se.exports = Re(1).Symbol;
            }, function(Se, Ce, Re) {
              var at = Re(3), ft = Re(5), st = Re(4), Dt = Re(15), Pt = Re(37), tn = Re(68).KEY, Fn = Re(8), Un = Re(26), qn = Re(28), nr = Re(17), sr = Re(2), Ii = Re(30), gi = Re(31), Sa = Re(69), Tt = Re(70), Ar = Re(10), Vr = Re(11), Si = Re(18), mi = Re(9), Dr = Re(23), Gr = Re(16), Vi = Re(38), ya = Re(71), xr = Re(72), Ro = Re(32), Oo = Re(7), pi = Re(13), xs = xr.f, Ti = Oo.f, si = ya.f, ni = at.Symbol, ja = at.JSON, Ta = ja && ja.stringify, Ws = sr("_hidden"), Uu = sr("toPrimitive"), Su = {}.propertyIsEnumerable, hl = Un("symbol-registry"), Tf = Un("symbols"), Cu = Un("op-symbols"), Lc = Object.prototype, Eh = typeof ni == "function" && !!Ro.f, B0 = at.QObject, qy = !B0 || !B0.prototype || !B0.prototype.findChild, vp = st && Fn(function() {
                return Vi(Ti({}, "a", { get: function() {
                  return Ti(this, "a", { value: 7 }).a;
                } })).a != 7;
              }) ? function(qr, Yi, to) {
                var is = xs(Lc, Yi);
                is && delete Lc[Yi], Ti(qr, Yi, to), is && qr !== Lc && Ti(Lc, Yi, is);
              } : Ti, Ap = function(qr) {
                var Yi = Tf[qr] = Vi(ni.prototype);
                return Yi._k = qr, Yi;
              }, ig = Eh && typeof ni.iterator == "symbol" ? function(qr) {
                return typeof qr == "symbol";
              } : function(qr) {
                return qr instanceof ni;
              }, $y = function(qr, Yi, to) {
                return qr === Lc && $y(Cu, Yi, to), Ar(qr), Yi = Dr(Yi, true), Ar(to), ft(Tf, Yi) ? (to.enumerable ? (ft(qr, Ws) && qr[Ws][Yi] && (qr[Ws][Yi] = false), to = Vi(to, { enumerable: Gr(0, false) })) : (ft(qr, Ws) || Ti(qr, Ws, Gr(1, {})), qr[Ws][Yi] = true), vp(qr, Yi, to)) : Ti(qr, Yi, to);
              }, Ed = function(qr, Yi) {
                Ar(qr);
                for (var to, is = Sa(Yi = mi(Yi)), Bl = 0, zl = is.length; zl > Bl; )
                  $y(qr, to = is[Bl++], Yi[to]);
                return qr;
              }, z0 = function(qr) {
                var Yi = Su.call(this, qr = Dr(qr, true));
                return !(this === Lc && ft(Tf, qr) && !ft(Cu, qr)) && (!(Yi || !ft(this, qr) || !ft(Tf, qr) || ft(this, Ws) && this[Ws][qr]) || Yi);
              }, ws = function(qr, Yi) {
                if (qr = mi(qr), Yi = Dr(Yi, true), qr !== Lc || !ft(Tf, Yi) || ft(Cu, Yi)) {
                  var to = xs(qr, Yi);
                  return !to || !ft(Tf, Yi) || ft(qr, Ws) && qr[Ws][Yi] || (to.enumerable = true), to;
                }
              }, ag = function(qr) {
                for (var Yi, to = si(mi(qr)), is = [], Bl = 0; to.length > Bl; )
                  ft(Tf, Yi = to[Bl++]) || Yi == Ws || Yi == tn || is.push(Yi);
                return is;
              }, gp = function(qr) {
                for (var Yi, to = qr === Lc, is = si(to ? Cu : mi(qr)), Bl = [], zl = 0; is.length > zl; )
                  !ft(Tf, Yi = is[zl++]) || to && !ft(Lc, Yi) || Bl.push(Tf[Yi]);
                return Bl;
              };
              Eh || (Pt((ni = function() {
                if (this instanceof ni)
                  throw TypeError("Symbol is not a constructor!");
                var qr = nr(arguments.length > 0 ? arguments[0] : void 0), Yi = function(to) {
                  this === Lc && Yi.call(Cu, to), ft(this, Ws) && ft(this[Ws], qr) && (this[Ws][qr] = false), vp(this, qr, Gr(1, to));
                };
                return st && qy && vp(Lc, qr, { configurable: true, set: Yi }), Ap(qr);
              }).prototype, "toString", function() {
                return this._k;
              }), xr.f = ws, Oo.f = $y, Re(41).f = ya.f = ag, Re(19).f = z0, Ro.f = gp, st && !Re(14) && Pt(Lc, "propertyIsEnumerable", z0, true), Ii.f = function(qr) {
                return Ap(sr(qr));
              }), Dt(Dt.G + Dt.W + Dt.F * !Eh, { Symbol: ni });
              for (var Yh = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Ip = 0; Yh.length > Ip; )
                sr(Yh[Ip++]);
              for (var Jm = pi(sr.store), qi = 0; Jm.length > qi; )
                gi(Jm[qi++]);
              Dt(Dt.S + Dt.F * !Eh, "Symbol", { for: function(qr) {
                return ft(hl, qr += "") ? hl[qr] : hl[qr] = ni(qr);
              }, keyFor: function(qr) {
                if (!ig(qr))
                  throw TypeError(qr + " is not a symbol!");
                for (var Yi in hl)
                  if (hl[Yi] === qr)
                    return Yi;
              }, useSetter: function() {
                qy = true;
              }, useSimple: function() {
                qy = false;
              } }), Dt(Dt.S + Dt.F * !Eh, "Object", { create: function(qr, Yi) {
                return Yi === void 0 ? Vi(qr) : Ed(Vi(qr), Yi);
              }, defineProperty: $y, defineProperties: Ed, getOwnPropertyDescriptor: ws, getOwnPropertyNames: ag, getOwnPropertySymbols: gp });
              var Rr = Fn(function() {
                Ro.f(1);
              });
              Dt(Dt.S + Dt.F * Rr, "Object", { getOwnPropertySymbols: function(qr) {
                return Ro.f(Si(qr));
              } }), ja && Dt(Dt.S + Dt.F * (!Eh || Fn(function() {
                var qr = ni();
                return Ta([qr]) != "[null]" || Ta({ a: qr }) != "{}" || Ta(Object(qr)) != "{}";
              })), "JSON", { stringify: function(qr) {
                for (var Yi, to, is = [qr], Bl = 1; arguments.length > Bl; )
                  is.push(arguments[Bl++]);
                if (to = Yi = is[1], (Vr(Yi) || qr !== void 0) && !ig(qr))
                  return Tt(Yi) || (Yi = function(zl, $c) {
                    if (typeof to == "function" && ($c = to.call(this, zl, $c)), !ig($c))
                      return $c;
                  }), is[1] = Yi, Ta.apply(ja, is);
              } }), ni.prototype[Uu] || Re(6)(ni.prototype, Uu, ni.prototype.valueOf), qn(ni, "Symbol"), qn(Math, "Math", true), qn(at.JSON, "JSON", true);
            }, function(Se, Ce, Re) {
              var at = Re(17)("meta"), ft = Re(11), st = Re(5), Dt = Re(7).f, Pt = 0, tn = Object.isExtensible || function() {
                return true;
              }, Fn = !Re(8)(function() {
                return tn(Object.preventExtensions({}));
              }), Un = function(nr) {
                Dt(nr, at, { value: { i: "O" + ++Pt, w: {} } });
              }, qn = Se.exports = { KEY: at, NEED: false, fastKey: function(nr, sr) {
                if (!ft(nr))
                  return typeof nr == "symbol" ? nr : (typeof nr == "string" ? "S" : "P") + nr;
                if (!st(nr, at)) {
                  if (!tn(nr))
                    return "F";
                  if (!sr)
                    return "E";
                  Un(nr);
                }
                return nr[at].i;
              }, getWeak: function(nr, sr) {
                if (!st(nr, at)) {
                  if (!tn(nr))
                    return true;
                  if (!sr)
                    return false;
                  Un(nr);
                }
                return nr[at].w;
              }, onFreeze: function(nr) {
                return Fn && qn.NEED && tn(nr) && !st(nr, at) && Un(nr), nr;
              } };
            }, function(Se, Ce, Re) {
              var at = Re(13), ft = Re(32), st = Re(19);
              Se.exports = function(Dt) {
                var Pt = at(Dt), tn = ft.f;
                if (tn)
                  for (var Fn, Un = tn(Dt), qn = st.f, nr = 0; Un.length > nr; )
                    qn.call(Dt, Fn = Un[nr++]) && Pt.push(Fn);
                return Pt;
              };
            }, function(Se, Ce, Re) {
              var at = Re(24);
              Se.exports = Array.isArray || function(ft) {
                return at(ft) == "Array";
              };
            }, function(Se, Ce, Re) {
              var at = Re(9), ft = Re(41).f, st = {}.toString, Dt = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
              Se.exports.f = function(Pt) {
                return Dt && st.call(Pt) == "[object Window]" ? function(tn) {
                  try {
                    return ft(tn);
                  } catch {
                    return Dt.slice();
                  }
                }(Pt) : ft(at(Pt));
              };
            }, function(Se, Ce, Re) {
              var at = Re(19), ft = Re(16), st = Re(9), Dt = Re(23), Pt = Re(5), tn = Re(35), Fn = Object.getOwnPropertyDescriptor;
              Ce.f = Re(4) ? Fn : function(Un, qn) {
                if (Un = st(Un), qn = Dt(qn, true), tn)
                  try {
                    return Fn(Un, qn);
                  } catch {
                  }
                if (Pt(Un, qn))
                  return ft(!at.f.call(Un, qn), Un[qn]);
              };
            }, function(Se, Ce) {
            }, function(Se, Ce, Re) {
              Re(31)("asyncIterator");
            }, function(Se, Ce, Re) {
              Re(31)("observable");
            }, function(Se, Ce, Re) {
              Ce.__esModule = true;
              var at, ft = Re(77), st = (at = ft) && at.__esModule ? at : { default: at };
              Ce.default = st.default || function(Dt) {
                for (var Pt = 1; Pt < arguments.length; Pt++) {
                  var tn = arguments[Pt];
                  for (var Fn in tn)
                    Object.prototype.hasOwnProperty.call(tn, Fn) && (Dt[Fn] = tn[Fn]);
                }
                return Dt;
              };
            }, function(Se, Ce, Re) {
              Se.exports = { default: Re(78), __esModule: true };
            }, function(Se, Ce, Re) {
              Re(79), Se.exports = Re(1).Object.assign;
            }, function(Se, Ce, Re) {
              var at = Re(15);
              at(at.S + at.F, "Object", { assign: Re(80) });
            }, function(Se, Ce, Re) {
              var at = Re(4), ft = Re(13), st = Re(32), Dt = Re(19), Pt = Re(18), tn = Re(40), Fn = Object.assign;
              Se.exports = !Fn || Re(8)(function() {
                var Un = {}, qn = {}, nr = Symbol(), sr = "abcdefghijklmnopqrst";
                return Un[nr] = 7, sr.split("").forEach(function(Ii) {
                  qn[Ii] = Ii;
                }), Fn({}, Un)[nr] != 7 || Object.keys(Fn({}, qn)).join("") != sr;
              }) ? function(Un, qn) {
                for (var nr = Pt(Un), sr = arguments.length, Ii = 1, gi = st.f, Sa = Dt.f; sr > Ii; )
                  for (var Tt, Ar = tn(arguments[Ii++]), Vr = gi ? ft(Ar).concat(gi(Ar)) : ft(Ar), Si = Vr.length, mi = 0; Si > mi; )
                    Tt = Vr[mi++], at && !Sa.call(Ar, Tt) || (nr[Tt] = Ar[Tt]);
                return nr;
              } : Fn;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true;
              var at = st(Re(82)), ft = st(Re(85));
              function st(Dt) {
                return Dt && Dt.__esModule ? Dt : { default: Dt };
              }
              Ce.default = function(Dt, Pt) {
                if (Array.isArray(Dt))
                  return Dt;
                if ((0, at.default)(Object(Dt)))
                  return function(tn, Fn) {
                    var Un = [], qn = true, nr = false, sr = void 0;
                    try {
                      for (var Ii, gi = (0, ft.default)(tn); !(qn = (Ii = gi.next()).done) && (Un.push(Ii.value), !Fn || Un.length !== Fn); qn = true)
                        ;
                    } catch (Sa) {
                      nr = true, sr = Sa;
                    } finally {
                      try {
                        !qn && gi.return && gi.return();
                      } finally {
                        if (nr)
                          throw sr;
                      }
                    }
                    return Un;
                  }(Dt, Pt);
                throw new TypeError("Invalid attempt to destructure non-iterable instance");
              };
            }, function(Se, Ce, Re) {
              Se.exports = { default: Re(83), __esModule: true };
            }, function(Se, Ce, Re) {
              Re(29), Re(20), Se.exports = Re(84);
            }, function(Se, Ce, Re) {
              var at = Re(42), ft = Re(2)("iterator"), st = Re(12);
              Se.exports = Re(1).isIterable = function(Dt) {
                var Pt = Object(Dt);
                return Pt[ft] !== void 0 || "@@iterator" in Pt || st.hasOwnProperty(at(Pt));
              };
            }, function(Se, Ce, Re) {
              Se.exports = { default: Re(86), __esModule: true };
            }, function(Se, Ce, Re) {
              Re(29), Re(20), Se.exports = Re(87);
            }, function(Se, Ce, Re) {
              var at = Re(10), ft = Re(88);
              Se.exports = Re(1).getIterator = function(st) {
                var Dt = ft(st);
                if (typeof Dt != "function")
                  throw TypeError(st + " is not iterable!");
                return at(Dt.call(st));
              };
            }, function(Se, Ce, Re) {
              var at = Re(42), ft = Re(2)("iterator"), st = Re(12);
              Se.exports = Re(1).getIteratorMethod = function(Dt) {
                if (Dt != null)
                  return Dt[ft] || Dt["@@iterator"] || st[at(Dt)];
              };
            }, function(Se, Ce, Re) {
              Se.exports = { default: Re(90), __esModule: true };
            }, function(Se, Ce, Re) {
              Re(91), Se.exports = Re(1).Object.keys;
            }, function(Se, Ce, Re) {
              var at = Re(18), ft = Re(13);
              Re(92)("keys", function() {
                return function(st) {
                  return ft(at(st));
                };
              });
            }, function(Se, Ce, Re) {
              var at = Re(15), ft = Re(1), st = Re(8);
              Se.exports = function(Dt, Pt) {
                var tn = (ft.Object || {})[Dt] || Object[Dt], Fn = {};
                Fn[Dt] = Pt(tn), at(at.S + at.F * st(function() {
                  tn(1);
                }), "Object", Fn);
              };
            }, function(Se, Ce, Re) {
              (function(at) {
                var ft = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], st = /^\s+|\s+$/g, Dt = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Pt = /\{\n\/\* \[wrapped with (.+)\] \*/, tn = /,? & /, Fn = /^[-+]0x[0-9a-f]+$/i, Un = /^0b[01]+$/i, qn = /^\[object .+?Constructor\]$/, nr = /^0o[0-7]+$/i, sr = /^(?:0|[1-9]\d*)$/, Ii = parseInt, gi = typeof at == "object" && at && at.Object === Object && at, Sa = typeof self == "object" && self && self.Object === Object && self, Tt = gi || Sa || Function("return this")();
                function Ar(qi, Rr, qr) {
                  switch (qr.length) {
                    case 0:
                      return qi.call(Rr);
                    case 1:
                      return qi.call(Rr, qr[0]);
                    case 2:
                      return qi.call(Rr, qr[0], qr[1]);
                    case 3:
                      return qi.call(Rr, qr[0], qr[1], qr[2]);
                  }
                  return qi.apply(Rr, qr);
                }
                function Vr(qi, Rr) {
                  return !!(qi && qi.length) && function(qr, Yi, to) {
                    if (Yi != Yi)
                      return function(zl, $c, Dh, Sc) {
                        for (var lc = zl.length, Af = Dh + (Sc ? 1 : -1); Sc ? Af-- : ++Af < lc; )
                          if ($c(zl[Af], Af, zl))
                            return Af;
                        return -1;
                      }(qr, Si, to);
                    for (var is = to - 1, Bl = qr.length; ++is < Bl; )
                      if (qr[is] === Yi)
                        return is;
                    return -1;
                  }(qi, Rr, 0) > -1;
                }
                function Si(qi) {
                  return qi != qi;
                }
                function mi(qi, Rr) {
                  for (var qr = qi.length, Yi = 0; qr--; )
                    qi[qr] === Rr && Yi++;
                  return Yi;
                }
                function Dr(qi, Rr) {
                  for (var qr = -1, Yi = qi.length, to = 0, is = []; ++qr < Yi; ) {
                    var Bl = qi[qr];
                    Bl !== Rr && Bl !== "__lodash_placeholder__" || (qi[qr] = "__lodash_placeholder__", is[to++] = qr);
                  }
                  return is;
                }
                var Gr, Vi, ya, xr = Function.prototype, Ro = Object.prototype, Oo = Tt["__core-js_shared__"], pi = (Gr = /[^.]+$/.exec(Oo && Oo.keys && Oo.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Gr : "", xs = xr.toString, Ti = Ro.hasOwnProperty, si = Ro.toString, ni = RegExp("^" + xs.call(Ti).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ja = Object.create, Ta = Math.max, Ws = Math.min, Uu = (Vi = Ap(Object, "defineProperty"), (ya = Ap.name) && ya.length > 2 ? Vi : void 0);
                function Su(qi) {
                  return Yh(qi) ? ja(qi) : {};
                }
                function hl(qi) {
                  return !(!Yh(qi) || function(Rr) {
                    return !!pi && pi in Rr;
                  }(qi)) && (function(Rr) {
                    var qr = Yh(Rr) ? si.call(Rr) : "";
                    return qr == "[object Function]" || qr == "[object GeneratorFunction]";
                  }(qi) || function(Rr) {
                    var qr = false;
                    if (Rr != null && typeof Rr.toString != "function")
                      try {
                        qr = !!(Rr + "");
                      } catch {
                      }
                    return qr;
                  }(qi) ? ni : qn).test(function(Rr) {
                    if (Rr != null) {
                      try {
                        return xs.call(Rr);
                      } catch {
                      }
                      try {
                        return Rr + "";
                      } catch {
                      }
                    }
                    return "";
                  }(qi));
                }
                function Tf(qi, Rr, qr, Yi) {
                  for (var to = -1, is = qi.length, Bl = qr.length, zl = -1, $c = Rr.length, Dh = Ta(is - Bl, 0), Sc = Array($c + Dh), lc = !Yi; ++zl < $c; )
                    Sc[zl] = Rr[zl];
                  for (; ++to < Bl; )
                    (lc || to < is) && (Sc[qr[to]] = qi[to]);
                  for (; Dh--; )
                    Sc[zl++] = qi[to++];
                  return Sc;
                }
                function Cu(qi, Rr, qr, Yi) {
                  for (var to = -1, is = qi.length, Bl = -1, zl = qr.length, $c = -1, Dh = Rr.length, Sc = Ta(is - zl, 0), lc = Array(Sc + Dh), Af = !Yi; ++to < Sc; )
                    lc[to] = qi[to];
                  for (var Cv = to; ++$c < Dh; )
                    lc[Cv + $c] = Rr[$c];
                  for (; ++Bl < zl; )
                    (Af || to < is) && (lc[Cv + qr[Bl]] = qi[to++]);
                  return lc;
                }
                function Lc(qi) {
                  return function() {
                    var Rr = arguments;
                    switch (Rr.length) {
                      case 0:
                        return new qi();
                      case 1:
                        return new qi(Rr[0]);
                      case 2:
                        return new qi(Rr[0], Rr[1]);
                      case 3:
                        return new qi(Rr[0], Rr[1], Rr[2]);
                      case 4:
                        return new qi(Rr[0], Rr[1], Rr[2], Rr[3]);
                      case 5:
                        return new qi(Rr[0], Rr[1], Rr[2], Rr[3], Rr[4]);
                      case 6:
                        return new qi(Rr[0], Rr[1], Rr[2], Rr[3], Rr[4], Rr[5]);
                      case 7:
                        return new qi(Rr[0], Rr[1], Rr[2], Rr[3], Rr[4], Rr[5], Rr[6]);
                    }
                    var qr = Su(qi.prototype), Yi = qi.apply(qr, Rr);
                    return Yh(Yi) ? Yi : qr;
                  };
                }
                function Eh(qi, Rr, qr, Yi, to, is, Bl, zl, $c, Dh) {
                  var Sc = 128 & Rr, lc = 1 & Rr, Af = 2 & Rr, Cv = 24 & Rr, Mv = 512 & Rr, Qm = Af ? void 0 : Lc(qi);
                  return function Hg() {
                    for (var ih = arguments.length, Ou = Array(ih), ud = ih; ud--; )
                      Ou[ud] = arguments[ud];
                    if (Cv)
                      var Tv = vp(Hg), j0 = mi(Ou, Tv);
                    if (Yi && (Ou = Tf(Ou, Yi, to, Cv)), is && (Ou = Cu(Ou, is, Bl, Cv)), ih -= j0, Cv && ih < Dh) {
                      var Wg = Dr(Ou, Tv);
                      return B0(qi, Rr, Eh, Hg.placeholder, qr, Ou, Wg, zl, $c, Dh - ih);
                    }
                    var Ug = lc ? qr : this, G0 = Af ? Ug[qi] : qi;
                    return ih = Ou.length, zl ? Ou = z0(Ou, zl) : Mv && ih > 1 && Ou.reverse(), Sc && $c < ih && (Ou.length = $c), this && this !== Tt && this instanceof Hg && (G0 = Qm || Lc(G0)), G0.apply(Ug, Ou);
                  };
                }
                function B0(qi, Rr, qr, Yi, to, is, Bl, zl, $c, Dh) {
                  var Sc = 8 & Rr;
                  Rr |= Sc ? 32 : 64, 4 & (Rr &= ~(Sc ? 64 : 32)) || (Rr &= -4);
                  var lc = qr(qi, Rr, to, Sc ? is : void 0, Sc ? Bl : void 0, Sc ? void 0 : is, Sc ? void 0 : Bl, zl, $c, Dh);
                  return lc.placeholder = Yi, ws(lc, qi, Rr);
                }
                function qy(qi, Rr, qr, Yi, to, is, Bl, zl) {
                  var $c = 2 & Rr;
                  if (!$c && typeof qi != "function")
                    throw new TypeError("Expected a function");
                  var Dh = Yi ? Yi.length : 0;
                  if (Dh || (Rr &= -97, Yi = to = void 0), Bl = Bl === void 0 ? Bl : Ta(Jm(Bl), 0), zl = zl === void 0 ? zl : Jm(zl), Dh -= to ? to.length : 0, 64 & Rr) {
                    var Sc = Yi, lc = to;
                    Yi = to = void 0;
                  }
                  var Af = [qi, Rr, qr, Yi, to, Sc, lc, is, Bl, zl];
                  if (qi = Af[0], Rr = Af[1], qr = Af[2], Yi = Af[3], to = Af[4], !(zl = Af[9] = Af[9] == null ? $c ? 0 : qi.length : Ta(Af[9] - Dh, 0)) && 24 & Rr && (Rr &= -25), Rr && Rr != 1)
                    Cv = Rr == 8 || Rr == 16 ? function(Mv, Qm, Hg) {
                      var ih = Lc(Mv);
                      return function Ou() {
                        for (var ud = arguments.length, Tv = Array(ud), j0 = ud, Wg = vp(Ou); j0--; )
                          Tv[j0] = arguments[j0];
                        var Ug = ud < 3 && Tv[0] !== Wg && Tv[ud - 1] !== Wg ? [] : Dr(Tv, Wg);
                        if ((ud -= Ug.length) < Hg)
                          return B0(Mv, Qm, Eh, Ou.placeholder, void 0, Tv, Ug, void 0, void 0, Hg - ud);
                        var G0 = this && this !== Tt && this instanceof Ou ? ih : Mv;
                        return Ar(G0, this, Tv);
                      };
                    }(qi, Rr, zl) : Rr != 32 && Rr != 33 || to.length ? Eh.apply(void 0, Af) : function(Mv, Qm, Hg, ih) {
                      var Ou = 1 & Qm, ud = Lc(Mv);
                      return function Tv() {
                        for (var j0 = -1, Wg = arguments.length, Ug = -1, G0 = ih.length, Sx = Array(G0 + Wg), Cx = this && this !== Tt && this instanceof Tv ? ud : Mv; ++Ug < G0; )
                          Sx[Ug] = ih[Ug];
                        for (; Wg--; )
                          Sx[Ug++] = arguments[++j0];
                        return Ar(Cx, Ou ? Hg : this, Sx);
                      };
                    }(qi, Rr, qr, Yi);
                  else
                    var Cv = function(Mv, Qm, Hg) {
                      var ih = 1 & Qm, Ou = Lc(Mv);
                      return function ud() {
                        var Tv = this && this !== Tt && this instanceof ud ? Ou : Mv;
                        return Tv.apply(ih ? Hg : this, arguments);
                      };
                    }(qi, Rr, qr);
                  return ws(Cv, qi, Rr);
                }
                function vp(qi) {
                  return qi.placeholder;
                }
                function Ap(qi, Rr) {
                  var qr = function(Yi, to) {
                    return Yi == null ? void 0 : Yi[to];
                  }(qi, Rr);
                  return hl(qr) ? qr : void 0;
                }
                function ig(qi) {
                  var Rr = qi.match(Pt);
                  return Rr ? Rr[1].split(tn) : [];
                }
                function $y(qi, Rr) {
                  var qr = Rr.length, Yi = qr - 1;
                  return Rr[Yi] = (qr > 1 ? "& " : "") + Rr[Yi], Rr = Rr.join(qr > 2 ? ", " : " "), qi.replace(Dt, `{
/* [wrapped with ` + Rr + `] */
`);
                }
                function Ed(qi, Rr) {
                  return !!(Rr = Rr == null ? 9007199254740991 : Rr) && (typeof qi == "number" || sr.test(qi)) && qi > -1 && qi % 1 == 0 && qi < Rr;
                }
                function z0(qi, Rr) {
                  for (var qr = qi.length, Yi = Ws(Rr.length, qr), to = function(Bl, zl) {
                    var $c = -1, Dh = Bl.length;
                    for (zl || (zl = Array(Dh)); ++$c < Dh; )
                      zl[$c] = Bl[$c];
                    return zl;
                  }(qi); Yi--; ) {
                    var is = Rr[Yi];
                    qi[Yi] = Ed(is, qr) ? to[is] : void 0;
                  }
                  return qi;
                }
                var ws = Uu ? function(qi, Rr, qr) {
                  var Yi, to = Rr + "";
                  return Uu(qi, "toString", { configurable: true, enumerable: false, value: (Yi = $y(to, ag(ig(to), qr)), function() {
                    return Yi;
                  }) });
                } : function(qi) {
                  return qi;
                };
                function ag(qi, Rr) {
                  return function(qr, Yi) {
                    for (var to = -1, is = qr ? qr.length : 0; ++to < is && Yi(qr[to], to, qr) !== false; )
                      ;
                  }(ft, function(qr) {
                    var Yi = "_." + qr[0];
                    Rr & qr[1] && !Vr(qi, Yi) && qi.push(Yi);
                  }), qi.sort();
                }
                function gp(qi, Rr, qr) {
                  var Yi = qy(qi, 8, void 0, void 0, void 0, void 0, void 0, Rr = qr ? void 0 : Rr);
                  return Yi.placeholder = gp.placeholder, Yi;
                }
                function Yh(qi) {
                  var Rr = typeof qi;
                  return !!qi && (Rr == "object" || Rr == "function");
                }
                function Ip(qi) {
                  return qi ? (qi = function(Rr) {
                    if (typeof Rr == "number")
                      return Rr;
                    if (function(to) {
                      return typeof to == "symbol" || function(is) {
                        return !!is && typeof is == "object";
                      }(to) && si.call(to) == "[object Symbol]";
                    }(Rr))
                      return NaN;
                    if (Yh(Rr)) {
                      var qr = typeof Rr.valueOf == "function" ? Rr.valueOf() : Rr;
                      Rr = Yh(qr) ? qr + "" : qr;
                    }
                    if (typeof Rr != "string")
                      return Rr === 0 ? Rr : +Rr;
                    Rr = Rr.replace(st, "");
                    var Yi = Un.test(Rr);
                    return Yi || nr.test(Rr) ? Ii(Rr.slice(2), Yi ? 2 : 8) : Fn.test(Rr) ? NaN : +Rr;
                  }(qi)) === 1 / 0 || qi === -1 / 0 ? 17976931348623157e292 * (qi < 0 ? -1 : 1) : qi == qi ? qi : 0 : qi === 0 ? qi : 0;
                }
                function Jm(qi) {
                  var Rr = Ip(qi), qr = Rr % 1;
                  return Rr == Rr ? qr ? Rr - qr : Rr : 0;
                }
                gp.placeholder = {}, Se.exports = gp;
              }).call(this, Re(43));
            }, function(Se, Ce, Re) {
              function at(Cu) {
                return Cu && Cu.__esModule ? Cu.default : Cu;
              }
              Ce.__esModule = true;
              var ft = Re(95);
              Ce.threezerotwofour = at(ft);
              var st = Re(96);
              Ce.apathy = at(st);
              var Dt = Re(97);
              Ce.ashes = at(Dt);
              var Pt = Re(98);
              Ce.atelierDune = at(Pt);
              var tn = Re(99);
              Ce.atelierForest = at(tn);
              var Fn = Re(100);
              Ce.atelierHeath = at(Fn);
              var Un = Re(101);
              Ce.atelierLakeside = at(Un);
              var qn = Re(102);
              Ce.atelierSeaside = at(qn);
              var nr = Re(103);
              Ce.bespin = at(nr);
              var sr = Re(104);
              Ce.brewer = at(sr);
              var Ii = Re(105);
              Ce.bright = at(Ii);
              var gi = Re(106);
              Ce.chalk = at(gi);
              var Sa = Re(107);
              Ce.codeschool = at(Sa);
              var Tt = Re(108);
              Ce.colors = at(Tt);
              var Ar = Re(109);
              Ce.default = at(Ar);
              var Vr = Re(110);
              Ce.eighties = at(Vr);
              var Si = Re(111);
              Ce.embers = at(Si);
              var mi = Re(112);
              Ce.flat = at(mi);
              var Dr = Re(113);
              Ce.google = at(Dr);
              var Gr = Re(114);
              Ce.grayscale = at(Gr);
              var Vi = Re(115);
              Ce.greenscreen = at(Vi);
              var ya = Re(116);
              Ce.harmonic = at(ya);
              var xr = Re(117);
              Ce.hopscotch = at(xr);
              var Ro = Re(118);
              Ce.isotope = at(Ro);
              var Oo = Re(119);
              Ce.marrakesh = at(Oo);
              var pi = Re(120);
              Ce.mocha = at(pi);
              var xs = Re(121);
              Ce.monokai = at(xs);
              var Ti = Re(122);
              Ce.ocean = at(Ti);
              var si = Re(123);
              Ce.paraiso = at(si);
              var ni = Re(124);
              Ce.pop = at(ni);
              var ja = Re(125);
              Ce.railscasts = at(ja);
              var Ta = Re(126);
              Ce.shapeshifter = at(Ta);
              var Ws = Re(127);
              Ce.solarized = at(Ws);
              var Uu = Re(128);
              Ce.summerfruit = at(Uu);
              var Su = Re(129);
              Ce.tomorrow = at(Su);
              var hl = Re(130);
              Ce.tube = at(hl);
              var Tf = Re(131);
              Ce.twilight = at(Tf);
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              Ce.__esModule = true, Ce.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, Se.exports = Ce.default;
            }, function(Se, Ce, Re) {
              var at = Re(33);
              function ft(st) {
                var Dt = Math.round(at(st, 0, 255)).toString(16);
                return Dt.length == 1 ? "0" + Dt : Dt;
              }
              Se.exports = function(st) {
                var Dt = st.length === 4 ? ft(255 * st[3]) : "";
                return "#" + ft(st[0]) + ft(st[1]) + ft(st[2]) + Dt;
              };
            }, function(Se, Ce, Re) {
              var at = Re(134), ft = Re(135), st = Re(136), Dt = Re(137), Pt = { "#": ft, hsl: function(Fn) {
                var Un = at(Fn), qn = Dt(Un);
                return Un.length === 4 && qn.push(Un[3]), qn;
              }, rgb: st };
              function tn(Fn) {
                for (var Un in Pt)
                  if (Fn.indexOf(Un) === 0)
                    return Pt[Un](Fn);
              }
              tn.rgb = st, tn.hsl = at, tn.hex = ft, Se.exports = tn;
            }, function(Se, Ce, Re) {
              var at = Re(44), ft = Re(33);
              function st(Dt, Pt) {
                switch (Dt = parseFloat(Dt), Pt) {
                  case 0:
                    return ft(Dt, 0, 360);
                  case 1:
                  case 2:
                    return ft(Dt, 0, 100);
                  case 3:
                    return ft(Dt, 0, 1);
                }
              }
              Se.exports = function(Dt) {
                return at(Dt).map(st);
              };
            }, function(Se, Ce) {
              Se.exports = function(Re) {
                Re.length !== 4 && Re.length !== 5 || (Re = function(st) {
                  for (var Dt = "#", Pt = 1; Pt < st.length; Pt++) {
                    var tn = st.charAt(Pt);
                    Dt += tn + tn;
                  }
                  return Dt;
                }(Re));
                var at = [parseInt(Re.substring(1, 3), 16), parseInt(Re.substring(3, 5), 16), parseInt(Re.substring(5, 7), 16)];
                if (Re.length === 9) {
                  var ft = parseFloat((parseInt(Re.substring(7, 9), 16) / 255).toFixed(2));
                  at.push(ft);
                }
                return at;
              };
            }, function(Se, Ce, Re) {
              var at = Re(44), ft = Re(33);
              function st(Dt, Pt) {
                return Pt < 3 ? Dt.indexOf("%") != -1 ? Math.round(255 * ft(parseInt(Dt, 10), 0, 100) / 100) : ft(parseInt(Dt, 10), 0, 255) : ft(parseFloat(Dt), 0, 1);
              }
              Se.exports = function(Dt) {
                return at(Dt).map(st);
              };
            }, function(Se, Ce) {
              Se.exports = function(Re) {
                var at, ft, st, Dt, Pt, tn = Re[0] / 360, Fn = Re[1] / 100, Un = Re[2] / 100;
                if (Fn == 0)
                  return [Pt = 255 * Un, Pt, Pt];
                at = 2 * Un - (ft = Un < 0.5 ? Un * (1 + Fn) : Un + Fn - Un * Fn), Dt = [0, 0, 0];
                for (var qn = 0; qn < 3; qn++)
                  (st = tn + 1 / 3 * -(qn - 1)) < 0 && st++, st > 1 && st--, Pt = 6 * st < 1 ? at + 6 * (ft - at) * st : 2 * st < 1 ? ft : 3 * st < 2 ? at + (ft - at) * (2 / 3 - st) * 6 : at, Dt[qn] = 255 * Pt;
                return Dt;
              };
            }, function(Se, Ce, Re) {
              (function(at) {
                var ft = typeof at == "object" && at && at.Object === Object && at, st = typeof self == "object" && self && self.Object === Object && self, Dt = ft || st || Function("return this")();
                function Pt(Dr, Gr, Vi) {
                  switch (Vi.length) {
                    case 0:
                      return Dr.call(Gr);
                    case 1:
                      return Dr.call(Gr, Vi[0]);
                    case 2:
                      return Dr.call(Gr, Vi[0], Vi[1]);
                    case 3:
                      return Dr.call(Gr, Vi[0], Vi[1], Vi[2]);
                  }
                  return Dr.apply(Gr, Vi);
                }
                function tn(Dr, Gr) {
                  for (var Vi = -1, ya = Gr.length, xr = Dr.length; ++Vi < ya; )
                    Dr[xr + Vi] = Gr[Vi];
                  return Dr;
                }
                var Fn = Object.prototype, Un = Fn.hasOwnProperty, qn = Fn.toString, nr = Dt.Symbol, sr = Fn.propertyIsEnumerable, Ii = nr ? nr.isConcatSpreadable : void 0, gi = Math.max;
                function Sa(Dr) {
                  return Tt(Dr) || function(Gr) {
                    return function(Vi) {
                      return function(ya) {
                        return !!ya && typeof ya == "object";
                      }(Vi) && function(ya) {
                        return ya != null && function(xr) {
                          return typeof xr == "number" && xr > -1 && xr % 1 == 0 && xr <= 9007199254740991;
                        }(ya.length) && !function(xr) {
                          var Ro = function(Oo) {
                            var pi = typeof Oo;
                            return !!Oo && (pi == "object" || pi == "function");
                          }(xr) ? qn.call(xr) : "";
                          return Ro == "[object Function]" || Ro == "[object GeneratorFunction]";
                        }(ya);
                      }(Vi);
                    }(Gr) && Un.call(Gr, "callee") && (!sr.call(Gr, "callee") || qn.call(Gr) == "[object Arguments]");
                  }(Dr) || !!(Ii && Dr && Dr[Ii]);
                }
                var Tt = Array.isArray, Ar, Vr, Si, mi = (Vr = function(Dr) {
                  var Gr = (Dr = function ya(xr, Ro, Oo, pi, xs) {
                    var Ti = -1, si = xr.length;
                    for (Oo || (Oo = Sa), xs || (xs = []); ++Ti < si; ) {
                      var ni = xr[Ti];
                      Ro > 0 && Oo(ni) ? Ro > 1 ? ya(ni, Ro - 1, Oo, pi, xs) : tn(xs, ni) : pi || (xs[xs.length] = ni);
                    }
                    return xs;
                  }(Dr, 1)).length, Vi = Gr;
                  for (Ar; Vi--; )
                    if (typeof Dr[Vi] != "function")
                      throw new TypeError("Expected a function");
                  return function() {
                    for (var ya = 0, xr = Gr ? Dr[ya].apply(this, arguments) : arguments[0]; ++ya < Gr; )
                      xr = Dr[ya].call(this, xr);
                    return xr;
                  };
                }, Si = gi(Si === void 0 ? Vr.length - 1 : Si, 0), function() {
                  for (var Dr = arguments, Gr = -1, Vi = gi(Dr.length - Si, 0), ya = Array(Vi); ++Gr < Vi; )
                    ya[Gr] = Dr[Si + Gr];
                  Gr = -1;
                  for (var xr = Array(Si + 1); ++Gr < Si; )
                    xr[Gr] = Dr[Gr];
                  return xr[Si] = ya, Pt(Vr, this, xr);
                });
                Se.exports = mi;
              }).call(this, Re(43));
            }, function(Se, Ce, Re) {
              Object.defineProperty(Ce, "__esModule", { value: true }), Ce.yuv2rgb = function(at) {
                var ft, st, Dt, Pt = at[0], tn = at[1], Fn = at[2];
                return ft = 1 * Pt + 0 * tn + 1.13983 * Fn, st = 1 * Pt + -0.39465 * tn + -0.5806 * Fn, Dt = 1 * Pt + 2.02311 * tn + 0 * Fn, ft = Math.min(Math.max(0, ft), 1), st = Math.min(Math.max(0, st), 1), Dt = Math.min(Math.max(0, Dt), 1), [255 * ft, 255 * st, 255 * Dt];
              }, Ce.rgb2yuv = function(at) {
                var ft = at[0] / 255, st = at[1] / 255, Dt = at[2] / 255;
                return [0.299 * ft + 0.587 * st + 0.114 * Dt, -0.14713 * ft + -0.28886 * st + 0.436 * Dt, 0.615 * ft + -0.51499 * st + -0.10001 * Dt];
              };
            }, function(Se, Ce, Re) {
              function at(Dt, Pt, tn) {
                return Pt in Dt ? Object.defineProperty(Dt, Pt, { value: tn, enumerable: true, configurable: true, writable: true }) : Dt[Pt] = tn, Dt;
              }
              var ft = Re(141), st = function() {
                function Dt() {
                  at(this, "_callbacks", void 0), at(this, "_isDispatching", void 0), at(this, "_isHandled", void 0), at(this, "_isPending", void 0), at(this, "_lastID", void 0), at(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
                }
                var Pt = Dt.prototype;
                return Pt.register = function(tn) {
                  var Fn = "ID_" + this._lastID++;
                  return this._callbacks[Fn] = tn, Fn;
                }, Pt.unregister = function(tn) {
                  this._callbacks[tn] || ft(false), delete this._callbacks[tn];
                }, Pt.waitFor = function(tn) {
                  this._isDispatching || ft(false);
                  for (var Fn = 0; Fn < tn.length; Fn++) {
                    var Un = tn[Fn];
                    this._isPending[Un] ? this._isHandled[Un] || ft(false) : (this._callbacks[Un] || ft(false), this._invokeCallback(Un));
                  }
                }, Pt.dispatch = function(tn) {
                  this._isDispatching && ft(false), this._startDispatching(tn);
                  try {
                    for (var Fn in this._callbacks)
                      this._isPending[Fn] || this._invokeCallback(Fn);
                  } finally {
                    this._stopDispatching();
                  }
                }, Pt.isDispatching = function() {
                  return this._isDispatching;
                }, Pt._invokeCallback = function(tn) {
                  this._isPending[tn] = true, this._callbacks[tn](this._pendingPayload), this._isHandled[tn] = true;
                }, Pt._startDispatching = function(tn) {
                  for (var Fn in this._callbacks)
                    this._isPending[Fn] = false, this._isHandled[Fn] = false;
                  this._pendingPayload = tn, this._isDispatching = true;
                }, Pt._stopDispatching = function() {
                  delete this._pendingPayload, this._isDispatching = false;
                }, Dt;
              }();
              Se.exports = st;
            }, function(Se, Ce, Re) {
              Se.exports = function(at, ft) {
                for (var st = arguments.length, Dt = new Array(st > 2 ? st - 2 : 0), Pt = 2; Pt < st; Pt++)
                  Dt[Pt - 2] = arguments[Pt];
                if (!at) {
                  var tn;
                  if (ft === void 0)
                    tn = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                  else {
                    var Fn = 0;
                    (tn = new Error(ft.replace(/%s/g, function() {
                      return String(Dt[Fn++]);
                    }))).name = "Invariant Violation";
                  }
                  throw tn.framesToPop = 1, tn;
                }
              };
            }, function(Se, Ce, Re) {
              function at(dn, Dn, Ot) {
                return Dn in dn ? Object.defineProperty(dn, Dn, { value: Ot, enumerable: true, configurable: true, writable: true }) : dn[Dn] = Ot, dn;
              }
              function ft(dn, Dn) {
                var Ot = Object.keys(dn);
                if (Object.getOwnPropertySymbols) {
                  var gn = Object.getOwnPropertySymbols(dn);
                  Dn && (gn = gn.filter(function(wn) {
                    return Object.getOwnPropertyDescriptor(dn, wn).enumerable;
                  })), Ot.push.apply(Ot, gn);
                }
                return Ot;
              }
              function st(dn) {
                for (var Dn = 1; Dn < arguments.length; Dn++) {
                  var Ot = arguments[Dn] != null ? arguments[Dn] : {};
                  Dn % 2 ? ft(Object(Ot), true).forEach(function(gn) {
                    at(dn, gn, Ot[gn]);
                  }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(dn, Object.getOwnPropertyDescriptors(Ot)) : ft(Object(Ot)).forEach(function(gn) {
                    Object.defineProperty(dn, gn, Object.getOwnPropertyDescriptor(Ot, gn));
                  });
                }
                return dn;
              }
              function Dt(dn, Dn) {
                if (!(dn instanceof Dn))
                  throw new TypeError("Cannot call a class as a function");
              }
              function Pt(dn, Dn) {
                for (var Ot = 0; Ot < Dn.length; Ot++) {
                  var gn = Dn[Ot];
                  gn.enumerable = gn.enumerable || false, gn.configurable = true, "value" in gn && (gn.writable = true), Object.defineProperty(dn, gn.key, gn);
                }
              }
              function tn(dn, Dn, Ot) {
                return Dn && Pt(dn.prototype, Dn), Ot && Pt(dn, Ot), dn;
              }
              function Fn(dn, Dn) {
                return (Fn = Object.setPrototypeOf || function(Ot, gn) {
                  return Ot.__proto__ = gn, Ot;
                })(dn, Dn);
              }
              function Un(dn, Dn) {
                if (typeof Dn != "function" && Dn !== null)
                  throw new TypeError("Super expression must either be null or a function");
                dn.prototype = Object.create(Dn && Dn.prototype, { constructor: { value: dn, writable: true, configurable: true } }), Dn && Fn(dn, Dn);
              }
              function qn(dn) {
                return (qn = Object.setPrototypeOf ? Object.getPrototypeOf : function(Dn) {
                  return Dn.__proto__ || Object.getPrototypeOf(Dn);
                })(dn);
              }
              function nr(dn) {
                return (nr = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Dn) {
                  return typeof Dn;
                } : function(Dn) {
                  return Dn && typeof Symbol == "function" && Dn.constructor === Symbol && Dn !== Symbol.prototype ? "symbol" : typeof Dn;
                })(dn);
              }
              function sr(dn) {
                if (dn === void 0)
                  throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return dn;
              }
              function Ii(dn, Dn) {
                return !Dn || nr(Dn) !== "object" && typeof Dn != "function" ? sr(dn) : Dn;
              }
              function gi(dn) {
                var Dn = function() {
                  if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                    return false;
                  if (typeof Proxy == "function")
                    return true;
                  try {
                    return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                    })), true;
                  } catch {
                    return false;
                  }
                }();
                return function() {
                  var Ot, gn = qn(dn);
                  if (Dn) {
                    var wn = qn(this).constructor;
                    Ot = Reflect.construct(gn, arguments, wn);
                  } else
                    Ot = gn.apply(this, arguments);
                  return Ii(this, Ot);
                };
              }
              Re.r(Ce);
              var Sa = Re(0), Tt = Re.n(Sa);
              function Ar() {
                var dn = this.constructor.getDerivedStateFromProps(this.props, this.state);
                dn != null && this.setState(dn);
              }
              function Vr(dn) {
                this.setState(function(Dn) {
                  var Ot = this.constructor.getDerivedStateFromProps(dn, Dn);
                  return Ot != null ? Ot : null;
                }.bind(this));
              }
              function Si(dn, Dn) {
                try {
                  var Ot = this.props, gn = this.state;
                  this.props = dn, this.state = Dn, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Ot, gn);
                } finally {
                  this.props = Ot, this.state = gn;
                }
              }
              function mi(dn) {
                var Dn = dn.prototype;
                if (!Dn || !Dn.isReactComponent)
                  throw new Error("Can only polyfill class components");
                if (typeof dn.getDerivedStateFromProps != "function" && typeof Dn.getSnapshotBeforeUpdate != "function")
                  return dn;
                var Ot = null, gn = null, wn = null;
                if (typeof Dn.componentWillMount == "function" ? Ot = "componentWillMount" : typeof Dn.UNSAFE_componentWillMount == "function" && (Ot = "UNSAFE_componentWillMount"), typeof Dn.componentWillReceiveProps == "function" ? gn = "componentWillReceiveProps" : typeof Dn.UNSAFE_componentWillReceiveProps == "function" && (gn = "UNSAFE_componentWillReceiveProps"), typeof Dn.componentWillUpdate == "function" ? wn = "componentWillUpdate" : typeof Dn.UNSAFE_componentWillUpdate == "function" && (wn = "UNSAFE_componentWillUpdate"), Ot !== null || gn !== null || wn !== null) {
                  var Fr = dn.displayName || dn.name, Ri = typeof dn.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                  throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Fr + " uses " + Ri + " but also contains the following legacy lifecycles:" + (Ot !== null ? `
  ` + Ot : "") + (gn !== null ? `
  ` + gn : "") + (wn !== null ? `
  ` + wn : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
                }
                if (typeof dn.getDerivedStateFromProps == "function" && (Dn.componentWillMount = Ar, Dn.componentWillReceiveProps = Vr), typeof Dn.getSnapshotBeforeUpdate == "function") {
                  if (typeof Dn.componentDidUpdate != "function")
                    throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                  Dn.componentWillUpdate = Si;
                  var di = Dn.componentDidUpdate;
                  Dn.componentDidUpdate = function(ur, xa, Go) {
                    var ou = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : Go;
                    di.call(this, ur, xa, ou);
                  };
                }
                return dn;
              }
              function Dr(dn, Dn) {
                if (dn == null)
                  return {};
                var Ot, gn, wn = function(Ri, di) {
                  if (Ri == null)
                    return {};
                  var ur, xa, Go = {}, ou = Object.keys(Ri);
                  for (xa = 0; xa < ou.length; xa++)
                    ur = ou[xa], di.indexOf(ur) >= 0 || (Go[ur] = Ri[ur]);
                  return Go;
                }(dn, Dn);
                if (Object.getOwnPropertySymbols) {
                  var Fr = Object.getOwnPropertySymbols(dn);
                  for (gn = 0; gn < Fr.length; gn++)
                    Ot = Fr[gn], Dn.indexOf(Ot) >= 0 || Object.prototype.propertyIsEnumerable.call(dn, Ot) && (wn[Ot] = dn[Ot]);
                }
                return wn;
              }
              function Gr(dn) {
                var Dn = function(Ot) {
                  return {}.toString.call(Ot).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
                }(dn);
                return Dn === "number" && (Dn = isNaN(dn) ? "nan" : (0 | dn) != dn ? "float" : "integer"), Dn;
              }
              Ar.__suppressDeprecationWarning = true, Vr.__suppressDeprecationWarning = true, Si.__suppressDeprecationWarning = true;
              var Vi = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, ya = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, xr = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Ro = Re(45), Oo = function(dn) {
                var Dn = function(Ot) {
                  return { backgroundColor: Ot.base00, ellipsisColor: Ot.base09, braceColor: Ot.base07, expandedIcon: Ot.base0D, collapsedIcon: Ot.base0E, keyColor: Ot.base07, arrayKeyColor: Ot.base0C, objectSize: Ot.base04, copyToClipboard: Ot.base0F, copyToClipboardCheck: Ot.base0D, objectBorder: Ot.base02, dataTypes: { boolean: Ot.base0E, date: Ot.base0D, float: Ot.base0B, function: Ot.base0D, integer: Ot.base0F, string: Ot.base09, nan: Ot.base08, null: Ot.base0A, undefined: Ot.base05, regexp: Ot.base0A, background: Ot.base02 }, editVariable: { editIcon: Ot.base0E, cancelIcon: Ot.base09, removeIcon: Ot.base09, addIcon: Ot.base0E, checkIcon: Ot.base0E, background: Ot.base01, color: Ot.base0A, border: Ot.base07 }, addKeyModal: { background: Ot.base05, border: Ot.base04, color: Ot.base0A, labelColor: Ot.base01 }, validationFailure: { background: Ot.base09, iconColor: Ot.base01, fontColor: Ot.base01 } };
                }(dn);
                return { "app-container": { fontFamily: xr.globalFontFamily, cursor: xr.globalCursor, backgroundColor: Dn.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Dn.ellipsisColor, fontSize: xr.ellipsisFontSize, lineHeight: xr.ellipsisLineHeight, cursor: xr.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: xr.braceCursor, fontWeight: xr.braceFontWeight, color: Dn.braceColor }, "expanded-icon": { color: Dn.expandedIcon }, "collapsed-icon": { color: Dn.collapsedIcon }, colon: { display: "inline-block", margin: xr.keyMargin, color: Dn.keyColor, verticalAlign: "top" }, objectKeyVal: function(Ot, gn) {
                  return { style: st({ paddingTop: xr.keyValPaddingTop, paddingRight: xr.keyValPaddingRight, paddingBottom: xr.keyValPaddingBottom, borderLeft: xr.keyValBorderLeft + " " + Dn.objectBorder, ":hover": { paddingLeft: gn.paddingLeft - 1 + "px", borderLeft: xr.keyValBorderHover + " " + Dn.objectBorder } }, gn) };
                }, "object-key-val-no-border": { padding: xr.keyValPadding }, "pushed-content": { marginLeft: xr.pushedContentMarginLeft }, variableValue: function(Ot, gn) {
                  return { style: st({ display: "inline-block", paddingRight: xr.variableValuePaddingRight, position: "relative" }, gn) };
                }, "object-name": { display: "inline-block", color: Dn.keyColor, letterSpacing: xr.keyLetterSpacing, fontStyle: xr.keyFontStyle, verticalAlign: xr.keyVerticalAlign, opacity: xr.keyOpacity, ":hover": { opacity: xr.keyOpacityHover } }, "array-key": { display: "inline-block", color: Dn.arrayKeyColor, letterSpacing: xr.keyLetterSpacing, fontStyle: xr.keyFontStyle, verticalAlign: xr.keyVerticalAlign, opacity: xr.keyOpacity, ":hover": { opacity: xr.keyOpacityHover } }, "object-size": { color: Dn.objectSize, borderRadius: xr.objectSizeBorderRadius, fontStyle: xr.objectSizeFontStyle, margin: xr.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: xr.dataTypeFontSize, marginRight: xr.dataTypeMarginRight, opacity: xr.datatypeOpacity }, boolean: { display: "inline-block", color: Dn.dataTypes.boolean }, date: { display: "inline-block", color: Dn.dataTypes.date }, "date-value": { marginLeft: xr.dateValueMarginLeft }, float: { display: "inline-block", color: Dn.dataTypes.float }, function: { display: "inline-block", color: Dn.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Dn.dataTypes.integer }, string: { display: "inline-block", color: Dn.dataTypes.string }, nan: { display: "inline-block", color: Dn.dataTypes.nan, fontSize: xr.nanFontSize, fontWeight: xr.nanFontWeight, backgroundColor: Dn.dataTypes.background, padding: xr.nanPadding, borderRadius: xr.nanBorderRadius }, null: { display: "inline-block", color: Dn.dataTypes.null, fontSize: xr.nullFontSize, fontWeight: xr.nullFontWeight, backgroundColor: Dn.dataTypes.background, padding: xr.nullPadding, borderRadius: xr.nullBorderRadius }, undefined: { display: "inline-block", color: Dn.dataTypes.undefined, fontSize: xr.undefinedFontSize, padding: xr.undefinedPadding, borderRadius: xr.undefinedBorderRadius, backgroundColor: Dn.dataTypes.background }, regexp: { display: "inline-block", color: Dn.dataTypes.regexp }, "copy-to-clipboard": { cursor: xr.clipboardCursor }, "copy-icon": { color: Dn.copyToClipboard, fontSize: xr.iconFontSize, marginRight: xr.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Dn.copyToClipboardCheck, marginLeft: xr.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: xr.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: xr.metaDataPadding }, "icon-container": { display: "inline-block", width: xr.iconContainerWidth }, tooltip: { padding: xr.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Dn.editVariable.removeIcon, cursor: xr.iconCursor, fontSize: xr.iconFontSize, marginRight: xr.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Dn.editVariable.addIcon, cursor: xr.iconCursor, fontSize: xr.iconFontSize, marginRight: xr.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Dn.editVariable.editIcon, cursor: xr.iconCursor, fontSize: xr.iconFontSize, marginRight: xr.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: xr.iconCursor, color: Dn.editVariable.checkIcon, fontSize: xr.iconFontSize, paddingRight: xr.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: xr.iconCursor, color: Dn.editVariable.cancelIcon, fontSize: xr.iconFontSize, paddingRight: xr.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: xr.editInputMinWidth, borderRadius: xr.editInputBorderRadius, backgroundColor: Dn.editVariable.background, color: Dn.editVariable.color, padding: xr.editInputPadding, marginRight: xr.editInputMarginRight, fontFamily: xr.editInputFontFamily }, "detected-row": { paddingTop: xr.detectedRowPaddingTop }, "key-modal-request": { position: xr.addKeyCoverPosition, top: xr.addKeyCoverPositionPx, left: xr.addKeyCoverPositionPx, right: xr.addKeyCoverPositionPx, bottom: xr.addKeyCoverPositionPx, backgroundColor: xr.addKeyCoverBackground }, "key-modal": { width: xr.addKeyModalWidth, backgroundColor: Dn.addKeyModal.background, marginLeft: xr.addKeyModalMargin, marginRight: xr.addKeyModalMargin, padding: xr.addKeyModalPadding, borderRadius: xr.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Dn.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Dn.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Dn.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Dn.addKeyModal.labelColor, fontSize: xr.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Dn.editVariable.addIcon, fontSize: xr.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Dn.ellipsisColor, fontSize: xr.ellipsisFontSize, lineHeight: xr.ellipsisLineHeight, cursor: xr.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Dn.validationFailure.fontColor, backgroundColor: Dn.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Dn.validationFailure.iconColor, fontSize: xr.iconFontSize, transform: "rotate(45deg)" } };
              };
              function pi(dn, Dn, Ot) {
                return dn || console.error("theme has not been set"), function(gn) {
                  var wn = Vi;
                  return gn !== false && gn !== "none" || (wn = ya), Object(Ro.createStyling)(Oo, { defaultBase16: wn })(gn);
                }(dn)(Dn, Ot);
              }
              var xs = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = (gn.rjvId, gn.type_name), Fr = gn.displayDataTypes, Ri = gn.theme;
                  return Fr ? Tt.a.createElement("span", Object.assign({ className: "data-type-label" }, pi(Ri, "data-type-label")), wn) : null;
                } }]), Ot;
              }(Tt.a.PureComponent), Ti = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props;
                  return Tt.a.createElement("div", pi(gn.theme, "boolean"), Tt.a.createElement(xs, Object.assign({ type_name: "bool" }, gn)), gn.value ? "true" : "false");
                } }]), Ot;
              }(Tt.a.PureComponent), si = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props;
                  return Tt.a.createElement("div", pi(gn.theme, "date"), Tt.a.createElement(xs, Object.assign({ type_name: "date" }, gn)), Tt.a.createElement("span", Object.assign({ className: "date-value" }, pi(gn.theme, "date-value")), gn.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
                } }]), Ot;
              }(Tt.a.PureComponent), ni = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props;
                  return Tt.a.createElement("div", pi(gn.theme, "float"), Tt.a.createElement(xs, Object.assign({ type_name: "float" }, gn)), this.props.value);
                } }]), Ot;
              }(Tt.a.PureComponent);
              function ja(dn, Dn) {
                (Dn == null || Dn > dn.length) && (Dn = dn.length);
                for (var Ot = 0, gn = new Array(Dn); Ot < Dn; Ot++)
                  gn[Ot] = dn[Ot];
                return gn;
              }
              function Ta(dn, Dn) {
                if (dn) {
                  if (typeof dn == "string")
                    return ja(dn, Dn);
                  var Ot = Object.prototype.toString.call(dn).slice(8, -1);
                  return Ot === "Object" && dn.constructor && (Ot = dn.constructor.name), Ot === "Map" || Ot === "Set" ? Array.from(dn) : Ot === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ot) ? ja(dn, Dn) : void 0;
                }
              }
              function Ws(dn, Dn) {
                var Ot;
                if (typeof Symbol == "undefined" || dn[Symbol.iterator] == null) {
                  if (Array.isArray(dn) || (Ot = Ta(dn)) || Dn && dn && typeof dn.length == "number") {
                    Ot && (dn = Ot);
                    var gn = 0, wn = function() {
                    };
                    return { s: wn, n: function() {
                      return gn >= dn.length ? { done: true } : { done: false, value: dn[gn++] };
                    }, e: function(ur) {
                      throw ur;
                    }, f: wn };
                  }
                  throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                }
                var Fr, Ri = true, di = false;
                return { s: function() {
                  Ot = dn[Symbol.iterator]();
                }, n: function() {
                  var ur = Ot.next();
                  return Ri = ur.done, ur;
                }, e: function(ur) {
                  di = true, Fr = ur;
                }, f: function() {
                  try {
                    Ri || Ot.return == null || Ot.return();
                  } finally {
                    if (di)
                      throw Fr;
                  }
                } };
              }
              function Uu(dn) {
                return function(Dn) {
                  if (Array.isArray(Dn))
                    return ja(Dn);
                }(dn) || function(Dn) {
                  if (typeof Symbol != "undefined" && Symbol.iterator in Object(Dn))
                    return Array.from(Dn);
                }(dn) || Ta(dn) || function() {
                  throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
                }();
              }
              var Su = Re(46), hl = new (Re(47)).Dispatcher(), Tf = new (function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  var gn;
                  Dt(this, Ot);
                  for (var wn = arguments.length, Fr = new Array(wn), Ri = 0; Ri < wn; Ri++)
                    Fr[Ri] = arguments[Ri];
                  return (gn = Dn.call.apply(Dn, [this].concat(Fr))).objects = {}, gn.set = function(di, ur, xa, Go) {
                    gn.objects[di] === void 0 && (gn.objects[di] = {}), gn.objects[di][ur] === void 0 && (gn.objects[di][ur] = {}), gn.objects[di][ur][xa] = Go;
                  }, gn.get = function(di, ur, xa, Go) {
                    return gn.objects[di] === void 0 || gn.objects[di][ur] === void 0 || gn.objects[di][ur][xa] == null ? Go : gn.objects[di][ur][xa];
                  }, gn.handleAction = function(di) {
                    var ur = di.rjvId, xa = di.data;
                    switch (di.name) {
                      case "RESET":
                        gn.emit("reset-" + ur);
                        break;
                      case "VARIABLE_UPDATED":
                        di.data.updated_src = gn.updateSrc(ur, xa), gn.set(ur, "action", "variable-update", st(st({}, xa), {}, { type: "variable-edited" })), gn.emit("variable-update-" + ur);
                        break;
                      case "VARIABLE_REMOVED":
                        di.data.updated_src = gn.updateSrc(ur, xa), gn.set(ur, "action", "variable-update", st(st({}, xa), {}, { type: "variable-removed" })), gn.emit("variable-update-" + ur);
                        break;
                      case "VARIABLE_ADDED":
                        di.data.updated_src = gn.updateSrc(ur, xa), gn.set(ur, "action", "variable-update", st(st({}, xa), {}, { type: "variable-added" })), gn.emit("variable-update-" + ur);
                        break;
                      case "ADD_VARIABLE_KEY_REQUEST":
                        gn.set(ur, "action", "new-key-request", xa), gn.emit("add-key-request-" + ur);
                    }
                  }, gn.updateSrc = function(di, ur) {
                    var xa = ur.name, Go = ur.namespace, ou = ur.new_value, Xl = (ur.existing_value, ur.variable_removed);
                    Go.shift();
                    var El, js = gn.get(di, "global", "src"), vf = gn.deepCopy(js, Uu(Go)), kh = vf, pl = Ws(Go);
                    try {
                      for (pl.s(); !(El = pl.n()).done; )
                        kh = kh[El.value];
                    } catch (Oh) {
                      pl.e(Oh);
                    } finally {
                      pl.f();
                    }
                    return Xl ? Gr(kh) == "array" ? kh.splice(xa, 1) : delete kh[xa] : xa !== null ? kh[xa] = ou : vf = ou, gn.set(di, "global", "src", vf), vf;
                  }, gn.deepCopy = function(di, ur) {
                    var xa, Go = Gr(di), ou = ur.shift();
                    return Go == "array" ? xa = Uu(di) : Go == "object" && (xa = st({}, di)), ou !== void 0 && (xa[ou] = gn.deepCopy(di[ou], ur)), xa;
                  }, gn;
                }
                return Ot;
              }(Su.EventEmitter))();
              hl.register(Tf.handleAction.bind(Tf));
              var Cu = Tf, Lc = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).toggleCollapsed = function() {
                    wn.setState({ collapsed: !wn.state.collapsed }, function() {
                      Cu.set(wn.props.rjvId, wn.props.namespace, "collapsed", wn.state.collapsed);
                    });
                  }, wn.getFunctionDisplay = function(Fr) {
                    var Ri = sr(wn).props;
                    return Fr ? Tt.a.createElement("span", null, wn.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), Tt.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, Tt.a.createElement("span", null, "{"), Tt.a.createElement("span", pi(Ri.theme, "ellipsis"), "..."), Tt.a.createElement("span", null, "}"))) : wn.props.value.toString().slice(9, -1);
                  }, wn.state = { collapsed: Cu.get(gn.rjvId, gn.namespace, "collapsed", true) }, wn;
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = this.state.collapsed;
                  return Tt.a.createElement("div", pi(gn.theme, "function"), Tt.a.createElement(xs, Object.assign({ type_name: "function" }, gn)), Tt.a.createElement("span", Object.assign({}, pi(gn.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(wn)));
                } }]), Ot;
              }(Tt.a.PureComponent), Eh = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  return Tt.a.createElement("div", pi(this.props.theme, "nan"), "NaN");
                } }]), Ot;
              }(Tt.a.PureComponent), B0 = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  return Tt.a.createElement("div", pi(this.props.theme, "null"), "NULL");
                } }]), Ot;
              }(Tt.a.PureComponent), qy = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props;
                  return Tt.a.createElement("div", pi(gn.theme, "integer"), Tt.a.createElement(xs, Object.assign({ type_name: "int" }, gn)), this.props.value);
                } }]), Ot;
              }(Tt.a.PureComponent), vp = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props;
                  return Tt.a.createElement("div", pi(gn.theme, "regexp"), Tt.a.createElement(xs, Object.assign({ type_name: "regexp" }, gn)), this.props.value.toString());
                } }]), Ot;
              }(Tt.a.PureComponent), Ap = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).toggleCollapsed = function() {
                    wn.setState({ collapsed: !wn.state.collapsed }, function() {
                      Cu.set(wn.props.rjvId, wn.props.namespace, "collapsed", wn.state.collapsed);
                    });
                  }, wn.state = { collapsed: Cu.get(gn.rjvId, gn.namespace, "collapsed", true) }, wn;
                }
                return tn(Ot, [{ key: "render", value: function() {
                  this.state.collapsed;
                  var gn = this.props, wn = gn.collapseStringsAfterLength, Fr = gn.theme, Ri = gn.value, di = { style: { cursor: "default" } };
                  return Gr(wn) === "integer" && Ri.length > wn && (di.style.cursor = "pointer", this.state.collapsed && (Ri = Tt.a.createElement("span", null, Ri.substring(0, wn), Tt.a.createElement("span", pi(Fr, "ellipsis"), " ...")))), Tt.a.createElement("div", pi(Fr, "string"), Tt.a.createElement(xs, Object.assign({ type_name: "string" }, gn)), Tt.a.createElement("span", Object.assign({ className: "string-value" }, di, { onClick: this.toggleCollapsed }), '"', Ri, '"'));
                } }]), Ot;
              }(Tt.a.PureComponent), ig = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  return Tt.a.createElement("div", pi(this.props.theme, "undefined"), "undefined");
                } }]), Ot;
              }(Tt.a.PureComponent);
              function $y() {
                return ($y = Object.assign || function(dn) {
                  for (var Dn = 1; Dn < arguments.length; Dn++) {
                    var Ot = arguments[Dn];
                    for (var gn in Ot)
                      Object.prototype.hasOwnProperty.call(Ot, gn) && (dn[gn] = Ot[gn]);
                  }
                  return dn;
                }).apply(this, arguments);
              }
              var Ed = Sa.useLayoutEffect, z0 = function(dn) {
                var Dn = Object(Sa.useRef)(dn);
                return Ed(function() {
                  Dn.current = dn;
                }), Dn;
              }, ws = function(dn, Dn) {
                typeof dn != "function" ? dn.current = Dn : dn(Dn);
              }, ag = function(dn, Dn) {
                var Ot = Object(Sa.useRef)();
                return Object(Sa.useCallback)(function(gn) {
                  dn.current = gn, Ot.current && ws(Ot.current, null), Ot.current = Dn, Dn && ws(Dn, gn);
                }, [Dn]);
              }, gp = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Yh = function(dn) {
                Object.keys(gp).forEach(function(Dn) {
                  dn.style.setProperty(Dn, gp[Dn], "important");
                });
              }, Ip = null, Jm = function() {
              }, qi = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Rr = !!document.documentElement.currentStyle, qr = function(dn, Dn) {
                var Ot = dn.cacheMeasurements, gn = dn.maxRows, wn = dn.minRows, Fr = dn.onChange, Ri = Fr === void 0 ? Jm : Fr, di = dn.onHeightChange, ur = di === void 0 ? Jm : di, xa = function(pl, Oh) {
                  if (pl == null)
                    return {};
                  var Av, ib, RS = {}, e1 = Object.keys(pl);
                  for (ib = 0; ib < e1.length; ib++)
                    Av = e1[ib], Oh.indexOf(Av) >= 0 || (RS[Av] = pl[Av]);
                  return RS;
                }(dn, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), Go, ou = xa.value !== void 0, Xl = Object(Sa.useRef)(null), El = ag(Xl, Dn), js = Object(Sa.useRef)(0), vf = Object(Sa.useRef)(), kh = function() {
                  var pl = Xl.current, Oh = Ot && vf.current ? vf.current : function(e1) {
                    var RC = window.getComputedStyle(e1);
                    if (RC === null)
                      return null;
                    var Tx, Dd = (Tx = RC, qi.reduce(function(kd, t_) {
                      return kd[t_] = Tx[t_], kd;
                    }, {})), ab = Dd.boxSizing;
                    return ab === "" ? null : (Rr && ab === "border-box" && (Dd.width = parseFloat(Dd.width) + parseFloat(Dd.borderRightWidth) + parseFloat(Dd.borderLeftWidth) + parseFloat(Dd.paddingRight) + parseFloat(Dd.paddingLeft) + "px"), { sizingStyle: Dd, paddingSize: parseFloat(Dd.paddingBottom) + parseFloat(Dd.paddingTop), borderSize: parseFloat(Dd.borderBottomWidth) + parseFloat(Dd.borderTopWidth) });
                  }(pl);
                  if (Oh) {
                    vf.current = Oh;
                    var Av = function(e1, RC, Tx, Dd) {
                      Tx === void 0 && (Tx = 1), Dd === void 0 && (Dd = 1 / 0), Ip || ((Ip = document.createElement("textarea")).setAttribute("tab-index", "-1"), Ip.setAttribute("aria-hidden", "true"), Yh(Ip)), Ip.parentNode === null && document.body.appendChild(Ip);
                      var ab = e1.paddingSize, kd = e1.borderSize, t_ = e1.sizingStyle, Ep = t_.boxSizing;
                      Object.keys(t_).forEach(function(Ix) {
                        var ev = Ix;
                        Ip.style[ev] = t_[ev];
                      }), Yh(Ip), Ip.value = RC;
                      var NC = function(Ix, ev) {
                        var sD = Ix.scrollHeight;
                        return ev.sizingStyle.boxSizing === "border-box" ? sD + ev.borderSize : sD - ev.paddingSize;
                      }(Ip, e1);
                      Ip.value = "x";
                      var oD = Ip.scrollHeight - ab, Xy = oD * Tx;
                      Ep === "border-box" && (Xy = Xy + ab + kd), NC = Math.max(Xy, NC);
                      var Ax = oD * Dd;
                      return Ep === "border-box" && (Ax = Ax + ab + kd), [NC = Math.min(Ax, NC), oD];
                    }(Oh, pl.value || pl.placeholder || "x", wn, gn), ib = Av[0], RS = Av[1];
                    js.current !== ib && (js.current = ib, pl.style.setProperty("height", ib + "px", "important"), ur(ib, { rowHeight: RS }));
                  }
                };
                return Object(Sa.useLayoutEffect)(kh), Go = z0(kh), Object(Sa.useLayoutEffect)(function() {
                  var pl = function(Oh) {
                    Go.current(Oh);
                  };
                  return window.addEventListener("resize", pl), function() {
                    window.removeEventListener("resize", pl);
                  };
                }, []), Object(Sa.createElement)("textarea", $y({}, xa, { onChange: function(pl) {
                  ou || kh(), Ri(pl);
                }, ref: El }));
              }, Yi = Object(Sa.forwardRef)(qr);
              function to(dn) {
                dn = dn.trim();
                try {
                  if ((dn = JSON.stringify(JSON.parse(dn)))[0] === "[")
                    return is("array", JSON.parse(dn));
                  if (dn[0] === "{")
                    return is("object", JSON.parse(dn));
                  if (dn.match(/\-?\d+\.\d+/) && dn.match(/\-?\d+\.\d+/)[0] === dn)
                    return is("float", parseFloat(dn));
                  if (dn.match(/\-?\d+e-\d+/) && dn.match(/\-?\d+e-\d+/)[0] === dn)
                    return is("float", Number(dn));
                  if (dn.match(/\-?\d+/) && dn.match(/\-?\d+/)[0] === dn)
                    return is("integer", parseInt(dn));
                  if (dn.match(/\-?\d+e\+\d+/) && dn.match(/\-?\d+e\+\d+/)[0] === dn)
                    return is("integer", Number(dn));
                } catch {
                }
                switch (dn = dn.toLowerCase()) {
                  case "undefined":
                    return is("undefined", void 0);
                  case "nan":
                    return is("nan", NaN);
                  case "null":
                    return is("null", null);
                  case "true":
                    return is("boolean", true);
                  case "false":
                    return is("boolean", false);
                  default:
                    if (dn = Date.parse(dn))
                      return is("date", new Date(dn));
                }
                return is(false, null);
              }
              function is(dn, Dn) {
                return { type: dn, value: Dn };
              }
              var Bl = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
                } }]), Ot;
              }(Tt.a.PureComponent), zl = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
                } }]), Ot;
              }(Tt.a.PureComponent), $c = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]), Ri = Ou(wn).style;
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", { fill: Ri.color, width: Ri.height, height: Ri.width, style: Ri, viewBox: "0 0 1792 1792" }, Tt.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                } }]), Ot;
              }(Tt.a.PureComponent), Dh = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]), Ri = Ou(wn).style;
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", { fill: Ri.color, width: Ri.height, height: Ri.width, style: Ri, viewBox: "0 0 1792 1792" }, Tt.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
                } }]), Ot;
              }(Tt.a.PureComponent), Sc = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", { style: st(st({}, Ou(wn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Tt.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
                } }]), Ot;
              }(Tt.a.PureComponent), lc = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", { style: st(st({}, Ou(wn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, Tt.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
                } }]), Ot;
              }(Tt.a.PureComponent), Af = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("g", null, Tt.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
                } }]), Ot;
              }(Tt.a.PureComponent), Cv = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("g", null, Tt.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), Ot;
              }(Tt.a.PureComponent), Mv = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("g", null, Tt.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), Ot;
              }(Tt.a.PureComponent), Qm = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("g", null, Tt.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
                } }]), Ot;
              }(Tt.a.PureComponent), Hg = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("g", null, Tt.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
                } }]), Ot;
              }(Tt.a.PureComponent), ih = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.style, Fr = Dr(gn, ["style"]);
                  return Tt.a.createElement("span", Fr, Tt.a.createElement("svg", Object.assign({}, Ou(wn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), Tt.a.createElement("g", null, Tt.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
                } }]), Ot;
              }(Tt.a.PureComponent);
              function Ou(dn) {
                return dn || (dn = {}), { style: st(st({ verticalAlign: "middle" }, dn), {}, { color: dn.color ? dn.color : "#000000", height: "1em", width: "1em" }) };
              }
              var ud = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).copiedTimer = null, wn.handleCopy = function() {
                    var Fr = document.createElement("textarea"), Ri = wn.props, di = Ri.clickCallback, ur = Ri.src, xa = Ri.namespace;
                    Fr.innerHTML = JSON.stringify(wn.clipboardValue(ur), null, "  "), document.body.appendChild(Fr), Fr.select(), document.execCommand("copy"), document.body.removeChild(Fr), wn.copiedTimer = setTimeout(function() {
                      wn.setState({ copied: false });
                    }, 5500), wn.setState({ copied: true }, function() {
                      typeof di == "function" && di({ src: ur, namespace: xa, name: xa[xa.length - 1] });
                    });
                  }, wn.getClippyIcon = function() {
                    var Fr = wn.props.theme;
                    return wn.state.copied ? Tt.a.createElement("span", null, Tt.a.createElement(Af, Object.assign({ className: "copy-icon" }, pi(Fr, "copy-icon"))), Tt.a.createElement("span", pi(Fr, "copy-icon-copied"), "\u2714")) : Tt.a.createElement(Af, Object.assign({ className: "copy-icon" }, pi(Fr, "copy-icon")));
                  }, wn.clipboardValue = function(Fr) {
                    switch (Gr(Fr)) {
                      case "function":
                      case "regexp":
                        return Fr.toString();
                      default:
                        return Fr;
                    }
                  }, wn.state = { copied: false }, wn;
                }
                return tn(Ot, [{ key: "componentWillUnmount", value: function() {
                  this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
                } }, { key: "render", value: function() {
                  var gn = this.props, wn = (gn.src, gn.theme), Fr = gn.hidden, Ri = gn.rowHovered, di = pi(wn, "copy-to-clipboard").style, ur = "inline";
                  return Fr && (ur = "none"), Tt.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Ri ? "inline-block" : "none" } }, Tt.a.createElement("span", { style: st(st({}, di), {}, { display: ur }), onClick: this.handleCopy }, this.getClippyIcon()));
                } }]), Ot;
              }(Tt.a.PureComponent), Tv = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).getEditIcon = function() {
                    var Fr = wn.props, Ri = Fr.variable, di = Fr.theme;
                    return Tt.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: wn.state.hovered ? "inline-block" : "none" } }, Tt.a.createElement(Hg, Object.assign({ className: "click-to-edit-icon" }, pi(di, "editVarIcon"), { onClick: function() {
                      wn.prepopInput(Ri);
                    } })));
                  }, wn.prepopInput = function(Fr) {
                    if (wn.props.onEdit !== false) {
                      var Ri = function(ur) {
                        var xa;
                        switch (Gr(ur)) {
                          case "undefined":
                            xa = "undefined";
                            break;
                          case "nan":
                            xa = "NaN";
                            break;
                          case "string":
                            xa = ur;
                            break;
                          case "date":
                          case "function":
                          case "regexp":
                            xa = ur.toString();
                            break;
                          default:
                            try {
                              xa = JSON.stringify(ur, null, "  ");
                            } catch {
                              xa = "";
                            }
                        }
                        return xa;
                      }(Fr.value), di = to(Ri);
                      wn.setState({ editMode: true, editValue: Ri, parsedInput: { type: di.type, value: di.value } });
                    }
                  }, wn.getRemoveIcon = function() {
                    var Fr = wn.props, Ri = Fr.variable, di = Fr.namespace, ur = Fr.theme, xa = Fr.rjvId;
                    return Tt.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: wn.state.hovered ? "inline-block" : "none" } }, Tt.a.createElement(Cv, Object.assign({ className: "click-to-remove-icon" }, pi(ur, "removeVarIcon"), { onClick: function() {
                      hl.dispatch({ name: "VARIABLE_REMOVED", rjvId: xa, data: { name: Ri.name, namespace: di, existing_value: Ri.value, variable_removed: true } });
                    } })));
                  }, wn.getValue = function(Fr, Ri) {
                    var di = !Ri && Fr.type, ur = sr(wn).props;
                    switch (di) {
                      case false:
                        return wn.getEditInput();
                      case "string":
                        return Tt.a.createElement(Ap, Object.assign({ value: Fr.value }, ur));
                      case "integer":
                        return Tt.a.createElement(qy, Object.assign({ value: Fr.value }, ur));
                      case "float":
                        return Tt.a.createElement(ni, Object.assign({ value: Fr.value }, ur));
                      case "boolean":
                        return Tt.a.createElement(Ti, Object.assign({ value: Fr.value }, ur));
                      case "function":
                        return Tt.a.createElement(Lc, Object.assign({ value: Fr.value }, ur));
                      case "null":
                        return Tt.a.createElement(B0, ur);
                      case "nan":
                        return Tt.a.createElement(Eh, ur);
                      case "undefined":
                        return Tt.a.createElement(ig, ur);
                      case "date":
                        return Tt.a.createElement(si, Object.assign({ value: Fr.value }, ur));
                      case "regexp":
                        return Tt.a.createElement(vp, Object.assign({ value: Fr.value }, ur));
                      default:
                        return Tt.a.createElement("div", { className: "object-value" }, JSON.stringify(Fr.value));
                    }
                  }, wn.getEditInput = function() {
                    var Fr = wn.props.theme, Ri = wn.state.editValue;
                    return Tt.a.createElement("div", null, Tt.a.createElement(Yi, Object.assign({ type: "text", inputRef: function(di) {
                      return di && di.focus();
                    }, value: Ri, className: "variable-editor", onChange: function(di) {
                      var ur = di.target.value, xa = to(ur);
                      wn.setState({ editValue: ur, parsedInput: { type: xa.type, value: xa.value } });
                    }, onKeyDown: function(di) {
                      switch (di.key) {
                        case "Escape":
                          wn.setState({ editMode: false, editValue: "" });
                          break;
                        case "Enter":
                          (di.ctrlKey || di.metaKey) && wn.submitEdit(true);
                      }
                      di.stopPropagation();
                    }, placeholder: "update this value", minRows: 2 }, pi(Fr, "edit-input"))), Tt.a.createElement("div", pi(Fr, "edit-icon-container"), Tt.a.createElement(Cv, Object.assign({ className: "edit-cancel" }, pi(Fr, "cancel-icon"), { onClick: function() {
                      wn.setState({ editMode: false, editValue: "" });
                    } })), Tt.a.createElement(ih, Object.assign({ className: "edit-check string-value" }, pi(Fr, "check-icon"), { onClick: function() {
                      wn.submitEdit();
                    } })), Tt.a.createElement("div", null, wn.showDetected())));
                  }, wn.submitEdit = function(Fr) {
                    var Ri = wn.props, di = Ri.variable, ur = Ri.namespace, xa = Ri.rjvId, Go = wn.state, ou = Go.editValue, Xl = Go.parsedInput, El = ou;
                    Fr && Xl.type && (El = Xl.value), wn.setState({ editMode: false }), hl.dispatch({ name: "VARIABLE_UPDATED", rjvId: xa, data: { name: di.name, namespace: ur, existing_value: di.value, new_value: El, variable_removed: false } });
                  }, wn.showDetected = function() {
                    var Fr = wn.props, Ri = Fr.theme, di = (Fr.variable, Fr.namespace, Fr.rjvId, wn.state.parsedInput), ur = (di.type, di.value, wn.getDetectedInput());
                    if (ur)
                      return Tt.a.createElement("div", null, Tt.a.createElement("div", pi(Ri, "detected-row"), ur, Tt.a.createElement(ih, { className: "edit-check detected", style: st({ verticalAlign: "top", paddingLeft: "3px" }, pi(Ri, "check-icon").style), onClick: function() {
                        wn.submitEdit(true);
                      } })));
                  }, wn.getDetectedInput = function() {
                    var Fr = wn.state.parsedInput, Ri = Fr.type, di = Fr.value, ur = sr(wn).props, xa = ur.theme;
                    if (Ri !== false)
                      switch (Ri.toLowerCase()) {
                        case "object":
                          return Tt.a.createElement("span", null, Tt.a.createElement("span", { style: st(st({}, pi(xa, "brace").style), {}, { cursor: "default" }) }, "{"), Tt.a.createElement("span", { style: st(st({}, pi(xa, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Tt.a.createElement("span", { style: st(st({}, pi(xa, "brace").style), {}, { cursor: "default" }) }, "}"));
                        case "array":
                          return Tt.a.createElement("span", null, Tt.a.createElement("span", { style: st(st({}, pi(xa, "brace").style), {}, { cursor: "default" }) }, "["), Tt.a.createElement("span", { style: st(st({}, pi(xa, "ellipsis").style), {}, { cursor: "default" }) }, "..."), Tt.a.createElement("span", { style: st(st({}, pi(xa, "brace").style), {}, { cursor: "default" }) }, "]"));
                        case "string":
                          return Tt.a.createElement(Ap, Object.assign({ value: di }, ur));
                        case "integer":
                          return Tt.a.createElement(qy, Object.assign({ value: di }, ur));
                        case "float":
                          return Tt.a.createElement(ni, Object.assign({ value: di }, ur));
                        case "boolean":
                          return Tt.a.createElement(Ti, Object.assign({ value: di }, ur));
                        case "function":
                          return Tt.a.createElement(Lc, Object.assign({ value: di }, ur));
                        case "null":
                          return Tt.a.createElement(B0, ur);
                        case "nan":
                          return Tt.a.createElement(Eh, ur);
                        case "undefined":
                          return Tt.a.createElement(ig, ur);
                        case "date":
                          return Tt.a.createElement(si, Object.assign({ value: new Date(di) }, ur));
                      }
                  }, wn.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, wn;
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this, wn = this.props, Fr = wn.variable, Ri = wn.singleIndent, di = wn.type, ur = wn.theme, xa = wn.namespace, Go = wn.indentWidth, ou = wn.enableClipboard, Xl = wn.onEdit, El = wn.onDelete, js = wn.onSelect, vf = wn.displayArrayKey, kh = wn.quotesOnKeys, pl = this.state.editMode;
                  return Tt.a.createElement("div", Object.assign({}, pi(ur, "objectKeyVal", { paddingLeft: Go * Ri }), { onMouseEnter: function() {
                    return gn.setState(st(st({}, gn.state), {}, { hovered: true }));
                  }, onMouseLeave: function() {
                    return gn.setState(st(st({}, gn.state), {}, { hovered: false }));
                  }, className: "variable-row", key: Fr.name }), di == "array" ? vf ? Tt.a.createElement("span", Object.assign({}, pi(ur, "array-key"), { key: Fr.name + "_" + xa }), Fr.name, Tt.a.createElement("div", pi(ur, "colon"), ":")) : null : Tt.a.createElement("span", null, Tt.a.createElement("span", Object.assign({}, pi(ur, "object-name"), { className: "object-key", key: Fr.name + "_" + xa }), !!kh && Tt.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Tt.a.createElement("span", { style: { display: "inline-block" } }, Fr.name), !!kh && Tt.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Tt.a.createElement("span", pi(ur, "colon"), ":")), Tt.a.createElement("div", Object.assign({ className: "variable-value", onClick: js === false && Xl === false ? null : function(Oh) {
                    var Av = Uu(xa);
                    (Oh.ctrlKey || Oh.metaKey) && Xl !== false ? gn.prepopInput(Fr) : js !== false && (Av.shift(), js(st(st({}, Fr), {}, { namespace: Av })));
                  } }, pi(ur, "variableValue", { cursor: js === false ? "default" : "pointer" })), this.getValue(Fr, pl)), ou ? Tt.a.createElement(ud, { rowHovered: this.state.hovered, hidden: pl, src: Fr.value, clickCallback: ou, theme: ur, namespace: [].concat(Uu(xa), [Fr.name]) }) : null, Xl !== false && pl == 0 ? this.getEditIcon() : null, El !== false && pl == 0 ? this.getRemoveIcon() : null);
                } }]), Ot;
              }(Tt.a.PureComponent), j0 = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  var gn;
                  Dt(this, Ot);
                  for (var wn = arguments.length, Fr = new Array(wn), Ri = 0; Ri < wn; Ri++)
                    Fr[Ri] = arguments[Ri];
                  return (gn = Dn.call.apply(Dn, [this].concat(Fr))).getObjectSize = function() {
                    var di = gn.props, ur = di.size, xa = di.theme;
                    if (di.displayObjectSize)
                      return Tt.a.createElement("span", Object.assign({ className: "object-size" }, pi(xa, "object-size")), ur, " item", ur === 1 ? "" : "s");
                  }, gn.getAddAttribute = function(di) {
                    var ur = gn.props, xa = ur.theme, Go = ur.namespace, ou = ur.name, Xl = ur.src, El = ur.rjvId, js = ur.depth;
                    return Tt.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: di ? "inline-block" : "none" } }, Tt.a.createElement(Mv, Object.assign({ className: "click-to-add-icon" }, pi(xa, "addVarIcon"), { onClick: function() {
                      var vf = { name: js > 0 ? ou : null, namespace: Go.splice(0, Go.length - 1), existing_value: Xl, variable_removed: false, key_name: null };
                      Gr(Xl) === "object" ? hl.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: El, data: vf }) : hl.dispatch({ name: "VARIABLE_ADDED", rjvId: El, data: st(st({}, vf), {}, { new_value: [].concat(Uu(Xl), [null]) }) });
                    } })));
                  }, gn.getRemoveObject = function(di) {
                    var ur = gn.props, xa = ur.theme, Go = (ur.hover, ur.namespace), ou = ur.name, Xl = ur.src, El = ur.rjvId;
                    if (Go.length !== 1)
                      return Tt.a.createElement("span", { className: "click-to-remove", style: { display: di ? "inline-block" : "none" } }, Tt.a.createElement(Cv, Object.assign({ className: "click-to-remove-icon" }, pi(xa, "removeVarIcon"), { onClick: function() {
                        hl.dispatch({ name: "VARIABLE_REMOVED", rjvId: El, data: { name: ou, namespace: Go.splice(0, Go.length - 1), existing_value: Xl, variable_removed: true } });
                      } })));
                  }, gn.render = function() {
                    var di = gn.props, ur = di.theme, xa = di.onDelete, Go = di.onAdd, ou = di.enableClipboard, Xl = di.src, El = di.namespace, js = di.rowHovered;
                    return Tt.a.createElement("div", Object.assign({}, pi(ur, "object-meta-data"), { className: "object-meta-data", onClick: function(vf) {
                      vf.stopPropagation();
                    } }), gn.getObjectSize(), ou ? Tt.a.createElement(ud, { rowHovered: js, clickCallback: ou, src: Xl, theme: ur, namespace: El }) : null, Go !== false ? gn.getAddAttribute(js) : null, xa !== false ? gn.getRemoveObject(js) : null);
                  }, gn;
                }
                return Ot;
              }(Tt.a.PureComponent);
              function Wg(dn) {
                var Dn = dn.parent_type, Ot = dn.namespace, gn = dn.quotesOnKeys, wn = dn.theme, Fr = dn.jsvRoot, Ri = dn.name, di = dn.displayArrayKey, ur = dn.name ? dn.name : "";
                return !Fr || Ri !== false && Ri !== null ? Dn == "array" ? di ? Tt.a.createElement("span", Object.assign({}, pi(wn, "array-key"), { key: Ot }), Tt.a.createElement("span", { className: "array-key" }, ur), Tt.a.createElement("span", pi(wn, "colon"), ":")) : Tt.a.createElement("span", null) : Tt.a.createElement("span", Object.assign({}, pi(wn, "object-name"), { key: Ot }), Tt.a.createElement("span", { className: "object-key" }, gn && Tt.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), Tt.a.createElement("span", null, ur), gn && Tt.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), Tt.a.createElement("span", pi(wn, "colon"), ":")) : Tt.a.createElement("span", null);
              }
              function Ug(dn) {
                var Dn = dn.theme;
                switch (dn.iconStyle) {
                  case "triangle":
                    return Tt.a.createElement(lc, Object.assign({}, pi(Dn, "expanded-icon"), { className: "expanded-icon" }));
                  case "square":
                    return Tt.a.createElement($c, Object.assign({}, pi(Dn, "expanded-icon"), { className: "expanded-icon" }));
                  default:
                    return Tt.a.createElement(Bl, Object.assign({}, pi(Dn, "expanded-icon"), { className: "expanded-icon" }));
                }
              }
              function G0(dn) {
                var Dn = dn.theme;
                switch (dn.iconStyle) {
                  case "triangle":
                    return Tt.a.createElement(Sc, Object.assign({}, pi(Dn, "collapsed-icon"), { className: "collapsed-icon" }));
                  case "square":
                    return Tt.a.createElement(Dh, Object.assign({}, pi(Dn, "collapsed-icon"), { className: "collapsed-icon" }));
                  default:
                    return Tt.a.createElement(zl, Object.assign({}, pi(Dn, "collapsed-icon"), { className: "collapsed-icon" }));
                }
              }
              var Sx = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).toggleCollapsed = function(Fr) {
                    var Ri = [];
                    for (var di in wn.state.expanded)
                      Ri.push(wn.state.expanded[di]);
                    Ri[Fr] = !Ri[Fr], wn.setState({ expanded: Ri });
                  }, wn.state = { expanded: [] }, wn;
                }
                return tn(Ot, [{ key: "getExpandedIcon", value: function(gn) {
                  var wn = this.props, Fr = wn.theme, Ri = wn.iconStyle;
                  return this.state.expanded[gn] ? Tt.a.createElement(Ug, { theme: Fr, iconStyle: Ri }) : Tt.a.createElement(G0, { theme: Fr, iconStyle: Ri });
                } }, { key: "render", value: function() {
                  var gn = this, wn = this.props, Fr = wn.src, Ri = wn.groupArraysAfterLength, di = (wn.depth, wn.name), ur = wn.theme, xa = wn.jsvRoot, Go = wn.namespace, ou = (wn.parent_type, Dr(wn, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), Xl = 0, El = 5 * this.props.indentWidth;
                  xa || (Xl = 5 * this.props.indentWidth);
                  var js = Ri, vf = Math.ceil(Fr.length / js);
                  return Tt.a.createElement("div", Object.assign({ className: "object-key-val" }, pi(ur, xa ? "jsv-root" : "objectKeyVal", { paddingLeft: Xl })), Tt.a.createElement(Wg, this.props), Tt.a.createElement("span", null, Tt.a.createElement(j0, Object.assign({ size: Fr.length }, this.props))), Uu(Array(vf)).map(function(kh, pl) {
                    return Tt.a.createElement("div", Object.assign({ key: pl, className: "object-key-val array-group" }, pi(ur, "objectKeyVal", { marginLeft: 6, paddingLeft: El })), Tt.a.createElement("span", pi(ur, "brace-row"), Tt.a.createElement("div", Object.assign({ className: "icon-container" }, pi(ur, "icon-container"), { onClick: function(Oh) {
                      gn.toggleCollapsed(pl);
                    } }), gn.getExpandedIcon(pl)), gn.state.expanded[pl] ? Tt.a.createElement(Mx, Object.assign({ key: di + pl, depth: 0, name: false, collapsed: false, groupArraysAfterLength: js, index_offset: pl * js, src: Fr.slice(pl * js, pl * js + js), namespace: Go, type: "array", parent_type: "array_group", theme: ur }, ou)) : Tt.a.createElement("span", Object.assign({}, pi(ur, "brace"), { onClick: function(Oh) {
                      gn.toggleCollapsed(pl);
                    }, className: "array-group-brace" }), "[", Tt.a.createElement("div", Object.assign({}, pi(ur, "array-group-meta-data"), { className: "array-group-meta-data" }), Tt.a.createElement("span", Object.assign({ className: "object-size" }, pi(ur, "object-size")), pl * js, " - ", pl * js + js > Fr.length ? Fr.length : pl * js + js)), "]")));
                  }));
                } }]), Ot;
              }(Tt.a.PureComponent), Cx = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  Dt(this, Ot), (wn = Dn.call(this, gn)).toggleCollapsed = function() {
                    wn.setState({ expanded: !wn.state.expanded }, function() {
                      Cu.set(wn.props.rjvId, wn.props.namespace, "expanded", wn.state.expanded);
                    });
                  }, wn.getObjectContent = function(Ri, di, ur) {
                    return Tt.a.createElement("div", { className: "pushed-content object-container" }, Tt.a.createElement("div", Object.assign({ className: "object-content" }, pi(wn.props.theme, "pushed-content")), wn.renderObjectContents(di, ur)));
                  }, wn.getEllipsis = function() {
                    return wn.state.size === 0 ? null : Tt.a.createElement("div", Object.assign({}, pi(wn.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: wn.toggleCollapsed }), "...");
                  }, wn.getObjectMetaData = function(Ri) {
                    var di = wn.props, ur = (di.rjvId, di.theme, wn.state), xa = ur.size, Go = ur.hovered;
                    return Tt.a.createElement(j0, Object.assign({ rowHovered: Go, size: xa }, wn.props));
                  }, wn.renderObjectContents = function(Ri, di) {
                    var ur, xa = wn.props, Go = xa.depth, ou = xa.parent_type, Xl = xa.index_offset, El = xa.groupArraysAfterLength, js = xa.namespace, vf = wn.state.object_type, kh = [], pl = Object.keys(Ri || {});
                    return wn.props.sortKeys && vf !== "array" && (pl = pl.sort()), pl.forEach(function(Oh) {
                      if (ur = new iD(Oh, Ri[Oh]), ou === "array_group" && Xl && (ur.name = parseInt(ur.name) + Xl), Ri.hasOwnProperty(Oh))
                        if (ur.type === "object")
                          kh.push(Tt.a.createElement(Mx, Object.assign({ key: ur.name, depth: Go + 1, name: ur.name, src: ur.value, namespace: js.concat(ur.name), parent_type: vf }, di)));
                        else if (ur.type === "array") {
                          var Av = Mx;
                          El && ur.value.length > El && (Av = Sx), kh.push(Tt.a.createElement(Av, Object.assign({ key: ur.name, depth: Go + 1, name: ur.name, src: ur.value, namespace: js.concat(ur.name), type: "array", parent_type: vf }, di)));
                        } else
                          kh.push(Tt.a.createElement(Tv, Object.assign({ key: ur.name + "_" + js, variable: ur, singleIndent: 5, namespace: js, type: wn.props.type }, di)));
                    }), kh;
                  };
                  var Fr = Ot.getState(gn);
                  return wn.state = st(st({}, Fr), {}, { prevProps: {} }), wn;
                }
                return tn(Ot, [{ key: "getBraceStart", value: function(gn, wn) {
                  var Fr = this, Ri = this.props, di = Ri.src, ur = Ri.theme, xa = Ri.iconStyle;
                  if (Ri.parent_type === "array_group")
                    return Tt.a.createElement("span", null, Tt.a.createElement("span", pi(ur, "brace"), gn === "array" ? "[" : "{"), wn ? this.getObjectMetaData(di) : null);
                  var Go = wn ? Ug : G0;
                  return Tt.a.createElement("span", null, Tt.a.createElement("span", Object.assign({ onClick: function(ou) {
                    Fr.toggleCollapsed();
                  } }, pi(ur, "brace-row")), Tt.a.createElement("div", Object.assign({ className: "icon-container" }, pi(ur, "icon-container")), Tt.a.createElement(Go, { theme: ur, iconStyle: xa })), Tt.a.createElement(Wg, this.props), Tt.a.createElement("span", pi(ur, "brace"), gn === "array" ? "[" : "{")), wn ? this.getObjectMetaData(di) : null);
                } }, { key: "render", value: function() {
                  var gn = this, wn = this.props, Fr = wn.depth, Ri = wn.src, di = (wn.namespace, wn.name, wn.type, wn.parent_type), ur = wn.theme, xa = wn.jsvRoot, Go = wn.iconStyle, ou = Dr(wn, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), Xl = this.state, El = Xl.object_type, js = Xl.expanded, vf = {};
                  return xa || di === "array_group" ? di === "array_group" && (vf.borderLeft = 0, vf.display = "inline") : vf.paddingLeft = 5 * this.props.indentWidth, Tt.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                    return gn.setState(st(st({}, gn.state), {}, { hovered: true }));
                  }, onMouseLeave: function() {
                    return gn.setState(st(st({}, gn.state), {}, { hovered: false }));
                  } }, pi(ur, xa ? "jsv-root" : "objectKeyVal", vf)), this.getBraceStart(El, js), js ? this.getObjectContent(Fr, Ri, st({ theme: ur, iconStyle: Go }, ou)) : this.getEllipsis(), Tt.a.createElement("span", { className: "brace-row" }, Tt.a.createElement("span", { style: st(st({}, pi(ur, "brace").style), {}, { paddingLeft: js ? "3px" : "0px" }) }, El === "array" ? "]" : "}"), js ? null : this.getObjectMetaData(Ri)));
                } }], [{ key: "getDerivedStateFromProps", value: function(gn, wn) {
                  var Fr = wn.prevProps;
                  return gn.src !== Fr.src || gn.collapsed !== Fr.collapsed || gn.name !== Fr.name || gn.namespace !== Fr.namespace || gn.rjvId !== Fr.rjvId ? st(st({}, Ot.getState(gn)), {}, { prevProps: gn }) : null;
                } }]), Ot;
              }(Tt.a.PureComponent);
              Cx.getState = function(dn) {
                var Dn = Object.keys(dn.src).length, Ot = (dn.collapsed === false || dn.collapsed !== true && dn.collapsed > dn.depth) && (!dn.shouldCollapse || dn.shouldCollapse({ name: dn.name, src: dn.src, type: Gr(dn.src), namespace: dn.namespace }) === false) && Dn !== 0;
                return { expanded: Cu.get(dn.rjvId, dn.namespace, "expanded", Ot), object_type: dn.type === "array" ? "array" : "object", parent_type: dn.type === "array" ? "array" : "object", size: Dn, hovered: false };
              };
              var iD = function dn(Dn, Ot) {
                Dt(this, dn), this.name = Dn, this.value = Ot, this.type = Gr(Ot);
              };
              mi(Cx);
              var Mx = Cx, LC = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  var gn;
                  Dt(this, Ot);
                  for (var wn = arguments.length, Fr = new Array(wn), Ri = 0; Ri < wn; Ri++)
                    Fr[Ri] = arguments[Ri];
                  return (gn = Dn.call.apply(Dn, [this].concat(Fr))).render = function() {
                    var di = sr(gn).props, ur = [di.name], xa = Mx;
                    return Array.isArray(di.src) && di.groupArraysAfterLength && di.src.length > di.groupArraysAfterLength && (xa = Sx), Tt.a.createElement("div", { className: "pretty-json-container object-container" }, Tt.a.createElement("div", { className: "object-content" }, Tt.a.createElement(xa, Object.assign({ namespace: ur, depth: 0, jsvRoot: true }, di))));
                  }, gn;
                }
                return Ot;
              }(Tt.a.PureComponent), aD = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).closeModal = function() {
                    hl.dispatch({ rjvId: wn.props.rjvId, name: "RESET" });
                  }, wn.submit = function() {
                    wn.props.submit(wn.state.input);
                  }, wn.state = { input: gn.input ? gn.input : "" }, wn;
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this, wn = this.props, Fr = wn.theme, Ri = wn.rjvId, di = wn.isValid, ur = this.state.input, xa = di(ur);
                  return Tt.a.createElement("div", Object.assign({ className: "key-modal-request" }, pi(Fr, "key-modal-request"), { onClick: this.closeModal }), Tt.a.createElement("div", Object.assign({}, pi(Fr, "key-modal"), { onClick: function(Go) {
                    Go.stopPropagation();
                  } }), Tt.a.createElement("div", pi(Fr, "key-modal-label"), "Key Name:"), Tt.a.createElement("div", { style: { position: "relative" } }, Tt.a.createElement("input", Object.assign({}, pi(Fr, "key-modal-input"), { className: "key-modal-input", ref: function(Go) {
                    return Go && Go.focus();
                  }, spellCheck: false, value: ur, placeholder: "...", onChange: function(Go) {
                    gn.setState({ input: Go.target.value });
                  }, onKeyPress: function(Go) {
                    xa && Go.key === "Enter" ? gn.submit() : Go.key === "Escape" && gn.closeModal();
                  } })), xa ? Tt.a.createElement(ih, Object.assign({}, pi(Fr, "key-modal-submit"), { className: "key-modal-submit", onClick: function(Go) {
                    return gn.submit();
                  } })) : null), Tt.a.createElement("span", pi(Fr, "key-modal-cancel"), Tt.a.createElement(Qm, Object.assign({}, pi(Fr, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                    hl.dispatch({ rjvId: Ri, name: "RESET" });
                  } })))));
                } }]), Ot;
              }(Tt.a.PureComponent), nA = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  var gn;
                  Dt(this, Ot);
                  for (var wn = arguments.length, Fr = new Array(wn), Ri = 0; Ri < wn; Ri++)
                    Fr[Ri] = arguments[Ri];
                  return (gn = Dn.call.apply(Dn, [this].concat(Fr))).isValid = function(di) {
                    var ur = gn.props.rjvId, xa = Cu.get(ur, "action", "new-key-request");
                    return di != "" && Object.keys(xa.existing_value).indexOf(di) === -1;
                  }, gn.submit = function(di) {
                    var ur = gn.props.rjvId, xa = Cu.get(ur, "action", "new-key-request");
                    xa.new_value = st({}, xa.existing_value), xa.new_value[di] = gn.props.defaultValue, hl.dispatch({ name: "VARIABLE_ADDED", rjvId: ur, data: xa });
                  }, gn;
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.active, Fr = gn.theme, Ri = gn.rjvId;
                  return wn ? Tt.a.createElement(aD, { rjvId: Ri, theme: Fr, isValid: this.isValid, submit: this.submit }) : null;
                } }]), Ot;
              }(Tt.a.PureComponent), L3 = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot() {
                  return Dt(this, Ot), Dn.apply(this, arguments);
                }
                return tn(Ot, [{ key: "render", value: function() {
                  var gn = this.props, wn = gn.message, Fr = gn.active, Ri = gn.theme, di = gn.rjvId;
                  return Fr ? Tt.a.createElement("div", Object.assign({ className: "validation-failure" }, pi(Ri, "validation-failure"), { onClick: function() {
                    hl.dispatch({ rjvId: di, name: "RESET" });
                  } }), Tt.a.createElement("span", pi(Ri, "validation-failure-label"), wn), Tt.a.createElement(Qm, pi(Ri, "validation-failure-clear"))) : null;
                } }]), Ot;
              }(Tt.a.PureComponent), e_ = function(dn) {
                Un(Ot, dn);
                var Dn = gi(Ot);
                function Ot(gn) {
                  var wn;
                  return Dt(this, Ot), (wn = Dn.call(this, gn)).rjvId = Date.now().toString(), wn.getListeners = function() {
                    return { reset: wn.resetState, "variable-update": wn.updateSrc, "add-key-request": wn.addKeyRequest };
                  }, wn.updateSrc = function() {
                    var Fr, Ri = Cu.get(wn.rjvId, "action", "variable-update"), di = Ri.name, ur = Ri.namespace, xa = Ri.new_value, Go = Ri.existing_value, ou = (Ri.variable_removed, Ri.updated_src), Xl = Ri.type, El = wn.props, js = El.onEdit, vf = El.onDelete, kh = El.onAdd, pl = { existing_src: wn.state.src, new_value: xa, updated_src: ou, name: di, namespace: ur, existing_value: Go };
                    switch (Xl) {
                      case "variable-added":
                        Fr = kh(pl);
                        break;
                      case "variable-edited":
                        Fr = js(pl);
                        break;
                      case "variable-removed":
                        Fr = vf(pl);
                    }
                    Fr !== false ? (Cu.set(wn.rjvId, "global", "src", ou), wn.setState({ src: ou })) : wn.setState({ validationFailure: true });
                  }, wn.addKeyRequest = function() {
                    wn.setState({ addKeyRequest: true });
                  }, wn.resetState = function() {
                    wn.setState({ validationFailure: false, addKeyRequest: false });
                  }, wn.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Ot.defaultProps.src, name: Ot.defaultProps.name, theme: Ot.defaultProps.theme, validationMessage: Ot.defaultProps.validationMessage, prevSrc: Ot.defaultProps.src, prevName: Ot.defaultProps.name, prevTheme: Ot.defaultProps.theme }, wn;
                }
                return tn(Ot, [{ key: "componentDidMount", value: function() {
                  Cu.set(this.rjvId, "global", "src", this.state.src);
                  var gn = this.getListeners();
                  for (var wn in gn)
                    Cu.on(wn + "-" + this.rjvId, gn[wn]);
                  this.setState({ addKeyRequest: false, editKeyRequest: false });
                } }, { key: "componentDidUpdate", value: function(gn, wn) {
                  wn.addKeyRequest !== false && this.setState({ addKeyRequest: false }), wn.editKeyRequest !== false && this.setState({ editKeyRequest: false }), gn.src !== this.state.src && Cu.set(this.rjvId, "global", "src", this.state.src);
                } }, { key: "componentWillUnmount", value: function() {
                  var gn = this.getListeners();
                  for (var wn in gn)
                    Cu.removeListener(wn + "-" + this.rjvId, gn[wn]);
                } }, { key: "render", value: function() {
                  var gn = this.state, wn = gn.validationFailure, Fr = gn.validationMessage, Ri = gn.addKeyRequest, di = gn.theme, ur = gn.src, xa = gn.name, Go = this.props, ou = Go.style, Xl = Go.defaultValue;
                  return Tt.a.createElement("div", { className: "react-json-view", style: st(st({}, pi(di, "app-container").style), ou) }, Tt.a.createElement(L3, { message: Fr, active: wn, theme: di, rjvId: this.rjvId }), Tt.a.createElement(LC, Object.assign({}, this.props, { src: ur, name: xa, theme: di, type: Gr(ur), rjvId: this.rjvId })), Tt.a.createElement(nA, { active: Ri, theme: di, rjvId: this.rjvId, defaultValue: Xl }));
                } }], [{ key: "getDerivedStateFromProps", value: function(gn, wn) {
                  if (gn.src !== wn.prevSrc || gn.name !== wn.prevName || gn.theme !== wn.prevTheme) {
                    var Fr = { src: gn.src, name: gn.name, theme: gn.theme, validationMessage: gn.validationMessage, prevSrc: gn.src, prevName: gn.name, prevTheme: gn.theme };
                    return Ot.validateState(Fr);
                  }
                  return null;
                } }]), Ot;
              }(Tt.a.PureComponent);
              e_.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, e_.validateState = function(dn) {
                var Dn = {};
                return Gr(dn.theme) !== "object" || function(Ot) {
                  var gn = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                  if (Gr(Ot) === "object") {
                    for (var wn = 0; wn < gn.length; wn++)
                      if (!(gn[wn] in Ot))
                        return false;
                    return true;
                  }
                  return false;
                }(dn.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Dn.theme = "rjv-default"), Gr(dn.src) !== "object" && Gr(dn.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Dn.name = "ERROR", Dn.src = { message: "src property must be a valid json object" }), st(st({}, dn), Dn);
              }, mi(e_), Ce.default = e_;
            }]);
          });
        })(JV);
        var jle = ee(JV.exports);
        const _Y = ({ id: ye, title: Ge, chart: xe, option: Se }) => {
          const { tool: Ce } = Pn({}), Re = pe({ global: true }), [at, { set: ft }] = Xe(true);
          console.log("option", Se);
          const st = (Dt) => {
            const { updated_src: Pt } = Dt;
            xe == null || xe.setOption(Pt), Ce == null || Ce.add(ye, xe, Pt, Ge), Re.emit("list");
          };
          return yY("div", { children: [rD(DTe, { children: rD(Vle, { children: rD(bY, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (Dt) => {
            ft(!Dt);
          } }) }) }), rD("br", {}), Se && rD(jle, { src: Se, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: at, iconStyle: "triangle", enableClipboard: true, onEdit: st, onAdd: st, onDelete: st })] });
        };
        s.EchartTool = zle, s.ReactEchartsJson = _Y, s.useEchartsTool = Pn, s.useEventEmitter = pe;
      })(Een);
      const Den = () => {
        const s = _se({ global: true }), a = M.useRef(0), { tool: n6 } = jCe({});
        M.useState(false), M.useState("right");
        const [f6, d4] = M.useState([]), [y4, _] = M.useState();
        return s.useSubscription("list", () => {
          var S;
          n6 != null && n6.list().length && (_((S = n6 == null ? void 0 : n6.list()) == null ? void 0 : S[a.current]), d4(n6 == null ? void 0 : n6.list()));
        }), yV("div", { className: Ien.container, children: false });
      };
      var EQe = { exports: {} };
      (function(s, a) {
        (function(n6, f6) {
          s.exports = f6(L.default);
        })(bt, function(n6) {
          return function(f6) {
            var d4 = {};
            function y4(_) {
              if (d4[_])
                return d4[_].exports;
              var S = d4[_] = { i: _, l: false, exports: {} };
              return f6[_].call(S.exports, S, S.exports, y4), S.l = true, S.exports;
            }
            return y4.m = f6, y4.c = d4, y4.d = function(_, S, T) {
              y4.o(_, S) || Object.defineProperty(_, S, { enumerable: true, get: T });
            }, y4.r = function(_) {
              typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(_, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(_, "__esModule", { value: true });
            }, y4.t = function(_, S) {
              if (1 & S && (_ = y4(_)), 8 & S || 4 & S && typeof _ == "object" && _ && _.__esModule)
                return _;
              var T = /* @__PURE__ */ Object.create(null);
              if (y4.r(T), Object.defineProperty(T, "default", { enumerable: true, value: _ }), 2 & S && typeof _ != "string")
                for (var E in _)
                  y4.d(T, E, function(O) {
                    return _[O];
                  }.bind(null, E));
              return T;
            }, y4.n = function(_) {
              var S = _ && _.__esModule ? function() {
                return _.default;
              } : function() {
                return _;
              };
              return y4.d(S, "a", S), S;
            }, y4.o = function(_, S) {
              return Object.prototype.hasOwnProperty.call(_, S);
            }, y4.p = "", y4(y4.s = 48);
          }([function(f6, d4) {
            f6.exports = n6;
          }, function(f6, d4) {
            var y4 = f6.exports = { version: "2.6.12" };
            typeof __e == "number" && (__e = y4);
          }, function(f6, d4, y4) {
            var _ = y4(26)("wks"), S = y4(17), T = y4(3).Symbol, E = typeof T == "function";
            (f6.exports = function(O) {
              return _[O] || (_[O] = E && T[O] || (E ? T : S)("Symbol." + O));
            }).store = _;
          }, function(f6, d4) {
            var y4 = f6.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
            typeof __g == "number" && (__g = y4);
          }, function(f6, d4, y4) {
            f6.exports = !y4(8)(function() {
              return Object.defineProperty({}, "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(f6, d4) {
            var y4 = {}.hasOwnProperty;
            f6.exports = function(_, S) {
              return y4.call(_, S);
            };
          }, function(f6, d4, y4) {
            var _ = y4(7), S = y4(16);
            f6.exports = y4(4) ? function(T, E, O) {
              return _.f(T, E, S(1, O));
            } : function(T, E, O) {
              return T[E] = O, T;
            };
          }, function(f6, d4, y4) {
            var _ = y4(10), S = y4(35), T = y4(23), E = Object.defineProperty;
            d4.f = y4(4) ? Object.defineProperty : function(O, R, V) {
              if (_(O), R = T(R, true), _(V), S)
                try {
                  return E(O, R, V);
                } catch {
                }
              if ("get" in V || "set" in V)
                throw TypeError("Accessors not supported!");
              return "value" in V && (O[R] = V.value), O;
            };
          }, function(f6, d4) {
            f6.exports = function(y4) {
              try {
                return !!y4();
              } catch {
                return true;
              }
            };
          }, function(f6, d4, y4) {
            var _ = y4(40), S = y4(22);
            f6.exports = function(T) {
              return _(S(T));
            };
          }, function(f6, d4, y4) {
            var _ = y4(11);
            f6.exports = function(S) {
              if (!_(S))
                throw TypeError(S + " is not an object!");
              return S;
            };
          }, function(f6, d4) {
            f6.exports = function(y4) {
              return typeof y4 == "object" ? y4 !== null : typeof y4 == "function";
            };
          }, function(f6, d4) {
            f6.exports = {};
          }, function(f6, d4, y4) {
            var _ = y4(39), S = y4(27);
            f6.exports = Object.keys || function(T) {
              return _(T, S);
            };
          }, function(f6, d4) {
            f6.exports = true;
          }, function(f6, d4, y4) {
            var _ = y4(3), S = y4(1), T = y4(53), E = y4(6), O = y4(5), R = function(V, z3, H) {
              var Z, ee, oe, fe = V & R.F, _e = V & R.G, pe = V & R.S, Ve = V & R.P, Le = V & R.B, je = V & R.W, Xe = _e ? S : S[z3] || (S[z3] = {}), Ye = Xe.prototype, rt2 = _e ? _ : pe ? _[z3] : (_[z3] || {}).prototype;
              for (Z in _e && (H = z3), H)
                (ee = !fe && rt2 && rt2[Z] !== void 0) && O(Xe, Z) || (oe = ee ? rt2[Z] : H[Z], Xe[Z] = _e && typeof rt2[Z] != "function" ? H[Z] : Le && ee ? T(oe, _) : je && rt2[Z] == oe ? function(ut) {
                  var wt = function(dt, Gt, Qt) {
                    if (this instanceof ut) {
                      switch (arguments.length) {
                        case 0:
                          return new ut();
                        case 1:
                          return new ut(dt);
                        case 2:
                          return new ut(dt, Gt);
                      }
                      return new ut(dt, Gt, Qt);
                    }
                    return ut.apply(this, arguments);
                  };
                  return wt.prototype = ut.prototype, wt;
                }(oe) : Ve && typeof oe == "function" ? T(Function.call, oe) : oe, Ve && ((Xe.virtual || (Xe.virtual = {}))[Z] = oe, V & R.R && Ye && !Ye[Z] && E(Ye, Z, oe)));
            };
            R.F = 1, R.G = 2, R.S = 4, R.P = 8, R.B = 16, R.W = 32, R.U = 64, R.R = 128, f6.exports = R;
          }, function(f6, d4) {
            f6.exports = function(y4, _) {
              return { enumerable: !(1 & y4), configurable: !(2 & y4), writable: !(4 & y4), value: _ };
            };
          }, function(f6, d4) {
            var y4 = 0, _ = Math.random();
            f6.exports = function(S) {
              return "Symbol(".concat(S === void 0 ? "" : S, ")_", (++y4 + _).toString(36));
            };
          }, function(f6, d4, y4) {
            var _ = y4(22);
            f6.exports = function(S) {
              return Object(_(S));
            };
          }, function(f6, d4) {
            d4.f = {}.propertyIsEnumerable;
          }, function(f6, d4, y4) {
            var _ = y4(52)(true);
            y4(34)(String, "String", function(S) {
              this._t = String(S), this._i = 0;
            }, function() {
              var S, T = this._t, E = this._i;
              return E >= T.length ? { value: void 0, done: true } : (S = _(T, E), this._i += S.length, { value: S, done: false });
            });
          }, function(f6, d4) {
            var y4 = Math.ceil, _ = Math.floor;
            f6.exports = function(S) {
              return isNaN(S = +S) ? 0 : (S > 0 ? _ : y4)(S);
            };
          }, function(f6, d4) {
            f6.exports = function(y4) {
              if (y4 == null)
                throw TypeError("Can't call method on  " + y4);
              return y4;
            };
          }, function(f6, d4, y4) {
            var _ = y4(11);
            f6.exports = function(S, T) {
              if (!_(S))
                return S;
              var E, O;
              if (T && typeof (E = S.toString) == "function" && !_(O = E.call(S)) || typeof (E = S.valueOf) == "function" && !_(O = E.call(S)) || !T && typeof (E = S.toString) == "function" && !_(O = E.call(S)))
                return O;
              throw TypeError("Can't convert object to primitive value");
            };
          }, function(f6, d4) {
            var y4 = {}.toString;
            f6.exports = function(_) {
              return y4.call(_).slice(8, -1);
            };
          }, function(f6, d4, y4) {
            var _ = y4(26)("keys"), S = y4(17);
            f6.exports = function(T) {
              return _[T] || (_[T] = S(T));
            };
          }, function(f6, d4, y4) {
            var _ = y4(1), S = y4(3), T = S["__core-js_shared__"] || (S["__core-js_shared__"] = {});
            (f6.exports = function(E, O) {
              return T[E] || (T[E] = O !== void 0 ? O : {});
            })("versions", []).push({ version: _.version, mode: y4(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
          }, function(f6, d4) {
            f6.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
          }, function(f6, d4, y4) {
            var _ = y4(7).f, S = y4(5), T = y4(2)("toStringTag");
            f6.exports = function(E, O, R) {
              E && !S(E = R ? E : E.prototype, T) && _(E, T, { configurable: true, value: O });
            };
          }, function(f6, d4, y4) {
            y4(62);
            for (var _ = y4(3), S = y4(6), T = y4(12), E = y4(2)("toStringTag"), O = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), R = 0; R < O.length; R++) {
              var V = O[R], z3 = _[V], H = z3 && z3.prototype;
              H && !H[E] && S(H, E, V), T[V] = T.Array;
            }
          }, function(f6, d4, y4) {
            d4.f = y4(2);
          }, function(f6, d4, y4) {
            var _ = y4(3), S = y4(1), T = y4(14), E = y4(30), O = y4(7).f;
            f6.exports = function(R) {
              var V = S.Symbol || (S.Symbol = T ? {} : _.Symbol || {});
              R.charAt(0) == "_" || R in V || O(V, R, { value: E.f(R) });
            };
          }, function(f6, d4) {
            d4.f = Object.getOwnPropertySymbols;
          }, function(f6, d4) {
            f6.exports = function(y4, _, S) {
              return Math.min(Math.max(y4, _), S);
            };
          }, function(f6, d4, y4) {
            var _ = y4(14), S = y4(15), T = y4(37), E = y4(6), O = y4(12), R = y4(55), V = y4(28), z3 = y4(61), H = y4(2)("iterator"), Z = !([].keys && "next" in [].keys()), ee = function() {
              return this;
            };
            f6.exports = function(oe, fe, _e, pe, Ve, Le, je) {
              R(_e, fe, pe);
              var Xe, Ye, rt2, ut = function(On) {
                if (!Z && On in Qt)
                  return Qt[On];
                switch (On) {
                  case "keys":
                  case "values":
                    return function() {
                      return new _e(this, On);
                    };
                }
                return function() {
                  return new _e(this, On);
                };
              }, wt = fe + " Iterator", dt = Ve == "values", Gt = false, Qt = oe.prototype, Nt = Qt[H] || Qt["@@iterator"] || Ve && Qt[Ve], er = Nt || ut(Ve), un = Ve ? dt ? ut("entries") : er : void 0, pn = fe == "Array" && Qt.entries || Nt;
              if (pn && (rt2 = z3(pn.call(new oe()))) !== Object.prototype && rt2.next && (V(rt2, wt, true), _ || typeof rt2[H] == "function" || E(rt2, H, ee)), dt && Nt && Nt.name !== "values" && (Gt = true, er = function() {
                return Nt.call(this);
              }), _ && !je || !Z && !Gt && Qt[H] || E(Qt, H, er), O[fe] = er, O[wt] = ee, Ve)
                if (Xe = { values: dt ? er : ut("values"), keys: Le ? er : ut("keys"), entries: un }, je)
                  for (Ye in Xe)
                    Ye in Qt || T(Qt, Ye, Xe[Ye]);
                else
                  S(S.P + S.F * (Z || Gt), fe, Xe);
              return Xe;
            };
          }, function(f6, d4, y4) {
            f6.exports = !y4(4) && !y4(8)(function() {
              return Object.defineProperty(y4(36)("div"), "a", { get: function() {
                return 7;
              } }).a != 7;
            });
          }, function(f6, d4, y4) {
            var _ = y4(11), S = y4(3).document, T = _(S) && _(S.createElement);
            f6.exports = function(E) {
              return T ? S.createElement(E) : {};
            };
          }, function(f6, d4, y4) {
            f6.exports = y4(6);
          }, function(f6, d4, y4) {
            var _ = y4(10), S = y4(56), T = y4(27), E = y4(25)("IE_PROTO"), O = function() {
            }, R = function() {
              var V, z3 = y4(36)("iframe"), H = T.length;
              for (z3.style.display = "none", y4(60).appendChild(z3), z3.src = "javascript:", (V = z3.contentWindow.document).open(), V.write("<script>document.F=Object<\/script>"), V.close(), R = V.F; H--; )
                delete R.prototype[T[H]];
              return R();
            };
            f6.exports = Object.create || function(V, z3) {
              var H;
              return V !== null ? (O.prototype = _(V), H = new O(), O.prototype = null, H[E] = V) : H = R(), z3 === void 0 ? H : S(H, z3);
            };
          }, function(f6, d4, y4) {
            var _ = y4(5), S = y4(9), T = y4(57)(false), E = y4(25)("IE_PROTO");
            f6.exports = function(O, R) {
              var V, z3 = S(O), H = 0, Z = [];
              for (V in z3)
                V != E && _(z3, V) && Z.push(V);
              for (; R.length > H; )
                _(z3, V = R[H++]) && (~T(Z, V) || Z.push(V));
              return Z;
            };
          }, function(f6, d4, y4) {
            var _ = y4(24);
            f6.exports = Object("z").propertyIsEnumerable(0) ? Object : function(S) {
              return _(S) == "String" ? S.split("") : Object(S);
            };
          }, function(f6, d4, y4) {
            var _ = y4(39), S = y4(27).concat("length", "prototype");
            d4.f = Object.getOwnPropertyNames || function(T) {
              return _(T, S);
            };
          }, function(f6, d4, y4) {
            var _ = y4(24), S = y4(2)("toStringTag"), T = _(function() {
              return arguments;
            }()) == "Arguments";
            f6.exports = function(E) {
              var O, R, V;
              return E === void 0 ? "Undefined" : E === null ? "Null" : typeof (R = function(z3, H) {
                try {
                  return z3[H];
                } catch {
                }
              }(O = Object(E), S)) == "string" ? R : T ? _(O) : (V = _(O)) == "Object" && typeof O.callee == "function" ? "Arguments" : V;
            };
          }, function(f6, d4) {
            var y4;
            y4 = function() {
              return this;
            }();
            try {
              y4 = y4 || new Function("return this")();
            } catch {
              typeof window == "object" && (y4 = window);
            }
            f6.exports = y4;
          }, function(f6, d4) {
            var y4 = /-?\d+(\.\d+)?%?/g;
            f6.exports = function(_) {
              return _.match(y4);
            };
          }, function(f6, d4, y4) {
            Object.defineProperty(d4, "__esModule", { value: true }), d4.getBase16Theme = d4.createStyling = d4.invertTheme = void 0;
            var _ = ee(y4(49)), S = ee(y4(76)), T = ee(y4(81)), E = ee(y4(89)), O = ee(y4(93)), R = function(Ye) {
              if (Ye && Ye.__esModule)
                return Ye;
              var rt2 = {};
              if (Ye != null)
                for (var ut in Ye)
                  Object.prototype.hasOwnProperty.call(Ye, ut) && (rt2[ut] = Ye[ut]);
              return rt2.default = Ye, rt2;
            }(y4(94)), V = ee(y4(132)), z3 = ee(y4(133)), H = ee(y4(138)), Z = y4(139);
            function ee(Ye) {
              return Ye && Ye.__esModule ? Ye : { default: Ye };
            }
            var oe = R.default, fe = (0, E.default)(oe), _e = (0, H.default)(z3.default, Z.rgb2yuv, function(Ye) {
              var rt2, ut = (0, T.default)(Ye, 3), wt = ut[0], dt = ut[1], Gt = ut[2];
              return [(rt2 = wt, rt2 < 0.25 ? 1 : rt2 < 0.5 ? 0.9 - rt2 : 1.1 - rt2), dt, Gt];
            }, Z.yuv2rgb, V.default), pe = function(Ye) {
              return function(rt2) {
                return { className: [rt2.className, Ye.className].filter(Boolean).join(" "), style: (0, S.default)({}, rt2.style || {}, Ye.style || {}) };
              };
            }, Ve = function(Ye, rt2) {
              var ut = (0, E.default)(rt2);
              for (var wt in Ye)
                ut.indexOf(wt) === -1 && ut.push(wt);
              return ut.reduce(function(dt, Gt) {
                return dt[Gt] = function(Qt, Nt) {
                  if (Qt === void 0)
                    return Nt;
                  if (Nt === void 0)
                    return Qt;
                  var er = Qt === void 0 ? "undefined" : (0, _.default)(Qt), un = Nt === void 0 ? "undefined" : (0, _.default)(Nt);
                  switch (er) {
                    case "string":
                      switch (un) {
                        case "string":
                          return [Nt, Qt].filter(Boolean).join(" ");
                        case "object":
                          return pe({ className: Qt, style: Nt });
                        case "function":
                          return function(pn) {
                            for (var On = arguments.length, fr = Array(On > 1 ? On - 1 : 0), yr = 1; yr < On; yr++)
                              fr[yr - 1] = arguments[yr];
                            return pe({ className: Qt })(Nt.apply(void 0, [pn].concat(fr)));
                          };
                      }
                    case "object":
                      switch (un) {
                        case "string":
                          return pe({ className: Nt, style: Qt });
                        case "object":
                          return (0, S.default)({}, Nt, Qt);
                        case "function":
                          return function(pn) {
                            for (var On = arguments.length, fr = Array(On > 1 ? On - 1 : 0), yr = 1; yr < On; yr++)
                              fr[yr - 1] = arguments[yr];
                            return pe({ style: Qt })(Nt.apply(void 0, [pn].concat(fr)));
                          };
                      }
                    case "function":
                      switch (un) {
                        case "string":
                          return function(pn) {
                            for (var On = arguments.length, fr = Array(On > 1 ? On - 1 : 0), yr = 1; yr < On; yr++)
                              fr[yr - 1] = arguments[yr];
                            return Qt.apply(void 0, [pe(pn)({ className: Nt })].concat(fr));
                          };
                        case "object":
                          return function(pn) {
                            for (var On = arguments.length, fr = Array(On > 1 ? On - 1 : 0), yr = 1; yr < On; yr++)
                              fr[yr - 1] = arguments[yr];
                            return Qt.apply(void 0, [pe(pn)({ style: Nt })].concat(fr));
                          };
                        case "function":
                          return function(pn) {
                            for (var On = arguments.length, fr = Array(On > 1 ? On - 1 : 0), yr = 1; yr < On; yr++)
                              fr[yr - 1] = arguments[yr];
                            return Qt.apply(void 0, [Nt.apply(void 0, [pn].concat(fr))].concat(fr));
                          };
                      }
                  }
                }(Ye[Gt], rt2[Gt]), dt;
              }, {});
            }, Le = function(Ye, rt2) {
              for (var ut = arguments.length, wt = Array(ut > 2 ? ut - 2 : 0), dt = 2; dt < ut; dt++)
                wt[dt - 2] = arguments[dt];
              if (rt2 === null)
                return Ye;
              Array.isArray(rt2) || (rt2 = [rt2]);
              var Gt = rt2.map(function(Nt) {
                return Ye[Nt];
              }).filter(Boolean), Qt = Gt.reduce(function(Nt, er) {
                return typeof er == "string" ? Nt.className = [Nt.className, er].filter(Boolean).join(" ") : (er === void 0 ? "undefined" : (0, _.default)(er)) === "object" ? Nt.style = (0, S.default)({}, Nt.style, er) : typeof er == "function" && (Nt = (0, S.default)({}, Nt, er.apply(void 0, [Nt].concat(wt)))), Nt;
              }, { className: "", style: {} });
              return Qt.className || delete Qt.className, (0, E.default)(Qt.style).length === 0 && delete Qt.style, Qt;
            }, je = d4.invertTheme = function(Ye) {
              return (0, E.default)(Ye).reduce(function(rt2, ut) {
                return rt2[ut] = /^base/.test(ut) ? _e(Ye[ut]) : ut === "scheme" ? Ye[ut] + ":inverted" : Ye[ut], rt2;
              }, {});
            }, Xe = (d4.createStyling = (0, O.default)(function(Ye) {
              for (var rt2 = arguments.length, ut = Array(rt2 > 3 ? rt2 - 3 : 0), wt = 3; wt < rt2; wt++)
                ut[wt - 3] = arguments[wt];
              var dt = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, Gt = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Qt = dt.defaultBase16, Nt = Qt === void 0 ? oe : Qt, er = dt.base16Themes, un = er === void 0 ? null : er, pn = Xe(Gt, un);
              pn && (Gt = (0, S.default)({}, pn, Gt));
              var On = fe.reduce(function(Ja, ko) {
                return Ja[ko] = Gt[ko] || Nt[ko], Ja;
              }, {}), fr = (0, E.default)(Gt).reduce(function(Ja, ko) {
                return fe.indexOf(ko) === -1 && (Ja[ko] = Gt[ko]), Ja;
              }, {}), yr = Ye(On), da = Ve(fr, yr);
              return (0, O.default)(Le, 2).apply(void 0, [da].concat(ut));
            }, 3), d4.getBase16Theme = function(Ye, rt2) {
              if (Ye && Ye.extend && (Ye = Ye.extend), typeof Ye == "string") {
                var ut = Ye.split(":"), wt = (0, T.default)(ut, 2), dt = wt[0], Gt = wt[1];
                Ye = (rt2 || {})[dt] || R[dt], Gt === "inverted" && (Ye = je(Ye));
              }
              return Ye && Ye.hasOwnProperty("base00") ? Ye : void 0;
            });
          }, function(f6, d4, y4) {
            var _, S = typeof Reflect == "object" ? Reflect : null, T = S && typeof S.apply == "function" ? S.apply : function(pe, Ve, Le) {
              return Function.prototype.apply.call(pe, Ve, Le);
            };
            _ = S && typeof S.ownKeys == "function" ? S.ownKeys : Object.getOwnPropertySymbols ? function(pe) {
              return Object.getOwnPropertyNames(pe).concat(Object.getOwnPropertySymbols(pe));
            } : function(pe) {
              return Object.getOwnPropertyNames(pe);
            };
            var E = Number.isNaN || function(pe) {
              return pe != pe;
            };
            function O() {
              O.init.call(this);
            }
            f6.exports = O, f6.exports.once = function(pe, Ve) {
              return new Promise(function(Le, je) {
                function Xe() {
                  Ye !== void 0 && pe.removeListener("error", Ye), Le([].slice.call(arguments));
                }
                var Ye;
                Ve !== "error" && (Ye = function(rt2) {
                  pe.removeListener(Ve, Xe), je(rt2);
                }, pe.once("error", Ye)), pe.once(Ve, Xe);
              });
            }, O.EventEmitter = O, O.prototype._events = void 0, O.prototype._eventsCount = 0, O.prototype._maxListeners = void 0;
            var R = 10;
            function V(pe) {
              if (typeof pe != "function")
                throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof pe);
            }
            function z3(pe) {
              return pe._maxListeners === void 0 ? O.defaultMaxListeners : pe._maxListeners;
            }
            function H(pe, Ve, Le, je) {
              var Xe, Ye, rt2, ut;
              if (V(Le), (Ye = pe._events) === void 0 ? (Ye = pe._events = /* @__PURE__ */ Object.create(null), pe._eventsCount = 0) : (Ye.newListener !== void 0 && (pe.emit("newListener", Ve, Le.listener ? Le.listener : Le), Ye = pe._events), rt2 = Ye[Ve]), rt2 === void 0)
                rt2 = Ye[Ve] = Le, ++pe._eventsCount;
              else if (typeof rt2 == "function" ? rt2 = Ye[Ve] = je ? [Le, rt2] : [rt2, Le] : je ? rt2.unshift(Le) : rt2.push(Le), (Xe = z3(pe)) > 0 && rt2.length > Xe && !rt2.warned) {
                rt2.warned = true;
                var wt = new Error("Possible EventEmitter memory leak detected. " + rt2.length + " " + String(Ve) + " listeners added. Use emitter.setMaxListeners() to increase limit");
                wt.name = "MaxListenersExceededWarning", wt.emitter = pe, wt.type = Ve, wt.count = rt2.length, ut = wt, console && console.warn && console.warn(ut);
              }
              return pe;
            }
            function Z() {
              if (!this.fired)
                return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
            }
            function ee(pe, Ve, Le) {
              var je = { fired: false, wrapFn: void 0, target: pe, type: Ve, listener: Le }, Xe = Z.bind(je);
              return Xe.listener = Le, je.wrapFn = Xe, Xe;
            }
            function oe(pe, Ve, Le) {
              var je = pe._events;
              if (je === void 0)
                return [];
              var Xe = je[Ve];
              return Xe === void 0 ? [] : typeof Xe == "function" ? Le ? [Xe.listener || Xe] : [Xe] : Le ? function(Ye) {
                for (var rt2 = new Array(Ye.length), ut = 0; ut < rt2.length; ++ut)
                  rt2[ut] = Ye[ut].listener || Ye[ut];
                return rt2;
              }(Xe) : _e(Xe, Xe.length);
            }
            function fe(pe) {
              var Ve = this._events;
              if (Ve !== void 0) {
                var Le = Ve[pe];
                if (typeof Le == "function")
                  return 1;
                if (Le !== void 0)
                  return Le.length;
              }
              return 0;
            }
            function _e(pe, Ve) {
              for (var Le = new Array(Ve), je = 0; je < Ve; ++je)
                Le[je] = pe[je];
              return Le;
            }
            Object.defineProperty(O, "defaultMaxListeners", { enumerable: true, get: function() {
              return R;
            }, set: function(pe) {
              if (typeof pe != "number" || pe < 0 || E(pe))
                throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + pe + ".");
              R = pe;
            } }), O.init = function() {
              this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
            }, O.prototype.setMaxListeners = function(pe) {
              if (typeof pe != "number" || pe < 0 || E(pe))
                throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + pe + ".");
              return this._maxListeners = pe, this;
            }, O.prototype.getMaxListeners = function() {
              return z3(this);
            }, O.prototype.emit = function(pe) {
              for (var Ve = [], Le = 1; Le < arguments.length; Le++)
                Ve.push(arguments[Le]);
              var je = pe === "error", Xe = this._events;
              if (Xe !== void 0)
                je = je && Xe.error === void 0;
              else if (!je)
                return false;
              if (je) {
                var Ye;
                if (Ve.length > 0 && (Ye = Ve[0]), Ye instanceof Error)
                  throw Ye;
                var rt2 = new Error("Unhandled error." + (Ye ? " (" + Ye.message + ")" : ""));
                throw rt2.context = Ye, rt2;
              }
              var ut = Xe[pe];
              if (ut === void 0)
                return false;
              if (typeof ut == "function")
                T(ut, this, Ve);
              else {
                var wt = ut.length, dt = _e(ut, wt);
                for (Le = 0; Le < wt; ++Le)
                  T(dt[Le], this, Ve);
              }
              return true;
            }, O.prototype.addListener = function(pe, Ve) {
              return H(this, pe, Ve, false);
            }, O.prototype.on = O.prototype.addListener, O.prototype.prependListener = function(pe, Ve) {
              return H(this, pe, Ve, true);
            }, O.prototype.once = function(pe, Ve) {
              return V(Ve), this.on(pe, ee(this, pe, Ve)), this;
            }, O.prototype.prependOnceListener = function(pe, Ve) {
              return V(Ve), this.prependListener(pe, ee(this, pe, Ve)), this;
            }, O.prototype.removeListener = function(pe, Ve) {
              var Le, je, Xe, Ye, rt2;
              if (V(Ve), (je = this._events) === void 0)
                return this;
              if ((Le = je[pe]) === void 0)
                return this;
              if (Le === Ve || Le.listener === Ve)
                --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete je[pe], je.removeListener && this.emit("removeListener", pe, Le.listener || Ve));
              else if (typeof Le != "function") {
                for (Xe = -1, Ye = Le.length - 1; Ye >= 0; Ye--)
                  if (Le[Ye] === Ve || Le[Ye].listener === Ve) {
                    rt2 = Le[Ye].listener, Xe = Ye;
                    break;
                  }
                if (Xe < 0)
                  return this;
                Xe === 0 ? Le.shift() : function(ut, wt) {
                  for (; wt + 1 < ut.length; wt++)
                    ut[wt] = ut[wt + 1];
                  ut.pop();
                }(Le, Xe), Le.length === 1 && (je[pe] = Le[0]), je.removeListener !== void 0 && this.emit("removeListener", pe, rt2 || Ve);
              }
              return this;
            }, O.prototype.off = O.prototype.removeListener, O.prototype.removeAllListeners = function(pe) {
              var Ve, Le, je;
              if ((Le = this._events) === void 0)
                return this;
              if (Le.removeListener === void 0)
                return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Le[pe] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Le[pe]), this;
              if (arguments.length === 0) {
                var Xe, Ye = Object.keys(Le);
                for (je = 0; je < Ye.length; ++je)
                  (Xe = Ye[je]) !== "removeListener" && this.removeAllListeners(Xe);
                return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
              }
              if (typeof (Ve = Le[pe]) == "function")
                this.removeListener(pe, Ve);
              else if (Ve !== void 0)
                for (je = Ve.length - 1; je >= 0; je--)
                  this.removeListener(pe, Ve[je]);
              return this;
            }, O.prototype.listeners = function(pe) {
              return oe(this, pe, true);
            }, O.prototype.rawListeners = function(pe) {
              return oe(this, pe, false);
            }, O.listenerCount = function(pe, Ve) {
              return typeof pe.listenerCount == "function" ? pe.listenerCount(Ve) : fe.call(pe, Ve);
            }, O.prototype.listenerCount = fe, O.prototype.eventNames = function() {
              return this._eventsCount > 0 ? _(this._events) : [];
            };
          }, function(f6, d4, y4) {
            f6.exports.Dispatcher = y4(140);
          }, function(f6, d4, y4) {
            f6.exports = y4(142);
          }, function(f6, d4, y4) {
            d4.__esModule = true;
            var _ = E(y4(50)), S = E(y4(65)), T = typeof S.default == "function" && typeof _.default == "symbol" ? function(O) {
              return typeof O;
            } : function(O) {
              return O && typeof S.default == "function" && O.constructor === S.default && O !== S.default.prototype ? "symbol" : typeof O;
            };
            function E(O) {
              return O && O.__esModule ? O : { default: O };
            }
            d4.default = typeof S.default == "function" && T(_.default) === "symbol" ? function(O) {
              return O === void 0 ? "undefined" : T(O);
            } : function(O) {
              return O && typeof S.default == "function" && O.constructor === S.default && O !== S.default.prototype ? "symbol" : O === void 0 ? "undefined" : T(O);
            };
          }, function(f6, d4, y4) {
            f6.exports = { default: y4(51), __esModule: true };
          }, function(f6, d4, y4) {
            y4(20), y4(29), f6.exports = y4(30).f("iterator");
          }, function(f6, d4, y4) {
            var _ = y4(21), S = y4(22);
            f6.exports = function(T) {
              return function(E, O) {
                var R, V, z3 = String(S(E)), H = _(O), Z = z3.length;
                return H < 0 || H >= Z ? T ? "" : void 0 : (R = z3.charCodeAt(H)) < 55296 || R > 56319 || H + 1 === Z || (V = z3.charCodeAt(H + 1)) < 56320 || V > 57343 ? T ? z3.charAt(H) : R : T ? z3.slice(H, H + 2) : V - 56320 + (R - 55296 << 10) + 65536;
              };
            };
          }, function(f6, d4, y4) {
            var _ = y4(54);
            f6.exports = function(S, T, E) {
              if (_(S), T === void 0)
                return S;
              switch (E) {
                case 1:
                  return function(O) {
                    return S.call(T, O);
                  };
                case 2:
                  return function(O, R) {
                    return S.call(T, O, R);
                  };
                case 3:
                  return function(O, R, V) {
                    return S.call(T, O, R, V);
                  };
              }
              return function() {
                return S.apply(T, arguments);
              };
            };
          }, function(f6, d4) {
            f6.exports = function(y4) {
              if (typeof y4 != "function")
                throw TypeError(y4 + " is not a function!");
              return y4;
            };
          }, function(f6, d4, y4) {
            var _ = y4(38), S = y4(16), T = y4(28), E = {};
            y4(6)(E, y4(2)("iterator"), function() {
              return this;
            }), f6.exports = function(O, R, V) {
              O.prototype = _(E, { next: S(1, V) }), T(O, R + " Iterator");
            };
          }, function(f6, d4, y4) {
            var _ = y4(7), S = y4(10), T = y4(13);
            f6.exports = y4(4) ? Object.defineProperties : function(E, O) {
              S(E);
              for (var R, V = T(O), z3 = V.length, H = 0; z3 > H; )
                _.f(E, R = V[H++], O[R]);
              return E;
            };
          }, function(f6, d4, y4) {
            var _ = y4(9), S = y4(58), T = y4(59);
            f6.exports = function(E) {
              return function(O, R, V) {
                var z3, H = _(O), Z = S(H.length), ee = T(V, Z);
                if (E && R != R) {
                  for (; Z > ee; )
                    if ((z3 = H[ee++]) != z3)
                      return true;
                } else
                  for (; Z > ee; ee++)
                    if ((E || ee in H) && H[ee] === R)
                      return E || ee || 0;
                return !E && -1;
              };
            };
          }, function(f6, d4, y4) {
            var _ = y4(21), S = Math.min;
            f6.exports = function(T) {
              return T > 0 ? S(_(T), 9007199254740991) : 0;
            };
          }, function(f6, d4, y4) {
            var _ = y4(21), S = Math.max, T = Math.min;
            f6.exports = function(E, O) {
              return (E = _(E)) < 0 ? S(E + O, 0) : T(E, O);
            };
          }, function(f6, d4, y4) {
            var _ = y4(3).document;
            f6.exports = _ && _.documentElement;
          }, function(f6, d4, y4) {
            var _ = y4(5), S = y4(18), T = y4(25)("IE_PROTO"), E = Object.prototype;
            f6.exports = Object.getPrototypeOf || function(O) {
              return O = S(O), _(O, T) ? O[T] : typeof O.constructor == "function" && O instanceof O.constructor ? O.constructor.prototype : O instanceof Object ? E : null;
            };
          }, function(f6, d4, y4) {
            var _ = y4(63), S = y4(64), T = y4(12), E = y4(9);
            f6.exports = y4(34)(Array, "Array", function(O, R) {
              this._t = E(O), this._i = 0, this._k = R;
            }, function() {
              var O = this._t, R = this._k, V = this._i++;
              return !O || V >= O.length ? (this._t = void 0, S(1)) : S(0, R == "keys" ? V : R == "values" ? O[V] : [V, O[V]]);
            }, "values"), T.Arguments = T.Array, _("keys"), _("values"), _("entries");
          }, function(f6, d4) {
            f6.exports = function() {
            };
          }, function(f6, d4) {
            f6.exports = function(y4, _) {
              return { value: _, done: !!y4 };
            };
          }, function(f6, d4, y4) {
            f6.exports = { default: y4(66), __esModule: true };
          }, function(f6, d4, y4) {
            y4(67), y4(73), y4(74), y4(75), f6.exports = y4(1).Symbol;
          }, function(f6, d4, y4) {
            var _ = y4(3), S = y4(5), T = y4(4), E = y4(15), O = y4(37), R = y4(68).KEY, V = y4(8), z3 = y4(26), H = y4(28), Z = y4(17), ee = y4(2), oe = y4(30), fe = y4(31), _e = y4(69), pe = y4(70), Ve = y4(10), Le = y4(11), je = y4(18), Xe = y4(9), Ye = y4(23), rt2 = y4(16), ut = y4(38), wt = y4(71), dt = y4(72), Gt = y4(32), Qt = y4(7), Nt = y4(13), er = dt.f, un = Qt.f, pn = wt.f, On = _.Symbol, fr = _.JSON, yr = fr && fr.stringify, da = ee("_hidden"), Ja = ee("toPrimitive"), ko = {}.propertyIsEnumerable, wo = z3("symbol-registry"), So = z3("symbols"), Fa = z3("op-symbols"), po = Object.prototype, To = typeof On == "function" && !!Gt.f, Ya = _.QObject, $o = !Ya || !Ya.prototype || !Ya.prototype.findChild, Hu = T && V(function() {
              return ut(un({}, "a", { get: function() {
                return un(this, "a", { value: 7 }).a;
              } })).a != 7;
            }) ? function(Yr, na, lo) {
              var hs = er(po, na);
              hs && delete po[na], un(Yr, na, lo), hs && Yr !== po && un(po, na, hs);
            } : un, ms = function(Yr) {
              var na = So[Yr] = ut(On.prototype);
              return na._k = Yr, na;
            }, sc = To && typeof On.iterator == "symbol" ? function(Yr) {
              return typeof Yr == "symbol";
            } : function(Yr) {
              return Yr instanceof On;
            }, Oc = function(Yr, na, lo) {
              return Yr === po && Oc(Fa, na, lo), Ve(Yr), na = Ye(na, true), Ve(lo), S(So, na) ? (lo.enumerable ? (S(Yr, da) && Yr[da][na] && (Yr[da][na] = false), lo = ut(lo, { enumerable: rt2(0, false) })) : (S(Yr, da) || un(Yr, da, rt2(1, {})), Yr[da][na] = true), Hu(Yr, na, lo)) : un(Yr, na, lo);
            }, _c2 = function(Yr, na) {
              Ve(Yr);
              for (var lo, hs = _e(na = Xe(na)), du = 0, au = hs.length; au > du; )
                Oc(Yr, lo = hs[du++], na[lo]);
              return Yr;
            }, _v = function(Yr) {
              var na = ko.call(this, Yr = Ye(Yr, true));
              return !(this === po && S(So, Yr) && !S(Fa, Yr)) && (!(na || !S(this, Yr) || !S(So, Yr) || S(this, da) && this[da][Yr]) || na);
            }, cp = function(Yr, na) {
              if (Yr = Xe(Yr), na = Ye(na, true), Yr !== po || !S(So, na) || S(Fa, na)) {
                var lo = er(Yr, na);
                return !lo || !S(So, na) || S(Yr, da) && Yr[da][na] || (lo.enumerable = true), lo;
              }
            }, Vg = function(Yr) {
              for (var na, lo = pn(Xe(Yr)), hs = [], du = 0; lo.length > du; )
                S(So, na = lo[du++]) || na == da || na == R || hs.push(na);
              return hs;
            }, rh = function(Yr) {
              for (var na, lo = Yr === po, hs = pn(lo ? Fa : Xe(Yr)), du = [], au = 0; hs.length > au; )
                !S(So, na = hs[au++]) || lo && !S(po, na) || du.push(So[na]);
              return du;
            };
            To || (O((On = function() {
              if (this instanceof On)
                throw TypeError("Symbol is not a constructor!");
              var Yr = Z(arguments.length > 0 ? arguments[0] : void 0), na = function(lo) {
                this === po && na.call(Fa, lo), S(this, da) && S(this[da], Yr) && (this[da][Yr] = false), Hu(this, Yr, rt2(1, lo));
              };
              return T && $o && Hu(po, Yr, { configurable: true, set: na }), ms(Yr);
            }).prototype, "toString", function() {
              return this._k;
            }), dt.f = cp, Qt.f = Oc, y4(41).f = wt.f = Vg, y4(19).f = _v, Gt.f = rh, T && !y4(14) && O(po, "propertyIsEnumerable", _v, true), oe.f = function(Yr) {
              return ms(ee(Yr));
            }), E(E.G + E.W + E.F * !To, { Symbol: On });
            for (var Mp = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), fp = 0; Mp.length > fp; )
              ee(Mp[fp++]);
            for (var vx = Nt(ee.store), ea = 0; vx.length > ea; )
              fe(vx[ea++]);
            E(E.S + E.F * !To, "Symbol", { for: function(Yr) {
              return S(wo, Yr += "") ? wo[Yr] : wo[Yr] = On(Yr);
            }, keyFor: function(Yr) {
              if (!sc(Yr))
                throw TypeError(Yr + " is not a symbol!");
              for (var na in wo)
                if (wo[na] === Yr)
                  return na;
            }, useSetter: function() {
              $o = true;
            }, useSimple: function() {
              $o = false;
            } }), E(E.S + E.F * !To, "Object", { create: function(Yr, na) {
              return na === void 0 ? ut(Yr) : _c2(ut(Yr), na);
            }, defineProperty: Oc, defineProperties: _c2, getOwnPropertyDescriptor: cp, getOwnPropertyNames: Vg, getOwnPropertySymbols: rh });
            var Qr = V(function() {
              Gt.f(1);
            });
            E(E.S + E.F * Qr, "Object", { getOwnPropertySymbols: function(Yr) {
              return Gt.f(je(Yr));
            } }), fr && E(E.S + E.F * (!To || V(function() {
              var Yr = On();
              return yr([Yr]) != "[null]" || yr({ a: Yr }) != "{}" || yr(Object(Yr)) != "{}";
            })), "JSON", { stringify: function(Yr) {
              for (var na, lo, hs = [Yr], du = 1; arguments.length > du; )
                hs.push(arguments[du++]);
              if (lo = na = hs[1], (Le(na) || Yr !== void 0) && !sc(Yr))
                return pe(na) || (na = function(au, pf) {
                  if (typeof lo == "function" && (pf = lo.call(this, au, pf)), !sc(pf))
                    return pf;
                }), hs[1] = na, yr.apply(fr, hs);
            } }), On.prototype[Ja] || y4(6)(On.prototype, Ja, On.prototype.valueOf), H(On, "Symbol"), H(Math, "Math", true), H(_.JSON, "JSON", true);
          }, function(f6, d4, y4) {
            var _ = y4(17)("meta"), S = y4(11), T = y4(5), E = y4(7).f, O = 0, R = Object.isExtensible || function() {
              return true;
            }, V = !y4(8)(function() {
              return R(Object.preventExtensions({}));
            }), z3 = function(Z) {
              E(Z, _, { value: { i: "O" + ++O, w: {} } });
            }, H = f6.exports = { KEY: _, NEED: false, fastKey: function(Z, ee) {
              if (!S(Z))
                return typeof Z == "symbol" ? Z : (typeof Z == "string" ? "S" : "P") + Z;
              if (!T(Z, _)) {
                if (!R(Z))
                  return "F";
                if (!ee)
                  return "E";
                z3(Z);
              }
              return Z[_].i;
            }, getWeak: function(Z, ee) {
              if (!T(Z, _)) {
                if (!R(Z))
                  return true;
                if (!ee)
                  return false;
                z3(Z);
              }
              return Z[_].w;
            }, onFreeze: function(Z) {
              return V && H.NEED && R(Z) && !T(Z, _) && z3(Z), Z;
            } };
          }, function(f6, d4, y4) {
            var _ = y4(13), S = y4(32), T = y4(19);
            f6.exports = function(E) {
              var O = _(E), R = S.f;
              if (R)
                for (var V, z3 = R(E), H = T.f, Z = 0; z3.length > Z; )
                  H.call(E, V = z3[Z++]) && O.push(V);
              return O;
            };
          }, function(f6, d4, y4) {
            var _ = y4(24);
            f6.exports = Array.isArray || function(S) {
              return _(S) == "Array";
            };
          }, function(f6, d4, y4) {
            var _ = y4(9), S = y4(41).f, T = {}.toString, E = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
            f6.exports.f = function(O) {
              return E && T.call(O) == "[object Window]" ? function(R) {
                try {
                  return S(R);
                } catch {
                  return E.slice();
                }
              }(O) : S(_(O));
            };
          }, function(f6, d4, y4) {
            var _ = y4(19), S = y4(16), T = y4(9), E = y4(23), O = y4(5), R = y4(35), V = Object.getOwnPropertyDescriptor;
            d4.f = y4(4) ? V : function(z3, H) {
              if (z3 = T(z3), H = E(H, true), R)
                try {
                  return V(z3, H);
                } catch {
                }
              if (O(z3, H))
                return S(!_.f.call(z3, H), z3[H]);
            };
          }, function(f6, d4) {
          }, function(f6, d4, y4) {
            y4(31)("asyncIterator");
          }, function(f6, d4, y4) {
            y4(31)("observable");
          }, function(f6, d4, y4) {
            d4.__esModule = true;
            var _, S = y4(77), T = (_ = S) && _.__esModule ? _ : { default: _ };
            d4.default = T.default || function(E) {
              for (var O = 1; O < arguments.length; O++) {
                var R = arguments[O];
                for (var V in R)
                  Object.prototype.hasOwnProperty.call(R, V) && (E[V] = R[V]);
              }
              return E;
            };
          }, function(f6, d4, y4) {
            f6.exports = { default: y4(78), __esModule: true };
          }, function(f6, d4, y4) {
            y4(79), f6.exports = y4(1).Object.assign;
          }, function(f6, d4, y4) {
            var _ = y4(15);
            _(_.S + _.F, "Object", { assign: y4(80) });
          }, function(f6, d4, y4) {
            var _ = y4(4), S = y4(13), T = y4(32), E = y4(19), O = y4(18), R = y4(40), V = Object.assign;
            f6.exports = !V || y4(8)(function() {
              var z3 = {}, H = {}, Z = Symbol(), ee = "abcdefghijklmnopqrst";
              return z3[Z] = 7, ee.split("").forEach(function(oe) {
                H[oe] = oe;
              }), V({}, z3)[Z] != 7 || Object.keys(V({}, H)).join("") != ee;
            }) ? function(z3, H) {
              for (var Z = O(z3), ee = arguments.length, oe = 1, fe = T.f, _e = E.f; ee > oe; )
                for (var pe, Ve = R(arguments[oe++]), Le = fe ? S(Ve).concat(fe(Ve)) : S(Ve), je = Le.length, Xe = 0; je > Xe; )
                  pe = Le[Xe++], _ && !_e.call(Ve, pe) || (Z[pe] = Ve[pe]);
              return Z;
            } : V;
          }, function(f6, d4, y4) {
            d4.__esModule = true;
            var _ = T(y4(82)), S = T(y4(85));
            function T(E) {
              return E && E.__esModule ? E : { default: E };
            }
            d4.default = function(E, O) {
              if (Array.isArray(E))
                return E;
              if ((0, _.default)(Object(E)))
                return function(R, V) {
                  var z3 = [], H = true, Z = false, ee = void 0;
                  try {
                    for (var oe, fe = (0, S.default)(R); !(H = (oe = fe.next()).done) && (z3.push(oe.value), !V || z3.length !== V); H = true)
                      ;
                  } catch (_e) {
                    Z = true, ee = _e;
                  } finally {
                    try {
                      !H && fe.return && fe.return();
                    } finally {
                      if (Z)
                        throw ee;
                    }
                  }
                  return z3;
                }(E, O);
              throw new TypeError("Invalid attempt to destructure non-iterable instance");
            };
          }, function(f6, d4, y4) {
            f6.exports = { default: y4(83), __esModule: true };
          }, function(f6, d4, y4) {
            y4(29), y4(20), f6.exports = y4(84);
          }, function(f6, d4, y4) {
            var _ = y4(42), S = y4(2)("iterator"), T = y4(12);
            f6.exports = y4(1).isIterable = function(E) {
              var O = Object(E);
              return O[S] !== void 0 || "@@iterator" in O || T.hasOwnProperty(_(O));
            };
          }, function(f6, d4, y4) {
            f6.exports = { default: y4(86), __esModule: true };
          }, function(f6, d4, y4) {
            y4(29), y4(20), f6.exports = y4(87);
          }, function(f6, d4, y4) {
            var _ = y4(10), S = y4(88);
            f6.exports = y4(1).getIterator = function(T) {
              var E = S(T);
              if (typeof E != "function")
                throw TypeError(T + " is not iterable!");
              return _(E.call(T));
            };
          }, function(f6, d4, y4) {
            var _ = y4(42), S = y4(2)("iterator"), T = y4(12);
            f6.exports = y4(1).getIteratorMethod = function(E) {
              if (E != null)
                return E[S] || E["@@iterator"] || T[_(E)];
            };
          }, function(f6, d4, y4) {
            f6.exports = { default: y4(90), __esModule: true };
          }, function(f6, d4, y4) {
            y4(91), f6.exports = y4(1).Object.keys;
          }, function(f6, d4, y4) {
            var _ = y4(18), S = y4(13);
            y4(92)("keys", function() {
              return function(T) {
                return S(_(T));
              };
            });
          }, function(f6, d4, y4) {
            var _ = y4(15), S = y4(1), T = y4(8);
            f6.exports = function(E, O) {
              var R = (S.Object || {})[E] || Object[E], V = {};
              V[E] = O(R), _(_.S + _.F * T(function() {
                R(1);
              }), "Object", V);
            };
          }, function(f6, d4, y4) {
            (function(_) {
              var S = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], T = /^\s+|\s+$/g, E = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, O = /\{\n\/\* \[wrapped with (.+)\] \*/, R = /,? & /, V = /^[-+]0x[0-9a-f]+$/i, z3 = /^0b[01]+$/i, H = /^\[object .+?Constructor\]$/, Z = /^0o[0-7]+$/i, ee = /^(?:0|[1-9]\d*)$/, oe = parseInt, fe = typeof _ == "object" && _ && _.Object === Object && _, _e = typeof self == "object" && self && self.Object === Object && self, pe = fe || _e || Function("return this")();
              function Ve(ea, Qr, Yr) {
                switch (Yr.length) {
                  case 0:
                    return ea.call(Qr);
                  case 1:
                    return ea.call(Qr, Yr[0]);
                  case 2:
                    return ea.call(Qr, Yr[0], Yr[1]);
                  case 3:
                    return ea.call(Qr, Yr[0], Yr[1], Yr[2]);
                }
                return ea.apply(Qr, Yr);
              }
              function Le(ea, Qr) {
                return !!(ea && ea.length) && function(Yr, na, lo) {
                  if (na != na)
                    return function(au, pf, hp, Ah) {
                      for (var Td = au.length, Ih = hp + (Ah ? 1 : -1); Ah ? Ih-- : ++Ih < Td; )
                        if (pf(au[Ih], Ih, au))
                          return Ih;
                      return -1;
                    }(Yr, je, lo);
                  for (var hs = lo - 1, du = Yr.length; ++hs < du; )
                    if (Yr[hs] === na)
                      return hs;
                  return -1;
                }(ea, Qr, 0) > -1;
              }
              function je(ea) {
                return ea != ea;
              }
              function Xe(ea, Qr) {
                for (var Yr = ea.length, na = 0; Yr--; )
                  ea[Yr] === Qr && na++;
                return na;
              }
              function Ye(ea, Qr) {
                for (var Yr = -1, na = ea.length, lo = 0, hs = []; ++Yr < na; ) {
                  var du = ea[Yr];
                  du !== Qr && du !== "__lodash_placeholder__" || (ea[Yr] = "__lodash_placeholder__", hs[lo++] = Yr);
                }
                return hs;
              }
              var rt2, ut, wt, dt = Function.prototype, Gt = Object.prototype, Qt = pe["__core-js_shared__"], Nt = (rt2 = /[^.]+$/.exec(Qt && Qt.keys && Qt.keys.IE_PROTO || "")) ? "Symbol(src)_1." + rt2 : "", er = dt.toString, un = Gt.hasOwnProperty, pn = Gt.toString, On = RegExp("^" + er.call(un).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), fr = Object.create, yr = Math.max, da = Math.min, Ja = (ut = ms(Object, "defineProperty"), (wt = ms.name) && wt.length > 2 ? ut : void 0);
              function ko(ea) {
                return Mp(ea) ? fr(ea) : {};
              }
              function wo(ea) {
                return !(!Mp(ea) || function(Qr) {
                  return !!Nt && Nt in Qr;
                }(ea)) && (function(Qr) {
                  var Yr = Mp(Qr) ? pn.call(Qr) : "";
                  return Yr == "[object Function]" || Yr == "[object GeneratorFunction]";
                }(ea) || function(Qr) {
                  var Yr = false;
                  if (Qr != null && typeof Qr.toString != "function")
                    try {
                      Yr = !!(Qr + "");
                    } catch {
                    }
                  return Yr;
                }(ea) ? On : H).test(function(Qr) {
                  if (Qr != null) {
                    try {
                      return er.call(Qr);
                    } catch {
                    }
                    try {
                      return Qr + "";
                    } catch {
                    }
                  }
                  return "";
                }(ea));
              }
              function So(ea, Qr, Yr, na) {
                for (var lo = -1, hs = ea.length, du = Yr.length, au = -1, pf = Qr.length, hp = yr(hs - du, 0), Ah = Array(pf + hp), Td = !na; ++au < pf; )
                  Ah[au] = Qr[au];
                for (; ++lo < du; )
                  (Td || lo < hs) && (Ah[Yr[lo]] = ea[lo]);
                for (; hp--; )
                  Ah[au++] = ea[lo++];
                return Ah;
              }
              function Fa(ea, Qr, Yr, na) {
                for (var lo = -1, hs = ea.length, du = -1, au = Yr.length, pf = -1, hp = Qr.length, Ah = yr(hs - au, 0), Td = Array(Ah + hp), Ih = !na; ++lo < Ah; )
                  Td[lo] = ea[lo];
                for (var k0 = lo; ++pf < hp; )
                  Td[k0 + pf] = Qr[pf];
                for (; ++du < au; )
                  (Ih || lo < hs) && (Td[k0 + Yr[du]] = ea[lo++]);
                return Td;
              }
              function po(ea) {
                return function() {
                  var Qr = arguments;
                  switch (Qr.length) {
                    case 0:
                      return new ea();
                    case 1:
                      return new ea(Qr[0]);
                    case 2:
                      return new ea(Qr[0], Qr[1]);
                    case 3:
                      return new ea(Qr[0], Qr[1], Qr[2]);
                    case 4:
                      return new ea(Qr[0], Qr[1], Qr[2], Qr[3]);
                    case 5:
                      return new ea(Qr[0], Qr[1], Qr[2], Qr[3], Qr[4]);
                    case 6:
                      return new ea(Qr[0], Qr[1], Qr[2], Qr[3], Qr[4], Qr[5]);
                    case 7:
                      return new ea(Qr[0], Qr[1], Qr[2], Qr[3], Qr[4], Qr[5], Qr[6]);
                  }
                  var Yr = ko(ea.prototype), na = ea.apply(Yr, Qr);
                  return Mp(na) ? na : Yr;
                };
              }
              function To(ea, Qr, Yr, na, lo, hs, du, au, pf, hp) {
                var Ah = 128 & Qr, Td = 1 & Qr, Ih = 2 & Qr, k0 = 24 & Qr, jy = 512 & Qr, J1 = Ih ? void 0 : po(ea);
                return function Gy() {
                  for (var $p = arguments.length, xc = Array($p), xv = $p; xv--; )
                    xc[xv] = arguments[xv];
                  if (k0)
                    var Bg = Hu(Gy), $b = Xe(xc, Bg);
                  if (na && (xc = So(xc, na, lo, k0)), hs && (xc = Fa(xc, hs, du, k0)), $p -= $b, k0 && $p < hp) {
                    var Xm = Ye(xc, Bg);
                    return Ya(ea, Qr, To, Gy.placeholder, Yr, xc, Xm, au, pf, hp - $p);
                  }
                  var Hy = Td ? Yr : this, Q1 = Ih ? Hy[ea] : ea;
                  return $p = xc.length, au ? xc = _v(xc, au) : jy && $p > 1 && xc.reverse(), Ah && pf < $p && (xc.length = pf), this && this !== pe && this instanceof Gy && (Q1 = J1 || po(Q1)), Q1.apply(Hy, xc);
                };
              }
              function Ya(ea, Qr, Yr, na, lo, hs, du, au, pf, hp) {
                var Ah = 8 & Qr;
                Qr |= Ah ? 32 : 64, 4 & (Qr &= ~(Ah ? 64 : 32)) || (Qr &= -4);
                var Td = Yr(ea, Qr, lo, Ah ? hs : void 0, Ah ? du : void 0, Ah ? void 0 : hs, Ah ? void 0 : du, au, pf, hp);
                return Td.placeholder = na, cp(Td, ea, Qr);
              }
              function $o(ea, Qr, Yr, na, lo, hs, du, au) {
                var pf = 2 & Qr;
                if (!pf && typeof ea != "function")
                  throw new TypeError("Expected a function");
                var hp = na ? na.length : 0;
                if (hp || (Qr &= -97, na = lo = void 0), du = du === void 0 ? du : yr(vx(du), 0), au = au === void 0 ? au : vx(au), hp -= lo ? lo.length : 0, 64 & Qr) {
                  var Ah = na, Td = lo;
                  na = lo = void 0;
                }
                var Ih = [ea, Qr, Yr, na, lo, Ah, Td, hs, du, au];
                if (ea = Ih[0], Qr = Ih[1], Yr = Ih[2], na = Ih[3], lo = Ih[4], !(au = Ih[9] = Ih[9] == null ? pf ? 0 : ea.length : yr(Ih[9] - hp, 0)) && 24 & Qr && (Qr &= -25), Qr && Qr != 1)
                  k0 = Qr == 8 || Qr == 16 ? function(jy, J1, Gy) {
                    var $p = po(jy);
                    return function xc() {
                      for (var xv = arguments.length, Bg = Array(xv), $b = xv, Xm = Hu(xc); $b--; )
                        Bg[$b] = arguments[$b];
                      var Hy = xv < 3 && Bg[0] !== Xm && Bg[xv - 1] !== Xm ? [] : Ye(Bg, Xm);
                      if ((xv -= Hy.length) < Gy)
                        return Ya(jy, J1, To, xc.placeholder, void 0, Bg, Hy, void 0, void 0, Gy - xv);
                      var Q1 = this && this !== pe && this instanceof xc ? $p : jy;
                      return Ve(Q1, this, Bg);
                    };
                  }(ea, Qr, au) : Qr != 32 && Qr != 33 || lo.length ? To.apply(void 0, Ih) : function(jy, J1, Gy, $p) {
                    var xc = 1 & J1, xv = po(jy);
                    return function Bg() {
                      for (var $b = -1, Xm = arguments.length, Hy = -1, Q1 = $p.length, IS = Array(Q1 + Xm), ES = this && this !== pe && this instanceof Bg ? xv : jy; ++Hy < Q1; )
                        IS[Hy] = $p[Hy];
                      for (; Xm--; )
                        IS[Hy++] = arguments[++$b];
                      return Ve(ES, xc ? Gy : this, IS);
                    };
                  }(ea, Qr, Yr, na);
                else
                  var k0 = function(jy, J1, Gy) {
                    var $p = 1 & J1, xc = po(jy);
                    return function xv() {
                      var Bg = this && this !== pe && this instanceof xv ? xc : jy;
                      return Bg.apply($p ? Gy : this, arguments);
                    };
                  }(ea, Qr, Yr);
                return cp(k0, ea, Qr);
              }
              function Hu(ea) {
                return ea.placeholder;
              }
              function ms(ea, Qr) {
                var Yr = function(na, lo) {
                  return na == null ? void 0 : na[lo];
                }(ea, Qr);
                return wo(Yr) ? Yr : void 0;
              }
              function sc(ea) {
                var Qr = ea.match(O);
                return Qr ? Qr[1].split(R) : [];
              }
              function Oc(ea, Qr) {
                var Yr = Qr.length, na = Yr - 1;
                return Qr[na] = (Yr > 1 ? "& " : "") + Qr[na], Qr = Qr.join(Yr > 2 ? ", " : " "), ea.replace(E, `{
/* [wrapped with ` + Qr + `] */
`);
              }
              function _c2(ea, Qr) {
                return !!(Qr = Qr == null ? 9007199254740991 : Qr) && (typeof ea == "number" || ee.test(ea)) && ea > -1 && ea % 1 == 0 && ea < Qr;
              }
              function _v(ea, Qr) {
                for (var Yr = ea.length, na = da(Qr.length, Yr), lo = function(du, au) {
                  var pf = -1, hp = du.length;
                  for (au || (au = Array(hp)); ++pf < hp; )
                    au[pf] = du[pf];
                  return au;
                }(ea); na--; ) {
                  var hs = Qr[na];
                  ea[na] = _c2(hs, Yr) ? lo[hs] : void 0;
                }
                return ea;
              }
              var cp = Ja ? function(ea, Qr, Yr) {
                var na, lo = Qr + "";
                return Ja(ea, "toString", { configurable: true, enumerable: false, value: (na = Oc(lo, Vg(sc(lo), Yr)), function() {
                  return na;
                }) });
              } : function(ea) {
                return ea;
              };
              function Vg(ea, Qr) {
                return function(Yr, na) {
                  for (var lo = -1, hs = Yr ? Yr.length : 0; ++lo < hs && na(Yr[lo], lo, Yr) !== false; )
                    ;
                }(S, function(Yr) {
                  var na = "_." + Yr[0];
                  Qr & Yr[1] && !Le(ea, na) && ea.push(na);
                }), ea.sort();
              }
              function rh(ea, Qr, Yr) {
                var na = $o(ea, 8, void 0, void 0, void 0, void 0, void 0, Qr = Yr ? void 0 : Qr);
                return na.placeholder = rh.placeholder, na;
              }
              function Mp(ea) {
                var Qr = typeof ea;
                return !!ea && (Qr == "object" || Qr == "function");
              }
              function fp(ea) {
                return ea ? (ea = function(Qr) {
                  if (typeof Qr == "number")
                    return Qr;
                  if (function(lo) {
                    return typeof lo == "symbol" || function(hs) {
                      return !!hs && typeof hs == "object";
                    }(lo) && pn.call(lo) == "[object Symbol]";
                  }(Qr))
                    return NaN;
                  if (Mp(Qr)) {
                    var Yr = typeof Qr.valueOf == "function" ? Qr.valueOf() : Qr;
                    Qr = Mp(Yr) ? Yr + "" : Yr;
                  }
                  if (typeof Qr != "string")
                    return Qr === 0 ? Qr : +Qr;
                  Qr = Qr.replace(T, "");
                  var na = z3.test(Qr);
                  return na || Z.test(Qr) ? oe(Qr.slice(2), na ? 2 : 8) : V.test(Qr) ? NaN : +Qr;
                }(ea)) === 1 / 0 || ea === -1 / 0 ? 17976931348623157e292 * (ea < 0 ? -1 : 1) : ea == ea ? ea : 0 : ea === 0 ? ea : 0;
              }
              function vx(ea) {
                var Qr = fp(ea), Yr = Qr % 1;
                return Qr == Qr ? Yr ? Qr - Yr : Qr : 0;
              }
              rh.placeholder = {}, f6.exports = rh;
            }).call(this, y4(43));
          }, function(f6, d4, y4) {
            function _(Fa) {
              return Fa && Fa.__esModule ? Fa.default : Fa;
            }
            d4.__esModule = true;
            var S = y4(95);
            d4.threezerotwofour = _(S);
            var T = y4(96);
            d4.apathy = _(T);
            var E = y4(97);
            d4.ashes = _(E);
            var O = y4(98);
            d4.atelierDune = _(O);
            var R = y4(99);
            d4.atelierForest = _(R);
            var V = y4(100);
            d4.atelierHeath = _(V);
            var z3 = y4(101);
            d4.atelierLakeside = _(z3);
            var H = y4(102);
            d4.atelierSeaside = _(H);
            var Z = y4(103);
            d4.bespin = _(Z);
            var ee = y4(104);
            d4.brewer = _(ee);
            var oe = y4(105);
            d4.bright = _(oe);
            var fe = y4(106);
            d4.chalk = _(fe);
            var _e = y4(107);
            d4.codeschool = _(_e);
            var pe = y4(108);
            d4.colors = _(pe);
            var Ve = y4(109);
            d4.default = _(Ve);
            var Le = y4(110);
            d4.eighties = _(Le);
            var je = y4(111);
            d4.embers = _(je);
            var Xe = y4(112);
            d4.flat = _(Xe);
            var Ye = y4(113);
            d4.google = _(Ye);
            var rt2 = y4(114);
            d4.grayscale = _(rt2);
            var ut = y4(115);
            d4.greenscreen = _(ut);
            var wt = y4(116);
            d4.harmonic = _(wt);
            var dt = y4(117);
            d4.hopscotch = _(dt);
            var Gt = y4(118);
            d4.isotope = _(Gt);
            var Qt = y4(119);
            d4.marrakesh = _(Qt);
            var Nt = y4(120);
            d4.mocha = _(Nt);
            var er = y4(121);
            d4.monokai = _(er);
            var un = y4(122);
            d4.ocean = _(un);
            var pn = y4(123);
            d4.paraiso = _(pn);
            var On = y4(124);
            d4.pop = _(On);
            var fr = y4(125);
            d4.railscasts = _(fr);
            var yr = y4(126);
            d4.shapeshifter = _(yr);
            var da = y4(127);
            d4.solarized = _(da);
            var Ja = y4(128);
            d4.summerfruit = _(Ja);
            var ko = y4(129);
            d4.tomorrow = _(ko);
            var wo = y4(130);
            d4.tube = _(wo);
            var So = y4(131);
            d4.twilight = _(So);
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            d4.__esModule = true, d4.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, f6.exports = d4.default;
          }, function(f6, d4, y4) {
            var _ = y4(33);
            function S(T) {
              var E = Math.round(_(T, 0, 255)).toString(16);
              return E.length == 1 ? "0" + E : E;
            }
            f6.exports = function(T) {
              var E = T.length === 4 ? S(255 * T[3]) : "";
              return "#" + S(T[0]) + S(T[1]) + S(T[2]) + E;
            };
          }, function(f6, d4, y4) {
            var _ = y4(134), S = y4(135), T = y4(136), E = y4(137), O = { "#": S, hsl: function(V) {
              var z3 = _(V), H = E(z3);
              return z3.length === 4 && H.push(z3[3]), H;
            }, rgb: T };
            function R(V) {
              for (var z3 in O)
                if (V.indexOf(z3) === 0)
                  return O[z3](V);
            }
            R.rgb = T, R.hsl = _, R.hex = S, f6.exports = R;
          }, function(f6, d4, y4) {
            var _ = y4(44), S = y4(33);
            function T(E, O) {
              switch (E = parseFloat(E), O) {
                case 0:
                  return S(E, 0, 360);
                case 1:
                case 2:
                  return S(E, 0, 100);
                case 3:
                  return S(E, 0, 1);
              }
            }
            f6.exports = function(E) {
              return _(E).map(T);
            };
          }, function(f6, d4) {
            f6.exports = function(y4) {
              y4.length !== 4 && y4.length !== 5 || (y4 = function(T) {
                for (var E = "#", O = 1; O < T.length; O++) {
                  var R = T.charAt(O);
                  E += R + R;
                }
                return E;
              }(y4));
              var _ = [parseInt(y4.substring(1, 3), 16), parseInt(y4.substring(3, 5), 16), parseInt(y4.substring(5, 7), 16)];
              if (y4.length === 9) {
                var S = parseFloat((parseInt(y4.substring(7, 9), 16) / 255).toFixed(2));
                _.push(S);
              }
              return _;
            };
          }, function(f6, d4, y4) {
            var _ = y4(44), S = y4(33);
            function T(E, O) {
              return O < 3 ? E.indexOf("%") != -1 ? Math.round(255 * S(parseInt(E, 10), 0, 100) / 100) : S(parseInt(E, 10), 0, 255) : S(parseFloat(E), 0, 1);
            }
            f6.exports = function(E) {
              return _(E).map(T);
            };
          }, function(f6, d4) {
            f6.exports = function(y4) {
              var _, S, T, E, O, R = y4[0] / 360, V = y4[1] / 100, z3 = y4[2] / 100;
              if (V == 0)
                return [O = 255 * z3, O, O];
              _ = 2 * z3 - (S = z3 < 0.5 ? z3 * (1 + V) : z3 + V - z3 * V), E = [0, 0, 0];
              for (var H = 0; H < 3; H++)
                (T = R + 1 / 3 * -(H - 1)) < 0 && T++, T > 1 && T--, O = 6 * T < 1 ? _ + 6 * (S - _) * T : 2 * T < 1 ? S : 3 * T < 2 ? _ + (S - _) * (2 / 3 - T) * 6 : _, E[H] = 255 * O;
              return E;
            };
          }, function(f6, d4, y4) {
            (function(_) {
              var S = typeof _ == "object" && _ && _.Object === Object && _, T = typeof self == "object" && self && self.Object === Object && self, E = S || T || Function("return this")();
              function O(Ye, rt2, ut) {
                switch (ut.length) {
                  case 0:
                    return Ye.call(rt2);
                  case 1:
                    return Ye.call(rt2, ut[0]);
                  case 2:
                    return Ye.call(rt2, ut[0], ut[1]);
                  case 3:
                    return Ye.call(rt2, ut[0], ut[1], ut[2]);
                }
                return Ye.apply(rt2, ut);
              }
              function R(Ye, rt2) {
                for (var ut = -1, wt = rt2.length, dt = Ye.length; ++ut < wt; )
                  Ye[dt + ut] = rt2[ut];
                return Ye;
              }
              var V = Object.prototype, z3 = V.hasOwnProperty, H = V.toString, Z = E.Symbol, ee = V.propertyIsEnumerable, oe = Z ? Z.isConcatSpreadable : void 0, fe = Math.max;
              function _e(Ye) {
                return pe(Ye) || function(rt2) {
                  return function(ut) {
                    return function(wt) {
                      return !!wt && typeof wt == "object";
                    }(ut) && function(wt) {
                      return wt != null && function(dt) {
                        return typeof dt == "number" && dt > -1 && dt % 1 == 0 && dt <= 9007199254740991;
                      }(wt.length) && !function(dt) {
                        var Gt = function(Qt) {
                          var Nt = typeof Qt;
                          return !!Qt && (Nt == "object" || Nt == "function");
                        }(dt) ? H.call(dt) : "";
                        return Gt == "[object Function]" || Gt == "[object GeneratorFunction]";
                      }(wt);
                    }(ut);
                  }(rt2) && z3.call(rt2, "callee") && (!ee.call(rt2, "callee") || H.call(rt2) == "[object Arguments]");
                }(Ye) || !!(oe && Ye && Ye[oe]);
              }
              var pe = Array.isArray, Ve, Le, je, Xe = (Le = function(Ye) {
                var rt2 = (Ye = function wt(dt, Gt, Qt, Nt, er) {
                  var un = -1, pn = dt.length;
                  for (Qt || (Qt = _e), er || (er = []); ++un < pn; ) {
                    var On = dt[un];
                    Gt > 0 && Qt(On) ? Gt > 1 ? wt(On, Gt - 1, Qt, Nt, er) : R(er, On) : Nt || (er[er.length] = On);
                  }
                  return er;
                }(Ye, 1)).length, ut = rt2;
                for (Ve; ut--; )
                  if (typeof Ye[ut] != "function")
                    throw new TypeError("Expected a function");
                return function() {
                  for (var wt = 0, dt = rt2 ? Ye[wt].apply(this, arguments) : arguments[0]; ++wt < rt2; )
                    dt = Ye[wt].call(this, dt);
                  return dt;
                };
              }, je = fe(je === void 0 ? Le.length - 1 : je, 0), function() {
                for (var Ye = arguments, rt2 = -1, ut = fe(Ye.length - je, 0), wt = Array(ut); ++rt2 < ut; )
                  wt[rt2] = Ye[je + rt2];
                rt2 = -1;
                for (var dt = Array(je + 1); ++rt2 < je; )
                  dt[rt2] = Ye[rt2];
                return dt[je] = wt, O(Le, this, dt);
              });
              f6.exports = Xe;
            }).call(this, y4(43));
          }, function(f6, d4, y4) {
            Object.defineProperty(d4, "__esModule", { value: true }), d4.yuv2rgb = function(_) {
              var S, T, E, O = _[0], R = _[1], V = _[2];
              return S = 1 * O + 0 * R + 1.13983 * V, T = 1 * O + -0.39465 * R + -0.5806 * V, E = 1 * O + 2.02311 * R + 0 * V, S = Math.min(Math.max(0, S), 1), T = Math.min(Math.max(0, T), 1), E = Math.min(Math.max(0, E), 1), [255 * S, 255 * T, 255 * E];
            }, d4.rgb2yuv = function(_) {
              var S = _[0] / 255, T = _[1] / 255, E = _[2] / 255;
              return [0.299 * S + 0.587 * T + 0.114 * E, -0.14713 * S + -0.28886 * T + 0.436 * E, 0.615 * S + -0.51499 * T + -0.10001 * E];
            };
          }, function(f6, d4, y4) {
            function _(E, O, R) {
              return O in E ? Object.defineProperty(E, O, { value: R, enumerable: true, configurable: true, writable: true }) : E[O] = R, E;
            }
            var S = y4(141), T = function() {
              function E() {
                _(this, "_callbacks", void 0), _(this, "_isDispatching", void 0), _(this, "_isHandled", void 0), _(this, "_isPending", void 0), _(this, "_lastID", void 0), _(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
              }
              var O = E.prototype;
              return O.register = function(R) {
                var V = "ID_" + this._lastID++;
                return this._callbacks[V] = R, V;
              }, O.unregister = function(R) {
                this._callbacks[R] || S(false), delete this._callbacks[R];
              }, O.waitFor = function(R) {
                this._isDispatching || S(false);
                for (var V = 0; V < R.length; V++) {
                  var z3 = R[V];
                  this._isPending[z3] ? this._isHandled[z3] || S(false) : (this._callbacks[z3] || S(false), this._invokeCallback(z3));
                }
              }, O.dispatch = function(R) {
                this._isDispatching && S(false), this._startDispatching(R);
                try {
                  for (var V in this._callbacks)
                    this._isPending[V] || this._invokeCallback(V);
                } finally {
                  this._stopDispatching();
                }
              }, O.isDispatching = function() {
                return this._isDispatching;
              }, O._invokeCallback = function(R) {
                this._isPending[R] = true, this._callbacks[R](this._pendingPayload), this._isHandled[R] = true;
              }, O._startDispatching = function(R) {
                for (var V in this._callbacks)
                  this._isPending[V] = false, this._isHandled[V] = false;
                this._pendingPayload = R, this._isDispatching = true;
              }, O._stopDispatching = function() {
                delete this._pendingPayload, this._isDispatching = false;
              }, E;
            }();
            f6.exports = T;
          }, function(f6, d4, y4) {
            f6.exports = function(_, S) {
              for (var T = arguments.length, E = new Array(T > 2 ? T - 2 : 0), O = 2; O < T; O++)
                E[O - 2] = arguments[O];
              if (!_) {
                var R;
                if (S === void 0)
                  R = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
                else {
                  var V = 0;
                  (R = new Error(S.replace(/%s/g, function() {
                    return String(E[V++]);
                  }))).name = "Invariant Violation";
                }
                throw R.framesToPop = 1, R;
              }
            };
          }, function(f6, d4, y4) {
            function _(En, Pn, Kt) {
              return Pn in En ? Object.defineProperty(En, Pn, { value: Kt, enumerable: true, configurable: true, writable: true }) : En[Pn] = Kt, En;
            }
            function S(En, Pn) {
              var Kt = Object.keys(En);
              if (Object.getOwnPropertySymbols) {
                var yn = Object.getOwnPropertySymbols(En);
                Pn && (yn = yn.filter(function(fn) {
                  return Object.getOwnPropertyDescriptor(En, fn).enumerable;
                })), Kt.push.apply(Kt, yn);
              }
              return Kt;
            }
            function T(En) {
              for (var Pn = 1; Pn < arguments.length; Pn++) {
                var Kt = arguments[Pn] != null ? arguments[Pn] : {};
                Pn % 2 ? S(Object(Kt), true).forEach(function(yn) {
                  _(En, yn, Kt[yn]);
                }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(En, Object.getOwnPropertyDescriptors(Kt)) : S(Object(Kt)).forEach(function(yn) {
                  Object.defineProperty(En, yn, Object.getOwnPropertyDescriptor(Kt, yn));
                });
              }
              return En;
            }
            function E(En, Pn) {
              if (!(En instanceof Pn))
                throw new TypeError("Cannot call a class as a function");
            }
            function O(En, Pn) {
              for (var Kt = 0; Kt < Pn.length; Kt++) {
                var yn = Pn[Kt];
                yn.enumerable = yn.enumerable || false, yn.configurable = true, "value" in yn && (yn.writable = true), Object.defineProperty(En, yn.key, yn);
              }
            }
            function R(En, Pn, Kt) {
              return Pn && O(En.prototype, Pn), Kt && O(En, Kt), En;
            }
            function V(En, Pn) {
              return (V = Object.setPrototypeOf || function(Kt, yn) {
                return Kt.__proto__ = yn, Kt;
              })(En, Pn);
            }
            function z3(En, Pn) {
              if (typeof Pn != "function" && Pn !== null)
                throw new TypeError("Super expression must either be null or a function");
              En.prototype = Object.create(Pn && Pn.prototype, { constructor: { value: En, writable: true, configurable: true } }), Pn && V(En, Pn);
            }
            function H(En) {
              return (H = Object.setPrototypeOf ? Object.getPrototypeOf : function(Pn) {
                return Pn.__proto__ || Object.getPrototypeOf(Pn);
              })(En);
            }
            function Z(En) {
              return (Z = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Pn) {
                return typeof Pn;
              } : function(Pn) {
                return Pn && typeof Symbol == "function" && Pn.constructor === Symbol && Pn !== Symbol.prototype ? "symbol" : typeof Pn;
              })(En);
            }
            function ee(En) {
              if (En === void 0)
                throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
              return En;
            }
            function oe(En, Pn) {
              return !Pn || Z(Pn) !== "object" && typeof Pn != "function" ? ee(En) : Pn;
            }
            function fe(En) {
              var Pn = function() {
                if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                  return false;
                if (typeof Proxy == "function")
                  return true;
                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                  })), true;
                } catch {
                  return false;
                }
              }();
              return function() {
                var Kt, yn = H(En);
                if (Pn) {
                  var fn = H(this).constructor;
                  Kt = Reflect.construct(yn, arguments, fn);
                } else
                  Kt = yn.apply(this, arguments);
                return oe(this, Kt);
              };
            }
            y4.r(d4);
            var _e = y4(0), pe = y4.n(_e);
            function Ve() {
              var En = this.constructor.getDerivedStateFromProps(this.props, this.state);
              En != null && this.setState(En);
            }
            function Le(En) {
              this.setState(function(Pn) {
                var Kt = this.constructor.getDerivedStateFromProps(En, Pn);
                return Kt != null ? Kt : null;
              }.bind(this));
            }
            function je(En, Pn) {
              try {
                var Kt = this.props, yn = this.state;
                this.props = En, this.state = Pn, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Kt, yn);
              } finally {
                this.props = Kt, this.state = yn;
              }
            }
            function Xe(En) {
              var Pn = En.prototype;
              if (!Pn || !Pn.isReactComponent)
                throw new Error("Can only polyfill class components");
              if (typeof En.getDerivedStateFromProps != "function" && typeof Pn.getSnapshotBeforeUpdate != "function")
                return En;
              var Kt = null, yn = null, fn = null;
              if (typeof Pn.componentWillMount == "function" ? Kt = "componentWillMount" : typeof Pn.UNSAFE_componentWillMount == "function" && (Kt = "UNSAFE_componentWillMount"), typeof Pn.componentWillReceiveProps == "function" ? yn = "componentWillReceiveProps" : typeof Pn.UNSAFE_componentWillReceiveProps == "function" && (yn = "UNSAFE_componentWillReceiveProps"), typeof Pn.componentWillUpdate == "function" ? fn = "componentWillUpdate" : typeof Pn.UNSAFE_componentWillUpdate == "function" && (fn = "UNSAFE_componentWillUpdate"), Kt !== null || yn !== null || fn !== null) {
                var Br = En.displayName || En.name, Nr = typeof En.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
                throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Br + " uses " + Nr + " but also contains the following legacy lifecycles:" + (Kt !== null ? `
  ` + Kt : "") + (yn !== null ? `
  ` + yn : "") + (fn !== null ? `
  ` + fn : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
              }
              if (typeof En.getDerivedStateFromProps == "function" && (Pn.componentWillMount = Ve, Pn.componentWillReceiveProps = Le), typeof Pn.getSnapshotBeforeUpdate == "function") {
                if (typeof Pn.componentDidUpdate != "function")
                  throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
                Pn.componentWillUpdate = je;
                var yi = Pn.componentDidUpdate;
                Pn.componentDidUpdate = function(Er, _a2, rs) {
                  var wu = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : rs;
                  yi.call(this, Er, _a2, wu);
                };
              }
              return En;
            }
            function Ye(En, Pn) {
              if (En == null)
                return {};
              var Kt, yn, fn = function(Nr, yi) {
                if (Nr == null)
                  return {};
                var Er, _a2, rs = {}, wu = Object.keys(Nr);
                for (_a2 = 0; _a2 < wu.length; _a2++)
                  Er = wu[_a2], yi.indexOf(Er) >= 0 || (rs[Er] = Nr[Er]);
                return rs;
              }(En, Pn);
              if (Object.getOwnPropertySymbols) {
                var Br = Object.getOwnPropertySymbols(En);
                for (yn = 0; yn < Br.length; yn++)
                  Kt = Br[yn], Pn.indexOf(Kt) >= 0 || Object.prototype.propertyIsEnumerable.call(En, Kt) && (fn[Kt] = En[Kt]);
              }
              return fn;
            }
            function rt2(En) {
              var Pn = function(Kt) {
                return {}.toString.call(Kt).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
              }(En);
              return Pn === "number" && (Pn = isNaN(En) ? "nan" : (0 | En) != En ? "float" : "integer"), Pn;
            }
            Ve.__suppressDeprecationWarning = true, Le.__suppressDeprecationWarning = true, je.__suppressDeprecationWarning = true;
            var ut = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, wt = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, dt = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, Gt = y4(45), Qt = function(En) {
              var Pn = function(Kt) {
                return { backgroundColor: Kt.base00, ellipsisColor: Kt.base09, braceColor: Kt.base07, expandedIcon: Kt.base0D, collapsedIcon: Kt.base0E, keyColor: Kt.base07, arrayKeyColor: Kt.base0C, objectSize: Kt.base04, copyToClipboard: Kt.base0F, copyToClipboardCheck: Kt.base0D, objectBorder: Kt.base02, dataTypes: { boolean: Kt.base0E, date: Kt.base0D, float: Kt.base0B, function: Kt.base0D, integer: Kt.base0F, string: Kt.base09, nan: Kt.base08, null: Kt.base0A, undefined: Kt.base05, regexp: Kt.base0A, background: Kt.base02 }, editVariable: { editIcon: Kt.base0E, cancelIcon: Kt.base09, removeIcon: Kt.base09, addIcon: Kt.base0E, checkIcon: Kt.base0E, background: Kt.base01, color: Kt.base0A, border: Kt.base07 }, addKeyModal: { background: Kt.base05, border: Kt.base04, color: Kt.base0A, labelColor: Kt.base01 }, validationFailure: { background: Kt.base09, iconColor: Kt.base01, fontColor: Kt.base01 } };
              }(En);
              return { "app-container": { fontFamily: dt.globalFontFamily, cursor: dt.globalCursor, backgroundColor: Pn.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Pn.ellipsisColor, fontSize: dt.ellipsisFontSize, lineHeight: dt.ellipsisLineHeight, cursor: dt.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: dt.braceCursor, fontWeight: dt.braceFontWeight, color: Pn.braceColor }, "expanded-icon": { color: Pn.expandedIcon }, "collapsed-icon": { color: Pn.collapsedIcon }, colon: { display: "inline-block", margin: dt.keyMargin, color: Pn.keyColor, verticalAlign: "top" }, objectKeyVal: function(Kt, yn) {
                return { style: T({ paddingTop: dt.keyValPaddingTop, paddingRight: dt.keyValPaddingRight, paddingBottom: dt.keyValPaddingBottom, borderLeft: dt.keyValBorderLeft + " " + Pn.objectBorder, ":hover": { paddingLeft: yn.paddingLeft - 1 + "px", borderLeft: dt.keyValBorderHover + " " + Pn.objectBorder } }, yn) };
              }, "object-key-val-no-border": { padding: dt.keyValPadding }, "pushed-content": { marginLeft: dt.pushedContentMarginLeft }, variableValue: function(Kt, yn) {
                return { style: T({ display: "inline-block", paddingRight: dt.variableValuePaddingRight, position: "relative" }, yn) };
              }, "object-name": { display: "inline-block", color: Pn.keyColor, letterSpacing: dt.keyLetterSpacing, fontStyle: dt.keyFontStyle, verticalAlign: dt.keyVerticalAlign, opacity: dt.keyOpacity, ":hover": { opacity: dt.keyOpacityHover } }, "array-key": { display: "inline-block", color: Pn.arrayKeyColor, letterSpacing: dt.keyLetterSpacing, fontStyle: dt.keyFontStyle, verticalAlign: dt.keyVerticalAlign, opacity: dt.keyOpacity, ":hover": { opacity: dt.keyOpacityHover } }, "object-size": { color: Pn.objectSize, borderRadius: dt.objectSizeBorderRadius, fontStyle: dt.objectSizeFontStyle, margin: dt.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: dt.dataTypeFontSize, marginRight: dt.dataTypeMarginRight, opacity: dt.datatypeOpacity }, boolean: { display: "inline-block", color: Pn.dataTypes.boolean }, date: { display: "inline-block", color: Pn.dataTypes.date }, "date-value": { marginLeft: dt.dateValueMarginLeft }, float: { display: "inline-block", color: Pn.dataTypes.float }, function: { display: "inline-block", color: Pn.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Pn.dataTypes.integer }, string: { display: "inline-block", color: Pn.dataTypes.string }, nan: { display: "inline-block", color: Pn.dataTypes.nan, fontSize: dt.nanFontSize, fontWeight: dt.nanFontWeight, backgroundColor: Pn.dataTypes.background, padding: dt.nanPadding, borderRadius: dt.nanBorderRadius }, null: { display: "inline-block", color: Pn.dataTypes.null, fontSize: dt.nullFontSize, fontWeight: dt.nullFontWeight, backgroundColor: Pn.dataTypes.background, padding: dt.nullPadding, borderRadius: dt.nullBorderRadius }, undefined: { display: "inline-block", color: Pn.dataTypes.undefined, fontSize: dt.undefinedFontSize, padding: dt.undefinedPadding, borderRadius: dt.undefinedBorderRadius, backgroundColor: Pn.dataTypes.background }, regexp: { display: "inline-block", color: Pn.dataTypes.regexp }, "copy-to-clipboard": { cursor: dt.clipboardCursor }, "copy-icon": { color: Pn.copyToClipboard, fontSize: dt.iconFontSize, marginRight: dt.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Pn.copyToClipboardCheck, marginLeft: dt.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: dt.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: dt.metaDataPadding }, "icon-container": { display: "inline-block", width: dt.iconContainerWidth }, tooltip: { padding: dt.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Pn.editVariable.removeIcon, cursor: dt.iconCursor, fontSize: dt.iconFontSize, marginRight: dt.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Pn.editVariable.addIcon, cursor: dt.iconCursor, fontSize: dt.iconFontSize, marginRight: dt.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Pn.editVariable.editIcon, cursor: dt.iconCursor, fontSize: dt.iconFontSize, marginRight: dt.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: dt.iconCursor, color: Pn.editVariable.checkIcon, fontSize: dt.iconFontSize, paddingRight: dt.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: dt.iconCursor, color: Pn.editVariable.cancelIcon, fontSize: dt.iconFontSize, paddingRight: dt.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: dt.editInputMinWidth, borderRadius: dt.editInputBorderRadius, backgroundColor: Pn.editVariable.background, color: Pn.editVariable.color, padding: dt.editInputPadding, marginRight: dt.editInputMarginRight, fontFamily: dt.editInputFontFamily }, "detected-row": { paddingTop: dt.detectedRowPaddingTop }, "key-modal-request": { position: dt.addKeyCoverPosition, top: dt.addKeyCoverPositionPx, left: dt.addKeyCoverPositionPx, right: dt.addKeyCoverPositionPx, bottom: dt.addKeyCoverPositionPx, backgroundColor: dt.addKeyCoverBackground }, "key-modal": { width: dt.addKeyModalWidth, backgroundColor: Pn.addKeyModal.background, marginLeft: dt.addKeyModalMargin, marginRight: dt.addKeyModalMargin, padding: dt.addKeyModalPadding, borderRadius: dt.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Pn.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Pn.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Pn.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Pn.addKeyModal.labelColor, fontSize: dt.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Pn.editVariable.addIcon, fontSize: dt.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Pn.ellipsisColor, fontSize: dt.ellipsisFontSize, lineHeight: dt.ellipsisLineHeight, cursor: dt.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Pn.validationFailure.fontColor, backgroundColor: Pn.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Pn.validationFailure.iconColor, fontSize: dt.iconFontSize, transform: "rotate(45deg)" } };
            };
            function Nt(En, Pn, Kt) {
              return En || console.error("theme has not been set"), function(yn) {
                var fn = ut;
                return yn !== false && yn !== "none" || (fn = wt), Object(Gt.createStyling)(Qt, { defaultBase16: fn })(yn);
              }(En)(Pn, Kt);
            }
            var er = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = (yn.rjvId, yn.type_name), Br = yn.displayDataTypes, Nr = yn.theme;
                return Br ? pe.a.createElement("span", Object.assign({ className: "data-type-label" }, Nt(Nr, "data-type-label")), fn) : null;
              } }]), Kt;
            }(pe.a.PureComponent), un = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props;
                return pe.a.createElement("div", Nt(yn.theme, "boolean"), pe.a.createElement(er, Object.assign({ type_name: "bool" }, yn)), yn.value ? "true" : "false");
              } }]), Kt;
            }(pe.a.PureComponent), pn = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props;
                return pe.a.createElement("div", Nt(yn.theme, "date"), pe.a.createElement(er, Object.assign({ type_name: "date" }, yn)), pe.a.createElement("span", Object.assign({ className: "date-value" }, Nt(yn.theme, "date-value")), yn.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
              } }]), Kt;
            }(pe.a.PureComponent), On = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props;
                return pe.a.createElement("div", Nt(yn.theme, "float"), pe.a.createElement(er, Object.assign({ type_name: "float" }, yn)), this.props.value);
              } }]), Kt;
            }(pe.a.PureComponent);
            function fr(En, Pn) {
              (Pn == null || Pn > En.length) && (Pn = En.length);
              for (var Kt = 0, yn = new Array(Pn); Kt < Pn; Kt++)
                yn[Kt] = En[Kt];
              return yn;
            }
            function yr(En, Pn) {
              if (En) {
                if (typeof En == "string")
                  return fr(En, Pn);
                var Kt = Object.prototype.toString.call(En).slice(8, -1);
                return Kt === "Object" && En.constructor && (Kt = En.constructor.name), Kt === "Map" || Kt === "Set" ? Array.from(En) : Kt === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Kt) ? fr(En, Pn) : void 0;
              }
            }
            function da(En, Pn) {
              var Kt;
              if (typeof Symbol == "undefined" || En[Symbol.iterator] == null) {
                if (Array.isArray(En) || (Kt = yr(En)) || Pn && En && typeof En.length == "number") {
                  Kt && (En = Kt);
                  var yn = 0, fn = function() {
                  };
                  return { s: fn, n: function() {
                    return yn >= En.length ? { done: true } : { done: false, value: En[yn++] };
                  }, e: function(Er) {
                    throw Er;
                  }, f: fn };
                }
                throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }
              var Br, Nr = true, yi = false;
              return { s: function() {
                Kt = En[Symbol.iterator]();
              }, n: function() {
                var Er = Kt.next();
                return Nr = Er.done, Er;
              }, e: function(Er) {
                yi = true, Br = Er;
              }, f: function() {
                try {
                  Nr || Kt.return == null || Kt.return();
                } finally {
                  if (yi)
                    throw Br;
                }
              } };
            }
            function Ja(En) {
              return function(Pn) {
                if (Array.isArray(Pn))
                  return fr(Pn);
              }(En) || function(Pn) {
                if (typeof Symbol != "undefined" && Symbol.iterator in Object(Pn))
                  return Array.from(Pn);
              }(En) || yr(En) || function() {
                throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
              }();
            }
            var ko = y4(46), wo = new (y4(47)).Dispatcher(), So = new (function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                var yn;
                E(this, Kt);
                for (var fn = arguments.length, Br = new Array(fn), Nr = 0; Nr < fn; Nr++)
                  Br[Nr] = arguments[Nr];
                return (yn = Pn.call.apply(Pn, [this].concat(Br))).objects = {}, yn.set = function(yi, Er, _a2, rs) {
                  yn.objects[yi] === void 0 && (yn.objects[yi] = {}), yn.objects[yi][Er] === void 0 && (yn.objects[yi][Er] = {}), yn.objects[yi][Er][_a2] = rs;
                }, yn.get = function(yi, Er, _a2, rs) {
                  return yn.objects[yi] === void 0 || yn.objects[yi][Er] === void 0 || yn.objects[yi][Er][_a2] == null ? rs : yn.objects[yi][Er][_a2];
                }, yn.handleAction = function(yi) {
                  var Er = yi.rjvId, _a2 = yi.data;
                  switch (yi.name) {
                    case "RESET":
                      yn.emit("reset-" + Er);
                      break;
                    case "VARIABLE_UPDATED":
                      yi.data.updated_src = yn.updateSrc(Er, _a2), yn.set(Er, "action", "variable-update", T(T({}, _a2), {}, { type: "variable-edited" })), yn.emit("variable-update-" + Er);
                      break;
                    case "VARIABLE_REMOVED":
                      yi.data.updated_src = yn.updateSrc(Er, _a2), yn.set(Er, "action", "variable-update", T(T({}, _a2), {}, { type: "variable-removed" })), yn.emit("variable-update-" + Er);
                      break;
                    case "VARIABLE_ADDED":
                      yi.data.updated_src = yn.updateSrc(Er, _a2), yn.set(Er, "action", "variable-update", T(T({}, _a2), {}, { type: "variable-added" })), yn.emit("variable-update-" + Er);
                      break;
                    case "ADD_VARIABLE_KEY_REQUEST":
                      yn.set(Er, "action", "new-key-request", _a2), yn.emit("add-key-request-" + Er);
                  }
                }, yn.updateSrc = function(yi, Er) {
                  var _a2 = Er.name, rs = Er.namespace, wu = Er.new_value, _l = (Er.existing_value, Er.variable_removed);
                  rs.shift();
                  var Rf, Ol = yn.get(yi, "global", "src"), Sf = yn.deepCopy(Ol, Ja(rs)), qf = Sf, _s = da(rs);
                  try {
                    for (_s.s(); !(Rf = _s.n()).done; )
                      qf = qf[Rf.value];
                  } catch (df) {
                    _s.e(df);
                  } finally {
                    _s.f();
                  }
                  return _l ? rt2(qf) == "array" ? qf.splice(_a2, 1) : delete qf[_a2] : _a2 !== null ? qf[_a2] = wu : Sf = wu, yn.set(yi, "global", "src", Sf), Sf;
                }, yn.deepCopy = function(yi, Er) {
                  var _a2, rs = rt2(yi), wu = Er.shift();
                  return rs == "array" ? _a2 = Ja(yi) : rs == "object" && (_a2 = T({}, yi)), wu !== void 0 && (_a2[wu] = yn.deepCopy(yi[wu], Er)), _a2;
                }, yn;
              }
              return Kt;
            }(ko.EventEmitter))();
            wo.register(So.handleAction.bind(So));
            var Fa = So, po = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).toggleCollapsed = function() {
                  fn.setState({ collapsed: !fn.state.collapsed }, function() {
                    Fa.set(fn.props.rjvId, fn.props.namespace, "collapsed", fn.state.collapsed);
                  });
                }, fn.getFunctionDisplay = function(Br) {
                  var Nr = ee(fn).props;
                  return Br ? pe.a.createElement("span", null, fn.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), pe.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, pe.a.createElement("span", null, "{"), pe.a.createElement("span", Nt(Nr.theme, "ellipsis"), "..."), pe.a.createElement("span", null, "}"))) : fn.props.value.toString().slice(9, -1);
                }, fn.state = { collapsed: Fa.get(yn.rjvId, yn.namespace, "collapsed", true) }, fn;
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = this.state.collapsed;
                return pe.a.createElement("div", Nt(yn.theme, "function"), pe.a.createElement(er, Object.assign({ type_name: "function" }, yn)), pe.a.createElement("span", Object.assign({}, Nt(yn.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(fn)));
              } }]), Kt;
            }(pe.a.PureComponent), To = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                return pe.a.createElement("div", Nt(this.props.theme, "nan"), "NaN");
              } }]), Kt;
            }(pe.a.PureComponent), Ya = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                return pe.a.createElement("div", Nt(this.props.theme, "null"), "NULL");
              } }]), Kt;
            }(pe.a.PureComponent), $o = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props;
                return pe.a.createElement("div", Nt(yn.theme, "integer"), pe.a.createElement(er, Object.assign({ type_name: "int" }, yn)), this.props.value);
              } }]), Kt;
            }(pe.a.PureComponent), Hu = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props;
                return pe.a.createElement("div", Nt(yn.theme, "regexp"), pe.a.createElement(er, Object.assign({ type_name: "regexp" }, yn)), this.props.value.toString());
              } }]), Kt;
            }(pe.a.PureComponent), ms = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).toggleCollapsed = function() {
                  fn.setState({ collapsed: !fn.state.collapsed }, function() {
                    Fa.set(fn.props.rjvId, fn.props.namespace, "collapsed", fn.state.collapsed);
                  });
                }, fn.state = { collapsed: Fa.get(yn.rjvId, yn.namespace, "collapsed", true) }, fn;
              }
              return R(Kt, [{ key: "render", value: function() {
                this.state.collapsed;
                var yn = this.props, fn = yn.collapseStringsAfterLength, Br = yn.theme, Nr = yn.value, yi = { style: { cursor: "default" } };
                return rt2(fn) === "integer" && Nr.length > fn && (yi.style.cursor = "pointer", this.state.collapsed && (Nr = pe.a.createElement("span", null, Nr.substring(0, fn), pe.a.createElement("span", Nt(Br, "ellipsis"), " ...")))), pe.a.createElement("div", Nt(Br, "string"), pe.a.createElement(er, Object.assign({ type_name: "string" }, yn)), pe.a.createElement("span", Object.assign({ className: "string-value" }, yi, { onClick: this.toggleCollapsed }), '"', Nr, '"'));
              } }]), Kt;
            }(pe.a.PureComponent), sc = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                return pe.a.createElement("div", Nt(this.props.theme, "undefined"), "undefined");
              } }]), Kt;
            }(pe.a.PureComponent);
            function Oc() {
              return (Oc = Object.assign || function(En) {
                for (var Pn = 1; Pn < arguments.length; Pn++) {
                  var Kt = arguments[Pn];
                  for (var yn in Kt)
                    Object.prototype.hasOwnProperty.call(Kt, yn) && (En[yn] = Kt[yn]);
                }
                return En;
              }).apply(this, arguments);
            }
            var _c2 = _e.useLayoutEffect, _v = function(En) {
              var Pn = Object(_e.useRef)(En);
              return _c2(function() {
                Pn.current = En;
              }), Pn;
            }, cp = function(En, Pn) {
              typeof En != "function" ? En.current = Pn : En(Pn);
            }, Vg = function(En, Pn) {
              var Kt = Object(_e.useRef)();
              return Object(_e.useCallback)(function(yn) {
                En.current = yn, Kt.current && cp(Kt.current, null), Kt.current = Pn, Pn && cp(Pn, yn);
              }, [Pn]);
            }, rh = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, Mp = function(En) {
              Object.keys(rh).forEach(function(Pn) {
                En.style.setProperty(Pn, rh[Pn], "important");
              });
            }, fp = null, vx = function() {
            }, ea = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Qr = !!document.documentElement.currentStyle, Yr = function(En, Pn) {
              var Kt = En.cacheMeasurements, yn = En.maxRows, fn = En.minRows, Br = En.onChange, Nr = Br === void 0 ? vx : Br, yi = En.onHeightChange, Er = yi === void 0 ? vx : yi, _a2 = function(_s, df) {
                if (_s == null)
                  return {};
                var Wy, gx, b32 = {}, Ym = Object.keys(_s);
                for (gx = 0; gx < Ym.length; gx++)
                  Wy = Ym[gx], df.indexOf(Wy) >= 0 || (b32[Wy] = _s[Wy]);
                return b32;
              }(En, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), rs, wu = _a2.value !== void 0, _l = Object(_e.useRef)(null), Rf = Vg(_l, Pn), Ol = Object(_e.useRef)(0), Sf = Object(_e.useRef)(), qf = function() {
                var _s = _l.current, df = Kt && Sf.current ? Sf.current : function(Ym) {
                  var MC = window.getComputedStyle(Ym);
                  if (MC === null)
                    return null;
                  var TC, Ad = (TC = MC, ea.reduce(function(HE, AC) {
                    return HE[AC] = TC[AC], HE;
                  }, {})), DS = Ad.boxSizing;
                  return DS === "" ? null : (Qr && DS === "border-box" && (Ad.width = parseFloat(Ad.width) + parseFloat(Ad.borderRightWidth) + parseFloat(Ad.borderLeftWidth) + parseFloat(Ad.paddingRight) + parseFloat(Ad.paddingLeft) + "px"), { sizingStyle: Ad, paddingSize: parseFloat(Ad.paddingBottom) + parseFloat(Ad.paddingTop), borderSize: parseFloat(Ad.borderBottomWidth) + parseFloat(Ad.borderTopWidth) });
                }(_s);
                if (df) {
                  Sf.current = df;
                  var Wy = function(Ym, MC, TC, Ad) {
                    TC === void 0 && (TC = 1), Ad === void 0 && (Ad = 1 / 0), fp || ((fp = document.createElement("textarea")).setAttribute("tab-index", "-1"), fp.setAttribute("aria-hidden", "true"), Mp(fp)), fp.parentNode === null && document.body.appendChild(fp);
                    var DS = Ym.paddingSize, HE = Ym.borderSize, AC = Ym.sizingStyle, WE = AC.boxSizing;
                    Object.keys(AC).forEach(function(qE) {
                      var UT = qE;
                      fp.style[UT] = AC[UT];
                    }), Mp(fp), fp.value = MC;
                    var WT = function(qE, UT) {
                      var Xb = qE.scrollHeight;
                      return UT.sizingStyle.boxSizing === "border-box" ? Xb + UT.borderSize : Xb - UT.paddingSize;
                    }(fp, Ym);
                    fp.value = "x";
                    var zg = fp.scrollHeight - DS, UE = zg * TC;
                    WE === "border-box" && (UE = UE + DS + HE), WT = Math.max(UE, WT);
                    var kS = zg * Ad;
                    return WE === "border-box" && (kS = kS + DS + HE), [WT = Math.min(kS, WT), zg];
                  }(df, _s.value || _s.placeholder || "x", fn, yn), gx = Wy[0], b32 = Wy[1];
                  Ol.current !== gx && (Ol.current = gx, _s.style.setProperty("height", gx + "px", "important"), Er(gx, { rowHeight: b32 }));
                }
              };
              return Object(_e.useLayoutEffect)(qf), rs = _v(qf), Object(_e.useLayoutEffect)(function() {
                var _s = function(df) {
                  rs.current(df);
                };
                return window.addEventListener("resize", _s), function() {
                  window.removeEventListener("resize", _s);
                };
              }, []), Object(_e.createElement)("textarea", Oc({}, _a2, { onChange: function(_s) {
                wu || qf(), Nr(_s);
              }, ref: Rf }));
            }, na = Object(_e.forwardRef)(Yr);
            function lo(En) {
              En = En.trim();
              try {
                if ((En = JSON.stringify(JSON.parse(En)))[0] === "[")
                  return hs("array", JSON.parse(En));
                if (En[0] === "{")
                  return hs("object", JSON.parse(En));
                if (En.match(/\-?\d+\.\d+/) && En.match(/\-?\d+\.\d+/)[0] === En)
                  return hs("float", parseFloat(En));
                if (En.match(/\-?\d+e-\d+/) && En.match(/\-?\d+e-\d+/)[0] === En)
                  return hs("float", Number(En));
                if (En.match(/\-?\d+/) && En.match(/\-?\d+/)[0] === En)
                  return hs("integer", parseInt(En));
                if (En.match(/\-?\d+e\+\d+/) && En.match(/\-?\d+e\+\d+/)[0] === En)
                  return hs("integer", Number(En));
              } catch {
              }
              switch (En = En.toLowerCase()) {
                case "undefined":
                  return hs("undefined", void 0);
                case "nan":
                  return hs("nan", NaN);
                case "null":
                  return hs("null", null);
                case "true":
                  return hs("boolean", true);
                case "false":
                  return hs("boolean", false);
                default:
                  if (En = Date.parse(En))
                    return hs("date", new Date(En));
              }
              return hs(false, null);
            }
            function hs(En, Pn) {
              return { type: En, value: Pn };
            }
            var du = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
              } }]), Kt;
            }(pe.a.PureComponent), au = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
              } }]), Kt;
            }(pe.a.PureComponent), pf = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]), Nr = xc(fn).style;
                return pe.a.createElement("span", Br, pe.a.createElement("svg", { fill: Nr.color, width: Nr.height, height: Nr.width, style: Nr, viewBox: "0 0 1792 1792" }, pe.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Kt;
            }(pe.a.PureComponent), hp = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]), Nr = xc(fn).style;
                return pe.a.createElement("span", Br, pe.a.createElement("svg", { fill: Nr.color, width: Nr.height, height: Nr.width, style: Nr, viewBox: "0 0 1792 1792" }, pe.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
              } }]), Kt;
            }(pe.a.PureComponent), Ah = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", { style: T(T({}, xc(fn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, pe.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
              } }]), Kt;
            }(pe.a.PureComponent), Td = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", { style: T(T({}, xc(fn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, pe.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
              } }]), Kt;
            }(pe.a.PureComponent), Ih = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("g", null, pe.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
              } }]), Kt;
            }(pe.a.PureComponent), k0 = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("g", null, pe.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Kt;
            }(pe.a.PureComponent), jy = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("g", null, pe.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Kt;
            }(pe.a.PureComponent), J1 = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("g", null, pe.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
              } }]), Kt;
            }(pe.a.PureComponent), Gy = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("g", null, pe.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
              } }]), Kt;
            }(pe.a.PureComponent), $p = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.style, Br = Ye(yn, ["style"]);
                return pe.a.createElement("span", Br, pe.a.createElement("svg", Object.assign({}, xc(fn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), pe.a.createElement("g", null, pe.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
              } }]), Kt;
            }(pe.a.PureComponent);
            function xc(En) {
              return En || (En = {}), { style: T(T({ verticalAlign: "middle" }, En), {}, { color: En.color ? En.color : "#000000", height: "1em", width: "1em" }) };
            }
            var xv = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).copiedTimer = null, fn.handleCopy = function() {
                  var Br = document.createElement("textarea"), Nr = fn.props, yi = Nr.clickCallback, Er = Nr.src, _a2 = Nr.namespace;
                  Br.innerHTML = JSON.stringify(fn.clipboardValue(Er), null, "  "), document.body.appendChild(Br), Br.select(), document.execCommand("copy"), document.body.removeChild(Br), fn.copiedTimer = setTimeout(function() {
                    fn.setState({ copied: false });
                  }, 5500), fn.setState({ copied: true }, function() {
                    typeof yi == "function" && yi({ src: Er, namespace: _a2, name: _a2[_a2.length - 1] });
                  });
                }, fn.getClippyIcon = function() {
                  var Br = fn.props.theme;
                  return fn.state.copied ? pe.a.createElement("span", null, pe.a.createElement(Ih, Object.assign({ className: "copy-icon" }, Nt(Br, "copy-icon"))), pe.a.createElement("span", Nt(Br, "copy-icon-copied"), "\u2714")) : pe.a.createElement(Ih, Object.assign({ className: "copy-icon" }, Nt(Br, "copy-icon")));
                }, fn.clipboardValue = function(Br) {
                  switch (rt2(Br)) {
                    case "function":
                    case "regexp":
                      return Br.toString();
                    default:
                      return Br;
                  }
                }, fn.state = { copied: false }, fn;
              }
              return R(Kt, [{ key: "componentWillUnmount", value: function() {
                this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
              } }, { key: "render", value: function() {
                var yn = this.props, fn = (yn.src, yn.theme), Br = yn.hidden, Nr = yn.rowHovered, yi = Nt(fn, "copy-to-clipboard").style, Er = "inline";
                return Br && (Er = "none"), pe.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Nr ? "inline-block" : "none" } }, pe.a.createElement("span", { style: T(T({}, yi), {}, { display: Er }), onClick: this.handleCopy }, this.getClippyIcon()));
              } }]), Kt;
            }(pe.a.PureComponent), Bg = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).getEditIcon = function() {
                  var Br = fn.props, Nr = Br.variable, yi = Br.theme;
                  return pe.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: fn.state.hovered ? "inline-block" : "none" } }, pe.a.createElement(Gy, Object.assign({ className: "click-to-edit-icon" }, Nt(yi, "editVarIcon"), { onClick: function() {
                    fn.prepopInput(Nr);
                  } })));
                }, fn.prepopInput = function(Br) {
                  if (fn.props.onEdit !== false) {
                    var Nr = function(Er) {
                      var _a2;
                      switch (rt2(Er)) {
                        case "undefined":
                          _a2 = "undefined";
                          break;
                        case "nan":
                          _a2 = "NaN";
                          break;
                        case "string":
                          _a2 = Er;
                          break;
                        case "date":
                        case "function":
                        case "regexp":
                          _a2 = Er.toString();
                          break;
                        default:
                          try {
                            _a2 = JSON.stringify(Er, null, "  ");
                          } catch {
                            _a2 = "";
                          }
                      }
                      return _a2;
                    }(Br.value), yi = lo(Nr);
                    fn.setState({ editMode: true, editValue: Nr, parsedInput: { type: yi.type, value: yi.value } });
                  }
                }, fn.getRemoveIcon = function() {
                  var Br = fn.props, Nr = Br.variable, yi = Br.namespace, Er = Br.theme, _a2 = Br.rjvId;
                  return pe.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: fn.state.hovered ? "inline-block" : "none" } }, pe.a.createElement(k0, Object.assign({ className: "click-to-remove-icon" }, Nt(Er, "removeVarIcon"), { onClick: function() {
                    wo.dispatch({ name: "VARIABLE_REMOVED", rjvId: _a2, data: { name: Nr.name, namespace: yi, existing_value: Nr.value, variable_removed: true } });
                  } })));
                }, fn.getValue = function(Br, Nr) {
                  var yi = !Nr && Br.type, Er = ee(fn).props;
                  switch (yi) {
                    case false:
                      return fn.getEditInput();
                    case "string":
                      return pe.a.createElement(ms, Object.assign({ value: Br.value }, Er));
                    case "integer":
                      return pe.a.createElement($o, Object.assign({ value: Br.value }, Er));
                    case "float":
                      return pe.a.createElement(On, Object.assign({ value: Br.value }, Er));
                    case "boolean":
                      return pe.a.createElement(un, Object.assign({ value: Br.value }, Er));
                    case "function":
                      return pe.a.createElement(po, Object.assign({ value: Br.value }, Er));
                    case "null":
                      return pe.a.createElement(Ya, Er);
                    case "nan":
                      return pe.a.createElement(To, Er);
                    case "undefined":
                      return pe.a.createElement(sc, Er);
                    case "date":
                      return pe.a.createElement(pn, Object.assign({ value: Br.value }, Er));
                    case "regexp":
                      return pe.a.createElement(Hu, Object.assign({ value: Br.value }, Er));
                    default:
                      return pe.a.createElement("div", { className: "object-value" }, JSON.stringify(Br.value));
                  }
                }, fn.getEditInput = function() {
                  var Br = fn.props.theme, Nr = fn.state.editValue;
                  return pe.a.createElement("div", null, pe.a.createElement(na, Object.assign({ type: "text", inputRef: function(yi) {
                    return yi && yi.focus();
                  }, value: Nr, className: "variable-editor", onChange: function(yi) {
                    var Er = yi.target.value, _a2 = lo(Er);
                    fn.setState({ editValue: Er, parsedInput: { type: _a2.type, value: _a2.value } });
                  }, onKeyDown: function(yi) {
                    switch (yi.key) {
                      case "Escape":
                        fn.setState({ editMode: false, editValue: "" });
                        break;
                      case "Enter":
                        (yi.ctrlKey || yi.metaKey) && fn.submitEdit(true);
                    }
                    yi.stopPropagation();
                  }, placeholder: "update this value", minRows: 2 }, Nt(Br, "edit-input"))), pe.a.createElement("div", Nt(Br, "edit-icon-container"), pe.a.createElement(k0, Object.assign({ className: "edit-cancel" }, Nt(Br, "cancel-icon"), { onClick: function() {
                    fn.setState({ editMode: false, editValue: "" });
                  } })), pe.a.createElement($p, Object.assign({ className: "edit-check string-value" }, Nt(Br, "check-icon"), { onClick: function() {
                    fn.submitEdit();
                  } })), pe.a.createElement("div", null, fn.showDetected())));
                }, fn.submitEdit = function(Br) {
                  var Nr = fn.props, yi = Nr.variable, Er = Nr.namespace, _a2 = Nr.rjvId, rs = fn.state, wu = rs.editValue, _l = rs.parsedInput, Rf = wu;
                  Br && _l.type && (Rf = _l.value), fn.setState({ editMode: false }), wo.dispatch({ name: "VARIABLE_UPDATED", rjvId: _a2, data: { name: yi.name, namespace: Er, existing_value: yi.value, new_value: Rf, variable_removed: false } });
                }, fn.showDetected = function() {
                  var Br = fn.props, Nr = Br.theme, yi = (Br.variable, Br.namespace, Br.rjvId, fn.state.parsedInput), Er = (yi.type, yi.value, fn.getDetectedInput());
                  if (Er)
                    return pe.a.createElement("div", null, pe.a.createElement("div", Nt(Nr, "detected-row"), Er, pe.a.createElement($p, { className: "edit-check detected", style: T({ verticalAlign: "top", paddingLeft: "3px" }, Nt(Nr, "check-icon").style), onClick: function() {
                      fn.submitEdit(true);
                    } })));
                }, fn.getDetectedInput = function() {
                  var Br = fn.state.parsedInput, Nr = Br.type, yi = Br.value, Er = ee(fn).props, _a2 = Er.theme;
                  if (Nr !== false)
                    switch (Nr.toLowerCase()) {
                      case "object":
                        return pe.a.createElement("span", null, pe.a.createElement("span", { style: T(T({}, Nt(_a2, "brace").style), {}, { cursor: "default" }) }, "{"), pe.a.createElement("span", { style: T(T({}, Nt(_a2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), pe.a.createElement("span", { style: T(T({}, Nt(_a2, "brace").style), {}, { cursor: "default" }) }, "}"));
                      case "array":
                        return pe.a.createElement("span", null, pe.a.createElement("span", { style: T(T({}, Nt(_a2, "brace").style), {}, { cursor: "default" }) }, "["), pe.a.createElement("span", { style: T(T({}, Nt(_a2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), pe.a.createElement("span", { style: T(T({}, Nt(_a2, "brace").style), {}, { cursor: "default" }) }, "]"));
                      case "string":
                        return pe.a.createElement(ms, Object.assign({ value: yi }, Er));
                      case "integer":
                        return pe.a.createElement($o, Object.assign({ value: yi }, Er));
                      case "float":
                        return pe.a.createElement(On, Object.assign({ value: yi }, Er));
                      case "boolean":
                        return pe.a.createElement(un, Object.assign({ value: yi }, Er));
                      case "function":
                        return pe.a.createElement(po, Object.assign({ value: yi }, Er));
                      case "null":
                        return pe.a.createElement(Ya, Er);
                      case "nan":
                        return pe.a.createElement(To, Er);
                      case "undefined":
                        return pe.a.createElement(sc, Er);
                      case "date":
                        return pe.a.createElement(pn, Object.assign({ value: new Date(yi) }, Er));
                    }
                }, fn.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, fn;
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this, fn = this.props, Br = fn.variable, Nr = fn.singleIndent, yi = fn.type, Er = fn.theme, _a2 = fn.namespace, rs = fn.indentWidth, wu = fn.enableClipboard, _l = fn.onEdit, Rf = fn.onDelete, Ol = fn.onSelect, Sf = fn.displayArrayKey, qf = fn.quotesOnKeys, _s = this.state.editMode;
                return pe.a.createElement("div", Object.assign({}, Nt(Er, "objectKeyVal", { paddingLeft: rs * Nr }), { onMouseEnter: function() {
                  return yn.setState(T(T({}, yn.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return yn.setState(T(T({}, yn.state), {}, { hovered: false }));
                }, className: "variable-row", key: Br.name }), yi == "array" ? Sf ? pe.a.createElement("span", Object.assign({}, Nt(Er, "array-key"), { key: Br.name + "_" + _a2 }), Br.name, pe.a.createElement("div", Nt(Er, "colon"), ":")) : null : pe.a.createElement("span", null, pe.a.createElement("span", Object.assign({}, Nt(Er, "object-name"), { className: "object-key", key: Br.name + "_" + _a2 }), !!qf && pe.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), pe.a.createElement("span", { style: { display: "inline-block" } }, Br.name), !!qf && pe.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), pe.a.createElement("span", Nt(Er, "colon"), ":")), pe.a.createElement("div", Object.assign({ className: "variable-value", onClick: Ol === false && _l === false ? null : function(df) {
                  var Wy = Ja(_a2);
                  (df.ctrlKey || df.metaKey) && _l !== false ? yn.prepopInput(Br) : Ol !== false && (Wy.shift(), Ol(T(T({}, Br), {}, { namespace: Wy })));
                } }, Nt(Er, "variableValue", { cursor: Ol === false ? "default" : "pointer" })), this.getValue(Br, _s)), wu ? pe.a.createElement(xv, { rowHovered: this.state.hovered, hidden: _s, src: Br.value, clickCallback: wu, theme: Er, namespace: [].concat(Ja(_a2), [Br.name]) }) : null, _l !== false && _s == 0 ? this.getEditIcon() : null, Rf !== false && _s == 0 ? this.getRemoveIcon() : null);
              } }]), Kt;
            }(pe.a.PureComponent), $b = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                var yn;
                E(this, Kt);
                for (var fn = arguments.length, Br = new Array(fn), Nr = 0; Nr < fn; Nr++)
                  Br[Nr] = arguments[Nr];
                return (yn = Pn.call.apply(Pn, [this].concat(Br))).getObjectSize = function() {
                  var yi = yn.props, Er = yi.size, _a2 = yi.theme;
                  if (yi.displayObjectSize)
                    return pe.a.createElement("span", Object.assign({ className: "object-size" }, Nt(_a2, "object-size")), Er, " item", Er === 1 ? "" : "s");
                }, yn.getAddAttribute = function(yi) {
                  var Er = yn.props, _a2 = Er.theme, rs = Er.namespace, wu = Er.name, _l = Er.src, Rf = Er.rjvId, Ol = Er.depth;
                  return pe.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: yi ? "inline-block" : "none" } }, pe.a.createElement(jy, Object.assign({ className: "click-to-add-icon" }, Nt(_a2, "addVarIcon"), { onClick: function() {
                    var Sf = { name: Ol > 0 ? wu : null, namespace: rs.splice(0, rs.length - 1), existing_value: _l, variable_removed: false, key_name: null };
                    rt2(_l) === "object" ? wo.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Rf, data: Sf }) : wo.dispatch({ name: "VARIABLE_ADDED", rjvId: Rf, data: T(T({}, Sf), {}, { new_value: [].concat(Ja(_l), [null]) }) });
                  } })));
                }, yn.getRemoveObject = function(yi) {
                  var Er = yn.props, _a2 = Er.theme, rs = (Er.hover, Er.namespace), wu = Er.name, _l = Er.src, Rf = Er.rjvId;
                  if (rs.length !== 1)
                    return pe.a.createElement("span", { className: "click-to-remove", style: { display: yi ? "inline-block" : "none" } }, pe.a.createElement(k0, Object.assign({ className: "click-to-remove-icon" }, Nt(_a2, "removeVarIcon"), { onClick: function() {
                      wo.dispatch({ name: "VARIABLE_REMOVED", rjvId: Rf, data: { name: wu, namespace: rs.splice(0, rs.length - 1), existing_value: _l, variable_removed: true } });
                    } })));
                }, yn.render = function() {
                  var yi = yn.props, Er = yi.theme, _a2 = yi.onDelete, rs = yi.onAdd, wu = yi.enableClipboard, _l = yi.src, Rf = yi.namespace, Ol = yi.rowHovered;
                  return pe.a.createElement("div", Object.assign({}, Nt(Er, "object-meta-data"), { className: "object-meta-data", onClick: function(Sf) {
                    Sf.stopPropagation();
                  } }), yn.getObjectSize(), wu ? pe.a.createElement(xv, { rowHovered: Ol, clickCallback: wu, src: _l, theme: Er, namespace: Rf }) : null, rs !== false ? yn.getAddAttribute(Ol) : null, _a2 !== false ? yn.getRemoveObject(Ol) : null);
                }, yn;
              }
              return Kt;
            }(pe.a.PureComponent);
            function Xm(En) {
              var Pn = En.parent_type, Kt = En.namespace, yn = En.quotesOnKeys, fn = En.theme, Br = En.jsvRoot, Nr = En.name, yi = En.displayArrayKey, Er = En.name ? En.name : "";
              return !Br || Nr !== false && Nr !== null ? Pn == "array" ? yi ? pe.a.createElement("span", Object.assign({}, Nt(fn, "array-key"), { key: Kt }), pe.a.createElement("span", { className: "array-key" }, Er), pe.a.createElement("span", Nt(fn, "colon"), ":")) : pe.a.createElement("span", null) : pe.a.createElement("span", Object.assign({}, Nt(fn, "object-name"), { key: Kt }), pe.a.createElement("span", { className: "object-key" }, yn && pe.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), pe.a.createElement("span", null, Er), yn && pe.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), pe.a.createElement("span", Nt(fn, "colon"), ":")) : pe.a.createElement("span", null);
            }
            function Hy(En) {
              var Pn = En.theme;
              switch (En.iconStyle) {
                case "triangle":
                  return pe.a.createElement(Td, Object.assign({}, Nt(Pn, "expanded-icon"), { className: "expanded-icon" }));
                case "square":
                  return pe.a.createElement(pf, Object.assign({}, Nt(Pn, "expanded-icon"), { className: "expanded-icon" }));
                default:
                  return pe.a.createElement(du, Object.assign({}, Nt(Pn, "expanded-icon"), { className: "expanded-icon" }));
              }
            }
            function Q1(En) {
              var Pn = En.theme;
              switch (En.iconStyle) {
                case "triangle":
                  return pe.a.createElement(Ah, Object.assign({}, Nt(Pn, "collapsed-icon"), { className: "collapsed-icon" }));
                case "square":
                  return pe.a.createElement(hp, Object.assign({}, Nt(Pn, "collapsed-icon"), { className: "collapsed-icon" }));
                default:
                  return pe.a.createElement(au, Object.assign({}, Nt(Pn, "collapsed-icon"), { className: "collapsed-icon" }));
              }
            }
            var IS = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).toggleCollapsed = function(Br) {
                  var Nr = [];
                  for (var yi in fn.state.expanded)
                    Nr.push(fn.state.expanded[yi]);
                  Nr[Br] = !Nr[Br], fn.setState({ expanded: Nr });
                }, fn.state = { expanded: [] }, fn;
              }
              return R(Kt, [{ key: "getExpandedIcon", value: function(yn) {
                var fn = this.props, Br = fn.theme, Nr = fn.iconStyle;
                return this.state.expanded[yn] ? pe.a.createElement(Hy, { theme: Br, iconStyle: Nr }) : pe.a.createElement(Q1, { theme: Br, iconStyle: Nr });
              } }, { key: "render", value: function() {
                var yn = this, fn = this.props, Br = fn.src, Nr = fn.groupArraysAfterLength, yi = (fn.depth, fn.name), Er = fn.theme, _a2 = fn.jsvRoot, rs = fn.namespace, wu = (fn.parent_type, Ye(fn, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), _l = 0, Rf = 5 * this.props.indentWidth;
                _a2 || (_l = 5 * this.props.indentWidth);
                var Ol = Nr, Sf = Math.ceil(Br.length / Ol);
                return pe.a.createElement("div", Object.assign({ className: "object-key-val" }, Nt(Er, _a2 ? "jsv-root" : "objectKeyVal", { paddingLeft: _l })), pe.a.createElement(Xm, this.props), pe.a.createElement("span", null, pe.a.createElement($b, Object.assign({ size: Br.length }, this.props))), Ja(Array(Sf)).map(function(qf, _s) {
                  return pe.a.createElement("div", Object.assign({ key: _s, className: "object-key-val array-group" }, Nt(Er, "objectKeyVal", { marginLeft: 6, paddingLeft: Rf })), pe.a.createElement("span", Nt(Er, "brace-row"), pe.a.createElement("div", Object.assign({ className: "icon-container" }, Nt(Er, "icon-container"), { onClick: function(df) {
                    yn.toggleCollapsed(_s);
                  } }), yn.getExpandedIcon(_s)), yn.state.expanded[_s] ? pe.a.createElement(HT, Object.assign({ key: yi + _s, depth: 0, name: false, collapsed: false, groupArraysAfterLength: Ol, index_offset: _s * Ol, src: Br.slice(_s * Ol, _s * Ol + Ol), namespace: rs, type: "array", parent_type: "array_group", theme: Er }, wu)) : pe.a.createElement("span", Object.assign({}, Nt(Er, "brace"), { onClick: function(df) {
                    yn.toggleCollapsed(_s);
                  }, className: "array-group-brace" }), "[", pe.a.createElement("div", Object.assign({}, Nt(Er, "array-group-meta-data"), { className: "array-group-meta-data" }), pe.a.createElement("span", Object.assign({ className: "object-size" }, Nt(Er, "object-size")), _s * Ol, " - ", _s * Ol + Ol > Br.length ? Br.length : _s * Ol + Ol)), "]")));
                }));
              } }]), Kt;
            }(pe.a.PureComponent), ES = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                E(this, Kt), (fn = Pn.call(this, yn)).toggleCollapsed = function() {
                  fn.setState({ expanded: !fn.state.expanded }, function() {
                    Fa.set(fn.props.rjvId, fn.props.namespace, "expanded", fn.state.expanded);
                  });
                }, fn.getObjectContent = function(Nr, yi, Er) {
                  return pe.a.createElement("div", { className: "pushed-content object-container" }, pe.a.createElement("div", Object.assign({ className: "object-content" }, Nt(fn.props.theme, "pushed-content")), fn.renderObjectContents(yi, Er)));
                }, fn.getEllipsis = function() {
                  return fn.state.size === 0 ? null : pe.a.createElement("div", Object.assign({}, Nt(fn.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: fn.toggleCollapsed }), "...");
                }, fn.getObjectMetaData = function(Nr) {
                  var yi = fn.props, Er = (yi.rjvId, yi.theme, fn.state), _a2 = Er.size, rs = Er.hovered;
                  return pe.a.createElement($b, Object.assign({ rowHovered: rs, size: _a2 }, fn.props));
                }, fn.renderObjectContents = function(Nr, yi) {
                  var Er, _a2 = fn.props, rs = _a2.depth, wu = _a2.parent_type, _l = _a2.index_offset, Rf = _a2.groupArraysAfterLength, Ol = _a2.namespace, Sf = fn.state.object_type, qf = [], _s = Object.keys(Nr || {});
                  return fn.props.sortKeys && Sf !== "array" && (_s = _s.sort()), _s.forEach(function(df) {
                    if (Er = new LX(df, Nr[df]), wu === "array_group" && _l && (Er.name = parseInt(Er.name) + _l), Nr.hasOwnProperty(df))
                      if (Er.type === "object")
                        qf.push(pe.a.createElement(HT, Object.assign({ key: Er.name, depth: rs + 1, name: Er.name, src: Er.value, namespace: Ol.concat(Er.name), parent_type: Sf }, yi)));
                      else if (Er.type === "array") {
                        var Wy = HT;
                        Rf && Er.value.length > Rf && (Wy = IS), qf.push(pe.a.createElement(Wy, Object.assign({ key: Er.name, depth: rs + 1, name: Er.name, src: Er.value, namespace: Ol.concat(Er.name), type: "array", parent_type: Sf }, yi)));
                      } else
                        qf.push(pe.a.createElement(Bg, Object.assign({ key: Er.name + "_" + Ol, variable: Er, singleIndent: 5, namespace: Ol, type: fn.props.type }, yi)));
                  }), qf;
                };
                var Br = Kt.getState(yn);
                return fn.state = T(T({}, Br), {}, { prevProps: {} }), fn;
              }
              return R(Kt, [{ key: "getBraceStart", value: function(yn, fn) {
                var Br = this, Nr = this.props, yi = Nr.src, Er = Nr.theme, _a2 = Nr.iconStyle;
                if (Nr.parent_type === "array_group")
                  return pe.a.createElement("span", null, pe.a.createElement("span", Nt(Er, "brace"), yn === "array" ? "[" : "{"), fn ? this.getObjectMetaData(yi) : null);
                var rs = fn ? Hy : Q1;
                return pe.a.createElement("span", null, pe.a.createElement("span", Object.assign({ onClick: function(wu) {
                  Br.toggleCollapsed();
                } }, Nt(Er, "brace-row")), pe.a.createElement("div", Object.assign({ className: "icon-container" }, Nt(Er, "icon-container")), pe.a.createElement(rs, { theme: Er, iconStyle: _a2 })), pe.a.createElement(Xm, this.props), pe.a.createElement("span", Nt(Er, "brace"), yn === "array" ? "[" : "{")), fn ? this.getObjectMetaData(yi) : null);
              } }, { key: "render", value: function() {
                var yn = this, fn = this.props, Br = fn.depth, Nr = fn.src, yi = (fn.namespace, fn.name, fn.type, fn.parent_type), Er = fn.theme, _a2 = fn.jsvRoot, rs = fn.iconStyle, wu = Ye(fn, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), _l = this.state, Rf = _l.object_type, Ol = _l.expanded, Sf = {};
                return _a2 || yi === "array_group" ? yi === "array_group" && (Sf.borderLeft = 0, Sf.display = "inline") : Sf.paddingLeft = 5 * this.props.indentWidth, pe.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                  return yn.setState(T(T({}, yn.state), {}, { hovered: true }));
                }, onMouseLeave: function() {
                  return yn.setState(T(T({}, yn.state), {}, { hovered: false }));
                } }, Nt(Er, _a2 ? "jsv-root" : "objectKeyVal", Sf)), this.getBraceStart(Rf, Ol), Ol ? this.getObjectContent(Br, Nr, T({ theme: Er, iconStyle: rs }, wu)) : this.getEllipsis(), pe.a.createElement("span", { className: "brace-row" }, pe.a.createElement("span", { style: T(T({}, Nt(Er, "brace").style), {}, { paddingLeft: Ol ? "3px" : "0px" }) }, Rf === "array" ? "]" : "}"), Ol ? null : this.getObjectMetaData(Nr)));
              } }], [{ key: "getDerivedStateFromProps", value: function(yn, fn) {
                var Br = fn.prevProps;
                return yn.src !== Br.src || yn.collapsed !== Br.collapsed || yn.name !== Br.name || yn.namespace !== Br.namespace || yn.rjvId !== Br.rjvId ? T(T({}, Kt.getState(yn)), {}, { prevProps: yn }) : null;
              } }]), Kt;
            }(pe.a.PureComponent);
            ES.getState = function(En) {
              var Pn = Object.keys(En.src).length, Kt = (En.collapsed === false || En.collapsed !== true && En.collapsed > En.depth) && (!En.shouldCollapse || En.shouldCollapse({ name: En.name, src: En.src, type: rt2(En.src), namespace: En.namespace }) === false) && Pn !== 0;
              return { expanded: Fa.get(En.rjvId, En.namespace, "expanded", Kt), object_type: En.type === "array" ? "array" : "object", parent_type: En.type === "array" ? "array" : "object", size: Pn, hovered: false };
            };
            var LX = function En(Pn, Kt) {
              E(this, En), this.name = Pn, this.value = Kt, this.type = rt2(Kt);
            };
            Xe(ES);
            var HT = ES, RX = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                var yn;
                E(this, Kt);
                for (var fn = arguments.length, Br = new Array(fn), Nr = 0; Nr < fn; Nr++)
                  Br[Nr] = arguments[Nr];
                return (yn = Pn.call.apply(Pn, [this].concat(Br))).render = function() {
                  var yi = ee(yn).props, Er = [yi.name], _a2 = HT;
                  return Array.isArray(yi.src) && yi.groupArraysAfterLength && yi.src.length > yi.groupArraysAfterLength && (_a2 = IS), pe.a.createElement("div", { className: "pretty-json-container object-container" }, pe.a.createElement("div", { className: "object-content" }, pe.a.createElement(_a2, Object.assign({ namespace: Er, depth: 0, jsvRoot: true }, yi))));
                }, yn;
              }
              return Kt;
            }(pe.a.PureComponent), NX = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).closeModal = function() {
                  wo.dispatch({ rjvId: fn.props.rjvId, name: "RESET" });
                }, fn.submit = function() {
                  fn.props.submit(fn.state.input);
                }, fn.state = { input: yn.input ? yn.input : "" }, fn;
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this, fn = this.props, Br = fn.theme, Nr = fn.rjvId, yi = fn.isValid, Er = this.state.input, _a2 = yi(Er);
                return pe.a.createElement("div", Object.assign({ className: "key-modal-request" }, Nt(Br, "key-modal-request"), { onClick: this.closeModal }), pe.a.createElement("div", Object.assign({}, Nt(Br, "key-modal"), { onClick: function(rs) {
                  rs.stopPropagation();
                } }), pe.a.createElement("div", Nt(Br, "key-modal-label"), "Key Name:"), pe.a.createElement("div", { style: { position: "relative" } }, pe.a.createElement("input", Object.assign({}, Nt(Br, "key-modal-input"), { className: "key-modal-input", ref: function(rs) {
                  return rs && rs.focus();
                }, spellCheck: false, value: Er, placeholder: "...", onChange: function(rs) {
                  yn.setState({ input: rs.target.value });
                }, onKeyPress: function(rs) {
                  _a2 && rs.key === "Enter" ? yn.submit() : rs.key === "Escape" && yn.closeModal();
                } })), _a2 ? pe.a.createElement($p, Object.assign({}, Nt(Br, "key-modal-submit"), { className: "key-modal-submit", onClick: function(rs) {
                  return yn.submit();
                } })) : null), pe.a.createElement("span", Nt(Br, "key-modal-cancel"), pe.a.createElement(J1, Object.assign({}, Nt(Br, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                  wo.dispatch({ rjvId: Nr, name: "RESET" });
                } })))));
              } }]), Kt;
            }(pe.a.PureComponent), FX = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                var yn;
                E(this, Kt);
                for (var fn = arguments.length, Br = new Array(fn), Nr = 0; Nr < fn; Nr++)
                  Br[Nr] = arguments[Nr];
                return (yn = Pn.call.apply(Pn, [this].concat(Br))).isValid = function(yi) {
                  var Er = yn.props.rjvId, _a2 = Fa.get(Er, "action", "new-key-request");
                  return yi != "" && Object.keys(_a2.existing_value).indexOf(yi) === -1;
                }, yn.submit = function(yi) {
                  var Er = yn.props.rjvId, _a2 = Fa.get(Er, "action", "new-key-request");
                  _a2.new_value = T({}, _a2.existing_value), _a2.new_value[yi] = yn.props.defaultValue, wo.dispatch({ name: "VARIABLE_ADDED", rjvId: Er, data: _a2 });
                }, yn;
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.active, Br = yn.theme, Nr = yn.rjvId;
                return fn ? pe.a.createElement(NX, { rjvId: Nr, theme: Br, isValid: this.isValid, submit: this.submit }) : null;
              } }]), Kt;
            }(pe.a.PureComponent), VX = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt() {
                return E(this, Kt), Pn.apply(this, arguments);
              }
              return R(Kt, [{ key: "render", value: function() {
                var yn = this.props, fn = yn.message, Br = yn.active, Nr = yn.theme, yi = yn.rjvId;
                return Br ? pe.a.createElement("div", Object.assign({ className: "validation-failure" }, Nt(Nr, "validation-failure"), { onClick: function() {
                  wo.dispatch({ rjvId: yi, name: "RESET" });
                } }), pe.a.createElement("span", Nt(Nr, "validation-failure-label"), fn), pe.a.createElement(J1, Nt(Nr, "validation-failure-clear"))) : null;
              } }]), Kt;
            }(pe.a.PureComponent), m32 = function(En) {
              z3(Kt, En);
              var Pn = fe(Kt);
              function Kt(yn) {
                var fn;
                return E(this, Kt), (fn = Pn.call(this, yn)).rjvId = Date.now().toString(), fn.getListeners = function() {
                  return { reset: fn.resetState, "variable-update": fn.updateSrc, "add-key-request": fn.addKeyRequest };
                }, fn.updateSrc = function() {
                  var Br, Nr = Fa.get(fn.rjvId, "action", "variable-update"), yi = Nr.name, Er = Nr.namespace, _a2 = Nr.new_value, rs = Nr.existing_value, wu = (Nr.variable_removed, Nr.updated_src), _l = Nr.type, Rf = fn.props, Ol = Rf.onEdit, Sf = Rf.onDelete, qf = Rf.onAdd, _s = { existing_src: fn.state.src, new_value: _a2, updated_src: wu, name: yi, namespace: Er, existing_value: rs };
                  switch (_l) {
                    case "variable-added":
                      Br = qf(_s);
                      break;
                    case "variable-edited":
                      Br = Ol(_s);
                      break;
                    case "variable-removed":
                      Br = Sf(_s);
                  }
                  Br !== false ? (Fa.set(fn.rjvId, "global", "src", wu), fn.setState({ src: wu })) : fn.setState({ validationFailure: true });
                }, fn.addKeyRequest = function() {
                  fn.setState({ addKeyRequest: true });
                }, fn.resetState = function() {
                  fn.setState({ validationFailure: false, addKeyRequest: false });
                }, fn.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Kt.defaultProps.src, name: Kt.defaultProps.name, theme: Kt.defaultProps.theme, validationMessage: Kt.defaultProps.validationMessage, prevSrc: Kt.defaultProps.src, prevName: Kt.defaultProps.name, prevTheme: Kt.defaultProps.theme }, fn;
              }
              return R(Kt, [{ key: "componentDidMount", value: function() {
                Fa.set(this.rjvId, "global", "src", this.state.src);
                var yn = this.getListeners();
                for (var fn in yn)
                  Fa.on(fn + "-" + this.rjvId, yn[fn]);
                this.setState({ addKeyRequest: false, editKeyRequest: false });
              } }, { key: "componentDidUpdate", value: function(yn, fn) {
                fn.addKeyRequest !== false && this.setState({ addKeyRequest: false }), fn.editKeyRequest !== false && this.setState({ editKeyRequest: false }), yn.src !== this.state.src && Fa.set(this.rjvId, "global", "src", this.state.src);
              } }, { key: "componentWillUnmount", value: function() {
                var yn = this.getListeners();
                for (var fn in yn)
                  Fa.removeListener(fn + "-" + this.rjvId, yn[fn]);
              } }, { key: "render", value: function() {
                var yn = this.state, fn = yn.validationFailure, Br = yn.validationMessage, Nr = yn.addKeyRequest, yi = yn.theme, Er = yn.src, _a2 = yn.name, rs = this.props, wu = rs.style, _l = rs.defaultValue;
                return pe.a.createElement("div", { className: "react-json-view", style: T(T({}, Nt(yi, "app-container").style), wu) }, pe.a.createElement(VX, { message: Br, active: fn, theme: yi, rjvId: this.rjvId }), pe.a.createElement(RX, Object.assign({}, this.props, { src: Er, name: _a2, theme: yi, type: rt2(Er), rjvId: this.rjvId })), pe.a.createElement(FX, { active: Nr, theme: yi, rjvId: this.rjvId, defaultValue: _l }));
              } }], [{ key: "getDerivedStateFromProps", value: function(yn, fn) {
                if (yn.src !== fn.prevSrc || yn.name !== fn.prevName || yn.theme !== fn.prevTheme) {
                  var Br = { src: yn.src, name: yn.name, theme: yn.theme, validationMessage: yn.validationMessage, prevSrc: yn.src, prevName: yn.name, prevTheme: yn.theme };
                  return Kt.validateState(Br);
                }
                return null;
              } }]), Kt;
            }(pe.a.PureComponent);
            m32.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, m32.validateState = function(En) {
              var Pn = {};
              return rt2(En.theme) !== "object" || function(Kt) {
                var yn = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
                if (rt2(Kt) === "object") {
                  for (var fn = 0; fn < yn.length; fn++)
                    if (!(yn[fn] in Kt))
                      return false;
                  return true;
                }
                return false;
              }(En.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Pn.theme = "rjv-default"), rt2(En.src) !== "object" && rt2(En.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Pn.name = "ERROR", Pn.src = { message: "src property must be a valid json object" }), T(T({}, En), Pn);
            }, Xe(m32), d4.default = m32;
          }]);
        });
      })(EQe);
      var ken = vt(EQe.exports);
      const Oen = ({ id: s, title: a, chart: n6, option: f6 }) => {
        const { tool: d4 } = jCe({}), y4 = _se({ global: true }), [_, { set: S }] = Q(true);
        console.log("option", f6);
        const T = (E) => {
          const { updated_src: O } = E;
          n6 == null || n6.setOption(O), d4 == null || d4.add(s, n6, O, a), y4.emit("list");
        };
        return ven("div", { children: [yV(xen, { children: yV(Men, { children: yV(Aen, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (E) => {
          S(!E);
        } }) }) }), yV("br", {}), f6 && yV(ken, { src: f6, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: _, iconStyle: "triangle", enableClipboard: true, onEdit: T, onAdd: T, onDelete: T })] });
      };
      o.EchartTool = Den, o.ReactEchartsJson = Oen, o.useEcharts = qZt, o.useEchartsTool = jCe, o.useEventEmitter = _se;
    })(TRt);
    const ARt = () => {
      const o = rre({ global: true }), i = C.useRef(0), { tool: t3 } = _1e({});
      C.useState(false), C.useState("right");
      const [c3, p3] = C.useState([]), [g3, b3] = C.useState();
      return o.useSubscription("list", () => {
        var w3;
        t3 != null && t3.list().length && (b3((w3 = t3 == null ? void 0 : t3.list()) == null ? void 0 : w3[i.current]), p3(t3 == null ? void 0 : t3.list()));
      }), o9("div", { className: MRt.container, children: false });
    };
    var uje = { exports: {} };
    (function(o, i) {
      (function(t3, c3) {
        o.exports = c3(P.default);
      })(_t, function(t3) {
        return function(c3) {
          var p3 = {};
          function g3(b3) {
            if (p3[b3])
              return p3[b3].exports;
            var w3 = p3[b3] = { i: b3, l: false, exports: {} };
            return c3[b3].call(w3.exports, w3, w3.exports, g3), w3.l = true, w3.exports;
          }
          return g3.m = c3, g3.c = p3, g3.d = function(b3, w3, M) {
            g3.o(b3, w3) || Object.defineProperty(b3, w3, { enumerable: true, get: M });
          }, g3.r = function(b3) {
            typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(b3, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(b3, "__esModule", { value: true });
          }, g3.t = function(b3, w3) {
            if (1 & w3 && (b3 = g3(b3)), 8 & w3 || 4 & w3 && typeof b3 == "object" && b3 && b3.__esModule)
              return b3;
            var M = /* @__PURE__ */ Object.create(null);
            if (g3.r(M), Object.defineProperty(M, "default", { enumerable: true, value: b3 }), 2 & w3 && typeof b3 != "string")
              for (var I in b3)
                g3.d(M, I, function(k3) {
                  return b3[k3];
                }.bind(null, I));
            return M;
          }, g3.n = function(b3) {
            var w3 = b3 && b3.__esModule ? function() {
              return b3.default;
            } : function() {
              return b3;
            };
            return g3.d(w3, "a", w3), w3;
          }, g3.o = function(b3, w3) {
            return Object.prototype.hasOwnProperty.call(b3, w3);
          }, g3.p = "", g3(g3.s = 48);
        }([function(c3, p3) {
          c3.exports = t3;
        }, function(c3, p3) {
          var g3 = c3.exports = { version: "2.6.12" };
          typeof __e == "number" && (__e = g3);
        }, function(c3, p3, g3) {
          var b3 = g3(26)("wks"), w3 = g3(17), M = g3(3).Symbol, I = typeof M == "function";
          (c3.exports = function(k3) {
            return b3[k3] || (b3[k3] = I && M[k3] || (I ? M : w3)("Symbol." + k3));
          }).store = b3;
        }, function(c3, p3) {
          var g3 = c3.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
          typeof __g == "number" && (__g = g3);
        }, function(c3, p3, g3) {
          c3.exports = !g3(8)(function() {
            return Object.defineProperty({}, "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(c3, p3) {
          var g3 = {}.hasOwnProperty;
          c3.exports = function(b3, w3) {
            return g3.call(b3, w3);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(7), w3 = g3(16);
          c3.exports = g3(4) ? function(M, I, k3) {
            return b3.f(M, I, w3(1, k3));
          } : function(M, I, k3) {
            return M[I] = k3, M;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(10), w3 = g3(35), M = g3(23), I = Object.defineProperty;
          p3.f = g3(4) ? Object.defineProperty : function(k3, L, F) {
            if (b3(k3), L = M(L, true), b3(F), w3)
              try {
                return I(k3, L, F);
              } catch {
              }
            if ("get" in F || "set" in F)
              throw TypeError("Accessors not supported!");
            return "value" in F && (k3[L] = F.value), k3;
          };
        }, function(c3, p3) {
          c3.exports = function(g3) {
            try {
              return !!g3();
            } catch {
              return true;
            }
          };
        }, function(c3, p3, g3) {
          var b3 = g3(40), w3 = g3(22);
          c3.exports = function(M) {
            return b3(w3(M));
          };
        }, function(c3, p3, g3) {
          var b3 = g3(11);
          c3.exports = function(w3) {
            if (!b3(w3))
              throw TypeError(w3 + " is not an object!");
            return w3;
          };
        }, function(c3, p3) {
          c3.exports = function(g3) {
            return typeof g3 == "object" ? g3 !== null : typeof g3 == "function";
          };
        }, function(c3, p3) {
          c3.exports = {};
        }, function(c3, p3, g3) {
          var b3 = g3(39), w3 = g3(27);
          c3.exports = Object.keys || function(M) {
            return b3(M, w3);
          };
        }, function(c3, p3) {
          c3.exports = true;
        }, function(c3, p3, g3) {
          var b3 = g3(3), w3 = g3(1), M = g3(53), I = g3(6), k3 = g3(5), L = function(F, B, G) {
            var J, Q, se, he = F & L.F, be = F & L.G, de = F & L.S, Fe = F & L.P, Pe = F & L.B, ze = F & L.W, $e = be ? w3 : w3[B] || (w3[B] = {}), Ke = $e.prototype, nt = be ? b3 : de ? b3[B] : (b3[B] || {}).prototype;
            for (J in be && (G = B), G)
              (Q = !he && nt && nt[J] !== void 0) && k3($e, J) || (se = Q ? nt[J] : G[J], $e[J] = be && typeof nt[J] != "function" ? G[J] : Pe && Q ? M(se, b3) : ze && nt[J] == se ? function(lt2) {
                var bt = function(vt, jt, Jt) {
                  if (this instanceof lt2) {
                    switch (arguments.length) {
                      case 0:
                        return new lt2();
                      case 1:
                        return new lt2(vt);
                      case 2:
                        return new lt2(vt, jt);
                    }
                    return new lt2(vt, jt, Jt);
                  }
                  return lt2.apply(this, arguments);
                };
                return bt.prototype = lt2.prototype, bt;
              }(se) : Fe && typeof se == "function" ? M(Function.call, se) : se, Fe && (($e.virtual || ($e.virtual = {}))[J] = se, F & L.R && Ke && !Ke[J] && I(Ke, J, se)));
          };
          L.F = 1, L.G = 2, L.S = 4, L.P = 8, L.B = 16, L.W = 32, L.U = 64, L.R = 128, c3.exports = L;
        }, function(c3, p3) {
          c3.exports = function(g3, b3) {
            return { enumerable: !(1 & g3), configurable: !(2 & g3), writable: !(4 & g3), value: b3 };
          };
        }, function(c3, p3) {
          var g3 = 0, b3 = Math.random();
          c3.exports = function(w3) {
            return "Symbol(".concat(w3 === void 0 ? "" : w3, ")_", (++g3 + b3).toString(36));
          };
        }, function(c3, p3, g3) {
          var b3 = g3(22);
          c3.exports = function(w3) {
            return Object(b3(w3));
          };
        }, function(c3, p3) {
          p3.f = {}.propertyIsEnumerable;
        }, function(c3, p3, g3) {
          var b3 = g3(52)(true);
          g3(34)(String, "String", function(w3) {
            this._t = String(w3), this._i = 0;
          }, function() {
            var w3, M = this._t, I = this._i;
            return I >= M.length ? { value: void 0, done: true } : (w3 = b3(M, I), this._i += w3.length, { value: w3, done: false });
          });
        }, function(c3, p3) {
          var g3 = Math.ceil, b3 = Math.floor;
          c3.exports = function(w3) {
            return isNaN(w3 = +w3) ? 0 : (w3 > 0 ? b3 : g3)(w3);
          };
        }, function(c3, p3) {
          c3.exports = function(g3) {
            if (g3 == null)
              throw TypeError("Can't call method on  " + g3);
            return g3;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(11);
          c3.exports = function(w3, M) {
            if (!b3(w3))
              return w3;
            var I, k3;
            if (M && typeof (I = w3.toString) == "function" && !b3(k3 = I.call(w3)) || typeof (I = w3.valueOf) == "function" && !b3(k3 = I.call(w3)) || !M && typeof (I = w3.toString) == "function" && !b3(k3 = I.call(w3)))
              return k3;
            throw TypeError("Can't convert object to primitive value");
          };
        }, function(c3, p3) {
          var g3 = {}.toString;
          c3.exports = function(b3) {
            return g3.call(b3).slice(8, -1);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(26)("keys"), w3 = g3(17);
          c3.exports = function(M) {
            return b3[M] || (b3[M] = w3(M));
          };
        }, function(c3, p3, g3) {
          var b3 = g3(1), w3 = g3(3), M = w3["__core-js_shared__"] || (w3["__core-js_shared__"] = {});
          (c3.exports = function(I, k3) {
            return M[I] || (M[I] = k3 !== void 0 ? k3 : {});
          })("versions", []).push({ version: b3.version, mode: g3(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
        }, function(c3, p3) {
          c3.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
        }, function(c3, p3, g3) {
          var b3 = g3(7).f, w3 = g3(5), M = g3(2)("toStringTag");
          c3.exports = function(I, k3, L) {
            I && !w3(I = L ? I : I.prototype, M) && b3(I, M, { configurable: true, value: k3 });
          };
        }, function(c3, p3, g3) {
          g3(62);
          for (var b3 = g3(3), w3 = g3(6), M = g3(12), I = g3(2)("toStringTag"), k3 = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), L = 0; L < k3.length; L++) {
            var F = k3[L], B = b3[F], G = B && B.prototype;
            G && !G[I] && w3(G, I, F), M[F] = M.Array;
          }
        }, function(c3, p3, g3) {
          p3.f = g3(2);
        }, function(c3, p3, g3) {
          var b3 = g3(3), w3 = g3(1), M = g3(14), I = g3(30), k3 = g3(7).f;
          c3.exports = function(L) {
            var F = w3.Symbol || (w3.Symbol = M ? {} : b3.Symbol || {});
            L.charAt(0) == "_" || L in F || k3(F, L, { value: I.f(L) });
          };
        }, function(c3, p3) {
          p3.f = Object.getOwnPropertySymbols;
        }, function(c3, p3) {
          c3.exports = function(g3, b3, w3) {
            return Math.min(Math.max(g3, b3), w3);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(14), w3 = g3(15), M = g3(37), I = g3(6), k3 = g3(12), L = g3(55), F = g3(28), B = g3(61), G = g3(2)("iterator"), J = !([].keys && "next" in [].keys()), Q = function() {
            return this;
          };
          c3.exports = function(se, he, be, de, Fe, Pe, ze) {
            L(be, he, de);
            var $e, Ke, nt, lt2 = function(kn) {
              if (!J && kn in Jt)
                return Jt[kn];
              switch (kn) {
                case "keys":
                case "values":
                  return function() {
                    return new be(this, kn);
                  };
              }
              return function() {
                return new be(this, kn);
              };
            }, bt = he + " Iterator", vt = Fe == "values", jt = false, Jt = se.prototype, Rt = Jt[G] || Jt["@@iterator"] || Fe && Jt[Fe], Jn = Rt || lt2(Fe), ln = Fe ? vt ? lt2("entries") : Jn : void 0, vn = he == "Array" && Jt.entries || Rt;
            if (vn && (nt = B(vn.call(new se()))) !== Object.prototype && nt.next && (F(nt, bt, true), b3 || typeof nt[G] == "function" || I(nt, G, Q)), vt && Rt && Rt.name !== "values" && (jt = true, Jn = function() {
              return Rt.call(this);
            }), b3 && !ze || !J && !jt && Jt[G] || I(Jt, G, Jn), k3[he] = Jn, k3[bt] = Q, Fe)
              if ($e = { values: vt ? Jn : lt2("values"), keys: Pe ? Jn : lt2("keys"), entries: ln }, ze)
                for (Ke in $e)
                  Ke in Jt || M(Jt, Ke, $e[Ke]);
              else
                w3(w3.P + w3.F * (J || jt), he, $e);
            return $e;
          };
        }, function(c3, p3, g3) {
          c3.exports = !g3(4) && !g3(8)(function() {
            return Object.defineProperty(g3(36)("div"), "a", { get: function() {
              return 7;
            } }).a != 7;
          });
        }, function(c3, p3, g3) {
          var b3 = g3(11), w3 = g3(3).document, M = b3(w3) && b3(w3.createElement);
          c3.exports = function(I) {
            return M ? w3.createElement(I) : {};
          };
        }, function(c3, p3, g3) {
          c3.exports = g3(6);
        }, function(c3, p3, g3) {
          var b3 = g3(10), w3 = g3(56), M = g3(27), I = g3(25)("IE_PROTO"), k3 = function() {
          }, L = function() {
            var F, B = g3(36)("iframe"), G = M.length;
            for (B.style.display = "none", g3(60).appendChild(B), B.src = "javascript:", (F = B.contentWindow.document).open(), F.write("<script>document.F=Object<\/script>"), F.close(), L = F.F; G--; )
              delete L.prototype[M[G]];
            return L();
          };
          c3.exports = Object.create || function(F, B) {
            var G;
            return F !== null ? (k3.prototype = b3(F), G = new k3(), k3.prototype = null, G[I] = F) : G = L(), B === void 0 ? G : w3(G, B);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(5), w3 = g3(9), M = g3(57)(false), I = g3(25)("IE_PROTO");
          c3.exports = function(k3, L) {
            var F, B = w3(k3), G = 0, J = [];
            for (F in B)
              F != I && b3(B, F) && J.push(F);
            for (; L.length > G; )
              b3(B, F = L[G++]) && (~M(J, F) || J.push(F));
            return J;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(24);
          c3.exports = Object("z").propertyIsEnumerable(0) ? Object : function(w3) {
            return b3(w3) == "String" ? w3.split("") : Object(w3);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(39), w3 = g3(27).concat("length", "prototype");
          p3.f = Object.getOwnPropertyNames || function(M) {
            return b3(M, w3);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(24), w3 = g3(2)("toStringTag"), M = b3(function() {
            return arguments;
          }()) == "Arguments";
          c3.exports = function(I) {
            var k3, L, F;
            return I === void 0 ? "Undefined" : I === null ? "Null" : typeof (L = function(B, G) {
              try {
                return B[G];
              } catch {
              }
            }(k3 = Object(I), w3)) == "string" ? L : M ? b3(k3) : (F = b3(k3)) == "Object" && typeof k3.callee == "function" ? "Arguments" : F;
          };
        }, function(c3, p3) {
          var g3;
          g3 = function() {
            return this;
          }();
          try {
            g3 = g3 || new Function("return this")();
          } catch {
            typeof window == "object" && (g3 = window);
          }
          c3.exports = g3;
        }, function(c3, p3) {
          var g3 = /-?\d+(\.\d+)?%?/g;
          c3.exports = function(b3) {
            return b3.match(g3);
          };
        }, function(c3, p3, g3) {
          Object.defineProperty(p3, "__esModule", { value: true }), p3.getBase16Theme = p3.createStyling = p3.invertTheme = void 0;
          var b3 = Q(g3(49)), w3 = Q(g3(76)), M = Q(g3(81)), I = Q(g3(89)), k3 = Q(g3(93)), L = function(Ke) {
            if (Ke && Ke.__esModule)
              return Ke;
            var nt = {};
            if (Ke != null)
              for (var lt2 in Ke)
                Object.prototype.hasOwnProperty.call(Ke, lt2) && (nt[lt2] = Ke[lt2]);
            return nt.default = Ke, nt;
          }(g3(94)), F = Q(g3(132)), B = Q(g3(133)), G = Q(g3(138)), J = g3(139);
          function Q(Ke) {
            return Ke && Ke.__esModule ? Ke : { default: Ke };
          }
          var se = L.default, he = (0, I.default)(se), be = (0, G.default)(B.default, J.rgb2yuv, function(Ke) {
            var nt, lt2 = (0, M.default)(Ke, 3), bt = lt2[0], vt = lt2[1], jt = lt2[2];
            return [(nt = bt, nt < 0.25 ? 1 : nt < 0.5 ? 0.9 - nt : 1.1 - nt), vt, jt];
          }, J.yuv2rgb, F.default), de = function(Ke) {
            return function(nt) {
              return { className: [nt.className, Ke.className].filter(Boolean).join(" "), style: (0, w3.default)({}, nt.style || {}, Ke.style || {}) };
            };
          }, Fe = function(Ke, nt) {
            var lt2 = (0, I.default)(nt);
            for (var bt in Ke)
              lt2.indexOf(bt) === -1 && lt2.push(bt);
            return lt2.reduce(function(vt, jt) {
              return vt[jt] = function(Jt, Rt) {
                if (Jt === void 0)
                  return Rt;
                if (Rt === void 0)
                  return Jt;
                var Jn = Jt === void 0 ? "undefined" : (0, b3.default)(Jt), ln = Rt === void 0 ? "undefined" : (0, b3.default)(Rt);
                switch (Jn) {
                  case "string":
                    switch (ln) {
                      case "string":
                        return [Rt, Jt].filter(Boolean).join(" ");
                      case "object":
                        return de({ className: Jt, style: Rt });
                      case "function":
                        return function(vn) {
                          for (var kn = arguments.length, cr = Array(kn > 1 ? kn - 1 : 0), gr = 1; gr < kn; gr++)
                            cr[gr - 1] = arguments[gr];
                          return de({ className: Jt })(Rt.apply(void 0, [vn].concat(cr)));
                        };
                    }
                  case "object":
                    switch (ln) {
                      case "string":
                        return de({ className: Rt, style: Jt });
                      case "object":
                        return (0, w3.default)({}, Rt, Jt);
                      case "function":
                        return function(vn) {
                          for (var kn = arguments.length, cr = Array(kn > 1 ? kn - 1 : 0), gr = 1; gr < kn; gr++)
                            cr[gr - 1] = arguments[gr];
                          return de({ style: Jt })(Rt.apply(void 0, [vn].concat(cr)));
                        };
                    }
                  case "function":
                    switch (ln) {
                      case "string":
                        return function(vn) {
                          for (var kn = arguments.length, cr = Array(kn > 1 ? kn - 1 : 0), gr = 1; gr < kn; gr++)
                            cr[gr - 1] = arguments[gr];
                          return Jt.apply(void 0, [de(vn)({ className: Rt })].concat(cr));
                        };
                      case "object":
                        return function(vn) {
                          for (var kn = arguments.length, cr = Array(kn > 1 ? kn - 1 : 0), gr = 1; gr < kn; gr++)
                            cr[gr - 1] = arguments[gr];
                          return Jt.apply(void 0, [de(vn)({ style: Rt })].concat(cr));
                        };
                      case "function":
                        return function(vn) {
                          for (var kn = arguments.length, cr = Array(kn > 1 ? kn - 1 : 0), gr = 1; gr < kn; gr++)
                            cr[gr - 1] = arguments[gr];
                          return Jt.apply(void 0, [Rt.apply(void 0, [vn].concat(cr))].concat(cr));
                        };
                    }
                }
              }(Ke[jt], nt[jt]), vt;
            }, {});
          }, Pe = function(Ke, nt) {
            for (var lt2 = arguments.length, bt = Array(lt2 > 2 ? lt2 - 2 : 0), vt = 2; vt < lt2; vt++)
              bt[vt - 2] = arguments[vt];
            if (nt === null)
              return Ke;
            Array.isArray(nt) || (nt = [nt]);
            var jt = nt.map(function(Rt) {
              return Ke[Rt];
            }).filter(Boolean), Jt = jt.reduce(function(Rt, Jn) {
              return typeof Jn == "string" ? Rt.className = [Rt.className, Jn].filter(Boolean).join(" ") : (Jn === void 0 ? "undefined" : (0, b3.default)(Jn)) === "object" ? Rt.style = (0, w3.default)({}, Rt.style, Jn) : typeof Jn == "function" && (Rt = (0, w3.default)({}, Rt, Jn.apply(void 0, [Rt].concat(bt)))), Rt;
            }, { className: "", style: {} });
            return Jt.className || delete Jt.className, (0, I.default)(Jt.style).length === 0 && delete Jt.style, Jt;
          }, ze = p3.invertTheme = function(Ke) {
            return (0, I.default)(Ke).reduce(function(nt, lt2) {
              return nt[lt2] = /^base/.test(lt2) ? be(Ke[lt2]) : lt2 === "scheme" ? Ke[lt2] + ":inverted" : Ke[lt2], nt;
            }, {});
          }, $e = (p3.createStyling = (0, k3.default)(function(Ke) {
            for (var nt = arguments.length, lt2 = Array(nt > 3 ? nt - 3 : 0), bt = 3; bt < nt; bt++)
              lt2[bt - 3] = arguments[bt];
            var vt = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, jt = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Jt = vt.defaultBase16, Rt = Jt === void 0 ? se : Jt, Jn = vt.base16Themes, ln = Jn === void 0 ? null : Jn, vn = $e(jt, ln);
            vn && (jt = (0, w3.default)({}, vn, jt));
            var kn = he.reduce(function(Ka, Do) {
              return Ka[Do] = jt[Do] || Rt[Do], Ka;
            }, {}), cr = (0, I.default)(jt).reduce(function(Ka, Do) {
              return he.indexOf(Do) === -1 && (Ka[Do] = jt[Do]), Ka;
            }, {}), gr = Ke(kn), ha = Fe(cr, gr);
            return (0, k3.default)(Pe, 2).apply(void 0, [ha].concat(lt2));
          }, 3), p3.getBase16Theme = function(Ke, nt) {
            if (Ke && Ke.extend && (Ke = Ke.extend), typeof Ke == "string") {
              var lt2 = Ke.split(":"), bt = (0, M.default)(lt2, 2), vt = bt[0], jt = bt[1];
              Ke = (nt || {})[vt] || L[vt], jt === "inverted" && (Ke = ze(Ke));
            }
            return Ke && Ke.hasOwnProperty("base00") ? Ke : void 0;
          });
        }, function(c3, p3, g3) {
          var b3, w3 = typeof Reflect == "object" ? Reflect : null, M = w3 && typeof w3.apply == "function" ? w3.apply : function(de, Fe, Pe) {
            return Function.prototype.apply.call(de, Fe, Pe);
          };
          b3 = w3 && typeof w3.ownKeys == "function" ? w3.ownKeys : Object.getOwnPropertySymbols ? function(de) {
            return Object.getOwnPropertyNames(de).concat(Object.getOwnPropertySymbols(de));
          } : function(de) {
            return Object.getOwnPropertyNames(de);
          };
          var I = Number.isNaN || function(de) {
            return de != de;
          };
          function k3() {
            k3.init.call(this);
          }
          c3.exports = k3, c3.exports.once = function(de, Fe) {
            return new Promise(function(Pe, ze) {
              function $e() {
                Ke !== void 0 && de.removeListener("error", Ke), Pe([].slice.call(arguments));
              }
              var Ke;
              Fe !== "error" && (Ke = function(nt) {
                de.removeListener(Fe, $e), ze(nt);
              }, de.once("error", Ke)), de.once(Fe, $e);
            });
          }, k3.EventEmitter = k3, k3.prototype._events = void 0, k3.prototype._eventsCount = 0, k3.prototype._maxListeners = void 0;
          var L = 10;
          function F(de) {
            if (typeof de != "function")
              throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof de);
          }
          function B(de) {
            return de._maxListeners === void 0 ? k3.defaultMaxListeners : de._maxListeners;
          }
          function G(de, Fe, Pe, ze) {
            var $e, Ke, nt, lt2;
            if (F(Pe), (Ke = de._events) === void 0 ? (Ke = de._events = /* @__PURE__ */ Object.create(null), de._eventsCount = 0) : (Ke.newListener !== void 0 && (de.emit("newListener", Fe, Pe.listener ? Pe.listener : Pe), Ke = de._events), nt = Ke[Fe]), nt === void 0)
              nt = Ke[Fe] = Pe, ++de._eventsCount;
            else if (typeof nt == "function" ? nt = Ke[Fe] = ze ? [Pe, nt] : [nt, Pe] : ze ? nt.unshift(Pe) : nt.push(Pe), ($e = B(de)) > 0 && nt.length > $e && !nt.warned) {
              nt.warned = true;
              var bt = new Error("Possible EventEmitter memory leak detected. " + nt.length + " " + String(Fe) + " listeners added. Use emitter.setMaxListeners() to increase limit");
              bt.name = "MaxListenersExceededWarning", bt.emitter = de, bt.type = Fe, bt.count = nt.length, lt2 = bt, console && console.warn && console.warn(lt2);
            }
            return de;
          }
          function J() {
            if (!this.fired)
              return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
          }
          function Q(de, Fe, Pe) {
            var ze = { fired: false, wrapFn: void 0, target: de, type: Fe, listener: Pe }, $e = J.bind(ze);
            return $e.listener = Pe, ze.wrapFn = $e, $e;
          }
          function se(de, Fe, Pe) {
            var ze = de._events;
            if (ze === void 0)
              return [];
            var $e = ze[Fe];
            return $e === void 0 ? [] : typeof $e == "function" ? Pe ? [$e.listener || $e] : [$e] : Pe ? function(Ke) {
              for (var nt = new Array(Ke.length), lt2 = 0; lt2 < nt.length; ++lt2)
                nt[lt2] = Ke[lt2].listener || Ke[lt2];
              return nt;
            }($e) : be($e, $e.length);
          }
          function he(de) {
            var Fe = this._events;
            if (Fe !== void 0) {
              var Pe = Fe[de];
              if (typeof Pe == "function")
                return 1;
              if (Pe !== void 0)
                return Pe.length;
            }
            return 0;
          }
          function be(de, Fe) {
            for (var Pe = new Array(Fe), ze = 0; ze < Fe; ++ze)
              Pe[ze] = de[ze];
            return Pe;
          }
          Object.defineProperty(k3, "defaultMaxListeners", { enumerable: true, get: function() {
            return L;
          }, set: function(de) {
            if (typeof de != "number" || de < 0 || I(de))
              throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + de + ".");
            L = de;
          } }), k3.init = function() {
            this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
          }, k3.prototype.setMaxListeners = function(de) {
            if (typeof de != "number" || de < 0 || I(de))
              throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + de + ".");
            return this._maxListeners = de, this;
          }, k3.prototype.getMaxListeners = function() {
            return B(this);
          }, k3.prototype.emit = function(de) {
            for (var Fe = [], Pe = 1; Pe < arguments.length; Pe++)
              Fe.push(arguments[Pe]);
            var ze = de === "error", $e = this._events;
            if ($e !== void 0)
              ze = ze && $e.error === void 0;
            else if (!ze)
              return false;
            if (ze) {
              var Ke;
              if (Fe.length > 0 && (Ke = Fe[0]), Ke instanceof Error)
                throw Ke;
              var nt = new Error("Unhandled error." + (Ke ? " (" + Ke.message + ")" : ""));
              throw nt.context = Ke, nt;
            }
            var lt2 = $e[de];
            if (lt2 === void 0)
              return false;
            if (typeof lt2 == "function")
              M(lt2, this, Fe);
            else {
              var bt = lt2.length, vt = be(lt2, bt);
              for (Pe = 0; Pe < bt; ++Pe)
                M(vt[Pe], this, Fe);
            }
            return true;
          }, k3.prototype.addListener = function(de, Fe) {
            return G(this, de, Fe, false);
          }, k3.prototype.on = k3.prototype.addListener, k3.prototype.prependListener = function(de, Fe) {
            return G(this, de, Fe, true);
          }, k3.prototype.once = function(de, Fe) {
            return F(Fe), this.on(de, Q(this, de, Fe)), this;
          }, k3.prototype.prependOnceListener = function(de, Fe) {
            return F(Fe), this.prependListener(de, Q(this, de, Fe)), this;
          }, k3.prototype.removeListener = function(de, Fe) {
            var Pe, ze, $e, Ke, nt;
            if (F(Fe), (ze = this._events) === void 0)
              return this;
            if ((Pe = ze[de]) === void 0)
              return this;
            if (Pe === Fe || Pe.listener === Fe)
              --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete ze[de], ze.removeListener && this.emit("removeListener", de, Pe.listener || Fe));
            else if (typeof Pe != "function") {
              for ($e = -1, Ke = Pe.length - 1; Ke >= 0; Ke--)
                if (Pe[Ke] === Fe || Pe[Ke].listener === Fe) {
                  nt = Pe[Ke].listener, $e = Ke;
                  break;
                }
              if ($e < 0)
                return this;
              $e === 0 ? Pe.shift() : function(lt2, bt) {
                for (; bt + 1 < lt2.length; bt++)
                  lt2[bt] = lt2[bt + 1];
                lt2.pop();
              }(Pe, $e), Pe.length === 1 && (ze[de] = Pe[0]), ze.removeListener !== void 0 && this.emit("removeListener", de, nt || Fe);
            }
            return this;
          }, k3.prototype.off = k3.prototype.removeListener, k3.prototype.removeAllListeners = function(de) {
            var Fe, Pe, ze;
            if ((Pe = this._events) === void 0)
              return this;
            if (Pe.removeListener === void 0)
              return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Pe[de] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Pe[de]), this;
            if (arguments.length === 0) {
              var $e, Ke = Object.keys(Pe);
              for (ze = 0; ze < Ke.length; ++ze)
                ($e = Ke[ze]) !== "removeListener" && this.removeAllListeners($e);
              return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
            }
            if (typeof (Fe = Pe[de]) == "function")
              this.removeListener(de, Fe);
            else if (Fe !== void 0)
              for (ze = Fe.length - 1; ze >= 0; ze--)
                this.removeListener(de, Fe[ze]);
            return this;
          }, k3.prototype.listeners = function(de) {
            return se(this, de, true);
          }, k3.prototype.rawListeners = function(de) {
            return se(this, de, false);
          }, k3.listenerCount = function(de, Fe) {
            return typeof de.listenerCount == "function" ? de.listenerCount(Fe) : he.call(de, Fe);
          }, k3.prototype.listenerCount = he, k3.prototype.eventNames = function() {
            return this._eventsCount > 0 ? b3(this._events) : [];
          };
        }, function(c3, p3, g3) {
          c3.exports.Dispatcher = g3(140);
        }, function(c3, p3, g3) {
          c3.exports = g3(142);
        }, function(c3, p3, g3) {
          p3.__esModule = true;
          var b3 = I(g3(50)), w3 = I(g3(65)), M = typeof w3.default == "function" && typeof b3.default == "symbol" ? function(k3) {
            return typeof k3;
          } : function(k3) {
            return k3 && typeof w3.default == "function" && k3.constructor === w3.default && k3 !== w3.default.prototype ? "symbol" : typeof k3;
          };
          function I(k3) {
            return k3 && k3.__esModule ? k3 : { default: k3 };
          }
          p3.default = typeof w3.default == "function" && M(b3.default) === "symbol" ? function(k3) {
            return k3 === void 0 ? "undefined" : M(k3);
          } : function(k3) {
            return k3 && typeof w3.default == "function" && k3.constructor === w3.default && k3 !== w3.default.prototype ? "symbol" : k3 === void 0 ? "undefined" : M(k3);
          };
        }, function(c3, p3, g3) {
          c3.exports = { default: g3(51), __esModule: true };
        }, function(c3, p3, g3) {
          g3(20), g3(29), c3.exports = g3(30).f("iterator");
        }, function(c3, p3, g3) {
          var b3 = g3(21), w3 = g3(22);
          c3.exports = function(M) {
            return function(I, k3) {
              var L, F, B = String(w3(I)), G = b3(k3), J = B.length;
              return G < 0 || G >= J ? M ? "" : void 0 : (L = B.charCodeAt(G)) < 55296 || L > 56319 || G + 1 === J || (F = B.charCodeAt(G + 1)) < 56320 || F > 57343 ? M ? B.charAt(G) : L : M ? B.slice(G, G + 2) : F - 56320 + (L - 55296 << 10) + 65536;
            };
          };
        }, function(c3, p3, g3) {
          var b3 = g3(54);
          c3.exports = function(w3, M, I) {
            if (b3(w3), M === void 0)
              return w3;
            switch (I) {
              case 1:
                return function(k3) {
                  return w3.call(M, k3);
                };
              case 2:
                return function(k3, L) {
                  return w3.call(M, k3, L);
                };
              case 3:
                return function(k3, L, F) {
                  return w3.call(M, k3, L, F);
                };
            }
            return function() {
              return w3.apply(M, arguments);
            };
          };
        }, function(c3, p3) {
          c3.exports = function(g3) {
            if (typeof g3 != "function")
              throw TypeError(g3 + " is not a function!");
            return g3;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(38), w3 = g3(16), M = g3(28), I = {};
          g3(6)(I, g3(2)("iterator"), function() {
            return this;
          }), c3.exports = function(k3, L, F) {
            k3.prototype = b3(I, { next: w3(1, F) }), M(k3, L + " Iterator");
          };
        }, function(c3, p3, g3) {
          var b3 = g3(7), w3 = g3(10), M = g3(13);
          c3.exports = g3(4) ? Object.defineProperties : function(I, k3) {
            w3(I);
            for (var L, F = M(k3), B = F.length, G = 0; B > G; )
              b3.f(I, L = F[G++], k3[L]);
            return I;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(9), w3 = g3(58), M = g3(59);
          c3.exports = function(I) {
            return function(k3, L, F) {
              var B, G = b3(k3), J = w3(G.length), Q = M(F, J);
              if (I && L != L) {
                for (; J > Q; )
                  if ((B = G[Q++]) != B)
                    return true;
              } else
                for (; J > Q; Q++)
                  if ((I || Q in G) && G[Q] === L)
                    return I || Q || 0;
              return !I && -1;
            };
          };
        }, function(c3, p3, g3) {
          var b3 = g3(21), w3 = Math.min;
          c3.exports = function(M) {
            return M > 0 ? w3(b3(M), 9007199254740991) : 0;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(21), w3 = Math.max, M = Math.min;
          c3.exports = function(I, k3) {
            return (I = b3(I)) < 0 ? w3(I + k3, 0) : M(I, k3);
          };
        }, function(c3, p3, g3) {
          var b3 = g3(3).document;
          c3.exports = b3 && b3.documentElement;
        }, function(c3, p3, g3) {
          var b3 = g3(5), w3 = g3(18), M = g3(25)("IE_PROTO"), I = Object.prototype;
          c3.exports = Object.getPrototypeOf || function(k3) {
            return k3 = w3(k3), b3(k3, M) ? k3[M] : typeof k3.constructor == "function" && k3 instanceof k3.constructor ? k3.constructor.prototype : k3 instanceof Object ? I : null;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(63), w3 = g3(64), M = g3(12), I = g3(9);
          c3.exports = g3(34)(Array, "Array", function(k3, L) {
            this._t = I(k3), this._i = 0, this._k = L;
          }, function() {
            var k3 = this._t, L = this._k, F = this._i++;
            return !k3 || F >= k3.length ? (this._t = void 0, w3(1)) : w3(0, L == "keys" ? F : L == "values" ? k3[F] : [F, k3[F]]);
          }, "values"), M.Arguments = M.Array, b3("keys"), b3("values"), b3("entries");
        }, function(c3, p3) {
          c3.exports = function() {
          };
        }, function(c3, p3) {
          c3.exports = function(g3, b3) {
            return { value: b3, done: !!g3 };
          };
        }, function(c3, p3, g3) {
          c3.exports = { default: g3(66), __esModule: true };
        }, function(c3, p3, g3) {
          g3(67), g3(73), g3(74), g3(75), c3.exports = g3(1).Symbol;
        }, function(c3, p3, g3) {
          var b3 = g3(3), w3 = g3(5), M = g3(4), I = g3(15), k3 = g3(37), L = g3(68).KEY, F = g3(8), B = g3(26), G = g3(28), J = g3(17), Q = g3(2), se = g3(30), he = g3(31), be = g3(69), de = g3(70), Fe = g3(10), Pe = g3(11), ze = g3(18), $e = g3(9), Ke = g3(23), nt = g3(16), lt2 = g3(38), bt = g3(71), vt = g3(72), jt = g3(32), Jt = g3(7), Rt = g3(13), Jn = vt.f, ln = Jt.f, vn = bt.f, kn = b3.Symbol, cr = b3.JSON, gr = cr && cr.stringify, ha = Q("_hidden"), Ka = Q("toPrimitive"), Do = {}.propertyIsEnumerable, _o = B("symbol-registry"), xo = B("symbols"), Ra = B("op-symbols"), ho = Object.prototype, Mo = typeof kn == "function" && !!jt.f, Xa = b3.QObject, Zo = !Xa || !Xa.prototype || !Xa.prototype.findChild, rc = M && F(function() {
            return lt2(ln({}, "a", { get: function() {
              return ln(this, "a", { value: 7 }).a;
            } })).a != 7;
          }) ? function(Xr, ta, co) {
            var cs = Jn(ho, ta);
            cs && delete ho[ta], ln(Xr, ta, co), cs && Xr !== ho && ln(ho, ta, cs);
          } : ln, ys = function(Xr) {
            var ta = xo[Xr] = lt2(kn.prototype);
            return ta._k = Xr, ta;
          }, Vu = Mo && typeof kn.iterator == "symbol" ? function(Xr) {
            return typeof Xr == "symbol";
          } : function(Xr) {
            return Xr instanceof kn;
          }, gc = function(Xr, ta, co) {
            return Xr === ho && gc(Ra, ta, co), Fe(Xr), ta = Ke(ta, true), Fe(co), w3(xo, ta) ? (co.enumerable ? (w3(Xr, ha) && Xr[ha][ta] && (Xr[ha][ta] = false), co = lt2(co, { enumerable: nt(0, false) })) : (w3(Xr, ha) || ln(Xr, ha, nt(1, {})), Xr[ha][ta] = true), rc(Xr, ta, co)) : ln(Xr, ta, co);
          }, ef = function(Xr, ta) {
            Fe(Xr);
            for (var co, cs = be(ta = $e(ta)), nu = 0, ru = cs.length; ru > nu; )
              gc(Xr, co = cs[nu++], ta[co]);
            return Xr;
          }, dv = function(Xr) {
            var ta = Do.call(this, Xr = Ke(Xr, true));
            return !(this === ho && w3(xo, Xr) && !w3(Ra, Xr)) && (!(ta || !w3(this, Xr) || !w3(xo, Xr) || w3(this, ha) && this[ha][Xr]) || ta);
          }, Wf = function(Xr, ta) {
            if (Xr = $e(Xr), ta = Ke(ta, true), Xr !== ho || !w3(xo, ta) || w3(Ra, ta)) {
              var co = Jn(Xr, ta);
              return !co || !w3(xo, ta) || w3(Xr, ha) && Xr[ha][ta] || (co.enumerable = true), co;
            }
          }, Ag = function(Xr) {
            for (var ta, co = vn($e(Xr)), cs = [], nu = 0; co.length > nu; )
              w3(xo, ta = co[nu++]) || ta == ha || ta == L || cs.push(ta);
            return cs;
          }, eh = function(Xr) {
            for (var ta, co = Xr === ho, cs = vn(co ? Ra : $e(Xr)), nu = [], ru = 0; cs.length > ru; )
              !w3(xo, ta = cs[ru++]) || co && !w3(ho, ta) || nu.push(xo[ta]);
            return nu;
          };
          Mo || (k3((kn = function() {
            if (this instanceof kn)
              throw TypeError("Symbol is not a constructor!");
            var Xr = J(arguments.length > 0 ? arguments[0] : void 0), ta = function(co) {
              this === ho && ta.call(Ra, co), w3(this, ha) && w3(this[ha], Xr) && (this[ha][Xr] = false), rc(this, Xr, nt(1, co));
            };
            return M && Zo && rc(ho, Xr, { configurable: true, set: ta }), ys(Xr);
          }).prototype, "toString", function() {
            return this._k;
          }), vt.f = Wf, Jt.f = gc, g3(41).f = bt.f = Ag, g3(19).f = dv, jt.f = eh, M && !g3(14) && k3(ho, "propertyIsEnumerable", dv, true), se.f = function(Xr) {
            return ys(Q(Xr));
          }), I(I.G + I.W + I.F * !Mo, { Symbol: kn });
          for (var _p = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), ap = 0; _p.length > ap; )
            Q(_p[ap++]);
          for (var Hw = Rt(Q.store), Ji = 0; Hw.length > Ji; )
            he(Hw[Ji++]);
          I(I.S + I.F * !Mo, "Symbol", { for: function(Xr) {
            return w3(_o, Xr += "") ? _o[Xr] : _o[Xr] = kn(Xr);
          }, keyFor: function(Xr) {
            if (!Vu(Xr))
              throw TypeError(Xr + " is not a symbol!");
            for (var ta in _o)
              if (_o[ta] === Xr)
                return ta;
          }, useSetter: function() {
            Zo = true;
          }, useSimple: function() {
            Zo = false;
          } }), I(I.S + I.F * !Mo, "Object", { create: function(Xr, ta) {
            return ta === void 0 ? lt2(Xr) : ef(lt2(Xr), ta);
          }, defineProperty: gc, defineProperties: ef, getOwnPropertyDescriptor: Wf, getOwnPropertyNames: Ag, getOwnPropertySymbols: eh });
          var Jr = F(function() {
            jt.f(1);
          });
          I(I.S + I.F * Jr, "Object", { getOwnPropertySymbols: function(Xr) {
            return jt.f(ze(Xr));
          } }), cr && I(I.S + I.F * (!Mo || F(function() {
            var Xr = kn();
            return gr([Xr]) != "[null]" || gr({ a: Xr }) != "{}" || gr(Object(Xr)) != "{}";
          })), "JSON", { stringify: function(Xr) {
            for (var ta, co, cs = [Xr], nu = 1; arguments.length > nu; )
              cs.push(arguments[nu++]);
            if (co = ta = cs[1], (Pe(ta) || Xr !== void 0) && !Vu(Xr))
              return de(ta) || (ta = function(ru, hf) {
                if (typeof co == "function" && (hf = co.call(this, ru, hf)), !Vu(hf))
                  return hf;
              }), cs[1] = ta, gr.apply(cr, cs);
          } }), kn.prototype[Ka] || g3(6)(kn.prototype, Ka, kn.prototype.valueOf), G(kn, "Symbol"), G(Math, "Math", true), G(b3.JSON, "JSON", true);
        }, function(c3, p3, g3) {
          var b3 = g3(17)("meta"), w3 = g3(11), M = g3(5), I = g3(7).f, k3 = 0, L = Object.isExtensible || function() {
            return true;
          }, F = !g3(8)(function() {
            return L(Object.preventExtensions({}));
          }), B = function(J) {
            I(J, b3, { value: { i: "O" + ++k3, w: {} } });
          }, G = c3.exports = { KEY: b3, NEED: false, fastKey: function(J, Q) {
            if (!w3(J))
              return typeof J == "symbol" ? J : (typeof J == "string" ? "S" : "P") + J;
            if (!M(J, b3)) {
              if (!L(J))
                return "F";
              if (!Q)
                return "E";
              B(J);
            }
            return J[b3].i;
          }, getWeak: function(J, Q) {
            if (!M(J, b3)) {
              if (!L(J))
                return true;
              if (!Q)
                return false;
              B(J);
            }
            return J[b3].w;
          }, onFreeze: function(J) {
            return F && G.NEED && L(J) && !M(J, b3) && B(J), J;
          } };
        }, function(c3, p3, g3) {
          var b3 = g3(13), w3 = g3(32), M = g3(19);
          c3.exports = function(I) {
            var k3 = b3(I), L = w3.f;
            if (L)
              for (var F, B = L(I), G = M.f, J = 0; B.length > J; )
                G.call(I, F = B[J++]) && k3.push(F);
            return k3;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(24);
          c3.exports = Array.isArray || function(w3) {
            return b3(w3) == "Array";
          };
        }, function(c3, p3, g3) {
          var b3 = g3(9), w3 = g3(41).f, M = {}.toString, I = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
          c3.exports.f = function(k3) {
            return I && M.call(k3) == "[object Window]" ? function(L) {
              try {
                return w3(L);
              } catch {
                return I.slice();
              }
            }(k3) : w3(b3(k3));
          };
        }, function(c3, p3, g3) {
          var b3 = g3(19), w3 = g3(16), M = g3(9), I = g3(23), k3 = g3(5), L = g3(35), F = Object.getOwnPropertyDescriptor;
          p3.f = g3(4) ? F : function(B, G) {
            if (B = M(B), G = I(G, true), L)
              try {
                return F(B, G);
              } catch {
              }
            if (k3(B, G))
              return w3(!b3.f.call(B, G), B[G]);
          };
        }, function(c3, p3) {
        }, function(c3, p3, g3) {
          g3(31)("asyncIterator");
        }, function(c3, p3, g3) {
          g3(31)("observable");
        }, function(c3, p3, g3) {
          p3.__esModule = true;
          var b3, w3 = g3(77), M = (b3 = w3) && b3.__esModule ? b3 : { default: b3 };
          p3.default = M.default || function(I) {
            for (var k3 = 1; k3 < arguments.length; k3++) {
              var L = arguments[k3];
              for (var F in L)
                Object.prototype.hasOwnProperty.call(L, F) && (I[F] = L[F]);
            }
            return I;
          };
        }, function(c3, p3, g3) {
          c3.exports = { default: g3(78), __esModule: true };
        }, function(c3, p3, g3) {
          g3(79), c3.exports = g3(1).Object.assign;
        }, function(c3, p3, g3) {
          var b3 = g3(15);
          b3(b3.S + b3.F, "Object", { assign: g3(80) });
        }, function(c3, p3, g3) {
          var b3 = g3(4), w3 = g3(13), M = g3(32), I = g3(19), k3 = g3(18), L = g3(40), F = Object.assign;
          c3.exports = !F || g3(8)(function() {
            var B = {}, G = {}, J = Symbol(), Q = "abcdefghijklmnopqrst";
            return B[J] = 7, Q.split("").forEach(function(se) {
              G[se] = se;
            }), F({}, B)[J] != 7 || Object.keys(F({}, G)).join("") != Q;
          }) ? function(B, G) {
            for (var J = k3(B), Q = arguments.length, se = 1, he = M.f, be = I.f; Q > se; )
              for (var de, Fe = L(arguments[se++]), Pe = he ? w3(Fe).concat(he(Fe)) : w3(Fe), ze = Pe.length, $e = 0; ze > $e; )
                de = Pe[$e++], b3 && !be.call(Fe, de) || (J[de] = Fe[de]);
            return J;
          } : F;
        }, function(c3, p3, g3) {
          p3.__esModule = true;
          var b3 = M(g3(82)), w3 = M(g3(85));
          function M(I) {
            return I && I.__esModule ? I : { default: I };
          }
          p3.default = function(I, k3) {
            if (Array.isArray(I))
              return I;
            if ((0, b3.default)(Object(I)))
              return function(L, F) {
                var B = [], G = true, J = false, Q = void 0;
                try {
                  for (var se, he = (0, w3.default)(L); !(G = (se = he.next()).done) && (B.push(se.value), !F || B.length !== F); G = true)
                    ;
                } catch (be) {
                  J = true, Q = be;
                } finally {
                  try {
                    !G && he.return && he.return();
                  } finally {
                    if (J)
                      throw Q;
                  }
                }
                return B;
              }(I, k3);
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          };
        }, function(c3, p3, g3) {
          c3.exports = { default: g3(83), __esModule: true };
        }, function(c3, p3, g3) {
          g3(29), g3(20), c3.exports = g3(84);
        }, function(c3, p3, g3) {
          var b3 = g3(42), w3 = g3(2)("iterator"), M = g3(12);
          c3.exports = g3(1).isIterable = function(I) {
            var k3 = Object(I);
            return k3[w3] !== void 0 || "@@iterator" in k3 || M.hasOwnProperty(b3(k3));
          };
        }, function(c3, p3, g3) {
          c3.exports = { default: g3(86), __esModule: true };
        }, function(c3, p3, g3) {
          g3(29), g3(20), c3.exports = g3(87);
        }, function(c3, p3, g3) {
          var b3 = g3(10), w3 = g3(88);
          c3.exports = g3(1).getIterator = function(M) {
            var I = w3(M);
            if (typeof I != "function")
              throw TypeError(M + " is not iterable!");
            return b3(I.call(M));
          };
        }, function(c3, p3, g3) {
          var b3 = g3(42), w3 = g3(2)("iterator"), M = g3(12);
          c3.exports = g3(1).getIteratorMethod = function(I) {
            if (I != null)
              return I[w3] || I["@@iterator"] || M[b3(I)];
          };
        }, function(c3, p3, g3) {
          c3.exports = { default: g3(90), __esModule: true };
        }, function(c3, p3, g3) {
          g3(91), c3.exports = g3(1).Object.keys;
        }, function(c3, p3, g3) {
          var b3 = g3(18), w3 = g3(13);
          g3(92)("keys", function() {
            return function(M) {
              return w3(b3(M));
            };
          });
        }, function(c3, p3, g3) {
          var b3 = g3(15), w3 = g3(1), M = g3(8);
          c3.exports = function(I, k3) {
            var L = (w3.Object || {})[I] || Object[I], F = {};
            F[I] = k3(L), b3(b3.S + b3.F * M(function() {
              L(1);
            }), "Object", F);
          };
        }, function(c3, p3, g3) {
          (function(b3) {
            var w3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], M = /^\s+|\s+$/g, I = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, k3 = /\{\n\/\* \[wrapped with (.+)\] \*/, L = /,? & /, F = /^[-+]0x[0-9a-f]+$/i, B = /^0b[01]+$/i, G = /^\[object .+?Constructor\]$/, J = /^0o[0-7]+$/i, Q = /^(?:0|[1-9]\d*)$/, se = parseInt, he = typeof b3 == "object" && b3 && b3.Object === Object && b3, be = typeof self == "object" && self && self.Object === Object && self, de = he || be || Function("return this")();
            function Fe(Ji, Jr, Xr) {
              switch (Xr.length) {
                case 0:
                  return Ji.call(Jr);
                case 1:
                  return Ji.call(Jr, Xr[0]);
                case 2:
                  return Ji.call(Jr, Xr[0], Xr[1]);
                case 3:
                  return Ji.call(Jr, Xr[0], Xr[1], Xr[2]);
              }
              return Ji.apply(Jr, Xr);
            }
            function Pe(Ji, Jr) {
              return !!(Ji && Ji.length) && function(Xr, ta, co) {
                if (ta != ta)
                  return function(ru, hf, op, _h) {
                    for (var wd = ru.length, xh = op + (_h ? 1 : -1); _h ? xh-- : ++xh < wd; )
                      if (hf(ru[xh], xh, ru))
                        return xh;
                    return -1;
                  }(Xr, ze, co);
                for (var cs = co - 1, nu = Xr.length; ++cs < nu; )
                  if (Xr[cs] === ta)
                    return cs;
                return -1;
              }(Ji, Jr, 0) > -1;
            }
            function ze(Ji) {
              return Ji != Ji;
            }
            function $e(Ji, Jr) {
              for (var Xr = Ji.length, ta = 0; Xr--; )
                Ji[Xr] === Jr && ta++;
              return ta;
            }
            function Ke(Ji, Jr) {
              for (var Xr = -1, ta = Ji.length, co = 0, cs = []; ++Xr < ta; ) {
                var nu = Ji[Xr];
                nu !== Jr && nu !== "__lodash_placeholder__" || (Ji[Xr] = "__lodash_placeholder__", cs[co++] = Xr);
              }
              return cs;
            }
            var nt, lt2, bt, vt = Function.prototype, jt = Object.prototype, Jt = de["__core-js_shared__"], Rt = (nt = /[^.]+$/.exec(Jt && Jt.keys && Jt.keys.IE_PROTO || "")) ? "Symbol(src)_1." + nt : "", Jn = vt.toString, ln = jt.hasOwnProperty, vn = jt.toString, kn = RegExp("^" + Jn.call(ln).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), cr = Object.create, gr = Math.max, ha = Math.min, Ka = (lt2 = ys(Object, "defineProperty"), (bt = ys.name) && bt.length > 2 ? lt2 : void 0);
            function Do(Ji) {
              return _p(Ji) ? cr(Ji) : {};
            }
            function _o(Ji) {
              return !(!_p(Ji) || function(Jr) {
                return !!Rt && Rt in Jr;
              }(Ji)) && (function(Jr) {
                var Xr = _p(Jr) ? vn.call(Jr) : "";
                return Xr == "[object Function]" || Xr == "[object GeneratorFunction]";
              }(Ji) || function(Jr) {
                var Xr = false;
                if (Jr != null && typeof Jr.toString != "function")
                  try {
                    Xr = !!(Jr + "");
                  } catch {
                  }
                return Xr;
              }(Ji) ? kn : G).test(function(Jr) {
                if (Jr != null) {
                  try {
                    return Jn.call(Jr);
                  } catch {
                  }
                  try {
                    return Jr + "";
                  } catch {
                  }
                }
                return "";
              }(Ji));
            }
            function xo(Ji, Jr, Xr, ta) {
              for (var co = -1, cs = Ji.length, nu = Xr.length, ru = -1, hf = Jr.length, op = gr(cs - nu, 0), _h = Array(hf + op), wd = !ta; ++ru < hf; )
                _h[ru] = Jr[ru];
              for (; ++co < nu; )
                (wd || co < cs) && (_h[Xr[co]] = Ji[co]);
              for (; op--; )
                _h[ru++] = Ji[co++];
              return _h;
            }
            function Ra(Ji, Jr, Xr, ta) {
              for (var co = -1, cs = Ji.length, nu = -1, ru = Xr.length, hf = -1, op = Jr.length, _h = gr(cs - ru, 0), wd = Array(_h + op), xh = !ta; ++co < _h; )
                wd[co] = Ji[co];
              for (var m0 = co; ++hf < op; )
                wd[m0 + hf] = Jr[hf];
              for (; ++nu < ru; )
                (xh || co < cs) && (wd[m0 + Xr[nu]] = Ji[co++]);
              return wd;
            }
            function ho(Ji) {
              return function() {
                var Jr = arguments;
                switch (Jr.length) {
                  case 0:
                    return new Ji();
                  case 1:
                    return new Ji(Jr[0]);
                  case 2:
                    return new Ji(Jr[0], Jr[1]);
                  case 3:
                    return new Ji(Jr[0], Jr[1], Jr[2]);
                  case 4:
                    return new Ji(Jr[0], Jr[1], Jr[2], Jr[3]);
                  case 5:
                    return new Ji(Jr[0], Jr[1], Jr[2], Jr[3], Jr[4]);
                  case 6:
                    return new Ji(Jr[0], Jr[1], Jr[2], Jr[3], Jr[4], Jr[5]);
                  case 7:
                    return new Ji(Jr[0], Jr[1], Jr[2], Jr[3], Jr[4], Jr[5], Jr[6]);
                }
                var Xr = Do(Ji.prototype), ta = Ji.apply(Xr, Jr);
                return _p(ta) ? ta : Xr;
              };
            }
            function Mo(Ji, Jr, Xr, ta, co, cs, nu, ru, hf, op) {
              var _h = 128 & Jr, wd = 1 & Jr, xh = 2 & Jr, m0 = 24 & Jr, Sy = 512 & Jr, Ob = xh ? void 0 : ho(Ji);
              return function Cy() {
                for (var Gp = arguments.length, yc = Array(Gp), Xd = Gp; Xd--; )
                  yc[Xd] = arguments[Xd];
                if (m0)
                  var Ig = rc(Cy), Pb = $e(yc, Ig);
                if (ta && (yc = xo(yc, ta, co, m0)), cs && (yc = Ra(yc, cs, nu, m0)), Gp -= Pb, m0 && Gp < op) {
                  var Em = Ke(yc, Ig);
                  return Xa(Ji, Jr, Mo, Cy.placeholder, Xr, yc, Em, ru, hf, op - Gp);
                }
                var My = wd ? Xr : this, z1 = xh ? My[Ji] : Ji;
                return Gp = yc.length, ru ? yc = dv(yc, ru) : Sy && Gp > 1 && yc.reverse(), _h && hf < Gp && (yc.length = hf), this && this !== de && this instanceof Cy && (z1 = Ob || ho(z1)), z1.apply(My, yc);
              };
            }
            function Xa(Ji, Jr, Xr, ta, co, cs, nu, ru, hf, op) {
              var _h = 8 & Jr;
              Jr |= _h ? 32 : 64, 4 & (Jr &= ~(_h ? 64 : 32)) || (Jr &= -4);
              var wd = Xr(Ji, Jr, co, _h ? cs : void 0, _h ? nu : void 0, _h ? void 0 : cs, _h ? void 0 : nu, ru, hf, op);
              return wd.placeholder = ta, Wf(wd, Ji, Jr);
            }
            function Zo(Ji, Jr, Xr, ta, co, cs, nu, ru) {
              var hf = 2 & Jr;
              if (!hf && typeof Ji != "function")
                throw new TypeError("Expected a function");
              var op = ta ? ta.length : 0;
              if (op || (Jr &= -97, ta = co = void 0), nu = nu === void 0 ? nu : gr(Hw(nu), 0), ru = ru === void 0 ? ru : Hw(ru), op -= co ? co.length : 0, 64 & Jr) {
                var _h = ta, wd = co;
                ta = co = void 0;
              }
              var xh = [Ji, Jr, Xr, ta, co, _h, wd, cs, nu, ru];
              if (Ji = xh[0], Jr = xh[1], Xr = xh[2], ta = xh[3], co = xh[4], !(ru = xh[9] = xh[9] == null ? hf ? 0 : Ji.length : gr(xh[9] - op, 0)) && 24 & Jr && (Jr &= -25), Jr && Jr != 1)
                m0 = Jr == 8 || Jr == 16 ? function(Sy, Ob, Cy) {
                  var Gp = ho(Sy);
                  return function yc() {
                    for (var Xd = arguments.length, Ig = Array(Xd), Pb = Xd, Em = rc(yc); Pb--; )
                      Ig[Pb] = arguments[Pb];
                    var My = Xd < 3 && Ig[0] !== Em && Ig[Xd - 1] !== Em ? [] : Ke(Ig, Em);
                    if ((Xd -= My.length) < Cy)
                      return Xa(Sy, Ob, Mo, yc.placeholder, void 0, Ig, My, void 0, void 0, Cy - Xd);
                    var z1 = this && this !== de && this instanceof yc ? Gp : Sy;
                    return Fe(z1, this, Ig);
                  };
                }(Ji, Jr, ru) : Jr != 32 && Jr != 33 || co.length ? Mo.apply(void 0, xh) : function(Sy, Ob, Cy, Gp) {
                  var yc = 1 & Ob, Xd = ho(Sy);
                  return function Ig() {
                    for (var Pb = -1, Em = arguments.length, My = -1, z1 = Gp.length, oT = Array(z1 + Em), Q2 = this && this !== de && this instanceof Ig ? Xd : Sy; ++My < z1; )
                      oT[My] = Gp[My];
                    for (; Em--; )
                      oT[My++] = arguments[++Pb];
                    return Fe(Q2, yc ? Cy : this, oT);
                  };
                }(Ji, Jr, Xr, ta);
              else
                var m0 = function(Sy, Ob, Cy) {
                  var Gp = 1 & Ob, yc = ho(Sy);
                  return function Xd() {
                    var Ig = this && this !== de && this instanceof Xd ? yc : Sy;
                    return Ig.apply(Gp ? Cy : this, arguments);
                  };
                }(Ji, Jr, Xr);
              return Wf(m0, Ji, Jr);
            }
            function rc(Ji) {
              return Ji.placeholder;
            }
            function ys(Ji, Jr) {
              var Xr = function(ta, co) {
                return ta == null ? void 0 : ta[co];
              }(Ji, Jr);
              return _o(Xr) ? Xr : void 0;
            }
            function Vu(Ji) {
              var Jr = Ji.match(k3);
              return Jr ? Jr[1].split(L) : [];
            }
            function gc(Ji, Jr) {
              var Xr = Jr.length, ta = Xr - 1;
              return Jr[ta] = (Xr > 1 ? "& " : "") + Jr[ta], Jr = Jr.join(Xr > 2 ? ", " : " "), Ji.replace(I, `{
/* [wrapped with ` + Jr + `] */
`);
            }
            function ef(Ji, Jr) {
              return !!(Jr = Jr == null ? 9007199254740991 : Jr) && (typeof Ji == "number" || Q.test(Ji)) && Ji > -1 && Ji % 1 == 0 && Ji < Jr;
            }
            function dv(Ji, Jr) {
              for (var Xr = Ji.length, ta = ha(Jr.length, Xr), co = function(nu, ru) {
                var hf = -1, op = nu.length;
                for (ru || (ru = Array(op)); ++hf < op; )
                  ru[hf] = nu[hf];
                return ru;
              }(Ji); ta--; ) {
                var cs = Jr[ta];
                Ji[ta] = ef(cs, Xr) ? co[cs] : void 0;
              }
              return Ji;
            }
            var Wf = Ka ? function(Ji, Jr, Xr) {
              var ta, co = Jr + "";
              return Ka(Ji, "toString", { configurable: true, enumerable: false, value: (ta = gc(co, Ag(Vu(co), Xr)), function() {
                return ta;
              }) });
            } : function(Ji) {
              return Ji;
            };
            function Ag(Ji, Jr) {
              return function(Xr, ta) {
                for (var co = -1, cs = Xr ? Xr.length : 0; ++co < cs && ta(Xr[co], co, Xr) !== false; )
                  ;
              }(w3, function(Xr) {
                var ta = "_." + Xr[0];
                Jr & Xr[1] && !Pe(Ji, ta) && Ji.push(ta);
              }), Ji.sort();
            }
            function eh(Ji, Jr, Xr) {
              var ta = Zo(Ji, 8, void 0, void 0, void 0, void 0, void 0, Jr = Xr ? void 0 : Jr);
              return ta.placeholder = eh.placeholder, ta;
            }
            function _p(Ji) {
              var Jr = typeof Ji;
              return !!Ji && (Jr == "object" || Jr == "function");
            }
            function ap(Ji) {
              return Ji ? (Ji = function(Jr) {
                if (typeof Jr == "number")
                  return Jr;
                if (function(co) {
                  return typeof co == "symbol" || function(cs) {
                    return !!cs && typeof cs == "object";
                  }(co) && vn.call(co) == "[object Symbol]";
                }(Jr))
                  return NaN;
                if (_p(Jr)) {
                  var Xr = typeof Jr.valueOf == "function" ? Jr.valueOf() : Jr;
                  Jr = _p(Xr) ? Xr + "" : Xr;
                }
                if (typeof Jr != "string")
                  return Jr === 0 ? Jr : +Jr;
                Jr = Jr.replace(M, "");
                var ta = B.test(Jr);
                return ta || J.test(Jr) ? se(Jr.slice(2), ta ? 2 : 8) : F.test(Jr) ? NaN : +Jr;
              }(Ji)) === 1 / 0 || Ji === -1 / 0 ? 17976931348623157e292 * (Ji < 0 ? -1 : 1) : Ji == Ji ? Ji : 0 : Ji === 0 ? Ji : 0;
            }
            function Hw(Ji) {
              var Jr = ap(Ji), Xr = Jr % 1;
              return Jr == Jr ? Xr ? Jr - Xr : Jr : 0;
            }
            eh.placeholder = {}, c3.exports = eh;
          }).call(this, g3(43));
        }, function(c3, p3, g3) {
          function b3(Ra) {
            return Ra && Ra.__esModule ? Ra.default : Ra;
          }
          p3.__esModule = true;
          var w3 = g3(95);
          p3.threezerotwofour = b3(w3);
          var M = g3(96);
          p3.apathy = b3(M);
          var I = g3(97);
          p3.ashes = b3(I);
          var k3 = g3(98);
          p3.atelierDune = b3(k3);
          var L = g3(99);
          p3.atelierForest = b3(L);
          var F = g3(100);
          p3.atelierHeath = b3(F);
          var B = g3(101);
          p3.atelierLakeside = b3(B);
          var G = g3(102);
          p3.atelierSeaside = b3(G);
          var J = g3(103);
          p3.bespin = b3(J);
          var Q = g3(104);
          p3.brewer = b3(Q);
          var se = g3(105);
          p3.bright = b3(se);
          var he = g3(106);
          p3.chalk = b3(he);
          var be = g3(107);
          p3.codeschool = b3(be);
          var de = g3(108);
          p3.colors = b3(de);
          var Fe = g3(109);
          p3.default = b3(Fe);
          var Pe = g3(110);
          p3.eighties = b3(Pe);
          var ze = g3(111);
          p3.embers = b3(ze);
          var $e = g3(112);
          p3.flat = b3($e);
          var Ke = g3(113);
          p3.google = b3(Ke);
          var nt = g3(114);
          p3.grayscale = b3(nt);
          var lt2 = g3(115);
          p3.greenscreen = b3(lt2);
          var bt = g3(116);
          p3.harmonic = b3(bt);
          var vt = g3(117);
          p3.hopscotch = b3(vt);
          var jt = g3(118);
          p3.isotope = b3(jt);
          var Jt = g3(119);
          p3.marrakesh = b3(Jt);
          var Rt = g3(120);
          p3.mocha = b3(Rt);
          var Jn = g3(121);
          p3.monokai = b3(Jn);
          var ln = g3(122);
          p3.ocean = b3(ln);
          var vn = g3(123);
          p3.paraiso = b3(vn);
          var kn = g3(124);
          p3.pop = b3(kn);
          var cr = g3(125);
          p3.railscasts = b3(cr);
          var gr = g3(126);
          p3.shapeshifter = b3(gr);
          var ha = g3(127);
          p3.solarized = b3(ha);
          var Ka = g3(128);
          p3.summerfruit = b3(Ka);
          var Do = g3(129);
          p3.tomorrow = b3(Do);
          var _o = g3(130);
          p3.tube = b3(_o);
          var xo = g3(131);
          p3.twilight = b3(xo);
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          p3.__esModule = true, p3.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, c3.exports = p3.default;
        }, function(c3, p3, g3) {
          var b3 = g3(33);
          function w3(M) {
            var I = Math.round(b3(M, 0, 255)).toString(16);
            return I.length == 1 ? "0" + I : I;
          }
          c3.exports = function(M) {
            var I = M.length === 4 ? w3(255 * M[3]) : "";
            return "#" + w3(M[0]) + w3(M[1]) + w3(M[2]) + I;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(134), w3 = g3(135), M = g3(136), I = g3(137), k3 = { "#": w3, hsl: function(F) {
            var B = b3(F), G = I(B);
            return B.length === 4 && G.push(B[3]), G;
          }, rgb: M };
          function L(F) {
            for (var B in k3)
              if (F.indexOf(B) === 0)
                return k3[B](F);
          }
          L.rgb = M, L.hsl = b3, L.hex = w3, c3.exports = L;
        }, function(c3, p3, g3) {
          var b3 = g3(44), w3 = g3(33);
          function M(I, k3) {
            switch (I = parseFloat(I), k3) {
              case 0:
                return w3(I, 0, 360);
              case 1:
              case 2:
                return w3(I, 0, 100);
              case 3:
                return w3(I, 0, 1);
            }
          }
          c3.exports = function(I) {
            return b3(I).map(M);
          };
        }, function(c3, p3) {
          c3.exports = function(g3) {
            g3.length !== 4 && g3.length !== 5 || (g3 = function(M) {
              for (var I = "#", k3 = 1; k3 < M.length; k3++) {
                var L = M.charAt(k3);
                I += L + L;
              }
              return I;
            }(g3));
            var b3 = [parseInt(g3.substring(1, 3), 16), parseInt(g3.substring(3, 5), 16), parseInt(g3.substring(5, 7), 16)];
            if (g3.length === 9) {
              var w3 = parseFloat((parseInt(g3.substring(7, 9), 16) / 255).toFixed(2));
              b3.push(w3);
            }
            return b3;
          };
        }, function(c3, p3, g3) {
          var b3 = g3(44), w3 = g3(33);
          function M(I, k3) {
            return k3 < 3 ? I.indexOf("%") != -1 ? Math.round(255 * w3(parseInt(I, 10), 0, 100) / 100) : w3(parseInt(I, 10), 0, 255) : w3(parseFloat(I), 0, 1);
          }
          c3.exports = function(I) {
            return b3(I).map(M);
          };
        }, function(c3, p3) {
          c3.exports = function(g3) {
            var b3, w3, M, I, k3, L = g3[0] / 360, F = g3[1] / 100, B = g3[2] / 100;
            if (F == 0)
              return [k3 = 255 * B, k3, k3];
            b3 = 2 * B - (w3 = B < 0.5 ? B * (1 + F) : B + F - B * F), I = [0, 0, 0];
            for (var G = 0; G < 3; G++)
              (M = L + 1 / 3 * -(G - 1)) < 0 && M++, M > 1 && M--, k3 = 6 * M < 1 ? b3 + 6 * (w3 - b3) * M : 2 * M < 1 ? w3 : 3 * M < 2 ? b3 + (w3 - b3) * (2 / 3 - M) * 6 : b3, I[G] = 255 * k3;
            return I;
          };
        }, function(c3, p3, g3) {
          (function(b3) {
            var w3 = typeof b3 == "object" && b3 && b3.Object === Object && b3, M = typeof self == "object" && self && self.Object === Object && self, I = w3 || M || Function("return this")();
            function k3(Ke, nt, lt2) {
              switch (lt2.length) {
                case 0:
                  return Ke.call(nt);
                case 1:
                  return Ke.call(nt, lt2[0]);
                case 2:
                  return Ke.call(nt, lt2[0], lt2[1]);
                case 3:
                  return Ke.call(nt, lt2[0], lt2[1], lt2[2]);
              }
              return Ke.apply(nt, lt2);
            }
            function L(Ke, nt) {
              for (var lt2 = -1, bt = nt.length, vt = Ke.length; ++lt2 < bt; )
                Ke[vt + lt2] = nt[lt2];
              return Ke;
            }
            var F = Object.prototype, B = F.hasOwnProperty, G = F.toString, J = I.Symbol, Q = F.propertyIsEnumerable, se = J ? J.isConcatSpreadable : void 0, he = Math.max;
            function be(Ke) {
              return de(Ke) || function(nt) {
                return function(lt2) {
                  return function(bt) {
                    return !!bt && typeof bt == "object";
                  }(lt2) && function(bt) {
                    return bt != null && function(vt) {
                      return typeof vt == "number" && vt > -1 && vt % 1 == 0 && vt <= 9007199254740991;
                    }(bt.length) && !function(vt) {
                      var jt = function(Jt) {
                        var Rt = typeof Jt;
                        return !!Jt && (Rt == "object" || Rt == "function");
                      }(vt) ? G.call(vt) : "";
                      return jt == "[object Function]" || jt == "[object GeneratorFunction]";
                    }(bt);
                  }(lt2);
                }(nt) && B.call(nt, "callee") && (!Q.call(nt, "callee") || G.call(nt) == "[object Arguments]");
              }(Ke) || !!(se && Ke && Ke[se]);
            }
            var de = Array.isArray, Fe, Pe, ze, $e = (Pe = function(Ke) {
              var nt = (Ke = function bt(vt, jt, Jt, Rt, Jn) {
                var ln = -1, vn = vt.length;
                for (Jt || (Jt = be), Jn || (Jn = []); ++ln < vn; ) {
                  var kn = vt[ln];
                  jt > 0 && Jt(kn) ? jt > 1 ? bt(kn, jt - 1, Jt, Rt, Jn) : L(Jn, kn) : Rt || (Jn[Jn.length] = kn);
                }
                return Jn;
              }(Ke, 1)).length, lt2 = nt;
              for (Fe; lt2--; )
                if (typeof Ke[lt2] != "function")
                  throw new TypeError("Expected a function");
              return function() {
                for (var bt = 0, vt = nt ? Ke[bt].apply(this, arguments) : arguments[0]; ++bt < nt; )
                  vt = Ke[bt].call(this, vt);
                return vt;
              };
            }, ze = he(ze === void 0 ? Pe.length - 1 : ze, 0), function() {
              for (var Ke = arguments, nt = -1, lt2 = he(Ke.length - ze, 0), bt = Array(lt2); ++nt < lt2; )
                bt[nt] = Ke[ze + nt];
              nt = -1;
              for (var vt = Array(ze + 1); ++nt < ze; )
                vt[nt] = Ke[nt];
              return vt[ze] = bt, k3(Pe, this, vt);
            });
            c3.exports = $e;
          }).call(this, g3(43));
        }, function(c3, p3, g3) {
          Object.defineProperty(p3, "__esModule", { value: true }), p3.yuv2rgb = function(b3) {
            var w3, M, I, k3 = b3[0], L = b3[1], F = b3[2];
            return w3 = 1 * k3 + 0 * L + 1.13983 * F, M = 1 * k3 + -0.39465 * L + -0.5806 * F, I = 1 * k3 + 2.02311 * L + 0 * F, w3 = Math.min(Math.max(0, w3), 1), M = Math.min(Math.max(0, M), 1), I = Math.min(Math.max(0, I), 1), [255 * w3, 255 * M, 255 * I];
          }, p3.rgb2yuv = function(b3) {
            var w3 = b3[0] / 255, M = b3[1] / 255, I = b3[2] / 255;
            return [0.299 * w3 + 0.587 * M + 0.114 * I, -0.14713 * w3 + -0.28886 * M + 0.436 * I, 0.615 * w3 + -0.51499 * M + -0.10001 * I];
          };
        }, function(c3, p3, g3) {
          function b3(I, k3, L) {
            return k3 in I ? Object.defineProperty(I, k3, { value: L, enumerable: true, configurable: true, writable: true }) : I[k3] = L, I;
          }
          var w3 = g3(141), M = function() {
            function I() {
              b3(this, "_callbacks", void 0), b3(this, "_isDispatching", void 0), b3(this, "_isHandled", void 0), b3(this, "_isPending", void 0), b3(this, "_lastID", void 0), b3(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
            }
            var k3 = I.prototype;
            return k3.register = function(L) {
              var F = "ID_" + this._lastID++;
              return this._callbacks[F] = L, F;
            }, k3.unregister = function(L) {
              this._callbacks[L] || w3(false), delete this._callbacks[L];
            }, k3.waitFor = function(L) {
              this._isDispatching || w3(false);
              for (var F = 0; F < L.length; F++) {
                var B = L[F];
                this._isPending[B] ? this._isHandled[B] || w3(false) : (this._callbacks[B] || w3(false), this._invokeCallback(B));
              }
            }, k3.dispatch = function(L) {
              this._isDispatching && w3(false), this._startDispatching(L);
              try {
                for (var F in this._callbacks)
                  this._isPending[F] || this._invokeCallback(F);
              } finally {
                this._stopDispatching();
              }
            }, k3.isDispatching = function() {
              return this._isDispatching;
            }, k3._invokeCallback = function(L) {
              this._isPending[L] = true, this._callbacks[L](this._pendingPayload), this._isHandled[L] = true;
            }, k3._startDispatching = function(L) {
              for (var F in this._callbacks)
                this._isPending[F] = false, this._isHandled[F] = false;
              this._pendingPayload = L, this._isDispatching = true;
            }, k3._stopDispatching = function() {
              delete this._pendingPayload, this._isDispatching = false;
            }, I;
          }();
          c3.exports = M;
        }, function(c3, p3, g3) {
          c3.exports = function(b3, w3) {
            for (var M = arguments.length, I = new Array(M > 2 ? M - 2 : 0), k3 = 2; k3 < M; k3++)
              I[k3 - 2] = arguments[k3];
            if (!b3) {
              var L;
              if (w3 === void 0)
                L = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
              else {
                var F = 0;
                (L = new Error(w3.replace(/%s/g, function() {
                  return String(I[F++]);
                }))).name = "Invariant Violation";
              }
              throw L.framesToPop = 1, L;
            }
          };
        }, function(c3, p3, g3) {
          function b3(In, Nn, Yt) {
            return Nn in In ? Object.defineProperty(In, Nn, { value: Yt, enumerable: true, configurable: true, writable: true }) : In[Nn] = Yt, In;
          }
          function w3(In, Nn) {
            var Yt = Object.keys(In);
            if (Object.getOwnPropertySymbols) {
              var _n = Object.getOwnPropertySymbols(In);
              Nn && (_n = _n.filter(function(Cn) {
                return Object.getOwnPropertyDescriptor(In, Cn).enumerable;
              })), Yt.push.apply(Yt, _n);
            }
            return Yt;
          }
          function M(In) {
            for (var Nn = 1; Nn < arguments.length; Nn++) {
              var Yt = arguments[Nn] != null ? arguments[Nn] : {};
              Nn % 2 ? w3(Object(Yt), true).forEach(function(_n) {
                b3(In, _n, Yt[_n]);
              }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(In, Object.getOwnPropertyDescriptors(Yt)) : w3(Object(Yt)).forEach(function(_n) {
                Object.defineProperty(In, _n, Object.getOwnPropertyDescriptor(Yt, _n));
              });
            }
            return In;
          }
          function I(In, Nn) {
            if (!(In instanceof Nn))
              throw new TypeError("Cannot call a class as a function");
          }
          function k3(In, Nn) {
            for (var Yt = 0; Yt < Nn.length; Yt++) {
              var _n = Nn[Yt];
              _n.enumerable = _n.enumerable || false, _n.configurable = true, "value" in _n && (_n.writable = true), Object.defineProperty(In, _n.key, _n);
            }
          }
          function L(In, Nn, Yt) {
            return Nn && k3(In.prototype, Nn), Yt && k3(In, Yt), In;
          }
          function F(In, Nn) {
            return (F = Object.setPrototypeOf || function(Yt, _n) {
              return Yt.__proto__ = _n, Yt;
            })(In, Nn);
          }
          function B(In, Nn) {
            if (typeof Nn != "function" && Nn !== null)
              throw new TypeError("Super expression must either be null or a function");
            In.prototype = Object.create(Nn && Nn.prototype, { constructor: { value: In, writable: true, configurable: true } }), Nn && F(In, Nn);
          }
          function G(In) {
            return (G = Object.setPrototypeOf ? Object.getPrototypeOf : function(Nn) {
              return Nn.__proto__ || Object.getPrototypeOf(Nn);
            })(In);
          }
          function J(In) {
            return (J = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Nn) {
              return typeof Nn;
            } : function(Nn) {
              return Nn && typeof Symbol == "function" && Nn.constructor === Symbol && Nn !== Symbol.prototype ? "symbol" : typeof Nn;
            })(In);
          }
          function Q(In) {
            if (In === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return In;
          }
          function se(In, Nn) {
            return !Nn || J(Nn) !== "object" && typeof Nn != "function" ? Q(In) : Nn;
          }
          function he(In) {
            var Nn = function() {
              if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
                return false;
              if (typeof Proxy == "function")
                return true;
              try {
                return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                })), true;
              } catch {
                return false;
              }
            }();
            return function() {
              var Yt, _n = G(In);
              if (Nn) {
                var Cn = G(this).constructor;
                Yt = Reflect.construct(_n, arguments, Cn);
              } else
                Yt = _n.apply(this, arguments);
              return se(this, Yt);
            };
          }
          g3.r(p3);
          var be = g3(0), de = g3.n(be);
          function Fe() {
            var In = this.constructor.getDerivedStateFromProps(this.props, this.state);
            In != null && this.setState(In);
          }
          function Pe(In) {
            this.setState(function(Nn) {
              var Yt = this.constructor.getDerivedStateFromProps(In, Nn);
              return Yt != null ? Yt : null;
            }.bind(this));
          }
          function ze(In, Nn) {
            try {
              var Yt = this.props, _n = this.state;
              this.props = In, this.state = Nn, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(Yt, _n);
            } finally {
              this.props = Yt, this.state = _n;
            }
          }
          function $e(In) {
            var Nn = In.prototype;
            if (!Nn || !Nn.isReactComponent)
              throw new Error("Can only polyfill class components");
            if (typeof In.getDerivedStateFromProps != "function" && typeof Nn.getSnapshotBeforeUpdate != "function")
              return In;
            var Yt = null, _n = null, Cn = null;
            if (typeof Nn.componentWillMount == "function" ? Yt = "componentWillMount" : typeof Nn.UNSAFE_componentWillMount == "function" && (Yt = "UNSAFE_componentWillMount"), typeof Nn.componentWillReceiveProps == "function" ? _n = "componentWillReceiveProps" : typeof Nn.UNSAFE_componentWillReceiveProps == "function" && (_n = "UNSAFE_componentWillReceiveProps"), typeof Nn.componentWillUpdate == "function" ? Cn = "componentWillUpdate" : typeof Nn.UNSAFE_componentWillUpdate == "function" && (Cn = "UNSAFE_componentWillUpdate"), Yt !== null || _n !== null || Cn !== null) {
              var Vt = In.displayName || In.name, Gi = typeof In.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + Vt + " uses " + Gi + " but also contains the following legacy lifecycles:" + (Yt !== null ? `
  ` + Yt : "") + (_n !== null ? `
  ` + _n : "") + (Cn !== null ? `
  ` + Cn : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
            }
            if (typeof In.getDerivedStateFromProps == "function" && (Nn.componentWillMount = Fe, Nn.componentWillReceiveProps = Pe), typeof Nn.getSnapshotBeforeUpdate == "function") {
              if (typeof Nn.componentDidUpdate != "function")
                throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
              Nn.componentWillUpdate = ze;
              var wi = Nn.componentDidUpdate;
              Nn.componentDidUpdate = function(pr, Ma, Na) {
                var fu = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : Na;
                wi.call(this, pr, Ma, fu);
              };
            }
            return In;
          }
          function Ke(In, Nn) {
            if (In == null)
              return {};
            var Yt, _n, Cn = function(Gi, wi) {
              if (Gi == null)
                return {};
              var pr, Ma, Na = {}, fu = Object.keys(Gi);
              for (Ma = 0; Ma < fu.length; Ma++)
                pr = fu[Ma], wi.indexOf(pr) >= 0 || (Na[pr] = Gi[pr]);
              return Na;
            }(In, Nn);
            if (Object.getOwnPropertySymbols) {
              var Vt = Object.getOwnPropertySymbols(In);
              for (_n = 0; _n < Vt.length; _n++)
                Yt = Vt[_n], Nn.indexOf(Yt) >= 0 || Object.prototype.propertyIsEnumerable.call(In, Yt) && (Cn[Yt] = In[Yt]);
            }
            return Cn;
          }
          function nt(In) {
            var Nn = function(Yt) {
              return {}.toString.call(Yt).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
            }(In);
            return Nn === "number" && (Nn = isNaN(In) ? "nan" : (0 | In) != In ? "float" : "integer"), Nn;
          }
          Fe.__suppressDeprecationWarning = true, Pe.__suppressDeprecationWarning = true, ze.__suppressDeprecationWarning = true;
          var lt2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, bt = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, vt = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, jt = g3(45), Jt = function(In) {
            var Nn = function(Yt) {
              return { backgroundColor: Yt.base00, ellipsisColor: Yt.base09, braceColor: Yt.base07, expandedIcon: Yt.base0D, collapsedIcon: Yt.base0E, keyColor: Yt.base07, arrayKeyColor: Yt.base0C, objectSize: Yt.base04, copyToClipboard: Yt.base0F, copyToClipboardCheck: Yt.base0D, objectBorder: Yt.base02, dataTypes: { boolean: Yt.base0E, date: Yt.base0D, float: Yt.base0B, function: Yt.base0D, integer: Yt.base0F, string: Yt.base09, nan: Yt.base08, null: Yt.base0A, undefined: Yt.base05, regexp: Yt.base0A, background: Yt.base02 }, editVariable: { editIcon: Yt.base0E, cancelIcon: Yt.base09, removeIcon: Yt.base09, addIcon: Yt.base0E, checkIcon: Yt.base0E, background: Yt.base01, color: Yt.base0A, border: Yt.base07 }, addKeyModal: { background: Yt.base05, border: Yt.base04, color: Yt.base0A, labelColor: Yt.base01 }, validationFailure: { background: Yt.base09, iconColor: Yt.base01, fontColor: Yt.base01 } };
            }(In);
            return { "app-container": { fontFamily: vt.globalFontFamily, cursor: vt.globalCursor, backgroundColor: Nn.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Nn.ellipsisColor, fontSize: vt.ellipsisFontSize, lineHeight: vt.ellipsisLineHeight, cursor: vt.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: vt.braceCursor, fontWeight: vt.braceFontWeight, color: Nn.braceColor }, "expanded-icon": { color: Nn.expandedIcon }, "collapsed-icon": { color: Nn.collapsedIcon }, colon: { display: "inline-block", margin: vt.keyMargin, color: Nn.keyColor, verticalAlign: "top" }, objectKeyVal: function(Yt, _n) {
              return { style: M({ paddingTop: vt.keyValPaddingTop, paddingRight: vt.keyValPaddingRight, paddingBottom: vt.keyValPaddingBottom, borderLeft: vt.keyValBorderLeft + " " + Nn.objectBorder, ":hover": { paddingLeft: _n.paddingLeft - 1 + "px", borderLeft: vt.keyValBorderHover + " " + Nn.objectBorder } }, _n) };
            }, "object-key-val-no-border": { padding: vt.keyValPadding }, "pushed-content": { marginLeft: vt.pushedContentMarginLeft }, variableValue: function(Yt, _n) {
              return { style: M({ display: "inline-block", paddingRight: vt.variableValuePaddingRight, position: "relative" }, _n) };
            }, "object-name": { display: "inline-block", color: Nn.keyColor, letterSpacing: vt.keyLetterSpacing, fontStyle: vt.keyFontStyle, verticalAlign: vt.keyVerticalAlign, opacity: vt.keyOpacity, ":hover": { opacity: vt.keyOpacityHover } }, "array-key": { display: "inline-block", color: Nn.arrayKeyColor, letterSpacing: vt.keyLetterSpacing, fontStyle: vt.keyFontStyle, verticalAlign: vt.keyVerticalAlign, opacity: vt.keyOpacity, ":hover": { opacity: vt.keyOpacityHover } }, "object-size": { color: Nn.objectSize, borderRadius: vt.objectSizeBorderRadius, fontStyle: vt.objectSizeFontStyle, margin: vt.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: vt.dataTypeFontSize, marginRight: vt.dataTypeMarginRight, opacity: vt.datatypeOpacity }, boolean: { display: "inline-block", color: Nn.dataTypes.boolean }, date: { display: "inline-block", color: Nn.dataTypes.date }, "date-value": { marginLeft: vt.dateValueMarginLeft }, float: { display: "inline-block", color: Nn.dataTypes.float }, function: { display: "inline-block", color: Nn.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Nn.dataTypes.integer }, string: { display: "inline-block", color: Nn.dataTypes.string }, nan: { display: "inline-block", color: Nn.dataTypes.nan, fontSize: vt.nanFontSize, fontWeight: vt.nanFontWeight, backgroundColor: Nn.dataTypes.background, padding: vt.nanPadding, borderRadius: vt.nanBorderRadius }, null: { display: "inline-block", color: Nn.dataTypes.null, fontSize: vt.nullFontSize, fontWeight: vt.nullFontWeight, backgroundColor: Nn.dataTypes.background, padding: vt.nullPadding, borderRadius: vt.nullBorderRadius }, undefined: { display: "inline-block", color: Nn.dataTypes.undefined, fontSize: vt.undefinedFontSize, padding: vt.undefinedPadding, borderRadius: vt.undefinedBorderRadius, backgroundColor: Nn.dataTypes.background }, regexp: { display: "inline-block", color: Nn.dataTypes.regexp }, "copy-to-clipboard": { cursor: vt.clipboardCursor }, "copy-icon": { color: Nn.copyToClipboard, fontSize: vt.iconFontSize, marginRight: vt.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Nn.copyToClipboardCheck, marginLeft: vt.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: vt.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: vt.metaDataPadding }, "icon-container": { display: "inline-block", width: vt.iconContainerWidth }, tooltip: { padding: vt.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Nn.editVariable.removeIcon, cursor: vt.iconCursor, fontSize: vt.iconFontSize, marginRight: vt.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Nn.editVariable.addIcon, cursor: vt.iconCursor, fontSize: vt.iconFontSize, marginRight: vt.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Nn.editVariable.editIcon, cursor: vt.iconCursor, fontSize: vt.iconFontSize, marginRight: vt.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: vt.iconCursor, color: Nn.editVariable.checkIcon, fontSize: vt.iconFontSize, paddingRight: vt.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: vt.iconCursor, color: Nn.editVariable.cancelIcon, fontSize: vt.iconFontSize, paddingRight: vt.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: vt.editInputMinWidth, borderRadius: vt.editInputBorderRadius, backgroundColor: Nn.editVariable.background, color: Nn.editVariable.color, padding: vt.editInputPadding, marginRight: vt.editInputMarginRight, fontFamily: vt.editInputFontFamily }, "detected-row": { paddingTop: vt.detectedRowPaddingTop }, "key-modal-request": { position: vt.addKeyCoverPosition, top: vt.addKeyCoverPositionPx, left: vt.addKeyCoverPositionPx, right: vt.addKeyCoverPositionPx, bottom: vt.addKeyCoverPositionPx, backgroundColor: vt.addKeyCoverBackground }, "key-modal": { width: vt.addKeyModalWidth, backgroundColor: Nn.addKeyModal.background, marginLeft: vt.addKeyModalMargin, marginRight: vt.addKeyModalMargin, padding: vt.addKeyModalPadding, borderRadius: vt.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Nn.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Nn.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Nn.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Nn.addKeyModal.labelColor, fontSize: vt.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Nn.editVariable.addIcon, fontSize: vt.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Nn.ellipsisColor, fontSize: vt.ellipsisFontSize, lineHeight: vt.ellipsisLineHeight, cursor: vt.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Nn.validationFailure.fontColor, backgroundColor: Nn.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Nn.validationFailure.iconColor, fontSize: vt.iconFontSize, transform: "rotate(45deg)" } };
          };
          function Rt(In, Nn, Yt) {
            return In || console.error("theme has not been set"), function(_n) {
              var Cn = lt2;
              return _n !== false && _n !== "none" || (Cn = bt), Object(jt.createStyling)(Jt, { defaultBase16: Cn })(_n);
            }(In)(Nn, Yt);
          }
          var Jn = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = (_n.rjvId, _n.type_name), Vt = _n.displayDataTypes, Gi = _n.theme;
              return Vt ? de.a.createElement("span", Object.assign({ className: "data-type-label" }, Rt(Gi, "data-type-label")), Cn) : null;
            } }]), Yt;
          }(de.a.PureComponent), ln = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props;
              return de.a.createElement("div", Rt(_n.theme, "boolean"), de.a.createElement(Jn, Object.assign({ type_name: "bool" }, _n)), _n.value ? "true" : "false");
            } }]), Yt;
          }(de.a.PureComponent), vn = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props;
              return de.a.createElement("div", Rt(_n.theme, "date"), de.a.createElement(Jn, Object.assign({ type_name: "date" }, _n)), de.a.createElement("span", Object.assign({ className: "date-value" }, Rt(_n.theme, "date-value")), _n.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
            } }]), Yt;
          }(de.a.PureComponent), kn = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props;
              return de.a.createElement("div", Rt(_n.theme, "float"), de.a.createElement(Jn, Object.assign({ type_name: "float" }, _n)), this.props.value);
            } }]), Yt;
          }(de.a.PureComponent);
          function cr(In, Nn) {
            (Nn == null || Nn > In.length) && (Nn = In.length);
            for (var Yt = 0, _n = new Array(Nn); Yt < Nn; Yt++)
              _n[Yt] = In[Yt];
            return _n;
          }
          function gr(In, Nn) {
            if (In) {
              if (typeof In == "string")
                return cr(In, Nn);
              var Yt = Object.prototype.toString.call(In).slice(8, -1);
              return Yt === "Object" && In.constructor && (Yt = In.constructor.name), Yt === "Map" || Yt === "Set" ? Array.from(In) : Yt === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Yt) ? cr(In, Nn) : void 0;
            }
          }
          function ha(In, Nn) {
            var Yt;
            if (typeof Symbol == "undefined" || In[Symbol.iterator] == null) {
              if (Array.isArray(In) || (Yt = gr(In)) || Nn && In && typeof In.length == "number") {
                Yt && (In = Yt);
                var _n = 0, Cn = function() {
                };
                return { s: Cn, n: function() {
                  return _n >= In.length ? { done: true } : { done: false, value: In[_n++] };
                }, e: function(pr) {
                  throw pr;
                }, f: Cn };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            var Vt, Gi = true, wi = false;
            return { s: function() {
              Yt = In[Symbol.iterator]();
            }, n: function() {
              var pr = Yt.next();
              return Gi = pr.done, pr;
            }, e: function(pr) {
              wi = true, Vt = pr;
            }, f: function() {
              try {
                Gi || Yt.return == null || Yt.return();
              } finally {
                if (wi)
                  throw Vt;
              }
            } };
          }
          function Ka(In) {
            return function(Nn) {
              if (Array.isArray(Nn))
                return cr(Nn);
            }(In) || function(Nn) {
              if (typeof Symbol != "undefined" && Symbol.iterator in Object(Nn))
                return Array.from(Nn);
            }(In) || gr(In) || function() {
              throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }();
          }
          var Do = g3(46), _o = new (g3(47)).Dispatcher(), xo = new (function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              var _n;
              I(this, Yt);
              for (var Cn = arguments.length, Vt = new Array(Cn), Gi = 0; Gi < Cn; Gi++)
                Vt[Gi] = arguments[Gi];
              return (_n = Nn.call.apply(Nn, [this].concat(Vt))).objects = {}, _n.set = function(wi, pr, Ma, Na) {
                _n.objects[wi] === void 0 && (_n.objects[wi] = {}), _n.objects[wi][pr] === void 0 && (_n.objects[wi][pr] = {}), _n.objects[wi][pr][Ma] = Na;
              }, _n.get = function(wi, pr, Ma, Na) {
                return _n.objects[wi] === void 0 || _n.objects[wi][pr] === void 0 || _n.objects[wi][pr][Ma] == null ? Na : _n.objects[wi][pr][Ma];
              }, _n.handleAction = function(wi) {
                var pr = wi.rjvId, Ma = wi.data;
                switch (wi.name) {
                  case "RESET":
                    _n.emit("reset-" + pr);
                    break;
                  case "VARIABLE_UPDATED":
                    wi.data.updated_src = _n.updateSrc(pr, Ma), _n.set(pr, "action", "variable-update", M(M({}, Ma), {}, { type: "variable-edited" })), _n.emit("variable-update-" + pr);
                    break;
                  case "VARIABLE_REMOVED":
                    wi.data.updated_src = _n.updateSrc(pr, Ma), _n.set(pr, "action", "variable-update", M(M({}, Ma), {}, { type: "variable-removed" })), _n.emit("variable-update-" + pr);
                    break;
                  case "VARIABLE_ADDED":
                    wi.data.updated_src = _n.updateSrc(pr, Ma), _n.set(pr, "action", "variable-update", M(M({}, Ma), {}, { type: "variable-added" })), _n.emit("variable-update-" + pr);
                    break;
                  case "ADD_VARIABLE_KEY_REQUEST":
                    _n.set(pr, "action", "new-key-request", Ma), _n.emit("add-key-request-" + pr);
                }
              }, _n.updateSrc = function(wi, pr) {
                var Ma = pr.name, Na = pr.namespace, fu = pr.new_value, ic = (pr.existing_value, pr.variable_removed);
                Na.shift();
                var mc, _u = _n.get(wi, "global", "src"), kf = _n.deepCopy(_u, Ka(Na)), xp = kf, Al = ha(Na);
                try {
                  for (Al.s(); !(mc = Al.n()).done; )
                    xp = xp[mc.value];
                } catch (Sd) {
                  Al.e(Sd);
                } finally {
                  Al.f();
                }
                return ic ? nt(xp) == "array" ? xp.splice(Ma, 1) : delete xp[Ma] : Ma !== null ? xp[Ma] = fu : kf = fu, _n.set(wi, "global", "src", kf), kf;
              }, _n.deepCopy = function(wi, pr) {
                var Ma, Na = nt(wi), fu = pr.shift();
                return Na == "array" ? Ma = Ka(wi) : Na == "object" && (Ma = M({}, wi)), fu !== void 0 && (Ma[fu] = _n.deepCopy(wi[fu], pr)), Ma;
              }, _n;
            }
            return Yt;
          }(Do.EventEmitter))();
          _o.register(xo.handleAction.bind(xo));
          var Ra = xo, ho = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).toggleCollapsed = function() {
                Cn.setState({ collapsed: !Cn.state.collapsed }, function() {
                  Ra.set(Cn.props.rjvId, Cn.props.namespace, "collapsed", Cn.state.collapsed);
                });
              }, Cn.getFunctionDisplay = function(Vt) {
                var Gi = Q(Cn).props;
                return Vt ? de.a.createElement("span", null, Cn.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), de.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, de.a.createElement("span", null, "{"), de.a.createElement("span", Rt(Gi.theme, "ellipsis"), "..."), de.a.createElement("span", null, "}"))) : Cn.props.value.toString().slice(9, -1);
              }, Cn.state = { collapsed: Ra.get(_n.rjvId, _n.namespace, "collapsed", true) }, Cn;
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = this.state.collapsed;
              return de.a.createElement("div", Rt(_n.theme, "function"), de.a.createElement(Jn, Object.assign({ type_name: "function" }, _n)), de.a.createElement("span", Object.assign({}, Rt(_n.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Cn)));
            } }]), Yt;
          }(de.a.PureComponent), Mo = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              return de.a.createElement("div", Rt(this.props.theme, "nan"), "NaN");
            } }]), Yt;
          }(de.a.PureComponent), Xa = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              return de.a.createElement("div", Rt(this.props.theme, "null"), "NULL");
            } }]), Yt;
          }(de.a.PureComponent), Zo = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props;
              return de.a.createElement("div", Rt(_n.theme, "integer"), de.a.createElement(Jn, Object.assign({ type_name: "int" }, _n)), this.props.value);
            } }]), Yt;
          }(de.a.PureComponent), rc = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props;
              return de.a.createElement("div", Rt(_n.theme, "regexp"), de.a.createElement(Jn, Object.assign({ type_name: "regexp" }, _n)), this.props.value.toString());
            } }]), Yt;
          }(de.a.PureComponent), ys = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).toggleCollapsed = function() {
                Cn.setState({ collapsed: !Cn.state.collapsed }, function() {
                  Ra.set(Cn.props.rjvId, Cn.props.namespace, "collapsed", Cn.state.collapsed);
                });
              }, Cn.state = { collapsed: Ra.get(_n.rjvId, _n.namespace, "collapsed", true) }, Cn;
            }
            return L(Yt, [{ key: "render", value: function() {
              this.state.collapsed;
              var _n = this.props, Cn = _n.collapseStringsAfterLength, Vt = _n.theme, Gi = _n.value, wi = { style: { cursor: "default" } };
              return nt(Cn) === "integer" && Gi.length > Cn && (wi.style.cursor = "pointer", this.state.collapsed && (Gi = de.a.createElement("span", null, Gi.substring(0, Cn), de.a.createElement("span", Rt(Vt, "ellipsis"), " ...")))), de.a.createElement("div", Rt(Vt, "string"), de.a.createElement(Jn, Object.assign({ type_name: "string" }, _n)), de.a.createElement("span", Object.assign({ className: "string-value" }, wi, { onClick: this.toggleCollapsed }), '"', Gi, '"'));
            } }]), Yt;
          }(de.a.PureComponent), Vu = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              return de.a.createElement("div", Rt(this.props.theme, "undefined"), "undefined");
            } }]), Yt;
          }(de.a.PureComponent);
          function gc() {
            return (gc = Object.assign || function(In) {
              for (var Nn = 1; Nn < arguments.length; Nn++) {
                var Yt = arguments[Nn];
                for (var _n in Yt)
                  Object.prototype.hasOwnProperty.call(Yt, _n) && (In[_n] = Yt[_n]);
              }
              return In;
            }).apply(this, arguments);
          }
          var ef = be.useLayoutEffect, dv = function(In) {
            var Nn = Object(be.useRef)(In);
            return ef(function() {
              Nn.current = In;
            }), Nn;
          }, Wf = function(In, Nn) {
            typeof In != "function" ? In.current = Nn : In(Nn);
          }, Ag = function(In, Nn) {
            var Yt = Object(be.useRef)();
            return Object(be.useCallback)(function(_n) {
              In.current = _n, Yt.current && Wf(Yt.current, null), Yt.current = Nn, Nn && Wf(Nn, _n);
            }, [Nn]);
          }, eh = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, _p = function(In) {
            Object.keys(eh).forEach(function(Nn) {
              In.style.setProperty(Nn, eh[Nn], "important");
            });
          }, ap = null, Hw = function() {
          }, Ji = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Jr = !!document.documentElement.currentStyle, Xr = function(In, Nn) {
            var Yt = In.cacheMeasurements, _n = In.maxRows, Cn = In.minRows, Vt = In.onChange, Gi = Vt === void 0 ? Hw : Vt, wi = In.onHeightChange, pr = wi === void 0 ? Hw : wi, Ma = function(Al, Sd) {
              if (Al == null)
                return {};
              var td, Lb, qI = {}, b0 = Object.keys(Al);
              for (Lb = 0; Lb < b0.length; Lb++)
                td = b0[Lb], Sd.indexOf(td) >= 0 || (qI[td] = Al[td]);
              return qI;
            }(In, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), Na, fu = Ma.value !== void 0, ic = Object(be.useRef)(null), mc = Ag(ic, Nn), _u = Object(be.useRef)(0), kf = Object(be.useRef)(), xp = function() {
              var Al = ic.current, Sd = Yt && kf.current ? kf.current : function(b0) {
                var Ww = window.getComputedStyle(b0);
                if (Ww === null)
                  return null;
                var tC, vv = (tC = Ww, Ji.reduce(function($I, Uw) {
                  return $I[Uw] = tC[Uw], $I;
                }, {})), Rb = vv.boxSizing;
                return Rb === "" ? null : (Jr && Rb === "border-box" && (vv.width = parseFloat(vv.width) + parseFloat(vv.borderRightWidth) + parseFloat(vv.borderLeftWidth) + parseFloat(vv.paddingRight) + parseFloat(vv.paddingLeft) + "px"), { sizingStyle: vv, paddingSize: parseFloat(vv.paddingBottom) + parseFloat(vv.paddingTop), borderSize: parseFloat(vv.borderBottomWidth) + parseFloat(vv.borderTopWidth) });
              }(Al);
              if (Sd) {
                kf.current = Sd;
                var td = function(b0, Ww, tC, vv) {
                  tC === void 0 && (tC = 1), vv === void 0 && (vv = 1 / 0), ap || ((ap = document.createElement("textarea")).setAttribute("tab-index", "-1"), ap.setAttribute("aria-hidden", "true"), _p(ap)), ap.parentNode === null && document.body.appendChild(ap);
                  var Rb = b0.paddingSize, $I = b0.borderSize, Uw = b0.sizingStyle, qw = Uw.boxSizing;
                  Object.keys(Uw).forEach(function(Bo) {
                    var Ms = Bo;
                    ap.style[Ms] = Uw[Ms];
                  }), _p(ap), ap.value = Ww;
                  var nC = function(Bo, Ms) {
                    var YI = Bo.scrollHeight;
                    return Ms.sizingStyle.boxSizing === "border-box" ? YI + Ms.borderSize : YI - Ms.paddingSize;
                  }(ap, b0);
                  ap.value = "x";
                  var NL = ap.scrollHeight - Rb, XI = NL * tC;
                  qw === "border-box" && (XI = XI + Rb + $I), nC = Math.max(XI, nC);
                  var sT = NL * vv;
                  return qw === "border-box" && (sT = sT + Rb + $I), [nC = Math.min(sT, nC), NL];
                }(Sd, Al.value || Al.placeholder || "x", Cn, _n), Lb = td[0], qI = td[1];
                _u.current !== Lb && (_u.current = Lb, Al.style.setProperty("height", Lb + "px", "important"), pr(Lb, { rowHeight: qI }));
              }
            };
            return Object(be.useLayoutEffect)(xp), Na = dv(xp), Object(be.useLayoutEffect)(function() {
              var Al = function(Sd) {
                Na.current(Sd);
              };
              return window.addEventListener("resize", Al), function() {
                window.removeEventListener("resize", Al);
              };
            }, []), Object(be.createElement)("textarea", gc({}, Ma, { onChange: function(Al) {
              fu || xp(), Gi(Al);
            }, ref: mc }));
          }, ta = Object(be.forwardRef)(Xr);
          function co(In) {
            In = In.trim();
            try {
              if ((In = JSON.stringify(JSON.parse(In)))[0] === "[")
                return cs("array", JSON.parse(In));
              if (In[0] === "{")
                return cs("object", JSON.parse(In));
              if (In.match(/\-?\d+\.\d+/) && In.match(/\-?\d+\.\d+/)[0] === In)
                return cs("float", parseFloat(In));
              if (In.match(/\-?\d+e-\d+/) && In.match(/\-?\d+e-\d+/)[0] === In)
                return cs("float", Number(In));
              if (In.match(/\-?\d+/) && In.match(/\-?\d+/)[0] === In)
                return cs("integer", parseInt(In));
              if (In.match(/\-?\d+e\+\d+/) && In.match(/\-?\d+e\+\d+/)[0] === In)
                return cs("integer", Number(In));
            } catch {
            }
            switch (In = In.toLowerCase()) {
              case "undefined":
                return cs("undefined", void 0);
              case "nan":
                return cs("nan", NaN);
              case "null":
                return cs("null", null);
              case "true":
                return cs("boolean", true);
              case "false":
                return cs("boolean", false);
              default:
                if (In = Date.parse(In))
                  return cs("date", new Date(In));
            }
            return cs(false, null);
          }
          function cs(In, Nn) {
            return { type: In, value: Nn };
          }
          var nu = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
            } }]), Yt;
          }(de.a.PureComponent), ru = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
            } }]), Yt;
          }(de.a.PureComponent), hf = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]), Gi = yc(Cn).style;
              return de.a.createElement("span", Vt, de.a.createElement("svg", { fill: Gi.color, width: Gi.height, height: Gi.width, style: Gi, viewBox: "0 0 1792 1792" }, de.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), Yt;
          }(de.a.PureComponent), op = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]), Gi = yc(Cn).style;
              return de.a.createElement("span", Vt, de.a.createElement("svg", { fill: Gi.color, width: Gi.height, height: Gi.width, style: Gi, viewBox: "0 0 1792 1792" }, de.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
            } }]), Yt;
          }(de.a.PureComponent), _h = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", { style: M(M({}, yc(Cn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, de.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
            } }]), Yt;
          }(de.a.PureComponent), wd = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", { style: M(M({}, yc(Cn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, de.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
            } }]), Yt;
          }(de.a.PureComponent), xh = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("g", null, de.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
            } }]), Yt;
          }(de.a.PureComponent), m0 = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("g", null, de.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), Yt;
          }(de.a.PureComponent), Sy = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("g", null, de.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), Yt;
          }(de.a.PureComponent), Ob = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("g", null, de.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
            } }]), Yt;
          }(de.a.PureComponent), Cy = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("g", null, de.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
            } }]), Yt;
          }(de.a.PureComponent), Gp = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.style, Vt = Ke(_n, ["style"]);
              return de.a.createElement("span", Vt, de.a.createElement("svg", Object.assign({}, yc(Cn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), de.a.createElement("g", null, de.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
            } }]), Yt;
          }(de.a.PureComponent);
          function yc(In) {
            return In || (In = {}), { style: M(M({ verticalAlign: "middle" }, In), {}, { color: In.color ? In.color : "#000000", height: "1em", width: "1em" }) };
          }
          var Xd = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).copiedTimer = null, Cn.handleCopy = function() {
                var Vt = document.createElement("textarea"), Gi = Cn.props, wi = Gi.clickCallback, pr = Gi.src, Ma = Gi.namespace;
                Vt.innerHTML = JSON.stringify(Cn.clipboardValue(pr), null, "  "), document.body.appendChild(Vt), Vt.select(), document.execCommand("copy"), document.body.removeChild(Vt), Cn.copiedTimer = setTimeout(function() {
                  Cn.setState({ copied: false });
                }, 5500), Cn.setState({ copied: true }, function() {
                  typeof wi == "function" && wi({ src: pr, namespace: Ma, name: Ma[Ma.length - 1] });
                });
              }, Cn.getClippyIcon = function() {
                var Vt = Cn.props.theme;
                return Cn.state.copied ? de.a.createElement("span", null, de.a.createElement(xh, Object.assign({ className: "copy-icon" }, Rt(Vt, "copy-icon"))), de.a.createElement("span", Rt(Vt, "copy-icon-copied"), "\u2714")) : de.a.createElement(xh, Object.assign({ className: "copy-icon" }, Rt(Vt, "copy-icon")));
              }, Cn.clipboardValue = function(Vt) {
                switch (nt(Vt)) {
                  case "function":
                  case "regexp":
                    return Vt.toString();
                  default:
                    return Vt;
                }
              }, Cn.state = { copied: false }, Cn;
            }
            return L(Yt, [{ key: "componentWillUnmount", value: function() {
              this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
            } }, { key: "render", value: function() {
              var _n = this.props, Cn = (_n.src, _n.theme), Vt = _n.hidden, Gi = _n.rowHovered, wi = Rt(Cn, "copy-to-clipboard").style, pr = "inline";
              return Vt && (pr = "none"), de.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: Gi ? "inline-block" : "none" } }, de.a.createElement("span", { style: M(M({}, wi), {}, { display: pr }), onClick: this.handleCopy }, this.getClippyIcon()));
            } }]), Yt;
          }(de.a.PureComponent), Ig = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).getEditIcon = function() {
                var Vt = Cn.props, Gi = Vt.variable, wi = Vt.theme;
                return de.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Cn.state.hovered ? "inline-block" : "none" } }, de.a.createElement(Cy, Object.assign({ className: "click-to-edit-icon" }, Rt(wi, "editVarIcon"), { onClick: function() {
                  Cn.prepopInput(Gi);
                } })));
              }, Cn.prepopInput = function(Vt) {
                if (Cn.props.onEdit !== false) {
                  var Gi = function(pr) {
                    var Ma;
                    switch (nt(pr)) {
                      case "undefined":
                        Ma = "undefined";
                        break;
                      case "nan":
                        Ma = "NaN";
                        break;
                      case "string":
                        Ma = pr;
                        break;
                      case "date":
                      case "function":
                      case "regexp":
                        Ma = pr.toString();
                        break;
                      default:
                        try {
                          Ma = JSON.stringify(pr, null, "  ");
                        } catch {
                          Ma = "";
                        }
                    }
                    return Ma;
                  }(Vt.value), wi = co(Gi);
                  Cn.setState({ editMode: true, editValue: Gi, parsedInput: { type: wi.type, value: wi.value } });
                }
              }, Cn.getRemoveIcon = function() {
                var Vt = Cn.props, Gi = Vt.variable, wi = Vt.namespace, pr = Vt.theme, Ma = Vt.rjvId;
                return de.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Cn.state.hovered ? "inline-block" : "none" } }, de.a.createElement(m0, Object.assign({ className: "click-to-remove-icon" }, Rt(pr, "removeVarIcon"), { onClick: function() {
                  _o.dispatch({ name: "VARIABLE_REMOVED", rjvId: Ma, data: { name: Gi.name, namespace: wi, existing_value: Gi.value, variable_removed: true } });
                } })));
              }, Cn.getValue = function(Vt, Gi) {
                var wi = !Gi && Vt.type, pr = Q(Cn).props;
                switch (wi) {
                  case false:
                    return Cn.getEditInput();
                  case "string":
                    return de.a.createElement(ys, Object.assign({ value: Vt.value }, pr));
                  case "integer":
                    return de.a.createElement(Zo, Object.assign({ value: Vt.value }, pr));
                  case "float":
                    return de.a.createElement(kn, Object.assign({ value: Vt.value }, pr));
                  case "boolean":
                    return de.a.createElement(ln, Object.assign({ value: Vt.value }, pr));
                  case "function":
                    return de.a.createElement(ho, Object.assign({ value: Vt.value }, pr));
                  case "null":
                    return de.a.createElement(Xa, pr);
                  case "nan":
                    return de.a.createElement(Mo, pr);
                  case "undefined":
                    return de.a.createElement(Vu, pr);
                  case "date":
                    return de.a.createElement(vn, Object.assign({ value: Vt.value }, pr));
                  case "regexp":
                    return de.a.createElement(rc, Object.assign({ value: Vt.value }, pr));
                  default:
                    return de.a.createElement("div", { className: "object-value" }, JSON.stringify(Vt.value));
                }
              }, Cn.getEditInput = function() {
                var Vt = Cn.props.theme, Gi = Cn.state.editValue;
                return de.a.createElement("div", null, de.a.createElement(ta, Object.assign({ type: "text", inputRef: function(wi) {
                  return wi && wi.focus();
                }, value: Gi, className: "variable-editor", onChange: function(wi) {
                  var pr = wi.target.value, Ma = co(pr);
                  Cn.setState({ editValue: pr, parsedInput: { type: Ma.type, value: Ma.value } });
                }, onKeyDown: function(wi) {
                  switch (wi.key) {
                    case "Escape":
                      Cn.setState({ editMode: false, editValue: "" });
                      break;
                    case "Enter":
                      (wi.ctrlKey || wi.metaKey) && Cn.submitEdit(true);
                  }
                  wi.stopPropagation();
                }, placeholder: "update this value", minRows: 2 }, Rt(Vt, "edit-input"))), de.a.createElement("div", Rt(Vt, "edit-icon-container"), de.a.createElement(m0, Object.assign({ className: "edit-cancel" }, Rt(Vt, "cancel-icon"), { onClick: function() {
                  Cn.setState({ editMode: false, editValue: "" });
                } })), de.a.createElement(Gp, Object.assign({ className: "edit-check string-value" }, Rt(Vt, "check-icon"), { onClick: function() {
                  Cn.submitEdit();
                } })), de.a.createElement("div", null, Cn.showDetected())));
              }, Cn.submitEdit = function(Vt) {
                var Gi = Cn.props, wi = Gi.variable, pr = Gi.namespace, Ma = Gi.rjvId, Na = Cn.state, fu = Na.editValue, ic = Na.parsedInput, mc = fu;
                Vt && ic.type && (mc = ic.value), Cn.setState({ editMode: false }), _o.dispatch({ name: "VARIABLE_UPDATED", rjvId: Ma, data: { name: wi.name, namespace: pr, existing_value: wi.value, new_value: mc, variable_removed: false } });
              }, Cn.showDetected = function() {
                var Vt = Cn.props, Gi = Vt.theme, wi = (Vt.variable, Vt.namespace, Vt.rjvId, Cn.state.parsedInput), pr = (wi.type, wi.value, Cn.getDetectedInput());
                if (pr)
                  return de.a.createElement("div", null, de.a.createElement("div", Rt(Gi, "detected-row"), pr, de.a.createElement(Gp, { className: "edit-check detected", style: M({ verticalAlign: "top", paddingLeft: "3px" }, Rt(Gi, "check-icon").style), onClick: function() {
                    Cn.submitEdit(true);
                  } })));
              }, Cn.getDetectedInput = function() {
                var Vt = Cn.state.parsedInput, Gi = Vt.type, wi = Vt.value, pr = Q(Cn).props, Ma = pr.theme;
                if (Gi !== false)
                  switch (Gi.toLowerCase()) {
                    case "object":
                      return de.a.createElement("span", null, de.a.createElement("span", { style: M(M({}, Rt(Ma, "brace").style), {}, { cursor: "default" }) }, "{"), de.a.createElement("span", { style: M(M({}, Rt(Ma, "ellipsis").style), {}, { cursor: "default" }) }, "..."), de.a.createElement("span", { style: M(M({}, Rt(Ma, "brace").style), {}, { cursor: "default" }) }, "}"));
                    case "array":
                      return de.a.createElement("span", null, de.a.createElement("span", { style: M(M({}, Rt(Ma, "brace").style), {}, { cursor: "default" }) }, "["), de.a.createElement("span", { style: M(M({}, Rt(Ma, "ellipsis").style), {}, { cursor: "default" }) }, "..."), de.a.createElement("span", { style: M(M({}, Rt(Ma, "brace").style), {}, { cursor: "default" }) }, "]"));
                    case "string":
                      return de.a.createElement(ys, Object.assign({ value: wi }, pr));
                    case "integer":
                      return de.a.createElement(Zo, Object.assign({ value: wi }, pr));
                    case "float":
                      return de.a.createElement(kn, Object.assign({ value: wi }, pr));
                    case "boolean":
                      return de.a.createElement(ln, Object.assign({ value: wi }, pr));
                    case "function":
                      return de.a.createElement(ho, Object.assign({ value: wi }, pr));
                    case "null":
                      return de.a.createElement(Xa, pr);
                    case "nan":
                      return de.a.createElement(Mo, pr);
                    case "undefined":
                      return de.a.createElement(Vu, pr);
                    case "date":
                      return de.a.createElement(vn, Object.assign({ value: new Date(wi) }, pr));
                  }
              }, Cn.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Cn;
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this, Cn = this.props, Vt = Cn.variable, Gi = Cn.singleIndent, wi = Cn.type, pr = Cn.theme, Ma = Cn.namespace, Na = Cn.indentWidth, fu = Cn.enableClipboard, ic = Cn.onEdit, mc = Cn.onDelete, _u = Cn.onSelect, kf = Cn.displayArrayKey, xp = Cn.quotesOnKeys, Al = this.state.editMode;
              return de.a.createElement("div", Object.assign({}, Rt(pr, "objectKeyVal", { paddingLeft: Na * Gi }), { onMouseEnter: function() {
                return _n.setState(M(M({}, _n.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return _n.setState(M(M({}, _n.state), {}, { hovered: false }));
              }, className: "variable-row", key: Vt.name }), wi == "array" ? kf ? de.a.createElement("span", Object.assign({}, Rt(pr, "array-key"), { key: Vt.name + "_" + Ma }), Vt.name, de.a.createElement("div", Rt(pr, "colon"), ":")) : null : de.a.createElement("span", null, de.a.createElement("span", Object.assign({}, Rt(pr, "object-name"), { className: "object-key", key: Vt.name + "_" + Ma }), !!xp && de.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), de.a.createElement("span", { style: { display: "inline-block" } }, Vt.name), !!xp && de.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), de.a.createElement("span", Rt(pr, "colon"), ":")), de.a.createElement("div", Object.assign({ className: "variable-value", onClick: _u === false && ic === false ? null : function(Sd) {
                var td = Ka(Ma);
                (Sd.ctrlKey || Sd.metaKey) && ic !== false ? _n.prepopInput(Vt) : _u !== false && (td.shift(), _u(M(M({}, Vt), {}, { namespace: td })));
              } }, Rt(pr, "variableValue", { cursor: _u === false ? "default" : "pointer" })), this.getValue(Vt, Al)), fu ? de.a.createElement(Xd, { rowHovered: this.state.hovered, hidden: Al, src: Vt.value, clickCallback: fu, theme: pr, namespace: [].concat(Ka(Ma), [Vt.name]) }) : null, ic !== false && Al == 0 ? this.getEditIcon() : null, mc !== false && Al == 0 ? this.getRemoveIcon() : null);
            } }]), Yt;
          }(de.a.PureComponent), Pb = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              var _n;
              I(this, Yt);
              for (var Cn = arguments.length, Vt = new Array(Cn), Gi = 0; Gi < Cn; Gi++)
                Vt[Gi] = arguments[Gi];
              return (_n = Nn.call.apply(Nn, [this].concat(Vt))).getObjectSize = function() {
                var wi = _n.props, pr = wi.size, Ma = wi.theme;
                if (wi.displayObjectSize)
                  return de.a.createElement("span", Object.assign({ className: "object-size" }, Rt(Ma, "object-size")), pr, " item", pr === 1 ? "" : "s");
              }, _n.getAddAttribute = function(wi) {
                var pr = _n.props, Ma = pr.theme, Na = pr.namespace, fu = pr.name, ic = pr.src, mc = pr.rjvId, _u = pr.depth;
                return de.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: wi ? "inline-block" : "none" } }, de.a.createElement(Sy, Object.assign({ className: "click-to-add-icon" }, Rt(Ma, "addVarIcon"), { onClick: function() {
                  var kf = { name: _u > 0 ? fu : null, namespace: Na.splice(0, Na.length - 1), existing_value: ic, variable_removed: false, key_name: null };
                  nt(ic) === "object" ? _o.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: mc, data: kf }) : _o.dispatch({ name: "VARIABLE_ADDED", rjvId: mc, data: M(M({}, kf), {}, { new_value: [].concat(Ka(ic), [null]) }) });
                } })));
              }, _n.getRemoveObject = function(wi) {
                var pr = _n.props, Ma = pr.theme, Na = (pr.hover, pr.namespace), fu = pr.name, ic = pr.src, mc = pr.rjvId;
                if (Na.length !== 1)
                  return de.a.createElement("span", { className: "click-to-remove", style: { display: wi ? "inline-block" : "none" } }, de.a.createElement(m0, Object.assign({ className: "click-to-remove-icon" }, Rt(Ma, "removeVarIcon"), { onClick: function() {
                    _o.dispatch({ name: "VARIABLE_REMOVED", rjvId: mc, data: { name: fu, namespace: Na.splice(0, Na.length - 1), existing_value: ic, variable_removed: true } });
                  } })));
              }, _n.render = function() {
                var wi = _n.props, pr = wi.theme, Ma = wi.onDelete, Na = wi.onAdd, fu = wi.enableClipboard, ic = wi.src, mc = wi.namespace, _u = wi.rowHovered;
                return de.a.createElement("div", Object.assign({}, Rt(pr, "object-meta-data"), { className: "object-meta-data", onClick: function(kf) {
                  kf.stopPropagation();
                } }), _n.getObjectSize(), fu ? de.a.createElement(Xd, { rowHovered: _u, clickCallback: fu, src: ic, theme: pr, namespace: mc }) : null, Na !== false ? _n.getAddAttribute(_u) : null, Ma !== false ? _n.getRemoveObject(_u) : null);
              }, _n;
            }
            return Yt;
          }(de.a.PureComponent);
          function Em(In) {
            var Nn = In.parent_type, Yt = In.namespace, _n = In.quotesOnKeys, Cn = In.theme, Vt = In.jsvRoot, Gi = In.name, wi = In.displayArrayKey, pr = In.name ? In.name : "";
            return !Vt || Gi !== false && Gi !== null ? Nn == "array" ? wi ? de.a.createElement("span", Object.assign({}, Rt(Cn, "array-key"), { key: Yt }), de.a.createElement("span", { className: "array-key" }, pr), de.a.createElement("span", Rt(Cn, "colon"), ":")) : de.a.createElement("span", null) : de.a.createElement("span", Object.assign({}, Rt(Cn, "object-name"), { key: Yt }), de.a.createElement("span", { className: "object-key" }, _n && de.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), de.a.createElement("span", null, pr), _n && de.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), de.a.createElement("span", Rt(Cn, "colon"), ":")) : de.a.createElement("span", null);
          }
          function My(In) {
            var Nn = In.theme;
            switch (In.iconStyle) {
              case "triangle":
                return de.a.createElement(wd, Object.assign({}, Rt(Nn, "expanded-icon"), { className: "expanded-icon" }));
              case "square":
                return de.a.createElement(hf, Object.assign({}, Rt(Nn, "expanded-icon"), { className: "expanded-icon" }));
              default:
                return de.a.createElement(nu, Object.assign({}, Rt(Nn, "expanded-icon"), { className: "expanded-icon" }));
            }
          }
          function z1(In) {
            var Nn = In.theme;
            switch (In.iconStyle) {
              case "triangle":
                return de.a.createElement(_h, Object.assign({}, Rt(Nn, "collapsed-icon"), { className: "collapsed-icon" }));
              case "square":
                return de.a.createElement(op, Object.assign({}, Rt(Nn, "collapsed-icon"), { className: "collapsed-icon" }));
              default:
                return de.a.createElement(ru, Object.assign({}, Rt(Nn, "collapsed-icon"), { className: "collapsed-icon" }));
            }
          }
          var oT = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).toggleCollapsed = function(Vt) {
                var Gi = [];
                for (var wi in Cn.state.expanded)
                  Gi.push(Cn.state.expanded[wi]);
                Gi[Vt] = !Gi[Vt], Cn.setState({ expanded: Gi });
              }, Cn.state = { expanded: [] }, Cn;
            }
            return L(Yt, [{ key: "getExpandedIcon", value: function(_n) {
              var Cn = this.props, Vt = Cn.theme, Gi = Cn.iconStyle;
              return this.state.expanded[_n] ? de.a.createElement(My, { theme: Vt, iconStyle: Gi }) : de.a.createElement(z1, { theme: Vt, iconStyle: Gi });
            } }, { key: "render", value: function() {
              var _n = this, Cn = this.props, Vt = Cn.src, Gi = Cn.groupArraysAfterLength, wi = (Cn.depth, Cn.name), pr = Cn.theme, Ma = Cn.jsvRoot, Na = Cn.namespace, fu = (Cn.parent_type, Ke(Cn, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), ic = 0, mc = 5 * this.props.indentWidth;
              Ma || (ic = 5 * this.props.indentWidth);
              var _u = Gi, kf = Math.ceil(Vt.length / _u);
              return de.a.createElement("div", Object.assign({ className: "object-key-val" }, Rt(pr, Ma ? "jsv-root" : "objectKeyVal", { paddingLeft: ic })), de.a.createElement(Em, this.props), de.a.createElement("span", null, de.a.createElement(Pb, Object.assign({ size: Vt.length }, this.props))), Ka(Array(kf)).map(function(xp, Al) {
                return de.a.createElement("div", Object.assign({ key: Al, className: "object-key-val array-group" }, Rt(pr, "objectKeyVal", { marginLeft: 6, paddingLeft: mc })), de.a.createElement("span", Rt(pr, "brace-row"), de.a.createElement("div", Object.assign({ className: "icon-container" }, Rt(pr, "icon-container"), { onClick: function(Sd) {
                  _n.toggleCollapsed(Al);
                } }), _n.getExpandedIcon(Al)), _n.state.expanded[Al] ? de.a.createElement(eC, Object.assign({ key: wi + Al, depth: 0, name: false, collapsed: false, groupArraysAfterLength: _u, index_offset: Al * _u, src: Vt.slice(Al * _u, Al * _u + _u), namespace: Na, type: "array", parent_type: "array_group", theme: pr }, fu)) : de.a.createElement("span", Object.assign({}, Rt(pr, "brace"), { onClick: function(Sd) {
                  _n.toggleCollapsed(Al);
                }, className: "array-group-brace" }), "[", de.a.createElement("div", Object.assign({}, Rt(pr, "array-group-meta-data"), { className: "array-group-meta-data" }), de.a.createElement("span", Object.assign({ className: "object-size" }, Rt(pr, "object-size")), Al * _u, " - ", Al * _u + _u > Vt.length ? Vt.length : Al * _u + _u)), "]")));
              }));
            } }]), Yt;
          }(de.a.PureComponent), Q2 = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              I(this, Yt), (Cn = Nn.call(this, _n)).toggleCollapsed = function() {
                Cn.setState({ expanded: !Cn.state.expanded }, function() {
                  Ra.set(Cn.props.rjvId, Cn.props.namespace, "expanded", Cn.state.expanded);
                });
              }, Cn.getObjectContent = function(Gi, wi, pr) {
                return de.a.createElement("div", { className: "pushed-content object-container" }, de.a.createElement("div", Object.assign({ className: "object-content" }, Rt(Cn.props.theme, "pushed-content")), Cn.renderObjectContents(wi, pr)));
              }, Cn.getEllipsis = function() {
                return Cn.state.size === 0 ? null : de.a.createElement("div", Object.assign({}, Rt(Cn.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Cn.toggleCollapsed }), "...");
              }, Cn.getObjectMetaData = function(Gi) {
                var wi = Cn.props, pr = (wi.rjvId, wi.theme, Cn.state), Ma = pr.size, Na = pr.hovered;
                return de.a.createElement(Pb, Object.assign({ rowHovered: Na, size: Ma }, Cn.props));
              }, Cn.renderObjectContents = function(Gi, wi) {
                var pr, Ma = Cn.props, Na = Ma.depth, fu = Ma.parent_type, ic = Ma.index_offset, mc = Ma.groupArraysAfterLength, _u = Ma.namespace, kf = Cn.state.object_type, xp = [], Al = Object.keys(Gi || {});
                return Cn.props.sortKeys && kf !== "array" && (Al = Al.sort()), Al.forEach(function(Sd) {
                  if (pr = new RL(Sd, Gi[Sd]), fu === "array_group" && ic && (pr.name = parseInt(pr.name) + ic), Gi.hasOwnProperty(Sd))
                    if (pr.type === "object")
                      xp.push(de.a.createElement(eC, Object.assign({ key: pr.name, depth: Na + 1, name: pr.name, src: pr.value, namespace: _u.concat(pr.name), parent_type: kf }, wi)));
                    else if (pr.type === "array") {
                      var td = eC;
                      mc && pr.value.length > mc && (td = oT), xp.push(de.a.createElement(td, Object.assign({ key: pr.name, depth: Na + 1, name: pr.name, src: pr.value, namespace: _u.concat(pr.name), type: "array", parent_type: kf }, wi)));
                    } else
                      xp.push(de.a.createElement(Ig, Object.assign({ key: pr.name + "_" + _u, variable: pr, singleIndent: 5, namespace: _u, type: Cn.props.type }, wi)));
                }), xp;
              };
              var Vt = Yt.getState(_n);
              return Cn.state = M(M({}, Vt), {}, { prevProps: {} }), Cn;
            }
            return L(Yt, [{ key: "getBraceStart", value: function(_n, Cn) {
              var Vt = this, Gi = this.props, wi = Gi.src, pr = Gi.theme, Ma = Gi.iconStyle;
              if (Gi.parent_type === "array_group")
                return de.a.createElement("span", null, de.a.createElement("span", Rt(pr, "brace"), _n === "array" ? "[" : "{"), Cn ? this.getObjectMetaData(wi) : null);
              var Na = Cn ? My : z1;
              return de.a.createElement("span", null, de.a.createElement("span", Object.assign({ onClick: function(fu) {
                Vt.toggleCollapsed();
              } }, Rt(pr, "brace-row")), de.a.createElement("div", Object.assign({ className: "icon-container" }, Rt(pr, "icon-container")), de.a.createElement(Na, { theme: pr, iconStyle: Ma })), de.a.createElement(Em, this.props), de.a.createElement("span", Rt(pr, "brace"), _n === "array" ? "[" : "{")), Cn ? this.getObjectMetaData(wi) : null);
            } }, { key: "render", value: function() {
              var _n = this, Cn = this.props, Vt = Cn.depth, Gi = Cn.src, wi = (Cn.namespace, Cn.name, Cn.type, Cn.parent_type), pr = Cn.theme, Ma = Cn.jsvRoot, Na = Cn.iconStyle, fu = Ke(Cn, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), ic = this.state, mc = ic.object_type, _u = ic.expanded, kf = {};
              return Ma || wi === "array_group" ? wi === "array_group" && (kf.borderLeft = 0, kf.display = "inline") : kf.paddingLeft = 5 * this.props.indentWidth, de.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
                return _n.setState(M(M({}, _n.state), {}, { hovered: true }));
              }, onMouseLeave: function() {
                return _n.setState(M(M({}, _n.state), {}, { hovered: false }));
              } }, Rt(pr, Ma ? "jsv-root" : "objectKeyVal", kf)), this.getBraceStart(mc, _u), _u ? this.getObjectContent(Vt, Gi, M({ theme: pr, iconStyle: Na }, fu)) : this.getEllipsis(), de.a.createElement("span", { className: "brace-row" }, de.a.createElement("span", { style: M(M({}, Rt(pr, "brace").style), {}, { paddingLeft: _u ? "3px" : "0px" }) }, mc === "array" ? "]" : "}"), _u ? null : this.getObjectMetaData(Gi)));
            } }], [{ key: "getDerivedStateFromProps", value: function(_n, Cn) {
              var Vt = Cn.prevProps;
              return _n.src !== Vt.src || _n.collapsed !== Vt.collapsed || _n.name !== Vt.name || _n.namespace !== Vt.namespace || _n.rjvId !== Vt.rjvId ? M(M({}, Yt.getState(_n)), {}, { prevProps: _n }) : null;
            } }]), Yt;
          }(de.a.PureComponent);
          Q2.getState = function(In) {
            var Nn = Object.keys(In.src).length, Yt = (In.collapsed === false || In.collapsed !== true && In.collapsed > In.depth) && (!In.shouldCollapse || In.shouldCollapse({ name: In.name, src: In.src, type: nt(In.src), namespace: In.namespace }) === false) && Nn !== 0;
            return { expanded: Ra.get(In.rjvId, In.namespace, "expanded", Yt), object_type: In.type === "array" ? "array" : "object", parent_type: In.type === "array" ? "array" : "object", size: Nn, hovered: false };
          };
          var RL = function In(Nn, Yt) {
            I(this, In), this.name = Nn, this.value = Yt, this.type = nt(Yt);
          };
          $e(Q2);
          var eC = Q2, QW = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              var _n;
              I(this, Yt);
              for (var Cn = arguments.length, Vt = new Array(Cn), Gi = 0; Gi < Cn; Gi++)
                Vt[Gi] = arguments[Gi];
              return (_n = Nn.call.apply(Nn, [this].concat(Vt))).render = function() {
                var wi = Q(_n).props, pr = [wi.name], Ma = eC;
                return Array.isArray(wi.src) && wi.groupArraysAfterLength && wi.src.length > wi.groupArraysAfterLength && (Ma = oT), de.a.createElement("div", { className: "pretty-json-container object-container" }, de.a.createElement("div", { className: "object-content" }, de.a.createElement(Ma, Object.assign({ namespace: pr, depth: 0, jsvRoot: true }, wi))));
              }, _n;
            }
            return Yt;
          }(de.a.PureComponent), eU = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).closeModal = function() {
                _o.dispatch({ rjvId: Cn.props.rjvId, name: "RESET" });
              }, Cn.submit = function() {
                Cn.props.submit(Cn.state.input);
              }, Cn.state = { input: _n.input ? _n.input : "" }, Cn;
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this, Cn = this.props, Vt = Cn.theme, Gi = Cn.rjvId, wi = Cn.isValid, pr = this.state.input, Ma = wi(pr);
              return de.a.createElement("div", Object.assign({ className: "key-modal-request" }, Rt(Vt, "key-modal-request"), { onClick: this.closeModal }), de.a.createElement("div", Object.assign({}, Rt(Vt, "key-modal"), { onClick: function(Na) {
                Na.stopPropagation();
              } }), de.a.createElement("div", Rt(Vt, "key-modal-label"), "Key Name:"), de.a.createElement("div", { style: { position: "relative" } }, de.a.createElement("input", Object.assign({}, Rt(Vt, "key-modal-input"), { className: "key-modal-input", ref: function(Na) {
                return Na && Na.focus();
              }, spellCheck: false, value: pr, placeholder: "...", onChange: function(Na) {
                _n.setState({ input: Na.target.value });
              }, onKeyPress: function(Na) {
                Ma && Na.key === "Enter" ? _n.submit() : Na.key === "Escape" && _n.closeModal();
              } })), Ma ? de.a.createElement(Gp, Object.assign({}, Rt(Vt, "key-modal-submit"), { className: "key-modal-submit", onClick: function(Na) {
                return _n.submit();
              } })) : null), de.a.createElement("span", Rt(Vt, "key-modal-cancel"), de.a.createElement(Ob, Object.assign({}, Rt(Vt, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
                _o.dispatch({ rjvId: Gi, name: "RESET" });
              } })))));
            } }]), Yt;
          }(de.a.PureComponent), tU = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              var _n;
              I(this, Yt);
              for (var Cn = arguments.length, Vt = new Array(Cn), Gi = 0; Gi < Cn; Gi++)
                Vt[Gi] = arguments[Gi];
              return (_n = Nn.call.apply(Nn, [this].concat(Vt))).isValid = function(wi) {
                var pr = _n.props.rjvId, Ma = Ra.get(pr, "action", "new-key-request");
                return wi != "" && Object.keys(Ma.existing_value).indexOf(wi) === -1;
              }, _n.submit = function(wi) {
                var pr = _n.props.rjvId, Ma = Ra.get(pr, "action", "new-key-request");
                Ma.new_value = M({}, Ma.existing_value), Ma.new_value[wi] = _n.props.defaultValue, _o.dispatch({ name: "VARIABLE_ADDED", rjvId: pr, data: Ma });
              }, _n;
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.active, Vt = _n.theme, Gi = _n.rjvId;
              return Cn ? de.a.createElement(eU, { rjvId: Gi, theme: Vt, isValid: this.isValid, submit: this.submit }) : null;
            } }]), Yt;
          }(de.a.PureComponent), nU = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt() {
              return I(this, Yt), Nn.apply(this, arguments);
            }
            return L(Yt, [{ key: "render", value: function() {
              var _n = this.props, Cn = _n.message, Vt = _n.active, Gi = _n.theme, wi = _n.rjvId;
              return Vt ? de.a.createElement("div", Object.assign({ className: "validation-failure" }, Rt(Gi, "validation-failure"), { onClick: function() {
                _o.dispatch({ rjvId: wi, name: "RESET" });
              } }), de.a.createElement("span", Rt(Gi, "validation-failure-label"), Cn), de.a.createElement(Ob, Rt(Gi, "validation-failure-clear"))) : null;
            } }]), Yt;
          }(de.a.PureComponent), Ak = function(In) {
            B(Yt, In);
            var Nn = he(Yt);
            function Yt(_n) {
              var Cn;
              return I(this, Yt), (Cn = Nn.call(this, _n)).rjvId = Date.now().toString(), Cn.getListeners = function() {
                return { reset: Cn.resetState, "variable-update": Cn.updateSrc, "add-key-request": Cn.addKeyRequest };
              }, Cn.updateSrc = function() {
                var Vt, Gi = Ra.get(Cn.rjvId, "action", "variable-update"), wi = Gi.name, pr = Gi.namespace, Ma = Gi.new_value, Na = Gi.existing_value, fu = (Gi.variable_removed, Gi.updated_src), ic = Gi.type, mc = Cn.props, _u = mc.onEdit, kf = mc.onDelete, xp = mc.onAdd, Al = { existing_src: Cn.state.src, new_value: Ma, updated_src: fu, name: wi, namespace: pr, existing_value: Na };
                switch (ic) {
                  case "variable-added":
                    Vt = xp(Al);
                    break;
                  case "variable-edited":
                    Vt = _u(Al);
                    break;
                  case "variable-removed":
                    Vt = kf(Al);
                }
                Vt !== false ? (Ra.set(Cn.rjvId, "global", "src", fu), Cn.setState({ src: fu })) : Cn.setState({ validationFailure: true });
              }, Cn.addKeyRequest = function() {
                Cn.setState({ addKeyRequest: true });
              }, Cn.resetState = function() {
                Cn.setState({ validationFailure: false, addKeyRequest: false });
              }, Cn.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: Yt.defaultProps.src, name: Yt.defaultProps.name, theme: Yt.defaultProps.theme, validationMessage: Yt.defaultProps.validationMessage, prevSrc: Yt.defaultProps.src, prevName: Yt.defaultProps.name, prevTheme: Yt.defaultProps.theme }, Cn;
            }
            return L(Yt, [{ key: "componentDidMount", value: function() {
              Ra.set(this.rjvId, "global", "src", this.state.src);
              var _n = this.getListeners();
              for (var Cn in _n)
                Ra.on(Cn + "-" + this.rjvId, _n[Cn]);
              this.setState({ addKeyRequest: false, editKeyRequest: false });
            } }, { key: "componentDidUpdate", value: function(_n, Cn) {
              Cn.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Cn.editKeyRequest !== false && this.setState({ editKeyRequest: false }), _n.src !== this.state.src && Ra.set(this.rjvId, "global", "src", this.state.src);
            } }, { key: "componentWillUnmount", value: function() {
              var _n = this.getListeners();
              for (var Cn in _n)
                Ra.removeListener(Cn + "-" + this.rjvId, _n[Cn]);
            } }, { key: "render", value: function() {
              var _n = this.state, Cn = _n.validationFailure, Vt = _n.validationMessage, Gi = _n.addKeyRequest, wi = _n.theme, pr = _n.src, Ma = _n.name, Na = this.props, fu = Na.style, ic = Na.defaultValue;
              return de.a.createElement("div", { className: "react-json-view", style: M(M({}, Rt(wi, "app-container").style), fu) }, de.a.createElement(nU, { message: Vt, active: Cn, theme: wi, rjvId: this.rjvId }), de.a.createElement(QW, Object.assign({}, this.props, { src: pr, name: Ma, theme: wi, type: nt(pr), rjvId: this.rjvId })), de.a.createElement(tU, { active: Gi, theme: wi, rjvId: this.rjvId, defaultValue: ic }));
            } }], [{ key: "getDerivedStateFromProps", value: function(_n, Cn) {
              if (_n.src !== Cn.prevSrc || _n.name !== Cn.prevName || _n.theme !== Cn.prevTheme) {
                var Vt = { src: _n.src, name: _n.name, theme: _n.theme, validationMessage: _n.validationMessage, prevSrc: _n.src, prevName: _n.name, prevTheme: _n.theme };
                return Yt.validateState(Vt);
              }
              return null;
            } }]), Yt;
          }(de.a.PureComponent);
          Ak.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Ak.validateState = function(In) {
            var Nn = {};
            return nt(In.theme) !== "object" || function(Yt) {
              var _n = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
              if (nt(Yt) === "object") {
                for (var Cn = 0; Cn < _n.length; Cn++)
                  if (!(_n[Cn] in Yt))
                    return false;
                return true;
              }
              return false;
            }(In.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Nn.theme = "rjv-default"), nt(In.src) !== "object" && nt(In.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Nn.name = "ERROR", Nn.src = { message: "src property must be a valid json object" }), M(M({}, In), Nn);
          }, $e(Ak), p3.default = Ak;
        }]);
      });
    })(uje);
    var IRt = pt(uje.exports);
    const ERt = ({ id: o, title: i, chart: t3, option: c3 }) => {
      const { tool: p3 } = _1e({}), g3 = rre({ global: true }), [b3, { set: w3 }] = te(true);
      console.log("option", c3);
      const M = (I) => {
        const { updated_src: k3 } = I;
        t3 == null || t3.setOption(k3), p3 == null || p3.add(o, t3, k3, i), g3.emit("list");
      };
      return hRt("div", { children: [o9(mRt, { children: o9(wRt, { children: o9(CRt, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (I) => {
        w3(!I);
      } }) }) }), o9("br", {}), c3 && o9(IRt, { src: c3, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: b3, iconStyle: "triangle", enableClipboard: true, onEdit: M, onAdd: M, onDelete: M })] });
    };
    l3.EchartTool = ARt, l3.ReactEchartsJson = ERt, l3.useEcharts = HOt, l3.useEchartsTool = _1e, l3.useEventEmitter = rre;
  })(Nhe);
  const tkn = () => {
    const l3 = Nhe.useEventEmitter({ global: true }), r3 = Nc.useRef(0), { tool: e3 } = Nhe.useEchartsTool({});
    Nc.useState(false), Nc.useState("right");
    const [u, h] = Nc.useState([]), [v4, m3] = Nc.useState();
    return l3.useSubscription("list", () => {
      var x3;
      e3 != null && e3.list().length && (m3((x3 = e3 == null ? void 0 : e3.list()) == null ? void 0 : x3[r3.current]), h(e3 == null ? void 0 : e3.list()));
    }), Xz("div", { className: ekn.container, children: false });
  };
  var Mgt = { exports: {} };
  (function(l3, r3) {
    (function(e3, u) {
      l3.exports = u(uj.default);
    })(p2, function(e3) {
      return function(u) {
        var h = {};
        function v4(m3) {
          if (h[m3])
            return h[m3].exports;
          var x3 = h[m3] = { i: m3, l: false, exports: {} };
          return u[m3].call(x3.exports, x3, x3.exports, v4), x3.l = true, x3.exports;
        }
        return v4.m = u, v4.c = h, v4.d = function(m3, x3, C) {
          v4.o(m3, x3) || Object.defineProperty(m3, x3, { enumerable: true, get: C });
        }, v4.r = function(m3) {
          typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(m3, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(m3, "__esModule", { value: true });
        }, v4.t = function(m3, x3) {
          if (1 & x3 && (m3 = v4(m3)), 8 & x3 || 4 & x3 && typeof m3 == "object" && m3 && m3.__esModule)
            return m3;
          var C = /* @__PURE__ */ Object.create(null);
          if (v4.r(C), Object.defineProperty(C, "default", { enumerable: true, value: m3 }), 2 & x3 && typeof m3 != "string")
            for (var A2 in m3)
              v4.d(C, A2, function(D) {
                return m3[D];
              }.bind(null, A2));
          return C;
        }, v4.n = function(m3) {
          var x3 = m3 && m3.__esModule ? function() {
            return m3.default;
          } : function() {
            return m3;
          };
          return v4.d(x3, "a", x3), x3;
        }, v4.o = function(m3, x3) {
          return Object.prototype.hasOwnProperty.call(m3, x3);
        }, v4.p = "", v4(v4.s = 48);
      }([function(u, h) {
        u.exports = e3;
      }, function(u, h) {
        var v4 = u.exports = { version: "2.6.12" };
        typeof __e == "number" && (__e = v4);
      }, function(u, h, v4) {
        var m3 = v4(26)("wks"), x3 = v4(17), C = v4(3).Symbol, A2 = typeof C == "function";
        (u.exports = function(D) {
          return m3[D] || (m3[D] = A2 && C[D] || (A2 ? C : x3)("Symbol." + D));
        }).store = m3;
      }, function(u, h) {
        var v4 = u.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
        typeof __g == "number" && (__g = v4);
      }, function(u, h, v4) {
        u.exports = !v4(8)(function() {
          return Object.defineProperty({}, "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(u, h) {
        var v4 = {}.hasOwnProperty;
        u.exports = function(m3, x3) {
          return v4.call(m3, x3);
        };
      }, function(u, h, v4) {
        var m3 = v4(7), x3 = v4(16);
        u.exports = v4(4) ? function(C, A2, D) {
          return m3.f(C, A2, x3(1, D));
        } : function(C, A2, D) {
          return C[A2] = D, C;
        };
      }, function(u, h, v4) {
        var m3 = v4(10), x3 = v4(35), C = v4(23), A2 = Object.defineProperty;
        h.f = v4(4) ? Object.defineProperty : function(D, P, N) {
          if (m3(D), P = C(P, true), m3(N), x3)
            try {
              return A2(D, P, N);
            } catch {
            }
          if ("get" in N || "set" in N)
            throw TypeError("Accessors not supported!");
          return "value" in N && (D[P] = N.value), D;
        };
      }, function(u, h) {
        u.exports = function(v4) {
          try {
            return !!v4();
          } catch {
            return true;
          }
        };
      }, function(u, h, v4) {
        var m3 = v4(40), x3 = v4(22);
        u.exports = function(C) {
          return m3(x3(C));
        };
      }, function(u, h, v4) {
        var m3 = v4(11);
        u.exports = function(x3) {
          if (!m3(x3))
            throw TypeError(x3 + " is not an object!");
          return x3;
        };
      }, function(u, h) {
        u.exports = function(v4) {
          return typeof v4 == "object" ? v4 !== null : typeof v4 == "function";
        };
      }, function(u, h) {
        u.exports = {};
      }, function(u, h, v4) {
        var m3 = v4(39), x3 = v4(27);
        u.exports = Object.keys || function(C) {
          return m3(C, x3);
        };
      }, function(u, h) {
        u.exports = true;
      }, function(u, h, v4) {
        var m3 = v4(3), x3 = v4(1), C = v4(53), A2 = v4(6), D = v4(5), P = function(N, j, W) {
          var K, te, ne, ce = N & P.F, me = N & P.G, ve = N & P.S, Be = N & P.P, Oe = N & P.B, We = N & P.W, Ue = me ? x3 : x3[j] || (x3[j] = {}), qe = Ue.prototype, Ze = me ? m3 : ve ? m3[j] : (m3[j] || {}).prototype;
          for (K in me && (W = j), W)
            (te = !ce && Ze && Ze[K] !== void 0) && D(Ue, K) || (ne = te ? Ze[K] : W[K], Ue[K] = me && typeof Ze[K] != "function" ? W[K] : Oe && te ? C(ne, m3) : We && Ze[K] == ne ? function(ct) {
              var _t = function(pt, zt, Zt) {
                if (this instanceof ct) {
                  switch (arguments.length) {
                    case 0:
                      return new ct();
                    case 1:
                      return new ct(pt);
                    case 2:
                      return new ct(pt, zt);
                  }
                  return new ct(pt, zt, Zt);
                }
                return ct.apply(this, arguments);
              };
              return _t.prototype = ct.prototype, _t;
            }(ne) : Be && typeof ne == "function" ? C(Function.call, ne) : ne, Be && ((Ue.virtual || (Ue.virtual = {}))[K] = ne, N & P.R && qe && !qe[K] && A2(qe, K, ne)));
        };
        P.F = 1, P.G = 2, P.S = 4, P.P = 8, P.B = 16, P.W = 32, P.U = 64, P.R = 128, u.exports = P;
      }, function(u, h) {
        u.exports = function(v4, m3) {
          return { enumerable: !(1 & v4), configurable: !(2 & v4), writable: !(4 & v4), value: m3 };
        };
      }, function(u, h) {
        var v4 = 0, m3 = Math.random();
        u.exports = function(x3) {
          return "Symbol(".concat(x3 === void 0 ? "" : x3, ")_", (++v4 + m3).toString(36));
        };
      }, function(u, h, v4) {
        var m3 = v4(22);
        u.exports = function(x3) {
          return Object(m3(x3));
        };
      }, function(u, h) {
        h.f = {}.propertyIsEnumerable;
      }, function(u, h, v4) {
        var m3 = v4(52)(true);
        v4(34)(String, "String", function(x3) {
          this._t = String(x3), this._i = 0;
        }, function() {
          var x3, C = this._t, A2 = this._i;
          return A2 >= C.length ? { value: void 0, done: true } : (x3 = m3(C, A2), this._i += x3.length, { value: x3, done: false });
        });
      }, function(u, h) {
        var v4 = Math.ceil, m3 = Math.floor;
        u.exports = function(x3) {
          return isNaN(x3 = +x3) ? 0 : (x3 > 0 ? m3 : v4)(x3);
        };
      }, function(u, h) {
        u.exports = function(v4) {
          if (v4 == null)
            throw TypeError("Can't call method on  " + v4);
          return v4;
        };
      }, function(u, h, v4) {
        var m3 = v4(11);
        u.exports = function(x3, C) {
          if (!m3(x3))
            return x3;
          var A2, D;
          if (C && typeof (A2 = x3.toString) == "function" && !m3(D = A2.call(x3)) || typeof (A2 = x3.valueOf) == "function" && !m3(D = A2.call(x3)) || !C && typeof (A2 = x3.toString) == "function" && !m3(D = A2.call(x3)))
            return D;
          throw TypeError("Can't convert object to primitive value");
        };
      }, function(u, h) {
        var v4 = {}.toString;
        u.exports = function(m3) {
          return v4.call(m3).slice(8, -1);
        };
      }, function(u, h, v4) {
        var m3 = v4(26)("keys"), x3 = v4(17);
        u.exports = function(C) {
          return m3[C] || (m3[C] = x3(C));
        };
      }, function(u, h, v4) {
        var m3 = v4(1), x3 = v4(3), C = x3["__core-js_shared__"] || (x3["__core-js_shared__"] = {});
        (u.exports = function(A2, D) {
          return C[A2] || (C[A2] = D !== void 0 ? D : {});
        })("versions", []).push({ version: m3.version, mode: v4(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
      }, function(u, h) {
        u.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
      }, function(u, h, v4) {
        var m3 = v4(7).f, x3 = v4(5), C = v4(2)("toStringTag");
        u.exports = function(A2, D, P) {
          A2 && !x3(A2 = P ? A2 : A2.prototype, C) && m3(A2, C, { configurable: true, value: D });
        };
      }, function(u, h, v4) {
        v4(62);
        for (var m3 = v4(3), x3 = v4(6), C = v4(12), A2 = v4(2)("toStringTag"), D = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), P = 0; P < D.length; P++) {
          var N = D[P], j = m3[N], W = j && j.prototype;
          W && !W[A2] && x3(W, A2, N), C[N] = C.Array;
        }
      }, function(u, h, v4) {
        h.f = v4(2);
      }, function(u, h, v4) {
        var m3 = v4(3), x3 = v4(1), C = v4(14), A2 = v4(30), D = v4(7).f;
        u.exports = function(P) {
          var N = x3.Symbol || (x3.Symbol = C ? {} : m3.Symbol || {});
          P.charAt(0) == "_" || P in N || D(N, P, { value: A2.f(P) });
        };
      }, function(u, h) {
        h.f = Object.getOwnPropertySymbols;
      }, function(u, h) {
        u.exports = function(v4, m3, x3) {
          return Math.min(Math.max(v4, m3), x3);
        };
      }, function(u, h, v4) {
        var m3 = v4(14), x3 = v4(15), C = v4(37), A2 = v4(6), D = v4(12), P = v4(55), N = v4(28), j = v4(61), W = v4(2)("iterator"), K = !([].keys && "next" in [].keys()), te = function() {
          return this;
        };
        u.exports = function(ne, ce, me, ve, Be, Oe, We) {
          P(me, ce, ve);
          var Ue, qe, Ze, ct = function(zn) {
            if (!K && zn in Zt)
              return Zt[zn];
            switch (zn) {
              case "keys":
              case "values":
                return function() {
                  return new me(this, zn);
                };
            }
            return function() {
              return new me(this, zn);
            };
          }, _t = ce + " Iterator", pt = Be == "values", zt = false, Zt = ne.prototype, Ft = Zt[W] || Zt["@@iterator"] || Be && Zt[Be], Kn = Ft || ct(Be), hn = Be ? pt ? ct("entries") : Kn : void 0, xn = ce == "Array" && Zt.entries || Ft;
          if (xn && (Ze = j(xn.call(new ne()))) !== Object.prototype && Ze.next && (N(Ze, _t, true), m3 || typeof Ze[W] == "function" || A2(Ze, W, te)), pt && Ft && Ft.name !== "values" && (zt = true, Kn = function() {
            return Ft.call(this);
          }), m3 && !We || !K && !zt && Zt[W] || A2(Zt, W, Kn), D[ce] = Kn, D[_t] = te, Be)
            if (Ue = { values: pt ? Kn : ct("values"), keys: Oe ? Kn : ct("keys"), entries: hn }, We)
              for (qe in Ue)
                qe in Zt || C(Zt, qe, Ue[qe]);
            else
              x3(x3.P + x3.F * (K || zt), ce, Ue);
          return Ue;
        };
      }, function(u, h, v4) {
        u.exports = !v4(4) && !v4(8)(function() {
          return Object.defineProperty(v4(36)("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      }, function(u, h, v4) {
        var m3 = v4(11), x3 = v4(3).document, C = m3(x3) && m3(x3.createElement);
        u.exports = function(A2) {
          return C ? x3.createElement(A2) : {};
        };
      }, function(u, h, v4) {
        u.exports = v4(6);
      }, function(u, h, v4) {
        var m3 = v4(10), x3 = v4(56), C = v4(27), A2 = v4(25)("IE_PROTO"), D = function() {
        }, P = function() {
          var N, j = v4(36)("iframe"), W = C.length;
          for (j.style.display = "none", v4(60).appendChild(j), j.src = "javascript:", (N = j.contentWindow.document).open(), N.write("<script>document.F=Object<\/script>"), N.close(), P = N.F; W--; )
            delete P.prototype[C[W]];
          return P();
        };
        u.exports = Object.create || function(N, j) {
          var W;
          return N !== null ? (D.prototype = m3(N), W = new D(), D.prototype = null, W[A2] = N) : W = P(), j === void 0 ? W : x3(W, j);
        };
      }, function(u, h, v4) {
        var m3 = v4(5), x3 = v4(9), C = v4(57)(false), A2 = v4(25)("IE_PROTO");
        u.exports = function(D, P) {
          var N, j = x3(D), W = 0, K = [];
          for (N in j)
            N != A2 && m3(j, N) && K.push(N);
          for (; P.length > W; )
            m3(j, N = P[W++]) && (~C(K, N) || K.push(N));
          return K;
        };
      }, function(u, h, v4) {
        var m3 = v4(24);
        u.exports = Object("z").propertyIsEnumerable(0) ? Object : function(x3) {
          return m3(x3) == "String" ? x3.split("") : Object(x3);
        };
      }, function(u, h, v4) {
        var m3 = v4(39), x3 = v4(27).concat("length", "prototype");
        h.f = Object.getOwnPropertyNames || function(C) {
          return m3(C, x3);
        };
      }, function(u, h, v4) {
        var m3 = v4(24), x3 = v4(2)("toStringTag"), C = m3(function() {
          return arguments;
        }()) == "Arguments";
        u.exports = function(A2) {
          var D, P, N;
          return A2 === void 0 ? "Undefined" : A2 === null ? "Null" : typeof (P = function(j, W) {
            try {
              return j[W];
            } catch {
            }
          }(D = Object(A2), x3)) == "string" ? P : C ? m3(D) : (N = m3(D)) == "Object" && typeof D.callee == "function" ? "Arguments" : N;
        };
      }, function(u, h) {
        var v4;
        v4 = function() {
          return this;
        }();
        try {
          v4 = v4 || new Function("return this")();
        } catch {
          typeof window == "object" && (v4 = window);
        }
        u.exports = v4;
      }, function(u, h) {
        var v4 = /-?\d+(\.\d+)?%?/g;
        u.exports = function(m3) {
          return m3.match(v4);
        };
      }, function(u, h, v4) {
        Object.defineProperty(h, "__esModule", { value: true }), h.getBase16Theme = h.createStyling = h.invertTheme = void 0;
        var m3 = te(v4(49)), x3 = te(v4(76)), C = te(v4(81)), A2 = te(v4(89)), D = te(v4(93)), P = function(qe) {
          if (qe && qe.__esModule)
            return qe;
          var Ze = {};
          if (qe != null)
            for (var ct in qe)
              Object.prototype.hasOwnProperty.call(qe, ct) && (Ze[ct] = qe[ct]);
          return Ze.default = qe, Ze;
        }(v4(94)), N = te(v4(132)), j = te(v4(133)), W = te(v4(138)), K = v4(139);
        function te(qe) {
          return qe && qe.__esModule ? qe : { default: qe };
        }
        var ne = P.default, ce = (0, A2.default)(ne), me = (0, W.default)(j.default, K.rgb2yuv, function(qe) {
          var Ze, ct = (0, C.default)(qe, 3), _t = ct[0], pt = ct[1], zt = ct[2];
          return [(Ze = _t, Ze < 0.25 ? 1 : Ze < 0.5 ? 0.9 - Ze : 1.1 - Ze), pt, zt];
        }, K.yuv2rgb, N.default), ve = function(qe) {
          return function(Ze) {
            return { className: [Ze.className, qe.className].filter(Boolean).join(" "), style: (0, x3.default)({}, Ze.style || {}, qe.style || {}) };
          };
        }, Be = function(qe, Ze) {
          var ct = (0, A2.default)(Ze);
          for (var _t in qe)
            ct.indexOf(_t) === -1 && ct.push(_t);
          return ct.reduce(function(pt, zt) {
            return pt[zt] = function(Zt, Ft) {
              if (Zt === void 0)
                return Ft;
              if (Ft === void 0)
                return Zt;
              var Kn = Zt === void 0 ? "undefined" : (0, m3.default)(Zt), hn = Ft === void 0 ? "undefined" : (0, m3.default)(Ft);
              switch (Kn) {
                case "string":
                  switch (hn) {
                    case "string":
                      return [Ft, Zt].filter(Boolean).join(" ");
                    case "object":
                      return ve({ className: Zt, style: Ft });
                    case "function":
                      return function(xn) {
                        for (var zn = arguments.length, or = Array(zn > 1 ? zn - 1 : 0), vr = 1; vr < zn; vr++)
                          or[vr - 1] = arguments[vr];
                        return ve({ className: Zt })(Ft.apply(void 0, [xn].concat(or)));
                      };
                  }
                case "object":
                  switch (hn) {
                    case "string":
                      return ve({ className: Ft, style: Zt });
                    case "object":
                      return (0, x3.default)({}, Ft, Zt);
                    case "function":
                      return function(xn) {
                        for (var zn = arguments.length, or = Array(zn > 1 ? zn - 1 : 0), vr = 1; vr < zn; vr++)
                          or[vr - 1] = arguments[vr];
                        return ve({ style: Zt })(Ft.apply(void 0, [xn].concat(or)));
                      };
                  }
                case "function":
                  switch (hn) {
                    case "string":
                      return function(xn) {
                        for (var zn = arguments.length, or = Array(zn > 1 ? zn - 1 : 0), vr = 1; vr < zn; vr++)
                          or[vr - 1] = arguments[vr];
                        return Zt.apply(void 0, [ve(xn)({ className: Ft })].concat(or));
                      };
                    case "object":
                      return function(xn) {
                        for (var zn = arguments.length, or = Array(zn > 1 ? zn - 1 : 0), vr = 1; vr < zn; vr++)
                          or[vr - 1] = arguments[vr];
                        return Zt.apply(void 0, [ve(xn)({ style: Ft })].concat(or));
                      };
                    case "function":
                      return function(xn) {
                        for (var zn = arguments.length, or = Array(zn > 1 ? zn - 1 : 0), vr = 1; vr < zn; vr++)
                          or[vr - 1] = arguments[vr];
                        return Zt.apply(void 0, [Ft.apply(void 0, [xn].concat(or))].concat(or));
                      };
                  }
              }
            }(qe[zt], Ze[zt]), pt;
          }, {});
        }, Oe = function(qe, Ze) {
          for (var ct = arguments.length, _t = Array(ct > 2 ? ct - 2 : 0), pt = 2; pt < ct; pt++)
            _t[pt - 2] = arguments[pt];
          if (Ze === null)
            return qe;
          Array.isArray(Ze) || (Ze = [Ze]);
          var zt = Ze.map(function(Ft) {
            return qe[Ft];
          }).filter(Boolean), Zt = zt.reduce(function(Ft, Kn) {
            return typeof Kn == "string" ? Ft.className = [Ft.className, Kn].filter(Boolean).join(" ") : (Kn === void 0 ? "undefined" : (0, m3.default)(Kn)) === "object" ? Ft.style = (0, x3.default)({}, Ft.style, Kn) : typeof Kn == "function" && (Ft = (0, x3.default)({}, Ft, Kn.apply(void 0, [Ft].concat(_t)))), Ft;
          }, { className: "", style: {} });
          return Zt.className || delete Zt.className, (0, A2.default)(Zt.style).length === 0 && delete Zt.style, Zt;
        }, We = h.invertTheme = function(qe) {
          return (0, A2.default)(qe).reduce(function(Ze, ct) {
            return Ze[ct] = /^base/.test(ct) ? me(qe[ct]) : ct === "scheme" ? qe[ct] + ":inverted" : qe[ct], Ze;
          }, {});
        }, Ue = (h.createStyling = (0, D.default)(function(qe) {
          for (var Ze = arguments.length, ct = Array(Ze > 3 ? Ze - 3 : 0), _t = 3; _t < Ze; _t++)
            ct[_t - 3] = arguments[_t];
          var pt = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, zt = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Zt = pt.defaultBase16, Ft = Zt === void 0 ? ne : Zt, Kn = pt.base16Themes, hn = Kn === void 0 ? null : Kn, xn = Ue(zt, hn);
          xn && (zt = (0, x3.default)({}, xn, zt));
          var zn = ce.reduce(function(Ba, Lo) {
            return Ba[Lo] = zt[Lo] || Ft[Lo], Ba;
          }, {}), or = (0, A2.default)(zt).reduce(function(Ba, Lo) {
            return ce.indexOf(Lo) === -1 && (Ba[Lo] = zt[Lo]), Ba;
          }, {}), vr = qe(zn), la = Be(or, vr);
          return (0, D.default)(Oe, 2).apply(void 0, [la].concat(ct));
        }, 3), h.getBase16Theme = function(qe, Ze) {
          if (qe && qe.extend && (qe = qe.extend), typeof qe == "string") {
            var ct = qe.split(":"), _t = (0, C.default)(ct, 2), pt = _t[0], zt = _t[1];
            qe = (Ze || {})[pt] || P[pt], zt === "inverted" && (qe = We(qe));
          }
          return qe && qe.hasOwnProperty("base00") ? qe : void 0;
        });
      }, function(u, h, v4) {
        var m3, x3 = typeof Reflect == "object" ? Reflect : null, C = x3 && typeof x3.apply == "function" ? x3.apply : function(ve, Be, Oe) {
          return Function.prototype.apply.call(ve, Be, Oe);
        };
        m3 = x3 && typeof x3.ownKeys == "function" ? x3.ownKeys : Object.getOwnPropertySymbols ? function(ve) {
          return Object.getOwnPropertyNames(ve).concat(Object.getOwnPropertySymbols(ve));
        } : function(ve) {
          return Object.getOwnPropertyNames(ve);
        };
        var A2 = Number.isNaN || function(ve) {
          return ve != ve;
        };
        function D() {
          D.init.call(this);
        }
        u.exports = D, u.exports.once = function(ve, Be) {
          return new Promise(function(Oe, We) {
            function Ue() {
              qe !== void 0 && ve.removeListener("error", qe), Oe([].slice.call(arguments));
            }
            var qe;
            Be !== "error" && (qe = function(Ze) {
              ve.removeListener(Be, Ue), We(Ze);
            }, ve.once("error", qe)), ve.once(Be, Ue);
          });
        }, D.EventEmitter = D, D.prototype._events = void 0, D.prototype._eventsCount = 0, D.prototype._maxListeners = void 0;
        var P = 10;
        function N(ve) {
          if (typeof ve != "function")
            throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof ve);
        }
        function j(ve) {
          return ve._maxListeners === void 0 ? D.defaultMaxListeners : ve._maxListeners;
        }
        function W(ve, Be, Oe, We) {
          var Ue, qe, Ze, ct;
          if (N(Oe), (qe = ve._events) === void 0 ? (qe = ve._events = /* @__PURE__ */ Object.create(null), ve._eventsCount = 0) : (qe.newListener !== void 0 && (ve.emit("newListener", Be, Oe.listener ? Oe.listener : Oe), qe = ve._events), Ze = qe[Be]), Ze === void 0)
            Ze = qe[Be] = Oe, ++ve._eventsCount;
          else if (typeof Ze == "function" ? Ze = qe[Be] = We ? [Oe, Ze] : [Ze, Oe] : We ? Ze.unshift(Oe) : Ze.push(Oe), (Ue = j(ve)) > 0 && Ze.length > Ue && !Ze.warned) {
            Ze.warned = true;
            var _t = new Error("Possible EventEmitter memory leak detected. " + Ze.length + " " + String(Be) + " listeners added. Use emitter.setMaxListeners() to increase limit");
            _t.name = "MaxListenersExceededWarning", _t.emitter = ve, _t.type = Be, _t.count = Ze.length, ct = _t, console && console.warn && console.warn(ct);
          }
          return ve;
        }
        function K() {
          if (!this.fired)
            return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
        }
        function te(ve, Be, Oe) {
          var We = { fired: false, wrapFn: void 0, target: ve, type: Be, listener: Oe }, Ue = K.bind(We);
          return Ue.listener = Oe, We.wrapFn = Ue, Ue;
        }
        function ne(ve, Be, Oe) {
          var We = ve._events;
          if (We === void 0)
            return [];
          var Ue = We[Be];
          return Ue === void 0 ? [] : typeof Ue == "function" ? Oe ? [Ue.listener || Ue] : [Ue] : Oe ? function(qe) {
            for (var Ze = new Array(qe.length), ct = 0; ct < Ze.length; ++ct)
              Ze[ct] = qe[ct].listener || qe[ct];
            return Ze;
          }(Ue) : me(Ue, Ue.length);
        }
        function ce(ve) {
          var Be = this._events;
          if (Be !== void 0) {
            var Oe = Be[ve];
            if (typeof Oe == "function")
              return 1;
            if (Oe !== void 0)
              return Oe.length;
          }
          return 0;
        }
        function me(ve, Be) {
          for (var Oe = new Array(Be), We = 0; We < Be; ++We)
            Oe[We] = ve[We];
          return Oe;
        }
        Object.defineProperty(D, "defaultMaxListeners", { enumerable: true, get: function() {
          return P;
        }, set: function(ve) {
          if (typeof ve != "number" || ve < 0 || A2(ve))
            throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + ve + ".");
          P = ve;
        } }), D.init = function() {
          this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
        }, D.prototype.setMaxListeners = function(ve) {
          if (typeof ve != "number" || ve < 0 || A2(ve))
            throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + ve + ".");
          return this._maxListeners = ve, this;
        }, D.prototype.getMaxListeners = function() {
          return j(this);
        }, D.prototype.emit = function(ve) {
          for (var Be = [], Oe = 1; Oe < arguments.length; Oe++)
            Be.push(arguments[Oe]);
          var We = ve === "error", Ue = this._events;
          if (Ue !== void 0)
            We = We && Ue.error === void 0;
          else if (!We)
            return false;
          if (We) {
            var qe;
            if (Be.length > 0 && (qe = Be[0]), qe instanceof Error)
              throw qe;
            var Ze = new Error("Unhandled error." + (qe ? " (" + qe.message + ")" : ""));
            throw Ze.context = qe, Ze;
          }
          var ct = Ue[ve];
          if (ct === void 0)
            return false;
          if (typeof ct == "function")
            C(ct, this, Be);
          else {
            var _t = ct.length, pt = me(ct, _t);
            for (Oe = 0; Oe < _t; ++Oe)
              C(pt[Oe], this, Be);
          }
          return true;
        }, D.prototype.addListener = function(ve, Be) {
          return W(this, ve, Be, false);
        }, D.prototype.on = D.prototype.addListener, D.prototype.prependListener = function(ve, Be) {
          return W(this, ve, Be, true);
        }, D.prototype.once = function(ve, Be) {
          return N(Be), this.on(ve, te(this, ve, Be)), this;
        }, D.prototype.prependOnceListener = function(ve, Be) {
          return N(Be), this.prependListener(ve, te(this, ve, Be)), this;
        }, D.prototype.removeListener = function(ve, Be) {
          var Oe, We, Ue, qe, Ze;
          if (N(Be), (We = this._events) === void 0)
            return this;
          if ((Oe = We[ve]) === void 0)
            return this;
          if (Oe === Be || Oe.listener === Be)
            --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete We[ve], We.removeListener && this.emit("removeListener", ve, Oe.listener || Be));
          else if (typeof Oe != "function") {
            for (Ue = -1, qe = Oe.length - 1; qe >= 0; qe--)
              if (Oe[qe] === Be || Oe[qe].listener === Be) {
                Ze = Oe[qe].listener, Ue = qe;
                break;
              }
            if (Ue < 0)
              return this;
            Ue === 0 ? Oe.shift() : function(ct, _t) {
              for (; _t + 1 < ct.length; _t++)
                ct[_t] = ct[_t + 1];
              ct.pop();
            }(Oe, Ue), Oe.length === 1 && (We[ve] = Oe[0]), We.removeListener !== void 0 && this.emit("removeListener", ve, Ze || Be);
          }
          return this;
        }, D.prototype.off = D.prototype.removeListener, D.prototype.removeAllListeners = function(ve) {
          var Be, Oe, We;
          if ((Oe = this._events) === void 0)
            return this;
          if (Oe.removeListener === void 0)
            return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : Oe[ve] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete Oe[ve]), this;
          if (arguments.length === 0) {
            var Ue, qe = Object.keys(Oe);
            for (We = 0; We < qe.length; ++We)
              (Ue = qe[We]) !== "removeListener" && this.removeAllListeners(Ue);
            return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
          }
          if (typeof (Be = Oe[ve]) == "function")
            this.removeListener(ve, Be);
          else if (Be !== void 0)
            for (We = Be.length - 1; We >= 0; We--)
              this.removeListener(ve, Be[We]);
          return this;
        }, D.prototype.listeners = function(ve) {
          return ne(this, ve, true);
        }, D.prototype.rawListeners = function(ve) {
          return ne(this, ve, false);
        }, D.listenerCount = function(ve, Be) {
          return typeof ve.listenerCount == "function" ? ve.listenerCount(Be) : ce.call(ve, Be);
        }, D.prototype.listenerCount = ce, D.prototype.eventNames = function() {
          return this._eventsCount > 0 ? m3(this._events) : [];
        };
      }, function(u, h, v4) {
        u.exports.Dispatcher = v4(140);
      }, function(u, h, v4) {
        u.exports = v4(142);
      }, function(u, h, v4) {
        h.__esModule = true;
        var m3 = A2(v4(50)), x3 = A2(v4(65)), C = typeof x3.default == "function" && typeof m3.default == "symbol" ? function(D) {
          return typeof D;
        } : function(D) {
          return D && typeof x3.default == "function" && D.constructor === x3.default && D !== x3.default.prototype ? "symbol" : typeof D;
        };
        function A2(D) {
          return D && D.__esModule ? D : { default: D };
        }
        h.default = typeof x3.default == "function" && C(m3.default) === "symbol" ? function(D) {
          return D === void 0 ? "undefined" : C(D);
        } : function(D) {
          return D && typeof x3.default == "function" && D.constructor === x3.default && D !== x3.default.prototype ? "symbol" : D === void 0 ? "undefined" : C(D);
        };
      }, function(u, h, v4) {
        u.exports = { default: v4(51), __esModule: true };
      }, function(u, h, v4) {
        v4(20), v4(29), u.exports = v4(30).f("iterator");
      }, function(u, h, v4) {
        var m3 = v4(21), x3 = v4(22);
        u.exports = function(C) {
          return function(A2, D) {
            var P, N, j = String(x3(A2)), W = m3(D), K = j.length;
            return W < 0 || W >= K ? C ? "" : void 0 : (P = j.charCodeAt(W)) < 55296 || P > 56319 || W + 1 === K || (N = j.charCodeAt(W + 1)) < 56320 || N > 57343 ? C ? j.charAt(W) : P : C ? j.slice(W, W + 2) : N - 56320 + (P - 55296 << 10) + 65536;
          };
        };
      }, function(u, h, v4) {
        var m3 = v4(54);
        u.exports = function(x3, C, A2) {
          if (m3(x3), C === void 0)
            return x3;
          switch (A2) {
            case 1:
              return function(D) {
                return x3.call(C, D);
              };
            case 2:
              return function(D, P) {
                return x3.call(C, D, P);
              };
            case 3:
              return function(D, P, N) {
                return x3.call(C, D, P, N);
              };
          }
          return function() {
            return x3.apply(C, arguments);
          };
        };
      }, function(u, h) {
        u.exports = function(v4) {
          if (typeof v4 != "function")
            throw TypeError(v4 + " is not a function!");
          return v4;
        };
      }, function(u, h, v4) {
        var m3 = v4(38), x3 = v4(16), C = v4(28), A2 = {};
        v4(6)(A2, v4(2)("iterator"), function() {
          return this;
        }), u.exports = function(D, P, N) {
          D.prototype = m3(A2, { next: x3(1, N) }), C(D, P + " Iterator");
        };
      }, function(u, h, v4) {
        var m3 = v4(7), x3 = v4(10), C = v4(13);
        u.exports = v4(4) ? Object.defineProperties : function(A2, D) {
          x3(A2);
          for (var P, N = C(D), j = N.length, W = 0; j > W; )
            m3.f(A2, P = N[W++], D[P]);
          return A2;
        };
      }, function(u, h, v4) {
        var m3 = v4(9), x3 = v4(58), C = v4(59);
        u.exports = function(A2) {
          return function(D, P, N) {
            var j, W = m3(D), K = x3(W.length), te = C(N, K);
            if (A2 && P != P) {
              for (; K > te; )
                if ((j = W[te++]) != j)
                  return true;
            } else
              for (; K > te; te++)
                if ((A2 || te in W) && W[te] === P)
                  return A2 || te || 0;
            return !A2 && -1;
          };
        };
      }, function(u, h, v4) {
        var m3 = v4(21), x3 = Math.min;
        u.exports = function(C) {
          return C > 0 ? x3(m3(C), 9007199254740991) : 0;
        };
      }, function(u, h, v4) {
        var m3 = v4(21), x3 = Math.max, C = Math.min;
        u.exports = function(A2, D) {
          return (A2 = m3(A2)) < 0 ? x3(A2 + D, 0) : C(A2, D);
        };
      }, function(u, h, v4) {
        var m3 = v4(3).document;
        u.exports = m3 && m3.documentElement;
      }, function(u, h, v4) {
        var m3 = v4(5), x3 = v4(18), C = v4(25)("IE_PROTO"), A2 = Object.prototype;
        u.exports = Object.getPrototypeOf || function(D) {
          return D = x3(D), m3(D, C) ? D[C] : typeof D.constructor == "function" && D instanceof D.constructor ? D.constructor.prototype : D instanceof Object ? A2 : null;
        };
      }, function(u, h, v4) {
        var m3 = v4(63), x3 = v4(64), C = v4(12), A2 = v4(9);
        u.exports = v4(34)(Array, "Array", function(D, P) {
          this._t = A2(D), this._i = 0, this._k = P;
        }, function() {
          var D = this._t, P = this._k, N = this._i++;
          return !D || N >= D.length ? (this._t = void 0, x3(1)) : x3(0, P == "keys" ? N : P == "values" ? D[N] : [N, D[N]]);
        }, "values"), C.Arguments = C.Array, m3("keys"), m3("values"), m3("entries");
      }, function(u, h) {
        u.exports = function() {
        };
      }, function(u, h) {
        u.exports = function(v4, m3) {
          return { value: m3, done: !!v4 };
        };
      }, function(u, h, v4) {
        u.exports = { default: v4(66), __esModule: true };
      }, function(u, h, v4) {
        v4(67), v4(73), v4(74), v4(75), u.exports = v4(1).Symbol;
      }, function(u, h, v4) {
        var m3 = v4(3), x3 = v4(5), C = v4(4), A2 = v4(15), D = v4(37), P = v4(68).KEY, N = v4(8), j = v4(26), W = v4(28), K = v4(17), te = v4(2), ne = v4(30), ce = v4(31), me = v4(69), ve = v4(70), Be = v4(10), Oe = v4(11), We = v4(18), Ue = v4(9), qe = v4(23), Ze = v4(16), ct = v4(38), _t = v4(71), pt = v4(72), zt = v4(32), Zt = v4(7), Ft = v4(13), Kn = pt.f, hn = Zt.f, xn = _t.f, zn = m3.Symbol, or = m3.JSON, vr = or && or.stringify, la = te("_hidden"), Ba = te("toPrimitive"), Lo = {}.propertyIsEnumerable, Ao = j("symbol-registry"), oo = j("symbols"), Pa = j("op-symbols"), fo = Object.prototype, Co = typeof zn == "function" && !!zt.f, $a = m3.QObject, Yo = !$a || !$a.prototype || !$a.prototype.findChild, Qu = C && N(function() {
          return ct(hn({}, "a", { get: function() {
            return hn(this, "a", { value: 7 }).a;
          } })).a != 7;
        }) ? function(Ur, Zi, uo) {
          var us = Kn(fo, Zi);
          us && delete fo[Zi], hn(Ur, Zi, uo), us && Ur !== fo && hn(fo, Zi, us);
        } : hn, ds = function(Ur) {
          var Zi = oo[Ur] = ct(zn.prototype);
          return Zi._k = Ur, Zi;
        }, Lu = Co && typeof zn.iterator == "symbol" ? function(Ur) {
          return typeof Ur == "symbol";
        } : function(Ur) {
          return Ur instanceof zn;
        }, dc = function(Ur, Zi, uo) {
          return Ur === fo && dc(Pa, Zi, uo), Be(Ur), Zi = qe(Zi, true), Be(uo), x3(oo, Zi) ? (uo.enumerable ? (x3(Ur, la) && Ur[la][Zi] && (Ur[la][Zi] = false), uo = ct(uo, { enumerable: Ze(0, false) })) : (x3(Ur, la) || hn(Ur, la, Ze(1, {})), Ur[la][Zi] = true), Qu(Ur, Zi, uo)) : hn(Ur, Zi, uo);
        }, Kc = function(Ur, Zi) {
          Be(Ur);
          for (var uo, us = me(Zi = Ue(Zi)), Jl = 0, Ql = us.length; Ql > Jl; )
            dc(Ur, uo = us[Jl++], Zi[uo]);
          return Ur;
        }, sv = function(Ur) {
          var Zi = Lo.call(this, Ur = qe(Ur, true));
          return !(this === fo && x3(oo, Ur) && !x3(Pa, Ur)) && (!(Zi || !x3(this, Ur) || !x3(oo, Ur) || x3(this, la) && this[la][Ur]) || Zi);
        }, Hf = function(Ur, Zi) {
          if (Ur = Ue(Ur), Zi = qe(Zi, true), Ur !== fo || !x3(oo, Zi) || x3(Pa, Zi)) {
            var uo = Kn(Ur, Zi);
            return !uo || !x3(oo, Zi) || x3(Ur, la) && Ur[la][Zi] || (uo.enumerable = true), uo;
          }
        }, vg = function(Ur) {
          for (var Zi, uo = xn(Ue(Ur)), us = [], Jl = 0; uo.length > Jl; )
            x3(oo, Zi = uo[Jl++]) || Zi == la || Zi == P || us.push(Zi);
          return us;
        }, Ef = function(Ur) {
          for (var Zi, uo = Ur === fo, us = xn(uo ? Pa : Ue(Ur)), Jl = [], Ql = 0; us.length > Ql; )
            !x3(oo, Zi = us[Ql++]) || uo && !x3(fo, Zi) || Jl.push(oo[Zi]);
          return Jl;
        };
        Co || (D((zn = function() {
          if (this instanceof zn)
            throw TypeError("Symbol is not a constructor!");
          var Ur = K(arguments.length > 0 ? arguments[0] : void 0), Zi = function(uo) {
            this === fo && Zi.call(Pa, uo), x3(this, la) && x3(this[la], Ur) && (this[la][Ur] = false), Qu(this, Ur, Ze(1, uo));
          };
          return C && Yo && Qu(fo, Ur, { configurable: true, set: Zi }), ds(Ur);
        }).prototype, "toString", function() {
          return this._k;
        }), pt.f = Hf, Zt.f = dc, v4(41).f = _t.f = vg, v4(19).f = sv, zt.f = Ef, C && !v4(14) && D(fo, "propertyIsEnumerable", sv, true), ne.f = function(Ur) {
          return ds(te(Ur));
        }), A2(A2.G + A2.W + A2.F * !Co, { Symbol: zn });
        for (var md = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), Gh = 0; md.length > Gh; )
          te(md[Gh++]);
        for (var nw = Ft(te.store), Ki = 0; nw.length > Ki; )
          ce(nw[Ki++]);
        A2(A2.S + A2.F * !Co, "Symbol", { for: function(Ur) {
          return x3(Ao, Ur += "") ? Ao[Ur] : Ao[Ur] = zn(Ur);
        }, keyFor: function(Ur) {
          if (!Lu(Ur))
            throw TypeError(Ur + " is not a symbol!");
          for (var Zi in Ao)
            if (Ao[Zi] === Ur)
              return Zi;
        }, useSetter: function() {
          Yo = true;
        }, useSimple: function() {
          Yo = false;
        } }), A2(A2.S + A2.F * !Co, "Object", { create: function(Ur, Zi) {
          return Zi === void 0 ? ct(Ur) : Kc(ct(Ur), Zi);
        }, defineProperty: dc, defineProperties: Kc, getOwnPropertyDescriptor: Hf, getOwnPropertyNames: vg, getOwnPropertySymbols: Ef });
        var Zr = N(function() {
          zt.f(1);
        });
        A2(A2.S + A2.F * Zr, "Object", { getOwnPropertySymbols: function(Ur) {
          return zt.f(We(Ur));
        } }), or && A2(A2.S + A2.F * (!Co || N(function() {
          var Ur = zn();
          return vr([Ur]) != "[null]" || vr({ a: Ur }) != "{}" || vr(Object(Ur)) != "{}";
        })), "JSON", { stringify: function(Ur) {
          for (var Zi, uo, us = [Ur], Jl = 1; arguments.length > Jl; )
            us.push(arguments[Jl++]);
          if (uo = Zi = us[1], (Oe(Zi) || Ur !== void 0) && !Lu(Ur))
            return ve(Zi) || (Zi = function(Ql, sf) {
              if (typeof uo == "function" && (sf = uo.call(this, Ql, sf)), !Lu(sf))
                return sf;
            }), us[1] = Zi, vr.apply(or, us);
        } }), zn.prototype[Ba] || v4(6)(zn.prototype, Ba, zn.prototype.valueOf), W(zn, "Symbol"), W(Math, "Math", true), W(m3.JSON, "JSON", true);
      }, function(u, h, v4) {
        var m3 = v4(17)("meta"), x3 = v4(11), C = v4(5), A2 = v4(7).f, D = 0, P = Object.isExtensible || function() {
          return true;
        }, N = !v4(8)(function() {
          return P(Object.preventExtensions({}));
        }), j = function(K) {
          A2(K, m3, { value: { i: "O" + ++D, w: {} } });
        }, W = u.exports = { KEY: m3, NEED: false, fastKey: function(K, te) {
          if (!x3(K))
            return typeof K == "symbol" ? K : (typeof K == "string" ? "S" : "P") + K;
          if (!C(K, m3)) {
            if (!P(K))
              return "F";
            if (!te)
              return "E";
            j(K);
          }
          return K[m3].i;
        }, getWeak: function(K, te) {
          if (!C(K, m3)) {
            if (!P(K))
              return true;
            if (!te)
              return false;
            j(K);
          }
          return K[m3].w;
        }, onFreeze: function(K) {
          return N && W.NEED && P(K) && !C(K, m3) && j(K), K;
        } };
      }, function(u, h, v4) {
        var m3 = v4(13), x3 = v4(32), C = v4(19);
        u.exports = function(A2) {
          var D = m3(A2), P = x3.f;
          if (P)
            for (var N, j = P(A2), W = C.f, K = 0; j.length > K; )
              W.call(A2, N = j[K++]) && D.push(N);
          return D;
        };
      }, function(u, h, v4) {
        var m3 = v4(24);
        u.exports = Array.isArray || function(x3) {
          return m3(x3) == "Array";
        };
      }, function(u, h, v4) {
        var m3 = v4(9), x3 = v4(41).f, C = {}.toString, A2 = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
        u.exports.f = function(D) {
          return A2 && C.call(D) == "[object Window]" ? function(P) {
            try {
              return x3(P);
            } catch {
              return A2.slice();
            }
          }(D) : x3(m3(D));
        };
      }, function(u, h, v4) {
        var m3 = v4(19), x3 = v4(16), C = v4(9), A2 = v4(23), D = v4(5), P = v4(35), N = Object.getOwnPropertyDescriptor;
        h.f = v4(4) ? N : function(j, W) {
          if (j = C(j), W = A2(W, true), P)
            try {
              return N(j, W);
            } catch {
            }
          if (D(j, W))
            return x3(!m3.f.call(j, W), j[W]);
        };
      }, function(u, h) {
      }, function(u, h, v4) {
        v4(31)("asyncIterator");
      }, function(u, h, v4) {
        v4(31)("observable");
      }, function(u, h, v4) {
        h.__esModule = true;
        var m3, x3 = v4(77), C = (m3 = x3) && m3.__esModule ? m3 : { default: m3 };
        h.default = C.default || function(A2) {
          for (var D = 1; D < arguments.length; D++) {
            var P = arguments[D];
            for (var N in P)
              Object.prototype.hasOwnProperty.call(P, N) && (A2[N] = P[N]);
          }
          return A2;
        };
      }, function(u, h, v4) {
        u.exports = { default: v4(78), __esModule: true };
      }, function(u, h, v4) {
        v4(79), u.exports = v4(1).Object.assign;
      }, function(u, h, v4) {
        var m3 = v4(15);
        m3(m3.S + m3.F, "Object", { assign: v4(80) });
      }, function(u, h, v4) {
        var m3 = v4(4), x3 = v4(13), C = v4(32), A2 = v4(19), D = v4(18), P = v4(40), N = Object.assign;
        u.exports = !N || v4(8)(function() {
          var j = {}, W = {}, K = Symbol(), te = "abcdefghijklmnopqrst";
          return j[K] = 7, te.split("").forEach(function(ne) {
            W[ne] = ne;
          }), N({}, j)[K] != 7 || Object.keys(N({}, W)).join("") != te;
        }) ? function(j, W) {
          for (var K = D(j), te = arguments.length, ne = 1, ce = C.f, me = A2.f; te > ne; )
            for (var ve, Be = P(arguments[ne++]), Oe = ce ? x3(Be).concat(ce(Be)) : x3(Be), We = Oe.length, Ue = 0; We > Ue; )
              ve = Oe[Ue++], m3 && !me.call(Be, ve) || (K[ve] = Be[ve]);
          return K;
        } : N;
      }, function(u, h, v4) {
        h.__esModule = true;
        var m3 = C(v4(82)), x3 = C(v4(85));
        function C(A2) {
          return A2 && A2.__esModule ? A2 : { default: A2 };
        }
        h.default = function(A2, D) {
          if (Array.isArray(A2))
            return A2;
          if ((0, m3.default)(Object(A2)))
            return function(P, N) {
              var j = [], W = true, K = false, te = void 0;
              try {
                for (var ne, ce = (0, x3.default)(P); !(W = (ne = ce.next()).done) && (j.push(ne.value), !N || j.length !== N); W = true)
                  ;
              } catch (me) {
                K = true, te = me;
              } finally {
                try {
                  !W && ce.return && ce.return();
                } finally {
                  if (K)
                    throw te;
                }
              }
              return j;
            }(A2, D);
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        };
      }, function(u, h, v4) {
        u.exports = { default: v4(83), __esModule: true };
      }, function(u, h, v4) {
        v4(29), v4(20), u.exports = v4(84);
      }, function(u, h, v4) {
        var m3 = v4(42), x3 = v4(2)("iterator"), C = v4(12);
        u.exports = v4(1).isIterable = function(A2) {
          var D = Object(A2);
          return D[x3] !== void 0 || "@@iterator" in D || C.hasOwnProperty(m3(D));
        };
      }, function(u, h, v4) {
        u.exports = { default: v4(86), __esModule: true };
      }, function(u, h, v4) {
        v4(29), v4(20), u.exports = v4(87);
      }, function(u, h, v4) {
        var m3 = v4(10), x3 = v4(88);
        u.exports = v4(1).getIterator = function(C) {
          var A2 = x3(C);
          if (typeof A2 != "function")
            throw TypeError(C + " is not iterable!");
          return m3(A2.call(C));
        };
      }, function(u, h, v4) {
        var m3 = v4(42), x3 = v4(2)("iterator"), C = v4(12);
        u.exports = v4(1).getIteratorMethod = function(A2) {
          if (A2 != null)
            return A2[x3] || A2["@@iterator"] || C[m3(A2)];
        };
      }, function(u, h, v4) {
        u.exports = { default: v4(90), __esModule: true };
      }, function(u, h, v4) {
        v4(91), u.exports = v4(1).Object.keys;
      }, function(u, h, v4) {
        var m3 = v4(18), x3 = v4(13);
        v4(92)("keys", function() {
          return function(C) {
            return x3(m3(C));
          };
        });
      }, function(u, h, v4) {
        var m3 = v4(15), x3 = v4(1), C = v4(8);
        u.exports = function(A2, D) {
          var P = (x3.Object || {})[A2] || Object[A2], N = {};
          N[A2] = D(P), m3(m3.S + m3.F * C(function() {
            P(1);
          }), "Object", N);
        };
      }, function(u, h, v4) {
        (function(m3) {
          var x3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], C = /^\s+|\s+$/g, A2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, D = /\{\n\/\* \[wrapped with (.+)\] \*/, P = /,? & /, N = /^[-+]0x[0-9a-f]+$/i, j = /^0b[01]+$/i, W = /^\[object .+?Constructor\]$/, K = /^0o[0-7]+$/i, te = /^(?:0|[1-9]\d*)$/, ne = parseInt, ce = typeof m3 == "object" && m3 && m3.Object === Object && m3, me = typeof self == "object" && self && self.Object === Object && self, ve = ce || me || Function("return this")();
          function Be(Ki, Zr, Ur) {
            switch (Ur.length) {
              case 0:
                return Ki.call(Zr);
              case 1:
                return Ki.call(Zr, Ur[0]);
              case 2:
                return Ki.call(Zr, Ur[0], Ur[1]);
              case 3:
                return Ki.call(Zr, Ur[0], Ur[1], Ur[2]);
            }
            return Ki.apply(Zr, Ur);
          }
          function Oe(Ki, Zr) {
            return !!(Ki && Ki.length) && function(Ur, Zi, uo) {
              if (Zi != Zi)
                return function(Ql, sf, ep, hh) {
                  for (var bd = Ql.length, ph = ep + (hh ? 1 : -1); hh ? ph-- : ++ph < bd; )
                    if (sf(Ql[ph], ph, Ql))
                      return ph;
                  return -1;
                }(Ur, We, uo);
              for (var us = uo - 1, Jl = Ur.length; ++us < Jl; )
                if (Ur[us] === Zi)
                  return us;
              return -1;
            }(Ki, Zr, 0) > -1;
          }
          function We(Ki) {
            return Ki != Ki;
          }
          function Ue(Ki, Zr) {
            for (var Ur = Ki.length, Zi = 0; Ur--; )
              Ki[Ur] === Zr && Zi++;
            return Zi;
          }
          function qe(Ki, Zr) {
            for (var Ur = -1, Zi = Ki.length, uo = 0, us = []; ++Ur < Zi; ) {
              var Jl = Ki[Ur];
              Jl !== Zr && Jl !== "__lodash_placeholder__" || (Ki[Ur] = "__lodash_placeholder__", us[uo++] = Ur);
            }
            return us;
          }
          var Ze, ct, _t, pt = Function.prototype, zt = Object.prototype, Zt = ve["__core-js_shared__"], Ft = (Ze = /[^.]+$/.exec(Zt && Zt.keys && Zt.keys.IE_PROTO || "")) ? "Symbol(src)_1." + Ze : "", Kn = pt.toString, hn = zt.hasOwnProperty, xn = zt.toString, zn = RegExp("^" + Kn.call(hn).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), or = Object.create, vr = Math.max, la = Math.min, Ba = (ct = ds(Object, "defineProperty"), (_t = ds.name) && _t.length > 2 ? ct : void 0);
          function Lo(Ki) {
            return md(Ki) ? or(Ki) : {};
          }
          function Ao(Ki) {
            return !(!md(Ki) || function(Zr) {
              return !!Ft && Ft in Zr;
            }(Ki)) && (function(Zr) {
              var Ur = md(Zr) ? xn.call(Zr) : "";
              return Ur == "[object Function]" || Ur == "[object GeneratorFunction]";
            }(Ki) || function(Zr) {
              var Ur = false;
              if (Zr != null && typeof Zr.toString != "function")
                try {
                  Ur = !!(Zr + "");
                } catch {
                }
              return Ur;
            }(Ki) ? zn : W).test(function(Zr) {
              if (Zr != null) {
                try {
                  return Kn.call(Zr);
                } catch {
                }
                try {
                  return Zr + "";
                } catch {
                }
              }
              return "";
            }(Ki));
          }
          function oo(Ki, Zr, Ur, Zi) {
            for (var uo = -1, us = Ki.length, Jl = Ur.length, Ql = -1, sf = Zr.length, ep = vr(us - Jl, 0), hh = Array(sf + ep), bd = !Zi; ++Ql < sf; )
              hh[Ql] = Zr[Ql];
            for (; ++uo < Jl; )
              (bd || uo < us) && (hh[Ur[uo]] = Ki[uo]);
            for (; ep--; )
              hh[Ql++] = Ki[uo++];
            return hh;
          }
          function Pa(Ki, Zr, Ur, Zi) {
            for (var uo = -1, us = Ki.length, Jl = -1, Ql = Ur.length, sf = -1, ep = Zr.length, hh = vr(us - Ql, 0), bd = Array(hh + ep), ph = !Zi; ++uo < hh; )
              bd[uo] = Ki[uo];
            for (var l0 = uo; ++sf < ep; )
              bd[l0 + sf] = Zr[sf];
            for (; ++Jl < Ql; )
              (ph || uo < us) && (bd[l0 + Ur[Jl]] = Ki[uo++]);
            return bd;
          }
          function fo(Ki) {
            return function() {
              var Zr = arguments;
              switch (Zr.length) {
                case 0:
                  return new Ki();
                case 1:
                  return new Ki(Zr[0]);
                case 2:
                  return new Ki(Zr[0], Zr[1]);
                case 3:
                  return new Ki(Zr[0], Zr[1], Zr[2]);
                case 4:
                  return new Ki(Zr[0], Zr[1], Zr[2], Zr[3]);
                case 5:
                  return new Ki(Zr[0], Zr[1], Zr[2], Zr[3], Zr[4]);
                case 6:
                  return new Ki(Zr[0], Zr[1], Zr[2], Zr[3], Zr[4], Zr[5]);
                case 7:
                  return new Ki(Zr[0], Zr[1], Zr[2], Zr[3], Zr[4], Zr[5], Zr[6]);
              }
              var Ur = Lo(Ki.prototype), Zi = Ki.apply(Ur, Zr);
              return md(Zi) ? Zi : Ur;
            };
          }
          function Co(Ki, Zr, Ur, Zi, uo, us, Jl, Ql, sf, ep) {
            var hh = 128 & Zr, bd = 1 & Zr, ph = 2 & Zr, l0 = 24 & Zr, iy = 512 & Zr, _b2 = ph ? void 0 : fo(Ki);
            return function ay() {
              for (var Vp = arguments.length, vc = Array(Vp), Hd = Vp; Hd--; )
                vc[Hd] = arguments[Hd];
              if (l0)
                var gg = Qu(ay), xb = Ue(vc, gg);
              if (Zi && (vc = oo(vc, Zi, uo, l0)), us && (vc = Pa(vc, us, Jl, l0)), Vp -= xb, l0 && Vp < ep) {
                var um = qe(vc, gg);
                return $a(Ki, Zr, Co, ay.placeholder, Ur, vc, um, Ql, sf, ep - Vp);
              }
              var oy = bd ? Ur : this, x1 = ph ? oy[Ki] : Ki;
              return Vp = vc.length, Ql ? vc = sv(vc, Ql) : iy && Vp > 1 && vc.reverse(), hh && sf < Vp && (vc.length = sf), this && this !== ve && this instanceof ay && (x1 = _b2 || fo(x1)), x1.apply(oy, vc);
            };
          }
          function $a(Ki, Zr, Ur, Zi, uo, us, Jl, Ql, sf, ep) {
            var hh = 8 & Zr;
            Zr |= hh ? 32 : 64, 4 & (Zr &= ~(hh ? 64 : 32)) || (Zr &= -4);
            var bd = Ur(Ki, Zr, uo, hh ? us : void 0, hh ? Jl : void 0, hh ? void 0 : us, hh ? void 0 : Jl, Ql, sf, ep);
            return bd.placeholder = Zi, Hf(bd, Ki, Zr);
          }
          function Yo(Ki, Zr, Ur, Zi, uo, us, Jl, Ql) {
            var sf = 2 & Zr;
            if (!sf && typeof Ki != "function")
              throw new TypeError("Expected a function");
            var ep = Zi ? Zi.length : 0;
            if (ep || (Zr &= -97, Zi = uo = void 0), Jl = Jl === void 0 ? Jl : vr(nw(Jl), 0), Ql = Ql === void 0 ? Ql : nw(Ql), ep -= uo ? uo.length : 0, 64 & Zr) {
              var hh = Zi, bd = uo;
              Zi = uo = void 0;
            }
            var ph = [Ki, Zr, Ur, Zi, uo, hh, bd, us, Jl, Ql];
            if (Ki = ph[0], Zr = ph[1], Ur = ph[2], Zi = ph[3], uo = ph[4], !(Ql = ph[9] = ph[9] == null ? sf ? 0 : Ki.length : vr(ph[9] - ep, 0)) && 24 & Zr && (Zr &= -25), Zr && Zr != 1)
              l0 = Zr == 8 || Zr == 16 ? function(iy, _b2, ay) {
                var Vp = fo(iy);
                return function vc() {
                  for (var Hd = arguments.length, gg = Array(Hd), xb = Hd, um = Qu(vc); xb--; )
                    gg[xb] = arguments[xb];
                  var oy = Hd < 3 && gg[0] !== um && gg[Hd - 1] !== um ? [] : qe(gg, um);
                  if ((Hd -= oy.length) < ay)
                    return $a(iy, _b2, Co, vc.placeholder, void 0, gg, oy, void 0, void 0, ay - Hd);
                  var x1 = this && this !== ve && this instanceof vc ? Vp : iy;
                  return Be(x1, this, gg);
                };
              }(Ki, Zr, Ql) : Zr != 32 && Zr != 33 || uo.length ? Co.apply(void 0, ph) : function(iy, _b2, ay, Vp) {
                var vc = 1 & _b2, Hd = fo(iy);
                return function gg() {
                  for (var xb = -1, um = arguments.length, oy = -1, x1 = Vp.length, _M = Array(x1 + um), M2 = this && this !== ve && this instanceof gg ? Hd : iy; ++oy < x1; )
                    _M[oy] = Vp[oy];
                  for (; um--; )
                    _M[oy++] = arguments[++xb];
                  return Be(M2, vc ? ay : this, _M);
                };
              }(Ki, Zr, Ur, Zi);
            else
              var l0 = function(iy, _b2, ay) {
                var Vp = 1 & _b2, vc = fo(iy);
                return function Hd() {
                  var gg = this && this !== ve && this instanceof Hd ? vc : iy;
                  return gg.apply(Vp ? ay : this, arguments);
                };
              }(Ki, Zr, Ur);
            return Hf(l0, Ki, Zr);
          }
          function Qu(Ki) {
            return Ki.placeholder;
          }
          function ds(Ki, Zr) {
            var Ur = function(Zi, uo) {
              return Zi == null ? void 0 : Zi[uo];
            }(Ki, Zr);
            return Ao(Ur) ? Ur : void 0;
          }
          function Lu(Ki) {
            var Zr = Ki.match(D);
            return Zr ? Zr[1].split(P) : [];
          }
          function dc(Ki, Zr) {
            var Ur = Zr.length, Zi = Ur - 1;
            return Zr[Zi] = (Ur > 1 ? "& " : "") + Zr[Zi], Zr = Zr.join(Ur > 2 ? ", " : " "), Ki.replace(A2, `{
/* [wrapped with ` + Zr + `] */
`);
          }
          function Kc(Ki, Zr) {
            return !!(Zr = Zr == null ? 9007199254740991 : Zr) && (typeof Ki == "number" || te.test(Ki)) && Ki > -1 && Ki % 1 == 0 && Ki < Zr;
          }
          function sv(Ki, Zr) {
            for (var Ur = Ki.length, Zi = la(Zr.length, Ur), uo = function(Jl, Ql) {
              var sf = -1, ep = Jl.length;
              for (Ql || (Ql = Array(ep)); ++sf < ep; )
                Ql[sf] = Jl[sf];
              return Ql;
            }(Ki); Zi--; ) {
              var us = Zr[Zi];
              Ki[Zi] = Kc(us, Ur) ? uo[us] : void 0;
            }
            return Ki;
          }
          var Hf = Ba ? function(Ki, Zr, Ur) {
            var Zi, uo = Zr + "";
            return Ba(Ki, "toString", { configurable: true, enumerable: false, value: (Zi = dc(uo, vg(Lu(uo), Ur)), function() {
              return Zi;
            }) });
          } : function(Ki) {
            return Ki;
          };
          function vg(Ki, Zr) {
            return function(Ur, Zi) {
              for (var uo = -1, us = Ur ? Ur.length : 0; ++uo < us && Zi(Ur[uo], uo, Ur) !== false; )
                ;
            }(x3, function(Ur) {
              var Zi = "_." + Ur[0];
              Zr & Ur[1] && !Oe(Ki, Zi) && Ki.push(Zi);
            }), Ki.sort();
          }
          function Ef(Ki, Zr, Ur) {
            var Zi = Yo(Ki, 8, void 0, void 0, void 0, void 0, void 0, Zr = Ur ? void 0 : Zr);
            return Zi.placeholder = Ef.placeholder, Zi;
          }
          function md(Ki) {
            var Zr = typeof Ki;
            return !!Ki && (Zr == "object" || Zr == "function");
          }
          function Gh(Ki) {
            return Ki ? (Ki = function(Zr) {
              if (typeof Zr == "number")
                return Zr;
              if (function(uo) {
                return typeof uo == "symbol" || function(us) {
                  return !!us && typeof us == "object";
                }(uo) && xn.call(uo) == "[object Symbol]";
              }(Zr))
                return NaN;
              if (md(Zr)) {
                var Ur = typeof Zr.valueOf == "function" ? Zr.valueOf() : Zr;
                Zr = md(Ur) ? Ur + "" : Ur;
              }
              if (typeof Zr != "string")
                return Zr === 0 ? Zr : +Zr;
              Zr = Zr.replace(C, "");
              var Zi = j.test(Zr);
              return Zi || K.test(Zr) ? ne(Zr.slice(2), Zi ? 2 : 8) : N.test(Zr) ? NaN : +Zr;
            }(Ki)) === 1 / 0 || Ki === -1 / 0 ? 17976931348623157e292 * (Ki < 0 ? -1 : 1) : Ki == Ki ? Ki : 0 : Ki === 0 ? Ki : 0;
          }
          function nw(Ki) {
            var Zr = Gh(Ki), Ur = Zr % 1;
            return Zr == Zr ? Ur ? Zr - Ur : Zr : 0;
          }
          Ef.placeholder = {}, u.exports = Ef;
        }).call(this, v4(43));
      }, function(u, h, v4) {
        function m3(Pa) {
          return Pa && Pa.__esModule ? Pa.default : Pa;
        }
        h.__esModule = true;
        var x3 = v4(95);
        h.threezerotwofour = m3(x3);
        var C = v4(96);
        h.apathy = m3(C);
        var A2 = v4(97);
        h.ashes = m3(A2);
        var D = v4(98);
        h.atelierDune = m3(D);
        var P = v4(99);
        h.atelierForest = m3(P);
        var N = v4(100);
        h.atelierHeath = m3(N);
        var j = v4(101);
        h.atelierLakeside = m3(j);
        var W = v4(102);
        h.atelierSeaside = m3(W);
        var K = v4(103);
        h.bespin = m3(K);
        var te = v4(104);
        h.brewer = m3(te);
        var ne = v4(105);
        h.bright = m3(ne);
        var ce = v4(106);
        h.chalk = m3(ce);
        var me = v4(107);
        h.codeschool = m3(me);
        var ve = v4(108);
        h.colors = m3(ve);
        var Be = v4(109);
        h.default = m3(Be);
        var Oe = v4(110);
        h.eighties = m3(Oe);
        var We = v4(111);
        h.embers = m3(We);
        var Ue = v4(112);
        h.flat = m3(Ue);
        var qe = v4(113);
        h.google = m3(qe);
        var Ze = v4(114);
        h.grayscale = m3(Ze);
        var ct = v4(115);
        h.greenscreen = m3(ct);
        var _t = v4(116);
        h.harmonic = m3(_t);
        var pt = v4(117);
        h.hopscotch = m3(pt);
        var zt = v4(118);
        h.isotope = m3(zt);
        var Zt = v4(119);
        h.marrakesh = m3(Zt);
        var Ft = v4(120);
        h.mocha = m3(Ft);
        var Kn = v4(121);
        h.monokai = m3(Kn);
        var hn = v4(122);
        h.ocean = m3(hn);
        var xn = v4(123);
        h.paraiso = m3(xn);
        var zn = v4(124);
        h.pop = m3(zn);
        var or = v4(125);
        h.railscasts = m3(or);
        var vr = v4(126);
        h.shapeshifter = m3(vr);
        var la = v4(127);
        h.solarized = m3(la);
        var Ba = v4(128);
        h.summerfruit = m3(Ba);
        var Lo = v4(129);
        h.tomorrow = m3(Lo);
        var Ao = v4(130);
        h.tube = m3(Ao);
        var oo = v4(131);
        h.twilight = m3(oo);
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, u.exports = h.default;
      }, function(u, h, v4) {
        h.__esModule = true, h.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, u.exports = h.default;
      }, function(u, h, v4) {
        var m3 = v4(33);
        function x3(C) {
          var A2 = Math.round(m3(C, 0, 255)).toString(16);
          return A2.length == 1 ? "0" + A2 : A2;
        }
        u.exports = function(C) {
          var A2 = C.length === 4 ? x3(255 * C[3]) : "";
          return "#" + x3(C[0]) + x3(C[1]) + x3(C[2]) + A2;
        };
      }, function(u, h, v4) {
        var m3 = v4(134), x3 = v4(135), C = v4(136), A2 = v4(137), D = { "#": x3, hsl: function(N) {
          var j = m3(N), W = A2(j);
          return j.length === 4 && W.push(j[3]), W;
        }, rgb: C };
        function P(N) {
          for (var j in D)
            if (N.indexOf(j) === 0)
              return D[j](N);
        }
        P.rgb = C, P.hsl = m3, P.hex = x3, u.exports = P;
      }, function(u, h, v4) {
        var m3 = v4(44), x3 = v4(33);
        function C(A2, D) {
          switch (A2 = parseFloat(A2), D) {
            case 0:
              return x3(A2, 0, 360);
            case 1:
            case 2:
              return x3(A2, 0, 100);
            case 3:
              return x3(A2, 0, 1);
          }
        }
        u.exports = function(A2) {
          return m3(A2).map(C);
        };
      }, function(u, h) {
        u.exports = function(v4) {
          v4.length !== 4 && v4.length !== 5 || (v4 = function(C) {
            for (var A2 = "#", D = 1; D < C.length; D++) {
              var P = C.charAt(D);
              A2 += P + P;
            }
            return A2;
          }(v4));
          var m3 = [parseInt(v4.substring(1, 3), 16), parseInt(v4.substring(3, 5), 16), parseInt(v4.substring(5, 7), 16)];
          if (v4.length === 9) {
            var x3 = parseFloat((parseInt(v4.substring(7, 9), 16) / 255).toFixed(2));
            m3.push(x3);
          }
          return m3;
        };
      }, function(u, h, v4) {
        var m3 = v4(44), x3 = v4(33);
        function C(A2, D) {
          return D < 3 ? A2.indexOf("%") != -1 ? Math.round(255 * x3(parseInt(A2, 10), 0, 100) / 100) : x3(parseInt(A2, 10), 0, 255) : x3(parseFloat(A2), 0, 1);
        }
        u.exports = function(A2) {
          return m3(A2).map(C);
        };
      }, function(u, h) {
        u.exports = function(v4) {
          var m3, x3, C, A2, D, P = v4[0] / 360, N = v4[1] / 100, j = v4[2] / 100;
          if (N == 0)
            return [D = 255 * j, D, D];
          m3 = 2 * j - (x3 = j < 0.5 ? j * (1 + N) : j + N - j * N), A2 = [0, 0, 0];
          for (var W = 0; W < 3; W++)
            (C = P + 1 / 3 * -(W - 1)) < 0 && C++, C > 1 && C--, D = 6 * C < 1 ? m3 + 6 * (x3 - m3) * C : 2 * C < 1 ? x3 : 3 * C < 2 ? m3 + (x3 - m3) * (2 / 3 - C) * 6 : m3, A2[W] = 255 * D;
          return A2;
        };
      }, function(u, h, v4) {
        (function(m3) {
          var x3 = typeof m3 == "object" && m3 && m3.Object === Object && m3, C = typeof self == "object" && self && self.Object === Object && self, A2 = x3 || C || Function("return this")();
          function D(qe, Ze, ct) {
            switch (ct.length) {
              case 0:
                return qe.call(Ze);
              case 1:
                return qe.call(Ze, ct[0]);
              case 2:
                return qe.call(Ze, ct[0], ct[1]);
              case 3:
                return qe.call(Ze, ct[0], ct[1], ct[2]);
            }
            return qe.apply(Ze, ct);
          }
          function P(qe, Ze) {
            for (var ct = -1, _t = Ze.length, pt = qe.length; ++ct < _t; )
              qe[pt + ct] = Ze[ct];
            return qe;
          }
          var N = Object.prototype, j = N.hasOwnProperty, W = N.toString, K = A2.Symbol, te = N.propertyIsEnumerable, ne = K ? K.isConcatSpreadable : void 0, ce = Math.max;
          function me(qe) {
            return ve(qe) || function(Ze) {
              return function(ct) {
                return function(_t) {
                  return !!_t && typeof _t == "object";
                }(ct) && function(_t) {
                  return _t != null && function(pt) {
                    return typeof pt == "number" && pt > -1 && pt % 1 == 0 && pt <= 9007199254740991;
                  }(_t.length) && !function(pt) {
                    var zt = function(Zt) {
                      var Ft = typeof Zt;
                      return !!Zt && (Ft == "object" || Ft == "function");
                    }(pt) ? W.call(pt) : "";
                    return zt == "[object Function]" || zt == "[object GeneratorFunction]";
                  }(_t);
                }(ct);
              }(Ze) && j.call(Ze, "callee") && (!te.call(Ze, "callee") || W.call(Ze) == "[object Arguments]");
            }(qe) || !!(ne && qe && qe[ne]);
          }
          var ve = Array.isArray, Be, Oe, We, Ue = (Oe = function(qe) {
            var Ze = (qe = function _t(pt, zt, Zt, Ft, Kn) {
              var hn = -1, xn = pt.length;
              for (Zt || (Zt = me), Kn || (Kn = []); ++hn < xn; ) {
                var zn = pt[hn];
                zt > 0 && Zt(zn) ? zt > 1 ? _t(zn, zt - 1, Zt, Ft, Kn) : P(Kn, zn) : Ft || (Kn[Kn.length] = zn);
              }
              return Kn;
            }(qe, 1)).length, ct = Ze;
            for (Be; ct--; )
              if (typeof qe[ct] != "function")
                throw new TypeError("Expected a function");
            return function() {
              for (var _t = 0, pt = Ze ? qe[_t].apply(this, arguments) : arguments[0]; ++_t < Ze; )
                pt = qe[_t].call(this, pt);
              return pt;
            };
          }, We = ce(We === void 0 ? Oe.length - 1 : We, 0), function() {
            for (var qe = arguments, Ze = -1, ct = ce(qe.length - We, 0), _t = Array(ct); ++Ze < ct; )
              _t[Ze] = qe[We + Ze];
            Ze = -1;
            for (var pt = Array(We + 1); ++Ze < We; )
              pt[Ze] = qe[Ze];
            return pt[We] = _t, D(Oe, this, pt);
          });
          u.exports = Ue;
        }).call(this, v4(43));
      }, function(u, h, v4) {
        Object.defineProperty(h, "__esModule", { value: true }), h.yuv2rgb = function(m3) {
          var x3, C, A2, D = m3[0], P = m3[1], N = m3[2];
          return x3 = 1 * D + 0 * P + 1.13983 * N, C = 1 * D + -0.39465 * P + -0.5806 * N, A2 = 1 * D + 2.02311 * P + 0 * N, x3 = Math.min(Math.max(0, x3), 1), C = Math.min(Math.max(0, C), 1), A2 = Math.min(Math.max(0, A2), 1), [255 * x3, 255 * C, 255 * A2];
        }, h.rgb2yuv = function(m3) {
          var x3 = m3[0] / 255, C = m3[1] / 255, A2 = m3[2] / 255;
          return [0.299 * x3 + 0.587 * C + 0.114 * A2, -0.14713 * x3 + -0.28886 * C + 0.436 * A2, 0.615 * x3 + -0.51499 * C + -0.10001 * A2];
        };
      }, function(u, h, v4) {
        function m3(A2, D, P) {
          return D in A2 ? Object.defineProperty(A2, D, { value: P, enumerable: true, configurable: true, writable: true }) : A2[D] = P, A2;
        }
        var x3 = v4(141), C = function() {
          function A2() {
            m3(this, "_callbacks", void 0), m3(this, "_isDispatching", void 0), m3(this, "_isHandled", void 0), m3(this, "_isPending", void 0), m3(this, "_lastID", void 0), m3(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
          }
          var D = A2.prototype;
          return D.register = function(P) {
            var N = "ID_" + this._lastID++;
            return this._callbacks[N] = P, N;
          }, D.unregister = function(P) {
            this._callbacks[P] || x3(false), delete this._callbacks[P];
          }, D.waitFor = function(P) {
            this._isDispatching || x3(false);
            for (var N = 0; N < P.length; N++) {
              var j = P[N];
              this._isPending[j] ? this._isHandled[j] || x3(false) : (this._callbacks[j] || x3(false), this._invokeCallback(j));
            }
          }, D.dispatch = function(P) {
            this._isDispatching && x3(false), this._startDispatching(P);
            try {
              for (var N in this._callbacks)
                this._isPending[N] || this._invokeCallback(N);
            } finally {
              this._stopDispatching();
            }
          }, D.isDispatching = function() {
            return this._isDispatching;
          }, D._invokeCallback = function(P) {
            this._isPending[P] = true, this._callbacks[P](this._pendingPayload), this._isHandled[P] = true;
          }, D._startDispatching = function(P) {
            for (var N in this._callbacks)
              this._isPending[N] = false, this._isHandled[N] = false;
            this._pendingPayload = P, this._isDispatching = true;
          }, D._stopDispatching = function() {
            delete this._pendingPayload, this._isDispatching = false;
          }, A2;
        }();
        u.exports = C;
      }, function(u, h, v4) {
        u.exports = function(m3, x3) {
          for (var C = arguments.length, A2 = new Array(C > 2 ? C - 2 : 0), D = 2; D < C; D++)
            A2[D - 2] = arguments[D];
          if (!m3) {
            var P;
            if (x3 === void 0)
              P = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
            else {
              var N = 0;
              (P = new Error(x3.replace(/%s/g, function() {
                return String(A2[N++]);
              }))).name = "Invariant Violation";
            }
            throw P.framesToPop = 1, P;
          }
        };
      }, function(u, h, v4) {
        function m3(An, Rn, $t) {
          return Rn in An ? Object.defineProperty(An, Rn, { value: $t, enumerable: true, configurable: true, writable: true }) : An[Rn] = $t, An;
        }
        function x3(An, Rn) {
          var $t = Object.keys(An);
          if (Object.getOwnPropertySymbols) {
            var bn = Object.getOwnPropertySymbols(An);
            Rn && (bn = bn.filter(function(Mn) {
              return Object.getOwnPropertyDescriptor(An, Mn).enumerable;
            })), $t.push.apply($t, bn);
          }
          return $t;
        }
        function C(An) {
          for (var Rn = 1; Rn < arguments.length; Rn++) {
            var $t = arguments[Rn] != null ? arguments[Rn] : {};
            Rn % 2 ? x3(Object($t), true).forEach(function(bn) {
              m3(An, bn, $t[bn]);
            }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(An, Object.getOwnPropertyDescriptors($t)) : x3(Object($t)).forEach(function(bn) {
              Object.defineProperty(An, bn, Object.getOwnPropertyDescriptor($t, bn));
            });
          }
          return An;
        }
        function A2(An, Rn) {
          if (!(An instanceof Rn))
            throw new TypeError("Cannot call a class as a function");
        }
        function D(An, Rn) {
          for (var $t = 0; $t < Rn.length; $t++) {
            var bn = Rn[$t];
            bn.enumerable = bn.enumerable || false, bn.configurable = true, "value" in bn && (bn.writable = true), Object.defineProperty(An, bn.key, bn);
          }
        }
        function P(An, Rn, $t) {
          return Rn && D(An.prototype, Rn), $t && D(An, $t), An;
        }
        function N(An, Rn) {
          return (N = Object.setPrototypeOf || function($t, bn) {
            return $t.__proto__ = bn, $t;
          })(An, Rn);
        }
        function j(An, Rn) {
          if (typeof Rn != "function" && Rn !== null)
            throw new TypeError("Super expression must either be null or a function");
          An.prototype = Object.create(Rn && Rn.prototype, { constructor: { value: An, writable: true, configurable: true } }), Rn && N(An, Rn);
        }
        function W(An) {
          return (W = Object.setPrototypeOf ? Object.getPrototypeOf : function(Rn) {
            return Rn.__proto__ || Object.getPrototypeOf(Rn);
          })(An);
        }
        function K(An) {
          return (K = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(Rn) {
            return typeof Rn;
          } : function(Rn) {
            return Rn && typeof Symbol == "function" && Rn.constructor === Symbol && Rn !== Symbol.prototype ? "symbol" : typeof Rn;
          })(An);
        }
        function te(An) {
          if (An === void 0)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return An;
        }
        function ne(An, Rn) {
          return !Rn || K(Rn) !== "object" && typeof Rn != "function" ? te(An) : Rn;
        }
        function ce(An) {
          var Rn = function() {
            if (typeof Reflect == "undefined" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }();
          return function() {
            var $t, bn = W(An);
            if (Rn) {
              var Mn = W(this).constructor;
              $t = Reflect.construct(bn, arguments, Mn);
            } else
              $t = bn.apply(this, arguments);
            return ne(this, $t);
          };
        }
        v4.r(h);
        var me = v4(0), ve = v4.n(me);
        function Be() {
          var An = this.constructor.getDerivedStateFromProps(this.props, this.state);
          An != null && this.setState(An);
        }
        function Oe(An) {
          this.setState(function(Rn) {
            var $t = this.constructor.getDerivedStateFromProps(An, Rn);
            return $t != null ? $t : null;
          }.bind(this));
        }
        function We(An, Rn) {
          try {
            var $t = this.props, bn = this.state;
            this.props = An, this.state = Rn, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate($t, bn);
          } finally {
            this.props = $t, this.state = bn;
          }
        }
        function Ue(An) {
          var Rn = An.prototype;
          if (!Rn || !Rn.isReactComponent)
            throw new Error("Can only polyfill class components");
          if (typeof An.getDerivedStateFromProps != "function" && typeof Rn.getSnapshotBeforeUpdate != "function")
            return An;
          var $t = null, bn = null, Mn = null;
          if (typeof Rn.componentWillMount == "function" ? $t = "componentWillMount" : typeof Rn.UNSAFE_componentWillMount == "function" && ($t = "UNSAFE_componentWillMount"), typeof Rn.componentWillReceiveProps == "function" ? bn = "componentWillReceiveProps" : typeof Rn.UNSAFE_componentWillReceiveProps == "function" && (bn = "UNSAFE_componentWillReceiveProps"), typeof Rn.componentWillUpdate == "function" ? Mn = "componentWillUpdate" : typeof Rn.UNSAFE_componentWillUpdate == "function" && (Mn = "UNSAFE_componentWillUpdate"), $t !== null || bn !== null || Mn !== null) {
            var jr = An.displayName || An.name, zi = typeof An.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
            throw Error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

` + jr + " uses " + zi + " but also contains the following legacy lifecycles:" + ($t !== null ? `
  ` + $t : "") + (bn !== null ? `
  ` + bn : "") + (Mn !== null ? `
  ` + Mn : "") + `

The above lifecycles should be removed. Learn more about this warning here:
https://fb.me/react-async-component-lifecycle-hooks`);
          }
          if (typeof An.getDerivedStateFromProps == "function" && (Rn.componentWillMount = Be, Rn.componentWillReceiveProps = Oe), typeof Rn.getSnapshotBeforeUpdate == "function") {
            if (typeof Rn.componentDidUpdate != "function")
              throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
            Rn.componentWillUpdate = We;
            var xi = Rn.componentDidUpdate;
            Rn.componentDidUpdate = function(Sr, cn, as) {
              var Eu = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : as;
              xi.call(this, Sr, cn, Eu);
            };
          }
          return An;
        }
        function qe(An, Rn) {
          if (An == null)
            return {};
          var $t, bn, Mn = function(zi, xi) {
            if (zi == null)
              return {};
            var Sr, cn, as = {}, Eu = Object.keys(zi);
            for (cn = 0; cn < Eu.length; cn++)
              Sr = Eu[cn], xi.indexOf(Sr) >= 0 || (as[Sr] = zi[Sr]);
            return as;
          }(An, Rn);
          if (Object.getOwnPropertySymbols) {
            var jr = Object.getOwnPropertySymbols(An);
            for (bn = 0; bn < jr.length; bn++)
              $t = jr[bn], Rn.indexOf($t) >= 0 || Object.prototype.propertyIsEnumerable.call(An, $t) && (Mn[$t] = An[$t]);
          }
          return Mn;
        }
        function Ze(An) {
          var Rn = function($t) {
            return {}.toString.call($t).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
          }(An);
          return Rn === "number" && (Rn = isNaN(An) ? "nan" : (0 | An) != An ? "float" : "integer"), Rn;
        }
        Be.__suppressDeprecationWarning = true, Oe.__suppressDeprecationWarning = true, We.__suppressDeprecationWarning = true;
        var ct = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, _t = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, pt = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, zt = v4(45), Zt = function(An) {
          var Rn = function($t) {
            return { backgroundColor: $t.base00, ellipsisColor: $t.base09, braceColor: $t.base07, expandedIcon: $t.base0D, collapsedIcon: $t.base0E, keyColor: $t.base07, arrayKeyColor: $t.base0C, objectSize: $t.base04, copyToClipboard: $t.base0F, copyToClipboardCheck: $t.base0D, objectBorder: $t.base02, dataTypes: { boolean: $t.base0E, date: $t.base0D, float: $t.base0B, function: $t.base0D, integer: $t.base0F, string: $t.base09, nan: $t.base08, null: $t.base0A, undefined: $t.base05, regexp: $t.base0A, background: $t.base02 }, editVariable: { editIcon: $t.base0E, cancelIcon: $t.base09, removeIcon: $t.base09, addIcon: $t.base0E, checkIcon: $t.base0E, background: $t.base01, color: $t.base0A, border: $t.base07 }, addKeyModal: { background: $t.base05, border: $t.base04, color: $t.base0A, labelColor: $t.base01 }, validationFailure: { background: $t.base09, iconColor: $t.base01, fontColor: $t.base01 } };
          }(An);
          return { "app-container": { fontFamily: pt.globalFontFamily, cursor: pt.globalCursor, backgroundColor: Rn.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: Rn.ellipsisColor, fontSize: pt.ellipsisFontSize, lineHeight: pt.ellipsisLineHeight, cursor: pt.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: pt.braceCursor, fontWeight: pt.braceFontWeight, color: Rn.braceColor }, "expanded-icon": { color: Rn.expandedIcon }, "collapsed-icon": { color: Rn.collapsedIcon }, colon: { display: "inline-block", margin: pt.keyMargin, color: Rn.keyColor, verticalAlign: "top" }, objectKeyVal: function($t, bn) {
            return { style: C({ paddingTop: pt.keyValPaddingTop, paddingRight: pt.keyValPaddingRight, paddingBottom: pt.keyValPaddingBottom, borderLeft: pt.keyValBorderLeft + " " + Rn.objectBorder, ":hover": { paddingLeft: bn.paddingLeft - 1 + "px", borderLeft: pt.keyValBorderHover + " " + Rn.objectBorder } }, bn) };
          }, "object-key-val-no-border": { padding: pt.keyValPadding }, "pushed-content": { marginLeft: pt.pushedContentMarginLeft }, variableValue: function($t, bn) {
            return { style: C({ display: "inline-block", paddingRight: pt.variableValuePaddingRight, position: "relative" }, bn) };
          }, "object-name": { display: "inline-block", color: Rn.keyColor, letterSpacing: pt.keyLetterSpacing, fontStyle: pt.keyFontStyle, verticalAlign: pt.keyVerticalAlign, opacity: pt.keyOpacity, ":hover": { opacity: pt.keyOpacityHover } }, "array-key": { display: "inline-block", color: Rn.arrayKeyColor, letterSpacing: pt.keyLetterSpacing, fontStyle: pt.keyFontStyle, verticalAlign: pt.keyVerticalAlign, opacity: pt.keyOpacity, ":hover": { opacity: pt.keyOpacityHover } }, "object-size": { color: Rn.objectSize, borderRadius: pt.objectSizeBorderRadius, fontStyle: pt.objectSizeFontStyle, margin: pt.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: pt.dataTypeFontSize, marginRight: pt.dataTypeMarginRight, opacity: pt.datatypeOpacity }, boolean: { display: "inline-block", color: Rn.dataTypes.boolean }, date: { display: "inline-block", color: Rn.dataTypes.date }, "date-value": { marginLeft: pt.dateValueMarginLeft }, float: { display: "inline-block", color: Rn.dataTypes.float }, function: { display: "inline-block", color: Rn.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: Rn.dataTypes.integer }, string: { display: "inline-block", color: Rn.dataTypes.string }, nan: { display: "inline-block", color: Rn.dataTypes.nan, fontSize: pt.nanFontSize, fontWeight: pt.nanFontWeight, backgroundColor: Rn.dataTypes.background, padding: pt.nanPadding, borderRadius: pt.nanBorderRadius }, null: { display: "inline-block", color: Rn.dataTypes.null, fontSize: pt.nullFontSize, fontWeight: pt.nullFontWeight, backgroundColor: Rn.dataTypes.background, padding: pt.nullPadding, borderRadius: pt.nullBorderRadius }, undefined: { display: "inline-block", color: Rn.dataTypes.undefined, fontSize: pt.undefinedFontSize, padding: pt.undefinedPadding, borderRadius: pt.undefinedBorderRadius, backgroundColor: Rn.dataTypes.background }, regexp: { display: "inline-block", color: Rn.dataTypes.regexp }, "copy-to-clipboard": { cursor: pt.clipboardCursor }, "copy-icon": { color: Rn.copyToClipboard, fontSize: pt.iconFontSize, marginRight: pt.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: Rn.copyToClipboardCheck, marginLeft: pt.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: pt.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: pt.metaDataPadding }, "icon-container": { display: "inline-block", width: pt.iconContainerWidth }, tooltip: { padding: pt.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: Rn.editVariable.removeIcon, cursor: pt.iconCursor, fontSize: pt.iconFontSize, marginRight: pt.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: Rn.editVariable.addIcon, cursor: pt.iconCursor, fontSize: pt.iconFontSize, marginRight: pt.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: Rn.editVariable.editIcon, cursor: pt.iconCursor, fontSize: pt.iconFontSize, marginRight: pt.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: pt.iconCursor, color: Rn.editVariable.checkIcon, fontSize: pt.iconFontSize, paddingRight: pt.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: pt.iconCursor, color: Rn.editVariable.cancelIcon, fontSize: pt.iconFontSize, paddingRight: pt.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: pt.editInputMinWidth, borderRadius: pt.editInputBorderRadius, backgroundColor: Rn.editVariable.background, color: Rn.editVariable.color, padding: pt.editInputPadding, marginRight: pt.editInputMarginRight, fontFamily: pt.editInputFontFamily }, "detected-row": { paddingTop: pt.detectedRowPaddingTop }, "key-modal-request": { position: pt.addKeyCoverPosition, top: pt.addKeyCoverPositionPx, left: pt.addKeyCoverPositionPx, right: pt.addKeyCoverPositionPx, bottom: pt.addKeyCoverPositionPx, backgroundColor: pt.addKeyCoverBackground }, "key-modal": { width: pt.addKeyModalWidth, backgroundColor: Rn.addKeyModal.background, marginLeft: pt.addKeyModalMargin, marginRight: pt.addKeyModalMargin, padding: pt.addKeyModalPadding, borderRadius: pt.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: Rn.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: Rn.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: Rn.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: Rn.addKeyModal.labelColor, fontSize: pt.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: Rn.editVariable.addIcon, fontSize: pt.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: Rn.ellipsisColor, fontSize: pt.ellipsisFontSize, lineHeight: pt.ellipsisLineHeight, cursor: pt.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: Rn.validationFailure.fontColor, backgroundColor: Rn.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: Rn.validationFailure.iconColor, fontSize: pt.iconFontSize, transform: "rotate(45deg)" } };
        };
        function Ft(An, Rn, $t) {
          return An || console.error("theme has not been set"), function(bn) {
            var Mn = ct;
            return bn !== false && bn !== "none" || (Mn = _t), Object(zt.createStyling)(Zt, { defaultBase16: Mn })(bn);
          }(An)(Rn, $t);
        }
        var Kn = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = (bn.rjvId, bn.type_name), jr = bn.displayDataTypes, zi = bn.theme;
            return jr ? ve.a.createElement("span", Object.assign({ className: "data-type-label" }, Ft(zi, "data-type-label")), Mn) : null;
          } }]), $t;
        }(ve.a.PureComponent), hn = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props;
            return ve.a.createElement("div", Ft(bn.theme, "boolean"), ve.a.createElement(Kn, Object.assign({ type_name: "bool" }, bn)), bn.value ? "true" : "false");
          } }]), $t;
        }(ve.a.PureComponent), xn = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props;
            return ve.a.createElement("div", Ft(bn.theme, "date"), ve.a.createElement(Kn, Object.assign({ type_name: "date" }, bn)), ve.a.createElement("span", Object.assign({ className: "date-value" }, Ft(bn.theme, "date-value")), bn.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
          } }]), $t;
        }(ve.a.PureComponent), zn = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props;
            return ve.a.createElement("div", Ft(bn.theme, "float"), ve.a.createElement(Kn, Object.assign({ type_name: "float" }, bn)), this.props.value);
          } }]), $t;
        }(ve.a.PureComponent);
        function or(An, Rn) {
          (Rn == null || Rn > An.length) && (Rn = An.length);
          for (var $t = 0, bn = new Array(Rn); $t < Rn; $t++)
            bn[$t] = An[$t];
          return bn;
        }
        function vr(An, Rn) {
          if (An) {
            if (typeof An == "string")
              return or(An, Rn);
            var $t = Object.prototype.toString.call(An).slice(8, -1);
            return $t === "Object" && An.constructor && ($t = An.constructor.name), $t === "Map" || $t === "Set" ? Array.from(An) : $t === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($t) ? or(An, Rn) : void 0;
          }
        }
        function la(An, Rn) {
          var $t;
          if (typeof Symbol == "undefined" || An[Symbol.iterator] == null) {
            if (Array.isArray(An) || ($t = vr(An)) || Rn && An && typeof An.length == "number") {
              $t && (An = $t);
              var bn = 0, Mn = function() {
              };
              return { s: Mn, n: function() {
                return bn >= An.length ? { done: true } : { done: false, value: An[bn++] };
              }, e: function(Sr) {
                throw Sr;
              }, f: Mn };
            }
            throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }
          var jr, zi = true, xi = false;
          return { s: function() {
            $t = An[Symbol.iterator]();
          }, n: function() {
            var Sr = $t.next();
            return zi = Sr.done, Sr;
          }, e: function(Sr) {
            xi = true, jr = Sr;
          }, f: function() {
            try {
              zi || $t.return == null || $t.return();
            } finally {
              if (xi)
                throw jr;
            }
          } };
        }
        function Ba(An) {
          return function(Rn) {
            if (Array.isArray(Rn))
              return or(Rn);
          }(An) || function(Rn) {
            if (typeof Symbol != "undefined" && Symbol.iterator in Object(Rn))
              return Array.from(Rn);
          }(An) || vr(An) || function() {
            throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
          }();
        }
        var Lo = v4(46), Ao = new (v4(47)).Dispatcher(), oo = new (function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            var bn;
            A2(this, $t);
            for (var Mn = arguments.length, jr = new Array(Mn), zi = 0; zi < Mn; zi++)
              jr[zi] = arguments[zi];
            return (bn = Rn.call.apply(Rn, [this].concat(jr))).objects = {}, bn.set = function(xi, Sr, cn, as) {
              bn.objects[xi] === void 0 && (bn.objects[xi] = {}), bn.objects[xi][Sr] === void 0 && (bn.objects[xi][Sr] = {}), bn.objects[xi][Sr][cn] = as;
            }, bn.get = function(xi, Sr, cn, as) {
              return bn.objects[xi] === void 0 || bn.objects[xi][Sr] === void 0 || bn.objects[xi][Sr][cn] == null ? as : bn.objects[xi][Sr][cn];
            }, bn.handleAction = function(xi) {
              var Sr = xi.rjvId, cn = xi.data;
              switch (xi.name) {
                case "RESET":
                  bn.emit("reset-" + Sr);
                  break;
                case "VARIABLE_UPDATED":
                  xi.data.updated_src = bn.updateSrc(Sr, cn), bn.set(Sr, "action", "variable-update", C(C({}, cn), {}, { type: "variable-edited" })), bn.emit("variable-update-" + Sr);
                  break;
                case "VARIABLE_REMOVED":
                  xi.data.updated_src = bn.updateSrc(Sr, cn), bn.set(Sr, "action", "variable-update", C(C({}, cn), {}, { type: "variable-removed" })), bn.emit("variable-update-" + Sr);
                  break;
                case "VARIABLE_ADDED":
                  xi.data.updated_src = bn.updateSrc(Sr, cn), bn.set(Sr, "action", "variable-update", C(C({}, cn), {}, { type: "variable-added" })), bn.emit("variable-update-" + Sr);
                  break;
                case "ADD_VARIABLE_KEY_REQUEST":
                  bn.set(Sr, "action", "new-key-request", cn), bn.emit("add-key-request-" + Sr);
              }
            }, bn.updateSrc = function(xi, Sr) {
              var cn = Sr.name, as = Sr.namespace, Eu = Sr.new_value, eu = (Sr.existing_value, Sr.variable_removed);
              as.shift();
              var Df, yo = bn.get(xi, "global", "src"), lf = bn.deepCopy(yo, Ba(as)), tp = lf, Vs = la(as);
              try {
                for (Vs.s(); !(Df = Vs.n()).done; )
                  tp = tp[Df.value];
              } catch (_d) {
                Vs.e(_d);
              } finally {
                Vs.f();
              }
              return eu ? Ze(tp) == "array" ? tp.splice(cn, 1) : delete tp[cn] : cn !== null ? tp[cn] = Eu : lf = Eu, bn.set(xi, "global", "src", lf), lf;
            }, bn.deepCopy = function(xi, Sr) {
              var cn, as = Ze(xi), Eu = Sr.shift();
              return as == "array" ? cn = Ba(xi) : as == "object" && (cn = C({}, xi)), Eu !== void 0 && (cn[Eu] = bn.deepCopy(xi[Eu], Sr)), cn;
            }, bn;
          }
          return $t;
        }(Lo.EventEmitter))();
        Ao.register(oo.handleAction.bind(oo));
        var Pa = oo, fo = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).toggleCollapsed = function() {
              Mn.setState({ collapsed: !Mn.state.collapsed }, function() {
                Pa.set(Mn.props.rjvId, Mn.props.namespace, "collapsed", Mn.state.collapsed);
              });
            }, Mn.getFunctionDisplay = function(jr) {
              var zi = te(Mn).props;
              return jr ? ve.a.createElement("span", null, Mn.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), ve.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, ve.a.createElement("span", null, "{"), ve.a.createElement("span", Ft(zi.theme, "ellipsis"), "..."), ve.a.createElement("span", null, "}"))) : Mn.props.value.toString().slice(9, -1);
            }, Mn.state = { collapsed: Pa.get(bn.rjvId, bn.namespace, "collapsed", true) }, Mn;
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = this.state.collapsed;
            return ve.a.createElement("div", Ft(bn.theme, "function"), ve.a.createElement(Kn, Object.assign({ type_name: "function" }, bn)), ve.a.createElement("span", Object.assign({}, Ft(bn.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(Mn)));
          } }]), $t;
        }(ve.a.PureComponent), Co = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            return ve.a.createElement("div", Ft(this.props.theme, "nan"), "NaN");
          } }]), $t;
        }(ve.a.PureComponent), $a = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            return ve.a.createElement("div", Ft(this.props.theme, "null"), "NULL");
          } }]), $t;
        }(ve.a.PureComponent), Yo = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props;
            return ve.a.createElement("div", Ft(bn.theme, "integer"), ve.a.createElement(Kn, Object.assign({ type_name: "int" }, bn)), this.props.value);
          } }]), $t;
        }(ve.a.PureComponent), Qu = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props;
            return ve.a.createElement("div", Ft(bn.theme, "regexp"), ve.a.createElement(Kn, Object.assign({ type_name: "regexp" }, bn)), this.props.value.toString());
          } }]), $t;
        }(ve.a.PureComponent), ds = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).toggleCollapsed = function() {
              Mn.setState({ collapsed: !Mn.state.collapsed }, function() {
                Pa.set(Mn.props.rjvId, Mn.props.namespace, "collapsed", Mn.state.collapsed);
              });
            }, Mn.state = { collapsed: Pa.get(bn.rjvId, bn.namespace, "collapsed", true) }, Mn;
          }
          return P($t, [{ key: "render", value: function() {
            this.state.collapsed;
            var bn = this.props, Mn = bn.collapseStringsAfterLength, jr = bn.theme, zi = bn.value, xi = { style: { cursor: "default" } };
            return Ze(Mn) === "integer" && zi.length > Mn && (xi.style.cursor = "pointer", this.state.collapsed && (zi = ve.a.createElement("span", null, zi.substring(0, Mn), ve.a.createElement("span", Ft(jr, "ellipsis"), " ...")))), ve.a.createElement("div", Ft(jr, "string"), ve.a.createElement(Kn, Object.assign({ type_name: "string" }, bn)), ve.a.createElement("span", Object.assign({ className: "string-value" }, xi, { onClick: this.toggleCollapsed }), '"', zi, '"'));
          } }]), $t;
        }(ve.a.PureComponent), Lu = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            return ve.a.createElement("div", Ft(this.props.theme, "undefined"), "undefined");
          } }]), $t;
        }(ve.a.PureComponent);
        function dc() {
          return (dc = Object.assign || function(An) {
            for (var Rn = 1; Rn < arguments.length; Rn++) {
              var $t = arguments[Rn];
              for (var bn in $t)
                Object.prototype.hasOwnProperty.call($t, bn) && (An[bn] = $t[bn]);
            }
            return An;
          }).apply(this, arguments);
        }
        var Kc = me.useLayoutEffect, sv = function(An) {
          var Rn = Object(me.useRef)(An);
          return Kc(function() {
            Rn.current = An;
          }), Rn;
        }, Hf = function(An, Rn) {
          typeof An != "function" ? An.current = Rn : An(Rn);
        }, vg = function(An, Rn) {
          var $t = Object(me.useRef)();
          return Object(me.useCallback)(function(bn) {
            An.current = bn, $t.current && Hf($t.current, null), $t.current = Rn, Rn && Hf(Rn, bn);
          }, [Rn]);
        }, Ef = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, md = function(An) {
          Object.keys(Ef).forEach(function(Rn) {
            An.style.setProperty(Rn, Ef[Rn], "important");
          });
        }, Gh = null, nw = function() {
        }, Ki = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], Zr = !!document.documentElement.currentStyle, Ur = function(An, Rn) {
          var $t = An.cacheMeasurements, bn = An.maxRows, Mn = An.minRows, jr = An.onChange, zi = jr === void 0 ? nw : jr, xi = An.onHeightChange, Sr = xi === void 0 ? nw : xi, cn = function(Vs, _d) {
            if (Vs == null)
              return {};
            var sy, T_, m5 = {}, A_ = Object.keys(Vs);
            for (T_ = 0; T_ < A_.length; T_++)
              sy = A_[T_], _d.indexOf(sy) >= 0 || (m5[sy] = Vs[sy]);
            return m5;
          }(An, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]), as, Eu = cn.value !== void 0, eu = Object(me.useRef)(null), Df = vg(eu, Rn), yo = Object(me.useRef)(0), lf = Object(me.useRef)(), tp = function() {
            var Vs = eu.current, _d = $t && lf.current ? lf.current : function(A_) {
              var cm = window.getComputedStyle(A_);
              if (cm === null)
                return null;
              var rw, Wd = (rw = cm, Ki.reduce(function(iw, A22) {
                return iw[A22] = rw[A22], iw;
              }, {})), ly = Wd.boxSizing;
              return ly === "" ? null : (Zr && ly === "border-box" && (Wd.width = parseFloat(Wd.width) + parseFloat(Wd.borderRightWidth) + parseFloat(Wd.borderLeftWidth) + parseFloat(Wd.paddingRight) + parseFloat(Wd.paddingLeft) + "px"), { sizingStyle: Wd, paddingSize: parseFloat(Wd.paddingBottom) + parseFloat(Wd.paddingTop), borderSize: parseFloat(Wd.borderBottomWidth) + parseFloat(Wd.borderTopWidth) });
            }(Vs);
            if (_d) {
              lf.current = _d;
              var sy = function(A_, cm, rw, Wd) {
                rw === void 0 && (rw = 1), Wd === void 0 && (Wd = 1 / 0), Gh || ((Gh = document.createElement("textarea")).setAttribute("tab-index", "-1"), Gh.setAttribute("aria-hidden", "true"), md(Gh)), Gh.parentNode === null && document.body.appendChild(Gh);
                var ly = A_.paddingSize, iw = A_.borderSize, A22 = A_.sizingStyle, JA = A22.boxSizing;
                Object.keys(A22).forEach(function(D2) {
                  var xM = D2;
                  Gh.style[xM] = A22[xM];
                }), md(Gh), Gh.value = cm;
                var I2 = function(D2, xM) {
                  var b5 = D2.scrollHeight;
                  return xM.sizingStyle.boxSizing === "border-box" ? b5 + xM.borderSize : b5 - xM.paddingSize;
                }(Gh, A_);
                Gh.value = "x";
                var cP = Gh.scrollHeight - ly, QA = cP * rw;
                JA === "border-box" && (QA = QA + ly + iw), I2 = Math.max(QA, I2);
                var E2 = cP * Wd;
                return JA === "border-box" && (E2 = E2 + ly + iw), [I2 = Math.min(E2, I2), cP];
              }(_d, Vs.value || Vs.placeholder || "x", Mn, bn), T_ = sy[0], m5 = sy[1];
              yo.current !== T_ && (yo.current = T_, Vs.style.setProperty("height", T_ + "px", "important"), Sr(T_, { rowHeight: m5 }));
            }
          };
          return Object(me.useLayoutEffect)(tp), as = sv(tp), Object(me.useLayoutEffect)(function() {
            var Vs = function(_d) {
              as.current(_d);
            };
            return window.addEventListener("resize", Vs), function() {
              window.removeEventListener("resize", Vs);
            };
          }, []), Object(me.createElement)("textarea", dc({}, cn, { onChange: function(Vs) {
            Eu || tp(), zi(Vs);
          }, ref: Df }));
        }, Zi = Object(me.forwardRef)(Ur);
        function uo(An) {
          An = An.trim();
          try {
            if ((An = JSON.stringify(JSON.parse(An)))[0] === "[")
              return us("array", JSON.parse(An));
            if (An[0] === "{")
              return us("object", JSON.parse(An));
            if (An.match(/\-?\d+\.\d+/) && An.match(/\-?\d+\.\d+/)[0] === An)
              return us("float", parseFloat(An));
            if (An.match(/\-?\d+e-\d+/) && An.match(/\-?\d+e-\d+/)[0] === An)
              return us("float", Number(An));
            if (An.match(/\-?\d+/) && An.match(/\-?\d+/)[0] === An)
              return us("integer", parseInt(An));
            if (An.match(/\-?\d+e\+\d+/) && An.match(/\-?\d+e\+\d+/)[0] === An)
              return us("integer", Number(An));
          } catch {
          }
          switch (An = An.toLowerCase()) {
            case "undefined":
              return us("undefined", void 0);
            case "nan":
              return us("nan", NaN);
            case "null":
              return us("null", null);
            case "true":
              return us("boolean", true);
            case "false":
              return us("boolean", false);
            default:
              if (An = Date.parse(An))
                return us("date", new Date(An));
          }
          return us(false, null);
        }
        function us(An, Rn) {
          return { type: An, value: Rn };
        }
        var Jl = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
          } }]), $t;
        }(ve.a.PureComponent), Ql = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
          } }]), $t;
        }(ve.a.PureComponent), sf = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]), zi = vc(Mn).style;
            return ve.a.createElement("span", jr, ve.a.createElement("svg", { fill: zi.color, width: zi.height, height: zi.width, style: zi, viewBox: "0 0 1792 1792" }, ve.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), $t;
        }(ve.a.PureComponent), ep = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]), zi = vc(Mn).style;
            return ve.a.createElement("span", jr, ve.a.createElement("svg", { fill: zi.color, width: zi.height, height: zi.width, style: zi, viewBox: "0 0 1792 1792" }, ve.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
          } }]), $t;
        }(ve.a.PureComponent), hh = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", { style: C(C({}, vc(Mn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, ve.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
          } }]), $t;
        }(ve.a.PureComponent), bd = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", { style: C(C({}, vc(Mn).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, ve.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
          } }]), $t;
        }(ve.a.PureComponent), ph = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("g", null, ve.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
          } }]), $t;
        }(ve.a.PureComponent), l0 = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("g", null, ve.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), $t;
        }(ve.a.PureComponent), iy = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("g", null, ve.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), $t;
        }(ve.a.PureComponent), _b2 = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("g", null, ve.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
          } }]), $t;
        }(ve.a.PureComponent), ay = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("g", null, ve.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
          } }]), $t;
        }(ve.a.PureComponent), Vp = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.style, jr = qe(bn, ["style"]);
            return ve.a.createElement("span", jr, ve.a.createElement("svg", Object.assign({}, vc(Mn), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), ve.a.createElement("g", null, ve.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
          } }]), $t;
        }(ve.a.PureComponent);
        function vc(An) {
          return An || (An = {}), { style: C(C({ verticalAlign: "middle" }, An), {}, { color: An.color ? An.color : "#000000", height: "1em", width: "1em" }) };
        }
        var Hd = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).copiedTimer = null, Mn.handleCopy = function() {
              var jr = document.createElement("textarea"), zi = Mn.props, xi = zi.clickCallback, Sr = zi.src, cn = zi.namespace;
              jr.innerHTML = JSON.stringify(Mn.clipboardValue(Sr), null, "  "), document.body.appendChild(jr), jr.select(), document.execCommand("copy"), document.body.removeChild(jr), Mn.copiedTimer = setTimeout(function() {
                Mn.setState({ copied: false });
              }, 5500), Mn.setState({ copied: true }, function() {
                typeof xi == "function" && xi({ src: Sr, namespace: cn, name: cn[cn.length - 1] });
              });
            }, Mn.getClippyIcon = function() {
              var jr = Mn.props.theme;
              return Mn.state.copied ? ve.a.createElement("span", null, ve.a.createElement(ph, Object.assign({ className: "copy-icon" }, Ft(jr, "copy-icon"))), ve.a.createElement("span", Ft(jr, "copy-icon-copied"), "\u2714")) : ve.a.createElement(ph, Object.assign({ className: "copy-icon" }, Ft(jr, "copy-icon")));
            }, Mn.clipboardValue = function(jr) {
              switch (Ze(jr)) {
                case "function":
                case "regexp":
                  return jr.toString();
                default:
                  return jr;
              }
            }, Mn.state = { copied: false }, Mn;
          }
          return P($t, [{ key: "componentWillUnmount", value: function() {
            this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
          } }, { key: "render", value: function() {
            var bn = this.props, Mn = (bn.src, bn.theme), jr = bn.hidden, zi = bn.rowHovered, xi = Ft(Mn, "copy-to-clipboard").style, Sr = "inline";
            return jr && (Sr = "none"), ve.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: zi ? "inline-block" : "none" } }, ve.a.createElement("span", { style: C(C({}, xi), {}, { display: Sr }), onClick: this.handleCopy }, this.getClippyIcon()));
          } }]), $t;
        }(ve.a.PureComponent), gg = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).getEditIcon = function() {
              var jr = Mn.props, zi = jr.variable, xi = jr.theme;
              return ve.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: Mn.state.hovered ? "inline-block" : "none" } }, ve.a.createElement(ay, Object.assign({ className: "click-to-edit-icon" }, Ft(xi, "editVarIcon"), { onClick: function() {
                Mn.prepopInput(zi);
              } })));
            }, Mn.prepopInput = function(jr) {
              if (Mn.props.onEdit !== false) {
                var zi = function(Sr) {
                  var cn;
                  switch (Ze(Sr)) {
                    case "undefined":
                      cn = "undefined";
                      break;
                    case "nan":
                      cn = "NaN";
                      break;
                    case "string":
                      cn = Sr;
                      break;
                    case "date":
                    case "function":
                    case "regexp":
                      cn = Sr.toString();
                      break;
                    default:
                      try {
                        cn = JSON.stringify(Sr, null, "  ");
                      } catch {
                        cn = "";
                      }
                  }
                  return cn;
                }(jr.value), xi = uo(zi);
                Mn.setState({ editMode: true, editValue: zi, parsedInput: { type: xi.type, value: xi.value } });
              }
            }, Mn.getRemoveIcon = function() {
              var jr = Mn.props, zi = jr.variable, xi = jr.namespace, Sr = jr.theme, cn = jr.rjvId;
              return ve.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: Mn.state.hovered ? "inline-block" : "none" } }, ve.a.createElement(l0, Object.assign({ className: "click-to-remove-icon" }, Ft(Sr, "removeVarIcon"), { onClick: function() {
                Ao.dispatch({ name: "VARIABLE_REMOVED", rjvId: cn, data: { name: zi.name, namespace: xi, existing_value: zi.value, variable_removed: true } });
              } })));
            }, Mn.getValue = function(jr, zi) {
              var xi = !zi && jr.type, Sr = te(Mn).props;
              switch (xi) {
                case false:
                  return Mn.getEditInput();
                case "string":
                  return ve.a.createElement(ds, Object.assign({ value: jr.value }, Sr));
                case "integer":
                  return ve.a.createElement(Yo, Object.assign({ value: jr.value }, Sr));
                case "float":
                  return ve.a.createElement(zn, Object.assign({ value: jr.value }, Sr));
                case "boolean":
                  return ve.a.createElement(hn, Object.assign({ value: jr.value }, Sr));
                case "function":
                  return ve.a.createElement(fo, Object.assign({ value: jr.value }, Sr));
                case "null":
                  return ve.a.createElement($a, Sr);
                case "nan":
                  return ve.a.createElement(Co, Sr);
                case "undefined":
                  return ve.a.createElement(Lu, Sr);
                case "date":
                  return ve.a.createElement(xn, Object.assign({ value: jr.value }, Sr));
                case "regexp":
                  return ve.a.createElement(Qu, Object.assign({ value: jr.value }, Sr));
                default:
                  return ve.a.createElement("div", { className: "object-value" }, JSON.stringify(jr.value));
              }
            }, Mn.getEditInput = function() {
              var jr = Mn.props.theme, zi = Mn.state.editValue;
              return ve.a.createElement("div", null, ve.a.createElement(Zi, Object.assign({ type: "text", inputRef: function(xi) {
                return xi && xi.focus();
              }, value: zi, className: "variable-editor", onChange: function(xi) {
                var Sr = xi.target.value, cn = uo(Sr);
                Mn.setState({ editValue: Sr, parsedInput: { type: cn.type, value: cn.value } });
              }, onKeyDown: function(xi) {
                switch (xi.key) {
                  case "Escape":
                    Mn.setState({ editMode: false, editValue: "" });
                    break;
                  case "Enter":
                    (xi.ctrlKey || xi.metaKey) && Mn.submitEdit(true);
                }
                xi.stopPropagation();
              }, placeholder: "update this value", minRows: 2 }, Ft(jr, "edit-input"))), ve.a.createElement("div", Ft(jr, "edit-icon-container"), ve.a.createElement(l0, Object.assign({ className: "edit-cancel" }, Ft(jr, "cancel-icon"), { onClick: function() {
                Mn.setState({ editMode: false, editValue: "" });
              } })), ve.a.createElement(Vp, Object.assign({ className: "edit-check string-value" }, Ft(jr, "check-icon"), { onClick: function() {
                Mn.submitEdit();
              } })), ve.a.createElement("div", null, Mn.showDetected())));
            }, Mn.submitEdit = function(jr) {
              var zi = Mn.props, xi = zi.variable, Sr = zi.namespace, cn = zi.rjvId, as = Mn.state, Eu = as.editValue, eu = as.parsedInput, Df = Eu;
              jr && eu.type && (Df = eu.value), Mn.setState({ editMode: false }), Ao.dispatch({ name: "VARIABLE_UPDATED", rjvId: cn, data: { name: xi.name, namespace: Sr, existing_value: xi.value, new_value: Df, variable_removed: false } });
            }, Mn.showDetected = function() {
              var jr = Mn.props, zi = jr.theme, xi = (jr.variable, jr.namespace, jr.rjvId, Mn.state.parsedInput), Sr = (xi.type, xi.value, Mn.getDetectedInput());
              if (Sr)
                return ve.a.createElement("div", null, ve.a.createElement("div", Ft(zi, "detected-row"), Sr, ve.a.createElement(Vp, { className: "edit-check detected", style: C({ verticalAlign: "top", paddingLeft: "3px" }, Ft(zi, "check-icon").style), onClick: function() {
                  Mn.submitEdit(true);
                } })));
            }, Mn.getDetectedInput = function() {
              var jr = Mn.state.parsedInput, zi = jr.type, xi = jr.value, Sr = te(Mn).props, cn = Sr.theme;
              if (zi !== false)
                switch (zi.toLowerCase()) {
                  case "object":
                    return ve.a.createElement("span", null, ve.a.createElement("span", { style: C(C({}, Ft(cn, "brace").style), {}, { cursor: "default" }) }, "{"), ve.a.createElement("span", { style: C(C({}, Ft(cn, "ellipsis").style), {}, { cursor: "default" }) }, "..."), ve.a.createElement("span", { style: C(C({}, Ft(cn, "brace").style), {}, { cursor: "default" }) }, "}"));
                  case "array":
                    return ve.a.createElement("span", null, ve.a.createElement("span", { style: C(C({}, Ft(cn, "brace").style), {}, { cursor: "default" }) }, "["), ve.a.createElement("span", { style: C(C({}, Ft(cn, "ellipsis").style), {}, { cursor: "default" }) }, "..."), ve.a.createElement("span", { style: C(C({}, Ft(cn, "brace").style), {}, { cursor: "default" }) }, "]"));
                  case "string":
                    return ve.a.createElement(ds, Object.assign({ value: xi }, Sr));
                  case "integer":
                    return ve.a.createElement(Yo, Object.assign({ value: xi }, Sr));
                  case "float":
                    return ve.a.createElement(zn, Object.assign({ value: xi }, Sr));
                  case "boolean":
                    return ve.a.createElement(hn, Object.assign({ value: xi }, Sr));
                  case "function":
                    return ve.a.createElement(fo, Object.assign({ value: xi }, Sr));
                  case "null":
                    return ve.a.createElement($a, Sr);
                  case "nan":
                    return ve.a.createElement(Co, Sr);
                  case "undefined":
                    return ve.a.createElement(Lu, Sr);
                  case "date":
                    return ve.a.createElement(xn, Object.assign({ value: new Date(xi) }, Sr));
                }
            }, Mn.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, Mn;
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this, Mn = this.props, jr = Mn.variable, zi = Mn.singleIndent, xi = Mn.type, Sr = Mn.theme, cn = Mn.namespace, as = Mn.indentWidth, Eu = Mn.enableClipboard, eu = Mn.onEdit, Df = Mn.onDelete, yo = Mn.onSelect, lf = Mn.displayArrayKey, tp = Mn.quotesOnKeys, Vs = this.state.editMode;
            return ve.a.createElement("div", Object.assign({}, Ft(Sr, "objectKeyVal", { paddingLeft: as * zi }), { onMouseEnter: function() {
              return bn.setState(C(C({}, bn.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return bn.setState(C(C({}, bn.state), {}, { hovered: false }));
            }, className: "variable-row", key: jr.name }), xi == "array" ? lf ? ve.a.createElement("span", Object.assign({}, Ft(Sr, "array-key"), { key: jr.name + "_" + cn }), jr.name, ve.a.createElement("div", Ft(Sr, "colon"), ":")) : null : ve.a.createElement("span", null, ve.a.createElement("span", Object.assign({}, Ft(Sr, "object-name"), { className: "object-key", key: jr.name + "_" + cn }), !!tp && ve.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), ve.a.createElement("span", { style: { display: "inline-block" } }, jr.name), !!tp && ve.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), ve.a.createElement("span", Ft(Sr, "colon"), ":")), ve.a.createElement("div", Object.assign({ className: "variable-value", onClick: yo === false && eu === false ? null : function(_d) {
              var sy = Ba(cn);
              (_d.ctrlKey || _d.metaKey) && eu !== false ? bn.prepopInput(jr) : yo !== false && (sy.shift(), yo(C(C({}, jr), {}, { namespace: sy })));
            } }, Ft(Sr, "variableValue", { cursor: yo === false ? "default" : "pointer" })), this.getValue(jr, Vs)), Eu ? ve.a.createElement(Hd, { rowHovered: this.state.hovered, hidden: Vs, src: jr.value, clickCallback: Eu, theme: Sr, namespace: [].concat(Ba(cn), [jr.name]) }) : null, eu !== false && Vs == 0 ? this.getEditIcon() : null, Df !== false && Vs == 0 ? this.getRemoveIcon() : null);
          } }]), $t;
        }(ve.a.PureComponent), xb = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            var bn;
            A2(this, $t);
            for (var Mn = arguments.length, jr = new Array(Mn), zi = 0; zi < Mn; zi++)
              jr[zi] = arguments[zi];
            return (bn = Rn.call.apply(Rn, [this].concat(jr))).getObjectSize = function() {
              var xi = bn.props, Sr = xi.size, cn = xi.theme;
              if (xi.displayObjectSize)
                return ve.a.createElement("span", Object.assign({ className: "object-size" }, Ft(cn, "object-size")), Sr, " item", Sr === 1 ? "" : "s");
            }, bn.getAddAttribute = function(xi) {
              var Sr = bn.props, cn = Sr.theme, as = Sr.namespace, Eu = Sr.name, eu = Sr.src, Df = Sr.rjvId, yo = Sr.depth;
              return ve.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: xi ? "inline-block" : "none" } }, ve.a.createElement(iy, Object.assign({ className: "click-to-add-icon" }, Ft(cn, "addVarIcon"), { onClick: function() {
                var lf = { name: yo > 0 ? Eu : null, namespace: as.splice(0, as.length - 1), existing_value: eu, variable_removed: false, key_name: null };
                Ze(eu) === "object" ? Ao.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: Df, data: lf }) : Ao.dispatch({ name: "VARIABLE_ADDED", rjvId: Df, data: C(C({}, lf), {}, { new_value: [].concat(Ba(eu), [null]) }) });
              } })));
            }, bn.getRemoveObject = function(xi) {
              var Sr = bn.props, cn = Sr.theme, as = (Sr.hover, Sr.namespace), Eu = Sr.name, eu = Sr.src, Df = Sr.rjvId;
              if (as.length !== 1)
                return ve.a.createElement("span", { className: "click-to-remove", style: { display: xi ? "inline-block" : "none" } }, ve.a.createElement(l0, Object.assign({ className: "click-to-remove-icon" }, Ft(cn, "removeVarIcon"), { onClick: function() {
                  Ao.dispatch({ name: "VARIABLE_REMOVED", rjvId: Df, data: { name: Eu, namespace: as.splice(0, as.length - 1), existing_value: eu, variable_removed: true } });
                } })));
            }, bn.render = function() {
              var xi = bn.props, Sr = xi.theme, cn = xi.onDelete, as = xi.onAdd, Eu = xi.enableClipboard, eu = xi.src, Df = xi.namespace, yo = xi.rowHovered;
              return ve.a.createElement("div", Object.assign({}, Ft(Sr, "object-meta-data"), { className: "object-meta-data", onClick: function(lf) {
                lf.stopPropagation();
              } }), bn.getObjectSize(), Eu ? ve.a.createElement(Hd, { rowHovered: yo, clickCallback: Eu, src: eu, theme: Sr, namespace: Df }) : null, as !== false ? bn.getAddAttribute(yo) : null, cn !== false ? bn.getRemoveObject(yo) : null);
            }, bn;
          }
          return $t;
        }(ve.a.PureComponent);
        function um(An) {
          var Rn = An.parent_type, $t = An.namespace, bn = An.quotesOnKeys, Mn = An.theme, jr = An.jsvRoot, zi = An.name, xi = An.displayArrayKey, Sr = An.name ? An.name : "";
          return !jr || zi !== false && zi !== null ? Rn == "array" ? xi ? ve.a.createElement("span", Object.assign({}, Ft(Mn, "array-key"), { key: $t }), ve.a.createElement("span", { className: "array-key" }, Sr), ve.a.createElement("span", Ft(Mn, "colon"), ":")) : ve.a.createElement("span", null) : ve.a.createElement("span", Object.assign({}, Ft(Mn, "object-name"), { key: $t }), ve.a.createElement("span", { className: "object-key" }, bn && ve.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), ve.a.createElement("span", null, Sr), bn && ve.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), ve.a.createElement("span", Ft(Mn, "colon"), ":")) : ve.a.createElement("span", null);
        }
        function oy(An) {
          var Rn = An.theme;
          switch (An.iconStyle) {
            case "triangle":
              return ve.a.createElement(bd, Object.assign({}, Ft(Rn, "expanded-icon"), { className: "expanded-icon" }));
            case "square":
              return ve.a.createElement(sf, Object.assign({}, Ft(Rn, "expanded-icon"), { className: "expanded-icon" }));
            default:
              return ve.a.createElement(Jl, Object.assign({}, Ft(Rn, "expanded-icon"), { className: "expanded-icon" }));
          }
        }
        function x1(An) {
          var Rn = An.theme;
          switch (An.iconStyle) {
            case "triangle":
              return ve.a.createElement(hh, Object.assign({}, Ft(Rn, "collapsed-icon"), { className: "collapsed-icon" }));
            case "square":
              return ve.a.createElement(ep, Object.assign({}, Ft(Rn, "collapsed-icon"), { className: "collapsed-icon" }));
            default:
              return ve.a.createElement(Ql, Object.assign({}, Ft(Rn, "collapsed-icon"), { className: "collapsed-icon" }));
          }
        }
        var _M = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).toggleCollapsed = function(jr) {
              var zi = [];
              for (var xi in Mn.state.expanded)
                zi.push(Mn.state.expanded[xi]);
              zi[jr] = !zi[jr], Mn.setState({ expanded: zi });
            }, Mn.state = { expanded: [] }, Mn;
          }
          return P($t, [{ key: "getExpandedIcon", value: function(bn) {
            var Mn = this.props, jr = Mn.theme, zi = Mn.iconStyle;
            return this.state.expanded[bn] ? ve.a.createElement(oy, { theme: jr, iconStyle: zi }) : ve.a.createElement(x1, { theme: jr, iconStyle: zi });
          } }, { key: "render", value: function() {
            var bn = this, Mn = this.props, jr = Mn.src, zi = Mn.groupArraysAfterLength, xi = (Mn.depth, Mn.name), Sr = Mn.theme, cn = Mn.jsvRoot, as = Mn.namespace, Eu = (Mn.parent_type, qe(Mn, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), eu = 0, Df = 5 * this.props.indentWidth;
            cn || (eu = 5 * this.props.indentWidth);
            var yo = zi, lf = Math.ceil(jr.length / yo);
            return ve.a.createElement("div", Object.assign({ className: "object-key-val" }, Ft(Sr, cn ? "jsv-root" : "objectKeyVal", { paddingLeft: eu })), ve.a.createElement(um, this.props), ve.a.createElement("span", null, ve.a.createElement(xb, Object.assign({ size: jr.length }, this.props))), Ba(Array(lf)).map(function(tp, Vs) {
              return ve.a.createElement("div", Object.assign({ key: Vs, className: "object-key-val array-group" }, Ft(Sr, "objectKeyVal", { marginLeft: 6, paddingLeft: Df })), ve.a.createElement("span", Ft(Sr, "brace-row"), ve.a.createElement("div", Object.assign({ className: "icon-container" }, Ft(Sr, "icon-container"), { onClick: function(_d) {
                bn.toggleCollapsed(Vs);
              } }), bn.getExpandedIcon(Vs)), bn.state.expanded[Vs] ? ve.a.createElement(T2, Object.assign({ key: xi + Vs, depth: 0, name: false, collapsed: false, groupArraysAfterLength: yo, index_offset: Vs * yo, src: jr.slice(Vs * yo, Vs * yo + yo), namespace: as, type: "array", parent_type: "array_group", theme: Sr }, Eu)) : ve.a.createElement("span", Object.assign({}, Ft(Sr, "brace"), { onClick: function(_d) {
                bn.toggleCollapsed(Vs);
              }, className: "array-group-brace" }), "[", ve.a.createElement("div", Object.assign({}, Ft(Sr, "array-group-meta-data"), { className: "array-group-meta-data" }), ve.a.createElement("span", Object.assign({ className: "object-size" }, Ft(Sr, "object-size")), Vs * yo, " - ", Vs * yo + yo > jr.length ? jr.length : Vs * yo + yo)), "]")));
            }));
          } }]), $t;
        }(ve.a.PureComponent), M2 = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            A2(this, $t), (Mn = Rn.call(this, bn)).toggleCollapsed = function() {
              Mn.setState({ expanded: !Mn.state.expanded }, function() {
                Pa.set(Mn.props.rjvId, Mn.props.namespace, "expanded", Mn.state.expanded);
              });
            }, Mn.getObjectContent = function(zi, xi, Sr) {
              return ve.a.createElement("div", { className: "pushed-content object-container" }, ve.a.createElement("div", Object.assign({ className: "object-content" }, Ft(Mn.props.theme, "pushed-content")), Mn.renderObjectContents(xi, Sr)));
            }, Mn.getEllipsis = function() {
              return Mn.state.size === 0 ? null : ve.a.createElement("div", Object.assign({}, Ft(Mn.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: Mn.toggleCollapsed }), "...");
            }, Mn.getObjectMetaData = function(zi) {
              var xi = Mn.props, Sr = (xi.rjvId, xi.theme, Mn.state), cn = Sr.size, as = Sr.hovered;
              return ve.a.createElement(xb, Object.assign({ rowHovered: as, size: cn }, Mn.props));
            }, Mn.renderObjectContents = function(zi, xi) {
              var Sr, cn = Mn.props, as = cn.depth, Eu = cn.parent_type, eu = cn.index_offset, Df = cn.groupArraysAfterLength, yo = cn.namespace, lf = Mn.state.object_type, tp = [], Vs = Object.keys(zi || {});
              return Mn.props.sortKeys && lf !== "array" && (Vs = Vs.sort()), Vs.forEach(function(_d) {
                if (Sr = new uP(_d, zi[_d]), Eu === "array_group" && eu && (Sr.name = parseInt(Sr.name) + eu), zi.hasOwnProperty(_d))
                  if (Sr.type === "object")
                    tp.push(ve.a.createElement(T2, Object.assign({ key: Sr.name, depth: as + 1, name: Sr.name, src: Sr.value, namespace: yo.concat(Sr.name), parent_type: lf }, xi)));
                  else if (Sr.type === "array") {
                    var sy = T2;
                    Df && Sr.value.length > Df && (sy = _M), tp.push(ve.a.createElement(sy, Object.assign({ key: Sr.name, depth: as + 1, name: Sr.name, src: Sr.value, namespace: yo.concat(Sr.name), type: "array", parent_type: lf }, xi)));
                  } else
                    tp.push(ve.a.createElement(gg, Object.assign({ key: Sr.name + "_" + yo, variable: Sr, singleIndent: 5, namespace: yo, type: Mn.props.type }, xi)));
              }), tp;
            };
            var jr = $t.getState(bn);
            return Mn.state = C(C({}, jr), {}, { prevProps: {} }), Mn;
          }
          return P($t, [{ key: "getBraceStart", value: function(bn, Mn) {
            var jr = this, zi = this.props, xi = zi.src, Sr = zi.theme, cn = zi.iconStyle;
            if (zi.parent_type === "array_group")
              return ve.a.createElement("span", null, ve.a.createElement("span", Ft(Sr, "brace"), bn === "array" ? "[" : "{"), Mn ? this.getObjectMetaData(xi) : null);
            var as = Mn ? oy : x1;
            return ve.a.createElement("span", null, ve.a.createElement("span", Object.assign({ onClick: function(Eu) {
              jr.toggleCollapsed();
            } }, Ft(Sr, "brace-row")), ve.a.createElement("div", Object.assign({ className: "icon-container" }, Ft(Sr, "icon-container")), ve.a.createElement(as, { theme: Sr, iconStyle: cn })), ve.a.createElement(um, this.props), ve.a.createElement("span", Ft(Sr, "brace"), bn === "array" ? "[" : "{")), Mn ? this.getObjectMetaData(xi) : null);
          } }, { key: "render", value: function() {
            var bn = this, Mn = this.props, jr = Mn.depth, zi = Mn.src, xi = (Mn.namespace, Mn.name, Mn.type, Mn.parent_type), Sr = Mn.theme, cn = Mn.jsvRoot, as = Mn.iconStyle, Eu = qe(Mn, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), eu = this.state, Df = eu.object_type, yo = eu.expanded, lf = {};
            return cn || xi === "array_group" ? xi === "array_group" && (lf.borderLeft = 0, lf.display = "inline") : lf.paddingLeft = 5 * this.props.indentWidth, ve.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
              return bn.setState(C(C({}, bn.state), {}, { hovered: true }));
            }, onMouseLeave: function() {
              return bn.setState(C(C({}, bn.state), {}, { hovered: false }));
            } }, Ft(Sr, cn ? "jsv-root" : "objectKeyVal", lf)), this.getBraceStart(Df, yo), yo ? this.getObjectContent(jr, zi, C({ theme: Sr, iconStyle: as }, Eu)) : this.getEllipsis(), ve.a.createElement("span", { className: "brace-row" }, ve.a.createElement("span", { style: C(C({}, Ft(Sr, "brace").style), {}, { paddingLeft: yo ? "3px" : "0px" }) }, Df === "array" ? "]" : "}"), yo ? null : this.getObjectMetaData(zi)));
          } }], [{ key: "getDerivedStateFromProps", value: function(bn, Mn) {
            var jr = Mn.prevProps;
            return bn.src !== jr.src || bn.collapsed !== jr.collapsed || bn.name !== jr.name || bn.namespace !== jr.namespace || bn.rjvId !== jr.rjvId ? C(C({}, $t.getState(bn)), {}, { prevProps: bn }) : null;
          } }]), $t;
        }(ve.a.PureComponent);
        M2.getState = function(An) {
          var Rn = Object.keys(An.src).length, $t = (An.collapsed === false || An.collapsed !== true && An.collapsed > An.depth) && (!An.shouldCollapse || An.shouldCollapse({ name: An.name, src: An.src, type: Ze(An.src), namespace: An.namespace }) === false) && Rn !== 0;
          return { expanded: Pa.get(An.rjvId, An.namespace, "expanded", $t), object_type: An.type === "array" ? "array" : "object", parent_type: An.type === "array" ? "array" : "object", size: Rn, hovered: false };
        };
        var uP = function An(Rn, $t) {
          A2(this, An), this.name = Rn, this.value = $t, this.type = Ze($t);
        };
        Ue(M2);
        var T2 = M2, Fj = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            var bn;
            A2(this, $t);
            for (var Mn = arguments.length, jr = new Array(Mn), zi = 0; zi < Mn; zi++)
              jr[zi] = arguments[zi];
            return (bn = Rn.call.apply(Rn, [this].concat(jr))).render = function() {
              var xi = te(bn).props, Sr = [xi.name], cn = T2;
              return Array.isArray(xi.src) && xi.groupArraysAfterLength && xi.src.length > xi.groupArraysAfterLength && (cn = _M), ve.a.createElement("div", { className: "pretty-json-container object-container" }, ve.a.createElement("div", { className: "object-content" }, ve.a.createElement(cn, Object.assign({ namespace: Sr, depth: 0, jsvRoot: true }, xi))));
            }, bn;
          }
          return $t;
        }(ve.a.PureComponent), Vj = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).closeModal = function() {
              Ao.dispatch({ rjvId: Mn.props.rjvId, name: "RESET" });
            }, Mn.submit = function() {
              Mn.props.submit(Mn.state.input);
            }, Mn.state = { input: bn.input ? bn.input : "" }, Mn;
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this, Mn = this.props, jr = Mn.theme, zi = Mn.rjvId, xi = Mn.isValid, Sr = this.state.input, cn = xi(Sr);
            return ve.a.createElement("div", Object.assign({ className: "key-modal-request" }, Ft(jr, "key-modal-request"), { onClick: this.closeModal }), ve.a.createElement("div", Object.assign({}, Ft(jr, "key-modal"), { onClick: function(as) {
              as.stopPropagation();
            } }), ve.a.createElement("div", Ft(jr, "key-modal-label"), "Key Name:"), ve.a.createElement("div", { style: { position: "relative" } }, ve.a.createElement("input", Object.assign({}, Ft(jr, "key-modal-input"), { className: "key-modal-input", ref: function(as) {
              return as && as.focus();
            }, spellCheck: false, value: Sr, placeholder: "...", onChange: function(as) {
              bn.setState({ input: as.target.value });
            }, onKeyPress: function(as) {
              cn && as.key === "Enter" ? bn.submit() : as.key === "Escape" && bn.closeModal();
            } })), cn ? ve.a.createElement(Vp, Object.assign({}, Ft(jr, "key-modal-submit"), { className: "key-modal-submit", onClick: function(as) {
              return bn.submit();
            } })) : null), ve.a.createElement("span", Ft(jr, "key-modal-cancel"), ve.a.createElement(_b2, Object.assign({}, Ft(jr, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
              Ao.dispatch({ rjvId: zi, name: "RESET" });
            } })))));
          } }]), $t;
        }(ve.a.PureComponent), Bj = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            var bn;
            A2(this, $t);
            for (var Mn = arguments.length, jr = new Array(Mn), zi = 0; zi < Mn; zi++)
              jr[zi] = arguments[zi];
            return (bn = Rn.call.apply(Rn, [this].concat(jr))).isValid = function(xi) {
              var Sr = bn.props.rjvId, cn = Pa.get(Sr, "action", "new-key-request");
              return xi != "" && Object.keys(cn.existing_value).indexOf(xi) === -1;
            }, bn.submit = function(xi) {
              var Sr = bn.props.rjvId, cn = Pa.get(Sr, "action", "new-key-request");
              cn.new_value = C({}, cn.existing_value), cn.new_value[xi] = bn.props.defaultValue, Ao.dispatch({ name: "VARIABLE_ADDED", rjvId: Sr, data: cn });
            }, bn;
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.active, jr = bn.theme, zi = bn.rjvId;
            return Mn ? ve.a.createElement(Vj, { rjvId: zi, theme: jr, isValid: this.isValid, submit: this.submit }) : null;
          } }]), $t;
        }(ve.a.PureComponent), zj = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t() {
            return A2(this, $t), Rn.apply(this, arguments);
          }
          return P($t, [{ key: "render", value: function() {
            var bn = this.props, Mn = bn.message, jr = bn.active, zi = bn.theme, xi = bn.rjvId;
            return jr ? ve.a.createElement("div", Object.assign({ className: "validation-failure" }, Ft(zi, "validation-failure"), { onClick: function() {
              Ao.dispatch({ rjvId: xi, name: "RESET" });
            } }), ve.a.createElement("span", Ft(zi, "validation-failure-label"), Mn), ve.a.createElement(_b2, Ft(zi, "validation-failure-clear"))) : null;
          } }]), $t;
        }(ve.a.PureComponent), y5 = function(An) {
          j($t, An);
          var Rn = ce($t);
          function $t(bn) {
            var Mn;
            return A2(this, $t), (Mn = Rn.call(this, bn)).rjvId = Date.now().toString(), Mn.getListeners = function() {
              return { reset: Mn.resetState, "variable-update": Mn.updateSrc, "add-key-request": Mn.addKeyRequest };
            }, Mn.updateSrc = function() {
              var jr, zi = Pa.get(Mn.rjvId, "action", "variable-update"), xi = zi.name, Sr = zi.namespace, cn = zi.new_value, as = zi.existing_value, Eu = (zi.variable_removed, zi.updated_src), eu = zi.type, Df = Mn.props, yo = Df.onEdit, lf = Df.onDelete, tp = Df.onAdd, Vs = { existing_src: Mn.state.src, new_value: cn, updated_src: Eu, name: xi, namespace: Sr, existing_value: as };
              switch (eu) {
                case "variable-added":
                  jr = tp(Vs);
                  break;
                case "variable-edited":
                  jr = yo(Vs);
                  break;
                case "variable-removed":
                  jr = lf(Vs);
              }
              jr !== false ? (Pa.set(Mn.rjvId, "global", "src", Eu), Mn.setState({ src: Eu })) : Mn.setState({ validationFailure: true });
            }, Mn.addKeyRequest = function() {
              Mn.setState({ addKeyRequest: true });
            }, Mn.resetState = function() {
              Mn.setState({ validationFailure: false, addKeyRequest: false });
            }, Mn.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: $t.defaultProps.src, name: $t.defaultProps.name, theme: $t.defaultProps.theme, validationMessage: $t.defaultProps.validationMessage, prevSrc: $t.defaultProps.src, prevName: $t.defaultProps.name, prevTheme: $t.defaultProps.theme }, Mn;
          }
          return P($t, [{ key: "componentDidMount", value: function() {
            Pa.set(this.rjvId, "global", "src", this.state.src);
            var bn = this.getListeners();
            for (var Mn in bn)
              Pa.on(Mn + "-" + this.rjvId, bn[Mn]);
            this.setState({ addKeyRequest: false, editKeyRequest: false });
          } }, { key: "componentDidUpdate", value: function(bn, Mn) {
            Mn.addKeyRequest !== false && this.setState({ addKeyRequest: false }), Mn.editKeyRequest !== false && this.setState({ editKeyRequest: false }), bn.src !== this.state.src && Pa.set(this.rjvId, "global", "src", this.state.src);
          } }, { key: "componentWillUnmount", value: function() {
            var bn = this.getListeners();
            for (var Mn in bn)
              Pa.removeListener(Mn + "-" + this.rjvId, bn[Mn]);
          } }, { key: "render", value: function() {
            var bn = this.state, Mn = bn.validationFailure, jr = bn.validationMessage, zi = bn.addKeyRequest, xi = bn.theme, Sr = bn.src, cn = bn.name, as = this.props, Eu = as.style, eu = as.defaultValue;
            return ve.a.createElement("div", { className: "react-json-view", style: C(C({}, Ft(xi, "app-container").style), Eu) }, ve.a.createElement(zj, { message: jr, active: Mn, theme: xi, rjvId: this.rjvId }), ve.a.createElement(Fj, Object.assign({}, this.props, { src: Sr, name: cn, theme: xi, type: Ze(Sr), rjvId: this.rjvId })), ve.a.createElement(Bj, { active: zi, theme: xi, rjvId: this.rjvId, defaultValue: eu }));
          } }], [{ key: "getDerivedStateFromProps", value: function(bn, Mn) {
            if (bn.src !== Mn.prevSrc || bn.name !== Mn.prevName || bn.theme !== Mn.prevTheme) {
              var jr = { src: bn.src, name: bn.name, theme: bn.theme, validationMessage: bn.validationMessage, prevSrc: bn.src, prevName: bn.name, prevTheme: bn.theme };
              return $t.validateState(jr);
            }
            return null;
          } }]), $t;
        }(ve.a.PureComponent);
        y5.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, y5.validateState = function(An) {
          var Rn = {};
          return Ze(An.theme) !== "object" || function($t) {
            var bn = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
            if (Ze($t) === "object") {
              for (var Mn = 0; Mn < bn.length; Mn++)
                if (!(bn[Mn] in $t))
                  return false;
              return true;
            }
            return false;
          }(An.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), Rn.theme = "rjv-default"), Ze(An.src) !== "object" && Ze(An.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), Rn.name = "ERROR", Rn.src = { message: "src property must be a valid json object" }), C(C({}, An), Rn);
        }, Ue(y5), h.default = y5;
      }]);
    });
  })(Mgt);
  var nkn = Nan(Mgt.exports);
  const rkn = ({ id: l3, title: r3, chart: e3, option: u }) => {
    const { tool: h } = Vvt({}), v4 = Nhe.useEventEmitter({ global: true }), [m3, { set: x3 }] = Ian(true), C = (A2) => {
      const { updated_src: D } = A2;
      e3 == null || e3.setOption(D), h == null || h.add(l3, e3, D, r3), v4.emit("list");
    };
    return z5n("div", { children: [Xz(q5n, { children: Xz(K5n, { children: Xz(J5n, { checkedChildren: "\u5C55\u5F00\u914D\u7F6E", unCheckedChildren: "\u6298\u53E0\u914D\u7F6E", defaultChecked: false, onChange: (A2) => {
      x3(!A2);
    } }) }) }), Xz("br", {}), u && Xz(nkn, { src: u, theme: "pop", displayObjectSize: false, displayDataTypes: false, collapsed: m3, iconStyle: "triangle", enableClipboard: true, onEdit: C, onAdd: C, onDelete: C })] });
  };
  exports.EchartTool = tkn;
  exports.ReactEchartsJson = rkn;
  exports.useEcharts = dEn;
  exports.useEchartsTool = Vvt;
  exports.useEventEmitter = Fvt;
})(reactEchartsJson_cjs);
var main = { exports: {} };
(function(module, exports) {
  !function(e2, t2) {
    module.exports = t2(React__default);
  }(commonjsGlobal, function(e2) {
    return function(e3) {
      var t2 = {};
      function n2(a) {
        if (t2[a])
          return t2[a].exports;
        var r2 = t2[a] = { i: a, l: false, exports: {} };
        return e3[a].call(r2.exports, r2, r2.exports, n2), r2.l = true, r2.exports;
      }
      return n2.m = e3, n2.c = t2, n2.d = function(e4, t3, a) {
        n2.o(e4, t3) || Object.defineProperty(e4, t3, { enumerable: true, get: a });
      }, n2.r = function(e4) {
        typeof Symbol != "undefined" && Symbol.toStringTag && Object.defineProperty(e4, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(e4, "__esModule", { value: true });
      }, n2.t = function(e4, t3) {
        if (1 & t3 && (e4 = n2(e4)), 8 & t3)
          return e4;
        if (4 & t3 && typeof e4 == "object" && e4 && e4.__esModule)
          return e4;
        var a = /* @__PURE__ */ Object.create(null);
        if (n2.r(a), Object.defineProperty(a, "default", { enumerable: true, value: e4 }), 2 & t3 && typeof e4 != "string")
          for (var r2 in e4)
            n2.d(a, r2, function(t4) {
              return e4[t4];
            }.bind(null, r2));
        return a;
      }, n2.n = function(e4) {
        var t3 = e4 && e4.__esModule ? function() {
          return e4.default;
        } : function() {
          return e4;
        };
        return n2.d(t3, "a", t3), t3;
      }, n2.o = function(e4, t3) {
        return Object.prototype.hasOwnProperty.call(e4, t3);
      }, n2.p = "", n2(n2.s = 48);
    }([function(t2, n2) {
      t2.exports = e2;
    }, function(e3, t2) {
      var n2 = e3.exports = { version: "2.6.12" };
      typeof __e == "number" && (__e = n2);
    }, function(e3, t2, n2) {
      var a = n2(26)("wks"), r2 = n2(17), o = n2(3).Symbol, i = typeof o == "function";
      (e3.exports = function(e4) {
        return a[e4] || (a[e4] = i && o[e4] || (i ? o : r2)("Symbol." + e4));
      }).store = a;
    }, function(e3, t2) {
      var n2 = e3.exports = typeof window != "undefined" && window.Math == Math ? window : typeof self != "undefined" && self.Math == Math ? self : Function("return this")();
      typeof __g == "number" && (__g = n2);
    }, function(e3, t2, n2) {
      e3.exports = !n2(8)(function() {
        return Object.defineProperty({}, "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2) {
      var n2 = {}.hasOwnProperty;
      e3.exports = function(e4, t3) {
        return n2.call(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(16);
      e3.exports = n2(4) ? function(e4, t3, n3) {
        return a.f(e4, t3, r2(1, n3));
      } : function(e4, t3, n3) {
        return e4[t3] = n3, e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(35), o = n2(23), i = Object.defineProperty;
      t2.f = n2(4) ? Object.defineProperty : function(e4, t3, n3) {
        if (a(e4), t3 = o(t3, true), a(n3), r2)
          try {
            return i(e4, t3, n3);
          } catch (e5) {
          }
        if ("get" in n3 || "set" in n3)
          throw TypeError("Accessors not supported!");
        return "value" in n3 && (e4[t3] = n3.value), e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        try {
          return !!e4();
        } catch (e5) {
          return true;
        }
      };
    }, function(e3, t2, n2) {
      var a = n2(40), r2 = n2(22);
      e3.exports = function(e4) {
        return a(r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4) {
        if (!a(e4))
          throw TypeError(e4 + " is not an object!");
        return e4;
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        return typeof e4 == "object" ? e4 !== null : typeof e4 == "function";
      };
    }, function(e3, t2) {
      e3.exports = {};
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27);
      e3.exports = Object.keys || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2) {
      e3.exports = true;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(53), i = n2(6), s = n2(5), c2 = function(e4, t3, n3) {
        var l2, u, f2, p2 = e4 & c2.F, d2 = e4 & c2.G, b2 = e4 & c2.S, h = e4 & c2.P, v4 = e4 & c2.B, m2 = e4 & c2.W, y2 = d2 ? r2 : r2[t3] || (r2[t3] = {}), g2 = y2.prototype, E = d2 ? a : b2 ? a[t3] : (a[t3] || {}).prototype;
        for (l2 in d2 && (n3 = t3), n3)
          (u = !p2 && E && E[l2] !== void 0) && s(y2, l2) || (f2 = u ? E[l2] : n3[l2], y2[l2] = d2 && typeof E[l2] != "function" ? n3[l2] : v4 && u ? o(f2, a) : m2 && E[l2] == f2 ? function(e5) {
            var t4 = function(t5, n4, a2) {
              if (this instanceof e5) {
                switch (arguments.length) {
                  case 0:
                    return new e5();
                  case 1:
                    return new e5(t5);
                  case 2:
                    return new e5(t5, n4);
                }
                return new e5(t5, n4, a2);
              }
              return e5.apply(this, arguments);
            };
            return t4.prototype = e5.prototype, t4;
          }(f2) : h && typeof f2 == "function" ? o(Function.call, f2) : f2, h && ((y2.virtual || (y2.virtual = {}))[l2] = f2, e4 & c2.R && g2 && !g2[l2] && i(g2, l2, f2)));
      };
      c2.F = 1, c2.G = 2, c2.S = 4, c2.P = 8, c2.B = 16, c2.W = 32, c2.U = 64, c2.R = 128, e3.exports = c2;
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { enumerable: !(1 & e4), configurable: !(2 & e4), writable: !(4 & e4), value: t3 };
      };
    }, function(e3, t2) {
      var n2 = 0, a = Math.random();
      e3.exports = function(e4) {
        return "Symbol(".concat(e4 === void 0 ? "" : e4, ")_", (++n2 + a).toString(36));
      };
    }, function(e3, t2, n2) {
      var a = n2(22);
      e3.exports = function(e4) {
        return Object(a(e4));
      };
    }, function(e3, t2) {
      t2.f = {}.propertyIsEnumerable;
    }, function(e3, t2, n2) {
      var a = n2(52)(true);
      n2(34)(String, "String", function(e4) {
        this._t = String(e4), this._i = 0;
      }, function() {
        var e4, t3 = this._t, n3 = this._i;
        return n3 >= t3.length ? { value: void 0, done: true } : (e4 = a(t3, n3), this._i += e4.length, { value: e4, done: false });
      });
    }, function(e3, t2) {
      var n2 = Math.ceil, a = Math.floor;
      e3.exports = function(e4) {
        return isNaN(e4 = +e4) ? 0 : (e4 > 0 ? a : n2)(e4);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (e4 == null)
          throw TypeError("Can't call method on  " + e4);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(11);
      e3.exports = function(e4, t3) {
        if (!a(e4))
          return e4;
        var n3, r2;
        if (t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (typeof (n3 = e4.valueOf) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        if (!t3 && typeof (n3 = e4.toString) == "function" && !a(r2 = n3.call(e4)))
          return r2;
        throw TypeError("Can't convert object to primitive value");
      };
    }, function(e3, t2) {
      var n2 = {}.toString;
      e3.exports = function(e4) {
        return n2.call(e4).slice(8, -1);
      };
    }, function(e3, t2, n2) {
      var a = n2(26)("keys"), r2 = n2(17);
      e3.exports = function(e4) {
        return a[e4] || (a[e4] = r2(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(1), r2 = n2(3), o = r2["__core-js_shared__"] || (r2["__core-js_shared__"] = {});
      (e3.exports = function(e4, t3) {
        return o[e4] || (o[e4] = t3 !== void 0 ? t3 : {});
      })("versions", []).push({ version: a.version, mode: n2(14) ? "pure" : "global", copyright: "\xA9 2020 Denis Pushkarev (zloirock.ru)" });
    }, function(e3, t2) {
      e3.exports = "constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(",");
    }, function(e3, t2, n2) {
      var a = n2(7).f, r2 = n2(5), o = n2(2)("toStringTag");
      e3.exports = function(e4, t3, n3) {
        e4 && !r2(e4 = n3 ? e4 : e4.prototype, o) && a(e4, o, { configurable: true, value: t3 });
      };
    }, function(e3, t2, n2) {
      n2(62);
      for (var a = n2(3), r2 = n2(6), o = n2(12), i = n2(2)("toStringTag"), s = "CSSRuleList,CSSStyleDeclaration,CSSValueList,ClientRectList,DOMRectList,DOMStringList,DOMTokenList,DataTransferItemList,FileList,HTMLAllCollection,HTMLCollection,HTMLFormElement,HTMLSelectElement,MediaList,MimeTypeArray,NamedNodeMap,NodeList,PaintRequestList,Plugin,PluginArray,SVGLengthList,SVGNumberList,SVGPathSegList,SVGPointList,SVGStringList,SVGTransformList,SourceBufferList,StyleSheetList,TextTrackCueList,TextTrackList,TouchList".split(","), c2 = 0; c2 < s.length; c2++) {
        var l2 = s[c2], u = a[l2], f2 = u && u.prototype;
        f2 && !f2[i] && r2(f2, i, l2), o[l2] = o.Array;
      }
    }, function(e3, t2, n2) {
      t2.f = n2(2);
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(1), o = n2(14), i = n2(30), s = n2(7).f;
      e3.exports = function(e4) {
        var t3 = r2.Symbol || (r2.Symbol = o ? {} : a.Symbol || {});
        e4.charAt(0) == "_" || e4 in t3 || s(t3, e4, { value: i.f(e4) });
      };
    }, function(e3, t2) {
      t2.f = Object.getOwnPropertySymbols;
    }, function(e3, t2) {
      e3.exports = function(e4, t3, n2) {
        return Math.min(Math.max(e4, t3), n2);
      };
    }, function(e3, t2, n2) {
      var a = n2(14), r2 = n2(15), o = n2(37), i = n2(6), s = n2(12), c2 = n2(55), l2 = n2(28), u = n2(61), f2 = n2(2)("iterator"), p2 = !([].keys && "next" in [].keys()), d2 = function() {
        return this;
      };
      e3.exports = function(e4, t3, n3, b2, h, v4, m2) {
        c2(n3, t3, b2);
        var y2, g2, E, j = function(e5) {
          if (!p2 && e5 in O)
            return O[e5];
          switch (e5) {
            case "keys":
            case "values":
              return function() {
                return new n3(this, e5);
              };
          }
          return function() {
            return new n3(this, e5);
          };
        }, x2 = t3 + " Iterator", _ = h == "values", k2 = false, O = e4.prototype, C = O[f2] || O["@@iterator"] || h && O[h], S = C || j(h), w2 = h ? _ ? j("entries") : S : void 0, A2 = t3 == "Array" && O.entries || C;
        if (A2 && (E = u(A2.call(new e4()))) !== Object.prototype && E.next && (l2(E, x2, true), a || typeof E[f2] == "function" || i(E, f2, d2)), _ && C && C.name !== "values" && (k2 = true, S = function() {
          return C.call(this);
        }), a && !m2 || !p2 && !k2 && O[f2] || i(O, f2, S), s[t3] = S, s[x2] = d2, h)
          if (y2 = { values: _ ? S : j("values"), keys: v4 ? S : j("keys"), entries: w2 }, m2)
            for (g2 in y2)
              g2 in O || o(O, g2, y2[g2]);
          else
            r2(r2.P + r2.F * (p2 || k2), t3, y2);
        return y2;
      };
    }, function(e3, t2, n2) {
      e3.exports = !n2(4) && !n2(8)(function() {
        return Object.defineProperty(n2(36)("div"), "a", { get: function() {
          return 7;
        } }).a != 7;
      });
    }, function(e3, t2, n2) {
      var a = n2(11), r2 = n2(3).document, o = a(r2) && a(r2.createElement);
      e3.exports = function(e4) {
        return o ? r2.createElement(e4) : {};
      };
    }, function(e3, t2, n2) {
      e3.exports = n2(6);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(56), o = n2(27), i = n2(25)("IE_PROTO"), s = function() {
      }, c2 = function() {
        var e4, t3 = n2(36)("iframe"), a2 = o.length;
        for (t3.style.display = "none", n2(60).appendChild(t3), t3.src = "javascript:", (e4 = t3.contentWindow.document).open(), e4.write("<script>document.F=Object<\/script>"), e4.close(), c2 = e4.F; a2--; )
          delete c2.prototype[o[a2]];
        return c2();
      };
      e3.exports = Object.create || function(e4, t3) {
        var n3;
        return e4 !== null ? (s.prototype = a(e4), n3 = new s(), s.prototype = null, n3[i] = e4) : n3 = c2(), t3 === void 0 ? n3 : r2(n3, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(9), o = n2(57)(false), i = n2(25)("IE_PROTO");
      e3.exports = function(e4, t3) {
        var n3, s = r2(e4), c2 = 0, l2 = [];
        for (n3 in s)
          n3 != i && a(s, n3) && l2.push(n3);
        for (; t3.length > c2; )
          a(s, n3 = t3[c2++]) && (~o(l2, n3) || l2.push(n3));
        return l2;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Object("z").propertyIsEnumerable(0) ? Object : function(e4) {
        return a(e4) == "String" ? e4.split("") : Object(e4);
      };
    }, function(e3, t2, n2) {
      var a = n2(39), r2 = n2(27).concat("length", "prototype");
      t2.f = Object.getOwnPropertyNames || function(e4) {
        return a(e4, r2);
      };
    }, function(e3, t2, n2) {
      var a = n2(24), r2 = n2(2)("toStringTag"), o = a(function() {
        return arguments;
      }()) == "Arguments";
      e3.exports = function(e4) {
        var t3, n3, i;
        return e4 === void 0 ? "Undefined" : e4 === null ? "Null" : typeof (n3 = function(e5, t4) {
          try {
            return e5[t4];
          } catch (e6) {
          }
        }(t3 = Object(e4), r2)) == "string" ? n3 : o ? a(t3) : (i = a(t3)) == "Object" && typeof t3.callee == "function" ? "Arguments" : i;
      };
    }, function(e3, t2) {
      var n2;
      n2 = function() {
        return this;
      }();
      try {
        n2 = n2 || new Function("return this")();
      } catch (e4) {
        typeof window == "object" && (n2 = window);
      }
      e3.exports = n2;
    }, function(e3, t2) {
      var n2 = /-?\d+(\.\d+)?%?/g;
      e3.exports = function(e4) {
        return e4.match(n2);
      };
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.getBase16Theme = t2.createStyling = t2.invertTheme = void 0;
      var a = d2(n2(49)), r2 = d2(n2(76)), o = d2(n2(81)), i = d2(n2(89)), s = d2(n2(93)), c2 = function(e4) {
        if (e4 && e4.__esModule)
          return e4;
        var t3 = {};
        if (e4 != null)
          for (var n3 in e4)
            Object.prototype.hasOwnProperty.call(e4, n3) && (t3[n3] = e4[n3]);
        return t3.default = e4, t3;
      }(n2(94)), l2 = d2(n2(132)), u = d2(n2(133)), f2 = d2(n2(138)), p2 = n2(139);
      function d2(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      var b2 = c2.default, h = (0, i.default)(b2), v4 = (0, f2.default)(u.default, p2.rgb2yuv, function(e4) {
        var t3, n3 = (0, o.default)(e4, 3), a2 = n3[0], r3 = n3[1], i2 = n3[2];
        return [(t3 = a2, t3 < 0.25 ? 1 : t3 < 0.5 ? 0.9 - t3 : 1.1 - t3), r3, i2];
      }, p2.yuv2rgb, l2.default), m2 = function(e4) {
        return function(t3) {
          return { className: [t3.className, e4.className].filter(Boolean).join(" "), style: (0, r2.default)({}, t3.style || {}, e4.style || {}) };
        };
      }, y2 = function(e4, t3) {
        var n3 = (0, i.default)(t3);
        for (var o2 in e4)
          n3.indexOf(o2) === -1 && n3.push(o2);
        return n3.reduce(function(n4, o3) {
          return n4[o3] = function(e5, t4) {
            if (e5 === void 0)
              return t4;
            if (t4 === void 0)
              return e5;
            var n5 = e5 === void 0 ? "undefined" : (0, a.default)(e5), o4 = t4 === void 0 ? "undefined" : (0, a.default)(t4);
            switch (n5) {
              case "string":
                switch (o4) {
                  case "string":
                    return [t4, e5].filter(Boolean).join(" ");
                  case "object":
                    return m2({ className: e5, style: t4 });
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ className: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "object":
                switch (o4) {
                  case "string":
                    return m2({ className: t4, style: e5 });
                  case "object":
                    return (0, r2.default)({}, t4, e5);
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return m2({ style: e5 })(t4.apply(void 0, [n6].concat(r3)));
                    };
                }
              case "function":
                switch (o4) {
                  case "string":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ className: t4 })].concat(r3));
                    };
                  case "object":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [m2(n6)({ style: t4 })].concat(r3));
                    };
                  case "function":
                    return function(n6) {
                      for (var a2 = arguments.length, r3 = Array(a2 > 1 ? a2 - 1 : 0), o5 = 1; o5 < a2; o5++)
                        r3[o5 - 1] = arguments[o5];
                      return e5.apply(void 0, [t4.apply(void 0, [n6].concat(r3))].concat(r3));
                    };
                }
            }
          }(e4[o3], t3[o3]), n4;
        }, {});
      }, g2 = function(e4, t3) {
        for (var n3 = arguments.length, o2 = Array(n3 > 2 ? n3 - 2 : 0), s2 = 2; s2 < n3; s2++)
          o2[s2 - 2] = arguments[s2];
        if (t3 === null)
          return e4;
        Array.isArray(t3) || (t3 = [t3]);
        var c3 = t3.map(function(t4) {
          return e4[t4];
        }).filter(Boolean), l3 = c3.reduce(function(e5, t4) {
          return typeof t4 == "string" ? e5.className = [e5.className, t4].filter(Boolean).join(" ") : (t4 === void 0 ? "undefined" : (0, a.default)(t4)) === "object" ? e5.style = (0, r2.default)({}, e5.style, t4) : typeof t4 == "function" && (e5 = (0, r2.default)({}, e5, t4.apply(void 0, [e5].concat(o2)))), e5;
        }, { className: "", style: {} });
        return l3.className || delete l3.className, (0, i.default)(l3.style).length === 0 && delete l3.style, l3;
      }, E = t2.invertTheme = function(e4) {
        return (0, i.default)(e4).reduce(function(t3, n3) {
          return t3[n3] = /^base/.test(n3) ? v4(e4[n3]) : n3 === "scheme" ? e4[n3] + ":inverted" : e4[n3], t3;
        }, {});
      }, j = (t2.createStyling = (0, s.default)(function(e4) {
        for (var t3 = arguments.length, n3 = Array(t3 > 3 ? t3 - 3 : 0), a2 = 3; a2 < t3; a2++)
          n3[a2 - 3] = arguments[a2];
        var o2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, c3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, l3 = o2.defaultBase16, u2 = l3 === void 0 ? b2 : l3, f3 = o2.base16Themes, p3 = f3 === void 0 ? null : f3, d3 = j(c3, p3);
        d3 && (c3 = (0, r2.default)({}, d3, c3));
        var v5 = h.reduce(function(e5, t4) {
          return e5[t4] = c3[t4] || u2[t4], e5;
        }, {}), m3 = (0, i.default)(c3).reduce(function(e5, t4) {
          return h.indexOf(t4) === -1 ? (e5[t4] = c3[t4], e5) : e5;
        }, {}), E2 = e4(v5), x2 = y2(m3, E2);
        return (0, s.default)(g2, 2).apply(void 0, [x2].concat(n3));
      }, 3), t2.getBase16Theme = function(e4, t3) {
        if (e4 && e4.extend && (e4 = e4.extend), typeof e4 == "string") {
          var n3 = e4.split(":"), a2 = (0, o.default)(n3, 2), r3 = a2[0], i2 = a2[1];
          e4 = (t3 || {})[r3] || c2[r3], i2 === "inverted" && (e4 = E(e4));
        }
        return e4 && e4.hasOwnProperty("base00") ? e4 : void 0;
      });
    }, function(e3, t2, n2) {
      var a, r2 = typeof Reflect == "object" ? Reflect : null, o = r2 && typeof r2.apply == "function" ? r2.apply : function(e4, t3, n3) {
        return Function.prototype.apply.call(e4, t3, n3);
      };
      a = r2 && typeof r2.ownKeys == "function" ? r2.ownKeys : Object.getOwnPropertySymbols ? function(e4) {
        return Object.getOwnPropertyNames(e4).concat(Object.getOwnPropertySymbols(e4));
      } : function(e4) {
        return Object.getOwnPropertyNames(e4);
      };
      var i = Number.isNaN || function(e4) {
        return e4 != e4;
      };
      function s() {
        s.init.call(this);
      }
      e3.exports = s, e3.exports.once = function(e4, t3) {
        return new Promise(function(n3, a2) {
          function r3() {
            o2 !== void 0 && e4.removeListener("error", o2), n3([].slice.call(arguments));
          }
          var o2;
          t3 !== "error" && (o2 = function(n4) {
            e4.removeListener(t3, r3), a2(n4);
          }, e4.once("error", o2)), e4.once(t3, r3);
        });
      }, s.EventEmitter = s, s.prototype._events = void 0, s.prototype._eventsCount = 0, s.prototype._maxListeners = void 0;
      var c2 = 10;
      function l2(e4) {
        if (typeof e4 != "function")
          throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof e4);
      }
      function u(e4) {
        return e4._maxListeners === void 0 ? s.defaultMaxListeners : e4._maxListeners;
      }
      function f2(e4, t3, n3, a2) {
        var r3, o2, i2, s2;
        if (l2(n3), (o2 = e4._events) === void 0 ? (o2 = e4._events = /* @__PURE__ */ Object.create(null), e4._eventsCount = 0) : (o2.newListener !== void 0 && (e4.emit("newListener", t3, n3.listener ? n3.listener : n3), o2 = e4._events), i2 = o2[t3]), i2 === void 0)
          i2 = o2[t3] = n3, ++e4._eventsCount;
        else if (typeof i2 == "function" ? i2 = o2[t3] = a2 ? [n3, i2] : [i2, n3] : a2 ? i2.unshift(n3) : i2.push(n3), (r3 = u(e4)) > 0 && i2.length > r3 && !i2.warned) {
          i2.warned = true;
          var c3 = new Error("Possible EventEmitter memory leak detected. " + i2.length + " " + String(t3) + " listeners added. Use emitter.setMaxListeners() to increase limit");
          c3.name = "MaxListenersExceededWarning", c3.emitter = e4, c3.type = t3, c3.count = i2.length, s2 = c3, console && console.warn && console.warn(s2);
        }
        return e4;
      }
      function p2() {
        if (!this.fired)
          return this.target.removeListener(this.type, this.wrapFn), this.fired = true, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
      }
      function d2(e4, t3, n3) {
        var a2 = { fired: false, wrapFn: void 0, target: e4, type: t3, listener: n3 }, r3 = p2.bind(a2);
        return r3.listener = n3, a2.wrapFn = r3, r3;
      }
      function b2(e4, t3, n3) {
        var a2 = e4._events;
        if (a2 === void 0)
          return [];
        var r3 = a2[t3];
        return r3 === void 0 ? [] : typeof r3 == "function" ? n3 ? [r3.listener || r3] : [r3] : n3 ? function(e5) {
          for (var t4 = new Array(e5.length), n4 = 0; n4 < t4.length; ++n4)
            t4[n4] = e5[n4].listener || e5[n4];
          return t4;
        }(r3) : v4(r3, r3.length);
      }
      function h(e4) {
        var t3 = this._events;
        if (t3 !== void 0) {
          var n3 = t3[e4];
          if (typeof n3 == "function")
            return 1;
          if (n3 !== void 0)
            return n3.length;
        }
        return 0;
      }
      function v4(e4, t3) {
        for (var n3 = new Array(t3), a2 = 0; a2 < t3; ++a2)
          n3[a2] = e4[a2];
        return n3;
      }
      Object.defineProperty(s, "defaultMaxListeners", { enumerable: true, get: function() {
        return c2;
      }, set: function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        c2 = e4;
      } }), s.init = function() {
        this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
      }, s.prototype.setMaxListeners = function(e4) {
        if (typeof e4 != "number" || e4 < 0 || i(e4))
          throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + e4 + ".");
        return this._maxListeners = e4, this;
      }, s.prototype.getMaxListeners = function() {
        return u(this);
      }, s.prototype.emit = function(e4) {
        for (var t3 = [], n3 = 1; n3 < arguments.length; n3++)
          t3.push(arguments[n3]);
        var a2 = e4 === "error", r3 = this._events;
        if (r3 !== void 0)
          a2 = a2 && r3.error === void 0;
        else if (!a2)
          return false;
        if (a2) {
          var i2;
          if (t3.length > 0 && (i2 = t3[0]), i2 instanceof Error)
            throw i2;
          var s2 = new Error("Unhandled error." + (i2 ? " (" + i2.message + ")" : ""));
          throw s2.context = i2, s2;
        }
        var c3 = r3[e4];
        if (c3 === void 0)
          return false;
        if (typeof c3 == "function")
          o(c3, this, t3);
        else {
          var l3 = c3.length, u2 = v4(c3, l3);
          for (n3 = 0; n3 < l3; ++n3)
            o(u2[n3], this, t3);
        }
        return true;
      }, s.prototype.addListener = function(e4, t3) {
        return f2(this, e4, t3, false);
      }, s.prototype.on = s.prototype.addListener, s.prototype.prependListener = function(e4, t3) {
        return f2(this, e4, t3, true);
      }, s.prototype.once = function(e4, t3) {
        return l2(t3), this.on(e4, d2(this, e4, t3)), this;
      }, s.prototype.prependOnceListener = function(e4, t3) {
        return l2(t3), this.prependListener(e4, d2(this, e4, t3)), this;
      }, s.prototype.removeListener = function(e4, t3) {
        var n3, a2, r3, o2, i2;
        if (l2(t3), (a2 = this._events) === void 0)
          return this;
        if ((n3 = a2[e4]) === void 0)
          return this;
        if (n3 === t3 || n3.listener === t3)
          --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete a2[e4], a2.removeListener && this.emit("removeListener", e4, n3.listener || t3));
        else if (typeof n3 != "function") {
          for (r3 = -1, o2 = n3.length - 1; o2 >= 0; o2--)
            if (n3[o2] === t3 || n3[o2].listener === t3) {
              i2 = n3[o2].listener, r3 = o2;
              break;
            }
          if (r3 < 0)
            return this;
          r3 === 0 ? n3.shift() : function(e5, t4) {
            for (; t4 + 1 < e5.length; t4++)
              e5[t4] = e5[t4 + 1];
            e5.pop();
          }(n3, r3), n3.length === 1 && (a2[e4] = n3[0]), a2.removeListener !== void 0 && this.emit("removeListener", e4, i2 || t3);
        }
        return this;
      }, s.prototype.off = s.prototype.removeListener, s.prototype.removeAllListeners = function(e4) {
        var t3, n3, a2;
        if ((n3 = this._events) === void 0)
          return this;
        if (n3.removeListener === void 0)
          return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : n3[e4] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete n3[e4]), this;
        if (arguments.length === 0) {
          var r3, o2 = Object.keys(n3);
          for (a2 = 0; a2 < o2.length; ++a2)
            (r3 = o2[a2]) !== "removeListener" && this.removeAllListeners(r3);
          return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
        }
        if (typeof (t3 = n3[e4]) == "function")
          this.removeListener(e4, t3);
        else if (t3 !== void 0)
          for (a2 = t3.length - 1; a2 >= 0; a2--)
            this.removeListener(e4, t3[a2]);
        return this;
      }, s.prototype.listeners = function(e4) {
        return b2(this, e4, true);
      }, s.prototype.rawListeners = function(e4) {
        return b2(this, e4, false);
      }, s.listenerCount = function(e4, t3) {
        return typeof e4.listenerCount == "function" ? e4.listenerCount(t3) : h.call(e4, t3);
      }, s.prototype.listenerCount = h, s.prototype.eventNames = function() {
        return this._eventsCount > 0 ? a(this._events) : [];
      };
    }, function(e3, t2, n2) {
      e3.exports.Dispatcher = n2(140);
    }, function(e3, t2, n2) {
      e3.exports = n2(142);
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = i(n2(50)), r2 = i(n2(65)), o = typeof r2.default == "function" && typeof a.default == "symbol" ? function(e4) {
        return typeof e4;
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : typeof e4;
      };
      function i(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = typeof r2.default == "function" && o(a.default) === "symbol" ? function(e4) {
        return e4 === void 0 ? "undefined" : o(e4);
      } : function(e4) {
        return e4 && typeof r2.default == "function" && e4.constructor === r2.default && e4 !== r2.default.prototype ? "symbol" : e4 === void 0 ? "undefined" : o(e4);
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(51), __esModule: true };
    }, function(e3, t2, n2) {
      n2(20), n2(29), e3.exports = n2(30).f("iterator");
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = n2(22);
      e3.exports = function(e4) {
        return function(t3, n3) {
          var o, i, s = String(r2(t3)), c2 = a(n3), l2 = s.length;
          return c2 < 0 || c2 >= l2 ? e4 ? "" : void 0 : (o = s.charCodeAt(c2)) < 55296 || o > 56319 || c2 + 1 === l2 || (i = s.charCodeAt(c2 + 1)) < 56320 || i > 57343 ? e4 ? s.charAt(c2) : o : e4 ? s.slice(c2, c2 + 2) : i - 56320 + (o - 55296 << 10) + 65536;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(54);
      e3.exports = function(e4, t3, n3) {
        if (a(e4), t3 === void 0)
          return e4;
        switch (n3) {
          case 1:
            return function(n4) {
              return e4.call(t3, n4);
            };
          case 2:
            return function(n4, a2) {
              return e4.call(t3, n4, a2);
            };
          case 3:
            return function(n4, a2, r2) {
              return e4.call(t3, n4, a2, r2);
            };
        }
        return function() {
          return e4.apply(t3, arguments);
        };
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        if (typeof e4 != "function")
          throw TypeError(e4 + " is not a function!");
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(38), r2 = n2(16), o = n2(28), i = {};
      n2(6)(i, n2(2)("iterator"), function() {
        return this;
      }), e3.exports = function(e4, t3, n3) {
        e4.prototype = a(i, { next: r2(1, n3) }), o(e4, t3 + " Iterator");
      };
    }, function(e3, t2, n2) {
      var a = n2(7), r2 = n2(10), o = n2(13);
      e3.exports = n2(4) ? Object.defineProperties : function(e4, t3) {
        r2(e4);
        for (var n3, i = o(t3), s = i.length, c2 = 0; s > c2; )
          a.f(e4, n3 = i[c2++], t3[n3]);
        return e4;
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(58), o = n2(59);
      e3.exports = function(e4) {
        return function(t3, n3, i) {
          var s, c2 = a(t3), l2 = r2(c2.length), u = o(i, l2);
          if (e4 && n3 != n3) {
            for (; l2 > u; )
              if ((s = c2[u++]) != s)
                return true;
          } else
            for (; l2 > u; u++)
              if ((e4 || u in c2) && c2[u] === n3)
                return e4 || u || 0;
          return !e4 && -1;
        };
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.min;
      e3.exports = function(e4) {
        return e4 > 0 ? r2(a(e4), 9007199254740991) : 0;
      };
    }, function(e3, t2, n2) {
      var a = n2(21), r2 = Math.max, o = Math.min;
      e3.exports = function(e4, t3) {
        return (e4 = a(e4)) < 0 ? r2(e4 + t3, 0) : o(e4, t3);
      };
    }, function(e3, t2, n2) {
      var a = n2(3).document;
      e3.exports = a && a.documentElement;
    }, function(e3, t2, n2) {
      var a = n2(5), r2 = n2(18), o = n2(25)("IE_PROTO"), i = Object.prototype;
      e3.exports = Object.getPrototypeOf || function(e4) {
        return e4 = r2(e4), a(e4, o) ? e4[o] : typeof e4.constructor == "function" && e4 instanceof e4.constructor ? e4.constructor.prototype : e4 instanceof Object ? i : null;
      };
    }, function(e3, t2, n2) {
      var a = n2(63), r2 = n2(64), o = n2(12), i = n2(9);
      e3.exports = n2(34)(Array, "Array", function(e4, t3) {
        this._t = i(e4), this._i = 0, this._k = t3;
      }, function() {
        var e4 = this._t, t3 = this._k, n3 = this._i++;
        return !e4 || n3 >= e4.length ? (this._t = void 0, r2(1)) : r2(0, t3 == "keys" ? n3 : t3 == "values" ? e4[n3] : [n3, e4[n3]]);
      }, "values"), o.Arguments = o.Array, a("keys"), a("values"), a("entries");
    }, function(e3, t2) {
      e3.exports = function() {
      };
    }, function(e3, t2) {
      e3.exports = function(e4, t3) {
        return { value: t3, done: !!e4 };
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(66), __esModule: true };
    }, function(e3, t2, n2) {
      n2(67), n2(73), n2(74), n2(75), e3.exports = n2(1).Symbol;
    }, function(e3, t2, n2) {
      var a = n2(3), r2 = n2(5), o = n2(4), i = n2(15), s = n2(37), c2 = n2(68).KEY, l2 = n2(8), u = n2(26), f2 = n2(28), p2 = n2(17), d2 = n2(2), b2 = n2(30), h = n2(31), v4 = n2(69), m2 = n2(70), y2 = n2(10), g2 = n2(11), E = n2(18), j = n2(9), x2 = n2(23), _ = n2(16), k2 = n2(38), O = n2(71), C = n2(72), S = n2(32), w2 = n2(7), A2 = n2(13), M = C.f, P = w2.f, F = O.f, D = a.Symbol, I = a.JSON, R = I && I.stringify, L = d2("_hidden"), B = d2("toPrimitive"), N = {}.propertyIsEnumerable, z2 = u("symbol-registry"), T = u("symbols"), q2 = u("op-symbols"), V = Object.prototype, K = typeof D == "function" && !!S.f, W = a.QObject, H = !W || !W.prototype || !W.prototype.findChild, U = o && l2(function() {
        return k2(P({}, "a", { get: function() {
          return P(this, "a", { value: 7 }).a;
        } })).a != 7;
      }) ? function(e4, t3, n3) {
        var a2 = M(V, t3);
        a2 && delete V[t3], P(e4, t3, n3), a2 && e4 !== V && P(V, t3, a2);
      } : P, G = function(e4) {
        var t3 = T[e4] = k2(D.prototype);
        return t3._k = e4, t3;
      }, J = K && typeof D.iterator == "symbol" ? function(e4) {
        return typeof e4 == "symbol";
      } : function(e4) {
        return e4 instanceof D;
      }, Y = function(e4, t3, n3) {
        return e4 === V && Y(q2, t3, n3), y2(e4), t3 = x2(t3, true), y2(n3), r2(T, t3) ? (n3.enumerable ? (r2(e4, L) && e4[L][t3] && (e4[L][t3] = false), n3 = k2(n3, { enumerable: _(0, false) })) : (r2(e4, L) || P(e4, L, _(1, {})), e4[L][t3] = true), U(e4, t3, n3)) : P(e4, t3, n3);
      }, $ = function(e4, t3) {
        y2(e4);
        for (var n3, a2 = v4(t3 = j(t3)), r3 = 0, o2 = a2.length; o2 > r3; )
          Y(e4, n3 = a2[r3++], t3[n3]);
        return e4;
      }, Q = function(e4) {
        var t3 = N.call(this, e4 = x2(e4, true));
        return !(this === V && r2(T, e4) && !r2(q2, e4)) && (!(t3 || !r2(this, e4) || !r2(T, e4) || r2(this, L) && this[L][e4]) || t3);
      }, Z = function(e4, t3) {
        if (e4 = j(e4), t3 = x2(t3, true), e4 !== V || !r2(T, t3) || r2(q2, t3)) {
          var n3 = M(e4, t3);
          return !n3 || !r2(T, t3) || r2(e4, L) && e4[L][t3] || (n3.enumerable = true), n3;
        }
      }, X = function(e4) {
        for (var t3, n3 = F(j(e4)), a2 = [], o2 = 0; n3.length > o2; )
          r2(T, t3 = n3[o2++]) || t3 == L || t3 == c2 || a2.push(t3);
        return a2;
      }, ee = function(e4) {
        for (var t3, n3 = e4 === V, a2 = F(n3 ? q2 : j(e4)), o2 = [], i2 = 0; a2.length > i2; )
          !r2(T, t3 = a2[i2++]) || n3 && !r2(V, t3) || o2.push(T[t3]);
        return o2;
      };
      K || (s((D = function() {
        if (this instanceof D)
          throw TypeError("Symbol is not a constructor!");
        var e4 = p2(arguments.length > 0 ? arguments[0] : void 0), t3 = function(n3) {
          this === V && t3.call(q2, n3), r2(this, L) && r2(this[L], e4) && (this[L][e4] = false), U(this, e4, _(1, n3));
        };
        return o && H && U(V, e4, { configurable: true, set: t3 }), G(e4);
      }).prototype, "toString", function() {
        return this._k;
      }), C.f = Z, w2.f = Y, n2(41).f = O.f = X, n2(19).f = Q, S.f = ee, o && !n2(14) && s(V, "propertyIsEnumerable", Q, true), b2.f = function(e4) {
        return G(d2(e4));
      }), i(i.G + i.W + i.F * !K, { Symbol: D });
      for (var te = "hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","), ne = 0; te.length > ne; )
        d2(te[ne++]);
      for (var ae = A2(d2.store), re = 0; ae.length > re; )
        h(ae[re++]);
      i(i.S + i.F * !K, "Symbol", { for: function(e4) {
        return r2(z2, e4 += "") ? z2[e4] : z2[e4] = D(e4);
      }, keyFor: function(e4) {
        if (!J(e4))
          throw TypeError(e4 + " is not a symbol!");
        for (var t3 in z2)
          if (z2[t3] === e4)
            return t3;
      }, useSetter: function() {
        H = true;
      }, useSimple: function() {
        H = false;
      } }), i(i.S + i.F * !K, "Object", { create: function(e4, t3) {
        return t3 === void 0 ? k2(e4) : $(k2(e4), t3);
      }, defineProperty: Y, defineProperties: $, getOwnPropertyDescriptor: Z, getOwnPropertyNames: X, getOwnPropertySymbols: ee });
      var oe = l2(function() {
        S.f(1);
      });
      i(i.S + i.F * oe, "Object", { getOwnPropertySymbols: function(e4) {
        return S.f(E(e4));
      } }), I && i(i.S + i.F * (!K || l2(function() {
        var e4 = D();
        return R([e4]) != "[null]" || R({ a: e4 }) != "{}" || R(Object(e4)) != "{}";
      })), "JSON", { stringify: function(e4) {
        for (var t3, n3, a2 = [e4], r3 = 1; arguments.length > r3; )
          a2.push(arguments[r3++]);
        if (n3 = t3 = a2[1], (g2(t3) || e4 !== void 0) && !J(e4))
          return m2(t3) || (t3 = function(e5, t4) {
            if (typeof n3 == "function" && (t4 = n3.call(this, e5, t4)), !J(t4))
              return t4;
          }), a2[1] = t3, R.apply(I, a2);
      } }), D.prototype[B] || n2(6)(D.prototype, B, D.prototype.valueOf), f2(D, "Symbol"), f2(Math, "Math", true), f2(a.JSON, "JSON", true);
    }, function(e3, t2, n2) {
      var a = n2(17)("meta"), r2 = n2(11), o = n2(5), i = n2(7).f, s = 0, c2 = Object.isExtensible || function() {
        return true;
      }, l2 = !n2(8)(function() {
        return c2(Object.preventExtensions({}));
      }), u = function(e4) {
        i(e4, a, { value: { i: "O" + ++s, w: {} } });
      }, f2 = e3.exports = { KEY: a, NEED: false, fastKey: function(e4, t3) {
        if (!r2(e4))
          return typeof e4 == "symbol" ? e4 : (typeof e4 == "string" ? "S" : "P") + e4;
        if (!o(e4, a)) {
          if (!c2(e4))
            return "F";
          if (!t3)
            return "E";
          u(e4);
        }
        return e4[a].i;
      }, getWeak: function(e4, t3) {
        if (!o(e4, a)) {
          if (!c2(e4))
            return true;
          if (!t3)
            return false;
          u(e4);
        }
        return e4[a].w;
      }, onFreeze: function(e4) {
        return l2 && f2.NEED && c2(e4) && !o(e4, a) && u(e4), e4;
      } };
    }, function(e3, t2, n2) {
      var a = n2(13), r2 = n2(32), o = n2(19);
      e3.exports = function(e4) {
        var t3 = a(e4), n3 = r2.f;
        if (n3)
          for (var i, s = n3(e4), c2 = o.f, l2 = 0; s.length > l2; )
            c2.call(e4, i = s[l2++]) && t3.push(i);
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(24);
      e3.exports = Array.isArray || function(e4) {
        return a(e4) == "Array";
      };
    }, function(e3, t2, n2) {
      var a = n2(9), r2 = n2(41).f, o = {}.toString, i = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [];
      e3.exports.f = function(e4) {
        return i && o.call(e4) == "[object Window]" ? function(e5) {
          try {
            return r2(e5);
          } catch (e6) {
            return i.slice();
          }
        }(e4) : r2(a(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(19), r2 = n2(16), o = n2(9), i = n2(23), s = n2(5), c2 = n2(35), l2 = Object.getOwnPropertyDescriptor;
      t2.f = n2(4) ? l2 : function(e4, t3) {
        if (e4 = o(e4), t3 = i(t3, true), c2)
          try {
            return l2(e4, t3);
          } catch (e5) {
          }
        if (s(e4, t3))
          return r2(!a.f.call(e4, t3), e4[t3]);
      };
    }, function(e3, t2) {
    }, function(e3, t2, n2) {
      n2(31)("asyncIterator");
    }, function(e3, t2, n2) {
      n2(31)("observable");
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a, r2 = n2(77), o = (a = r2) && a.__esModule ? a : { default: a };
      t2.default = o.default || function(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3];
          for (var a2 in n3)
            Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
        }
        return e4;
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(78), __esModule: true };
    }, function(e3, t2, n2) {
      n2(79), e3.exports = n2(1).Object.assign;
    }, function(e3, t2, n2) {
      var a = n2(15);
      a(a.S + a.F, "Object", { assign: n2(80) });
    }, function(e3, t2, n2) {
      var a = n2(4), r2 = n2(13), o = n2(32), i = n2(19), s = n2(18), c2 = n2(40), l2 = Object.assign;
      e3.exports = !l2 || n2(8)(function() {
        var e4 = {}, t3 = {}, n3 = Symbol(), a2 = "abcdefghijklmnopqrst";
        return e4[n3] = 7, a2.split("").forEach(function(e5) {
          t3[e5] = e5;
        }), l2({}, e4)[n3] != 7 || Object.keys(l2({}, t3)).join("") != a2;
      }) ? function(e4, t3) {
        for (var n3 = s(e4), l3 = arguments.length, u = 1, f2 = o.f, p2 = i.f; l3 > u; )
          for (var d2, b2 = c2(arguments[u++]), h = f2 ? r2(b2).concat(f2(b2)) : r2(b2), v4 = h.length, m2 = 0; v4 > m2; )
            d2 = h[m2++], a && !p2.call(b2, d2) || (n3[d2] = b2[d2]);
        return n3;
      } : l2;
    }, function(e3, t2, n2) {
      t2.__esModule = true;
      var a = o(n2(82)), r2 = o(n2(85));
      function o(e4) {
        return e4 && e4.__esModule ? e4 : { default: e4 };
      }
      t2.default = function(e4, t3) {
        if (Array.isArray(e4))
          return e4;
        if ((0, a.default)(Object(e4)))
          return function(e5, t4) {
            var n3 = [], a2 = true, o2 = false, i = void 0;
            try {
              for (var s, c2 = (0, r2.default)(e5); !(a2 = (s = c2.next()).done) && (n3.push(s.value), !t4 || n3.length !== t4); a2 = true)
                ;
            } catch (e6) {
              o2 = true, i = e6;
            } finally {
              try {
                !a2 && c2.return && c2.return();
              } finally {
                if (o2)
                  throw i;
              }
            }
            return n3;
          }(e4, t3);
        throw new TypeError("Invalid attempt to destructure non-iterable instance");
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(83), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(84);
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).isIterable = function(e4) {
        var t3 = Object(e4);
        return t3[r2] !== void 0 || "@@iterator" in t3 || o.hasOwnProperty(a(t3));
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(86), __esModule: true };
    }, function(e3, t2, n2) {
      n2(29), n2(20), e3.exports = n2(87);
    }, function(e3, t2, n2) {
      var a = n2(10), r2 = n2(88);
      e3.exports = n2(1).getIterator = function(e4) {
        var t3 = r2(e4);
        if (typeof t3 != "function")
          throw TypeError(e4 + " is not iterable!");
        return a(t3.call(e4));
      };
    }, function(e3, t2, n2) {
      var a = n2(42), r2 = n2(2)("iterator"), o = n2(12);
      e3.exports = n2(1).getIteratorMethod = function(e4) {
        if (e4 != null)
          return e4[r2] || e4["@@iterator"] || o[a(e4)];
      };
    }, function(e3, t2, n2) {
      e3.exports = { default: n2(90), __esModule: true };
    }, function(e3, t2, n2) {
      n2(91), e3.exports = n2(1).Object.keys;
    }, function(e3, t2, n2) {
      var a = n2(18), r2 = n2(13);
      n2(92)("keys", function() {
        return function(e4) {
          return r2(a(e4));
        };
      });
    }, function(e3, t2, n2) {
      var a = n2(15), r2 = n2(1), o = n2(8);
      e3.exports = function(e4, t3) {
        var n3 = (r2.Object || {})[e4] || Object[e4], i = {};
        i[e4] = t3(n3), a(a.S + a.F * o(function() {
          n3(1);
        }), "Object", i);
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = [["ary", 128], ["bind", 1], ["bindKey", 2], ["curry", 8], ["curryRight", 16], ["flip", 512], ["partial", 32], ["partialRight", 64], ["rearg", 256]], a = /^\s+|\s+$/g, r2 = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, o = /\{\n\/\* \[wrapped with (.+)\] \*/, i = /,? & /, s = /^[-+]0x[0-9a-f]+$/i, c2 = /^0b[01]+$/i, l2 = /^\[object .+?Constructor\]$/, u = /^0o[0-7]+$/i, f2 = /^(?:0|[1-9]\d*)$/, p2 = parseInt, d2 = typeof t3 == "object" && t3 && t3.Object === Object && t3, b2 = typeof self == "object" && self && self.Object === Object && self, h = d2 || b2 || Function("return this")();
        function v4(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function m2(e4, t4) {
          return !!(e4 ? e4.length : 0) && function(e5, t5, n4) {
            if (t5 != t5)
              return function(e6, t6, n5, a3) {
                var r4 = e6.length, o2 = n5 + (a3 ? 1 : -1);
                for (; a3 ? o2-- : ++o2 < r4; )
                  if (t6(e6[o2], o2, e6))
                    return o2;
                return -1;
              }(e5, y2, n4);
            var a2 = n4 - 1, r3 = e5.length;
            for (; ++a2 < r3; )
              if (e5[a2] === t5)
                return a2;
            return -1;
          }(e4, t4, 0) > -1;
        }
        function y2(e4) {
          return e4 != e4;
        }
        function g2(e4, t4) {
          for (var n4 = e4.length, a2 = 0; n4--; )
            e4[n4] === t4 && a2++;
          return a2;
        }
        function E(e4, t4) {
          for (var n4 = -1, a2 = e4.length, r3 = 0, o2 = []; ++n4 < a2; ) {
            var i2 = e4[n4];
            i2 !== t4 && i2 !== "__lodash_placeholder__" || (e4[n4] = "__lodash_placeholder__", o2[r3++] = n4);
          }
          return o2;
        }
        var j, x2, _, k2 = Function.prototype, O = Object.prototype, C = h["__core-js_shared__"], S = (j = /[^.]+$/.exec(C && C.keys && C.keys.IE_PROTO || "")) ? "Symbol(src)_1." + j : "", w2 = k2.toString, A2 = O.hasOwnProperty, M = O.toString, P = RegExp("^" + w2.call(A2).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), F = Object.create, D = Math.max, I = Math.min, R = (x2 = H(Object, "defineProperty"), (_ = H.name) && _.length > 2 ? x2 : void 0);
        function L(e4) {
          return X(e4) ? F(e4) : {};
        }
        function B(e4) {
          return !(!X(e4) || function(e5) {
            return !!S && S in e5;
          }(e4)) && (function(e5) {
            var t4 = X(e5) ? M.call(e5) : "";
            return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
          }(e4) || function(e5) {
            var t4 = false;
            if (e5 != null && typeof e5.toString != "function")
              try {
                t4 = !!(e5 + "");
              } catch (e6) {
              }
            return t4;
          }(e4) ? P : l2).test(function(e5) {
            if (e5 != null) {
              try {
                return w2.call(e5);
              } catch (e6) {
              }
              try {
                return e5 + "";
              } catch (e6) {
              }
            }
            return "";
          }(e4));
        }
        function N(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = n4.length, s2 = -1, c3 = t4.length, l3 = D(o2 - i2, 0), u2 = Array(c3 + l3), f3 = !a2; ++s2 < c3; )
            u2[s2] = t4[s2];
          for (; ++r3 < i2; )
            (f3 || r3 < o2) && (u2[n4[r3]] = e4[r3]);
          for (; l3--; )
            u2[s2++] = e4[r3++];
          return u2;
        }
        function z2(e4, t4, n4, a2) {
          for (var r3 = -1, o2 = e4.length, i2 = -1, s2 = n4.length, c3 = -1, l3 = t4.length, u2 = D(o2 - s2, 0), f3 = Array(u2 + l3), p3 = !a2; ++r3 < u2; )
            f3[r3] = e4[r3];
          for (var d3 = r3; ++c3 < l3; )
            f3[d3 + c3] = t4[c3];
          for (; ++i2 < s2; )
            (p3 || r3 < o2) && (f3[d3 + n4[i2]] = e4[r3++]);
          return f3;
        }
        function T(e4) {
          return function() {
            var t4 = arguments;
            switch (t4.length) {
              case 0:
                return new e4();
              case 1:
                return new e4(t4[0]);
              case 2:
                return new e4(t4[0], t4[1]);
              case 3:
                return new e4(t4[0], t4[1], t4[2]);
              case 4:
                return new e4(t4[0], t4[1], t4[2], t4[3]);
              case 5:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4]);
              case 6:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5]);
              case 7:
                return new e4(t4[0], t4[1], t4[2], t4[3], t4[4], t4[5], t4[6]);
            }
            var n4 = L(e4.prototype), a2 = e4.apply(n4, t4);
            return X(a2) ? a2 : n4;
          };
        }
        function q2(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 128 & t4, f3 = 1 & t4, p3 = 2 & t4, d3 = 24 & t4, b3 = 512 & t4, v5 = p3 ? void 0 : T(e4);
          return function m3() {
            for (var y3 = arguments.length, j2 = Array(y3), x3 = y3; x3--; )
              j2[x3] = arguments[x3];
            if (d3)
              var _2 = W(m3), k3 = g2(j2, _2);
            if (a2 && (j2 = N(j2, a2, r3, d3)), o2 && (j2 = z2(j2, o2, i2, d3)), y3 -= k3, d3 && y3 < l3) {
              var O2 = E(j2, _2);
              return V(e4, t4, q2, m3.placeholder, n4, j2, O2, s2, c3, l3 - y3);
            }
            var C2 = f3 ? n4 : this, S2 = p3 ? C2[e4] : e4;
            return y3 = j2.length, s2 ? j2 = Y(j2, s2) : b3 && y3 > 1 && j2.reverse(), u2 && c3 < y3 && (j2.length = c3), this && this !== h && this instanceof m3 && (S2 = v5 || T(S2)), S2.apply(C2, j2);
          };
        }
        function V(e4, t4, n4, a2, r3, o2, i2, s2, c3, l3) {
          var u2 = 8 & t4;
          t4 |= u2 ? 32 : 64, 4 & (t4 &= ~(u2 ? 64 : 32)) || (t4 &= -4);
          var f3 = n4(e4, t4, r3, u2 ? o2 : void 0, u2 ? i2 : void 0, u2 ? void 0 : o2, u2 ? void 0 : i2, s2, c3, l3);
          return f3.placeholder = a2, $(f3, e4, t4);
        }
        function K(e4, t4, n4, a2, r3, o2, i2, s2) {
          var c3 = 2 & t4;
          if (!c3 && typeof e4 != "function")
            throw new TypeError("Expected a function");
          var l3 = a2 ? a2.length : 0;
          if (l3 || (t4 &= -97, a2 = r3 = void 0), i2 = i2 === void 0 ? i2 : D(te(i2), 0), s2 = s2 === void 0 ? s2 : te(s2), l3 -= r3 ? r3.length : 0, 64 & t4) {
            var u2 = a2, f3 = r3;
            a2 = r3 = void 0;
          }
          var p3 = [e4, t4, n4, a2, r3, u2, f3, o2, i2, s2];
          if (e4 = p3[0], t4 = p3[1], n4 = p3[2], a2 = p3[3], r3 = p3[4], !(s2 = p3[9] = p3[9] == null ? c3 ? 0 : e4.length : D(p3[9] - l3, 0)) && 24 & t4 && (t4 &= -25), t4 && t4 != 1)
            d3 = t4 == 8 || t4 == 16 ? function(e5, t5, n5) {
              var a3 = T(e5);
              return function r4() {
                for (var o3 = arguments.length, i3 = Array(o3), s3 = o3, c4 = W(r4); s3--; )
                  i3[s3] = arguments[s3];
                var l4 = o3 < 3 && i3[0] !== c4 && i3[o3 - 1] !== c4 ? [] : E(i3, c4);
                if ((o3 -= l4.length) < n5)
                  return V(e5, t5, q2, r4.placeholder, void 0, i3, l4, void 0, void 0, n5 - o3);
                var u3 = this && this !== h && this instanceof r4 ? a3 : e5;
                return v4(u3, this, i3);
              };
            }(e4, t4, s2) : t4 != 32 && t4 != 33 || r3.length ? q2.apply(void 0, p3) : function(e5, t5, n5, a3) {
              var r4 = 1 & t5, o3 = T(e5);
              return function t6() {
                for (var i3 = -1, s3 = arguments.length, c4 = -1, l4 = a3.length, u3 = Array(l4 + s3), f4 = this && this !== h && this instanceof t6 ? o3 : e5; ++c4 < l4; )
                  u3[c4] = a3[c4];
                for (; s3--; )
                  u3[c4++] = arguments[++i3];
                return v4(f4, r4 ? n5 : this, u3);
              };
            }(e4, t4, n4, a2);
          else
            var d3 = function(e5, t5, n5) {
              var a3 = 1 & t5, r4 = T(e5);
              return function t6() {
                var o3 = this && this !== h && this instanceof t6 ? r4 : e5;
                return o3.apply(a3 ? n5 : this, arguments);
              };
            }(e4, t4, n4);
          return $(d3, e4, t4);
        }
        function W(e4) {
          return e4.placeholder;
        }
        function H(e4, t4) {
          var n4 = function(e5, t5) {
            return e5 == null ? void 0 : e5[t5];
          }(e4, t4);
          return B(n4) ? n4 : void 0;
        }
        function U(e4) {
          var t4 = e4.match(o);
          return t4 ? t4[1].split(i) : [];
        }
        function G(e4, t4) {
          var n4 = t4.length, a2 = n4 - 1;
          return t4[a2] = (n4 > 1 ? "& " : "") + t4[a2], t4 = t4.join(n4 > 2 ? ", " : " "), e4.replace(r2, "{\n/* [wrapped with " + t4 + "] */\n");
        }
        function J(e4, t4) {
          return !!(t4 = t4 == null ? 9007199254740991 : t4) && (typeof e4 == "number" || f2.test(e4)) && e4 > -1 && e4 % 1 == 0 && e4 < t4;
        }
        function Y(e4, t4) {
          for (var n4 = e4.length, a2 = I(t4.length, n4), r3 = function(e5, t5) {
            var n5 = -1, a3 = e5.length;
            for (t5 || (t5 = Array(a3)); ++n5 < a3; )
              t5[n5] = e5[n5];
            return t5;
          }(e4); a2--; ) {
            var o2 = t4[a2];
            e4[a2] = J(o2, n4) ? r3[o2] : void 0;
          }
          return e4;
        }
        var $ = R ? function(e4, t4, n4) {
          var a2, r3 = t4 + "";
          return R(e4, "toString", { configurable: true, enumerable: false, value: (a2 = G(r3, Q(U(r3), n4)), function() {
            return a2;
          }) });
        } : function(e4) {
          return e4;
        };
        function Q(e4, t4) {
          return function(e5, t5) {
            for (var n4 = -1, a2 = e5 ? e5.length : 0; ++n4 < a2 && t5(e5[n4], n4, e5) !== false; )
              ;
          }(n3, function(n4) {
            var a2 = "_." + n4[0];
            t4 & n4[1] && !m2(e4, a2) && e4.push(a2);
          }), e4.sort();
        }
        function Z(e4, t4, n4) {
          var a2 = K(e4, 8, void 0, void 0, void 0, void 0, void 0, t4 = n4 ? void 0 : t4);
          return a2.placeholder = Z.placeholder, a2;
        }
        function X(e4) {
          var t4 = typeof e4;
          return !!e4 && (t4 == "object" || t4 == "function");
        }
        function ee(e4) {
          return e4 ? (e4 = function(e5) {
            if (typeof e5 == "number")
              return e5;
            if (function(e6) {
              return typeof e6 == "symbol" || function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && M.call(e6) == "[object Symbol]";
            }(e5))
              return NaN;
            if (X(e5)) {
              var t4 = typeof e5.valueOf == "function" ? e5.valueOf() : e5;
              e5 = X(t4) ? t4 + "" : t4;
            }
            if (typeof e5 != "string")
              return e5 === 0 ? e5 : +e5;
            e5 = e5.replace(a, "");
            var n4 = c2.test(e5);
            return n4 || u.test(e5) ? p2(e5.slice(2), n4 ? 2 : 8) : s.test(e5) ? NaN : +e5;
          }(e4)) === 1 / 0 || e4 === -1 / 0 ? 17976931348623157e292 * (e4 < 0 ? -1 : 1) : e4 == e4 ? e4 : 0 : e4 === 0 ? e4 : 0;
        }
        function te(e4) {
          var t4 = ee(e4), n4 = t4 % 1;
          return t4 == t4 ? n4 ? t4 - n4 : t4 : 0;
        }
        Z.placeholder = {}, e3.exports = Z;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      function a(e4) {
        return e4 && e4.__esModule ? e4.default : e4;
      }
      t2.__esModule = true;
      var r2 = n2(95);
      t2.threezerotwofour = a(r2);
      var o = n2(96);
      t2.apathy = a(o);
      var i = n2(97);
      t2.ashes = a(i);
      var s = n2(98);
      t2.atelierDune = a(s);
      var c2 = n2(99);
      t2.atelierForest = a(c2);
      var l2 = n2(100);
      t2.atelierHeath = a(l2);
      var u = n2(101);
      t2.atelierLakeside = a(u);
      var f2 = n2(102);
      t2.atelierSeaside = a(f2);
      var p2 = n2(103);
      t2.bespin = a(p2);
      var d2 = n2(104);
      t2.brewer = a(d2);
      var b2 = n2(105);
      t2.bright = a(b2);
      var h = n2(106);
      t2.chalk = a(h);
      var v4 = n2(107);
      t2.codeschool = a(v4);
      var m2 = n2(108);
      t2.colors = a(m2);
      var y2 = n2(109);
      t2.default = a(y2);
      var g2 = n2(110);
      t2.eighties = a(g2);
      var E = n2(111);
      t2.embers = a(E);
      var j = n2(112);
      t2.flat = a(j);
      var x2 = n2(113);
      t2.google = a(x2);
      var _ = n2(114);
      t2.grayscale = a(_);
      var k2 = n2(115);
      t2.greenscreen = a(k2);
      var O = n2(116);
      t2.harmonic = a(O);
      var C = n2(117);
      t2.hopscotch = a(C);
      var S = n2(118);
      t2.isotope = a(S);
      var w2 = n2(119);
      t2.marrakesh = a(w2);
      var A2 = n2(120);
      t2.mocha = a(A2);
      var M = n2(121);
      t2.monokai = a(M);
      var P = n2(122);
      t2.ocean = a(P);
      var F = n2(123);
      t2.paraiso = a(F);
      var D = n2(124);
      t2.pop = a(D);
      var I = n2(125);
      t2.railscasts = a(I);
      var R = n2(126);
      t2.shapeshifter = a(R);
      var L = n2(127);
      t2.solarized = a(L);
      var B = n2(128);
      t2.summerfruit = a(B);
      var N = n2(129);
      t2.tomorrow = a(N);
      var z2 = n2(130);
      t2.tube = a(z2);
      var T = n2(131);
      t2.twilight = a(T);
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "threezerotwofour", author: "jan t. sott (http://github.com/idleberg)", base00: "#090300", base01: "#3a3432", base02: "#4a4543", base03: "#5c5855", base04: "#807d7c", base05: "#a5a2a2", base06: "#d6d5d4", base07: "#f7f7f7", base08: "#db2d20", base09: "#e8bbd0", base0A: "#fded02", base0B: "#01a252", base0C: "#b5e4f4", base0D: "#01a0e4", base0E: "#a16a94", base0F: "#cdab53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "apathy", author: "jannik siebert (https://github.com/janniks)", base00: "#031A16", base01: "#0B342D", base02: "#184E45", base03: "#2B685E", base04: "#5F9C92", base05: "#81B5AC", base06: "#A7CEC8", base07: "#D2E7E4", base08: "#3E9688", base09: "#3E7996", base0A: "#3E4C96", base0B: "#883E96", base0C: "#963E4C", base0D: "#96883E", base0E: "#4C963E", base0F: "#3E965B" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ashes", author: "jannik siebert (https://github.com/janniks)", base00: "#1C2023", base01: "#393F45", base02: "#565E65", base03: "#747C84", base04: "#ADB3BA", base05: "#C7CCD1", base06: "#DFE2E5", base07: "#F3F4F5", base08: "#C7AE95", base09: "#C7C795", base0A: "#AEC795", base0B: "#95C7AE", base0C: "#95AEC7", base0D: "#AE95C7", base0E: "#C795AE", base0F: "#C79595" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier dune", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/dune)", base00: "#20201d", base01: "#292824", base02: "#6e6b5e", base03: "#7d7a68", base04: "#999580", base05: "#a6a28c", base06: "#e8e4cf", base07: "#fefbec", base08: "#d73737", base09: "#b65611", base0A: "#cfb017", base0B: "#60ac39", base0C: "#1fad83", base0D: "#6684e1", base0E: "#b854d4", base0F: "#d43552" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier forest", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/forest)", base00: "#1b1918", base01: "#2c2421", base02: "#68615e", base03: "#766e6b", base04: "#9c9491", base05: "#a8a19f", base06: "#e6e2e0", base07: "#f1efee", base08: "#f22c40", base09: "#df5320", base0A: "#d5911a", base0B: "#5ab738", base0C: "#00ad9c", base0D: "#407ee7", base0E: "#6666ea", base0F: "#c33ff3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier heath", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/heath)", base00: "#1b181b", base01: "#292329", base02: "#695d69", base03: "#776977", base04: "#9e8f9e", base05: "#ab9bab", base06: "#d8cad8", base07: "#f7f3f7", base08: "#ca402b", base09: "#a65926", base0A: "#bb8a35", base0B: "#379a37", base0C: "#159393", base0D: "#516aec", base0E: "#7b59c0", base0F: "#cc33cc" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier lakeside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/lakeside/)", base00: "#161b1d", base01: "#1f292e", base02: "#516d7b", base03: "#5a7b8c", base04: "#7195a8", base05: "#7ea2b4", base06: "#c1e4f6", base07: "#ebf8ff", base08: "#d22d72", base09: "#935c25", base0A: "#8a8a0f", base0B: "#568c3b", base0C: "#2d8f6f", base0D: "#257fad", base0E: "#5d5db1", base0F: "#b72dd2" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "atelier seaside", author: "bram de haan (http://atelierbram.github.io/syntax-highlighting/atelier-schemes/seaside/)", base00: "#131513", base01: "#242924", base02: "#5e6e5e", base03: "#687d68", base04: "#809980", base05: "#8ca68c", base06: "#cfe8cf", base07: "#f0fff0", base08: "#e6193c", base09: "#87711d", base0A: "#c3c322", base0B: "#29a329", base0C: "#1999b3", base0D: "#3d62f5", base0E: "#ad2bee", base0F: "#e619c3" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bespin", author: "jan t. sott", base00: "#28211c", base01: "#36312e", base02: "#5e5d5c", base03: "#666666", base04: "#797977", base05: "#8a8986", base06: "#9d9b97", base07: "#baae9e", base08: "#cf6a4c", base09: "#cf7d34", base0A: "#f9ee98", base0B: "#54be0d", base0C: "#afc4db", base0D: "#5ea6ea", base0E: "#9b859d", base0F: "#937121" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "brewer", author: "timoth\xE9e poisot (http://github.com/tpoisot)", base00: "#0c0d0e", base01: "#2e2f30", base02: "#515253", base03: "#737475", base04: "#959697", base05: "#b7b8b9", base06: "#dadbdc", base07: "#fcfdfe", base08: "#e31a1c", base09: "#e6550d", base0A: "#dca060", base0B: "#31a354", base0C: "#80b1d3", base0D: "#3182bd", base0E: "#756bb1", base0F: "#b15928" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "bright", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#303030", base02: "#505050", base03: "#b0b0b0", base04: "#d0d0d0", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ffffff", base08: "#fb0120", base09: "#fc6d24", base0A: "#fda331", base0B: "#a1c659", base0C: "#76c7b7", base0D: "#6fb3d2", base0E: "#d381c3", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "chalk", author: "chris kempson (http://chriskempson.com)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#f5f5f5", base08: "#fb9fb1", base09: "#eda987", base0A: "#ddb26f", base0B: "#acc267", base0C: "#12cfc0", base0D: "#6fc2ef", base0E: "#e1a3ee", base0F: "#deaf8f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "codeschool", author: "brettof86", base00: "#232c31", base01: "#1c3657", base02: "#2a343a", base03: "#3f4944", base04: "#84898c", base05: "#9ea7a6", base06: "#a7cfa3", base07: "#b5d8f6", base08: "#2a5491", base09: "#43820d", base0A: "#a03b1e", base0B: "#237986", base0C: "#b02f30", base0D: "#484d79", base0E: "#c59820", base0F: "#c98344" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "colors", author: "mrmrs (http://clrs.cc)", base00: "#111111", base01: "#333333", base02: "#555555", base03: "#777777", base04: "#999999", base05: "#bbbbbb", base06: "#dddddd", base07: "#ffffff", base08: "#ff4136", base09: "#ff851b", base0A: "#ffdc00", base0B: "#2ecc40", base0C: "#7fdbff", base0D: "#0074d9", base0E: "#b10dc9", base0F: "#85144b" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "default", author: "chris kempson (http://chriskempson.com)", base00: "#181818", base01: "#282828", base02: "#383838", base03: "#585858", base04: "#b8b8b8", base05: "#d8d8d8", base06: "#e8e8e8", base07: "#f8f8f8", base08: "#ab4642", base09: "#dc9656", base0A: "#f7ca88", base0B: "#a1b56c", base0C: "#86c1b9", base0D: "#7cafc2", base0E: "#ba8baf", base0F: "#a16946" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "eighties", author: "chris kempson (http://chriskempson.com)", base00: "#2d2d2d", base01: "#393939", base02: "#515151", base03: "#747369", base04: "#a09f93", base05: "#d3d0c8", base06: "#e8e6df", base07: "#f2f0ec", base08: "#f2777a", base09: "#f99157", base0A: "#ffcc66", base0B: "#99cc99", base0C: "#66cccc", base0D: "#6699cc", base0E: "#cc99cc", base0F: "#d27b53" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "embers", author: "jannik siebert (https://github.com/janniks)", base00: "#16130F", base01: "#2C2620", base02: "#433B32", base03: "#5A5047", base04: "#8A8075", base05: "#A39A90", base06: "#BEB6AE", base07: "#DBD6D1", base08: "#826D57", base09: "#828257", base0A: "#6D8257", base0B: "#57826D", base0C: "#576D82", base0D: "#6D5782", base0E: "#82576D", base0F: "#825757" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "flat", author: "chris kempson (http://chriskempson.com)", base00: "#2C3E50", base01: "#34495E", base02: "#7F8C8D", base03: "#95A5A6", base04: "#BDC3C7", base05: "#e0e0e0", base06: "#f5f5f5", base07: "#ECF0F1", base08: "#E74C3C", base09: "#E67E22", base0A: "#F1C40F", base0B: "#2ECC71", base0C: "#1ABC9C", base0D: "#3498DB", base0E: "#9B59B6", base0F: "#be643c" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "google", author: "seth wright (http://sethawright.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#CC342B", base09: "#F96A38", base0A: "#FBA922", base0B: "#198844", base0C: "#3971ED", base0D: "#3971ED", base0E: "#A36AC7", base0F: "#3971ED" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "grayscale", author: "alexandre gavioli (https://github.com/alexx2/)", base00: "#101010", base01: "#252525", base02: "#464646", base03: "#525252", base04: "#ababab", base05: "#b9b9b9", base06: "#e3e3e3", base07: "#f7f7f7", base08: "#7c7c7c", base09: "#999999", base0A: "#a0a0a0", base0B: "#8e8e8e", base0C: "#868686", base0D: "#686868", base0E: "#747474", base0F: "#5e5e5e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "green screen", author: "chris kempson (http://chriskempson.com)", base00: "#001100", base01: "#003300", base02: "#005500", base03: "#007700", base04: "#009900", base05: "#00bb00", base06: "#00dd00", base07: "#00ff00", base08: "#007700", base09: "#009900", base0A: "#007700", base0B: "#00bb00", base0C: "#005500", base0D: "#009900", base0E: "#00bb00", base0F: "#005500" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "harmonic16", author: "jannik siebert (https://github.com/janniks)", base00: "#0b1c2c", base01: "#223b54", base02: "#405c79", base03: "#627e99", base04: "#aabcce", base05: "#cbd6e2", base06: "#e5ebf1", base07: "#f7f9fb", base08: "#bf8b56", base09: "#bfbf56", base0A: "#8bbf56", base0B: "#56bf8b", base0C: "#568bbf", base0D: "#8b56bf", base0E: "#bf568b", base0F: "#bf5656" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "hopscotch", author: "jan t. sott", base00: "#322931", base01: "#433b42", base02: "#5c545b", base03: "#797379", base04: "#989498", base05: "#b9b5b8", base06: "#d5d3d5", base07: "#ffffff", base08: "#dd464c", base09: "#fd8b19", base0A: "#fdcc59", base0B: "#8fc13e", base0C: "#149b93", base0D: "#1290bf", base0E: "#c85e7c", base0F: "#b33508" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "isotope", author: "jan t. sott", base00: "#000000", base01: "#404040", base02: "#606060", base03: "#808080", base04: "#c0c0c0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#ff0000", base09: "#ff9900", base0A: "#ff0099", base0B: "#33ff00", base0C: "#00ffff", base0D: "#0066ff", base0E: "#cc00ff", base0F: "#3300ff" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "marrakesh", author: "alexandre gavioli (http://github.com/alexx2/)", base00: "#201602", base01: "#302e00", base02: "#5f5b17", base03: "#6c6823", base04: "#86813b", base05: "#948e48", base06: "#ccc37a", base07: "#faf0a5", base08: "#c35359", base09: "#b36144", base0A: "#a88339", base0B: "#18974e", base0C: "#75a738", base0D: "#477ca1", base0E: "#8868b3", base0F: "#b3588e" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "mocha", author: "chris kempson (http://chriskempson.com)", base00: "#3B3228", base01: "#534636", base02: "#645240", base03: "#7e705a", base04: "#b8afad", base05: "#d0c8c6", base06: "#e9e1dd", base07: "#f5eeeb", base08: "#cb6077", base09: "#d28b71", base0A: "#f4bc87", base0B: "#beb55b", base0C: "#7bbda4", base0D: "#8ab3b5", base0E: "#a89bb9", base0F: "#bb9584" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "monokai", author: "wimer hazenberg (http://www.monokai.nl)", base00: "#272822", base01: "#383830", base02: "#49483e", base03: "#75715e", base04: "#a59f85", base05: "#f8f8f2", base06: "#f5f4f1", base07: "#f9f8f5", base08: "#f92672", base09: "#fd971f", base0A: "#f4bf75", base0B: "#a6e22e", base0C: "#a1efe4", base0D: "#66d9ef", base0E: "#ae81ff", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "ocean", author: "chris kempson (http://chriskempson.com)", base00: "#2b303b", base01: "#343d46", base02: "#4f5b66", base03: "#65737e", base04: "#a7adba", base05: "#c0c5ce", base06: "#dfe1e8", base07: "#eff1f5", base08: "#bf616a", base09: "#d08770", base0A: "#ebcb8b", base0B: "#a3be8c", base0C: "#96b5b4", base0D: "#8fa1b3", base0E: "#b48ead", base0F: "#ab7967" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "paraiso", author: "jan t. sott", base00: "#2f1e2e", base01: "#41323f", base02: "#4f424c", base03: "#776e71", base04: "#8d8687", base05: "#a39e9b", base06: "#b9b6b0", base07: "#e7e9db", base08: "#ef6155", base09: "#f99b15", base0A: "#fec418", base0B: "#48b685", base0C: "#5bc4bf", base0D: "#06b6ef", base0E: "#815ba4", base0F: "#e96ba8" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "pop", author: "chris kempson (http://chriskempson.com)", base00: "#000000", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#b0b0b0", base05: "#d0d0d0", base06: "#e0e0e0", base07: "#ffffff", base08: "#eb008a", base09: "#f29333", base0A: "#f8ca12", base0B: "#37b349", base0C: "#00aabb", base0D: "#0e5a94", base0E: "#b31e8d", base0F: "#7a2d00" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "railscasts", author: "ryan bates (http://railscasts.com)", base00: "#2b2b2b", base01: "#272935", base02: "#3a4055", base03: "#5a647e", base04: "#d4cfc9", base05: "#e6e1dc", base06: "#f4f1ed", base07: "#f9f7f3", base08: "#da4939", base09: "#cc7833", base0A: "#ffc66d", base0B: "#a5c261", base0C: "#519f50", base0D: "#6d9cbe", base0E: "#b6b3eb", base0F: "#bc9458" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "shapeshifter", author: "tyler benziger (http://tybenz.com)", base00: "#000000", base01: "#040404", base02: "#102015", base03: "#343434", base04: "#555555", base05: "#ababab", base06: "#e0e0e0", base07: "#f9f9f9", base08: "#e92f2f", base09: "#e09448", base0A: "#dddd13", base0B: "#0ed839", base0C: "#23edda", base0D: "#3b48e3", base0E: "#f996e2", base0F: "#69542d" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "solarized", author: "ethan schoonover (http://ethanschoonover.com/solarized)", base00: "#002b36", base01: "#073642", base02: "#586e75", base03: "#657b83", base04: "#839496", base05: "#93a1a1", base06: "#eee8d5", base07: "#fdf6e3", base08: "#dc322f", base09: "#cb4b16", base0A: "#b58900", base0B: "#859900", base0C: "#2aa198", base0D: "#268bd2", base0E: "#6c71c4", base0F: "#d33682" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "summerfruit", author: "christopher corley (http://cscorley.github.io/)", base00: "#151515", base01: "#202020", base02: "#303030", base03: "#505050", base04: "#B0B0B0", base05: "#D0D0D0", base06: "#E0E0E0", base07: "#FFFFFF", base08: "#FF0086", base09: "#FD8900", base0A: "#ABA800", base0B: "#00C918", base0C: "#1faaaa", base0D: "#3777E6", base0E: "#AD00A1", base0F: "#cc6633" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "tomorrow", author: "chris kempson (http://chriskempson.com)", base00: "#1d1f21", base01: "#282a2e", base02: "#373b41", base03: "#969896", base04: "#b4b7b4", base05: "#c5c8c6", base06: "#e0e0e0", base07: "#ffffff", base08: "#cc6666", base09: "#de935f", base0A: "#f0c674", base0B: "#b5bd68", base0C: "#8abeb7", base0D: "#81a2be", base0E: "#b294bb", base0F: "#a3685a" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "london tube", author: "jan t. sott", base00: "#231f20", base01: "#1c3f95", base02: "#5a5758", base03: "#737171", base04: "#959ca1", base05: "#d9d8d8", base06: "#e7e7e8", base07: "#ffffff", base08: "#ee2e24", base09: "#f386a1", base0A: "#ffd204", base0B: "#00853e", base0C: "#85cebc", base0D: "#009ddc", base0E: "#98005d", base0F: "#b06110" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      t2.__esModule = true, t2.default = { scheme: "twilight", author: "david hart (http://hart-dev.com)", base00: "#1e1e1e", base01: "#323537", base02: "#464b50", base03: "#5f5a60", base04: "#838184", base05: "#a7a7a7", base06: "#c3c3c3", base07: "#ffffff", base08: "#cf6a4c", base09: "#cda869", base0A: "#f9ee98", base0B: "#8f9d6a", base0C: "#afc4db", base0D: "#7587a6", base0E: "#9b859d", base0F: "#9b703f" }, e3.exports = t2.default;
    }, function(e3, t2, n2) {
      var a = n2(33);
      function r2(e4) {
        var t3 = Math.round(a(e4, 0, 255)).toString(16);
        return t3.length == 1 ? "0" + t3 : t3;
      }
      e3.exports = function(e4) {
        var t3 = e4.length === 4 ? r2(255 * e4[3]) : "";
        return "#" + r2(e4[0]) + r2(e4[1]) + r2(e4[2]) + t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(134), r2 = n2(135), o = n2(136), i = n2(137);
      var s = { "#": r2, hsl: function(e4) {
        var t3 = a(e4), n3 = i(t3);
        return t3.length === 4 && n3.push(t3[3]), n3;
      }, rgb: o };
      function c2(e4) {
        for (var t3 in s)
          if (e4.indexOf(t3) === 0)
            return s[t3](e4);
      }
      c2.rgb = o, c2.hsl = a, c2.hex = r2, e3.exports = c2;
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        switch (e4 = parseFloat(e4), t3) {
          case 0:
            return r2(e4, 0, 360);
          case 1:
          case 2:
            return r2(e4, 0, 100);
          case 3:
            return r2(e4, 0, 1);
        }
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        e4.length !== 4 && e4.length !== 5 || (e4 = function(e5) {
          for (var t4 = "#", n3 = 1; n3 < e5.length; n3++) {
            var a = e5.charAt(n3);
            t4 += a + a;
          }
          return t4;
        }(e4));
        var t3 = [parseInt(e4.substring(1, 3), 16), parseInt(e4.substring(3, 5), 16), parseInt(e4.substring(5, 7), 16)];
        if (e4.length === 9) {
          var n2 = parseFloat((parseInt(e4.substring(7, 9), 16) / 255).toFixed(2));
          t3.push(n2);
        }
        return t3;
      };
    }, function(e3, t2, n2) {
      var a = n2(44), r2 = n2(33);
      function o(e4, t3) {
        return t3 < 3 ? e4.indexOf("%") != -1 ? Math.round(255 * r2(parseInt(e4, 10), 0, 100) / 100) : r2(parseInt(e4, 10), 0, 255) : r2(parseFloat(e4), 0, 1);
      }
      e3.exports = function(e4) {
        return a(e4).map(o);
      };
    }, function(e3, t2) {
      e3.exports = function(e4) {
        var t3, n2, a, r2, o, i = e4[0] / 360, s = e4[1] / 100, c2 = e4[2] / 100;
        if (s == 0)
          return [o = 255 * c2, o, o];
        t3 = 2 * c2 - (n2 = c2 < 0.5 ? c2 * (1 + s) : c2 + s - c2 * s), r2 = [0, 0, 0];
        for (var l2 = 0; l2 < 3; l2++)
          (a = i + 1 / 3 * -(l2 - 1)) < 0 && a++, a > 1 && a--, o = 6 * a < 1 ? t3 + 6 * (n2 - t3) * a : 2 * a < 1 ? n2 : 3 * a < 2 ? t3 + (n2 - t3) * (2 / 3 - a) * 6 : t3, r2[l2] = 255 * o;
        return r2;
      };
    }, function(e3, t2, n2) {
      (function(t3) {
        var n3 = typeof t3 == "object" && t3 && t3.Object === Object && t3, a = typeof self == "object" && self && self.Object === Object && self, r2 = n3 || a || Function("return this")();
        function o(e4, t4, n4) {
          switch (n4.length) {
            case 0:
              return e4.call(t4);
            case 1:
              return e4.call(t4, n4[0]);
            case 2:
              return e4.call(t4, n4[0], n4[1]);
            case 3:
              return e4.call(t4, n4[0], n4[1], n4[2]);
          }
          return e4.apply(t4, n4);
        }
        function i(e4, t4) {
          for (var n4 = -1, a2 = t4.length, r3 = e4.length; ++n4 < a2; )
            e4[r3 + n4] = t4[n4];
          return e4;
        }
        var s = Object.prototype, c2 = s.hasOwnProperty, l2 = s.toString, u = r2.Symbol, f2 = s.propertyIsEnumerable, p2 = u ? u.isConcatSpreadable : void 0, d2 = Math.max;
        function b2(e4) {
          return h(e4) || function(e5) {
            return function(e6) {
              return function(e7) {
                return !!e7 && typeof e7 == "object";
              }(e6) && function(e7) {
                return e7 != null && function(e8) {
                  return typeof e8 == "number" && e8 > -1 && e8 % 1 == 0 && e8 <= 9007199254740991;
                }(e7.length) && !function(e8) {
                  var t4 = function(e9) {
                    var t5 = typeof e9;
                    return !!e9 && (t5 == "object" || t5 == "function");
                  }(e8) ? l2.call(e8) : "";
                  return t4 == "[object Function]" || t4 == "[object GeneratorFunction]";
                }(e7);
              }(e6);
            }(e5) && c2.call(e5, "callee") && (!f2.call(e5, "callee") || l2.call(e5) == "[object Arguments]");
          }(e4) || !!(p2 && e4 && e4[p2]);
        }
        var h = Array.isArray;
        var v4, m2, y2, g2 = (m2 = function(e4) {
          var t4 = (e4 = function e5(t5, n5, a2, r3, o2) {
            var s2 = -1, c3 = t5.length;
            for (a2 || (a2 = b2), o2 || (o2 = []); ++s2 < c3; ) {
              var l3 = t5[s2];
              n5 > 0 && a2(l3) ? n5 > 1 ? e5(l3, n5 - 1, a2, r3, o2) : i(o2, l3) : r3 || (o2[o2.length] = l3);
            }
            return o2;
          }(e4, 1)).length, n4 = t4;
          for (v4; n4--; )
            if (typeof e4[n4] != "function")
              throw new TypeError("Expected a function");
          return function() {
            for (var n5 = 0, a2 = t4 ? e4[n5].apply(this, arguments) : arguments[0]; ++n5 < t4; )
              a2 = e4[n5].call(this, a2);
            return a2;
          };
        }, y2 = d2(y2 === void 0 ? m2.length - 1 : y2, 0), function() {
          for (var e4 = arguments, t4 = -1, n4 = d2(e4.length - y2, 0), a2 = Array(n4); ++t4 < n4; )
            a2[t4] = e4[y2 + t4];
          t4 = -1;
          for (var r3 = Array(y2 + 1); ++t4 < y2; )
            r3[t4] = e4[t4];
          return r3[y2] = a2, o(m2, this, r3);
        });
        e3.exports = g2;
      }).call(this, n2(43));
    }, function(e3, t2, n2) {
      Object.defineProperty(t2, "__esModule", { value: true }), t2.yuv2rgb = function(e4) {
        var t3, n3, a, r2 = e4[0], o = e4[1], i = e4[2];
        return t3 = 1 * r2 + 0 * o + 1.13983 * i, n3 = 1 * r2 + -0.39465 * o + -0.5806 * i, a = 1 * r2 + 2.02311 * o + 0 * i, t3 = Math.min(Math.max(0, t3), 1), n3 = Math.min(Math.max(0, n3), 1), a = Math.min(Math.max(0, a), 1), [255 * t3, 255 * n3, 255 * a];
      }, t2.rgb2yuv = function(e4) {
        var t3 = e4[0] / 255, n3 = e4[1] / 255, a = e4[2] / 255;
        return [0.299 * t3 + 0.587 * n3 + 0.114 * a, -0.14713 * t3 + -0.28886 * n3 + 0.436 * a, 0.615 * t3 + -0.51499 * n3 + -0.10001 * a];
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      var r2 = n2(141), o = function() {
        function e4() {
          a(this, "_callbacks", void 0), a(this, "_isDispatching", void 0), a(this, "_isHandled", void 0), a(this, "_isPending", void 0), a(this, "_lastID", void 0), a(this, "_pendingPayload", void 0), this._callbacks = {}, this._isDispatching = false, this._isHandled = {}, this._isPending = {}, this._lastID = 1;
        }
        var t3 = e4.prototype;
        return t3.register = function(e5) {
          var t4 = "ID_" + this._lastID++;
          return this._callbacks[t4] = e5, t4;
        }, t3.unregister = function(e5) {
          this._callbacks[e5] || r2(false), delete this._callbacks[e5];
        }, t3.waitFor = function(e5) {
          this._isDispatching || r2(false);
          for (var t4 = 0; t4 < e5.length; t4++) {
            var n3 = e5[t4];
            this._isPending[n3] ? this._isHandled[n3] || r2(false) : (this._callbacks[n3] || r2(false), this._invokeCallback(n3));
          }
        }, t3.dispatch = function(e5) {
          this._isDispatching && r2(false), this._startDispatching(e5);
          try {
            for (var t4 in this._callbacks)
              this._isPending[t4] || this._invokeCallback(t4);
          } finally {
            this._stopDispatching();
          }
        }, t3.isDispatching = function() {
          return this._isDispatching;
        }, t3._invokeCallback = function(e5) {
          this._isPending[e5] = true, this._callbacks[e5](this._pendingPayload), this._isHandled[e5] = true;
        }, t3._startDispatching = function(e5) {
          for (var t4 in this._callbacks)
            this._isPending[t4] = false, this._isHandled[t4] = false;
          this._pendingPayload = e5, this._isDispatching = true;
        }, t3._stopDispatching = function() {
          delete this._pendingPayload, this._isDispatching = false;
        }, e4;
      }();
      e3.exports = o;
    }, function(e3, t2, n2) {
      e3.exports = function(e4, t3) {
        for (var n3 = arguments.length, r2 = new Array(n3 > 2 ? n3 - 2 : 0), o = 2; o < n3; o++)
          r2[o - 2] = arguments[o];
        if (!e4) {
          var i;
          if (t3 === void 0)
            i = new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");
          else {
            var s = 0;
            (i = new Error(t3.replace(/%s/g, function() {
              return String(r2[s++]);
            }))).name = "Invariant Violation";
          }
          throw i.framesToPop = 1, i;
        }
      };
    }, function(e3, t2, n2) {
      function a(e4, t3, n3) {
        return t3 in e4 ? Object.defineProperty(e4, t3, { value: n3, enumerable: true, configurable: true, writable: true }) : e4[t3] = n3, e4;
      }
      function r2(e4, t3) {
        var n3 = Object.keys(e4);
        if (Object.getOwnPropertySymbols) {
          var a2 = Object.getOwnPropertySymbols(e4);
          t3 && (a2 = a2.filter(function(t4) {
            return Object.getOwnPropertyDescriptor(e4, t4).enumerable;
          })), n3.push.apply(n3, a2);
        }
        return n3;
      }
      function o(e4) {
        for (var t3 = 1; t3 < arguments.length; t3++) {
          var n3 = arguments[t3] != null ? arguments[t3] : {};
          t3 % 2 ? r2(Object(n3), true).forEach(function(t4) {
            a(e4, t4, n3[t4]);
          }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e4, Object.getOwnPropertyDescriptors(n3)) : r2(Object(n3)).forEach(function(t4) {
            Object.defineProperty(e4, t4, Object.getOwnPropertyDescriptor(n3, t4));
          });
        }
        return e4;
      }
      function i(e4, t3) {
        if (!(e4 instanceof t3))
          throw new TypeError("Cannot call a class as a function");
      }
      function s(e4, t3) {
        for (var n3 = 0; n3 < t3.length; n3++) {
          var a2 = t3[n3];
          a2.enumerable = a2.enumerable || false, a2.configurable = true, "value" in a2 && (a2.writable = true), Object.defineProperty(e4, a2.key, a2);
        }
      }
      function c2(e4, t3, n3) {
        return t3 && s(e4.prototype, t3), n3 && s(e4, n3), e4;
      }
      function l2(e4, t3) {
        return (l2 = Object.setPrototypeOf || function(e5, t4) {
          return e5.__proto__ = t4, e5;
        })(e4, t3);
      }
      function u(e4, t3) {
        if (typeof t3 != "function" && t3 !== null)
          throw new TypeError("Super expression must either be null or a function");
        e4.prototype = Object.create(t3 && t3.prototype, { constructor: { value: e4, writable: true, configurable: true } }), t3 && l2(e4, t3);
      }
      function f2(e4) {
        return (f2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(e5) {
          return e5.__proto__ || Object.getPrototypeOf(e5);
        })(e4);
      }
      function p2(e4) {
        return (p2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e5) {
          return typeof e5;
        } : function(e5) {
          return e5 && typeof Symbol == "function" && e5.constructor === Symbol && e5 !== Symbol.prototype ? "symbol" : typeof e5;
        })(e4);
      }
      function d2(e4) {
        if (e4 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return e4;
      }
      function b2(e4, t3) {
        return !t3 || p2(t3) !== "object" && typeof t3 != "function" ? d2(e4) : t3;
      }
      function h(e4) {
        var t3 = function() {
          if (typeof Reflect == "undefined" || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if (typeof Proxy == "function")
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (e5) {
            return false;
          }
        }();
        return function() {
          var n3, a2 = f2(e4);
          if (t3) {
            var r3 = f2(this).constructor;
            n3 = Reflect.construct(a2, arguments, r3);
          } else
            n3 = a2.apply(this, arguments);
          return b2(this, n3);
        };
      }
      n2.r(t2);
      var v4 = n2(0), m2 = n2.n(v4);
      function y2() {
        var e4 = this.constructor.getDerivedStateFromProps(this.props, this.state);
        e4 != null && this.setState(e4);
      }
      function g2(e4) {
        this.setState(function(t3) {
          var n3 = this.constructor.getDerivedStateFromProps(e4, t3);
          return n3 != null ? n3 : null;
        }.bind(this));
      }
      function E(e4, t3) {
        try {
          var n3 = this.props, a2 = this.state;
          this.props = e4, this.state = t3, this.__reactInternalSnapshotFlag = true, this.__reactInternalSnapshot = this.getSnapshotBeforeUpdate(n3, a2);
        } finally {
          this.props = n3, this.state = a2;
        }
      }
      function j(e4) {
        var t3 = e4.prototype;
        if (!t3 || !t3.isReactComponent)
          throw new Error("Can only polyfill class components");
        if (typeof e4.getDerivedStateFromProps != "function" && typeof t3.getSnapshotBeforeUpdate != "function")
          return e4;
        var n3 = null, a2 = null, r3 = null;
        if (typeof t3.componentWillMount == "function" ? n3 = "componentWillMount" : typeof t3.UNSAFE_componentWillMount == "function" && (n3 = "UNSAFE_componentWillMount"), typeof t3.componentWillReceiveProps == "function" ? a2 = "componentWillReceiveProps" : typeof t3.UNSAFE_componentWillReceiveProps == "function" && (a2 = "UNSAFE_componentWillReceiveProps"), typeof t3.componentWillUpdate == "function" ? r3 = "componentWillUpdate" : typeof t3.UNSAFE_componentWillUpdate == "function" && (r3 = "UNSAFE_componentWillUpdate"), n3 !== null || a2 !== null || r3 !== null) {
          var o2 = e4.displayName || e4.name, i2 = typeof e4.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
          throw Error("Unsafe legacy lifecycles will not be called for components using new component APIs.\n\n" + o2 + " uses " + i2 + " but also contains the following legacy lifecycles:" + (n3 !== null ? "\n  " + n3 : "") + (a2 !== null ? "\n  " + a2 : "") + (r3 !== null ? "\n  " + r3 : "") + "\n\nThe above lifecycles should be removed. Learn more about this warning here:\nhttps://fb.me/react-async-component-lifecycle-hooks");
        }
        if (typeof e4.getDerivedStateFromProps == "function" && (t3.componentWillMount = y2, t3.componentWillReceiveProps = g2), typeof t3.getSnapshotBeforeUpdate == "function") {
          if (typeof t3.componentDidUpdate != "function")
            throw new Error("Cannot polyfill getSnapshotBeforeUpdate() for components that do not define componentDidUpdate() on the prototype");
          t3.componentWillUpdate = E;
          var s2 = t3.componentDidUpdate;
          t3.componentDidUpdate = function(e5, t4, n4) {
            var a3 = this.__reactInternalSnapshotFlag ? this.__reactInternalSnapshot : n4;
            s2.call(this, e5, t4, a3);
          };
        }
        return e4;
      }
      function x2(e4, t3) {
        if (e4 == null)
          return {};
        var n3, a2, r3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, t3);
        if (Object.getOwnPropertySymbols) {
          var o2 = Object.getOwnPropertySymbols(e4);
          for (a2 = 0; a2 < o2.length; a2++)
            n3 = o2[a2], t3.indexOf(n3) >= 0 || Object.prototype.propertyIsEnumerable.call(e4, n3) && (r3[n3] = e4[n3]);
        }
        return r3;
      }
      function _(e4) {
        var t3 = function(e5) {
          return {}.toString.call(e5).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
        }(e4);
        return t3 === "number" && (t3 = isNaN(e4) ? "nan" : (0 | e4) != e4 ? "float" : "integer"), t3;
      }
      y2.__suppressDeprecationWarning = true, g2.__suppressDeprecationWarning = true, E.__suppressDeprecationWarning = true;
      var k2 = { scheme: "rjv-default", author: "mac gainor", base00: "rgba(0, 0, 0, 0)", base01: "rgb(245, 245, 245)", base02: "rgb(235, 235, 235)", base03: "#93a1a1", base04: "rgba(0, 0, 0, 0.3)", base05: "#586e75", base06: "#073642", base07: "#002b36", base08: "#d33682", base09: "#cb4b16", base0A: "#dc322f", base0B: "#859900", base0C: "#6c71c4", base0D: "#586e75", base0E: "#2aa198", base0F: "#268bd2" }, O = { scheme: "rjv-grey", author: "mac gainor", base00: "rgba(1, 1, 1, 0)", base01: "rgba(1, 1, 1, 0.1)", base02: "rgba(0, 0, 0, 0.2)", base03: "rgba(1, 1, 1, 0.3)", base04: "rgba(0, 0, 0, 0.4)", base05: "rgba(1, 1, 1, 0.5)", base06: "rgba(1, 1, 1, 0.6)", base07: "rgba(1, 1, 1, 0.7)", base08: "rgba(1, 1, 1, 0.8)", base09: "rgba(1, 1, 1, 0.8)", base0A: "rgba(1, 1, 1, 0.8)", base0B: "rgba(1, 1, 1, 0.8)", base0C: "rgba(1, 1, 1, 0.8)", base0D: "rgba(1, 1, 1, 0.8)", base0E: "rgba(1, 1, 1, 0.8)", base0F: "rgba(1, 1, 1, 0.8)" }, C = { white: "#fff", black: "#000", transparent: "rgba(1, 1, 1, 0)", globalFontFamily: "monospace", globalCursor: "default", indentBlockWidth: "5px", braceFontWeight: "bold", braceCursor: "pointer", ellipsisFontSize: "18px", ellipsisLineHeight: "10px", ellipsisCursor: "pointer", keyMargin: "0px 5px", keyLetterSpacing: "0.5px", keyFontStyle: "none", keyBorderRadius: "3px", keyColonWeight: "bold", keyVerticalAlign: "top", keyOpacity: "0.85", keyOpacityHover: "1", keyValPaddingTop: "3px", keyValPaddingBottom: "3px", keyValPaddingRight: "5px", keyValBorderLeft: "1px solid", keyValBorderHover: "2px solid", keyValPaddingHover: "3px 5px 3px 4px", pushedContentMarginLeft: "6px", variableValuePaddingRight: "6px", nullFontSize: "11px", nullFontWeight: "bold", nullPadding: "1px 2px", nullBorderRadius: "3px", nanFontSize: "11px", nanFontWeight: "bold", nanPadding: "1px 2px", nanBorderRadius: "3px", undefinedFontSize: "11px", undefinedFontWeight: "bold", undefinedPadding: "1px 2px", undefinedBorderRadius: "3px", dataTypeFontSize: "11px", dataTypeMarginRight: "4px", datatypeOpacity: "0.8", objectSizeBorderRadius: "3px", objectSizeFontStyle: "italic", objectSizeMargin: "0px 6px 0px 0px", clipboardCursor: "pointer", clipboardCheckMarginLeft: "-12px", metaDataPadding: "0px 0px 0px 10px", arrayGroupMetaPadding: "0px 0px 0px 4px", iconContainerWidth: "17px", tooltipPadding: "4px", editInputMinWidth: "130px", editInputBorderRadius: "2px", editInputPadding: "5px", editInputMarginRight: "4px", editInputFontFamily: "monospace", iconCursor: "pointer", iconFontSize: "15px", iconPaddingRight: "1px", dateValueMarginLeft: "2px", iconMarginRight: "3px", detectedRowPaddingTop: "3px", addKeyCoverBackground: "rgba(255, 255, 255, 0.3)", addKeyCoverPosition: "absolute", addKeyCoverPositionPx: "0px", addKeyModalWidth: "200px", addKeyModalMargin: "auto", addKeyModalPadding: "10px", addKeyModalRadius: "3px" }, S = n2(45), w2 = function(e4) {
        var t3 = function(e5) {
          return { backgroundColor: e5.base00, ellipsisColor: e5.base09, braceColor: e5.base07, expandedIcon: e5.base0D, collapsedIcon: e5.base0E, keyColor: e5.base07, arrayKeyColor: e5.base0C, objectSize: e5.base04, copyToClipboard: e5.base0F, copyToClipboardCheck: e5.base0D, objectBorder: e5.base02, dataTypes: { boolean: e5.base0E, date: e5.base0D, float: e5.base0B, function: e5.base0D, integer: e5.base0F, string: e5.base09, nan: e5.base08, null: e5.base0A, undefined: e5.base05, regexp: e5.base0A, background: e5.base02 }, editVariable: { editIcon: e5.base0E, cancelIcon: e5.base09, removeIcon: e5.base09, addIcon: e5.base0E, checkIcon: e5.base0E, background: e5.base01, color: e5.base0A, border: e5.base07 }, addKeyModal: { background: e5.base05, border: e5.base04, color: e5.base0A, labelColor: e5.base01 }, validationFailure: { background: e5.base09, iconColor: e5.base01, fontColor: e5.base01 } };
        }(e4);
        return { "app-container": { fontFamily: C.globalFontFamily, cursor: C.globalCursor, backgroundColor: t3.backgroundColor, position: "relative" }, ellipsis: { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "brace-row": { display: "inline-block", cursor: "pointer" }, brace: { display: "inline-block", cursor: C.braceCursor, fontWeight: C.braceFontWeight, color: t3.braceColor }, "expanded-icon": { color: t3.expandedIcon }, "collapsed-icon": { color: t3.collapsedIcon }, colon: { display: "inline-block", margin: C.keyMargin, color: t3.keyColor, verticalAlign: "top" }, objectKeyVal: function(e5, n3) {
          return { style: o({ paddingTop: C.keyValPaddingTop, paddingRight: C.keyValPaddingRight, paddingBottom: C.keyValPaddingBottom, borderLeft: C.keyValBorderLeft + " " + t3.objectBorder, ":hover": { paddingLeft: n3.paddingLeft - 1 + "px", borderLeft: C.keyValBorderHover + " " + t3.objectBorder } }, n3) };
        }, "object-key-val-no-border": { padding: C.keyValPadding }, "pushed-content": { marginLeft: C.pushedContentMarginLeft }, variableValue: function(e5, t4) {
          return { style: o({ display: "inline-block", paddingRight: C.variableValuePaddingRight, position: "relative" }, t4) };
        }, "object-name": { display: "inline-block", color: t3.keyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "array-key": { display: "inline-block", color: t3.arrayKeyColor, letterSpacing: C.keyLetterSpacing, fontStyle: C.keyFontStyle, verticalAlign: C.keyVerticalAlign, opacity: C.keyOpacity, ":hover": { opacity: C.keyOpacityHover } }, "object-size": { color: t3.objectSize, borderRadius: C.objectSizeBorderRadius, fontStyle: C.objectSizeFontStyle, margin: C.objectSizeMargin, cursor: "default" }, "data-type-label": { fontSize: C.dataTypeFontSize, marginRight: C.dataTypeMarginRight, opacity: C.datatypeOpacity }, boolean: { display: "inline-block", color: t3.dataTypes.boolean }, date: { display: "inline-block", color: t3.dataTypes.date }, "date-value": { marginLeft: C.dateValueMarginLeft }, float: { display: "inline-block", color: t3.dataTypes.float }, function: { display: "inline-block", color: t3.dataTypes.function, cursor: "pointer", whiteSpace: "pre-line" }, "function-value": { fontStyle: "italic" }, integer: { display: "inline-block", color: t3.dataTypes.integer }, string: { display: "inline-block", color: t3.dataTypes.string }, nan: { display: "inline-block", color: t3.dataTypes.nan, fontSize: C.nanFontSize, fontWeight: C.nanFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nanPadding, borderRadius: C.nanBorderRadius }, null: { display: "inline-block", color: t3.dataTypes.null, fontSize: C.nullFontSize, fontWeight: C.nullFontWeight, backgroundColor: t3.dataTypes.background, padding: C.nullPadding, borderRadius: C.nullBorderRadius }, undefined: { display: "inline-block", color: t3.dataTypes.undefined, fontSize: C.undefinedFontSize, padding: C.undefinedPadding, borderRadius: C.undefinedBorderRadius, backgroundColor: t3.dataTypes.background }, regexp: { display: "inline-block", color: t3.dataTypes.regexp }, "copy-to-clipboard": { cursor: C.clipboardCursor }, "copy-icon": { color: t3.copyToClipboard, fontSize: C.iconFontSize, marginRight: C.iconMarginRight, verticalAlign: "top" }, "copy-icon-copied": { color: t3.copyToClipboardCheck, marginLeft: C.clipboardCheckMarginLeft }, "array-group-meta-data": { display: "inline-block", padding: C.arrayGroupMetaPadding }, "object-meta-data": { display: "inline-block", padding: C.metaDataPadding }, "icon-container": { display: "inline-block", width: C.iconContainerWidth }, tooltip: { padding: C.tooltipPadding }, removeVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.removeIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, addVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.addIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, editVarIcon: { verticalAlign: "top", display: "inline-block", color: t3.editVariable.editIcon, cursor: C.iconCursor, fontSize: C.iconFontSize, marginRight: C.iconMarginRight }, "edit-icon-container": { display: "inline-block", verticalAlign: "top" }, "check-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.checkIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "cancel-icon": { display: "inline-block", cursor: C.iconCursor, color: t3.editVariable.cancelIcon, fontSize: C.iconFontSize, paddingRight: C.iconPaddingRight }, "edit-input": { display: "inline-block", minWidth: C.editInputMinWidth, borderRadius: C.editInputBorderRadius, backgroundColor: t3.editVariable.background, color: t3.editVariable.color, padding: C.editInputPadding, marginRight: C.editInputMarginRight, fontFamily: C.editInputFontFamily }, "detected-row": { paddingTop: C.detectedRowPaddingTop }, "key-modal-request": { position: C.addKeyCoverPosition, top: C.addKeyCoverPositionPx, left: C.addKeyCoverPositionPx, right: C.addKeyCoverPositionPx, bottom: C.addKeyCoverPositionPx, backgroundColor: C.addKeyCoverBackground }, "key-modal": { width: C.addKeyModalWidth, backgroundColor: t3.addKeyModal.background, marginLeft: C.addKeyModalMargin, marginRight: C.addKeyModalMargin, padding: C.addKeyModalPadding, borderRadius: C.addKeyModalRadius, marginTop: "15px", position: "relative" }, "key-modal-label": { color: t3.addKeyModal.labelColor, marginLeft: "2px", marginBottom: "5px", fontSize: "11px" }, "key-modal-input-container": { overflow: "hidden" }, "key-modal-input": { width: "100%", padding: "3px 6px", fontFamily: "monospace", color: t3.addKeyModal.color, border: "none", boxSizing: "border-box", borderRadius: "2px" }, "key-modal-cancel": { backgroundColor: t3.editVariable.removeIcon, position: "absolute", top: "0px", right: "0px", borderRadius: "0px 3px 0px 3px", cursor: "pointer" }, "key-modal-cancel-icon": { color: t3.addKeyModal.labelColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" }, "key-modal-submit": { color: t3.editVariable.addIcon, fontSize: C.iconFontSize, position: "absolute", right: "2px", top: "3px", cursor: "pointer" }, "function-ellipsis": { display: "inline-block", color: t3.ellipsisColor, fontSize: C.ellipsisFontSize, lineHeight: C.ellipsisLineHeight, cursor: C.ellipsisCursor }, "validation-failure": { float: "right", padding: "3px 6px", borderRadius: "2px", cursor: "pointer", color: t3.validationFailure.fontColor, backgroundColor: t3.validationFailure.background }, "validation-failure-label": { marginRight: "6px" }, "validation-failure-clear": { position: "relative", verticalAlign: "top", cursor: "pointer", color: t3.validationFailure.iconColor, fontSize: C.iconFontSize, transform: "rotate(45deg)" } };
      };
      function A2(e4, t3, n3) {
        return e4 || console.error("theme has not been set"), function(e5) {
          var t4 = k2;
          return e5 !== false && e5 !== "none" || (t4 = O), Object(S.createStyling)(w2, { defaultBase16: t4 })(e5);
        }(e4)(t3, n3);
      }
      var M = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = (e5.rjvId, e5.type_name), n4 = e5.displayDataTypes, a2 = e5.theme;
          return n4 ? m2.a.createElement("span", Object.assign({ className: "data-type-label" }, A2(a2, "data-type-label")), t4) : null;
        } }]), n3;
      }(m2.a.PureComponent), P = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "boolean"), m2.a.createElement(M, Object.assign({ type_name: "bool" }, e5)), e5.value ? "true" : "false");
        } }]), n3;
      }(m2.a.PureComponent), F = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "date"), m2.a.createElement(M, Object.assign({ type_name: "date" }, e5)), m2.a.createElement("span", Object.assign({ className: "date-value" }, A2(e5.theme, "date-value")), e5.value.toLocaleTimeString("en-us", { weekday: "short", year: "numeric", month: "short", day: "numeric", hour: "2-digit", minute: "2-digit" })));
        } }]), n3;
      }(m2.a.PureComponent), D = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "float"), m2.a.createElement(M, Object.assign({ type_name: "float" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent);
      function I(e4, t3) {
        (t3 == null || t3 > e4.length) && (t3 = e4.length);
        for (var n3 = 0, a2 = new Array(t3); n3 < t3; n3++)
          a2[n3] = e4[n3];
        return a2;
      }
      function R(e4, t3) {
        if (e4) {
          if (typeof e4 == "string")
            return I(e4, t3);
          var n3 = Object.prototype.toString.call(e4).slice(8, -1);
          return n3 === "Object" && e4.constructor && (n3 = e4.constructor.name), n3 === "Map" || n3 === "Set" ? Array.from(e4) : n3 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n3) ? I(e4, t3) : void 0;
        }
      }
      function L(e4, t3) {
        var n3;
        if (typeof Symbol == "undefined" || e4[Symbol.iterator] == null) {
          if (Array.isArray(e4) || (n3 = R(e4)) || t3 && e4 && typeof e4.length == "number") {
            n3 && (e4 = n3);
            var a2 = 0, r3 = function() {
            };
            return { s: r3, n: function() {
              return a2 >= e4.length ? { done: true } : { done: false, value: e4[a2++] };
            }, e: function(e5) {
              throw e5;
            }, f: r3 };
          }
          throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }
        var o2, i2 = true, s2 = false;
        return { s: function() {
          n3 = e4[Symbol.iterator]();
        }, n: function() {
          var e5 = n3.next();
          return i2 = e5.done, e5;
        }, e: function(e5) {
          s2 = true, o2 = e5;
        }, f: function() {
          try {
            i2 || n3.return == null || n3.return();
          } finally {
            if (s2)
              throw o2;
          }
        } };
      }
      function B(e4) {
        return function(e5) {
          if (Array.isArray(e5))
            return I(e5);
        }(e4) || function(e5) {
          if (typeof Symbol != "undefined" && Symbol.iterator in Object(e5))
            return Array.from(e5);
        }(e4) || R(e4) || function() {
          throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
        }();
      }
      var N = n2(46), z2 = new (n2(47)).Dispatcher(), T = new (function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).objects = {}, e5.set = function(t4, n4, a3, r4) {
            e5.objects[t4] === void 0 && (e5.objects[t4] = {}), e5.objects[t4][n4] === void 0 && (e5.objects[t4][n4] = {}), e5.objects[t4][n4][a3] = r4;
          }, e5.get = function(t4, n4, a3, r4) {
            return e5.objects[t4] === void 0 || e5.objects[t4][n4] === void 0 || e5.objects[t4][n4][a3] == null ? r4 : e5.objects[t4][n4][a3];
          }, e5.handleAction = function(t4) {
            var n4 = t4.rjvId, a3 = t4.data;
            switch (t4.name) {
              case "RESET":
                e5.emit("reset-" + n4);
                break;
              case "VARIABLE_UPDATED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-edited" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_REMOVED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-removed" })), e5.emit("variable-update-" + n4);
                break;
              case "VARIABLE_ADDED":
                t4.data.updated_src = e5.updateSrc(n4, a3), e5.set(n4, "action", "variable-update", o(o({}, a3), {}, { type: "variable-added" })), e5.emit("variable-update-" + n4);
                break;
              case "ADD_VARIABLE_KEY_REQUEST":
                e5.set(n4, "action", "new-key-request", a3), e5.emit("add-key-request-" + n4);
            }
          }, e5.updateSrc = function(t4, n4) {
            var a3 = n4.name, r4 = n4.namespace, o2 = n4.new_value, i2 = (n4.existing_value, n4.variable_removed);
            r4.shift();
            var s3, c3 = e5.get(t4, "global", "src"), l3 = e5.deepCopy(c3, B(r4)), u2 = l3, f3 = L(r4);
            try {
              for (f3.s(); !(s3 = f3.n()).done; ) {
                u2 = u2[s3.value];
              }
            } catch (e6) {
              f3.e(e6);
            } finally {
              f3.f();
            }
            return i2 ? _(u2) == "array" ? u2.splice(a3, 1) : delete u2[a3] : a3 !== null ? u2[a3] = o2 : l3 = o2, e5.set(t4, "global", "src", l3), l3;
          }, e5.deepCopy = function(t4, n4) {
            var a3, r4 = _(t4), i2 = n4.shift();
            return r4 == "array" ? a3 = B(t4) : r4 == "object" && (a3 = o({}, t4)), i2 !== void 0 && (a3[i2] = e5.deepCopy(t4[i2], n4)), a3;
          }, e5;
        }
        return n3;
      }(N.EventEmitter))();
      z2.register(T.handleAction.bind(T));
      var q2 = T, V = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.getFunctionDisplay = function(e6) {
            var t4 = d2(a2).props;
            return e6 ? m2.a.createElement("span", null, a2.props.value.toString().slice(9, -1).replace(/\{[\s\S]+/, ""), m2.a.createElement("span", { className: "function-collapsed", style: { fontWeight: "bold" } }, m2.a.createElement("span", null, "{"), m2.a.createElement("span", A2(t4.theme, "ellipsis"), "..."), m2.a.createElement("span", null, "}"))) : a2.props.value.toString().slice(9, -1);
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = this.state.collapsed;
          return m2.a.createElement("div", A2(e5.theme, "function"), m2.a.createElement(M, Object.assign({ type_name: "function" }, e5)), m2.a.createElement("span", Object.assign({}, A2(e5.theme, "function-value"), { className: "rjv-function-container", onClick: this.toggleCollapsed }), this.getFunctionDisplay(t4)));
        } }]), n3;
      }(m2.a.PureComponent), K = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "nan"), "NaN");
        } }]), n3;
      }(m2.a.PureComponent), W = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "null"), "NULL");
        } }]), n3;
      }(m2.a.PureComponent), H = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "integer"), m2.a.createElement(M, Object.assign({ type_name: "int" }, e5)), this.props.value);
        } }]), n3;
      }(m2.a.PureComponent), U = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props;
          return m2.a.createElement("div", A2(e5.theme, "regexp"), m2.a.createElement(M, Object.assign({ type_name: "regexp" }, e5)), this.props.value.toString());
        } }]), n3;
      }(m2.a.PureComponent), G = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ collapsed: !a2.state.collapsed }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "collapsed", a2.state.collapsed);
            });
          }, a2.state = { collapsed: q2.get(e5.rjvId, e5.namespace, "collapsed", true) }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          this.state.collapsed;
          var e5 = this.props, t4 = e5.collapseStringsAfterLength, n4 = e5.theme, a2 = e5.value, r3 = { style: { cursor: "default" } };
          return _(t4) === "integer" && a2.length > t4 && (r3.style.cursor = "pointer", this.state.collapsed && (a2 = m2.a.createElement("span", null, a2.substring(0, t4), m2.a.createElement("span", A2(n4, "ellipsis"), " ...")))), m2.a.createElement("div", A2(n4, "string"), m2.a.createElement(M, Object.assign({ type_name: "string" }, e5)), m2.a.createElement("span", Object.assign({ className: "string-value" }, r3, { onClick: this.toggleCollapsed }), '"', a2, '"'));
        } }]), n3;
      }(m2.a.PureComponent), J = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          return m2.a.createElement("div", A2(this.props.theme, "undefined"), "undefined");
        } }]), n3;
      }(m2.a.PureComponent);
      function Y() {
        return (Y = Object.assign || function(e4) {
          for (var t3 = 1; t3 < arguments.length; t3++) {
            var n3 = arguments[t3];
            for (var a2 in n3)
              Object.prototype.hasOwnProperty.call(n3, a2) && (e4[a2] = n3[a2]);
          }
          return e4;
        }).apply(this, arguments);
      }
      var $ = v4.useLayoutEffect, Q = function(e4) {
        var t3 = Object(v4.useRef)(e4);
        return $(function() {
          t3.current = e4;
        }), t3;
      }, Z = function(e4, t3) {
        typeof e4 != "function" ? e4.current = t3 : e4(t3);
      }, X = function(e4, t3) {
        var n3 = Object(v4.useRef)();
        return Object(v4.useCallback)(function(a2) {
          e4.current = a2, n3.current && Z(n3.current, null), n3.current = t3, t3 && Z(t3, a2);
        }, [t3]);
      }, ee = { "min-height": "0", "max-height": "none", height: "0", visibility: "hidden", overflow: "hidden", position: "absolute", "z-index": "-1000", top: "0", right: "0" }, te = function(e4) {
        Object.keys(ee).forEach(function(t3) {
          e4.style.setProperty(t3, ee[t3], "important");
        });
      }, ne = null;
      var ae = function() {
      }, re = ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "boxSizing", "fontFamily", "fontSize", "fontStyle", "fontWeight", "letterSpacing", "lineHeight", "paddingBottom", "paddingLeft", "paddingRight", "paddingTop", "tabSize", "textIndent", "textRendering", "textTransform", "width"], oe = !!document.documentElement.currentStyle, ie = function(e4, t3) {
        var n3 = e4.cacheMeasurements, a2 = e4.maxRows, r3 = e4.minRows, o2 = e4.onChange, i2 = o2 === void 0 ? ae : o2, s2 = e4.onHeightChange, c3 = s2 === void 0 ? ae : s2, l3 = function(e5, t4) {
          if (e5 == null)
            return {};
          var n4, a3, r4 = {}, o3 = Object.keys(e5);
          for (a3 = 0; a3 < o3.length; a3++)
            n4 = o3[a3], t4.indexOf(n4) >= 0 || (r4[n4] = e5[n4]);
          return r4;
        }(e4, ["cacheMeasurements", "maxRows", "minRows", "onChange", "onHeightChange"]);
        var u2, f3 = l3.value !== void 0, p3 = Object(v4.useRef)(null), d3 = X(p3, t3), b3 = Object(v4.useRef)(0), h2 = Object(v4.useRef)(), m3 = function() {
          var e5 = p3.current, t4 = n3 && h2.current ? h2.current : function(e6) {
            var t5 = window.getComputedStyle(e6);
            if (t5 === null)
              return null;
            var n4, a3 = (n4 = t5, re.reduce(function(e7, t6) {
              return e7[t6] = n4[t6], e7;
            }, {})), r4 = a3.boxSizing;
            return r4 === "" ? null : (oe && r4 === "border-box" && (a3.width = parseFloat(a3.width) + parseFloat(a3.borderRightWidth) + parseFloat(a3.borderLeftWidth) + parseFloat(a3.paddingRight) + parseFloat(a3.paddingLeft) + "px"), { sizingStyle: a3, paddingSize: parseFloat(a3.paddingBottom) + parseFloat(a3.paddingTop), borderSize: parseFloat(a3.borderBottomWidth) + parseFloat(a3.borderTopWidth) });
          }(e5);
          if (t4) {
            h2.current = t4;
            var o3 = function(e6, t5, n4, a3) {
              n4 === void 0 && (n4 = 1), a3 === void 0 && (a3 = 1 / 0), ne || ((ne = document.createElement("textarea")).setAttribute("tab-index", "-1"), ne.setAttribute("aria-hidden", "true"), te(ne)), ne.parentNode === null && document.body.appendChild(ne);
              var r4 = e6.paddingSize, o4 = e6.borderSize, i4 = e6.sizingStyle, s4 = i4.boxSizing;
              Object.keys(i4).forEach(function(e7) {
                var t6 = e7;
                ne.style[t6] = i4[t6];
              }), te(ne), ne.value = t5;
              var c4 = function(e7, t6) {
                var n5 = e7.scrollHeight;
                return t6.sizingStyle.boxSizing === "border-box" ? n5 + t6.borderSize : n5 - t6.paddingSize;
              }(ne, e6);
              ne.value = "x";
              var l4 = ne.scrollHeight - r4, u3 = l4 * n4;
              s4 === "border-box" && (u3 = u3 + r4 + o4), c4 = Math.max(u3, c4);
              var f4 = l4 * a3;
              return s4 === "border-box" && (f4 = f4 + r4 + o4), [c4 = Math.min(f4, c4), l4];
            }(t4, e5.value || e5.placeholder || "x", r3, a2), i3 = o3[0], s3 = o3[1];
            b3.current !== i3 && (b3.current = i3, e5.style.setProperty("height", i3 + "px", "important"), c3(i3, { rowHeight: s3 }));
          }
        };
        return Object(v4.useLayoutEffect)(m3), u2 = Q(m3), Object(v4.useLayoutEffect)(function() {
          var e5 = function(e6) {
            u2.current(e6);
          };
          return window.addEventListener("resize", e5), function() {
            window.removeEventListener("resize", e5);
          };
        }, []), Object(v4.createElement)("textarea", Y({}, l3, { onChange: function(e5) {
          f3 || m3(), i2(e5);
        }, ref: d3 }));
      }, se = Object(v4.forwardRef)(ie);
      function ce(e4) {
        e4 = e4.trim();
        try {
          if ((e4 = JSON.stringify(JSON.parse(e4)))[0] === "[")
            return le("array", JSON.parse(e4));
          if (e4[0] === "{")
            return le("object", JSON.parse(e4));
          if (e4.match(/\-?\d+\.\d+/) && e4.match(/\-?\d+\.\d+/)[0] === e4)
            return le("float", parseFloat(e4));
          if (e4.match(/\-?\d+e-\d+/) && e4.match(/\-?\d+e-\d+/)[0] === e4)
            return le("float", Number(e4));
          if (e4.match(/\-?\d+/) && e4.match(/\-?\d+/)[0] === e4)
            return le("integer", parseInt(e4));
          if (e4.match(/\-?\d+e\+\d+/) && e4.match(/\-?\d+e\+\d+/)[0] === e4)
            return le("integer", Number(e4));
        } catch (e5) {
        }
        switch (e4 = e4.toLowerCase()) {
          case "undefined":
            return le("undefined", void 0);
          case "nan":
            return le("nan", NaN);
          case "null":
            return le("null", null);
          case "true":
            return le("boolean", true);
          case "false":
            return le("boolean", false);
          default:
            if (e4 = Date.parse(e4))
              return le("date", new Date(e4));
        }
        return le(false, null);
      }
      function le(e4, t3) {
        return { type: e4, value: t3 };
      }
      var ue = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M7,13H17V11H7" })));
        } }]), n3;
      }(m2.a.PureComponent), fe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 24 24", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("path", { d: "M12,20C7.59,20 4,16.41 4,12C4,7.59 7.59,4 12,4C16.41,4 20,7.59 20,12C20,16.41 16.41,20 12,20M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2M13,7H11V11H7V13H11V17H13V13H17V11H13V7Z" })));
        } }]), n3;
      }(m2.a.PureComponent), pe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-832q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h832q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), de = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]), a2 = xe(t4).style;
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { fill: a2.color, width: a2.height, height: a2.width, style: a2, viewBox: "0 0 1792 1792" }, m2.a.createElement("path", { d: "M1344 800v64q0 14-9 23t-23 9h-352v352q0 14-9 23t-23 9h-64q-14 0-23-9t-9-23v-352h-352q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h352v-352q0-14 9-23t23-9h64q14 0 23 9t9 23v352h352q14 0 23 9t9 23zm128 448v-832q0-66-47-113t-113-47h-832q-66 0-113 47t-47 113v832q0 66 47 113t113 47h832q66 0 113-47t47-113zm128-832v832q0 119-84.5 203.5t-203.5 84.5h-832q-119 0-203.5-84.5t-84.5-203.5v-832q0-119 84.5-203.5t203.5-84.5h832q119 0 203.5 84.5t84.5 203.5z" })));
        } }]), n3;
      }(m2.a.PureComponent), be = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 14l6-6-6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), he = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", { style: o(o({}, xe(t4).style), {}, { paddingLeft: "2px", verticalAlign: "top" }), viewBox: "0 0 15 15", fill: "currentColor" }, m2.a.createElement("path", { d: "M0 5l6 6 6-6z" })));
        } }]), n3;
      }(m2.a.PureComponent), ve = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30 35h-25v-22.5h25v7.5h2.5v-12.5c0-1.4-1.1-2.5-2.5-2.5h-7.5c0-2.8-2.2-5-5-5s-5 2.2-5 5h-7.5c-1.4 0-2.5 1.1-2.5 2.5v27.5c0 1.4 1.1 2.5 2.5 2.5h25c1.4 0 2.5-1.1 2.5-2.5v-5h-2.5v5z m-20-27.5h2.5s2.5-1.1 2.5-2.5 1.1-2.5 2.5-2.5 2.5 1.1 2.5 2.5 1.3 2.5 2.5 2.5h2.5s2.5 1.1 2.5 2.5h-20c0-1.5 1.1-2.5 2.5-2.5z m-2.5 20h5v-2.5h-5v2.5z m17.5-5v-5l-10 7.5 10 7.5v-5h12.5v-5h-12.5z m-17.5 10h7.5v-2.5h-7.5v2.5z m12.5-17.5h-12.5v2.5h12.5v-2.5z m-7.5 5h-5v2.5h5v-2.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), me = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m28.6 25q0-0.5-0.4-1l-4-4 4-4q0.4-0.5 0.4-1 0-0.6-0.4-1.1l-2-2q-0.4-0.4-1-0.4-0.6 0-1 0.4l-4.1 4.1-4-4.1q-0.4-0.4-1-0.4-0.6 0-1 0.4l-2 2q-0.5 0.5-0.5 1.1 0 0.5 0.5 1l4 4-4 4q-0.5 0.5-0.5 1 0 0.7 0.5 1.1l2 2q0.4 0.4 1 0.4 0.6 0 1-0.4l4-4.1 4.1 4.1q0.4 0.4 1 0.4 0.6 0 1-0.4l2-2q0.4-0.4 0.4-1z m8.7-5q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ye = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m30.1 21.4v-2.8q0-0.6-0.4-1t-1-0.5h-5.7v-5.7q0-0.6-0.4-1t-1-0.4h-2.9q-0.6 0-1 0.4t-0.4 1v5.7h-5.7q-0.6 0-1 0.5t-0.5 1v2.8q0 0.6 0.5 1t1 0.5h5.7v5.7q0 0.5 0.4 1t1 0.4h2.9q0.6 0 1-0.4t0.4-1v-5.7h5.7q0.6 0 1-0.5t0.4-1z m7.2-1.4q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent), ge = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.6 21.6h-10v10h-3.2v-10h-10v-3.2h10v-10h3.2v10h10v3.2z" }))));
        } }]), n3;
      }(m2.a.PureComponent), Ee = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m19.8 26.4l2.6-2.6-3.4-3.4-2.6 2.6v1.3h2.2v2.1h1.2z m9.8-16q-0.3-0.4-0.7 0l-7.8 7.8q-0.4 0.4 0 0.7t0.7 0l7.8-7.8q0.4-0.4 0-0.7z m1.8 13.2v4.3q0 2.6-1.9 4.5t-4.5 1.9h-18.6q-2.6 0-4.5-1.9t-1.9-4.5v-18.6q0-2.7 1.9-4.6t4.5-1.8h18.6q1.4 0 2.6 0.5 0.3 0.2 0.4 0.5 0.1 0.4-0.2 0.7l-1.1 1.1q-0.3 0.3-0.7 0.1-0.5-0.1-1-0.1h-18.6q-1.4 0-2.5 1.1t-1 2.5v18.6q0 1.4 1 2.5t2.5 1h18.6q1.5 0 2.5-1t1.1-2.5v-2.9q0-0.2 0.2-0.4l1.4-1.5q0.3-0.3 0.8-0.1t0.4 0.6z m-2.1-16.5l6.4 6.5-15 15h-6.4v-6.5z m9.9 3l-2.1 2-6.4-6.4 2.1-2q0.6-0.7 1.5-0.7t1.5 0.7l3.4 3.4q0.6 0.6 0.6 1.5t-0.6 1.5z" }))));
        } }]), n3;
      }(m2.a.PureComponent), je = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.style, n4 = x2(e5, ["style"]);
          return m2.a.createElement("span", n4, m2.a.createElement("svg", Object.assign({}, xe(t4), { viewBox: "0 0 40 40", fill: "currentColor", preserveAspectRatio: "xMidYMid meet" }), m2.a.createElement("g", null, m2.a.createElement("path", { d: "m31.7 16.4q0-0.6-0.4-1l-2.1-2.1q-0.4-0.4-1-0.4t-1 0.4l-9.1 9.1-5-5q-0.5-0.4-1-0.4t-1 0.4l-2.1 2q-0.4 0.4-0.4 1 0 0.6 0.4 1l8.1 8.1q0.4 0.4 1 0.4 0.6 0 1-0.4l12.2-12.1q0.4-0.4 0.4-1z m5.6 3.6q0 4.7-2.3 8.6t-6.3 6.2-8.6 2.3-8.6-2.3-6.2-6.2-2.3-8.6 2.3-8.6 6.2-6.2 8.6-2.3 8.6 2.3 6.3 6.2 2.3 8.6z" }))));
        } }]), n3;
      }(m2.a.PureComponent);
      function xe(e4) {
        return e4 || (e4 = {}), { style: o(o({ verticalAlign: "middle" }, e4), {}, { color: e4.color ? e4.color : "#000000", height: "1em", width: "1em" }) };
      }
      var _e = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).copiedTimer = null, a2.handleCopy = function() {
            var e6 = document.createElement("textarea"), t4 = a2.props, n4 = t4.clickCallback, r3 = t4.src, o2 = t4.namespace;
            e6.innerHTML = JSON.stringify(a2.clipboardValue(r3), null, "  "), document.body.appendChild(e6), e6.select(), document.execCommand("copy"), document.body.removeChild(e6), a2.copiedTimer = setTimeout(function() {
              a2.setState({ copied: false });
            }, 5500), a2.setState({ copied: true }, function() {
              typeof n4 == "function" && n4({ src: r3, namespace: o2, name: o2[o2.length - 1] });
            });
          }, a2.getClippyIcon = function() {
            var e6 = a2.props.theme;
            return a2.state.copied ? m2.a.createElement("span", null, m2.a.createElement(ve, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon"))), m2.a.createElement("span", A2(e6, "copy-icon-copied"), "\u2714")) : m2.a.createElement(ve, Object.assign({ className: "copy-icon" }, A2(e6, "copy-icon")));
          }, a2.clipboardValue = function(e6) {
            switch (_(e6)) {
              case "function":
              case "regexp":
                return e6.toString();
              default:
                return e6;
            }
          }, a2.state = { copied: false }, a2;
        }
        return c2(n3, [{ key: "componentWillUnmount", value: function() {
          this.copiedTimer && (clearTimeout(this.copiedTimer), this.copiedTimer = null);
        } }, { key: "render", value: function() {
          var e5 = this.props, t4 = (e5.src, e5.theme), n4 = e5.hidden, a2 = e5.rowHovered, r3 = A2(t4, "copy-to-clipboard").style, i2 = "inline";
          return n4 && (i2 = "none"), m2.a.createElement("span", { className: "copy-to-clipboard-container", title: "Copy to clipboard", style: { verticalAlign: "top", display: a2 ? "inline-block" : "none" } }, m2.a.createElement("span", { style: o(o({}, r3), {}, { display: i2 }), onClick: this.handleCopy }, this.getClippyIcon()));
        } }]), n3;
      }(m2.a.PureComponent), ke = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).getEditIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.theme;
            return m2.a.createElement("div", { className: "click-to-edit", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(Ee, Object.assign({ className: "click-to-edit-icon" }, A2(n4, "editVarIcon"), { onClick: function() {
              a2.prepopInput(t4);
            } })));
          }, a2.prepopInput = function(e6) {
            if (a2.props.onEdit !== false) {
              var t4 = function(e7) {
                var t5;
                switch (_(e7)) {
                  case "undefined":
                    t5 = "undefined";
                    break;
                  case "nan":
                    t5 = "NaN";
                    break;
                  case "string":
                    t5 = e7;
                    break;
                  case "date":
                  case "function":
                  case "regexp":
                    t5 = e7.toString();
                    break;
                  default:
                    try {
                      t5 = JSON.stringify(e7, null, "  ");
                    } catch (e8) {
                      t5 = "";
                    }
                }
                return t5;
              }(e6.value), n4 = ce(t4);
              a2.setState({ editMode: true, editValue: t4, parsedInput: { type: n4.type, value: n4.value } });
            }
          }, a2.getRemoveIcon = function() {
            var e6 = a2.props, t4 = e6.variable, n4 = e6.namespace, r3 = e6.theme, o2 = e6.rjvId;
            return m2.a.createElement("div", { className: "click-to-remove", style: { verticalAlign: "top", display: a2.state.hovered ? "inline-block" : "none" } }, m2.a.createElement(me, Object.assign({ className: "click-to-remove-icon" }, A2(r3, "removeVarIcon"), { onClick: function() {
              z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: o2, data: { name: t4.name, namespace: n4, existing_value: t4.value, variable_removed: true } });
            } })));
          }, a2.getValue = function(e6, t4) {
            var n4 = !t4 && e6.type, r3 = d2(a2).props;
            switch (n4) {
              case false:
                return a2.getEditInput();
              case "string":
                return m2.a.createElement(G, Object.assign({ value: e6.value }, r3));
              case "integer":
                return m2.a.createElement(H, Object.assign({ value: e6.value }, r3));
              case "float":
                return m2.a.createElement(D, Object.assign({ value: e6.value }, r3));
              case "boolean":
                return m2.a.createElement(P, Object.assign({ value: e6.value }, r3));
              case "function":
                return m2.a.createElement(V, Object.assign({ value: e6.value }, r3));
              case "null":
                return m2.a.createElement(W, r3);
              case "nan":
                return m2.a.createElement(K, r3);
              case "undefined":
                return m2.a.createElement(J, r3);
              case "date":
                return m2.a.createElement(F, Object.assign({ value: e6.value }, r3));
              case "regexp":
                return m2.a.createElement(U, Object.assign({ value: e6.value }, r3));
              default:
                return m2.a.createElement("div", { className: "object-value" }, JSON.stringify(e6.value));
            }
          }, a2.getEditInput = function() {
            var e6 = a2.props.theme, t4 = a2.state.editValue;
            return m2.a.createElement("div", null, m2.a.createElement(se, Object.assign({ type: "text", inputRef: function(e7) {
              return e7 && e7.focus();
            }, value: t4, className: "variable-editor", onChange: function(e7) {
              var t5 = e7.target.value, n4 = ce(t5);
              a2.setState({ editValue: t5, parsedInput: { type: n4.type, value: n4.value } });
            }, onKeyDown: function(e7) {
              switch (e7.key) {
                case "Escape":
                  a2.setState({ editMode: false, editValue: "" });
                  break;
                case "Enter":
                  (e7.ctrlKey || e7.metaKey) && a2.submitEdit(true);
              }
              e7.stopPropagation();
            }, placeholder: "update this value", minRows: 2 }, A2(e6, "edit-input"))), m2.a.createElement("div", A2(e6, "edit-icon-container"), m2.a.createElement(me, Object.assign({ className: "edit-cancel" }, A2(e6, "cancel-icon"), { onClick: function() {
              a2.setState({ editMode: false, editValue: "" });
            } })), m2.a.createElement(je, Object.assign({ className: "edit-check string-value" }, A2(e6, "check-icon"), { onClick: function() {
              a2.submitEdit();
            } })), m2.a.createElement("div", null, a2.showDetected())));
          }, a2.submitEdit = function(e6) {
            var t4 = a2.props, n4 = t4.variable, r3 = t4.namespace, o2 = t4.rjvId, i2 = a2.state, s2 = i2.editValue, c3 = i2.parsedInput, l3 = s2;
            e6 && c3.type && (l3 = c3.value), a2.setState({ editMode: false }), z2.dispatch({ name: "VARIABLE_UPDATED", rjvId: o2, data: { name: n4.name, namespace: r3, existing_value: n4.value, new_value: l3, variable_removed: false } });
          }, a2.showDetected = function() {
            var e6 = a2.props, t4 = e6.theme, n4 = (e6.variable, e6.namespace, e6.rjvId, a2.state.parsedInput), r3 = (n4.type, n4.value, a2.getDetectedInput());
            if (r3)
              return m2.a.createElement("div", null, m2.a.createElement("div", A2(t4, "detected-row"), r3, m2.a.createElement(je, { className: "edit-check detected", style: o({ verticalAlign: "top", paddingLeft: "3px" }, A2(t4, "check-icon").style), onClick: function() {
                a2.submitEdit(true);
              } })));
          }, a2.getDetectedInput = function() {
            var e6 = a2.state.parsedInput, t4 = e6.type, n4 = e6.value, r3 = d2(a2).props, i2 = r3.theme;
            if (t4 !== false)
              switch (t4.toLowerCase()) {
                case "object":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "{"), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "}"));
                case "array":
                  return m2.a.createElement("span", null, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "["), m2.a.createElement("span", { style: o(o({}, A2(i2, "ellipsis").style), {}, { cursor: "default" }) }, "..."), m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { cursor: "default" }) }, "]"));
                case "string":
                  return m2.a.createElement(G, Object.assign({ value: n4 }, r3));
                case "integer":
                  return m2.a.createElement(H, Object.assign({ value: n4 }, r3));
                case "float":
                  return m2.a.createElement(D, Object.assign({ value: n4 }, r3));
                case "boolean":
                  return m2.a.createElement(P, Object.assign({ value: n4 }, r3));
                case "function":
                  return m2.a.createElement(V, Object.assign({ value: n4 }, r3));
                case "null":
                  return m2.a.createElement(W, r3);
                case "nan":
                  return m2.a.createElement(K, r3);
                case "undefined":
                  return m2.a.createElement(J, r3);
                case "date":
                  return m2.a.createElement(F, Object.assign({ value: new Date(n4) }, r3));
              }
          }, a2.state = { editMode: false, editValue: "", hovered: false, renameKey: false, parsedInput: { type: false, value: null } }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.variable, a2 = t4.singleIndent, r3 = t4.type, i2 = t4.theme, s2 = t4.namespace, c3 = t4.indentWidth, l3 = t4.enableClipboard, u2 = t4.onEdit, f3 = t4.onDelete, p3 = t4.onSelect, d3 = t4.displayArrayKey, b3 = t4.quotesOnKeys, h2 = this.state.editMode;
          return m2.a.createElement("div", Object.assign({}, A2(i2, "objectKeyVal", { paddingLeft: c3 * a2 }), { onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          }, className: "variable-row", key: n4.name }), r3 == "array" ? d3 ? m2.a.createElement("span", Object.assign({}, A2(i2, "array-key"), { key: n4.name + "_" + s2 }), n4.name, m2.a.createElement("div", A2(i2, "colon"), ":")) : null : m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({}, A2(i2, "object-name"), { className: "object-key", key: n4.name + "_" + s2 }), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", { style: { display: "inline-block" } }, n4.name), !!b3 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(i2, "colon"), ":")), m2.a.createElement("div", Object.assign({ className: "variable-value", onClick: p3 === false && u2 === false ? null : function(t5) {
            var a3 = B(s2);
            (t5.ctrlKey || t5.metaKey) && u2 !== false ? e5.prepopInput(n4) : p3 !== false && (a3.shift(), p3(o(o({}, n4), {}, { namespace: a3 })));
          } }, A2(i2, "variableValue", { cursor: p3 === false ? "default" : "pointer" })), this.getValue(n4, h2)), l3 ? m2.a.createElement(_e, { rowHovered: this.state.hovered, hidden: h2, src: n4.value, clickCallback: l3, theme: i2, namespace: [].concat(B(s2), [n4.name]) }) : null, u2 !== false && h2 == 0 ? this.getEditIcon() : null, f3 !== false && h2 == 0 ? this.getRemoveIcon() : null);
        } }]), n3;
      }(m2.a.PureComponent), Oe = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).getObjectSize = function() {
            var t4 = e5.props, n4 = t4.size, a3 = t4.theme;
            if (t4.displayObjectSize)
              return m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(a3, "object-size")), n4, " item", n4 === 1 ? "" : "s");
          }, e5.getAddAttribute = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = n4.namespace, i2 = n4.name, s3 = n4.src, c3 = n4.rjvId, l3 = n4.depth;
            return m2.a.createElement("span", { className: "click-to-add", style: { verticalAlign: "top", display: t4 ? "inline-block" : "none" } }, m2.a.createElement(ye, Object.assign({ className: "click-to-add-icon" }, A2(a3, "addVarIcon"), { onClick: function() {
              var e6 = { name: l3 > 0 ? i2 : null, namespace: r4.splice(0, r4.length - 1), existing_value: s3, variable_removed: false, key_name: null };
              _(s3) === "object" ? z2.dispatch({ name: "ADD_VARIABLE_KEY_REQUEST", rjvId: c3, data: e6 }) : z2.dispatch({ name: "VARIABLE_ADDED", rjvId: c3, data: o(o({}, e6), {}, { new_value: [].concat(B(s3), [null]) }) });
            } })));
          }, e5.getRemoveObject = function(t4) {
            var n4 = e5.props, a3 = n4.theme, r4 = (n4.hover, n4.namespace), o2 = n4.name, i2 = n4.src, s3 = n4.rjvId;
            if (r4.length !== 1)
              return m2.a.createElement("span", { className: "click-to-remove", style: { display: t4 ? "inline-block" : "none" } }, m2.a.createElement(me, Object.assign({ className: "click-to-remove-icon" }, A2(a3, "removeVarIcon"), { onClick: function() {
                z2.dispatch({ name: "VARIABLE_REMOVED", rjvId: s3, data: { name: o2, namespace: r4.splice(0, r4.length - 1), existing_value: i2, variable_removed: true } });
              } })));
          }, e5.render = function() {
            var t4 = e5.props, n4 = t4.theme, a3 = t4.onDelete, r4 = t4.onAdd, o2 = t4.enableClipboard, i2 = t4.src, s3 = t4.namespace, c3 = t4.rowHovered;
            return m2.a.createElement("div", Object.assign({}, A2(n4, "object-meta-data"), { className: "object-meta-data", onClick: function(e6) {
              e6.stopPropagation();
            } }), e5.getObjectSize(), o2 ? m2.a.createElement(_e, { rowHovered: c3, clickCallback: o2, src: i2, theme: n4, namespace: s3 }) : null, r4 !== false ? e5.getAddAttribute(c3) : null, a3 !== false ? e5.getRemoveObject(c3) : null);
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent);
      function Ce(e4) {
        var t3 = e4.parent_type, n3 = e4.namespace, a2 = e4.quotesOnKeys, r3 = e4.theme, o2 = e4.jsvRoot, i2 = e4.name, s2 = e4.displayArrayKey, c3 = e4.name ? e4.name : "";
        return !o2 || i2 !== false && i2 !== null ? t3 == "array" ? s2 ? m2.a.createElement("span", Object.assign({}, A2(r3, "array-key"), { key: n3 }), m2.a.createElement("span", { className: "array-key" }, c3), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null) : m2.a.createElement("span", Object.assign({}, A2(r3, "object-name"), { key: n3 }), m2.a.createElement("span", { className: "object-key" }, a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"'), m2.a.createElement("span", null, c3), a2 && m2.a.createElement("span", { style: { verticalAlign: "top" } }, '"')), m2.a.createElement("span", A2(r3, "colon"), ":")) : m2.a.createElement("span", null);
      }
      function Se(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(he, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          case "square":
            return m2.a.createElement(pe, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
          default:
            return m2.a.createElement(ue, Object.assign({}, A2(t3, "expanded-icon"), { className: "expanded-icon" }));
        }
      }
      function we(e4) {
        var t3 = e4.theme;
        switch (e4.iconStyle) {
          case "triangle":
            return m2.a.createElement(be, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          case "square":
            return m2.a.createElement(de, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
          default:
            return m2.a.createElement(fe, Object.assign({}, A2(t3, "collapsed-icon"), { className: "collapsed-icon" }));
        }
      }
      var Ae = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function(e6) {
            var t4 = [];
            for (var n4 in a2.state.expanded)
              t4.push(a2.state.expanded[n4]);
            t4[e6] = !t4[e6], a2.setState({ expanded: t4 });
          }, a2.state = { expanded: [] }, a2;
        }
        return c2(n3, [{ key: "getExpandedIcon", value: function(e5) {
          var t4 = this.props, n4 = t4.theme, a2 = t4.iconStyle;
          return this.state.expanded[e5] ? m2.a.createElement(Se, { theme: n4, iconStyle: a2 }) : m2.a.createElement(we, { theme: n4, iconStyle: a2 });
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.src, a2 = t4.groupArraysAfterLength, r3 = (t4.depth, t4.name), o2 = t4.theme, i2 = t4.jsvRoot, s2 = t4.namespace, c3 = (t4.parent_type, x2(t4, ["src", "groupArraysAfterLength", "depth", "name", "theme", "jsvRoot", "namespace", "parent_type"])), l3 = 0, u2 = 5 * this.props.indentWidth;
          i2 || (l3 = 5 * this.props.indentWidth);
          var f3 = a2, p3 = Math.ceil(n4.length / f3);
          return m2.a.createElement("div", Object.assign({ className: "object-key-val" }, A2(o2, i2 ? "jsv-root" : "objectKeyVal", { paddingLeft: l3 })), m2.a.createElement(Ce, this.props), m2.a.createElement("span", null, m2.a.createElement(Oe, Object.assign({ size: n4.length }, this.props))), B(Array(p3)).map(function(t5, a3) {
            return m2.a.createElement("div", Object.assign({ key: a3, className: "object-key-val array-group" }, A2(o2, "objectKeyVal", { marginLeft: 6, paddingLeft: u2 })), m2.a.createElement("span", A2(o2, "brace-row"), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            } }), e5.getExpandedIcon(a3)), e5.state.expanded[a3] ? m2.a.createElement(Fe, Object.assign({ key: r3 + a3, depth: 0, name: false, collapsed: false, groupArraysAfterLength: f3, index_offset: a3 * f3, src: n4.slice(a3 * f3, a3 * f3 + f3), namespace: s2, type: "array", parent_type: "array_group", theme: o2 }, c3)) : m2.a.createElement("span", Object.assign({}, A2(o2, "brace"), { onClick: function(t6) {
              e5.toggleCollapsed(a3);
            }, className: "array-group-brace" }), "[", m2.a.createElement("div", Object.assign({}, A2(o2, "array-group-meta-data"), { className: "array-group-meta-data" }), m2.a.createElement("span", Object.assign({ className: "object-size" }, A2(o2, "object-size")), a3 * f3, " - ", a3 * f3 + f3 > n4.length ? n4.length : a3 * f3 + f3)), "]")));
          }));
        } }]), n3;
      }(m2.a.PureComponent), Me = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          i(this, n3), (a2 = t3.call(this, e5)).toggleCollapsed = function() {
            a2.setState({ expanded: !a2.state.expanded }, function() {
              q2.set(a2.props.rjvId, a2.props.namespace, "expanded", a2.state.expanded);
            });
          }, a2.getObjectContent = function(e6, t4, n4) {
            return m2.a.createElement("div", { className: "pushed-content object-container" }, m2.a.createElement("div", Object.assign({ className: "object-content" }, A2(a2.props.theme, "pushed-content")), a2.renderObjectContents(t4, n4)));
          }, a2.getEllipsis = function() {
            return a2.state.size === 0 ? null : m2.a.createElement("div", Object.assign({}, A2(a2.props.theme, "ellipsis"), { className: "node-ellipsis", onClick: a2.toggleCollapsed }), "...");
          }, a2.getObjectMetaData = function(e6) {
            var t4 = a2.props, n4 = (t4.rjvId, t4.theme, a2.state), r4 = n4.size, o2 = n4.hovered;
            return m2.a.createElement(Oe, Object.assign({ rowHovered: o2, size: r4 }, a2.props));
          }, a2.renderObjectContents = function(e6, t4) {
            var n4, r4 = a2.props, o2 = r4.depth, i2 = r4.parent_type, s2 = r4.index_offset, c3 = r4.groupArraysAfterLength, l3 = r4.namespace, u2 = a2.state.object_type, f3 = [], p3 = Object.keys(e6 || {});
            return a2.props.sortKeys && u2 !== "array" && (p3 = p3.sort()), p3.forEach(function(r5) {
              if (n4 = new Pe(r5, e6[r5]), i2 === "array_group" && s2 && (n4.name = parseInt(n4.name) + s2), e6.hasOwnProperty(r5))
                if (n4.type === "object")
                  f3.push(m2.a.createElement(Fe, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), parent_type: u2 }, t4)));
                else if (n4.type === "array") {
                  var p4 = Fe;
                  c3 && n4.value.length > c3 && (p4 = Ae), f3.push(m2.a.createElement(p4, Object.assign({ key: n4.name, depth: o2 + 1, name: n4.name, src: n4.value, namespace: l3.concat(n4.name), type: "array", parent_type: u2 }, t4)));
                } else
                  f3.push(m2.a.createElement(ke, Object.assign({ key: n4.name + "_" + l3, variable: n4, singleIndent: 5, namespace: l3, type: a2.props.type }, t4)));
            }), f3;
          };
          var r3 = n3.getState(e5);
          return a2.state = o(o({}, r3), {}, { prevProps: {} }), a2;
        }
        return c2(n3, [{ key: "getBraceStart", value: function(e5, t4) {
          var n4 = this, a2 = this.props, r3 = a2.src, o2 = a2.theme, i2 = a2.iconStyle;
          if (a2.parent_type === "array_group")
            return m2.a.createElement("span", null, m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{"), t4 ? this.getObjectMetaData(r3) : null);
          var s2 = t4 ? Se : we;
          return m2.a.createElement("span", null, m2.a.createElement("span", Object.assign({ onClick: function(e6) {
            n4.toggleCollapsed();
          } }, A2(o2, "brace-row")), m2.a.createElement("div", Object.assign({ className: "icon-container" }, A2(o2, "icon-container")), m2.a.createElement(s2, { theme: o2, iconStyle: i2 })), m2.a.createElement(Ce, this.props), m2.a.createElement("span", A2(o2, "brace"), e5 === "array" ? "[" : "{")), t4 ? this.getObjectMetaData(r3) : null);
        } }, { key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.depth, a2 = t4.src, r3 = (t4.namespace, t4.name, t4.type, t4.parent_type), i2 = t4.theme, s2 = t4.jsvRoot, c3 = t4.iconStyle, l3 = x2(t4, ["depth", "src", "namespace", "name", "type", "parent_type", "theme", "jsvRoot", "iconStyle"]), u2 = this.state, f3 = u2.object_type, p3 = u2.expanded, d3 = {};
          return s2 || r3 === "array_group" ? r3 === "array_group" && (d3.borderLeft = 0, d3.display = "inline") : d3.paddingLeft = 5 * this.props.indentWidth, m2.a.createElement("div", Object.assign({ className: "object-key-val", onMouseEnter: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: true }));
          }, onMouseLeave: function() {
            return e5.setState(o(o({}, e5.state), {}, { hovered: false }));
          } }, A2(i2, s2 ? "jsv-root" : "objectKeyVal", d3)), this.getBraceStart(f3, p3), p3 ? this.getObjectContent(n4, a2, o({ theme: i2, iconStyle: c3 }, l3)) : this.getEllipsis(), m2.a.createElement("span", { className: "brace-row" }, m2.a.createElement("span", { style: o(o({}, A2(i2, "brace").style), {}, { paddingLeft: p3 ? "3px" : "0px" }) }, f3 === "array" ? "]" : "}"), p3 ? null : this.getObjectMetaData(a2)));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          var a2 = t4.prevProps;
          return e5.src !== a2.src || e5.collapsed !== a2.collapsed || e5.name !== a2.name || e5.namespace !== a2.namespace || e5.rjvId !== a2.rjvId ? o(o({}, n3.getState(e5)), {}, { prevProps: e5 }) : null;
        } }]), n3;
      }(m2.a.PureComponent);
      Me.getState = function(e4) {
        var t3 = Object.keys(e4.src).length, n3 = (e4.collapsed === false || e4.collapsed !== true && e4.collapsed > e4.depth) && (!e4.shouldCollapse || e4.shouldCollapse({ name: e4.name, src: e4.src, type: _(e4.src), namespace: e4.namespace }) === false) && t3 !== 0;
        return { expanded: q2.get(e4.rjvId, e4.namespace, "expanded", n3), object_type: e4.type === "array" ? "array" : "object", parent_type: e4.type === "array" ? "array" : "object", size: t3, hovered: false };
      };
      var Pe = function e4(t3, n3) {
        i(this, e4), this.name = t3, this.value = n3, this.type = _(n3);
      };
      j(Me);
      var Fe = Me, De = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), o2 = 0; o2 < a2; o2++)
            r3[o2] = arguments[o2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).render = function() {
            var t4 = d2(e5).props, n4 = [t4.name], a3 = Fe;
            return Array.isArray(t4.src) && t4.groupArraysAfterLength && t4.src.length > t4.groupArraysAfterLength && (a3 = Ae), m2.a.createElement("div", { className: "pretty-json-container object-container" }, m2.a.createElement("div", { className: "object-content" }, m2.a.createElement(a3, Object.assign({ namespace: n4, depth: 0, jsvRoot: true }, t4))));
          }, e5;
        }
        return n3;
      }(m2.a.PureComponent), Ie = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).closeModal = function() {
            z2.dispatch({ rjvId: a2.props.rjvId, name: "RESET" });
          }, a2.submit = function() {
            a2.props.submit(a2.state.input);
          }, a2.state = { input: e5.input ? e5.input : "" }, a2;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this, t4 = this.props, n4 = t4.theme, a2 = t4.rjvId, r3 = t4.isValid, o2 = this.state.input, i2 = r3(o2);
          return m2.a.createElement("div", Object.assign({ className: "key-modal-request" }, A2(n4, "key-modal-request"), { onClick: this.closeModal }), m2.a.createElement("div", Object.assign({}, A2(n4, "key-modal"), { onClick: function(e6) {
            e6.stopPropagation();
          } }), m2.a.createElement("div", A2(n4, "key-modal-label"), "Key Name:"), m2.a.createElement("div", { style: { position: "relative" } }, m2.a.createElement("input", Object.assign({}, A2(n4, "key-modal-input"), { className: "key-modal-input", ref: function(e6) {
            return e6 && e6.focus();
          }, spellCheck: false, value: o2, placeholder: "...", onChange: function(t5) {
            e5.setState({ input: t5.target.value });
          }, onKeyPress: function(t5) {
            i2 && t5.key === "Enter" ? e5.submit() : t5.key === "Escape" && e5.closeModal();
          } })), i2 ? m2.a.createElement(je, Object.assign({}, A2(n4, "key-modal-submit"), { className: "key-modal-submit", onClick: function(t5) {
            return e5.submit();
          } })) : null), m2.a.createElement("span", A2(n4, "key-modal-cancel"), m2.a.createElement(ge, Object.assign({}, A2(n4, "key-modal-cancel-icon"), { className: "key-modal-cancel", onClick: function() {
            z2.dispatch({ rjvId: a2, name: "RESET" });
          } })))));
        } }]), n3;
      }(m2.a.PureComponent), Re = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          var e5;
          i(this, n3);
          for (var a2 = arguments.length, r3 = new Array(a2), s2 = 0; s2 < a2; s2++)
            r3[s2] = arguments[s2];
          return (e5 = t3.call.apply(t3, [this].concat(r3))).isValid = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            return t4 != "" && Object.keys(a3.existing_value).indexOf(t4) === -1;
          }, e5.submit = function(t4) {
            var n4 = e5.props.rjvId, a3 = q2.get(n4, "action", "new-key-request");
            a3.new_value = o({}, a3.existing_value), a3.new_value[t4] = e5.props.defaultValue, z2.dispatch({ name: "VARIABLE_ADDED", rjvId: n4, data: a3 });
          }, e5;
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.active, n4 = e5.theme, a2 = e5.rjvId;
          return t4 ? m2.a.createElement(Ie, { rjvId: a2, theme: n4, isValid: this.isValid, submit: this.submit }) : null;
        } }]), n3;
      }(m2.a.PureComponent), Le = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3() {
          return i(this, n3), t3.apply(this, arguments);
        }
        return c2(n3, [{ key: "render", value: function() {
          var e5 = this.props, t4 = e5.message, n4 = e5.active, a2 = e5.theme, r3 = e5.rjvId;
          return n4 ? m2.a.createElement("div", Object.assign({ className: "validation-failure" }, A2(a2, "validation-failure"), { onClick: function() {
            z2.dispatch({ rjvId: r3, name: "RESET" });
          } }), m2.a.createElement("span", A2(a2, "validation-failure-label"), t4), m2.a.createElement(ge, A2(a2, "validation-failure-clear"))) : null;
        } }]), n3;
      }(m2.a.PureComponent), Be = function(e4) {
        u(n3, e4);
        var t3 = h(n3);
        function n3(e5) {
          var a2;
          return i(this, n3), (a2 = t3.call(this, e5)).rjvId = Date.now().toString(), a2.getListeners = function() {
            return { reset: a2.resetState, "variable-update": a2.updateSrc, "add-key-request": a2.addKeyRequest };
          }, a2.updateSrc = function() {
            var e6, t4 = q2.get(a2.rjvId, "action", "variable-update"), n4 = t4.name, r3 = t4.namespace, o2 = t4.new_value, i2 = t4.existing_value, s2 = (t4.variable_removed, t4.updated_src), c3 = t4.type, l3 = a2.props, u2 = l3.onEdit, f3 = l3.onDelete, p3 = l3.onAdd, d3 = { existing_src: a2.state.src, new_value: o2, updated_src: s2, name: n4, namespace: r3, existing_value: i2 };
            switch (c3) {
              case "variable-added":
                e6 = p3(d3);
                break;
              case "variable-edited":
                e6 = u2(d3);
                break;
              case "variable-removed":
                e6 = f3(d3);
            }
            e6 !== false ? (q2.set(a2.rjvId, "global", "src", s2), a2.setState({ src: s2 })) : a2.setState({ validationFailure: true });
          }, a2.addKeyRequest = function() {
            a2.setState({ addKeyRequest: true });
          }, a2.resetState = function() {
            a2.setState({ validationFailure: false, addKeyRequest: false });
          }, a2.state = { addKeyRequest: false, editKeyRequest: false, validationFailure: false, src: n3.defaultProps.src, name: n3.defaultProps.name, theme: n3.defaultProps.theme, validationMessage: n3.defaultProps.validationMessage, prevSrc: n3.defaultProps.src, prevName: n3.defaultProps.name, prevTheme: n3.defaultProps.theme }, a2;
        }
        return c2(n3, [{ key: "componentDidMount", value: function() {
          q2.set(this.rjvId, "global", "src", this.state.src);
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.on(t4 + "-" + this.rjvId, e5[t4]);
          this.setState({ addKeyRequest: false, editKeyRequest: false });
        } }, { key: "componentDidUpdate", value: function(e5, t4) {
          t4.addKeyRequest !== false && this.setState({ addKeyRequest: false }), t4.editKeyRequest !== false && this.setState({ editKeyRequest: false }), e5.src !== this.state.src && q2.set(this.rjvId, "global", "src", this.state.src);
        } }, { key: "componentWillUnmount", value: function() {
          var e5 = this.getListeners();
          for (var t4 in e5)
            q2.removeListener(t4 + "-" + this.rjvId, e5[t4]);
        } }, { key: "render", value: function() {
          var e5 = this.state, t4 = e5.validationFailure, n4 = e5.validationMessage, a2 = e5.addKeyRequest, r3 = e5.theme, i2 = e5.src, s2 = e5.name, c3 = this.props, l3 = c3.style, u2 = c3.defaultValue;
          return m2.a.createElement("div", { className: "react-json-view", style: o(o({}, A2(r3, "app-container").style), l3) }, m2.a.createElement(Le, { message: n4, active: t4, theme: r3, rjvId: this.rjvId }), m2.a.createElement(De, Object.assign({}, this.props, { src: i2, name: s2, theme: r3, type: _(i2), rjvId: this.rjvId })), m2.a.createElement(Re, { active: a2, theme: r3, rjvId: this.rjvId, defaultValue: u2 }));
        } }], [{ key: "getDerivedStateFromProps", value: function(e5, t4) {
          if (e5.src !== t4.prevSrc || e5.name !== t4.prevName || e5.theme !== t4.prevTheme) {
            var a2 = { src: e5.src, name: e5.name, theme: e5.theme, validationMessage: e5.validationMessage, prevSrc: e5.src, prevName: e5.name, prevTheme: e5.theme };
            return n3.validateState(a2);
          }
          return null;
        } }]), n3;
      }(m2.a.PureComponent);
      Be.defaultProps = { src: {}, name: "root", theme: "rjv-default", collapsed: false, collapseStringsAfterLength: false, shouldCollapse: false, sortKeys: false, quotesOnKeys: true, groupArraysAfterLength: 100, indentWidth: 4, enableClipboard: true, displayObjectSize: true, displayDataTypes: true, onEdit: false, onDelete: false, onAdd: false, onSelect: false, iconStyle: "triangle", style: {}, validationMessage: "Validation Error", defaultValue: null, displayArrayKey: true }, Be.validateState = function(e4) {
        var t3 = {};
        return _(e4.theme) !== "object" || function(e5) {
          var t4 = ["base00", "base01", "base02", "base03", "base04", "base05", "base06", "base07", "base08", "base09", "base0A", "base0B", "base0C", "base0D", "base0E", "base0F"];
          if (_(e5) === "object") {
            for (var n3 = 0; n3 < t4.length; n3++)
              if (!(t4[n3] in e5))
                return false;
            return true;
          }
          return false;
        }(e4.theme) || (console.error("react-json-view error:", "theme prop must be a theme name or valid base-16 theme object.", 'defaulting to "rjv-default" theme'), t3.theme = "rjv-default"), _(e4.src) !== "object" && _(e4.src) !== "array" && (console.error("react-json-view error:", "src property must be a valid json object"), t3.name = "ERROR", t3.src = { message: "src property must be a valid json object" }), o(o({}, e4), t3);
      }, j(Be);
      t2.default = Be;
    }]);
  });
})(main);
var ReactJson = /* @__PURE__ */ getDefaultExportFromCjs(main.exports);
const OptionView = ({
  id: id2,
  title,
  chart,
  option
}) => {
  const {
    tool
  } = useEchartsTool({});
  const event = reactEchartsJson_cjs.useEventEmitter({
    global: true
  });
  const [collapsed, {
    set: toggleCollapsed
  }] = useBoolean(true);
  const optionChange = (ctrl) => {
    const {
      updated_src
    } = ctrl;
    chart == null ? void 0 : chart.setOption(updated_src);
    tool == null ? void 0 : tool.add(id2, chart, updated_src, title);
    event.emit("list");
  };
  return /* @__PURE__ */ jsxs("div", {
    children: [/* @__PURE__ */ jsx(Row$1, {
      children: /* @__PURE__ */ jsx(Col$1, {
        children: /* @__PURE__ */ jsx(Switch$1, {
          checkedChildren: "\u5C55\u5F00\u914D\u7F6E",
          unCheckedChildren: "\u6298\u53E0\u914D\u7F6E",
          defaultChecked: false,
          onChange: (e2) => {
            toggleCollapsed(!e2);
          }
        })
      })
    }), /* @__PURE__ */ jsx("br", {}), option && /* @__PURE__ */ jsx(ReactJson, {
      src: option,
      theme: "pop",
      displayObjectSize: false,
      displayDataTypes: false,
      collapsed,
      iconStyle: "triangle",
      enableClipboard: true,
      onEdit: optionChange,
      onAdd: optionChange,
      onDelete: optionChange
    })]
  });
};
const EchartTool = () => {
  const event = useEventEmitter({
    global: true
  });
  const currentIndex = useRef(0);
  const {
    tool
  } = useEchartsTool({});
  useState(false);
  useState("right");
  const [chartList, setChartList] = useState([]);
  const [currentChart, setCurrentChart] = useState();
  event.useSubscription("list", () => {
    var _a2;
    if (tool == null ? void 0 : tool.list().length) {
      setCurrentChart((_a2 = tool == null ? void 0 : tool.list()) == null ? void 0 : _a2[currentIndex.current]);
      setChartList(tool == null ? void 0 : tool.list());
    }
  });
  return /* @__PURE__ */ jsx("div", {
    className: styles.container,
    children: false
  });
};
export { EchartTool, OptionView as ReactEchartsJson, useEcharts, useEchartsTool, useEventEmitter };
